000100 IDENTIFICATION DIVISION.
000200 PROGRAM-ID. MB3OAB.
000201*       RELEASE DATE=08/24/01.        REVISION LEVEL=08.06      * ++++++++
000202***************************************************************** ++++++++
000203*WARNING.  THIS COMPUTER PROGRAM IS PROTECTED BY COPYRIGHT LAW  * ++++++++
000204*AND INTERNATIONAL TREATIES.  UNAUTHORIZED REPRODUCTION OR      * ++++++++
000205*DISTRIBUTION OF THIS PROGRAM, OR ANY PORTION OF IT, MAY RESULT * ++++++++
000206*IN SEVERE CIVIL AND CRIMINAL PENATLIES, AND WILL BE PROSECUTED * ++++++++
000207*TO THE MAXIMUM EXTENT POSSIBLE UNDER THE LAW.                  * ++++++++
000208*COPYRIGHT 1999 PAYSYS INTERNATIONAL, INC.  ALL RIGHTS RESERVED.* ++++++++
000209***************************************************************** ++++++++
000300*
000400******************************************************************
000500*                                                                *
000600*    ---------------MERCHANT BANKCARD SYSTEM---------------      *
000700*                                                                *
000800*          MB3OAB - MB3O FILE COMMON BATCH I/O ROUTINE           *
000900*                                                                *
001000*                VARIABLE LENGTH SEQUENTIAL FILE                 *
001100*                                                                *
001200*    --------------DEPOSIT HISTORY 3 BACKUP OUT------------      *
001300*                                                                *
001400******************************************************************
001500*                                                                *
001600*    COPYBOOKS WHICH MUST APPEAR IN YOUR BATCH PROGRAM:          *
001700*                                                                *
001800*    (WS) MB00RB - BATCH REQUEST BLOCK                           *
001900*    (WS) MMD3IO - I/O AREA                                      *
002000*    (WS) SS02WS - STANDARD ABEND ROUTINE WORK AREA              *
002100*    (PD) MB00PD - PROCEDURE DIVISION CALL STATEMENT             *
002200*                                                                *
002300******************************************************************
002400*                                                                *
002500*    TO USE THIS ROUTINE.........                                *
002600*                                                                *
002700* 1. HOUSEKEEPING DUTIES:                                        *
002800*                                                                *
002900*    A. IN THE HOUSEKEEPING SECTION OF YOUR PROGRAM, MOVE THE    *
003000*       NAME OF THE PROGRAM USING THIS ROUTINE TO THE FIELD      *
003100*       'SS02WS-ABEND-PROG-ID'. THIS FIELD IS USED AS PART OF THE*
003200*       STANDARD ABEND MESSAGES IF A PROGRAM ABORTS WITHIN THIS  *
003300*       ACCESS ROUTINE.  IF THE FIELD 'SS02WS-ABEND-PROG-ID' IS  *
003400*       LEFT BLANK, THIS ROUTINE WILL FORCE AN ABEND SITUATION.  *
003500*                                                                *
003600*    B. BEFORE PERFORMING THE ACCESS ROUTINE, MOVE A LITERAL TO  *
003700*       THE FIELD 'SS02WS-ABEND-LOCATION'. THIS FIELD CAN BE USED*
003800*       TO INDICATE WHERE THE ROUTINE IS BEING 'FROM' IN CASE    *
003900*       OF ABNORMAL TERMINATION. (E.G. DEBUGGING ASSISTANCE)     *
004000*                                                                *
004100*    C. SET THE RETURN CODES WHICH YOU WANT, FOR THE DURATION    *
004200*       OF THIS PROGRAM, TO BE CONSIDERED VALID IN THE FIELDS    *
004300*       'MB3ORB-PERM-STATUS-1 TO -5'. THESE FIELDS ARE INITIAL-  *
004400*       IZED TO ZERO (AS ZERO IS ALWAYS AN ACCEPTABLE RETURN     *
004500*       CODE).  THIS ROUTINE WILL (IN ALL I-O REQUESTS) SUCCESS- *
004600*       FULLY SATISFY YOUR PERFORM REQUEST IF ANY OF THE REQUESTS*
004700*       ENCOUNTER ANY OF THE PERMANENT STATUS CODES 1-5.         *
004800*                                                                *
004900* 2. SET ONE OF THE FOLLOWING CONDITION NAMES TO 'TRUE' TO SET   *
005000*    THE FILE REQUEST:                                           *
005100*                                                                *
005200*        CONDITION NAME                EXPLANATION               *
005300*   *----------------------***---------------------------------* *
005400*                                                                *
005500*    MB3ORB-OPEN-INPUT      - OPEN THE FILE AS INPUT.            *
005600*    MB3ORB-OPEN-OUTPUT     - OPEN THE FILE AS OUTPUT.           *
005700*    MB3ORB-OPEN-IO         - OPEN THE FILE AS I-O.              *
005800*    MB3ORB-READ-SEQ        - READ THE NEXT SEQUENTIAL RECORD    *
005900*                             IN THE FILE.                       *
006000*    MB3ORB-WRITE           - WRITE A RECORD (THE RECORD MUST    *
006100*                             BE IN 'MB3OIO-RECORD').            *
006200*    MB3ORB-REWRITE         - REWRITE A RECORD (THE RECORD MUST  *
006300*                             BE IN 'MB3OIO-RECORD').            *
006400*    MB3ORB-CLOSE           - CLOSE THE FILE.                    *
006500*                                                                *
006600* 3. SET ONE OR BOTH OF THE 'TEMPORARY' RETURN CODE FIELDS       *
006700*    'MB3ORB-TEMP-STATUS-1 AND -2'.  THESE TWO RETURN CODES      *
006800*    ARE TO BE USED ON A PER USE BASIS OF THIS ROUTINE.          *
006900*    THESE TWO RETURN CODES ARE INITIALIZED TO ZERO AND ARE      *
007000*    BOTH RESET TO ZERO AFTER EACH CALL OF THIS PROGRAM.         *
007100*    THE TEMPORARY RETURN CODE FIELDS ARE CHECKED FIRST AND      *
007200*    THEN THE PERMANENT RETURN CODES (POINT 1.C ABOVE) WILL      *
007300*    BE CHECKED.                                                 *
007400*                                                                *
007500* 4. PERFORM MB00PD-MB3O-ACCESS THRU MB00PD-MB3O-ACCESS-EXIT.    *
007600*                                                                *
007700*    A. YOU MUST HANDLE MANUALLY ANY RETURN CODE (EITHER TEMP    *
007800*       OR PERM) THAT YOU REQUESTED, AND IF NEEDED, YOUR OWN     *
007900*       ABEND REQUEST.                                           *
008000*                                                                *
008100*    B. ALL ACCESS ROUTINES MOVE THE FILE STATUS TO THE FIELD    *
008200*       SS02WS-FILE-STATUS IN COPYBOOK SS02WS. USE THE '88' LEVEL*
008300*       NAMES TO TEST YOUR MANUAL STATUS CHECKS.  ALSO IN COPY   *
008400*       BOOK SS02WS, USE THE 'WS-' FILE STATUS DATA NAMES WHEN   *
008500*       SETTING THE PERM OR TEMP FILE STATUS CODES PRIOR TO      *
008600*       PERFORMING THE ACCESS ROUTINE.                           *
008700*                                                                *
008800******************************************************************
008900/
009000 ENVIRONMENT DIVISION.
009100*
009200 CONFIGURATION SECTION.
009300 SOURCE-COMPUTER.            IBM-4341.
009400 OBJECT-COMPUTER.            IBM-4341.
009500*
009600 INPUT-OUTPUT SECTION.
009700*
009800 FILE-CONTROL.
009900*
010000     SELECT  MB3O-FILE
010100             ASSIGN              TO SYS002-UT-3380-S-MB3O
010200             FILE STATUS         IS WS-STATUS.
010300/
010400 DATA DIVISION.
010500*
010600 FILE SECTION.
010700*
010800 FD  MB3O-FILE
010900     RECORDING MODE IS V
011000     RECORD CONTAINS 273 TO 350 CHARACTERS
011100     BLOCK CONTAINS 0 CHARACTERS.
011200*
011300 01  MB3O-FD-MAX-RECORD.
011400     03  FILLER              PIC  X(350).
011500*
011600 01  MB3O-FD-RECORD.
011700     03  MB3O-FD-KEY         PIC  X(35).
011800     03  MB3O-FD-DATA        PIC  X(237).
011900     03  MB3O-FD-VAR-IND     PIC  9(01).
012000         88  MB3O-FD-VDI-NOT-PRESENT         VALUE ZERO.
012100         88  MB3O-FD-VDI-DEPOSIT-DATA        VALUE 1.
012200         88  MB3O-FD-VDI-FEE-DATA            VALUE 2.
012300         88  MB3O-FD-VDI-HEADER-DATA         VALUE 3.
012400     03  MB3O-FD-VAR-DATA                    OCCURS 0 TO 77 TIMES
012500                                             DEPENDING ON
012600                                             WS-DATA-LENGTH.
012700         05  MB3O-FD-VD-BYTE PIC  X(01).
012800*
012900*
013000/
013100 WORKING-STORAGE SECTION.
013200*
013300 01  FILLER                  PIC  X(12)      VALUE '** WS-BEG **'.
013400*
013500 01  FILLER                  PIC  X(18)      VALUE
013600     'FIRST CALL SWITCH:'.
013700*
013800 01  WS-FIRST-CALL-SW        PIC  X(01)      VALUE 'Y'.
013900     88  WS-FIRST-CALL-SW-IS-YES             VALUE 'Y'.
014000*
014100 01  FILLER                  PIC  X(12)      VALUE
014200     'FILE STATUS:'.
014300*
014400 01  WS-STATUS               PIC  X(02)      VALUE ZERO.
014500*
014600 01  FILLER                  PIC  X(12)      VALUE
014700     'I-O REQUEST:'.
014800*
014900 01  WS-IO-REQUEST           PIC  9(02)      VALUE ZERO.
015000*
015100 01  FILLER                  PIC  X(12)      VALUE
015200     'DATA LENGTH:'.
015300*
015400 01  WS-DATA-LENGTH          PIC S9(04)      BINARY
015500                                             VALUE ZERO.
015600     88  WS-MAXIMUM-DATA-LENGTH              VALUE +324.
015700*
015800 01  FILLER                  PIC  X(28)      VALUE
015900     'PROCESSING SUMMARY COUNTERS:'.
016000*
016100 01  WS-SUMMARY-COUNTERS.
016200     03  WS-SC-READS         PIC S9(09)      PACKED-DECIMAL
016300                                             VALUE ZERO.
016400     03  WS-SC-WRITES        PIC S9(09)      PACKED-DECIMAL
016500                                             VALUE ZERO.
016600     03  WS-SC-REWRITES      PIC S9(09)      PACKED-DECIMAL
016700                                             VALUE ZERO.
016800*
016900 01  FILLER                  PIC  X(27)      VALUE
017000     'PROCESSING SUMMARY MESSAGE:'.
017100*
017200 01  WS-SUMMARY-MESSAGE.
017300     03  FILLER              PIC  X(10)      VALUE '(PGMSTAT) '.
017400     03  WS-SM-PROG-ID       PIC  X(06)      VALUE SPACES.
017500     03  FILLER              PIC  X(03)      VALUE ' - '.
017600     03  WS-SM-FILE-ID       PIC  X(04)      VALUE 'MB3O'.
017700     03  FILLER              PIC  X(11)      VALUE ' - OPENED: '.
017800     03  WS-SM-ACCESS        PIC  X(03)      VALUE SPACES.
017900     03  FILLER              PIC  X(01)      VALUE SPACE.
018000     03  WS-SM-OPENED        PIC  X(06)      VALUE SPACES.
018100     03  FILLER              PIC  X(01)      VALUE SPACE.
018200     03  WS-SM-READS         PIC  ZZZZZZZZ9.
018300     03  FILLER              PIC  X(08)      VALUE ' READS, '.
018400     03  WS-SM-WRITES        PIC  ZZZZZZZZ9.
018500     03  FILLER              PIC  X(09)      VALUE ' WRITES, '.
018600     03  WS-SM-REWRITES      PIC  ZZZZZZZZ9.
018700     03  FILLER              PIC  X(09)      VALUE ' REWRITES'.
018800/
018900     COPY MMD3RL REPLACING ==:MMD3:== BY ==MB3O==.
019000/
019100     COPY SS00WS.
019200/
019300 01  FILLER                  PIC  X(12)      VALUE '** WS-END **'.
019400/
019500 LINKAGE SECTION.
019600*
019700****************************
019800*    FILE REQUEST BLOCK    *
019900****************************
020000*
020100     COPY MB00RB REPLACING ==:MB00:== BY ==MB3O==.
020200*
020300******************
020400*    I/O AREA    *
020500******************
020600*
020700     COPY MMD3IO REPLACING ==:MMD3:== BY ==MB3O==.
020800*
020900*********************************
021000*    ABEND ROUTINE WORK AREA    *
021100*********************************
021200*
021300     COPY SS02WS.
021400/
021500 PROCEDURE DIVISION          USING MB3ORB-WORK-AREA,
021600                                   MB3OIO-RECORD,
021700                                   SS02WS-ABEND-WORK-AREA.
021800*
021900 A000-MAIN-LINE-SECTION.
022000*
022100*
022200******************************************
022300*    SET THE ABEND WORK AREA IF THIS     *
022400*    IS THE FIRST CALL OF THE PROGRAM    *
022500******************************************
022600*
022700     IF  WS-FIRST-CALL-SW-IS-YES
022800         PERFORM Z000-PROGRAM-INITIALIZATION
022900            THRU Z099-PI-EXIT.
023000*
023100**************************
023200*    PROCESS THE FILE    *
023300**************************
023400*
023500     PERFORM S000-SEQUENTIAL-ACCESS
023600        THRU S999-SA-EXIT.
023700*
023800************************************************
023900*    MOVE THE STATUS CODE TO ITS RESPECTIVE    *
024000*    FIELD IN COPYBOOK SS02WS.                 *
024100************************************************
024200*
024300     MOVE MB3ORB-STATUS          TO SS02WS-FILE-STATUS.
024400*
024500 A999-GOBACK.
024600*
024700     GOBACK.
024800/
024900 S000-SEQUENTIAL-ACCESS.
025000*
025100     GO TO S110-SA-OPEN-INPUT
025200           S120-SA-OPEN-OUTPUT
025300           S130-SA-OPEN-I-O
025400           S100-SA-INVALID-REQUEST
025500           S100-SA-INVALID-REQUEST
025600           S100-SA-INVALID-REQUEST
025700           S100-SA-INVALID-REQUEST
025800           S100-SA-INVALID-REQUEST
025900           S100-SA-INVALID-REQUEST
026000           S100-SA-INVALID-REQUEST
026100           S100-SA-INVALID-REQUEST
026200           S140-SA-READ-SEQ
026300           S100-SA-INVALID-REQUEST
026400           S150-SA-WRITE
026500           S160-SA-REWRITE
026600           S100-SA-INVALID-REQUEST
026700           S170-SA-CLOSE
026800           DEPENDING ON MB3ORB-IO-REQUEST.
026900*
027000 S100-SA-INVALID-REQUEST.
027100*
027200     MOVE MB3ORB-IO-REQUEST      TO SS02WS-ABEND-REQUEST.
027300     MOVE '- BAD I-O REQ - MB3O' TO SS02WS-ABENDMSG8.
027400     GO TO Z950-ABORT.
027500*
027600 S110-SA-OPEN-INPUT.
027700*
027800     OPEN INPUT MB3O-FILE.
027900*
028000     MOVE 'SEQ'                  TO WS-SM-ACCESS.
028100     MOVE 'INPUT'                TO WS-SM-OPENED.
028200     MOVE '- OPEN  ERROR - MB3O' TO SS02WS-ABENDMSG8.
028300     GO TO S900-SA-CHECK-STATUS.
028400*
028500 S120-SA-OPEN-OUTPUT.
028600*
028700     OPEN OUTPUT MB3O-FILE.
028800*
028900     MOVE 'SEQ'                  TO WS-SM-ACCESS.
029000     MOVE 'OUTPUT'               TO WS-SM-OPENED.
029100     MOVE '- OPEN  ERROR - MB3O' TO SS02WS-ABENDMSG8.
029200     GO TO S900-SA-CHECK-STATUS.
029300*
029400 S130-SA-OPEN-I-O.
029500*
029600     OPEN I-O MB3O-FILE.
029700*
029800     MOVE 'SEQ'                  TO WS-SM-ACCESS.
029900     MOVE 'I-O'                  TO WS-SM-OPENED.
030000     MOVE '- OPEN  ERROR - MB3O' TO SS02WS-ABENDMSG8.
030100     GO TO S900-SA-CHECK-STATUS.
030200*
030300 S140-SA-READ-SEQ.
030400*
030500     SET WS-MAXIMUM-DATA-LENGTH  TO TRUE.
030600     READ MB3O-FILE              INTO MB3OIO-RECORD.
030700*
030800     ADD 1                       TO WS-SC-READS.
030900     MOVE '- READ  ERROR - MB3O' TO SS02WS-ABENDMSG8.
031000     GO TO S900-SA-CHECK-STATUS.
031100*
031200 S150-SA-WRITE.
031300*
031400     MOVE MB3OIO-RECORD          TO MB3O-FD-MAX-RECORD.
031500*
031600     EVALUATE TRUE
031700         WHEN MB3O-FD-VAR-IND IS NOT NUMERIC
031800             MOVE ZERO           TO MB3O-FD-VAR-IND
031900             MOVE ZERO           TO WS-DATA-LENGTH
032000         WHEN MB3O-FD-VDI-DEPOSIT-DATA
032100             MOVE LENGTH OF MB3O-VD-DEPOSIT-DATA
032200                                 TO WS-DATA-LENGTH
032300         WHEN MB3O-FD-VDI-FEE-DATA
032400             MOVE LENGTH OF MB3O-VD-FEE-AREA
032500                                 TO WS-DATA-LENGTH
032600         WHEN MB3O-FD-VDI-HEADER-DATA
032700             MOVE LENGTH OF MB3O-VD-HEADER-TOTALS
032800                                 TO WS-DATA-LENGTH
032900         WHEN OTHER
033000             MOVE ZERO           TO MB3O-FD-VAR-IND
033100             MOVE ZERO           TO WS-DATA-LENGTH
033200     END-EVALUATE.
033300*
033400     WRITE MB3O-FD-RECORD.
033500*
033600     ADD 1                       TO WS-SC-WRITES.
033700     MOVE '- WRITE ERROR - MB3O' TO SS02WS-ABENDMSG8.
033800     GO TO S900-SA-CHECK-STATUS.
033900*
034000 S160-SA-REWRITE.
034100*
034200     MOVE MB3OIO-RECORD          TO MB3O-FD-MAX-RECORD.
034300*
034400     EVALUATE TRUE
034500         WHEN MB3O-FD-VAR-IND IS NOT NUMERIC
034600             MOVE ZERO           TO MB3O-FD-VAR-IND
034700             MOVE ZERO           TO WS-DATA-LENGTH
034800         WHEN MB3O-FD-VDI-DEPOSIT-DATA
034900             MOVE LENGTH OF MB3O-VD-DEPOSIT-DATA
035000                                 TO WS-DATA-LENGTH
035100         WHEN MB3O-FD-VDI-FEE-DATA
035200             MOVE LENGTH OF MB3O-VD-FEE-AREA
035300                                 TO WS-DATA-LENGTH
035400         WHEN MB3O-FD-VDI-HEADER-DATA
035500             MOVE LENGTH OF MB3O-VD-HEADER-TOTALS
035600                                 TO WS-DATA-LENGTH
035700         WHEN OTHER
035800             MOVE ZERO           TO MB3O-FD-VAR-IND
035900             MOVE ZERO           TO WS-DATA-LENGTH
036000     END-EVALUATE.
036100*
036200     REWRITE MB3O-FD-RECORD      FROM MB3OIO-RECORD.
036300*
036400     ADD 1                       TO WS-SC-REWRITES.
036500     MOVE '- REWRT ERROR - MB3O' TO SS02WS-ABENDMSG8.
036600     GO TO S900-SA-CHECK-STATUS.
036700*
036800 S170-SA-CLOSE.
036900*
037000     MOVE SPACE                  TO WS-FIRST-CALL-SW.
037100     CLOSE MB3O-FILE.
037200*
037300     PERFORM Z100-DISPLAY-THE-SUMMARY
037400        THRU Z199-DTS-EXIT.
037500*
037600     MOVE '- CLOSE ERROR - MB3O' TO SS02WS-ABENDMSG8.
037700     GO TO S900-SA-CHECK-STATUS.
037800*
037900 S900-SA-CHECK-STATUS.
038000*
038100     MOVE WS-STATUS              TO MB3ORB-STATUS.
038200*
038300     IF  MB3ORB-STATUS IS EQUAL  TO MB3ORB-TEMP-STATUS-1   OR
038400         MB3ORB-STATUS IS EQUAL  TO MB3ORB-TEMP-STATUS-2   OR
038500         MB3ORB-STATUS IS EQUAL  TO MB3ORB-PERM-STATUS-1   OR
038600         MB3ORB-STATUS IS EQUAL  TO MB3ORB-PERM-STATUS-2   OR
038700         MB3ORB-STATUS IS EQUAL  TO MB3ORB-PERM-STATUS-3   OR
038800         MB3ORB-STATUS IS EQUAL  TO MB3ORB-PERM-STATUS-4   OR
038900         MB3ORB-STATUS IS EQUAL  TO MB3ORB-PERM-STATUS-5
039000         MOVE ZERO               TO MB3ORB-TEMP-STATUS-1
039100         MOVE ZERO               TO MB3ORB-TEMP-STATUS-2
039200     ELSE
039300         GO TO Z900-ABORT.
039400*
039500 S999-SA-EXIT.
039600     EXIT.
039700/
039800 Z000-PROGRAM-INITIALIZATION.
039900*
040000************************************************************
040100*    THE CALLING PROGRAM MUST SUPPLY THE PROGRAM ID TO     *
040200*    ENSURE THAT ANY SUBSEQUENT ABEND CAN BE TRACED TO     *
040300*    IT.  IF THE PROGRAM ID IS NOT SUPPLIED, THE ACCESS    *
040400*    ROUTINE ABENDS HERE.                                  *
040500************************************************************
040600*
040700     IF  SS02WS-ABEND-PROG-ID IS EQUAL TO SPACES
040800         MOVE '- BAD PROG NAME - MB3O'
040900                                 TO SS02WS-ABENDMSG8
041000         MOVE 'BADPRO'           TO SS02WS-ABEND-PROG-ID
041100         GO TO Z950-ABORT.
041200*
041300     MOVE SS02WS-ABEND-PROG-ID   TO WS-SM-PROG-ID.
041400*
041500*************************************************************
041600*    SINCE THIS ROUTINE IS PERFORMED ONLY ONCE DURING       *
041700*    THE EXECUTION OF A CALLING PROGRAM, THE FIRST          *
041800*    REQUEST MUST BE FOR AN OPEN.  SET THE ACCESS METHOD    *
041900*    (SEQENTIAL, DYNAMIC, OR RANDOM), OR ISSUE AN ABEND     *
042000*    IF THE REQUEST IS NOT FOR AN OPEN.                     *
042100*************************************************************
042200*
042300     IF  MB3ORB-OPEN-INPUT    OR
042400         MB3ORB-OPEN-OUTPUT   OR
042500         MB3ORB-OPEN-IO
042600         MOVE 'N'                TO WS-FIRST-CALL-SW
042700     ELSE
042800         MOVE 'ILLEGAL ACCESS REQUEST'
042900                                 TO SS02WS-ABENDMSG8
043000         GO TO Z950-ABORT.
043100*
043200 Z099-PI-EXIT.
043300     EXIT.
043400*
043500 Z100-DISPLAY-THE-SUMMARY.
043600*
043700     MOVE WS-SC-READS            TO WS-SM-READS.
043800     MOVE WS-SC-WRITES           TO WS-SM-WRITES.
043900     MOVE WS-SC-REWRITES         TO WS-SM-REWRITES.
044000     DISPLAY WS-SUMMARY-MESSAGE.
044100*
044200     INITIALIZE WS-SUMMARY-COUNTERS.
044300*
044400 Z199-DTS-EXIT.
044500     EXIT.
044600/
044700 Z900-ABORT.
044800*
044900     MOVE 'SMB3O'                TO SS02WS-ABEND-CODE-X.
045000     MOVE MB3ORB-STATUS          TO SS02WS-ABEND-STATUS.
045100     MOVE MB3ORB-IO-REQUEST      TO WS-IO-REQUEST.
045200     MOVE WS-IO-REQUEST          TO SS02WS-ABEND-REQUEST.
045300*
045400 Z950-ABORT.
045500*
045600     PERFORM SS02PD-ABEND        THRU SS02PD-ABEND-EXIT.
045700*
045800 Z999-ABORT-EXIT.
045900     EXIT.
046000/
046100********************************
046200*    STANDARD ABEND ROUTINE    *
046300********************************
046400*
046500     COPY SS02PD.
046600*
