000100 IDENTIFICATION DIVISION.
000200 PROGRAM-ID. MMUIAB.
000201*       RELEASE DATE=08/24/01.        REVISION LEVEL=08.06      * ++++++++
000202***************************************************************** ++++++++
000203*WARNING.  THIS COMPUTER PROGRAM IS PROTECTED BY COPYRIGHT LAW  * ++++++++
000204*AND INTERNATIONAL TREATIES.  UNAUTHORIZED REPRODUCTION OR      * ++++++++
000205*DISTRIBUTION OF THIS PROGRAM, OR ANY PORTION OF IT, MAY RESULT * ++++++++
000206*IN SEVERE CIVIL AND CRIMINAL PENATLIES, AND WILL BE PROSECUTED * ++++++++
000207*TO THE MAXIMUM EXTENT POSSIBLE UNDER THE LAW.                  * ++++++++
000208*COPYRIGHT 1999 PAYSYS INTERNATIONAL, INC.  ALL RIGHTS RESERVED.* ++++++++
000209***************************************************************** ++++++++
000300******************************************************************
000400*                                                                *
000500*    ---------------MERCHANT BANKCARD SYSTEM---------------      *
000600*                                                                *
000700*          MMUIAB - MMUI FILE COMMON BATCH I/O ROUTINE           *
000800*                                                                *
000900*                 VARIABLE LENGTH VSAM FILE                      *
001000*                                                                *
001100*    ---USER-INPUT NON-MONETARY MAINTRENACE INTERFACE IN---      *
001200*                                                                *
001300******************************************************************
001400*                                                                *
001500*    COPYBOOKS WHICH MUST APPEAR IN YOUR BATCH PROGRAM:          *
001600*                                                                *
001700*    (WS) MB00RB - BATCH REQUEST BLOCK                           *
001800*    (WS) MMUIIO - I/O AREA                                      *
001900*    (WS) SS02WS - STANDARD ABEND ROUTINE WORK AREA              *
002000*    (PD) MB00PD - PROCEDURE DIVISION CALL STATEMENT             *
002100*                                                                *
002200******************************************************************
002300*                                                                *
002400*    TO USE THIS ROUTINE.........                                *
002500*                                                                *
002600* 1. HOUSEKEEPING DUTIES:                                        *
002700*                                                                *
002800*    A. IN THE HOUSEKEEPING SECTION OF YOUR PROGRAM, MOVE THE    *
002900*       NAME OF THE PROGRAM USING THIS ROUTINE TO THE FIELD      *
003000*       'SS02WS-ABEND-PROG-ID'. THIS FIELD IS USED AS PART OF THE*
003100*       STANDARD ABEND MESSAGES IF A PROGRAM ABORTS WITHIN THIS  *
003200*       ACCESS ROUTINE.  IF THE FIELD 'SS02WS-ABEND-PROG-ID' IS  *
003300*       LEFT BLANK, THIS ROUTINE WILL FORCE AN ABEND SITUATION.  *
003400*                                                                *
003500*    B. BEFORE PERFORMING THE ACCESS ROUTINE, MOVE A LITERAL TO  *
003600*       THE FIELD 'SS02WS-ABEND-LOCATION'. THIS FIELD CAN BE USED*
003700*       TO INDICATE WHERE THE ROUTINE IS BEING 'FROM' IN CASE    *
003800*       OF ABNORMAL TERMINATION. (E.G. DEBUGGING ASSISTANCE)     *
003900*                                                                *
004000*    C. SET THE RETURN CODES WHICH YOU WANT, FOR THE DURATION    *
004100*       OF THIS PROGRAM, TO BE CONSIDERED VALID IN THE FIELDS    *
004200*       'MMUIRB-PERM-STATUS-1 TO -5'. THESE FIELDS ARE INITIAL-  *
004300*       IZED TO ZERO (AS ZERO IS ALWAYS AN ACCEPTABLE RETURN     *
004400*       CODE).  THIS ROUTINE WILL (IN ALL I-O REQUESTS) SUCCESS- *
004500*       FULLY SATISFY YOUR PERFORM REQUEST IF ANY OF THE REQUESTS*
004600*       ENCOUNTER ANY OF THE PERMANENT STATUS CODES 1-5.         *
004700*                                                                *
004800* 2. SET ONE OF THE FOLLOWING CONDITION NAMES TO 'TRUE' TO SET   *
004900*    THE FILE REQUEST:                                           *
005000*                                                                *
005100*        CONDITION NAME                EXPLANATION               *
005200*   *----------------------***---------------------------------* *
005300*                                                                *
005400*    MMUIRB-OPEN-INPUT      - OPEN THE FILE AS INPUT WITH        *
005500*                             SEQUENTIAL ACCESS.                 *
005600*    MMUIRB-OPEN-OUTPUT     - OPEN THE FILE AS OUTPUT WITH       *
005700*                             SEQUENTIAL ACCESS.                 *
005800*    MMUIRB-OPEN-IO         - OPEN THE FILE AS I-O WITH          *
005900*                             SEQUENTIAL ACCESS.                 *
006000*    MMUIRB-OPEN-INPUT-DYN  - OPEN THE FILE AS INPUT WITH        *
006100*                             DYNAMIC ACCESS.                    *
006200*    MMUIRB-OPEN-OUTPUT-DYN - OPEN THE FILE AS OUTPUT WITH       *
006300*                             DYNAMIC ACCESS.                    *
006400*    MMUIRB-OPEN-IO-DYN     - OPEN THE FILE AS I-O WITH          *
006500*                             DYNAMIC ACCESS.                    *
006600*    MMUIRB-OPEN-INPUT-RDM  - OPEN THE FILE AS INPUT WITH        *
006700*                             RANDOM ACCESS.                     *
006800*    MMUIRB-OPEN-OUTPUT-RDM - OPEN THE FILE AS OUTPUT WITH       *
006900*                             RANDOM ACCESS.                     *
007000*    MMUIRB-OPEN-IO-RDM     - OPEN THE FILE AS I-O WITH          *
007100*                             RANDOM ACCESS.                     *
007200*    MMUIRB-START-GTE       - START THE FILE WIOTH A KEY         *
007300*                             > OR            = THE        KEY   *
007400*                             CONTAINED IN 'MMUIIO-KEY'.         *
007500*    MMUIRB-START-EQUAL     - START THE FILE WITH A KEY =        *
007600*                             TO THE KEY CONTAINED IN            *
007700*                             'MMUIIO-KEY'.                      *
007800*    MMUIRB-READ-SEQ        - READ THE NEXT SEQUENTIAL RECORD    *
007900*                             IN THE FILE.                       *
008000*    MMUIRB-READ-RANDOM     - READ THE RECORD IN THE FILE        *
008100*                             CORRESPONDING TO THE KEY CONTAINED *
008200*                             IN 'MMUIIO-KEY'.                   *
008300*    MMUIRB-WRITE           - WRITE A RECORD (THE RECORD MUST    *
008400*                             BE IN 'MMUIIO-RECORD').            *
008500*    MMUIRB-REWRITE         - REWRITE A RECORD (THE RECORD MUST  *
008600*                             BE IN 'MMUIIO-RECORD').            *
008700*    MMUIRB-DELETE          - DELETE THE RECORD IN THE FILE      *
008800*                             CORRESPONDING TO THE KEY CONTAINED *
008900*                             IN 'MMUIIO-KEY'.                   *
009000*    MMUIRB-CLOSE           - CLOSE THE FILE.                    *
009100*                                                                *
009200* 3. SET ONE OR BOTH OF THE 'TEMPORARY' RETURN CODE FIELDS       *
009300*    'MMUIRB-TEMP-STATUS-1 AND -2'.  THESE TWO RETURN CODES      *
009400*    ARE TO BE USED ON A PER USE BASIS OF THIS ROUTINE.          *
009500*    THESE TWO RETURN CODES ARE INITIALIZED TO ZERO AND ARE      *
009600*    BOTH RESET TO ZERO AFTER EACH CALL OF THIS PROGRAM.         *
009700*    THE TEMPORARY RETURN CODE FIELDS ARE CHECKED FIRST AND      *
009800*    THEN THE PERMANENT RETURN CODES (POINT 1.C ABOVE) WILL      *
009900*    BE CHECKED.                                                 *
010000*                                                                *
010100* 4. PERFORM MB00PD-MMUI-ACCESS THRU MB00PD-MMUI-ACCESS-EXIT.    *
010200*                                                                *
010300*    A. YOU MUST HANDLE MANUALLY ANY RETURN CODE (EITHER TEMP    *
010400*       OR PERM) THAT YOU REQUESTED, AND IF NEEDED, YOUR OWN     *
010500*       ABEND REQUEST.                                           *
010600*                                                                *
010700*    B. ALL ACCESS ROUTINES MOVE THE FILE STATUS TO THE FIELD    *
010800*       SS02WS-FILE-STATUS IN COPYBOOK SS02WS. USE THE '88' LEVEL*
010900*       NAMES TO TEST YOUR MANUAL STATUS CHECKS.  ALSO IN COPY   *
011000*       BOOK SS02WS, USE THE 'WS-' FILE STATUS DATA NAMES WHEN   *
011100*       SETTING THE PERM OR TEMP FILE STATUS CODES PRIOR TO      *
011200*       PERFORMING THE ACCESS ROUTINE.  FOR VSAM FILES, THE VSAM *
011300*       RETURN CODE IS MOVED TO THE FIELD 'SS02WS-FILE-RETURN' IN*
011400*       COPYBOOK SS02WS.                                         *
011500*                                                                *
011600******************************************************************
011700/
011800 ENVIRONMENT DIVISION.
011900*
012000 CONFIGURATION SECTION.
012100 SOURCE-COMPUTER.            IBM-4341.
012200 OBJECT-COMPUTER.            IBM-4341.
012300*
012400 INPUT-OUTPUT SECTION.
012500*
012600 FILE-CONTROL.
012700*
012800     SELECT  MMUI-FILE-SEQ
012900             ASSIGN TO MMUI
013000             ORGANIZATION IS INDEXED
013100             ACCESS       IS SEQUENTIAL
013200             FILE STATUS  IS WS-STATUS
013300                             WS-RETURN
013400             RECORD KEY   IS MMUI-SEQ-KEY.
013500*
013600     SELECT  MMUI-FILE-DYN
013700             ASSIGN TO MMUI
013800             ORGANIZATION IS INDEXED
013900             ACCESS       IS DYNAMIC
014000             FILE STATUS  IS WS-STATUS
014100                             WS-RETURN
014200             RECORD KEY   IS MMUI-DYN-KEY.
014300*
014400     SELECT  MMUI-FILE-RDM
014500             ASSIGN TO MMUI
014600             ORGANIZATION IS INDEXED
014700             ACCESS       IS RANDOM
014800             FILE STATUS  IS WS-STATUS
014900                             WS-RETURN
015000             RECORD KEY   IS MMUI-RDM-KEY.
015100*
015200 I-O-CONTROL.
015300*
015400     SAME AREA FOR
015500         MMUI-FILE-SEQ
015600         MMUI-FILE-DYN
015700         MMUI-FILE-RDM.
015800/
015900 DATA DIVISION.
016000*
016100 FILE SECTION.
016200*
016300***********************
016400*    SEQUENTIAL FD    *
016500***********************
016600*
016700 FD  MMUI-FILE-SEQ
016800     RECORD CONTAINS 9 TO 8186 CHARACTERS.
016900*
017000 01  MMUI-SEQ-MAX-RECORD.
017100     03  MMUI-SEQ-MAX-KEY    PIC  X(07).
017200     03  MMUI-SEQ-MAX-LENGTH PIC  S9(04)     BINARY.
017300     03  MMUI-SEQ-MAX-DATA   PIC  X(8177).
017400*
017500 01  MMUI-SEQ-RECORD.
017600     03  MMUI-SEQ-KEY        PIC  X(07).
017700     03  MMUI-SEQ-LENGTH     PIC S9(04)      BINARY.
017800     03  MMUI-SEQ-VAR-DATA                  OCCURS 0 TO 8177 TIMES
017900                                             DEPENDING ON
018000                                             WS-DATA-LENGTH.
018100         05  MMUI-SEQ-VD-BYTE
018200                             PIC  X(01).
018300*
018400********************
018500*    DYNAMIC FD    *
018600********************
018700*
018800 FD  MMUI-FILE-DYN
018900     RECORD CONTAINS 9 TO 8186 CHARACTERS.
019000*
019100 01  MMUI-DYN-MAX-RECORD.
019200     03  MMUI-DYN-MAX-KEY    PIC  X(07).
019300     03  MMUI-DYN-MAX-LENGTH PIC  S9(04)     BINARY.
019400     03  MMUI-DYN-MAX-DATA   PIC  X(8177).
019500*
019600 01  MMUI-DYN-RECORD.
019700     03  MMUI-DYN-KEY        PIC  X(07).
019800     03  MMUI-DYN-LENGTH     PIC S9(04)      BINARY.
019900     03  MMUI-DYN-VAR-DATA                  OCCURS 0 TO 8177 TIMES
020000                                             DEPENDING ON
020100                                             WS-DATA-LENGTH.
020200         05  MMUI-DYN-VD-BYTE
020300                             PIC  X(01).
020400*
020500*******************
020600*    RANDOM FD    *
020700*******************
020800*
020900 FD  MMUI-FILE-RDM
021000     RECORD CONTAINS 9 TO 8186 CHARACTERS.
021100*
021200 01  MMUI-RDM-MAX-RECORD.
021300     03  MMUI-RDM-MAX-KEY    PIC  X(07).
021400     03  MMUI-RDM-MAX-LENGTH PIC  S9(04)     BINARY.
021500     03  MMUI-RDM-MAX-DATA   PIC  X(8177).
021600*
021700 01  MMUI-RDM-RECORD.
021800     03  MMUI-RDM-KEY        PIC  X(07).
021900     03  MMUI-RDM-LENGTH     PIC S9(04)      BINARY.
022000     03  MMUI-RDM-VAR-DATA                  OCCURS 0 TO 8177 TIMES
022100                                             DEPENDING ON
022200                                             WS-DATA-LENGTH.
022300         05  MMUI-RDM-VD-BYTE
022400                             PIC  X(01).
022500/
022600 WORKING-STORAGE SECTION.
022700*
022800 01  FILLER                  PIC  X(12)      VALUE '** WS-BEG **'.
022900*
023000 01  FILLER                  PIC  X(24)      VALUE
023100     'ACCESS METHOD INDICATOR:'.
023200*
023300 01  WS-ACCESS-METHOD        PIC  X(01)      VALUE SPACE.
023400     88  ACCESS-METHOD-NOT-SET               VALUE SPACE.
023500     88  ACCESS-IS-SEQUENTIAL                VALUE 'S'.
023600     88  ACCESS-IS-DYNAMIC                   VALUE 'D'.
023700     88  ACCESS-IS-RANDOM                    VALUE 'R'.
023800*
023900 01  FILLER                  PIC  X(12)      VALUE
024000     'FILE STATUS:'.
024100*
024200 01  WS-STATUS               PIC  X(02)      VALUE ZERO.
024300*
024400 01  FILLER                  PIC  X(16)      VALUE
024500     'EXTENDED RETURN:'.
024600*
024700 01  WS-RETURN.
024800     03  WS-RETURN-CODE      PIC 9(02)       BINARY
024900                                             VALUE ZERO.
025000     03  WS-FUNCTION-CODE    PIC 9(02)       BINARY
025100                                             VALUE ZERO.
025200     03  WS-FEEDBACK-CODE    PIC 9(02)       BINARY
025300                                             VALUE ZERO.
025400*
025500 01  FILLER                  PIC  X(12)      VALUE
025600     'I-O REQUEST:'.
025700*
025800 01  WS-IO-REQUEST           PIC  9(02)      VALUE ZERO.
025900*
026000 01  FILLER                  PIC  X(28)      VALUE
026100     'PROCESSING SUMMARY COUNTERS:'.
026200*
026300 01  WS-SUMMARY-COUNTERS.
026400     03  WS-SC-READS         PIC S9(09)      PACKED-DECIMAL
026500                                             VALUE ZERO.
026600     03  WS-SC-WRITES        PIC S9(09)      PACKED-DECIMAL
026700                                             VALUE ZERO.
026800     03  WS-SC-REWRITES      PIC S9(09)      PACKED-DECIMAL
026900                                             VALUE ZERO.
027000     03  WS-SC-DELETES       PIC S9(09)      PACKED-DECIMAL
027100                                             VALUE ZERO.
027200*
027300 01  FILLER                  PIC  X(27)      VALUE
027400     'PROCESSING SUMMARY MESSAGE:'.
027500*
027600 01  WS-SUMMARY-MESSAGE.
027700     03  FILLER              PIC  X(10)      VALUE '(PGMSTAT) '.
027800     03  WS-SM-PROG-ID       PIC  X(06)      VALUE SPACES.
027900     03  FILLER              PIC  X(03)      VALUE ' - '.
028000     03  WS-SM-FILE-ID       PIC  X(04)      VALUE 'MMUI'.
028100     03  FILLER              PIC  X(11)      VALUE ' - OPENED: '.
028200     03  WS-SM-ACCESS        PIC  X(03)      VALUE SPACES.
028300     03  FILLER              PIC  X(01)      VALUE SPACE.
028400     03  WS-SM-OPENED        PIC  X(06)      VALUE SPACES.
028500     03  FILLER              PIC  X(01)      VALUE SPACE.
028600     03  WS-SM-READS         PIC  ZZZZZZZZ9.
028700     03  FILLER              PIC  X(08)      VALUE ' READS, '.
028800     03  WS-SM-WRITES        PIC  ZZZZZZZZ9.
028900     03  FILLER              PIC  X(09)      VALUE ' WRITES, '.
029000     03  WS-SM-REWRITES      PIC  ZZZZZZZZ9.
029100     03  FILLER              PIC  X(11)      VALUE ' REWRITES, '.
029200     03  WS-SM-DELETES       PIC  ZZZZZZZZ9.
029300     03  FILLER              PIC  X(08)      VALUE ' DELETES'.
029400*
029500 01  WS-DATA-LENGTH          PIC S9(08)      BINARY
029600                                             VALUE ZERO.
029700/
029800     COPY SS00WS.
029900/
030000 01  FILLER                  PIC  X(12)      VALUE '** WS-END **'.
030100/
030200 LINKAGE SECTION.
030300*
030400****************************
030500*    FILE REQUEST BLOCK    *
030600****************************
030700*
030800     COPY MB00RB REPLACING ==:MB00:== BY ==MMUI==.
030900*
031000******************
031100*    I/O AREA    *
031200******************
031300*
031400     COPY MMUIIO REPLACING ==:MMUI:== BY ==MMUI==.
031500*
031600*********************************
031700*    ABEND ROUTINE WORK AREA    *
031800*********************************
031900*
032000     COPY SS02WS.
032100/
032200 PROCEDURE DIVISION          USING MMUIRB-WORK-AREA,
032300                                   MMUIIO-RECORD,
032400                                   SS02WS-ABEND-WORK-AREA.
032500*
032600 A000-MAIN-LINE-SECTION.
032700*
032800*
032900***************************************************
033000*    SET THE ACCESS METHOD AND ABEND WORK AREA    *
033100*    IF THIS IS THE FIRST CALL OF THIS PROGRAM    *
033200***************************************************
033300*
033400     IF  ACCESS-METHOD-NOT-SET
033500         PERFORM Z000-PROGRAM-INITIALIZATION
033600            THRU Z099-PI-EXIT.
033700*
033800**************************************************************
033900*    PROCESS THE FILE DEPENDING OF THE PROCESSING OPTION.    *
034000**************************************************************
034100*
034200     IF  ACCESS-IS-SEQUENTIAL
034300         PERFORM S000-SEQUENTIAL-ACCESS
034400            THRU S999-SA-EXIT
034500     ELSE
034600         IF  ACCESS-IS-DYNAMIC
034700             PERFORM D000-DYNAMIC-ACCESS
034800                THRU D999-DA-EXIT
034900         ELSE
035000             PERFORM R000-RANDOM-ACCESS
035100                THRU R999-RA-EXIT.
035200*
035300*****************************************************
035400*    MOVE THE STATUS CODE AND RETURN CODE TO        *
035500*    THEIR RESPECTIVE FIELDS IN COPYBOOK SS02WS.    *
035600*****************************************************
035700*
035800     MOVE MMUIRB-STATUS          TO SS02WS-FILE-STATUS.
035900     MOVE MMUIRB-RETURN          TO SS02WS-FILE-RETURN.
036000*
036100 A999-GOBACK.
036200*
036300     GOBACK.
036400/
036500 D000-DYNAMIC-ACCESS.
036600*
036700     GO TO D100-DA-INVALID-REQUEST
036800           D100-DA-INVALID-REQUEST
036900           D100-DA-INVALID-REQUEST
037000           D110-DA-OPEN-INPUT
037100           D120-DA-OPEN-OUTPUT
037200           D130-DA-OPEN-I-O
037300           D100-DA-INVALID-REQUEST
037400           D100-DA-INVALID-REQUEST
037500           D100-DA-INVALID-REQUEST
037600           D140-DA-START-GTE
037700           D150-DA-START-EQUAL
037800           D160-DA-READ-SEQ
037900           D170-DA-READ-RANDOM
038000           D180-DA-WRITE
038100           D190-DA-REWRITE
038200           D200-DA-DELETE
038300           D210-DA-CLOSE
038400           DEPENDING ON MMUIRB-IO-REQUEST.
038500*
038600 D100-DA-INVALID-REQUEST.
038700*
038800     MOVE MMUIRB-IO-REQUEST      TO SS02WS-ABEND-REQUEST.
038900     MOVE '- BAD I-O REQ - MMUI' TO SS02WS-ABENDMSG8.
039000     GO TO Z950-ABORT.
039100*
039200 D110-DA-OPEN-INPUT.
039300*
039400     OPEN INPUT MMUI-FILE-DYN.
039500*
039600     IF  WS-STATUS IS EQUAL TO '97'
039700         MOVE '97'               TO MMUIRB-OPEN-STATUS
039800         MOVE LOW-VALUES         TO WS-RETURN
039900         MOVE ZEROS              TO WS-STATUS.
040000*
040100     MOVE 'DYN'                  TO WS-SM-ACCESS.
040200     MOVE 'INPUT'                TO WS-SM-OPENED.
040300     MOVE '- OPEN  ERROR - MMUI' TO SS02WS-ABENDMSG8.
040400     GO TO D900-DA-CHECK-STATUS.
040500*
040600 D120-DA-OPEN-OUTPUT.
040700*
040800     OPEN OUTPUT MMUI-FILE-DYN.
040900*
041000     IF  WS-STATUS IS EQUAL TO '97'
041100         MOVE '97'               TO MMUIRB-OPEN-STATUS
041200         MOVE LOW-VALUES         TO WS-RETURN
041300         MOVE ZEROS              TO WS-STATUS.
041400*
041500     MOVE 'DYN'                  TO WS-SM-ACCESS.
041600     MOVE 'OUTPUT'               TO WS-SM-OPENED.
041700     MOVE '- OPEN  ERROR - MMUI' TO SS02WS-ABENDMSG8.
041800     GO TO D900-DA-CHECK-STATUS.
041900*
042000 D130-DA-OPEN-I-O.
042100*
042200     OPEN I-O MMUI-FILE-DYN.
042300*
042400     MOVE 'DYN'                  TO WS-SM-ACCESS.
042500     MOVE 'I-O'                  TO WS-SM-OPENED.
042600     MOVE '- OPEN  ERROR - MMUI' TO SS02WS-ABENDMSG8.
042700     GO TO D900-DA-CHECK-STATUS.
042800*
042900 D140-DA-START-GTE.
043000*
043100     MOVE MMUIIO-KEY             TO MMUI-DYN-KEY.
043200     START MMUI-FILE-DYN
043300           KEY IS NOT LESS THAN MMUI-DYN-KEY.
043400*
043500     MOVE '- START ERROR - MMUI' TO SS02WS-ABENDMSG8.
043600     GO TO D900-DA-CHECK-STATUS.
043700*
043800 D150-DA-START-EQUAL.
043900*
044000     MOVE MMUIIO-KEY             TO MMUI-DYN-KEY.
044100     START MMUI-FILE-DYN
044200           KEY IS EQUAL TO MMUI-DYN-KEY.
044300*
044400     MOVE '- START ERROR - MMUI' TO SS02WS-ABENDMSG8.
044500     GO TO D900-DA-CHECK-STATUS.
044600*
044700 D160-DA-READ-SEQ.
044800*
044900     READ MMUI-FILE-DYN NEXT RECORD
045000                                 INTO MMUIIO-RECORD.
045100*
045200     ADD 1                       TO WS-SC-READS.
045300     MOVE '- READ  ERROR - MMUI' TO SS02WS-ABENDMSG8.
045400     GO TO D900-DA-CHECK-STATUS.
045500*
045600 D170-DA-READ-RANDOM.
045700*
045800     MOVE MMUIIO-KEY             TO MMUI-DYN-KEY.
045900     READ MMUI-FILE-DYN          INTO MMUIIO-RECORD.
046000*
046100     ADD 1                       TO WS-SC-READS.
046200     MOVE '- READ  ERROR - MMUI' TO SS02WS-ABENDMSG8.
046300     GO TO D900-DA-CHECK-STATUS.
046400*
046500 D180-DA-WRITE.
046600*
046700     MOVE MMUIIO-RECORD          TO MMUI-DYN-MAX-RECORD.
046800     MOVE MMUI-DYN-MAX-LENGTH    TO WS-DATA-LENGTH.
046900*
047000     WRITE MMUI-DYN-RECORD.
047100*
047200     ADD 1                       TO WS-SC-WRITES.
047300     MOVE '- WRITE ERROR - MMUI' TO SS02WS-ABENDMSG8.
047400     GO TO D900-DA-CHECK-STATUS.
047500*
047600 D190-DA-REWRITE.
047700*
047800     MOVE MMUIIO-RECORD          TO MMUI-DYN-MAX-RECORD.
047900     MOVE MMUI-DYN-MAX-LENGTH    TO WS-DATA-LENGTH.
048000*
048100     REWRITE MMUI-DYN-RECORD.
048200*
048300     ADD 1                       TO WS-SC-REWRITES.
048400     MOVE '- REWRT ERROR - MMUI' TO SS02WS-ABENDMSG8.
048500     GO TO D900-DA-CHECK-STATUS.
048600*
048700 D200-DA-DELETE.
048800*
048900     MOVE MMUIIO-KEY             TO MMUI-DYN-KEY.
049000     DELETE MMUI-FILE-DYN RECORD.
049100*
049200     ADD 1                       TO WS-SC-DELETES.
049300     MOVE '- DELET ERROR - MMUI' TO SS02WS-ABENDMSG8.
049400     GO TO D900-DA-CHECK-STATUS.
049500*
049600 D210-DA-CLOSE.
049700*
049800     MOVE SPACE                  TO WS-ACCESS-METHOD.
049900     CLOSE  MMUI-FILE-DYN.
050000*
050100     PERFORM Z100-DISPLAY-THE-SUMMARY
050200        THRU Z199-DTS-EXIT.
050300*
050400     MOVE '- CLOSE ERROR - MMUI' TO SS02WS-ABENDMSG8.
050500     GO TO D900-DA-CHECK-STATUS.
050600*
050700 D900-DA-CHECK-STATUS.
050800*
050900     MOVE WS-STATUS              TO MMUIRB-STATUS.
051000     MOVE WS-RETURN              TO MMUIRB-RETURN.
051100*
051200     IF  MMUIRB-STATUS IS EQUAL  TO MMUIRB-TEMP-STATUS-1   OR
051300         MMUIRB-STATUS IS EQUAL  TO MMUIRB-TEMP-STATUS-2   OR
051400         MMUIRB-STATUS IS EQUAL  TO MMUIRB-PERM-STATUS-1   OR
051500         MMUIRB-STATUS IS EQUAL  TO MMUIRB-PERM-STATUS-2   OR
051600         MMUIRB-STATUS IS EQUAL  TO MMUIRB-PERM-STATUS-3   OR
051700         MMUIRB-STATUS IS EQUAL  TO MMUIRB-PERM-STATUS-4   OR
051800         MMUIRB-STATUS IS EQUAL  TO MMUIRB-PERM-STATUS-5
051900         MOVE ZERO               TO MMUIRB-TEMP-STATUS-1
052000         MOVE ZERO               TO MMUIRB-TEMP-STATUS-2
052100     ELSE
052200         GO TO Z900-ABORT.
052300*
052400 D999-DA-EXIT.
052500     EXIT.
052600/
052700 R000-RANDOM-ACCESS.
052800*
052900     GO TO R100-RA-INVALID-REQUEST
053000           R100-RA-INVALID-REQUEST
053100           R100-RA-INVALID-REQUEST
053200           R100-RA-INVALID-REQUEST
053300           R100-RA-INVALID-REQUEST
053400           R100-RA-INVALID-REQUEST
053500           R110-RA-OPEN-INPUT
053600           R120-RA-OPEN-OUTPUT
053700           R130-RA-OPEN-I-O
053800           R100-RA-INVALID-REQUEST
053900           R100-RA-INVALID-REQUEST
054000           R100-RA-INVALID-REQUEST
054100           R140-RA-READ-RANDOM
054200           R150-RA-WRITE
054300           R160-RA-REWRITE
054400           R170-RA-DELETE
054500           R180-RA-CLOSE
054600           DEPENDING ON MMUIRB-IO-REQUEST.
054700*
054800 R100-RA-INVALID-REQUEST.
054900*
055000     MOVE MMUIRB-IO-REQUEST      TO SS02WS-ABEND-REQUEST.
055100     MOVE '- BAD I-O REQ - MMUI' TO SS02WS-ABENDMSG8.
055200     GO TO Z950-ABORT.
055300*
055400 R110-RA-OPEN-INPUT.
055500*
055600     OPEN INPUT MMUI-FILE-RDM.
055700*
055800     IF  WS-STATUS IS EQUAL TO '97'
055900         MOVE '97'               TO MMUIRB-OPEN-STATUS
056000         MOVE LOW-VALUES         TO WS-RETURN
056100         MOVE ZEROS              TO WS-STATUS.
056200*
056300     MOVE 'RDM'                  TO WS-SM-ACCESS.
056400     MOVE 'INPUT'                TO WS-SM-OPENED.
056500     MOVE '- OPEN  ERROR - MMUI' TO SS02WS-ABENDMSG8.
056600     GO TO R900-RA-CHECK-STATUS.
056700*
056800 R120-RA-OPEN-OUTPUT.
056900*
057000     OPEN OUTPUT MMUI-FILE-RDM.
057100*
057200     IF  WS-STATUS IS EQUAL TO '97'
057300         MOVE '97'               TO MMUIRB-OPEN-STATUS
057400         MOVE LOW-VALUES         TO WS-RETURN
057500         MOVE ZEROS              TO WS-STATUS.
057600*
057700     MOVE 'RDM'                  TO WS-SM-ACCESS.
057800     MOVE 'OUTPUT'               TO WS-SM-OPENED.
057900     MOVE '- OPEN  ERROR - MMUI' TO SS02WS-ABENDMSG8.
058000     GO TO R900-RA-CHECK-STATUS.
058100*
058200 R130-RA-OPEN-I-O.
058300*
058400     OPEN I-O MMUI-FILE-RDM.
058500*
058600     MOVE 'RDM'                  TO WS-SM-ACCESS.
058700     MOVE 'I-O'                  TO WS-SM-OPENED.
058800     MOVE '- OPEN  ERROR - MMUI' TO SS02WS-ABENDMSG8.
058900     GO TO R900-RA-CHECK-STATUS.
059000*
059100 R140-RA-READ-RANDOM.
059200*
059300     MOVE MMUIIO-KEY             TO MMUI-RDM-KEY.
059400     READ MMUI-FILE-RDM          INTO MMUIIO-RECORD.
059500*
059600     ADD 1                       TO WS-SC-READS.
059700     MOVE '- READ  ERROR - MMUI' TO SS02WS-ABENDMSG8.
059800     GO TO R900-RA-CHECK-STATUS.
059900*
060000 R150-RA-WRITE.
060100*
060200     MOVE MMUIIO-RECORD          TO MMUI-RDM-MAX-RECORD.
060300     MOVE MMUI-RDM-MAX-LENGTH    TO WS-DATA-LENGTH.
060400*
060500     WRITE MMUI-RDM-RECORD.
060600*
060700     ADD 1                       TO WS-SC-WRITES.
060800     MOVE '- WRITE ERROR - MMUI' TO SS02WS-ABENDMSG8.
060900     GO TO R900-RA-CHECK-STATUS.
061000*
061100 R160-RA-REWRITE.
061200*
061300     MOVE MMUIIO-RECORD          TO MMUI-RDM-MAX-RECORD.
061400     MOVE MMUI-RDM-MAX-LENGTH    TO WS-DATA-LENGTH.
061500*
061600     REWRITE MMUI-RDM-RECORD.
061700*
061800     ADD 1                       TO WS-SC-REWRITES.
061900     MOVE '- REWRT ERROR - MMUI' TO SS02WS-ABENDMSG8.
062000     GO TO R900-RA-CHECK-STATUS.
062100*
062200 R170-RA-DELETE.
062300*
062400     MOVE MMUIIO-KEY             TO MMUI-RDM-KEY.
062500     DELETE MMUI-FILE-RDM RECORD.
062600*
062700     ADD 1                       TO WS-SC-DELETES.
062800     MOVE '- DELET ERROR - MMUI' TO SS02WS-ABENDMSG8.
062900     GO TO R900-RA-CHECK-STATUS.
063000*
063100 R180-RA-CLOSE.
063200*
063300     MOVE SPACE                  TO WS-ACCESS-METHOD.
063400     CLOSE  MMUI-FILE-RDM.
063500*
063600     PERFORM Z100-DISPLAY-THE-SUMMARY
063700        THRU Z199-DTS-EXIT.
063800*
063900     MOVE '- CLOSE ERROR - MMUI' TO SS02WS-ABENDMSG8.
064000     GO TO R900-RA-CHECK-STATUS.
064100*
064200 R900-RA-CHECK-STATUS.
064300*
064400     MOVE WS-STATUS              TO MMUIRB-STATUS.
064500     MOVE WS-RETURN              TO MMUIRB-RETURN.
064600*
064700     IF  MMUIRB-STATUS IS EQUAL  TO MMUIRB-TEMP-STATUS-1   OR
064800         MMUIRB-STATUS IS EQUAL  TO MMUIRB-TEMP-STATUS-2   OR
064900         MMUIRB-STATUS IS EQUAL  TO MMUIRB-PERM-STATUS-1   OR
065000         MMUIRB-STATUS IS EQUAL  TO MMUIRB-PERM-STATUS-2   OR
065100         MMUIRB-STATUS IS EQUAL  TO MMUIRB-PERM-STATUS-3   OR
065200         MMUIRB-STATUS IS EQUAL  TO MMUIRB-PERM-STATUS-4   OR
065300         MMUIRB-STATUS IS EQUAL  TO MMUIRB-PERM-STATUS-5
065400         MOVE ZERO               TO MMUIRB-TEMP-STATUS-1
065500         MOVE ZERO               TO MMUIRB-TEMP-STATUS-2
065600     ELSE
065700         GO TO Z900-ABORT.
065800*
065900 R999-RA-EXIT.
066000     EXIT.
066100/
066200 S000-SEQUENTIAL-ACCESS.
066300*
066400     GO TO S110-SA-OPEN-INPUT
066500           S120-SA-OPEN-OUTPUT
066600           S130-SA-OPEN-I-O
066700           S100-SA-INVALID-REQUEST
066800           S100-SA-INVALID-REQUEST
066900           S100-SA-INVALID-REQUEST
067000           S100-SA-INVALID-REQUEST
067100           S100-SA-INVALID-REQUEST
067200           S100-SA-INVALID-REQUEST
067300           S140-SA-START-GTE
067400           S150-SA-START-EQUAL
067500           S160-SA-READ-SEQ
067600           S100-SA-INVALID-REQUEST
067700           S170-SA-WRITE
067800           S180-SA-REWRITE
067900           S190-SA-DELETE
068000           S200-SA-CLOSE
068100           DEPENDING ON MMUIRB-IO-REQUEST.
068200*
068300 S100-SA-INVALID-REQUEST.
068400*
068500     MOVE MMUIRB-IO-REQUEST      TO SS02WS-ABEND-REQUEST.
068600     MOVE '- BAD I-O REQ - MMUI' TO SS02WS-ABENDMSG8.
068700     GO TO Z950-ABORT.
068800*
068900 S110-SA-OPEN-INPUT.
069000*
069100     OPEN INPUT MMUI-FILE-SEQ.
069200*
069300     IF  WS-STATUS IS EQUAL TO '97'
069400         MOVE '97'               TO MMUIRB-OPEN-STATUS
069500         MOVE LOW-VALUES         TO WS-RETURN
069600         MOVE ZEROS              TO WS-STATUS.
069700*
069800     MOVE 'SEQ'                  TO WS-SM-ACCESS.
069900     MOVE 'INPUT'                TO WS-SM-OPENED.
070000     MOVE '- OPEN  ERROR - MMUI' TO SS02WS-ABENDMSG8.
070100     GO TO S900-SA-CHECK-STATUS.
070200*
070300 S120-SA-OPEN-OUTPUT.
070400*
070500     OPEN OUTPUT MMUI-FILE-SEQ.
070600*
070700     IF  WS-STATUS IS EQUAL TO '97'
070800         MOVE '97'               TO MMUIRB-OPEN-STATUS
070900         MOVE LOW-VALUES         TO WS-RETURN
071000         MOVE ZEROS              TO WS-STATUS.
071100*
071200     MOVE 'SEQ'                  TO WS-SM-ACCESS.
071300     MOVE 'OUTPUT'               TO WS-SM-OPENED.
071400     MOVE '- OPEN  ERROR - MMUI' TO SS02WS-ABENDMSG8.
071500     GO TO S900-SA-CHECK-STATUS.
071600*
071700 S130-SA-OPEN-I-O.
071800*
071900     OPEN I-O MMUI-FILE-SEQ.
072000*
072100     MOVE 'SEQ'                  TO WS-SM-ACCESS.
072200     MOVE 'I-O'                  TO WS-SM-OPENED.
072300     MOVE '- OPEN  ERROR - MMUI' TO SS02WS-ABENDMSG8.
072400     GO TO S900-SA-CHECK-STATUS.
072500*
072600 S140-SA-START-GTE.
072700*
072800     MOVE MMUIIO-KEY             TO MMUI-SEQ-KEY.
072900     START MMUI-FILE-SEQ
073000           KEY IS NOT LESS THAN MMUI-SEQ-KEY.
073100*
073200     MOVE '- START ERROR - MMUI' TO SS02WS-ABENDMSG8.
073300     GO TO S900-SA-CHECK-STATUS.
073400*
073500 S150-SA-START-EQUAL.
073600*
073700     MOVE MMUIIO-KEY             TO MMUI-SEQ-KEY.
073800     START MMUI-FILE-SEQ
073900           KEY IS EQUAL TO MMUI-SEQ-KEY.
074000*
074100     MOVE '- START ERROR - MMUI' TO SS02WS-ABENDMSG8.
074200     GO TO S900-SA-CHECK-STATUS.
074300*
074400 S160-SA-READ-SEQ.
074500*
074600     READ MMUI-FILE-SEQ          INTO MMUIIO-RECORD.
074700*
074800     ADD 1                       TO WS-SC-READS.
074900     MOVE '- READ  ERROR - MMUI' TO SS02WS-ABENDMSG8.
075000     GO TO S900-SA-CHECK-STATUS.
075100*
075200 S170-SA-WRITE.
075300*
075400     MOVE MMUIIO-RECORD          TO MMUI-SEQ-MAX-RECORD.
075500     MOVE MMUI-SEQ-MAX-LENGTH    TO WS-DATA-LENGTH.
075600*
075700     WRITE MMUI-SEQ-RECORD.
075800*
075900     ADD 1                       TO WS-SC-WRITES.
076000     MOVE '- WRITE ERROR - MMUI' TO SS02WS-ABENDMSG8.
076100     GO TO S900-SA-CHECK-STATUS.
076200*
076300 S180-SA-REWRITE.
076400*
076500     MOVE MMUIIO-RECORD          TO MMUI-SEQ-MAX-RECORD.
076600     MOVE MMUI-SEQ-MAX-LENGTH    TO WS-DATA-LENGTH.
076700*
076800     REWRITE MMUI-SEQ-RECORD.
076900*
077000     ADD 1                       TO WS-SC-REWRITES.
077100     MOVE '- REWRT ERROR - MMUI' TO SS02WS-ABENDMSG8.
077200     GO TO S900-SA-CHECK-STATUS.
077300*
077400 S190-SA-DELETE.
077500*
077600     MOVE MMUIIO-KEY             TO MMUI-SEQ-KEY.
077700     DELETE MMUI-FILE-SEQ RECORD.
077800*
077900     ADD 1                       TO WS-SC-DELETES.
078000     MOVE '- DELET ERROR - MMUI' TO SS02WS-ABENDMSG8.
078100     GO TO S900-SA-CHECK-STATUS.
078200*
078300 S200-SA-CLOSE.
078400*
078500     MOVE SPACE                  TO WS-ACCESS-METHOD.
078600     CLOSE MMUI-FILE-SEQ.
078700*
078800     PERFORM Z100-DISPLAY-THE-SUMMARY
078900        THRU Z199-DTS-EXIT.
079000*
079100     MOVE '- CLOSE ERROR - MMUI' TO SS02WS-ABENDMSG8.
079200     GO TO S900-SA-CHECK-STATUS.
079300*
079400 S900-SA-CHECK-STATUS.
079500*
079600     MOVE WS-STATUS              TO MMUIRB-STATUS.
079700     MOVE WS-RETURN              TO MMUIRB-RETURN.
079800*
079900     IF  MMUIRB-STATUS IS EQUAL  TO MMUIRB-TEMP-STATUS-1   OR
080000         MMUIRB-STATUS IS EQUAL  TO MMUIRB-TEMP-STATUS-2   OR
080100         MMUIRB-STATUS IS EQUAL  TO MMUIRB-PERM-STATUS-1   OR
080200         MMUIRB-STATUS IS EQUAL  TO MMUIRB-PERM-STATUS-2   OR
080300         MMUIRB-STATUS IS EQUAL  TO MMUIRB-PERM-STATUS-3   OR
080400         MMUIRB-STATUS IS EQUAL  TO MMUIRB-PERM-STATUS-4   OR
080500         MMUIRB-STATUS IS EQUAL  TO MMUIRB-PERM-STATUS-5
080600         MOVE ZERO               TO MMUIRB-TEMP-STATUS-1
080700         MOVE ZERO               TO MMUIRB-TEMP-STATUS-2
080800     ELSE
080900         GO TO Z900-ABORT.
081000*
081100 S999-SA-EXIT.
081200     EXIT.
081300/
081400 Z000-PROGRAM-INITIALIZATION.
081500*
081600************************************************************
081700*    THE CALLING PROGRAM MUST SUPPLY THE PROGRAM ID TO     *
081800*    ENSURE THAT ANY SUBSEQUENT ABEND CAN BE TRACED TO     *
081900*    IT.  IF THE PROGRAM ID IS NOT SUPPLIED, THE ACCESS    *
082000*    ROUTINE ABENDS HERE.                                  *
082100************************************************************
082200*
082300     IF  SS02WS-ABEND-PROG-ID IS EQUAL TO SPACES
082400         MOVE '- BAD PROG NAME - MMUI'
082500                                 TO SS02WS-ABENDMSG8
082600         MOVE 'BADPRO'           TO SS02WS-ABEND-PROG-ID
082700         GO TO Z950-ABORT.
082800*
082900     MOVE SS02WS-ABEND-PROG-ID   TO WS-SM-PROG-ID.
083000*
083100*************************************************************
083200*    SINCE THIS ROUTINE IS PERFORMED ONLY ONCE DURING       *
083300*    THE EXECUTION OF A CALLING PROGRAM, THE FIRST          *
083400*    REQUEST MUST BE FOR AN OPEN.  SET THE ACCESS METHOD    *
083500*    (SEQENTIAL, DYNAMIC, OR RANDOM), OR ISSUE AN ABEND     *
083600*    IF THE REQUEST IS NOT FOR AN OPEN.                     *
083700*************************************************************
083800*
083900     IF  MMUIRB-OPEN-INPUT    OR
084000         MMUIRB-OPEN-OUTPUT   OR
084100         MMUIRB-OPEN-IO
084200         MOVE 'S'                TO WS-ACCESS-METHOD.
084300*
084400     IF  MMUIRB-OPEN-INPUT-DYN    OR
084500         MMUIRB-OPEN-OUTPUT-DYN   OR
084600         MMUIRB-OPEN-IO-DYN
084700         MOVE 'D'                TO WS-ACCESS-METHOD.
084800*
084900     IF  MMUIRB-OPEN-INPUT-RDM    OR
085000         MMUIRB-OPEN-OUTPUT-RDM   OR
085100         MMUIRB-OPEN-IO-RDM
085200         MOVE 'R'                TO WS-ACCESS-METHOD.
085300*
085400     IF  ACCESS-METHOD-NOT-SET
085500         MOVE 'SMMUI'            TO SS02WS-ABEND-CODE-X
085600         MOVE MMUIRB-IO-REQUEST  TO WS-IO-REQUEST
085700         MOVE WS-IO-REQUEST      TO SS02WS-ABEND-REQUEST
085800         MOVE 'ILLEGAL ACCESS REQUEST'
085900                                 TO SS02WS-ABENDMSG8
086000         GO TO Z950-ABORT.
086100*
086200 Z099-PI-EXIT.
086300     EXIT.
086400*
086500 Z100-DISPLAY-THE-SUMMARY.
086600*
086700     MOVE WS-SC-READS            TO WS-SM-READS.
086800     MOVE WS-SC-WRITES           TO WS-SM-WRITES.
086900     MOVE WS-SC-REWRITES         TO WS-SM-REWRITES.
087000     MOVE WS-SC-DELETES          TO WS-SM-DELETES.
087100     DISPLAY WS-SUMMARY-MESSAGE.
087200*
087300     INITIALIZE WS-SUMMARY-COUNTERS.
087400*
087500 Z199-DTS-EXIT.
087600     EXIT.
087700/
087800 Z900-ABORT.
087900*
088000     MOVE 'SMMUI'                TO SS02WS-ABEND-CODE-X.
088100     MOVE MMUIRB-STATUS          TO SS02WS-ABEND-STATUS.
088200     MOVE MMUIRB-RETURN-CODE     TO SS02WS-ABEND-RETURN.
088300     MOVE MMUIRB-FUNCTION-CODE   TO SS02WS-ABEND-FUNCTION.
088400     MOVE MMUIRB-FEEDBACK-CODE   TO SS02WS-ABEND-FEEDBACK.
088500     MOVE MMUIRB-IO-REQUEST      TO WS-IO-REQUEST.
088600     MOVE WS-IO-REQUEST          TO SS02WS-ABEND-REQUEST.
088700*
088800 Z950-ABORT.
088900*
089000     PERFORM SS02PD-ABEND        THRU SS02PD-ABEND-EXIT.
089100*
089200 Z999-ABORT-EXIT.
089300     EXIT.
089400/
089500********************************
089600*    STANDARD ABEND ROUTINE    *
089700********************************
089800*
089900     COPY SS02PD.
090000*
