000100 IDENTIFICATION DIVISION.
000200 PROGRAM-ID. MBD100BC.
000201*       RELEASE DATE=08/24/01.        REVISION LEVEL=08.06      * ++++++++
000202***************************************************************** ++++++++
000203*WARNING.  THIS COMPUTER PROGRAM IS PROTECTED BY COPYRIGHT LAW  * ++++++++
000204*AND INTERNATIONAL TREATIES.  UNAUTHORIZED REPRODUCTION OR      * ++++++++
000205*DISTRIBUTION OF THIS PROGRAM, OR ANY PORTION OF IT, MAY RESULT * ++++++++
000206*IN SEVERE CIVIL AND CRIMINAL PENATLIES, AND WILL BE PROSECUTED * ++++++++
000207*TO THE MAXIMUM EXTENT POSSIBLE UNDER THE LAW.                  * ++++++++
000208*COPYRIGHT 1999 PAYSYS INTERNATIONAL, INC.  ALL RIGHTS RESERVED.* ++++++++
000209***************************************************************** ++++++++
000300*****************************************************************
000400*                                                               *
000500*   V - PLUS  M E R C H A N T   B A N K C A R D   S Y S T E M   *
000600*                                                               *
000700*     MBD100BC - BAR CODE FILE RECOVERY AND                     *
000800*                NON-MONETARY REPORTS                           *
000900*                                                               *
001000*****************************************************************
001100 ENVIRONMENT DIVISION.
001200 CONFIGURATION SECTION.
001300 SOURCE-COMPUTER.            IBM-4341.
001400 OBJECT-COMPUTER.            IBM-4341.
001500/
001600 INPUT-OUTPUT SECTION.
001700*
001800 FILE-CONTROL.
001900/
002000 DATA DIVISION.
002100 FILE SECTION.
002200/
002300 WORKING-STORAGE SECTION.
002400*
002500 01  FILLER                  PIC  X(12)      VALUE '** WS-BEG **'.
002600*
002700     COPY MMBCRL.
002800/
002900     COPY MMBCIO.
003000/
003100     COPY MB00RB REPLACING ==:MB00:== BY ==MMBC==.
003200/
003300     COPY MMBCIR.
003400/
003500     COPY MML1WS REPLACING ==:MML1:== BY ==MTL1==.
003600/
003700     COPY MTCCRL REPLACING ==:MTCC:== BY ==MTCC==.
003800/
003900     COPY MB00WS.
004000/
004100     COPY SS95WS.
004200/
004300     COPY MB99WS.
004400/
004500     COPY SS00WS.
004600/
004700     COPY SS01WS.
004800/
004900     COPY SS02WS.
005000*
005100 01  FILLER                  PIC  X(12)      VALUE '** WS-END **'.
005200/
005300 LINKAGE SECTION.
005400     COPY MBD100WS.
005500/
005600     COPY MMSCRL.
005700/
005800     COPY MMOCRL.
005900/
006000     COPY MML1RL REPLACING ==:MML1:== BY ==MTL1==.
006100/
006200     COPY MTCCRL REPLACING ==:MTCC:== BY ==MTC1==.
006300/
006400     COPY MTCCRL REPLACING ==:MTCC:== BY ==MTC2==.
006500/
006600 PROCEDURE DIVISION              USING MBD100WS-AREA
006700                                       MMSC-RECORD
006800                                       MMOC-RECORD
006900                                       MTL1-RECORD
007000                                       MTC1-RECORD
007100                                       MTC2-RECORD.
007200*
007300 A000-MAIN-LINE-SECT SECTION.
007400 A010-ML-BEGIN.
007500*
007600     MOVE 'MBD100BC'             TO SS02WS-ABEND-PROG-ID.
007700     MOVE 'MMBC'                 TO MB99WS-FILE-ID.
007800     MOVE MMSC-TODAYS-JULIAN     TO MB99WS-PROC-DATE.
007900     MOVE MMSC-TIME-STAMP        TO MB99WS-PROC-TIME.
008000*
008100     IF  MBD100WS-OPEN-FILE
008200         SET SS95WS-FUNCTION-INITIALIZE
008300                                 TO TRUE
008400         PERFORM SS95PD-NAP-ROUTINE
008500            THRU SS95PD-NAP-EXIT
008600         PERFORM O000-OPEN-FILE
008700            THRU O999-OF-EXIT.
008800*
008900     IF  MBD100WS-CLOSE-FILE
009000         PERFORM C000-CLOSE-FILE
009100            THRU C999-CF-EXIT.
009200*
009300     IF  MBD100WS-PROCESS-RECORD
009400         PERFORM P000-PROCESS-RECORD
009500            THRU P099-PR-EXIT.
009600*
009700     GOBACK.
009800*
009900 A999-ML-EXIT.
010000     EXIT.
010100/
010200 C000-CLOSE-FILE SECTION.
010300 C010-CF-BEGIN.
010400*
010500     MOVE 'C1BC'                 TO SS02WS-ABEND-LOCATION.
010600     SET MMBCRB-CLOSE            TO TRUE.
010700     PERFORM MB00PD-MMBC-ACCESS
010800        THRU MB00PD-MMBC-ACCESS-EXIT.
010900*
011000 C999-CF-EXIT.
011100     EXIT.
011200/
011300 O000-OPEN-FILE SECTION.
011400 O010-OF-BEGIN.
011500*
011600     MOVE MMSC-DATE-FORMAT       TO SS01WS-DATE-FORMAT.
011700*
011800     MOVE 'O1BC'                 TO SS02WS-ABEND-LOCATION.
011900*
012000     IF  MBD100WS-UPDATE
012100         SET MMBCRB-OPEN-IO-DYN  TO TRUE
012200     ELSE
012300         SET MMBCRB-OPEN-INPUT-DYN
012400                                 TO TRUE.
012500*
012600     PERFORM MB00PD-MMBC-ACCESS
012700        THRU MB00PD-MMBC-ACCESS-EXIT.
012800*
012900     MOVE 'R0BC'                 TO SS02WS-ABEND-LOCATION.
013000     SET MMBCRB-READ-SEQ         TO TRUE.
013100     PERFORM MB00PD-MMBC-ACCESS
013200        THRU MB00PD-MMBC-ACCESS-EXIT.
013300     MOVE 'MMBC'                 TO MB99WS-FILE-ID.
013400*
013500     IF  MMBCIO-HEADER
013600         NEXT SENTENCE
013700     ELSE
013800         PERFORM MB99PD-MISSING-HEADER-ABEND
013900            THRU MB99PD-MHA-EXIT.
014000*
014100     MOVE MMBCIO-DATE-STAMP      TO MB99WS-FILE-DATE.
014200     MOVE MMBCIO-TIME-STAMP      TO MB99WS-FILE-TIME.
014300     PERFORM MB99PD-CHECK-DATE-TIME
014400        THRU MB99PD-CDT-EXIT.
014500*
014600     PERFORM Z900-INIT-RECORD
014700        THRU Z999-IR-EXIT.
014800*
014900 O999-OF-EXIT.
015000     EXIT.
015100/
015200 P000-PROCESS-RECORD SECTION.
015300 P010-PR-BEGIN.
015400*
015500     MOVE MMOC-CURRENCY-CODE     TO SS95WS-CURRENCY-CODE.
015600*
015700     IF  MTL1-MMBC-KEY IS NOT EQUAL TO MMBC-KEY
015800         PERFORM P500-FILE-UPDATE
015900            THRU P599-FU-EXIT.
016000*
016100     IF  MTL1-TOTALS-RECORD
016200         GO TO P099-PR-EXIT.
016300*
016400     IF  MTL1-MMBC-KEY IS NOT EQUAL TO MMBC-KEY
016500         PERFORM P700-GET-RECORD-TO-UPDATE
016600            THRU P799-GRTU-EXIT.
016700*
016800     MOVE MTL1-FIELD-CODE        TO MBD100WS-FIELD-CODE.
016900*
017000     IF (MBD100WS-FC-1-2-ADD AND MBD100WS-FC-3-4-ADD)
017100     OR (MBD100WS-FC-1-2-REP AND MBD100WS-FC-3-4-REP)
017200         PERFORM U000-NEW-RECORD
017300            THRU U099-NR-EXIT
017400     ELSE
017500         PERFORM 0000-MAINT-RECORD
017600            THRU 5999-MR-EXIT.
017700*
017800 P099-PR-EXIT.
017900     EXIT.
018000/
018100 P500-FILE-UPDATE SECTION.
018200 P510-FU-BEGIN.
018300*
018400     IF  MBD100WS-JOURNAL
018500         GO TO P599-FU-EXIT.
018600*
018700     IF  MMBC-KEY IS EQUAL TO MMBCIR-KEY
018800         GO TO P599-FU-EXIT.
018900*
019000     IF  MBD100WS-IO-REWRITE
019100         MOVE MMBC-RECORD        TO MMBCIO-RECORD
019200         MOVE SS02WS-NO-RECORD-FOUND
019300                                 TO MMBCRB-TEMP-STATUS-1
019400         MOVE 'U1BC'             TO SS02WS-ABEND-LOCATION
019500         SET MMBCRB-REWRITE      TO TRUE
019600         PERFORM MB00PD-MMBC-ACCESS
019700            THRU MB00PD-MMBC-ACCESS-EXIT
019800         IF  SS02WS-FS-NO-RECORD-FOUND
019900             MOVE 'W'            TO MBD100WS-IO-SW.
020000*
020100     IF  MBD100WS-IO-NO-REC-FOUND
020200     OR  MBD100WS-IO-WRITE
020300         MOVE MMBC-RECORD        TO MMBCIO-RECORD
020400         MOVE SS02WS-DUPLICATE-RECORD
020500                                 TO MMBCRB-TEMP-STATUS-1
020600         MOVE 'W2BC'             TO SS02WS-ABEND-LOCATION
020700         SET MMBCRB-WRITE        TO TRUE
020800         PERFORM MB00PD-MMBC-ACCESS
020900            THRU MB00PD-MMBC-ACCESS-EXIT
021000         IF  SS02WS-FS-DUPLICATE-RECORD
021100             MOVE 'U'            TO MBD100WS-IO-SW
021200             MOVE MMBC-RECORD    TO MMBCIO-RECORD
021300             MOVE 'U2BC'         TO SS02WS-ABEND-LOCATION
021400             SET MMBCRB-REWRITE  TO TRUE
021500             PERFORM MB00PD-MMBC-ACCESS
021600                THRU MB00PD-MMBC-ACCESS-EXIT.
021700*
021800     PERFORM Z900-INIT-RECORD
021900        THRU Z999-IR-EXIT.
022000*
022100 P599-FU-EXIT.
022200     EXIT.
022300/
022400 P700-GET-RECORD-TO-UPDATE SECTION.
022500 P710-GRTU-BEGIN.
022600*
022700     IF  MBD100WS-JOURNAL
022800         PERFORM Z900-INIT-RECORD
022900            THRU Z999-IR-EXIT
023000         GO TO P799-GRTU-EXIT.
023100*
023200     MOVE SS02WS-NO-RECORD-FOUND
023300                                 TO MMBCRB-TEMP-STATUS-1.
023400     MOVE MTL1-MMBC-KEY          TO MMBCIO-KEY.
023500*
023600     MOVE 'R1BC'                 TO SS02WS-ABEND-LOCATION.
023700     SET MMBCRB-READ-RANDOM      TO TRUE.
023800     PERFORM MB00PD-MMBC-ACCESS
023900        THRU MB00PD-MMBC-ACCESS-EXIT.
024000*
024100     IF  SS02WS-FS-NO-RECORD-FOUND
024200         PERFORM Z900-INIT-RECORD
024300            THRU Z999-IR-EXIT
024400         MOVE 'N'                TO MBD100WS-IO-SW
024500     ELSE
024600         MOVE MMBCIO-RECORD      TO MMBC-RECORD
024700         MOVE 'U'                TO MBD100WS-IO-SW.
024800*
024900 P799-GRTU-EXIT.
025000     EXIT.
025100/
025200 U000-NEW-RECORD SECTION.
025300 U010-NR-BEGIN.
025400*
025500     PERFORM Z100-COMMON-FROM-DATA
025600        THRU Z199-CFD-EXIT.
025700*
025800     PERFORM Z200-COMMON-TO-DATA
025900        THRU Z299-CTD-EXIT.
026000*
026100     MOVE MTL1-ADD-AREA          TO MMBC-RECORD.
026200*
026300     IF  MBD100WS-IO-NO-REC-FOUND
026400         MOVE 'W'                TO MBD100WS-IO-SW.
026500*
026600     IF  MBD100WS-FC-1-2-ADD
026700         MOVE '*** NEW RECORD ADDED ***'
026800                                 TO MBD100WS-PL2-TO-VALUE
026900                                    MBD100WS-PL1-FROM-VALUE
027000     ELSE
027100         MOVE '*** REPLACEMENT RECORD ***'
027200                                 TO MBD100WS-PL2-TO-VALUE
027300                                    MBD100WS-PL1-FROM-VALUE.
027400*
027500     MOVE SPACES                 TO MTCC-RECORD.
027600     MOVE MMBC-ORG               TO MTCC-MBU905-BEG-ORG.
027700     MOVE MMBC-INSERT-NBR        TO MTCC-MBU905-BEG-INSERT-NBR.
027800     MOVE 'MBU905'               TO MTCC-PROGRAM-ID.
027900     MOVE MTCC-RECORD            TO MTC2-RECORD.
028000*
028100 U099-NR-EXIT.
028200     EXIT.
028300/
028400 Z100-COMMON-FROM-DATA SECTION.
028500 Z110-CFD-BEGIN.
028600*
028700     MOVE MTL1-MMBC-INSERT-NBR   TO MBD100WS-PL1-PROD.
028800*
028900 Z199-CFD-EXIT.
029000     EXIT.
029100/
029200 Z200-COMMON-TO-DATA SECTION.
029300 Z210-CTD-BEGIN.
029400*
029500 Z299-CTD-EXIT.
029600     EXIT.
029700/
029800 Z900-INIT-RECORD SECTION.
029900 Z910-IR-BEGIN.
030000*
030100     MOVE MMBCIR-RECORD          TO MMBC-RECORD.
030200     MOVE SPACES                 TO MTC1-RECORD.
030300     MOVE SPACES                 TO MTC2-RECORD.
030400*
030500 Z999-IR-EXIT.
030600     EXIT.
030700/
030800 0000-MAINT-RECORD SECTION.
030900 0010-MR-BEGIN.
031000*
031100     PERFORM Z100-COMMON-FROM-DATA
031200        THRU Z199-CFD-EXIT.
031300*
031400     PERFORM Z200-COMMON-TO-DATA
031500        THRU Z299-CTD-EXIT.
031600*
031700     IF  MTL1-FIELD-CODE IS EQUAL TO 0101
031800         GO TO 0101-MR-FIELD.
031900*
032000     IF  MTL1-FIELD-CODE IS EQUAL TO 0102
032100         GO TO 0102-MR-FIELD.
032200*
032300     IF  MTL1-FIELD-CODE IS EQUAL TO 0103
032400         GO TO 0103-MR-FIELD.
032500*
032600     IF  MTL1-FIELD-CODE IS EQUAL TO 0104
032700         GO TO 0104-MR-FIELD.
032800*
032900     IF  MTL1-FIELD-CODE IS EQUAL TO 0105
033000         GO TO 0105-MR-FIELD.
033100*
033200     IF  MTL1-FIELD-CODE IS EQUAL TO 0106
033300         GO TO 0106-MR-FIELD.
033400*
033500     IF  MTL1-FIELD-CODE IS EQUAL TO 0107
033600         GO TO 0107-MR-FIELD.
033700*
033800     IF  MTL1-FIELD-CODE IS EQUAL TO 0108
033900         GO TO 0108-MR-FIELD.
034000*
034100     IF  MTL1-FIELD-CODE IS EQUAL TO 0109
034200         GO TO 0109-MR-FIELD.
034300*
034400     IF  MTL1-FIELD-CODE IS EQUAL TO 0110
034500         GO TO 0110-MR-FIELD.
034600*
034700     IF  MTL1-FIELD-CODE IS EQUAL TO 0111
034800         GO TO 0111-MR-FIELD.
034900*
035000     IF  MTL1-FIELD-CODE IS EQUAL TO 0112
035100         GO TO 0112-MR-FIELD.
035200*
035300     IF  MTL1-FIELD-CODE IS EQUAL TO 0113
035400         GO TO 0113-MR-FIELD.
035500*
035600     IF  MTL1-FIELD-CODE IS EQUAL TO 0114
035700         GO TO 0114-MR-FIELD.
035800*
035900     IF  MTL1-FIELD-CODE IS EQUAL TO 0115
036000         GO TO 0115-MR-FIELD.
036100*
036200     IF  MTL1-FIELD-CODE IS EQUAL TO 0116
036300         GO TO 0116-MR-FIELD.
036400*
036500     IF  MTL1-FIELD-CODE IS EQUAL TO 0117
036600         GO TO 0117-MR-FIELD.
036700*
036800     IF  MTL1-FIELD-CODE IS EQUAL TO 0118
036900         GO TO 0118-MR-FIELD.
037000*
037100     IF  MTL1-FIELD-CODE IS EQUAL TO 0197
037200         GO TO 0197-MR-FIELD.
037300*
037400     IF  MTL1-FIELD-CODE IS EQUAL TO 0204
037500         GO TO 0204-MR-FIELD.
037600*
037700     IF  MTL1-FIELD-CODE IS EQUAL TO 0205
037800         GO TO 0205-MR-FIELD.
037900*
038000     IF  MTL1-FIELD-CODE IS EQUAL TO 0206
038100         GO TO 0206-MR-FIELD.
038200*
038300     IF  MTL1-FIELD-CODE IS EQUAL TO 0198
038400         GO TO 0198-MR-FIELD.
038500*
038600     IF  MTL1-FIELD-CODE IS EQUAL TO 0199
038700         GO TO 0199-MR-FIELD.
038800*
038900     MOVE '*** ERROR - INVALID FIELD CODE ***'
039000                                 TO MBD100WS-PL2-TO-VALUE.
039100     GO TO 5999-MR-EXIT.
039200*
039300 0101-MR-FIELD.
039400*
039500     IF  MBD100WS-JOURNAL
039600         MOVE MTL1-VL01-B-DATA-9 TO MMBC-REC-STATUS.
039700*
039800     MOVE 'RECORD STATUS         '
039900                                 TO MBD100WS-PL1-DESC.
040000     MOVE MMBC-REC-STATUS        TO MBD100WS-PL1-FROM-VALUE.
040100     MOVE MTL1-VL01-A-DATA-9     TO MMBC-REC-STATUS.
040200     MOVE MMBC-REC-STATUS        TO MBD100WS-PL2-TO-VALUE.
040300     GO TO 5100-MR-NO-REC-CHECK.
040400*
040500*
040600*
040700 0102-MR-FIELD.
040800*
040900     IF  MBD100WS-JOURNAL
041000         MOVE MTL1-VL01-B-DATA-X TO MMBC-DATE-OPENED-USE.
041100*
041200     MOVE 'DATE OPENED USAGE     '
041300                                 TO MBD100WS-PL1-DESC.
041400     MOVE MMBC-DATE-OPENED-USE   TO MBD100WS-PL1-FROM-VALUE.
041500     MOVE MTL1-VL01-A-DATA-X     TO MMBC-DATE-OPENED-USE.
041600     MOVE MMBC-DATE-OPENED-USE   TO MBD100WS-PL2-TO-VALUE.
041700     GO TO 5100-MR-NO-REC-CHECK.
041800*
041900*
042000*
042100 0103-MR-FIELD.
042200*
042300     IF  MBD100WS-JOURNAL
042400         MOVE MTL1-VL01-B-DATA-X TO MMBC-DATE-OPENED-IND.
042500*
042600     MOVE 'DATE OPENED INDICATOR '
042700                                 TO MBD100WS-PL1-DESC.
042800     MOVE MMBC-DATE-OPENED-IND   TO MBD100WS-PL1-FROM-VALUE.
042900     MOVE MTL1-VL01-A-DATA-X     TO MMBC-DATE-OPENED-IND.
043000     MOVE MMBC-DATE-OPENED-IND   TO MBD100WS-PL2-TO-VALUE.
043100     GO TO 5100-MR-NO-REC-CHECK.
043200*
043300*
043400*
043500 0104-MR-FIELD.
043600*
043700     IF  MBD100WS-JOURNAL
043800         MOVE MTL1-VL07-B-DATA-9 TO MMBC-DATE-OPENED-BEG.
043900*
044000     MOVE 'DATE OPENED-BEGINNING '
044100                                 TO MBD100WS-PL1-DESC.
044200     MOVE MMBC-DATE-OPENED-BEG   TO SS01WS-JULIAN.
044300     PERFORM 8100-FROM-DATE      THRU 8199-FD-EXIT.
044400     MOVE MTL1-VL07-A-DATA-9     TO MMBC-DATE-OPENED-BEG.
044500     MOVE MMBC-DATE-OPENED-BEG   TO SS01WS-JULIAN.
044600     PERFORM 8200-TO-DATE        THRU 8299-TD-EXIT.
044700     GO TO 5100-MR-NO-REC-CHECK.
044800*
044900*
045000*
045100 0105-MR-FIELD.
045200*
045300     IF  MBD100WS-JOURNAL
045400         MOVE MTL1-VL07-B-DATA-9 TO MMBC-DATE-OPENED-END.
045500*
045600     MOVE 'DATE OPENED-ENDING    '
045700                                 TO MBD100WS-PL1-DESC.
045800     MOVE MMBC-DATE-OPENED-END   TO SS01WS-JULIAN.
045900     PERFORM 8100-FROM-DATE      THRU 8199-FD-EXIT.
046000     MOVE MTL1-VL07-A-DATA-9     TO MMBC-DATE-OPENED-END.
046100     MOVE MMBC-DATE-OPENED-END   TO SS01WS-JULIAN.
046200     PERFORM 8200-TO-DATE        THRU 8299-TD-EXIT.
046300     GO TO 5100-MR-NO-REC-CHECK.
046400*
046500*
046600*
046700 0106-MR-FIELD.
046800*
046900     IF  MBD100WS-JOURNAL
047000         MOVE MTL1-VL01-B-DATA-X TO MMBC-DATE-LAST-ACTIVE-USE.
047100*
047200     MOVE 'DATE LAST ACTIVE USAGE'
047300                                 TO MBD100WS-PL1-DESC.
047400     MOVE MMBC-DATE-LAST-ACTIVE-USE
047500                                 TO MBD100WS-PL1-FROM-VALUE.
047600     MOVE MTL1-VL01-A-DATA-X     TO MMBC-DATE-LAST-ACTIVE-USE.
047700     MOVE MMBC-DATE-LAST-ACTIVE-USE
047800                                 TO MBD100WS-PL2-TO-VALUE.
047900     GO TO 5100-MR-NO-REC-CHECK.
048000*
048100*
048200*
048300 0107-MR-FIELD.
048400*
048500     IF  MBD100WS-JOURNAL
048600         MOVE MTL1-VL01-B-DATA-X TO MMBC-DATE-LAST-ACTIVE-IND.
048700*
048800     MOVE 'DATE LAST ACTIVE IND  '
048900                                 TO MBD100WS-PL1-DESC.
049000     MOVE MMBC-DATE-LAST-ACTIVE-IND
049100                                 TO MBD100WS-PL1-FROM-VALUE.
049200     MOVE MTL1-VL01-A-DATA-X     TO MMBC-DATE-LAST-ACTIVE-IND.
049300     MOVE MMBC-DATE-LAST-ACTIVE-IND
049400                                 TO MBD100WS-PL2-TO-VALUE.
049500     GO TO 5100-MR-NO-REC-CHECK.
049600*
049700*
049800*
049900 0108-MR-FIELD.
050000*
050100     IF  MBD100WS-JOURNAL
050200         MOVE MTL1-VL07-B-DATA-9 TO MMBC-DATE-LAST-ACTIVE-BEG.
050300*
050400     MOVE 'DATE LAST ACTIVE-BEGIN'
050500                                 TO MBD100WS-PL1-DESC.
050600     MOVE MMBC-DATE-LAST-ACTIVE-BEG
050700                                 TO SS01WS-JULIAN.
050800     PERFORM 8100-FROM-DATE      THRU 8199-FD-EXIT.
050900     MOVE MTL1-VL07-A-DATA-9     TO MMBC-DATE-LAST-ACTIVE-BEG.
051000     MOVE MMBC-DATE-LAST-ACTIVE-BEG
051100                                 TO SS01WS-JULIAN.
051200     PERFORM 8200-TO-DATE        THRU 8299-TD-EXIT.
051300     GO TO 5100-MR-NO-REC-CHECK.
051400*
051500*
051600*
051700 0109-MR-FIELD.
051800*
051900     IF  MBD100WS-JOURNAL
052000         MOVE MTL1-VL07-B-DATA-9 TO MMBC-DATE-LAST-ACTIVE-END.
052100*
052200     MOVE 'DATE LAST ACTIVE-END  '
052300                                 TO MBD100WS-PL1-DESC.
052400     MOVE MMBC-DATE-LAST-ACTIVE-END
052500                                 TO SS01WS-JULIAN.
052600     PERFORM 8100-FROM-DATE      THRU 8199-FD-EXIT.
052700     MOVE MTL1-VL07-A-DATA-9     TO MMBC-DATE-LAST-ACTIVE-END.
052800     MOVE MMBC-DATE-LAST-ACTIVE-END
052900                                 TO SS01WS-JULIAN.
053000     PERFORM 8200-TO-DATE        THRU 8299-TD-EXIT.
053100     GO TO 5100-MR-NO-REC-CHECK.
053200*
053300*
053400*
053500 0110-MR-FIELD.
053600*
053700     IF  MBD100WS-JOURNAL
053800         MOVE MTL1-VL01-B-DATA-X TO MMBC-BLOCK-CODE-USE.
053900*
054000     MOVE 'BLOCK CODE USAGE      '
054100                                 TO MBD100WS-PL1-DESC.
054200     MOVE MMBC-BLOCK-CODE-USE    TO MBD100WS-PL1-FROM-VALUE.
054300     MOVE MTL1-VL01-A-DATA-X     TO MMBC-BLOCK-CODE-USE.
054400     MOVE MMBC-BLOCK-CODE-USE    TO MBD100WS-PL2-TO-VALUE.
054500     GO TO 5100-MR-NO-REC-CHECK.
054600*
054700*
054800*
054900 0111-MR-FIELD.
055000*
055100     IF  MBD100WS-JOURNAL
055200         MOVE MTL1-VL01-B-DATA-X TO MMBC-BLOCK-CODE-IND.
055300*
055400     MOVE 'BLOCK CODE INDICATOR  '
055500                                 TO MBD100WS-PL1-DESC.
055600     MOVE MMBC-BLOCK-CODE-IND    TO MBD100WS-PL1-FROM-VALUE.
055700     MOVE MTL1-VL01-A-DATA-X     TO MMBC-BLOCK-CODE-IND.
055800     MOVE MMBC-BLOCK-CODE-IND    TO MBD100WS-PL2-TO-VALUE.
055900     GO TO 5100-MR-NO-REC-CHECK.
056000*
056100*
056200*
056300 0112-MR-FIELD.
056400*
056500     SET X-MMBC-BLOCK-CODE       TO MTL1-FIELD-OCCURRENCE.
056600*
056700     IF  MBD100WS-JOURNAL
056800         MOVE MTL1-VL01-B-DATA-X TO MMBC-BLOCK-CODE
056900                                    (X-MMBC-BLOCK-CODE).
057000*
057100     MOVE 'BLOCK CODE            '
057200                                 TO MBD100WS-PL1-DESC.
057300     MOVE MMBC-BLOCK-CODE
057400          (X-MMBC-BLOCK-CODE)    TO MBD100WS-PL1-FROM-VALUE.
057500     MOVE MTL1-VL01-A-DATA-X     TO MMBC-BLOCK-CODE
057600                                    (X-MMBC-BLOCK-CODE).
057700     MOVE MMBC-BLOCK-CODE
057800          (X-MMBC-BLOCK-CODE)    TO MBD100WS-PL2-TO-VALUE.
057900     GO TO 5100-MR-NO-REC-CHECK.
058000*
058100*
058200*
058300 0113-MR-FIELD.
058400*
058500     IF  MBD100WS-JOURNAL
058600         MOVE MTL1-VL01-B-DATA-X TO MMBC-STMT-CYCLE-USE.
058700*
058800     MOVE 'STMT CYCLE USAGE FLAG '
058900                                 TO MBD100WS-PL1-DESC.
059000     MOVE MMBC-STMT-CYCLE-USE    TO MBD100WS-PL1-FROM-VALUE.
059100     MOVE MTL1-VL01-A-DATA-X     TO MMBC-STMT-CYCLE-USE.
059200     MOVE MMBC-STMT-CYCLE-USE    TO MBD100WS-PL2-TO-VALUE.
059300     GO TO 5100-MR-NO-REC-CHECK.
059400*
059500*
059600*
059700 0114-MR-FIELD.
059800*
059900     IF  MBD100WS-JOURNAL
060000         MOVE MTL1-VL01-B-DATA-X TO MMBC-STMT-CYCLE-IND.
060100*
060200     MOVE 'STMT CYCLE INDICATOR  '
060300                                 TO MBD100WS-PL1-DESC.
060400     MOVE MMBC-STMT-CYCLE-IND    TO MBD100WS-PL1-FROM-VALUE.
060500     MOVE MTL1-VL01-A-DATA-X     TO MMBC-STMT-CYCLE-IND.
060600     MOVE MMBC-STMT-CYCLE-IND    TO MBD100WS-PL2-TO-VALUE.
060700     GO TO 5100-MR-NO-REC-CHECK.
060800*
060900*
061000*
061100 0115-MR-FIELD.
061200*
061300     SET X-MMBC-STMT-CYCLE       TO MTL1-FIELD-OCCURRENCE.
061400*
061500     IF  MBD100WS-JOURNAL
061600         MOVE MTL1-VL02-B-DATA-9 TO MMBC-STMT-CYCLE
061700                                    (X-MMBC-STMT-CYCLE).
061800*
061900     MOVE 'STMT CYCLE            '
062000                                 TO MBD100WS-PL1-DESC.
062100     MOVE MMBC-STMT-CYCLE
062200          (X-MMBC-STMT-CYCLE)    TO MBD100WS-PL1-FV-99.
062300     MOVE MTL1-VL02-A-DATA-9     TO MMBC-STMT-CYCLE
062400                                    (X-MMBC-STMT-CYCLE).
062500     MOVE MMBC-STMT-CYCLE
062600          (X-MMBC-STMT-CYCLE)    TO MBD100WS-PL2-TV-99.
062700     GO TO 5100-MR-NO-REC-CHECK.
062800*
062900*
063000*
063100 0116-MR-FIELD.
063200*
063300     IF  MBD100WS-JOURNAL
063400         MOVE MTL1-VL01-B-DATA-X TO MMBC-STMT-MSG-FLAG-USE.
063500*
063600     MOVE 'STMT MESSAGE USAGE    '
063700                                 TO MBD100WS-PL1-DESC.
063800     MOVE MMBC-STMT-MSG-FLAG-USE TO MBD100WS-PL1-FROM-VALUE.
063900     MOVE MTL1-VL01-A-DATA-X     TO MMBC-STMT-MSG-FLAG-USE.
064000     MOVE MMBC-STMT-MSG-FLAG-USE TO MBD100WS-PL2-TO-VALUE.
064100     GO TO 5100-MR-NO-REC-CHECK.
064200*
064300*
064400*
064500 0117-MR-FIELD.
064600*
064700     IF  MBD100WS-JOURNAL
064800         MOVE MTL1-VL01-B-DATA-X TO MMBC-STMT-MSG-FLAG-IND.
064900*
065000     MOVE 'STMT MESSAGE INDICATOR'
065100                                 TO MBD100WS-PL1-DESC.
065200     MOVE MMBC-STMT-MSG-FLAG-IND TO MBD100WS-PL1-FROM-VALUE.
065300     MOVE MTL1-VL01-A-DATA-X     TO MMBC-STMT-MSG-FLAG-IND.
065400     MOVE MMBC-STMT-MSG-FLAG-IND TO MBD100WS-PL2-TO-VALUE.
065500     GO TO 5100-MR-NO-REC-CHECK.
065600*
065700*
065800*
065900 0118-MR-FIELD.
066000*
066100     SET X-MMBC-STMT-MSG-FLAG    TO MTL1-FIELD-OCCURRENCE.
066200*
066300     IF  MBD100WS-JOURNAL
066400         MOVE MTL1-VL01-B-DATA-X TO MMBC-STMT-MSG-FLAG
066500                                    (X-MMBC-STMT-MSG-FLAG).
066600*
066700     MOVE 'STMT MESSAGE FLAG     '
066800                                 TO MBD100WS-PL1-DESC.
066900     MOVE MMBC-STMT-MSG-FLAG
067000          (X-MMBC-STMT-MSG-FLAG) TO MBD100WS-PL1-FROM-VALUE.
067100     MOVE MTL1-VL01-A-DATA-X     TO MMBC-STMT-MSG-FLAG
067200                                    (X-MMBC-STMT-MSG-FLAG).
067300     MOVE MMBC-STMT-MSG-FLAG
067400          (X-MMBC-STMT-MSG-FLAG) TO MBD100WS-PL2-TO-VALUE.
067500     GO TO 5100-MR-NO-REC-CHECK.
067600*
067700*
067800*
067900 0197-MR-FIELD.
068000*
068100     IF  MBD100WS-JOURNAL
068200         MOVE MTL1-VL01-B-DATA-9 TO MMBC-REC-STATUS.
068300*
068400     MOVE 'RECORD STATUS         '
068500                                 TO MBD100WS-PL1-DESC.
068600     MOVE MMBC-REC-STATUS        TO MBD100WS-PL1-FV-9.
068700     MOVE MTL1-VL01-A-DATA-9     TO MMBC-REC-STATUS.
068800     MOVE MMBC-REC-STATUS        TO MBD100WS-PL2-TV-9.
068900     GO TO 5100-MR-NO-REC-CHECK.
069000*
069100*
069200*
069300 0198-MR-FIELD.
069400*
069500     IF  MBD100WS-JOURNAL
069600         MOVE MTL1-VL03-B-DATA-X TO MMBC-LAST-MAINT-OPER.
069700*
069800     MOVE 'LAST MAINT OPERATOR   '
069900                                 TO MBD100WS-PL1-DESC.
070000     MOVE MMBC-LAST-MAINT-OPER   TO MBD100WS-PL1-FROM-VALUE.
070100     MOVE MTL1-VL03-A-DATA-X     TO MMBC-LAST-MAINT-OPER.
070200     MOVE MMBC-LAST-MAINT-OPER   TO MBD100WS-PL2-TO-VALUE.
070300     GO TO 5100-MR-NO-REC-CHECK.
070400*
070500*
070600*
070700 0199-MR-FIELD.
070800*
070900     IF  MBD100WS-JOURNAL
071000         MOVE MTL1-VL07-B-DATA-9 TO MMBC-LAST-MAINT-DATE.
071100*
071200     MOVE 'DATE LAST MAINTENANCE '
071300                                 TO MBD100WS-PL1-DESC.
071400     MOVE MMBC-LAST-MAINT-DATE   TO SS01WS-JULIAN.
071500     PERFORM 8100-FROM-DATE      THRU 8199-FD-EXIT.
071600     MOVE MTL1-VL07-A-DATA-9     TO MMBC-LAST-MAINT-DATE.
071700     MOVE MMBC-LAST-MAINT-DATE   TO SS01WS-JULIAN.
071800     PERFORM 8200-TO-DATE        THRU 8299-TD-EXIT.
071900     GO TO 5100-MR-NO-REC-CHECK.
072000*
072100*
072200*
072300 0204-MR-FIELD.
072400*
072500     IF  MBD100WS-JOURNAL
072600         MOVE MTL1-VL01-B-DATA-X TO MMBC-POSTAL-CODE-USE.
072700*
072800     MOVE 'POSTAL CODE USAGE     '
072900                                 TO MBD100WS-PL1-DESC.
073000     MOVE MMBC-POSTAL-CODE-USE   TO MBD100WS-PL1-FROM-VALUE.
073100     MOVE MTL1-VL01-A-DATA-X     TO MMBC-POSTAL-CODE-USE.
073200     MOVE MMBC-POSTAL-CODE-USE   TO MBD100WS-PL2-TO-VALUE.
073300     GO TO 5100-MR-NO-REC-CHECK.
073400*
073500*
073600*
073700 0205-MR-FIELD.
073800*
073900     IF  MBD100WS-JOURNAL
074000         MOVE MTL1-VL01-B-DATA-X TO MMBC-POSTAL-CODE-IND.
074100*
074200     MOVE 'POSTAL CODE INDICATOR '
074300                                 TO MBD100WS-PL1-DESC.
074400     MOVE MMBC-POSTAL-CODE-IND   TO MBD100WS-PL1-FROM-VALUE.
074500     MOVE MTL1-VL01-A-DATA-X     TO MMBC-POSTAL-CODE-IND.
074600     MOVE MMBC-POSTAL-CODE-IND   TO MBD100WS-PL2-TO-VALUE.
074700     GO TO 5100-MR-NO-REC-CHECK.
074800*
074900*
075000*
075100 0206-MR-FIELD.
075200*
075300     SET X-MMBC-POSTAL-CODE      TO MTL1-FIELD-OCCURRENCE.
075400*
075500     IF  MBD100WS-JOURNAL
075600         MOVE MTL1-VL10-B-DATA-X TO MMBC-POSTAL-CODE
075700                                    (X-MMBC-POSTAL-CODE).
075800*
075900     MOVE 'POSTAL CODE           '
076000                                 TO MBD100WS-PL1-DESC.
076100     MOVE MMBC-POSTAL-CODE
076200          (X-MMBC-POSTAL-CODE)   TO MBD100WS-PL1-FROM-VALUE.
076300     MOVE MTL1-VL10-A-DATA-X     TO MMBC-POSTAL-CODE
076400                                    (X-MMBC-POSTAL-CODE).
076500     MOVE MMBC-POSTAL-CODE
076600          (X-MMBC-POSTAL-CODE)   TO MBD100WS-PL2-TO-VALUE.
076700     GO TO 5100-MR-NO-REC-CHECK.
076800*
076900*
077000*
077100 5100-MR-NO-REC-CHECK.
077200*
077300     IF  MBD100WS-UPDATE
077400     AND MBD100WS-IO-NO-REC-FOUND
077500         MOVE '*** ERROR - NO RECORD FOUND ***'
077600                                 TO MBD100WS-PL2-TO-VALUE.
077700*
077800 5999-MR-EXIT.
077900     EXIT.
078000/
078100 8100-FROM-DATE SECTION.
078200 8110-FD-BEGIN.
078300*
078400     MOVE SS01WS-JULIAN          TO MBD100WS-PL1-FV-JULIAN.
078500     PERFORM SS26PD-NUMERICALLY-EDIT-DATE
078600        THRU SS26PD-NED-EXIT.
078700     MOVE SS01WS-XX-XX-YYYY      TO MBD100WS-PL1-FV-DATE.
078800     INSPECT MBD100WS-PL1-FV-JULIAN REPLACING ALL ',' BY '-'.
078900*
079000 8199-FD-EXIT.
079100     EXIT.
079200*
079300*
079400*
079500 8200-TO-DATE SECTION.
079600 8210-TD-BEGIN.
079700*
079800     MOVE SS01WS-JULIAN          TO MBD100WS-PL2-TV-JULIAN.
079900     PERFORM SS26PD-NUMERICALLY-EDIT-DATE
080000        THRU SS26PD-NED-EXIT.
080100     MOVE SS01WS-XX-XX-YYYY      TO MBD100WS-PL2-TV-DATE.
080200     INSPECT MBD100WS-PL2-TV-JULIAN REPLACING ALL ',' BY '-'.
080300*
080400 8299-TD-EXIT.
080500     EXIT.
080600/
080700 9000-PERFORMED-ROUTINES-SECT SECTION.
080800*
080900     COPY MB00PD REPLACING ==:MB00:== BY ==MMBC==.
081000/
081100     COPY SS95PD.
081200/
081300     COPY MB99PD.
081400/
081500     COPY SS02PD.
081600/
081700     COPY SS07PD.
081800/
081900     COPY SS08PD.
082000/
082100     COPY SS26PD.
082200/
082300     COPY SS27PD.
082400*
082500 9995-END-SOURCE-STATEMENTS SECTION.
082600 9999-END-OF-PROGRAM.
082700     EXIT.
