000100 IDENTIFICATION DIVISION.
000200 PROGRAM-ID. MBD100EX.
000201*       RELEASE DATE=08/24/01.        REVISION LEVEL=08.06      * ++++++++
000202***************************************************************** ++++++++
000203*WARNING.  THIS COMPUTER PROGRAM IS PROTECTED BY COPYRIGHT LAW  * ++++++++
000204*AND INTERNATIONAL TREATIES.  UNAUTHORIZED REPRODUCTION OR      * ++++++++
000205*DISTRIBUTION OF THIS PROGRAM, OR ANY PORTION OF IT, MAY RESULT * ++++++++
000206*IN SEVERE CIVIL AND CRIMINAL PENATLIES, AND WILL BE PROSECUTED * ++++++++
000207*TO THE MAXIMUM EXTENT POSSIBLE UNDER THE LAW.                  * ++++++++
000208*COPYRIGHT 1999 PAYSYS INTERNATIONAL, INC.  ALL RIGHTS RESERVED.* ++++++++
000209***************************************************************** ++++++++
000300*****************************************************************
000400*                                                               *
000500*   V - PLUS  M E R C H A N T   B A N K C A R D   S Y S T E M   *
000600*                                                               *
000700*     MBD100EX - E.X.A.M. FILE RECOVERY AND                     *
000800*                NON-MONETARY REPORTS                           *
000900*                                                               *
001000*****************************************************************
001100 ENVIRONMENT DIVISION.
001200 CONFIGURATION SECTION.
001300 SOURCE-COMPUTER.            IBM-4341.
001400 OBJECT-COMPUTER.            IBM-4341.
001500/
001600 INPUT-OUTPUT SECTION.
001700*
001800 FILE-CONTROL.
001900/
002000 DATA DIVISION.
002100 FILE SECTION.
002200/
002300 WORKING-STORAGE SECTION.
002400*
002500 01  FILLER                  PIC  X(12)      VALUE '** WS-BEG **'.
002600*
002700     COPY MMEXRL REPLACING ==:MMEX:== BY ==MMEX==.
002800/
002900     COPY MMEXIO REPLACING ==:MMEX:== BY ==MMEX==.
003000/
003100     COPY MB00RB REPLACING ==:MB00:== BY ==MMEX==.
003200/
003300     COPY MMEXIR REPLACING ==:MMEX:== BY ==MMEX==.
003400/
003500     COPY MML1WS REPLACING ==:MML1:== BY ==MTL1==.
003600/
003700     COPY MTCCRL REPLACING ==:MTCC:== BY ==MTCC==.
003800/
003900     COPY MB00WS.
004000/
004100     COPY SS95WS.
004200/
004300     COPY MB99WS.
004400/
004500     COPY SS00WS.
004600/
004700     COPY SS01WS.
004800/
004900     COPY SS02WS.
005000*
005100 01  FILLER                  PIC  X(12)      VALUE '** WS-END **'.
005200/
005300 LINKAGE SECTION.
005400     COPY MBD100WS.
005500/
005600     COPY MMSCRL.
005700/
005800     COPY MMOCRL.
005900/
006000     COPY MML1RL REPLACING ==:MML1:== BY ==MTL1==.
006100/
006200     COPY MTCCRL REPLACING ==:MTCC:== BY ==MTC1==.
006300/
006400     COPY MTCCRL REPLACING ==:MTCC:== BY ==MTC2==.
006500/
006600 PROCEDURE DIVISION              USING MBD100WS-AREA
006700                                       MMSC-RECORD
006800                                       MMOC-RECORD
006900                                       MTL1-RECORD
007000                                       MTC1-RECORD
007100                                       MTC2-RECORD.
007200*
007300 A000-MAIN-LINE-SECT SECTION.
007400 A010-ML-BEGIN.
007500*
007600*
007700*
007800     MOVE 'MBD100EX'             TO SS02WS-ABEND-PROG-ID.
007900     MOVE 'MMEX'                 TO MB99WS-FILE-ID.
008000     MOVE MMSC-TODAYS-JULIAN     TO MB99WS-PROC-DATE.
008100     MOVE MMSC-TIME-STAMP        TO MB99WS-PROC-TIME.
008200*
008300     IF  MBD100WS-OPEN-FILE
008400         SET SS95WS-FUNCTION-INITIALIZE
008500                                 TO TRUE
008600         PERFORM SS95PD-NAP-ROUTINE
008700            THRU SS95PD-NAP-EXIT
008800         PERFORM O000-OPEN-FILE
008900            THRU O999-OF-EXIT.
009000*
009100     IF  MBD100WS-CLOSE-FILE
009200         PERFORM C000-CLOSE-FILE
009300            THRU C999-CF-EXIT.
009400*
009500     IF  MBD100WS-PROCESS-RECORD
009600         PERFORM P000-PROCESS-RECORD
009700            THRU P099-PR-EXIT.
009800*
009900     GOBACK.
010000*
010100 A999-ML-EXIT.
010200     EXIT.
010300/
010400 C000-CLOSE-FILE SECTION.
010500 C010-CF-BEGIN.
010600*
010700     MOVE 'C1EX'                 TO SS02WS-ABEND-LOCATION.
010800     SET MMEXRB-CLOSE            TO TRUE.
010900     PERFORM MB00PD-MMEX-ACCESS
011000        THRU MB00PD-MMEX-ACCESS-EXIT.
011100*
011200 C999-CF-EXIT.
011300     EXIT.
011400/
011500 O000-OPEN-FILE SECTION.
011600 O010-OF-BEGIN.
011700*
011800     MOVE MMSC-DATE-FORMAT       TO SS01WS-DATE-FORMAT.
011900*
012000     MOVE 'O1EX'                 TO SS02WS-ABEND-LOCATION.
012100*
012200     IF  MBD100WS-UPDATE
012300         SET MMEXRB-OPEN-IO-DYN  TO TRUE
012400     ELSE
012500         SET MMEXRB-OPEN-INPUT-DYN
012600                                 TO TRUE.
012700*
012800     PERFORM MB00PD-MMEX-ACCESS
012900        THRU MB00PD-MMEX-ACCESS-EXIT.
013000*
013100     MOVE 'R0EX'                 TO SS02WS-ABEND-LOCATION.
013200     SET MMEXRB-READ-SEQ         TO TRUE.
013300     PERFORM MB00PD-MMEX-ACCESS
013400        THRU MB00PD-MMEX-ACCESS-EXIT.
013500     MOVE 'MMEX'                 TO MB99WS-FILE-ID.
013600*
013700     IF  MMEXIO-HEADER
013800         NEXT SENTENCE
013900     ELSE
014000         PERFORM MB99PD-MISSING-HEADER-ABEND
014100            THRU MB99PD-MHA-EXIT.
014200*
014300     MOVE MMEXIO-DATE-STAMP      TO MB99WS-FILE-DATE.
014400     MOVE MMEXIO-TIME-STAMP      TO MB99WS-FILE-TIME.
014500     PERFORM MB99PD-CHECK-DATE-TIME
014600        THRU MB99PD-CDT-EXIT.
014700*
014800     PERFORM Z900-INIT-RECORD
014900        THRU Z999-IR-EXIT.
015000*
015100 O999-OF-EXIT.
015200     EXIT.
015300/
015400 P000-PROCESS-RECORD SECTION.
015500 P010-PR-BEGIN.
015600*
015700     MOVE MMOC-CURRENCY-CODE     TO SS95WS-CURRENCY-CODE.
015800*
015900     IF  MTL1-MMEX-KEY IS NOT EQUAL TO MMEX-KEY
016000         PERFORM P500-FILE-UPDATE
016100            THRU P599-FU-EXIT.
016200*
016300     IF  MTL1-TOTALS-RECORD
016400         GO TO P099-PR-EXIT.
016500*
016600     IF  MTL1-MMEX-KEY IS NOT EQUAL TO MMEX-KEY
016700         PERFORM P700-GET-RECORD-TO-UPDATE
016800            THRU P799-GRTU-EXIT.
016900*
017000     MOVE MTL1-FIELD-CODE        TO MBD100WS-FIELD-CODE.
017100*
017200     IF (MBD100WS-FC-1-2-ADD AND MBD100WS-FC-3-4-ADD)
017300     OR (MBD100WS-FC-1-2-REP AND MBD100WS-FC-3-4-REP)
017400         PERFORM U000-NEW-RECORD
017500            THRU U099-NR-EXIT
017600     ELSE
017700         PERFORM 0000-MAINT-RECORD
017800            THRU 5999-MR-EXIT.
017900*
018000 P099-PR-EXIT.
018100     EXIT.
018200/
018300 P500-FILE-UPDATE SECTION.
018400 P510-FU-BEGIN.
018500*
018600     IF  MBD100WS-JOURNAL
018700         GO TO P599-FU-EXIT.
018800*
018900     IF  MMEX-KEY IS EQUAL TO MMEXIR-KEY
019000         GO TO P599-FU-EXIT.
019100*
019200     IF  MBD100WS-IO-REWRITE
019300         MOVE MMEX-RECORD        TO MMEXIO-RECORD
019400         MOVE SS02WS-NO-RECORD-FOUND
019500                                 TO MMEXRB-TEMP-STATUS-1
019600         MOVE 'U1EX'             TO SS02WS-ABEND-LOCATION
019700         SET MMEXRB-REWRITE      TO TRUE
019800         PERFORM MB00PD-MMEX-ACCESS
019900            THRU MB00PD-MMEX-ACCESS-EXIT
020000         IF  SS02WS-FS-NO-RECORD-FOUND
020100             MOVE 'W'            TO MBD100WS-IO-SW.
020200*
020300     IF  MBD100WS-IO-NO-REC-FOUND
020400     OR  MBD100WS-IO-WRITE
020500         MOVE MMEX-RECORD        TO MMEXIO-RECORD
020600         MOVE SS02WS-DUPLICATE-RECORD
020700                                 TO MMEXRB-TEMP-STATUS-1
020800         MOVE 'W2EX'             TO SS02WS-ABEND-LOCATION
020900         SET MMEXRB-WRITE        TO TRUE
021000         PERFORM MB00PD-MMEX-ACCESS
021100            THRU MB00PD-MMEX-ACCESS-EXIT
021200         IF  SS02WS-FS-DUPLICATE-RECORD
021300             MOVE 'U'            TO MBD100WS-IO-SW
021400             MOVE MMEX-RECORD    TO MMEXIO-RECORD
021500             MOVE 'U2EX'         TO SS02WS-ABEND-LOCATION
021600             SET MMEXRB-REWRITE  TO TRUE
021700             PERFORM MB00PD-MMEX-ACCESS
021800                THRU MB00PD-MMEX-ACCESS-EXIT.
021900*
022000     PERFORM Z900-INIT-RECORD
022100        THRU Z999-IR-EXIT.
022200*
022300 P599-FU-EXIT.
022400     EXIT.
022500/
022600 P700-GET-RECORD-TO-UPDATE SECTION.
022700 P710-GRTU-BEGIN.
022800*
022900     IF  MBD100WS-JOURNAL
023000         PERFORM Z900-INIT-RECORD
023100            THRU Z999-IR-EXIT
023200         GO TO P799-GRTU-EXIT.
023300*
023400     MOVE SS02WS-NO-RECORD-FOUND
023500                                 TO MMEXRB-TEMP-STATUS-1.
023600     MOVE MTL1-MMEX-KEY          TO MMEXIO-KEY.
023700*
023800     MOVE 'R1EX'                 TO SS02WS-ABEND-LOCATION.
023900     SET MMEXRB-READ-RANDOM      TO TRUE.
024000     PERFORM MB00PD-MMEX-ACCESS
024100        THRU MB00PD-MMEX-ACCESS-EXIT.
024200*
024300     IF  SS02WS-FS-NO-RECORD-FOUND
024400         PERFORM Z900-INIT-RECORD
024500            THRU Z999-IR-EXIT
024600         MOVE 'N'                TO MBD100WS-IO-SW
024700     ELSE
024800         MOVE MMEXIO-RECORD      TO MMEX-RECORD
024900         MOVE 'U'                TO MBD100WS-IO-SW.
025000*
025100 P799-GRTU-EXIT.
025200     EXIT.
025300/
025400 U000-NEW-RECORD SECTION.
025500 U010-NR-BEGIN.
025600*
025700     PERFORM Z100-COMMON-FROM-DATA
025800        THRU Z199-CFD-EXIT.
025900*
026000     PERFORM Z200-COMMON-TO-DATA
026100        THRU Z299-CTD-EXIT.
026200*
026300     MOVE MTL1-ADD-AREA          TO MMEX-RECORD.
026400*
026500     IF  MBD100WS-IO-NO-REC-FOUND
026600         MOVE 'W'                TO MBD100WS-IO-SW.
026700*
026800     IF  MBD100WS-FC-1-2-ADD
026900         MOVE '*** NEW RECORD ADDED ***'
027000                                 TO MBD100WS-PL2-TO-VALUE
027100                                    MBD100WS-PL1-FROM-VALUE
027200     ELSE
027300         MOVE '*** REPLACEMENT RECORD ***'
027400                                 TO MBD100WS-PL2-TO-VALUE
027500                                    MBD100WS-PL1-FROM-VALUE.
027600*
027700     MOVE SPACES                 TO MTCC-RECORD.
027800*
027900 U099-NR-EXIT.
028000     EXIT.
028100/
028200 Z100-COMMON-FROM-DATA SECTION.
028300 Z110-CFD-BEGIN.
028400*
028500     MOVE MTL1-MMEX-REQUEST-NBR-X
028600                                 TO MBD100WS-PL1-KEY.
028700*
028800 Z199-CFD-EXIT.
028900     EXIT.
029000/
029100 Z200-COMMON-TO-DATA SECTION.
029200 Z210-CTD-BEGIN.
029300*
029400 Z299-CTD-EXIT.
029500     EXIT.
029600/
029700 Z900-INIT-RECORD SECTION.
029800 Z910-IR-BEGIN.
029900*
030000     MOVE MMEXIR-RECORD          TO MMEX-RECORD.
030100     MOVE SPACES                 TO MTC1-RECORD.
030200     MOVE SPACES                 TO MTC2-RECORD.
030300*
030400 Z999-IR-EXIT.
030500     EXIT.
030600/
030700 0000-MAINT-RECORD SECTION.
030800 0010-MR-BEGIN.
030900*
031000     PERFORM Z100-COMMON-FROM-DATA
031100        THRU Z199-CFD-EXIT.
031200*
031300     PERFORM Z200-COMMON-TO-DATA
031400        THRU Z299-CTD-EXIT.
031500*
031600     IF  MTL1-FIELD-CODE IS EQUAL TO 0198
031700         GO TO 0198-MR-FIELD.
031800*
031900     IF  MTL1-FIELD-CODE IS EQUAL TO 0199
032000         GO TO 0199-MR-FIELD.
032100*
032200     MOVE '*** ERROR - INVALID FIELD CODE ***'
032300                                 TO MBD100WS-PL2-TO-VALUE.
032400     GO TO 5999-MR-EXIT.
032500*
032600 0198-MR-FIELD.
032700*
032800     IF  MBD100WS-JOURNAL
032900         MOVE MTL1-VL03-B-DATA-X TO MMEX-LAST-MAINT-OPER.
033000*
033100     MOVE 'LAST MAINT OPERATOR   '
033200                                 TO MBD100WS-PL1-DESC.
033300     MOVE MMEX-LAST-MAINT-OPER   TO MBD100WS-PL1-FROM-VALUE.
033400     MOVE MTL1-VL03-A-DATA-X     TO MMEX-LAST-MAINT-OPER.
033500     MOVE MMEX-LAST-MAINT-OPER   TO MBD100WS-PL2-TO-VALUE.
033600     GO TO 5100-MR-NO-REC-CHECK.
033700*
033800*
033900*
034000 0199-MR-FIELD.
034100*
034200     IF  MBD100WS-JOURNAL
034300         MOVE MTL1-VL07-B-DATA-9 TO MMEX-LAST-MAINT-DATE.
034400*
034500     MOVE 'DATE LAST MAINTENANCE '
034600                                 TO MBD100WS-PL1-DESC.
034700     MOVE MMEX-LAST-MAINT-DATE   TO SS01WS-JULIAN.
034800     PERFORM 8100-FROM-DATE      THRU 8199-FD-EXIT.
034900     MOVE MTL1-VL07-A-DATA-9     TO MMEX-LAST-MAINT-DATE.
035000     MOVE MMEX-LAST-MAINT-DATE   TO SS01WS-JULIAN.
035100     PERFORM 8200-TO-DATE        THRU 8299-TD-EXIT.
035200     GO TO 5100-MR-NO-REC-CHECK.
035300*
035400*
035500*
035600 5100-MR-NO-REC-CHECK.
035700*
035800     IF  MBD100WS-UPDATE
035900     AND MBD100WS-IO-NO-REC-FOUND
036000         MOVE '*** ERROR - NO RECORD FOUND ***'
036100                                 TO MBD100WS-PL2-TO-VALUE.
036200*
036300 5999-MR-EXIT.
036400     EXIT.
036500/
036600 8100-FROM-DATE SECTION.
036700 8110-FD-BEGIN.
036800*
036900     MOVE SS01WS-JULIAN          TO MBD100WS-PL1-FV-JULIAN.
037000     PERFORM SS26PD-NUMERICALLY-EDIT-DATE
037100        THRU SS26PD-NED-EXIT.
037200     MOVE SS01WS-XX-XX-YYYY      TO MBD100WS-PL1-FV-DATE.
037300     INSPECT MBD100WS-PL1-FV-JULIAN REPLACING ALL ',' BY '-'.
037400*
037500 8199-FD-EXIT.
037600     EXIT.
037700*
037800*
037900*
038000 8200-TO-DATE SECTION.
038100 8210-TD-BEGIN.
038200*
038300     MOVE SS01WS-JULIAN          TO MBD100WS-PL2-TV-JULIAN.
038400     PERFORM SS26PD-NUMERICALLY-EDIT-DATE
038500        THRU SS26PD-NED-EXIT.
038600     MOVE SS01WS-XX-XX-YYYY      TO MBD100WS-PL2-TV-DATE.
038700     INSPECT MBD100WS-PL2-TV-JULIAN REPLACING ALL ',' BY '-'.
038800*
038900 8299-TD-EXIT.
039000     EXIT.
039100/
039200 9000-PERFORMED-ROUTINES-SECT SECTION.
039300*
039400     COPY MB00PD REPLACING ==:MB00:== BY ==MMEX==.
039500/
039600     COPY SS95PD.
039700/
039800     COPY MB99PD.
039900/
040000     COPY SS02PD.
040100/
040200     COPY SS07PD.
040300/
040400     COPY SS08PD.
040500/
040600     COPY SS26PD.
040700/
040800     COPY SS27PD.
040900*
041000 9995-END-SOURCE-STATEMENTS SECTION.
041100 9999-END-OF-PROGRAM.
041200     EXIT.
