000100 IDENTIFICATION DIVISION.
000200 PROGRAM-ID. MBD100FA.
000201*       RELEASE DATE=08/24/01.        REVISION LEVEL=08.06      * ++++++++
000202***************************************************************** ++++++++
000203*WARNING.  THIS COMPUTER PROGRAM IS PROTECTED BY COPYRIGHT LAW  * ++++++++
000204*AND INTERNATIONAL TREATIES.  UNAUTHORIZED REPRODUCTION OR      * ++++++++
000205*DISTRIBUTION OF THIS PROGRAM, OR ANY PORTION OF IT, MAY RESULT * ++++++++
000206*IN SEVERE CIVIL AND CRIMINAL PENATLIES, AND WILL BE PROSECUTED * ++++++++
000207*TO THE MAXIMUM EXTENT POSSIBLE UNDER THE LAW.                  * ++++++++
000208*COPYRIGHT 1999 PAYSYS INTERNATIONAL, INC.  ALL RIGHTS RESERVED.* ++++++++
000209***************************************************************** ++++++++
000300*****************************************************************
000400*                                                               *
000500*   V - PLUS  M E R C H A N T   B A N K C A R D   S Y S T E M   *
000600*                                                               *
000700*     MBD100FA - ADD FEE ACTIVITY RECORD ON ADD OF MERCHANT     *
000800*                SUBROUTINE                                     *
000900*                                                               *
001000*****************************************************************
001100 ENVIRONMENT DIVISION.
001200 CONFIGURATION SECTION.
001300 SOURCE-COMPUTER.            IBM-4341.
001400 OBJECT-COMPUTER.            IBM-4341.
001500/
001600 INPUT-OUTPUT SECTION.
001700*
001800 FILE-CONTROL.
001900/
002000 DATA DIVISION.
002100 FILE SECTION.
002200/
002300 WORKING-STORAGE SECTION.
002400*
002500 01  FILLER                  PIC  X(12)      VALUE '** WS-BEG **'.
002600*
002700     COPY MMFARL REPLACING ==:MMFA:== BY ==MMFA==.
002800/
002900     COPY MMFAIO REPLACING ==:MMFA:== BY ==MMFA==.
003000/
003100     COPY MB00RB REPLACING ==:MB00:== BY ==MMFA==.
003200/
003300     COPY MMFAIR REPLACING ==:MMFA:== BY ==MMFA==.
003400/
003500     COPY MB00WS.
003600/
003700     COPY MB99WS.
003800/
003900     COPY SS00WS.
004000/
004100     COPY SS01WS.
004200/
004300     COPY SS02WS.
004400/
004500     COPY SS95WS.
004600*
004700 01  FILLER                  PIC  X(12)      VALUE '** WS-END **'.
004800/
004900 LINKAGE SECTION.
005000     COPY MBD100WS.
005100/
005200     COPY MML1RL REPLACING ==:MML1:== BY ==MTL1==.
005300/
005400     COPY MMSCRL.
005500/
005600 PROCEDURE DIVISION              USING MBD100WS-AREA
005700                                       MTL1-RECORD
005800                                       MMSC-RECORD.
005900*
006000 A000-MAIN-LINE-SECT SECTION.
006100 A010-ML-BEGIN.
006200*
006300     MOVE 'MBD100FA'             TO SS02WS-ABEND-PROG-ID.
006400     MOVE 'MMFA'                 TO MB99WS-FILE-ID.
006500     MOVE MMSC-TODAYS-JULIAN     TO MB99WS-PROC-DATE.
006600     MOVE MMSC-TIME-STAMP        TO MB99WS-PROC-TIME.
006700*
006800     IF  MBD100WS-FA-OPEN
006900         SET SS95WS-FUNCTION-INITIALIZE
007000                                 TO TRUE
007100         PERFORM SS95PD-NAP-ROUTINE
007200            THRU SS95PD-NAP-EXIT
007300         PERFORM O000-OPEN-FILE
007400            THRU O999-OF-EXIT.
007500*
007600     IF  MBD100WS-FA-CLOSE
007700         PERFORM C000-CLOSE-FILE
007800            THRU C999-CF-EXIT.
007900*
008000     IF  MBD100WS-FA-ADD-RECORD
008100         PERFORM P000-PROCESS-RECORD
008200            THRU P099-PR-EXIT.
008300*
008400     GOBACK.
008500*
008600 A999-ML-EXIT.
008700     EXIT.
008800/
008900 C000-CLOSE-FILE SECTION.
009000 C010-CF-BEGIN.
009100*
009200     MOVE 'C1FA'                 TO SS02WS-ABEND-LOCATION.
009300     SET MMFARB-CLOSE            TO TRUE.
009400     PERFORM MB00PD-MMFA-ACCESS
009500        THRU MB00PD-MMFA-ACCESS-EXIT.
009600*
009700 C999-CF-EXIT.
009800     EXIT.
009900/
010000 O000-OPEN-FILE SECTION.
010100 O010-OF-BEGIN.
010200*
010300     MOVE 'O1FA'                 TO SS02WS-ABEND-LOCATION.
010400     SET MMFARB-OPEN-IO-DYN      TO TRUE.
010500     PERFORM MB00PD-MMFA-ACCESS
010600        THRU MB00PD-MMFA-ACCESS-EXIT.
010700*
010800     MOVE 'R0FA'                 TO SS02WS-ABEND-LOCATION.
010900     SET MMFARB-READ-SEQ         TO TRUE.
011000     PERFORM MB00PD-MMFA-ACCESS
011100        THRU MB00PD-MMFA-ACCESS-EXIT.
011200     MOVE 'MMFA'                 TO MB99WS-FILE-ID.
011300*
011400     IF  MMFAIO-HEADER
011500         NEXT SENTENCE
011600     ELSE
011700         PERFORM MB99PD-MISSING-HEADER-ABEND
011800            THRU MB99PD-MHA-EXIT.
011900*
012000     MOVE MMFAIO-DATE-STAMP      TO MB99WS-FILE-DATE.
012100     MOVE MMFAIO-TIME-STAMP      TO MB99WS-FILE-TIME.
012200     PERFORM MB99PD-CHECK-DATE-TIME
012300        THRU MB99PD-CDT-EXIT.
012400*
012500 O999-OF-EXIT.
012600     EXIT.
012700/
012800 P000-PROCESS-RECORD SECTION.
012900 P010-PR-BEGIN.
013000*
013100     MOVE MMFAIR-RECORD          TO MMFA-RECORD.
013200     MOVE MTL1-MMMM-KEY          TO MMFA-KEY.
013300     SET MMFA-REC-ACTIVE         TO TRUE.
013400*
013500     MOVE MMFA-RECORD            TO MMFAIO-RECORD.
013600     MOVE SS02WS-DUPLICATE-RECORD
013700                                 TO MMFARB-TEMP-STATUS-1.
013800     MOVE 'W2FA'                 TO SS02WS-ABEND-LOCATION.
013900     SET MMFARB-WRITE            TO TRUE.
014000     PERFORM MB00PD-MMFA-ACCESS
014100        THRU MB00PD-MMFA-ACCESS-EXIT.
014200*
014300 P099-PR-EXIT.
014400     EXIT.
014500/
014600 8100-FROM-DATE SECTION.
014700 8110-FD-BEGIN.
014800*
014900     MOVE SS01WS-JULIAN          TO MBD100WS-PL1-FV-JULIAN.
015000     PERFORM SS26PD-NUMERICALLY-EDIT-DATE
015100        THRU SS26PD-NED-EXIT.
015200     MOVE SS01WS-XX-XX-YYYY      TO MBD100WS-PL1-FV-DATE.
015300     INSPECT MBD100WS-PL1-FV-JULIAN REPLACING ALL ',' BY '-'.
015400*
015500 8199-FD-EXIT.
015600     EXIT.
015700*
015800*
015900*
016000 8200-TO-DATE SECTION.
016100 8210-TD-BEGIN.
016200*
016300     MOVE SS01WS-JULIAN          TO MBD100WS-PL2-TV-JULIAN.
016400     PERFORM SS26PD-NUMERICALLY-EDIT-DATE
016500        THRU SS26PD-NED-EXIT.
016600     MOVE SS01WS-XX-XX-YYYY      TO MBD100WS-PL2-TV-DATE.
016700     INSPECT MBD100WS-PL2-TV-JULIAN REPLACING ALL ',' BY '-'.
016800*
016900 8299-TD-EXIT.
017000     EXIT.
017100/
017200 9000-PERFORMED-ROUTINES-SECT SECTION.
017300*
017400     COPY MB00PD REPLACING ==:MB00:== BY ==MMFA==.
017500/
017600     COPY MB99PD.
017700/
017800     COPY SS02PD.
017900/
018000     COPY SS07PD.
018100/
018200     COPY SS08PD.
018300/
018400     COPY SS26PD.
018500/
018600     COPY SS27PD.
018700/
018800     COPY SS95PD.
018900*
019000 9995-END-SOURCE-STATEMENTS SECTION.
019100 9999-END-OF-PROGRAM.
019200     EXIT.
