000100 IDENTIFICATION DIVISION.
000200 PROGRAM-ID. MBD100FS.
000201*       RELEASE DATE=08/24/01.        REVISION LEVEL=08.06      * ++++++++
000202***************************************************************** ++++++++
000203*WARNING.  THIS COMPUTER PROGRAM IS PROTECTED BY COPYRIGHT LAW  * ++++++++
000204*AND INTERNATIONAL TREATIES.  UNAUTHORIZED REPRODUCTION OR      * ++++++++
000205*DISTRIBUTION OF THIS PROGRAM, OR ANY PORTION OF IT, MAY RESULT * ++++++++
000206*IN SEVERE CIVIL AND CRIMINAL PENATLIES, AND WILL BE PROSECUTED * ++++++++
000207*TO THE MAXIMUM EXTENT POSSIBLE UNDER THE LAW.                  * ++++++++
000208*COPYRIGHT 1999 PAYSYS INTERNATIONAL, INC.  ALL RIGHTS RESERVED.* ++++++++
000209***************************************************************** ++++++++
000300*****************************************************************
000400*                                                               *
000500*   V - PLUS  M E R C H A N T   B A N K C A R D   S Y S T E M   *
000600*                                                               *
000700*     MBD100FS - FIELD SECURITY FILE RECOVERY AND               *
000800*                NON-MONETARY REPORTS                           *
000900*                                                               *
001000*****************************************************************
001100 ENVIRONMENT DIVISION.
001200 CONFIGURATION SECTION.
001300 SOURCE-COMPUTER.            IBM-4341.
001400 OBJECT-COMPUTER.            IBM-4341.
001500/
001600 INPUT-OUTPUT SECTION.
001700*
001800 FILE-CONTROL.
001900/
002000 DATA DIVISION.
002100 FILE SECTION.
002200/
002300 WORKING-STORAGE SECTION.
002400*
002500 01  FILLER                  PIC  X(12)      VALUE '** WS-BEG **'.
002600*
002700     COPY MMFSRL.
002800/
002900     COPY MMFSIO.
003000/
003100     COPY MB00RB REPLACING ==:MB00:== BY ==MMFS==.
003200/
003300     COPY MMFSIR.
003400/
003500     COPY MML1WS REPLACING ==:MML1:== BY ==MTL1==.
003600/
003700     COPY MTCCRL REPLACING ==:MTCC:== BY ==MTCC==.
003800/
003900     COPY MB00WS.
004000/
004100     COPY SS95WS.
004200/
004300     COPY MB99WS.
004400/
004500     COPY SS00WS.
004600/
004700     COPY SS01WS.
004800/
004900     COPY SS02WS.
005000*
005100 01  FILLER                  PIC  X(12)      VALUE '** WS-END **'.
005200/
005300 LINKAGE SECTION.
005400     COPY MBD100WS.
005500/
005600     COPY MMSCRL.
005700/
005800     COPY MMOCRL.
005900/
006000     COPY MML1RL REPLACING ==:MML1:== BY ==MTL1==.
006100/
006200     COPY MTCCRL REPLACING ==:MTCC:== BY ==MTC1==.
006300/
006400     COPY MTCCRL REPLACING ==:MTCC:== BY ==MTC2==.
006500/
006600 PROCEDURE DIVISION              USING MBD100WS-AREA
006700                                       MMSC-RECORD
006800                                       MMOC-RECORD
006900                                       MTL1-RECORD
007000                                       MTC1-RECORD
007100                                       MTC2-RECORD.
007200*
007300 A000-MAIN-LINE-SECT SECTION.
007400 A010-ML-BEGIN.
007500*
007600     MOVE 'MBD100FS'             TO SS02WS-ABEND-PROG-ID.
007700     MOVE 'MMFS'                 TO MB99WS-FILE-ID.
007800     MOVE MMSC-TODAYS-JULIAN     TO MB99WS-PROC-DATE.
007900     MOVE MMSC-TIME-STAMP        TO MB99WS-PROC-TIME.
008000*
008100     IF  MBD100WS-OPEN-FILE
008200         SET SS95WS-FUNCTION-INITIALIZE
008300                                 TO TRUE
008400         PERFORM SS95PD-NAP-ROUTINE
008500            THRU SS95PD-NAP-EXIT
008600         PERFORM O000-OPEN-FILE
008700            THRU O999-OF-EXIT.
008800*
008900     IF  MBD100WS-CLOSE-FILE
009000         PERFORM C000-CLOSE-FILE
009100            THRU C999-CF-EXIT.
009200*
009300     IF  MBD100WS-PROCESS-RECORD
009400         PERFORM P000-PROCESS-RECORD
009500            THRU P099-PR-EXIT.
009600*
009700     GOBACK.
009800*
009900 A999-ML-EXIT.
010000     EXIT.
010100/
010200 C000-CLOSE-FILE SECTION.
010300 C010-CF-BEGIN.
010400*
010500     MOVE 'C1FS'                 TO SS02WS-ABEND-LOCATION.
010600     SET MMFSRB-CLOSE            TO TRUE.
010700     PERFORM MB00PD-MMFS-ACCESS
010800        THRU MB00PD-MMFS-ACCESS-EXIT.
010900*
011000 C999-CF-EXIT.
011100     EXIT.
011200/
011300 O000-OPEN-FILE SECTION.
011400 O010-OF-BEGIN.
011500*
011600     MOVE MMSC-DATE-FORMAT       TO SS01WS-DATE-FORMAT.
011700*
011800     MOVE 'O1FS'                 TO SS02WS-ABEND-LOCATION.
011900*
012000     IF  MBD100WS-UPDATE
012100         SET MMFSRB-OPEN-IO-DYN  TO TRUE
012200     ELSE
012300         SET MMFSRB-OPEN-INPUT-DYN
012400                                 TO TRUE.
012500*
012600     PERFORM MB00PD-MMFS-ACCESS
012700        THRU MB00PD-MMFS-ACCESS-EXIT.
012800*
012900     MOVE 'R0FS'                 TO SS02WS-ABEND-LOCATION.
013000     SET MMFSRB-READ-SEQ         TO TRUE.
013100     PERFORM MB00PD-MMFS-ACCESS
013200        THRU MB00PD-MMFS-ACCESS-EXIT.
013300     MOVE 'MMFS'                 TO MB99WS-FILE-ID.
013400*
013500     IF  MMFSIO-HEADER
013600         NEXT SENTENCE
013700     ELSE
013800         PERFORM MB99PD-MISSING-HEADER-ABEND
013900            THRU MB99PD-MHA-EXIT.
014000*
014100     MOVE MMFSIO-DATE-STAMP      TO MB99WS-FILE-DATE.
014200     MOVE MMFSIO-TIME-STAMP      TO MB99WS-FILE-TIME.
014300     PERFORM MB99PD-CHECK-DATE-TIME
014400        THRU MB99PD-CDT-EXIT.
014500*
014600     PERFORM Z900-INIT-RECORD
014700        THRU Z999-IR-EXIT.
014800*
014900 O999-OF-EXIT.
015000     EXIT.
015100/
015200 P000-PROCESS-RECORD SECTION.
015300 P010-PR-BEGIN.
015400*
015500     MOVE MMOC-CURRENCY-CODE     TO SS95WS-CURRENCY-CODE.
015600*
015700     IF  MTL1-MMFS-KEY IS NOT EQUAL TO MMFS-KEY
015800         PERFORM P500-FILE-UPDATE
015900            THRU P599-FU-EXIT.
016000*
016100     IF  MTL1-TOTALS-RECORD
016200         GO TO P099-PR-EXIT.
016300*
016400     IF  MTL1-MMFS-KEY IS NOT EQUAL TO MMFS-KEY
016500         PERFORM P700-GET-RECORD-TO-UPDATE
016600            THRU P799-GRTU-EXIT.
016700*
016800     MOVE MTL1-FIELD-CODE        TO MBD100WS-FIELD-CODE.
016900*
017000     IF (MBD100WS-FC-1-2-ADD AND MBD100WS-FC-3-4-ADD)
017100     OR (MBD100WS-FC-1-2-REP AND MBD100WS-FC-3-4-REP)
017200         PERFORM U000-NEW-RECORD
017300            THRU U099-NR-EXIT
017400     ELSE
017500         PERFORM 0000-MAINT-RECORD
017600            THRU 5999-MR-EXIT.
017700*
017800 P099-PR-EXIT.
017900     EXIT.
018000/
018100 P500-FILE-UPDATE SECTION.
018200 P510-FU-BEGIN.
018300*
018400     IF  MBD100WS-JOURNAL
018500         GO TO P599-FU-EXIT.
018600*
018700     IF  MMFS-KEY IS EQUAL TO MMFSIR-KEY
018800         GO TO P599-FU-EXIT.
018900*
019000     IF  MBD100WS-IO-REWRITE
019100         MOVE MMFS-RECORD        TO MMFSIO-RECORD
019200         MOVE SS02WS-NO-RECORD-FOUND
019300                                 TO MMFSRB-TEMP-STATUS-1
019400         MOVE 'U1FS'             TO SS02WS-ABEND-LOCATION
019500         SET MMFSRB-REWRITE      TO TRUE
019600         PERFORM MB00PD-MMFS-ACCESS
019700            THRU MB00PD-MMFS-ACCESS-EXIT
019800         IF  SS02WS-FS-NO-RECORD-FOUND
019900             MOVE 'W'            TO MBD100WS-IO-SW.
020000*
020100     IF  MBD100WS-IO-NO-REC-FOUND
020200     OR  MBD100WS-IO-WRITE
020300         MOVE MMFS-RECORD        TO MMFSIO-RECORD
020400         MOVE SS02WS-DUPLICATE-RECORD
020500                                 TO MMFSRB-TEMP-STATUS-1
020600         MOVE 'W2FS'             TO SS02WS-ABEND-LOCATION
020700         SET MMFSRB-WRITE        TO TRUE
020800         PERFORM MB00PD-MMFS-ACCESS
020900            THRU MB00PD-MMFS-ACCESS-EXIT
021000         IF  SS02WS-FS-DUPLICATE-RECORD
021100             MOVE 'U'            TO MBD100WS-IO-SW
021200             MOVE MMFS-RECORD    TO MMFSIO-RECORD
021300             MOVE 'U2FS'         TO SS02WS-ABEND-LOCATION
021400             SET MMFSRB-REWRITE  TO TRUE
021500             PERFORM MB00PD-MMFS-ACCESS
021600                THRU MB00PD-MMFS-ACCESS-EXIT.
021700*
021800     PERFORM Z900-INIT-RECORD
021900        THRU Z999-IR-EXIT.
022000*
022100 P599-FU-EXIT.
022200     EXIT.
022300/
022400 P700-GET-RECORD-TO-UPDATE SECTION.
022500 P710-GRTU-BEGIN.
022600*
022700     IF  MBD100WS-JOURNAL
022800         PERFORM Z900-INIT-RECORD
022900            THRU Z999-IR-EXIT
023000         GO TO P799-GRTU-EXIT.
023100*
023200     MOVE SS02WS-NO-RECORD-FOUND
023300                                 TO MMFSRB-TEMP-STATUS-1.
023400     MOVE MTL1-MMFS-KEY          TO MMFSIO-KEY.
023500*
023600     MOVE 'R1FS'                 TO SS02WS-ABEND-LOCATION.
023700     SET MMFSRB-READ-RANDOM      TO TRUE.
023800     PERFORM MB00PD-MMFS-ACCESS
023900        THRU MB00PD-MMFS-ACCESS-EXIT.
024000*
024100     IF  SS02WS-FS-NO-RECORD-FOUND
024200         PERFORM Z900-INIT-RECORD
024300            THRU Z999-IR-EXIT
024400         MOVE 'N'                TO MBD100WS-IO-SW
024500     ELSE
024600         MOVE MMFSIO-RECORD      TO MMFS-RECORD
024700         MOVE 'U'                TO MBD100WS-IO-SW.
024800*
024900 P799-GRTU-EXIT.
025000     EXIT.
025100/
025200 U000-NEW-RECORD SECTION.
025300 U010-NR-BEGIN.
025400*
025500     PERFORM Z100-COMMON-FROM-DATA
025600        THRU Z199-CFD-EXIT.
025700*
025800     PERFORM Z200-COMMON-TO-DATA
025900        THRU Z299-CTD-EXIT.
026000*
026100     MOVE MTL1-ADD-AREA          TO MMFS-RECORD.
026200*
026300     IF  MBD100WS-IO-NO-REC-FOUND
026400         MOVE 'W'                TO MBD100WS-IO-SW.
026500*
026600     IF  MBD100WS-FC-1-2-ADD
026700         MOVE '*** NEW RECORD ADDED ***'
026800                                 TO MBD100WS-PL2-TO-VALUE
026900                                    MBD100WS-PL1-FROM-VALUE
027000     ELSE
027100         MOVE '*** REPLACEMENT RECORD ***'
027200                                 TO MBD100WS-PL2-TO-VALUE
027300                                    MBD100WS-PL1-FROM-VALUE.
027400*
027500     MOVE SPACES                 TO MTCC-RECORD.
027600     MOVE MMFS-ORG               TO MTCC-MBU909-BEG-ORG.
027700     MOVE MMFS-FS-CODE           TO MTCC-MBU909-BEG-FS-CODE.
027800     MOVE 'MBU909'               TO MTCC-PROGRAM-ID.
027900     MOVE MTCC-RECORD            TO MTC2-RECORD.
028000*
028100 U099-NR-EXIT.
028200     EXIT.
028300/
028400 Z100-COMMON-FROM-DATA SECTION.
028500 Z110-CFD-BEGIN.
028600*
028700     MOVE MTL1-MMFS-FS-CODE      TO MBD100WS-PL1-FS-CODE.
028800*
028900 Z199-CFD-EXIT.
029000     EXIT.
029100/
029200 Z200-COMMON-TO-DATA SECTION.
029300 Z210-CTD-BEGIN.
029400*
029500 Z299-CTD-EXIT.
029600     EXIT.
029700/
029800 Z900-INIT-RECORD SECTION.
029900 Z910-IR-BEGIN.
030000*
030100     MOVE MMFSIR-RECORD          TO MMFS-RECORD.
030200     MOVE SPACES                 TO MTC1-RECORD.
030300     MOVE SPACES                 TO MTC2-RECORD.
030400*
030500 Z999-IR-EXIT.
030600     EXIT.
030700/
030800 0000-MAINT-RECORD SECTION.
030900 0010-MR-BEGIN.
031000*
031100     PERFORM Z100-COMMON-FROM-DATA
031200        THRU Z199-CFD-EXIT.
031300*
031400     PERFORM Z200-COMMON-TO-DATA
031500        THRU Z299-CTD-EXIT.
031600*
031700     IF  MTL1-FIELD-CODE IS EQUAL TO 0101
031800         GO TO 0101-MR-FIELD.
031900*
032000     IF  MTL1-FIELD-CODE IS EQUAL TO 0102
032100         GO TO 0102-MR-FIELD.
032200*
032300     IF  MTL1-FIELD-CODE IS EQUAL TO 0103
032400         GO TO 0103-MR-FIELD.
032500*
032600     IF  MTL1-FIELD-CODE IS EQUAL TO 0197
032700         GO TO 0197-MR-FIELD.
032800*
032900     IF  MTL1-FIELD-CODE IS EQUAL TO 0198
033000         GO TO 0198-MR-FIELD.
033100*
033200     IF  MTL1-FIELD-CODE IS EQUAL TO 0199
033300         GO TO 0199-MR-FIELD.
033400*
033500     IF  MTL1-FIELD-CODE IS EQUAL TO 0202
033600         GO TO 0202-MR-FIELD.
033700*
033800     IF  MTL1-FIELD-CODE IS EQUAL TO 0203
033900         GO TO 0203-MR-FIELD.
034000*
034100     MOVE '*** ERROR - INVALID FIELD CODE ***'
034200                                 TO MBD100WS-PL2-TO-VALUE.
034300     GO TO 5999-MR-EXIT.
034400*
034500 0101-MR-FIELD.
034600*
034700     IF  MBD100WS-JOURNAL
034800         MOVE MTL1-VL30-B-DATA-X TO MMFS-NAME.
034900*
035000     MOVE 'FIELD SECURITY NAME   '
035100                                 TO MBD100WS-PL1-DESC.
035200     MOVE MMFS-NAME              TO MBD100WS-PL1-FROM-VALUE.
035300     MOVE MTL1-VL30-A-DATA-X     TO MMFS-NAME.
035400     MOVE MMFS-NAME              TO MBD100WS-PL2-TO-VALUE.
035500     GO TO 5100-MR-NO-REC-CHECK.
035600*
035700*
035800*
035900 0102-MR-FIELD.
036000*
036100     SET X-MMFS-MERCH            TO MTL1-FIELD-OCCURRENCE.
036200*
036300     IF  MBD100WS-JOURNAL
036400         MOVE MTL1-VL01-B-DATA-9 TO MMFS-MT-FIELD-ATTR
036500                                    (X-MMFS-MERCH).
036600*
036700     MOVE 'MERCH FIELD ATTRIBUTE '
036800                                 TO MBD100WS-PL1-DESC.
036900     MOVE MMFS-MT-FIELD-ATTR
037000          (X-MMFS-MERCH)         TO MBD100WS-PL1-FV-9.
037100     MOVE MTL1-VL01-A-DATA-9     TO MMFS-MT-FIELD-ATTR
037200                                    (X-MMFS-MERCH).
037300     MOVE MMFS-MT-FIELD-ATTR
037400          (X-MMFS-MERCH)         TO MBD100WS-PL2-TV-9.
037500     GO TO 5100-MR-NO-REC-CHECK.
037600*
037700*
037800*
037900 0103-MR-FIELD.
038000*
038100     SET X-MMFS-MERCH            TO MTL1-FIELD-OCCURRENCE.
038200*
038300     IF  MBD100WS-JOURNAL
038400         MOVE MTL1-VL01-B-DATA-X TO MMFS-MT-AUDIT-CODE
038500                                    (X-MMFS-MERCH).
038600*
038700     MOVE 'MERCH AUDIT CODE      '
038800                                 TO MBD100WS-PL1-DESC.
038900     MOVE MMFS-MT-AUDIT-CODE
039000          (X-MMFS-MERCH)         TO MBD100WS-PL1-FROM-VALUE.
039100     MOVE MTL1-VL01-A-DATA-X     TO MMFS-MT-AUDIT-CODE
039200                                    (X-MMFS-MERCH).
039300     MOVE MMFS-MT-AUDIT-CODE
039400          (X-MMFS-MERCH)         TO MBD100WS-PL2-TO-VALUE.
039500     GO TO 5100-MR-NO-REC-CHECK.
039600*
039700*
039800*
039900 0198-MR-FIELD.
040000*
040100     IF  MBD100WS-JOURNAL
040200         MOVE MTL1-VL03-B-DATA-X TO MMFS-LAST-MAINT-OPER.
040300*
040400     MOVE 'LAST MAINT OPERATOR   '
040500                                 TO MBD100WS-PL1-DESC.
040600     MOVE MMFS-LAST-MAINT-OPER   TO MBD100WS-PL1-FROM-VALUE.
040700     MOVE MTL1-VL03-A-DATA-X     TO MMFS-LAST-MAINT-OPER.
040800     MOVE MMFS-LAST-MAINT-OPER   TO MBD100WS-PL2-TO-VALUE.
040900     GO TO 5100-MR-NO-REC-CHECK.
041000*
041100*
041200*
041300 0197-MR-FIELD.
041400*
041500     IF  MBD100WS-JOURNAL
041600         MOVE MTL1-VL01-B-DATA-9 TO MMFS-REC-STATUS.
041700*
041800     MOVE 'RECORD STATUS         '
041900                                 TO MBD100WS-PL1-DESC.
042000     MOVE MMFS-REC-STATUS        TO MBD100WS-PL1-FV-9.
042100     MOVE MTL1-VL01-A-DATA-9     TO MMFS-REC-STATUS.
042200     MOVE MMFS-REC-STATUS        TO MBD100WS-PL2-TV-9.
042300     GO TO 5100-MR-NO-REC-CHECK.
042400*
042500*
042600*
042700 0199-MR-FIELD.
042800*
042900     IF  MBD100WS-JOURNAL
043000         MOVE MTL1-VL07-B-DATA-9 TO MMFS-LAST-MAINT-DATE.
043100*
043200     MOVE 'DATE LAST MAINTENANCE '
043300                                 TO MBD100WS-PL1-DESC.
043400     MOVE MMFS-LAST-MAINT-DATE   TO SS01WS-JULIAN.
043500     PERFORM 8100-FROM-DATE      THRU 8199-FD-EXIT.
043600     MOVE MTL1-VL07-A-DATA-9     TO MMFS-LAST-MAINT-DATE.
043700     MOVE MMFS-LAST-MAINT-DATE   TO SS01WS-JULIAN.
043800     PERFORM 8200-TO-DATE        THRU 8299-TD-EXIT.
043900     GO TO 5100-MR-NO-REC-CHECK.
044000*
044100*
044200*
044300 0202-MR-FIELD.
044400*
044500     SET X-MMFS-STORE            TO MTL1-FIELD-OCCURRENCE.
044600*
044700     IF  MBD100WS-JOURNAL
044800         MOVE MTL1-VL01-B-DATA-9 TO MMFS-ST-FIELD-ATTR
044900                                    (X-MMFS-STORE).
045000*
045100     MOVE 'STORE FIELD ATTRIBUTE '
045200                                 TO MBD100WS-PL1-DESC.
045300     MOVE MMFS-ST-FIELD-ATTR
045400          (X-MMFS-STORE)         TO MBD100WS-PL1-FV-9.
045500     MOVE MTL1-VL01-A-DATA-9     TO MMFS-ST-FIELD-ATTR
045600                                    (X-MMFS-STORE).
045700     MOVE MMFS-ST-FIELD-ATTR
045800          (X-MMFS-STORE)         TO MBD100WS-PL2-TV-9.
045900     GO TO 5100-MR-NO-REC-CHECK.
046000*
046100*
046200*
046300 0203-MR-FIELD.
046400*
046500     SET X-MMFS-STORE            TO MTL1-FIELD-OCCURRENCE.
046600*
046700     IF  MBD100WS-JOURNAL
046800         MOVE MTL1-VL01-B-DATA-X TO MMFS-ST-AUDIT-CODE
046900                                    (X-MMFS-STORE).
047000*
047100     MOVE 'STORE AUDIT CODE      '
047200                                 TO MBD100WS-PL1-DESC.
047300     MOVE MMFS-ST-AUDIT-CODE
047400          (X-MMFS-STORE)         TO MBD100WS-PL1-FROM-VALUE.
047500     MOVE MTL1-VL01-A-DATA-X     TO MMFS-ST-AUDIT-CODE
047600                                    (X-MMFS-STORE).
047700     MOVE MMFS-ST-AUDIT-CODE
047800          (X-MMFS-STORE)         TO MBD100WS-PL2-TO-VALUE.
047900     GO TO 5100-MR-NO-REC-CHECK.
048000*
048100*
048200*
048300 5100-MR-NO-REC-CHECK.
048400*
048500     IF  MBD100WS-UPDATE
048600     AND MBD100WS-IO-NO-REC-FOUND
048700         MOVE '*** ERROR - NO RECORD FOUND ***'
048800                                 TO MBD100WS-PL2-TO-VALUE.
048900*
049000 5999-MR-EXIT.
049100     EXIT.
049200/
049300 8100-FROM-DATE SECTION.
049400 8110-FD-BEGIN.
049500*
049600     MOVE SS01WS-JULIAN          TO MBD100WS-PL1-FV-JULIAN.
049700     PERFORM SS26PD-NUMERICALLY-EDIT-DATE
049800        THRU SS26PD-NED-EXIT.
049900     MOVE SS01WS-XX-XX-YYYY      TO MBD100WS-PL1-FV-DATE.
050000     INSPECT MBD100WS-PL1-FV-JULIAN REPLACING ALL ',' BY '-'.
050100*
050200 8199-FD-EXIT.
050300     EXIT.
050400*
050500*
050600*
050700 8200-TO-DATE SECTION.
050800 8210-TD-BEGIN.
050900*
051000     MOVE SS01WS-JULIAN          TO MBD100WS-PL2-TV-JULIAN.
051100     PERFORM SS26PD-NUMERICALLY-EDIT-DATE
051200        THRU SS26PD-NED-EXIT.
051300     MOVE SS01WS-XX-XX-YYYY      TO MBD100WS-PL2-TV-DATE.
051400     INSPECT MBD100WS-PL2-TV-JULIAN REPLACING ALL ',' BY '-'.
051500*
051600 8299-TD-EXIT.
051700     EXIT.
051800/
051900 9000-PERFORMED-ROUTINES-SECT SECTION.
052000*
052100     COPY MB00PD REPLACING ==:MB00:== BY ==MMFS==.
052200/
052300     COPY SS95PD.
052400/
052500     COPY MB99PD.
052600/
052700     COPY SS02PD.
052800/
052900     COPY SS07PD.
053000/
053100     COPY SS08PD.
053200/
053300     COPY SS26PD.
053400/
053500     COPY SS27PD.
053600*
053700 9995-END-SOURCE-STATEMENTS SECTION.
053800 9999-END-OF-PROGRAM.
053900     EXIT.
