000100 IDENTIFICATION DIVISION.
000200 PROGRAM-ID. MBD100MM.
000201*       RELEASE DATE=08/24/01.        REVISION LEVEL=08.06      * ++++++++
000202***************************************************************** ++++++++
000203*WARNING.  THIS COMPUTER PROGRAM IS PROTECTED BY COPYRIGHT LAW  * ++++++++
000204*AND INTERNATIONAL TREATIES.  UNAUTHORIZED REPRODUCTION OR      * ++++++++
000205*DISTRIBUTION OF THIS PROGRAM, OR ANY PORTION OF IT, MAY RESULT * ++++++++
000206*IN SEVERE CIVIL AND CRIMINAL PENATLIES, AND WILL BE PROSECUTED * ++++++++
000207*TO THE MAXIMUM EXTENT POSSIBLE UNDER THE LAW.                  * ++++++++
000208*COPYRIGHT 1999 PAYSYS INTERNATIONAL, INC.  ALL RIGHTS RESERVED.* ++++++++
000209***************************************************************** ++++++++
000300*****************************************************************
000400*                                                               *
000500*   V - PLUS  M E R C H A N T   B A N K C A R D   S Y S T E M   *
000600*                                                               *
000700*     MBD100MM - MERCHANT MASTER RECOVERY AND                   *
000800*                NON-MONETARY REPORTS                           *
000900*                                                               *
001000*****************************************************************
001100 ENVIRONMENT DIVISION.
001200 CONFIGURATION SECTION.
001300 SOURCE-COMPUTER.            IBM-4341.
001400 OBJECT-COMPUTER.            IBM-4341.
001500/
001600 INPUT-OUTPUT SECTION.
001700*
001800 FILE-CONTROL.
001900/
002000 DATA DIVISION.
002100 FILE SECTION.
002200/
002300 WORKING-STORAGE SECTION.
002400*
002500 01  FILLER                  PIC  X(12)      VALUE '** WS-BEG **'.
002600*
002700     COPY MMMMRL.
002800/
002900     COPY MMMMIO.
003000/
003100     COPY MB00RB REPLACING ==:MB00:== BY ==MMMM==.
003200/
003300     COPY MMMMIR.
003400/
003500     COPY MML1WS REPLACING ==:MML1:== BY ==MTL1==.
003600/
003700     COPY MTCCRL REPLACING ==:MTCC:== BY ==MTCC==.
003800/
003900     COPY MB00WS.
004000/
004100     COPY SS95WS.
004200/
004300     COPY MB99WS.
004400/
004500     COPY SS00WS.
004600/
004700     COPY SS01WS.
004800/
004900     COPY SS02WS.
005000*
005100 01  FILLER                  PIC  X(12)      VALUE '** WS-END **'.
005200/
005300 LINKAGE SECTION.
005400     COPY MBD100WS.
005500/
005600     COPY MMSCRL.
005700/
005800     COPY MMOCRL.
005900/
006000     COPY MML1RL REPLACING ==:MML1:== BY ==MTL1==.
006100/
006200     COPY MTCCRL REPLACING ==:MTCC:== BY ==MTC1==.
006300/
006400     COPY MTCCRL REPLACING ==:MTCC:== BY ==MTC2==.
006500/
006600 PROCEDURE DIVISION              USING MBD100WS-AREA
006700                                       MMSC-RECORD
006800                                       MMOC-RECORD
006900                                       MTL1-RECORD
007000                                       MTC1-RECORD
007100                                       MTC2-RECORD.
007200*
007300 A000-MAIN-LINE-SECT SECTION.
007400 A010-ML-BEGIN.
007500*
007600     MOVE 'MBD100MM'             TO SS02WS-ABEND-PROG-ID.
007700     MOVE 'MMMM'                 TO MB99WS-FILE-ID.
007800     MOVE MMSC-TODAYS-JULIAN     TO MB99WS-PROC-DATE.
007900     MOVE MMSC-TIME-STAMP        TO MB99WS-PROC-TIME.
008000*
008100     IF  MBD100WS-OPEN-FILE
008200         SET SS95WS-FUNCTION-INITIALIZE
008300                                 TO TRUE
008400         PERFORM SS95PD-NAP-ROUTINE
008500            THRU SS95PD-NAP-EXIT
008600         PERFORM O000-OPEN-FILE
008700            THRU O999-OF-EXIT.
008800*
008900     IF  MBD100WS-CLOSE-FILE
009000         PERFORM C000-CLOSE-FILE
009100            THRU C999-CF-EXIT.
009200*
009300     IF  MBD100WS-PROCESS-RECORD
009400         PERFORM P000-PROCESS-RECORD
009500            THRU P099-PR-EXIT.
009600*
009700     GOBACK.
009800*
009900 A999-ML-EXIT.
010000     EXIT.
010100/
010200 C000-CLOSE-FILE SECTION.
010300 C010-CF-BEGIN.
010400*
010500     MOVE 'C1MM'                 TO SS02WS-ABEND-LOCATION.
010600     SET MMMMRB-CLOSE            TO TRUE.
010700     PERFORM MB00PD-MMMM-ACCESS
010800        THRU MB00PD-MMMM-ACCESS-EXIT.
010900*
011000 C999-CF-EXIT.
011100     EXIT.
011200/
011300 O000-OPEN-FILE SECTION.
011400 O010-OF-BEGIN.
011500*
011600     MOVE MMSC-DATE-FORMAT       TO SS01WS-DATE-FORMAT.
011700*
011800     MOVE 'O1MM'                 TO SS02WS-ABEND-LOCATION.
011900*
012000     IF  MBD100WS-UPDATE
012100         SET MMMMRB-OPEN-IO-DYN  TO TRUE
012200     ELSE
012300         SET MMMMRB-OPEN-INPUT-DYN
012400                                 TO TRUE.
012500*
012600     PERFORM MB00PD-MMMM-ACCESS
012700        THRU MB00PD-MMMM-ACCESS-EXIT.
012800*
012900     MOVE 'R0MM'                 TO SS02WS-ABEND-LOCATION.
013000     SET MMMMRB-READ-SEQ         TO TRUE.
013100     PERFORM MB00PD-MMMM-ACCESS
013200        THRU MB00PD-MMMM-ACCESS-EXIT.
013300     MOVE 'MMMM'                 TO MB99WS-FILE-ID.
013400*
013500     IF  MMMMIO-HEADER
013600         NEXT SENTENCE
013700     ELSE
013800         PERFORM MB99PD-MISSING-HEADER-ABEND
013900            THRU MB99PD-MHA-EXIT.
014000*
014100     MOVE MMMMIO-DATE-STAMP      TO MB99WS-FILE-DATE.
014200     MOVE MMMMIO-TIME-STAMP      TO MB99WS-FILE-TIME.
014300     PERFORM MB99PD-CHECK-DATE-TIME
014400        THRU MB99PD-CDT-EXIT.
014500*
014600     PERFORM Z900-INIT-RECORD
014700        THRU Z999-IR-EXIT.
014800*
014900 O999-OF-EXIT.
015000     EXIT.
015100/
015200 P000-PROCESS-RECORD SECTION.
015300 P010-PR-BEGIN.
015400*
015500     MOVE MMOC-CURRENCY-CODE     TO SS95WS-CURRENCY-CODE.
015600*
015700     IF  MTL1-MMMM-KEY IS NOT EQUAL TO MMMM-KEY
015800         PERFORM P500-FILE-UPDATE
015900            THRU P599-FU-EXIT.
016000*
016100     IF  MTL1-TOTALS-RECORD
016200         GO TO P099-PR-EXIT.
016300*
016400     IF  MTL1-MMMM-KEY IS NOT EQUAL TO MMMM-KEY
016500         PERFORM P700-GET-RECORD-TO-UPDATE
016600            THRU P799-GRTU-EXIT.
016700*
016800     MOVE MTL1-FIELD-CODE        TO MBD100WS-FIELD-CODE.
016900*
017000     IF (MBD100WS-FC-1-2-ADD AND MBD100WS-FC-3-4-ADD)
017100     OR (MBD100WS-FC-1-2-REP AND MBD100WS-FC-3-4-REP)
017200         PERFORM U000-NEW-RECORD
017300            THRU U099-NR-EXIT
017400     ELSE
017500         PERFORM 0000-MAINT-RECORD
017600            THRU 5999-MR-EXIT.
017700*
017800 P099-PR-EXIT.
017900     EXIT.
018000/
018100 P500-FILE-UPDATE SECTION.
018200 P510-FU-BEGIN.
018300*
018400     IF  MBD100WS-JOURNAL
018500         GO TO P599-FU-EXIT.
018600*
018700     IF  MMMM-KEY IS EQUAL TO MMMMIR-KEY
018800         GO TO P599-FU-EXIT.
018900*
019000     IF  MBD100WS-IO-REWRITE
019100         MOVE MMMM-RECORD        TO MMMMIO-RECORD
019200         MOVE SS02WS-NO-RECORD-FOUND
019300                                 TO MMMMRB-TEMP-STATUS-1
019400         MOVE 'U1MM'             TO SS02WS-ABEND-LOCATION
019500         SET MMMMRB-REWRITE      TO TRUE
019600         PERFORM MB00PD-MMMM-ACCESS
019700            THRU MB00PD-MMMM-ACCESS-EXIT
019800         IF  SS02WS-FS-NO-RECORD-FOUND
019900             MOVE 'W'            TO MBD100WS-IO-SW.
020000*
020100     IF  MBD100WS-IO-NO-REC-FOUND
020200     OR  MBD100WS-IO-WRITE
020300         MOVE MMMM-RECORD        TO MMMMIO-RECORD
020400         MOVE SS02WS-DUPLICATE-RECORD
020500                                 TO MMMMRB-TEMP-STATUS-1
020600         MOVE 'W2MM'             TO SS02WS-ABEND-LOCATION
020700         SET MMMMRB-WRITE        TO TRUE
020800         PERFORM MB00PD-MMMM-ACCESS
020900            THRU MB00PD-MMMM-ACCESS-EXIT
021000         IF  SS02WS-FS-DUPLICATE-RECORD
021100             MOVE 'U'            TO MBD100WS-IO-SW
021200             MOVE MMMM-RECORD    TO MMMMIO-RECORD
021300             MOVE 'U2MM'         TO SS02WS-ABEND-LOCATION
021400             SET MMMMRB-REWRITE  TO TRUE
021500             PERFORM MB00PD-MMMM-ACCESS
021600                THRU MB00PD-MMMM-ACCESS-EXIT.
021700*
021800     PERFORM Z900-INIT-RECORD
021900        THRU Z999-IR-EXIT.
022000*
022100 P599-FU-EXIT.
022200     EXIT.
022300/
022400 P700-GET-RECORD-TO-UPDATE SECTION.
022500 P710-GRTU-BEGIN.
022600*
022700     IF  MBD100WS-JOURNAL
022800         PERFORM Z900-INIT-RECORD
022900            THRU Z999-IR-EXIT
023000         GO TO P799-GRTU-EXIT.
023100*
023200     MOVE SS02WS-NO-RECORD-FOUND
023300                                 TO MMMMRB-TEMP-STATUS-1.
023400     MOVE MTL1-MMMM-KEY          TO MMMMIO-KEY.
023500*
023600     MOVE 'R1MM'                 TO SS02WS-ABEND-LOCATION.
023700     SET MMMMRB-READ-RANDOM      TO TRUE.
023800     PERFORM MB00PD-MMMM-ACCESS
023900        THRU MB00PD-MMMM-ACCESS-EXIT.
024000*
024100     IF  SS02WS-FS-NO-RECORD-FOUND
024200         PERFORM Z900-INIT-RECORD
024300            THRU Z999-IR-EXIT
024400         MOVE 'N'                TO MBD100WS-IO-SW
024500     ELSE
024600         MOVE MMMMIO-RECORD      TO MMMM-RECORD
024700         MOVE 'U'                TO MBD100WS-IO-SW.
024800*
024900 P799-GRTU-EXIT.
025000     EXIT.
025100/
025200 U000-NEW-RECORD SECTION.
025300 U010-NR-BEGIN.
025400*
025500     PERFORM Z100-COMMON-FROM-DATA
025600        THRU Z199-CFD-EXIT.
025700*
025800     PERFORM Z200-COMMON-TO-DATA
025900        THRU Z299-CTD-EXIT.
026000*
026100     MOVE MTL1-ADD-AREA          TO MMMM-RECORD.
026200*
026300     IF  MBD100WS-IO-NO-REC-FOUND
026400         MOVE 'W'                TO MBD100WS-IO-SW.
026500*
026600     IF  MBD100WS-FC-1-2-ADD
026700         MOVE '*** NEW RECORD ADDED ***'
026800                                 TO MBD100WS-PL2-TO-VALUE
026900                                    MBD100WS-PL1-FROM-VALUE
027000     ELSE
027100         MOVE '*** REPLACEMENT RECORD ***'
027200                                 TO MBD100WS-PL2-TO-VALUE
027300                                    MBD100WS-PL1-FROM-VALUE.
027400*
027500     MOVE SPACES                 TO MTCC-RECORD.
027600     MOVE MMMM-ORG               TO MTCC-MBU913-BEG-ORG.
027700     MOVE MMMM-MERCHANT          TO MTCC-MBU913-BEG-MERCHANT.
027800     MOVE 'MBU913'               TO MTCC-PROGRAM-ID.
027900     MOVE MTCC-RECORD            TO MTC1-RECORD.
028000*
028100 U099-NR-EXIT.
028200     EXIT.
028300/
028400 Z100-COMMON-FROM-DATA SECTION.
028500 Z110-CFD-BEGIN.
028600*
028700     MOVE MTL1-MMMM-MERCHANT     TO MBD100WS-PL1-MERCHANT.
028800*
028900 Z199-CFD-EXIT.
029000     EXIT.
029100/
029200 Z200-COMMON-TO-DATA SECTION.
029300 Z210-CTD-BEGIN.
029400*
029500 Z299-CTD-EXIT.
029600     EXIT.
029700/
029800 Z900-INIT-RECORD SECTION.
029900 Z910-IR-BEGIN.
030000*
030100     MOVE MMMMIR-RECORD          TO MMMM-RECORD.
030200     MOVE SPACES                 TO MTC1-RECORD.
030300     MOVE SPACES                 TO MTC2-RECORD.
030400*
030500 Z999-IR-EXIT.
030600     EXIT.
030700/
030800 0000-MAINT-RECORD SECTION.
030900 0010-MR-BEGIN.
031000*
031100     PERFORM Z100-COMMON-FROM-DATA
031200        THRU Z199-CFD-EXIT.
031300*
031400     PERFORM Z200-COMMON-TO-DATA
031500        THRU Z299-CTD-EXIT.
031600*
031700     IF  MTL1-FIELD-CODE IS EQUAL TO 0101
031800         GO TO 0101-MR-FIELD.
031900*
032000     IF  MTL1-FIELD-CODE IS EQUAL TO 0102
032100         GO TO 0102-MR-FIELD.
032200*
032300     IF  MTL1-FIELD-CODE IS EQUAL TO 0103
032400         GO TO 0103-MR-FIELD.
032500*
032600     IF  MTL1-FIELD-CODE IS EQUAL TO 0104
032700         GO TO 0104-MR-FIELD.
032800*
032900     IF  MTL1-FIELD-CODE IS EQUAL TO 0105
033000         GO TO 0105-MR-FIELD.
033100*
033200     IF  MTL1-FIELD-CODE IS EQUAL TO 0106
033300         GO TO 0106-MR-FIELD.
033400*
033500     IF  MTL1-FIELD-CODE IS EQUAL TO 0107
033600         GO TO 0107-MR-FIELD.
033700*
033800     IF  MTL1-FIELD-CODE IS EQUAL TO 0108
033900         GO TO 0108-MR-FIELD.
034000*
034100     IF  MTL1-FIELD-CODE IS EQUAL TO 0109
034200         GO TO 0109-MR-FIELD.
034300*
034400     IF  MTL1-FIELD-CODE IS EQUAL TO 0110
034500         GO TO 0110-MR-FIELD.
034600*
034700     IF  MTL1-FIELD-CODE IS EQUAL TO 0190
034800         GO TO 0190-MR-FIELD.
034900*
035000     IF  MTL1-FIELD-CODE IS EQUAL TO 0191
035100         GO TO 0191-MR-FIELD.
035200*
035300     IF  MTL1-FIELD-CODE IS EQUAL TO 0192
035400         GO TO 0192-MR-FIELD.
035500*
035600     IF  MTL1-FIELD-CODE IS EQUAL TO 0193
035700         GO TO 0193-MR-FIELD.
035800*
035900     IF  MTL1-FIELD-CODE IS EQUAL TO 0194
036000         GO TO 0194-MR-FIELD.
036100*
036200     IF  MTL1-FIELD-CODE IS EQUAL TO 0195
036300         GO TO 0195-MR-FIELD.
036400*
036500     IF  MTL1-FIELD-CODE IS EQUAL TO 0196
036600         GO TO 0196-MR-FIELD.
036700*
036800     IF  MTL1-FIELD-CODE IS EQUAL TO 0197
036900         GO TO 0197-MR-FIELD.
037000*
037100     IF  MTL1-FIELD-CODE IS EQUAL TO 0198
037200         GO TO 0198-MR-FIELD.
037300*
037400     IF  MTL1-FIELD-CODE IS EQUAL TO 0199
037500         GO TO 0199-MR-FIELD.
037600*
037700     IF  MTL1-FIELD-CODE IS EQUAL TO 0301
037800         GO TO 0301-MR-FIELD.
037900*
038000     IF  MTL1-FIELD-CODE IS EQUAL TO 0302
038100         GO TO 0302-MR-FIELD.
038200*
038300     IF  MTL1-FIELD-CODE IS EQUAL TO 0303
038400         GO TO 0303-MR-FIELD.
038500*
038600     IF  MTL1-FIELD-CODE IS EQUAL TO 0304
038700         GO TO 0304-MR-FIELD.
038800*
038900     IF  MTL1-FIELD-CODE IS EQUAL TO 0305
039000         GO TO 0305-MR-FIELD.
039100*
039200     IF  MTL1-FIELD-CODE IS EQUAL TO 0306
039300         GO TO 0306-MR-FIELD.
039400*
039500     IF  MTL1-FIELD-CODE IS EQUAL TO 0307
039600         GO TO 0307-MR-FIELD.
039700*
039800     IF  MTL1-FIELD-CODE IS EQUAL TO 0308
039900         GO TO 0308-MR-FIELD.
040000*
040100     IF  MTL1-FIELD-CODE IS EQUAL TO 0309
040200         GO TO 0309-MR-FIELD.
040300*
040400     IF  MTL1-FIELD-CODE IS EQUAL TO 0310
040500         GO TO 0310-MR-FIELD.
040600*
040700     IF  MTL1-FIELD-CODE IS EQUAL TO 0311
040800         GO TO 0311-MR-FIELD.
040900*
041000     IF  MTL1-FIELD-CODE IS EQUAL TO 0312
041100         GO TO 0312-MR-FIELD.
041200*
041300     IF  MTL1-FIELD-CODE IS EQUAL TO 0313
041400         GO TO 0313-MR-FIELD.
041500*
041600     IF  MTL1-FIELD-CODE IS EQUAL TO 0314
041700         GO TO 0314-MR-FIELD.
041800*
041900     IF  MTL1-FIELD-CODE IS EQUAL TO 0315
042000         GO TO 0315-MR-FIELD.
042100*
042200     IF  MTL1-FIELD-CODE IS EQUAL TO 0316
042300         GO TO 0316-MR-FIELD.
042400*
042500     IF  MTL1-FIELD-CODE IS EQUAL TO 0317
042600         GO TO 0317-MR-FIELD.
042700*
042800     IF  MTL1-FIELD-CODE IS EQUAL TO 0318
042900         GO TO 0318-MR-FIELD.
043000*
043100     IF  MTL1-FIELD-CODE IS EQUAL TO 0319
043200         GO TO 0319-MR-FIELD.
043300*
043400     IF  MTL1-FIELD-CODE IS EQUAL TO 0320
043500         GO TO 0320-MR-FIELD.
043600*
043700     IF  MTL1-FIELD-CODE IS EQUAL TO 0321
043800         GO TO 0321-MR-FIELD.
043900*
044000     IF  MTL1-FIELD-CODE IS EQUAL TO 0322
044100         GO TO 0322-MR-FIELD.
044200*
044300     IF  MTL1-FIELD-CODE IS EQUAL TO 0323
044400         GO TO 0323-MR-FIELD.
044500*
044600     IF  MTL1-FIELD-CODE IS EQUAL TO 0324
044700         GO TO 0324-MR-FIELD.
044800*
044900     IF  MTL1-FIELD-CODE IS EQUAL TO 0325
045000         GO TO 0325-MR-FIELD.
045100*
045200     IF  MTL1-FIELD-CODE IS EQUAL TO 0326
045300         GO TO 0326-MR-FIELD.
045400*
045500     IF  MTL1-FIELD-CODE IS EQUAL TO 0327
045600         GO TO 0327-MR-FIELD.
045700*
045800     IF  MTL1-FIELD-CODE IS EQUAL TO 0328
045900         GO TO 0328-MR-FIELD.
046000*
046100     IF  MTL1-FIELD-CODE IS EQUAL TO 0329
046200         GO TO 0329-MR-FIELD.
046300*
046400     IF  MTL1-FIELD-CODE IS EQUAL TO 0330
046500         GO TO 0330-MR-FIELD.
046600*
046700     IF  MTL1-FIELD-CODE IS EQUAL TO 0331
046800         GO TO 0331-MR-FIELD.
046900     IF  MTL1-FIELD-CODE IS EQUAL TO 0332
047000         GO TO 0332-MR-FIELD.
047100*
047200     IF  MTL1-FIELD-CODE IS EQUAL TO 0333
047300         GO TO 0333-MR-FIELD.
047400*
047500     IF  MTL1-FIELD-CODE IS EQUAL TO 0401
047600         GO TO 0401-MR-FIELD.
047700*
047800     IF  MTL1-FIELD-CODE IS EQUAL TO 0402
047900         GO TO 0402-MR-FIELD.
048000*
048100     IF  MTL1-FIELD-CODE IS EQUAL TO 0403
048200         GO TO 0403-MR-FIELD.
048300*
048400     IF  MTL1-FIELD-CODE IS EQUAL TO 0404
048500         GO TO 0404-MR-FIELD.
048600*
048700     IF  MTL1-FIELD-CODE IS EQUAL TO 0405
048800         GO TO 0405-MR-FIELD.
048900*
049000     IF  MTL1-FIELD-CODE IS EQUAL TO 0406
049100         GO TO 0406-MR-FIELD.
049200*
049300     IF  MTL1-FIELD-CODE IS EQUAL TO 0407
049400         GO TO 0407-MR-FIELD.
049500*
049600     IF  MTL1-FIELD-CODE IS EQUAL TO 0408
049700         GO TO 0408-MR-FIELD.
049800*
049900     IF  MTL1-FIELD-CODE IS EQUAL TO 0409
050000         GO TO 0409-MR-FIELD.
050100*
050200     IF  MTL1-FIELD-CODE IS EQUAL TO 0410
050300         GO TO 0410-MR-FIELD.
050400*
050500     IF  MTL1-FIELD-CODE IS EQUAL TO 0501
050600         GO TO 0501-MR-FIELD.
050700*
050800     IF  MTL1-FIELD-CODE IS EQUAL TO 0502
050900         GO TO 0502-MR-FIELD.
051000*
051100     IF  MTL1-FIELD-CODE IS EQUAL TO 0503
051200         GO TO 0503-MR-FIELD.
051300*
051400     IF  MTL1-FIELD-CODE IS EQUAL TO 0504
051500         GO TO 0504-MR-FIELD.
051600*
051700     IF  MTL1-FIELD-CODE IS EQUAL TO 0505
051800         GO TO 0505-MR-FIELD.
051900*
052000     IF  MTL1-FIELD-CODE IS EQUAL TO 0506
052100         GO TO 0506-MR-FIELD.
052200*
052300     IF  MTL1-FIELD-CODE IS EQUAL TO 0507
052400         GO TO 0507-MR-FIELD.
052500*
052600     IF  MTL1-FIELD-CODE IS EQUAL TO 0508
052700         GO TO 0508-MR-FIELD.
052800*
052900     IF  MTL1-FIELD-CODE IS EQUAL TO 0509
053000         GO TO 0509-MR-FIELD.
053100*
053200     IF  MTL1-FIELD-CODE IS EQUAL TO 0510
053300         GO TO 0510-MR-FIELD.
053400*
053500     IF  MTL1-FIELD-CODE IS EQUAL TO 0511
053600         GO TO 0511-MR-FIELD.
053700*
053800     IF  MTL1-FIELD-CODE IS EQUAL TO 0701
053900         GO TO 0701-MR-FIELD.
054000*
054100     IF  MTL1-FIELD-CODE IS EQUAL TO 0702
054200         GO TO 0702-MR-FIELD.
054300*
054400     IF  MTL1-FIELD-CODE IS EQUAL TO 0703
054500         GO TO 0703-MR-FIELD.
054600*
054700     IF  MTL1-FIELD-CODE IS EQUAL TO 0704
054800         GO TO 0704-MR-FIELD.
054900*
055000     IF  MTL1-FIELD-CODE IS EQUAL TO 0705
055100         GO TO 0705-MR-FIELD.
055200*
055300     IF  MTL1-FIELD-CODE IS EQUAL TO 0706
055400         GO TO 0706-MR-FIELD.
055500*
055600     IF  MTL1-FIELD-CODE IS EQUAL TO 0707
055700         GO TO 0707-MR-FIELD.
055800*
055900     IF  MTL1-FIELD-CODE IS EQUAL TO 0708
056000         GO TO 0708-MR-FIELD.
056100*
056200     IF  MTL1-FIELD-CODE IS EQUAL TO 0801
056300         GO TO 0801-MR-FIELD.
056400*
056500     IF  MTL1-FIELD-CODE IS EQUAL TO 0802
056600         GO TO 0802-MR-FIELD.
056700*
056800     IF  MTL1-FIELD-CODE IS EQUAL TO 0803
056900         GO TO 0803-MR-FIELD.
057000*
057100     IF  MTL1-FIELD-CODE IS EQUAL TO 0804
057200         GO TO 0804-MR-FIELD.
057300*
057400     IF  MTL1-FIELD-CODE IS EQUAL TO 0805
057500         GO TO 0805-MR-FIELD.
057600*
057700     IF  MTL1-FIELD-CODE IS EQUAL TO 0806
057800         GO TO 0806-MR-FIELD.
057900*
058000     IF  MTL1-FIELD-CODE IS EQUAL TO 0807
058100         GO TO 0807-MR-FIELD.
058200*
058300     IF  MTL1-FIELD-CODE IS EQUAL TO 0808
058400         GO TO 0808-MR-FIELD.
058500*
058600     IF  MTL1-FIELD-CODE IS EQUAL TO 0809
058700         GO TO 0809-MR-FIELD.
058800*
058900     IF  MTL1-FIELD-CODE IS EQUAL TO 0810
059000         GO TO 0810-MR-FIELD.
059100*
059200     IF  MTL1-FIELD-CODE IS EQUAL TO 0811
059300         GO TO 0811-MR-FIELD.
059400*
059500     IF  MTL1-FIELD-CODE IS EQUAL TO 0812
059600         GO TO 0812-MR-FIELD.
059700*
059800     IF  MTL1-FIELD-CODE IS EQUAL TO 0813
059900         GO TO 0813-MR-FIELD.
060000*
060100     IF  MTL1-FIELD-CODE IS EQUAL TO 0814
060200         GO TO 0814-MR-FIELD.
060300*
060400     IF  MTL1-FIELD-CODE IS EQUAL TO 0815
060500         GO TO 0815-MR-FIELD.
060600*
060700     IF  MTL1-FIELD-CODE IS EQUAL TO 0816
060800         GO TO 0816-MR-FIELD.
060900*
061000     IF  MTL1-FIELD-CODE IS EQUAL TO 0817
061100         GO TO 0817-MR-FIELD.
061200*
061300     IF  MTL1-FIELD-CODE IS EQUAL TO 0818
061400         GO TO 0818-MR-FIELD.
061500*
061600     IF  MTL1-FIELD-CODE IS EQUAL TO 0819
061700         GO TO 0819-MR-FIELD.
061800*
061900     IF  MTL1-FIELD-CODE IS EQUAL TO 0820
062000         GO TO 0820-MR-FIELD.
062100*
062200     IF  MTL1-FIELD-CODE IS EQUAL TO 0821
062300         GO TO 0821-MR-FIELD.
062400*
062500     IF  MTL1-FIELD-CODE IS EQUAL TO 0822
062600         GO TO 0822-MR-FIELD.
062700*
062800     IF  MTL1-FIELD-CODE IS EQUAL TO 0823
062900         GO TO 0823-MR-FIELD.
063000*
063100     IF  MTL1-FIELD-CODE IS EQUAL TO 0824
063200         GO TO 0824-MR-FIELD.
063300     IF  MTL1-FIELD-CODE IS EQUAL TO 0825
063400         GO TO 0825-MR-FIELD.
063500*
063600     IF  MTL1-FIELD-CODE IS EQUAL TO 0826
063700         GO TO 0826-MR-FIELD.
063800*
063900     IF  MTL1-FIELD-CODE IS EQUAL TO 0827
064000         GO TO 0827-MR-FIELD.
064100*
064200     IF  MTL1-FIELD-CODE IS EQUAL TO 0828
064300         GO TO 0828-MR-FIELD.
064400*
064500     IF  MTL1-FIELD-CODE IS EQUAL TO 0829
064600         GO TO 0829-MR-FIELD.
064700*
064800     IF  MTL1-FIELD-CODE IS EQUAL TO 0830
064900         GO TO 0830-MR-FIELD.
064910*                                                                 RG802901
064920     IF  MTL1-FIELD-CODE IS EQUAL TO 0831                         RG802901
064930         GO TO 0831-MR-FIELD.                                     RG802901
065000*
065100     IF  MTL1-FIELD-CODE IS EQUAL TO 0901
065200         GO TO 0901-MR-FIELD.
065300*
065400     IF  MTL1-FIELD-CODE IS EQUAL TO 0902
065500         GO TO 0902-MR-FIELD.
065600*
065700     IF  MTL1-FIELD-CODE IS EQUAL TO 0903
065800         GO TO 0903-MR-FIELD.
065900*
066000     IF  MTL1-FIELD-CODE IS EQUAL TO 0904
066100         GO TO 0904-MR-FIELD.
066200*
066300     IF  MTL1-FIELD-CODE IS EQUAL TO 0905
066400         GO TO 0905-MR-FIELD.
066500*
066600     IF  MTL1-FIELD-CODE IS EQUAL TO 0906
066700         GO TO 0906-MR-FIELD.
066800*
066900     IF  MTL1-FIELD-CODE IS EQUAL TO 0907
067000         GO TO 0907-MR-FIELD.
067100*
067200     IF  MTL1-FIELD-CODE IS EQUAL TO 0908
067300         GO TO 0908-MR-FIELD.
067400*
067500     IF  MTL1-FIELD-CODE IS EQUAL TO 0909
067600         GO TO 0909-MR-FIELD.
067700*
067800     IF  MTL1-FIELD-CODE IS EQUAL TO 0910
067900         GO TO 0910-MR-FIELD.
068000*
068100     IF  MTL1-FIELD-CODE IS EQUAL TO 1001
068200         GO TO 1001-MR-FIELD.
068300*
068400     IF  MTL1-FIELD-CODE IS EQUAL TO 1002
068500         GO TO 1002-MR-FIELD.
068600*
068700     IF  MTL1-FIELD-CODE IS EQUAL TO 1003
068800         GO TO 1003-MR-FIELD.
068900*
069000     IF  MTL1-FIELD-CODE IS EQUAL TO 1004
069100         GO TO 1004-MR-FIELD.
069200*
069300     IF  MTL1-FIELD-CODE IS EQUAL TO 1005
069400         GO TO 1005-MR-FIELD.
069500*
069600     IF  MTL1-FIELD-CODE IS EQUAL TO 1006
069700         GO TO 1006-MR-FIELD.
069710*                                                                 RG800902
069712     IF  MTL1-FIELD-CODE IS EQUAL TO 1007                         RG800902
069714         GO TO 1007-MR-FIELD.                                     RG800902
069716*                                                                 RG800902
069718     IF  MTL1-FIELD-CODE IS EQUAL TO 1008                         RG800902
069720         GO TO 1008-MR-FIELD.                                     RG800902
069722*                                                                 RG800902
069724     IF  MTL1-FIELD-CODE IS EQUAL TO 1009                         RG800902
069726         GO TO 1009-MR-FIELD.                                     RG800902
069728*                                                                 RG800902
069730     IF  MTL1-FIELD-CODE IS EQUAL TO 1010                         RG800902
069732         GO TO 1010-MR-FIELD.                                     RG800902
069800*
069900     IF  MTL1-FIELD-CODE IS EQUAL TO 1101
070000         GO TO 1101-MR-FIELD.
070100*
070200     IF  MTL1-FIELD-CODE IS EQUAL TO 1102
070300         GO TO 1102-MR-FIELD.
070400*
070500     IF  MTL1-FIELD-CODE IS EQUAL TO 1103
070600         GO TO 1103-MR-FIELD.
070700*
070800     IF  MTL1-FIELD-CODE IS EQUAL TO 1104
070900         GO TO 1104-MR-FIELD.
071000*
071100     IF  MTL1-FIELD-CODE IS EQUAL TO 1105
071200         GO TO 1105-MR-FIELD.
071300*
071400     IF  MTL1-FIELD-CODE IS EQUAL TO 1106
071500         GO TO 1106-MR-FIELD.
071600*
071700     IF  MTL1-FIELD-CODE IS EQUAL TO 1201
071800         GO TO 1201-MR-FIELD.
071900*
072000     IF  MTL1-FIELD-CODE IS EQUAL TO 9010
072100         GO TO 9010-MR-FIELD.
072200*
072300     IF  MTL1-FIELD-CODE IS EQUAL TO 9011
072400         GO TO 9011-MR-FIELD.
072500*
072600     IF  MTL1-FIELD-CODE IS EQUAL TO 9012
072700         GO TO 9012-MR-FIELD.
072800*
072900     IF  MTL1-FIELD-CODE IS EQUAL TO 9013
073000         GO TO 9013-MR-FIELD.
073100*
073200     MOVE '*** ERROR - INVALID FIELD CODE ***'
073300                                 TO MBD100WS-PL2-TO-VALUE.
073400     GO TO 5999-MR-EXIT.
073500*
073600 0101-MR-FIELD.
073700*
073800     SET X-MMMM-DEMOGRAPHICS     TO MTL1-FIELD-OCCURRENCE.
073900*
074000     IF  MBD100WS-JOURNAL
074100         MOVE MTL1-VL03-B-DATA-X TO MMMM-COUNTRY-CODE
074200                                    (X-MMMM-DEMOGRAPHICS).
074300*
074400     MOVE 'COUNTRY CODE          '
074500                                 TO MBD100WS-PL1-DESC.
074600     MOVE MMMM-COUNTRY-CODE
074700          (X-MMMM-DEMOGRAPHICS)  TO MBD100WS-PL1-FROM-VALUE.
074800     MOVE MTL1-VL03-A-DATA-X     TO MMMM-COUNTRY-CODE
074900                                    (X-MMMM-DEMOGRAPHICS).
075000     MOVE MMMM-COUNTRY-CODE
075100          (X-MMMM-DEMOGRAPHICS)  TO MBD100WS-PL2-TO-VALUE.
075200     GO TO 5100-MR-NO-REC-CHECK.
075300*
075400*
075500*
075600 0102-MR-FIELD.
075700*
075800     IF  MBD100WS-JOURNAL
075900         MOVE MTL1-VL30-B-DATA-X TO MMMM-DBA-NAME.
076000*
076100     MOVE 'DBA NAME              '
076200                                 TO MBD100WS-PL1-DESC.
076300     MOVE MMMM-DBA-NAME          TO MBD100WS-PL1-FROM-VALUE.
076400     MOVE MTL1-VL30-A-DATA-X     TO MMMM-DBA-NAME.
076500     MOVE MMMM-DBA-NAME          TO MBD100WS-PL2-TO-VALUE.
076600     GO TO 5100-MR-NO-REC-CHECK.
076700*
076800*
076900*
077000 0103-MR-FIELD.
077100*
077200     IF  MBD100WS-JOURNAL
077300         MOVE MTL1-VL01-B-DATA-X TO MMMM-SINGLE-STORE-FLAG.
077400*
077500     MOVE 'SINGLE STORE FLAG     '
077600                                 TO MBD100WS-PL1-DESC.
077700     MOVE MMMM-SINGLE-STORE-FLAG TO MBD100WS-PL1-FROM-VALUE.
077800     MOVE MTL1-VL01-A-DATA-X     TO MMMM-SINGLE-STORE-FLAG.
077900     MOVE MMMM-SINGLE-STORE-FLAG TO MBD100WS-PL2-TO-VALUE.
078000     GO TO 5100-MR-NO-REC-CHECK.
078100*
078200*
078300*
078400 0104-MR-FIELD.
078500*
078600     IF  MBD100WS-JOURNAL
078700         MOVE MTL1-VL30-B-DATA-X TO MMMM-DBA-CITY.
078800*
078900     MOVE 'DBA CITY              '
079000                                 TO MBD100WS-PL1-DESC.
079100     MOVE MMMM-DBA-CITY          TO MBD100WS-PL1-FROM-VALUE.
079200     MOVE MTL1-VL30-A-DATA-X     TO MMMM-DBA-CITY.
079300     MOVE MMMM-DBA-CITY          TO MBD100WS-PL2-TO-VALUE.
079400     GO TO 5100-MR-NO-REC-CHECK.
079500*
079600*
079700*
079800 0105-MR-FIELD.
079900*
080000     IF  MBD100WS-JOURNAL
080100         MOVE MTL1-VL03-B-DATA-X TO MMMM-DBA-COUNTRY-CODE.
080200*
080300     MOVE 'DBA COUNTRY CODE      '
080400                                 TO MBD100WS-PL1-DESC.
080500     MOVE MMMM-DBA-COUNTRY-CODE  TO MBD100WS-PL1-FROM-VALUE.
080600     MOVE MTL1-VL03-A-DATA-X     TO MMMM-DBA-COUNTRY-CODE.
080700     MOVE MMMM-DBA-COUNTRY-CODE  TO MBD100WS-PL2-TO-VALUE.
080800     GO TO 5100-MR-NO-REC-CHECK.
080900*
081000*
081100*
081200 0106-MR-FIELD.
081300*
081400     SET X-MMMM-DEMOGRAPHICS     TO MTL1-FIELD-OCCURRENCE.
081500     SET X-MMMM-NA               TO MTL1-FIELD-OCCURRENCE-2.
081600*
081700     IF  MBD100WS-JOURNAL
081800         MOVE MTL1-VL40-B-DATA-X TO MMMM-NA-LINE
081900                                    (X-MMMM-DEMOGRAPHICS
082000                                     X-MMMM-NA).
082100*
082200     MOVE 'NAME/ADDRESS LINE     '
082300                                 TO MBD100WS-PL1-DESC.
082400     MOVE MMMM-NA-LINE
082500          (X-MMMM-DEMOGRAPHICS X-MMMM-NA)
082600                                 TO MBD100WS-PL1-FROM-VALUE.
082700     MOVE MTL1-VL40-A-DATA-X     TO MMMM-NA-LINE
082800                                    (X-MMMM-DEMOGRAPHICS
082900                                     X-MMMM-NA).
083000     MOVE MMMM-NA-LINE
083100          (X-MMMM-DEMOGRAPHICS X-MMMM-NA)
083200                                 TO MBD100WS-PL2-TO-VALUE.
083300     GO TO 5100-MR-NO-REC-CHECK.
083400*
083500*
083600*
083700 0107-MR-FIELD.
083800*
083900     SET X-MMMM-DEMOGRAPHICS     TO MTL1-FIELD-OCCURRENCE.
084000*
084100     IF  MBD100WS-JOURNAL
084200         MOVE MTL1-VL03-B-DATA-X TO MMMM-STATE-CODE
084300                                    (X-MMMM-DEMOGRAPHICS).
084400*
084500     MOVE 'STATE/PROVINCE CODE   '
084600                                 TO MBD100WS-PL1-DESC.
084700     MOVE MMMM-STATE-CODE
084800          (X-MMMM-DEMOGRAPHICS)  TO MBD100WS-PL1-FROM-VALUE.
084900     MOVE MTL1-VL03-A-DATA-X     TO MMMM-STATE-CODE
085000                                    (X-MMMM-DEMOGRAPHICS).
085100     MOVE MMMM-STATE-CODE
085200          (X-MMMM-DEMOGRAPHICS)  TO MBD100WS-PL2-TO-VALUE.
085300     GO TO 5100-MR-NO-REC-CHECK.
085400*
085500*
085600*
085700 0108-MR-FIELD.
085800*
085900     SET X-MMMM-DEMOGRAPHICS     TO MTL1-FIELD-OCCURRENCE.
086000*
086100     IF  MBD100WS-JOURNAL
086200         MOVE MTL1-VL20-B-DATA-X TO MMMM-PHONE
086300                                    (X-MMMM-DEMOGRAPHICS).
086400*
086500     MOVE 'PHONE NUMBER          '
086600                                 TO MBD100WS-PL1-DESC.
086700     MOVE MMMM-PHONE
086800          (X-MMMM-DEMOGRAPHICS)  TO MBD100WS-PL1-FROM-VALUE.
086900     MOVE MTL1-VL20-A-DATA-X     TO MMMM-PHONE
087000                                    (X-MMMM-DEMOGRAPHICS).
087100     MOVE MMMM-PHONE
087200          (X-MMMM-DEMOGRAPHICS)  TO MBD100WS-PL2-TO-VALUE.
087300     GO TO 5100-MR-NO-REC-CHECK.
087400*
087500*
087600*
087700 0109-MR-FIELD.
087800*
087900     SET X-MMMM-DEMOGRAPHICS     TO MTL1-FIELD-OCCURRENCE.
088000*
088100     IF  MBD100WS-JOURNAL
088200         MOVE MTL1-VL10-B-DATA-X TO MMMM-POSTAL-CODE
088300                                    (X-MMMM-DEMOGRAPHICS).
088400*
088500     MOVE 'POSTAL CODE           '
088600                                 TO MBD100WS-PL1-DESC.
088700     MOVE MMMM-POSTAL-CODE
088800          (X-MMMM-DEMOGRAPHICS)  TO MBD100WS-PL1-FROM-VALUE.
088900     MOVE MTL1-VL10-A-DATA-X     TO MMMM-POSTAL-CODE
089000                                    (X-MMMM-DEMOGRAPHICS).
089100     MOVE MMMM-POSTAL-CODE
089200          (X-MMMM-DEMOGRAPHICS)  TO MBD100WS-PL2-TO-VALUE.
089300     GO TO 5100-MR-NO-REC-CHECK.
089400*
089500*
089600*
089700 0110-MR-FIELD.
089800*
089900     SET X-MMMM-DEMOGRAPHICS     TO MTL1-FIELD-OCCURRENCE.
090000*
090100     IF  MBD100WS-JOURNAL
090200         MOVE MTL1-VL20-B-DATA-X TO MMMM-FAX
090300                                    (X-MMMM-DEMOGRAPHICS).
090400*
090500     MOVE 'FAX NUMBER            '
090600                                 TO MBD100WS-PL1-DESC.
090700     MOVE MMMM-FAX
090800          (X-MMMM-DEMOGRAPHICS)  TO MBD100WS-PL1-FROM-VALUE.
090900     MOVE MTL1-VL20-A-DATA-X     TO MMMM-FAX
091000                                    (X-MMMM-DEMOGRAPHICS).
091100     MOVE MMMM-FAX
091200          (X-MMMM-DEMOGRAPHICS)  TO MBD100WS-PL2-TO-VALUE.
091300     GO TO 5100-MR-NO-REC-CHECK.
091400*
091500*
091600*
091700 0190-MR-FIELD.
091800*
091900     IF  MBD100WS-JOURNAL
092000         MOVE MTL1-VL07-B-DATA-9 TO MMMM-OUT-OF-BUS-DATE.
092100*
092200     MOVE 'OUT-OF-BUSINESS DATE  '
092300                                 TO MBD100WS-PL1-DESC.
092400     MOVE MMMM-OUT-OF-BUS-DATE   TO SS01WS-JULIAN.
092500     PERFORM 8100-FROM-DATE      THRU 8199-FD-EXIT.
092600     MOVE MTL1-VL07-A-DATA-9     TO MMMM-OUT-OF-BUS-DATE.
092700     MOVE MMMM-OUT-OF-BUS-DATE   TO SS01WS-JULIAN.
092800     PERFORM 8200-TO-DATE        THRU 8299-TD-EXIT.
092900     GO TO 5100-MR-NO-REC-CHECK.
093000*
093100*
093200*
093300 0191-MR-FIELD.
093400*
093500     IF  MBD100WS-JOURNAL
093600         MOVE MTL1-VL07-B-DATA-9 TO MMMM-OWNERSHIP-CHG-DATE.
093700*
093800     MOVE 'OWNERSHIP CHANGE DATE '
093900                                 TO MBD100WS-PL1-DESC.
094000     MOVE MMMM-OWNERSHIP-CHG-DATE
094100                                 TO SS01WS-JULIAN.
094200     PERFORM 8100-FROM-DATE      THRU 8199-FD-EXIT.
094300     MOVE MTL1-VL07-A-DATA-9     TO MMMM-OWNERSHIP-CHG-DATE.
094400     MOVE MMMM-OWNERSHIP-CHG-DATE
094500                                 TO SS01WS-JULIAN.
094600     PERFORM 8200-TO-DATE        THRU 8299-TD-EXIT.
094700     GO TO 5100-MR-NO-REC-CHECK.
094800*
094900*
095000*
095100 0192-MR-FIELD.
095200*
095300     IF  MBD100WS-JOURNAL
095400         MOVE MTL1-VL02-B-DATA-X TO MMMM-CLOSE-REASON.
095500*
095600     MOVE 'CLOSE REASON CODE     '
095700                                 TO MBD100WS-PL1-DESC.
095800     MOVE MMMM-CLOSE-REASON
095900                                 TO MBD100WS-PL1-FROM-VALUE.
096000     MOVE MTL1-VL02-A-DATA-X     TO MMMM-CLOSE-REASON.
096100     MOVE MMMM-CLOSE-REASON
096200                                 TO MBD100WS-PL2-TO-VALUE.
096300     GO TO 5100-MR-NO-REC-CHECK.
096400*
096500*
096600*
096700 0193-MR-FIELD.
096800*
096900     IF  MBD100WS-JOURNAL
097000         MOVE MTL1-VL07-B-DATA-9 TO MMMM-DATE-PURGED.
097100*
097200     MOVE 'DATE PURGED           '
097300                                 TO MBD100WS-PL1-DESC.
097400     MOVE MMMM-DATE-PURGED       TO SS01WS-JULIAN.
097500     PERFORM 8100-FROM-DATE      THRU 8199-FD-EXIT.
097600     MOVE MTL1-VL07-A-DATA-9     TO MMMM-DATE-PURGED.
097700     MOVE MMMM-DATE-PURGED       TO SS01WS-JULIAN.
097800     PERFORM 8200-TO-DATE        THRU 8299-TD-EXIT.
097900     GO TO 5100-MR-NO-REC-CHECK.
098000*
098100*
098200*
098300 0194-MR-FIELD.
098400*
098500     IF  MBD100WS-JOURNAL
098600         MOVE MTL1-VL07-B-DATA-9 TO MMMM-PURGING-DATE.
098700*
098800     MOVE 'DATE PURGING          '
098900                                 TO MBD100WS-PL1-DESC.
099000     MOVE MMMM-PURGING-DATE      TO SS01WS-JULIAN.
099100     PERFORM 8100-FROM-DATE      THRU 8199-FD-EXIT.
099200     MOVE MTL1-VL07-A-DATA-9     TO MMMM-PURGING-DATE.
099300     MOVE MMMM-PURGING-DATE      TO SS01WS-JULIAN.
099400     PERFORM 8200-TO-DATE        THRU 8299-TD-EXIT.
099500     GO TO 5100-MR-NO-REC-CHECK.
099600*
099700*
099800*
099900 0195-MR-FIELD.
100000*
100100     IF  MBD100WS-JOURNAL
100200         MOVE MTL1-VL07-B-DATA-9 TO MMMM-DATE-CLOSED.
100300*
100400     MOVE 'DATE CLOSED           '
100500                                 TO MBD100WS-PL1-DESC.
100600     MOVE MMMM-DATE-CLOSED       TO SS01WS-JULIAN.
100700     PERFORM 8100-FROM-DATE      THRU 8199-FD-EXIT.
100800     MOVE MTL1-VL07-A-DATA-9     TO MMMM-DATE-CLOSED.
100900     MOVE MMMM-DATE-CLOSED       TO SS01WS-JULIAN.
101000     PERFORM 8200-TO-DATE        THRU 8299-TD-EXIT.
101100     GO TO 5100-MR-NO-REC-CHECK.
101200*
101300*
101400*
101500 0196-MR-FIELD.
101600*
101700     IF  MBD100WS-JOURNAL
101800         MOVE MTL1-VL03-B-DATA-X TO MMMM-STATUS-CHANGE-OPER.
101900*
102000     MOVE 'STATUS CHANGE OPERATOR'
102100                                 TO MBD100WS-PL1-DESC.
102200     MOVE MMMM-STATUS-CHANGE-OPER
102300                                 TO MBD100WS-PL1-FROM-VALUE.
102400     MOVE MTL1-VL03-A-DATA-X     TO MMMM-STATUS-CHANGE-OPER.
102500     MOVE MMMM-STATUS-CHANGE-OPER
102600                                 TO MBD100WS-PL2-TO-VALUE.
102700     GO TO 5100-MR-NO-REC-CHECK.
102800*
102900*
103000*
103100 0197-MR-FIELD.
103200*
103300     IF  MBD100WS-JOURNAL
103400         MOVE MTL1-VL01-B-DATA-9 TO MMMM-REC-STATUS.
103500*
103600     MOVE 'RECORD STATUS         '
103700                                 TO MBD100WS-PL1-DESC.
103800     MOVE MMMM-REC-STATUS        TO MBD100WS-PL1-FV-9.
103900     MOVE MTL1-VL01-A-DATA-9     TO MMMM-REC-STATUS.
104000     MOVE MMMM-REC-STATUS        TO MBD100WS-PL2-TV-9.
104100     GO TO 5100-MR-NO-REC-CHECK.
104200*
104300*
104400*
104500 0198-MR-FIELD.
104600*
104700     IF  MBD100WS-JOURNAL
104800         MOVE MTL1-VL03-B-DATA-X TO MMMM-LAST-MAINT-OPER.
104900*
105000     MOVE 'LAST MAINT OPERATOR   '
105100                                 TO MBD100WS-PL1-DESC.
105200     MOVE MMMM-LAST-MAINT-OPER   TO MBD100WS-PL1-FROM-VALUE.
105300     MOVE MTL1-VL03-A-DATA-X     TO MMMM-LAST-MAINT-OPER.
105400     MOVE MMMM-LAST-MAINT-OPER   TO MBD100WS-PL2-TO-VALUE.
105500     GO TO 5100-MR-NO-REC-CHECK.
105600*
105700*
105800*
105900 0199-MR-FIELD.
106000*
106100     IF  MBD100WS-JOURNAL
106200         MOVE MTL1-VL07-B-DATA-9 TO MMMM-LAST-MAINT-DATE.
106300*
106400     MOVE 'DATE LAST MAINTENANCE '
106500                                 TO MBD100WS-PL1-DESC.
106600     MOVE MMMM-LAST-MAINT-DATE   TO SS01WS-JULIAN.
106700     PERFORM 8100-FROM-DATE      THRU 8199-FD-EXIT.
106800     MOVE MTL1-VL07-A-DATA-9     TO MMMM-LAST-MAINT-DATE.
106900     MOVE MMMM-LAST-MAINT-DATE   TO SS01WS-JULIAN.
107000     PERFORM 8200-TO-DATE        THRU 8299-TD-EXIT.
107100     GO TO 5100-MR-NO-REC-CHECK.
107200*
107300*
107400*
107500 0301-MR-FIELD.
107600*
107700     IF  MBD100WS-JOURNAL
107800         MOVE MTL1-VL02-B-DATA-9 TO MMMM-STMT-FREQ-1.
107900*
108000     MOVE 'STATEMENT FREQUENCY 1 '
108100                                 TO MBD100WS-PL1-DESC.
108200     MOVE MMMM-STMT-FREQ-1       TO MBD100WS-PL1-FV-99.
108300     MOVE MTL1-VL02-A-DATA-9     TO MMMM-STMT-FREQ-1.
108400     MOVE MMMM-STMT-FREQ-1       TO MBD100WS-PL2-TV-99.
108500     GO TO 5100-MR-NO-REC-CHECK.
108600*
108700*
108800*
108900 0302-MR-FIELD.
109000*
109100     IF  MBD100WS-JOURNAL
109200         MOVE MTL1-VL02-B-DATA-9 TO MMMM-STMT-FREQ-2.
109300*
109400     MOVE 'STATEMENT FREQUENCY 2 '
109500                                 TO MBD100WS-PL1-DESC.
109600     MOVE MMMM-STMT-FREQ-2       TO MBD100WS-PL1-FV-99.
109700     MOVE MTL1-VL02-A-DATA-9     TO MMMM-STMT-FREQ-2.
109800     MOVE MMMM-STMT-FREQ-2       TO MBD100WS-PL2-TV-99.
109900     GO TO 5100-MR-NO-REC-CHECK.
110000*
110100*
110200*
110300 0303-MR-FIELD.
110400*
110500     IF  MBD100WS-JOURNAL
110600         MOVE MTL1-VL01-B-DATA-X TO MMMM-DISC-LEVEL.
110700*
110800     MOVE 'DISCOUNT LEVEL        '
110900                                 TO MBD100WS-PL1-DESC.
111000     MOVE MMMM-DISC-LEVEL        TO MBD100WS-PL1-FROM-VALUE.
111100     MOVE MTL1-VL01-A-DATA-X     TO MMMM-DISC-LEVEL.
111200     MOVE MMMM-DISC-LEVEL        TO MBD100WS-PL2-TO-VALUE.
111300     GO TO 5100-MR-NO-REC-CHECK.
111400*
111500*
111600*
111700 0304-MR-FIELD.
111800*
111900     IF  MBD100WS-JOURNAL
112000         MOVE MTL1-VL10-B-DATA-9 TO MMMM-DISC-RATE-TABLE.
112100*
112200     MOVE 'DISCOUNT RATE TABLE   '
112300                                 TO MBD100WS-PL1-DESC.
112400     MOVE MMMM-DISC-RATE-TABLE   TO MBD100WS-PL1-FV-999999999.
112500     MOVE MTL1-VL10-A-DATA-9     TO MMMM-DISC-RATE-TABLE.
112600     MOVE MMMM-DISC-RATE-TABLE   TO MBD100WS-PL2-TV-999999999.
112700     GO TO 5100-MR-NO-REC-CHECK.
112800*
112900*
113000*
113100 0305-MR-FIELD.
113200*
113300     IF  MBD100WS-JOURNAL
113400         MOVE MTL1-VL01-B-DATA-X TO MMMM-STMT-ADDR-CONTROL.
113500*
113600     MOVE 'ADDRESS CONTROL       '
113700                                 TO MBD100WS-PL1-DESC.
113800     MOVE MMMM-STMT-ADDR-CONTROL TO MBD100WS-PL1-FROM-VALUE.
113900     MOVE MTL1-VL01-A-DATA-X     TO MMMM-STMT-ADDR-CONTROL.
114000     MOVE MMMM-STMT-ADDR-CONTROL TO MBD100WS-PL2-TO-VALUE.
114100     GO TO 5100-MR-NO-REC-CHECK.
114200*
114300*
114400*
114500 0306-MR-FIELD.
114600*
114700     IF  MBD100WS-JOURNAL
114800         MOVE MTL1-VL02-B-DATA-9 TO MMMM-DISC-FREQ-1.
114900*
115000     MOVE 'DISCOUNT FREQUENCY 1  '
115100                                 TO MBD100WS-PL1-DESC.
115200     MOVE MMMM-DISC-FREQ-1       TO MBD100WS-PL1-FV-99.
115300     MOVE MTL1-VL02-A-DATA-9     TO MMMM-DISC-FREQ-1.
115400     MOVE MMMM-DISC-FREQ-1       TO MBD100WS-PL2-TV-99.
115500     GO TO 5100-MR-NO-REC-CHECK.
115600*
115700*
115800*
115900 0307-MR-FIELD.
116000*
116100     IF  MBD100WS-JOURNAL
116200         MOVE MTL1-VL02-B-DATA-9 TO MMMM-DISC-FREQ-2.
116300*
116400     MOVE 'DISCOUNT FREQUENCY 2  '
116500                                 TO MBD100WS-PL1-DESC.
116600     MOVE MMMM-DISC-FREQ-2       TO MBD100WS-PL1-FV-99.
116700     MOVE MTL1-VL02-A-DATA-9     TO MMMM-DISC-FREQ-2.
116800     MOVE MMMM-DISC-FREQ-2       TO MBD100WS-PL2-TV-99.
116900     GO TO 5100-MR-NO-REC-CHECK.
117000*
117100*
117200*
117300 0308-MR-FIELD.
117400*
117500     IF  MBD100WS-JOURNAL
117600         MOVE MTL1-VL01-B-DATA-X TO MMMM-STMT-CONTROL.
117700*
117800     MOVE 'STATEMENT CONTROL     '
117900                                 TO MBD100WS-PL1-DESC.
118000     MOVE MMMM-STMT-CONTROL      TO MBD100WS-PL1-FROM-VALUE.
118100     MOVE MTL1-VL01-A-DATA-X     TO MMMM-STMT-CONTROL.
118200     MOVE MMMM-STMT-CONTROL      TO MBD100WS-PL2-TO-VALUE.
118300     GO TO 5100-MR-NO-REC-CHECK.
118400*
118500*
118600*
118700 0309-MR-FIELD.
118800*
118900     IF  MBD100WS-JOURNAL
119000         MOVE MTL1-VL20-B-NBR-NO-DEC
119100                                 TO MMMM-MIN-DISC-AMT.
119200*
119300     MOVE 'MINIMUM DISCOUNT AMT  '
119400                                 TO MBD100WS-PL1-DESC.
119500     MOVE MMMM-MIN-DISC-AMT      TO SS95WS-IN-AMT.
119600     PERFORM SS95PD-NAP-ROUTINE
119700                                 THRU SS95PD-NAP-EXIT.
119800     MOVE SS95WS-OUT-AMT-L23     TO MBD100WS-PL1-FROM-VALUE.
119900     MOVE MTL1-VL20-A-NBR-NO-DEC TO MMMM-MIN-DISC-AMT.
120000     MOVE MMMM-MIN-DISC-AMT      TO SS95WS-IN-AMT.
120100     PERFORM SS95PD-NAP-ROUTINE
120200                                 THRU SS95PD-NAP-EXIT.
120300     MOVE SS95WS-OUT-AMT-L23     TO MBD100WS-PL2-TO-VALUE.
120400     GO TO 5100-MR-NO-REC-CHECK.
120500*
120600*
120700*
120800 0310-MR-FIELD.
120900*
121000     IF  MBD100WS-JOURNAL
121100         MOVE MTL1-VL01-B-DATA-X TO MMMM-STMT-TYPE.
121200*
121300     MOVE 'STATEMENT TYPE        '
121400                                 TO MBD100WS-PL1-DESC.
121500     MOVE MMMM-STMT-TYPE         TO MBD100WS-PL1-FROM-VALUE.
121600     MOVE MTL1-VL01-A-DATA-X     TO MMMM-STMT-TYPE.
121700     MOVE MMMM-STMT-TYPE         TO MBD100WS-PL2-TO-VALUE.
121800     GO TO 5100-MR-NO-REC-CHECK.
121900*
122000*
122100*
122200 0311-MR-FIELD.
122300*
122400     IF  MBD100WS-JOURNAL
122500         MOVE MTL1-VL01-B-DATA-X TO MMMM-DISC-FEE-BASE.
122600*
122700     MOVE 'DISCOUNT FEE BASE FLAG'
122800                                 TO MBD100WS-PL1-DESC.
122900     MOVE MMMM-DISC-FEE-BASE     TO MBD100WS-PL1-FROM-VALUE.
123000     MOVE MTL1-VL01-A-DATA-X     TO MMMM-DISC-FEE-BASE.
123100     MOVE MMMM-DISC-FEE-BASE     TO MBD100WS-PL2-TO-VALUE.
123200     GO TO 5100-MR-NO-REC-CHECK.
123300*
123400*
123500*
123600 0312-MR-FIELD.
123700*
123800     SET X-MMMM-STMT-MSG-FLAG    TO MTL1-FIELD-OCCURRENCE.
123900*
124000     IF  MBD100WS-JOURNAL
124100         MOVE MTL1-VL01-B-DATA-X TO MMMM-STMT-MSG-FLAG
124200                                    (X-MMMM-STMT-MSG-FLAG).
124300*
124400     MOVE 'STATEMENT MESSAGE FLAG'
124500                                 TO MBD100WS-PL1-DESC.
124600     MOVE MMMM-STMT-MSG-FLAG
124700          (X-MMMM-STMT-MSG-FLAG) TO MBD100WS-PL1-FROM-VALUE.
124800     MOVE MTL1-VL01-A-DATA-X     TO MMMM-STMT-MSG-FLAG
124900                                    (X-MMMM-STMT-MSG-FLAG).
125000     MOVE MMMM-STMT-MSG-FLAG
125100          (X-MMMM-STMT-MSG-FLAG) TO MBD100WS-PL2-TO-VALUE.
125200     GO TO 5100-MR-NO-REC-CHECK.
125300*
125400*
125500*
125600 0313-MR-FIELD.
125700*
125800     SET X-MMMM-FP               TO MTL1-FIELD-OCCURRENCE.
125900*
126000     IF  MBD100WS-JOURNAL
126100         MOVE MTL1-VL01-B-DATA-X TO MMMM-FEE-PERIOD
126200                                    (X-MMMM-FP).
126300*
126400     MOVE 'FEE PERIOD FLAG       '
126500                                 TO MBD100WS-PL1-DESC.
126600     MOVE MMMM-FEE-PERIOD
126700          (X-MMMM-FP)            TO MBD100WS-PL1-FROM-VALUE.
126800     MOVE MTL1-VL01-A-DATA-X     TO MMMM-FEE-PERIOD
126900                                    (X-MMMM-FP).
127000     MOVE MMMM-FEE-PERIOD
127100          (X-MMMM-FP)            TO MBD100WS-PL2-TO-VALUE.
127200     GO TO 5100-MR-NO-REC-CHECK.
127300*
127400*
127500*
127600 0314-MR-FIELD.
127700*
127800     IF  MBD100WS-JOURNAL
127900         MOVE MTL1-VL01-B-DATA-X TO MMMM-PART-LEVEL.
128000*
128100     MOVE 'PARTICIPATION LEVEL   '
128200                                 TO MBD100WS-PL1-DESC.
128300     MOVE MMMM-PART-LEVEL        TO MBD100WS-PL1-FROM-VALUE.
128400     MOVE MTL1-VL01-A-DATA-X     TO MMMM-PART-LEVEL.
128500     MOVE MMMM-PART-LEVEL        TO MBD100WS-PL2-TO-VALUE.
128600     GO TO 5100-MR-NO-REC-CHECK.
128700*
128800*
128900*
129000 0315-MR-FIELD.
129100*
129200     IF  MBD100WS-JOURNAL
129300         MOVE MTL1-VL10-B-DATA-9 TO MMMM-PART-RATE-TABLE.
129400*
129500     MOVE 'PART RATE TABLE       '
129600                                 TO MBD100WS-PL1-DESC.
129700     MOVE MMMM-PART-RATE-TABLE   TO MBD100WS-PL1-FV-999999999.
129800     MOVE MTL1-VL10-A-DATA-9     TO MMMM-PART-RATE-TABLE.
129900     MOVE MMMM-PART-RATE-TABLE   TO MBD100WS-PL2-TV-999999999.
130000     GO TO 5100-MR-NO-REC-CHECK.
130100*
130200*
130300*
130400 0316-MR-FIELD.
130500*
130600     IF  MBD100WS-JOURNAL
130700         MOVE MTL1-VL02-B-DATA-9 TO MMMM-PART-FREQ-1.
130800*
130900     MOVE 'PARTICIPATION FREQ 1  '
131000                                 TO MBD100WS-PL1-DESC.
131100     MOVE MMMM-PART-FREQ-1       TO MBD100WS-PL1-FV-99.
131200     MOVE MTL1-VL02-A-DATA-9     TO MMMM-PART-FREQ-1.
131300     MOVE MMMM-PART-FREQ-1       TO MBD100WS-PL2-TV-99.
131400     GO TO 5100-MR-NO-REC-CHECK.
131500*
131600*
131700*
131800 0317-MR-FIELD.
131900*
132000     IF  MBD100WS-JOURNAL
132100         MOVE MTL1-VL02-B-DATA-9 TO MMMM-PART-FREQ-2.
132200*
132300     MOVE 'PARTICIPATION FREQ 2  '
132400                                 TO MBD100WS-PL1-DESC.
132500     MOVE MMMM-PART-FREQ-2       TO MBD100WS-PL1-FV-99.
132600     MOVE MTL1-VL02-A-DATA-9     TO MMMM-PART-FREQ-2.
132700     MOVE MMMM-PART-FREQ-2       TO MBD100WS-PL2-TV-99.
132800     GO TO 5100-MR-NO-REC-CHECK.
132900*
133000*
133100*
133200 0318-MR-FIELD.
133300*
133400     IF  MBD100WS-JOURNAL
133500         MOVE MTL1-VL20-B-NBR-NO-DEC
133600                                 TO MMMM-MIN-PART-AMT.
133700*
133800     MOVE 'MINIMUM PART AMOUNT   '
133900                                 TO MBD100WS-PL1-DESC.
134000     MOVE MMMM-MIN-PART-AMT      TO SS95WS-IN-AMT.
134100     PERFORM SS95PD-NAP-ROUTINE
134200                                 THRU SS95PD-NAP-EXIT.
134300     MOVE SS95WS-OUT-AMT-L23     TO MBD100WS-PL1-FROM-VALUE.
134400     MOVE MTL1-VL20-A-NBR-NO-DEC TO MMMM-MIN-PART-AMT.
134500     MOVE MMMM-MIN-PART-AMT      TO SS95WS-IN-AMT.
134600     PERFORM SS95PD-NAP-ROUTINE
134700                                 THRU SS95PD-NAP-EXIT.
134800     MOVE SS95WS-OUT-AMT-L23     TO MBD100WS-PL2-TO-VALUE.
134900     GO TO 5100-MR-NO-REC-CHECK.
135000*
135100*
135200*
135300 0319-MR-FIELD.
135400*
135500     IF  MBD100WS-JOURNAL
135600         MOVE MTL1-VL10-B-DATA-9 TO MMMM-INCOME-TABLE-NBR.
135700*
135800     MOVE 'INCOME TABLE NUMBER   '
135900                                 TO MBD100WS-PL1-DESC.
136000     MOVE MMMM-INCOME-TABLE-NBR  TO MBD100WS-PL1-FV-999999999.
136100     MOVE MTL1-VL10-A-DATA-9     TO MMMM-INCOME-TABLE-NBR.
136200     MOVE MMMM-INCOME-TABLE-NBR  TO MBD100WS-PL2-TV-999999999.
136300     GO TO 5100-MR-NO-REC-CHECK.
136400*
136500*
136600*
136700 0320-MR-FIELD.
136800*
136900     IF  MBD100WS-JOURNAL
137000         MOVE MTL1-VL10-B-DATA-9 TO MMMM-EXPENSE-TABLE-NBR.
137100*
137200     MOVE 'EXPENSE TABLE NUMBER  '
137300                                 TO MBD100WS-PL1-DESC.
137400     MOVE MMMM-EXPENSE-TABLE-NBR TO MBD100WS-PL1-FV-999999999.
137500     MOVE MTL1-VL10-A-DATA-9     TO MMMM-EXPENSE-TABLE-NBR.
137600     MOVE MMMM-EXPENSE-TABLE-NBR TO MBD100WS-PL2-TV-999999999.
137700     GO TO 5100-MR-NO-REC-CHECK.
137800*
137900*
138000*
138100 0321-MR-FIELD.
138200*
138300     IF  MBD100WS-JOURNAL
138400         MOVE MTL1-VL01-B-DATA-X TO MMMM-PART-FEE-BASE.
138500*
138600     MOVE 'PARTICIPATION FEE BASE'
138700                                 TO MBD100WS-PL1-DESC.
138800     MOVE MMMM-PART-FEE-BASE     TO MBD100WS-PL1-FROM-VALUE.
138900     MOVE MTL1-VL01-A-DATA-X     TO MMMM-PART-FEE-BASE.
139000     MOVE MMMM-PART-FEE-BASE     TO MBD100WS-PL2-TO-VALUE.
139100     GO TO 5100-MR-NO-REC-CHECK.
139200*
139300*
139400*
139500 0322-MR-FIELD.
139600*
139700     IF  MBD100WS-JOURNAL
139800         MOVE MTL1-VL10-B-DATA-9 TO MMMM-PART-VOL-RATE-TABLE.
139900*
140000     MOVE 'PART VOLUME RATE TABLE'
140100                                 TO MBD100WS-PL1-DESC.
140200     MOVE MMMM-PART-VOL-RATE-TABLE
140300                                 TO MBD100WS-PL1-FV-999999999.
140400     MOVE MTL1-VL10-A-DATA-9     TO MMMM-PART-VOL-RATE-TABLE.
140500     MOVE MMMM-PART-VOL-RATE-TABLE
140600                                 TO MBD100WS-PL2-TV-999999999.
140700     GO TO 5100-MR-NO-REC-CHECK.
140800*
140900*
141000*
141100 0323-MR-FIELD.
141200*
141300     IF  MBD100WS-JOURNAL
141400         MOVE MTL1-VL01-B-DATA-X TO MMMM-MEMB-FEE-FREQ.
141500*
141600     MOVE 'MEMBERSHIP FEE FREQ   '
141700                                 TO MBD100WS-PL1-DESC.
141800     MOVE MMMM-MEMB-FEE-FREQ     TO MBD100WS-PL1-FROM-VALUE.
141900     MOVE MTL1-VL01-A-DATA-X     TO MMMM-MEMB-FEE-FREQ.
142000     MOVE MMMM-MEMB-FEE-FREQ     TO MBD100WS-PL2-TO-VALUE.
142100     GO TO 5100-MR-NO-REC-CHECK.
142200*
142300*
142400*
142500 0324-MR-FIELD.
142600*
142700     IF  MBD100WS-JOURNAL
142800         MOVE MTL1-VL07-B-DATA-9 TO MMMM-DATE-LAST-MEMB-FEE.
142900*
143000     MOVE 'DATE LAST MEMB FEE    '
143100                                 TO MBD100WS-PL1-DESC.
143200     MOVE MMMM-DATE-LAST-MEMB-FEE
143300                                 TO SS01WS-JULIAN.
143400     PERFORM 8100-FROM-DATE      THRU 8199-FD-EXIT.
143500     MOVE MTL1-VL07-A-DATA-9     TO MMMM-DATE-LAST-MEMB-FEE.
143600     MOVE MMMM-DATE-LAST-MEMB-FEE
143700                                 TO SS01WS-JULIAN.
143800     PERFORM 8200-TO-DATE        THRU 8299-TD-EXIT.
143900     GO TO 5100-MR-NO-REC-CHECK.
144000*
144100*
144200*
144300 0325-MR-FIELD.
144400*
144500     IF  MBD100WS-JOURNAL
144600         MOVE MTL1-VL01-B-DATA-X TO MMMM-PART-VOL-BONUS-FLAG.
144700*
144800     MOVE 'PART VOLUME BONUS FLAG'
144900                                 TO MBD100WS-PL1-DESC.
145000     MOVE MMMM-PART-VOL-BONUS-FLAG
145100                                 TO MBD100WS-PL1-FROM-VALUE.
145200     MOVE MTL1-VL01-A-DATA-X     TO MMMM-PART-VOL-BONUS-FLAG.
145300     MOVE MMMM-PART-VOL-BONUS-FLAG
145400                                 TO MBD100WS-PL2-TO-VALUE.
145500     GO TO 5100-MR-NO-REC-CHECK.
145600*
145700*
145800*
145900 0326-MR-FIELD.
146000*
146100     IF  MBD100WS-JOURNAL
146200         MOVE MTL1-VL07-B-DATA-9 TO MMMM-DATE-LAST-PART-VOL.
146300*
146400     MOVE 'DATE LAST PART VOLUME '
146500                                 TO MBD100WS-PL1-DESC.
146600     MOVE MMMM-DATE-LAST-PART-VOL
146700                                 TO SS01WS-JULIAN.
146800     PERFORM 8100-FROM-DATE      THRU 8199-FD-EXIT.
146900     MOVE MTL1-VL07-A-DATA-9     TO MMMM-DATE-LAST-PART-VOL.
147000     MOVE MMMM-DATE-LAST-PART-VOL
147100                                 TO SS01WS-JULIAN.
147200     PERFORM 8200-TO-DATE        THRU 8299-TD-EXIT.
147300     GO TO 5100-MR-NO-REC-CHECK.
147400*
147500*
147600*
147700 0327-MR-FIELD.
147800*
147900     IF  MBD100WS-JOURNAL
148000         MOVE MTL1-VL03-B-DATA-9 TO MMMM-RETAIN-DEPOSITS.
148100*
148200     MOVE 'RETAIN DEPOSITS       '
148300                                 TO MBD100WS-PL1-DESC.
148400     MOVE MMMM-RETAIN-DEPOSITS   TO MBD100WS-PL1-FV-999.
148500     MOVE MTL1-VL03-A-DATA-9     TO MMMM-RETAIN-DEPOSITS.
148600     MOVE MMMM-RETAIN-DEPOSITS   TO MBD100WS-PL2-TV-999.
148700     GO TO 5100-MR-NO-REC-CHECK.
148800*
148900*
149000*
149100 0328-MR-FIELD.
149200*
149300     IF  MBD100WS-JOURNAL
149400         MOVE MTL1-VL01-B-DATA-X TO MMMM-STATEMENT-DETAIL-FLAG.
149500*
149600     MOVE 'STATEMENT DETAIL FLAG '
149700                                 TO MBD100WS-PL1-DESC.
149800     MOVE MMMM-STATEMENT-DETAIL-FLAG
149900                                 TO MBD100WS-PL1-FROM-VALUE.
150000     MOVE MTL1-VL01-A-DATA-X     TO MMMM-STATEMENT-DETAIL-FLAG.
150100     MOVE MMMM-STATEMENT-DETAIL-FLAG
150200                                 TO MBD100WS-PL2-TO-VALUE.
150300     GO TO 5100-MR-NO-REC-CHECK.
150400*
150500*
150600*
150700 0329-MR-FIELD.
150800*
150900     IF  MBD100WS-JOURNAL
151000         MOVE MTL1-VL01-B-DATA-X TO MMMM-STATEMENT-RPT-FLAG.
151100*
151200     MOVE 'STATEMENT REPORT FLAG '
151300                                 TO MBD100WS-PL1-DESC.
151400     MOVE MMMM-STATEMENT-RPT-FLAG
151500                                 TO MBD100WS-PL1-FROM-VALUE.
151600     MOVE MTL1-VL01-A-DATA-X     TO MMMM-STATEMENT-RPT-FLAG.
151700     MOVE MMMM-STATEMENT-RPT-FLAG
151800                                 TO MBD100WS-PL2-TO-VALUE.
151900     GO TO 5100-MR-NO-REC-CHECK.
152000*
152100*
152200*
152300 0330-MR-FIELD.
152400*
152500     IF  MBD100WS-JOURNAL
152600         MOVE MTL1-VL01-B-DATA-X TO MMMM-SETUP-FEE-FLAG.
152700*
152800     MOVE 'SETUP FEE FLAG        '
152900                                 TO MBD100WS-PL1-DESC.
153000     MOVE MMMM-SETUP-FEE-FLAG    TO MBD100WS-PL1-FROM-VALUE.
153100     MOVE MTL1-VL01-A-DATA-X     TO MMMM-SETUP-FEE-FLAG.
153200     MOVE MMMM-SETUP-FEE-FLAG    TO MBD100WS-PL2-TO-VALUE.
153300     GO TO 5100-MR-NO-REC-CHECK.
153400*
153500*
153600*
153700 0331-MR-FIELD.
153800*
153900     IF  MBD100WS-JOURNAL
154000         MOVE MTL1-VL01-B-DATA-X TO MMMM-DEP-DETAIL-CONTENT-SW.
154100*
154200     MOVE 'DEPOSIT DETAIL CONTENT'
154300                                 TO MBD100WS-PL1-DESC.
154400     MOVE MMMM-DEP-DETAIL-CONTENT-SW
154500                                 TO MBD100WS-PL1-FROM-VALUE.
154600     MOVE MTL1-VL01-A-DATA-X     TO MMMM-DEP-DETAIL-CONTENT-SW.
154700     MOVE MMMM-DEP-DETAIL-CONTENT-SW
154800                                 TO MBD100WS-PL2-TO-VALUE.
154900     GO TO 5100-MR-NO-REC-CHECK.
155000
155100*
155200*
155300*
155400 0332-MR-FIELD.
155500*
155600     IF  MBD100WS-JOURNAL
155700         MOVE MTL1-VL01-B-DATA-X TO MMMM-EURO-REPORTING-FLAG.
155800*
155900     MOVE 'EURO REPORTING FLAG   '
156000                                 TO MBD100WS-PL1-DESC.
156100     MOVE MMMM-EURO-REPORTING-FLAG
156200                                 TO MBD100WS-PL1-FROM-VALUE.
156300     MOVE MTL1-VL01-A-DATA-X     TO MMMM-EURO-REPORTING-FLAG.
156400     MOVE MMMM-EURO-REPORTING-FLAG
156500                                 TO MBD100WS-PL2-TO-VALUE.
156600     GO TO 5100-MR-NO-REC-CHECK.
156700*
156800*
156900*
157000 0333-MR-FIELD.
157100*
157200     IF  MBD100WS-JOURNAL
157300         MOVE MTL1-VL03-B-DATA-9 TO MMMM-DUAL-CURRENCY-ORG.
157400*
157500     MOVE 'DUAL CURRENCY ORG NBR '
157600                                 TO MBD100WS-PL1-DESC.
157700     MOVE MMMM-DUAL-CURRENCY-ORG TO MBD100WS-PL1-FV-999.
157800     MOVE MTL1-VL03-A-DATA-9     TO MMMM-DUAL-CURRENCY-ORG.
157900     MOVE MMMM-DUAL-CURRENCY-ORG TO MBD100WS-PL2-TV-999.
158000     GO TO 5100-MR-NO-REC-CHECK.
158100*
158200*
158300*
158400 0401-MR-FIELD.
158500*
158600     SET X-MMMM-RESV             TO MTL1-FIELD-OCCURRENCE.
158700*
158800     IF  MBD100WS-JOURNAL
158900         MOVE MTL1-VL01-B-DATA-X TO MMMM-RESV-FREQ
159000                                    (X-MMMM-RESV).
159100*
159200     MOVE 'RESERVE FREQUENCY     '
159300                                 TO MBD100WS-PL1-DESC.
159400     MOVE MMMM-RESV-FREQ
159500          (X-MMMM-RESV)          TO MBD100WS-PL1-FROM-VALUE.
159600     MOVE MTL1-VL01-A-DATA-X     TO MMMM-RESV-FREQ
159700                                    (X-MMMM-RESV).
159800     MOVE MMMM-RESV-FREQ
159900          (X-MMMM-RESV)          TO MBD100WS-PL2-TO-VALUE.
160000     GO TO 5100-MR-NO-REC-CHECK.
160100*
160200*
160300*
160400 0402-MR-FIELD.
160500*
160600     SET X-MMMM-RESV             TO MTL1-FIELD-OCCURRENCE.
160700*
160800     IF  MBD100WS-JOURNAL
160900         MOVE MTL1-VL10-B-DATA-9 TO MMMM-RESV-RATE-TABLE
161000                                    (X-MMMM-RESV).
161100*
161200     MOVE 'RESERVE RATE TABLE    '
161300                                 TO MBD100WS-PL1-DESC.
161400     MOVE MMMM-RESV-RATE-TABLE
161500          (X-MMMM-RESV)          TO MBD100WS-PL1-FV-999999999.
161600     MOVE MTL1-VL10-A-DATA-9     TO MMMM-RESV-RATE-TABLE
161700                                    (X-MMMM-RESV).
161800     MOVE MMMM-RESV-RATE-TABLE
161900          (X-MMMM-RESV)          TO MBD100WS-PL2-TV-999999999.
162000     GO TO 5100-MR-NO-REC-CHECK.
162100*
162200*
162300*
162400 0403-MR-FIELD.
162500*
162600     SET X-MMMM-RESV             TO MTL1-FIELD-OCCURRENCE.
162700*
162800     IF  MBD100WS-JOURNAL
162900         MOVE MTL1-VL30-B-DATA-X TO MMMM-RESV-DESC
163000                                    (X-MMMM-RESV).
163100*
163200     MOVE 'RESERVE DESCRIPTION   '
163300                                 TO MBD100WS-PL1-DESC.
163400     MOVE MMMM-RESV-DESC
163500          (X-MMMM-RESV)          TO MBD100WS-PL1-FROM-VALUE.
163600     MOVE MTL1-VL30-A-DATA-X     TO MMMM-RESV-DESC
163700                                    (X-MMMM-RESV).
163800     MOVE MMMM-RESV-DESC
163900          (X-MMMM-RESV)          TO MBD100WS-PL2-TO-VALUE.
164000     GO TO 5100-MR-NO-REC-CHECK.
164100*
164200*
164300*
164400 0404-MR-FIELD.
164500*
164600     SET X-MMMM-RESV             TO MTL1-FIELD-OCCURRENCE.
164700*
164800     IF  MBD100WS-JOURNAL
164900         MOVE MTL1-VL01-B-DATA-X TO MMMM-RESV-LEVEL
165000                                    (X-MMMM-RESV).
165100*
165200     MOVE 'RESERVE LEVEL         '
165300                                 TO MBD100WS-PL1-DESC.
165400     MOVE MMMM-RESV-LEVEL
165500          (X-MMMM-RESV)          TO MBD100WS-PL1-FROM-VALUE.
165600     MOVE MTL1-VL01-A-DATA-X     TO MMMM-RESV-LEVEL
165700                                    (X-MMMM-RESV).
165800     MOVE MMMM-RESV-LEVEL
165900          (X-MMMM-RESV)          TO MBD100WS-PL2-TO-VALUE.
166000     GO TO 5100-MR-NO-REC-CHECK.
166100*
166200*
166300*
166400 0405-MR-FIELD.
166500*
166600     SET X-MMMM-RESV             TO MTL1-FIELD-OCCURRENCE.
166700*
166800     IF  MBD100WS-JOURNAL
166900         MOVE MTL1-VL01-B-DATA-X TO MMMM-RESV-FEE-BASE
167000                                    (X-MMMM-RESV).
167100*
167200     MOVE 'RESERVE FEE BASE      '
167300                                 TO MBD100WS-PL1-DESC.
167400     MOVE MMMM-RESV-FEE-BASE
167500          (X-MMMM-RESV)          TO MBD100WS-PL1-FROM-VALUE.
167600     MOVE MTL1-VL01-A-DATA-X     TO MMMM-RESV-FEE-BASE
167700                                    (X-MMMM-RESV).
167800     MOVE MMMM-RESV-FEE-BASE
167900          (X-MMMM-RESV)          TO MBD100WS-PL2-TO-VALUE.
168000     GO TO 5100-MR-NO-REC-CHECK.
168100*
168200*
168300*
168400 0406-MR-FIELD.
168500*
168600     SET X-MMMM-RESV             TO MTL1-FIELD-OCCURRENCE.
168700*
168800     IF  MBD100WS-JOURNAL
168900         MOVE MTL1-VL20-B-NBR-NO-DEC
169000                                 TO MMMM-RESV-FLOOR
169100                                    (X-MMMM-RESV).
169200*
169300     MOVE 'RESERVE FLOOR         '
169400                                 TO MBD100WS-PL1-DESC.
169500     MOVE MMMM-RESV-FLOOR
169600          (X-MMMM-RESV)          TO SS95WS-IN-AMT.
169700     PERFORM SS95PD-NAP-ROUTINE
169800                                 THRU SS95PD-NAP-EXIT.
169900     MOVE SS95WS-OUT-AMT-L23     TO MBD100WS-PL1-FROM-VALUE.
170000     MOVE MTL1-VL20-A-NBR-NO-DEC TO MMMM-RESV-FLOOR
170100                                    (X-MMMM-RESV).
170200     MOVE MMMM-RESV-FLOOR
170300          (X-MMMM-RESV)          TO SS95WS-IN-AMT.
170400     PERFORM SS95PD-NAP-ROUTINE
170500                                 THRU SS95PD-NAP-EXIT.
170600     MOVE SS95WS-OUT-AMT-L23     TO MBD100WS-PL2-TO-VALUE.
170700     GO TO 5100-MR-NO-REC-CHECK.
170800*
170900*
171000*
171100 0407-MR-FIELD.
171200*
171300     SET X-MMMM-RESV             TO MTL1-FIELD-OCCURRENCE.
171400*
171500     IF  MBD100WS-JOURNAL
171600         MOVE MTL1-VL20-B-NBR-NO-DEC
171700                                 TO MMMM-RESV-CEILING
171800                                    (X-MMMM-RESV).
171900*
172000     MOVE 'RESERVE CEILING       '
172100                                 TO MBD100WS-PL1-DESC.
172200     MOVE MMMM-RESV-CEILING
172300          (X-MMMM-RESV)          TO SS95WS-IN-AMT.
172400     PERFORM SS95PD-NAP-ROUTINE
172500                                 THRU SS95PD-NAP-EXIT.
172600     MOVE SS95WS-OUT-AMT-L23     TO MBD100WS-PL1-FROM-VALUE.
172700     MOVE MTL1-VL20-A-NBR-NO-DEC TO MMMM-RESV-CEILING
172800                                    (X-MMMM-RESV).
172900     MOVE MMMM-RESV-CEILING
173000          (X-MMMM-RESV)          TO SS95WS-IN-AMT.
173100     PERFORM SS95PD-NAP-ROUTINE
173200                                 THRU SS95PD-NAP-EXIT.
173300     MOVE SS95WS-OUT-AMT-L23     TO MBD100WS-PL2-TO-VALUE.
173400     GO TO 5100-MR-NO-REC-CHECK.
173500*
173600*
173700*
173800 0408-MR-FIELD.
173900*
174000     SET X-MMMM-BILL             TO MTL1-FIELD-OCCURRENCE.
174100*
174200     IF  MBD100WS-JOURNAL
174300         MOVE MTL1-VL01-B-DATA-X TO MMMM-BILL-USE-FLAG
174400                                    (X-MMMM-BILL).
174500*
174600     MOVE 'BILL USE FLAG         '
174700                                 TO MBD100WS-PL1-DESC.
174800     MOVE MMMM-BILL-USE-FLAG
174900          (X-MMMM-BILL)          TO MBD100WS-PL1-FROM-VALUE.
175000     MOVE MTL1-VL01-A-DATA-X     TO MMMM-BILL-USE-FLAG
175100                                    (X-MMMM-BILL).
175200     MOVE MMMM-BILL-USE-FLAG
175300          (X-MMMM-BILL)          TO MBD100WS-PL2-TO-VALUE.
175400     GO TO 5100-MR-NO-REC-CHECK.
175500*
175600*
175700*
175800 0409-MR-FIELD.
175900*
176000     SET X-MMMM-BILL             TO MTL1-FIELD-OCCURRENCE.
176100*
176200     IF  MBD100WS-JOURNAL
176300         MOVE MTL1-VL03-B-DATA-9 TO MMMM-BILLING-ORG
176400                                    (X-MMMM-BILL).
176500*
176600     MOVE 'BILLING ORG NUMBER    '
176700                                 TO MBD100WS-PL1-DESC.
176800     MOVE MMMM-BILLING-ORG
176900          (X-MMMM-BILL)          TO MBD100WS-PL1-FV-999.
177000     MOVE MTL1-VL03-A-DATA-9     TO MMMM-BILLING-ORG
177100                                    (X-MMMM-BILL).
177200     MOVE MMMM-BILLING-ORG
177300          (X-MMMM-BILL)          TO MBD100WS-PL2-TV-999.
177400     GO TO 5100-MR-NO-REC-CHECK.
177500*
177600*
177700*
177800 0410-MR-FIELD.
177900*
178000     SET X-MMMM-BILL             TO MTL1-FIELD-OCCURRENCE.
178100*
178200     IF  MBD100WS-JOURNAL
178300         MOVE MTL1-VL20-B-DATA-X TO MMMM-BILLING-ACCT
178400                                    (X-MMMM-BILL).
178500*
178600     MOVE 'BILLING ACCOUNT NBR   '
178700                                 TO MBD100WS-PL1-DESC.
178800     MOVE MMMM-BILLING-ACCT
178900          (X-MMMM-BILL)          TO MBD100WS-PL1-FROM-VALUE.
179000     MOVE MTL1-VL20-A-DATA-X     TO MMMM-BILLING-ACCT
179100                                    (X-MMMM-BILL).
179200     MOVE MMMM-BILLING-ACCT
179300          (X-MMMM-BILL)          TO MBD100WS-PL2-TO-VALUE.
179400     GO TO 5100-MR-NO-REC-CHECK.
179500*
179600*
179700*
179800 0501-MR-FIELD.
179900*
180000     SET X-MMMM-SETT-ACH         TO MTL1-FIELD-OCCURRENCE.
180100*
180200     IF  MBD100WS-JOURNAL
180300         MOVE MTL1-VL01-B-DATA-X TO MMMM-PRENOTE-CONTROL
180400                                    (X-MMMM-SETT-ACH).
180500*
180600     MOVE 'ACH PRENOTE CONTROL   '
180700                                 TO MBD100WS-PL1-DESC.
180800     MOVE MMMM-PRENOTE-CONTROL
180900          (X-MMMM-SETT-ACH)      TO MBD100WS-PL1-FROM-VALUE.
181000     MOVE MTL1-VL01-A-DATA-X     TO MMMM-PRENOTE-CONTROL
181100                                    (X-MMMM-SETT-ACH).
181200     MOVE MMMM-PRENOTE-CONTROL
181300          (X-MMMM-SETT-ACH)      TO MBD100WS-PL2-TO-VALUE.
181400     GO TO 5100-MR-NO-REC-CHECK.
181500*
181600*
181700*
181800 0502-MR-FIELD.
181900*
182000     SET X-MMMM-SETT-ACH         TO MTL1-FIELD-OCCURRENCE.
182100*
182200     IF  MBD100WS-JOURNAL
182300         MOVE MTL1-VL07-B-DATA-9 TO MMMM-DATE-PRENOTE-INIT
182400                                    (X-MMMM-SETT-ACH).
182500*
182600     MOVE 'DATE PRENOTE INIT     '
182700                                 TO MBD100WS-PL1-DESC.
182800     MOVE MMMM-DATE-PRENOTE-INIT
182900          (X-MMMM-SETT-ACH)      TO SS01WS-JULIAN.
183000     PERFORM 8100-FROM-DATE      THRU 8199-FD-EXIT.
183100     MOVE MTL1-VL07-A-DATA-9     TO MMMM-DATE-PRENOTE-INIT
183200                                    (X-MMMM-SETT-ACH).
183300     MOVE MMMM-DATE-PRENOTE-INIT
183400          (X-MMMM-SETT-ACH)      TO SS01WS-JULIAN.
183500     PERFORM 8200-TO-DATE        THRU 8299-TD-EXIT.
183600     GO TO 5100-MR-NO-REC-CHECK.
183700*
183800*
183900*
184000 0503-MR-FIELD.
184100*
184200     SET X-MMMM-SETT-ACH         TO MTL1-FIELD-OCCURRENCE.
184300*
184400     IF  MBD100WS-JOURNAL
184500         MOVE MTL1-VL02-B-DATA-X TO MMMM-PENDING-SETT-ACCT-METH
184600                                    (X-MMMM-SETT-ACH).
184700*
184800     MOVE 'PENDING SETT ACCT METH'
184900                                 TO MBD100WS-PL1-DESC.
185000     MOVE MMMM-PENDING-SETT-ACCT-METH
185100          (X-MMMM-SETT-ACH)      TO MBD100WS-PL1-FROM-VALUE.
185200     MOVE MTL1-VL02-A-DATA-X     TO MMMM-PENDING-SETT-ACCT-METH
185300                                    (X-MMMM-SETT-ACH).
185400     MOVE MMMM-PENDING-SETT-ACCT-METH
185500          (X-MMMM-SETT-ACH)      TO MBD100WS-PL2-TO-VALUE.
185600     GO TO 5100-MR-NO-REC-CHECK.
185700*
185800*
185900*
186000 0504-MR-FIELD.
186100*
186200     SET X-MMMM-SETT-ACH         TO MTL1-FIELD-OCCURRENCE.
186300*
186400     IF  MBD100WS-JOURNAL
186500         MOVE MTL1-VL07-B-DATA-9 TO MMMM-DATE-PENDING-ACH-ACTIVE
186600                                    (X-MMMM-SETT-ACH).
186700*
186800     MOVE 'DATE PENDING ACH ACTIV'
186900                                 TO MBD100WS-PL1-DESC.
187000     MOVE MMMM-DATE-PENDING-ACH-ACTIVE
187100          (X-MMMM-SETT-ACH)      TO SS01WS-JULIAN.
187200     PERFORM 8100-FROM-DATE      THRU 8199-FD-EXIT.
187300     MOVE MTL1-VL07-A-DATA-9     TO MMMM-DATE-PENDING-ACH-ACTIVE
187400                                    (X-MMMM-SETT-ACH).
187500     MOVE MMMM-DATE-PENDING-ACH-ACTIVE
187600          (X-MMMM-SETT-ACH)      TO SS01WS-JULIAN.
187700     PERFORM 8200-TO-DATE        THRU 8299-TD-EXIT.
187800     GO TO 5100-MR-NO-REC-CHECK.
187900*
188000*
188100*
188200 0505-MR-FIELD.
188300*
188400     SET X-MMMM-SETT-ACH         TO MTL1-FIELD-OCCURRENCE.
188500*
188600     IF  MBD100WS-JOURNAL
188700         MOVE MTL1-VL02-B-DATA-X TO MMMM-PENDING-SETT-ACCT-METH
188800                                    (X-MMMM-SETT-ACH).
188900*
189000     MOVE 'PENDING SETT ACCT METH'
189100                                 TO MBD100WS-PL1-DESC.
189200     MOVE MMMM-PENDING-SETT-ACCT-METH
189300          (X-MMMM-SETT-ACH)      TO MBD100WS-PL1-FROM-VALUE.
189400     MOVE MTL1-VL02-A-DATA-X     TO MMMM-PENDING-SETT-ACCT-METH
189500                                    (X-MMMM-SETT-ACH).
189600     MOVE MMMM-PENDING-SETT-ACCT-METH
189700          (X-MMMM-SETT-ACH)      TO MBD100WS-PL2-TO-VALUE.
189800     GO TO 5100-MR-NO-REC-CHECK.
189900*
190000*
190100*
190200 0506-MR-FIELD.
190300*
190400     SET X-MMMM-SETT-ACH         TO MTL1-FIELD-OCCURRENCE.
190500*
190600     IF  MBD100WS-JOURNAL
190700         MOVE MTL1-VL01-B-DATA-X TO MMMM-PENDING-CR-ACCT-TYPE
190800                                    (X-MMMM-SETT-ACH).
190900*
191000     MOVE 'PENDING CR ACCT TYPE  '
191100                                 TO MBD100WS-PL1-DESC.
191200     MOVE MMMM-PENDING-CR-ACCT-TYPE
191300          (X-MMMM-SETT-ACH)      TO MBD100WS-PL1-FROM-VALUE.
191400     MOVE MTL1-VL01-A-DATA-X     TO MMMM-PENDING-CR-ACCT-TYPE
191500                                    (X-MMMM-SETT-ACH).
191600     MOVE MMMM-PENDING-CR-ACCT-TYPE
191700          (X-MMMM-SETT-ACH)      TO MBD100WS-PL2-TO-VALUE.
191800     GO TO 5100-MR-NO-REC-CHECK.
191900*
192000*
192100*
192200 0507-MR-FIELD.
192300*
192400     SET X-MMMM-SETT-ACH         TO MTL1-FIELD-OCCURRENCE.
192500*
192600     IF  MBD100WS-JOURNAL
192700         MOVE MTL1-VL10-B-DATA-9 TO MMMM-PENDING-CR-RT
192800                                    (X-MMMM-SETT-ACH).
192900*
193000     MOVE 'PENDING CR ACCT R/T   '
193100                                 TO MBD100WS-PL1-DESC.
193200     MOVE MMMM-PENDING-CR-RT
193300          (X-MMMM-SETT-ACH)      TO MBD100WS-PL1-FV-999999999.
193400     MOVE MTL1-VL10-A-DATA-9     TO MMMM-PENDING-CR-RT
193500                                    (X-MMMM-SETT-ACH).
193600     MOVE MMMM-PENDING-CR-RT
193700          (X-MMMM-SETT-ACH)      TO MBD100WS-PL2-TV-999999999.
193800     GO TO 5100-MR-NO-REC-CHECK.
193900*
194000*
194100*
194200 0508-MR-FIELD.
194300*
194400     SET X-MMMM-SETT-ACH         TO MTL1-FIELD-OCCURRENCE.
194500*
194600     IF  MBD100WS-JOURNAL
194700         MOVE MTL1-VL20-B-DATA-X TO MMMM-PENDING-CR-ACCT
194800                                    (X-MMMM-SETT-ACH).
194900*
195000     MOVE 'PENDING CR ACCT       '
195100                                 TO MBD100WS-PL1-DESC.
195200     MOVE MMMM-PENDING-CR-ACCT
195300          (X-MMMM-SETT-ACH)      TO MBD100WS-PL1-FROM-VALUE.
195400     MOVE MTL1-VL20-A-DATA-X     TO MMMM-PENDING-CR-ACCT
195500                                    (X-MMMM-SETT-ACH).
195600     MOVE MMMM-PENDING-CR-ACCT
195700          (X-MMMM-SETT-ACH)      TO MBD100WS-PL2-TO-VALUE.
195800     GO TO 5100-MR-NO-REC-CHECK.
195900*
196000*
196100*
196200 0509-MR-FIELD.
196300*
196400     SET X-MMMM-SETT-ACH         TO MTL1-FIELD-OCCURRENCE.
196500*
196600     IF  MBD100WS-JOURNAL
196700         MOVE MTL1-VL01-B-DATA-X TO MMMM-PENDING-DR-ACCT-TYPE
196800                                    (X-MMMM-SETT-ACH).
196900*
197000     MOVE 'PENDING DR ACCT TYPE  '
197100                                 TO MBD100WS-PL1-DESC.
197200     MOVE MMMM-PENDING-DR-ACCT-TYPE
197300          (X-MMMM-SETT-ACH)      TO MBD100WS-PL1-FROM-VALUE.
197400     MOVE MTL1-VL01-A-DATA-X     TO MMMM-PENDING-DR-ACCT-TYPE
197500                                    (X-MMMM-SETT-ACH).
197600     MOVE MMMM-PENDING-DR-ACCT-TYPE
197700          (X-MMMM-SETT-ACH)      TO MBD100WS-PL2-TO-VALUE.
197800     GO TO 5100-MR-NO-REC-CHECK.
197900*
198000*
198100*
198200 0510-MR-FIELD.
198300*
198400     SET X-MMMM-SETT-ACH         TO MTL1-FIELD-OCCURRENCE.
198500*
198600     IF  MBD100WS-JOURNAL
198700         MOVE MTL1-VL10-B-DATA-9 TO MMMM-PENDING-DR-RT
198800                                    (X-MMMM-SETT-ACH).
198900*
199000     MOVE 'PENDING DR ACCT R/T   '
199100                                 TO MBD100WS-PL1-DESC.
199200     MOVE MMMM-PENDING-DR-RT
199300          (X-MMMM-SETT-ACH)      TO MBD100WS-PL1-FV-999999999.
199400     MOVE MTL1-VL10-A-DATA-9     TO MMMM-PENDING-DR-RT
199500                                    (X-MMMM-SETT-ACH).
199600     MOVE MMMM-PENDING-DR-RT
199700          (X-MMMM-SETT-ACH)      TO MBD100WS-PL2-TV-999999999.
199800     GO TO 5100-MR-NO-REC-CHECK.
199900*
200000*
200100*
200200 0511-MR-FIELD.
200300*
200400     SET X-MMMM-SETT-ACH         TO MTL1-FIELD-OCCURRENCE.
200500*
200600     IF  MBD100WS-JOURNAL
200700         MOVE MTL1-VL20-B-DATA-X TO MMMM-PENDING-DR-ACCT
200800                                    (X-MMMM-SETT-ACH).
200900*
201000     MOVE 'PENDING DR ACCT       '
201100                                 TO MBD100WS-PL1-DESC.
201200     MOVE MMMM-PENDING-DR-ACCT
201300          (X-MMMM-SETT-ACH)      TO MBD100WS-PL1-FROM-VALUE.
201400     MOVE MTL1-VL20-A-DATA-X     TO MMMM-PENDING-DR-ACCT
201500                                    (X-MMMM-SETT-ACH).
201600     MOVE MMMM-PENDING-DR-ACCT
201700          (X-MMMM-SETT-ACH)      TO MBD100WS-PL2-TO-VALUE.
201800     GO TO 5100-MR-NO-REC-CHECK.
201900*
202000*
202100*
202200 0701-MR-FIELD.
202300*
202400     IF  MBD100WS-JOURNAL
202500         MOVE MTL1-VL01-B-DATA-X TO MMMM-POST-REJECTS-FLAG.
202600*
202700     MOVE 'POST REJECTS FLAG     '
202800                                 TO MBD100WS-PL1-DESC.
202900     MOVE MMMM-POST-REJECTS-FLAG TO MBD100WS-PL1-FROM-VALUE.
203000     MOVE MTL1-VL01-A-DATA-X     TO MMMM-POST-REJECTS-FLAG.
203100     MOVE MMMM-POST-REJECTS-FLAG TO MBD100WS-PL2-TO-VALUE.
203200     GO TO 5100-MR-NO-REC-CHECK.
203300*
203400*
203500*
203600 0702-MR-FIELD.
203700*
203800     IF  MBD100WS-JOURNAL
203900         MOVE MTL1-VL02-B-DATA-9 TO MMMM-SETT-FREQ-1.
204000*
204100     MOVE 'SETTLEMENT FREQUENCY 1'
204200                                 TO MBD100WS-PL1-DESC.
204300     MOVE MMMM-SETT-FREQ-1       TO MBD100WS-PL1-FV-99.
204400     MOVE MTL1-VL02-A-DATA-9     TO MMMM-SETT-FREQ-1.
204500     MOVE MMMM-SETT-FREQ-1       TO MBD100WS-PL2-TV-99.
204600     GO TO 5100-MR-NO-REC-CHECK.
204700*
204800*
204900*
205000 0703-MR-FIELD.
205100*
205200     IF  MBD100WS-JOURNAL
205300         MOVE MTL1-VL02-B-DATA-9 TO MMMM-SETT-FREQ-2.
205400*
205500     MOVE 'SETTLEMENT FREQUENCY 2'
205600                                 TO MBD100WS-PL1-DESC.
205700     MOVE MMMM-SETT-FREQ-2       TO MBD100WS-PL1-FV-99.
205800     MOVE MTL1-VL02-A-DATA-9     TO MMMM-SETT-FREQ-2.
205900     MOVE MMMM-SETT-FREQ-2       TO MBD100WS-PL2-TV-99.
206000     GO TO 5100-MR-NO-REC-CHECK.
206100*
206200*
206300*
206400 0704-MR-FIELD.
206500*
206600     IF  MBD100WS-JOURNAL
206700         MOVE MTL1-VL01-B-DATA-X TO MMMM-SETT-COMB-DEPOSIT-FLAG.
206800*
206900     MOVE 'COMBINED DEPOSITS FLAG'
207000                                 TO MBD100WS-PL1-DESC.
207100     MOVE MMMM-SETT-COMB-DEPOSIT-FLAG
207200                                 TO MBD100WS-PL1-FROM-VALUE.
207300     MOVE MTL1-VL01-A-DATA-X     TO MMMM-SETT-COMB-DEPOSIT-FLAG.
207400     MOVE MMMM-SETT-COMB-DEPOSIT-FLAG
207500                                 TO MBD100WS-PL2-TO-VALUE.
207600     GO TO 5100-MR-NO-REC-CHECK.
207700*
207800*
207900*
208000 0705-MR-FIELD.
208100*
208200     IF  MBD100WS-JOURNAL
208300         MOVE MTL1-VL01-B-DATA-X TO MMMM-SETT-NOTICE-RPT-FLAG.
208400*
208500     MOVE 'SETT NOTICE RPT FLAG  '
208600                                 TO MBD100WS-PL1-DESC.
208700     MOVE MMMM-SETT-NOTICE-RPT-FLAG
208800                                 TO MBD100WS-PL1-FROM-VALUE.
208900     MOVE MTL1-VL01-A-DATA-X     TO MMMM-SETT-NOTICE-RPT-FLAG.
209000     MOVE MMMM-SETT-NOTICE-RPT-FLAG
209100                                 TO MBD100WS-PL2-TO-VALUE.
209200     GO TO 5100-MR-NO-REC-CHECK.
209300*
209400*
209500*
209600 0706-MR-FIELD.
209700*
209800     IF  MBD100WS-JOURNAL
209900         MOVE MTL1-VL01-B-DATA-X TO MMMM-SETT-NOTICE-DETAIL-FLAG.
210000*
210100     MOVE 'SETT NOTICE DETAIL    '
210200                                 TO MBD100WS-PL1-DESC.
210300     MOVE MMMM-SETT-NOTICE-DETAIL-FLAG
210400                                 TO MBD100WS-PL1-FROM-VALUE.
210500     MOVE MTL1-VL01-A-DATA-X     TO MMMM-SETT-NOTICE-DETAIL-FLAG.
210600     MOVE MMMM-SETT-NOTICE-DETAIL-FLAG
210700                                 TO MBD100WS-PL2-TO-VALUE.
210800     GO TO 5100-MR-NO-REC-CHECK.
210900*
211000*
211100*
211200 0707-MR-FIELD.
211300*
211400     SET X-MMMM-TAT              TO MTL1-FIELD-OCCURRENCE.
211500*
211600     IF  MBD100WS-JOURNAL
211700         MOVE MTL1-VL02-B-DATA-X TO MMMM-TAT-ACCOUNT
211800                                    (X-MMMM-TAT).
211900*
212000     MOVE 'TRANS ASSIGN ACCOUNT  '
212100                                 TO MBD100WS-PL1-DESC.
212200     MOVE MMMM-TAT-ACCOUNT
212300          (X-MMMM-TAT)           TO MBD100WS-PL1-FROM-VALUE.
212400     MOVE MTL1-VL02-A-DATA-X     TO MMMM-TAT-ACCOUNT
212500                                    (X-MMMM-TAT).
212600     MOVE MMMM-TAT-ACCOUNT
212700          (X-MMMM-TAT)           TO MBD100WS-PL2-TO-VALUE.
212800     GO TO 5100-MR-NO-REC-CHECK.
212900*
213000*
213100*
213200 0708-MR-FIELD.
213300*
213400     SET X-MMMM-TAT              TO MTL1-FIELD-OCCURRENCE.
213500*
213600     IF  MBD100WS-JOURNAL
213700         MOVE MTL1-VL01-B-DATA-X TO MMMM-TAT-USER-CODE
213800                                    (X-MMMM-TAT).
213900*
214000     MOVE 'TRANS ASSIGN USER CODE'
214100                                 TO MBD100WS-PL1-DESC.
214200     MOVE MMMM-TAT-USER-CODE
214300          (X-MMMM-TAT)           TO MBD100WS-PL1-FROM-VALUE.
214400     MOVE MTL1-VL01-A-DATA-X     TO MMMM-TAT-USER-CODE
214500                                    (X-MMMM-TAT).
214600     MOVE MMMM-TAT-USER-CODE
214700          (X-MMMM-TAT)           TO MBD100WS-PL2-TO-VALUE.
214800     GO TO 5100-MR-NO-REC-CHECK.
214900*
215000*
215100*
215200 0801-MR-FIELD.
215300*
215400     IF  MBD100WS-JOURNAL
215500         MOVE MTL1-VL05-B-DATA-9 TO MMMM-AGENT-BANK.
215600*
215700     MOVE 'AGENT BANK            '
215800                                 TO MBD100WS-PL1-DESC.
215900     MOVE MMMM-AGENT-BANK        TO MBD100WS-PL1-FV-99999.
216000     MOVE MTL1-VL05-A-DATA-9     TO MMMM-AGENT-BANK.
216100     MOVE MMMM-AGENT-BANK        TO MBD100WS-PL2-TV-99999.
216200     GO TO 5100-MR-NO-REC-CHECK.
216300*
216400*
216500*
216600 0802-MR-FIELD.
216700*
216800     IF  MBD100WS-JOURNAL
216900         MOVE MTL1-VL10-B-DATA-9 TO MMMM-BRANCH.
217000*
217100     MOVE 'BRANCH NUMBER         '
217200                                 TO MBD100WS-PL1-DESC.
217300     MOVE MMMM-BRANCH            TO MBD100WS-PL1-FV-999999999.
217400     MOVE MTL1-VL10-A-DATA-9     TO MMMM-BRANCH.
217500     MOVE MMMM-BRANCH            TO MBD100WS-PL2-TV-999999999.
217600     GO TO 5100-MR-NO-REC-CHECK.
217700*
217800*
217900*
218000 0803-MR-FIELD.
218100*
218200     IF  MBD100WS-JOURNAL
218300         MOVE MTL1-VL01-B-DATA-X TO MMMM-BLOCK-CODE.
218400*
218500     MOVE 'BLOCK CODE            '
218600                                 TO MBD100WS-PL1-DESC.
218700     MOVE MMMM-BLOCK-CODE        TO MBD100WS-PL1-FROM-VALUE.
218800     MOVE MTL1-VL01-A-DATA-X     TO MMMM-BLOCK-CODE.
218900     MOVE MMMM-BLOCK-CODE        TO MBD100WS-PL2-TO-VALUE.
219000     GO TO 5100-MR-NO-REC-CHECK.
219100*
219200*
219300*
219400 0804-MR-FIELD.
219500*
219600     IF  MBD100WS-JOURNAL
219700         MOVE MTL1-VL07-B-DATA-9 TO MMMM-DATE-BLOCK-CODE.
219800*
219900     MOVE 'DATE BLOCK CODE       '
220000                                 TO MBD100WS-PL1-DESC.
220100     MOVE MMMM-DATE-BLOCK-CODE   TO SS01WS-JULIAN.
220200     PERFORM 8100-FROM-DATE      THRU 8199-FD-EXIT.
220300     MOVE MTL1-VL07-A-DATA-9     TO MMMM-DATE-BLOCK-CODE.
220400     MOVE MMMM-DATE-BLOCK-CODE   TO SS01WS-JULIAN.
220500     PERFORM 8200-TO-DATE        THRU 8299-TD-EXIT.
220600     GO TO 5100-MR-NO-REC-CHECK.
220700*
220800*
220900*
221000 0805-MR-FIELD.
221100*
221200     IF  MBD100WS-JOURNAL
221300         MOVE MTL1-VL03-B-DATA-X TO MMMM-BLOCK-OPER.
221400*
221500     MOVE 'BLOCK CODE OPERATOR   '
221600                                 TO MBD100WS-PL1-DESC.
221700     MOVE MMMM-BLOCK-OPER        TO MBD100WS-PL1-FROM-VALUE.
221800     MOVE MTL1-VL03-A-DATA-X     TO MMMM-BLOCK-OPER.
221900     MOVE MMMM-BLOCK-OPER        TO MBD100WS-PL2-TO-VALUE.
222000     GO TO 5100-MR-NO-REC-CHECK.
222100*
222200*
222300*
222400 0806-MR-FIELD.
222500*
222600     IF  MBD100WS-JOURNAL
222700         MOVE MTL1-VL03-B-DATA-X TO MMMM-OFFICER-ID.
222800*
222900     MOVE 'OFFICER ID            '
223000                                 TO MBD100WS-PL1-DESC.
223100     MOVE MMMM-OFFICER-ID        TO MBD100WS-PL1-FROM-VALUE.
223200     MOVE MTL1-VL03-A-DATA-X     TO MMMM-OFFICER-ID.
223300     MOVE MMMM-OFFICER-ID        TO MBD100WS-PL2-TO-VALUE.
223400     GO TO 5100-MR-NO-REC-CHECK.
223500*
223600*
223700*
223800 0807-MR-FIELD.
223900*
224000     IF  MBD100WS-JOURNAL
224100         MOVE MTL1-VL20-B-DATA-X TO MMMM-TAX-ID.
224200*
224300     MOVE 'TAX ID NUMBER         '
224400                                 TO MBD100WS-PL1-DESC.
224500     MOVE MMMM-TAX-ID            TO MBD100WS-PL1-FROM-VALUE.
224600     MOVE MTL1-VL20-A-DATA-X     TO MMMM-TAX-ID.
224700     MOVE MMMM-TAX-ID            TO MBD100WS-PL2-TO-VALUE.
224800     GO TO 5100-MR-NO-REC-CHECK.
224900*
225000*
225100*
225200 0808-MR-FIELD.
225300*
225400     IF  MBD100WS-JOURNAL
225500         MOVE MTL1-VL02-B-DATA-X TO MMMM-INCORPORATION-STATUS.
225600*
225700     MOVE 'INCORPORATION STATUS  '
225800                                 TO MBD100WS-PL1-DESC.
225900     MOVE MMMM-INCORPORATION-STATUS
226000                                 TO MBD100WS-PL1-FROM-VALUE.
226100     MOVE MTL1-VL02-A-DATA-X     TO MMMM-INCORPORATION-STATUS.
226200     MOVE MMMM-INCORPORATION-STATUS
226300                                 TO MBD100WS-PL2-TO-VALUE.
226400     GO TO 5100-MR-NO-REC-CHECK.
226500*
226600*
226700*
226800 0809-MR-FIELD.
226900*
227000     IF  MBD100WS-JOURNAL
227100         MOVE MTL1-VL30-B-DATA-X TO MMMM-SOLE-PROP-LAST.
227200*
227300     MOVE 'SOLE PROP LAST NAME   '
227400                                 TO MBD100WS-PL1-DESC.
227500     MOVE MMMM-SOLE-PROP-LAST    TO MBD100WS-PL1-FROM-VALUE.
227600     MOVE MTL1-VL30-A-DATA-X     TO MMMM-SOLE-PROP-LAST.
227700     MOVE MMMM-SOLE-PROP-LAST    TO MBD100WS-PL2-TO-VALUE.
227800     GO TO 5100-MR-NO-REC-CHECK.
227900*
228000*
228100*
228200 0810-MR-FIELD.
228300*
228400     IF  MBD100WS-JOURNAL
228500         MOVE MTL1-VL30-B-DATA-X TO MMMM-SOLE-PROP-FIRST.
228600*
228700     MOVE 'SOLE PROP FIRST NAME  '
228800                                 TO MBD100WS-PL1-DESC.
228900     MOVE MMMM-SOLE-PROP-FIRST   TO MBD100WS-PL1-FROM-VALUE.
229000     MOVE MTL1-VL30-A-DATA-X     TO MMMM-SOLE-PROP-FIRST.
229100     MOVE MMMM-SOLE-PROP-FIRST   TO MBD100WS-PL2-TO-VALUE.
229200     GO TO 5100-MR-NO-REC-CHECK.
229300*
229400*
229500*
229600 0811-MR-FIELD.
229700*
229800     IF  MBD100WS-JOURNAL
229900         MOVE MTL1-VL01-B-DATA-X TO MMMM-SOLE-PROP-INITIAL.
230000*
230100     MOVE 'SOLE PROP INITIAL     '
230200                                 TO MBD100WS-PL1-DESC.
230300     MOVE MMMM-SOLE-PROP-INITIAL TO MBD100WS-PL1-FROM-VALUE.
230400     MOVE MTL1-VL01-A-DATA-X     TO MMMM-SOLE-PROP-INITIAL.
230500     MOVE MMMM-SOLE-PROP-INITIAL TO MBD100WS-PL2-TO-VALUE.
230600     GO TO 5100-MR-NO-REC-CHECK.
230700*
230800*
230900*
231000 0812-MR-FIELD.
231100*
231200     SET X-MMMM-CONTACT          TO MTL1-FIELD-OCCURRENCE.
231300*
231400     IF  MBD100WS-JOURNAL
231500         MOVE MTL1-VL40-B-DATA-X TO MMMM-CONTACT
231600                                    (X-MMMM-CONTACT).
231700*
231800     MOVE 'CONTACT NAME          '
231900                                 TO MBD100WS-PL1-DESC.
232000     MOVE MMMM-CONTACT
232100          (X-MMMM-CONTACT)       TO MBD100WS-PL1-FROM-VALUE.
232200     MOVE MTL1-VL40-A-DATA-X     TO MMMM-CONTACT
232300                                    (X-MMMM-CONTACT).
232400     MOVE MMMM-CONTACT
232500          (X-MMMM-CONTACT)       TO MBD100WS-PL2-TO-VALUE.
232600     GO TO 5100-MR-NO-REC-CHECK.
232700*
232800*
232900*
233000 0813-MR-FIELD.
233100*
233200     SET X-MMMM-CONTACT          TO MTL1-FIELD-OCCURRENCE.
233300*
233400     IF  MBD100WS-JOURNAL
233500         MOVE MTL1-VL20-B-DATA-X TO MMMM-CONTACT-PHONE
233600                                    (X-MMMM-CONTACT).
233700*
233800     MOVE 'CONTACT PHONE         '
233900                                 TO MBD100WS-PL1-DESC.
234000     MOVE MMMM-CONTACT-PHONE
234100          (X-MMMM-CONTACT)       TO MBD100WS-PL1-FROM-VALUE.
234200     MOVE MTL1-VL20-A-DATA-X     TO MMMM-CONTACT-PHONE
234300                                    (X-MMMM-CONTACT).
234400     MOVE MMMM-CONTACT-PHONE
234500          (X-MMMM-CONTACT)       TO MBD100WS-PL2-TO-VALUE.
234600     GO TO 5100-MR-NO-REC-CHECK.
234700*
234800*
234900*
235000 0814-MR-FIELD.
235100*
235200     SET X-MMMM-CONTACT          TO MTL1-FIELD-OCCURRENCE.
235300*
235400     IF  MBD100WS-JOURNAL
235500         MOVE MTL1-VL20-B-DATA-X TO MMMM-CONTACT-FAX
235600                                    (X-MMMM-CONTACT).
235700*
235800     MOVE 'CONTACT FAX           '
235900                                 TO MBD100WS-PL1-DESC.
236000     MOVE MMMM-CONTACT-FAX
236100          (X-MMMM-CONTACT)       TO MBD100WS-PL1-FROM-VALUE.
236200     MOVE MTL1-VL20-A-DATA-X     TO MMMM-CONTACT-FAX
236300                                    (X-MMMM-CONTACT).
236400     MOVE MMMM-CONTACT-FAX
236500          (X-MMMM-CONTACT)       TO MBD100WS-PL2-TO-VALUE.
236600     GO TO 5100-MR-NO-REC-CHECK.
236700*
236800*
236900*
237000 0815-MR-FIELD.
237100*
237200     IF  MBD100WS-JOURNAL
237300         MOVE MTL1-VL03-B-DATA-X TO MMMM-VISIT-REP-OPER.
237400*
237500     MOVE 'VISIT REP OPERATOR ID '
237600                                 TO MBD100WS-PL1-DESC.
237700     MOVE MMMM-VISIT-REP-OPER    TO MBD100WS-PL1-FROM-VALUE.
237800     MOVE MTL1-VL03-A-DATA-X     TO MMMM-VISIT-REP-OPER.
237900     MOVE MMMM-VISIT-REP-OPER    TO MBD100WS-PL2-TO-VALUE.
238000     GO TO 5100-MR-NO-REC-CHECK.
238100*
238200*
238300*
238400 0816-MR-FIELD.
238500*
238600     IF  MBD100WS-JOURNAL
238700         MOVE MTL1-VL02-B-DATA-9 TO MMMM-VISIT-FREQ.
238800*
238900     MOVE 'VISIT FREQUENCY       '
239000                                 TO MBD100WS-PL1-DESC.
239100     MOVE MMMM-VISIT-FREQ        TO MBD100WS-PL1-FV-99.
239200     MOVE MTL1-VL02-A-DATA-9     TO MMMM-VISIT-FREQ.
239300     MOVE MMMM-VISIT-FREQ        TO MBD100WS-PL2-TV-99.
239400     GO TO 5100-MR-NO-REC-CHECK.
239500*
239600*
239700*
239800 0817-MR-FIELD.
239900*
240000     IF  MBD100WS-JOURNAL
240100         MOVE MTL1-VL03-B-DATA-X TO MMMM-REVIEW-REP-OPER.
240200*
240300     MOVE 'REVIEW REP OPERATOR ID'
240400                                 TO MBD100WS-PL1-DESC.
240500     MOVE MMMM-REVIEW-REP-OPER   TO MBD100WS-PL1-FROM-VALUE.
240600     MOVE MTL1-VL03-A-DATA-X     TO MMMM-REVIEW-REP-OPER.
240700     MOVE MMMM-REVIEW-REP-OPER   TO MBD100WS-PL2-TO-VALUE.
240800     GO TO 5100-MR-NO-REC-CHECK.
240900*
241000*
241100*
241200 0818-MR-FIELD.
241300*
241400     IF  MBD100WS-JOURNAL
241500         MOVE MTL1-VL02-B-DATA-9 TO MMMM-REVIEW-FREQ.
241600*
241700     MOVE 'REVIEW FREQUENCY      '
241800                                 TO MBD100WS-PL1-DESC.
241900     MOVE MMMM-REVIEW-FREQ       TO MBD100WS-PL1-FV-99.
242000     MOVE MTL1-VL02-A-DATA-9     TO MMMM-REVIEW-FREQ.
242100     MOVE MMMM-REVIEW-FREQ       TO MBD100WS-PL2-TV-99.
242200     GO TO 5100-MR-NO-REC-CHECK.
242300*
242400*
242500*
242600 0819-MR-FIELD.
242700*
242800     IF  MBD100WS-JOURNAL
242900         MOVE MTL1-VL07-B-DATA-9 TO MMMM-DATE-LAST-VISIT.
243000*
243100     MOVE 'DATE LAST VISIT       '
243200                                 TO MBD100WS-PL1-DESC.
243300     MOVE MMMM-DATE-LAST-VISIT   TO SS01WS-JULIAN.
243400     PERFORM 8100-FROM-DATE      THRU 8199-FD-EXIT.
243500     MOVE MTL1-VL07-A-DATA-9     TO MMMM-DATE-LAST-VISIT.
243600     MOVE MMMM-DATE-LAST-VISIT   TO SS01WS-JULIAN.
243700     PERFORM 8200-TO-DATE        THRU 8299-TD-EXIT.
243800     GO TO 5100-MR-NO-REC-CHECK.
243900*
244000*
244100*
244200 0820-MR-FIELD.
244300*
244400     IF  MBD100WS-JOURNAL
244500         MOVE MTL1-VL07-B-DATA-9 TO MMMM-DATE-LAST-REVIEW.
244600*
244700     MOVE 'DATE LAST REVIEW      '
244800                                 TO MBD100WS-PL1-DESC.
244900     MOVE MMMM-DATE-LAST-REVIEW  TO SS01WS-JULIAN.
245000     PERFORM 8100-FROM-DATE      THRU 8199-FD-EXIT.
245100     MOVE MTL1-VL07-A-DATA-9     TO MMMM-DATE-LAST-REVIEW.
245200     MOVE MMMM-DATE-LAST-REVIEW  TO SS01WS-JULIAN.
245300     PERFORM 8200-TO-DATE        THRU 8299-TD-EXIT.
245400     GO TO 5100-MR-NO-REC-CHECK.
245500*
245600*
245700*
245800 0821-MR-FIELD.
245900*
246000     IF  MBD100WS-JOURNAL
246100         MOVE MTL1-VL07-B-DATA-9 TO MMMM-DATE-NEXT-VISIT.
246200*
246300     MOVE 'DATE NEXT VISIT       '
246400                                 TO MBD100WS-PL1-DESC.
246500     MOVE MMMM-DATE-NEXT-VISIT   TO SS01WS-JULIAN.
246600     PERFORM 8100-FROM-DATE      THRU 8199-FD-EXIT.
246700     MOVE MTL1-VL07-A-DATA-9     TO MMMM-DATE-NEXT-VISIT.
246800     MOVE MMMM-DATE-NEXT-VISIT   TO SS01WS-JULIAN.
246900     PERFORM 8200-TO-DATE        THRU 8299-TD-EXIT.
247000     GO TO 5100-MR-NO-REC-CHECK.
247100*
247200*
247300*
247400 0822-MR-FIELD.
247500*
247600     IF  MBD100WS-JOURNAL
247700         MOVE MTL1-VL07-B-DATA-9 TO MMMM-DATE-NEXT-REVIEW.
247800*
247900     MOVE 'DATE NEXT REVIEW      '
248000                                 TO MBD100WS-PL1-DESC.
248100     MOVE MMMM-DATE-NEXT-REVIEW  TO SS01WS-JULIAN.
248200     PERFORM 8100-FROM-DATE      THRU 8199-FD-EXIT.
248300     MOVE MTL1-VL07-A-DATA-9     TO MMMM-DATE-NEXT-REVIEW.
248400     MOVE MMMM-DATE-NEXT-REVIEW  TO SS01WS-JULIAN.
248500     PERFORM 8200-TO-DATE        THRU 8299-TD-EXIT.
248600     GO TO 5100-MR-NO-REC-CHECK.
248700*
248800*
248900*
249000 0823-MR-FIELD.
249100*
249200     IF  MBD100WS-JOURNAL
249300         MOVE MTL1-VL40-B-DATA-X TO MMMM-VISIT-REP-NAME.
249400*
249500     MOVE 'VISIT REP NAME        '
249600                                 TO MBD100WS-PL1-DESC.
249700     MOVE MMMM-VISIT-REP-NAME    TO MBD100WS-PL1-FROM-VALUE.
249800     MOVE MTL1-VL40-A-DATA-X     TO MMMM-VISIT-REP-NAME.
249900     MOVE MMMM-VISIT-REP-NAME    TO MBD100WS-PL2-TO-VALUE.
250000     GO TO 5100-MR-NO-REC-CHECK.
250100*
250200*
250300*
250400 0824-MR-FIELD.
250500*
250600     IF  MBD100WS-JOURNAL
250700         MOVE MTL1-VL40-B-DATA-X TO MMMM-REVIEW-REP-NAME.
250800*
250900     MOVE 'REVIEW REP NAME       '
251000                                 TO MBD100WS-PL1-DESC.
251100     MOVE MMMM-REVIEW-REP-NAME   TO MBD100WS-PL1-FROM-VALUE.
251200     MOVE MTL1-VL40-A-DATA-X     TO MMMM-REVIEW-REP-NAME.
251300     MOVE MMMM-REVIEW-REP-NAME   TO MBD100WS-PL2-TO-VALUE.
251400     GO TO 5100-MR-NO-REC-CHECK.
251500*
251600*
251700*
251800 0825-MR-FIELD.
251900*
252000     IF  MBD100WS-JOURNAL
252100         MOVE MTL1-VL01-B-DATA-X TO MMMM-1099-REFUSAL-IND.
252200*
252300     MOVE '1099 REFUSAL INDICATOR'
252400                                 TO MBD100WS-PL1-DESC.
252500     MOVE MMMM-1099-REFUSAL-IND  TO MBD100WS-PL1-FROM-VALUE.
252600     MOVE MTL1-VL01-A-DATA-X     TO MMMM-1099-REFUSAL-IND.
252700     MOVE MMMM-1099-REFUSAL-IND  TO MBD100WS-PL2-TO-VALUE.
252800     GO TO 5100-MR-NO-REC-CHECK.
252900*
253000*
253100*
253200 0826-MR-FIELD.
253300*
253400     IF  MBD100WS-JOURNAL
253500         MOVE MTL1-VL01-B-DATA-X TO MMMM-TIN-TYPE.
253600*
253700     MOVE 'TAXPAYER ID TYPE      '
253800                                 TO MBD100WS-PL1-DESC.
253900     MOVE MMMM-TIN-TYPE          TO MBD100WS-PL1-FROM-VALUE.
254000     MOVE MTL1-VL01-A-DATA-X     TO MMMM-TIN-TYPE.
254100     MOVE MMMM-TIN-TYPE          TO MBD100WS-PL2-TO-VALUE.
254200     GO TO 5100-MR-NO-REC-CHECK.
254300*
254400*
254500*
254600 0827-MR-FIELD.
254700*
254800     IF  MBD100WS-JOURNAL
254900         MOVE MTL1-VL30-B-DATA-X TO MMMM-CORP-LEGAL-NAME.
255000*
255100     MOVE 'CORPORATE/LEGAL NAME  '
255200                                 TO MBD100WS-PL1-DESC.
255300     MOVE MMMM-CORP-LEGAL-NAME   TO MBD100WS-PL1-FROM-VALUE.
255400     MOVE MTL1-VL30-A-DATA-X     TO MMMM-CORP-LEGAL-NAME.
255500     MOVE MMMM-CORP-LEGAL-NAME   TO MBD100WS-PL2-TO-VALUE.
255600     GO TO 5100-MR-NO-REC-CHECK.
255700*
255800*
255900*
256000 0828-MR-FIELD.
256100*
256200     IF  MBD100WS-JOURNAL
256300         MOVE MTL1-VL02-B-DATA-X TO MMMM-MINORITY-CODE.
256400*
256500     MOVE 'MINORITY CODE         '
256600                                 TO MBD100WS-PL1-DESC.
256700     MOVE MMMM-MINORITY-CODE     TO MBD100WS-PL1-FROM-VALUE.
256800     MOVE MTL1-VL02-A-DATA-X     TO MMMM-MINORITY-CODE.
256900     MOVE MMMM-MINORITY-CODE     TO MBD100WS-PL2-TO-VALUE.
257000     GO TO 5100-MR-NO-REC-CHECK.
257100*
257200*
257300 0829-MR-FIELD.
257400*
257500     IF  MBD100WS-JOURNAL
257600         MOVE MTL1-VL01-B-DATA-X TO MMMM-WOMAN-OWNED-CODE.
257700*
257800     MOVE 'WOMAN-OWNED CODE      '
257900                                 TO MBD100WS-PL1-DESC.
258000     MOVE MMMM-WOMAN-OWNED-CODE  TO MBD100WS-PL1-FROM-VALUE.
258100     MOVE MTL1-VL01-A-DATA-X     TO MMMM-WOMAN-OWNED-CODE.
258200     MOVE MMMM-WOMAN-OWNED-CODE  TO MBD100WS-PL2-TO-VALUE.
258300     GO TO 5100-MR-NO-REC-CHECK.
258400*
258500*
258600*
258700 0830-MR-FIELD.
258800*
258900     IF  MBD100WS-JOURNAL
259000         MOVE MTL1-VL10-B-DATA-X TO MMMM-DUN-AND-BRADSTREET-NBR.
259100*
259200     MOVE 'DUN/BRADSTREET NUMBER '
259300                                 TO MBD100WS-PL1-DESC.
259400     MOVE MMMM-DUN-AND-BRADSTREET-NBR
259500                                 TO MBD100WS-PL1-FROM-VALUE.
259600     MOVE MTL1-VL10-A-DATA-X     TO MMMM-DUN-AND-BRADSTREET-NBR.
259700     MOVE MMMM-DUN-AND-BRADSTREET-NBR
259800                                 TO MBD100WS-PL2-TO-VALUE.
259900     GO TO 5100-MR-NO-REC-CHECK.
259905*                                                                 RG802901
259910*                                                                 RG802901
259915*                                                                 RG802901
259920 0831-MR-FIELD.                                                   RG802901
259925*                                                                 RG802901
259930     IF  MBD100WS-JOURNAL                                         RG802901
259935         MOVE MTL1-VL60-B-DATA-X TO MMMM-URL-EMAIL.               RG802901
259940*                                                                 RG802901
259945     MOVE 'URL/E-MAIL ADDRESS    '                                RG802901
259950                                 TO MBD100WS-PL1-DESC.            RG802901
259955     MOVE MMMM-URL-EMAIL         TO MBD100WS-PL1-FROM-VALUE.      RG802901
259960     MOVE MTL1-VL60-A-DATA-X     TO MMMM-URL-EMAIL.               RG802901
259965     MOVE MMMM-URL-EMAIL         TO MBD100WS-PL2-TO-VALUE.        RG802901
259970     GO TO 5100-MR-NO-REC-CHECK.                                  RG802901
260000*
260100*
260200*
260300 0901-MR-FIELD.
260400*
260500     SET X-MMMM-MERCH-CHAIN      TO MTL1-FIELD-OCCURRENCE.
260600*
260700     IF  MBD100WS-JOURNAL
260800         MOVE MTL1-VL10-B-DATA-9 TO MMMM-MERCH-CHAIN-ID
260900                                    (X-MMMM-MERCH-CHAIN).
261000*
261100     MOVE 'MERCHANT CHAIN ID     '
261200                                 TO MBD100WS-PL1-DESC.
261300     MOVE MMMM-MERCH-CHAIN-ID
261400          (X-MMMM-MERCH-CHAIN)   TO MBD100WS-PL1-FV-999999999.
261500     MOVE MTL1-VL10-A-DATA-9     TO MMMM-MERCH-CHAIN-ID
261600                                    (X-MMMM-MERCH-CHAIN).
261700     MOVE MMMM-MERCH-CHAIN-ID
261800          (X-MMMM-MERCH-CHAIN)   TO MBD100WS-PL2-TV-999999999.
261900     GO TO 5100-MR-NO-REC-CHECK.
262000*
262100*
262200*
262300 0902-MR-FIELD.
262400*
262500     SET X-MMMM-IMP              TO MTL1-FIELD-OCCURRENCE.
262600*
262700     IF  MBD100WS-JOURNAL
262800         MOVE MTL1-VL20-B-DATA-X TO MMMM-IMP-DEV-TITLE
262900                                    (X-MMMM-IMP).
263000*
263100     MOVE 'IMPRINTER DEVICE TITLE'
263200                                 TO MBD100WS-PL1-DESC.
263300     MOVE MMMM-IMP-DEV-TITLE
263400          (X-MMMM-IMP)           TO MBD100WS-PL1-FROM-VALUE.
263500     MOVE MTL1-VL20-A-DATA-X     TO MMMM-IMP-DEV-TITLE
263600                                    (X-MMMM-IMP).
263700     MOVE MMMM-IMP-DEV-TITLE
263800          (X-MMMM-IMP)           TO MBD100WS-PL2-TO-VALUE.
263900     GO TO 5100-MR-NO-REC-CHECK.
264000*
264100*
264200*
264300 0903-MR-FIELD.
264400*
264500     SET X-MMMM-IMP              TO MTL1-FIELD-OCCURRENCE.
264600*
264700     IF  MBD100WS-JOURNAL
264800         MOVE MTL1-VL05-B-DATA-9 TO MMMM-IMP-DEV-NBR
264900                                    (X-MMMM-IMP).
265000*
265100     MOVE 'IMPRINTER DEVICE NBR  '
265200                                 TO MBD100WS-PL1-DESC.
265300     MOVE MMMM-IMP-DEV-NBR
265400          (X-MMMM-IMP)           TO MBD100WS-PL1-FV-99999.
265500     MOVE MTL1-VL05-A-DATA-9     TO MMMM-IMP-DEV-NBR
265600                                    (X-MMMM-IMP).
265700     MOVE MMMM-IMP-DEV-NBR
265800          (X-MMMM-IMP)           TO MBD100WS-PL2-TV-99999.
265900     GO TO 5100-MR-NO-REC-CHECK.
266000*
266100*
266200*
266300 0904-MR-FIELD.
266400*
266500     SET X-MMMM-POS              TO MTL1-FIELD-OCCURRENCE.
266600*
266700     IF  MBD100WS-JOURNAL
266800         MOVE MTL1-VL20-B-DATA-X TO MMMM-POS-DEV-TITLE
266900                                    (X-MMMM-POS).
267000*
267100     MOVE 'POS DEVICE TITLE      '
267200                                 TO MBD100WS-PL1-DESC.
267300     MOVE MMMM-POS-DEV-TITLE
267400          (X-MMMM-POS)           TO MBD100WS-PL1-FROM-VALUE.
267500     MOVE MTL1-VL20-A-DATA-X     TO MMMM-POS-DEV-TITLE
267600                                    (X-MMMM-POS).
267700     MOVE MMMM-POS-DEV-TITLE
267800          (X-MMMM-POS)           TO MBD100WS-PL2-TO-VALUE.
267900     GO TO 5100-MR-NO-REC-CHECK.
268000*
268100*
268200*
268300 0905-MR-FIELD.
268400*
268500     SET X-MMMM-POS              TO MTL1-FIELD-OCCURRENCE.
268600*
268700     IF  MBD100WS-JOURNAL
268800         MOVE MTL1-VL05-B-DATA-9 TO MMMM-POS-DEV-NBR
268900                                    (X-MMMM-POS).
269000*
269100     MOVE 'POS DEVICE NUMBER     '
269200                                 TO MBD100WS-PL1-DESC.
269300     MOVE MMMM-POS-DEV-NBR
269400          (X-MMMM-POS)           TO MBD100WS-PL1-FV-99999.
269500     MOVE MTL1-VL05-A-DATA-9     TO MMMM-POS-DEV-NBR
269600                                    (X-MMMM-POS).
269700     MOVE MMMM-POS-DEV-NBR
269800          (X-MMMM-POS)           TO MBD100WS-PL2-TV-99999.
269900     GO TO 5100-MR-NO-REC-CHECK.
270000*
270100*
270200*
270300 0906-MR-FIELD.
270400*
270500     SET X-MMMM-MEMO             TO MTL1-FIELD-OCCURRENCE.
270600*
270700     IF  MBD100WS-JOURNAL
270800         MOVE MTL1-VL50-B-DATA-X TO MMMM-MEMO
270900                                    (X-MMMM-MEMO).
271000*
271100     MOVE 'STORE MEMO            '
271200                                 TO MBD100WS-PL1-DESC.
271300     MOVE MMMM-MEMO
271400          (X-MMMM-MEMO)          TO MBD100WS-PL1-FROM-VALUE.
271500     MOVE MTL1-VL50-A-DATA-X     TO MMMM-MEMO
271600                                    (X-MMMM-MEMO).
271700     MOVE MMMM-MEMO
271800          (X-MMMM-MEMO)          TO MBD100WS-PL2-TO-VALUE.
271900     GO TO 5100-MR-NO-REC-CHECK.
272000*
272100*
272200*
272300 0907-MR-FIELD.
272400*
272500     SET X-MMMM-STMT-CHAIN       TO MTL1-FIELD-OCCURRENCE.
272600*
272700     IF  MBD100WS-JOURNAL
272800         MOVE MTL1-VL01-B-DATA-X TO MMMM-STMT-CHAIN-FLAG
272900                                    (X-MMMM-STMT-CHAIN).
273000*
273100     MOVE 'STATEMENT CHAIN FLAG  '
273200                                 TO MBD100WS-PL1-DESC.
273300     MOVE MMMM-STMT-CHAIN-FLAG
273400          (X-MMMM-STMT-CHAIN)    TO MBD100WS-PL1-FROM-VALUE.
273500     MOVE MTL1-VL01-A-DATA-X     TO MMMM-STMT-CHAIN-FLAG
273600                                    (X-MMMM-STMT-CHAIN).
273700     MOVE MMMM-STMT-CHAIN-FLAG
273800          (X-MMMM-STMT-CHAIN)    TO MBD100WS-PL2-TO-VALUE.
273900     GO TO 5100-MR-NO-REC-CHECK.
274000*
274100*
274200*
274300 0908-MR-FIELD.
274400*
274500     IF  MBD100WS-JOURNAL
274600         MOVE MTL1-VL07-B-DATA-9 TO MMMM-BI-WEEKLY-STMT-DATE.
274700*
274800     MOVE 'BI-WEEKLY STMT DATE   '
274900                                 TO MBD100WS-PL1-DESC.
275000     MOVE MMMM-BI-WEEKLY-STMT-DATE
275100                                 TO SS01WS-JULIAN.
275200     PERFORM 8100-FROM-DATE      THRU 8199-FD-EXIT.
275300     MOVE MTL1-VL07-A-DATA-9     TO MMMM-BI-WEEKLY-STMT-DATE.
275400     MOVE MMMM-BI-WEEKLY-STMT-DATE
275500                                 TO SS01WS-JULIAN.
275600     PERFORM 8200-TO-DATE        THRU 8299-TD-EXIT.
275700     GO TO 5100-MR-NO-REC-CHECK.
275800*
275900*
276000*
276100 0909-MR-FIELD.
276200*
276300     IF  MBD100WS-JOURNAL
276400         MOVE MTL1-VL10-B-DATA-9 TO MMMM-NBR-BULLETINS.
276500*
276600     MOVE 'NUMBER OF BULLETINS   '
276700                                 TO MBD100WS-PL1-DESC.
276800     MOVE MMMM-NBR-BULLETINS     TO MBD100WS-PL1-FV-999999999.
276900     MOVE MTL1-VL10-A-DATA-9     TO MMMM-NBR-BULLETINS.
277000     MOVE MMMM-NBR-BULLETINS     TO MBD100WS-PL2-TV-999999999.
277100     GO TO 5100-MR-NO-REC-CHECK.
277200*
277300*
277400*
277500 0910-MR-FIELD.
277600*
277700     IF  MBD100WS-JOURNAL
277800         MOVE MTL1-VL10-B-DATA-9 TO MMMM-NBR-STORES.
277900*
278000     MOVE 'NUMBER OF STORES      '
278100                                 TO MBD100WS-PL1-DESC.
278200     MOVE MMMM-NBR-STORES        TO MBD100WS-PL1-FV-999999999.
278300     MOVE MTL1-VL10-A-DATA-9     TO MMMM-NBR-STORES.
278400     MOVE MMMM-NBR-STORES        TO MBD100WS-PL2-TV-999999999.
278500     GO TO 5100-MR-NO-REC-CHECK.
278600*
278700*
278800*
278900 1001-MR-FIELD.
279000*
279100     IF  MBD100WS-JOURNAL
279200         MOVE MTL1-VL10-B-DATA-9 TO MMMM-FRAUD-TABLE.
279300*
279400     MOVE 'FRAUD TABLE           '
279500                                 TO MBD100WS-PL1-DESC.
279600     MOVE MMMM-FRAUD-TABLE       TO MBD100WS-PL1-FV-999999999.
279700     MOVE MTL1-VL10-A-DATA-9     TO MMMM-FRAUD-TABLE.
279800     MOVE MMMM-FRAUD-TABLE       TO MBD100WS-PL2-TV-999999999.
279900     GO TO 5100-MR-NO-REC-CHECK.
280000*
280100*
280200*
280300 1002-MR-FIELD.
280400*
280500     SET X-MMMM-FRAUD-PROJ       TO MTL1-FIELD-OCCURRENCE.
280600*
280700     IF  MBD100WS-JOURNAL
280800         MOVE MTL1-VL20-B-NBR-NO-DEC
280900                                 TO MMMM-PROJ-AMT
281000                                    (X-MMMM-FRAUD-PROJ).
281100*
281200     MOVE 'PROJECTED AMOUNT      '
281300                                 TO MBD100WS-PL1-DESC.
281400     MOVE MMMM-PROJ-AMT
281500          (X-MMMM-FRAUD-PROJ)    TO SS95WS-IN-AMT.
281600     PERFORM SS95PD-NAP-ROUTINE
281700                                 THRU SS95PD-NAP-EXIT.
281800     MOVE SS95WS-OUT-AMT-L23     TO MBD100WS-PL1-FROM-VALUE.
281900     MOVE MTL1-VL20-A-NBR-NO-DEC TO MMMM-PROJ-AMT
282000                                    (X-MMMM-FRAUD-PROJ).
282100     MOVE MMMM-PROJ-AMT
282200          (X-MMMM-FRAUD-PROJ)    TO SS95WS-IN-AMT.
282300     PERFORM SS95PD-NAP-ROUTINE
282400                                 THRU SS95PD-NAP-EXIT.
282500     MOVE SS95WS-OUT-AMT-L23     TO MBD100WS-PL2-TO-VALUE.
282600     GO TO 5100-MR-NO-REC-CHECK.
282700*
282800*
282900*
283000 1003-MR-FIELD.
283100*
283200     SET X-MMMM-FRAUD-PROJ       TO MTL1-FIELD-OCCURRENCE.
283300*
283400     IF  MBD100WS-JOURNAL
283500         MOVE MTL1-VL20-B-NBR-NO-DEC
283600                                 TO MMMM-PROJ-NBR
283700                                    (X-MMMM-FRAUD-PROJ).
283800*
283900     MOVE 'PROJECTED NUMBER      '
284000                                 TO MBD100WS-PL1-DESC.
284100     MOVE MMMM-PROJ-NBR
284200          (X-MMMM-FRAUD-PROJ)    TO SS95WS-IN-NBR.
284300     PERFORM SS95PD-NAP-ROUTINE
284400                                 THRU SS95PD-NAP-EXIT.
284500     MOVE SS95WS-OUT-NBR-L12     TO MBD100WS-PL1-FROM-VALUE.
284600     MOVE MTL1-VL20-A-NBR-NO-DEC TO MMMM-PROJ-NBR
284700                                    (X-MMMM-FRAUD-PROJ).
284800     MOVE MMMM-PROJ-NBR
284900          (X-MMMM-FRAUD-PROJ)    TO SS95WS-IN-NBR.
285000     PERFORM SS95PD-NAP-ROUTINE
285100                                 THRU SS95PD-NAP-EXIT.
285200     MOVE SS95WS-OUT-NBR-L12     TO MBD100WS-PL2-TO-VALUE.
285300     GO TO 5100-MR-NO-REC-CHECK.
285400*
285500*
285600*
285700 1004-MR-FIELD.
285800*
285900     IF  MBD100WS-JOURNAL
286000         MOVE MTL1-VL03-B-DATA-9 TO MMMM-DUP-SALES-BATCH-NBR-C-H. RG800902
286100*
286200     MOVE 'DUP SALES BATCH NBR   '                                RG800902
286300                                 TO MBD100WS-PL1-DESC.
286400     MOVE MMMM-DUP-SALES-BATCH-NBR-C-H                            RG800902
286500                                 TO MBD100WS-PL1-FV-999.
286600     MOVE MTL1-VL03-A-DATA-9     TO MMMM-DUP-SALES-BATCH-NBR-C-H  RG800902
286700     MOVE MMMM-DUP-SALES-BATCH-NBR-C-H                            RG800902
286800                                 TO MBD100WS-PL2-TV-999.
286900     GO TO 5100-MR-NO-REC-CHECK.
287000*
287100*
287200*
287300 1005-MR-FIELD.
287400*
287500     IF  MBD100WS-JOURNAL
287600         MOVE MTL1-VL03-B-DATA-9 TO MMMM-DUP-SALES-DAY-NBR-C-H.   RG800902
287700*
287800     MOVE 'DUP SALES DAY NBR     '                                RG800902
287900                                 TO MBD100WS-PL1-DESC.
288000     MOVE MMMM-DUP-SALES-DAY-NBR-C-H                              RG800902
288100                                 TO MBD100WS-PL1-FV-999.
288200     MOVE MTL1-VL03-A-DATA-9     TO MMMM-DUP-SALES-DAY-NBR-C-H    RG800902
288300     MOVE MMMM-DUP-SALES-DAY-NBR-C-H                              RG800902
288400                                 TO MBD100WS-PL2-TV-999.
288500     GO TO 5100-MR-NO-REC-CHECK.
288600*
288700*
288800*
288900 1006-MR-FIELD.
289000*
289100     IF  MBD100WS-JOURNAL
289200         MOVE MTL1-VL02-B-DATA-9 TO MMMM-FRAUD-AVG-NBR-MONTHS.
289300*
289400     MOVE 'FRAUD AVG NBR MONTHS  '
289500                                 TO MBD100WS-PL1-DESC.
289600     MOVE MMMM-FRAUD-AVG-NBR-MONTHS
289700                                 TO MBD100WS-PL1-FV-99.
289800     MOVE MTL1-VL02-A-DATA-9     TO MMMM-FRAUD-AVG-NBR-MONTHS.
289900     MOVE MMMM-FRAUD-AVG-NBR-MONTHS
290000                                 TO MBD100WS-PL2-TV-99.
290100     GO TO 5100-MR-NO-REC-CHECK.
290102*                                                                 RG800902
290104*                                                                 RG800902
290106*                                                                 RG800902
290108 1007-MR-FIELD.                                                   RG800902
290110*                                                                 RG800902
290112     IF  MBD100WS-JOURNAL                                         RG800902
290114         MOVE MTL1-VL20-B-NBR-NO-DEC                              RG800902
290116                                 TO MMMM-DUP-SALES-DAY-AMT-C-H.   RG800902
290118*                                                                 RG800902
290120     MOVE 'DUP SALES DAY AMT     '                                RG800902
290122                                 TO MBD100WS-PL1-DESC.            RG800902
290124     MOVE MMMM-DUP-SALES-DAY-AMT-C-H                              RG800902
290126                                 TO SS95WS-IN-AMT.                RG800902
290128     PERFORM SS95PD-NAP-ROUTINE                                   RG800902
290130                                 THRU SS95PD-NAP-EXIT.            RG800902
290132     MOVE SS95WS-OUT-AMT-L23     TO MBD100WS-PL1-FROM-VALUE.      RG800902
290134     MOVE MTL1-VL20-A-NBR-NO-DEC TO MMMM-DUP-SALES-DAY-AMT-C-H.   RG800902
290136     MOVE MMMM-DUP-SALES-DAY-AMT-C-H                              RG800902
290138                                 TO SS95WS-IN-AMT.                RG800902
290140     PERFORM SS95PD-NAP-ROUTINE                                   RG800902
290142                                 THRU SS95PD-NAP-EXIT.            RG800902
290144     MOVE SS95WS-OUT-AMT-L23     TO MBD100WS-PL2-TO-VALUE.        RG800902
290146     GO TO 5100-MR-NO-REC-CHECK.                                  RG800902
290148*                                                                 RG800902
290150*                                                                 RG800902
290152*                                                                 RG800902
290154 1008-MR-FIELD.                                                   RG800902
290156*                                                                 RG800902
290158     IF  MBD100WS-JOURNAL                                         RG800902
290160         MOVE MTL1-VL03-B-DATA-9 TO MMMM-DUP-AUTHS-BATCH-NBR-C-H. RG800902
290162*                                                                 RG800902
290164     MOVE 'DUP AUTHS BATCH NBR   '                                RG800902
290166                                 TO MBD100WS-PL1-DESC.            RG800902
290168     MOVE MMMM-DUP-AUTHS-BATCH-NBR-C-H                            RG800902
290170                                 TO MBD100WS-PL1-FV-999.          RG800902
290172     MOVE MTL1-VL03-A-DATA-9     TO MMMM-DUP-AUTHS-BATCH-NBR-C-H. RG800902
290174     MOVE MMMM-DUP-AUTHS-BATCH-NBR-C-H                            RG800902
290176                                 TO MBD100WS-PL2-TV-999.          RG800902
290178     GO TO 5100-MR-NO-REC-CHECK.                                  RG800902
290180*                                                                 RG800902
290182*                                                                 RG800902
290184*                                                                 RG800902
290186 1009-MR-FIELD.                                                   RG800902
290188*                                                                 RG800902
290190     IF  MBD100WS-JOURNAL                                         RG800902
290192         MOVE MTL1-VL03-B-DATA-9 TO MMMM-DUP-AUTHS-DAY-NBR-C-H.   RG800902
290194*                                                                 RG800902
290196     MOVE 'DUP AUTHS DAY NBR     '                                RG800902
290198                                 TO MBD100WS-PL1-DESC.            RG800902
290200     MOVE MMMM-DUP-AUTHS-DAY-NBR-C-H                              RG800902
290202                                 TO MBD100WS-PL1-FV-999.          RG800902
290204     MOVE MTL1-VL03-A-DATA-9     TO MMMM-DUP-AUTHS-DAY-NBR-C-H.   RG800902
290206     MOVE MMMM-DUP-AUTHS-DAY-NBR-C-H                              RG800902
290208                                 TO MBD100WS-PL2-TV-999.          RG800902
290210     GO TO 5100-MR-NO-REC-CHECK.                                  RG800902
290212*                                                                 RG800902
290214*                                                                 RG800902
290216*                                                                 RG800902
290218 1010-MR-FIELD.                                                   RG800902
290220*                                                                 RG800902
290222     IF  MBD100WS-JOURNAL                                         RG800902
290224         MOVE MTL1-VL20-B-NBR-NO-DEC                              RG800902
290226                                 TO MMMM-DUP-AUTHS-DAY-AMT-C-H.   RG800902
290228*                                                                 RG800902
290230     MOVE 'DUP AUTHS DAY AMT     '                                RG800902
290232                                 TO MBD100WS-PL1-DESC.            RG800902
290234     MOVE MMMM-DUP-AUTHS-DAY-AMT-C-H                              RG800902
290236                                 TO SS95WS-IN-AMT.                RG800902
290238     PERFORM SS95PD-NAP-ROUTINE                                   RG800902
290240                                 THRU SS95PD-NAP-EXIT.            RG800902
290242     MOVE SS95WS-OUT-AMT-L23     TO MBD100WS-PL1-FROM-VALUE.      RG800902
290244     MOVE MTL1-VL20-A-NBR-NO-DEC TO MMMM-DUP-AUTHS-DAY-AMT-C-H.   RG800902
290246     MOVE MMMM-DUP-AUTHS-DAY-AMT-C-H                              RG800902
290248                                 TO SS95WS-IN-AMT.                RG800902
290250     PERFORM SS95PD-NAP-ROUTINE                                   RG800902
290252                                 THRU SS95PD-NAP-EXIT.            RG800902
290254     MOVE SS95WS-OUT-AMT-L23     TO MBD100WS-PL2-TO-VALUE.        RG800902
290256     GO TO 5100-MR-NO-REC-CHECK.                                  RG800902
290299*                                                                 RG800902
290300*
290400*
290500 1101-MR-FIELD.
290600*
290700     SET X-MMMM-USER-DATA        TO MTL1-FIELD-OCCURRENCE.
290800*
290900     IF  MBD100WS-JOURNAL
291000         MOVE MTL1-VL20-B-DATA-X TO MMMM-USER-DATA-TITLE
291100                                    (X-MMMM-USER-DATA).
291200*
291300     MOVE 'USER DATA TITLE       '
291400                                 TO MBD100WS-PL1-DESC.
291500     MOVE MMMM-USER-DATA-TITLE
291600          (X-MMMM-USER-DATA)     TO MBD100WS-PL1-FROM-VALUE.
291700     MOVE MTL1-VL20-A-DATA-X     TO MMMM-USER-DATA-TITLE
291800                                    (X-MMMM-USER-DATA).
291900     MOVE MMMM-USER-DATA-TITLE
292000          (X-MMMM-USER-DATA)     TO MBD100WS-PL2-TO-VALUE.
292100     GO TO 5100-MR-NO-REC-CHECK.
292200*
292300*
292400*
292500 1102-MR-FIELD.
292600*
292700     SET X-MMMM-USER-DATA        TO MTL1-FIELD-OCCURRENCE.
292800*
292900     IF  MBD100WS-JOURNAL
293000         MOVE MTL1-VL20-B-DATA-X TO MMMM-USER-DATA
293100                                    (X-MMMM-USER-DATA).
293200*
293300     MOVE 'USER DATA             '
293400                                 TO MBD100WS-PL1-DESC.
293500     MOVE MMMM-USER-DATA
293600          (X-MMMM-USER-DATA)     TO MBD100WS-PL1-FROM-VALUE.
293700     MOVE MTL1-VL20-A-DATA-X     TO MMMM-USER-DATA
293800                                    (X-MMMM-USER-DATA).
293900     MOVE MMMM-USER-DATA
294000          (X-MMMM-USER-DATA)     TO MBD100WS-PL2-TO-VALUE.
294100     GO TO 5100-MR-NO-REC-CHECK.
294200*
294300*
294400*
294500 1103-MR-FIELD.
294600*
294700     SET X-MMMM-USER-DATE        TO MTL1-FIELD-OCCURRENCE.
294800*
294900     IF  MBD100WS-JOURNAL
295000         MOVE MTL1-VL20-B-DATA-X TO MMMM-USER-DATE-TITLE
295100                                    (X-MMMM-USER-DATE).
295200*
295300     MOVE 'USER DATE TITLE       '
295400                                 TO MBD100WS-PL1-DESC.
295500     MOVE MMMM-USER-DATE-TITLE
295600          (X-MMMM-USER-DATE)     TO MBD100WS-PL1-FROM-VALUE.
295700     MOVE MTL1-VL20-A-DATA-X     TO MMMM-USER-DATE-TITLE
295800                                    (X-MMMM-USER-DATE).
295900     MOVE MMMM-USER-DATE-TITLE
296000          (X-MMMM-USER-DATE)     TO MBD100WS-PL2-TO-VALUE.
296100     GO TO 5100-MR-NO-REC-CHECK.
296200*
296300*
296400*
296500 1104-MR-FIELD.
296600*
296700     SET X-MMMM-USER-DATE        TO MTL1-FIELD-OCCURRENCE.
296800*
296900     IF  MBD100WS-JOURNAL
297000         MOVE MTL1-VL07-B-DATA-9 TO MMMM-USER-DATE
297100                                    (X-MMMM-USER-DATE).
297200*
297300     MOVE 'USER DATE             '
297400                                 TO MBD100WS-PL1-DESC.
297500     MOVE MMMM-USER-DATE
297600          (X-MMMM-USER-DATE)     TO SS01WS-JULIAN.
297700     PERFORM 8100-FROM-DATE      THRU 8199-FD-EXIT.
297800     MOVE MTL1-VL07-A-DATA-9     TO MMMM-USER-DATE
297900                                    (X-MMMM-USER-DATE).
298000     MOVE MMMM-USER-DATE
298100          (X-MMMM-USER-DATE)     TO SS01WS-JULIAN.
298200     PERFORM 8200-TO-DATE        THRU 8299-TD-EXIT.
298300     GO TO 5100-MR-NO-REC-CHECK.
298400*
298500*
298600*
298700 1105-MR-FIELD.
298800*
298900     SET X-MMMM-USER-AMT         TO MTL1-FIELD-OCCURRENCE.
299000*
299100     IF  MBD100WS-JOURNAL
299200         MOVE MTL1-VL20-B-DATA-X TO MMMM-USER-AMT-TITLE
299300                                    (X-MMMM-USER-AMT).
299400*
299500     MOVE 'USER AMOUNT TITLE     '
299600                                 TO MBD100WS-PL1-DESC.
299700     MOVE MMMM-USER-AMT-TITLE
299800          (X-MMMM-USER-AMT)      TO MBD100WS-PL1-FROM-VALUE.
299900     MOVE MTL1-VL20-A-DATA-X     TO MMMM-USER-AMT-TITLE
300000                                    (X-MMMM-USER-AMT).
300100     MOVE MMMM-USER-AMT-TITLE
300200          (X-MMMM-USER-AMT)      TO MBD100WS-PL2-TO-VALUE.
300300     GO TO 5100-MR-NO-REC-CHECK.
300400*
300500*
300600*
300700 1106-MR-FIELD.
300800*
300900     SET X-MMMM-USER-AMT         TO MTL1-FIELD-OCCURRENCE.
301000*
301100     IF  MBD100WS-JOURNAL
301200         MOVE MTL1-VL20-B-NBR-NO-DEC
301300                                 TO MMMM-USER-AMT
301400                                    (X-MMMM-USER-AMT).
301500*
301600     MOVE 'USER AMOUNT           '
301700                                 TO MBD100WS-PL1-DESC.
301800     MOVE MMMM-USER-AMT
301900          (X-MMMM-USER-AMT)      TO SS95WS-IN-AMT.
302000     PERFORM SS95PD-NAP-ROUTINE
302100                                 THRU SS95PD-NAP-EXIT.
302200     MOVE SS95WS-OUT-AMT-L23     TO MBD100WS-PL1-FROM-VALUE.
302300     MOVE MTL1-VL20-A-NBR-NO-DEC TO MMMM-USER-AMT
302400                                    (X-MMMM-USER-AMT).
302500     MOVE MMMM-USER-AMT
302600          (X-MMMM-USER-AMT)      TO SS95WS-IN-AMT.
302700     PERFORM SS95PD-NAP-ROUTINE
302800                                 THRU SS95PD-NAP-EXIT.
302900     MOVE SS95WS-OUT-AMT-L23     TO MBD100WS-PL2-TO-VALUE.
303000     GO TO 5100-MR-NO-REC-CHECK.
303100*
303200*
303300*
303400 1201-MR-FIELD.
303500*
303600     IF  MBD100WS-JOURNAL
303700         MOVE MTL1-VL10-B-DATA-9 TO MMMM-STORE-NBR.
303800*
303900     MOVE 'SINGLE STORE NUMBER   '
304000                                 TO MBD100WS-PL1-DESC.
304100     MOVE MMMM-STORE-NBR         TO MBD100WS-PL1-FV-999999999.
304200     MOVE MTL1-VL10-A-DATA-9     TO MMMM-STORE-NBR.
304300     MOVE MMMM-STORE-NBR         TO MBD100WS-PL2-TV-999999999.
304400     GO TO 5100-MR-NO-REC-CHECK.
304500*
304600*
304700*
304800 9010-MR-FIELD.
304900*
305000     SET X-MMMM-POS              TO MTL1-FIELD-OCCURRENCE.
305100*
305200     IF  MBD100WS-JOURNAL
305300         MOVE MTL1-VL05-B-DATA-9 TO MMMM-POS-DEV-NBR
305400                                    (X-MMMM-POS).
305500*
305600     MOVE 'NBR OF POS DEVICES    '
305700                                 TO MBD100WS-PL1-DESC.
305800     MOVE MMMM-POS-DEV-NBR
305900          (X-MMMM-POS)           TO MBD100WS-PL1-FV-99999.
306000     MOVE MTL1-VL05-A-DATA-9     TO MMMM-POS-DEV-NBR
306100                                    (X-MMMM-POS).
306200     MOVE MMMM-POS-DEV-NBR
306300          (X-MMMM-POS)           TO MBD100WS-PL2-TV-99999.
306400     GO TO 5100-MR-NO-REC-CHECK.
306500*
306600*
306700*
306800 9011-MR-FIELD.
306900*
307000     SET X-MMMM-IMP              TO MTL1-FIELD-OCCURRENCE.
307100*
307200     IF  MBD100WS-JOURNAL
307300         MOVE MTL1-VL05-B-DATA-9 TO MMMM-IMP-DEV-NBR
307400                                    (X-MMMM-IMP).
307500*
307600     MOVE 'NBR OF IMPRINTERS     '
307700                                 TO MBD100WS-PL1-DESC.
307800     MOVE MMMM-IMP-DEV-NBR
307900          (X-MMMM-IMP)           TO MBD100WS-PL1-FV-99999.
308000     MOVE MTL1-VL05-A-DATA-9     TO MMMM-IMP-DEV-NBR
308100                                    (X-MMMM-IMP).
308200     MOVE MMMM-IMP-DEV-NBR
308300          (X-MMMM-IMP)           TO MBD100WS-PL2-TV-99999.
308400     GO TO 5100-MR-NO-REC-CHECK.
308500*
308600*
308700*
308800 9012-MR-FIELD.
308900*
309000     IF  MBD100WS-JOURNAL
309100         MOVE MTL1-VL10-B-DATA-9 TO MMMM-NBR-STORES.
309200*
309300     MOVE 'NUMBER OF STORES      '
309400                                 TO MBD100WS-PL1-DESC.
309500     MOVE MMMM-NBR-STORES        TO MBD100WS-PL1-FV-999999999.
309600     MOVE MTL1-VL10-A-DATA-9     TO MMMM-NBR-STORES.
309700     MOVE MMMM-NBR-STORES        TO MBD100WS-PL2-TV-999999999.
309800     GO TO 5100-MR-NO-REC-CHECK.
309900*
310000*
310100*
310200 9013-MR-FIELD.
310300*
310400     IF  MBD100WS-JOURNAL
310500         MOVE MTL1-VL10-B-DATA-9 TO MMMM-NBR-BULLETINS.
310600*
310700     MOVE 'NUMBER OF BULLETINS   '
310800                                 TO MBD100WS-PL1-DESC.
310900     MOVE MMMM-NBR-BULLETINS     TO MBD100WS-PL1-FV-999999999.
311000     MOVE MTL1-VL10-A-DATA-9     TO MMMM-NBR-BULLETINS.
311100     MOVE MMMM-NBR-BULLETINS     TO MBD100WS-PL2-TV-999999999.
311200     GO TO 5100-MR-NO-REC-CHECK.
311300*
311400*
311500*
311600 5100-MR-NO-REC-CHECK.
311700*
311800     IF  MBD100WS-UPDATE
311900     AND MBD100WS-IO-NO-REC-FOUND
312000         MOVE '*** ERROR - NO RECORD FOUND ***'
312100                                 TO MBD100WS-PL2-TO-VALUE.
312200*
312300 5999-MR-EXIT.
312400     EXIT.
312500/
312600 8100-FROM-DATE SECTION.
312700 8110-FD-BEGIN.
312800*
312900     MOVE SS01WS-JULIAN          TO MBD100WS-PL1-FV-JULIAN.
313000     PERFORM SS26PD-NUMERICALLY-EDIT-DATE
313100        THRU SS26PD-NED-EXIT.
313200     MOVE SS01WS-XX-XX-YYYY      TO MBD100WS-PL1-FV-DATE.
313300     INSPECT MBD100WS-PL1-FV-JULIAN REPLACING ALL ',' BY '-'.
313400*
313500 8199-FD-EXIT.
313600     EXIT.
313700*
313800*
313900*
314000 8200-TO-DATE SECTION.
314100 8210-TD-BEGIN.
314200*
314300     MOVE SS01WS-JULIAN          TO MBD100WS-PL2-TV-JULIAN.
314400     PERFORM SS26PD-NUMERICALLY-EDIT-DATE
314500        THRU SS26PD-NED-EXIT.
314600     MOVE SS01WS-XX-XX-YYYY      TO MBD100WS-PL2-TV-DATE.
314700     INSPECT MBD100WS-PL2-TV-JULIAN REPLACING ALL ',' BY '-'.
314800*
314900 8299-TD-EXIT.
315000     EXIT.
315100/
315200 9000-PERFORMED-ROUTINES-SECT SECTION.
315300*
315400     COPY MB00PD REPLACING ==:MB00:== BY ==MMMM==.
315500/
315600     COPY SS95PD.
315700/
315800     COPY MB99PD.
315900/
316000     COPY SS02PD.
316100/
316200     COPY SS07PD.
316300/
316400     COPY SS08PD.
316500/
316600     COPY SS26PD.
316700/
316800     COPY SS27PD.
316900*
317000 9995-END-SOURCE-STATEMENTS SECTION.
317100 9999-END-OF-PROGRAM.
317200     EXIT.
