000100 IDENTIFICATION DIVISION.
000200 PROGRAM-ID. MBD100MP.
000201*       RELEASE DATE=08/24/01.        REVISION LEVEL=08.06      * ++++++++
000202***************************************************************** ++++++++
000203*WARNING.  THIS COMPUTER PROGRAM IS PROTECTED BY COPYRIGHT LAW  * ++++++++
000204*AND INTERNATIONAL TREATIES.  UNAUTHORIZED REPRODUCTION OR      * ++++++++
000205*DISTRIBUTION OF THIS PROGRAM, OR ANY PORTION OF IT, MAY RESULT * ++++++++
000206*IN SEVERE CIVIL AND CRIMINAL PENATLIES, AND WILL BE PROSECUTED * ++++++++
000207*TO THE MAXIMUM EXTENT POSSIBLE UNDER THE LAW.                  * ++++++++
000208*COPYRIGHT 1999 PAYSYS INTERNATIONAL, INC.  ALL RIGHTS RESERVED.* ++++++++
000209***************************************************************** ++++++++
000300*****************************************************************
000400*                                                               *
000500*   V - PLUS  M E R C H A N T   B A N K C A R D   S Y S T E M   *
000600*                                                               *
000700*     MBD100MP - MERCHANT PRODUCT ASSIGNMENTS RECOVERY AND      *
000800*                NON-MONETARY REPORTS                           *
000900*                                                               *
001000*****************************************************************
001100 ENVIRONMENT DIVISION.
001200 CONFIGURATION SECTION.
001300 SOURCE-COMPUTER.            IBM-4341.
001400 OBJECT-COMPUTER.            IBM-4341.
001500/
001600 INPUT-OUTPUT SECTION.
001700*
001800 FILE-CONTROL.
001900/
002000 DATA DIVISION.
002100 FILE SECTION.
002200/
002300 WORKING-STORAGE SECTION.
002400*
002500 01  FILLER                  PIC  X(12)      VALUE '** WS-BEG **'.
002600*
002700     COPY MMMPRL.
002800/
002900     COPY MMMPIO.
003000/
003100     COPY MB00RB REPLACING ==:MB00:== BY ==MMMP==.
003200/
003300     COPY MMMPIR.
003400/
003500     COPY MML1WS REPLACING ==:MML1:== BY ==MTL1==.
003600/
003700     COPY MTCCRL REPLACING ==:MTCC:== BY ==MTCC==.
003800/
003900     COPY MB00WS.
004000/
004100     COPY SS95WS.
004200/
004300     COPY MB99WS.
004400/
004500     COPY SS00WS.
004600/
004700     COPY SS01WS.
004800/
004900     COPY SS02WS.
005000*
005100 01  FILLER                  PIC  X(12)      VALUE '** WS-END **'.
005200/
005300 LINKAGE SECTION.
005400     COPY MBD100WS.
005500/
005600     COPY MMSCRL.
005700/
005800     COPY MMOCRL.
005900/
006000     COPY MML1RL REPLACING ==:MML1:== BY ==MTL1==.
006100/
006200     COPY MTCCRL REPLACING ==:MTCC:== BY ==MTC1==.
006300/
006400     COPY MTCCRL REPLACING ==:MTCC:== BY ==MTC2==.
006500/
006600 PROCEDURE DIVISION              USING MBD100WS-AREA
006700                                       MMSC-RECORD
006800                                       MMOC-RECORD
006900                                       MTL1-RECORD
007000                                       MTC1-RECORD
007100                                       MTC2-RECORD.
007200*
007300 A000-MAIN-LINE-SECT SECTION.
007400 A010-ML-BEGIN.
007500*
007600     MOVE 'MBD100MP'             TO SS02WS-ABEND-PROG-ID.
007700     MOVE 'MMMP'                 TO MB99WS-FILE-ID.
007800     MOVE MMSC-TODAYS-JULIAN     TO MB99WS-PROC-DATE.
007900     MOVE MMSC-TIME-STAMP        TO MB99WS-PROC-TIME.
008000*
008100     IF  MBD100WS-OPEN-FILE
008200         SET SS95WS-FUNCTION-INITIALIZE
008300                                 TO TRUE
008400         PERFORM SS95PD-NAP-ROUTINE
008500            THRU SS95PD-NAP-EXIT
008600         PERFORM O000-OPEN-FILE
008700            THRU O999-OF-EXIT.
008800*
008900     IF  MBD100WS-CLOSE-FILE
009000         PERFORM C000-CLOSE-FILE
009100            THRU C999-CF-EXIT.
009200*
009300     IF  MBD100WS-PROCESS-RECORD
009400         PERFORM P000-PROCESS-RECORD
009500            THRU P099-PR-EXIT.
009600*
009700     GOBACK.
009800*
009900 A999-ML-EXIT.
010000     EXIT.
010100/
010200 C000-CLOSE-FILE SECTION.
010300 C010-CF-BEGIN.
010400*
010500     MOVE 'C1MP'                 TO SS02WS-ABEND-LOCATION.
010600     SET MMMPRB-CLOSE            TO TRUE.
010700     PERFORM MB00PD-MMMP-ACCESS
010800        THRU MB00PD-MMMP-ACCESS-EXIT.
010900*
011000 C999-CF-EXIT.
011100     EXIT.
011200/
011300 O000-OPEN-FILE SECTION.
011400 O010-OF-BEGIN.
011500*
011600     MOVE MMSC-DATE-FORMAT       TO SS01WS-DATE-FORMAT.
011700*
011800     MOVE 'O1MP'                 TO SS02WS-ABEND-LOCATION.
011900*
012000     IF  MBD100WS-UPDATE
012100         SET MMMPRB-OPEN-IO-DYN  TO TRUE
012200     ELSE
012300         SET MMMPRB-OPEN-INPUT-DYN
012400                                 TO TRUE.
012500*
012600     PERFORM MB00PD-MMMP-ACCESS
012700        THRU MB00PD-MMMP-ACCESS-EXIT.
012800*
012900     MOVE 'R0MP'                 TO SS02WS-ABEND-LOCATION.
013000     SET MMMPRB-READ-SEQ         TO TRUE.
013100     PERFORM MB00PD-MMMP-ACCESS
013200        THRU MB00PD-MMMP-ACCESS-EXIT.
013300     MOVE 'MMMP'                 TO MB99WS-FILE-ID.
013400*
013500     IF  MMMPIO-HEADER
013600         NEXT SENTENCE
013700     ELSE
013800         PERFORM MB99PD-MISSING-HEADER-ABEND
013900            THRU MB99PD-MHA-EXIT.
014000*
014100     MOVE MMMPIO-DATE-STAMP      TO MB99WS-FILE-DATE.
014200     MOVE MMMPIO-TIME-STAMP      TO MB99WS-FILE-TIME.
014300     PERFORM MB99PD-CHECK-DATE-TIME
014400        THRU MB99PD-CDT-EXIT.
014500*
014600     PERFORM Z900-INIT-RECORD
014700        THRU Z999-IR-EXIT.
014800*
014900 O999-OF-EXIT.
015000     EXIT.
015100/
015200 P000-PROCESS-RECORD SECTION.
015300 P010-PR-BEGIN.
015400*
015500     MOVE MMOC-CURRENCY-CODE     TO SS95WS-CURRENCY-CODE.
015600*
015700     IF  MTL1-MMMP-KEY IS NOT EQUAL TO MMMP-KEY
015800         PERFORM P500-FILE-UPDATE
015900            THRU P599-FU-EXIT.
016000*
016100     IF  MTL1-TOTALS-RECORD
016200         GO TO P099-PR-EXIT.
016300*
016400     IF  MTL1-MMMP-KEY IS NOT EQUAL TO MMMP-KEY
016500         PERFORM P700-GET-RECORD-TO-UPDATE
016600            THRU P799-GRTU-EXIT.
016700*
016800     MOVE MTL1-FIELD-CODE        TO MBD100WS-FIELD-CODE.
016900*
017000     IF (MBD100WS-FC-1-2-ADD AND MBD100WS-FC-3-4-ADD)
017100     OR (MBD100WS-FC-1-2-REP AND MBD100WS-FC-3-4-REP)
017200         PERFORM U000-NEW-RECORD
017300            THRU U099-NR-EXIT
017400     ELSE
017500         PERFORM 0000-MAINT-RECORD
017600            THRU 5999-MR-EXIT.
017700*
017800 P099-PR-EXIT.
017900     EXIT.
018000/
018100 P500-FILE-UPDATE SECTION.
018200 P510-FU-BEGIN.
018300*
018400     IF  MBD100WS-JOURNAL
018500         GO TO P599-FU-EXIT.
018600*
018700     IF  MMMP-KEY IS EQUAL TO MMMPIR-KEY
018800         GO TO P599-FU-EXIT.
018900*
019000     IF  MBD100WS-IO-REWRITE
019100         MOVE MMMP-RECORD        TO MMMPIO-RECORD
019200         MOVE SS02WS-NO-RECORD-FOUND
019300                                 TO MMMPRB-TEMP-STATUS-1
019400         MOVE 'U1MP'             TO SS02WS-ABEND-LOCATION
019500         SET MMMPRB-REWRITE      TO TRUE
019600         PERFORM MB00PD-MMMP-ACCESS
019700            THRU MB00PD-MMMP-ACCESS-EXIT
019800         IF  SS02WS-FS-NO-RECORD-FOUND
019900             MOVE 'W'            TO MBD100WS-IO-SW.
020000*
020100     IF  MBD100WS-IO-NO-REC-FOUND
020200     OR  MBD100WS-IO-WRITE
020300         MOVE MMMP-RECORD        TO MMMPIO-RECORD
020400         MOVE SS02WS-DUPLICATE-RECORD
020500                                 TO MMMPRB-TEMP-STATUS-1
020600         MOVE 'W2MP'             TO SS02WS-ABEND-LOCATION
020700         SET MMMPRB-WRITE        TO TRUE
020800         PERFORM MB00PD-MMMP-ACCESS
020900            THRU MB00PD-MMMP-ACCESS-EXIT
021000         IF  SS02WS-FS-DUPLICATE-RECORD
021100             MOVE 'U'            TO MBD100WS-IO-SW
021200             MOVE MMMP-RECORD    TO MMMPIO-RECORD
021300             MOVE 'U2MP'         TO SS02WS-ABEND-LOCATION
021400             SET MMMPRB-REWRITE  TO TRUE
021500             PERFORM MB00PD-MMMP-ACCESS
021600                THRU MB00PD-MMMP-ACCESS-EXIT.
021700*
021800     PERFORM Z900-INIT-RECORD
021900        THRU Z999-IR-EXIT.
022000*
022100 P599-FU-EXIT.
022200     EXIT.
022300/
022400 P700-GET-RECORD-TO-UPDATE SECTION.
022500 P710-GRTU-BEGIN.
022600*
022700     IF  MBD100WS-JOURNAL
022800         PERFORM Z900-INIT-RECORD
022900            THRU Z999-IR-EXIT
023000         GO TO P799-GRTU-EXIT.
023100*
023200     MOVE SS02WS-NO-RECORD-FOUND
023300                                 TO MMMPRB-TEMP-STATUS-1.
023400     MOVE MTL1-MMMP-KEY          TO MMMPIO-KEY.
023500*
023600     MOVE 'R1MP'                 TO SS02WS-ABEND-LOCATION.
023700     SET MMMPRB-READ-RANDOM      TO TRUE.
023800     PERFORM MB00PD-MMMP-ACCESS
023900        THRU MB00PD-MMMP-ACCESS-EXIT.
024000*
024100     IF  SS02WS-FS-NO-RECORD-FOUND
024200         PERFORM Z900-INIT-RECORD
024300            THRU Z999-IR-EXIT
024400         MOVE 'N'                TO MBD100WS-IO-SW
024500     ELSE
024600         MOVE MMMPIO-RECORD      TO MMMP-RECORD
024700         MOVE 'U'                TO MBD100WS-IO-SW.
024800*
024900 P799-GRTU-EXIT.
025000     EXIT.
025100/
025200 U000-NEW-RECORD SECTION.
025300 U010-NR-BEGIN.
025400*
025500     PERFORM Z100-COMMON-FROM-DATA
025600        THRU Z199-CFD-EXIT.
025700*
025800     PERFORM Z200-COMMON-TO-DATA
025900        THRU Z299-CTD-EXIT.
026000*
026100     MOVE MTL1-ADD-AREA          TO MMMP-RECORD.
026200*
026300     IF  MBD100WS-IO-NO-REC-FOUND
026400         MOVE 'W'                TO MBD100WS-IO-SW.
026500*
026600     IF  MBD100WS-FC-1-2-ADD
026700         MOVE '*** NEW RECORD ADDED ***'
026800                                 TO MBD100WS-PL2-TO-VALUE
026900                                    MBD100WS-PL1-FROM-VALUE
027000     ELSE
027100         MOVE '*** REPLACEMENT RECORD ***'
027200                                 TO MBD100WS-PL2-TO-VALUE
027300                                    MBD100WS-PL1-FROM-VALUE.
027400*
027500     MOVE SPACES                 TO MTCC-RECORD.
027600     MOVE MMMP-ORG               TO MTCC-MBU914-BEG-ORG.
027700     MOVE MMMP-MERCHANT          TO MTCC-MBU914-BEG-MERCHANT.
027800     MOVE 'MBU914'               TO MTCC-PROGRAM-ID.
027900     MOVE MTCC-RECORD            TO MTC1-RECORD.
028000*
028100 U099-NR-EXIT.
028200     EXIT.
028300/
028400 Z100-COMMON-FROM-DATA SECTION.
028500 Z110-CFD-BEGIN.
028600*
028700     MOVE MTL1-MMMP-MERCHANT     TO MBD100WS-PL1-MERCHANT.
028800     MOVE MTL1-MMMP-PRODUCT      TO MBD100WS-PL1-PROD.
028900*
029000 Z199-CFD-EXIT.
029100     EXIT.
029200/
029300 Z200-COMMON-TO-DATA SECTION.
029400 Z210-CTD-BEGIN.
029500*
029600 Z299-CTD-EXIT.
029700     EXIT.
029800/
029900 Z900-INIT-RECORD SECTION.
030000 Z910-IR-BEGIN.
030100*
030200     MOVE MMMPIR-RECORD          TO MMMP-RECORD.
030300     MOVE SPACES                 TO MTC1-RECORD.
030400     MOVE SPACES                 TO MTC2-RECORD.
030500*
030600 Z999-IR-EXIT.
030700     EXIT.
030800/
030900 0000-MAINT-RECORD SECTION.
031000 0010-MR-BEGIN.
031100*
031200     PERFORM Z100-COMMON-FROM-DATA
031300        THRU Z199-CFD-EXIT.
031400*
031500     PERFORM Z200-COMMON-TO-DATA
031600        THRU Z299-CTD-EXIT.
031700*
031800     IF  MTL1-FIELD-CODE IS EQUAL TO 0197
031900         GO TO 0197-MR-FIELD.
032000*
032100     IF  MTL1-FIELD-CODE IS EQUAL TO 0198
032200         GO TO 0198-MR-FIELD.
032300*
032400     IF  MTL1-FIELD-CODE IS EQUAL TO 0199
032500         GO TO 0199-MR-FIELD.
032600*
032700     IF  MTL1-FIELD-CODE IS EQUAL TO 1451
032800         GO TO 1451-MR-FIELD.
032900*
033000     IF  MTL1-FIELD-CODE IS EQUAL TO 1452
033100         GO TO 1452-MR-FIELD.
033200*
033300     IF  MTL1-FIELD-CODE IS EQUAL TO 1453
033400         GO TO 1453-MR-FIELD.
033500*
033600     IF  MTL1-FIELD-CODE IS EQUAL TO 1454
033700         GO TO 1454-MR-FIELD.
033800*
033900     IF  MTL1-FIELD-CODE IS EQUAL TO 1455
034000         GO TO 1455-MR-FIELD.
034100*
034200     IF  MTL1-FIELD-CODE IS EQUAL TO 1456
034300         GO TO 1456-MR-FIELD.
034400*
034500     IF  MTL1-FIELD-CODE IS EQUAL TO 1457
034600         GO TO 1457-MR-FIELD.
034700*
034800     IF  MTL1-FIELD-CODE IS EQUAL TO 1458
034900         GO TO 1458-MR-FIELD.
035000*
035100     IF  MTL1-FIELD-CODE IS EQUAL TO 1459
035200         GO TO 1459-MR-FIELD.
035300*
035400     IF  MTL1-FIELD-CODE IS EQUAL TO 1460
035500         GO TO 1460-MR-FIELD.
035600*
035700     IF  MTL1-FIELD-CODE IS EQUAL TO 1461
035800         GO TO 1461-MR-FIELD.
035900*
036000     IF  MTL1-FIELD-CODE IS EQUAL TO 1462
036100         GO TO 1462-MR-FIELD.
036200*
036300     IF  MTL1-FIELD-CODE IS EQUAL TO 1463
036400         GO TO 1463-MR-FIELD.
036500*
036600     MOVE '*** ERROR - INVALID FIELD CODE ***'
036700                                 TO MBD100WS-PL2-TO-VALUE.
036800     GO TO 5999-MR-EXIT.
036900*
037000 0197-MR-FIELD.
037100*
037200     IF  MBD100WS-JOURNAL
037300         MOVE MTL1-VL01-B-DATA-9 TO MMMP-REC-STATUS.
037400*
037500     MOVE 'RECORD STATUS         '
037600                                 TO MBD100WS-PL1-DESC.
037700     MOVE MMMP-REC-STATUS        TO MBD100WS-PL1-FV-9.
037800     MOVE MTL1-VL01-A-DATA-9     TO MMMP-REC-STATUS.
037900     MOVE MMMP-REC-STATUS        TO MBD100WS-PL2-TV-9.
038000     GO TO 5100-MR-NO-REC-CHECK.
038100*
038200*
038300*
038400 0198-MR-FIELD.
038500*
038600     IF  MBD100WS-JOURNAL
038700         MOVE MTL1-VL03-B-DATA-X TO MMMP-LAST-MAINT-OPER.
038800*
038900     MOVE 'LAST MAINT OPERATOR   '
039000                                 TO MBD100WS-PL1-DESC.
039100     MOVE MMMP-LAST-MAINT-OPER   TO MBD100WS-PL1-FROM-VALUE.
039200     MOVE MTL1-VL03-A-DATA-X     TO MMMP-LAST-MAINT-OPER.
039300     MOVE MMMP-LAST-MAINT-OPER   TO MBD100WS-PL2-TO-VALUE.
039400     GO TO 5100-MR-NO-REC-CHECK.
039500*
039600*
039700*
039800 0199-MR-FIELD.
039900*
040000     IF  MBD100WS-JOURNAL
040100         MOVE MTL1-VL07-B-DATA-9 TO MMMP-LAST-MAINT-DATE.
040200*
040300     MOVE 'DATE LAST MAINTENANCE '
040400                                 TO MBD100WS-PL1-DESC.
040500     MOVE MMMP-LAST-MAINT-DATE   TO SS01WS-JULIAN.
040600     PERFORM 8100-FROM-DATE      THRU 8199-FD-EXIT.
040700     MOVE MTL1-VL07-A-DATA-9     TO MMMP-LAST-MAINT-DATE.
040800     MOVE MMMP-LAST-MAINT-DATE   TO SS01WS-JULIAN.
040900     PERFORM 8200-TO-DATE        THRU 8299-TD-EXIT.
041000     GO TO 5100-MR-NO-REC-CHECK.
041100*
041200*
041300*
041400 1451-MR-FIELD.
041500*
041600     IF  MBD100WS-JOURNAL
041700         MOVE MTL1-VL01-B-DATA-X TO MMMP-PROD-STATUS.
041800*
041900     MOVE 'PRODUCT STATUS        '
042000                                 TO MBD100WS-PL1-DESC.
042100     MOVE MMMP-PROD-STATUS       TO MBD100WS-PL1-FROM-VALUE.
042200     MOVE MTL1-VL01-A-DATA-X     TO MMMP-PROD-STATUS.
042300     MOVE MMMP-PROD-STATUS       TO MBD100WS-PL2-TO-VALUE.
042400     GO TO 5100-MR-NO-REC-CHECK.
042500*
042600*
042700*
042800 1452-MR-FIELD.
042900*
043000     IF  MBD100WS-JOURNAL
043100         MOVE MTL1-VL01-B-DATA-X TO MMMP-PROD-DISC-FEE-BASE.
043200*
043300     MOVE 'DISCOUNT FEE BASE     '
043400                                 TO MBD100WS-PL1-DESC.
043500     MOVE MMMP-PROD-DISC-FEE-BASE
043600                                 TO MBD100WS-PL1-FROM-VALUE.
043700     MOVE MTL1-VL01-A-DATA-X     TO MMMP-PROD-DISC-FEE-BASE.
043800     MOVE MMMP-PROD-DISC-FEE-BASE
043900                                 TO MBD100WS-PL2-TO-VALUE.
044000     GO TO 5100-MR-NO-REC-CHECK.
044100*
044200*
044300*
044400 1453-MR-FIELD.
044500*
044600     IF  MBD100WS-JOURNAL
044700         MOVE MTL1-VL10-B-DATA-9 TO MMMP-PROD-DISC-RATE-TABLE.
044800*
044900     MOVE 'DISCOUNT RATE TABLE   '
045000                                 TO MBD100WS-PL1-DESC.
045100     MOVE MMMP-PROD-DISC-RATE-TABLE
045200                                 TO MBD100WS-PL1-FV-999999999.
045300     MOVE MTL1-VL10-A-DATA-9     TO MMMP-PROD-DISC-RATE-TABLE.
045400     MOVE MMMP-PROD-DISC-RATE-TABLE
045500                                 TO MBD100WS-PL2-TV-999999999.
045600     GO TO 5100-MR-NO-REC-CHECK.
045700*
045800*
045900*
046000 1454-MR-FIELD.
046100*
046200     IF  MBD100WS-JOURNAL
046300         MOVE MTL1-VL07-B-DATA-9 TO MMMP-PROD-EFF-DATE.
046400*
046500     MOVE 'PRODUCT EFFECTIVE DATE'
046600                                 TO MBD100WS-PL1-DESC.
046700     MOVE MMMP-PROD-EFF-DATE     TO SS01WS-JULIAN.
046800     PERFORM 8100-FROM-DATE      THRU 8199-FD-EXIT.
046900     MOVE MTL1-VL07-A-DATA-9     TO MMMP-PROD-EFF-DATE.
047000     MOVE MMMP-PROD-EFF-DATE     TO SS01WS-JULIAN.
047100     PERFORM 8200-TO-DATE        THRU 8299-TD-EXIT.
047200     GO TO 5100-MR-NO-REC-CHECK.
047300*
047400*
047500*
047600 1455-MR-FIELD.
047700*
047800     IF  MBD100WS-JOURNAL
047900         MOVE MTL1-VL01-B-DATA-X TO MMMP-PROD-PART-FEE-BASE.
048000*
048100     MOVE 'PARTICIPATION FEE BASE'
048200                                 TO MBD100WS-PL1-DESC.
048300     MOVE MMMP-PROD-PART-FEE-BASE
048400                                 TO MBD100WS-PL1-FROM-VALUE.
048500     MOVE MTL1-VL01-A-DATA-X     TO MMMP-PROD-PART-FEE-BASE.
048600     MOVE MMMP-PROD-PART-FEE-BASE
048700                                 TO MBD100WS-PL2-TO-VALUE.
048800     GO TO 5100-MR-NO-REC-CHECK.
048900*
049000*
049100*
049200 1456-MR-FIELD.
049300*
049400     IF  MBD100WS-JOURNAL
049500         MOVE MTL1-VL10-B-DATA-9 TO MMMP-PROD-PART-RATE-TABLE.
049600*
049700     MOVE 'PART RATE TABLE       '
049800                                 TO MBD100WS-PL1-DESC.
049900     MOVE MMMP-PROD-PART-RATE-TABLE
050000                                 TO MBD100WS-PL1-FV-999999999.
050100     MOVE MTL1-VL10-A-DATA-9     TO MMMP-PROD-PART-RATE-TABLE.
050200     MOVE MMMP-PROD-PART-RATE-TABLE
050300                                 TO MBD100WS-PL2-TV-999999999.
050400     GO TO 5100-MR-NO-REC-CHECK.
050500*
050600*
050700*
050800 1457-MR-FIELD.
050900*
051000     IF  MBD100WS-JOURNAL
051100         MOVE MTL1-VL01-B-DATA-X TO MMMP-PROD-SETTLE-FLAG.
051200*
051300     MOVE 'PRODUCT SETTLE FLAG   '
051400                                 TO MBD100WS-PL1-DESC.
051500     MOVE MMMP-PROD-SETTLE-FLAG  TO MBD100WS-PL1-FROM-VALUE.
051600     MOVE MTL1-VL01-A-DATA-X     TO MMMP-PROD-SETTLE-FLAG.
051700     MOVE MMMP-PROD-SETTLE-FLAG  TO MBD100WS-PL2-TO-VALUE.
051800     GO TO 5100-MR-NO-REC-CHECK.
051900*
052000*
052100*
052200 1458-MR-FIELD.
052300*
052400     SET X-MMMP-PROD-RESV        TO MTL1-FIELD-OCCURRENCE.
052500*
052600     IF  MBD100WS-JOURNAL
052700         MOVE MTL1-VL01-B-DATA-X TO MMMP-PROD-RESV-FEE-BASE
052800                                    (X-MMMP-PROD-RESV).
052900*
053000     MOVE 'RESERVE FEE BASE      '
053100                                 TO MBD100WS-PL1-DESC.
053200     MOVE MMMP-PROD-RESV-FEE-BASE
053300          (X-MMMP-PROD-RESV)     TO MBD100WS-PL1-FROM-VALUE.
053400     MOVE MTL1-VL01-A-DATA-X     TO MMMP-PROD-RESV-FEE-BASE
053500                                    (X-MMMP-PROD-RESV).
053600     MOVE MMMP-PROD-RESV-FEE-BASE
053700          (X-MMMP-PROD-RESV)     TO MBD100WS-PL2-TO-VALUE.
053800     GO TO 5100-MR-NO-REC-CHECK.
053900*
054000*
054100*
054200 1459-MR-FIELD.
054300*
054400     SET X-MMMP-PROD-RESV        TO MTL1-FIELD-OCCURRENCE.
054500*
054600     IF  MBD100WS-JOURNAL
054700         MOVE MTL1-VL10-B-DATA-9 TO MMMP-PROD-RESV-RATE-TABLE
054800                                    (X-MMMP-PROD-RESV).
054900*
055000     MOVE 'RESERVE RATE TABLE    '
055100                                 TO MBD100WS-PL1-DESC.
055200     MOVE MMMP-PROD-RESV-RATE-TABLE
055300          (X-MMMP-PROD-RESV)     TO MBD100WS-PL1-FV-999999999.
055400     MOVE MTL1-VL10-A-DATA-9     TO MMMP-PROD-RESV-RATE-TABLE
055500                                    (X-MMMP-PROD-RESV).
055600     MOVE MMMP-PROD-RESV-RATE-TABLE
055700          (X-MMMP-PROD-RESV)     TO MBD100WS-PL2-TV-999999999.
055800     GO TO 5100-MR-NO-REC-CHECK.
055900*
056000*
056100*
056200 1460-MR-FIELD.
056300*
056400     IF  MBD100WS-JOURNAL
056500         MOVE MTL1-VL05-B-DATA-9 TO MMMP-PROD-SOURCE.
056600*
056700     MOVE 'PRODUCT SOURCE        '
056800                                 TO MBD100WS-PL1-DESC.
056900     MOVE MMMP-PROD-SOURCE       TO MBD100WS-PL1-FROM-VALUE.
057000     MOVE MTL1-VL05-A-DATA-X     TO MMMP-PROD-SOURCE.
057100     MOVE MMMP-PROD-SOURCE       TO MBD100WS-PL2-TO-VALUE.
057200     GO TO 5100-MR-NO-REC-CHECK.
057300*
057400*
057500*
057600 1461-MR-FIELD.
057700*
057800     IF  MBD100WS-JOURNAL
057900         MOVE MTL1-VL05-B-DATA-X TO MMMP-PROD-SHORT-DESC.
058000*
058100     MOVE 'PRODUCT SHORT DESC    '
058200                                 TO MBD100WS-PL1-DESC.
058300     MOVE MMMP-PROD-SHORT-DESC   TO MBD100WS-PL1-FROM-VALUE.
058400     MOVE MTL1-VL05-A-DATA-X     TO MMMP-PROD-SHORT-DESC.
058500     MOVE MMMP-PROD-SHORT-DESC   TO MBD100WS-PL2-TO-VALUE.
058600     GO TO 5100-MR-NO-REC-CHECK.
058700*
058800*
058900*
059000 1462-MR-FIELD.
059100*
059200     IF  MBD100WS-JOURNAL
059300         MOVE MTL1-VL02-B-DATA-X TO MMMP-PROD-USER-CODE.
059400*
059500     MOVE 'PRODUCT USER CODE     '
059600                                 TO MBD100WS-PL1-DESC.
059700     MOVE MMMP-PROD-USER-CODE    TO MBD100WS-PL1-FROM-VALUE.
059800     MOVE MTL1-VL02-A-DATA-X     TO MMMP-PROD-USER-CODE.
059900     MOVE MMMP-PROD-USER-CODE    TO MBD100WS-PL2-TO-VALUE.
060000     GO TO 5100-MR-NO-REC-CHECK.
060100*
060200*
060300*
060400 1463-MR-FIELD.
060500*
060600     IF  MBD100WS-JOURNAL
060700         MOVE MTL1-VL01-B-DATA-X TO MMMP-PROD-INTCHG-FEE-BASE.
060800*
060900     MOVE 'INTERCHANGE FEE BASE  '
061000                                 TO MBD100WS-PL1-DESC.
061100     MOVE MMMP-PROD-INTCHG-FEE-BASE
061200                                 TO MBD100WS-PL1-FROM-VALUE.
061300     MOVE MTL1-VL01-A-DATA-X     TO MMMP-PROD-INTCHG-FEE-BASE.
061400     MOVE MMMP-PROD-INTCHG-FEE-BASE
061500                                 TO MBD100WS-PL2-TO-VALUE.
061600     GO TO 5100-MR-NO-REC-CHECK.
061700*
061800*
061900*
062000 5100-MR-NO-REC-CHECK.
062100*
062200     IF  MBD100WS-UPDATE
062300     AND MBD100WS-IO-NO-REC-FOUND
062400         MOVE '*** ERROR - NO RECORD FOUND ***'
062500                                 TO MBD100WS-PL2-TO-VALUE.
062600*
062700 5999-MR-EXIT.
062800     EXIT.
062900/
063000 8100-FROM-DATE SECTION.
063100 8110-FD-BEGIN.
063200*
063300     MOVE SS01WS-JULIAN          TO MBD100WS-PL1-FV-JULIAN.
063400     PERFORM SS26PD-NUMERICALLY-EDIT-DATE
063500        THRU SS26PD-NED-EXIT.
063600     MOVE SS01WS-XX-XX-YYYY      TO MBD100WS-PL1-FV-DATE.
063700     INSPECT MBD100WS-PL1-FV-JULIAN REPLACING ALL ',' BY '-'.
063800*
063900 8199-FD-EXIT.
064000     EXIT.
064100*
064200*
064300*
064400 8200-TO-DATE SECTION.
064500 8210-TD-BEGIN.
064600*
064700     MOVE SS01WS-JULIAN          TO MBD100WS-PL2-TV-JULIAN.
064800     PERFORM SS26PD-NUMERICALLY-EDIT-DATE
064900        THRU SS26PD-NED-EXIT.
065000     MOVE SS01WS-XX-XX-YYYY      TO MBD100WS-PL2-TV-DATE.
065100     INSPECT MBD100WS-PL2-TV-JULIAN REPLACING ALL ',' BY '-'.
065200*
065300 8299-TD-EXIT.
065400     EXIT.
065500/
065600 9000-PERFORMED-ROUTINES-SECT SECTION.
065700*
065800     COPY MB00PD REPLACING ==:MB00:== BY ==MMMP==.
065900/
066000     COPY SS95PD.
066100/
066200     COPY MB99PD.
066300/
066400     COPY SS02PD.
066500/
066600     COPY SS07PD.
066700/
066800     COPY SS08PD.
066900/
067000     COPY SS26PD.
067100/
067200     COPY SS27PD.
067300*
067400 9995-END-SOURCE-STATEMENTS SECTION.
067500 9999-END-OF-PROGRAM.
067600     EXIT.
