000100 IDENTIFICATION DIVISION.
000200 PROGRAM-ID. MBD100RC.
000201*       RELEASE DATE=08/24/01.        REVISION LEVEL=08.06      * ++++++++
000202***************************************************************** ++++++++
000203*WARNING.  THIS COMPUTER PROGRAM IS PROTECTED BY COPYRIGHT LAW  * ++++++++
000204*AND INTERNATIONAL TREATIES.  UNAUTHORIZED REPRODUCTION OR      * ++++++++
000205*DISTRIBUTION OF THIS PROGRAM, OR ANY PORTION OF IT, MAY RESULT * ++++++++
000206*IN SEVERE CIVIL AND CRIMINAL PENATLIES, AND WILL BE PROSECUTED * ++++++++
000207*TO THE MAXIMUM EXTENT POSSIBLE UNDER THE LAW.                  * ++++++++
000208*COPYRIGHT 1999 PAYSYS INTERNATIONAL, INC.  ALL RIGHTS RESERVED.* ++++++++
000209***************************************************************** ++++++++
000300*****************************************************************
000400*                                                               *
000500*   V - PLUS  M E R C H A N T   B A N K C A R D   S Y S T E M   *
000600*                                                               *
000700*     MBD100RC - RELATIONSHIP CONTROL RECOVERY AND              *
000800*                NON-MONETARY REPORTS                           *
000900*                                                               *
001000*****************************************************************
001100 ENVIRONMENT DIVISION.
001200 CONFIGURATION SECTION.
001300 SOURCE-COMPUTER.            IBM-4341.
001400 OBJECT-COMPUTER.            IBM-4341.
001500/
001600 INPUT-OUTPUT SECTION.
001700*
001800 FILE-CONTROL.
001900/
002000 DATA DIVISION.
002100 FILE SECTION.
002200/
002300 WORKING-STORAGE SECTION.
002400*
002500 01  FILLER                  PIC  X(12)      VALUE '** WS-BEG **'.
002600*
002700     COPY MMRCRL.
002800/
002900     COPY MMRCIO.
003000/
003100     COPY MB00RB REPLACING ==:MB00:== BY ==MMRC==.
003200/
003300     COPY MMRCIR.
003400/
003500     COPY MML1WS REPLACING ==:MML1:== BY ==MTL1==.
003600/
003700     COPY MTCCRL REPLACING ==:MTCC:== BY ==MTCC==.
003800/
003900     COPY MB00WS.
004000/
004100     COPY SS95WS.
004200/
004300     COPY MB99WS.
004400/
004500     COPY SS00WS.
004600/
004700     COPY SS01WS.
004800/
004900     COPY SS02WS.
005000*
005100 01  FILLER                  PIC  X(12)      VALUE '** WS-END **'.
005200/
005300 LINKAGE SECTION.
005400     COPY MBD100WS.
005500/
005600     COPY MMSCRL.
005700/
005800     COPY MMOCRL.
005900/
006000     COPY MML1RL REPLACING ==:MML1:== BY ==MTL1==.
006100/
006200     COPY MTCCRL REPLACING ==:MTCC:== BY ==MTC1==.
006300/
006400     COPY MTCCRL REPLACING ==:MTCC:== BY ==MTC2==.
006500/
006600 PROCEDURE DIVISION              USING MBD100WS-AREA
006700                                       MMSC-RECORD
006800                                       MMOC-RECORD
006900                                       MTL1-RECORD
007000                                       MTC1-RECORD
007100                                       MTC2-RECORD.
007200*
007300 A000-MAIN-LINE-SECT SECTION.
007400 A010-ML-BEGIN.
007500*
007600     MOVE 'MBD100RC'             TO SS02WS-ABEND-PROG-ID.
007700     MOVE 'MMRC'                 TO MB99WS-FILE-ID.
007800     MOVE MMSC-TODAYS-JULIAN     TO MB99WS-PROC-DATE.
007900     MOVE MMSC-TIME-STAMP        TO MB99WS-PROC-TIME.
008000*
008100     IF  MBD100WS-OPEN-FILE
008200         SET SS95WS-FUNCTION-INITIALIZE
008300                                 TO TRUE
008400         PERFORM SS95PD-NAP-ROUTINE
008500            THRU SS95PD-NAP-EXIT
008600         PERFORM O000-OPEN-FILE
008700            THRU O999-OF-EXIT.
008800*
008900     IF  MBD100WS-CLOSE-FILE
009000         PERFORM C000-CLOSE-FILE
009100            THRU C999-CF-EXIT.
009200*
009300     IF  MBD100WS-PROCESS-RECORD
009400         PERFORM P000-PROCESS-RECORD
009500            THRU P099-PR-EXIT.
009600*
009700     GOBACK.
009800*
009900 A999-ML-EXIT.
010000     EXIT.
010100/
010200 C000-CLOSE-FILE SECTION.
010300 C010-CF-BEGIN.
010400*
010500     MOVE 'C1RC'                 TO SS02WS-ABEND-LOCATION.
010600     SET MMRCRB-CLOSE            TO TRUE.
010700     PERFORM MB00PD-MMRC-ACCESS
010800        THRU MB00PD-MMRC-ACCESS-EXIT.
010900*
011000 C999-CF-EXIT.
011100     EXIT.
011200/
011300 O000-OPEN-FILE SECTION.
011400 O010-OF-BEGIN.
011500*
011600     MOVE MMSC-DATE-FORMAT       TO SS01WS-DATE-FORMAT.
011700*
011800     MOVE 'O1RC'                 TO SS02WS-ABEND-LOCATION.
011900*
012000     IF  MBD100WS-UPDATE
012100         SET MMRCRB-OPEN-IO-DYN  TO TRUE
012200     ELSE
012300         SET MMRCRB-OPEN-INPUT-DYN
012400                                 TO TRUE.
012500*
012600     PERFORM MB00PD-MMRC-ACCESS
012700        THRU MB00PD-MMRC-ACCESS-EXIT.
012800*
012900     MOVE 'R0RC'                 TO SS02WS-ABEND-LOCATION.
013000     SET MMRCRB-READ-SEQ         TO TRUE.
013100     PERFORM MB00PD-MMRC-ACCESS
013200        THRU MB00PD-MMRC-ACCESS-EXIT.
013300     MOVE 'MMRC'                 TO MB99WS-FILE-ID.
013400*
013500     IF  MMRCIO-HEADER
013600         NEXT SENTENCE
013700     ELSE
013800         PERFORM MB99PD-MISSING-HEADER-ABEND
013900            THRU MB99PD-MHA-EXIT.
014000*
014100     MOVE MMRCIO-DATE-STAMP      TO MB99WS-FILE-DATE.
014200     MOVE MMRCIO-TIME-STAMP      TO MB99WS-FILE-TIME.
014300     PERFORM MB99PD-CHECK-DATE-TIME
014400        THRU MB99PD-CDT-EXIT.
014500*
014600     PERFORM Z900-INIT-RECORD
014700        THRU Z999-IR-EXIT.
014800*
014900 O999-OF-EXIT.
015000     EXIT.
015100/
015200 P000-PROCESS-RECORD SECTION.
015300 P010-PR-BEGIN.
015400*
015500     MOVE MMOC-CURRENCY-CODE     TO SS95WS-CURRENCY-CODE.
015600*
015700     IF  MTL1-MMRC-KEY IS NOT EQUAL TO MMRC-KEY
015800         PERFORM P500-FILE-UPDATE
015900            THRU P599-FU-EXIT.
016000*
016100     IF  MTL1-TOTALS-RECORD
016200         GO TO P099-PR-EXIT.
016300*
016400     IF  MTL1-MMRC-KEY IS NOT EQUAL TO MMRC-KEY
016500         PERFORM P700-GET-RECORD-TO-UPDATE
016600            THRU P799-GRTU-EXIT.
016700*
016800     MOVE MTL1-FIELD-CODE        TO MBD100WS-FIELD-CODE.
016900*
017000     IF (MBD100WS-FC-1-2-ADD AND MBD100WS-FC-3-4-ADD)
017100     OR (MBD100WS-FC-1-2-REP AND MBD100WS-FC-3-4-REP)
017200         PERFORM U000-NEW-RECORD
017300            THRU U099-NR-EXIT
017400     ELSE
017500         PERFORM 0000-MAINT-RECORD
017600            THRU 5999-MR-EXIT.
017700*
017800 P099-PR-EXIT.
017900     EXIT.
018000/
018100 P500-FILE-UPDATE SECTION.
018200 P510-FU-BEGIN.
018300*
018400     IF  MBD100WS-JOURNAL
018500         GO TO P599-FU-EXIT.
018600*
018700     IF  MMRC-KEY IS EQUAL TO MMRCIR-KEY
018800         GO TO P599-FU-EXIT.
018900*
019000     IF  MBD100WS-IO-REWRITE
019100         MOVE MMRC-RECORD        TO MMRCIO-RECORD
019200         MOVE SS02WS-NO-RECORD-FOUND
019300                                 TO MMRCRB-TEMP-STATUS-1
019400         MOVE 'U1RC'             TO SS02WS-ABEND-LOCATION
019500         SET MMRCRB-REWRITE      TO TRUE
019600         PERFORM MB00PD-MMRC-ACCESS
019700            THRU MB00PD-MMRC-ACCESS-EXIT
019800         IF  SS02WS-FS-NO-RECORD-FOUND
019900             MOVE 'W'            TO MBD100WS-IO-SW.
020000*
020100     IF  MBD100WS-IO-NO-REC-FOUND
020200     OR  MBD100WS-IO-WRITE
020300         MOVE MMRC-RECORD        TO MMRCIO-RECORD
020400         MOVE SS02WS-DUPLICATE-RECORD
020500                                 TO MMRCRB-TEMP-STATUS-1
020600         MOVE 'W2RC'             TO SS02WS-ABEND-LOCATION
020700         SET MMRCRB-WRITE        TO TRUE
020800         PERFORM MB00PD-MMRC-ACCESS
020900            THRU MB00PD-MMRC-ACCESS-EXIT
021000         IF  SS02WS-FS-DUPLICATE-RECORD
021100             MOVE 'U'            TO MBD100WS-IO-SW
021200             MOVE MMRC-RECORD    TO MMRCIO-RECORD
021300             MOVE 'U2RC'         TO SS02WS-ABEND-LOCATION
021400             SET MMRCRB-REWRITE  TO TRUE
021500             PERFORM MB00PD-MMRC-ACCESS
021600                THRU MB00PD-MMRC-ACCESS-EXIT.
021700*
021800     PERFORM Z900-INIT-RECORD
021900        THRU Z999-IR-EXIT.
022000*
022100 P599-FU-EXIT.
022200     EXIT.
022300/
022400 P700-GET-RECORD-TO-UPDATE SECTION.
022500 P710-GRTU-BEGIN.
022600*
022700     IF  MBD100WS-JOURNAL
022800         PERFORM Z900-INIT-RECORD
022900            THRU Z999-IR-EXIT
023000         GO TO P799-GRTU-EXIT.
023100*
023200     MOVE SS02WS-NO-RECORD-FOUND
023300                                 TO MMRCRB-TEMP-STATUS-1.
023400     MOVE MTL1-MMRC-KEY          TO MMRCIO-KEY.
023500*
023600     MOVE 'R1RC'                 TO SS02WS-ABEND-LOCATION.
023700     SET MMRCRB-READ-RANDOM      TO TRUE.
023800     PERFORM MB00PD-MMRC-ACCESS
023900        THRU MB00PD-MMRC-ACCESS-EXIT.
024000*
024100     IF  SS02WS-FS-NO-RECORD-FOUND
024200         PERFORM Z900-INIT-RECORD
024300            THRU Z999-IR-EXIT
024400         MOVE 'N'                TO MBD100WS-IO-SW
024500     ELSE
024600         MOVE MMRCIO-RECORD      TO MMRC-RECORD
024700         MOVE 'U'                TO MBD100WS-IO-SW.
024800*
024900 P799-GRTU-EXIT.
025000     EXIT.
025100/
025200 U000-NEW-RECORD SECTION.
025300 U010-NR-BEGIN.
025400*
025500     PERFORM Z100-COMMON-FROM-DATA
025600        THRU Z199-CFD-EXIT.
025700*
025800     PERFORM Z200-COMMON-TO-DATA
025900        THRU Z299-CTD-EXIT.
026000*
026100     MOVE MTL1-ADD-AREA          TO MMRC-RECORD.
026200*
026300     IF  MBD100WS-IO-NO-REC-FOUND
026400         MOVE 'W'                TO MBD100WS-IO-SW.
026500*
026600     IF  MBD100WS-FC-1-2-ADD
026700         MOVE '*** NEW RECORD ADDED ***'
026800                                 TO MBD100WS-PL2-TO-VALUE
026900                                    MBD100WS-PL1-FROM-VALUE
027000     ELSE
027100         MOVE '*** REPLACEMENT RECORD ***'
027200                                 TO MBD100WS-PL2-TO-VALUE
027300                                    MBD100WS-PL1-FROM-VALUE.
027400*
027500     MOVE SPACES                 TO MTCC-RECORD.
027600     MOVE MMRC-ORG               TO MTCC-MBU916-BEG-ORG.
027700     MOVE MMRC-CHAIN             TO MTCC-MBU916-BEG-CHAIN.
027800     MOVE 'MBU916'               TO MTCC-PROGRAM-ID.
027900     MOVE MTCC-RECORD            TO MTC2-RECORD.
028000*
028100 U099-NR-EXIT.
028200     EXIT.
028300/
028400 Z100-COMMON-FROM-DATA SECTION.
028500 Z110-CFD-BEGIN.
028600*
028700     MOVE MTL1-MMRC-CHAIN        TO MBD100WS-PL1-CHAIN.
028800*
028900 Z199-CFD-EXIT.
029000     EXIT.
029100/
029200 Z200-COMMON-TO-DATA SECTION.
029300 Z210-CTD-BEGIN.
029400*
029500 Z299-CTD-EXIT.
029600     EXIT.
029700/
029800 Z900-INIT-RECORD SECTION.
029900 Z910-IR-BEGIN.
030000*
030100     MOVE MMRCIR-RECORD          TO MMRC-RECORD.
030200     MOVE SPACES                 TO MTC1-RECORD.
030300     MOVE SPACES                 TO MTC2-RECORD.
030400*
030500 Z999-IR-EXIT.
030600     EXIT.
030700/
030800 0000-MAINT-RECORD SECTION.
030900 0010-MR-BEGIN.
031000*
031100     PERFORM Z100-COMMON-FROM-DATA
031200        THRU Z199-CFD-EXIT.
031300*
031400     PERFORM Z200-COMMON-TO-DATA
031500        THRU Z299-CTD-EXIT.
031600*
031700     IF  MTL1-FIELD-CODE IS EQUAL TO 0101
031800         GO TO 0101-MR-FIELD.
031900*
032000     IF  MTL1-FIELD-CODE IS EQUAL TO 0102
032100         GO TO 0102-MR-FIELD.
032200*
032300     IF  MTL1-FIELD-CODE IS EQUAL TO 0103
032400         GO TO 0103-MR-FIELD.
032500*
032600     IF  MTL1-FIELD-CODE IS EQUAL TO 0104
032700         GO TO 0104-MR-FIELD.
032800*
032900     IF  MTL1-FIELD-CODE IS EQUAL TO 0105
033000         GO TO 0105-MR-FIELD.
033100*
033200     IF  MTL1-FIELD-CODE IS EQUAL TO 0106
033300         GO TO 0106-MR-FIELD.
033400*
033500     IF  MTL1-FIELD-CODE IS EQUAL TO 0107
033600         GO TO 0107-MR-FIELD.
033700*
033800     IF  MTL1-FIELD-CODE IS EQUAL TO 0108
033900         GO TO 0108-MR-FIELD.
034000*
034100     IF  MTL1-FIELD-CODE IS EQUAL TO 0109
034200         GO TO 0109-MR-FIELD.
034300*
034400     IF  MTL1-FIELD-CODE IS EQUAL TO 0110
034500         GO TO 0110-MR-FIELD.
034600*
034700     IF  MTL1-FIELD-CODE IS EQUAL TO 0111
034800         GO TO 0111-MR-FIELD.
034900*
035000     IF  MTL1-FIELD-CODE IS EQUAL TO 0197
035100         GO TO 0197-MR-FIELD.
035200*
035300     IF  MTL1-FIELD-CODE IS EQUAL TO 0198
035400         GO TO 0198-MR-FIELD.
035500*
035600     IF  MTL1-FIELD-CODE IS EQUAL TO 0199
035700         GO TO 0199-MR-FIELD.
035800*
035900     IF  MTL1-FIELD-CODE IS EQUAL TO 0201
036000         GO TO 0201-MR-FIELD.
036100*
036200     MOVE '*** ERROR - INVALID FIELD CODE ***'
036300                                 TO MBD100WS-PL2-TO-VALUE.
036400     GO TO 5999-MR-EXIT.
036500*
036600 0101-MR-FIELD.
036700*
036800     IF  MBD100WS-JOURNAL
036900         MOVE MTL1-VL01-B-DATA-X TO MMRC-EURO-REPORTING-FLAG.
037000*
037100     MOVE 'EURO REPORTING FLAG   '
037200                                 TO MBD100WS-PL1-DESC.
037300     MOVE MMRC-EURO-REPORTING-FLAG
037400                                 TO MBD100WS-PL1-FROM-VALUE.
037500     MOVE MTL1-VL01-A-DATA-X     TO MMRC-EURO-REPORTING-FLAG.
037600     MOVE MMRC-EURO-REPORTING-FLAG
037700                                 TO MBD100WS-PL2-TO-VALUE.
037800     GO TO 5100-MR-NO-REC-CHECK.
037900*
038000*
038100*
038200 0102-MR-FIELD.
038300*
038400     IF  MBD100WS-JOURNAL
038500         MOVE MTL1-VL01-B-DATA-X TO MMRC-STMT-FLAG.
038600*
038700     MOVE 'STATEMENT PRINT       '
038800                                 TO MBD100WS-PL1-DESC.
038900     MOVE MMRC-STMT-FLAG         TO MBD100WS-PL1-FROM-VALUE.
039000     MOVE MTL1-VL01-A-DATA-X     TO MMRC-STMT-FLAG.
039100     MOVE MMRC-STMT-FLAG         TO MBD100WS-PL2-TO-VALUE.
039200     GO TO 5100-MR-NO-REC-CHECK.
039300*
039400*
039500*
039600 0103-MR-FIELD.
039700*
039800     IF  MBD100WS-JOURNAL
039900         MOVE MTL1-VL01-B-DATA-X TO MMRC-STMT-OPTION.
040000*
040100     MOVE 'STATEMENT OPTION      '
040200                                 TO MBD100WS-PL1-DESC.
040300     MOVE MMRC-STMT-OPTION       TO MBD100WS-PL1-FROM-VALUE.
040400     MOVE MTL1-VL01-A-DATA-X     TO MMRC-STMT-OPTION.
040500     MOVE MMRC-STMT-OPTION       TO MBD100WS-PL2-TO-VALUE.
040600     GO TO 5100-MR-NO-REC-CHECK.
040700*
040800*
040900*
041000 0104-MR-FIELD.
041100*
041200     IF  MBD100WS-JOURNAL
041300         MOVE MTL1-VL02-B-DATA-9 TO MMRC-STMT-FREQ-1.
041400*
041500     MOVE 'STATEMENT FREQUENCY 1 '
041600                                 TO MBD100WS-PL1-DESC.
041700     MOVE MMRC-STMT-FREQ-1       TO MBD100WS-PL1-FV-99.
041800     MOVE MTL1-VL02-A-DATA-9     TO MMRC-STMT-FREQ-1.
041900     MOVE MMRC-STMT-FREQ-1       TO MBD100WS-PL2-TV-99.
042000     GO TO 5100-MR-NO-REC-CHECK.
042100*
042200*
042300*
042400 0105-MR-FIELD.
042500*
042600     IF  MBD100WS-JOURNAL
042700         MOVE MTL1-VL02-B-DATA-9 TO MMRC-STMT-FREQ-2.
042800*
042900     MOVE 'STATEMENT FREQUENCY 2 '
043000                                 TO MBD100WS-PL1-DESC.
043100     MOVE MMRC-STMT-FREQ-2       TO MBD100WS-PL1-FV-99.
043200     MOVE MTL1-VL02-A-DATA-9     TO MMRC-STMT-FREQ-2.
043300     MOVE MMRC-STMT-FREQ-2       TO MBD100WS-PL2-TV-99.
043400     GO TO 5100-MR-NO-REC-CHECK.
043500*
043600*
043700*
043800 0106-MR-FIELD.
043900*
044000     SET X-MMRC-NA               TO MTL1-FIELD-OCCURRENCE.
044100*
044200     IF  MBD100WS-JOURNAL
044300         MOVE MTL1-VL40-B-DATA-X TO MMRC-NA-LINE
044400                                    (X-MMRC-NA).
044500*
044600     MOVE 'NAME/ADDRESS LINE     '
044700                                 TO MBD100WS-PL1-DESC.
044800     MOVE MMRC-NA-LINE
044900          (X-MMRC-NA)            TO MBD100WS-PL1-FROM-VALUE.
045000     MOVE MTL1-VL40-A-DATA-X     TO MMRC-NA-LINE
045100                                    (X-MMRC-NA).
045200     MOVE MMRC-NA-LINE
045300          (X-MMRC-NA)            TO MBD100WS-PL2-TO-VALUE.
045400     GO TO 5100-MR-NO-REC-CHECK.
045500*
045600*
045700*
045800 0107-MR-FIELD.
045900*
046000     IF  MBD100WS-JOURNAL
046100         MOVE MTL1-VL03-B-DATA-X TO MMRC-STATE-CODE.
046200*
046300     MOVE 'STATE/PROVINCE CODE   '
046400                                 TO MBD100WS-PL1-DESC.
046500     MOVE MMRC-STATE-CODE        TO MBD100WS-PL1-FROM-VALUE.
046600     MOVE MTL1-VL03-A-DATA-X     TO MMRC-STATE-CODE.
046700     MOVE MMRC-STATE-CODE        TO MBD100WS-PL2-TO-VALUE.
046800     GO TO 5100-MR-NO-REC-CHECK.
046900*
047000*
047100*
047200 0108-MR-FIELD.
047300*
047400     IF  MBD100WS-JOURNAL
047500         MOVE MTL1-VL20-B-DATA-X TO MMRC-PHONE.
047600*
047700     MOVE 'PHONE NUMBER          '
047800                                 TO MBD100WS-PL1-DESC.
047900     MOVE MMRC-PHONE             TO MBD100WS-PL1-FROM-VALUE.
048000     MOVE MTL1-VL20-A-DATA-X     TO MMRC-PHONE.
048100     MOVE MMRC-PHONE             TO MBD100WS-PL2-TO-VALUE.
048200     GO TO 5100-MR-NO-REC-CHECK.
048300*
048400*
048500*
048600 0109-MR-FIELD.
048700*
048800     IF  MBD100WS-JOURNAL
048900         MOVE MTL1-VL10-B-DATA-X TO MMRC-POSTAL-CODE.
049000*
049100     MOVE 'POSTAL CODE           '
049200                                 TO MBD100WS-PL1-DESC.
049300     MOVE MMRC-POSTAL-CODE       TO MBD100WS-PL1-FROM-VALUE.
049400     MOVE MTL1-VL10-A-DATA-X     TO MMRC-POSTAL-CODE.
049500     MOVE MMRC-POSTAL-CODE       TO MBD100WS-PL2-TO-VALUE.
049600     GO TO 5100-MR-NO-REC-CHECK.
049700*
049800*
049900*
050000 0110-MR-FIELD.
050100*
050200     IF  MBD100WS-JOURNAL
050300         MOVE MTL1-VL20-B-DATA-X TO MMRC-FAX.
050400*
050500     MOVE 'FAX NUMBER            '
050600                                 TO MBD100WS-PL1-DESC.
050700     MOVE MMRC-FAX               TO MBD100WS-PL1-FROM-VALUE.
050800     MOVE MTL1-VL20-A-DATA-X     TO MMRC-FAX.
050900     MOVE MMRC-FAX               TO MBD100WS-PL2-TO-VALUE.
051000     GO TO 5100-MR-NO-REC-CHECK.
051100*
051200*
051300*
051400 0111-MR-FIELD.
051500*
051600     SET X-MMRC-STMT-MSG         TO MTL1-FIELD-OCCURRENCE.
051700*
051800     IF  MBD100WS-JOURNAL
051900         MOVE MTL1-VL01-B-DATA-X TO MMRC-STMT-MSG-FLAG
052000                                    (X-MMRC-STMT-MSG).
052100*
052200     MOVE 'STATEMENT MESSAGE FLAG'
052300                                 TO MBD100WS-PL1-DESC.
052400     MOVE MMRC-STMT-MSG-FLAG
052500          (X-MMRC-STMT-MSG)      TO MBD100WS-PL1-FROM-VALUE.
052600     MOVE MTL1-VL01-A-DATA-X     TO MMRC-STMT-MSG-FLAG
052700                                    (X-MMRC-STMT-MSG).
052800     MOVE MMRC-STMT-MSG-FLAG
052900          (X-MMRC-STMT-MSG)      TO MBD100WS-PL2-TO-VALUE.
053000     GO TO 5100-MR-NO-REC-CHECK.
053100*
053200*
053300*
053400 0197-MR-FIELD.
053500*
053600     IF  MBD100WS-JOURNAL
053700         MOVE MTL1-VL01-B-DATA-9 TO MMRC-REC-STATUS.
053800*
053900     MOVE 'RECORD STATUS         '
054000                                 TO MBD100WS-PL1-DESC.
054100     MOVE MMRC-REC-STATUS        TO MBD100WS-PL1-FV-9.
054200     MOVE MTL1-VL01-A-DATA-9     TO MMRC-REC-STATUS.
054300     MOVE MMRC-REC-STATUS        TO MBD100WS-PL2-TV-9.
054400     GO TO 5100-MR-NO-REC-CHECK.
054500*
054600*
054700*
054800 0198-MR-FIELD.
054900*
055000     IF  MBD100WS-JOURNAL
055100         MOVE MTL1-VL03-B-DATA-X TO MMRC-LAST-MAINT-OPER.
055200*
055300     MOVE 'LAST MAINT OPERATOR   '
055400                                 TO MBD100WS-PL1-DESC.
055500     MOVE MMRC-LAST-MAINT-OPER   TO MBD100WS-PL1-FROM-VALUE.
055600     MOVE MTL1-VL03-A-DATA-X     TO MMRC-LAST-MAINT-OPER.
055700     MOVE MMRC-LAST-MAINT-OPER   TO MBD100WS-PL2-TO-VALUE.
055800     GO TO 5100-MR-NO-REC-CHECK.
055900*
056000*
056100*
056200 0199-MR-FIELD.
056300*
056400     IF  MBD100WS-JOURNAL
056500         MOVE MTL1-VL07-B-DATA-9 TO MMRC-LAST-MAINT-DATE.
056600*
056700     MOVE 'DATE LAST MAINTENANCE '
056800                                 TO MBD100WS-PL1-DESC.
056900     MOVE MMRC-LAST-MAINT-DATE   TO SS01WS-JULIAN.
057000     PERFORM 8100-FROM-DATE      THRU 8199-FD-EXIT.
057100     MOVE MTL1-VL07-A-DATA-9     TO MMRC-LAST-MAINT-DATE.
057200     MOVE MMRC-LAST-MAINT-DATE   TO SS01WS-JULIAN.
057300     PERFORM 8200-TO-DATE        THRU 8299-TD-EXIT.
057400     GO TO 5100-MR-NO-REC-CHECK.
057500*
057600*
057700*
057800 0201-MR-FIELD.
057900*
058000     SET X-MMRC-STMT-MSG         TO MTL1-FIELD-OCCURRENCE.
058100     SET X-MMRC-STMT-MSG-LINE    TO MTL1-FIELD-OCCURRENCE-2.
058200*
058300     IF  MBD100WS-JOURNAL
058400         MOVE MTL1-VL50-B-DATA-X TO MMRC-STMT-MSG-LINE
058500                                    (X-MMRC-STMT-MSG
058600                                     X-MMRC-STMT-MSG-LINE).
058700*
058800     MOVE 'STATEMENT MESSAGE LINE'
058900                                 TO MBD100WS-PL1-DESC.
059000     MOVE MMRC-STMT-MSG-LINE
059100          (X-MMRC-STMT-MSG X-MMRC-STMT-MSG-LINE)
059200                                 TO MBD100WS-PL1-FROM-VALUE.
059300     MOVE MTL1-VL50-A-DATA-X     TO MMRC-STMT-MSG-LINE
059400                                    (X-MMRC-STMT-MSG
059500                                     X-MMRC-STMT-MSG-LINE).
059600     MOVE MMRC-STMT-MSG-LINE
059700          (X-MMRC-STMT-MSG X-MMRC-STMT-MSG-LINE)
059800                                 TO MBD100WS-PL2-TO-VALUE.
059900     GO TO 5100-MR-NO-REC-CHECK.
060000*
060100*
060200*
060300 5100-MR-NO-REC-CHECK.
060400*
060500     IF  MBD100WS-UPDATE
060600     AND MBD100WS-IO-NO-REC-FOUND
060700         MOVE '*** ERROR - NO RECORD FOUND ***'
060800                                 TO MBD100WS-PL2-TO-VALUE.
060900*
061000 5999-MR-EXIT.
061100     EXIT.
061200/
061300 8100-FROM-DATE SECTION.
061400 8110-FD-BEGIN.
061500*
061600     MOVE SS01WS-JULIAN          TO MBD100WS-PL1-FV-JULIAN.
061700     PERFORM SS26PD-NUMERICALLY-EDIT-DATE
061800        THRU SS26PD-NED-EXIT.
061900     MOVE SS01WS-XX-XX-YYYY      TO MBD100WS-PL1-FV-DATE.
062000     INSPECT MBD100WS-PL1-FV-JULIAN REPLACING ALL ',' BY '-'.
062100*
062200 8199-FD-EXIT.
062300     EXIT.
062400*
062500*
062600*
062700 8200-TO-DATE SECTION.
062800 8210-TD-BEGIN.
062900*
063000     MOVE SS01WS-JULIAN          TO MBD100WS-PL2-TV-JULIAN.
063100     PERFORM SS26PD-NUMERICALLY-EDIT-DATE
063200        THRU SS26PD-NED-EXIT.
063300     MOVE SS01WS-XX-XX-YYYY      TO MBD100WS-PL2-TV-DATE.
063400     INSPECT MBD100WS-PL2-TV-JULIAN REPLACING ALL ',' BY '-'.
063500*
063600 8299-TD-EXIT.
063700     EXIT.
063800/
063900 9000-PERFORMED-ROUTINES-SECT SECTION.
064000*
064100     COPY MB00PD REPLACING ==:MB00:== BY ==MMRC==.
064200/
064300     COPY SS95PD.
064400/
064500     COPY MB99PD.
064600/
064700     COPY SS02PD.
064800/
064900     COPY SS07PD.
065000/
065100     COPY SS08PD.
065200/
065300     COPY SS26PD.
065400/
065500     COPY SS27PD.
065600*
065700 9995-END-SOURCE-STATEMENTS SECTION.
065800 9999-END-OF-PROGRAM.
065900     EXIT.
