000100 IDENTIFICATION DIVISION.
000200 PROGRAM-ID. MBD200AE.
000201*       RELEASE DATE=08/24/01.        REVISION LEVEL=08.06      * ++++++++
000202***************************************************************** ++++++++
000203*WARNING.  THIS COMPUTER PROGRAM IS PROTECTED BY COPYRIGHT LAW  * ++++++++
000204*AND INTERNATIONAL TREATIES.  UNAUTHORIZED REPRODUCTION OR      * ++++++++
000205*DISTRIBUTION OF THIS PROGRAM, OR ANY PORTION OF IT, MAY RESULT * ++++++++
000206*IN SEVERE CIVIL AND CRIMINAL PENATLIES, AND WILL BE PROSECUTED * ++++++++
000207*TO THE MAXIMUM EXTENT POSSIBLE UNDER THE LAW.                  * ++++++++
000208*COPYRIGHT 1999 PAYSYS INTERNATIONAL, INC.  ALL RIGHTS RESERVED.* ++++++++
000209***************************************************************** ++++++++
000300*****************************************************************
000400*                                                               *
000500*   V - PLUS  M E R C H A N T   B A N K C A R D   S Y S T E M   *
000600*                                                               *
000700*       MBD200AE - ACH EFFECTIVE DATE SUBROUTINE                *
000800*                                                               *
000900*****************************************************************
001000 ENVIRONMENT DIVISION.
001100 CONFIGURATION SECTION.
001200 SOURCE-COMPUTER.            IBM-4341.
001300 OBJECT-COMPUTER.            IBM-4341.
001400/
001500 DATA DIVISION.
001600 WORKING-STORAGE SECTION.
001700*
001800 01  FILLER                  PIC  X(12)      VALUE '** WS-BEG **'.
001900*
002000 01  WS-D200-WORK-AREAS.
002100     03  WS-D200-SEARCH-SW   PIC  X(01)      VALUE 'Y'.
002200     03  WS-D200-ACH-DATE    PIC  9(07)      VALUE ZERO.
002300     03  WS-D200-ACH-DAYS    PIC  9(01)      VALUE ZERO.
002400/
002500     COPY MB00WS.
002600/
002700     COPY SS01WS.
002800*
002900 01  FILLER                  PIC  X(12)      VALUE '** WS-END **'.
003000/
003100 LINKAGE SECTION.
003200     COPY MBD200WS.
003300/
003400     COPY MMSCRL.
003500/
003600     COPY MMOCRL.
003700/
003800 PROCEDURE DIVISION              USING MBD200WS-AREA
003900                                       MMSC-RECORD
004000                                       MMOC-RECORD.
004100*
004200 A000-MAIN-LINE SECTION.
004300 A010-ML-BEGIN.
004400*
004500     MOVE ZERO                   TO MBD200WS-MBD200AE-EFF-DATE-CR.
004600     MOVE ZERO                   TO MBD200WS-MBD200AE-EFF-DATE-DR.
004700*
004800*
004900*
005000     MOVE 2                      TO WS-D200-ACH-DAYS.
005100     PERFORM B000-CALC-ACH-EFF-DATE
005200        THRU B999-CAED-EXIT.
005300     MOVE WS-D200-ACH-DATE       TO MBD200WS-MBD200AE-EFF-DATE-CR.
005400*
005500*
005600*
005700     MOVE 1                      TO WS-D200-ACH-DAYS.
005800     PERFORM B000-CALC-ACH-EFF-DATE
005900        THRU B999-CAED-EXIT.
006000     MOVE WS-D200-ACH-DATE       TO MBD200WS-MBD200AE-EFF-DATE-DR.
006100*
006200*
006300*
006400     GOBACK.
006500*
006600 A999-ML-EXIT.
006700     EXIT.
006800/
006900 B000-CALC-ACH-EFF-DATE SECTION.
007000 B010-CAED-BEGIN.
007100*
007200     MOVE MMOC-TODAYS-JULIAN     TO SS01WS-JULIAN.
007300     MOVE 1                      TO SS01WS-FREQ.
007400     MOVE 'D'                    TO SS01WS-PERIOD.
007500     PERFORM SS03PD-FUTURE-DATE
007600        THRU SS03PD-FD-EXIT.
007700     MOVE SS01WS-JULIAN          TO WS-D200-ACH-DATE.
007800*
007900     PERFORM C000-CHECK-ACH-CALENDAR
008000        THRU C099-CAC-EXIT.
008100*
008200     MOVE WS-D200-ACH-DATE       TO SS01WS-JULIAN.
008300     MOVE WS-D200-ACH-DAYS       TO SS01WS-FREQ.
008400     MOVE 'D'                    TO SS01WS-PERIOD.
008500     PERFORM SS03PD-FUTURE-DATE
008600        THRU SS03PD-FD-EXIT.
008700     MOVE SS01WS-JULIAN          TO WS-D200-ACH-DATE.
008800*
008900     PERFORM C000-CHECK-ACH-CALENDAR
009000        THRU C099-CAC-EXIT.
009100*
009200 B999-CAED-EXIT.
009300     EXIT.
009400/
009500 C000-CHECK-ACH-CALENDAR SECTION.
009600 C010-CAC-BEGIN.
009700*
009800     MOVE WS-D200-ACH-DATE       TO SS01WS-JULIAN.
009900     PERFORM SS06PD-DAY-OF-WEEK
010000        THRU SS06PD-DOW-EXIT.
010100*
010200     COMPUTE SS01WS-DOW          =  SS01WS-DOW + 1.
010300     SET X-MMSC-ACH-WW           TO SS01WS-DOW.
010400     MOVE ZERO                   TO SS01WS-FREQ.
010500*
010600     PERFORM C100-CHECK-WORK-WEEK
010700        THRU C199-CWW-EXIT
010800        UNTIL MMSC-ACH-WORK-WEEK-R (X-MMSC-ACH-WW)
010900                                 IS EQUAL TO 'X'
011000           OR  SS01WS-FREQ IS GREATER THAN 7.
011100*
011200     MOVE WS-D200-ACH-DATE       TO SS01WS-JULIAN.
011300     MOVE 'D'                    TO SS01WS-PERIOD.
011400     PERFORM SS03PD-FUTURE-DATE
011500        THRU SS03PD-FD-EXIT.
011600     MOVE SS01WS-JULIAN          TO WS-D200-ACH-DATE.
011700*
011800     MOVE 'Y'                    TO WS-D200-SEARCH-SW.
011900*
012000     PERFORM C200-CHECK-HOLIDAYS
012100        THRU C299-CH-EXIT
012200        UNTIL WS-D200-SEARCH-SW IS EQUAL TO 'N'.
012300*
012400 C099-CAC-EXIT.
012500     EXIT.
012600/
012700 C100-CHECK-WORK-WEEK SECTION.
012800 C110-CWW-BEGIN.
012900*
013000     SET X-MMSC-ACH-WW           UP BY 1.
013100     ADD 1                       TO SS01WS-FREQ.
013200*
013300     IF  X-MMSC-ACH-WW IS GREATER THAN 7
013400         SET X-MMSC-ACH-WW       TO 1.
013500*
013600 C199-CWW-EXIT.
013700     EXIT.
013800/
013900 C200-CHECK-HOLIDAYS SECTION.
014000 C210-CH-BEGIN.
014100*
014200     SET X-MMSC-ACH-HOL          TO 1.
014300     SEARCH MMSC-ACH-HOLIDAYS-TABLE
014400         VARYING X-MMSC-ACH-HOL
014500         AT END
014600             MOVE 'N'            TO WS-D200-SEARCH-SW
014700             GO TO C299-CH-EXIT
014800         WHEN WS-D200-ACH-DATE IS EQUAL TO
014900              MMSC-ACH-HOLIDAYS (X-MMSC-ACH-HOL)
015000              NEXT SENTENCE.
015100*
015200     MOVE WS-D200-ACH-DATE       TO SS01WS-JULIAN.
015300     MOVE 1                      TO SS01WS-FREQ.
015400     MOVE 'D'                    TO SS01WS-PERIOD.
015500     PERFORM SS03PD-FUTURE-DATE
015600        THRU SS03PD-FD-EXIT.
015700     MOVE SS01WS-JULIAN          TO WS-D200-ACH-DATE.
015800*
015900 C299-CH-EXIT.
016000     EXIT.
016100/
016200 9000-PERFORMED-ROUTINES-SECT SECTION.
016300     COPY SS03PD.
016400/
016500     COPY SS06PD.
016600/
016700     COPY SS07PD.
016800/
016900     COPY SS08PD.
017000*
017100 9995-END-SOURCE-STATEMENTS SECTION.
017200 9999-END-OF-PROGRAM.
017300     EXIT.
