000100 IDENTIFICATION DIVISION.
000200 PROGRAM-ID. MBD200DC.
000201*       RELEASE DATE=08/24/01.        REVISION LEVEL=08.06      * ++++++++
000202***************************************************************** ++++++++
000203*WARNING.  THIS COMPUTER PROGRAM IS PROTECTED BY COPYRIGHT LAW  * ++++++++
000204*AND INTERNATIONAL TREATIES.  UNAUTHORIZED REPRODUCTION OR      * ++++++++
000205*DISTRIBUTION OF THIS PROGRAM, OR ANY PORTION OF IT, MAY RESULT * ++++++++
000206*IN SEVERE CIVIL AND CRIMINAL PENATLIES, AND WILL BE PROSECUTED * ++++++++
000207*TO THE MAXIMUM EXTENT POSSIBLE UNDER THE LAW.                  * ++++++++
000208*COPYRIGHT 1999 PAYSYS INTERNATIONAL, INC.  ALL RIGHTS RESERVED.* ++++++++
000209***************************************************************** ++++++++
000300*****************************************************************
000400*                                                               *
000500*       MBD200DC - DISCOUNT SUBROUTINE                          *
000600*                                                               *
000700*****************************************************************
000800 ENVIRONMENT DIVISION.
000900 CONFIGURATION SECTION.
001000 SOURCE-COMPUTER.            IBM-4341.
001100 OBJECT-COMPUTER.            IBM-4341.
001200/
001300 DATA DIVISION.
001400 WORKING-STORAGE SECTION.
001500*
001600 01  FILLER                  PIC  X(12)      VALUE '** WS-BEG **'.
001700*
001800 01  WS-D200-AREA.
001900     03  WS-D200-INIT-SW     PIC  X(01)      VALUE 'Y'.
002000         88  WS-D200-INITIALIZE-YES          VALUE 'Y'.
002100         88  WS-D200-INITIALIZE-NO           VALUE 'N'.
002200     03  WS-D200-ROLLING-SEARCH-AMT
002300                             PIC S9(17)      COMP-3 VALUE ZERO.
002400     03  WS-D200-ROLLING-DENOMINATOR
002500                             PIC S9(17)      COMP-3 VALUE ZERO.
002600     03  WS-D200-EXCEPTION-FUNCTION
002700                             PIC  X(01)      VALUE 'O'.
002800         88  WS-D200-EF-OVERRIDE             VALUE 'O'.
002900         88  WS-D200-EF-ADJUSTMENT           VALUE 'A'.
003000     03  WS-D200-EXCEPTION-PRIORITY-X.
003100         05  WS-D200-EXCEPTION-PRIORITY-9
003200                             PIC  9(01)      VALUE ZERO.
003300     03  WS-D200-EXCEPTION-PRIORITY-R
003400                             REDEFINES
003500                             WS-D200-EXCEPTION-PRIORITY-X.
003600         05  WS-D200-EXCEPTION-PRIORITY
003700                             PIC  X(01).
003800     03  WS-D200-RATE-PER-ITEM
003900                             PIC S9(09)      COMP-3 VALUE ZERO.
004000     03  WS-D200-RATE-PCT    REDEFINES WS-D200-RATE-PER-ITEM
004100                             PIC S9(09)      COMP-3.
004200     03  WS-D200-RATE-PER-ITEM-ADJ
004300                             PIC S9(09)      COMP-3 VALUE ZERO.
004400     03  WS-D200-RATE-PCT-ADJ
004500                             REDEFINES WS-D200-RATE-PER-ITEM-ADJ
004600                             PIC S9(09)      COMP-3.
004700*
004800 01  WS-D200-SALES-RETURNS-AREA.
004900     03  WS-D200-SRA-TABLE                   OCCURS 18 TIMES
005000                                             INDEXED BY
005100                                             X-WS-D200-SRA
005200                                             X-WS-D200-SRA-1
005300                                             X-WS-D200-SRA-2.
005400         05  WS-D200-SRA-SALES-NBR
005500                             PIC S9(09)      COMP-3 VALUE ZERO.
005600         05  WS-D200-SRA-SALES-AMT
005700                             PIC S9(17)      COMP-3 VALUE ZERO.
005800         05  WS-D200-SRA-RETURNS-NBR
005900                             PIC S9(09)      COMP-3 VALUE ZERO.
006000         05  WS-D200-SRA-RETURNS-AMT
006100                             PIC S9(17)      COMP-3 VALUE ZERO.
006200         05  WS-D200-SRA-INCOME-AMT
006300                             PIC S9(17)      COMP-3 VALUE ZERO.
006400         05  WS-D200-SRA-AVG-TKT
006500                             PIC S9(17)      COMP-3 VALUE ZERO.
006600/
006700     COPY MMPARL REPLACING ==:MMPA:== BY ==MMPA==.
006800/
006900     COPY MMPARL REPLACING ==:MMPA:== BY ==MMCP==.
007000/
007100     COPY MMRTWS.
007200/
007300     COPY MMTCWS.
007400/
007500     COPY MB00WS.
007600*
007700     COPY SS00WS.
007800*
007900     COPY SS50WS.
008000*
008100 01  FILLER                  PIC  X(12)      VALUE '** WS-END **'.
008200/
008300 LINKAGE SECTION.
008400     COPY MBD200WS.
008500/
008600     COPY MMMPRL.
008700/
008800     COPY MMSCRL.
008900/
009000     COPY MMOCRL.
009100/
009200     COPY MMMMRL.
009300/
009400     COPY MMRTRL.
009500/
009600     COPY MTPTRL REPLACING ==:MTPT:== BY ==MTPT==.
009700/
009800     COPY MMPATB REPLACING ==:MMPA:== BY ==MMPA==.
009900/
010000     COPY MMPATB REPLACING ==:MMPA:== BY ==MMCP==.
010100/
010200 PROCEDURE DIVISION              USING MBD200WS-AREA
010300                                       MMMP-RECORD
010400                                       MMSC-RECORD
010500                                       MMOC-RECORD
010600                                       MMMM-RECORD
010700                                       MMRT-RECORD
010800                                       MTPT-RECORD
010900                                       MMPATB-TABLE-PARMS
011000                                       MMPATB-TABLE-DATA
011100                                       MMCPTB-TABLE-PARMS
011200                                       MMCPTB-TABLE-DATA.
011300*
011400 A000-MAIN-LINE SECTION.
011500 A010-ML-BEGIN.
011600*
011700     PERFORM A100-DISCOUNT-PROCESSING
011800        THRU A199-DP-EXIT.
011900*
012000     GOBACK.
012100*
012200 A099-ML-EXIT.
012300     EXIT.
012400/
012500 A100-DISCOUNT-PROCESSING SECTION.
012600 A100-DP-BEGIN.
012700*
012800     IF  WS-D200-INITIALIZE-YES
012900         PERFORM A800-SUBROUTINE-INIT
013000            THRU A899-SI-EXIT
013100     END-IF.
013200*
013300     MOVE MMRT-METHOD            TO MMRTWS-METHOD.
013400*
013500     EVALUATE TRUE
013600         WHEN MBD200WS-DA-DF-PROCESS-TRANS
013700             PERFORM E000-PROCESS-TRANSACTION
013800                THRU E099-PT-EXIT
013900         WHEN MBD200WS-DA-DF-PROCESS-TODAYS
014000             PERFORM T000-PROCESS-TODAYS
014100                THRU T099-PT-EXIT
014200         WHEN MBD200WS-DA-DF-PROCESS-AVG-TKT
014300             IF  MMRTWS-DTD-VOLUME-W-AVG-TKT
014400             AND MMRT-EXCEPTION-IS-ADJUSTMENT (1)
014500                 PERFORM V000-PROCESS-AVG-TICKET
014600                    THRU V099-PAT-EXIT
014700             END-IF
014800         WHEN MBD200WS-DA-DF-PROCESS-PLAN
014900             IF  MMRTWS-DTD-VOLUME-W-CR-PLAN
015000             AND
015100                (MMRT-EXCEPTION-IS-ADJUSTMENT (2)
015200              OR MMRT-EXCEPTION-COND-OVERRIDE (2))
015300                 PERFORM P000-PROCESS-PLAN
015400                    THRU P099-PP-EXIT
015500             END-IF
015600         WHEN MBD200WS-DA-DF-CALC-DISC
015700             PERFORM C000-CALCULATE-DISCOUNT
015800                THRU C099-CD-EXIT
015900         WHEN OTHER
016000             PERFORM X000-DISCOUNT-SETUP
016100                THRU X099-DS-EXIT
016200     END-EVALUATE.
016300*
016400 A199-DP-EXIT.
016500     EXIT.
016600/
016700 A800-SUBROUTINE-INIT SECTION.
016800 A801-SI-BEGIN.
016900*
017000     SET SS50WS-FUNCTION-INITIALIZE
017100                                 TO TRUE.
017200     PERFORM SS50PD-MULTIPLY
017300        THRU SS50PD-M-EXIT.
017400*
017500     SET WS-D200-INITIALIZE-NO   TO TRUE.
017600*
017700 A899-SI-EXIT.
017800     EXIT.
017900/
018000 C000-CALCULATE-DISCOUNT SECTION.
018100 C001-CD-BEGIN.
018200*
018300     COMPUTE MBD200WS-DA-AMT-SUBJECT-TIERS
018400                                 =  MBD200WS-DA-AMT-PREV-TODAY
018500                                 -  MBD200WS-DA-AMT-OVERRIDE.
018600     COMPUTE MBD200WS-DA-NBR-SUBJECT-TIERS
018700                                 =  MBD200WS-DA-NBR-PREV-TODAY
018800                                 -  MBD200WS-DA-NBR-OVERRIDE.
018900*
019000     IF  MMRTWS-INCREMENTAL-METHODS
019100         PERFORM D000-LOAD-DISCOUNT-W-TODAY
019200            THRU D099-LDWT-EXIT
019300            VARYING X-MMRT-PRIM FROM 1 BY 1
019400            UNTIL   X-MMRT-PRIM IS GREATER THAN 10.
019500*
019600     EVALUATE TRUE
019700         WHEN MMRTWS-INCREMENTAL-METHODS
019800             PERFORM C100-APPLY-INCREMENTAL
019900                THRU C199-AI-EXIT
020000         WHEN OTHER
020100             PERFORM C500-APPLY-CUMULATIVE
020200                THRU C599-AC-EXIT
020300     END-EVALUATE.
020400*
020500     PERFORM C900-FINAL-DISCOUNT-TOTAL
020600        THRU C999-FDT-EXIT.
020700*
020800 C099-CD-EXIT.
020900     EXIT.
021000/
021100 C100-APPLY-INCREMENTAL SECTION.
021200 C101-AI-BEGIN.
021300*
021400     MOVE MBD200WS-DA-AMT-SUBJECT-TIERS
021500                                 TO MBD200WS-DA-WORK-AMT-7.
021600     MOVE MBD200WS-DA-NBR-SUBJECT-TIERS
021700                                 TO MBD200WS-DA-WORK-NBR-7.
021800*
021900     IF  MMRTWS-VALID-METH-ON-NUMBER
022000         EVALUATE TRUE
022100             WHEN MBD200WS-DA-NBR-SUBJECT-TIERS
022200                                 IS NOT LESS THAN ZERO
022300                 PERFORM C200-LOAD-TIER-W-SUBJ-TO-DISC
022400                    THRU C299-LTWSTD-EXIT
022500                    VARYING X-MBD200WS-DA-TIER FROM 10 BY -1
022600                      UNTIL X-MBD200WS-DA-TIER IS LESS THAN 1
022700             WHEN OTHER
022800                 PERFORM C200-LOAD-TIER-W-SUBJ-TO-DISC
022900                    THRU C299-LTWSTD-EXIT
023000                    VARYING X-MBD200WS-DA-TIER FROM 1 BY 1
023100                      UNTIL X-MBD200WS-DA-TIER IS GREATER THAN 10
023200         END-EVALUATE
023300     ELSE
023400         EVALUATE TRUE
023500             WHEN MBD200WS-DA-AMT-SUBJECT-TIERS
023600                                 IS NOT LESS THAN ZERO
023700                 PERFORM C200-LOAD-TIER-W-SUBJ-TO-DISC
023800                    THRU C299-LTWSTD-EXIT
023900                    VARYING X-MBD200WS-DA-TIER FROM 10 BY -1
024000                      UNTIL X-MBD200WS-DA-TIER IS LESS THAN 1
024100             WHEN OTHER
024200                 PERFORM C200-LOAD-TIER-W-SUBJ-TO-DISC
024300                    THRU C299-LTWSTD-EXIT
024400                    VARYING X-MBD200WS-DA-TIER FROM 1 BY 1
024500                      UNTIL X-MBD200WS-DA-TIER IS GREATER THAN 10
024600         END-EVALUATE
024700     END-IF.
024800*
024900     PERFORM C800-COMPUTE-DISC-IN-TIER
025000        THRU C899-CDIT-EXIT
025100        VARYING X-MBD200WS-DA-TIER FROM 1 BY 1
025200          UNTIL X-MBD200WS-DA-TIER IS GREATER THAN 10.
025300*
025400     EVALUATE TRUE
025500         WHEN (MMRTWS-CTD-NUMBER-INC
025600           OR  MMRTWS-CTD-VOLUME-INC)
025700             MOVE WS-D200-SRA-AVG-TKT (16)
025800                                 TO MBD200WS-DA-AVG-TKT-AMT
025900         WHEN (MMRTWS-MTD-NUMBER-INC
026000           OR  MMRTWS-MTD-VOLUME-INC
026100           OR  MMRTWS-MTD-TIERED-INCOME)
026200             MOVE WS-D200-SRA-AVG-TKT (14)
026300                                 TO MBD200WS-DA-AVG-TKT-AMT
026400         WHEN OTHER
026500             MOVE WS-D200-SRA-AVG-TKT (17)
026600                                 TO MBD200WS-DA-AVG-TKT-AMT
026700     END-EVALUATE.
026800*
026900*
027000*
027100 C199-AI-EXIT.
027200     EXIT.
027300/
027400 C200-LOAD-TIER-W-SUBJ-TO-DISC SECTION.
027500 C201-LTWSTD-BEGIN.
027600*
027700     IF  MMRTWS-VALID-METH-ON-NUMBER
027800         EVALUATE TRUE
027900             WHEN MBD200WS-DA-TIER-NBR-TODAY (X-MBD200WS-DA-TIER)
028000                      IS NOT LESS THAN MBD200WS-DA-WORK-NBR-7
028100                 MOVE MBD200WS-DA-WORK-NBR-7
028200                                 TO MBD200WS-DA-TIER-NBR-SUBJECT
028300                                    (X-MBD200WS-DA-TIER)
028400                 MOVE ZERO       TO MBD200WS-DA-WORK-NBR-7
028500             WHEN OTHER
028600                 MOVE MBD200WS-DA-TIER-NBR-TODAY
028700                      (X-MBD200WS-DA-TIER)
028800                                 TO MBD200WS-DA-TIER-NBR-SUBJECT
028900                                    (X-MBD200WS-DA-TIER)
029000                 COMPUTE MBD200WS-DA-WORK-NBR-7
029100                                 =  MBD200WS-DA-WORK-NBR-7
029200                                 -  MBD200WS-DA-TIER-NBR-TODAY
029300                                    (X-MBD200WS-DA-TIER)
029400                 END-COMPUTE
029500         END-EVALUATE
029600     ELSE
029700         EVALUATE TRUE
029800             WHEN MBD200WS-DA-TIER-AMT-TODAY (X-MBD200WS-DA-TIER)
029900                      IS NOT LESS THAN MBD200WS-DA-WORK-AMT-7
030000                 MOVE MBD200WS-DA-WORK-AMT-7
030100                                 TO MBD200WS-DA-TIER-AMT-SUBJECT
030200                                    (X-MBD200WS-DA-TIER)
030300                 MOVE ZERO       TO MBD200WS-DA-WORK-AMT-7
030400             WHEN OTHER
030500                 MOVE MBD200WS-DA-TIER-AMT-TODAY
030600                      (X-MBD200WS-DA-TIER)
030700                                 TO MBD200WS-DA-TIER-AMT-SUBJECT
030800                                    (X-MBD200WS-DA-TIER)
030900                 COMPUTE MBD200WS-DA-WORK-AMT-7
031000                                 =  MBD200WS-DA-WORK-AMT-7
031100                                 -  MBD200WS-DA-TIER-AMT-TODAY
031200                                    (X-MBD200WS-DA-TIER)
031300                 END-COMPUTE
031400         END-EVALUATE
031500     END-IF.
031600*
031700 C299-LTWSTD-EXIT.
031800     EXIT.
031900/
032000 C500-APPLY-CUMULATIVE SECTION.
032100 C501-AC-BEGIN.
032200*
032300     MOVE MBD200WS-DA-AMT-PREV-TODAY
032400                                 TO WS-D200-ROLLING-SEARCH-AMT.
032500*
032600     IF  MMRTWS-DTD-AVG-TKT-CUM
032700         MOVE WS-D200-SRA-AVG-TKT (17)
032800                                 TO WS-D200-ROLLING-SEARCH-AMT.
032900*
033000*
033100*
033200     IF  MMRTWS-ROLLING-1-MON-AVG-TKT
033300         MOVE WS-D200-SRA-AVG-TKT (1)
033400                                 TO WS-D200-ROLLING-SEARCH-AMT.
033500*
033600*
033700*
033800     IF  MMRTWS-ROLLING-3-MON-AVG-TKT
033900         COMPUTE WS-D200-ROLLING-DENOMINATOR
034000                                 =  WS-D200-SRA-SALES-NBR (1)
034100                                 +  WS-D200-SRA-SALES-NBR (2)
034200                                 +  WS-D200-SRA-SALES-NBR (3)
034300         END-COMPUTE
034400         EVALUATE TRUE
034500             WHEN WS-D200-ROLLING-DENOMINATOR IS EQUAL TO ZERO
034600                 MOVE ZERO       TO WS-D200-ROLLING-SEARCH-AMT
034700             WHEN OTHER
034800                 COMPUTE WS-D200-ROLLING-SEARCH-AMT ROUNDED
034900                                 = (WS-D200-SRA-SALES-AMT (1)
035000                                 +  WS-D200-SRA-SALES-AMT (2)
035100                                 +  WS-D200-SRA-SALES-AMT (3))
035200                                 /  WS-D200-ROLLING-DENOMINATOR
035300                 END-COMPUTE
035400         END-EVALUATE
035500     END-IF.
035600*
035700*
035800*
035900     IF  MMRTWS-ROLLING-6-MON-AVG-TKT
036000         COMPUTE WS-D200-ROLLING-DENOMINATOR
036100                                 =  WS-D200-SRA-SALES-NBR (1)
036200                                 +  WS-D200-SRA-SALES-NBR (2)
036300                                 +  WS-D200-SRA-SALES-NBR (3)
036400                                 +  WS-D200-SRA-SALES-NBR (4)
036500                                 +  WS-D200-SRA-SALES-NBR (5)
036600                                 +  WS-D200-SRA-SALES-NBR (6)
036700         END-COMPUTE
036800         EVALUATE TRUE
036900             WHEN WS-D200-ROLLING-DENOMINATOR IS EQUAL TO ZERO
037000                 MOVE ZERO       TO WS-D200-ROLLING-SEARCH-AMT
037100             WHEN OTHER
037200                 COMPUTE WS-D200-ROLLING-SEARCH-AMT ROUNDED
037300                                 = (WS-D200-SRA-SALES-AMT (1)
037400                                 +  WS-D200-SRA-SALES-AMT (2)
037500                                 +  WS-D200-SRA-SALES-AMT (3)
037600                                 +  WS-D200-SRA-SALES-AMT (4)
037700                                 +  WS-D200-SRA-SALES-AMT (5)
037800                                 +  WS-D200-SRA-SALES-AMT (6))
037900                                 /  WS-D200-ROLLING-DENOMINATOR
038000                 END-COMPUTE
038100         END-EVALUATE
038200     END-IF.
038300*
038400*
038500*
038600     IF  MMRTWS-ROLLING-12-MON-AVG-TKT
038700         COMPUTE WS-D200-ROLLING-DENOMINATOR
038800                                 =  WS-D200-SRA-SALES-NBR (1)
038900                                 +  WS-D200-SRA-SALES-NBR (2)
039000                                 +  WS-D200-SRA-SALES-NBR (3)
039100                                 +  WS-D200-SRA-SALES-NBR (4)
039200                                 +  WS-D200-SRA-SALES-NBR (5)
039300                                 +  WS-D200-SRA-SALES-NBR (6)
039400                                 +  WS-D200-SRA-SALES-NBR (7)
039500                                 +  WS-D200-SRA-SALES-NBR (8)
039600                                 +  WS-D200-SRA-SALES-NBR (9)
039700                                 +  WS-D200-SRA-SALES-NBR (10)
039800                                 +  WS-D200-SRA-SALES-NBR (11)
039900                                 +  WS-D200-SRA-SALES-NBR (12)
040000         END-COMPUTE
040100         EVALUATE TRUE
040200             WHEN WS-D200-ROLLING-DENOMINATOR IS EQUAL TO ZERO
040300                 MOVE ZERO       TO WS-D200-ROLLING-SEARCH-AMT
040400             WHEN OTHER
040500                 COMPUTE WS-D200-ROLLING-SEARCH-AMT ROUNDED
040600                                 = (WS-D200-SRA-SALES-AMT (1)
040700                                 +  WS-D200-SRA-SALES-AMT (2)
040800                                 +  WS-D200-SRA-SALES-AMT (3)
040900                                 +  WS-D200-SRA-SALES-AMT (4)
041000                                 +  WS-D200-SRA-SALES-AMT (5)
041100                                 +  WS-D200-SRA-SALES-AMT (6)
041200                                 +  WS-D200-SRA-SALES-AMT (7)
041300                                 +  WS-D200-SRA-SALES-AMT (8)
041400                                 +  WS-D200-SRA-SALES-AMT (9)
041500                                 +  WS-D200-SRA-SALES-AMT (10)
041600                                 +  WS-D200-SRA-SALES-AMT (11)
041700                                 +  WS-D200-SRA-SALES-AMT (12))
041800                                 /  WS-D200-ROLLING-DENOMINATOR
041900                 END-COMPUTE
042000         END-EVALUATE
042100     END-IF.
042200*
042300*
042400*
042500     IF  MMRTWS-ROLLING-1-MON-VOL
042600         EVALUATE TRUE
042700             WHEN MMMM-DL-PRODUCT
042800                 EVALUATE TRUE
042900                     WHEN MMMP-PDFB-GROSS-SALES
043000                         COMPUTE WS-D200-ROLLING-SEARCH-AMT
043100                                 =   0
043200                                 +   WS-D200-SRA-SALES-AMT (1)
043300                         END-COMPUTE
043400                     WHEN MMMP-PDFB-GROSS-VOLUME
043500                         COMPUTE WS-D200-ROLLING-SEARCH-AMT
043600                                 =   WS-D200-SRA-SALES-AMT (1)
043700                                 +   WS-D200-SRA-RETURNS-AMT (1)
043800                         END-COMPUTE
043900                     WHEN OTHER
044000                         COMPUTE WS-D200-ROLLING-SEARCH-AMT
044100                                 =   WS-D200-SRA-SALES-AMT (1)
044200                                 -   WS-D200-SRA-RETURNS-AMT (1)
044300                         END-COMPUTE
044400                 END-EVALUATE
044500             WHEN OTHER
044600                 EVALUATE TRUE
044700                     WHEN MMMM-DFB-GROSS-SALES
044800                         COMPUTE WS-D200-ROLLING-SEARCH-AMT
044900                                 =   0
045000                                 +   WS-D200-SRA-SALES-AMT (1)
045100                         END-COMPUTE
045200                     WHEN MMMM-DFB-GROSS-VOLUME
045300                         COMPUTE WS-D200-ROLLING-SEARCH-AMT
045400                                 =   WS-D200-SRA-SALES-AMT (1)
045500                                 +   WS-D200-SRA-RETURNS-AMT (1)
045600                         END-COMPUTE
045700                     WHEN OTHER
045800                         COMPUTE WS-D200-ROLLING-SEARCH-AMT
045900                                 =   WS-D200-SRA-SALES-AMT (1)
046000                                 -   WS-D200-SRA-RETURNS-AMT (1)
046100                         END-COMPUTE
046200                 END-EVALUATE
046300         END-EVALUATE
046400     END-IF.
046500*
046600*
046700*
046800     IF  MMRTWS-ROLLING-3-MON-VOL
046900         MOVE 3                  TO WS-D200-ROLLING-DENOMINATOR
047000         EVALUATE TRUE
047100             WHEN MMMM-DL-PRODUCT
047200                 EVALUATE TRUE
047300                     WHEN MMMP-PDFB-GROSS-SALES
047400                         COMPUTE WS-D200-ROLLING-SEARCH-AMT
047500                                 =   WS-D200-SRA-SALES-AMT (1)
047600                                 +   WS-D200-SRA-SALES-AMT (2)
047700                                 +   WS-D200-SRA-SALES-AMT (3)
047800                         END-COMPUTE
047900                     WHEN MMMP-PDFB-GROSS-VOLUME
048000                         COMPUTE WS-D200-ROLLING-SEARCH-AMT
048100                                 =   WS-D200-SRA-SALES-AMT (1)
048200                                 +   WS-D200-SRA-SALES-AMT (2)
048300                                 +   WS-D200-SRA-SALES-AMT (3)
048400                                 +   WS-D200-SRA-RETURNS-AMT (1)
048500                                 +   WS-D200-SRA-RETURNS-AMT (2)
048600                                 +   WS-D200-SRA-RETURNS-AMT (3)
048700                         END-COMPUTE
048800                     WHEN OTHER
048900                         COMPUTE WS-D200-ROLLING-SEARCH-AMT
049000                                 =   WS-D200-SRA-SALES-AMT (1)
049100                                 +   WS-D200-SRA-SALES-AMT (2)
049200                                 +   WS-D200-SRA-SALES-AMT (3)
049300                                 -   WS-D200-SRA-RETURNS-AMT (1)
049400                                 -   WS-D200-SRA-RETURNS-AMT (2)
049500                                 -   WS-D200-SRA-RETURNS-AMT (3)
049600                         END-COMPUTE
049700                 END-EVALUATE
049800             WHEN OTHER
049900                 EVALUATE TRUE
050000                     WHEN MMMM-DFB-GROSS-SALES
050100                         COMPUTE WS-D200-ROLLING-SEARCH-AMT
050200                                 =   WS-D200-SRA-SALES-AMT (1)
050300                                 +   WS-D200-SRA-SALES-AMT (2)
050400                                 +   WS-D200-SRA-SALES-AMT (3)
050500                         END-COMPUTE
050600                     WHEN MMMM-DFB-GROSS-VOLUME
050700                         COMPUTE WS-D200-ROLLING-SEARCH-AMT
050800                                 =   WS-D200-SRA-SALES-AMT (1)
050900                                 +   WS-D200-SRA-SALES-AMT (2)
051000                                 +   WS-D200-SRA-SALES-AMT (3)
051100                                 +   WS-D200-SRA-RETURNS-AMT (1)
051200                                 +   WS-D200-SRA-RETURNS-AMT (2)
051300                                 +   WS-D200-SRA-RETURNS-AMT (3)
051400                         END-COMPUTE
051500                     WHEN OTHER
051600                         COMPUTE WS-D200-ROLLING-SEARCH-AMT
051700                                 =   WS-D200-SRA-SALES-AMT (1)
051800                                 +   WS-D200-SRA-SALES-AMT (2)
051900                                 +   WS-D200-SRA-SALES-AMT (3)
052000                                 -   WS-D200-SRA-RETURNS-AMT (1)
052100                                 -   WS-D200-SRA-RETURNS-AMT (2)
052200                                 -   WS-D200-SRA-RETURNS-AMT (3)
052300                         END-COMPUTE
052400                 END-EVALUATE
052500         END-EVALUATE
052600         COMPUTE WS-D200-ROLLING-SEARCH-AMT ROUNDED
052700                                 =  WS-D200-ROLLING-SEARCH-AMT
052800                                 /  WS-D200-ROLLING-DENOMINATOR
052900         END-COMPUTE
053000     END-IF.
053100*
053200*
053300*
053400     IF  MMRTWS-ROLLING-6-MON-VOL
053500         MOVE 6                  TO WS-D200-ROLLING-DENOMINATOR
053600         EVALUATE TRUE
053700             WHEN MMMM-DL-PRODUCT
053800                 EVALUATE TRUE
053900                     WHEN MMMP-PDFB-GROSS-SALES
054000                         COMPUTE WS-D200-ROLLING-SEARCH-AMT
054100                                 =   WS-D200-SRA-SALES-AMT (1)
054200                                 +   WS-D200-SRA-SALES-AMT (2)
054300                                 +   WS-D200-SRA-SALES-AMT (3)
054400                                 +   WS-D200-SRA-SALES-AMT (4)
054500                                 +   WS-D200-SRA-SALES-AMT (5)
054600                                 +   WS-D200-SRA-SALES-AMT (6)
054700                         END-COMPUTE
054800                     WHEN MMMP-PDFB-GROSS-VOLUME
054900                         COMPUTE WS-D200-ROLLING-SEARCH-AMT
055000                                 =   WS-D200-SRA-SALES-AMT (1)
055100                                 +   WS-D200-SRA-SALES-AMT (2)
055200                                 +   WS-D200-SRA-SALES-AMT (3)
055300                                 +   WS-D200-SRA-SALES-AMT (4)
055400                                 +   WS-D200-SRA-SALES-AMT (5)
055500                                 +   WS-D200-SRA-SALES-AMT (6)
055600                                 +   WS-D200-SRA-RETURNS-AMT (1)
055700                                 +   WS-D200-SRA-RETURNS-AMT (2)
055800                                 +   WS-D200-SRA-RETURNS-AMT (3)
055900                                 +   WS-D200-SRA-RETURNS-AMT (4)
056000                                 +   WS-D200-SRA-RETURNS-AMT (5)
056100                                 +   WS-D200-SRA-RETURNS-AMT (6)
056200                         END-COMPUTE
056300                     WHEN OTHER
056400                         COMPUTE WS-D200-ROLLING-SEARCH-AMT
056500                                 =   WS-D200-SRA-SALES-AMT (1)
056600                                 +   WS-D200-SRA-SALES-AMT (2)
056700                                 +   WS-D200-SRA-SALES-AMT (3)
056800                                 +   WS-D200-SRA-SALES-AMT (4)
056900                                 +   WS-D200-SRA-SALES-AMT (5)
057000                                 +   WS-D200-SRA-SALES-AMT (6)
057100                                 -   WS-D200-SRA-RETURNS-AMT (1)
057200                                 -   WS-D200-SRA-RETURNS-AMT (2)
057300                                 -   WS-D200-SRA-RETURNS-AMT (3)
057400                                 -   WS-D200-SRA-RETURNS-AMT (4)
057500                                 -   WS-D200-SRA-RETURNS-AMT (5)
057600                                 -   WS-D200-SRA-RETURNS-AMT (6)
057700                         END-COMPUTE
057800                 END-EVALUATE
057900             WHEN OTHER
058000                 EVALUATE TRUE
058100                     WHEN MMMM-DFB-GROSS-SALES
058200                         COMPUTE WS-D200-ROLLING-SEARCH-AMT
058300                                 =   WS-D200-SRA-SALES-AMT (1)
058400                                 +   WS-D200-SRA-SALES-AMT (2)
058500                                 +   WS-D200-SRA-SALES-AMT (3)
058600                                 +   WS-D200-SRA-SALES-AMT (4)
058700                                 +   WS-D200-SRA-SALES-AMT (5)
058800                                 +   WS-D200-SRA-SALES-AMT (6)
058900                         END-COMPUTE
059000                     WHEN MMMM-DFB-GROSS-VOLUME
059100                         COMPUTE WS-D200-ROLLING-SEARCH-AMT
059200                                 =   WS-D200-SRA-SALES-AMT (1)
059300                                 +   WS-D200-SRA-SALES-AMT (2)
059400                                 +   WS-D200-SRA-SALES-AMT (3)
059500                                 +   WS-D200-SRA-SALES-AMT (4)
059600                                 +   WS-D200-SRA-SALES-AMT (5)
059700                                 +   WS-D200-SRA-SALES-AMT (6)
059800                                 +   WS-D200-SRA-RETURNS-AMT (1)
059900                                 +   WS-D200-SRA-RETURNS-AMT (2)
060000                                 +   WS-D200-SRA-RETURNS-AMT (3)
060100                                 +   WS-D200-SRA-RETURNS-AMT (4)
060200                                 +   WS-D200-SRA-RETURNS-AMT (5)
060300                                 +   WS-D200-SRA-RETURNS-AMT (6)
060400                         END-COMPUTE
060500                     WHEN OTHER
060600                         COMPUTE WS-D200-ROLLING-SEARCH-AMT
060700                                 =   WS-D200-SRA-SALES-AMT (1)
060800                                 +   WS-D200-SRA-SALES-AMT (2)
060900                                 +   WS-D200-SRA-SALES-AMT (3)
061000                                 +   WS-D200-SRA-SALES-AMT (4)
061100                                 +   WS-D200-SRA-SALES-AMT (5)
061200                                 +   WS-D200-SRA-SALES-AMT (6)
061300                                 -   WS-D200-SRA-RETURNS-AMT (1)
061400                                 -   WS-D200-SRA-RETURNS-AMT (2)
061500                                 -   WS-D200-SRA-RETURNS-AMT (3)
061600                                 -   WS-D200-SRA-RETURNS-AMT (4)
061700                                 -   WS-D200-SRA-RETURNS-AMT (5)
061800                                 -   WS-D200-SRA-RETURNS-AMT (6)
061900                         END-COMPUTE
062000                 END-EVALUATE
062100         END-EVALUATE
062200         COMPUTE WS-D200-ROLLING-SEARCH-AMT ROUNDED
062300                                 =  WS-D200-ROLLING-SEARCH-AMT
062400                                 /  WS-D200-ROLLING-DENOMINATOR
062500         END-COMPUTE
062600     END-IF.
062700*
062800*
062900*
063000     IF  MMRTWS-ROLLING-12-MON-VOL
063100         MOVE 12                 TO WS-D200-ROLLING-DENOMINATOR
063200         EVALUATE TRUE
063300             WHEN MMMM-DL-PRODUCT
063400                 EVALUATE TRUE
063500                     WHEN MMMP-PDFB-GROSS-SALES
063600                         COMPUTE WS-D200-ROLLING-SEARCH-AMT
063700                                 =   WS-D200-SRA-SALES-AMT (1)
063800                                 +   WS-D200-SRA-SALES-AMT (2)
063900                                 +   WS-D200-SRA-SALES-AMT (3)
064000                                 +   WS-D200-SRA-SALES-AMT (4)
064100                                 +   WS-D200-SRA-SALES-AMT (5)
064200                                 +   WS-D200-SRA-SALES-AMT (6)
064300                                 +   WS-D200-SRA-SALES-AMT (7)
064400                                 +   WS-D200-SRA-SALES-AMT (8)
064500                                 +   WS-D200-SRA-SALES-AMT (9)
064600                                 +   WS-D200-SRA-SALES-AMT (10)
064700                                 +   WS-D200-SRA-SALES-AMT (11)
064800                                 +   WS-D200-SRA-SALES-AMT (12)
064900                         END-COMPUTE
065000                     WHEN MMMP-PDFB-GROSS-VOLUME
065100                         COMPUTE WS-D200-ROLLING-SEARCH-AMT
065200                                 =   WS-D200-SRA-SALES-AMT (1)
065300                                 +   WS-D200-SRA-SALES-AMT (2)
065400                                 +   WS-D200-SRA-SALES-AMT (3)
065500                                 +   WS-D200-SRA-SALES-AMT (4)
065600                                 +   WS-D200-SRA-SALES-AMT (5)
065700                                 +   WS-D200-SRA-SALES-AMT (6)
065800                                 +   WS-D200-SRA-SALES-AMT (7)
065900                                 +   WS-D200-SRA-SALES-AMT (8)
066000                                 +   WS-D200-SRA-SALES-AMT (9)
066100                                 +   WS-D200-SRA-SALES-AMT (10)
066200                                 +   WS-D200-SRA-SALES-AMT (11)
066300                                 +   WS-D200-SRA-SALES-AMT (12)
066400                                 +   WS-D200-SRA-RETURNS-AMT (1)
066500                                 +   WS-D200-SRA-RETURNS-AMT (2)
066600                                 +   WS-D200-SRA-RETURNS-AMT (3)
066700                                 +   WS-D200-SRA-RETURNS-AMT (4)
066800                                 +   WS-D200-SRA-RETURNS-AMT (5)
066900                                 +   WS-D200-SRA-RETURNS-AMT (6)
067000                                 +   WS-D200-SRA-RETURNS-AMT (7)
067100                                 +   WS-D200-SRA-RETURNS-AMT (8)
067200                                 +   WS-D200-SRA-RETURNS-AMT (9)
067300                                 +   WS-D200-SRA-RETURNS-AMT (10)
067400                                 +   WS-D200-SRA-RETURNS-AMT (11)
067500                                 +   WS-D200-SRA-RETURNS-AMT (12)
067600                         END-COMPUTE
067700                     WHEN OTHER
067800                         COMPUTE WS-D200-ROLLING-SEARCH-AMT
067900                                 =   WS-D200-SRA-SALES-AMT (1)
068000                                 +   WS-D200-SRA-SALES-AMT (2)
068100                                 +   WS-D200-SRA-SALES-AMT (3)
068200                                 +   WS-D200-SRA-SALES-AMT (4)
068300                                 +   WS-D200-SRA-SALES-AMT (5)
068400                                 +   WS-D200-SRA-SALES-AMT (6)
068500                                 +   WS-D200-SRA-SALES-AMT (7)
068600                                 +   WS-D200-SRA-SALES-AMT (8)
068700                                 +   WS-D200-SRA-SALES-AMT (9)
068800                                 +   WS-D200-SRA-SALES-AMT (10)
068900                                 +   WS-D200-SRA-SALES-AMT (11)
069000                                 +   WS-D200-SRA-SALES-AMT (12)
069100                                 -   WS-D200-SRA-RETURNS-AMT (1)
069200                                 -   WS-D200-SRA-RETURNS-AMT (2)
069300                                 -   WS-D200-SRA-RETURNS-AMT (3)
069400                                 -   WS-D200-SRA-RETURNS-AMT (4)
069500                                 -   WS-D200-SRA-RETURNS-AMT (5)
069600                                 -   WS-D200-SRA-RETURNS-AMT (6)
069700                                 -   WS-D200-SRA-RETURNS-AMT (7)
069800                                 -   WS-D200-SRA-RETURNS-AMT (8)
069900                                 -   WS-D200-SRA-RETURNS-AMT (9)
070000                                 -   WS-D200-SRA-RETURNS-AMT (10)
070100                                 -   WS-D200-SRA-RETURNS-AMT (11)
070200                                 -   WS-D200-SRA-RETURNS-AMT (12)
070300                         END-COMPUTE
070400                 END-EVALUATE
070500             WHEN OTHER
070600                 EVALUATE TRUE
070700                     WHEN MMMM-DFB-GROSS-SALES
070800                         COMPUTE WS-D200-ROLLING-SEARCH-AMT
070900                                 =   WS-D200-SRA-SALES-AMT (1)
071000                                 +   WS-D200-SRA-SALES-AMT (2)
071100                                 +   WS-D200-SRA-SALES-AMT (3)
071200                                 +   WS-D200-SRA-SALES-AMT (4)
071300                                 +   WS-D200-SRA-SALES-AMT (5)
071400                                 +   WS-D200-SRA-SALES-AMT (6)
071500                                 +   WS-D200-SRA-SALES-AMT (7)
071600                                 +   WS-D200-SRA-SALES-AMT (8)
071700                                 +   WS-D200-SRA-SALES-AMT (9)
071800                                 +   WS-D200-SRA-SALES-AMT (10)
071900                                 +   WS-D200-SRA-SALES-AMT (11)
072000                                 +   WS-D200-SRA-SALES-AMT (12)
072100                         END-COMPUTE
072200                     WHEN MMMM-DFB-GROSS-VOLUME
072300                         COMPUTE WS-D200-ROLLING-SEARCH-AMT
072400                                 =   WS-D200-SRA-SALES-AMT (1)
072500                                 +   WS-D200-SRA-SALES-AMT (2)
072600                                 +   WS-D200-SRA-SALES-AMT (3)
072700                                 +   WS-D200-SRA-SALES-AMT (4)
072800                                 +   WS-D200-SRA-SALES-AMT (5)
072900                                 +   WS-D200-SRA-SALES-AMT (6)
073000                                 +   WS-D200-SRA-SALES-AMT (7)
073100                                 +   WS-D200-SRA-SALES-AMT (8)
073200                                 +   WS-D200-SRA-SALES-AMT (9)
073300                                 +   WS-D200-SRA-SALES-AMT (10)
073400                                 +   WS-D200-SRA-SALES-AMT (11)
073500                                 +   WS-D200-SRA-SALES-AMT (12)
073600                                 +   WS-D200-SRA-RETURNS-AMT (1)
073700                                 +   WS-D200-SRA-RETURNS-AMT (2)
073800                                 +   WS-D200-SRA-RETURNS-AMT (3)
073900                                 +   WS-D200-SRA-RETURNS-AMT (4)
074000                                 +   WS-D200-SRA-RETURNS-AMT (5)
074100                                 +   WS-D200-SRA-RETURNS-AMT (6)
074200                                 +   WS-D200-SRA-RETURNS-AMT (7)
074300                                 +   WS-D200-SRA-RETURNS-AMT (8)
074400                                 +   WS-D200-SRA-RETURNS-AMT (9)
074500                                 +   WS-D200-SRA-RETURNS-AMT (10)
074600                                 +   WS-D200-SRA-RETURNS-AMT (11)
074700                                 +   WS-D200-SRA-RETURNS-AMT (12)
074800                         END-COMPUTE
074900                     WHEN OTHER
075000                         COMPUTE WS-D200-ROLLING-SEARCH-AMT
075100                                 =   WS-D200-SRA-SALES-AMT (1)
075200                                 +   WS-D200-SRA-SALES-AMT (2)
075300                                 +   WS-D200-SRA-SALES-AMT (3)
075400                                 +   WS-D200-SRA-SALES-AMT (4)
075500                                 +   WS-D200-SRA-SALES-AMT (5)
075600                                 +   WS-D200-SRA-SALES-AMT (6)
075700                                 +   WS-D200-SRA-SALES-AMT (7)
075800                                 +   WS-D200-SRA-SALES-AMT (8)
075900                                 +   WS-D200-SRA-SALES-AMT (9)
076000                                 +   WS-D200-SRA-SALES-AMT (10)
076100                                 +   WS-D200-SRA-SALES-AMT (11)
076200                                 +   WS-D200-SRA-SALES-AMT (12)
076300                                 -   WS-D200-SRA-RETURNS-AMT (1)
076400                                 -   WS-D200-SRA-RETURNS-AMT (2)
076500                                 -   WS-D200-SRA-RETURNS-AMT (3)
076600                                 -   WS-D200-SRA-RETURNS-AMT (4)
076700                                 -   WS-D200-SRA-RETURNS-AMT (5)
076800                                 -   WS-D200-SRA-RETURNS-AMT (6)
076900                                 -   WS-D200-SRA-RETURNS-AMT (7)
077000                                 -   WS-D200-SRA-RETURNS-AMT (8)
077100                                 -   WS-D200-SRA-RETURNS-AMT (9)
077200                                 -   WS-D200-SRA-RETURNS-AMT (10)
077300                                 -   WS-D200-SRA-RETURNS-AMT (11)
077400                                 -   WS-D200-SRA-RETURNS-AMT (12)
077500                         END-COMPUTE
077600                 END-EVALUATE
077700         END-EVALUATE
077800         COMPUTE WS-D200-ROLLING-SEARCH-AMT ROUNDED
077900                                 =  WS-D200-ROLLING-SEARCH-AMT
078000                                 /  WS-D200-ROLLING-DENOMINATOR
078100         END-COMPUTE
078200     END-IF.
078300*
078400*
078500*
078600     EVALUATE TRUE
078700         WHEN (MMRTWS-CTD-NUMBER-INC
078800           OR  MMRTWS-CTD-VOLUME-INC)
078900             MOVE WS-D200-SRA-AVG-TKT (16)
079000                                 TO MBD200WS-DA-AVG-TKT-AMT
079100         WHEN (MMRTWS-MTD-NUMBER-INC
079200           OR  MMRTWS-MTD-VOLUME-INC
079300           OR  MMRTWS-MTD-TIERED-INCOME)
079400             MOVE WS-D200-SRA-AVG-TKT (14)
079500                                 TO MBD200WS-DA-AVG-TKT-AMT
079600         WHEN (MMRTWS-ROLLING-1-MON-AVG-TKT
079700           OR  MMRTWS-ROLLING-3-MON-AVG-TKT
079800           OR  MMRTWS-ROLLING-6-MON-AVG-TKT
079900           OR  MMRTWS-ROLLING-12-MON-AVG-TKT)
080000             MOVE WS-D200-ROLLING-SEARCH-AMT
080100                                 TO MBD200WS-DA-AVG-TKT-AMT
080200         WHEN OTHER
080300             MOVE WS-D200-SRA-AVG-TKT (17)
080400                                 TO MBD200WS-DA-AVG-TKT-AMT
080500     END-EVALUATE.
080600*
080700*
080800*
080900     IF  MMRTWS-VALID-METH-ON-NUMBER
081000         SET X-MMRT-PRIM         TO 1
081100         SEARCH MMRT-PRIMARY-RATES-TABLE VARYING X-MMRT-PRIM
081200             AT END
081300                 SET X-MMRT-PRIM TO 1
081400             WHEN MBD200WS-DA-NBR-PREV-TODAY IS NOT GREATER THAN
081500                                 MMRT-PRIM-LIMIT-NBR (X-MMRT-PRIM)
081600                 SET X-MBD200WS-DA-TIER
081700                                 TO X-MMRT-PRIM
081800                 MOVE MBD200WS-DA-NBR-SUBJECT-TIERS
081900                                 TO MBD200WS-DA-TIER-NBR-SUBJECT
082000                                    (X-MBD200WS-DA-TIER)
082100         END-SEARCH
082200     ELSE
082300         SET X-MMRT-PRIM         TO 1
082400         SEARCH MMRT-PRIMARY-RATES-TABLE VARYING X-MMRT-PRIM
082500             AT END
082600                 SET X-MMRT-PRIM TO 1
082700             WHEN WS-D200-ROLLING-SEARCH-AMT IS NOT GREATER THAN
082800                                 MMRT-PRIM-LIMIT (X-MMRT-PRIM)
082900                 SET X-MBD200WS-DA-TIER
083000                                 TO X-MMRT-PRIM
083100                 MOVE MBD200WS-DA-AMT-SUBJECT-TIERS
083200                                 TO MBD200WS-DA-TIER-AMT-SUBJECT
083300                                    (X-MBD200WS-DA-TIER)
083400         END-SEARCH
083500     END-IF.
083600*
083700     PERFORM C800-COMPUTE-DISC-IN-TIER
083800        THRU C899-CDIT-EXIT
083900        VARYING X-MBD200WS-DA-TIER FROM 1 BY 1
084000          UNTIL X-MBD200WS-DA-TIER IS GREATER THAN 10.
084100*
084200 C599-AC-EXIT.
084300     EXIT.
084400/
084500 C800-COMPUTE-DISC-IN-TIER SECTION.
084600 C810-CDIT-BEGIN.
084700*
084800     SET X-MMRT-PRIM             TO X-MBD200WS-DA-TIER.
084900*
085000     EVALUATE TRUE
085100         WHEN MMRTWS-VALID-METH-ON-NUMBER
085200             MOVE MMOC-PER-ITEM-NOD
085300                                 TO SS50WS-MULTIPLIER-NOD
085400             MOVE ZERO           TO SS50WS-MULTIPLICAND-NOD
085500             MOVE MBD200WS-DA-TIER-NBR-SUBJECT
085600              (X-MBD200WS-DA-TIER)
085700                                 TO SS50WS-MULTIPLICAND
085800             MOVE MMRT-PRIM-PER-ITEM (X-MMRT-PRIM)
085900                                 TO SS50WS-MULTIPLIER-PER-ITEM
086000             PERFORM SS50PD-MULTIPLY
086100                                 THRU SS50PD-M-EXIT
086200             MOVE SS50WS-PRODUCT
086300                                 TO MBD200WS-DA-TIER-TOTAL-DISC
086400                                    (X-MBD200WS-DA-TIER)
086500*****
086600*****        COMPUTE MBD200WS-DA-TIER-TOTAL-DISC
086700*****                (X-MBD200WS-DA-TIER)
086800*****                    ROUNDED =  MBD200WS-DA-TIER-NBR-SUBJECT
086900*****                               (X-MBD200WS-DA-TIER)
087000*****                            *  MMRT-PRIM-PER-ITEM
087100*****                               (X-MMRT-PRIM)
087200*****        END-COMPUTE
087300         WHEN OTHER
087400             MOVE MMOC-PERCENT-NOD
087500                                 TO SS50WS-MULTIPLIER-NOD
087600             SET SS50WS-MULTIPLICAND-BY-CC
087700                                 TO TRUE
087800             MOVE MBD200WS-DA-TIER-AMT-SUBJECT
087900                  (X-MBD200WS-DA-TIER)
088000                                 TO SS50WS-MULTIPLICAND
088100             MOVE MMRT-PRIM-RATE (X-MMRT-PRIM)
088200                                 TO SS50WS-MULTIPLIER-PERCENT
088300             PERFORM SS50PD-MULTIPLY
088400                                 THRU SS50PD-M-EXIT
088500             MOVE SS50WS-PRODUCT TO MBD200WS-DA-TIER-TOTAL-DISC
088600                                    (X-MBD200WS-DA-TIER)
088700*
088800***          COMPUTE MBD200WS-DA-TIER-TOTAL-DISC
088900***                  (X-MBD200WS-DA-TIER)
089000***                      ROUNDED =  MBD200WS-DA-TIER-AMT-SUBJECT
089100***                                 (X-MBD200WS-DA-TIER)
089200***                              *  MMRT-PRIM-RATE
089300***                                 (X-MMRT-PRIM)
089400***          END-COMPUTE
089500     END-EVALUATE.
089600*
089700 C899-CDIT-EXIT.
089800     EXIT.
089900/
090000 C900-FINAL-DISCOUNT-TOTAL SECTION.
090100 C901-FDT-BEGIN.
090200*
090300     COMPUTE MBD200WS-DA-DISC-TIER
090400                                 = MBD200WS-DA-TIER-TOTAL-DISC (1)
090500                                 + MBD200WS-DA-TIER-TOTAL-DISC (2)
090600                                 + MBD200WS-DA-TIER-TOTAL-DISC (3)
090700                                 + MBD200WS-DA-TIER-TOTAL-DISC (4)
090800                                 + MBD200WS-DA-TIER-TOTAL-DISC (5)
090900                                 + MBD200WS-DA-TIER-TOTAL-DISC (6)
091000                                 + MBD200WS-DA-TIER-TOTAL-DISC (7)
091100                                 + MBD200WS-DA-TIER-TOTAL-DISC (8)
091200                                 + MBD200WS-DA-TIER-TOTAL-DISC (9)
091300                                 + MBD200WS-DA-TIER-TOTAL-DISC
091400                                                             (10).
091500*
091600     COMPUTE MBD200WS-DA-DISC-TOTAL
091700                                 =  MBD200WS-DA-DISC-TIER
091800                                 +  MBD200WS-DA-DISC-AVG-TKT
091900                                 +  MBD200WS-DA-DISC-PLAN-ADJ
092000                                 +  MBD200WS-DA-DISC-PLAN-OVRD
092100                                 +  MBD200WS-DA-DISC-TRANS-ADJ
092200                                 +  MBD200WS-DA-DISC-TRANS-OVRD
092300                                 +  MBD200WS-DA-DISC-MANUAL.
092400*
092500 C999-FDT-EXIT.
092600     EXIT.
092700/
092800 D000-LOAD-DISCOUNT-W-TODAY SECTION.
092900 D001-LDWT-BEGIN.
093000*
093100     SET X-MBD200WS-DA-TIER      TO X-MMRT-PRIM.
093200*
093300     EVALUATE TRUE
093400         WHEN MMRTWS-VALID-METH-ON-NUMBER
093500             PERFORM D100-LOAD-TIER-TODAY-NUMBERS
093600                THRU D199-LTTN-EXIT
093700         WHEN OTHER
093800             PERFORM D500-LOAD-TIER-TODAY-AMOUNTS
093900                THRU D599-LTTA-EXIT
094000     END-EVALUATE.
094100*
094200 D099-LDWT-EXIT.
094300     EXIT.
094400/
094500 D100-LOAD-TIER-TODAY-NUMBERS SECTION.
094600 D101-LTTN-BEGIN.
094700*
094800     IF  MBD200WS-DA-TIER-NBR-PREV (X-MBD200WS-DA-TIER)
094900                                 IS LESS THAN ZERO
095000         MOVE MBD200WS-DA-TIER-NBR-ALLOWED (X-MBD200WS-DA-TIER)
095100                                 TO MBD200WS-DA-WORK-NBR-4
095200     ELSE
095300         COMPUTE MBD200WS-DA-WORK-NBR-4
095400                                 =  MBD200WS-DA-TIER-NBR-ALLOWED
095500                                    (X-MBD200WS-DA-TIER)
095600                                 -  MBD200WS-DA-TIER-NBR-PREV
095700                                    (X-MBD200WS-DA-TIER).
095800*
095900     IF  MBD200WS-DA-WORK-NBR-1 IS NOT GREATER THAN
096000         MBD200WS-DA-WORK-NBR-4
096100         MOVE MBD200WS-DA-WORK-NBR-1
096200                                 TO MBD200WS-DA-TIER-NBR-TODAY
096300                                    (X-MBD200WS-DA-TIER)
096400         MOVE ZERO               TO MBD200WS-DA-WORK-NBR-1
096500     ELSE
096600         MOVE MBD200WS-DA-WORK-NBR-4
096700                                 TO MBD200WS-DA-TIER-NBR-TODAY
096800                                    (X-MBD200WS-DA-TIER)
096900         COMPUTE MBD200WS-DA-WORK-NBR-1
097000                                 =  MBD200WS-DA-WORK-NBR-1
097100                                 -  MBD200WS-DA-WORK-NBR-4.
097200*
097300     COMPUTE MBD200WS-DA-TIER-NBR-TOTAL (X-MBD200WS-DA-TIER)
097400                                 =  MBD200WS-DA-TIER-NBR-PREV
097500                                    (X-MBD200WS-DA-TIER)
097600                                 +  MBD200WS-DA-TIER-NBR-TODAY
097700                                    (X-MBD200WS-DA-TIER).
097800*
097900 D199-LTTN-EXIT.
098000     EXIT.
098100/
098200 D500-LOAD-TIER-TODAY-AMOUNTS SECTION.
098300 D501-LTTA-BEGIN.
098400*
098500     IF  MBD200WS-DA-TIER-AMT-PREV (X-MBD200WS-DA-TIER)
098600                                 IS LESS THAN ZERO
098700         MOVE MBD200WS-DA-TIER-AMT-ALLOWED (X-MBD200WS-DA-TIER)
098800                                 TO MBD200WS-DA-WORK-AMT-4
098900     ELSE
099000         COMPUTE MBD200WS-DA-WORK-AMT-4
099100                                 =  MBD200WS-DA-TIER-AMT-ALLOWED
099200                                    (X-MBD200WS-DA-TIER)
099300                                 -  MBD200WS-DA-TIER-AMT-PREV
099400                                    (X-MBD200WS-DA-TIER).
099500*
099600     IF  MBD200WS-DA-WORK-AMT-1 IS NOT GREATER THAN
099700         MBD200WS-DA-WORK-AMT-4
099800         MOVE MBD200WS-DA-WORK-AMT-1
099900                                 TO MBD200WS-DA-TIER-AMT-TODAY
100000                                    (X-MBD200WS-DA-TIER)
100100         MOVE ZERO               TO MBD200WS-DA-WORK-AMT-1
100200     ELSE
100300         MOVE MBD200WS-DA-WORK-AMT-4
100400                                 TO MBD200WS-DA-TIER-AMT-TODAY
100500                                    (X-MBD200WS-DA-TIER)
100600         COMPUTE MBD200WS-DA-WORK-AMT-1
100700                                 =  MBD200WS-DA-WORK-AMT-1
100800                                 -  MBD200WS-DA-WORK-AMT-4.
100900*
101000     COMPUTE MBD200WS-DA-TIER-AMT-TOTAL (X-MBD200WS-DA-TIER)
101100                                 =  MBD200WS-DA-TIER-AMT-PREV
101200                                    (X-MBD200WS-DA-TIER)
101300                                 +  MBD200WS-DA-TIER-AMT-TODAY
101400                                    (X-MBD200WS-DA-TIER).
101500*
101600 D599-LTTA-EXIT.
101700     EXIT.
101800/
101900 E000-PROCESS-TRANSACTION SECTION.
102000 E001-PT-BEGIN.
102100*
102200     SET MBD200WS-DA-OVERRIDE-NO TO TRUE.
102300     SET MBD200WS-DA-ADJUSTMENT-NO
102400                                 TO TRUE.
102500     MOVE ZERO                   TO MTPT-INDIV-DISC-AMT.
102600     SET MTPT-INDIV-DISCOUNT     TO TRUE.
102700     MOVE ZERO                   TO MBD200WS-DA-ADJ-DISC-AMT.
102800     SET MBD200WS-DA-ADF-DISCOUNT
102900                                 TO TRUE.
103000     MOVE ZERO                   TO MBD200WS-DA-OVRD-DISC-AMT.
103100     SET MBD200WS-DA-ODF-DISCOUNT
103200                                 TO TRUE.
103300*
103400     MOVE MTPT-LOGIC-MODULE      TO MMTCWS-LOGIC-MODULE.
103500*
103600     EVALUATE TRUE
103700         WHEN MMTCWS-LM-DISCOUNT
103800             SET  MBD200WS-DA-ACTIVITY
103900                                 TO TRUE
104000             ADD  MTPT-AMOUNT    TO MBD200WS-DA-DISC-MANUAL
104100         WHEN MMTCWS-LM-REFUND
104200             SET  MBD200WS-DA-ACTIVITY
104300                                 TO TRUE
104400             SUBTRACT MTPT-AMOUNT
104500                                 FROM MBD200WS-DA-DISC-MANUAL
104600     END-EVALUATE.
104700*
104800     EVALUATE TRUE
104900         WHEN (MBD200WS-DA-DFB-GROSS-SALES
105000           AND MMTCWS-LM-RETURN)
105100             CONTINUE
105200         WHEN (MBD200WS-DA-DFB-GROSS-SALES
105300           AND MMTCWS-LM-RETURN-REV)
105400             CONTINUE
105500         WHEN MMTCWS-LM-DISCOUNT
105600             CONTINUE
105700         WHEN MMTCWS-LM-REFUND
105800             CONTINUE
105900         WHEN MMMM-DF1-DAILY-DISC
106000             PERFORM E100-TRANSACTION-LOGIC
106100                THRU E199-TL-EXIT
106200     END-EVALUATE.
106300*
106400     IF  MBD200WS-DA-ADJ-DISC-AMT IS LESS THAN ZERO
106500         SET MBD200WS-DA-ADF-REFUND
106600                                 TO TRUE
106700     ELSE
106800         SET MBD200WS-DA-ADF-DISCOUNT
106900                                 TO TRUE.
107000*
107100     IF  MBD200WS-DA-OVRD-DISC-AMT IS LESS THAN ZERO
107200         SET MBD200WS-DA-ODF-REFUND
107300                                 TO TRUE
107400     ELSE
107500         SET MBD200WS-DA-ODF-DISCOUNT
107600                                 TO TRUE.
107700*
107800 E099-PT-EXIT.
107900     EXIT.
108000/
108100 E100-TRANSACTION-LOGIC SECTION.
108200 E101-TL-BEGIN.
108300*
108400     IF  MMRT-EXCEPTION-TRAN-OVERRIDE (2)
108500     OR  MMRT-EXCEPTION-TRAN-OVERRIDE (3)
108600     OR  MMRT-EXCEPTION-TRAN-OVERRIDE (4)
108700     OR  MMRT-EXCEPTION-TRAN-OVERRIDE (5)
108800     OR  MMRT-EXCEPTION-TRAN-OVERRIDE (6)
108900     OR  MMRT-EXCEPTION-TRAN-OVERRIDE (7)
109000         PERFORM F000-TRAN-OVERRIDE-CHECK
109100            THRU F099-TOC-EXIT.
109200*
109300     IF  MMRT-EXCEPTION-IS-ADJUSTMENT (2)
109400     OR  MMRT-EXCEPTION-IS-ADJUSTMENT (3)
109500     OR  MMRT-EXCEPTION-IS-ADJUSTMENT (4)
109600     OR  MMRT-EXCEPTION-IS-ADJUSTMENT (5)
109700     OR  MMRT-EXCEPTION-IS-ADJUSTMENT (6)
109800     OR  MMRT-EXCEPTION-IS-ADJUSTMENT (7)
109900         PERFORM F500-ADJUSTMENT-CHECK
110000            THRU F599-AC-EXIT.
110100*
110200     IF  MMRTWS-INDIVIDUAL-TICKET
110300         EVALUATE TRUE
110400             WHEN MBD200WS-DA-OVERRIDE-YES
110500                 IF  MMTCWS-LM-SALE-REV
110600                 OR (MMTCWS-LM-RETURN
110700                 AND MBD200WS-DA-DFB-NET-SALES)
110800                 OR (MMTCWS-LM-RETURN-REV
110900                 AND MBD200WS-DA-DFB-GROSS-VOLUME)
111000                     SUBTRACT MTPT-AMOUNT
111100                               FROM MBD200WS-DA-AMT-PREV-TODAY
111200                     SUBTRACT MTPT-AMOUNT
111300                               FROM MBD200WS-DA-TIER-AMT-TODAY
111400                                    (X-MBD200WS-DA-TIER)
111500                 ELSE
111600                     ADD  MTPT-AMOUNT
111700                                 TO MBD200WS-DA-AMT-PREV-TODAY
111800                     ADD  MTPT-AMOUNT
111900                                 TO MBD200WS-DA-TIER-AMT-TODAY
112000                                    (X-MBD200WS-DA-TIER)
112100                 END-IF
112200             WHEN OTHER
112300                 PERFORM M000-INDIVIDUAL-TICKET
112400                    THRU M099-IT-EXIT
112500         END-EVALUATE.
112600*
112700 E199-TL-EXIT.
112800     EXIT.
112900/
113000 F000-TRAN-OVERRIDE-CHECK SECTION.
113100 F001-TOC-BEGIN.
113200*
113300     SET WS-D200-EF-OVERRIDE     TO TRUE.
113400*
113500     PERFORM
113600         VARYING WS-D200-EXCEPTION-PRIORITY-9 FROM 1 BY 1
113700         UNTIL   WS-D200-EXCEPTION-PRIORITY-9 IS GREATER THAN 6
113800         OR      MBD200WS-DA-OVERRIDE-YES
113900         SET X-MMRT-EXCEPTION    TO 2
114000         SEARCH MMRT-EXCEPTION VARYING X-MMRT-EXCEPTION
114100             AT END
114200                 SET X-MMRT-EXCEPTION TO 2
114300             WHEN MMRT-EXCEPTION-PRIORITY (X-MMRT-EXCEPTION)
114400                                 IS EQUAL TO
114500                                 WS-D200-EXCEPTION-PRIORITY
114600                 PERFORM F100-OVERRIDE-EXCEPTION
114700                    THRU F199-OE-EXIT
114800         END-SEARCH
114900     END-PERFORM.
115000*
115100 F099-TOC-EXIT.
115200     EXIT.
115300/
115400 F100-OVERRIDE-EXCEPTION SECTION.
115500 F101-OE-BEGIN.
115600*
115700     MOVE ZERO                   TO WS-D200-RATE-PCT.
115800*
115900     EVALUATE TRUE
116000         WHEN X-MMRT-EXCEPTION IS EQUAL TO 2
116100             EVALUATE TRUE
116200                 WHEN MMRTWS-DTD-VOLUME-W-CR-PLAN
116300                     CONTINUE
116400                 WHEN OTHER
116500                     PERFORM G000-PLAN-EXCEPTION-CHECK
116600                        THRU G099-PEC-EXIT
116700             END-EVALUATE
116800         WHEN X-MMRT-EXCEPTION IS EQUAL TO 3
116900             PERFORM H000-SING-TKT-EXCEPTION-CHECK
117000                THRU H099-STEC-EXIT
117100         WHEN X-MMRT-EXCEPTION IS EQUAL TO 4
117200             PERFORM I000-STATE-EXCEPTION-CHECK
117300                THRU I099-SEC-EXIT
117400         WHEN X-MMRT-EXCEPTION IS EQUAL TO 5
117500             PERFORM J000-LOGO-EXCEPTION-CHECK
117600                THRU J099-LEC-EXIT
117700         WHEN X-MMRT-EXCEPTION IS EQUAL TO 6
117800             PERFORM K000-DEPT-EXCEPTION-CHECK
117900                THRU K099-DEC-EXIT
118000         WHEN X-MMRT-EXCEPTION IS EQUAL TO 7
118100             PERFORM L000-SKU-EXCEPTION-CHECK
118200                THRU L099-SEC-EXIT
118300     END-EVALUATE.
118400*
118500     IF  MBD200WS-DA-OVERRIDE-YES
118600         EVALUATE TRUE
118700             WHEN MMRTWS-VALID-METH-ON-NUMBER
118800                 SET MTPT-IDI-IS-PER-ITEM
118900                                 TO TRUE
119000*
119100                 MOVE MMOC-PER-ITEM-NOD
119200                                 TO SS50WS-MULTIPLIER-NOD
119300                 MOVE ZERO       TO SS50WS-MULTIPLICAND-NOD
119400                 MOVE WS-D200-RATE-PER-ITEM
119500                                 TO SS50WS-MULTIPLICAND
119600                 MOVE MTPT-NBR-ITEMS
119700                                 TO SS50WS-MULTIPLIER-PER-ITEM
119800                 PERFORM SS50PD-MULTIPLY
119900                                 THRU SS50PD-M-EXIT
120000                 MOVE SS50WS-PRODUCT
120100                                 TO MBD200WS-DA-WORK-AMT-2
120200*
120300***              COMPUTE MBD200WS-DA-WORK-AMT-2 ROUNDED
120400***                              =  WS-D200-RATE-PER-ITEM
120500***                              *  MTPT-NBR-ITEMS
120600***              END-COMPUTE
120700                 IF  MMTCWS-LM-SALE-REV
120800                 OR (MMTCWS-LM-RETURN
120900                 AND MBD200WS-DA-DFB-NET-SALES)
121000                 OR (MMTCWS-LM-RETURN-REV
121100                 AND MBD200WS-DA-DFB-GROSS-VOLUME)
121200                     COMPUTE MBD200WS-DA-WORK-AMT-2
121300                                 =  0 - MBD200WS-DA-WORK-AMT-2
121400                     END-COMPUTE
121500                 END-IF
121600                 ADD  MBD200WS-DA-WORK-AMT-2
121700                                 TO MTPT-INDIV-DISC-AMT
121800                 ADD  MBD200WS-DA-WORK-AMT-2
121900                                 TO MBD200WS-DA-OVRD-DISC-AMT
122000                 ADD  WS-D200-RATE-PER-ITEM
122100                                 TO MTPT-INDIV-DISC-PER-ITEM
122200                 PERFORM Z200-SET-TRANS-INDIV-DISC-FLAG
122300                    THRU Z299-STIDF-EXIT
122400                 ADD  MBD200WS-DA-WORK-AMT-2
122500                                 TO MBD200WS-DA-DISC-TRANS-OVRD
122600                 IF  MMTCWS-LM-SALE-REV
122700                 OR (MMTCWS-LM-RETURN
122800                 AND MBD200WS-DA-DFB-NET-SALES)
122900                 OR (MMTCWS-LM-RETURN-REV
123000                 AND MBD200WS-DA-DFB-GROSS-VOLUME)
123100                     SUBTRACT MTPT-NBR-ITEMS
123200                               FROM MBD200WS-DA-NBR-OVERRIDE
123300                 ELSE
123400                     ADD  MTPT-NBR-ITEMS
123500                                 TO MBD200WS-DA-NBR-OVERRIDE
123600                 END-IF
123700             WHEN OTHER
123800                 SET MTPT-IDI-IS-RATE
123900                                 TO TRUE
124000*
124100                 MOVE MMOC-PERCENT-NOD
124200                                 TO SS50WS-MULTIPLIER-NOD
124300                 SET SS50WS-MULTIPLICAND-BY-CC
124400                                 TO TRUE
124500                 MOVE MTPT-AMOUNT
124600                                 TO SS50WS-MULTIPLICAND
124700                 MOVE WS-D200-RATE-PCT
124800                                 TO SS50WS-MULTIPLIER-PERCENT
124900                 PERFORM SS50PD-MULTIPLY
125000                                 THRU SS50PD-M-EXIT
125100                 MOVE SS50WS-PRODUCT
125200                                 TO MBD200WS-DA-WORK-AMT-2
125300*
125400***              COMPUTE MBD200WS-DA-WORK-AMT-2 ROUNDED
125500***                              =  WS-D200-RATE-PCT
125600***                              *  MTPT-AMOUNT
125700***              END-COMPUTE
125800                 IF  MMTCWS-LM-SALE-REV
125900                 OR (MMTCWS-LM-RETURN
126000                 AND MBD200WS-DA-DFB-NET-SALES)
126100                 OR (MMTCWS-LM-RETURN-REV
126200                 AND MBD200WS-DA-DFB-GROSS-VOLUME)
126300                     COMPUTE MBD200WS-DA-WORK-AMT-2
126400                                 =  0 - MBD200WS-DA-WORK-AMT-2
126500                     END-COMPUTE
126600                 END-IF
126700                 ADD  MBD200WS-DA-WORK-AMT-2
126800                                 TO MTPT-INDIV-DISC-AMT
126900                 ADD  MBD200WS-DA-WORK-AMT-2
127000                                 TO MBD200WS-DA-OVRD-DISC-AMT
127100                 ADD  WS-D200-RATE-PCT
127200                                 TO MTPT-INDIV-DISC-RATE
127300                 PERFORM Z200-SET-TRANS-INDIV-DISC-FLAG
127400                    THRU Z299-STIDF-EXIT
127500                 ADD  MBD200WS-DA-WORK-AMT-2
127600                                 TO MBD200WS-DA-DISC-TRANS-OVRD
127700                 IF  MMTCWS-LM-SALE-REV
127800                 OR (MMTCWS-LM-RETURN
127900                 AND MBD200WS-DA-DFB-NET-SALES)
128000                 OR (MMTCWS-LM-RETURN-REV
128100                 AND MBD200WS-DA-DFB-GROSS-VOLUME)
128200                     SUBTRACT MTPT-AMOUNT
128300                               FROM MBD200WS-DA-AMT-OVERRIDE
128400                 ELSE
128500                     ADD  MTPT-AMOUNT
128600                                 TO MBD200WS-DA-AMT-OVERRIDE
128700                 END-IF
128800         END-EVALUATE.
128900*
129000 F199-OE-EXIT.
129100     EXIT.
129200/
129300 F500-ADJUSTMENT-CHECK SECTION.
129400 F501-AC-BEGIN.
129500*
129600     SET WS-D200-EF-ADJUSTMENT   TO TRUE.
129700     MOVE ZERO                   TO WS-D200-RATE-PCT.
129800     MOVE ZERO                   TO WS-D200-RATE-PCT-ADJ.
129900*
130000     IF  MMRT-EXCEPTION-IS-ADJUSTMENT (2)
130100         EVALUATE TRUE
130200             WHEN MMRTWS-DTD-VOLUME-W-CR-PLAN
130300                 CONTINUE
130400             WHEN OTHER
130500                 PERFORM G000-PLAN-EXCEPTION-CHECK
130600                    THRU G099-PEC-EXIT
130700         END-EVALUATE.
130800*
130900     ADD  WS-D200-RATE-PCT       TO WS-D200-RATE-PCT-ADJ.
131000     MOVE ZERO                   TO WS-D200-RATE-PCT.
131100*
131200*
131300*
131400     IF  MMRT-EXCEPTION-IS-ADJUSTMENT (3)
131500         PERFORM H000-SING-TKT-EXCEPTION-CHECK
131600            THRU H099-STEC-EXIT.
131700*
131800     ADD  WS-D200-RATE-PCT       TO WS-D200-RATE-PCT-ADJ.
131900     MOVE ZERO                   TO WS-D200-RATE-PCT.
132000*
132100*
132200*
132300     IF  MMRT-EXCEPTION-IS-ADJUSTMENT (4)
132400         PERFORM I000-STATE-EXCEPTION-CHECK
132500            THRU I099-SEC-EXIT.
132600*
132700     ADD  WS-D200-RATE-PCT       TO WS-D200-RATE-PCT-ADJ.
132800     MOVE ZERO                   TO WS-D200-RATE-PCT.
132900*
133000*
133100*
133200     IF  MMRT-EXCEPTION-IS-ADJUSTMENT (5)
133300         PERFORM J000-LOGO-EXCEPTION-CHECK
133400            THRU J099-LEC-EXIT.
133500*
133600     ADD  WS-D200-RATE-PCT       TO WS-D200-RATE-PCT-ADJ.
133700     MOVE ZERO                   TO WS-D200-RATE-PCT.
133800*
133900*
134000*
134100     IF  MMRT-EXCEPTION-IS-ADJUSTMENT (6)
134200         PERFORM K000-DEPT-EXCEPTION-CHECK
134300            THRU K099-DEC-EXIT.
134400*
134500     ADD  WS-D200-RATE-PCT       TO WS-D200-RATE-PCT-ADJ.
134600     MOVE ZERO                   TO WS-D200-RATE-PCT.
134700*
134800*
134900*
135000     IF  MMRT-EXCEPTION-IS-ADJUSTMENT (7)
135100         PERFORM L000-SKU-EXCEPTION-CHECK
135200            THRU L099-SEC-EXIT.
135300*
135400     ADD  WS-D200-RATE-PCT       TO WS-D200-RATE-PCT-ADJ.
135500     MOVE ZERO                   TO WS-D200-RATE-PCT.
135600*
135700*
135800*
135900     IF  WS-D200-RATE-PCT-ADJ IS NOT EQUAL TO ZERO
136000         EVALUATE TRUE
136100             WHEN MMRTWS-VALID-METH-ON-NUMBER
136200                 SET MTPT-IDI-IS-PER-ITEM
136300                                 TO TRUE
136400*
136500                 MOVE MMOC-PER-ITEM-NOD
136600                                 TO SS50WS-MULTIPLIER-NOD
136700                 MOVE ZERO
136800                                 TO SS50WS-MULTIPLICAND-NOD
136900                 MOVE WS-D200-RATE-PER-ITEM-ADJ
137000                                 TO SS50WS-MULTIPLICAND
137100                 MOVE MTPT-NBR-ITEMS
137200                                 TO SS50WS-MULTIPLIER-PER-ITEM
137300                 PERFORM SS50PD-MULTIPLY
137400                                 THRU SS50PD-M-EXIT
137500                 MOVE SS50WS-PRODUCT
137600                                 TO MBD200WS-DA-WORK-AMT-2
137700*
137800***              COMPUTE MBD200WS-DA-WORK-AMT-2 ROUNDED
137900***                              =  WS-D200-RATE-PER-ITEM-ADJ
138000***                              *  MTPT-NBR-ITEMS
138100***              END-COMPUTE
138200                 IF  MMTCWS-LM-SALE-REV
138300                 OR (MMTCWS-LM-RETURN
138400                 AND MBD200WS-DA-DFB-NET-SALES)
138500                 OR (MMTCWS-LM-RETURN-REV
138600                 AND MBD200WS-DA-DFB-GROSS-VOLUME)
138700                     COMPUTE MBD200WS-DA-WORK-AMT-2
138800                                 =  0 - MBD200WS-DA-WORK-AMT-2
138900                     END-COMPUTE
139000                 END-IF
139100                 ADD  MBD200WS-DA-WORK-AMT-2
139200                                 TO MTPT-INDIV-DISC-AMT
139300                 ADD  MBD200WS-DA-WORK-AMT-2
139400                                 TO MBD200WS-DA-ADJ-DISC-AMT
139500                 ADD  WS-D200-RATE-PER-ITEM-ADJ
139600                                 TO MTPT-INDIV-DISC-ADJ-PER-ITEM
139700                 PERFORM Z200-SET-TRANS-INDIV-DISC-FLAG
139800                    THRU Z299-STIDF-EXIT
139900                 ADD  MBD200WS-DA-WORK-AMT-2
140000                                 TO MBD200WS-DA-DISC-TRANS-ADJ
140100                 IF  MBD200WS-DA-OVERRIDE-NO
140200                     IF  MMTCWS-LM-SALE-REV
140300                     OR (MMTCWS-LM-RETURN
140400                     AND MBD200WS-DA-DFB-NET-SALES)
140500                     OR (MMTCWS-LM-RETURN-REV
140600                     AND MBD200WS-DA-DFB-GROSS-VOLUME)
140700                         SUBTRACT MTPT-NBR-ITEMS
140800                               FROM MBD200WS-DA-NBR-ADJUSTMENTS
140900                     ELSE
141000                         ADD  MTPT-NBR-ITEMS
141100                                 TO MBD200WS-DA-NBR-ADJUSTMENTS
141200                     END-IF
141300                 END-IF
141400             WHEN OTHER
141500                 SET MTPT-IDI-IS-RATE
141600                                 TO TRUE
141700*
141800                 MOVE MMOC-PERCENT-NOD
141900                                 TO SS50WS-MULTIPLIER-NOD
142000                 SET SS50WS-MULTIPLICAND-BY-CC
142100                                 TO TRUE
142200                 MOVE MTPT-AMOUNT
142300                                 TO SS50WS-MULTIPLICAND
142400                 MOVE WS-D200-RATE-PCT-ADJ
142500                                 TO SS50WS-MULTIPLIER-PERCENT
142600                 PERFORM SS50PD-MULTIPLY
142700                                 THRU SS50PD-M-EXIT
142800                 MOVE SS50WS-PRODUCT
142900                                 TO MBD200WS-DA-WORK-AMT-2
143000*
143100***              COMPUTE MBD200WS-DA-WORK-AMT-2 ROUNDED
143200***                              =  WS-D200-RATE-PCT-ADJ
143300***                              *  MTPT-AMOUNT
143400***              END-COMPUTE
143500                 IF  MMTCWS-LM-SALE-REV
143600                 OR (MMTCWS-LM-RETURN
143700                 AND MBD200WS-DA-DFB-NET-SALES)
143800                 OR (MMTCWS-LM-RETURN-REV
143900                 AND MBD200WS-DA-DFB-GROSS-VOLUME)
144000                     COMPUTE MBD200WS-DA-WORK-AMT-2
144100                                 =  0 - MBD200WS-DA-WORK-AMT-2
144200                     END-COMPUTE
144300                 END-IF
144400                 ADD  MBD200WS-DA-WORK-AMT-2
144500                                 TO MTPT-INDIV-DISC-AMT
144600                 ADD  MBD200WS-DA-WORK-AMT-2
144700                                 TO MBD200WS-DA-ADJ-DISC-AMT
144800                 ADD  WS-D200-RATE-PCT-ADJ
144900                                 TO MTPT-INDIV-DISC-ADJ-RATE
145000                 PERFORM Z200-SET-TRANS-INDIV-DISC-FLAG
145100                    THRU Z299-STIDF-EXIT
145200                 ADD  MBD200WS-DA-WORK-AMT-2
145300                                 TO MBD200WS-DA-DISC-TRANS-ADJ
145400                 IF  MBD200WS-DA-OVERRIDE-NO
145500                     IF  MMTCWS-LM-SALE-REV
145600                     OR (MMTCWS-LM-RETURN
145700                     AND MBD200WS-DA-DFB-NET-SALES)
145800                     OR (MMTCWS-LM-RETURN-REV
145900                     AND MBD200WS-DA-DFB-GROSS-VOLUME)
146000                         SUBTRACT MTPT-AMOUNT
146100                               FROM MBD200WS-DA-AMT-ADJUSTMENTS
146200                     ELSE
146300                         ADD  MTPT-AMOUNT
146400                                 TO MBD200WS-DA-AMT-ADJUSTMENTS
146500                     END-IF
146600                 END-IF
146700         END-EVALUATE.
146800*
146900 F599-AC-EXIT.
147000     EXIT.
147100/
147200 G000-PLAN-EXCEPTION-CHECK SECTION.
147300 G001-PEC-BEGIN.
147400*
147500     SET X-MMRT-PLAN             TO 1.
147600*
147700     SEARCH MMRT-PLAN-TABLE VARYING X-MMRT-PLAN
147800         AT END
147900             PERFORM G500-CP-RANGE-EXCEPTION-CHECK
148000                THRU G599-CPRC-EXIT
148100         WHEN MMRT-PLAN-X (X-MMRT-PLAN) IS EQUAL TO '*****'
148200             MOVE MMRT-PLAN-RATE (X-MMRT-PLAN)
148300                                 TO WS-D200-RATE-PCT
148400             PERFORM Z300-SET-OVERRIDE-ADJ-FLAGS
148500                THRU Z399-SOAF-EXIT
148600         WHEN MTPT-PLAN-X IS NOT EQUAL TO ZERO
148700          AND MTPT-PLAN-X IS EQUAL TO MMRT-PLAN-X (X-MMRT-PLAN)
148800             MOVE MMRT-PLAN-RATE (X-MMRT-PLAN)
148900                                 TO WS-D200-RATE-PCT
149000             PERFORM Z300-SET-OVERRIDE-ADJ-FLAGS
149100                THRU Z399-SOAF-EXIT
149200         WHEN MTPT-PLAN-X IS NOT EQUAL TO ZERO
149300          AND
149400                  (MMRT-PLAN-X(X-MMRT-PLAN) (1:1) IS EQUAL TO
149500                                MTPT-PLAN-X (1:1)
149600               OR  MMRT-PLAN-X(X-MMRT-PLAN) (1:1) IS EQUAL TO '*')
149700          AND
149800                  (MMRT-PLAN-X(X-MMRT-PLAN) (2:1) IS EQUAL TO
149900                                MTPT-PLAN-X (2:1)
150000               OR  MMRT-PLAN-X(X-MMRT-PLAN) (2:1) IS EQUAL TO '*')
150100          AND
150200                  (MMRT-PLAN-X(X-MMRT-PLAN) (3:1) IS EQUAL TO
150300                                MTPT-PLAN-X (3:1)
150400               OR  MMRT-PLAN-X(X-MMRT-PLAN) (3:1) IS EQUAL TO '*')
150500          AND
150600                  (MMRT-PLAN-X(X-MMRT-PLAN) (4:1) IS EQUAL TO
150700                                MTPT-PLAN-X (4:1)
150800               OR  MMRT-PLAN-X(X-MMRT-PLAN) (4:1) IS EQUAL TO '*')
150900          AND
151000                  (MMRT-PLAN-X(X-MMRT-PLAN) (5:1) IS EQUAL TO
151100                                MTPT-PLAN-X (5:1)
151200               OR  MMRT-PLAN-X(X-MMRT-PLAN) (5:1) IS EQUAL TO '*')
151300             MOVE MMRT-PLAN-RATE (X-MMRT-PLAN)
151400                                 TO WS-D200-RATE-PCT
151500             PERFORM Z300-SET-OVERRIDE-ADJ-FLAGS
151600                THRU Z399-SOAF-EXIT.
151700*
151800 G099-PEC-EXIT.
151900     EXIT.
152000/
152100 G500-CP-RANGE-EXCEPTION-CHECK SECTION.
152200 G501-CPRC-BEGIN.
152300*
152400     SET X-MMRT-PLAN             TO 1.
152500*
152600     SEARCH MMRT-PLAN-TABLE VARYING X-MMRT-PLAN
152700         AT END
152800             SET X-MMRT-PLAN     TO 1
152900         WHEN MTPT-PLAN-X IS NOT EQUAL TO ZERO
153000          AND MTPT-PLAN-X IS NOT LESS THAN    MMRT-PLAN-BEG-X
153100                                              (X-MMRT-PLAN)
153200          AND MTPT-PLAN-X IS NOT GREATER THAN MMRT-PLAN-END-X
153300                                              (X-MMRT-PLAN)
153400             MOVE MMRT-PLAN-RANGE-RATE (X-MMRT-PLAN)
153500                                 TO WS-D200-RATE-PCT
153600             PERFORM Z300-SET-OVERRIDE-ADJ-FLAGS
153700                THRU Z399-SOAF-EXIT.
153800*
153900 G599-CPRC-EXIT.
154000     EXIT.
154100/
154200 H000-SING-TKT-EXCEPTION-CHECK SECTION.
154300 H001-STEC-BEGIN.
154400*
154500     IF  MTPT-AMOUNT IS NOT LESS THAN MMRT-SINGLE-TKT-BEG-LIMIT
154600         SET X-MMRT-SINGLE-TKT       TO 1
154700         SEARCH MMRT-SINGLE-TKT-TABLE VARYING X-MMRT-SINGLE-TKT
154800             AT END
154900                 SET X-MMRT-SINGLE-TKT
155000                                 TO 1
155100             WHEN MTPT-AMOUNT IS NOT GREATER THAN
155200                                 MMRT-SINGLE-TKT-LIMIT
155300                                 (X-MMRT-SINGLE-TKT)
155400                 MOVE MMRT-SINGLE-TKT-RATE (X-MMRT-SINGLE-TKT)
155500                                 TO WS-D200-RATE-PCT
155600                 PERFORM Z300-SET-OVERRIDE-ADJ-FLAGS
155700                    THRU Z399-SOAF-EXIT.
155800*
155900 H099-STEC-EXIT.
156000     EXIT.
156100/
156200 I000-STATE-EXCEPTION-CHECK SECTION.
156300 I001-SEC-BEGIN.
156400*
156500     SET X-MMRT-STATE            TO 1.
156600*
156700     SEARCH MMRT-STATE-TABLE VARYING X-MMRT-STATE
156800         AT END
156900             SET X-MMRT-STATE    TO 1
157000         WHEN MTPT-GOVERNING-STATE IS NOT EQUAL TO SPACES
157100          AND MTPT-GOVERNING-STATE IS EQUAL TO MMRT-STATE
157200                                               (X-MMRT-STATE)
157300             MOVE MMRT-STATE-RATE (X-MMRT-STATE)
157400                                 TO WS-D200-RATE-PCT
157500             PERFORM Z300-SET-OVERRIDE-ADJ-FLAGS
157600                THRU Z399-SOAF-EXIT.
157700*
157800 I099-SEC-EXIT.
157900     EXIT.
158000/
158100 J000-LOGO-EXCEPTION-CHECK SECTION.
158200 J001-LEC-BEGIN.
158300*
158400     SET X-MMRT-LOGO             TO 1.
158500*
158600     SEARCH MMRT-LOGO-TABLE VARYING X-MMRT-LOGO
158700         AT END
158800             SET X-MMRT-LOGO     TO 1
158900         WHEN MTPT-LOGO IS GREATER THAN ZERO
159000          AND MTPT-LOGO IS EQUAL TO MMRT-LOGO (X-MMRT-LOGO)
159100             MOVE MMRT-LOGO-RATE (X-MMRT-LOGO)
159200                                 TO WS-D200-RATE-PCT
159300             PERFORM Z300-SET-OVERRIDE-ADJ-FLAGS
159400                THRU Z399-SOAF-EXIT.
159500*
159600 J099-LEC-EXIT.
159700     EXIT.
159800/
159900 K000-DEPT-EXCEPTION-CHECK SECTION.
160000 K001-DEC-BEGIN.
160100*
160200     SET X-MMRT-DEPT             TO 1.
160300*
160400     SEARCH MMRT-DEPT-TABLE VARYING X-MMRT-DEPT
160500         AT END
160600             SET X-MMRT-DEPT     TO 1
160700         WHEN MMRT-DEPT (X-MMRT-DEPT) IS EQUAL TO '****'
160800             MOVE MMRT-DEPT-RATE (X-MMRT-DEPT)
160900                                 TO WS-D200-RATE-PCT
161000             PERFORM Z300-SET-OVERRIDE-ADJ-FLAGS
161100                THRU Z399-SOAF-EXIT
161200         WHEN MTPT-DEPT-CODE IS NOT EQUAL TO SPACES
161300          AND MTPT-DEPT-CODE IS EQUAL TO MMRT-DEPT (X-MMRT-DEPT)
161400             MOVE MMRT-DEPT-RATE (X-MMRT-DEPT)
161500                                 TO WS-D200-RATE-PCT
161600             PERFORM Z300-SET-OVERRIDE-ADJ-FLAGS
161700                THRU Z399-SOAF-EXIT
161800         WHEN MTPT-DEPT-CODE IS NOT EQUAL TO SPACES
161900          AND
162000                  (MMRT-DEPT(X-MMRT-DEPT) (1:1) IS EQUAL TO
162100                           MTPT-DEPT-CODE (1:1)
162200               OR  MMRT-DEPT(X-MMRT-DEPT) (1:1) IS EQUAL TO '*')
162300          AND
162400                  (MMRT-DEPT(X-MMRT-DEPT) (2:1) IS EQUAL TO
162500                           MTPT-DEPT-CODE (2:1)
162600               OR  MMRT-DEPT(X-MMRT-DEPT) (2:1) IS EQUAL TO '*')
162700          AND
162800                  (MMRT-DEPT(X-MMRT-DEPT) (3:1) IS EQUAL TO
162900                           MTPT-DEPT-CODE (3:1)
163000               OR  MMRT-DEPT(X-MMRT-DEPT) (3:1) IS EQUAL TO '*')
163100          AND
163200                  (MMRT-DEPT(X-MMRT-DEPT) (4:1) IS EQUAL TO
163300                           MTPT-DEPT-CODE (4:1)
163400               OR  MMRT-DEPT(X-MMRT-DEPT) (4:1) IS EQUAL TO '*')
163500             MOVE MMRT-DEPT-RATE (X-MMRT-DEPT)
163600                                 TO WS-D200-RATE-PCT
163700             PERFORM Z300-SET-OVERRIDE-ADJ-FLAGS
163800                THRU Z399-SOAF-EXIT.
163900*
164000 K099-DEC-EXIT.
164100     EXIT.
164200/
164300 L000-SKU-EXCEPTION-CHECK SECTION.
164400 L001-SEC-BEGIN.
164500*
164600     SET X-MMRT-SKU              TO 1.
164700*
164800     SEARCH MMRT-SKU-TABLE VARYING X-MMRT-SKU
164900         AT END
165000             SET X-MMRT-SKU      TO 1
165100         WHEN MMRT-SKU-NBR (X-MMRT-SKU) IS EQUAL TO '*********'
165200             MOVE MMRT-SKU-RATE (X-MMRT-SKU)
165300                                 TO WS-D200-RATE-PCT
165400             PERFORM Z300-SET-OVERRIDE-ADJ-FLAGS
165500                THRU Z399-SOAF-EXIT
165600         WHEN MTPT-SKU-NBR-X IS NOT EQUAL TO ZERO
165700          AND MTPT-SKU-NBR-X IS EQUAL TO MMRT-SKU-NBR (X-MMRT-SKU)
165800             MOVE MMRT-SKU-RATE (X-MMRT-SKU)
165900                                 TO WS-D200-RATE-PCT
166000             PERFORM Z300-SET-OVERRIDE-ADJ-FLAGS
166100                THRU Z399-SOAF-EXIT
166200         WHEN MTPT-SKU-NBR-X IS NOT EQUAL TO ZERO
166300          AND
166400                  (MMRT-SKU-NBR(X-MMRT-SKU) (1:1) IS EQUAL TO
166500                             MTPT-SKU-NBR-X (1:1)
166600               OR  MMRT-SKU-NBR(X-MMRT-SKU) (1:1) IS EQUAL TO '*')
166700          AND
166800                  (MMRT-SKU-NBR(X-MMRT-SKU) (2:1) IS EQUAL TO
166900                             MTPT-SKU-NBR-X (2:1)
167000               OR  MMRT-SKU-NBR(X-MMRT-SKU) (2:1) IS EQUAL TO '*')
167100          AND
167200                  (MMRT-SKU-NBR(X-MMRT-SKU) (3:1) IS EQUAL TO
167300                             MTPT-SKU-NBR-X (3:1)
167400               OR  MMRT-SKU-NBR(X-MMRT-SKU) (3:1) IS EQUAL TO '*')
167500          AND
167600                  (MMRT-SKU-NBR(X-MMRT-SKU) (4:1) IS EQUAL TO
167700                             MTPT-SKU-NBR-X (4:1)
167800               OR  MMRT-SKU-NBR(X-MMRT-SKU) (4:1) IS EQUAL TO '*')
167900          AND
168000                  (MMRT-SKU-NBR(X-MMRT-SKU) (5:1) IS EQUAL TO
168100                             MTPT-SKU-NBR-X (5:1)
168200               OR  MMRT-SKU-NBR(X-MMRT-SKU) (5:1) IS EQUAL TO '*')
168300          AND
168400                  (MMRT-SKU-NBR(X-MMRT-SKU) (6:1) IS EQUAL TO
168500                             MTPT-SKU-NBR-X (6:1)
168600               OR  MMRT-SKU-NBR(X-MMRT-SKU) (6:1) IS EQUAL TO '*')
168700          AND
168800                  (MMRT-SKU-NBR(X-MMRT-SKU) (7:1) IS EQUAL TO
168900                             MTPT-SKU-NBR-X (7:1)
169000               OR  MMRT-SKU-NBR(X-MMRT-SKU) (7:1) IS EQUAL TO '*')
169100          AND
169200                  (MMRT-SKU-NBR(X-MMRT-SKU) (8:1) IS EQUAL TO
169300                             MTPT-SKU-NBR-X (8:1)
169400               OR  MMRT-SKU-NBR(X-MMRT-SKU) (8:1) IS EQUAL TO '*')
169500          AND
169600                  (MMRT-SKU-NBR(X-MMRT-SKU) (9:1) IS EQUAL TO
169700                             MTPT-SKU-NBR-X (9:1)
169800               OR  MMRT-SKU-NBR(X-MMRT-SKU) (9:1) IS EQUAL TO '*')
169900             MOVE MMRT-SKU-RATE (X-MMRT-SKU)
170000                                 TO WS-D200-RATE-PCT
170100             PERFORM Z300-SET-OVERRIDE-ADJ-FLAGS
170200                THRU Z399-SOAF-EXIT.
170300*
170400 L099-SEC-EXIT.
170500     EXIT.
170600/
170700 M000-INDIVIDUAL-TICKET SECTION.
170800 M001-IT-BEGIN.
170900*
171000     SET X-MMRT-PRIM             TO 1.
171100*
171200     SEARCH MMRT-PRIMARY-RATES-TABLE VARYING X-MMRT-PRIM
171300         AT END
171400             SET X-MMRT-PRIM     TO 10
171500         WHEN MTPT-AMOUNT IS NOT GREATER THAN MMRT-PRIM-LIMIT
171600                                              (X-MMRT-PRIM)
171700             NEXT SENTENCE.
171800*
171900     MOVE MMOC-PERCENT-NOD       TO SS50WS-MULTIPLIER-NOD
172000     SET SS50WS-MULTIPLICAND-BY-CC
172100                                 TO TRUE
172200     MOVE MTPT-AMOUNT
172300                                 TO SS50WS-MULTIPLICAND
172400     MOVE MMRT-PRIM-RATE (X-MMRT-PRIM)
172500                                 TO SS50WS-MULTIPLIER-PERCENT
172600     PERFORM SS50PD-MULTIPLY
172700                                 THRU SS50PD-M-EXIT
172800     MOVE SS50WS-PRODUCT         TO MBD200WS-DA-WORK-AMT-5.
172900*
173000***  COMPUTE MBD200WS-DA-WORK-AMT-5 ROUNDED
173100***                              =  MMRT-PRIM-RATE (X-MMRT-PRIM)
173200***                              *  MTPT-AMOUNT.
173300*
173400     MOVE MMRT-PRIM-RATE (X-MMRT-PRIM)
173500                                 TO MTPT-INDIV-DISC-RATE.
173600     SET MTPT-IDI-IS-RATE        TO TRUE.
173700*
173800     SET X-MBD200WS-DA-TIER      TO X-MMRT-PRIM.
173900*
174000     IF  MMTCWS-LM-SALE-REV
174100     OR (MMTCWS-LM-RETURN
174200     AND MBD200WS-DA-DFB-NET-SALES)
174300     OR (MMTCWS-LM-RETURN-REV
174400     AND MBD200WS-DA-DFB-GROSS-VOLUME)
174500         COMPUTE MBD200WS-DA-WORK-AMT-5
174600                                 =  0 - MBD200WS-DA-WORK-AMT-5
174700         SUBTRACT MTPT-AMOUNT  FROM MBD200WS-DA-AMT-PREV-TODAY
174800         SUBTRACT MTPT-AMOUNT  FROM MBD200WS-DA-TIER-AMT-TODAY
174900                                    (X-MBD200WS-DA-TIER)
175000     ELSE
175100         ADD MTPT-AMOUNT         TO MBD200WS-DA-AMT-PREV-TODAY
175200         ADD MTPT-AMOUNT         TO MBD200WS-DA-TIER-AMT-TODAY
175300                                    (X-MBD200WS-DA-TIER).
175400*
175500     ADD  MBD200WS-DA-WORK-AMT-5 TO MTPT-INDIV-DISC-AMT.
175600     ADD  MBD200WS-DA-WORK-AMT-5 TO MBD200WS-DA-OVRD-DISC-AMT.
175700     PERFORM Z200-SET-TRANS-INDIV-DISC-FLAG
175800        THRU Z299-STIDF-EXIT.
175900     ADD  MBD200WS-DA-WORK-AMT-5 TO MBD200WS-DA-DISC-TRANS-OVRD.
176000*
176100     IF  MMTCWS-LM-SALE-REV
176200     OR (MMTCWS-LM-RETURN
176300     AND MBD200WS-DA-DFB-NET-SALES)
176400     OR (MMTCWS-LM-RETURN-REV
176500     AND MBD200WS-DA-DFB-GROSS-VOLUME)
176600         SUBTRACT MTPT-AMOUNT  FROM MBD200WS-DA-AMT-OVERRIDE
176700     ELSE
176800         ADD  MTPT-AMOUNT        TO MBD200WS-DA-AMT-OVERRIDE.
176900*
177000     SET WS-D200-EF-OVERRIDE     TO TRUE.
177100     PERFORM Z300-SET-OVERRIDE-ADJ-FLAGS
177200        THRU Z399-SOAF-EXIT.
177300*
177400 M099-IT-EXIT.
177500     EXIT.
177600/
177700 P000-PROCESS-PLAN SECTION.
177800 P001-PP-BEGIN.
177900*
178000     INITIALIZE MBD200WS-DA-PLAN-AREA.
178100*
178200     PERFORM
178300         VARYING X-MMCPTB FROM 1 BY 1
178400         UNTIL   X-MMCPTB IS GREATER THAN MMCPTB-MAX-ENTRIES
178500            OR   MMCPTB-END-OF-TABLE (X-MMCPTB)
178600         MOVE MMCPTB-RECORD (X-MMCPTB)
178700                                 TO MMCP-RECORD
178800         EVALUATE TRUE
178900             WHEN MMMM-DL-PRODUCT
179000                 IF  MMCP-DETAIL
179100                 AND MMCP-PRODUCT IS EQUAL TO MMMP-PRODUCT
179200                     PERFORM P100-SEARCH-PLAN-SINGLE
179300                        THRU P199-SPS-EXIT
179400                 END-IF
179500             WHEN OTHER
179600                 IF  MMCP-DETAIL
179700                     PERFORM P100-SEARCH-PLAN-SINGLE
179800                        THRU P199-SPS-EXIT
179900                 END-IF
180000         END-EVALUATE
180100     END-PERFORM.
180200*
180300     PERFORM
180400         VARYING X-MMRT-PLAN FROM 1 BY 1
180500         UNTIL   X-MMRT-PLAN IS GREATER THAN 56
180600         SET X-MBD200WS-DA-PLAN  TO X-MMRT-PLAN
180700*
180800         MOVE MMOC-PERCENT-NOD   TO SS50WS-MULTIPLIER-NOD
180900         SET SS50WS-MULTIPLICAND-BY-CC
181000                                 TO TRUE
181100         MOVE MBD200WS-DA-PLAN-FBS (X-MBD200WS-DA-PLAN)
181200                                 TO SS50WS-MULTIPLICAND
181300         MOVE MMRT-PLAN-RATE (X-MMRT-PLAN)
181400                                 TO SS50WS-MULTIPLIER-PERCENT
181500         PERFORM SS50PD-MULTIPLY
181600                                 THRU SS50PD-M-EXIT
181700         MOVE SS50WS-PRODUCT     TO MBD200WS-DA-PLAN-DISC
181800                                    (X-MBD200WS-DA-PLAN)
181900*
182000***      COMPUTE MBD200WS-DA-PLAN-DISC (X-MBD200WS-DA-PLAN)
182100***                              ROUNDED
182200***                              =  MMRT-PLAN-RATE (X-MMRT-PLAN)
182300***                              *  MBD200WS-DA-PLAN-FBS
182400***                                 (X-MBD200WS-DA-PLAN)
182500***      END-COMPUTE
182600*
182700         MOVE MMOC-PERCENT-NOD   TO SS50WS-MULTIPLIER-NOD
182800         SET SS50WS-MULTIPLICAND-BY-CC
182900                                 TO TRUE
183000         MOVE MBD200WS-DA-PLAN-RANGE-FBS (X-MBD200WS-DA-PLAN)
183100                                 TO SS50WS-MULTIPLICAND
183200         MOVE MMRT-PLAN-RANGE-RATE(X-MMRT-PLAN)
183300                                 TO SS50WS-MULTIPLIER-PERCENT
183400         PERFORM SS50PD-MULTIPLY
183500                                 THRU SS50PD-M-EXIT
183600         MOVE SS50WS-PRODUCT     TO MBD200WS-DA-PLAN-RANGE-DISC
183700                                    (X-MBD200WS-DA-PLAN)
183800*
183900***      COMPUTE MBD200WS-DA-PLAN-RANGE-DISC (X-MBD200WS-DA-PLAN)
184000***                              ROUNDED
184100***                              =  MMRT-PLAN-RANGE-RATE
184200***                                 (X-MMRT-PLAN)
184300***                              *  MBD200WS-DA-PLAN-RANGE-FBS
184400***                                 (X-MBD200WS-DA-PLAN)
184500***      END-COMPUTE
184600         EVALUATE TRUE
184700             WHEN MMRT-EXCEPTION-IS-ADJUSTMENT (2)
184800                 COMPUTE MBD200WS-DA-DISC-PLAN-ADJ
184900                                 =  MBD200WS-DA-DISC-PLAN-ADJ
185000                                 +  MBD200WS-DA-PLAN-DISC
185100                                    (X-MBD200WS-DA-PLAN)
185200                                 +  MBD200WS-DA-PLAN-RANGE-DISC
185300                                    (X-MBD200WS-DA-PLAN)
185400                 END-COMPUTE
185500                  ADD  MBD200WS-DA-PLAN-FBS
185600                       (X-MBD200WS-DA-PLAN)
185700                                 TO MBD200WS-DA-AMT-ADJUSTMENTS
185800                  ADD  MBD200WS-DA-PLAN-RANGE-FBS
185900                       (X-MBD200WS-DA-PLAN)
186000                                 TO MBD200WS-DA-AMT-ADJUSTMENTS
186100             WHEN MMRT-EXCEPTION-COND-OVERRIDE (2)
186200                 COMPUTE MBD200WS-DA-DISC-PLAN-OVRD
186300                                 =  MBD200WS-DA-DISC-PLAN-OVRD
186400                                 +  MBD200WS-DA-PLAN-DISC
186500                                    (X-MBD200WS-DA-PLAN)
186600                                 +  MBD200WS-DA-PLAN-RANGE-DISC
186700                                    (X-MBD200WS-DA-PLAN)
186800                 END-COMPUTE
186900                  ADD  MBD200WS-DA-PLAN-FBS
187000                       (X-MBD200WS-DA-PLAN)
187100                                 TO MBD200WS-DA-AMT-OVERRIDE
187200                  ADD  MBD200WS-DA-PLAN-RANGE-FBS
187300                       (X-MBD200WS-DA-PLAN)
187400                                 TO MBD200WS-DA-AMT-OVERRIDE
187500             WHEN OTHER
187600                 CONTINUE
187700         END-EVALUATE
187800     END-PERFORM.
187900*
188000*
188100*
188200*
188300*
188400*
188500 P099-PP-EXIT.
188600     EXIT.
188700/
188800 P100-SEARCH-PLAN-SINGLE SECTION.
188900 P101-SPS-BEGIN.
189000*
189100     SET MBD200WS-DA-PLAN-SINGLE TO TRUE.
189200*
189300     SET X-MMRT-PLAN             TO 1.
189400     SEARCH MMRT-PLAN-TABLE VARYING X-MMRT-PLAN
189500         AT END
189600             PERFORM P200-SEARCH-PLAN-RANGE
189700                THRU P299-SPR-EXIT
189800         WHEN MMRT-PLAN-X (X-MMRT-PLAN) IS EQUAL TO MMCP-PLAN-X
189900          AND MMRT-PLAN-X (X-MMRT-PLAN) IS GREATER THAN ZERO
190000             PERFORM P300-ACCUM-STATS
190100                THRU P399-AS-EXIT
190200         WHEN MMCP-PLAN-X IS NOT EQUAL TO ZERO
190300          AND
190400                 (MMRT-PLAN-X (X-MMRT-PLAN) (1:1) IS EQUAL TO
190500                                MMCP-PLAN-X (1:1)
190600              OR  MMRT-PLAN-X (X-MMRT-PLAN) (1:1) IS EQUAL TO '*')
190700          AND
190800                 (MMRT-PLAN-X (X-MMRT-PLAN) (2:1) IS EQUAL TO
190900                                MMCP-PLAN-X (2:1)
191000              OR  MMRT-PLAN-X (X-MMRT-PLAN) (2:1) IS EQUAL TO '*')
191100          AND
191200                 (MMRT-PLAN-X (X-MMRT-PLAN) (3:1) IS EQUAL TO
191300                                MMCP-PLAN-X (3:1)
191400              OR  MMRT-PLAN-X (X-MMRT-PLAN) (3:1) IS EQUAL TO '*')
191500          AND
191600                 (MMRT-PLAN-X (X-MMRT-PLAN) (4:1) IS EQUAL TO
191700                                MMCP-PLAN-X (4:1)
191800              OR  MMRT-PLAN-X (X-MMRT-PLAN) (4:1) IS EQUAL TO '*')
191900          AND
192000                 (MMRT-PLAN-X (X-MMRT-PLAN) (5:1) IS EQUAL TO
192100                                MMCP-PLAN-X (5:1)
192200              OR  MMRT-PLAN-X (X-MMRT-PLAN) (5:1) IS EQUAL TO '*')
192300             PERFORM P300-ACCUM-STATS
192400                THRU P399-AS-EXIT.
192500*
192600 P199-SPS-EXIT.
192700     EXIT.
192800/
192900 P200-SEARCH-PLAN-RANGE SECTION.
193000 P201-SPR-BEGIN.
193100*
193200     SET MBD200WS-DA-PLAN-RANGE  TO TRUE.
193300*
193400     SET X-MMRT-PLAN             TO 1.
193500     SEARCH MMRT-PLAN-TABLE VARYING X-MMRT-PLAN
193600         AT END
193700             SET X-MMRT-PLAN     TO 1
193800         WHEN MMCP-PLAN-X IS NOT LESS THAN
193900                                 MMRT-PLAN-BEG-X (X-MMRT-PLAN)
194000          AND MMCP-PLAN-X IS NOT GREATER THAN
194100                                 MMRT-PLAN-END-X (X-MMRT-PLAN)
194200             PERFORM P300-ACCUM-STATS
194300                THRU P399-AS-EXIT.
194400*
194500 P299-SPR-EXIT.
194600     EXIT.
194700/
194800 P300-ACCUM-STATS SECTION.
194900 P301-AS-BEGIN.
195000*
195100     SET  X-MBD200WS-DA-PLAN     TO X-MMRT-PLAN.
195200     MOVE MMCP-LOGIC-MODULE      TO MMTCWS-LOGIC-MODULE.
195300*
195400     EVALUATE TRUE
195500         WHEN MMMM-DL-PRODUCT
195600             EVALUATE TRUE
195700                 WHEN MMMP-PDFB-GROSS-SALES
195800                     PERFORM P700-ADD-SALES
195900                        THRU P799-AS-EXIT
196000                 WHEN MMMP-PDFB-GROSS-VOLUME
196100                     PERFORM P700-ADD-SALES
196200                        THRU P799-AS-EXIT
196300                     PERFORM P800-ADD-RETURNS
196400                        THRU P899-AR-EXIT
196500                 WHEN OTHER
196600                     PERFORM P700-ADD-SALES
196700                        THRU P799-AS-EXIT
196800                     PERFORM P900-SUBTRACT-RETURNS
196900                        THRU P999-SR-EXIT
197000             END-EVALUATE
197100         WHEN OTHER
197200             EVALUATE TRUE
197300                 WHEN MMMM-DFB-GROSS-SALES
197400                     PERFORM P700-ADD-SALES
197500                        THRU P799-AS-EXIT
197600                 WHEN MMMM-DFB-GROSS-VOLUME
197700                     PERFORM P700-ADD-SALES
197800                        THRU P799-AS-EXIT
197900                     PERFORM P800-ADD-RETURNS
198000                        THRU P899-AR-EXIT
198100                 WHEN OTHER
198200                     PERFORM P700-ADD-SALES
198300                        THRU P799-AS-EXIT
198400                     PERFORM P900-SUBTRACT-RETURNS
198500                        THRU P999-SR-EXIT
198600             END-EVALUATE
198700     END-EVALUATE.
198800*
198900 P399-AS-EXIT.
199000     EXIT.
199100/
199200 P700-ADD-SALES SECTION.
199300 P701-AS-BEGIN.
199400*
199500     EVALUATE TRUE
199600         WHEN MMTCWS-LM-SALE
199700             EVALUATE TRUE
199800                 WHEN MBD200WS-DA-PLAN-SINGLE
199900                     ADD MMCP-AMT (17)
200000                                 TO MBD200WS-DA-PLAN-FBS
200100                                    (X-MBD200WS-DA-PLAN)
200200                 WHEN OTHER
200300                     ADD MMCP-AMT (17)
200400                                 TO MBD200WS-DA-PLAN-RANGE-FBS
200500                                    (X-MBD200WS-DA-PLAN)
200600             END-EVALUATE
200700         WHEN MMTCWS-LM-SALE-REV
200800             EVALUATE TRUE
200900                 WHEN MBD200WS-DA-PLAN-SINGLE
201000                     SUBTRACT MMCP-AMT (17)
201100                                 FROM MBD200WS-DA-PLAN-FBS
201200                                    (X-MBD200WS-DA-PLAN)
201300                 WHEN OTHER
201400                     SUBTRACT MMCP-AMT (17)
201500                                 FROM MBD200WS-DA-PLAN-RANGE-FBS
201600                                    (X-MBD200WS-DA-PLAN)
201700             END-EVALUATE
201800     END-EVALUATE.
201900*
202000 P799-AS-EXIT.
202100     EXIT.
202200/
202300 P800-ADD-RETURNS SECTION.
202400 P801-AR-BEGIN.
202500*
202600     EVALUATE TRUE
202700         WHEN MMTCWS-LM-RETURN
202800             EVALUATE TRUE
202900                 WHEN MBD200WS-DA-PLAN-SINGLE
203000                     ADD MMCP-AMT (17)
203100                                 TO MBD200WS-DA-PLAN-FBS
203200                                    (X-MBD200WS-DA-PLAN)
203300                 WHEN OTHER
203400                     ADD MMCP-AMT (17)
203500                                 TO MBD200WS-DA-PLAN-RANGE-FBS
203600                                    (X-MBD200WS-DA-PLAN)
203700             END-EVALUATE
203800         WHEN MMTCWS-LM-RETURN-REV
203900             EVALUATE TRUE
204000                 WHEN MBD200WS-DA-PLAN-SINGLE
204100                     SUBTRACT MMCP-AMT (17)
204200                                 FROM MBD200WS-DA-PLAN-FBS
204300                                    (X-MBD200WS-DA-PLAN)
204400                 WHEN OTHER
204500                     SUBTRACT MMCP-AMT (17)
204600                                 FROM MBD200WS-DA-PLAN-RANGE-FBS
204700                                    (X-MBD200WS-DA-PLAN)
204800             END-EVALUATE
204900     END-EVALUATE.
205000*
205100 P899-AR-EXIT.
205200     EXIT.
205300/
205400 P900-SUBTRACT-RETURNS SECTION.
205500 P901-SR-BEGIN.
205600*
205700     EVALUATE TRUE
205800         WHEN MMTCWS-LM-RETURN
205900             EVALUATE TRUE
206000                 WHEN MBD200WS-DA-PLAN-SINGLE
206100                     SUBTRACT MMCP-AMT (17)
206200                                 FROM MBD200WS-DA-PLAN-FBS
206300                                    (X-MBD200WS-DA-PLAN)
206400                 WHEN OTHER
206500                     SUBTRACT MMCP-AMT (17)
206600                                 FROM MBD200WS-DA-PLAN-RANGE-FBS
206700                                    (X-MBD200WS-DA-PLAN)
206800             END-EVALUATE
206900         WHEN MMTCWS-LM-RETURN-REV
207000             EVALUATE TRUE
207100                 WHEN MBD200WS-DA-PLAN-SINGLE
207200                     ADD MMCP-AMT (17)
207300                                 TO MBD200WS-DA-PLAN-FBS
207400                                    (X-MBD200WS-DA-PLAN)
207500                 WHEN OTHER
207600                     ADD MMCP-AMT (17)
207700                                 TO MBD200WS-DA-PLAN-RANGE-FBS
207800                                    (X-MBD200WS-DA-PLAN)
207900             END-EVALUATE
208000     END-EVALUATE.
208100*
208200 P999-SR-EXIT.
208300     EXIT.
208400/
208500 T000-PROCESS-TODAYS SECTION.
208600 T001-PT-BEGIN.
208700*
208800     PERFORM X900-ACCUM-STATS-TABLE
208900        THRU X999-AST-EXIT.
209000*
209100     MOVE ZERO                   TO MBD200WS-DA-WORK-AMT-1.
209200*
209300     IF  MMRTWS-CTD-NUMBER-INC
209400     OR  MMRTWS-CTD-VOLUME-INC
209500         SET X-WS-D200-SRA       TO 13
209600         PERFORM Z000-CALC-FEE-BASE
209700            THRU Z099-CFB-EXIT.
209800*
209900     IF  MMRTWS-MTD-NUMBER-INC
210000     OR  MMRTWS-MTD-VOLUME-INC
210100     OR  MMRTWS-MTD-TIERED-INCOME
210200         SET X-WS-D200-SRA       TO 13
210300         PERFORM Z000-CALC-FEE-BASE
210400            THRU Z099-CFB-EXIT.
210500*
210600     IF  MMRTWS-INDIVIDUAL-TICKET
210700         MOVE ZERO               TO MBD200WS-DA-WORK-NBR-1
210800         MOVE ZERO               TO MBD200WS-DA-WORK-AMT-1.
210900*
211000     IF  MMRTWS-DTD-NUMBER-INC
211100     OR  MMRTWS-DTD-NUMBER-CUM
211200     OR  MMRTWS-DTD-VOLUME-INC
211300     OR  MMRTWS-DTD-VOLUME-CUM
211400     OR  MMRTWS-DTD-VOLUME-W-CR-PLAN
211500     OR  MMRTWS-DTD-VOLUME-W-AVG-TKT
211600     OR  MMRTWS-DTD-AVG-TKT-CUM
211700     OR  MMRTWS-ROLLING-1-MON-VOL
211800     OR  MMRTWS-ROLLING-3-MON-VOL
211900     OR  MMRTWS-ROLLING-6-MON-VOL
212000     OR  MMRTWS-ROLLING-12-MON-VOL
212100     OR  MMRTWS-ROLLING-1-MON-AVG-TKT
212200     OR  MMRTWS-ROLLING-3-MON-AVG-TKT
212300     OR  MMRTWS-ROLLING-6-MON-AVG-TKT
212400     OR  MMRTWS-ROLLING-12-MON-AVG-TKT
212500         SET X-WS-D200-SRA       TO 13
212600         PERFORM Z000-CALC-FEE-BASE
212700            THRU Z099-CFB-EXIT.
212800*
212900     ADD  MBD200WS-DA-WORK-AMT-1 TO MBD200WS-DA-AMT-PREV-TODAY.
213000     ADD  MBD200WS-DA-WORK-NBR-1 TO MBD200WS-DA-NBR-PREV-TODAY.
213100*
213200*
213300*
213400 T099-PT-EXIT.
213500     EXIT.
213600/
213700 V000-PROCESS-AVG-TICKET SECTION.
213800 V001-PAT-BEGIN.
213900*
214000     SET X-MMRT-ATV              TO 1.
214100*
214200     SEARCH MMRT-AVG-TKT-VOL-TABLE VARYING X-MMRT-ATV
214300         AT END
214400             SET X-MMRT-ATV      TO 1
214500         WHEN WS-D200-SRA-AVG-TKT (17) IS NOT GREATER THAN
214600                                 MMRT-ATV-LIMIT (X-MMRT-ATV)
214700             NEXT SENTENCE.
214800*
214900     SET MBD200WS-DA-AVG-TKT-INDEX
215000                                 TO X-MMRT-ATV.
215100*
215200     MOVE MMOC-PERCENT-NOD       TO SS50WS-MULTIPLIER-NOD
215300     SET SS50WS-MULTIPLICAND-BY-CC
215400                                 TO TRUE
215500     MOVE MBD200WS-DA-AMT-PREV-TODAY
215600                                 TO SS50WS-MULTIPLICAND
215700     MOVE MMRT-ATV-RATE (X-MMRT-ATV)
215800                                 TO SS50WS-MULTIPLIER-PERCENT
215900     PERFORM SS50PD-MULTIPLY
216000                                 THRU SS50PD-M-EXIT
216100     MOVE SS50WS-PRODUCT         TO MBD200WS-DA-DISC-AVG-TKT.
216200*
216300***  COMPUTE MBD200WS-DA-DISC-AVG-TKT ROUNDED
216400***                              =  MBD200WS-DA-AMT-PREV-TODAY
216500***                              *  MMRT-ATV-RATE (X-MMRT-ATV).
216600*
216700 V099-PAT-EXIT.
216800     EXIT.
216900/
217000 X000-DISCOUNT-SETUP SECTION.
217100 X010-DS-BEGIN.
217200*
217300     PERFORM X900-ACCUM-STATS-TABLE
217400        THRU X999-AST-EXIT.
217500*
217600     IF  MMRTWS-CTD-NUMBER-INC
217700     OR  MMRTWS-CTD-VOLUME-INC
217800         SET X-WS-D200-SRA       TO 16
217900         PERFORM Z000-CALC-FEE-BASE
218000            THRU Z099-CFB-EXIT.
218100*
218200     IF  MMRTWS-MTD-NUMBER-INC
218300     OR  MMRTWS-MTD-VOLUME-INC
218400     OR  MMRTWS-MTD-TIERED-INCOME
218500         SET X-WS-D200-SRA       TO 14
218600         PERFORM Z000-CALC-FEE-BASE
218700            THRU Z099-CFB-EXIT.
218800*
218900     IF  MMRTWS-INDIVIDUAL-TICKET
219000         MOVE ZERO               TO MBD200WS-DA-WORK-NBR-1
219100         MOVE ZERO               TO MBD200WS-DA-WORK-AMT-1.
219200*
219300     IF  MMRTWS-DTD-NUMBER-INC
219400     OR  MMRTWS-DTD-NUMBER-CUM
219500     OR  MMRTWS-DTD-VOLUME-INC
219600     OR  MMRTWS-DTD-VOLUME-CUM
219700     OR  MMRTWS-DTD-VOLUME-W-CR-PLAN
219800     OR  MMRTWS-DTD-VOLUME-W-AVG-TKT
219900     OR  MMRTWS-DTD-AVG-TKT-CUM
220000     OR  MMRTWS-ROLLING-1-MON-VOL
220100     OR  MMRTWS-ROLLING-3-MON-VOL
220200     OR  MMRTWS-ROLLING-6-MON-VOL
220300     OR  MMRTWS-ROLLING-12-MON-VOL
220400     OR  MMRTWS-ROLLING-1-MON-AVG-TKT
220500     OR  MMRTWS-ROLLING-3-MON-AVG-TKT
220600     OR  MMRTWS-ROLLING-6-MON-AVG-TKT
220700     OR  MMRTWS-ROLLING-12-MON-AVG-TKT
220800         SET X-WS-D200-SRA       TO 17
220900         PERFORM Z000-CALC-FEE-BASE
221000            THRU Z099-CFB-EXIT.
221100*
221200     IF  MMMM-DF1-MONTHLY-DISC
221300     OR  MMMM-DF1-WEEKLY-DISC
221400     OR  MMMM-DF1-BI-WEEKLY-DISC
221500     OR  MMMM-DF2-MONTHLY-DISC
221600     OR  MMMM-DF2-WEEKLY-DISC
221700         MOVE MBD200WS-DA-WORK-AMT-1
221800                                 TO MBD200WS-DA-AMT-PREV-TODAY
221900         MOVE MBD200WS-DA-WORK-NBR-1
222000                                 TO MBD200WS-DA-NBR-PREV-TODAY.
222100*
222200*
222300*
222400     IF  MMRTWS-INCREMENTAL-METHODS
222500         MOVE ZERO               TO MBD200WS-DA-WORK-AMT-4
222600         MOVE ZERO               TO MBD200WS-DA-WORK-NBR-4
222700         PERFORM X300-LOAD-DISCOUNT-W-STATS
222800            THRU X399-LDWS-EXIT
222900            VARYING X-MMRT-PRIM FROM 1 BY 1
223000              UNTIL X-MMRT-PRIM IS GREATER THAN 10
223100     ELSE
223200         PERFORM
223300            VARYING X-MMRT-PRIM FROM 1 BY 1
223400            UNTIL   X-MMRT-PRIM IS GREATER THAN 10
223500            SET X-MBD200WS-DA-TIER
223600                                 TO X-MMRT-PRIM
223700            EVALUATE TRUE
223800                WHEN MMRTWS-VALID-METH-ON-NUMBER
223900                    MOVE MMRT-PRIM-LIMIT-NBR (X-MMRT-PRIM)
224000                                 TO MBD200WS-DA-TIER-NBR-ALLOWED
224100                                    (X-MBD200WS-DA-TIER)
224200                WHEN OTHER
224300                    MOVE MMRT-PRIM-LIMIT (X-MMRT-PRIM)
224400                                 TO MBD200WS-DA-TIER-AMT-ALLOWED
224500                                    (X-MBD200WS-DA-TIER)
224600            END-EVALUATE
224700         END-PERFORM
224800     END-IF.
224900*
225000     EVALUATE TRUE
225100         WHEN MMMM-DL-PRODUCT
225200             MOVE MMMP-PROD-DISC-FEE-BASE
225300                                 TO MBD200WS-DA-FEE-BASE
225400         WHEN OTHER
225500             MOVE MMMM-DISC-FEE-BASE
225600                                 TO MBD200WS-DA-FEE-BASE
225700     END-EVALUATE.
225800*
225900 X099-DS-EXIT.
226000     EXIT.
226100/
226200 X300-LOAD-DISCOUNT-W-STATS SECTION.
226300 X310-LDWS-BEGIN.
226400*
226500     SET X-MBD200WS-DA-TIER      TO X-MMRT-PRIM.
226600*
226700     IF  MMRTWS-VALID-METH-ON-NUMBER
226800         PERFORM X500-LOAD-TIER-NUMBERS
226900            THRU X599-LTN-EXIT
227000     ELSE
227100         PERFORM X400-LOAD-TIER-AMOUNTS
227200            THRU X499-LTA-EXIT.
227300*
227400 X399-LDWS-EXIT.
227500     EXIT.
227600/
227700 X400-LOAD-TIER-AMOUNTS SECTION.
227800 X410-LTA-BEGIN.
227900*
228000     COMPUTE MBD200WS-DA-TIER-AMT-ALLOWED (X-MBD200WS-DA-TIER)
228100                                 =  MMRT-PRIM-LIMIT (X-MMRT-PRIM)
228200                                 -  MBD200WS-DA-WORK-AMT-4.
228300*
228400     MOVE MMRT-PRIM-LIMIT (X-MMRT-PRIM)
228500                                 TO MBD200WS-DA-WORK-AMT-4.
228600*
228700     IF  MBD200WS-DA-WORK-AMT-1 IS NOT GREATER THAN
228800         MBD200WS-DA-TIER-AMT-ALLOWED (X-MBD200WS-DA-TIER)
228900         MOVE MBD200WS-DA-WORK-AMT-1
229000                                 TO MBD200WS-DA-TIER-AMT-PREV
229100                                    (X-MBD200WS-DA-TIER)
229200         MOVE ZERO               TO MBD200WS-DA-WORK-AMT-1
229300     ELSE
229400         MOVE MBD200WS-DA-TIER-AMT-ALLOWED (X-MBD200WS-DA-TIER)
229500                                 TO MBD200WS-DA-TIER-AMT-PREV
229600                                    (X-MBD200WS-DA-TIER)
229700         COMPUTE MBD200WS-DA-WORK-AMT-1
229800                                 =  MBD200WS-DA-WORK-AMT-1
229900                                 -  MBD200WS-DA-TIER-AMT-ALLOWED
230000                                    (X-MBD200WS-DA-TIER).
230100*
230200*
230300*
230400 X499-LTA-EXIT.
230500     EXIT.
230600/
230700 X500-LOAD-TIER-NUMBERS SECTION.
230800 X510-LTN-BEGIN.
230900*
231000     COMPUTE MBD200WS-DA-TIER-NBR-ALLOWED (X-MBD200WS-DA-TIER)
231100                                 =  MMRT-PRIM-LIMIT-NBR
231200                                    (X-MMRT-PRIM)
231300                                 -  MBD200WS-DA-WORK-NBR-4.
231400*
231500     MOVE MMRT-PRIM-LIMIT-NBR (X-MMRT-PRIM)
231600                                 TO MBD200WS-DA-WORK-NBR-4.
231700*
231800     IF  MBD200WS-DA-WORK-NBR-1 IS NOT GREATER THAN
231900         MBD200WS-DA-TIER-NBR-ALLOWED (X-MBD200WS-DA-TIER)
232000         MOVE MBD200WS-DA-WORK-NBR-1
232100                                 TO MBD200WS-DA-TIER-NBR-PREV
232200                                    (X-MBD200WS-DA-TIER)
232300         MOVE ZERO               TO MBD200WS-DA-WORK-NBR-1
232400     ELSE
232500         MOVE MBD200WS-DA-TIER-NBR-ALLOWED (X-MBD200WS-DA-TIER)
232600                                 TO MBD200WS-DA-TIER-NBR-PREV
232700                                    (X-MBD200WS-DA-TIER)
232800         COMPUTE MBD200WS-DA-WORK-NBR-1
232900                                 =  MBD200WS-DA-WORK-NBR-1
233000                                 -  MBD200WS-DA-TIER-NBR-ALLOWED
233100                                    (X-MBD200WS-DA-TIER).
233200*
233300*
233400*
233500 X599-LTN-EXIT.
233600     EXIT.
233700/
233800 X900-ACCUM-STATS-TABLE SECTION.
233900 X901-AST-BEGIN.
234000*
234100     INITIALIZE WS-D200-SALES-RETURNS-AREA.
234200*
234300     PERFORM
234400         VARYING X-MMPATB FROM 1 BY 1
234500         UNTIL   X-MMPATB IS GREATER THAN MMPATB-MAX-ENTRIES
234600            OR   MMPATB-END-OF-TABLE (X-MMPATB)
234700         MOVE MMPATB-RECORD (X-MMPATB)
234800                                 TO MMPA-RECORD
234900         EVALUATE TRUE
235000             WHEN MMMM-DL-PRODUCT
235100                 IF  MMPA-DETAIL
235200                 AND MMPA-PRODUCT IS EQUAL TO MMMP-PRODUCT
235300                     PERFORM Z100-ACCUM-STATS
235400                        THRU Z199-AS-EXIT
235500                 END-IF
235600             WHEN OTHER
235700                 IF  MMPA-TOTALS
235800                     PERFORM Z100-ACCUM-STATS
235900                        THRU Z199-AS-EXIT
236000                 END-IF
236100         END-EVALUATE
236200     END-PERFORM.
236300*
236400     PERFORM Z400-CALC-AVERAGE-TICKET
236500        THRU Z499-CAT-EXIT
236600        VARYING X-WS-D200-SRA FROM 1 BY 1
236700        UNTIL   X-WS-D200-SRA IS GREATER THAN 18.
236800*
236900 X999-AST-EXIT.
237000     EXIT.
237100/
237200 Z000-CALC-FEE-BASE SECTION.
237300 Z001-CFB-BEGIN.
237400*
237500     EVALUATE TRUE
237600         WHEN MMMM-DL-PRODUCT
237700             EVALUATE TRUE
237800                 WHEN MMMP-PDFB-GROSS-SALES
237900                     MOVE WS-D200-SRA-SALES-NBR (X-WS-D200-SRA)
238000                                 TO MBD200WS-DA-WORK-NBR-1
238100                     MOVE WS-D200-SRA-SALES-AMT (X-WS-D200-SRA)
238200                                 TO MBD200WS-DA-WORK-AMT-1
238300                 WHEN MMMP-PDFB-GROSS-VOLUME
238400                     COMPUTE MBD200WS-DA-WORK-NBR-1
238500                                 =  WS-D200-SRA-SALES-NBR
238600                                    (X-WS-D200-SRA)
238700                                 +  WS-D200-SRA-RETURNS-NBR
238800                                    (X-WS-D200-SRA)
238900                     END-COMPUTE
239000                     COMPUTE MBD200WS-DA-WORK-AMT-1
239100                                 =  WS-D200-SRA-SALES-AMT
239200                                    (X-WS-D200-SRA)
239300                                 +  WS-D200-SRA-RETURNS-AMT
239400                                    (X-WS-D200-SRA)
239500                     END-COMPUTE
239600                 WHEN OTHER
239700                     COMPUTE MBD200WS-DA-WORK-NBR-1
239800                                 =  WS-D200-SRA-SALES-NBR
239900                                    (X-WS-D200-SRA)
240000                                 +  WS-D200-SRA-RETURNS-NBR
240100                                    (X-WS-D200-SRA)
240200                     END-COMPUTE
240300                     COMPUTE MBD200WS-DA-WORK-AMT-1
240400                                 =  WS-D200-SRA-SALES-AMT
240500                                    (X-WS-D200-SRA)
240600                                 -  WS-D200-SRA-RETURNS-AMT
240700                                    (X-WS-D200-SRA)
240800                     END-COMPUTE
240900             END-EVALUATE
241000         WHEN OTHER
241100             EVALUATE TRUE
241200                 WHEN MMMM-DFB-GROSS-SALES
241300                     MOVE WS-D200-SRA-SALES-NBR (X-WS-D200-SRA)
241400                                 TO MBD200WS-DA-WORK-NBR-1
241500                     MOVE WS-D200-SRA-SALES-AMT (X-WS-D200-SRA)
241600                                 TO MBD200WS-DA-WORK-AMT-1
241700                 WHEN MMMM-DFB-GROSS-VOLUME
241800                     COMPUTE MBD200WS-DA-WORK-NBR-1
241900                                 =  WS-D200-SRA-SALES-NBR
242000                                    (X-WS-D200-SRA)
242100                                 +  WS-D200-SRA-RETURNS-NBR
242200                                    (X-WS-D200-SRA)
242300                     END-COMPUTE
242400                     COMPUTE MBD200WS-DA-WORK-AMT-1
242500                                 =  WS-D200-SRA-SALES-AMT
242600                                    (X-WS-D200-SRA)
242700                                 +  WS-D200-SRA-RETURNS-AMT
242800                                    (X-WS-D200-SRA)
242900                     END-COMPUTE
243000                 WHEN OTHER
243100                     COMPUTE MBD200WS-DA-WORK-NBR-1
243200                                 =  WS-D200-SRA-SALES-NBR
243300                                    (X-WS-D200-SRA)
243400                                 +  WS-D200-SRA-RETURNS-NBR
243500                                    (X-WS-D200-SRA)
243600                     END-COMPUTE
243700                     COMPUTE MBD200WS-DA-WORK-AMT-1
243800                                 =  WS-D200-SRA-SALES-AMT
243900                                    (X-WS-D200-SRA)
244000                                 -  WS-D200-SRA-RETURNS-AMT
244100                                    (X-WS-D200-SRA)
244200                     END-COMPUTE
244300             END-EVALUATE
244400     END-EVALUATE.
244500*
244600 Z099-CFB-EXIT.
244700     EXIT.
244800/
244900 Z100-ACCUM-STATS SECTION.
245000 Z101-AS-BEGIN.
245100*
245200     MOVE MMPA-LOGIC-MODULE      TO MMTCWS-LOGIC-MODULE.
245300*
245400     EVALUATE TRUE
245500         WHEN MMTCWS-LM-SALE
245600             PERFORM
245700                 VARYING X-MMPA FROM 1 BY 1
245800                 UNTIL   X-MMPA IS GREATER THAN 18
245900                 SET X-WS-D200-SRA
246000                                 TO X-MMPA
246100                 ADD MMPA-NBR (X-MMPA)
246200                                 TO WS-D200-SRA-SALES-NBR
246300                                    (X-WS-D200-SRA)
246400                 ADD MMPA-AMT (X-MMPA)
246500                                 TO WS-D200-SRA-SALES-AMT
246600                                    (X-WS-D200-SRA)
246700             END-PERFORM
246800         WHEN MMTCWS-LM-SALE-REV
246900             PERFORM
247000                 VARYING X-MMPA FROM 1 BY 1
247100                 UNTIL   X-MMPA IS GREATER THAN 18
247200                 SET X-WS-D200-SRA
247300                                 TO X-MMPA
247400                 SUBTRACT MMPA-NBR (X-MMPA)
247500                                 FROM WS-D200-SRA-SALES-NBR
247600                                      (X-WS-D200-SRA)
247700                 SUBTRACT MMPA-AMT (X-MMPA)
247800                                 FROM WS-D200-SRA-SALES-AMT
247900                                      (X-WS-D200-SRA)
248000             END-PERFORM
248100         WHEN MMTCWS-LM-RETURN
248200             PERFORM
248300                 VARYING X-MMPA FROM 1 BY 1
248400                 UNTIL   X-MMPA IS GREATER THAN 18
248500                 SET X-WS-D200-SRA
248600                                 TO X-MMPA
248700                 ADD MMPA-NBR (X-MMPA)
248800                                 TO WS-D200-SRA-RETURNS-NBR
248900                                    (X-WS-D200-SRA)
249000                 ADD MMPA-AMT (X-MMPA)
249100                                 TO WS-D200-SRA-RETURNS-AMT
249200                                    (X-WS-D200-SRA)
249300             END-PERFORM
249400         WHEN MMTCWS-LM-RETURN-REV
249500             PERFORM
249600                 VARYING X-MMPA FROM 1 BY 1
249700                 UNTIL   X-MMPA IS GREATER THAN 18
249800                 SET X-WS-D200-SRA
249900                                 TO X-MMPA
250000                 SUBTRACT MMPA-NBR (X-MMPA)
250100                                 FROM WS-D200-SRA-RETURNS-NBR
250200                                      (X-WS-D200-SRA)
250300                 SUBTRACT MMPA-AMT (X-MMPA)
250400                                 FROM WS-D200-SRA-RETURNS-AMT
250500                                      (X-WS-D200-SRA)
250600             END-PERFORM
250700         WHEN MMTCWS-LM-CR-FEES
250800             PERFORM
250900                 VARYING X-MMPA FROM 1 BY 1
251000                 UNTIL   X-MMPA IS GREATER THAN 18
251100                 SET X-WS-D200-SRA
251200                                 TO X-MMPA
251300                 SUBTRACT MMPA-AMT (X-MMPA)
251400                                 FROM WS-D200-SRA-INCOME-AMT
251500                                      (X-WS-D200-SRA)
251600             END-PERFORM
251700         WHEN MMTCWS-LM-DR-FEES
251800             PERFORM
251900                 VARYING X-MMPA FROM 1 BY 1
252000                 UNTIL   X-MMPA IS GREATER THAN 18
252100                 SET X-WS-D200-SRA
252200                                 TO X-MMPA
252300                 ADD MMPA-AMT (X-MMPA)
252400                                 TO WS-D200-SRA-INCOME-AMT
252500                                    (X-WS-D200-SRA)
252600             END-PERFORM
252700     END-EVALUATE.
252800*
252900 Z199-AS-EXIT.
253000     EXIT.
253100/
253200 Z200-SET-TRANS-INDIV-DISC-FLAG SECTION.
253300 Z201-STIDF-BEGIN.
253400*
253500     EVALUATE TRUE
253600         WHEN MTPT-INDIV-DISC-AMT IS LESS THAN ZERO
253700             SET MTPT-INDIV-REFUND
253800                                 TO TRUE
253900         WHEN OTHER
254000             SET MTPT-INDIV-DISCOUNT
254100                                 TO TRUE
254200     END-EVALUATE.
254300*
254400 Z299-STIDF-EXIT.
254500     EXIT.
254600/
254700 Z300-SET-OVERRIDE-ADJ-FLAGS SECTION.
254800 Z301-SOAF-BEGIN.
254900*
255000     IF  WS-D200-EF-OVERRIDE
255100         SET MBD200WS-DA-OVERRIDE-YES
255200                                 TO TRUE.
255300*
255400     IF  WS-D200-EF-ADJUSTMENT
255500         SET MBD200WS-DA-ADJUSTMENT-YES
255600                                 TO TRUE.
255700*
255800 Z399-SOAF-EXIT.
255900     EXIT.
256000/
256100 Z400-CALC-AVERAGE-TICKET SECTION.
256200 Z401-CAT-BEGIN.
256300*
256400     IF  WS-D200-SRA-SALES-NBR (X-WS-D200-SRA) IS EQUAL TO ZERO
256500         MOVE ZERO               TO WS-D200-SRA-AVG-TKT
256600                                    (X-WS-D200-SRA)
256700     ELSE
256800         COMPUTE WS-D200-SRA-AVG-TKT (X-WS-D200-SRA) ROUNDED
256900                                 =  WS-D200-SRA-SALES-AMT
257000                                    (X-WS-D200-SRA)
257100                                 /  WS-D200-SRA-SALES-NBR
257200                                    (X-WS-D200-SRA)
257300     END-IF.
257400*
257500     IF  WS-D200-SRA-AVG-TKT (X-WS-D200-SRA) IS LESS THAN ZERO
257600         MOVE ZERO               TO WS-D200-SRA-AVG-TKT
257700                                    (X-WS-D200-SRA).
257800*
257900 Z499-CAT-EXIT.
258000     EXIT.
258100/
258200 9000-PERFORMED-ROUTINES-SECT SECTION.
258300*
258400  COPY SS50PD.
258500*
258600*
258700 9995-END-SOURCE-STATEMENTS SECTION.
258800 9999-END-OF-PROGRAM.
258900     GOBACK.
