000100 IDENTIFICATION DIVISION.
000200 PROGRAM-ID. MBD200PC.
000201*       RELEASE DATE=08/24/01.        REVISION LEVEL=08.06      * ++++++++
000202***************************************************************** ++++++++
000203*WARNING.  THIS COMPUTER PROGRAM IS PROTECTED BY COPYRIGHT LAW  * ++++++++
000204*AND INTERNATIONAL TREATIES.  UNAUTHORIZED REPRODUCTION OR      * ++++++++
000205*DISTRIBUTION OF THIS PROGRAM, OR ANY PORTION OF IT, MAY RESULT * ++++++++
000206*IN SEVERE CIVIL AND CRIMINAL PENATLIES, AND WILL BE PROSECUTED * ++++++++
000207*TO THE MAXIMUM EXTENT POSSIBLE UNDER THE LAW.                  * ++++++++
000208*COPYRIGHT 1999 PAYSYS INTERNATIONAL, INC.  ALL RIGHTS RESERVED.* ++++++++
000209***************************************************************** ++++++++
000300*****************************************************************
000400*                                                               *
000500*       MBD200PC - PARTICIPATION SUBROUTINE                     *
000600*                                                               *
000700*****************************************************************
000800 ENVIRONMENT DIVISION.
000900 CONFIGURATION SECTION.
001000 SOURCE-COMPUTER.            IBM-4341.
001100 OBJECT-COMPUTER.            IBM-4341.
001200/
001300 DATA DIVISION.
001400 WORKING-STORAGE SECTION.
001500*
001600 01  FILLER                  PIC  X(12)      VALUE '** WS-BEG **'.
001700*
001800 01  WS-D200-AREA.
001900     03  WS-D200-INIT-SW     PIC  X(01)      VALUE 'Y'.
002000         88  WS-D200-INITIALIZE-YES          VALUE 'Y'.
002100         88  WS-D200-INITIALIZE-NO           VALUE 'N'.
002200     03  WS-D200-ROLLING-SEARCH-AMT
002300                             PIC S9(17)      COMP-3 VALUE ZERO.
002400     03  WS-D200-ROLLING-DENOMINATOR
002500                             PIC S9(17)      COMP-3 VALUE ZERO.
002600     03  WS-D200-EXCEPTION-FUNCTION
002700                             PIC  X(01)      VALUE 'O'.
002800         88  WS-D200-EF-OVERRIDE             VALUE 'O'.
002900         88  WS-D200-EF-ADJUSTMENT           VALUE 'A'.
003000     03  WS-D200-EXCEPTION-PRIORITY-X.
003100         05  WS-D200-EXCEPTION-PRIORITY-9
003200                             PIC  9(01)      VALUE ZERO.
003300     03  WS-D200-EXCEPTION-PRIORITY-R
003400                             REDEFINES
003500                             WS-D200-EXCEPTION-PRIORITY-X.
003600         05  WS-D200-EXCEPTION-PRIORITY
003700                             PIC  X(01).
003800     03  WS-D200-RATE-PER-ITEM
003900                             PIC S9(09)      COMP-3 VALUE ZERO.
004000     03  WS-D200-RATE-PCT    REDEFINES WS-D200-RATE-PER-ITEM
004100                             PIC S9(09)      COMP-3.
004200     03  WS-D200-RATE-PER-ITEM-ADJ
004300                             PIC S9(09)      COMP-3 VALUE ZERO.
004400     03  WS-D200-RATE-PCT-ADJ
004500                             REDEFINES WS-D200-RATE-PER-ITEM-ADJ
004600                             PIC S9(09)      COMP-3.
004700*
004800 01  WS-D200-SALES-RETURNS-AREA.
004900     03  WS-D200-SRA-TABLE                   OCCURS 18 TIMES
005000                                             INDEXED BY
005100                                             X-WS-D200-SRA
005200                                             X-WS-D200-SRA-1
005300                                             X-WS-D200-SRA-2.
005400         05  WS-D200-SRA-SALES-NBR
005500                             PIC S9(09)      COMP-3 VALUE ZERO.
005600         05  WS-D200-SRA-SALES-AMT
005700                             PIC S9(17)      COMP-3 VALUE ZERO.
005800         05  WS-D200-SRA-RETURNS-NBR
005900                             PIC S9(09)      COMP-3 VALUE ZERO.
006000         05  WS-D200-SRA-RETURNS-AMT
006100                             PIC S9(17)      COMP-3 VALUE ZERO.
006200         05  WS-D200-SRA-INCOME-AMT
006300                             PIC S9(17)      COMP-3 VALUE ZERO.
006400         05  WS-D200-SRA-AVG-TKT
006500                             PIC S9(17)      COMP-3 VALUE ZERO.
006600/
006700     COPY MMPARL REPLACING ==:MMPA:== BY ==MMPA==.
006800/
006900     COPY MMPARL REPLACING ==:MMPA:== BY ==MMCP==.
007000/
007100     COPY MMRTWS.
007200/
007300     COPY MMTCWS.
007400/
007500     COPY MB00WS.
007600*
007700     COPY SS00WS.
007800*
007900     COPY SS50WS.
008000*
008100 01  FILLER                  PIC  X(12)      VALUE '** WS-END **'.
008200/
008300 LINKAGE SECTION.
008400     COPY MBD200WS.
008500/
008600     COPY MMMPRL.
008700/
008800     COPY MMSCRL.
008900/
009000     COPY MMOCRL.
009100/
009200     COPY MMMMRL.
009300/
009400     COPY MMRTRL.
009500/
009600     COPY MTPTRL REPLACING ==:MTPT:== BY ==MTPT==.
009700/
009800     COPY MMPATB REPLACING ==:MMPA:== BY ==MMPA==.
009900/
010000     COPY MMPATB REPLACING ==:MMPA:== BY ==MMCP==.
010100/
010200 PROCEDURE DIVISION              USING MBD200WS-AREA
010300                                       MMMP-RECORD
010400                                       MMSC-RECORD
010500                                       MMOC-RECORD
010600                                       MMMM-RECORD
010700                                       MMRT-RECORD
010800                                       MTPT-RECORD
010900                                       MMPATB-TABLE-PARMS
011000                                       MMPATB-TABLE-DATA
011100                                       MMCPTB-TABLE-PARMS
011200                                       MMCPTB-TABLE-DATA.
011300*
011400 A000-MAIN-LINE SECTION.
011500 A010-ML-BEGIN.
011600*
011700     PERFORM A100-PART-PROCESSING
011800        THRU A199-PP-EXIT.
011900*
012000     GOBACK.
012100*
012200 A099-ML-EXIT.
012300     EXIT.
012400/
012500 A100-PART-PROCESSING SECTION.
012600 A101-PP-BEGIN.
012700*
012800     IF  WS-D200-INITIALIZE-YES
012900         PERFORM A800-SUBROUTINE-INIT
013000            THRU A899-SI-EXIT
013100     END-IF.
013200*
013300     MOVE MMRT-METHOD            TO MMRTWS-METHOD.
013400*
013500     EVALUATE TRUE
013600         WHEN MBD200WS-PA-PF-PROCESS-TRANS
013700             PERFORM E000-PROCESS-TRANSACTION
013800                THRU E099-PT-EXIT
013900         WHEN MBD200WS-PA-PF-PROCESS-TODAYS
014000             PERFORM T000-PROCESS-TODAYS
014100                THRU T099-PT-EXIT
014200         WHEN MBD200WS-PA-PF-PROCESS-AVG-TKT
014300             IF  MMRTWS-PTD-VOLUME-W-AVG-TKT
014400             AND MMRT-EXCEPTION-IS-ADJUSTMENT (1)
014500                 PERFORM V000-PROCESS-AVG-TICKET
014600                    THRU V099-PAT-EXIT
014700             END-IF
014800         WHEN MBD200WS-PA-PF-PROCESS-PLAN
014900             IF  MMRTWS-PTD-VOLUME-W-CR-PLAN
015000             AND
015100                (MMRT-EXCEPTION-IS-ADJUSTMENT (2)
015200              OR MMRT-EXCEPTION-COND-OVERRIDE (2))
015300                 PERFORM P000-PROCESS-PLAN
015400                    THRU P099-PP-EXIT
015500             END-IF
015600         WHEN MBD200WS-PA-PF-CALC-PART
015700             PERFORM C000-CALCULATE-PART
015800                THRU C099-CP-EXIT
015900         WHEN OTHER
016000             PERFORM X000-PART-SETUP
016100                THRU X099-PS-EXIT
016200     END-EVALUATE.
016300*
016400 A199-PP-EXIT.
016500     EXIT.
016600/
016700 A800-SUBROUTINE-INIT SECTION.
016800 A801-SI-BEGIN.
016900*
017000     SET SS50WS-FUNCTION-INITIALIZE
017100                                 TO TRUE.
017200     PERFORM SS50PD-MULTIPLY
017300        THRU SS50PD-M-EXIT.
017400*
017500     SET WS-D200-INITIALIZE-NO   TO TRUE.
017600*
017700 A899-SI-EXIT.
017800     EXIT.
017900/
018000 C000-CALCULATE-PART SECTION.
018100 C001-CP-BEGIN.
018200*
018300     COMPUTE MBD200WS-PA-AMT-SUBJECT-TIERS
018400                                 =  MBD200WS-PA-AMT-PREV-TODAY
018500                                 -  MBD200WS-PA-AMT-OVERRIDE.
018600     COMPUTE MBD200WS-PA-NBR-SUBJECT-TIERS
018700                                 =  MBD200WS-PA-NBR-PREV-TODAY
018800                                 -  MBD200WS-PA-NBR-OVERRIDE.
018900*
019000     IF  MMRTWS-INCREMENTAL-METHODS
019100         PERFORM D000-LOAD-PART-W-TODAY
019200            THRU D099-LPWT-EXIT
019300            VARYING X-MMRT-PRIM FROM 1 BY 1
019400            UNTIL   X-MMRT-PRIM IS GREATER THAN 10.
019500*
019600     EVALUATE TRUE
019700         WHEN MMRTWS-INCREMENTAL-METHODS
019800             PERFORM C100-APPLY-INCREMENTAL
019900                THRU C199-AI-EXIT
020000         WHEN OTHER
020100             PERFORM C500-APPLY-CUMULATIVE
020200                THRU C599-AC-EXIT
020300     END-EVALUATE.
020400*
020500     PERFORM C900-FINAL-PART-TOTAL
020600        THRU C999-FPT-EXIT.
020700*
020800 C099-CP-EXIT.
020900     EXIT.
021000/
021100 C100-APPLY-INCREMENTAL SECTION.
021200 C101-AI-BEGIN.
021300*
021400     MOVE MBD200WS-PA-AMT-SUBJECT-TIERS
021500                                 TO MBD200WS-PA-WORK-AMT-7.
021600     MOVE MBD200WS-PA-NBR-SUBJECT-TIERS
021700                                 TO MBD200WS-PA-WORK-NBR-7.
021800*
021900     IF  MMRTWS-VALID-METH-ON-NUMBER
022000         EVALUATE TRUE
022100             WHEN MBD200WS-PA-NBR-SUBJECT-TIERS
022200                                 IS NOT LESS THAN ZERO
022300                 PERFORM C200-LOAD-TIER-W-SUBJ-TO-PART
022400                    THRU C299-LTWSTP-EXIT
022500                    VARYING X-MBD200WS-PA-TIER FROM 10 BY -1
022600                      UNTIL X-MBD200WS-PA-TIER IS LESS THAN 1
022700             WHEN OTHER
022800                 PERFORM C200-LOAD-TIER-W-SUBJ-TO-PART
022900                    THRU C299-LTWSTP-EXIT
023000                    VARYING X-MBD200WS-PA-TIER FROM 1 BY 1
023100                      UNTIL X-MBD200WS-PA-TIER IS GREATER THAN 10
023200         END-EVALUATE
023300     ELSE
023400         EVALUATE TRUE
023500             WHEN MBD200WS-PA-AMT-SUBJECT-TIERS
023600                                 IS NOT LESS THAN ZERO
023700                 PERFORM C200-LOAD-TIER-W-SUBJ-TO-PART
023800                    THRU C299-LTWSTP-EXIT
023900                    VARYING X-MBD200WS-PA-TIER FROM 10 BY -1
024000                      UNTIL X-MBD200WS-PA-TIER IS LESS THAN 1
024100             WHEN OTHER
024200                 PERFORM C200-LOAD-TIER-W-SUBJ-TO-PART
024300                    THRU C299-LTWSTP-EXIT
024400                    VARYING X-MBD200WS-PA-TIER FROM 1 BY 1
024500                      UNTIL X-MBD200WS-PA-TIER IS GREATER THAN 10
024600         END-EVALUATE
024700     END-IF.
024800*
024900     PERFORM C800-COMPUTE-PART-IN-TIER
025000        THRU C899-CPIT-EXIT
025100        VARYING X-MBD200WS-PA-TIER FROM 1 BY 1
025200          UNTIL X-MBD200WS-PA-TIER IS GREATER THAN 10.
025300*
025400     EVALUATE TRUE
025500         WHEN (MMRTWS-CTD-NUMBER-INC
025600           OR  MMRTWS-CTD-VOLUME-INC)
025700             MOVE WS-D200-SRA-AVG-TKT (16)
025800                                 TO MBD200WS-PA-AVG-TKT-AMT
025900         WHEN (MMRTWS-MTD-NUMBER-INC
026000           OR  MMRTWS-MTD-VOLUME-INC
026100           OR  MMRTWS-MTD-TIERED-INCOME)
026200             MOVE WS-D200-SRA-AVG-TKT (14)
026300                                 TO MBD200WS-PA-AVG-TKT-AMT
026400         WHEN OTHER
026500             MOVE WS-D200-SRA-AVG-TKT (17)
026600                                 TO MBD200WS-PA-AVG-TKT-AMT
026700     END-EVALUATE.
026800*
026900*
027000*
027100 C199-AI-EXIT.
027200     EXIT.
027300/
027400 C200-LOAD-TIER-W-SUBJ-TO-PART SECTION.
027500 C201-LTWSTP-BEGIN.
027600*
027700     IF  MMRTWS-VALID-METH-ON-NUMBER
027800         EVALUATE TRUE
027900             WHEN MBD200WS-PA-TIER-NBR-TODAY (X-MBD200WS-PA-TIER)
028000                      IS NOT LESS THAN MBD200WS-PA-WORK-NBR-7
028100                 MOVE MBD200WS-PA-WORK-NBR-7
028200                                 TO MBD200WS-PA-TIER-NBR-SUBJECT
028300                                    (X-MBD200WS-PA-TIER)
028400                 MOVE ZERO       TO MBD200WS-PA-WORK-NBR-7
028500             WHEN OTHER
028600                 MOVE MBD200WS-PA-TIER-NBR-TODAY
028700                      (X-MBD200WS-PA-TIER)
028800                                 TO MBD200WS-PA-TIER-NBR-SUBJECT
028900                                    (X-MBD200WS-PA-TIER)
029000                 COMPUTE MBD200WS-PA-WORK-NBR-7
029100                                 =  MBD200WS-PA-WORK-NBR-7
029200                                 -  MBD200WS-PA-TIER-NBR-TODAY
029300                                    (X-MBD200WS-PA-TIER)
029400                 END-COMPUTE
029500         END-EVALUATE
029600     ELSE
029700         EVALUATE TRUE
029800             WHEN MBD200WS-PA-TIER-AMT-TODAY (X-MBD200WS-PA-TIER)
029900                      IS NOT LESS THAN MBD200WS-PA-WORK-AMT-7
030000                 MOVE MBD200WS-PA-WORK-AMT-7
030100                                 TO MBD200WS-PA-TIER-AMT-SUBJECT
030200                                    (X-MBD200WS-PA-TIER)
030300                 MOVE ZERO       TO MBD200WS-PA-WORK-AMT-7
030400             WHEN OTHER
030500                 MOVE MBD200WS-PA-TIER-AMT-TODAY
030600                      (X-MBD200WS-PA-TIER)
030700                                 TO MBD200WS-PA-TIER-AMT-SUBJECT
030800                                    (X-MBD200WS-PA-TIER)
030900                 COMPUTE MBD200WS-PA-WORK-AMT-7
031000                                 =  MBD200WS-PA-WORK-AMT-7
031100                                 -  MBD200WS-PA-TIER-AMT-TODAY
031200                                    (X-MBD200WS-PA-TIER)
031300                 END-COMPUTE
031400         END-EVALUATE
031500     END-IF.
031600*
031700 C299-LTWSTP-EXIT.
031800     EXIT.
031900/
032000 C500-APPLY-CUMULATIVE SECTION.
032100 C501-AC-BEGIN.
032200*
032300     MOVE MBD200WS-PA-AMT-PREV-TODAY
032400                                 TO WS-D200-ROLLING-SEARCH-AMT.
032500*
032600     IF  MMRTWS-PTD-AVG-TKT-CUM
032700         MOVE WS-D200-SRA-AVG-TKT (17)
032800                                 TO WS-D200-ROLLING-SEARCH-AMT.
032900*
033000*
033100*
033200     IF  MMRTWS-ROLLING-1-MON-AVG-TKT
033300         MOVE WS-D200-SRA-AVG-TKT (1)
033400                                 TO WS-D200-ROLLING-SEARCH-AMT.
033500*
033600*
033700*
033800     IF  MMRTWS-ROLLING-3-MON-AVG-TKT
033900         COMPUTE WS-D200-ROLLING-DENOMINATOR
034000                                 =  WS-D200-SRA-SALES-NBR (1)
034100                                 +  WS-D200-SRA-SALES-NBR (2)
034200                                 +  WS-D200-SRA-SALES-NBR (3)
034300         END-COMPUTE
034400         EVALUATE TRUE
034500             WHEN WS-D200-ROLLING-DENOMINATOR IS EQUAL TO ZERO
034600                 MOVE ZERO       TO WS-D200-ROLLING-SEARCH-AMT
034700             WHEN OTHER
034800                 COMPUTE WS-D200-ROLLING-SEARCH-AMT ROUNDED
034900                                 = (WS-D200-SRA-SALES-AMT (1)
035000                                 +  WS-D200-SRA-SALES-AMT (2)
035100                                 +  WS-D200-SRA-SALES-AMT (3))
035200                                 /  WS-D200-ROLLING-DENOMINATOR
035300                 END-COMPUTE
035400         END-EVALUATE
035500     END-IF.
035600*
035700*
035800*
035900     IF  MMRTWS-ROLLING-6-MON-AVG-TKT
036000         COMPUTE WS-D200-ROLLING-DENOMINATOR
036100                                 =  WS-D200-SRA-SALES-NBR (1)
036200                                 +  WS-D200-SRA-SALES-NBR (2)
036300                                 +  WS-D200-SRA-SALES-NBR (3)
036400                                 +  WS-D200-SRA-SALES-NBR (4)
036500                                 +  WS-D200-SRA-SALES-NBR (5)
036600                                 +  WS-D200-SRA-SALES-NBR (6)
036700         END-COMPUTE
036800         EVALUATE TRUE
036900             WHEN WS-D200-ROLLING-DENOMINATOR IS EQUAL TO ZERO
037000                 MOVE ZERO       TO WS-D200-ROLLING-SEARCH-AMT
037100             WHEN OTHER
037200                 COMPUTE WS-D200-ROLLING-SEARCH-AMT ROUNDED
037300                                 = (WS-D200-SRA-SALES-AMT (1)
037400                                 +  WS-D200-SRA-SALES-AMT (2)
037500                                 +  WS-D200-SRA-SALES-AMT (3)
037600                                 +  WS-D200-SRA-SALES-AMT (4)
037700                                 +  WS-D200-SRA-SALES-AMT (5)
037800                                 +  WS-D200-SRA-SALES-AMT (6))
037900                                 /  WS-D200-ROLLING-DENOMINATOR
038000                 END-COMPUTE
038100         END-EVALUATE
038200     END-IF.
038300*
038400*
038500*
038600     IF  MMRTWS-ROLLING-12-MON-AVG-TKT
038700         COMPUTE WS-D200-ROLLING-DENOMINATOR
038800                                 =  WS-D200-SRA-SALES-NBR (1)
038900                                 +  WS-D200-SRA-SALES-NBR (2)
039000                                 +  WS-D200-SRA-SALES-NBR (3)
039100                                 +  WS-D200-SRA-SALES-NBR (4)
039200                                 +  WS-D200-SRA-SALES-NBR (5)
039300                                 +  WS-D200-SRA-SALES-NBR (6)
039400                                 +  WS-D200-SRA-SALES-NBR (7)
039500                                 +  WS-D200-SRA-SALES-NBR (8)
039600                                 +  WS-D200-SRA-SALES-NBR (9)
039700                                 +  WS-D200-SRA-SALES-NBR (10)
039800                                 +  WS-D200-SRA-SALES-NBR (11)
039900                                 +  WS-D200-SRA-SALES-NBR (12)
040000         END-COMPUTE
040100         EVALUATE TRUE
040200             WHEN WS-D200-ROLLING-DENOMINATOR IS EQUAL TO ZERO
040300                 MOVE ZERO       TO WS-D200-ROLLING-SEARCH-AMT
040400             WHEN OTHER
040500                 COMPUTE WS-D200-ROLLING-SEARCH-AMT ROUNDED
040600                                 = (WS-D200-SRA-SALES-AMT (1)
040700                                 +  WS-D200-SRA-SALES-AMT (2)
040800                                 +  WS-D200-SRA-SALES-AMT (3)
040900                                 +  WS-D200-SRA-SALES-AMT (4)
041000                                 +  WS-D200-SRA-SALES-AMT (5)
041100                                 +  WS-D200-SRA-SALES-AMT (6)
041200                                 +  WS-D200-SRA-SALES-AMT (7)
041300                                 +  WS-D200-SRA-SALES-AMT (8)
041400                                 +  WS-D200-SRA-SALES-AMT (9)
041500                                 +  WS-D200-SRA-SALES-AMT (10)
041600                                 +  WS-D200-SRA-SALES-AMT (11)
041700                                 +  WS-D200-SRA-SALES-AMT (12))
041800                                 /  WS-D200-ROLLING-DENOMINATOR
041900                 END-COMPUTE
042000         END-EVALUATE
042100     END-IF.
042200*
042300*
042400*
042500     IF  MMRTWS-ROLLING-1-MON-VOL
042600         EVALUATE TRUE
042700             WHEN MMMM-PL-PRODUCT
042800                 EVALUATE TRUE
042900                     WHEN MMMP-PPFB-GROSS-SALES
043000                         COMPUTE WS-D200-ROLLING-SEARCH-AMT
043100                                 =   0
043200                                 +   WS-D200-SRA-SALES-AMT (1)
043300                         END-COMPUTE
043400                     WHEN MMMP-PPFB-GROSS-VOLUME
043500                         COMPUTE WS-D200-ROLLING-SEARCH-AMT
043600                                 =   WS-D200-SRA-SALES-AMT (1)
043700                                 +   WS-D200-SRA-RETURNS-AMT (1)
043800                         END-COMPUTE
043900                     WHEN OTHER
044000                         COMPUTE WS-D200-ROLLING-SEARCH-AMT
044100                                 =   WS-D200-SRA-SALES-AMT (1)
044200                                 -   WS-D200-SRA-RETURNS-AMT (1)
044300                         END-COMPUTE
044400                 END-EVALUATE
044500             WHEN OTHER
044600                 EVALUATE TRUE
044700                     WHEN MMMM-PFB-GROSS-SALES
044800                         COMPUTE WS-D200-ROLLING-SEARCH-AMT
044900                                 =   0
045000                                 +   WS-D200-SRA-SALES-AMT (1)
045100                         END-COMPUTE
045200                     WHEN MMMM-PFB-GROSS-VOLUME
045300                         COMPUTE WS-D200-ROLLING-SEARCH-AMT
045400                                 =   WS-D200-SRA-SALES-AMT (1)
045500                                 +   WS-D200-SRA-RETURNS-AMT (1)
045600                         END-COMPUTE
045700                     WHEN OTHER
045800                         COMPUTE WS-D200-ROLLING-SEARCH-AMT
045900                                 =   WS-D200-SRA-SALES-AMT (1)
046000                                 -   WS-D200-SRA-RETURNS-AMT (1)
046100                         END-COMPUTE
046200                 END-EVALUATE
046300         END-EVALUATE
046400     END-IF.
046500*
046600*
046700*
046800     IF  MMRTWS-ROLLING-3-MON-VOL
046900         MOVE 3                  TO WS-D200-ROLLING-DENOMINATOR
047000         EVALUATE TRUE
047100             WHEN MMMM-PL-PRODUCT
047200                 EVALUATE TRUE
047300                     WHEN MMMP-PPFB-GROSS-SALES
047400                         COMPUTE WS-D200-ROLLING-SEARCH-AMT
047500                                 =   WS-D200-SRA-SALES-AMT (1)
047600                                 +   WS-D200-SRA-SALES-AMT (2)
047700                                 +   WS-D200-SRA-SALES-AMT (3)
047800                         END-COMPUTE
047900                     WHEN MMMP-PPFB-GROSS-VOLUME
048000                         COMPUTE WS-D200-ROLLING-SEARCH-AMT
048100                                 =   WS-D200-SRA-SALES-AMT (1)
048200                                 +   WS-D200-SRA-SALES-AMT (2)
048300                                 +   WS-D200-SRA-SALES-AMT (3)
048400                                 +   WS-D200-SRA-RETURNS-AMT (1)
048500                                 +   WS-D200-SRA-RETURNS-AMT (2)
048600                                 +   WS-D200-SRA-RETURNS-AMT (3)
048700                         END-COMPUTE
048800                     WHEN OTHER
048900                         COMPUTE WS-D200-ROLLING-SEARCH-AMT
049000                                 =   WS-D200-SRA-SALES-AMT (1)
049100                                 +   WS-D200-SRA-SALES-AMT (2)
049200                                 +   WS-D200-SRA-SALES-AMT (3)
049300                                 -   WS-D200-SRA-RETURNS-AMT (1)
049400                                 -   WS-D200-SRA-RETURNS-AMT (2)
049500                                 -   WS-D200-SRA-RETURNS-AMT (3)
049600                         END-COMPUTE
049700                 END-EVALUATE
049800             WHEN OTHER
049900                 EVALUATE TRUE
050000                     WHEN MMMM-PFB-GROSS-SALES
050100                         COMPUTE WS-D200-ROLLING-SEARCH-AMT
050200                                 =   WS-D200-SRA-SALES-AMT (1)
050300                                 +   WS-D200-SRA-SALES-AMT (2)
050400                                 +   WS-D200-SRA-SALES-AMT (3)
050500                         END-COMPUTE
050600                     WHEN MMMM-PFB-GROSS-VOLUME
050700                         COMPUTE WS-D200-ROLLING-SEARCH-AMT
050800                                 =   WS-D200-SRA-SALES-AMT (1)
050900                                 +   WS-D200-SRA-SALES-AMT (2)
051000                                 +   WS-D200-SRA-SALES-AMT (3)
051100                                 +   WS-D200-SRA-RETURNS-AMT (1)
051200                                 +   WS-D200-SRA-RETURNS-AMT (2)
051300                                 +   WS-D200-SRA-RETURNS-AMT (3)
051400                         END-COMPUTE
051500                     WHEN OTHER
051600                         COMPUTE WS-D200-ROLLING-SEARCH-AMT
051700                                 =   WS-D200-SRA-SALES-AMT (1)
051800                                 +   WS-D200-SRA-SALES-AMT (2)
051900                                 +   WS-D200-SRA-SALES-AMT (3)
052000                                 -   WS-D200-SRA-RETURNS-AMT (1)
052100                                 -   WS-D200-SRA-RETURNS-AMT (2)
052200                                 -   WS-D200-SRA-RETURNS-AMT (3)
052300                         END-COMPUTE
052400                 END-EVALUATE
052500         END-EVALUATE
052600         COMPUTE WS-D200-ROLLING-SEARCH-AMT ROUNDED
052700                                 =  WS-D200-ROLLING-SEARCH-AMT
052800                                 /  WS-D200-ROLLING-DENOMINATOR
052900         END-COMPUTE
053000     END-IF.
053100*
053200*
053300*
053400     IF  MMRTWS-ROLLING-6-MON-VOL
053500         MOVE 6                  TO WS-D200-ROLLING-DENOMINATOR
053600         EVALUATE TRUE
053700             WHEN MMMM-PL-PRODUCT
053800                 EVALUATE TRUE
053900                     WHEN MMMP-PPFB-GROSS-SALES
054000                         COMPUTE WS-D200-ROLLING-SEARCH-AMT
054100                                 =   WS-D200-SRA-SALES-AMT (1)
054200                                 +   WS-D200-SRA-SALES-AMT (2)
054300                                 +   WS-D200-SRA-SALES-AMT (3)
054400                                 +   WS-D200-SRA-SALES-AMT (4)
054500                                 +   WS-D200-SRA-SALES-AMT (5)
054600                                 +   WS-D200-SRA-SALES-AMT (6)
054700                         END-COMPUTE
054800                     WHEN MMMP-PPFB-GROSS-VOLUME
054900                         COMPUTE WS-D200-ROLLING-SEARCH-AMT
055000                                 =   WS-D200-SRA-SALES-AMT (1)
055100                                 +   WS-D200-SRA-SALES-AMT (2)
055200                                 +   WS-D200-SRA-SALES-AMT (3)
055300                                 +   WS-D200-SRA-SALES-AMT (4)
055400                                 +   WS-D200-SRA-SALES-AMT (5)
055500                                 +   WS-D200-SRA-SALES-AMT (6)
055600                                 +   WS-D200-SRA-RETURNS-AMT (1)
055700                                 +   WS-D200-SRA-RETURNS-AMT (2)
055800                                 +   WS-D200-SRA-RETURNS-AMT (3)
055900                                 +   WS-D200-SRA-RETURNS-AMT (4)
056000                                 +   WS-D200-SRA-RETURNS-AMT (5)
056100                                 +   WS-D200-SRA-RETURNS-AMT (6)
056200                         END-COMPUTE
056300                     WHEN OTHER
056400                         COMPUTE WS-D200-ROLLING-SEARCH-AMT
056500                                 =   WS-D200-SRA-SALES-AMT (1)
056600                                 +   WS-D200-SRA-SALES-AMT (2)
056700                                 +   WS-D200-SRA-SALES-AMT (3)
056800                                 +   WS-D200-SRA-SALES-AMT (4)
056900                                 +   WS-D200-SRA-SALES-AMT (5)
057000                                 +   WS-D200-SRA-SALES-AMT (6)
057100                                 -   WS-D200-SRA-RETURNS-AMT (1)
057200                                 -   WS-D200-SRA-RETURNS-AMT (2)
057300                                 -   WS-D200-SRA-RETURNS-AMT (3)
057400                                 -   WS-D200-SRA-RETURNS-AMT (4)
057500                                 -   WS-D200-SRA-RETURNS-AMT (5)
057600                                 -   WS-D200-SRA-RETURNS-AMT (6)
057700                         END-COMPUTE
057800                 END-EVALUATE
057900             WHEN OTHER
058000                 EVALUATE TRUE
058100                     WHEN MMMM-PFB-GROSS-SALES
058200                         COMPUTE WS-D200-ROLLING-SEARCH-AMT
058300                                 =   WS-D200-SRA-SALES-AMT (1)
058400                                 +   WS-D200-SRA-SALES-AMT (2)
058500                                 +   WS-D200-SRA-SALES-AMT (3)
058600                                 +   WS-D200-SRA-SALES-AMT (4)
058700                                 +   WS-D200-SRA-SALES-AMT (5)
058800                                 +   WS-D200-SRA-SALES-AMT (6)
058900                         END-COMPUTE
059000                     WHEN MMMM-PFB-GROSS-VOLUME
059100                         COMPUTE WS-D200-ROLLING-SEARCH-AMT
059200                                 =   WS-D200-SRA-SALES-AMT (1)
059300                                 +   WS-D200-SRA-SALES-AMT (2)
059400                                 +   WS-D200-SRA-SALES-AMT (3)
059500                                 +   WS-D200-SRA-SALES-AMT (4)
059600                                 +   WS-D200-SRA-SALES-AMT (5)
059700                                 +   WS-D200-SRA-SALES-AMT (6)
059800                                 +   WS-D200-SRA-RETURNS-AMT (1)
059900                                 +   WS-D200-SRA-RETURNS-AMT (2)
060000                                 +   WS-D200-SRA-RETURNS-AMT (3)
060100                                 +   WS-D200-SRA-RETURNS-AMT (4)
060200                                 +   WS-D200-SRA-RETURNS-AMT (5)
060300                                 +   WS-D200-SRA-RETURNS-AMT (6)
060400                         END-COMPUTE
060500                     WHEN OTHER
060600                         COMPUTE WS-D200-ROLLING-SEARCH-AMT
060700                                 =   WS-D200-SRA-SALES-AMT (1)
060800                                 +   WS-D200-SRA-SALES-AMT (2)
060900                                 +   WS-D200-SRA-SALES-AMT (3)
061000                                 +   WS-D200-SRA-SALES-AMT (4)
061100                                 +   WS-D200-SRA-SALES-AMT (5)
061200                                 +   WS-D200-SRA-SALES-AMT (6)
061300                                 -   WS-D200-SRA-RETURNS-AMT (1)
061400                                 -   WS-D200-SRA-RETURNS-AMT (2)
061500                                 -   WS-D200-SRA-RETURNS-AMT (3)
061600                                 -   WS-D200-SRA-RETURNS-AMT (4)
061700                                 -   WS-D200-SRA-RETURNS-AMT (5)
061800                                 -   WS-D200-SRA-RETURNS-AMT (6)
061900                         END-COMPUTE
062000                 END-EVALUATE
062100         END-EVALUATE
062200         COMPUTE WS-D200-ROLLING-SEARCH-AMT ROUNDED
062300                                 =  WS-D200-ROLLING-SEARCH-AMT
062400                                 /  WS-D200-ROLLING-DENOMINATOR
062500         END-COMPUTE
062600     END-IF.
062700*
062800*
062900*
063000     IF  MMRTWS-ROLLING-12-MON-VOL
063100         MOVE 12                 TO WS-D200-ROLLING-DENOMINATOR
063200         EVALUATE TRUE
063300             WHEN MMMM-PL-PRODUCT
063400                 EVALUATE TRUE
063500                     WHEN MMMP-PPFB-GROSS-SALES
063600                         COMPUTE WS-D200-ROLLING-SEARCH-AMT
063700                                 =   WS-D200-SRA-SALES-AMT (1)
063800                                 +   WS-D200-SRA-SALES-AMT (2)
063900                                 +   WS-D200-SRA-SALES-AMT (3)
064000                                 +   WS-D200-SRA-SALES-AMT (4)
064100                                 +   WS-D200-SRA-SALES-AMT (5)
064200                                 +   WS-D200-SRA-SALES-AMT (6)
064300                                 +   WS-D200-SRA-SALES-AMT (7)
064400                                 +   WS-D200-SRA-SALES-AMT (8)
064500                                 +   WS-D200-SRA-SALES-AMT (9)
064600                                 +   WS-D200-SRA-SALES-AMT (10)
064700                                 +   WS-D200-SRA-SALES-AMT (11)
064800                                 +   WS-D200-SRA-SALES-AMT (12)
064900                         END-COMPUTE
065000                     WHEN MMMP-PPFB-GROSS-VOLUME
065100                         COMPUTE WS-D200-ROLLING-SEARCH-AMT
065200                                 =   WS-D200-SRA-SALES-AMT (1)
065300                                 +   WS-D200-SRA-SALES-AMT (2)
065400                                 +   WS-D200-SRA-SALES-AMT (3)
065500                                 +   WS-D200-SRA-SALES-AMT (4)
065600                                 +   WS-D200-SRA-SALES-AMT (5)
065700                                 +   WS-D200-SRA-SALES-AMT (6)
065800                                 +   WS-D200-SRA-SALES-AMT (7)
065900                                 +   WS-D200-SRA-SALES-AMT (8)
066000                                 +   WS-D200-SRA-SALES-AMT (9)
066100                                 +   WS-D200-SRA-SALES-AMT (10)
066200                                 +   WS-D200-SRA-SALES-AMT (11)
066300                                 +   WS-D200-SRA-SALES-AMT (12)
066400                                 +   WS-D200-SRA-RETURNS-AMT (1)
066500                                 +   WS-D200-SRA-RETURNS-AMT (2)
066600                                 +   WS-D200-SRA-RETURNS-AMT (3)
066700                                 +   WS-D200-SRA-RETURNS-AMT (4)
066800                                 +   WS-D200-SRA-RETURNS-AMT (5)
066900                                 +   WS-D200-SRA-RETURNS-AMT (6)
067000                                 +   WS-D200-SRA-RETURNS-AMT (7)
067100                                 +   WS-D200-SRA-RETURNS-AMT (8)
067200                                 +   WS-D200-SRA-RETURNS-AMT (9)
067300                                 +   WS-D200-SRA-RETURNS-AMT (10)
067400                                 +   WS-D200-SRA-RETURNS-AMT (11)
067500                                 +   WS-D200-SRA-RETURNS-AMT (12)
067600                         END-COMPUTE
067700                     WHEN OTHER
067800                         COMPUTE WS-D200-ROLLING-SEARCH-AMT
067900                                 =   WS-D200-SRA-SALES-AMT (1)
068000                                 +   WS-D200-SRA-SALES-AMT (2)
068100                                 +   WS-D200-SRA-SALES-AMT (3)
068200                                 +   WS-D200-SRA-SALES-AMT (4)
068300                                 +   WS-D200-SRA-SALES-AMT (5)
068400                                 +   WS-D200-SRA-SALES-AMT (6)
068500                                 +   WS-D200-SRA-SALES-AMT (7)
068600                                 +   WS-D200-SRA-SALES-AMT (8)
068700                                 +   WS-D200-SRA-SALES-AMT (9)
068800                                 +   WS-D200-SRA-SALES-AMT (10)
068900                                 +   WS-D200-SRA-SALES-AMT (11)
069000                                 +   WS-D200-SRA-SALES-AMT (12)
069100                                 -   WS-D200-SRA-RETURNS-AMT (1)
069200                                 -   WS-D200-SRA-RETURNS-AMT (2)
069300                                 -   WS-D200-SRA-RETURNS-AMT (3)
069400                                 -   WS-D200-SRA-RETURNS-AMT (4)
069500                                 -   WS-D200-SRA-RETURNS-AMT (5)
069600                                 -   WS-D200-SRA-RETURNS-AMT (6)
069700                                 -   WS-D200-SRA-RETURNS-AMT (7)
069800                                 -   WS-D200-SRA-RETURNS-AMT (8)
069900                                 -   WS-D200-SRA-RETURNS-AMT (9)
070000                                 -   WS-D200-SRA-RETURNS-AMT (10)
070100                                 -   WS-D200-SRA-RETURNS-AMT (11)
070200                                 -   WS-D200-SRA-RETURNS-AMT (12)
070300                         END-COMPUTE
070400                 END-EVALUATE
070500             WHEN OTHER
070600                 EVALUATE TRUE
070700                     WHEN MMMM-PFB-GROSS-SALES
070800                         COMPUTE WS-D200-ROLLING-SEARCH-AMT
070900                                 =   WS-D200-SRA-SALES-AMT (1)
071000                                 +   WS-D200-SRA-SALES-AMT (2)
071100                                 +   WS-D200-SRA-SALES-AMT (3)
071200                                 +   WS-D200-SRA-SALES-AMT (4)
071300                                 +   WS-D200-SRA-SALES-AMT (5)
071400                                 +   WS-D200-SRA-SALES-AMT (6)
071500                                 +   WS-D200-SRA-SALES-AMT (7)
071600                                 +   WS-D200-SRA-SALES-AMT (8)
071700                                 +   WS-D200-SRA-SALES-AMT (9)
071800                                 +   WS-D200-SRA-SALES-AMT (10)
071900                                 +   WS-D200-SRA-SALES-AMT (11)
072000                                 +   WS-D200-SRA-SALES-AMT (12)
072100                         END-COMPUTE
072200                     WHEN MMMM-PFB-GROSS-VOLUME
072300                         COMPUTE WS-D200-ROLLING-SEARCH-AMT
072400                                 =   WS-D200-SRA-SALES-AMT (1)
072500                                 +   WS-D200-SRA-SALES-AMT (2)
072600                                 +   WS-D200-SRA-SALES-AMT (3)
072700                                 +   WS-D200-SRA-SALES-AMT (4)
072800                                 +   WS-D200-SRA-SALES-AMT (5)
072900                                 +   WS-D200-SRA-SALES-AMT (6)
073000                                 +   WS-D200-SRA-SALES-AMT (7)
073100                                 +   WS-D200-SRA-SALES-AMT (8)
073200                                 +   WS-D200-SRA-SALES-AMT (9)
073300                                 +   WS-D200-SRA-SALES-AMT (10)
073400                                 +   WS-D200-SRA-SALES-AMT (11)
073500                                 +   WS-D200-SRA-SALES-AMT (12)
073600                                 +   WS-D200-SRA-RETURNS-AMT (1)
073700                                 +   WS-D200-SRA-RETURNS-AMT (2)
073800                                 +   WS-D200-SRA-RETURNS-AMT (3)
073900                                 +   WS-D200-SRA-RETURNS-AMT (4)
074000                                 +   WS-D200-SRA-RETURNS-AMT (5)
074100                                 +   WS-D200-SRA-RETURNS-AMT (6)
074200                                 +   WS-D200-SRA-RETURNS-AMT (7)
074300                                 +   WS-D200-SRA-RETURNS-AMT (8)
074400                                 +   WS-D200-SRA-RETURNS-AMT (9)
074500                                 +   WS-D200-SRA-RETURNS-AMT (10)
074600                                 +   WS-D200-SRA-RETURNS-AMT (11)
074700                                 +   WS-D200-SRA-RETURNS-AMT (12)
074800                         END-COMPUTE
074900                     WHEN OTHER
075000                         COMPUTE WS-D200-ROLLING-SEARCH-AMT
075100                                 =   WS-D200-SRA-SALES-AMT (1)
075200                                 +   WS-D200-SRA-SALES-AMT (2)
075300                                 +   WS-D200-SRA-SALES-AMT (3)
075400                                 +   WS-D200-SRA-SALES-AMT (4)
075500                                 +   WS-D200-SRA-SALES-AMT (5)
075600                                 +   WS-D200-SRA-SALES-AMT (6)
075700                                 +   WS-D200-SRA-SALES-AMT (7)
075800                                 +   WS-D200-SRA-SALES-AMT (8)
075900                                 +   WS-D200-SRA-SALES-AMT (9)
076000                                 +   WS-D200-SRA-SALES-AMT (10)
076100                                 +   WS-D200-SRA-SALES-AMT (11)
076200                                 +   WS-D200-SRA-SALES-AMT (12)
076300                                 -   WS-D200-SRA-RETURNS-AMT (1)
076400                                 -   WS-D200-SRA-RETURNS-AMT (2)
076500                                 -   WS-D200-SRA-RETURNS-AMT (3)
076600                                 -   WS-D200-SRA-RETURNS-AMT (4)
076700                                 -   WS-D200-SRA-RETURNS-AMT (5)
076800                                 -   WS-D200-SRA-RETURNS-AMT (6)
076900                                 -   WS-D200-SRA-RETURNS-AMT (7)
077000                                 -   WS-D200-SRA-RETURNS-AMT (8)
077100                                 -   WS-D200-SRA-RETURNS-AMT (9)
077200                                 -   WS-D200-SRA-RETURNS-AMT (10)
077300                                 -   WS-D200-SRA-RETURNS-AMT (11)
077400                                 -   WS-D200-SRA-RETURNS-AMT (12)
077500                         END-COMPUTE
077600                 END-EVALUATE
077700         END-EVALUATE
077800         COMPUTE WS-D200-ROLLING-SEARCH-AMT ROUNDED
077900                                 =  WS-D200-ROLLING-SEARCH-AMT
078000                                 /  WS-D200-ROLLING-DENOMINATOR
078100         END-COMPUTE
078200     END-IF.
078300*
078400*
078500*
078600     EVALUATE TRUE
078700         WHEN (MMRTWS-CTD-NUMBER-INC
078800           OR  MMRTWS-CTD-VOLUME-INC)
078900             MOVE WS-D200-SRA-AVG-TKT (16)
079000                                 TO MBD200WS-PA-AVG-TKT-AMT
079100         WHEN (MMRTWS-MTD-NUMBER-INC
079200           OR  MMRTWS-MTD-VOLUME-INC
079300           OR  MMRTWS-MTD-TIERED-INCOME)
079400             MOVE WS-D200-SRA-AVG-TKT (14)
079500                                 TO MBD200WS-PA-AVG-TKT-AMT
079600         WHEN (MMRTWS-ROLLING-1-MON-AVG-TKT
079700           OR  MMRTWS-ROLLING-3-MON-AVG-TKT
079800           OR  MMRTWS-ROLLING-6-MON-AVG-TKT
079900           OR  MMRTWS-ROLLING-12-MON-AVG-TKT)
080000             MOVE WS-D200-ROLLING-SEARCH-AMT
080100                                 TO MBD200WS-PA-AVG-TKT-AMT
080200         WHEN OTHER
080300             MOVE WS-D200-SRA-AVG-TKT (17)
080400                                 TO MBD200WS-PA-AVG-TKT-AMT
080500     END-EVALUATE.
080600*
080700*
080800*
080900     IF  MMRTWS-VALID-METH-ON-NUMBER
081000         SET X-MMRT-PRIM         TO 1
081100         SEARCH MMRT-PRIMARY-RATES-TABLE VARYING X-MMRT-PRIM
081200             AT END
081300                 SET X-MMRT-PRIM TO 1
081400             WHEN MBD200WS-PA-NBR-PREV-TODAY IS NOT GREATER THAN
081500                                 MMRT-PRIM-LIMIT-NBR (X-MMRT-PRIM)
081600                 SET X-MBD200WS-PA-TIER
081700                                 TO X-MMRT-PRIM
081800                 MOVE MBD200WS-PA-NBR-SUBJECT-TIERS
081900                                 TO MBD200WS-PA-TIER-NBR-SUBJECT
082000                                    (X-MBD200WS-PA-TIER)
082100         END-SEARCH
082200     ELSE
082300         SET X-MMRT-PRIM         TO 1
082400         SEARCH MMRT-PRIMARY-RATES-TABLE VARYING X-MMRT-PRIM
082500             AT END
082600                 SET X-MMRT-PRIM TO 1
082700             WHEN WS-D200-ROLLING-SEARCH-AMT IS NOT GREATER THAN
082800                                 MMRT-PRIM-LIMIT (X-MMRT-PRIM)
082900                 SET X-MBD200WS-PA-TIER
083000                                 TO X-MMRT-PRIM
083100                 MOVE MBD200WS-PA-AMT-SUBJECT-TIERS
083200                                 TO MBD200WS-PA-TIER-AMT-SUBJECT
083300                                    (X-MBD200WS-PA-TIER)
083400         END-SEARCH
083500     END-IF.
083600*
083700     PERFORM C800-COMPUTE-PART-IN-TIER
083800        THRU C899-CPIT-EXIT
083900        VARYING X-MBD200WS-PA-TIER FROM 1 BY 1
084000          UNTIL X-MBD200WS-PA-TIER IS GREATER THAN 10.
084100*
084200 C599-AC-EXIT.
084300     EXIT.
084400/
084500 C800-COMPUTE-PART-IN-TIER SECTION.
084600 C810-CPIT-BEGIN.
084700*
084800     SET X-MMRT-PRIM             TO X-MBD200WS-PA-TIER.
084900*
085000     EVALUATE TRUE
085100         WHEN MMRTWS-VALID-METH-ON-NUMBER
085200         MOVE MMOC-PER-ITEM-NOD  TO SS50WS-MULTIPLIER-NOD
085300         MOVE ZERO               TO SS50WS-MULTIPLICAND-NOD
085400         MOVE MBD200WS-PA-TIER-NBR-SUBJECT (X-MBD200WS-PA-TIER)
085500                                 TO SS50WS-MULTIPLICAND
085600         MOVE MMRT-PRIM-PER-ITEM (X-MMRT-PRIM)
085700                                 TO SS50WS-MULTIPLIER-PER-ITEM
085800         PERFORM SS50PD-MULTIPLY
085900                                 THRU SS50PD-M-EXIT
086000         MOVE SS50WS-PRODUCT
086100                                 TO MBD200WS-PA-TIER-TOTAL-PART
086200                                    (X-MBD200WS-PA-TIER)
086300*
086400***          COMPUTE MBD200WS-PA-TIER-TOTAL-PART
086500***                  (X-MBD200WS-PA-TIER)
086600***                      ROUNDED =  MBD200WS-PA-TIER-NBR-SUBJECT
086700***                                 (X-MBD200WS-PA-TIER)
086800***                              *  MMRT-PRIM-PER-ITEM
086900***                                 (X-MMRT-PRIM)
087000***          END-COMPUTE
087100         WHEN OTHER
087200         MOVE MMOC-PERCENT-NOD   TO SS50WS-MULTIPLIER-NOD
087300         SET SS50WS-MULTIPLICAND-BY-CC
087400                                 TO TRUE
087500         MOVE MBD200WS-PA-TIER-AMT-SUBJECT (X-MBD200WS-PA-TIER)
087600                                 TO SS50WS-MULTIPLICAND
087700         MOVE MMRT-PRIM-RATE (X-MMRT-PRIM)
087800                                 TO SS50WS-MULTIPLIER-PERCENT
087900         PERFORM SS50PD-MULTIPLY
088000                                 THRU SS50PD-M-EXIT
088100         MOVE SS50WS-PRODUCT
088200                                 TO MBD200WS-PA-TIER-TOTAL-PART
088300                                    (X-MBD200WS-PA-TIER)
088400*
088500***          COMPUTE MBD200WS-PA-TIER-TOTAL-PART
088600***                  (X-MBD200WS-PA-TIER)
088700***                      ROUNDED =  MBD200WS-PA-TIER-AMT-SUBJECT
088800***                                 (X-MBD200WS-PA-TIER)
088900***                              *  MMRT-PRIM-RATE
089000***                                 (X-MMRT-PRIM)
089100***          END-COMPUTE
089200     END-EVALUATE.
089300*
089400 C899-CPIT-EXIT.
089500     EXIT.
089600/
089700 C900-FINAL-PART-TOTAL SECTION.
089800 C901-FPT-BEGIN.
089900*
090000     COMPUTE MBD200WS-PA-PART-TIER
090100                                 = MBD200WS-PA-TIER-TOTAL-PART (1)
090200                                 + MBD200WS-PA-TIER-TOTAL-PART (2)
090300                                 + MBD200WS-PA-TIER-TOTAL-PART (3)
090400                                 + MBD200WS-PA-TIER-TOTAL-PART (4)
090500                                 + MBD200WS-PA-TIER-TOTAL-PART (5)
090600                                 + MBD200WS-PA-TIER-TOTAL-PART (6)
090700                                 + MBD200WS-PA-TIER-TOTAL-PART (7)
090800                                 + MBD200WS-PA-TIER-TOTAL-PART (8)
090900                                 + MBD200WS-PA-TIER-TOTAL-PART (9)
091000                                 + MBD200WS-PA-TIER-TOTAL-PART
091100                                                             (10).
091200*
091300     COMPUTE MBD200WS-PA-PART-TOTAL
091400                                 =  MBD200WS-PA-PART-TIER
091500                                 +  MBD200WS-PA-PART-AVG-TKT
091600                                 +  MBD200WS-PA-PART-PLAN-ADJ
091700                                 +  MBD200WS-PA-PART-PLAN-OVRD
091800                                 +  MBD200WS-PA-PART-TRANS-ADJ
091900                                 +  MBD200WS-PA-PART-TRANS-OVRD
092000                                 +  MBD200WS-PA-PART-MANUAL.
092100*
092200 C999-FPT-EXIT.
092300     EXIT.
092400/
092500 D000-LOAD-PART-W-TODAY SECTION.
092600 D001-LPWT-BEGIN.
092700*
092800     SET X-MBD200WS-PA-TIER      TO X-MMRT-PRIM.
092900*
093000     EVALUATE TRUE
093100         WHEN MMRTWS-VALID-METH-ON-NUMBER
093200             PERFORM D100-LOAD-TIER-TODAY-NUMBERS
093300                THRU D199-LTTN-EXIT
093400         WHEN OTHER
093500             PERFORM D500-LOAD-TIER-TODAY-AMOUNTS
093600                THRU D599-LTTA-EXIT
093700     END-EVALUATE.
093800*
093900 D099-LPWT-EXIT.
094000     EXIT.
094100/
094200 D100-LOAD-TIER-TODAY-NUMBERS SECTION.
094300 D101-LTTN-BEGIN.
094400*
094500     IF  MBD200WS-PA-TIER-NBR-PREV (X-MBD200WS-PA-TIER)
094600                                 IS LESS THAN ZERO
094700         MOVE MBD200WS-PA-TIER-NBR-ALLOWED (X-MBD200WS-PA-TIER)
094800                                 TO MBD200WS-PA-WORK-NBR-4
094900     ELSE
095000         COMPUTE MBD200WS-PA-WORK-NBR-4
095100                                 =  MBD200WS-PA-TIER-NBR-ALLOWED
095200                                    (X-MBD200WS-PA-TIER)
095300                                 -  MBD200WS-PA-TIER-NBR-PREV
095400                                    (X-MBD200WS-PA-TIER).
095500*
095600     IF  MBD200WS-PA-WORK-NBR-1 IS NOT GREATER THAN
095700         MBD200WS-PA-WORK-NBR-4
095800         MOVE MBD200WS-PA-WORK-NBR-1
095900                                 TO MBD200WS-PA-TIER-NBR-TODAY
096000                                    (X-MBD200WS-PA-TIER)
096100         MOVE ZERO               TO MBD200WS-PA-WORK-NBR-1
096200     ELSE
096300         MOVE MBD200WS-PA-WORK-NBR-4
096400                                 TO MBD200WS-PA-TIER-NBR-TODAY
096500                                    (X-MBD200WS-PA-TIER)
096600         COMPUTE MBD200WS-PA-WORK-NBR-1
096700                                 =  MBD200WS-PA-WORK-NBR-1
096800                                 -  MBD200WS-PA-WORK-NBR-4.
096900*
097000     COMPUTE MBD200WS-PA-TIER-NBR-TOTAL (X-MBD200WS-PA-TIER)
097100                                 =  MBD200WS-PA-TIER-NBR-PREV
097200                                    (X-MBD200WS-PA-TIER)
097300                                 +  MBD200WS-PA-TIER-NBR-TODAY
097400                                    (X-MBD200WS-PA-TIER).
097500*
097600 D199-LTTN-EXIT.
097700     EXIT.
097800/
097900 D500-LOAD-TIER-TODAY-AMOUNTS SECTION.
098000 D501-LTTA-BEGIN.
098100*
098200     IF  MBD200WS-PA-TIER-AMT-PREV (X-MBD200WS-PA-TIER)
098300                                 IS LESS THAN ZERO
098400         MOVE MBD200WS-PA-TIER-AMT-ALLOWED (X-MBD200WS-PA-TIER)
098500                                 TO MBD200WS-PA-WORK-AMT-4
098600     ELSE
098700         COMPUTE MBD200WS-PA-WORK-AMT-4
098800                                 =  MBD200WS-PA-TIER-AMT-ALLOWED
098900                                    (X-MBD200WS-PA-TIER)
099000                                 -  MBD200WS-PA-TIER-AMT-PREV
099100                                    (X-MBD200WS-PA-TIER).
099200*
099300     IF  MBD200WS-PA-WORK-AMT-1 IS NOT GREATER THAN
099400         MBD200WS-PA-WORK-AMT-4
099500         MOVE MBD200WS-PA-WORK-AMT-1
099600                                 TO MBD200WS-PA-TIER-AMT-TODAY
099700                                    (X-MBD200WS-PA-TIER)
099800         MOVE ZERO               TO MBD200WS-PA-WORK-AMT-1
099900     ELSE
100000         MOVE MBD200WS-PA-WORK-AMT-4
100100                                 TO MBD200WS-PA-TIER-AMT-TODAY
100200                                    (X-MBD200WS-PA-TIER)
100300         COMPUTE MBD200WS-PA-WORK-AMT-1
100400                                 =  MBD200WS-PA-WORK-AMT-1
100500                                 -  MBD200WS-PA-WORK-AMT-4.
100600*
100700     COMPUTE MBD200WS-PA-TIER-AMT-TOTAL (X-MBD200WS-PA-TIER)
100800                                 =  MBD200WS-PA-TIER-AMT-PREV
100900                                    (X-MBD200WS-PA-TIER)
101000                                 +  MBD200WS-PA-TIER-AMT-TODAY
101100                                    (X-MBD200WS-PA-TIER).
101200*
101300 D599-LTTA-EXIT.
101400     EXIT.
101500/
101600 E000-PROCESS-TRANSACTION SECTION.
101700 E001-PT-BEGIN.
101800*
101900     SET MBD200WS-PA-OVERRIDE-NO TO TRUE.
102000     SET MBD200WS-PA-ADJUSTMENT-NO
102100                                 TO TRUE.
102200     MOVE ZERO                   TO MTPT-INDIV-PART-AMT.
102300     SET MTPT-INDIV-PART-CR      TO TRUE.
102400     MOVE ZERO                   TO MBD200WS-PA-ADJ-PART-AMT.
102500     SET MBD200WS-PA-APF-PART-CR
102600                                 TO TRUE.
102700     MOVE ZERO                   TO MBD200WS-PA-OVRD-PART-AMT.
102800     SET MBD200WS-PA-OPF-PART-CR
102900                                 TO TRUE.
103000*
103100     MOVE MTPT-LOGIC-MODULE      TO MMTCWS-LOGIC-MODULE.
103200*
103300     EVALUATE TRUE
103400         WHEN MMTCWS-LM-PART-CR
103500             SET  MBD200WS-PA-ACTIVITY
103600                                 TO TRUE
103700             ADD  MTPT-AMOUNT    TO MBD200WS-PA-PART-MANUAL
103800         WHEN MMTCWS-LM-PART-DR
103900             SET  MBD200WS-PA-ACTIVITY
104000                                 TO TRUE
104100             SUBTRACT MTPT-AMOUNT
104200                                 FROM MBD200WS-PA-PART-MANUAL
104300     END-EVALUATE.
104400*
104500     EVALUATE TRUE
104600         WHEN (MBD200WS-PA-PFB-GROSS-SALES
104700           AND MMTCWS-LM-RETURN)
104800             CONTINUE
104900         WHEN (MBD200WS-PA-PFB-GROSS-SALES
105000           AND MMTCWS-LM-RETURN-REV)
105100             CONTINUE
105200         WHEN MMTCWS-LM-PART-CR
105300             CONTINUE
105400         WHEN MMTCWS-LM-PART-DR
105500             CONTINUE
105600         WHEN MMMM-PF1-DAILY-PART
105700             PERFORM E100-TRANSACTION-LOGIC
105800                THRU E199-TL-EXIT
105900     END-EVALUATE.
106000*
106100     IF  MBD200WS-PA-ADJ-PART-AMT IS LESS THAN ZERO
106200         SET MBD200WS-PA-APF-PART-DR
106300                                 TO TRUE
106400     ELSE
106500         SET MBD200WS-PA-APF-PART-CR
106600                                 TO TRUE.
106700*
106800     IF  MBD200WS-PA-OVRD-PART-AMT IS LESS THAN ZERO
106900         SET MBD200WS-PA-OPF-PART-DR
107000                                 TO TRUE
107100     ELSE
107200         SET MBD200WS-PA-OPF-PART-CR
107300                                 TO TRUE.
107400*
107500 E099-PT-EXIT.
107600     EXIT.
107700/
107800 E100-TRANSACTION-LOGIC SECTION.
107900 E101-TL-BEGIN.
108000*
108100     IF  MMRT-EXCEPTION-TRAN-OVERRIDE (2)
108200     OR  MMRT-EXCEPTION-TRAN-OVERRIDE (3)
108300     OR  MMRT-EXCEPTION-TRAN-OVERRIDE (4)
108400     OR  MMRT-EXCEPTION-TRAN-OVERRIDE (5)
108500     OR  MMRT-EXCEPTION-TRAN-OVERRIDE (6)
108600     OR  MMRT-EXCEPTION-TRAN-OVERRIDE (7)
108700         PERFORM F000-TRAN-OVERRIDE-CHECK
108800            THRU F099-TOC-EXIT.
108900*
109000     IF  MMRT-EXCEPTION-IS-ADJUSTMENT (2)
109100     OR  MMRT-EXCEPTION-IS-ADJUSTMENT (3)
109200     OR  MMRT-EXCEPTION-IS-ADJUSTMENT (4)
109300     OR  MMRT-EXCEPTION-IS-ADJUSTMENT (5)
109400     OR  MMRT-EXCEPTION-IS-ADJUSTMENT (6)
109500     OR  MMRT-EXCEPTION-IS-ADJUSTMENT (7)
109600         PERFORM F500-ADJUSTMENT-CHECK
109700            THRU F599-AC-EXIT.
109800*
109900     IF  MMRTWS-INDIVIDUAL-TICKET
110000         EVALUATE TRUE
110100             WHEN MBD200WS-PA-OVERRIDE-YES
110200                 IF  MMTCWS-LM-SALE-REV
110300                 OR (MMTCWS-LM-RETURN
110400                 AND MBD200WS-PA-PFB-NET-SALES)
110500                 OR (MMTCWS-LM-RETURN-REV
110600                 AND MBD200WS-PA-PFB-GROSS-VOLUME)
110700                     SUBTRACT MTPT-AMOUNT
110800                               FROM MBD200WS-PA-AMT-PREV-TODAY
110900                     SUBTRACT MTPT-AMOUNT
111000                               FROM MBD200WS-PA-TIER-AMT-TODAY
111100                                    (X-MBD200WS-PA-TIER)
111200                 ELSE
111300                     ADD  MTPT-AMOUNT
111400                                 TO MBD200WS-PA-AMT-PREV-TODAY
111500                     ADD  MTPT-AMOUNT
111600                                 TO MBD200WS-PA-TIER-AMT-TODAY
111700                                    (X-MBD200WS-PA-TIER)
111800                 END-IF
111900             WHEN OTHER
112000                 PERFORM M000-INDIVIDUAL-TICKET
112100                    THRU M099-IT-EXIT
112200         END-EVALUATE.
112300*
112400 E199-TL-EXIT.
112500     EXIT.
112600/
112700 F000-TRAN-OVERRIDE-CHECK SECTION.
112800 F001-TOC-BEGIN.
112900*
113000     SET WS-D200-EF-OVERRIDE     TO TRUE.
113100*
113200     PERFORM
113300         VARYING WS-D200-EXCEPTION-PRIORITY-9 FROM 1 BY 1
113400         UNTIL   WS-D200-EXCEPTION-PRIORITY-9 IS GREATER THAN 6
113500         OR      MBD200WS-PA-OVERRIDE-YES
113600         SET X-MMRT-EXCEPTION    TO 2
113700         SEARCH MMRT-EXCEPTION VARYING X-MMRT-EXCEPTION
113800             AT END
113900                 SET X-MMRT-EXCEPTION TO 2
114000             WHEN MMRT-EXCEPTION-PRIORITY (X-MMRT-EXCEPTION)
114100                                 IS EQUAL TO
114200                                 WS-D200-EXCEPTION-PRIORITY
114300                 PERFORM F100-OVERRIDE-EXCEPTION
114400                    THRU F199-OE-EXIT
114500         END-SEARCH
114600     END-PERFORM.
114700*
114800 F099-TOC-EXIT.
114900     EXIT.
115000/
115100 F100-OVERRIDE-EXCEPTION SECTION.
115200 F101-OE-BEGIN.
115300*
115400     MOVE ZERO                   TO WS-D200-RATE-PCT.
115500*
115600     EVALUATE TRUE
115700         WHEN X-MMRT-EXCEPTION IS EQUAL TO 2
115800             EVALUATE TRUE
115900                 WHEN MMRTWS-PTD-VOLUME-W-CR-PLAN
116000                     CONTINUE
116100                 WHEN OTHER
116200                     PERFORM G000-PLAN-EXCEPTION-CHECK
116300                        THRU G099-PEC-EXIT
116400             END-EVALUATE
116500         WHEN X-MMRT-EXCEPTION IS EQUAL TO 3
116600             PERFORM H000-SING-TKT-EXCEPTION-CHECK
116700                THRU H099-STEC-EXIT
116800         WHEN X-MMRT-EXCEPTION IS EQUAL TO 4
116900             PERFORM I000-STATE-EXCEPTION-CHECK
117000                THRU I099-SEC-EXIT
117100         WHEN X-MMRT-EXCEPTION IS EQUAL TO 5
117200             PERFORM J000-LOGO-EXCEPTION-CHECK
117300                THRU J099-LEC-EXIT
117400         WHEN X-MMRT-EXCEPTION IS EQUAL TO 6
117500             PERFORM K000-DEPT-EXCEPTION-CHECK
117600                THRU K099-DEC-EXIT
117700         WHEN X-MMRT-EXCEPTION IS EQUAL TO 7
117800             PERFORM L000-SKU-EXCEPTION-CHECK
117900                THRU L099-SEC-EXIT
118000     END-EVALUATE.
118100*
118200     IF  MBD200WS-PA-OVERRIDE-YES
118300         EVALUATE TRUE
118400             WHEN MMRTWS-VALID-METH-ON-NUMBER
118500                 SET MTPT-IPI-IS-PER-ITEM
118600                                 TO TRUE
118700*
118800                 MOVE MMOC-PER-ITEM-NOD
118900                                 TO SS50WS-MULTIPLIER-NOD
119000                 MOVE ZERO
119100                                 TO SS50WS-MULTIPLICAND-NOD
119200                 MOVE MTPT-NBR-ITEMS
119300                                 TO SS50WS-MULTIPLICAND
119400                 MOVE WS-D200-RATE-PER-ITEM
119500                                 TO SS50WS-MULTIPLIER-PER-ITEM
119600                 PERFORM SS50PD-MULTIPLY
119700                                 THRU SS50PD-M-EXIT
119800                 MOVE SS50WS-PRODUCT
119900                                 TO MBD200WS-PA-WORK-AMT-2
120000*
120100***              COMPUTE MBD200WS-PA-WORK-AMT-2 ROUNDED
120200***                              =  WS-D200-RATE-PER-ITEM
120300***                              *  MTPT-NBR-ITEMS
120400***              END-COMPUTE
120500                 IF  MMTCWS-LM-SALE-REV
120600                 OR (MMTCWS-LM-RETURN
120700                 AND MBD200WS-PA-PFB-NET-SALES)
120800                 OR (MMTCWS-LM-RETURN-REV
120900                 AND MBD200WS-PA-PFB-GROSS-VOLUME)
121000                     COMPUTE MBD200WS-PA-WORK-AMT-2
121100                                 =  0 - MBD200WS-PA-WORK-AMT-2
121200                     END-COMPUTE
121300                 END-IF
121400                 ADD  MBD200WS-PA-WORK-AMT-2
121500                                 TO MTPT-INDIV-PART-AMT
121600                 ADD  MBD200WS-PA-WORK-AMT-2
121700                                 TO MBD200WS-PA-OVRD-PART-AMT
121800                 ADD  WS-D200-RATE-PER-ITEM
121900                                 TO MTPT-INDIV-PART-PER-ITEM
122000                 PERFORM Z200-SET-TRANS-INDIV-PART-FLAG
122100                    THRU Z299-STIPF-EXIT
122200                 ADD  MBD200WS-PA-WORK-AMT-2
122300                                 TO MBD200WS-PA-PART-TRANS-OVRD
122400                 IF  MMTCWS-LM-SALE-REV
122500                 OR (MMTCWS-LM-RETURN
122600                 AND MBD200WS-PA-PFB-NET-SALES)
122700                 OR (MMTCWS-LM-RETURN-REV
122800                 AND MBD200WS-PA-PFB-GROSS-VOLUME)
122900                     SUBTRACT MTPT-NBR-ITEMS
123000                               FROM MBD200WS-PA-NBR-OVERRIDE
123100                 ELSE
123200                     ADD  MTPT-NBR-ITEMS
123300                                 TO MBD200WS-PA-NBR-OVERRIDE
123400                 END-IF
123500             WHEN OTHER
123600                 SET MTPT-IPI-IS-RATE
123700                                 TO TRUE
123800*
123900             MOVE MMOC-PERCENT-NOD
124000                                 TO SS50WS-MULTIPLIER-NOD
124100             SET SS50WS-MULTIPLICAND-BY-CC
124200                                 TO TRUE
124300             MOVE MTPT-AMOUNT
124400                                 TO SS50WS-MULTIPLICAND
124500             MOVE WS-D200-RATE-PCT
124600                                 TO SS50WS-MULTIPLIER-PERCENT
124700             PERFORM SS50PD-MULTIPLY
124800                                 THRU SS50PD-M-EXIT
124900             MOVE SS50WS-PRODUCT TO MBD200WS-PA-WORK-AMT-2
125000*
125100***              COMPUTE MBD200WS-PA-WORK-AMT-2 ROUNDED
125200***                              =  WS-D200-RATE-PCT
125300***                              *  MTPT-AMOUNT
125400***              END-COMPUTE
125500                 IF  MMTCWS-LM-SALE-REV
125600                 OR (MMTCWS-LM-RETURN
125700                 AND MBD200WS-PA-PFB-NET-SALES)
125800                 OR (MMTCWS-LM-RETURN-REV
125900                 AND MBD200WS-PA-PFB-GROSS-VOLUME)
126000                     COMPUTE MBD200WS-PA-WORK-AMT-2
126100                                 =  0 - MBD200WS-PA-WORK-AMT-2
126200                     END-COMPUTE
126300                 END-IF
126400                 ADD  MBD200WS-PA-WORK-AMT-2
126500                                 TO MTPT-INDIV-PART-AMT
126600                 ADD  MBD200WS-PA-WORK-AMT-2
126700                                 TO MBD200WS-PA-OVRD-PART-AMT
126800                 ADD  WS-D200-RATE-PCT
126900                                 TO MTPT-INDIV-PART-RATE
127000                 PERFORM Z200-SET-TRANS-INDIV-PART-FLAG
127100                    THRU Z299-STIPF-EXIT
127200                 ADD  MBD200WS-PA-WORK-AMT-2
127300                                 TO MBD200WS-PA-PART-TRANS-OVRD
127400                 IF  MMTCWS-LM-SALE-REV
127500                 OR (MMTCWS-LM-RETURN
127600                 AND MBD200WS-PA-PFB-NET-SALES)
127700                 OR (MMTCWS-LM-RETURN-REV
127800                 AND MBD200WS-PA-PFB-GROSS-VOLUME)
127900                     SUBTRACT MTPT-AMOUNT
128000                               FROM MBD200WS-PA-AMT-OVERRIDE
128100                 ELSE
128200                     ADD  MTPT-AMOUNT
128300                                 TO MBD200WS-PA-AMT-OVERRIDE
128400                 END-IF
128500         END-EVALUATE.
128600*
128700 F199-OE-EXIT.
128800     EXIT.
128900/
129000 F500-ADJUSTMENT-CHECK SECTION.
129100 F501-AC-BEGIN.
129200*
129300     SET WS-D200-EF-ADJUSTMENT   TO TRUE.
129400     MOVE ZERO                   TO WS-D200-RATE-PCT.
129500     MOVE ZERO                   TO WS-D200-RATE-PCT-ADJ.
129600*
129700     IF  MMRT-EXCEPTION-IS-ADJUSTMENT (2)
129800         EVALUATE TRUE
129900             WHEN MMRTWS-PTD-VOLUME-W-CR-PLAN
130000                 CONTINUE
130100             WHEN OTHER
130200                 PERFORM G000-PLAN-EXCEPTION-CHECK
130300                    THRU G099-PEC-EXIT
130400         END-EVALUATE.
130500*
130600     ADD  WS-D200-RATE-PCT       TO WS-D200-RATE-PCT-ADJ.
130700     MOVE ZERO                   TO WS-D200-RATE-PCT.
130800*
130900*
131000*
131100     IF  MMRT-EXCEPTION-IS-ADJUSTMENT (3)
131200         PERFORM H000-SING-TKT-EXCEPTION-CHECK
131300            THRU H099-STEC-EXIT.
131400*
131500     ADD  WS-D200-RATE-PCT       TO WS-D200-RATE-PCT-ADJ.
131600     MOVE ZERO                   TO WS-D200-RATE-PCT.
131700*
131800*
131900*
132000     IF  MMRT-EXCEPTION-IS-ADJUSTMENT (4)
132100         PERFORM I000-STATE-EXCEPTION-CHECK
132200            THRU I099-SEC-EXIT.
132300*
132400     ADD  WS-D200-RATE-PCT       TO WS-D200-RATE-PCT-ADJ.
132500     MOVE ZERO                   TO WS-D200-RATE-PCT.
132600*
132700*
132800*
132900     IF  MMRT-EXCEPTION-IS-ADJUSTMENT (5)
133000         PERFORM J000-LOGO-EXCEPTION-CHECK
133100            THRU J099-LEC-EXIT.
133200*
133300     ADD  WS-D200-RATE-PCT       TO WS-D200-RATE-PCT-ADJ.
133400     MOVE ZERO                   TO WS-D200-RATE-PCT.
133500*
133600*
133700*
133800     IF  MMRT-EXCEPTION-IS-ADJUSTMENT (6)
133900         PERFORM K000-DEPT-EXCEPTION-CHECK
134000            THRU K099-DEC-EXIT.
134100*
134200     ADD  WS-D200-RATE-PCT       TO WS-D200-RATE-PCT-ADJ.
134300     MOVE ZERO                   TO WS-D200-RATE-PCT.
134400*
134500*
134600*
134700     IF  MMRT-EXCEPTION-IS-ADJUSTMENT (7)
134800         PERFORM L000-SKU-EXCEPTION-CHECK
134900            THRU L099-SEC-EXIT.
135000*
135100     ADD  WS-D200-RATE-PCT       TO WS-D200-RATE-PCT-ADJ.
135200     MOVE ZERO                   TO WS-D200-RATE-PCT.
135300*
135400*
135500*
135600     IF  WS-D200-RATE-PCT-ADJ IS NOT EQUAL TO ZERO
135700         EVALUATE TRUE
135800             WHEN MMRTWS-VALID-METH-ON-NUMBER
135900                 SET MTPT-IPI-IS-PER-ITEM
136000                                 TO TRUE
136100*
136200                 MOVE MMOC-PER-ITEM-NOD
136300                                 TO SS50WS-MULTIPLIER-NOD
136400                 MOVE ZERO
136500                                 TO SS50WS-MULTIPLICAND-NOD
136600                 MOVE MTPT-NBR-ITEMS
136700                                 TO SS50WS-MULTIPLICAND
136800                 MOVE WS-D200-RATE-PER-ITEM-ADJ
136900                                 TO SS50WS-MULTIPLIER-PER-ITEM
137000                 PERFORM SS50PD-MULTIPLY
137100                                 THRU SS50PD-M-EXIT
137200                 MOVE SS50WS-PRODUCT
137300                                 TO MBD200WS-PA-WORK-AMT-2
137400*
137500**               COMPUTE MBD200WS-PA-WORK-AMT-2 ROUNDED
137600**                               =  WS-D200-RATE-PER-ITEM-ADJ
137700**                               *  MTPT-NBR-ITEMS
137800**               END-COMPUTE
137900                 IF  MMTCWS-LM-SALE-REV
138000                 OR (MMTCWS-LM-RETURN
138100                 AND MBD200WS-PA-PFB-NET-SALES)
138200                 OR (MMTCWS-LM-RETURN-REV
138300                 AND MBD200WS-PA-PFB-GROSS-VOLUME)
138400                     COMPUTE MBD200WS-PA-WORK-AMT-2
138500                                 =  0 - MBD200WS-PA-WORK-AMT-2
138600                     END-COMPUTE
138700                 END-IF
138800                 ADD  MBD200WS-PA-WORK-AMT-2
138900                                 TO MTPT-INDIV-PART-AMT
139000                 ADD  MBD200WS-PA-WORK-AMT-2
139100                                 TO MBD200WS-PA-ADJ-PART-AMT
139200                 ADD  WS-D200-RATE-PER-ITEM-ADJ
139300                                 TO MTPT-INDIV-PART-ADJ-PER-ITEM
139400                 PERFORM Z200-SET-TRANS-INDIV-PART-FLAG
139500                    THRU Z299-STIPF-EXIT
139600                 ADD  MBD200WS-PA-WORK-AMT-2
139700                                 TO MBD200WS-PA-PART-TRANS-ADJ
139800                 IF  MBD200WS-PA-OVERRIDE-NO
139900                     IF  MMTCWS-LM-SALE-REV
140000                     OR (MMTCWS-LM-RETURN
140100                     AND MBD200WS-PA-PFB-NET-SALES)
140200                     OR (MMTCWS-LM-RETURN-REV
140300                     AND MBD200WS-PA-PFB-GROSS-VOLUME)
140400                         SUBTRACT MTPT-NBR-ITEMS
140500                               FROM MBD200WS-PA-NBR-ADJUSTMENTS
140600                     ELSE
140700                         ADD  MTPT-NBR-ITEMS
140800                                 TO MBD200WS-PA-NBR-ADJUSTMENTS
140900                     END-IF
141000                 END-IF
141100             WHEN OTHER
141200                 SET MTPT-IPI-IS-RATE
141300                                 TO TRUE
141400*
141500                 MOVE MMOC-PERCENT-NOD
141600                                 TO SS50WS-MULTIPLIER-NOD
141700                 SET SS50WS-MULTIPLICAND-BY-CC
141800                                 TO TRUE
141900                 MOVE MTPT-AMOUNT
142000                                 TO SS50WS-MULTIPLICAND
142100                 MOVE WS-D200-RATE-PCT-ADJ
142200                                 TO SS50WS-MULTIPLIER-PERCENT
142300                 PERFORM SS50PD-MULTIPLY
142400                                 THRU SS50PD-M-EXIT
142500                 MOVE SS50WS-PRODUCT
142600                                 TO MBD200WS-PA-WORK-AMT-2
142700*
142800***              COMPUTE MBD200WS-PA-WORK-AMT-2 ROUNDED
142900***                              =  WS-D200-RATE-PCT-ADJ
143000***                              *  MTPT-AMOUNT
143100***              END-COMPUTE
143200                 IF  MMTCWS-LM-SALE-REV
143300                 OR (MMTCWS-LM-RETURN
143400                 AND MBD200WS-PA-PFB-NET-SALES)
143500                 OR (MMTCWS-LM-RETURN-REV
143600                 AND MBD200WS-PA-PFB-GROSS-VOLUME)
143700                     COMPUTE MBD200WS-PA-WORK-AMT-2
143800                                 =  0 - MBD200WS-PA-WORK-AMT-2
143900                     END-COMPUTE
144000                 END-IF
144100                 ADD  MBD200WS-PA-WORK-AMT-2
144200                                 TO MTPT-INDIV-PART-AMT
144300                 ADD  MBD200WS-PA-WORK-AMT-2
144400                                 TO MBD200WS-PA-ADJ-PART-AMT
144500                 ADD  WS-D200-RATE-PCT-ADJ
144600                                 TO MTPT-INDIV-PART-ADJ-RATE
144700                 PERFORM Z200-SET-TRANS-INDIV-PART-FLAG
144800                    THRU Z299-STIPF-EXIT
144900                 ADD  MBD200WS-PA-WORK-AMT-2
145000                                 TO MBD200WS-PA-PART-TRANS-ADJ
145100                 IF  MBD200WS-PA-OVERRIDE-NO
145200                     IF  MMTCWS-LM-SALE-REV
145300                     OR (MMTCWS-LM-RETURN
145400                     AND MBD200WS-PA-PFB-NET-SALES)
145500                     OR (MMTCWS-LM-RETURN-REV
145600                     AND MBD200WS-PA-PFB-GROSS-VOLUME)
145700                         SUBTRACT MTPT-AMOUNT
145800                               FROM MBD200WS-PA-AMT-ADJUSTMENTS
145900                     ELSE
146000                         ADD  MTPT-AMOUNT
146100                                 TO MBD200WS-PA-AMT-ADJUSTMENTS
146200                     END-IF
146300                 END-IF
146400         END-EVALUATE.
146500*
146600 F599-AC-EXIT.
146700     EXIT.
146800/
146900 G000-PLAN-EXCEPTION-CHECK SECTION.
147000 G001-PEC-BEGIN.
147100*
147200     SET X-MMRT-PLAN             TO 1.
147300*
147400     SEARCH MMRT-PLAN-TABLE VARYING X-MMRT-PLAN
147500         AT END
147600             PERFORM G500-CP-RANGE-EXCEPTION-CHECK
147700                THRU G599-CPRC-EXIT
147800         WHEN MMRT-PLAN-X (X-MMRT-PLAN) IS EQUAL TO '*****'
147900             MOVE MMRT-PLAN-RATE (X-MMRT-PLAN)
148000                                 TO WS-D200-RATE-PCT
148100             PERFORM Z300-SET-OVERRIDE-ADJ-FLAGS
148200                THRU Z399-SOAF-EXIT
148300         WHEN MTPT-PLAN-X IS NOT EQUAL TO ZERO
148400          AND MTPT-PLAN-X IS EQUAL TO MMRT-PLAN-X (X-MMRT-PLAN)
148500             MOVE MMRT-PLAN-RATE (X-MMRT-PLAN)
148600                                 TO WS-D200-RATE-PCT
148700             PERFORM Z300-SET-OVERRIDE-ADJ-FLAGS
148800                THRU Z399-SOAF-EXIT
148900         WHEN MTPT-PLAN-X IS NOT EQUAL TO ZERO
149000          AND
149100                  (MMRT-PLAN-X(X-MMRT-PLAN) (1:1) IS EQUAL TO
149200                                MTPT-PLAN-X (1:1)
149300               OR  MMRT-PLAN-X(X-MMRT-PLAN) (1:1) IS EQUAL TO '*')
149400          AND
149500                  (MMRT-PLAN-X(X-MMRT-PLAN) (2:1) IS EQUAL TO
149600                                MTPT-PLAN-X (2:1)
149700               OR  MMRT-PLAN-X(X-MMRT-PLAN) (2:1) IS EQUAL TO '*')
149800          AND
149900                  (MMRT-PLAN-X(X-MMRT-PLAN) (3:1) IS EQUAL TO
150000                                MTPT-PLAN-X (3:1)
150100               OR  MMRT-PLAN-X(X-MMRT-PLAN) (3:1) IS EQUAL TO '*')
150200          AND
150300                  (MMRT-PLAN-X(X-MMRT-PLAN) (4:1) IS EQUAL TO
150400                                MTPT-PLAN-X (4:1)
150500               OR  MMRT-PLAN-X(X-MMRT-PLAN) (4:1) IS EQUAL TO '*')
150600          AND
150700                  (MMRT-PLAN-X(X-MMRT-PLAN) (5:1) IS EQUAL TO
150800                                MTPT-PLAN-X (5:1)
150900               OR  MMRT-PLAN-X(X-MMRT-PLAN) (5:1) IS EQUAL TO '*')
151000             MOVE MMRT-PLAN-RATE (X-MMRT-PLAN)
151100                                 TO WS-D200-RATE-PCT
151200             PERFORM Z300-SET-OVERRIDE-ADJ-FLAGS
151300                THRU Z399-SOAF-EXIT.
151400*
151500 G099-PEC-EXIT.
151600     EXIT.
151700/
151800 G500-CP-RANGE-EXCEPTION-CHECK SECTION.
151900 G501-CPRC-BEGIN.
152000*
152100     SET X-MMRT-PLAN             TO 1.
152200*
152300     SEARCH MMRT-PLAN-TABLE VARYING X-MMRT-PLAN
152400         AT END
152500             SET X-MMRT-PLAN     TO 1
152600         WHEN MTPT-PLAN-X IS NOT EQUAL TO ZERO
152700          AND MTPT-PLAN-X IS NOT LESS THAN    MMRT-PLAN-BEG-X
152800                                              (X-MMRT-PLAN)
152900          AND MTPT-PLAN-X IS NOT GREATER THAN MMRT-PLAN-END-X
153000                                              (X-MMRT-PLAN)
153100             MOVE MMRT-PLAN-RANGE-RATE (X-MMRT-PLAN)
153200                                 TO WS-D200-RATE-PCT
153300             PERFORM Z300-SET-OVERRIDE-ADJ-FLAGS
153400                THRU Z399-SOAF-EXIT.
153500*
153600 G599-CPRC-EXIT.
153700     EXIT.
153800/
153900 H000-SING-TKT-EXCEPTION-CHECK SECTION.
154000 H001-STEC-BEGIN.
154100*
154200     IF  MTPT-AMOUNT IS NOT LESS THAN MMRT-SINGLE-TKT-BEG-LIMIT
154300         SET X-MMRT-SINGLE-TKT       TO 1
154400         SEARCH MMRT-SINGLE-TKT-TABLE VARYING X-MMRT-SINGLE-TKT
154500             AT END
154600                 SET X-MMRT-SINGLE-TKT
154700                                 TO 1
154800             WHEN MTPT-AMOUNT IS NOT GREATER THAN
154900                                 MMRT-SINGLE-TKT-LIMIT
155000                                 (X-MMRT-SINGLE-TKT)
155100                 MOVE MMRT-SINGLE-TKT-RATE (X-MMRT-SINGLE-TKT)
155200                                 TO WS-D200-RATE-PCT
155300                 PERFORM Z300-SET-OVERRIDE-ADJ-FLAGS
155400                    THRU Z399-SOAF-EXIT.
155500*
155600 H099-STEC-EXIT.
155700     EXIT.
155800/
155900 I000-STATE-EXCEPTION-CHECK SECTION.
156000 I001-SEC-BEGIN.
156100*
156200     SET X-MMRT-STATE            TO 1.
156300*
156400     SEARCH MMRT-STATE-TABLE VARYING X-MMRT-STATE
156500         AT END
156600             SET X-MMRT-STATE    TO 1
156700         WHEN MTPT-GOVERNING-STATE IS NOT EQUAL TO SPACES
156800          AND MTPT-GOVERNING-STATE IS EQUAL TO MMRT-STATE
156900                                               (X-MMRT-STATE)
157000             MOVE MMRT-STATE-RATE (X-MMRT-STATE)
157100                                 TO WS-D200-RATE-PCT
157200             PERFORM Z300-SET-OVERRIDE-ADJ-FLAGS
157300                THRU Z399-SOAF-EXIT.
157400*
157500 I099-SEC-EXIT.
157600     EXIT.
157700/
157800 J000-LOGO-EXCEPTION-CHECK SECTION.
157900 J001-LEC-BEGIN.
158000*
158100     SET X-MMRT-LOGO             TO 1.
158200*
158300     SEARCH MMRT-LOGO-TABLE VARYING X-MMRT-LOGO
158400         AT END
158500             SET X-MMRT-LOGO     TO 1
158600         WHEN MTPT-LOGO IS GREATER THAN ZERO
158700          AND MTPT-LOGO IS EQUAL TO MMRT-LOGO (X-MMRT-LOGO)
158800             MOVE MMRT-LOGO-RATE (X-MMRT-LOGO)
158900                                 TO WS-D200-RATE-PCT
159000             PERFORM Z300-SET-OVERRIDE-ADJ-FLAGS
159100                THRU Z399-SOAF-EXIT.
159200*
159300 J099-LEC-EXIT.
159400     EXIT.
159500/
159600 K000-DEPT-EXCEPTION-CHECK SECTION.
159700 K001-DEC-BEGIN.
159800*
159900     SET X-MMRT-DEPT             TO 1.
160000*
160100     SEARCH MMRT-DEPT-TABLE VARYING X-MMRT-DEPT
160200         AT END
160300             SET X-MMRT-DEPT     TO 1
160400         WHEN MMRT-DEPT (X-MMRT-DEPT) IS EQUAL TO '****'
160500             MOVE MMRT-DEPT-RATE (X-MMRT-DEPT)
160600                                 TO WS-D200-RATE-PCT
160700             PERFORM Z300-SET-OVERRIDE-ADJ-FLAGS
160800                THRU Z399-SOAF-EXIT
160900         WHEN MTPT-DEPT-CODE IS NOT EQUAL TO SPACES
161000          AND MTPT-DEPT-CODE IS EQUAL TO MMRT-DEPT (X-MMRT-DEPT)
161100             MOVE MMRT-DEPT-RATE (X-MMRT-DEPT)
161200                                 TO WS-D200-RATE-PCT
161300             PERFORM Z300-SET-OVERRIDE-ADJ-FLAGS
161400                THRU Z399-SOAF-EXIT
161500         WHEN MTPT-DEPT-CODE IS NOT EQUAL TO SPACES
161600          AND
161700                  (MMRT-DEPT(X-MMRT-DEPT) (1:1) IS EQUAL TO
161800                           MTPT-DEPT-CODE (1:1)
161900               OR  MMRT-DEPT(X-MMRT-DEPT) (1:1) IS EQUAL TO '*')
162000          AND
162100                  (MMRT-DEPT(X-MMRT-DEPT) (2:1) IS EQUAL TO
162200                           MTPT-DEPT-CODE (2:1)
162300               OR  MMRT-DEPT(X-MMRT-DEPT) (2:1) IS EQUAL TO '*')
162400          AND
162500                  (MMRT-DEPT(X-MMRT-DEPT) (3:1) IS EQUAL TO
162600                           MTPT-DEPT-CODE (3:1)
162700               OR  MMRT-DEPT(X-MMRT-DEPT) (3:1) IS EQUAL TO '*')
162800          AND
162900                  (MMRT-DEPT(X-MMRT-DEPT) (4:1) IS EQUAL TO
163000                           MTPT-DEPT-CODE (4:1)
163100               OR  MMRT-DEPT(X-MMRT-DEPT) (4:1) IS EQUAL TO '*')
163200             MOVE MMRT-DEPT-RATE (X-MMRT-DEPT)
163300                                 TO WS-D200-RATE-PCT
163400             PERFORM Z300-SET-OVERRIDE-ADJ-FLAGS
163500                THRU Z399-SOAF-EXIT.
163600*
163700 K099-DEC-EXIT.
163800     EXIT.
163900/
164000 L000-SKU-EXCEPTION-CHECK SECTION.
164100 L001-SEC-BEGIN.
164200*
164300     SET X-MMRT-SKU              TO 1.
164400*
164500     SEARCH MMRT-SKU-TABLE VARYING X-MMRT-SKU
164600         AT END
164700             SET X-MMRT-SKU      TO 1
164800         WHEN MMRT-SKU-NBR (X-MMRT-SKU) IS EQUAL TO '*********'
164900             MOVE MMRT-SKU-RATE (X-MMRT-SKU)
165000                                 TO WS-D200-RATE-PCT
165100             PERFORM Z300-SET-OVERRIDE-ADJ-FLAGS
165200                THRU Z399-SOAF-EXIT
165300         WHEN MTPT-SKU-NBR-X IS NOT EQUAL TO ZERO
165400          AND MTPT-SKU-NBR-X IS EQUAL TO MMRT-SKU-NBR (X-MMRT-SKU)
165500             MOVE MMRT-SKU-RATE (X-MMRT-SKU)
165600                                 TO WS-D200-RATE-PCT
165700             PERFORM Z300-SET-OVERRIDE-ADJ-FLAGS
165800                THRU Z399-SOAF-EXIT
165900         WHEN MTPT-SKU-NBR-X IS NOT EQUAL TO ZERO
166000          AND
166100                  (MMRT-SKU-NBR(X-MMRT-SKU) (1:1) IS EQUAL TO
166200                             MTPT-SKU-NBR-X (1:1)
166300               OR  MMRT-SKU-NBR(X-MMRT-SKU) (1:1) IS EQUAL TO '*')
166400          AND
166500                  (MMRT-SKU-NBR(X-MMRT-SKU) (2:1) IS EQUAL TO
166600                             MTPT-SKU-NBR-X (2:1)
166700               OR  MMRT-SKU-NBR(X-MMRT-SKU) (2:1) IS EQUAL TO '*')
166800          AND
166900                  (MMRT-SKU-NBR(X-MMRT-SKU) (3:1) IS EQUAL TO
167000                             MTPT-SKU-NBR-X (3:1)
167100               OR  MMRT-SKU-NBR(X-MMRT-SKU) (3:1) IS EQUAL TO '*')
167200          AND
167300                  (MMRT-SKU-NBR(X-MMRT-SKU) (4:1) IS EQUAL TO
167400                             MTPT-SKU-NBR-X (4:1)
167500               OR  MMRT-SKU-NBR(X-MMRT-SKU) (4:1) IS EQUAL TO '*')
167600          AND
167700                  (MMRT-SKU-NBR(X-MMRT-SKU) (5:1) IS EQUAL TO
167800                             MTPT-SKU-NBR-X (5:1)
167900               OR  MMRT-SKU-NBR(X-MMRT-SKU) (5:1) IS EQUAL TO '*')
168000          AND
168100                  (MMRT-SKU-NBR(X-MMRT-SKU) (6:1) IS EQUAL TO
168200                             MTPT-SKU-NBR-X (6:1)
168300               OR  MMRT-SKU-NBR(X-MMRT-SKU) (6:1) IS EQUAL TO '*')
168400          AND
168500                  (MMRT-SKU-NBR(X-MMRT-SKU) (7:1) IS EQUAL TO
168600                             MTPT-SKU-NBR-X (7:1)
168700               OR  MMRT-SKU-NBR(X-MMRT-SKU) (7:1) IS EQUAL TO '*')
168800          AND
168900                  (MMRT-SKU-NBR(X-MMRT-SKU) (8:1) IS EQUAL TO
169000                             MTPT-SKU-NBR-X (8:1)
169100               OR  MMRT-SKU-NBR(X-MMRT-SKU) (8:1) IS EQUAL TO '*')
169200          AND
169300                  (MMRT-SKU-NBR(X-MMRT-SKU) (9:1) IS EQUAL TO
169400                             MTPT-SKU-NBR-X (9:1)
169500               OR  MMRT-SKU-NBR(X-MMRT-SKU) (9:1) IS EQUAL TO '*')
169600             MOVE MMRT-SKU-RATE (X-MMRT-SKU)
169700                                 TO WS-D200-RATE-PCT
169800             PERFORM Z300-SET-OVERRIDE-ADJ-FLAGS
169900                THRU Z399-SOAF-EXIT.
170000*
170100 L099-SEC-EXIT.
170200     EXIT.
170300/
170400 M000-INDIVIDUAL-TICKET SECTION.
170500 M001-IT-BEGIN.
170600*
170700     SET X-MMRT-PRIM             TO 1.
170800*
170900     SEARCH MMRT-PRIMARY-RATES-TABLE VARYING X-MMRT-PRIM
171000         AT END
171100             SET X-MMRT-PRIM     TO 10
171200         WHEN MTPT-AMOUNT IS NOT GREATER THAN MMRT-PRIM-LIMIT
171300                                              (X-MMRT-PRIM)
171400             NEXT SENTENCE.
171500*
171600*
171700     MOVE MMOC-PERCENT-NOD       TO SS50WS-MULTIPLIER-NOD
171800     SET SS50WS-MULTIPLICAND-BY-CC
171900                                 TO TRUE
172000     MOVE MTPT-AMOUNT            TO SS50WS-MULTIPLICAND
172100     MOVE MMRT-PRIM-RATE (X-MMRT-PRIM)
172200                                 TO SS50WS-MULTIPLIER-PERCENT
172300     PERFORM SS50PD-MULTIPLY
172400                                 THRU SS50PD-M-EXIT
172500     MOVE SS50WS-PRODUCT         TO MBD200WS-PA-WORK-AMT-5.
172600*
172700***  COMPUTE MBD200WS-PA-WORK-AMT-5 ROUNDED
172800***                              =  MMRT-PRIM-RATE (X-MMRT-PRIM)
172900***                              *  MTPT-AMOUNT.
173000*
173100     MOVE MMRT-PRIM-RATE (X-MMRT-PRIM)
173200                                 TO MTPT-INDIV-PART-RATE.
173300     SET MTPT-IPI-IS-RATE        TO TRUE.
173400*
173500     SET X-MBD200WS-PA-TIER      TO X-MMRT-PRIM.
173600*
173700     IF  MMTCWS-LM-SALE-REV
173800     OR (MMTCWS-LM-RETURN
173900     AND MBD200WS-PA-PFB-NET-SALES)
174000     OR (MMTCWS-LM-RETURN-REV
174100     AND MBD200WS-PA-PFB-GROSS-VOLUME)
174200         COMPUTE MBD200WS-PA-WORK-AMT-5
174300                                 =  0 - MBD200WS-PA-WORK-AMT-5
174400         SUBTRACT MTPT-AMOUNT  FROM MBD200WS-PA-AMT-PREV-TODAY
174500         SUBTRACT MTPT-AMOUNT  FROM MBD200WS-PA-TIER-AMT-TODAY
174600                                    (X-MBD200WS-PA-TIER)
174700     ELSE
174800         ADD MTPT-AMOUNT         TO MBD200WS-PA-AMT-PREV-TODAY
174900         ADD MTPT-AMOUNT         TO MBD200WS-PA-TIER-AMT-TODAY
175000                                    (X-MBD200WS-PA-TIER).
175100*
175200     ADD  MBD200WS-PA-WORK-AMT-5 TO MTPT-INDIV-PART-AMT.
175300     ADD  MBD200WS-PA-WORK-AMT-5 TO MBD200WS-PA-OVRD-PART-AMT.
175400     PERFORM Z200-SET-TRANS-INDIV-PART-FLAG
175500        THRU Z299-STIPF-EXIT.
175600     ADD  MBD200WS-PA-WORK-AMT-5 TO MBD200WS-PA-PART-TRANS-OVRD.
175700*
175800     IF  MMTCWS-LM-SALE-REV
175900     OR (MMTCWS-LM-RETURN
176000     AND MBD200WS-PA-PFB-NET-SALES)
176100     OR (MMTCWS-LM-RETURN-REV
176200     AND MBD200WS-PA-PFB-GROSS-VOLUME)
176300         SUBTRACT MTPT-AMOUNT  FROM MBD200WS-PA-AMT-OVERRIDE
176400     ELSE
176500         ADD  MTPT-AMOUNT        TO MBD200WS-PA-AMT-OVERRIDE.
176600*
176700     SET WS-D200-EF-OVERRIDE     TO TRUE.
176800     PERFORM Z300-SET-OVERRIDE-ADJ-FLAGS
176900        THRU Z399-SOAF-EXIT.
177000*
177100 M099-IT-EXIT.
177200     EXIT.
177300/
177400 P000-PROCESS-PLAN SECTION.
177500 P001-PP-BEGIN.
177600*
177700     INITIALIZE MBD200WS-PA-PLAN-AREA.
177800*
177900     PERFORM
178000         VARYING X-MMCPTB FROM 1 BY 1
178100         UNTIL   X-MMCPTB IS GREATER THAN MMCPTB-MAX-ENTRIES
178200            OR   MMCPTB-END-OF-TABLE (X-MMCPTB)
178300         MOVE MMCPTB-RECORD (X-MMCPTB)
178400                                 TO MMCP-RECORD
178500         EVALUATE TRUE
178600             WHEN MMMM-PL-PRODUCT
178700                 IF  MMCP-DETAIL
178800                 AND MMCP-PRODUCT IS EQUAL TO MMMP-PRODUCT
178900                     PERFORM P100-SEARCH-PLAN-SINGLE
179000                        THRU P199-SPS-EXIT
179100                 END-IF
179200             WHEN OTHER
179300                 IF  MMCP-DETAIL
179400                     PERFORM P100-SEARCH-PLAN-SINGLE
179500                        THRU P199-SPS-EXIT
179600                 END-IF
179700         END-EVALUATE
179800     END-PERFORM.
179900*
180000     PERFORM
180100         VARYING X-MMRT-PLAN FROM 1 BY 1
180200         UNTIL   X-MMRT-PLAN IS GREATER THAN 56
180300         SET X-MBD200WS-PA-PLAN  TO X-MMRT-PLAN
180400*
180500         MOVE MMOC-PERCENT-NOD
180600                                 TO SS50WS-MULTIPLIER-NOD
180700         SET SS50WS-MULTIPLICAND-BY-CC
180800                                 TO TRUE
180900         MOVE MBD200WS-PA-PLAN-FBS (X-MBD200WS-PA-PLAN)
181000                                 TO SS50WS-MULTIPLICAND
181100         MOVE MMRT-PLAN-RATE (X-MMRT-PLAN)
181200                                 TO SS50WS-MULTIPLIER-PERCENT
181300         PERFORM SS50PD-MULTIPLY
181400                                 THRU SS50PD-M-EXIT
181500         MOVE SS50WS-PRODUCT     TO MBD200WS-PA-PLAN-PART
181600                                    (X-MBD200WS-PA-PLAN)
181700*
181800***      COMPUTE MBD200WS-PA-PLAN-PART (X-MBD200WS-PA-PLAN)
181900***                              ROUNDED
182000***                              =  MMRT-PLAN-RATE (X-MMRT-PLAN)
182100***                              *  MBD200WS-PA-PLAN-FBS
182200***                                 (X-MBD200WS-PA-PLAN)
182300***      END-COMPUTE
182400*
182500         MOVE MMOC-PERCENT-NOD   TO SS50WS-MULTIPLIER-NOD
182600         SET SS50WS-MULTIPLICAND-BY-CC
182700                                 TO TRUE
182800         MOVE MBD200WS-PA-PLAN-RANGE-FBS (X-MBD200WS-PA-PLAN)
182900                                 TO SS50WS-MULTIPLICAND
183000         MOVE MMRT-PLAN-RANGE-RATE (X-MMRT-PLAN)
183100                                 TO SS50WS-MULTIPLIER-PERCENT
183200         PERFORM SS50PD-MULTIPLY
183300                                 THRU SS50PD-M-EXIT
183400         MOVE SS50WS-PRODUCT     TO MBD200WS-PA-PLAN-RANGE-PART
183500                                    (X-MBD200WS-PA-PLAN)
183600*
183700***      COMPUTE MBD200WS-PA-PLAN-RANGE-PART (X-MBD200WS-PA-PLAN)
183800***                              ROUNDED
183900***                              =  MMRT-PLAN-RANGE-RATE
184000***                                 (X-MMRT-PLAN)
184100***                              *  MBD200WS-PA-PLAN-RANGE-FBS
184200***                                 (X-MBD200WS-PA-PLAN)
184300***      END-COMPUTE
184400         EVALUATE TRUE
184500             WHEN MMRT-EXCEPTION-IS-ADJUSTMENT (2)
184600                 COMPUTE MBD200WS-PA-PART-PLAN-ADJ
184700                                 =  MBD200WS-PA-PART-PLAN-ADJ
184800                                 +  MBD200WS-PA-PLAN-PART
184900                                    (X-MBD200WS-PA-PLAN)
185000                                 +  MBD200WS-PA-PLAN-RANGE-PART
185100                                    (X-MBD200WS-PA-PLAN)
185200                 END-COMPUTE
185300                  ADD  MBD200WS-PA-PLAN-FBS
185400                       (X-MBD200WS-PA-PLAN)
185500                                 TO MBD200WS-PA-AMT-ADJUSTMENTS
185600                  ADD  MBD200WS-PA-PLAN-RANGE-FBS
185700                       (X-MBD200WS-PA-PLAN)
185800                                 TO MBD200WS-PA-AMT-ADJUSTMENTS
185900             WHEN MMRT-EXCEPTION-COND-OVERRIDE (2)
186000                 COMPUTE MBD200WS-PA-PART-PLAN-OVRD
186100                                 =  MBD200WS-PA-PART-PLAN-OVRD
186200                                 +  MBD200WS-PA-PLAN-PART
186300                                    (X-MBD200WS-PA-PLAN)
186400                                 +  MBD200WS-PA-PLAN-RANGE-PART
186500                                    (X-MBD200WS-PA-PLAN)
186600                 END-COMPUTE
186700                  ADD  MBD200WS-PA-PLAN-FBS
186800                       (X-MBD200WS-PA-PLAN)
186900                                 TO MBD200WS-PA-AMT-OVERRIDE
187000                  ADD  MBD200WS-PA-PLAN-RANGE-FBS
187100                       (X-MBD200WS-PA-PLAN)
187200                                 TO MBD200WS-PA-AMT-OVERRIDE
187300             WHEN OTHER
187400                 CONTINUE
187500         END-EVALUATE
187600     END-PERFORM.
187700*
187800*
187900*
188000*
188100*
188200*
188300 P099-PP-EXIT.
188400     EXIT.
188500/
188600 P100-SEARCH-PLAN-SINGLE SECTION.
188700 P101-SPS-BEGIN.
188800*
188900     SET MBD200WS-PA-PLAN-SINGLE TO TRUE.
189000*
189100     SET X-MMRT-PLAN             TO 1.
189200     SEARCH MMRT-PLAN-TABLE VARYING X-MMRT-PLAN
189300         AT END
189400             PERFORM P200-SEARCH-PLAN-RANGE
189500                THRU P299-SPR-EXIT
189600         WHEN MMRT-PLAN-X (X-MMRT-PLAN) IS EQUAL TO MMCP-PLAN-X
189700          AND MMRT-PLAN-X (X-MMRT-PLAN) IS GREATER THAN ZERO
189800             PERFORM P300-ACCUM-STATS
189900                THRU P399-AS-EXIT
190000         WHEN MMCP-PLAN-X IS NOT EQUAL TO ZERO
190100          AND
190200                 (MMRT-PLAN-X (X-MMRT-PLAN) (1:1) IS EQUAL TO
190300                                MMCP-PLAN-X (1:1)
190400              OR  MMRT-PLAN-X (X-MMRT-PLAN) (1:1) IS EQUAL TO '*')
190500          AND
190600                 (MMRT-PLAN-X (X-MMRT-PLAN) (2:1) IS EQUAL TO
190700                                MMCP-PLAN-X (2:1)
190800              OR  MMRT-PLAN-X (X-MMRT-PLAN) (2:1) IS EQUAL TO '*')
190900          AND
191000                 (MMRT-PLAN-X (X-MMRT-PLAN) (3:1) IS EQUAL TO
191100                                MMCP-PLAN-X (3:1)
191200              OR  MMRT-PLAN-X (X-MMRT-PLAN) (3:1) IS EQUAL TO '*')
191300          AND
191400                 (MMRT-PLAN-X (X-MMRT-PLAN) (4:1) IS EQUAL TO
191500                                MMCP-PLAN-X (4:1)
191600              OR  MMRT-PLAN-X (X-MMRT-PLAN) (4:1) IS EQUAL TO '*')
191700          AND
191800                 (MMRT-PLAN-X (X-MMRT-PLAN) (5:1) IS EQUAL TO
191900                                MMCP-PLAN-X (5:1)
192000              OR  MMRT-PLAN-X (X-MMRT-PLAN) (5:1) IS EQUAL TO '*')
192100             PERFORM P300-ACCUM-STATS
192200                THRU P399-AS-EXIT.
192300*
192400 P199-SPS-EXIT.
192500     EXIT.
192600/
192700 P200-SEARCH-PLAN-RANGE SECTION.
192800 P201-SPR-BEGIN.
192900*
193000     SET MBD200WS-PA-PLAN-RANGE  TO TRUE.
193100*
193200     SET X-MMRT-PLAN             TO 1.
193300     SEARCH MMRT-PLAN-TABLE VARYING X-MMRT-PLAN
193400         AT END
193500             SET X-MMRT-PLAN     TO 1
193600         WHEN MMCP-PLAN-X IS NOT LESS THAN
193700                                 MMRT-PLAN-BEG-X (X-MMRT-PLAN)
193800          AND MMCP-PLAN-X IS NOT GREATER THAN
193900                                 MMRT-PLAN-END-X (X-MMRT-PLAN)
194000             PERFORM P300-ACCUM-STATS
194100                THRU P399-AS-EXIT.
194200*
194300 P299-SPR-EXIT.
194400     EXIT.
194500/
194600 P300-ACCUM-STATS SECTION.
194700 P301-AS-BEGIN.
194800*
194900     SET  X-MBD200WS-PA-PLAN     TO X-MMRT-PLAN.
195000     MOVE MMCP-LOGIC-MODULE      TO MMTCWS-LOGIC-MODULE.
195100*
195200     EVALUATE TRUE
195300         WHEN MMMM-PL-PRODUCT
195400             EVALUATE TRUE
195500                 WHEN MMMP-PPFB-GROSS-SALES
195600                     PERFORM P700-ADD-SALES
195700                        THRU P799-AS-EXIT
195800                 WHEN MMMP-PPFB-GROSS-VOLUME
195900                     PERFORM P700-ADD-SALES
196000                        THRU P799-AS-EXIT
196100                     PERFORM P800-ADD-RETURNS
196200                        THRU P899-AR-EXIT
196300                 WHEN OTHER
196400                     PERFORM P700-ADD-SALES
196500                        THRU P799-AS-EXIT
196600                     PERFORM P900-SUBTRACT-RETURNS
196700                        THRU P999-SR-EXIT
196800             END-EVALUATE
196900         WHEN OTHER
197000             EVALUATE TRUE
197100                 WHEN MMMM-PFB-GROSS-SALES
197200                     PERFORM P700-ADD-SALES
197300                        THRU P799-AS-EXIT
197400                 WHEN MMMM-PFB-GROSS-VOLUME
197500                     PERFORM P700-ADD-SALES
197600                        THRU P799-AS-EXIT
197700                     PERFORM P800-ADD-RETURNS
197800                        THRU P899-AR-EXIT
197900                 WHEN OTHER
198000                     PERFORM P700-ADD-SALES
198100                        THRU P799-AS-EXIT
198200                     PERFORM P900-SUBTRACT-RETURNS
198300                        THRU P999-SR-EXIT
198400             END-EVALUATE
198500     END-EVALUATE.
198600*
198700 P399-AS-EXIT.
198800     EXIT.
198900/
199000 P700-ADD-SALES SECTION.
199100 P701-AS-BEGIN.
199200*
199300     EVALUATE TRUE
199400         WHEN MMTCWS-LM-SALE
199500             EVALUATE TRUE
199600                 WHEN MBD200WS-PA-PLAN-SINGLE
199700                     ADD MMCP-AMT (18)
199800                                 TO MBD200WS-PA-PLAN-FBS
199900                                    (X-MBD200WS-PA-PLAN)
200000                 WHEN OTHER
200100                     ADD MMCP-AMT (18)
200200                                 TO MBD200WS-PA-PLAN-RANGE-FBS
200300                                    (X-MBD200WS-PA-PLAN)
200400             END-EVALUATE
200500         WHEN MMTCWS-LM-SALE-REV
200600             EVALUATE TRUE
200700                 WHEN MBD200WS-PA-PLAN-SINGLE
200800                     SUBTRACT MMCP-AMT (18)
200900                                 FROM MBD200WS-PA-PLAN-FBS
201000                                    (X-MBD200WS-PA-PLAN)
201100                 WHEN OTHER
201200                     SUBTRACT MMCP-AMT (18)
201300                                 FROM MBD200WS-PA-PLAN-RANGE-FBS
201400                                    (X-MBD200WS-PA-PLAN)
201500             END-EVALUATE
201600     END-EVALUATE.
201700*
201800 P799-AS-EXIT.
201900     EXIT.
202000/
202100 P800-ADD-RETURNS SECTION.
202200 P801-AR-BEGIN.
202300*
202400     EVALUATE TRUE
202500         WHEN MMTCWS-LM-RETURN
202600             EVALUATE TRUE
202700                 WHEN MBD200WS-PA-PLAN-SINGLE
202800                     ADD MMCP-AMT (18)
202900                                 TO MBD200WS-PA-PLAN-FBS
203000                                    (X-MBD200WS-PA-PLAN)
203100                 WHEN OTHER
203200                     ADD MMCP-AMT (18)
203300                                 TO MBD200WS-PA-PLAN-RANGE-FBS
203400                                    (X-MBD200WS-PA-PLAN)
203500             END-EVALUATE
203600         WHEN MMTCWS-LM-RETURN-REV
203700             EVALUATE TRUE
203800                 WHEN MBD200WS-PA-PLAN-SINGLE
203900                     SUBTRACT MMCP-AMT (18)
204000                                 FROM MBD200WS-PA-PLAN-FBS
204100                                    (X-MBD200WS-PA-PLAN)
204200                 WHEN OTHER
204300                     SUBTRACT MMCP-AMT (18)
204400                                 FROM MBD200WS-PA-PLAN-RANGE-FBS
204500                                    (X-MBD200WS-PA-PLAN)
204600             END-EVALUATE
204700     END-EVALUATE.
204800*
204900 P899-AR-EXIT.
205000     EXIT.
205100/
205200 P900-SUBTRACT-RETURNS SECTION.
205300 P901-SR-BEGIN.
205400*
205500     EVALUATE TRUE
205600         WHEN MMTCWS-LM-RETURN
205700             EVALUATE TRUE
205800                 WHEN MBD200WS-PA-PLAN-SINGLE
205900                     SUBTRACT MMCP-AMT (18)
206000                                 FROM MBD200WS-PA-PLAN-FBS
206100                                    (X-MBD200WS-PA-PLAN)
206200                 WHEN OTHER
206300                     SUBTRACT MMCP-AMT (18)
206400                                 FROM MBD200WS-PA-PLAN-RANGE-FBS
206500                                    (X-MBD200WS-PA-PLAN)
206600             END-EVALUATE
206700         WHEN MMTCWS-LM-RETURN-REV
206800             EVALUATE TRUE
206900                 WHEN MBD200WS-PA-PLAN-SINGLE
207000                     ADD MMCP-AMT (18)
207100                                 TO MBD200WS-PA-PLAN-FBS
207200                                    (X-MBD200WS-PA-PLAN)
207300                 WHEN OTHER
207400                     ADD MMCP-AMT (18)
207500                                 TO MBD200WS-PA-PLAN-RANGE-FBS
207600                                    (X-MBD200WS-PA-PLAN)
207700             END-EVALUATE
207800     END-EVALUATE.
207900*
208000 P999-SR-EXIT.
208100     EXIT.
208200/
208300 T000-PROCESS-TODAYS SECTION.
208400 T001-PT-BEGIN.
208500*
208600     PERFORM X900-ACCUM-STATS-TABLE
208700        THRU X999-AST-EXIT.
208800*
208900     MOVE ZERO                   TO MBD200WS-PA-WORK-AMT-1.
209000*
209100     IF  MMRTWS-CTD-NUMBER-INC
209200     OR  MMRTWS-CTD-VOLUME-INC
209300         SET X-WS-D200-SRA       TO 13
209400         PERFORM Z000-CALC-FEE-BASE
209500            THRU Z099-CFB-EXIT.
209600*
209700     IF  MMRTWS-MTD-NUMBER-INC
209800     OR  MMRTWS-MTD-VOLUME-INC
209900     OR  MMRTWS-MTD-TIERED-INCOME
210000         SET X-WS-D200-SRA       TO 13
210100         PERFORM Z000-CALC-FEE-BASE
210200            THRU Z099-CFB-EXIT.
210300*
210400     IF  MMRTWS-INDIVIDUAL-TICKET
210500         MOVE ZERO               TO MBD200WS-PA-WORK-NBR-1
210600         MOVE ZERO               TO MBD200WS-PA-WORK-AMT-1.
210700*
210800     IF  MMRTWS-PTD-NUMBER-INC
210900     OR  MMRTWS-PTD-NUMBER-CUM
211000     OR  MMRTWS-PTD-VOLUME-INC
211100     OR  MMRTWS-PTD-VOLUME-CUM
211200     OR  MMRTWS-PTD-VOLUME-W-CR-PLAN
211300     OR  MMRTWS-PTD-VOLUME-W-AVG-TKT
211400     OR  MMRTWS-PTD-AVG-TKT-CUM
211500     OR  MMRTWS-ROLLING-1-MON-VOL
211600     OR  MMRTWS-ROLLING-3-MON-VOL
211700     OR  MMRTWS-ROLLING-6-MON-VOL
211800     OR  MMRTWS-ROLLING-12-MON-VOL
211900     OR  MMRTWS-ROLLING-1-MON-AVG-TKT
212000     OR  MMRTWS-ROLLING-3-MON-AVG-TKT
212100     OR  MMRTWS-ROLLING-6-MON-AVG-TKT
212200     OR  MMRTWS-ROLLING-12-MON-AVG-TKT
212300         SET X-WS-D200-SRA       TO 13
212400         PERFORM Z000-CALC-FEE-BASE
212500            THRU Z099-CFB-EXIT.
212600*
212700     ADD  MBD200WS-PA-WORK-AMT-1 TO MBD200WS-PA-AMT-PREV-TODAY.
212800     ADD  MBD200WS-PA-WORK-NBR-1 TO MBD200WS-PA-NBR-PREV-TODAY.
212900*
213000*
213100*
213200 T099-PT-EXIT.
213300     EXIT.
213400/
213500 V000-PROCESS-AVG-TICKET SECTION.
213600 V001-PAT-BEGIN.
213700*
213800     SET X-MMRT-ATV              TO 1.
213900*
214000     SEARCH MMRT-AVG-TKT-VOL-TABLE VARYING X-MMRT-ATV
214100         AT END
214200             SET X-MMRT-ATV      TO 1
214300         WHEN WS-D200-SRA-AVG-TKT (18) IS NOT GREATER THAN
214400                                 MMRT-ATV-LIMIT (X-MMRT-ATV)
214500             NEXT SENTENCE.
214600*
214700     SET MBD200WS-PA-AVG-TKT-INDEX
214800                                 TO X-MMRT-ATV.
214900*
215000     MOVE MMOC-PERCENT-NOD       TO SS50WS-MULTIPLIER-NOD
215100     SET SS50WS-MULTIPLICAND-BY-CC
215200                                 TO TRUE
215300     MOVE MBD200WS-PA-AMT-PREV-TODAY
215400                                 TO SS50WS-MULTIPLICAND
215500     MOVE MMRT-ATV-RATE (X-MMRT-ATV)
215600                                 TO SS50WS-MULTIPLIER-PERCENT
215700     PERFORM SS50PD-MULTIPLY
215800                                 THRU SS50PD-M-EXIT
215900     MOVE SS50WS-PRODUCT         TO MBD200WS-PA-PART-AVG-TKT.
216000*
216100**   COMPUTE MBD200WS-PA-PART-AVG-TKT ROUNDED
216200**                               =  MBD200WS-PA-AMT-PREV-TODAY
216300**                               *  MMRT-ATV-RATE (X-MMRT-ATV).
216400*
216500 V099-PAT-EXIT.
216600     EXIT.
216700/
216800 X000-PART-SETUP SECTION.
216900 X001-PS-BEGIN.
217000*
217100     PERFORM X900-ACCUM-STATS-TABLE
217200        THRU X999-AST-EXIT.
217300*
217400     IF  MMRTWS-CTD-NUMBER-INC
217500     OR  MMRTWS-CTD-VOLUME-INC
217600         SET X-WS-D200-SRA       TO 16
217700         PERFORM Z000-CALC-FEE-BASE
217800            THRU Z099-CFB-EXIT.
217900*
218000     IF  MMRTWS-MTD-NUMBER-INC
218100     OR  MMRTWS-MTD-VOLUME-INC
218200     OR  MMRTWS-MTD-TIERED-INCOME
218300         SET X-WS-D200-SRA       TO 14
218400         PERFORM Z000-CALC-FEE-BASE
218500            THRU Z099-CFB-EXIT.
218600*
218700     IF  MMRTWS-INDIVIDUAL-TICKET
218800         MOVE ZERO               TO MBD200WS-PA-WORK-NBR-1
218900         MOVE ZERO               TO MBD200WS-PA-WORK-AMT-1.
219000*
219100     IF  MMRTWS-PTD-NUMBER-INC
219200     OR  MMRTWS-PTD-NUMBER-CUM
219300     OR  MMRTWS-PTD-VOLUME-INC
219400     OR  MMRTWS-PTD-VOLUME-CUM
219500     OR  MMRTWS-PTD-VOLUME-W-CR-PLAN
219600     OR  MMRTWS-PTD-VOLUME-W-AVG-TKT
219700     OR  MMRTWS-PTD-AVG-TKT-CUM
219800     OR  MMRTWS-ROLLING-1-MON-VOL
219900     OR  MMRTWS-ROLLING-3-MON-VOL
220000     OR  MMRTWS-ROLLING-6-MON-VOL
220100     OR  MMRTWS-ROLLING-12-MON-VOL
220200     OR  MMRTWS-ROLLING-1-MON-AVG-TKT
220300     OR  MMRTWS-ROLLING-3-MON-AVG-TKT
220400     OR  MMRTWS-ROLLING-6-MON-AVG-TKT
220500     OR  MMRTWS-ROLLING-12-MON-AVG-TKT
220600         SET X-WS-D200-SRA       TO 18
220700         PERFORM Z000-CALC-FEE-BASE
220800            THRU Z099-CFB-EXIT.
220900*
221000     IF  MMMM-PF1-MONTHLY-PART
221100     OR  MMMM-PF1-WEEKLY-PART
221200     OR  MMMM-PF1-BI-WEEKLY-PART
221300     OR  MMMM-PF2-MONTHLY-PART
221400     OR  MMMM-PF2-WEEKLY-PART
221500         MOVE MBD200WS-PA-WORK-AMT-1
221600                                 TO MBD200WS-PA-AMT-PREV-TODAY
221700         MOVE MBD200WS-PA-WORK-NBR-1
221800                                 TO MBD200WS-PA-NBR-PREV-TODAY.
221900*
222000*
222100*
222200     IF  MMRTWS-INCREMENTAL-METHODS
222300         MOVE ZERO               TO MBD200WS-PA-WORK-AMT-4
222400         MOVE ZERO               TO MBD200WS-PA-WORK-NBR-4
222500         PERFORM X300-LOAD-PART-W-STATS
222600            THRU X399-LPWS-EXIT
222700            VARYING X-MMRT-PRIM FROM 1 BY 1
222800              UNTIL X-MMRT-PRIM IS GREATER THAN 10
222900     ELSE
223000         PERFORM
223100            VARYING X-MMRT-PRIM FROM 1 BY 1
223200            UNTIL   X-MMRT-PRIM IS GREATER THAN 10
223300            SET X-MBD200WS-PA-TIER
223400                                 TO X-MMRT-PRIM
223500            EVALUATE TRUE
223600                WHEN MMRTWS-VALID-METH-ON-NUMBER
223700                    MOVE MMRT-PRIM-LIMIT-NBR (X-MMRT-PRIM)
223800                                 TO MBD200WS-PA-TIER-NBR-ALLOWED
223900                                    (X-MBD200WS-PA-TIER)
224000                WHEN OTHER
224100                    MOVE MMRT-PRIM-LIMIT (X-MMRT-PRIM)
224200                                 TO MBD200WS-PA-TIER-AMT-ALLOWED
224300                                    (X-MBD200WS-PA-TIER)
224400            END-EVALUATE
224500         END-PERFORM
224600     END-IF.
224700*
224800     EVALUATE TRUE
224900         WHEN MMMM-PL-PRODUCT
225000             MOVE MMMP-PROD-PART-FEE-BASE
225100                                 TO MBD200WS-PA-FEE-BASE
225200         WHEN OTHER
225300             MOVE MMMM-PART-FEE-BASE
225400                                 TO MBD200WS-PA-FEE-BASE
225500     END-EVALUATE.
225600*
225700 X099-PS-EXIT.
225800     EXIT.
225900/
226000 X300-LOAD-PART-W-STATS SECTION.
226100 X310-LPWS-BEGIN.
226200*
226300     SET X-MBD200WS-PA-TIER      TO X-MMRT-PRIM.
226400*
226500     IF  MMRTWS-VALID-METH-ON-NUMBER
226600         PERFORM X500-LOAD-TIER-NUMBERS
226700            THRU X599-LTN-EXIT
226800     ELSE
226900         PERFORM X400-LOAD-TIER-AMOUNTS
227000            THRU X499-LTA-EXIT.
227100*
227200 X399-LPWS-EXIT.
227300     EXIT.
227400/
227500 X400-LOAD-TIER-AMOUNTS SECTION.
227600 X410-LTA-BEGIN.
227700*
227800     COMPUTE MBD200WS-PA-TIER-AMT-ALLOWED (X-MBD200WS-PA-TIER)
227900                                 =  MMRT-PRIM-LIMIT (X-MMRT-PRIM)
228000                                 -  MBD200WS-PA-WORK-AMT-4.
228100*
228200     MOVE MMRT-PRIM-LIMIT (X-MMRT-PRIM)
228300                                 TO MBD200WS-PA-WORK-AMT-4.
228400*
228500     IF  MBD200WS-PA-WORK-AMT-1 IS NOT GREATER THAN
228600         MBD200WS-PA-TIER-AMT-ALLOWED (X-MBD200WS-PA-TIER)
228700         MOVE MBD200WS-PA-WORK-AMT-1
228800                                 TO MBD200WS-PA-TIER-AMT-PREV
228900                                    (X-MBD200WS-PA-TIER)
229000         MOVE ZERO               TO MBD200WS-PA-WORK-AMT-1
229100     ELSE
229200         MOVE MBD200WS-PA-TIER-AMT-ALLOWED (X-MBD200WS-PA-TIER)
229300                                 TO MBD200WS-PA-TIER-AMT-PREV
229400                                    (X-MBD200WS-PA-TIER)
229500         COMPUTE MBD200WS-PA-WORK-AMT-1
229600                                 =  MBD200WS-PA-WORK-AMT-1
229700                                 -  MBD200WS-PA-TIER-AMT-ALLOWED
229800                                    (X-MBD200WS-PA-TIER).
229900*
230000*
230100*
230200 X499-LTA-EXIT.
230300     EXIT.
230400/
230500 X500-LOAD-TIER-NUMBERS SECTION.
230600 X510-LTN-BEGIN.
230700*
230800     COMPUTE MBD200WS-PA-TIER-NBR-ALLOWED (X-MBD200WS-PA-TIER)
230900                                 =  MMRT-PRIM-LIMIT-NBR
231000                                    (X-MMRT-PRIM)
231100                                 -  MBD200WS-PA-WORK-NBR-4.
231200*
231300     MOVE MMRT-PRIM-LIMIT-NBR (X-MMRT-PRIM)
231400                                 TO MBD200WS-PA-WORK-NBR-4.
231500*
231600     IF  MBD200WS-PA-WORK-NBR-1 IS NOT GREATER THAN
231700         MBD200WS-PA-TIER-NBR-ALLOWED (X-MBD200WS-PA-TIER)
231800         MOVE MBD200WS-PA-WORK-NBR-1
231900                                 TO MBD200WS-PA-TIER-NBR-PREV
232000                                    (X-MBD200WS-PA-TIER)
232100         MOVE ZERO               TO MBD200WS-PA-WORK-NBR-1
232200     ELSE
232300         MOVE MBD200WS-PA-TIER-NBR-ALLOWED (X-MBD200WS-PA-TIER)
232400                                 TO MBD200WS-PA-TIER-NBR-PREV
232500                                    (X-MBD200WS-PA-TIER)
232600         COMPUTE MBD200WS-PA-WORK-NBR-1
232700                                 =  MBD200WS-PA-WORK-NBR-1
232800                                 -  MBD200WS-PA-TIER-NBR-ALLOWED
232900                                    (X-MBD200WS-PA-TIER).
233000*
233100*
233200*
233300 X599-LTN-EXIT.
233400     EXIT.
233500/
233600 X900-ACCUM-STATS-TABLE SECTION.
233700 X901-AST-BEGIN.
233800*
233900     INITIALIZE WS-D200-SALES-RETURNS-AREA.
234000*
234100     PERFORM
234200         VARYING X-MMPATB FROM 1 BY 1
234300         UNTIL   X-MMPATB IS GREATER THAN MMPATB-MAX-ENTRIES
234400            OR   MMPATB-END-OF-TABLE (X-MMPATB)
234500         MOVE MMPATB-RECORD (X-MMPATB)
234600                                 TO MMPA-RECORD
234700         EVALUATE TRUE
234800             WHEN MMMM-PL-PRODUCT
234900                 IF  MMPA-DETAIL
235000                 AND MMPA-PRODUCT IS EQUAL TO MMMP-PRODUCT
235100                     PERFORM Z100-ACCUM-STATS
235200                        THRU Z199-AS-EXIT
235300                 END-IF
235400             WHEN OTHER
235500                 IF  MMPA-TOTALS
235600                     PERFORM Z100-ACCUM-STATS
235700                        THRU Z199-AS-EXIT
235800                 END-IF
235900         END-EVALUATE
236000     END-PERFORM.
236100*
236200     PERFORM Z400-CALC-AVERAGE-TICKET
236300        THRU Z499-CAT-EXIT
236400        VARYING X-WS-D200-SRA FROM 1 BY 1
236500        UNTIL   X-WS-D200-SRA IS GREATER THAN 18.
236600*
236700 X999-AST-EXIT.
236800     EXIT.
236900/
237000 Z000-CALC-FEE-BASE SECTION.
237100 Z001-CFB-BEGIN.
237200*
237300     EVALUATE TRUE
237400         WHEN MMMM-PL-PRODUCT
237500             EVALUATE TRUE
237600                 WHEN MMMP-PPFB-GROSS-SALES
237700                     MOVE WS-D200-SRA-SALES-NBR (X-WS-D200-SRA)
237800                                 TO MBD200WS-PA-WORK-NBR-1
237900                     MOVE WS-D200-SRA-SALES-AMT (X-WS-D200-SRA)
238000                                 TO MBD200WS-PA-WORK-AMT-1
238100                 WHEN MMMP-PPFB-GROSS-VOLUME
238200                     COMPUTE MBD200WS-PA-WORK-NBR-1
238300                                 =  WS-D200-SRA-SALES-NBR
238400                                    (X-WS-D200-SRA)
238500                                 +  WS-D200-SRA-RETURNS-NBR
238600                                    (X-WS-D200-SRA)
238700                     END-COMPUTE
238800                     COMPUTE MBD200WS-PA-WORK-AMT-1
238900                                 =  WS-D200-SRA-SALES-AMT
239000                                    (X-WS-D200-SRA)
239100                                 +  WS-D200-SRA-RETURNS-AMT
239200                                    (X-WS-D200-SRA)
239300                     END-COMPUTE
239400                 WHEN OTHER
239500                     COMPUTE MBD200WS-PA-WORK-NBR-1
239600                                 =  WS-D200-SRA-SALES-NBR
239700                                    (X-WS-D200-SRA)
239800                                 +  WS-D200-SRA-RETURNS-NBR
239900                                    (X-WS-D200-SRA)
240000                     END-COMPUTE
240100                     COMPUTE MBD200WS-PA-WORK-AMT-1
240200                                 =  WS-D200-SRA-SALES-AMT
240300                                    (X-WS-D200-SRA)
240400                                 -  WS-D200-SRA-RETURNS-AMT
240500                                    (X-WS-D200-SRA)
240600                     END-COMPUTE
240700             END-EVALUATE
240800         WHEN OTHER
240900             EVALUATE TRUE
241000                 WHEN MMMM-PFB-GROSS-SALES
241100                     MOVE WS-D200-SRA-SALES-NBR (X-WS-D200-SRA)
241200                                 TO MBD200WS-PA-WORK-NBR-1
241300                     MOVE WS-D200-SRA-SALES-AMT (X-WS-D200-SRA)
241400                                 TO MBD200WS-PA-WORK-AMT-1
241500                 WHEN MMMM-PFB-GROSS-VOLUME
241600                     COMPUTE MBD200WS-PA-WORK-NBR-1
241700                                 =  WS-D200-SRA-SALES-NBR
241800                                    (X-WS-D200-SRA)
241900                                 +  WS-D200-SRA-RETURNS-NBR
242000                                    (X-WS-D200-SRA)
242100                     END-COMPUTE
242200                     COMPUTE MBD200WS-PA-WORK-AMT-1
242300                                 =  WS-D200-SRA-SALES-AMT
242400                                    (X-WS-D200-SRA)
242500                                 +  WS-D200-SRA-RETURNS-AMT
242600                                    (X-WS-D200-SRA)
242700                     END-COMPUTE
242800                 WHEN OTHER
242900                     COMPUTE MBD200WS-PA-WORK-NBR-1
243000                                 =  WS-D200-SRA-SALES-NBR
243100                                    (X-WS-D200-SRA)
243200                                 +  WS-D200-SRA-RETURNS-NBR
243300                                    (X-WS-D200-SRA)
243400                     END-COMPUTE
243500                     COMPUTE MBD200WS-PA-WORK-AMT-1
243600                                 =  WS-D200-SRA-SALES-AMT
243700                                    (X-WS-D200-SRA)
243800                                 -  WS-D200-SRA-RETURNS-AMT
243900                                    (X-WS-D200-SRA)
244000                     END-COMPUTE
244100             END-EVALUATE
244200     END-EVALUATE.
244300*
244400 Z099-CFB-EXIT.
244500     EXIT.
244600/
244700 Z100-ACCUM-STATS SECTION.
244800 Z101-AS-BEGIN.
244900*
245000     MOVE MMPA-LOGIC-MODULE      TO MMTCWS-LOGIC-MODULE.
245100*
245200     EVALUATE TRUE
245300         WHEN MMTCWS-LM-SALE
245400             PERFORM
245500                 VARYING X-MMPA FROM 1 BY 1
245600                 UNTIL   X-MMPA IS GREATER THAN 18
245700                 SET X-WS-D200-SRA
245800                                 TO X-MMPA
245900                 ADD MMPA-NBR (X-MMPA)
246000                                 TO WS-D200-SRA-SALES-NBR
246100                                    (X-WS-D200-SRA)
246200                 ADD MMPA-AMT (X-MMPA)
246300                                 TO WS-D200-SRA-SALES-AMT
246400                                    (X-WS-D200-SRA)
246500             END-PERFORM
246600         WHEN MMTCWS-LM-SALE-REV
246700             PERFORM
246800                 VARYING X-MMPA FROM 1 BY 1
246900                 UNTIL   X-MMPA IS GREATER THAN 18
247000                 SET X-WS-D200-SRA
247100                                 TO X-MMPA
247200                 SUBTRACT MMPA-NBR (X-MMPA)
247300                                 FROM WS-D200-SRA-SALES-NBR
247400                                      (X-WS-D200-SRA)
247500                 SUBTRACT MMPA-AMT (X-MMPA)
247600                                 FROM WS-D200-SRA-SALES-AMT
247700                                      (X-WS-D200-SRA)
247800             END-PERFORM
247900         WHEN MMTCWS-LM-RETURN
248000             PERFORM
248100                 VARYING X-MMPA FROM 1 BY 1
248200                 UNTIL   X-MMPA IS GREATER THAN 18
248300                 SET X-WS-D200-SRA
248400                                 TO X-MMPA
248500                 ADD MMPA-NBR (X-MMPA)
248600                                 TO WS-D200-SRA-RETURNS-NBR
248700                                    (X-WS-D200-SRA)
248800                 ADD MMPA-AMT (X-MMPA)
248900                                 TO WS-D200-SRA-RETURNS-AMT
249000                                    (X-WS-D200-SRA)
249100             END-PERFORM
249200         WHEN MMTCWS-LM-RETURN-REV
249300             PERFORM
249400                 VARYING X-MMPA FROM 1 BY 1
249500                 UNTIL   X-MMPA IS GREATER THAN 18
249600                 SET X-WS-D200-SRA
249700                                 TO X-MMPA
249800                 SUBTRACT MMPA-NBR (X-MMPA)
249900                                 FROM WS-D200-SRA-RETURNS-NBR
250000                                      (X-WS-D200-SRA)
250100                 SUBTRACT MMPA-AMT (X-MMPA)
250200                                 FROM WS-D200-SRA-RETURNS-AMT
250300                                      (X-WS-D200-SRA)
250400             END-PERFORM
250500         WHEN MMTCWS-LM-CR-FEES
250600             PERFORM
250700                 VARYING X-MMPA FROM 1 BY 1
250800                 UNTIL   X-MMPA IS GREATER THAN 18
250900                 SET X-WS-D200-SRA
251000                                 TO X-MMPA
251100                 SUBTRACT MMPA-AMT (X-MMPA)
251200                                 FROM WS-D200-SRA-INCOME-AMT
251300                                      (X-WS-D200-SRA)
251400             END-PERFORM
251500         WHEN MMTCWS-LM-DR-FEES
251600             PERFORM
251700                 VARYING X-MMPA FROM 1 BY 1
251800                 UNTIL   X-MMPA IS GREATER THAN 18
251900                 SET X-WS-D200-SRA
252000                                 TO X-MMPA
252100                 ADD MMPA-AMT (X-MMPA)
252200                                 TO WS-D200-SRA-INCOME-AMT
252300                                    (X-WS-D200-SRA)
252400             END-PERFORM
252500     END-EVALUATE.
252600*
252700 Z199-AS-EXIT.
252800     EXIT.
252900/
253000 Z200-SET-TRANS-INDIV-PART-FLAG SECTION.
253100 Z201-STIPF-BEGIN.
253200*
253300     EVALUATE TRUE
253400         WHEN MTPT-INDIV-PART-AMT IS LESS THAN ZERO
253500             SET MTPT-INDIV-PART-DR
253600                                 TO TRUE
253700         WHEN OTHER
253800             SET MTPT-INDIV-PART-CR
253900                                 TO TRUE
254000     END-EVALUATE.
254100*
254200 Z299-STIPF-EXIT.
254300     EXIT.
254400/
254500 Z300-SET-OVERRIDE-ADJ-FLAGS SECTION.
254600 Z301-SOAF-BEGIN.
254700*
254800     IF  WS-D200-EF-OVERRIDE
254900         SET MBD200WS-PA-OVERRIDE-YES
255000                                 TO TRUE.
255100*
255200     IF  WS-D200-EF-ADJUSTMENT
255300         SET MBD200WS-PA-ADJUSTMENT-YES
255400                                 TO TRUE.
255500*
255600 Z399-SOAF-EXIT.
255700     EXIT.
255800/
255900 Z400-CALC-AVERAGE-TICKET SECTION.
256000 Z401-CAT-BEGIN.
256100*
256200     IF  WS-D200-SRA-SALES-NBR (X-WS-D200-SRA) IS EQUAL TO ZERO
256300         MOVE ZERO               TO WS-D200-SRA-AVG-TKT
256400                                    (X-WS-D200-SRA)
256500     ELSE
256600         COMPUTE WS-D200-SRA-AVG-TKT (X-WS-D200-SRA) ROUNDED
256700                                 =  WS-D200-SRA-SALES-AMT
256800                                    (X-WS-D200-SRA)
256900                                 /  WS-D200-SRA-SALES-NBR
257000                                    (X-WS-D200-SRA)
257100     END-IF.
257200*
257300     IF  WS-D200-SRA-AVG-TKT (X-WS-D200-SRA) IS LESS THAN ZERO
257400         MOVE ZERO               TO WS-D200-SRA-AVG-TKT
257500                                    (X-WS-D200-SRA).
257600*
257700 Z499-CAT-EXIT.
257800     EXIT.
257900/
258000 9000-PERFORMED-ROUTINES-SECT SECTION.
258100*
258200 COPY SS50PD.
258300*
258400*
258500 9995-END-SOURCE-STATEMENTS SECTION.
258600 9999-END-OF-PROGRAM.
258700     GOBACK.
