000100 IDENTIFICATION DIVISION.
000200 PROGRAM-ID. MBD210.
000201*       RELEASE DATE=08/24/01.        REVISION LEVEL=08.06      * ++++++++
000202***************************************************************** ++++++++
000203*WARNING.  THIS COMPUTER PROGRAM IS PROTECTED BY COPYRIGHT LAW  * ++++++++
000204*AND INTERNATIONAL TREATIES.  UNAUTHORIZED REPRODUCTION OR      * ++++++++
000205*DISTRIBUTION OF THIS PROGRAM, OR ANY PORTION OF IT, MAY RESULT * ++++++++
000206*IN SEVERE CIVIL AND CRIMINAL PENATLIES, AND WILL BE PROSECUTED * ++++++++
000207*TO THE MAXIMUM EXTENT POSSIBLE UNDER THE LAW.                  * ++++++++
000208*COPYRIGHT 1999 PAYSYS INTERNATIONAL, INC.  ALL RIGHTS RESERVED.* ++++++++
000209***************************************************************** ++++++++
000300*****************************************************************
000400*                                                               *
000500*   V - PLUS  M E R C H A N T   B A N K C A R D   S Y S T E M   *
000600*                                                               *
000700*   MBD210 - MERCHANT CLOSE/PURGE SECONDARY FUNCTIONS           *
000800*                                                               *
000900*****************************************************************
001000*                                                               *
001100*   THIS PROGRAM PERFORMS THREE FUNCTIONS.....................  *
001200*                                                               *
001300*   1. TO CREATE THE FILE TO AUTOMATICALLY CHANGE THE STORE     *
001400*      STATUS WHEN THE MERCHANT STATUS CHANGES.                 *
001500*      (FILE MTMS - USED BY PROGRAM MBD360)                     *
001600*                                                               *
001700*   2. TO CREATE THE FILE TO AUTOMATICALLY DELETE A MERCHANT    *
001800*      FROM THE MERCHANT CHAIN DETAIL RECORDS WHEN THE MERCHANT *
001900*      IS PURGED (SET TO STATUS 9).                             *
002000*      (FILE MTM9 - USED BY PROGRAM MBD320)                     *
002100*                                                               *
002200*   3. TO UPDATE THE MMXR (STORE/MERCHANT CROSS-REFERENCE FILE) *
002300*      WHEN THE MERCHANT IS PURGED (SET TO STATUS 9).           *
002400*                                                               *
002500*****************************************************************
002600 ENVIRONMENT DIVISION.
002700 CONFIGURATION SECTION.
002800 SOURCE-COMPUTER.            IBM-4341.
002900 OBJECT-COMPUTER.            IBM-4341.
003000/
003100 INPUT-OUTPUT SECTION.
003200*
003300 FILE-CONTROL.
003400*
003500     COPY MS1SES.
003600/
003700 DATA DIVISION.
003800 FILE SECTION.
003900*
004000     COPY MS1SSD.
004100     COPY MTMSRL.
004200     03  MS1S-FILE-CODE      PIC  X(01).
004300         88  MS1S-FC-IS-MTMS                 VALUE '0'.
004400         88  MS1S-FC-IS-MTM9                 VALUE '9'.
004500/
004600 WORKING-STORAGE SECTION.
004700*
004800 01  FILLER                  PIC  X(12)      VALUE '** WS-BEG **'.
004900*
005000     COPY MMSCIO.
005100/
005200     COPY MB00RB REPLACING ==:MB00:== BY ==MMSC==.
005300/
005400     COPY MMSCRL.
005500/
005600     COPY MMXRIO.
005700/
005800     COPY MB00RB REPLACING ==:MB00:== BY ==MMXR==.
005900/
006000     COPY MMXRRL.
006100/
006200     COPY MB00RB REPLACING ==:MB00:== BY ==MS1S==.
006300/
006400     COPY MB00RB REPLACING ==:MB00:== BY ==MS2S==.
006500/
006600     COPY MTM6IO.
006700/
006800     COPY MB00RB REPLACING ==:MB00:== BY ==MTM6==.
006900/
007000     COPY MTM6RL.
007100/
007200     COPY MTMSIO.
007300/
007400     COPY MB00RB REPLACING ==:MB00:== BY ==MTMS==.
007500/
007600     COPY MTM9IO.
007700/
007800     COPY MB00RB REPLACING ==:MB00:== BY ==MTM9==.
007900/
008000     COPY MTM9RL.
008100/
008200     COPY MB00WS.
008300/
008400     COPY MB99WS.
008500/
008600     COPY SS00WS.
008700/
008800     COPY SS01WS.
008900/
009000     COPY SS02WS.
009100*
009200 01  FILLER                  PIC  X(12)      VALUE '** WS-END **'.
009300/
009400 PROCEDURE DIVISION.
009500 A000-MAIN-LINE-SECT SECTION.
009600 A010-ML-BEGIN.
009700*
009800     MOVE 'MBD210'               TO SS02WS-ABEND-PROG-ID.
009900*
010000     PERFORM A100-OPEN-FILES
010100        THRU A199-OF-EXIT.
010200*
010300     PERFORM A200-SORT-PROCESS
010400        THRU A299-SP-EXIT.
010500*
010600     PERFORM A300-CLOSE-FILES
010700        THRU A399-CF-EXIT.
010800*
010900     STOP RUN.
011000*
011100 A099-ML-EXIT.
011200     EXIT.
011300/
011400 A100-OPEN-FILES SECTION.
011500 A101-OF-BEGIN.
011600*
011700     MOVE 'O1SC'                 TO SS02WS-ABEND-LOCATION.
011800     SET MMSCRB-OPEN-INPUT       TO TRUE.
011900     PERFORM MB00PD-MMSC-ACCESS
012000        THRU MB00PD-MMSC-ACCESS-EXIT.
012100*
012200     MOVE 'R1SC'                 TO SS02WS-ABEND-LOCATION.
012300     SET MMSCRB-READ-SEQ         TO TRUE.
012400     PERFORM MB00PD-MMSC-ACCESS
012500        THRU MB00PD-MMSC-ACCESS-EXIT.
012600*
012700     MOVE 'MMSC'                 TO MB99WS-FILE-ID.
012800*
012900     IF  MMSCIO-HEADER
013000         NEXT SENTENCE
013100     ELSE
013200         PERFORM MB99PD-MISSING-HEADER-ABEND
013300            THRU MB99PD-MHA-EXIT.
013400*
013500     MOVE MMSCIO-RECORD          TO MMSC-RECORD.
013600     MOVE MMSC-TODAYS-JULIAN     TO MB99WS-PROC-DATE.
013700     MOVE MMSC-TIME-STAMP        TO MB99WS-PROC-TIME.
013800*
013900*
014000*
014100     MOVE 'O1XR'                 TO SS02WS-ABEND-LOCATION.
014200     SET MMXRRB-OPEN-IO          TO TRUE.
014300     PERFORM MB00PD-MMXR-ACCESS
014400        THRU MB00PD-MMXR-ACCESS-EXIT.
014500*
014600     MOVE 'R1XR'                 TO SS02WS-ABEND-LOCATION.
014700     SET MMXRRB-READ-SEQ         TO TRUE.
014800     PERFORM MB00PD-MMXR-ACCESS
014900        THRU MB00PD-MMXR-ACCESS-EXIT.
015000*
015100     MOVE 'MMXR'                 TO MB99WS-FILE-ID.
015200*
015300     IF  MMXRIO-HEADER
015400         NEXT SENTENCE
015500     ELSE
015600         PERFORM MB99PD-MISSING-HEADER-ABEND
015700            THRU MB99PD-MHA-EXIT.
015800*
015900     MOVE MMXRIO-DATE-STAMP      TO MB99WS-FILE-DATE.
016000     MOVE MMXRIO-TIME-STAMP      TO MB99WS-FILE-TIME.
016100     PERFORM MB99PD-CHECK-DATE-TIME
016200        THRU MB99PD-CDT-EXIT.
016300*
016400     MOVE MMXRIO-RECORD          TO MMXR-RECORD.
016500*
016600*
016700*
016800     MOVE 'O1M6'                 TO SS02WS-ABEND-LOCATION.
016900     SET MTM6RB-OPEN-INPUT       TO TRUE.
017000     PERFORM MB00PD-MTM6-ACCESS
017100        THRU MB00PD-MTM6-ACCESS-EXIT.
017200*
017300     MOVE 'R0M6'                 TO SS02WS-ABEND-LOCATION.
017400     SET MTM6RB-READ-SEQ         TO TRUE.
017500     PERFORM MB00PD-MTM6-ACCESS
017600        THRU MB00PD-MTM6-ACCESS-EXIT.
017700     MOVE 'MTM6'                 TO MB99WS-FILE-ID.
017800*
017900     IF  MTM6IO-HEADER
018000         NEXT SENTENCE
018100     ELSE
018200         PERFORM MB99PD-MISSING-HEADER-ABEND
018300            THRU MB99PD-MHA-EXIT.
018400*
018500     MOVE MTM6IO-DATE-STAMP      TO MB99WS-FILE-DATE.
018600     MOVE MTM6IO-TIME-STAMP      TO MB99WS-FILE-TIME.
018700     PERFORM MB99PD-CHECK-DATE-TIME
018800        THRU MB99PD-CDT-EXIT.
018900*
019000     MOVE MTM6IO-RECORD          TO MTM6-RECORD.
019100*
019200*
019300*
019400     MOVE 'O1MS'                 TO SS02WS-ABEND-LOCATION.
019500     SET MTMSRB-OPEN-OUTPUT      TO TRUE.
019600     PERFORM MB00PD-MTMS-ACCESS
019700        THRU MB00PD-MTMS-ACCESS-EXIT.
019800*
019900     MOVE SPACES                 TO MTMSIO-RECORD.
020000     SET MTMSIO-HEADER           TO TRUE.
020100     MOVE MMSC-TODAYS-JULIAN     TO MTMSIO-DATE-STAMP.
020200     MOVE MMSC-TIME-STAMP        TO MTMSIO-TIME-STAMP.
020300*
020400     MOVE 'W0MS'                 TO SS02WS-ABEND-LOCATION.
020500     SET MTMSRB-WRITE            TO TRUE.
020600     PERFORM MB00PD-MTMS-ACCESS
020700        THRU MB00PD-MTMS-ACCESS-EXIT.
020800*
020900*
021000*
021100     MOVE 'O1M9'                 TO SS02WS-ABEND-LOCATION.
021200     SET MTM9RB-OPEN-OUTPUT      TO TRUE.
021300     PERFORM MB00PD-MTM9-ACCESS
021400        THRU MB00PD-MTM9-ACCESS-EXIT.
021500*
021600     MOVE SPACES                 TO MTM9IO-RECORD.
021700     SET MTM9IO-HEADER           TO TRUE.
021800     MOVE MMSC-TODAYS-JULIAN     TO MTM9IO-DATE-STAMP.
021900     MOVE MMSC-TIME-STAMP        TO MTM9IO-TIME-STAMP.
022000*
022100     MOVE 'W0M9'                 TO SS02WS-ABEND-LOCATION.
022200     SET MTM9RB-WRITE            TO TRUE.
022300     PERFORM MB00PD-MTM9-ACCESS
022400        THRU MB00PD-MTM9-ACCESS-EXIT.
022500*
022600 A199-OF-EXIT.
022700     EXIT.
022800*
022900*
023000*
023100 A200-SORT-PROCESS SECTION.
023200 A201-SP-BEGIN.
023300*
023400     SORT MS1S-SORT-FILE
023500         ON ASCENDING KEY MS1S-FILE-CODE
023600                          MTMS-KEY
023700         INPUT  PROCEDURE IS 1000-BUILD-FILES
023800         OUTPUT PROCEDURE IS 2000-WRITE-FILES.
023900*
024000     PERFORM SS98PD-VERIFY-SORT-RETURN
024100        THRU SS98PD-VSR-EXIT.
024200*
024300 A299-SP-EXIT.
024400     EXIT.
024500/
024600 A300-CLOSE-FILES SECTION.
024700 A301-CF-BEGIN.
024800*
024900     MOVE SPACES                 TO MTMSIO-RECORD.
025000     SET MTMSIO-TRAILER          TO TRUE.
025100     MOVE MMSC-TODAYS-JULIAN     TO MTMSIO-DATE-STAMP.
025200     MOVE MMSC-TIME-STAMP        TO MTMSIO-TIME-STAMP.
025300*
025400     MOVE 'W9MS'                 TO SS02WS-ABEND-LOCATION.
025500     SET MTMSRB-WRITE            TO TRUE.
025600     PERFORM MB00PD-MTMS-ACCESS
025700        THRU MB00PD-MTMS-ACCESS-EXIT.
025800*
025900*
026000*
026100     MOVE SPACES                 TO MTM9IO-RECORD.
026200     SET MTM9IO-TRAILER          TO TRUE.
026300     MOVE MMSC-TODAYS-JULIAN     TO MTM9IO-DATE-STAMP.
026400     MOVE MMSC-TIME-STAMP        TO MTM9IO-TIME-STAMP.
026500*
026600     MOVE 'W9M9'                 TO SS02WS-ABEND-LOCATION.
026700     SET MTM9RB-WRITE            TO TRUE.
026800     PERFORM MB00PD-MTM9-ACCESS
026900        THRU MB00PD-MTM9-ACCESS-EXIT.
027000*
027100*
027200*
027300     MOVE 'C1M6'                 TO SS02WS-ABEND-LOCATION.
027400     SET MTM6RB-CLOSE            TO TRUE.
027500     PERFORM MB00PD-MTM6-ACCESS
027600        THRU MB00PD-MTM6-ACCESS-EXIT.
027700*
027800     MOVE 'C1MS'                 TO SS02WS-ABEND-LOCATION.
027900     SET MTMSRB-CLOSE            TO TRUE.
028000     PERFORM MB00PD-MTMS-ACCESS
028100        THRU MB00PD-MTMS-ACCESS-EXIT.
028200*
028300     MOVE 'C1M9'                 TO SS02WS-ABEND-LOCATION.
028400     SET MTM9RB-CLOSE            TO TRUE.
028500     PERFORM MB00PD-MTM9-ACCESS
028600        THRU MB00PD-MTM9-ACCESS-EXIT.
028700*
028800     MOVE 'C1XR'                 TO SS02WS-ABEND-LOCATION.
028900     SET MMXRRB-CLOSE            TO TRUE.
029000     PERFORM MB00PD-MMXR-ACCESS
029100        THRU MB00PD-MMXR-ACCESS-EXIT.
029200*
029300     MOVE 'C1SC'                 TO SS02WS-ABEND-LOCATION.
029400     SET MMSCRB-CLOSE            TO TRUE.
029500     PERFORM MB00PD-MMSC-ACCESS
029600        THRU MB00PD-MMSC-ACCESS-EXIT.
029700*
029800 A399-CF-EXIT.
029900     EXIT.
030000/
030100 1000-BUILD-FILES SECTION.
030200 1001-BF-BEGIN.
030300*
030400     MOVE 'R1M6'                 TO SS02WS-ABEND-LOCATION.
030500     SET MTM6RB-READ-SEQ         TO TRUE.
030600     PERFORM MB00PD-MTM6-ACCESS
030700        THRU MB00PD-MTM6-ACCESS-EXIT.
030800*
030900     IF  MTM6IO-HEADER
031000         GO TO 1001-BF-BEGIN.
031100*
031200     IF  MTM6IO-TRAILER
031300         GO TO 1999-BF-EXIT.
031400*
031500     MOVE MTM6IO-RECORD          TO MTM6-RECORD.
031600*
031700     PERFORM
031800         UNTIL MMXRIO-ORG-MERCHANT IS GREATER THAN
031900                 MTM6-ORG-MERCHANT
032000         MOVE MMXRIO-RECORD      TO MMXR-RECORD
032100         EVALUATE TRUE
032200             WHEN MMXRIO-ORG-MERCHANT IS NOT EQUAL TO
032300                    MTM6-ORG-MERCHANT
032400                 CONTINUE
032410             WHEN MMXR-REC-PURGED                                 FX800005
032412                 CONTINUE                                         FX800005
032500             WHEN OTHER
032600                 PERFORM 1700-CREATE-MTMS
032700                    THRU 1799-C-MTMS-EXIT
032800                 PERFORM 1800-UPDATE-MMXR
032900                    THRU 1899-U-MMXR-EXIT
033000         END-EVALUATE
033100         MOVE 'R1XR'             TO SS02WS-ABEND-LOCATION
033200         SET MMXRRB-READ-SEQ     TO TRUE
033300         PERFORM MB00PD-MMXR-ACCESS
033400            THRU MB00PD-MMXR-ACCESS-EXIT
033500     END-PERFORM.
033600*
033700     IF  MTM6-REC-PURGED
033800         PERFORM
033900             VARYING X-MTM6-MERCH-CHAIN FROM 1 BY 1
034000             UNTIL   X-MTM6-MERCH-CHAIN IS GREATER THAN 10
034100             EVALUATE TRUE
034200                 WHEN MTM6-MERCH-CHAIN-ID (X-MTM6-MERCH-CHAIN)
034300                                 IS EQUAL TO ZERO
034400                     CONTINUE
034500                 WHEN OTHER
034600                     PERFORM 1600-CREATE-MTM9
034700                        THRU 1699-C-MTM9-EXIT
034800             END-EVALUATE
034900         END-PERFORM
035000     END-IF.
035100*
035200     GO TO 1001-BF-BEGIN.
035300*
035400*
035500*
035600 1600-CREATE-MTM9.
035700*
035800     MOVE SPACES                 TO MTM9-RECORD.
035900     MOVE MTM6-ORG               TO MTM9-ORG.
036000     MOVE MTM6-MERCH-CHAIN-ID (X-MTM6-MERCH-CHAIN)
036100                                 TO MTM9-CHAIN.
036200     MOVE MTM6-REC-STATUS        TO MTM9-REC-STATUS.
036300     MOVE MTM6-MERCHANT          TO MTM9-MEMBER.
036400     MOVE MTM9-RECORD            TO MTMS-RECORD.
036500     SET  MS1S-FC-IS-MTM9        TO TRUE.
036600     RELEASE MTMS-RECORD.
036700*
036800 1699-C-MTM9-EXIT.
036900     EXIT.
037000*
037100*
037200*
037300 1700-CREATE-MTMS.
037400*
037500     MOVE MTM6-RECORD            TO MTMS-RECORD
037600     MOVE MMXR-STORE             TO MTMS-STORE.
037700     SET  MS1S-FC-IS-MTMS        TO TRUE.
037800     RELEASE MTMS-RECORD.
037900*
038000 1799-C-MTMS-EXIT.
038100     EXIT.
038200*
038300*
038400*
038500 1800-UPDATE-MMXR.
038600*
038700     IF  MTM6-REC-PURGED
038800         NEXT SENTENCE
038900     ELSE
039000         GO TO 1899-U-MMXR-EXIT.
039100*
039200     SET  MMXR-REC-PURGED        TO TRUE.
039300     MOVE MMXR-RECORD            TO MMXRIO-RECORD.
039400*
039500     MOVE 'U1XR'                 TO SS02WS-ABEND-LOCATION.
039600     SET MMXRRB-REWRITE          TO TRUE.
039700     PERFORM MB00PD-MMXR-ACCESS
039800        THRU MB00PD-MMXR-ACCESS-EXIT.
039900*
040000 1899-U-MMXR-EXIT.
040100     EXIT.
040200*
040300*
040400*
040500 1999-BF-EXIT.
040600     EXIT.
040700/
040800 2000-WRITE-FILES SECTION.
040900 2001-WF-BEGIN.
041000*
041100     RETURN MS1S-SORT-FILE
041200         AT END
041300             GO TO 2999-WF-EXIT.
041400*
041500     EVALUATE TRUE
041600         WHEN MS1S-FC-IS-MTMS
041700             MOVE MTMS-RECORD    TO MTMSIO-RECORD
041800             MOVE 'W1MS'         TO SS02WS-ABEND-LOCATION
041900             SET MTMSRB-WRITE    TO TRUE
042000             PERFORM MB00PD-MTMS-ACCESS
042100                THRU MB00PD-MTMS-ACCESS-EXIT
042200         WHEN MS1S-FC-IS-MTM9
042300             MOVE MTMS-RECORD    TO MTM9IO-RECORD
042400             MOVE 'W1M9'         TO SS02WS-ABEND-LOCATION
042500             SET MTM9RB-WRITE    TO TRUE
042600             PERFORM MB00PD-MTM9-ACCESS
042700                THRU MB00PD-MTM9-ACCESS-EXIT
042800     END-EVALUATE.
042900*
043000     GO TO 2001-WF-BEGIN.
043100*
043200 2999-WF-EXIT.
043300     EXIT.
043400/
043500 9000-PERFORMED-ROUTINES-SECT SECTION.
043600*
043700     COPY MB00PD REPLACING ==:MB00:== BY ==MMSC==.
043800/
043900     COPY MB00PD REPLACING ==:MB00:== BY ==MMXR==.
044000/
044100     COPY MB00PD REPLACING ==:MB00:== BY ==MTM6==.
044200/
044300     COPY MB00PD REPLACING ==:MB00:== BY ==MTMS==.
044400/
044500     COPY MB00PD REPLACING ==:MB00:== BY ==MTM9==.
044600/
044700     COPY MB99PD.
044800/
044900     COPY SS02PD.
045000/
045100     COPY SS98PD.
045200*
045300 9995-END-SOURCE-STATEMENTS SECTION.
045400 9999-END-OF-PROGRAM.
045500     EXIT.
