000100 IDENTIFICATION DIVISION.
000200 PROGRAM-ID. MBD260.
000201*       RELEASE DATE=08/24/01.        REVISION LEVEL=08.06      *
000202*****************************************************************
000203*WARNING.  THIS COMPUTER PROGRAM IS PROTECTED BY COPYRIGHT LAW  *
000204*AND INTERNATIONAL TREATIES.  UNAUTHORIZED REPRODUCTION OR      *
000205*DISTRIBUTION OF THIS PROGRAM, OR ANY PORTION OF IT, MAY RESULT *
000206*IN SEVERE CIVIL AND CRIMINAL PENATLIES, AND WILL BE PROSECUTED *
000207*TO THE MAXIMUM EXTENT POSSIBLE UNDER THE LAW.                  *
000208*COPYRIGHT 1999 PAYSYS INTERNATIONAL, INC.  ALL RIGHTS RESERVED.*
000209*****************************************************************
000300*****************************************************************
000400*                                                               *
000500*   V - PLUS  M E R C H A N T   B A N K C A R D   S Y S T E M   *
000600*                                                               *
000700*       MBD260 - BUILD MERCHANT EXPENSE STATISTICS              *
000800*                                                               *
000900*****************************************************************
001000 ENVIRONMENT DIVISION.
001100 CONFIGURATION SECTION.
001200 SOURCE-COMPUTER.            IBM-4341.
001300 OBJECT-COMPUTER.            IBM-4341.
001400*
001500 INPUT-OUTPUT SECTION.
001600 FILE-CONTROL.
001700*
001800 DATA DIVISION.
001900 FILE SECTION.
002000/
002100 WORKING-STORAGE SECTION.
002200*
002300 01  FILLER                  PIC  X(12)      VALUE '** WS-BEG **'.
002400*
002500 01  WS-MBD260-WORK-AREAS.
002600     03  WS-D260-STMT-SW     PIC  X(01)      VALUE 'N'.
002700         88  WS-D260-NO-STMT-TODAY           VALUE 'N'.
002800         88  WS-D260-STMT-TODAY              VALUE 'Y'.
002900     03  WS-D260-DISC-SW     PIC  X(01)      VALUE 'N'.
003000         88  WS-D260-NO-DISC-TODAY           VALUE 'N'.
003100         88  WS-D260-DISC-TODAY              VALUE 'Y'.
003200     03  WS-D260-PART-SW     PIC  X(01)      VALUE 'N'.
003300         88  WS-D260-NO-PART-TODAY           VALUE 'N'.
003400         88  WS-D260-PART-TODAY              VALUE 'Y'.
003500     03  WS-D260-SETT-SW     PIC  X(01)      VALUE 'N'.
003600         88  WS-D260-NO-SETT-TODAY           VALUE 'N'.
003700         88  WS-D260-SETT-TODAY              VALUE 'Y'.
003800     03  WS-D260-RPT-REC-TYPE
003900                             PIC  9(01)      VALUE ZERO.
004000     03  WS-D260-BUBBLE-SW   PIC  X(01)      VALUE 'Y'.
004100         88  WS-D260-BUBBLE-SWAP             VALUE 'Y'.
004200         88  WS-D260-BUBBLE-NO-SWAP          VALUE 'N'.
004300     03  WS-D260-AMT-NO-SIGN PIC  9(17)      VALUE ZERO.
004400*
004500     03  WS-D260-INDEX       PIC S9(08)      BINARY  VALUE ZERO.
004600*
004700*
004800*
004900     03  WS-D260-WORK-DATE   PIC S9(07)      COMP-3 VALUE ZERO.
005000     03  WS-D260-WORK-JULIAN PIC  9(07)      VALUE ZERO.
005100     03  WS-D260-LAST-MM     PIC  9(02)      VALUE ZERO.
005200     03  WS-D260-LAST-DD     PIC  9(02)      VALUE ZERO.
005300     03  WS-D260-LAST-YY     PIC  9(04)      VALUE ZERO.
005400     03  WS-D260-LAST-DOW    PIC  9(01)      VALUE ZERO.
005500     03  WS-D260-CURR-MM     PIC  9(02)      VALUE ZERO.
005600     03  WS-D260-CURR-DD     PIC  9(02)      VALUE ZERO.
005700     03  WS-D260-CURR-YY     PIC  9(04)      VALUE ZERO.
005800     03  WS-D260-CURR-DOW    PIC  9(01)      VALUE ZERO.
005900     03  WS-D260-NEXT-MM     PIC  9(02)      VALUE ZERO.
006000     03  WS-D260-NEXT-DD     PIC  9(02)      VALUE ZERO.
006100     03  WS-D260-NEXT-YY     PIC  9(04)      VALUE ZERO.
006200     03  WS-D260-NEXT-DOW    PIC  9(01)      VALUE ZERO.
006300     03  WS-D260-ACCR-MM     PIC  9(02)      VALUE ZERO.
006400     03  WS-D260-ACCR-DD     PIC  9(02)      VALUE ZERO.
006500     03  WS-D260-ACCR-YY     PIC  9(04)      VALUE ZERO.
006600     03  WS-D260-ACCR-DOW    PIC  9(01)      VALUE ZERO.
006700     03  WS-D260-LACC-MM     PIC  9(02)      VALUE ZERO.
006800     03  WS-D260-LACC-DD     PIC  9(02)      VALUE ZERO.
006900     03  WS-D260-LACC-YY     PIC  9(04)      VALUE ZERO.
007000     03  WS-D260-LACC-DOW    PIC  9(01)      VALUE ZERO.
007100     03  WS-D260-WTD-DAYS-COUNT
007200                             PIC  9(05)      VALUE ZERO.
007300     03  WS-D260-WTD-PROC-DAYS
007400                             PIC  9(05)      VALUE ZERO.
007500     03  WS-D260-NBR-PROC-DAYS
007600                             PIC  9(05)      VALUE ZERO.
007700     03  WS-D260-PROC-DAYS-AREA              VALUE ZERO.
007800         05  WS-D260-PROC-DAYS-TABLE         OCCURS 31 TIMES
007900                                             INDEXED BY
008000                                             X-WS-D260-PDT.
008100             07  WS-D260-PDT-DOM
008200                             PIC  9(01).
008300                 88  WS-D260-PDT-NOT-PROC    VALUE ZERO.
008400                 88  WS-D260-PDT-PROCESSING  VALUE 1 THRU 7.
008500                 88  WS-D260-PDT-SUN         VALUE 1.
008600                 88  WS-D260-PDT-MON         VALUE 2.
008700                 88  WS-D260-PDT-TUE         VALUE 3.
008800                 88  WS-D260-PDT-WED         VALUE 4.
008900                 88  WS-D260-PDT-THU         VALUE 5.
009000                 88  WS-D260-PDT-FRI         VALUE 6.
009100                 88  WS-D260-PDT-SAT         VALUE 7.
009200/
009300     COPY MMSCRL.
009400/
009500     COPY MMOCRL.
009600/
009700     COPY MMMMIR.
009800/
009900     COPY MMMMRL.
010000/
010100     COPY MMMMWS.
010200/
010300     COPY MMPAIR REPLACING ==:MMPA:== BY ==MMOE==.
010400/
010500     COPY MMPARL REPLACING ==:MMPA:== BY ==MMOE==.
010600/
010700     COPY MMPAIR REPLACING ==:MMPA:== BY ==MMPE==.
010800/
010900     COPY MMPARL REPLACING ==:MMPA:== BY ==MMPE==.
011000/
011100     COPY MMTCRL.
011200/
011300     COPY MMPARL REPLACING ==:MMPA:== BY ==MTOE==.
011400/
011500     COPY MMPARL REPLACING ==:MMPA:== BY ==MTPE==.
011600/
011700     COPY MTPTRL REPLACING ==:MTPT:== BY ==MTPT==.
011800/
011900******************************************************************
012000     COPY MMSCIO.
012100/
012200     COPY MMOCIO.
012300/
012400     COPY MMMMIO.
012500/
012600     COPY MMPAIO REPLACING ==:MMPA:== BY ==MMOE==.
012700/
012800     COPY MMPAIO REPLACING ==:MMPA:== BY ==MMPE==.
012900/
013000     COPY MMTCIO.
013100/
013200     COPY MMPAIO REPLACING ==:MMPA:== BY ==MTOE==.
013300/
013400     COPY MMPAIO REPLACING ==:MMPA:== BY ==MTPE==.
013500/
013600     COPY MTPTIO REPLACING ==:MTPT:== BY ==MTET==.
013700/
013800******************************************************************
013900     COPY MB00RB REPLACING ==:MB00:== BY ==MMSC==.
014000/
014100     COPY MB00RB REPLACING ==:MB00:== BY ==MMOC==.
014200/
014300     COPY MB00RB REPLACING ==:MB00:== BY ==MMMM==.
014400/
014500     COPY MB00RB REPLACING ==:MB00:== BY ==MMOE==.
014600/
014700     COPY MB00RB REPLACING ==:MB00:== BY ==MMPE==.
014800/
014900     COPY MB00RB REPLACING ==:MB00:== BY ==MMTC==.
015000/
015100     COPY MB00RB REPLACING ==:MB00:== BY ==MTOE==.
015200/
015300     COPY MB00RB REPLACING ==:MB00:== BY ==MTPE==.
015400/
015500     COPY MB00RB REPLACING ==:MB00:== BY ==MTET==.
015600/
015700******************************************************************
015800     COPY MMPATB REPLACING ==:MMPA:== BY ==MMOE==.
015900/
016000     COPY MMPATB REPLACING ==:MMPA:== BY ==MMPE==.
016100/
016200     COPY MMTCTB.
016300/
016400******************************************************************
016500     COPY MMTCWS.
016600/
016700     COPY MTPTWS REPLACING ==:MTPT:== BY ==MTPT==.
016800/
016900     COPY MB00WS.
017000/
017100     COPY MB99WS.
017200/
017300     COPY SS00WS.
017400/
017500     COPY SS01WS.
017600/
017700     COPY SS02WS.
017800/
017900     COPY SS05WS.
018000/
018100     COPY SS12WS.
018200*
018300 01  FILLER                  PIC  X(12)      VALUE '** WS-END **'.
018400/
018500 PROCEDURE DIVISION.
018600 A000-MAIN-LINE-SECT SECTION.
018700 A010-ML-BEGIN.
018800*
018900     MOVE 'MBD260'               TO SS02WS-ABEND-PROG-ID.
019000*
019100     PERFORM A100-OPEN-FILES
019200        THRU A199-OF-EXIT.
019300*
019400     PERFORM A200-POSTING-PROCESS
019500        THRU A299-PP-EXIT
019600        UNTIL MMOCIO-TRAILER.
019700*
019800     PERFORM A300-CLOSE-FILES
019900        THRU A399-CF-EXIT.
020000*
020100     STOP RUN.
020200*
020300 A099-ML-EXIT.
020400     EXIT.
020500/
020600 A100-OPEN-FILES SECTION.
020700 A101-OF-OPEN-FILES.
020800*
020900     MOVE 'O1SC'                 TO SS02WS-ABEND-LOCATION.
021000     SET MMSCRB-OPEN-INPUT       TO TRUE.
021100     PERFORM MB00PD-MMSC-ACCESS
021200        THRU MB00PD-MMSC-ACCESS-EXIT.
021300*
021400     MOVE 'O1OC'                 TO SS02WS-ABEND-LOCATION.
021500     SET MMOCRB-OPEN-INPUT       TO TRUE.
021600     PERFORM MB00PD-MMOC-ACCESS
021700        THRU MB00PD-MMOC-ACCESS-EXIT.
021800*
021900     MOVE 'O1OE'                 TO SS02WS-ABEND-LOCATION.
022000     SET MMOERB-OPEN-INPUT       TO TRUE.
022100     PERFORM MB00PD-MMOE-ACCESS
022200        THRU MB00PD-MMOE-ACCESS-EXIT.
022300*
022400     MOVE 'O1MM'                 TO SS02WS-ABEND-LOCATION.
022500     SET MMMMRB-OPEN-INPUT       TO TRUE.
022600     PERFORM MB00PD-MMMM-ACCESS
022700        THRU MB00PD-MMMM-ACCESS-EXIT.
022800*
022900     MOVE 'O1PE'                 TO SS02WS-ABEND-LOCATION.
023000     SET MMPERB-OPEN-INPUT       TO TRUE.
023100     PERFORM MB00PD-MMPE-ACCESS
023200        THRU MB00PD-MMPE-ACCESS-EXIT.
023300*
023400     MOVE 'O1TC'                 TO SS02WS-ABEND-LOCATION.
023500     SET MMTCRB-OPEN-INPUT       TO TRUE.
023600     PERFORM MB00PD-MMTC-ACCESS
023700        THRU MB00PD-MMTC-ACCESS-EXIT.
023800*
023900     MOVE 'O1ET'                 TO SS02WS-ABEND-LOCATION.
024000     SET MTETRB-OPEN-INPUT       TO TRUE.
024100     PERFORM MB00PD-MTET-ACCESS
024200        THRU MB00PD-MTET-ACCESS-EXIT.
024300*
024400*
024500*
024600     MOVE 'OAOE'                 TO SS02WS-ABEND-LOCATION.
024700     SET MTOERB-OPEN-OUTPUT      TO TRUE.
024800     PERFORM MB00PD-MTOE-ACCESS
024900        THRU MB00PD-MTOE-ACCESS-EXIT.
025000*
025100     MOVE 'OAPE'                 TO SS02WS-ABEND-LOCATION.
025200     SET MTPERB-OPEN-OUTPUT      TO TRUE.
025300     PERFORM MB00PD-MTPE-ACCESS
025400        THRU MB00PD-MTPE-ACCESS-EXIT.
025500*
025600 A110-OF-CHECK-HEADERS.
025700*
025800     MOVE 'R0SC'                 TO SS02WS-ABEND-LOCATION.
025900     SET MMSCRB-READ-SEQ         TO TRUE.
026000     PERFORM MB00PD-MMSC-ACCESS
026100        THRU MB00PD-MMSC-ACCESS-EXIT.
026200*
026300     MOVE 'MMSC'                 TO MB99WS-FILE-ID.
026400*
026500     IF  MMSCIO-HEADER
026600         NEXT SENTENCE
026700     ELSE
026800         PERFORM MB99PD-MISSING-HEADER-ABEND
026900            THRU MB99PD-MHA-EXIT.
027000*
027100     MOVE MMSCIO-RECORD          TO MMSC-RECORD.
027200     MOVE MMSC-TODAYS-JULIAN     TO MB99WS-PROC-DATE.
027300     MOVE MMSC-TIME-STAMP        TO MB99WS-PROC-TIME.
027400*
027500*
027600*
027700     MOVE 'R0OC'                 TO SS02WS-ABEND-LOCATION.
027800     SET MMOCRB-READ-SEQ         TO TRUE.
027900     PERFORM MB00PD-MMOC-ACCESS
028000        THRU MB00PD-MMOC-ACCESS-EXIT.
028100     MOVE 'MMOC'                 TO MB99WS-FILE-ID.
028200*
028300     IF  MMOCIO-HEADER
028400         NEXT SENTENCE
028500     ELSE
028600         PERFORM MB99PD-MISSING-HEADER-ABEND
028700            THRU MB99PD-MHA-EXIT.
028800*
028900     MOVE MMOCIO-DATE-STAMP      TO MB99WS-FILE-DATE.
029000     MOVE MMOCIO-TIME-STAMP      TO MB99WS-FILE-TIME.
029100     PERFORM MB99PD-CHECK-DATE-TIME
029200        THRU MB99PD-CDT-EXIT.
029300*
029400     MOVE MMOCIO-RECORD          TO MMOC-RECORD.
029500*
029600*
029700*
029800     MOVE 'R0MM'                 TO SS02WS-ABEND-LOCATION.
029900     SET MMMMRB-READ-SEQ         TO TRUE.
030000     PERFORM MB00PD-MMMM-ACCESS
030100        THRU MB00PD-MMMM-ACCESS-EXIT.
030200     MOVE 'MMMM'                 TO MB99WS-FILE-ID.
030300*
030400     IF  MMMMIO-HEADER
030500         NEXT SENTENCE
030600     ELSE
030700         PERFORM MB99PD-MISSING-HEADER-ABEND
030800            THRU MB99PD-MHA-EXIT.
030900*
031000     MOVE MMMMIO-DATE-STAMP      TO MB99WS-FILE-DATE.
031100     MOVE MMMMIO-TIME-STAMP      TO MB99WS-FILE-TIME.
031200     PERFORM MB99PD-CHECK-DATE-TIME
031300        THRU MB99PD-CDT-EXIT.
031400*
031500     MOVE 'R1MM'                 TO SS02WS-ABEND-LOCATION.
031600     SET MMMMRB-READ-SEQ         TO TRUE.
031700     PERFORM MB00PD-MMMM-ACCESS
031800        THRU MB00PD-MMMM-ACCESS-EXIT.
031900*
032000     MOVE MMMMIO-RECORD          TO MMMM-RECORD.
032100*
032200*
032300*
032400     MOVE 'R0OE'                 TO SS02WS-ABEND-LOCATION.
032500     SET MMOERB-READ-SEQ         TO TRUE.
032600     PERFORM MB00PD-MMOE-ACCESS
032700        THRU MB00PD-MMOE-ACCESS-EXIT.
032800     MOVE 'MMOE'                 TO MB99WS-FILE-ID.
032900*
033000     IF  MMOEIO-HEADER
033100         NEXT SENTENCE
033200     ELSE
033300         PERFORM MB99PD-MISSING-HEADER-ABEND
033400            THRU MB99PD-MHA-EXIT.
033500*
033600     MOVE MMOEIO-DATE-STAMP      TO MB99WS-FILE-DATE.
033700     MOVE MMOEIO-TIME-STAMP      TO MB99WS-FILE-TIME.
033800     PERFORM MB99PD-CHECK-DATE-TIME
033900        THRU MB99PD-CDT-EXIT.
034000*
034100     MOVE 'R1OE'                 TO SS02WS-ABEND-LOCATION.
034200     SET MMOERB-READ-SEQ         TO TRUE.
034300     PERFORM MB00PD-MMOE-ACCESS
034400        THRU MB00PD-MMOE-ACCESS-EXIT.
034500*
034600     MOVE MMOEIO-RECORD          TO MMOE-RECORD.
034700*
034800*
034900*
035000     MOVE 'R0PE'                 TO SS02WS-ABEND-LOCATION.
035100     SET MMPERB-READ-SEQ         TO TRUE.
035200     PERFORM MB00PD-MMPE-ACCESS
035300        THRU MB00PD-MMPE-ACCESS-EXIT.
035400     MOVE 'MMPE'                 TO MB99WS-FILE-ID.
035500*
035600     IF  MMPEIO-HEADER
035700         NEXT SENTENCE
035800     ELSE
035900         PERFORM MB99PD-MISSING-HEADER-ABEND
036000            THRU MB99PD-MHA-EXIT.
036100*
036200     MOVE MMPEIO-DATE-STAMP      TO MB99WS-FILE-DATE.
036300     MOVE MMPEIO-TIME-STAMP      TO MB99WS-FILE-TIME.
036400     PERFORM MB99PD-CHECK-DATE-TIME
036500        THRU MB99PD-CDT-EXIT.
036600*
036700     MOVE 'R1PE'                 TO SS02WS-ABEND-LOCATION.
036800     SET MMPERB-READ-SEQ         TO TRUE.
036900     PERFORM MB00PD-MMPE-ACCESS
037000        THRU MB00PD-MMPE-ACCESS-EXIT.
037100*
037200     MOVE MMPEIO-RECORD          TO MMPE-RECORD.
037300*
037400*
037500*
037600     MOVE 'R0TC'                 TO SS02WS-ABEND-LOCATION.
037700     SET MMTCRB-READ-SEQ         TO TRUE.
037800     PERFORM MB00PD-MMTC-ACCESS
037900        THRU MB00PD-MMTC-ACCESS-EXIT.
038000     MOVE 'MMTC'                 TO MB99WS-FILE-ID.
038100*
038200     IF  MMTCIO-HEADER
038300         NEXT SENTENCE
038400     ELSE
038500         PERFORM MB99PD-MISSING-HEADER-ABEND
038600            THRU MB99PD-MHA-EXIT.
038700*
038800     MOVE MMTCIO-DATE-STAMP      TO MB99WS-FILE-DATE.
038900     MOVE MMTCIO-TIME-STAMP      TO MB99WS-FILE-TIME.
039000     PERFORM MB99PD-CHECK-DATE-TIME
039100        THRU MB99PD-CDT-EXIT.
039200*
039300     MOVE 'R1TC'                 TO SS02WS-ABEND-LOCATION.
039400     SET MMTCRB-READ-SEQ         TO TRUE.
039500     PERFORM MB00PD-MMTC-ACCESS
039600        THRU MB00PD-MMTC-ACCESS-EXIT.
039700*
039800     MOVE MMTCIO-RECORD          TO MMTC-RECORD.
039900*
040000*
040100*
040200     MOVE 'R0ET'                 TO SS02WS-ABEND-LOCATION.
040300     SET MTETRB-READ-SEQ         TO TRUE.
040400     PERFORM MB00PD-MTET-ACCESS
040500        THRU MB00PD-MTET-ACCESS-EXIT.
040600     MOVE 'MTET'                 TO MB99WS-FILE-ID.
040700*
040800     IF  MTETIO-HEADER
040900         NEXT SENTENCE
041000     ELSE
041100         PERFORM MB99PD-MISSING-HEADER-ABEND
041200            THRU MB99PD-MHA-EXIT.
041300*
041400     MOVE MTETIO-DATE-STAMP      TO MB99WS-FILE-DATE.
041500     MOVE MTETIO-TIME-STAMP      TO MB99WS-FILE-TIME.
041600     PERFORM MB99PD-CHECK-DATE-TIME
041700        THRU MB99PD-CDT-EXIT.
041800*
041900     MOVE 'R1ET'                 TO SS02WS-ABEND-LOCATION.
042000     SET MTETRB-READ-SEQ         TO TRUE.
042100     PERFORM MB00PD-MTET-ACCESS
042200        THRU MB00PD-MTET-ACCESS-EXIT.
042300*
042400     MOVE MTETIO-RECORD          TO MTPT-RECORD.
042500     MOVE MTPT-ORG-MERCHANT      TO MTPTWS-ORG-MERCHANT.
042600     MOVE MTPT-PRODUCT-X         TO MTPTWS-PRODUCT-X.
042700*
042800*
042900*
043000 A150-OF-WRITE-HEADERS.
043100*
043200     MOVE SPACES                 TO MTOEIO-RECORD.
043300     MOVE ZERO                   TO MTOEIO-KEY.
043400     SET MTOEIO-HEADER           TO TRUE.
043500     MOVE MMSC-TODAYS-JULIAN     TO MTOEIO-DATE-STAMP.
043600     MOVE MMSC-TIME-STAMP        TO MTOEIO-TIME-STAMP.
043700*
043800     MOVE 'W0OE'                 TO SS02WS-ABEND-LOCATION.
043900     SET MTOERB-WRITE            TO TRUE.
044000     PERFORM MB00PD-MTOE-ACCESS
044100        THRU MB00PD-MTOE-ACCESS-EXIT.
044200*
044300*
044400*
044500     MOVE SPACES                 TO MTPEIO-RECORD.
044600     MOVE ZERO                   TO MTPEIO-KEY.
044700     SET MTPEIO-HEADER           TO TRUE.
044800     MOVE MMSC-TODAYS-JULIAN     TO MTPEIO-DATE-STAMP.
044900     MOVE MMSC-TIME-STAMP        TO MTPEIO-TIME-STAMP.
045000*
045100     MOVE 'WAPE'                 TO SS02WS-ABEND-LOCATION.
045200     SET MTPERB-WRITE            TO TRUE.
045300     PERFORM MB00PD-MTPE-ACCESS
045400        THRU MB00PD-MTPE-ACCESS-EXIT.
045500*
045600*
045700*
045800 A199-OF-EXIT.
045900     EXIT.
046000/
046100 A200-POSTING-PROCESS SECTION.
046200 A201-PP-BEGIN.
046300*
046400     PERFORM B000-PROCESS-ORG
046500        THRU B099-PO-EXIT.
046600*
046700     IF  MMOCIO-TRAILER
046800         GO TO A299-PP-EXIT.
046900*
047000*
047100     PERFORM C000-PROCESS-MERCHANTS
047200        THRU C099-PM-EXIT
047300        UNTIL MMMMIO-ORG  IS GREATER THAN MMOC-ORG.
047400*
047500 A299-PP-EXIT.
047600     EXIT.
047700/
047800 A300-CLOSE-FILES SECTION.
047900 A301-CF-BEGIN.
048000*
048100     MOVE SPACES                 TO MTOEIO-RECORD.
048200     MOVE ZERO                   TO MTOEIO-KEY.
048300     SET MTOEIO-TRAILER          TO TRUE.
048400     MOVE MMSC-TODAYS-JULIAN     TO MTOEIO-DATE-STAMP.
048500     MOVE MMSC-TIME-STAMP        TO MTOEIO-TIME-STAMP.
048600*
048700     MOVE 'W9OE'                 TO SS02WS-ABEND-LOCATION.
048800     SET MTOERB-WRITE            TO TRUE.
048900     PERFORM MB00PD-MTOE-ACCESS
049000        THRU MB00PD-MTOE-ACCESS-EXIT.
049100*
049200*
049300*
049400     MOVE SPACES                 TO MTPEIO-RECORD.
049500     MOVE ZERO                   TO MTPEIO-KEY.
049600     SET MTPEIO-TRAILER          TO TRUE.
049700     MOVE MMSC-TODAYS-JULIAN     TO MTPEIO-DATE-STAMP.
049800     MOVE MMSC-TIME-STAMP        TO MTPEIO-TIME-STAMP.
049900*
050000     MOVE 'WZPE'                 TO SS02WS-ABEND-LOCATION.
050100     SET MTPERB-WRITE            TO TRUE.
050200     PERFORM MB00PD-MTPE-ACCESS
050300        THRU MB00PD-MTPE-ACCESS-EXIT.
050400*
050500*
050600*
050700     MOVE 'C1SC'                 TO SS02WS-ABEND-LOCATION.
050800     SET MMSCRB-CLOSE            TO TRUE.
050900     PERFORM MB00PD-MMSC-ACCESS
051000        THRU MB00PD-MMSC-ACCESS-EXIT.
051100*
051200     MOVE 'C1OC'                 TO SS02WS-ABEND-LOCATION.
051300     SET MMOCRB-CLOSE            TO TRUE.
051400     PERFORM MB00PD-MMOC-ACCESS
051500        THRU MB00PD-MMOC-ACCESS-EXIT.
051600*
051700     MOVE 'C1MM'                 TO SS02WS-ABEND-LOCATION.
051800     SET MMMMRB-CLOSE            TO TRUE.
051900     PERFORM MB00PD-MMMM-ACCESS
052000        THRU MB00PD-MMMM-ACCESS-EXIT.
052100*
052200     MOVE 'C1OE'                 TO SS02WS-ABEND-LOCATION.
052300     SET MMOERB-CLOSE            TO TRUE.
052400     PERFORM MB00PD-MMOE-ACCESS
052500        THRU MB00PD-MMOE-ACCESS-EXIT.
052600*
052700     MOVE 'C1PE'                 TO SS02WS-ABEND-LOCATION.
052800     SET MMPERB-CLOSE            TO TRUE.
052900     PERFORM MB00PD-MMPE-ACCESS
053000        THRU MB00PD-MMPE-ACCESS-EXIT.
053100*
053200     MOVE 'C1TC'                 TO SS02WS-ABEND-LOCATION.
053300     SET MMTCRB-CLOSE            TO TRUE.
053400     PERFORM MB00PD-MMTC-ACCESS
053500        THRU MB00PD-MMTC-ACCESS-EXIT.
053600*
053700     MOVE 'C1ET'                 TO SS02WS-ABEND-LOCATION.
053800     SET MTETRB-CLOSE            TO TRUE.
053900     PERFORM MB00PD-MTET-ACCESS
054000        THRU MB00PD-MTET-ACCESS-EXIT.
054100*
054200*
054300*
054400     MOVE 'CAOE'                 TO SS02WS-ABEND-LOCATION.
054500     SET MTOERB-CLOSE            TO TRUE.
054600     PERFORM MB00PD-MTOE-ACCESS
054700        THRU MB00PD-MTOE-ACCESS-EXIT.
054800*
054900     MOVE 'CAPE'                 TO SS02WS-ABEND-LOCATION.
055000     SET MTPERB-CLOSE            TO TRUE.
055100     PERFORM MB00PD-MTPE-ACCESS
055200        THRU MB00PD-MTPE-ACCESS-EXIT.
055300*
055400 A399-CF-EXIT.
055500     EXIT.
055600/
055700 B000-PROCESS-ORG SECTION.
055800 B010-PO-BEGIN.
055900*
056000     MOVE 'R2OC'                 TO SS02WS-ABEND-LOCATION.
056100     SET MMOCRB-READ-SEQ         TO TRUE.
056200     PERFORM MB00PD-MMOC-ACCESS
056300        THRU MB00PD-MMOC-ACCESS-EXIT.
056400*
056500     IF  MMOCIO-TRAILER
056600         GO TO B099-PO-EXIT.
056700*
056800     MOVE MMOCIO-RECORD          TO MMOC-RECORD.
056900*
057000     IF  MMOC-REC-INCOMPLETE
057100         GO TO B010-PO-BEGIN.
057200*
057300     IF  MMOC-ADD-PENDING
057400         GO TO B010-PO-BEGIN.
057500*
057600     MOVE LOW-VALUES             TO MMTCIO-RECORD.
057700     MOVE MMOC-ORG               TO MMTCTB-ORG.
057800*
057900     PERFORM MMTCPX-LOAD-TRANSACTION-TABLE
058000        THRU MMTCPX-LTT-EXIT.
058100*
058200     IF  MMOC-NOT-PROCESSING
058300         PERFORM 8000-ORG-NOT-PROCESSING
058400            THRU 8099-ONP-EXIT
058500         GO TO B010-PO-BEGIN.
058600*
058700     MOVE MMOC-DATE-LAST-PROC    TO SS01WS-JULIAN.
058800     PERFORM SS08PD-JUL-TO-GREG
058900        THRU SS08PD-JTG-EXIT.
059000     MOVE SS01WS-MM              TO WS-D260-LAST-MM.
059100     MOVE SS01WS-DD              TO WS-D260-LAST-DD.
059200     MOVE SS01WS-YEAR            TO WS-D260-LAST-YY.
059300     MOVE MMOC-DATE-LAST-PROC    TO SS01WS-JULIAN.
059400     PERFORM SS06PD-DAY-OF-WEEK
059500        THRU SS06PD-DOW-EXIT.
059600     COMPUTE WS-D260-LAST-DOW    =  SS01WS-DOW + 1.
059700*
059800     MOVE MMOC-TODAYS-JULIAN     TO SS01WS-JULIAN.
059900     PERFORM SS08PD-JUL-TO-GREG
060000        THRU SS08PD-JTG-EXIT.
060100     MOVE SS01WS-MM              TO WS-D260-CURR-MM.
060200     MOVE SS01WS-DD              TO WS-D260-CURR-DD.
060300     MOVE SS01WS-YEAR            TO WS-D260-CURR-YY.
060400     MOVE MMOC-TODAYS-JULIAN     TO SS01WS-JULIAN.
060500     PERFORM SS06PD-DAY-OF-WEEK
060600        THRU SS06PD-DOW-EXIT.
060700     COMPUTE WS-D260-CURR-DOW    =  SS01WS-DOW + 1.
060800*
060900     MOVE MMOC-DATE-NEXT-PROC    TO SS01WS-JULIAN.
061000     PERFORM SS08PD-JUL-TO-GREG
061100        THRU SS08PD-JTG-EXIT.
061200     MOVE SS01WS-MM              TO WS-D260-NEXT-MM.
061300     MOVE SS01WS-DD              TO WS-D260-NEXT-DD.
061400     MOVE SS01WS-YEAR            TO WS-D260-NEXT-YY.
061500     MOVE MMOC-DATE-NEXT-PROC    TO SS01WS-JULIAN.
061600     PERFORM SS06PD-DAY-OF-WEEK
061700        THRU SS06PD-DOW-EXIT.
061800     COMPUTE WS-D260-NEXT-DOW    =  SS01WS-DOW + 1.
061900*
062000     MOVE MMOC-ACCR-THRU-DATE    TO SS01WS-JULIAN.
062100     PERFORM SS08PD-JUL-TO-GREG
062200        THRU SS08PD-JTG-EXIT.
062300     MOVE SS01WS-MM              TO WS-D260-ACCR-MM.
062400     MOVE SS01WS-DD              TO WS-D260-ACCR-DD.
062500     MOVE SS01WS-YEAR            TO WS-D260-ACCR-YY.
062600     MOVE MMOC-ACCR-THRU-DATE    TO SS01WS-JULIAN.
062700     PERFORM SS06PD-DAY-OF-WEEK
062800        THRU SS06PD-DOW-EXIT.
062900     COMPUTE WS-D260-ACCR-DOW    =  SS01WS-DOW + 1.
063000*
063100     MOVE MMOC-DATE-LAST-ACCR    TO SS01WS-JULIAN.
063200     PERFORM SS08PD-JUL-TO-GREG
063300        THRU SS08PD-JTG-EXIT.
063400     MOVE SS01WS-MM              TO WS-D260-LACC-MM.
063500     MOVE SS01WS-DD              TO WS-D260-LACC-DD.
063600     MOVE SS01WS-YEAR            TO WS-D260-LACC-YY.
063700     MOVE MMOC-DATE-LAST-ACCR    TO SS01WS-JULIAN.
063800     PERFORM SS06PD-DAY-OF-WEEK
063900        THRU SS06PD-DOW-EXIT.
064000     COMPUTE WS-D260-LACC-DOW    =  SS01WS-DOW + 1.
064100*
064200     MOVE ZERO                   TO WS-D260-PROC-DAYS-AREA.
064300     MOVE MMOC-DATE-LAST-ACCR    TO WS-D260-WORK-JULIAN.
064400     PERFORM B100-PO-SET-PROC-DAYS
064500        THRU B109-PO-SPD-EXIT
064600        UNTIL WS-D260-WORK-JULIAN
064700              IS NOT LESS THAN MMOC-ACCR-THRU-DATE.
064800*
064900     IF  WS-D260-ACCR-MM IS LESS THAN WS-D260-NEXT-MM
065000         SET X-WS-D260-PDT       TO WS-D260-ACCR-DD
065100         MOVE WS-D260-PDT-DOM (X-WS-D260-PDT)
065200                                 TO SS01WS-DOW
065300         PERFORM B110-PO-SET-EOM-DAYS
065400            THRU B119-PO-SED-EXIT
065500            UNTIL X-WS-D260-PDT IS GREATER THAN 31.
065600*
065700     MOVE 1                      TO SS01WS-DOW.
065800     MOVE MMOC-ACCR-THRU-DATE    TO SS01WS-DATE-1.
065900     MOVE MMOC-DATE-LAST-ACCR    TO SS01WS-DATE-2.
066000     PERFORM SS04PD-ELAPSED-DAYS
066100        THRU SS04PD-ED-EXIT.
066200     MOVE SS01WS-RESULT          TO WS-D260-NBR-PROC-DAYS.
066300*
066400     MOVE 1                      TO SS01WS-DOW.
066500     MOVE MMOC-TODAYS-JULIAN     TO SS01WS-DATE-1.
066600     MOVE MMOC-DATE-LAST-ACCR    TO SS01WS-DATE-2.
066700     PERFORM SS04PD-ELAPSED-DAYS
066800        THRU SS04PD-ED-EXIT.
066900     MOVE SS01WS-RESULT          TO WS-D260-WTD-PROC-DAYS.
067000*
067100 B099-PO-EXIT.
067200     EXIT.
067300/
067400 B100-PO-SET-PROC-DAYS SECTION.
067500 B101-PO-SPD-BEGIN.
067600*
067700     MOVE WS-D260-WORK-JULIAN    TO SS01WS-JULIAN.
067800     MOVE ZERO                   TO SS01WS-DAY-OF-MON.
067900     MOVE 1                      TO SS01WS-FREQ.
068000     MOVE 'D'                    TO SS01WS-PERIOD.
068100     PERFORM SS03PD-FUTURE-DATE
068200        THRU SS03PD-FD-EXIT.
068300*
068400     MOVE SS01WS-JULIAN          TO WS-D260-WORK-JULIAN.
068500     SET X-WS-D260-PDT           TO SS01WS-DD.
068600*
068700     PERFORM SS06PD-DAY-OF-WEEK
068800        THRU SS06PD-DOW-EXIT.
068900*
069000     COMPUTE WS-D260-PDT-DOM (X-WS-D260-PDT)
069100                                 =  SS01WS-DOW + 1.
069200*
069300 B109-PO-SPD-EXIT.
069400     EXIT.
069500*
069600*
069700*
069800 B110-PO-SET-EOM-DAYS SECTION.
069900 B111-PO-SED-BEGIN.
070000     MOVE SS01WS-DOW             TO WS-D260-PDT-DOM
070100                                    (X-WS-D260-PDT).
070200     SET X-WS-D260-PDT           UP BY 1.
070300*
070400 B119-PO-SED-EXIT.
070500     EXIT.
070600/
070700 C000-PROCESS-MERCHANTS SECTION.
070800 C010-PM-BEGIN.
070900*
071000     IF  MMMMIO-ORG  IS LESS THAN MMOC-ORG
071100         PERFORM C900-GET-NEXT-MERCH
071200            THRU C999-GNM-EXIT
071300         MOVE MMMMIR-RECORD      TO MMMM-RECORD
071400         MOVE MMOC-ORG           TO MMMM-ORG
071500         GO TO C099-PM-EXIT.
071600*
071700     IF  MMMMIO-ORG  IS NOT EQUAL TO MMOC-ORG
071800         GO TO C099-PM-EXIT.
071900*
072000     MOVE MMMMIO-RECORD          TO MMMM-RECORD.
072100*
072200     IF  MMMM-REC-INCOMPLETE
072300     OR  MMMM-REC-PURGED
072400     OR  MMMM-REC-PURGING
072500     OR  MMMM-REC-MODEL
072600     OR  MMMM-ADD-PENDING
072700         PERFORM C900-GET-NEXT-MERCH
072800            THRU C999-GNM-EXIT
072900         GO TO C099-PM-EXIT.
073000*
073100     PERFORM D000-MERCH-PRE-PROCESS
073200        THRU D099-MPP-EXIT.
073300*
073400     PERFORM D300-POST-STATS
073500        THRU D399-PM-EXIT.
073600*
073700     PERFORM D900-MERCH-POST-PROCESS
073800        THRU D999-MPP-EXIT.
073900*
074000     PERFORM C900-GET-NEXT-MERCH
074100        THRU C999-GNM-EXIT.
074200*
074300 C099-PM-EXIT.
074400     EXIT.
074500/
074600 C900-GET-NEXT-MERCH SECTION.
074700 C901-GNM-BEGIN.
074800*
074900     MOVE 'R3MM'                 TO SS02WS-ABEND-LOCATION.
075000     SET MMMMRB-READ-SEQ         TO TRUE.
075100     PERFORM MB00PD-MMMM-ACCESS
075200        THRU MB00PD-MMMM-ACCESS-EXIT.
075300*
075400 C999-GNM-EXIT.
075500     EXIT.
075600/
075700 D000-MERCH-PRE-PROCESS SECTION.
075800 D001-MPP-BEGIN.
075900*
076000******************************************************************
076100*    LOAD MMOE RECORDS INTO TABLE FOR PROCESSING                 *
076200******************************************************************
076300     MOVE SPACES                 TO MMOETB-TABLE-DATA.
076400     MOVE MMMM-ORG-MERCHANT      TO MMOETB-START-ORG-ACCT.
076500     SET X-MMOETB                TO 1.
076600     PERFORM MB05PD-MMOE-READ-AND-LOAD
076700        THRU MB05PD-MMOE-RAL-EXIT
076800        UNTIL MMOEIO-ORG-ACCT     IS GREATER THAN
076900                                 MMMM-ORG-MERCHANT
077000          OR  X-MMOETB IS GREATER THAN MMOETB-MAX-ENTRIES
077100          OR  MMOEIO-TRAILER.
077200*
077300******************************************************************
077400*    LOAD MMPE RECORDS INTO TABLE FOR PROCESSING                 *
077500******************************************************************
077600     MOVE SPACES                 TO MMPETB-TABLE-DATA.
077700     MOVE MMMM-ORG-MERCHANT      TO MMPETB-START-ORG-ACCT.
077800     SET X-MMPETB                TO 1.
077900     PERFORM MB05PD-MMPE-READ-AND-LOAD
078000        THRU MB05PD-MMPE-RAL-EXIT
078100        UNTIL MMPEIO-ORG-ACCT     IS GREATER THAN
078200                                 MMMM-ORG-MERCHANT
078300          OR  X-MMPETB IS GREATER THAN MMPETB-MAX-ENTRIES
078400          OR  MMPEIO-TRAILER.
078500*
078600******************************************************************
078700*    SET SETTLEMENT, STATEMENT, DISCOUNT AND PARTICIPATION       *
078800*    FLAGS TO "NOT TODAY".                                       *
078900******************************************************************
079000     MOVE MMMM-STMT-SW           TO WS-D260-STMT-SW.
079100     MOVE MMMM-SETT-SW           TO WS-D260-SETT-SW.
079200     MOVE MMMM-DISC-SW           TO WS-D260-DISC-SW.
079300     MOVE MMMM-PART-SW           TO WS-D260-PART-SW.
079400*
079500******************************************************************
079600*    ROLL MMPE-FILE STATS TABLE OCCURRENCES WHEN APPLICABLE      *
079700******************************************************************
079800     PERFORM
079900         VARYING X-MMPETB FROM 1 BY 1
080000         UNTIL   X-MMPETB IS GREATER THAN MMPETB-MAX-ENTRIES
080100            OR   MMPETB-END-OF-TABLE (X-MMPETB)
080200         MOVE MMPETB-RECORD (X-MMPETB)
080300                                 TO MMPE-RECORD
080400         MOVE MMPEIR-TABLE (13)  TO MMPE-TABLE (13)
080500         IF  WS-D260-CURR-MM IS NOT EQUAL TO WS-D260-LAST-MM
080600             MOVE MMPE-TABLE(11) TO MMPE-TABLE (12)
080700             MOVE MMPE-TABLE(10) TO MMPE-TABLE (11)
080800             MOVE MMPE-TABLE(09) TO MMPE-TABLE (10)
080900             MOVE MMPE-TABLE(08) TO MMPE-TABLE (09)
081000             MOVE MMPE-TABLE(07) TO MMPE-TABLE (08)
081100             MOVE MMPE-TABLE(06) TO MMPE-TABLE (07)
081200             MOVE MMPE-TABLE(05) TO MMPE-TABLE (06)
081300             MOVE MMPE-TABLE(04) TO MMPE-TABLE (05)
081400             MOVE MMPE-TABLE(03) TO MMPE-TABLE (04)
081500             MOVE MMPE-TABLE(02) TO MMPE-TABLE (03)
081600             MOVE MMPE-TABLE(01) TO MMPE-TABLE (02)
081700             MOVE MMPE-TABLE(14) TO MMPE-TABLE (01)
081800             MOVE MMPEIR-TABLE (14)
081900                                 TO MMPE-TABLE (14)
082000         END-IF
082100         IF  WS-D260-CURR-YY IS NOT EQUAL TO WS-D260-LAST-YY
082200             MOVE MMPEIR-TABLE (15)
082300                                 TO MMPE-TABLE (15)
082400         END-IF
082500         IF  MMMM-STMT-CLEAR-TODAY
082600             MOVE MMPEIR-TABLE (16)
082700                                 TO MMPE-TABLE (16)
082800         END-IF
082900         IF  MMMM-DISC-CLEAR-TODAY
083000             MOVE MMPEIR-TABLE (17)
083100                                 TO MMPE-TABLE (17)
083200         END-IF
083300         IF  MMMM-PART-CLEAR-TODAY
083400             MOVE MMPEIR-TABLE (18)
083500                                 TO MMPE-TABLE (18)
083600         END-IF
083700         MOVE MMPE-RECORD        TO MMPETB-RECORD (X-MMPETB)
083800     END-PERFORM.
083900*
084000******************************************************************
084100*    ROLL MMOE-FILE STATS TABLE OCCURRENCES WHEN APPLICABLE      *
084200******************************************************************
084300     PERFORM
084400         VARYING X-MMOETB FROM 1 BY 1
084500         UNTIL   X-MMOETB IS GREATER THAN MMOETB-MAX-ENTRIES
084600            OR   MMOETB-END-OF-TABLE (X-MMOETB)
084700         MOVE MMOETB-RECORD (X-MMOETB)
084800                                 TO MMOE-RECORD
084900         MOVE MMOEIR-TABLE (13)  TO MMOE-TABLE (13)
085000         IF  WS-D260-CURR-MM IS NOT EQUAL TO WS-D260-LAST-MM
085100             MOVE MMOE-TABLE(11) TO MMOE-TABLE (12)
085200             MOVE MMOE-TABLE(10) TO MMOE-TABLE (11)
085300             MOVE MMOE-TABLE(09) TO MMOE-TABLE (10)
085400             MOVE MMOE-TABLE(08) TO MMOE-TABLE (09)
085500             MOVE MMOE-TABLE(07) TO MMOE-TABLE (08)
085600             MOVE MMOE-TABLE(06) TO MMOE-TABLE (07)
085700             MOVE MMOE-TABLE(05) TO MMOE-TABLE (06)
085800             MOVE MMOE-TABLE(04) TO MMOE-TABLE (05)
085900             MOVE MMOE-TABLE(03) TO MMOE-TABLE (04)
086000             MOVE MMOE-TABLE(02) TO MMOE-TABLE (03)
086100             MOVE MMOE-TABLE(01) TO MMOE-TABLE (02)
086200             MOVE MMOE-TABLE(14) TO MMOE-TABLE (01)
086300             MOVE MMOEIR-TABLE (14)
086400                                 TO MMOE-TABLE (14)
086500         END-IF
086600         IF  WS-D260-CURR-YY IS NOT EQUAL TO WS-D260-LAST-YY
086700             MOVE MMOEIR-TABLE (15)
086800                                 TO MMOE-TABLE (15)
086900         END-IF
087000         IF  MMMM-STMT-CLEAR-TODAY
087100             MOVE MMOEIR-TABLE (16)
087200                                 TO MMOE-TABLE (16)
087300         END-IF
087400         IF  MMMM-DISC-CLEAR-TODAY
087500             MOVE MMOEIR-TABLE (17)
087600                                 TO MMOE-TABLE (17)
087700         END-IF
087800         IF  MMMM-PART-CLEAR-TODAY
087900             MOVE MMOEIR-TABLE (18)
088000                                 TO MMOE-TABLE (18)
088100         END-IF
088200         MOVE MMOE-RECORD        TO MMOETB-RECORD (X-MMOETB)
088300     END-PERFORM.
088400*
088500 D099-MPP-EXIT.
088600     EXIT.
088700*
088800*
088900*
089000 D100-MPP-ADD-WTD-DAYS SECTION.
089100 D101-MPP-AWD-BEGIN.
089200*
089300     ADD 1                       TO SS01WS-FREQ.
089400     ADD 1                       TO SS01WS-DATE-2.
089500*
089600     IF  SS01WS-DATE-2 IS GREATER THAN 6
089700         MOVE ZERO               TO SS01WS-DATE-2.
089800*
089900 D199-MPP-AWD-EXIT.
090000     EXIT.
090100/
090200 D300-POST-STATS SECTION.
090300 D301-PS-BEGIN.
090400*
090500     MOVE MTETIO-RECORD          TO MTPT-RECORD.
090600     MOVE MTPT-ORG-MERCHANT      TO MTPTWS-ORG-MERCHANT.
090700     MOVE MTPT-PRODUCT-X         TO MTPTWS-PRODUCT-X.
090800*
090900     PERFORM F000-PROCESS-TRANSACTIONS
091000        THRU F099-PT-EXIT
091100        UNTIL MTPTWS-ORG-MERCHANT IS GREATER THAN
091200                                 MMMM-ORG-MERCHANT.
091300*
091400     MOVE MTETIO-RECORD          TO MTPT-RECORD.
091500     MOVE MTPT-ORG-MERCHANT      TO MTPTWS-ORG-MERCHANT.
091600     MOVE MTPT-PRODUCT-X         TO MTPTWS-PRODUCT-X.
091700*
091800 D399-PM-EXIT.
091900     EXIT.
092000/
092100 D900-MERCH-POST-PROCESS SECTION.
092200 D901-MPP-BEGIN.
092300*
092400******************************************************************
092500******************************************************************
092600******************************************************************
092700*****************BUBBLE SORT MMPETB-TABLE*************************
092800******************************************************************
092900******************************************************************
093000******************************************************************
093100     SET WS-D260-BUBBLE-SWAP     TO TRUE.
093200     COMPUTE WS-D260-INDEX        =  MMPETB-MAX-ENTRIES - 1.
093300     PERFORM
093400         UNTIL WS-D260-BUBBLE-NO-SWAP
093500         SET WS-D260-BUBBLE-NO-SWAP
093600                                 TO TRUE
093700         PERFORM
093800             VARYING X-MMPETB FROM 1 BY 1
093900             UNTIL   X-MMPETB IS GREATER THAN WS-D260-INDEX
094000                OR   MMPETB-END-OF-TABLE (X-MMPETB)
094100                 SET X-MMPETB-SEARCH
094200                                 TO X-MMPETB
094300                 SET X-MMPETB-SEARCH
094400                                 UP BY 1
094500                 IF  MMPETB-KEY (X-MMPETB) IS GREATER THAN
094600                     MMPETB-KEY (X-MMPETB-SEARCH)
094700                     IF  MMPETB-END-OF-TABLE (X-MMPETB-SEARCH)
094800                         CONTINUE
094900                     ELSE
095000                         SET WS-D260-BUBBLE-SWAP
095100                                 TO TRUE
095200                         MOVE MMPETB-RECORD (X-MMPETB)
095300                                 TO MMPE-RECORD
095400                         MOVE MMPETB-RECORD (X-MMPETB-SEARCH)
095500                                 TO MMPETB-RECORD (X-MMPETB)
095600                         MOVE MMPE-RECORD
095700                                 TO MMPETB-RECORD
095800                                    (X-MMPETB-SEARCH)
095900                     END-IF
096000                 END-IF
096100         END-PERFORM
096200     END-PERFORM.
096300*
096400*
096500*
096600******************************************************************
096700******************************************************************
096800******************************************************************
096900*****************BUBBLE SORT MMOETB-TABLE*************************
097000******************************************************************
097100******************************************************************
097200******************************************************************
097300     SET WS-D260-BUBBLE-SWAP     TO TRUE.
097400     COMPUTE WS-D260-INDEX        =  MMOETB-MAX-ENTRIES - 1.
097500     PERFORM
097600         UNTIL WS-D260-BUBBLE-NO-SWAP
097700         SET WS-D260-BUBBLE-NO-SWAP
097800                                 TO TRUE
097900         PERFORM
098000             VARYING X-MMOETB FROM 1 BY 1
098100             UNTIL   X-MMOETB IS GREATER THAN WS-D260-INDEX
098200                OR   MMOETB-END-OF-TABLE (X-MMOETB)
098300                 SET X-MMOETB-SEARCH
098400                                 TO X-MMOETB
098500                 SET X-MMOETB-SEARCH
098600                                 UP BY 1
098700                 IF  MMOETB-KEY (X-MMOETB) IS GREATER THAN
098800                     MMOETB-KEY (X-MMOETB-SEARCH)
098900                     IF  MMOETB-END-OF-TABLE (X-MMOETB-SEARCH)
099000                         CONTINUE
099100                     ELSE
099200                         SET WS-D260-BUBBLE-SWAP
099300                                 TO TRUE
099400                         MOVE MMOETB-RECORD (X-MMOETB)
099500                                 TO MMOE-RECORD
099600                         MOVE MMOETB-RECORD (X-MMOETB-SEARCH)
099700                                 TO MMOETB-RECORD (X-MMOETB)
099800                         MOVE MMOE-RECORD
099900                                 TO MMOETB-RECORD
100000                                    (X-MMOETB-SEARCH)
100100                     END-IF
100200                 END-IF
100300         END-PERFORM
100400     END-PERFORM.
100500*
100600*
100700*
100800******************************************************************
100900*    OUTPUT STATISTICS FILES                                     *
101000******************************************************************
101100     PERFORM
101200         VARYING X-MMPETB FROM 1 BY 1
101300         UNTIL X-MMPETB IS GREATER THAN MMPETB-MAX-ENTRIES
101400           OR  MMPETB-END-OF-TABLE (X-MMPETB)
101500         MOVE MMPETB-RECORD (X-MMPETB)
101600                                 TO MMPE-RECORD
101700         IF  MMPE-TOTALS-DATA IS NOT EQUAL TO MMPEIR-TOTALS-DATA
101800             MOVE MMPE-RECORD    TO MTPEIO-RECORD
101900             MOVE 'WBPE'         TO SS02WS-ABEND-LOCATION
102000             SET MTPERB-WRITE    TO TRUE
102100             PERFORM MB00PD-MTPE-ACCESS
102200                THRU MB00PD-MTPE-ACCESS-EXIT
102300         END-IF
102400     END-PERFORM.
102500*
102600     PERFORM
102700         VARYING X-MMOETB FROM 1 BY 1
102800         UNTIL X-MMOETB IS GREATER THAN MMOETB-MAX-ENTRIES
102900           OR  MMOETB-END-OF-TABLE (X-MMOETB)
103000         MOVE MMOETB-RECORD (X-MMOETB)
103100                                 TO MMOE-RECORD
103200         IF  MMOE-TOTALS-DATA IS NOT EQUAL TO MMOEIR-TOTALS-DATA
103300             MOVE MMOE-RECORD    TO MTOEIO-RECORD
103400             MOVE 'WBOE'         TO SS02WS-ABEND-LOCATION
103500             SET MTOERB-WRITE    TO TRUE
103600             PERFORM MB00PD-MTOE-ACCESS
103700                THRU MB00PD-MTOE-ACCESS-EXIT
103800         END-IF
103900     END-PERFORM.
104000*
104100 D999-MPP-EXIT.
104200     EXIT.
104300/
104400 F000-PROCESS-TRANSACTIONS SECTION.
104500 F010-PT-BEGIN.
104600*
104700     MOVE MTETIO-RECORD          TO MTPT-RECORD.
104800     MOVE MTPT-ORG-MERCHANT      TO MTPTWS-ORG-MERCHANT.
104900     MOVE MTPT-PRODUCT-X         TO MTPTWS-PRODUCT-X.
105000*
105100     PERFORM F100-TRANSACTION-LOGIC
105200        THRU F199-TL-EXIT.
105300*
105400     PERFORM F800-GET-NEXT-TRANSACTION
105500        THRU F899-GNT-EXIT.
105600*
105700     MOVE MTETIO-RECORD          TO MTPT-RECORD.
105800     MOVE MTPT-ORG-MERCHANT      TO MTPTWS-ORG-MERCHANT.
105900     MOVE MTPT-PRODUCT-X         TO MTPTWS-PRODUCT-X.
106000*
106100 F099-PT-EXIT.
106200     EXIT.
106300/
106400 F100-TRANSACTION-LOGIC SECTION.
106500 F110-TL-BEGIN.
106600*
106700     MOVE MTPT-LOGIC-MODULE      TO MMTCWS-LOGIC-MODULE.
106800     SET X-MMTCTB                TO MTPT-TRANS-CODE.
106900     MOVE MMTCTB-RECORD (X-MMTCTB)
107000                                 TO MMTC-RECORD.
107100*
107200     IF  MTPT-ORG-MERCHANT IS LESS THAN MMMM-ORG-MERCHANT
107300         MOVE 01                 TO MTPT-POST-FLAG
107400         MOVE 26003              TO SS02WS-ABEND-CODE
107500         MOVE 'NO MERCHANT FOR TRANS'
107600                                 TO SS02WS-ABENDMSG8
107700         PERFORM SS02PD-ABEND
107800            THRU SS02PD-ABEND-EXIT
107900         PERFORM F900-NON-POST-TRANSACTION
108000            THRU F999-NPT-EXIT
108100         GO TO F199-TL-EXIT.
108200*
108300*
108400*
108500     IF  MTPT-TRANS-CODE IS GREATER THAN ZERO
108600     AND MTPT-TRANS-CODE IS LESS THAN 999
108700     AND MMTCTB-RECORD (X-MMTCTB) IS NOT EQUAL TO SPACES
108800         NEXT SENTENCE
108900     ELSE
109000         MOVE 02                 TO MTPT-POST-FLAG
109100         MOVE 26004              TO SS02WS-ABEND-CODE
109200         MOVE 'INVALID TRANS CODE'
109300                                 TO SS02WS-ABENDMSG8
109400         PERFORM SS02PD-ABEND
109500            THRU SS02PD-ABEND-EXIT
109600         PERFORM F900-NON-POST-TRANSACTION
109700            THRU F999-NPT-EXIT
109800         GO TO F199-TL-EXIT.
109900*
110000*
110100     MOVE MMPEIR-RECORD          TO MMPE-RECORD.
110200     MOVE MMPEIR-RECORD          TO MTPE-RECORD.
110300*
110400     IF  MMTCWS-LM-PRODUCT-ALLOWED
110500         EVALUATE TRUE
110600             WHEN MTPT-PRODUCT IS GREATER THAN ZERO
110700                 PERFORM F200-GET-PRODUCT-RECORDS
110800                    THRU F299-GPR-EXIT
110900             WHEN MMTCWS-LM-PRODUCT-OPTIONAL
111000                 PERFORM F200-GET-PRODUCT-RECORDS
111100                    THRU F299-GPR-EXIT
111200             WHEN OTHER
111300                 MOVE 02         TO MTPT-POST-FLAG
111400                 MOVE 26005      TO SS02WS-ABEND-CODE
111500                 MOVE 'MISSING PROD ON TRANS'
111600                                 TO SS02WS-ABENDMSG8
111700                 PERFORM SS02PD-ABEND
111800                    THRU SS02PD-ABEND-EXIT
111900         END-EVALUATE
112000     ELSE
112100         MOVE ZERO               TO MTPT-PRODUCT
112200         PERFORM F200-GET-PRODUCT-RECORDS
112300            THRU F299-GPR-EXIT.
112400*
112500*
112600*
112700     MOVE MMOEIR-RECORD          TO MMOE-RECORD.
112800     MOVE MMOEIR-RECORD          TO MTOE-RECORD.
112900*
113000     IF  MMTCWS-LM-QUAL-LEVEL-ALLOWED
113100         EVALUATE TRUE
113200             WHEN MTPT-QUAL-LEVEL IS GREATER THAN ZERO
113300                 PERFORM F400-GET-INTCHG-RECORDS
113400                    THRU F499-GIR-EXIT
113500             WHEN MMTCWS-LM-QUAL-LEVEL-OPTIONAL
113600                 CONTINUE
113700             WHEN OTHER
113800                 EVALUATE TRUE
113900                     WHEN MTPT-PROD-IS-VISA
114000                         MOVE 99 TO MTPT-QUAL-LEVEL
114100                     WHEN MTPT-PROD-IS-MC
114200                         MOVE 99 TO MTPT-QUAL-LEVEL
114300                     WHEN OTHER
114400                         MOVE 09 TO MTPT-QUAL-LEVEL
114500                 END-EVALUATE
114600         END-EVALUATE
114700     ELSE
114800         MOVE ZERO               TO MTPT-QUAL-LEVEL.
114900*
115000*
115100*
115200     PERFORM T000-APPLY-TRANSACTION
115300        THRU T099-AT-EXIT.
115400*
115500     IF  MMPE-ORG-ACCT     IS EQUAL TO MMMM-ORG-MERCHANT
115600         MOVE MMPE-RECORD        TO MMPETB-RECORD
115700                                    (X-MMPETB-DETAIL).
115800*
115900     IF  MTPE-ORG-ACCT     IS EQUAL TO MMMM-ORG-MERCHANT
116000         MOVE MTPE-RECORD        TO MMPETB-RECORD
116100                                    (X-MMPETB-TOTAL).
116200*
116300     IF  MMOE-ORG-ACCT     IS EQUAL TO MMMM-ORG-MERCHANT
116400         MOVE MMOE-RECORD        TO MMOETB-RECORD
116500                                    (X-MMOETB-DETAIL).
116600*
116700     IF  MTOE-ORG-ACCT     IS EQUAL TO MMMM-ORG-MERCHANT
116800         MOVE MTOE-RECORD        TO MMOETB-RECORD
116900                                    (X-MMOETB-TOTAL).
117000*
117100 F199-TL-EXIT.
117200     EXIT.
117300/
117400 F200-GET-PRODUCT-RECORDS SECTION.
117500 F210-GPR-BEGIN.
117600*
117700     SET X-MMPETB-DETAIL         TO 1.
117800     SEARCH MMPETB-TABLE VARYING X-MMPETB-DETAIL
117900         AT END
118000             MOVE 'PAT1'         TO SS02WS-ABEND-LOCATION
118100             MOVE 26006          TO SS02WS-ABEND-CODE
118200             MOVE 'MMPE TABLE TOO SMALL'
118300                                 TO SS02WS-ABENDMSG8
118400             PERFORM SS02PD-ABEND
118500                THRU SS02PD-ABEND-EXIT
118600         WHEN MMPETB-END-OF-TABLE (X-MMPETB-DETAIL)
118700             MOVE MMPEIR-RECORD  TO MMPE-RECORD
118800             MOVE MTPT-ORG-MERCHANT
118900                                 TO MMPE-ORG-ACCT
119000             SET  MMPE-DETAIL    TO TRUE
119100             MOVE MTPT-PRODUCT   TO MMPE-PRODUCT
119200             MOVE MTPT-LOGIC-MODULE
119300                                 TO MMPE-LOGIC-MODULE
119400             SET  MMPE-REC-ACTIVE
119500                                 TO TRUE
119600             MOVE MMPE-RECORD    TO MMPETB-RECORD
119700                                    (X-MMPETB-DETAIL)
119800         WHEN MMPETB-ORG-ACCT     (X-MMPETB-DETAIL) IS EQUAL TO
119900                                 MTPT-ORG-MERCHANT
120000          AND MMPETB-DETAIL (X-MMPETB-DETAIL)
120100          AND MMPETB-PRODUCT (X-MMPETB-DETAIL) IS EQUAL TO
120200                                 MTPT-PRODUCT
120300          AND MMPETB-LOGIC-MODULE (X-MMPETB-DETAIL) IS EQUAL TO
120400                                 MTPT-LOGIC-MODULE
120500             NEXT SENTENCE.
120600*
120700     MOVE MMPETB-RECORD (X-MMPETB-DETAIL)
120800                                 TO MMPE-RECORD.
120900*
121000*
121100*
121200     SET X-MMPETB-TOTAL          TO 1.
121300     SEARCH MMPETB-TABLE VARYING X-MMPETB-TOTAL
121400         AT END
121500             MOVE 'PAT2'         TO SS02WS-ABEND-LOCATION
121600             MOVE 26007          TO SS02WS-ABEND-CODE
121700             MOVE 'MMPE TABLE TOO SMALL'
121800                                 TO SS02WS-ABENDMSG8
121900             PERFORM SS02PD-ABEND
122000                THRU SS02PD-ABEND-EXIT
122100         WHEN MMPETB-END-OF-TABLE (X-MMPETB-TOTAL)
122200             MOVE MMPEIR-RECORD  TO MTPE-RECORD
122300             MOVE MTPT-ORG-MERCHANT
122400                                 TO MTPE-ORG-ACCT
122500             SET  MTPE-TOTALS    TO TRUE
122600             MOVE ZERO           TO MTPE-PRODUCT
122700             MOVE MTPT-LOGIC-MODULE
122800                                 TO MTPE-LOGIC-MODULE
122900             SET  MTPE-REC-ACTIVE
123000                                 TO TRUE
123100             MOVE MTPE-RECORD    TO MMPETB-RECORD
123200                                    (X-MMPETB-TOTAL)
123300         WHEN MMPETB-ORG-ACCT     (X-MMPETB-TOTAL) IS EQUAL TO
123400                                 MTPT-ORG-MERCHANT
123500          AND MMPETB-TOTALS (X-MMPETB-TOTAL)
123600          AND MMPETB-PRODUCT (X-MMPETB-TOTAL) IS EQUAL TO ZERO
123700          AND MMPETB-LOGIC-MODULE (X-MMPETB-TOTAL) IS EQUAL TO
123800                                 MTPT-LOGIC-MODULE
123900             NEXT SENTENCE.
124000*
124100     MOVE MMPETB-RECORD (X-MMPETB-TOTAL)
124200                                 TO MTPE-RECORD.
124300*
124400 F299-GPR-EXIT.
124500     EXIT.
124600/
124700 F400-GET-INTCHG-RECORDS SECTION.
124800 F410-GIR-BEGIN.
124900*
125000     SET X-MMOETB-DETAIL         TO 1.
125100     SEARCH MMOETB-TABLE VARYING X-MMOETB-DETAIL
125200         AT END
125300             MOVE 'OIT1'         TO SS02WS-ABEND-LOCATION
125400             MOVE 26010          TO SS02WS-ABEND-CODE
125500             MOVE 'MMOE TABLE TOO SMALL'
125600                                 TO SS02WS-ABENDMSG8
125700             PERFORM SS02PD-ABEND
125800                THRU SS02PD-ABEND-EXIT
125900         WHEN MMOETB-END-OF-TABLE (X-MMOETB-DETAIL)
126000             MOVE MMOEIR-RECORD  TO MMOE-RECORD
126100             MOVE MTPT-ORG-MERCHANT
126200                                 TO MMOE-ORG-ACCT
126300             SET  MMOE-DETAIL    TO TRUE
126400             MOVE MTPT-PRODUCT   TO MMOE-PRODUCT
126500             MOVE MTPT-QUAL-LEVEL
126600                                 TO MMOE-QUAL-LEVEL
126700             MOVE MTPT-LOGIC-MODULE
126800                                 TO MMOE-LOGIC-MODULE
126900             SET  MMOE-REC-ACTIVE
127000                                 TO TRUE
127100             MOVE MMOE-RECORD    TO MMOETB-RECORD
127200                                    (X-MMOETB-DETAIL)
127300         WHEN MMOETB-ORG-ACCT     (X-MMOETB-DETAIL) IS EQUAL TO
127400                                 MTPT-ORG-MERCHANT
127500          AND MMOETB-DETAIL (X-MMOETB-DETAIL)
127600          AND MMOETB-PRODUCT (X-MMOETB-DETAIL) IS EQUAL TO
127700                                 MTPT-PRODUCT
127800          AND MMOETB-QUAL-LEVEL (X-MMOETB-DETAIL) IS EQUAL TO
127900                                 MTPT-QUAL-LEVEL
128000          AND MMOETB-LOGIC-MODULE (X-MMOETB-DETAIL) IS EQUAL TO
128100                                 MTPT-LOGIC-MODULE
128200             NEXT SENTENCE.
128300*
128400     MOVE MMOETB-RECORD (X-MMOETB-DETAIL)
128500                                 TO MMOE-RECORD.
128600*
128700*
128800*
128900     SET X-MMOETB-TOTAL          TO 1.
129000     SEARCH MMOETB-TABLE VARYING X-MMOETB-TOTAL
129100         AT END
129200             MOVE 'OIT2'         TO SS02WS-ABEND-LOCATION
129300             MOVE 26011          TO SS02WS-ABEND-CODE
129400             MOVE 'MMOE TABLE TOO SMALL'
129500                                 TO SS02WS-ABENDMSG8
129600             PERFORM SS02PD-ABEND
129700                THRU SS02PD-ABEND-EXIT
129800         WHEN MMOETB-END-OF-TABLE (X-MMOETB-TOTAL)
129900             MOVE MMOEIR-RECORD  TO MTOE-RECORD
130000             MOVE MTPT-ORG-MERCHANT
130100                                 TO MTOE-ORG-ACCT
130200             SET  MTOE-TOTALS    TO TRUE
130300             MOVE ZERO           TO MTOE-PRODUCT
130400             MOVE ZERO           TO MTOE-QUAL-LEVEL
130500             MOVE MTPT-LOGIC-MODULE
130600                                 TO MTOE-LOGIC-MODULE
130700             SET  MTOE-REC-ACTIVE
130800                                 TO TRUE
130900             MOVE MTOE-RECORD    TO MMOETB-RECORD
131000                                    (X-MMOETB-TOTAL)
131100         WHEN MMOETB-ORG-ACCT     (X-MMOETB-TOTAL) IS EQUAL TO
131200                                 MTPT-ORG-MERCHANT
131300          AND MMOETB-TOTALS (X-MMOETB-TOTAL)
131400          AND MMOETB-PRODUCT (X-MMOETB-TOTAL) IS EQUAL TO ZERO
131500          AND MMOETB-QUAL-LEVEL (X-MMOETB-TOTAL)
131600                                 IS EQUAL TO ZERO
131700          AND MMOETB-LOGIC-MODULE (X-MMOETB-TOTAL) IS EQUAL TO
131800                                 MTPT-LOGIC-MODULE
131900             NEXT SENTENCE.
132000*
132100     MOVE MMOETB-RECORD (X-MMOETB-TOTAL)
132200                                 TO MTOE-RECORD.
132300*
132400 F499-GIR-EXIT.
132500     EXIT.
132600/
132700 F800-GET-NEXT-TRANSACTION SECTION.
132800 F810-GNT-BEGIN.
132900*
133000     MOVE MTPT-RECORD            TO MTETIO-RECORD.
133100     MOVE MTPT-ORG-MERCHANT      TO MTPTWS-ORG-MERCHANT.
133200     MOVE MTPT-PRODUCT-X         TO MTPTWS-PRODUCT-X.
133300*
133400     MOVE 'R2ET'                 TO SS02WS-ABEND-LOCATION.
133500     SET MTETRB-READ-SEQ         TO TRUE.
133600     PERFORM MB00PD-MTET-ACCESS
133700        THRU MB00PD-MTET-ACCESS-EXIT.
133800*
133900     MOVE MTETIO-RECORD          TO MTPT-RECORD.
134000     MOVE MTPT-ORG-MERCHANT      TO MTPTWS-ORG-MERCHANT.
134100     MOVE MTPT-PRODUCT-X         TO MTPTWS-PRODUCT-X.
134200*
134300 F899-GNT-EXIT.
134400     EXIT.
134500/
134600 F900-NON-POST-TRANSACTION SECTION.
134700 F910-NPT-BEGIN.
134800*
134900     PERFORM F800-GET-NEXT-TRANSACTION
135000        THRU F899-GNT-EXIT.
135100*
135200 F999-NPT-EXIT.
135300     EXIT.
135400/
135500 T000-APPLY-TRANSACTION SECTION.
135600 T001-AT-BEGIN.
135700*
135800     MOVE MTPT-LOGIC-MODULE      TO MMTCWS-LOGIC-MODULE.
135900*
136000     IF  MMPE-ORG-ACCT     IS EQUAL TO MMMM-ORG-MERCHANT
136100         ADD MTPT-FEE-FACTOR-NBR TO MMPE-NBR (13)
136200         ADD MTPT-FEE-FACTOR-NBR TO MMPE-NBR (14)
136300         ADD MTPT-FEE-FACTOR-NBR TO MMPE-NBR (15)
136400         ADD MTPT-FEE-FACTOR-NBR TO MMPE-NBR (16)
136500         ADD MTPT-FEE-FACTOR-NBR TO MMPE-NBR (17)
136600         ADD MTPT-FEE-FACTOR-NBR TO MMPE-NBR (18)
136700         ADD MTPT-FEE-EXP-AMOUNT TO MMPE-AMT (13)
136800         ADD MTPT-FEE-EXP-AMOUNT TO MMPE-AMT (14)
136900         ADD MTPT-FEE-EXP-AMOUNT TO MMPE-AMT (15)
137000         ADD MTPT-FEE-EXP-AMOUNT TO MMPE-AMT (16)
137100         ADD MTPT-FEE-EXP-AMOUNT TO MMPE-AMT (17)
137200         ADD MTPT-FEE-EXP-AMOUNT TO MMPE-AMT (18).
137300*
137400     IF  MTPE-ORG-ACCT     IS EQUAL TO MMMM-ORG-MERCHANT
137500         ADD MTPT-FEE-FACTOR-NBR TO MTPE-NBR (13)
137600         ADD MTPT-FEE-FACTOR-NBR TO MTPE-NBR (14)
137700         ADD MTPT-FEE-FACTOR-NBR TO MTPE-NBR (15)
137800         ADD MTPT-FEE-FACTOR-NBR TO MTPE-NBR (16)
137900         ADD MTPT-FEE-FACTOR-NBR TO MTPE-NBR (17)
138000         ADD MTPT-FEE-FACTOR-NBR TO MTPE-NBR (18)
138100         ADD MTPT-FEE-EXP-AMOUNT TO MTPE-AMT (13)
138200         ADD MTPT-FEE-EXP-AMOUNT TO MTPE-AMT (14)
138300         ADD MTPT-FEE-EXP-AMOUNT TO MTPE-AMT (15)
138400         ADD MTPT-FEE-EXP-AMOUNT TO MTPE-AMT (16)
138500         ADD MTPT-FEE-EXP-AMOUNT TO MTPE-AMT (17)
138600         ADD MTPT-FEE-EXP-AMOUNT TO MTPE-AMT (18).
138700*
138800     IF  MMOE-ORG-ACCT     IS EQUAL TO MMMM-ORG-MERCHANT
138900         ADD MTPT-FEE-FACTOR-NBR TO MMOE-NBR (13)
139000         ADD MTPT-FEE-FACTOR-NBR TO MMOE-NBR (14)
139100         ADD MTPT-FEE-FACTOR-NBR TO MMOE-NBR (15)
139200         ADD MTPT-FEE-FACTOR-NBR TO MMOE-NBR (16)
139300         ADD MTPT-FEE-FACTOR-NBR TO MMOE-NBR (17)
139400         ADD MTPT-FEE-FACTOR-NBR TO MMOE-NBR (18)
139500         ADD MTPT-FEE-EXP-AMOUNT TO MMOE-AMT (13)
139600         ADD MTPT-FEE-EXP-AMOUNT TO MMOE-AMT (14)
139700         ADD MTPT-FEE-EXP-AMOUNT TO MMOE-AMT (15)
139800         ADD MTPT-FEE-EXP-AMOUNT TO MMOE-AMT (16)
139900         ADD MTPT-FEE-EXP-AMOUNT TO MMOE-AMT (17)
140000         ADD MTPT-FEE-EXP-AMOUNT TO MMOE-AMT (18).
140100*
140200     IF  MTOE-ORG-ACCT     IS EQUAL TO MMMM-ORG-MERCHANT
140300         ADD MTPT-FEE-FACTOR-NBR TO MTOE-NBR (13)
140400         ADD MTPT-FEE-FACTOR-NBR TO MTOE-NBR (14)
140500         ADD MTPT-FEE-FACTOR-NBR TO MTOE-NBR (15)
140600         ADD MTPT-FEE-FACTOR-NBR TO MTOE-NBR (16)
140700         ADD MTPT-FEE-FACTOR-NBR TO MTOE-NBR (17)
140800         ADD MTPT-FEE-FACTOR-NBR TO MTOE-NBR (18)
140900         ADD MTPT-FEE-EXP-AMOUNT TO MTOE-AMT (13)
141000         ADD MTPT-FEE-EXP-AMOUNT TO MTOE-AMT (14)
141100         ADD MTPT-FEE-EXP-AMOUNT TO MTOE-AMT (15)
141200         ADD MTPT-FEE-EXP-AMOUNT TO MTOE-AMT (16)
141300         ADD MTPT-FEE-EXP-AMOUNT TO MTOE-AMT (17)
141400         ADD MTPT-FEE-EXP-AMOUNT TO MTOE-AMT (18).
141500*
141600 T099-AT-EXIT.
141700     EXIT.
141800/
141900 8000-ORG-NOT-PROCESSING SECTION.
142000 8010-ONP-BEGIN.
142100*
142200     PERFORM 8100-ONP-PROCESS-MMOE
142300        THRU 8199-ONP-CP-EXIT
142400        UNTIL MMOEIO-ORG IS GREATER THAN MMOC-ORG.
142500*
142600     PERFORM 8300-ONP-PROCESS-MMPE
142700        THRU 8399-ONP-PA-EXIT
142800        UNTIL MMPEIO-ORG IS GREATER THAN MMOC-ORG.
142900*
143000 8099-ONP-EXIT.
143100     EXIT.
143200/
143300 8100-ONP-PROCESS-MMOE  SECTION.
143400 8110-ONP-CP-BEGIN.
143500*
143600     MOVE MMOEIO-RECORD          TO MTOEIO-RECORD.
143700*
143800     MOVE 'WWOE'                 TO SS02WS-ABEND-LOCATION.
143900     SET MTOERB-WRITE            TO TRUE.
144000     PERFORM MB00PD-MTOE-ACCESS
144100        THRU MB00PD-MTOE-ACCESS-EXIT.
144200*
144300     MOVE 'R5OE'                 TO SS02WS-ABEND-LOCATION.
144400     SET MMOERB-READ-SEQ         TO TRUE.
144500     PERFORM MB00PD-MMOE-ACCESS
144600        THRU MB00PD-MMOE-ACCESS-EXIT.
144700*
144800     MOVE MMOEIO-RECORD          TO MMOE-RECORD.
144900*
145000 8199-ONP-CP-EXIT.
145100     EXIT.
145200/
145300 8300-ONP-PROCESS-MMPE SECTION.
145400 8310-ONP-PA-BEGIN.
145500*
145600     MOVE MMPEIO-RECORD          TO MTPEIO-RECORD.
145700*
145800     MOVE 'WWPE'                 TO SS02WS-ABEND-LOCATION.
145900     SET MTPERB-WRITE            TO TRUE.
146000     PERFORM MB00PD-MTPE-ACCESS
146100        THRU MB00PD-MTPE-ACCESS-EXIT.
146200*
146300     MOVE 'R5PE'                 TO SS02WS-ABEND-LOCATION.
146400     SET MMPERB-READ-SEQ         TO TRUE.
146500     PERFORM MB00PD-MMPE-ACCESS
146600        THRU MB00PD-MMPE-ACCESS-EXIT.
146700*
146800     MOVE MMPEIO-RECORD          TO MMPE-RECORD.
146900*
147000 8399-ONP-PA-EXIT.
147100     EXIT.
147200/
147300 9000-PERFORMED-ROUTINES SECTION.
147400     COPY MB00PD REPLACING ==:MB00:== BY ==MMSC==.
147500/
147600     COPY MB00PD REPLACING ==:MB00:== BY ==MMOC==.
147700/
147800     COPY MB00PD REPLACING ==:MB00:== BY ==MMOE==.
147900/
148000     COPY MB05PD REPLACING ==:MB05:== BY ==MMOE==
148100                           ==:XX:==   BY ==OE==.
148200/
148300     COPY MB00PD REPLACING ==:MB00:== BY ==MMMM==.
148400/
148500     COPY MMMMPX.
148600/
148700     COPY MB00PD REPLACING ==:MB00:== BY ==MMPE==.
148800/
148900     COPY MB05PD REPLACING ==:MB05:== BY ==MMPE==
149000                           ==:XX:==   BY ==PE==.
149100/
149200     COPY MB00PD REPLACING ==:MB00:== BY ==MMTC==.
149300/
149400     COPY MMTCPX.
149500/
149600     COPY MB00PD REPLACING ==:MB00:== BY ==MTOE==.
149700/
149800     COPY MB00PD REPLACING ==:MB00:== BY ==MTPE==.
149900/
150000     COPY MB00PD REPLACING ==:MB00:== BY ==MTET==.
150100/
150200     COPY MB99PD.
150300/
150400     COPY SS02PD.
150500/
150600     COPY SS03PD.
150700/
150800     COPY SS04PD.
150900/
151000     COPY SS06PD.
151100/
151200     COPY SS07PD.
151300/
151400     COPY SS08PD.
151500/
151600     COPY SS09PD.
151700/
151800     COPY SS12PD.
151900/
152000     COPY SS18PD.
152100*
152200 9995-END-SOURCE-STATEMENTS SECTION.
152300 9999-END-OF-PROGRAM.
152400     EXIT.
