000100 IDENTIFICATION DIVISION.
000200 PROGRAM-ID. MBD320BC.
000201*       RELEASE DATE=08/24/01.        REVISION LEVEL=08.06      * ++++++++
000202***************************************************************** ++++++++
000203*WARNING.  THIS COMPUTER PROGRAM IS PROTECTED BY COPYRIGHT LAW  * ++++++++
000204*AND INTERNATIONAL TREATIES.  UNAUTHORIZED REPRODUCTION OR      * ++++++++
000205*DISTRIBUTION OF THIS PROGRAM, OR ANY PORTION OF IT, MAY RESULT * ++++++++
000206*IN SEVERE CIVIL AND CRIMINAL PENATLIES, AND WILL BE PROSECUTED * ++++++++
000207*TO THE MAXIMUM EXTENT POSSIBLE UNDER THE LAW.                  * ++++++++
000208*COPYRIGHT 1999 PAYSYS INTERNATIONAL, INC.  ALL RIGHTS RESERVED.* ++++++++
000209***************************************************************** ++++++++
000300*****************************************************************
000400*                                                               *
000500*  MBD320BC - BAR CODE ASSIGNMENT SUBROUTINE - CHAIN STATEMENTS *
000600*                                                               *
000700*****************************************************************
000800 ENVIRONMENT DIVISION.
000900 CONFIGURATION SECTION.
001000 SOURCE-COMPUTER.            IBM-4341.
001100 OBJECT-COMPUTER.            IBM-4341.
001200/
001300 DATA DIVISION.
001400 WORKING-STORAGE SECTION.
001500*
001600 01  FILLER                  PIC  X(12)      VALUE '** WS-BEG **'.
001700*
001800 01  WS-D320-WORK-AREAS.
001900*
002000     03  WS-D320-BAR-CODE-HIT-FLAG
002100                             PIC  X(01)      VALUE 'N'.
002200         88  WS-D320-BCHF-EQUAL              VALUE 'Y'.
002300         88  WS-D320-BCHF-NOT-EQUAL          VALUE 'N'.
002400/
002500     COPY MMBCIR.
002600/
002700     COPY MB00WS.
002800*
002900 01  FILLER                  PIC  X(12)      VALUE '** WS-END **'.
003000/
003100 LINKAGE SECTION.
003200     COPY MMRCRL.
003300/
003400     COPY MMBCRL.
003500/
003600     COPY MMBCTB.
003700/
003800 PROCEDURE DIVISION              USING MMRC-RECORD
003900                                       MMBC-RECORD
004000                                       MMBCTB-TABLE-PARMS
004100                                       MMBCTB-TABLE-DATA.
004200*
004300 A000-MAIN-LINE SECTION.
004400 A010-ML-BEGIN.
004500*
004600     MOVE MMBCIR-RECORD          TO MMBC-RECORD.
004700*
004800     PERFORM B000-SCAN-BAR-CODE-TABLE
004900        THRU B099-SBCT-EXIT
005000        VARYING X-MMBCTB FROM 1 BY 1
005100        UNTIL   X-MMBCTB IS GREATER THAN MMBCTB-MAX-ENTRIES
005200           OR   MMBCTB-END-OF-TABLE (X-MMBCTB)
005300           OR   MMBC-KEY IS NOT EQUAL TO MMBCIR-KEY.
005400*
005500     GO TO 9999-END-OF-PROGRAM.
005600*
005700 A999-ML-EXIT.
005800     EXIT.
005900/
006000 B000-SCAN-BAR-CODE-TABLE SECTION.
006100 B010-SBCT-BEGIN.
006200*
006300     MOVE MMBCTB-RECORD (X-MMBCTB)
006400                                 TO MMBC-RECORD.
006500*
006600*****************************************************************
006700*    CHECK STATEMENT CYCLE                                      *
006800*****************************************************************
006900*
007000     IF  MMBC-USE-STMT-CYCLE
007100         SET WS-D320-BCHF-NOT-EQUAL
007200                                 TO TRUE
007300         PERFORM
007400             VARYING X-MMBC-STMT-CYCLE FROM 1 BY 1
007500             UNTIL   X-MMBC-STMT-CYCLE IS GREATER THAN 18
007600             IF  MMBC-STMT-CYCLE (X-MMBC-STMT-CYCLE)
007700                                 IS EQUAL TO ZERO
007800                 CONTINUE
007900             ELSE
008000                 IF  MMRC-STMT-FREQ-1 IS EQUAL TO
008100                     MMBC-STMT-CYCLE (X-MMBC-STMT-CYCLE)
008200                 OR  MMRC-STMT-FREQ-2 IS EQUAL TO
008300                     MMBC-STMT-CYCLE (X-MMBC-STMT-CYCLE)
008400                     SET WS-D320-BCHF-EQUAL
008500                                 TO TRUE
008600                 END-IF
008700             END-IF
008800         END-PERFORM
008900         EVALUATE TRUE
009000            WHEN MMBC-SC-IND-EQUAL
009100                IF  WS-D320-BCHF-NOT-EQUAL
009200                    MOVE MMBCIR-RECORD
009300                                 TO MMBC-RECORD
009400                END-IF
009500            WHEN MMBC-SC-IND-NOT-EQUAL
009600                IF  WS-D320-BCHF-EQUAL
009700                    MOVE MMBCIR-RECORD
009800                                 TO MMBC-RECORD
009900                END-IF
010000         END-EVALUATE.
010100*
010200     IF  MMBC-KEY IS EQUAL TO MMBCIR-KEY
010300         GO TO B099-SBCT-EXIT.
010400*
010500*****************************************************************
010600*    CHECK POSTAL CODE                                          *
010700*****************************************************************
010800*
010900     IF  MMBC-USE-POSTAL-CODE
011000         SET WS-D320-BCHF-NOT-EQUAL
011100                                 TO TRUE
011200         PERFORM
011300             VARYING X-MMBC-POSTAL-CODE FROM 1 BY 1
011400             UNTIL   X-MMBC-POSTAL-CODE IS GREATER THAN 18
011500             OR      WS-D320-BCHF-EQUAL
011600             IF (MMBC-POSTAL-CODE (X-MMBC-POSTAL-CODE)  (1:1)
011700                                 IS EQUAL TO '*'
011800              OR MMBC-POSTAL-CODE (X-MMBC-POSTAL-CODE)  (1:1)
011900                                 IS EQUAL TO
012000                 MMRC-POSTAL-CODE (1:1))
012100             AND
012200                (MMBC-POSTAL-CODE (X-MMBC-POSTAL-CODE)  (2:1)
012300                                 IS EQUAL TO '*'
012400              OR MMBC-POSTAL-CODE (X-MMBC-POSTAL-CODE)  (2:1)
012500                                 IS EQUAL TO
012600                 MMRC-POSTAL-CODE (2:1))
012700             AND
012800                (MMBC-POSTAL-CODE (X-MMBC-POSTAL-CODE)  (3:1)
012900                                 IS EQUAL TO '*'
013000              OR MMBC-POSTAL-CODE (X-MMBC-POSTAL-CODE)  (3:1)
013100                                 IS EQUAL TO
013200                 MMRC-POSTAL-CODE (3:1))
013300             AND
013400                (MMBC-POSTAL-CODE (X-MMBC-POSTAL-CODE)  (4:1)
013500                                 IS EQUAL TO '*'
013600              OR MMBC-POSTAL-CODE (X-MMBC-POSTAL-CODE)  (4:1)
013700                                 IS EQUAL TO
013800                 MMRC-POSTAL-CODE (4:1))
013900             AND
014000                (MMBC-POSTAL-CODE (X-MMBC-POSTAL-CODE)  (5:1)
014100                                 IS EQUAL TO '*'
014200              OR MMBC-POSTAL-CODE (X-MMBC-POSTAL-CODE)  (5:1)
014300                                 IS EQUAL TO
014400                 MMRC-POSTAL-CODE (5:1))
014500             AND
014600                (MMBC-POSTAL-CODE (X-MMBC-POSTAL-CODE)  (6:1)
014700                                 IS EQUAL TO '*'
014800              OR MMBC-POSTAL-CODE (X-MMBC-POSTAL-CODE)  (6:1)
014900                                 IS EQUAL TO
015000                 MMRC-POSTAL-CODE (6:1))
015100             AND
015200                (MMBC-POSTAL-CODE (X-MMBC-POSTAL-CODE)  (7:1)
015300                                 IS EQUAL TO '*'
015400              OR MMBC-POSTAL-CODE (X-MMBC-POSTAL-CODE)  (7:1)
015500                                 IS EQUAL TO
015600                 MMRC-POSTAL-CODE (7:1))
015700             AND
015800                (MMBC-POSTAL-CODE (X-MMBC-POSTAL-CODE)  (8:1)
015900                                 IS EQUAL TO '*'
016000              OR MMBC-POSTAL-CODE (X-MMBC-POSTAL-CODE)  (8:1)
016100                                 IS EQUAL TO
016200                 MMRC-POSTAL-CODE (8:1))
016300             AND
016400                (MMBC-POSTAL-CODE (X-MMBC-POSTAL-CODE)  (9:1)
016500                                 IS EQUAL TO '*'
016600              OR MMBC-POSTAL-CODE (X-MMBC-POSTAL-CODE)  (9:1)
016700                                 IS EQUAL TO
016800                 MMRC-POSTAL-CODE (9:1))
016900             AND
017000                (MMBC-POSTAL-CODE (X-MMBC-POSTAL-CODE)  (10:1)
017100                                 IS EQUAL TO '*'
017200              OR MMBC-POSTAL-CODE (X-MMBC-POSTAL-CODE)  (10:1)
017300                                 IS EQUAL TO
017400                 MMRC-POSTAL-CODE (10:1))
017500                 SET WS-D320-BCHF-EQUAL
017600                                 TO TRUE
017700             END-IF
017800         END-PERFORM
017900         EVALUATE TRUE
018000            WHEN MMBC-POSTAL-IND-EQUAL
018100                IF  WS-D320-BCHF-NOT-EQUAL
018200                    MOVE MMBCIR-RECORD
018300                                 TO MMBC-RECORD
018400                END-IF
018500            WHEN MMBC-POSTAL-IND-NOT-EQUAL
018600                IF  WS-D320-BCHF-EQUAL
018700                    MOVE MMBCIR-RECORD
018800                                 TO MMBC-RECORD
018900                END-IF
019000         END-EVALUATE.
019100*
019200     IF  MMBC-KEY IS EQUAL TO MMBCIR-KEY
019300         GO TO B099-SBCT-EXIT.
019400*
019500*****************************************************************
019600*    CHECK STATEMENT MESSAGE FLAG                               *
019700*****************************************************************
019800*
019900     IF  MMBC-USE-STMT-MSG-FLAG
020000         SET WS-D320-BCHF-NOT-EQUAL
020100                                 TO TRUE
020200         IF (MMBC-STMT-MSG-FLAG (1) IS EQUAL TO SPACES
020300         OR  MMBC-STMT-MSG-FLAG (1) IS EQUAL TO
020400             MMRC-STMT-MSG-FLAG (1))
020500         AND
020600            (MMBC-STMT-MSG-FLAG (2) IS EQUAL TO SPACES
020700         OR  MMBC-STMT-MSG-FLAG (2) IS EQUAL TO
020800             MMRC-STMT-MSG-FLAG (2))
020900         AND
021000            (MMBC-STMT-MSG-FLAG (3) IS EQUAL TO SPACES
021100         OR  MMBC-STMT-MSG-FLAG (3) IS EQUAL TO
021200             MMRC-STMT-MSG-FLAG (3))
021300         AND
021400            (MMBC-STMT-MSG-FLAG (4) IS EQUAL TO SPACES
021500         OR  MMBC-STMT-MSG-FLAG (4) IS EQUAL TO
021600             MMRC-STMT-MSG-FLAG (4))
021700         AND
021800            (MMBC-STMT-MSG-FLAG (5) IS EQUAL TO SPACES
021900         OR  MMBC-STMT-MSG-FLAG (5) IS EQUAL TO
022000             MMRC-STMT-MSG-FLAG (5))
022100             SET WS-D320-BCHF-EQUAL
022200                                 TO TRUE
022300         END-IF
022400         EVALUATE TRUE
022500            WHEN MMBC-SMF-IND-EQUAL
022600                IF  WS-D320-BCHF-NOT-EQUAL
022700                    MOVE MMBCIR-RECORD
022800                                 TO MMBC-RECORD
022900                END-IF
023000            WHEN MMBC-SMF-IND-NOT-EQUAL
023100                IF  WS-D320-BCHF-EQUAL
023200                    MOVE MMBCIR-RECORD
023300                                 TO MMBC-RECORD
023400                END-IF
023500         END-EVALUATE.
023600*
023700     IF  MMBC-DONT-USE-STMT-MSG-FLAG
023800     AND MMBC-DONT-USE-POSTAL-CODE
023900     AND MMBC-DONT-USE-STMT-CYCLE
024000         MOVE MMBCIR-RECORD      TO MMBC-RECORD.
024100*
024200 B099-SBCT-EXIT.
024300     EXIT.
024400/
024500 9000-PERFORMED-ROUTINES-SECT SECTION.
024600*
024700*
024800*
024900 9995-END-SOURCE-STATEMENTS SECTION.
025000 9999-END-OF-PROGRAM.
025100     GOBACK.
