000100 IDENTIFICATION DIVISION.
000200 PROGRAM-ID. MBD340.
000201*       RELEASE DATE=08/24/01.        REVISION LEVEL=08.06      *
000202*****************************************************************
000203*WARNING.  THIS COMPUTER PROGRAM IS PROTECTED BY COPYRIGHT LAW  *
000204*AND INTERNATIONAL TREATIES.  UNAUTHORIZED REPRODUCTION OR      *
000205*DISTRIBUTION OF THIS PROGRAM, OR ANY PORTION OF IT, MAY RESULT *
000206*IN SEVERE CIVIL AND CRIMINAL PENATLIES, AND WILL BE PROSECUTED *
000207*TO THE MAXIMUM EXTENT POSSIBLE UNDER THE LAW.                  *
000208*COPYRIGHT 1999 PAYSYS INTERNATIONAL, INC.  ALL RIGHTS RESERVED.*
000209*****************************************************************
000300*****************************************************************
000400*                                                               *
000500*   V - PLUS  M E R C H A N T   B A N K C A R D   S Y S T E M   *
000600*                                                               *
000700*       MBD340 - EXTRACT STORE TRANSACTIONS AND SORT            *
000800*                                                               *
000900*****************************************************************
001000 ENVIRONMENT DIVISION.
001100 CONFIGURATION SECTION.
001200 SOURCE-COMPUTER.            IBM-4341.
001300 OBJECT-COMPUTER.            IBM-4341.
001400/
001500 INPUT-OUTPUT SECTION.
001600*
001700 FILE-CONTROL.
001800*
001900     COPY MS1SES.
002000*
002100     COPY MS2SES.
002200/
002300 DATA DIVISION.
002400 FILE SECTION.
002500*
002600     COPY MS1SSD.
002700     COPY MTSTRL.
002800/
002900     COPY MS2SSD.
003000     COPY MTVIRL REPLACING ==:MTVI:== BY ==MTVI==.
003100/
003200 WORKING-STORAGE SECTION.
003300*
003400 01  FILLER                  PIC  X(12)      VALUE '** WS-BEG **'.
003500*
003600 01  WS-D340-WORK-AREAS.
003700     03  WS-D340-CARD-ACCEPTOR-ID
003800                             PIC  X(15)      VALUE SPACES.
003900     03  WS-D340-REFMOD-1    PIC  9(02)      VALUE ZERO.
004000     03  WS-D340-REFMOD-2    PIC  9(02)      VALUE ZERO.
004100     03  WS-D340-LENGTH-1    PIC  9(02)      VALUE ZERO.
004200     03  WS-D340-LENGTH-2    PIC  9(02)      VALUE ZERO.
004300     03  WS-D340-START       PIC  9(02)      VALUE ZERO.
004400/
004500     COPY MMSCIO.
004600/
004700     COPY MB00RB REPLACING ==:MB00:== BY ==MMSC==.
004800/
004900     COPY MMSCRL.
005000/
005100     COPY MMTCWS.
005200/
005300     COPY MB00RB REPLACING ==:MB00:== BY ==MS1S==.
005400/
005500     COPY MB00RB REPLACING ==:MB00:== BY ==MS2S==.
005600/
005700     COPY MTPTIO REPLACING ==:MTPT:== BY ==MTPT==.
005800/
005900     COPY MB00RB REPLACING ==:MB00:== BY ==MTPT==.
006000/
006100     COPY MTPTRL REPLACING ==:MTPT:== BY ==MTPT==.
006200/
006300     COPY MTSTIO.
006400/
006500     COPY MB00RB REPLACING ==:MB00:== BY ==MTST==.
006600/
006700     COPY MTVIIO REPLACING ==:MTVI:== BY ==MTVI==.
006800/
006900     COPY MB00RB REPLACING ==:MB00:== BY ==MTVI==.
007000/
007100     COPY MB00WS.
007200/
007300     COPY MB99WS.
007400/
007500     COPY SS00WS.
007600/
007700     COPY SS01WS.
007800/
007900     COPY SS02WS.
008000*
008100 01  FILLER                  PIC  X(12)      VALUE '** WS-END **'.
008200/
008300 PROCEDURE DIVISION.
008400 A000-MAIN-LINE-SECT SECTION.
008500 A010-ML-BEGIN.
008600*
008700     MOVE 'MBD340'               TO SS02WS-ABEND-PROG-ID.
008800*
008900     PERFORM A100-OPEN-FILES
009000        THRU A199-OF-EXIT.
009100*
009200     PERFORM A200-SORT-PROCESS
009300        THRU A299-SP-EXIT.
009400*
009500     PERFORM A300-CLOSE-FILES
009600        THRU A399-CF-EXIT.
009700*
009800     STOP RUN.
009900*
010000 A099-ML-EXIT.
010100     EXIT.
010200/
010300 A100-OPEN-FILES SECTION.
010400 A101-OF-BEGIN.
010500*
010600     MOVE 'O1SC'                 TO SS02WS-ABEND-LOCATION.
010700     SET MMSCRB-OPEN-INPUT       TO TRUE.
010800     PERFORM MB00PD-MMSC-ACCESS
010900        THRU MB00PD-MMSC-ACCESS-EXIT.
011000*
011100     MOVE 'R1SC'                 TO SS02WS-ABEND-LOCATION.
011200     SET MMSCRB-READ-SEQ         TO TRUE.
011300     PERFORM MB00PD-MMSC-ACCESS
011400        THRU MB00PD-MMSC-ACCESS-EXIT.
011500*
011600     MOVE 'MMSC'                 TO MB99WS-FILE-ID.
011700*
011800     IF  MMSCIO-HEADER
011900         NEXT SENTENCE
012000     ELSE
012100         PERFORM MB99PD-MISSING-HEADER-ABEND
012200            THRU MB99PD-MHA-EXIT.
012300*
012400     MOVE MMSCIO-RECORD          TO MMSC-RECORD.
012500     MOVE MMSC-TODAYS-JULIAN     TO MB99WS-PROC-DATE.
012600     MOVE MMSC-TIME-STAMP        TO MB99WS-PROC-TIME.
012700*
012800*
012900*
013000     MOVE 'O1PT'                 TO SS02WS-ABEND-LOCATION.
013100     SET MTPTRB-OPEN-INPUT       TO TRUE.
013200     PERFORM MB00PD-MTPT-ACCESS
013300        THRU MB00PD-MTPT-ACCESS-EXIT.
013400*
013500     MOVE 'R0PT'                 TO SS02WS-ABEND-LOCATION.
013600     SET MTPTRB-READ-SEQ         TO TRUE.
013700     PERFORM MB00PD-MTPT-ACCESS
013800        THRU MB00PD-MTPT-ACCESS-EXIT.
013900     MOVE 'MTPT'                 TO MB99WS-FILE-ID.
014000*
014100     IF  MTPTIO-HEADER
014200         NEXT SENTENCE
014300     ELSE
014400         PERFORM MB99PD-MISSING-HEADER-ABEND
014500            THRU MB99PD-MHA-EXIT.
014600*
014700     MOVE MTPTIO-DATE-STAMP      TO MB99WS-FILE-DATE.
014800     MOVE MTPTIO-TIME-STAMP      TO MB99WS-FILE-TIME.
014900     PERFORM MB99PD-CHECK-DATE-TIME
015000        THRU MB99PD-CDT-EXIT.
015100*
015200     MOVE MTPTIO-RECORD          TO MTPT-RECORD.
015300*
015400*
015500*
015600     MOVE 'O1ST'                 TO SS02WS-ABEND-LOCATION.
015700     SET MTSTRB-OPEN-OUTPUT      TO TRUE.
015800     PERFORM MB00PD-MTST-ACCESS
015900        THRU MB00PD-MTST-ACCESS-EXIT.
016000*
016100     MOVE SPACES                 TO MTSTIO-RECORD.
016200     SET MTSTIO-HEADER           TO TRUE.
016300     MOVE ZERO                   TO MTSTIO-SEQ-NBR.
016400     MOVE MMSC-TODAYS-JULIAN     TO MTSTIO-DATE-STAMP.
016500     MOVE MMSC-TIME-STAMP        TO MTSTIO-TIME-STAMP.
016600*
016700     MOVE 'W0ST'                 TO SS02WS-ABEND-LOCATION.
016800     SET MTSTRB-WRITE            TO TRUE.
016900     PERFORM MB00PD-MTST-ACCESS
017000        THRU MB00PD-MTST-ACCESS-EXIT.
017100*
017200*
017300*
017400     MOVE 'O1VI'                 TO SS02WS-ABEND-LOCATION.
017500     SET MTVIRB-OPEN-INPUT       TO TRUE.
017600     PERFORM MB00PD-MTVI-ACCESS
017700        THRU MB00PD-MTVI-ACCESS-EXIT.
017800*
017900     MOVE SS02WS-END-OF-FILE     TO MTVIRB-PERM-STATUS-1.
018000*
018100 A199-OF-EXIT.
018200     EXIT.
018300/
018400 A200-SORT-PROCESS SECTION.
018500 A201-SP-BEGIN.
018600*
018700     SORT MS1S-SORT-FILE
018800         ON ASCENDING KEY MTST-ORG-STORE
018900                          MTST-POST-KEY
019000         INPUT  PROCEDURE IS 1000-EXTRACT-MTST
019100         OUTPUT PROCEDURE IS 2000-WRITE-MTST.
019200*
019300     PERFORM SS98PD-VERIFY-SORT-RETURN
019400        THRU SS98PD-VSR-EXIT.
019500*
019600*
019700*
019800     MOVE LENGTH OF WS-D340-CARD-ACCEPTOR-ID
019900                                 TO WS-D340-LENGTH-1.
020000*
020100     SORT MS2S-SORT-FILE
020200         ON ASCENDING KEY MTVI-50-ORG-STORE
020300         INPUT  PROCEDURE IS 5000-EXTRACT-MTVI
020400         OUTPUT PROCEDURE IS 6000-WRITE-MTVI.
020500*
020600     PERFORM SS98PD-VERIFY-SORT-RETURN
020700        THRU SS98PD-VSR-EXIT.
020800*
020900*
021000*
021100 A299-SP-EXIT.
021200     EXIT.
021300/
021400 A300-CLOSE-FILES SECTION.
021500 A301-CF-BEGIN.
021600*
021700     MOVE SPACES                 TO MTSTIO-RECORD.
021800     SET MTSTIO-TRAILER          TO TRUE.
021900     MOVE ZERO                   TO MTSTIO-SEQ-NBR.
022000     MOVE MMSC-TODAYS-JULIAN     TO MTSTIO-DATE-STAMP.
022100     MOVE MMSC-TIME-STAMP        TO MTSTIO-TIME-STAMP.
022200*
022300     MOVE 'W9ST'                 TO SS02WS-ABEND-LOCATION.
022400     SET MTSTRB-WRITE            TO TRUE.
022500     PERFORM MB00PD-MTST-ACCESS
022600        THRU MB00PD-MTST-ACCESS-EXIT.
022700*
022800     MOVE 'C1PT'                 TO SS02WS-ABEND-LOCATION.
022900     SET MTPTRB-CLOSE            TO TRUE.
023000     PERFORM MB00PD-MTPT-ACCESS
023100        THRU MB00PD-MTPT-ACCESS-EXIT.
023200*
023300     MOVE 'C1ST'                 TO SS02WS-ABEND-LOCATION.
023400     SET MTSTRB-CLOSE            TO TRUE.
023500     PERFORM MB00PD-MTST-ACCESS
023600        THRU MB00PD-MTST-ACCESS-EXIT.
023700*
023800     MOVE 'C2VI'                 TO SS02WS-ABEND-LOCATION.
023900     SET MTVIRB-CLOSE            TO TRUE.
024000     PERFORM MB00PD-MTVI-ACCESS
024100        THRU MB00PD-MTVI-ACCESS-EXIT.
024200*
024300     MOVE 'C1SC'                 TO SS02WS-ABEND-LOCATION.
024400     SET MMSCRB-CLOSE            TO TRUE.
024500     PERFORM MB00PD-MMSC-ACCESS
024600        THRU MB00PD-MMSC-ACCESS-EXIT.
024700*
024800 A399-CF-EXIT.
024900     EXIT.
025000/
025100 1000-EXTRACT-MTST SECTION.
025200 1001-E-MTST-BEGIN.
025300*
025400     MOVE 'R2PT'                 TO SS02WS-ABEND-LOCATION.
025500     SET MTPTRB-READ-SEQ         TO TRUE.
025600     PERFORM MB00PD-MTPT-ACCESS
025700        THRU MB00PD-MTPT-ACCESS-EXIT.
025800*
025900     IF  MTPTIO-HEADER
026000         GO TO 1001-E-MTST-BEGIN.
026100*
026200     IF  MTPTIO-TRAILER
026300         GO TO 1999-E-MTST-EXIT.
026400*
026500     MOVE MTPTIO-RECORD          TO MTPT-RECORD.
026600*
026700     IF  MTPT-STORE IS EQUAL TO ZERO
026800     OR  MTPT-POST-FLAG IS GREATER THAN ZERO
026900         GO TO 1001-E-MTST-BEGIN.
027000*
027100     MOVE MTPT-LOGIC-MODULE      TO MMTCWS-LOGIC-MODULE.
027200*
027300     IF  MMTCWS-LM-STORE-ALLOWED
027400         NEXT SENTENCE
027500     ELSE
027600         GO TO 1001-E-MTST-BEGIN.
027700*
027800     MOVE MTPT-RECORD            TO MTST-RECORD.
027900     MOVE MTPT-MERCHANT          TO MTST-MERCHANT.
028000     MOVE MTPT-STORE             TO MTST-STORE.
028100     RELEASE MTST-RECORD.
028200     GO TO 1001-E-MTST-BEGIN.
028300*
028400 1999-E-MTST-EXIT.
028500     EXIT.
028600/
028700 2000-WRITE-MTST SECTION.
028800 2001-W-MTST-BEGIN.
028900*
029000     RETURN MS1S-SORT-FILE
029100         AT END
029200             GO TO 2999-W-MTST-EXIT.
029300*
029400     MOVE MTST-RECORD            TO MTSTIO-RECORD.
029500*
029600     MOVE 'W1ST'                 TO SS02WS-ABEND-LOCATION.
029700     SET MTSTRB-WRITE            TO TRUE.
029800     PERFORM MB00PD-MTST-ACCESS
029900        THRU MB00PD-MTST-ACCESS-EXIT.
030000*
030100     GO TO 2001-W-MTST-BEGIN.
030200*
030300 2999-W-MTST-EXIT.
030400     EXIT.
030500/
030600 5000-EXTRACT-MTVI SECTION.
030700 5001-E-MTVI-BEGIN.
030800*
030900     MOVE 'R2VI'                 TO SS02WS-ABEND-LOCATION.
031000     SET MTVIRB-READ-SEQ         TO TRUE.
031100     PERFORM MB00PD-MTVI-ACCESS
031200        THRU MB00PD-MTVI-ACCESS-EXIT.
031300*
031400     IF  SS02WS-FS-END-OF-FILE
031500         GO TO 5900-E-MTVI-CLOSE-FILES.
031600*
031700     MOVE MTVIIO-RECORD          TO MTVI-RECORD.
031800     MOVE MTVI-50-CARD-ACCEPTOR-ID
031900                                 TO WS-D340-CARD-ACCEPTOR-ID.
032000     MOVE SPACES                 TO MTVI-50-CARD-ACCEPTOR-ID.
032100     MOVE ZEROES                 TO MTVI-50-ORG-STORE.
032200     MOVE 1                      TO WS-D340-REFMOD-2.
032300     MOVE 1                      TO WS-D340-START.
032400*
032500     IF  WS-D340-CARD-ACCEPTOR-ID (1:3) IS EQUAL TO '000'
032600     AND WS-D340-CARD-ACCEPTOR-ID IS NUMERIC
032700         MOVE 4                  TO WS-D340-START.
032800*
032900     PERFORM
033000         VARYING WS-D340-REFMOD-1 FROM WS-D340-START BY 1
033100         UNTIL   WS-D340-REFMOD-1 IS GREATER THAN
033200                                 WS-D340-LENGTH-1
033300            OR   WS-D340-REFMOD-2 IS GREATER THAN LENGTH OF
033400                                 MTVI-50-ORG-STORE
033500         IF  WS-D340-CARD-ACCEPTOR-ID (WS-D340-REFMOD-1:1)
033600                                 IS NUMERIC
033700             MOVE WS-D340-CARD-ACCEPTOR-ID (WS-D340-REFMOD-1:1)
033800                                 TO MTVI-50-ORG-STORE
033900                                    (WS-D340-REFMOD-2:1)
034000             ADD  1              TO WS-D340-REFMOD-2
034100         END-IF
034200     END-PERFORM.
034300*
034400     RELEASE MTVI-RECORD.
034500     GO TO 5001-E-MTVI-BEGIN.
034600*
034700*
034800*
034900 5900-E-MTVI-CLOSE-FILES.
035000*
035100     MOVE 'C1VI'                 TO SS02WS-ABEND-LOCATION.
035200     SET MTVIRB-CLOSE            TO TRUE.
035300     PERFORM MB00PD-MTVI-ACCESS
035400        THRU MB00PD-MTVI-ACCESS-EXIT.
035500*
035600     MOVE 'O2VI'                 TO SS02WS-ABEND-LOCATION.
035700     SET MTVIRB-OPEN-OUTPUT      TO TRUE.
035800     PERFORM MB00PD-MTVI-ACCESS
035900        THRU MB00PD-MTVI-ACCESS-EXIT.
036000*
036100 5999-E-MTVI-EXIT.
036200     EXIT.
036300/
036400 6000-WRITE-MTVI SECTION.
036500 6001-W-MTVI-BEGIN.
036600*
036700     RETURN MS2S-SORT-FILE
036800         AT END
036900             GO TO 6999-W-MTVI-EXIT.
037000*
037100     MOVE MTVI-RECORD            TO MTVIIO-RECORD.
037200*
037300     MOVE 'W1VI'                 TO SS02WS-ABEND-LOCATION.
037400     SET MTVIRB-WRITE            TO TRUE.
037500     PERFORM MB00PD-MTVI-ACCESS
037600        THRU MB00PD-MTVI-ACCESS-EXIT.
037700*
037800     GO TO 6001-W-MTVI-BEGIN.
037900*
038000 6999-W-MTVI-EXIT.
038100     EXIT.
038200/
038300 9000-PERFORMED-ROUTINES-SECT SECTION.
038400*
038500     COPY MB00PD REPLACING ==:MB00:== BY ==MMSC==.
038600/
038700     COPY MB00PD REPLACING ==:MB00:== BY ==MTPT==.
038800/
038900     COPY MB00PD REPLACING ==:MB00:== BY ==MTST==.
039000/
039100     COPY MB00PD REPLACING ==:MB00:== BY ==MTVI==.
039200/
039300     COPY MB99PD.
039400/
039500     COPY SS02PD.
039600/
039700     COPY SS98PD.
039800*
039900 9995-END-SOURCE-STATEMENTS SECTION.
040000 9999-END-OF-PROGRAM.
040100     EXIT.
