000100 IDENTIFICATION DIVISION.
000200 PROGRAM-ID. MBD360Q1.
000201*       RELEASE DATE=08/24/01.        REVISION LEVEL=08.06      * ++++++++
000202***************************************************************** ++++++++
000203*WARNING.  THIS COMPUTER PROGRAM IS PROTECTED BY COPYRIGHT LAW  * ++++++++
000204*AND INTERNATIONAL TREATIES.  UNAUTHORIZED REPRODUCTION OR      * ++++++++
000205*DISTRIBUTION OF THIS PROGRAM, OR ANY PORTION OF IT, MAY RESULT * ++++++++
000206*IN SEVERE CIVIL AND CRIMINAL PENATLIES, AND WILL BE PROSECUTED * ++++++++
000207*TO THE MAXIMUM EXTENT POSSIBLE UNDER THE LAW.                  * ++++++++
000208*COPYRIGHT 1999 PAYSYS INTERNATIONAL, INC.  ALL RIGHTS RESERVED.* ++++++++
000209***************************************************************** ++++++++
000300*****************************************************************
000400*                                                               *
000500*   V - 2 1   M E R C H A N T   B A N K C A R D   S Y S T E M   *
000600*                                                               *
000700*   MBD360Q1 - EUROPEAN QUARTERLY REPORT TOTALS - TRANS + VOLUME*
000800*                                                               *
000900*****************************************************************
001000*                                                               *
001100*   N O T E --- THIS PROGRAM IS AN ATTACHMENT TO THE STORE      *
001200*               POSTING PROGRAM AND PROVIDES FOR THE            *
001300*               ACCUMULATION OF EUROPEAN TRANSACTIONS AND VOLUME*
001400*               TOTALS FOR THE EUROPEAN QUARTERLY REPORTS.      *
001500*               ACCEPTANCE INFORMATION IS ACCUMULATED BY PROGRAM*
001600*               MBD371.                                         *
001700*               IF EUROPE IS DISABLED ON THE SYSTEM RECORD      *
001800*               (MMSC), THIS SUBROUTINE WILL NOT PROCESS THE    *
001900*               STORE INITIATED TRANSACTIONS AND THE MMQ1 FILE  *
002000*               NEED NOT BE PRESENT IN THE JCL.                 *
002100*                                                               *
002200*****************************************************************
002300 ENVIRONMENT DIVISION.
002400 CONFIGURATION SECTION.
002500 SOURCE-COMPUTER.            IBM-4341.
002600 OBJECT-COMPUTER.            IBM-4341.
002700/
002800 DATA DIVISION.
002900 WORKING-STORAGE SECTION.
003000*
003100 01  FILLER                  PIC  X(12)      VALUE '** WS-BEG **'.
003200*
003300 01  WS-D360-WORK-AREAS.
003400     03  WS-D360-CAT-INDEX   PIC  9(02)      VALUE ZERO.
003500     03  WS-D360-EUROPAY-SW  PIC  X(01)      VALUE 'N'.
003600         88  WS-D360-EUROPAY-OFF             VALUE 'N'.
003700         88  WS-D360-EUROPAY-ON              VALUE 'Y'.
003800/
003900     COPY MMQ1IO.
004000/
004100     COPY MB00RB REPLACING ==:MB00:== BY ==MMQ1==.
004200/
004300     COPY MMQ1IR.
004400/
004500     COPY MMQ1RL.
004600/
004700     COPY MB00WS.
004800/
004900     COPY MMTCWS.
005000/
005100     COPY MTPTWS REPLACING ==:MTPT:== BY ==MTPT==.
005200/
005300     COPY MB99WS.
005400/
005500     COPY SS00WS.
005600/
005700     COPY SS01WS.
005800/
005900     COPY SS02WS.
006000*
006100 01  FILLER                  PIC  X(12)      VALUE '** WS-END **'.
006200/
006300 LINKAGE SECTION.
006400     COPY MBD360WS.
006500/
006600     COPY MMSCRL.
006700/
006800     COPY MMOCRL.
006900/
007000     COPY MMSMRL.
007100/
007200     COPY MTSTRL.
007300/
007400 PROCEDURE DIVISION              USING MBD360WS-AREA
007500                                       MMSC-RECORD
007600                                       MMOC-RECORD
007700                                       MMSM-RECORD
007800                                       MTST-RECORD.
007900*
008000 A000-MAIN-LINE SECTION.
008100 A010-ML-BEGIN.
008200*
008300     MOVE 'D360Q1'               TO SS02WS-ABEND-PROG-ID.
008400*
008500     IF  MMSC-EUROPAY-OFF
008600         GO TO 9999-END-OF-PROGRAM.
008700*
008800     EVALUATE TRUE
008900       WHEN MBD360WS-Q1-PROCESS-RECORD
009000         PERFORM A500-PROCESS-RECORD
009100            THRU A599-PR-EXIT
009200       WHEN MBD360WS-Q1-ORG-CHANGE
009300         PERFORM A200-ORG-CHANGE
009400            THRU A299-OC-EXIT
009500       WHEN MBD360WS-Q1-ORG-UPDATE
009600         PERFORM A300-ORG-UPDATE
009700            THRU A399-OU-EXIT
009800       WHEN MBD360WS-Q1-OPEN-FILE
009900         PERFORM A100-OPEN-FILES
010000            THRU A199-OF-EXIT
010100       WHEN MBD360WS-Q1-CLOSE-FILE
010200         PERFORM A900-CLOSE-FILES
010300            THRU A999-CF-EXIT
010400       WHEN MBD360WS-Q1-ROLL-TOTALS
010500         PERFORM A400-ROLL-TOTALS
010600            THRU A499-RT-EXIT
010700     END-EVALUATE.
010800*
010900     GO TO 9999-END-OF-PROGRAM.
011000*
011100 A099-ML-EXIT.
011200     EXIT.
011300/
011400 A100-OPEN-FILES SECTION.
011500 A101-OF-BEGIN.
011600*
011700     MOVE MMSC-TODAYS-JULIAN     TO MB99WS-PROC-DATE.
011800     MOVE MMSC-TIME-STAMP        TO MB99WS-PROC-TIME.
011900*
012000     MOVE 'O1Q1'                 TO SS02WS-ABEND-LOCATION.
012100     SET MMQ1RB-OPEN-IO-DYN      TO TRUE.
012200     PERFORM MB00PD-MMQ1-ACCESS
012300        THRU MB00PD-MMQ1-ACCESS-EXIT.
012400*
012500*
012600*
012700     MOVE 'R0Q1'                 TO SS02WS-ABEND-LOCATION.
012800     SET MMQ1RB-READ-SEQ         TO TRUE.
012900     PERFORM MB00PD-MMQ1-ACCESS
013000        THRU MB00PD-MMQ1-ACCESS-EXIT.
013100     MOVE 'MMQ1'                 TO MB99WS-FILE-ID.
013200*
013300     IF  MMQ1IO-HEADER
013400         NEXT SENTENCE
013500     ELSE
013600         PERFORM MB99PD-MISSING-HEADER-ABEND
013700            THRU MB99PD-MHA-EXIT.
013800*
013900     MOVE MMQ1IO-DATE-STAMP      TO MB99WS-FILE-DATE.
014000     MOVE MMQ1IO-TIME-STAMP      TO MB99WS-FILE-TIME.
014100     PERFORM MB99PD-CHECK-DATE-TIME
014200        THRU MB99PD-CDT-EXIT.
014300*
014400     MOVE MMQ1IO-RECORD          TO MMQ1-RECORD.
014500*
014600*
014700*
014800 A199-OF-EXIT.
014900     EXIT.
015000/
015100 A200-ORG-CHANGE SECTION.
015200 A201-OC-BEGIN.
015300*
015400     IF  MMOC-MC-QTR-FLAG-EUROCARD
015500     OR  MMOC-VISA-QTR-FLAG-EU
015600         SET WS-D360-EUROPAY-ON  TO TRUE
015700     ELSE
015800         SET WS-D360-EUROPAY-OFF TO TRUE
015900     END-IF.
016000*
016100     PERFORM
016200         UNTIL MMQ1IO-KEY IS NOT LESS THAN MMOC-KEY
016300            OR MMQ1IO-TRAILER
016400         EVALUATE TRUE
016500           WHEN MMQ1IO-HEADER
016600             CONTINUE
016700           WHEN MMQ1IO-KEY IS LESS THAN MMOC-KEY
016800             MOVE MMQ1IO-RECORD  TO MMQ1-RECORD
016900             SET MMQ1-REC-PURGED TO TRUE
017000             MOVE MMQ1-RECORD    TO MMQ1IO-RECORD
017100             MOVE 'U1Q1'         TO SS02WS-ABEND-LOCATION
017200             SET MMQ1RB-REWRITE  TO TRUE
017300             PERFORM MB00PD-MMQ1-ACCESS
017400                THRU MB00PD-MMQ1-ACCESS-EXIT
017500         END-EVALUATE
017600         MOVE 'R1Q1'             TO SS02WS-ABEND-LOCATION
017700         SET MMQ1RB-READ-SEQ     TO TRUE
017800         PERFORM MB00PD-MMQ1-ACCESS
017900            THRU MB00PD-MMQ1-ACCESS-EXIT
018000     END-PERFORM.
018100*
018200*
018300*
018400     IF  MMOC-NOT-PROCESSING
018500         EVALUATE TRUE
018600           WHEN WS-D360-EUROPAY-OFF
018700             CONTINUE
018800           WHEN WS-D360-EUROPAY-ON
018900             IF  MMQ1IO-KEY IS EQUAL TO MMOC-KEY
019000                 MOVE 'R8Q1'     TO SS02WS-ABEND-LOCATION
019100                 SET MMQ1RB-READ-SEQ
019200                                 TO TRUE
019300                 PERFORM MB00PD-MMQ1-ACCESS
019400                    THRU MB00PD-MMQ1-ACCESS-EXIT
019500             END-IF
019600         END-EVALUATE
019700         GO TO A299-OC-EXIT.
019800*
019900*
020000*
020100     MOVE MMQ1IO-RECORD          TO MMQ1-RECORD.
020200*
020300     EVALUATE TRUE
020400       WHEN MMQ1-KEY IS GREATER THAN MMOC-KEY
020500         EVALUATE TRUE
020600           WHEN WS-D360-EUROPAY-OFF
020700             MOVE MMQ1IR-RECORD  TO MMQ1-RECORD
020800           WHEN WS-D360-EUROPAY-ON
020900             MOVE MMQ1IR-RECORD  TO MMQ1-RECORD
021000             MOVE MMOC-KEY       TO MMQ1-KEY
021100             SET MMQ1-REC-ACTIVE TO TRUE
021200             SET MMQ1-ADD-COMPLETED
021300                                 TO TRUE
021400             MOVE MMQ1-RECORD    TO MMQ1IO-RECORD
021500             MOVE 'W2Q1'         TO SS02WS-ABEND-LOCATION
021600             SET MMQ1RB-WRITE    TO TRUE
021700             PERFORM MB00PD-MMQ1-ACCESS
021800                THRU MB00PD-MMQ1-ACCESS-EXIT
021900             MOVE MMOC-KEY       TO MMQ1IO-KEY
022000             MOVE 'S2Q1'         TO SS02WS-ABEND-LOCATION
022100             SET MMQ1RB-START-GTE
022200                                 TO TRUE
022300             PERFORM MB00PD-MMQ1-ACCESS
022400                THRU MB00PD-MMQ1-ACCESS-EXIT
022500             MOVE 'R2Q1'         TO SS02WS-ABEND-LOCATION
022600             SET MMQ1RB-READ-SEQ TO TRUE
022700             PERFORM MB00PD-MMQ1-ACCESS
022800                THRU MB00PD-MMQ1-ACCESS-EXIT
022900         END-EVALUATE
023000       WHEN MMQ1-KEY IS EQUAL TO MMOC-KEY
023100         EVALUATE TRUE
023200           WHEN WS-D360-EUROPAY-OFF
023300             SET MMQ1-REC-PURGED TO TRUE
023400             MOVE MMQ1-RECORD    TO MMQ1IO-RECORD
023500             MOVE 'U2Q1'         TO SS02WS-ABEND-LOCATION
023600             SET MMQ1RB-REWRITE  TO TRUE
023700             PERFORM MB00PD-MMQ1-ACCESS
023800                THRU MB00PD-MMQ1-ACCESS-EXIT
023900           WHEN WS-D360-EUROPAY-ON
024000             IF  MMQ1-REC-ACTIVE
024100                 CONTINUE
024200             ELSE
024300                 MOVE MMQ1IR-RECORD
024400                                 TO MMQ1-RECORD
024500                 MOVE MMOC-KEY   TO MMQ1-KEY
024600                 SET MMQ1-REC-ACTIVE
024700                                 TO TRUE
024800             END-IF
024900         END-EVALUATE
025000     END-EVALUATE.
025100*
025200*
025300*
025400 A299-OC-EXIT.
025500     EXIT.
025600/
025700 A300-ORG-UPDATE SECTION.
025800 A301-OU-BEGIN.
025900*
026000     IF  MMQ1-QTR-BEG-DATE(1) IS EQUAL TO ZERO
026100     AND MMQ1-QTR-END-DATE(1) IS EQUAL TO ZERO
026200         MOVE MBD360WS-QTR-BEG-DATE
026300                                 TO MMQ1-QTR-BEG-DATE (1)
026400         MOVE MBD360WS-QTR-END-DATE
026500                                 TO MMQ1-QTR-END-DATE (1)
026600     END-IF.
026700*
026800     EVALUATE TRUE
026900       WHEN WS-D360-EUROPAY-OFF
027000         CONTINUE
027100       WHEN WS-D360-EUROPAY-ON
027200         MOVE MMQ1-RECORD        TO MMQ1IO-RECORD
027300         MOVE 'U3Q1'             TO SS02WS-ABEND-LOCATION
027400         SET MMQ1RB-REWRITE      TO TRUE
027500         PERFORM MB00PD-MMQ1-ACCESS
027600            THRU MB00PD-MMQ1-ACCESS-EXIT
027700         MOVE 'R3Q1'             TO SS02WS-ABEND-LOCATION
027800         SET MMQ1RB-READ-SEQ     TO TRUE
027900         PERFORM MB00PD-MMQ1-ACCESS
028000            THRU MB00PD-MMQ1-ACCESS-EXIT
028100     END-EVALUATE.
028200*
028300 A399-OU-EXIT.
028400     EXIT.
028500*
028600*
028700*
028800 A400-ROLL-TOTALS SECTION.
028900 A401-RT-BEGIN.
029000*
029100     MOVE MMQ1-VI-TABLE (3)      TO MMQ1-VI-TABLE (4).
029200     MOVE MMQ1-VI-TABLE (2)      TO MMQ1-VI-TABLE (3).
029300     MOVE MMQ1-VI-TABLE (1)      TO MMQ1-VI-TABLE (2).
029400     MOVE MMQ1IR-VI-TABLE (1)    TO MMQ1-VI-TABLE (1).
029500*
029600     MOVE MMQ1-MC-EUROPAY-TOTALS (3)
029700                                 TO MMQ1-MC-EUROPAY-TOTALS (4).
029800     MOVE MMQ1-MC-EUROPAY-TOTALS (2)
029900                                 TO MMQ1-MC-EUROPAY-TOTALS (3).
030000     MOVE MMQ1-MC-EUROPAY-TOTALS (1)
030100                                 TO MMQ1-MC-EUROPAY-TOTALS (2).
030200     MOVE MMQ1IR-MC-EUROPAY-TOTALS (1)
030300                                 TO MMQ1-MC-EUROPAY-TOTALS (1).
030400*
030500     MOVE MBD360WS-QTR-BEG-DATE  TO MMQ1-QTR-BEG-DATE (1).
030600     MOVE MBD360WS-QTR-END-DATE  TO MMQ1-QTR-END-DATE (1).
030700     MOVE MBD360WS-QTR-BEG-DATE  TO MMQ1-VI-QTR-BEG-DATE (1).
030800     MOVE MBD360WS-QTR-END-DATE  TO MMQ1-VI-QTR-END-DATE (1).
030900*
031000 A499-RT-EXIT.
031100     EXIT.
031200/
031300 A500-PROCESS-RECORD SECTION.
031400 A501-PR-BEGIN.
031500*
031600     IF  WS-D360-EUROPAY-OFF
031700         GO TO A599-PR-EXIT.
031800*
031900     IF  MTST-PRODUCT IS EQUAL TO ZERO
032000         GO TO A599-PR-EXIT.
032100*
032200     MOVE MTST-LOGIC-MODULE      TO MMTCWS-LOGIC-MODULE.
032300*
032400     IF  MMTCWS-LM-SALE
032500     OR  MMTCWS-LM-SALE-REV
032600     OR  MMTCWS-LM-RETURN
032700     OR  MMTCWS-LM-RETURN-REV
032800         CONTINUE
032900     ELSE
033000         GO TO A599-PR-EXIT.
033100*
033200     SET  X-MMOC-PROD            TO MTST-PRODUCT.
033300*
033400     EVALUATE TRUE
033500       WHEN MTST-PROD-IS-VISA
033600           PERFORM M010-VISA-EUROPE
033700              THRU M019-VE-EXIT
033800       WHEN MMOC-PROD-QRF-EUROCARD-MC    (X-MMOC-PROD)
033900           PERFORM M020-EUROCARD-MC
034000              THRU M029-E-MC-EXIT
034100       WHEN MMOC-PROD-QRF-EUROCHEQUE     (X-MMOC-PROD)
034200           PERFORM M030-EUROCHEQUE
034300              THRU M039-E-EXIT
034400       WHEN MMOC-PROD-QRF-EUROCHEQUE-ATM (X-MMOC-PROD)
034500           PERFORM M040-EUROCHEQUE-ATM
034600              THRU M049-E-ATM-EXIT
034700       WHEN MMOC-PROD-QRF-CIRRUS         (X-MMOC-PROD)
034800           PERFORM M050-CIRRUS
034900              THRU M059-C-EXIT
035000       WHEN MMOC-PROD-QRF-EDC            (X-MMOC-PROD)
035100           PERFORM M060-EDC
035200              THRU M069-EDC-EXIT
035300       WHEN MMOC-PROD-QRF-MAESTRO        (X-MMOC-PROD)
035400           PERFORM M070-MAESTRO
035500              THRU M079-M-EXIT
035600       WHEN MMOC-PROD-QRF-CLIP           (X-MMOC-PROD)
035700           PERFORM M080-CLIP
035800              THRU M089-CLIP-EXIT
035900       WHEN MMOC-PROD-QRF-CHIP           (X-MMOC-PROD)
036000           PERFORM M090-CHIP
036100              THRU M099-CHIP-EXIT
036200     END-EVALUATE.
036300*
036400 A599-PR-EXIT.
036500     EXIT.
036600/
036700 A900-CLOSE-FILES SECTION.
036800 A901-CF-BEGIN.
036900*
037000     MOVE 'C1Q1'                 TO SS02WS-ABEND-LOCATION.
037100     SET MMQ1RB-CLOSE            TO TRUE.
037200     PERFORM MB00PD-MMQ1-ACCESS
037300        THRU MB00PD-MMQ1-ACCESS-EXIT.
037400*
037500 A999-CF-EXIT.
037600     EXIT.
037700/
037800 M010-VISA-EUROPE SECTION.
037900 M011-VE-BEGIN.
038000*
038100     EVALUATE TRUE
038200         WHEN MBD360WS-CURR-MM IS EQUAL TO 01
038300         WHEN MBD360WS-CURR-MM IS EQUAL TO 04
038400         WHEN MBD360WS-CURR-MM IS EQUAL TO 07
038500         WHEN MBD360WS-CURR-MM IS EQUAL TO 10
038600             SET X-MMQ1-VI-MON   TO 1
038700             MOVE MBD360WS-CURR-YY
038800                                 TO MMQ1-VI-YEAR (1 1)
038900             MOVE MBD360WS-CURR-MM
039000                                 TO MMQ1-VI-MONTH (1 1)
039100         WHEN MBD360WS-CURR-MM IS EQUAL TO 02
039200         WHEN MBD360WS-CURR-MM IS EQUAL TO 05
039300         WHEN MBD360WS-CURR-MM IS EQUAL TO 08
039400         WHEN MBD360WS-CURR-MM IS EQUAL TO 11
039500             SET X-MMQ1-VI-MON   TO 2
039600             MOVE MBD360WS-CURR-YY
039700                                 TO MMQ1-VI-YEAR (1 2)
039800             MOVE MBD360WS-CURR-MM
039900                                 TO MMQ1-VI-MONTH (1 2)
040000         WHEN OTHER
040100             SET X-MMQ1-VI-MON   TO 3
040200             MOVE MBD360WS-CURR-YY
040300                                 TO MMQ1-VI-YEAR (1 3)
040400             MOVE MBD360WS-CURR-MM
040500                                 TO MMQ1-VI-MONTH (1 3)
040600     END-EVALUATE.
040700*
040800*
040900*
041000     MOVE MMSM-VI-CATEGORY-CODE  TO MBD360WS-Q1-CATEGORY-CODE.
041100     MOVE MTST-CARD-PROD-TYPE    TO MTPTWS-CARD-PROD-TYPE.
041200*
041300*
041400*
041500     EVALUATE TRUE
041600         WHEN MMTCWS-LM-RETURN
041700         WHEN MMTCWS-LM-SALE-REV
041800             ADD  MTST-AMOUNT    TO MMQ1-VI-REFUND-AMT
041900                                    (1 X-MMQ1-VI-MON)
042000             ADD  MTST-NBR-ITEMS TO MMQ1-VI-REFUND-NBR
042100                                    (1 X-MMQ1-VI-MON)
042200         WHEN MMTCWS-LM-SALE
042300         WHEN MMTCWS-LM-RETURN-REV
042400             EVALUATE TRUE
042500                 WHEN MMSM-STORE-ATM
042600                     ADD MTST-AMOUNT
042700                                 TO MMQ1-VI-ATM-AMT
042800                                    (1 X-MMQ1-VI-MON)
042900                     ADD MTST-NBR-ITEMS
043000                                 TO MMQ1-VI-ATM-NBR
043100                                    (1 X-MMQ1-VI-MON)
043200                     IF  MTPTWS-CPT-VI-PROPRIETARY
043300                         ADD MTST-AMOUNT
043400                                 TO MMQ1-VI-NBR-ATMS-PLUS-AMT (1)
043500                         ADD MTST-NBR-ITEMS
043600                                 TO MMQ1-VI-NBR-ATMS-PLUS-NBR (1)
043700                     END-IF
043800                 WHEN MMSM-STORE-CASH-ADV
043900                     ADD MTST-AMOUNT
044000                                 TO MMQ1-VI-CASH-ADV-AMT
044100                                    (1 X-MMQ1-VI-MON)
044200                     ADD MTST-NBR-ITEMS
044300                                 TO MMQ1-VI-CASH-ADV-NBR
044400                                    (1 X-MMQ1-VI-MON)
044500                 WHEN MTPTWS-CPT-VI-ELECTRON
044600                     ADD MTST-AMOUNT
044700                                 TO MMQ1-VI-ELECTRON-AMT
044800                                    (1 X-MMQ1-VI-MON)
044900                     ADD MTST-NBR-ITEMS
045000                                 TO MMQ1-VI-ELECTRON-NBR
045100                                    (1 X-MMQ1-VI-MON)
045200                 WHEN OTHER
045300                     ADD MTST-AMOUNT
045400                                 TO MMQ1-VI-VISA-AMT
045500                                    (1 X-MMQ1-VI-MON)
045600                     ADD MTST-NBR-ITEMS
045700                                 TO MMQ1-VI-VISA-NBR
045800                                    (1 X-MMQ1-VI-MON)
045900             END-EVALUATE
046000     END-EVALUATE.
046100*
046200*
046300*
046400     EVALUATE TRUE
046500       WHEN MBD360WS-Q1-CC-VI-TOTAL-01
046600           MOVE 01               TO WS-D360-CAT-INDEX
046700       WHEN MBD360WS-Q1-CC-VI-TOTAL-02
046800           MOVE 02               TO WS-D360-CAT-INDEX
046900       WHEN MBD360WS-Q1-CC-VI-TOTAL-03
047000           MOVE 03               TO WS-D360-CAT-INDEX
047100       WHEN MBD360WS-Q1-CC-VI-TOTAL-04
047200           MOVE 04               TO WS-D360-CAT-INDEX
047300       WHEN MBD360WS-Q1-CC-VI-TOTAL-05
047400           MOVE 05               TO WS-D360-CAT-INDEX
047500       WHEN MBD360WS-Q1-CC-VI-TOTAL-06
047600           MOVE 06               TO WS-D360-CAT-INDEX
047700       WHEN MBD360WS-Q1-CC-VI-TOTAL-07
047800           MOVE 07               TO WS-D360-CAT-INDEX
047900       WHEN MBD360WS-Q1-CC-VI-TOTAL-08
048000           MOVE 08               TO WS-D360-CAT-INDEX
048100       WHEN MBD360WS-Q1-CC-VI-TOTAL-09
048200           MOVE 09               TO WS-D360-CAT-INDEX
048300       WHEN MBD360WS-Q1-CC-VI-TOTAL-10
048400           MOVE 10               TO WS-D360-CAT-INDEX
048500       WHEN MBD360WS-Q1-CC-VI-TOTAL-12
048600           MOVE 12               TO WS-D360-CAT-INDEX
048700       WHEN MBD360WS-Q1-CC-VI-TOTAL-13
048800           MOVE 13               TO WS-D360-CAT-INDEX
048900       WHEN MBD360WS-Q1-CC-VI-TOTAL-14
049000           MOVE 14               TO WS-D360-CAT-INDEX
049100       WHEN OTHER
049200           MOVE 11               TO WS-D360-CAT-INDEX
049300     END-EVALUATE.
049400*
049500     SET X-MMQ1-VI-IS            TO WS-D360-CAT-INDEX.
049600     ADD MTST-AMOUNT             TO MMQ1-VI-IS-AMT
049700                                    (1 X-MMQ1-VI-IS).
049800     ADD MTST-NBR-ITEMS          TO MMQ1-VI-IS-NBR
049900                                    (1 X-MMQ1-VI-IS).
050000*
050100*
050200*
050300 M019-VE-EXIT.
050400     EXIT.
050500/
050600 M020-EUROCARD-MC SECTION.
050700 M021-E-MC-BEGIN.
050800*
050900     EVALUATE TRUE
051000       WHEN MMSM-STORE-CASH-ADV
051100           CONTINUE
051200       WHEN MMSM-STORE-ATM
051300           CONTINUE
051400       WHEN MMTCWS-LM-RETURN
051500           CONTINUE
051600       WHEN MMTCWS-LM-SALE-REV
051700           CONTINUE
051800       WHEN OTHER
051900         EVALUATE TRUE
052000           WHEN MTST-QI-DOMESTIC
052100             ADD  MTST-NBR-ITEMS TO MMQ1-INTRA-NBR-R(1)
052200             ADD  MTST-AMOUNT    TO MMQ1-INTRA-AMT-R(1)
052300             PERFORM Z000-SET-CATEGORY-INDEX
052400                THRU Z099-SCI-EXIT
052500             SET  X-MMQ1-EMC     TO WS-D360-CAT-INDEX
052600             ADD  MTST-NBR-ITEMS TO MMQ1-E-MC-CAT-NBR
052700                                    (1 X-MMQ1-EMC)
052800             ADD  MTST-AMOUNT    TO MMQ1-E-MC-CAT-AMT
052900                                    (1 X-MMQ1-EMC)
053000           WHEN MTST-QI-REGIONAL
053100             ADD  MTST-NBR-ITEMS TO MMQ1-REGIONAL-NBR-R(1)
053200             ADD  MTST-AMOUNT    TO MMQ1-REGIONAL-AMT-R(1)
053300             PERFORM Z000-SET-CATEGORY-INDEX
053400                THRU Z099-SCI-EXIT
053500             SET  X-MMQ1-EMC     TO WS-D360-CAT-INDEX
053600             ADD  MTST-NBR-ITEMS TO MMQ1-E-MC-CAT-NBR
053700                                    (1 X-MMQ1-EMC)
053800             ADD  MTST-AMOUNT    TO MMQ1-E-MC-CAT-AMT
053900                                    (1 X-MMQ1-EMC)
054000           WHEN MTST-QI-INTERNATIONAL
054100             ADD  MTST-NBR-ITEMS TO MMQ1-INTER-NBR-R(1)
054200             ADD  MTST-AMOUNT    TO MMQ1-INTER-AMT-R(1)
054300             PERFORM Z000-SET-CATEGORY-INDEX
054400                THRU Z099-SCI-EXIT
054500             SET  X-MMQ1-EMC     TO WS-D360-CAT-INDEX
054600             ADD  MTST-NBR-ITEMS TO MMQ1-E-MC-CAT-NBR
054700                                    (1 X-MMQ1-EMC)
054800             ADD  MTST-AMOUNT    TO MMQ1-E-MC-CAT-AMT
054900                                    (1 X-MMQ1-EMC)
055000         END-EVALUATE
055100     END-EVALUATE.
055200*
055300     EVALUATE TRUE
055400       WHEN MMTCWS-LM-RETURN
055500           CONTINUE
055600       WHEN MMTCWS-LM-SALE-REV
055700           CONTINUE
055800       WHEN (MMSM-STORE-CASH-ADV
055900         OR  MMSM-STORE-ATM)
056000         EVALUATE TRUE
056100           WHEN MTST-QI-DOMESTIC
056200             ADD  MTST-NBR-ITEMS TO MMQ1-INTRA-NBR-CA(1)
056300             ADD  MTST-AMOUNT    TO MMQ1-INTRA-AMT-CA(1)
056400           WHEN MTST-QI-REGIONAL
056500             ADD  MTST-NBR-ITEMS TO MMQ1-REGIONAL-NBR-CA(1)
056600             ADD  MTST-AMOUNT    TO MMQ1-REGIONAL-AMT-CA(1)
056700           WHEN MTST-QI-INTERNATIONAL
056800             ADD  MTST-NBR-ITEMS TO MMQ1-INTER-NBR-CA(1)
056900             ADD  MTST-AMOUNT    TO MMQ1-INTER-AMT-CA(1)
057000         END-EVALUATE
057100     END-EVALUATE.
057200*
057300     EVALUATE TRUE
057400       WHEN MMTCWS-LM-RETURN
057500           CONTINUE
057600       WHEN MMTCWS-LM-SALE-REV
057700           CONTINUE
057800       WHEN MMSM-STORE-ATM
057900         EVALUATE TRUE
058000           WHEN MTST-QI-DOMESTIC
058100             ADD  MTST-NBR-ITEMS TO MMQ1-INTRA-NBR-ATM(1)
058200             ADD  MTST-AMOUNT    TO MMQ1-INTRA-AMT-ATM(1)
058300           WHEN MTST-QI-REGIONAL
058400             ADD  MTST-NBR-ITEMS TO MMQ1-REGIONAL-NBR-ATM(1)
058500             ADD  MTST-AMOUNT    TO MMQ1-REGIONAL-AMT-ATM(1)
058600           WHEN MTST-QI-INTERNATIONAL
058700             ADD  MTST-NBR-ITEMS TO MMQ1-INTER-NBR-ATM(1)
058800             ADD  MTST-AMOUNT    TO MMQ1-INTER-AMT-ATM(1)
058900         END-EVALUATE
059000     END-EVALUATE.
059100*
059200     EVALUATE TRUE
059300       WHEN MMTCWS-LM-SALE
059400           CONTINUE
059500       WHEN MMTCWS-LM-RETURN-REV
059600           CONTINUE
059700       WHEN OTHER
059800         EVALUATE TRUE
059900           WHEN MTST-QI-DOMESTIC
060000             ADD  MTST-NBR-ITEMS TO MMQ1-INTRA-NBR-CR(1)
060100             ADD  MTST-AMOUNT    TO MMQ1-INTRA-AMT-CR(1)
060200           WHEN MTST-QI-REGIONAL
060300             ADD  MTST-NBR-ITEMS TO MMQ1-REGIONAL-NBR-CR(1)
060400             ADD  MTST-AMOUNT    TO MMQ1-REGIONAL-AMT-CR(1)
060500           WHEN MTST-QI-INTERNATIONAL
060600             ADD  MTST-NBR-ITEMS TO MMQ1-INTER-NBR-CR(1)
060700             ADD  MTST-AMOUNT    TO MMQ1-INTER-AMT-CR(1)
060800         END-EVALUATE
060900     END-EVALUATE.
061000*
061100 M029-E-MC-EXIT.
061200     EXIT.
061300/
061400 M030-EUROCHEQUE SECTION.
061500 M031-E-BEGIN.
061600*
061700     EVALUATE TRUE
061800       WHEN MTST-QI-REGIONAL-ABOVE
061900         EVALUATE TRUE
062000           WHEN (MMTCWS-LM-SALE
062100             OR  MMTCWS-LM-RETURN-REV)
062200             ADD  MTST-NBR-ITEMS TO MMQ1-EUROCHEQUE-NBR-A(1)
062300             ADD  MTST-AMOUNT    TO MMQ1-EUROCHEQUE-AMT-A(1)
062400           WHEN (MMTCWS-LM-RETURN
062500             OR  MMTCWS-LM-SALE-REV)
062600             ADD  MTST-NBR-ITEMS TO MMQ1-EUROCHEQUE-NBR-A(1)
062700             SUBTRACT MTST-AMOUNT
062800                               FROM MMQ1-EUROCHEQUE-AMT-A(1)
062900         END-EVALUATE
063000       WHEN MTST-QI-REGIONAL
063100         EVALUATE TRUE
063200           WHEN (MMTCWS-LM-SALE
063300             OR  MMTCWS-LM-RETURN-REV)
063400             ADD  MTST-NBR-ITEMS TO MMQ1-EUROCHEQUE-NBR-B(1)
063500             ADD  MTST-AMOUNT    TO MMQ1-EUROCHEQUE-AMT-B(1)
063600           WHEN (MMTCWS-LM-RETURN
063700             OR  MMTCWS-LM-SALE-REV)
063800             ADD  MTST-NBR-ITEMS TO MMQ1-EUROCHEQUE-NBR-B(1)
063900             SUBTRACT MTST-AMOUNT
064000                               FROM MMQ1-EUROCHEQUE-AMT-B(1)
064100         END-EVALUATE
064200     END-EVALUATE.
064300*
064400 M039-E-EXIT.
064500     EXIT.
064600/
064700 M040-EUROCHEQUE-ATM SECTION.
064800 M041-E-ATM-BEGIN.
064900*
065000     EVALUATE TRUE
065100       WHEN MTST-QI-REGIONAL
065200         EVALUATE TRUE
065300           WHEN (MMTCWS-LM-SALE
065400             OR  MMTCWS-LM-RETURN-REV)
065500             ADD  MTST-NBR-ITEMS TO MMQ1-ECHEQ-ATM-NBR-E(1)
065600             ADD  MTST-AMOUNT    TO MMQ1-ECHEQ-ATM-AMT-E(1)
065700           WHEN (MMTCWS-LM-RETURN
065800             OR  MMTCWS-LM-SALE-REV)
065900             ADD  MTST-NBR-ITEMS TO MMQ1-ECHEQ-ATM-NBR-E(1)
066000             SUBTRACT MTST-AMOUNT
066100                               FROM MMQ1-ECHEQ-ATM-AMT-E(1)
066200         END-EVALUATE
066300     END-EVALUATE.
066400*
066500 M049-E-ATM-EXIT.
066600     EXIT.
066700*
066800*
066900*
067000 M050-CIRRUS SECTION.
067100 M051-C-BEGIN.
067200*
067300     EVALUATE TRUE
067400       WHEN MTST-QI-REGIONAL
067500         EVALUATE TRUE
067600           WHEN (MMTCWS-LM-SALE
067700             OR  MMTCWS-LM-RETURN-REV)
067800             ADD  MTST-NBR-ITEMS TO MMQ1-ECHEQ-ATM-NBR-C(1)
067900             ADD  MTST-AMOUNT    TO MMQ1-ECHEQ-ATM-AMT-C(1)
068000           WHEN (MMTCWS-LM-RETURN
068100             OR  MMTCWS-LM-SALE-REV)
068200             ADD  MTST-NBR-ITEMS TO MMQ1-ECHEQ-ATM-NBR-C(1)
068300             SUBTRACT MTST-AMOUNT
068400                               FROM MMQ1-ECHEQ-ATM-AMT-C(1)
068500         END-EVALUATE
068600       WHEN MTST-QI-INTERNATIONAL
068700         EVALUATE TRUE
068800           WHEN (MMTCWS-LM-SALE
068900             OR  MMTCWS-LM-RETURN-REV)
069000             ADD  MTST-NBR-ITEMS TO MMQ1-ECHEQ-ATM-NBR-F(1)
069100             ADD  MTST-AMOUNT    TO MMQ1-ECHEQ-ATM-AMT-F(1)
069200           WHEN (MMTCWS-LM-RETURN
069300             OR  MMTCWS-LM-SALE-REV)
069400             ADD  MTST-NBR-ITEMS TO MMQ1-ECHEQ-ATM-NBR-F(1)
069500             SUBTRACT MTST-AMOUNT
069600                               FROM MMQ1-ECHEQ-ATM-AMT-F(1)
069700         END-EVALUATE
069800     END-EVALUATE.
069900*
070000 M059-C-EXIT.
070100     EXIT.
070200/
070300 M060-EDC SECTION.
070400 M061-EDC-BEGIN.
070500*
070600     EVALUATE TRUE
070700       WHEN MTST-QI-REGIONAL
070800         PERFORM Z000-SET-CATEGORY-INDEX
070900            THRU Z099-SCI-EXIT
071000         SET  X-MMQ1-EMT         TO WS-D360-CAT-INDEX
071100         EVALUATE TRUE
071200           WHEN (MMTCWS-LM-SALE
071300             OR  MMTCWS-LM-RETURN-REV)
071400             ADD  MTST-NBR-ITEMS TO MMQ1-EDC-NBR-E(1)
071500             ADD  MTST-AMOUNT    TO MMQ1-EDC-AMT-E(1)
071600             ADD  MTST-NBR-ITEMS TO MMQ1-EDC-MAESTRO-CAT-NBR
071700                                    (1 X-MMQ1-EMT)
071800             ADD  MTST-AMOUNT    TO MMQ1-EDC-MAESTRO-CAT-AMT
071900                                    (1 X-MMQ1-EMT)
072000           WHEN (MMTCWS-LM-RETURN
072100             OR  MMTCWS-LM-SALE-REV)
072200             ADD  MTST-NBR-ITEMS TO MMQ1-EDC-NBR-E(1)
072300             SUBTRACT MTST-AMOUNT
072400                               FROM MMQ1-EDC-AMT-E(1)
072500             ADD  MTST-NBR-ITEMS TO MMQ1-EDC-MAESTRO-CAT-NBR
072600                                    (1 X-MMQ1-EMT)
072700             SUBTRACT MTST-AMOUNT
072800                               FROM MMQ1-EDC-MAESTRO-CAT-AMT
072900                                    (1 X-MMQ1-EMT)
073000         END-EVALUATE
073100       WHEN MTST-QI-INTERNATIONAL
073200         PERFORM Z000-SET-CATEGORY-INDEX
073300            THRU Z099-SCI-EXIT
073400         SET  X-MMQ1-EMT         TO WS-D360-CAT-INDEX
073500         EVALUATE TRUE
073600           WHEN (MMTCWS-LM-SALE
073700             OR  MMTCWS-LM-RETURN-REV)
073800             ADD  MTST-NBR-ITEMS TO MMQ1-EDC-NBR-F(1)
073900             ADD  MTST-AMOUNT    TO MMQ1-EDC-AMT-F(1)
074000             ADD  MTST-NBR-ITEMS TO MMQ1-EDC-MAESTRO-CAT-NBR
074100                                    (1 X-MMQ1-EMT)
074200             ADD  MTST-AMOUNT    TO MMQ1-EDC-MAESTRO-CAT-AMT
074300                                    (1 X-MMQ1-EMT)
074400           WHEN (MMTCWS-LM-RETURN
074500             OR  MMTCWS-LM-SALE-REV)
074600             ADD  MTST-NBR-ITEMS TO MMQ1-EDC-NBR-F(1)
074700             SUBTRACT MTST-AMOUNT
074800                               FROM MMQ1-EDC-AMT-F(1)
074900             ADD  MTST-NBR-ITEMS TO MMQ1-EDC-MAESTRO-CAT-NBR
075000                                    (1 X-MMQ1-EMT)
075100             SUBTRACT MTST-AMOUNT
075200                               FROM MMQ1-EDC-MAESTRO-CAT-AMT
075300                                    (1 X-MMQ1-EMT)
075400         END-EVALUATE
075500     END-EVALUATE.
075600*
075700 M069-EDC-EXIT.
075800     EXIT.
075900/
076000 M070-MAESTRO SECTION.
076100 M071-M-BEGIN.
076200*
076300     EVALUATE TRUE
076400       WHEN MTST-QI-REGIONAL
076500         PERFORM Z000-SET-CATEGORY-INDEX
076600            THRU Z099-SCI-EXIT
076700         SET  X-MMQ1-EMT         TO WS-D360-CAT-INDEX
076800         EVALUATE TRUE
076900           WHEN (MMTCWS-LM-SALE
077000             OR  MMTCWS-LM-RETURN-REV)
077100             ADD  MTST-NBR-ITEMS TO MMQ1-MAESTRO-NBR-E(1)
077200             ADD  MTST-AMOUNT    TO MMQ1-MAESTRO-AMT-E(1)
077300             ADD  MTST-NBR-ITEMS TO MMQ1-EDC-MAESTRO-CAT-NBR
077400                                    (1 X-MMQ1-EMT)
077500             ADD  MTST-AMOUNT    TO MMQ1-EDC-MAESTRO-CAT-AMT
077600                                    (1 X-MMQ1-EMT)
077700           WHEN (MMTCWS-LM-RETURN
077800             OR  MMTCWS-LM-SALE-REV)
077900             ADD  MTST-NBR-ITEMS TO MMQ1-MAESTRO-NBR-E(1)
078000             SUBTRACT MTST-AMOUNT
078100                               FROM MMQ1-MAESTRO-AMT-E(1)
078200             ADD  MTST-NBR-ITEMS TO MMQ1-EDC-MAESTRO-CAT-NBR
078300                                    (1 X-MMQ1-EMT)
078400             SUBTRACT MTST-AMOUNT
078500                               FROM MMQ1-EDC-MAESTRO-CAT-AMT
078600                                    (1 X-MMQ1-EMT)
078700         END-EVALUATE
078800       WHEN MTST-QI-INTERNATIONAL
078900         PERFORM Z000-SET-CATEGORY-INDEX
079000            THRU Z099-SCI-EXIT
079100         SET  X-MMQ1-EMT         TO WS-D360-CAT-INDEX
079200         EVALUATE TRUE
079300           WHEN (MMTCWS-LM-SALE
079400             OR  MMTCWS-LM-RETURN-REV)
079500             ADD  MTST-NBR-ITEMS TO MMQ1-MAESTRO-NBR-F(1)
079600             ADD  MTST-AMOUNT    TO MMQ1-MAESTRO-AMT-F(1)
079700             ADD  MTST-NBR-ITEMS TO MMQ1-EDC-MAESTRO-CAT-NBR
079800                                    (1 X-MMQ1-EMT)
079900             ADD  MTST-AMOUNT    TO MMQ1-EDC-MAESTRO-CAT-AMT
080000                                    (1 X-MMQ1-EMT)
080100           WHEN (MMTCWS-LM-RETURN
080200             OR  MMTCWS-LM-SALE-REV)
080300             ADD  MTST-NBR-ITEMS TO MMQ1-MAESTRO-NBR-F(1)
080400             SUBTRACT MTST-AMOUNT
080500                               FROM MMQ1-MAESTRO-AMT-F(1)
080600             ADD  MTST-NBR-ITEMS TO MMQ1-EDC-MAESTRO-CAT-NBR
080700                                    (1 X-MMQ1-EMT)
080800             SUBTRACT MTST-AMOUNT
080900                               FROM MMQ1-EDC-MAESTRO-CAT-AMT
081000                                    (1 X-MMQ1-EMT)
081100         END-EVALUATE
081200     END-EVALUATE.
081300*
081400 M079-M-EXIT.
081500     EXIT.
081600/
081700 M080-CLIP SECTION.
081800 M081-CLIP-BEGIN.
081900*
082000*    CURRENTLY, CLIP CARDS HAVE NO QUARTERLY TOTALS.
082100*
082200*
082300*
082400*
082500*
082600*
082700*
082800*
082900*
083000*
083100*
083200*
083300*
083400*
083500*
083600*
083700*
083800*
083900*
084000*
084100*
084200*
084300*
084400*
084500*
084600*
084700*
084800*
084900*
085000*
085100*
085200*
085300*
085400*
085500*
085600*
085700*
085800*
085900*
086000*
086100*
086200*
086300*
086400*
086500*
086600*
086700*
086800*
086900*
087000 M089-CLIP-EXIT.
087100     EXIT.
087200/
087300 M090-CHIP SECTION.
087400 M091-CHIP-BEGIN.
087500*
087600*    CURRENTLY, CHIP CARDS HAVE NO QUARTERLY TOTALS.
087700*
087800*
087900*
088000*
088100*
088200*
088300*
088400*
088500*
088600*
088700*
088800*
088900*
089000*
089100*
089200*
089300*
089400*
089500*
089600*
089700*
089800*
089900*
090000*
090100*
090200*
090300*
090400*
090500*
090600*
090700*
090800*
090900*
091000*
091100*
091200*
091300*
091400*
091500*
091600*
091700*
091800*
091900*
092000*
092100*
092200*
092300*
092400*
092500*
092600 M099-CHIP-EXIT.
092700     EXIT.
092800/
092900 Z000-SET-CATEGORY-INDEX SECTION.
093000 Z001-SCI-BEGIN.
093100*
093200     MOVE MMSM-MC-CATEGORY-CODE  TO MBD360WS-Q1-CATEGORY-CODE.
093300*
093400     EVALUATE TRUE
093500       WHEN MBD360WS-Q1-CC-TOTAL-01
093600         MOVE 01                 TO WS-D360-CAT-INDEX
093700       WHEN MBD360WS-Q1-CC-TOTAL-02
093800         MOVE 02                 TO WS-D360-CAT-INDEX
093900       WHEN MBD360WS-Q1-CC-TOTAL-03
094000         MOVE 03                 TO WS-D360-CAT-INDEX
094100       WHEN MBD360WS-Q1-CC-TOTAL-04
094200         MOVE 04                 TO WS-D360-CAT-INDEX
094300       WHEN MBD360WS-Q1-CC-TOTAL-05
094400         MOVE 05                 TO WS-D360-CAT-INDEX
094500       WHEN MBD360WS-Q1-CC-TOTAL-06
094600         MOVE 06                 TO WS-D360-CAT-INDEX
094700       WHEN MBD360WS-Q1-CC-TOTAL-07
094800         MOVE 07                 TO WS-D360-CAT-INDEX
094900       WHEN MBD360WS-Q1-CC-TOTAL-08
095000         MOVE 08                 TO WS-D360-CAT-INDEX
095100       WHEN MBD360WS-Q1-CC-TOTAL-09
095200         MOVE 09                 TO WS-D360-CAT-INDEX
095300       WHEN MBD360WS-Q1-CC-TOTAL-10
095400         MOVE 10                 TO WS-D360-CAT-INDEX
095500       WHEN MBD360WS-Q1-CC-TOTAL-11
095600         MOVE 11                 TO WS-D360-CAT-INDEX
095700       WHEN MBD360WS-Q1-CC-TOTAL-12
095800         MOVE 12                 TO WS-D360-CAT-INDEX
095900       WHEN MBD360WS-Q1-CC-TOTAL-13
096000         MOVE 13                 TO WS-D360-CAT-INDEX
096100       WHEN MBD360WS-Q1-CC-TOTAL-14
096200         MOVE 14                 TO WS-D360-CAT-INDEX
096300       WHEN MBD360WS-Q1-CC-TOTAL-15
096400         MOVE 15                 TO WS-D360-CAT-INDEX
096500       WHEN MBD360WS-Q1-CC-TOTAL-16
096600         MOVE 16                 TO WS-D360-CAT-INDEX
096700       WHEN MBD360WS-Q1-CC-TOTAL-17
096800         MOVE 17                 TO WS-D360-CAT-INDEX
096900       WHEN MBD360WS-Q1-CC-TOTAL-18
097000         MOVE 18                 TO WS-D360-CAT-INDEX
097100       WHEN MBD360WS-Q1-CC-TOTAL-19
097200         MOVE 19                 TO WS-D360-CAT-INDEX
097300       WHEN MBD360WS-Q1-CC-TOTAL-20
097400         MOVE 20                 TO WS-D360-CAT-INDEX
097500       WHEN MBD360WS-Q1-CC-TOTAL-21
097600         MOVE 21                 TO WS-D360-CAT-INDEX
097700       WHEN MBD360WS-Q1-CC-TOTAL-22
097800         MOVE 22                 TO WS-D360-CAT-INDEX
097900       WHEN MBD360WS-Q1-CC-TOTAL-23
098000         MOVE 23                 TO WS-D360-CAT-INDEX
098100       WHEN MBD360WS-Q1-CC-TOTAL-24
098200         MOVE 24                 TO WS-D360-CAT-INDEX
098300       WHEN MBD360WS-Q1-CC-TOTAL-25
098400         MOVE 25                 TO WS-D360-CAT-INDEX
098500       WHEN MBD360WS-Q1-CC-TOTAL-26
098600         MOVE 26                 TO WS-D360-CAT-INDEX
098700       WHEN MBD360WS-Q1-CC-TOTAL-27
098800         MOVE 27                 TO WS-D360-CAT-INDEX
098900       WHEN MBD360WS-Q1-CC-TOTAL-28
099000         MOVE 28                 TO WS-D360-CAT-INDEX
099100       WHEN MBD360WS-Q1-CC-TOTAL-29
099200         MOVE 29                 TO WS-D360-CAT-INDEX
099300       WHEN MBD360WS-Q1-CC-TOTAL-30
099400         MOVE 30                 TO WS-D360-CAT-INDEX
099500       WHEN MBD360WS-Q1-CC-TOTAL-31
099600         MOVE 31                 TO WS-D360-CAT-INDEX
099700       WHEN MBD360WS-Q1-CC-TOTAL-32
099800         MOVE 32                 TO WS-D360-CAT-INDEX
099900       WHEN MBD360WS-Q1-CC-TOTAL-33
100000         MOVE 33                 TO WS-D360-CAT-INDEX
100100       WHEN MBD360WS-Q1-CC-TOTAL-34
100200         MOVE 34                 TO WS-D360-CAT-INDEX
100300       WHEN MBD360WS-Q1-CC-TOTAL-35
100400         MOVE 35                 TO WS-D360-CAT-INDEX
100500       WHEN MBD360WS-Q1-CC-TOTAL-36
100600         MOVE 36                 TO WS-D360-CAT-INDEX
100700       WHEN MBD360WS-Q1-CC-TOTAL-37
100800         MOVE 37                 TO WS-D360-CAT-INDEX
100900       WHEN MBD360WS-Q1-CC-TOTAL-38
101000         MOVE 38                 TO WS-D360-CAT-INDEX
101100       WHEN MBD360WS-Q1-CC-TOTAL-39
101200         MOVE 39                 TO WS-D360-CAT-INDEX
101300       WHEN MBD360WS-Q1-CC-TOTAL-40
101400         MOVE 40                 TO WS-D360-CAT-INDEX
101500       WHEN OTHER
101600         MOVE MMQ1-EDC-MAESTRO-MAX (1)
101700                                 TO WS-D360-CAT-INDEX
101800     END-EVALUATE.
101900*
102000 Z099-SCI-EXIT.
102100     EXIT.
102200/
102300 9000-PERFORMED-ROUTINES-SECT SECTION.
102400     COPY MB00PD REPLACING ==:MB00:== BY ==MMQ1==.
102500/
102600     COPY MB99PD.
102700/
102800     COPY SS02PD.
102900*
103000 9995-END-SOURCE-STATEMENTS SECTION.
103100 9999-END-OF-PROGRAM.
103200     GOBACK.
