000100 IDENTIFICATION DIVISION.
000200 PROGRAM-ID. MBD360Q2.
000201*       RELEASE DATE=08/24/01.        REVISION LEVEL=08.06      * ++++++++
000202***************************************************************** ++++++++
000203*WARNING.  THIS COMPUTER PROGRAM IS PROTECTED BY COPYRIGHT LAW  * ++++++++
000204*AND INTERNATIONAL TREATIES.  UNAUTHORIZED REPRODUCTION OR      * ++++++++
000205*DISTRIBUTION OF THIS PROGRAM, OR ANY PORTION OF IT, MAY RESULT * ++++++++
000206*IN SEVERE CIVIL AND CRIMINAL PENATLIES, AND WILL BE PROSECUTED * ++++++++
000207*TO THE MAXIMUM EXTENT POSSIBLE UNDER THE LAW.                  * ++++++++
000208*COPYRIGHT 1999 PAYSYS INTERNATIONAL, INC.  ALL RIGHTS RESERVED.* ++++++++
000209***************************************************************** ++++++++
000300*****************************************************************
000400*                                                               *
000500*   V - 2 1   M E R C H A N T   B A N K C A R D   S Y S T E M   *
000600*                                                               *
000700*   MBD360Q2 - CANADIAN QUARTERLY REPORT TOTALS - TRANS + VOLUME*
000800*                                                               *
000900*****************************************************************
001000*                                                               *
001100*   N O T E --- THIS PROGRAM IS AN ATTACHMENT TO THE STORE      *
001200*               POSTING PROGRAM AND PROVIDES FOR THE            *
001300*               ACCUMULATION OF CANADIAN TRANSACTIONS AND VOLUME*
001400*               TOTALS FOR THE CANADIAN QUARTERLY REPORTS.      *
001500*               ACCEPTANCE INFORMATION IS ACCUMULATED BY PROGRAM*
001600*               MBD372.                                         *
001700*                                                               *
001800*****************************************************************
001900 ENVIRONMENT DIVISION.
002000 CONFIGURATION SECTION.
002100 SOURCE-COMPUTER.            IBM-4341.
002200 OBJECT-COMPUTER.            IBM-4341.
002300/
002400 DATA DIVISION.
002500 WORKING-STORAGE SECTION.
002600*
002700 01  FILLER                  PIC  X(12)      VALUE '** WS-BEG **'.
002800*
002900 01  WS-D360-WORK-AREAS.
003000     03  WS-D360-CAT-INDEX   PIC  9(02)      VALUE ZERO.
003100/
003200     COPY MMQ2IO.
003300/
003400     COPY MB00RB REPLACING ==:MB00:== BY ==MMQ2==.
003500/
003600     COPY MMQ2IR.
003700/
003800     COPY MMQ2RL.
003900/
004000     COPY MB00WS.
004100/
004200     COPY MMTCWS.
004300/
004400     COPY MB99WS.
004500/
004600     COPY SS00WS.
004700/
004800     COPY SS01WS.
004900/
005000     COPY SS02WS.
005100*
005200 01  FILLER                  PIC  X(12)      VALUE '** WS-END **'.
005300/
005400 LINKAGE SECTION.
005500     COPY MBD360WS.
005600/
005700     COPY MMSCRL.
005800/
005900     COPY MMOCRL.
006000/
006100     COPY MMSMRL.
006200/
006300     COPY MTSTRL.
006400/
006500 PROCEDURE DIVISION              USING MBD360WS-AREA
006600                                       MMSC-RECORD
006700                                       MMOC-RECORD
006800                                       MMSM-RECORD
006900                                       MTST-RECORD.
007000*
007100 A000-MAIN-LINE SECTION.
007200 A010-ML-BEGIN.
007300*
007400     MOVE 'D360Q2'               TO SS02WS-ABEND-PROG-ID.
007500*
007600     IF  MMSC-REGION-CANADA-OFF
007700         GO TO 9999-END-OF-PROGRAM.
007800*
007900     EVALUATE TRUE
008000       WHEN MBD360WS-Q2-PROCESS-RECORD
008100         PERFORM A500-PROCESS-RECORD
008200            THRU A599-PR-EXIT
008300       WHEN MBD360WS-Q2-ORG-CHANGE
008400         PERFORM A200-ORG-CHANGE
008500            THRU A299-OC-EXIT
008600       WHEN MBD360WS-Q2-ORG-UPDATE
008700         PERFORM A300-ORG-UPDATE
008800            THRU A399-OU-EXIT
008900       WHEN MBD360WS-Q2-OPEN-FILE
009000         PERFORM A100-OPEN-FILES
009100            THRU A199-OF-EXIT
009200       WHEN MBD360WS-Q2-CLOSE-FILE
009300         PERFORM A900-CLOSE-FILES
009400            THRU A999-CF-EXIT
009500       WHEN MBD360WS-Q2-ROLL-TOTALS
009600         PERFORM A400-ROLL-TOTALS
009700            THRU A499-RT-EXIT
009800     END-EVALUATE.
009900*
010000     GO TO 9999-END-OF-PROGRAM.
010100*
010200 A099-ML-EXIT.
010300     EXIT.
010400/
010500 A100-OPEN-FILES SECTION.
010600 A101-OF-BEGIN.
010700*
010800     MOVE MMSC-TODAYS-JULIAN     TO MB99WS-PROC-DATE.
010900     MOVE MMSC-TIME-STAMP        TO MB99WS-PROC-TIME.
011000*
011100     MOVE 'O1Q2'                 TO SS02WS-ABEND-LOCATION.
011200     SET MMQ2RB-OPEN-IO-DYN      TO TRUE.
011300     PERFORM MB00PD-MMQ2-ACCESS
011400        THRU MB00PD-MMQ2-ACCESS-EXIT.
011500*
011600*
011700*
011800     MOVE 'R0Q2'                 TO SS02WS-ABEND-LOCATION.
011900     SET MMQ2RB-READ-SEQ         TO TRUE.
012000     PERFORM MB00PD-MMQ2-ACCESS
012100        THRU MB00PD-MMQ2-ACCESS-EXIT.
012200     MOVE 'MMQ2'                 TO MB99WS-FILE-ID.
012300*
012400     IF  MMQ2IO-HEADER
012500         NEXT SENTENCE
012600     ELSE
012700         PERFORM MB99PD-MISSING-HEADER-ABEND
012800            THRU MB99PD-MHA-EXIT.
012900*
013000     MOVE MMQ2IO-DATE-STAMP      TO MB99WS-FILE-DATE.
013100     MOVE MMQ2IO-TIME-STAMP      TO MB99WS-FILE-TIME.
013200     PERFORM MB99PD-CHECK-DATE-TIME
013300        THRU MB99PD-CDT-EXIT.
013400*
013500     MOVE MMQ2IO-RECORD          TO MMQ2-RECORD.
013600*
013700*
013800*
013900 A199-OF-EXIT.
014000     EXIT.
014100/
014200 A200-ORG-CHANGE SECTION.
014300 A201-OC-BEGIN.
014400*
014500     PERFORM
014600         UNTIL MMQ2IO-KEY IS NOT LESS THAN MMOC-KEY
014700            OR MMQ2IO-TRAILER
014800         EVALUATE TRUE
014900           WHEN MMQ2IO-HEADER
015000             CONTINUE
015100           WHEN MMQ2IO-KEY IS LESS THAN MMOC-KEY
015200             MOVE MMQ2IO-RECORD  TO MMQ2-RECORD
015300             SET MMQ2-REC-PURGED TO TRUE
015400             MOVE MMQ2-RECORD    TO MMQ2IO-RECORD
015500             MOVE 'U1Q2'         TO SS02WS-ABEND-LOCATION
015600             SET MMQ2RB-REWRITE  TO TRUE
015700             PERFORM MB00PD-MMQ2-ACCESS
015800                THRU MB00PD-MMQ2-ACCESS-EXIT
015900         END-EVALUATE
016000         MOVE 'R1Q2'             TO SS02WS-ABEND-LOCATION
016100         SET MMQ2RB-READ-SEQ     TO TRUE
016200         PERFORM MB00PD-MMQ2-ACCESS
016300            THRU MB00PD-MMQ2-ACCESS-EXIT
016400     END-PERFORM.
016500*
016600*
016700*
016800     IF  MMOC-NOT-PROCESSING
016900         EVALUATE TRUE
017000           WHEN MMOC-VISA-QTR-FLAG-CANADA
017100             IF  MMQ2IO-KEY IS EQUAL TO MMOC-KEY
017200                 MOVE 'R8Q2'     TO SS02WS-ABEND-LOCATION
017300                 SET MMQ2RB-READ-SEQ
017400                                 TO TRUE
017500                 PERFORM MB00PD-MMQ2-ACCESS
017600                    THRU MB00PD-MMQ2-ACCESS-EXIT
017700             END-IF
017800         END-EVALUATE
017900         GO TO A299-OC-EXIT.
018000*
018100*
018200*
018300     MOVE MMQ2IO-RECORD          TO MMQ2-RECORD.
018400*
018500     EVALUATE TRUE
018600       WHEN MMQ2-KEY IS GREATER THAN MMOC-KEY
018700         EVALUATE TRUE
018800           WHEN MMOC-VISA-QTR-FLAG-CANADA
018900             MOVE MMQ2IR-RECORD  TO MMQ2-RECORD
019000             MOVE MMOC-KEY       TO MMQ2-KEY
019100             SET MMQ2-REC-ACTIVE TO TRUE
019200             SET MMQ2-ADD-COMPLETED
019300                                 TO TRUE
019400             MOVE MMQ2-RECORD    TO MMQ2IO-RECORD
019500             MOVE 'W2Q2'         TO SS02WS-ABEND-LOCATION
019600             SET MMQ2RB-WRITE    TO TRUE
019700             PERFORM MB00PD-MMQ2-ACCESS
019800                THRU MB00PD-MMQ2-ACCESS-EXIT
019900             MOVE MMOC-KEY       TO MMQ2IO-KEY
020000             MOVE 'S2Q2'         TO SS02WS-ABEND-LOCATION
020100             SET MMQ2RB-START-GTE
020200                                 TO TRUE
020300             PERFORM MB00PD-MMQ2-ACCESS
020400                THRU MB00PD-MMQ2-ACCESS-EXIT
020500             MOVE 'R2Q2'         TO SS02WS-ABEND-LOCATION
020600             SET MMQ2RB-READ-SEQ TO TRUE
020700             PERFORM MB00PD-MMQ2-ACCESS
020800                THRU MB00PD-MMQ2-ACCESS-EXIT
020900           WHEN OTHER
021000             MOVE MMQ2IR-RECORD  TO MMQ2-RECORD
021100         END-EVALUATE
021200       WHEN MMQ2-KEY IS EQUAL TO MMOC-KEY
021300         EVALUATE TRUE
021400           WHEN MMOC-VISA-QTR-FLAG-CANADA
021500             IF  MMQ2-REC-ACTIVE
021600                 CONTINUE
021700             ELSE
021800                 MOVE MMQ2IR-RECORD
021900                                 TO MMQ2-RECORD
022000                 MOVE MMOC-KEY   TO MMQ2-KEY
022100                 SET MMQ2-REC-ACTIVE
022200                                 TO TRUE
022300             END-IF
022400           WHEN OTHER
022500             SET MMQ2-REC-PURGED TO TRUE
022600             MOVE MMQ2-RECORD    TO MMQ2IO-RECORD
022700             MOVE 'U2Q2'         TO SS02WS-ABEND-LOCATION
022800             SET MMQ2RB-REWRITE  TO TRUE
022900             PERFORM MB00PD-MMQ2-ACCESS
023000                THRU MB00PD-MMQ2-ACCESS-EXIT
023100         END-EVALUATE
023200     END-EVALUATE.
023300*
023400*
023500*
023600 A299-OC-EXIT.
023700     EXIT.
023800/
023900 A300-ORG-UPDATE SECTION.
024000 A301-OU-BEGIN.
024100*
024200     IF  MMQ2-QTR-BEG-DATE(1) IS EQUAL TO ZERO
024300     AND MMQ2-QTR-END-DATE(1) IS EQUAL TO ZERO
024400         MOVE MBD360WS-QTR-BEG-DATE
024500                                 TO MMQ2-QTR-BEG-DATE (1)
024600         MOVE MBD360WS-QTR-END-DATE
024700                                 TO MMQ2-QTR-END-DATE (1)
024800     END-IF.
024900*
025000     EVALUATE TRUE
025100       WHEN MMOC-VISA-QTR-FLAG-CANADA
025200         COMPUTE MMQ2-VI-NET-SALES-AMT(1 1)
025300                                 =  MMQ2-VI-ONUS-AMT(1 1)
025400                                 +  MMQ2-VI-DOMESTIC-AMT (1 1)
025500                                 +  MMQ2-VI-INTER-AMT (1 1)
025600                                 +  MMQ2-VI-ONUS-CD-AMT(1 1)
025700                                 +  MMQ2-VI-DOMESTIC-CD-AMT (1 1)
025800                                 +  MMQ2-VI-INTER-CD-AMT (1 1)
025900                                 -  MMQ2-VI-CREDITS-AMT(1 1)
026000         COMPUTE MMQ2-VI-NET-SALES-NBR(1 1)
026100                                 =  MMQ2-VI-ONUS-NBR(1 1)
026200                                 +  MMQ2-VI-DOMESTIC-NBR (1 1)
026300                                 +  MMQ2-VI-INTER-NBR (1 1)
026400                                 +  MMQ2-VI-ONUS-CD-NBR(1 1)
026500                                 +  MMQ2-VI-DOMESTIC-CD-NBR (1 1)
026600                                 +  MMQ2-VI-INTER-CD-NBR (1 1)
026700                                 +  MMQ2-VI-CREDITS-NBR(1 1)
026800         COMPUTE MMQ2-VI-NET-SALES-AMT(1 2)
026900                                 =  MMQ2-VI-ONUS-AMT(1 2)
027000                                 +  MMQ2-VI-DOMESTIC-AMT (1 2)
027100                                 +  MMQ2-VI-INTER-AMT (1 2)
027200                                 +  MMQ2-VI-ONUS-CD-AMT(1 2)
027300                                 +  MMQ2-VI-DOMESTIC-CD-AMT (1 2)
027400                                 +  MMQ2-VI-INTER-CD-AMT (1 2)
027500                                 -  MMQ2-VI-CREDITS-AMT(1 2)
027600         COMPUTE MMQ2-VI-NET-SALES-NBR(1 2)
027700                                 =  MMQ2-VI-ONUS-NBR(1 2)
027800                                 +  MMQ2-VI-DOMESTIC-NBR (1 2)
027900                                 +  MMQ2-VI-INTER-NBR (1 2)
028000                                 +  MMQ2-VI-ONUS-CD-NBR(1 2)
028100                                 +  MMQ2-VI-DOMESTIC-CD-NBR (1 2)
028200                                 +  MMQ2-VI-INTER-CD-NBR (1 2)
028300                                 +  MMQ2-VI-CREDITS-NBR(1 2)
028400         COMPUTE MMQ2-VI-NET-SALES-AMT(1 3)
028500                                 =  MMQ2-VI-ONUS-AMT(1 3)
028600                                 +  MMQ2-VI-DOMESTIC-AMT (1 3)
028700                                 +  MMQ2-VI-INTER-AMT (1 3)
028800                                 +  MMQ2-VI-ONUS-CD-AMT(1 3)
028900                                 +  MMQ2-VI-DOMESTIC-CD-AMT (1 3)
029000                                 +  MMQ2-VI-INTER-CD-AMT (1 3)
029100                                 -  MMQ2-VI-CREDITS-AMT(1 3)
029200         COMPUTE MMQ2-VI-NET-SALES-NBR(1 3)
029300                                 =  MMQ2-VI-ONUS-NBR(1 3)
029400                                 +  MMQ2-VI-DOMESTIC-NBR (1 3)
029500                                 +  MMQ2-VI-INTER-NBR (1 3)
029600                                 +  MMQ2-VI-ONUS-CD-NBR(1 3)
029700                                 +  MMQ2-VI-DOMESTIC-CD-NBR (1 3)
029800                                 +  MMQ2-VI-INTER-CD-NBR (1 3)
029900                                 +  MMQ2-VI-CREDITS-NBR(1 3)
030000         MOVE MMQ2-RECORD        TO MMQ2IO-RECORD
030100         MOVE 'U3Q2'             TO SS02WS-ABEND-LOCATION
030200         SET MMQ2RB-REWRITE      TO TRUE
030300         PERFORM MB00PD-MMQ2-ACCESS
030400            THRU MB00PD-MMQ2-ACCESS-EXIT
030500         MOVE 'R3Q2'             TO SS02WS-ABEND-LOCATION
030600         SET MMQ2RB-READ-SEQ     TO TRUE
030700         PERFORM MB00PD-MMQ2-ACCESS
030800            THRU MB00PD-MMQ2-ACCESS-EXIT
030900     END-EVALUATE.
031000*
031100 A399-OU-EXIT.
031200     EXIT.
031300*
031400*
031500*
031600 A400-ROLL-TOTALS SECTION.
031700 A401-RT-BEGIN.
031800*
031900     MOVE MMQ2-VI-TABLE (3)      TO MMQ2-VI-TABLE (4).
032000     MOVE MMQ2-VI-TABLE (2)      TO MMQ2-VI-TABLE (3).
032100     MOVE MMQ2-VI-TABLE (1)      TO MMQ2-VI-TABLE (2).
032200     MOVE MMQ2IR-VI-TABLE (1)    TO MMQ2-VI-TABLE (1).
032300*
032400     MOVE MBD360WS-QTR-BEG-DATE  TO MMQ2-QTR-BEG-DATE (1).
032500     MOVE MBD360WS-QTR-END-DATE  TO MMQ2-QTR-END-DATE (1).
032600*
032700 A499-RT-EXIT.
032800     EXIT.
032900/
033000 A500-PROCESS-RECORD SECTION.
033100 A501-PR-BEGIN.
033200*
033300     IF  MMOC-VISA-QTR-FLAG-CANADA
033400         CONTINUE
033500     ELSE
033600         GO TO A599-PR-EXIT.
033700*
033800     IF  MTST-PROD-IS-VISA
033900         CONTINUE
034000     ELSE
034100         GO TO A599-PR-EXIT.
034200*
034300     MOVE MTST-LOGIC-MODULE      TO MMTCWS-LOGIC-MODULE.
034400*
034500     IF  MMTCWS-LM-SALE
034600     OR  MMTCWS-LM-SALE-REV
034700     OR  MMTCWS-LM-RETURN
034800     OR  MMTCWS-LM-RETURN-REV
034900         CONTINUE
035000     ELSE
035100         GO TO A599-PR-EXIT.
035200*
035300     PERFORM V000-PROCESS-VISA-QR
035400        THRU V099-PVQR-EXIT.
035500*
035600 A599-PR-EXIT.
035700     EXIT.
035800/
035900 A900-CLOSE-FILES SECTION.
036000 A901-CF-BEGIN.
036100*
036200     MOVE 'C1Q2'                 TO SS02WS-ABEND-LOCATION.
036300     SET MMQ2RB-CLOSE            TO TRUE.
036400     PERFORM MB00PD-MMQ2-ACCESS
036500        THRU MB00PD-MMQ2-ACCESS-EXIT.
036600*
036700 A999-CF-EXIT.
036800     EXIT.
036900/
037000 V000-PROCESS-VISA-QR SECTION.
037100 V001-PVQR-BEGIN.
037200*
037300     EVALUATE TRUE
037400         WHEN MBD360WS-CURR-MM IS EQUAL TO 01
037500         WHEN MBD360WS-CURR-MM IS EQUAL TO 04
037600         WHEN MBD360WS-CURR-MM IS EQUAL TO 07
037700         WHEN MBD360WS-CURR-MM IS EQUAL TO 10
037800             SET X-MMQ2-VI-MON   TO 1
037900             MOVE MBD360WS-CURR-YY
038000                                 TO MMQ2-VI-YEAR (1 1)
038100             MOVE MBD360WS-CURR-MM
038200                                 TO MMQ2-VI-MONTH (1 1)
038300         WHEN MBD360WS-CURR-MM IS EQUAL TO 02
038400         WHEN MBD360WS-CURR-MM IS EQUAL TO 05
038500         WHEN MBD360WS-CURR-MM IS EQUAL TO 08
038600         WHEN MBD360WS-CURR-MM IS EQUAL TO 11
038700             SET X-MMQ2-VI-MON   TO 2
038800             MOVE MBD360WS-CURR-YY
038900                                 TO MMQ2-VI-YEAR (1 2)
039000             MOVE MBD360WS-CURR-MM
039100                                 TO MMQ2-VI-MONTH (1 2)
039200         WHEN OTHER
039300             SET X-MMQ2-VI-MON   TO 3
039400             MOVE MBD360WS-CURR-YY
039500                                 TO MMQ2-VI-YEAR (1 3)
039600             MOVE MBD360WS-CURR-MM
039700                                 TO MMQ2-VI-MONTH (1 3)
039800     END-EVALUATE.
039900*
040000     EVALUATE TRUE
040100         WHEN MMTCWS-LM-RETURN
040200         WHEN MMTCWS-LM-SALE-REV
040300             ADD  MTST-AMOUNT    TO MMQ2-VI-CREDITS-AMT
040400                                    (1 X-MMQ2-VI-MON)
040500             ADD  MTST-NBR-ITEMS TO MMQ2-VI-CREDITS-NBR
040600                                    (1 X-MMQ2-VI-MON)
040700         WHEN MMTCWS-LM-SALE
040800         WHEN MMTCWS-LM-RETURN-REV
040900             EVALUATE TRUE
041000                 WHEN MTST-QI-INTRACHANGE
041100                     EVALUATE TRUE
041200                         WHEN MMSM-STORE-ATM
041300                         WHEN MMSM-STORE-CASH-ADV
041400                             ADD MTST-AMOUNT
041500                                 TO MMQ2-VI-ONUS-CD-AMT
041600                                    (1 X-MMQ2-VI-MON)
041700                             ADD MTST-NBR-ITEMS
041800                                 TO MMQ2-VI-ONUS-CD-NBR
041900                                    (1 X-MMQ2-VI-MON)
042000                         WHEN OTHER
042100                             ADD MTST-AMOUNT
042200                                 TO MMQ2-VI-ONUS-AMT
042300                                    (1 X-MMQ2-VI-MON)
042400                             ADD MTST-NBR-ITEMS
042500                                 TO MMQ2-VI-ONUS-NBR
042600                                    (1 X-MMQ2-VI-MON)
042700                     END-EVALUATE
042800                 WHEN MTST-QI-DOMESTIC
042900                     EVALUATE TRUE
043000                         WHEN MMSM-STORE-ATM
043100                         WHEN MMSM-STORE-CASH-ADV
043200                             ADD MTST-AMOUNT
043300                                 TO MMQ2-VI-DOMESTIC-CD-AMT
043400                                    (1 X-MMQ2-VI-MON)
043500                             ADD MTST-NBR-ITEMS
043600                                 TO MMQ2-VI-DOMESTIC-CD-NBR
043700                                    (1 X-MMQ2-VI-MON)
043800                         WHEN OTHER
043900                             ADD MTST-AMOUNT
044000                                 TO MMQ2-VI-DOMESTIC-AMT
044100                                    (1 X-MMQ2-VI-MON)
044200                             ADD MTST-NBR-ITEMS
044300                                 TO MMQ2-VI-DOMESTIC-NBR
044400                                    (1 X-MMQ2-VI-MON)
044500                     END-EVALUATE
044600                 WHEN OTHER
044700                     EVALUATE TRUE
044800                         WHEN MMSM-STORE-ATM
044900                         WHEN MMSM-STORE-CASH-ADV
045000                             ADD MTST-AMOUNT
045100                                 TO MMQ2-VI-INTER-CD-AMT
045200                                    (1 X-MMQ2-VI-MON)
045300                             ADD MTST-NBR-ITEMS
045400                                 TO MMQ2-VI-INTER-CD-NBR
045500                                    (1 X-MMQ2-VI-MON)
045600                         WHEN OTHER
045700                             ADD MTST-AMOUNT
045800                                 TO MMQ2-VI-INTER-AMT
045900                                    (1 X-MMQ2-VI-MON)
046000                             ADD MTST-NBR-ITEMS
046100                                 TO MMQ2-VI-INTER-NBR
046200                                    (1 X-MMQ2-VI-MON)
046300                     END-EVALUATE
046400             END-EVALUATE
046500     END-EVALUATE.
046600*
046700*
046800*
046900 V099-PVQR-EXIT.
047000     EXIT.
047100/
047200 9000-PERFORMED-ROUTINES-SECT SECTION.
047300     COPY MB00PD REPLACING ==:MB00:== BY ==MMQ2==.
047400/
047500     COPY MB99PD.
047600/
047700     COPY SS02PD.
047800*
047900 9995-END-SOURCE-STATEMENTS SECTION.
048000 9999-END-OF-PROGRAM.
048100     GOBACK.
