000100 IDENTIFICATION DIVISION.
000200 PROGRAM-ID. MBD410.
000201*       RELEASE DATE=08/24/01.        REVISION LEVEL=08.06      *
000202*****************************************************************
000203*WARNING.  THIS COMPUTER PROGRAM IS PROTECTED BY COPYRIGHT LAW  *
000204*AND INTERNATIONAL TREATIES.  UNAUTHORIZED REPRODUCTION OR      *
000205*DISTRIBUTION OF THIS PROGRAM, OR ANY PORTION OF IT, MAY RESULT *
000206*IN SEVERE CIVIL AND CRIMINAL PENATLIES, AND WILL BE PROSECUTED *
000207*TO THE MAXIMUM EXTENT POSSIBLE UNDER THE LAW.                  *
000208*COPYRIGHT 1999 PAYSYS INTERNATIONAL, INC.  ALL RIGHTS RESERVED.*
000209*****************************************************************
000300*****************************************************************
000400*                                                               *
000500*   V - PLUS  M E R C H A N T   B A N K C A R D   S Y S T E M   *
000600*                                                               *
000700*   MBD410 - STORE CLOSE/PURGE SECONDARY FUNCTIONS              *
000800*                                                               *
000900*****************************************************************
001000*                                                               *
001100*   THIS PROGRAM PERFORMS TWO FUNCTIONS.......................  *
001200*                                                               *
001300*   1. TO CREATE THE FILE TO AUTOMATICALLY DELETE A STORE       *
001400*      FROM THE STORE CHAIN DETAIL RECORDS WHEN THE STORE       *
001500*      IS PURGED (SET TO STATUS 9).                             *
001600*      (FILE MTS9 - USED BY PROGRAM MBD420)                     *
001700*                                                               *
001800*   2. TO UPDATE THE MMXR (STORE/MERCHANT CROSS-REFERENCE FILE) *
001900*      WHEN THE STORE IS PURGED (SET TO STATUS 9).              *
002000*                                                               *
002100*****************************************************************
002200 ENVIRONMENT DIVISION.
002300 CONFIGURATION SECTION.
002400 SOURCE-COMPUTER.            IBM-4341.
002500 OBJECT-COMPUTER.            IBM-4341.
002600/
002700 INPUT-OUTPUT SECTION.
002800*
002900 FILE-CONTROL.
003000*
003100     COPY MS1SES.
003200/
003300 DATA DIVISION.
003400 FILE SECTION.
003500*
003600     COPY MS1SSD.
003700     COPY MTM6RL.
003800     03  MS1S-FILE-CODE      PIC  X(01).
003900         88  MS1S-FC-IS-MTM6                 VALUE '0'.
004000         88  MS1S-FC-IS-MTS9                 VALUE '9'.
004100     03  MS1S-KEY.
004200         05  MS1S-ORG-MERCHANT.
004300             88  MS1S-HEADER                 VALUE ZERO.
004400             88  MS1S-TRAILER                VALUE ALL '9'.
004500             07  MS1S-ORG-X.
004600                 09  MS1S-ORG
004700                             PIC  9(03).
004800             07  MS1S-MERCHANT-X.
004900                 09  MS1S-MERCHANT
005000                             PIC  9(09).
005100         05  MS1S-STORE-X.
005200             07  MS1S-STORE  PIC S9(09)      BINARY.
005300*
005400/
005500 WORKING-STORAGE SECTION.
005600*
005700 01  FILLER                  PIC  X(12)      VALUE '** WS-BEG **'.
005800*
005900     COPY MMSCIO.
006000/
006100     COPY MB00RB REPLACING ==:MB00:== BY ==MMSC==.
006200/
006300     COPY MMSCRL.
006400/
006500     COPY MMXRIO.
006600/
006700     COPY MB00RB REPLACING ==:MB00:== BY ==MMXR==.
006800/
006900     COPY MMXRRL.
007000/
007100     COPY MB00RB REPLACING ==:MB00:== BY ==MS1S==.
007200/
007300     COPY MB00RB REPLACING ==:MB00:== BY ==MS2S==.
007400/
007500     COPY MTS6IO.
007600/
007700     COPY MB00RB REPLACING ==:MB00:== BY ==MTS6==.
007800/
007900     COPY MTS6RL.
008000/
008100     COPY MTS9IO.
008200/
008300     COPY MB00RB REPLACING ==:MB00:== BY ==MTS9==.
008400/
008500     COPY MTS9RL.
008600/
008700     COPY MB00WS.
008800/
008900     COPY MB99WS.
009000/
009100     COPY SS00WS.
009200/
009300     COPY SS01WS.
009400/
009500     COPY SS02WS.
009600*
009700 01  FILLER                  PIC  X(12)      VALUE '** WS-END **'.
009800/
009900 PROCEDURE DIVISION.
010000 A000-MAIN-LINE-SECT SECTION.
010100 A010-ML-BEGIN.
010200*
010300     MOVE 'MBD410'               TO SS02WS-ABEND-PROG-ID.
010400*
010500     PERFORM A100-OPEN-FILES
010600        THRU A199-OF-EXIT.
010700*
010800     PERFORM A200-SORT-PROCESS
010900        THRU A299-SP-EXIT.
011000*
011100     PERFORM A300-CLOSE-FILES
011200        THRU A399-CF-EXIT.
011300*
011400     STOP RUN.
011500*
011600 A099-ML-EXIT.
011700     EXIT.
011800/
011900 A100-OPEN-FILES SECTION.
012000 A101-OF-BEGIN.
012100*
012200     MOVE 'O1SC'                 TO SS02WS-ABEND-LOCATION.
012300     SET MMSCRB-OPEN-INPUT       TO TRUE.
012400     PERFORM MB00PD-MMSC-ACCESS
012500        THRU MB00PD-MMSC-ACCESS-EXIT.
012600*
012700     MOVE 'R1SC'                 TO SS02WS-ABEND-LOCATION.
012800     SET MMSCRB-READ-SEQ         TO TRUE.
012900     PERFORM MB00PD-MMSC-ACCESS
013000        THRU MB00PD-MMSC-ACCESS-EXIT.
013100*
013200     MOVE 'MMSC'                 TO MB99WS-FILE-ID.
013300*
013400     IF  MMSCIO-HEADER
013500         NEXT SENTENCE
013600     ELSE
013700         PERFORM MB99PD-MISSING-HEADER-ABEND
013800            THRU MB99PD-MHA-EXIT.
013900*
014000     MOVE MMSCIO-RECORD          TO MMSC-RECORD.
014100     MOVE MMSC-TODAYS-JULIAN     TO MB99WS-PROC-DATE.
014200     MOVE MMSC-TIME-STAMP        TO MB99WS-PROC-TIME.
014300*
014400*
014500*
014600     MOVE 'O1XR'                 TO SS02WS-ABEND-LOCATION.
014700     SET MMXRRB-OPEN-IO          TO TRUE.
014800     PERFORM MB00PD-MMXR-ACCESS
014900        THRU MB00PD-MMXR-ACCESS-EXIT.
015000*
015100     MOVE 'R1XR'                 TO SS02WS-ABEND-LOCATION.
015200     SET MMXRRB-READ-SEQ         TO TRUE.
015300     PERFORM MB00PD-MMXR-ACCESS
015400        THRU MB00PD-MMXR-ACCESS-EXIT.
015500*
015600     MOVE 'MMXR'                 TO MB99WS-FILE-ID.
015700*
015800     IF  MMXRIO-HEADER
015900         NEXT SENTENCE
016000     ELSE
016100         PERFORM MB99PD-MISSING-HEADER-ABEND
016200            THRU MB99PD-MHA-EXIT.
016300*
016400     MOVE MMXRIO-DATE-STAMP      TO MB99WS-FILE-DATE.
016500     MOVE MMXRIO-TIME-STAMP      TO MB99WS-FILE-TIME.
016600     PERFORM MB99PD-CHECK-DATE-TIME
016700        THRU MB99PD-CDT-EXIT.
016800*
016900     MOVE MMXRIO-RECORD          TO MMXR-RECORD.
017000*
017100*
017200*
017300     MOVE 'O1S6'                 TO SS02WS-ABEND-LOCATION.
017400     SET MTS6RB-OPEN-INPUT       TO TRUE.
017500     PERFORM MB00PD-MTS6-ACCESS
017600        THRU MB00PD-MTS6-ACCESS-EXIT.
017700*
017800     MOVE 'R0S6'                 TO SS02WS-ABEND-LOCATION.
017900     SET MTS6RB-READ-SEQ         TO TRUE.
018000     PERFORM MB00PD-MTS6-ACCESS
018100        THRU MB00PD-MTS6-ACCESS-EXIT.
018200     MOVE 'MTS6'                 TO MB99WS-FILE-ID.
018300*
018400     IF  MTS6IO-HEADER
018500         NEXT SENTENCE
018600     ELSE
018700         PERFORM MB99PD-MISSING-HEADER-ABEND
018800            THRU MB99PD-MHA-EXIT.
018900*
019000     MOVE MTS6IO-DATE-STAMP      TO MB99WS-FILE-DATE.
019100     MOVE MTS6IO-TIME-STAMP      TO MB99WS-FILE-TIME.
019200     PERFORM MB99PD-CHECK-DATE-TIME
019300        THRU MB99PD-CDT-EXIT.
019400*
019500     MOVE MTS6IO-RECORD          TO MTS6-RECORD.
019600*
019700*
019800*
019900     MOVE 'O1S9'                 TO SS02WS-ABEND-LOCATION.
020000     SET MTS9RB-OPEN-OUTPUT      TO TRUE.
020100     PERFORM MB00PD-MTS9-ACCESS
020200        THRU MB00PD-MTS9-ACCESS-EXIT.
020300*
020400     MOVE SPACES                 TO MTS9IO-RECORD.
020500     SET MTS9IO-HEADER           TO TRUE.
020600     MOVE MMSC-TODAYS-JULIAN     TO MTS9IO-DATE-STAMP.
020700     MOVE MMSC-TIME-STAMP        TO MTS9IO-TIME-STAMP.
020800*
020900     MOVE 'W0S9'                 TO SS02WS-ABEND-LOCATION.
021000     SET MTS9RB-WRITE            TO TRUE.
021100     PERFORM MB00PD-MTS9-ACCESS
021200        THRU MB00PD-MTS9-ACCESS-EXIT.
021300*
021400 A199-OF-EXIT.
021500     EXIT.
021600*
021700*
021800*
021900 A200-SORT-PROCESS SECTION.
022000 A201-SP-BEGIN.
022100*
022200     SORT MS1S-SORT-FILE
022300         ON ASCENDING KEY MS1S-FILE-CODE
022400                          MS1S-KEY
022500         INPUT  PROCEDURE IS 1000-BUILD-FILES
022600         OUTPUT PROCEDURE IS 2000-WRITE-FILES.
022700*
022800     PERFORM SS98PD-VERIFY-SORT-RETURN
022900        THRU SS98PD-VSR-EXIT.
023000*
023100 A299-SP-EXIT.
023200     EXIT.
023300/
023400 A300-CLOSE-FILES SECTION.
023500 A301-CF-BEGIN.
023600*
023700     MOVE SPACES                 TO MTS9IO-RECORD.
023800     SET MTS9IO-TRAILER          TO TRUE.
023900     MOVE MMSC-TODAYS-JULIAN     TO MTS9IO-DATE-STAMP.
024000     MOVE MMSC-TIME-STAMP        TO MTS9IO-TIME-STAMP.
024100*
024200     MOVE 'W9S9'                 TO SS02WS-ABEND-LOCATION.
024300     SET MTS9RB-WRITE            TO TRUE.
024400     PERFORM MB00PD-MTS9-ACCESS
024500        THRU MB00PD-MTS9-ACCESS-EXIT.
024600*
024700*
024800*
024900     MOVE 'C1S6'                 TO SS02WS-ABEND-LOCATION.
025000     SET MTS6RB-CLOSE            TO TRUE.
025100     PERFORM MB00PD-MTS6-ACCESS
025200        THRU MB00PD-MTS6-ACCESS-EXIT.
025300*
025400     MOVE 'C1S9'                 TO SS02WS-ABEND-LOCATION.
025500     SET MTS9RB-CLOSE            TO TRUE.
025600     PERFORM MB00PD-MTS9-ACCESS
025700        THRU MB00PD-MTS9-ACCESS-EXIT.
025800*
025900     MOVE 'C1XR'                 TO SS02WS-ABEND-LOCATION.
026000     SET MMXRRB-CLOSE            TO TRUE.
026100     PERFORM MB00PD-MMXR-ACCESS
026200        THRU MB00PD-MMXR-ACCESS-EXIT.
026300*
026400     MOVE 'C1SC'                 TO SS02WS-ABEND-LOCATION.
026500     SET MMSCRB-CLOSE            TO TRUE.
026600     PERFORM MB00PD-MMSC-ACCESS
026700        THRU MB00PD-MMSC-ACCESS-EXIT.
026800*
026900 A399-CF-EXIT.
027000     EXIT.
027100/
027200 1000-BUILD-FILES SECTION.
027300 1001-BF-BEGIN.
027400*
027500     MOVE 'R1S6'                 TO SS02WS-ABEND-LOCATION.
027600     SET MTS6RB-READ-SEQ         TO TRUE.
027700     PERFORM MB00PD-MTS6-ACCESS
027800        THRU MB00PD-MTS6-ACCESS-EXIT.
027900*
028000     IF  MTS6IO-HEADER
028100         GO TO 1001-BF-BEGIN.
028200*
028300     IF  MTS6IO-TRAILER
028400         GO TO 1999-BF-EXIT.
028500*
028600     MOVE MTS6IO-RECORD          TO MTS6-RECORD.
028700*
028800     IF  MTS6-REC-PURGED
028900         PERFORM
029000             VARYING X-MTS6-STORE-CHAIN FROM 1 BY 1
029100             UNTIL   X-MTS6-STORE-CHAIN IS GREATER THAN 10
029200             EVALUATE TRUE
029300                 WHEN MTS6-STORE-CHAIN-ID (X-MTS6-STORE-CHAIN)
029400                                 IS EQUAL TO ZERO
029500                     CONTINUE
029600                 WHEN OTHER
029700                     PERFORM 1600-CREATE-MTS9
029800                        THRU 1699-C-MTS9-EXIT
029900             END-EVALUATE
030000         END-PERFORM
030100     END-IF.
030200*
030300     GO TO 1001-BF-BEGIN.
030400*
030500*
030600*
030700 1600-CREATE-MTS9.
030800*
030900     MOVE SPACES                 TO MTS9-RECORD.
031000     MOVE MTS6-ORG               TO MTS9-ORG.
031100     MOVE MTS6-STORE-CHAIN-ID (X-MTS6-STORE-CHAIN)
031200                                 TO MTS9-CHAIN.
031300     MOVE MTS6-REC-STATUS        TO MTS9-REC-STATUS.
031400     MOVE MTS6-MERCHANT          TO MTS9-MEMBER.
031500     MOVE MTS9-RECORD            TO MTM6-RECORD.
031600     SET  MS1S-FC-IS-MTS9        TO TRUE.
031700     MOVE MTS9-ORG               TO MS1S-ORG.
031800     MOVE MTS9-CHAIN             TO MS1S-MERCHANT.
031900     MOVE ZERO                   TO MS1S-STORE.
032000     RELEASE MTM6-RECORD.
032100*
032200 1699-C-MTS9-EXIT.
032300     EXIT.
032400*
032500*
032600*
032700 1700-CREATE-MTM6.
032800*
032900     MOVE MTS6-RECORD            TO MTM6-RECORD
033000     MOVE MTS6-STORE             TO MTM6-STORE.
033100     MOVE MTS6-MERCHANT          TO MTM6-MERCHANT.
033200     SET  MS1S-FC-IS-MTM6        TO TRUE.
033300     MOVE MTS6-ORG               TO MS1S-ORG.
033400     MOVE MTS6-MERCHANT          TO MS1S-MERCHANT.
033500     MOVE MTS6-STORE             TO MS1S-STORE.
033600     RELEASE MTM6-RECORD.
033700*
033800 1799-C-MTM6-EXIT.
033900     EXIT.
034000*
034100*
034200*
034300 1999-BF-EXIT.
034400     EXIT.
034500/
034600 2000-WRITE-FILES SECTION.
034700 2001-WF-BEGIN.
034800*
034900     RETURN MS1S-SORT-FILE
035000         AT END
035100             GO TO 2999-WF-EXIT.
035200*
035300     EVALUATE TRUE
035400         WHEN MS1S-FC-IS-MTM6
035500             IF  MTM6-REC-PURGED
035600                 PERFORM 2100-PURGE-MMXR-STORE
035700                    THRU 2199-PMMXRS-EXIT
035800             END-IF
035900         WHEN MS1S-FC-IS-MTS9
036000             MOVE MTM6-RECORD    TO MTS9IO-RECORD
036100             MOVE 'W1S9'         TO SS02WS-ABEND-LOCATION
036200             SET MTS9RB-WRITE    TO TRUE
036300             PERFORM MB00PD-MTS9-ACCESS
036400                THRU MB00PD-MTS9-ACCESS-EXIT
036500     END-EVALUATE.
036600*
036700     GO TO 2001-WF-BEGIN.
036800*
036900*
037000*
037100 2100-PURGE-MMXR-STORE.
037200*
037300     PERFORM
037400         UNTIL MMXRIO-KEY IS GREATER THAN MS1S-KEY
037500         MOVE MMXRIO-RECORD      TO MMXR-RECORD
037600         EVALUATE TRUE
037700             WHEN MMXRIO-KEY IS NOT EQUAL TO MS1S-KEY
037800                 CONTINUE
037900             WHEN OTHER
038000                 PERFORM 2800-UPDATE-MMXR
038100                    THRU 2899-U-MMXR-EXIT
038200         END-EVALUATE
038300         MOVE 'R1XR'             TO SS02WS-ABEND-LOCATION
038400         SET MMXRRB-READ-SEQ     TO TRUE
038500         PERFORM MB00PD-MMXR-ACCESS
038600            THRU MB00PD-MMXR-ACCESS-EXIT
038700     END-PERFORM.
038800*
038900 2199-PMMXRS-EXIT.
039000     EXIT.
039100*
039200*
039300*
039400 2800-UPDATE-MMXR.
039500*
039600     IF  MTM6-REC-PURGED
039700         NEXT SENTENCE
039800     ELSE
039900         GO TO 2899-U-MMXR-EXIT.
040000*
040100     SET  MMXR-REC-PURGED        TO TRUE.
040200     MOVE MMXR-RECORD            TO MMXRIO-RECORD.
040300*
040400     MOVE 'U1XR'                 TO SS02WS-ABEND-LOCATION.
040500     SET MMXRRB-REWRITE          TO TRUE.
040600     PERFORM MB00PD-MMXR-ACCESS
040700        THRU MB00PD-MMXR-ACCESS-EXIT.
040800*
040900 2899-U-MMXR-EXIT.
041000     EXIT.
041100*
041200*
041300*
041400 2999-WF-EXIT.
041500     EXIT.
041600/
041700 9000-PERFORMED-ROUTINES-SECT SECTION.
041800*
041900     COPY MB00PD REPLACING ==:MB00:== BY ==MMSC==.
042000/
042100     COPY MB00PD REPLACING ==:MB00:== BY ==MMXR==.
042200/
042300     COPY MB00PD REPLACING ==:MB00:== BY ==MTS6==.
042400/
042500     COPY MB00PD REPLACING ==:MB00:== BY ==MTS9==.
042600/
042700     COPY MB99PD.
042800/
042900     COPY SS02PD.
043000/
043100     COPY SS98PD.
043200*
043300 9995-END-SOURCE-STATEMENTS SECTION.
043400 9999-END-OF-PROGRAM.
043500     EXIT.
