000100 IDENTIFICATION DIVISION.
000200 PROGRAM-ID. MBD720.
000201*       RELEASE DATE=08/24/01.        REVISION LEVEL=08.06      *
000202*****************************************************************
000203*WARNING.  THIS COMPUTER PROGRAM IS PROTECTED BY COPYRIGHT LAW  *
000204*AND INTERNATIONAL TREATIES.  UNAUTHORIZED REPRODUCTION OR      *
000205*DISTRIBUTION OF THIS PROGRAM, OR ANY PORTION OF IT, MAY RESULT *
000206*IN SEVERE CIVIL AND CRIMINAL PENATLIES, AND WILL BE PROSECUTED *
000207*TO THE MAXIMUM EXTENT POSSIBLE UNDER THE LAW.                  *
000208*COPYRIGHT 1999 PAYSYS INTERNATIONAL, INC.  ALL RIGHTS RESERVED.*
000209*****************************************************************
000300*****************************************************************
000400*                                                               *
000500*   V - PLUS  M E R C H A N T   B A N K C A R D   S Y S T E M   *
000600*                                                               *
000700*       MBD720 - STOCK REPORTS DRIVER PROGRAM                   *
000800*                                                               *
000900*****************************************************************
001000 ENVIRONMENT DIVISION.
001100 CONFIGURATION SECTION.
001200 SOURCE-COMPUTER.            IBM-4341.
001300 OBJECT-COMPUTER.            IBM-4341.
001400/
001500 INPUT-OUTPUT SECTION.
001600*
001700 FILE-CONTROL.
001800*
001900/
002000 DATA DIVISION.
002100 FILE SECTION.
002200*
002300/
002400 WORKING-STORAGE SECTION.
002500*
002600 01  FILLER                  PIC  X(12)      VALUE '** WS-BEG **'.
002700*
002800     COPY MTCCRL REPLACING ==:MTCC:== BY ==MTCC==.
002900/
003000     COPY MB00RB REPLACING ==:MB00:== BY ==MTCC==.
003100/
003200     COPY MTCCIO REPLACING ==:MTCC:== BY ==MTCC==.
003300/
003400     COPY MTRFRL REPLACING ==:MTRF:== BY ==MTRF==.
003500/
003600     COPY MB00RB REPLACING ==:MB00:== BY ==MTRF==.
003700/
003800     COPY MTRFIO REPLACING ==:MTRF:== BY ==MTRF==.
003900/
004000     COPY MTRFWS REPLACING ==:MTRF:== BY ==MTRF==.
004100/
004200     COPY MB00WS.
004300/
004400     COPY MB20WS.
004500/
004600     COPY MB22WS.
004700/
004800     COPY SS00WS.
004900/
005000     COPY SS01WS.
005100/
005200     COPY SS02WS.
005300*
005400 01  FILLER                  PIC  X(12)      VALUE '** WS-END **'.
005500/
005600 PROCEDURE DIVISION.
005700 A000-MAIN-LINE-SECT SECTION.
005800 A010-ML-BEGIN.
005900*
006000     MOVE SPACES                 TO MTRF-RECORD.
006100     MOVE SPACES                 TO MB20WS-SH-L1.
006200     MOVE SPACES                 TO MB20WS-SH-L2.
006300     MOVE SPACES                 TO MB20WS-SH-L3.
006400     MOVE SPACES                 TO MB20WS-SH-L4.
006500     MOVE SPACES                 TO MB20WS-SH-L5.
006600     MOVE SPACES                 TO MB20WS-SH-L6.
006700     MOVE SPACES                 TO MB20WS-SH-L7.
006800     MOVE SPACES                 TO MB20WS-SH-L8.
006900*
007000     PERFORM A100-OPEN-FILES
007100        THRU A199-OF-EXIT.
007200*
007300     PERFORM A200-PROCESS-REPORTS
007400        THRU A299-PR-EXIT
007500        UNTIL MTRFIO-TRAILER.
007600*
007700     PERFORM A300-CLOSE-FILES
007800        THRU A399-CF-EXIT.
007900*
008000     STOP RUN.
008100*
008200 A099-ML-EXIT.
008300     EXIT.
008400/
008500 A100-OPEN-FILES SECTION.
008600 A110-OF-BEGIN.
008700*
008800     MOVE 'MBD720'               TO SS02WS-ABEND-PROG-ID.
008900*
009000     MOVE 'O1RF'                 TO SS02WS-ABEND-LOCATION.
009100     SET MTRFRB-OPEN-INPUT       TO TRUE.
009200     PERFORM MB00PD-MTRF-ACCESS
009300        THRU MB00PD-MTRF-ACCESS-EXIT.
009400*
009500     MOVE 'O1CC'                 TO SS02WS-ABEND-LOCATION.
009600     SET MTCCRB-OPEN-INPUT       TO TRUE.
009700     PERFORM MB00PD-MTCC-ACCESS
009800        THRU MB00PD-MTCC-ACCESS-EXIT.
009900*
010000     MOVE SS02WS-END-OF-FILE     TO MTCCRB-PERM-STATUS-1.
010100*
010200     PERFORM Z100-READ-CONTROL-CARD
010300        THRU Z199-RCC-EXIT
010400        UNTIL MTCC-PROGRAM-ID IS EQUAL TO SS02WS-ABEND-PROG-ID.
010500*
010600     MOVE 'R0RF'                 TO SS02WS-ABEND-LOCATION.
010700     SET MTRFRB-READ-SEQ         TO TRUE.
010800     PERFORM MB00PD-MTRF-ACCESS
010900        THRU MB00PD-MTRF-ACCESS-EXIT.
011000*
011100     PERFORM MB22PD-INITIALIZE-PAGE
011200        THRU MB22PD-IP-EXIT.
011300*
011400 A199-OF-EXIT.
011500     EXIT.
011600/
011700 A200-PROCESS-REPORTS SECTION.
011800 A210-PR-BEGIN.
011900*
012000     MOVE 'R1RF'                 TO SS02WS-ABEND-LOCATION.
012100     SET MTRFRB-READ-SEQ         TO TRUE.
012200     PERFORM MB00PD-MTRF-ACCESS
012300        THRU MB00PD-MTRF-ACCESS-EXIT.
012400*
012500     IF  MTRFIO-HEADER
012600     OR  MTRFIO-TRAILER
012700         GO TO A299-PR-EXIT.
012800*
012900     MOVE MTRFIO-RECORD          TO MTRF-RECORD.
013000*
013100     IF  MTCC-MBD720-ALL
013200     OR  MTCC-MBD720-REPORT-X IS EQUAL TO MTRF-K1-REPORT-X
013300         PERFORM B000-PROCESS-REPORT-RECORD
013400            THRU B999-PRR-EXIT.
013500*
013600 A299-PR-EXIT.
013700     EXIT.
013800/
013900 A300-CLOSE-FILES SECTION.
014000 A310-CF-BEGIN.
014100*
014200     MOVE 'C1RF'                 TO SS02WS-ABEND-LOCATION.
014300     SET MTRFRB-CLOSE            TO TRUE.
014400     PERFORM MB00PD-MTRF-ACCESS
014500        THRU MB00PD-MTRF-ACCESS-EXIT.
014600*
014700     MOVE 'C1CC'                 TO SS02WS-ABEND-LOCATION.
014800     SET MTCCRB-CLOSE            TO TRUE.
014900     PERFORM MB00PD-MTCC-ACCESS
015000        THRU MB00PD-MTCC-ACCESS-EXIT.
015100*
015200     PERFORM MB20PD-CLOSE-PRINT-FILES
015300        THRU MB20PD-CPF-EXIT.
015400*
015500 A399-CF-EXIT.
015600     EXIT.
015700/
015800 B000-PROCESS-REPORT-RECORD SECTION.
015900 B010-PRR-BEGIN.
016000*
016100     IF  MTRF-K1-RPT-USER
016200         PERFORM C000-PROCESS-USER-REPORTS
016300            THRU C999-PUR-EXIT
016400         GO TO B999-PRR-EXIT.
016500*
016600     IF  MTRF-K1-RPT-OPTIONAL
016700         NEXT SENTENCE
016800     ELSE
016900         GO TO B999-PRR-EXIT.
017000*
017100     GO TO B010-PRR-REPORT-01
017200           B020-PRR-REPORT-02
017300           B030-PRR-REPORT-03
017400           B040-PRR-REPORT-04
017500           B050-PRR-REPORT-05
017600           B060-PRR-REPORT-06
017700           B070-PRR-REPORT-07
017800           B080-PRR-REPORT-08
017900           B090-PRR-REPORT-09
018000           B100-PRR-REPORT-10
018100           B110-PRR-REPORT-11
018200           B120-PRR-REPORT-12
018300           B130-PRR-REPORT-13
018400           B140-PRR-REPORT-14
018500           B150-PRR-REPORT-15
018600           B160-PRR-REPORT-16
018700           B170-PRR-REPORT-17
018800           B180-PRR-REPORT-18
018900           B190-PRR-REPORT-19
019000           B200-PRR-REPORT-20
019100           B210-PRR-REPORT-21
019200           B220-PRR-REPORT-22
019300           B230-PRR-REPORT-23
019400           B240-PRR-REPORT-24
019500           B250-PRR-REPORT-25
019600           B260-PRR-REPORT-26
019700           B270-PRR-REPORT-27
019800           B280-PRR-REPORT-28
019900           B290-PRR-REPORT-29
020000           B300-PRR-REPORT-30
020100           B310-PRR-REPORT-31
020200           B320-PRR-REPORT-32
020300           B330-PRR-REPORT-33
020400           B340-PRR-REPORT-34
020500           B350-PRR-REPORT-35
020600           B360-PRR-REPORT-36
020700           B370-PRR-REPORT-37
020800           B380-PRR-REPORT-38
020900           B390-PRR-REPORT-39
021000           B400-PRR-REPORT-40
021100           B410-PRR-REPORT-41
021200           B420-PRR-REPORT-42
021300           B430-PRR-REPORT-43
021400           B440-PRR-REPORT-44
021500           B450-PRR-REPORT-45
021600           B460-PRR-REPORT-46
021700           B470-PRR-REPORT-47
021800           B480-PRR-REPORT-48
021900           B490-PRR-REPORT-49
022000           B500-PRR-REPORT-50
022100           B510-PRR-REPORT-51
022200           B520-PRR-REPORT-52
022300           B530-PRR-REPORT-53
022400           B540-PRR-REPORT-54
022500           B550-PRR-REPORT-55
022600           B560-PRR-REPORT-56
022700           B570-PRR-REPORT-57
022800           B580-PRR-REPORT-58
022900           B590-PRR-REPORT-59
023000           B600-PRR-REPORT-60
023100           B610-PRR-REPORT-61
023200           B620-PRR-REPORT-62
023300           B630-PRR-REPORT-63
023400           B640-PRR-REPORT-64
023500           B650-PRR-REPORT-65
023600           B660-PRR-REPORT-66
023700           B670-PRR-REPORT-67
023800           B680-PRR-REPORT-68
023900           B690-PRR-REPORT-69
024000           B700-PRR-REPORT-70
024100           B710-PRR-REPORT-71
024200           B720-PRR-REPORT-72
024300           B730-PRR-REPORT-73
024400           B740-PRR-REPORT-74
024500           B750-PRR-REPORT-75
024600           B760-PRR-REPORT-76
024700           B770-PRR-REPORT-77
024800           B780-PRR-REPORT-78
024900           B790-PRR-REPORT-79
025000           B800-PRR-REPORT-80
025100           B810-PRR-REPORT-81
025200           B820-PRR-REPORT-82
025300           B830-PRR-REPORT-83
025400           B840-PRR-REPORT-84
025500           B850-PRR-REPORT-85
025600           B860-PRR-REPORT-86
025700           B870-PRR-REPORT-87
025800           B880-PRR-REPORT-88
025900           B890-PRR-REPORT-89
026000           B900-PRR-REPORT-90
026100           B910-PRR-REPORT-91
026200           B920-PRR-REPORT-92
026300           B930-PRR-REPORT-93
026400           DEPENDING ON MTRF-K1-RPT-NBR.
026500*
026600 B010-PRR-REPORT-01.
026700*
026800     PERFORM R010-REPORT-01
026900        THRU R019-R01-EXIT.
027000     PERFORM P000-PRINT-THE-REPORTS
027100        THRU P999-PTR-EXIT.
027200     GO TO B999-PRR-EXIT.
027300*
027400*
027500*
027600 B020-PRR-REPORT-02.
027700*
027800     PERFORM R020-REPORT-02
027900        THRU R029-R02-EXIT.
028000     PERFORM P000-PRINT-THE-REPORTS
028100        THRU P999-PTR-EXIT.
028200     GO TO B999-PRR-EXIT.
028300*
028400*
028500*
028600 B030-PRR-REPORT-03.
028700*
028800     PERFORM R030-REPORT-03
028900        THRU R039-R03-EXIT.
029000     PERFORM P000-PRINT-THE-REPORTS
029100        THRU P999-PTR-EXIT.
029200     GO TO B999-PRR-EXIT.
029300*
029400*
029500*
029600 B040-PRR-REPORT-04.
029700*
029800     PERFORM R040-REPORT-04
029900        THRU R049-R04-EXIT.
030000     PERFORM P000-PRINT-THE-REPORTS
030100        THRU P999-PTR-EXIT.
030200     GO TO B999-PRR-EXIT.
030300*
030400*
030500*
030600 B050-PRR-REPORT-05.
030700*
030800     PERFORM R050-REPORT-05
030900        THRU R059-R05-EXIT.
031000     PERFORM P000-PRINT-THE-REPORTS
031100        THRU P999-PTR-EXIT.
031200     GO TO B999-PRR-EXIT.
031300*
031400*
031500*
031600 B060-PRR-REPORT-06.
031700*
031800     PERFORM R060-REPORT-06
031900        THRU R069-R06-EXIT.
032000     PERFORM P000-PRINT-THE-REPORTS
032100        THRU P999-PTR-EXIT.
032200     GO TO B999-PRR-EXIT.
032300*
032400*
032500*
032600 B070-PRR-REPORT-07.
032700*
032800     PERFORM R070-REPORT-07
032900        THRU R079-R07-EXIT.
033000     PERFORM P000-PRINT-THE-REPORTS
033100        THRU P999-PTR-EXIT.
033200     GO TO B999-PRR-EXIT.
033300*
033400*
033500*
033600 B080-PRR-REPORT-08.
033700*
033800     PERFORM R080-REPORT-08
033900        THRU R089-R08-EXIT.
034000     PERFORM P000-PRINT-THE-REPORTS
034100        THRU P999-PTR-EXIT.
034200     GO TO B999-PRR-EXIT.
034300*
034400*
034500*
034600 B090-PRR-REPORT-09.
034700*
034800     PERFORM R090-REPORT-09
034900        THRU R099-R09-EXIT.
035000     PERFORM P000-PRINT-THE-REPORTS
035100        THRU P999-PTR-EXIT.
035200     GO TO B999-PRR-EXIT.
035300*
035400*
035500*
035600 B100-PRR-REPORT-10.
035700*
035800     PERFORM R100-REPORT-10
035900        THRU R109-R10-EXIT.
036000     PERFORM P000-PRINT-THE-REPORTS
036100        THRU P999-PTR-EXIT.
036200     GO TO B999-PRR-EXIT.
036300*
036400*
036500*
036600 B110-PRR-REPORT-11.
036700*
036800     PERFORM R110-REPORT-11
036900        THRU R119-R11-EXIT.
037000     PERFORM P000-PRINT-THE-REPORTS
037100        THRU P999-PTR-EXIT.
037200     GO TO B999-PRR-EXIT.
037300*
037400*
037500*
037600 B120-PRR-REPORT-12.
037700*
037800     PERFORM R120-REPORT-12
037900        THRU R129-R12-EXIT.
038000     PERFORM P000-PRINT-THE-REPORTS
038100        THRU P999-PTR-EXIT.
038200     GO TO B999-PRR-EXIT.
038300*
038400*
038500*
038600 B130-PRR-REPORT-13.
038700*
038800     PERFORM R130-REPORT-13
038900        THRU R139-R13-EXIT.
039000     PERFORM P000-PRINT-THE-REPORTS
039100        THRU P999-PTR-EXIT.
039200     GO TO B999-PRR-EXIT.
039300*
039400*
039500*
039600 B140-PRR-REPORT-14.
039700*
039800     PERFORM R140-REPORT-14
039900        THRU R149-R14-EXIT.
040000     PERFORM P000-PRINT-THE-REPORTS
040100        THRU P999-PTR-EXIT.
040200     GO TO B999-PRR-EXIT.
040300*
040400*
040500*
040600 B150-PRR-REPORT-15.
040700*
040800     PERFORM R150-REPORT-15
040900        THRU R159-R15-EXIT.
041000     PERFORM P000-PRINT-THE-REPORTS
041100        THRU P999-PTR-EXIT.
041200     GO TO B999-PRR-EXIT.
041300*
041400*
041500*
041600 B160-PRR-REPORT-16.
041700*
041800     PERFORM R160-REPORT-16
041900        THRU R169-R16-EXIT.
042000     PERFORM P000-PRINT-THE-REPORTS
042100        THRU P999-PTR-EXIT.
042200     GO TO B999-PRR-EXIT.
042300*
042400*
042500*
042600 B170-PRR-REPORT-17.
042700*
042800     PERFORM R170-REPORT-17
042900        THRU R179-R17-EXIT.
043000     PERFORM P000-PRINT-THE-REPORTS
043100        THRU P999-PTR-EXIT.
043200     GO TO B999-PRR-EXIT.
043300*
043400*
043500*
043600 B180-PRR-REPORT-18.
043700*
043800     PERFORM R180-REPORT-18
043900        THRU R189-R18-EXIT.
044000     PERFORM P000-PRINT-THE-REPORTS
044100        THRU P999-PTR-EXIT.
044200     GO TO B999-PRR-EXIT.
044300*
044400*
044500*
044600 B190-PRR-REPORT-19.
044700*
044800     PERFORM R190-REPORT-19
044900        THRU R199-R19-EXIT.
045000     PERFORM P000-PRINT-THE-REPORTS
045100        THRU P999-PTR-EXIT.
045200     GO TO B999-PRR-EXIT.
045300*
045400*
045500*
045600 B200-PRR-REPORT-20.
045700*
045800     PERFORM R200-REPORT-20
045900        THRU R209-R20-EXIT.
046000     PERFORM P000-PRINT-THE-REPORTS
046100        THRU P999-PTR-EXIT.
046200     GO TO B999-PRR-EXIT.
046300*
046400*
046500*
046600 B210-PRR-REPORT-21.
046700*
046800     PERFORM R210-REPORT-21
046900        THRU R219-R21-EXIT.
047000     PERFORM P000-PRINT-THE-REPORTS
047100        THRU P999-PTR-EXIT.
047200     GO TO B999-PRR-EXIT.
047300*
047400*
047500*
047600 B220-PRR-REPORT-22.
047700*
047800     PERFORM R220-REPORT-22
047900        THRU R229-R22-EXIT.
048000     PERFORM P000-PRINT-THE-REPORTS
048100        THRU P999-PTR-EXIT.
048200     GO TO B999-PRR-EXIT.
048300*
048400*
048500*
048600 B230-PRR-REPORT-23.
048700*
048800     PERFORM R230-REPORT-23
048900        THRU R239-R23-EXIT.
049000     PERFORM P000-PRINT-THE-REPORTS
049100        THRU P999-PTR-EXIT.
049200     GO TO B999-PRR-EXIT.
049300*
049400*
049500*
049600 B240-PRR-REPORT-24.
049700*
049800     PERFORM R240-REPORT-24
049900        THRU R249-R24-EXIT.
050000     PERFORM P000-PRINT-THE-REPORTS
050100        THRU P999-PTR-EXIT.
050200     GO TO B999-PRR-EXIT.
050300*
050400*
050500*
050600 B250-PRR-REPORT-25.
050700*
050800     PERFORM R250-REPORT-25
050900        THRU R259-R25-EXIT.
051000     PERFORM P000-PRINT-THE-REPORTS
051100        THRU P999-PTR-EXIT.
051200     GO TO B999-PRR-EXIT.
051300*
051400*
051500*
051600 B260-PRR-REPORT-26.
051700*
051800     PERFORM R260-REPORT-26
051900        THRU R269-R26-EXIT.
052000     PERFORM P000-PRINT-THE-REPORTS
052100        THRU P999-PTR-EXIT.
052200     GO TO B999-PRR-EXIT.
052300*
052400*
052500*
052600 B270-PRR-REPORT-27.
052700*
052800     PERFORM R270-REPORT-27
052900        THRU R279-R27-EXIT.
053000     PERFORM P000-PRINT-THE-REPORTS
053100        THRU P999-PTR-EXIT.
053200     GO TO B999-PRR-EXIT.
053300*
053400*
053500*
053600 B280-PRR-REPORT-28.
053700*
053800     PERFORM R280-REPORT-28
053900        THRU R289-R28-EXIT.
054000     PERFORM P000-PRINT-THE-REPORTS
054100        THRU P999-PTR-EXIT.
054200     GO TO B999-PRR-EXIT.
054300*
054400*
054500*
054600 B290-PRR-REPORT-29.
054700*
054800     PERFORM R290-REPORT-29
054900        THRU R299-R29-EXIT.
055000     PERFORM P000-PRINT-THE-REPORTS
055100        THRU P999-PTR-EXIT.
055200     GO TO B999-PRR-EXIT.
055300*
055400*
055500*
055600 B300-PRR-REPORT-30.
055700*
055800     PERFORM R300-REPORT-30
055900        THRU R309-R30-EXIT.
056000     PERFORM P000-PRINT-THE-REPORTS
056100        THRU P999-PTR-EXIT.
056200     GO TO B999-PRR-EXIT.
056300*
056400*
056500*
056600 B310-PRR-REPORT-31.
056700*
056800     PERFORM R310-REPORT-31
056900        THRU R319-R31-EXIT.
057000     PERFORM P000-PRINT-THE-REPORTS
057100        THRU P999-PTR-EXIT.
057200     GO TO B999-PRR-EXIT.
057300*
057400*
057500*
057600 B320-PRR-REPORT-32.
057700*
057800     PERFORM R320-REPORT-32
057900        THRU R329-R32-EXIT.
058000     PERFORM P000-PRINT-THE-REPORTS
058100        THRU P999-PTR-EXIT.
058200     GO TO B999-PRR-EXIT.
058300*
058400*
058500*
058600 B330-PRR-REPORT-33.
058700*
058800     PERFORM R330-REPORT-33
058900        THRU R339-R33-EXIT.
059000     PERFORM P000-PRINT-THE-REPORTS
059100        THRU P999-PTR-EXIT.
059200     GO TO B999-PRR-EXIT.
059300*
059400*
059500*
059600 B340-PRR-REPORT-34.
059700*
059800     PERFORM R340-REPORT-34
059900        THRU R349-R34-EXIT.
060000     PERFORM P000-PRINT-THE-REPORTS
060100        THRU P999-PTR-EXIT.
060200     GO TO B999-PRR-EXIT.
060300*
060400*
060500*
060600 B350-PRR-REPORT-35.
060700*
060800     PERFORM R350-REPORT-35
060900        THRU R359-R35-EXIT.
061000     PERFORM P000-PRINT-THE-REPORTS
061100        THRU P999-PTR-EXIT.
061200     GO TO B999-PRR-EXIT.
061300*
061400*
061500*
061600 B360-PRR-REPORT-36.
061700*
061800     PERFORM R360-REPORT-36
061900        THRU R369-R36-EXIT.
062000     PERFORM P000-PRINT-THE-REPORTS
062100        THRU P999-PTR-EXIT.
062200     GO TO B999-PRR-EXIT.
062300*
062400*
062500*
062600 B370-PRR-REPORT-37.
062700*
062800     PERFORM R370-REPORT-37
062900        THRU R379-R37-EXIT.
063000     PERFORM P000-PRINT-THE-REPORTS
063100        THRU P999-PTR-EXIT.
063200     GO TO B999-PRR-EXIT.
063300*
063400*
063500*
063600 B380-PRR-REPORT-38.
063700*
063800     PERFORM R380-REPORT-38
063900        THRU R389-R38-EXIT.
064000     PERFORM P000-PRINT-THE-REPORTS
064100        THRU P999-PTR-EXIT.
064200     GO TO B999-PRR-EXIT.
064300*
064400*
064500*
064600 B390-PRR-REPORT-39.
064700*
064800     PERFORM R390-REPORT-39
064900        THRU R399-R39-EXIT.
065000     PERFORM P000-PRINT-THE-REPORTS
065100        THRU P999-PTR-EXIT.
065200     GO TO B999-PRR-EXIT.
065300*
065400*
065500*
065600 B400-PRR-REPORT-40.
065700*
065800     PERFORM R400-REPORT-40
065900        THRU R409-R40-EXIT.
066000     PERFORM P000-PRINT-THE-REPORTS
066100        THRU P999-PTR-EXIT.
066200     GO TO B999-PRR-EXIT.
066300*
066400*
066500*
066600 B410-PRR-REPORT-41.
066700*
066800     PERFORM R410-REPORT-41
066900        THRU R419-R41-EXIT.
067000     PERFORM P000-PRINT-THE-REPORTS
067100        THRU P999-PTR-EXIT.
067200     GO TO B999-PRR-EXIT.
067300*
067400*
067500*
067600 B420-PRR-REPORT-42.
067700*
067800     PERFORM R420-REPORT-42
067900        THRU R429-R42-EXIT.
068000     PERFORM P000-PRINT-THE-REPORTS
068100        THRU P999-PTR-EXIT.
068200     GO TO B999-PRR-EXIT.
068300*
068400*
068500*
068600 B430-PRR-REPORT-43.
068700*
068800     PERFORM R430-REPORT-43
068900        THRU R439-R43-EXIT.
069000     PERFORM P000-PRINT-THE-REPORTS
069100        THRU P999-PTR-EXIT.
069200     GO TO B999-PRR-EXIT.
069300*
069400*
069500*
069600 B440-PRR-REPORT-44.
069700*
069800     PERFORM R440-REPORT-44
069900        THRU R449-R44-EXIT.
070000     PERFORM P000-PRINT-THE-REPORTS
070100        THRU P999-PTR-EXIT.
070200     GO TO B999-PRR-EXIT.
070300*
070400*
070500*
070600 B450-PRR-REPORT-45.
070700*
070800     PERFORM R450-REPORT-45
070900        THRU R459-R45-EXIT.
071000     PERFORM P000-PRINT-THE-REPORTS
071100        THRU P999-PTR-EXIT.
071200     GO TO B999-PRR-EXIT.
071300*
071400*
071500*
071600 B460-PRR-REPORT-46.
071700*
071800     PERFORM R460-REPORT-46
071900        THRU R469-R46-EXIT.
072000     PERFORM P000-PRINT-THE-REPORTS
072100        THRU P999-PTR-EXIT.
072200     GO TO B999-PRR-EXIT.
072300*
072400*
072500*
072600 B470-PRR-REPORT-47.
072700*
072800     PERFORM R470-REPORT-47
072900        THRU R479-R47-EXIT.
073000     PERFORM P000-PRINT-THE-REPORTS
073100        THRU P999-PTR-EXIT.
073200     GO TO B999-PRR-EXIT.
073300*
073400*
073500*
073600 B480-PRR-REPORT-48.
073700*
073800     PERFORM R480-REPORT-48
073900        THRU R489-R48-EXIT.
074000     PERFORM P000-PRINT-THE-REPORTS
074100        THRU P999-PTR-EXIT.
074200     GO TO B999-PRR-EXIT.
074300*
074400*
074500*
074600 B490-PRR-REPORT-49.
074700*
074800     PERFORM R490-REPORT-49
074900        THRU R499-R49-EXIT.
075000     PERFORM P000-PRINT-THE-REPORTS
075100        THRU P999-PTR-EXIT.
075200     GO TO B999-PRR-EXIT.
075300*
075400*
075500*
075600 B500-PRR-REPORT-50.
075700     GO TO B999-PRR-EXIT.
075800 B510-PRR-REPORT-51.
075900     GO TO B999-PRR-EXIT.
076000 B520-PRR-REPORT-52.
076100     GO TO B999-PRR-EXIT.
076200 B530-PRR-REPORT-53.
076300     GO TO B999-PRR-EXIT.
076400 B540-PRR-REPORT-54.
076500     GO TO B999-PRR-EXIT.
076600*
076700*
076800*
076900 B550-PRR-REPORT-55.
077000*
077100     PERFORM R550-REPORT-55
077200        THRU R559-R55-EXIT.
077300     PERFORM P000-PRINT-THE-REPORTS
077400        THRU P999-PTR-EXIT.
077500     GO TO B999-PRR-EXIT.
077600*
077700*
077800*
077900 B560-PRR-REPORT-56.
078000*
078100     PERFORM R560-REPORT-56
078200        THRU R569-R56-EXIT.
078300     PERFORM P000-PRINT-THE-REPORTS
078400        THRU P999-PTR-EXIT.
078500     GO TO B999-PRR-EXIT.
078600*
078700*
078800*
078900 B570-PRR-REPORT-57.
079000*
079100     PERFORM R570-REPORT-57
079200        THRU R579-R57-EXIT.
079300     PERFORM P000-PRINT-THE-REPORTS
079400        THRU P999-PTR-EXIT.
079500     GO TO B999-PRR-EXIT.
079600*
079700*
079800*
079900 B580-PRR-REPORT-58.
080000*
080100     PERFORM R580-REPORT-58
080200        THRU R589-R58-EXIT.
080300     PERFORM P000-PRINT-THE-REPORTS
080400        THRU P999-PTR-EXIT.
080500     GO TO B999-PRR-EXIT.
080600*
080700*
080800*
080900 B590-PRR-REPORT-59.
081000*
081100     PERFORM R590-REPORT-59
081200        THRU R599-R59-EXIT.
081300     PERFORM P000-PRINT-THE-REPORTS
081400        THRU P999-PTR-EXIT.
081500     GO TO B999-PRR-EXIT.
081600*
081700*
081800*
081900 B600-PRR-REPORT-60.
082000     GO TO B999-PRR-EXIT.
082100 B610-PRR-REPORT-61.
082200     GO TO B999-PRR-EXIT.
082300 B620-PRR-REPORT-62.
082400     GO TO B999-PRR-EXIT.
082500 B630-PRR-REPORT-63.
082600     GO TO B999-PRR-EXIT.
082700 B640-PRR-REPORT-64.
082800     GO TO B999-PRR-EXIT.
082900 B650-PRR-REPORT-65.
083000     GO TO B999-PRR-EXIT.
083100 B660-PRR-REPORT-66.
083200     GO TO B999-PRR-EXIT.
083300 B670-PRR-REPORT-67.
083400     GO TO B999-PRR-EXIT.
083500 B680-PRR-REPORT-68.
083600     GO TO B999-PRR-EXIT.
083700 B690-PRR-REPORT-69.
083800     GO TO B999-PRR-EXIT.
083900*
084000*
084100*
084200 B700-PRR-REPORT-70.
084300     GO TO B999-PRR-EXIT.
084400 B710-PRR-REPORT-71.
084500     GO TO B999-PRR-EXIT.
084600 B720-PRR-REPORT-72.
084700     GO TO B999-PRR-EXIT.
084800 B730-PRR-REPORT-73.
084900     GO TO B999-PRR-EXIT.
085000 B740-PRR-REPORT-74.
085100     GO TO B999-PRR-EXIT.
085200 B750-PRR-REPORT-75.
085300     GO TO B999-PRR-EXIT.
085400 B760-PRR-REPORT-76.
085500     GO TO B999-PRR-EXIT.
085600 B770-PRR-REPORT-77.
085700     GO TO B999-PRR-EXIT.
085800 B780-PRR-REPORT-78.
085900     GO TO B999-PRR-EXIT.
086000 B790-PRR-REPORT-79.
086100     GO TO B999-PRR-EXIT.
086200*
086300*
086400*
086500 B800-PRR-REPORT-80.
086600     GO TO B999-PRR-EXIT.
086700 B810-PRR-REPORT-81.
086800     GO TO B999-PRR-EXIT.
086900 B820-PRR-REPORT-82.
087000     GO TO B999-PRR-EXIT.
087100 B830-PRR-REPORT-83.
087200     GO TO B999-PRR-EXIT.
087300 B840-PRR-REPORT-84.
087400     GO TO B999-PRR-EXIT.
087500*
087600*
087700*
087800 B850-PRR-REPORT-85.
087900     PERFORM R850-REPORT-85
088000        THRU R859-R85-EXIT.
088100     PERFORM P000-PRINT-THE-REPORTS
088200        THRU P999-PTR-EXIT.
088300     GO TO B999-PRR-EXIT.
088400*
088500*
088600*
088700 B860-PRR-REPORT-86.
088800     PERFORM R860-REPORT-86
088900        THRU R869-R86-EXIT.
089000     PERFORM P000-PRINT-THE-REPORTS
089100        THRU P999-PTR-EXIT.
089200     GO TO B999-PRR-EXIT.
089300*
089400*
089500*
089600 B870-PRR-REPORT-87.
089700     PERFORM R870-REPORT-87
089800        THRU R879-R87-EXIT.
089900     PERFORM P000-PRINT-THE-REPORTS
090000        THRU P999-PTR-EXIT.
090100     GO TO B999-PRR-EXIT.
090200*
090300*
090400*
090500 B880-PRR-REPORT-88.
090600     PERFORM R880-REPORT-88
090700        THRU R889-R88-EXIT.
090800     PERFORM P000-PRINT-THE-REPORTS
090900        THRU P999-PTR-EXIT.
091000     GO TO B999-PRR-EXIT.
091100*
091200*
091300*
091400 B890-PRR-REPORT-89.
091500     PERFORM R890-REPORT-89
091600        THRU R899-R89-EXIT.
091700     PERFORM P000-PRINT-THE-REPORTS
091800        THRU P999-PTR-EXIT.
091900     GO TO B999-PRR-EXIT.
092000*
092100*
092200*
092300 B900-PRR-REPORT-90.
092400     PERFORM R900-REPORT-90
092500        THRU R909-R90-EXIT.
092600     PERFORM P000-PRINT-THE-REPORTS
092700        THRU P999-PTR-EXIT.
092800     GO TO B999-PRR-EXIT.
092900*
093000*
093100*
093200 B910-PRR-REPORT-91.
093300     PERFORM R910-REPORT-91
093400        THRU R919-R91-EXIT.
093500     PERFORM P000-PRINT-THE-REPORTS
093600        THRU P999-PTR-EXIT.
093700     GO TO B999-PRR-EXIT.
093800*
093900*
094000*
094100 B920-PRR-REPORT-92.
094200     PERFORM R920-REPORT-92
094300        THRU R929-R92-EXIT.
094400     PERFORM P000-PRINT-THE-REPORTS
094500        THRU P999-PTR-EXIT.
094600     GO TO B999-PRR-EXIT.
094700*
094800*
094900*
095000 B930-PRR-REPORT-93.
095100     PERFORM R930-REPORT-93
095200        THRU R939-R93-EXIT.
095300     PERFORM P000-PRINT-THE-REPORTS
095400        THRU P999-PTR-EXIT.
095500     GO TO B999-PRR-EXIT.
095600*
095700*
095800*
095900 B999-PRR-EXIT.
096000     EXIT.
096100/
096200 C000-PROCESS-USER-REPORTS SECTION.
096300 C001-PUR-BEGIN.
096400*
096500     GO TO C010-PUR-REPORT-01
096600           C020-PUR-REPORT-02
096700           C030-PUR-REPORT-03
096800           C040-PUR-REPORT-04
096900           C050-PUR-REPORT-05
097000           C060-PUR-REPORT-06
097100           C070-PUR-REPORT-07
097200           C080-PUR-REPORT-08
097300           C090-PUR-REPORT-09
097400           C100-PUR-REPORT-10
097500           C110-PUR-REPORT-11
097600           C120-PUR-REPORT-12
097700           C130-PUR-REPORT-13
097800           C140-PUR-REPORT-14
097900           C150-PUR-REPORT-15
098000           C160-PUR-REPORT-16
098100           C170-PUR-REPORT-17
098200           C180-PUR-REPORT-18
098300           C190-PUR-REPORT-19
098400           C200-PUR-REPORT-20
098500           C210-PUR-REPORT-21
098600           C220-PUR-REPORT-22
098700           C230-PUR-REPORT-23
098800           C240-PUR-REPORT-24
098900           DEPENDING ON MTRF-K1-RPT-NBR.
099000*
099100     GO TO C999-PUR-EXIT.
099200*
099300*
099400*
099500 C010-PUR-REPORT-01.
099600*
099700     PERFORM U010-REPORT-01
099800        THRU U019-U01-EXIT.
099900     PERFORM P000-PRINT-THE-REPORTS
100000        THRU P999-PTR-EXIT.
100100     GO TO C999-PUR-EXIT.
100200*
100300*
100400*
100500 C020-PUR-REPORT-02.
100600*
100700     PERFORM U020-REPORT-02
100800        THRU U029-U02-EXIT.
100900     PERFORM P000-PRINT-THE-REPORTS
101000        THRU P999-PTR-EXIT.
101100     GO TO C999-PUR-EXIT.
101200*
101300*
101400*
101500 C030-PUR-REPORT-03.
101600*
101700     PERFORM U030-REPORT-03
101800        THRU U039-U03-EXIT.
101900     PERFORM P000-PRINT-THE-REPORTS
102000        THRU P999-PTR-EXIT.
102100     GO TO C999-PUR-EXIT.
102200*
102300*
102400*
102500 C040-PUR-REPORT-04.
102600*
102700     PERFORM U040-REPORT-04
102800        THRU U049-U04-EXIT.
102900     PERFORM P000-PRINT-THE-REPORTS
103000        THRU P999-PTR-EXIT.
103100     GO TO C999-PUR-EXIT.
103200*
103300*
103400*
103500 C050-PUR-REPORT-05.
103600*
103700     PERFORM U050-REPORT-05
103800        THRU U059-U05-EXIT.
103900     PERFORM P000-PRINT-THE-REPORTS
104000        THRU P999-PTR-EXIT.
104100     GO TO C999-PUR-EXIT.
104200*
104300*
104400*
104500 C060-PUR-REPORT-06.
104600*
104700     PERFORM U060-REPORT-06
104800        THRU U069-U06-EXIT.
104900     PERFORM P000-PRINT-THE-REPORTS
105000        THRU P999-PTR-EXIT.
105100     GO TO C999-PUR-EXIT.
105200*
105300*
105400*
105500 C070-PUR-REPORT-07.
105600*
105700     PERFORM U070-REPORT-07
105800        THRU U079-U07-EXIT.
105900     PERFORM P000-PRINT-THE-REPORTS
106000        THRU P999-PTR-EXIT.
106100     GO TO C999-PUR-EXIT.
106200*
106300*
106400*
106500 C080-PUR-REPORT-08.
106600*
106700     PERFORM U080-REPORT-08
106800        THRU U089-U08-EXIT.
106900     PERFORM P000-PRINT-THE-REPORTS
107000        THRU P999-PTR-EXIT.
107100     GO TO C999-PUR-EXIT.
107200*
107300*
107400*
107500 C090-PUR-REPORT-09.
107600*
107700     PERFORM U090-REPORT-09
107800        THRU U099-U09-EXIT.
107900     PERFORM P000-PRINT-THE-REPORTS
108000        THRU P999-PTR-EXIT.
108100     GO TO C999-PUR-EXIT.
108200*
108300*
108400*
108500 C100-PUR-REPORT-10.
108600*
108700     PERFORM U100-REPORT-10
108800        THRU U109-U10-EXIT.
108900     PERFORM P000-PRINT-THE-REPORTS
109000        THRU P999-PTR-EXIT.
109100     GO TO C999-PUR-EXIT.
109200*
109300*
109400*
109500 C110-PUR-REPORT-11.
109600*
109700     PERFORM U110-REPORT-11
109800        THRU U119-U11-EXIT.
109900     PERFORM P000-PRINT-THE-REPORTS
110000        THRU P999-PTR-EXIT.
110100     GO TO C999-PUR-EXIT.
110200*
110300*
110400*
110500 C120-PUR-REPORT-12.
110600*
110700     PERFORM U120-REPORT-12
110800        THRU U129-U12-EXIT.
110900     PERFORM P000-PRINT-THE-REPORTS
111000        THRU P999-PTR-EXIT.
111100     GO TO C999-PUR-EXIT.
111200*
111300*
111400*
111500 C130-PUR-REPORT-13.
111600*
111700     PERFORM U130-REPORT-13
111800        THRU U139-U13-EXIT.
111900     PERFORM P000-PRINT-THE-REPORTS
112000        THRU P999-PTR-EXIT.
112100     GO TO C999-PUR-EXIT.
112200*
112300*
112400*
112500 C140-PUR-REPORT-14.
112600*
112700     PERFORM U140-REPORT-14
112800        THRU U149-U14-EXIT.
112900     PERFORM P000-PRINT-THE-REPORTS
113000        THRU P999-PTR-EXIT.
113100     GO TO C999-PUR-EXIT.
113200*
113300*
113400*
113500 C150-PUR-REPORT-15.
113600*
113700     PERFORM U150-REPORT-15
113800        THRU U159-U15-EXIT.
113900     PERFORM P000-PRINT-THE-REPORTS
114000        THRU P999-PTR-EXIT.
114100     GO TO C999-PUR-EXIT.
114200*
114300*
114400*
114500 C160-PUR-REPORT-16.
114600*
114700     PERFORM U160-REPORT-16
114800        THRU U169-U16-EXIT.
114900     PERFORM P000-PRINT-THE-REPORTS
115000        THRU P999-PTR-EXIT.
115100     GO TO C999-PUR-EXIT.
115200*
115300*
115400*
115500 C170-PUR-REPORT-17.
115600*
115700     PERFORM U170-REPORT-17
115800        THRU U179-U17-EXIT.
115900     PERFORM P000-PRINT-THE-REPORTS
116000        THRU P999-PTR-EXIT.
116100     GO TO C999-PUR-EXIT.
116200*
116300*
116400*
116500 C180-PUR-REPORT-18.
116600*
116700     PERFORM U180-REPORT-18
116800        THRU U189-U18-EXIT.
116900     PERFORM P000-PRINT-THE-REPORTS
117000        THRU P999-PTR-EXIT.
117100     GO TO C999-PUR-EXIT.
117200*
117300*
117400*
117500 C190-PUR-REPORT-19.
117600*
117700     PERFORM U190-REPORT-19
117800        THRU U199-U19-EXIT.
117900     PERFORM P000-PRINT-THE-REPORTS
118000        THRU P999-PTR-EXIT.
118100     GO TO C999-PUR-EXIT.
118200*
118300*
118400*
118500 C200-PUR-REPORT-20.
118600*
118700     PERFORM U200-REPORT-20
118800        THRU U209-U20-EXIT.
118900     PERFORM P000-PRINT-THE-REPORTS
119000        THRU P999-PTR-EXIT.
119100     GO TO C999-PUR-EXIT.
119200*
119300*
119400*
119500 C210-PUR-REPORT-21.
119600*
119700     PERFORM U210-REPORT-21
119800        THRU U219-U21-EXIT.
119900     PERFORM P000-PRINT-THE-REPORTS
120000        THRU P999-PTR-EXIT.
120100     GO TO C999-PUR-EXIT.
120200*
120300*
120400*
120500 C220-PUR-REPORT-22.
120600*
120700     PERFORM U220-REPORT-22
120800        THRU U229-U22-EXIT.
120900     PERFORM P000-PRINT-THE-REPORTS
121000        THRU P999-PTR-EXIT.
121100     GO TO C999-PUR-EXIT.
121200*
121300*
121400*
121500 C230-PUR-REPORT-23.
121600*
121700     PERFORM U230-REPORT-23
121800        THRU U239-U23-EXIT.
121900     PERFORM P000-PRINT-THE-REPORTS
122000        THRU P999-PTR-EXIT.
122100     GO TO C999-PUR-EXIT.
122200*
122300*
122400*
122500 C240-PUR-REPORT-24.
122600*
122700     PERFORM U240-REPORT-24
122800        THRU U249-U24-EXIT.
122900     PERFORM P000-PRINT-THE-REPORTS
123000        THRU P999-PTR-EXIT.
123100     GO TO C999-PUR-EXIT.
123200*
123300*
123400*
123500 C999-PUR-EXIT.
123600     EXIT.
123700/
123800 P000-PRINT-THE-REPORTS SECTION.
123900 P010-PTR-BEGIN.
124000*
124100     PERFORM MB22PD-DRIVER-PRINT-LINES
124200        THRU MB22PD-DPL-EXIT.
124300*
124400 P999-PTR-EXIT.
124500     EXIT.
124600/
124700 R010-REPORT-01 SECTION.
124800 R011-R01-BEGIN.
124900*
125000     CALL MB00WS-MBD72001        USING MB22WS-LINK-DATA
125100                                       MTRF-RECORD.
125200*
125300 R019-R01-EXIT.
125400     EXIT.
125500*
125600*
125700*
125800 R020-REPORT-02 SECTION.
125900 R021-R02-BEGIN.
126000*
126100     CALL MB00WS-MBD72002        USING MB22WS-LINK-DATA
126200                                       MTRF-RECORD.
126300*
126400 R029-R02-EXIT.
126500     EXIT.
126600*
126700*
126800*
126900 R030-REPORT-03 SECTION.
127000 R031-R03-BEGIN.
127100*
127200     CALL MB00WS-MBD72003        USING MB22WS-LINK-DATA
127300                                       MTRF-RECORD.
127400*
127500 R039-R03-EXIT.
127600     EXIT.
127700*
127800*
127900*
128000 R040-REPORT-04 SECTION.
128100 R041-R04-BEGIN.
128200*
128300     CALL MB00WS-MBD72004        USING MB22WS-LINK-DATA
128400                                       MTRF-RECORD.
128500*
128600 R049-R04-EXIT.
128700     EXIT.
128800/
128900 R050-REPORT-05 SECTION.
129000 R051-R05-BEGIN.
129100*
129200     CALL MB00WS-MBD72005        USING MB22WS-LINK-DATA
129300                                       MTRF-RECORD.
129400*
129500 R059-R05-EXIT.
129600     EXIT.
129700*
129800*
129900*
130000 R060-REPORT-06 SECTION.
130100 R061-R06-BEGIN.
130200*
130300     CALL MB00WS-MBD72006        USING MB22WS-LINK-DATA
130400                                       MTRF-RECORD.
130500*
130600 R069-R06-EXIT.
130700     EXIT.
130800*
130900*
131000*
131100 R070-REPORT-07 SECTION.
131200 R071-R07-BEGIN.
131300*
131400     CALL MB00WS-MBD72007        USING MB22WS-LINK-DATA
131500                                       MTRF-RECORD.
131600*
131700 R079-R07-EXIT.
131800     EXIT.
131900*
132000*
132100*
132200 R080-REPORT-08 SECTION.
132300 R081-R08-BEGIN.
132400*
132500     CALL MB00WS-MBD72008        USING MB22WS-LINK-DATA
132600                                       MTRF-RECORD.
132700*
132800 R089-R08-EXIT.
132900     EXIT.
133000*
133100*
133200*
133300 R090-REPORT-09 SECTION.
133400 R091-R09-BEGIN.
133500*
133600     CALL MB00WS-MBD72009        USING MB22WS-LINK-DATA
133700                                       MTRF-RECORD.
133800*
133900 R099-R09-EXIT.
134000     EXIT.
134100/
134200 R100-REPORT-10 SECTION.
134300 R101-R10-BEGIN.
134400*
134500     CALL MB00WS-MBD72010        USING MB22WS-LINK-DATA
134600                                       MTRF-RECORD.
134700*
134800 R109-R10-EXIT.
134900     EXIT.
135000*
135100*
135200*
135300 R110-REPORT-11 SECTION.
135400 R111-R11-BEGIN.
135500*
135600     CALL MB00WS-MBD72011        USING MB22WS-LINK-DATA
135700                                       MTRF-RECORD.
135800*
135900 R119-R11-EXIT.
136000     EXIT.
136100*
136200*
136300*
136400 R120-REPORT-12 SECTION.
136500 R121-R12-BEGIN.
136600*
136700     CALL MB00WS-MBD72012        USING MB22WS-LINK-DATA
136800                                       MTRF-RECORD.
136900*
137000 R129-R12-EXIT.
137100     EXIT.
137200*
137300*
137400*
137500 R130-REPORT-13 SECTION.
137600 R131-R13-BEGIN.
137700*
137800     CALL MB00WS-MBD72013        USING MB22WS-LINK-DATA
137900                                       MTRF-RECORD.
138000*
138100 R139-R13-EXIT.
138200     EXIT.
138300*
138400*
138500*
138600 R140-REPORT-14 SECTION.
138700 R141-R14-BEGIN.
138800*
138900     CALL MB00WS-MBD72014        USING MB22WS-LINK-DATA
139000                                       MTRF-RECORD.
139100*
139200 R149-R14-EXIT.
139300     EXIT.
139400/
139500 R150-REPORT-15 SECTION.
139600 R151-R15-BEGIN.
139700*
139800     CALL MB00WS-MBD72015        USING MB22WS-LINK-DATA
139900                                       MTRF-RECORD.
140000*
140100 R159-R15-EXIT.
140200     EXIT.
140300*
140400*
140500*
140600 R160-REPORT-16 SECTION.
140700 R161-R16-BEGIN.
140800*
140900     CALL MB00WS-MBD72016        USING MB22WS-LINK-DATA
141000                                       MTRF-RECORD.
141100*
141200 R169-R16-EXIT.
141300     EXIT.
141400*
141500*
141600*
141700 R170-REPORT-17 SECTION.
141800 R171-R17-BEGIN.
141900*
142000     CALL MB00WS-MBD72017        USING MB22WS-LINK-DATA
142100                                       MTRF-RECORD.
142200*
142300 R179-R17-EXIT.
142400     EXIT.
142500*
142600*
142700*
142800 R180-REPORT-18 SECTION.
142900 R181-R18-BEGIN.
143000*
143100     CALL MB00WS-MBD72018        USING MB22WS-LINK-DATA
143200                                       MTRF-RECORD.
143300*
143400 R189-R18-EXIT.
143500     EXIT.
143600*
143700*
143800*
143900 R190-REPORT-19 SECTION.
144000 R191-R19-BEGIN.
144100*
144200     CALL MB00WS-MBD72019        USING MB22WS-LINK-DATA
144300                                       MTRF-RECORD.
144400*
144500 R199-R19-EXIT.
144600     EXIT.
144700/
144800 R200-REPORT-20 SECTION.
144900 R201-R20-BEGIN.
145000*
145100     CALL MB00WS-MBD72020        USING MB22WS-LINK-DATA
145200                                       MTRF-RECORD.
145300*
145400 R209-R20-EXIT.
145500     EXIT.
145600*
145700*
145800*
145900 R210-REPORT-21 SECTION.
146000 R211-R21-BEGIN.
146100*
146200     CALL MB00WS-MBD72021        USING MB22WS-LINK-DATA
146300                                       MTRF-RECORD.
146400*
146500 R219-R21-EXIT.
146600     EXIT.
146700*
146800*
146900*
147000 R220-REPORT-22 SECTION.
147100 R221-R22-BEGIN.
147200*
147300     CALL MB00WS-MBD72022        USING MB22WS-LINK-DATA
147400                                       MTRF-RECORD.
147500*
147600 R229-R22-EXIT.
147700     EXIT.
147800*
147900*
148000*
148100 R230-REPORT-23 SECTION.
148200 R231-R23-BEGIN.
148300*
148400     CALL MB00WS-MBD72023        USING MB22WS-LINK-DATA
148500                                       MTRF-RECORD.
148600*
148700 R239-R23-EXIT.
148800     EXIT.
148900*
149000*
149100*
149200 R240-REPORT-24 SECTION.
149300 R241-R24-BEGIN.
149400*
149500     CALL MB00WS-MBD72024        USING MB22WS-LINK-DATA
149600                                       MTRF-RECORD.
149700*
149800 R249-R24-EXIT.
149900     EXIT.
150000/
150100 R250-REPORT-25 SECTION.
150200 R251-R25-BEGIN.
150300*
150400     CALL MB00WS-MBD72025        USING MB22WS-LINK-DATA
150500                                       MTRF-RECORD.
150600*
150700 R259-R25-EXIT.
150800     EXIT.
150900*
151000*
151100*
151200 R260-REPORT-26 SECTION.
151300 R261-R26-BEGIN.
151400*
151500     CALL MB00WS-MBD72026        USING MB22WS-LINK-DATA
151600                                       MTRF-RECORD.
151700*
151800 R269-R26-EXIT.
151900     EXIT.
152000*
152100*
152200*
152300 R270-REPORT-27 SECTION.
152400 R271-R27-BEGIN.
152500*
152600     CALL MB00WS-MBD72027        USING MB22WS-LINK-DATA
152700                                       MTRF-RECORD.
152800*
152900 R279-R27-EXIT.
153000     EXIT.
153100*
153200*
153300*
153400 R280-REPORT-28 SECTION.
153500 R281-R28-BEGIN.
153600*
153700     CALL MB00WS-MBD72028        USING MB22WS-LINK-DATA
153800                                       MTRF-RECORD.
153900*
154000 R289-R28-EXIT.
154100     EXIT.
154200*
154300*
154400*
154500 R290-REPORT-29 SECTION.
154600 R291-R29-BEGIN.
154700*
154800     CALL MB00WS-MBD72029        USING MB22WS-LINK-DATA
154900                                       MTRF-RECORD.
155000*
155100 R299-R29-EXIT.
155200     EXIT.
155300/
155400 R300-REPORT-30 SECTION.
155500 R301-R30-BEGIN.
155600*
155700     CALL MB00WS-MBD72030        USING MB22WS-LINK-DATA
155800                                       MTRF-RECORD.
155900*
156000 R309-R30-EXIT.
156100     EXIT.
156200*
156300*
156400*
156500 R310-REPORT-31 SECTION.
156600 R311-R31-BEGIN.
156700*
156800     CALL MB00WS-MBD72031        USING MB22WS-LINK-DATA
156900                                       MTRF-RECORD.
157000*
157100 R319-R31-EXIT.
157200     EXIT.
157300*
157400*
157500*
157600 R320-REPORT-32 SECTION.
157700 R321-R32-BEGIN.
157800*
157900     CALL MB00WS-MBD72032        USING MB22WS-LINK-DATA
158000                                       MTRF-RECORD.
158100*
158200 R329-R32-EXIT.
158300     EXIT.
158400*
158500*
158600*
158700 R330-REPORT-33 SECTION.
158800 R331-R33-BEGIN.
158900*
159000     CALL MB00WS-MBD72033        USING MB22WS-LINK-DATA
159100                                       MTRF-RECORD.
159200*
159300 R339-R33-EXIT.
159400     EXIT.
159500*
159600*
159700*
159800 R340-REPORT-34 SECTION.
159900 R341-R34-BEGIN.
160000*
160100     CALL MB00WS-MBD72034        USING MB22WS-LINK-DATA
160200                                       MTRF-RECORD.
160300*
160400 R349-R34-EXIT.
160500     EXIT.
160600/
160700 R350-REPORT-35 SECTION.
160800 R351-R35-BEGIN.
160900*
161000     CALL MB00WS-MBD72035        USING MB22WS-LINK-DATA
161100                                       MTRF-RECORD.
161200*
161300 R359-R35-EXIT.
161400     EXIT.
161500*
161600*
161700*
161800 R360-REPORT-36 SECTION.
161900 R361-R36-BEGIN.
162000*
162100     CALL MB00WS-MBD72036        USING MB22WS-LINK-DATA
162200                                       MTRF-RECORD.
162300*
162400 R369-R36-EXIT.
162500     EXIT.
162600*
162700*
162800*
162900 R370-REPORT-37 SECTION.
163000 R371-R37-BEGIN.
163100*
163200     CALL MB00WS-MBD72037        USING MB22WS-LINK-DATA
163300                                       MTRF-RECORD.
163400*
163500 R379-R37-EXIT.
163600     EXIT.
163700*
163800*
163900*
164000 R380-REPORT-38 SECTION.
164100 R381-R38-BEGIN.
164200*
164300     CALL MB00WS-MBD72038        USING MB22WS-LINK-DATA
164400                                       MTRF-RECORD.
164500*
164600 R389-R38-EXIT.
164700     EXIT.
164800*
164900*
165000*
165100 R390-REPORT-39 SECTION.
165200 R391-R39-BEGIN.
165300*
165400     CALL MB00WS-MBD72039        USING MB22WS-LINK-DATA
165500                                       MTRF-RECORD.
165600*
165700 R399-R39-EXIT.
165800     EXIT.
165900/
166000 R400-REPORT-40 SECTION.
166100 R401-R40-BEGIN.
166200*
166300     CALL MB00WS-MBD72040        USING MB22WS-LINK-DATA
166400                                       MTRF-RECORD.
166500*
166600 R409-R40-EXIT.
166700     EXIT.
166800*
166900*
167000*
167100 R410-REPORT-41 SECTION.
167200 R411-R41-BEGIN.
167300*
167400     CALL MB00WS-MBD72041        USING MB22WS-LINK-DATA
167500                                       MTRF-RECORD.
167600*
167700 R419-R41-EXIT.
167800     EXIT.
167900*
168000*
168100*
168200 R420-REPORT-42 SECTION.
168300 R421-R42-BEGIN.
168400*
168500     CALL MB00WS-MBD72042        USING MB22WS-LINK-DATA
168600                                       MTRF-RECORD.
168700*
168800 R429-R42-EXIT.
168900     EXIT.
169000*
169100*
169200*
169300 R430-REPORT-43 SECTION.
169400 R431-R43-BEGIN.
169500*
169600     CALL MB00WS-MBD72043        USING MB22WS-LINK-DATA
169700                                       MTRF-RECORD.
169800*
169900 R439-R43-EXIT.
170000     EXIT.
170100*
170200*
170300*
170400 R440-REPORT-44 SECTION.
170500 R441-R44-BEGIN.
170600*
170700     CALL MB00WS-MBD72044        USING MB22WS-LINK-DATA
170800                                       MTRF-RECORD.
170900*
171000 R449-R44-EXIT.
171100     EXIT.
171200/
171300 R450-REPORT-45 SECTION.
171400 R451-R45-BEGIN.
171500*
171600     CALL MB00WS-MBD72045        USING MB22WS-LINK-DATA
171700                                       MTRF-RECORD.
171800*
171900 R459-R45-EXIT.
172000     EXIT.
172100*
172200*
172300*
172400 R460-REPORT-46 SECTION.
172500 R461-R46-BEGIN.
172600*
172700     CALL MB00WS-MBD72046        USING MB22WS-LINK-DATA
172800                                       MTRF-RECORD.
172900*
173000 R469-R46-EXIT.
173100     EXIT.
173200*
173300*
173400*
173500 R470-REPORT-47 SECTION.
173600 R471-R47-BEGIN.
173700*
173800     CALL MB00WS-MBD72047        USING MB22WS-LINK-DATA
173900                                       MTRF-RECORD.
174000*
174100 R479-R47-EXIT.
174200     EXIT.
174300*
174400*
174500*
174600 R480-REPORT-48 SECTION.
174700 R481-R48-BEGIN.
174800*
174900     CALL MB00WS-MBD72048        USING MB22WS-LINK-DATA
175000                                       MTRF-RECORD.
175100*
175200 R489-R48-EXIT.
175300     EXIT.
175400*
175500*
175600*
175700 R490-REPORT-49 SECTION.
175800 R491-R49-BEGIN.
175900*
176000     CALL MB00WS-MBD72049        USING MB22WS-LINK-DATA
176100                                       MTRF-RECORD.
176200*
176300 R499-R49-EXIT.
176400     EXIT.
176500/
176600 R550-REPORT-55 SECTION.
176700 R551-R55-BEGIN.
176800*
176900     CALL MB00WS-MBD72055        USING MB22WS-LINK-DATA
177000                                       MTRF-RECORD.
177100*
177200 R559-R55-EXIT.
177300     EXIT.
177400/
177500 R560-REPORT-56 SECTION.
177600 R561-R56-BEGIN.
177700*
177800     CALL MB00WS-MBD72056        USING MB22WS-LINK-DATA
177900                                       MTRF-RECORD.
178000*
178100 R569-R56-EXIT.
178200     EXIT.
178300*
178400*
178500*
178600 R570-REPORT-57 SECTION.
178700 R571-R57-BEGIN.
178800*
178900     CALL MB00WS-MBD72057        USING MB22WS-LINK-DATA
179000                                       MTRF-RECORD.
179100*
179200 R579-R57-EXIT.
179300     EXIT.
179400*
179500*
179600*
179700 R580-REPORT-58 SECTION.
179800 R581-R58-BEGIN.
179900*
180000     CALL MB00WS-MBD72058        USING MB22WS-LINK-DATA
180100                                       MTRF-RECORD.
180200*
180300 R589-R58-EXIT.
180400     EXIT.
180500*
180600*
180700*
180800 R590-REPORT-59 SECTION.
180900 R591-R59-BEGIN.
181000*
181100     CALL MB00WS-MBD72059        USING MB22WS-LINK-DATA
181200                                       MTRF-RECORD.
181300*
181400 R599-R59-EXIT.
181500     EXIT.
181600/
181700 R850-REPORT-85 SECTION.
181800 R851-R85-BEGIN.
181900*
182000     CALL MB00WS-MBD72085        USING MB22WS-LINK-DATA
182100                                       MTRF-RECORD.
182200*
182300 R859-R85-EXIT.
182400     EXIT.
182500*
182600*
182700*
182800 R860-REPORT-86 SECTION.
182900 R861-R86-BEGIN.
183000*
183100     CALL MB00WS-MBD72086        USING MB22WS-LINK-DATA
183200                                       MTRF-RECORD.
183300*
183400 R869-R86-EXIT.
183500     EXIT.
183600*
183700*
183800*
183900 R870-REPORT-87 SECTION.
184000 R871-R87-BEGIN.
184100*
184200     CALL MB00WS-MBD72087        USING MB22WS-LINK-DATA
184300                                       MTRF-RECORD.
184400*
184500 R879-R87-EXIT.
184600     EXIT.
184700*
184800*
184900*
185000 R880-REPORT-88 SECTION.
185100 R881-R88-BEGIN.
185200*
185300     CALL MB00WS-MBD72088        USING MB22WS-LINK-DATA
185400                                       MTRF-RECORD.
185500*
185600 R889-R88-EXIT.
185700     EXIT.
185800*
185900*
186000*
186100 R890-REPORT-89 SECTION.
186200 R891-R89-BEGIN.
186300*
186400     CALL MB00WS-MBD72089        USING MB22WS-LINK-DATA
186500                                       MTRF-RECORD.
186600*
186700 R899-R89-EXIT.
186800     EXIT.
186900/
187000 R900-REPORT-90 SECTION.
187100 R901-R90-BEGIN.
187200*
187300     CALL MB00WS-MBD72090        USING MB22WS-LINK-DATA
187400                                       MTRF-RECORD.
187500*
187600 R909-R90-EXIT.
187700     EXIT.
187800*
187900*
188000*
188100 R910-REPORT-91 SECTION.
188200 R911-R91-BEGIN.
188300*
188400     CALL MB00WS-MBD72091        USING MB22WS-LINK-DATA
188500                                       MTRF-RECORD.
188600*
188700 R919-R91-EXIT.
188800     EXIT.
188900*
189000*
189100*
189200 R920-REPORT-92 SECTION.
189300 R921-R92-BEGIN.
189400*
189500     CALL MB00WS-MBD72092        USING MB22WS-LINK-DATA
189600                                       MTRF-RECORD.
189700*
189800 R929-R92-EXIT.
189900     EXIT.
190000*
190100*
190200*
190300 R930-REPORT-93 SECTION.
190400 R931-R93-BEGIN.
190500*
190600     CALL MB00WS-MBD72093        USING MB22WS-LINK-DATA
190700                                       MTRF-RECORD.
190800*
190900 R939-R93-EXIT.
191000     EXIT.
191100/
191200 U010-REPORT-01 SECTION.
191300 U011-U01-BEGIN.
191400*
191500     CALL MB00WS-MBD73001        USING MB22WS-LINK-DATA
191600                                       MTRF-RECORD.
191700*
191800 U019-U01-EXIT.
191900     EXIT.
192000*
192100*
192200*
192300 U020-REPORT-02 SECTION.
192400 U021-U02-BEGIN.
192500*
192600     CALL MB00WS-MBD73002        USING MB22WS-LINK-DATA
192700                                       MTRF-RECORD.
192800*
192900 U029-U02-EXIT.
193000     EXIT.
193100*
193200*
193300*
193400 U030-REPORT-03 SECTION.
193500 U031-U03-BEGIN.
193600*
193700     CALL MB00WS-MBD73003        USING MB22WS-LINK-DATA
193800                                       MTRF-RECORD.
193900*
194000 U039-U03-EXIT.
194100     EXIT.
194200*
194300*
194400*
194500 U040-REPORT-04 SECTION.
194600 U041-U04-BEGIN.
194700*
194800     CALL MB00WS-MBD73004        USING MB22WS-LINK-DATA
194900                                       MTRF-RECORD.
195000*
195100 U049-U04-EXIT.
195200     EXIT.
195300/
195400 U050-REPORT-05 SECTION.
195500 U051-U05-BEGIN.
195600*
195700     CALL MB00WS-MBD73005        USING MB22WS-LINK-DATA
195800                                       MTRF-RECORD.
195900*
196000 U059-U05-EXIT.
196100     EXIT.
196200*
196300*
196400*
196500 U060-REPORT-06 SECTION.
196600 U061-U06-BEGIN.
196700*
196800     CALL MB00WS-MBD73006        USING MB22WS-LINK-DATA
196900                                       MTRF-RECORD.
197000*
197100 U069-U06-EXIT.
197200     EXIT.
197300*
197400*
197500*
197600 U070-REPORT-07 SECTION.
197700 U071-U07-BEGIN.
197800*
197900     CALL MB00WS-MBD73007        USING MB22WS-LINK-DATA
198000                                       MTRF-RECORD.
198100*
198200 U079-U07-EXIT.
198300     EXIT.
198400*
198500*
198600*
198700 U080-REPORT-08 SECTION.
198800 U081-U08-BEGIN.
198900*
199000     CALL MB00WS-MBD73008        USING MB22WS-LINK-DATA
199100                                       MTRF-RECORD.
199200*
199300 U089-U08-EXIT.
199400     EXIT.
199500*
199600*
199700*
199800 U090-REPORT-09 SECTION.
199900 U091-U09-BEGIN.
200000*
200100     CALL MB00WS-MBD73009        USING MB22WS-LINK-DATA
200200                                       MTRF-RECORD.
200300*
200400 U099-U09-EXIT.
200500     EXIT.
200600/
200700 U100-REPORT-10 SECTION.
200800 U101-U10-BEGIN.
200900*
201000     CALL MB00WS-MBD73010        USING MB22WS-LINK-DATA
201100                                       MTRF-RECORD.
201200*
201300 U109-U10-EXIT.
201400     EXIT.
201500*
201600*
201700*
201800 U110-REPORT-11 SECTION.
201900 U111-U11-BEGIN.
202000*
202100     CALL MB00WS-MBD73011        USING MB22WS-LINK-DATA
202200                                       MTRF-RECORD.
202300*
202400 U119-U11-EXIT.
202500     EXIT.
202600*
202700*
202800*
202900 U120-REPORT-12 SECTION.
203000 U121-U12-BEGIN.
203100*
203200     CALL MB00WS-MBD73012        USING MB22WS-LINK-DATA
203300                                       MTRF-RECORD.
203400*
203500 U129-U12-EXIT.
203600     EXIT.
203700*
203800*
203900*
204000 U130-REPORT-13 SECTION.
204100 U131-U13-BEGIN.
204200*
204300     CALL MB00WS-MBD73013        USING MB22WS-LINK-DATA
204400                                       MTRF-RECORD.
204500*
204600 U139-U13-EXIT.
204700     EXIT.
204800*
204900*
205000*
205100 U140-REPORT-14 SECTION.
205200 U141-U14-BEGIN.
205300*
205400     CALL MB00WS-MBD73014        USING MB22WS-LINK-DATA
205500                                       MTRF-RECORD.
205600*
205700 U149-U14-EXIT.
205800     EXIT.
205900/
206000 U150-REPORT-15 SECTION.
206100 U151-U15-BEGIN.
206200*
206300     CALL MB00WS-MBD73015        USING MB22WS-LINK-DATA
206400                                       MTRF-RECORD.
206500*
206600 U159-U15-EXIT.
206700     EXIT.
206800*
206900*
207000*
207100 U160-REPORT-16 SECTION.
207200 U161-U16-BEGIN.
207300*
207400     CALL MB00WS-MBD73016        USING MB22WS-LINK-DATA
207500                                       MTRF-RECORD.
207600*
207700 U169-U16-EXIT.
207800     EXIT.
207900*
208000*
208100*
208200 U170-REPORT-17 SECTION.
208300 U171-U17-BEGIN.
208400*
208500     CALL MB00WS-MBD73017        USING MB22WS-LINK-DATA
208600                                       MTRF-RECORD.
208700*
208800 U179-U17-EXIT.
208900     EXIT.
209000*
209100*
209200*
209300 U180-REPORT-18 SECTION.
209400 U181-U18-BEGIN.
209500*
209600     CALL MB00WS-MBD73018        USING MB22WS-LINK-DATA
209700                                       MTRF-RECORD.
209800*
209900 U189-U18-EXIT.
210000     EXIT.
210100*
210200*
210300*
210400 U190-REPORT-19 SECTION.
210500 U191-U19-BEGIN.
210600*
210700     CALL MB00WS-MBD73019        USING MB22WS-LINK-DATA
210800                                       MTRF-RECORD.
210900*
211000 U199-U19-EXIT.
211100     EXIT.
211200/
211300 U200-REPORT-20 SECTION.
211400 U201-U20-BEGIN.
211500*
211600     CALL MB00WS-MBD73020        USING MB22WS-LINK-DATA
211700                                       MTRF-RECORD.
211800*
211900 U209-U20-EXIT.
212000     EXIT.
212100*
212200*
212300*
212400 U210-REPORT-21 SECTION.
212500 U211-U21-BEGIN.
212600*
212700     CALL MB00WS-MBD73021        USING MB22WS-LINK-DATA
212800                                       MTRF-RECORD.
212900*
213000 U219-U21-EXIT.
213100     EXIT.
213200*
213300*
213400*
213500 U220-REPORT-22 SECTION.
213600 U221-U22-BEGIN.
213700*
213800     CALL MB00WS-MBD73022        USING MB22WS-LINK-DATA
213900                                       MTRF-RECORD.
214000*
214100 U229-U22-EXIT.
214200     EXIT.
214300*
214400*
214500*
214600 U230-REPORT-23 SECTION.
214700 U231-U23-BEGIN.
214800*
214900     CALL MB00WS-MBD73023        USING MB22WS-LINK-DATA
215000                                       MTRF-RECORD.
215100*
215200 U239-U23-EXIT.
215300     EXIT.
215400*
215500*
215600*
215700 U240-REPORT-24 SECTION.
215800 U241-U24-BEGIN.
215900*
216000     CALL MB00WS-MBD73024        USING MB22WS-LINK-DATA
216100                                       MTRF-RECORD.
216200*
216300 U249-U24-EXIT.
216400     EXIT.
216500/
216600 Z100-READ-CONTROL-CARD SECTION.
216700 Z100-RCC-BEGIN.
216800*
216900     MOVE 'R1CC'                 TO SS02WS-ABEND-LOCATION.
217000     SET MTCCRB-READ-SEQ         TO TRUE.
217100     PERFORM MB00PD-MTCC-ACCESS
217200        THRU MB00PD-MTCC-ACCESS-EXIT.
217300*
217400     IF  SS02WS-FS-END-OF-FILE
217500         MOVE 'ALL'              TO MTCC-RECORD
217600         MOVE 'MBD720'           TO MTCC-PROGRAM-ID
217700         GO TO Z199-RCC-EXIT.
217800*
217900     MOVE MTCCIO-RECORD          TO MTCC-RECORD.
218000*
218100     IF  MTCC-PROGRAM-ID IS EQUAL TO SS02WS-ABEND-PROG-ID
218200         GO TO Z199-RCC-EXIT.
218300*
218400     MOVE SPACES                 TO MTCC-RECORD.
218500*
218600 Z199-RCC-EXIT.
218700     EXIT.
218800/
218900 9000-PERFORMED-ROUTINES-SECT SECTION.
219000*
219100     COPY MB00PD REPLACING ==:MB00:== BY ==MTCC==.
219200/
219300     COPY MB00PD REPLACING ==:MB00:== BY ==MTRF==.
219400/
219500     COPY MB20PD.
219600/
219700     COPY MB22PD1.
219800/
219900     COPY SS02PD.
220000/
220100     COPY SS07PD.
220200/
220300     COPY SS08PD.
220400/
220500     COPY SS16PD.
220600/
220700     COPY SS26PD.
220800/
220900     COPY SS27PD.
221000*
221100 9995-END-SOURCE-STATEMENTS SECTION.
221200 9999-END-OF-PROGRAM.
221300     EXIT.
