000100 IDENTIFICATION DIVISION.
000200 PROGRAM-ID. MBD72001.
000201*       RELEASE DATE=08/24/01.        REVISION LEVEL=08.06      * ++++++++
000202***************************************************************** ++++++++
000203*WARNING.  THIS COMPUTER PROGRAM IS PROTECTED BY COPYRIGHT LAW  * ++++++++
000204*AND INTERNATIONAL TREATIES.  UNAUTHORIZED REPRODUCTION OR      * ++++++++
000205*DISTRIBUTION OF THIS PROGRAM, OR ANY PORTION OF IT, MAY RESULT * ++++++++
000206*IN SEVERE CIVIL AND CRIMINAL PENATLIES, AND WILL BE PROSECUTED * ++++++++
000207*TO THE MAXIMUM EXTENT POSSIBLE UNDER THE LAW.                  * ++++++++
000208*COPYRIGHT 1999 PAYSYS INTERNATIONAL, INC.  ALL RIGHTS RESERVED.* ++++++++
000209***************************************************************** ++++++++
000300*****************************************************************
000400*                                                               *
000500*   V - PLUS  M E R C H A N T   B A N K C A R D   S Y S T E M   *
000600*                                                               *
000700*       MBD72001 - OPTIONAL REPORT 01 SUBROUTINE                *
000800*                                                               *
000900*****************************************************************
001000 ENVIRONMENT DIVISION.
001100 CONFIGURATION SECTION.
001200 SOURCE-COMPUTER.            IBM-4341.
001300 OBJECT-COMPUTER.            IBM-4341.
001400/
001500 DATA DIVISION.
001600 WORKING-STORAGE SECTION.
001700*
001800 01  FILLER                  PIC  X(12)      VALUE '** WS-BEG **'.
001900*
002000 01  WS-MBD72001-WORK-AREAS.
002100     03  WS-D72001-ACTIVITY-SW
002200                             PIC  X(01)      VALUE 'N'.
002300     03  WS-D720-LINE-CHECK  PIC S9(05)      COMP-3 VALUE +34.
002400*
002500*****************************************************
002600*    THE VALUE FOR THE FOLLWING LEVEL INDICES ARE:  *
002700*       1 - ORGANIZATION                            *
002800*       2 - MERCHANT                                *
002900*       3 - STORE, PLAN OR T/C                      *
003000*                                                   *
003100*    THE VALUE FOR THE FOLLWING ITEM INDICES ARE:   *
003200*       1 - DEPOSITS DEBITS                         *
003300*       2 - DEPOSITS CREDIT                         *
003400*       3 - RESERVES DEBITS                         *
003500*       4 - RESERVES CREDIT                         *
003600*       5 - DISCOUNT DEBITS                         *
003700*       6 - DISCOUNT CREDIT                         *
003800*       7 - PARTICIPTION DEBITS                     *
003900*       8 - PARTICIPTION CREDIT                     *
004000*       9 - SYSTEM ADJUSTMENTS DEBITS               *
004100*      10 - SYSTEM ADJUSTMENTS CREDIT               *
004200*      11 - RECOVERY ADJUSTMENTS DEBITS             *
004300*      12 - RECOVERY ADJUSTMENTS CREDIT             *
004400*      13 - SYSTEM FEES DEBIT                       *
004500*      14 - SYSTEM FEES CREDIT                      *
004600*      15 - USER FEES DEBIT                         *
004700*      16 - USER FEES CREDIT                        *
004800*      17 - INTERCHANGE FEES DEBITS                 *
004900*      18 - INTERCHANGE FEES CREDIT                 *
005000*      19 - USER CREDITS DEBITS                     *
005100*      20 - USER CREDITS CREDIT                     *
005200*      21 - TRANSFER TO BILLING/INVOICE DEBITS      *
005300*      22 - TRANSFER TO BILLING/INVOICE CREDITS     *
005400*      23 - HOLDOVER DEBITS                         *
005500*      24 - HOLDOVER CREDITS                        *
005600*      25 - SETTLEMENT DEBITS -- ACH                *
005700*      26 - SETTLEMENT CREDITS - ACH                *
005800*      27 - SETTLEMENT DEBITS -- CHECK              *
005900*      28 - SETTLEMENT CREDITS - CHECK              *
006000*      29 - SETTLEMENT DEBITS -- WIRE TRANSFER      *
006100*      30 - SETTLEMENT CREDITS - WIRE TRANSFER      *
006200*      31 - SETTLEMENT DEBITS -- MANUAL             *
006300*      32 - SETTLEMENT CREDITS - MANUAL             *
006400*      33 - SETTLEMENT DEBITS -- BILLING/INVOICE    *
006500*      34 - SETTLEMENT CREDITS - BILLING/INVOICE    *
006600*      35 - SETTLEMENT DEBITS -- WINDOW             *
006700*      36 - SETTLEMENT CREDITS - WINDOW             *
006800*      37 - WINDOW TRANSACTIONS DEBITS              *
006900*      38 - WINDOW TRANSACTIONS CREDIT              *
007000*      39 - DEPOSIT MEMOS DEBITS                    *
007100*      40 - DEPOSIT MEMOS CREDIT                    *
007200*      41 - AUTHORIZATION DECLINES                  *
007300*      42 - AUTHORIZATION APPROVALS                 *
007400*      43 - MEMOS DEBITS                            *
007500*      44 - MEMOS CREDITS                           *
007600*      45 - RESERVE BALANCE DEBITS                  *
007700*      46 - RESERVE BALANCE CREDITS                 *
007800*                                                   *
007900*****************************************************
008000*
008100     03  WS-TOTALS-TABLE.
008200         05  WS-TT-LEVEL                     OCCURS 3 TIMES
008300                                             INDEXED BY
008400                                             X-WS-TT.
008500             07  WS-TT-ITEM                  OCCURS 46 TIMES
008600                                             INDEXED BY
008700                                             X-WS-TT-ITEM.
008800                 09  WS-TT-NBR
008900                             PIC S9(09)      COMP-3.
009000                 09  WS-TT-AMT
009100                             PIC S9(17)      COMP-3.
009200/
009300*****************************************************
009400*    THE VALUE FOR THE FOLLWING ITEM INDICES ARE:   *
009500*       1 - DEPOSITS                                *
009600*       2 - RESERVES                                *
009700*       3 - DISCOUNT                                *
009800*       4 - PARTICIPTION                            *
009900*       5 - SYSTEM ADJUSTMENTS                      *
010000*       6 - RECOVERY ADJUSTMENTS                    *
010100*       7 - SYSTEM FEES DEBIT                       *
010200*       8 - USER FEES DEBIT                         *
010300*       9 - INTERCHANGE FEES                        *
010400*      10 - USER CREDITS                            *
010500*      11 - TRANSFER TO BILLING/INVOICE             *
010600*      12 - HOLDOVER                                *
010700*      13 - SETTLEMENT -- ACH                       *
010800*      14 - SETTLEMENT -- CHECK                     *
010900*      15 - SETTLEMENT -- WIRE TRANSFER             *
011000*      16 - SETTLEMENT -- MANUAL                    *
011100*      17 - SETTLEMENT -- BILLING/INVOICE           *
011200*      18 - SETTLEMENT -- WINDOW                    *
011300*      19 - WINDOW TRANSACTIONS                     *
011400*      20 - DEPOSIT MEMOS                           *
011500*      21 - AUTHORIZATION DECLINES                  *
011600*      22 - MEMOS                                   *
011700*      23 - RESERVE BALANCE                         *
011800*      24 - FUTURE USE                              *
011900*      25 - FUTURE USE                              *
012000*      26 - FUTURE USE                              *
012100*      27 - FUTURE USE                              *
012200*      28 - SETTLEMENT IN SUB-TOTAL                 *
012300*      29 - SETTLEMENT IN TOTALS                    *
012400*      30 - SETTLEMENT OUT TOTALS                   *
012500*                                                   *
012600*****************************************************
012700*
012800     03  WS-TOTAL-ITEM-PRINT-TABLE.
012900         05  WS-TIPT-ITEM                    OCCURS 30 TIMES
013000                                             INDEXED BY
013100                                             X-WS-TIPT-ITEM.
013200             07  WS-TIPT-ITEM-FLAG
013300                             PIC  X(01)      VALUE 'N'.
013400                 88  WS-TIPT-IF-PRINT        VALUE 'Y'.
013500                 88  WS-TIPT-IF-NO-PRINT     VALUE 'N'.
013600*
013700*
013800     03  WS-HOLD-MER-NBR     PIC  9(09)      VALUE ZERO.
013900/
014000     COPY MB20WS.
014100*
014200 01  WS-DETAIL-LINE-1        REDEFINES MB20WS-PRINT-LINE.
014300     03  FILLER              PIC  X(01).
014400     03  WS-DL1-MER-NBR      PIC  9(09).
014500     03  FILLER              PIC  X(01).
014600     03  WS-DL1-STORE-NBR    PIC  9(09).
014700     03  FILLER              PIC  X(02).
014800     03  WS-DL1-TC-NBR       PIC  9(03).
014900     03  FILLER              PIC  X(01).
015000     03  WS-DL1-LM-NBR       PIC  9(03).
015100     03  FILLER              PIC  X(01).
015200     03  WS-DL1-CP-NBR       PIC  9(02).
015300     03  FILLER              PIC  X(01).
015400     03  WS-DL1-QL-NBR       PIC  9(02).
015500     03  FILLER              PIC  X(01).
015600     03  WS-DL1-PLAN-NBR     PIC  9(05).
015700     03  FILLER              PIC  X(01).
015800     03  WS-DL1-WINDOW       PIC  X(01).
015900     03  FILLER              PIC  X(01).
016000     03  WS-DL1-DATE         PIC  X(10).
016100     03  FILLER              PIC  X(01).
016200     03  WS-DL1-SOURCE-NBR   PIC  9(05).
016300     03  FILLER              PIC  X(02).
016400     03  WS-DL1-NBR          PIC  9(05).
016500     03  FILLER              PIC  X(01).
016600     03  WS-DL1-SEQ-NBR      PIC  9(08).
016700     03  FILLER              PIC  X(03).
016800     03  WS-DL1-GL-NBR       PIC  9(01).
016900     03  FILLER              PIC  X(01).
017000     03  WS-DL1-NBR-ITEMS    PIC  X(12).
017100     03  FILLER              PIC  X(01).
017200     03  WS-DL1-TRANS-AMT    PIC  X(21).
017300     03  WS-DL1-DESCRIPTION  PIC  X(15).
017400*
017500 01  WS-MERCHANT-TOTAL-LINE-1
017600                             REDEFINES MB20WS-PRINT-LINE.
017700     03  WS-MTL1-LIT-1       PIC  X(43).
017800     03  FILLER              PIC  X(07).
017900     03  WS-MTL1-MER-NBR     PIC  9(09).
018000     03  FILLER              PIC  X(04).
018100     03  WS-MTL1-MER-DESC    PIC  X(40).
018200     03  FILLER              PIC  X(29).
018300*
018400 01  WS-ORG-TOTAL-LINE-1     REDEFINES MB20WS-PRINT-LINE.
018500     03  WS-OTL1-LIT-1       PIC  X(47).
018600     03  FILLER              PIC  X(03).
018700     03  WS-OTL1-ORG-NBR     PIC  9(03).
018800     03  FILLER              PIC  X(10).
018900     03  WS-OTL1-ORG-DESC    PIC  X(40).
019000     03  FILLER              PIC  X(29).
019100*
019200 01  WS-HEADING-TOTAL-LINE-1 REDEFINES MB20WS-PRINT-LINE.
019300     03  FILLER              PIC  X(27).
019400     03  WS-HTL1-LIT-1       PIC  X(38).
019500     03  FILLER              PIC  X(04).
019600     03  WS-HTL1-LIT-2       PIC  X(38).
019700     03  FILLER              PIC  X(25).
019800*
019900 01  WS-TOTAL-LINE-1         REDEFINES MB20WS-PRINT-LINE.
020000     03  FILLER              PIC  X(05).
020100     03  WS-TL1-LIT-1        PIC  X(22).
020200     03  WS-TL1-DR-NBR       PIC  X(12).
020300     03  FILLER              PIC  X(06).
020400     03  WS-TL1-DR-AMT       PIC  X(21).
020500     03  FILLER              PIC  X(04).
020600     03  WS-TL1-CR-NBR       PIC  X(12).
020700     03  FILLER              PIC  X(05).
020800     03  WS-TL1-CR-AMT       PIC  X(21).
020900     03  FILLER              PIC  X(24).
021000/
021100     COPY SS95WS.
021200/
021300     COPY MTRFWS REPLACING ==:MTRF:== BY ==MTRF==.
021400/
021500     COPY MTRFRL REPLACING ==:MTRF:== BY ==MWRF==.
021600/
021700     COPY MTPTRL REPLACING ==:MTPT:== BY ==MTPT==.
021800/
021900     COPY MMTCWS.
022000/
022100     COPY MTP0RL REPLACING ==:MTP0:== BY ==MTR0==.
022200/
022300     COPY MTP0RL REPLACING ==:MTP0:== BY ==MTR1==.
022400/
022500     COPY MTP0RL REPLACING ==:MTP0:== BY ==MTR2==.
022600/
022700     COPY MTP0RL REPLACING ==:MTP0:== BY ==MTR3==.
022800/
022900     COPY MTP0RL REPLACING ==:MTP0:== BY ==MTR4==.
023000/
023100     COPY MTP0RL REPLACING ==:MTP0:== BY ==MTR5==.
023200/
023300     COPY MTP0RL REPLACING ==:MTP0:== BY ==MTR6==.
023400/
023500     COPY MTP0RL REPLACING ==:MTP0:== BY ==MTR7==.
023600/
023700     COPY MTP0RL REPLACING ==:MTP0:== BY ==MTR8==.
023800/
023900     COPY MTP0RL REPLACING ==:MTP0:== BY ==MTR9==.
024000/
024100     COPY MB00WS.
024200/
024300     COPY SS00WS.
024400/
024500     COPY SS01WS.
024600/
024700     COPY SS02WS.
024800*
024900 01  FILLER                  PIC  X(12)      VALUE '** WS-END **'.
025000/
025100 LINKAGE SECTION.
025200     COPY MB22WS.
025300/
025400     COPY MTRFRL REPLACING ==:MTRF:== BY ==MTRF==.
025500/
025600 PROCEDURE DIVISION              USING MB22WS-LINK-DATA
025700                                       MTRF-RECORD.
025800*
025900 A000-MAIN-LINE-SECT SECTION.
026000 A010-ML-BEGIN.
026100*
026200     IF  MTRF-K1-RT-DETAIL
026300         PERFORM D000-DETAIL-RECORD
026400            THRU D099-DR-EXIT.
026500*
026600     IF  MTRF-K1-RT-HEADER
026700         PERFORM H000-HEADER-RECORD
026800            THRU H099-HR-EXIT.
026900*
027000     IF  MTRF-K1-RT-TRAILER
027100         PERFORM T000-TRAILER-RECORD
027200            THRU T099-TR-EXIT.
027300*
027400     GOBACK.
027500*
027600 A099-ML-EXIT.
027700     EXIT.
027800/
027900 D000-DETAIL-RECORD SECTION.
028000 D010-DR-BEGIN.
028100*
028200     MOVE 'Y'                    TO WS-D72001-ACTIVITY-SW.
028300*
028400     MOVE MTRF-MT-TRANSACTION    TO MTPT-RECORD.
028500*
028600     IF  MTPT-MERCHANT   IS NOT EQUAL TO WS-HOLD-MER-NBR
028700     AND WS-HOLD-MER-NBR IS GREATER THAN ZERO
028800         PERFORM 9100-CHECK-NBR-LINES
028900            THRU 9100-CNL-EXIT
029000         PERFORM 9020-PRINT-MER-TOTALS
029100            THRU 9020-PMT-EXIT
029200         PERFORM 9080-ZERO-MER-ACCUMS
029300            THRU 9080-ZMA-EXIT
029400         PERFORM MB22PD-PRINT-1-LINE
029500            THRU MB22PD-P1L-EXIT.
029600*
029700     MOVE MTPT-MERCHANT          TO WS-HOLD-MER-NBR.
029800*
029900     MOVE MTPT-MERCHANT          TO WS-DL1-MER-NBR.
030000     MOVE MTPT-STORE             TO WS-DL1-STORE-NBR.
030100     MOVE MTPT-TRANS-CODE        TO WS-DL1-TC-NBR.
030200     MOVE MTPT-LOGIC-MODULE      TO WS-DL1-LM-NBR.
030300     MOVE MTPT-PRODUCT           TO WS-DL1-CP-NBR.
030400     MOVE MTPT-QUAL-LEVEL        TO WS-DL1-QL-NBR.
030500     MOVE MTPT-PLAN              TO WS-DL1-PLAN-NBR.
030600*
030700     IF  MTPT-SETTLED-WINDOW
030800         MOVE MTPT-SETT-FLAG     TO WS-DL1-WINDOW.
030900*
031000     MOVE MTPT-BATCH-DATE        TO SS01WS-JULIAN.
031100     PERFORM SS26PD-NUMERICALLY-EDIT-DATE
031200        THRU SS26PD-NED-EXIT.
031300     MOVE SS01WS-XX-XX-YYYY      TO WS-DL1-DATE.
031400     MOVE MTPT-BATCH-SOURCE      TO WS-DL1-SOURCE-NBR.
031500     MOVE MTPT-BATCH-NBR         TO WS-DL1-NBR.
031600     MOVE MTPT-BATCH-SEQ         TO WS-DL1-SEQ-NBR.
031700     MOVE MTPT-GL-SOURCE         TO WS-DL1-GL-NBR.
031800*
031900     MOVE MTPT-NBR-ITEMS         TO SS95WS-IN-NBR.
032000     PERFORM SS95PD-NAP-ROUTINE
032100        THRU SS95PD-NAP-EXIT.
032200     MOVE SS95WS-OUT-NBR-L12     TO WS-DL1-NBR-ITEMS.
032300*
032400     MOVE MTPT-AMOUNT            TO SS95WS-IN-AMT.
032500     PERFORM SS95PD-NAP-ROUTINE
032600        THRU SS95PD-NAP-EXIT.
032700     MOVE SS95WS-OUT-AMT-L20     TO WS-DL1-TRANS-AMT.
032800*
032900     MOVE MTPT-RPT-DESC          TO WS-DL1-DESCRIPTION.
033000*
033100     PERFORM 9050-ACCUMULATE-TOTALS
033200        THRU 9050-AT-EXIT.
033300*
033400     EVALUATE TRUE
033500         WHEN MTRF-K1-DETAIL
033600             PERFORM MB22PD-PRINT-1-LINE
033700                THRU MB22PD-P1L-EXIT
033800         WHEN OTHER
033900             MOVE SPACES         TO MB20WS-PRINT-LINE
034000     END-EVALUATE.
034100*
034200     MOVE MTRF-RECORD            TO MWRF-RECORD.
034300*
034400 D099-DR-EXIT.
034500     EXIT.
034600/
034700 H000-HEADER-RECORD SECTION.
034800 H010-HR-BEGIN.
034900*
035000     MOVE MTRF-K1-FORM           TO MB20WS-FORM-CODE.
035100     MOVE MTRF-HD-DATE-FORMAT    TO SS01WS-DATE-FORMAT.
035200     MOVE MTRF-HD-FICHE-FLAG     TO MB20WS-FICHE-CODE.
035300     MOVE MTRF-HD-SYSTEM-NAME    TO MB20WS-SH-SYSTEM.
035400     MOVE MTRF-HD-REPORT-ID      TO MB20WS-SH-RPT-ID.
035500     MOVE 'O01'                  TO MB20WS-SH-INTERNAL-RPT-ID.
035600     MOVE MTRF-K1-ORG            TO MB20WS-SH-ORG.
035700     MOVE MTRF-HD-ORG-NAME       TO MB20WS-SH-ORG-NAME.
035800     MOVE MTRF-HD-RPT-TITLE      TO MB20WS-SH-RPT-NAME.
035900     MOVE MTRF-HD-FILE-DATE      TO SS01WS-JULIAN.
036000     PERFORM SS26PD-NUMERICALLY-EDIT-DATE
036100        THRU SS26PD-NED-EXIT.
036200     MOVE SS01WS-XX-XX-YYYY      TO MB20WS-SH-FILE-DATE.
036300     MOVE MTRF-HD-REPORT-DEST-ID TO MB20WS-SH-DEST-ID.
036400     MOVE MTRF-HD-DEST-DESC      TO MB20WS-SH-DEST-DESC.
036500*
036600     MOVE '  MERCHANT   STORE   *-- POSTING DATA ---*  '
036700                                 TO MB20WS-SH-L5R-1.
036800     MOVE '*----- BATCH INFORMATION ------*           N'
036900                                 TO MB20WS-SH-L5R-2.
037000     MOVE 'UMBER         TRANSACTION                   '
037100                                 TO MB20WS-SH-L5R-3.
037200*
037300     MOVE '   NUMBER   NUMBER    T/C L/M PR QL  PLAN   '
037400                                 TO MB20WS-SH-L6R-1.
037500     MOVE '   DATE   SOURCE   NBR     SEQ    G/L       '
037600                                 TO MB20WS-SH-L6R-2.
037700     MOVE 'ITEMS            AMOUNT       DESCRIPTION   '
037800                                 TO MB20WS-SH-L6R-3.
037900*
038000     MOVE ZERO                   TO MB20WS-PAGE-COUNT.
038100     MOVE MB20WS-FORCE-PAGE      TO MB20WS-LINE-COUNT.
038200     MOVE MTRF-HD-LINES-PER-PAGE TO MB20WS-LINES-PER-PAGE.
038300     MOVE MTRF-HD-CURRENCY-NOD   TO MTRFWS-SAVE-CURRENCY-NOD.
038400     MOVE MTRF-HD-PER-ITEM-NOD   TO MTRFWS-SAVE-PER-ITEM-NOD.
038500     MOVE MTRF-HD-PERCENT-NOD    TO MTRFWS-SAVE-PERCENT-NOD.
038600     SET SS95WS-FUNCTION-INITIALIZE
038700                                 TO TRUE.
038800     PERFORM SS95PD-NAP-ROUTINE
038900        THRU SS95PD-NAP-EXIT.
039000*
039100     MOVE MTRF-HD-CURRENCY-CODE  TO SS95WS-CURRENCY-CODE.
039200     SET SS95WS-NAP-IND-IS-ALL   TO TRUE.
039300     MOVE 'N'                    TO WS-D72001-ACTIVITY-SW.
039400     MOVE MTRF-RECORD            TO MTR9-RECORD.
039500     MOVE SPACES                 TO MWRF-RECORD.
039600     MOVE ZERO                   TO MWRF-MERCHANT.
039700     PERFORM 9070-ZERO-ORG-ACCUMS
039800        THRU 9070-ZOA-EXIT.
039900     PERFORM 9080-ZERO-MER-ACCUMS
040000        THRU 9080-ZMA-EXIT.
040100     PERFORM 9090-ZERO-STORE-ACCUMS
040200        THRU 9090-ZSA-EXIT.
040300     MOVE ZERO                   TO WS-HOLD-MER-NBR.
040400*
040500*****               111111111122222222223
040600*****      123456789012345678901234567890
040700     MOVE 'YYYYYYYYYYNNNNNNNNYYYYYNNNNNYN'
040800                                 TO WS-TOTAL-ITEM-PRINT-TABLE.
040900*
041000     MOVE 5                      TO WS-D720-LINE-CHECK.
041100*
041200     PERFORM
041300         VARYING X-WS-TIPT-ITEM FROM 1 BY 1
041400         UNTIL   X-WS-TIPT-ITEM IS GREATER THAN 30
041500         IF  WS-TIPT-IF-PRINT (X-WS-TIPT-ITEM)
041600             ADD  1              TO WS-D720-LINE-CHECK
041700         END-IF
041800     END-PERFORM.
041900*
042000     IF  WS-TIPT-IF-PRINT (28)
042100         ADD  1                  TO WS-D720-LINE-CHECK.
042200*
042300     IF  WS-TIPT-IF-PRINT (29)
042400         ADD  1                  TO WS-D720-LINE-CHECK.
042500*
042600     IF  WS-TIPT-IF-PRINT (30)
042700         ADD  1                  TO WS-D720-LINE-CHECK.
042800*
042900 H099-HR-EXIT.
043000     EXIT.
043100/
043200 T000-TRAILER-RECORD SECTION.
043300 T010-TR-BEGIN.
043400*
043500     MOVE MTR9-RECORD            TO MTRF-RECORD.
043600*
043700     IF  WS-D72001-ACTIVITY-SW IS EQUAL TO 'N'
043800         IF  MTRF-HD-AF-PRODUCE
043900             PERFORM MB22PD-PRINT-NO-ACTIVITY
044000                THRU MB22PD-PNA-EXIT
044100             GO TO T099-TR-EXIT
044200         ELSE
044300             GO TO T099-TR-EXIT.
044400*
044500***************************************************************
044600*    WE MUST NOW PRINT MERCHANT TOTALS. THE REASON FOR THIS IS*
044700*    WE COULD HAVE PRINTED SEVERAL DETAIL RECORDS AND THEN    *
044800*    ENCOUNTERED A TRAILER RECORD WITH OUT HAVING  PROCESSED  *
044900*    THE MERCHANT BREAK/TOTALING LOGIC. THIS CODE WILL FORCE  *
045000*    A MERCHANT TOTAL TO BE PRINTED.                          *
045100***************************************************************
045200*
045300     PERFORM 9100-CHECK-NBR-LINES
045400        THRU 9100-CNL-EXIT.
045500*
045600     PERFORM 9020-PRINT-MER-TOTALS
045700        THRU 9020-PMT-EXIT.
045800*
045900     PERFORM 9080-ZERO-MER-ACCUMS
046000        THRU 9080-ZMA-EXIT.
046100*
046200     PERFORM 9100-CHECK-NBR-LINES
046300        THRU 9100-CNL-EXIT.
046400*
046500     PERFORM 9010-PRINT-ORG-TOTALS
046600        THRU 9010-POT-EXIT.
046700*
046800 T099-TR-EXIT.
046900     EXIT.
047000/
047100 9000-PERFORMED-ROUTINES-SECT SECTION.
047200 9010-PRINT-ORG-TOTALS.
047300*
047400     PERFORM MB22PD-PRINT-1-LINE
047500        THRU MB22PD-P1L-EXIT.
047600*
047700     MOVE SPACES                 TO MB20WS-SH-LINE-5
047800                                    MB20WS-SH-LINE-6
047900                                    MB20WS-SH-LINE-7
048000                                    MB20WS-SH-LINE-8.
048100*
048200     MOVE '**** ORGANIZATION TOTALS ****  FOR ORGANIZATION'
048300                                 TO WS-OTL1-LIT-1.
048400     MOVE MTRF-K1-ORG            TO WS-OTL1-ORG-NBR.
048500     MOVE MTRF-HD-ORG-NAME       TO WS-OTL1-ORG-DESC.
048600     PERFORM MB22PD-PRINT-1-LINE
048700        THRU MB22PD-P1L-EXIT.
048800*
048900     SET X-WS-TT                 TO 1.
049000     PERFORM 9030-PRINT-TOTALS
049100        THRU 9030-PT-EXIT.
049200*
049300 9010-POT-EXIT.
049400     EXIT.
049500/
049600 9020-PRINT-MER-TOTALS.
049700*
049800     PERFORM MB22PD-PRINT-1-LINE
049900        THRU MB22PD-P1L-EXIT.
050000*
050100     MOVE '**** MERCHANT TOTALS ****      FOR MERCHANT    '
050200                                 TO WS-MTL1-LIT-1.
050300     MOVE MWRF-MERCHANT          TO WS-MTL1-MER-NBR.
050400     MOVE MWRF-NAME              TO WS-MTL1-MER-DESC.
050500     PERFORM MB22PD-PRINT-1-LINE
050600        THRU MB22PD-P1L-EXIT.
050700*
050800     SET X-WS-TT                 TO 2.
050900     PERFORM 9030-PRINT-TOTALS
051000        THRU 9030-PT-EXIT.
051100*
051200 9020-PMT-EXIT.
051300     EXIT.
051400/
051500 9030-PRINT-TOTALS.
051600*
051700     MOVE '*-------------- DEBITS -------------*'
051800                                 TO WS-HTL1-LIT-1.
051900     MOVE '*------------- CREDITS -------------*'
052000                                 TO WS-HTL1-LIT-2.
052100     PERFORM MB22PD-PRINT-1-LINE
052200        THRU MB22PD-P1L-EXIT.
052300*
052400     MOVE 'DEPOSITS              '
052500                                 TO WS-TL1-LIT-1.
052600     MOVE WS-TT-NBR (X-WS-TT 1)  TO SS95WS-IN-NBR.
052700     MOVE WS-TT-AMT (X-WS-TT 1)  TO SS95WS-IN-AMT.
052800     PERFORM SS95PD-NAP-ROUTINE
052900        THRU SS95PD-NAP-EXIT.
053000     MOVE SS95WS-OUT-NBR-L12     TO WS-TL1-DR-NBR.
053100     MOVE SS95WS-OUT-AMT-L20     TO WS-TL1-DR-AMT.
053200*
053300     MOVE WS-TT-NBR (X-WS-TT 2)  TO SS95WS-IN-NBR.
053400     MOVE WS-TT-AMT (X-WS-TT 2)  TO SS95WS-IN-AMT.
053500     PERFORM SS95PD-NAP-ROUTINE
053600        THRU SS95PD-NAP-EXIT.
053700     MOVE SS95WS-OUT-NBR-L12     TO WS-TL1-CR-NBR.
053800     MOVE SS95WS-OUT-AMT-L20     TO WS-TL1-CR-AMT.
053900*
054000     IF  WS-TIPT-IF-PRINT (1)
054100         PERFORM MB22PD-PRINT-1-LINE
054200            THRU MB22PD-P1L-EXIT
054300     ELSE
054400         MOVE SPACES             TO MB20WS-PRINT-LINE.
054500*
054600     MOVE 'RESERVES              '
054700                                 TO WS-TL1-LIT-1.
054800     MOVE WS-TT-NBR (X-WS-TT 3)  TO SS95WS-IN-NBR.
054900     MOVE WS-TT-AMT (X-WS-TT 3)  TO SS95WS-IN-AMT.
055000     PERFORM SS95PD-NAP-ROUTINE
055100        THRU SS95PD-NAP-EXIT.
055200     MOVE SS95WS-OUT-NBR-L12     TO WS-TL1-DR-NBR.
055300     MOVE SS95WS-OUT-AMT-L20     TO WS-TL1-DR-AMT.
055400*
055500     MOVE WS-TT-NBR (X-WS-TT 4)  TO SS95WS-IN-NBR.
055600     MOVE WS-TT-AMT (X-WS-TT 4)  TO SS95WS-IN-AMT.
055700     PERFORM SS95PD-NAP-ROUTINE
055800        THRU SS95PD-NAP-EXIT.
055900     MOVE SS95WS-OUT-NBR-L12     TO WS-TL1-CR-NBR.
056000     MOVE SS95WS-OUT-AMT-L20     TO WS-TL1-CR-AMT.
056100*
056200     IF  WS-TIPT-IF-PRINT (2)
056300         PERFORM MB22PD-PRINT-1-LINE
056400            THRU MB22PD-P1L-EXIT
056500     ELSE
056600         MOVE SPACES             TO MB20WS-PRINT-LINE.
056700*
056800     MOVE 'DISCOUNT              '
056900                                 TO WS-TL1-LIT-1.
057000     MOVE WS-TT-NBR (X-WS-TT 5)  TO SS95WS-IN-NBR.
057100     MOVE WS-TT-AMT (X-WS-TT 5)  TO SS95WS-IN-AMT.
057200     PERFORM SS95PD-NAP-ROUTINE
057300        THRU SS95PD-NAP-EXIT.
057400     MOVE SS95WS-OUT-NBR-L12     TO WS-TL1-DR-NBR.
057500     MOVE SS95WS-OUT-AMT-L20     TO WS-TL1-DR-AMT.
057600*
057700     MOVE WS-TT-NBR (X-WS-TT 6)  TO SS95WS-IN-NBR.
057800     MOVE WS-TT-AMT (X-WS-TT 6)  TO SS95WS-IN-AMT.
057900     PERFORM SS95PD-NAP-ROUTINE
058000        THRU SS95PD-NAP-EXIT.
058100     MOVE SS95WS-OUT-NBR-L12     TO WS-TL1-CR-NBR.
058200     MOVE SS95WS-OUT-AMT-L20     TO WS-TL1-CR-AMT.
058300*
058400     IF  WS-TIPT-IF-PRINT (3)
058500         PERFORM MB22PD-PRINT-1-LINE
058600            THRU MB22PD-P1L-EXIT
058700     ELSE
058800         MOVE SPACES             TO MB20WS-PRINT-LINE.
058900*
059000     MOVE 'PARTICIPATION         '
059100                                 TO WS-TL1-LIT-1.
059200     MOVE WS-TT-NBR (X-WS-TT 7)  TO SS95WS-IN-NBR.
059300     MOVE WS-TT-AMT (X-WS-TT 7)  TO SS95WS-IN-AMT.
059400     PERFORM SS95PD-NAP-ROUTINE
059500        THRU SS95PD-NAP-EXIT.
059600     MOVE SS95WS-OUT-NBR-L12     TO WS-TL1-DR-NBR.
059700     MOVE SS95WS-OUT-AMT-L20     TO WS-TL1-DR-AMT.
059800*
059900     MOVE WS-TT-NBR (X-WS-TT 8)  TO SS95WS-IN-NBR.
060000     MOVE WS-TT-AMT (X-WS-TT 8)  TO SS95WS-IN-AMT.
060100     PERFORM SS95PD-NAP-ROUTINE
060200        THRU SS95PD-NAP-EXIT.
060300     MOVE SS95WS-OUT-NBR-L12     TO WS-TL1-CR-NBR.
060400     MOVE SS95WS-OUT-AMT-L20     TO WS-TL1-CR-AMT.
060500*
060600     IF  WS-TIPT-IF-PRINT (4)
060700         PERFORM MB22PD-PRINT-1-LINE
060800            THRU MB22PD-P1L-EXIT
060900     ELSE
061000         MOVE SPACES             TO MB20WS-PRINT-LINE.
061100*
061200     MOVE 'MERCHANT ADJUSTMENTS  '
061300                                 TO WS-TL1-LIT-1.
061400     MOVE WS-TT-NBR (X-WS-TT 9)  TO SS95WS-IN-NBR.
061500     MOVE WS-TT-AMT (X-WS-TT 9)  TO SS95WS-IN-AMT.
061600     PERFORM SS95PD-NAP-ROUTINE
061700        THRU SS95PD-NAP-EXIT.
061800     MOVE SS95WS-OUT-NBR-L12     TO WS-TL1-DR-NBR.
061900     MOVE SS95WS-OUT-AMT-L20     TO WS-TL1-DR-AMT.
062000*
062100     MOVE WS-TT-NBR (X-WS-TT 10) TO SS95WS-IN-NBR.
062200     MOVE WS-TT-AMT (X-WS-TT 10) TO SS95WS-IN-AMT.
062300     PERFORM SS95PD-NAP-ROUTINE
062400        THRU SS95PD-NAP-EXIT.
062500     MOVE SS95WS-OUT-NBR-L12     TO WS-TL1-CR-NBR.
062600     MOVE SS95WS-OUT-AMT-L20     TO WS-TL1-CR-AMT.
062700*
062800     IF  WS-TIPT-IF-PRINT (5)
062900         PERFORM MB22PD-PRINT-1-LINE
063000            THRU MB22PD-P1L-EXIT
063100     ELSE
063200         MOVE SPACES             TO MB20WS-PRINT-LINE.
063300*
063400     MOVE 'RECOVERY ADJUSTMENTS  '
063500                                 TO WS-TL1-LIT-1.
063600     MOVE WS-TT-NBR (X-WS-TT 11) TO SS95WS-IN-NBR.
063700     MOVE WS-TT-AMT (X-WS-TT 11) TO SS95WS-IN-AMT.
063800     PERFORM SS95PD-NAP-ROUTINE
063900        THRU SS95PD-NAP-EXIT.
064000     MOVE SS95WS-OUT-NBR-L12     TO WS-TL1-DR-NBR.
064100     MOVE SS95WS-OUT-AMT-L20     TO WS-TL1-DR-AMT.
064200*
064300     MOVE WS-TT-NBR (X-WS-TT 12) TO SS95WS-IN-NBR.
064400     MOVE WS-TT-AMT (X-WS-TT 12) TO SS95WS-IN-AMT.
064500     PERFORM SS95PD-NAP-ROUTINE
064600        THRU SS95PD-NAP-EXIT.
064700     MOVE SS95WS-OUT-NBR-L12     TO WS-TL1-CR-NBR.
064800     MOVE SS95WS-OUT-AMT-L20     TO WS-TL1-CR-AMT.
064900*
065000     IF  WS-TIPT-IF-PRINT (6)
065100         PERFORM MB22PD-PRINT-1-LINE
065200            THRU MB22PD-P1L-EXIT
065300     ELSE
065400         MOVE SPACES             TO MB20WS-PRINT-LINE.
065500*
065600     MOVE 'SYSTEM FEES           '
065700                                 TO WS-TL1-LIT-1.
065800     MOVE WS-TT-NBR (X-WS-TT 13) TO SS95WS-IN-NBR.
065900     MOVE WS-TT-AMT (X-WS-TT 13) TO SS95WS-IN-AMT.
066000     PERFORM SS95PD-NAP-ROUTINE
066100        THRU SS95PD-NAP-EXIT.
066200     MOVE SS95WS-OUT-NBR-L12     TO WS-TL1-DR-NBR.
066300     MOVE SS95WS-OUT-AMT-L20     TO WS-TL1-DR-AMT.
066400*
066500     MOVE WS-TT-NBR (X-WS-TT 14) TO SS95WS-IN-NBR.
066600     MOVE WS-TT-AMT (X-WS-TT 14) TO SS95WS-IN-AMT.
066700     PERFORM SS95PD-NAP-ROUTINE
066800        THRU SS95PD-NAP-EXIT.
066900     MOVE SS95WS-OUT-NBR-L12     TO WS-TL1-CR-NBR.
067000     MOVE SS95WS-OUT-AMT-L20     TO WS-TL1-CR-AMT.
067100*
067200     IF  WS-TIPT-IF-PRINT (7)
067300         PERFORM MB22PD-PRINT-1-LINE
067400            THRU MB22PD-P1L-EXIT
067500     ELSE
067600         MOVE SPACES             TO MB20WS-PRINT-LINE.
067700*
067800     MOVE 'USER FEES             '
067900                                 TO WS-TL1-LIT-1.
068000     MOVE WS-TT-NBR (X-WS-TT 15) TO SS95WS-IN-NBR.
068100     MOVE WS-TT-AMT (X-WS-TT 15) TO SS95WS-IN-AMT.
068200     PERFORM SS95PD-NAP-ROUTINE
068300        THRU SS95PD-NAP-EXIT.
068400     MOVE SS95WS-OUT-NBR-L12     TO WS-TL1-DR-NBR.
068500     MOVE SS95WS-OUT-AMT-L20     TO WS-TL1-DR-AMT.
068600*
068700     MOVE WS-TT-NBR (X-WS-TT 16) TO SS95WS-IN-NBR.
068800     MOVE WS-TT-AMT (X-WS-TT 16) TO SS95WS-IN-AMT.
068900     PERFORM SS95PD-NAP-ROUTINE
069000        THRU SS95PD-NAP-EXIT.
069100     MOVE SS95WS-OUT-NBR-L12     TO WS-TL1-CR-NBR.
069200     MOVE SS95WS-OUT-AMT-L20     TO WS-TL1-CR-AMT.
069300*
069400     IF  WS-TIPT-IF-PRINT (8)
069500         PERFORM MB22PD-PRINT-1-LINE
069600            THRU MB22PD-P1L-EXIT
069700     ELSE
069800         MOVE SPACES             TO MB20WS-PRINT-LINE.
069900*
070000     MOVE 'INTERCHANGE FEES      '
070100                                 TO WS-TL1-LIT-1.
070200     MOVE WS-TT-NBR (X-WS-TT 17) TO SS95WS-IN-NBR.
070300     MOVE WS-TT-AMT (X-WS-TT 17) TO SS95WS-IN-AMT.
070400     PERFORM SS95PD-NAP-ROUTINE
070500        THRU SS95PD-NAP-EXIT.
070600     MOVE SS95WS-OUT-NBR-L12     TO WS-TL1-DR-NBR.
070700     MOVE SS95WS-OUT-AMT-L20     TO WS-TL1-DR-AMT.
070800*
070900     MOVE WS-TT-NBR (X-WS-TT 18) TO SS95WS-IN-NBR.
071000     MOVE WS-TT-AMT (X-WS-TT 18) TO SS95WS-IN-AMT.
071100     PERFORM SS95PD-NAP-ROUTINE
071200        THRU SS95PD-NAP-EXIT.
071300     MOVE SS95WS-OUT-NBR-L12     TO WS-TL1-CR-NBR.
071400     MOVE SS95WS-OUT-AMT-L20     TO WS-TL1-CR-AMT.
071500*
071600     IF  WS-TIPT-IF-PRINT (9)
071700         PERFORM MB22PD-PRINT-1-LINE
071800            THRU MB22PD-P1L-EXIT
071900     ELSE
072000         MOVE SPACES             TO MB20WS-PRINT-LINE.
072100*
072200     MOVE 'USER CREDITS          '
072300                                 TO WS-TL1-LIT-1.
072400     MOVE WS-TT-NBR (X-WS-TT 19) TO SS95WS-IN-NBR.
072500     MOVE WS-TT-AMT (X-WS-TT 19) TO SS95WS-IN-AMT.
072600     PERFORM SS95PD-NAP-ROUTINE
072700        THRU SS95PD-NAP-EXIT.
072800     MOVE SS95WS-OUT-NBR-L12     TO WS-TL1-DR-NBR.
072900     MOVE SS95WS-OUT-AMT-L20     TO WS-TL1-DR-AMT.
073000*
073100     MOVE WS-TT-NBR (X-WS-TT 20) TO SS95WS-IN-NBR.
073200     MOVE WS-TT-AMT (X-WS-TT 20) TO SS95WS-IN-AMT.
073300     PERFORM SS95PD-NAP-ROUTINE
073400        THRU SS95PD-NAP-EXIT.
073500     MOVE SS95WS-OUT-NBR-L12     TO WS-TL1-CR-NBR.
073600     MOVE SS95WS-OUT-AMT-L20     TO WS-TL1-CR-AMT.
073700*
073800     IF  WS-TIPT-IF-PRINT (10)
073900         PERFORM MB22PD-PRINT-1-LINE
074000            THRU MB22PD-P1L-EXIT
074100     ELSE
074200         MOVE SPACES             TO MB20WS-PRINT-LINE.
074300*
074400     MOVE ALL '-'                TO WS-TL1-DR-NBR.
074500     MOVE ALL '-'                TO WS-TL1-DR-AMT.
074600     MOVE ALL '-'                TO WS-TL1-CR-NBR.
074700     MOVE ALL '-'                TO WS-TL1-CR-AMT.
074800*
074900     IF  WS-TIPT-IF-PRINT (28)
075000         PERFORM MB22PD-PRINT-1-LINE
075100            THRU MB22PD-P1L-EXIT
075200     ELSE
075300         MOVE SPACES             TO MB20WS-PRINT-LINE.
075400*
075500     MOVE '    SUB-TOTAL.........'
075600                                 TO WS-TL1-LIT-1.
075700     COMPUTE SS95WS-IN-NBR       =  WS-TT-NBR (X-WS-TT 1)
075800                                 +  WS-TT-NBR (X-WS-TT 3)
075900                                 +  WS-TT-NBR (X-WS-TT 5)
076000                                 +  WS-TT-NBR (X-WS-TT 7)
076100                                 +  WS-TT-NBR (X-WS-TT 9)
076200                                 +  WS-TT-NBR (X-WS-TT 11)
076300                                 +  WS-TT-NBR (X-WS-TT 13)
076400                                 +  WS-TT-NBR (X-WS-TT 15)
076500                                 +  WS-TT-NBR (X-WS-TT 17)
076600                                 +  WS-TT-NBR (X-WS-TT 19).
076700     COMPUTE SS95WS-IN-AMT       =  WS-TT-AMT (X-WS-TT 1)
076800                                 +  WS-TT-AMT (X-WS-TT 3)
076900                                 +  WS-TT-AMT (X-WS-TT 5)
077000                                 +  WS-TT-AMT (X-WS-TT 7)
077100                                 +  WS-TT-AMT (X-WS-TT 9)
077200                                 +  WS-TT-AMT (X-WS-TT 11)
077300                                 +  WS-TT-AMT (X-WS-TT 13)
077400                                 +  WS-TT-AMT (X-WS-TT 15)
077500                                 +  WS-TT-AMT (X-WS-TT 17)
077600                                 +  WS-TT-AMT (X-WS-TT 19).
077700     PERFORM SS95PD-NAP-ROUTINE
077800        THRU SS95PD-NAP-EXIT.
077900     MOVE SS95WS-OUT-NBR-L12     TO WS-TL1-DR-NBR.
078000     MOVE SS95WS-OUT-AMT-L20     TO WS-TL1-DR-AMT.
078100*
078200     COMPUTE SS95WS-IN-NBR       =  WS-TT-NBR (X-WS-TT 2)
078300                                 +  WS-TT-NBR (X-WS-TT 4)
078400                                 +  WS-TT-NBR (X-WS-TT 6)
078500                                 +  WS-TT-NBR (X-WS-TT 8)
078600                                 +  WS-TT-NBR (X-WS-TT 10)
078700                                 +  WS-TT-NBR (X-WS-TT 12)
078800                                 +  WS-TT-NBR (X-WS-TT 14)
078900                                 +  WS-TT-NBR (X-WS-TT 16)
079000                                 +  WS-TT-NBR (X-WS-TT 18)
079100                                 +  WS-TT-NBR (X-WS-TT 20).
079200     COMPUTE SS95WS-IN-AMT       =  WS-TT-AMT (X-WS-TT 2)
079300                                 +  WS-TT-AMT (X-WS-TT 4)
079400                                 +  WS-TT-AMT (X-WS-TT 6)
079500                                 +  WS-TT-AMT (X-WS-TT 8)
079600                                 +  WS-TT-AMT (X-WS-TT 10)
079700                                 +  WS-TT-AMT (X-WS-TT 12)
079800                                 +  WS-TT-AMT (X-WS-TT 14)
079900                                 +  WS-TT-AMT (X-WS-TT 16)
080000                                 +  WS-TT-AMT (X-WS-TT 18)
080100                                 +  WS-TT-AMT (X-WS-TT 20).
080200     PERFORM SS95PD-NAP-ROUTINE
080300        THRU SS95PD-NAP-EXIT.
080400     MOVE SS95WS-OUT-NBR-L12     TO WS-TL1-CR-NBR.
080500     MOVE SS95WS-OUT-AMT-L20     TO WS-TL1-CR-AMT.
080600*
080700     IF  WS-TIPT-IF-PRINT (28)
080800         PERFORM MB22PD-PRINT-1-LINE
080900            THRU MB22PD-P1L-EXIT
081000     ELSE
081100         MOVE SPACES             TO MB20WS-PRINT-LINE.
081200*
081300     MOVE 'TRANSFER TO INVOICE   '
081400                                 TO WS-TL1-LIT-1.
081500     MOVE WS-TT-NBR (X-WS-TT 21) TO SS95WS-IN-NBR.
081600     MOVE WS-TT-AMT (X-WS-TT 21) TO SS95WS-IN-AMT.
081700     PERFORM SS95PD-NAP-ROUTINE
081800        THRU SS95PD-NAP-EXIT.
081900     MOVE SS95WS-OUT-NBR-L12     TO WS-TL1-DR-NBR.
082000     MOVE SS95WS-OUT-AMT-L20     TO WS-TL1-DR-AMT.
082100*
082200     MOVE WS-TT-NBR (X-WS-TT 22) TO SS95WS-IN-NBR.
082300     MOVE WS-TT-AMT (X-WS-TT 22) TO SS95WS-IN-AMT.
082400     PERFORM SS95PD-NAP-ROUTINE
082500        THRU SS95PD-NAP-EXIT.
082600     MOVE SS95WS-OUT-NBR-L12     TO WS-TL1-CR-NBR.
082700     MOVE SS95WS-OUT-AMT-L20     TO WS-TL1-CR-AMT.
082800*
082900     IF  WS-TIPT-IF-PRINT (11)
083000         PERFORM MB22PD-PRINT-1-LINE
083100            THRU MB22PD-P1L-EXIT
083200     ELSE
083300         MOVE SPACES             TO MB20WS-PRINT-LINE.
083400*
083500     MOVE 'HOLDOVER TRANSACTIONS '
083600                                 TO WS-TL1-LIT-1.
083700     MOVE WS-TT-NBR (X-WS-TT 23) TO SS95WS-IN-NBR.
083800     MOVE WS-TT-AMT (X-WS-TT 23) TO SS95WS-IN-AMT.
083900     PERFORM SS95PD-NAP-ROUTINE
084000        THRU SS95PD-NAP-EXIT.
084100     MOVE SS95WS-OUT-NBR-L12     TO WS-TL1-DR-NBR.
084200     MOVE SS95WS-OUT-AMT-L20     TO WS-TL1-DR-AMT.
084300*
084400     MOVE WS-TT-NBR (X-WS-TT 24) TO SS95WS-IN-NBR.
084500     MOVE WS-TT-AMT (X-WS-TT 24) TO SS95WS-IN-AMT.
084600     PERFORM SS95PD-NAP-ROUTINE
084700        THRU SS95PD-NAP-EXIT.
084800     MOVE SS95WS-OUT-NBR-L12     TO WS-TL1-CR-NBR.
084900     MOVE SS95WS-OUT-AMT-L20     TO WS-TL1-CR-AMT.
085000*
085100     IF  WS-TIPT-IF-PRINT (12)
085200         PERFORM MB22PD-PRINT-1-LINE
085300            THRU MB22PD-P1L-EXIT
085400     ELSE
085500         MOVE SPACES             TO MB20WS-PRINT-LINE.
085600*
085700     MOVE ALL '-'                TO WS-TL1-DR-NBR.
085800     MOVE ALL '-'                TO WS-TL1-DR-AMT.
085900     MOVE ALL '-'                TO WS-TL1-CR-NBR.
086000     MOVE ALL '-'                TO WS-TL1-CR-AMT.
086100*
086200     IF  WS-TIPT-IF-PRINT (29)
086300         PERFORM MB22PD-PRINT-1-LINE
086400            THRU MB22PD-P1L-EXIT
086500     ELSE
086600         MOVE SPACES             TO MB20WS-PRINT-LINE.
086700*
086800     MOVE '*SETTLEMENT IN TOTAL* '
086900                                 TO WS-TL1-LIT-1.
087000     COMPUTE SS95WS-IN-NBR       =  WS-TT-NBR (X-WS-TT 1)
087100                                 +  WS-TT-NBR (X-WS-TT 3)
087200                                 +  WS-TT-NBR (X-WS-TT 5)
087300                                 +  WS-TT-NBR (X-WS-TT 7)
087400                                 +  WS-TT-NBR (X-WS-TT 9)
087500                                 +  WS-TT-NBR (X-WS-TT 11)
087600                                 +  WS-TT-NBR (X-WS-TT 13)
087700                                 +  WS-TT-NBR (X-WS-TT 15)
087800                                 +  WS-TT-NBR (X-WS-TT 17)
087900                                 +  WS-TT-NBR (X-WS-TT 19)
088000                                 +  WS-TT-NBR (X-WS-TT 21)
088100                                 +  WS-TT-NBR (X-WS-TT 23).
088200     COMPUTE SS95WS-IN-AMT       =  WS-TT-AMT (X-WS-TT 1)
088300                                 +  WS-TT-AMT (X-WS-TT 3)
088400                                 +  WS-TT-AMT (X-WS-TT 5)
088500                                 +  WS-TT-AMT (X-WS-TT 7)
088600                                 +  WS-TT-AMT (X-WS-TT 9)
088700                                 +  WS-TT-AMT (X-WS-TT 11)
088800                                 +  WS-TT-AMT (X-WS-TT 13)
088900                                 +  WS-TT-AMT (X-WS-TT 15)
089000                                 +  WS-TT-AMT (X-WS-TT 17)
089100                                 +  WS-TT-AMT (X-WS-TT 19)
089200                                 +  WS-TT-AMT (X-WS-TT 21)
089300                                 +  WS-TT-AMT (X-WS-TT 23).
089400     PERFORM SS95PD-NAP-ROUTINE
089500        THRU SS95PD-NAP-EXIT.
089600     MOVE SS95WS-OUT-NBR-L12     TO WS-TL1-DR-NBR.
089700     MOVE SS95WS-OUT-AMT-L20     TO WS-TL1-DR-AMT.
089800*
089900     COMPUTE SS95WS-IN-NBR       =  WS-TT-NBR (X-WS-TT 2)
090000                                 +  WS-TT-NBR (X-WS-TT 4)
090100                                 +  WS-TT-NBR (X-WS-TT 6)
090200                                 +  WS-TT-NBR (X-WS-TT 8)
090300                                 +  WS-TT-NBR (X-WS-TT 10)
090400                                 +  WS-TT-NBR (X-WS-TT 12)
090500                                 +  WS-TT-NBR (X-WS-TT 14)
090600                                 +  WS-TT-NBR (X-WS-TT 16)
090700                                 +  WS-TT-NBR (X-WS-TT 18)
090800                                 +  WS-TT-NBR (X-WS-TT 20)
090900                                 +  WS-TT-NBR (X-WS-TT 22)
091000                                 +  WS-TT-NBR (X-WS-TT 24).
091100     COMPUTE SS95WS-IN-AMT       =  WS-TT-AMT (X-WS-TT 2)
091200                                 +  WS-TT-AMT (X-WS-TT 4)
091300                                 +  WS-TT-AMT (X-WS-TT 6)
091400                                 +  WS-TT-AMT (X-WS-TT 8)
091500                                 +  WS-TT-AMT (X-WS-TT 10)
091600                                 +  WS-TT-AMT (X-WS-TT 12)
091700                                 +  WS-TT-AMT (X-WS-TT 14)
091800                                 +  WS-TT-AMT (X-WS-TT 16)
091900                                 +  WS-TT-AMT (X-WS-TT 18)
092000                                 +  WS-TT-AMT (X-WS-TT 20)
092100                                 +  WS-TT-AMT (X-WS-TT 22)
092200                                 +  WS-TT-AMT (X-WS-TT 24).
092300     PERFORM SS95PD-NAP-ROUTINE
092400        THRU SS95PD-NAP-EXIT.
092500     MOVE SS95WS-OUT-NBR-L12     TO WS-TL1-CR-NBR.
092600     MOVE SS95WS-OUT-AMT-L20     TO WS-TL1-CR-AMT.
092700*
092800     IF  WS-TIPT-IF-PRINT (29)
092900         PERFORM MB22PD-PRINT-2-LINES
093000            THRU MB22PD-P2L-EXIT
093100     ELSE
093200         MOVE SPACES             TO MB20WS-PRINT-LINE
093300         PERFORM MB22PD-PRINT-1-LINE
093400            THRU MB22PD-P1L-EXIT.
093500*
093600     MOVE 'SETTLEMENT - A C H    '
093700                                 TO WS-TL1-LIT-1.
093800     MOVE WS-TT-NBR (X-WS-TT 25) TO SS95WS-IN-NBR.
093900     MOVE WS-TT-AMT (X-WS-TT 25) TO SS95WS-IN-AMT.
094000     PERFORM SS95PD-NAP-ROUTINE
094100        THRU SS95PD-NAP-EXIT.
094200     MOVE SS95WS-OUT-NBR-L12     TO WS-TL1-DR-NBR.
094300     MOVE SS95WS-OUT-AMT-L20     TO WS-TL1-DR-AMT.
094400*
094500     MOVE WS-TT-NBR (X-WS-TT 26) TO SS95WS-IN-NBR.
094600     MOVE WS-TT-AMT (X-WS-TT 26) TO SS95WS-IN-AMT.
094700     PERFORM SS95PD-NAP-ROUTINE
094800        THRU SS95PD-NAP-EXIT.
094900     MOVE SS95WS-OUT-NBR-L12     TO WS-TL1-CR-NBR.
095000     MOVE SS95WS-OUT-AMT-L20     TO WS-TL1-CR-AMT.
095100*
095200     IF  WS-TIPT-IF-PRINT (13)
095300         PERFORM MB22PD-PRINT-1-LINE
095400            THRU MB22PD-P1L-EXIT
095500     ELSE
095600         MOVE SPACES             TO MB20WS-PRINT-LINE.
095700*
095800     MOVE 'SETTLEMENT - CHECK    '
095900                                 TO WS-TL1-LIT-1.
096000     MOVE WS-TT-NBR (X-WS-TT 27) TO SS95WS-IN-NBR.
096100     MOVE WS-TT-AMT (X-WS-TT 27) TO SS95WS-IN-AMT.
096200     PERFORM SS95PD-NAP-ROUTINE
096300        THRU SS95PD-NAP-EXIT.
096400     MOVE SS95WS-OUT-NBR-L12     TO WS-TL1-DR-NBR.
096500     MOVE SS95WS-OUT-AMT-L20     TO WS-TL1-DR-AMT.
096600*
096700     MOVE WS-TT-NBR (X-WS-TT 28) TO SS95WS-IN-NBR.
096800     MOVE WS-TT-AMT (X-WS-TT 28) TO SS95WS-IN-AMT.
096900     PERFORM SS95PD-NAP-ROUTINE
097000        THRU SS95PD-NAP-EXIT.
097100     MOVE SS95WS-OUT-NBR-L12     TO WS-TL1-CR-NBR.
097200     MOVE SS95WS-OUT-AMT-L20     TO WS-TL1-CR-AMT.
097300*
097400     IF  WS-TIPT-IF-PRINT (14)
097500         PERFORM MB22PD-PRINT-1-LINE
097600            THRU MB22PD-P1L-EXIT
097700     ELSE
097800         MOVE SPACES             TO MB20WS-PRINT-LINE.
097900*
098000     MOVE 'SETTLEMENT - WIRE     '
098100                                 TO WS-TL1-LIT-1.
098200     MOVE WS-TT-NBR (X-WS-TT 29) TO SS95WS-IN-NBR.
098300     MOVE WS-TT-AMT (X-WS-TT 29) TO SS95WS-IN-AMT.
098400     PERFORM SS95PD-NAP-ROUTINE
098500        THRU SS95PD-NAP-EXIT.
098600     MOVE SS95WS-OUT-NBR-L12     TO WS-TL1-DR-NBR.
098700     MOVE SS95WS-OUT-AMT-L20     TO WS-TL1-DR-AMT.
098800*
098900     MOVE WS-TT-NBR (X-WS-TT 30) TO SS95WS-IN-NBR.
099000     MOVE WS-TT-AMT (X-WS-TT 30) TO SS95WS-IN-AMT.
099100     PERFORM SS95PD-NAP-ROUTINE
099200        THRU SS95PD-NAP-EXIT.
099300     MOVE SS95WS-OUT-NBR-L12     TO WS-TL1-CR-NBR.
099400     MOVE SS95WS-OUT-AMT-L20     TO WS-TL1-CR-AMT.
099500*
099600     IF  WS-TIPT-IF-PRINT (15)
099700         PERFORM MB22PD-PRINT-1-LINE
099800            THRU MB22PD-P1L-EXIT
099900     ELSE
100000         MOVE SPACES             TO MB20WS-PRINT-LINE.
100100*
100200     MOVE 'SETTLEMENT - MANUAL   '
100300                                 TO WS-TL1-LIT-1.
100400     MOVE WS-TT-NBR (X-WS-TT 31) TO SS95WS-IN-NBR.
100500     MOVE WS-TT-AMT (X-WS-TT 31) TO SS95WS-IN-AMT.
100600     PERFORM SS95PD-NAP-ROUTINE
100700        THRU SS95PD-NAP-EXIT.
100800     MOVE SS95WS-OUT-NBR-L12     TO WS-TL1-DR-NBR.
100900     MOVE SS95WS-OUT-AMT-L20     TO WS-TL1-DR-AMT.
101000*
101100     MOVE WS-TT-NBR (X-WS-TT 32) TO SS95WS-IN-NBR.
101200     MOVE WS-TT-AMT (X-WS-TT 32) TO SS95WS-IN-AMT.
101300     PERFORM SS95PD-NAP-ROUTINE
101400        THRU SS95PD-NAP-EXIT.
101500     MOVE SS95WS-OUT-NBR-L12     TO WS-TL1-CR-NBR.
101600     MOVE SS95WS-OUT-AMT-L20     TO WS-TL1-CR-AMT.
101700*
101800     IF  WS-TIPT-IF-PRINT (16)
101900         PERFORM MB22PD-PRINT-1-LINE
102000            THRU MB22PD-P1L-EXIT
102100     ELSE
102200         MOVE SPACES             TO MB20WS-PRINT-LINE.
102300*
102400     MOVE 'SETTLEMENT - INVOICE  '
102500                                 TO WS-TL1-LIT-1.
102600     MOVE WS-TT-NBR (X-WS-TT 33) TO SS95WS-IN-NBR.
102700     MOVE WS-TT-AMT (X-WS-TT 33) TO SS95WS-IN-AMT.
102800     PERFORM SS95PD-NAP-ROUTINE
102900        THRU SS95PD-NAP-EXIT.
103000     MOVE SS95WS-OUT-NBR-L12     TO WS-TL1-DR-NBR.
103100     MOVE SS95WS-OUT-AMT-L20     TO WS-TL1-DR-AMT.
103200*
103300     MOVE WS-TT-NBR (X-WS-TT 34) TO SS95WS-IN-NBR.
103400     MOVE WS-TT-AMT (X-WS-TT 34) TO SS95WS-IN-AMT.
103500     PERFORM SS95PD-NAP-ROUTINE
103600        THRU SS95PD-NAP-EXIT.
103700     MOVE SS95WS-OUT-NBR-L12     TO WS-TL1-CR-NBR.
103800     MOVE SS95WS-OUT-AMT-L20     TO WS-TL1-CR-AMT.
103900*
104000     IF  WS-TIPT-IF-PRINT (17)
104100         PERFORM MB22PD-PRINT-1-LINE
104200            THRU MB22PD-P1L-EXIT
104300     ELSE
104400         MOVE SPACES             TO MB20WS-PRINT-LINE.
104500*
104600     MOVE 'SETTLEMENT - WINDOW   '
104700                                 TO WS-TL1-LIT-1.
104800     MOVE WS-TT-NBR (X-WS-TT 35) TO SS95WS-IN-NBR.
104900     MOVE WS-TT-AMT (X-WS-TT 35) TO SS95WS-IN-AMT.
105000     PERFORM SS95PD-NAP-ROUTINE
105100        THRU SS95PD-NAP-EXIT.
105200     MOVE SS95WS-OUT-NBR-L12     TO WS-TL1-DR-NBR.
105300     MOVE SS95WS-OUT-AMT-L20     TO WS-TL1-DR-AMT.
105400*
105500     MOVE WS-TT-NBR (X-WS-TT 36) TO SS95WS-IN-NBR.
105600     MOVE WS-TT-AMT (X-WS-TT 36) TO SS95WS-IN-AMT.
105700     PERFORM SS95PD-NAP-ROUTINE
105800        THRU SS95PD-NAP-EXIT.
105900     MOVE SS95WS-OUT-NBR-L12     TO WS-TL1-CR-NBR.
106000     MOVE SS95WS-OUT-AMT-L20     TO WS-TL1-CR-AMT.
106100*
106200     IF  WS-TIPT-IF-PRINT (18)
106300         PERFORM MB22PD-PRINT-1-LINE
106400            THRU MB22PD-P1L-EXIT
106500     ELSE
106600         MOVE SPACES             TO MB20WS-PRINT-LINE.
106700*
106800     MOVE ALL '-'                TO WS-TL1-DR-NBR.
106900     MOVE ALL '-'                TO WS-TL1-DR-AMT.
107000     MOVE ALL '-'                TO WS-TL1-CR-NBR.
107100     MOVE ALL '-'                TO WS-TL1-CR-AMT.
107200*
107300     IF  WS-TIPT-IF-PRINT (30)
107400         PERFORM MB22PD-PRINT-1-LINE
107500            THRU MB22PD-P1L-EXIT
107600     ELSE
107700         MOVE SPACES             TO MB20WS-PRINT-LINE.
107800*
107900     MOVE '*SETTLEMENT OUT TOTAL*'
108000                                 TO WS-TL1-LIT-1.
108100     COMPUTE SS95WS-IN-NBR       =  WS-TT-NBR (X-WS-TT 25)
108200                                 +  WS-TT-NBR (X-WS-TT 27)
108300                                 +  WS-TT-NBR (X-WS-TT 29)
108400                                 +  WS-TT-NBR (X-WS-TT 31)
108500                                 +  WS-TT-NBR (X-WS-TT 33)
108600                                 +  WS-TT-NBR (X-WS-TT 35).
108700     COMPUTE SS95WS-IN-AMT       =  WS-TT-AMT (X-WS-TT 25)
108800                                 +  WS-TT-AMT (X-WS-TT 27)
108900                                 +  WS-TT-AMT (X-WS-TT 29)
109000                                 +  WS-TT-AMT (X-WS-TT 31)
109100                                 +  WS-TT-AMT (X-WS-TT 33)
109200                                 +  WS-TT-AMT (X-WS-TT 35).
109300     PERFORM SS95PD-NAP-ROUTINE
109400        THRU SS95PD-NAP-EXIT.
109500     MOVE SS95WS-OUT-NBR-L12     TO WS-TL1-DR-NBR.
109600     MOVE SS95WS-OUT-AMT-L20     TO WS-TL1-DR-AMT.
109700*
109800     COMPUTE SS95WS-IN-NBR       =  WS-TT-NBR (X-WS-TT 26)
109900                                 +  WS-TT-NBR (X-WS-TT 28)
110000                                 +  WS-TT-NBR (X-WS-TT 30)
110100                                 +  WS-TT-NBR (X-WS-TT 32)
110200                                 +  WS-TT-NBR (X-WS-TT 34)
110300                                 +  WS-TT-NBR (X-WS-TT 36).
110400     COMPUTE SS95WS-IN-AMT       =  WS-TT-AMT (X-WS-TT 26)
110500                                 +  WS-TT-AMT (X-WS-TT 28)
110600                                 +  WS-TT-AMT (X-WS-TT 30)
110700                                 +  WS-TT-AMT (X-WS-TT 32)
110800                                 +  WS-TT-AMT (X-WS-TT 34)
110900                                 +  WS-TT-AMT (X-WS-TT 36).
111000     PERFORM SS95PD-NAP-ROUTINE
111100        THRU SS95PD-NAP-EXIT.
111200     MOVE SS95WS-OUT-NBR-L12     TO WS-TL1-CR-NBR.
111300     MOVE SS95WS-OUT-AMT-L20     TO WS-TL1-CR-AMT.
111400*
111500     IF  WS-TIPT-IF-PRINT (30)
111600         PERFORM MB22PD-PRINT-2-LINES
111700            THRU MB22PD-P2L-EXIT
111800     ELSE
111900         MOVE SPACES             TO MB20WS-PRINT-LINE
112000         IF  WS-TIPT-IF-PRINT (29)
112100             PERFORM MB22PD-PRINT-1-LINE
112200                THRU MB22PD-P1L-EXIT.
112300*
112400     MOVE 'WINDOW TRANSACTIONS   '
112500                                 TO WS-TL1-LIT-1.
112600     MOVE WS-TT-NBR (X-WS-TT 37) TO SS95WS-IN-NBR.
112700     MOVE WS-TT-AMT (X-WS-TT 37) TO SS95WS-IN-AMT.
112800     PERFORM SS95PD-NAP-ROUTINE
112900        THRU SS95PD-NAP-EXIT.
113000     MOVE SS95WS-OUT-NBR-L12     TO WS-TL1-DR-NBR.
113100     MOVE SS95WS-OUT-AMT-L20     TO WS-TL1-DR-AMT.
113200*
113300     MOVE WS-TT-NBR (X-WS-TT 38) TO SS95WS-IN-NBR.
113400     MOVE WS-TT-AMT (X-WS-TT 38) TO SS95WS-IN-AMT.
113500     PERFORM SS95PD-NAP-ROUTINE
113600        THRU SS95PD-NAP-EXIT.
113700     MOVE SS95WS-OUT-NBR-L12     TO WS-TL1-CR-NBR.
113800     MOVE SS95WS-OUT-AMT-L20     TO WS-TL1-CR-AMT.
113900*
114000     IF  WS-TIPT-IF-PRINT (19)
114100         PERFORM MB22PD-PRINT-1-LINE
114200            THRU MB22PD-P1L-EXIT
114300     ELSE
114400         MOVE SPACES             TO MB20WS-PRINT-LINE.
114500*
114600     MOVE 'DEPOSIT MEMOS         '
114700                                 TO WS-TL1-LIT-1.
114800     MOVE WS-TT-NBR (X-WS-TT 39) TO SS95WS-IN-NBR.
114900     MOVE WS-TT-AMT (X-WS-TT 39) TO SS95WS-IN-AMT.
115000     PERFORM SS95PD-NAP-ROUTINE
115100        THRU SS95PD-NAP-EXIT.
115200     MOVE SS95WS-OUT-NBR-L12     TO WS-TL1-DR-NBR.
115300     MOVE SS95WS-OUT-AMT-L20     TO WS-TL1-DR-AMT.
115400*
115500     MOVE WS-TT-NBR (X-WS-TT 40) TO SS95WS-IN-NBR.
115600     MOVE WS-TT-AMT (X-WS-TT 40) TO SS95WS-IN-AMT.
115700     PERFORM SS95PD-NAP-ROUTINE
115800        THRU SS95PD-NAP-EXIT.
115900     MOVE SS95WS-OUT-NBR-L12     TO WS-TL1-CR-NBR.
116000     MOVE SS95WS-OUT-AMT-L20     TO WS-TL1-CR-AMT.
116100*
116200     IF  WS-TIPT-IF-PRINT (20)
116300         PERFORM MB22PD-PRINT-1-LINE
116400            THRU MB22PD-P1L-EXIT
116500     ELSE
116600         MOVE SPACES             TO MB20WS-PRINT-LINE.
116700*
116800     MOVE 'AUTH DECLINED/APPROVED'
116900                                 TO WS-TL1-LIT-1.
117000     MOVE WS-TT-NBR (X-WS-TT 41) TO SS95WS-IN-NBR.
117100     MOVE WS-TT-AMT (X-WS-TT 41) TO SS95WS-IN-AMT.
117200     PERFORM SS95PD-NAP-ROUTINE
117300        THRU SS95PD-NAP-EXIT.
117400     MOVE SS95WS-OUT-NBR-L12     TO WS-TL1-DR-NBR.
117500     MOVE SS95WS-OUT-AMT-L20     TO WS-TL1-DR-AMT.
117600*
117700     MOVE WS-TT-NBR (X-WS-TT 42) TO SS95WS-IN-NBR.
117800     MOVE WS-TT-AMT (X-WS-TT 42) TO SS95WS-IN-AMT.
117900     PERFORM SS95PD-NAP-ROUTINE
118000        THRU SS95PD-NAP-EXIT.
118100     MOVE SS95WS-OUT-NBR-L12     TO WS-TL1-CR-NBR.
118200     MOVE SS95WS-OUT-AMT-L20     TO WS-TL1-CR-AMT.
118300*
118400     IF  WS-TIPT-IF-PRINT (21)
118500         PERFORM MB22PD-PRINT-1-LINE
118600            THRU MB22PD-P1L-EXIT
118700     ELSE
118800         MOVE SPACES             TO MB20WS-PRINT-LINE.
118900*
119000     MOVE 'MEMOS                 '
119100                                 TO WS-TL1-LIT-1.
119200     MOVE WS-TT-NBR (X-WS-TT 43) TO SS95WS-IN-NBR.
119300     MOVE WS-TT-AMT (X-WS-TT 43) TO SS95WS-IN-AMT.
119400     PERFORM SS95PD-NAP-ROUTINE
119500        THRU SS95PD-NAP-EXIT.
119600     MOVE SS95WS-OUT-NBR-L12     TO WS-TL1-DR-NBR.
119700     MOVE SS95WS-OUT-AMT-L20     TO WS-TL1-DR-AMT.
119800*
119900     MOVE WS-TT-NBR (X-WS-TT 44) TO SS95WS-IN-NBR.
120000     MOVE WS-TT-AMT (X-WS-TT 44) TO SS95WS-IN-AMT.
120100     PERFORM SS95PD-NAP-ROUTINE
120200        THRU SS95PD-NAP-EXIT.
120300     MOVE SS95WS-OUT-NBR-L12     TO WS-TL1-CR-NBR.
120400     MOVE SS95WS-OUT-AMT-L20     TO WS-TL1-CR-AMT.
120500*
120600     IF  WS-TIPT-IF-PRINT (22)
120700         PERFORM MB22PD-PRINT-1-LINE
120800            THRU MB22PD-P1L-EXIT
120900     ELSE
121000         MOVE SPACES             TO MB20WS-PRINT-LINE.
121100*
121200     MOVE 'RESERVE BALANCE       '
121300                                 TO WS-TL1-LIT-1.
121400     MOVE WS-TT-NBR (X-WS-TT 45) TO SS95WS-IN-NBR.
121500     MOVE WS-TT-AMT (X-WS-TT 45) TO SS95WS-IN-AMT.
121600     PERFORM SS95PD-NAP-ROUTINE
121700        THRU SS95PD-NAP-EXIT.
121800     MOVE SS95WS-OUT-NBR-L12     TO WS-TL1-DR-NBR.
121900     MOVE SS95WS-OUT-AMT-L20     TO WS-TL1-DR-AMT.
122000*
122100     MOVE WS-TT-NBR (X-WS-TT 46) TO SS95WS-IN-NBR.
122200     MOVE WS-TT-AMT (X-WS-TT 46) TO SS95WS-IN-AMT.
122300     PERFORM SS95PD-NAP-ROUTINE
122400        THRU SS95PD-NAP-EXIT.
122500     MOVE SS95WS-OUT-NBR-L12     TO WS-TL1-CR-NBR.
122600     MOVE SS95WS-OUT-AMT-L20     TO WS-TL1-CR-AMT.
122700*
122800     IF  WS-TIPT-IF-PRINT (23)
122900         PERFORM MB22PD-PRINT-1-LINE
123000            THRU MB22PD-P1L-EXIT
123100     ELSE
123200         MOVE SPACES             TO MB20WS-PRINT-LINE.
123300*
123400 9030-PT-EXIT.
123500     EXIT.
123600*
123700 9050-ACCUMULATE-TOTALS.
123800*
123900     MOVE MTPT-LOGIC-MODULE      TO MMTCWS-LOGIC-MODULE.
124000*
124100     EVALUATE TRUE
124200         WHEN MMTCWS-LM-BATCH-HDR-DR
124300             SET X-WS-TT-ITEM    TO 1
124400         WHEN MMTCWS-LM-BATCH-HDR-CR
124500             SET X-WS-TT-ITEM    TO 2
124600         WHEN MMTCWS-LM-VALID-RESV-SETT-DR
124700             SET X-WS-TT-ITEM    TO 3
124800         WHEN MMTCWS-LM-VALID-RESV-SETT-CR
124900             SET X-WS-TT-ITEM    TO 4
125000         WHEN MMTCWS-LM-DISCOUNT
125100             SET X-WS-TT-ITEM    TO 5
125200         WHEN MMTCWS-LM-REFUND
125300             SET X-WS-TT-ITEM    TO 6
125400         WHEN MMTCWS-LM-PART-DR
125500             SET X-WS-TT-ITEM    TO 7
125600         WHEN MMTCWS-LM-PART-CR
125700             SET X-WS-TT-ITEM    TO 8
125800         WHEN MMTCWS-LM-ADJ-DR
125900             SET X-WS-TT-ITEM    TO 9
126000         WHEN MMTCWS-LM-ADJ-CR
126100             SET X-WS-TT-ITEM    TO 10
126200         WHEN MMTCWS-LM-RECOVERY-ADJ-DR
126300             SET X-WS-TT-ITEM    TO 11
126400         WHEN MMTCWS-LM-RECOVERY-ADJ-CR
126500             SET X-WS-TT-ITEM    TO 12
126600         WHEN MMTCWS-LM-SYSTEM-FEES-DR
126700             SET X-WS-TT-ITEM    TO 13
126800         WHEN MMTCWS-LM-SYSTEM-FEES-CR
126900             SET X-WS-TT-ITEM    TO 14
127000         WHEN MMTCWS-LM-USER-FEES
127100             SET X-WS-TT-ITEM    TO 15
127200         WHEN MMTCWS-LM-USER-FEES-CR
127300             SET X-WS-TT-ITEM    TO 16
127400         WHEN MMTCWS-LM-INTCHG-FEES-DR
127500             SET X-WS-TT-ITEM    TO 17
127600         WHEN MMTCWS-LM-INTCHG-FEES-CR
127700             SET X-WS-TT-ITEM    TO 18
127800         WHEN MMTCWS-LM-USER-DEBITS
127900             SET X-WS-TT-ITEM    TO 19
128000         WHEN MMTCWS-LM-USER-CREDITS
128100             SET X-WS-TT-ITEM    TO 20
128200         WHEN MMTCWS-LM-SETTLEMENT-DR-XFER
128300             SET X-WS-TT-ITEM    TO 21
128400         WHEN MMTCWS-LM-SETTLEMENT-CR-XFER
128500             SET X-WS-TT-ITEM    TO 22
128600         WHEN MMTCWS-LM-HOLDOVER
128700             SET X-WS-TT-ITEM    TO 23
128800         WHEN MMTCWS-LM-HOLDOVER-CR
128900             SET X-WS-TT-ITEM    TO 24
129000         WHEN MMTCWS-LM-SYSTEM-SETT-DR-ACH
129100             SET X-WS-TT-ITEM    TO 25
129200         WHEN MMTCWS-LM-SYSTEM-SETT-CR-ACH
129300             SET X-WS-TT-ITEM    TO 26
129400         WHEN MMTCWS-LM-SYSTEM-SETT-DR-CHECK
129500             SET X-WS-TT-ITEM    TO 27
129600         WHEN MMTCWS-LM-SYSTEM-SETT-CR-CHECK
129700             SET X-WS-TT-ITEM    TO 28
129800         WHEN MMTCWS-LM-SYSTEM-SETT-DR-WIRE
129900             SET X-WS-TT-ITEM    TO 29
130000         WHEN MMTCWS-LM-SYSTEM-SETT-CR-WIRE
130100             SET X-WS-TT-ITEM    TO 30
130200         WHEN MMTCWS-LM-SYSTEM-SETT-DR-MAN
130300             SET X-WS-TT-ITEM    TO 31
130400         WHEN MMTCWS-LM-SYSTEM-SETT-CR-MAN
130500             SET X-WS-TT-ITEM    TO 32
130600         WHEN MMTCWS-LM-SYSTEM-SETT-DR-BILL
130700             SET X-WS-TT-ITEM    TO 33
130800         WHEN MMTCWS-LM-SYSTEM-SETT-CR-BILL
130900             SET X-WS-TT-ITEM    TO 34
131000         WHEN MMTCWS-LM-WINDOW-SETT-DR
131100             SET X-WS-TT-ITEM    TO 35
131200         WHEN MMTCWS-LM-WINDOW-SETT-CR
131300             SET X-WS-TT-ITEM    TO 36
131400         WHEN MMTCWS-LM-VALID-DEP-MEMO-DR
131500             SET X-WS-TT-ITEM    TO 39
131600         WHEN MMTCWS-LM-VALID-DEP-MEMO-CR
131700             SET X-WS-TT-ITEM    TO 40
131800         WHEN MMTCWS-LM-AUTH-DECLINED
131900             SET X-WS-TT-ITEM    TO 41
132000         WHEN MMTCWS-LM-AUTH-APPROVED
132100             SET X-WS-TT-ITEM    TO 42
132200         WHEN MMTCWS-LM-CHECK-APPROVAL
132300             SET X-WS-TT-ITEM    TO 43
132400         WHEN MMTCWS-LM-RESERVE-TO-PROC
132500             SET X-WS-TT-ITEM    TO 45
132600         WHEN MMTCWS-LM-RESERVE-MANUAL
132700             SET X-WS-TT-ITEM    TO 46
132800         WHEN OTHER
132900             SET X-WS-TT-ITEM    TO 44
133000     END-EVALUATE.
133100*
133200     PERFORM 9060-ADD-TO-TOTALS
133300        THRU 9060-ATT-EXIT.
133400*
133500     EVALUATE TRUE
133600         WHEN (MMTCWS-LM-WINDOW-ALLOWED
133700          AND  MMTCWS-LM-VALID-DEBIT
133800          AND  MTPT-SETTLED-WINDOW)
133900             SET X-WS-TT-ITEM    TO 37
134000             PERFORM 9060-ADD-TO-TOTALS
134100                THRU 9060-ATT-EXIT
134200         WHEN (MMTCWS-LM-WINDOW-ALLOWED
134300          AND  MMTCWS-LM-VALID-CREDIT
134400          AND  MTPT-SETTLED-WINDOW)
134500             SET X-WS-TT-ITEM    TO 38
134600             PERFORM 9060-ADD-TO-TOTALS
134700                THRU 9060-ATT-EXIT
134800     END-EVALUATE.
134900*
135000 9050-AT-EXIT.
135100     EXIT.
135200*
135300 9060-ADD-TO-TOTALS.
135400*
135500     ADD MTPT-NBR-ITEMS          TO WS-TT-NBR (1 X-WS-TT-ITEM).
135600     ADD MTPT-AMOUNT             TO WS-TT-AMT (1 X-WS-TT-ITEM).
135700*
135800     ADD MTPT-NBR-ITEMS          TO WS-TT-NBR (2 X-WS-TT-ITEM).
135900     ADD MTPT-AMOUNT             TO WS-TT-AMT (2 X-WS-TT-ITEM).
136000*
136100     ADD MTPT-NBR-ITEMS          TO WS-TT-NBR (3 X-WS-TT-ITEM).
136200     ADD MTPT-AMOUNT             TO WS-TT-AMT (3 X-WS-TT-ITEM).
136300*
136400 9060-ATT-EXIT.
136500     EXIT.
136600/
136700 9070-ZERO-ORG-ACCUMS.
136800*
136900     INITIALIZE WS-TT-LEVEL (1).
137000*
137100 9070-ZOA-EXIT.
137200     EXIT.
137300*
137400 9080-ZERO-MER-ACCUMS.
137500*
137600     INITIALIZE WS-TT-LEVEL (2).
137700*
137800 9080-ZMA-EXIT.
137900     EXIT.
138000*
138100 9090-ZERO-STORE-ACCUMS.
138200*
138300     INITIALIZE WS-TT-LEVEL (3).
138400*
138500 9090-ZSA-EXIT.
138600     EXIT.
138700*
138800 9100-CHECK-NBR-LINES.
138900*
139000     COMPUTE MB20WS-LINES-REMAINING
139100                                 = MB20WS-LINE-LIMIT
139200                                 - MB20WS-LINE-COUNT.
139300*
139400     IF  MB20WS-LINES-REMAINING IS LESS THAN WS-D720-LINE-CHECK
139500         MOVE MB20WS-FORCE-PAGE  TO MB20WS-LINE-COUNT.
139600*
139700 9100-CNL-EXIT.
139800     EXIT.
139900/
140000     COPY MB22PD.
140100/
140200     COPY SS95PD.
140300/
140400     COPY SS02PD.
140500/
140600     COPY SS07PD.
140700/
140800     COPY SS08PD.
140900/
141000     COPY SS16PD.
141100/
141200     COPY SS26PD.
141300/
141400     COPY SS27PD.
141500*
141600 9995-END-SOURCE-STATEMENTS SECTION.
141700 9999-END-OF-PROGRAM.
141800     EXIT.
