000100 IDENTIFICATION DIVISION.
000200 PROGRAM-ID. MBD72006.
000201*       RELEASE DATE=08/24/01.        REVISION LEVEL=08.06      * ++++++++
000202***************************************************************** ++++++++
000203*WARNING.  THIS COMPUTER PROGRAM IS PROTECTED BY COPYRIGHT LAW  * ++++++++
000204*AND INTERNATIONAL TREATIES.  UNAUTHORIZED REPRODUCTION OR      * ++++++++
000205*DISTRIBUTION OF THIS PROGRAM, OR ANY PORTION OF IT, MAY RESULT * ++++++++
000206*IN SEVERE CIVIL AND CRIMINAL PENATLIES, AND WILL BE PROSECUTED * ++++++++
000207*TO THE MAXIMUM EXTENT POSSIBLE UNDER THE LAW.                  * ++++++++
000208*COPYRIGHT 1999 PAYSYS INTERNATIONAL, INC.  ALL RIGHTS RESERVED.* ++++++++
000209***************************************************************** ++++++++
000300*****************************************************************
000400*                                                               *
000500*   V - PLUS  M E R C H A N T   B A N K C A R D   S Y S T E M   *
000600*                                                               *
000700*       MBD72006 - OPTIONAL REPORT 06 SUBROUTINE                *
000800*                                                               *
000900*****************************************************************
001000 ENVIRONMENT DIVISION.
001100 CONFIGURATION SECTION.
001200 SOURCE-COMPUTER.            IBM-4341.
001300 OBJECT-COMPUTER.            IBM-4341.
001400/
001500 DATA DIVISION.
001600 WORKING-STORAGE SECTION.
001700*
001800 01  FILLER                  PIC  X(12)      VALUE '** WS-BEG **'.
001900*
002000 01  WS-MBD72006-WORK-AREAS.
002100     03  WS-D72006-ACTIVITY-SW
002200                             PIC  X(01)      VALUE 'N'.
002300     03  WS-D720-LINE-CHECK  PIC S9(05)      COMP-3 VALUE +34.
002400*
002500*****************************************************
002600*    THE VALUE FOR THE FOLLWING LEVEL INDICES ARE:  *
002700*       1 - ORGANIZATION                            *
002800*       2 - MERCHANT                                *
002900*       3 - STORE, PLAN OR T/C                      *
003000*                                                   *
003100*    THE VALUE FOR THE FOLLWING ITEM INDICES ARE:   *
003200*       1 - DEPOSITS DEBITS                         *
003300*       2 - DEPOSITS CREDIT                         *
003400*       3 - RESERVES DEBITS                         *
003500*       4 - RESERVES CREDIT                         *
003600*       5 - DISCOUNT DEBITS                         *
003700*       6 - DISCOUNT CREDIT                         *
003800*       7 - PARTICIPTION DEBITS                     *
003900*       8 - PARTICIPTION CREDIT                     *
004000*       9 - SYSTEM ADJUSTMENTS DEBITS               *
004100*      10 - SYSTEM ADJUSTMENTS CREDIT               *
004200*      11 - RECOVERY ADJUSTMENTS DEBITS             *
004300*      12 - RECOVERY ADJUSTMENTS CREDIT             *
004400*      13 - SYSTEM FEES DEBIT                       *
004500*      14 - SYSTEM FEES CREDIT                      *
004600*      15 - USER FEES DEBIT                         *
004700*      16 - USER FEES CREDIT                        *
004800*      17 - INTERCHANGE FEES DEBITS                 *
004900*      18 - INTERCHANGE FEES CREDIT                 *
005000*      19 - USER CREDITS DEBITS                     *
005100*      20 - USER CREDITS CREDIT                     *
005200*      21 - TRANSFER TO BILLING/INVOICE DEBITS      *
005300*      22 - TRANSFER TO BILLING/INVOICE CREDITS     *
005400*      23 - HOLDOVER DEBITS                         *
005500*      24 - HOLDOVER CREDITS                        *
005600*      25 - SETTLEMENT DEBITS -- ACH                *
005700*      26 - SETTLEMENT CREDITS - ACH                *
005800*      27 - SETTLEMENT DEBITS -- CHECK              *
005900*      28 - SETTLEMENT CREDITS - CHECK              *
006000*      29 - SETTLEMENT DEBITS -- WIRE TRANSFER      *
006100*      30 - SETTLEMENT CREDITS - WIRE TRANSFER      *
006200*      31 - SETTLEMENT DEBITS -- MANUAL             *
006300*      32 - SETTLEMENT CREDITS - MANUAL             *
006400*      33 - SETTLEMENT DEBITS -- BILLING/INVOICE    *
006500*      34 - SETTLEMENT CREDITS - BILLING/INVOICE    *
006600*      35 - SETTLEMENT DEBITS -- WINDOW             *
006700*      36 - SETTLEMENT CREDITS - WINDOW             *
006800*      37 - WINDOW TRANSACTIONS DEBITS              *
006900*      38 - WINDOW TRANSACTIONS CREDIT              *
007000*      39 - DEPOSIT MEMOS DEBITS                    *
007100*      40 - DEPOSIT MEMOS CREDIT                    *
007200*      41 - AUTHORIZATION DECLINES                  *
007300*      42 - AUTHORIZATION APPROVALS                 *
007400*      43 - MEMOS DEBITS                            *
007500*      44 - MEMOS CREDITS                           *
007600*      45 - RESERVE BALANCE DEBITS                  *
007700*      46 - RESERVE BALANCE CREDITS                 *
007800*                                                   *
007900*****************************************************
008000*
008100     03  WS-TOTALS-TABLE.
008200         05  WS-TT-LEVEL                     OCCURS 3 TIMES
008300                                             INDEXED BY
008400                                             X-WS-TT.
008500             07  WS-TT-ITEM                  OCCURS 46 TIMES
008600                                             INDEXED BY
008700                                             X-WS-TT-ITEM.
008800                 09  WS-TT-NBR
008900                             PIC S9(09)      COMP-3.
009000                 09  WS-TT-AMT
009100                             PIC S9(17)      COMP-3.
009200/
009300*****************************************************
009400*    THE VALUE FOR THE FOLLWING ITEM INDICES ARE:   *
009500*       1 - DEPOSITS                                *
009600*       2 - RESERVES                                *
009700*       3 - DISCOUNT                                *
009800*       4 - PARTICIPTION                            *
009900*       5 - SYSTEM ADJUSTMENTS                      *
010000*       6 - RECOVERY ADJUSTMENTS                    *
010100*       7 - SYSTEM FEES DEBIT                       *
010200*       8 - USER FEES DEBIT                         *
010300*       9 - INTERCHANGE FEES                        *
010400*      10 - USER CREDITS                            *
010500*      11 - TRANSFER TO BILLING/INVOICE             *
010600*      12 - HOLDOVER                                *
010700*      13 - SETTLEMENT -- ACH                       *
010800*      14 - SETTLEMENT -- CHECK                     *
010900*      15 - SETTLEMENT -- WIRE TRANSFER             *
011000*      16 - SETTLEMENT -- MANUAL                    *
011100*      17 - SETTLEMENT -- BILLING/INVOICE           *
011200*      18 - SETTLEMENT -- WINDOW                    *
011300*      19 - WINDOW TRANSACTIONS                     *
011400*      20 - DEPOSIT MEMOS                           *
011500*      21 - AUTHORIZATION DECLINES                  *
011600*      22 - MEMOS                                   *
011700*      23 - RESERVE BALANCE                         *
011800*      24 - FUTURE USE                              *
011900*      25 - FUTURE USE                              *
012000*      26 - FUTURE USE                              *
012100*      27 - FUTURE USE                              *
012200*      28 - SETTLEMENT IN SUB-TOTAL                 *
012300*      29 - SETTLEMENT IN TOTALS                    *
012400*      30 - SETTLEMENT OUT TOTALS                   *
012500*                                                   *
012600*****************************************************
012700*
012800     03  WS-TOTAL-ITEM-PRINT-TABLE.
012900         05  WS-TIPT-ITEM                    OCCURS 30 TIMES
013000                                             INDEXED BY
013100                                             X-WS-TIPT-ITEM.
013200             07  WS-TIPT-ITEM-FLAG
013300                             PIC  X(01)      VALUE 'N'.
013400                 88  WS-TIPT-IF-PRINT        VALUE 'Y'.
013500                 88  WS-TIPT-IF-NO-PRINT     VALUE 'N'.
013600*
013700*
013800     03  WS-HOLD-MER-NBR     PIC  9(09)      VALUE ZERO.
013900/
014000     COPY MB20WS.
014100*
014200 01  WS-DETAIL-LINE-1        REDEFINES MB20WS-PRINT-LINE.
014300     03  FILLER              PIC  X(01).
014400     03  WS-DL1-MER-NBR      PIC  9(09).
014500     03  FILLER              PIC  X(01).
014600     03  WS-DL1-STORE-NBR    PIC  9(09).
014700     03  FILLER              PIC  X(02).
014800     03  WS-DL1-TC-NBR       PIC  9(03).
014900     03  FILLER              PIC  X(01).
015000     03  WS-DL1-LM-NBR       PIC  9(03).
015100     03  FILLER              PIC  X(01).
015200     03  WS-DL1-CP-NBR       PIC  9(02).
015300     03  FILLER              PIC  X(01).
015400     03  WS-DL1-QL-NBR       PIC  9(02).
015500     03  FILLER              PIC  X(01).
015600     03  WS-DL1-PLAN-NBR     PIC  9(05).
015700     03  FILLER              PIC  X(01).
015800     03  WS-DL1-WINDOW       PIC  X(01).
015900     03  FILLER              PIC  X(01).
016000     03  WS-DL1-DATE         PIC  X(10).
016100     03  FILLER              PIC  X(01).
016200     03  WS-DL1-SOURCE-NBR   PIC  9(05).
016300     03  FILLER              PIC  X(02).
016400     03  WS-DL1-NBR          PIC  9(05).
016500     03  FILLER              PIC  X(01).
016600     03  WS-DL1-SEQ-NBR      PIC  9(08).
016700     03  FILLER              PIC  X(03).
016800     03  WS-DL1-GL-NBR       PIC  9(01).
016900     03  FILLER              PIC  X(01).
017000     03  WS-DL1-NBR-ITEMS    PIC  X(12).
017100     03  FILLER              PIC  X(01).
017200     03  WS-DL1-TRANS-AMT    PIC  X(21).
017300     03  WS-DL1-DESCRIPTION  PIC  X(15).
017400*
017500 01  WS-MERCHANT-TOTAL-LINE-1
017600                             REDEFINES MB20WS-PRINT-LINE.
017700     03  WS-MTL1-LIT-1       PIC  X(43).
017800     03  FILLER              PIC  X(07).
017900     03  WS-MTL1-MER-NBR     PIC  9(09).
018000     03  FILLER              PIC  X(04).
018100     03  WS-MTL1-MER-DESC    PIC  X(40).
018200     03  FILLER              PIC  X(01).
018300     03  WS-MTL1-FREQ-LIT    PIC  X(20).
018400     03  WS-MTL1-STMT-FREQ-1 PIC  99-.
018500     03  WS-MTL1-STMT-FREQ-2 PIC  99-.
018600     03  FILLER              PIC  X(02).
018700*
018800 01  WS-ORG-TOTAL-LINE-1     REDEFINES MB20WS-PRINT-LINE.
018900     03  WS-OTL1-LIT-1       PIC  X(47).
019000     03  FILLER              PIC  X(03).
019100     03  WS-OTL1-ORG-NBR     PIC  9(03).
019200     03  FILLER              PIC  X(10).
019300     03  WS-OTL1-ORG-DESC    PIC  X(40).
019400     03  FILLER              PIC  X(29).
019500*
019600 01  WS-HEADING-TOTAL-LINE-1 REDEFINES MB20WS-PRINT-LINE.
019700     03  FILLER              PIC  X(27).
019800     03  WS-HTL1-LIT-1       PIC  X(38).
019900     03  FILLER              PIC  X(04).
020000     03  WS-HTL1-LIT-2       PIC  X(38).
020100     03  FILLER              PIC  X(25).
020200*
020300 01  WS-TOTAL-LINE-1         REDEFINES MB20WS-PRINT-LINE.
020400     03  FILLER              PIC  X(05).
020500     03  WS-TL1-LIT-1        PIC  X(22).
020600     03  WS-TL1-DR-NBR       PIC  X(12).
020700     03  FILLER              PIC  X(06).
020800     03  WS-TL1-DR-AMT       PIC  X(21).
020900     03  FILLER              PIC  X(04).
021000     03  WS-TL1-CR-NBR       PIC  X(12).
021100     03  FILLER              PIC  X(05).
021200     03  WS-TL1-CR-AMT       PIC  X(21).
021300     03  FILLER              PIC  X(24).
021400/
021500     COPY SS95WS.
021600/
021700     COPY MTRFWS REPLACING ==:MTRF:== BY ==MTRF==.
021800/
021900     COPY MTRFRL REPLACING ==:MTRF:== BY ==MWRF==.
022000/
022100     COPY MTPTRL REPLACING ==:MTPT:== BY ==MTPT==.
022200/
022300     COPY MMTCWS.
022400/
022500     COPY MTP0RL REPLACING ==:MTP0:== BY ==MTR0==.
022600/
022700     COPY MTP0RL REPLACING ==:MTP0:== BY ==MTR1==.
022800/
022900     COPY MTP0RL REPLACING ==:MTP0:== BY ==MTR2==.
023000/
023100     COPY MTP0RL REPLACING ==:MTP0:== BY ==MTR3==.
023200/
023300     COPY MTP0RL REPLACING ==:MTP0:== BY ==MTR4==.
023400/
023500     COPY MTP0RL REPLACING ==:MTP0:== BY ==MTR5==.
023600/
023700     COPY MTP0RL REPLACING ==:MTP0:== BY ==MTR6==.
023800/
023900     COPY MTP0RL REPLACING ==:MTP0:== BY ==MTR7==.
024000/
024100     COPY MTP0RL REPLACING ==:MTP0:== BY ==MTR8==.
024200/
024300     COPY MTP0RL REPLACING ==:MTP0:== BY ==MTR9==.
024400/
024500     COPY MB00WS.
024600/
024700     COPY SS00WS.
024800/
024900     COPY SS01WS.
025000/
025100     COPY SS02WS.
025200*
025300 01  FILLER                  PIC  X(12)      VALUE '** WS-END **'.
025400/
025500 LINKAGE SECTION.
025600     COPY MB22WS.
025700/
025800     COPY MTRFRL REPLACING ==:MTRF:== BY ==MTRF==.
025900/
026000 PROCEDURE DIVISION              USING MB22WS-LINK-DATA
026100                                       MTRF-RECORD.
026200*
026300 A000-MAIN-LINE-SECT SECTION.
026400 A010-ML-BEGIN.
026500*
026600     IF  MTRF-K1-RT-DETAIL
026700         PERFORM D000-DETAIL-RECORD
026800            THRU D099-DR-EXIT.
026900*
027000     IF  MTRF-K1-RT-HEADER
027100         PERFORM H000-HEADER-RECORD
027200            THRU H099-HR-EXIT.
027300*
027400     IF  MTRF-K1-RT-TRAILER
027500         PERFORM T000-TRAILER-RECORD
027600            THRU T099-TR-EXIT.
027700*
027800     GOBACK.
027900*
028000 A099-ML-EXIT.
028100     EXIT.
028200/
028300 D000-DETAIL-RECORD SECTION.
028400 D010-DR-BEGIN.
028500*
028600     MOVE 'Y'                    TO WS-D72006-ACTIVITY-SW.
028700*
028800     MOVE MTRF-MT-TRANSACTION    TO MTPT-RECORD.
028900*
029000     IF  MTPT-MERCHANT   IS NOT EQUAL TO WS-HOLD-MER-NBR
029100     AND WS-HOLD-MER-NBR IS GREATER THAN ZERO
029200         PERFORM 9100-CHECK-NBR-LINES
029300            THRU 9100-CNL-EXIT
029400         PERFORM 9020-PRINT-MER-TOTALS
029500            THRU 9020-PMT-EXIT
029600         PERFORM 9080-ZERO-MER-ACCUMS
029700            THRU 9080-ZMA-EXIT
029800         PERFORM MB22PD-PRINT-1-LINE
029900            THRU MB22PD-P1L-EXIT.
030000*
030100     MOVE MTPT-MERCHANT          TO WS-HOLD-MER-NBR.
030200*
030300     MOVE MTPT-MERCHANT          TO WS-DL1-MER-NBR.
030400     MOVE MTPT-STORE             TO WS-DL1-STORE-NBR.
030500     MOVE MTPT-TRANS-CODE        TO WS-DL1-TC-NBR.
030600     MOVE MTPT-LOGIC-MODULE      TO WS-DL1-LM-NBR.
030700     MOVE MTPT-PRODUCT           TO WS-DL1-CP-NBR.
030800     MOVE MTPT-QUAL-LEVEL        TO WS-DL1-QL-NBR.
030900     MOVE MTPT-PLAN              TO WS-DL1-PLAN-NBR.
031000*
031100     IF  MTPT-SETTLED-WINDOW
031200         MOVE MTPT-SETT-FLAG     TO WS-DL1-WINDOW.
031300*
031400     MOVE MTPT-BATCH-DATE        TO SS01WS-JULIAN.
031500     PERFORM SS26PD-NUMERICALLY-EDIT-DATE
031600        THRU SS26PD-NED-EXIT.
031700     MOVE SS01WS-XX-XX-YYYY      TO WS-DL1-DATE.
031800     MOVE MTPT-BATCH-SOURCE      TO WS-DL1-SOURCE-NBR.
031900     MOVE MTPT-BATCH-NBR         TO WS-DL1-NBR.
032000     MOVE MTPT-BATCH-SEQ         TO WS-DL1-SEQ-NBR.
032100     MOVE MTPT-GL-SOURCE         TO WS-DL1-GL-NBR.
032200*
032300     MOVE MTPT-NBR-ITEMS         TO SS95WS-IN-NBR.
032400     PERFORM SS95PD-NAP-ROUTINE
032500        THRU SS95PD-NAP-EXIT.
032600     MOVE SS95WS-OUT-NBR-L12     TO WS-DL1-NBR-ITEMS.
032700*
032800     MOVE MTPT-AMOUNT            TO SS95WS-IN-AMT.
032900     PERFORM SS95PD-NAP-ROUTINE
033000        THRU SS95PD-NAP-EXIT.
033100     MOVE SS95WS-OUT-AMT-L20     TO WS-DL1-TRANS-AMT.
033200*
033300     MOVE MTPT-RPT-DESC          TO WS-DL1-DESCRIPTION.
033400*
033500     PERFORM 9050-ACCUMULATE-TOTALS
033600        THRU 9050-AT-EXIT.
033700*
033800     EVALUATE TRUE
033900         WHEN MTRF-K1-DETAIL
034000             PERFORM MB22PD-PRINT-1-LINE
034100                THRU MB22PD-P1L-EXIT
034200         WHEN OTHER
034300             MOVE SPACES         TO MB20WS-PRINT-LINE
034400     END-EVALUATE.
034500*
034600     MOVE MTRF-RECORD            TO MWRF-RECORD.
034700*
034800 D099-DR-EXIT.
034900     EXIT.
035000/
035100 H000-HEADER-RECORD SECTION.
035200 H010-HR-BEGIN.
035300*
035400     MOVE MTRF-K1-FORM           TO MB20WS-FORM-CODE.
035500     MOVE MTRF-HD-DATE-FORMAT    TO SS01WS-DATE-FORMAT.
035600     MOVE MTRF-HD-FICHE-FLAG     TO MB20WS-FICHE-CODE.
035700     MOVE MTRF-HD-SYSTEM-NAME    TO MB20WS-SH-SYSTEM.
035800     MOVE MTRF-HD-REPORT-ID      TO MB20WS-SH-RPT-ID.
035900     MOVE 'O06'                  TO MB20WS-SH-INTERNAL-RPT-ID.
036000     MOVE MTRF-K1-ORG            TO MB20WS-SH-ORG.
036100     MOVE MTRF-HD-ORG-NAME       TO MB20WS-SH-ORG-NAME.
036200     MOVE MTRF-HD-RPT-TITLE      TO MB20WS-SH-RPT-NAME.
036300     MOVE MTRF-HD-FILE-DATE      TO SS01WS-JULIAN.
036400     PERFORM SS26PD-NUMERICALLY-EDIT-DATE
036500        THRU SS26PD-NED-EXIT.
036600     MOVE SS01WS-XX-XX-YYYY      TO MB20WS-SH-FILE-DATE.
036700     MOVE MTRF-HD-REPORT-DEST-ID TO MB20WS-SH-DEST-ID.
036800     MOVE MTRF-HD-DEST-DESC      TO MB20WS-SH-DEST-DESC.
036900*
037000     MOVE '  MERCHANT   STORE   *-- POSTING DATA ---*  '
037100                                 TO MB20WS-SH-L5R-1.
037200     MOVE '*----- BATCH INFORMATION ------*           N'
037300                                 TO MB20WS-SH-L5R-2.
037400     MOVE 'UMBER         TRANSACTION                   '
037500                                 TO MB20WS-SH-L5R-3.
037600*
037700     MOVE '   NUMBER   NUMBER    T/C L/M PR QL  PLAN   '
037800                                 TO MB20WS-SH-L6R-1.
037900     MOVE '   DATE   SOURCE   NBR     SEQ    G/L       '
038000                                 TO MB20WS-SH-L6R-2.
038100     MOVE 'ITEMS            AMOUNT       DESCRIPTION   '
038200                                 TO MB20WS-SH-L6R-3.
038300*
038400     MOVE ZERO                   TO MB20WS-PAGE-COUNT.
038500     MOVE MB20WS-FORCE-PAGE      TO MB20WS-LINE-COUNT.
038600     MOVE MTRF-HD-LINES-PER-PAGE TO MB20WS-LINES-PER-PAGE.
038700     MOVE MTRF-HD-CURRENCY-NOD   TO MTRFWS-SAVE-CURRENCY-NOD.
038800     MOVE MTRF-HD-PER-ITEM-NOD   TO MTRFWS-SAVE-PER-ITEM-NOD.
038900     MOVE MTRF-HD-PERCENT-NOD    TO MTRFWS-SAVE-PERCENT-NOD.
039000     SET SS95WS-FUNCTION-INITIALIZE
039100                                 TO TRUE.
039200     PERFORM SS95PD-NAP-ROUTINE
039300        THRU SS95PD-NAP-EXIT.
039400*
039500     MOVE MTRF-HD-CURRENCY-CODE  TO SS95WS-CURRENCY-CODE.
039600     SET SS95WS-NAP-IND-IS-ALL   TO TRUE.
039700     MOVE 'N'                    TO WS-D72006-ACTIVITY-SW.
039800     MOVE MTRF-RECORD            TO MTR9-RECORD.
039900     MOVE SPACES                 TO MWRF-RECORD.
040000     MOVE ZERO                   TO MWRF-MERCHANT.
040100     PERFORM 9070-ZERO-ORG-ACCUMS
040200        THRU 9070-ZOA-EXIT.
040300     PERFORM 9080-ZERO-MER-ACCUMS
040400        THRU 9080-ZMA-EXIT.
040500     PERFORM 9090-ZERO-STORE-ACCUMS
040600        THRU 9090-ZSA-EXIT.
040700     MOVE ZERO                   TO WS-HOLD-MER-NBR.
040800*
040900*****               111111111122222222223
041000*****      123456789012345678901234567890
041100     MOVE 'YYYYYYYYYYYYYYYYYYYNNYYNNNNYYY'
041200                                 TO WS-TOTAL-ITEM-PRINT-TABLE.
041300*
041400     MOVE 5                      TO WS-D720-LINE-CHECK.
041500*
041600     PERFORM
041700         VARYING X-WS-TIPT-ITEM FROM 1 BY 1
041800         UNTIL   X-WS-TIPT-ITEM IS GREATER THAN 30
041900         IF  WS-TIPT-IF-PRINT (X-WS-TIPT-ITEM)
042000             ADD  1              TO WS-D720-LINE-CHECK
042100         END-IF
042200     END-PERFORM.
042300*
042400     IF  WS-TIPT-IF-PRINT (28)
042500         ADD  1                  TO WS-D720-LINE-CHECK.
042600*
042700     IF  WS-TIPT-IF-PRINT (29)
042800         ADD  1                  TO WS-D720-LINE-CHECK.
042900*
043000     IF  WS-TIPT-IF-PRINT (30)
043100         ADD  1                  TO WS-D720-LINE-CHECK.
043200*
043300 H099-HR-EXIT.
043400     EXIT.
043500/
043600 T000-TRAILER-RECORD SECTION.
043700 T010-TR-BEGIN.
043800*
043900     MOVE MTR9-RECORD            TO MTRF-RECORD.
044000*
044100     IF  WS-D72006-ACTIVITY-SW IS EQUAL TO 'N'
044200         IF  MTRF-HD-AF-PRODUCE
044300             PERFORM MB22PD-PRINT-NO-ACTIVITY
044400                THRU MB22PD-PNA-EXIT
044500             GO TO T099-TR-EXIT
044600         ELSE
044700             GO TO T099-TR-EXIT.
044800*
044900***************************************************************
045000*    WE MUST NOW PRINT MERCHANT TOTALS. THE REASON FOR THIS IS*
045100*    WE COULD HAVE PRINTED SEVERAL DETAIL RECORDS AND THEN    *
045200*    ENCOUNTERED A TRAILER RECORD WITH OUT HAVING  PROCESSED  *
045300*    THE MERCHANT BREAK/TOTALING LOGIC. THIS CODE WILL FORCE  *
045400*    A MERCHANT TOTAL TO BE PRINTED.                          *
045500***************************************************************
045600*
045700     PERFORM 9100-CHECK-NBR-LINES
045800        THRU 9100-CNL-EXIT.
045900*
046000     PERFORM 9020-PRINT-MER-TOTALS
046100        THRU 9020-PMT-EXIT.
046200*
046300     PERFORM 9080-ZERO-MER-ACCUMS
046400        THRU 9080-ZMA-EXIT.
046500*
046600     PERFORM 9100-CHECK-NBR-LINES
046700        THRU 9100-CNL-EXIT.
046800*
046900     PERFORM 9010-PRINT-ORG-TOTALS
047000        THRU 9010-POT-EXIT.
047100*
047200 T099-TR-EXIT.
047300     EXIT.
047400/
047500 9000-PERFORMED-ROUTINES-SECT SECTION.
047600 9010-PRINT-ORG-TOTALS.
047700*
047800     PERFORM MB22PD-PRINT-1-LINE
047900        THRU MB22PD-P1L-EXIT.
048000*
048100     MOVE SPACES                 TO MB20WS-SH-LINE-5
048200                                    MB20WS-SH-LINE-6
048300                                    MB20WS-SH-LINE-7
048400                                    MB20WS-SH-LINE-8.
048500*
048600     MOVE '**** ORGANIZATION TOTALS ****  FOR ORGANIZATION'
048700                                 TO WS-OTL1-LIT-1.
048800     MOVE MTRF-K1-ORG            TO WS-OTL1-ORG-NBR.
048900     MOVE MTRF-HD-ORG-NAME       TO WS-OTL1-ORG-DESC.
049000     PERFORM MB22PD-PRINT-1-LINE
049100        THRU MB22PD-P1L-EXIT.
049200*
049300     SET X-WS-TT                 TO 1.
049400     PERFORM 9030-PRINT-TOTALS
049500        THRU 9030-PT-EXIT.
049600*
049700 9010-POT-EXIT.
049800     EXIT.
049900/
050000 9020-PRINT-MER-TOTALS.
050100*
050200     PERFORM MB22PD-PRINT-1-LINE
050300        THRU MB22PD-P1L-EXIT.
050400*
050500     MOVE '**** MERCHANT TOTALS ****      FOR MERCHANT    '
050600                                 TO WS-MTL1-LIT-1.
050700     MOVE MWRF-MERCHANT          TO WS-MTL1-MER-NBR.
050800     MOVE MWRF-NAME              TO WS-MTL1-MER-DESC.
050900     MOVE 'STATEMENT FREQUENCY'  TO WS-MTL1-FREQ-LIT.
051000     MOVE MWRF-STMT-FREQ-1       TO WS-MTL1-STMT-FREQ-1.
051100     MOVE MWRF-STMT-FREQ-2       TO WS-MTL1-STMT-FREQ-2.
051200     PERFORM MB22PD-PRINT-1-LINE
051300        THRU MB22PD-P1L-EXIT.
051400*
051500     SET X-WS-TT                 TO 2.
051600     PERFORM 9030-PRINT-TOTALS
051700        THRU 9030-PT-EXIT.
051800*
051900 9020-PMT-EXIT.
052000     EXIT.
052100/
052200 9030-PRINT-TOTALS.
052300*
052400     MOVE '*-------------- DEBITS -------------*'
052500                                 TO WS-HTL1-LIT-1.
052600     MOVE '*------------- CREDITS -------------*'
052700                                 TO WS-HTL1-LIT-2.
052800     PERFORM MB22PD-PRINT-1-LINE
052900        THRU MB22PD-P1L-EXIT.
053000*
053100     MOVE 'DEPOSITS              '
053200                                 TO WS-TL1-LIT-1.
053300     MOVE WS-TT-NBR (X-WS-TT 1)  TO SS95WS-IN-NBR.
053400     MOVE WS-TT-AMT (X-WS-TT 1)  TO SS95WS-IN-AMT.
053500     PERFORM SS95PD-NAP-ROUTINE
053600        THRU SS95PD-NAP-EXIT.
053700     MOVE SS95WS-OUT-NBR-L12     TO WS-TL1-DR-NBR.
053800     MOVE SS95WS-OUT-AMT-L20     TO WS-TL1-DR-AMT.
053900*
054000     MOVE WS-TT-NBR (X-WS-TT 2)  TO SS95WS-IN-NBR.
054100     MOVE WS-TT-AMT (X-WS-TT 2)  TO SS95WS-IN-AMT.
054200     PERFORM SS95PD-NAP-ROUTINE
054300        THRU SS95PD-NAP-EXIT.
054400     MOVE SS95WS-OUT-NBR-L12     TO WS-TL1-CR-NBR.
054500     MOVE SS95WS-OUT-AMT-L20     TO WS-TL1-CR-AMT.
054600*
054700     IF  WS-TIPT-IF-PRINT (1)
054800         PERFORM MB22PD-PRINT-1-LINE
054900            THRU MB22PD-P1L-EXIT
055000     ELSE
055100         MOVE SPACES             TO MB20WS-PRINT-LINE.
055200*
055300     MOVE 'RESERVES              '
055400                                 TO WS-TL1-LIT-1.
055500     MOVE WS-TT-NBR (X-WS-TT 3)  TO SS95WS-IN-NBR.
055600     MOVE WS-TT-AMT (X-WS-TT 3)  TO SS95WS-IN-AMT.
055700     PERFORM SS95PD-NAP-ROUTINE
055800        THRU SS95PD-NAP-EXIT.
055900     MOVE SS95WS-OUT-NBR-L12     TO WS-TL1-DR-NBR.
056000     MOVE SS95WS-OUT-AMT-L20     TO WS-TL1-DR-AMT.
056100*
056200     MOVE WS-TT-NBR (X-WS-TT 4)  TO SS95WS-IN-NBR.
056300     MOVE WS-TT-AMT (X-WS-TT 4)  TO SS95WS-IN-AMT.
056400     PERFORM SS95PD-NAP-ROUTINE
056500        THRU SS95PD-NAP-EXIT.
056600     MOVE SS95WS-OUT-NBR-L12     TO WS-TL1-CR-NBR.
056700     MOVE SS95WS-OUT-AMT-L20     TO WS-TL1-CR-AMT.
056800*
056900     IF  WS-TIPT-IF-PRINT (2)
057000         PERFORM MB22PD-PRINT-1-LINE
057100            THRU MB22PD-P1L-EXIT
057200     ELSE
057300         MOVE SPACES             TO MB20WS-PRINT-LINE.
057400*
057500     MOVE 'DISCOUNT              '
057600                                 TO WS-TL1-LIT-1.
057700     MOVE WS-TT-NBR (X-WS-TT 5)  TO SS95WS-IN-NBR.
057800     MOVE WS-TT-AMT (X-WS-TT 5)  TO SS95WS-IN-AMT.
057900     PERFORM SS95PD-NAP-ROUTINE
058000        THRU SS95PD-NAP-EXIT.
058100     MOVE SS95WS-OUT-NBR-L12     TO WS-TL1-DR-NBR.
058200     MOVE SS95WS-OUT-AMT-L20     TO WS-TL1-DR-AMT.
058300*
058400     MOVE WS-TT-NBR (X-WS-TT 6)  TO SS95WS-IN-NBR.
058500     MOVE WS-TT-AMT (X-WS-TT 6)  TO SS95WS-IN-AMT.
058600     PERFORM SS95PD-NAP-ROUTINE
058700        THRU SS95PD-NAP-EXIT.
058800     MOVE SS95WS-OUT-NBR-L12     TO WS-TL1-CR-NBR.
058900     MOVE SS95WS-OUT-AMT-L20     TO WS-TL1-CR-AMT.
059000*
059100     IF  WS-TIPT-IF-PRINT (3)
059200         PERFORM MB22PD-PRINT-1-LINE
059300            THRU MB22PD-P1L-EXIT
059400     ELSE
059500         MOVE SPACES             TO MB20WS-PRINT-LINE.
059600*
059700     MOVE 'PARTICIPATION         '
059800                                 TO WS-TL1-LIT-1.
059900     MOVE WS-TT-NBR (X-WS-TT 7)  TO SS95WS-IN-NBR.
060000     MOVE WS-TT-AMT (X-WS-TT 7)  TO SS95WS-IN-AMT.
060100     PERFORM SS95PD-NAP-ROUTINE
060200        THRU SS95PD-NAP-EXIT.
060300     MOVE SS95WS-OUT-NBR-L12     TO WS-TL1-DR-NBR.
060400     MOVE SS95WS-OUT-AMT-L20     TO WS-TL1-DR-AMT.
060500*
060600     MOVE WS-TT-NBR (X-WS-TT 8)  TO SS95WS-IN-NBR.
060700     MOVE WS-TT-AMT (X-WS-TT 8)  TO SS95WS-IN-AMT.
060800     PERFORM SS95PD-NAP-ROUTINE
060900        THRU SS95PD-NAP-EXIT.
061000     MOVE SS95WS-OUT-NBR-L12     TO WS-TL1-CR-NBR.
061100     MOVE SS95WS-OUT-AMT-L20     TO WS-TL1-CR-AMT.
061200*
061300     IF  WS-TIPT-IF-PRINT (4)
061400         PERFORM MB22PD-PRINT-1-LINE
061500            THRU MB22PD-P1L-EXIT
061600     ELSE
061700         MOVE SPACES             TO MB20WS-PRINT-LINE.
061800*
061900     MOVE 'MERCHANT ADJUSTMENTS  '
062000                                 TO WS-TL1-LIT-1.
062100     MOVE WS-TT-NBR (X-WS-TT 9)  TO SS95WS-IN-NBR.
062200     MOVE WS-TT-AMT (X-WS-TT 9)  TO SS95WS-IN-AMT.
062300     PERFORM SS95PD-NAP-ROUTINE
062400        THRU SS95PD-NAP-EXIT.
062500     MOVE SS95WS-OUT-NBR-L12     TO WS-TL1-DR-NBR.
062600     MOVE SS95WS-OUT-AMT-L20     TO WS-TL1-DR-AMT.
062700*
062800     MOVE WS-TT-NBR (X-WS-TT 10) TO SS95WS-IN-NBR.
062900     MOVE WS-TT-AMT (X-WS-TT 10) TO SS95WS-IN-AMT.
063000     PERFORM SS95PD-NAP-ROUTINE
063100        THRU SS95PD-NAP-EXIT.
063200     MOVE SS95WS-OUT-NBR-L12     TO WS-TL1-CR-NBR.
063300     MOVE SS95WS-OUT-AMT-L20     TO WS-TL1-CR-AMT.
063400*
063500     IF  WS-TIPT-IF-PRINT (5)
063600         PERFORM MB22PD-PRINT-1-LINE
063700            THRU MB22PD-P1L-EXIT
063800     ELSE
063900         MOVE SPACES             TO MB20WS-PRINT-LINE.
064000*
064100     MOVE 'RECOVERY ADJUSTMENTS  '
064200                                 TO WS-TL1-LIT-1.
064300     MOVE WS-TT-NBR (X-WS-TT 11) TO SS95WS-IN-NBR.
064400     MOVE WS-TT-AMT (X-WS-TT 11) TO SS95WS-IN-AMT.
064500     PERFORM SS95PD-NAP-ROUTINE
064600        THRU SS95PD-NAP-EXIT.
064700     MOVE SS95WS-OUT-NBR-L12     TO WS-TL1-DR-NBR.
064800     MOVE SS95WS-OUT-AMT-L20     TO WS-TL1-DR-AMT.
064900*
065000     MOVE WS-TT-NBR (X-WS-TT 12) TO SS95WS-IN-NBR.
065100     MOVE WS-TT-AMT (X-WS-TT 12) TO SS95WS-IN-AMT.
065200     PERFORM SS95PD-NAP-ROUTINE
065300        THRU SS95PD-NAP-EXIT.
065400     MOVE SS95WS-OUT-NBR-L12     TO WS-TL1-CR-NBR.
065500     MOVE SS95WS-OUT-AMT-L20     TO WS-TL1-CR-AMT.
065600*
065700     IF  WS-TIPT-IF-PRINT (6)
065800         PERFORM MB22PD-PRINT-1-LINE
065900            THRU MB22PD-P1L-EXIT
066000     ELSE
066100         MOVE SPACES             TO MB20WS-PRINT-LINE.
066200*
066300     MOVE 'SYSTEM FEES           '
066400                                 TO WS-TL1-LIT-1.
066500     MOVE WS-TT-NBR (X-WS-TT 13) TO SS95WS-IN-NBR.
066600     MOVE WS-TT-AMT (X-WS-TT 13) TO SS95WS-IN-AMT.
066700     PERFORM SS95PD-NAP-ROUTINE
066800        THRU SS95PD-NAP-EXIT.
066900     MOVE SS95WS-OUT-NBR-L12     TO WS-TL1-DR-NBR.
067000     MOVE SS95WS-OUT-AMT-L20     TO WS-TL1-DR-AMT.
067100*
067200     MOVE WS-TT-NBR (X-WS-TT 14) TO SS95WS-IN-NBR.
067300     MOVE WS-TT-AMT (X-WS-TT 14) TO SS95WS-IN-AMT.
067400     PERFORM SS95PD-NAP-ROUTINE
067500        THRU SS95PD-NAP-EXIT.
067600     MOVE SS95WS-OUT-NBR-L12     TO WS-TL1-CR-NBR.
067700     MOVE SS95WS-OUT-AMT-L20     TO WS-TL1-CR-AMT.
067800*
067900     IF  WS-TIPT-IF-PRINT (7)
068000         PERFORM MB22PD-PRINT-1-LINE
068100            THRU MB22PD-P1L-EXIT
068200     ELSE
068300         MOVE SPACES             TO MB20WS-PRINT-LINE.
068400*
068500     MOVE 'USER FEES             '
068600                                 TO WS-TL1-LIT-1.
068700     MOVE WS-TT-NBR (X-WS-TT 15) TO SS95WS-IN-NBR.
068800     MOVE WS-TT-AMT (X-WS-TT 15) TO SS95WS-IN-AMT.
068900     PERFORM SS95PD-NAP-ROUTINE
069000        THRU SS95PD-NAP-EXIT.
069100     MOVE SS95WS-OUT-NBR-L12     TO WS-TL1-DR-NBR.
069200     MOVE SS95WS-OUT-AMT-L20     TO WS-TL1-DR-AMT.
069300*
069400     MOVE WS-TT-NBR (X-WS-TT 16) TO SS95WS-IN-NBR.
069500     MOVE WS-TT-AMT (X-WS-TT 16) TO SS95WS-IN-AMT.
069600     PERFORM SS95PD-NAP-ROUTINE
069700        THRU SS95PD-NAP-EXIT.
069800     MOVE SS95WS-OUT-NBR-L12     TO WS-TL1-CR-NBR.
069900     MOVE SS95WS-OUT-AMT-L20     TO WS-TL1-CR-AMT.
070000*
070100     IF  WS-TIPT-IF-PRINT (8)
070200         PERFORM MB22PD-PRINT-1-LINE
070300            THRU MB22PD-P1L-EXIT
070400     ELSE
070500         MOVE SPACES             TO MB20WS-PRINT-LINE.
070600*
070700     MOVE 'INTERCHANGE FEES      '
070800                                 TO WS-TL1-LIT-1.
070900     MOVE WS-TT-NBR (X-WS-TT 17) TO SS95WS-IN-NBR.
071000     MOVE WS-TT-AMT (X-WS-TT 17) TO SS95WS-IN-AMT.
071100     PERFORM SS95PD-NAP-ROUTINE
071200        THRU SS95PD-NAP-EXIT.
071300     MOVE SS95WS-OUT-NBR-L12     TO WS-TL1-DR-NBR.
071400     MOVE SS95WS-OUT-AMT-L20     TO WS-TL1-DR-AMT.
071500*
071600     MOVE WS-TT-NBR (X-WS-TT 18) TO SS95WS-IN-NBR.
071700     MOVE WS-TT-AMT (X-WS-TT 18) TO SS95WS-IN-AMT.
071800     PERFORM SS95PD-NAP-ROUTINE
071900        THRU SS95PD-NAP-EXIT.
072000     MOVE SS95WS-OUT-NBR-L12     TO WS-TL1-CR-NBR.
072100     MOVE SS95WS-OUT-AMT-L20     TO WS-TL1-CR-AMT.
072200*
072300     IF  WS-TIPT-IF-PRINT (9)
072400         PERFORM MB22PD-PRINT-1-LINE
072500            THRU MB22PD-P1L-EXIT
072600     ELSE
072700         MOVE SPACES             TO MB20WS-PRINT-LINE.
072800*
072900     MOVE 'USER CREDITS          '
073000                                 TO WS-TL1-LIT-1.
073100     MOVE WS-TT-NBR (X-WS-TT 19) TO SS95WS-IN-NBR.
073200     MOVE WS-TT-AMT (X-WS-TT 19) TO SS95WS-IN-AMT.
073300     PERFORM SS95PD-NAP-ROUTINE
073400        THRU SS95PD-NAP-EXIT.
073500     MOVE SS95WS-OUT-NBR-L12     TO WS-TL1-DR-NBR.
073600     MOVE SS95WS-OUT-AMT-L20     TO WS-TL1-DR-AMT.
073700*
073800     MOVE WS-TT-NBR (X-WS-TT 20) TO SS95WS-IN-NBR.
073900     MOVE WS-TT-AMT (X-WS-TT 20) TO SS95WS-IN-AMT.
074000     PERFORM SS95PD-NAP-ROUTINE
074100        THRU SS95PD-NAP-EXIT.
074200     MOVE SS95WS-OUT-NBR-L12     TO WS-TL1-CR-NBR.
074300     MOVE SS95WS-OUT-AMT-L20     TO WS-TL1-CR-AMT.
074400*
074500     IF  WS-TIPT-IF-PRINT (10)
074600         PERFORM MB22PD-PRINT-1-LINE
074700            THRU MB22PD-P1L-EXIT
074800     ELSE
074900         MOVE SPACES             TO MB20WS-PRINT-LINE.
075000*
075100     MOVE ALL '-'                TO WS-TL1-DR-NBR.
075200     MOVE ALL '-'                TO WS-TL1-DR-AMT.
075300     MOVE ALL '-'                TO WS-TL1-CR-NBR.
075400     MOVE ALL '-'                TO WS-TL1-CR-AMT.
075500*
075600     IF  WS-TIPT-IF-PRINT (28)
075700         PERFORM MB22PD-PRINT-1-LINE
075800            THRU MB22PD-P1L-EXIT
075900     ELSE
076000         MOVE SPACES             TO MB20WS-PRINT-LINE.
076100*
076200     MOVE '    SUB-TOTAL.........'
076300                                 TO WS-TL1-LIT-1.
076400     COMPUTE SS95WS-IN-NBR       =  WS-TT-NBR (X-WS-TT 1)
076500                                 +  WS-TT-NBR (X-WS-TT 3)
076600                                 +  WS-TT-NBR (X-WS-TT 5)
076700                                 +  WS-TT-NBR (X-WS-TT 7)
076800                                 +  WS-TT-NBR (X-WS-TT 9)
076900                                 +  WS-TT-NBR (X-WS-TT 11)
077000                                 +  WS-TT-NBR (X-WS-TT 13)
077100                                 +  WS-TT-NBR (X-WS-TT 15)
077200                                 +  WS-TT-NBR (X-WS-TT 17)
077300                                 +  WS-TT-NBR (X-WS-TT 19).
077400     COMPUTE SS95WS-IN-AMT       =  WS-TT-AMT (X-WS-TT 1)
077500                                 +  WS-TT-AMT (X-WS-TT 3)
077600                                 +  WS-TT-AMT (X-WS-TT 5)
077700                                 +  WS-TT-AMT (X-WS-TT 7)
077800                                 +  WS-TT-AMT (X-WS-TT 9)
077900                                 +  WS-TT-AMT (X-WS-TT 11)
078000                                 +  WS-TT-AMT (X-WS-TT 13)
078100                                 +  WS-TT-AMT (X-WS-TT 15)
078200                                 +  WS-TT-AMT (X-WS-TT 17)
078300                                 +  WS-TT-AMT (X-WS-TT 19).
078400     PERFORM SS95PD-NAP-ROUTINE
078500        THRU SS95PD-NAP-EXIT.
078600     MOVE SS95WS-OUT-NBR-L12     TO WS-TL1-DR-NBR.
078700     MOVE SS95WS-OUT-AMT-L20     TO WS-TL1-DR-AMT.
078800*
078900     COMPUTE SS95WS-IN-NBR       =  WS-TT-NBR (X-WS-TT 2)
079000                                 +  WS-TT-NBR (X-WS-TT 4)
079100                                 +  WS-TT-NBR (X-WS-TT 6)
079200                                 +  WS-TT-NBR (X-WS-TT 8)
079300                                 +  WS-TT-NBR (X-WS-TT 10)
079400                                 +  WS-TT-NBR (X-WS-TT 12)
079500                                 +  WS-TT-NBR (X-WS-TT 14)
079600                                 +  WS-TT-NBR (X-WS-TT 16)
079700                                 +  WS-TT-NBR (X-WS-TT 18)
079800                                 +  WS-TT-NBR (X-WS-TT 20).
079900     COMPUTE SS95WS-IN-AMT       =  WS-TT-AMT (X-WS-TT 2)
080000                                 +  WS-TT-AMT (X-WS-TT 4)
080100                                 +  WS-TT-AMT (X-WS-TT 6)
080200                                 +  WS-TT-AMT (X-WS-TT 8)
080300                                 +  WS-TT-AMT (X-WS-TT 10)
080400                                 +  WS-TT-AMT (X-WS-TT 12)
080500                                 +  WS-TT-AMT (X-WS-TT 14)
080600                                 +  WS-TT-AMT (X-WS-TT 16)
080700                                 +  WS-TT-AMT (X-WS-TT 18)
080800                                 +  WS-TT-AMT (X-WS-TT 20).
080900     PERFORM SS95PD-NAP-ROUTINE
081000        THRU SS95PD-NAP-EXIT.
081100     MOVE SS95WS-OUT-NBR-L12     TO WS-TL1-CR-NBR.
081200     MOVE SS95WS-OUT-AMT-L20     TO WS-TL1-CR-AMT.
081300*
081400     IF  WS-TIPT-IF-PRINT (28)
081500         PERFORM MB22PD-PRINT-1-LINE
081600            THRU MB22PD-P1L-EXIT
081700     ELSE
081800         MOVE SPACES             TO MB20WS-PRINT-LINE.
081900*
082000     MOVE 'TRANSFER TO INVOICE   '
082100                                 TO WS-TL1-LIT-1.
082200     MOVE WS-TT-NBR (X-WS-TT 21) TO SS95WS-IN-NBR.
082300     MOVE WS-TT-AMT (X-WS-TT 21) TO SS95WS-IN-AMT.
082400     PERFORM SS95PD-NAP-ROUTINE
082500        THRU SS95PD-NAP-EXIT.
082600     MOVE SS95WS-OUT-NBR-L12     TO WS-TL1-DR-NBR.
082700     MOVE SS95WS-OUT-AMT-L20     TO WS-TL1-DR-AMT.
082800*
082900     MOVE WS-TT-NBR (X-WS-TT 22) TO SS95WS-IN-NBR.
083000     MOVE WS-TT-AMT (X-WS-TT 22) TO SS95WS-IN-AMT.
083100     PERFORM SS95PD-NAP-ROUTINE
083200        THRU SS95PD-NAP-EXIT.
083300     MOVE SS95WS-OUT-NBR-L12     TO WS-TL1-CR-NBR.
083400     MOVE SS95WS-OUT-AMT-L20     TO WS-TL1-CR-AMT.
083500*
083600     IF  WS-TIPT-IF-PRINT (11)
083700         PERFORM MB22PD-PRINT-1-LINE
083800            THRU MB22PD-P1L-EXIT
083900     ELSE
084000         MOVE SPACES             TO MB20WS-PRINT-LINE.
084100*
084200     MOVE 'HOLDOVER TRANSACTIONS '
084300                                 TO WS-TL1-LIT-1.
084400     MOVE WS-TT-NBR (X-WS-TT 23) TO SS95WS-IN-NBR.
084500     MOVE WS-TT-AMT (X-WS-TT 23) TO SS95WS-IN-AMT.
084600     PERFORM SS95PD-NAP-ROUTINE
084700        THRU SS95PD-NAP-EXIT.
084800     MOVE SS95WS-OUT-NBR-L12     TO WS-TL1-DR-NBR.
084900     MOVE SS95WS-OUT-AMT-L20     TO WS-TL1-DR-AMT.
085000*
085100     MOVE WS-TT-NBR (X-WS-TT 24) TO SS95WS-IN-NBR.
085200     MOVE WS-TT-AMT (X-WS-TT 24) TO SS95WS-IN-AMT.
085300     PERFORM SS95PD-NAP-ROUTINE
085400        THRU SS95PD-NAP-EXIT.
085500     MOVE SS95WS-OUT-NBR-L12     TO WS-TL1-CR-NBR.
085600     MOVE SS95WS-OUT-AMT-L20     TO WS-TL1-CR-AMT.
085700*
085800     IF  WS-TIPT-IF-PRINT (12)
085900         PERFORM MB22PD-PRINT-1-LINE
086000            THRU MB22PD-P1L-EXIT
086100     ELSE
086200         MOVE SPACES             TO MB20WS-PRINT-LINE.
086300*
086400     MOVE ALL '-'                TO WS-TL1-DR-NBR.
086500     MOVE ALL '-'                TO WS-TL1-DR-AMT.
086600     MOVE ALL '-'                TO WS-TL1-CR-NBR.
086700     MOVE ALL '-'                TO WS-TL1-CR-AMT.
086800*
086900     IF  WS-TIPT-IF-PRINT (29)
087000         PERFORM MB22PD-PRINT-1-LINE
087100            THRU MB22PD-P1L-EXIT
087200     ELSE
087300         MOVE SPACES             TO MB20WS-PRINT-LINE.
087400*
087500     MOVE '*SETTLEMENT IN TOTAL* '
087600                                 TO WS-TL1-LIT-1.
087700     COMPUTE SS95WS-IN-NBR       =  WS-TT-NBR (X-WS-TT 1)
087800                                 +  WS-TT-NBR (X-WS-TT 3)
087900                                 +  WS-TT-NBR (X-WS-TT 5)
088000                                 +  WS-TT-NBR (X-WS-TT 7)
088100                                 +  WS-TT-NBR (X-WS-TT 9)
088200                                 +  WS-TT-NBR (X-WS-TT 11)
088300                                 +  WS-TT-NBR (X-WS-TT 13)
088400                                 +  WS-TT-NBR (X-WS-TT 15)
088500                                 +  WS-TT-NBR (X-WS-TT 17)
088600                                 +  WS-TT-NBR (X-WS-TT 19)
088700                                 +  WS-TT-NBR (X-WS-TT 21)
088800                                 +  WS-TT-NBR (X-WS-TT 23).
088900     COMPUTE SS95WS-IN-AMT       =  WS-TT-AMT (X-WS-TT 1)
089000                                 +  WS-TT-AMT (X-WS-TT 3)
089100                                 +  WS-TT-AMT (X-WS-TT 5)
089200                                 +  WS-TT-AMT (X-WS-TT 7)
089300                                 +  WS-TT-AMT (X-WS-TT 9)
089400                                 +  WS-TT-AMT (X-WS-TT 11)
089500                                 +  WS-TT-AMT (X-WS-TT 13)
089600                                 +  WS-TT-AMT (X-WS-TT 15)
089700                                 +  WS-TT-AMT (X-WS-TT 17)
089800                                 +  WS-TT-AMT (X-WS-TT 19)
089900                                 +  WS-TT-AMT (X-WS-TT 21)
090000                                 +  WS-TT-AMT (X-WS-TT 23).
090100     PERFORM SS95PD-NAP-ROUTINE
090200        THRU SS95PD-NAP-EXIT.
090300     MOVE SS95WS-OUT-NBR-L12     TO WS-TL1-DR-NBR.
090400     MOVE SS95WS-OUT-AMT-L20     TO WS-TL1-DR-AMT.
090500*
090600     COMPUTE SS95WS-IN-NBR       =  WS-TT-NBR (X-WS-TT 2)
090700                                 +  WS-TT-NBR (X-WS-TT 4)
090800                                 +  WS-TT-NBR (X-WS-TT 6)
090900                                 +  WS-TT-NBR (X-WS-TT 8)
091000                                 +  WS-TT-NBR (X-WS-TT 10)
091100                                 +  WS-TT-NBR (X-WS-TT 12)
091200                                 +  WS-TT-NBR (X-WS-TT 14)
091300                                 +  WS-TT-NBR (X-WS-TT 16)
091400                                 +  WS-TT-NBR (X-WS-TT 18)
091500                                 +  WS-TT-NBR (X-WS-TT 20)
091600                                 +  WS-TT-NBR (X-WS-TT 22)
091700                                 +  WS-TT-NBR (X-WS-TT 24).
091800     COMPUTE SS95WS-IN-AMT       =  WS-TT-AMT (X-WS-TT 2)
091900                                 +  WS-TT-AMT (X-WS-TT 4)
092000                                 +  WS-TT-AMT (X-WS-TT 6)
092100                                 +  WS-TT-AMT (X-WS-TT 8)
092200                                 +  WS-TT-AMT (X-WS-TT 10)
092300                                 +  WS-TT-AMT (X-WS-TT 12)
092400                                 +  WS-TT-AMT (X-WS-TT 14)
092500                                 +  WS-TT-AMT (X-WS-TT 16)
092600                                 +  WS-TT-AMT (X-WS-TT 18)
092700                                 +  WS-TT-AMT (X-WS-TT 20)
092800                                 +  WS-TT-AMT (X-WS-TT 22)
092900                                 +  WS-TT-AMT (X-WS-TT 24).
093000     PERFORM SS95PD-NAP-ROUTINE
093100        THRU SS95PD-NAP-EXIT.
093200     MOVE SS95WS-OUT-NBR-L12     TO WS-TL1-CR-NBR.
093300     MOVE SS95WS-OUT-AMT-L20     TO WS-TL1-CR-AMT.
093400*
093500     IF  WS-TIPT-IF-PRINT (29)
093600         PERFORM MB22PD-PRINT-2-LINES
093700            THRU MB22PD-P2L-EXIT
093800     ELSE
093900         MOVE SPACES             TO MB20WS-PRINT-LINE
094000         PERFORM MB22PD-PRINT-1-LINE
094100            THRU MB22PD-P1L-EXIT.
094200*
094300     MOVE 'SETTLEMENT - A C H    '
094400                                 TO WS-TL1-LIT-1.
094500     MOVE WS-TT-NBR (X-WS-TT 25) TO SS95WS-IN-NBR.
094600     MOVE WS-TT-AMT (X-WS-TT 25) TO SS95WS-IN-AMT.
094700     PERFORM SS95PD-NAP-ROUTINE
094800        THRU SS95PD-NAP-EXIT.
094900     MOVE SS95WS-OUT-NBR-L12     TO WS-TL1-DR-NBR.
095000     MOVE SS95WS-OUT-AMT-L20     TO WS-TL1-DR-AMT.
095100*
095200     MOVE WS-TT-NBR (X-WS-TT 26) TO SS95WS-IN-NBR.
095300     MOVE WS-TT-AMT (X-WS-TT 26) TO SS95WS-IN-AMT.
095400     PERFORM SS95PD-NAP-ROUTINE
095500        THRU SS95PD-NAP-EXIT.
095600     MOVE SS95WS-OUT-NBR-L12     TO WS-TL1-CR-NBR.
095700     MOVE SS95WS-OUT-AMT-L20     TO WS-TL1-CR-AMT.
095800*
095900     IF  WS-TIPT-IF-PRINT (13)
096000         PERFORM MB22PD-PRINT-1-LINE
096100            THRU MB22PD-P1L-EXIT
096200     ELSE
096300         MOVE SPACES             TO MB20WS-PRINT-LINE.
096400*
096500     MOVE 'SETTLEMENT - CHECK    '
096600                                 TO WS-TL1-LIT-1.
096700     MOVE WS-TT-NBR (X-WS-TT 27) TO SS95WS-IN-NBR.
096800     MOVE WS-TT-AMT (X-WS-TT 27) TO SS95WS-IN-AMT.
096900     PERFORM SS95PD-NAP-ROUTINE
097000        THRU SS95PD-NAP-EXIT.
097100     MOVE SS95WS-OUT-NBR-L12     TO WS-TL1-DR-NBR.
097200     MOVE SS95WS-OUT-AMT-L20     TO WS-TL1-DR-AMT.
097300*
097400     MOVE WS-TT-NBR (X-WS-TT 28) TO SS95WS-IN-NBR.
097500     MOVE WS-TT-AMT (X-WS-TT 28) TO SS95WS-IN-AMT.
097600     PERFORM SS95PD-NAP-ROUTINE
097700        THRU SS95PD-NAP-EXIT.
097800     MOVE SS95WS-OUT-NBR-L12     TO WS-TL1-CR-NBR.
097900     MOVE SS95WS-OUT-AMT-L20     TO WS-TL1-CR-AMT.
098000*
098100     IF  WS-TIPT-IF-PRINT (14)
098200         PERFORM MB22PD-PRINT-1-LINE
098300            THRU MB22PD-P1L-EXIT
098400     ELSE
098500         MOVE SPACES             TO MB20WS-PRINT-LINE.
098600*
098700     MOVE 'SETTLEMENT - WIRE     '
098800                                 TO WS-TL1-LIT-1.
098900     MOVE WS-TT-NBR (X-WS-TT 29) TO SS95WS-IN-NBR.
099000     MOVE WS-TT-AMT (X-WS-TT 29) TO SS95WS-IN-AMT.
099100     PERFORM SS95PD-NAP-ROUTINE
099200        THRU SS95PD-NAP-EXIT.
099300     MOVE SS95WS-OUT-NBR-L12     TO WS-TL1-DR-NBR.
099400     MOVE SS95WS-OUT-AMT-L20     TO WS-TL1-DR-AMT.
099500*
099600     MOVE WS-TT-NBR (X-WS-TT 30) TO SS95WS-IN-NBR.
099700     MOVE WS-TT-AMT (X-WS-TT 30) TO SS95WS-IN-AMT.
099800     PERFORM SS95PD-NAP-ROUTINE
099900        THRU SS95PD-NAP-EXIT.
100000     MOVE SS95WS-OUT-NBR-L12     TO WS-TL1-CR-NBR.
100100     MOVE SS95WS-OUT-AMT-L20     TO WS-TL1-CR-AMT.
100200*
100300     IF  WS-TIPT-IF-PRINT (15)
100400         PERFORM MB22PD-PRINT-1-LINE
100500            THRU MB22PD-P1L-EXIT
100600     ELSE
100700         MOVE SPACES             TO MB20WS-PRINT-LINE.
100800*
100900     MOVE 'SETTLEMENT - MANUAL   '
101000                                 TO WS-TL1-LIT-1.
101100     MOVE WS-TT-NBR (X-WS-TT 31) TO SS95WS-IN-NBR.
101200     MOVE WS-TT-AMT (X-WS-TT 31) TO SS95WS-IN-AMT.
101300     PERFORM SS95PD-NAP-ROUTINE
101400        THRU SS95PD-NAP-EXIT.
101500     MOVE SS95WS-OUT-NBR-L12     TO WS-TL1-DR-NBR.
101600     MOVE SS95WS-OUT-AMT-L20     TO WS-TL1-DR-AMT.
101700*
101800     MOVE WS-TT-NBR (X-WS-TT 32) TO SS95WS-IN-NBR.
101900     MOVE WS-TT-AMT (X-WS-TT 32) TO SS95WS-IN-AMT.
102000     PERFORM SS95PD-NAP-ROUTINE
102100        THRU SS95PD-NAP-EXIT.
102200     MOVE SS95WS-OUT-NBR-L12     TO WS-TL1-CR-NBR.
102300     MOVE SS95WS-OUT-AMT-L20     TO WS-TL1-CR-AMT.
102400*
102500     IF  WS-TIPT-IF-PRINT (16)
102600         PERFORM MB22PD-PRINT-1-LINE
102700            THRU MB22PD-P1L-EXIT
102800     ELSE
102900         MOVE SPACES             TO MB20WS-PRINT-LINE.
103000*
103100     MOVE 'SETTLEMENT - INVOICE  '
103200                                 TO WS-TL1-LIT-1.
103300     MOVE WS-TT-NBR (X-WS-TT 33) TO SS95WS-IN-NBR.
103400     MOVE WS-TT-AMT (X-WS-TT 33) TO SS95WS-IN-AMT.
103500     PERFORM SS95PD-NAP-ROUTINE
103600        THRU SS95PD-NAP-EXIT.
103700     MOVE SS95WS-OUT-NBR-L12     TO WS-TL1-DR-NBR.
103800     MOVE SS95WS-OUT-AMT-L20     TO WS-TL1-DR-AMT.
103900*
104000     MOVE WS-TT-NBR (X-WS-TT 34) TO SS95WS-IN-NBR.
104100     MOVE WS-TT-AMT (X-WS-TT 34) TO SS95WS-IN-AMT.
104200     PERFORM SS95PD-NAP-ROUTINE
104300        THRU SS95PD-NAP-EXIT.
104400     MOVE SS95WS-OUT-NBR-L12     TO WS-TL1-CR-NBR.
104500     MOVE SS95WS-OUT-AMT-L20     TO WS-TL1-CR-AMT.
104600*
104700     IF  WS-TIPT-IF-PRINT (17)
104800         PERFORM MB22PD-PRINT-1-LINE
104900            THRU MB22PD-P1L-EXIT
105000     ELSE
105100         MOVE SPACES             TO MB20WS-PRINT-LINE.
105200*
105300     MOVE 'SETTLEMENT - WINDOW   '
105400                                 TO WS-TL1-LIT-1.
105500     MOVE WS-TT-NBR (X-WS-TT 35) TO SS95WS-IN-NBR.
105600     MOVE WS-TT-AMT (X-WS-TT 35) TO SS95WS-IN-AMT.
105700     PERFORM SS95PD-NAP-ROUTINE
105800        THRU SS95PD-NAP-EXIT.
105900     MOVE SS95WS-OUT-NBR-L12     TO WS-TL1-DR-NBR.
106000     MOVE SS95WS-OUT-AMT-L20     TO WS-TL1-DR-AMT.
106100*
106200     MOVE WS-TT-NBR (X-WS-TT 36) TO SS95WS-IN-NBR.
106300     MOVE WS-TT-AMT (X-WS-TT 36) TO SS95WS-IN-AMT.
106400     PERFORM SS95PD-NAP-ROUTINE
106500        THRU SS95PD-NAP-EXIT.
106600     MOVE SS95WS-OUT-NBR-L12     TO WS-TL1-CR-NBR.
106700     MOVE SS95WS-OUT-AMT-L20     TO WS-TL1-CR-AMT.
106800*
106900     IF  WS-TIPT-IF-PRINT (18)
107000         PERFORM MB22PD-PRINT-1-LINE
107100            THRU MB22PD-P1L-EXIT
107200     ELSE
107300         MOVE SPACES             TO MB20WS-PRINT-LINE.
107400*
107500     MOVE ALL '-'                TO WS-TL1-DR-NBR.
107600     MOVE ALL '-'                TO WS-TL1-DR-AMT.
107700     MOVE ALL '-'                TO WS-TL1-CR-NBR.
107800     MOVE ALL '-'                TO WS-TL1-CR-AMT.
107900*
108000     IF  WS-TIPT-IF-PRINT (30)
108100         PERFORM MB22PD-PRINT-1-LINE
108200            THRU MB22PD-P1L-EXIT
108300     ELSE
108400         MOVE SPACES             TO MB20WS-PRINT-LINE.
108500*
108600     MOVE '*SETTLEMENT OUT TOTAL*'
108700                                 TO WS-TL1-LIT-1.
108800     COMPUTE SS95WS-IN-NBR       =  WS-TT-NBR (X-WS-TT 25)
108900                                 +  WS-TT-NBR (X-WS-TT 27)
109000                                 +  WS-TT-NBR (X-WS-TT 29)
109100                                 +  WS-TT-NBR (X-WS-TT 31)
109200                                 +  WS-TT-NBR (X-WS-TT 33)
109300                                 +  WS-TT-NBR (X-WS-TT 35).
109400     COMPUTE SS95WS-IN-AMT       =  WS-TT-AMT (X-WS-TT 25)
109500                                 +  WS-TT-AMT (X-WS-TT 27)
109600                                 +  WS-TT-AMT (X-WS-TT 29)
109700                                 +  WS-TT-AMT (X-WS-TT 31)
109800                                 +  WS-TT-AMT (X-WS-TT 33)
109900                                 +  WS-TT-AMT (X-WS-TT 35).
110000     PERFORM SS95PD-NAP-ROUTINE
110100        THRU SS95PD-NAP-EXIT.
110200     MOVE SS95WS-OUT-NBR-L12     TO WS-TL1-DR-NBR.
110300     MOVE SS95WS-OUT-AMT-L20     TO WS-TL1-DR-AMT.
110400*
110500     COMPUTE SS95WS-IN-NBR       =  WS-TT-NBR (X-WS-TT 26)
110600                                 +  WS-TT-NBR (X-WS-TT 28)
110700                                 +  WS-TT-NBR (X-WS-TT 30)
110800                                 +  WS-TT-NBR (X-WS-TT 32)
110900                                 +  WS-TT-NBR (X-WS-TT 34)
111000                                 +  WS-TT-NBR (X-WS-TT 36).
111100     COMPUTE SS95WS-IN-AMT       =  WS-TT-AMT (X-WS-TT 26)
111200                                 +  WS-TT-AMT (X-WS-TT 28)
111300                                 +  WS-TT-AMT (X-WS-TT 30)
111400                                 +  WS-TT-AMT (X-WS-TT 32)
111500                                 +  WS-TT-AMT (X-WS-TT 34)
111600                                 +  WS-TT-AMT (X-WS-TT 36).
111700     PERFORM SS95PD-NAP-ROUTINE
111800        THRU SS95PD-NAP-EXIT.
111900     MOVE SS95WS-OUT-NBR-L12     TO WS-TL1-CR-NBR.
112000     MOVE SS95WS-OUT-AMT-L20     TO WS-TL1-CR-AMT.
112100*
112200     IF  WS-TIPT-IF-PRINT (30)
112300         PERFORM MB22PD-PRINT-2-LINES
112400            THRU MB22PD-P2L-EXIT
112500     ELSE
112600         MOVE SPACES             TO MB20WS-PRINT-LINE
112700         IF  WS-TIPT-IF-PRINT (29)
112800             PERFORM MB22PD-PRINT-1-LINE
112900                THRU MB22PD-P1L-EXIT.
113000*
113100     MOVE 'WINDOW TRANSACTIONS   '
113200                                 TO WS-TL1-LIT-1.
113300     MOVE WS-TT-NBR (X-WS-TT 37) TO SS95WS-IN-NBR.
113400     MOVE WS-TT-AMT (X-WS-TT 37) TO SS95WS-IN-AMT.
113500     PERFORM SS95PD-NAP-ROUTINE
113600        THRU SS95PD-NAP-EXIT.
113700     MOVE SS95WS-OUT-NBR-L12     TO WS-TL1-DR-NBR.
113800     MOVE SS95WS-OUT-AMT-L20     TO WS-TL1-DR-AMT.
113900*
114000     MOVE WS-TT-NBR (X-WS-TT 38) TO SS95WS-IN-NBR.
114100     MOVE WS-TT-AMT (X-WS-TT 38) TO SS95WS-IN-AMT.
114200     PERFORM SS95PD-NAP-ROUTINE
114300        THRU SS95PD-NAP-EXIT.
114400     MOVE SS95WS-OUT-NBR-L12     TO WS-TL1-CR-NBR.
114500     MOVE SS95WS-OUT-AMT-L20     TO WS-TL1-CR-AMT.
114600*
114700     IF  WS-TIPT-IF-PRINT (19)
114800         PERFORM MB22PD-PRINT-1-LINE
114900            THRU MB22PD-P1L-EXIT
115000     ELSE
115100         MOVE SPACES             TO MB20WS-PRINT-LINE.
115200*
115300     MOVE 'DEPOSIT MEMOS         '
115400                                 TO WS-TL1-LIT-1.
115500     MOVE WS-TT-NBR (X-WS-TT 39) TO SS95WS-IN-NBR.
115600     MOVE WS-TT-AMT (X-WS-TT 39) TO SS95WS-IN-AMT.
115700     PERFORM SS95PD-NAP-ROUTINE
115800        THRU SS95PD-NAP-EXIT.
115900     MOVE SS95WS-OUT-NBR-L12     TO WS-TL1-DR-NBR.
116000     MOVE SS95WS-OUT-AMT-L20     TO WS-TL1-DR-AMT.
116100*
116200     MOVE WS-TT-NBR (X-WS-TT 40) TO SS95WS-IN-NBR.
116300     MOVE WS-TT-AMT (X-WS-TT 40) TO SS95WS-IN-AMT.
116400     PERFORM SS95PD-NAP-ROUTINE
116500        THRU SS95PD-NAP-EXIT.
116600     MOVE SS95WS-OUT-NBR-L12     TO WS-TL1-CR-NBR.
116700     MOVE SS95WS-OUT-AMT-L20     TO WS-TL1-CR-AMT.
116800*
116900     IF  WS-TIPT-IF-PRINT (20)
117000         PERFORM MB22PD-PRINT-1-LINE
117100            THRU MB22PD-P1L-EXIT
117200     ELSE
117300         MOVE SPACES             TO MB20WS-PRINT-LINE.
117400*
117500     MOVE 'AUTH DECLINED/APPROVED'
117600                                 TO WS-TL1-LIT-1.
117700     MOVE WS-TT-NBR (X-WS-TT 41) TO SS95WS-IN-NBR.
117800     MOVE WS-TT-AMT (X-WS-TT 41) TO SS95WS-IN-AMT.
117900     PERFORM SS95PD-NAP-ROUTINE
118000        THRU SS95PD-NAP-EXIT.
118100     MOVE SS95WS-OUT-NBR-L12     TO WS-TL1-DR-NBR.
118200     MOVE SS95WS-OUT-AMT-L20     TO WS-TL1-DR-AMT.
118300*
118400     MOVE WS-TT-NBR (X-WS-TT 42) TO SS95WS-IN-NBR.
118500     MOVE WS-TT-AMT (X-WS-TT 42) TO SS95WS-IN-AMT.
118600     PERFORM SS95PD-NAP-ROUTINE
118700        THRU SS95PD-NAP-EXIT.
118800     MOVE SS95WS-OUT-NBR-L12     TO WS-TL1-CR-NBR.
118900     MOVE SS95WS-OUT-AMT-L20     TO WS-TL1-CR-AMT.
119000*
119100     IF  WS-TIPT-IF-PRINT (21)
119200         PERFORM MB22PD-PRINT-1-LINE
119300            THRU MB22PD-P1L-EXIT
119400     ELSE
119500         MOVE SPACES             TO MB20WS-PRINT-LINE.
119600*
119700     MOVE 'MEMOS                 '
119800                                 TO WS-TL1-LIT-1.
119900     MOVE WS-TT-NBR (X-WS-TT 43) TO SS95WS-IN-NBR.
120000     MOVE WS-TT-AMT (X-WS-TT 43) TO SS95WS-IN-AMT.
120100     PERFORM SS95PD-NAP-ROUTINE
120200        THRU SS95PD-NAP-EXIT.
120300     MOVE SS95WS-OUT-NBR-L12     TO WS-TL1-DR-NBR.
120400     MOVE SS95WS-OUT-AMT-L20     TO WS-TL1-DR-AMT.
120500*
120600     MOVE WS-TT-NBR (X-WS-TT 44) TO SS95WS-IN-NBR.
120700     MOVE WS-TT-AMT (X-WS-TT 44) TO SS95WS-IN-AMT.
120800     PERFORM SS95PD-NAP-ROUTINE
120900        THRU SS95PD-NAP-EXIT.
121000     MOVE SS95WS-OUT-NBR-L12     TO WS-TL1-CR-NBR.
121100     MOVE SS95WS-OUT-AMT-L20     TO WS-TL1-CR-AMT.
121200*
121300     IF  WS-TIPT-IF-PRINT (22)
121400         PERFORM MB22PD-PRINT-1-LINE
121500            THRU MB22PD-P1L-EXIT
121600     ELSE
121700         MOVE SPACES             TO MB20WS-PRINT-LINE.
121800*
121900     MOVE 'RESERVE BALANCE       '
122000                                 TO WS-TL1-LIT-1.
122100     MOVE WS-TT-NBR (X-WS-TT 45) TO SS95WS-IN-NBR.
122200     MOVE WS-TT-AMT (X-WS-TT 45) TO SS95WS-IN-AMT.
122300     PERFORM SS95PD-NAP-ROUTINE
122400        THRU SS95PD-NAP-EXIT.
122500     MOVE SS95WS-OUT-NBR-L12     TO WS-TL1-DR-NBR.
122600     MOVE SS95WS-OUT-AMT-L20     TO WS-TL1-DR-AMT.
122700*
122800     MOVE WS-TT-NBR (X-WS-TT 46) TO SS95WS-IN-NBR.
122900     MOVE WS-TT-AMT (X-WS-TT 46) TO SS95WS-IN-AMT.
123000     PERFORM SS95PD-NAP-ROUTINE
123100        THRU SS95PD-NAP-EXIT.
123200     MOVE SS95WS-OUT-NBR-L12     TO WS-TL1-CR-NBR.
123300     MOVE SS95WS-OUT-AMT-L20     TO WS-TL1-CR-AMT.
123400*
123500     IF  WS-TIPT-IF-PRINT (23)
123600         PERFORM MB22PD-PRINT-1-LINE
123700            THRU MB22PD-P1L-EXIT
123800     ELSE
123900         MOVE SPACES             TO MB20WS-PRINT-LINE.
124000*
124100 9030-PT-EXIT.
124200     EXIT.
124300*
124400 9050-ACCUMULATE-TOTALS.
124500*
124600     MOVE MTPT-LOGIC-MODULE      TO MMTCWS-LOGIC-MODULE.
124700*
124800     EVALUATE TRUE
124900         WHEN MMTCWS-LM-BATCH-HDR-DR
125000             SET X-WS-TT-ITEM    TO 1
125100         WHEN MMTCWS-LM-BATCH-HDR-CR
125200             SET X-WS-TT-ITEM    TO 2
125300         WHEN MMTCWS-LM-VALID-RESV-SETT-DR
125400             SET X-WS-TT-ITEM    TO 3
125500         WHEN MMTCWS-LM-VALID-RESV-SETT-CR
125600             SET X-WS-TT-ITEM    TO 4
125700         WHEN MMTCWS-LM-DISCOUNT
125800             SET X-WS-TT-ITEM    TO 5
125900         WHEN MMTCWS-LM-REFUND
126000             SET X-WS-TT-ITEM    TO 6
126100         WHEN MMTCWS-LM-PART-DR
126200             SET X-WS-TT-ITEM    TO 7
126300         WHEN MMTCWS-LM-PART-CR
126400             SET X-WS-TT-ITEM    TO 8
126500         WHEN MMTCWS-LM-ADJ-DR
126600             SET X-WS-TT-ITEM    TO 9
126700         WHEN MMTCWS-LM-ADJ-CR
126800             SET X-WS-TT-ITEM    TO 10
126900         WHEN MMTCWS-LM-RECOVERY-ADJ-DR
127000             SET X-WS-TT-ITEM    TO 11
127100         WHEN MMTCWS-LM-RECOVERY-ADJ-CR
127200             SET X-WS-TT-ITEM    TO 12
127300         WHEN MMTCWS-LM-SYSTEM-FEES-DR
127400             SET X-WS-TT-ITEM    TO 13
127500         WHEN MMTCWS-LM-SYSTEM-FEES-CR
127600             SET X-WS-TT-ITEM    TO 14
127700         WHEN MMTCWS-LM-USER-FEES
127800             SET X-WS-TT-ITEM    TO 15
127900         WHEN MMTCWS-LM-USER-FEES-CR
128000             SET X-WS-TT-ITEM    TO 16
128100         WHEN MMTCWS-LM-INTCHG-FEES-DR
128200             SET X-WS-TT-ITEM    TO 17
128300         WHEN MMTCWS-LM-INTCHG-FEES-CR
128400             SET X-WS-TT-ITEM    TO 18
128500         WHEN MMTCWS-LM-USER-DEBITS
128600             SET X-WS-TT-ITEM    TO 19
128700         WHEN MMTCWS-LM-USER-CREDITS
128800             SET X-WS-TT-ITEM    TO 20
128900         WHEN MMTCWS-LM-SETTLEMENT-DR-XFER
129000             SET X-WS-TT-ITEM    TO 21
129100         WHEN MMTCWS-LM-SETTLEMENT-CR-XFER
129200             SET X-WS-TT-ITEM    TO 22
129300         WHEN MMTCWS-LM-HOLDOVER
129400             SET X-WS-TT-ITEM    TO 23
129500         WHEN MMTCWS-LM-HOLDOVER-CR
129600             SET X-WS-TT-ITEM    TO 24
129700         WHEN MMTCWS-LM-SYSTEM-SETT-DR-ACH
129800             SET X-WS-TT-ITEM    TO 25
129900         WHEN MMTCWS-LM-SYSTEM-SETT-CR-ACH
130000             SET X-WS-TT-ITEM    TO 26
130100         WHEN MMTCWS-LM-SYSTEM-SETT-DR-CHECK
130200             SET X-WS-TT-ITEM    TO 27
130300         WHEN MMTCWS-LM-SYSTEM-SETT-CR-CHECK
130400             SET X-WS-TT-ITEM    TO 28
130500         WHEN MMTCWS-LM-SYSTEM-SETT-DR-WIRE
130600             SET X-WS-TT-ITEM    TO 29
130700         WHEN MMTCWS-LM-SYSTEM-SETT-CR-WIRE
130800             SET X-WS-TT-ITEM    TO 30
130900         WHEN MMTCWS-LM-SYSTEM-SETT-DR-MAN
131000             SET X-WS-TT-ITEM    TO 31
131100         WHEN MMTCWS-LM-SYSTEM-SETT-CR-MAN
131200             SET X-WS-TT-ITEM    TO 32
131300         WHEN MMTCWS-LM-SYSTEM-SETT-DR-BILL
131400             SET X-WS-TT-ITEM    TO 33
131500         WHEN MMTCWS-LM-SYSTEM-SETT-CR-BILL
131600             SET X-WS-TT-ITEM    TO 34
131700         WHEN MMTCWS-LM-WINDOW-SETT-DR
131800             SET X-WS-TT-ITEM    TO 35
131900         WHEN MMTCWS-LM-WINDOW-SETT-CR
132000             SET X-WS-TT-ITEM    TO 36
132100         WHEN MMTCWS-LM-VALID-DEP-MEMO-DR
132200             SET X-WS-TT-ITEM    TO 39
132300         WHEN MMTCWS-LM-VALID-DEP-MEMO-CR
132400             SET X-WS-TT-ITEM    TO 40
132500         WHEN MMTCWS-LM-AUTH-DECLINED
132600             SET X-WS-TT-ITEM    TO 41
132700         WHEN MMTCWS-LM-AUTH-APPROVED
132800             SET X-WS-TT-ITEM    TO 42
132900         WHEN MMTCWS-LM-CHECK-APPROVAL
133000             SET X-WS-TT-ITEM    TO 43
133100         WHEN MMTCWS-LM-RESERVE-TO-PROC
133200             SET X-WS-TT-ITEM    TO 45
133300         WHEN MMTCWS-LM-RESERVE-MANUAL
133400             SET X-WS-TT-ITEM    TO 46
133500         WHEN OTHER
133600             SET X-WS-TT-ITEM    TO 44
133700     END-EVALUATE.
133800*
133900     PERFORM 9060-ADD-TO-TOTALS
134000        THRU 9060-ATT-EXIT.
134100*
134200     EVALUATE TRUE
134300         WHEN (MMTCWS-LM-WINDOW-ALLOWED
134400          AND  MMTCWS-LM-VALID-DEBIT
134500          AND  MTPT-SETTLED-WINDOW)
134600             SET X-WS-TT-ITEM    TO 37
134700             PERFORM 9060-ADD-TO-TOTALS
134800                THRU 9060-ATT-EXIT
134900         WHEN (MMTCWS-LM-WINDOW-ALLOWED
135000          AND  MMTCWS-LM-VALID-CREDIT
135100          AND  MTPT-SETTLED-WINDOW)
135200             SET X-WS-TT-ITEM    TO 38
135300             PERFORM 9060-ADD-TO-TOTALS
135400                THRU 9060-ATT-EXIT
135500     END-EVALUATE.
135600*
135700 9050-AT-EXIT.
135800     EXIT.
135900*
136000 9060-ADD-TO-TOTALS.
136100*
136200     ADD MTPT-NBR-ITEMS          TO WS-TT-NBR (1 X-WS-TT-ITEM).
136300     ADD MTPT-AMOUNT             TO WS-TT-AMT (1 X-WS-TT-ITEM).
136400*
136500     ADD MTPT-NBR-ITEMS          TO WS-TT-NBR (2 X-WS-TT-ITEM).
136600     ADD MTPT-AMOUNT             TO WS-TT-AMT (2 X-WS-TT-ITEM).
136700*
136800     ADD MTPT-NBR-ITEMS          TO WS-TT-NBR (3 X-WS-TT-ITEM).
136900     ADD MTPT-AMOUNT             TO WS-TT-AMT (3 X-WS-TT-ITEM).
137000*
137100 9060-ATT-EXIT.
137200     EXIT.
137300/
137400 9070-ZERO-ORG-ACCUMS.
137500*
137600     INITIALIZE WS-TT-LEVEL (1).
137700*
137800 9070-ZOA-EXIT.
137900     EXIT.
138000*
138100 9080-ZERO-MER-ACCUMS.
138200*
138300     INITIALIZE WS-TT-LEVEL (2).
138400*
138500 9080-ZMA-EXIT.
138600     EXIT.
138700*
138800 9090-ZERO-STORE-ACCUMS.
138900*
139000     INITIALIZE WS-TT-LEVEL (3).
139100*
139200 9090-ZSA-EXIT.
139300     EXIT.
139400*
139500 9100-CHECK-NBR-LINES.
139600*
139700     COMPUTE MB20WS-LINES-REMAINING
139800                                 = MB20WS-LINE-LIMIT
139900                                 - MB20WS-LINE-COUNT.
140000*
140100     IF  MB20WS-LINES-REMAINING IS LESS THAN WS-D720-LINE-CHECK
140200         MOVE MB20WS-FORCE-PAGE  TO MB20WS-LINE-COUNT.
140300*
140400 9100-CNL-EXIT.
140500     EXIT.
140600/
140700     COPY MB22PD.
140800/
140900     COPY SS95PD.
141000/
141100     COPY SS02PD.
141200/
141300     COPY SS07PD.
141400/
141500     COPY SS08PD.
141600/
141700     COPY SS16PD.
141800/
141900     COPY SS26PD.
142000/
142100     COPY SS27PD.
142200*
142300 9995-END-SOURCE-STATEMENTS SECTION.
142400 9999-END-OF-PROGRAM.
142500     EXIT.
