000100 IDENTIFICATION DIVISION.
000200 PROGRAM-ID. MBD72008.
000201*       RELEASE DATE=08/24/01.        REVISION LEVEL=08.06      * ++++++++
000202***************************************************************** ++++++++
000203*WARNING.  THIS COMPUTER PROGRAM IS PROTECTED BY COPYRIGHT LAW  * ++++++++
000204*AND INTERNATIONAL TREATIES.  UNAUTHORIZED REPRODUCTION OR      * ++++++++
000205*DISTRIBUTION OF THIS PROGRAM, OR ANY PORTION OF IT, MAY RESULT * ++++++++
000206*IN SEVERE CIVIL AND CRIMINAL PENATLIES, AND WILL BE PROSECUTED * ++++++++
000207*TO THE MAXIMUM EXTENT POSSIBLE UNDER THE LAW.                  * ++++++++
000208*COPYRIGHT 1999 PAYSYS INTERNATIONAL, INC.  ALL RIGHTS RESERVED.* ++++++++
000209***************************************************************** ++++++++
000300*****************************************************************
000400*                                                               *
000500*   V - PLUS  M E R C H A N T   B A N K C A R D   S Y S T E M   *
000600*                                                               *
000700*       MBD72008 - OPTIONAL REPORT 08 SUBROUTINE                *
000800*                                                               *
000900*****************************************************************
001000 ENVIRONMENT DIVISION.
001100 CONFIGURATION SECTION.
001200 SOURCE-COMPUTER.            IBM-4341.
001300 OBJECT-COMPUTER.            IBM-4341.
001400/
001500 DATA DIVISION.
001600 WORKING-STORAGE SECTION.
001700*
001800 01  FILLER                  PIC  X(12)      VALUE '** WS-BEG **'.
001900*
002000 01  WS-MBD72008-WORK-AREAS.
002100     03  WS-D72008-ACTIVITY-SW
002200                             PIC  X(01)      VALUE 'N'.
002300     03  WS-D720-LINE-CHECK  PIC S9(05)      COMP-3 VALUE +34.
002400*
002500*****************************************************
002600*    THE VALUE FOR THE FOLLWING LEVEL INDICES ARE:  *
002700*       1 - ORGANIZATION                            *
002800*       2 - MERCHANT                                *
002900*       3 - STORE, PLAN OR T/C                      *
003000*                                                   *
003100*    THE VALUE FOR THE FOLLWING ITEM INDICES ARE:   *
003200*       1 - DEPOSITS DEBITS                         *
003300*       2 - DEPOSITS CREDIT                         *
003400*       3 - RESERVES DEBITS                         *
003500*       4 - RESERVES CREDIT                         *
003600*       5 - DISCOUNT DEBITS                         *
003700*       6 - DISCOUNT CREDIT                         *
003800*       7 - PARTICIPTION DEBITS                     *
003900*       8 - PARTICIPTION CREDIT                     *
004000*       9 - SYSTEM ADJUSTMENTS DEBITS               *
004100*      10 - SYSTEM ADJUSTMENTS CREDIT               *
004200*      11 - RECOVERY ADJUSTMENTS DEBITS             *
004300*      12 - RECOVERY ADJUSTMENTS CREDIT             *
004400*      13 - SYSTEM FEES DEBIT                       *
004500*      14 - SYSTEM FEES CREDIT                      *
004600*      15 - USER FEES DEBIT                         *
004700*      16 - USER FEES CREDIT                        *
004800*      17 - INTERCHANGE FEES DEBITS                 *
004900*      18 - INTERCHANGE FEES CREDIT                 *
005000*      19 - USER CREDITS DEBITS                     *
005100*      20 - USER CREDITS CREDIT                     *
005200*      21 - TRANSFER TO BILLING/INVOICE DEBITS      *
005300*      22 - TRANSFER TO BILLING/INVOICE CREDITS     *
005400*      23 - HOLDOVER DEBITS                         *
005500*      24 - HOLDOVER CREDITS                        *
005600*      25 - SETTLEMENT DEBITS -- ACH                *
005700*      26 - SETTLEMENT CREDITS - ACH                *
005800*      27 - SETTLEMENT DEBITS -- CHECK              *
005900*      28 - SETTLEMENT CREDITS - CHECK              *
006000*      29 - SETTLEMENT DEBITS -- WIRE TRANSFER      *
006100*      30 - SETTLEMENT CREDITS - WIRE TRANSFER      *
006200*      31 - SETTLEMENT DEBITS -- MANUAL             *
006300*      32 - SETTLEMENT CREDITS - MANUAL             *
006400*      33 - SETTLEMENT DEBITS -- BILLING/INVOICE    *
006500*      34 - SETTLEMENT CREDITS - BILLING/INVOICE    *
006600*      35 - SETTLEMENT DEBITS -- WINDOW             *
006700*      36 - SETTLEMENT CREDITS - WINDOW             *
006800*      37 - WINDOW TRANSACTIONS DEBITS              *
006900*      38 - WINDOW TRANSACTIONS CREDIT              *
007000*      39 - DEPOSIT MEMOS DEBITS                    *
007100*      40 - DEPOSIT MEMOS CREDIT                    *
007200*      41 - AUTHORIZATION DECLINES                  *
007300*      42 - AUTHORIZATION APPROVALS                 *
007400*      43 - MEMOS DEBITS                            *
007500*      44 - MEMOS CREDITS                           *
007600*      45 - RESERVE BALANCE DEBITS                  *
007700*      46 - RESERVE BALANCE CREDITS                 *
007800*                                                   *
007900*****************************************************
008000*
008100     03  WS-TOTALS-TABLE.
008200         05  WS-TT-LEVEL                     OCCURS 3 TIMES
008300                                             INDEXED BY
008400                                             X-WS-TT.
008500             07  WS-TT-ITEM                  OCCURS 46 TIMES
008600                                             INDEXED BY
008700                                             X-WS-TT-ITEM.
008800                 09  WS-TT-NBR
008900                             PIC S9(09)      COMP-3.
009000                 09  WS-TT-AMT
009100                             PIC S9(17)      COMP-3.
009200/
009300*****************************************************
009400*    THE VALUE FOR THE FOLLWING ITEM INDICES ARE:   *
009500*       1 - DEPOSITS                                *
009600*       2 - RESERVES                                *
009700*       3 - DISCOUNT                                *
009800*       4 - PARTICIPTION                            *
009900*       5 - SYSTEM ADJUSTMENTS                      *
010000*       6 - RECOVERY ADJUSTMENTS                    *
010100*       7 - SYSTEM FEES DEBIT                       *
010200*       8 - USER FEES DEBIT                         *
010300*       9 - INTERCHANGE FEES                        *
010400*      10 - USER CREDITS                            *
010500*      11 - TRANSFER TO BILLING/INVOICE             *
010600*      12 - HOLDOVER                                *
010700*      13 - SETTLEMENT -- ACH                       *
010800*      14 - SETTLEMENT -- CHECK                     *
010900*      15 - SETTLEMENT -- WIRE TRANSFER             *
011000*      16 - SETTLEMENT -- MANUAL                    *
011100*      17 - SETTLEMENT -- BILLING/INVOICE           *
011200*      18 - SETTLEMENT -- WINDOW                    *
011300*      19 - WINDOW TRANSACTIONS                     *
011400*      20 - DEPOSIT MEMOS                           *
011500*      21 - AUTHORIZATION DECLINES                  *
011600*      22 - MEMOS                                   *
011700*      23 - RESERVE BALANCE                         *
011800*      24 - FUTURE USE                              *
011900*      25 - FUTURE USE                              *
012000*      26 - FUTURE USE                              *
012100*      27 - FUTURE USE                              *
012200*      28 - SETTLEMENT IN SUB-TOTAL                 *
012300*      29 - SETTLEMENT IN TOTALS                    *
012400*      30 - SETTLEMENT OUT TOTALS                   *
012500*                                                   *
012600*****************************************************
012700*
012800     03  WS-TOTAL-ITEM-PRINT-TABLE.
012900         05  WS-TIPT-ITEM                    OCCURS 30 TIMES
013000                                             INDEXED BY
013100                                             X-WS-TIPT-ITEM.
013200             07  WS-TIPT-ITEM-FLAG
013300                             PIC  X(01)      VALUE 'N'.
013400                 88  WS-TIPT-IF-PRINT        VALUE 'Y'.
013500                 88  WS-TIPT-IF-NO-PRINT     VALUE 'N'.
013600*
013700     03  WS-TC-ACCUM-TOT.
013800         05  WS-TC-ACCUMS.
013900             07  WS-TC-NBR   PIC S9(09)      COMP-3.
014000             07  WS-TC-AMT   PIC S9(17)      COMP-3.
014100*
014200     03  WS-HOLD-TC-NBR      PIC  9(05)      VALUE ZERO.
014300     03  WS-HOLD-TC-DESC     PIC  X(40)      VALUE ZERO.
014400/
014500     COPY MB20WS.
014600*
014700 01  WS-DETAIL-LINE-1        REDEFINES MB20WS-PRINT-LINE.
014800     03  FILLER              PIC  X(01).
014900     03  WS-DL1-MER-NBR      PIC  9(09).
015000     03  FILLER              PIC  X(01).
015100     03  WS-DL1-STORE-NBR    PIC  9(09).
015200     03  FILLER              PIC  X(02).
015300     03  WS-DL1-TC-NBR       PIC  9(03).
015400     03  FILLER              PIC  X(01).
015500     03  WS-DL1-LM-NBR       PIC  9(03).
015600     03  FILLER              PIC  X(01).
015700     03  WS-DL1-CP-NBR       PIC  9(02).
015800     03  FILLER              PIC  X(01).
015900     03  WS-DL1-QL-NBR       PIC  9(02).
016000     03  FILLER              PIC  X(01).
016100     03  WS-DL1-PLAN-NBR     PIC  9(05).
016200     03  FILLER              PIC  X(01).
016300     03  WS-DL1-WINDOW       PIC  X(01).
016400     03  FILLER              PIC  X(01).
016500     03  WS-DL1-DATE         PIC  X(10).
016600     03  FILLER              PIC  X(01).
016700     03  WS-DL1-SOURCE-NBR   PIC  9(05).
016800     03  FILLER              PIC  X(02).
016900     03  WS-DL1-NBR          PIC  9(05).
017000     03  FILLER              PIC  X(01).
017100     03  WS-DL1-SEQ-NBR      PIC  9(08).
017200     03  FILLER              PIC  X(03).
017300     03  WS-DL1-GL-NBR       PIC  9(01).
017400     03  FILLER              PIC  X(01).
017500     03  WS-DL1-NBR-ITEMS    PIC  X(12).
017600     03  FILLER              PIC  X(01).
017700     03  WS-DL1-TRANS-AMT    PIC  X(21).
017800     03  WS-DL1-DESCRIPTION  PIC  X(15).
017900*
018000 01  WS-MERCHANT-TOTAL-LINE-1
018100                             REDEFINES MB20WS-PRINT-LINE.
018200     03  WS-MTL1-LIT-1       PIC  X(43).
018300     03  FILLER              PIC  X(07).
018400     03  WS-MTL1-TC-NBR      PIC  9(03).
018500     03  FILLER              PIC  X(11).
018600     03  WS-MTL1-TC-DESC     PIC  X(40).
018700     03  FILLER              PIC  X(29).
018800*
018900 01  WS-TC-TOTAL-LINE-2      REDEFINES MB20WS-PRINT-LINE.
019000     03  FILLER              PIC  X(05).
019100     03  WS-TTL2-LIT-1       PIC  X(05).
019200     03  FILLER              PIC  X(16).
019300     03  WS-TTL2-TC-NBR      PIC  X(12).
019400     03  FILLER              PIC  X(07).
019500     03  WS-TTL2-TC-AMT      PIC  X(21).
019600     03  FILLER              PIC  X(66).
019700*
019800 01  WS-ORG-TOTAL-LINE-1     REDEFINES MB20WS-PRINT-LINE.
019900     03  WS-OTL1-LIT-1       PIC  X(47).
020000     03  FILLER              PIC  X(03).
020100     03  WS-OTL1-ORG-NBR     PIC  9(03).
020200     03  FILLER              PIC  X(10).
020300     03  WS-OTL1-ORG-DESC    PIC  X(40).
020400     03  FILLER              PIC  X(29).
020500*
020600 01  WS-HEADING-TOTAL-LINE-1 REDEFINES MB20WS-PRINT-LINE.
020700     03  FILLER              PIC  X(27).
020800     03  WS-HTL1-LIT-1       PIC  X(38).
020900     03  FILLER              PIC  X(04).
021000     03  WS-HTL1-LIT-2       PIC  X(38).
021100     03  FILLER              PIC  X(25).
021200*
021300 01  WS-TOTAL-LINE-1         REDEFINES MB20WS-PRINT-LINE.
021400     03  FILLER              PIC  X(05).
021500     03  WS-TL1-LIT-1        PIC  X(22).
021600     03  WS-TL1-DR-NBR       PIC  X(12).
021700     03  FILLER              PIC  X(06).
021800     03  WS-TL1-DR-AMT       PIC  X(21).
021900     03  FILLER              PIC  X(04).
022000     03  WS-TL1-CR-NBR       PIC  X(12).
022100     03  FILLER              PIC  X(05).
022200     03  WS-TL1-CR-AMT       PIC  X(21).
022300     03  FILLER              PIC  X(24).
022400/
022500     COPY SS95WS.
022600/
022700     COPY MTRFWS REPLACING ==:MTRF:== BY ==MTRF==.
022800/
022900     COPY MTRFRL REPLACING ==:MTRF:== BY ==MWRF==.
023000/
023100     COPY MTPTRL REPLACING ==:MTPT:== BY ==MTPT==.
023200/
023300     COPY MMTCWS.
023400/
023500     COPY MTP0RL REPLACING ==:MTP0:== BY ==MTR0==.
023600/
023700     COPY MTP0RL REPLACING ==:MTP0:== BY ==MTR1==.
023800/
023900     COPY MTP0RL REPLACING ==:MTP0:== BY ==MTR2==.
024000/
024100     COPY MTP0RL REPLACING ==:MTP0:== BY ==MTR3==.
024200/
024300     COPY MTP0RL REPLACING ==:MTP0:== BY ==MTR4==.
024400/
024500     COPY MTP0RL REPLACING ==:MTP0:== BY ==MTR5==.
024600/
024700     COPY MTP0RL REPLACING ==:MTP0:== BY ==MTR6==.
024800/
024900     COPY MTP0RL REPLACING ==:MTP0:== BY ==MTR7==.
025000/
025100     COPY MTP0RL REPLACING ==:MTP0:== BY ==MTR8==.
025200/
025300     COPY MTP0RL REPLACING ==:MTP0:== BY ==MTR9==.
025400/
025500     COPY MB00WS.
025600/
025700     COPY SS00WS.
025800/
025900     COPY SS01WS.
026000/
026100     COPY SS02WS.
026200*
026300 01  FILLER                  PIC  X(12)      VALUE '** WS-END **'.
026400/
026500 LINKAGE SECTION.
026600     COPY MB22WS.
026700/
026800     COPY MTRFRL REPLACING ==:MTRF:== BY ==MTRF==.
026900/
027000 PROCEDURE DIVISION              USING MB22WS-LINK-DATA
027100                                       MTRF-RECORD.
027200*
027300 A000-MAIN-LINE-SECT SECTION.
027400 A010-ML-BEGIN.
027500*
027600     IF  MTRF-K1-RT-DETAIL
027700         PERFORM D000-DETAIL-RECORD
027800            THRU D099-DR-EXIT.
027900*
028000     IF  MTRF-K1-RT-HEADER
028100         PERFORM H000-HEADER-RECORD
028200            THRU H099-HR-EXIT.
028300*
028400     IF  MTRF-K1-RT-TRAILER
028500         PERFORM T000-TRAILER-RECORD
028600            THRU T099-TR-EXIT.
028700*
028800     GOBACK.
028900*
029000 A099-ML-EXIT.
029100     EXIT.
029200/
029300 D000-DETAIL-RECORD SECTION.
029400 D010-DR-BEGIN.
029500*
029600     MOVE 'Y'                    TO WS-D72008-ACTIVITY-SW.
029700*
029800     MOVE MTRF-MT-TRANSACTION    TO MTPT-RECORD.
029900*
030000     IF  MTPT-TRANS-CODE IS NOT EQUAL TO WS-HOLD-TC-NBR
030100     AND WS-HOLD-TC-NBR IS GREATER THAN ZERO
030200         PERFORM 9100-CHECK-NBR-LINES
030300            THRU 9100-CNL-EXIT
030400         PERFORM 9020-PRINT-TC-TOTALS
030500            THRU 9020-PTT-EXIT
030600         PERFORM 9090-ZERO-TC-ACCUMS
030700            THRU 9090-ZTA-EXIT
030800         PERFORM MB22PD-PRINT-1-LINE
030900            THRU MB22PD-P1L-EXIT.
031000*
031100     MOVE MTPT-TRANS-CODE        TO WS-HOLD-TC-NBR.
031200     MOVE MTPT-RPT-DESC          TO WS-HOLD-TC-DESC.
031300*
031400     MOVE MTPT-MERCHANT          TO WS-DL1-MER-NBR.
031500     MOVE MTPT-STORE             TO WS-DL1-STORE-NBR.
031600     MOVE MTPT-TRANS-CODE        TO WS-DL1-TC-NBR.
031700     MOVE MTPT-LOGIC-MODULE      TO WS-DL1-LM-NBR.
031800     MOVE MTPT-PRODUCT           TO WS-DL1-CP-NBR.
031900     MOVE MTPT-QUAL-LEVEL        TO WS-DL1-QL-NBR.
032000     MOVE MTPT-PLAN              TO WS-DL1-PLAN-NBR.
032100*
032200     IF  MTPT-SETTLED-WINDOW
032300         MOVE MTPT-SETT-FLAG     TO WS-DL1-WINDOW.
032400*
032500     MOVE MTPT-BATCH-DATE        TO SS01WS-JULIAN.
032600     PERFORM SS26PD-NUMERICALLY-EDIT-DATE
032700        THRU SS26PD-NED-EXIT.
032800     MOVE SS01WS-XX-XX-YYYY      TO WS-DL1-DATE.
032900     MOVE MTPT-BATCH-SOURCE      TO WS-DL1-SOURCE-NBR.
033000     MOVE MTPT-BATCH-NBR         TO WS-DL1-NBR.
033100     MOVE MTPT-BATCH-SEQ         TO WS-DL1-SEQ-NBR.
033200     MOVE MTPT-GL-SOURCE         TO WS-DL1-GL-NBR.
033300*
033400     MOVE MTPT-NBR-ITEMS         TO SS95WS-IN-NBR.
033500     PERFORM SS95PD-NAP-ROUTINE
033600        THRU SS95PD-NAP-EXIT.
033700     MOVE SS95WS-OUT-NBR-L12     TO WS-DL1-NBR-ITEMS.
033800*
033900     MOVE MTPT-AMOUNT            TO SS95WS-IN-AMT.
034000     PERFORM SS95PD-NAP-ROUTINE
034100        THRU SS95PD-NAP-EXIT.
034200     MOVE SS95WS-OUT-AMT-L20     TO WS-DL1-TRANS-AMT.
034300*
034400     MOVE MTPT-RPT-DESC          TO WS-DL1-DESCRIPTION.
034500*
034600     PERFORM 9050-ACCUMULATE-TOTALS
034700        THRU 9050-AT-EXIT.
034800*
034900     EVALUATE TRUE
035000         WHEN MTRF-K1-DETAIL
035100             PERFORM MB22PD-PRINT-1-LINE
035200                THRU MB22PD-P1L-EXIT
035300         WHEN OTHER
035400             MOVE SPACES         TO MB20WS-PRINT-LINE
035500     END-EVALUATE.
035600*
035700     MOVE MTRF-RECORD            TO MWRF-RECORD.
035800*
035900 D099-DR-EXIT.
036000     EXIT.
036100/
036200 H000-HEADER-RECORD SECTION.
036300 H010-HR-BEGIN.
036400*
036500     MOVE MTRF-K1-FORM           TO MB20WS-FORM-CODE.
036600     MOVE MTRF-HD-DATE-FORMAT    TO SS01WS-DATE-FORMAT.
036700     MOVE MTRF-HD-FICHE-FLAG     TO MB20WS-FICHE-CODE.
036800     MOVE MTRF-HD-SYSTEM-NAME    TO MB20WS-SH-SYSTEM.
036900     MOVE MTRF-HD-REPORT-ID      TO MB20WS-SH-RPT-ID.
037000     MOVE 'O08'                  TO MB20WS-SH-INTERNAL-RPT-ID.
037100     MOVE MTRF-K1-ORG            TO MB20WS-SH-ORG.
037200     MOVE MTRF-HD-ORG-NAME       TO MB20WS-SH-ORG-NAME.
037300     MOVE MTRF-HD-RPT-TITLE      TO MB20WS-SH-RPT-NAME.
037400     MOVE MTRF-HD-FILE-DATE      TO SS01WS-JULIAN.
037500     PERFORM SS26PD-NUMERICALLY-EDIT-DATE
037600        THRU SS26PD-NED-EXIT.
037700     MOVE SS01WS-XX-XX-YYYY      TO MB20WS-SH-FILE-DATE.
037800     MOVE MTRF-HD-REPORT-DEST-ID TO MB20WS-SH-DEST-ID.
037900     MOVE MTRF-HD-DEST-DESC      TO MB20WS-SH-DEST-DESC.
038000*
038100     MOVE '  MERCHANT   STORE   *-- POSTING DATA ---*  '
038200                                 TO MB20WS-SH-L5R-1.
038300     MOVE '*----- BATCH INFORMATION ------*           N'
038400                                 TO MB20WS-SH-L5R-2.
038500     MOVE 'UMBER         TRANSACTION                   '
038600                                 TO MB20WS-SH-L5R-3.
038700*
038800     MOVE '   NUMBER   NUMBER    T/C L/M PR QL  PLAN   '
038900                                 TO MB20WS-SH-L6R-1.
039000     MOVE '   DATE   SOURCE   NBR     SEQ    G/L       '
039100                                 TO MB20WS-SH-L6R-2.
039200     MOVE 'ITEMS            AMOUNT       DESCRIPTION   '
039300                                 TO MB20WS-SH-L6R-3.
039400*
039500     MOVE ZERO                   TO MB20WS-PAGE-COUNT.
039600     MOVE MB20WS-FORCE-PAGE      TO MB20WS-LINE-COUNT.
039700     MOVE MTRF-HD-LINES-PER-PAGE TO MB20WS-LINES-PER-PAGE.
039800     MOVE MTRF-HD-CURRENCY-NOD   TO MTRFWS-SAVE-CURRENCY-NOD.
039900     MOVE MTRF-HD-PER-ITEM-NOD   TO MTRFWS-SAVE-PER-ITEM-NOD.
040000     MOVE MTRF-HD-PERCENT-NOD    TO MTRFWS-SAVE-PERCENT-NOD.
040100     SET SS95WS-FUNCTION-INITIALIZE
040200                                 TO TRUE.
040300     PERFORM SS95PD-NAP-ROUTINE
040400        THRU SS95PD-NAP-EXIT.
040500*
040600     MOVE MTRF-HD-CURRENCY-CODE  TO SS95WS-CURRENCY-CODE.
040700     SET SS95WS-NAP-IND-IS-ALL   TO TRUE.
040800     MOVE 'N'                    TO WS-D72008-ACTIVITY-SW.
040900     MOVE MTRF-RECORD            TO MTR9-RECORD.
041000     MOVE SPACES                 TO MWRF-RECORD.
041100     MOVE ZERO                   TO MWRF-MERCHANT.
041200     PERFORM 9070-ZERO-ORG-ACCUMS
041300        THRU 9070-ZOA-EXIT.
041400     PERFORM 9080-ZERO-MER-ACCUMS
041500        THRU 9080-ZMA-EXIT.
041600     PERFORM 9090-ZERO-TC-ACCUMS
041700        THRU 9090-ZTA-EXIT.
041800     MOVE ZERO                   TO WS-HOLD-TC-NBR.
041900     MOVE SPACES                 TO WS-HOLD-TC-DESC.
042000     INITIALIZE WS-TC-ACCUMS.
042100*
042200*****               111111111122222222223
042300*****      123456789012345678901234567890
042400     MOVE 'YYYYYYYYYYYYYYYYYYYYYYYNNNNYYY'
042500                                 TO WS-TOTAL-ITEM-PRINT-TABLE.
042600*
042700     MOVE 5                      TO WS-D720-LINE-CHECK.
042800*
042900     PERFORM
043000         VARYING X-WS-TIPT-ITEM FROM 1 BY 1
043100         UNTIL   X-WS-TIPT-ITEM IS GREATER THAN 30
043200         IF  WS-TIPT-IF-PRINT (X-WS-TIPT-ITEM)
043300             ADD  1              TO WS-D720-LINE-CHECK
043400         END-IF
043500     END-PERFORM.
043600*
043700     IF  WS-TIPT-IF-PRINT (28)
043800         ADD  1                  TO WS-D720-LINE-CHECK.
043900*
044000     IF  WS-TIPT-IF-PRINT (29)
044100         ADD  1                  TO WS-D720-LINE-CHECK.
044200*
044300     IF  WS-TIPT-IF-PRINT (30)
044400         ADD  1                  TO WS-D720-LINE-CHECK.
044500*
044600 H099-HR-EXIT.
044700     EXIT.
044800/
044900 T000-TRAILER-RECORD SECTION.
045000 T010-TR-BEGIN.
045100*
045200     MOVE MTR9-RECORD            TO MTRF-RECORD.
045300*
045400     IF  WS-D72008-ACTIVITY-SW IS EQUAL TO 'N'
045500         IF  MTRF-HD-AF-PRODUCE
045600             PERFORM MB22PD-PRINT-NO-ACTIVITY
045700                THRU MB22PD-PNA-EXIT
045800             GO TO T099-TR-EXIT
045900         ELSE
046000             GO TO T099-TR-EXIT.
046100*
046200***************************************************************
046300*    WE MUST NOW PRINT MERCHANT TOTALS. THE REASON FOR THIS IS*
046400*    WE COULD HAVE PRINTED SEVERAL DETAIL RECORDS AND THEN    *
046500*    ENCOUNTERED A TRAILER RECORD WITH OUT HAVING  PROCESSED  *
046600*    THE MERCHANT BREAK/TOTALING LOGIC. THIS CODE WILL FORCE  *
046700*    A MERCHANT TOTAL TO BE PRINTED.                          *
046800***************************************************************
046900*
047000     PERFORM 9100-CHECK-NBR-LINES
047100        THRU 9100-CNL-EXIT.
047200*
047300     PERFORM 9020-PRINT-TC-TOTALS
047400        THRU 9020-PTT-EXIT.
047500*
047600     PERFORM 9090-ZERO-TC-ACCUMS
047700        THRU 9090-ZTA-EXIT.
047800*
047900     PERFORM 9100-CHECK-NBR-LINES
048000        THRU 9100-CNL-EXIT.
048100*
048200     PERFORM 9010-PRINT-ORG-TOTALS
048300        THRU 9010-POT-EXIT.
048400*
048500 T099-TR-EXIT.
048600     EXIT.
048700/
048800 9000-PERFORMED-ROUTINES-SECT SECTION.
048900 9010-PRINT-ORG-TOTALS.
049000*
049100     PERFORM MB22PD-PRINT-1-LINE
049200        THRU MB22PD-P1L-EXIT.
049300*
049400     MOVE SPACES                 TO MB20WS-SH-LINE-5
049500                                    MB20WS-SH-LINE-6
049600                                    MB20WS-SH-LINE-7
049700                                    MB20WS-SH-LINE-8.
049800*
049900     MOVE '**** ORGANIZATION TOTALS ****  FOR ORGANIZATION'
050000                                 TO WS-OTL1-LIT-1.
050100     MOVE MTRF-K1-ORG            TO WS-OTL1-ORG-NBR.
050200     MOVE MTRF-HD-ORG-NAME       TO WS-OTL1-ORG-DESC.
050300     PERFORM MB22PD-PRINT-1-LINE
050400        THRU MB22PD-P1L-EXIT.
050500*
050600     SET X-WS-TT                 TO 1.
050700     PERFORM 9030-PRINT-TOTALS
050800        THRU 9030-PT-EXIT.
050900*
051000 9010-POT-EXIT.
051100     EXIT.
051200/
051300 9020-PRINT-TC-TOTALS.
051400*
051500     PERFORM MB22PD-PRINT-1-LINE
051600        THRU MB22PD-P1L-EXIT.
051700*
051800     MOVE '**** TRAN CODE TOTALS ****     FOR TRAN CODE   '
051900                                 TO WS-MTL1-LIT-1.
052000     MOVE WS-HOLD-TC-NBR         TO WS-MTL1-TC-NBR.
052100     MOVE WS-HOLD-TC-DESC        TO WS-MTL1-TC-DESC.
052200     PERFORM MB22PD-PRINT-1-LINE
052300        THRU MB22PD-P1L-EXIT.
052400*
052500     MOVE 'TOTAL'                TO WS-TTL2-LIT-1.
052600     MOVE WS-TC-NBR              TO SS95WS-IN-NBR.
052700     MOVE WS-TC-AMT              TO SS95WS-IN-AMT.
052800     PERFORM SS95PD-NAP-ROUTINE
052900        THRU SS95PD-NAP-EXIT.
053000     MOVE SS95WS-OUT-NBR-L12     TO WS-TTL2-TC-NBR.
053100     MOVE SS95WS-OUT-AMT-L20     TO WS-TTL2-TC-AMT.
053200*
053300     PERFORM MB22PD-PRINT-2-LINES
053400        THRU MB22PD-P2L-EXIT.
053500*
053600     INITIALIZE WS-TC-ACCUMS.
053700*
053800 9020-PTT-EXIT.
053900     EXIT.
054000/
054100 9030-PRINT-TOTALS.
054200*
054300     MOVE '*-------------- DEBITS -------------*'
054400                                 TO WS-HTL1-LIT-1.
054500     MOVE '*------------- CREDITS -------------*'
054600                                 TO WS-HTL1-LIT-2.
054700     PERFORM MB22PD-PRINT-1-LINE
054800        THRU MB22PD-P1L-EXIT.
054900*
055000     MOVE 'DEPOSITS              '
055100                                 TO WS-TL1-LIT-1.
055200     MOVE WS-TT-NBR (X-WS-TT 1)  TO SS95WS-IN-NBR.
055300     MOVE WS-TT-AMT (X-WS-TT 1)  TO SS95WS-IN-AMT.
055400     PERFORM SS95PD-NAP-ROUTINE
055500        THRU SS95PD-NAP-EXIT.
055600     MOVE SS95WS-OUT-NBR-L12     TO WS-TL1-DR-NBR.
055700     MOVE SS95WS-OUT-AMT-L20     TO WS-TL1-DR-AMT.
055800*
055900     MOVE WS-TT-NBR (X-WS-TT 2)  TO SS95WS-IN-NBR.
056000     MOVE WS-TT-AMT (X-WS-TT 2)  TO SS95WS-IN-AMT.
056100     PERFORM SS95PD-NAP-ROUTINE
056200        THRU SS95PD-NAP-EXIT.
056300     MOVE SS95WS-OUT-NBR-L12     TO WS-TL1-CR-NBR.
056400     MOVE SS95WS-OUT-AMT-L20     TO WS-TL1-CR-AMT.
056500*
056600     IF  WS-TIPT-IF-PRINT (1)
056700         PERFORM MB22PD-PRINT-1-LINE
056800            THRU MB22PD-P1L-EXIT
056900     ELSE
057000         MOVE SPACES             TO MB20WS-PRINT-LINE.
057100*
057200     MOVE 'RESERVES              '
057300                                 TO WS-TL1-LIT-1.
057400     MOVE WS-TT-NBR (X-WS-TT 3)  TO SS95WS-IN-NBR.
057500     MOVE WS-TT-AMT (X-WS-TT 3)  TO SS95WS-IN-AMT.
057600     PERFORM SS95PD-NAP-ROUTINE
057700        THRU SS95PD-NAP-EXIT.
057800     MOVE SS95WS-OUT-NBR-L12     TO WS-TL1-DR-NBR.
057900     MOVE SS95WS-OUT-AMT-L20     TO WS-TL1-DR-AMT.
058000*
058100     MOVE WS-TT-NBR (X-WS-TT 4)  TO SS95WS-IN-NBR.
058200     MOVE WS-TT-AMT (X-WS-TT 4)  TO SS95WS-IN-AMT.
058300     PERFORM SS95PD-NAP-ROUTINE
058400        THRU SS95PD-NAP-EXIT.
058500     MOVE SS95WS-OUT-NBR-L12     TO WS-TL1-CR-NBR.
058600     MOVE SS95WS-OUT-AMT-L20     TO WS-TL1-CR-AMT.
058700*
058800     IF  WS-TIPT-IF-PRINT (2)
058900         PERFORM MB22PD-PRINT-1-LINE
059000            THRU MB22PD-P1L-EXIT
059100     ELSE
059200         MOVE SPACES             TO MB20WS-PRINT-LINE.
059300*
059400     MOVE 'DISCOUNT              '
059500                                 TO WS-TL1-LIT-1.
059600     MOVE WS-TT-NBR (X-WS-TT 5)  TO SS95WS-IN-NBR.
059700     MOVE WS-TT-AMT (X-WS-TT 5)  TO SS95WS-IN-AMT.
059800     PERFORM SS95PD-NAP-ROUTINE
059900        THRU SS95PD-NAP-EXIT.
060000     MOVE SS95WS-OUT-NBR-L12     TO WS-TL1-DR-NBR.
060100     MOVE SS95WS-OUT-AMT-L20     TO WS-TL1-DR-AMT.
060200*
060300     MOVE WS-TT-NBR (X-WS-TT 6)  TO SS95WS-IN-NBR.
060400     MOVE WS-TT-AMT (X-WS-TT 6)  TO SS95WS-IN-AMT.
060500     PERFORM SS95PD-NAP-ROUTINE
060600        THRU SS95PD-NAP-EXIT.
060700     MOVE SS95WS-OUT-NBR-L12     TO WS-TL1-CR-NBR.
060800     MOVE SS95WS-OUT-AMT-L20     TO WS-TL1-CR-AMT.
060900*
061000     IF  WS-TIPT-IF-PRINT (3)
061100         PERFORM MB22PD-PRINT-1-LINE
061200            THRU MB22PD-P1L-EXIT
061300     ELSE
061400         MOVE SPACES             TO MB20WS-PRINT-LINE.
061500*
061600     MOVE 'PARTICIPATION         '
061700                                 TO WS-TL1-LIT-1.
061800     MOVE WS-TT-NBR (X-WS-TT 7)  TO SS95WS-IN-NBR.
061900     MOVE WS-TT-AMT (X-WS-TT 7)  TO SS95WS-IN-AMT.
062000     PERFORM SS95PD-NAP-ROUTINE
062100        THRU SS95PD-NAP-EXIT.
062200     MOVE SS95WS-OUT-NBR-L12     TO WS-TL1-DR-NBR.
062300     MOVE SS95WS-OUT-AMT-L20     TO WS-TL1-DR-AMT.
062400*
062500     MOVE WS-TT-NBR (X-WS-TT 8)  TO SS95WS-IN-NBR.
062600     MOVE WS-TT-AMT (X-WS-TT 8)  TO SS95WS-IN-AMT.
062700     PERFORM SS95PD-NAP-ROUTINE
062800        THRU SS95PD-NAP-EXIT.
062900     MOVE SS95WS-OUT-NBR-L12     TO WS-TL1-CR-NBR.
063000     MOVE SS95WS-OUT-AMT-L20     TO WS-TL1-CR-AMT.
063100*
063200     IF  WS-TIPT-IF-PRINT (4)
063300         PERFORM MB22PD-PRINT-1-LINE
063400            THRU MB22PD-P1L-EXIT
063500     ELSE
063600         MOVE SPACES             TO MB20WS-PRINT-LINE.
063700*
063800     MOVE 'MERCHANT ADJUSTMENTS  '
063900                                 TO WS-TL1-LIT-1.
064000     MOVE WS-TT-NBR (X-WS-TT 9)  TO SS95WS-IN-NBR.
064100     MOVE WS-TT-AMT (X-WS-TT 9)  TO SS95WS-IN-AMT.
064200     PERFORM SS95PD-NAP-ROUTINE
064300        THRU SS95PD-NAP-EXIT.
064400     MOVE SS95WS-OUT-NBR-L12     TO WS-TL1-DR-NBR.
064500     MOVE SS95WS-OUT-AMT-L20     TO WS-TL1-DR-AMT.
064600*
064700     MOVE WS-TT-NBR (X-WS-TT 10) TO SS95WS-IN-NBR.
064800     MOVE WS-TT-AMT (X-WS-TT 10) TO SS95WS-IN-AMT.
064900     PERFORM SS95PD-NAP-ROUTINE
065000        THRU SS95PD-NAP-EXIT.
065100     MOVE SS95WS-OUT-NBR-L12     TO WS-TL1-CR-NBR.
065200     MOVE SS95WS-OUT-AMT-L20     TO WS-TL1-CR-AMT.
065300*
065400     IF  WS-TIPT-IF-PRINT (5)
065500         PERFORM MB22PD-PRINT-1-LINE
065600            THRU MB22PD-P1L-EXIT
065700     ELSE
065800         MOVE SPACES             TO MB20WS-PRINT-LINE.
065900*
066000     MOVE 'RECOVERY ADJUSTMENTS  '
066100                                 TO WS-TL1-LIT-1.
066200     MOVE WS-TT-NBR (X-WS-TT 11) TO SS95WS-IN-NBR.
066300     MOVE WS-TT-AMT (X-WS-TT 11) TO SS95WS-IN-AMT.
066400     PERFORM SS95PD-NAP-ROUTINE
066500        THRU SS95PD-NAP-EXIT.
066600     MOVE SS95WS-OUT-NBR-L12     TO WS-TL1-DR-NBR.
066700     MOVE SS95WS-OUT-AMT-L20     TO WS-TL1-DR-AMT.
066800*
066900     MOVE WS-TT-NBR (X-WS-TT 12) TO SS95WS-IN-NBR.
067000     MOVE WS-TT-AMT (X-WS-TT 12) TO SS95WS-IN-AMT.
067100     PERFORM SS95PD-NAP-ROUTINE
067200        THRU SS95PD-NAP-EXIT.
067300     MOVE SS95WS-OUT-NBR-L12     TO WS-TL1-CR-NBR.
067400     MOVE SS95WS-OUT-AMT-L20     TO WS-TL1-CR-AMT.
067500*
067600     IF  WS-TIPT-IF-PRINT (6)
067700         PERFORM MB22PD-PRINT-1-LINE
067800            THRU MB22PD-P1L-EXIT
067900     ELSE
068000         MOVE SPACES             TO MB20WS-PRINT-LINE.
068100*
068200     MOVE 'SYSTEM FEES           '
068300                                 TO WS-TL1-LIT-1.
068400     MOVE WS-TT-NBR (X-WS-TT 13) TO SS95WS-IN-NBR.
068500     MOVE WS-TT-AMT (X-WS-TT 13) TO SS95WS-IN-AMT.
068600     PERFORM SS95PD-NAP-ROUTINE
068700        THRU SS95PD-NAP-EXIT.
068800     MOVE SS95WS-OUT-NBR-L12     TO WS-TL1-DR-NBR.
068900     MOVE SS95WS-OUT-AMT-L20     TO WS-TL1-DR-AMT.
069000*
069100     MOVE WS-TT-NBR (X-WS-TT 14) TO SS95WS-IN-NBR.
069200     MOVE WS-TT-AMT (X-WS-TT 14) TO SS95WS-IN-AMT.
069300     PERFORM SS95PD-NAP-ROUTINE
069400        THRU SS95PD-NAP-EXIT.
069500     MOVE SS95WS-OUT-NBR-L12     TO WS-TL1-CR-NBR.
069600     MOVE SS95WS-OUT-AMT-L20     TO WS-TL1-CR-AMT.
069700*
069800     IF  WS-TIPT-IF-PRINT (7)
069900         PERFORM MB22PD-PRINT-1-LINE
070000            THRU MB22PD-P1L-EXIT
070100     ELSE
070200         MOVE SPACES             TO MB20WS-PRINT-LINE.
070300*
070400     MOVE 'USER FEES             '
070500                                 TO WS-TL1-LIT-1.
070600     MOVE WS-TT-NBR (X-WS-TT 15) TO SS95WS-IN-NBR.
070700     MOVE WS-TT-AMT (X-WS-TT 15) TO SS95WS-IN-AMT.
070800     PERFORM SS95PD-NAP-ROUTINE
070900        THRU SS95PD-NAP-EXIT.
071000     MOVE SS95WS-OUT-NBR-L12     TO WS-TL1-DR-NBR.
071100     MOVE SS95WS-OUT-AMT-L20     TO WS-TL1-DR-AMT.
071200*
071300     MOVE WS-TT-NBR (X-WS-TT 16) TO SS95WS-IN-NBR.
071400     MOVE WS-TT-AMT (X-WS-TT 16) TO SS95WS-IN-AMT.
071500     PERFORM SS95PD-NAP-ROUTINE
071600        THRU SS95PD-NAP-EXIT.
071700     MOVE SS95WS-OUT-NBR-L12     TO WS-TL1-CR-NBR.
071800     MOVE SS95WS-OUT-AMT-L20     TO WS-TL1-CR-AMT.
071900*
072000     IF  WS-TIPT-IF-PRINT (8)
072100         PERFORM MB22PD-PRINT-1-LINE
072200            THRU MB22PD-P1L-EXIT
072300     ELSE
072400         MOVE SPACES             TO MB20WS-PRINT-LINE.
072500*
072600     MOVE 'INTERCHANGE FEES      '
072700                                 TO WS-TL1-LIT-1.
072800     MOVE WS-TT-NBR (X-WS-TT 17) TO SS95WS-IN-NBR.
072900     MOVE WS-TT-AMT (X-WS-TT 17) TO SS95WS-IN-AMT.
073000     PERFORM SS95PD-NAP-ROUTINE
073100        THRU SS95PD-NAP-EXIT.
073200     MOVE SS95WS-OUT-NBR-L12     TO WS-TL1-DR-NBR.
073300     MOVE SS95WS-OUT-AMT-L20     TO WS-TL1-DR-AMT.
073400*
073500     MOVE WS-TT-NBR (X-WS-TT 18) TO SS95WS-IN-NBR.
073600     MOVE WS-TT-AMT (X-WS-TT 18) TO SS95WS-IN-AMT.
073700     PERFORM SS95PD-NAP-ROUTINE
073800        THRU SS95PD-NAP-EXIT.
073900     MOVE SS95WS-OUT-NBR-L12     TO WS-TL1-CR-NBR.
074000     MOVE SS95WS-OUT-AMT-L20     TO WS-TL1-CR-AMT.
074100*
074200     IF  WS-TIPT-IF-PRINT (9)
074300         PERFORM MB22PD-PRINT-1-LINE
074400            THRU MB22PD-P1L-EXIT
074500     ELSE
074600         MOVE SPACES             TO MB20WS-PRINT-LINE.
074700*
074800     MOVE 'USER CREDITS          '
074900                                 TO WS-TL1-LIT-1.
075000     MOVE WS-TT-NBR (X-WS-TT 19) TO SS95WS-IN-NBR.
075100     MOVE WS-TT-AMT (X-WS-TT 19) TO SS95WS-IN-AMT.
075200     PERFORM SS95PD-NAP-ROUTINE
075300        THRU SS95PD-NAP-EXIT.
075400     MOVE SS95WS-OUT-NBR-L12     TO WS-TL1-DR-NBR.
075500     MOVE SS95WS-OUT-AMT-L20     TO WS-TL1-DR-AMT.
075600*
075700     MOVE WS-TT-NBR (X-WS-TT 20) TO SS95WS-IN-NBR.
075800     MOVE WS-TT-AMT (X-WS-TT 20) TO SS95WS-IN-AMT.
075900     PERFORM SS95PD-NAP-ROUTINE
076000        THRU SS95PD-NAP-EXIT.
076100     MOVE SS95WS-OUT-NBR-L12     TO WS-TL1-CR-NBR.
076200     MOVE SS95WS-OUT-AMT-L20     TO WS-TL1-CR-AMT.
076300*
076400     IF  WS-TIPT-IF-PRINT (10)
076500         PERFORM MB22PD-PRINT-1-LINE
076600            THRU MB22PD-P1L-EXIT
076700     ELSE
076800         MOVE SPACES             TO MB20WS-PRINT-LINE.
076900*
077000     MOVE ALL '-'                TO WS-TL1-DR-NBR.
077100     MOVE ALL '-'                TO WS-TL1-DR-AMT.
077200     MOVE ALL '-'                TO WS-TL1-CR-NBR.
077300     MOVE ALL '-'                TO WS-TL1-CR-AMT.
077400*
077500     IF  WS-TIPT-IF-PRINT (28)
077600         PERFORM MB22PD-PRINT-1-LINE
077700            THRU MB22PD-P1L-EXIT
077800     ELSE
077900         MOVE SPACES             TO MB20WS-PRINT-LINE.
078000*
078100     MOVE '    SUB-TOTAL.........'
078200                                 TO WS-TL1-LIT-1.
078300     COMPUTE SS95WS-IN-NBR       =  WS-TT-NBR (X-WS-TT 1)
078400                                 +  WS-TT-NBR (X-WS-TT 3)
078500                                 +  WS-TT-NBR (X-WS-TT 5)
078600                                 +  WS-TT-NBR (X-WS-TT 7)
078700                                 +  WS-TT-NBR (X-WS-TT 9)
078800                                 +  WS-TT-NBR (X-WS-TT 11)
078900                                 +  WS-TT-NBR (X-WS-TT 13)
079000                                 +  WS-TT-NBR (X-WS-TT 15)
079100                                 +  WS-TT-NBR (X-WS-TT 17)
079200                                 +  WS-TT-NBR (X-WS-TT 19).
079300     COMPUTE SS95WS-IN-AMT       =  WS-TT-AMT (X-WS-TT 1)
079400                                 +  WS-TT-AMT (X-WS-TT 3)
079500                                 +  WS-TT-AMT (X-WS-TT 5)
079600                                 +  WS-TT-AMT (X-WS-TT 7)
079700                                 +  WS-TT-AMT (X-WS-TT 9)
079800                                 +  WS-TT-AMT (X-WS-TT 11)
079900                                 +  WS-TT-AMT (X-WS-TT 13)
080000                                 +  WS-TT-AMT (X-WS-TT 15)
080100                                 +  WS-TT-AMT (X-WS-TT 17)
080200                                 +  WS-TT-AMT (X-WS-TT 19).
080300     PERFORM SS95PD-NAP-ROUTINE
080400        THRU SS95PD-NAP-EXIT.
080500     MOVE SS95WS-OUT-NBR-L12     TO WS-TL1-DR-NBR.
080600     MOVE SS95WS-OUT-AMT-L20     TO WS-TL1-DR-AMT.
080700*
080800     COMPUTE SS95WS-IN-NBR       =  WS-TT-NBR (X-WS-TT 2)
080900                                 +  WS-TT-NBR (X-WS-TT 4)
081000                                 +  WS-TT-NBR (X-WS-TT 6)
081100                                 +  WS-TT-NBR (X-WS-TT 8)
081200                                 +  WS-TT-NBR (X-WS-TT 10)
081300                                 +  WS-TT-NBR (X-WS-TT 12)
081400                                 +  WS-TT-NBR (X-WS-TT 14)
081500                                 +  WS-TT-NBR (X-WS-TT 16)
081600                                 +  WS-TT-NBR (X-WS-TT 18)
081700                                 +  WS-TT-NBR (X-WS-TT 20).
081800     COMPUTE SS95WS-IN-AMT       =  WS-TT-AMT (X-WS-TT 2)
081900                                 +  WS-TT-AMT (X-WS-TT 4)
082000                                 +  WS-TT-AMT (X-WS-TT 6)
082100                                 +  WS-TT-AMT (X-WS-TT 8)
082200                                 +  WS-TT-AMT (X-WS-TT 10)
082300                                 +  WS-TT-AMT (X-WS-TT 12)
082400                                 +  WS-TT-AMT (X-WS-TT 14)
082500                                 +  WS-TT-AMT (X-WS-TT 16)
082600                                 +  WS-TT-AMT (X-WS-TT 18)
082700                                 +  WS-TT-AMT (X-WS-TT 20).
082800     PERFORM SS95PD-NAP-ROUTINE
082900        THRU SS95PD-NAP-EXIT.
083000     MOVE SS95WS-OUT-NBR-L12     TO WS-TL1-CR-NBR.
083100     MOVE SS95WS-OUT-AMT-L20     TO WS-TL1-CR-AMT.
083200*
083300     IF  WS-TIPT-IF-PRINT (28)
083400         PERFORM MB22PD-PRINT-1-LINE
083500            THRU MB22PD-P1L-EXIT
083600     ELSE
083700         MOVE SPACES             TO MB20WS-PRINT-LINE.
083800*
083900     MOVE 'TRANSFER TO INVOICE   '
084000                                 TO WS-TL1-LIT-1.
084100     MOVE WS-TT-NBR (X-WS-TT 21) TO SS95WS-IN-NBR.
084200     MOVE WS-TT-AMT (X-WS-TT 21) TO SS95WS-IN-AMT.
084300     PERFORM SS95PD-NAP-ROUTINE
084400        THRU SS95PD-NAP-EXIT.
084500     MOVE SS95WS-OUT-NBR-L12     TO WS-TL1-DR-NBR.
084600     MOVE SS95WS-OUT-AMT-L20     TO WS-TL1-DR-AMT.
084700*
084800     MOVE WS-TT-NBR (X-WS-TT 22) TO SS95WS-IN-NBR.
084900     MOVE WS-TT-AMT (X-WS-TT 22) TO SS95WS-IN-AMT.
085000     PERFORM SS95PD-NAP-ROUTINE
085100        THRU SS95PD-NAP-EXIT.
085200     MOVE SS95WS-OUT-NBR-L12     TO WS-TL1-CR-NBR.
085300     MOVE SS95WS-OUT-AMT-L20     TO WS-TL1-CR-AMT.
085400*
085500     IF  WS-TIPT-IF-PRINT (11)
085600         PERFORM MB22PD-PRINT-1-LINE
085700            THRU MB22PD-P1L-EXIT
085800     ELSE
085900         MOVE SPACES             TO MB20WS-PRINT-LINE.
086000*
086100     MOVE 'HOLDOVER TRANSACTIONS '
086200                                 TO WS-TL1-LIT-1.
086300     MOVE WS-TT-NBR (X-WS-TT 23) TO SS95WS-IN-NBR.
086400     MOVE WS-TT-AMT (X-WS-TT 23) TO SS95WS-IN-AMT.
086500     PERFORM SS95PD-NAP-ROUTINE
086600        THRU SS95PD-NAP-EXIT.
086700     MOVE SS95WS-OUT-NBR-L12     TO WS-TL1-DR-NBR.
086800     MOVE SS95WS-OUT-AMT-L20     TO WS-TL1-DR-AMT.
086900*
087000     MOVE WS-TT-NBR (X-WS-TT 24) TO SS95WS-IN-NBR.
087100     MOVE WS-TT-AMT (X-WS-TT 24) TO SS95WS-IN-AMT.
087200     PERFORM SS95PD-NAP-ROUTINE
087300        THRU SS95PD-NAP-EXIT.
087400     MOVE SS95WS-OUT-NBR-L12     TO WS-TL1-CR-NBR.
087500     MOVE SS95WS-OUT-AMT-L20     TO WS-TL1-CR-AMT.
087600*
087700     IF  WS-TIPT-IF-PRINT (12)
087800         PERFORM MB22PD-PRINT-1-LINE
087900            THRU MB22PD-P1L-EXIT
088000     ELSE
088100         MOVE SPACES             TO MB20WS-PRINT-LINE.
088200*
088300     MOVE ALL '-'                TO WS-TL1-DR-NBR.
088400     MOVE ALL '-'                TO WS-TL1-DR-AMT.
088500     MOVE ALL '-'                TO WS-TL1-CR-NBR.
088600     MOVE ALL '-'                TO WS-TL1-CR-AMT.
088700*
088800     IF  WS-TIPT-IF-PRINT (29)
088900         PERFORM MB22PD-PRINT-1-LINE
089000            THRU MB22PD-P1L-EXIT
089100     ELSE
089200         MOVE SPACES             TO MB20WS-PRINT-LINE.
089300*
089400     MOVE '*SETTLEMENT IN TOTAL* '
089500                                 TO WS-TL1-LIT-1.
089600     COMPUTE SS95WS-IN-NBR       =  WS-TT-NBR (X-WS-TT 1)
089700                                 +  WS-TT-NBR (X-WS-TT 3)
089800                                 +  WS-TT-NBR (X-WS-TT 5)
089900                                 +  WS-TT-NBR (X-WS-TT 7)
090000                                 +  WS-TT-NBR (X-WS-TT 9)
090100                                 +  WS-TT-NBR (X-WS-TT 11)
090200                                 +  WS-TT-NBR (X-WS-TT 13)
090300                                 +  WS-TT-NBR (X-WS-TT 15)
090400                                 +  WS-TT-NBR (X-WS-TT 17)
090500                                 +  WS-TT-NBR (X-WS-TT 19)
090600                                 +  WS-TT-NBR (X-WS-TT 21)
090700                                 +  WS-TT-NBR (X-WS-TT 23).
090800     COMPUTE SS95WS-IN-AMT       =  WS-TT-AMT (X-WS-TT 1)
090900                                 +  WS-TT-AMT (X-WS-TT 3)
091000                                 +  WS-TT-AMT (X-WS-TT 5)
091100                                 +  WS-TT-AMT (X-WS-TT 7)
091200                                 +  WS-TT-AMT (X-WS-TT 9)
091300                                 +  WS-TT-AMT (X-WS-TT 11)
091400                                 +  WS-TT-AMT (X-WS-TT 13)
091500                                 +  WS-TT-AMT (X-WS-TT 15)
091600                                 +  WS-TT-AMT (X-WS-TT 17)
091700                                 +  WS-TT-AMT (X-WS-TT 19)
091800                                 +  WS-TT-AMT (X-WS-TT 21)
091900                                 +  WS-TT-AMT (X-WS-TT 23).
092000     PERFORM SS95PD-NAP-ROUTINE
092100        THRU SS95PD-NAP-EXIT.
092200     MOVE SS95WS-OUT-NBR-L12     TO WS-TL1-DR-NBR.
092300     MOVE SS95WS-OUT-AMT-L20     TO WS-TL1-DR-AMT.
092400*
092500     COMPUTE SS95WS-IN-NBR       =  WS-TT-NBR (X-WS-TT 2)
092600                                 +  WS-TT-NBR (X-WS-TT 4)
092700                                 +  WS-TT-NBR (X-WS-TT 6)
092800                                 +  WS-TT-NBR (X-WS-TT 8)
092900                                 +  WS-TT-NBR (X-WS-TT 10)
093000                                 +  WS-TT-NBR (X-WS-TT 12)
093100                                 +  WS-TT-NBR (X-WS-TT 14)
093200                                 +  WS-TT-NBR (X-WS-TT 16)
093300                                 +  WS-TT-NBR (X-WS-TT 18)
093400                                 +  WS-TT-NBR (X-WS-TT 20)
093500                                 +  WS-TT-NBR (X-WS-TT 22)
093600                                 +  WS-TT-NBR (X-WS-TT 24).
093700     COMPUTE SS95WS-IN-AMT       =  WS-TT-AMT (X-WS-TT 2)
093800                                 +  WS-TT-AMT (X-WS-TT 4)
093900                                 +  WS-TT-AMT (X-WS-TT 6)
094000                                 +  WS-TT-AMT (X-WS-TT 8)
094100                                 +  WS-TT-AMT (X-WS-TT 10)
094200                                 +  WS-TT-AMT (X-WS-TT 12)
094300                                 +  WS-TT-AMT (X-WS-TT 14)
094400                                 +  WS-TT-AMT (X-WS-TT 16)
094500                                 +  WS-TT-AMT (X-WS-TT 18)
094600                                 +  WS-TT-AMT (X-WS-TT 20)
094700                                 +  WS-TT-AMT (X-WS-TT 22)
094800                                 +  WS-TT-AMT (X-WS-TT 24).
094900     PERFORM SS95PD-NAP-ROUTINE
095000        THRU SS95PD-NAP-EXIT.
095100     MOVE SS95WS-OUT-NBR-L12     TO WS-TL1-CR-NBR.
095200     MOVE SS95WS-OUT-AMT-L20     TO WS-TL1-CR-AMT.
095300*
095400     IF  WS-TIPT-IF-PRINT (29)
095500         PERFORM MB22PD-PRINT-2-LINES
095600            THRU MB22PD-P2L-EXIT
095700     ELSE
095800         MOVE SPACES             TO MB20WS-PRINT-LINE
095900         PERFORM MB22PD-PRINT-1-LINE
096000            THRU MB22PD-P1L-EXIT.
096100*
096200     MOVE 'SETTLEMENT - A C H    '
096300                                 TO WS-TL1-LIT-1.
096400     MOVE WS-TT-NBR (X-WS-TT 25) TO SS95WS-IN-NBR.
096500     MOVE WS-TT-AMT (X-WS-TT 25) TO SS95WS-IN-AMT.
096600     PERFORM SS95PD-NAP-ROUTINE
096700        THRU SS95PD-NAP-EXIT.
096800     MOVE SS95WS-OUT-NBR-L12     TO WS-TL1-DR-NBR.
096900     MOVE SS95WS-OUT-AMT-L20     TO WS-TL1-DR-AMT.
097000*
097100     MOVE WS-TT-NBR (X-WS-TT 26) TO SS95WS-IN-NBR.
097200     MOVE WS-TT-AMT (X-WS-TT 26) TO SS95WS-IN-AMT.
097300     PERFORM SS95PD-NAP-ROUTINE
097400        THRU SS95PD-NAP-EXIT.
097500     MOVE SS95WS-OUT-NBR-L12     TO WS-TL1-CR-NBR.
097600     MOVE SS95WS-OUT-AMT-L20     TO WS-TL1-CR-AMT.
097700*
097800     IF  WS-TIPT-IF-PRINT (13)
097900         PERFORM MB22PD-PRINT-1-LINE
098000            THRU MB22PD-P1L-EXIT
098100     ELSE
098200         MOVE SPACES             TO MB20WS-PRINT-LINE.
098300*
098400     MOVE 'SETTLEMENT - CHECK    '
098500                                 TO WS-TL1-LIT-1.
098600     MOVE WS-TT-NBR (X-WS-TT 27) TO SS95WS-IN-NBR.
098700     MOVE WS-TT-AMT (X-WS-TT 27) TO SS95WS-IN-AMT.
098800     PERFORM SS95PD-NAP-ROUTINE
098900        THRU SS95PD-NAP-EXIT.
099000     MOVE SS95WS-OUT-NBR-L12     TO WS-TL1-DR-NBR.
099100     MOVE SS95WS-OUT-AMT-L20     TO WS-TL1-DR-AMT.
099200*
099300     MOVE WS-TT-NBR (X-WS-TT 28) TO SS95WS-IN-NBR.
099400     MOVE WS-TT-AMT (X-WS-TT 28) TO SS95WS-IN-AMT.
099500     PERFORM SS95PD-NAP-ROUTINE
099600        THRU SS95PD-NAP-EXIT.
099700     MOVE SS95WS-OUT-NBR-L12     TO WS-TL1-CR-NBR.
099800     MOVE SS95WS-OUT-AMT-L20     TO WS-TL1-CR-AMT.
099900*
100000     IF  WS-TIPT-IF-PRINT (14)
100100         PERFORM MB22PD-PRINT-1-LINE
100200            THRU MB22PD-P1L-EXIT
100300     ELSE
100400         MOVE SPACES             TO MB20WS-PRINT-LINE.
100500*
100600     MOVE 'SETTLEMENT - WIRE     '
100700                                 TO WS-TL1-LIT-1.
100800     MOVE WS-TT-NBR (X-WS-TT 29) TO SS95WS-IN-NBR.
100900     MOVE WS-TT-AMT (X-WS-TT 29) TO SS95WS-IN-AMT.
101000     PERFORM SS95PD-NAP-ROUTINE
101100        THRU SS95PD-NAP-EXIT.
101200     MOVE SS95WS-OUT-NBR-L12     TO WS-TL1-DR-NBR.
101300     MOVE SS95WS-OUT-AMT-L20     TO WS-TL1-DR-AMT.
101400*
101500     MOVE WS-TT-NBR (X-WS-TT 30) TO SS95WS-IN-NBR.
101600     MOVE WS-TT-AMT (X-WS-TT 30) TO SS95WS-IN-AMT.
101700     PERFORM SS95PD-NAP-ROUTINE
101800        THRU SS95PD-NAP-EXIT.
101900     MOVE SS95WS-OUT-NBR-L12     TO WS-TL1-CR-NBR.
102000     MOVE SS95WS-OUT-AMT-L20     TO WS-TL1-CR-AMT.
102100*
102200     IF  WS-TIPT-IF-PRINT (15)
102300         PERFORM MB22PD-PRINT-1-LINE
102400            THRU MB22PD-P1L-EXIT
102500     ELSE
102600         MOVE SPACES             TO MB20WS-PRINT-LINE.
102700*
102800     MOVE 'SETTLEMENT - MANUAL   '
102900                                 TO WS-TL1-LIT-1.
103000     MOVE WS-TT-NBR (X-WS-TT 31) TO SS95WS-IN-NBR.
103100     MOVE WS-TT-AMT (X-WS-TT 31) TO SS95WS-IN-AMT.
103200     PERFORM SS95PD-NAP-ROUTINE
103300        THRU SS95PD-NAP-EXIT.
103400     MOVE SS95WS-OUT-NBR-L12     TO WS-TL1-DR-NBR.
103500     MOVE SS95WS-OUT-AMT-L20     TO WS-TL1-DR-AMT.
103600*
103700     MOVE WS-TT-NBR (X-WS-TT 32) TO SS95WS-IN-NBR.
103800     MOVE WS-TT-AMT (X-WS-TT 32) TO SS95WS-IN-AMT.
103900     PERFORM SS95PD-NAP-ROUTINE
104000        THRU SS95PD-NAP-EXIT.
104100     MOVE SS95WS-OUT-NBR-L12     TO WS-TL1-CR-NBR.
104200     MOVE SS95WS-OUT-AMT-L20     TO WS-TL1-CR-AMT.
104300*
104400     IF  WS-TIPT-IF-PRINT (16)
104500         PERFORM MB22PD-PRINT-1-LINE
104600            THRU MB22PD-P1L-EXIT
104700     ELSE
104800         MOVE SPACES             TO MB20WS-PRINT-LINE.
104900*
105000     MOVE 'SETTLEMENT - INVOICE  '
105100                                 TO WS-TL1-LIT-1.
105200     MOVE WS-TT-NBR (X-WS-TT 33) TO SS95WS-IN-NBR.
105300     MOVE WS-TT-AMT (X-WS-TT 33) TO SS95WS-IN-AMT.
105400     PERFORM SS95PD-NAP-ROUTINE
105500        THRU SS95PD-NAP-EXIT.
105600     MOVE SS95WS-OUT-NBR-L12     TO WS-TL1-DR-NBR.
105700     MOVE SS95WS-OUT-AMT-L20     TO WS-TL1-DR-AMT.
105800*
105900     MOVE WS-TT-NBR (X-WS-TT 34) TO SS95WS-IN-NBR.
106000     MOVE WS-TT-AMT (X-WS-TT 34) TO SS95WS-IN-AMT.
106100     PERFORM SS95PD-NAP-ROUTINE
106200        THRU SS95PD-NAP-EXIT.
106300     MOVE SS95WS-OUT-NBR-L12     TO WS-TL1-CR-NBR.
106400     MOVE SS95WS-OUT-AMT-L20     TO WS-TL1-CR-AMT.
106500*
106600     IF  WS-TIPT-IF-PRINT (17)
106700         PERFORM MB22PD-PRINT-1-LINE
106800            THRU MB22PD-P1L-EXIT
106900     ELSE
107000         MOVE SPACES             TO MB20WS-PRINT-LINE.
107100*
107200     MOVE 'SETTLEMENT - WINDOW   '
107300                                 TO WS-TL1-LIT-1.
107400     MOVE WS-TT-NBR (X-WS-TT 35) TO SS95WS-IN-NBR.
107500     MOVE WS-TT-AMT (X-WS-TT 35) TO SS95WS-IN-AMT.
107600     PERFORM SS95PD-NAP-ROUTINE
107700        THRU SS95PD-NAP-EXIT.
107800     MOVE SS95WS-OUT-NBR-L12     TO WS-TL1-DR-NBR.
107900     MOVE SS95WS-OUT-AMT-L20     TO WS-TL1-DR-AMT.
108000*
108100     MOVE WS-TT-NBR (X-WS-TT 36) TO SS95WS-IN-NBR.
108200     MOVE WS-TT-AMT (X-WS-TT 36) TO SS95WS-IN-AMT.
108300     PERFORM SS95PD-NAP-ROUTINE
108400        THRU SS95PD-NAP-EXIT.
108500     MOVE SS95WS-OUT-NBR-L12     TO WS-TL1-CR-NBR.
108600     MOVE SS95WS-OUT-AMT-L20     TO WS-TL1-CR-AMT.
108700*
108800     IF  WS-TIPT-IF-PRINT (18)
108900         PERFORM MB22PD-PRINT-1-LINE
109000            THRU MB22PD-P1L-EXIT
109100     ELSE
109200         MOVE SPACES             TO MB20WS-PRINT-LINE.
109300*
109400     MOVE ALL '-'                TO WS-TL1-DR-NBR.
109500     MOVE ALL '-'                TO WS-TL1-DR-AMT.
109600     MOVE ALL '-'                TO WS-TL1-CR-NBR.
109700     MOVE ALL '-'                TO WS-TL1-CR-AMT.
109800*
109900     IF  WS-TIPT-IF-PRINT (30)
110000         PERFORM MB22PD-PRINT-1-LINE
110100            THRU MB22PD-P1L-EXIT
110200     ELSE
110300         MOVE SPACES             TO MB20WS-PRINT-LINE.
110400*
110500     MOVE '*SETTLEMENT OUT TOTAL*'
110600                                 TO WS-TL1-LIT-1.
110700     COMPUTE SS95WS-IN-NBR       =  WS-TT-NBR (X-WS-TT 25)
110800                                 +  WS-TT-NBR (X-WS-TT 27)
110900                                 +  WS-TT-NBR (X-WS-TT 29)
111000                                 +  WS-TT-NBR (X-WS-TT 31)
111100                                 +  WS-TT-NBR (X-WS-TT 33)
111200                                 +  WS-TT-NBR (X-WS-TT 35).
111300     COMPUTE SS95WS-IN-AMT       =  WS-TT-AMT (X-WS-TT 25)
111400                                 +  WS-TT-AMT (X-WS-TT 27)
111500                                 +  WS-TT-AMT (X-WS-TT 29)
111600                                 +  WS-TT-AMT (X-WS-TT 31)
111700                                 +  WS-TT-AMT (X-WS-TT 33)
111800                                 +  WS-TT-AMT (X-WS-TT 35).
111900     PERFORM SS95PD-NAP-ROUTINE
112000        THRU SS95PD-NAP-EXIT.
112100     MOVE SS95WS-OUT-NBR-L12     TO WS-TL1-DR-NBR.
112200     MOVE SS95WS-OUT-AMT-L20     TO WS-TL1-DR-AMT.
112300*
112400     COMPUTE SS95WS-IN-NBR       =  WS-TT-NBR (X-WS-TT 26)
112500                                 +  WS-TT-NBR (X-WS-TT 28)
112600                                 +  WS-TT-NBR (X-WS-TT 30)
112700                                 +  WS-TT-NBR (X-WS-TT 32)
112800                                 +  WS-TT-NBR (X-WS-TT 34)
112900                                 +  WS-TT-NBR (X-WS-TT 36).
113000     COMPUTE SS95WS-IN-AMT       =  WS-TT-AMT (X-WS-TT 26)
113100                                 +  WS-TT-AMT (X-WS-TT 28)
113200                                 +  WS-TT-AMT (X-WS-TT 30)
113300                                 +  WS-TT-AMT (X-WS-TT 32)
113400                                 +  WS-TT-AMT (X-WS-TT 34)
113500                                 +  WS-TT-AMT (X-WS-TT 36).
113600     PERFORM SS95PD-NAP-ROUTINE
113700        THRU SS95PD-NAP-EXIT.
113800     MOVE SS95WS-OUT-NBR-L12     TO WS-TL1-CR-NBR.
113900     MOVE SS95WS-OUT-AMT-L20     TO WS-TL1-CR-AMT.
114000*
114100     IF  WS-TIPT-IF-PRINT (30)
114200         PERFORM MB22PD-PRINT-2-LINES
114300            THRU MB22PD-P2L-EXIT
114400     ELSE
114500         MOVE SPACES             TO MB20WS-PRINT-LINE
114600         IF  WS-TIPT-IF-PRINT (29)
114700             PERFORM MB22PD-PRINT-1-LINE
114800                THRU MB22PD-P1L-EXIT.
114900*
115000     MOVE 'WINDOW TRANSACTIONS   '
115100                                 TO WS-TL1-LIT-1.
115200     MOVE WS-TT-NBR (X-WS-TT 37) TO SS95WS-IN-NBR.
115300     MOVE WS-TT-AMT (X-WS-TT 37) TO SS95WS-IN-AMT.
115400     PERFORM SS95PD-NAP-ROUTINE
115500        THRU SS95PD-NAP-EXIT.
115600     MOVE SS95WS-OUT-NBR-L12     TO WS-TL1-DR-NBR.
115700     MOVE SS95WS-OUT-AMT-L20     TO WS-TL1-DR-AMT.
115800*
115900     MOVE WS-TT-NBR (X-WS-TT 38) TO SS95WS-IN-NBR.
116000     MOVE WS-TT-AMT (X-WS-TT 38) TO SS95WS-IN-AMT.
116100     PERFORM SS95PD-NAP-ROUTINE
116200        THRU SS95PD-NAP-EXIT.
116300     MOVE SS95WS-OUT-NBR-L12     TO WS-TL1-CR-NBR.
116400     MOVE SS95WS-OUT-AMT-L20     TO WS-TL1-CR-AMT.
116500*
116600     IF  WS-TIPT-IF-PRINT (19)
116700         PERFORM MB22PD-PRINT-1-LINE
116800            THRU MB22PD-P1L-EXIT
116900     ELSE
117000         MOVE SPACES             TO MB20WS-PRINT-LINE.
117100*
117200     MOVE 'DEPOSIT MEMOS         '
117300                                 TO WS-TL1-LIT-1.
117400     MOVE WS-TT-NBR (X-WS-TT 39) TO SS95WS-IN-NBR.
117500     MOVE WS-TT-AMT (X-WS-TT 39) TO SS95WS-IN-AMT.
117600     PERFORM SS95PD-NAP-ROUTINE
117700        THRU SS95PD-NAP-EXIT.
117800     MOVE SS95WS-OUT-NBR-L12     TO WS-TL1-DR-NBR.
117900     MOVE SS95WS-OUT-AMT-L20     TO WS-TL1-DR-AMT.
118000*
118100     MOVE WS-TT-NBR (X-WS-TT 40) TO SS95WS-IN-NBR.
118200     MOVE WS-TT-AMT (X-WS-TT 40) TO SS95WS-IN-AMT.
118300     PERFORM SS95PD-NAP-ROUTINE
118400        THRU SS95PD-NAP-EXIT.
118500     MOVE SS95WS-OUT-NBR-L12     TO WS-TL1-CR-NBR.
118600     MOVE SS95WS-OUT-AMT-L20     TO WS-TL1-CR-AMT.
118700*
118800     IF  WS-TIPT-IF-PRINT (20)
118900         PERFORM MB22PD-PRINT-1-LINE
119000            THRU MB22PD-P1L-EXIT
119100     ELSE
119200         MOVE SPACES             TO MB20WS-PRINT-LINE.
119300*
119400     MOVE 'AUTH DECLINED/APPROVED'
119500                                 TO WS-TL1-LIT-1.
119600     MOVE WS-TT-NBR (X-WS-TT 41) TO SS95WS-IN-NBR.
119700     MOVE WS-TT-AMT (X-WS-TT 41) TO SS95WS-IN-AMT.
119800     PERFORM SS95PD-NAP-ROUTINE
119900        THRU SS95PD-NAP-EXIT.
120000     MOVE SS95WS-OUT-NBR-L12     TO WS-TL1-DR-NBR.
120100     MOVE SS95WS-OUT-AMT-L20     TO WS-TL1-DR-AMT.
120200*
120300     MOVE WS-TT-NBR (X-WS-TT 42) TO SS95WS-IN-NBR.
120400     MOVE WS-TT-AMT (X-WS-TT 42) TO SS95WS-IN-AMT.
120500     PERFORM SS95PD-NAP-ROUTINE
120600        THRU SS95PD-NAP-EXIT.
120700     MOVE SS95WS-OUT-NBR-L12     TO WS-TL1-CR-NBR.
120800     MOVE SS95WS-OUT-AMT-L20     TO WS-TL1-CR-AMT.
120900*
121000     IF  WS-TIPT-IF-PRINT (21)
121100         PERFORM MB22PD-PRINT-1-LINE
121200            THRU MB22PD-P1L-EXIT
121300     ELSE
121400         MOVE SPACES             TO MB20WS-PRINT-LINE.
121500*
121600     MOVE 'MEMOS                 '
121700                                 TO WS-TL1-LIT-1.
121800     MOVE WS-TT-NBR (X-WS-TT 43) TO SS95WS-IN-NBR.
121900     MOVE WS-TT-AMT (X-WS-TT 43) TO SS95WS-IN-AMT.
122000     PERFORM SS95PD-NAP-ROUTINE
122100        THRU SS95PD-NAP-EXIT.
122200     MOVE SS95WS-OUT-NBR-L12     TO WS-TL1-DR-NBR.
122300     MOVE SS95WS-OUT-AMT-L20     TO WS-TL1-DR-AMT.
122400*
122500     MOVE WS-TT-NBR (X-WS-TT 44) TO SS95WS-IN-NBR.
122600     MOVE WS-TT-AMT (X-WS-TT 44) TO SS95WS-IN-AMT.
122700     PERFORM SS95PD-NAP-ROUTINE
122800        THRU SS95PD-NAP-EXIT.
122900     MOVE SS95WS-OUT-NBR-L12     TO WS-TL1-CR-NBR.
123000     MOVE SS95WS-OUT-AMT-L20     TO WS-TL1-CR-AMT.
123100*
123200     IF  WS-TIPT-IF-PRINT (22)
123300         PERFORM MB22PD-PRINT-1-LINE
123400            THRU MB22PD-P1L-EXIT
123500     ELSE
123600         MOVE SPACES             TO MB20WS-PRINT-LINE.
123700*
123800     MOVE 'RESERVE BALANCE       '
123900                                 TO WS-TL1-LIT-1.
124000     MOVE WS-TT-NBR (X-WS-TT 45) TO SS95WS-IN-NBR.
124100     MOVE WS-TT-AMT (X-WS-TT 45) TO SS95WS-IN-AMT.
124200     PERFORM SS95PD-NAP-ROUTINE
124300        THRU SS95PD-NAP-EXIT.
124400     MOVE SS95WS-OUT-NBR-L12     TO WS-TL1-DR-NBR.
124500     MOVE SS95WS-OUT-AMT-L20     TO WS-TL1-DR-AMT.
124600*
124700     MOVE WS-TT-NBR (X-WS-TT 46) TO SS95WS-IN-NBR.
124800     MOVE WS-TT-AMT (X-WS-TT 46) TO SS95WS-IN-AMT.
124900     PERFORM SS95PD-NAP-ROUTINE
125000        THRU SS95PD-NAP-EXIT.
125100     MOVE SS95WS-OUT-NBR-L12     TO WS-TL1-CR-NBR.
125200     MOVE SS95WS-OUT-AMT-L20     TO WS-TL1-CR-AMT.
125300*
125400     IF  WS-TIPT-IF-PRINT (23)
125500         PERFORM MB22PD-PRINT-1-LINE
125600            THRU MB22PD-P1L-EXIT
125700     ELSE
125800         MOVE SPACES             TO MB20WS-PRINT-LINE.
125900*
126000 9030-PT-EXIT.
126100     EXIT.
126200*
126300 9050-ACCUMULATE-TOTALS.
126400*
126500     MOVE MTPT-LOGIC-MODULE      TO MMTCWS-LOGIC-MODULE.
126600*
126700     EVALUATE TRUE
126800         WHEN MMTCWS-LM-BATCH-HDR-DR
126900             SET X-WS-TT-ITEM    TO 1
127000         WHEN MMTCWS-LM-BATCH-HDR-CR
127100             SET X-WS-TT-ITEM    TO 2
127200         WHEN MMTCWS-LM-VALID-RESV-SETT-DR
127300             SET X-WS-TT-ITEM    TO 3
127400         WHEN MMTCWS-LM-VALID-RESV-SETT-CR
127500             SET X-WS-TT-ITEM    TO 4
127600         WHEN MMTCWS-LM-DISCOUNT
127700             SET X-WS-TT-ITEM    TO 5
127800         WHEN MMTCWS-LM-REFUND
127900             SET X-WS-TT-ITEM    TO 6
128000         WHEN MMTCWS-LM-PART-DR
128100             SET X-WS-TT-ITEM    TO 7
128200         WHEN MMTCWS-LM-PART-CR
128300             SET X-WS-TT-ITEM    TO 8
128400         WHEN MMTCWS-LM-ADJ-DR
128500             SET X-WS-TT-ITEM    TO 9
128600         WHEN MMTCWS-LM-ADJ-CR
128700             SET X-WS-TT-ITEM    TO 10
128800         WHEN MMTCWS-LM-RECOVERY-ADJ-DR
128900             SET X-WS-TT-ITEM    TO 11
129000         WHEN MMTCWS-LM-RECOVERY-ADJ-CR
129100             SET X-WS-TT-ITEM    TO 12
129200         WHEN MMTCWS-LM-SYSTEM-FEES-DR
129300             SET X-WS-TT-ITEM    TO 13
129400         WHEN MMTCWS-LM-SYSTEM-FEES-CR
129500             SET X-WS-TT-ITEM    TO 14
129600         WHEN MMTCWS-LM-USER-FEES
129700             SET X-WS-TT-ITEM    TO 15
129800         WHEN MMTCWS-LM-USER-FEES-CR
129900             SET X-WS-TT-ITEM    TO 16
130000         WHEN MMTCWS-LM-INTCHG-FEES-DR
130100             SET X-WS-TT-ITEM    TO 17
130200         WHEN MMTCWS-LM-INTCHG-FEES-CR
130300             SET X-WS-TT-ITEM    TO 18
130400         WHEN MMTCWS-LM-USER-DEBITS
130500             SET X-WS-TT-ITEM    TO 19
130600         WHEN MMTCWS-LM-USER-CREDITS
130700             SET X-WS-TT-ITEM    TO 20
130800         WHEN MMTCWS-LM-SETTLEMENT-DR-XFER
130900             SET X-WS-TT-ITEM    TO 21
131000         WHEN MMTCWS-LM-SETTLEMENT-CR-XFER
131100             SET X-WS-TT-ITEM    TO 22
131200         WHEN MMTCWS-LM-HOLDOVER
131300             SET X-WS-TT-ITEM    TO 23
131400         WHEN MMTCWS-LM-HOLDOVER-CR
131500             SET X-WS-TT-ITEM    TO 24
131600         WHEN MMTCWS-LM-SYSTEM-SETT-DR-ACH
131700             SET X-WS-TT-ITEM    TO 25
131800         WHEN MMTCWS-LM-SYSTEM-SETT-CR-ACH
131900             SET X-WS-TT-ITEM    TO 26
132000         WHEN MMTCWS-LM-SYSTEM-SETT-DR-CHECK
132100             SET X-WS-TT-ITEM    TO 27
132200         WHEN MMTCWS-LM-SYSTEM-SETT-CR-CHECK
132300             SET X-WS-TT-ITEM    TO 28
132400         WHEN MMTCWS-LM-SYSTEM-SETT-DR-WIRE
132500             SET X-WS-TT-ITEM    TO 29
132600         WHEN MMTCWS-LM-SYSTEM-SETT-CR-WIRE
132700             SET X-WS-TT-ITEM    TO 30
132800         WHEN MMTCWS-LM-SYSTEM-SETT-DR-MAN
132900             SET X-WS-TT-ITEM    TO 31
133000         WHEN MMTCWS-LM-SYSTEM-SETT-CR-MAN
133100             SET X-WS-TT-ITEM    TO 32
133200         WHEN MMTCWS-LM-SYSTEM-SETT-DR-BILL
133300             SET X-WS-TT-ITEM    TO 33
133400         WHEN MMTCWS-LM-SYSTEM-SETT-CR-BILL
133500             SET X-WS-TT-ITEM    TO 34
133600         WHEN MMTCWS-LM-WINDOW-SETT-DR
133700             SET X-WS-TT-ITEM    TO 35
133800         WHEN MMTCWS-LM-WINDOW-SETT-CR
133900             SET X-WS-TT-ITEM    TO 36
134000         WHEN MMTCWS-LM-VALID-DEP-MEMO-DR
134100             SET X-WS-TT-ITEM    TO 39
134200         WHEN MMTCWS-LM-VALID-DEP-MEMO-CR
134300             SET X-WS-TT-ITEM    TO 40
134400         WHEN MMTCWS-LM-AUTH-DECLINED
134500             SET X-WS-TT-ITEM    TO 41
134600         WHEN MMTCWS-LM-AUTH-APPROVED
134700             SET X-WS-TT-ITEM    TO 42
134800         WHEN MMTCWS-LM-CHECK-APPROVAL
134900             SET X-WS-TT-ITEM    TO 43
135000         WHEN MMTCWS-LM-RESERVE-TO-PROC
135100             SET X-WS-TT-ITEM    TO 45
135200         WHEN MMTCWS-LM-RESERVE-MANUAL
135300             SET X-WS-TT-ITEM    TO 46
135400         WHEN OTHER
135500             SET X-WS-TT-ITEM    TO 44
135600     END-EVALUATE.
135700*
135800     ADD MTPT-NBR-ITEMS          TO WS-TC-NBR.
135900     ADD MTPT-AMOUNT             TO WS-TC-AMT.
136000*
136100     PERFORM 9060-ADD-TO-TOTALS
136200        THRU 9060-ATT-EXIT.
136300*
136400     EVALUATE TRUE
136500         WHEN (MMTCWS-LM-WINDOW-ALLOWED
136600          AND  MMTCWS-LM-VALID-DEBIT
136700          AND  MTPT-SETTLED-WINDOW)
136800             SET X-WS-TT-ITEM    TO 37
136900             PERFORM 9060-ADD-TO-TOTALS
137000                THRU 9060-ATT-EXIT
137100         WHEN (MMTCWS-LM-WINDOW-ALLOWED
137200          AND  MMTCWS-LM-VALID-CREDIT
137300          AND  MTPT-SETTLED-WINDOW)
137400             SET X-WS-TT-ITEM    TO 38
137500             PERFORM 9060-ADD-TO-TOTALS
137600                THRU 9060-ATT-EXIT
137700     END-EVALUATE.
137800*
137900 9050-AT-EXIT.
138000     EXIT.
138100*
138200 9060-ADD-TO-TOTALS.
138300*
138400     ADD MTPT-NBR-ITEMS          TO WS-TT-NBR (1 X-WS-TT-ITEM).
138500     ADD MTPT-AMOUNT             TO WS-TT-AMT (1 X-WS-TT-ITEM).
138600*
138700     ADD MTPT-NBR-ITEMS          TO WS-TT-NBR (2 X-WS-TT-ITEM).
138800     ADD MTPT-AMOUNT             TO WS-TT-AMT (2 X-WS-TT-ITEM).
138900*
139000     ADD MTPT-NBR-ITEMS          TO WS-TT-NBR (3 X-WS-TT-ITEM).
139100     ADD MTPT-AMOUNT             TO WS-TT-AMT (3 X-WS-TT-ITEM).
139200*
139300 9060-ATT-EXIT.
139400     EXIT.
139500/
139600 9070-ZERO-ORG-ACCUMS.
139700*
139800     INITIALIZE WS-TT-LEVEL (1).
139900*
140000 9070-ZOA-EXIT.
140100     EXIT.
140200*
140300 9080-ZERO-MER-ACCUMS.
140400*
140500     INITIALIZE WS-TT-LEVEL (2).
140600*
140700 9080-ZMA-EXIT.
140800     EXIT.
140900*
141000 9090-ZERO-TC-ACCUMS.
141100*
141200     INITIALIZE WS-TT-LEVEL (3).
141300*
141400 9090-ZTA-EXIT.
141500     EXIT.
141600*
141700 9100-CHECK-NBR-LINES.
141800*
141900     COMPUTE MB20WS-LINES-REMAINING
142000                                 = MB20WS-LINE-LIMIT
142100                                 - MB20WS-LINE-COUNT.
142200*
142300     IF  MB20WS-LINES-REMAINING IS LESS THAN WS-D720-LINE-CHECK
142400         MOVE MB20WS-FORCE-PAGE  TO MB20WS-LINE-COUNT.
142500*
142600 9100-CNL-EXIT.
142700     EXIT.
142800/
142900     COPY MB22PD.
143000/
143100     COPY SS95PD.
143200/
143300     COPY SS02PD.
143400/
143500     COPY SS07PD.
143600/
143700     COPY SS08PD.
143800/
143900     COPY SS16PD.
144000/
144100     COPY SS26PD.
144200/
144300     COPY SS27PD.
144400*
144500 9995-END-SOURCE-STATEMENTS SECTION.
144600 9999-END-OF-PROGRAM.
144700     EXIT.
