000100 IDENTIFICATION DIVISION.
000200 PROGRAM-ID. MBD72013.
000201*       RELEASE DATE=08/24/01.        REVISION LEVEL=08.06      * ++++++++
000202***************************************************************** ++++++++
000203*WARNING.  THIS COMPUTER PROGRAM IS PROTECTED BY COPYRIGHT LAW  * ++++++++
000204*AND INTERNATIONAL TREATIES.  UNAUTHORIZED REPRODUCTION OR      * ++++++++
000205*DISTRIBUTION OF THIS PROGRAM, OR ANY PORTION OF IT, MAY RESULT * ++++++++
000206*IN SEVERE CIVIL AND CRIMINAL PENATLIES, AND WILL BE PROSECUTED * ++++++++
000207*TO THE MAXIMUM EXTENT POSSIBLE UNDER THE LAW.                  * ++++++++
000208*COPYRIGHT 1999 PAYSYS INTERNATIONAL, INC.  ALL RIGHTS RESERVED.* ++++++++
000209***************************************************************** ++++++++
000300*****************************************************************
000400*                                                               *
000500*   V - PLUS  M E R C H A N T   B A N K C A R D   S Y S T E M   *
000600*                                                               *
000700*       MBD72013 - OPTIONAL REPORT 13 SUBROUTINE                *
000800*                                                               *
000900*****************************************************************
001000 ENVIRONMENT DIVISION.
001100 CONFIGURATION SECTION.
001200 SOURCE-COMPUTER.            IBM-4341.
001300 OBJECT-COMPUTER.            IBM-4341.
001400/
001500 DATA DIVISION.
001600 WORKING-STORAGE SECTION.
001700*
001800 01  FILLER                  PIC  X(12)      VALUE '** WS-BEG **'.
001900*
002000 01  WS-MBD72013-WORK-AREAS.
002100     03  WS-D72013-ACTIVITY-SW
002200                             PIC  X(01)      VALUE 'N'.
002300     03  WS-D720-LINE-CHECK  PIC S9(05)      COMP-3 VALUE +34.
002400     03  WS-D720-1ST-STORE   PIC  X(01)      VALUE 'N'.
002500     03  WS-D720-MERCH-TOT   PIC  X(01)      VALUE 'N'.
002600     03  WS-D720-STORE-TOT   PIC  X(01)      VALUE 'N'.
002700*
002800*****************************************************
002900*    THE VALUE FOR THE FOLLWING LEVEL INDICES ARE:  *
003000*       1 - ORGANIZATION                            *
003100*       2 - MERCHANT                                *
003200*       3 - STORE, PLAN OR T/C                      *
003300*                                                   *
003400*    THE VALUE FOR THE FOLLWING ITEM INDICES ARE:   *
003500*       1 - DEPOSITS DEBITS                         *
003600*       2 - DEPOSITS CREDIT                         *
003700*       3 - RESERVES DEBITS                         *
003800*       4 - RESERVES CREDIT                         *
003900*       5 - DISCOUNT DEBITS                         *
004000*       6 - DISCOUNT CREDIT                         *
004100*       7 - PARTICIPTION DEBITS                     *
004200*       8 - PARTICIPTION CREDIT                     *
004300*       9 - SYSTEM ADJUSTMENTS DEBITS               *
004400*      10 - SYSTEM ADJUSTMENTS CREDIT               *
004500*      11 - RECOVERY ADJUSTMENTS DEBITS             *
004600*      12 - RECOVERY ADJUSTMENTS CREDIT             *
004700*      13 - SYSTEM FEES DEBIT                       *
004800*      14 - SYSTEM FEES CREDIT                      *
004900*      15 - USER FEES DEBIT                         *
005000*      16 - USER FEES CREDIT                        *
005100*      17 - INTERCHANGE FEES DEBITS                 *
005200*      18 - INTERCHANGE FEES CREDIT                 *
005300*      19 - USER CREDITS DEBITS                     *
005400*      20 - USER CREDITS CREDIT                     *
005500*      21 - TRANSFER TO BILLING/INVOICE DEBITS      *
005600*      22 - TRANSFER TO BILLING/INVOICE CREDITS     *
005700*      23 - HOLDOVER DEBITS                         *
005800*      24 - HOLDOVER CREDITS                        *
005900*      25 - SETTLEMENT DEBITS -- ACH                *
006000*      26 - SETTLEMENT CREDITS - ACH                *
006100*      27 - SETTLEMENT DEBITS -- CHECK              *
006200*      28 - SETTLEMENT CREDITS - CHECK              *
006300*      29 - SETTLEMENT DEBITS -- WIRE TRANSFER      *
006400*      30 - SETTLEMENT CREDITS - WIRE TRANSFER      *
006500*      31 - SETTLEMENT DEBITS -- MANUAL             *
006600*      32 - SETTLEMENT CREDITS - MANUAL             *
006700*      33 - SETTLEMENT DEBITS -- BILLING/INVOICE    *
006800*      34 - SETTLEMENT CREDITS - BILLING/INVOICE    *
006900*      35 - SETTLEMENT DEBITS -- WINDOW             *
007000*      36 - SETTLEMENT CREDITS - WINDOW             *
007100*      37 - WINDOW TRANSACTIONS DEBITS              *
007200*      38 - WINDOW TRANSACTIONS CREDIT              *
007300*      39 - DEPOSIT MEMOS DEBITS                    *
007400*      40 - DEPOSIT MEMOS CREDIT                    *
007500*      41 - AUTHORIZATION DECLINES                  *
007600*      42 - AUTHORIZATION APPROVALS                 *
007700*      43 - MEMOS DEBITS                            *
007800*      44 - MEMOS CREDITS                           *
007900*      45 - RESERVE BALANCE DEBITS                  *
008000*      46 - RESERVE BALANCE CREDITS                 *
008100*                                                   *
008200*****************************************************
008300*
008400     03  WS-TOTALS-TABLE.
008500         05  WS-TT-LEVEL                     OCCURS 3 TIMES
008600                                             INDEXED BY
008700                                             X-WS-TT.
008800             07  WS-TT-ITEM                  OCCURS 46 TIMES
008900                                             INDEXED BY
009000                                             X-WS-TT-ITEM.
009100                 09  WS-TT-NBR
009200                             PIC S9(09)      COMP-3.
009300                 09  WS-TT-AMT
009400                             PIC S9(17)      COMP-3.
009500/
009600*****************************************************
009700*    THE VALUE FOR THE FOLLWING ITEM INDICES ARE:   *
009800*       1 - DEPOSITS                                *
009900*       2 - RESERVES                                *
010000*       3 - DISCOUNT                                *
010100*       4 - PARTICIPTION                            *
010200*       5 - SYSTEM ADJUSTMENTS                      *
010300*       6 - RECOVERY ADJUSTMENTS                    *
010400*       7 - SYSTEM FEES DEBIT                       *
010500*       8 - USER FEES DEBIT                         *
010600*       9 - INTERCHANGE FEES                        *
010700*      10 - USER CREDITS                            *
010800*      11 - TRANSFER TO BILLING/INVOICE             *
010900*      12 - HOLDOVER                                *
011000*      13 - SETTLEMENT -- ACH                       *
011100*      14 - SETTLEMENT -- CHECK                     *
011200*      15 - SETTLEMENT -- WIRE TRANSFER             *
011300*      16 - SETTLEMENT -- MANUAL                    *
011400*      17 - SETTLEMENT -- BILLING/INVOICE           *
011500*      18 - SETTLEMENT -- WINDOW                    *
011600*      19 - WINDOW TRANSACTIONS                     *
011700*      20 - DEPOSIT MEMOS                           *
011800*      21 - AUTHORIZATION DECLINES                  *
011900*      22 - MEMOS                                   *
012000*      23 - RESERVE BALANCE                         *
012100*      24 - FUTURE USE                              *
012200*      25 - FUTURE USE                              *
012300*      26 - FUTURE USE                              *
012400*      27 - FUTURE USE                              *
012500*      28 - SETTLEMENT IN SUB-TOTAL                 *
012600*      29 - SETTLEMENT IN TOTALS                    *
012700*      30 - SETTLEMENT OUT TOTALS                   *
012800*                                                   *
012900*****************************************************
013000*
013100     03  WS-TOTAL-ITEM-PRINT-TABLE.
013200         05  WS-TIPT-ITEM                    OCCURS 30 TIMES
013300                                             INDEXED BY
013400                                             X-WS-TIPT-ITEM.
013500             07  WS-TIPT-ITEM-FLAG
013600                             PIC  X(01)      VALUE 'N'.
013700                 88  WS-TIPT-IF-PRINT        VALUE 'Y'.
013800                 88  WS-TIPT-IF-NO-PRINT     VALUE 'N'.
013900*
014000     03  WS-PREV-KEY.
014100         05  WS-PREV-TYPE    PIC  X(01)      VALUE SPACES.
014200         05  WS-PREV-MER-NBR PIC  9(09)      VALUE ZERO.
014300     03  WS-CURR-KEY.
014400         05  WS-CURR-TYPE    PIC  X(01)      VALUE SPACES.
014500         05  WS-CURR-MER-NBR PIC  9(09)      VALUE ZERO.
014600/
014700     COPY MB20WS.
014800*
014900 01  WS-DETAIL-LINE-1        REDEFINES MB20WS-PRINT-LINE.
015000     03  WS-DL1-TYPE         PIC  X(01).
015100     03  WS-DL1-MER-NBR      PIC  9(09).
015200     03  FILLER              PIC  X(01).
015300     03  WS-DL1-STORE-NBR    PIC  9(09).
015400     03  FILLER              PIC  X(02).
015500     03  WS-DL1-TC-NBR       PIC  9(03).
015600     03  FILLER              PIC  X(01).
015700     03  WS-DL1-LM-NBR       PIC  9(03).
015800     03  FILLER              PIC  X(01).
015900     03  WS-DL1-CP-NBR       PIC  9(02).
016000     03  FILLER              PIC  X(01).
016100     03  WS-DL1-QL-NBR       PIC  9(02).
016200     03  FILLER              PIC  X(01).
016300     03  WS-DL1-PLAN-NBR     PIC  9(05).
016400     03  FILLER              PIC  X(01).
016500     03  WS-DL1-WINDOW       PIC  X(01).
016600     03  FILLER              PIC  X(01).
016700     03  WS-DL1-DATE         PIC  X(10).
016800     03  FILLER              PIC  X(01).
016900     03  WS-DL1-SOURCE-NBR   PIC  9(05).
017000     03  FILLER              PIC  X(02).
017100     03  WS-DL1-NBR          PIC  9(05).
017200     03  FILLER              PIC  X(01).
017300     03  WS-DL1-SEQ-NBR      PIC  9(08).
017400     03  FILLER              PIC  X(03).
017500     03  WS-DL1-GL-NBR       PIC  9(01).
017600     03  FILLER              PIC  X(01).
017700     03  WS-DL1-NBR-ITEMS    PIC  X(12).
017800     03  FILLER              PIC  X(01).
017900     03  WS-DL1-TRANS-AMT    PIC  X(21).
018000     03  WS-DL1-DESCRIPTION  PIC  X(15).
018100*
018200 01  WS-MERCHANT-TOTAL-LINE-1
018300                             REDEFINES MB20WS-PRINT-LINE.
018400     03  WS-MTL1-LIT-1       PIC  X(43).
018500     03  FILLER              PIC  X(07).
018600     03  WS-MTL1-MER-NBR     PIC  9(09).
018700     03  FILLER              PIC  X(04).
018800     03  WS-MTL1-MER-DESC    PIC  X(40).
018900     03  FILLER              PIC  X(29).
019000*
019100 01  WS-ORG-TOTAL-LINE-1     REDEFINES MB20WS-PRINT-LINE.
019200     03  WS-OTL1-LIT-1       PIC  X(47).
019300     03  FILLER              PIC  X(03).
019400     03  WS-OTL1-ORG-NBR     PIC  9(03).
019500     03  FILLER              PIC  X(10).
019600     03  WS-OTL1-ORG-DESC    PIC  X(40).
019700     03  FILLER              PIC  X(29).
019800*
019900 01  WS-HEADING-TOTAL-LINE-1 REDEFINES MB20WS-PRINT-LINE.
020000     03  FILLER              PIC  X(27).
020100     03  WS-HTL1-LIT-1       PIC  X(38).
020200     03  FILLER              PIC  X(04).
020300     03  WS-HTL1-LIT-2       PIC  X(38).
020400     03  FILLER              PIC  X(25).
020500*
020600 01  WS-TOTAL-LINE-1         REDEFINES MB20WS-PRINT-LINE.
020700     03  FILLER              PIC  X(05).
020800     03  WS-TL1-LIT-1        PIC  X(22).
020900     03  WS-TL1-DR-NBR       PIC  X(12).
021000     03  FILLER              PIC  X(06).
021100     03  WS-TL1-DR-AMT       PIC  X(21).
021200     03  FILLER              PIC  X(04).
021300     03  WS-TL1-CR-NBR       PIC  X(12).
021400     03  FILLER              PIC  X(05).
021500     03  WS-TL1-CR-AMT       PIC  X(21).
021600     03  FILLER              PIC  X(24).
021700/
021800     COPY SS95WS.
021900/
022000     COPY MTRFWS REPLACING ==:MTRF:== BY ==MTRF==.
022100/
022200     COPY MTRFRL REPLACING ==:MTRF:== BY ==MWRF==.
022300/
022400     COPY MTPTRL REPLACING ==:MTPT:== BY ==MTPT==.
022500/
022600     COPY MMTCWS.
022700/
022800     COPY MTP0RL REPLACING ==:MTP0:== BY ==MTR0==.
022900/
023000     COPY MTP0RL REPLACING ==:MTP0:== BY ==MTR1==.
023100/
023200     COPY MTP0RL REPLACING ==:MTP0:== BY ==MTR2==.
023300/
023400     COPY MTP0RL REPLACING ==:MTP0:== BY ==MTR3==.
023500/
023600     COPY MTP0RL REPLACING ==:MTP0:== BY ==MTR4==.
023700/
023800     COPY MTP0RL REPLACING ==:MTP0:== BY ==MTR5==.
023900/
024000     COPY MTP0RL REPLACING ==:MTP0:== BY ==MTR6==.
024100/
024200     COPY MTP0RL REPLACING ==:MTP0:== BY ==MTR7==.
024300/
024400     COPY MTP0RL REPLACING ==:MTP0:== BY ==MTR8==.
024500/
024600     COPY MTP0RL REPLACING ==:MTP0:== BY ==MTR9==.
024700/
024800     COPY MB00WS.
024900/
025000     COPY SS00WS.
025100/
025200     COPY SS01WS.
025300/
025400     COPY SS02WS.
025500*
025600 01  FILLER                  PIC  X(12)      VALUE '** WS-END **'.
025700/
025800 LINKAGE SECTION.
025900     COPY MB22WS.
026000/
026100     COPY MTRFRL REPLACING ==:MTRF:== BY ==MTRF==.
026200/
026300 PROCEDURE DIVISION              USING MB22WS-LINK-DATA
026400                                       MTRF-RECORD.
026500*
026600 A000-MAIN-LINE-SECT SECTION.
026700 A010-ML-BEGIN.
026800*
026900     IF  MTRF-K1-RT-DETAIL
027000         PERFORM D000-DETAIL-RECORD
027100            THRU D099-DR-EXIT.
027200*
027300     IF  MTRF-K1-RT-HEADER
027400         PERFORM H000-HEADER-RECORD
027500            THRU H099-HR-EXIT.
027600*
027700     IF  MTRF-K1-RT-TRAILER
027800         PERFORM T000-TRAILER-RECORD
027900            THRU T099-TR-EXIT.
028000*
028100     GOBACK.
028200*
028300 A099-ML-EXIT.
028400     EXIT.
028500/
028600 D000-DETAIL-RECORD SECTION.
028700 D010-DR-BEGIN.
028800*
028900     MOVE 'Y'                    TO WS-D72013-ACTIVITY-SW.
029000*
029100     MOVE MTRF-MT-TRANSACTION    TO MTPT-RECORD.
029200*
029300     EVALUATE TRUE
029400       WHEN MTRF-K2-O13-FT-STORE
029500         MOVE MTPT-STORE         TO WS-CURR-MER-NBR
029600       WHEN OTHER
029700         MOVE MTPT-MERCHANT      TO WS-CURR-MER-NBR
029800     END-EVALUATE.
029900*
030000     MOVE MTRF-K2-O13-FILE-TYPE  TO WS-CURR-TYPE.
030100*
030200     IF  WS-CURR-KEY IS NOT EQUAL TO WS-PREV-KEY
030300     AND WS-PREV-MER-NBR IS GREATER THAN ZERO
030400         PERFORM 9100-CHECK-NBR-LINES
030500            THRU 9100-CNL-EXIT
030600         PERFORM 9020-PRINT-MER-TOTALS
030700            THRU 9020-PMT-EXIT
030800         PERFORM 9080-ZERO-MER-ACCUMS
030900            THRU 9080-ZMA-EXIT
031000         PERFORM MB22PD-PRINT-1-LINE
031100            THRU MB22PD-P1L-EXIT.
031200*
031300     IF  MTRF-K2-O13-FT-STORE
031400     AND WS-D720-1ST-STORE IS EQUAL TO 'N'
031500         MOVE 'Y'                TO WS-D720-1ST-STORE
031600         MOVE MB20WS-FORCE-PAGE  TO MB20WS-LINE-COUNT
031700         PERFORM 9100-CHECK-NBR-LINES
031800            THRU 9100-CNL-EXIT
031900         PERFORM 9010-PRINT-ORG-TOTALS
032000            THRU 9010-POT-EXIT
032100         PERFORM 9070-ZERO-ORG-ACCUMS
032200            THRU 9070-ZOA-EXIT
032300         MOVE 'Y'                TO WS-D720-MERCH-TOT
032400         MOVE MB20WS-FORCE-PAGE  TO MB20WS-LINE-COUNT
032500     END-IF.
032600*
032700     EVALUATE TRUE
032800       WHEN MTRF-K2-O13-FT-STORE
032900         MOVE MTPT-STORE         TO WS-PREV-MER-NBR
033000       WHEN OTHER
033100         MOVE MTPT-MERCHANT      TO WS-PREV-MER-NBR
033200     END-EVALUATE.
033300*
033400     MOVE MTRF-K2-O13-FILE-TYPE  TO WS-PREV-TYPE.
033500*
033600     MOVE MTRF-K2-O13-FILE-TYPE  TO WS-DL1-TYPE.
033700     MOVE MTPT-MERCHANT          TO WS-DL1-MER-NBR.
033800     MOVE MTPT-STORE             TO WS-DL1-STORE-NBR.
033900     MOVE MTPT-TRANS-CODE        TO WS-DL1-TC-NBR.
034000     MOVE MTPT-LOGIC-MODULE      TO WS-DL1-LM-NBR.
034100     MOVE MTPT-PRODUCT           TO WS-DL1-CP-NBR.
034200     MOVE MTPT-QUAL-LEVEL        TO WS-DL1-QL-NBR.
034300     MOVE MTPT-PLAN              TO WS-DL1-PLAN-NBR.
034400*
034500     IF  MTPT-SETTLED-WINDOW
034600         MOVE MTPT-SETT-FLAG     TO WS-DL1-WINDOW.
034700*
034800     MOVE MTPT-BATCH-DATE        TO SS01WS-JULIAN.
034900     PERFORM SS26PD-NUMERICALLY-EDIT-DATE
035000        THRU SS26PD-NED-EXIT.
035100     MOVE SS01WS-XX-XX-YYYY      TO WS-DL1-DATE.
035200     MOVE MTPT-BATCH-SOURCE      TO WS-DL1-SOURCE-NBR.
035300     MOVE MTPT-BATCH-NBR         TO WS-DL1-NBR.
035400     MOVE MTPT-BATCH-SEQ         TO WS-DL1-SEQ-NBR.
035500     MOVE MTPT-GL-SOURCE         TO WS-DL1-GL-NBR.
035600*
035700     MOVE MTPT-NBR-ITEMS         TO SS95WS-IN-NBR.
035800     PERFORM SS95PD-NAP-ROUTINE
035900        THRU SS95PD-NAP-EXIT.
036000     MOVE SS95WS-OUT-NBR-L12     TO WS-DL1-NBR-ITEMS.
036100*
036200     MOVE MTPT-AMOUNT            TO SS95WS-IN-AMT.
036300     PERFORM SS95PD-NAP-ROUTINE
036400        THRU SS95PD-NAP-EXIT.
036500     MOVE SS95WS-OUT-AMT-L20     TO WS-DL1-TRANS-AMT.
036600*
036700     MOVE MTPT-RPT-DESC          TO WS-DL1-DESCRIPTION.
036800*
036900     PERFORM 9050-ACCUMULATE-TOTALS
037000        THRU 9050-AT-EXIT.
037100*
037200     EVALUATE TRUE
037300         WHEN MTRF-K1-DETAIL
037400             PERFORM MB22PD-PRINT-1-LINE
037500                THRU MB22PD-P1L-EXIT
037600         WHEN OTHER
037700             MOVE SPACES         TO MB20WS-PRINT-LINE
037800     END-EVALUATE.
037900*
038000     MOVE MTRF-RECORD            TO MWRF-RECORD.
038100*
038200 D099-DR-EXIT.
038300     EXIT.
038400/
038500 H000-HEADER-RECORD SECTION.
038600 H010-HR-BEGIN.
038700*
038800     MOVE MTRF-K1-FORM           TO MB20WS-FORM-CODE.
038900     MOVE MTRF-HD-DATE-FORMAT    TO SS01WS-DATE-FORMAT.
039000     MOVE MTRF-HD-FICHE-FLAG     TO MB20WS-FICHE-CODE.
039100     MOVE MTRF-HD-SYSTEM-NAME    TO MB20WS-SH-SYSTEM.
039200     MOVE MTRF-HD-REPORT-ID      TO MB20WS-SH-RPT-ID.
039300     MOVE 'O13'                  TO MB20WS-SH-INTERNAL-RPT-ID.
039400     MOVE MTRF-K1-ORG            TO MB20WS-SH-ORG.
039500     MOVE MTRF-HD-ORG-NAME       TO MB20WS-SH-ORG-NAME.
039600     MOVE MTRF-HD-RPT-TITLE      TO MB20WS-SH-RPT-NAME.
039700     MOVE MTRF-HD-FILE-DATE      TO SS01WS-JULIAN.
039800     PERFORM SS26PD-NUMERICALLY-EDIT-DATE
039900        THRU SS26PD-NED-EXIT.
040000     MOVE SS01WS-XX-XX-YYYY      TO MB20WS-SH-FILE-DATE.
040100     MOVE MTRF-HD-REPORT-DEST-ID TO MB20WS-SH-DEST-ID.
040200     MOVE MTRF-HD-DEST-DESC      TO MB20WS-SH-DEST-DESC.
040300*
040400     MOVE '  MERCHANT   STORE   *-- POSTING DATA ---*  '
040500                                 TO MB20WS-SH-L5R-1.
040600     MOVE '*----- BATCH INFORMATION ------*           N'
040700                                 TO MB20WS-SH-L5R-2.
040800     MOVE 'UMBER         TRANSACTION                   '
040900                                 TO MB20WS-SH-L5R-3.
041000*
041100     MOVE '   NUMBER   NUMBER    T/C L/M PR QL  PLAN   '
041200                                 TO MB20WS-SH-L6R-1.
041300     MOVE '   DATE   SOURCE   NBR     SEQ    G/L       '
041400                                 TO MB20WS-SH-L6R-2.
041500     MOVE 'ITEMS            AMOUNT       DESCRIPTION   '
041600                                 TO MB20WS-SH-L6R-3.
041700*
041800     MOVE ZERO                   TO MB20WS-PAGE-COUNT.
041900     MOVE MB20WS-FORCE-PAGE      TO MB20WS-LINE-COUNT.
042000     MOVE MTRF-HD-LINES-PER-PAGE TO MB20WS-LINES-PER-PAGE.
042100     MOVE MTRF-HD-CURRENCY-NOD   TO MTRFWS-SAVE-CURRENCY-NOD.
042200     MOVE MTRF-HD-PER-ITEM-NOD   TO MTRFWS-SAVE-PER-ITEM-NOD.
042300     MOVE MTRF-HD-PERCENT-NOD    TO MTRFWS-SAVE-PERCENT-NOD.
042400     SET SS95WS-FUNCTION-INITIALIZE
042500                                 TO TRUE.
042600     PERFORM SS95PD-NAP-ROUTINE
042700        THRU SS95PD-NAP-EXIT.
042800*
042900     MOVE MTRF-HD-CURRENCY-CODE  TO SS95WS-CURRENCY-CODE.
043000     SET SS95WS-NAP-IND-IS-ALL   TO TRUE.
043100     MOVE 'N'                    TO WS-D72013-ACTIVITY-SW.
043200     MOVE MTRF-RECORD            TO MTR9-RECORD.
043300     MOVE SPACES                 TO MWRF-RECORD.
043400     MOVE ZERO                   TO MWRF-MERCHANT.
043500     PERFORM 9070-ZERO-ORG-ACCUMS
043600        THRU 9070-ZOA-EXIT.
043700     PERFORM 9080-ZERO-MER-ACCUMS
043800        THRU 9080-ZMA-EXIT.
043900     PERFORM 9090-ZERO-STORE-ACCUMS
044000        THRU 9090-ZSA-EXIT.
044100     MOVE SPACES                 TO WS-CURR-TYPE.
044200     MOVE ZERO                   TO WS-CURR-MER-NBR.
044300     MOVE SPACES                 TO WS-PREV-TYPE.
044400     MOVE ZERO                   TO WS-PREV-MER-NBR.
044500     MOVE 'N'                    TO WS-D72013-ACTIVITY-SW.
044600     MOVE 'N'                    TO WS-D720-1ST-STORE.
044700     MOVE 'N'                    TO WS-D720-MERCH-TOT.
044800     MOVE 'N'                    TO WS-D720-STORE-TOT.
044900*
045000*****               111111111122222222223
045100*****      123456789012345678901234567890
045200     MOVE 'YYYYYYYYYYYYYYYYYYYYYYYNNNNYYY'
045300                                 TO WS-TOTAL-ITEM-PRINT-TABLE.
045400*
045500     MOVE 5                      TO WS-D720-LINE-CHECK.
045600*
045700     PERFORM
045800         VARYING X-WS-TIPT-ITEM FROM 1 BY 1
045900         UNTIL   X-WS-TIPT-ITEM IS GREATER THAN 30
046000         IF  WS-TIPT-IF-PRINT (X-WS-TIPT-ITEM)
046100             ADD  1              TO WS-D720-LINE-CHECK
046200         END-IF
046300     END-PERFORM.
046400*
046500     IF  WS-TIPT-IF-PRINT (28)
046600         ADD  1                  TO WS-D720-LINE-CHECK.
046700*
046800     IF  WS-TIPT-IF-PRINT (29)
046900         ADD  1                  TO WS-D720-LINE-CHECK.
047000*
047100     IF  WS-TIPT-IF-PRINT (30)
047200         ADD  1                  TO WS-D720-LINE-CHECK.
047300*
047400 H099-HR-EXIT.
047500     EXIT.
047600/
047700 T000-TRAILER-RECORD SECTION.
047800 T010-TR-BEGIN.
047900*
048000     MOVE MTR9-RECORD            TO MTRF-RECORD.
048100*
048200     IF  WS-D72013-ACTIVITY-SW IS EQUAL TO 'N'
048300         IF  MTRF-HD-AF-PRODUCE
048400             PERFORM MB22PD-PRINT-NO-ACTIVITY
048500                THRU MB22PD-PNA-EXIT
048600             GO TO T099-TR-EXIT
048700         ELSE
048800             GO TO T099-TR-EXIT.
048900*
049000***************************************************************
049100*    WE MUST NOW PRINT MERCHANT TOTALS. THE REASON FOR THIS IS*
049200*    WE COULD HAVE PRINTED SEVERAL DETAIL RECORDS AND THEN    *
049300*    ENCOUNTERED A TRAILER RECORD WITH OUT HAVING  PROCESSED  *
049400*    THE MERCHANT BREAK/TOTALING LOGIC. THIS CODE WILL FORCE  *
049500*    A MERCHANT TOTAL TO BE PRINTED.                          *
049600***************************************************************
049700*
049800     PERFORM 9100-CHECK-NBR-LINES
049900        THRU 9100-CNL-EXIT.
050000*
050100     PERFORM 9020-PRINT-MER-TOTALS
050200        THRU 9020-PMT-EXIT.
050300*
050400     PERFORM 9080-ZERO-MER-ACCUMS
050500        THRU 9080-ZMA-EXIT.
050600*
050700     IF  WS-D720-MERCH-TOT IS EQUAL TO 'N'
050800         MOVE MB20WS-FORCE-PAGE  TO MB20WS-LINE-COUNT
050900         PERFORM 9100-CHECK-NBR-LINES
051000            THRU 9100-CNL-EXIT
051100         PERFORM 9010-PRINT-ORG-TOTALS
051200            THRU 9010-POT-EXIT
051300         PERFORM 9070-ZERO-ORG-ACCUMS
051400            THRU 9070-ZOA-EXIT
051500         MOVE 'Y'                TO WS-D720-MERCH-TOT
051600         MOVE MB20WS-FORCE-PAGE  TO MB20WS-LINE-COUNT
051700     END-IF.
051800*
051900     IF  WS-D720-STORE-TOT IS EQUAL TO 'N'
052000         MOVE MB20WS-FORCE-PAGE  TO MB20WS-LINE-COUNT
052100         PERFORM 9100-CHECK-NBR-LINES
052200            THRU 9100-CNL-EXIT
052300         PERFORM 9010-PRINT-ORG-TOTALS
052400            THRU 9010-POT-EXIT
052500         PERFORM 9070-ZERO-ORG-ACCUMS
052600            THRU 9070-ZOA-EXIT
052700         MOVE 'Y'                TO WS-D720-STORE-TOT
052800         MOVE MB20WS-FORCE-PAGE  TO MB20WS-LINE-COUNT
052900     END-IF.
053000*
053100 T099-TR-EXIT.
053200     EXIT.
053300/
053400 9000-PERFORMED-ROUTINES-SECT SECTION.
053500 9010-PRINT-ORG-TOTALS.
053600*
053700     MOVE MTRF-RECORD            TO MTR8-RECORD.
053800     MOVE MTR9-RECORD            TO MTRF-RECORD.
053900*
054000     MOVE SPACES                 TO MB20WS-PRINT-LINE.
054100*
054200     PERFORM MB22PD-PRINT-1-LINE
054300        THRU MB22PD-P1L-EXIT.
054400*
054500     MOVE SPACES                 TO MB20WS-SH-LINE-5
054600                                    MB20WS-SH-LINE-6
054700                                    MB20WS-SH-LINE-7
054800                                    MB20WS-SH-LINE-8.
054900*
055000     EVALUATE TRUE
055100       WHEN WS-D720-MERCH-TOT IS EQUAL TO 'N'
055200         MOVE '**** TRANSACTIONS ON MERCHANTS TOTALS ****'
055300                                 TO WS-OTL1-LIT-1
055400         PERFORM MB22PD-PRINT-2-LINES
055500            THRU MB22PD-P2L-EXIT
055600       WHEN WS-D720-STORE-TOT IS EQUAL TO 'N'
055700         MOVE '**** TRANSACTIONS ON STORES TOTALS ****'
055800                                 TO WS-OTL1-LIT-1
055900         PERFORM MB22PD-PRINT-2-LINES
056000            THRU MB22PD-P2L-EXIT
056100     END-EVALUATE.
056200*
056300     MOVE '**** ORGANIZATION TOTALS ****  FOR ORGANIZATION'
056400                                 TO WS-OTL1-LIT-1.
056500     MOVE MTRF-K1-ORG            TO WS-OTL1-ORG-NBR.
056600     MOVE MTRF-HD-ORG-NAME       TO WS-OTL1-ORG-DESC.
056700     PERFORM MB22PD-PRINT-1-LINE
056800        THRU MB22PD-P1L-EXIT.
056900*
057000     SET X-WS-TT                 TO 1.
057100     PERFORM 9030-PRINT-TOTALS
057200        THRU 9030-PT-EXIT.
057300*
057400     MOVE MTR8-RECORD            TO MTRF-RECORD.
057500*
057600 9010-POT-EXIT.
057700     EXIT.
057800/
057900 9020-PRINT-MER-TOTALS.
058000*
058100     PERFORM MB22PD-PRINT-1-LINE
058200        THRU MB22PD-P1L-EXIT.
058300*
058400     EVALUATE TRUE
058500       WHEN MWRF-K2-O13-FT-STORE
058600         MOVE '***** STORE  TOTALS *****         FOR STORE    '
058700                                 TO WS-MTL1-LIT-1
058800         MOVE MWRF-K2-O13-STORE  TO WS-MTL1-MER-NBR
058900       WHEN OTHER
059000         MOVE '**** MERCHANT TOTALS ****      FOR MERCHANT    '
059100                                 TO WS-MTL1-LIT-1
059200         MOVE MWRF-K2-O13-MERCHANT
059300                                 TO WS-MTL1-MER-NBR
059400     END-EVALUATE.
059500*
059600     MOVE MWRF-NAME              TO WS-MTL1-MER-DESC.
059700*
059800     PERFORM MB22PD-PRINT-1-LINE
059900        THRU MB22PD-P1L-EXIT.
060000*
060100     SET X-WS-TT                 TO 2.
060200     PERFORM 9030-PRINT-TOTALS
060300        THRU 9030-PT-EXIT.
060400*
060500 9020-PMT-EXIT.
060600     EXIT.
060700/
060800 9030-PRINT-TOTALS.
060900*
061000     MOVE '*-------------- DEBITS -------------*'
061100                                 TO WS-HTL1-LIT-1.
061200     MOVE '*------------- CREDITS -------------*'
061300                                 TO WS-HTL1-LIT-2.
061400     PERFORM MB22PD-PRINT-1-LINE
061500        THRU MB22PD-P1L-EXIT.
061600*
061700     MOVE 'DEPOSITS              '
061800                                 TO WS-TL1-LIT-1.
061900     MOVE WS-TT-NBR (X-WS-TT 1)  TO SS95WS-IN-NBR.
062000     MOVE WS-TT-AMT (X-WS-TT 1)  TO SS95WS-IN-AMT.
062100     PERFORM SS95PD-NAP-ROUTINE
062200        THRU SS95PD-NAP-EXIT.
062300     MOVE SS95WS-OUT-NBR-L12     TO WS-TL1-DR-NBR.
062400     MOVE SS95WS-OUT-AMT-L20     TO WS-TL1-DR-AMT.
062500*
062600     MOVE WS-TT-NBR (X-WS-TT 2)  TO SS95WS-IN-NBR.
062700     MOVE WS-TT-AMT (X-WS-TT 2)  TO SS95WS-IN-AMT.
062800     PERFORM SS95PD-NAP-ROUTINE
062900        THRU SS95PD-NAP-EXIT.
063000     MOVE SS95WS-OUT-NBR-L12     TO WS-TL1-CR-NBR.
063100     MOVE SS95WS-OUT-AMT-L20     TO WS-TL1-CR-AMT.
063200*
063300     IF  WS-TIPT-IF-PRINT (1)
063400         PERFORM MB22PD-PRINT-1-LINE
063500            THRU MB22PD-P1L-EXIT
063600     ELSE
063700         MOVE SPACES             TO MB20WS-PRINT-LINE.
063800*
063900     MOVE 'RESERVES              '
064000                                 TO WS-TL1-LIT-1.
064100     MOVE WS-TT-NBR (X-WS-TT 3)  TO SS95WS-IN-NBR.
064200     MOVE WS-TT-AMT (X-WS-TT 3)  TO SS95WS-IN-AMT.
064300     PERFORM SS95PD-NAP-ROUTINE
064400        THRU SS95PD-NAP-EXIT.
064500     MOVE SS95WS-OUT-NBR-L12     TO WS-TL1-DR-NBR.
064600     MOVE SS95WS-OUT-AMT-L20     TO WS-TL1-DR-AMT.
064700*
064800     MOVE WS-TT-NBR (X-WS-TT 4)  TO SS95WS-IN-NBR.
064900     MOVE WS-TT-AMT (X-WS-TT 4)  TO SS95WS-IN-AMT.
065000     PERFORM SS95PD-NAP-ROUTINE
065100        THRU SS95PD-NAP-EXIT.
065200     MOVE SS95WS-OUT-NBR-L12     TO WS-TL1-CR-NBR.
065300     MOVE SS95WS-OUT-AMT-L20     TO WS-TL1-CR-AMT.
065400*
065500     IF  WS-TIPT-IF-PRINT (2)
065600         PERFORM MB22PD-PRINT-1-LINE
065700            THRU MB22PD-P1L-EXIT
065800     ELSE
065900         MOVE SPACES             TO MB20WS-PRINT-LINE.
066000*
066100     MOVE 'DISCOUNT              '
066200                                 TO WS-TL1-LIT-1.
066300     MOVE WS-TT-NBR (X-WS-TT 5)  TO SS95WS-IN-NBR.
066400     MOVE WS-TT-AMT (X-WS-TT 5)  TO SS95WS-IN-AMT.
066500     PERFORM SS95PD-NAP-ROUTINE
066600        THRU SS95PD-NAP-EXIT.
066700     MOVE SS95WS-OUT-NBR-L12     TO WS-TL1-DR-NBR.
066800     MOVE SS95WS-OUT-AMT-L20     TO WS-TL1-DR-AMT.
066900*
067000     MOVE WS-TT-NBR (X-WS-TT 6)  TO SS95WS-IN-NBR.
067100     MOVE WS-TT-AMT (X-WS-TT 6)  TO SS95WS-IN-AMT.
067200     PERFORM SS95PD-NAP-ROUTINE
067300        THRU SS95PD-NAP-EXIT.
067400     MOVE SS95WS-OUT-NBR-L12     TO WS-TL1-CR-NBR.
067500     MOVE SS95WS-OUT-AMT-L20     TO WS-TL1-CR-AMT.
067600*
067700     IF  WS-TIPT-IF-PRINT (3)
067800         PERFORM MB22PD-PRINT-1-LINE
067900            THRU MB22PD-P1L-EXIT
068000     ELSE
068100         MOVE SPACES             TO MB20WS-PRINT-LINE.
068200*
068300     MOVE 'PARTICIPATION         '
068400                                 TO WS-TL1-LIT-1.
068500     MOVE WS-TT-NBR (X-WS-TT 7)  TO SS95WS-IN-NBR.
068600     MOVE WS-TT-AMT (X-WS-TT 7)  TO SS95WS-IN-AMT.
068700     PERFORM SS95PD-NAP-ROUTINE
068800        THRU SS95PD-NAP-EXIT.
068900     MOVE SS95WS-OUT-NBR-L12     TO WS-TL1-DR-NBR.
069000     MOVE SS95WS-OUT-AMT-L20     TO WS-TL1-DR-AMT.
069100*
069200     MOVE WS-TT-NBR (X-WS-TT 8)  TO SS95WS-IN-NBR.
069300     MOVE WS-TT-AMT (X-WS-TT 8)  TO SS95WS-IN-AMT.
069400     PERFORM SS95PD-NAP-ROUTINE
069500        THRU SS95PD-NAP-EXIT.
069600     MOVE SS95WS-OUT-NBR-L12     TO WS-TL1-CR-NBR.
069700     MOVE SS95WS-OUT-AMT-L20     TO WS-TL1-CR-AMT.
069800*
069900     IF  WS-TIPT-IF-PRINT (4)
070000         PERFORM MB22PD-PRINT-1-LINE
070100            THRU MB22PD-P1L-EXIT
070200     ELSE
070300         MOVE SPACES             TO MB20WS-PRINT-LINE.
070400*
070500     MOVE 'MERCHANT ADJUSTMENTS  '
070600                                 TO WS-TL1-LIT-1.
070700     MOVE WS-TT-NBR (X-WS-TT 9)  TO SS95WS-IN-NBR.
070800     MOVE WS-TT-AMT (X-WS-TT 9)  TO SS95WS-IN-AMT.
070900     PERFORM SS95PD-NAP-ROUTINE
071000        THRU SS95PD-NAP-EXIT.
071100     MOVE SS95WS-OUT-NBR-L12     TO WS-TL1-DR-NBR.
071200     MOVE SS95WS-OUT-AMT-L20     TO WS-TL1-DR-AMT.
071300*
071400     MOVE WS-TT-NBR (X-WS-TT 10) TO SS95WS-IN-NBR.
071500     MOVE WS-TT-AMT (X-WS-TT 10) TO SS95WS-IN-AMT.
071600     PERFORM SS95PD-NAP-ROUTINE
071700        THRU SS95PD-NAP-EXIT.
071800     MOVE SS95WS-OUT-NBR-L12     TO WS-TL1-CR-NBR.
071900     MOVE SS95WS-OUT-AMT-L20     TO WS-TL1-CR-AMT.
072000*
072100     IF  WS-TIPT-IF-PRINT (5)
072200         PERFORM MB22PD-PRINT-1-LINE
072300            THRU MB22PD-P1L-EXIT
072400     ELSE
072500         MOVE SPACES             TO MB20WS-PRINT-LINE.
072600*
072700     MOVE 'RECOVERY ADJUSTMENTS  '
072800                                 TO WS-TL1-LIT-1.
072900     MOVE WS-TT-NBR (X-WS-TT 11) TO SS95WS-IN-NBR.
073000     MOVE WS-TT-AMT (X-WS-TT 11) TO SS95WS-IN-AMT.
073100     PERFORM SS95PD-NAP-ROUTINE
073200        THRU SS95PD-NAP-EXIT.
073300     MOVE SS95WS-OUT-NBR-L12     TO WS-TL1-DR-NBR.
073400     MOVE SS95WS-OUT-AMT-L20     TO WS-TL1-DR-AMT.
073500*
073600     MOVE WS-TT-NBR (X-WS-TT 12) TO SS95WS-IN-NBR.
073700     MOVE WS-TT-AMT (X-WS-TT 12) TO SS95WS-IN-AMT.
073800     PERFORM SS95PD-NAP-ROUTINE
073900        THRU SS95PD-NAP-EXIT.
074000     MOVE SS95WS-OUT-NBR-L12     TO WS-TL1-CR-NBR.
074100     MOVE SS95WS-OUT-AMT-L20     TO WS-TL1-CR-AMT.
074200*
074300     IF  WS-TIPT-IF-PRINT (6)
074400         PERFORM MB22PD-PRINT-1-LINE
074500            THRU MB22PD-P1L-EXIT
074600     ELSE
074700         MOVE SPACES             TO MB20WS-PRINT-LINE.
074800*
074900     MOVE 'SYSTEM FEES           '
075000                                 TO WS-TL1-LIT-1.
075100     MOVE WS-TT-NBR (X-WS-TT 13) TO SS95WS-IN-NBR.
075200     MOVE WS-TT-AMT (X-WS-TT 13) TO SS95WS-IN-AMT.
075300     PERFORM SS95PD-NAP-ROUTINE
075400        THRU SS95PD-NAP-EXIT.
075500     MOVE SS95WS-OUT-NBR-L12     TO WS-TL1-DR-NBR.
075600     MOVE SS95WS-OUT-AMT-L20     TO WS-TL1-DR-AMT.
075700*
075800     MOVE WS-TT-NBR (X-WS-TT 14) TO SS95WS-IN-NBR.
075900     MOVE WS-TT-AMT (X-WS-TT 14) TO SS95WS-IN-AMT.
076000     PERFORM SS95PD-NAP-ROUTINE
076100        THRU SS95PD-NAP-EXIT.
076200     MOVE SS95WS-OUT-NBR-L12     TO WS-TL1-CR-NBR.
076300     MOVE SS95WS-OUT-AMT-L20     TO WS-TL1-CR-AMT.
076400*
076500     IF  WS-TIPT-IF-PRINT (7)
076600         PERFORM MB22PD-PRINT-1-LINE
076700            THRU MB22PD-P1L-EXIT
076800     ELSE
076900         MOVE SPACES             TO MB20WS-PRINT-LINE.
077000*
077100     MOVE 'USER FEES             '
077200                                 TO WS-TL1-LIT-1.
077300     MOVE WS-TT-NBR (X-WS-TT 15) TO SS95WS-IN-NBR.
077400     MOVE WS-TT-AMT (X-WS-TT 15) TO SS95WS-IN-AMT.
077500     PERFORM SS95PD-NAP-ROUTINE
077600        THRU SS95PD-NAP-EXIT.
077700     MOVE SS95WS-OUT-NBR-L12     TO WS-TL1-DR-NBR.
077800     MOVE SS95WS-OUT-AMT-L20     TO WS-TL1-DR-AMT.
077900*
078000     MOVE WS-TT-NBR (X-WS-TT 16) TO SS95WS-IN-NBR.
078100     MOVE WS-TT-AMT (X-WS-TT 16) TO SS95WS-IN-AMT.
078200     PERFORM SS95PD-NAP-ROUTINE
078300        THRU SS95PD-NAP-EXIT.
078400     MOVE SS95WS-OUT-NBR-L12     TO WS-TL1-CR-NBR.
078500     MOVE SS95WS-OUT-AMT-L20     TO WS-TL1-CR-AMT.
078600*
078700     IF  WS-TIPT-IF-PRINT (8)
078800         PERFORM MB22PD-PRINT-1-LINE
078900            THRU MB22PD-P1L-EXIT
079000     ELSE
079100         MOVE SPACES             TO MB20WS-PRINT-LINE.
079200*
079300     MOVE 'INTERCHANGE FEES      '
079400                                 TO WS-TL1-LIT-1.
079500     MOVE WS-TT-NBR (X-WS-TT 17) TO SS95WS-IN-NBR.
079600     MOVE WS-TT-AMT (X-WS-TT 17) TO SS95WS-IN-AMT.
079700     PERFORM SS95PD-NAP-ROUTINE
079800        THRU SS95PD-NAP-EXIT.
079900     MOVE SS95WS-OUT-NBR-L12     TO WS-TL1-DR-NBR.
080000     MOVE SS95WS-OUT-AMT-L20     TO WS-TL1-DR-AMT.
080100*
080200     MOVE WS-TT-NBR (X-WS-TT 18) TO SS95WS-IN-NBR.
080300     MOVE WS-TT-AMT (X-WS-TT 18) TO SS95WS-IN-AMT.
080400     PERFORM SS95PD-NAP-ROUTINE
080500        THRU SS95PD-NAP-EXIT.
080600     MOVE SS95WS-OUT-NBR-L12     TO WS-TL1-CR-NBR.
080700     MOVE SS95WS-OUT-AMT-L20     TO WS-TL1-CR-AMT.
080800*
080900     IF  WS-TIPT-IF-PRINT (9)
081000         PERFORM MB22PD-PRINT-1-LINE
081100            THRU MB22PD-P1L-EXIT
081200     ELSE
081300         MOVE SPACES             TO MB20WS-PRINT-LINE.
081400*
081500     MOVE 'USER CREDITS          '
081600                                 TO WS-TL1-LIT-1.
081700     MOVE WS-TT-NBR (X-WS-TT 19) TO SS95WS-IN-NBR.
081800     MOVE WS-TT-AMT (X-WS-TT 19) TO SS95WS-IN-AMT.
081900     PERFORM SS95PD-NAP-ROUTINE
082000        THRU SS95PD-NAP-EXIT.
082100     MOVE SS95WS-OUT-NBR-L12     TO WS-TL1-DR-NBR.
082200     MOVE SS95WS-OUT-AMT-L20     TO WS-TL1-DR-AMT.
082300*
082400     MOVE WS-TT-NBR (X-WS-TT 20) TO SS95WS-IN-NBR.
082500     MOVE WS-TT-AMT (X-WS-TT 20) TO SS95WS-IN-AMT.
082600     PERFORM SS95PD-NAP-ROUTINE
082700        THRU SS95PD-NAP-EXIT.
082800     MOVE SS95WS-OUT-NBR-L12     TO WS-TL1-CR-NBR.
082900     MOVE SS95WS-OUT-AMT-L20     TO WS-TL1-CR-AMT.
083000*
083100     IF  WS-TIPT-IF-PRINT (10)
083200         PERFORM MB22PD-PRINT-1-LINE
083300            THRU MB22PD-P1L-EXIT
083400     ELSE
083500         MOVE SPACES             TO MB20WS-PRINT-LINE.
083600*
083700     MOVE ALL '-'                TO WS-TL1-DR-NBR.
083800     MOVE ALL '-'                TO WS-TL1-DR-AMT.
083900     MOVE ALL '-'                TO WS-TL1-CR-NBR.
084000     MOVE ALL '-'                TO WS-TL1-CR-AMT.
084100*
084200     IF  WS-TIPT-IF-PRINT (28)
084300         PERFORM MB22PD-PRINT-1-LINE
084400            THRU MB22PD-P1L-EXIT
084500     ELSE
084600         MOVE SPACES             TO MB20WS-PRINT-LINE.
084700*
084800     MOVE '    SUB-TOTAL.........'
084900                                 TO WS-TL1-LIT-1.
085000     COMPUTE SS95WS-IN-NBR       =  WS-TT-NBR (X-WS-TT 1)
085100                                 +  WS-TT-NBR (X-WS-TT 3)
085200                                 +  WS-TT-NBR (X-WS-TT 5)
085300                                 +  WS-TT-NBR (X-WS-TT 7)
085400                                 +  WS-TT-NBR (X-WS-TT 9)
085500                                 +  WS-TT-NBR (X-WS-TT 11)
085600                                 +  WS-TT-NBR (X-WS-TT 13)
085700                                 +  WS-TT-NBR (X-WS-TT 15)
085800                                 +  WS-TT-NBR (X-WS-TT 17)
085900                                 +  WS-TT-NBR (X-WS-TT 19).
086000     COMPUTE SS95WS-IN-AMT       =  WS-TT-AMT (X-WS-TT 1)
086100                                 +  WS-TT-AMT (X-WS-TT 3)
086200                                 +  WS-TT-AMT (X-WS-TT 5)
086300                                 +  WS-TT-AMT (X-WS-TT 7)
086400                                 +  WS-TT-AMT (X-WS-TT 9)
086500                                 +  WS-TT-AMT (X-WS-TT 11)
086600                                 +  WS-TT-AMT (X-WS-TT 13)
086700                                 +  WS-TT-AMT (X-WS-TT 15)
086800                                 +  WS-TT-AMT (X-WS-TT 17)
086900                                 +  WS-TT-AMT (X-WS-TT 19).
087000     PERFORM SS95PD-NAP-ROUTINE
087100        THRU SS95PD-NAP-EXIT.
087200     MOVE SS95WS-OUT-NBR-L12     TO WS-TL1-DR-NBR.
087300     MOVE SS95WS-OUT-AMT-L20     TO WS-TL1-DR-AMT.
087400*
087500     COMPUTE SS95WS-IN-NBR       =  WS-TT-NBR (X-WS-TT 2)
087600                                 +  WS-TT-NBR (X-WS-TT 4)
087700                                 +  WS-TT-NBR (X-WS-TT 6)
087800                                 +  WS-TT-NBR (X-WS-TT 8)
087900                                 +  WS-TT-NBR (X-WS-TT 10)
088000                                 +  WS-TT-NBR (X-WS-TT 12)
088100                                 +  WS-TT-NBR (X-WS-TT 14)
088200                                 +  WS-TT-NBR (X-WS-TT 16)
088300                                 +  WS-TT-NBR (X-WS-TT 18)
088400                                 +  WS-TT-NBR (X-WS-TT 20).
088500     COMPUTE SS95WS-IN-AMT       =  WS-TT-AMT (X-WS-TT 2)
088600                                 +  WS-TT-AMT (X-WS-TT 4)
088700                                 +  WS-TT-AMT (X-WS-TT 6)
088800                                 +  WS-TT-AMT (X-WS-TT 8)
088900                                 +  WS-TT-AMT (X-WS-TT 10)
089000                                 +  WS-TT-AMT (X-WS-TT 12)
089100                                 +  WS-TT-AMT (X-WS-TT 14)
089200                                 +  WS-TT-AMT (X-WS-TT 16)
089300                                 +  WS-TT-AMT (X-WS-TT 18)
089400                                 +  WS-TT-AMT (X-WS-TT 20).
089500     PERFORM SS95PD-NAP-ROUTINE
089600        THRU SS95PD-NAP-EXIT.
089700     MOVE SS95WS-OUT-NBR-L12     TO WS-TL1-CR-NBR.
089800     MOVE SS95WS-OUT-AMT-L20     TO WS-TL1-CR-AMT.
089900*
090000     IF  WS-TIPT-IF-PRINT (28)
090100         PERFORM MB22PD-PRINT-1-LINE
090200            THRU MB22PD-P1L-EXIT
090300     ELSE
090400         MOVE SPACES             TO MB20WS-PRINT-LINE.
090500*
090600     MOVE 'TRANSFER TO INVOICE   '
090700                                 TO WS-TL1-LIT-1.
090800     MOVE WS-TT-NBR (X-WS-TT 21) TO SS95WS-IN-NBR.
090900     MOVE WS-TT-AMT (X-WS-TT 21) TO SS95WS-IN-AMT.
091000     PERFORM SS95PD-NAP-ROUTINE
091100        THRU SS95PD-NAP-EXIT.
091200     MOVE SS95WS-OUT-NBR-L12     TO WS-TL1-DR-NBR.
091300     MOVE SS95WS-OUT-AMT-L20     TO WS-TL1-DR-AMT.
091400*
091500     MOVE WS-TT-NBR (X-WS-TT 22) TO SS95WS-IN-NBR.
091600     MOVE WS-TT-AMT (X-WS-TT 22) TO SS95WS-IN-AMT.
091700     PERFORM SS95PD-NAP-ROUTINE
091800        THRU SS95PD-NAP-EXIT.
091900     MOVE SS95WS-OUT-NBR-L12     TO WS-TL1-CR-NBR.
092000     MOVE SS95WS-OUT-AMT-L20     TO WS-TL1-CR-AMT.
092100*
092200     IF  WS-TIPT-IF-PRINT (11)
092300         PERFORM MB22PD-PRINT-1-LINE
092400            THRU MB22PD-P1L-EXIT
092500     ELSE
092600         MOVE SPACES             TO MB20WS-PRINT-LINE.
092700*
092800     MOVE 'HOLDOVER TRANSACTIONS '
092900                                 TO WS-TL1-LIT-1.
093000     MOVE WS-TT-NBR (X-WS-TT 23) TO SS95WS-IN-NBR.
093100     MOVE WS-TT-AMT (X-WS-TT 23) TO SS95WS-IN-AMT.
093200     PERFORM SS95PD-NAP-ROUTINE
093300        THRU SS95PD-NAP-EXIT.
093400     MOVE SS95WS-OUT-NBR-L12     TO WS-TL1-DR-NBR.
093500     MOVE SS95WS-OUT-AMT-L20     TO WS-TL1-DR-AMT.
093600*
093700     MOVE WS-TT-NBR (X-WS-TT 24) TO SS95WS-IN-NBR.
093800     MOVE WS-TT-AMT (X-WS-TT 24) TO SS95WS-IN-AMT.
093900     PERFORM SS95PD-NAP-ROUTINE
094000        THRU SS95PD-NAP-EXIT.
094100     MOVE SS95WS-OUT-NBR-L12     TO WS-TL1-CR-NBR.
094200     MOVE SS95WS-OUT-AMT-L20     TO WS-TL1-CR-AMT.
094300*
094400     IF  WS-TIPT-IF-PRINT (12)
094500         PERFORM MB22PD-PRINT-1-LINE
094600            THRU MB22PD-P1L-EXIT
094700     ELSE
094800         MOVE SPACES             TO MB20WS-PRINT-LINE.
094900*
095000     MOVE ALL '-'                TO WS-TL1-DR-NBR.
095100     MOVE ALL '-'                TO WS-TL1-DR-AMT.
095200     MOVE ALL '-'                TO WS-TL1-CR-NBR.
095300     MOVE ALL '-'                TO WS-TL1-CR-AMT.
095400*
095500     IF  WS-TIPT-IF-PRINT (29)
095600         PERFORM MB22PD-PRINT-1-LINE
095700            THRU MB22PD-P1L-EXIT
095800     ELSE
095900         MOVE SPACES             TO MB20WS-PRINT-LINE.
096000*
096100     MOVE '*SETTLEMENT IN TOTAL* '
096200                                 TO WS-TL1-LIT-1.
096300     COMPUTE SS95WS-IN-NBR       =  WS-TT-NBR (X-WS-TT 1)
096400                                 +  WS-TT-NBR (X-WS-TT 3)
096500                                 +  WS-TT-NBR (X-WS-TT 5)
096600                                 +  WS-TT-NBR (X-WS-TT 7)
096700                                 +  WS-TT-NBR (X-WS-TT 9)
096800                                 +  WS-TT-NBR (X-WS-TT 11)
096900                                 +  WS-TT-NBR (X-WS-TT 13)
097000                                 +  WS-TT-NBR (X-WS-TT 15)
097100                                 +  WS-TT-NBR (X-WS-TT 17)
097200                                 +  WS-TT-NBR (X-WS-TT 19)
097300                                 +  WS-TT-NBR (X-WS-TT 21)
097400                                 +  WS-TT-NBR (X-WS-TT 23).
097500     COMPUTE SS95WS-IN-AMT       =  WS-TT-AMT (X-WS-TT 1)
097600                                 +  WS-TT-AMT (X-WS-TT 3)
097700                                 +  WS-TT-AMT (X-WS-TT 5)
097800                                 +  WS-TT-AMT (X-WS-TT 7)
097900                                 +  WS-TT-AMT (X-WS-TT 9)
098000                                 +  WS-TT-AMT (X-WS-TT 11)
098100                                 +  WS-TT-AMT (X-WS-TT 13)
098200                                 +  WS-TT-AMT (X-WS-TT 15)
098300                                 +  WS-TT-AMT (X-WS-TT 17)
098400                                 +  WS-TT-AMT (X-WS-TT 19)
098500                                 +  WS-TT-AMT (X-WS-TT 21)
098600                                 +  WS-TT-AMT (X-WS-TT 23).
098700     PERFORM SS95PD-NAP-ROUTINE
098800        THRU SS95PD-NAP-EXIT.
098900     MOVE SS95WS-OUT-NBR-L12     TO WS-TL1-DR-NBR.
099000     MOVE SS95WS-OUT-AMT-L20     TO WS-TL1-DR-AMT.
099100*
099200     COMPUTE SS95WS-IN-NBR       =  WS-TT-NBR (X-WS-TT 2)
099300                                 +  WS-TT-NBR (X-WS-TT 4)
099400                                 +  WS-TT-NBR (X-WS-TT 6)
099500                                 +  WS-TT-NBR (X-WS-TT 8)
099600                                 +  WS-TT-NBR (X-WS-TT 10)
099700                                 +  WS-TT-NBR (X-WS-TT 12)
099800                                 +  WS-TT-NBR (X-WS-TT 14)
099900                                 +  WS-TT-NBR (X-WS-TT 16)
100000                                 +  WS-TT-NBR (X-WS-TT 18)
100100                                 +  WS-TT-NBR (X-WS-TT 20)
100200                                 +  WS-TT-NBR (X-WS-TT 22)
100300                                 +  WS-TT-NBR (X-WS-TT 24).
100400     COMPUTE SS95WS-IN-AMT       =  WS-TT-AMT (X-WS-TT 2)
100500                                 +  WS-TT-AMT (X-WS-TT 4)
100600                                 +  WS-TT-AMT (X-WS-TT 6)
100700                                 +  WS-TT-AMT (X-WS-TT 8)
100800                                 +  WS-TT-AMT (X-WS-TT 10)
100900                                 +  WS-TT-AMT (X-WS-TT 12)
101000                                 +  WS-TT-AMT (X-WS-TT 14)
101100                                 +  WS-TT-AMT (X-WS-TT 16)
101200                                 +  WS-TT-AMT (X-WS-TT 18)
101300                                 +  WS-TT-AMT (X-WS-TT 20)
101400                                 +  WS-TT-AMT (X-WS-TT 22)
101500                                 +  WS-TT-AMT (X-WS-TT 24).
101600     PERFORM SS95PD-NAP-ROUTINE
101700        THRU SS95PD-NAP-EXIT.
101800     MOVE SS95WS-OUT-NBR-L12     TO WS-TL1-CR-NBR.
101900     MOVE SS95WS-OUT-AMT-L20     TO WS-TL1-CR-AMT.
102000*
102100     IF  WS-TIPT-IF-PRINT (29)
102200         PERFORM MB22PD-PRINT-2-LINES
102300            THRU MB22PD-P2L-EXIT
102400     ELSE
102500         MOVE SPACES             TO MB20WS-PRINT-LINE
102600         PERFORM MB22PD-PRINT-1-LINE
102700            THRU MB22PD-P1L-EXIT.
102800*
102900     MOVE 'SETTLEMENT - A C H    '
103000                                 TO WS-TL1-LIT-1.
103100     MOVE WS-TT-NBR (X-WS-TT 25) TO SS95WS-IN-NBR.
103200     MOVE WS-TT-AMT (X-WS-TT 25) TO SS95WS-IN-AMT.
103300     PERFORM SS95PD-NAP-ROUTINE
103400        THRU SS95PD-NAP-EXIT.
103500     MOVE SS95WS-OUT-NBR-L12     TO WS-TL1-DR-NBR.
103600     MOVE SS95WS-OUT-AMT-L20     TO WS-TL1-DR-AMT.
103700*
103800     MOVE WS-TT-NBR (X-WS-TT 26) TO SS95WS-IN-NBR.
103900     MOVE WS-TT-AMT (X-WS-TT 26) TO SS95WS-IN-AMT.
104000     PERFORM SS95PD-NAP-ROUTINE
104100        THRU SS95PD-NAP-EXIT.
104200     MOVE SS95WS-OUT-NBR-L12     TO WS-TL1-CR-NBR.
104300     MOVE SS95WS-OUT-AMT-L20     TO WS-TL1-CR-AMT.
104400*
104500     IF  WS-TIPT-IF-PRINT (13)
104600         PERFORM MB22PD-PRINT-1-LINE
104700            THRU MB22PD-P1L-EXIT
104800     ELSE
104900         MOVE SPACES             TO MB20WS-PRINT-LINE.
105000*
105100     MOVE 'SETTLEMENT - CHECK    '
105200                                 TO WS-TL1-LIT-1.
105300     MOVE WS-TT-NBR (X-WS-TT 27) TO SS95WS-IN-NBR.
105400     MOVE WS-TT-AMT (X-WS-TT 27) TO SS95WS-IN-AMT.
105500     PERFORM SS95PD-NAP-ROUTINE
105600        THRU SS95PD-NAP-EXIT.
105700     MOVE SS95WS-OUT-NBR-L12     TO WS-TL1-DR-NBR.
105800     MOVE SS95WS-OUT-AMT-L20     TO WS-TL1-DR-AMT.
105900*
106000     MOVE WS-TT-NBR (X-WS-TT 28) TO SS95WS-IN-NBR.
106100     MOVE WS-TT-AMT (X-WS-TT 28) TO SS95WS-IN-AMT.
106200     PERFORM SS95PD-NAP-ROUTINE
106300        THRU SS95PD-NAP-EXIT.
106400     MOVE SS95WS-OUT-NBR-L12     TO WS-TL1-CR-NBR.
106500     MOVE SS95WS-OUT-AMT-L20     TO WS-TL1-CR-AMT.
106600*
106700     IF  WS-TIPT-IF-PRINT (14)
106800         PERFORM MB22PD-PRINT-1-LINE
106900            THRU MB22PD-P1L-EXIT
107000     ELSE
107100         MOVE SPACES             TO MB20WS-PRINT-LINE.
107200*
107300     MOVE 'SETTLEMENT - WIRE     '
107400                                 TO WS-TL1-LIT-1.
107500     MOVE WS-TT-NBR (X-WS-TT 29) TO SS95WS-IN-NBR.
107600     MOVE WS-TT-AMT (X-WS-TT 29) TO SS95WS-IN-AMT.
107700     PERFORM SS95PD-NAP-ROUTINE
107800        THRU SS95PD-NAP-EXIT.
107900     MOVE SS95WS-OUT-NBR-L12     TO WS-TL1-DR-NBR.
108000     MOVE SS95WS-OUT-AMT-L20     TO WS-TL1-DR-AMT.
108100*
108200     MOVE WS-TT-NBR (X-WS-TT 30) TO SS95WS-IN-NBR.
108300     MOVE WS-TT-AMT (X-WS-TT 30) TO SS95WS-IN-AMT.
108400     PERFORM SS95PD-NAP-ROUTINE
108500        THRU SS95PD-NAP-EXIT.
108600     MOVE SS95WS-OUT-NBR-L12     TO WS-TL1-CR-NBR.
108700     MOVE SS95WS-OUT-AMT-L20     TO WS-TL1-CR-AMT.
108800*
108900     IF  WS-TIPT-IF-PRINT (15)
109000         PERFORM MB22PD-PRINT-1-LINE
109100            THRU MB22PD-P1L-EXIT
109200     ELSE
109300         MOVE SPACES             TO MB20WS-PRINT-LINE.
109400*
109500     MOVE 'SETTLEMENT - MANUAL   '
109600                                 TO WS-TL1-LIT-1.
109700     MOVE WS-TT-NBR (X-WS-TT 31) TO SS95WS-IN-NBR.
109800     MOVE WS-TT-AMT (X-WS-TT 31) TO SS95WS-IN-AMT.
109900     PERFORM SS95PD-NAP-ROUTINE
110000        THRU SS95PD-NAP-EXIT.
110100     MOVE SS95WS-OUT-NBR-L12     TO WS-TL1-DR-NBR.
110200     MOVE SS95WS-OUT-AMT-L20     TO WS-TL1-DR-AMT.
110300*
110400     MOVE WS-TT-NBR (X-WS-TT 32) TO SS95WS-IN-NBR.
110500     MOVE WS-TT-AMT (X-WS-TT 32) TO SS95WS-IN-AMT.
110600     PERFORM SS95PD-NAP-ROUTINE
110700        THRU SS95PD-NAP-EXIT.
110800     MOVE SS95WS-OUT-NBR-L12     TO WS-TL1-CR-NBR.
110900     MOVE SS95WS-OUT-AMT-L20     TO WS-TL1-CR-AMT.
111000*
111100     IF  WS-TIPT-IF-PRINT (16)
111200         PERFORM MB22PD-PRINT-1-LINE
111300            THRU MB22PD-P1L-EXIT
111400     ELSE
111500         MOVE SPACES             TO MB20WS-PRINT-LINE.
111600*
111700     MOVE 'SETTLEMENT - INVOICE  '
111800                                 TO WS-TL1-LIT-1.
111900     MOVE WS-TT-NBR (X-WS-TT 33) TO SS95WS-IN-NBR.
112000     MOVE WS-TT-AMT (X-WS-TT 33) TO SS95WS-IN-AMT.
112100     PERFORM SS95PD-NAP-ROUTINE
112200        THRU SS95PD-NAP-EXIT.
112300     MOVE SS95WS-OUT-NBR-L12     TO WS-TL1-DR-NBR.
112400     MOVE SS95WS-OUT-AMT-L20     TO WS-TL1-DR-AMT.
112500*
112600     MOVE WS-TT-NBR (X-WS-TT 34) TO SS95WS-IN-NBR.
112700     MOVE WS-TT-AMT (X-WS-TT 34) TO SS95WS-IN-AMT.
112800     PERFORM SS95PD-NAP-ROUTINE
112900        THRU SS95PD-NAP-EXIT.
113000     MOVE SS95WS-OUT-NBR-L12     TO WS-TL1-CR-NBR.
113100     MOVE SS95WS-OUT-AMT-L20     TO WS-TL1-CR-AMT.
113200*
113300     IF  WS-TIPT-IF-PRINT (17)
113400         PERFORM MB22PD-PRINT-1-LINE
113500            THRU MB22PD-P1L-EXIT
113600     ELSE
113700         MOVE SPACES             TO MB20WS-PRINT-LINE.
113800*
113900     MOVE 'SETTLEMENT - WINDOW   '
114000                                 TO WS-TL1-LIT-1.
114100     MOVE WS-TT-NBR (X-WS-TT 35) TO SS95WS-IN-NBR.
114200     MOVE WS-TT-AMT (X-WS-TT 35) TO SS95WS-IN-AMT.
114300     PERFORM SS95PD-NAP-ROUTINE
114400        THRU SS95PD-NAP-EXIT.
114500     MOVE SS95WS-OUT-NBR-L12     TO WS-TL1-DR-NBR.
114600     MOVE SS95WS-OUT-AMT-L20     TO WS-TL1-DR-AMT.
114700*
114800     MOVE WS-TT-NBR (X-WS-TT 36) TO SS95WS-IN-NBR.
114900     MOVE WS-TT-AMT (X-WS-TT 36) TO SS95WS-IN-AMT.
115000     PERFORM SS95PD-NAP-ROUTINE
115100        THRU SS95PD-NAP-EXIT.
115200     MOVE SS95WS-OUT-NBR-L12     TO WS-TL1-CR-NBR.
115300     MOVE SS95WS-OUT-AMT-L20     TO WS-TL1-CR-AMT.
115400*
115500     IF  WS-TIPT-IF-PRINT (18)
115600         PERFORM MB22PD-PRINT-1-LINE
115700            THRU MB22PD-P1L-EXIT
115800     ELSE
115900         MOVE SPACES             TO MB20WS-PRINT-LINE.
116000*
116100     MOVE ALL '-'                TO WS-TL1-DR-NBR.
116200     MOVE ALL '-'                TO WS-TL1-DR-AMT.
116300     MOVE ALL '-'                TO WS-TL1-CR-NBR.
116400     MOVE ALL '-'                TO WS-TL1-CR-AMT.
116500*
116600     IF  WS-TIPT-IF-PRINT (30)
116700         PERFORM MB22PD-PRINT-1-LINE
116800            THRU MB22PD-P1L-EXIT
116900     ELSE
117000         MOVE SPACES             TO MB20WS-PRINT-LINE.
117100*
117200     MOVE '*SETTLEMENT OUT TOTAL*'
117300                                 TO WS-TL1-LIT-1.
117400     COMPUTE SS95WS-IN-NBR       =  WS-TT-NBR (X-WS-TT 25)
117500                                 +  WS-TT-NBR (X-WS-TT 27)
117600                                 +  WS-TT-NBR (X-WS-TT 29)
117700                                 +  WS-TT-NBR (X-WS-TT 31)
117800                                 +  WS-TT-NBR (X-WS-TT 33)
117900                                 +  WS-TT-NBR (X-WS-TT 35).
118000     COMPUTE SS95WS-IN-AMT       =  WS-TT-AMT (X-WS-TT 25)
118100                                 +  WS-TT-AMT (X-WS-TT 27)
118200                                 +  WS-TT-AMT (X-WS-TT 29)
118300                                 +  WS-TT-AMT (X-WS-TT 31)
118400                                 +  WS-TT-AMT (X-WS-TT 33)
118500                                 +  WS-TT-AMT (X-WS-TT 35).
118600     PERFORM SS95PD-NAP-ROUTINE
118700        THRU SS95PD-NAP-EXIT.
118800     MOVE SS95WS-OUT-NBR-L12     TO WS-TL1-DR-NBR.
118900     MOVE SS95WS-OUT-AMT-L20     TO WS-TL1-DR-AMT.
119000*
119100     COMPUTE SS95WS-IN-NBR       =  WS-TT-NBR (X-WS-TT 26)
119200                                 +  WS-TT-NBR (X-WS-TT 28)
119300                                 +  WS-TT-NBR (X-WS-TT 30)
119400                                 +  WS-TT-NBR (X-WS-TT 32)
119500                                 +  WS-TT-NBR (X-WS-TT 34)
119600                                 +  WS-TT-NBR (X-WS-TT 36).
119700     COMPUTE SS95WS-IN-AMT       =  WS-TT-AMT (X-WS-TT 26)
119800                                 +  WS-TT-AMT (X-WS-TT 28)
119900                                 +  WS-TT-AMT (X-WS-TT 30)
120000                                 +  WS-TT-AMT (X-WS-TT 32)
120100                                 +  WS-TT-AMT (X-WS-TT 34)
120200                                 +  WS-TT-AMT (X-WS-TT 36).
120300     PERFORM SS95PD-NAP-ROUTINE
120400        THRU SS95PD-NAP-EXIT.
120500     MOVE SS95WS-OUT-NBR-L12     TO WS-TL1-CR-NBR.
120600     MOVE SS95WS-OUT-AMT-L20     TO WS-TL1-CR-AMT.
120700*
120800     IF  WS-TIPT-IF-PRINT (30)
120900         PERFORM MB22PD-PRINT-2-LINES
121000            THRU MB22PD-P2L-EXIT
121100     ELSE
121200         MOVE SPACES             TO MB20WS-PRINT-LINE
121300         IF  WS-TIPT-IF-PRINT (29)
121400             PERFORM MB22PD-PRINT-1-LINE
121500                THRU MB22PD-P1L-EXIT.
121600*
121700     MOVE 'WINDOW TRANSACTIONS   '
121800                                 TO WS-TL1-LIT-1.
121900     MOVE WS-TT-NBR (X-WS-TT 37) TO SS95WS-IN-NBR.
122000     MOVE WS-TT-AMT (X-WS-TT 37) TO SS95WS-IN-AMT.
122100     PERFORM SS95PD-NAP-ROUTINE
122200        THRU SS95PD-NAP-EXIT.
122300     MOVE SS95WS-OUT-NBR-L12     TO WS-TL1-DR-NBR.
122400     MOVE SS95WS-OUT-AMT-L20     TO WS-TL1-DR-AMT.
122500*
122600     MOVE WS-TT-NBR (X-WS-TT 38) TO SS95WS-IN-NBR.
122700     MOVE WS-TT-AMT (X-WS-TT 38) TO SS95WS-IN-AMT.
122800     PERFORM SS95PD-NAP-ROUTINE
122900        THRU SS95PD-NAP-EXIT.
123000     MOVE SS95WS-OUT-NBR-L12     TO WS-TL1-CR-NBR.
123100     MOVE SS95WS-OUT-AMT-L20     TO WS-TL1-CR-AMT.
123200*
123300     IF  WS-TIPT-IF-PRINT (19)
123400         PERFORM MB22PD-PRINT-1-LINE
123500            THRU MB22PD-P1L-EXIT
123600     ELSE
123700         MOVE SPACES             TO MB20WS-PRINT-LINE.
123800*
123900     MOVE 'DEPOSIT MEMOS         '
124000                                 TO WS-TL1-LIT-1.
124100     MOVE WS-TT-NBR (X-WS-TT 39) TO SS95WS-IN-NBR.
124200     MOVE WS-TT-AMT (X-WS-TT 39) TO SS95WS-IN-AMT.
124300     PERFORM SS95PD-NAP-ROUTINE
124400        THRU SS95PD-NAP-EXIT.
124500     MOVE SS95WS-OUT-NBR-L12     TO WS-TL1-DR-NBR.
124600     MOVE SS95WS-OUT-AMT-L20     TO WS-TL1-DR-AMT.
124700*
124800     MOVE WS-TT-NBR (X-WS-TT 40) TO SS95WS-IN-NBR.
124900     MOVE WS-TT-AMT (X-WS-TT 40) TO SS95WS-IN-AMT.
125000     PERFORM SS95PD-NAP-ROUTINE
125100        THRU SS95PD-NAP-EXIT.
125200     MOVE SS95WS-OUT-NBR-L12     TO WS-TL1-CR-NBR.
125300     MOVE SS95WS-OUT-AMT-L20     TO WS-TL1-CR-AMT.
125400*
125500     IF  WS-TIPT-IF-PRINT (20)
125600         PERFORM MB22PD-PRINT-1-LINE
125700            THRU MB22PD-P1L-EXIT
125800     ELSE
125900         MOVE SPACES             TO MB20WS-PRINT-LINE.
126000*
126100     MOVE 'AUTH DECLINED/APPROVED'
126200                                 TO WS-TL1-LIT-1.
126300     MOVE WS-TT-NBR (X-WS-TT 41) TO SS95WS-IN-NBR.
126400     MOVE WS-TT-AMT (X-WS-TT 41) TO SS95WS-IN-AMT.
126500     PERFORM SS95PD-NAP-ROUTINE
126600        THRU SS95PD-NAP-EXIT.
126700     MOVE SS95WS-OUT-NBR-L12     TO WS-TL1-DR-NBR.
126800     MOVE SS95WS-OUT-AMT-L20     TO WS-TL1-DR-AMT.
126900*
127000     MOVE WS-TT-NBR (X-WS-TT 42) TO SS95WS-IN-NBR.
127100     MOVE WS-TT-AMT (X-WS-TT 42) TO SS95WS-IN-AMT.
127200     PERFORM SS95PD-NAP-ROUTINE
127300        THRU SS95PD-NAP-EXIT.
127400     MOVE SS95WS-OUT-NBR-L12     TO WS-TL1-CR-NBR.
127500     MOVE SS95WS-OUT-AMT-L20     TO WS-TL1-CR-AMT.
127600*
127700     IF  WS-TIPT-IF-PRINT (21)
127800         PERFORM MB22PD-PRINT-1-LINE
127900            THRU MB22PD-P1L-EXIT
128000     ELSE
128100         MOVE SPACES             TO MB20WS-PRINT-LINE.
128200*
128300     MOVE 'MEMOS                 '
128400                                 TO WS-TL1-LIT-1.
128500     MOVE WS-TT-NBR (X-WS-TT 43) TO SS95WS-IN-NBR.
128600     MOVE WS-TT-AMT (X-WS-TT 43) TO SS95WS-IN-AMT.
128700     PERFORM SS95PD-NAP-ROUTINE
128800        THRU SS95PD-NAP-EXIT.
128900     MOVE SS95WS-OUT-NBR-L12     TO WS-TL1-DR-NBR.
129000     MOVE SS95WS-OUT-AMT-L20     TO WS-TL1-DR-AMT.
129100*
129200     MOVE WS-TT-NBR (X-WS-TT 44) TO SS95WS-IN-NBR.
129300     MOVE WS-TT-AMT (X-WS-TT 44) TO SS95WS-IN-AMT.
129400     PERFORM SS95PD-NAP-ROUTINE
129500        THRU SS95PD-NAP-EXIT.
129600     MOVE SS95WS-OUT-NBR-L12     TO WS-TL1-CR-NBR.
129700     MOVE SS95WS-OUT-AMT-L20     TO WS-TL1-CR-AMT.
129800*
129900     IF  WS-TIPT-IF-PRINT (22)
130000         PERFORM MB22PD-PRINT-1-LINE
130100            THRU MB22PD-P1L-EXIT
130200     ELSE
130300         MOVE SPACES             TO MB20WS-PRINT-LINE.
130400*
130500     MOVE 'RESERVE BALANCE       '
130600                                 TO WS-TL1-LIT-1.
130700     MOVE WS-TT-NBR (X-WS-TT 45) TO SS95WS-IN-NBR.
130800     MOVE WS-TT-AMT (X-WS-TT 45) TO SS95WS-IN-AMT.
130900     PERFORM SS95PD-NAP-ROUTINE
131000        THRU SS95PD-NAP-EXIT.
131100     MOVE SS95WS-OUT-NBR-L12     TO WS-TL1-DR-NBR.
131200     MOVE SS95WS-OUT-AMT-L20     TO WS-TL1-DR-AMT.
131300*
131400     MOVE WS-TT-NBR (X-WS-TT 46) TO SS95WS-IN-NBR.
131500     MOVE WS-TT-AMT (X-WS-TT 46) TO SS95WS-IN-AMT.
131600     PERFORM SS95PD-NAP-ROUTINE
131700        THRU SS95PD-NAP-EXIT.
131800     MOVE SS95WS-OUT-NBR-L12     TO WS-TL1-CR-NBR.
131900     MOVE SS95WS-OUT-AMT-L20     TO WS-TL1-CR-AMT.
132000*
132100     IF  WS-TIPT-IF-PRINT (23)
132200         PERFORM MB22PD-PRINT-1-LINE
132300            THRU MB22PD-P1L-EXIT
132400     ELSE
132500         MOVE SPACES             TO MB20WS-PRINT-LINE.
132600*
132700 9030-PT-EXIT.
132800     EXIT.
132900*
133000 9050-ACCUMULATE-TOTALS.
133100*
133200     MOVE MTPT-LOGIC-MODULE      TO MMTCWS-LOGIC-MODULE.
133300*
133400     EVALUATE TRUE
133500         WHEN MMTCWS-LM-BATCH-HDR-DR
133600             SET X-WS-TT-ITEM    TO 1
133700         WHEN MMTCWS-LM-BATCH-HDR-CR
133800             SET X-WS-TT-ITEM    TO 2
133900         WHEN MMTCWS-LM-VALID-RESV-SETT-DR
134000             SET X-WS-TT-ITEM    TO 3
134100         WHEN MMTCWS-LM-VALID-RESV-SETT-CR
134200             SET X-WS-TT-ITEM    TO 4
134300         WHEN MMTCWS-LM-DISCOUNT
134400             SET X-WS-TT-ITEM    TO 5
134500         WHEN MMTCWS-LM-REFUND
134600             SET X-WS-TT-ITEM    TO 6
134700         WHEN MMTCWS-LM-PART-DR
134800             SET X-WS-TT-ITEM    TO 7
134900         WHEN MMTCWS-LM-PART-CR
135000             SET X-WS-TT-ITEM    TO 8
135100         WHEN MMTCWS-LM-ADJ-DR
135200             SET X-WS-TT-ITEM    TO 9
135300         WHEN MMTCWS-LM-ADJ-CR
135400             SET X-WS-TT-ITEM    TO 10
135500         WHEN MMTCWS-LM-RECOVERY-ADJ-DR
135600             SET X-WS-TT-ITEM    TO 11
135700         WHEN MMTCWS-LM-RECOVERY-ADJ-CR
135800             SET X-WS-TT-ITEM    TO 12
135900         WHEN MMTCWS-LM-SYSTEM-FEES-DR
136000             SET X-WS-TT-ITEM    TO 13
136100         WHEN MMTCWS-LM-SYSTEM-FEES-CR
136200             SET X-WS-TT-ITEM    TO 14
136300         WHEN MMTCWS-LM-USER-FEES
136400             SET X-WS-TT-ITEM    TO 15
136500         WHEN MMTCWS-LM-USER-FEES-CR
136600             SET X-WS-TT-ITEM    TO 16
136700         WHEN MMTCWS-LM-INTCHG-FEES-DR
136800             SET X-WS-TT-ITEM    TO 17
136900         WHEN MMTCWS-LM-INTCHG-FEES-CR
137000             SET X-WS-TT-ITEM    TO 18
137100         WHEN MMTCWS-LM-USER-DEBITS
137200             SET X-WS-TT-ITEM    TO 19
137300         WHEN MMTCWS-LM-USER-CREDITS
137400             SET X-WS-TT-ITEM    TO 20
137500         WHEN MMTCWS-LM-SETTLEMENT-DR-XFER
137600             SET X-WS-TT-ITEM    TO 21
137700         WHEN MMTCWS-LM-SETTLEMENT-CR-XFER
137800             SET X-WS-TT-ITEM    TO 22
137900         WHEN MMTCWS-LM-HOLDOVER
138000             SET X-WS-TT-ITEM    TO 23
138100         WHEN MMTCWS-LM-HOLDOVER-CR
138200             SET X-WS-TT-ITEM    TO 24
138300         WHEN MMTCWS-LM-SYSTEM-SETT-DR-ACH
138400             SET X-WS-TT-ITEM    TO 25
138500         WHEN MMTCWS-LM-SYSTEM-SETT-CR-ACH
138600             SET X-WS-TT-ITEM    TO 26
138700         WHEN MMTCWS-LM-SYSTEM-SETT-DR-CHECK
138800             SET X-WS-TT-ITEM    TO 27
138900         WHEN MMTCWS-LM-SYSTEM-SETT-CR-CHECK
139000             SET X-WS-TT-ITEM    TO 28
139100         WHEN MMTCWS-LM-SYSTEM-SETT-DR-WIRE
139200             SET X-WS-TT-ITEM    TO 29
139300         WHEN MMTCWS-LM-SYSTEM-SETT-CR-WIRE
139400             SET X-WS-TT-ITEM    TO 30
139500         WHEN MMTCWS-LM-SYSTEM-SETT-DR-MAN
139600             SET X-WS-TT-ITEM    TO 31
139700         WHEN MMTCWS-LM-SYSTEM-SETT-CR-MAN
139800             SET X-WS-TT-ITEM    TO 32
139900         WHEN MMTCWS-LM-SYSTEM-SETT-DR-BILL
140000             SET X-WS-TT-ITEM    TO 33
140100         WHEN MMTCWS-LM-SYSTEM-SETT-CR-BILL
140200             SET X-WS-TT-ITEM    TO 34
140300         WHEN MMTCWS-LM-WINDOW-SETT-DR
140400             SET X-WS-TT-ITEM    TO 35
140500         WHEN MMTCWS-LM-WINDOW-SETT-CR
140600             SET X-WS-TT-ITEM    TO 36
140700         WHEN MMTCWS-LM-VALID-DEP-MEMO-DR
140800             SET X-WS-TT-ITEM    TO 39
140900         WHEN MMTCWS-LM-VALID-DEP-MEMO-CR
141000             SET X-WS-TT-ITEM    TO 40
141100         WHEN MMTCWS-LM-AUTH-DECLINED
141200             SET X-WS-TT-ITEM    TO 41
141300         WHEN MMTCWS-LM-AUTH-APPROVED
141400             SET X-WS-TT-ITEM    TO 42
141500         WHEN MMTCWS-LM-CHECK-APPROVAL
141600             SET X-WS-TT-ITEM    TO 43
141700         WHEN MMTCWS-LM-RESERVE-TO-PROC
141800             SET X-WS-TT-ITEM    TO 45
141900         WHEN MMTCWS-LM-RESERVE-MANUAL
142000             SET X-WS-TT-ITEM    TO 46
142100         WHEN OTHER
142200             SET X-WS-TT-ITEM    TO 44
142300     END-EVALUATE.
142400*
142500     PERFORM 9060-ADD-TO-TOTALS
142600        THRU 9060-ATT-EXIT.
142700*
142800     EVALUATE TRUE
142900         WHEN (MMTCWS-LM-WINDOW-ALLOWED
143000          AND  MMTCWS-LM-VALID-DEBIT
143100          AND  MTPT-SETTLED-WINDOW)
143200             SET X-WS-TT-ITEM    TO 37
143300             PERFORM 9060-ADD-TO-TOTALS
143400                THRU 9060-ATT-EXIT
143500         WHEN (MMTCWS-LM-WINDOW-ALLOWED
143600          AND  MMTCWS-LM-VALID-CREDIT
143700          AND  MTPT-SETTLED-WINDOW)
143800             SET X-WS-TT-ITEM    TO 38
143900             PERFORM 9060-ADD-TO-TOTALS
144000                THRU 9060-ATT-EXIT
144100     END-EVALUATE.
144200*
144300 9050-AT-EXIT.
144400     EXIT.
144500*
144600 9060-ADD-TO-TOTALS.
144700*
144800     ADD MTPT-NBR-ITEMS          TO WS-TT-NBR (1 X-WS-TT-ITEM).
144900     ADD MTPT-AMOUNT             TO WS-TT-AMT (1 X-WS-TT-ITEM).
145000*
145100     ADD MTPT-NBR-ITEMS          TO WS-TT-NBR (2 X-WS-TT-ITEM).
145200     ADD MTPT-AMOUNT             TO WS-TT-AMT (2 X-WS-TT-ITEM).
145300*
145400     ADD MTPT-NBR-ITEMS          TO WS-TT-NBR (3 X-WS-TT-ITEM).
145500     ADD MTPT-AMOUNT             TO WS-TT-AMT (3 X-WS-TT-ITEM).
145600*
145700 9060-ATT-EXIT.
145800     EXIT.
145900/
146000 9070-ZERO-ORG-ACCUMS.
146100*
146200     INITIALIZE WS-TT-LEVEL (1).
146300*
146400 9070-ZOA-EXIT.
146500     EXIT.
146600*
146700 9080-ZERO-MER-ACCUMS.
146800*
146900     INITIALIZE WS-TT-LEVEL (2).
147000*
147100 9080-ZMA-EXIT.
147200     EXIT.
147300*
147400 9090-ZERO-STORE-ACCUMS.
147500*
147600     INITIALIZE WS-TT-LEVEL (3).
147700*
147800 9090-ZSA-EXIT.
147900     EXIT.
148000*
148100 9100-CHECK-NBR-LINES.
148200*
148300     COMPUTE MB20WS-LINES-REMAINING
148400                                 = MB20WS-LINE-LIMIT
148500                                 - MB20WS-LINE-COUNT.
148600*
148700     IF  MB20WS-LINES-REMAINING IS LESS THAN WS-D720-LINE-CHECK
148800         MOVE MB20WS-FORCE-PAGE  TO MB20WS-LINE-COUNT.
148900*
149000 9100-CNL-EXIT.
149100     EXIT.
149200/
149300     COPY MB22PD.
149400/
149500     COPY SS95PD.
149600/
149700     COPY SS02PD.
149800/
149900     COPY SS07PD.
150000/
150100     COPY SS08PD.
150200/
150300     COPY SS16PD.
150400/
150500     COPY SS26PD.
150600/
150700     COPY SS27PD.
150800*
150900 9995-END-SOURCE-STATEMENTS SECTION.
151000 9999-END-OF-PROGRAM.
151100     EXIT.
