000100 IDENTIFICATION DIVISION.
000200 PROGRAM-ID. MBD72021.
000201*       RELEASE DATE=08/24/01.        REVISION LEVEL=08.06      * ++++++++
000202***************************************************************** ++++++++
000203*WARNING.  THIS COMPUTER PROGRAM IS PROTECTED BY COPYRIGHT LAW  * ++++++++
000204*AND INTERNATIONAL TREATIES.  UNAUTHORIZED REPRODUCTION OR      * ++++++++
000205*DISTRIBUTION OF THIS PROGRAM, OR ANY PORTION OF IT, MAY RESULT * ++++++++
000206*IN SEVERE CIVIL AND CRIMINAL PENATLIES, AND WILL BE PROSECUTED * ++++++++
000207*TO THE MAXIMUM EXTENT POSSIBLE UNDER THE LAW.                  * ++++++++
000208*COPYRIGHT 1999 PAYSYS INTERNATIONAL, INC.  ALL RIGHTS RESERVED.* ++++++++
000209***************************************************************** ++++++++
000300*****************************************************************
000400*                                                               *
000500*   V - PLUS  M E R C H A N T   B A N K C A R D   S Y S T E M   *
000600*                                                               *
000700*       MBD72021 - OPTIONAL REPORT 21 SUBROUTINE                *
000800*                                                               *
000900*****************************************************************
001000 ENVIRONMENT DIVISION.
001100 CONFIGURATION SECTION.
001200 SOURCE-COMPUTER.            IBM-4341.
001300 OBJECT-COMPUTER.            IBM-4341.
001400/
001500 DATA DIVISION.
001600 WORKING-STORAGE SECTION.
001700*
001800 01  FILLER                  PIC  X(12)      VALUE '** WS-BEG **'.
001900*
002000 01  WS-MBD72021-WORK-AREAS.
002100     03  WS-D72021-ACTIVITY-SW
002200                             PIC  X(01)      VALUE 'N'.
002300     03  WS-D720-LINE-CHECK  PIC S9(05)      COMP-3 VALUE +3.
002400*
002500     03  WS-D720-ORG-TOTALS.
002600         05  WS-D720-OT-AMT  PIC S9(17)      COMP-3 VALUE ZERO.
002700     03  WS-D720-MERCH-TOTALS.
002800         05  WS-D720-MERCH-TOTAL             OCCURS 4 TIMES
002900                                             INDEXED BY
003000                                             X-WS-D720-MT.
003100             07  WS-D720-MT-ORG
003200                             PIC  9(03)      VALUE ZERO.
003300             07  WS-D720-MT-ACCT
003400                             PIC  X(19)      VALUE SPACES.
003500             07  WS-D720-MT-AMT
003600                             PIC S9(17)      COMP-3 VALUE ZERO.
003700/
003800     COPY MB20WS.
003900 01  WS-PRINT-LINE-01        REDEFINES MB20WS-PRINT-LINE.
004000     03  WS-PL01-MERCHANT    PIC  9(09)-.
004100     03  FILLER              PIC  X(05).
004200     03  WS-PL01-ORG         PIC  9(03)-.
004300     03  WS-PL01-ACCT        PIC  X(20).
004400     03  WS-PL01-WAS-BILLED.
004500         05  WS-PL01-STORE   PIC  9(09)-.
004600         05  WS-PL01-PLAN    PIC  9(05)-.
004700         05  WS-PL01-TC      PIC  9(03)-.
004800     03  WS-PL01-AMT         PIC  X(24).
004900     03  WS-PL01-DESC        PIC  X(15).
005000     03  FILLER              PIC  X(34).
005100 01  WS-PRINT-LINE-02        REDEFINES MB20WS-PRINT-LINE.
005200     03  WS-PL02-LIT-1       PIC  X(35).
005300     03  WS-PL02-MERCHANT    PIC  9(09)BB.
005400     03  WS-PL02-NAME        PIC  X(40).
005500     03  FILLER              PIC  X(46).
005600 01  WS-PRINT-LINE-03        REDEFINES MB20WS-PRINT-LINE.
005700     03  WS-PL03-LIT-1       PIC  X(43).
005800     03  WS-PL03-ORG         PIC  9(03)-.
005900     03  WS-PL03-NAME        PIC  X(40).
006000     03  FILLER              PIC  X(45).
006100/
006200     COPY SS95WS.
006300/
006400     COPY MTRFWS REPLACING ==:MTRF:== BY ==MTRF==.
006500/
006600     COPY MTRFRL REPLACING ==:MTRF:== BY ==MWRF==.
006700/
006800     COPY MTP0RL REPLACING ==:MTP0:== BY ==MTR0==.
006900/
007000     COPY MTP0RL REPLACING ==:MTP0:== BY ==MTR1==.
007100/
007200     COPY MTP0RL REPLACING ==:MTP0:== BY ==MTR2==.
007300/
007400     COPY MTP0RL REPLACING ==:MTP0:== BY ==MTR3==.
007500/
007600     COPY MTP0RL REPLACING ==:MTP0:== BY ==MTR4==.
007700/
007800     COPY MTP0RL REPLACING ==:MTP0:== BY ==MTR5==.
007900/
008000     COPY MTP0RL REPLACING ==:MTP0:== BY ==MTR6==.
008100/
008200     COPY MTP0RL REPLACING ==:MTP0:== BY ==MTR7==.
008300/
008400     COPY MTP0RL REPLACING ==:MTP0:== BY ==MTR8==.
008500/
008600     COPY MTP0RL REPLACING ==:MTP0:== BY ==MTR9==.
008700/
008800     COPY MTSIRL.
008900/
009000     COPY MB00WS.
009100/
009200     COPY SS00WS.
009300/
009400     COPY SS01WS.
009500/
009600     COPY SS02WS.
009700*
009800 01  FILLER                  PIC  X(12)      VALUE '** WS-END **'.
009900/
010000 LINKAGE SECTION.
010100     COPY MB22WS.
010200/
010300     COPY MTRFRL REPLACING ==:MTRF:== BY ==MTRF==.
010400/
010500 PROCEDURE DIVISION              USING MB22WS-LINK-DATA
010600                                       MTRF-RECORD.
010700*
010800 A000-MAIN-LINE-SECT SECTION.
010900 A010-ML-BEGIN.
011000*
011100     IF  MTRF-K1-RT-DETAIL
011200         PERFORM D000-DETAIL-RECORD
011300            THRU D099-DR-EXIT.
011400*
011500     IF  MTRF-K1-RT-HEADER
011600         PERFORM H000-HEADER-RECORD
011700            THRU H099-HR-EXIT.
011800*
011900     IF  MTRF-K1-RT-TRAILER
012000         PERFORM T000-TRAILER-RECORD
012100            THRU T099-TR-EXIT.
012200*
012300     GOBACK.
012400*
012500 A099-ML-EXIT.
012600     EXIT.
012700/
012800 D000-DETAIL-RECORD SECTION.
012900 D010-DR-BEGIN.
013000*
013100     MOVE 'Y'                    TO WS-D72021-ACTIVITY-SW.
013200*
013300     IF  MTRF-K2-O21-MERCHANT IS NOT EQUAL TO MWRF-K2-O17-MERCHANT
013400         MOVE 9                  TO WS-D720-LINE-CHECK
013500         PERFORM 9200-MERCHANT-TOTALS
013600            THRU 9299-MT-EXIT
013700         INITIALIZE                 WS-D720-MERCH-TOTALS.
013800*
013900     MOVE MTRF-RECORD            TO MWRF-RECORD.
014000*
014100     MOVE MTRF-SI-RECORD         TO MTSI-RECORD.
014200*
014300     MOVE MTSI-MERCHANT          TO WS-PL01-MERCHANT.
014400     MOVE MTSI-CMS-ORG           TO WS-PL01-ORG.
014500     MOVE MTSI-CMS-ACCT          TO WS-PL01-ACCT.
014600     MOVE MTSI-CMS-STORE         TO WS-PL01-STORE.
014700     MOVE MTSI-CMS-PLAN          TO WS-PL01-PLAN.
014800     MOVE MTSI-CMS-TC            TO WS-PL01-TC.
014900     MOVE MTSI-AMOUNT            TO SS95WS-IN-AMT.
015000*
015100     IF  MTSI-TC-BILL-DR
015200         COMPUTE SS95WS-IN-AMT   =  0.00 - MTSI-AMOUNT.
015300*
015400     PERFORM SS95PD-NAP-ROUTINE
015500        THRU SS95PD-NAP-EXIT.
015600     MOVE SS95WS-OUT-AMT-L23     TO WS-PL01-AMT.
015700     MOVE MTSI-ACH-DESC          TO WS-PL01-DESC.
015800*
015900     SET X-WS-D720-MT            TO 1.
016000     SEARCH WS-D720-MERCH-TOTAL VARYING X-WS-D720-MT
016100         AT END
016200             SET X-WS-D720-MT    TO 1
016300             SEARCH WS-D720-MERCH-TOTAL VARYING X-WS-D720-MT
016400                 AT END
016500                     SET X-WS-D720-MT
016600                                 TO 4
016700                     MOVE MTSI-CMS-ORG
016800                                 TO WS-D720-MT-ORG (X-WS-D720-MT)
016900                     MOVE MTSI-CMS-ACCT
017000                                 TO WS-D720-MT-ACCT(X-WS-D720-MT)
017100                 WHEN WS-D720-MT-ORG (X-WS-D720-MT)
017200                                 IS EQUAL TO ZERO
017300                     MOVE MTSI-CMS-ORG
017400                                 TO WS-D720-MT-ORG (X-WS-D720-MT)
017500                     MOVE MTSI-CMS-ACCT
017600                                 TO WS-D720-MT-ACCT(X-WS-D720-MT)
017700             END-SEARCH
017800         WHEN WS-D720-MT-ORG (X-WS-D720-MT)
017900                                 IS EQUAL TO MTSI-CMS-ORG
018000          AND WS-D720-MT-ACCT (X-WS-D720-MT)
018100                                 IS EQUAL TO MTSI-CMS-ACCT
018200              NEXT SENTENCE
018300     END-SEARCH.
018400*
018500     IF  MTSI-TC-BILL-DR
018600         SUBTRACT MTSI-AMOUNT  FROM WS-D720-MT-AMT (X-WS-D720-MT)
018700         SUBTRACT MTSI-AMOUNT  FROM WS-D720-OT-AMT.
018800*
018900     IF  MTSI-TC-BILL-CR
019000         ADD  MTSI-AMOUNT        TO WS-D720-MT-AMT (X-WS-D720-MT)
019100         ADD  MTSI-AMOUNT        TO WS-D720-OT-AMT.
019200*
019300     EVALUATE TRUE
019400         WHEN MTRF-K1-DETAIL
019500             PERFORM MB22PD-PRINT-1-LINE
019600                THRU MB22PD-P1L-EXIT
019700         WHEN OTHER
019800             MOVE SPACES         TO MB20WS-PRINT-LINE
019900     END-EVALUATE.
020000*
020100 D099-DR-EXIT.
020200     EXIT.
020300/
020400 H000-HEADER-RECORD SECTION.
020500 H010-HR-BEGIN.
020600*
020700     MOVE MTRF-K1-FORM           TO MB20WS-FORM-CODE.
020800     MOVE MTRF-HD-DATE-FORMAT    TO SS01WS-DATE-FORMAT.
020900     MOVE MTRF-HD-FICHE-FLAG     TO MB20WS-FICHE-CODE.
021000     MOVE MTRF-HD-SYSTEM-NAME    TO MB20WS-SH-SYSTEM.
021100     MOVE MTRF-HD-REPORT-ID      TO MB20WS-SH-RPT-ID.
021200     MOVE 'O21'                  TO MB20WS-SH-INTERNAL-RPT-ID.
021300     MOVE MTRF-K1-ORG            TO MB20WS-SH-ORG.
021400     MOVE MTRF-HD-ORG-NAME       TO MB20WS-SH-ORG-NAME.
021500     MOVE MTRF-HD-RPT-TITLE      TO MB20WS-SH-RPT-NAME.
021600     MOVE MTRF-HD-FILE-DATE      TO SS01WS-JULIAN.
021700     PERFORM SS26PD-NUMERICALLY-EDIT-DATE
021800        THRU SS26PD-NED-EXIT.
021900     MOVE SS01WS-XX-XX-YYYY      TO MB20WS-SH-FILE-DATE.
022000     MOVE MTRF-HD-REPORT-DEST-ID TO MB20WS-SH-DEST-ID.
022100     MOVE MTRF-HD-DEST-DESC      TO MB20WS-SH-DEST-DESC.
022200*
022300     MOVE ' MERCHANT      *---------------- CMS DATA --'
022400                                 TO MB20WS-SH-L5R-1.
022500     MOVE '--------------**-------------- MBS DATA ----'
022600                                 TO MB20WS-SH-L5R-2.
022700     MOVE '---------*                                  '
022800                                 TO MB20WS-SH-L5R-3.
022900*
023000     MOVE '  NUMBER       ORG --ACCOUNT  NUMBER--   STO'
023100                                 TO MB20WS-SH-L6R-1.
023200     MOVE 'RE    PLAN T/C                 AMOUNT  --DES'
023300                                 TO MB20WS-SH-L6R-2.
023400     MOVE 'CRIPTION--                                  '
023500                                 TO MB20WS-SH-L6R-3.
023600*
023700     MOVE ZERO                   TO MB20WS-PAGE-COUNT.
023800     MOVE MB20WS-FORCE-PAGE      TO MB20WS-LINE-COUNT.
023900     MOVE MTRF-HD-LINES-PER-PAGE TO MB20WS-LINES-PER-PAGE.
024000     MOVE MTRF-HD-CURRENCY-NOD   TO MTRFWS-SAVE-CURRENCY-NOD.
024100     MOVE MTRF-HD-PER-ITEM-NOD   TO MTRFWS-SAVE-PER-ITEM-NOD.
024200     MOVE MTRF-HD-PERCENT-NOD    TO MTRFWS-SAVE-PERCENT-NOD.
024300     SET SS95WS-FUNCTION-INITIALIZE
024400                                 TO TRUE.
024500     PERFORM SS95PD-NAP-ROUTINE
024600        THRU SS95PD-NAP-EXIT.
024700*
024800     MOVE MTRF-HD-CURRENCY-CODE  TO SS95WS-CURRENCY-CODE.
024900     MOVE 'N'                    TO WS-D72021-ACTIVITY-SW.
025000     MOVE MTRF-RECORD            TO MTR9-RECORD.
025100     INITIALIZE                     WS-D720-MERCH-TOTALS.
025200     INITIALIZE                     WS-D720-ORG-TOTALS.
025300     MOVE ZERO                   TO MWRF-K2-O21-MERCHANT.
025400*
025500*
025600 H099-HR-EXIT.
025700     EXIT.
025800/
025900 T000-TRAILER-RECORD SECTION.
026000 T010-TR-BEGIN.
026100     MOVE MTR9-RECORD            TO MTRF-RECORD.
026200*
026300     IF  WS-D72021-ACTIVITY-SW IS EQUAL TO 'N'
026400         IF  MTRF-HD-AF-PRODUCE
026500             PERFORM MB22PD-PRINT-NO-ACTIVITY
026600                                 THRU MB22PD-PNA-EXIT
026700             GO TO T099-TR-EXIT
026800         ELSE
026900             GO TO T099-TR-EXIT.
027000*
027100     MOVE 9                      TO WS-D720-LINE-CHECK.
027200     PERFORM 9100-CHECK-NBR-LINES
027300        THRU 9100-CNL-EXIT.
027400     PERFORM 9200-MERCHANT-TOTALS
027500        THRU 9299-MT-EXIT
027600     MOVE 3                      TO WS-D720-LINE-CHECK.
027700     PERFORM 9100-CHECK-NBR-LINES
027800        THRU 9100-CNL-EXIT.
027900     PERFORM 9300-PRINT-ORG-TOTALS
028000        THRU 9399-POT-EXIT.
028100*
028200 T099-TR-EXIT.
028300     EXIT.
028400/
028500 9000-PERFORMED-ROUTINES-SECT SECTION.
028600*
028700 9100-CHECK-NBR-LINES.
028800*
028900     COMPUTE MB20WS-LINES-REMAINING
029000                                 = MB20WS-LINE-LIMIT
029100                                 - MB20WS-LINE-COUNT.
029200*
029300     IF  MB20WS-LINES-REMAINING IS LESS THAN WS-D720-LINE-CHECK
029400         MOVE MB20WS-FORCE-PAGE  TO MB20WS-LINE-COUNT.
029500*
029600 9100-CNL-EXIT.
029700     EXIT.
029800/
029900 9200-MERCHANT-TOTALS.
030000*
030100     IF  MWRF-K2-O21-MERCHANT IS EQUAL TO ZERO
030200         GO TO 9299-MT-EXIT.
030300*
030400     EVALUATE TRUE
030500         WHEN MTRF-K1-DETAIL
030600             PERFORM MB22PD-PRINT-1-LINE
030700                THRU MB22PD-P1L-EXIT
030800         WHEN OTHER
030900             MOVE SPACES         TO MB20WS-PRINT-LINE
031000     END-EVALUATE.
031100*
031200     MOVE '***MERCHANT TOTALS*** FOR MERCHANT'
031300                                 TO WS-PL02-LIT-1.
031400     MOVE MWRF-K2-O21-MERCHANT   TO WS-PL02-MERCHANT.
031500     MOVE MWRF-NAME              TO WS-PL02-NAME.
031600*
031700     EVALUATE TRUE
031800         WHEN MTRF-K1-DETAIL
031900             PERFORM MB22PD-PRINT-1-LINE
032000                THRU MB22PD-P1L-EXIT
032100         WHEN OTHER
032200             MOVE SPACES         TO MB20WS-PRINT-LINE
032300     END-EVALUATE.
032400*
032500     PERFORM
032600         VARYING X-WS-D720-MT FROM 1 BY 1
032700         UNTIL   X-WS-D720-MT IS GREATER THAN 4
032800         IF  WS-D720-MT-ORG  (X-WS-D720-MT) IS EQUAL TO ZERO
032900         AND WS-D720-MT-ACCT (X-WS-D720-MT) IS EQUAL TO SPACES
033000         AND WS-D720-MT-AMT  (X-WS-D720-MT) IS EQUAL TO ZERO
033100             CONTINUE
033200         ELSE
033300             MOVE '   CMS ACCOUNT'
033400                                 TO MB20WS-PRINT-LINE
033500             MOVE WS-D720-MT-ORG (X-WS-D720-MT)
033600                                 TO WS-PL01-ORG
033700             MOVE WS-D720-MT-ACCT (X-WS-D720-MT)
033800                                 TO WS-PL01-ACCT
033900             MOVE 'WAS INVOICED:'
034000                                 TO WS-PL01-WAS-BILLED
034100             MOVE WS-D720-MT-AMT (X-WS-D720-MT)
034200                                 TO SS95WS-IN-AMT
034300             PERFORM SS95PD-NAP-ROUTINE
034400                THRU SS95PD-NAP-EXIT
034500             MOVE SS95WS-OUT-AMT-L23
034600                                 TO WS-PL01-AMT
034700             EVALUATE TRUE
034800                 WHEN MTRF-K1-DETAIL
034900                     PERFORM MB22PD-PRINT-1-LINE
035000                        THRU MB22PD-P1L-EXIT
035100                 WHEN OTHER
035200                     MOVE SPACES TO MB20WS-PRINT-LINE
035300             END-EVALUATE
035400         END-IF
035500     END-PERFORM.
035600*
035700     MOVE '   TOTAL INVOICED TO MERCHANT:'
035800                                 TO MB20WS-PRINT-LINE.
035900*
036000     COMPUTE SS95WS-IN-AMT       =  WS-D720-MT-AMT (1)
036100                                 +  WS-D720-MT-AMT (2)
036200                                 +  WS-D720-MT-AMT (3)
036300                                 +  WS-D720-MT-AMT (4).
036400     PERFORM SS95PD-NAP-ROUTINE
036500        THRU SS95PD-NAP-EXIT.
036600     MOVE SS95WS-OUT-AMT-L23     TO WS-PL01-AMT.
036700*
036800     EVALUATE TRUE
036900         WHEN MTRF-K1-DETAIL
037000             PERFORM MB22PD-PRINT-2-LINES
037100                THRU MB22PD-P2L-EXIT
037200         WHEN OTHER
037300             MOVE SPACES         TO MB20WS-PRINT-LINE
037400     END-EVALUATE.
037500*
037600 9299-MT-EXIT.
037700     EXIT.
037800/
037900 9300-PRINT-ORG-TOTALS.
038000*
038100     MOVE '***ORGANIZATION TOTALS*** FOR ORGANIZATION'
038200                                 TO WS-PL03-LIT-1.
038300     MOVE MTRF-K1-ORG            TO WS-PL03-ORG.
038400     MOVE MTRF-HD-ORG-NAME       TO WS-PL03-NAME.
038500     PERFORM MB22PD-PRINT-2-LINES
038600        THRU MB22PD-P2L-EXIT.
038700*
038800     MOVE WS-D720-OT-AMT         TO SS95WS-IN-AMT.
038900     PERFORM SS95PD-NAP-ROUTINE
039000        THRU SS95PD-NAP-EXIT.
039100     MOVE SS95WS-OUT-AMT-L23     TO WS-PL01-AMT.
039200     PERFORM MB22PD-PRINT-1-LINE
039300        THRU MB22PD-P1L-EXIT.
039400*
039500 9399-POT-EXIT.
039600     EXIT.
039700/
039800     COPY MB22PD.
039900/
040000     COPY SS95PD.
040100/
040200     COPY SS02PD.
040300/
040400     COPY SS07PD.
040500/
040600     COPY SS08PD.
040700/
040800     COPY SS16PD.
040900/
041000     COPY SS26PD.
041100/
041200     COPY SS27PD.
041300*
041400 9995-END-SOURCE-STATEMENTS SECTION.
041500 9999-END-OF-PROGRAM.
041600     EXIT.
