000100 IDENTIFICATION DIVISION.
000200 PROGRAM-ID. MBD72048.
000201*       RELEASE DATE=08/24/01.        REVISION LEVEL=08.06      * ++++++++
000202***************************************************************** ++++++++
000203*WARNING.  THIS COMPUTER PROGRAM IS PROTECTED BY COPYRIGHT LAW  * ++++++++
000204*AND INTERNATIONAL TREATIES.  UNAUTHORIZED REPRODUCTION OR      * ++++++++
000205*DISTRIBUTION OF THIS PROGRAM, OR ANY PORTION OF IT, MAY RESULT * ++++++++
000206*IN SEVERE CIVIL AND CRIMINAL PENATLIES, AND WILL BE PROSECUTED * ++++++++
000207*TO THE MAXIMUM EXTENT POSSIBLE UNDER THE LAW.                  * ++++++++
000208*COPYRIGHT 1999 PAYSYS INTERNATIONAL, INC.  ALL RIGHTS RESERVED.* ++++++++
000209***************************************************************** ++++++++
000300*****************************************************************
000400*                                                               *
000500*       MBD72048 - OPTIONAL REPORT 48 SUBROUTINE                *
000600*                                                               *
000700*****************************************************************
000800 ENVIRONMENT DIVISION.
000900 CONFIGURATION SECTION.
001000 SOURCE-COMPUTER.            IBM-4341.
001100 OBJECT-COMPUTER.            IBM-4341.
001200/
001300 DATA DIVISION.
001400 WORKING-STORAGE SECTION.
001500*
001600 01  FILLER                  PIC  X(12)      VALUE '** WS-BEG **'.
001700*
001800 01  WS-MBD72048-WORK-AREAS.
001900     03  WS-D72048-ACTIVITY-SW
002000                             PIC  X(01)      VALUE 'N'.
002100*
002200     COPY MB20WS.
002300 01  WS-PRINT-LINE-1         REDEFINES MB20WS-PRINT-LINE.
002400     03  FILLER              PIC  X(09).
002500     03  WS-PL1-DATA.
002600         05  WS-PL1-TITLE                    OCCURS 2 TIMES
002700                                             INDEXED BY
002800                                             X-WS-PL1.
002900             07  WS-PL1-LIT  PIC  X(33).
003000             07  WS-PL1-AMT  PIC  X(23).
003100             07  FILLER      PIC  X(01).
003200     03  FILLER              PIC  X(09).
003300*
003400 01  WS-PRINT-LINE-2         REDEFINES MB20WS-PRINT-LINE.
003500     03  FILLER              PIC  X(09).
003600     03  WS-PL2-LIT          PIC  X(09).
003700     03  WS-PL2-MERCHANT     PIC  9(09)-.
003800     03  WS-PL2-NAME         PIC  X(41).
003900     03  WS-PL2-STATUS-LIT   PIC  X(07).
004000     03  WS-PL2-REC-STATUS   PIC  X(01).
004100     03  FILLER              PIC  X(01).
004200     03  WS-PL2-CLOSE-LIT    PIC  X(13).
004300     03  WS-PL2-CLOSE-REASON PIC  X(02).
004400     03  FILLER              PIC  X(39).
004500/
004600     COPY MTRFWS REPLACING ==:MTRF:== BY ==MTRF==.
004700/
004800     COPY MTRFRL REPLACING ==:MTRF:== BY ==MWRF==.
004900/
005000     COPY MTP0RL REPLACING ==:MTP0:== BY ==MTR0==.
005100/
005200     COPY MTP0RL REPLACING ==:MTP0:== BY ==MTR1==.
005300/
005400     COPY MTP0RL REPLACING ==:MTP0:== BY ==MTR2==.
005500/
005600     COPY MTP0RL REPLACING ==:MTP0:== BY ==MTR3==.
005700/
005800     COPY MTP0RL REPLACING ==:MTP0:== BY ==MTR4==.
005900/
006000     COPY MTP0RL REPLACING ==:MTP0:== BY ==MTR5==.
006100/
006200     COPY MTP0RL REPLACING ==:MTP0:== BY ==MTR6==.
006300/
006400     COPY MTP0RL REPLACING ==:MTP0:== BY ==MTR7==.
006500/
006600     COPY MTP0RL REPLACING ==:MTP0:== BY ==MTR8==.
006700/
006800     COPY MTP0RL REPLACING ==:MTP0:== BY ==MTR9==.
006900/
007000     COPY MB00WS.
007100/
007200     COPY SS95WS.
007300/
007400     COPY SS00WS.
007500/
007600     COPY SS01WS.
007700/
007800     COPY SS02WS.
007900*
008000 01  FILLER                  PIC  X(12)      VALUE '** WS-END **'.
008100/
008200 LINKAGE SECTION.
008300     COPY MB22WS.
008400/
008500     COPY MTRFRL REPLACING ==:MTRF:== BY ==MTRF==.
008600/
008700 PROCEDURE DIVISION              USING MB22WS-LINK-DATA
008800                                       MTRF-RECORD.
008900*
009000 A000-MAIN-LINE-SECT SECTION.
009100 A010-ML-BEGIN.
009200*
009300     IF  MTRF-K1-RT-DETAIL
009400         PERFORM D000-DETAIL-RECORD
009500            THRU D099-DR-EXIT.
009600*
009700     IF  MTRF-K1-RT-HEADER
009800         PERFORM H000-HEADER-RECORD
009900            THRU H099-HR-EXIT.
010000*
010100     IF  MTRF-K1-RT-TRAILER
010200         PERFORM T000-TRAILER-RECORD
010300            THRU T099-TR-EXIT.
010400*
010500     GOBACK.
010600*
010700 A099-ML-EXIT.
010800     EXIT.
010900/
011000 D000-DETAIL-RECORD SECTION.
011100 D010-DR-BEGIN.
011200*
011300     MOVE 'Y'                    TO WS-D72048-ACTIVITY-SW.
011400     MOVE MB20WS-FORCE-PAGE      TO MB20WS-LINE-COUNT.
011500*
011600     MOVE 'MERCHANT'             TO WS-PL2-LIT.
011700     MOVE MTRF-K2-O48-MERCHANT   TO WS-PL2-MERCHANT.
011800     MOVE MTRF-NAME              TO WS-PL2-NAME.
011900     MOVE 'STATUS='              TO WS-PL2-STATUS-LIT.
012000     MOVE MTRF-REC-STATUS        TO WS-PL2-REC-STATUS.
012100     MOVE 'CLOSE-REASON='        TO WS-PL2-CLOSE-LIT.
012200     MOVE MTRF-CLOSE-REASON      TO WS-PL2-CLOSE-REASON.
012300     PERFORM MB22PD-PRINT-3-LINES
012400        THRU MB22PD-P3L-EXIT.
012500*
012600 D020-DR-SETT.
012700*
012800     MOVE
012900     '****************** SETTLEMENT ACTIVITY *****************'
013000                                 TO WS-PL1-TITLE (1).
013100     PERFORM MB22PD-PRINT-2-LINES
013200        THRU MB22PD-P2L-EXIT.
013300*
013400*
013500*
013600     MOVE 'BEGINNING SETTLEMENT BALANCE'
013700                                 TO WS-PL1-LIT (1).
013800     MOVE MTRF-O48-BEG-BAL-SETT
013900                                 TO SS95WS-IN-AMT.
014000     PERFORM SS95PD-NAP-ROUTINE
014100        THRU SS95PD-NAP-EXIT.
014200     MOVE SS95WS-OUT-AMT-L23     TO WS-PL1-AMT (1).
014300     PERFORM MB22PD-PRINT-1-LINE
014400        THRU MB22PD-P1L-EXIT.
014500*
014600*
014700*
014800     MOVE 'AMOUNT IN SETTLEMENT TODAY'
014900                                 TO WS-PL1-LIT (1).
015000     MOVE MTRF-O48-SETT-IN
015100                                 TO SS95WS-IN-AMT.
015200     PERFORM SS95PD-NAP-ROUTINE
015300        THRU SS95PD-NAP-EXIT.
015400     MOVE SS95WS-OUT-AMT-L23     TO WS-PL1-AMT (1).
015500     PERFORM MB22PD-PRINT-1-LINE
015600        THRU MB22PD-P1L-EXIT.
015700*
015800*
015900*
016000     MOVE 'AMOUNT OUT OF SETTLEMENT TODAY'
016100                                 TO WS-PL1-LIT (1).
016200     MOVE MTRF-O48-SETT-OUT
016300                                 TO SS95WS-IN-AMT.
016400     PERFORM SS95PD-NAP-ROUTINE
016500        THRU SS95PD-NAP-EXIT.
016600     MOVE SS95WS-OUT-AMT-L23     TO WS-PL1-AMT (1).
016700     PERFORM MB22PD-PRINT-1-LINE
016800        THRU MB22PD-P1L-EXIT.
016900*
017000*
017100*
017200     MOVE 'ENDING SETTLEMENT BALANCE'
017300                                 TO WS-PL1-LIT (1).
017400     MOVE MTRF-O48-END-BAL-SETT
017500                                 TO SS95WS-IN-AMT.
017600     PERFORM SS95PD-NAP-ROUTINE
017700        THRU SS95PD-NAP-EXIT.
017800     MOVE SS95WS-OUT-AMT-L23     TO WS-PL1-AMT (1).
017900     PERFORM MB22PD-PRINT-1-LINE
018000        THRU MB22PD-P1L-EXIT.
018100*
018200*
018300*
018400     PERFORM MB22PD-PRINT-2-LINES
018500        THRU MB22PD-P2L-EXIT.
018600*
018700 D030-DR-RESV-1-RESV-2.
018800*
018900     MOVE
019000     '************** RESERVE ACCOUNT 1 ACTIVITY **************'
019100                                 TO WS-PL1-TITLE (1).
019200     MOVE
019300     '************** RESERVE ACCOUNT 2 ACTIVITY **************'
019400                                 TO WS-PL1-TITLE (2).
019500     PERFORM MB22PD-PRINT-2-LINES
019600        THRU MB22PD-P2L-EXIT.
019700*
019800*
019900*
020000     MOVE 'BEGINNING RESERVE 1 BALANCE'
020100                                 TO WS-PL1-LIT (1).
020200     MOVE MTRF-O48-BEG-BAL-RESV-1
020300                                 TO SS95WS-IN-AMT.
020400     PERFORM SS95PD-NAP-ROUTINE
020500        THRU SS95PD-NAP-EXIT.
020600     MOVE SS95WS-OUT-AMT-L23     TO WS-PL1-AMT (1).
020700     MOVE 'BEGINNING RESERVE 2 BALANCE'
020800                                 TO WS-PL1-LIT (2).
020900     MOVE MTRF-O48-BEG-BAL-RESV-2
021000                                 TO SS95WS-IN-AMT.
021100     PERFORM SS95PD-NAP-ROUTINE
021200        THRU SS95PD-NAP-EXIT.
021300     MOVE SS95WS-OUT-AMT-L23     TO WS-PL1-AMT (2).
021400     PERFORM MB22PD-PRINT-1-LINE
021500        THRU MB22PD-P1L-EXIT.
021600*
021700*
021800*
021900     MOVE 'AMOUNT FUNDED TODAY'
022000                                 TO WS-PL1-LIT (1).
022100     MOVE MTRF-O48-RESV-1-FUNDING-IN
022200                                 TO SS95WS-IN-AMT.
022300     PERFORM SS95PD-NAP-ROUTINE
022400        THRU SS95PD-NAP-EXIT.
022500     MOVE SS95WS-OUT-AMT-L23     TO WS-PL1-AMT (1).
022600     MOVE 'AMOUNT FUNDED TODAY'
022700                                 TO WS-PL1-LIT (2).
022800     MOVE MTRF-O48-RESV-2-FUNDING-IN
022900                                 TO SS95WS-IN-AMT.
023000     PERFORM SS95PD-NAP-ROUTINE
023100        THRU SS95PD-NAP-EXIT.
023200     MOVE SS95WS-OUT-AMT-L23     TO WS-PL1-AMT (2).
023300     PERFORM MB22PD-PRINT-1-LINE
023400        THRU MB22PD-P1L-EXIT.
023500*
023600*
023700*
023800     MOVE 'AMOUNT TO SETTLEMENT TODAY'
023900                                 TO WS-PL1-LIT (1).
024000     MOVE MTRF-O48-RESV-1-TO-SETT-OUT
024100                                 TO SS95WS-IN-AMT.
024200     PERFORM SS95PD-NAP-ROUTINE
024300        THRU SS95PD-NAP-EXIT.
024400     MOVE SS95WS-OUT-AMT-L23     TO WS-PL1-AMT (1).
024500     MOVE 'AMOUNT TO SETTLEMENT TODAY'
024600                                 TO WS-PL1-LIT (2).
024700     MOVE MTRF-O48-RESV-2-TO-SETT-OUT
024800                                 TO SS95WS-IN-AMT.
024900     PERFORM SS95PD-NAP-ROUTINE
025000        THRU SS95PD-NAP-EXIT.
025100     MOVE SS95WS-OUT-AMT-L23     TO WS-PL1-AMT (2).
025200     PERFORM MB22PD-PRINT-1-LINE
025300        THRU MB22PD-P1L-EXIT.
025400*
025500*
025600*
025700     MOVE 'AMOUNT TO PROCESSOR TODAY'
025800                                 TO WS-PL1-LIT (1).
025900     MOVE MTRF-O48-RESV-1-TO-PROC-OUT
026000                                 TO SS95WS-IN-AMT.
026100     PERFORM SS95PD-NAP-ROUTINE
026200        THRU SS95PD-NAP-EXIT.
026300     MOVE SS95WS-OUT-AMT-L23     TO WS-PL1-AMT (1).
026400     MOVE 'AMOUNT TO PROCESSOR TODAY'
026500                                 TO WS-PL1-LIT (2).
026600     MOVE MTRF-O48-RESV-2-TO-PROC-OUT
026700                                 TO SS95WS-IN-AMT.
026800     PERFORM SS95PD-NAP-ROUTINE
026900        THRU SS95PD-NAP-EXIT.
027000     MOVE SS95WS-OUT-AMT-L23     TO WS-PL1-AMT (2).
027100     PERFORM MB22PD-PRINT-1-LINE
027200        THRU MB22PD-P1L-EXIT.
027300*
027400*
027500*
027600     MOVE 'ENDING RESERVE 1 BALANCE'
027700                                 TO WS-PL1-LIT (1).
027800     MOVE MTRF-O48-END-BAL-RESV-1
027900                                 TO SS95WS-IN-AMT.
028000     PERFORM SS95PD-NAP-ROUTINE
028100        THRU SS95PD-NAP-EXIT.
028200     MOVE SS95WS-OUT-AMT-L23     TO WS-PL1-AMT (1).
028300     MOVE 'ENDING RESERVE 2 BALANCE'
028400                                 TO WS-PL1-LIT (2).
028500     MOVE MTRF-O48-END-BAL-RESV-2
028600                                 TO SS95WS-IN-AMT.
028700     PERFORM SS95PD-NAP-ROUTINE
028800        THRU SS95PD-NAP-EXIT.
028900     MOVE SS95WS-OUT-AMT-L23     TO WS-PL1-AMT (2).
029000     PERFORM MB22PD-PRINT-3-LINES
029100        THRU MB22PD-P3L-EXIT.
029200*
029300 D040-DR-RESV-3-RESV-4.
029400*
029500     MOVE
029600     '************** RESERVE ACCOUNT 3 ACTIVITY **************'
029700                                 TO WS-PL1-TITLE (1).
029800     MOVE
029900     '************** RESERVE ACCOUNT 4 ACTIVITY **************'
030000                                 TO WS-PL1-TITLE (2).
030100     PERFORM MB22PD-PRINT-2-LINES
030200        THRU MB22PD-P2L-EXIT.
030300*
030400*
030500*
030600     MOVE 'BEGINNING RESERVE 3 BALANCE'
030700                                 TO WS-PL1-LIT (1).
030800     MOVE MTRF-O48-BEG-BAL-RESV-3
030900                                 TO SS95WS-IN-AMT.
031000     PERFORM SS95PD-NAP-ROUTINE
031100        THRU SS95PD-NAP-EXIT.
031200     MOVE SS95WS-OUT-AMT-L23     TO WS-PL1-AMT (1).
031300     MOVE 'BEGINNING RESERVE 4 BALANCE'
031400                                 TO WS-PL1-LIT (2).
031500     MOVE MTRF-O48-BEG-BAL-RESV-4
031600                                 TO SS95WS-IN-AMT.
031700     PERFORM SS95PD-NAP-ROUTINE
031800        THRU SS95PD-NAP-EXIT.
031900     MOVE SS95WS-OUT-AMT-L23     TO WS-PL1-AMT (2).
032000     PERFORM MB22PD-PRINT-1-LINE
032100        THRU MB22PD-P1L-EXIT.
032200*
032300*
032400*
032500     MOVE 'AMOUNT FUNDED TODAY'  TO WS-PL1-LIT (1).
032600     MOVE MTRF-O48-RESV-3-FUNDING-IN
032700                                 TO SS95WS-IN-AMT.
032800     PERFORM SS95PD-NAP-ROUTINE
032900        THRU SS95PD-NAP-EXIT.
033000     MOVE SS95WS-OUT-AMT-L23     TO WS-PL1-AMT (1).
033100     MOVE 'AMOUNT FUNDED TODAY'  TO WS-PL1-LIT (2).
033200     MOVE MTRF-O48-RESV-4-FUNDING-IN
033300                                 TO SS95WS-IN-AMT.
033400     PERFORM SS95PD-NAP-ROUTINE
033500        THRU SS95PD-NAP-EXIT.
033600     MOVE SS95WS-OUT-AMT-L23     TO WS-PL1-AMT (2).
033700     PERFORM MB22PD-PRINT-1-LINE
033800        THRU MB22PD-P1L-EXIT.
033900*
034000*
034100*
034200     MOVE 'AMOUNT TO SETTLEMENT TODAY'
034300                                 TO WS-PL1-LIT (1).
034400     MOVE MTRF-O48-RESV-3-TO-SETT-OUT
034500                                 TO SS95WS-IN-AMT.
034600     PERFORM SS95PD-NAP-ROUTINE
034700        THRU SS95PD-NAP-EXIT.
034800     MOVE SS95WS-OUT-AMT-L23     TO WS-PL1-AMT (1).
034900     MOVE 'AMOUNT TO SETTLEMENT TODAY'
035000                                 TO WS-PL1-LIT (2).
035100     MOVE MTRF-O48-RESV-4-TO-SETT-OUT
035200                                 TO SS95WS-IN-AMT.
035300     PERFORM SS95PD-NAP-ROUTINE
035400        THRU SS95PD-NAP-EXIT.
035500     MOVE SS95WS-OUT-AMT-L23     TO WS-PL1-AMT (2).
035600     PERFORM MB22PD-PRINT-1-LINE
035700        THRU MB22PD-P1L-EXIT.
035800*
035900*
036000*
036100     MOVE 'AMOUNT TO PROCESSOR TODAY'
036200                                 TO WS-PL1-LIT (1).
036300     MOVE MTRF-O48-RESV-3-TO-PROC-OUT
036400                                 TO SS95WS-IN-AMT.
036500     PERFORM SS95PD-NAP-ROUTINE
036600        THRU SS95PD-NAP-EXIT.
036700     MOVE SS95WS-OUT-AMT-L23     TO WS-PL1-AMT (1).
036800     MOVE 'AMOUNT TO PROCESSOR TODAY'
036900                                 TO WS-PL1-LIT (2).
037000     MOVE MTRF-O48-RESV-4-TO-PROC-OUT
037100                                 TO SS95WS-IN-AMT.
037200     PERFORM SS95PD-NAP-ROUTINE
037300        THRU SS95PD-NAP-EXIT.
037400     MOVE SS95WS-OUT-AMT-L23     TO WS-PL1-AMT (2).
037500     PERFORM MB22PD-PRINT-1-LINE
037600        THRU MB22PD-P1L-EXIT.
037700*
037800*
037900*
038000     MOVE 'ENDING RESERVE 3 BALANCE'
038100                                 TO WS-PL1-LIT (1).
038200     MOVE MTRF-O48-END-BAL-RESV-3
038300                                 TO SS95WS-IN-AMT.
038400     PERFORM SS95PD-NAP-ROUTINE
038500        THRU SS95PD-NAP-EXIT.
038600     MOVE SS95WS-OUT-AMT-L23     TO WS-PL1-AMT (1).
038700     MOVE 'ENDING RESERVE 4 BALANCE'
038800                                 TO WS-PL1-LIT (2).
038900     MOVE MTRF-O48-END-BAL-RESV-4
039000                                 TO SS95WS-IN-AMT.
039100     PERFORM SS95PD-NAP-ROUTINE
039200        THRU SS95PD-NAP-EXIT.
039300     MOVE SS95WS-OUT-AMT-L23     TO WS-PL1-AMT (2).
039400     PERFORM MB22PD-PRINT-3-LINES
039500        THRU MB22PD-P3L-EXIT.
039600*
039700 D099-DR-EXIT.
039800     EXIT.
039900/
040000 H000-HEADER-RECORD SECTION.
040100 H010-HR-BEGIN.
040200*
040300     MOVE MTRF-K1-FORM           TO MB20WS-FORM-CODE.
040400     MOVE MTRF-HD-DATE-FORMAT    TO SS01WS-DATE-FORMAT.
040500     MOVE MTRF-HD-FICHE-FLAG     TO MB20WS-FICHE-CODE.
040600     MOVE MTRF-HD-SYSTEM-NAME    TO MB20WS-SH-SYSTEM.
040700     MOVE MTRF-HD-REPORT-ID      TO MB20WS-SH-RPT-ID.
040800     MOVE 'O48'                  TO MB20WS-SH-INTERNAL-RPT-ID.
040900     MOVE MTRF-K1-ORG            TO MB20WS-SH-ORG.
041000     MOVE MTRF-HD-ORG-NAME       TO MB20WS-SH-ORG-NAME.
041100     MOVE MTRF-HD-RPT-TITLE      TO MB20WS-SH-RPT-NAME.
041200     MOVE MTRF-HD-FILE-DATE      TO SS01WS-JULIAN.
041300     PERFORM SS26PD-NUMERICALLY-EDIT-DATE
041400        THRU SS26PD-NED-EXIT.
041500     MOVE SS01WS-XX-XX-YYYY      TO MB20WS-SH-FILE-DATE.
041600     MOVE MTRF-HD-REPORT-DEST-ID TO MB20WS-SH-DEST-ID.
041700     MOVE MTRF-HD-DEST-DESC      TO MB20WS-SH-DEST-DESC.
041800*
041900     MOVE '                                            '
042000                                 TO MB20WS-SH-L5R-1.
042100     MOVE '                                            '
042200                                 TO MB20WS-SH-L5R-2.
042300     MOVE '                                            '
042400                                 TO MB20WS-SH-L5R-3.
042500*
042600     MOVE '                                            '
042700                                 TO MB20WS-SH-L6R-1.
042800     MOVE '                                            '
042900                                 TO MB20WS-SH-L6R-2.
043000     MOVE '                                            '
043100                                 TO MB20WS-SH-L6R-3.
043200*
043300     MOVE ZERO                   TO MB20WS-PAGE-COUNT.
043400     MOVE MB20WS-FORCE-PAGE      TO MB20WS-LINE-COUNT.
043500     MOVE MTRF-HD-LINES-PER-PAGE TO MB20WS-LINES-PER-PAGE.
043600     MOVE MTRF-HD-CURRENCY-NOD   TO MTRFWS-SAVE-CURRENCY-NOD.
043700     MOVE MTRF-HD-PER-ITEM-NOD   TO MTRFWS-SAVE-PER-ITEM-NOD.
043800     MOVE MTRF-HD-PERCENT-NOD    TO MTRFWS-SAVE-PERCENT-NOD.
043900     SET SS95WS-FUNCTION-INITIALIZE
044000                                 TO TRUE.
044100     PERFORM SS95PD-NAP-ROUTINE
044200        THRU SS95PD-NAP-EXIT.
044300*
044400     MOVE MTRF-HD-CURRENCY-CODE  TO SS95WS-CURRENCY-CODE.
044500     MOVE 'N'                    TO WS-D72048-ACTIVITY-SW.
044600     MOVE MTRF-RECORD            TO MTR9-RECORD.
044700*
044800 H099-HR-EXIT.
044900     EXIT.
045000/
045100 T000-TRAILER-RECORD SECTION.
045200 T010-TR-BEGIN.
045300     MOVE MTR9-RECORD            TO MTRF-RECORD.
045400*
045500     IF  WS-D72048-ACTIVITY-SW IS EQUAL TO 'N'
045600         IF  MTRF-HD-AF-PRODUCE
045700             PERFORM MB22PD-PRINT-NO-ACTIVITY
045800                                 THRU MB22PD-PNA-EXIT
045900             GO TO T099-TR-EXIT
046000         ELSE
046100             GO TO T099-TR-EXIT.
046200*
046300 T099-TR-EXIT.
046400     EXIT.
046500/
046600 9000-PERFORMED-ROUTINES-SECT SECTION.
046700     COPY MB22PD.
046800/
046900     COPY SS95PD.
047000/
047100     COPY SS02PD.
047200/
047300     COPY SS07PD.
047400/
047500     COPY SS08PD.
047600/
047700     COPY SS16PD.
047800/
047900     COPY SS26PD.
048000/
048100     COPY SS27PD.
048200*
048300 9995-END-SOURCE-STATEMENTS SECTION.
048400 9999-END-OF-PROGRAM.
048500     EXIT.
