000100 IDENTIFICATION DIVISION.
000200 PROGRAM-ID. MBD72055.
000201*       RELEASE DATE=08/24/01.        REVISION LEVEL=08.06      * ++++++++
000202***************************************************************** ++++++++
000203*WARNING.  THIS COMPUTER PROGRAM IS PROTECTED BY COPYRIGHT LAW  * ++++++++
000204*AND INTERNATIONAL TREATIES.  UNAUTHORIZED REPRODUCTION OR      * ++++++++
000205*DISTRIBUTION OF THIS PROGRAM, OR ANY PORTION OF IT, MAY RESULT * ++++++++
000206*IN SEVERE CIVIL AND CRIMINAL PENATLIES, AND WILL BE PROSECUTED * ++++++++
000207*TO THE MAXIMUM EXTENT POSSIBLE UNDER THE LAW.                  * ++++++++
000208*COPYRIGHT 1999 PAYSYS INTERNATIONAL, INC.  ALL RIGHTS RESERVED.* ++++++++
000209***************************************************************** ++++++++
000300*****************************************************************
000400*                                                               *
000500*   V - PLUS  M E R C H A N T   B A N K C A R D   S Y S T E M   *
000600*                                                               *
000700*       MBD72055 - OPTIONAL REPORT 55 SUBROUTINE                *
000800*                                                               *
000900*****************************************************************
001000 ENVIRONMENT DIVISION.
001100 CONFIGURATION SECTION.
001200 SOURCE-COMPUTER.            IBM-4341.
001300 OBJECT-COMPUTER.            IBM-4341.
001400/
001500 DATA DIVISION.
001600 WORKING-STORAGE SECTION.
001700*
001800 01  FILLER                  PIC  X(12)      VALUE '** WS-BEG **'.
001900*
002000 01  WS-MBD72055-WORK-AREAS.
002100     03  WS-D72055-ACTIVITY-SW
002200                             PIC  X(01)      VALUE 'N'.
002300     03  WS-D720-LINE-CHECK  PIC S9(05)      COMP-3 VALUE +1.
002400     03  WS-ORG-TOTALS-AREA.
002500         05  WS-OT-REASONS-MAX
002600                             PIC S9(04)      BINARY VALUE +100.
002700         05  WS-OT-REASONS-X.
002800             07  WS-OT-REASON-TABLE          OCCURS 100 TIMES
002900                                             INDEXED BY
003000                                             X-WS-OT-RT.
003100                 09  WS-OT-REASON
003200                             PIC  X(30)      VALUE SPACES.
003300                     88  WS-OT-REASON-END-OF-TABLE
003400                                             VALUE SPACES.
003500                 09  WS-OT-NBR
003600                             PIC S9(09)      COMP-3 VALUE ZERO.
003700*
003800/
003900     COPY MB20WS.
004000 01  WS-PRINT-LINE-1         REDEFINES MB20WS-PRINT-LINE.
004100     03  WS-PL1-MERCHANT     PIC  9(09)-.
004200     03  FILLER              PIC  X(05).
004300     03  WS-PL1-MERCHANT-LIT PIC  X(10).
004400     03  FILLER              PIC  X(05).
004500     03  WS-PL1-NAME         PIC  X(40).
004600     03  FILLER              PIC  X(05).
004700     03  WS-PL1-REASON       PIC  X(30).
004800     03  FILLER              PIC  X(27).
004900 01  WS-PRINT-LINE-2         REDEFINES MB20WS-PRINT-LINE.
005000     03  FILLER              PIC  X(04).
005100     03  WS-PL2-NAME         PIC  X(40).
005200     03  WS-PL2-NBR          PIC  X(12).
005300     03  FILLER              PIC  X(76).
005400/
005500     COPY SS95WS.
005600/
005700     COPY MTRFWS REPLACING ==:MTRF:== BY ==MTRF==.
005800/
005900     COPY MTRFRL REPLACING ==:MTRF:== BY ==MWRF==.
006000/
006100     COPY MTP0RL REPLACING ==:MTP0:== BY ==MTR0==.
006200/
006300     COPY MTP0RL REPLACING ==:MTP0:== BY ==MTR1==.
006400/
006500     COPY MTP0RL REPLACING ==:MTP0:== BY ==MTR2==.
006600/
006700     COPY MTP0RL REPLACING ==:MTP0:== BY ==MTR3==.
006800/
006900     COPY MTP0RL REPLACING ==:MTP0:== BY ==MTR4==.
007000/
007100     COPY MTP0RL REPLACING ==:MTP0:== BY ==MTR5==.
007200/
007300     COPY MTP0RL REPLACING ==:MTP0:== BY ==MTR6==.
007400/
007500     COPY MTP0RL REPLACING ==:MTP0:== BY ==MTR7==.
007600/
007700     COPY MTP0RL REPLACING ==:MTP0:== BY ==MTR8==.
007800/
007900     COPY MTP0RL REPLACING ==:MTP0:== BY ==MTR9==.
008000/
008100     COPY MB00WS.
008200/
008300     COPY SS00WS.
008400/
008500     COPY SS01WS.
008600/
008700     COPY SS02WS.
008800*
008900 01  FILLER                  PIC  X(12)      VALUE '** WS-END **'.
009000/
009100 LINKAGE SECTION.
009200     COPY MB22WS.
009300/
009400     COPY MTRFRL REPLACING ==:MTRF:== BY ==MTRF==.
009500/
009600 PROCEDURE DIVISION              USING MB22WS-LINK-DATA
009700                                       MTRF-RECORD.
009800*
009900 A000-MAIN-LINE-SECT SECTION.
010000 A010-ML-BEGIN.
010100*
010200     IF  MTRF-K1-RT-DETAIL
010300         PERFORM D000-DETAIL-RECORD
010400            THRU D099-DR-EXIT.
010500*
010600     IF  MTRF-K1-RT-HEADER
010700         PERFORM H000-HEADER-RECORD
010800            THRU H099-HR-EXIT.
010900*
011000     IF  MTRF-K1-RT-TRAILER
011100         PERFORM T000-TRAILER-RECORD
011200            THRU T099-TR-EXIT.
011300*
011400     GOBACK.
011500*
011600 A099-ML-EXIT.
011700     EXIT.
011800/
011900 D000-DETAIL-RECORD SECTION.
012000 D010-DR-BEGIN.
012100*
012200     MOVE 'Y'                    TO WS-D72055-ACTIVITY-SW.
012300*
012400     IF  MTRF-K2-O55-RT-MBD320
012500         MOVE MTRF-RECORD        TO MWRF-RECORD
012600         GO TO D099-DR-EXIT.
012700*
012800     IF  MTRF-K2-O55-RT-MBD200
012900         ADD  MTRF-O55-TOTAL-EXCEPTIONS
013000                                 TO MWRF-O55-TOTAL-EXCEPTIONS
013100         ADD  MTRF-O55-TOTAL-STATEMENTS
013200                                 TO MWRF-O55-TOTAL-STATEMENTS
013300         ADD  MTRF-O55-TOTAL-ON-LINE-ONLY
013400                                 TO MWRF-O55-TOTAL-ON-LINE-ONLY
013500         ADD  MTRF-O55-TOTAL-CHAIN-STMTS
013600                                 TO MWRF-O55-TOTAL-CHAIN-STMTS
013700         GO TO D099-DR-EXIT.
013800*
013900*
014000     MOVE MTRF-K2-O55-MERCHANT   TO WS-PL1-MERCHANT.
014100*
014200     IF  MTRF-K2-O55-DETAIL-CHAIN
014300         MOVE 'CHAIN'            TO WS-PL1-MERCHANT-LIT
014400     ELSE
014500         MOVE 'MERCHANT'         TO WS-PL1-MERCHANT-LIT.
014600*
014700     MOVE MTRF-NAME              TO WS-PL1-NAME.
014800     MOVE MTRF-O55-EXCEPTION-DESC
014900                                 TO WS-PL1-REASON.
015000*
015100     EVALUATE TRUE
015200         WHEN MTRF-K1-DETAIL
015300             PERFORM MB22PD-PRINT-1-LINE
015400                THRU MB22PD-P1L-EXIT
015500         WHEN OTHER
015600             MOVE SPACES         TO MB20WS-PRINT-LINE
015700     END-EVALUATE.
015800*
015900     SET X-WS-OT-RT              TO 1.
016000     SEARCH WS-OT-REASON-TABLE VARYING X-WS-OT-RT
016100         AT END
016200             SET X-WS-OT-RT      TO 100
016300         WHEN WS-OT-REASON-END-OF-TABLE (X-WS-OT-RT)
016400             MOVE MTRF-O55-EXCEPTION-DESC
016500                                 TO WS-OT-REASON (X-WS-OT-RT)
016600         WHEN WS-OT-REASON (X-WS-OT-RT)
016700                         IS EQUAL TO MTRF-O55-EXCEPTION-DESC
016800             NEXT SENTENCE.
016900*
017000     ADD  1                      TO WS-OT-NBR (X-WS-OT-RT).
017100*
017200     PERFORM MB22PD-PRINT-1-LINE
017300        THRU MB22PD-P1L-EXIT.
017400*
017500 D099-DR-EXIT.
017600     EXIT.
017700/
017800 H000-HEADER-RECORD SECTION.
017900 H010-HR-BEGIN.
018000*
018100     MOVE MTRF-K1-FORM           TO MB20WS-FORM-CODE.
018200     MOVE MTRF-HD-DATE-FORMAT    TO SS01WS-DATE-FORMAT.
018300     MOVE MTRF-HD-FICHE-FLAG     TO MB20WS-FICHE-CODE.
018400     MOVE MTRF-HD-SYSTEM-NAME    TO MB20WS-SH-SYSTEM.
018500     MOVE MTRF-HD-REPORT-ID      TO MB20WS-SH-RPT-ID.
018600     MOVE 'O55'                  TO MB20WS-SH-INTERNAL-RPT-ID.
018700     MOVE MTRF-K1-ORG            TO MB20WS-SH-ORG.
018800     MOVE MTRF-HD-ORG-NAME       TO MB20WS-SH-ORG-NAME.
018900     MOVE MTRF-HD-RPT-TITLE      TO MB20WS-SH-RPT-NAME.
019000     MOVE MTRF-HD-FILE-DATE      TO SS01WS-JULIAN.
019100     PERFORM SS26PD-NUMERICALLY-EDIT-DATE
019200        THRU SS26PD-NED-EXIT.
019300     MOVE SS01WS-XX-XX-YYYY      TO MB20WS-SH-FILE-DATE.
019400     MOVE MTRF-HD-REPORT-DEST-ID TO MB20WS-SH-DEST-ID.
019500     MOVE MTRF-HD-DEST-DESC      TO MB20WS-SH-DEST-DESC.
019600*
019700     MOVE ' MERCHANT                                   '
019800                                 TO MB20WS-SH-L5R-1.
019900     MOVE '                                            '
020000                                 TO MB20WS-SH-L5R-2.
020100     MOVE '                                            '
020200                                 TO MB20WS-SH-L5R-3.
020300*
020400     MOVE '  NUMBER                      *------------M'
020500                                 TO MB20WS-SH-L6R-1.
020600     MOVE 'ERCHANT NAME-------------*     *------EXCEPT'
020700                                 TO MB20WS-SH-L6R-2.
020800     MOVE 'ION REASON------*                           '
020900                                 TO MB20WS-SH-L6R-3.
021000*
021100     MOVE ZERO                   TO MB20WS-PAGE-COUNT.
021200     MOVE MB20WS-FORCE-PAGE      TO MB20WS-LINE-COUNT.
021300     MOVE MTRF-HD-LINES-PER-PAGE TO MB20WS-LINES-PER-PAGE.
021400     MOVE MTRF-HD-CURRENCY-NOD   TO MTRFWS-SAVE-CURRENCY-NOD.
021500     MOVE MTRF-HD-PER-ITEM-NOD   TO MTRFWS-SAVE-PER-ITEM-NOD.
021600     MOVE MTRF-HD-PERCENT-NOD    TO MTRFWS-SAVE-PERCENT-NOD.
021700     SET SS95WS-FUNCTION-INITIALIZE
021800                                 TO TRUE.
021900     PERFORM SS95PD-NAP-ROUTINE
022000        THRU SS95PD-NAP-EXIT.
022100*
022200     MOVE MTRF-HD-CURRENCY-CODE  TO SS95WS-CURRENCY-CODE.
022300     MOVE 'N'                    TO WS-D72055-ACTIVITY-SW.
022400     MOVE MTRF-RECORD            TO MTR9-RECORD.
022500*
022600     INITIALIZE WS-OT-REASONS-X.
022700*
022800 H099-HR-EXIT.
022900     EXIT.
023000/
023100 T000-TRAILER-RECORD SECTION.
023200 T010-TR-BEGIN.
023300     MOVE MTR9-RECORD            TO MTRF-RECORD.
023400*
023500     IF  WS-D72055-ACTIVITY-SW IS EQUAL TO 'N'
023600         IF  MTRF-HD-AF-PRODUCE
023700             PERFORM MB22PD-PRINT-NO-ACTIVITY
023800                                 THRU MB22PD-PNA-EXIT
023900             GO TO T099-TR-EXIT
024000         ELSE
024100             GO TO T099-TR-EXIT.
024200*
024300     MOVE MB20WS-FORCE-PAGE      TO MB20WS-LINE-COUNT.
024400     PERFORM 9010-PRINT-ORG-TOTALS
024500        THRU 9010-POT-EXIT.
024600*
024700 T099-TR-EXIT.
024800     EXIT.
024900/
025000 9000-PERFORMED-ROUTINES-SECT SECTION.
025100 9010-PRINT-ORG-TOTALS.
025200*
025300     MOVE '*** ORGANIZATION TOTALS ***'
025400                                 TO MB20WS-PRINT-LINE.
025500     PERFORM MB22PD-PRINT-2-LINES
025600        THRU MB22PD-P2L-EXIT.
025700*
025800     MOVE '*** EXCEPTION REASON TOTALS ***'
025900                                 TO MB20WS-PRINT-LINE.
026000     PERFORM MB22PD-PRINT-1-LINE
026100        THRU MB22PD-P1L-EXIT.
026200*
026300     PERFORM
026400         VARYING X-WS-OT-RT FROM 1 BY 1
026500         UNTIL   X-WS-OT-RT IS GREATER THAN WS-OT-REASONS-MAX
026600            OR   WS-OT-REASON-END-OF-TABLE (X-WS-OT-RT)
026700         MOVE WS-OT-REASON (X-WS-OT-RT)
026800                                 TO WS-PL2-NAME
026900         MOVE WS-OT-NBR (X-WS-OT-RT)
027000                                 TO SS95WS-IN-NBR
027100         PERFORM SS95PD-NAP-ROUTINE
027200            THRU SS95PD-NAP-EXIT
027300         MOVE SS95WS-OUT-NBR-L12 TO WS-PL2-NBR
027400         PERFORM MB22PD-PRINT-1-LINE
027500            THRU MB22PD-P1L-EXIT
027600     END-PERFORM.
027700*
027800     PERFORM MB22PD-PRINT-2-LINES
027900        THRU MB22PD-P2L-EXIT.
028000*
028100     MOVE '*** STATEMENT TOTALS ***'
028200                                 TO MB20WS-PRINT-LINE.
028300     PERFORM MB22PD-PRINT-1-LINE
028400        THRU MB22PD-P1L-EXIT.
028500*
028600     MOVE 'TOTAL MERCHANT STATEMENTS'
028700                                 TO WS-PL2-NAME.
028800     MOVE MWRF-O55-TOTAL-STATEMENTS
028900                                 TO SS95WS-IN-NBR.
029000     PERFORM SS95PD-NAP-ROUTINE
029100        THRU SS95PD-NAP-EXIT.
029200     MOVE SS95WS-OUT-NBR-L12     TO WS-PL2-NBR.
029300     PERFORM MB22PD-PRINT-1-LINE
029400        THRU MB22PD-P1L-EXIT.
029500*
029600     MOVE 'TOTAL CHAIN STATEMENTS'
029700                                 TO WS-PL2-NAME.
029800     MOVE MWRF-O55-TOTAL-CHAIN-STMTS
029900                                 TO SS95WS-IN-NBR.
030000     PERFORM SS95PD-NAP-ROUTINE
030100        THRU SS95PD-NAP-EXIT.
030200     MOVE SS95WS-OUT-NBR-L12     TO WS-PL2-NBR.
030300     PERFORM MB22PD-PRINT-1-LINE
030400        THRU MB22PD-P1L-EXIT.
030500*
030600     MOVE 'TOTAL STATEMENTS WITH EXCEPTIONS'
030700                                 TO WS-PL2-NAME.
030800     MOVE MWRF-O55-TOTAL-EXCEPTIONS
030900                                 TO SS95WS-IN-NBR.
031000     PERFORM SS95PD-NAP-ROUTINE
031100        THRU SS95PD-NAP-EXIT.
031200     MOVE SS95WS-OUT-NBR-L12     TO WS-PL2-NBR.
031300     PERFORM MB22PD-PRINT-1-LINE
031400        THRU MB22PD-P1L-EXIT.
031500*
031600 9010-POT-EXIT.
031700     EXIT.
031800/
031900*
032000 9100-CHECK-NBR-LINES.
032100*
032200     COMPUTE MB20WS-LINES-REMAINING
032300                                 = MB20WS-LINE-LIMIT
032400                                 - MB20WS-LINE-COUNT.
032500*
032600     IF  MB20WS-LINES-REMAINING IS LESS THAN WS-D720-LINE-CHECK
032700         MOVE MB20WS-FORCE-PAGE  TO MB20WS-LINE-COUNT.
032800*
032900 9100-CNL-EXIT.
033000     EXIT.
033100/
033200     COPY MB22PD.
033300/
033400     COPY SS95PD.
033500/
033600     COPY SS02PD.
033700/
033800     COPY SS07PD.
033900/
034000     COPY SS08PD.
034100/
034200     COPY SS16PD.
034300/
034400     COPY SS26PD.
034500/
034600     COPY SS27PD.
034700*
034800 9995-END-SOURCE-STATEMENTS SECTION.
034900 9999-END-OF-PROGRAM.
035000     EXIT.
