000100 IDENTIFICATION DIVISION.
000200 PROGRAM-ID. MBD762.
000201*       RELEASE DATE=08/24/01.        REVISION LEVEL=08.06      *
000202*****************************************************************
000203*WARNING.  THIS COMPUTER PROGRAM IS PROTECTED BY COPYRIGHT LAW  *
000204*AND INTERNATIONAL TREATIES.  UNAUTHORIZED REPRODUCTION OR      *
000205*DISTRIBUTION OF THIS PROGRAM, OR ANY PORTION OF IT, MAY RESULT *
000206*IN SEVERE CIVIL AND CRIMINAL PENATLIES, AND WILL BE PROSECUTED *
000207*TO THE MAXIMUM EXTENT POSSIBLE UNDER THE LAW.                  *
000208*COPYRIGHT 1999 PAYSYS INTERNATIONAL, INC.  ALL RIGHTS RESERVED.*
000209*****************************************************************
000300*****************************************************************
000400*                                                               *
000500*   MBD762 - ZIP SORT CHAIN STATEMENTS DRIVER PROGRAM           *
000600*                                                               *
000700*****************************************************************
000800 ENVIRONMENT DIVISION.
000900 CONFIGURATION SECTION.
001000 SOURCE-COMPUTER.            IBM-4341.
001100 OBJECT-COMPUTER.            IBM-4341.
001200/
001300 INPUT-OUTPUT SECTION.
001400*
001500 FILE-CONTROL.
001600*
001700     COPY MS1SES.
001800/
001900 DATA DIVISION.
002000 FILE SECTION.
002100*
002200     COPY MS1SSD.
002300     COPY MTP0RL REPLACING ==:MTP0:== BY ==MTR0==.
002400     03  MS1S-MBD762-SORT-KEY.
002500         05  MS1S-MBD762-ORG-X.
002600             07  MS1S-MBD762-ORG
002700                             PIC  9(03).
002800/
002900 WORKING-STORAGE SECTION.
003000*
003100 01  FILLER                  PIC  X(12)      VALUE '** WS-BEG **'.
003200*
003300 01  WS-D762-WORK-AREAS.
003400     03  WS-D762-STMT-PGM-NBR
003500                             PIC  9(01)      VALUE ZERO.
003600     03  WS-D762-PRINT-FILE-X.
003700         05  WS-D762-PRINT-FILE
003800                             PIC  9(01)      VALUE ZERO.
003900     03  WS-D762-FORM-X.
004000         05  WS-D762-FORM    PIC  9(02)      VALUE ZERO.
004100     03  WS-D762-ORG-X.
004200         05  WS-D762-ORG     PIC  9(03)      VALUE ZERO.
004300/
004400     COPY MTCCRL REPLACING ==:MTCC:== BY ==MTCC==.
004500/
004600     COPY MB00RB REPLACING ==:MB00:== BY ==MTCC==.
004700/
004800     COPY MTCCIO REPLACING ==:MTCC:== BY ==MTCC==.
004900/
005000     COPY MTRFRL REPLACING ==:MTRF:== BY ==MTRF==.
005100/
005200     COPY MB00RB REPLACING ==:MB00:== BY ==MTRF==.
005300/
005400     COPY MTRFIO REPLACING ==:MTRF:== BY ==MTRF==.
005500/
005600     COPY MTRFWS REPLACING ==:MTRF:== BY ==MTRF==.
005700/
005800     COPY MTRFRL REPLACING ==:MTRF:== BY ==MWRF==.
005900/
006000     COPY MB00RB REPLACING ==:MB00:== BY ==MS1S==.
006100/
006200     COPY MB00WS.
006300/
006400     COPY MB20WS.
006500/
006600     COPY MB22WS.
006700/
006800     COPY SS00WS.
006900/
007000     COPY SS01WS.
007100/
007200     COPY SS02WS.
007300*
007400 01  FILLER                  PIC  X(12)      VALUE '** WS-END **'.
007500/
007600 PROCEDURE DIVISION.
007700 A000-MAIN-LINE-SECT SECTION.
007800 A010-ML-BEGIN.
007900*
008000     MOVE SPACES                 TO MTRF-RECORD.
008100     MOVE SPACES                 TO MB20WS-SH-L1.
008200     MOVE SPACES                 TO MB20WS-SH-L2.
008300     MOVE SPACES                 TO MB20WS-SH-L3.
008400     MOVE SPACES                 TO MB20WS-SH-L4.
008500     MOVE SPACES                 TO MB20WS-SH-L5.
008600     MOVE SPACES                 TO MB20WS-SH-L6.
008700     MOVE SPACES                 TO MB20WS-SH-L7.
008800     MOVE SPACES                 TO MB20WS-SH-L8.
008900     PERFORM A100-OPEN-FILES
009000        THRU A199-OF-EXIT.
009100*
009200     PERFORM A700-MERCHANT-SORT
009300        THRU A799-MS-EXIT.
009400*
009500     PERFORM A300-CLOSE-FILES
009600        THRU A399-CF-EXIT.
009700*
009800     STOP RUN.
009900*
010000 A099-ML-EXIT.
010100     EXIT.
010200/
010300 A100-OPEN-FILES SECTION.
010400 A110-OF-BEGIN.
010500*
010600     MOVE 'MBD762'               TO SS02WS-ABEND-PROG-ID.
010700*
010800     MOVE 'O1RF'                 TO SS02WS-ABEND-LOCATION.
010900     SET MTRFRB-OPEN-INPUT       TO TRUE.
011000     PERFORM MB00PD-MTRF-ACCESS
011100        THRU MB00PD-MTRF-ACCESS-EXIT.
011200*
011300     MOVE 'O1CC'                 TO SS02WS-ABEND-LOCATION.
011400     SET MTCCRB-OPEN-INPUT       TO TRUE.
011500     PERFORM MB00PD-MTCC-ACCESS
011600        THRU MB00PD-MTCC-ACCESS-EXIT.
011700*
011800     MOVE SS02WS-END-OF-FILE     TO MTCCRB-PERM-STATUS-1.
011900*
012000     PERFORM Z100-READ-CONTROL-CARD
012100        THRU Z199-RCC-EXIT
012200        UNTIL MTCC-PROGRAM-ID IS EQUAL TO SS02WS-ABEND-PROG-ID.
012300*
012400     MOVE 'R1RF'                 TO SS02WS-ABEND-LOCATION.
012500     SET MTRFRB-READ-SEQ         TO TRUE.
012600     PERFORM MB00PD-MTRF-ACCESS
012700        THRU MB00PD-MTRF-ACCESS-EXIT.
012800*
012900     PERFORM MB22PD-INITIALIZE-PAGE
013000        THRU MB22PD-IP-EXIT.
013100*
013200 A199-OF-EXIT.
013300     EXIT.
013400/
013500 A300-CLOSE-FILES SECTION.
013600 A310-CF-BEGIN.
013700*
013800     MOVE 'C1RF'                 TO SS02WS-ABEND-LOCATION.
013900     SET MTRFRB-CLOSE            TO TRUE.
014000     PERFORM MB00PD-MTRF-ACCESS
014100        THRU MB00PD-MTRF-ACCESS-EXIT.
014200*
014300     MOVE 'C1CC'                 TO SS02WS-ABEND-LOCATION.
014400     SET MTCCRB-CLOSE            TO TRUE.
014500     PERFORM MB00PD-MTCC-ACCESS
014600        THRU MB00PD-MTCC-ACCESS-EXIT.
014700*
014800     PERFORM MB20PD-CLOSE-PRINT-FILES
014900        THRU MB20PD-CPF-EXIT.
015000*
015100 A399-CF-EXIT.
015200     EXIT.
015300/
015400 A700-MERCHANT-SORT SECTION.
015500 A710-MS-BEGIN.
015600*
015700     MOVE SS02WS-END-OF-FILE     TO MTRFRB-PERM-STATUS-1.
015800*
015900     MOVE SPACES                 TO WS-D762-PRINT-FILE-X.
016000     MOVE SPACES                 TO WS-D762-FORM-X.
016100     MOVE SPACES                 TO MTRFWS-KEY-1.
016200*
016300     SORT MS1S-SORT-FILE
016400          ON ASCENDING KEY MTR0-K1-PRINT-FILE-X
016500                           MTR0-K1-FORM-X
016600                           MTR0-K1-ORG-X
016700                           MTR0-K1-GROUP-X
016800                           MTR0-K1-REPORT-X
016900                           MTR0-K1-REC-TYPE-X
017000                           MTR0-KEY-2
017100          INPUT  PROCEDURE IS A800-EXTRACT-SPECIAL-FORM-SECT
017200          OUTPUT PROCEDURE IS A900-PROCESS-REPORT-SECT.
017300*
017400     PERFORM SS98PD-VERIFY-SORT-RETURN
017500        THRU SS98PD-VSR-EXIT.
017600*
017700 A799-MS-EXIT.
017800     EXIT.
017900/
018000 A800-EXTRACT-SPECIAL-FORM-SECT SECTION.
018100 A810-ESF-BEGIN.
018200*
018300     MOVE 'R2RF'                 TO SS02WS-ABEND-LOCATION.
018400     SET MTRFRB-READ-SEQ         TO TRUE.
018500     PERFORM MB00PD-MTRF-ACCESS
018600        THRU MB00PD-MTRF-ACCESS-EXIT.
018700*
018800     IF  SS02WS-FS-END-OF-FILE
018900         GO TO A899-ESF-EXIT.
019000*
019100     MOVE MTRFIO-RECORD          TO MTRF-RECORD.
019200*
019300     IF  MTRF-K1-REPORT-X IS NOT EQUAL TO 'O52'
019400         GO TO A810-ESF-BEGIN.
019500*
019600     IF  MTCC-MBD762-ALL
019700     OR  MTCC-MBD762-ORG-X IS EQUAL TO MTRF-K1-ORG-X
019800         NEXT SENTENCE
019900     ELSE
020000         GO TO A810-ESF-BEGIN.
020100*
020200     IF  MTRF-K1-PRINT-FILE-X IS EQUAL TO WS-D762-PRINT-FILE-X
020300     AND MTRF-K1-FORM-X       IS EQUAL TO WS-D762-FORM-X
020400         NEXT SENTENCE
020500     ELSE
020600         MOVE SPACES             TO MTRFWS-KEY-1.
020700*
020800     MOVE MTRF-K1-PRINT-FILE-X   TO WS-D762-PRINT-FILE-X.
020900     MOVE MTRF-K1-FORM-X         TO WS-D762-FORM-X.
021000*
021100     IF  MTRF-K1-RT-HEADER
021200     AND MTRFWS-KEY-1 IS EQUAL TO SPACES
021300         MOVE MTRF-KEY-1         TO MTRFWS-KEY-1.
021400*
021500     MOVE MTRF-K1-ORG-X          TO WS-D762-ORG-X.
021600     MOVE MTRFWS-K1-PRINT-FILE-X TO MTRF-K1-PRINT-FILE-X.
021700     MOVE MTRFWS-K1-FORM-X       TO MTRF-K1-FORM-X.
021800     MOVE MTRFWS-K1-ORG-X        TO MTRF-K1-ORG-X.
021900     MOVE ZERO                   TO MTRF-K1-GROUP.
022000*
022100     IF  MTRF-K1-RT-HEADER
022200     OR  MTRF-K1-RT-TRAILER
022300         IF  WS-D762-ORG-X IS EQUAL TO MTRFWS-K1-ORG-X
022400             NEXT SENTENCE
022500         ELSE
022600             GO TO A810-ESF-BEGIN.
022700*
022800     IF  MTRF-K1-RT-HEADER
022900     OR  MTRF-K1-RT-TRAILER
023000         MOVE '000000000'        TO MTRF-K2-O50-POSTAL-CODE
023100     ELSE
023200         IF  MTRF-K2-O50-NA-RECORD
023300             MOVE MTRF-RECORD    TO MWRF-RECORD
023400             MOVE MWRF-O50-POSTAL-CODE
023500                                 TO MTRF-K2-O50-POSTAL-CODE
023600         ELSE
023700             MOVE MWRF-O50-POSTAL-CODE
023800                                 TO MTRF-K2-O50-POSTAL-CODE.
023900*
024000     MOVE MTRF-RECORD            TO MTR0-RECORD.
024100     MOVE WS-D762-ORG-X          TO MS1S-MBD762-ORG-X.
024200     RELEASE MTR0-RECORD.
024300     GO TO A810-ESF-BEGIN.
024400*
024500 A899-ESF-EXIT.
024600     EXIT.
024700/
024800 A900-PROCESS-REPORT-SECT SECTION.
024900 A910-PR-BEGIN.
025000*
025100     RETURN MS1S-SORT-FILE
025200         AT END
025300             GO TO A999-PR-EXIT.
025400*
025500     MOVE MTR0-RECORD            TO MTRF-RECORD.
025600     MOVE MS1S-MBD762-ORG-X      TO MTRF-K1-ORG-X.
025700*
025800     IF  MTRF-K1-HEADER
025900     OR  MTRF-K1-TRAILER
026000         GO TO A910-PR-BEGIN.
026100*
026200     PERFORM B000-PROCESS-REPORT-RECORD
026300        THRU B999-PRR-EXIT.
026400*
026500     GO TO A910-PR-BEGIN.
026600*
026700 A999-PR-EXIT.
026800     EXIT.
026900/
027000 B000-PROCESS-REPORT-RECORD SECTION.
027100 B010-PRR-BEGIN.
027200*
027300     IF  MTRF-K1-RPT-NBR IS EQUAL TO 52
027400         PERFORM R520-REPORT-52
027500            THRU R529-R52-EXIT
027600         PERFORM P000-PRINT-THE-REPORTS
027700            THRU P999-PTR-EXIT.
027800*
027900 B999-PRR-EXIT.
028000     EXIT.
028100/
028200 R520-REPORT-52 SECTION.
028300 R521-R52-BEGIN.
028400*
028500*
028600     CALL MB00WS-MBD74052        USING MB22WS-LINK-DATA
028700                                       MTRF-RECORD.
028800*
028900 R529-R52-EXIT.
029000     EXIT.
029100/
029200 P000-PRINT-THE-REPORTS SECTION.
029300 P010-PTR-BEGIN.
029400*
029500     PERFORM MB22PD-DRIVER-PRINT-LINES
029600        THRU MB22PD-DPL-EXIT.
029700*
029800 P999-PTR-EXIT.
029900     EXIT.
030000/
030100 Z100-READ-CONTROL-CARD SECTION.
030200 Z100-RCC-BEGIN.
030300*
030400     MOVE 'R1CC'                 TO SS02WS-ABEND-LOCATION.
030500     SET MTCCRB-READ-SEQ         TO TRUE.
030600     PERFORM MB00PD-MTCC-ACCESS
030700        THRU MB00PD-MTCC-ACCESS-EXIT.
030800*
030900     IF  SS02WS-FS-END-OF-FILE
031000         MOVE 'ALL'              TO MTCC-RECORD
031100         MOVE 'MBD762'           TO MTCC-PROGRAM-ID
031200         GO TO Z199-RCC-EXIT.
031300*
031400     MOVE MTCCIO-RECORD          TO MTCC-RECORD.
031500*
031600     IF  MTCC-PROGRAM-ID IS EQUAL TO SS02WS-ABEND-PROG-ID
031700         GO TO Z199-RCC-EXIT.
031800*
031900     MOVE SPACES                 TO MTCC-RECORD.
032000*
032100 Z199-RCC-EXIT.
032200     EXIT.
032300/
032400 9000-PERFORMED-ROUTINES-SECT SECTION.
032500*
032600     COPY MB00PD REPLACING ==:MB00:== BY ==MTCC==.
032700/
032800     COPY MB00PD REPLACING ==:MB00:== BY ==MTRF==.
032900/
033000     COPY MB20PD.
033100/
033200     COPY MB22PD1.
033300/
033400     COPY SS02PD.
033500/
033600     COPY SS07PD.
033700/
033800     COPY SS08PD.
033900/
034000     COPY SS16PD.
034100/
034200     COPY SS26PD.
034300/
034400     COPY SS27PD.
034500/
034600     COPY SS98PD.
034700*
034800 9995-END-SOURCE-STATEMENTS SECTION.
034900 9999-END-OF-PROGRAM.
035000     EXIT.
