000100 IDENTIFICATION DIVISION.
000200 PROGRAM-ID. MBD766.
000201*       RELEASE DATE=08/24/01.        REVISION LEVEL=08.06      *
000202*****************************************************************
000203*WARNING.  THIS COMPUTER PROGRAM IS PROTECTED BY COPYRIGHT LAW  *
000204*AND INTERNATIONAL TREATIES.  UNAUTHORIZED REPRODUCTION OR      *
000205*DISTRIBUTION OF THIS PROGRAM, OR ANY PORTION OF IT, MAY RESULT *
000206*IN SEVERE CIVIL AND CRIMINAL PENATLIES, AND WILL BE PROSECUTED *
000207*TO THE MAXIMUM EXTENT POSSIBLE UNDER THE LAW.                  *
000208*COPYRIGHT 1999 PAYSYS INTERNATIONAL, INC.  ALL RIGHTS RESERVED.*
000209*****************************************************************
000300*****************************************************************
000400*                                                               *
000500*    MBD766 - DUAL/MULTI-CURRENCY STATEMENTS DRIVER PROGRAM     *
000600*                                                               *
000700*****************************************************************
000800 ENVIRONMENT DIVISION.
000900 CONFIGURATION SECTION.
001000 SOURCE-COMPUTER.            IBM-4341.
001100 OBJECT-COMPUTER.            IBM-4341.
001200/
001300 INPUT-OUTPUT SECTION.
001400*
001500 FILE-CONTROL.
001600*
001700     COPY MS1SES.
001800/
001900 DATA DIVISION.
002000 FILE SECTION.
002100*
002200     COPY MS1SSD.
002300     COPY MTRFRL REPLACING ==:MTRF:== BY ==MS1S==.
002400     03  MS1S-SUPPLEMENTARY-SORT-KEY.
002500         05  MS1S-COMBINED-KEY
002600                             PIC  X(13).
002700/
002800 WORKING-STORAGE SECTION.
002900*
003000 01  FILLER                  PIC  X(12)      VALUE '** WS-BEG **'.
003100*
003200 01  WS-D766-WORK-AREAS.
003300     03  WS-D766-BYPASS-SW   PIC  X(01)      VALUE 'N'.
003400         88  WS-D766-BYPASS-YES              VALUE 'Y'.
003500         88  WS-D766-BYPASS-NO               VALUE 'N'.
003600/
003700     COPY MTRFRL REPLACING ==:MTRF:== BY ==MTRF==.
003800/
003900     COPY MB00RB REPLACING ==:MB00:== BY ==MTRF==.
004000/
004100     COPY MTRFIO REPLACING ==:MTRF:== BY ==MTRF==.
004200/
004300     COPY MTRFRL REPLACING ==:MTRF:== BY ==MWRF==.
004400/
004500     COPY MB00RB REPLACING ==:MB00:== BY ==MS1S==.
004600/
004700     COPY MB00WS.
004800/
004900     COPY MB20WS.
005000/
005100     COPY MB22WS.
005200/
005300     COPY SS00WS.
005400/
005500     COPY SS01WS.
005600/
005700     COPY SS02WS.
005800*
005900 01  FILLER                  PIC  X(12)      VALUE '** WS-END **'.
006000/
006100 PROCEDURE DIVISION.
006200 A000-MAIN-LINE-SECT SECTION.
006300 A010-ML-BEGIN.
006400*
006500     MOVE SPACES                 TO MTRF-RECORD.
006600     MOVE SPACES                 TO MB20WS-SH-L1.
006700     MOVE SPACES                 TO MB20WS-SH-L2.
006800     MOVE SPACES                 TO MB20WS-SH-L3.
006900     MOVE SPACES                 TO MB20WS-SH-L4.
007000     MOVE SPACES                 TO MB20WS-SH-L5.
007100     MOVE SPACES                 TO MB20WS-SH-L6.
007200     MOVE SPACES                 TO MB20WS-SH-L7.
007300     MOVE SPACES                 TO MB20WS-SH-L8.
007400     PERFORM A100-OPEN-FILES
007500        THRU A199-OF-EXIT.
007600*
007700     PERFORM A700-MERCHANT-SORT
007800        THRU A799-MS-EXIT.
007900*
008000     PERFORM A300-CLOSE-FILES
008100        THRU A399-CF-EXIT.
008200*
008300     STOP RUN.
008400*
008500 A099-ML-EXIT.
008600     EXIT.
008700/
008800 A100-OPEN-FILES SECTION.
008900 A110-OF-BEGIN.
009000*
009100     MOVE 'MBD766'               TO SS02WS-ABEND-PROG-ID.
009200*
009300     MOVE 'O1RF'                 TO SS02WS-ABEND-LOCATION.
009400     SET MTRFRB-OPEN-INPUT       TO TRUE.
009500     PERFORM MB00PD-MTRF-ACCESS
009600        THRU MB00PD-MTRF-ACCESS-EXIT.
009700*
009800     MOVE 'R1RF'                 TO SS02WS-ABEND-LOCATION.
009900     SET MTRFRB-READ-SEQ         TO TRUE.
010000     PERFORM MB00PD-MTRF-ACCESS
010100        THRU MB00PD-MTRF-ACCESS-EXIT.
010200*
010300     PERFORM MB22PD-INITIALIZE-PAGE
010400        THRU MB22PD-IP-EXIT.
010500*
010600 A199-OF-EXIT.
010700     EXIT.
010800/
010900 A300-CLOSE-FILES SECTION.
011000 A310-CF-BEGIN.
011100*
011200     MOVE 'C1RF'                 TO SS02WS-ABEND-LOCATION.
011300     SET MTRFRB-CLOSE            TO TRUE.
011400     PERFORM MB00PD-MTRF-ACCESS
011500        THRU MB00PD-MTRF-ACCESS-EXIT.
011600*
011700     PERFORM MB20PD-CLOSE-PRINT-FILES
011800        THRU MB20PD-CPF-EXIT.
011900*
012000 A399-CF-EXIT.
012100     EXIT.
012200/
012300 A700-MERCHANT-SORT SECTION.
012400 A710-MS-BEGIN.
012500*
012600     MOVE SS02WS-END-OF-FILE     TO MTRFRB-PERM-STATUS-1.
012700*
012800     SORT MS1S-SORT-FILE
012900          ON ASCENDING KEY MS1S-KEY-1
013000                           MS1S-K2-MBD766-SORT-KEY-1
013100                           MS1S-SUPPLEMENTARY-SORT-KEY
013200                           MS1S-K2-MBD766-SORT-KEY-2
013300          INPUT  PROCEDURE IS A800-EXTRACT-SPECIAL-FORM-SECT
013400          OUTPUT PROCEDURE IS A900-PROCESS-REPORT-SECT.
013500*
013600     PERFORM SS98PD-VERIFY-SORT-RETURN
013700        THRU SS98PD-VSR-EXIT.
013800*
013900 A799-MS-EXIT.
014000     EXIT.
014100/
014200 A800-EXTRACT-SPECIAL-FORM-SECT SECTION.
014300 A810-ESF-BEGIN.
014400*
014500     MOVE 'R2RF'                 TO SS02WS-ABEND-LOCATION.
014600     SET MTRFRB-READ-SEQ         TO TRUE.
014700     PERFORM MB00PD-MTRF-ACCESS
014800        THRU MB00PD-MTRF-ACCESS-EXIT.
014900*
015000     IF  SS02WS-FS-END-OF-FILE
015100         GO TO A899-ESF-EXIT
015200     END-IF.
015300*
015400     MOVE MTRFIO-RECORD          TO MTRF-RECORD.
015500
015600     IF  MTRF-K1-REPORT-X NOT = 'O50'
015700         GO TO A810-ESF-BEGIN
015800     END-IF.
015900*
016000     IF  MTRF-K1-RT-HEADER
016100     OR  MTRF-K1-RT-TRAILER
016200     OR  MTRF-K2-O50-NA-RECORD
016300     OR  MTRF-K2-O50-STMT-MSG-1
016400     OR  MTRF-K2-O50-STMT-MSG-2
016500     OR  MTRF-K2-O50-STMT-MSG-3
016600     OR  MTRF-K2-O50-STMT-MSG-4
016700     OR  MTRF-K2-O50-STMT-MSG-5
016800     OR  MTRF-K2-O50-CORR-NA-RECORD
016900     OR  MTRF-K2-O50-USER-FEE-TITLES
017000     OR  MTRF-K2-O50-PROD-DESC-RECORD
017100     OR  MTRF-K2-O50-BALANCE-SUMMARY
017200     OR  MTRF-K2-O50-RESERVE-SUMMARY
017300         CONTINUE
017400     ELSE
017500         GO TO A810-ESF-BEGIN
017600     END-IF.
017700*
017800     MOVE LOW-VALUES             TO MS1S-SUPPLEMENTARY-SORT-KEY.
017900*
018000     IF  MTRF-K1-RT-HEADER
018100     OR  MTRF-K1-RT-TRAILER
018200     OR  MTRF-K2-O50-STMT-MSG-1
018300     OR  MTRF-K2-O50-STMT-MSG-2
018400     OR  MTRF-K2-O50-STMT-MSG-3
018500     OR  MTRF-K2-O50-STMT-MSG-4
018600     OR  MTRF-K2-O50-STMT-MSG-5
018700     OR  MTRF-K2-O50-USER-FEE-TITLES
018800     OR  MTRF-K2-O50-PROD-DESC-RECORD
018900         GO TO A850-ESF-CONTINUE
019000     END-IF.
019100*
019200     IF  MTRF-K2-O50-NA-RECORD
019300         MOVE MTRF-RECORD        TO MWRF-RECORD
019400     END-IF.
019500*
019600     IF  MWRF-O50-DUAL-CURRENCY-OFF
019700         GO TO A810-ESF-BEGIN
019800     END-IF.
019900*
020000     IF  MTRF-K2-O50-CORR-NA-RECORD
020100     AND MWRF-O50-DUAL-CURRENCY-ORG NOT = MTRF-K1-ORG
020200         GO TO A810-ESF-BEGIN
020300     END-IF.
020400*
020500     MOVE LOW-VALUES             TO MS1S-SUPPLEMENTARY-SORT-KEY.
020600*
020700     MOVE MTRF-K1-ORG            TO MTRF-K2-O50-COMBINED-KEY(1:3).
020800     MOVE MTRF-K2-O50-MERCHANT   TO MTRF-K2-O50-COMBINED-KEY(4:9).
020900     MOVE MWRF-O50-DUAL-CURRENCY-ORG
021000                                 TO MTRF-K1-ORG.
021100*
021200 A850-ESF-CONTINUE.
021300*
021400     MOVE MTRF-RECORD            TO MS1S-RECORD.
021500*
021600     IF  MTRF-K2-O50-NA-RECORD
021700     OR  MTRF-K2-O50-BALANCE-SUMMARY
021800     OR  MTRF-K2-O50-RESERVE-SUMMARY
021900         MOVE MTRF-K2-O50-COMBINED-KEY
022000                                 TO MS1S-SUPPLEMENTARY-SORT-KEY
022100     END-IF.
022200*
022300     RELEASE MS1S-RECORD.
022400     GO TO A810-ESF-BEGIN.
022500*
022600 A899-ESF-EXIT.
022700     EXIT.
022800/
022900 A900-PROCESS-REPORT-SECT SECTION.
023000 A910-PR-BEGIN.
023100*
023200     RETURN MS1S-SORT-FILE
023300         AT END
023400             GO TO A999-PR-EXIT.
023500*
023600     MOVE MS1S-RECORD            TO MTRF-RECORD.
023700*
023800     IF  MTRF-K1-HEADER
023900     OR  MTRF-K1-TRAILER
024000         GO TO A910-PR-BEGIN
024100     END-IF.
024200*
024300     PERFORM B000-PROCESS-REPORT-RECORD
024400        THRU B999-PRR-EXIT.
024500*
024600     GO TO A910-PR-BEGIN.
024700*
024800 A999-PR-EXIT.
024900     EXIT.
025000/
025100 B000-PROCESS-REPORT-RECORD SECTION.
025200 B010-PRR-BEGIN.
025300*
025400     MOVE 'DUAL'                 TO MTRF-K2-O50-POSTAL-CODE.
025500     IF  MTRF-K1-RPT-NBR = 50
025600         PERFORM R500-REPORT-50
025700            THRU R509-R50-EXIT
025800         PERFORM P000-PRINT-THE-REPORTS
025900            THRU P999-PTR-EXIT
026000     END-IF.
026100*
026200 B999-PRR-EXIT.
026300     EXIT.
026400/
026500 R500-REPORT-50 SECTION.
026600 R501-R50-BEGIN.
026700*
026800*
026900     CALL MB00WS-MBD74050        USING MB22WS-LINK-DATA
027000                                       MTRF-RECORD.
027100*
027200 R509-R50-EXIT.
027300     EXIT.
027400/
027500 P000-PRINT-THE-REPORTS SECTION.
027600 P010-PTR-BEGIN.
027700*
027800     PERFORM MB22PD-DRIVER-PRINT-LINES
027900        THRU MB22PD-DPL-EXIT.
028000*
028100 P999-PTR-EXIT.
028200     EXIT.
028300/
028400 9000-PERFORMED-ROUTINES-SECT SECTION.
028500*
028600     COPY MB00PD REPLACING ==:MB00:== BY ==MTRF==.
028700/
028800     COPY MB20PD.
028900/
029000     COPY MB22PD1.
029100/
029200     COPY SS02PD.
029300/
029400     COPY SS07PD.
029500/
029600     COPY SS08PD.
029700/
029800     COPY SS16PD.
029900/
030000     COPY SS26PD.
030100/
030200     COPY SS27PD.
030300/
030400     COPY SS98PD.
030500*
030600 9995-END-SOURCE-STATEMENTS SECTION.
030700 9999-END-OF-PROGRAM.
030800     EXIT.
