000100 IDENTIFICATION DIVISION.
000200 PROGRAM-ID. MBO1S00.
000201*       RELEASE DATE=08/24/01.        REVISION LEVEL=08.06      *
000202*****************************************************************
000203*WARNING.  THIS COMPUTER PROGRAM IS PROTECTED BY COPYRIGHT LAW  *
000204*AND INTERNATIONAL TREATIES.  UNAUTHORIZED REPRODUCTION OR      *
000205*DISTRIBUTION OF THIS PROGRAM, OR ANY PORTION OF IT, MAY RESULT *
000206*IN SEVERE CIVIL AND CRIMINAL PENATLIES, AND WILL BE PROSECUTED *
000207*TO THE MAXIMUM EXTENT POSSIBLE UNDER THE LAW.                  *
000208*COPYRIGHT 1999 PAYSYS INTERNATIONAL, INC.  ALL RIGHTS RESERVED.*
000209*****************************************************************
000300*****************************************************************
000400*                                                               *
000500*   V - PLUS  M E R C H A N T   B A N K C A R D   S Y S T E M   *
000600*                                                               *
000700*      MBO1S00 - STORE CLOSE TO ACTIVE                          *
000800*                LOCATE SCREEN 00                               *
000900*                                                               *
001000*              1. TRANSID                                       *
001100*                 A. MB1S                                       *
001200*              2. MAPS USED -                                   *
001300*                 A. MB1S00 (LOCATE MAP)                        *
001400*              3. FILES USED -                                  *
001500*                 A. MMSM (STORE MASTER)                        *
001600*                 B. MMOC (ORG CONTROL RECORD)                  *
001700*                                                               *
001800*****************************************************************
001900*
002000 ENVIRONMENT DIVISION.
002100*
002200 DATA DIVISION.
002300*
002400 WORKING-STORAGE SECTION.
002500*
002600 01  FILLER                  PIC  X(12)      VALUE
002700     '** WS-BEG **'.
002800*
002900 01  FILLER                  PIC  X(14)      VALUE
003000     'MISCELLANEOUS:'.
003100*
003200 01  WS-MISCELLANEOUS.
003300     03  WS-ORG-LOW          PIC S9(03)      COMP-3
003400                                             VALUE +001.
003500     03  WS-ORG-HIGH         PIC S9(03)      COMP-3
003600                                             VALUE +998.
003700/
003800 01  FILLER                  PIC  X(29)      VALUE
003900     'I/O REQUEST BLOCK WORK AREAS:'.
004000*
004100     COPY MBIOWS.
004200/
004300 01  FILLER                  PIC  X(18)      VALUE
004400     'I/O REQUEST BLOCK:'.
004500*
004600     COPY MBIORO.
004700/
004800 01  FILLER                  PIC  X(21)      VALUE
004900     'ERROR MESSAGES TABLE:'.
005000*
005100     COPY MBEMWS.
005200/
005300 01  FILLER                  PIC  X(20)      VALUE
005400     'CCS DATE WORK AREAS:'.
005500*
005600     COPY SS01WS.
005700/
005800 01  FILLER                  PIC  X(27)      VALUE
005900     'CCS CHECK DIGIT WORK AREAS:'.
006000*
006100     COPY SS05WS.
006200/
006300 01  FILLER                  PIC  X(15)      VALUE
006400     'CCS WORK AREAS:'.
006500*
006600     COPY SS08WS.
006700/
006800     COPY SS00WS.
006900/
007000     COPY SMFTWS.
007100/
007200     COPY SMPTRL REPLACING ==:SMPT:== BY ==SMPT==.
007300/
007400     COPY MB61LK.
007500/
007600 01  FILLER                  PIC  X(12)      VALUE
007700     '** WS-END **'.
007800/
007900 LINKAGE SECTION.
008000*
008100 01  DFHCOMMAREA.
008200*
008300     COPY MB60WS.
008400/
008500********************************************
008600*    STORE CLOSE TO ACTIVE LOCATE MAP      *
008700********************************************
008800*
008900     COPY MB1S00.
009000/
009100*******************************************************
009200*    STORE CLOSE TO ACTIVE LOCATE MAP REDEFINITION *
009300*******************************************************
009400*
009500     COPY MB1S00R.
009600/
009700***************************
009800*    ORG RECORD LAYOUT    *
009900***************************
010000*
010100     COPY MMOCRL.
010200/
010300***************************************
010400*    STORE MASTER RECORD LAYOUT       *
010500***************************************
010600*
010700     COPY MMSMRL.
010800/
010900 PROCEDURE DIVISION.
011000*
011100 A000-HOUSEKEEPING SECTION.
011200*
011300 A020-INIT.
011400*
011500     MOVE 'PC01'                 TO MBCA-PROGRAM-LOCATION.
011600     PERFORM MB70PD-ON-LINE-HOUSEKEEPING
011700                                 THRU MB70PD-OLH-EXIT.
011800*
011900     IF  MBCA-RECEIVE-SCREEN
012000         GO TO C000-RECEIVE-SCREEN.
012100/
012200 B000-SEND-SCREEN SECTION.
012300*
012400*********************************************
012500*    GET CICS STORAGE NEEDED FOR THE MAP    *
012600*********************************************
012700*
012800     MOVE 'SC01'                 TO MBCA-PROGRAM-LOCATION.
012900     PERFORM MB60PD-GETMAIN-FOR-MAP
013000                                 THRU MB60PD-GFM-EXIT.
013100*
013200*
013300*****************************************************************
013400*    SEE IF THE MBCA-MERCHANT-ORG IS GREATER THAN ZERO. IF IT   *
013500*    IS, PLUG IT INTO THE MAP. THE THE MBCA-STORE IS GREATER    *
013600*    THAN ZERO, PLUG IT INTO THE MAP.                           *
013700*****************************************************************
013800*
013900     IF  MBCA-MMSM-KEY-CODE
014000         IF  MBCA-MERCHANT-ORG IS GREATER THAN ZERO
014100         AND MBCA-STORE        IS GREATER THAN ZERO
014200             MOVE MBCA-MERCHANT-ORG
014300                                 TO S100-ORG
014400             MOVE MBCA-STORE     TO S100-STORE
014500             MOVE DFHBMUNF       TO S100-ORG-A
014600                                    S100-STORE-A
014700             IF  MBCA-DIRECT-TRANSFER-CODE
014800             AND MBCA-INITIAL-SCREEN-NBR
014900                 MOVE 00         TO MBCA-SCREEN-NBR
015000                 GO TO C082-READ-ORG
015100             ELSE
015200                 GO TO B020-BUILD-SCREEN.
015300*
015400     IF  MBCA-VALID-KEY-CODES
015500         IF  MBCA-MERCHANT-ORG IS GREATER THAN ZERO
015600             MOVE MBCA-MERCHANT-ORG
015700                                 TO S100-ORG
015800             MOVE DFHBMUNF       TO S100-ORG-A
015900             IF  MBCA-STORE IS GREATER THAN ZERO
016000                 MOVE MBCA-STORE
016100                                 TO S100-STORE
016200                 MOVE DFHBMUNF   TO S100-STORE-A.
016300*
016400 B020-BUILD-SCREEN.
016500*
016600*******************************************
016700*    INITIALIZE THE STANDARD MAP LINES    *
016800*******************************************
016900*
017000     MOVE SS08WS-CURSOR          TO S100-ORG-L.
017100     MOVE 00                     TO MBCA-SCREEN-NBR.
017200     PERFORM MB60PD-INIT-STD-MAP-LINES
017300                                 THRU MB60PD-ISML-EXIT.
017400*
017500**********************
017600*    SEND THE MAP    *
017700**********************
017800*
017900     MOVE 'BM01'                 TO MBCA-PROGRAM-LOCATION.
018000     PERFORM MB60PD-SEND-MAP-WITH-ERASE
018100                                 THRU MB60PD-SMWE-EXIT.
018200*
018300************************
018400*    RETURN TO CICS    *
018500************************
018600*
018700     MOVE 'PC02'                 TO MBCA-PROGRAM-LOCATION.
018800     PERFORM MB70PD-RETURN-TRANS-ID
018900                                 THRU MB70PD-RTI-EXIT.
019000/
019100 C000-RECEIVE-SCREEN SECTION.
019200*
019300*************************************************
019400*    THIS SECTION RECEIVES THE LOCATE SCREEN    *
019500*************************************************
019600*
019700     MOVE 'BM02'                 TO MBCA-PROGRAM-LOCATION.
019800     PERFORM MB60PD-RECEIVE-MAP  THRU MB60PD-RM-EXIT.
019900*
020000**************************************************************
020100*    CHECK FOR ANOTHER TRANSACTION ID ENTERED BY THE USER    *
020200**************************************************************
020300*
020400     MOVE 'PC03'                 TO MBCA-PROGRAM-LOCATION.
020500     PERFORM MB60PD-NEW-TRANS-ROUTINE
020600                                 THRU MB60PD-NTR-EXIT.
020700*
020800 C020-FIELD-EDITS.
020900*
021000     MOVE MBCA-EIBAID            TO SS08WS-EIBAID.
021100*
021200     IF  (S100-ORG-L IS LESS THAN 1
021300     AND  S100-STORE-L IS LESS THAN 1)
021400     AND (SS08WS-VALID-PF-KEY
021500     OR   SS08WS-EIBAID-VALID-PF-KEY)
021600         SET MBCA-INITIAL-SCREEN-NBR
021700                                 TO TRUE
021800         GO TO F090-TRANSFER-XCTL.
021900*
022000******************************************************
022100*    RESET THE FIELD ATTRIBUTES TO THEIR NORMAL      *
022200*    PRIOR STATE PRIOR TO ANY EDITING BEING DONE.    *
022300******************************************************
022400*
022500     MOVE DFHBMUNN               TO S100-ORG-A
022600                                    S100-STORE-A.
022700     MOVE DFHBMASK               TO S100-ORG-LP-A
022800                                    S100-ORG-RP-A
022900                                    S100-STORE-LP-A
023000                                    S100-STORE-RP-A.
023100*
023200 C080-EDIT-ORG.
023300*
023400     IF  S100-ORG IS NOT NUMERIC
023500     OR  S100-ORG IS LESS THAN MBCA-ORG-LOW
023600     OR  S100-ORG IS GREATER THAN MBCA-ORG-HIGH
023700     OR  S100-ORG IS LESS THAN WS-ORG-LOW
023800     OR  S100-ORG IS GREATER THAN WS-ORG-HIGH
023900         MOVE MBEMWS-INVALID-ORG TO S100-ERR-MESSAGE
024000         GO TO C098-ORG-ERROR.
024100*
024200 C082-READ-ORG.
024300*
024400************************************************
024500*    READ THE ORGANIZATION RECORD.  IT MUST    *
024600*    BE ON FILE AND AN ACTIVE RECORD.          *
024700************************************************
024800*
024900     MOVE S100-ORG               TO MBIOWS-MMOC-ORG.
025000     MOVE 'FC01'                 TO MBCA-PROGRAM-LOCATION.
025100     MOVE SS08WS-CICS-FC-NOTFND  TO MBIORO-TEMP-STATUS-1.
025200     SET MBIORO-READ-RANDOM      TO TRUE.
025300     PERFORM MMOCAO-ACCESS       THRU MMOCAO-ACCESS-EXIT.
025400*
025500     IF  SS08WS-RC-FC-NOTFND
025600         MOVE MBEMWS-NOT-ON-FILE TO S100-ERR-MESSAGE
025700     ELSE
025800         IF  MMOC-ADD-PENDING
025900             MOVE MBEMWS-ADD-PENDING
026000                                 TO S100-ERR-MESSAGE
026100         ELSE
026200             IF  MMOC-REC-PURGED
026300                 MOVE MBEMWS-NOT-ACTIVE
026400                                 TO S100-ERR-MESSAGE
026500             ELSE
026600                 MOVE DFHBMUNF   TO S100-ORG-A
026700                 MOVE S100-ORG   TO MBCA-MERCHANT-ORG
026800                 MOVE MMOC-CURRENCY-CODE
026900                                 TO MBCA-CURRENCY-CODE
027000                 GO TO C100-EDIT-STORE.
027100*
027200 C098-ORG-ERROR.
027300*
027400     SET SS08WS-ERROR-SW-YES     TO TRUE.
027500     MOVE DFHBMASB               TO S100-ORG-LP-A
027600                                    S100-ORG-RP-A.
027700     MOVE SS08WS-CURSOR          TO S100-ORG-L.
027800     MOVE DFHBMNBF               TO S100-ORG-A.
027900     MOVE DFHBMUNF               TO S100-STORE-A.
028000     GO TO D000-RETURN-ERRORS.
028100*
028200 C100-EDIT-STORE.
028300*
028400     IF  S100-STORE IS NOT NUMERIC
028500     OR  S100-STORE IS EQUAL TO ZEROES OR 999999999
028600         MOVE MBEMWS-INVALID-STORE
028700                                 TO S100-ERR-MESSAGE
028800         GO TO C118-STORE-ERROR.
028900*
029000 C102-READ-STORE.
029100*
029200***************************************************************
029300*    READ THE STORE MASTER RECORD.     IT MUST BE ON          *
029400*    FILE AND AN ACTIVE OR CLOSED RECORD.                     *
029500***************************************************************
029600*
029700     MOVE DFHBMUNF               TO S100-STORE-A.
029800*
029900     MOVE S100-ORG               TO MBIOWS-MMSM-ORG.
030000     MOVE S100-STORE             TO MBIOWS-MMSM-STORE.
030100     MOVE SS08WS-CICS-FC-NOTFND  TO MBIORO-TEMP-STATUS-1.
030200     MOVE 'FC02'                 TO MBCA-PROGRAM-LOCATION.
030300     SET MBIORO-READ-RANDOM      TO TRUE.
030400     PERFORM MMSMAO-ACCESS       THRU MMSMAO-ACCESS-EXIT.
030500*
030600     IF  SS08WS-RC-FC-VALID-RTN-CODE
030700         MOVE S100-STORE         TO MBCA-STORE.
030800*
030900     IF  SS08WS-RC-FC-NOTFND
031000         MOVE MBEMWS-NOT-ON-FILE TO S100-ERR-MESSAGE
031100         GO TO C118-STORE-ERROR.
031200*
031300     IF  MMSM-REC-SINGLE-STORE
031400         MOVE MBEMWS-SINGLE-STORE
031500                                 TO S100-ERR-MESSAGE
031600         GO TO C118-STORE-ERROR.
031700*
031800     IF  MMSM-REC-CLOSED
031900         NEXT SENTENCE
032000     ELSE
032100         MOVE MBEMWS-BAD-REC-STATUS
032200                                 TO S100-ERR-MESSAGE
032300         GO TO C118-STORE-ERROR.
032400*
032500************************************************
032600*    OTHERWISE, WE PASSED THE STORE EDIT       *
032700************************************************
032800*
032900     GO TO D000-RETURN-ERRORS.
033000*
033100 C118-STORE-ERROR.
033200*
033300     SET SS08WS-ERROR-SW-YES     TO TRUE.
033400     MOVE DFHBMASB               TO S100-STORE-LP-A
033500                                    S100-STORE-RP-A.
033600     MOVE SS08WS-CURSOR          TO S100-STORE-L.
033700     MOVE DFHBMNBF               TO S100-STORE-A.
033800/
033900 D000-RETURN-ERRORS SECTION.
034000*
034100     IF  SS08WS-ERROR-SW-NO
034200         GO TO F000-SETUP-COMMAREA
034300     ELSE
034400         IF  SS08WS-VALID-PF-KEY
034500         OR  SS08WS-EIBAID-VALID-PF-KEY
034600             SET MBCA-INITIAL-SCREEN-NBR
034700                                 TO TRUE
034800             GO TO F090-TRANSFER-XCTL.
034900*
035000***************************************************************
035100*    INITIALIZE THE STANDARD MAP LINES.  IN AN ERROR          *
035200*    CONDITION, THIS ROUTINE IS PERFORMED PRIMARILY           *
035300*    TO UPDATE THE DATE AND TIME ON THE SCREEN.               *
035400***************************************************************
035500*
035600     PERFORM MB60PD-INIT-STD-MAP-LINES
035700                                 THRU MB60PD-ISML-EXIT.
035800*
035900**********************
036000*    SEND THE MAP    *
036100**********************
036200*
036300     MOVE 'BM03'                 TO MBCA-PROGRAM-LOCATION.
036400     PERFORM MB60PD-SEND-MAP-WITH-ERASE
036500                                 THRU MB60PD-SMWE-EXIT.
036600*
036700************************
036800*    RETURN TO CICS    *
036900************************
037000*
037100     MOVE 'PC04'                 TO MBCA-PROGRAM-LOCATION.
037200     PERFORM MB70PD-RETURN-TRANS-ID
037300                                 THRU MB70PD-RTI-EXIT.
037400/
037500 F000-SETUP-COMMAREA SECTION.
037600*
037700***************************************************************
037800*  SET UP COMMAREA FIELDS AND TRANSFER TO THE NEXT PROGRAM    *
037900***************************************************************
038000*
038100     MOVE MBCA-EIBAID            TO SS08WS-EIBAID.
038200*
038300     MOVE MBIOWS-MMSM-DIRECT-KEY-CODE
038400                                 TO MBCA-KEY-CODE.
038500*
038600     PERFORM MB60PD-EDIT-PAGE-NBR
038700                                 THRU MB60PD-EPN-EXIT.
038800*
038900     IF  SS08WS-VALID-PF-KEY
039000     OR  SS08WS-EIBAID-VALID-PF-KEY
039100         SET MBCA-INITIAL-SCREEN-NBR
039200                                 TO TRUE.
039300*
039400 F090-TRANSFER-XCTL.
039500*
039600     MOVE 'PC05'                 TO MBCA-PROGRAM-LOCATION.
039700     PERFORM MB70PD-XCTL-TO-MBOXCTL
039800                                 THRU MB70PD-XTM-EXIT.
039900/
040000 Z000-COPIED-ROUTINES SECTION.
040100**********************************
040200*    JUL TO GREG DATE ROUTINE    *
040300**********************************
040400*
040500     COPY SS08PD.
040600/
040700     COPY SS26PD.
040800/
040900     COPY SS27PD.
041000/
041100*****************************
041200*    CHECK DIGIT ROUITNE    *
041300*****************************
041400*
041500     COPY SS09PD.
041600/
041700*********************************
041800*    LINE 24 PF KEYS ROUTINE    *
041900*********************************
042000*
042100     COPY SS15PD.
042200/
042300*******************************************
042400*    ORG FILE RECORD 1 ACCESS ROUTINES    *
042500*******************************************
042600*
042700     COPY MMOCAO.
042800/
042900*********************************************
043000*    STORE MASTER RECORD ACCESS ROUTINES *
043100*********************************************
043200*
043300     COPY MMSMAO.
043400/
043500*****************************
043600*    ONLINE MAP ROUTINES    *
043700*****************************
043800*
043900     COPY MB60PD REPLACING 'MBMAPXX' BY 'MB1S00 '
044000                           MBMAPXXI BY MB1S00I
044100                           MBMAPXXO BY MB1S00O.
044200/
044300***************************
044400*    ONLINE PROCEDURES    *
044500***************************
044600*
044700     COPY MB70PD.
044800/
044900     COPY SMFTPXO.
