000100 IDENTIFICATION DIVISION.
000200 PROGRAM-ID. MBO3M00.
000201*       RELEASE DATE=08/24/01.        REVISION LEVEL=08.06      *
000202*****************************************************************
000203*WARNING.  THIS COMPUTER PROGRAM IS PROTECTED BY COPYRIGHT LAW  *
000204*AND INTERNATIONAL TREATIES.  UNAUTHORIZED REPRODUCTION OR      *
000205*DISTRIBUTION OF THIS PROGRAM, OR ANY PORTION OF IT, MAY RESULT *
000206*IN SEVERE CIVIL AND CRIMINAL PENATLIES, AND WILL BE PROSECUTED *
000207*TO THE MAXIMUM EXTENT POSSIBLE UNDER THE LAW.                  *
000208*COPYRIGHT 1999 PAYSYS INTERNATIONAL, INC.  ALL RIGHTS RESERVED.*
000209*****************************************************************
000300*****************************************************************
000400*                                                               *
000500*   V - PLUS  M E R C H A N T   B A N K C A R D   S Y S T E M   *
000600*                                                               *
000700*      MBO3M00 - MERCHANT MODEL PURGE                           *
000800*                LOCATE SCREEN 00                               *
000900*                                                               *
001000*              1. TRANSID                                       *
001100*                 A. MB3M                                       *
001200*              2. MAPS USED -                                   *
001300*                 A. MB3M00 (LOCATE MAP)                        *
001400*              3. FILES USED -                                  *
001500*                 A. MMMM (MERCHANT MASTER)                     *
001600*                 B. MMOC (ORG CONTROL RECORD)                  *
001700*                                                               *
001800*****************************************************************
001900*
002000 ENVIRONMENT DIVISION.
002100*
002200 DATA DIVISION.
002300*
002400 WORKING-STORAGE SECTION.
002500*
002600 01  FILLER                  PIC  X(12)      VALUE
002700     '** WS-BEG **'.
002800*
002900 01  FILLER                  PIC  X(14)      VALUE
003000     'MISCELLANEOUS:'.
003100*
003200 01  WS-MISCELLANEOUS.
003300     03  WS-ORG-LOW          PIC S9(03)      COMP-3
003400                                             VALUE +001.
003500     03  WS-ORG-HIGH         PIC S9(03)      COMP-3
003600                                             VALUE +998.
003700/
003800 01  FILLER                  PIC  X(29)      VALUE
003900     'I/O REQUEST BLOCK WORK AREAS:'.
004000*
004100     COPY MBIOWS.
004200/
004300 01  FILLER                  PIC  X(18)      VALUE
004400     'I/O REQUEST BLOCK:'.
004500*
004600     COPY MBIORO.
004700/
004800 01  FILLER                  PIC  X(21)      VALUE
004900     'ERROR MESSAGES TABLE:'.
005000*
005100     COPY MBEMWS.
005200/
005300 01  FILLER                  PIC  X(27)      VALUE
005400     'MERCHANT MASTER WORK AREAS:'.
005500*
005600     COPY MMMMWS.
005700/
005800 01  FILLER                  PIC  X(20)      VALUE
005900     'CCS DATE WORK AREAS:'.
006000*
006100     COPY SS01WS.
006200/
006300 01  FILLER                  PIC  X(27)      VALUE
006400     'CCS CHECK DIGIT WORK AREAS:'.
006500*
006600     COPY SS05WS.
006700/
006800 01  FILLER                  PIC  X(15)      VALUE
006900     'CCS WORK AREAS:'.
007000*
007100     COPY SS08WS.
007200/
007300     COPY SS00WS.
007400/
007500     COPY SMFTWS.
007600/
007700     COPY SMPTRL REPLACING ==:SMPT:== BY ==SMPT==.
007800/
007900     COPY MB61LK.
008000/
008100 01  FILLER                  PIC  X(12)      VALUE
008200     '** WS-END **'.
008300/
008400 LINKAGE SECTION.
008500*
008600 01  DFHCOMMAREA.
008700*
008800     COPY MB60WS.
008900/
009000**************************************************
009100*    MERCHANT MODEL PURGE TO ACTIVE LOCATE MAP   *
009200**************************************************
009300*
009400     COPY MB3M00.
009500/
009600*******************************************************
009700*    MERCHANT MODEL PURGE LOCATE MAP REDEFINITION     *
009800*******************************************************
009900*
010000     COPY MB3M00R.
010100/
010200***************************
010300*    ORG RECORD LAYOUT    *
010400***************************
010500*
010600     COPY MMOCRL.
010700/
010800***************************************
010900*    MERCHANT MASTER RECORD LAYOUT    *
011000***************************************
011100*
011200     COPY MMMMRL.
011300/
011400 PROCEDURE DIVISION.
011500*
011600 A000-HOUSEKEEPING SECTION.
011700*
011800 A020-INIT.
011900*
012000     MOVE 'PC01'                 TO MBCA-PROGRAM-LOCATION.
012100     PERFORM MB70PD-ON-LINE-HOUSEKEEPING
012200                                 THRU MB70PD-OLH-EXIT.
012300*
012400     IF  MBCA-RECEIVE-SCREEN
012500         GO TO C000-RECEIVE-SCREEN.
012600/
012700 B000-SEND-SCREEN SECTION.
012800*
012900*********************************************
013000*    GET CICS STORAGE NEEDED FOR THE MAP    *
013100*********************************************
013200*
013300     MOVE 'SC01'                 TO MBCA-PROGRAM-LOCATION.
013400     PERFORM MB60PD-GETMAIN-FOR-MAP
013500                                 THRU MB60PD-GFM-EXIT.
013600*
013700*
013800*****************************************************************
013900*    SEE IF THE MBCA-MERCHANT-ORG IS GREATER THAN ZERO. IF IT   *
014000*    IS, PLUG IT INTO THE MAP. THE THE MBCA-MERCHANT IS GREATER *
014100*    THAN ZERO, PLUG IT INTO THE MAP.                           *
014200*****************************************************************
014300*
014400     IF  MBCA-MMMM-KEY-CODE
014500         IF  MBCA-MERCHANT-ORG IS GREATER THAN ZERO
014600         AND MBCA-MERCHANT     IS GREATER THAN ZERO
014700             MOVE MBCA-MERCHANT-ORG
014800                                 TO M300-ORG
014900             MOVE MBCA-MERCHANT  TO M300-MERCHANT
015000             MOVE DFHBMUNF       TO M300-ORG-A
015100                                    M300-MERCHANT-A
015200             IF  MBCA-DIRECT-TRANSFER-CODE
015300             AND MBCA-INITIAL-SCREEN-NBR
015400                 MOVE 00         TO MBCA-SCREEN-NBR
015500                 GO TO C082-READ-ORG
015600             ELSE
015700                 GO TO B020-BUILD-SCREEN.
015800*
015900     IF  MBCA-VALID-KEY-CODES
016000         IF  MBCA-MERCHANT-ORG IS GREATER THAN ZERO
016100             MOVE MBCA-MERCHANT-ORG
016200                                 TO M300-ORG
016300             MOVE DFHBMUNF       TO M300-ORG-A
016400             IF  MBCA-MERCHANT IS GREATER THAN ZERO
016500                 MOVE MBCA-MERCHANT
016600                                 TO M300-MERCHANT
016700                 MOVE DFHBMUNF   TO M300-MERCHANT-A.
016800*
016900 B020-BUILD-SCREEN.
017000*
017100*******************************************
017200*    INITIALIZE THE STANDARD MAP LINES    *
017300*******************************************
017400*
017500     MOVE SS08WS-CURSOR          TO M300-ORG-L.
017600     MOVE 00                     TO MBCA-SCREEN-NBR.
017700     PERFORM MB60PD-INIT-STD-MAP-LINES
017800                                 THRU MB60PD-ISML-EXIT.
017900*
018000**********************
018100*    SEND THE MAP    *
018200**********************
018300*
018400     MOVE 'BM01'                 TO MBCA-PROGRAM-LOCATION.
018500     PERFORM MB60PD-SEND-MAP-WITH-ERASE
018600                                 THRU MB60PD-SMWE-EXIT.
018700*
018800************************
018900*    RETURN TO CICS    *
019000************************
019100*
019200     MOVE 'PC02'                 TO MBCA-PROGRAM-LOCATION.
019300     PERFORM MB70PD-RETURN-TRANS-ID
019400                                 THRU MB70PD-RTI-EXIT.
019500/
019600 C000-RECEIVE-SCREEN SECTION.
019700*
019800*************************************************
019900*    THIS SECTION RECEIVES THE LOCATE SCREEN    *
020000*************************************************
020100*
020200     MOVE 'BM02'                 TO MBCA-PROGRAM-LOCATION.
020300     PERFORM MB60PD-RECEIVE-MAP  THRU MB60PD-RM-EXIT.
020400*
020500**************************************************************
020600*    CHECK FOR ANOTHER TRANSACTION ID ENTERED BY THE USER    *
020700**************************************************************
020800*
020900     MOVE 'PC03'                 TO MBCA-PROGRAM-LOCATION.
021000     PERFORM MB60PD-NEW-TRANS-ROUTINE
021100                                 THRU MB60PD-NTR-EXIT.
021200*
021300 C020-FIELD-EDITS.
021400*
021500     MOVE MBCA-EIBAID            TO SS08WS-EIBAID.
021600*
021700     IF  (M300-ORG-L IS LESS THAN 1
021800     AND  M300-MERCHANT-L IS LESS THAN 1)
021900     AND (SS08WS-VALID-PF-KEY
022000     OR   SS08WS-EIBAID-VALID-PF-KEY)
022100         SET MBCA-INITIAL-SCREEN-NBR
022200                                 TO TRUE
022300         GO TO F090-TRANSFER-XCTL.
022400*
022500******************************************************
022600*    RESET THE FIELD ATTRIBUTES TO THEIR NORMAL      *
022700*    PRIOR STATE PRIOR TO ANY EDITING BEING DONE.    *
022800******************************************************
022900*
023000     MOVE DFHBMUNN               TO M300-ORG-A
023100                                    M300-MERCHANT-A.
023200     MOVE DFHBMASK               TO M300-ORG-LP-A
023300                                    M300-ORG-RP-A
023400                                    M300-MERCHANT-LP-A
023500                                    M300-MERCHANT-RP-A.
023600*
023700 C080-EDIT-ORG.
023800*
023900     IF  M300-ORG IS NOT NUMERIC
024000     OR  M300-ORG IS LESS THAN MBCA-ORG-LOW
024100     OR  M300-ORG IS GREATER THAN MBCA-ORG-HIGH
024200     OR  M300-ORG IS LESS THAN WS-ORG-LOW
024300     OR  M300-ORG IS GREATER THAN WS-ORG-HIGH
024400         MOVE MBEMWS-INVALID-ORG TO M300-ERR-MESSAGE
024500         GO TO C098-ORG-ERROR.
024600*
024700 C082-READ-ORG.
024800*
024900************************************************
025000*    READ THE ORGANIZATION RECORD.  IT MUST    *
025100*    BE ON FILE AND AN ACTIVE RECORD.          *
025200************************************************
025300*
025400     MOVE M300-ORG               TO MBIOWS-MMOC-ORG.
025500     MOVE 'FC01'                 TO MBCA-PROGRAM-LOCATION.
025600     MOVE SS08WS-CICS-FC-NOTFND  TO MBIORO-TEMP-STATUS-1.
025700     SET MBIORO-READ-RANDOM      TO TRUE.
025800     PERFORM MMOCAO-ACCESS       THRU MMOCAO-ACCESS-EXIT.
025900*
026000     IF  SS08WS-RC-FC-NOTFND
026100         MOVE MBEMWS-NOT-ON-FILE TO M300-ERR-MESSAGE
026200     ELSE
026300         IF  MMOC-ADD-PENDING
026400             MOVE MBEMWS-ADD-PENDING
026500                                 TO M300-ERR-MESSAGE
026600         ELSE
026700             IF  MMOC-REC-PURGED
026800                 MOVE MBEMWS-NOT-ACTIVE
026900                                 TO M300-ERR-MESSAGE
027000             ELSE
027100                 MOVE DFHBMUNF   TO M300-ORG-A
027200                 MOVE M300-ORG   TO MBCA-MERCHANT-ORG
027300                 MOVE MMOC-CURRENCY-CODE
027400                                 TO MBCA-CURRENCY-CODE
027500                 GO TO C100-EDIT-MERCHANT.
027600*
027700 C098-ORG-ERROR.
027800*
027900     SET SS08WS-ERROR-SW-YES     TO TRUE.
028000     MOVE DFHBMASB               TO M300-ORG-LP-A
028100                                    M300-ORG-RP-A.
028200     MOVE SS08WS-CURSOR          TO M300-ORG-L.
028300     MOVE DFHBMNBF               TO M300-ORG-A.
028400     MOVE DFHBMUNF               TO M300-MERCHANT-A.
028500     GO TO D000-RETURN-ERRORS.
028600*
028700 C100-EDIT-MERCHANT.
028800*
028900     IF  M300-MERCHANT IS NOT NUMERIC
029000     OR  M300-MERCHANT IS EQUAL TO ZEROES OR 999999999
029100         MOVE MBEMWS-INVALID-MERCHANT
029200                                 TO M300-ERR-MESSAGE
029300         GO TO C118-MERCHANT-ERROR.
029400*
029500 C102-READ-MERCHANT.
029600*
029700***************************************************************
029800*    READ THE MERCHANT MASTER RECORD.  IT MUST BE ON          *
029900*    FILE AND AN ACTIVE OR CLOSED RECORD.                     *
030000***************************************************************
030100*
030200     MOVE DFHBMUNF               TO M300-MERCHANT-A.
030300*
030400     MOVE M300-ORG               TO MBIOWS-MMMM-ORG.
030500     MOVE M300-MERCHANT          TO MBIOWS-MMMM-MERCHANT.
030600     MOVE SS08WS-CICS-FC-NOTFND  TO MBIORO-TEMP-STATUS-1.
030700     MOVE 'FC02'                 TO MBCA-PROGRAM-LOCATION.
030800     SET MBIORO-READ-RANDOM      TO TRUE.
030900     PERFORM MMMMAO-ACCESS       THRU MMMMAO-ACCESS-EXIT.
031000*
031100     IF  SS08WS-RC-FC-VALID-RTN-CODE
031200         MOVE M300-MERCHANT      TO MBCA-MERCHANT.
031300*
031400     IF  SS08WS-RC-FC-NOTFND
031500         MOVE MBEMWS-NOT-ON-FILE TO M300-ERR-MESSAGE
031600         GO TO C118-MERCHANT-ERROR.
031700*
031800     IF  MMMM-REC-MODEL
031900         NEXT SENTENCE
032000     ELSE
032100         MOVE MBEMWS-BAD-REC-STATUS
032200                                 TO M300-ERR-MESSAGE
032300         GO TO C118-MERCHANT-ERROR.
032400*
032500************************************************
032600*    OTHERWISE, WE PASSED THE MERCHANT EDIT    *
032700************************************************
032800*
032900     GO TO D000-RETURN-ERRORS.
033000*
033100 C118-MERCHANT-ERROR.
033200*
033300     SET SS08WS-ERROR-SW-YES     TO TRUE.
033400     MOVE DFHBMASB               TO M300-MERCHANT-LP-A
033500                                    M300-MERCHANT-RP-A.
033600     MOVE SS08WS-CURSOR          TO M300-MERCHANT-L.
033700     MOVE DFHBMNBF               TO M300-MERCHANT-A.
033800/
033900 D000-RETURN-ERRORS SECTION.
034000*
034100     IF  SS08WS-ERROR-SW-NO
034200         GO TO F000-SETUP-COMMAREA
034300     ELSE
034400         IF  SS08WS-VALID-PF-KEY
034500         OR  SS08WS-EIBAID-VALID-PF-KEY
034600             SET MBCA-INITIAL-SCREEN-NBR
034700                                 TO TRUE
034800             GO TO F090-TRANSFER-XCTL.
034900*
035000***************************************************************
035100*    INITIALIZE THE STANDARD MAP LINES.  IN AN ERROR          *
035200*    CONDITION, THIS ROUTINE IS PERFORMED PRIMARILY           *
035300*    TO UPDATE THE DATE AND TIME ON THE SCREEN.               *
035400***************************************************************
035500*
035600     PERFORM MB60PD-INIT-STD-MAP-LINES
035700                                 THRU MB60PD-ISML-EXIT.
035800*
035900**********************
036000*    SEND THE MAP    *
036100**********************
036200*
036300     MOVE 'BM03'                 TO MBCA-PROGRAM-LOCATION.
036400     PERFORM MB60PD-SEND-MAP-WITH-ERASE
036500                                 THRU MB60PD-SMWE-EXIT.
036600*
036700************************
036800*    RETURN TO CICS    *
036900************************
037000*
037100     MOVE 'PC04'                 TO MBCA-PROGRAM-LOCATION.
037200     PERFORM MB70PD-RETURN-TRANS-ID
037300                                 THRU MB70PD-RTI-EXIT.
037400/
037500 F000-SETUP-COMMAREA SECTION.
037600*
037700***************************************************************
037800*  SET UP COMMAREA FIELDS AND TRANSFER TO THE NEXT PROGRAM    *
037900***************************************************************
038000*
038100     MOVE MBCA-EIBAID            TO SS08WS-EIBAID.
038200*
038300     MOVE MBIOWS-MMMM-DIRECT-KEY-CODE
038400                                 TO MBCA-KEY-CODE.
038500*
038600     PERFORM MB60PD-EDIT-PAGE-NBR
038700                                 THRU MB60PD-EPN-EXIT.
038800*
038900     IF  SS08WS-VALID-PF-KEY
039000     OR  SS08WS-EIBAID-VALID-PF-KEY
039100         SET MBCA-INITIAL-SCREEN-NBR
039200                                 TO TRUE.
039300*
039400 F090-TRANSFER-XCTL.
039500*
039600     MOVE 'PC05'                 TO MBCA-PROGRAM-LOCATION.
039700     PERFORM MB70PD-XCTL-TO-MBOXCTL
039800                                 THRU MB70PD-XTM-EXIT.
039900/
040000 Z000-COPIED-ROUTINES SECTION.
040100**********************************
040200*    JUL TO GREG DATE ROUTINE    *
040300**********************************
040400*
040500     COPY SS08PD.
040600/
040700     COPY SS26PD.
040800/
040900     COPY SS27PD.
041000/
041100*****************************
041200*    CHECK DIGIT ROUITNE    *
041300*****************************
041400*
041500     COPY SS09PD.
041600/
041700*********************************
041800*    LINE 24 PF KEYS ROUTINE    *
041900*********************************
042000*
042100     COPY SS15PD.
042200/
042300*******************************************
042400*    ORG FILE RECORD 1 ACCESS ROUTINES    *
042500*******************************************
042600*
042700     COPY MMOCAO.
042800/
042900*********************************************
043000*    MERCHANT MASTER RECORD ACCESS ROUTINES *
043100*********************************************
043200*
043300     COPY MMMMAO.
043400/
043500*****************************
043600*    ONLINE MAP ROUTINES    *
043700*****************************
043800*
043900     COPY MB60PD REPLACING 'MBMAPXX' BY 'MB3M00 '
044000                           MBMAPXXI BY MB3M00I
044100                           MBMAPXXO BY MB3M00O.
044200/
044300***************************
044400*    ONLINE PROCEDURES    *
044500***************************
044600*
044700     COPY MB70PD.
044800/
044900     COPY SMFTPXO.
