000100 IDENTIFICATION DIVISION.
000200 PROGRAM-ID. MBO3S00.
000201*       RELEASE DATE=08/24/01.        REVISION LEVEL=08.06      *
000202*****************************************************************
000203*WARNING.  THIS COMPUTER PROGRAM IS PROTECTED BY COPYRIGHT LAW  *
000204*AND INTERNATIONAL TREATIES.  UNAUTHORIZED REPRODUCTION OR      *
000205*DISTRIBUTION OF THIS PROGRAM, OR ANY PORTION OF IT, MAY RESULT *
000206*IN SEVERE CIVIL AND CRIMINAL PENATLIES, AND WILL BE PROSECUTED *
000207*TO THE MAXIMUM EXTENT POSSIBLE UNDER THE LAW.                  *
000208*COPYRIGHT 1999 PAYSYS INTERNATIONAL, INC.  ALL RIGHTS RESERVED.*
000209*****************************************************************
000300*****************************************************************
000400*                                                               *
000500*   V - PLUS  M E R C H A N T   B A N K C A R D   S Y S T E M   *
000600*                                                               *
000700*      MBO3S00 - STORE MODEL PURGE                              *
000800*                LOCATE SCREEN 00                               *
000900*                                                               *
001000*              1. TRANSID                                       *
001100*                 A. MB3S                                       *
001200*              2. MAPS USED -                                   *
001300*                 A. MB3S00 (LOCATE MAP)                        *
001400*              3. FILES USED -                                  *
001500*                 A. MMSM (STORE MASTER)                        *
001600*                 B. MMOC (ORG CONTROL RECORD)                  *
001700*                                                               *
001800*****************************************************************
001900*
002000 ENVIRONMENT DIVISION.
002100*
002200 DATA DIVISION.
002300*
002400 WORKING-STORAGE SECTION.
002500*
002600 01  FILLER                  PIC  X(12)      VALUE
002700     '** WS-BEG **'.
002800*
002900 01  FILLER                  PIC  X(14)      VALUE
003000     'MISCELLANEOUS:'.
003100*
003200 01  WS-MISCELLANEOUS.
003300     03  WS-ORG-LOW          PIC S9(03)      COMP-3
003400                                             VALUE +001.
003500     03  WS-ORG-HIGH         PIC S9(03)      COMP-3
003600                                             VALUE +998.
003700/
003800 01  FILLER                  PIC  X(29)      VALUE
003900     'I/O REQUEST BLOCK WORK AREAS:'.
004000*
004100     COPY MBIOWS.
004200/
004300 01  FILLER                  PIC  X(18)      VALUE
004400     'I/O REQUEST BLOCK:'.
004500*
004600     COPY MBIORO.
004700/
004800 01  FILLER                  PIC  X(21)      VALUE
004900     'ERROR MESSAGES TABLE:'.
005000*
005100     COPY MBEMWS.
005200/
005300 01  FILLER                  PIC  X(27)      VALUE
005400     'STORE MASTER WORK AREAS:'.
005500*
005600     COPY MMSMWS.
005700/
005800 01  FILLER                  PIC  X(20)      VALUE
005900     'CCS DATE WORK AREAS:'.
006000*
006100     COPY SS01WS.
006200/
006300 01  FILLER                  PIC  X(27)      VALUE
006400     'CCS CHECK DIGIT WORK AREAS:'.
006500*
006600     COPY SS05WS.
006700/
006800 01  FILLER                  PIC  X(15)      VALUE
006900     'CCS WORK AREAS:'.
007000*
007100     COPY SS08WS.
007200/
007300     COPY SS00WS.
007400/
007500     COPY SMFTWS.
007600/
007700     COPY SMPTRL REPLACING ==:SMPT:== BY ==SMPT==.
007800/
007900     COPY MB61LK.
008000/
008100 01  FILLER                  PIC  X(12)      VALUE
008200     '** WS-END **'.
008300/
008400 LINKAGE SECTION.
008500*
008600 01  DFHCOMMAREA.
008700*
008800     COPY MB60WS.
008900****************************************
009000*    STORE MODEL PURGE LOCATE MAP      *
009100****************************************
009200*
009300     COPY MB3S00.
009400/
009500*******************************************************
009600*    STORE MODEL PURGE LOCATE MAP REDEFINITION        *
009700*******************************************************
009800*
009900     COPY MB3S00R.
010000/
010100***************************
010200*    ORG RECORD LAYOUT    *
010300***************************
010400*
010500     COPY MMOCRL.
010600/
010700***************************************
010800*    STORE MASTER RECORD LAYOUT       *
010900***************************************
011000*
011100     COPY MMSMRL.
011200/
011300 PROCEDURE DIVISION.
011400*
011500 A000-HOUSEKEEPING SECTION.
011600*
011700 A020-INIT.
011800*
011900     MOVE 'PC01'                 TO MBCA-PROGRAM-LOCATION.
012000     PERFORM MB70PD-ON-LINE-HOUSEKEEPING
012100                                 THRU MB70PD-OLH-EXIT.
012200*
012300     IF  MBCA-RECEIVE-SCREEN
012400         GO TO C000-RECEIVE-SCREEN.
012500/
012600 B000-SEND-SCREEN SECTION.
012700*
012800*********************************************
012900*    GET CICS STORAGE NEEDED FOR THE MAP    *
013000*********************************************
013100*
013200     MOVE 'SC01'                 TO MBCA-PROGRAM-LOCATION.
013300     PERFORM MB60PD-GETMAIN-FOR-MAP
013400                                 THRU MB60PD-GFM-EXIT.
013500*
013600*
013700*****************************************************************
013800*    SEE IF THE MBCA-MERCHANT-ORG IS GREATER THAN ZERO. IF IT   *
013900*    IS, PLUG IT INTO THE MAP. THE THE MBCA-STORE IS GREATER    *
014000*    THAN ZERO, PLUG IT INTO THE MAP.                           *
014100*****************************************************************
014200*
014300     IF  MBCA-MMSM-KEY-CODE
014400         IF  MBCA-MERCHANT-ORG IS GREATER THAN ZERO
014500         AND MBCA-STORE        IS GREATER THAN ZERO
014600             MOVE MBCA-MERCHANT-ORG
014700                                 TO S300-ORG
014800             MOVE MBCA-STORE     TO S300-STORE
014900             MOVE DFHBMUNF       TO S300-ORG-A
015000                                    S300-STORE-A
015100             IF  MBCA-DIRECT-TRANSFER-CODE
015200             AND MBCA-INITIAL-SCREEN-NBR
015300                 MOVE 00         TO MBCA-SCREEN-NBR
015400                 GO TO C082-READ-ORG
015500             ELSE
015600                 GO TO B020-BUILD-SCREEN.
015700*
015800     IF  MBCA-VALID-KEY-CODES
015900         IF  MBCA-MERCHANT-ORG IS GREATER THAN ZERO
016000             MOVE MBCA-MERCHANT-ORG
016100                                 TO S300-ORG
016200             MOVE DFHBMUNF       TO S300-ORG-A
016300             IF  MBCA-STORE IS GREATER THAN ZERO
016400                 MOVE MBCA-STORE
016500                                 TO S300-STORE
016600                 MOVE DFHBMUNF   TO S300-STORE-A.
016700*
016800 B020-BUILD-SCREEN.
016900*
017000*******************************************
017100*    INITIALIZE THE STANDARD MAP LINES    *
017200*******************************************
017300*
017400     MOVE SS08WS-CURSOR          TO S300-ORG-L.
017500     MOVE 00                     TO MBCA-SCREEN-NBR.
017600     PERFORM MB60PD-INIT-STD-MAP-LINES
017700                                 THRU MB60PD-ISML-EXIT.
017800*
017900**********************
018000*    SEND THE MAP    *
018100**********************
018200*
018300     MOVE 'BM01'                 TO MBCA-PROGRAM-LOCATION.
018400     PERFORM MB60PD-SEND-MAP-WITH-ERASE
018500                                 THRU MB60PD-SMWE-EXIT.
018600*
018700************************
018800*    RETURN TO CICS    *
018900************************
019000*
019100     MOVE 'PC02'                 TO MBCA-PROGRAM-LOCATION.
019200     PERFORM MB70PD-RETURN-TRANS-ID
019300                                 THRU MB70PD-RTI-EXIT.
019400/
019500 C000-RECEIVE-SCREEN SECTION.
019600*
019700*************************************************
019800*    THIS SECTION RECEIVES THE LOCATE SCREEN    *
019900*************************************************
020000*
020100     MOVE 'BM02'                 TO MBCA-PROGRAM-LOCATION.
020200     PERFORM MB60PD-RECEIVE-MAP  THRU MB60PD-RM-EXIT.
020300*
020400**************************************************************
020500*    CHECK FOR ANOTHER TRANSACTION ID ENTERED BY THE USER    *
020600**************************************************************
020700*
020800     MOVE 'PC03'                 TO MBCA-PROGRAM-LOCATION.
020900     PERFORM MB60PD-NEW-TRANS-ROUTINE
021000                                 THRU MB60PD-NTR-EXIT.
021100*
021200 C020-FIELD-EDITS.
021300*
021400     MOVE MBCA-EIBAID            TO SS08WS-EIBAID.
021500*
021600     IF  (S300-ORG-L IS LESS THAN 1
021700     AND  S300-STORE-L IS LESS THAN 1)
021800     AND (SS08WS-VALID-PF-KEY
021900     OR   SS08WS-EIBAID-VALID-PF-KEY)
022000         SET MBCA-INITIAL-SCREEN-NBR
022100                                 TO TRUE
022200         GO TO F090-TRANSFER-XCTL.
022300*
022400******************************************************
022500*    RESET THE FIELD ATTRIBUTES TO THEIR NORMAL      *
022600*    PRIOR STATE PRIOR TO ANY EDITING BEING DONE.    *
022700******************************************************
022800*
022900     MOVE DFHBMUNN               TO S300-ORG-A
023000                                    S300-STORE-A.
023100     MOVE DFHBMASK               TO S300-ORG-LP-A
023200                                    S300-ORG-RP-A
023300                                    S300-STORE-LP-A
023400                                    S300-STORE-RP-A.
023500*
023600 C080-EDIT-ORG.
023700*
023800     IF  S300-ORG IS NOT NUMERIC
023900     OR  S300-ORG IS LESS THAN MBCA-ORG-LOW
024000     OR  S300-ORG IS GREATER THAN MBCA-ORG-HIGH
024100     OR  S300-ORG IS LESS THAN WS-ORG-LOW
024200     OR  S300-ORG IS GREATER THAN WS-ORG-HIGH
024300         MOVE MBEMWS-INVALID-ORG TO S300-ERR-MESSAGE
024400         GO TO C098-ORG-ERROR.
024500*
024600 C082-READ-ORG.
024700*
024800************************************************
024900*    READ THE ORGANIZATION RECORD.  IT MUST    *
025000*    BE ON FILE AND AN ACTIVE RECORD.          *
025100************************************************
025200*
025300     MOVE S300-ORG               TO MBIOWS-MMOC-ORG.
025400     MOVE 'FC01'                 TO MBCA-PROGRAM-LOCATION.
025500     MOVE SS08WS-CICS-FC-NOTFND  TO MBIORO-TEMP-STATUS-1.
025600     SET MBIORO-READ-RANDOM      TO TRUE.
025700     PERFORM MMOCAO-ACCESS       THRU MMOCAO-ACCESS-EXIT.
025800*
025900     IF  SS08WS-RC-FC-NOTFND
026000         MOVE MBEMWS-NOT-ON-FILE TO S300-ERR-MESSAGE
026100     ELSE
026200         IF  MMOC-ADD-PENDING
026300             MOVE MBEMWS-ADD-PENDING
026400                                 TO S300-ERR-MESSAGE
026500         ELSE
026600             IF  MMOC-REC-PURGED
026700                 MOVE MBEMWS-NOT-ACTIVE
026800                                 TO S300-ERR-MESSAGE
026900             ELSE
027000                 MOVE DFHBMUNF   TO S300-ORG-A
027100                 MOVE S300-ORG   TO MBCA-MERCHANT-ORG
027200                 MOVE MMOC-CURRENCY-CODE
027300                                 TO MBCA-CURRENCY-CODE
027400                 GO TO C100-EDIT-STORE.
027500*
027600 C098-ORG-ERROR.
027700*
027800     SET SS08WS-ERROR-SW-YES     TO TRUE.
027900     MOVE DFHBMASB               TO S300-ORG-LP-A
028000                                    S300-ORG-RP-A.
028100     MOVE SS08WS-CURSOR          TO S300-ORG-L.
028200     MOVE DFHBMNBF               TO S300-ORG-A.
028300     MOVE DFHBMUNF               TO S300-STORE-A.
028400     GO TO D000-RETURN-ERRORS.
028500*
028600 C100-EDIT-STORE.
028700*
028800     IF  S300-STORE IS NOT NUMERIC
028900     OR  S300-STORE IS EQUAL TO ZEROES OR 999999999
029000         MOVE MBEMWS-INVALID-STORE
029100                                 TO S300-ERR-MESSAGE
029200         GO TO C118-STORE-ERROR.
029300*
029400 C102-READ-STORE.
029500*
029600***************************************************************
029700*    READ THE STORE MASTER RECORD.     IT MUST BE ON          *
029800*    FILE AND AN ACTIVE OR CLOSED RECORD.                     *
029900***************************************************************
030000*
030100     MOVE DFHBMUNF               TO S300-STORE-A.
030200*
030300     MOVE S300-ORG               TO MBIOWS-MMSM-ORG.
030400     MOVE S300-STORE             TO MBIOWS-MMSM-STORE.
030500     MOVE SS08WS-CICS-FC-NOTFND  TO MBIORO-TEMP-STATUS-1.
030600     MOVE 'FC02'                 TO MBCA-PROGRAM-LOCATION.
030700     SET MBIORO-READ-RANDOM      TO TRUE.
030800     PERFORM MMSMAO-ACCESS       THRU MMSMAO-ACCESS-EXIT.
030900*
031000     IF  SS08WS-RC-FC-VALID-RTN-CODE
031100         MOVE S300-STORE         TO MBCA-STORE.
031200*
031300     IF  SS08WS-RC-FC-NOTFND
031400         MOVE MBEMWS-NOT-ON-FILE TO S300-ERR-MESSAGE
031500         GO TO C118-STORE-ERROR.
031600*
031700     IF  MMSM-REC-MODEL
031800         NEXT SENTENCE
031900     ELSE
032000         MOVE MBEMWS-BAD-REC-STATUS
032100                                 TO S300-ERR-MESSAGE
032200         GO TO C118-STORE-ERROR.
032300*
032400************************************************
032500*    OTHERWISE, WE PASSED THE STORE EDIT       *
032600************************************************
032700*
032800     GO TO D000-RETURN-ERRORS.
032900*
033000 C118-STORE-ERROR.
033100*
033200     SET SS08WS-ERROR-SW-YES     TO TRUE.
033300     MOVE DFHBMASB               TO S300-STORE-LP-A
033400                                    S300-STORE-RP-A.
033500     MOVE SS08WS-CURSOR          TO S300-STORE-L.
033600     MOVE DFHBMNBF               TO S300-STORE-A.
033700/
033800 D000-RETURN-ERRORS SECTION.
033900*
034000     IF  SS08WS-ERROR-SW-NO
034100         GO TO F000-SETUP-COMMAREA
034200     ELSE
034300         IF  SS08WS-VALID-PF-KEY
034400         OR  SS08WS-EIBAID-VALID-PF-KEY
034500             SET MBCA-INITIAL-SCREEN-NBR
034600                                 TO TRUE
034700             GO TO F090-TRANSFER-XCTL.
034800*
034900***************************************************************
035000*    INITIALIZE THE STANDARD MAP LINES.  IN AN ERROR          *
035100*    CONDITION, THIS ROUTINE IS PERFORMED PRIMARILY           *
035200*    TO UPDATE THE DATE AND TIME ON THE SCREEN.               *
035300***************************************************************
035400*
035500     PERFORM MB60PD-INIT-STD-MAP-LINES
035600                                 THRU MB60PD-ISML-EXIT.
035700*
035800**********************
035900*    SEND THE MAP    *
036000**********************
036100*
036200     MOVE 'BM03'                 TO MBCA-PROGRAM-LOCATION.
036300     PERFORM MB60PD-SEND-MAP-WITH-ERASE
036400                                 THRU MB60PD-SMWE-EXIT.
036500*
036600************************
036700*    RETURN TO CICS    *
036800************************
036900*
037000     MOVE 'PC04'                 TO MBCA-PROGRAM-LOCATION.
037100     PERFORM MB70PD-RETURN-TRANS-ID
037200                                 THRU MB70PD-RTI-EXIT.
037300/
037400 F000-SETUP-COMMAREA SECTION.
037500*
037600***************************************************************
037700*  SET UP COMMAREA FIELDS AND TRANSFER TO THE NEXT PROGRAM    *
037800***************************************************************
037900*
038000     MOVE MBCA-EIBAID            TO SS08WS-EIBAID.
038100*
038200     MOVE MBIOWS-MMSM-DIRECT-KEY-CODE
038300                                 TO MBCA-KEY-CODE.
038400*
038500     PERFORM MB60PD-EDIT-PAGE-NBR
038600                                 THRU MB60PD-EPN-EXIT.
038700*
038800     IF  SS08WS-VALID-PF-KEY
038900     OR  SS08WS-EIBAID-VALID-PF-KEY
039000         SET MBCA-INITIAL-SCREEN-NBR
039100                                 TO TRUE.
039200*
039300 F090-TRANSFER-XCTL.
039400*
039500     MOVE 'PC05'                 TO MBCA-PROGRAM-LOCATION.
039600     PERFORM MB70PD-XCTL-TO-MBOXCTL
039700                                 THRU MB70PD-XTM-EXIT.
039800/
039900 Z000-COPIED-ROUTINES SECTION.
040000**********************************
040100*    JUL TO GREG DATE ROUTINE    *
040200**********************************
040300*
040400     COPY SS08PD.
040500/
040600     COPY SS26PD.
040700/
040800     COPY SS27PD.
040900/
041000*****************************
041100*    CHECK DIGIT ROUITNE    *
041200*****************************
041300*
041400     COPY SS09PD.
041500/
041600*********************************
041700*    LINE 24 PF KEYS ROUTINE    *
041800*********************************
041900*
042000     COPY SS15PD.
042100/
042200*******************************************
042300*    ORG FILE RECORD 1 ACCESS ROUTINES    *
042400*******************************************
042500*
042600     COPY MMOCAO.
042700/
042800*********************************************
042900*    STORE MASTER RECORD ACCESS ROUTINES *
043000*********************************************
043100*
043200     COPY MMSMAO.
043300/
043400*****************************
043500*    ONLINE MAP ROUTINES    *
043600*****************************
043700*
043800     COPY MB60PD REPLACING 'MBMAPXX' BY 'MB3S00 '
043900                           MBMAPXXI BY MB3S00I
044000                           MBMAPXXO BY MB3S00O.
044100/
044200***************************
044300*    ONLINE PROCEDURES    *
044400***************************
044500*
044600     COPY MB70PD.
044700/
044800     COPY SMFTPXO.
