000100 IDENTIFICATION DIVISION.
000200 PROGRAM-ID. MBO3S01.
000201*       RELEASE DATE=08/24/01.        REVISION LEVEL=08.06      *
000202*****************************************************************
000203*WARNING.  THIS COMPUTER PROGRAM IS PROTECTED BY COPYRIGHT LAW  *
000204*AND INTERNATIONAL TREATIES.  UNAUTHORIZED REPRODUCTION OR      *
000205*DISTRIBUTION OF THIS PROGRAM, OR ANY PORTION OF IT, MAY RESULT *
000206*IN SEVERE CIVIL AND CRIMINAL PENATLIES, AND WILL BE PROSECUTED *
000207*TO THE MAXIMUM EXTENT POSSIBLE UNDER THE LAW.                  *
000208*COPYRIGHT 1999 PAYSYS INTERNATIONAL, INC.  ALL RIGHTS RESERVED.*
000209*****************************************************************
000300*****************************************************************
000400*                                                               *
000500*   V - PLUS  M E R C H A N T   B A N K C A R D   S Y S T E M   *
000600*                                                               *
000700*      MBO3S01 - STORE MODEL PURGE                              *
000800*                SCREEN 01                                      *
000900*                                                               *
001000*              1. TRANSIDS                                      *
001100*                 A. MB3S                                       *
001200*              2. MAPS USED -                                   *
001300*                 A. MB3S01 (SCREEN 01)                         *
001400*              3. FILES USED -                                  *
001500*                 A. MMSM (STORE MASTER FILE)                   *
001600*                 B. MML1 (LOG FILE)                            *
001700*                                                               *
001800*****************************************************************
001900*
002000 ENVIRONMENT DIVISION.
002100*
002200 DATA DIVISION.
002300*
002400 WORKING-STORAGE SECTION.
002500*
002600 01  FILLER                  PIC  X(12)      VALUE '** WS-BEG **'.
002700*
002800 01  FILLER                  PIC  X(17)      VALUE
002900     'PROGRAM SWITCHES:'.
003000*
003100 01  WS-PROGRAM-SWITCHES.
003200     03  WS-UPDATE-SW        PIC  X(01)      VALUE 'N'.
003300         88  WS-UPDATE-SW-YES                VALUE 'Y'.
003400         88  WS-UPDATE-SW-NO                 VALUE 'N'.
003500/
003600 01  FILLER                  PIC  X(29)      VALUE
003700     'I/O REQUEST BLOCK WORK AREAS:'.
003800*
003900     COPY MBIOWS.
004000/
004100 01  FILLER                  PIC  X(21)      VALUE
004200     'ERROR MESSAGES TABLE:'.
004300*
004400     COPY MBEMWS.
004500/
004600 01  FILLER                  PIC  X(18)      VALUE
004700     'I/O REQUEST BLOCK:'.
004800*
004900     COPY MBIORO.
005000/
005100 01  FILLER                  PIC  X(25)      VALUE
005200     'LOG RECORD REQUEST BLOCK:'.
005300*
005400     COPY MML1WS REPLACING ==:MML1:== BY ==MML1==.
005500/
005600 01  FILLER                  PIC  X(20)      VALUE
005700     'CCS DATE WORK AREAS:'.
005800*
005900     COPY SS01WS.
006000/
006100 01  FILLER                  PIC  X(15)      VALUE
006200     'CCS WORK AREAS:'.
006300*
006400     COPY SS08WS.
006500/
006600     COPY SS00WS.
006700/
006800     COPY SMFTWS.
006900/
007000     COPY SMPTRL REPLACING ==:SMPT:== BY ==SMPT==.
007100/
007200     COPY MB61LK.
007300/
007400 01  FILLER                  PIC  X(12)      VALUE '** WS-END **'.
007500/
007600 LINKAGE SECTION.
007700*
007800 01  DFHCOMMAREA.
007900*
008000     COPY MB60WS.
008100/
008200********************************
008300*    STORE MODEL PURGE MAP     *
008400********************************
008500*
008600     COPY MB3S01.
008700/
008800***********************************************
008900*    STORE MODEL PURGE MAP REDEFINITION       *
009000***********************************************
009100*
009200     COPY MB3S01R.
009300/
009400****************************************
009500*    STORE MASTER  RECORD LAYOUT       *
009600****************************************
009700*
009800     COPY MMSMRL.
009900/
010000***************************
010100*    LOG RECORD LAYOUT    *
010200***************************
010300*
010400     COPY MML1RL REPLACING ==:MML1:== BY ==MML1==.
010500/
010600 PROCEDURE DIVISION.
010700*
010800 A000-HOUSEKEEPING SECTION.
010900*
011000 A020-INIT.
011100*
011200     MOVE 'PC01'                 TO MBCA-PROGRAM-LOCATION.
011300     PERFORM MB70PD-ON-LINE-HOUSEKEEPING
011400                                 THRU MB70PD-OLH-EXIT.
011500*
011600     IF  MBCA-RECEIVE-SCREEN
011700         GO TO C000-RECEIVE-SCREEN.
011800/
011900 B000-SEND-SCREEN SECTION.
012000*
012100*********************************************
012200*    GET CICS STORAGE NEEDED FOR THE MAP    *
012300*********************************************
012400*
012500     MOVE 'SC01'                 TO MBCA-PROGRAM-LOCATION.
012600     PERFORM MB60PD-GETMAIN-FOR-MAP
012700                                 THRU MB60PD-GFM-EXIT.
012800*
012900*******************************************
013000*    INITIALIZE THE STANDARD MAP LINES    *
013100*******************************************
013200*
013300     PERFORM MB60PD-INIT-STD-MAP-LINES
013400                                 THRU MB60PD-ISML-EXIT.
013500*
013600*****************************************
013700*    READ THE STORE MASTER RECORD       *
013800*****************************************
013900*
014000     MOVE 'FC01'                 TO MBCA-PROGRAM-LOCATION.
014100     PERFORM 9100-READ-MMSM      THRU 9199-READ-MMSM-EXIT.
014200*
014300 B020-MOVE-FIELDS-TO-SCREEN.
014400*
014500     MOVE 'N'                    TO S301-PURGE-REC.
014600     MOVE MMSM-LAST-MAINT-DATE   TO SS01WS-JULIAN.
014700     PERFORM SS26PD-NUMERICALLY-EDIT-DATE
014800        THRU SS26PD-NED-EXIT.
014900     MOVE SS01WS-XX-XX-YYYY      TO S301-LAST-MAINT-DATE.
015000     MOVE MMSM-LAST-MAINT-OPER   TO S301-LAST-MAINT-OPER.
015100     MOVE MMSM-MERCHANT-ID       TO S301-MERCHANT-ID.
015200     MOVE MMSM-DBA-NAME          TO S301-DBA-NAME.
015300     MOVE MMSM-DBA-CITY          TO S301-DBA-CITY.
015400     MOVE MMSM-DBA-COUNTRY-CODE  TO S301-DBA-STATE.
015500     MOVE MMSM-COUNTRY-CODE (1)  TO S301-COUNTRY-CODE.
015600*
015700     PERFORM
015800         VARYING X-MMSM-NA
015900         FROM 1 BY 1
016000         UNTIL X-MMSM-NA IS GREATER THAN 5
016100         SET X-S301-NA           TO X-MMSM-NA
016200         MOVE MMSM-NA-LINE (1 X-MMSM-NA)
016300                                 TO S301-NA-LINE (X-S301-NA)
016400     END-PERFORM.
016500*
016600     MOVE MMSM-STATE-CODE (1)    TO S301-STATE-CODE.
016700     MOVE MMSM-PHONE (1)         TO S301-PHONE.
016800     MOVE MMSM-POSTAL-CODE (1)   TO S301-POSTAL-CODE.
016900     MOVE MMSM-FAX (1)           TO S301-FAX.
017000*
017100******************************************
017200*    SET THE CURSOR AND SCREEN NUMBER    *
017300******************************************
017400*
017500     MOVE SS08WS-CURSOR          TO S301-PURGE-REC-L.
017600*
017700     COMPUTE MBCA-SCREEN-NBR     =  MBCA-SCREEN-NBR - 50.
017800*
017900**********************
018000*    SEND THE MAP    *
018100**********************
018200*
018300     MOVE 'BM01'                 TO MBCA-PROGRAM-LOCATION.
018400     PERFORM MB60PD-SEND-MAP-WITH-ERASE
018500                                 THRU MB60PD-SMWE-EXIT.
018600*
018700************************
018800*    RETURN TO CICS    *
018900************************
019000*
019100     MOVE 'PC02'                 TO MBCA-PROGRAM-LOCATION.
019200     PERFORM MB70PD-RETURN-TRANS-ID
019300                                 THRU MB70PD-RTI-EXIT.
019400/
019500 C000-RECEIVE-SCREEN SECTION.
019600*
019700******************************************
019800*    THIS SECTION RECEIVES THE SCREEN    *
019900******************************************
020000*
020100     MOVE 'BM02'                 TO MBCA-PROGRAM-LOCATION
020200     PERFORM MB60PD-RECEIVE-MAP  THRU MB60PD-RM-EXIT.
020300*
020400**************************************************************
020500*    CHECK FOR ANOTHER TRANSACTION ID ENTERED BY THE USER    *
020600**************************************************************
020700*
020800     MOVE 'PC03'                 TO MBCA-PROGRAM-LOCATION.
020900     PERFORM MB60PD-NEW-TRANS-ROUTINE
021000                                 THRU MB60PD-NTR-EXIT.
021100*
021200*****************************************
021300*    READ THE STORE MASTER RECORD       *
021400*****************************************
021500*
021600     MOVE 'FC02'                 TO MBCA-PROGRAM-LOCATION.
021700     PERFORM 9100-READ-MMSM      THRU 9199-READ-MMSM-EXIT.
021800*
021900 C020-FIELD-EDITS.
022000*
022100*
022200***************************************
022300*    FIELD EDIT FOR PURGE RECORD      *
022400***************************************
022500*
022600     IF  S301-PURGE-REC-L        IS GREATER THAN ZERO
022700         MOVE DFHBMASF           TO S301-PURGE-REC-A
022800     ELSE
022900         MOVE 'N'                TO S301-PURGE-REC.
023000*
023100     IF  S301-VALID-PURGE-REC
023200         NEXT SENTENCE
023300     ELSE
023400         GO TO C025-PURGE-REC-ERROR.
023500*
023600     GO TO D000-RETURN-ERRORS.
023700*
023800 C025-PURGE-REC-ERROR.
023900*
024000     IF  S301-PURGE-REC-L        IS GREATER THAN ZERO
024100         MOVE DFHBMUBF           TO S301-PURGE-REC-A.
024200*
024300     SET SS08WS-ERROR-SW-YES     TO TRUE.
024400     MOVE DFHBMASB               TO S301-PURGE-REC-LP-A
024500                                    S301-PURGE-REC-RP-A.
024600     MOVE SS08WS-CURSOR          TO S301-PURGE-REC-L.
024700*
024800/
024900 D000-RETURN-ERRORS SECTION.
025000*
025100     IF  SS08WS-ERROR-SW-NO
025200         GO TO E000-UPDATE-FILE.
025300*
025400***************************************************************
025500*    INITIALIZE THE STANDARD MAP LINES.  IN AN ERROR          *
025600*    CONDITION, THIS ROUTINE IS PERFORMED PRIMARILY           *
025700*    TO UPDATE THE DATE AND TIME ON THE SCREEN.               *
025800***************************************************************
025900*
026000     PERFORM MB60PD-INIT-STD-MAP-LINES
026100                                 THRU MB60PD-ISML-EXIT.
026200*
026300**********************
026400*    SEND THE MAP    *
026500**********************
026600*
026700     MOVE 'BM03'                 TO MBCA-PROGRAM-LOCATION.
026800     PERFORM MB60PD-SEND-MAP-DATA-ONLY
026900                                 THRU MB60PD-SMDO-EXIT.
027000*
027100************************
027200*    RETURN TO CICS    *
027300************************
027400*
027500     MOVE 'PC04'                 TO MBCA-PROGRAM-LOCATION.
027600     PERFORM MB70PD-RETURN-TRANS-ID
027700                                 THRU MB70PD-RTI-EXIT.
027800/
027900 E000-UPDATE-FILE SECTION.
028000*
028100****************************************************
028200*    READ THE STORE MASTER RECORD FOR UPDATE       *
028300****************************************************
028400*
028500     MOVE 'FC03'                 TO MBCA-PROGRAM-LOCATION.
028600     SET MBIORO-READ-RANDOM-UPDATE
028700                                 TO TRUE.
028800     PERFORM MMSMAO-ACCESS       THRU MMSMAO-ACCESS-EXIT.
028900*
029000 E010-CONTINUE.
029100*
029200*************************************
029300*    OBTAIN STORAGE FOR LOG FILE    *
029400*    RECORD IF DOING MAINTENANCE    *
029500*************************************
029600*
029700     MOVE 'SC02'                 TO MBCA-PROGRAM-LOCATION.
029800     SET MBIORO-GETMAIN          TO TRUE.
029900     PERFORM MML1AO-ACCESS       THRU MML1AO-ACCESS-EXIT.
030000*
030100 E020-UPDATE-FIELDS.
030200*
030300     IF  S301-PURGE-REC-L        IS GREATER THAN ZERO
030400         IF S301-PURGE-REC IS EQUAL TO 'Y'
030500             SET WS-UPDATE-SW-YES
030600                                 TO TRUE
030700             MOVE 0197           TO MML1-FIELD-CODE
030800             MOVE ZEROES         TO MML1-FIELD-OCCURRENCE
030900                                    MML1-FIELD-OCCURRENCE-2
031000             MOVE MML1WS-VL-01   TO MML1-VARIABLE-LENGTH
031100             MOVE MMSM-REC-STATUS
031200                                 TO MML1-VL01-B-DATA-9
031300             SET MMSM-REC-PURGED TO TRUE
031400             MOVE MMSM-REC-STATUS
031500                                 TO MML1-VL01-A-DATA-9
031600             MOVE 'FC04'         TO MBCA-PROGRAM-LOCATION
031700             PERFORM 9200-WRITE-LOG-REC-STORE
031800                                 THRU 9299-WLRS-EXIT
031900             MOVE 0196           TO MML1-FIELD-CODE
032000             MOVE ZEROES         TO MML1-FIELD-OCCURRENCE
032100                                    MML1-FIELD-OCCURRENCE-2
032200             MOVE MML1WS-VL-03   TO MML1-VARIABLE-LENGTH
032300             MOVE MMSM-STATUS-CHANGE-OPER
032400                                 TO MML1-VL03-B-DATA-X
032500             MOVE MBCA-OPERATOR-ID
032600                                 TO MMSM-STATUS-CHANGE-OPER
032700             MOVE MMSM-STATUS-CHANGE-OPER
032800                                 TO MML1-VL03-A-DATA-X
032900             MOVE 'FC05'         TO MBCA-PROGRAM-LOCATION
033000             PERFORM 9200-WRITE-LOG-REC-STORE
033100                                 THRU 9299-WLRS-EXIT.
033200*
033300 E040-UPDATE-MMSM.
033400*
033500**************************************************************
033600*    WRITE A LOG RECORD TO SHOW THAT THE LAST MAINT DATE     *
033700*    AND OPERATOR HAS BEEN UPDATED IF FIELDS WERE CHANGED    *
033800*    ON THE SCREEN                                           *
033900**************************************************************
034000*
034100     IF  WS-UPDATE-SW-YES
034200         MOVE 0198               TO MML1-FIELD-CODE
034300         MOVE ZEROES             TO MML1-FIELD-OCCURRENCE
034400                                    MML1-FIELD-OCCURRENCE-2
034500         MOVE MML1WS-VL-03       TO MML1-VARIABLE-LENGTH
034600         MOVE MMSM-LAST-MAINT-OPER
034700                                 TO MML1-VL03-B-DATA-X
034800         MOVE MBCA-OPERATOR-ID   TO MMSM-LAST-MAINT-OPER
034900         MOVE MMSM-LAST-MAINT-OPER
035000                                 TO MML1-VL03-A-DATA-X
035100         MOVE 'FC06'             TO MBCA-PROGRAM-LOCATION
035200         PERFORM 9200-WRITE-LOG-REC-STORE
035300                                 THRU 9299-WLRS-EXIT
035400         MOVE 0199               TO MML1-FIELD-CODE
035500         MOVE MML1WS-VL-07       TO MML1-VARIABLE-LENGTH
035600         MOVE MMSM-LAST-MAINT-DATE
035700                                 TO MML1-VL07-B-DATA-9
035800         MOVE MBCA-START-DATE    TO MMSM-LAST-MAINT-DATE
035900         MOVE MMSM-LAST-MAINT-DATE
036000                                 TO MML1-VL07-A-DATA-9
036100         MOVE 'FC07'             TO MBCA-PROGRAM-LOCATION
036200         PERFORM 9200-WRITE-LOG-REC-STORE
036300                                 THRU 9299-WLRS-EXIT.
036400*
036500**************************************************************
036600*    REWRITE THE STORE MASTER RECORD                         *
036700*    IF FIELDS HAVE BEEN CHANGED ON THE SCREEN, OR           *
036800*    UNLOCK IT IF THEY HAVE NOT                              *
036900**************************************************************
037000*
037100     IF  WS-UPDATE-SW-YES
037200         MOVE 'FC08'             TO MBCA-PROGRAM-LOCATION
037300         SET MBIORO-REWRITE      TO TRUE
037400         PERFORM MMSMAO-ACCESS   THRU MMSMAO-ACCESS-EXIT
037500     ELSE
037600         MOVE 'FC09'             TO MBCA-PROGRAM-LOCATION
037700         SET MBIORO-UNLOCK       TO TRUE
037800         PERFORM MMSMAO-ACCESS   THRU MMSMAO-ACCESS-EXIT.
037900/
038000 F000-SETUP-COMMAREA SECTION.
038100*
038200***************************************************************
038300*  SET UP COMMAREA FIELDS AND TRANSFER TO THE NEXT PROGRAM    *
038400***************************************************************
038500*
038600     MOVE MBCA-EIBAID            TO SS08WS-EIBAID.
038700*
038800     PERFORM MB60PD-EDIT-PAGE-NBR
038900                                 THRU MB60PD-EPN-EXIT.
039000*
039100     IF  SS08WS-VALID-PF-KEY
039200     OR  SS08WS-EIBAID-VALID-PF-KEY
039300         SET MBCA-INITIAL-SCREEN-NBR
039400                                 TO TRUE.
039500*
039600     MOVE 'PC05'                 TO MBCA-PROGRAM-LOCATION.
039700     PERFORM MB70PD-XCTL-TO-MBOXCTL
039800                                 THRU MB70PD-XTM-EXIT.
039900/
040000 9000-PERFORMED-AREA SECTION.
040100*
040200 9100-READ-MMSM.
040300*
040400*****************************************
040500*    READ THE STORE MASTER RECORD       *
040600*****************************************
040700*
040800     MOVE MBCA-MERCHANT-ORG      TO MBIOWS-MMSM-ORG
040900                                    S301-ORG.
041000     MOVE MBCA-STORE             TO MBIOWS-MMSM-STORE
041100                                    S301-STORE.
041200     SET MBIORO-READ-RANDOM      TO TRUE.
041300     PERFORM MMSMAO-ACCESS       THRU MMSMAO-ACCESS-EXIT.
041400*
041500 9199-READ-MMSM-EXIT.
041600     EXIT.
041700*
041800 9200-WRITE-LOG-REC-STORE.
041900*
042000     MOVE 'SM'                   TO MML1-FILE-CODE.
042100     MOVE MBCA-MERCHANT-ORG      TO MML1-MMSM-ORG.
042200     MOVE MBCA-STORE             TO MML1-MMSM-STORE.
042300     MOVE MBCA-SIGNON-NAME       TO MML1-SIGNON-NAME.
042400     MOVE MBCA-TERMINAL-ID       TO MML1-TERMINAL-ID.
042500     MOVE ZEROS                  TO MML1-SOURCE-CODE.
042600     MOVE MBCA-FIELD-SECURITY    TO MML1-FIELD-SECURITY.
042700     SET MBIORO-WRITE            TO TRUE.
042800     PERFORM MML1AO-ACCESS       THRU MML1AO-ACCESS-EXIT.
042900     MOVE SPACES                 TO MML1-VARIABLE-AREA.
043000*
043100 9299-WLRS-EXIT.
043200     EXIT.
043300/
043400 Z000-COPIED-ROUTINES SECTION.
043500**********************************
043600*    JUL TO GREG DATE ROUTINE    *
043700**********************************
043800*
043900     COPY SS08PD.
044000/
044100     COPY SS26PD.
044200/
044300     COPY SS27PD.
044400/
044500*********************************
044600*    LINE 24 PF KEYS ROUTINE    *
044700*********************************
044800*
044900     COPY SS15PD.
045000/
045100************************************************
045200*    STORE MASTER RECORD ACCESS ROUTINES       *
045300************************************************
045400*
045500     COPY MMSMAO.
045600/
045700*****************************************
045800*    LOG FILE RECORD ACCESS ROUTINES    *
045900*****************************************
046000*
046100     COPY MML1AO.
046200/
046300*****************************
046400*    ONLINE MAP ROUTINES    *
046500*****************************
046600*
046700     COPY MB60PD REPLACING 'MBMAPXX' BY 'MB3S01 '
046800                           MBMAPXXI BY MB3S01I
046900                           MBMAPXXO BY MB3S01O.
047000/
047100***************************
047200*    ONLINE PROCEDURES    *
047300***************************
047400*
047500     COPY MB70PD.
047600/
047700     COPY SMFTPXO.
