000100 IDENTIFICATION DIVISION.
000200 PROGRAM-ID. MBO6M00.
000201*       RELEASE DATE=08/24/01.        REVISION LEVEL=08.06      *
000202*****************************************************************
000203*WARNING.  THIS COMPUTER PROGRAM IS PROTECTED BY COPYRIGHT LAW  *
000204*AND INTERNATIONAL TREATIES.  UNAUTHORIZED REPRODUCTION OR      *
000205*DISTRIBUTION OF THIS PROGRAM, OR ANY PORTION OF IT, MAY RESULT *
000206*IN SEVERE CIVIL AND CRIMINAL PENATLIES, AND WILL BE PROSECUTED *
000207*TO THE MAXIMUM EXTENT POSSIBLE UNDER THE LAW.                  *
000208*COPYRIGHT 1999 PAYSYS INTERNATIONAL, INC.  ALL RIGHTS RESERVED.*
000209*****************************************************************
000300*****************************************************************
000400*                                                               *
000500*   V - PLUS  M E R C H A N T   B A N K C A R D   S Y S T E M   *
000600*                                                               *
000700*      MBO6M00 - MERCHANT PURGING TO CLOSE                      *
000800*                LOCATE SCREEN 00                               *
000900*                                                               *
001000*              1. TRANSID                                       *
001100*                 A. MB6M                                       *
001200*              2. MAPS USED -                                   *
001300*                 A. MB6M00 (LOCATE MAP)                        *
001400*              3. FILES USED -                                  *
001500*                 A. MMMM (MERCHANT MASTER)                     *
001600*                 B. MMOC (ORG CONTROL RECORD)                  *
001700*                                                               *
001800*****************************************************************
001900*
002000 ENVIRONMENT DIVISION.
002100*
002200 DATA DIVISION.
002300*
002400 WORKING-STORAGE SECTION.
002500*
002600 01  FILLER                  PIC  X(12)      VALUE
002700     '** WS-BEG **'.
002800*
002900 01  FILLER                  PIC  X(14)      VALUE
003000     'MISCELLANEOUS:'.
003100*
003200 01  WS-MISCELLANEOUS.
003300     03  WS-ORG-LOW          PIC S9(03)      COMP-3
003400                                             VALUE +001.
003500     03  WS-ORG-HIGH         PIC S9(03)      COMP-3
003600                                             VALUE +998.
003700/
003800 01  FILLER                  PIC  X(29)      VALUE
003900     'I/O REQUEST BLOCK WORK AREAS:'.
004000*
004100     COPY MBIOWS.
004200/
004300 01  FILLER                  PIC  X(18)      VALUE
004400     'I/O REQUEST BLOCK:'.
004500*
004600     COPY MBIORO.
004700/
004800 01  FILLER                  PIC  X(21)      VALUE
004900     'ERROR MESSAGES TABLE:'.
005000*
005100     COPY MBEMWS.
005200/
005300 01  FILLER                  PIC  X(27)      VALUE
005400     'MERCHANT MASTER WORK AREAS:'.
005500*
005600     COPY MMMMWS.
005700/
005800 01  FILLER                  PIC  X(20)      VALUE
005900     'CCS DATE WORK AREAS:'.
006000*
006100     COPY SS01WS.
006200/
006300 01  FILLER                  PIC  X(27)      VALUE
006400     'CCS CHECK DIGIT WORK AREAS:'.
006500*
006600     COPY SS05WS.
006700/
006800 01  FILLER                  PIC  X(15)      VALUE
006900     'CCS WORK AREAS:'.
007000*
007100     COPY SS08WS.
007200/
007300     COPY SS00WS.
007400/
007500     COPY SMFTWS.
007600/
007700     COPY SMPTRL REPLACING ==:SMPT:== BY ==SMPT==.
007800/
007900     COPY MB61LK.
008000/
008100 01  FILLER                  PIC  X(12)      VALUE
008200     '** WS-END **'.
008300/
008400 LINKAGE SECTION.
008500*
008600 01  DFHCOMMAREA.
008700*
008800     COPY MB60WS.
008900/
009000********************************************
009100*    MERCHANT CLOSE TO ACTIVE LOCATE MAP   *
009200********************************************
009300*
009400     COPY MB6M00.
009500/
009600*******************************************************
009700*    MERCHANT CLOSE TO ACTIVE LOCATE MAP REDEFINITION *
009800*******************************************************
009900*
010000     COPY MB6M00R.
010100/
010200***************************
010300*    ORG RECORD LAYOUT    *
010400***************************
010500*
010600     COPY MMOCRL.
010700/
010800***************************************
010900*    MERCHANT MASTER RECORD LAYOUT    *
011000***************************************
011100*
011200     COPY MMMMRL.
011300/
011400 PROCEDURE DIVISION.
011500*
011600 A000-HOUSEKEEPING SECTION.
011700*
011800 A020-INIT.
011900*
012000     MOVE 'PC01'                 TO MBCA-PROGRAM-LOCATION.
012100     PERFORM MB70PD-ON-LINE-HOUSEKEEPING
012200                                 THRU MB70PD-OLH-EXIT.
012300*
012400     IF  MBCA-RECEIVE-SCREEN
012500         GO TO C000-RECEIVE-SCREEN.
012600/
012700 B000-SEND-SCREEN SECTION.
012800*
012900*********************************************
013000*    GET CICS STORAGE NEEDED FOR THE MAP    *
013100*********************************************
013200*
013300     MOVE 'SC01'                 TO MBCA-PROGRAM-LOCATION.
013400     PERFORM MB60PD-GETMAIN-FOR-MAP
013500                                 THRU MB60PD-GFM-EXIT.
013600*
013700*
013800*****************************************************************
013900*    SEE IF THE MBCA-MERCHANT-ORG IS GREATER THAN ZERO. IF IT   *
014000*    IS, PLUG IT INTO THE MAP. THE THE MBCA-MERCHANT IS GREATER *
014100*    THAN ZERO, PLUG IT INTO THE MAP.                           *
014200*****************************************************************
014300*
014400     IF  MBCA-MMMM-KEY-CODE
014500         IF  MBCA-MERCHANT-ORG IS GREATER THAN ZERO
014600         AND MBCA-MERCHANT     IS GREATER THAN ZERO
014700             MOVE MBCA-MERCHANT-ORG
014800                                 TO M600-ORG
014900             MOVE MBCA-MERCHANT  TO M600-MERCHANT
015000             MOVE DFHBMUNF       TO M600-ORG-A
015100                                    M600-MERCHANT-A
015200             IF  MBCA-DIRECT-TRANSFER-CODE
015300             AND MBCA-INITIAL-SCREEN-NBR
015400                 MOVE 00         TO MBCA-SCREEN-NBR
015500                 GO TO C082-READ-ORG
015600             ELSE
015700                 GO TO B020-BUILD-SCREEN.
015800*
015900     IF  MBCA-VALID-KEY-CODES
016000         IF  MBCA-MERCHANT-ORG IS GREATER THAN ZERO
016100             MOVE MBCA-MERCHANT-ORG
016200                                 TO M600-ORG
016300             MOVE DFHBMUNF       TO M600-ORG-A
016400             IF  MBCA-MERCHANT IS GREATER THAN ZERO
016500                 MOVE MBCA-MERCHANT
016600                                 TO M600-MERCHANT
016700                 MOVE DFHBMUNF   TO M600-MERCHANT-A.
016800*
016900 B020-BUILD-SCREEN.
017000*
017100*******************************************
017200*    INITIALIZE THE STANDARD MAP LINES    *
017300*******************************************
017400*
017500     MOVE SS08WS-CURSOR          TO M600-ORG-L.
017600     MOVE 00                     TO MBCA-SCREEN-NBR.
017700     PERFORM MB60PD-INIT-STD-MAP-LINES
017800                                 THRU MB60PD-ISML-EXIT.
017900*
018000**********************
018100*    SEND THE MAP    *
018200**********************
018300*
018400     MOVE 'BM01'                 TO MBCA-PROGRAM-LOCATION.
018500     PERFORM MB60PD-SEND-MAP-WITH-ERASE
018600                                 THRU MB60PD-SMWE-EXIT.
018700*
018800************************
018900*    RETURN TO CICS    *
019000************************
019100*
019200     MOVE 'PC02'                 TO MBCA-PROGRAM-LOCATION.
019300     PERFORM MB70PD-RETURN-TRANS-ID
019400                                 THRU MB70PD-RTI-EXIT.
019500/
019600 C000-RECEIVE-SCREEN SECTION.
019700*
019800*************************************************
019900*    THIS SECTION RECEIVES THE LOCATE SCREEN    *
020000*************************************************
020100*
020200     MOVE 'BM02'                 TO MBCA-PROGRAM-LOCATION.
020300     PERFORM MB60PD-RECEIVE-MAP  THRU MB60PD-RM-EXIT.
020400*
020500**************************************************************
020600*    CHECK FOR ANOTHER TRANSACTION ID ENTERED BY THE USER    *
020700**************************************************************
020800*
020900     MOVE 'PC03'                 TO MBCA-PROGRAM-LOCATION.
021000     PERFORM MB60PD-NEW-TRANS-ROUTINE
021100                                 THRU MB60PD-NTR-EXIT.
021200*
021300 C020-FIELD-EDITS.
021400*
021500     MOVE MBCA-EIBAID            TO SS08WS-EIBAID.
021600*
021700     IF  (M600-ORG-L IS LESS THAN 1
021800     AND  M600-MERCHANT-L IS LESS THAN 1)
021900     AND (SS08WS-VALID-PF-KEY
022000     OR   SS08WS-EIBAID-VALID-PF-KEY)
022100         SET MBCA-INITIAL-SCREEN-NBR
022200                                 TO TRUE
022300         GO TO F090-TRANSFER-XCTL.
022400*
022500******************************************************
022600*    RESET THE FIELD ATTRIBUTES TO THEIR NORMAL      *
022700*    PRIOR STATE PRIOR TO ANY EDITING BEING DONE.    *
022800******************************************************
022900*
023000     MOVE DFHBMUNN               TO M600-ORG-A
023100                                    M600-MERCHANT-A.
023200     MOVE DFHBMASK               TO M600-ORG-LP-A
023300                                    M600-ORG-RP-A
023400                                    M600-MERCHANT-LP-A
023500                                    M600-MERCHANT-RP-A.
023600*
023700 C080-EDIT-ORG.
023800*
023900     IF  M600-ORG IS NOT NUMERIC
024000     OR  M600-ORG IS LESS THAN MBCA-ORG-LOW
024100     OR  M600-ORG IS GREATER THAN MBCA-ORG-HIGH
024200     OR  M600-ORG IS LESS THAN WS-ORG-LOW
024300     OR  M600-ORG IS GREATER THAN WS-ORG-HIGH
024400         MOVE MBEMWS-INVALID-ORG TO M600-ERR-MESSAGE
024500         GO TO C098-ORG-ERROR.
024600*
024700 C082-READ-ORG.
024800*
024900************************************************
025000*    READ THE ORGANIZATION RECORD.  IT MUST    *
025100*    BE ON FILE AND AN ACTIVE RECORD.          *
025200************************************************
025300*
025400     MOVE M600-ORG               TO MBIOWS-MMOC-ORG.
025500     MOVE 'FC01'                 TO MBCA-PROGRAM-LOCATION.
025600     MOVE SS08WS-CICS-FC-NOTFND  TO MBIORO-TEMP-STATUS-1.
025700     SET MBIORO-READ-RANDOM      TO TRUE.
025800     PERFORM MMOCAO-ACCESS       THRU MMOCAO-ACCESS-EXIT.
025900*
026000     IF  SS08WS-RC-FC-NOTFND
026100         MOVE MBEMWS-NOT-ON-FILE TO M600-ERR-MESSAGE
026200     ELSE
026300         IF  MMOC-ADD-PENDING
026400             MOVE MBEMWS-ADD-PENDING
026500                                 TO M600-ERR-MESSAGE
026600         ELSE
026700             IF  MMOC-REC-PURGED
026800                 MOVE MBEMWS-NOT-ACTIVE
026900                                 TO M600-ERR-MESSAGE
027000             ELSE
027100                 MOVE DFHBMUNF   TO M600-ORG-A
027200                 MOVE M600-ORG   TO MBCA-MERCHANT-ORG
027300                 MOVE MMOC-CURRENCY-CODE
027400                                 TO MBCA-CURRENCY-CODE
027500                 MOVE MMOC-CURRENCY-NOD
027600                                 TO MBCA-CURRENCY-NOD
027700                 MOVE MMOC-PER-ITEM-NOD
027800                                 TO MBCA-PER-ITEM-NOD
027900                 MOVE MMOC-PERCENT-NOD
028000                                 TO MBCA-PERCENT-NOD
028100                 GO TO C100-EDIT-MERCHANT.
028200*
028300 C098-ORG-ERROR.
028400*
028500     SET SS08WS-ERROR-SW-YES     TO TRUE.
028600     MOVE DFHBMASB               TO M600-ORG-LP-A
028700                                    M600-ORG-RP-A.
028800     MOVE SS08WS-CURSOR          TO M600-ORG-L.
028900     MOVE DFHBMNBF               TO M600-ORG-A.
029000     MOVE DFHBMUNF               TO M600-MERCHANT-A.
029100     GO TO D000-RETURN-ERRORS.
029200*
029300 C100-EDIT-MERCHANT.
029400*
029500     IF  M600-MERCHANT IS NOT NUMERIC
029600     OR  M600-MERCHANT IS EQUAL TO ZEROES OR 999999999
029700         MOVE MBEMWS-INVALID-MERCHANT
029800                                 TO M600-ERR-MESSAGE
029900         GO TO C118-MERCHANT-ERROR.
030000*
030100 C102-READ-MERCHANT.
030200*
030300***************************************************************
030400*    READ THE MERCHANT MASTER RECORD.  IT MUST BE ON          *
030500*    FILE AND AN ACTIVE OR CLOSED RECORD.                     *
030600***************************************************************
030700*
030800     MOVE DFHBMUNF               TO M600-MERCHANT-A.
030900*
031000     MOVE M600-ORG               TO MBIOWS-MMMM-ORG.
031100     MOVE M600-MERCHANT          TO MBIOWS-MMMM-MERCHANT.
031200     MOVE SS08WS-CICS-FC-NOTFND  TO MBIORO-TEMP-STATUS-1.
031300     MOVE 'FC02'                 TO MBCA-PROGRAM-LOCATION.
031400     SET MBIORO-READ-RANDOM      TO TRUE.
031500     PERFORM MMMMAO-ACCESS       THRU MMMMAO-ACCESS-EXIT.
031600*
031700     IF  SS08WS-RC-FC-VALID-RTN-CODE
031800         MOVE M600-MERCHANT      TO MBCA-MERCHANT.
031900*
032000     IF  SS08WS-RC-FC-NOTFND
032100         MOVE MBEMWS-NOT-ON-FILE TO M600-ERR-MESSAGE
032200         GO TO C118-MERCHANT-ERROR.
032300*
032400     IF  MMMM-REC-PENDING-PURGE
032500     OR  MMMM-REC-PURGING
032600         NEXT SENTENCE
032700     ELSE
032800         MOVE MBEMWS-BAD-REC-STATUS
032900                                 TO M600-ERR-MESSAGE
033000         GO TO C118-MERCHANT-ERROR.
033100*
033200************************************************
033300*    OTHERWISE, WE PASSED THE MERCHANT EDIT    *
033400************************************************
033500*
033600     GO TO D000-RETURN-ERRORS.
033700*
033800 C118-MERCHANT-ERROR.
033900*
034000     SET SS08WS-ERROR-SW-YES     TO TRUE.
034100     MOVE DFHBMASB               TO M600-MERCHANT-LP-A
034200                                    M600-MERCHANT-RP-A.
034300     MOVE SS08WS-CURSOR          TO M600-MERCHANT-L.
034400     MOVE DFHBMNBF               TO M600-MERCHANT-A.
034500/
034600 D000-RETURN-ERRORS SECTION.
034700*
034800     IF  SS08WS-ERROR-SW-NO
034900         GO TO F000-SETUP-COMMAREA
035000     ELSE
035100         IF  SS08WS-VALID-PF-KEY
035200         OR  SS08WS-EIBAID-VALID-PF-KEY
035300             SET MBCA-INITIAL-SCREEN-NBR
035400                                 TO TRUE
035500             GO TO F090-TRANSFER-XCTL.
035600*
035700***************************************************************
035800*    INITIALIZE THE STANDARD MAP LINES.  IN AN ERROR          *
035900*    CONDITION, THIS ROUTINE IS PERFORMED PRIMARILY           *
036000*    TO UPDATE THE DATE AND TIME ON THE SCREEN.               *
036100***************************************************************
036200*
036300     PERFORM MB60PD-INIT-STD-MAP-LINES
036400                                 THRU MB60PD-ISML-EXIT.
036500*
036600**********************
036700*    SEND THE MAP    *
036800**********************
036900*
037000     MOVE 'BM03'                 TO MBCA-PROGRAM-LOCATION.
037100     PERFORM MB60PD-SEND-MAP-WITH-ERASE
037200                                 THRU MB60PD-SMWE-EXIT.
037300*
037400************************
037500*    RETURN TO CICS    *
037600************************
037700*
037800     MOVE 'PC04'                 TO MBCA-PROGRAM-LOCATION.
037900     PERFORM MB70PD-RETURN-TRANS-ID
038000                                 THRU MB70PD-RTI-EXIT.
038100/
038200 F000-SETUP-COMMAREA SECTION.
038300*
038400***************************************************************
038500*  SET UP COMMAREA FIELDS AND TRANSFER TO THE NEXT PROGRAM    *
038600***************************************************************
038700*
038800     MOVE MBCA-EIBAID            TO SS08WS-EIBAID.
038900*
039000     MOVE MBIOWS-MMMM-DIRECT-KEY-CODE
039100                                 TO MBCA-KEY-CODE.
039200*
039300     PERFORM MB60PD-EDIT-PAGE-NBR
039400                                 THRU MB60PD-EPN-EXIT.
039500*
039600     IF  SS08WS-VALID-PF-KEY
039700     OR  SS08WS-EIBAID-VALID-PF-KEY
039800         SET MBCA-INITIAL-SCREEN-NBR
039900                                 TO TRUE.
040000*
040100 F090-TRANSFER-XCTL.
040200*
040300     MOVE 'PC05'                 TO MBCA-PROGRAM-LOCATION.
040400     PERFORM MB70PD-XCTL-TO-MBOXCTL
040500                                 THRU MB70PD-XTM-EXIT.
040600/
040700 Z000-COPIED-ROUTINES SECTION.
040800**********************************
040900*    JUL TO GREG DATE ROUTINE    *
041000**********************************
041100*
041200     COPY SS08PD.
041300/
041400     COPY SS26PD.
041500/
041600     COPY SS27PD.
041700/
041800*****************************
041900*    CHECK DIGIT ROUITNE    *
042000*****************************
042100*
042200     COPY SS09PD.
042300/
042400*********************************
042500*    LINE 24 PF KEYS ROUTINE    *
042600*********************************
042700*
042800     COPY SS15PD.
042900/
043000*******************************************
043100*    ORG FILE RECORD 1 ACCESS ROUTINES    *
043200*******************************************
043300*
043400     COPY MMOCAO.
043500/
043600*********************************************
043700*    MERCHANT MASTER RECORD ACCESS ROUTINES *
043800*********************************************
043900*
044000     COPY MMMMAO.
044100/
044200*****************************
044300*    ONLINE MAP ROUTINES    *
044400*****************************
044500*
044600     COPY MB60PD REPLACING 'MBMAPXX' BY 'MB6M00 '
044700                           MBMAPXXI BY MB6M00I
044800                           MBMAPXXO BY MB6M00O.
044900/
045000***************************
045100*    ONLINE PROCEDURES    *
045200***************************
045300*
045400     COPY MB70PD.
045500/
045600     COPY SMFTPXO.
