000100 IDENTIFICATION DIVISION.
000200 PROGRAM-ID. MBO6M01.
000201*       RELEASE DATE=08/24/01.        REVISION LEVEL=08.06      *
000202*****************************************************************
000203*WARNING.  THIS COMPUTER PROGRAM IS PROTECTED BY COPYRIGHT LAW  *
000204*AND INTERNATIONAL TREATIES.  UNAUTHORIZED REPRODUCTION OR      *
000205*DISTRIBUTION OF THIS PROGRAM, OR ANY PORTION OF IT, MAY RESULT *
000206*IN SEVERE CIVIL AND CRIMINAL PENATLIES, AND WILL BE PROSECUTED *
000207*TO THE MAXIMUM EXTENT POSSIBLE UNDER THE LAW.                  *
000208*COPYRIGHT 1999 PAYSYS INTERNATIONAL, INC.  ALL RIGHTS RESERVED.*
000209*****************************************************************
000300*****************************************************************
000400*                                                               *
000500*   V - PLUS  M E R C H A N T   B A N K C A R D   S Y S T E M   *
000600*                                                               *
000700*      MBO6M01 - MERCHANT RECORD PURGING TO CLOSE               *
000800*                SCREEN 01                                      *
000900*                                                               *
001000*              1. TRANSIDS                                      *
001100*                 A. MB6M                                       *
001200*              2. MAPS USED -                                   *
001300*                 A. MB6M01 (SCREEN 01)                         *
001400*              3. FILES USED -                                  *
001500*                 A. MMMM (MERCHANT MASTER FILE)                *
001600*                 B. MMSM (STORE MASTER FILE)                   *
001700*                 C. MMXR (STORE MERCHANT CROSS REF FILE)       *
001800*                 D. MML1 (LOG FILE)                            *
001900*                                                               *
002000*****************************************************************
002100*
002200 ENVIRONMENT DIVISION.
002300*
002400 DATA DIVISION.
002500*
002600 WORKING-STORAGE SECTION.
002700*
002800 01  FILLER                  PIC  X(12)      VALUE '** WS-BEG **'.
002900*
003000 01  FILLER                  PIC  X(14)      VALUE
003100     'MISCELLANEOUS:'.
003200*
003300 01  WS-MISCELLANEOUS.
003400     03  WS-NBR-CHAINS       PIC  9(02)      VALUE ZEROS.
003500*
003600 01  FILLER                  PIC  X(17)      VALUE
003700     'PROGRAM SWITCHES:'.
003800*
003900 01  WS-PROGRAM-SWITCHES.
004000     03  WS-UPDATE-SW        PIC  X(01)      VALUE 'N'.
004100         88  WS-UPDATE-SW-YES                VALUE 'Y'.
004200         88  WS-UPDATE-SW-NO                 VALUE 'N'.
004300/
004400 01  FILLER                  PIC  X(29)      VALUE
004500     'I/O REQUEST BLOCK WORK AREAS:'.
004600*
004700     COPY MBIOWS.
004800/
004900 01  FILLER                  PIC  X(18)      VALUE
005000     'I/O REQUEST BLOCK:'.
005100*
005200     COPY MBIORO.
005300/
005400 01  FILLER                  PIC  X(25)      VALUE
005500     'LOG RECORD REQUEST BLOCK:'.
005600*
005700     COPY MML1WS REPLACING ==:MML1:== BY ==MML1==.
005800/
005900 01  FILLER                  PIC  X(31)      VALUE
006000     'DYNAMICALLY CALLED SUBROUTINES:'.
006100*
006200     COPY MB00WS.
006300/
006400 01  FILLER                  PIC  X(37)      VALUE
006500     'FORMAT NBR AND AMTS BY CURRENCY CODE:'.
006600*
006700     COPY SS95WS.
006800/
006900 01  FILLER                  PIC  X(20)      VALUE
007000     'CCS DATE WORK AREAS:'.
007100*
007200     COPY SS01WS.
007300/
007400 01  FILLER                  PIC  X(15)      VALUE
007500     'CCS WORK AREAS:'.
007600*
007700     COPY SS08WS.
007800/
007900     COPY SS00WS.
008000/
008100     COPY SMFTWS.
008200/
008300     COPY SMPTRL REPLACING ==:SMPT:== BY ==SMPT==.
008400/
008500     COPY MB61LK.
008600/
008700 01  FILLER                  PIC  X(12)      VALUE '** WS-END **'.
008800/
008900 LINKAGE SECTION.
009000*
009100 01  DFHCOMMAREA.
009200*
009300     COPY MB60WS.
009400/
009500************************************
009600*    MERCHANT PURGING TO CLOSE MAP *
009700************************************
009800*
009900     COPY MB6M01.
010000/
010100*************************************************
010200*    MERCHANT PURGING TO CLOSE MAP REDEFINITION *
010300*************************************************
010400*
010500     COPY MB6M01R.
010600/
010700****************************************
010800*    MERCHANT MASTER RECORD LAYOUT     *
010900****************************************
011000*
011100     COPY MMMMRL.
011200/
011300****************************************
011400*    STORE MASTER  RECORD LAYOUT       *
011500****************************************
011600*
011700     COPY MMSMRL.
011800/
011900****************************************************
012000*    STORE MERCHANT CROSS REF MASTER RECORD LAYOUT *
012100****************************************************
012200*
012300     COPY MMXRRL.
012400/
012500***************************
012600*    LOG RECORD LAYOUT    *
012700***************************
012800*
012900     COPY MML1RL REPLACING ==:MML1:== BY ==MML1==.
013000/
013100 PROCEDURE DIVISION.
013200*
013300 A000-HOUSEKEEPING SECTION.
013400*
013500 A020-INIT.
013600*
013700     MOVE 'PC01'                 TO MBCA-PROGRAM-LOCATION.
013800     PERFORM MB70PD-ON-LINE-HOUSEKEEPING
013900                                 THRU MB70PD-OLH-EXIT.
014000*
014100     SET SS95WS-FUNCTION-INITIALIZE
014200                                 TO TRUE.
014300     PERFORM SS95PD-NAP-ROUTINE
014400        THRU SS95PD-NAP-EXIT.
014500*
014600     IF  MBCA-RECEIVE-SCREEN
014700         GO TO C000-RECEIVE-SCREEN.
014800/
014900 B000-SEND-SCREEN SECTION.
015000*
015100*********************************************
015200*    GET CICS STORAGE NEEDED FOR THE MAP    *
015300*********************************************
015400*
015500     MOVE 'SC01'                 TO MBCA-PROGRAM-LOCATION.
015600     PERFORM MB60PD-GETMAIN-FOR-MAP
015700                                 THRU MB60PD-GFM-EXIT.
015800*
015900*******************************************
016000*    INITIALIZE THE STANDARD MAP LINES    *
016100*******************************************
016200*
016300     PERFORM MB60PD-INIT-STD-MAP-LINES
016400                                 THRU MB60PD-ISML-EXIT.
016500*
016600*****************************************
016700*    READ THE MERCHANT MASTER RECORD    *
016800*****************************************
016900*
017000     MOVE 'FC01'                 TO MBCA-PROGRAM-LOCATION.
017100     PERFORM 9100-READ-MMMM      THRU 9199-READ-MMMM-EXIT.
017200*
017300*********************************************
017400*    MOVE THE PRIMARY NAME TO THE SCREEN    *
017500*********************************************
017600*
017700     MOVE MMMM-NA-LINE (1 1)     TO M601-MERCH-NAME.
017800*
017900 B020-MOVE-FIELDS-TO-SCREEN.
018000*
018100     MOVE MBCA-CURRENCY-CODE     TO SS95WS-CURRENCY-CODE.
018200     MOVE 'N'                    TO M601-CLOSE-FLAG
018300                                    M601-STORE-FLAG.
018400     MOVE MMMM-CLOSE-REASON      TO M601-CLOSE-REASON.
018500     MOVE MMMM-DATE-OPENED       TO SS01WS-JULIAN.
018600     PERFORM SS26PD-NUMERICALLY-EDIT-DATE
018700        THRU SS26PD-NED-EXIT.
018800     MOVE SS01WS-XX-XX-YYYY      TO M601-DATE-OPEN.
018900     MOVE MMMM-DBA-NAME          TO M601-DBA-NAME.
019000     MOVE MMMM-DATE-CLOSED       TO SS01WS-JULIAN.
019100     PERFORM SS26PD-NUMERICALLY-EDIT-DATE
019200        THRU SS26PD-NED-EXIT.
019300     MOVE SS01WS-XX-XX-YYYY      TO M601-DATE-CLOSED.
019400     MOVE MMMM-DBA-CITY          TO M601-DBA-CITY.
019500     MOVE MMMM-DBA-COUNTRY-CODE  TO M601-DBA-STATE.
019600     MOVE MMMM-PURGING-DATE      TO SS01WS-JULIAN.
019700     PERFORM SS26PD-NUMERICALLY-EDIT-DATE
019800        THRU SS26PD-NED-EXIT.
019900     MOVE SS01WS-XX-XX-YYYY      TO M601-DATE-PURGING.
020000     MOVE MMMM-DATE-LAST-ACTIVE  TO SS01WS-JULIAN.
020100     PERFORM SS26PD-NUMERICALLY-EDIT-DATE
020200        THRU SS26PD-NED-EXIT.
020300     MOVE SS01WS-XX-XX-YYYY      TO M601-DATE-LAST-ACT.
020400     MOVE MMMM-BLOCK-CODE        TO M601-BLOCK-CODE.
020500     MOVE MMMM-AGENT-BANK        TO M601-AGENT.
020600     MOVE MMMM-DATE-LAST-STMT    TO SS01WS-JULIAN.
020700     PERFORM SS26PD-NUMERICALLY-EDIT-DATE
020800        THRU SS26PD-NED-EXIT.
020900     MOVE SS01WS-XX-XX-YYYY      TO M601-DATE-LAST-STMT.
021000     MOVE MMMM-STMT-FREQ-1       TO M601-STMT-FREQ1.
021100     MOVE MMMM-STMT-FREQ-2       TO M601-STMT-FREQ2.
021200     MOVE MMMM-BRANCH            TO M601-BRANCH.
021300     MOVE MMMM-DATE-LAST-SETT    TO SS01WS-JULIAN.
021400     PERFORM SS26PD-NUMERICALLY-EDIT-DATE
021500        THRU SS26PD-NED-EXIT.
021600     MOVE SS01WS-XX-XX-YYYY      TO M601-DATE-LAST-SETT.
021700     MOVE MMMM-SETT-FREQ-1       TO M601-SETT-FREQ1.
021800     MOVE MMMM-SETT-FREQ-2       TO M601-SETT-FREQ2.
021900     MOVE MMMM-BAL-SETT          TO SS95WS-IN-AMT.
022000     PERFORM SS95PD-NAP-ROUTINE
022100                                 THRU SS95PD-NAP-EXIT.
022200     MOVE SS95WS-OUT-AMT-L21     TO M601-SETT-BAL.
022300     MOVE MMMM-BAL-RESV-1        TO SS95WS-IN-AMT.
022400     PERFORM SS95PD-NAP-ROUTINE
022500                                 THRU SS95PD-NAP-EXIT.
022600     MOVE SS95WS-OUT-AMT-L21     TO M601-RESV-BAL1.
022700     MOVE MMMM-BAL-RESV-2        TO SS95WS-IN-AMT.
022800     PERFORM SS95PD-NAP-ROUTINE
022900                                 THRU SS95PD-NAP-EXIT.
023000     MOVE SS95WS-OUT-AMT-L21     TO M601-RESV-BAL2.
023100     MOVE MMMM-BAL-RESV-3        TO SS95WS-IN-AMT.
023200     PERFORM SS95PD-NAP-ROUTINE
023300                                 THRU SS95PD-NAP-EXIT.
023400     MOVE SS95WS-OUT-AMT-L21     TO M601-RESV-BAL3.
023500     MOVE MMMM-BAL-RESV-4        TO SS95WS-IN-AMT.
023600     PERFORM SS95PD-NAP-ROUTINE
023700                                 THRU SS95PD-NAP-EXIT.
023800     MOVE SS95WS-OUT-AMT-L21     TO M601-RESV-BAL4.
023900     MOVE MMMM-IMP-DEV-TITLE (1) TO M601-IMP-TITLE1.
024000     MOVE MMMM-IMP-DEV-TITLE (2) TO M601-IMP-TITLE2.
024100     MOVE MMMM-IMP-DEV-TITLE (3) TO M601-IMP-TITLE3.
024200     MOVE MMMM-POS-DEV-TITLE (1) TO M601-POS-TITLE1.
024300     MOVE MMMM-POS-DEV-TITLE (2) TO M601-POS-TITLE2.
024400     MOVE MMMM-POS-DEV-TITLE (3) TO M601-POS-TITLE3.
024500     MOVE MMMM-IMP-DEV-NBR (1)   TO SS95WS-IN-NBR.
024600     PERFORM SS95PD-NAP-ROUTINE
024700                                 THRU SS95PD-NAP-EXIT.
024800     MOVE SS95WS-OUT-NBR-L07     TO M601-IMP-NBR1.
024900     MOVE MMMM-IMP-DEV-NBR (2)   TO SS95WS-IN-NBR.
025000     PERFORM SS95PD-NAP-ROUTINE
025100                                 THRU SS95PD-NAP-EXIT.
025200     MOVE SS95WS-OUT-NBR-L07     TO M601-IMP-NBR2.
025300     MOVE MMMM-IMP-DEV-NBR (3)   TO SS95WS-IN-NBR.
025400     PERFORM SS95PD-NAP-ROUTINE
025500                                 THRU SS95PD-NAP-EXIT.
025600     MOVE SS95WS-OUT-NBR-L07     TO M601-IMP-NBR3.
025700     MOVE MMMM-POS-DEV-NBR (1)   TO SS95WS-IN-NBR.
025800     PERFORM SS95PD-NAP-ROUTINE
025900                                 THRU SS95PD-NAP-EXIT.
026000     MOVE SS95WS-OUT-NBR-L07     TO M601-POS-NBR1.
026100     MOVE MMMM-POS-DEV-NBR (2)   TO SS95WS-IN-NBR.
026200     PERFORM SS95PD-NAP-ROUTINE
026300                                 THRU SS95PD-NAP-EXIT.
026400     MOVE SS95WS-OUT-NBR-L07     TO M601-POS-NBR2.
026500     MOVE MMMM-POS-DEV-NBR (3)   TO SS95WS-IN-NBR.
026600     PERFORM SS95PD-NAP-ROUTINE
026700                                 THRU SS95PD-NAP-EXIT.
026800     MOVE SS95WS-OUT-NBR-L07     TO M601-POS-NBR3.
026900*
027000********************************************
027100*  TO FORMAT AND POPULATE THE MESSAGE LINE *
027200********************************************
027300*
027400     IF M601-ERR-MESSAGE IS EQUAL TO SPACES OR LOW-VALUES
027500        PERFORM MB06PD-FORMAT-MESSAGE-LINE
027600           THRU MB06PD-FML-EXIT
027700        MOVE SS08WS-FORMATTED-MSG   TO M601-ERR-MESSAGE
027800     END-IF.
027900*
028000******************************************
028100*    SET THE CURSOR AND SCREEN NUMBER    *
028200******************************************
028300*
028400     MOVE SS08WS-CURSOR          TO M601-CLOSE-FLAG-L.
028500*
028600     COMPUTE MBCA-SCREEN-NBR     =  MBCA-SCREEN-NBR - 50.
028700*
028800**********************
028900*    SEND THE MAP    *
029000**********************
029100*
029200     MOVE 'BM01'                 TO MBCA-PROGRAM-LOCATION.
029300     PERFORM MB60PD-SEND-MAP-WITH-ERASE
029400                                 THRU MB60PD-SMWE-EXIT.
029500*
029600************************
029700*    RETURN TO CICS    *
029800************************
029900*
030000     MOVE 'PC02'                 TO MBCA-PROGRAM-LOCATION.
030100     PERFORM MB70PD-RETURN-TRANS-ID
030200                                 THRU MB70PD-RTI-EXIT.
030300/
030400 C000-RECEIVE-SCREEN SECTION.
030500*
030600******************************************
030700*    THIS SECTION RECEIVES THE SCREEN    *
030800******************************************
030900*
031000     MOVE 'BM02'                 TO MBCA-PROGRAM-LOCATION
031100     PERFORM MB60PD-RECEIVE-MAP  THRU MB60PD-RM-EXIT.
031200*
031300**************************************************************
031400*    CHECK FOR ANOTHER TRANSACTION ID ENTERED BY THE USER    *
031500**************************************************************
031600*
031700     MOVE 'PC03'                 TO MBCA-PROGRAM-LOCATION.
031800     PERFORM MB60PD-NEW-TRANS-ROUTINE
031900                                 THRU MB60PD-NTR-EXIT.
032000*
032100*****************************************
032200*    READ THE MERCH MASTER RECORD       *
032300*****************************************
032400*
032500     MOVE 'FC02'                 TO MBCA-PROGRAM-LOCATION.
032600     PERFORM 9100-READ-MMMM      THRU 9199-READ-MMMM-EXIT.
032700*
032800 C020-FIELD-EDITS.
032900*
033000***************************************
033100*    FIELD EDIT FOR CLOSE MERCH FLAG  *
033200***************************************
033300*
033400     IF  M601-CLOSE-FLAG-L       IS GREATER THAN ZERO
033500         MOVE DFHBMASF           TO M601-CLOSE-FLAG-A
033600     ELSE
033700         MOVE 'N'                TO M601-CLOSE-FLAG.
033800*
033900     IF  M601-VALID-CLOSE-FLAG
034000         NEXT SENTENCE
034100     ELSE
034200         GO TO C025-CLOSE-FLAG-ERROR.
034300*
034400     GO TO C030-CLOSE-STORE.
034500*
034600 C025-CLOSE-FLAG-ERROR.
034700*
034800     IF  M601-CLOSE-FLAG-L       IS GREATER THAN ZERO
034900         MOVE DFHBMUBF           TO M601-CLOSE-FLAG-A.
035000*
035100     SET SS08WS-ERROR-SW-YES     TO TRUE.
035200     MOVE DFHBMASB               TO M601-CLOSE-FLAG-LP-A
035300                                    M601-CLOSE-FLAG-RP-A.
035400     MOVE SS08WS-CURSOR          TO M601-CLOSE-FLAG-L.
035500*
035600 C030-CLOSE-STORE.
035700*
035800***************************************
035900*    FIELD EDIT FOR CLOSE STORE       *
036000***************************************
036100*
036200*
036300     IF  M601-STORE-FLAG-L       IS GREATER THAN ZERO
036400         MOVE DFHBMASF           TO M601-STORE-FLAG-A
036500     ELSE
036600         MOVE 'N'                TO M601-STORE-FLAG.
036700*
036800     IF  M601-VALID-STORE-FLAG
036900         NEXT SENTENCE
037000     ELSE
037100         GO TO C035-STORE-FLAG-ERROR.
037200*
037300     GO TO C040-CLOSE-REASON.
037400*
037500 C035-STORE-FLAG-ERROR.
037600*
037700     IF  M601-STORE-FLAG-L       IS GREATER THAN ZERO
037800         MOVE DFHBMUBF           TO M601-STORE-FLAG-A.
037900*
038000     SET SS08WS-ERROR-SW-YES     TO TRUE.
038100     MOVE DFHBMASB               TO M601-STORE-FLAG-LP-A
038200                                    M601-STORE-FLAG-RP-A.
038300     MOVE SS08WS-CURSOR          TO M601-STORE-FLAG-L.
038400*
038500 C040-CLOSE-REASON.
038600*
038700***************************************
038800*    FIELD EDIT FOR CLOSE REASON      *
038900***************************************
039000*
039100     IF  M601-CLOSE-REASON-L     IS GREATER THAN ZERO
039200         MOVE DFHBMASF           TO M601-CLOSE-REASON-A
039300     ELSE
039400         MOVE MMMM-CLOSE-REASON  TO M601-CLOSE-REASON.
039500*
039600     IF  M601-CLOSE-FLAG-L IS GREATER THAN ZERO
039700     AND M601-CLOSE-FLAG  IS EQUAL TO 'Y'
039800     AND M601-CLOSE-REASON IS EQUAL TO SPACES
039900         GO TO C045-CLOSE-REASON-ERROR.
040000*
040100     GO TO C050-CROSS-EDITS.
040200*
040300 C045-CLOSE-REASON-ERROR.
040400*
040500     IF  M601-CLOSE-REASON-L     IS GREATER THAN ZERO
040600         MOVE DFHBMUBF           TO M601-CLOSE-REASON-A.
040700*
040800     SET SS08WS-ERROR-SW-YES     TO TRUE.
040900     MOVE DFHBMASB               TO M601-CLOSE-REASON-LP-A
041000                                    M601-CLOSE-REASON-RP-A.
041100     MOVE SS08WS-CURSOR          TO M601-CLOSE-REASON-L.
041200*
041300 C050-CROSS-EDITS.
041400*
041500     IF  M601-CLOSE-FLAG IS EQUAL TO 'N'
041600     AND M601-STORE-FLAG IS EQUAL TO 'Y'
041700         SET SS08WS-ERROR-SW-YES TO TRUE
041800         MOVE DFHBMUBF           TO M601-STORE-FLAG-A
041900                                    M601-CLOSE-FLAG-A
042000         MOVE DFHBMASB           TO M601-STORE-FLAG-LP-A
042100                                    M601-STORE-FLAG-RP-A
042200                                    M601-CLOSE-FLAG-LP-A
042300                                    M601-CLOSE-FLAG-RP-A
042400         MOVE SS08WS-CURSOR      TO M601-CLOSE-FLAG-L.
042500*
042600/
042700 D000-RETURN-ERRORS SECTION.
042800*
042900     IF  SS08WS-ERROR-SW-NO
043000         GO TO E000-UPDATE-FILE.
043100*
043200***************************************************************
043300*    INITIALIZE THE STANDARD MAP LINES.  IN AN ERROR          *
043400*    CONDITION, THIS ROUTINE IS PERFORMED PRIMARILY           *
043500*    TO UPDATE THE DATE AND TIME ON THE SCREEN.               *
043600***************************************************************
043700*
043800     PERFORM MB60PD-INIT-STD-MAP-LINES
043900                                 THRU MB60PD-ISML-EXIT.
044000*
044100********************************************
044200*  TO FORMAT AND POPULATE THE MESSAGE LINE *
044300********************************************
044400*
044500     IF M601-ERR-MESSAGE IS EQUAL TO SPACES OR LOW-VALUES
044600        PERFORM MB06PD-FORMAT-MESSAGE-LINE
044700           THRU MB06PD-FML-EXIT
044800        MOVE SS08WS-FORMATTED-MSG   TO M601-ERR-MESSAGE
044900     END-IF.
045000*
045100**********************
045200*    SEND THE MAP    *
045300**********************
045400*
045500     MOVE 'BM03'                 TO MBCA-PROGRAM-LOCATION.
045600     PERFORM MB60PD-SEND-MAP-DATA-ONLY
045700                                 THRU MB60PD-SMDO-EXIT.
045800*
045900************************
046000*    RETURN TO CICS    *
046100************************
046200*
046300     MOVE 'PC04'                 TO MBCA-PROGRAM-LOCATION.
046400     PERFORM MB70PD-RETURN-TRANS-ID
046500                                 THRU MB70PD-RTI-EXIT.
046600/
046700 E000-UPDATE-FILE SECTION.
046800*
046900****************************************************
047000*    READ THE MERCH MASTER RECORD FOR UPDATE       *
047100****************************************************
047200*
047300     MOVE 'FC03'                 TO MBCA-PROGRAM-LOCATION.
047400     SET MBIORO-READ-RANDOM-UPDATE
047500                                 TO TRUE.
047600     PERFORM MMMMAO-ACCESS       THRU MMMMAO-ACCESS-EXIT.
047700*
047800 E010-CONTINUE.
047900*
048000*************************************
048100*    OBTAIN STORAGE FOR LOG FILE    *
048200*    RECORD IF DOING MAINTENANCE    *
048300*************************************
048400*
048500     MOVE 'SC02'                 TO MBCA-PROGRAM-LOCATION.
048600     SET MBIORO-GETMAIN          TO TRUE.
048700     PERFORM MML1AO-ACCESS       THRU MML1AO-ACCESS-EXIT.
048800*
048900 E020-UPDATE-FIELDS.
049000*
049100     IF  M601-CLOSE-FLAG-L       IS GREATER THAN ZERO
049200         IF  M601-CLOSE-FLAG IS EQUAL TO 'Y'
049300             EVALUATE TRUE
049400                 WHEN MMMM-SINGLE-STORE-YES
049500                     PERFORM 9600-SINGLE-STORE
049600                                 THRU 9699-SS-EXIT
049700             END-EVALUATE
049800             SET WS-UPDATE-SW-YES
049900                                 TO TRUE
050000             MOVE 0197           TO MML1-FIELD-CODE
050100             MOVE ZEROES         TO MML1-FIELD-OCCURRENCE
050200                                    MML1-FIELD-OCCURRENCE-2
050300             MOVE MML1WS-VL-01   TO MML1-VARIABLE-LENGTH
050400             MOVE MMMM-REC-STATUS
050500                                 TO MML1-VL01-B-DATA-9
050600             SET MMMM-REC-CLOSED TO TRUE
050700             MOVE MMMM-REC-STATUS
050800                                 TO MML1-VL01-A-DATA-9
050900             MOVE 'FC04'         TO MBCA-PROGRAM-LOCATION
051000             PERFORM 9200-WRITE-LOG-REC-MERCH
051100                                 THRU 9299-WLRM-EXIT
051200             MOVE 0196           TO MML1-FIELD-CODE
051300             MOVE ZEROES         TO MML1-FIELD-OCCURRENCE
051400                                    MML1-FIELD-OCCURRENCE-2
051500             MOVE MML1WS-VL-03   TO MML1-VARIABLE-LENGTH
051600             MOVE MMMM-STATUS-CHANGE-OPER
051700                                 TO MML1-VL03-B-DATA-X
051800             MOVE MBCA-OPERATOR-ID
051900                                 TO MMMM-STATUS-CHANGE-OPER
052000             MOVE MMMM-STATUS-CHANGE-OPER
052100                                 TO MML1-VL03-A-DATA-X
052200             MOVE 'FC05'         TO MBCA-PROGRAM-LOCATION
052300             PERFORM 9200-WRITE-LOG-REC-MERCH
052400                                 THRU 9299-WLRM-EXIT
052500             MOVE 0194           TO MML1-FIELD-CODE
052600             MOVE ZEROES         TO MML1-FIELD-OCCURRENCE
052700                                    MML1-FIELD-OCCURRENCE-2
052800             MOVE MML1WS-VL-07   TO MML1-VARIABLE-LENGTH
052900             MOVE MMMM-PURGING-DATE
053000                                 TO MML1-VL07-B-DATA-9
053100             MOVE ZEROS          TO MMMM-PURGING-DATE
053200             MOVE MMMM-PURGING-DATE
053300                                 TO MML1-VL07-A-DATA-9
053400             MOVE 'FC06'         TO MBCA-PROGRAM-LOCATION
053500             PERFORM 9200-WRITE-LOG-REC-MERCH
053600                                 THRU 9299-WLRM-EXIT.
053700*
053800     IF  M601-CLOSE-REASON-L     IS GREATER THAN ZERO
053900         IF M601-CLOSE-REASON IS NOT EQUAL TO MMMM-CLOSE-REASON
054000             SET WS-UPDATE-SW-YES
054100                                 TO TRUE
054200             MOVE 0192           TO MML1-FIELD-CODE
054300             MOVE ZEROES         TO MML1-FIELD-OCCURRENCE
054400                                    MML1-FIELD-OCCURRENCE-2
054500             MOVE MML1WS-VL-02   TO MML1-VARIABLE-LENGTH
054600             MOVE MMMM-CLOSE-REASON
054700                                 TO MML1-VL02-B-DATA-X
054800             MOVE M601-CLOSE-REASON
054900                                 TO MMMM-CLOSE-REASON
055000             MOVE MMMM-CLOSE-REASON
055100                                 TO MML1-VL02-A-DATA-X
055200             MOVE 'FC07'         TO MBCA-PROGRAM-LOCATION
055300             PERFORM 9200-WRITE-LOG-REC-MERCH
055400                                 THRU 9299-WLRM-EXIT.
055500*
055600     IF  M601-STORE-FLAG-L       IS GREATER THAN ZERO
055700         IF M601-STORE-FLAG IS EQUAL 'Y'
055800             PERFORM 9400-START-CROSS-REF
055900                                 THRU 9499-SCR-EXIT
056000             SET WS-UPDATE-SW-YES
056100                                 TO TRUE.
056200*
056300 E040-UPDATE-MMMM.
056400*
056500**************************************************************
056600*    WRITE A LOG RECORD TO SHOW THAT THE LAST MAINT DATE     *
056700*    AND OPERATOR HAS BEEN UPDATED IF FIELDS WERE CHANGED    *
056800*    ON THE SCREEN                                           *
056900**************************************************************
057000*
057100     IF  WS-UPDATE-SW-YES
057200         MOVE 0198               TO MML1-FIELD-CODE
057300         MOVE ZEROES             TO MML1-FIELD-OCCURRENCE
057400                                    MML1-FIELD-OCCURRENCE-2
057500         MOVE MML1WS-VL-03       TO MML1-VARIABLE-LENGTH
057600         MOVE MMMM-LAST-MAINT-OPER
057700                                 TO MML1-VL03-B-DATA-X
057800         MOVE MBCA-OPERATOR-ID   TO MMMM-LAST-MAINT-OPER
057900         MOVE MMMM-LAST-MAINT-OPER
058000                                 TO MML1-VL03-A-DATA-X
058100         MOVE 'FC08'             TO MBCA-PROGRAM-LOCATION
058200         PERFORM 9200-WRITE-LOG-REC-MERCH
058300                                 THRU 9299-WLRM-EXIT
058400         MOVE 0199               TO MML1-FIELD-CODE
058500         MOVE MML1WS-VL-07       TO MML1-VARIABLE-LENGTH
058600         MOVE MMMM-LAST-MAINT-DATE
058700                                 TO MML1-VL07-B-DATA-9
058800         MOVE MBCA-START-DATE    TO MMMM-LAST-MAINT-DATE
058900         MOVE MMMM-LAST-MAINT-DATE
059000                                 TO MML1-VL07-A-DATA-9
059100         MOVE 'FC09'             TO MBCA-PROGRAM-LOCATION
059200         PERFORM 9200-WRITE-LOG-REC-MERCH
059300                                 THRU 9299-WLRM-EXIT.
059400*
059500**************************************************************
059600*    REWRITE THE MERCH MASTER RECORD                         *
059700*    IF FIELDS HAVE BEEN CHANGED ON THE SCREEN, OR           *
059800*    UNLOCK IT IF THEY HAVE NOT                              *
059900**************************************************************
060000*
060100     IF  WS-UPDATE-SW-YES
060200         MOVE 'FC10'             TO MBCA-PROGRAM-LOCATION
060300         SET MBIORO-REWRITE      TO TRUE
060400         PERFORM MMMMAO-ACCESS   THRU MMMMAO-ACCESS-EXIT
060500     ELSE
060600         MOVE 'FC11'             TO MBCA-PROGRAM-LOCATION
060700         SET MBIORO-UNLOCK       TO TRUE
060800         PERFORM MMMMAO-ACCESS   THRU MMMMAO-ACCESS-EXIT.
060900/
061000 F000-SETUP-COMMAREA SECTION.
061100*
061200***************************************************************
061300*  SET UP COMMAREA FIELDS AND TRANSFER TO THE NEXT PROGRAM    *
061400***************************************************************
061500*
061600     MOVE MBCA-EIBAID            TO SS08WS-EIBAID.
061700*
061800     PERFORM MB60PD-EDIT-PAGE-NBR
061900                                 THRU MB60PD-EPN-EXIT.
062000*
062100     IF  SS08WS-VALID-PF-KEY
062200     OR  SS08WS-EIBAID-VALID-PF-KEY
062300         SET MBCA-INITIAL-SCREEN-NBR
062400                                 TO TRUE.
062500*
062600     MOVE 'PC05'                 TO MBCA-PROGRAM-LOCATION.
062700     PERFORM MB70PD-XCTL-TO-MBOXCTL
062800                                 THRU MB70PD-XTM-EXIT.
062900/
063000 9000-PERFORMED-AREA SECTION.
063100*
063200 9100-READ-MMMM.
063300*
063400*****************************************
063500*    READ THE MERCH MASTER RECORD       *
063600*****************************************
063700*
063800     MOVE MBCA-MERCHANT-ORG      TO MBIOWS-MMMM-ORG
063900                                    M601-ORG.
064000     MOVE MBCA-MERCHANT          TO MBIOWS-MMMM-MERCHANT
064100                                    M601-MERCHANT.
064200     SET MBIORO-READ-RANDOM      TO TRUE.
064300     PERFORM MMMMAO-ACCESS       THRU MMMMAO-ACCESS-EXIT.
064400*
064500 9199-READ-MMMM-EXIT.
064600     EXIT.
064700*
064800 9200-WRITE-LOG-REC-MERCH.
064900*
065000     MOVE 'MM'                   TO MML1-FILE-CODE.
065100     MOVE MBCA-MERCHANT-ORG      TO MML1-MMMM-ORG.
065200     MOVE MBCA-MERCHANT          TO MML1-MMMM-MERCHANT.
065300     MOVE MBCA-SIGNON-NAME       TO MML1-SIGNON-NAME.
065400     MOVE MBCA-TERMINAL-ID       TO MML1-TERMINAL-ID.
065500     MOVE ZEROS                  TO MML1-SOURCE-CODE.
065600     MOVE MBCA-FIELD-SECURITY    TO MML1-FIELD-SECURITY.
065700     SET MBIORO-WRITE            TO TRUE.
065800     PERFORM MML1AO-ACCESS       THRU MML1AO-ACCESS-EXIT.
065900     MOVE SPACES                 TO MML1-VARIABLE-AREA.
066000*
066100 9299-WLRM-EXIT.
066200     EXIT.
066300*
066400 9300-WRITE-LOG-REC-STORE.
066500*
066600     MOVE 'SM'                   TO MML1-FILE-CODE.
066700     MOVE MBCA-MERCHANT-ORG      TO MML1-MMSM-ORG.
066800     MOVE MMSM-STORE             TO MML1-MMSM-STORE.
066900     MOVE MBCA-SIGNON-NAME       TO MML1-SIGNON-NAME.
067000     MOVE MBCA-TERMINAL-ID       TO MML1-TERMINAL-ID.
067100     MOVE ZEROS                  TO MML1-SOURCE-CODE.
067200     MOVE MBCA-FIELD-SECURITY    TO MML1-FIELD-SECURITY.
067300     SET MBIORO-WRITE            TO TRUE.
067400     PERFORM MML1AO-ACCESS       THRU MML1AO-ACCESS-EXIT.
067500     MOVE SPACES                 TO MML1-VARIABLE-AREA.
067600*
067700 9399-WLRS-EXIT.
067800     EXIT.
067900*
068000 9400-START-CROSS-REF.
068100*
068200     MOVE 'FC12'                 TO MBCA-PROGRAM-LOCATION.
068300     MOVE MBCA-MERCHANT-ORG      TO MBIOWS-MMXR-ORG.
068400     MOVE MMMM-MERCHANT          TO MBIOWS-MMXR-MERCHANT.
068500     MOVE ZEROS                  TO MBIOWS-MMXR-STORE.
068600     SET MBIORO-STARTBR-GTE      TO TRUE.
068700     PERFORM MMXRAO-ACCESS       THRU MMXRAO-ACCESS-EXIT.
068800*
068900 9410-READ-NEXT-MMXR.
069000*
069100     MOVE 'FC13'                 TO MBCA-PROGRAM-LOCATION.
069200     SET MBIORO-READ-SEQ         TO TRUE.
069300     PERFORM MMXRAO-ACCESS       THRU MMXRAO-ACCESS-EXIT.
069400*
069500     IF  MMXR-ORG-MERCHANT IS GREATER THAN MMMM-KEY
069600         GO TO 9420-MMXR-ENDBR
069700     ELSE
069800         IF  MMXR-ORG-MERCHANT IS LESS THAN MMMM-KEY
069900             GO TO 9420-MMXR-ENDBR
070000         ELSE
070100             PERFORM 9500-STORE-CLOSE
070200                                 THRU 9599-SC-EXIT.
070300*
070400     GO TO 9410-READ-NEXT-MMXR.
070500*
070600 9420-MMXR-ENDBR.
070700*
070800     MOVE 'FC14'                 TO MBCA-PROGRAM-LOCATION.
070900     SET MBIORO-ENDBR            TO TRUE.
071000     PERFORM MMXRAO-ACCESS       THRU MMXRAO-ACCESS-EXIT.
071100*
071200 9499-SCR-EXIT.
071300     EXIT.
071400*
071500 9500-STORE-CLOSE.
071600*
071700     MOVE 'FC15'                 TO MBCA-PROGRAM-LOCATION.
071800     MOVE SS08WS-CICS-FC-NOTFND  TO MBIORO-TEMP-STATUS-1.
071900     MOVE MBCA-MERCHANT-ORG      TO MBIOWS-MMSM-ORG.
072000     MOVE MMXR-STORE             TO MBIOWS-MMSM-STORE.
072100     SET MBIORO-READ-RANDOM-UPDATE
072200                                 TO TRUE.
072300     PERFORM MMSMAO-ACCESS       THRU MMSMAO-ACCESS-EXIT.
072400*
072500     IF  SS08WS-RC-FC-NOTFND
072600         GO TO 9599-SC-EXIT.
072700*
072800     IF (MMSM-REC-PURGING
072900     OR  MMSM-REC-PENDING-PURGE)
073000     AND MMSM-PURGING-DATE IS EQUAL TO MMMM-PURGING-DATE
073100     AND MMSM-STATUS-CHANGE-OPER IS EQUAL
073200                                 TO MMMM-STATUS-CHANGE-OPER
073300         PERFORM 9700-UPDATE-STORE THRU 9799-US-EXIT
073400     ELSE
073500         MOVE 'FC16'             TO MBCA-PROGRAM-LOCATION
073600         SET MBIORO-UNLOCK       TO TRUE
073700         PERFORM MMSMAO-ACCESS   THRU MMSMAO-ACCESS-EXIT.
073800*
073900 9599-SC-EXIT.
074000     EXIT.
074100*
074200 9600-SINGLE-STORE.
074300*
074400     MOVE 'FC17'                 TO MBCA-PROGRAM-LOCATION.
074500     MOVE SS08WS-CICS-FC-NOTFND  TO MBIORO-PERM-STATUS-1.
074600     MOVE MBCA-MERCHANT-ORG      TO MBIOWS-MMSM-ORG.
074700     MOVE MMMM-STORE-NBR         TO MBIOWS-MMSM-STORE.
074800     SET MBIORO-READ-RANDOM-UPDATE
074900                                 TO TRUE.
075000     PERFORM MMSMAO-ACCESS       THRU MMSMAO-ACCESS-EXIT.
075100*
075200     IF  SS08WS-RC-FC-NOTFND
075300         GO TO 9699-SS-EXIT.
075400*
075500     PERFORM 9700-UPDATE-STORE   THRU 9799-US-EXIT.
075600*
075700 9699-SS-EXIT.
075800     EXIT.
075900*
076000 9700-UPDATE-STORE.
076100*
076200     IF  M601-CLOSE-REASON-L     IS GREATER THAN ZERO
076300         IF M601-CLOSE-REASON IS NOT EQUAL TO MMSM-CLOSE-REASON
076400             SET WS-UPDATE-SW-YES
076500                                 TO TRUE
076600             MOVE 0192           TO MML1-FIELD-CODE
076700             MOVE ZEROES         TO MML1-FIELD-OCCURRENCE
076800                                    MML1-FIELD-OCCURRENCE-2
076900             MOVE MML1WS-VL-02   TO MML1-VARIABLE-LENGTH
077000             MOVE MMSM-CLOSE-REASON
077100                                 TO MML1-VL02-B-DATA-X
077200             MOVE M601-CLOSE-REASON
077300                                 TO MMSM-CLOSE-REASON
077400             MOVE MMSM-CLOSE-REASON
077500                                 TO MML1-VL02-A-DATA-X
077600             MOVE 'FC18'         TO MBCA-PROGRAM-LOCATION
077700             PERFORM 9300-WRITE-LOG-REC-STORE
077800                                 THRU 9399-WLRS-EXIT.
077900*
078000     MOVE 0194                   TO MML1-FIELD-CODE.
078100     MOVE ZEROES                 TO MML1-FIELD-OCCURRENCE
078200                                    MML1-FIELD-OCCURRENCE-2.
078300     MOVE MML1WS-VL-07           TO MML1-VARIABLE-LENGTH.
078400     MOVE MMSM-PURGING-DATE      TO MML1-VL07-B-DATA-9.
078500     MOVE ZEROS                  TO MMSM-PURGING-DATE.
078600     MOVE MMSM-PURGING-DATE      TO MML1-VL07-A-DATA-9.
078700     MOVE 'FC19'                 TO MBCA-PROGRAM-LOCATION.
078800     PERFORM 9300-WRITE-LOG-REC-STORE
078900                                 THRU 9399-WLRS-EXIT.
079000*
079100     MOVE 0197                   TO MML1-FIELD-CODE.
079200     MOVE ZEROES                 TO MML1-FIELD-OCCURRENCE
079300                                    MML1-FIELD-OCCURRENCE-2.
079400     MOVE MML1WS-VL-01           TO MML1-VARIABLE-LENGTH.
079500     MOVE MMSM-REC-STATUS        TO MML1-VL01-B-DATA-9.
079600     SET MMSM-REC-CLOSED         TO TRUE.
079700     MOVE MMSM-REC-STATUS        TO MML1-VL01-A-DATA-9.
079800     MOVE 'FC20'                 TO MBCA-PROGRAM-LOCATION.
079900     PERFORM 9300-WRITE-LOG-REC-STORE
080000                                 THRU 9399-WLRS-EXIT.
080100     MOVE 0196                   TO MML1-FIELD-CODE.
080200     MOVE ZEROES                 TO MML1-FIELD-OCCURRENCE
080300                                    MML1-FIELD-OCCURRENCE-2.
080400     MOVE MML1WS-VL-03           TO MML1-VARIABLE-LENGTH.
080500     MOVE MMSM-STATUS-CHANGE-OPER
080600                                 TO MML1-VL03-B-DATA-X.
080700     MOVE MBCA-OPERATOR-ID       TO MMSM-STATUS-CHANGE-OPER.
080800     MOVE MMSM-STATUS-CHANGE-OPER
080900                                 TO MML1-VL03-A-DATA-X.
081000     MOVE 'FC21'                 TO MBCA-PROGRAM-LOCATION.
081100     PERFORM 9300-WRITE-LOG-REC-STORE
081200                                 THRU 9399-WLRS-EXIT.
081300*
081400     MOVE 0198                   TO MML1-FIELD-CODE.
081500     MOVE ZEROES                 TO MML1-FIELD-OCCURRENCE
081600                                    MML1-FIELD-OCCURRENCE-2.
081700     MOVE MML1WS-VL-03           TO MML1-VARIABLE-LENGTH.
081800     MOVE MMSM-LAST-MAINT-OPER   TO MML1-VL03-B-DATA-X.
081900     MOVE MBCA-OPERATOR-ID       TO MMSM-LAST-MAINT-OPER.
082000     MOVE MMSM-LAST-MAINT-OPER   TO MML1-VL03-A-DATA-X.
082100     MOVE 'FC22'                 TO MBCA-PROGRAM-LOCATION.
082200     PERFORM 9300-WRITE-LOG-REC-STORE
082300                                 THRU 9399-WLRS-EXIT.
082400     MOVE 0199                   TO MML1-FIELD-CODE.
082500     MOVE MML1WS-VL-07           TO MML1-VARIABLE-LENGTH.
082600     MOVE MMSM-LAST-MAINT-DATE   TO MML1-VL07-B-DATA-9.
082700     MOVE MBCA-START-DATE        TO MMSM-LAST-MAINT-DATE.
082800     MOVE MMSM-LAST-MAINT-DATE   TO MML1-VL07-A-DATA-9.
082900     MOVE 'FC23'                 TO MBCA-PROGRAM-LOCATION.
083000     PERFORM 9300-WRITE-LOG-REC-STORE
083100                                 THRU 9399-WLRS-EXIT.
083200*
083300     MOVE 'FC24'                 TO MBCA-PROGRAM-LOCATION.
083400     SET MBIORO-REWRITE          TO TRUE.
083500     PERFORM MMSMAO-ACCESS       THRU MMSMAO-ACCESS-EXIT.
083600*
083700 9799-US-EXIT.
083800     EXIT.
083900*
084000/
084100 Z000-COPIED-ROUTINES SECTION.
084200**********************************
084300*    JUL TO GREG DATE ROUTINE    *
084400**********************************
084500*
084600     COPY SS08PD.
084700/
084800     COPY SS26PD.
084900/
085000     COPY SS27PD.
085100/
085200*********************************
085300*    LINE 24 PF KEYS ROUTINE    *
085400*********************************
085500*
085600     COPY SS15PD.
085700/
085800************************************************
085900*    STORE MASTER RECORD ACCESS ROUTINES       *
086000************************************************
086100*
086200     COPY MMSMAO.
086300/
086400************************************************
086500*    MERCH MASTER RECORD ACCESS ROUTINES       *
086600************************************************
086700*
086800     COPY MMMMAO.
086900/
087000************************************************************
087100*    STORE MERCHANT CROSS REF MASTER RECORD ACCESS ROUTINES*
087200************************************************************
087300*
087400     COPY MMXRAO.
087500/
087600*****************************************
087700*    LOG FILE RECORD ACCESS ROUTINES    *
087800*****************************************
087900*
088000     COPY MML1AO.
088100/
088200*******************************************
088300*    FORMAT NBR AND AMTS BY CURRENCY CODE *
088400*******************************************
088500*
088600     COPY SS95PDO REPLACING ==:XXCA:== BY ==MBCA==.
088700/
088800*****************************
088900*    ONLINE MAP ROUTINES    *
089000*****************************
089100*
089200     COPY MB60PD REPLACING 'MBMAPXX' BY 'MB6M01 '
089300                           MBMAPXXI BY MB6M01I
089400                           MBMAPXXO BY MB6M01O.
089500/
089600*****************************
089700*    FORMATTED MESSAGE LINE *
089800*****************************
089900*
090000     COPY MB06PD.
090100/
090200***************************
090300*    ONLINE PROCEDURES    *
090400***************************
090500*
090600     COPY MB70PD.
090700/
090800     COPY SMFTPXO.
