000100 IDENTIFICATION DIVISION.
000200 PROGRAM-ID. MBO6S01.
000201*       RELEASE DATE=08/24/01.        REVISION LEVEL=08.06      *
000202*****************************************************************
000203*WARNING.  THIS COMPUTER PROGRAM IS PROTECTED BY COPYRIGHT LAW  *
000204*AND INTERNATIONAL TREATIES.  UNAUTHORIZED REPRODUCTION OR      *
000205*DISTRIBUTION OF THIS PROGRAM, OR ANY PORTION OF IT, MAY RESULT *
000206*IN SEVERE CIVIL AND CRIMINAL PENATLIES, AND WILL BE PROSECUTED *
000207*TO THE MAXIMUM EXTENT POSSIBLE UNDER THE LAW.                  *
000208*COPYRIGHT 1999 PAYSYS INTERNATIONAL, INC.  ALL RIGHTS RESERVED.*
000209*****************************************************************
000300*****************************************************************
000400*                                                               *
000500*   V - PLUS  M E R C H A N T   B A N K C A R D   S Y S T E M   *
000600*                                                               *
000700*      MBO6S01 - STORE PURGING TO CLOSE                         *
000800*                SCREEN 01                                      *
000900*                                                               *
001000*              1. TRANSIDS                                      *
001100*                 A. MB6S                                       *
001200*              2. MAPS USED -                                   *
001300*                 A. MB6S01 (SCREEN 01)                         *
001400*              3. FILES USED -                                  *
001500*                 A. MMSM (STORE MASTER FILE)                   *
001600*                 B. MMMM (MERCHANT MASTER FILE)                *
001700*                 C. MML1 (LOG FILE)                            *
001800*                                                               *
001900*****************************************************************
002000*
002100 ENVIRONMENT DIVISION.
002200*
002300 DATA DIVISION.
002400*
002500 WORKING-STORAGE SECTION.
002600*
002700 01  FILLER                  PIC  X(12)      VALUE '** WS-BEG **'.
002800*
002900 01  FILLER                  PIC  X(17)      VALUE
003000     'PROGRAM SWITCHES:'.
003100*
003200 01  WS-PROGRAM-SWITCHES.
003300     03  WS-UPDATE-SW        PIC  X(01)      VALUE 'N'.
003400         88  WS-UPDATE-SW-YES                VALUE 'Y'.
003500         88  WS-UPDATE-SW-NO                 VALUE 'N'.
003600/
003700 01  FILLER                  PIC  X(29)      VALUE
003800     'I/O REQUEST BLOCK WORK AREAS:'.
003900*
004000     COPY MBIOWS.
004100/
004200 01  FILLER                  PIC  X(21)      VALUE
004300     'ERROR MESSAGES TABLE:'.
004400*
004500     COPY MBEMWS.
004600/
004700 01  FILLER                  PIC  X(18)      VALUE
004800     'I/O REQUEST BLOCK:'.
004900*
005000     COPY MBIORO.
005100/
005200 01  FILLER                  PIC  X(25)      VALUE
005300     'LOG RECORD REQUEST BLOCK:'.
005400*
005500     COPY MML1WS REPLACING ==:MML1:== BY ==MML1==.
005600/
005700 01  FILLER                  PIC  X(31)      VALUE
005800     'DYNAMICALLY CALLED SUBROUTINES:'.
005900*
006000     COPY MB00WS.
006100/
006200 01  FILLER                  PIC  X(37)      VALUE
006300     'FORMAT NBR AND AMTS BY CURRENCY CODE:'.
006400*
006500     COPY SS95WS.
006600/
006700 01  FILLER                  PIC  X(20)      VALUE
006800     'CCS DATE WORK AREAS:'.
006900*
007000     COPY SS01WS.
007100/
007200 01  FILLER                  PIC  X(15)      VALUE
007300     'CCS WORK AREAS:'.
007400*
007500     COPY SS08WS.
007600/
007700     COPY SS00WS.
007800/
007900     COPY SMFTWS.
008000/
008100     COPY SMPTRL REPLACING ==:SMPT:== BY ==SMPT==.
008200/
008300     COPY MB61LK.
008400/
008500 01  FILLER                  PIC  X(12)      VALUE '** WS-END **'.
008600/
008700 LINKAGE SECTION.
008800*
008900 01  DFHCOMMAREA.
009000*
009100     COPY MB60WS.
009200/
009300********************************
009400*    STORE PURGING TO CLOSE MAP*
009500********************************
009600*
009700     COPY MB6S01.
009800/
009900***********************************************
010000*    STORE PURGING TO CLOSE MAP REDEFINITION  *
010100***********************************************
010200*
010300     COPY MB6S01R.
010400/
010500****************************************
010600*    STORE MASTER  RECORD LAYOUT       *
010700****************************************
010800*
010900     COPY MMSMRL.
011000/
011100****************************************
011200*    MERCHANT MASTER RECORD LAYOUT     *
011300****************************************
011400*
011500     COPY MMMMRL.
011600/
011700***************************
011800*    LOG RECORD LAYOUT    *
011900***************************
012000*
012100     COPY MML1RL REPLACING ==:MML1:== BY ==MML1==.
012200/
012300 PROCEDURE DIVISION.
012400*
012500 A000-HOUSEKEEPING SECTION.
012600*
012700 A020-INIT.
012800*
012900     MOVE 'PC01'                 TO MBCA-PROGRAM-LOCATION.
013000     PERFORM MB70PD-ON-LINE-HOUSEKEEPING
013100                                 THRU MB70PD-OLH-EXIT.
013200*
013300     SET SS95WS-FUNCTION-INITIALIZE
013400                                 TO TRUE.
013500     PERFORM SS95PD-NAP-ROUTINE
013600        THRU SS95PD-NAP-EXIT.
013700*
013800     IF  MBCA-RECEIVE-SCREEN
013900         GO TO C000-RECEIVE-SCREEN.
014000/
014100 B000-SEND-SCREEN SECTION.
014200*
014300*********************************************
014400*    GET CICS STORAGE NEEDED FOR THE MAP    *
014500*********************************************
014600*
014700     MOVE 'SC01'                 TO MBCA-PROGRAM-LOCATION.
014800     PERFORM MB60PD-GETMAIN-FOR-MAP
014900                                 THRU MB60PD-GFM-EXIT.
015000*
015100*******************************************
015200*    INITIALIZE THE STANDARD MAP LINES    *
015300*******************************************
015400*
015500     PERFORM MB60PD-INIT-STD-MAP-LINES
015600                                 THRU MB60PD-ISML-EXIT.
015700*
015800*****************************************
015900*    READ THE STORE MASTER RECORD       *
016000*****************************************
016100*
016200     MOVE 'FC01'                 TO MBCA-PROGRAM-LOCATION.
016300     PERFORM 9100-READ-MMSM      THRU 9199-READ-MMSM-EXIT.
016400*
016500*****************************************
016600*    READ THE MERCHANT MASTER RECORD    *
016700*****************************************
016800*
016900     MOVE MBCA-MERCHANT-ORG      TO MBIOWS-MMMM-ORG.
017000     MOVE MMSM-MERCHANT-ID       TO MBIOWS-MMMM-MERCHANT.
017100     SET MBIORO-READ-RANDOM      TO TRUE.
017200     PERFORM MMMMAO-ACCESS       THRU MMMMAO-ACCESS-EXIT.
017300*
017400*********************************************
017500*    MOVE THE PRIMARY NAME TO THE SCREEN    *
017600*********************************************
017700*
017800     MOVE MMSM-NA-LINE (1 1)     TO S601-STORE-NAME.
017900*
018000 B020-MOVE-FIELDS-TO-SCREEN.
018100*
018200     IF  MMMM-REC-ACTIVE
018300     OR  MMMM-REC-CLOSED
018400         MOVE 'N'                TO S601-CLOSE-FLAG
018500     ELSE
018600         MOVE DFHBMDAS           TO S601-CLOSE-FLAG-LIT-A
018700                                    S601-CLOSE-FLAG-LP-A
018800                                    S601-CLOSE-FLAG-RP-A
018900                                    S601-CLOSE-FLAG-A
019000         MOVE MBEMWS-MERCH-NOT-ACTIVE-CLOSED
019100                                 TO S601-ERR-MESSAGE.
019200*
019300     MOVE MBCA-CURRENCY-CODE     TO SS95WS-CURRENCY-CODE.
019400     MOVE MMSM-CLOSE-REASON      TO S601-CLOSE-REASON.
019500     MOVE MMSM-DATE-OPENED       TO SS01WS-JULIAN.
019600     PERFORM SS26PD-NUMERICALLY-EDIT-DATE
019700        THRU SS26PD-NED-EXIT.
019800     MOVE SS01WS-XX-XX-YYYY      TO S601-DATE-OPEN.
019900     MOVE MMSM-DBA-NAME          TO S601-DBA-NAME.
020000     MOVE MMSM-DATE-CLOSED       TO SS01WS-JULIAN.
020100     PERFORM SS26PD-NUMERICALLY-EDIT-DATE
020200        THRU SS26PD-NED-EXIT.
020300     MOVE SS01WS-XX-XX-YYYY      TO S601-DATE-CLOSED.
020400     MOVE MMSM-DBA-CITY          TO S601-DBA-CITY.
020500     MOVE MMSM-DBA-COUNTRY-CODE  TO S601-DBA-STATE.
020600     MOVE MMSM-PURGING-DATE      TO SS01WS-JULIAN.
020700     PERFORM SS26PD-NUMERICALLY-EDIT-DATE
020800        THRU SS26PD-NED-EXIT.
020900     MOVE SS01WS-XX-XX-YYYY      TO S601-DATE-PURGING.
021000     MOVE MMSM-DATE-LAST-ACTIVE  TO SS01WS-JULIAN.
021100     PERFORM SS26PD-NUMERICALLY-EDIT-DATE
021200        THRU SS26PD-NED-EXIT.
021300     MOVE SS01WS-XX-XX-YYYY      TO S601-DATE-LAST-ACT.
021400     MOVE MMSM-STORE-TYPE        TO S601-STORE-TYPE.
021500     MOVE MMSM-AGENT-BANK        TO S601-AGENT.
021600     MOVE MMSM-STORE-SETT-DATE   TO SS01WS-JULIAN.
021700     PERFORM SS26PD-NUMERICALLY-EDIT-DATE
021800        THRU SS26PD-NED-EXIT.
021900     MOVE SS01WS-XX-XX-YYYY      TO S601-SETT-ACT-DATE.
022000     MOVE MMSM-AUTH-CODE         TO S601-AUTH-FLAG.
022100     MOVE MMSM-BRANCH            TO S601-BRANCH.
022200     MOVE MMSM-STORE-SETT-FLAG   TO S601-SETT-FLAG.
022300     MOVE MMSM-AUTH-LOGO         TO S601-AUTH-LOGO.
022400     MOVE MMSM-IMP-DEV-TITLE (1) TO S601-IMP-TITLE1.
022500     MOVE MMSM-IMP-DEV-TITLE (2) TO S601-IMP-TITLE2.
022600     MOVE MMSM-IMP-DEV-TITLE (3) TO S601-IMP-TITLE3.
022700     MOVE MMSM-POS-DEV-TITLE (1) TO S601-POS-TITLE1.
022800     MOVE MMSM-POS-DEV-TITLE (2) TO S601-POS-TITLE2.
022900     MOVE MMSM-POS-DEV-TITLE (3) TO S601-POS-TITLE3.
023000     MOVE MMSM-IMP-DEV-NBR (1)   TO SS95WS-IN-NBR.
023100     PERFORM SS95PD-NAP-ROUTINE
023200                                 THRU SS95PD-NAP-EXIT.
023300     MOVE SS95WS-OUT-NBR-L07     TO S601-IMP-NBR1.
023400     MOVE MMSM-IMP-DEV-NBR (2)   TO SS95WS-IN-NBR.
023500     PERFORM SS95PD-NAP-ROUTINE
023600                                 THRU SS95PD-NAP-EXIT.
023700     MOVE SS95WS-OUT-NBR-L07     TO S601-IMP-NBR2.
023800     MOVE MMSM-IMP-DEV-NBR (3)   TO SS95WS-IN-NBR.
023900     PERFORM SS95PD-NAP-ROUTINE
024000                                 THRU SS95PD-NAP-EXIT.
024100     MOVE SS95WS-OUT-NBR-L07     TO S601-IMP-NBR3.
024200     MOVE MMSM-POS-DEV-NBR (1)   TO SS95WS-IN-NBR.
024300     PERFORM SS95PD-NAP-ROUTINE
024400                                 THRU SS95PD-NAP-EXIT.
024500     MOVE SS95WS-OUT-NBR-L07     TO S601-POS-NBR1.
024600     MOVE MMSM-POS-DEV-NBR (2)   TO SS95WS-IN-NBR.
024700     PERFORM SS95PD-NAP-ROUTINE
024800                                 THRU SS95PD-NAP-EXIT.
024900     MOVE SS95WS-OUT-NBR-L07     TO S601-POS-NBR2.
025000     MOVE MMSM-POS-DEV-NBR (3)   TO SS95WS-IN-NBR.
025100     PERFORM SS95PD-NAP-ROUTINE
025200                                 THRU SS95PD-NAP-EXIT.
025300     MOVE SS95WS-OUT-NBR-L07     TO S601-POS-NBR3.
025400*
025500******************************************
025600*    SET THE CURSOR AND SCREEN NUMBER    *
025700******************************************
025800*
025900     IF  MMMM-REC-ACTIVE
026000     OR  MMMM-REC-CLOSED
026100         MOVE SS08WS-CURSOR      TO S601-CLOSE-FLAG-L
026200     ELSE
026300         MOVE SS08WS-CURSOR      TO S601-ALT-TRANID-L.
026400*
026500     COMPUTE MBCA-SCREEN-NBR     =  MBCA-SCREEN-NBR - 50.
026600*
026700**********************
026800*    SEND THE MAP    *
026900**********************
027000*
027100     MOVE 'BM01'                 TO MBCA-PROGRAM-LOCATION.
027200     PERFORM MB60PD-SEND-MAP-WITH-ERASE
027300                                 THRU MB60PD-SMWE-EXIT.
027400*
027500************************
027600*    RETURN TO CICS    *
027700************************
027800*
027900     MOVE 'PC02'                 TO MBCA-PROGRAM-LOCATION.
028000     PERFORM MB70PD-RETURN-TRANS-ID
028100                                 THRU MB70PD-RTI-EXIT.
028200/
028300 C000-RECEIVE-SCREEN SECTION.
028400*
028500******************************************
028600*    THIS SECTION RECEIVES THE SCREEN    *
028700******************************************
028800*
028900     MOVE 'BM02'                 TO MBCA-PROGRAM-LOCATION
029000     PERFORM MB60PD-RECEIVE-MAP  THRU MB60PD-RM-EXIT.
029100*
029200**************************************************************
029300*    CHECK FOR ANOTHER TRANSACTION ID ENTERED BY THE USER    *
029400**************************************************************
029500*
029600     MOVE 'PC03'                 TO MBCA-PROGRAM-LOCATION.
029700     PERFORM MB60PD-NEW-TRANS-ROUTINE
029800                                 THRU MB60PD-NTR-EXIT.
029900*
030000*****************************************
030100*    READ THE STORE MASTER RECORD       *
030200*****************************************
030300*
030400     MOVE 'FC02'                 TO MBCA-PROGRAM-LOCATION.
030500     PERFORM 9100-READ-MMSM      THRU 9199-READ-MMSM-EXIT.
030600*
030700 C020-FIELD-EDITS.
030800*
030900***************************************
031000*    FIELD EDIT FOR CLOSE STORE FLAG  *
031100***************************************
031200*
031300     IF  S601-CLOSE-FLAG-L       IS GREATER THAN ZERO
031400         MOVE DFHBMASF           TO S601-CLOSE-FLAG-A
031500     ELSE
031600         MOVE 'N'                TO S601-CLOSE-FLAG.
031700*
031800     IF  S601-VALID-CLOSE-FLAG
031900         NEXT SENTENCE
032000     ELSE
032100         GO TO C025-CLOSE-FLAG-ERROR.
032200*
032300     GO TO C030-CLOSE-REASON.
032400*
032500 C025-CLOSE-FLAG-ERROR.
032600*
032700     IF  S601-CLOSE-FLAG-L       IS GREATER THAN ZERO
032800         MOVE DFHBMUBF           TO S601-CLOSE-FLAG-A.
032900*
033000     SET SS08WS-ERROR-SW-YES     TO TRUE.
033100     MOVE DFHBMASB               TO S601-CLOSE-FLAG-LP-A
033200                                    S601-CLOSE-FLAG-RP-A.
033300     MOVE SS08WS-CURSOR          TO S601-CLOSE-FLAG-L.
033400*
033500 C030-CLOSE-REASON.
033600*
033700***************************************
033800*    FIELD EDIT FOR CLOSE REASON      *
033900***************************************
034000*
034100     IF  S601-CLOSE-REASON-L     IS GREATER THAN ZERO
034200         MOVE DFHBMASF           TO S601-CLOSE-REASON-A
034300     ELSE
034400         MOVE MMSM-CLOSE-REASON  TO S601-CLOSE-REASON.
034500*
034600/
034700 D000-RETURN-ERRORS SECTION.
034800*
034900     IF  SS08WS-ERROR-SW-NO
035000         GO TO E000-UPDATE-FILE.
035100*
035200***************************************************************
035300*    INITIALIZE THE STANDARD MAP LINES.  IN AN ERROR          *
035400*    CONDITION, THIS ROUTINE IS PERFORMED PRIMARILY           *
035500*    TO UPDATE THE DATE AND TIME ON THE SCREEN.               *
035600***************************************************************
035700*
035800     PERFORM MB60PD-INIT-STD-MAP-LINES
035900                                 THRU MB60PD-ISML-EXIT.
036000*
036100**********************
036200*    SEND THE MAP    *
036300**********************
036400*
036500     MOVE 'BM03'                 TO MBCA-PROGRAM-LOCATION.
036600     PERFORM MB60PD-SEND-MAP-DATA-ONLY
036700                                 THRU MB60PD-SMDO-EXIT.
036800*
036900************************
037000*    RETURN TO CICS    *
037100************************
037200*
037300     MOVE 'PC04'                 TO MBCA-PROGRAM-LOCATION.
037400     PERFORM MB70PD-RETURN-TRANS-ID
037500                                 THRU MB70PD-RTI-EXIT.
037600/
037700 E000-UPDATE-FILE SECTION.
037800*
037900****************************************************
038000*    READ THE STORE MASTER RECORD FOR UPDATE       *
038100****************************************************
038200*
038300     MOVE 'FC03'                 TO MBCA-PROGRAM-LOCATION.
038400     SET MBIORO-READ-RANDOM-UPDATE
038500                                 TO TRUE.
038600     PERFORM MMSMAO-ACCESS       THRU MMSMAO-ACCESS-EXIT.
038700*
038800 E010-CONTINUE.
038900*
039000*************************************
039100*    OBTAIN STORAGE FOR LOG FILE    *
039200*    RECORD IF DOING MAINTENANCE    *
039300*************************************
039400*
039500     MOVE 'SC02'                 TO MBCA-PROGRAM-LOCATION.
039600     SET MBIORO-GETMAIN          TO TRUE.
039700     PERFORM MML1AO-ACCESS       THRU MML1AO-ACCESS-EXIT.
039800*
039900 E020-UPDATE-FIELDS.
040000*
040100     IF  S601-CLOSE-FLAG-L       IS GREATER THAN ZERO
040200         IF  S601-CLOSE-FLAG IS EQUAL TO 'Y'
040300             SET WS-UPDATE-SW-YES
040400                                 TO TRUE
040500             MOVE 0197           TO MML1-FIELD-CODE
040600             MOVE ZEROES         TO MML1-FIELD-OCCURRENCE
040700                                    MML1-FIELD-OCCURRENCE-2
040800             MOVE MML1WS-VL-01   TO MML1-VARIABLE-LENGTH
040900             MOVE MMSM-REC-STATUS
041000                                 TO MML1-VL01-B-DATA-9
041100             SET MMSM-REC-CLOSED TO TRUE
041200             MOVE MMSM-REC-STATUS
041300                                 TO MML1-VL01-A-DATA-9
041400             MOVE 'FC04'         TO MBCA-PROGRAM-LOCATION
041500             PERFORM 9200-WRITE-LOG-REC-STORE
041600                                 THRU 9299-WLRS-EXIT
041700             MOVE 0196           TO MML1-FIELD-CODE
041800             MOVE ZEROES         TO MML1-FIELD-OCCURRENCE
041900                                    MML1-FIELD-OCCURRENCE-2
042000             MOVE MML1WS-VL-03   TO MML1-VARIABLE-LENGTH
042100             MOVE MMSM-STATUS-CHANGE-OPER
042200                                 TO MML1-VL03-B-DATA-X
042300             MOVE MBCA-OPERATOR-ID
042400                                 TO MMSM-STATUS-CHANGE-OPER
042500             MOVE MMSM-STATUS-CHANGE-OPER
042600                                 TO MML1-VL03-A-DATA-X
042700             MOVE 'FC05'         TO MBCA-PROGRAM-LOCATION
042800             PERFORM 9200-WRITE-LOG-REC-STORE
042900                                 THRU 9299-WLRS-EXIT
043000             MOVE 0194           TO MML1-FIELD-CODE
043100             MOVE ZEROES         TO MML1-FIELD-OCCURRENCE
043200                                    MML1-FIELD-OCCURRENCE-2
043300             MOVE MML1WS-VL-07   TO MML1-VARIABLE-LENGTH
043400             MOVE MMSM-PURGING-DATE
043500                                 TO MML1-VL07-B-DATA-9
043600             MOVE ZEROS          TO MMSM-PURGING-DATE
043700             MOVE MMSM-PURGING-DATE
043800                                 TO MML1-VL07-A-DATA-9
043900             MOVE 'FC06'         TO MBCA-PROGRAM-LOCATION
044000             PERFORM 9200-WRITE-LOG-REC-STORE
044100                                 THRU 9299-WLRS-EXIT.
044200*
044300     IF  S601-CLOSE-REASON-L     IS GREATER THAN ZERO
044400         IF S601-CLOSE-REASON IS NOT EQUAL TO MMSM-CLOSE-REASON
044500             SET WS-UPDATE-SW-YES
044600                                 TO TRUE
044700             MOVE 0192           TO MML1-FIELD-CODE
044800             MOVE ZEROES         TO MML1-FIELD-OCCURRENCE
044900                                    MML1-FIELD-OCCURRENCE-2
045000             MOVE MML1WS-VL-02   TO MML1-VARIABLE-LENGTH
045100             MOVE MMSM-CLOSE-REASON
045200                                 TO MML1-VL02-B-DATA-X
045300             MOVE S601-CLOSE-REASON
045400                                 TO MMSM-CLOSE-REASON
045500             MOVE MMSM-CLOSE-REASON
045600                                 TO MML1-VL02-A-DATA-X
045700             MOVE 'FC07'         TO MBCA-PROGRAM-LOCATION
045800             PERFORM 9200-WRITE-LOG-REC-STORE
045900                                 THRU 9299-WLRS-EXIT.
046000*
046100 E040-UPDATE-MMSM.
046200*
046300**************************************************************
046400*    WRITE A LOG RECORD TO SHOW THAT THE LAST MAINT DATE     *
046500*    AND OPERATOR HAS BEEN UPDATED IF FIELDS WERE CHANGED    *
046600*    ON THE SCREEN                                           *
046700**************************************************************
046800*
046900     IF  WS-UPDATE-SW-YES
047000         MOVE 0198               TO MML1-FIELD-CODE
047100         MOVE ZEROES             TO MML1-FIELD-OCCURRENCE
047200                                    MML1-FIELD-OCCURRENCE-2
047300         MOVE MML1WS-VL-03       TO MML1-VARIABLE-LENGTH
047400         MOVE MMSM-LAST-MAINT-OPER
047500                                 TO MML1-VL03-B-DATA-X
047600         MOVE MBCA-OPERATOR-ID   TO MMSM-LAST-MAINT-OPER
047700         MOVE MMSM-LAST-MAINT-OPER
047800                                 TO MML1-VL03-A-DATA-X
047900         MOVE 'FC08'             TO MBCA-PROGRAM-LOCATION
048000         PERFORM 9200-WRITE-LOG-REC-STORE
048100                                 THRU 9299-WLRS-EXIT
048200         MOVE 0199               TO MML1-FIELD-CODE
048300         MOVE MML1WS-VL-07       TO MML1-VARIABLE-LENGTH
048400         MOVE MMSM-LAST-MAINT-DATE
048500                                 TO MML1-VL07-B-DATA-9
048600         MOVE MBCA-START-DATE    TO MMSM-LAST-MAINT-DATE
048700         MOVE MMSM-LAST-MAINT-DATE
048800                                 TO MML1-VL07-A-DATA-9
048900         MOVE 'FC09'             TO MBCA-PROGRAM-LOCATION
049000         PERFORM 9200-WRITE-LOG-REC-STORE
049100                                 THRU 9299-WLRS-EXIT.
049200*
049300**************************************************************
049400*    REWRITE THE STORE MASTER RECORD                         *
049500*    IF FIELDS HAVE BEEN CHANGED ON THE SCREEN, OR           *
049600*    UNLOCK IT IF THEY HAVE NOT                              *
049700**************************************************************
049800*
049900     IF  WS-UPDATE-SW-YES
050000         MOVE 'FC10'             TO MBCA-PROGRAM-LOCATION
050100         SET MBIORO-REWRITE      TO TRUE
050200         PERFORM MMSMAO-ACCESS   THRU MMSMAO-ACCESS-EXIT
050300     ELSE
050400         MOVE 'FC11'             TO MBCA-PROGRAM-LOCATION
050500         SET MBIORO-UNLOCK       TO TRUE
050600         PERFORM MMSMAO-ACCESS   THRU MMSMAO-ACCESS-EXIT.
050700/
050800 F000-SETUP-COMMAREA SECTION.
050900*
051000***************************************************************
051100*  SET UP COMMAREA FIELDS AND TRANSFER TO THE NEXT PROGRAM    *
051200***************************************************************
051300*
051400     MOVE MBCA-EIBAID            TO SS08WS-EIBAID.
051500*
051600     PERFORM MB60PD-EDIT-PAGE-NBR
051700                                 THRU MB60PD-EPN-EXIT.
051800*
051900     IF  SS08WS-VALID-PF-KEY
052000     OR  SS08WS-EIBAID-VALID-PF-KEY
052100         SET MBCA-INITIAL-SCREEN-NBR
052200                                 TO TRUE.
052300*
052400     MOVE 'PC05'                 TO MBCA-PROGRAM-LOCATION.
052500     PERFORM MB70PD-XCTL-TO-MBOXCTL
052600                                 THRU MB70PD-XTM-EXIT.
052700/
052800 9000-PERFORMED-AREA SECTION.
052900*
053000 9100-READ-MMSM.
053100*
053200*****************************************
053300*    READ THE STORE MASTER RECORD       *
053400*****************************************
053500*
053600     MOVE MBCA-MERCHANT-ORG      TO MBIOWS-MMSM-ORG
053700                                    S601-ORG.
053800     MOVE MBCA-STORE             TO MBIOWS-MMSM-STORE
053900                                    S601-STORE.
054000     SET MBIORO-READ-RANDOM      TO TRUE.
054100     PERFORM MMSMAO-ACCESS       THRU MMSMAO-ACCESS-EXIT.
054200*
054300 9199-READ-MMSM-EXIT.
054400     EXIT.
054500*
054600 9200-WRITE-LOG-REC-STORE.
054700*
054800     MOVE 'SM'                   TO MML1-FILE-CODE.
054900     MOVE MBCA-MERCHANT-ORG      TO MML1-MMSM-ORG.
055000     MOVE MBCA-STORE             TO MML1-MMSM-STORE.
055100     MOVE MBCA-SIGNON-NAME       TO MML1-SIGNON-NAME.
055200     MOVE MBCA-TERMINAL-ID       TO MML1-TERMINAL-ID.
055300     MOVE ZEROS                  TO MML1-SOURCE-CODE.
055400     MOVE MBCA-FIELD-SECURITY    TO MML1-FIELD-SECURITY.
055500     SET MBIORO-WRITE            TO TRUE.
055600     PERFORM MML1AO-ACCESS       THRU MML1AO-ACCESS-EXIT.
055700     MOVE SPACES                 TO MML1-VARIABLE-AREA.
055800*
055900 9299-WLRS-EXIT.
056000     EXIT.
056100*
056200/
056300 Z000-COPIED-ROUTINES SECTION.
056400**********************************
056500*    JUL TO GREG DATE ROUTINE    *
056600**********************************
056700*
056800     COPY SS08PD.
056900/
057000     COPY SS26PD.
057100/
057200     COPY SS27PD.
057300/
057400*********************************
057500*    LINE 24 PF KEYS ROUTINE    *
057600*********************************
057700*
057800     COPY SS15PD.
057900/
058000************************************************
058100*    STORE MASTER RECORD ACCESS ROUTINES       *
058200************************************************
058300*
058400     COPY MMSMAO.
058500/
058600************************************************
058700*    MERCHANT MASTER RECORD ACCESS ROUTINES    *
058800************************************************
058900*
059000     COPY MMMMAO.
059100/
059200*****************************************
059300*    LOG FILE RECORD ACCESS ROUTINES    *
059400*****************************************
059500*
059600     COPY MML1AO.
059700/
059800*******************************************
059900*    FORMAT NBR AND AMTS BY CURRENCY CODE *
060000*******************************************
060100*
060200     COPY SS95PDO REPLACING ==:XXCA:== BY ==MBCA==.
060300/
060400*****************************
060500*    ONLINE MAP ROUTINES    *
060600*****************************
060700*
060800     COPY MB60PD REPLACING 'MBMAPXX' BY 'MB6S01 '
060900                           MBMAPXXI BY MB6S01I
061000                           MBMAPXXO BY MB6S01O.
061100/
061200***************************
061300*    ONLINE PROCEDURES    *
061400***************************
061500*
061600     COPY MB70PD.
061700/
061800     COPY SMFTPXO.
