000100 IDENTIFICATION DIVISION.
000200 PROGRAM-ID. MBO7S01.
000201*       RELEASE DATE=08/24/01.        REVISION LEVEL=08.06      *
000202*****************************************************************
000203*WARNING.  THIS COMPUTER PROGRAM IS PROTECTED BY COPYRIGHT LAW  *
000204*AND INTERNATIONAL TREATIES.  UNAUTHORIZED REPRODUCTION OR      *
000205*DISTRIBUTION OF THIS PROGRAM, OR ANY PORTION OF IT, MAY RESULT *
000206*IN SEVERE CIVIL AND CRIMINAL PENATLIES, AND WILL BE PROSECUTED *
000207*TO THE MAXIMUM EXTENT POSSIBLE UNDER THE LAW.                  *
000208*COPYRIGHT 1999 PAYSYS INTERNATIONAL, INC.  ALL RIGHTS RESERVED.*
000209*****************************************************************
000300*****************************************************************
000400*                                                               *
000500*   V - PLUS  M E R C H A N T   B A N K C A R D   S Y S T E M   *
000600*                                                               *
000700*      MBO7S01 - STORE PURGING                                  *
000800*                SCREEN 01                                      *
000900*                                                               *
001000*              1. TRANSIDS                                      *
001100*                 A. MB7S                                       *
001200*              2. MAPS USED -                                   *
001300*                 A. MB7S01 (SCREEN 01)                         *
001400*              3. FILES USED -                                  *
001500*                 A. MMSM (STORE MASTER FILE)                   *
001600*                 B. MML1 (LOG FILE)                            *
001700*                                                               *
001800*****************************************************************
001900*
002000 ENVIRONMENT DIVISION.
002100*
002200 DATA DIVISION.
002300*
002400 WORKING-STORAGE SECTION.
002500*
002600 01  FILLER                  PIC  X(12)      VALUE '** WS-BEG **'.
002700*
002800 01  FILLER                  PIC  X(17)      VALUE
002900     'PROGRAM SWITCHES:'.
003000*
003100 01  WS-PROGRAM-SWITCHES.
003200     03  WS-UPDATE-SW        PIC  X(01)      VALUE 'N'.
003300         88  WS-UPDATE-SW-YES                VALUE 'Y'.
003400         88  WS-UPDATE-SW-NO                 VALUE 'N'.
003500/
003600 01  FILLER                  PIC  X(29)      VALUE
003700     'I/O REQUEST BLOCK WORK AREAS:'.
003800*
003900     COPY MBIOWS.
004000/
004100 01  FILLER                  PIC  X(21)      VALUE
004200     'ERROR MESSAGES TABLE:'.
004300*
004400     COPY MBEMWS.
004500/
004600 01  FILLER                  PIC  X(18)      VALUE
004700     'I/O REQUEST BLOCK:'.
004800*
004900     COPY MBIORO.
005000/
005100 01  FILLER                  PIC  X(25)      VALUE
005200     'LOG RECORD REQUEST BLOCK:'.
005300*
005400     COPY MML1WS REPLACING ==:MML1:== BY ==MML1==.
005500/
005600 01  FILLER                  PIC  X(31)      VALUE
005700     'DYNAMICALLY CALLED SUBROUTINES:'.
005800*
005900     COPY MB00WS.
006000/
006100 01  FILLER                  PIC  X(37)      VALUE
006200     'FORMAT NBR AND AMTS BY CURRENCY CODE:'.
006300*
006400     COPY SS95WS.
006500/
006600 01  FILLER                  PIC  X(20)      VALUE
006700     'CCS DATE WORK AREAS:'.
006800*
006900     COPY SS01WS.
007000/
007100 01  FILLER                  PIC  X(15)      VALUE
007200     'CCS WORK AREAS:'.
007300*
007400     COPY SS08WS.
007500/
007600     COPY SS00WS.
007700/
007800     COPY SMFTWS.
007900/
008000     COPY SMPTRL REPLACING ==:SMPT:== BY ==SMPT==.
008100/
008200     COPY MB61LK.
008300/
008400 01  FILLER                  PIC  X(12)      VALUE '** WS-END **'.
008500/
008600 LINKAGE SECTION.
008700*
008800 01  DFHCOMMAREA.
008900*
009000     COPY MB60WS.
009100/
009200********************************
009300*    STORE PURGING MAP         *
009400********************************
009500*
009600     COPY MB7S01.
009700/
009800***********************************************
009900*    STORE PURGING MAP REDEFINITION           *
010000***********************************************
010100*
010200     COPY MB7S01R.
010300/
010400****************************************
010500*    STORE MASTER  RECORD LAYOUT       *
010600****************************************
010700*
010800     COPY MMSMRL.
010900/
011000***************************
011100*    LOG RECORD LAYOUT    *
011200***************************
011300*
011400     COPY MML1RL REPLACING ==:MML1:== BY ==MML1==.
011500/
011600 PROCEDURE DIVISION.
011700*
011800 A000-HOUSEKEEPING SECTION.
011900*
012000 A020-INIT.
012100*
012200     MOVE 'PC01'                 TO MBCA-PROGRAM-LOCATION.
012300     PERFORM MB70PD-ON-LINE-HOUSEKEEPING
012400                                 THRU MB70PD-OLH-EXIT.
012500*
012600     SET SS95WS-FUNCTION-INITIALIZE
012700                                 TO TRUE.
012800     PERFORM SS95PD-NAP-ROUTINE
012900        THRU SS95PD-NAP-EXIT.
013000*
013100     IF  MBCA-RECEIVE-SCREEN
013200         GO TO C000-RECEIVE-SCREEN.
013300/
013400 B000-SEND-SCREEN SECTION.
013500*
013600*********************************************
013700*    GET CICS STORAGE NEEDED FOR THE MAP    *
013800*********************************************
013900*
014000     MOVE 'SC01'                 TO MBCA-PROGRAM-LOCATION.
014100     PERFORM MB60PD-GETMAIN-FOR-MAP
014200                                 THRU MB60PD-GFM-EXIT.
014300*
014400*******************************************
014500*    INITIALIZE THE STANDARD MAP LINES    *
014600*******************************************
014700*
014800     PERFORM MB60PD-INIT-STD-MAP-LINES
014900                                 THRU MB60PD-ISML-EXIT.
015000*
015100*****************************************
015200*    READ THE STORE MASTER RECORD       *
015300*****************************************
015400*
015500     MOVE 'FC01'                 TO MBCA-PROGRAM-LOCATION.
015600     PERFORM 9100-READ-MMSM      THRU 9199-READ-MMSM-EXIT.
015700*
015800*********************************************
015900*    MOVE THE PRIMARY NAME TO THE SCREEN    *
016000*********************************************
016100*
016200     MOVE MMSM-NA-LINE (1 1)     TO S701-STORE-NAME.
016300*
016400 B020-MOVE-FIELDS-TO-SCREEN.
016500*
016600     IF  MMSM-SETT-HIST-NOT-PRESENT
016700         MOVE 'N'                TO S701-CLOSE-FLAG
016800     ELSE
016900         MOVE DFHBMDAS           TO S701-CLOSE-FLAG-LIT-A
017000                                    S701-CLOSE-FLAG-LP-A
017100                                    S701-CLOSE-FLAG-RP-A
017200                                    S701-CLOSE-FLAG-A
017300         MOVE 'SETTLEMENT HISTORY IS PRESENT CLOSE FLAG DARKENED'
017400                                 TO S701-ERR-MESSAGE.
017500*
017600     MOVE MBCA-CURRENCY-CODE     TO SS95WS-CURRENCY-CODE.
017700     MOVE MMSM-CLOSE-REASON      TO S701-CLOSE-REASON.
017800     MOVE MMSM-DATE-OPENED       TO SS01WS-JULIAN.
017900     PERFORM SS26PD-NUMERICALLY-EDIT-DATE
018000        THRU SS26PD-NED-EXIT.
018100     MOVE SS01WS-XX-XX-YYYY      TO S701-DATE-OPEN.
018200     MOVE MMSM-DBA-NAME          TO S701-DBA-NAME.
018300     MOVE MMSM-DATE-CLOSED       TO SS01WS-JULIAN.
018400     PERFORM SS26PD-NUMERICALLY-EDIT-DATE
018500        THRU SS26PD-NED-EXIT.
018600     MOVE SS01WS-XX-XX-YYYY      TO S701-DATE-CLOSED.
018700     MOVE MMSM-DBA-CITY          TO S701-DBA-CITY.
018800     MOVE MMSM-DBA-COUNTRY-CODE  TO S701-DBA-STATE.
018900     MOVE MMSM-DATE-LAST-ACTIVE  TO SS01WS-JULIAN.
019000     PERFORM SS26PD-NUMERICALLY-EDIT-DATE
019100        THRU SS26PD-NED-EXIT.
019200     MOVE SS01WS-XX-XX-YYYY      TO S701-DATE-LAST-ACT.
019300     MOVE MMSM-STORE-TYPE        TO S701-STORE-TYPE.
019400     MOVE MMSM-AGENT-BANK        TO S701-AGENT.
019500     MOVE MMSM-STORE-SETT-DATE   TO SS01WS-JULIAN.
019600     PERFORM SS26PD-NUMERICALLY-EDIT-DATE
019700        THRU SS26PD-NED-EXIT.
019800     MOVE SS01WS-XX-XX-YYYY      TO S701-SETT-ACT-DATE.
019900     MOVE MMSM-AUTH-CODE         TO S701-AUTH-FLAG.
020000     MOVE MMSM-BRANCH            TO S701-BRANCH.
020100     MOVE MMSM-STORE-SETT-FLAG   TO S701-SETT-FLAG.
020200     MOVE MMSM-AUTH-LOGO         TO S701-AUTH-LOGO.
020300     MOVE MMSM-IMP-DEV-TITLE (1) TO S701-IMP-TITLE1.
020400     MOVE MMSM-IMP-DEV-TITLE (2) TO S701-IMP-TITLE2.
020500     MOVE MMSM-IMP-DEV-TITLE (3) TO S701-IMP-TITLE3.
020600     MOVE MMSM-POS-DEV-TITLE (1) TO S701-POS-TITLE1.
020700     MOVE MMSM-POS-DEV-TITLE (2) TO S701-POS-TITLE2.
020800     MOVE MMSM-POS-DEV-TITLE (3) TO S701-POS-TITLE3.
020900     MOVE MMSM-IMP-DEV-NBR (1)   TO SS95WS-IN-NBR.
021000     PERFORM SS95PD-NAP-ROUTINE
021100                                 THRU SS95PD-NAP-EXIT.
021200     MOVE SS95WS-OUT-NBR-L07     TO S701-IMP-NBR1.
021300     MOVE MMSM-IMP-DEV-NBR (2)   TO SS95WS-IN-NBR.
021400     PERFORM SS95PD-NAP-ROUTINE
021500                                 THRU SS95PD-NAP-EXIT.
021600     MOVE SS95WS-OUT-NBR-L07     TO S701-IMP-NBR2.
021700     MOVE MMSM-IMP-DEV-NBR (3)   TO SS95WS-IN-NBR.
021800     PERFORM SS95PD-NAP-ROUTINE
021900                                 THRU SS95PD-NAP-EXIT.
022000     MOVE SS95WS-OUT-NBR-L07     TO S701-IMP-NBR3.
022100     MOVE MMSM-POS-DEV-NBR (1)   TO SS95WS-IN-NBR.
022200     PERFORM SS95PD-NAP-ROUTINE
022300                                 THRU SS95PD-NAP-EXIT.
022400     MOVE SS95WS-OUT-NBR-L07     TO S701-POS-NBR1.
022500     MOVE MMSM-POS-DEV-NBR (2)   TO SS95WS-IN-NBR.
022600     PERFORM SS95PD-NAP-ROUTINE
022700                                 THRU SS95PD-NAP-EXIT.
022800     MOVE SS95WS-OUT-NBR-L07     TO S701-POS-NBR2.
022900     MOVE MMSM-POS-DEV-NBR (3)   TO SS95WS-IN-NBR.
023000     PERFORM SS95PD-NAP-ROUTINE
023100                                 THRU SS95PD-NAP-EXIT.
023200     MOVE SS95WS-OUT-NBR-L07     TO S701-POS-NBR3.
023300*
023400******************************************
023500*    SET THE CURSOR AND SCREEN NUMBER    *
023600******************************************
023700*
023800     IF  MMSM-SETT-HIST-NOT-PRESENT
023900         MOVE SS08WS-CURSOR      TO S701-CLOSE-FLAG-L
024000     ELSE
024100         MOVE SS08WS-CURSOR      TO S701-ALT-TRANID-L.
024200*
024300     COMPUTE MBCA-SCREEN-NBR     =  MBCA-SCREEN-NBR - 50.
024400*
024500**********************
024600*    SEND THE MAP    *
024700**********************
024800*
024900     MOVE 'BM01'                 TO MBCA-PROGRAM-LOCATION.
025000     PERFORM MB60PD-SEND-MAP-WITH-ERASE
025100                                 THRU MB60PD-SMWE-EXIT.
025200*
025300************************
025400*    RETURN TO CICS    *
025500************************
025600*
025700     MOVE 'PC02'                 TO MBCA-PROGRAM-LOCATION.
025800     PERFORM MB70PD-RETURN-TRANS-ID
025900                                 THRU MB70PD-RTI-EXIT.
026000/
026100 C000-RECEIVE-SCREEN SECTION.
026200*
026300******************************************
026400*    THIS SECTION RECEIVES THE SCREEN    *
026500******************************************
026600*
026700     MOVE 'BM02'                 TO MBCA-PROGRAM-LOCATION
026800     PERFORM MB60PD-RECEIVE-MAP  THRU MB60PD-RM-EXIT.
026900*
027000**************************************************************
027100*    CHECK FOR ANOTHER TRANSACTION ID ENTERED BY THE USER    *
027200**************************************************************
027300*
027400     MOVE 'PC03'                 TO MBCA-PROGRAM-LOCATION.
027500     PERFORM MB60PD-NEW-TRANS-ROUTINE
027600                                 THRU MB60PD-NTR-EXIT.
027700*
027800*****************************************
027900*    READ THE STORE MASTER RECORD       *
028000*****************************************
028100*
028200     MOVE 'FC02'                 TO MBCA-PROGRAM-LOCATION.
028300     PERFORM 9100-READ-MMSM      THRU 9199-READ-MMSM-EXIT.
028400*
028500 C020-FIELD-EDITS.
028600*
028700***************************************
028800*    FIELD EDIT FOR CLOSE STORE FLAG  *
028900***************************************
029000*
029100     IF  S701-CLOSE-FLAG-L       IS GREATER THAN ZERO
029200         MOVE DFHBMASF           TO S701-CLOSE-FLAG-A
029300     ELSE
029400         MOVE 'N'                TO S701-CLOSE-FLAG.
029500*
029600     IF  S701-VALID-CLOSE-FLAG
029700         NEXT SENTENCE
029800     ELSE
029900         GO TO C025-CLOSE-FLAG-ERROR.
030000*
030100     GO TO D000-RETURN-ERRORS.
030200*
030300 C025-CLOSE-FLAG-ERROR.
030400*
030500     IF  S701-CLOSE-FLAG-L       IS GREATER THAN ZERO
030600         MOVE DFHBMUBF           TO S701-CLOSE-FLAG-A.
030700*
030800     SET SS08WS-ERROR-SW-YES     TO TRUE.
030900     MOVE DFHBMASB               TO S701-CLOSE-FLAG-LP-A
031000                                    S701-CLOSE-FLAG-RP-A.
031100     MOVE SS08WS-CURSOR          TO S701-CLOSE-FLAG-L.
031200*
031300/
031400 D000-RETURN-ERRORS SECTION.
031500*
031600     IF  SS08WS-ERROR-SW-NO
031700         GO TO E000-UPDATE-FILE.
031800*
031900***************************************************************
032000*    INITIALIZE THE STANDARD MAP LINES.  IN AN ERROR          *
032100*    CONDITION, THIS ROUTINE IS PERFORMED PRIMARILY           *
032200*    TO UPDATE THE DATE AND TIME ON THE SCREEN.               *
032300***************************************************************
032400*
032500     PERFORM MB60PD-INIT-STD-MAP-LINES
032600                                 THRU MB60PD-ISML-EXIT.
032700*
032800**********************
032900*    SEND THE MAP    *
033000**********************
033100*
033200     MOVE 'BM03'                 TO MBCA-PROGRAM-LOCATION.
033300     PERFORM MB60PD-SEND-MAP-DATA-ONLY
033400                                 THRU MB60PD-SMDO-EXIT.
033500*
033600************************
033700*    RETURN TO CICS    *
033800************************
033900*
034000     MOVE 'PC04'                 TO MBCA-PROGRAM-LOCATION.
034100     PERFORM MB70PD-RETURN-TRANS-ID
034200                                 THRU MB70PD-RTI-EXIT.
034300/
034400 E000-UPDATE-FILE SECTION.
034500*
034600****************************************************
034700*    READ THE STORE MASTER RECORD FOR UPDATE       *
034800****************************************************
034900*
035000     MOVE 'FC03'                 TO MBCA-PROGRAM-LOCATION.
035100     SET MBIORO-READ-RANDOM-UPDATE
035200                                 TO TRUE.
035300     PERFORM MMSMAO-ACCESS       THRU MMSMAO-ACCESS-EXIT.
035400*
035500 E010-CONTINUE.
035600*
035700*************************************
035800*    OBTAIN STORAGE FOR LOG FILE    *
035900*    RECORD IF DOING MAINTENANCE    *
036000*************************************
036100*
036200     MOVE 'SC02'                 TO MBCA-PROGRAM-LOCATION.
036300     SET MBIORO-GETMAIN          TO TRUE.
036400     PERFORM MML1AO-ACCESS       THRU MML1AO-ACCESS-EXIT.
036500*
036600 E020-UPDATE-FIELDS.
036700*
036800     IF  S701-CLOSE-FLAG-L       IS GREATER THAN ZERO
036900         IF S701-CLOSE-FLAG IS EQUAL TO 'Y'
037000             SET WS-UPDATE-SW-YES
037100                                 TO TRUE
037200             MOVE 0197           TO MML1-FIELD-CODE
037300             MOVE ZEROES         TO MML1-FIELD-OCCURRENCE
037400                                    MML1-FIELD-OCCURRENCE-2
037500             MOVE MML1WS-VL-01   TO MML1-VARIABLE-LENGTH
037600             MOVE MMSM-REC-STATUS
037700                                 TO MML1-VL01-B-DATA-9
037800             SET MMSM-REC-PENDING-PURGE
037900                                 TO TRUE
038000             MOVE MMSM-REC-STATUS
038100                                 TO MML1-VL01-A-DATA-9
038200             MOVE 'FC04'         TO MBCA-PROGRAM-LOCATION
038300             PERFORM 9200-WRITE-LOG-REC-STORE
038400                                 THRU 9299-WLRS-EXIT
038500             MOVE 0196           TO MML1-FIELD-CODE
038600             MOVE ZEROES         TO MML1-FIELD-OCCURRENCE
038700                                    MML1-FIELD-OCCURRENCE-2
038800             MOVE MML1WS-VL-03   TO MML1-VARIABLE-LENGTH
038900             MOVE MMSM-STATUS-CHANGE-OPER
039000                                 TO MML1-VL03-B-DATA-X
039100             MOVE MBCA-OPERATOR-ID
039200                                 TO MMSM-STATUS-CHANGE-OPER
039300             MOVE MMSM-STATUS-CHANGE-OPER
039400                                 TO MML1-VL03-A-DATA-X
039500             MOVE 'FC05'         TO MBCA-PROGRAM-LOCATION
039600             PERFORM 9200-WRITE-LOG-REC-STORE
039700                                 THRU 9299-WLRS-EXIT.
039800*
039900 E040-UPDATE-MMSM.
040000*
040100**************************************************************
040200*    WRITE A LOG RECORD TO SHOW THAT THE LAST MAINT DATE     *
040300*    AND OPERATOR HAS BEEN UPDATED IF FIELDS WERE CHANGED    *
040400*    ON THE SCREEN                                           *
040500**************************************************************
040600*
040700     IF  WS-UPDATE-SW-YES
040800         MOVE 0198               TO MML1-FIELD-CODE
040900         MOVE ZEROES             TO MML1-FIELD-OCCURRENCE
041000                                    MML1-FIELD-OCCURRENCE-2
041100         MOVE MML1WS-VL-03       TO MML1-VARIABLE-LENGTH
041200         MOVE MMSM-LAST-MAINT-OPER
041300                                 TO MML1-VL03-B-DATA-X
041400         MOVE MBCA-OPERATOR-ID   TO MMSM-LAST-MAINT-OPER
041500         MOVE MMSM-LAST-MAINT-OPER
041600                                 TO MML1-VL03-A-DATA-X
041700         MOVE 'FC06'             TO MBCA-PROGRAM-LOCATION
041800         PERFORM 9200-WRITE-LOG-REC-STORE
041900                                 THRU 9299-WLRS-EXIT
042000         MOVE 0199               TO MML1-FIELD-CODE
042100         MOVE MML1WS-VL-07       TO MML1-VARIABLE-LENGTH
042200         MOVE MMSM-LAST-MAINT-DATE
042300                                 TO MML1-VL07-B-DATA-9
042400         MOVE MBCA-START-DATE    TO MMSM-LAST-MAINT-DATE
042500         MOVE MMSM-LAST-MAINT-DATE
042600                                 TO MML1-VL07-A-DATA-9
042700         MOVE 'FC07'             TO MBCA-PROGRAM-LOCATION
042800         PERFORM 9200-WRITE-LOG-REC-STORE
042900                                 THRU 9299-WLRS-EXIT.
043000*
043100**************************************************************
043200*    REWRITE THE STORE MASTER RECORD                         *
043300*    IF FIELDS HAVE BEEN CHANGED ON THE SCREEN, OR           *
043400*    UNLOCK IT IF THEY HAVE NOT                              *
043500**************************************************************
043600*
043700     IF  WS-UPDATE-SW-YES
043800         MOVE 'FC08'             TO MBCA-PROGRAM-LOCATION
043900         SET MBIORO-REWRITE      TO TRUE
044000         PERFORM MMSMAO-ACCESS   THRU MMSMAO-ACCESS-EXIT
044100     ELSE
044200         MOVE 'FC09'             TO MBCA-PROGRAM-LOCATION
044300         SET MBIORO-UNLOCK       TO TRUE
044400         PERFORM MMSMAO-ACCESS   THRU MMSMAO-ACCESS-EXIT.
044500/
044600 F000-SETUP-COMMAREA SECTION.
044700*
044800***************************************************************
044900*  SET UP COMMAREA FIELDS AND TRANSFER TO THE NEXT PROGRAM    *
045000***************************************************************
045100*
045200     MOVE MBCA-EIBAID            TO SS08WS-EIBAID.
045300*
045400     PERFORM MB60PD-EDIT-PAGE-NBR
045500                                 THRU MB60PD-EPN-EXIT.
045600*
045700     IF  SS08WS-VALID-PF-KEY
045800     OR  SS08WS-EIBAID-VALID-PF-KEY
045900         SET MBCA-INITIAL-SCREEN-NBR
046000                                 TO TRUE.
046100*
046200     MOVE 'PC05'                 TO MBCA-PROGRAM-LOCATION.
046300     PERFORM MB70PD-XCTL-TO-MBOXCTL
046400                                 THRU MB70PD-XTM-EXIT.
046500/
046600 9000-PERFORMED-AREA SECTION.
046700*
046800 9100-READ-MMSM.
046900*
047000*****************************************
047100*    READ THE STORE MASTER RECORD       *
047200*****************************************
047300*
047400     MOVE MBCA-MERCHANT-ORG      TO MBIOWS-MMSM-ORG
047500                                    S701-ORG.
047600     MOVE MBCA-STORE             TO MBIOWS-MMSM-STORE
047700                                    S701-STORE.
047800     SET MBIORO-READ-RANDOM      TO TRUE.
047900     PERFORM MMSMAO-ACCESS       THRU MMSMAO-ACCESS-EXIT.
048000*
048100 9199-READ-MMSM-EXIT.
048200     EXIT.
048300*
048400 9200-WRITE-LOG-REC-STORE.
048500*
048600     MOVE 'SM'                   TO MML1-FILE-CODE.
048700     MOVE MBCA-MERCHANT-ORG      TO MML1-MMSM-ORG.
048800     MOVE MBCA-STORE             TO MML1-MMSM-STORE.
048900     MOVE MBCA-SIGNON-NAME       TO MML1-SIGNON-NAME.
049000     MOVE MBCA-TERMINAL-ID       TO MML1-TERMINAL-ID.
049100     MOVE ZEROS                  TO MML1-SOURCE-CODE.
049200     MOVE MBCA-FIELD-SECURITY    TO MML1-FIELD-SECURITY.
049300     SET MBIORO-WRITE            TO TRUE.
049400     PERFORM MML1AO-ACCESS       THRU MML1AO-ACCESS-EXIT.
049500     MOVE SPACES                 TO MML1-VARIABLE-AREA.
049600*
049700 9299-WLRS-EXIT.
049800     EXIT.
049900/
050000 Z000-COPIED-ROUTINES SECTION.
050100**********************************
050200*    JUL TO GREG DATE ROUTINE    *
050300**********************************
050400*
050500     COPY SS08PD.
050600/
050700     COPY SS26PD.
050800/
050900     COPY SS27PD.
051000/
051100*********************************
051200*    LINE 24 PF KEYS ROUTINE    *
051300*********************************
051400*
051500     COPY SS15PD.
051600/
051700************************************************
051800*    STORE MASTER RECORD ACCESS ROUTINES       *
051900************************************************
052000*
052100     COPY MMSMAO.
052200/
052300*****************************************
052400*    LOG FILE RECORD ACCESS ROUTINES    *
052500*****************************************
052600*
052700     COPY MML1AO.
052800/
052900*******************************************
053000*    FORMAT NBR AND AMTS BY CURRENCY CODE *
053100*******************************************
053200*
053300     COPY SS95PDO REPLACING ==:XXCA:== BY ==MBCA==.
053400/
053500*****************************
053600*    ONLINE MAP ROUTINES    *
053700*****************************
053800*
053900     COPY MB60PD REPLACING 'MBMAPXX' BY 'MB7S01 '
054000                           MBMAPXXI BY MB7S01I
054100                           MBMAPXXO BY MB7S01O.
054200/
054300***************************
054400*    ONLINE PROCEDURES    *
054500***************************
054600*
054700     COPY MB70PD.
054800/
054900     COPY SMFTPXO.
