000100 IDENTIFICATION DIVISION.
000200 PROGRAM-ID. MBO9B00.
000201*       RELEASE DATE=08/24/01.        REVISION LEVEL=08.06      *
000202*****************************************************************
000203*WARNING.  THIS COMPUTER PROGRAM IS PROTECTED BY COPYRIGHT LAW  *
000204*AND INTERNATIONAL TREATIES.  UNAUTHORIZED REPRODUCTION OR      *
000205*DISTRIBUTION OF THIS PROGRAM, OR ANY PORTION OF IT, MAY RESULT *
000206*IN SEVERE CIVIL AND CRIMINAL PENATLIES, AND WILL BE PROSECUTED *
000207*TO THE MAXIMUM EXTENT POSSIBLE UNDER THE LAW.                  *
000208*COPYRIGHT 1999 PAYSYS INTERNATIONAL, INC.  ALL RIGHTS RESERVED.*
000209*****************************************************************
000300*****************************************************************
000400*                                                               *
000500*   V - PLUS  M E R C H A N T   B A N K C A R D   S Y S T E M   *
000600*                                                               *
000700*      MBO9B00 - BAR CODE STATUS CHANGE                         *
000800*                LOCATE SCREEN 00                               *
000900*                                                               *
001000*              1. TRANSIDS                                      *
001100*                 A. MB9B                                       *
001200*              2. MAPS USED -                                   *
001300*                 A. MB9B00 (LOCATE MAP)                        *
001400*              3. FILES USED -                                  *
001500*                 A. MMOC (ORG CONTROL FILE)                    *
001600*                 B. MMBC (BAR CODE FILE)                       *
001700*                                                               *
001800*****************************************************************
001900*
002000 ENVIRONMENT DIVISION.
002100*
002200 DATA DIVISION.
002300*
002400 WORKING-STORAGE SECTION.
002500*
002600 01  FILLER                  PIC  X(12)      VALUE
002700     '** WS-BEG **'.
002800*
002900 01  FILLER                  PIC  X(14)      VALUE
003000     'MISCELLANEOUS:'.
003100*
003200 01  WS-MISCELLANEOUS.
003300     03  WS-ORG-LOW          PIC S9(03)      COMP-3
003400                                             VALUE +001.
003500     03  WS-ORG-HIGH         PIC S9(03)      COMP-3
003600                                             VALUE +998.
003700/
003800 01  FILLER                  PIC  X(29)      VALUE
003900     'I/O REQUEST BLOCK WORK AREAS:'.
004000*
004100     COPY MBIOWS.
004200/
004300 01  FILLER                  PIC  X(18)      VALUE
004400     'I/O REQUEST BLOCK:'.
004500*
004600     COPY MBIORO.
004700/
004800 01  FILLER                  PIC  X(21)      VALUE
004900     'ERROR MESSAGES TABLE:'.
005000*
005100     COPY MBEMWS.
005200/
005300 01  FILLER                  PIC  X(28)      VALUE
005400     'BAR CODE INITIALIZER RECORD:'.
005500*
005600     COPY MMBCIR.
005700/
005800 01  FILLER                  PIC  X(20)      VALUE
005900     'CCS DATE WORK AREAS:'.
006000*
006100     COPY SS01WS.
006200/
006300 01  FILLER                  PIC  X(15)      VALUE
006400     'CCS WORK AREAS:'.
006500*
006600     COPY SS08WS.
006700/
006800     COPY SS00WS.
006900/
007000     COPY SMFTWS.
007100/
007200     COPY SMPTRL REPLACING ==:SMPT:== BY ==SMPT==.
007300/
007400     COPY MB61LK.
007500/
007600 01  FILLER                  PIC  X(12)      VALUE
007700     '** WS-END **'.
007800/
007900 LINKAGE SECTION.
008000*
008100 01  DFHCOMMAREA.
008200*
008300     COPY MB60WS.
008400/
008500******************************************
008600*    BAR CODE LOCATE MAP                 *
008700******************************************
008800*
008900     COPY MB9B00.
009000/
009100*******************************************************
009200*    BAR CODE LOCATE MAP REDEFINITION                 *
009300*******************************************************
009400*
009500     COPY MB9B00R.
009600/
009700***************************
009800*    ORG RECORD LAYOUT    *
009900***************************
010000*
010100     COPY MMOCRL.
010200/
010300*********************************************
010400*    BAR CODE RECORD LAYOUT                 *
010500*********************************************
010600*
010700     COPY MMBCRL.
010800/
010900 PROCEDURE DIVISION.
011000*
011100 A000-HOUSEKEEPING SECTION.
011200*
011300 A020-INIT.
011400*
011500     MOVE 'PC01'                 TO MBCA-PROGRAM-LOCATION.
011600     PERFORM MB70PD-ON-LINE-HOUSEKEEPING
011700                                 THRU MB70PD-OLH-EXIT.
011800*
011900     IF  MBCA-RECEIVE-SCREEN
012000         GO TO C000-RECEIVE-SCREEN.
012100/
012200 B000-SEND-SCREEN SECTION.
012300*
012400*********************************************
012500*    GET CICS STORAGE NEEDED FOR THE MAP    *
012600*********************************************
012700*
012800     MOVE 'SC01'                 TO MBCA-PROGRAM-LOCATION.
012900     PERFORM MB60PD-GETMAIN-FOR-MAP
013000                                 THRU MB60PD-GFM-EXIT.
013100*
013200*
013300*
013400     IF  MBCA-MMBC-KEY-CODE
013500         IF  MBCA-MERCHANT-ORG IS GREATER THAN ZERO
013600         AND MBCA-INSERT-NBR    IS GREATER THAN ZEROS
013700             MOVE MBCA-MERCHANT-ORG
013800                                 TO B900-ORG
013900             MOVE MBCA-INSERT-NBR
014000                                 TO B900-INSERT-NBR
014100             MOVE DFHBMUNF       TO B900-ORG-A
014200                                    B900-INSERT-NBR-A
014300             IF  MBCA-DIRECT-TRANSFER-CODE
014400             AND MBCA-INITIAL-SCREEN-NBR
014500                 MOVE 00         TO MBCA-SCREEN-NBR
014600                 GO TO C082-READ-ORG
014700             ELSE
014800                 GO TO B020-BUILD-SCREEN.
014900*
015000     IF  MBCA-VALID-KEY-CODES
015100         IF  MBCA-MERCHANT-ORG IS GREATER THAN ZERO
015200             MOVE MBCA-MERCHANT-ORG
015300                                 TO B900-ORG
015400             MOVE DFHBMUNF       TO B900-ORG-A
015500             IF  MBCA-INSERT-NBR IS GREATER THAN ZEROS
015600                 MOVE MBCA-INSERT-NBR
015700                                 TO B900-INSERT-NBR
015800                 MOVE DFHBMUNF   TO B900-INSERT-NBR-A.
015900*
016000 B020-BUILD-SCREEN.
016100*
016200*******************************************
016300*    INITIALIZE THE STANDARD MAP LINES    *
016400*******************************************
016500*
016600     MOVE SS08WS-CURSOR          TO B900-ORG-L.
016700     MOVE 00                     TO MBCA-SCREEN-NBR.
016800     PERFORM MB60PD-INIT-STD-MAP-LINES
016900                                 THRU MB60PD-ISML-EXIT.
017000*
017100**********************
017200*    SEND THE MAP    *
017300**********************
017400*
017500     MOVE 'BM01'                 TO MBCA-PROGRAM-LOCATION.
017600     PERFORM MB60PD-SEND-MAP-WITH-ERASE
017700                                 THRU MB60PD-SMWE-EXIT.
017800*
017900************************
018000*    RETURN TO CICS    *
018100************************
018200*
018300     MOVE 'PC02'                 TO MBCA-PROGRAM-LOCATION.
018400     PERFORM MB70PD-RETURN-TRANS-ID
018500                                 THRU MB70PD-RTI-EXIT.
018600/
018700 C000-RECEIVE-SCREEN SECTION.
018800*
018900*************************************************
019000*    THIS SECTION RECEIVES THE LOCATE SCREEN    *
019100*************************************************
019200*
019300     MOVE 'BM02'                 TO MBCA-PROGRAM-LOCATION.
019400     PERFORM MB60PD-RECEIVE-MAP  THRU MB60PD-RM-EXIT.
019500*
019600**************************************************************
019700*    CHECK FOR ANOTHER TRANSACTION ID ENTERED BY THE USER    *
019800**************************************************************
019900*
020000     MOVE 'PC03'                 TO MBCA-PROGRAM-LOCATION.
020100     PERFORM MB60PD-NEW-TRANS-ROUTINE
020200                                 THRU MB60PD-NTR-EXIT.
020300*
020400 C020-EDIT-SCREEN.
020500*
020600     SET SS08WS-ERROR-SW-NO      TO TRUE.
020700     MOVE MBCA-EIBAID            TO SS08WS-EIBAID.
020800*
020900     IF  (B900-ORG-L IS LESS THAN 1
021000     AND  B900-INSERT-NBR-L IS LESS THAN 1)
021100     AND (SS08WS-VALID-PF-KEY
021200     OR   SS08WS-EIBAID-VALID-PF-KEY)
021300         SET MBCA-INITIAL-SCREEN-NBR
021400                                 TO TRUE
021500         GO TO F090-TRANSFER-XCTL.
021600*
021700******************************************************
021800*    RESET THE FIELD ARRIBUTES TO THEIR NORMAL       *
021900*    PRIOR STATE PRIOR TO ANY EDITING BEING DONE.    *
022000******************************************************
022100*
022200     MOVE DFHBMUNN               TO B900-ORG-A
022300                                    B900-INSERT-NBR-A.
022400     MOVE DFHBMASK               TO B900-ORG-LP-A
022500                                    B900-ORG-RP-A
022600                                    B900-INSERT-NBR-LP-A
022700                                    B900-INSERT-NBR-RP-A.
022800*
022900 C080-EDIT-ORG.
023000*
023100     IF  B900-ORG-L IS EQUAL TO ZERO
023200     OR  B900-ORG IS NOT NUMERIC
023300     OR  B900-ORG IS LESS THAN MBCA-ORG-LOW
023400     OR  B900-ORG IS GREATER THAN MBCA-ORG-HIGH
023500     OR  B900-ORG IS LESS THAN WS-ORG-LOW
023600     OR  B900-ORG IS GREATER THAN WS-ORG-HIGH
023700         MOVE MBEMWS-INVALID-ORG TO B900-ERR-MESSAGE
023800         GO TO C098-ORG-ERROR.
023900*
024000 C082-READ-ORG.
024100*
024200************************************************
024300*    READ THE ORGANIZATION RECORD.  IT MUST    *
024400*    BE ON FILE AND AN ACTIVE RECORD.          *
024500************************************************
024600*
024700     MOVE B900-ORG               TO MBIOWS-MMOC-ORG.
024800     MOVE 'FC03'                 TO MBCA-PROGRAM-LOCATION.
024900     MOVE SS08WS-CICS-FC-NOTFND  TO MBIORO-TEMP-STATUS-1.
025000     SET MBIORO-READ-RANDOM      TO TRUE.
025100     PERFORM MMOCAO-ACCESS       THRU MMOCAO-ACCESS-EXIT.
025200*
025300     IF  SS08WS-RC-FC-NOTFND
025400         MOVE MBEMWS-NOT-ON-FILE TO B900-ERR-MESSAGE
025500     ELSE
025600         IF  MMOC-ADD-PENDING
025700             MOVE MBEMWS-ADD-PENDING
025800                                 TO B900-ERR-MESSAGE
025900         ELSE
026000             IF  MMOC-REC-PURGED
026100                 MOVE MBEMWS-NOT-ACTIVE
026200                                 TO B900-ERR-MESSAGE
026300             ELSE
026400                 MOVE DFHBMUNF   TO B900-ORG-A
026500                 MOVE B900-ORG   TO MBCA-MERCHANT-ORG
026600                 GO TO C100-EDIT-INSERT-NBR.
026700*
026800 C098-ORG-ERROR.
026900*
027000     SET SS08WS-ERROR-SW-YES     TO TRUE.
027100     MOVE DFHBMASB               TO B900-ORG-LP-A
027200                                    B900-ORG-RP-A.
027300     MOVE SS08WS-CURSOR          TO B900-ORG-L.
027400     MOVE DFHBMNBF               TO B900-ORG-A
027500                                    B900-INSERT-NBR-A.
027600     GO TO D000-RETURN-ERRORS.
027700*
027800 C100-EDIT-INSERT-NBR.
027900*
028000***********************************************************
028100*    THE LENGTH FIELD COULD BE CHECKED HERE TO            *
028200*    SEE IF ANYTHING WAS KEYED.                           *
028300***********************************************************
028400*
028500     IF  B900-INSERT-NBR-L IS GREATER THAN ZERO
028600     AND (B900-INSERT-NBR IS EQUAL TO ZEROS
028700     OR  B900-INSERT-NBR IS NOT NUMERIC
028800     OR  B900-INSERT-NBR IS EQUAL TO LOW-VALUES
028900     OR  B900-INSERT-NBR IS EQUAL TO ZEROS OR 99)
029000         MOVE MBEMWS-INVALID-INSERT-NBR
029100                                 TO B900-ERR-MESSAGE
029200         GO TO C118-INSERT-NBR-ERROR.
029300*
029400 C102-READ-INSERT-NBR.
029500*
029600***************************************************************
029700*    READ THE INSERT-NBR RECORD. IT MUST BE ON FILE AND       *
029800*    AN ACTIVE RECORD IF IN MAINTENANCE OR INQUIRY.  IT MUST  *
029900*    NOT BE ON FILE (OR IN AN ADD PENDING STATE), IF IN ADD.  *
030000***************************************************************
030100*
030200     IF  B900-INSERT-NBR IS NOT NUMERIC
030300         MOVE MBEMWS-INVALID-INSERT-NBR
030400                                 TO B900-ERR-MESSAGE
030500         GO TO C118-INSERT-NBR-ERROR.
030600*
030700     IF  B900-INSERT-NBR-1 IS EQUAL TO ZEROS
030800         MOVE MBEMWS-INVALID-INSERT-NBR
030900                                 TO B900-ERR-MESSAGE
031000         GO TO C118-INSERT-NBR-ERROR.
031100*
031200     MOVE B900-ORG               TO MBIOWS-MMBC-ORG.
031300     MOVE B900-INSERT-NBR        TO MBIOWS-MMBC-INSERT-NBR.
031400     MOVE SS08WS-CICS-FC-NOTFND  TO MBIORO-TEMP-STATUS-1.
031500     MOVE 'FC04'                 TO MBCA-PROGRAM-LOCATION.
031600     SET MBIORO-READ-RANDOM      TO TRUE.
031700     PERFORM MMBCAO-ACCESS       THRU MMBCAO-ACCESS-EXIT.
031800*
031900     IF  SS08WS-RC-FC-VALID-RTN-CODE
032000         MOVE B900-INSERT-NBR    TO MBCA-INSERT-NBR.
032100*
032200     IF  SS08WS-RC-FC-VALID-RTN-CODE
032300         IF  MMBC-ADD-PENDING
032400             MOVE MBEMWS-ADD-PENDING
032500                                 TO B900-ERR-MESSAGE
032600             GO TO C118-INSERT-NBR-ERROR
032700         ELSE
032800             GO TO F000-SETUP-COMMAREA
032900     ELSE
033000         MOVE MBEMWS-NOT-ON-FILE
033100                                 TO B900-ERR-MESSAGE
033200         GO TO C118-INSERT-NBR-ERROR.
033300*
033400 C118-INSERT-NBR-ERROR.
033500*
033600     SET SS08WS-ERROR-SW-YES     TO TRUE.
033700     MOVE DFHBMASB               TO B900-INSERT-NBR-LP-A
033800                                    B900-INSERT-NBR-RP-A.
033900     MOVE SS08WS-CURSOR          TO B900-INSERT-NBR-L.
034000     MOVE DFHBMNBF               TO B900-INSERT-NBR-A.
034100/
034200 D000-RETURN-ERRORS SECTION.
034300*
034400     IF  SS08WS-ERROR-SW-NO
034500         GO TO F000-SETUP-COMMAREA
034600     ELSE
034700         IF  SS08WS-VALID-PF-KEY
034800         OR  SS08WS-EIBAID-VALID-PF-KEY
034900             SET MBCA-INITIAL-SCREEN-NBR
035000                                 TO TRUE
035100             GO TO F090-TRANSFER-XCTL.
035200*
035300***************************************************************
035400*    INITIALIZE THE STANDARD MAP LINES.  IN AN ERROR          *
035500*    CONDITION, THIS ROUTINE IS PERFORMED PRIMARILY           *
035600*    TO UPDATE THE DATE AND TIME ON THE SCREEN.               *
035700***************************************************************
035800*
035900     PERFORM MB60PD-INIT-STD-MAP-LINES
036000                                 THRU MB60PD-ISML-EXIT.
036100*
036200**********************
036300*    SEND THE MAP    *
036400**********************
036500*
036600     MOVE 'BM03'                 TO MBCA-PROGRAM-LOCATION.
036700     PERFORM MB60PD-SEND-MAP-WITH-ERASE
036800                                 THRU MB60PD-SMWE-EXIT.
036900*
037000************************
037100*    RETURN TO CICS    *
037200************************
037300*
037400     MOVE 'PC04'                 TO MBCA-PROGRAM-LOCATION.
037500     PERFORM MB70PD-RETURN-TRANS-ID
037600                                 THRU MB70PD-RTI-EXIT.
037700/
037800 F000-SETUP-COMMAREA SECTION.
037900*
038000***************************************************************
038100*  SET UP COMMAREA FIELDS AND TRANSFER TO THE NEXT PROGRAM    *
038200***************************************************************
038300*
038400     MOVE MBCA-EIBAID            TO SS08WS-EIBAID.
038500*
038600     MOVE MBIOWS-MMBC-DIRECT-KEY-CODE
038700                                 TO MBCA-KEY-CODE.
038800*
038900     PERFORM MB60PD-EDIT-PAGE-NBR
039000                                 THRU MB60PD-EPN-EXIT.
039100*
039200     IF  SS08WS-VALID-PF-KEY
039300     OR  SS08WS-EIBAID-VALID-PF-KEY
039400         SET MBCA-INITIAL-SCREEN-NBR
039500                                 TO TRUE.
039600*
039700 F090-TRANSFER-XCTL.
039800*
039900     MOVE 'PC05'                 TO MBCA-PROGRAM-LOCATION.
040000     PERFORM MB70PD-XCTL-TO-MBOXCTL
040100                                 THRU MB70PD-XTM-EXIT.
040200/
040300 Z000-COPIED-ROUTINES SECTION.
040400*
040500**********************************
040600*    JUL TO GREG DATE ROUTINE    *
040700**********************************
040800*
040900     COPY SS08PD.
041000/
041100     COPY SS26PD.
041200/
041300     COPY SS27PD.
041400/
041500*********************************
041600*    LINE 24 PF KEYS ROUTINE    *
041700*********************************
041800*
041900     COPY SS15PD.
042000/
042100*******************************************
042200*    ORG FILE ACCESS ROUTINES             *
042300*******************************************
042400*
042500     COPY MMOCAO.
042600/
042700******************************************************
042800*    BAR CODE RECORD ACCESS ROUTINES                 *
042900******************************************************
043000*
043100     COPY MMBCAO.
043200/
043300*****************************
043400*    ONLINE MAP ROUTINES    *
043500*****************************
043600*
043700     COPY MB60PD REPLACING 'MBMAPXX' BY 'MB9B00 '
043800                           MBMAPXXI BY MB9B00I
043900                           MBMAPXXO BY MB9B00O.
044000/
044100***************************
044200*    ONLINE PROCEDURES    *
044300***************************
044400*
044500     COPY MB70PD.
044600/
044700     COPY SMFTPXO.
