000100 IDENTIFICATION DIVISION.
000200 PROGRAM-ID. MBO9C00.
000201*       RELEASE DATE=08/24/01.        REVISION LEVEL=08.06      *
000202*****************************************************************
000203*WARNING.  THIS COMPUTER PROGRAM IS PROTECTED BY COPYRIGHT LAW  *
000204*AND INTERNATIONAL TREATIES.  UNAUTHORIZED REPRODUCTION OR      *
000205*DISTRIBUTION OF THIS PROGRAM, OR ANY PORTION OF IT, MAY RESULT *
000206*IN SEVERE CIVIL AND CRIMINAL PENATLIES, AND WILL BE PROSECUTED *
000207*TO THE MAXIMUM EXTENT POSSIBLE UNDER THE LAW.                  *
000208*COPYRIGHT 1999 PAYSYS INTERNATIONAL, INC.  ALL RIGHTS RESERVED.*
000209*****************************************************************
000300*****************************************************************
000400*                                                               *
000500*   V - PLUS  M E R C H A N T   B A N K C A R D   S Y S T E M   *
000600*                                                               *
000700*      MBO9C00 - MERCH CHAIN DEFINITION ADD/MAINT/INQ           *
000800*                LOCATE SCREEN 00                               *
000900*                                                               *
001000*              1. TRANSIDS                                      *
001100*                 A. MB9C                                       *
001200*              2. MAPS USED -                                   *
001300*                 A. MB9C00 (LOCATE MAP)                        *
001400*              3. FILES USED -                                  *
001500*                 A. MMOC (ORG CONTROL FILE)                    *
001600*                 B. MMRC (MERCHANT RELATIONSHIP CONTROL)       *
001700*                 C. MMRD (MERCHANT RELATIONSHIP DETAIL)        *
001800*                                                               *
001900*****************************************************************
002000*
002100 ENVIRONMENT DIVISION.
002200*
002300 DATA DIVISION.
002400*
002500 WORKING-STORAGE SECTION.
002600*
002700 01  FILLER                  PIC  X(12)      VALUE
002800     '** WS-BEG **'.
002900*
003000 01  FILLER                  PIC  X(14)      VALUE
003100     'MISCELLANEOUS:'.
003200*
003300 01  WS-MISCELLANEOUS.
003400     03  WS-ORG-LOW          PIC S9(03)      COMP-3
003500                                             VALUE +001.
003600     03  WS-ORG-HIGH         PIC S9(03)      COMP-3
003700                                             VALUE +998.
003800/
003900 01  FILLER                  PIC  X(29)      VALUE
004000     'I/O REQUEST BLOCK WORK AREAS:'.
004100*
004200     COPY MBIOWS.
004300/
004400 01  FILLER                  PIC  X(18)      VALUE
004500     'I/O REQUEST BLOCK:'.
004600*
004700     COPY MBIORO.
004800/
004900 01  FILLER                  PIC  X(21)      VALUE
005000     'ERROR MESSAGES TABLE:'.
005100*
005200     COPY MBEMWS.
005300/
005400 01  FILLER                  PIC  X(20)      VALUE
005500     'CCS DATE WORK AREAS:'.
005600*
005700     COPY SS01WS.
005800/
005900 01  FILLER                  PIC  X(15)      VALUE
006000     'CCS WORK AREAS:'.
006100*
006200     COPY SS08WS.
006300/
006400     COPY SS00WS.
006500/
006600     COPY SMFTWS.
006700/
006800     COPY SMPTRL REPLACING ==:SMPT:== BY ==SMPT==.
006900/
007000     COPY MB61LK.
007100/
007200 01  FILLER                  PIC  X(12)      VALUE
007300     '** WS-END **'.
007400/
007500 LINKAGE SECTION.
007600*
007700 01  DFHCOMMAREA.
007800*
007900     COPY MB60WS.
008000/
008100******************************************
008200*    MERCHANT RELATIONSHIP LOCATE MAP    *
008300******************************************
008400*
008500     COPY MB9C00.
008600/
008700*******************************************************
008800*    MERCHANT RELATIONSHIP LOCATE MAP REDEFINITION    *
008900*******************************************************
009000*
009100     COPY MB9C00R.
009200/
009300***************************
009400*    ORG RECORD LAYOUT    *
009500***************************
009600*
009700     COPY MMOCRL.
009800/
009900*****************************************************
010000*    MERCHANT RELATIONSHIP CONTROL RECORD LAYOUT    *
010100*****************************************************
010200*
010300     COPY MMRCRL.
010400/
010500****************************************************
010600*    MERCHANT RELATIONSHIP DETAIL RECORD LAYOUT    *
010700****************************************************
010800*
010900     COPY MMRDRL REPLACING ==:MMRD:== BY ==MMRD==.
011000/
011100 PROCEDURE DIVISION.
011200*
011300 A000-HOUSEKEEPING SECTION.
011400*
011500 A020-INIT.
011600*
011700     MOVE 'PC01'                 TO MBCA-PROGRAM-LOCATION.
011800     PERFORM MB70PD-ON-LINE-HOUSEKEEPING
011900                                 THRU MB70PD-OLH-EXIT.
012000*
012100     IF  MBCA-RECEIVE-SCREEN
012200         GO TO C000-RECEIVE-SCREEN.
012300/
012400 B000-SEND-SCREEN SECTION.
012500*
012600*********************************************
012700*    GET CICS STORAGE NEEDED FOR THE MAP    *
012800*********************************************
012900*
013000     MOVE 'SC01'                 TO MBCA-PROGRAM-LOCATION.
013100     PERFORM MB60PD-GETMAIN-FOR-MAP
013200                                 THRU MB60PD-GFM-EXIT.
013300*
013400*
013500     IF  MBCA-INITIAL-KEY-CODE
013600     OR  MBCA-PTI-FUNCTION-IS-ADD
013700         GO TO B020-BUILD-SCREEN.
013800*
013900     IF  MBCA-MMRC-KEY-CODE
014000         IF  MBCA-MERCHANT-ORG IS GREATER THAN ZERO
014100         AND MBCA-CHAIN         IS GREATER THAN LOW-VALUE
014200             MOVE MBCA-MERCHANT-ORG
014300                                 TO C900-ORG
014400             MOVE MBCA-CHAIN     TO C900-CHAIN
014500             MOVE DFHBMUNF       TO C900-ORG-A
014600                                    C900-CHAIN-A
014700             IF  MBCA-DIRECT-TRANSFER-CODE
014800             AND MBCA-INITIAL-SCREEN-NBR
014900                 MOVE 00         TO MBCA-SCREEN-NBR
015000                 GO TO C082-READ-ORG
015100             ELSE
015200                 GO TO B020-BUILD-SCREEN.
015300*
015400     IF  MBCA-VALID-KEY-CODES
015500         IF  MBCA-MERCHANT-ORG IS GREATER THAN ZERO
015600             MOVE MBCA-MERCHANT-ORG
015700                                 TO C900-ORG
015800             MOVE DFHBMUNF       TO C900-ORG-A
015900             IF  MBCA-CHAIN IS GREATER THAN LOW-VALUE
016000                 MOVE MBCA-CHAIN
016100                                 TO C900-CHAIN
016200                 MOVE DFHBMUNF   TO C900-CHAIN-A.
016300*
016400 B020-BUILD-SCREEN.
016500*
016600*******************************************
016700*    INITIALIZE THE STANDARD MAP LINES    *
016800*******************************************
016900*
017000     MOVE SS08WS-CURSOR          TO C900-ORG-L.
017100     MOVE 00                     TO MBCA-SCREEN-NBR.
017200     PERFORM MB60PD-INIT-STD-MAP-LINES
017300                                 THRU MB60PD-ISML-EXIT.
017400*
017500     IF  MBCA-MERCHANT-ORG IS GREATER THAN ZEROS
017600         MOVE MBCA-MERCHANT-ORG
017700                                 TO C900-ORG
017800         MOVE DFHBMUNF           TO C900-ORG-A
017900         IF  MBCA-CHAIN IS GREATER THAN ZEROS
018000             MOVE MBCA-CHAIN     TO C900-CHAIN
018100             MOVE DFHBMUNF       TO C900-CHAIN-A.
018200*
018300**********************
018400*    SEND THE MAP    *
018500**********************
018600*
018700     MOVE 'BM01'                 TO MBCA-PROGRAM-LOCATION.
018800     PERFORM MB60PD-SEND-MAP-WITH-ERASE
018900                                 THRU MB60PD-SMWE-EXIT.
019000*
019100************************
019200*    RETURN TO CICS    *
019300************************
019400*
019500     MOVE 'PC02'                 TO MBCA-PROGRAM-LOCATION.
019600     PERFORM MB70PD-RETURN-TRANS-ID
019700                                 THRU MB70PD-RTI-EXIT.
019800/
019900 C000-RECEIVE-SCREEN SECTION.
020000*
020100*************************************************
020200*    THIS SECTION RECEIVES THE LOCATE SCREEN    *
020300*************************************************
020400*
020500     MOVE 'BM02'                 TO MBCA-PROGRAM-LOCATION.
020600     PERFORM MB60PD-RECEIVE-MAP  THRU MB60PD-RM-EXIT.
020700*
020800**************************************************************
020900*    CHECK FOR ANOTHER TRANSACTION ID ENTERED BY THE USER    *
021000**************************************************************
021100*
021200     MOVE 'PC03'                 TO MBCA-PROGRAM-LOCATION.
021300     PERFORM MB60PD-NEW-TRANS-ROUTINE
021400                                 THRU MB60PD-NTR-EXIT.
021500*
021600 C020-EDIT-SCREEN.
021700*
021800     SET SS08WS-ERROR-SW-NO      TO TRUE.
021900     MOVE MBCA-EIBAID            TO SS08WS-EIBAID.
022000*
022100     IF  (C900-ORG-L IS LESS THAN 1
022200     AND  C900-CHAIN-L IS LESS THAN 1)
022300     AND (SS08WS-VALID-PF-KEY
022400     OR   SS08WS-EIBAID-VALID-PF-KEY)
022500         SET MBCA-INITIAL-SCREEN-NBR
022600                                 TO TRUE
022700         GO TO F090-TRANSFER-XCTL.
022800*
022900******************************************************
023000*    RESET THE FIELD ARRIBUTES TO THEIR NORMAL       *
023100*    PRIOR STATE PRIOR TO ANY EDITING BEING DONE.    *
023200******************************************************
023300*
023400     MOVE DFHBMUNN               TO C900-ORG-A
023500                                    C900-CHAIN-A.
023600     MOVE DFHBMASK               TO C900-ORG-LP-A
023700                                    C900-ORG-RP-A
023800                                    C900-CHAIN-LP-A
023900                                    C900-CHAIN-RP-A.
024000*
024100 C080-EDIT-ORG.
024200*
024300     IF  C900-ORG-L IS EQUAL TO ZERO
024400     OR  C900-ORG IS NOT NUMERIC
024500     OR  C900-ORG IS LESS THAN MBCA-ORG-LOW
024600     OR  C900-ORG IS GREATER THAN MBCA-ORG-HIGH
024700     OR  C900-ORG IS LESS THAN WS-ORG-LOW
024800     OR  C900-ORG IS GREATER THAN WS-ORG-HIGH
024900         MOVE MBEMWS-INVALID-ORG TO C900-ERR-MESSAGE
025000         GO TO C098-ORG-ERROR.
025100*
025200 C082-READ-ORG.
025300*
025400************************************************
025500*    READ THE ORGANIZATION RECORD.  IT MUST    *
025600*    BE ON FILE AND AN ACTIVE RECORD.          *
025700************************************************
025800*
025900     MOVE C900-ORG               TO MBIOWS-MMOC-ORG.
026000     MOVE 'FC03'                 TO MBCA-PROGRAM-LOCATION.
026100     MOVE SS08WS-CICS-FC-NOTFND  TO MBIORO-TEMP-STATUS-1.
026200     SET MBIORO-READ-RANDOM      TO TRUE.
026300     PERFORM MMOCAO-ACCESS       THRU MMOCAO-ACCESS-EXIT.
026400*
026500     IF  SS08WS-RC-FC-NOTFND
026600         MOVE MBEMWS-NOT-ON-FILE TO C900-ERR-MESSAGE
026700     ELSE
026800         IF  MMOC-ADD-PENDING
026900             MOVE MBEMWS-ADD-PENDING
027000                                 TO C900-ERR-MESSAGE
027100         ELSE
027200             IF  MMOC-REC-PURGED
027300                 MOVE MBEMWS-NOT-ACTIVE
027400                                 TO C900-ERR-MESSAGE
027500             ELSE
027600                 MOVE DFHBMUNF   TO C900-ORG-A
027700                 MOVE C900-ORG   TO MBCA-MERCHANT-ORG
027800                 GO TO C100-EDIT-CHAIN.
027900*
028000 C098-ORG-ERROR.
028100*
028200     SET SS08WS-ERROR-SW-YES     TO TRUE.
028300     MOVE DFHBMASB               TO C900-ORG-LP-A
028400                                    C900-ORG-RP-A.
028500     MOVE SS08WS-CURSOR          TO C900-ORG-L.
028600     MOVE DFHBMNBF               TO C900-ORG-A
028700                                    C900-CHAIN-A.
028800     GO TO D000-RETURN-ERRORS.
028900*
029000 C100-EDIT-CHAIN.
029100*
029200***********************************************************
029300*    THE LENGTH FIELD COULD BE CHECKED HERE TO            *
029400*    SEE IF ANYTHING WAS KEYED.                           *
029500***********************************************************
029600*
029700     IF  C900-CHAIN IS EQUAL TO ZEROS
029800     OR  C900-CHAIN IS NOT NUMERIC
029900     OR  C900-CHAIN IS EQUAL TO ZEROS OR 999999999
030000         MOVE MBEMWS-INVALID-CHAIN
030100                                 TO C900-ERR-MESSAGE
030200         GO TO C118-CHAIN-ERROR.
030300*
030400 C102-READ-CHAIN.
030500*
030600***************************************************************
030700*    READ THE CHAIN RECORD.    IT MUST BE ON FILE AND         *
030800*    AN ACTIVE RECORD IF IN MAINTENANCE OR INQUIRY.  IT MUST  *
030900*    NOT BE ON FILE (OR IN AN ADD PENDING STATE), IF IN ADD.  *
031000***************************************************************
031100*
031200     MOVE C900-ORG               TO MBIOWS-MMRC-ORG.
031300     MOVE C900-CHAIN             TO MBIOWS-MMRC-CHAIN.
031400     MOVE SS08WS-CICS-FC-NOTFND  TO MBIORO-TEMP-STATUS-1.
031500     MOVE 'FC04'                 TO MBCA-PROGRAM-LOCATION.
031600     SET MBIORO-READ-RANDOM      TO TRUE.
031700     PERFORM MMRCAO-ACCESS       THRU MMRCAO-ACCESS-EXIT.
031800*
031900     IF  SS08WS-RC-FC-VALID-RTN-CODE
032000         MOVE C900-CHAIN         TO MBCA-CHAIN.
032100*
032200     IF  SS08WS-RC-FC-VALID-RTN-CODE
032300         IF  MMRC-ADD-PENDING
032400             MOVE MBEMWS-ADD-PENDING
032500                             TO C900-ERR-MESSAGE
032600             GO TO C118-CHAIN-ERROR
032700         ELSE
032800             IF  MMRC-REC-INCOMPLETE
032900                 MOVE MBEMWS-NOT-ACTIVE
033000                             TO C900-ERR-MESSAGE
033100                 GO TO C118-CHAIN-ERROR
033200             ELSE
033300                 GO TO F000-SETUP-COMMAREA
033400     ELSE
033500         MOVE MBEMWS-NOT-ON-FILE
033600                             TO C900-ERR-MESSAGE
033700         GO TO C118-CHAIN-ERROR.
033800*
033900 C118-CHAIN-ERROR.
034000*
034100     SET SS08WS-ERROR-SW-YES     TO TRUE.
034200     MOVE DFHBMASB               TO C900-CHAIN-LP-A
034300                                    C900-CHAIN-RP-A.
034400     MOVE SS08WS-CURSOR          TO C900-CHAIN-L.
034500     MOVE DFHBMNBF               TO C900-CHAIN-A.
034600/
034700 D000-RETURN-ERRORS SECTION.
034800*
034900     IF  SS08WS-ERROR-SW-NO
035000         GO TO F000-SETUP-COMMAREA
035100     ELSE
035200         IF  SS08WS-VALID-PF-KEY
035300         OR  SS08WS-EIBAID-VALID-PF-KEY
035400             SET MBCA-INITIAL-SCREEN-NBR
035500                                 TO TRUE
035600             GO TO F090-TRANSFER-XCTL.
035700*
035800***************************************************************
035900*    INITIALIZE THE STANDARD MAP LINES.  IN AN ERROR          *
036000*    CONDITION, THIS ROUTINE IS PERFORMED PRIMARILY           *
036100*    TO UPDATE THE DATE AND TIME ON THE SCREEN.               *
036200***************************************************************
036300*
036400     PERFORM MB60PD-INIT-STD-MAP-LINES
036500                                 THRU MB60PD-ISML-EXIT.
036600*
036700**********************
036800*    SEND THE MAP    *
036900**********************
037000*
037100     MOVE 'BM03'                 TO MBCA-PROGRAM-LOCATION.
037200     PERFORM MB60PD-SEND-MAP-WITH-ERASE
037300                                 THRU MB60PD-SMWE-EXIT.
037400*
037500************************
037600*    RETURN TO CICS    *
037700************************
037800*
037900     MOVE 'PC04'                 TO MBCA-PROGRAM-LOCATION.
038000     PERFORM MB70PD-RETURN-TRANS-ID
038100                                 THRU MB70PD-RTI-EXIT.
038200/
038300 F000-SETUP-COMMAREA SECTION.
038400*
038500***************************************************************
038600*  SET UP COMMAREA FIELDS AND TRANSFER TO THE NEXT PROGRAM    *
038700***************************************************************
038800*
038900     MOVE MBCA-EIBAID            TO SS08WS-EIBAID.
039000*
039100     MOVE MBIOWS-MMRC-DIRECT-KEY-CODE
039200                                 TO MBCA-KEY-CODE.
039300*
039400     PERFORM MB60PD-EDIT-PAGE-NBR
039500                                 THRU MB60PD-EPN-EXIT.
039600*
039700     IF  SS08WS-VALID-PF-KEY
039800     OR  SS08WS-EIBAID-VALID-PF-KEY
039900         SET MBCA-INITIAL-SCREEN-NBR
040000                                 TO TRUE.
040100*
040200 F090-TRANSFER-XCTL.
040300*
040400     MOVE 'PC05'                 TO MBCA-PROGRAM-LOCATION.
040500     PERFORM MB70PD-XCTL-TO-MBOXCTL
040600                                 THRU MB70PD-XTM-EXIT.
040700/
040800 Z000-COPIED-ROUTINES SECTION.
040900*
041000**********************************
041100*    JUL TO GREG DATE ROUTINE    *
041200**********************************
041300*
041400     COPY SS08PD.
041500/
041600     COPY SS26PD.
041700/
041800     COPY SS27PD.
041900/
042000*********************************
042100*    LINE 24 PF KEYS ROUTINE    *
042200*********************************
042300*
042400     COPY SS15PD.
042500/
042600*******************************************
042700*    ORG FILE ACCESS ROUTINES             *
042800*******************************************
042900*
043000     COPY MMOCAO.
043100/
043200******************************************************
043300*    MERCHANT RELATIONSHIP RECORD ACCESS ROUTINES    *
043400******************************************************
043500*
043600     COPY MMRCAO.
043700/
043800*****************************
043900*    ONLINE MAP ROUTINES    *
044000*****************************
044100*
044200     COPY MB60PD REPLACING 'MBMAPXX' BY 'MB9C00 '
044300                           MBMAPXXI BY MB9C00I
044400                           MBMAPXXO BY MB9C00O.
044500/
044600***************************
044700*    ONLINE PROCEDURES    *
044800***************************
044900*
045000     COPY MB70PD.
045100/
045200     COPY SMFTPXO.
