000100 IDENTIFICATION DIVISION.
000200 PROGRAM-ID. MBO9G01.
000201*       RELEASE DATE=08/24/01.        REVISION LEVEL=08.06      *
000202*****************************************************************
000203*WARNING.  THIS COMPUTER PROGRAM IS PROTECTED BY COPYRIGHT LAW  *
000204*AND INTERNATIONAL TREATIES.  UNAUTHORIZED REPRODUCTION OR      *
000205*DISTRIBUTION OF THIS PROGRAM, OR ANY PORTION OF IT, MAY RESULT *
000206*IN SEVERE CIVIL AND CRIMINAL PENATLIES, AND WILL BE PROSECUTED *
000207*TO THE MAXIMUM EXTENT POSSIBLE UNDER THE LAW.                  *
000208*COPYRIGHT 1999 PAYSYS INTERNATIONAL, INC.  ALL RIGHTS RESERVED.*
000209*****************************************************************
000300*****************************************************************
000400*                                                               *
000500*   V - PLUS  M E R C H A N T   B A N K C A R D   S Y S T E M   *
000600*                                                               *
000700*      MBO9G01 - STORE CHAIN STATUS MAINT                      *
000800*                SCREEN 01                                      *
000900*                                                               *
001000*              1. TRANSIDS                                      *
001100*                 A. MB9G                                       *
001200*              2. MAPS USED -                                   *
001300*                 A. MB9G01 (SCREEN 01)                         *
001400*              3. FILES USED -                                  *
001500*                 A. MMSR (STORE CHAIN CONTROL FILE)            *
001600*                 B. MMSD (STORE CHAIN DETAIL FILE)             *
001700*                 C. MML1 (LOG FILE)                            *
001800*                                                               *
001900*****************************************************************
002000*
002100 ENVIRONMENT DIVISION.
002200*
002300 DATA DIVISION.
002400*
002500 WORKING-STORAGE SECTION.
002600*
002700 01  FILLER                  PIC  X(12)      VALUE '** WS-BEG **'.
002800*
002900 01  FILLER                  PIC  X(14)      VALUE
003000     'MISCELLANEOUS:'.
003100*
003200 01  WS-MISCELLANEOUS.
003300     03  WS-SEQ-NBR          PIC  9(04)      VALUE ZEROS.
003400     03  WS-NBR-OF-MEMBERS   PIC  9(03)      VALUE ZEROS.
003500*
003600 01  FILLER                  PIC  X(17)      VALUE
003700     'PROGRAM SWITCHES:'.
003800*
003900 01  WS-PROGRAM-SWITCHES.
004000     03  WS-UPDATE-SW        PIC  X(01)      VALUE 'N'.
004100         88  WS-UPDATE-SW-YES                VALUE 'Y'.
004200         88  WS-UPDATE-SW-NO                 VALUE 'N'.
004300/
004400 01  FILLER                  PIC  X(29)      VALUE
004500     'I/O REQUEST BLOCK WORK AREAS:'.
004600*
004700     COPY MBIOWS.
004800/
004900 01  FILLER                  PIC  X(18)      VALUE
005000     'I/O REQUEST BLOCK:'.
005100*
005200     COPY MBIORO.
005300/
005400 01  FILLER                  PIC  X(25)      VALUE
005500     'LOG RECORD REQUEST BLOCK:'.
005600*
005700     COPY MML1WS REPLACING ==:MML1:== BY ==MML1==.
005800/
005900 01  FILLER                  PIC  X(20)      VALUE
006000     'CCS DATE WORK AREAS:'.
006100*
006200     COPY SS01WS.
006300/
006400 01  FILLER                  PIC  X(15)      VALUE
006500     'CCS WORK AREAS:'.
006600*
006700     COPY SS08WS.
006800/
006900     COPY SS00WS.
007000/
007100     COPY SMFTWS.
007200/
007300     COPY SMPTRL REPLACING ==:SMPT:== BY ==SMPT==.
007400/
007500     COPY MB61LK.
007600/
007700 01  FILLER                  PIC  X(12)      VALUE '** WS-END **'.
007800/
007900 LINKAGE SECTION.
008000*
008100 01  DFHCOMMAREA.
008200*
008300     COPY MB60WS.
008400/
008500***********************************
008600*    STORE CHAIN  MAP             *
008700***********************************
008800*
008900     COPY MB9G01.
009000/
009100************************************************
009200*    STORE CHAIN  MAP REDEFINITION             *
009300************************************************
009400*
009500     COPY MB9G01R.
009600/
009700****************************************
009800*    STORE CHAIN CONTROL RECORD LAYOUT *
009900****************************************
010000*
010100     COPY MMSRRL.
010200/
010300****************************************
010400*    STORE CHAIN DETAIL RECORD LAYOUT *
010500****************************************
010600*
010700     COPY MMSDRL REPLACING ==:MMSD:== BY ==MMSD==.
010800/
010900***************************
011000*    LOG RECORD LAYOUT    *
011100***************************
011200*
011300     COPY MML1RL REPLACING ==:MML1:== BY ==MML1==.
011400/
011500 PROCEDURE DIVISION.
011600*
011700 A000-HOUSEKEEPING SECTION.
011800*
011900 A020-INIT.
012000*
012100     MOVE 'PC01'                 TO MBCA-PROGRAM-LOCATION.
012200     PERFORM MB70PD-ON-LINE-HOUSEKEEPING
012300                                 THRU MB70PD-OLH-EXIT.
012400*
012500     IF  MBCA-RECEIVE-SCREEN
012600         GO TO C000-RECEIVE-SCREEN.
012700/
012800 B000-SEND-SCREEN SECTION.
012900*
013000*********************************************
013100*    GET CICS STORAGE NEEDED FOR THE MAP    *
013200*********************************************
013300*
013400     MOVE 'SC01'                 TO MBCA-PROGRAM-LOCATION.
013500     PERFORM MB60PD-GETMAIN-FOR-MAP
013600                                 THRU MB60PD-GFM-EXIT.
013700*
013800*******************************************
013900*    INITIALIZE THE STANDARD MAP LINES    *
014000*******************************************
014100*
014200     PERFORM MB60PD-INIT-STD-MAP-LINES
014300                                 THRU MB60PD-ISML-EXIT.
014400*
014500     MOVE 'FC01'                 TO MBCA-PROGRAM-LOCATION.
014600     PERFORM 9100-READ-MMSR      THRU 9109-READ-MMSR-EXIT.
014700*
014800 B020-MOVE-FIELDS-TO-SCREEN.
014900*
015000     MOVE MMSR-REC-STATUS        TO G901-CURRENT-STATUS.
015100     MOVE ZERO                   TO G901-CHANGE-STATUS.
015200     MOVE MMSR-LAST-MAINT-DATE   TO SS01WS-JULIAN.
015300     PERFORM SS26PD-NUMERICALLY-EDIT-DATE
015400        THRU SS26PD-NED-EXIT.
015500     MOVE SS01WS-XX-XX-YYYY      TO G901-LAST-MAINT-DATE.
015600     MOVE MMSR-LAST-MAINT-OPER   TO G901-LAST-MAINT-OPER.
015700     MOVE MMSR-NA-LINE (1)       TO G901-DESCRIPTION.
015800*
015900******************************************
016000*    SET THE CURSOR AND SCREEN NUMBER    *
016100******************************************
016200*
016300     MOVE SS08WS-CURSOR          TO G901-CHANGE-STATUS-L.
016400*
016500     COMPUTE MBCA-SCREEN-NBR     =  MBCA-SCREEN-NBR - 50.
016600*
016700**********************
016800*    SEND THE MAP    *
016900**********************
017000*
017100     MOVE 'BM01'                 TO MBCA-PROGRAM-LOCATION.
017200     PERFORM MB60PD-SEND-MAP-WITH-ERASE
017300                                 THRU MB60PD-SMWE-EXIT.
017400*
017500************************
017600*    RETURN TO CICS    *
017700************************
017800*
017900     MOVE 'PC02'                 TO MBCA-PROGRAM-LOCATION.
018000     PERFORM MB70PD-RETURN-TRANS-ID
018100                                 THRU MB70PD-RTI-EXIT.
018200/
018300 C000-RECEIVE-SCREEN SECTION.
018400*
018500******************************************
018600*    THIS SECTION RECEIVES THE SCREEN    *
018700******************************************
018800*
018900     MOVE 'BM02'                 TO MBCA-PROGRAM-LOCATION
019000     PERFORM MB60PD-RECEIVE-MAP  THRU MB60PD-RM-EXIT.
019100*
019200**************************************************************
019300*    CHECK FOR ANOTHER TRANSACTION ID ENTERED BY THE USER    *
019400**************************************************************
019500*
019600     MOVE 'PC03'                 TO MBCA-PROGRAM-LOCATION.
019700     PERFORM MB60PD-NEW-TRANS-ROUTINE
019800                                 THRU MB60PD-NTR-EXIT.
019900*
020000*****************************************
020100*    READ THE STORE CHAIN MASTER FILE *
020200*****************************************
020300*
020400     MOVE 'FC02'                 TO MBCA-PROGRAM-LOCATION.
020500     PERFORM 9100-READ-MMSR      THRU 9109-READ-MMSR-EXIT.
020600*
020700 C020-FIELD-EDITS.
020800*
020900***************************************
021000*    FIELD EDIT FOR CHANGE STATUS     *
021100***************************************
021200*
021300     IF  G901-CHANGE-STATUS-L    IS GREATER THAN ZERO
021400         MOVE DFHBMASF           TO G901-CHANGE-STATUS-A
021500     ELSE
021600         MOVE ZERO               TO G901-CHANGE-STATUS
021700         GO TO D000-RETURN-ERRORS.
021800*
021900     IF  G901-CHANGE-STATUS IS NOT NUMERIC
022000         GO TO C025-CHANGE-STATUS-ERROR.
022100*
022200     IF  G901-VALID-CHANGE-STATUS
022300         NEXT SENTENCE
022400     ELSE
022500         GO TO C025-CHANGE-STATUS-ERROR.
022600*
022700     GO TO C030-CROSS-EDITS.
022800*
022900 C025-CHANGE-STATUS-ERROR.
023000*
023100     MOVE DFHBMUBF               TO G901-CHANGE-STATUS-A.
023200*
023300     SET SS08WS-ERROR-SW-YES     TO TRUE.
023400     MOVE DFHBMASB               TO G901-CHANGE-STATUS-LP-A
023500                                    G901-CHANGE-STATUS-RP-A.
023600     MOVE SS08WS-CURSOR          TO G901-CHANGE-STATUS-L.
023700*
023800 C030-CROSS-EDITS.
023900*
024000***************************************************************
024100*    CROSS EDIT TO BE SURE THAT THE NO STORES ARE ACTIVE      *
024200*    TO THIS CHAIN.                                           *
024300***************************************************************
024400*
024500     IF  MMSR-REC-ACTIVE
024600         PERFORM 9200-START-MMSD THRU 9299-SMMSD-EXIT
024700         IF  WS-NBR-OF-MEMBERS IS GREATER THAN ZERO
024800             MOVE DFHBMUBF       TO G901-CHANGE-STATUS-A
024900             SET SS08WS-ERROR-SW-YES TO TRUE
025000             MOVE DFHBMASB       TO G901-CHANGE-STATUS-LP-A
025100                                    G901-CHANGE-STATUS-RP-A
025200             MOVE SS08WS-CURSOR  TO G901-CHANGE-STATUS-L.
025300*
025400/
025500 D000-RETURN-ERRORS SECTION.
025600*
025700     IF  SS08WS-ERROR-SW-NO
025800         GO TO E000-UPDATE-FILE.
025900*
026000***************************************************************
026100*    INITIALIZE THE STANDARD MAP LINES.  IN AN ERROR          *
026200*    CONDITION, THIS ROUTINE IS PERFORMED PRIMARILY           *
026300*    TO UPDATE THE DATE AND TIME ON THE SCREEN.               *
026400***************************************************************
026500*
026600     PERFORM MB60PD-INIT-STD-MAP-LINES
026700                                 THRU MB60PD-ISML-EXIT.
026800*
026900**********************
027000*    SEND THE MAP    *
027100**********************
027200*
027300     MOVE 'BM03'                 TO MBCA-PROGRAM-LOCATION.
027400     PERFORM MB60PD-SEND-MAP-DATA-ONLY
027500                                 THRU MB60PD-SMDO-EXIT.
027600*
027700************************
027800*    RETURN TO CICS    *
027900************************
028000*
028100     MOVE 'PC04'                 TO MBCA-PROGRAM-LOCATION.
028200     PERFORM MB70PD-RETURN-TRANS-ID
028300                                 THRU MB70PD-RTI-EXIT.
028400/
028500 E000-UPDATE-FILE SECTION.
028600*
028700****************************************************
028800*    READ THE STORE MASTER RECORD FOR UPDATE       *
028900****************************************************
029000*
029100     MOVE 'FC03'                 TO MBCA-PROGRAM-LOCATION.
029200     SET MBIORO-READ-RANDOM-UPDATE
029300                                 TO TRUE.
029400     PERFORM MMSRAO-ACCESS       THRU MMSRAO-ACCESS-EXIT.
029500*
029600 E010-CONTINUE.
029700*
029800*************************************
029900*    OBTAIN STORAGE FOR LOG FILE    *
030000*    RECORD IF DOING MAINTENANCE    *
030100*************************************
030200*
030300     MOVE 'SC02'                 TO MBCA-PROGRAM-LOCATION.
030400     SET MBIORO-GETMAIN          TO TRUE.
030500     PERFORM MML1AO-ACCESS       THRU MML1AO-ACCESS-EXIT.
030600*
030700 E020-UPDATE-FIELDS.
030800*
030900     IF  G901-CHANGE-STATUS-L    IS GREATER THAN ZERO
031000         IF G901-CHANGE-STATUS IS NOT EQUAL
031100                                 TO MMSR-REC-STATUS
031200             MOVE 1              TO WS-SEQ-NBR
031300             PERFORM 9300-UPDATE-MMSD
031400                                 THRU 9399-UMMSD-EXIT
031500             SET WS-UPDATE-SW-YES
031600                                 TO TRUE
031700             MOVE 0197           TO MML1-FIELD-CODE
031800             MOVE ZEROES         TO MML1-FIELD-OCCURRENCE
031900                                    MML1-FIELD-OCCURRENCE-2
032000             MOVE MML1WS-VL-01   TO MML1-VARIABLE-LENGTH
032100             MOVE MMSR-REC-STATUS
032200                                 TO MML1-VL01-B-DATA-9
032300             MOVE G901-CHANGE-STATUS
032400                                 TO MMSR-REC-STATUS
032500             MOVE MMSR-REC-STATUS
032600                                 TO MML1-VL01-A-DATA-9
032700             MOVE 'FC04'         TO MBCA-PROGRAM-LOCATION
032800             PERFORM 9150-WRITE-LOG-REC-MMSR
032900                                 THRU 9159-WLR-EXIT.
033000*
033100 E040-UPDATE-MMSR.
033200*
033300**************************************************************
033400*    WRITE A LOG RECORD TO SHOW THAT THE LAST MAINT DATE     *
033500*    AND OPERATOR HAS BEEN UPDATED IF FIELDS WERE CHANGED    *
033600*    ON THE SCREEN                                           *
033700**************************************************************
033800*
033900     IF  WS-UPDATE-SW-YES
034000         MOVE 0198               TO MML1-FIELD-CODE
034100         MOVE ZEROES             TO MML1-FIELD-OCCURRENCE
034200                                    MML1-FIELD-OCCURRENCE-2
034300         MOVE MML1WS-VL-03       TO MML1-VARIABLE-LENGTH
034400         MOVE MMSR-LAST-MAINT-OPER
034500                                 TO MML1-VL03-B-DATA-X
034600         MOVE MBCA-OPERATOR-ID   TO MMSR-LAST-MAINT-OPER
034700         MOVE MMSR-LAST-MAINT-OPER
034800                                 TO MML1-VL03-A-DATA-X
034900         MOVE 'FC07'             TO MBCA-PROGRAM-LOCATION
035000         PERFORM 9150-WRITE-LOG-REC-MMSR
035100                                 THRU 9159-WLR-EXIT
035200         MOVE 0199               TO MML1-FIELD-CODE
035300         MOVE MML1WS-VL-07       TO MML1-VARIABLE-LENGTH
035400         MOVE MMSR-LAST-MAINT-DATE
035500                                 TO MML1-VL07-B-DATA-9
035600         MOVE MBCA-START-DATE    TO MMSR-LAST-MAINT-DATE
035700         MOVE MMSR-LAST-MAINT-DATE
035800                                 TO MML1-VL07-A-DATA-9
035900         MOVE 'FC08'             TO MBCA-PROGRAM-LOCATION
036000         PERFORM 9150-WRITE-LOG-REC-MMSR
036100                                 THRU 9159-WLR-EXIT.
036200*
036300**************************************************************
036400*    REWRITE THE STORE MASTER RECORD                         *
036500*    IF FIELDS HAVE BEEN CHANGED ON THE SCREEN, OR           *
036600*    UNLOCK IT IF THEY HAVE NOT                              *
036700**************************************************************
036800*
036900     IF  WS-UPDATE-SW-YES
037000         MOVE 'FC09'             TO MBCA-PROGRAM-LOCATION
037100         SET MBIORO-REWRITE      TO TRUE
037200         PERFORM MMSRAO-ACCESS   THRU MMSRAO-ACCESS-EXIT
037300     ELSE
037400         MOVE 'FC10'             TO MBCA-PROGRAM-LOCATION
037500         SET MBIORO-UNLOCK       TO TRUE
037600         PERFORM MMSRAO-ACCESS   THRU MMSRAO-ACCESS-EXIT.
037700/
037800 F000-SETUP-COMMAREA SECTION.
037900*
038000***************************************************************
038100*  SET UP COMMAREA FIELDS AND TRANSFER TO THE NEXT PROGRAM    *
038200***************************************************************
038300*
038400     MOVE MBCA-EIBAID            TO SS08WS-EIBAID.
038500*
038600     PERFORM MB60PD-EDIT-PAGE-NBR
038700                                 THRU MB60PD-EPN-EXIT.
038800*
038900     IF  SS08WS-VALID-PF-KEY
039000     OR  SS08WS-EIBAID-VALID-PF-KEY
039100         SET MBCA-INITIAL-SCREEN-NBR
039200                                 TO TRUE.
039300*
039400     MOVE 'PC05'                 TO MBCA-PROGRAM-LOCATION.
039500     PERFORM MB70PD-XCTL-TO-MBOXCTL
039600                                 THRU MB70PD-XTM-EXIT.
039700/
039800 9000-PERFORMED-AREA SECTION.
039900*
040000 9100-READ-MMSR.
040100*
040200*****************************************
040300*    READ THE STORE CHAIN MASTER FILE *
040400*****************************************
040500*
040600     MOVE MBCA-MERCHANT-ORG      TO MBIOWS-MMSR-ORG
040700                                    G901-ORG.
040800     MOVE MBCA-S-CHAIN           TO MBIOWS-MMSR-CHAIN
040900                                    G901-CHAIN.
041000     SET MBIORO-READ-RANDOM      TO TRUE.
041100     PERFORM MMSRAO-ACCESS       THRU MMSRAO-ACCESS-EXIT.
041200*
041300 9109-READ-MMSR-EXIT.
041400     EXIT.
041500*
041600 9120-WRITE-LOG-REC-MMSD.
041700*
041800     MOVE 'SD'                   TO MML1-FILE-CODE.
041900     MOVE MBCA-MERCHANT-ORG      TO MML1-MMSD-ORG.
042000     MOVE MBCA-S-CHAIN           TO MML1-MMSD-CHAIN.
042100     MOVE WS-SEQ-NBR             TO MML1-MMSD-SEQ-NBR.
042200     MOVE MBCA-SIGNON-NAME       TO MML1-SIGNON-NAME.
042300     MOVE MBCA-TERMINAL-ID       TO MML1-TERMINAL-ID.
042400     MOVE ZEROS                  TO MML1-SOURCE-CODE.
042500     MOVE MBCA-FIELD-SECURITY    TO MML1-FIELD-SECURITY.
042600     SET MBIORO-WRITE            TO TRUE.
042700     PERFORM MML1AO-ACCESS       THRU MML1AO-ACCESS-EXIT.
042800     MOVE SPACES                 TO MML1-VARIABLE-AREA.
042900*
043000 9129-WLR-EXIT.
043100     EXIT.
043200*
043300 9150-WRITE-LOG-REC-MMSR.
043400*
043500     MOVE 'SR'                   TO MML1-FILE-CODE.
043600     MOVE MBCA-MERCHANT-ORG      TO MML1-MMSR-ORG.
043700     MOVE MBCA-S-CHAIN           TO MML1-MMSR-CHAIN.
043800     MOVE MBCA-SIGNON-NAME       TO MML1-SIGNON-NAME.
043900     MOVE MBCA-TERMINAL-ID       TO MML1-TERMINAL-ID.
044000     MOVE ZEROS                  TO MML1-SOURCE-CODE.
044100     MOVE MBCA-FIELD-SECURITY    TO MML1-FIELD-SECURITY.
044200     SET MBIORO-WRITE            TO TRUE.
044300     PERFORM MML1AO-ACCESS       THRU MML1AO-ACCESS-EXIT.
044400     MOVE SPACES                 TO MML1-VARIABLE-AREA.
044500*
044600 9159-WLR-EXIT.
044700     EXIT.
044800*
044900 9200-START-MMSD.
045000*
045100     MOVE 'FC29'                 TO MBCA-PROGRAM-LOCATION.
045200     MOVE MBCA-MERCHANT-ORG      TO MBIOWS-MMSD-ORG.
045300     MOVE MBCA-S-CHAIN           TO MBIOWS-MMSD-CHAIN.
045400     MOVE ZEROS                  TO MBIOWS-MMSD-SEQ-NBR.
045500     SET MBIORO-STARTBR-GTE      TO TRUE.
045600     PERFORM MMSDAO-ACCESS       THRU MMSDAO-ACCESS-EXIT.
045700*
045800 9205-READ-NEXT-MMSD.
045900*
046000     MOVE 'FC30'                 TO MBCA-PROGRAM-LOCATION.
046100     SET MBIORO-READ-SEQ         TO TRUE.
046200     PERFORM MMSDAO-ACCESS       THRU MMSDAO-ACCESS-EXIT.
046300*
046400     IF  MMSD-ORG-CHAIN IS GREATER THAN MMSR-ORG-CHAIN
046500         GO TO 9220-MMSD-ENDBR.
046600*
046700     ADD MMSD-NBR-OF-MEMBERS     TO WS-NBR-OF-MEMBERS.
046800*
046900     GO TO 9205-READ-NEXT-MMSD.
047000*
047100 9220-MMSD-ENDBR.
047200*
047300     MOVE 'FC34'                 TO MBCA-PROGRAM-LOCATION.
047400     SET MBIORO-ENDBR            TO TRUE.
047500     PERFORM MMSDAO-ACCESS       THRU MMSDAO-ACCESS-EXIT.
047600*
047700 9299-SMMSD-EXIT.
047800     EXIT.
047900*
048000 9300-UPDATE-MMSD.
048100*
048200     MOVE SS08WS-CICS-FC-NOTFND  TO MBIORO-PERM-STATUS-1.
048300     MOVE MBCA-MERCHANT-ORG      TO MBIOWS-MMSD-ORG.
048400     MOVE MMSR-CHAIN             TO MBIOWS-MMSD-CHAIN.
048500     MOVE WS-SEQ-NBR             TO MBIOWS-MMSD-SEQ-NBR.
048600     SET MBIORO-READ-RANDOM-UPDATE
048700                                 TO TRUE.
048800     MOVE 'FC11'                 TO MBCA-PROGRAM-LOCATION.
048900     PERFORM MMSDAO-ACCESS       THRU MMSDAO-ACCESS-EXIT.
049000*
049100     IF  SS08WS-RC-FC-NOTFND
049200         GO TO 9399-UMMSD-EXIT.
049300*
049400*
049500     SET WS-UPDATE-SW-YES        TO TRUE.
049600     MOVE 0197                   TO MML1-FIELD-CODE.
049700     MOVE ZEROES                 TO MML1-FIELD-OCCURRENCE
049800                                    MML1-FIELD-OCCURRENCE-2.
049900     MOVE MML1WS-VL-01           TO MML1-VARIABLE-LENGTH.
050000     MOVE MMSD-REC-STATUS        TO MML1-VL01-B-DATA-9.
050100     MOVE G901-CHANGE-STATUS     TO MMSD-REC-STATUS.
050200     MOVE MMSD-REC-STATUS        TO MML1-VL01-A-DATA-9.
050300     MOVE 'FC04'                 TO MBCA-PROGRAM-LOCATION.
050400     PERFORM 9120-WRITE-LOG-REC-MMSD
050500                                 THRU 9129-WLR-EXIT.
050600*
050700     MOVE 0198                   TO MML1-FIELD-CODE.
050800     MOVE ZEROES                 TO MML1-FIELD-OCCURRENCE
050900                                    MML1-FIELD-OCCURRENCE-2.
051000     MOVE MML1WS-VL-03           TO MML1-VARIABLE-LENGTH.
051100     MOVE MMSD-LAST-MAINT-OPER   TO MML1-VL03-B-DATA-X.
051200     MOVE MBCA-OPERATOR-ID       TO MMSD-LAST-MAINT-OPER.
051300     MOVE MMSD-LAST-MAINT-OPER   TO MML1-VL03-A-DATA-X.
051400     MOVE 'FC15'                 TO MBCA-PROGRAM-LOCATION.
051500     PERFORM 9120-WRITE-LOG-REC-MMSD
051600                                 THRU 9129-WLR-EXIT.
051700     MOVE 0199                   TO MML1-FIELD-CODE.
051800     MOVE ZEROES                 TO MML1-FIELD-OCCURRENCE
051900                                    MML1-FIELD-OCCURRENCE-2.
052000     MOVE MML1WS-VL-07           TO MML1-VARIABLE-LENGTH.
052100     MOVE MMSD-LAST-MAINT-DATE   TO MML1-VL07-B-DATA-9.
052200     MOVE MBCA-START-DATE        TO MMSD-LAST-MAINT-DATE.
052300     MOVE MMSD-LAST-MAINT-DATE   TO MML1-VL07-A-DATA-9.
052400     MOVE 'FC16'                 TO MBCA-PROGRAM-LOCATION.
052500     PERFORM 9120-WRITE-LOG-REC-MMSD
052600                                 THRU 9129-WLR-EXIT.
052700*
052800     SET MBIORO-REWRITE          TO TRUE.
052900     PERFORM MMSDAO-ACCESS       THRU MMSDAO-ACCESS-EXIT.
053000*
053100     ADD +1                      TO WS-SEQ-NBR.
053200*
053300     GO TO 9300-UPDATE-MMSD.
053400*
053500 9399-UMMSD-EXIT.
053600     EXIT.
053700*
053800/
053900 Z000-COPIED-ROUTINES SECTION.
054000**********************************
054100*    JUL TO GREG DATE ROUTINE    *
054200**********************************
054300*
054400     COPY SS08PD.
054500/
054600     COPY SS26PD.
054700/
054800     COPY SS27PD.
054900/
055000*********************************
055100*    LINE 24 PF KEYS ROUTINE    *
055200*********************************
055300*
055400     COPY SS15PD.
055500/
055600************************************************
055700*    STORE CHAIN CONTROL RECORD ACCESS ROUTINES*
055800************************************************
055900*
056000     COPY MMSRAO.
056100/
056200************************************************
056300*    STORE CHAIN DETAIL RECORD ACCESS ROUTINES *
056400************************************************
056500*
056600     COPY MMSDAO.
056700/
056800*****************************************
056900*    LOG FILE RECORD ACCESS ROUTINES    *
057000*****************************************
057100*
057200     COPY MML1AO.
057300/
057400*****************************
057500*    ONLINE MAP ROUTINES    *
057600*****************************
057700*
057800     COPY MB60PD REPLACING 'MBMAPXX' BY 'MB9G01 '
057900                           MBMAPXXI BY MB9G01I
058000                           MBMAPXXO BY MB9G01O.
058100/
058200***************************
058300*    ONLINE PROCEDURES    *
058400***************************
058500*
058600     COPY MB70PD.
058700/
058800     COPY SMFTPXO.
