000100 IDENTIFICATION DIVISION.
000200 PROGRAM-ID. MBO9V00.
000201*       RELEASE DATE=08/24/01.        REVISION LEVEL=08.06      *
000202*****************************************************************
000203*WARNING.  THIS COMPUTER PROGRAM IS PROTECTED BY COPYRIGHT LAW  *
000204*AND INTERNATIONAL TREATIES.  UNAUTHORIZED REPRODUCTION OR      *
000205*DISTRIBUTION OF THIS PROGRAM, OR ANY PORTION OF IT, MAY RESULT *
000206*IN SEVERE CIVIL AND CRIMINAL PENATLIES, AND WILL BE PROSECUTED *
000207*TO THE MAXIMUM EXTENT POSSIBLE UNDER THE LAW.                  *
000208*COPYRIGHT 1999 PAYSYS INTERNATIONAL, INC.  ALL RIGHTS RESERVED.*
000209*****************************************************************
000300*****************************************************************
000400*                                                               *
000500*   V - PLUS  M E R C H A N T   B A N K C A R D   S Y S T E M   *
000600*                                                               *
000700*      MBO9V00 - INVENTORY STATUS CHANGE                        *
000800*                LOCATE SCREEN 00                               *
000900*                                                               *
001000*              1. TRANSIDS                                      *
001100*                 A. MB9V                                       *
001200*              2. MAPS USED -                                   *
001300*                 A. MB9V00 (LOCATE MAP)                        *
001400*              3. FILES USED -                                  *
001500*                 A. MMOC (ORG CONTROL FILE)                    *
001600*                 B. MMIC (INVENTORY FILE)                      *
001700*                                                               *
001800*****************************************************************
001900*
002000 ENVIRONMENT DIVISION.
002100*
002200 DATA DIVISION.
002300*
002400 WORKING-STORAGE SECTION.
002500*
002600 01  FILLER                  PIC  X(12)      VALUE
002700     '** WS-BEG **'.
002800*
002900 01  FILLER                  PIC  X(14)      VALUE
003000     'MISCELLANEOUS:'.
003100*
003200 01  WS-MISCELLANEOUS.
003300     03  WS-ORG-LOW          PIC S9(03)      COMP-3
003400                                             VALUE +001.
003500     03  WS-ORG-HIGH         PIC S9(03)      COMP-3
003600                                             VALUE +998.
003700/
003800 01  FILLER                  PIC  X(29)      VALUE
003900     'I/O REQUEST BLOCK WORK AREAS:'.
004000*
004100     COPY MBIOWS.
004200/
004300 01  FILLER                  PIC  X(18)      VALUE
004400     'I/O REQUEST BLOCK:'.
004500*
004600     COPY MBIORO.
004700/
004800 01  FILLER                  PIC  X(21)      VALUE
004900     'ERROR MESSAGES TABLE:'.
005000*
005100     COPY MBEMWS.
005200/
005300 01  FILLER                  PIC  X(20)      VALUE
005400     'CCS DATE WORK AREAS:'.
005500*
005600     COPY SS01WS.
005700/
005800 01  FILLER                  PIC  X(15)      VALUE
005900     'CCS WORK AREAS:'.
006000*
006100     COPY SS08WS.
006200/
006300     COPY SS00WS.
006400/
006500     COPY SMFTWS.
006600/
006700     COPY SMPTRL REPLACING ==:SMPT:== BY ==SMPT==.
006800/
006900     COPY MB61LK.
007000/
007100 01  FILLER                  PIC  X(12)      VALUE
007200     '** WS-END **'.
007300/
007400 LINKAGE SECTION.
007500*
007600 01  DFHCOMMAREA.
007700*
007800     COPY MB60WS.
007900/
008000******************************************
008100*    INVENTORY LOCATE MAP                *
008200******************************************
008300*
008400     COPY MB9V00.
008500/
008600*******************************************************
008700*    INVENTORY LOCATE MAP REDEFINITION                *
008800*******************************************************
008900*
009000     COPY MB9V00R.
009100/
009200***************************
009300*    ORG RECORD LAYOUT    *
009400***************************
009500*
009600     COPY MMOCRL.
009700/
009800*********************************************
009900*    INVENTORY RECORD LAYOUT                *
010000*********************************************
010100*
010200     COPY MMICRL.
010300/
010400 PROCEDURE DIVISION.
010500*
010600 A000-HOUSEKEEPING SECTION.
010700*
010800 A020-INIT.
010900*
011000     MOVE 'PC01'                 TO MBCA-PROGRAM-LOCATION.
011100     PERFORM MB70PD-ON-LINE-HOUSEKEEPING
011200                                 THRU MB70PD-OLH-EXIT.
011300*
011400     IF  MBCA-RECEIVE-SCREEN
011500         GO TO C000-RECEIVE-SCREEN.
011600/
011700 B000-SEND-SCREEN SECTION.
011800*
011900*********************************************
012000*    GET CICS STORAGE NEEDED FOR THE MAP    *
012100*********************************************
012200*
012300     MOVE 'SC01'                 TO MBCA-PROGRAM-LOCATION.
012400     PERFORM MB60PD-GETMAIN-FOR-MAP
012500                                 THRU MB60PD-GFM-EXIT.
012600*
012700     IF  MBCA-INITIAL-KEY-CODE
012800         GO TO B020-BUILD-SCREEN.
012900*
013000     IF  MBCA-MMIC-KEY-CODE
013100         IF  MBCA-MERCHANT-ORG IS GREATER THAN ZERO
013200             MOVE MBCA-MERCHANT-ORG
013300                                 TO V900-ORG
013400             MOVE DFHBMUNF       TO V900-ORG-A
013500             MOVE 3              TO V900-ORG-L
013600             IF  MBCA-MERCHANT   IS GREATER THAN ZERO
013700             AND MBCA-S-M        IS EQUAL TO 'M'
013800                 MOVE MBCA-MERCHANT
013900                                 TO V900-MERCHANT
014000                 MOVE DFHBMUNF   TO V900-MERCHANT-A
014100                 MOVE MBCA-S-M   TO V900-TYPE
014200                 MOVE DFHBMFSE   TO V900-TYPE-A
014300                 MOVE 9          TO V900-MERCHANT-L
014400                 MOVE 1          TO V900-TYPE-L
014500             ELSE
014600                 IF  MBCA-MERCHANT IS GREATER THAN ZERO
014700                 AND MBCA-S-M    IS EQUAL TO 'S'
014800                     MOVE MBCA-MERCHANT
014900                                 TO V900-MERCHANT
015000                     MOVE DFHBMUNF
015100                                 TO V900-MERCHANT-A
015200                     MOVE MBCA-S-M
015300                                 TO V900-TYPE
015400                     MOVE 9      TO V900-MERCHANT-L
015500                     MOVE 1      TO V900-TYPE-L
015600                     MOVE DFHBMFSE
015700                                 TO V900-TYPE-A
015800                 ELSE
015900                     GO TO B010-CHECK-KEY-CODE
016000         ELSE
016100             GO TO B010-CHECK-KEY-CODE
016200     ELSE
016300         GO TO B010-CHECK-KEY-CODE.
016400*
016500     IF  MBCA-DIRECT-TRANSFER-CODE
016600     AND MBCA-INITIAL-SCREEN-NBR
016700         MOVE 00         TO MBCA-SCREEN-NBR
016800         GO TO C082-READ-ORG
016900     ELSE
017000         GO TO B020-BUILD-SCREEN.
017100*
017200 B010-CHECK-KEY-CODE.
017300*
017400     IF  MBCA-VALID-KEY-CODES
017500         IF  MBCA-MERCHANT-ORG IS GREATER THAN ZERO
017600             MOVE MBCA-MERCHANT-ORG
017700                                 TO V900-ORG
017800             MOVE DFHBMUNF       TO V900-ORG-A
017900             IF  MBCA-MERCHANT IS GREATER THAN ZERO
018000                 MOVE MBCA-MERCHANT
018100                                 TO V900-MERCHANT
018200                 MOVE DFHBMUNF   TO V900-MERCHANT-A
018300                 MOVE 'M'        TO MBCA-S-M
018400                 MOVE MBCA-S-M   TO V900-TYPE
018500                 MOVE DFHBMFSE   TO V900-TYPE-A
018600             ELSE
018700                 IF  MBCA-MERCHANT IS GREATER THAN ZERO
018800                     MOVE MBCA-MERCHANT
018900                                 TO V900-MERCHANT
019000                     MOVE DFHBMUNF
019100                                 TO V900-MERCHANT-A
019200                     MOVE 'S'    TO MBCA-S-M
019300                     MOVE MBCA-S-M
019400                                 TO V900-TYPE
019500                     MOVE DFHBMFSE
019600                                 TO V900-TYPE-A.
019700*
019800 B020-BUILD-SCREEN.
019900*
020000*******************************************
020100*    INITIALIZE THE STANDARD MAP LINES    *
020200*******************************************
020300*
020400     MOVE SS08WS-CURSOR          TO V900-ORG-L.
020500     MOVE 00                     TO MBCA-SCREEN-NBR.
020600     PERFORM MB60PD-INIT-STD-MAP-LINES
020700                                 THRU MB60PD-ISML-EXIT.
020800*
020900**********************
021000*    SEND THE MAP    *
021100**********************
021200*
021300     MOVE 'BM01'                 TO MBCA-PROGRAM-LOCATION.
021400     PERFORM MB60PD-SEND-MAP-WITH-ERASE
021500                                 THRU MB60PD-SMWE-EXIT.
021600*
021700************************
021800*    RETURN TO CICS    *
021900************************
022000*
022100     MOVE 'PC02'                 TO MBCA-PROGRAM-LOCATION.
022200     PERFORM MB70PD-RETURN-TRANS-ID
022300                                 THRU MB70PD-RTI-EXIT.
022400/
022500 C000-RECEIVE-SCREEN SECTION.
022600*
022700*************************************************
022800*    THIS SECTION RECEIVES THE LOCATE SCREEN    *
022900*************************************************
023000*
023100     MOVE 'BM02'                 TO MBCA-PROGRAM-LOCATION.
023200     PERFORM MB60PD-RECEIVE-MAP  THRU MB60PD-RM-EXIT.
023300*
023400**************************************************************
023500*    CHECK FOR ANOTHER TRANSACTION ID ENTERED BY THE USER    *
023600**************************************************************
023700*
023800     MOVE 'PC03'                 TO MBCA-PROGRAM-LOCATION.
023900     PERFORM MB60PD-NEW-TRANS-ROUTINE
024000                                 THRU MB60PD-NTR-EXIT.
024100*
024200 C020-EDIT-SCREEN.
024300*
024400     SET SS08WS-ERROR-SW-NO      TO TRUE.
024500     MOVE MBCA-EIBAID            TO SS08WS-EIBAID.
024600*
024700     IF  (V900-ORG-L IS LESS THAN 1
024800     AND  V900-MERCHANT-L IS LESS THAN 1
024900     AND  V900-TYPE-L IS LESS THAN 1)
025000     AND (SS08WS-VALID-PF-KEY
025100     OR   SS08WS-EIBAID-VALID-PF-KEY)
025200         SET MBCA-INITIAL-SCREEN-NBR
025300                                 TO TRUE
025400         GO TO F090-TRANSFER-XCTL.
025500*
025600******************************************************
025700*    RESET THE FIELD ARRIBUTES TO THEIR NORMAL       *
025800*    PRIOR STATE PRIOR TO ANY EDITING BEING DONE.    *
025900******************************************************
026000*
026100     MOVE DFHBMUNN               TO V900-ORG-A
026200                                    V900-TYPE-A
026300                                    V900-MERCHANT-A.
026400     MOVE DFHBMASK               TO V900-ORG-LP-A
026500                                    V900-ORG-RP-A
026600                                    V900-TYPE-LP-A
026700                                    V900-TYPE-RP-A
026800                                    V900-MERCHANT-LP-A
026900                                    V900-MERCHANT-RP-A.
027000*
027100 C080-EDIT-ORG.
027200*
027300     IF  V900-ORG-L IS EQUAL TO ZERO
027400     OR  V900-ORG IS NOT NUMERIC
027500     OR  V900-ORG IS LESS THAN MBCA-ORG-LOW
027600     OR  V900-ORG IS GREATER THAN MBCA-ORG-HIGH
027700     OR  V900-ORG IS LESS THAN WS-ORG-LOW
027800     OR  V900-ORG IS GREATER THAN WS-ORG-HIGH
027900         MOVE MBEMWS-INVALID-ORG TO V900-ERR-MESSAGE
028000         GO TO C098-ORG-ERROR.
028100*
028200 C082-READ-ORG.
028300*
028400************************************************
028500*    READ THE ORGANIZATION RECORD.  IT MUST    *
028600*    BE ON FILE AND AN ACTIVE RECORD.          *
028700************************************************
028800*
028900     MOVE V900-ORG               TO MBIOWS-MMOC-ORG.
029000     MOVE 'FC03'                 TO MBCA-PROGRAM-LOCATION.
029100     MOVE SS08WS-CICS-FC-NOTFND  TO MBIORO-TEMP-STATUS-1.
029200     SET MBIORO-READ-RANDOM      TO TRUE.
029300     PERFORM MMOCAO-ACCESS       THRU MMOCAO-ACCESS-EXIT.
029400*
029500     IF  SS08WS-RC-FC-NOTFND
029600         MOVE MBEMWS-NOT-ON-FILE TO V900-ERR-MESSAGE
029700     ELSE
029800         IF  MMOC-ADD-PENDING
029900             MOVE MBEMWS-ADD-PENDING
030000                                 TO V900-ERR-MESSAGE
030100         ELSE
030200             IF  MMOC-REC-PURGED
030300                 MOVE MBEMWS-NOT-ACTIVE
030400                                 TO V900-ERR-MESSAGE
030500             ELSE
030600                 MOVE DFHBMUNF   TO V900-ORG-A
030700                 MOVE V900-ORG   TO MBCA-MERCHANT-ORG
030800                 GO TO C100-EDIT-MERCHANT.
030900*
031000 C098-ORG-ERROR.
031100*
031200     SET SS08WS-ERROR-SW-YES     TO TRUE.
031300     MOVE DFHBMASB               TO V900-ORG-LP-A
031400                                    V900-ORG-RP-A.
031500     MOVE SS08WS-CURSOR          TO V900-ORG-L.
031600     MOVE DFHBMNBF               TO V900-ORG-A
031700                                    V900-MERCHANT-A.
031800     GO TO D000-RETURN-ERRORS.
031900*
032000 C100-EDIT-MERCHANT.
032100*
032200***********************************************************
032300*    THE LENGTH FIELD COULD BE CHECKED HERE TO            *
032400*    SEE IF ANYTHING WAS KEYED.                           *
032500***********************************************************
032600*
032700*
032800     IF  V900-MERCHANT-L IS EQUAL TO ZERO
032900     OR  V900-MERCHANT IS NOT NUMERIC
033000     OR  V900-MERCHANT IS EQUAL TO ZEROES OR 999999999
033100         MOVE MBEMWS-INVALID-STORE-MERCHANT
033200                                 TO V900-ERR-MESSAGE
033300         GO TO C138-MERCHANT-ERROR
033400     ELSE
033500         GO TO C140-EDIT-S-M.
033600*
033700 C138-MERCHANT-ERROR.
033800*
033900     MOVE 'Y'                    TO SS08WS-ERROR.
034000     MOVE DFHBMASB               TO V900-MERCHANT-LP-A
034100                                    V900-MERCHANT-RP-A.
034200     MOVE SS08WS-CURSOR          TO V900-MERCHANT-L.
034300     MOVE DFHBMNBF               TO V900-MERCHANT-A.
034400     MOVE DFHBMFSE               TO V900-TYPE-A.
034500     GO TO D000-RETURN-ERRORS.
034600*
034700 C140-EDIT-S-M.
034800*
034900     IF  V900-TYPE IS EQUAL TO 'M'
035000     OR  V900-TYPE IS EQUAL TO 'S'
035100         MOVE V900-TYPE          TO MBCA-S-M
035200         GO TO C144-READ-MERCHANT
035300     ELSE
035400         MOVE MBEMWS-INVALID-S-M TO V900-ERR-MESSAGE
035500         GO TO C142-S-M-ERROR.
035600*
035700 C142-S-M-ERROR.
035800*
035900     MOVE 'Y'                    TO SS08WS-ERROR.
036000     MOVE DFHBMASB               TO V900-TYPE-LP-A
036100                                    V900-TYPE-RP-A.
036200     MOVE SS08WS-CURSOR          TO V900-TYPE-L.
036300     MOVE DFHBMUNF               TO V900-MERCHANT-A.
036400     MOVE DFHBMUBF               TO V900-TYPE-A.
036500     GO TO D000-RETURN-ERRORS.
036600*
036700 C144-READ-MERCHANT.
036800*
036900*
037000     IF  V900-MERCHANT IS EQUAL TO SPACES
037100         MOVE MBEMWS-INVALID-MERCHANT
037200                                 TO V900-ERR-MESSAGE
037300         GO TO C118-MERCHANT-ERROR.
037400*
037500     IF  V900-MERCHANT-L IS EQUAL TO ZEROS
037600         MOVE MBEMWS-INVALID-MERCHANT
037700                                 TO V900-ERR-MESSAGE
037800         GO TO C118-MERCHANT-ERROR.
037900*
038000     MOVE V900-ORG               TO MBIOWS-MMIC-ORG.
038100     MOVE V900-MERCHANT          TO MBIOWS-MMIC-MERCHANT.
038200     MOVE V900-TYPE              TO MBIOWS-MMIC-TYPE.
038300     MOVE SS08WS-CICS-FC-NOTFND  TO MBIORO-TEMP-STATUS-1.
038400     MOVE 'FC04'                 TO MBCA-PROGRAM-LOCATION.
038500     SET MBIORO-READ-RANDOM      TO TRUE.
038600     PERFORM MMICAO-ACCESS       THRU MMICAO-ACCESS-EXIT.
038700*
038800     IF  SS08WS-RC-FC-VALID-RTN-CODE
038900         MOVE V900-TYPE          TO MBCA-S-M
039000         MOVE V900-MERCHANT      TO MBCA-MERCHANT.
039100*
039200     IF  SS08WS-RC-FC-VALID-RTN-CODE
039300         IF  MMIC-ADD-PENDING
039400             MOVE MBEMWS-ADD-PENDING
039500                                 TO V900-ERR-MESSAGE
039600             GO TO C118-MERCHANT-ERROR
039700         ELSE
039800             GO TO F000-SETUP-COMMAREA
039900     ELSE
040000         MOVE MBEMWS-NOT-ON-FILE
040100                                 TO V900-ERR-MESSAGE
040200         GO TO C118-MERCHANT-ERROR.
040300*
040400***********************************************
040500*    OTHERWISE, WE PASSED THE MERCHANT EDIT *
040600***********************************************
040700*
040800     GO TO F000-SETUP-COMMAREA.
040900*
041000 C118-MERCHANT-ERROR.
041100*
041200     SET SS08WS-ERROR-SW-YES     TO TRUE.
041300     MOVE DFHBMASB               TO V900-MERCHANT-LP-A
041400                                    V900-MERCHANT-RP-A.
041500     MOVE SS08WS-CURSOR          TO V900-MERCHANT-L.
041600     MOVE DFHBMNBF               TO V900-MERCHANT-A.
041700/
041800 D000-RETURN-ERRORS SECTION.
041900*
042000     IF  SS08WS-ERROR-SW-NO
042100         GO TO F000-SETUP-COMMAREA
042200     ELSE
042300         IF  SS08WS-VALID-PF-KEY
042400         OR  SS08WS-EIBAID-VALID-PF-KEY
042500             SET MBCA-INITIAL-SCREEN-NBR
042600                                 TO TRUE
042700             GO TO F090-TRANSFER-XCTL.
042800*
042900***************************************************************
043000*    INITIALIZE THE STANDARD MAP LINES.  IN AN ERROR          *
043100*    CONDITION, THIS ROUTINE IS PERFORMED PRIMARILY           *
043200*    TO UPDATE THE DATE AND TIME ON THE SCREEN.               *
043300***************************************************************
043400*
043500     PERFORM MB60PD-INIT-STD-MAP-LINES
043600                                 THRU MB60PD-ISML-EXIT.
043700*
043800**********************
043900*    SEND THE MAP    *
044000**********************
044100*
044200     MOVE 'BM03'                 TO MBCA-PROGRAM-LOCATION.
044300     PERFORM MB60PD-SEND-MAP-WITH-ERASE
044400                                 THRU MB60PD-SMWE-EXIT.
044500*
044600************************
044700*    RETURN TO CICS    *
044800************************
044900*
045000     MOVE 'PC04'                 TO MBCA-PROGRAM-LOCATION.
045100     PERFORM MB70PD-RETURN-TRANS-ID
045200                                 THRU MB70PD-RTI-EXIT.
045300/
045400 F000-SETUP-COMMAREA SECTION.
045500*
045600***************************************************************
045700*  SET UP COMMAREA FIELDS AND TRANSFER TO THE NEXT PROGRAM    *
045800***************************************************************
045900*
046000     MOVE MBCA-EIBAID            TO SS08WS-EIBAID.
046100*
046200     MOVE MBIOWS-MMIC-DIRECT-KEY-CODE
046300                                 TO MBCA-KEY-CODE.
046400*
046500     PERFORM MB60PD-EDIT-PAGE-NBR
046600                                 THRU MB60PD-EPN-EXIT.
046700*
046800     IF  SS08WS-VALID-PF-KEY
046900     OR  SS08WS-EIBAID-VALID-PF-KEY
047000         SET MBCA-INITIAL-SCREEN-NBR
047100                                 TO TRUE.
047200*
047300 F090-TRANSFER-XCTL.
047400*
047500     MOVE 'PC05'                 TO MBCA-PROGRAM-LOCATION.
047600     PERFORM MB70PD-XCTL-TO-MBOXCTL
047700                                 THRU MB70PD-XTM-EXIT.
047800/
047900 Z000-COPIED-ROUTINES SECTION.
048000*
048100**********************************
048200*    JUL TO GREG DATE ROUTINE    *
048300**********************************
048400*
048500     COPY SS08PD.
048600/
048700     COPY SS26PD.
048800/
048900     COPY SS27PD.
049000/
049100*********************************
049200*    LINE 24 PF KEYS ROUTINE    *
049300*********************************
049400*
049500     COPY SS15PD.
049600/
049700*******************************************
049800*    ORG FILE ACCESS ROUTINES             *
049900*******************************************
050000*
050100     COPY MMOCAO.
050200/
050300******************************************************
050400*    INVENTORY RECORD ACCESS ROUTINES                *
050500******************************************************
050600*
050700     COPY MMICAO.
050800/
050900*****************************
051000*    ONLINE MAP ROUTINES    *
051100*****************************
051200*
051300     COPY MB60PD REPLACING 'MBMAPXX' BY 'MB9V00 '
051400                           MBMAPXXI BY MB9V00I
051500                           MBMAPXXO BY MB9V00O.
051600/
051700***************************
051800*    ONLINE PROCEDURES    *
051900***************************
052000*
052100     COPY MB70PD.
052200/
052300     COPY SMFTPXO.
