000100 IDENTIFICATION DIVISION.
000200 PROGRAM-ID. MBOCM01.
000201*       RELEASE DATE=08/24/01.        REVISION LEVEL=08.06      *
000202*****************************************************************
000203*WARNING.  THIS COMPUTER PROGRAM IS PROTECTED BY COPYRIGHT LAW  *
000204*AND INTERNATIONAL TREATIES.  UNAUTHORIZED REPRODUCTION OR      *
000205*DISTRIBUTION OF THIS PROGRAM, OR ANY PORTION OF IT, MAY RESULT *
000206*IN SEVERE CIVIL AND CRIMINAL PENATLIES, AND WILL BE PROSECUTED *
000207*TO THE MAXIMUM EXTENT POSSIBLE UNDER THE LAW.                  *
000208*COPYRIGHT 1999 PAYSYS INTERNATIONAL, INC.  ALL RIGHTS RESERVED.*
000209*****************************************************************
000300*****************************************************************
000400*                                                               *
000500*   V - PLUS  M E R C H A N T   B A N K C A R D   S Y S T E M   *
000600*                                                               *
000700*      MBOCM01 - MERCHANT RECORD CLOSE                          *
000800*                SCREEN 01                                      *
000900*                                                               *
001000*              1. TRANSIDS                                      *
001100*                 A. MBCM                                       *
001200*              2. MAPS USED -                                   *
001300*                 A. MBCM01 (SCREEN 01)                         *
001400*              3. FILES USED -                                  *
001500*                 A. MMMM (MERCHANT MASTER FILE)                *
001600*                 B. MMSM (STORE MASTER FILE)                   *
001700*                 C. MMXR (STORE MERCHANT CROSS REF FILE)       *
001800*                 D. MML1 (LOG FILE)                            *
001900*                                                               *
002000*****************************************************************
002100*
002200 ENVIRONMENT DIVISION.
002300*
002400 DATA DIVISION.
002500*
002600 WORKING-STORAGE SECTION.
002700*
002800 01  FILLER                  PIC  X(12)      VALUE '** WS-BEG **'.
002900*
003000 01  FILLER                  PIC  X(14)      VALUE
003100     'MISCELLANEOUS:'.
003200*
003300 01  WS-MISCELLANEOUS.
003400     03  WS-NBR-CHAINS       PIC  9(02)      VALUE ZEROS.
003500*
003600 01  FILLER                  PIC  X(17)      VALUE
003700     'PROGRAM SWITCHES:'.
003800*
003900 01  WS-PROGRAM-SWITCHES.
004000     03  WS-UPDATE-SW        PIC  X(01)      VALUE 'N'.
004100         88  WS-UPDATE-SW-YES                VALUE 'Y'.
004200         88  WS-UPDATE-SW-NO                 VALUE 'N'.
004300     03  WS-UPDATE-STORE-SW  PIC  X(01)      VALUE 'N'.
004400         88  WS-UPDATE-STORE-SW-YES          VALUE 'Y'.
004500         88  WS-UPDATE-STORE-SW-NO           VALUE 'N'.
004600     03  WS-DATE-UPDATE-SW   PIC  X(01)      VALUE 'N'.
004700         88  WS-DATE-UPDATE-SW-YES           VALUE 'Y'.
004800         88  WS-DATE-UPDATE-SW-NO            VALUE 'N'.
004900/
005000 01  FILLER                  PIC  X(29)      VALUE
005100     'I/O REQUEST BLOCK WORK AREAS:'.
005200*
005300     COPY MBIOWS.
005400/
005500 01  FILLER                  PIC  X(18)      VALUE
005600     'I/O REQUEST BLOCK:'.
005700*
005800     COPY MBIORO.
005900/
006000 01  FILLER                  PIC  X(25)      VALUE
006100     'LOG RECORD REQUEST BLOCK:'.
006200*
006300     COPY MML1WS REPLACING ==:MML1:== BY ==MML1==.
006400/
006500 01  FILLER                  PIC  X(31)      VALUE
006600     'DYNAMICALLY CALLED SUBROUTINES:'.
006700*
006800     COPY MB00WS.
006900/
007000 01  FILLER                  PIC  X(37)      VALUE
007100     'FORMAT NBR AND AMTS BY CURRENCY CODE:'.
007200*
007300     COPY SS95WS.
007400/
007500 01  FILLER                  PIC  X(20)      VALUE
007600     'CCS DATE WORK AREAS:'.
007700*
007800     COPY SS01WS.
007900/
008000 01  FILLER                  PIC  X(15)      VALUE
008100     'CCS WORK AREAS:'.
008200*
008300     COPY SS08WS.
008400/
008500     COPY SS00WS.
008600/
008700     COPY SMFTWS.
008800/
008900     COPY SMPTRL REPLACING ==:SMPT:== BY ==SMPT==.
009000/
009100     COPY MB61LK.
009200/
009300 01  FILLER                  PIC  X(12)      VALUE '** WS-END **'.
009400/
009500 LINKAGE SECTION.
009600*
009700 01  DFHCOMMAREA.
009800*
009900     COPY MB60WS.
010000/
010100*****************************
010200*    MERCHANT CLOSE MAP     *
010300*****************************
010400*
010500     COPY MBCM01.
010600/
010700******************************************
010800*    MERCHANT CLOSE MAP REDEFINITION     *
010900******************************************
011000*
011100     COPY MBCM01R.
011200/
011300****************************************
011400*    MERCHANT MASTER RECORD LAYOUT     *
011500****************************************
011600/
011700****************************************
011800*    ORGANIZATION RECORD    LAYOUT     *
011900****************************************
012000*
012100     COPY MMOCRL.
012200*
012300     COPY MMMMRL.
012400/
012500****************************************
012600*    STORE MASTER  RECORD LAYOUT       *
012700****************************************
012800*
012900     COPY MMSMRL.
013000/
013100****************************************************
013200*    STORE MERCHANT CROSS REF MASTER RECORD LAYOUT *
013300****************************************************
013400*
013500     COPY MMXRRL.
013600/
013700***************************
013800*    LOG RECORD LAYOUT    *
013900***************************
014000*
014100     COPY MML1RL REPLACING ==:MML1:== BY ==MML1==.
014200/
014300 PROCEDURE DIVISION.
014400*
014500 A000-HOUSEKEEPING SECTION.
014600*
014700 A020-INIT.
014800*
014900     MOVE 'PC01'                 TO MBCA-PROGRAM-LOCATION.
015000     PERFORM MB70PD-ON-LINE-HOUSEKEEPING
015100                                 THRU MB70PD-OLH-EXIT.
015200*
015300     SET SS95WS-FUNCTION-INITIALIZE
015400                                 TO TRUE.
015500     PERFORM SS95PD-NAP-ROUTINE
015600        THRU SS95PD-NAP-EXIT.
015700*
015800     IF  MBCA-RECEIVE-SCREEN
015900         GO TO C000-RECEIVE-SCREEN.
016000/
016100 B000-SEND-SCREEN SECTION.
016200*
016300*********************************************
016400*    GET CICS STORAGE NEEDED FOR THE MAP    *
016500*********************************************
016600*
016700     MOVE 'SC01'                 TO MBCA-PROGRAM-LOCATION.
016800     PERFORM MB60PD-GETMAIN-FOR-MAP
016900                                 THRU MB60PD-GFM-EXIT.
017000*
017100*******************************************
017200*    INITIALIZE THE STANDARD MAP LINES    *
017300*******************************************
017400*
017500     PERFORM MB60PD-INIT-STD-MAP-LINES
017600                                 THRU MB60PD-ISML-EXIT.
017700*
017800*****************************************
017900*    READ THE MERCHANT MASTER RECORD    *
018000*****************************************
018100*
018200     MOVE 'FC01'                 TO MBCA-PROGRAM-LOCATION.
018300     PERFORM 9100-READ-MMMM      THRU 9199-READ-MMMM-EXIT.
018400*
018500*********************************************
018600*    MOVE THE PRIMARY NAME TO THE SCREEN    *
018700*********************************************
018800*
018900     MOVE MMMM-NA-LINE (1 1)     TO CM01-MERCH-NAME.
019000*
019100 B020-MOVE-FIELDS-TO-SCREEN.
019200*
019300     IF  MMMM-REC-CLOSED
019400         MOVE DFHBMDAS           TO CM01-CLOSE-FLAG-LIT-A
019500                                    CM01-CLOSE-FLAG-LP-A
019600                                    CM01-CLOSE-FLAG-RP-A
019700                                    CM01-CLOSE-FLAG-A
019800     ELSE
019900         MOVE 'N'                TO CM01-CLOSE-FLAG.
020000*
020100     MOVE MBCA-CURRENCY-CODE     TO SS95WS-CURRENCY-CODE.
020200     MOVE MMMM-CLOSE-REASON      TO CM01-CLOSE-REASON.
020300     MOVE MMMM-DATE-OPENED       TO SS01WS-JULIAN.
020400     PERFORM SS26PD-NUMERICALLY-EDIT-DATE
020500        THRU SS26PD-NED-EXIT.
020600     MOVE SS01WS-XX-XX-YYYY      TO CM01-DATE-OPEN.
020700     MOVE MMMM-DBA-NAME          TO CM01-DBA-NAME.
020800     MOVE MMMM-NBR-STORES        TO CM01-NBR-STORES.
020900     MOVE MMMM-DBA-CITY          TO CM01-DBA-CITY.
021000     MOVE MMMM-DBA-COUNTRY-CODE  TO CM01-DBA-STATE.
021100     MOVE MMMM-OUT-OF-BUS-DATE   TO SS01WS-JULIAN.
021200     PERFORM SS08PD-JUL-TO-GREG  THRU SS08PD-JTG-EXIT.
021300     MOVE SS01WS-DATE            TO CM01-OUT-OF-BUS-DATE.
021400     MOVE MMMM-OWNERSHIP-CHG-DATE
021500                                 TO SS01WS-JULIAN.
021600     PERFORM SS08PD-JUL-TO-GREG  THRU SS08PD-JTG-EXIT.
021700     MOVE SS01WS-DATE            TO CM01-OWNERSHIP-CHG-DATE.
021800*
021900     PERFORM
022000         VARYING X-MMMM-MERCH-CHAIN
022100         FROM 1 BY 1
022200         UNTIL X-MMMM-MERCH-CHAIN IS GREATER THAN 10
022300         IF  MMMM-MERCH-CHAIN-ID (X-MMMM-MERCH-CHAIN)
022400                                 IS GREATER THAN ZEROS
022500             COMPUTE WS-NBR-CHAINS = WS-NBR-CHAINS + 1
022600         END-IF
022700     END-PERFORM.
022800*
022900     MOVE WS-NBR-CHAINS          TO CM01-NBR-CHAINS.
023000     MOVE MMMM-DATE-LAST-ACTIVE  TO SS01WS-JULIAN.
023100     PERFORM SS26PD-NUMERICALLY-EDIT-DATE
023200        THRU SS26PD-NED-EXIT.
023300     MOVE SS01WS-XX-XX-YYYY      TO CM01-DATE-LAST-ACT.
023400     MOVE MMMM-BLOCK-CODE        TO CM01-BLOCK-CODE.
023500     MOVE MMMM-AGENT-BANK        TO CM01-AGENT.
023600     MOVE MMMM-DATE-LAST-STMT    TO SS01WS-JULIAN.
023700     PERFORM SS26PD-NUMERICALLY-EDIT-DATE
023800        THRU SS26PD-NED-EXIT.
023900     MOVE SS01WS-XX-XX-YYYY      TO CM01-DATE-LAST-STMT.
024000     MOVE MMMM-STMT-FREQ-1       TO CM01-STMT-FREQ1.
024100     MOVE MMMM-STMT-FREQ-2       TO CM01-STMT-FREQ2.
024200     MOVE MMMM-BRANCH            TO CM01-BRANCH.
024300     MOVE MMMM-DATE-LAST-SETT    TO SS01WS-JULIAN.
024400     PERFORM SS26PD-NUMERICALLY-EDIT-DATE
024500        THRU SS26PD-NED-EXIT.
024600     MOVE SS01WS-XX-XX-YYYY     TO CM01-DATE-LAST-SETT.
024700     MOVE MMMM-SETT-FREQ-1       TO CM01-SETT-FREQ1.
024800     MOVE MMMM-SETT-FREQ-2       TO CM01-SETT-FREQ2.
024900     MOVE MMMM-BAL-SETT          TO SS95WS-IN-AMT.
025000     PERFORM SS95PD-NAP-ROUTINE
025100                                 THRU SS95PD-NAP-EXIT.
025200     MOVE SS95WS-OUT-AMT-L21     TO CM01-SETT-BAL.
025300     MOVE MMMM-BAL-RESV-1        TO SS95WS-IN-AMT.
025400     PERFORM SS95PD-NAP-ROUTINE
025500                                 THRU SS95PD-NAP-EXIT.
025600     MOVE SS95WS-OUT-AMT-L21     TO CM01-RESV-BAL1.
025700     MOVE MMMM-BAL-RESV-2        TO SS95WS-IN-AMT.
025800     PERFORM SS95PD-NAP-ROUTINE
025900                                 THRU SS95PD-NAP-EXIT.
026000     MOVE SS95WS-OUT-AMT-L21     TO CM01-RESV-BAL2.
026100     MOVE MMMM-BAL-RESV-3        TO SS95WS-IN-AMT.
026200     PERFORM SS95PD-NAP-ROUTINE
026300                                 THRU SS95PD-NAP-EXIT.
026400     MOVE SS95WS-OUT-AMT-L21     TO CM01-RESV-BAL3.
026500     MOVE MMMM-BAL-RESV-4        TO SS95WS-IN-AMT.
026600     PERFORM SS95PD-NAP-ROUTINE
026700                                 THRU SS95PD-NAP-EXIT.
026800     MOVE SS95WS-OUT-AMT-L21     TO CM01-RESV-BAL4.
026900     MOVE MMMM-IMP-DEV-TITLE (1) TO CM01-IMP-TITLE1.
027000     MOVE MMMM-IMP-DEV-TITLE (2) TO CM01-IMP-TITLE2.
027100     MOVE MMMM-IMP-DEV-TITLE (3) TO CM01-IMP-TITLE3.
027200     MOVE MMMM-POS-DEV-TITLE (1) TO CM01-POS-TITLE1.
027300     MOVE MMMM-POS-DEV-TITLE (2) TO CM01-POS-TITLE2.
027400     MOVE MMMM-POS-DEV-TITLE (3) TO CM01-POS-TITLE3.
027500     MOVE MMMM-IMP-DEV-NBR (1)   TO SS95WS-IN-NBR.
027600     PERFORM SS95PD-NAP-ROUTINE
027700                                 THRU SS95PD-NAP-EXIT.
027800     MOVE SS95WS-OUT-NBR-L07     TO CM01-IMP-NBR1.
027900     MOVE MMMM-IMP-DEV-NBR (2)   TO SS95WS-IN-NBR.
028000     PERFORM SS95PD-NAP-ROUTINE
028100                                 THRU SS95PD-NAP-EXIT.
028200     MOVE SS95WS-OUT-NBR-L07     TO CM01-IMP-NBR2.
028300     MOVE MMMM-IMP-DEV-NBR (3)   TO SS95WS-IN-NBR.
028400     PERFORM SS95PD-NAP-ROUTINE
028500                                 THRU SS95PD-NAP-EXIT.
028600     MOVE SS95WS-OUT-NBR-L07     TO CM01-IMP-NBR3.
028700     MOVE MMMM-POS-DEV-NBR (1)   TO SS95WS-IN-NBR.
028800     PERFORM SS95PD-NAP-ROUTINE
028900                                 THRU SS95PD-NAP-EXIT.
029000     MOVE SS95WS-OUT-NBR-L07     TO CM01-POS-NBR1.
029100     MOVE MMMM-POS-DEV-NBR (2)   TO SS95WS-IN-NBR.
029200     PERFORM SS95PD-NAP-ROUTINE
029300                                 THRU SS95PD-NAP-EXIT.
029400     MOVE SS95WS-OUT-NBR-L07     TO CM01-POS-NBR2.
029500     MOVE MMMM-POS-DEV-NBR (3)   TO SS95WS-IN-NBR.
029600     PERFORM SS95PD-NAP-ROUTINE
029700                                 THRU SS95PD-NAP-EXIT.
029800     MOVE SS95WS-OUT-NBR-L07     TO CM01-POS-NBR3.
029900*
030000***********************************************************
030100*    SET THE CURRENCY CODE, CURRENCY NOD                  *
030200*            PER ITEM NOD, PERCENT NOD.                   *
030300***********************************************************
030400     IF CM01-ERR-MESSAGE IS EQUAL TO SPACES OR LOW-VALUES
030500        PERFORM MB06PD-FORMAT-MESSAGE-LINE
030600                                 THRU MB06PD-FML-EXIT
030700        MOVE SS08WS-FORMATTED-MSG   TO CM01-ERR-MESSAGE
030800     END-IF.
030900*
031000******************************************
031100*    SET THE CURSOR AND SCREEN NUMBER    *
031200******************************************
031300*
031400     IF  MMMM-REC-CLOSED
031500         MOVE SS08WS-CURSOR      TO CM01-ALT-TRANID-L
031600     ELSE
031700         MOVE SS08WS-CURSOR      TO CM01-CLOSE-FLAG-L.
031800*
031900     COMPUTE MBCA-SCREEN-NBR     =  MBCA-SCREEN-NBR - 50.
032000*
032100**********************
032200*    SEND THE MAP    *
032300**********************
032400*
032500     MOVE 'BM01'                 TO MBCA-PROGRAM-LOCATION.
032600     PERFORM MB60PD-SEND-MAP-WITH-ERASE
032700                                 THRU MB60PD-SMWE-EXIT.
032800*
032900************************
033000*    RETURN TO CICS    *
033100************************
033200*
033300     MOVE 'PC02'                 TO MBCA-PROGRAM-LOCATION.
033400     PERFORM MB70PD-RETURN-TRANS-ID
033500                                 THRU MB70PD-RTI-EXIT.
033600/
033700 C000-RECEIVE-SCREEN SECTION.
033800*
033900******************************************
034000*    THIS SECTION RECEIVES THE SCREEN    *
034100******************************************
034200*
034300     MOVE 'BM02'                 TO MBCA-PROGRAM-LOCATION
034400     PERFORM MB60PD-RECEIVE-MAP  THRU MB60PD-RM-EXIT.
034500*
034600**************************************************************
034700*    CHECK FOR ANOTHER TRANSACTION ID ENTERED BY THE USER    *
034800**************************************************************
034900*
035000     MOVE 'PC03'                 TO MBCA-PROGRAM-LOCATION.
035100     PERFORM MB60PD-NEW-TRANS-ROUTINE
035200                                 THRU MB60PD-NTR-EXIT.
035300*
035400************************************************
035500*    READ THE ORGANIZATION RECORD.             *
035600************************************************
035700*
035800     MOVE MBCA-MERCHANT-ORG      TO MBIOWS-MMOC-ORG.
035900     MOVE 'FC01'                 TO MBCA-PROGRAM-LOCATION.
036000     SET MBIORO-READ-RANDOM      TO TRUE.
036100     PERFORM MMOCAO-ACCESS       THRU MMOCAO-ACCESS-EXIT.
036200*
036300*****************************************
036400*    READ THE MERCH MASTER RECORD       *
036500*****************************************
036600*
036700     MOVE 'FC02'                 TO MBCA-PROGRAM-LOCATION.
036800     PERFORM 9100-READ-MMMM      THRU 9199-READ-MMMM-EXIT.
036900*
037000 C020-FIELD-EDITS.
037100*
037200***************************************
037300*    FIELD EDIT FOR CLOSE MERCH FLAG  *
037400***************************************
037500*
037600     IF  CM01-CLOSE-FLAG-L       IS GREATER THAN ZERO
037700         MOVE DFHBMASF           TO CM01-CLOSE-FLAG-A
037800     ELSE
037900         MOVE 'N'                TO CM01-CLOSE-FLAG.
038000*
038100     IF  CM01-VALID-CLOSE-FLAG
038200         NEXT SENTENCE
038300     ELSE
038400         GO TO C025-CLOSE-FLAG-ERROR.
038500*
038600     GO TO C030-CLOSE-REASON.
038700*
038800 C025-CLOSE-FLAG-ERROR.
038900*
039000     IF  CM01-CLOSE-FLAG-L       IS GREATER THAN ZERO
039100         MOVE DFHBMUBF           TO CM01-CLOSE-FLAG-A.
039200*
039300     SET SS08WS-ERROR-SW-YES     TO TRUE.
039400     MOVE DFHBMASB               TO CM01-CLOSE-FLAG-LP-A
039500                                    CM01-CLOSE-FLAG-RP-A.
039600     MOVE SS08WS-CURSOR          TO CM01-CLOSE-FLAG-L.
039700*
039800 C030-CLOSE-REASON.
039900*
040000***************************************
040100*    FIELD EDIT FOR CLOSE REASON      *
040200***************************************
040300*
040400     IF  CM01-CLOSE-REASON-L     IS GREATER THAN ZERO
040500         MOVE DFHBMASF           TO CM01-CLOSE-REASON-A
040600     ELSE
040700         MOVE MMMM-CLOSE-REASON  TO CM01-CLOSE-REASON.
040800*
040900     IF  CM01-CLOSE-FLAG-L IS GREATER THAN ZERO
041000     AND CM01-CLOSE-FLAG  IS EQUAL TO 'Y'
041100     AND CM01-CLOSE-REASON IS EQUAL TO SPACES
041200         GO TO C035-CLOSE-REASON-ERROR.
041300*
041400     GO TO C040-EDIT-OUT-OF-BUS-DATE.
041500*
041600 C035-CLOSE-REASON-ERROR.
041700*
041800     IF  CM01-CLOSE-REASON-L     IS GREATER THAN ZERO
041900         MOVE DFHBMUBF           TO CM01-CLOSE-REASON-A.
042000*
042100     SET SS08WS-ERROR-SW-YES     TO TRUE.
042200     MOVE DFHBMASB               TO CM01-CLOSE-REASON-LP-A
042300                                    CM01-CLOSE-REASON-RP-A.
042400     MOVE SS08WS-CURSOR          TO CM01-CLOSE-REASON-L.
042500*
042600 C040-EDIT-OUT-OF-BUS-DATE.
042700*
042800     IF  CM01-OUT-OF-BUS-DATE-L IS EQUAL TO ZERO
042900         MOVE MMMM-OUT-OF-BUS-DATE
043000                                 TO SS01WS-JULIAN
043100         PERFORM SS08PD-JUL-TO-GREG
043200                                 THRU SS08PD-JTG-EXIT
043300         MOVE SS01WS-DATE        TO CM01-OUT-OF-BUS-DATE.
043400*
043500     IF  CM01-OUT-OF-BUS-DATE IS NOT NUMERIC
043600         GO TO C045-OUT-OF-BUS-DATE-ERROR.
043700*
043800     IF  CM01-OUT-OF-BUS-DATE IS LESS THAN 1000000
043900         MOVE CM01-OUT-OF-BUS-DATE
044000                                 TO SS01WS-MDY
044100         MOVE SS01WS-MDYZ        TO SS01WS-DATEZ
044200     ELSE
044300         MOVE CM01-OUT-OF-BUS-DATE
044400                                 TO SS01WS-DATE.
044500*
044600     PERFORM SS05PD-DATE-VALIDATION
044700                                 THRU SS05PD-DV-EXIT.
044800*
044900     IF  SS01WS-DATE-IS-INVALID
045000         GO TO C045-OUT-OF-BUS-DATE-ERROR
045100     ELSE
045200         MOVE SS01WS-DATE        TO CM01-OUT-OF-BUS-DATE.
045300*
045400     PERFORM SS07PD-GREG-TO-JUL  THRU SS07PD-GTJ-EXIT.
045500*
045600     IF  MMOC-TODAYS-JULIAN IS GREATER THAN SS01WS-JULIAN
045700     OR  MMOC-TODAYS-JULIAN IS EQUAL TO SS01WS-JULIAN
045800         NEXT SENTENCE
045900     ELSE
046000         GO TO C045-OUT-OF-BUS-DATE-ERROR.
046100*
046200     IF  SS01WS-JULIAN IS GREATER THAN MMMM-DATE-LAST-ACTIVE
046300     OR  SS01WS-JULIAN IS EQUAL TO ZEROS
046400         NEXT SENTENCE
046500     ELSE
046600         GO TO C045-OUT-OF-BUS-DATE-ERROR.
046700*
046800     GO TO C050-EDIT-OWNERSHIP-CHG-DATE.
046900*
047000 C045-OUT-OF-BUS-DATE-ERROR.
047100*
047200     IF  CM01-OUT-OF-BUS-DATE-L  IS GREATER THAN ZERO
047300         MOVE DFHBMNBF           TO CM01-OUT-OF-BUS-DATE-A.
047400*
047500     SET SS08WS-ERROR-SW-YES     TO TRUE.
047600     MOVE DFHBMASB               TO CM01-OUT-OF-BUS-DATE-LP-A
047700                                    CM01-OUT-OF-BUS-DATE-RP-A.
047800     MOVE SS08WS-CURSOR          TO CM01-OUT-OF-BUS-DATE-L.
047900*
048000 C050-EDIT-OWNERSHIP-CHG-DATE.
048100*
048200     IF  CM01-OWNERSHIP-CHG-DATE-L IS EQUAL TO ZERO
048300         MOVE MMMM-OWNERSHIP-CHG-DATE
048400                                 TO SS01WS-JULIAN
048500         PERFORM SS08PD-JUL-TO-GREG
048600                                 THRU SS08PD-JTG-EXIT
048700         MOVE SS01WS-DATE        TO CM01-OWNERSHIP-CHG-DATE.
048800*
048900     IF  CM01-OWNERSHIP-CHG-DATE IS NOT NUMERIC
049000         GO TO C055-OWNERSHIP-CHG-DATE-ERROR.
049100*
049200     IF  CM01-OWNERSHIP-CHG-DATE IS LESS THAN 1000000
049300         MOVE CM01-OWNERSHIP-CHG-DATE
049400                                 TO SS01WS-MDY
049500         MOVE SS01WS-MDYZ        TO SS01WS-DATEZ
049600     ELSE
049700         MOVE CM01-OWNERSHIP-CHG-DATE
049800                                 TO SS01WS-DATE.
049900*
050000     PERFORM SS05PD-DATE-VALIDATION
050100                                 THRU SS05PD-DV-EXIT.
050200*
050300     IF  SS01WS-DATE-IS-INVALID
050400         GO TO C055-OWNERSHIP-CHG-DATE-ERROR
050500     ELSE
050600         MOVE SS01WS-DATE        TO CM01-OWNERSHIP-CHG-DATE.
050700*
050800     PERFORM SS07PD-GREG-TO-JUL  THRU SS07PD-GTJ-EXIT.
050900*
051000     IF  MMOC-TODAYS-JULIAN IS GREATER THAN SS01WS-JULIAN
051100     OR  MMOC-TODAYS-JULIAN IS EQUAL TO SS01WS-JULIAN
051200         NEXT SENTENCE
051300     ELSE
051400         GO TO C055-OWNERSHIP-CHG-DATE-ERROR.
051500*
051600     IF  SS01WS-JULIAN IS GREATER THAN MMMM-DATE-OPENED
051700     OR  SS01WS-JULIAN IS EQUAL TO ZEROS
051800         NEXT SENTENCE
051900     ELSE
052000         GO TO C055-OWNERSHIP-CHG-DATE-ERROR.
052100*
052200     GO TO D000-RETURN-ERRORS.
052300*
052400 C055-OWNERSHIP-CHG-DATE-ERROR.
052500*
052600     IF  CM01-OWNERSHIP-CHG-DATE-L IS GREATER THAN ZERO
052700         MOVE DFHBMNBF           TO CM01-OWNERSHIP-CHG-DATE-A.
052800*
052900     SET SS08WS-ERROR-SW-YES     TO TRUE.
053000     MOVE DFHBMASB               TO CM01-OWNERSHIP-CHG-DATE-LP-A
053100                                    CM01-OWNERSHIP-CHG-DATE-RP-A.
053200     MOVE SS08WS-CURSOR          TO CM01-OWNERSHIP-CHG-DATE-L.
053300*
053400/
053500 D000-RETURN-ERRORS SECTION.
053600*
053700     IF  SS08WS-ERROR-SW-NO
053800         GO TO E000-UPDATE-FILE.
053900*
054000***************************************************************
054100*    INITIALIZE THE STANDARD MAP LINES.  IN AN ERROR          *
054200*    CONDITION, THIS ROUTINE IS PERFORMED PRIMARILY           *
054300*    TO UPDATE THE DATE AND TIME ON THE SCREEN.               *
054400***************************************************************
054500*
054600     PERFORM MB60PD-INIT-STD-MAP-LINES
054700                                 THRU MB60PD-ISML-EXIT.
054800*
054900***********************************************************
055000*    SET THE CURRENCY CODE, CURRENCY NOD                  *
055100*            PER ITEM NOD, PERCENT NOD.                   *
055200***********************************************************
055300     IF CM01-ERR-MESSAGE IS EQUAL TO SPACES OR LOW-VALUES
055400        PERFORM MB06PD-FORMAT-MESSAGE-LINE
055500                                 THRU MB06PD-FML-EXIT
055600        MOVE SS08WS-FORMATTED-MSG   TO CM01-ERR-MESSAGE
055700     END-IF.
055800*
055900**********************
056000*    SEND THE MAP    *
056100**********************
056200*
056300     MOVE 'BM03'                 TO MBCA-PROGRAM-LOCATION.
056400     PERFORM MB60PD-SEND-MAP-DATA-ONLY
056500                                 THRU MB60PD-SMDO-EXIT.
056600*
056700************************
056800*    RETURN TO CICS    *
056900************************
057000*
057100     MOVE 'PC04'                 TO MBCA-PROGRAM-LOCATION.
057200     PERFORM MB70PD-RETURN-TRANS-ID
057300                                 THRU MB70PD-RTI-EXIT.
057400/
057500 E000-UPDATE-FILE SECTION.
057600*
057700****************************************************
057800*    READ THE MERCH MASTER RECORD FOR UPDATE       *
057900****************************************************
058000*
058100     MOVE 'FC03'                 TO MBCA-PROGRAM-LOCATION.
058200     SET MBIORO-READ-RANDOM-UPDATE
058300                                 TO TRUE.
058400     PERFORM MMMMAO-ACCESS       THRU MMMMAO-ACCESS-EXIT.
058500*
058600 E010-CONTINUE.
058700*
058800*************************************
058900*    OBTAIN STORAGE FOR LOG FILE    *
059000*    RECORD IF DOING MAINTENANCE    *
059100*************************************
059200*
059300     MOVE 'SC02'                 TO MBCA-PROGRAM-LOCATION.
059400     SET MBIORO-GETMAIN          TO TRUE.
059500     PERFORM MML1AO-ACCESS       THRU MML1AO-ACCESS-EXIT.
059600*
059700 E020-UPDATE-FIELDS.
059800*
059900     IF  CM01-CLOSE-FLAG-L       IS GREATER THAN ZERO
060000         IF CM01-CLOSE-FLAG IS EQUAL TO 'Y'
060100             SET WS-UPDATE-SW-YES
060200                                 TO TRUE
060300             MOVE 0197           TO MML1-FIELD-CODE
060400             MOVE ZEROES         TO MML1-FIELD-OCCURRENCE
060500                                    MML1-FIELD-OCCURRENCE-2
060600             MOVE MML1WS-VL-01   TO MML1-VARIABLE-LENGTH
060700             MOVE MMMM-REC-STATUS
060800                                 TO MML1-VL01-B-DATA-9
060900             SET MMMM-REC-CLOSED TO TRUE
061000             MOVE MMMM-REC-STATUS
061100                                 TO MML1-VL01-A-DATA-9
061200             MOVE 'FC04'         TO MBCA-PROGRAM-LOCATION
061300             PERFORM 9200-WRITE-LOG-REC-MERCH
061400                                 THRU 9299-WLRM-EXIT
061500             MOVE 0196           TO MML1-FIELD-CODE
061600             MOVE ZEROES         TO MML1-FIELD-OCCURRENCE
061700                                    MML1-FIELD-OCCURRENCE-2
061800             MOVE MML1WS-VL-03   TO MML1-VARIABLE-LENGTH
061900             MOVE MMMM-STATUS-CHANGE-OPER
062000                                 TO MML1-VL03-B-DATA-X
062100             MOVE MBCA-OPERATOR-ID
062200                                 TO MMMM-STATUS-CHANGE-OPER
062300             MOVE MMMM-STATUS-CHANGE-OPER
062400                                 TO MML1-VL03-A-DATA-X
062500             MOVE 'FC05'         TO MBCA-PROGRAM-LOCATION
062600             PERFORM 9200-WRITE-LOG-REC-MERCH
062700                                 THRU 9299-WLRM-EXIT.
062800*
062900     IF  CM01-CLOSE-REASON-L     IS GREATER THAN ZERO
063000         IF CM01-CLOSE-REASON IS NOT EQUAL TO MMMM-CLOSE-REASON
063100             SET WS-UPDATE-SW-YES
063200                                 TO TRUE
063300             MOVE 0192           TO MML1-FIELD-CODE
063400             MOVE ZEROES         TO MML1-FIELD-OCCURRENCE
063500                                    MML1-FIELD-OCCURRENCE-2
063600             MOVE MML1WS-VL-02   TO MML1-VARIABLE-LENGTH
063700             MOVE MMMM-CLOSE-REASON
063800                                 TO MML1-VL02-B-DATA-X
063900             MOVE CM01-CLOSE-REASON
064000                                 TO MMMM-CLOSE-REASON
064100             MOVE MMMM-CLOSE-REASON
064200                                 TO MML1-VL02-A-DATA-X
064300             MOVE 'FC06'         TO MBCA-PROGRAM-LOCATION
064400             PERFORM 9200-WRITE-LOG-REC-MERCH
064500                                 THRU 9299-WLRM-EXIT.
064600*
064700*
064800     IF  CM01-OUT-OF-BUS-DATE-L  IS GREATER THAN ZERO
064900         MOVE CM01-OUT-OF-BUS-DATE
065000                                 TO SS01WS-DATE
065100         PERFORM SS07PD-GREG-TO-JUL
065200                                 THRU SS07PD-GTJ-EXIT
065300         IF  SS01WS-JULIAN IS NOT EQUAL
065400                                 TO MMMM-OUT-OF-BUS-DATE
065500             SET WS-UPDATE-SW-YES
065600                                 TO TRUE
065700             SET WS-DATE-UPDATE-SW-YES
065800                                 TO TRUE
065900             MOVE 0190           TO MML1-FIELD-CODE
066000             MOVE ZEROES         TO MML1-FIELD-OCCURRENCE
066100                                    MML1-FIELD-OCCURRENCE-2
066200             MOVE MML1WS-VL-07   TO MML1-VARIABLE-LENGTH
066300             MOVE MMMM-OUT-OF-BUS-DATE
066400                                 TO MML1-VL07-B-DATA-9
066500             MOVE SS01WS-JULIAN  TO MMMM-OUT-OF-BUS-DATE
066600             MOVE MMMM-OUT-OF-BUS-DATE
066700                                 TO MML1-VL07-A-DATA-9
066800             MOVE 'FC07'         TO MBCA-PROGRAM-LOCATION
066900             PERFORM 9200-WRITE-LOG-REC-MERCH
067000                                 THRU 9299-WLRM-EXIT.
067100*
067200     IF  CM01-OWNERSHIP-CHG-DATE-L IS GREATER THAN ZERO
067300         MOVE CM01-OWNERSHIP-CHG-DATE
067400                                 TO SS01WS-DATE
067500         PERFORM SS07PD-GREG-TO-JUL
067600                                 THRU SS07PD-GTJ-EXIT
067700         IF  SS01WS-JULIAN IS NOT EQUAL
067800                                 TO MMMM-OWNERSHIP-CHG-DATE
067900             SET WS-UPDATE-SW-YES
068000                                 TO TRUE
068100             SET WS-DATE-UPDATE-SW-YES
068200                                 TO TRUE
068300             MOVE 0191           TO MML1-FIELD-CODE
068400             MOVE ZEROES         TO MML1-FIELD-OCCURRENCE
068500                                    MML1-FIELD-OCCURRENCE-2
068600             MOVE MML1WS-VL-07   TO MML1-VARIABLE-LENGTH
068700             MOVE MMMM-OWNERSHIP-CHG-DATE
068800                                 TO MML1-VL07-B-DATA-9
068900             MOVE SS01WS-JULIAN  TO MMMM-OWNERSHIP-CHG-DATE
069000             MOVE MMMM-OWNERSHIP-CHG-DATE
069100                                 TO MML1-VL07-A-DATA-9
069200             MOVE 'FC08'         TO MBCA-PROGRAM-LOCATION
069300             PERFORM 9200-WRITE-LOG-REC-MERCH
069400                                 THRU 9299-WLRM-EXIT.
069500 E040-UPDATE-MMMM.
069600*
069700**************************************************************
069800*    WRITE A LOG RECORD TO SHOW THAT THE LAST MAINT DATE     *
069900*    AND OPERATOR HAS BEEN UPDATED IF FIELDS WERE CHANGED    *
070000*    ON THE SCREEN                                           *
070100**************************************************************
070200*
070300     IF  WS-UPDATE-SW-YES
070400         PERFORM 9400-START-CROSS-REF
070500                                 THRU 9499-SCR-EXIT
070600         MOVE 0198               TO MML1-FIELD-CODE
070700         MOVE ZEROES             TO MML1-FIELD-OCCURRENCE
070800                                    MML1-FIELD-OCCURRENCE-2
070900         MOVE MML1WS-VL-03       TO MML1-VARIABLE-LENGTH
071000         MOVE MMMM-LAST-MAINT-OPER
071100                                 TO MML1-VL03-B-DATA-X
071200         MOVE MBCA-OPERATOR-ID   TO MMMM-LAST-MAINT-OPER
071300         MOVE MMMM-LAST-MAINT-OPER
071400                                 TO MML1-VL03-A-DATA-X
071500         MOVE 'FC07'             TO MBCA-PROGRAM-LOCATION
071600         PERFORM 9200-WRITE-LOG-REC-MERCH
071700                                 THRU 9299-WLRM-EXIT
071800         MOVE 0199               TO MML1-FIELD-CODE
071900         MOVE MML1WS-VL-07       TO MML1-VARIABLE-LENGTH
072000         MOVE MMMM-LAST-MAINT-DATE
072100                                 TO MML1-VL07-B-DATA-9
072200         MOVE MBCA-START-DATE    TO MMMM-LAST-MAINT-DATE
072300         MOVE MMMM-LAST-MAINT-DATE
072400                                 TO MML1-VL07-A-DATA-9
072500         MOVE 'FC08'             TO MBCA-PROGRAM-LOCATION
072600         PERFORM 9200-WRITE-LOG-REC-MERCH
072700                                 THRU 9299-WLRM-EXIT.
072800*
072900**************************************************************
073000*    REWRITE THE MERCH MASTER RECORD                         *
073100*    IF FIELDS HAVE BEEN CHANGED ON THE SCREEN, OR           *
073200*    UNLOCK IT IF THEY HAVE NOT                              *
073300**************************************************************
073400*
073500     IF  WS-UPDATE-SW-YES
073600         MOVE 'FC09'             TO MBCA-PROGRAM-LOCATION
073700         SET MBIORO-REWRITE      TO TRUE
073800         PERFORM MMMMAO-ACCESS   THRU MMMMAO-ACCESS-EXIT
073900     ELSE
074000         MOVE 'FC10'             TO MBCA-PROGRAM-LOCATION
074100         SET MBIORO-UNLOCK       TO TRUE
074200         PERFORM MMMMAO-ACCESS   THRU MMMMAO-ACCESS-EXIT.
074300/
074400 F000-SETUP-COMMAREA SECTION.
074500*
074600***************************************************************
074700*  SET UP COMMAREA FIELDS AND TRANSFER TO THE NEXT PROGRAM    *
074800***************************************************************
074900*
075000     MOVE MBCA-EIBAID            TO SS08WS-EIBAID.
075100*
075200     PERFORM MB60PD-EDIT-PAGE-NBR
075300                                 THRU MB60PD-EPN-EXIT.
075400*
075500     IF  SS08WS-VALID-PF-KEY
075600     OR  SS08WS-EIBAID-VALID-PF-KEY
075700         SET MBCA-INITIAL-SCREEN-NBR
075800                                 TO TRUE.
075900*
076000     MOVE 'PC05'                 TO MBCA-PROGRAM-LOCATION.
076100     PERFORM MB70PD-XCTL-TO-MBOXCTL
076200                                 THRU MB70PD-XTM-EXIT.
076300/
076400 9000-PERFORMED-AREA SECTION.
076500*
076600 9100-READ-MMMM.
076700*
076800*****************************************
076900*    READ THE MERCH MASTER RECORD       *
077000*****************************************
077100*
077200     MOVE MBCA-MERCHANT-ORG      TO MBIOWS-MMMM-ORG
077300                                    CM01-ORG.
077400     MOVE MBCA-MERCHANT          TO MBIOWS-MMMM-MERCHANT
077500                                    CM01-MERCHANT.
077600     SET MBIORO-READ-RANDOM      TO TRUE.
077700     PERFORM MMMMAO-ACCESS       THRU MMMMAO-ACCESS-EXIT.
077800*
077900 9199-READ-MMMM-EXIT.
078000     EXIT.
078100*
078200 9200-WRITE-LOG-REC-MERCH.
078300*
078400     MOVE 'MM'                   TO MML1-FILE-CODE.
078500     MOVE MBCA-MERCHANT-ORG      TO MML1-MMMM-ORG.
078600     MOVE MBCA-MERCHANT          TO MML1-MMMM-MERCHANT.
078700     MOVE MBCA-SIGNON-NAME       TO MML1-SIGNON-NAME.
078800     MOVE MBCA-TERMINAL-ID       TO MML1-TERMINAL-ID.
078900     MOVE ZEROS                  TO MML1-SOURCE-CODE.
079000     MOVE MBCA-FIELD-SECURITY    TO MML1-FIELD-SECURITY.
079100     SET MBIORO-WRITE            TO TRUE.
079200     PERFORM MML1AO-ACCESS       THRU MML1AO-ACCESS-EXIT.
079300     MOVE SPACES                 TO MML1-VARIABLE-AREA.
079400*
079500 9299-WLRM-EXIT.
079600     EXIT.
079700*
079800 9300-WRITE-LOG-REC-STORE.
079900*
080000     MOVE 'SM'                   TO MML1-FILE-CODE.
080100     MOVE MBCA-MERCHANT-ORG      TO MML1-MMSM-ORG.
080200     MOVE MMXR-STORE             TO MML1-MMSM-STORE.
080300     MOVE MBCA-SIGNON-NAME       TO MML1-SIGNON-NAME.
080400     MOVE MBCA-TERMINAL-ID       TO MML1-TERMINAL-ID.
080500     MOVE ZEROS                  TO MML1-SOURCE-CODE.
080600     MOVE MBCA-FIELD-SECURITY    TO MML1-FIELD-SECURITY.
080700     SET MBIORO-WRITE            TO TRUE.
080800     PERFORM MML1AO-ACCESS       THRU MML1AO-ACCESS-EXIT.
080900     MOVE SPACES                 TO MML1-VARIABLE-AREA.
081000*
081100 9399-WLRS-EXIT.
081200     EXIT.
081300*
081400 9400-START-CROSS-REF.
081500*
081600     MOVE 'FC11'                 TO MBCA-PROGRAM-LOCATION.
081700     MOVE MMMM-ORG               TO MBIOWS-MMXR-ORG.
081800     MOVE MMMM-MERCHANT          TO MBIOWS-MMXR-MERCHANT.
081900     MOVE ZEROS                  TO MBIOWS-MMXR-STORE.
082000     SET MBIORO-STARTBR-GTE      TO TRUE.
082100     PERFORM MMXRAO-ACCESS       THRU MMXRAO-ACCESS-EXIT.
082200*
082300 9410-READ-NEXT-MMXR.
082400*
082500     MOVE 'FC12'                 TO MBCA-PROGRAM-LOCATION.
082600     SET MBIORO-READ-SEQ         TO TRUE.
082700     PERFORM MMXRAO-ACCESS       THRU MMXRAO-ACCESS-EXIT.
082800*
082900     IF  MMXR-ORG-MERCHANT IS GREATER THAN MMMM-KEY
083000         GO TO 9420-MMXR-ENDBR
083100     ELSE
083200         IF  MMXR-ORG-MERCHANT IS LESS THAN MMMM-KEY
083300             GO TO 9420-MMXR-ENDBR
083400         ELSE
083500              PERFORM 9500-STORE-CLOSE
083600                                 THRU 9599-SC-EXIT.
083700*
083800     GO TO 9410-READ-NEXT-MMXR.
083900*
084000 9420-MMXR-ENDBR.
084100*
084200     MOVE 'FC13'                 TO MBCA-PROGRAM-LOCATION.
084300     SET MBIORO-ENDBR            TO TRUE.
084400     PERFORM MMXRAO-ACCESS       THRU MMXRAO-ACCESS-EXIT.
084500*
084600 9499-SCR-EXIT.
084700     EXIT.
084800*
084900 9500-STORE-CLOSE.
085000*
085100     MOVE 'FC14'                 TO MBCA-PROGRAM-LOCATION.
085200     MOVE SS08WS-CICS-FC-NOTFND  TO MBIORO-TEMP-STATUS-1.
085300     MOVE MMXR-ORG               TO MBIOWS-MMSM-ORG.
085400     MOVE MMXR-STORE             TO MBIOWS-MMSM-STORE.
085500     SET MBIORO-READ-RANDOM-UPDATE
085600                                 TO TRUE.
085700     PERFORM MMSMAO-ACCESS       THRU MMSMAO-ACCESS-EXIT.
085800*
085900     IF  SS08WS-RC-FC-NOTFND
086000         GO TO 9599-SC-EXIT.
086100*
086200     IF  WS-DATE-UPDATE-SW-YES
086300     AND (MMSM-REC-CLOSED
086400     OR   MMSM-REC-PENDING-PURGE
086500     OR   MMSM-REC-PURGING
086600     OR   MMSM-REC-PURGED)
086700         GO TO 9500-UPDATE-DATES.
086800*
086900     IF  NOT MMSM-REC-ACTIVE
087000         MOVE 'FC21'             TO MBCA-PROGRAM-LOCATION
087100         SET MBIORO-UNLOCK       TO TRUE
087200         PERFORM MMSMAO-ACCESS   THRU MMSMAO-ACCESS-EXIT
087300         GO TO 9599-SC-EXIT.
087400*
087500*
087600     IF  CM01-CLOSE-REASON-L     IS GREATER THAN ZERO
087700         IF CM01-CLOSE-REASON IS NOT EQUAL TO MMSM-CLOSE-REASON
087800             SET WS-UPDATE-STORE-SW-YES
087900                                 TO TRUE
088000             MOVE 0192           TO MML1-FIELD-CODE
088100             MOVE ZEROES         TO MML1-FIELD-OCCURRENCE
088200                                    MML1-FIELD-OCCURRENCE-2
088300             MOVE MML1WS-VL-02   TO MML1-VARIABLE-LENGTH
088400             MOVE MMSM-CLOSE-REASON
088500                                 TO MML1-VL02-B-DATA-X
088600             MOVE CM01-CLOSE-REASON
088700                                 TO MMSM-CLOSE-REASON
088800             MOVE MMSM-CLOSE-REASON
088900                                 TO MML1-VL02-A-DATA-X
089000             MOVE 'FC15'         TO MBCA-PROGRAM-LOCATION
089100             PERFORM 9300-WRITE-LOG-REC-STORE
089200                                 THRU 9399-WLRS-EXIT.
089300*
089400     IF  CM01-CLOSE-FLAG-L       IS GREATER THAN ZERO
089500         IF CM01-CLOSE-FLAG IS EQUAL TO 'Y'
089600             SET WS-UPDATE-STORE-SW-YES
089700                                 TO TRUE
089800             MOVE 0197           TO MML1-FIELD-CODE
089900             MOVE ZEROES         TO MML1-FIELD-OCCURRENCE
090000                                    MML1-FIELD-OCCURRENCE-2
090100             MOVE MML1WS-VL-01   TO MML1-VARIABLE-LENGTH
090200             MOVE MMSM-REC-STATUS
090300                                 TO MML1-VL01-B-DATA-9
090400             SET MMSM-REC-CLOSED TO TRUE
090500             MOVE MMSM-REC-STATUS
090600                                 TO MML1-VL01-A-DATA-9
090700             MOVE 'FC16'         TO MBCA-PROGRAM-LOCATION
090800             PERFORM 9300-WRITE-LOG-REC-STORE
090900                                 THRU 9399-WLRS-EXIT
091000             MOVE 0196           TO MML1-FIELD-CODE
091100             MOVE ZEROES         TO MML1-FIELD-OCCURRENCE
091200                                    MML1-FIELD-OCCURRENCE-2
091300             MOVE MML1WS-VL-03   TO MML1-VARIABLE-LENGTH
091400             MOVE MMSM-STATUS-CHANGE-OPER
091500                                 TO MML1-VL03-B-DATA-X
091600             MOVE MBCA-OPERATOR-ID
091700                                 TO MMSM-STATUS-CHANGE-OPER
091800             MOVE MMSM-STATUS-CHANGE-OPER
091900                                 TO MML1-VL03-A-DATA-X
092000             MOVE 'FC17'         TO MBCA-PROGRAM-LOCATION
092100             PERFORM 9300-WRITE-LOG-REC-STORE
092200                                 THRU 9399-WLRS-EXIT.
092300*
092400 9500-UPDATE-DATES.
092500*
092600     IF  CM01-OUT-OF-BUS-DATE-L  IS GREATER THAN ZERO
092700         MOVE CM01-OUT-OF-BUS-DATE
092800                                 TO SS01WS-DATE
092900         PERFORM SS07PD-GREG-TO-JUL
093000                                 THRU SS07PD-GTJ-EXIT
093100         IF  MMSM-OUT-OF-BUS-DATE IS EQUAL TO ZEROS
093200             SET WS-UPDATE-STORE-SW-YES
093300                                 TO TRUE
093400             MOVE 0190           TO MML1-FIELD-CODE
093500             MOVE ZEROES         TO MML1-FIELD-OCCURRENCE
093600                                    MML1-FIELD-OCCURRENCE-2
093700             MOVE MML1WS-VL-07   TO MML1-VARIABLE-LENGTH
093800             MOVE MMSM-OUT-OF-BUS-DATE
093900                                 TO MML1-VL07-B-DATA-9
094000             MOVE SS01WS-JULIAN  TO MMSM-OUT-OF-BUS-DATE
094100             MOVE MMSM-OUT-OF-BUS-DATE
094200                                 TO MML1-VL07-A-DATA-9
094300             MOVE 'FC07'         TO MBCA-PROGRAM-LOCATION
094400             PERFORM 9300-WRITE-LOG-REC-STORE
094500                                 THRU 9399-WLRS-EXIT.
094600*
094700     IF  CM01-OWNERSHIP-CHG-DATE-L IS GREATER THAN ZERO
094800         MOVE CM01-OWNERSHIP-CHG-DATE
094900                                 TO SS01WS-DATE
095000         PERFORM SS07PD-GREG-TO-JUL
095100                                 THRU SS07PD-GTJ-EXIT
095200         IF  MMSM-OWNERSHIP-CHG-DATE IS EQUAL TO ZERO
095300             SET WS-UPDATE-STORE-SW-YES
095400                                 TO TRUE
095500             MOVE 0191           TO MML1-FIELD-CODE
095600             MOVE ZEROES         TO MML1-FIELD-OCCURRENCE
095700                                    MML1-FIELD-OCCURRENCE-2
095800             MOVE MML1WS-VL-07   TO MML1-VARIABLE-LENGTH
095900             MOVE MMSM-OWNERSHIP-CHG-DATE
096000                                 TO MML1-VL07-B-DATA-9
096100             MOVE SS01WS-JULIAN  TO MMSM-OWNERSHIP-CHG-DATE
096200             MOVE MMSM-OWNERSHIP-CHG-DATE
096300                                 TO MML1-VL07-A-DATA-9
096400             MOVE 'FC08'         TO MBCA-PROGRAM-LOCATION
096500             PERFORM 9300-WRITE-LOG-REC-STORE
096600                                 THRU 9399-WLRS-EXIT.
096700*
096800     IF  WS-UPDATE-STORE-SW-YES
096900         MOVE 0198               TO MML1-FIELD-CODE
097000         MOVE ZEROES             TO MML1-FIELD-OCCURRENCE
097100                                    MML1-FIELD-OCCURRENCE-2
097200         MOVE MML1WS-VL-03       TO MML1-VARIABLE-LENGTH
097300         MOVE MMSM-LAST-MAINT-OPER
097400                                 TO MML1-VL03-B-DATA-X
097500         MOVE MBCA-OPERATOR-ID   TO MMSM-LAST-MAINT-OPER
097600         MOVE MMSM-LAST-MAINT-OPER
097700                                 TO MML1-VL03-A-DATA-X
097800         MOVE 'FC18'             TO MBCA-PROGRAM-LOCATION
097900         PERFORM 9300-WRITE-LOG-REC-STORE
098000                                 THRU 9399-WLRS-EXIT
098100         MOVE 0199               TO MML1-FIELD-CODE
098200         MOVE MML1WS-VL-07       TO MML1-VARIABLE-LENGTH
098300         MOVE MMSM-LAST-MAINT-DATE
098400                                 TO MML1-VL07-B-DATA-9
098500         MOVE MBCA-START-DATE    TO MMSM-LAST-MAINT-DATE
098600         MOVE MMSM-LAST-MAINT-DATE
098700                                 TO MML1-VL07-A-DATA-9
098800         MOVE 'FC19'             TO MBCA-PROGRAM-LOCATION
098900         PERFORM 9300-WRITE-LOG-REC-STORE
099000                                 THRU 9399-WLRS-EXIT.
099100*
099200     IF  WS-UPDATE-STORE-SW-YES
099300         SET WS-UPDATE-STORE-SW-NO
099400                                 TO TRUE
099500         MOVE 'FC20'             TO MBCA-PROGRAM-LOCATION
099600         SET MBIORO-REWRITE      TO TRUE
099700         PERFORM MMSMAO-ACCESS   THRU MMSMAO-ACCESS-EXIT
099800     ELSE
099900         MOVE 'FC21'             TO MBCA-PROGRAM-LOCATION
100000         SET MBIORO-UNLOCK       TO TRUE
100100         PERFORM MMSMAO-ACCESS   THRU MMSMAO-ACCESS-EXIT.
100200*
100300 9599-SC-EXIT.
100400     EXIT.
100500*
100600/
100700 Z000-COPIED-ROUTINES SECTION.
100800**********************************
100900*    JUL TO GREG DATE ROUTINE    *
101000**********************************
101100*
101200     COPY SS08PD.
101300/
101400**********************************
101500*    DATE VALIDATION ROUTINE     *
101600**********************************
101700*
101800     COPY SS05PD.
101900/
102000**********************************
102100*    GREG TO JULIAN              *
102200**********************************
102300*
102400     COPY SS07PD.
102500/
102600     COPY SS26PD.
102700/
102800     COPY SS27PD.
102900/
103000*********************************
103100*    LINE 24 PF KEYS ROUTINE    *
103200*********************************
103300*
103400     COPY SS15PD.
103500/
103600************************************************
103700*    STORE MASTER RECORD ACCESS ROUTINES       *
103800************************************************
103900*
104000     COPY MMSMAO.
104100/
104200************************************************
104300*    MERCH MASTER RECORD ACCESS ROUTINES       *
104400************************************************
104500*
104600     COPY MMMMAO.
104700/
104800************************************************************
104900*    STORE MERCHANT CROSS REF MASTER RECORD ACCESS ROUTINES*
105000************************************************************
105100*
105200     COPY MMXRAO.
105300/
105400************************************************
105500*    ORGANIZATION RECORD ACCESS ROUTINES       *
105600************************************************
105700*
105800     COPY MMOCAO.
105900/
106000*****************************************
106100*    LOG FILE RECORD ACCESS ROUTINES    *
106200*****************************************
106300*
106400     COPY MML1AO.
106500/
106600*******************************************
106700*    FORMAT NBR AND AMTS BY CURRENCY CODE *
106800*******************************************
106900*
107000     COPY SS95PDO REPLACING ==:XXCA:== BY ==MBCA==.
107100/
107200*****************************
107300*    ONLINE MAP ROUTINES    *
107400*****************************
107500*
107600     COPY MB60PD REPLACING 'MBMAPXX' BY 'MBCM01 '
107700                           MBMAPXXI BY MBCM01I
107800                           MBMAPXXO BY MBCM01O.
107900/
108000***********************************
108100*    FORMAT MESSAGE LINE BUILDER  *
108200***********************************
108300*
108400     COPY MB06PD.
108500/
108600***************************
108700*    ONLINE PROCEDURES    *
108800***************************
108900*
109000     COPY MB70PD.
109100/
109200     COPY SMFTPXO.
