000100 IDENTIFICATION DIVISION.
000200 PROGRAM-ID. MBODC00.
000201*       RELEASE DATE=08/24/01.        REVISION LEVEL=08.06      *
000202*****************************************************************
000203*WARNING.  THIS COMPUTER PROGRAM IS PROTECTED BY COPYRIGHT LAW  *
000204*AND INTERNATIONAL TREATIES.  UNAUTHORIZED REPRODUCTION OR      *
000205*DISTRIBUTION OF THIS PROGRAM, OR ANY PORTION OF IT, MAY RESULT *
000206*IN SEVERE CIVIL AND CRIMINAL PENATLIES, AND WILL BE PROSECUTED *
000207*TO THE MAXIMUM EXTENT POSSIBLE UNDER THE LAW.                  *
000208*COPYRIGHT 1999 PAYSYS INTERNATIONAL, INC.  ALL RIGHTS RESERVED.*
000209*****************************************************************
000300*****************************************************************
000400*                                                               *
000500*               M E R C H A N T   S Y S T E M                   *
000600*                                                               *
000700*      MBODC00 - ON-LINE MERCHANT CHAIN DIRECTORY               *
000800*                SCREEN 00                                      *
000900*                                                               *
001000*              1. TRANSIDS                                      *
001100*                 A. MBDC                                       *
001200*              2. MAPS USED -                                   *
001300*                 A. MBDC00 (SCREEN 00)                         *
001400*              3. FILES USED -                                  *
001500*                 A. MMOC   (ORG CONTROL FILE)                  *
001600*                 B. MMRC   (MERCHANT RELATIONSHIP CONTROL FILE)*
001700*                                                               *
001800*****************************************************************
001900*
002000 ENVIRONMENT DIVISION.
002100 DATA DIVISION.
002200 WORKING-STORAGE SECTION.
002300 01  FILLER                  PIC  X(12)      VALUE '** WS-BEG **'.
002400*         I/O REQUEST BLOCK WORK AREAS
002500     COPY MBIOWS.
002600/         I/O REQUEST BLOCK
002700     COPY MBIORO.
002800/         DATE WORK AREAS
002900     COPY SS01WS.
003000/         ONLINE WORK AREAS
003100     COPY SS08WS.
003200/
003300     COPY SS00WS.
003400/
003500     COPY SMFTWS.
003600/
003700     COPY SMPTRL REPLACING ==:SMPT:== BY ==SMPT==.
003800/
003900     COPY MB61LK.
004000/         STANDARD ERROR MESSAGES
004100     COPY MBEMWS.
004200*
004300 01  FILLER                  PIC  X(12)      VALUE '** WS-END **'.
004400/
004500 LINKAGE SECTION.
004600 01  DFHCOMMAREA.
004700     COPY MB60WS.
004800/         MERCHANT CHAIN DIRECTORY SCREEN 01 MAP DSECT
004900     COPY MBDC00.
005000/         MERCHANT CHAIN DIRECTORY SCREEN 01 MAP REDEFINITION
005100     COPY MBDC00R.
005200/         ORG CONTROL RECORD LAYOUT
005300     COPY MMOCRL.
005400/         MERCHANT RELATIONSHIP CONTROL RECORD LAYOUT
005500     COPY MMRCRL.
005600/
005700 PROCEDURE DIVISION.
005800 0000-HOUSEKEEPING SECTION.
005900 0100-INIT.
006000*
006100     MOVE 'PC01'                 TO MBCA-PROGRAM-LOCATION.
006200     PERFORM MB70PD-ON-LINE-HOUSEKEEPING
006300                                 THRU MB70PD-OLH-EXIT.
006400*
006500     IF  MBCA-RECEIVE-SCREEN
006600         GO TO 2000-RECEIVE-SCREEN.
006700*
006800 1000-SEND-SCREEN SECTION.
006900*
007000****************************************************************
007100*    GET CICS STORAGE NEEDED FOR THE MAP                       *
007200****************************************************************
007300*
007400     MOVE 'SC01'                 TO MBCA-PROGRAM-LOCATION.
007500     PERFORM MB60PD-GETMAIN-FOR-MAP
007600                                 THRU MB60PD-GFM-EXIT.
007700*
007800*****************************************************************
007900*    CHECK KEY CODES                                            *
008000* 1. IF INITIAL KEY CODE, BYPASS CHECK OF KEY CODES.            *
008100* 2. IF MMRC KEY CODE, IT MUST BE A VALID CODE.  IF DIRECT, GO  *
008200*    TO THE RECEIVE EDITING ROUTINE SINCE WE HAVE PLUGGED THE   *
008300*    ORG AND CHAIN INTO THE MAP.  IF AN ERROR OCCURS IN THE     *
008400*    RECEIVE SCREEN ROUTINE, IT WILL HANDLE BUILDING THE MAP    *
008500*    AND IT WILL SEND ITS OWN SCREEN.  THIS IS WHY LOCATE       *
008600*    PROGRAMS ALWAYS SEND WITH ERASE NO MATTER WHICH ROUTINE    *
008700*    YOU ARE IN.  IF NOT DIRECT, PLUG ORG AND CHAIN INTO THE MAP*
008800*    AND BYPASS ANY OTHER CHECKING OF THE KEY CODE.             *
008900* 3. IF 2 IS FALSE, SEE IF THE MBCA-MERCHANT-ORG                *
009000*    FIELD IS GREATER THAN ZERO.  IF SO, PLUG INTO MAP.         *
009100*    SEE IF THE MBCA-CHAIN FIELD IS GREATER THAN ZERO.  IF SO,  *
009200*    PLUG INTO MAP.                                             *
009300*    HANDLE IF THEY WERE NON-DIRECT.                            *
009400*****************************************************************
009500*
009600     IF  MBCA-INITIAL-KEY-CODE
009700         GO TO 1100-BUILD-SCREEN.
009800*
009900     IF  MBCA-MMRC-KEY-CODE
010000     AND MBCA-MERCHANT-ORG IS GREATER THAN ZERO
010100         MOVE MBCA-MERCHANT-ORG  TO DC00-ORG
010200         MOVE DFHBMUNF           TO DC00-ORG-A
010300         IF  MBCA-CHAIN IS GREATER THAN ZEROES
010400             MOVE MBCA-CHAIN     TO DC00-CHAIN
010500             MOVE DFHBMUNF       TO DC00-CHAIN-A
010600             IF  MBCA-DIRECT-TRANSFER-CODE
010700             AND MBCA-INITIAL-SCREEN-NBR
010800                 MOVE 00         TO MBCA-SCREEN-NBR
010900                 GO TO 2120-READ-ORG
011000             ELSE
011100                 GO TO 1100-BUILD-SCREEN.
011200*
011300     IF  MBCA-VALID-KEY-CODES
011400     AND MBCA-MERCHANT-ORG IS GREATER THAN ZERO
011500         MOVE MBCA-MERCHANT-ORG  TO DC00-ORG
011600         MOVE DFHBMUNF           TO DC00-ORG-A
011700         IF  MBCA-CHAIN IS GREATER THAN ZEROES
011800             MOVE MBCA-CHAIN     TO DC00-CHAIN
011900             MOVE DFHBMUNF       TO DC00-CHAIN-A.
012000*
012100 1100-BUILD-SCREEN.
012200*
012300****************************************************************
012400*    INITIALIZE THE STANDARD MAP LINES                         *
012500****************************************************************
012600*
012700     MOVE SS08WS-CURSOR          TO DC00-ORG-L.
012800     MOVE 00                     TO MBCA-SCREEN-NBR.
012900     PERFORM MB60PD-INIT-STD-MAP-LINES
013000                                 THRU MB60PD-ISML-EXIT.
013100*
013200     IF  MBCA-MERCHANT-ORG IS NUMERIC
013300     AND MBCA-MERCHANT-ORG IS GREATER THAN ZEROES
013400         MOVE MBCA-MERCHANT-ORG  TO DC00-ORG
013500         MOVE DFHBMUNF           TO DC00-ORG-A.
013600*
013700     IF  MBCA-CHAIN IS NUMERIC
013800     AND MBCA-CHAIN IS GREATER THAN ZEROES
013900         MOVE MBCA-CHAIN         TO DC00-CHAIN
014000         MOVE DFHBMUNF           TO DC00-CHAIN-A.
014100*
014200     MOVE DFHBMASK               TO DC00-CURRENT-PAGE-A.
014300*
014400****************************************************************
014500*    SEND THE MAP                                              *
014600****************************************************************
014700*
014800     MOVE 'BM01'                 TO MBCA-PROGRAM-LOCATION.
014900     PERFORM MB60PD-SEND-MAP-WITH-ERASE
015000                                 THRU MB60PD-SMWE-EXIT.
015100*
015200****************************************************************
015300*    RETURN TO CICS                                            *
015400****************************************************************
015500*
015600     MOVE 'PC02'                 TO MBCA-PROGRAM-LOCATION.
015700     PERFORM MB70PD-RETURN-TRANS-ID
015800                                 THRU MB70PD-RTI-EXIT.
015900/
016000 2000-RECEIVE-SCREEN SECTION.
016100*
016200****************************************************************
016300*    THIS SECTION RECEIVES THE 00 SCREEN                       *
016400****************************************************************
016500*
016600     MOVE 'BM02'                 TO MBCA-PROGRAM-LOCATION.
016700     PERFORM MB60PD-RECEIVE-MAP  THRU MB60PD-RM-EXIT.
016800*
016900****************************************************************
017000*    CHECK FOR ANOTHER TRANSACTION ID ENTERED BY THE USER      *
017100****************************************************************
017200*
017300     MOVE 'PC03'                 TO MBCA-PROGRAM-LOCATION.
017400     PERFORM MB60PD-NEW-TRANS-ROUTINE
017500                                 THRU MB60PD-NTR-EXIT.
017600*
017700 2100-EDIT-SCREEN.
017800*
017900     SET SS08WS-ERROR-SW-NO      TO TRUE.
018000     MOVE MBCA-EIBAID            TO SS08WS-EIBAID.
018100*
018200     IF  (DC00-ORG-L IS LESS THAN 1
018300     AND  DC00-CHAIN-L IS LESS THAN 1)
018400     AND (SS08WS-VALID-PF-KEY
018500     OR   SS08WS-EIBAID-VALID-PF-KEY)
018600         SET MBCA-INITIAL-SCREEN-NBR
018700                                 TO TRUE
018800         GO TO 2690-TRANSFER-XCTL.
018900*
019000 2110-EDIT-ORG.
019100*
019200     MOVE DFHBMUNF               TO DC00-ORG-A.
019300     MOVE DFHBMASK               TO DC00-ORG-LP-A
019400                                    DC00-ORG-RP-A.
019500*
019600     IF  DC00-ORG-L IS EQUAL TO ZERO
019700     OR  DC00-ORG IS NOT NUMERIC
019800         MOVE MBEMWS-INVALID-ORG TO DC00-ERR-MESSAGE
019900         GO TO 2130-ORG-ERROR.
020000*
020100     IF  DC00-ORG IS LESS THAN MBCA-ORG-LOW
020200     OR  DC00-ORG IS GREATER THAN MBCA-ORG-HIGH
020300         MOVE MBEMWS-INVALID-ORG TO DC00-ERR-MESSAGE
020400         GO TO 2130-ORG-ERROR.
020500*
020600 2120-READ-ORG.
020700*
020800****************************************************************
020900*    READ THE ORGANIZATION FILE                                *
021000****************************************************************
021100*
021200     MOVE 'FC01'                 TO MBCA-PROGRAM-LOCATION.
021300     MOVE DC00-ORG               TO MBIOWS-MMOC-ORG.
021400     MOVE SS08WS-CICS-FC-NOTFND  TO MBIORO-TEMP-STATUS-1.
021500     SET MBIORO-READ-RANDOM      TO TRUE.
021600     PERFORM MMOCAO-ACCESS       THRU MMOCAO-ACCESS-EXIT.
021700*
021800     IF  SS08WS-RC-FC-VALID-RTN-CODE
021900         MOVE MMOC-ORG           TO MBCA-MERCHANT-ORG
022000                                    MBCA-MBDC-ORG
022100         IF  MMOC-ADD-PENDING
022200             MOVE MBEMWS-ADD-PENDING
022300                                 TO DC00-ERR-MESSAGE
022400         ELSE
022500             IF  MMOC-REC-INCOMPLETE
022600             OR  MMOC-REC-PURGED
022700                 MOVE MBEMWS-NOT-ACTIVE
022800                                 TO DC00-ERR-MESSAGE
022900             ELSE
023000                 MOVE MMOC-NA-LINE (1 1)
023100                                 TO MBCA-MBDC-ORG-NAME
023200                 GO TO 2140-EDIT-RELATIONSHIP
023300     ELSE
023400         MOVE MBEMWS-NOT-ON-FILE TO DC00-ERR-MESSAGE.
023500*
023600 2130-ORG-ERROR.
023700*
023800     MOVE DFHBMNBF               TO DC00-ORG-A.
023900     MOVE DFHBMASB               TO DC00-ORG-LP-A
024000                                    DC00-ORG-RP-A.
024100     MOVE SS08WS-CURSOR          TO DC00-ORG-L.
024200     SET SS08WS-ERROR-SW-YES     TO TRUE.
024300*
024400 2140-EDIT-RELATIONSHIP.
024500*
024600     MOVE DFHBMUNF               TO DC00-CHAIN-A.
024700     MOVE DFHBMASK               TO DC00-CHAIN-LP-A
024800                                    DC00-CHAIN-RP-A.
024900*
025000     IF  DC00-CHAIN-L IS EQUAL TO ZERO
025100         MOVE ZEROES             TO DC00-CHAIN
025200     ELSE
025300         IF  DC00-CHAIN IS NOT NUMERIC
025400             MOVE MBEMWS-INVALID-CHAIN
025500                                 TO DC00-ERR-MESSAGE
025600             GO TO 2150-CHAIN-ERROR.
025700*
025800     IF  SS08WS-ERROR-SW-YES
025900         GO TO 2290-CHECK-ERROR.
026000*
026100****************************************************************
026200*    START BROWSE THE MERCHANT RELATIONSHIP FILE               *
026300****************************************************************
026400*
026500     MOVE 'FC02'                 TO MBCA-PROGRAM-LOCATION.
026600     MOVE MBCA-MBDC-ORG          TO MBIOWS-MMRC-ORG.
026700     MOVE DC00-CHAIN             TO MBIOWS-MMRC-CHAIN.
026800     SET MBIORO-STARTBR-GTE      TO TRUE.
026900     PERFORM MMRCAO-ACCESS       THRU MMRCAO-ACCESS-EXIT.
027000*
027100****************************************************************
027200*    READNEXT THE MERCHANT RELATIONSHIP FILE                   *
027300****************************************************************
027400*
027500     MOVE 'FC03'                 TO MBCA-PROGRAM-LOCATION.
027600     SET MBIORO-READ-SEQ         TO TRUE.
027700     PERFORM MMRCAO-ACCESS       THRU MMRCAO-ACCESS-EXIT.
027800*
027900****************************************************************
028000*    END BROWSE THE MERCHANT RELATIONSHIP FILE                 *
028100****************************************************************
028200*
028300     MOVE 'FC04'                 TO MBCA-PROGRAM-LOCATION.
028400     SET MBIORO-ENDBR            TO TRUE.
028500     PERFORM MMRCAO-ACCESS       THRU MMRCAO-ACCESS-EXIT.
028600*
028700     IF  MMRC-ORG    IS GREATER THAN MBCA-MBDC-ORG
028800         MOVE 'NO RECORDS ON FILE FOR THE SELECTION CRITERIA'
028900                                 TO DC00-ERR-MESSAGE
029000         MOVE DFHBMNBF           TO DC00-ORG-A
029100         MOVE DFHBMASB           TO DC00-ORG-LP-A
029200                                    DC00-ORG-RP-A
029300         MOVE SS08WS-CURSOR      TO DC00-ORG-L
029400     ELSE
029500         MOVE MMRC-CHAIN         TO MBCA-MBDC-FIRST-CHAIN-NBR
029600                                    MBCA-MBDC-FWD-CHAIN-NBR
029700                                    MBCA-CHAIN
029800         MOVE SPACES             TO MBCA-MBDC-RETURN-FLAG
029900         MOVE ZEROES             TO MBCA-MBDC-BACK-CHAIN-NBR
030000         GO TO 2290-CHECK-ERROR.
030100*
030200 2150-CHAIN-ERROR.
030300*
030400     MOVE DFHBMNBF               TO DC00-CHAIN-A.
030500     MOVE DFHBMASB               TO DC00-CHAIN-LP-A
030600                                    DC00-CHAIN-RP-A.
030700     MOVE SS08WS-CURSOR          TO DC00-CHAIN-L.
030800     SET SS08WS-ERROR-SW-YES     TO TRUE.
030900*
031000 2290-CHECK-ERROR.
031100*
031200     IF  SS08WS-ERROR-SW-NO
031300         GO TO 2600-SETUP-COMMAREA
031400     ELSE
031500         IF  SS08WS-VALID-PF-KEY
031600         OR  SS08WS-EIBAID-VALID-PF-KEY
031700             SET MBCA-INITIAL-SCREEN-NBR
031800                                 TO TRUE
031900             GO TO 2690-TRANSFER-XCTL.
032000*
032100 2300-SEND-MAP.
032200*
032300****************************************************************
032400*    SEND THE MAP                                              *
032500****************************************************************
032600*
032700     PERFORM MB60PD-INIT-STD-MAP-LINES
032800                                 THRU MB60PD-ISML-EXIT.
032900*
033000     MOVE DFHBMASK               TO DC00-CURRENT-PAGE-A.
033100*
033200     MOVE 'BM03'                 TO MBCA-PROGRAM-LOCATION.
033300     PERFORM MB60PD-SEND-MAP-DATA-ONLY
033400                                 THRU MB60PD-SMDO-EXIT.
033500*
033600****************************************************************
033700*    RETURN TO CICS                                            *
033800****************************************************************
033900*
034000     MOVE 'PC04'                 TO MBCA-PROGRAM-LOCATION.
034100     PERFORM MB70PD-RETURN-TRANS-ID
034200                                 THRU MB70PD-RTI-EXIT.
034300/
034400 2600-SETUP-COMMAREA.
034500*
034600****************************************************************
034700*    SET UP COMMAREA FIELDS AND TRANSFER TO THE NEXT PROGRAM   *
034800****************************************************************
034900*
035000     MOVE MBCA-EIBAID            TO SS08WS-EIBAID.
035100*
035200     MOVE MBIOWS-MMRC-KEY-CODE   TO MBCA-KEY-CODE.
035300*
035400     PERFORM MB60PD-EDIT-PAGE-NBR
035500                                 THRU MB60PD-EPN-EXIT.
035600*
035700     IF  SS08WS-VALID-PF-KEY
035800     OR  SS08WS-EIBAID-VALID-PF-KEY
035900         SET MBCA-INITIAL-SCREEN-NBR
036000                                 TO TRUE.
036100*
036200 2690-TRANSFER-XCTL.
036300*
036400     MOVE 'PC05'                 TO MBCA-PROGRAM-LOCATION.
036500     PERFORM MB70PD-XCTL-TO-MBOXCTL
036600                                 THRU MB70PD-XTM-EXIT.
036700/
036800 9000-PERFORMED-ROUTINES-SECT SECTION.
036900*         JULIAN TO GREGORIAN DATE ROUTINE
037000     COPY SS08PD.
037100/
037200     COPY SS26PD.
037300/
037400     COPY SS27PD.
037500/         LINE 24 PF KEYS ROUTINE
037600     COPY SS15PD.
037700/         ORG RECORD ACCESS ROUTINES
037800     COPY MMOCAO.
037900/         MERCHANT RELATIONSHIP RECORD 0 ACCESS ROUTINES
038000     COPY MMRCAO.
038100/         ON-LINE MAP ROUTINES
038200     COPY MB60PD REPLACING 'MBMAPXX' BY 'MBDC00 '
038300                           MBMAPXXI BY MBDC00I
038400                           MBMAPXXO BY MBDC00O.
038500/         ON-LINE PROCEDURES
038600     COPY MB70PD.
038700/
038800     COPY SMFTPXO.
