000100 IDENTIFICATION DIVISION.
000200 PROGRAM-ID. MBODC01.
000201*       RELEASE DATE=08/24/01.        REVISION LEVEL=08.06      *
000202*****************************************************************
000203*WARNING.  THIS COMPUTER PROGRAM IS PROTECTED BY COPYRIGHT LAW  *
000204*AND INTERNATIONAL TREATIES.  UNAUTHORIZED REPRODUCTION OR      *
000205*DISTRIBUTION OF THIS PROGRAM, OR ANY PORTION OF IT, MAY RESULT *
000206*IN SEVERE CIVIL AND CRIMINAL PENATLIES, AND WILL BE PROSECUTED *
000207*TO THE MAXIMUM EXTENT POSSIBLE UNDER THE LAW.                  *
000208*COPYRIGHT 1999 PAYSYS INTERNATIONAL, INC.  ALL RIGHTS RESERVED.*
000209*****************************************************************
000300*****************************************************************
000400*                                                               *
000500*               M E R C H A N T   S Y S T E M                   *
000600*                                                               *
000700*      MBODC01 - ON-LINE MERCHANT CHAIN DIRECTORY               *
000800*                SCREEN 01                                      *
000900*                                                               *
001000*              1. TRANSIDS                                      *
001100*                 A. MBDC                                       *
001200*              2. MAPS USED -                                   *
001300*                 A. MBDC01 (SCREEN 01)                         *
001400*              3. FILES USED -                                  *
001500*                 A. MMRC   (MERCHANT RELATIONSHIP CONTROL FILE)*
001600*                                                               *
001700*****************************************************************
001800*
001900 ENVIRONMENT DIVISION.
002000 DATA DIVISION.
002100 WORKING-STORAGE SECTION.
002200 01  FILLER                  PIC  X(12)      VALUE '** WS-BEG **'.
002300*         I/O REQUEST BLOCK WORK AREAS
002400     COPY MBIOWS.
002500/         I/O REQUEST BLOCK
002600     COPY MBIORO.
002700/         DATE WORK AREAS
002800     COPY SS01WS.
002900/         ONLINE WORK AREAS
003000     COPY SS08WS.
003100/
003200     COPY SS00WS.
003300/
003400     COPY SMFTWS.
003500/
003600     COPY SMPTRL REPLACING ==:SMPT:== BY ==SMPT==.
003700/
003800     COPY MB61LK.
003900/
004000 01  WS-MISCELLANEOUS.
004100     03  WS-SAVE-EIBAID      PIC  X(01)      VALUE SPACES.
004200     03  WS-FWD-CHAIN-NBR    PIC  9(09)      VALUE ZEROES.
004300     03  WS-SELECT-SW        PIC  X(01)      VALUE 'N'.
004400         88  WS-SELECT-NO                    VALUE 'N'.
004500         88  WS-SELECT-YES                   VALUE 'Y'.
004600     03  WS-BYPASS-SW        PIC  X(01)      VALUE 'N'.
004700         88  WS-BYPASS-NO                    VALUE 'N'.
004800         88  WS-BYPASS-YES                   VALUE 'Y'.
004900     03  TS-QUEUE-NAME.
005000         05  TS-QN-TERMID    PIC  X(04)      VALUE SPACES.
005100         05  TS-QN-TRANID    PIC  X(04)      VALUE 'MBDC'.
005200*
005300 01  WS-DETAIL-LINE.
005400     03  WS-CHAIN-NBR        PIC  9(09).
005500     03  FILLER              PIC  X(05)      VALUE SPACES.
005600     03  WS-CHAIN-NAME       PIC  X(40).
005700     03  FILLER              PIC  X(05)      VALUE SPACES.
005800     03  WS-STATUS-CODE      PIC  9(01).
005900*
006000 01  FILLER                  PIC  X(12)      VALUE '** WS-END **'.
006100/
006200 LINKAGE SECTION.
006300 01  DFHCOMMAREA.
006400     COPY MB60WS.
006500/         MERCHANT CHAIN DIRECTORY SCREEN 01 MAP DSECT
006600     COPY MBDC01.
006700/         MERCHANT CHAIN DIRECTORY SCREEN 01 MAP REDEFINITION
006800     COPY MBDC01R.
006900/         MERCHANT RELATIONSHIP CONTROL RECORD LAYOUT
007000     COPY MMRCRL.
007100/         MERCHANT CHAIN DIRECTORY TEMPORARY STORAGE
007200     COPY MBDCTS.
007300/
007400 PROCEDURE DIVISION.
007500 0000-HOUSEKEEPING SECTION.
007600 0100-INIT.
007700*
007800     MOVE MBCA-EIBAID            TO WS-SAVE-EIBAID.
007900     SET MBCA-EIBAID-ENTER       TO TRUE.
008000*
008100     MOVE 'PC01'                 TO MBCA-PROGRAM-LOCATION.
008200     PERFORM MB70PD-ON-LINE-HOUSEKEEPING
008300                                 THRU MB70PD-OLH-EXIT.
008400*
008500     MOVE WS-SAVE-EIBAID         TO MBCA-EIBAID.
008600     MOVE MBCA-TERMINAL-ID       TO TS-QN-TERMID.
008700*
008800     IF  MBCA-RECEIVE-SCREEN
008900         GO TO 2000-RECEIVE-SCREEN.
009000*
009100 1000-SEND-SCREEN SECTION.
009200*
009300****************************************************************
009400*    GET CICS STORAGE NEEDED FOR THE MAP                       *
009500****************************************************************
009600*
009700     MOVE 'SC01'                 TO MBCA-PROGRAM-LOCATION.
009800     PERFORM MB60PD-GETMAIN-FOR-MAP
009900                                 THRU MB60PD-GFM-EXIT.
010000*
010100     MOVE MBCA-MBDC-ORG          TO DC01-ORG.
010200     MOVE MBCA-MBDC-ORG-NAME     TO DC01-ORG-NAME.
010300     MOVE MBCA-MBDC-FIRST-CHAIN-NBR
010400                                 TO DC01-CHAIN.
010500     MOVE 01                     TO MBCA-SCREEN-NBR.
010600*
010700****************************************************************
010800*    INITIALIZE THE STANDARD MAP LINES                         *
010900****************************************************************
011000*
011100     PERFORM MB60PD-INIT-STD-MAP-LINES
011200                                 THRU MB60PD-ISML-EXIT.
011300*
011400****************************************************************
011500*    ACQUIRE MAIN STORAGE FOR TEMP STORAGE RECORD              *
011600****************************************************************
011700*
011800     MOVE 'TS01'                 TO MBCA-PROGRAM-LOCATION.
011900     PERFORM 8100-TEMP-STORAGE-GETMAIN
012000                                 THRU 8199-TSG-EXIT.
012100*
012200     EXEC CICS HANDLE CONDITION
012300               QIDERR (1010-CHECK-RETURN-FLAG)
012400          END-EXEC.
012500*
012600***********************************************
012700*    READ THE TEMP STORAGE RECORD             *
012800***********************************************
012900*
013000     MOVE 'TS02'                 TO MBCA-PROGRAM-LOCATION.
013100     PERFORM 8200-TEMP-STORAGE-READ
013200                                 THRU 8299-TSR-EXIT.
013300*
013400***********************************************
013500*    DELETE THE TEMP STORAGE RECORD           *
013600***********************************************
013700*
013800     MOVE 'TS03'                 TO MBCA-PROGRAM-LOCATION.
013900     PERFORM 8300-TEMP-STORAGE-DELETE
014000                                 THRU 8399-TSD-EXIT.
014100*
014200     PERFORM 8800-BUILD-SCREEN   THRU 8899-BS-EXIT.
014300     GO TO 1080-CONTINUE.
014400*
014500 1010-CHECK-RETURN-FLAG.
014600*
014700     IF  MBCA-MBDC-RETURN-BOTTOM
014800         PERFORM 8900-LAST-SCREEN
014900                                 THRU 8999-LS-EXIT
015000         IF  WS-BYPASS-YES
015100             GO TO 1015-READ-RELATIONSHIP
015200         ELSE
015300             GO TO 1080-CONTINUE
015400     ELSE
015500         IF  MBCA-MBDC-RETURN-BWD
015600             PERFORM 9000-BACK-SCREEN
015700                                 THRU 9099-BS-EXIT
015800             IF  WS-BYPASS-YES
015900                 GO TO 1015-READ-RELATIONSHIP
016000             ELSE
016100                 GO TO 1080-CONTINUE.
016200*
016300 1015-READ-RELATIONSHIP.
016400*
016500****************************************************************
016600*    START BROWSE THE MERCHANT RELATIONSHIP FILE               *
016700****************************************************************
016800*
016900     MOVE 'FC01'                 TO MBCA-PROGRAM-LOCATION.
017000     MOVE MBCA-MBDC-ORG          TO MBIOWS-MMRC-ORG.
017100     MOVE MBCA-MBDC-FWD-CHAIN-NBR
017200                                 TO MBIOWS-MMRC-CHAIN.
017300     SET MBIORO-STARTBR-GTE      TO TRUE.
017400     PERFORM MMRCAO-ACCESS       THRU MMRCAO-ACCESS-EXIT.
017500*
017600     SET X-CHAIN-INDEX           TO +1.
017700*
017800 1020-READ-LOOP.
017900*
018000****************************************************************
018100*    READNEXT THE MERCHANT RELATIONSHIP FILE                   *
018200****************************************************************
018300*
018400     MOVE 'FC02'                 TO MBCA-PROGRAM-LOCATION.
018500     SET MBIORO-READ-SEQ         TO TRUE.
018600     PERFORM MMRCAO-ACCESS       THRU MMRCAO-ACCESS-EXIT.
018700*
018800     IF  MMRC-ORG    IS GREATER THAN MBCA-MBDC-ORG
018900         GO TO 1020-END-BROWSE.
019000*
019100     PERFORM 9500-BUILD-SCREEN-LINE
019200                                 THRU 9599-BSL-EXIT.
019300*
019400     IF  X-CHAIN-INDEX IS EQUAL TO +1
019500         MOVE MMRC-CHAIN         TO MBCA-MBDC-BACK-CHAIN-NBR.
019600*
019700     IF  X-CHAIN-INDEX IS LESS THAN +15
019800         SET X-CHAIN-INDEX       UP BY +1
019900         GO TO 1020-READ-LOOP
020000     ELSE
020100         MOVE MMRC-CHAIN         TO MBCA-MBDC-FWD-CHAIN-NBR
020200         PERFORM 9400-READ-AHEAD THRU 9499-RA-EXIT
020300         SET X-CHAIN-INDEX       UP BY +1.
020400*
020500 1020-END-BROWSE.
020600*
020700****************************************************************
020800*    END BROWSE THE MERCHANT RELATIONSHIP FILE                 *
020900****************************************************************
021000*
021100     MOVE 'FC03'                 TO MBCA-PROGRAM-LOCATION.
021200     SET MBIORO-ENDBR            TO TRUE.
021300     PERFORM MMRCAO-ACCESS       THRU MMRCAO-ACCESS-EXIT.
021400*
021500 1060-SET-ATTRIBUTE.
021600*
021700     IF  X-CHAIN-INDEX IS EQUAL TO +1
021800         IF  MBCA-MBDC-RETURN-NORMAL
021900             SET MBCA-INITIAL-SCREEN-NBR
022000                                 TO TRUE
022100             MOVE 'PC02'         TO MBCA-PROGRAM-LOCATION
022200             PERFORM MB70PD-XCTL-TO-MBOXCTL
022300                                 THRU MB70PD-XTM-EXIT
022400         ELSE
022500             MOVE MBCA-MBDC-BACK-CHAIN-NBR
022600                                 TO MBCA-MBDC-FWD-CHAIN-NBR
022700             GO TO 1015-READ-RELATIONSHIP.
022800*
022900     IF  X-CHAIN-INDEX IS LESS THAN +16
023000         SET X-TS-MBDC-INDEX     TO X-CHAIN-INDEX
023100         MOVE ZEROES             TO MBCA-MBDC-FWD-CHAIN-NBR
023200                                    WS-FWD-CHAIN-NBR
023300                                    TS-MBDC-CHAIN-NBR
023400                                    (X-TS-MBDC-INDEX)
023500                                    TS-MBDC-STATUS-CODE
023600                                    (X-TS-MBDC-INDEX)
023700         MOVE SPACES             TO TS-MBDC-CHAIN-NAME
023800                                    (X-TS-MBDC-INDEX)
023900         MOVE DFHBMASK           TO DC01-SELECT-A
024000                                    (X-CHAIN-INDEX)
024100         MOVE DFHBMDAS           TO DC01-DIRECTORY-LINE-A
024200                                    (X-CHAIN-INDEX)
024300                                    DC01-SELECT-LP-A
024400                                    (X-CHAIN-INDEX)
024500                                    DC01-SELECT-RP-A
024600                                    (X-CHAIN-INDEX)
024700         SET X-CHAIN-INDEX       UP BY +1
024800         GO TO 1060-SET-ATTRIBUTE.
024900*
025000 1080-CONTINUE.
025100*
025200     IF  MBCA-MBDC-BACK-CHAIN-NBR IS NOT EQUAL
025300                                 TO MBCA-MBDC-FIRST-CHAIN-NBR
025400         MOVE DFHBMASB           TO DC01-FWD-BACK-IND-A (1).
025500*
025600     IF  WS-FWD-CHAIN-NBR IS NOT EQUAL TO ZEROES
025700         MOVE DFHBMASB           TO DC01-FWD-BACK-IND-A (15).
025800*
025900****************************************************************
026000*    WRITE THE TEMP STORAGE RECORD                             *
026100****************************************************************
026200*
026300     MOVE 'TS04'                 TO MBCA-PROGRAM-LOCATION.
026400     PERFORM 8400-WRITE-QUEUE    THRU 8499-WQ-EXIT.
026500*
026600     PERFORM 9100-SET-ATTRIBUTE  THRU 9199-SA-EXIT
026700         VARYING X-CHAIN-INDEX   FROM +1 BY +1
026800         UNTIL   X-CHAIN-INDEX IS GREATER THAN +15.
026900*
027000     SET X-CHAIN-INDEX           TO +1.
027100*
027200 1090-CURSOR-LOOP.
027300*
027400     IF  X-CHAIN-INDEX IS GREATER THAN +15
027500         MOVE SS08WS-CURSOR      TO DC01-ALT-TRANID-L
027600         GO TO 1100-CONTINUE.
027700*
027800     IF  DC01-SELECT-A (X-CHAIN-INDEX)
027900                                 IS EQUAL TO DFHBMASK
028000         SET X-CHAIN-INDEX       UP BY +1
028100         GO TO 1090-CURSOR-LOOP
028200     ELSE
028300         MOVE SS08WS-CURSOR      TO DC01-SELECT-L
028400                                    (X-CHAIN-INDEX).
028500*
028600 1100-CONTINUE.
028700*
028800     MOVE '*TOP*'                TO SS08WS-LINE-24-PF-KEY-FUNC(3).
028900     MOVE '*BOT*'                TO SS08WS-LINE-24-PF-KEY-FUNC(4).
029000     MOVE '*FWD*'                TO SS08WS-LINE-24-PF-KEY-FUNC(5).
029100     MOVE '*BWD*'                TO SS08WS-LINE-24-PF-KEY-FUNC(6).
029200     MOVE SS08WS-LINE-24         TO DC01-PF-KEYS.
029300     MOVE 'RESV'                 TO MBCA-PGMX-PF-TRANS-ID (3).
029400     MOVE 'RESV'                 TO MBCA-PGMX-PF-TRANS-ID (4).
029500     MOVE 'RESV'                 TO MBCA-PGMX-PF-TRANS-ID (5).
029600     MOVE 'RESV'                 TO MBCA-PGMX-PF-TRANS-ID (6).
029700*
029800     MOVE DFHBMASK               TO DC01-CURRENT-PAGE-A.
029900*
030000****************************************************************
030100*    SEND THE MAP                                              *
030200****************************************************************
030300*
030400     MOVE 'BM01'                 TO MBCA-PROGRAM-LOCATION.
030500     PERFORM MB60PD-SEND-MAP-WITH-ERASE
030600                                 THRU MB60PD-SMWE-EXIT.
030700*
030800****************************************************************
030900*    RETURN TO CICS                                            *
031000****************************************************************
031100*
031200     MOVE 'PC03'                 TO MBCA-PROGRAM-LOCATION.
031300     PERFORM MB70PD-RETURN-TRANS-ID
031400                                 THRU MB70PD-RTI-EXIT.
031500/
031600 2000-RECEIVE-SCREEN SECTION.
031700*
031800     IF  MBCA-EIBAID-CLEAR
031900         MOVE 'TS05'             TO MBCA-PROGRAM-LOCATION
032000         PERFORM 8300-TEMP-STORAGE-DELETE
032100                                 THRU 8399-TSD-EXIT
032200         MOVE 'PC04'             TO MBCA-PROGRAM-LOCATION
032300         PERFORM MB70PD-ON-LINE-HOUSEKEEPING
032400                                 THRU MB70PD-OLH-EXIT.
032500*
032600****************************************************************
032700*    THIS SECTION RECEIVES THE 01 SCREEN                       *
032800****************************************************************
032900*
033000     MOVE 'BM02'                 TO MBCA-PROGRAM-LOCATION.
033100     PERFORM MB60PD-RECEIVE-MAP  THRU MB60PD-RM-EXIT.
033200*
033300*****************************************************
033400*    ACQUIRE MAIN STORAGE FOR TEMP STORAGE RECORD   *
033500*****************************************************
033600*
033700     MOVE 'TS06'                 TO MBCA-PROGRAM-LOCATION.
033800     PERFORM 8100-TEMP-STORAGE-GETMAIN
033900                                 THRU 8199-TSG-EXIT.
034000*
034100***********************************************
034200*    READ THE TEMP STORAGE RECORD             *
034300***********************************************
034400*
034500     MOVE 'TS07'                 TO MBCA-PROGRAM-LOCATION.
034600     PERFORM 8200-TEMP-STORAGE-READ
034700                                 THRU 8299-TSR-EXIT.
034800*
034900***********************************************
035000*    DELETE THE TEMP STORAGE RECORD           *
035100***********************************************
035200*
035300     MOVE 'TS08'                 TO MBCA-PROGRAM-LOCATION.
035400     PERFORM 8300-TEMP-STORAGE-DELETE
035500                                 THRU 8399-TSD-EXIT.
035600*
035700****************************************************************
035800*    CHECK FOR ANOTHER TRANSACTION ID ENTERED BY THE USER      *
035900****************************************************************
036000*
036100     MOVE 'PC05'                 TO MBCA-PROGRAM-LOCATION.
036200     PERFORM MB60PD-NEW-TRANS-ROUTINE
036300                                 THRU MB60PD-NTR-EXIT.
036400*
036500 2005-EDIT-SELECT.
036600*
036700****************************************************************
036800*    EDIT SELECT FIELD                                         *
036900****************************************************************
037000*
037100     PERFORM 8600-EDIT-SELECT    THRU 8699-ES-EXIT.
037200*
037300 2090-CHECK-ERROR.
037400*
037500     IF  SS08WS-ERROR-SW-NO
037600         GO TO 2400-CHECK-SELECT.
037700*
037800 2300-SEND-MAP.
037900*
038000***********************************************
038100*    WRITE THE TEMP STORAGE RECORD            *
038200***********************************************
038300*
038400     MOVE 'TS09'                 TO MBCA-PROGRAM-LOCATION.
038500     PERFORM 8400-WRITE-QUEUE    THRU 8499-WQ-EXIT.
038600*
038700****************************************************************
038800*    SEND THE MAP                                              *
038900****************************************************************
039000*
039100     PERFORM MB60PD-INIT-STD-MAP-LINES
039200                                 THRU MB60PD-ISML-EXIT.
039300*
039400     MOVE '*TOP*'                TO SS08WS-LINE-24-PF-KEY-FUNC(3).
039500     MOVE '*BOT*'                TO SS08WS-LINE-24-PF-KEY-FUNC(4).
039600     MOVE '*FWD*'                TO SS08WS-LINE-24-PF-KEY-FUNC(5).
039700     MOVE '*BWD*'                TO SS08WS-LINE-24-PF-KEY-FUNC(6).
039800     MOVE SS08WS-LINE-24         TO DC01-PF-KEYS.
039900     MOVE 'RESV'                 TO MBCA-PGMX-PF-TRANS-ID (3).
040000     MOVE 'RESV'                 TO MBCA-PGMX-PF-TRANS-ID (4).
040100     MOVE 'RESV'                 TO MBCA-PGMX-PF-TRANS-ID (5).
040200     MOVE 'RESV'                 TO MBCA-PGMX-PF-TRANS-ID (6).
040300*
040400     MOVE DFHBMASK               TO DC01-CURRENT-PAGE-A.
040500*
040600     MOVE 'BM03'                 TO MBCA-PROGRAM-LOCATION.
040700     PERFORM MB60PD-SEND-MAP-DATA-ONLY
040800                                 THRU MB60PD-SMDO-EXIT.
040900*
041000****************************************************************
041100*    RETURN TO CICS                                            *
041200****************************************************************
041300*
041400     MOVE 'PC06'                 TO MBCA-PROGRAM-LOCATION.
041500     PERFORM MB70PD-RETURN-TRANS-ID
041600                                 THRU MB70PD-RTI-EXIT.
041700/
041800 2400-CHECK-SELECT.
041900*
042000     IF  WS-SELECT-YES
042100         SET X-TS-MBDC-INDEX     TO X-CHAIN-INDEX
042200         MOVE TS-MBDC-CHAIN-NBR (X-TS-MBDC-INDEX)
042300                                 TO MBCA-CHAIN
042400         MOVE MBIOWS-MMRC-DIRECT-KEY-CODE
042500                                 TO MBCA-KEY-CODE
042600         SET MBCA-INITIAL-SCREEN-NBR
042700                                 TO TRUE
042800         EVALUATE TRUE
042900           WHEN DC01-VALID-INQUIRY (X-CHAIN-INDEX)
043000               MOVE '..QC'       TO SS08WS-WORK-TRANS-ID
043100           WHEN DC01-VALID-STATUS-MAINT (X-CHAIN-INDEX)
043200               MOVE '..9C'       TO SS08WS-WORK-TRANS-ID
043300           WHEN OTHER
043400               MOVE '..MC'       TO SS08WS-WORK-TRANS-ID
043500         END-EVALUATE
043600         GO TO 2690-PF-KEY-BYPASS.
043700/
043800 2600-SETUP-COMMAREA.
043900*
044000****************************************************************
044100*    SET UP COMMAREA FIELDS AND TRANSFER TO THE NEXT PROGRAM   *
044200****************************************************************
044300*
044400     MOVE MBCA-EIBAID            TO SS08WS-EIBAID.
044500*
044600     IF  SS08WS-VALID-PF3
044700     OR  SS08WS-EIBAID-VALID-PF3
044800         MOVE 51                 TO MBCA-SCREEN-NBR
044900         MOVE MBCA-MBDC-FIRST-CHAIN-NBR
045000                                 TO MBCA-MBDC-FWD-CHAIN-NBR
045100         MOVE ' '                TO MBCA-MBDC-RETURN-FLAG
045200         GO TO 2690-PF-KEY-BYPASS.
045300*
045400     IF  SS08WS-VALID-PF4
045500     OR  SS08WS-EIBAID-VALID-PF4
045600         MOVE 51                 TO MBCA-SCREEN-NBR
045700         IF (TS-MBDC-CHAIN-NBR (1) IS GREATER THAN ZEROES
045800         AND TS-MBDC-CHAIN-NBR (15) IS EQUAL TO ZEROES)
045900         OR (MBCA-MBDC-FWD-CHAIN-NBR IS EQUAL TO ZEROES)
046000             MOVE ' '            TO MBCA-MBDC-RETURN-FLAG
046100             MOVE ZEROES         TO MBCA-MBDC-FWD-CHAIN-NBR
046200             MOVE 'TS10'         TO MBCA-PROGRAM-LOCATION
046300             PERFORM 8400-WRITE-QUEUE
046400                                 THRU 8499-WQ-EXIT
046500             GO TO 2690-PF-KEY-BYPASS
046600         ELSE
046700             MOVE 'E'            TO MBCA-MBDC-RETURN-FLAG
046800             GO TO 2690-PF-KEY-BYPASS.
046900*
047000     IF  SS08WS-VALID-PF5
047100     OR  SS08WS-EIBAID-VALID-PF5
047200         MOVE 51                 TO MBCA-SCREEN-NBR
047300         IF (TS-MBDC-CHAIN-NBR (1) IS GREATER THAN ZEROES
047400         AND TS-MBDC-CHAIN-NBR (15) IS EQUAL TO ZEROES)
047500         OR (MBCA-MBDC-FWD-CHAIN-NBR IS EQUAL TO ZEROES)
047600             MOVE ' '            TO MBCA-MBDC-RETURN-FLAG
047700             MOVE ZEROES         TO MBCA-MBDC-FWD-CHAIN-NBR
047800             MOVE 'TS11'         TO MBCA-PROGRAM-LOCATION
047900             PERFORM 8400-WRITE-QUEUE
048000                                 THRU 8499-WQ-EXIT
048100             GO TO 2690-PF-KEY-BYPASS
048200         ELSE
048300             MOVE 'F'            TO MBCA-MBDC-RETURN-FLAG
048400             ADD 1               TO MBCA-MBDC-FWD-CHAIN-NBR
048500             GO TO 2690-PF-KEY-BYPASS.
048600*
048700     IF  SS08WS-VALID-PF6
048800     OR  SS08WS-EIBAID-VALID-PF6
048900         MOVE 51                 TO MBCA-SCREEN-NBR
049000         IF  MBCA-MBDC-BACK-CHAIN-NBR IS EQUAL
049100                                 TO MBCA-MBDC-FIRST-CHAIN-NBR
049200             MOVE ' '            TO MBCA-MBDC-RETURN-FLAG
049300             MOVE 'TS12'         TO MBCA-PROGRAM-LOCATION
049400             PERFORM 8400-WRITE-QUEUE
049500                                 THRU 8499-WQ-EXIT
049600             GO TO 2690-PF-KEY-BYPASS
049700         ELSE
049800             MOVE MBCA-MBDC-BACK-CHAIN-NBR
049900                                 TO MBCA-MBDC-FWD-CHAIN-NBR
050000             MOVE 'B'            TO MBCA-MBDC-RETURN-FLAG
050100             GO TO 2690-PF-KEY-BYPASS.
050200*
050300     IF  SS08WS-VALID-PF-KEY
050400     OR  SS08WS-EIBAID-VALID-PF-KEY
050500     OR  TS-MBDC-CHAIN-NBR (15) IS EQUAL TO ZEROES
050600     OR  MBCA-MBDC-FWD-CHAIN-NBR IS EQUAL TO ZEROES
050700         SET MBCA-INITIAL-SCREEN-NBR
050800                                 TO TRUE
050900         MOVE MBIOWS-MMRC-KEY-CODE
051000                                 TO MBCA-KEY-CODE
051100         MOVE ' '                TO MBCA-MBDC-RETURN-FLAG
051200         GO TO 2690-PF-KEY-BYPASS.
051300*
051400     MOVE 51                     TO MBCA-SCREEN-NBR.
051500     ADD 1                       TO MBCA-MBDC-FWD-CHAIN-NBR.
051600     MOVE ' '                    TO MBCA-MBDC-RETURN-FLAG.
051700*
051800 2690-PF-KEY-BYPASS.
051900*
052000     MOVE 'PC07'                 TO MBCA-PROGRAM-LOCATION.
052100     PERFORM MB70PD-XCTL-TO-MBOXCTL
052200                                 THRU MB70PD-XTM-EXIT.
052300/
052400 8000-PERFORMED-ROUTINES-SECT SECTION.
052500*
052600 8100-TEMP-STORAGE-GETMAIN.
052700*
052800     EXEC CICS GETMAIN
052900               FLENGTH (LENGTH  OF TS-MBDC-RECORD)
053000               SET     (ADDRESS OF TS-MBDC-RECORD)
053100          END-EXEC.
053200*
053300 8199-TSG-EXIT.
053400     EXIT.
053500*
053600 8200-TEMP-STORAGE-READ.
053700*
053800     EXEC CICS READQ TS
053900               QUEUE   (TS-QUEUE-NAME)
054000               INTO    (TS-MBDC-RECORD)
054100               LENGTH  (LENGTH  OF TS-MBDC-RECORD)
054200               ITEM    (1)
054300          END-EXEC.
054400*
054500 8299-TSR-EXIT.
054600     EXIT.
054700*
054800 8300-TEMP-STORAGE-DELETE.
054900*
055000     EXEC CICS IGNORE CONDITION
055100               QIDERR
055200          END-EXEC.
055300*
055400     EXEC CICS DELETEQ TS
055500               QUEUE  (TS-QUEUE-NAME)
055600          END-EXEC.
055700*
055800 8399-TSD-EXIT.
055900     EXIT.
056000*
056100 8400-WRITE-QUEUE.
056200*
056300     EXEC CICS WRITEQ TS
056400               QUEUE   (TS-QUEUE-NAME)
056500               FROM    (TS-MBDC-RECORD)
056600               LENGTH  (LENGTH  OF TS-MBDC-RECORD)
056700          END-EXEC.
056800*
056900 8499-WQ-EXIT.
057000     EXIT.
057100*
057200 8600-EDIT-SELECT.
057300*
057400     SET X-CHAIN-INDEX           TO +1.
057500*
057600 8600-EDIT-LOOP.
057700*
057800     IF  DC01-SELECT-L (X-CHAIN-INDEX) IS GREATER THAN ZERO
057900         IF  DC01-VALID-SELECT (X-CHAIN-INDEX)
058000             MOVE DFHBMASF       TO DC01-SELECT-A
058100                                    (X-CHAIN-INDEX)
058200             MOVE DFHBMDAS       TO DC01-SELECT-LP-A
058300                                    (X-CHAIN-INDEX)
058400                                    DC01-SELECT-RP-A
058500                                    (X-CHAIN-INDEX)
058600             IF  DC01-VALID-INQUIRY-MAINT (X-CHAIN-INDEX)
058700                 MOVE 'Y'        TO WS-SELECT-SW
058800                 GO TO 8699-ES-EXIT
058900             ELSE
059000                 NEXT SENTENCE
059100         ELSE
059200             SET SS08WS-ERROR-SW-YES TO TRUE
059300             MOVE SS08WS-CURSOR  TO DC01-SELECT-L
059400                                    (X-CHAIN-INDEX)
059500             MOVE DFHBMUBF       TO DC01-SELECT-A
059600                                    (X-CHAIN-INDEX)
059700             MOVE DFHBMASB       TO DC01-SELECT-LP-A
059800                                    (X-CHAIN-INDEX)
059900                                    DC01-SELECT-RP-A
060000                                    (X-CHAIN-INDEX)
060100             GO TO 8699-ES-EXIT.
060200*
060300     IF  X-CHAIN-INDEX IS LESS THAN +15
060400         SET X-CHAIN-INDEX       UP BY +1
060500         GO TO 8600-EDIT-LOOP.
060600*
060700 8699-ES-EXIT.
060800     EXIT.
060900*
061000 8800-BUILD-SCREEN.
061100*
061200     SET X-CHAIN-INDEX           TO +1.
061300*
061400 8800-BUILD-LOOP.
061500*
061600     SET X-TS-MBDC-INDEX         TO X-CHAIN-INDEX.
061700*
061800     IF  TS-MBDC-CHAIN-NBR (X-TS-MBDC-INDEX)
061900                                 IS GREATER THAN ZEROES
062000         MOVE TS-MBDC-CHAIN-NBR (X-TS-MBDC-INDEX)
062100                                 TO WS-CHAIN-NBR
062200         MOVE TS-MBDC-CHAIN-NAME (X-TS-MBDC-INDEX)
062300                                 TO WS-CHAIN-NAME
062400         MOVE TS-MBDC-STATUS-CODE (X-TS-MBDC-INDEX)
062500                                 TO WS-STATUS-CODE
062600         MOVE WS-DETAIL-LINE     TO DC01-DIRECTORY-LINE
062700                                    (X-CHAIN-INDEX)
062800     ELSE
062900         MOVE DFHBMASK           TO DC01-SELECT-A
063000                                    (X-CHAIN-INDEX)
063100         MOVE DFHBMDAS           TO DC01-DIRECTORY-LINE-A
063200                                    (X-CHAIN-INDEX)
063300                                    DC01-SELECT-LP-A
063400                                    (X-CHAIN-INDEX)
063500                                    DC01-SELECT-RP-A
063600                                    (X-CHAIN-INDEX).
063700*
063800     IF  X-CHAIN-INDEX IS LESS THAN +15
063900         SET X-CHAIN-INDEX       UP BY +1
064000         GO TO 8800-BUILD-LOOP
064100     ELSE
064200         MOVE MBCA-MBDC-FWD-CHAIN-NBR
064300                                 TO WS-FWD-CHAIN-NBR.
064400*
064500 8899-BS-EXIT.
064600     EXIT.
064700*
064800 8900-LAST-SCREEN.
064900*
065000****************************************************************
065100*    START BROWSE THE MERCHANT RELATIONSHIP FILE               *
065200****************************************************************
065300*
065400     MOVE 'FC04'                 TO MBCA-PROGRAM-LOCATION.
065500     MOVE MBCA-MBDC-ORG          TO MBIOWS-MMRC-ORG.
065600     MOVE 999999999              TO MBIOWS-MMRC-CHAIN.
065700     SET MBIORO-STARTBR-GTE      TO TRUE.
065800     PERFORM MMRCAO-ACCESS       THRU MMRCAO-ACCESS-EXIT.
065900*
066000****************************************************************
066100*    READNEXT THE MERCHANT RELATIONSHIP FILE                   *
066200****************************************************************
066300*
066400     MOVE 'FC05'                 TO MBCA-PROGRAM-LOCATION.
066500     SET MBIORO-READ-SEQ         TO TRUE.
066600     PERFORM MMRCAO-ACCESS       THRU MMRCAO-ACCESS-EXIT.
066700*
066800****************************************************************
066900*    READPREV THE MERCHANT RELATIONSHIP FILE                   *
067000****************************************************************
067100*
067200     MOVE 'FC06'                 TO MBCA-PROGRAM-LOCATION.
067300     SET MBIORO-READ-PREV        TO TRUE.
067400     PERFORM MMRCAO-ACCESS       THRU MMRCAO-ACCESS-EXIT.
067500*
067600     SET X-CHAIN-INDEX           TO +15.
067700     MOVE 'N'                    TO WS-BYPASS-SW.
067800*
067900 8900-READ-RELATIONSHIP-FILE.
068000*
068100****************************************************************
068200*    READPREV THE MERCHANT RELATIONSHIP FILE                   *
068300****************************************************************
068400*
068500     MOVE 'FC07'                 TO MBCA-PROGRAM-LOCATION.
068600     SET MBIORO-READ-PREV        TO TRUE.
068700     PERFORM MMRCAO-ACCESS       THRU MMRCAO-ACCESS-EXIT.
068800*
068900 8900-BUILD-LOOP.
069000*
069100     IF (MMRC-ORG    IS LESS THAN MBCA-MBDC-ORG)
069200     OR (MMRC-ORG    IS EQUAL TO MBCA-MBDC-ORG
069300     AND MMRC-CHAIN    IS LESS THAN MBCA-MBDC-FIRST-CHAIN-NBR)
069400         GO TO 8900-END-BROWSE.
069500*
069600     IF  MMRC-CHAIN    IS EQUAL TO MBCA-MBDC-FIRST-CHAIN-NBR
069700     AND X-CHAIN-INDEX IS GREATER THAN +1
069800         MOVE ' '                TO MBCA-MBDC-RETURN-FLAG
069900         MOVE MBCA-MBDC-FIRST-CHAIN-NBR
070000                                 TO MBCA-MBDC-FWD-CHAIN-NBR
070100         MOVE 'Y'                TO WS-BYPASS-SW
070200         GO TO 8900-END-BROWSE.
070300*
070400     PERFORM 9500-BUILD-SCREEN-LINE
070500                                 THRU 9599-BSL-EXIT.
070600*
070700     IF  X-CHAIN-INDEX IS GREATER THAN +1
070800         SET X-CHAIN-INDEX       DOWN BY +1
070900         GO TO 8900-READ-RELATIONSHIP-FILE
071000     ELSE
071100         MOVE MMRC-CHAIN         TO MBCA-MBDC-BACK-CHAIN-NBR.
071200*
071300 8900-END-BROWSE.
071400*
071500****************************************************************
071600*    END BROWSE THE MERCHANT RELATIONSHIP FILE                 *
071700****************************************************************
071800*
071900     MOVE 'FC08'                 TO MBCA-PROGRAM-LOCATION.
072000     SET MBIORO-ENDBR            TO TRUE.
072100     PERFORM MMRCAO-ACCESS       THRU MMRCAO-ACCESS-EXIT.
072200*
072300     IF  WS-BYPASS-YES
072400         GO TO 8999-LS-EXIT.
072500*
072600     MOVE ZEROES                 TO MBCA-MBDC-FWD-CHAIN-NBR
072700                                    WS-FWD-CHAIN-NBR.
072800*
072900 8999-LS-EXIT.
073000     EXIT.
073100*
073200 9000-BACK-SCREEN.
073300*
073400****************************************************************
073500*    START BROWSE THE MERCHANT RELATIONSHIP FILE               *
073600****************************************************************
073700*
073800     MOVE 'FC09'                 TO MBCA-PROGRAM-LOCATION.
073900     MOVE MBCA-MBDC-ORG          TO MBIOWS-MMRC-ORG.
074000     MOVE MBCA-MBDC-FWD-CHAIN-NBR
074100                                 TO MBIOWS-MMRC-CHAIN.
074200     SET MBIORO-STARTBR-GTE      TO TRUE.
074300     PERFORM MMRCAO-ACCESS       THRU MMRCAO-ACCESS-EXIT.
074400*
074500****************************************************************
074600*    READNEXT THE MERCHANT RELATIONSHIP FILE                   *
074700****************************************************************
074800*
074900     MOVE 'FC10'                 TO MBCA-PROGRAM-LOCATION.
075000     SET MBIORO-READ-SEQ         TO TRUE.
075100     PERFORM MMRCAO-ACCESS       THRU MMRCAO-ACCESS-EXIT.
075200*
075300****************************************************************
075400*    READPREV THE MERCHANT RELATIONSHIP FILE                   *
075500****************************************************************
075600*
075700     MOVE 'FC11'                 TO MBCA-PROGRAM-LOCATION.
075800     SET MBIORO-READ-PREV        TO TRUE.
075900     PERFORM MMRCAO-ACCESS       THRU MMRCAO-ACCESS-EXIT.
076000*
076100     SET X-CHAIN-INDEX           TO +15.
076200     MOVE 'N'                    TO WS-BYPASS-SW.
076300*
076400 9000-READ-RELATIONSHIP-FILE.
076500*
076600****************************************************************
076700*    READPREV THE MERCHANT RELATIONSHIP FILE                   *
076800****************************************************************
076900*
077000     MOVE 'FC12'                 TO MBCA-PROGRAM-LOCATION.
077100     SET MBIORO-READ-PREV        TO TRUE.
077200     PERFORM MMRCAO-ACCESS       THRU MMRCAO-ACCESS-EXIT.
077300*
077400 9000-BUILD-LOOP.
077500*
077600     IF  X-CHAIN-INDEX IS GREATER THAN +1
077700     AND MMRC-CHAIN    IS EQUAL TO MBCA-MBDC-FIRST-CHAIN-NBR
077800         MOVE ' '                TO MBCA-MBDC-RETURN-FLAG
077900         MOVE MBCA-MBDC-FIRST-CHAIN-NBR
078000                                 TO MBCA-MBDC-FWD-CHAIN-NBR
078100         MOVE 'Y'                TO WS-BYPASS-SW
078200         GO TO 9000-END-BROWSE.
078300*
078400     IF  MMRC-CHAIN    IS EQUAL TO MBCA-MBDC-BACK-CHAIN-NBR
078500     AND X-CHAIN-INDEX IS EQUAL TO +15
078600         GO TO 9000-READ-RELATIONSHIP-FILE.
078700*
078800     PERFORM 9500-BUILD-SCREEN-LINE
078900                                 THRU 9599-BSL-EXIT.
079000*
079100     IF  X-CHAIN-INDEX IS EQUAL TO +15
079200         MOVE MMRC-CHAIN         TO MBCA-MBDC-FWD-CHAIN-NBR
079300                                    WS-FWD-CHAIN-NBR.
079400*
079500     IF  X-CHAIN-INDEX IS GREATER THAN +1
079600         SET X-CHAIN-INDEX       DOWN BY +1
079700         GO TO 9000-READ-RELATIONSHIP-FILE
079800     ELSE
079900         MOVE MMRC-CHAIN         TO MBCA-MBDC-BACK-CHAIN-NBR.
080000*
080100 9000-END-BROWSE.
080200*
080300****************************************************************
080400*    END BROWSE THE MERCHANT RELATIONSHIP FILE                 *
080500****************************************************************
080600*
080700     MOVE 'FC13'                 TO MBCA-PROGRAM-LOCATION.
080800     SET MBIORO-ENDBR            TO TRUE.
080900     PERFORM MMRCAO-ACCESS       THRU MMRCAO-ACCESS-EXIT.
081000*
081100 9099-BS-EXIT.
081200     EXIT.
081300*
081400 9100-SET-ATTRIBUTE.
081500*
081600     SET X-TS-MBDC-INDEX         TO X-CHAIN-INDEX.
081700*
081800     IF  TS-MBDC-STATUS-INCOMPLETE (X-TS-MBDC-INDEX)
081900         MOVE DFHBMASK           TO DC01-SELECT-A
082000                                    (X-CHAIN-INDEX)
082100         MOVE DFHBMDAS           TO DC01-SELECT-LP-A
082200                                    (X-CHAIN-INDEX)
082300                                    DC01-SELECT-RP-A
082400                                    (X-CHAIN-INDEX).
082500*
082600 9199-SA-EXIT.
082700     EXIT.
082800*
082900 9400-READ-AHEAD.
083000*
083100****************************************************************
083200*    READNEXT THE MERCHANT RELATIONSHIP FILE                   *
083300****************************************************************
083400*
083500     MOVE 'FC14'                 TO MBCA-PROGRAM-LOCATION.
083600     SET MBIORO-READ-SEQ         TO TRUE.
083700     PERFORM MMRCAO-ACCESS       THRU MMRCAO-ACCESS-EXIT.
083800*
083900     IF  MMRC-ORG    IS GREATER THAN MBCA-MBDC-ORG
084000         MOVE ZEROES             TO WS-FWD-CHAIN-NBR
084100                                    MBCA-MBDC-FWD-CHAIN-NBR
084200         GO TO 9499-RA-EXIT.
084300*
084400     MOVE MMRC-CHAIN             TO WS-FWD-CHAIN-NBR.
084500*
084600 9499-RA-EXIT.
084700     EXIT.
084800*
084900 9500-BUILD-SCREEN-LINE.
085000*
085100     SET X-TS-MBDC-INDEX         TO X-CHAIN-INDEX.
085200*
085300     MOVE MMRC-CHAIN             TO WS-CHAIN-NBR
085400                                    TS-MBDC-CHAIN-NBR
085500                                    (X-TS-MBDC-INDEX).
085600*
085700     MOVE MMRC-NA-LINE (1)       TO WS-CHAIN-NAME
085800                                    TS-MBDC-CHAIN-NAME
085900                                    (X-TS-MBDC-INDEX).
086000*
086100     MOVE MMRC-REC-STATUS        TO WS-STATUS-CODE
086200                                    TS-MBDC-STATUS-CODE
086300                                    (X-TS-MBDC-INDEX).
086400*
086500     MOVE WS-DETAIL-LINE         TO DC01-DIRECTORY-LINE
086600                                    (X-CHAIN-INDEX).
086700*
086800 9599-BSL-EXIT.
086900     EXIT.
087000/         JULIAN TO GREGORIAN DATE ROUTINE
087100     COPY SS08PD.
087200/
087300     COPY SS26PD.
087400/
087500     COPY SS27PD.
087600/         LINE 24 PF KEYS ROUTINE
087700     COPY SS15PD.
087800/         MERCHANT RELATIONSHIP RECORD 0 ACCESS ROUTINES
087900     COPY MMRCAO.
088000/         ON-LINE MAP ROUTINES
088100     COPY MB60PD REPLACING 'MBMAPXX' BY 'MBDC01 '
088200                           MBMAPXXI BY MBDC01I
088300                           MBMAPXXO BY MBDC01O.
088400/         ON-LINE PROCEDURES
088500     COPY MB70PD.
088600/
088700     COPY SMFTPXO.
