000100 IDENTIFICATION DIVISION.
000200 PROGRAM-ID. MBODE01.
000201*       RELEASE DATE=08/24/01.        REVISION LEVEL=08.06      *
000202*****************************************************************
000203*WARNING.  THIS COMPUTER PROGRAM IS PROTECTED BY COPYRIGHT LAW  *
000204*AND INTERNATIONAL TREATIES.  UNAUTHORIZED REPRODUCTION OR      *
000205*DISTRIBUTION OF THIS PROGRAM, OR ANY PORTION OF IT, MAY RESULT *
000206*IN SEVERE CIVIL AND CRIMINAL PENATLIES, AND WILL BE PROSECUTED *
000207*TO THE MAXIMUM EXTENT POSSIBLE UNDER THE LAW.                  *
000208*COPYRIGHT 1999 PAYSYS INTERNATIONAL, INC.  ALL RIGHTS RESERVED.*
000209*****************************************************************
000300*****************************************************************
000400*                                                               *
000500*   V - PLUS  M E R C H A N T   B A N K C A R D   S Y S T E M   *
000600*                                                               *
000700*      MBODE01 - ON-LINE EXPENSE FACTORS DIRECTORY              *
000800*                SCREEN 01                                      *
000900*                                                               *
001000*              1. TRANSIDS                                      *
001100*                 A. MBDE                                       *
001200*              2. MAPS USED -                                   *
001300*                 A. MBDE01 (SCREEN 01)                         *
001400*              3. FILES USED -                                  *
001500*                 A. MMEF   (EXPENSE FACTORS MASTER FILE)       *
001600*                                                               *
001700*****************************************************************
001800*
001900 ENVIRONMENT DIVISION.
002000 DATA DIVISION.
002100 WORKING-STORAGE SECTION.
002200 01  FILLER                  PIC  X(12)      VALUE '** WS-BEG **'.
002300*
002400*         I/O REQUEST BLOCK WORK AREAS
002500     COPY MBIOWS.
002600*
002700/         I/O REQUEST BLOCK
002800     COPY MBIORO.
002900*
003000/         DATE WORK AREAS
003100     COPY SS01WS.
003200*
003300/         ONLINE WORK AREAS
003400     COPY SS08WS.
003500/
003600     COPY SS00WS.
003700/
003800     COPY SMFTWS.
003900/
004000     COPY SMPTRL REPLACING ==:SMPT:== BY ==SMPT==.
004100/
004200     COPY MB61LK.
004300/
004400 01  WS-MISCELLANEOUS.
004500*
004600     03  WS-SAVE-EIBAID      PIC  X(01)      VALUE SPACES.
004700     03  WS-FWD-TABLE-NBR    PIC  9(09)      VALUE ZEROES.
004800*
004900     03  WS-SELECT-SW        PIC  X(01)      VALUE 'N'.
005000         88  WS-SELECT-NO                    VALUE 'N'.
005100         88  WS-SELECT-YES                   VALUE 'Y'.
005200*
005300     03  WS-BYPASS-SW        PIC  X(01)      VALUE 'N'.
005400         88  WS-BYPASS-NO                    VALUE 'N'.
005500         88  WS-BYPASS-YES                   VALUE 'Y'.
005600*
005700     03  TS-QUEUE-NAME.
005800         05  TS-QN-TERMID    PIC  X(04)      VALUE SPACES.
005900         05  TS-QN-TRANID    PIC  X(04)      VALUE 'MBDE'.
006000*
006100 01  WS-DETAIL-LINE.
006200     03  WS-TABLE-NBR        PIC  9(09).
006300     03  FILLER              PIC  X(07)      VALUE SPACES.
006400     03  WS-EXP-TABLE-NAME   PIC  X(30).
006500     03  FILLER              PIC  X(07)      VALUE SPACES.
006600     03  WS-STATUS-CODE      PIC  9(01).
006700*
006800 01  FILLER                  PIC  X(12)      VALUE '** WS-END **'.
006900/
007000 LINKAGE SECTION.
007100 01  DFHCOMMAREA.
007200     COPY MB60WS.
007300/         MERCHANT EXPENSE FACTORS DIRECTORY SCREEN MAP 01.
007400     COPY MBDE01.
007500/         MERCHANT EXPENSE FACTORS DIRECTORY SCREEN 01 REDEFINE.
007600     COPY MBDE01R.
007700/         EXPENSE FACTORS RECORD LAYOUT
007800     COPY MMIFRL REPLACING ==:MMIF:== BY ==MMEF==.
007900/         EXPENSE FACTORS DIRECTORY TEMPORARY STORAGE
008000     COPY MBDETS.
008100/
008200 PROCEDURE DIVISION.
008300 0000-HOUSEKEEPING SECTION.
008400 0100-INIT.
008500*
008600     MOVE MBCA-EIBAID            TO WS-SAVE-EIBAID.
008700     SET MBCA-EIBAID-ENTER       TO TRUE.
008800*
008900     MOVE 'PC01'                 TO MBCA-PROGRAM-LOCATION.
009000     PERFORM MB70PD-ON-LINE-HOUSEKEEPING
009100        THRU MB70PD-OLH-EXIT.
009200*
009300     MOVE WS-SAVE-EIBAID         TO MBCA-EIBAID.
009400     MOVE MBCA-TERMINAL-ID       TO TS-QN-TERMID.
009500*
009600     IF  MBCA-RECEIVE-SCREEN
009700         GO TO 2000-RECEIVE-SCREEN.
009800*
009900 1000-SEND-SCREEN SECTION.
010000*
010100****************************************************************
010200*    GET CICS STORAGE NEEDED FOR THE MAP                       *
010300****************************************************************
010400*
010500     MOVE 'SC01'                 TO MBCA-PROGRAM-LOCATION.
010600     PERFORM MB60PD-GETMAIN-FOR-MAP
010700        THRU MB60PD-GFM-EXIT.
010800*
010900     MOVE MBCA-MBDE-ORG          TO DE01-ORG.
011000     MOVE MBCA-MBDE-EXP-TABLE-NAME
011100                                 TO DE01-EXP-NAME.
011200     MOVE MBCA-MBDE-FIRST-TABLE-NBR
011300                                 TO DE01-BEG-TABLE-NBR.
011400     MOVE 01                     TO MBCA-SCREEN-NBR.
011500*
011600****************************************************************
011700*    INITIALIZE THE STANDARD MAP LINES                         *
011800****************************************************************
011900*
012000     PERFORM MB60PD-INIT-STD-MAP-LINES
012100        THRU MB60PD-ISML-EXIT.
012200*
012300****************************************************************
012400*    ACQUIRE MAIN STORAGE FOR TEMP STORAGE RECORD              *
012500****************************************************************
012600*
012700     MOVE 'TS01'                 TO MBCA-PROGRAM-LOCATION.
012800     PERFORM 8100-TEMP-STORAGE-GETMAIN
012900        THRU 8199-TSG-EXIT.
013000*
013100******************************************************************
013200*    IF NO TS HANDLE QUEUE ERROR AND GO TO 1010-CHECK RETURN-FLAG*
013300******************************************************************
013400*
013500     EXEC CICS HANDLE CONDITION
013600               QIDERR (1010-CHECK-RETURN-FLAG)
013700          END-EXEC.
013800*
013900***********************************************
014000*    READ THE TEMP STORAGE RECORD             *
014100***********************************************
014200*
014300     MOVE 'TS02'                 TO MBCA-PROGRAM-LOCATION.
014400     PERFORM 8200-TEMP-STORAGE-READ
014500        THRU 8299-TSR-EXIT.
014600*
014700***********************************************
014800*    DELETE THE TEMP STORAGE RECORD           *
014900***********************************************
015000*
015100     MOVE 'TS03'                 TO MBCA-PROGRAM-LOCATION.
015200     PERFORM 8300-TEMP-STORAGE-DELETE
015300        THRU 8399-TSD-EXIT.
015400*
015500     PERFORM 8800-BUILD-SCREEN
015600        THRU 8899-BS-EXIT.
015700*
015800     GO TO 1080-CONTINUE.
015900*
016000 1010-CHECK-RETURN-FLAG.
016100*
016200******************************************************************
016300*    TO ENTER THIS CODE NO TS QUEUE WAS AVAILABLE                *
016400******************************************************************
016500*
016600     IF  MBCA-MBDE-RETURN-BOTTOM
016700         PERFORM 8900-LAST-SCREEN
016800            THRU 8999-LS-EXIT
016900         IF  WS-BYPASS-YES
017000             GO TO 1015-READ-EXP-FILE
017100         ELSE
017200             GO TO 1080-CONTINUE
017300     ELSE
017400         IF  MBCA-MBDE-RETURN-BWD
017500             PERFORM 9000-BACK-SCREEN
017600                THRU 9099-BS-EXIT
017700             IF  WS-BYPASS-YES
017800                 GO TO 1015-READ-EXP-FILE
017900             ELSE
018000                 GO TO 1080-CONTINUE.
018100*
018200 1015-READ-EXP-FILE.
018300*
018400****************************************************************
018500*    START BROWSE THE EXPENSE FILE                             *
018600****************************************************************
018700*
018800     MOVE 'FC01'                 TO MBCA-PROGRAM-LOCATION.
018900     MOVE MBCA-MBDE-ORG          TO MBIOWS-MMEF-ORG.
019000     MOVE MBCA-MBDE-FWD-TABLE-NBR
019100                                 TO MBIOWS-MMEF-TABLE.
019200     SET MBIORO-STARTBR-GTE      TO TRUE.
019300     PERFORM MMEFAO-ACCESS       THRU MMEFAO-ACCESS-EXIT.
019400*
019500     SET X-DE01-MAP-SEL          TO +1.
019600*
019700 1020-READ-LOOP.
019800*
019900****************************************************************
020000*    READNEXT THE EXPENSE FACTORS FILE                         *
020100****************************************************************
020200*
020300     MOVE 'FC02'                 TO MBCA-PROGRAM-LOCATION.
020400     SET MBIORO-READ-SEQ         TO TRUE.
020500     PERFORM MMEFAO-ACCESS       THRU MMEFAO-ACCESS-EXIT.
020600*
020700     IF  MMEF-ORG IS GREATER THAN MBCA-MBDE-ORG
020800         GO TO 1020-END-BROWSE.
020900*
021000     PERFORM 9500-BUILD-SCREEN-LINE
021100        THRU 9599-BSL-EXIT.
021200*
021300     IF  X-DE01-MAP-SEL IS EQUAL TO +1
021400         MOVE MMEF-TABLE-NBR     TO MBCA-MBDE-BACK-TABLE-NBR.
021500*
021600     IF  X-DE01-MAP-SEL IS LESS THAN +15
021700         SET X-DE01-MAP-SEL      UP BY +1
021800         GO TO 1020-READ-LOOP
021900     ELSE
022000         MOVE MMEF-TABLE-NBR     TO MBCA-MBDE-FWD-TABLE-NBR
022100         PERFORM 9400-READ-AHEAD
022200            THRU 9499-RA-EXIT
022300         SET X-DE01-MAP-SEL      UP BY +1.
022400*
022500 1020-END-BROWSE.
022600*
022700****************************************************************
022800*    END BROWSE THE EXPENSE FILE                               *
022900****************************************************************
023000*
023100     MOVE 'FC03'                 TO MBCA-PROGRAM-LOCATION.
023200     SET MBIORO-ENDBR            TO TRUE.
023300     PERFORM MMEFAO-ACCESS
023400        THRU MMEFAO-ACCESS-EXIT.
023500*
023600 1060-SET-ATTRIBUTE.
023700*
023800     IF  X-DE01-MAP-SEL IS EQUAL TO +1
023900         IF  MBCA-MBDE-RETURN-NORMAL
024000             SET MBCA-INITIAL-SCREEN-NBR
024100                                 TO TRUE
024200             MOVE 'PC02'         TO MBCA-PROGRAM-LOCATION
024300             PERFORM MB70PD-XCTL-TO-MBOXCTL
024400                THRU MB70PD-XTM-EXIT
024500         ELSE
024600             MOVE MBCA-MBDE-BACK-TABLE-NBR
024700                                 TO MBCA-MBDE-FWD-TABLE-NBR
024800             GO TO 1015-READ-EXP-FILE.
024900*
025000     IF  X-DE01-MAP-SEL IS LESS THAN +16
025100         SET X-MBDETS-INDEX      TO X-DE01-MAP-SEL
025200         MOVE ZEROES             TO MBCA-MBDE-FWD-TABLE-NBR
025300                                    WS-FWD-TABLE-NBR
025400                                    MBDETS-TABLE-NBR
025500                                    (X-MBDETS-INDEX)
025600                                    MBDETS-STATUS-CODE
025700                                    (X-MBDETS-INDEX)
025800         MOVE SPACES             TO MBDETS-EXP-NAME
025900                                    (X-MBDETS-INDEX)
026000         MOVE DFHBMASK           TO DE01-SELECT-A
026100                                    (X-DE01-MAP-SEL)
026200         MOVE DFHBMDAS           TO DE01-TABLE-NBR-A
026300                                    (X-DE01-MAP-SEL)
026400                                    DE01-NAME-A
026500                                    (X-DE01-MAP-SEL)
026600                                    DE01-STAT-A
026700                                    (X-DE01-MAP-SEL)
026800                                    DE01-SELECT-LP-A
026900                                    (X-DE01-MAP-SEL)
027000                                    DE01-SELECT-RP-A
027100                                    (X-DE01-MAP-SEL)
027200         SET X-DE01-MAP-SEL      UP BY +1
027300         GO TO 1060-SET-ATTRIBUTE.
027400*
027500 1080-CONTINUE.
027600*
027700     IF  MBCA-MBDE-BACK-TABLE-NBR IS NOT EQUAL
027800                                 TO MBCA-MBDE-FIRST-TABLE-NBR
027900         MOVE DFHBMASB           TO DE01-FWD-BACK-IND-A (1).
028000*
028100     IF  WS-FWD-TABLE-NBR IS NOT EQUAL TO ZEROES
028200         MOVE DFHBMASB           TO DE01-FWD-BACK-IND-A (15).
028300*
028400****************************************************************
028500*    WRITE THE TEMP STORAGE RECORD                             *
028600****************************************************************
028700*
028800     MOVE 'TS04'                 TO MBCA-PROGRAM-LOCATION.
028900     PERFORM 8400-WRITE-QUEUE
029000        THRU 8499-WQ-EXIT.
029100*
029200     PERFORM 9100-SET-ATTRIBUTE
029300        THRU 9199-SA-EXIT
029400         VARYING X-DE01-MAP-SEL FROM +1 BY +1
029500         UNTIL   X-DE01-MAP-SEL IS GREATER THAN +15.
029600*
029700     SET X-DE01-MAP-SEL          TO +1.
029800*
029900 1090-CURSOR-LOOP.
030000*
030100******************************************************************
030200*    THIS PARAGRAPH WILL POSITION THE CURSOR. IT WILL LOOP THRU  *
030300*    MAP UNTILL IT FINDS A SELECT FIELD THAT IS NOT EQUAL TO     *
030400*    DFHBMASK, IT WILL THEN POSITION CURSOR THERE IF ALL FIELDS  *
030500*    ARE EQUAL TO MASK IT WILL POSITION CURSOR ON ALT TRANID     *
030600******************************************************************
030700*
030800     IF  X-DE01-MAP-SEL IS GREATER THAN +15
030900         MOVE SS08WS-CURSOR      TO DE01-ALT-TRANID-L
031000         GO TO 1100-CONTINUE.
031100*
031200     IF  DE01-SELECT-A (X-DE01-MAP-SEL)
031300                                 IS EQUAL TO DFHBMASK
031400         SET X-DE01-MAP-SEL      UP BY +1
031500         GO TO 1090-CURSOR-LOOP
031600     ELSE
031700         MOVE SS08WS-CURSOR      TO DE01-SELECT-L
031800                                    (X-DE01-MAP-SEL).
031900*
032000 1100-CONTINUE.
032100*
032200     MOVE '*TOP*'                TO SS08WS-LINE-24-PF-KEY-FUNC(3).
032300     MOVE '*BOT*'                TO SS08WS-LINE-24-PF-KEY-FUNC(4).
032400     MOVE '*FWD*'                TO SS08WS-LINE-24-PF-KEY-FUNC(5).
032500     MOVE '*BWD*'                TO SS08WS-LINE-24-PF-KEY-FUNC(6).
032600     MOVE SS08WS-LINE-24         TO DE01-PF-KEYS.
032700     MOVE 'RESV'                 TO MBCA-PGMX-PF-TRANS-ID (3).
032800     MOVE 'RESV'                 TO MBCA-PGMX-PF-TRANS-ID (4).
032900     MOVE 'RESV'                 TO MBCA-PGMX-PF-TRANS-ID (5).
033000     MOVE 'RESV'                 TO MBCA-PGMX-PF-TRANS-ID (6).
033100*
033200     MOVE DFHBMASK               TO DE01-CURRENT-PAGE-A.
033300*
033400****************************************************************
033500*    SEND THE MAP                                              *
033600****************************************************************
033700*
033800     MOVE 'BM01'                 TO MBCA-PROGRAM-LOCATION.
033900     PERFORM MB60PD-SEND-MAP-WITH-ERASE
034000        THRU MB60PD-SMWE-EXIT.
034100*
034200****************************************************************
034300*    RETURN TO CICS                                            *
034400****************************************************************
034500*
034600     MOVE 'PC03'                 TO MBCA-PROGRAM-LOCATION.
034700     PERFORM MB70PD-RETURN-TRANS-ID
034800        THRU MB70PD-RTI-EXIT.
034900/
035000 2000-RECEIVE-SCREEN SECTION.
035100*
035200******************************************************************
035300*    IF THE CLEAR KEY IS DEPRESSED DELETE TS QUEUE AND TRANSFER  *
035400*    CONTROL.                                                    *
035500******************************************************************
035600*
035700     IF  MBCA-EIBAID-CLEAR
035800         MOVE 'TS05'             TO MBCA-PROGRAM-LOCATION
035900         PERFORM 8300-TEMP-STORAGE-DELETE
036000            THRU 8399-TSD-EXIT
036100         MOVE 'PC04'             TO MBCA-PROGRAM-LOCATION
036200         PERFORM MB70PD-ON-LINE-HOUSEKEEPING
036300            THRU MB70PD-OLH-EXIT.
036400*
036500****************************************************************
036600*    THIS SECTION RECEIVES THE 01 SCREEN                       *
036700****************************************************************
036800*
036900     MOVE 'BM02'                 TO MBCA-PROGRAM-LOCATION.
037000     PERFORM MB60PD-RECEIVE-MAP
037100        THRU MB60PD-RM-EXIT.
037200*
037300*****************************************************
037400*    ACQUIRE MAIN STORAGE FOR TEMP STORAGE RECORD   *
037500*****************************************************
037600*
037700     MOVE 'TS06'                 TO MBCA-PROGRAM-LOCATION.
037800     PERFORM 8100-TEMP-STORAGE-GETMAIN
037900        THRU 8199-TSG-EXIT.
038000*
038100***********************************************
038200*    READ THE TEMP STORAGE RECORD             *
038300***********************************************
038400*
038500     MOVE 'TS07'                 TO MBCA-PROGRAM-LOCATION.
038600     PERFORM 8200-TEMP-STORAGE-READ
038700        THRU 8299-TSR-EXIT.
038800*
038900***********************************************
039000*    DELETE THE TEMP STORAGE RECORD           *
039100***********************************************
039200*
039300     MOVE 'TS08'                 TO MBCA-PROGRAM-LOCATION.
039400     PERFORM 8300-TEMP-STORAGE-DELETE
039500        THRU 8399-TSD-EXIT.
039600*
039700****************************************************************
039800*    CHECK FOR ANOTHER TRANSACTION ID ENTERED BY THE USER      *
039900****************************************************************
040000*
040100     MOVE 'PC05'                 TO MBCA-PROGRAM-LOCATION.
040200     PERFORM MB60PD-NEW-TRANS-ROUTINE
040300        THRU MB60PD-NTR-EXIT.
040400*
040500 2005-EDIT-SELECT.
040600*
040700****************************************************************
040800*    EDIT SELECT FIELD                                         *
040900****************************************************************
041000*
041100     PERFORM 8600-EDIT-SELECT
041200        THRU 8699-ES-EXIT.
041300*
041400 2090-CHECK-ERROR.
041500*
041600     IF  SS08WS-ERROR-SW-NO
041700         GO TO 2400-CHECK-SELECT.
041800*
041900 2300-SEND-MAP.
042000*
042100***********************************************
042200*    WRITE THE TEMP STORAGE RECORD            *
042300***********************************************
042400*
042500     MOVE 'TS09'                 TO MBCA-PROGRAM-LOCATION.
042600     PERFORM 8400-WRITE-QUEUE
042700        THRU 8499-WQ-EXIT.
042800*
042900****************************************************************
043000*    SEND THE MAP                                              *
043100****************************************************************
043200*
043300     PERFORM MB60PD-INIT-STD-MAP-LINES
043400        THRU MB60PD-ISML-EXIT.
043500*
043600     MOVE '*TOP*'                TO SS08WS-LINE-24-PF-KEY-FUNC(3).
043700     MOVE '*BOT*'                TO SS08WS-LINE-24-PF-KEY-FUNC(4).
043800     MOVE '*FWD*'                TO SS08WS-LINE-24-PF-KEY-FUNC(5).
043900     MOVE '*BWD*'                TO SS08WS-LINE-24-PF-KEY-FUNC(6).
044000     MOVE SS08WS-LINE-24         TO DE01-PF-KEYS.
044100     MOVE 'RESV'                 TO MBCA-PGMX-PF-TRANS-ID (3).
044200     MOVE 'RESV'                 TO MBCA-PGMX-PF-TRANS-ID (4).
044300     MOVE 'RESV'                 TO MBCA-PGMX-PF-TRANS-ID (5).
044400     MOVE 'RESV'                 TO MBCA-PGMX-PF-TRANS-ID (6).
044500*
044600     MOVE DFHBMASK               TO DE01-CURRENT-PAGE-A.
044700*
044800     MOVE 'BM03'                 TO MBCA-PROGRAM-LOCATION.
044900     PERFORM MB60PD-SEND-MAP-DATA-ONLY
045000        THRU MB60PD-SMDO-EXIT.
045100*
045200****************************************************************
045300*    RETURN TO CICS                                            *
045400****************************************************************
045500*
045600     MOVE 'PC06'                 TO MBCA-PROGRAM-LOCATION.
045700     PERFORM MB70PD-RETURN-TRANS-ID
045800        THRU MB70PD-RTI-EXIT.
045900/
046000 2400-CHECK-SELECT.
046100*
046200******************************************************************
046300*    IF DATA WAS ENTERED ON THE SCREEN WS-SELET-SW WILL BE SET TO*
046400*    YES IN PARAGRAPH 8600-EDIT-LOOP .                           *
046500******************************************************************
046600*
046700     IF  WS-SELECT-YES
046800         SET X-MBDETS-INDEX      TO X-DE01-MAP-SEL
046900         MOVE MBDETS-TABLE-NBR (X-MBDETS-INDEX)
047000                                 TO MBCA-TABLE
047100         MOVE MBIOWS-MMEF-DIRECT-KEY-CODE
047200                                 TO MBCA-KEY-CODE
047300         SET MBCA-INITIAL-SCREEN-NBR
047400                                 TO TRUE
047500         EVALUATE TRUE
047600           WHEN DE01-VALID-INQUIRY (X-DE01-MAP-SEL)
047700               MOVE '..QE'       TO SS08WS-WORK-TRANS-ID
047800           WHEN DE01-VALID-STATUS-MAINT (X-DE01-MAP-SEL)
047900               MOVE '..9E'       TO SS08WS-WORK-TRANS-ID
048000           WHEN OTHER
048100               MOVE '..ME'       TO SS08WS-WORK-TRANS-ID
048200         END-EVALUATE
048300         GO TO 2690-PF-KEY-BYPASS.
048400/
048500 2600-SETUP-COMMAREA.
048600*
048700****************************************************************
048800*    SET UP COMMAREA FIELDS AND TRANSFER TO THE NEXT PROGRAM   *
048900****************************************************************
049000*
049100     MOVE MBCA-EIBAID            TO SS08WS-EIBAID.
049200*
049300     IF  SS08WS-VALID-PF3
049400     OR  SS08WS-EIBAID-VALID-PF3
049500         MOVE 51                 TO MBCA-SCREEN-NBR
049600         MOVE MBCA-MBDE-FIRST-TABLE-NBR
049700                                 TO MBCA-MBDE-FWD-TABLE-NBR
049800         SET MBCA-MBDE-RETURN-NORMAL
049900                                 TO TRUE
050000         GO TO 2690-PF-KEY-BYPASS.
050100*
050200     IF  SS08WS-VALID-PF4
050300     OR  SS08WS-EIBAID-VALID-PF4
050400         MOVE 51                 TO MBCA-SCREEN-NBR
050500         IF (MBDETS-TABLE-NBR (1) IS GREATER THAN ZEROES
050600         AND MBDETS-TABLE-NBR (15) IS EQUAL TO ZEROES)
050700         OR (MBCA-MBDE-FWD-TABLE-NBR IS EQUAL TO ZEROES)
050800             SET MBCA-MBDE-RETURN-NORMAL
050900                                 TO TRUE
051000             MOVE ZEROES         TO MBCA-MBDE-FWD-TABLE-NBR
051100             MOVE 'TS10'         TO MBCA-PROGRAM-LOCATION
051200             PERFORM 8400-WRITE-QUEUE
051300                                 THRU 8499-WQ-EXIT
051400             GO TO 2690-PF-KEY-BYPASS
051500         ELSE
051600             SET MBCA-MBDE-RETURN-BOTTOM
051700                                 TO TRUE
051800             GO TO 2690-PF-KEY-BYPASS.
051900*
052000     IF  SS08WS-VALID-PF5
052100     OR  SS08WS-EIBAID-VALID-PF5
052200         MOVE 51                 TO MBCA-SCREEN-NBR
052300         IF (MBDETS-TABLE-NBR (1) IS GREATER THAN ZEROES
052400         AND MBDETS-TABLE-NBR (15) IS EQUAL TO ZEROES)
052500         OR (MBCA-MBDE-FWD-TABLE-NBR IS EQUAL TO ZEROES)
052600             SET MBCA-MBDE-RETURN-NORMAL
052700                                 TO TRUE
052800             MOVE ZEROES         TO MBCA-MBDE-FWD-TABLE-NBR
052900             MOVE 'TS11'         TO MBCA-PROGRAM-LOCATION
053000             PERFORM 8400-WRITE-QUEUE
053100                                 THRU 8499-WQ-EXIT
053200             GO TO 2690-PF-KEY-BYPASS
053300         ELSE
053400             SET MBCA-MBDE-RETURN-FWD
053500                                 TO TRUE
053600             ADD 1               TO MBCA-MBDE-FWD-TABLE-NBR
053700             GO TO 2690-PF-KEY-BYPASS.
053800*
053900     IF  SS08WS-VALID-PF6
054000     OR  SS08WS-EIBAID-VALID-PF6
054100         MOVE 51                 TO MBCA-SCREEN-NBR
054200         IF  MBCA-MBDE-BACK-TABLE-NBR IS EQUAL
054300                                 TO MBCA-MBDE-FIRST-TABLE-NBR
054400             SET MBCA-MBDE-RETURN-NORMAL
054500                                 TO TRUE
054600             MOVE 'TS12'         TO MBCA-PROGRAM-LOCATION
054700             PERFORM 8400-WRITE-QUEUE
054800                                 THRU 8499-WQ-EXIT
054900             GO TO 2690-PF-KEY-BYPASS
055000         ELSE
055100             MOVE MBCA-MBDE-BACK-TABLE-NBR
055200                                 TO MBCA-MBDE-FWD-TABLE-NBR
055300             SET MBCA-MBDE-RETURN-BWD
055400                                 TO TRUE
055500             GO TO 2690-PF-KEY-BYPASS.
055600*
055700     IF  SS08WS-VALID-PF-KEY
055800     OR  SS08WS-EIBAID-VALID-PF-KEY
055900     OR  MBDETS-TABLE-NBR (15) IS EQUAL TO ZEROES
056000     OR  MBCA-MBDE-FWD-TABLE-NBR IS EQUAL TO ZEROES
056100         SET MBCA-INITIAL-SCREEN-NBR
056200                                 TO TRUE
056300         MOVE MBIOWS-MMEF-KEY-CODE
056400                                 TO MBCA-KEY-CODE
056500         SET MBCA-MBDE-RETURN-NORMAL
056600                                 TO TRUE
056700         GO TO 2690-PF-KEY-BYPASS.
056800*
056900     MOVE 51                     TO MBCA-SCREEN-NBR.
057000     ADD 1                       TO MBCA-MBDE-FWD-TABLE-NBR.
057100     SET MBCA-MBDE-RETURN-NORMAL TO TRUE.
057200*
057300 2690-PF-KEY-BYPASS.
057400*
057500     MOVE 'PC07'                 TO MBCA-PROGRAM-LOCATION.
057600     PERFORM MB70PD-XCTL-TO-MBOXCTL
057700                                 THRU MB70PD-XTM-EXIT.
057800/
057900 8000-PERFORMED-ROUTINES-SECT SECTION.
058000*
058100 8100-TEMP-STORAGE-GETMAIN.
058200*
058300     EXEC CICS GETMAIN
058400               FLENGTH (LENGTH  OF MBDETS-RECORD)
058500               SET     (ADDRESS OF MBDETS-RECORD)
058600          END-EXEC.
058700*
058800 8199-TSG-EXIT.
058900     EXIT.
059000*
059100 8200-TEMP-STORAGE-READ.
059200*
059300     EXEC CICS READQ TS
059400               QUEUE   (TS-QUEUE-NAME)
059500               INTO    (MBDETS-RECORD)
059600               LENGTH  (LENGTH  OF MBDETS-RECORD)
059700               ITEM    (1)
059800          END-EXEC.
059900*
060000 8299-TSR-EXIT.
060100     EXIT.
060200*
060300 8300-TEMP-STORAGE-DELETE.
060400*
060500     EXEC CICS IGNORE CONDITION
060600               QIDERR
060700          END-EXEC.
060800*
060900     EXEC CICS DELETEQ TS
061000               QUEUE  (TS-QUEUE-NAME)
061100          END-EXEC.
061200*
061300 8399-TSD-EXIT.
061400     EXIT.
061500*
061600 8400-WRITE-QUEUE.
061700*
061800     EXEC CICS WRITEQ TS
061900               QUEUE   (TS-QUEUE-NAME)
062000               FROM    (MBDETS-RECORD)
062100               LENGTH  (LENGTH  OF MBDETS-RECORD)
062200          END-EXEC.
062300*
062400 8499-WQ-EXIT.
062500     EXIT.
062600*
062700 8600-EDIT-SELECT.
062800*
062900     SET X-DE01-MAP-SEL          TO +1.
063000*
063100 8600-EDIT-LOOP.
063200*
063300******************************************************************
063400*    THIS CODE LOOPS THRU THE SCREEN UNTIL FIRST SELECTION       *
063500*    IS ENCOUNTERED                                              *
063600******************************************************************
063700*
063800     IF  DE01-SELECT-L (X-DE01-MAP-SEL) IS GREATER THAN ZERO
063900         IF  DE01-VALID-SELECT (X-DE01-MAP-SEL)
064000             MOVE DFHBMASF       TO DE01-SELECT-A
064100                                    (X-DE01-MAP-SEL)
064200             MOVE DFHBMDAS       TO DE01-SELECT-LP-A
064300                                    (X-DE01-MAP-SEL)
064400                                    DE01-SELECT-RP-A
064500                                    (X-DE01-MAP-SEL)
064600             IF  DE01-VALID-INQUIRY-MAINT (X-DE01-MAP-SEL)
064700                 SET WS-SELECT-YES
064800                                 TO TRUE
064900                 GO TO 8699-ES-EXIT
065000             ELSE
065100                 NEXT SENTENCE
065200         ELSE
065300             SET SS08WS-ERROR-SW-YES TO TRUE
065400             MOVE SS08WS-CURSOR  TO DE01-SELECT-L
065500                                    (X-DE01-MAP-SEL)
065600             MOVE DFHBMUBF       TO DE01-SELECT-A
065700                                    (X-DE01-MAP-SEL)
065800             MOVE DFHBMASB       TO DE01-SELECT-LP-A
065900                                    (X-DE01-MAP-SEL)
066000                                    DE01-SELECT-RP-A
066100                                    (X-DE01-MAP-SEL)
066200             GO TO 8699-ES-EXIT.
066300*
066400     IF  X-DE01-MAP-SEL IS LESS THAN +15
066500         SET X-DE01-MAP-SEL      UP BY +1
066600         GO TO 8600-EDIT-LOOP.
066700*
066800 8699-ES-EXIT.
066900     EXIT.
067000*
067100 8800-BUILD-SCREEN.
067200*
067300     SET X-DE01-MAP-SEL          TO +1.
067400*
067500 8800-BUILD-LOOP.
067600*
067700     SET X-MBDETS-INDEX          TO X-DE01-MAP-SEL.
067800*
067900     IF  MBDETS-TABLE-NBR (X-MBDETS-INDEX)
068000                                 IS GREATER THAN ZEROES
068100         MOVE MBDETS-TABLE-NBR (X-MBDETS-INDEX)
068200                                 TO WS-TABLE-NBR
068300         MOVE MBDETS-EXP-NAME (X-MBDETS-INDEX)
068400                                 TO WS-EXP-TABLE-NAME
068500         MOVE MBDETS-STATUS-CODE (X-MBDETS-INDEX)
068600                                 TO WS-STATUS-CODE
068700         MOVE WS-TABLE-NBR       TO DE01-TABLE-NBR
068800                                    (X-DE01-MAP-SEL)
068900         MOVE WS-EXP-TABLE-NAME  TO DE01-NAME
069000                                    (X-DE01-MAP-SEL)
069100         MOVE WS-STATUS-CODE     TO DE01-STAT
069200                                    (X-DE01-MAP-SEL)
069300     ELSE
069400         MOVE DFHBMASK           TO DE01-SELECT-A
069500                                    (X-DE01-MAP-SEL)
069600         MOVE DFHBMDAS           TO DE01-TABLE-NBR-A
069700                                    (X-DE01-MAP-SEL)
069800                                    DE01-NAME-A
069900                                    (X-DE01-MAP-SEL)
070000                                    DE01-STAT-A
070100                                    (X-DE01-MAP-SEL)
070200                                    DE01-SELECT-LP-A
070300                                    (X-DE01-MAP-SEL)
070400                                    DE01-SELECT-RP-A
070500                                    (X-DE01-MAP-SEL).
070600*
070700     IF  X-DE01-MAP-SEL IS LESS THAN +15
070800         SET X-DE01-MAP-SEL      UP BY +1
070900         GO TO 8800-BUILD-LOOP
071000     ELSE
071100         MOVE MBCA-MBDE-FWD-TABLE-NBR
071200                                 TO WS-FWD-TABLE-NBR.
071300*
071400 8899-BS-EXIT.
071500     EXIT.
071600*
071700 8900-LAST-SCREEN.
071800*
071900****************************************************************
072000* THIS PARA WILL BUILD THE SCREEN FROM THE BOTTOM UP, MOVE     *
072100* 999999999 TO THE TABLE NUMBER TO GET THE LAST TABLE ON FILE  *
072200* WE THEN SET THE SCREEN INDEX TO 15 AND DO READ PREVIOUS      *
072300* MOVING DATA TO SCREEN AND SETTING INDEX DOWN BY 1 UNTIL INDEX*
072400* IS EQUAL TO 1 OR MMEF-ORG-NBR IS LESS THEN COMMAREA ORG NBR  *
072500* OR TABLE NBR IS LESS THAN FIRST TABLE NUMBER.                *
072600****************************************************************
072700*
072800*
072900****************************************************************
073000*    START BROWSE THE EXPENSE FACTORS FILE                     *
073100****************************************************************
073200*
073300     MOVE 'FC04'                 TO MBCA-PROGRAM-LOCATION.
073400     MOVE MBCA-MBDE-ORG          TO MBIOWS-MMEF-ORG.
073500     MOVE 999999999              TO MBIOWS-MMEF-TABLE.
073600     SET MBIORO-STARTBR-GTE      TO TRUE.
073700     PERFORM MMEFAO-ACCESS
073800        THRU MMEFAO-ACCESS-EXIT.
073900*
074000****************************************************************
074100*    READNEXT THE EXPENSE FACTORS FILE                         *
074200****************************************************************
074300*
074400     MOVE 'FC05'                 TO MBCA-PROGRAM-LOCATION.
074500     SET MBIORO-READ-SEQ         TO TRUE.
074600     PERFORM MMEFAO-ACCESS
074700        THRU MMEFAO-ACCESS-EXIT.
074800*
074900****************************************************************
075000*    READPREV THE EXPENSE FILE                                 *
075100****************************************************************
075200*
075300     MOVE 'FC06'                 TO MBCA-PROGRAM-LOCATION.
075400     SET MBIORO-READ-PREV        TO TRUE.
075500     PERFORM MMEFAO-ACCESS
075600        THRU MMEFAO-ACCESS-EXIT.
075700*
075800     SET X-DE01-MAP-SEL          TO +15.
075900     SET WS-BYPASS-NO            TO TRUE.
076000*
076100 8900-READ-EXP-FILE.
076200*
076300****************************************************************
076400*    READPREV THE EXPENSE FILE                                 *
076500****************************************************************
076600*
076700     MOVE 'FC07'                 TO MBCA-PROGRAM-LOCATION.
076800     SET MBIORO-READ-PREV        TO TRUE.
076900     PERFORM MMEFAO-ACCESS
077000        THRU MMEFAO-ACCESS-EXIT.
077100*
077200 8900-BUILD-LOOP.
077300*
077400     IF  MMEF-ORG IS LESS THAN MBCA-MBDE-ORG
077500     OR  MMEF-TABLE-NBR IS LESS THAN MBCA-MBDE-FIRST-TABLE-NBR
077600         GO TO 8900-END-BROWSE.
077700*
077800     IF  MMEF-TABLE-NBR IS EQUAL TO MBCA-MBDE-FIRST-TABLE-NBR
077900     AND X-DE01-MAP-SEL IS GREATER THAN +1
078000         SET MBCA-MBDE-RETURN-NORMAL
078100                                 TO TRUE
078200         MOVE MBCA-MBDE-FIRST-TABLE-NBR
078300                                 TO MBCA-MBDE-FWD-TABLE-NBR
078400         SET WS-BYPASS-YES       TO TRUE
078500         GO TO 8900-END-BROWSE.
078600*
078700     PERFORM 9500-BUILD-SCREEN-LINE
078800        THRU 9599-BSL-EXIT.
078900*
079000     IF  X-DE01-MAP-SEL IS GREATER THAN +1
079100         SET X-DE01-MAP-SEL      DOWN BY +1
079200         GO TO 8900-READ-EXP-FILE
079300     ELSE
079400         MOVE MMEF-TABLE-NBR     TO MBCA-MBDE-BACK-TABLE-NBR.
079500*
079600 8900-END-BROWSE.
079700*
079800****************************************************************
079900*    END BROWSE THE EXPENSE FACTORS FILE                       *
080000****************************************************************
080100*
080200     MOVE 'FC08'                 TO MBCA-PROGRAM-LOCATION.
080300     SET MBIORO-ENDBR            TO TRUE.
080400     PERFORM MMEFAO-ACCESS
080500        THRU MMEFAO-ACCESS-EXIT.
080600*
080700     IF  WS-BYPASS-YES
080800         GO TO 8999-LS-EXIT.
080900*
081000     MOVE ZEROES                 TO MBCA-MBDE-FWD-TABLE-NBR
081100                                    WS-FWD-TABLE-NBR.
081200*
081300 8999-LS-EXIT.
081400     EXIT.
081500*
081600 9000-BACK-SCREEN.
081700*
081800****************************************************************
081900*  THIS PARAGRAPH WILL BUILD THE SCREEN BASED ON THE FWD TABLE *
082000*  NBR IT WILL DO READ PREVIOUS FROM THIS NUMBER BACK.         *
082100****************************************************************
082200*
082300*
082400****************************************************************
082500*    START BROWSE THE EXPENSE FACTORS FILE                     *
082600****************************************************************
082700*
082800     MOVE 'FC09'                 TO MBCA-PROGRAM-LOCATION.
082900     MOVE MBCA-MBDE-ORG          TO MBIOWS-MMEF-ORG.
083000     MOVE MBCA-MBDE-FWD-TABLE-NBR
083100                                 TO MBIOWS-MMEF-TABLE.
083200     SET MBIORO-STARTBR-GTE      TO TRUE.
083300     PERFORM MMEFAO-ACCESS
083400        THRU MMEFAO-ACCESS-EXIT.
083500*
083600****************************************************************
083700*    READNEXT THE EXPENSE FACTORS FILE                         *
083800****************************************************************
083900*
084000     MOVE 'FC10'                 TO MBCA-PROGRAM-LOCATION.
084100     SET MBIORO-READ-SEQ         TO TRUE.
084200     PERFORM MMEFAO-ACCESS
084300        THRU MMEFAO-ACCESS-EXIT.
084400*
084500****************************************************************
084600*    READPREV THE EXPENSE FACTORS FILE                         *
084700****************************************************************
084800*
084900     MOVE 'FC11'                 TO MBCA-PROGRAM-LOCATION.
085000     SET MBIORO-READ-PREV        TO TRUE.
085100     PERFORM MMEFAO-ACCESS
085200        THRU MMEFAO-ACCESS-EXIT.
085300*
085400     SET X-DE01-MAP-SEL          TO +15.
085500     SET WS-BYPASS-NO            TO TRUE.
085600*
085700 9000-READ-EXP-FILE.
085800*
085900****************************************************************
086000*    READPREV THE EXPENSE FACTORS FILE                         *
086100****************************************************************
086200*
086300     MOVE 'FC12'                 TO MBCA-PROGRAM-LOCATION.
086400     SET MBIORO-READ-PREV        TO TRUE.
086500     PERFORM MMEFAO-ACCESS
086600        THRU MMEFAO-ACCESS-EXIT.
086700*
086800 9000-BUILD-LOOP.
086900*
087000     IF  X-DE01-MAP-SEL IS GREATER THAN +1
087100     AND MMEF-TABLE-NBR IS EQUAL TO MBCA-MBDE-FIRST-TABLE-NBR
087200         SET MBCA-MBDE-RETURN-NORMAL
087300                                 TO TRUE
087400         MOVE MBCA-MBDE-FIRST-TABLE-NBR
087500                                 TO MBCA-MBDE-FWD-TABLE-NBR
087600         SET WS-BYPASS-YES       TO TRUE
087700         GO TO 9000-END-BROWSE.
087800*
087900     IF  MMEF-TABLE-NBR IS EQUAL TO MBCA-MBDE-BACK-TABLE-NBR
088000     AND X-DE01-MAP-SEL IS EQUAL TO +15
088100         GO TO 9000-READ-EXP-FILE.
088200*
088300     PERFORM 9500-BUILD-SCREEN-LINE
088400        THRU 9599-BSL-EXIT.
088500*
088600     IF  X-DE01-MAP-SEL IS EQUAL TO +15
088700         MOVE MMEF-TABLE-NBR     TO MBCA-MBDE-FWD-TABLE-NBR
088800                                    WS-FWD-TABLE-NBR.
088900*
089000     IF  X-DE01-MAP-SEL IS GREATER THAN +1
089100         SET X-DE01-MAP-SEL      DOWN BY +1
089200         GO TO 9000-READ-EXP-FILE
089300     ELSE
089400         MOVE MMEF-TABLE-NBR     TO MBCA-MBDE-BACK-TABLE-NBR.
089500*
089600 9000-END-BROWSE.
089700*
089800****************************************************************
089900*    END BROWSE THE EXPENSE FACTORS FILE                       *
090000****************************************************************
090100*
090200     MOVE 'FC13'                 TO MBCA-PROGRAM-LOCATION.
090300     SET MBIORO-ENDBR            TO TRUE.
090400     PERFORM MMEFAO-ACCESS
090500        THRU MMEFAO-ACCESS-EXIT.
090600*
090700 9099-BS-EXIT.
090800     EXIT.
090900*
091000 9100-SET-ATTRIBUTE.
091100*
091200******************************************************************
091300*    THIS PARAGRAPH WILL LOOP THRU MAP CHECKING STATUS OF TEMP   *
091400*    STORAGE RECORD IF IT IS NOT ACTIVE IT WILL DARKEN PARENS AND*
091500*    MASK SELECT FIELD.                                          *
091600******************************************************************
091700*
091800     SET X-MBDETS-INDEX          TO X-DE01-MAP-SEL.
091900*
092000     IF  MBDETS-STATUS-INCOMPLETE   (X-MBDETS-INDEX)
092100         MOVE DFHBMASK           TO DE01-SELECT-A
092200                                    (X-DE01-MAP-SEL)
092300         MOVE DFHBMDAS           TO DE01-SELECT-LP-A
092400                                    (X-DE01-MAP-SEL)
092500                                    DE01-SELECT-RP-A
092600                                    (X-DE01-MAP-SEL).
092700*
092800 9199-SA-EXIT.
092900     EXIT.
093000*
093100 9400-READ-AHEAD.
093200*
093300****************************************************************
093400*    READNEXT THE EXPENSE FACTORS FILE                         *
093500****************************************************************
093600*
093700     MOVE 'FC14'                 TO MBCA-PROGRAM-LOCATION.
093800     SET MBIORO-READ-SEQ         TO TRUE.
093900     PERFORM MMEFAO-ACCESS
094000        THRU MMEFAO-ACCESS-EXIT.
094100*
094200     IF  MMEF-ORG IS GREATER THAN MBCA-MBDE-ORG
094300         MOVE ZEROES             TO WS-FWD-TABLE-NBR
094400                                    MBCA-MBDE-FWD-TABLE-NBR
094500         GO TO 9499-RA-EXIT.
094600*
094700     MOVE MMEF-TABLE-NBR         TO WS-FWD-TABLE-NBR.
094800*
094900 9499-RA-EXIT.
095000     EXIT.
095100*
095200 9500-BUILD-SCREEN-LINE.
095300*
095400     SET X-MBDETS-INDEX          TO X-DE01-MAP-SEL.
095500*
095600     MOVE MMEF-TABLE-NBR         TO WS-TABLE-NBR
095700                                    MBDETS-TABLE-NBR
095800                                    (X-MBDETS-INDEX).
095900*
096000     MOVE MMEF-REC-STATUS        TO WS-STATUS-CODE
096100                                    MBDETS-STATUS-CODE
096200                                    (X-MBDETS-INDEX).
096300*
096400     MOVE MMEF-TABLE-NAME        TO WS-EXP-TABLE-NAME
096500                                    MBDETS-EXP-NAME
096600                                    (X-MBDETS-INDEX).
096700*
096800     MOVE WS-TABLE-NBR           TO DE01-TABLE-NBR
096900                                    (X-DE01-MAP-SEL).
097000*
097100     MOVE WS-STATUS-CODE         TO DE01-STAT
097200                                    (X-DE01-MAP-SEL).
097300*
097400     MOVE WS-EXP-TABLE-NAME      TO DE01-NAME
097500                                    (X-DE01-MAP-SEL).
097600*
097700 9599-BSL-EXIT.
097800     EXIT.
097900*
098000/         JULIAN TO GREGORIAN DATE ROUTINE
098100     COPY SS08PD.
098200/
098300     COPY SS26PD.
098400/
098500     COPY SS27PD.
098600*
098700/         LINE 24 PF KEYS ROUTINE
098800     COPY SS15PD.
098900*
099000/         MERCHANT EXPENSE FACTORS ACCESS ROUTINES.
099100     COPY MMEFAO.
099200*
099300/         ON-LINE MAP ROUTINES
099400     COPY MB60PD REPLACING 'MBMAPXX' BY 'MBDE01 '
099500                           MBMAPXXI BY MBDE01I
099600                           MBMAPXXO BY MBDE01O.
099700*
099800/         ON-LINE PROCEDURES
099900     COPY MB70PD.
100000/
100100     COPY SMFTPXO.
