000100 IDENTIFICATION DIVISION.
000200 PROGRAM-ID. MBODI00.
000201*       RELEASE DATE=08/24/01.        REVISION LEVEL=08.06      *
000202*****************************************************************
000203*WARNING.  THIS COMPUTER PROGRAM IS PROTECTED BY COPYRIGHT LAW  *
000204*AND INTERNATIONAL TREATIES.  UNAUTHORIZED REPRODUCTION OR      *
000205*DISTRIBUTION OF THIS PROGRAM, OR ANY PORTION OF IT, MAY RESULT *
000206*IN SEVERE CIVIL AND CRIMINAL PENATLIES, AND WILL BE PROSECUTED *
000207*TO THE MAXIMUM EXTENT POSSIBLE UNDER THE LAW.                  *
000208*COPYRIGHT 1999 PAYSYS INTERNATIONAL, INC.  ALL RIGHTS RESERVED.*
000209*****************************************************************
000300*****************************************************************
000400*                                                               *
000500*   V - PLUS  M E R C H A N T   B A N K C A R D   S Y S T E M   *
000600*                                                               *
000700*      MBODI00 - ON-LINE INCOME FACTORS DIRECTORY               *
000800*                SCREEN 00                                      *
000900*                                                               *
001000*              1. TRANSIDS                                      *
001100*                 A. MBDI                                       *
001200*              2. MAPS USED -                                   *
001300*                 A. MBDI00 (SCREEN 00)                         *
001400*              3. FILES USED -                                  *
001500*                 A. MMOC   (ORG CONTROL FILE)                  *
001600*                 B. MMIF   (INCOME FACTORS MASTER FILE)        *
001700*                                                               *
001800*****************************************************************
001900*
002000 ENVIRONMENT DIVISION.
002100 DATA DIVISION.
002200 WORKING-STORAGE SECTION.
002300 01  FILLER                  PIC  X(12)      VALUE '** WS-BEG **'.
002400*         I/O REQUEST BLOCK WORK AREAS
002500     COPY MBIOWS.
002600/         I/O REQUEST BLOCK
002700     COPY MBIORO.
002800/         DATE WORK AREAS
002900     COPY SS01WS.
003000/         ONLINE WORK AREAS
003100     COPY SS08WS.
003200/
003300     COPY SS00WS.
003400/
003500     COPY SMFTWS.
003600/
003700     COPY SMPTRL REPLACING ==:SMPT:== BY ==SMPT==.
003800/
003900     COPY MB61LK.
004000/         STANDARD ERROR MESSAGES
004100     COPY MBEMWS.
004200*
004300 01  FILLER                  PIC  X(12)      VALUE '** WS-END **'.
004400/
004500 LINKAGE SECTION.
004600 01  DFHCOMMAREA.
004700     COPY MB60WS.
004800/         MERCHANT INCOME FACTORS DIRECTORY SCREEN 00 MAP DSECT
004900     COPY MBDI00.
005000/         MERCHANT INCOME FACTORS DIRECTORY SCREEN 00 REDEFINE
005100     COPY MBDI00R.
005200/         ORG CONTROL RECORD LAYOUT
005300     COPY MMOCRL.
005400/         MERCHANT INCOME FACTORS MASTER RECORD
005500     COPY MMIFRL REPLACING ==:MMIF:== BY ==MMIF==.
005600/
005700 PROCEDURE DIVISION.
005800 0000-HOUSEKEEPING SECTION.
005900 0100-INIT.
006000*
006100     MOVE 'PC01'                 TO MBCA-PROGRAM-LOCATION.
006200     PERFORM MB70PD-ON-LINE-HOUSEKEEPING
006300                                 THRU MB70PD-OLH-EXIT.
006400*
006500     IF  MBCA-RECEIVE-SCREEN
006600         GO TO 2000-RECEIVE-SCREEN.
006700*
006800 1000-SEND-SCREEN SECTION.
006900*
007000****************************************************************
007100*    GET CICS STORAGE NEEDED FOR THE MAP                       *
007200****************************************************************
007300*
007400     MOVE 'SC01'                 TO MBCA-PROGRAM-LOCATION.
007500     PERFORM MB60PD-GETMAIN-FOR-MAP
007600                                 THRU MB60PD-GFM-EXIT.
007700*
007800*****************************************************************
007900*    CHECK KEY CODES                                            *
008000* 1. IF INITIAL KEY CODE, BYPASS CHECK OF KEY CODES.            *
008100* 2. IF MMIF KEY CODE, IT MUST BE A VALID CODE.  IF DIRECT, GO  *
008200*    TO THE RECEIVE EDITING ROUTINE SINCE WE HAVE PLUGGED THE   *
008300*    ORG AND MERCHANT INTO THE MAP. IF AN ERROR OCCURS IN THE   *
008400*    RECEIVE SCREEN ROUTINE, IT WILL HANDLE BUILDING THE MAP    *
008500*    AND IT WILL SEND ITS OWN SCREEN.  THIS IS WHY LOCATE       *
008600*    PROGRAMS ALWAYS SEND WITH ERASE NO MATTER WHICH ROUTINE    *
008700*    YOU ARE IN.  IF NOT DIRECT, PLUG ORG AND TABLE NBR INTO THE*
008800*    MAP AND BYPASS ANY OTHER CHECKING OF THE KEY CODE.         *
008900* 3. IF 2 IS FALSE, SEE IF THE MBCA-MERCHANT-ORG                *
009000*    FIELD IS GREATER THAN ZERO.  IF SO, PLUG INTO MAP.         *
009100*    SEE IF THE MBCA-TABLE FIELD IS GREATER THAN ZERO. IF SO,   *
009200*    PLUG INTO MAP.                                             *
009300*    HANDLE IF THEY WERE NON-DIRECT.                            *
009400*****************************************************************
009500*
009600     IF  MBCA-INITIAL-KEY-CODE
009700         GO TO 1100-BUILD-SCREEN.
009800*
009900     IF  MBCA-MMIF-KEY-CODE
010000     AND MBCA-MERCHANT-ORG IS GREATER THAN ZERO
010100     AND MBCA-TABLE        IS GREATER THAN ZERO
010200         MOVE MBCA-MERCHANT-ORG  TO DI00-ORG
010300         MOVE MBCA-TABLE         TO DI00-TABLE-NBR
010400         MOVE DFHBMUNF           TO DI00-ORG-A
010500                                    DI00-TABLE-NBR-A
010600         IF  MBCA-DIRECT-TRANSFER-CODE
010700         AND MBCA-INITIAL-SCREEN-NBR
010800             MOVE 00             TO MBCA-SCREEN-NBR
010900             GO TO 2120-READ-ORG
011000         ELSE
011100             GO TO 1100-BUILD-SCREEN.
011200*
011300     IF  MBCA-VALID-KEY-CODES
011400     AND MBCA-MERCHANT-ORG IS GREATER THAN ZERO
011500     AND MBCA-TABLE        IS GREATER THAN ZERO
011600         MOVE MBCA-MERCHANT-ORG  TO DI00-ORG
011700         MOVE MBCA-TABLE         TO DI00-TABLE-NBR
011800         MOVE DFHBMUNF           TO DI00-ORG-A
011900                                    DI00-TABLE-NBR-A.
012000*
012100 1100-BUILD-SCREEN.
012200*
012300****************************************************************
012400*    INITIALIZE THE STANDARD MAP LINES                         *
012500****************************************************************
012600*
012700     MOVE SS08WS-CURSOR          TO DI00-ORG-L.
012800     MOVE 00                     TO MBCA-SCREEN-NBR.
012900     PERFORM MB60PD-INIT-STD-MAP-LINES
013000                                 THRU MB60PD-ISML-EXIT.
013100*
013200     IF  MBCA-MERCHANT-ORG IS NUMERIC
013300     AND MBCA-MERCHANT-ORG IS GREATER THAN ZEROES
013400         MOVE MBCA-MERCHANT-ORG  TO DI00-ORG
013500         MOVE DFHBMUNF           TO DI00-ORG-A.
013600*
013700     IF  MBCA-TABLE IS NUMERIC
013800     AND MBCA-TABLE IS GREATER THAN ZEROES
013900         MOVE MBCA-TABLE         TO DI00-TABLE-NBR
014000         MOVE DFHBMUNF           TO DI00-TABLE-NBR-A.
014100*
014200     MOVE DFHBMASK               TO DI00-CURRENT-PAGE-A.
014300*
014400****************************************************************
014500*    SEND THE MAP                                              *
014600****************************************************************
014700*
014800     MOVE 'BM01'                 TO MBCA-PROGRAM-LOCATION.
014900     PERFORM MB60PD-SEND-MAP-WITH-ERASE
015000                                 THRU MB60PD-SMWE-EXIT.
015100*
015200****************************************************************
015300*    RETURN TO CICS                                            *
015400****************************************************************
015500*
015600     MOVE 'PC02'                 TO MBCA-PROGRAM-LOCATION.
015700     PERFORM MB70PD-RETURN-TRANS-ID
015800                                 THRU MB70PD-RTI-EXIT.
015900/
016000 2000-RECEIVE-SCREEN SECTION.
016100*
016200****************************************************************
016300*    THIS SECTION RECEIVES THE 00 SCREEN                       *
016400****************************************************************
016500*
016600     MOVE 'BM02'                 TO MBCA-PROGRAM-LOCATION.
016700     PERFORM MB60PD-RECEIVE-MAP  THRU MB60PD-RM-EXIT.
016800*
016900****************************************************************
017000*    CHECK FOR ANOTHER TRANSACTION ID ENTERED BY THE USER      *
017100****************************************************************
017200*
017300     MOVE 'PC03'                 TO MBCA-PROGRAM-LOCATION.
017400     PERFORM MB60PD-NEW-TRANS-ROUTINE
017500                                 THRU MB60PD-NTR-EXIT.
017600*
017700 2100-EDIT-SCREEN.
017800*
017900     SET SS08WS-ERROR-SW-NO      TO TRUE.
018000     MOVE MBCA-EIBAID            TO SS08WS-EIBAID.
018100*
018200******************************************************************
018300*    IF NOTHING WAS ENTERED ON THE SCREEN AND A VALID PF KEY WAS *
018400*    DEPRESSED TRANSFER CONTROL TO THAT PROGRAM.                 *
018500******************************************************************
018600*
018700     IF  (DI00-ORG-L IS LESS THAN 1
018800     AND  DI00-TABLE-NBR-L IS LESS THAN 1)
018900     AND (SS08WS-VALID-PF-KEY
019000     OR   SS08WS-EIBAID-VALID-PF-KEY)
019100         SET MBCA-INITIAL-SCREEN-NBR
019200                                 TO TRUE
019300         GO TO 2690-TRANSFER-XCTL.
019400*
019500 2110-EDIT-ORG.
019600*
019700     MOVE DFHBMUNF               TO DI00-ORG-A.
019800     MOVE DFHBMASK               TO DI00-ORG-LP-A
019900                                    DI00-ORG-RP-A.
020000*
020100     IF  DI00-ORG-L IS EQUAL TO ZERO
020200     OR  DI00-ORG IS NOT NUMERIC
020300         MOVE MBEMWS-INVALID-ORG TO DI00-ERR-MESSAGE
020400         GO TO 2130-ORG-ERROR.
020500*
020600     IF  DI00-ORG IS LESS THAN MBCA-ORG-LOW
020700     OR  DI00-ORG IS GREATER THAN MBCA-ORG-HIGH
020800         MOVE MBEMWS-INVALID-ORG TO DI00-ERR-MESSAGE
020900         GO TO 2130-ORG-ERROR.
021000*
021100 2120-READ-ORG.
021200*
021300****************************************************************
021400*    READ THE ORGANIZATION FILE RECORD NUMBER 1                *
021500****************************************************************
021600*
021700     MOVE 'FC01'                 TO MBCA-PROGRAM-LOCATION.
021800     MOVE DI00-ORG               TO MBIOWS-MMOC-ORG.
021900     MOVE SS08WS-CICS-FC-NOTFND  TO MBIORO-TEMP-STATUS-1.
022000     SET MBIORO-READ-RANDOM      TO TRUE.
022100     PERFORM MMOCAO-ACCESS       THRU MMOCAO-ACCESS-EXIT.
022200*
022300     IF  SS08WS-RC-FC-VALID-RTN-CODE
022400         MOVE MMOC-ORG           TO MBCA-MERCHANT-ORG
022500                                    MBCA-MBDI-ORG
022600         IF  MMOC-ADD-PENDING
022700             MOVE MBEMWS-ADD-PENDING
022800                                 TO DI00-ERR-MESSAGE
022900         ELSE
023000             IF  MMOC-REC-INCOMPLETE
023100             OR  MMOC-REC-PURGED
023200                 MOVE MBEMWS-NOT-ACTIVE
023300                                 TO DI00-ERR-MESSAGE
023400             ELSE
023500                 MOVE MMOC-NA-LINE (1 1)
023600                                 TO MBCA-MBDI-INC-TABLE-NAME
023700                 GO TO 2140-EDIT-TABLE-NBR
023800     ELSE
023900         MOVE MBEMWS-NOT-ON-FILE TO DI00-ERR-MESSAGE.
024000*
024100 2130-ORG-ERROR.
024200*
024300     MOVE DFHBMNBF               TO DI00-ORG-A.
024400     MOVE DFHBMASB               TO DI00-ORG-LP-A
024500                                    DI00-ORG-RP-A.
024600     MOVE SS08WS-CURSOR          TO DI00-ORG-L.
024700     SET SS08WS-ERROR-SW-YES     TO TRUE.
024800*
024900 2140-EDIT-TABLE-NBR.
025000*
025100     MOVE DFHBMUNF               TO DI00-TABLE-NBR-A.
025200     MOVE DFHBMASK               TO DI00-TABLE-NBR-LP-A
025300                                    DI00-TABLE-NBR-RP-A.
025400*
025500     IF  DI00-TABLE-NBR-L IS EQUAL TO ZERO
025600         MOVE ZEROES             TO DI00-TABLE-NBR
025700     ELSE
025800         IF  DI00-TABLE-NBR IS NOT NUMERIC
025900             MOVE MBEMWS-INVALID-TABLE
026000                                 TO DI00-ERR-MESSAGE
026100             GO TO 2150-TABLE-NBR-ERROR.
026200*
026300     IF  SS08WS-ERROR-SW-YES
026400         GO TO 2290-CHECK-ERROR.
026500*
026600****************************************************************
026700*    START BROWSE THE INCOME FILE                              *
026800****************************************************************
026900*
027000     MOVE 'FC02'                 TO MBCA-PROGRAM-LOCATION.
027100     MOVE MBCA-MBDI-ORG          TO MBIOWS-MMIF-ORG.
027200     MOVE DI00-TABLE-NBR         TO MBIOWS-MMIF-TABLE.
027300     SET MBIORO-STARTBR-GTE      TO TRUE.
027400     PERFORM MMIFAO-ACCESS       THRU MMIFAO-ACCESS-EXIT.
027500*
027600****************************************************************
027700*    READNEXT THE INCOME FILE                                  *
027800****************************************************************
027900*
028000     MOVE 'FC03'                 TO MBCA-PROGRAM-LOCATION.
028100     SET MBIORO-READ-SEQ         TO TRUE.
028200     PERFORM MMIFAO-ACCESS       THRU MMIFAO-ACCESS-EXIT.
028300*
028400****************************************************************
028500*    END BROWSE THE MERCHANT FILE                              *
028600****************************************************************
028700*
028800     MOVE 'FC04'                 TO MBCA-PROGRAM-LOCATION.
028900     SET MBIORO-ENDBR            TO TRUE.
029000     PERFORM MMIFAO-ACCESS       THRU MMIFAO-ACCESS-EXIT.
029100*
029200     IF  MMIF-ORG IS GREATER THAN MBCA-MBDI-ORG
029300         MOVE 'NO RECORDS ON FILE FOR THE SELECTION CRITERIA'
029400                                 TO DI00-ERR-MESSAGE
029500         MOVE DFHBMNBF           TO DI00-ORG-A
029600         MOVE DFHBMASB           TO DI00-ORG-LP-A
029700                                    DI00-ORG-RP-A
029800         MOVE SS08WS-CURSOR      TO DI00-ORG-L
029900     ELSE
030000         MOVE MMIF-TABLE-NBR     TO MBCA-MBDI-FIRST-TABLE-NBR
030100                                    MBCA-MBDI-FWD-TABLE-NBR
030200                                    MBCA-TABLE
030300         MOVE SPACES             TO MBCA-MBDI-RETURN-FLAG
030400         MOVE ZEROES             TO MBCA-MBDI-BACK-TABLE-NBR
030500         GO TO 2290-CHECK-ERROR.
030600*
030700 2150-TABLE-NBR-ERROR.
030800*
030900     MOVE DFHBMNBF               TO DI00-TABLE-NBR-A.
031000     MOVE DFHBMASB               TO DI00-TABLE-NBR-LP-A
031100                                    DI00-TABLE-NBR-RP-A.
031200     MOVE SS08WS-CURSOR          TO DI00-TABLE-NBR-L
031300     SET SS08WS-ERROR-SW-YES     TO TRUE.
031400*
031500 2290-CHECK-ERROR.
031600*
031700     IF  SS08WS-ERROR-SW-NO
031800         GO TO 2600-SETUP-COMMAREA
031900     ELSE
032000         IF  SS08WS-VALID-PF-KEY
032100         OR  SS08WS-EIBAID-VALID-PF-KEY
032200             SET MBCA-INITIAL-SCREEN-NBR
032300                                 TO TRUE
032400             GO TO 2690-TRANSFER-XCTL.
032500*
032600 2300-SEND-MAP.
032700*
032800****************************************************************
032900*    SEND THE MAP                                              *
033000****************************************************************
033100*
033200     PERFORM MB60PD-INIT-STD-MAP-LINES
033300                                 THRU MB60PD-ISML-EXIT.
033400*
033500     MOVE DFHBMASK               TO DI00-CURRENT-PAGE-A.
033600*
033700     MOVE 'BM03'                 TO MBCA-PROGRAM-LOCATION.
033800     PERFORM MB60PD-SEND-MAP-DATA-ONLY
033900                                 THRU MB60PD-SMDO-EXIT.
034000*
034100****************************************************************
034200*    RETURN TO CICS                                            *
034300****************************************************************
034400*
034500     MOVE 'PC04'                 TO MBCA-PROGRAM-LOCATION.
034600     PERFORM MB70PD-RETURN-TRANS-ID
034700                                 THRU MB70PD-RTI-EXIT.
034800/
034900 2600-SETUP-COMMAREA.
035000*
035100****************************************************************
035200*    SET UP COMMAREA FIELDS AND TRANSFER TO THE NEXT PROGRAM   *
035300****************************************************************
035400*
035500     MOVE MBCA-EIBAID            TO SS08WS-EIBAID.
035600*
035700     MOVE MBIOWS-MMIF-KEY-CODE   TO MBCA-KEY-CODE.
035800*
035900     PERFORM MB60PD-EDIT-PAGE-NBR
036000                                 THRU MB60PD-EPN-EXIT.
036100*
036200     IF  SS08WS-VALID-PF-KEY
036300     OR  SS08WS-EIBAID-VALID-PF-KEY
036400         SET MBCA-INITIAL-SCREEN-NBR
036500                                 TO TRUE.
036600*
036700 2690-TRANSFER-XCTL.
036800*
036900     MOVE 'PC05'                 TO MBCA-PROGRAM-LOCATION.
037000     PERFORM MB70PD-XCTL-TO-MBOXCTL
037100                                 THRU MB70PD-XTM-EXIT.
037200/
037300 9000-PERFORMED-ROUTINES-SECT SECTION.
037400*
037500*         JULIAN TO GREGORIAN DATE ROUTINE
037600     COPY SS08PD.
037700/
037800     COPY SS26PD.
037900/
038000     COPY SS27PD.
038100*
038200/         LINE 24 PF KEYS ROUTINE
038300     COPY SS15PD.
038400*
038500/         ORG RECORD ACCESS ROUTINES
038600     COPY MMOCAO.
038700*
038800/         MERCHANT INCOME FACTORS ACCESS ROUTINES
038900     COPY MMIFAO.
039000*
039100/         ON-LINE MAP ROUTINES
039200     COPY MB60PD REPLACING 'MBMAPXX' BY 'MBDI00 '
039300                           MBMAPXXI BY MBDI00I
039400                           MBMAPXXO BY MBDI00O.
039500*
039600/         ON-LINE PROCEDURES
039700     COPY MB70PD.
039800/
039900     COPY SMFTPXO.
