000100 IDENTIFICATION DIVISION.
000200 PROGRAM-ID. MBODM01.
000201*       RELEASE DATE=08/24/01.        REVISION LEVEL=08.06      *
000202*****************************************************************
000203*WARNING.  THIS COMPUTER PROGRAM IS PROTECTED BY COPYRIGHT LAW  *
000204*AND INTERNATIONAL TREATIES.  UNAUTHORIZED REPRODUCTION OR      *
000205*DISTRIBUTION OF THIS PROGRAM, OR ANY PORTION OF IT, MAY RESULT *
000206*IN SEVERE CIVIL AND CRIMINAL PENATLIES, AND WILL BE PROSECUTED *
000207*TO THE MAXIMUM EXTENT POSSIBLE UNDER THE LAW.                  *
000208*COPYRIGHT 1999 PAYSYS INTERNATIONAL, INC.  ALL RIGHTS RESERVED.*
000209*****************************************************************
000300*****************************************************************
000400*                                                               *
000500*   V - PLUS  M E R C H A N T   B A N K C A R D   S Y S T E M   *
000600*                                                               *
000700*      MBODM01 - ON-LINE MERCHANT DIRECTORY                     *
000800*                SCREEN 01                                      *
000900*                                                               *
001000*              1. TRANSIDS                                      *
001100*                 A. MBDM                                       *
001200*              2. MAPS USED -                                   *
001300*                 A. MBDM01 (SCREEN 01)                         *
001400*              3. FILES USED -                                  *
001500*                 A. MMMM   (MERCHANT MASTER FILE)              *
001600*                                                               *
001700*****************************************************************
001800*
001900 ENVIRONMENT DIVISION.
002000 DATA DIVISION.
002100 WORKING-STORAGE SECTION.
002200 01  FILLER                  PIC  X(12)      VALUE '** WS-BEG **'.
002300*         I/O REQUEST BLOCK WORK AREAS
002400     COPY MBIOWS.
002500/         I/O REQUEST BLOCK
002600     COPY MBIORO.
002700/         DATE WORK AREAS
002800     COPY SS01WS.
002900/         ONLINE WORK AREAS
003000     COPY SS08WS.
003100/
003200     COPY SS00WS.
003300/
003400     COPY SMFTWS.
003500/
003600     COPY SMPTRL REPLACING ==:SMPT:== BY ==SMPT==.
003700/
003800     COPY MB61LK.
003900/
004000 01  WS-MISCELLANEOUS.
004100     03  WS-SAVE-EIBAID      PIC  X(01)      VALUE SPACES.
004200     03  WS-FWD-MERCHANT     PIC  9(09)      VALUE ZEROES.
004300     03  WS-SELECT-SW        PIC  X(01)      VALUE 'N'.
004400         88  WS-SELECT-NO                    VALUE 'N'.
004500         88  WS-SELECT-YES                   VALUE 'Y'.
004600     03  WS-BYPASS-SW        PIC  X(01)      VALUE 'N'.
004700         88  WS-BYPASS-NO                    VALUE 'N'.
004800         88  WS-BYPASS-YES                   VALUE 'Y'.
004900     03  TS-QUEUE-NAME.
005000         05  TS-QN-TERMID    PIC  X(04)      VALUE SPACES.
005100         05  TS-QN-TRANID    PIC  X(04)      VALUE 'MBDM'.
005200*
005300 01  WS-DETAIL-LINE.
005400     03  WS-MERCHANT-NBR     PIC  9(09).
005500     03  FILLER              PIC  X(02)      VALUE SPACES.
005600     03  WS-MERCHANT-NAME    PIC  X(30).
005700     03  FILLER              PIC  X(02)      VALUE SPACES.
005800     03  WS-PHONE-NUMBER     PIC  X(17).
005900     03  FILLER              PIC  X(02)      VALUE SPACES.
006000     03  WS-STATUS-CODE      PIC  9(01).
006100     03  FILLER              PIC  X(03)      VALUE SPACES.
006200     03  WS-BLOCK-CODE       PIC  X(01).
006300*
006400 01  FILLER                  PIC  X(12)      VALUE '** WS-END **'.
006500/
006600 LINKAGE SECTION.
006700 01  DFHCOMMAREA.
006800     COPY MB60WS.
006900/         MERCHANT DIRECTORY SCREEN 01 MAP DSECT
007000     COPY MBDM01.
007100/         MERCHANT DIRECTORY SCREEN 01 MAP REDEFINITION
007200     COPY MBDM01R.
007300/         MERCHANT MASTER RECORD LAYOUT
007400     COPY MMMMRL.
007500/         MERCHANT DIRECTORY TEMPORARY STORAGE
007600     COPY MBDMTS.
007700/
007800 PROCEDURE DIVISION.
007900 0000-HOUSEKEEPING SECTION.
008000 0100-INIT.
008100*
008200     MOVE MBCA-EIBAID            TO WS-SAVE-EIBAID.
008300     SET MBCA-EIBAID-ENTER       TO TRUE.
008400*
008500     MOVE 'PC01'                 TO MBCA-PROGRAM-LOCATION.
008600     PERFORM MB70PD-ON-LINE-HOUSEKEEPING
008700                                 THRU MB70PD-OLH-EXIT.
008800*
008900     MOVE WS-SAVE-EIBAID         TO MBCA-EIBAID.
009000     MOVE MBCA-TERMINAL-ID       TO TS-QN-TERMID.
009100*
009200     IF  MBCA-RECEIVE-SCREEN
009300         GO TO 2000-RECEIVE-SCREEN.
009400*
009500 1000-SEND-SCREEN SECTION.
009600*
009700****************************************************************
009800*    GET CICS STORAGE NEEDED FOR THE MAP                       *
009900****************************************************************
010000*
010100     MOVE 'SC01'                 TO MBCA-PROGRAM-LOCATION.
010200     PERFORM MB60PD-GETMAIN-FOR-MAP
010300                                 THRU MB60PD-GFM-EXIT.
010400*
010500     MOVE MBCA-MBDM-ORG          TO DM01-ORG.
010600     MOVE MBCA-MBDM-ORG-NAME     TO DM01-ORG-NAME.
010700     MOVE MBCA-MBDM-FIRST-MERCHANT
010800                                 TO DM01-MERCHANT.
010900     MOVE 01                     TO MBCA-SCREEN-NBR.
011000*
011100****************************************************************
011200*    INITIALIZE THE STANDARD MAP LINES                         *
011300****************************************************************
011400*
011500     PERFORM MB60PD-INIT-STD-MAP-LINES
011600                                 THRU MB60PD-ISML-EXIT.
011700*
011800****************************************************************
011900*    ACQUIRE MAIN STORAGE FOR TEMP STORAGE RECORD              *
012000****************************************************************
012100*
012200     MOVE 'TS01'                 TO MBCA-PROGRAM-LOCATION.
012300     PERFORM 8100-TEMP-STORAGE-GETMAIN
012400                                 THRU 8199-TSG-EXIT.
012500*
012600     EXEC CICS HANDLE CONDITION
012700               QIDERR (1010-CHECK-RETURN-FLAG)
012800          END-EXEC.
012900*
013000***********************************************
013100*    READ THE TEMP STORAGE RECORD             *
013200***********************************************
013300*
013400     MOVE 'TS02'                 TO MBCA-PROGRAM-LOCATION.
013500     PERFORM 8200-TEMP-STORAGE-READ
013600                                 THRU 8299-TSR-EXIT.
013700*
013800***********************************************
013900*    DELETE THE TEMP STORAGE RECORD           *
014000***********************************************
014100*
014200     MOVE 'TS03'                 TO MBCA-PROGRAM-LOCATION.
014300     PERFORM 8300-TEMP-STORAGE-DELETE
014400                                 THRU 8399-TSD-EXIT.
014500*
014600     PERFORM 8800-BUILD-SCREEN   THRU 8899-BS-EXIT.
014700     GO TO 1080-CONTINUE.
014800*
014900 1010-CHECK-RETURN-FLAG.
015000*
015100     IF  MBCA-MBDM-RETURN-BOTTOM
015200         PERFORM 8900-LAST-SCREEN
015300                                 THRU 8999-LS-EXIT
015400         IF  WS-BYPASS-YES
015500             GO TO 1015-READ-MERCHANT
015600         ELSE
015700             GO TO 1080-CONTINUE
015800     ELSE
015900         IF  MBCA-MBDM-RETURN-BWD
016000             PERFORM 9000-BACK-SCREEN
016100                                 THRU 9099-BS-EXIT
016200             IF  WS-BYPASS-YES
016300                 GO TO 1015-READ-MERCHANT
016400             ELSE
016500                 GO TO 1080-CONTINUE.
016600*
016700 1015-READ-MERCHANT.
016800*
016900****************************************************************
017000*    START BROWSE THE MERCHANT FILE                            *
017100****************************************************************
017200*
017300     MOVE 'FC01'                 TO MBCA-PROGRAM-LOCATION.
017400     MOVE MBCA-MBDM-ORG          TO MBIOWS-MMMM-ORG.
017500     MOVE MBCA-MBDM-FWD-MERCHANT TO MBIOWS-MMMM-MERCHANT.
017600     SET MBIORO-STARTBR-GTE      TO TRUE.
017700     PERFORM MMMMAO-ACCESS       THRU MMMMAO-ACCESS-EXIT.
017800*
017900     SET X-MERCHANT-INDEX        TO +1.
018000*
018100 1020-READ-LOOP.
018200*
018300****************************************************************
018400*    READNEXT THE MERCHANT FILE                                *
018500****************************************************************
018600*
018700     MOVE 'FC02'                 TO MBCA-PROGRAM-LOCATION.
018800     SET MBIORO-READ-SEQ         TO TRUE.
018900     PERFORM MMMMAO-ACCESS       THRU MMMMAO-ACCESS-EXIT.
019000*
019100     IF  MMMM-ORG IS GREATER THAN MBCA-MBDM-ORG
019200         GO TO 1020-END-BROWSE.
019300*
019400     PERFORM 9500-BUILD-SCREEN-LINE
019500                                 THRU 9599-BSL-EXIT.
019600*
019700     IF  X-MERCHANT-INDEX IS EQUAL TO +1
019800         MOVE MMMM-MERCHANT      TO MBCA-MBDM-BACK-MERCHANT.
019900*
020000     IF  X-MERCHANT-INDEX IS LESS THAN +15
020100         SET X-MERCHANT-INDEX    UP BY +1
020200         GO TO 1020-READ-LOOP
020300     ELSE
020400         MOVE MMMM-MERCHANT      TO MBCA-MBDM-FWD-MERCHANT
020500         PERFORM 9400-READ-AHEAD THRU 9499-RA-EXIT
020600         SET X-MERCHANT-INDEX    UP BY +1.
020700*
020800 1020-END-BROWSE.
020900*
021000****************************************************************
021100*    END BROWSE THE MERCHANT FILE                              *
021200****************************************************************
021300*
021400     MOVE 'FC03'                 TO MBCA-PROGRAM-LOCATION.
021500     SET MBIORO-ENDBR            TO TRUE.
021600     PERFORM MMMMAO-ACCESS      THRU MMMMAO-ACCESS-EXIT.
021700*
021800 1060-SET-ATTRIBUTE.
021900*
022000     IF  X-MERCHANT-INDEX IS EQUAL TO +1
022100         IF  MBCA-MBDM-RETURN-NORMAL
022200             SET MBCA-INITIAL-SCREEN-NBR
022300                                 TO TRUE
022400             MOVE 'PC02'         TO MBCA-PROGRAM-LOCATION
022500             PERFORM MB70PD-XCTL-TO-MBOXCTL
022600                                 THRU MB70PD-XTM-EXIT
022700         ELSE
022800             MOVE MBCA-MBDM-BACK-MERCHANT
022900                                 TO MBCA-MBDM-FWD-MERCHANT
023000             GO TO 1015-READ-MERCHANT.
023100*
023200     IF  X-MERCHANT-INDEX IS LESS THAN +16
023300         SET X-MBDMTS-INDEX      TO X-MERCHANT-INDEX
023400         MOVE ZEROES             TO MBCA-MBDM-FWD-MERCHANT
023500                                    WS-FWD-MERCHANT
023600                                    MBDMTS-MERCHANT
023700                                    (X-MBDMTS-INDEX)
023800                                    MBDMTS-STATUS-CODE
023900                                    (X-MBDMTS-INDEX)
024000         MOVE SPACES             TO MBDMTS-MERCHANT-NAME
024100                                    (X-MBDMTS-INDEX)
024200                                    MBDMTS-PHONE-NUMBER
024300                                    (X-MBDMTS-INDEX)
024400                                    MBDMTS-BLOCK-CODE
024500                                    (X-MBDMTS-INDEX)
024600         MOVE DFHBMASK           TO DM01-SELECT-A
024700                                    (X-MERCHANT-INDEX)
024800         MOVE DFHBMDAS           TO DM01-DIRECTORY-LINE-A
024900                                    (X-MERCHANT-INDEX)
025000                                    DM01-SELECT-LP-A
025100                                    (X-MERCHANT-INDEX)
025200                                    DM01-SELECT-RP-A
025300                                    (X-MERCHANT-INDEX)
025400         SET X-MERCHANT-INDEX    UP BY +1
025500         GO TO 1060-SET-ATTRIBUTE.
025600*
025700 1080-CONTINUE.
025800*
025900     IF  MBCA-MBDM-BACK-MERCHANT IS NOT EQUAL
026000                                 TO MBCA-MBDM-FIRST-MERCHANT
026100         MOVE DFHBMASB           TO DM01-FWD-BACK-IND-A (1).
026200*
026300     IF  WS-FWD-MERCHANT IS NOT EQUAL TO ZEROES
026400         MOVE DFHBMASB           TO DM01-FWD-BACK-IND-A (15).
026500*
026600****************************************************************
026700*    WRITE THE TEMP STORAGE RECORD                             *
026800****************************************************************
026900*
027000     MOVE 'TS04'                 TO MBCA-PROGRAM-LOCATION.
027100     PERFORM 8400-WRITE-QUEUE    THRU 8499-WQ-EXIT.
027200*
027300     PERFORM 9100-SET-ATTRIBUTE  THRU 9199-SA-EXIT
027400         VARYING X-MERCHANT-INDEX FROM +1 BY +1
027500         UNTIL   X-MERCHANT-INDEX IS GREATER THAN +15.
027600*
027700     SET X-MERCHANT-INDEX        TO +1.
027800*
027900 1090-CURSOR-LOOP.
028000*
028100     IF  X-MERCHANT-INDEX IS GREATER THAN +15
028200         MOVE SS08WS-CURSOR      TO DM01-ALT-TRANID-L
028300         GO TO 1100-CONTINUE.
028400*
028500     IF  DM01-SELECT-A (X-MERCHANT-INDEX)
028600                                 IS EQUAL TO DFHBMASK
028700         SET X-MERCHANT-INDEX    UP BY +1
028800         GO TO 1090-CURSOR-LOOP
028900     ELSE
029000         MOVE SS08WS-CURSOR      TO DM01-SELECT-L
029100                                    (X-MERCHANT-INDEX).
029200*
029300 1100-CONTINUE.
029400*
029500     MOVE '*TOP*'                TO SS08WS-LINE-24-PF-KEY-FUNC(3).
029600     MOVE '*BOT*'                TO SS08WS-LINE-24-PF-KEY-FUNC(4).
029700     MOVE '*FWD*'                TO SS08WS-LINE-24-PF-KEY-FUNC(5).
029800     MOVE '*BWD*'                TO SS08WS-LINE-24-PF-KEY-FUNC(6).
029900     MOVE SS08WS-LINE-24         TO DM01-PF-KEYS.
030000     MOVE 'RESV'                 TO MBCA-PGMX-PF-TRANS-ID (3).
030100     MOVE 'RESV'                 TO MBCA-PGMX-PF-TRANS-ID (4).
030200     MOVE 'RESV'                 TO MBCA-PGMX-PF-TRANS-ID (5).
030300     MOVE 'RESV'                 TO MBCA-PGMX-PF-TRANS-ID (6).
030400*
030500     MOVE DFHBMASK               TO DM01-CURRENT-PAGE-A.
030600*
030700****************************************************************
030800*    SEND THE MAP                                              *
030900****************************************************************
031000*
031100     MOVE 'BM01'                 TO MBCA-PROGRAM-LOCATION.
031200     PERFORM MB60PD-SEND-MAP-WITH-ERASE
031300                                 THRU MB60PD-SMWE-EXIT.
031400*
031500****************************************************************
031600*    RETURN TO CICS                                            *
031700****************************************************************
031800*
031900     MOVE 'PC03'                 TO MBCA-PROGRAM-LOCATION.
032000     PERFORM MB70PD-RETURN-TRANS-ID
032100                                 THRU MB70PD-RTI-EXIT.
032200/
032300 2000-RECEIVE-SCREEN SECTION.
032400*
032500     IF  MBCA-EIBAID-CLEAR
032600         MOVE 'TS05'             TO MBCA-PROGRAM-LOCATION
032700         PERFORM 8300-TEMP-STORAGE-DELETE
032800                                 THRU 8399-TSD-EXIT
032900         MOVE 'PC04'             TO MBCA-PROGRAM-LOCATION
033000         PERFORM MB70PD-ON-LINE-HOUSEKEEPING
033100                                 THRU MB70PD-OLH-EXIT.
033200*
033300****************************************************************
033400*    THIS SECTION RECEIVES THE 01 SCREEN                       *
033500****************************************************************
033600*
033700     MOVE 'BM02'                 TO MBCA-PROGRAM-LOCATION.
033800     PERFORM MB60PD-RECEIVE-MAP  THRU MB60PD-RM-EXIT.
033900*
034000*****************************************************
034100*    ACQUIRE MAIN STORAGE FOR TEMP STORAGE RECORD   *
034200*****************************************************
034300*
034400     MOVE 'TS06'                 TO MBCA-PROGRAM-LOCATION.
034500     PERFORM 8100-TEMP-STORAGE-GETMAIN
034600                                 THRU 8199-TSG-EXIT.
034700*
034800***********************************************
034900*    READ THE TEMP STORAGE RECORD             *
035000***********************************************
035100*
035200     MOVE 'TS07'                 TO MBCA-PROGRAM-LOCATION.
035300     PERFORM 8200-TEMP-STORAGE-READ
035400                                 THRU 8299-TSR-EXIT.
035500*
035600***********************************************
035700*    DELETE THE TEMP STORAGE RECORD           *
035800***********************************************
035900*
036000     MOVE 'TS08'                 TO MBCA-PROGRAM-LOCATION.
036100     PERFORM 8300-TEMP-STORAGE-DELETE
036200                                 THRU 8399-TSD-EXIT.
036300*
036400****************************************************************
036500*    CHECK FOR ANOTHER TRANSACTION ID ENTERED BY THE USER      *
036600****************************************************************
036700*
036800     MOVE 'PC05'                 TO MBCA-PROGRAM-LOCATION.
036900     PERFORM MB60PD-NEW-TRANS-ROUTINE
037000                                 THRU MB60PD-NTR-EXIT.
037100*
037200 2005-EDIT-SELECT.
037300*
037400****************************************************************
037500*    EDIT SELECT FIELD                                         *
037600****************************************************************
037700*
037800     PERFORM 8600-EDIT-SELECT    THRU 8699-ES-EXIT.
037900*
038000 2090-CHECK-ERROR.
038100*
038200     IF  SS08WS-ERROR-SW-NO
038300         GO TO 2400-CHECK-SELECT.
038400*
038500 2300-SEND-MAP.
038600*
038700***********************************************
038800*    WRITE THE TEMP STORAGE RECORD            *
038900***********************************************
039000*
039100     MOVE 'TS09'                 TO MBCA-PROGRAM-LOCATION.
039200     PERFORM 8400-WRITE-QUEUE    THRU 8499-WQ-EXIT.
039300*
039400****************************************************************
039500*    SEND THE MAP                                              *
039600****************************************************************
039700*
039800     PERFORM MB60PD-INIT-STD-MAP-LINES
039900                                 THRU MB60PD-ISML-EXIT.
040000*
040100     MOVE '*TOP*'                TO SS08WS-LINE-24-PF-KEY-FUNC(3).
040200     MOVE '*BOT*'                TO SS08WS-LINE-24-PF-KEY-FUNC(4).
040300     MOVE '*FWD*'                TO SS08WS-LINE-24-PF-KEY-FUNC(5).
040400     MOVE '*BWD*'                TO SS08WS-LINE-24-PF-KEY-FUNC(6).
040500     MOVE SS08WS-LINE-24         TO DM01-PF-KEYS.
040600     MOVE 'RESV'                 TO MBCA-PGMX-PF-TRANS-ID (3).
040700     MOVE 'RESV'                 TO MBCA-PGMX-PF-TRANS-ID (4).
040800     MOVE 'RESV'                 TO MBCA-PGMX-PF-TRANS-ID (5).
040900     MOVE 'RESV'                 TO MBCA-PGMX-PF-TRANS-ID (6).
041000*
041100     MOVE DFHBMASK               TO DM01-CURRENT-PAGE-A.
041200*
041300     MOVE 'BM03'                 TO MBCA-PROGRAM-LOCATION.
041400     PERFORM MB60PD-SEND-MAP-DATA-ONLY
041500                                 THRU MB60PD-SMDO-EXIT.
041600*
041700****************************************************************
041800*    RETURN TO CICS                                            *
041900****************************************************************
042000*
042100     MOVE 'PC06'                 TO MBCA-PROGRAM-LOCATION.
042200     PERFORM MB70PD-RETURN-TRANS-ID
042300                                 THRU MB70PD-RTI-EXIT.
042400/
042500 2400-CHECK-SELECT.
042600*
042700     IF  WS-SELECT-YES
042800         SET X-MBDMTS-INDEX      TO X-MERCHANT-INDEX
042900         MOVE MBDMTS-MERCHANT (X-MBDMTS-INDEX)
043000                                 TO MBCA-MERCHANT
043100         MOVE MBIOWS-MMMM-DIRECT-KEY-CODE
043200                                 TO MBCA-KEY-CODE
043300         SET MBCA-INITIAL-SCREEN-NBR
043400                                 TO TRUE
043500         EVALUATE TRUE
043600           WHEN DM01-VALID-INQUIRY (X-MERCHANT-INDEX)
043700               MOVE '..QM'       TO SS08WS-WORK-TRANS-ID
043800           WHEN DM01-VALID-STATUS-MAINT (X-MERCHANT-INDEX)
043900               MOVE '...M'       TO SS08WS-WORK-TRANS-ID
044000               MOVE DM01-SELECT (X-MERCHANT-INDEX)
044100                                 TO SS08WS-WORK-TRANS-ID (3:1)
044200           WHEN OTHER
044300               MOVE '..MM'       TO SS08WS-WORK-TRANS-ID
044400         END-EVALUATE
044500         GO TO 2690-PF-KEY-BYPASS.
044600/
044700 2600-SETUP-COMMAREA.
044800*
044900****************************************************************
045000*    SET UP COMMAREA FIELDS AND TRANSFER TO THE NEXT PROGRAM   *
045100****************************************************************
045200*
045300     MOVE MBCA-EIBAID            TO SS08WS-EIBAID.
045400*
045500     IF  SS08WS-VALID-PF3
045600     OR  SS08WS-EIBAID-VALID-PF3
045700         MOVE 51                 TO MBCA-SCREEN-NBR
045800         MOVE MBCA-MBDM-FIRST-MERCHANT
045900                                 TO MBCA-MBDM-FWD-MERCHANT
046000         SET MBCA-MBDM-RETURN-NORMAL
046100                                 TO TRUE
046200         GO TO 2690-PF-KEY-BYPASS.
046300*
046400     IF  SS08WS-VALID-PF4
046500     OR  SS08WS-EIBAID-VALID-PF4
046600         MOVE 51                 TO MBCA-SCREEN-NBR
046700         IF (MBDMTS-MERCHANT (1) IS GREATER THAN ZEROES
046800         AND MBDMTS-MERCHANT (15) IS EQUAL TO ZEROES)
046900         OR (MBCA-MBDM-FWD-MERCHANT IS EQUAL TO ZEROES)
047000             SET MBCA-MBDM-RETURN-NORMAL
047100                                 TO TRUE
047200             MOVE ZEROES         TO MBCA-MBDM-FWD-MERCHANT
047300             MOVE 'TS10'         TO MBCA-PROGRAM-LOCATION
047400             PERFORM 8400-WRITE-QUEUE
047500                                 THRU 8499-WQ-EXIT
047600             GO TO 2690-PF-KEY-BYPASS
047700         ELSE
047800             SET MBCA-MBDM-RETURN-BOTTOM
047900                                 TO TRUE
048000             GO TO 2690-PF-KEY-BYPASS.
048100*
048200     IF  SS08WS-VALID-PF5
048300     OR  SS08WS-EIBAID-VALID-PF5
048400         MOVE 51                 TO MBCA-SCREEN-NBR
048500         IF (MBDMTS-MERCHANT (1) IS GREATER THAN ZEROES
048600         AND MBDMTS-MERCHANT (15) IS EQUAL TO ZEROES)
048700         OR (MBCA-MBDM-FWD-MERCHANT IS EQUAL TO ZEROES)
048800             SET MBCA-MBDM-RETURN-NORMAL
048900                                 TO TRUE
049000             MOVE ZEROES         TO MBCA-MBDM-FWD-MERCHANT
049100             MOVE 'TS11'         TO MBCA-PROGRAM-LOCATION
049200             PERFORM 8400-WRITE-QUEUE
049300                                 THRU 8499-WQ-EXIT
049400             GO TO 2690-PF-KEY-BYPASS
049500         ELSE
049600             SET MBCA-MBDM-RETURN-FWD
049700                                 TO TRUE
049800             ADD 1               TO MBCA-MBDM-FWD-MERCHANT
049900             GO TO 2690-PF-KEY-BYPASS.
050000*
050100     IF  SS08WS-VALID-PF6
050200     OR  SS08WS-EIBAID-VALID-PF6
050300         MOVE 51                 TO MBCA-SCREEN-NBR
050400         IF  MBCA-MBDM-BACK-MERCHANT IS EQUAL
050500                                 TO MBCA-MBDM-FIRST-MERCHANT
050600             SET MBCA-MBDM-RETURN-NORMAL
050700                                 TO TRUE
050800             MOVE 'TS12'         TO MBCA-PROGRAM-LOCATION
050900             PERFORM 8400-WRITE-QUEUE
051000                                 THRU 8499-WQ-EXIT
051100             GO TO 2690-PF-KEY-BYPASS
051200         ELSE
051300             MOVE MBCA-MBDM-BACK-MERCHANT
051400                                 TO MBCA-MBDM-FWD-MERCHANT
051500             SET MBCA-MBDM-RETURN-BWD
051600                                 TO TRUE
051700             GO TO 2690-PF-KEY-BYPASS.
051800*
051900     IF  SS08WS-VALID-PF-KEY
052000     OR  SS08WS-EIBAID-VALID-PF-KEY
052100     OR  MBDMTS-MERCHANT (15) IS EQUAL TO ZEROES
052200     OR  MBCA-MBDM-FWD-MERCHANT IS EQUAL TO ZEROES
052300         SET MBCA-INITIAL-SCREEN-NBR
052400                                 TO TRUE
052500         MOVE MBIOWS-MMMM-KEY-CODE
052600                                 TO MBCA-KEY-CODE
052700         SET MBCA-MBDM-RETURN-NORMAL
052800                                 TO TRUE
052900         GO TO 2690-PF-KEY-BYPASS.
053000*
053100     MOVE 51                     TO MBCA-SCREEN-NBR.
053200     ADD 1                       TO MBCA-MBDM-FWD-MERCHANT.
053300     SET MBCA-MBDM-RETURN-NORMAL TO TRUE.
053400*
053500 2690-PF-KEY-BYPASS.
053600*
053700     MOVE 'PC07'                 TO MBCA-PROGRAM-LOCATION.
053800     PERFORM MB70PD-XCTL-TO-MBOXCTL
053900                                 THRU MB70PD-XTM-EXIT.
054000/
054100 8000-PERFORMED-ROUTINES-SECT SECTION.
054200*
054300 8100-TEMP-STORAGE-GETMAIN.
054400*
054500     EXEC CICS GETMAIN
054600               FLENGTH (LENGTH  OF MBDMTS-RECORD)
054700               SET     (ADDRESS OF MBDMTS-RECORD)
054800          END-EXEC.
054900*
055000 8199-TSG-EXIT.
055100     EXIT.
055200*
055300 8200-TEMP-STORAGE-READ.
055400*
055500     EXEC CICS READQ TS
055600               QUEUE   (TS-QUEUE-NAME)
055700               INTO    (MBDMTS-RECORD)
055800               LENGTH  (LENGTH  OF MBDMTS-RECORD)
055900               ITEM    (1)
056000          END-EXEC.
056100*
056200 8299-TSR-EXIT.
056300     EXIT.
056400*
056500 8300-TEMP-STORAGE-DELETE.
056600*
056700     EXEC CICS IGNORE CONDITION
056800               QIDERR
056900          END-EXEC.
057000*
057100     EXEC CICS DELETEQ TS
057200               QUEUE  (TS-QUEUE-NAME)
057300          END-EXEC.
057400*
057500 8399-TSD-EXIT.
057600     EXIT.
057700*
057800 8400-WRITE-QUEUE.
057900*
058000     EXEC CICS WRITEQ TS
058100               QUEUE   (TS-QUEUE-NAME)
058200               FROM    (MBDMTS-RECORD)
058300               LENGTH  (LENGTH  OF MBDMTS-RECORD)
058400          END-EXEC.
058500*
058600 8499-WQ-EXIT.
058700     EXIT.
058800*
058900 8600-EDIT-SELECT.
059000*
059100     SET X-MERCHANT-INDEX        TO +1.
059200*
059300 8600-EDIT-LOOP.
059400*
059500     IF  DM01-SELECT-L (X-MERCHANT-INDEX) IS GREATER THAN ZERO
059600         IF  DM01-VALID-SELECT (X-MERCHANT-INDEX)
059700             MOVE DFHBMASF       TO DM01-SELECT-A
059800                                    (X-MERCHANT-INDEX)
059900             MOVE DFHBMDAS       TO DM01-SELECT-LP-A
060000                                    (X-MERCHANT-INDEX)
060100                                    DM01-SELECT-RP-A
060200                                    (X-MERCHANT-INDEX)
060300             IF  DM01-VALID-INQUIRY-MAINT (X-MERCHANT-INDEX)
060400                 SET WS-SELECT-YES
060500                                 TO TRUE
060600                 GO TO 8699-ES-EXIT
060700             ELSE
060800                 NEXT SENTENCE
060900         ELSE
061000             SET SS08WS-ERROR-SW-YES TO TRUE
061100             MOVE SS08WS-CURSOR  TO DM01-SELECT-L
061200                                    (X-MERCHANT-INDEX)
061300             MOVE DFHBMUBF       TO DM01-SELECT-A
061400                                    (X-MERCHANT-INDEX)
061500             MOVE DFHBMASB       TO DM01-SELECT-LP-A
061600                                    (X-MERCHANT-INDEX)
061700                                    DM01-SELECT-RP-A
061800                                    (X-MERCHANT-INDEX)
061900             GO TO 8699-ES-EXIT.
062000*
062100     IF  X-MERCHANT-INDEX IS LESS THAN +15
062200         SET X-MERCHANT-INDEX    UP BY +1
062300         GO TO 8600-EDIT-LOOP.
062400*
062500 8699-ES-EXIT.
062600     EXIT.
062700*
062800 8800-BUILD-SCREEN.
062900*
063000     SET X-MERCHANT-INDEX        TO +1.
063100*
063200 8800-BUILD-LOOP.
063300*
063400     SET X-MBDMTS-INDEX          TO X-MERCHANT-INDEX.
063500*
063600     IF  MBDMTS-MERCHANT (X-MBDMTS-INDEX)
063700                                 IS GREATER THAN ZEROES
063800         MOVE MBDMTS-MERCHANT (X-MBDMTS-INDEX)
063900                                 TO WS-MERCHANT-NBR
064000         MOVE MBDMTS-MERCHANT-NAME (X-MBDMTS-INDEX)
064100                                 TO WS-MERCHANT-NAME
064200         MOVE MBDMTS-PHONE-NUMBER (X-MBDMTS-INDEX)
064300                                 TO WS-PHONE-NUMBER
064400         MOVE MBDMTS-STATUS-CODE (X-MBDMTS-INDEX)
064500                                 TO WS-STATUS-CODE
064600         MOVE MBDMTS-BLOCK-CODE   (X-MBDMTS-INDEX)
064700                                 TO WS-BLOCK-CODE
064800         MOVE WS-DETAIL-LINE     TO DM01-DIRECTORY-LINE
064900                                    (X-MERCHANT-INDEX)
065000     ELSE
065100         MOVE DFHBMASK           TO DM01-SELECT-A
065200                                    (X-MERCHANT-INDEX)
065300         MOVE DFHBMDAS           TO DM01-DIRECTORY-LINE-A
065400                                    (X-MERCHANT-INDEX)
065500                                    DM01-SELECT-LP-A
065600                                    (X-MERCHANT-INDEX)
065700                                    DM01-SELECT-RP-A
065800                                    (X-MERCHANT-INDEX).
065900*
066000     IF  X-MERCHANT-INDEX IS LESS THAN +15
066100         SET X-MERCHANT-INDEX    UP BY +1
066200         GO TO 8800-BUILD-LOOP
066300     ELSE
066400         MOVE MBCA-MBDM-FWD-MERCHANT
066500                                 TO WS-FWD-MERCHANT.
066600*
066700 8899-BS-EXIT.
066800     EXIT.
066900*
067000 8900-LAST-SCREEN.
067100*
067200****************************************************************
067300*    START BROWSE THE MERCHANT FILE                            *
067400****************************************************************
067500*
067600     MOVE 'FC04'                 TO MBCA-PROGRAM-LOCATION.
067700     MOVE MBCA-MBDM-ORG          TO MBIOWS-MMMM-ORG.
067800     MOVE 999999999              TO MBIOWS-MMMM-MERCHANT.
067900     SET MBIORO-STARTBR-GTE      TO TRUE.
068000     PERFORM MMMMAO-ACCESS       THRU MMMMAO-ACCESS-EXIT.
068100*
068200****************************************************************
068300*    READNEXT THE MERCHANT FILE                                *
068400****************************************************************
068500*
068600     MOVE 'FC05'                 TO MBCA-PROGRAM-LOCATION.
068700     SET MBIORO-READ-SEQ         TO TRUE.
068800     PERFORM MMMMAO-ACCESS       THRU MMMMAO-ACCESS-EXIT.
068900*
069000****************************************************************
069100*    READPREV THE MERCHANT FILE                                *
069200****************************************************************
069300*
069400     MOVE 'FC06'                 TO MBCA-PROGRAM-LOCATION.
069500     SET MBIORO-READ-PREV        TO TRUE.
069600     PERFORM MMMMAO-ACCESS       THRU MMMMAO-ACCESS-EXIT.
069700*
069800     SET X-MERCHANT-INDEX        TO +15.
069900     SET WS-BYPASS-NO            TO TRUE.
070000*
070100 8900-READ-MERCHANT-FILE.
070200*
070300****************************************************************
070400*    READPREV THE MERCHANT FILE                                *
070500****************************************************************
070600*
070700     MOVE 'FC07'                 TO MBCA-PROGRAM-LOCATION.
070800     SET MBIORO-READ-PREV        TO TRUE.
070900     PERFORM MMMMAO-ACCESS       THRU MMMMAO-ACCESS-EXIT.
071000*
071100 8900-BUILD-LOOP.
071200*
071300     IF  MMMM-ORG IS LESS THAN MBCA-MBDM-ORG
071400     OR  MMMM-MERCHANT IS LESS THAN MBCA-MBDM-FIRST-MERCHANT
071500         GO TO 8900-END-BROWSE.
071600*
071700     IF  MMMM-MERCHANT IS EQUAL TO MBCA-MBDM-FIRST-MERCHANT
071800     AND X-MERCHANT-INDEX IS GREATER THAN +1
071900         SET MBCA-MBDM-RETURN-NORMAL
072000                                 TO TRUE
072100         MOVE MBCA-MBDM-FIRST-MERCHANT
072200                                 TO MBCA-MBDM-FWD-MERCHANT
072300         SET WS-BYPASS-YES       TO TRUE
072400         GO TO 8900-END-BROWSE.
072500*
072600     PERFORM 9500-BUILD-SCREEN-LINE
072700                                 THRU 9599-BSL-EXIT.
072800*
072900     IF  X-MERCHANT-INDEX IS GREATER THAN +1
073000         SET X-MERCHANT-INDEX    DOWN BY +1
073100         GO TO 8900-READ-MERCHANT-FILE
073200     ELSE
073300         MOVE MMMM-MERCHANT      TO MBCA-MBDM-BACK-MERCHANT.
073400*
073500 8900-END-BROWSE.
073600*
073700****************************************************************
073800*    END BROWSE THE MERCHANT FILE                              *
073900****************************************************************
074000*
074100     MOVE 'FC08'                 TO MBCA-PROGRAM-LOCATION.
074200     SET MBIORO-ENDBR            TO TRUE.
074300     PERFORM MMMMAO-ACCESS       THRU MMMMAO-ACCESS-EXIT.
074400*
074500     IF  WS-BYPASS-YES
074600         GO TO 8999-LS-EXIT.
074700*
074800     MOVE ZEROES                 TO MBCA-MBDM-FWD-MERCHANT
074900                                    WS-FWD-MERCHANT.
075000*
075100 8999-LS-EXIT.
075200     EXIT.
075300*
075400 9000-BACK-SCREEN.
075500*
075600****************************************************************
075700*    START BROWSE THE MERCHANT FILE                            *
075800****************************************************************
075900*
076000     MOVE 'FC09'                 TO MBCA-PROGRAM-LOCATION.
076100     MOVE MBCA-MBDM-ORG          TO MBIOWS-MMMM-ORG.
076200     MOVE MBCA-MBDM-FWD-MERCHANT TO MBIOWS-MMMM-MERCHANT.
076300     SET MBIORO-STARTBR-GTE      TO TRUE.
076400     PERFORM MMMMAO-ACCESS       THRU MMMMAO-ACCESS-EXIT.
076500*
076600****************************************************************
076700*    READNEXT THE MERCHANT FILE                                *
076800****************************************************************
076900*
077000     MOVE 'FC10'                 TO MBCA-PROGRAM-LOCATION.
077100     SET MBIORO-READ-SEQ         TO TRUE.
077200     PERFORM MMMMAO-ACCESS       THRU MMMMAO-ACCESS-EXIT.
077300*
077400****************************************************************
077500*    READPREV THE MERCHANT FILE                                *
077600****************************************************************
077700*
077800     MOVE 'FC11'                 TO MBCA-PROGRAM-LOCATION.
077900     SET MBIORO-READ-PREV        TO TRUE.
078000     PERFORM MMMMAO-ACCESS       THRU MMMMAO-ACCESS-EXIT.
078100*
078200     SET X-MERCHANT-INDEX        TO +15.
078300     SET WS-BYPASS-NO            TO TRUE.
078400*
078500 9000-READ-MERCHANT-FILE.
078600*
078700****************************************************************
078800*    READPREV THE MERCHANT FILE                                *
078900****************************************************************
079000*
079100     MOVE 'FC12'                 TO MBCA-PROGRAM-LOCATION.
079200     SET MBIORO-READ-PREV        TO TRUE.
079300     PERFORM MMMMAO-ACCESS       THRU MMMMAO-ACCESS-EXIT.
079400*
079500 9000-BUILD-LOOP.
079600*
079700     IF  X-MERCHANT-INDEX IS GREATER THAN +1
079800     AND MMMM-MERCHANT IS EQUAL TO MBCA-MBDM-FIRST-MERCHANT
079900         SET MBCA-MBDM-RETURN-NORMAL
080000                                 TO TRUE
080100         MOVE MBCA-MBDM-FIRST-MERCHANT
080200                                 TO MBCA-MBDM-FWD-MERCHANT
080300         SET WS-BYPASS-YES       TO TRUE
080400         GO TO 9000-END-BROWSE.
080500*
080600     IF  MMMM-MERCHANT IS EQUAL TO MBCA-MBDM-BACK-MERCHANT
080700     AND X-MERCHANT-INDEX IS EQUAL TO +15
080800         GO TO 9000-READ-MERCHANT-FILE.
080900*
081000     PERFORM 9500-BUILD-SCREEN-LINE
081100                                 THRU 9599-BSL-EXIT.
081200*
081300     IF  X-MERCHANT-INDEX IS EQUAL TO +15
081400         MOVE MMMM-MERCHANT      TO MBCA-MBDM-FWD-MERCHANT
081500                                    WS-FWD-MERCHANT.
081600*
081700     IF  X-MERCHANT-INDEX IS GREATER THAN +1
081800         SET X-MERCHANT-INDEX    DOWN BY +1
081900         GO TO 9000-READ-MERCHANT-FILE
082000     ELSE
082100         MOVE MMMM-MERCHANT      TO MBCA-MBDM-BACK-MERCHANT.
082200*
082300 9000-END-BROWSE.
082400*
082500****************************************************************
082600*    END BROWSE THE MERCHANT FILE                              *
082700****************************************************************
082800*
082900     MOVE 'FC13'                 TO MBCA-PROGRAM-LOCATION.
083000     SET MBIORO-ENDBR            TO TRUE.
083100     PERFORM MMMMAO-ACCESS       THRU MMMMAO-ACCESS-EXIT.
083200*
083300 9099-BS-EXIT.
083400     EXIT.
083500*
083600 9100-SET-ATTRIBUTE.
083700*
083800     SET X-MBDMTS-INDEX          TO X-MERCHANT-INDEX.
083900*
084000     IF  MBDMTS-STATUS-INCOMPLETE   (X-MBDMTS-INDEX)
084100     OR  MBDMTS-STATUS-PURGED (X-MBDMTS-INDEX)
084200         MOVE DFHBMASK           TO DM01-SELECT-A
084300                                    (X-MERCHANT-INDEX)
084400         MOVE DFHBMDAS           TO DM01-SELECT-LP-A
084500                                    (X-MERCHANT-INDEX)
084600                                    DM01-SELECT-RP-A
084700                                    (X-MERCHANT-INDEX).
084800*
084900 9199-SA-EXIT.
085000     EXIT.
085100*
085200 9400-READ-AHEAD.
085300*
085400****************************************************************
085500*    READNEXT THE MERCHANT FILE                                *
085600****************************************************************
085700*
085800     MOVE 'FC14'                 TO MBCA-PROGRAM-LOCATION.
085900     SET MBIORO-READ-SEQ         TO TRUE.
086000     PERFORM MMMMAO-ACCESS       THRU MMMMAO-ACCESS-EXIT.
086100*
086200     IF  MMMM-ORG IS GREATER THAN MBCA-MBDM-ORG
086300         MOVE ZEROES             TO WS-FWD-MERCHANT
086400                                    MBCA-MBDM-FWD-MERCHANT
086500         GO TO 9499-RA-EXIT.
086600*
086700     MOVE MMMM-MERCHANT          TO WS-FWD-MERCHANT.
086800*
086900 9499-RA-EXIT.
087000     EXIT.
087100*
087200 9500-BUILD-SCREEN-LINE.
087300*
087400     SET X-MBDMTS-INDEX          TO X-MERCHANT-INDEX.
087500*
087600     MOVE MMMM-MERCHANT          TO WS-MERCHANT-NBR
087700                                    MBDMTS-MERCHANT
087800                                    (X-MBDMTS-INDEX).
087900*
088000     MOVE MMMM-NA-LINE (1 1)     TO WS-MERCHANT-NAME
088100                                    MBDMTS-MERCHANT-NAME
088200                                    (X-MBDMTS-INDEX).
088300*
088400     MOVE MMMM-PHONE (1)         TO WS-PHONE-NUMBER
088500                                    MBDMTS-PHONE-NUMBER
088600                                    (X-MBDMTS-INDEX).
088700*
088800     MOVE MMMM-REC-STATUS        TO WS-STATUS-CODE
088900                                    MBDMTS-STATUS-CODE
089000                                    (X-MBDMTS-INDEX).
089100*
089200     MOVE MMMM-BLOCK-CODE        TO WS-BLOCK-CODE
089300                                    MBDMTS-BLOCK-CODE
089400                                    (X-MBDMTS-INDEX).
089500*
089600     MOVE WS-DETAIL-LINE         TO DM01-DIRECTORY-LINE
089700                                    (X-MERCHANT-INDEX).
089800*
089900 9599-BSL-EXIT.
090000     EXIT.
090100/         JULIAN TO GREGORIAN DATE ROUTINE
090200     COPY SS08PD.
090300/
090400     COPY SS26PD.
090500/
090600     COPY SS27PD.
090700/         LINE 24 PF KEYS ROUTINE
090800     COPY SS15PD.
090900/         MERCHANT RECORD ACCESS ROUTINES
091000     COPY MMMMAO.
091100/         ON-LINE MAP ROUTINES
091200     COPY MB60PD REPLACING 'MBMAPXX' BY 'MBDM01 '
091300                           MBMAPXXI BY MBDM01I
091400                           MBMAPXXO BY MBDM01O.
091500/         ON-LINE PROCEDURES
091600     COPY MB70PD.
091700/
091800     COPY SMFTPXO.
