000100 IDENTIFICATION DIVISION.
000200 PROGRAM-ID. MBODO01.
000201*       RELEASE DATE=08/24/01.        REVISION LEVEL=08.06      *
000202*****************************************************************
000203*WARNING.  THIS COMPUTER PROGRAM IS PROTECTED BY COPYRIGHT LAW  *
000204*AND INTERNATIONAL TREATIES.  UNAUTHORIZED REPRODUCTION OR      *
000205*DISTRIBUTION OF THIS PROGRAM, OR ANY PORTION OF IT, MAY RESULT *
000206*IN SEVERE CIVIL AND CRIMINAL PENATLIES, AND WILL BE PROSECUTED *
000207*TO THE MAXIMUM EXTENT POSSIBLE UNDER THE LAW.                  *
000208*COPYRIGHT 1999 PAYSYS INTERNATIONAL, INC.  ALL RIGHTS RESERVED.*
000209*****************************************************************
000300*****************************************************************
000400*                                                               *
000500*   V - PLUS  M E R C H A N T   B A N K C A R D   S Y S T E M   *
000600*                                                               *
000700*      MBODO01 - ON-LINE ORGANIZATION DIRECTORY                 *
000800*                SCREEN 01                                      *
000900*                                                               *
001000*              1. TRANSIDS                                      *
001100*                 A. MBDO                                       *
001200*              2. MAPS USED -                                   *
001300*                 A. MBDO01 (SCREEN 01)                         *
001400*              3. FILES USED -                                  *
001500*                 A. MMOC   (ORG CONTROL FILE)                  *
001600*                                                               *
001700*****************************************************************
001800*
001900 ENVIRONMENT DIVISION.
002000 DATA DIVISION.
002100 WORKING-STORAGE SECTION.
002200 01  FILLER                  PIC  X(12)      VALUE '** WS-BEG **'.
002300*         I/O REQUEST BLOCK WORK AREAS
002400     COPY MBIOWS.
002500/         I/O REQUEST BLOCK
002600     COPY MBIORO.
002700/         DATE WORK AREAS
002800     COPY SS01WS.
002900/         ONLINE WORK AREAS
003000     COPY SS08WS.
003100/
003200     COPY SS00WS.
003300/
003400     COPY SMFTWS.
003500/
003600     COPY SMPTRL REPLACING ==:SMPT:== BY ==SMPT==.
003700/
003800     COPY MB61LK.
003900/
004000 01  WS-MISCELLANEOUS.
004100     03  WS-ORG-NINES        PIC  9(03)      VALUE 999.
004200     03  WS-ORG-ZEROES       PIC  9(03)      VALUE 000.
004300     03  WS-SAVE-EIBAID      PIC  X(01)      VALUE SPACES.
004400     03  WS-FWD-ORG          PIC  9(03)      VALUE 001.
004500     03  WS-SELECT-SW        PIC  X(01)      VALUE 'N'.
004600         88  WS-SELECT-NO                    VALUE 'N'.
004700         88  WS-SELECT-YES                   VALUE 'Y'.
004800     03  WS-BYPASS-SW        PIC  X(01)      VALUE 'N'.
004900         88  WS-BYPASS-NO                    VALUE 'N'.
005000         88  WS-BYPASS-YES                   VALUE 'Y'.
005100     03  TS-QUEUE-NAME.
005200         05  TS-QN-TERMID    PIC  X(04)      VALUE SPACES.
005300         05  TS-QN-TRANID    PIC  X(04)      VALUE 'MBDO'.
005400*
005500 01  WS-DETAIL-LINE.
005600     03  WS-ORG-NBR          PIC  9(03).
005700     03  FILLER              PIC  X(04)      VALUE SPACES.
005800     03  WS-ORG-NAME         PIC  X(30).
005900     03  FILLER              PIC  X(07)      VALUE SPACES.
006000     03  WS-STATUS-CODE      PIC  9(01).
006100*
006200 01  FILLER                  PIC  X(12)      VALUE '** WS-END **'.
006300/
006400 LINKAGE SECTION.
006500 01  DFHCOMMAREA.
006600     COPY MB60WS.
006700/         ORGANIZATION DIRECTORY SCREEN 01 MAP DSECT
006800     COPY MBDO01.
006900/         ORGANIZATION DIRECTORY SCREEN 01 MAP REDEFINITION
007000     COPY MBDO01R.
007100/         ORG CONTROL RECORD LAYOUT
007200     COPY MMOCRL.
007300/         ORGANIZATION DIRECTORY TEMPORARY STORAGE
007400     COPY MBDOTS.
007500/
007600 PROCEDURE DIVISION.
007700 0000-HOUSEKEEPING SECTION.
007800 0100-INIT.
007900*
008000     IF  MBCA-INITIAL-SCREEN-NBR
008100     AND MBCA-EIBAID-CLEAR
008200         MOVE 'PC01'             TO MBCA-PROGRAM-LOCATION
008300         PERFORM MB70PD-ON-LINE-HOUSEKEEPING
008400                                 THRU MB70PD-OLH-EXIT.
008500*
008600     MOVE MBCA-EIBAID            TO WS-SAVE-EIBAID.
008700     SET MBCA-EIBAID-ENTER       TO TRUE.
008800*
008900     MOVE 'PC02'                 TO MBCA-PROGRAM-LOCATION.
009000     PERFORM MB70PD-ON-LINE-HOUSEKEEPING
009100                                 THRU MB70PD-OLH-EXIT.
009200*
009300     MOVE WS-SAVE-EIBAID         TO MBCA-EIBAID.
009400     MOVE MBCA-TERMINAL-ID       TO TS-QN-TERMID.
009500*
009600     IF  MBCA-RECEIVE-SCREEN
009700         GO TO 2000-RECEIVE-SCREEN.
009800*
009900 1000-SEND-SCREEN SECTION.
010000*
010100****************************************************************
010200*    GET CICS STORAGE NEEDED FOR THE MAP                       *
010300****************************************************************
010400*
010500     MOVE 'SC01'                 TO MBCA-PROGRAM-LOCATION.
010600     PERFORM MB60PD-GETMAIN-FOR-MAP
010700                                 THRU MB60PD-GFM-EXIT.
010800*
010900****************************************************************
011000*    ACQUIRE MAIN STORAGE FOR TEMP STORAGE RECORD              *
011100****************************************************************
011200*
011300     MOVE 'TS01'                 TO MBCA-PROGRAM-LOCATION.
011400     PERFORM 8100-TEMP-STORAGE-GETMAIN
011500                                 THRU 8199-TSG-EXIT.
011600*
011700****************************************************************
011800*    INITIALIZE THE STANDARD MAP LINES                         *
011900****************************************************************
012000*
012100     IF  MBCA-INITIAL-SCREEN-NBR
012200         PERFORM 8500-INIT-COMMAREA
012300                                 THRU 8599-IC-EXIT
012400         IF  SS08WS-ERROR-SW-YES
012500             MOVE 01             TO MBCA-SCREEN-NBR
012600             PERFORM MB60PD-INIT-STD-MAP-LINES
012700                                 THRU MB60PD-ISML-EXIT
012800             SET X-ORG-INDEX     TO +1
012900             GO TO 1070-FILL-TEMP-STORAGE
013000         ELSE
013100             MOVE 01             TO MBCA-SCREEN-NBR
013200             PERFORM MB60PD-INIT-STD-MAP-LINES
013300                                 THRU MB60PD-ISML-EXIT
013400             GO TO 1010-CHECK-RETURN-FLAG
013500     ELSE
013600         MOVE 01                 TO MBCA-SCREEN-NBR
013700         PERFORM MB60PD-INIT-STD-MAP-LINES
013800                                 THRU MB60PD-ISML-EXIT.
013900*
014000     EXEC CICS HANDLE CONDITION
014100               QIDERR (1010-CHECK-RETURN-FLAG)
014200          END-EXEC.
014300*
014400***********************************************
014500*    READ THE TEMP STORAGE RECORD             *
014600***********************************************
014700*
014800     MOVE 'TS02'                 TO MBCA-PROGRAM-LOCATION.
014900     PERFORM 8200-TEMP-STORAGE-READ
015000                                 THRU 8299-TSR-EXIT.
015100*
015200***********************************************
015300*    DELETE THE TEMP STORAGE RECORD           *
015400***********************************************
015500*
015600     MOVE 'TS03'                 TO MBCA-PROGRAM-LOCATION.
015700     PERFORM 8300-TEMP-STORAGE-DELETE
015800                                 THRU 8399-TSD-EXIT.
015900*
016000     PERFORM 8800-BUILD-SCREEN   THRU 8899-BS-EXIT.
016100     GO TO 1080-CONTINUE.
016200*
016300 1010-CHECK-RETURN-FLAG.
016400*
016500     IF  MBCA-MBDO-RETURN-BOTTOM
016600         PERFORM 8900-LAST-SCREEN
016700                                 THRU 8999-LS-EXIT
016800         IF  WS-BYPASS-YES
016900             GO TO 1015-READ-ORG
017000         ELSE
017100             GO TO 1080-CONTINUE
017200     ELSE
017300         IF  MBCA-MBDO-RETURN-BWD
017400             PERFORM 9000-BACK-SCREEN
017500                                 THRU 9099-BS-EXIT
017600             IF  WS-BYPASS-YES
017700                 GO TO 1015-READ-ORG
017800             ELSE
017900                 GO TO 1080-CONTINUE.
018000*
018100 1015-READ-ORG.
018200*
018300****************************************************************
018400*    START BROWSE THE ORGANIZATION FILE                        *
018500****************************************************************
018600*
018700     MOVE 'FC01'                 TO MBCA-PROGRAM-LOCATION.
018800     MOVE MBCA-MBDO-FWD-ORG      TO MBIOWS-MMOC-ORG.
018900     SET MBIORO-STARTBR-GTE      TO TRUE.
019000     PERFORM MMOCAO-ACCESS       THRU MMOCAO-ACCESS-EXIT.
019100*
019200     SET X-ORG-INDEX             TO +1.
019300*
019400 1020-READ-LOOP.
019500*
019600****************************************************************
019700*    READNEXT THE ORGANIZATION FILE                            *
019800****************************************************************
019900*
020000     MOVE 'FC02'                 TO MBCA-PROGRAM-LOCATION.
020100     SET MBIORO-READ-SEQ         TO TRUE.
020200     PERFORM MMOCAO-ACCESS       THRU MMOCAO-ACCESS-EXIT.
020300*
020400     IF  MMOC-ORG    IS GREATER THAN MBCA-ORG-HIGH
020500     OR  MMOC-ORG    IS EQUAL TO WS-ORG-NINES
020600         GO TO 1020-END-BROWSE.
020700*
020800     IF  MMOC-ORG IS EQUAL TO ZEROS
020900         GO TO 1020-READ-LOOP.
021000*
021100     PERFORM 9300-BUILD-SCREEN-LINE
021200                                 THRU 9399-BSL-EXIT.
021300*
021400     IF  X-ORG-INDEX IS EQUAL TO +1
021500         MOVE MMOC-ORG           TO MBCA-MBDO-BACK-ORG.
021600*
021700     IF  X-ORG-INDEX IS LESS THAN +17
021800         SET X-ORG-INDEX         UP BY +1
021900         GO TO 1020-READ-LOOP
022000     ELSE
022100         MOVE MMOC-ORG           TO MBCA-MBDO-FWD-ORG
022200         PERFORM 9200-READ-AHEAD THRU 9299-RA-EXIT
022300         SET X-ORG-INDEX         UP BY +1.
022400*
022500 1020-END-BROWSE.
022600*
022700****************************************************************
022800*    END BROWSE THE ORGANIZATION FILE                          *
022900****************************************************************
023000*
023100     MOVE 'FC03'                 TO MBCA-PROGRAM-LOCATION.
023200     SET MBIORO-ENDBR            TO TRUE.
023300     PERFORM MMOCAO-ACCESS       THRU MMOCAO-ACCESS-EXIT.
023400*
023500 1060-SET-ATTRIBUTE.
023600*
023700     IF  X-ORG-INDEX IS EQUAL TO +1
023800         IF  MBCA-MBDO-RETURN-NORMAL
023900             SET MBCA-INITIAL-SCREEN-NBR
024000                                 TO TRUE
024100             MOVE '..NU'         TO SS08WS-WORK-TRANS-ID
024200             MOVE 'PC03'         TO MBCA-PROGRAM-LOCATION
024300             PERFORM MB70PD-XCTL-TO-MBOXCTL
024400                                 THRU MB70PD-XTM-EXIT
024500         ELSE
024600             MOVE MBCA-MBDO-BACK-ORG
024700                                 TO MBCA-MBDO-FWD-ORG
024800             GO TO 1015-READ-ORG.
024900*
025000 1070-FILL-TEMP-STORAGE.
025100*
025200     IF  X-ORG-INDEX IS LESS THAN +18
025300         SET X-MBDOTS-INDEX      TO X-ORG-INDEX
025400         MOVE ZEROES             TO MBCA-MBDO-FWD-ORG
025500                                    WS-FWD-ORG
025600                                    MBDOTS-ORG
025700                                    (X-MBDOTS-INDEX)
025800                                    MBDOTS-STATUS-CODE
025900                                    (X-MBDOTS-INDEX)
026000         MOVE SPACES             TO MBDOTS-ORG-NAME
026100                                    (X-MBDOTS-INDEX)
026200         MOVE DFHBMASK           TO DO01-SELECT-A
026300                                    (X-ORG-INDEX)
026400         MOVE DFHBMDAS           TO DO01-DIRECTORY-LINE-A
026500                                    (X-ORG-INDEX)
026600                                    DO01-SELECT-LP-A
026700                                    (X-ORG-INDEX)
026800                                    DO01-SELECT-RP-A
026900                                    (X-ORG-INDEX)
027000         SET X-ORG-INDEX         UP BY +1
027100         GO TO 1060-SET-ATTRIBUTE.
027200*
027300 1080-CONTINUE.
027400*
027500     IF  MBCA-MBDO-BACK-ORG IS NOT EQUAL
027600                                 TO MBCA-MBDO-FIRST-ORG
027700         MOVE DFHBMASB           TO DO01-FWD-BACK-IND-A (1).
027800*
027900     IF  WS-FWD-ORG IS NOT EQUAL TO ZEROES
028000         MOVE DFHBMASB           TO DO01-FWD-BACK-IND-A (17).
028100*
028200****************************************************************
028300*    WRITE THE TEMP STORAGE RECORD                             *
028400****************************************************************
028500*
028600     MOVE 'TS04'                 TO MBCA-PROGRAM-LOCATION.
028700     PERFORM 8400-WRITE-QUEUE    THRU 8499-WQ-EXIT.
028800*
028900     PERFORM 9100-SET-ATTRIBUTE  THRU 9199-SA-EXIT
029000         VARYING X-ORG-INDEX     FROM +1 BY +1
029100         UNTIL   X-ORG-INDEX IS GREATER THAN +17.
029200*
029300     SET X-ORG-INDEX             TO +1.
029400*
029500 1090-CURSOR-LOOP.
029600*
029700     IF  X-ORG-INDEX IS GREATER THAN +17
029800         MOVE SS08WS-CURSOR      TO DO01-ALT-TRANID-L
029900         GO TO 1100-CONTINUE.
030000*
030100     IF  DO01-SELECT-A (X-ORG-INDEX)
030200                                 IS EQUAL TO DFHBMASK
030300         SET X-ORG-INDEX         UP BY +1
030400         GO TO 1090-CURSOR-LOOP
030500     ELSE
030600         MOVE SS08WS-CURSOR      TO DO01-SELECT-L (X-ORG-INDEX).
030700*
030800 1100-CONTINUE.
030900*
031000     MOVE '*TOP*'                TO SS08WS-LINE-24-PF-KEY-FUNC(3).
031100     MOVE '*BOT*'                TO SS08WS-LINE-24-PF-KEY-FUNC(4).
031200     MOVE '*FWD*'                TO SS08WS-LINE-24-PF-KEY-FUNC(5).
031300     MOVE '*BWD*'                TO SS08WS-LINE-24-PF-KEY-FUNC(6).
031400     MOVE SS08WS-LINE-24         TO DO01-PF-KEYS.
031500     MOVE 'RESV'                 TO MBCA-PGMX-PF-TRANS-ID (3).
031600     MOVE 'RESV'                 TO MBCA-PGMX-PF-TRANS-ID (4).
031700     MOVE 'RESV'                 TO MBCA-PGMX-PF-TRANS-ID (5).
031800     MOVE 'RESV'                 TO MBCA-PGMX-PF-TRANS-ID (6).
031900*
032000     MOVE DFHBMASK               TO DO01-CURRENT-PAGE-A.
032100*
032200****************************************************************
032300*    SEND THE MAP                                              *
032400****************************************************************
032500*
032600     MOVE 'BM01'                 TO MBCA-PROGRAM-LOCATION.
032700     PERFORM MB60PD-SEND-MAP-WITH-ERASE
032800                                 THRU MB60PD-SMWE-EXIT.
032900*
033000****************************************************************
033100*    RETURN TO CICS                                            *
033200****************************************************************
033300*
033400     MOVE 'PC04'                 TO MBCA-PROGRAM-LOCATION.
033500     PERFORM MB70PD-RETURN-TRANS-ID
033600                                 THRU MB70PD-RTI-EXIT.
033700/
033800 2000-RECEIVE-SCREEN SECTION.
033900*
034000     IF  MBCA-EIBAID-CLEAR
034100         MOVE 'TS05'             TO MBCA-PROGRAM-LOCATION
034200         PERFORM 8300-TEMP-STORAGE-DELETE
034300                                 THRU 8399-TSD-EXIT
034400         MOVE 'PC05'             TO MBCA-PROGRAM-LOCATION
034500         MOVE 98                 TO MBCA-SCREEN-NBR
034600         PERFORM MB70PD-ON-LINE-HOUSEKEEPING
034700                                 THRU MB70PD-OLH-EXIT.
034800*
034900****************************************************************
035000*    THIS SECTION RECEIVES THE 01 SCREEN                       *
035100****************************************************************
035200*
035300     MOVE 'BM02'                 TO MBCA-PROGRAM-LOCATION.
035400     PERFORM MB60PD-RECEIVE-MAP  THRU MB60PD-RM-EXIT.
035500*
035600*****************************************************
035700*    ACQUIRE MAIN STORAGE FOR TEMP STORAGE RECORD   *
035800*****************************************************
035900*
036000     MOVE 'TS06'                 TO MBCA-PROGRAM-LOCATION.
036100     PERFORM 8100-TEMP-STORAGE-GETMAIN
036200                                 THRU 8199-TSG-EXIT.
036300*
036400***********************************************
036500*    READ THE TEMP STORAGE RECORD             *
036600***********************************************
036700*
036800     MOVE 'TS07'                 TO MBCA-PROGRAM-LOCATION.
036900     PERFORM 8200-TEMP-STORAGE-READ
037000                                 THRU 8299-TSR-EXIT.
037100*
037200***********************************************
037300*    DELETE THE TEMP STORAGE RECORD           *
037400***********************************************
037500*
037600     MOVE 'TS08'                 TO MBCA-PROGRAM-LOCATION.
037700     PERFORM 8300-TEMP-STORAGE-DELETE
037800                                 THRU 8399-TSD-EXIT.
037900*
038000****************************************************************
038100*    CHECK FOR ANOTHER TRANSACTION ID ENTERED BY THE USER      *
038200****************************************************************
038300*
038400     MOVE 'PC06'                 TO MBCA-PROGRAM-LOCATION.
038500     PERFORM MB60PD-NEW-TRANS-ROUTINE
038600                                 THRU MB60PD-NTR-EXIT.
038700*
038800 2005-EDIT-SELECT.
038900*
039000****************************************************************
039100*    EDIT SELECT FIELD                                         *
039200****************************************************************
039300*
039400     PERFORM 8600-EDIT-SELECT    THRU 8699-ES-EXIT.
039500*
039600 2090-CHECK-ERROR.
039700*
039800     IF  SS08WS-ERROR-SW-NO
039900         GO TO 2400-CHECK-SELECT.
040000*
040100 2300-SEND-MAP.
040200*
040300***********************************************
040400*    WRITE THE TEMP STORAGE RECORD            *
040500***********************************************
040600*
040700     MOVE 'TS09'                 TO MBCA-PROGRAM-LOCATION.
040800     PERFORM 8400-WRITE-QUEUE    THRU 8499-WQ-EXIT.
040900*
041000****************************************************************
041100*    SEND THE MAP                                              *
041200****************************************************************
041300*
041400     PERFORM MB60PD-INIT-STD-MAP-LINES
041500                                 THRU MB60PD-ISML-EXIT.
041600*
041700     MOVE '*TOP*'                TO SS08WS-LINE-24-PF-KEY-FUNC(3).
041800     MOVE '*BOT*'                TO SS08WS-LINE-24-PF-KEY-FUNC(4).
041900     MOVE '*FWD*'                TO SS08WS-LINE-24-PF-KEY-FUNC(5).
042000     MOVE '*BWD*'                TO SS08WS-LINE-24-PF-KEY-FUNC(6).
042100     MOVE SS08WS-LINE-24         TO DO01-PF-KEYS.
042200     MOVE 'RESV'                 TO MBCA-PGMX-PF-TRANS-ID (3).
042300     MOVE 'RESV'                 TO MBCA-PGMX-PF-TRANS-ID (4).
042400     MOVE 'RESV'                 TO MBCA-PGMX-PF-TRANS-ID (5).
042500     MOVE 'RESV'                 TO MBCA-PGMX-PF-TRANS-ID (6).
042600*
042700     MOVE DFHBMASK               TO DO01-CURRENT-PAGE-A.
042800*
042900     MOVE 'BM03'                 TO MBCA-PROGRAM-LOCATION.
043000     PERFORM MB60PD-SEND-MAP-DATA-ONLY
043100                                 THRU MB60PD-SMDO-EXIT.
043200*
043300****************************************************************
043400*    RETURN TO CICS                                            *
043500****************************************************************
043600*
043700     MOVE 'PC07'                 TO MBCA-PROGRAM-LOCATION.
043800     PERFORM MB70PD-RETURN-TRANS-ID
043900                                 THRU MB70PD-RTI-EXIT.
044000/
044100 2400-CHECK-SELECT.
044200*
044300     IF  WS-SELECT-YES
044400         SET X-MBDOTS-INDEX      TO X-ORG-INDEX
044500         MOVE MBDOTS-ORG (X-MBDOTS-INDEX)
044600                                 TO MBCA-MERCHANT-ORG
044700         MOVE MBIOWS-MMOC-DIRECT-KEY-CODE
044800                                 TO MBCA-KEY-CODE
044900         SET MBCA-INITIAL-SCREEN-NBR
045000                                 TO TRUE
045100         IF  DO01-VALID-INQUIRY (X-ORG-INDEX)
045200             MOVE '..QO'         TO SS08WS-WORK-TRANS-ID
045300             GO TO 2690-PF-KEY-BYPASS
045400         ELSE
045500             IF  DO01-VALID-MAINT (X-ORG-INDEX)
045600                 MOVE '..MO'     TO SS08WS-WORK-TRANS-ID
045700                 GO TO 2690-PF-KEY-BYPASS.
045800*
045900 2600-SETUP-COMMAREA.
046000*
046100****************************************************************
046200*    SET UP COMMAREA FIELDS AND TRANSFER TO THE NEXT PROGRAM   *
046300****************************************************************
046400*
046500     MOVE MBCA-EIBAID            TO SS08WS-EIBAID.
046600*
046700     IF  SS08WS-VALID-PF3
046800     OR  SS08WS-EIBAID-VALID-PF3
046900         MOVE 51                 TO MBCA-SCREEN-NBR
047000         MOVE MBCA-MBDO-FIRST-ORG
047100                                 TO MBCA-MBDO-FWD-ORG
047200         SET MBCA-MBDO-RETURN-NORMAL
047300                                 TO TRUE
047400         GO TO 2690-PF-KEY-BYPASS.
047500*
047600     IF  SS08WS-VALID-PF4
047700     OR  SS08WS-EIBAID-VALID-PF4
047800         MOVE 51                 TO MBCA-SCREEN-NBR
047900         IF (MBDOTS-ORG (1) IS GREATER THAN ZEROES
048000         AND MBDOTS-ORG (17) IS EQUAL TO ZEROES)
048100         OR (MBCA-MBDO-FWD-ORG IS EQUAL TO ZEROES)
048200             SET MBCA-MBDO-RETURN-NORMAL
048300                                 TO TRUE
048400             MOVE ZEROES         TO MBCA-MBDO-FWD-ORG
048500             MOVE 'TS10'         TO MBCA-PROGRAM-LOCATION
048600             PERFORM 8400-WRITE-QUEUE
048700                                 THRU 8499-WQ-EXIT
048800             GO TO 2690-PF-KEY-BYPASS
048900         ELSE
049000             SET MBCA-MBDO-RETURN-BOTTOM
049100                                 TO TRUE
049200             GO TO 2690-PF-KEY-BYPASS.
049300*
049400     IF  SS08WS-VALID-PF5
049500     OR  SS08WS-EIBAID-VALID-PF5
049600         MOVE 51                 TO MBCA-SCREEN-NBR
049700         IF (MBDOTS-ORG (1) IS GREATER THAN ZEROES
049800         AND MBDOTS-ORG (17) IS EQUAL TO ZEROES)
049900         OR (MBCA-MBDO-FWD-ORG IS EQUAL TO ZEROES)
050000             SET MBCA-MBDO-RETURN-NORMAL
050100                                 TO TRUE
050200             MOVE ZEROES         TO MBCA-MBDO-FWD-ORG
050300             MOVE 'TS11'         TO MBCA-PROGRAM-LOCATION
050400             PERFORM 8400-WRITE-QUEUE
050500                                 THRU 8499-WQ-EXIT
050600             GO TO 2690-PF-KEY-BYPASS
050700         ELSE
050800             SET MBCA-MBDO-RETURN-FWD
050900                                 TO TRUE
051000             ADD 1               TO MBCA-MBDO-FWD-ORG
051100             GO TO 2690-PF-KEY-BYPASS.
051200*
051300     IF  SS08WS-VALID-PF6
051400     OR  SS08WS-EIBAID-VALID-PF6
051500         MOVE 51                 TO MBCA-SCREEN-NBR
051600         IF  MBCA-MBDO-BACK-ORG IS EQUAL
051700                                 TO MBCA-MBDO-FIRST-ORG
051800             SET MBCA-MBDO-RETURN-NORMAL
051900                                 TO TRUE
052000             MOVE 'TS12'         TO MBCA-PROGRAM-LOCATION
052100             PERFORM 8400-WRITE-QUEUE
052200                                 THRU 8499-WQ-EXIT
052300             GO TO 2690-PF-KEY-BYPASS
052400         ELSE
052500             MOVE MBCA-MBDO-BACK-ORG
052600                                 TO MBCA-MBDO-FWD-ORG
052700             SET MBCA-MBDO-RETURN-BWD
052800                                 TO TRUE
052900             GO TO 2690-PF-KEY-BYPASS.
053000*
053100     IF  SS08WS-VALID-PF-KEY
053200     OR  SS08WS-EIBAID-VALID-PF-KEY
053300         SET MBCA-INITIAL-SCREEN-NBR
053400                                 TO TRUE
053500         GO TO 2690-PF-KEY-BYPASS
053600     ELSE
053700         IF  MBDOTS-ORG (17) IS EQUAL TO ZEROES
053800         OR  MBCA-MBDO-FWD-ORG IS EQUAL TO ZEROES
053900             SET MBCA-INITIAL-SCREEN-NBR
054000                                 TO TRUE
054100             MOVE '..NU'         TO SS08WS-WORK-TRANS-ID
054200             MOVE 'PC08'         TO MBCA-PROGRAM-LOCATION
054300             PERFORM MB70PD-XCTL-TO-MBOXCTL
054400                                 THRU MB70PD-XTM-EXIT.
054500*
054600     MOVE 51                     TO MBCA-SCREEN-NBR.
054700     ADD 1                       TO MBCA-MBDO-FWD-ORG.
054800     SET MBCA-MBDO-RETURN-NORMAL TO TRUE.
054900*
055000 2690-PF-KEY-BYPASS.
055100*
055200     MOVE 'PC09'                 TO MBCA-PROGRAM-LOCATION.
055300     PERFORM MB70PD-XCTL-TO-MBOXCTL
055400                                 THRU MB70PD-XTM-EXIT.
055500/
055600 8000-PERFORMED-ROUTINES-SECT SECTION.
055700*
055800 8100-TEMP-STORAGE-GETMAIN.
055900*
056000     EXEC CICS GETMAIN
056100               FLENGTH (LENGTH  OF MBDOTS-RECORD)
056200               SET     (ADDRESS OF MBDOTS-RECORD)
056300          END-EXEC.
056400*
056500 8199-TSG-EXIT.
056600     EXIT.
056700*
056800 8200-TEMP-STORAGE-READ.
056900*
057000     EXEC CICS READQ TS
057100               QUEUE   (TS-QUEUE-NAME)
057200               INTO    (MBDOTS-RECORD)
057300               LENGTH  (LENGTH  OF MBDOTS-RECORD)
057400               ITEM    (1)
057500          END-EXEC.
057600*
057700 8299-TSR-EXIT.
057800     EXIT.
057900*
058000 8300-TEMP-STORAGE-DELETE.
058100*
058200     EXEC CICS IGNORE CONDITION
058300               QIDERR
058400          END-EXEC.
058500*
058600     EXEC CICS DELETEQ TS
058700               QUEUE  (TS-QUEUE-NAME)
058800          END-EXEC.
058900*
059000 8399-TSD-EXIT.
059100     EXIT.
059200*
059300 8400-WRITE-QUEUE.
059400*
059500     EXEC CICS WRITEQ TS
059600               QUEUE   (TS-QUEUE-NAME)
059700               FROM    (MBDOTS-RECORD)
059800               LENGTH  (LENGTH  OF MBDOTS-RECORD)
059900          END-EXEC.
060000*
060100 8499-WQ-EXIT.
060200     EXIT.
060300*
060400 8500-INIT-COMMAREA.
060500*
060600     SET MBCA-MBDO-RETURN-NORMAL TO TRUE.
060700     MOVE ZEROES                 TO MBCA-MBDO-BACK-ORG.
060800*
060900     MOVE 'TS13'                 TO MBCA-PROGRAM-LOCATION.
061000     PERFORM 8300-TEMP-STORAGE-DELETE
061100                                 THRU 8399-TSD-EXIT.
061200*
061300****************************************************************
061400*    START BROWSE THE ORGANIZATION FILE                        *
061500****************************************************************
061600*
061700     MOVE 'FC04'                 TO MBCA-PROGRAM-LOCATION.
061800     IF  MBCA-ORG-LOW IS EQUAL TO ZEROS
061900         MOVE 001                TO MBIOWS-MMOC-ORG
062000     ELSE
062100         MOVE MBCA-ORG-LOW       TO MBIOWS-MMOC-ORG.
062200     SET MBIORO-STARTBR-GTE      TO TRUE.
062300     PERFORM MMOCAO-ACCESS       THRU MMOCAO-ACCESS-EXIT.
062400*
062500****************************************************************
062600*    READNEXT THE ORGANIZATION FILE                            *
062700****************************************************************
062800*
062900     MOVE 'FC05'                 TO MBCA-PROGRAM-LOCATION.
063000     SET MBIORO-READ-SEQ         TO TRUE.
063100     PERFORM MMOCAO-ACCESS       THRU MMOCAO-ACCESS-EXIT.
063200*
063300****************************************************************
063400*    END BROWSE THE ORGANIZATION FILE                          *
063500****************************************************************
063600*
063700     MOVE 'FC06'                 TO MBCA-PROGRAM-LOCATION.
063800     SET MBIORO-ENDBR            TO TRUE.
063900     PERFORM MMOCAO-ACCESS       THRU MMOCAO-ACCESS-EXIT.
064000*
064100     IF  MMOC-ORG    IS GREATER THAN MBCA-ORG-HIGH
064200     OR  MMOC-ORG    IS EQUAL TO WS-ORG-NINES
064300         MOVE 'NO ORG RECORDS ON FILE FOR YOUR SECURITY RANGE'
064400                                 TO DO01-ERR-MESSAGE
064500         MOVE ZEROES             TO MBCA-MBDO-FIRST-ORG
064600                                    MBCA-MBDO-FWD-ORG
064700         MOVE DFHBMDAS           TO DO01-LINE4-LIT-A
064800                                    DO01-LINE5-LIT-A
064900         SET SS08WS-ERROR-SW-YES TO TRUE
065000     ELSE
065100         MOVE MMOC-ORG           TO MBCA-MBDO-FIRST-ORG
065200                                    MBCA-MBDO-FWD-ORG.
065300*
065400 8599-IC-EXIT.
065500     EXIT.
065600*
065700 8600-EDIT-SELECT.
065800*
065900     SET X-ORG-INDEX             TO +1.
066000*
066100 8600-EDIT-LOOP.
066200*
066300     IF  DO01-SELECT-L (X-ORG-INDEX) IS GREATER THAN ZERO
066400         IF  DO01-VALID-SELECT (X-ORG-INDEX)
066500             MOVE DFHBMASF       TO DO01-SELECT-A
066600                                    (X-ORG-INDEX)
066700             MOVE DFHBMDAS       TO DO01-SELECT-LP-A
066800                                    (X-ORG-INDEX)
066900                                    DO01-SELECT-RP-A
067000                                    (X-ORG-INDEX)
067100             IF  DO01-VALID-INQUIRY-MAINT (X-ORG-INDEX)
067200                 SET WS-SELECT-YES
067300                                 TO TRUE
067400                 GO TO 8699-ES-EXIT
067500             ELSE
067600                 NEXT SENTENCE
067700         ELSE
067800             SET SS08WS-ERROR-SW-YES TO TRUE
067900             MOVE SS08WS-CURSOR  TO DO01-SELECT-L
068000                                    (X-ORG-INDEX)
068100             MOVE DFHBMUBF       TO DO01-SELECT-A
068200                                    (X-ORG-INDEX)
068300             MOVE DFHBMASB       TO DO01-SELECT-LP-A
068400                                    (X-ORG-INDEX)
068500                                    DO01-SELECT-RP-A
068600                                    (X-ORG-INDEX)
068700             GO TO 8699-ES-EXIT.
068800*
068900     IF  X-ORG-INDEX IS LESS THAN +17
069000         SET X-ORG-INDEX         UP BY +1
069100         GO TO 8600-EDIT-LOOP.
069200*
069300 8699-ES-EXIT.
069400     EXIT.
069500*
069600 8800-BUILD-SCREEN.
069700*
069800     SET X-ORG-INDEX             TO +1.
069900*
070000 8800-BUILD-LOOP.
070100*
070200     SET X-MBDOTS-INDEX          TO X-ORG-INDEX.
070300*
070400     IF  MBDOTS-ORG (X-MBDOTS-INDEX)
070500                                 IS GREATER THAN ZEROES
070600         MOVE MBDOTS-ORG (X-MBDOTS-INDEX)
070700                                 TO WS-ORG-NBR
070800         MOVE MBDOTS-ORG-NAME (X-MBDOTS-INDEX)
070900                                 TO WS-ORG-NAME
071000         MOVE MBDOTS-STATUS-CODE (X-MBDOTS-INDEX)
071100                                 TO WS-STATUS-CODE
071200         MOVE WS-DETAIL-LINE     TO DO01-DIRECTORY-LINE
071300                                    (X-ORG-INDEX)
071400     ELSE
071500         MOVE DFHBMASK           TO DO01-SELECT-A
071600                                    (X-ORG-INDEX)
071700         MOVE DFHBMDAS           TO DO01-DIRECTORY-LINE-A
071800                                    (X-ORG-INDEX)
071900                                    DO01-SELECT-LP-A
072000                                    (X-ORG-INDEX)
072100                                    DO01-SELECT-RP-A
072200                                    (X-ORG-INDEX).
072300*
072400     IF  X-ORG-INDEX IS LESS THAN +17
072500         SET X-ORG-INDEX         UP BY +1
072600         GO TO 8800-BUILD-LOOP
072700     ELSE
072800         MOVE MBCA-MBDO-FWD-ORG  TO WS-FWD-ORG.
072900*
073000 8899-BS-EXIT.
073100     EXIT.
073200*
073300 8900-LAST-SCREEN.
073400*
073500****************************************************************
073600*    START BROWSE THE ORGANIZATION FILE                        *
073700****************************************************************
073800*
073900     MOVE 'FC07'                 TO MBCA-PROGRAM-LOCATION.
074000     SET MBIOWS-MMOC-TRAILER     TO TRUE.
074100     SET MBIORO-STARTBR-GTE      TO TRUE.
074200     PERFORM MMOCAO-ACCESS       THRU MMOCAO-ACCESS-EXIT.
074300*
074400****************************************************************
074500*    READNEXT THE ORGANIZATION FILE                            *
074600****************************************************************
074700*
074800     MOVE 'FC08'                 TO MBCA-PROGRAM-LOCATION.
074900     SET MBIORO-READ-SEQ         TO TRUE.
075000     PERFORM MMOCAO-ACCESS       THRU MMOCAO-ACCESS-EXIT.
075100*
075200****************************************************************
075300*    READPREV THE ORGANIZATION FILE                            *
075400****************************************************************
075500*
075600     MOVE 'FC09'                 TO MBCA-PROGRAM-LOCATION.
075700     SET MBIORO-READ-PREV        TO TRUE.
075800     PERFORM MMOCAO-ACCESS       THRU MMOCAO-ACCESS-EXIT.
075900*
076000     SET X-ORG-INDEX             TO +17.
076100     SET WS-BYPASS-NO            TO TRUE.
076200*
076300 8900-READ-ORG-FILE.
076400*
076500****************************************************************
076600*    READPREV THE ORGANIZATION FILE                            *
076700****************************************************************
076800*
076900     MOVE 'FC10'                 TO MBCA-PROGRAM-LOCATION.
077000     SET MBIORO-READ-PREV        TO TRUE.
077100     PERFORM MMOCAO-ACCESS       THRU MMOCAO-ACCESS-EXIT.
077200*
077300 8900-BUILD-LOOP.
077400*
077500     IF  MMOC-ORG    IS LESS THAN MBCA-ORG-LOW
077600     OR  MMOC-ORG    IS EQUAL TO WS-ORG-ZEROES
077700         GO TO 8900-END-BROWSE
077800     ELSE
077900         IF  MMOC-ORG    IS GREATER THAN MBCA-ORG-HIGH
078000             GO TO 8900-READ-ORG-FILE.
078100*
078200     IF  MMOC-ORG    IS EQUAL TO MBCA-MBDO-FIRST-ORG
078300     AND X-ORG-INDEX IS GREATER THAN +1
078400         SET MBCA-MBDO-RETURN-NORMAL
078500                                 TO TRUE
078600         MOVE MBCA-MBDO-FIRST-ORG
078700                                 TO MBCA-MBDO-FWD-ORG
078800         SET WS-BYPASS-YES       TO TRUE
078900         GO TO 8900-END-BROWSE.
079000*
079100     PERFORM 9300-BUILD-SCREEN-LINE
079200                                 THRU 9399-BSL-EXIT.
079300*
079400     IF  X-ORG-INDEX IS GREATER THAN +1
079500         SET X-ORG-INDEX         DOWN BY +1
079600         GO TO 8900-READ-ORG-FILE
079700     ELSE
079800         MOVE MMOC-ORG           TO MBCA-MBDO-BACK-ORG.
079900*
080000 8900-END-BROWSE.
080100*
080200****************************************************************
080300*    END BROWSE THE ORGANIZATION FILE                          *
080400****************************************************************
080500*
080600     MOVE 'FC11'                 TO MBCA-PROGRAM-LOCATION.
080700     SET MBIORO-ENDBR            TO TRUE.
080800     PERFORM MMOCAO-ACCESS       THRU MMOCAO-ACCESS-EXIT.
080900*
081000     IF  WS-BYPASS-YES
081100         GO TO 8999-LS-EXIT.
081200*
081300     MOVE ZEROES                 TO MBCA-MBDO-FWD-ORG
081400                                    WS-FWD-ORG.
081500*
081600 8999-LS-EXIT.
081700     EXIT.
081800*
081900 9000-BACK-SCREEN.
082000*
082100****************************************************************
082200*    START BROWSE THE ORGANIZATION FILE                        *
082300****************************************************************
082400*
082500     MOVE 'FC12'                 TO MBCA-PROGRAM-LOCATION.
082600     MOVE MBCA-MBDO-FWD-ORG      TO MBIOWS-MMOC-ORG.
082700     SET MBIORO-STARTBR-GTE      TO TRUE.
082800     PERFORM MMOCAO-ACCESS       THRU MMOCAO-ACCESS-EXIT.
082900*
083000****************************************************************
083100*    READNEXT THE ORGANIZATION FILE                            *
083200****************************************************************
083300*
083400     MOVE 'FC13'                 TO MBCA-PROGRAM-LOCATION.
083500     SET MBIORO-READ-SEQ         TO TRUE.
083600     PERFORM MMOCAO-ACCESS       THRU MMOCAO-ACCESS-EXIT.
083700*
083800****************************************************************
083900*    READPREV THE ORGANIZATION FILE                            *
084000****************************************************************
084100*
084200     MOVE 'FC14'                 TO MBCA-PROGRAM-LOCATION.
084300     SET MBIORO-READ-PREV        TO TRUE.
084400     PERFORM MMOCAO-ACCESS       THRU MMOCAO-ACCESS-EXIT.
084500*
084600     SET X-ORG-INDEX             TO +17.
084700     SET WS-BYPASS-NO            TO TRUE.
084800*
084900 9000-READ-ORG-FILE.
085000*
085100****************************************************************
085200*    READPREV THE ORGANIZATION FILE                            *
085300****************************************************************
085400*
085500     MOVE 'FC15'                 TO MBCA-PROGRAM-LOCATION.
085600     SET MBIORO-READ-PREV        TO TRUE.
085700     PERFORM MMOCAO-ACCESS       THRU MMOCAO-ACCESS-EXIT.
085800*
085900 9000-BUILD-LOOP.
086000*
086100     IF  X-ORG-INDEX IS GREATER THAN +1
086200     AND MMOC-ORG    IS EQUAL TO MBCA-MBDO-FIRST-ORG
086300         SET MBCA-MBDO-RETURN-NORMAL
086400                                 TO TRUE
086500         MOVE MBCA-MBDO-FIRST-ORG
086600                                 TO MBCA-MBDO-FWD-ORG
086700         SET WS-BYPASS-YES       TO TRUE
086800         GO TO 9000-END-BROWSE.
086900*
087000     IF (MMOC-ORG    IS EQUAL TO MBCA-MBDO-BACK-ORG
087100     AND X-ORG-INDEX IS EQUAL TO +17)
087200         GO TO 9000-READ-ORG-FILE.
087300*
087400     PERFORM 9300-BUILD-SCREEN-LINE
087500                                 THRU 9399-BSL-EXIT.
087600*
087700     IF  X-ORG-INDEX IS EQUAL TO +17
087800         MOVE MMOC-ORG           TO MBCA-MBDO-FWD-ORG
087900                                    WS-FWD-ORG.
088000*
088100     IF  X-ORG-INDEX IS GREATER THAN +1
088200         SET X-ORG-INDEX         DOWN BY +1
088300         GO TO 9000-READ-ORG-FILE
088400     ELSE
088500         MOVE MMOC-ORG           TO MBCA-MBDO-BACK-ORG.
088600*
088700 9000-END-BROWSE.
088800*
088900****************************************************************
089000*    END BROWSE THE ORGANIZATION FILE                          *
089100****************************************************************
089200*
089300     MOVE 'FC16'                 TO MBCA-PROGRAM-LOCATION.
089400     SET MBIORO-ENDBR            TO TRUE.
089500     PERFORM MMOCAO-ACCESS       THRU MMOCAO-ACCESS-EXIT.
089600*
089700 9099-BS-EXIT.
089800     EXIT.
089900*
090000 9100-SET-ATTRIBUTE.
090100*
090200     SET X-MBDOTS-INDEX          TO X-ORG-INDEX.
090300*
090400     IF  MBDOTS-STATUS-INCOMPLETE (X-MBDOTS-INDEX)
090500     OR  MBDOTS-STATUS-PURGED (X-MBDOTS-INDEX)
090600         MOVE DFHBMASK           TO DO01-SELECT-A
090700                                    (X-ORG-INDEX)
090800         MOVE DFHBMDAS           TO DO01-SELECT-LP-A
090900                                    (X-ORG-INDEX)
091000                                    DO01-SELECT-RP-A
091100                                    (X-ORG-INDEX).
091200*
091300 9199-SA-EXIT.
091400     EXIT.
091500*
091600 9200-READ-AHEAD.
091700*
091800****************************************************************
091900*    READNEXT THE ORGANIZATION FILE                            *
092000****************************************************************
092100*
092200     MOVE 'FC17'                 TO MBCA-PROGRAM-LOCATION.
092300     SET MBIORO-READ-SEQ         TO TRUE.
092400     PERFORM MMOCAO-ACCESS       THRU MMOCAO-ACCESS-EXIT.
092500*
092600     IF  MMOC-ORG    IS GREATER THAN MBCA-ORG-HIGH
092700     OR  MMOC-ORG    IS EQUAL TO WS-ORG-NINES
092800         MOVE ZEROES             TO WS-FWD-ORG
092900                                    MBCA-MBDO-FWD-ORG
093000         GO TO 9299-RA-EXIT.
093100*
093200     MOVE MMOC-ORG               TO WS-FWD-ORG.
093300*
093400 9299-RA-EXIT.
093500     EXIT.
093600*
093700 9300-BUILD-SCREEN-LINE.
093800*
093900     SET X-MBDOTS-INDEX          TO X-ORG-INDEX.
094000*
094100     MOVE MMOC-ORG               TO WS-ORG-NBR
094200                                    MBDOTS-ORG
094300                                    (X-MBDOTS-INDEX).
094400*
094500     MOVE MMOC-NA-LINE (1 1)     TO WS-ORG-NAME
094600                                    MBDOTS-ORG-NAME
094700                                    (X-MBDOTS-INDEX).
094800*
094900     MOVE MMOC-REC-STATUS        TO WS-STATUS-CODE
095000                                    MBDOTS-STATUS-CODE
095100                                    (X-MBDOTS-INDEX).
095200*
095300     MOVE WS-DETAIL-LINE         TO DO01-DIRECTORY-LINE
095400                                    (X-ORG-INDEX).
095500*
095600 9399-BSL-EXIT.
095700     EXIT.
095800/         JULIAN TO GREGORIAN DATE ROUTINE
095900     COPY SS08PD.
096000/
096100     COPY SS26PD.
096200/
096300     COPY SS27PD.
096400/         LINE 24 PF KEYS ROUTINE
096500     COPY SS15PD.
096600/         ORGANIZATION RECORD ACCESS ROUTINES
096700     COPY MMOCAO.
096800/         ON-LINE MAP ROUTINES
096900     COPY MB60PD REPLACING 'MBMAPXX' BY 'MBDO01 '
097000                           MBMAPXXI BY MBDO01I
097100                           MBMAPXXO BY MBDO01O.
097200/         ON-LINE PROCEDURES
097300     COPY MB70PD.
097400/
097500     COPY SMFTPXO.
