000100 IDENTIFICATION DIVISION.
000200 PROGRAM-ID. MBODQ01.
000201*       RELEASE DATE=08/24/01.        REVISION LEVEL=08.06      *
000202*****************************************************************
000203*WARNING.  THIS COMPUTER PROGRAM IS PROTECTED BY COPYRIGHT LAW  *
000204*AND INTERNATIONAL TREATIES.  UNAUTHORIZED REPRODUCTION OR      *
000205*DISTRIBUTION OF THIS PROGRAM, OR ANY PORTION OF IT, MAY RESULT *
000206*IN SEVERE CIVIL AND CRIMINAL PENATLIES, AND WILL BE PROSECUTED *
000207*TO THE MAXIMUM EXTENT POSSIBLE UNDER THE LAW.                  *
000208*COPYRIGHT 1999 PAYSYS INTERNATIONAL, INC.  ALL RIGHTS RESERVED.*
000209*****************************************************************
000300*****************************************************************
000400*                                                               *
000500*   V - PLUS  M E R C H A N T   B A N K C A R D   S Y S T E M   *
000600*                                                               *
000700*      MBODQ01 - ON-LINE EXAM DIRECTORY                         *
000800*                SCREEN 01                                      *
000900*                                                               *
001000*              1. TRANSIDS                                      *
001100*                 A. MBDQ                                       *
001200*              2. MAPS USED -                                   *
001300*                 A. MBDQ01 (SCREEN 01)                         *
001400*              3. FILES USED -                                  *
001500*                 A. MMEX   (EXAM MASTER FILE)                  *
001600*                                                               *
001700*****************************************************************
001800*
001900 ENVIRONMENT DIVISION.
002000 DATA DIVISION.
002100 WORKING-STORAGE SECTION.
002200 01  FILLER                  PIC  X(12)      VALUE '** WS-BEG **'.
002300*         I/O REQUEST BLOCK WORK AREAS
002400     COPY MBIOWS.
002500/         I/O REQUEST BLOCK
002600     COPY MBIORO.
002700/         DATE WORK AREAS
002800     COPY SS01WS.
002900/         ONLINE WORK AREAS
003000     COPY SS08WS.
003100/
003200     COPY SS00WS.
003300/
003400     COPY SMFTWS.
003500/
003600     COPY SMPTRL REPLACING ==:SMPT:== BY ==SMPT==.
003700/
003800     COPY MB61LK.
003900/
004000 01  WS-MISCELLANEOUS.
004100     03  WS-SAVE-EIBAID      PIC  X(01)      VALUE SPACES.
004200     03  WS-FWD-REQUEST      PIC  9(09)      VALUE ZEROES.
004300     03  WS-STATUS-CODE      PIC  9(01)      VALUE ZEROS.
004400     03  WS-SELECT-SW        PIC  X(01)      VALUE 'N'.
004500         88  WS-SELECT-NO                    VALUE 'N'.
004600         88  WS-SELECT-YES                   VALUE 'Y'.
004700     03  WS-BYPASS-SW        PIC  X(01)      VALUE 'N'.
004800         88  WS-BYPASS-NO                    VALUE 'N'.
004900         88  WS-BYPASS-YES                   VALUE 'Y'.
005000     03  TS-QUEUE-NAME.
005100         05  TS-QN-TERMID    PIC  X(04)      VALUE SPACES.
005200         05  TS-QN-TRANID    PIC  X(04)      VALUE 'MBDQ'.
005300*
005400 01  WS-DETAIL-LINE.
005500     03  WS-ORG              PIC  9(03).
005600     03  FILLER              PIC  X(02)      VALUE SPACES.
005700     03  WS-REQUEST-NBR      PIC  9(05).
005800     03  FILLER              PIC  X(03)      VALUE SPACES.
005900     03  WS-DESCRIPTION      PIC  X(30).
006000     03  FILLER              PIC  X(02)      VALUE SPACES.
006100     03  WS-LAST-RUN-DATE    PIC  X(10).
006200     03  FILLER              PIC  X(01)      VALUE SPACES.
006300     03  WS-MAINT-FLAG       PIC  X(01).
006400     03  FILLER              PIC  X(02)      VALUE SPACES.
006500     03  WS-ORIG-OPER        PIC  X(03).
006600     03  FILLER              PIC  X(02)      VALUE SPACES.
006700     03  WS-LAST-OPER        PIC  X(03).
006800     03  FILLER              PIC  X(02)      VALUE SPACES.
006900     03  WS-STATUS           PIC  9(01).
007000*
007100 01  FILLER                  PIC  X(12)      VALUE '** WS-END **'.
007200/
007300 LINKAGE SECTION.
007400 01  DFHCOMMAREA.
007500     COPY MB60WS.
007600/         EXAM DIRECTORY SCREEN 01 MAP DSECT
007700     COPY MBDQ01.
007800/         EXAM DIRECTORY SCREEN 01 MAP REDEFINITION
007900     COPY MBDQ01R.
008000/         EXAM MASTER RECORD LAYOUT
008100     COPY MMEXRL REPLACING ==:MMEX:== BY ==MMEX==.
008200/         EXAM DIRECTORY TEMPORARY STORAGE
008300     COPY MBDQTS.
008400/
008500 PROCEDURE DIVISION.
008600 0000-HOUSEKEEPING SECTION.
008700 0100-INIT.
008800*
008900     MOVE MBCA-EIBAID            TO WS-SAVE-EIBAID.
009000     SET MBCA-EIBAID-ENTER       TO TRUE.
009100*
009200     MOVE 'PC01'                 TO MBCA-PROGRAM-LOCATION.
009300     PERFORM MB70PD-ON-LINE-HOUSEKEEPING
009400                                 THRU MB70PD-OLH-EXIT.
009500*
009600     MOVE WS-SAVE-EIBAID         TO MBCA-EIBAID.
009700     MOVE MBCA-TERMINAL-ID       TO TS-QN-TERMID.
009800*
009900     IF  MBCA-RECEIVE-SCREEN
010000         GO TO 2000-RECEIVE-SCREEN.
010100*
010200 1000-SEND-SCREEN SECTION.
010300*
010400****************************************************************
010500*    GET CICS STORAGE NEEDED FOR THE MAP                       *
010600****************************************************************
010700*
010800     MOVE 'SC01'                 TO MBCA-PROGRAM-LOCATION.
010900     PERFORM MB60PD-GETMAIN-FOR-MAP
011000                                 THRU MB60PD-GFM-EXIT.
011100*
011200     MOVE MBCA-MBDQ-ORG          TO DQ01-ORG.
011300     MOVE MBCA-MBDQ-FIRST-REQUEST
011400                                 TO DQ01-REQUEST.
011500     MOVE 01                     TO MBCA-SCREEN-NBR.
011600*
011700****************************************************************
011800*    INITIALIZE THE STANDARD MAP LINES                         *
011900****************************************************************
012000*
012100     PERFORM MB60PD-INIT-STD-MAP-LINES
012200                                 THRU MB60PD-ISML-EXIT.
012300*
012400****************************************************************
012500*    ACQUIRE MAIN STORAGE FOR TEMP STORAGE RECORD              *
012600****************************************************************
012700*
012800     MOVE 'TS01'                 TO MBCA-PROGRAM-LOCATION.
012900     PERFORM 8100-TEMP-STORAGE-GETMAIN
013000                                 THRU 8199-TSG-EXIT.
013100*
013200     EXEC CICS HANDLE CONDITION
013300               QIDERR (1010-CHECK-RETURN-FLAG)
013400          END-EXEC.
013500*
013600***********************************************
013700*    READ THE TEMP STORAGE RECORD             *
013800***********************************************
013900*
014000     MOVE 'TS02'                 TO MBCA-PROGRAM-LOCATION.
014100     PERFORM 8200-TEMP-STORAGE-READ
014200                                 THRU 8299-TSR-EXIT.
014300*
014400***********************************************
014500*    DELETE THE TEMP STORAGE RECORD           *
014600***********************************************
014700*
014800     MOVE 'TS03'                 TO MBCA-PROGRAM-LOCATION.
014900     PERFORM 8300-TEMP-STORAGE-DELETE
015000                                 THRU 8399-TSD-EXIT.
015100*
015200     PERFORM 8800-BUILD-SCREEN   THRU 8899-BS-EXIT.
015300     GO TO 1080-CONTINUE.
015400*
015500 1010-CHECK-RETURN-FLAG.
015600*
015700     IF  MBCA-MBDQ-RETURN-BOTTOM
015800         PERFORM 8900-LAST-SCREEN
015900                                 THRU 8999-LS-EXIT
016000         IF  WS-BYPASS-YES
016100             GO TO 1015-READ-REQUEST
016200         ELSE
016300             GO TO 1080-CONTINUE
016400     ELSE
016500         IF  MBCA-MBDQ-RETURN-BWD
016600             PERFORM 9000-BACK-SCREEN
016700                                 THRU 9099-BS-EXIT
016800             IF  WS-BYPASS-YES
016900                 GO TO 1015-READ-REQUEST
017000             ELSE
017100                 GO TO 1080-CONTINUE.
017200*
017300 1015-READ-REQUEST.
017400*
017500****************************************************************
017600*    START BROWSE THE EXAM FILE                                *
017700****************************************************************
017800*
017900     MOVE 'FC01'                 TO MBCA-PROGRAM-LOCATION.
018000     MOVE MBCA-MBDQ-ORG          TO MBIOWS-MMEX-ORG.
018100     MOVE MBCA-MBDQ-FWD-REQUEST  TO MBIOWS-MMEX-REQUEST-NBR.
018200     SET MBIORO-STARTBR-GTE      TO TRUE.
018300     PERFORM MMEXAO-ACCESS       THRU MMEXAO-ACCESS-EXIT.
018400*
018500     SET X-DQ01-REQ-INDEX        TO +1.
018600*
018700 1020-READ-LOOP.
018800*
018900****************************************************************
019000*    READNEXT THE EXAM FILE                                    *
019100****************************************************************
019200*
019300     MOVE 'FC02'                 TO MBCA-PROGRAM-LOCATION.
019400     SET MBIORO-READ-SEQ         TO TRUE.
019500     PERFORM MMEXAO-ACCESS       THRU MMEXAO-ACCESS-EXIT.
019600*
019700     IF  MMEX-ORG IS GREATER THAN MBCA-MBDQ-ORG
019800         GO TO 1020-END-BROWSE.
019900*
020000     PERFORM 9500-BUILD-SCREEN-LINE
020100                                 THRU 9599-BSL-EXIT.
020200*
020300     IF  X-DQ01-REQ-INDEX IS EQUAL TO +1
020400         MOVE MMEX-REQUEST-NBR   TO MBCA-MBDQ-BACK-REQUEST.
020500*
020600     IF  X-DQ01-REQ-INDEX IS LESS THAN +15
020700         SET X-DQ01-REQ-INDEX    UP BY +1
020800         GO TO 1020-READ-LOOP
020900     ELSE
021000         MOVE MMEX-REQUEST-NBR   TO MBCA-MBDQ-FWD-REQUEST
021100         PERFORM 9400-READ-AHEAD THRU 9499-RA-EXIT
021200         SET X-DQ01-REQ-INDEX    UP BY +1.
021300*
021400 1020-END-BROWSE.
021500*
021600****************************************************************
021700*    END BROWSE THE EXAM FILE                                  *
021800****************************************************************
021900*
022000     MOVE 'FC03'                 TO MBCA-PROGRAM-LOCATION.
022100     SET MBIORO-ENDBR            TO TRUE.
022200     PERFORM MMEXAO-ACCESS      THRU MMEXAO-ACCESS-EXIT.
022300*
022400 1060-SET-ATTRIBUTE.
022500*
022600     IF  X-DQ01-REQ-INDEX IS EQUAL TO +1
022700         IF  MBCA-MBDQ-RETURN-NORMAL
022800             SET MBCA-INITIAL-SCREEN-NBR
022900                                 TO TRUE
023000             MOVE 'PC02'         TO MBCA-PROGRAM-LOCATION
023100             PERFORM MB70PD-XCTL-TO-MBOXCTL
023200                                 THRU MB70PD-XTM-EXIT
023300         ELSE
023400             MOVE MBCA-MBDQ-BACK-REQUEST
023500                                 TO MBCA-MBDQ-FWD-REQUEST
023600             GO TO 1015-READ-REQUEST.
023700*
023800     IF  X-DQ01-REQ-INDEX IS LESS THAN +16
023900         SET X-MBDQTS-INDEX      TO X-DQ01-REQ-INDEX
024000         MOVE ZEROS              TO MBCA-MBDQ-FWD-REQUEST
024100                                    WS-FWD-REQUEST
024200                                    MBDQTS-REQUEST
024300                                    (X-MBDQTS-INDEX)
024400                                    MBDQTS-STATUS-CODE
024500                                    (X-MBDQTS-INDEX)
024600         MOVE SPACES             TO MBDQTS-DESCRIPTION
024700                                    (X-MBDQTS-INDEX)
024800                                    MBDQTS-LAST-RUN-DATE
024900                                    (X-MBDQTS-INDEX)
025000                                    MBDQTS-ORIG-OPER
025100                                    (X-MBDQTS-INDEX)
025200                                    MBDQTS-LAST-OPER
025300                                    (X-MBDQTS-INDEX)
025400         MOVE DFHBMASK           TO DQ01-SELECT-A
025500                                    (X-DQ01-REQ-INDEX)
025600         MOVE DFHBMDAS           TO DQ01-DIRECTORY-LINE-A
025700                                    (X-DQ01-REQ-INDEX)
025800                                    DQ01-SELECT-LP-A
025900                                    (X-DQ01-REQ-INDEX)
026000                                    DQ01-SELECT-RP-A
026100                                    (X-DQ01-REQ-INDEX)
026200         SET X-DQ01-REQ-INDEX    UP BY +1
026300         GO TO 1060-SET-ATTRIBUTE.
026400*
026500 1080-CONTINUE.
026600*
026700     IF  MBCA-MBDQ-BACK-REQUEST IS NOT EQUAL
026800                                 TO MBCA-MBDQ-FIRST-REQUEST
026900         MOVE DFHBMASB           TO DQ01-FWD-BACK-IND-A (1).
027000*
027100     IF  WS-FWD-REQUEST IS NOT EQUAL TO ZEROES
027200         MOVE DFHBMASB           TO DQ01-FWD-BACK-IND-A (15).
027300*
027400****************************************************************
027500*    WRITE THE TEMP STORAGE RECORD                             *
027600****************************************************************
027700*
027800     MOVE 'TS04'                 TO MBCA-PROGRAM-LOCATION.
027900     PERFORM 8400-WRITE-QUEUE    THRU 8499-WQ-EXIT.
028000*
028100     PERFORM 9100-SET-ATTRIBUTE  THRU 9199-SA-EXIT
028200         VARYING X-DQ01-REQ-INDEX FROM +1 BY +1
028300         UNTIL   X-DQ01-REQ-INDEX IS GREATER THAN +15.
028400*
028500     SET X-DQ01-REQ-INDEX        TO +1.
028600*
028700 1090-CURSOR-LOOP.
028800*
028900     IF  X-DQ01-REQ-INDEX IS GREATER THAN +15
029000         MOVE SS08WS-CURSOR      TO DQ01-ALT-TRANID-L
029100         GO TO 1100-CONTINUE.
029200*
029300     IF  DQ01-SELECT-A (X-DQ01-REQ-INDEX)
029400                                 IS EQUAL TO DFHBMASK
029500         SET X-DQ01-REQ-INDEX    UP BY +1
029600         GO TO 1090-CURSOR-LOOP
029700     ELSE
029800         MOVE SS08WS-CURSOR      TO DQ01-SELECT-L
029900                                    (X-DQ01-REQ-INDEX).
030000*
030100 1100-CONTINUE.
030200*
030300     MOVE '*TOP*'                TO SS08WS-LINE-24-PF-KEY-FUNC(3).
030400     MOVE '*BOT*'                TO SS08WS-LINE-24-PF-KEY-FUNC(4).
030500     MOVE '*FWD*'                TO SS08WS-LINE-24-PF-KEY-FUNC(5).
030600     MOVE '*BWD*'                TO SS08WS-LINE-24-PF-KEY-FUNC(6).
030700     MOVE SS08WS-LINE-24         TO DQ01-PF-KEYS.
030800     MOVE 'RESV'                 TO MBCA-PGMX-PF-TRANS-ID (3).
030900     MOVE 'RESV'                 TO MBCA-PGMX-PF-TRANS-ID (4).
031000     MOVE 'RESV'                 TO MBCA-PGMX-PF-TRANS-ID (5).
031100     MOVE 'RESV'                 TO MBCA-PGMX-PF-TRANS-ID (6).
031200*
031300     MOVE DFHBMASK               TO DQ01-CURRENT-PAGE-A.
031400*
031500****************************************************************
031600*    SEND THE MAP                                              *
031700****************************************************************
031800*
031900     MOVE 'BM01'                 TO MBCA-PROGRAM-LOCATION.
032000     PERFORM MB60PD-SEND-MAP-WITH-ERASE
032100                                 THRU MB60PD-SMWE-EXIT.
032200*
032300****************************************************************
032400*    RETURN TO CICS                                            *
032500****************************************************************
032600*
032700     MOVE 'PC03'                 TO MBCA-PROGRAM-LOCATION.
032800     PERFORM MB70PD-RETURN-TRANS-ID
032900                                 THRU MB70PD-RTI-EXIT.
033000/
033100 2000-RECEIVE-SCREEN SECTION.
033200*
033300     IF  MBCA-EIBAID-CLEAR
033400         MOVE 'TS05'             TO MBCA-PROGRAM-LOCATION
033500         PERFORM 8300-TEMP-STORAGE-DELETE
033600                                 THRU 8399-TSD-EXIT
033700         MOVE 'PC04'             TO MBCA-PROGRAM-LOCATION
033800         PERFORM MB70PD-ON-LINE-HOUSEKEEPING
033900                                 THRU MB70PD-OLH-EXIT.
034000*
034100****************************************************************
034200*    THIS SECTION RECEIVES THE 01 SCREEN                       *
034300****************************************************************
034400*
034500     MOVE 'BM02'                 TO MBCA-PROGRAM-LOCATION.
034600     PERFORM MB60PD-RECEIVE-MAP  THRU MB60PD-RM-EXIT.
034700*
034800*****************************************************
034900*    ACQUIRE MAIN STORAGE FOR TEMP STORAGE RECORD   *
035000*****************************************************
035100*
035200     MOVE 'TS06'                 TO MBCA-PROGRAM-LOCATION.
035300     PERFORM 8100-TEMP-STORAGE-GETMAIN
035400                                 THRU 8199-TSG-EXIT.
035500*
035600***********************************************
035700*    READ THE TEMP STORAGE RECORD             *
035800***********************************************
035900*
036000     MOVE 'TS07'                 TO MBCA-PROGRAM-LOCATION.
036100     PERFORM 8200-TEMP-STORAGE-READ
036200                                 THRU 8299-TSR-EXIT.
036300*
036400***********************************************
036500*    DELETE THE TEMP STORAGE RECORD           *
036600***********************************************
036700*
036800     MOVE 'TS08'                 TO MBCA-PROGRAM-LOCATION.
036900     PERFORM 8300-TEMP-STORAGE-DELETE
037000                                 THRU 8399-TSD-EXIT.
037100*
037200****************************************************************
037300*    CHECK FOR ANOTHER TRANSACTION ID ENTERED BY THE USER      *
037400****************************************************************
037500*
037600     MOVE 'PC05'                 TO MBCA-PROGRAM-LOCATION.
037700     PERFORM MB60PD-NEW-TRANS-ROUTINE
037800                                 THRU MB60PD-NTR-EXIT.
037900*
038000 2005-EDIT-SELECT.
038100*
038200****************************************************************
038300*    EDIT SELECT FIELD                                         *
038400****************************************************************
038500*
038600     PERFORM 8600-EDIT-SELECT    THRU 8699-ES-EXIT.
038700*
038800 2090-CHECK-ERROR.
038900*
039000     IF  SS08WS-ERROR-SW-NO
039100         GO TO 2400-CHECK-SELECT.
039200*
039300 2300-SEND-MAP.
039400*
039500***********************************************
039600*    WRITE THE TEMP STORAGE RECORD            *
039700***********************************************
039800*
039900     MOVE 'TS09'                 TO MBCA-PROGRAM-LOCATION.
040000     PERFORM 8400-WRITE-QUEUE    THRU 8499-WQ-EXIT.
040100*
040200****************************************************************
040300*    SEND THE MAP                                              *
040400****************************************************************
040500*
040600     PERFORM MB60PD-INIT-STD-MAP-LINES
040700                                 THRU MB60PD-ISML-EXIT.
040800*
040900     MOVE '*TOP*'                TO SS08WS-LINE-24-PF-KEY-FUNC(3).
041000     MOVE '*BOT*'                TO SS08WS-LINE-24-PF-KEY-FUNC(4).
041100     MOVE '*FWD*'                TO SS08WS-LINE-24-PF-KEY-FUNC(5).
041200     MOVE '*BWD*'                TO SS08WS-LINE-24-PF-KEY-FUNC(6).
041300     MOVE SS08WS-LINE-24         TO DQ01-PF-KEYS.
041400     MOVE 'RESV'                 TO MBCA-PGMX-PF-TRANS-ID (3).
041500     MOVE 'RESV'                 TO MBCA-PGMX-PF-TRANS-ID (4).
041600     MOVE 'RESV'                 TO MBCA-PGMX-PF-TRANS-ID (5).
041700     MOVE 'RESV'                 TO MBCA-PGMX-PF-TRANS-ID (6).
041800*
041900     MOVE DFHBMASK               TO DQ01-CURRENT-PAGE-A.
042000*
042100     MOVE 'BM03'                 TO MBCA-PROGRAM-LOCATION.
042200     PERFORM MB60PD-SEND-MAP-DATA-ONLY
042300                                 THRU MB60PD-SMDO-EXIT.
042400*
042500****************************************************************
042600*    RETURN TO CICS                                            *
042700****************************************************************
042800*
042900     MOVE 'PC06'                 TO MBCA-PROGRAM-LOCATION.
043000     PERFORM MB70PD-RETURN-TRANS-ID
043100                                 THRU MB70PD-RTI-EXIT.
043200/
043300 2400-CHECK-SELECT.
043400*
043500     IF  WS-SELECT-YES
043600         SET X-MBDQTS-INDEX      TO X-DQ01-REQ-INDEX
043700         MOVE MBDQTS-REQUEST (X-MBDQTS-INDEX)
043800                                 TO MBCA-REQUEST-NBR
043900         MOVE MBIOWS-MMEX-DIRECT-KEY-CODE
044000                                 TO MBCA-KEY-CODE
044100         SET MBCA-INITIAL-SCREEN-NBR
044200                                 TO TRUE
044300         IF  DQ01-VALID-INQUIRY (X-DQ01-REQ-INDEX)
044400             MOVE '..QQ'         TO SS08WS-WORK-TRANS-ID
044500             GO TO 2690-PF-KEY-BYPASS
044600         ELSE
044700             IF  DQ01-VALID-MAINT (X-DQ01-REQ-INDEX)
044800                 MOVE '..MQ'     TO SS08WS-WORK-TRANS-ID
044900                 GO TO 2690-PF-KEY-BYPASS.
045000/
045100 2600-SETUP-COMMAREA.
045200*
045300****************************************************************
045400*    SET UP COMMAREA FIELDS AND TRANSFER TO THE NEXT PROGRAM   *
045500****************************************************************
045600*
045700     MOVE MBCA-EIBAID            TO SS08WS-EIBAID.
045800*
045900     IF  SS08WS-VALID-PF3
046000     OR  SS08WS-EIBAID-VALID-PF3
046100         MOVE 51                 TO MBCA-SCREEN-NBR
046200         MOVE MBCA-MBDQ-FIRST-REQUEST
046300                                 TO MBCA-MBDQ-FWD-REQUEST
046400         SET MBCA-MBDQ-RETURN-NORMAL
046500                                 TO TRUE
046600         GO TO 2690-PF-KEY-BYPASS.
046700*
046800     IF  SS08WS-VALID-PF4
046900     OR  SS08WS-EIBAID-VALID-PF4
047000         MOVE 51                 TO MBCA-SCREEN-NBR
047100         IF (MBDQTS-REQUEST (1) IS GREATER THAN ZEROES
047200         AND MBDQTS-REQUEST (15) IS EQUAL TO ZEROES)
047300         OR (MBCA-MBDQ-FWD-REQUEST IS EQUAL TO ZEROES)
047400             SET MBCA-MBDQ-RETURN-NORMAL
047500                                 TO TRUE
047600             MOVE ZEROES         TO MBCA-MBDQ-FWD-REQUEST
047700             MOVE 'TS10'         TO MBCA-PROGRAM-LOCATION
047800             PERFORM 8400-WRITE-QUEUE
047900                                 THRU 8499-WQ-EXIT
048000             GO TO 2690-PF-KEY-BYPASS
048100         ELSE
048200             SET MBCA-MBDQ-RETURN-BOTTOM
048300                                 TO TRUE
048400             GO TO 2690-PF-KEY-BYPASS.
048500*
048600     IF  SS08WS-VALID-PF5
048700     OR  SS08WS-EIBAID-VALID-PF5
048800         MOVE 51                 TO MBCA-SCREEN-NBR
048900         IF (MBDQTS-REQUEST (1) IS GREATER THAN ZEROES
049000         AND MBDQTS-REQUEST (15) IS EQUAL TO ZEROES)
049100         OR (MBCA-MBDQ-FWD-REQUEST IS EQUAL TO ZEROES)
049200             SET MBCA-MBDQ-RETURN-NORMAL
049300                                 TO TRUE
049400             MOVE ZEROES         TO MBCA-MBDQ-FWD-REQUEST
049500             MOVE 'TS11'         TO MBCA-PROGRAM-LOCATION
049600             PERFORM 8400-WRITE-QUEUE
049700                                 THRU 8499-WQ-EXIT
049800             GO TO 2690-PF-KEY-BYPASS
049900         ELSE
050000             SET MBCA-MBDQ-RETURN-FWD
050100                                 TO TRUE
050200             ADD 1               TO MBCA-MBDQ-FWD-REQUEST
050300             GO TO 2690-PF-KEY-BYPASS.
050400*
050500     IF  SS08WS-VALID-PF6
050600     OR  SS08WS-EIBAID-VALID-PF6
050700         MOVE 51                 TO MBCA-SCREEN-NBR
050800         IF  MBCA-MBDQ-BACK-REQUEST IS EQUAL
050900                                 TO MBCA-MBDQ-FIRST-REQUEST
051000             SET MBCA-MBDQ-RETURN-NORMAL
051100                                 TO TRUE
051200             MOVE 'TS12'         TO MBCA-PROGRAM-LOCATION
051300             PERFORM 8400-WRITE-QUEUE
051400                                 THRU 8499-WQ-EXIT
051500             GO TO 2690-PF-KEY-BYPASS
051600         ELSE
051700             MOVE MBCA-MBDQ-BACK-REQUEST
051800                                 TO MBCA-MBDQ-FWD-REQUEST
051900             SET MBCA-MBDQ-RETURN-BWD
052000                                 TO TRUE
052100             GO TO 2690-PF-KEY-BYPASS.
052200*
052300     IF  SS08WS-VALID-PF-KEY
052400     OR  SS08WS-EIBAID-VALID-PF-KEY
052500     OR  MBDQTS-REQUEST (15) IS EQUAL TO ZEROES
052600     OR  MBCA-MBDQ-FWD-REQUEST IS EQUAL TO ZEROES
052700         SET MBCA-INITIAL-SCREEN-NBR
052800                                 TO TRUE
052900         MOVE MBIOWS-MMEX-KEY-CODE
053000                                 TO MBCA-KEY-CODE
053100         SET MBCA-MBDQ-RETURN-NORMAL
053200                                 TO TRUE
053300         GO TO 2690-PF-KEY-BYPASS.
053400*
053500     MOVE 51                     TO MBCA-SCREEN-NBR.
053600     ADD 1                       TO MBCA-MBDQ-FWD-REQUEST.
053700     SET MBCA-MBDQ-RETURN-NORMAL TO TRUE.
053800*
053900 2690-PF-KEY-BYPASS.
054000*
054100     MOVE 'PC07'                 TO MBCA-PROGRAM-LOCATION.
054200     PERFORM MB70PD-XCTL-TO-MBOXCTL
054300                                 THRU MB70PD-XTM-EXIT.
054400/
054500 8000-PERFORMED-ROUTINES-SECT SECTION.
054600*
054700 8100-TEMP-STORAGE-GETMAIN.
054800*
054900     EXEC CICS GETMAIN
055000               FLENGTH (LENGTH  OF MBDQTS-RECORD)
055100               SET     (ADDRESS OF MBDQTS-RECORD)
055200          END-EXEC.
055300*
055400 8199-TSG-EXIT.
055500     EXIT.
055600*
055700 8200-TEMP-STORAGE-READ.
055800*
055900     EXEC CICS READQ TS
056000               QUEUE   (TS-QUEUE-NAME)
056100               INTO    (MBDQTS-RECORD)
056200               LENGTH  (LENGTH  OF MBDQTS-RECORD)
056300               ITEM    (1)
056400          END-EXEC.
056500*
056600 8299-TSR-EXIT.
056700     EXIT.
056800*
056900 8300-TEMP-STORAGE-DELETE.
057000*
057100     EXEC CICS IGNORE CONDITION
057200               QIDERR
057300          END-EXEC.
057400*
057500     EXEC CICS DELETEQ TS
057600               QUEUE  (TS-QUEUE-NAME)
057700          END-EXEC.
057800*
057900 8399-TSD-EXIT.
058000     EXIT.
058100*
058200 8400-WRITE-QUEUE.
058300*
058400     EXEC CICS WRITEQ TS
058500               QUEUE   (TS-QUEUE-NAME)
058600               FROM    (MBDQTS-RECORD)
058700               LENGTH  (LENGTH  OF MBDQTS-RECORD)
058800          END-EXEC.
058900*
059000 8499-WQ-EXIT.
059100     EXIT.
059200*
059300 8600-EDIT-SELECT.
059400*
059500     SET X-DQ01-REQ-INDEX        TO +1.
059600*
059700 8600-EDIT-LOOP.
059800*
059900     IF  DQ01-SELECT-L (X-DQ01-REQ-INDEX) IS GREATER THAN ZERO
060000         IF  DQ01-VALID-SELECT (X-DQ01-REQ-INDEX)
060100             MOVE DFHBMASF       TO DQ01-SELECT-A
060200                                    (X-DQ01-REQ-INDEX)
060300             MOVE DFHBMDAS       TO DQ01-SELECT-LP-A
060400                                    (X-DQ01-REQ-INDEX)
060500                                    DQ01-SELECT-RP-A
060600                                    (X-DQ01-REQ-INDEX)
060700             IF  DQ01-VALID-INQUIRY-MAINT (X-DQ01-REQ-INDEX)
060800                 SET WS-SELECT-YES
060900                                 TO TRUE
061000                 GO TO 8699-ES-EXIT
061100             ELSE
061200                 NEXT SENTENCE
061300         ELSE
061400             SET SS08WS-ERROR-SW-YES TO TRUE
061500             MOVE SS08WS-CURSOR  TO DQ01-SELECT-L
061600                                    (X-DQ01-REQ-INDEX)
061700             MOVE DFHBMUBF       TO DQ01-SELECT-A
061800                                    (X-DQ01-REQ-INDEX)
061900             MOVE DFHBMASB       TO DQ01-SELECT-LP-A
062000                                    (X-DQ01-REQ-INDEX)
062100                                    DQ01-SELECT-RP-A
062200                                    (X-DQ01-REQ-INDEX)
062300             GO TO 8699-ES-EXIT.
062400*
062500     IF  X-DQ01-REQ-INDEX IS LESS THAN +15
062600         SET X-DQ01-REQ-INDEX    UP BY +1
062700         GO TO 8600-EDIT-LOOP.
062800*
062900 8699-ES-EXIT.
063000     EXIT.
063100*
063200 8800-BUILD-SCREEN.
063300*
063400     SET X-DQ01-REQ-INDEX        TO +1.
063500*
063600 8800-BUILD-LOOP.
063700*
063800     SET X-MBDQTS-INDEX          TO X-DQ01-REQ-INDEX.
063900*
064000     IF  MBDQTS-REQUEST (X-MBDQTS-INDEX)
064100                                 IS GREATER THAN ZEROES
064200         MOVE MBDQTS-ORG (X-MBDQTS-INDEX)
064300                                 TO WS-ORG
064400         MOVE MBDQTS-REQUEST (X-MBDQTS-INDEX)
064500                                 TO WS-REQUEST-NBR
064600         MOVE MBDQTS-DESCRIPTION (X-MBDQTS-INDEX)
064700                                 TO WS-DESCRIPTION
064800         MOVE MBDQTS-LAST-RUN-DATE (X-MBDQTS-INDEX)
064900                                 TO WS-LAST-RUN-DATE
065000         MOVE MBDQTS-MAINT-FLAG (X-MBDQTS-INDEX)
065100                                 TO WS-MAINT-FLAG
065200         MOVE MBDQTS-ORIG-OPER (X-MBDQTS-INDEX)
065300                                 TO WS-ORIG-OPER
065400         MOVE MBDQTS-LAST-OPER (X-MBDQTS-INDEX)
065500                                 TO WS-LAST-OPER
065600         MOVE MBDQTS-STATUS-CODE (X-MBDQTS-INDEX)
065700                                 TO WS-STATUS-CODE
065800         MOVE WS-DETAIL-LINE     TO DQ01-DIRECTORY-LINE
065900                                    (X-DQ01-REQ-INDEX)
066000     ELSE
066100         MOVE DFHBMASK           TO DQ01-SELECT-A
066200                                    (X-DQ01-REQ-INDEX)
066300         MOVE DFHBMDAS           TO DQ01-DIRECTORY-LINE-A
066400                                    (X-DQ01-REQ-INDEX)
066500                                    DQ01-SELECT-LP-A
066600                                    (X-DQ01-REQ-INDEX)
066700                                    DQ01-SELECT-RP-A
066800                                    (X-DQ01-REQ-INDEX).
066900*
067000     IF  X-DQ01-REQ-INDEX IS LESS THAN +15
067100         SET X-DQ01-REQ-INDEX    UP BY +1
067200         GO TO 8800-BUILD-LOOP
067300     ELSE
067400         MOVE MBCA-MBDQ-FWD-REQUEST
067500                                 TO WS-FWD-REQUEST.
067600*
067700 8899-BS-EXIT.
067800     EXIT.
067900*
068000 8900-LAST-SCREEN.
068100*
068200****************************************************************
068300*    START BROWSE THE EXAM FILE                                *
068400****************************************************************
068500*
068600     MOVE 'FC04'                 TO MBCA-PROGRAM-LOCATION.
068700     MOVE MBCA-MBDQ-ORG          TO MBIOWS-MMEX-ORG.
068800     MOVE 999999999              TO MBIOWS-MMEX-REQUEST-NBR.
068900     SET MBIORO-STARTBR-GTE      TO TRUE.
069000     PERFORM MMEXAO-ACCESS       THRU MMEXAO-ACCESS-EXIT.
069100*
069200****************************************************************
069300*    READNEXT THE EXAM FILE                                    *
069400****************************************************************
069500*
069600     MOVE 'FC05'                 TO MBCA-PROGRAM-LOCATION.
069700     SET MBIORO-READ-SEQ         TO TRUE.
069800     PERFORM MMEXAO-ACCESS       THRU MMEXAO-ACCESS-EXIT.
069900*
070000****************************************************************
070100*    READPREV THE EXAM FILE                                    *
070200****************************************************************
070300*
070400     MOVE 'FC06'                 TO MBCA-PROGRAM-LOCATION.
070500     SET MBIORO-READ-PREV        TO TRUE.
070600     PERFORM MMEXAO-ACCESS       THRU MMEXAO-ACCESS-EXIT.
070700*
070800     SET X-DQ01-REQ-INDEX        TO +15.
070900     SET WS-BYPASS-NO            TO TRUE.
071000*
071100 8900-READ-EXAM-FILE.
071200*
071300****************************************************************
071400*    READPREV THE EXAM FILE                                    *
071500****************************************************************
071600*
071700     MOVE 'FC07'                 TO MBCA-PROGRAM-LOCATION.
071800     SET MBIORO-READ-PREV        TO TRUE.
071900     PERFORM MMEXAO-ACCESS       THRU MMEXAO-ACCESS-EXIT.
072000*
072100 8900-BUILD-LOOP.
072200*
072300     IF  MMEX-ORG IS LESS THAN MBCA-MBDQ-ORG
072400     OR  MMEX-REQUEST-NBR IS LESS THAN MBCA-MBDQ-FIRST-REQUEST
072500         GO TO 8900-END-BROWSE.
072600*
072700     IF  MMEX-REQUEST-NBR IS EQUAL TO MBCA-MBDQ-FIRST-REQUEST
072800     AND X-DQ01-REQ-INDEX IS GREATER THAN +1
072900         SET MBCA-MBDQ-RETURN-NORMAL
073000                                 TO TRUE
073100         MOVE MBCA-MBDQ-FIRST-REQUEST
073200                                 TO MBCA-MBDQ-FWD-REQUEST
073300         SET WS-BYPASS-YES       TO TRUE
073400         GO TO 8900-END-BROWSE.
073500*
073600     PERFORM 9500-BUILD-SCREEN-LINE
073700                                 THRU 9599-BSL-EXIT.
073800*
073900     IF  X-DQ01-REQ-INDEX IS GREATER THAN +1
074000         SET X-DQ01-REQ-INDEX    DOWN BY +1
074100         GO TO 8900-READ-EXAM-FILE
074200     ELSE
074300         MOVE MMEX-REQUEST-NBR   TO MBCA-MBDQ-BACK-REQUEST.
074400*
074500 8900-END-BROWSE.
074600*
074700****************************************************************
074800*    END BROWSE THE EXAM FILE                                  *
074900****************************************************************
075000*
075100     MOVE 'FC08'                 TO MBCA-PROGRAM-LOCATION.
075200     SET MBIORO-ENDBR            TO TRUE.
075300     PERFORM MMEXAO-ACCESS       THRU MMEXAO-ACCESS-EXIT.
075400*
075500     IF  WS-BYPASS-YES
075600         GO TO 8999-LS-EXIT.
075700*
075800     MOVE ZEROES                 TO MBCA-MBDQ-FWD-REQUEST
075900                                    WS-FWD-REQUEST.
076000*
076100 8999-LS-EXIT.
076200     EXIT.
076300*
076400 9000-BACK-SCREEN.
076500*
076600****************************************************************
076700*    START BROWSE THE EXAM FILE                                *
076800****************************************************************
076900*
077000     MOVE 'FC09'                 TO MBCA-PROGRAM-LOCATION.
077100     MOVE MBCA-MBDQ-ORG          TO MBIOWS-MMEX-ORG.
077200     MOVE MBCA-MBDQ-FWD-REQUEST  TO MBIOWS-MMEX-REQUEST-NBR.
077300     SET MBIORO-STARTBR-GTE      TO TRUE.
077400     PERFORM MMEXAO-ACCESS       THRU MMEXAO-ACCESS-EXIT.
077500*
077600****************************************************************
077700*    READNEXT THE EXAM FILE                                    *
077800****************************************************************
077900*
078000     MOVE 'FC10'                 TO MBCA-PROGRAM-LOCATION.
078100     SET MBIORO-READ-SEQ         TO TRUE.
078200     PERFORM MMEXAO-ACCESS       THRU MMEXAO-ACCESS-EXIT.
078300*
078400****************************************************************
078500*    READPREV THE EXAM FILE                                    *
078600****************************************************************
078700*
078800     MOVE 'FC11'                 TO MBCA-PROGRAM-LOCATION.
078900     SET MBIORO-READ-PREV        TO TRUE.
079000     PERFORM MMEXAO-ACCESS       THRU MMEXAO-ACCESS-EXIT.
079100*
079200     SET X-DQ01-REQ-INDEX        TO +15.
079300     SET WS-BYPASS-NO            TO TRUE.
079400*
079500 9000-READ-EXAM-FILE.
079600*
079700****************************************************************
079800*    READPREV THE EXAM FILE                                    *
079900****************************************************************
080000*
080100     MOVE 'FC12'                 TO MBCA-PROGRAM-LOCATION.
080200     SET MBIORO-READ-PREV        TO TRUE.
080300     PERFORM MMEXAO-ACCESS       THRU MMEXAO-ACCESS-EXIT.
080400*
080500 9000-BUILD-LOOP.
080600*
080700     IF  X-DQ01-REQ-INDEX IS GREATER THAN +1
080800     AND MMEX-REQUEST-NBR IS EQUAL TO MBCA-MBDQ-FIRST-REQUEST
080900         SET MBCA-MBDQ-RETURN-NORMAL
081000                                 TO TRUE
081100         MOVE MBCA-MBDQ-FIRST-REQUEST
081200                                 TO MBCA-MBDQ-FWD-REQUEST
081300         SET WS-BYPASS-YES       TO TRUE
081400         GO TO 9000-END-BROWSE.
081500*
081600     IF  MMEX-REQUEST-NBR IS EQUAL TO MBCA-MBDQ-BACK-REQUEST
081700     AND X-DQ01-REQ-INDEX IS EQUAL TO +15
081800         GO TO 9000-READ-EXAM-FILE.
081900*
082000     PERFORM 9500-BUILD-SCREEN-LINE
082100                                 THRU 9599-BSL-EXIT.
082200*
082300     IF  X-DQ01-REQ-INDEX IS EQUAL TO +15
082400         MOVE MMEX-REQUEST-NBR   TO MBCA-MBDQ-FWD-REQUEST
082500                                    WS-FWD-REQUEST.
082600*
082700     IF  X-DQ01-REQ-INDEX IS GREATER THAN +1
082800         SET X-DQ01-REQ-INDEX    DOWN BY +1
082900         GO TO 9000-READ-EXAM-FILE
083000     ELSE
083100         MOVE MMEX-REQUEST-NBR   TO MBCA-MBDQ-BACK-REQUEST.
083200*
083300 9000-END-BROWSE.
083400*
083500****************************************************************
083600*    END BROWSE THE EXAM FILE                                  *
083700****************************************************************
083800*
083900     MOVE 'FC13'                 TO MBCA-PROGRAM-LOCATION.
084000     SET MBIORO-ENDBR            TO TRUE.
084100     PERFORM MMEXAO-ACCESS       THRU MMEXAO-ACCESS-EXIT.
084200*
084300 9099-BS-EXIT.
084400     EXIT.
084500*
084600 9100-SET-ATTRIBUTE.
084700*
084800     SET X-MBDQTS-INDEX          TO X-DQ01-REQ-INDEX.
084900*
085000     IF  MBDQTS-STATUS-INCOMPLETE   (X-MBDQTS-INDEX)
085100     OR  MBDQTS-STATUS-PURGE        (X-MBDQTS-INDEX)
085200         MOVE DFHBMASK           TO DQ01-SELECT-A
085300                                    (X-DQ01-REQ-INDEX)
085400         MOVE DFHBMDAS           TO DQ01-SELECT-LP-A
085500                                    (X-DQ01-REQ-INDEX)
085600                                    DQ01-SELECT-RP-A
085700                                    (X-DQ01-REQ-INDEX).
085800*
085900 9199-SA-EXIT.
086000     EXIT.
086100*
086200 9400-READ-AHEAD.
086300*
086400****************************************************************
086500*    READNEXT THE EXAM FILE                                    *
086600****************************************************************
086700*
086800     MOVE 'FC14'                 TO MBCA-PROGRAM-LOCATION.
086900     SET MBIORO-READ-SEQ         TO TRUE.
087000     PERFORM MMEXAO-ACCESS       THRU MMEXAO-ACCESS-EXIT.
087100*
087200     IF  MMEX-ORG IS GREATER THAN MBCA-MBDQ-ORG
087300         MOVE ZEROES             TO WS-FWD-REQUEST
087400                                    MBCA-MBDQ-FWD-REQUEST
087500         GO TO 9499-RA-EXIT.
087600*
087700     MOVE MMEX-REQUEST-NBR       TO WS-FWD-REQUEST.
087800*
087900 9499-RA-EXIT.
088000     EXIT.
088100*
088200 9500-BUILD-SCREEN-LINE.
088300*
088400     SET X-MBDQTS-INDEX          TO X-DQ01-REQ-INDEX.
088500*
088600     MOVE MMEX-ORG               TO WS-ORG
088700                                    MBDQTS-ORG
088800                                    (X-MBDQTS-INDEX).
088900*
089000     MOVE MMEX-REQUEST-NBR       TO WS-REQUEST-NBR
089100                                    MBDQTS-REQUEST
089200                                    (X-MBDQTS-INDEX).
089300*
089400     MOVE MMEX-DESC              TO WS-DESCRIPTION
089500                                    MBDQTS-DESCRIPTION
089600                                    (X-MBDQTS-INDEX).
089700*
089800     MOVE SPACES                 TO SS01WS-EDIT-X.
089900     MOVE MMEX-LAST-RUN-DATE     TO SS01WS-JULIAN.
090000     PERFORM SS26PD-NUMERICALLY-EDIT-DATE
090100        THRU SS26PD-NED-EXIT.
090200     MOVE SS01WS-XX-XX-YYYY      TO WS-LAST-RUN-DATE
090300                                    MBDQTS-LAST-RUN-DATE
090400                                    (X-MBDQTS-INDEX).
090500*
090600     IF  MMEX-LAST-PROC-REQUEST-ON
090700         MOVE 'M'                TO WS-MAINT-FLAG
090800                                    MBDQTS-MAINT-FLAG
090900                                    (X-MBDQTS-INDEX)
091000     ELSE
091100         MOVE SPACES             TO WS-MAINT-FLAG
091200                                    MBDQTS-MAINT-FLAG
091300                                    (X-MBDQTS-INDEX).
091400*
091500     MOVE MMEX-ORIG-OPER         TO WS-ORIG-OPER
091600                                    MBDQTS-ORIG-OPER
091700                                    (X-MBDQTS-INDEX).
091800*
091900     MOVE MMEX-LAST-OPER         TO WS-LAST-OPER
092000                                    MBDQTS-LAST-OPER
092100                                    (X-MBDQTS-INDEX).
092200*
092300     MOVE MMEX-REC-STATUS        TO WS-STATUS
092400                                    MBDQTS-STATUS-CODE
092500                                    (X-MBDQTS-INDEX).
092600*
092700     MOVE WS-DETAIL-LINE         TO DQ01-DIRECTORY-LINE
092800                                    (X-DQ01-REQ-INDEX).
092900*
093000 9599-BSL-EXIT.
093100     EXIT.
093200/         JULIAN TO GREGORIAN DATE ROUTINE
093300     COPY SS08PD.
093400/
093500     COPY SS26PD.
093600/
093700     COPY SS27PD.
093800/         LINE 24 PF KEYS ROUTINE
093900     COPY SS15PD.
094000/         EXAM RECORD ACCESS ROUTINES
094100     COPY MMEXAO.
094200/         ON-LINE MAP ROUTINES
094300     COPY MB60PD REPLACING 'MBMAPXX' BY 'MBDQ01 '
094400                           MBMAPXXI BY MBDQ01I
094500                           MBMAPXXO BY MBDQ01O.
094600/         ON-LINE PROCEDURES
094700     COPY MB70PD.
094800/
094900     COPY SMFTPXO.
