000100 IDENTIFICATION DIVISION.
000200 PROGRAM-ID. MBODR00.
000201*       RELEASE DATE=08/24/01.        REVISION LEVEL=08.06      *
000202*****************************************************************
000203*WARNING.  THIS COMPUTER PROGRAM IS PROTECTED BY COPYRIGHT LAW  *
000204*AND INTERNATIONAL TREATIES.  UNAUTHORIZED REPRODUCTION OR      *
000205*DISTRIBUTION OF THIS PROGRAM, OR ANY PORTION OF IT, MAY RESULT *
000206*IN SEVERE CIVIL AND CRIMINAL PENATLIES, AND WILL BE PROSECUTED *
000207*TO THE MAXIMUM EXTENT POSSIBLE UNDER THE LAW.                  *
000208*COPYRIGHT 1999 PAYSYS INTERNATIONAL, INC.  ALL RIGHTS RESERVED.*
000209*****************************************************************
000300*****************************************************************
000400*                                                               *
000500*               M E R C H A N T   S Y S T E M                   *
000600*                                                               *
000700*      MBODR00 - ON-LINE RATE TABLE DIRECTORY                   *
000800*                SCREEN 00                                      *
000900*                                                               *
001000*              1. TRANSIDS                                      *
001100*                 A. MBDR                                       *
001200*              2. MAPS USED -                                   *
001300*                 A. MBDR00 (SCREEN 00)                         *
001400*              3. FILES USED -                                  *
001500*                 A. MMOC   (ORG CONTROL FILE)                  *
001600*                 B. MMRT   (RATE TABLE MASTER FILE)            *
001700*                                                               *
001800*****************************************************************
001900*
002000 ENVIRONMENT DIVISION.
002100 DATA DIVISION.
002200 WORKING-STORAGE SECTION.
002300 01  FILLER                  PIC  X(12)      VALUE '** WS-BEG **'.
002400*         I/O REQUEST BLOCK WORK AREAS
002500     COPY MBIOWS.
002600/         I/O REQUEST BLOCK
002700     COPY MBIORO.
002800/         DATE WORK AREAS
002900     COPY SS01WS.
003000/         ONLINE WORK AREAS
003100     COPY SS08WS.
003200/
003300     COPY SS00WS.
003400/
003500     COPY SMFTWS.
003600/
003700     COPY SMPTRL REPLACING ==:SMPT:== BY ==SMPT==.
003800/
003900     COPY MB61LK.
004000/         STANDARD ERROR MESSAGES
004100     COPY MBEMWS.
004200*
004300 01  FILLER                  PIC  X(12)      VALUE '** WS-END **'.
004400/
004500 LINKAGE SECTION.
004600 01  DFHCOMMAREA.
004700     COPY MB60WS.
004800/         RATE TABLE DIRECTORY SCREEN 00 MAP DSECT
004900     COPY MBDR00.
005000/         RATE TABLE DIRECTORY SCREEN 00 MAP REDEFINITION
005100     COPY MBDR00R.
005200/         SYSTEM/ORG CONTROL RECORD LAYOUT
005300     COPY MMOCRL.
005400/         RATE TABLE MASTER RECORD LAYOUT
005500     COPY MMRTRL.
005600/
005700 PROCEDURE DIVISION.
005800 0000-HOUSEKEEPING SECTION.
005900 0100-INIT.
006000*
006100     MOVE 'PC01'                 TO MBCA-PROGRAM-LOCATION.
006200     PERFORM MB70PD-ON-LINE-HOUSEKEEPING
006300                                 THRU MB70PD-OLH-EXIT.
006400*
006500     IF  MBCA-RECEIVE-SCREEN
006600         GO TO 2000-RECEIVE-SCREEN.
006700*
006800 1000-SEND-SCREEN SECTION.
006900*
007000****************************************************************
007100*    GET CICS STORAGE NEEDED FOR THE MAP                       *
007200****************************************************************
007300*
007400     MOVE 'SC01'                 TO MBCA-PROGRAM-LOCATION.
007500     PERFORM MB60PD-GETMAIN-FOR-MAP
007600                                 THRU MB60PD-GFM-EXIT.
007700*
007800*****************************************************************
007900*    CHECK KEY CODES                                            *
008000* 1. IF INITIAL KEY CODE, BYPASS CHECK OF KEY CODES.            *
008100* 2. IF MMRT KEY CODE, IT MUST BE A VALID CODE.  IF DIRECT, GO  *
008200*    TO THE RECEIVE EDITING ROUTINE SINCE WE HAVE PLUGGED THE   *
008300*    ORG AND TABLE INTO THE MAP. IF AN ERROR OCCURS IN THE      *
008400*    RECEIVE SCREEN ROUTINE, IT WILL HANDLE BUILDING THE MAP    *
008500*    AND IT WILL SEND ITS OWN SCREEN.  THIS IS WHY LOCATE       *
008600*    PROGRAMS ALWAYS SEND WITH ERASE NO MATTER WHICH ROUTINE    *
008700*    YOU ARE IN.  IF NOT DIRECT, PLUG ORG AND TABLE INTO THE    *
008800*    MAP AND BYPASS ANY OTHER CHECKING OF THE KEY CODE.         *
008900* 3. IF 2 IS FALSE, SEE IF THE MBCA-MERCHANT-ORG               *
009000*    FIELD IS GREATER THAN ZERO.  IF SO, PLUG INTO MAP.         *
009100*    SEE IF THE MBCA-TABLE FIELD IS GREATER THAN ZERO. IF SO,   *
009200*    PLUG INTO MAP.                                             *
009300*    HANDLE IF THEY WERE NON-DIRECT.                            *
009400*****************************************************************
009500*
009600     IF  MBCA-INITIAL-KEY-CODE
009700         GO TO 1100-BUILD-SCREEN.
009800*
009900     IF  MBCA-MMRT-KEY-CODE
010000     AND MBCA-MERCHANT-ORG IS GREATER THAN ZERO
010100         MOVE MBCA-MERCHANT-ORG TO DR00-ORG
010200         MOVE DFHBMUNF           TO DR00-ORG-A
010300         IF  MBCA-TABLE IS GREATER THAN ZEROES
010400             MOVE MBCA-TABLE     TO DR00-TABLE-NBR
010500             MOVE DFHBMUNF       TO DR00-TABLE-NBR-A
010600             IF  MBCA-DIRECT-TRANSFER-CODE
010700             AND MBCA-INITIAL-SCREEN-NBR
010800                 MOVE 00         TO MBCA-SCREEN-NBR
010900                 GO TO 2120-READ-ORG
011000             ELSE
011100                 GO TO 1100-BUILD-SCREEN.
011200*
011300     IF  MBCA-VALID-KEY-CODES
011400     AND MBCA-MERCHANT-ORG IS GREATER THAN ZERO
011500         MOVE MBCA-MERCHANT-ORG TO DR00-ORG
011600         MOVE DFHBMUNF           TO DR00-ORG-A
011700         IF  MBCA-TABLE IS GREATER THAN ZEROES
011800             MOVE MBCA-TABLE     TO DR00-TABLE-NBR
011900             MOVE DFHBMUNF       TO DR00-TABLE-NBR-A.
012000*
012100 1100-BUILD-SCREEN.
012200*
012300****************************************************************
012400*    INITIALIZE THE STANDARD MAP LINES                         *
012500****************************************************************
012600*
012700     MOVE SS08WS-CURSOR          TO DR00-ORG-L.
012800     MOVE 00                     TO MBCA-SCREEN-NBR.
012900     PERFORM MB60PD-INIT-STD-MAP-LINES
013000                                 THRU MB60PD-ISML-EXIT.
013100*
013200     IF  MBCA-MERCHANT-ORG IS NUMERIC
013300     AND MBCA-MERCHANT-ORG IS GREATER THAN ZEROES
013400         MOVE MBCA-MERCHANT-ORG TO DR00-ORG
013500         MOVE DFHBMUNF           TO DR00-ORG-A.
013600*
013700     IF  MBCA-TABLE IS NUMERIC
013800     AND MBCA-TABLE IS GREATER THAN ZEROES
013900         MOVE MBCA-TABLE         TO DR00-TABLE-NBR
014000         MOVE DFHBMUNF           TO DR00-TABLE-NBR-A.
014100*
014200     IF  MBCA-TABLE-TYPE IS EQUAL TO SPACES
014300         NEXT SENTENCE
014400     ELSE
014500         MOVE MBCA-TABLE-TYPE    TO DR00-TABLE-TYPE.
014600*
014700     MOVE DFHBMASK               TO DR00-CURRENT-PAGE-A.
014800*
014900****************************************************************
015000*    SEND THE MAP                                              *
015100****************************************************************
015200*
015300     MOVE 'BM01'                 TO MBCA-PROGRAM-LOCATION.
015400     PERFORM MB60PD-SEND-MAP-WITH-ERASE
015500                                 THRU MB60PD-SMWE-EXIT.
015600*
015700****************************************************************
015800*    RETURN TO CICS                                            *
015900****************************************************************
016000*
016100     MOVE 'PC02'                 TO MBCA-PROGRAM-LOCATION.
016200     PERFORM MB70PD-RETURN-TRANS-ID
016300                                 THRU MB70PD-RTI-EXIT.
016400/
016500 2000-RECEIVE-SCREEN SECTION.
016600*
016700****************************************************************
016800*    THIS SECTION RECEIVES THE 00 SCREEN                       *
016900****************************************************************
017000*
017100     MOVE 'BM02'                 TO MBCA-PROGRAM-LOCATION.
017200     PERFORM MB60PD-RECEIVE-MAP  THRU MB60PD-RM-EXIT.
017300*
017400****************************************************************
017500*    CHECK FOR ANOTHER TRANSACTION ID ENTERED BY THE USER      *
017600****************************************************************
017700*
017800     MOVE 'PC03'                 TO MBCA-PROGRAM-LOCATION.
017900     PERFORM MB60PD-NEW-TRANS-ROUTINE
018000                                 THRU MB60PD-NTR-EXIT.
018100*
018200 2100-EDIT-SCREEN.
018300*
018400     MOVE 'N'                    TO SS08WS-ERROR.
018500     MOVE MBCA-EIBAID            TO SS08WS-EIBAID.
018600*
018700     IF  (DR00-ORG-L IS LESS THAN 1
018800     AND  DR00-TABLE-NBR-L IS LESS THAN 1)
018900     AND (SS08WS-VALID-PF-KEY
019000     OR   SS08WS-EIBAID-VALID-PF-KEY)
019100         MOVE 99                 TO MBCA-SCREEN-NBR
019200         GO TO 2690-TRANSFER-XCTL.
019300*
019400 2110-EDIT-ORG.
019500*
019600     MOVE DFHBMUNF               TO DR00-ORG-A.
019700     MOVE DFHBMASK               TO DR00-ORG-LP-A
019800                                    DR00-ORG-RP-A.
019900*
020000     IF  DR00-ORG-L IS EQUAL TO ZERO
020100     OR  DR00-ORG IS NOT NUMERIC
020200         MOVE MBEMWS-INVALID-ORG TO DR00-ERR-MESSAGE
020300         GO TO 2130-ORG-ERROR.
020400*
020500     IF  DR00-ORG IS LESS THAN MBCA-ORG-LOW
020600     OR  DR00-ORG IS GREATER THAN MBCA-ORG-HIGH
020700         MOVE MBEMWS-INVALID-ORG TO DR00-ERR-MESSAGE
020800         GO TO 2130-ORG-ERROR.
020900*
021000 2120-READ-ORG.
021100*
021200****************************************************************
021300*    READ THE ORGANIZATION FILE                                *
021400****************************************************************
021500*
021600     MOVE 'FC01'                 TO MBCA-PROGRAM-LOCATION.
021700     MOVE DR00-ORG               TO MBIOWS-MMOC-ORG.
021800     MOVE SS08WS-CICS-FC-NOTFND  TO MBIORO-TEMP-STATUS-1.
021900     SET MBIORO-READ-RANDOM      TO TRUE.
022000     PERFORM MMOCAO-ACCESS       THRU MMOCAO-ACCESS-EXIT.
022100*
022200     IF  SS08WS-RC-FC-VALID-RTN-CODE
022300         MOVE MMOC-ORG           TO MBCA-MERCHANT-ORG
022400                                    MBCA-MBDR-ORG
022500         IF  MMOC-ADD-PENDING
022600             MOVE MBEMWS-ADD-PENDING
022700                                 TO DR00-ERR-MESSAGE
022800         ELSE
022900             IF  MMOC-REC-INCOMPLETE
023000             OR  MMOC-REC-PURGED
023100                 MOVE MBEMWS-NOT-ACTIVE
023200                                 TO DR00-ERR-MESSAGE
023300             ELSE
023400                 MOVE MMOC-NA-LINE (1 1)
023500                                 TO MBCA-MBDR-ORG-NAME
023600                 GO TO 2200-EDIT-TABLE-TYPE
023700     ELSE
023800         MOVE MBEMWS-NOT-ON-FILE TO DR00-ERR-MESSAGE.
023900*
024000 2130-ORG-ERROR.
024100*
024200     MOVE DFHBMNBF               TO DR00-ORG-A.
024300     MOVE DFHBMASB               TO DR00-ORG-LP-A
024400                                    DR00-ORG-RP-A.
024500     MOVE SS08WS-CURSOR          TO DR00-ORG-L.
024600     MOVE 'Y'                    TO SS08WS-ERROR.
024700*
024800 2200-EDIT-TABLE-TYPE.
024900*
025000     IF  DR00-TABLE-TYPE-L IS EQUAL TO ZERO
025100         IF  MBCA-TT-VALID
025200             MOVE MBCA-TABLE-TYPE
025300                                 TO DR00-TABLE-TYPE
025400         ELSE
025500             MOVE SPACES         TO DR00-TABLE-TYPE
025600     ELSE
025700         IF  DR00-TABLE-TYPE-VALID
025800             NEXT SENTENCE
025900         ELSE
026000             MOVE MBEMWS-INVALID-TYPE
026100                                 TO DR00-ERR-MESSAGE
026200             GO TO 2210-TYPE-ERROR.
026300*
026400     MOVE DFHBMFSE               TO DR00-TABLE-TYPE-A.
026500     MOVE DR00-TABLE-TYPE        TO MBCA-TABLE-TYPE.
026600     GO TO 2370-EDIT-RATE-TABLE.
026700*
026800 2210-TYPE-ERROR.
026900*
027000     MOVE 'Y'                    TO SS08WS-ERROR.
027100     MOVE DFHBMASB               TO DR00-TABLE-TYPE-LP-A
027200                                    DR00-TABLE-TYPE-RP-A.
027300     MOVE SS08WS-CURSOR          TO DR00-TABLE-TYPE-L.
027400     MOVE DFHBMUBF               TO DR00-TABLE-TYPE-A.
027500*
027600 2370-EDIT-RATE-TABLE.
027700*
027800     MOVE DFHBMUNF               TO DR00-TABLE-NBR-A.
027900     MOVE DFHBMASK               TO DR00-TABLE-NBR-LP-A
028000                                    DR00-TABLE-NBR-RP-A.
028100*
028200     IF  DR00-TABLE-NBR-L IS EQUAL TO ZERO
028300         MOVE ZEROES             TO DR00-TABLE-NBR
028400     ELSE
028500         IF  DR00-TABLE-NBR IS NOT NUMERIC
028600             MOVE MBEMWS-INVALID-TABLE
028700                                 TO DR00-ERR-MESSAGE
028800             GO TO 2380-TABLE-ERROR.
028900*
029000     IF  SS08WS-ERROR IS EQUAL TO 'Y'
029100         GO TO 2390-CHECK-ERROR.
029200*
029300****************************************************************
029400*    START BROWSE THE RATE TABLE FILE                          *
029500****************************************************************
029600*
029700     MOVE 'FC02'                 TO MBCA-PROGRAM-LOCATION.
029800     MOVE MBCA-MBDR-ORG          TO MBIOWS-MMRT-ORG.
029900     MOVE DR00-TABLE-NBR         TO MBIOWS-MMRT-TABLE-NBR.
030000     MOVE DR00-TABLE-TYPE        TO MBIOWS-MMRT-TABLE-TYPE.
030100     SET MBIORO-STARTBR-GTE      TO TRUE.
030200     PERFORM MMRTAO-ACCESS       THRU MMRTAO-ACCESS-EXIT.
030300*
030400****************************************************************
030500*    READNEXT THE RATE TABLE FILE                              *
030600****************************************************************
030700*
030800     MOVE 'FC03'                 TO MBCA-PROGRAM-LOCATION.
030900     SET MBIORO-READ-SEQ         TO TRUE.
031000     PERFORM MMRTAO-ACCESS       THRU MMRTAO-ACCESS-EXIT.
031100*
031200     PERFORM
031300         UNTIL DR00-TABLE-TYPE IS EQUAL TO SPACES
031400            OR MMRT-TABLE-TYPE IS EQUAL TO DR00-TABLE-TYPE
031500            OR MMRT-TRAILER
031600             MOVE 'FC04'         TO MBCA-PROGRAM-LOCATION
031700             SET MBIORO-READ-SEQ TO TRUE
031800             PERFORM MMRTAO-ACCESS
031900                THRU MMRTAO-ACCESS-EXIT
032000     END-PERFORM.
032100*
032200****************************************************************
032300*    END BROWSE THE RATE TABLE FILE                            *
032400****************************************************************
032500*
032600     MOVE 'FC05'                 TO MBCA-PROGRAM-LOCATION.
032700     SET MBIORO-ENDBR            TO TRUE.
032800     PERFORM MMRTAO-ACCESS       THRU MMRTAO-ACCESS-EXIT.
032900*
033000     IF  MMRT-ORG IS GREATER THAN MBCA-MBDR-ORG
033100         MOVE 'NO RECORDS ON FILE FOR THE SELECTION CRITERIA'
033200                                 TO DR00-ERR-MESSAGE
033300         MOVE DFHBMNBF           TO DR00-ORG-A
033400         MOVE DFHBMASB           TO DR00-ORG-LP-A
033500                                    DR00-ORG-RP-A
033600         MOVE SS08WS-CURSOR      TO DR00-ORG-L
033700     ELSE
033800         IF  MBCA-TABLE-TYPE IS EQUAL TO SPACES
033900         OR  MMRT-TABLE-TYPE IS EQUAL TO MBCA-TABLE-TYPE
034000             MOVE MMRT-TABLE-NBR TO MBCA-MBDR-FIRST-TABLE-NBR
034100                                    MBCA-MBDR-FWD-TABLE-NBR
034200                                    MBCA-TABLE
034300             MOVE SPACES         TO MBCA-MBDR-RETURN-FLAG
034400             MOVE ZEROES         TO MBCA-MBDR-BACK-TABLE-NBR
034500             GO TO 2390-CHECK-ERROR
034600         ELSE
034700             MOVE 'NO RECORDS ON FILE FOR THE SELECTION CRITERIA'
034800                                 TO DR00-ERR-MESSAGE
034900             MOVE DFHBMNBF       TO DR00-ORG-A
035000             MOVE DFHBMASB       TO DR00-ORG-LP-A
035100                                    DR00-ORG-RP-A
035200             MOVE SS08WS-CURSOR  TO DR00-ORG-L.
035300*
035400 2380-TABLE-ERROR.
035500*
035600     MOVE DFHBMNBF               TO DR00-TABLE-NBR-A.
035700     MOVE DFHBMUBF               TO DR00-TABLE-TYPE-A.
035800     MOVE DFHBMASB               TO DR00-TABLE-NBR-LP-A
035900                                    DR00-TABLE-NBR-RP-A
036000                                    DR00-TABLE-TYPE-LP-A
036100                                    DR00-TABLE-TYPE-RP-A.
036200     MOVE SS08WS-CURSOR          TO DR00-TABLE-NBR-L.
036300     MOVE 'Y'                    TO SS08WS-ERROR.
036400*
036500 2390-CHECK-ERROR.
036600*
036700     IF  SS08WS-ERROR IS EQUAL TO 'N'
036800         GO TO 2600-SETUP-COMMAREA
036900     ELSE
037000         IF  SS08WS-VALID-PF-KEY
037100         OR  SS08WS-EIBAID-VALID-PF-KEY
037200             MOVE 99             TO MBCA-SCREEN-NBR
037300             GO TO 2690-TRANSFER-XCTL.
037400*
037500 2500-SEND-MAP.
037600*
037700****************************************************************
037800*    SEND THE MAP                                              *
037900****************************************************************
038000*
038100     PERFORM MB60PD-INIT-STD-MAP-LINES
038200                                 THRU MB60PD-ISML-EXIT.
038300*
038400     MOVE DFHBMASK               TO DR00-CURRENT-PAGE-A.
038500*
038600     MOVE 'BM03'                 TO MBCA-PROGRAM-LOCATION.
038700     PERFORM MB60PD-SEND-MAP-DATA-ONLY
038800                                 THRU MB60PD-SMDO-EXIT.
038900*
039000****************************************************************
039100*    RETURN TO CICS                                            *
039200****************************************************************
039300*
039400     MOVE 'PC04'                 TO MBCA-PROGRAM-LOCATION.
039500     PERFORM MB70PD-RETURN-TRANS-ID
039600                                 THRU MB70PD-RTI-EXIT.
039700/
039800 2600-SETUP-COMMAREA.
039900*
040000****************************************************************
040100*    SET UP COMMAREA FIELDS AND TRANSFER TO THE NEXT PROGRAM   *
040200****************************************************************
040300*
040400     MOVE MBCA-EIBAID            TO SS08WS-EIBAID.
040500*
040600     MOVE MBIOWS-MMRT-KEY-CODE   TO MBCA-KEY-CODE.
040700*
040800     PERFORM MB60PD-EDIT-PAGE-NBR
040900                                 THRU MB60PD-EPN-EXIT.
041000*
041100     IF  SS08WS-VALID-PF-KEY
041200     OR  SS08WS-EIBAID-VALID-PF-KEY
041300         MOVE 99                 TO MBCA-SCREEN-NBR.
041400*
041500 2690-TRANSFER-XCTL.
041600*
041700     MOVE 'PC05'                 TO MBCA-PROGRAM-LOCATION.
041800     PERFORM MB70PD-XCTL-TO-MBOXCTL
041900                                 THRU MB70PD-XTM-EXIT.
042000/
042100 9000-PERFORMED-ROUTINES-SECT SECTION.
042200*         JULIAN TO GREGORIAN DATE ROUTINE
042300     COPY SS08PD.
042400/
042500     COPY SS26PD.
042600/
042700     COPY SS27PD.
042800/         LINE 24 PF KEYS ROUTINE
042900     COPY SS15PD.
043000/         SYSTEM/ORG RECORD ACCESS ROUTINES
043100     COPY MMOCAO.
043200/         RATE-TABLE RECORD ACCESS ROUTINES
043300     COPY MMRTAO.
043400/         ON-LINE MAP ROUTINES
043500     COPY MB60PD REPLACING 'MBMAPXX' BY 'MBDR00 '
043600                           MBMAPXXI BY MBDR00I
043700                           MBMAPXXO BY MBDR00O.
043800/         ON-LINE PROCEDURES
043900     COPY MB70PD.
044000/
044100     COPY SMFTPXO.
