000100 IDENTIFICATION DIVISION.
000200 PROGRAM-ID. MBODS00.
000201*       RELEASE DATE=08/24/01.        REVISION LEVEL=08.06      *
000202*****************************************************************
000203*WARNING.  THIS COMPUTER PROGRAM IS PROTECTED BY COPYRIGHT LAW  *
000204*AND INTERNATIONAL TREATIES.  UNAUTHORIZED REPRODUCTION OR      *
000205*DISTRIBUTION OF THIS PROGRAM, OR ANY PORTION OF IT, MAY RESULT *
000206*IN SEVERE CIVIL AND CRIMINAL PENATLIES, AND WILL BE PROSECUTED *
000207*TO THE MAXIMUM EXTENT POSSIBLE UNDER THE LAW.                  *
000208*COPYRIGHT 1999 PAYSYS INTERNATIONAL, INC.  ALL RIGHTS RESERVED.*
000209*****************************************************************
000300*****************************************************************
000400*                                                               *
000500*   V - PLUS  M E R C H A N T   B A N K C A R D   S Y S T E M   *
000600*                                                               *
000700*      MBODS00 - ON-LINE STORE DIRECTORY                        *
000800*                SCREEN 00                                      *
000900*                                                               *
001000*              1. TRANSIDS                                      *
001100*                 A. MBDS                                       *
001200*              2. MAPS USED -                                   *
001300*                 A. MBDS00 (SCREEN 00)                         *
001400*              3. FILES USED -                                  *
001500*                 A. MMOC   (ORG CONTROL FILE)                  *
001600*                 B. MMSM   (STORE MASTER FILE)                 *
001700*                                                               *
001800*****************************************************************
001900*
002000 ENVIRONMENT DIVISION.
002100 DATA DIVISION.
002200 WORKING-STORAGE SECTION.
002300 01  FILLER                  PIC  X(12)      VALUE '** WS-BEG **'.
002400*         I/O REQUEST BLOCK WORK AREAS
002500 01  WS-MISC-FIELDS.
002600     03  TS-QUEUE-NAME.
002700         05  TS-QN-TERMID    PIC  X(04)      VALUE SPACES.
002800         05  TS-QN-TRANID    PIC  X(04)      VALUE 'MBDS'.
002900     COPY MBIOWS.
003000/         I/O REQUEST BLOCK
003100     COPY MBIORO.
003200/         DATE WORK AREAS
003300     COPY SS01WS.
003400/         ONLINE WORK AREAS
003500     COPY SS08WS.
003600/
003700     COPY SS00WS.
003800/
003900     COPY SMFTWS.
004000/
004100     COPY SMPTRL REPLACING ==:SMPT:== BY ==SMPT==.
004200/
004300     COPY MB61LK.
004400/         STANDARD ERROR MESSAGES
004500     COPY MBEMWS.
004600*
004700 01  FILLER                  PIC  X(12)      VALUE '** WS-END **'.
004800/
004900 LINKAGE SECTION.
005000 01  DFHCOMMAREA.
005100     COPY MB60WS.
005200/         STORE DIRECTORY SCREEN 00 MAP DSECT
005300     COPY MBDS00.
005400/         STORE DIRECTORY SCREEN 00 MAP REDEFINITION
005500     COPY MBDS00R.
005600/         ORG CONTROL RECORD LAYOUT
005700     COPY MMOCRL.
005800/         STORE MASTER RECORD LAYOUT
005900     COPY MMSMRL.
006000/
006100 PROCEDURE DIVISION.
006200 0000-HOUSEKEEPING SECTION.
006300 0100-INIT.
006400*
006500     MOVE 'PC01'                 TO MBCA-PROGRAM-LOCATION.
006600     PERFORM MB70PD-ON-LINE-HOUSEKEEPING
006700                                 THRU MB70PD-OLH-EXIT.
006800*
006900     IF  MBCA-RECEIVE-SCREEN
007000         GO TO 2000-RECEIVE-SCREEN.
007100*
007200 1000-SEND-SCREEN SECTION.
007300*
007400****************************************************************
007500*    GET CICS STORAGE NEEDED FOR THE MAP                       *
007600****************************************************************
007700*
007800     MOVE 'SC01'                 TO MBCA-PROGRAM-LOCATION.
007900     PERFORM MB60PD-GETMAIN-FOR-MAP
008000                                 THRU MB60PD-GFM-EXIT.
008100*
008200     EXEC CICS IGNORE CONDITION
008300               QIDERR
008400          END-EXEC.
008500*
008600     MOVE MBCA-TERMINAL-ID       TO TS-QN-TERMID.
008700     MOVE 'SC02'                 TO MBCA-PROGRAM-LOCATION.
008800*
008900     EXEC CICS DELETEQ TS
009000               QUEUE  (TS-QUEUE-NAME)
009100          END-EXEC.
009200*
009300*****************************************************************
009400*    CHECK KEY CODES                                            *
009500* 1. IF INITIAL KEY CODE, BYPASS CHECK OF KEY CODES.            *
009600* 2. IF MMSM KEY CODE, IT MUST BE A VALID CODE.  IF DIRECT, GO  *
009700*    TO THE RECEIVE EDITING ROUTINE SINCE WE HAVE PLUGGED THE   *
009800*    ORG AND STORE INTO THE MAP. IF AN ERROR OCCURS IN THE      *
009900*    RECEIVE SCREEN ROUTINE, IT WILL HANDLE BUILDING THE MAP    *
010000*    AND IT WILL SEND ITS OWN SCREEN.  THIS IS WHY LOCATE       *
010100*    PROGRAMS ALWAYS SEND WITH ERASE NO MATTER WHICH ROUTINE    *
010200*    YOU ARE IN.  IF NOT DIRECT, PLUG ORG AND STORE INTO THE *
010300*    MAP AND BYPASS ANY OTHER CHECKING OF THE KEY CODE.         *
010400* 3. IF 2 IS FALSE, SEE IF THE MBCA-MERCHANT-ORG                *
010500*    FIELD IS GREATER THAN ZERO.  IF SO, PLUG INTO MAP.         *
010600*    SEE IF THE MBCA-STORE FIELD IS GREATER THAN ZERO. IF SO,*
010700*    PLUG INTO MAP.                                             *
010800*    HANDLE IF THEY WERE NON-DIRECT.                            *
010900*****************************************************************
011000*
011100     IF  MBCA-INITIAL-KEY-CODE
011200         GO TO 1100-BUILD-SCREEN.
011300*
011400     IF  MBCA-MMSM-KEY-CODE
011500     AND MBCA-MERCHANT-ORG IS GREATER THAN ZERO
011600         MOVE MBCA-MERCHANT-ORG  TO DS00-ORG
011700         MOVE DFHBMUNF           TO DS00-ORG-A
011800         IF  MBCA-STORE IS GREATER THAN ZEROES
011900             MOVE MBCA-STORE     TO DS00-STORE
012000             MOVE DFHBMUNF       TO DS00-STORE-A
012100             IF  MBCA-DIRECT-TRANSFER-CODE
012200             AND MBCA-INITIAL-SCREEN-NBR
012300                 MOVE 00         TO MBCA-SCREEN-NBR
012400                 GO TO 2120-READ-ORG
012500             ELSE
012600                 GO TO 1100-BUILD-SCREEN.
012700*
012800     IF  MBCA-VALID-KEY-CODES
012900     AND MBCA-MERCHANT-ORG IS GREATER THAN ZERO
013000         MOVE MBCA-MERCHANT-ORG  TO DS00-ORG
013100         MOVE DFHBMUNF           TO DS00-ORG-A
013200         IF  MBCA-STORE IS GREATER THAN ZEROES
013300             MOVE MBCA-STORE     TO DS00-STORE
013400             MOVE DFHBMUNF       TO DS00-STORE-A.
013500*
013600 1100-BUILD-SCREEN.
013700*
013800****************************************************************
013900*    INITIALIZE THE STANDARD MAP LINES                         *
014000****************************************************************
014100*
014200     MOVE SS08WS-CURSOR          TO DS00-ORG-L.
014300     MOVE 00                     TO MBCA-SCREEN-NBR.
014400     PERFORM MB60PD-INIT-STD-MAP-LINES
014500                                 THRU MB60PD-ISML-EXIT.
014600*
014700     IF  MBCA-MERCHANT-ORG IS NUMERIC
014800     AND MBCA-MERCHANT-ORG IS GREATER THAN ZEROES
014900         MOVE MBCA-MERCHANT-ORG  TO DS00-ORG
015000         MOVE DFHBMUNF           TO DS00-ORG-A.
015100*
015200     IF  MBCA-STORE IS NUMERIC
015300     AND MBCA-STORE IS GREATER THAN ZEROES
015400         MOVE MBCA-STORE         TO DS00-STORE
015500         MOVE DFHBMUNF           TO DS00-STORE-A.
015600*
015700     MOVE DFHBMASK               TO DS00-CURRENT-PAGE-A.
015800*
015900****************************************************************
016000*    SEND THE MAP                                              *
016100****************************************************************
016200*
016300     MOVE 'BM01'                 TO MBCA-PROGRAM-LOCATION.
016400     PERFORM MB60PD-SEND-MAP-WITH-ERASE
016500                                 THRU MB60PD-SMWE-EXIT.
016600*
016700****************************************************************
016800*    RETURN TO CICS                                            *
016900****************************************************************
017000*
017100     MOVE 'PC02'                 TO MBCA-PROGRAM-LOCATION.
017200     PERFORM MB70PD-RETURN-TRANS-ID
017300                                 THRU MB70PD-RTI-EXIT.
017400/
017500 2000-RECEIVE-SCREEN SECTION.
017600*
017700****************************************************************
017800*    THIS SECTION RECEIVES THE 00 SCREEN                       *
017900****************************************************************
018000*
018100     MOVE 'BM02'                 TO MBCA-PROGRAM-LOCATION.
018200     PERFORM MB60PD-RECEIVE-MAP  THRU MB60PD-RM-EXIT.
018300*
018400****************************************************************
018500*    CHECK FOR ANOTHER TRANSACTION ID ENTERED BY THE USER      *
018600****************************************************************
018700*
018800     MOVE 'PC03'                 TO MBCA-PROGRAM-LOCATION.
018900     PERFORM MB60PD-NEW-TRANS-ROUTINE
019000                                 THRU MB60PD-NTR-EXIT.
019100*
019200 2100-EDIT-SCREEN.
019300*
019400     SET SS08WS-ERROR-SW-NO      TO TRUE.
019500     MOVE MBCA-EIBAID            TO SS08WS-EIBAID.
019600*
019700     IF  (DS00-ORG-L IS LESS THAN 1
019800     AND  DS00-STORE-L IS LESS THAN 1)
019900     AND (SS08WS-VALID-PF-KEY
020000     OR   SS08WS-EIBAID-VALID-PF-KEY)
020100         SET MBCA-INITIAL-SCREEN-NBR
020200                                 TO TRUE
020300         GO TO 2690-TRANSFER-XCTL.
020400*
020500 2110-EDIT-ORG.
020600*
020700     MOVE DFHBMUNF               TO DS00-ORG-A.
020800     MOVE DFHBMASK               TO DS00-ORG-LP-A
020900                                    DS00-ORG-RP-A.
021000*
021100     IF  DS00-ORG-L IS EQUAL TO ZERO
021200     OR  DS00-ORG IS NOT NUMERIC
021300         MOVE MBEMWS-INVALID-ORG TO DS00-ERR-MESSAGE
021400         GO TO 2130-ORG-ERROR.
021500*
021600     IF  DS00-ORG IS LESS THAN MBCA-ORG-LOW
021700     OR  DS00-ORG IS GREATER THAN MBCA-ORG-HIGH
021800         MOVE MBEMWS-INVALID-ORG TO DS00-ERR-MESSAGE
021900         GO TO 2130-ORG-ERROR.
022000*
022100 2120-READ-ORG.
022200*
022300****************************************************************
022400*    READ THE ORGANIZATION FILE                                *
022500****************************************************************
022600*
022700     MOVE 'FC01'                 TO MBCA-PROGRAM-LOCATION.
022800     MOVE DS00-ORG               TO MBIOWS-MMOC-ORG.
022900     MOVE SS08WS-CICS-FC-NOTFND  TO MBIORO-TEMP-STATUS-1.
023000     SET MBIORO-READ-RANDOM      TO TRUE.
023100     PERFORM MMOCAO-ACCESS       THRU MMOCAO-ACCESS-EXIT.
023200*
023300     IF  SS08WS-RC-FC-VALID-RTN-CODE
023400         MOVE MMOC-ORG           TO MBCA-MERCHANT-ORG
023500                                    MBCA-MBDS-ORG
023600         IF  MMOC-ADD-PENDING
023700             MOVE MBEMWS-ADD-PENDING
023800                                 TO DS00-ERR-MESSAGE
023900         ELSE
024000             IF  MMOC-REC-INCOMPLETE
024100             OR  MMOC-REC-PURGED
024200                 MOVE MBEMWS-NOT-ACTIVE
024300                                 TO DS00-ERR-MESSAGE
024400             ELSE
024500                 MOVE MMOC-NA-LINE (1 1)
024600                                 TO MBCA-MBDS-ORG-NAME
024700                 GO TO 2140-EDIT-STORE
024800     ELSE
024900         MOVE MBEMWS-NOT-ON-FILE TO DS00-ERR-MESSAGE.
025000*
025100 2130-ORG-ERROR.
025200*
025300     MOVE DFHBMNBF               TO DS00-ORG-A.
025400     MOVE DFHBMASB               TO DS00-ORG-LP-A
025500                                    DS00-ORG-RP-A.
025600     MOVE SS08WS-CURSOR          TO DS00-ORG-L.
025700     SET SS08WS-ERROR-SW-YES     TO TRUE.
025800*
025900 2140-EDIT-STORE.
026000*
026100     MOVE DFHBMUNF               TO DS00-STORE-A.
026200     MOVE DFHBMASK               TO DS00-STORE-LP-A
026300                                    DS00-STORE-RP-A.
026400*
026500     IF  DS00-STORE-L IS EQUAL TO ZERO
026600         MOVE ZEROES             TO DS00-STORE
026700     ELSE
026800         IF  DS00-STORE IS NOT NUMERIC
026900             MOVE MBEMWS-INVALID-STORE
027000                                 TO DS00-ERR-MESSAGE
027100             GO TO 2150-STORE-ERROR.
027200*
027300     IF  SS08WS-ERROR-SW-YES
027400         GO TO 2290-CHECK-ERROR.
027500*
027600****************************************************************
027700*    START BROWSE THE STORE FILE                               *
027800****************************************************************
027900*
028000     MOVE 'FC02'                 TO MBCA-PROGRAM-LOCATION.
028100     MOVE MBCA-MBDS-ORG          TO MBIOWS-MMSM-ORG.
028200     MOVE DS00-STORE             TO MBIOWS-MMSM-STORE.
028300     SET MBIORO-STARTBR-GTE      TO TRUE.
028400     PERFORM MMSMAO-ACCESS       THRU MMSMAO-ACCESS-EXIT.
028500*
028600****************************************************************
028700*    READNEXT THE STORE FILE                                   *
028800****************************************************************
028900*
029000     MOVE 'FC03'                 TO MBCA-PROGRAM-LOCATION.
029100     SET MBIORO-READ-SEQ         TO TRUE.
029200     PERFORM MMSMAO-ACCESS       THRU MMSMAO-ACCESS-EXIT.
029300*
029400****************************************************************
029500*    END BROWSE THE STORE FILE                                 *
029600****************************************************************
029700*
029800     MOVE 'FC04'                 TO MBCA-PROGRAM-LOCATION.
029900     SET MBIORO-ENDBR            TO TRUE.
030000     PERFORM MMSMAO-ACCESS       THRU MMSMAO-ACCESS-EXIT.
030100*
030200     IF  MMSM-ORG IS GREATER THAN MBCA-MBDS-ORG
030300         MOVE 'NO RECORDS ON FILE FOR THE SELECTION CRITERIA'
030400                                 TO DS00-ERR-MESSAGE
030500         MOVE DFHBMNBF           TO DS00-ORG-A
030600         MOVE DFHBMASB           TO DS00-ORG-LP-A
030700                                    DS00-ORG-RP-A
030800         MOVE SS08WS-CURSOR      TO DS00-ORG-L
030900     ELSE
031000         MOVE MMSM-STORE         TO MBCA-MBDS-FIRST-STORE
031100                                    MBCA-MBDS-FWD-STORE
031200                                    MBCA-STORE
031300         MOVE SPACES             TO MBCA-MBDS-RETURN-FLAG
031400         MOVE ZEROES             TO MBCA-MBDS-BACK-STORE
031500         GO TO 2290-CHECK-ERROR.
031600*
031700 2150-STORE-ERROR.
031800*
031900     MOVE DFHBMNBF               TO DS00-STORE-A.
032000     MOVE DFHBMASB               TO DS00-STORE-LP-A
032100                                    DS00-STORE-RP-A.
032200     MOVE SS08WS-CURSOR          TO DS00-STORE-L
032300     SET SS08WS-ERROR-SW-YES     TO TRUE.
032400*
032500 2290-CHECK-ERROR.
032600*
032700     IF  SS08WS-ERROR-SW-NO
032800         GO TO 2600-SETUP-COMMAREA
032900     ELSE
033000         IF  SS08WS-VALID-PF-KEY
033100         OR  SS08WS-EIBAID-VALID-PF-KEY
033200             SET MBCA-INITIAL-SCREEN-NBR
033300                                 TO TRUE
033400             GO TO 2690-TRANSFER-XCTL.
033500*
033600 2300-SEND-MAP.
033700*
033800****************************************************************
033900*    SEND THE MAP                                              *
034000****************************************************************
034100*
034200     PERFORM MB60PD-INIT-STD-MAP-LINES
034300                                 THRU MB60PD-ISML-EXIT.
034400*
034500     MOVE DFHBMASK               TO DS00-CURRENT-PAGE-A.
034600*
034700     MOVE 'BM03'                 TO MBCA-PROGRAM-LOCATION.
034800     PERFORM MB60PD-SEND-MAP-DATA-ONLY
034900                                 THRU MB60PD-SMDO-EXIT.
035000*
035100****************************************************************
035200*    RETURN TO CICS                                            *
035300****************************************************************
035400*
035500     MOVE 'PC04'                 TO MBCA-PROGRAM-LOCATION.
035600     PERFORM MB70PD-RETURN-TRANS-ID
035700                                 THRU MB70PD-RTI-EXIT.
035800/
035900 2600-SETUP-COMMAREA.
036000*
036100****************************************************************
036200*    SET UP COMMAREA FIELDS AND TRANSFER TO THE NEXT PROGRAM   *
036300****************************************************************
036400*
036500     MOVE MBCA-EIBAID            TO SS08WS-EIBAID.
036600*
036700     MOVE MBIOWS-MMSM-KEY-CODE   TO MBCA-KEY-CODE.
036800*
036900     PERFORM MB60PD-EDIT-PAGE-NBR
037000                                 THRU MB60PD-EPN-EXIT.
037100*
037200     IF  SS08WS-VALID-PF-KEY
037300     OR  SS08WS-EIBAID-VALID-PF-KEY
037400         SET MBCA-INITIAL-SCREEN-NBR
037500                                 TO TRUE.
037600*
037700 2690-TRANSFER-XCTL.
037800*
037900     MOVE 'PC05'                 TO MBCA-PROGRAM-LOCATION.
038000     PERFORM MB70PD-XCTL-TO-MBOXCTL
038100                                 THRU MB70PD-XTM-EXIT.
038200/
038300 9000-PERFORMED-ROUTINES-SECT SECTION.
038400*         JULIAN TO GREGORIAN DATE ROUTINE
038500     COPY SS08PD.
038600/
038700     COPY SS26PD.
038800/
038900     COPY SS27PD.
039000/         LINE 24 PF KEYS ROUTINE
039100     COPY SS15PD.
039200/         ORG RECORD ACCESS ROUTINES
039300     COPY MMOCAO.
039400/         STORE RECORD ACCESS ROUTINES
039500     COPY MMSMAO.
039600/         ON-LINE MAP ROUTINES
039700     COPY MB60PD REPLACING 'MBMAPXX' BY 'MBDS00 '
039800                           MBMAPXXI BY MBDS00I
039900                           MBMAPXXO BY MBDS00O.
040000/         ON-LINE PROCEDURES
040100     COPY MB70PD.
040200/
040300     COPY SMFTPXO.
