000100 IDENTIFICATION DIVISION.
000200 PROGRAM-ID. MBODU00.
000201*       RELEASE DATE=08/24/01.        REVISION LEVEL=08.06      *
000202*****************************************************************
000203*WARNING.  THIS COMPUTER PROGRAM IS PROTECTED BY COPYRIGHT LAW  *
000204*AND INTERNATIONAL TREATIES.  UNAUTHORIZED REPRODUCTION OR      *
000205*DISTRIBUTION OF THIS PROGRAM, OR ANY PORTION OF IT, MAY RESULT *
000206*IN SEVERE CIVIL AND CRIMINAL PENATLIES, AND WILL BE PROSECUTED *
000207*TO THE MAXIMUM EXTENT POSSIBLE UNDER THE LAW.                  *
000208*COPYRIGHT 1999 PAYSYS INTERNATIONAL, INC.  ALL RIGHTS RESERVED.*
000209*****************************************************************
000300*****************************************************************
000400*                                                               *
000500*               M E R C H A N T   S Y S T E M                   *
000600*                                                               *
000700*      MBODU00 - ON-LINE FRAUD TABLE DIRECTORY                  *
000800*                SCREEN 00                                      *
000900*                                                               *
001000*              1. TRANSIDS                                      *
001100*                 A. MBDU                                       *
001200*              2. MAPS USED -                                   *
001300*                 A. MBDU00 (SCREEN 00)                         *
001400*              3. FILES USED -                                  *
001500*                 A. MMOC   (ORG CONTROL FILE)                  *
001600*                 B. MMFP   (FRAUD TABLE MASTER FILE)           *
001700*                                                               *
001800*****************************************************************
001900*
002000 ENVIRONMENT DIVISION.
002100 DATA DIVISION.
002200 WORKING-STORAGE SECTION.
002300 01  FILLER                  PIC  X(12)      VALUE '** WS-BEG **'.
002400*         I/O REQUEST BLOCK WORK AREAS
002500     COPY MBIOWS.
002600/         I/O REQUEST BLOCK
002700     COPY MBIORO.
002800/         DATE WORK AREAS
002900     COPY SS01WS.
003000/         ONLINE WORK AREAS
003100     COPY SS08WS.
003200/
003300     COPY SS00WS.
003400/
003500     COPY SMFTWS.
003600/
003700     COPY SMPTRL REPLACING ==:SMPT:== BY ==SMPT==.
003800/
003900     COPY MB61LK.
004000/         STANDARD ERROR MESSAGES
004100     COPY MBEMWS.
004200*
004300 01  FILLER                  PIC  X(12)      VALUE '** WS-END **'.
004400/
004500 LINKAGE SECTION.
004600 01  DFHCOMMAREA.
004700     COPY MB60WS.
004800/         FRAUD TABLE DIRECTORY SCREEN 00 MAP DSECT
004900     COPY MBDU00.
005000/         FRAUD TABLE DIRECTORY SCREEN 00 MAP REDEFINITION
005100     COPY MBDU00R.
005200/         SYSTEM/ORG CONTROL RECORD LAYOUT
005300     COPY MMOCRL.
005400/         FRAUD TABLE MASTER RECORD LAYOUT
005500     COPY MMFPRL.
005600/
005700 PROCEDURE DIVISION.
005800 0000-HOUSEKEEPING SECTION.
005900 0100-INIT.
006000*
006100     MOVE 'PC01'                 TO MBCA-PROGRAM-LOCATION.
006200     PERFORM MB70PD-ON-LINE-HOUSEKEEPING
006300                                 THRU MB70PD-OLH-EXIT.
006400*
006500     IF  MBCA-RECEIVE-SCREEN
006600         GO TO 2000-RECEIVE-SCREEN.
006700*
006800 1000-SEND-SCREEN SECTION.
006900*
007000****************************************************************
007100*    GET CICS STORAGE NEEDED FOR THE MAP                       *
007200****************************************************************
007300*
007400     MOVE 'SC01'                 TO MBCA-PROGRAM-LOCATION.
007500     PERFORM MB60PD-GETMAIN-FOR-MAP
007600                                 THRU MB60PD-GFM-EXIT.
007700*
007800*****************************************************************
007900*    CHECK KEY CODES                                            *
008000* 1. IF INITIAL KEY CODE, BYPASS CHECK OF KEY CODES.            *
008100* 2. IF MMFP KEY CODE, IT MUST BE A VALID CODE.  IF DIRECT, GO  *
008200*    TO THE RECEIVE EDITING ROUTINE SINCE WE HAVE PLUGGED THE   *
008300*    ORG AND TABLE INTO THE MAP. IF AN ERROR OCCURS IN THE      *
008400*    RECEIVE SCREEN ROUTINE, IT WILL HANDLE BUILDING THE MAP    *
008500*    AND IT WILL SEND ITS OWN SCREEN.  THIS IS WHY LOCATE       *
008600*    PROGRAMS ALWAYS SEND WITH ERASE NO MATTER WHICH ROUTINE    *
008700*    YOU ARE IN.  IF NOT DIRECT, PLUG ORG AND TABLE INTO THE    *
008800*    MAP AND BYPASS ANY OTHER CHECKING OF THE KEY CODE.         *
008900* 3. IF 2 IS FALSE, SEE IF THE MBCA-MERCHANT-ORG               *
009000*    FIELD IS GREATER THAN ZERO.  IF SO, PLUG INTO MAP.         *
009100*    SEE IF THE MBCA-TABLE FIELD IS GREATER THAN ZERO. IF SO,   *
009200*    PLUG INTO MAP.                                             *
009300*    HANDLE IF THEY WERE NON-DIRECT.                            *
009400*****************************************************************
009500*
009600     IF  MBCA-INITIAL-KEY-CODE
009700         GO TO 1100-BUILD-SCREEN.
009800*
009900     IF  MBCA-MMFP-KEY-CODE
010000     AND MBCA-MERCHANT-ORG IS GREATER THAN ZERO
010100         MOVE MBCA-MERCHANT-ORG TO DU00-ORG
010200         MOVE DFHBMUNF           TO DU00-ORG-A
010300         IF  MBCA-TABLE IS GREATER THAN ZEROES
010400             MOVE MBCA-TABLE     TO DU00-TABLE-NBR
010500             MOVE DFHBMUNF       TO DU00-TABLE-NBR-A
010600             IF  MBCA-DIRECT-TRANSFER-CODE
010700             AND MBCA-INITIAL-SCREEN-NBR
010800                 MOVE 00         TO MBCA-SCREEN-NBR
010900                 GO TO 2120-READ-ORG
011000             ELSE
011100                 GO TO 1100-BUILD-SCREEN.
011200*
011300     IF  MBCA-VALID-KEY-CODES
011400     AND MBCA-MERCHANT-ORG IS GREATER THAN ZERO
011500         MOVE MBCA-MERCHANT-ORG TO DU00-ORG
011600         MOVE DFHBMUNF           TO DU00-ORG-A
011700         IF  MBCA-TABLE IS GREATER THAN ZEROES
011800             MOVE MBCA-TABLE     TO DU00-TABLE-NBR
011900             MOVE DFHBMUNF       TO DU00-TABLE-NBR-A.
012000*
012100 1100-BUILD-SCREEN.
012200*
012300****************************************************************
012400*    INITIALIZE THE STANDARD MAP LINES                         *
012500****************************************************************
012600*
012700     MOVE SS08WS-CURSOR          TO DU00-ORG-L.
012800     MOVE 00                     TO MBCA-SCREEN-NBR.
012900     PERFORM MB60PD-INIT-STD-MAP-LINES
013000                                 THRU MB60PD-ISML-EXIT.
013100*
013200     IF  MBCA-MERCHANT-ORG IS NUMERIC
013300     AND MBCA-MERCHANT-ORG IS GREATER THAN ZEROES
013400         MOVE MBCA-MERCHANT-ORG  TO DU00-ORG
013500         MOVE DFHBMUNF           TO DU00-ORG-A.
013600*
013700     IF  MBCA-TABLE IS NUMERIC
013800     AND MBCA-TABLE IS GREATER THAN ZEROES
013900         MOVE MBCA-TABLE         TO DU00-TABLE-NBR
014000         MOVE DFHBMUNF           TO DU00-TABLE-NBR-A.
014100*
014200     MOVE DFHBMASK               TO DU00-CURRENT-PAGE-A.
014300*
014400****************************************************************
014500*    SEND THE MAP                                              *
014600****************************************************************
014700*
014800     MOVE 'BM01'                 TO MBCA-PROGRAM-LOCATION.
014900     PERFORM MB60PD-SEND-MAP-WITH-ERASE
015000                                 THRU MB60PD-SMWE-EXIT.
015100*
015200****************************************************************
015300*    RETURN TO CICS                                            *
015400****************************************************************
015500*
015600     MOVE 'PC02'                 TO MBCA-PROGRAM-LOCATION.
015700     PERFORM MB70PD-RETURN-TRANS-ID
015800                                 THRU MB70PD-RTI-EXIT.
015900/
016000 2000-RECEIVE-SCREEN SECTION.
016100*
016200****************************************************************
016300*    THIS SECTION RECEIVES THE 00 SCREEN                       *
016400****************************************************************
016500*
016600     MOVE 'BM02'                 TO MBCA-PROGRAM-LOCATION.
016700     PERFORM MB60PD-RECEIVE-MAP  THRU MB60PD-RM-EXIT.
016800*
016900****************************************************************
017000*    CHECK FOR ANOTHER TRANSACTION ID ENTERED BY THE USER      *
017100****************************************************************
017200*
017300     MOVE 'PC03'                 TO MBCA-PROGRAM-LOCATION.
017400     PERFORM MB60PD-NEW-TRANS-ROUTINE
017500                                 THRU MB60PD-NTR-EXIT.
017600*
017700 2100-EDIT-SCREEN.
017800*
017900     MOVE 'N'                    TO SS08WS-ERROR.
018000     MOVE MBCA-EIBAID            TO SS08WS-EIBAID.
018100*
018200     IF  (DU00-ORG-L IS LESS THAN 1
018300     AND  DU00-TABLE-NBR-L IS LESS THAN 1)
018400     AND (SS08WS-VALID-PF-KEY
018500     OR   SS08WS-EIBAID-VALID-PF-KEY)
018600         MOVE 99                 TO MBCA-SCREEN-NBR
018700         GO TO 2690-TRANSFER-XCTL.
018800*
018900 2110-EDIT-ORG.
019000*
019100     MOVE DFHBMUNF               TO DU00-ORG-A.
019200     MOVE DFHBMASK               TO DU00-ORG-LP-A
019300                                    DU00-ORG-RP-A.
019400*
019500     IF  DU00-ORG-L IS EQUAL TO ZERO
019600     OR  DU00-ORG IS NOT NUMERIC
019700         MOVE MBEMWS-INVALID-ORG TO DU00-ERR-MESSAGE
019800         GO TO 2130-ORG-ERROR.
019900*
020000     IF  DU00-ORG IS LESS THAN MBCA-ORG-LOW
020100     OR  DU00-ORG IS GREATER THAN MBCA-ORG-HIGH
020200         MOVE MBEMWS-INVALID-ORG TO DU00-ERR-MESSAGE
020300         GO TO 2130-ORG-ERROR.
020400*
020500 2120-READ-ORG.
020600*
020700****************************************************************
020800*    READ THE ORGANIZATION FILE                                *
020900****************************************************************
021000*
021100     MOVE 'FC01'                 TO MBCA-PROGRAM-LOCATION.
021200     MOVE DU00-ORG               TO MBIOWS-MMOC-ORG.
021300     MOVE SS08WS-CICS-FC-NOTFND  TO MBIORO-TEMP-STATUS-1.
021400     SET MBIORO-READ-RANDOM      TO TRUE.
021500     PERFORM MMOCAO-ACCESS       THRU MMOCAO-ACCESS-EXIT.
021600*
021700     IF  SS08WS-RC-FC-VALID-RTN-CODE
021800         MOVE MMOC-ORG           TO MBCA-MERCHANT-ORG
021900                                    MBCA-MBDU-ORG
022000         IF  MMOC-ADD-PENDING
022100             MOVE MBEMWS-ADD-PENDING
022200                                 TO DU00-ERR-MESSAGE
022300         ELSE
022400             IF  MMOC-REC-INCOMPLETE
022500             OR  MMOC-REC-PURGED
022600                 MOVE MBEMWS-NOT-ACTIVE
022700                                 TO DU00-ERR-MESSAGE
022800             ELSE
022900                 MOVE MMOC-NA-LINE (1 1)
023000                                 TO MBCA-MBDU-ORG-NAME
023100                 GO TO 2370-EDIT-FRAUD-TABLE
023200     ELSE
023300         MOVE MBEMWS-NOT-ON-FILE TO DU00-ERR-MESSAGE.
023400*
023500 2130-ORG-ERROR.
023600*
023700     MOVE DFHBMNBF               TO DU00-ORG-A.
023800     MOVE DFHBMASB               TO DU00-ORG-LP-A
023900                                    DU00-ORG-RP-A.
024000     MOVE SS08WS-CURSOR          TO DU00-ORG-L.
024100     MOVE 'Y'                    TO SS08WS-ERROR.
024200*
024300 2370-EDIT-FRAUD-TABLE.
024400*
024500     MOVE DFHBMUNF               TO DU00-TABLE-NBR-A.
024600     MOVE DFHBMASK               TO DU00-TABLE-NBR-LP-A
024700                                    DU00-TABLE-NBR-RP-A.
024800*
024900     IF  DU00-TABLE-NBR-L IS EQUAL TO ZERO
025000         MOVE ZEROES             TO DU00-TABLE-NBR
025100     ELSE
025200         IF  DU00-TABLE-NBR IS NOT NUMERIC
025300             MOVE MBEMWS-INVALID-TABLE
025400                                 TO DU00-ERR-MESSAGE
025500             GO TO 2380-TABLE-ERROR.
025600*
025700     IF  SS08WS-ERROR IS EQUAL TO 'Y'
025800         GO TO 2390-CHECK-ERROR.
025900*
026000****************************************************************
026100*    START BROWSE THE FRAUD TABLE FILE                         *
026200****************************************************************
026300*
026400     MOVE 'FC02'                 TO MBCA-PROGRAM-LOCATION.
026500     MOVE MBCA-MBDU-ORG          TO MBIOWS-MMFP-ORG.
026600     MOVE DU00-TABLE-NBR         TO MBIOWS-MMFP-TABLE-NBR.
026700     SET MBIORO-STARTBR-GTE      TO TRUE.
026800     PERFORM MMFPAO-ACCESS       THRU MMFPAO-ACCESS-EXIT.
026900*
027000****************************************************************
027100*    READNEXT THE FRAUD TABLE FILE                             *
027200****************************************************************
027300*
027400     MOVE 'FC03'                 TO MBCA-PROGRAM-LOCATION.
027500     SET MBIORO-READ-SEQ         TO TRUE.
027600     PERFORM MMFPAO-ACCESS       THRU MMFPAO-ACCESS-EXIT.
027700*
027800****************************************************************
027900*    END BROWSE THE FRAUD TABLE FILE                           *
028000****************************************************************
028100*
028200     MOVE 'FC05'                 TO MBCA-PROGRAM-LOCATION.
028300     SET MBIORO-ENDBR            TO TRUE.
028400     PERFORM MMFPAO-ACCESS       THRU MMFPAO-ACCESS-EXIT.
028500*
028600     IF  MMFP-ORG IS GREATER THAN MBCA-MBDU-ORG
028700         MOVE 'NO RECORDS ON FILE FOR THE SELECTION CRITERIA'
028800                                 TO DU00-ERR-MESSAGE
028900         MOVE DFHBMNBF           TO DU00-ORG-A
029000         MOVE DFHBMASB           TO DU00-ORG-LP-A
029100                                    DU00-ORG-RP-A
029200         MOVE SS08WS-CURSOR      TO DU00-ORG-L
029300     ELSE
029400         MOVE MMFP-TABLE-NBR     TO MBCA-MBDU-FIRST-TABLE-NBR
029500                                    MBCA-MBDU-FWD-TABLE-NBR
029600                                    MBCA-TABLE
029700         MOVE SPACES             TO MBCA-MBDU-RETURN-FLAG
029800         MOVE ZEROES             TO MBCA-MBDU-BACK-TABLE-NBR
029900         GO TO 2390-CHECK-ERROR.
030000*
030100 2380-TABLE-ERROR.
030200*
030300     MOVE DFHBMNBF               TO DU00-TABLE-NBR-A.
030400     MOVE DFHBMASB               TO DU00-TABLE-NBR-LP-A
030500                                    DU00-TABLE-NBR-RP-A.
030600     MOVE SS08WS-CURSOR          TO DU00-TABLE-NBR-L.
030700     MOVE 'Y'                    TO SS08WS-ERROR.
030800*
030900 2390-CHECK-ERROR.
031000*
031100     IF  SS08WS-ERROR IS EQUAL TO 'N'
031200         GO TO 2600-SETUP-COMMAREA
031300     ELSE
031400         IF  SS08WS-VALID-PF-KEY
031500         OR  SS08WS-EIBAID-VALID-PF-KEY
031600             MOVE 99             TO MBCA-SCREEN-NBR
031700             GO TO 2690-TRANSFER-XCTL.
031800*
031900 2500-SEND-MAP.
032000*
032100****************************************************************
032200*    SEND THE MAP                                              *
032300****************************************************************
032400*
032500     PERFORM MB60PD-INIT-STD-MAP-LINES
032600                                 THRU MB60PD-ISML-EXIT.
032700*
032800     MOVE DFHBMASK               TO DU00-CURRENT-PAGE-A.
032900*
033000     MOVE 'BM03'                 TO MBCA-PROGRAM-LOCATION.
033100     PERFORM MB60PD-SEND-MAP-DATA-ONLY
033200                                 THRU MB60PD-SMDO-EXIT.
033300*
033400****************************************************************
033500*    RETURN TO CICS                                            *
033600****************************************************************
033700*
033800     MOVE 'PC04'                 TO MBCA-PROGRAM-LOCATION.
033900     PERFORM MB70PD-RETURN-TRANS-ID
034000                                 THRU MB70PD-RTI-EXIT.
034100/
034200 2600-SETUP-COMMAREA.
034300*
034400****************************************************************
034500*    SET UP COMMAREA FIELDS AND TRANSFER TO THE NEXT PROGRAM   *
034600****************************************************************
034700*
034800     MOVE MBCA-EIBAID            TO SS08WS-EIBAID.
034900*
035000     MOVE MBIOWS-MMFP-KEY-CODE   TO MBCA-KEY-CODE.
035100*
035200     PERFORM MB60PD-EDIT-PAGE-NBR
035300                                 THRU MB60PD-EPN-EXIT.
035400*
035500     IF  SS08WS-VALID-PF-KEY
035600     OR  SS08WS-EIBAID-VALID-PF-KEY
035700         MOVE 99                 TO MBCA-SCREEN-NBR.
035800*
035900 2690-TRANSFER-XCTL.
036000*
036100     MOVE 'PC05'                 TO MBCA-PROGRAM-LOCATION.
036200     PERFORM MB70PD-XCTL-TO-MBOXCTL
036300                                 THRU MB70PD-XTM-EXIT.
036400/
036500 9000-PERFORMED-ROUTINES-SECT SECTION.
036600*         JULIAN TO GREGORIAN DATE ROUTINE
036700     COPY SS08PD.
036800/
036900     COPY SS26PD.
037000/
037100     COPY SS27PD.
037200/         LINE 24 PF KEYS ROUTINE
037300     COPY SS15PD.
037400/         SYSTEM/ORG RECORD ACCESS ROUTINES
037500     COPY MMOCAO.
037600/         FRAUD-TABLE RECORD ACCESS ROUTINES
037700     COPY MMFPAO.
037800/         ON-LINE MAP ROUTINES
037900     COPY MB60PD REPLACING 'MBMAPXX' BY 'MBDU00 '
038000                           MBMAPXXI BY MBDU00I
038100                           MBMAPXXO BY MBDU00O.
038200/         ON-LINE PROCEDURES
038300     COPY MB70PD.
038400/
038500     COPY SMFTPXO.
