000100 IDENTIFICATION DIVISION.
000200 PROGRAM-ID. MBODX01.
000201*       RELEASE DATE=08/24/01.        REVISION LEVEL=08.06      *
000202*****************************************************************
000203*WARNING.  THIS COMPUTER PROGRAM IS PROTECTED BY COPYRIGHT LAW  *
000204*AND INTERNATIONAL TREATIES.  UNAUTHORIZED REPRODUCTION OR      *
000205*DISTRIBUTION OF THIS PROGRAM, OR ANY PORTION OF IT, MAY RESULT *
000206*IN SEVERE CIVIL AND CRIMINAL PENATLIES, AND WILL BE PROSECUTED *
000207*TO THE MAXIMUM EXTENT POSSIBLE UNDER THE LAW.                  *
000208*COPYRIGHT 1999 PAYSYS INTERNATIONAL, INC.  ALL RIGHTS RESERVED.*
000209*****************************************************************
000300*****************************************************************
000400*                                                               *
000500*               M E R C H A N T   S Y S T E M                   *
000600*                                                               *
000700*      MBODX01 - ON-LINE MERCHANT MONETARY TRANS DIRECTORY      *
000800*                SCREEN 01                                      *
000900*                                                               *
001000*              1. TRANSIDS                                      *
001100*                 A. MBDX                                       *
001200*              2. MAPS USED -                                   *
001300*                 A. MBDX01 (SCREEN 01)                         *
001400*              3. FILES USED -                                  *
001500*                 A. MMTC   (MONETARY TRANS CONTROL FILE)       *
001600*                                                               *
001700*****************************************************************
001800*
001900 ENVIRONMENT DIVISION.
002000 DATA DIVISION.
002100 WORKING-STORAGE SECTION.
002200 01  FILLER                  PIC  X(12)      VALUE '** WS-BEG **'.
002300*         I/O REQUEST BLOCK WORK AREAS
002400     COPY MBIOWS.
002500/         I/O REQUEST BLOCK
002600     COPY MBIORO.
002700/         DATE WORK AREAS
002800     COPY SS01WS.
002900/         ONLINE WORK AREAS
003000     COPY SS08WS.
003100/
003200     COPY SS00WS.
003300/
003400     COPY SMFTWS.
003500/
003600     COPY SMPTRL REPLACING ==:SMPT:== BY ==SMPT==.
003700/
003800     COPY MB61LK.
003900/
004000 01  WS-MISCELLANEOUS.
004100     03  WS-SAVE-EIBAID      PIC  X(01)      VALUE SPACES.
004200     03  WS-FWD-TXN-CODE     PIC  9(03)      VALUE ZEROES.
004300     03  WS-SELECT-SW        PIC  X(01)      VALUE 'N'.
004400         88  WS-SELECT-NO                    VALUE 'N'.
004500         88  WS-SELECT-YES                   VALUE 'Y'.
004600     03  WS-BYPASS-SW        PIC  X(01)      VALUE 'N'.
004700         88  WS-BYPASS-NO                    VALUE 'N'.
004800         88  WS-BYPASS-YES                   VALUE 'Y'.
004900     03  TS-QUEUE-NAME.
005000         05  TS-QN-TERMID    PIC  X(04)      VALUE SPACES.
005100         05  TS-QN-TRANID    PIC  X(04)      VALUE 'MBDX'.
005200*
005300 01  WS-DETAIL-LINE.
005400     03  WS-TXN-CODE         PIC  9(03).
005500     03  FILLER              PIC  X(02)      VALUE SPACES.
005600     03  WS-LOGIC-MODULE     PIC  9(03).
005700     03  FILLER              PIC  X(03)      VALUE SPACES.
005800     03  WS-DESCRIPTION      PIC  X(15).
005900     03  FILLER              PIC  X(02)      VALUE SPACES.
006000     03  WS-GL-DR-DESC       PIC  X(15).
006100     03  FILLER              PIC  X(02)      VALUE SPACES.
006200     03  WS-GL-CR-DESC       PIC  X(15).
006300     03  FILLER              PIC  X(03)      VALUE SPACES.
006400     03  WS-STATUS-CODE      PIC  9(01).
006500*
006600 01  FILLER                  PIC  X(12)      VALUE '** WS-END **'.
006700/
006800 LINKAGE SECTION.
006900 01  DFHCOMMAREA.
007000     COPY MB60WS.
007100/         MONETARY TRANS DIRECTORY SCREEN 01 MAP DSECT
007200     COPY MBDX01.
007300/         MONETARY TRANS DIRECTORY SCREEN 01 MAP REDEFINITION
007400     COPY MBDX01R.
007500/         MONETARY TRANS CONTROL RECORD LAYOUT
007600     COPY MMTCRL.
007700/         MONETARY TRANS DIRECTORY TEMPORARY STORAGE
007800     COPY MBDXTS.
007900/
008000 PROCEDURE DIVISION.
008100 0000-HOUSEKEEPING SECTION.
008200 0100-INIT.
008300*
008400     MOVE MBCA-EIBAID            TO WS-SAVE-EIBAID.
008500     SET MBCA-EIBAID-ENTER       TO TRUE.
008600*
008700     MOVE 'PC01'                 TO MBCA-PROGRAM-LOCATION.
008800     PERFORM MB70PD-ON-LINE-HOUSEKEEPING
008900                                 THRU MB70PD-OLH-EXIT.
009000*
009100     MOVE WS-SAVE-EIBAID         TO MBCA-EIBAID.
009200     MOVE MBCA-TERMINAL-ID       TO TS-QN-TERMID.
009300*
009400     IF  MBCA-RECEIVE-SCREEN
009500         GO TO 2000-RECEIVE-SCREEN.
009600*
009700 1000-SEND-SCREEN SECTION.
009800*
009900****************************************************************
010000*    GET CICS STORAGE NEEDED FOR THE MAP                       *
010100****************************************************************
010200*
010300     MOVE 'SC01'                 TO MBCA-PROGRAM-LOCATION.
010400     PERFORM MB60PD-GETMAIN-FOR-MAP
010500                                 THRU MB60PD-GFM-EXIT.
010600*
010700     MOVE MBCA-MBDX-ORG          TO DX01-ORG.
010800     MOVE MBCA-MBDX-ORG-NAME     TO DX01-ORG-NAME.
010900     MOVE 01                     TO MBCA-SCREEN-NBR.
011000*
011100****************************************************************
011200*    INITIALIZE THE STANDARD MAP LINES                         *
011300****************************************************************
011400*
011500     PERFORM MB60PD-INIT-STD-MAP-LINES
011600                                 THRU MB60PD-ISML-EXIT.
011700*
011800****************************************************************
011900*    ACQUIRE MAIN STORAGE FOR TEMP STORAGE RECORD              *
012000****************************************************************
012100*
012200     MOVE 'TS01'                 TO MBCA-PROGRAM-LOCATION.
012300     PERFORM 8100-TEMP-STORAGE-GETMAIN
012400                                 THRU 8199-TSG-EXIT.
012500*
012600     EXEC CICS HANDLE CONDITION
012700               QIDERR (1010-CHECK-RETURN-FLAG)
012800          END-EXEC.
012900*
013000***********************************************
013100*    READ THE TEMP STORAGE RECORD             *
013200***********************************************
013300*
013400     MOVE 'TS02'                 TO MBCA-PROGRAM-LOCATION.
013500     PERFORM 8200-TEMP-STORAGE-READ
013600                                 THRU 8299-TSR-EXIT.
013700*
013800***********************************************
013900*    DELETE THE TEMP STORAGE RECORD           *
014000***********************************************
014100*
014200     MOVE 'TS03'                 TO MBCA-PROGRAM-LOCATION.
014300     PERFORM 8300-TEMP-STORAGE-DELETE
014400                                 THRU 8399-TSD-EXIT.
014500*
014600     PERFORM 8800-BUILD-SCREEN   THRU 8899-BS-EXIT.
014700     GO TO 1080-CONTINUE.
014800*
014900 1010-CHECK-RETURN-FLAG.
015000*
015100     IF  MBCA-MBDX-RETURN-BOTTOM
015200         PERFORM 8900-LAST-SCREEN
015300                                 THRU 8999-LS-EXIT
015400         IF  WS-BYPASS-YES
015500             GO TO 1015-READ-MMTC
015600         ELSE
015700             GO TO 1080-CONTINUE
015800     ELSE
015900         IF  MBCA-MBDX-RETURN-BWD
016000             PERFORM 9000-BACK-SCREEN
016100                                 THRU 9099-BS-EXIT
016200             IF  WS-BYPASS-YES
016300                 GO TO 1015-READ-MMTC
016400             ELSE
016500                 GO TO 1080-CONTINUE.
016600*
016700 1015-READ-MMTC.
016800*
016900****************************************************************
017000*    START BROWSE THE MONETARY TRANS FILE                      *
017100****************************************************************
017200*
017300     MOVE 'FC01'                 TO MBCA-PROGRAM-LOCATION.
017400     MOVE MBCA-MBDX-ORG          TO MBIOWS-MMTC-ORG.
017500     MOVE MBCA-MBDX-FWD-TXN-CODE
017600                                 TO MBIOWS-MMTC-TXN-CODE.
017700     SET MBIORO-STARTBR-GTE      TO TRUE.
017800     PERFORM MMTCAO-ACCESS       THRU MMTCAO-ACCESS-EXIT.
017900*
018000     SET X-TXN-INDEX             TO +1.
018100*
018200 1020-READ-LOOP.
018300*
018400****************************************************************
018500*    READNEXT THE MONETARY TRANS FILE                          *
018600****************************************************************
018700*
018800     MOVE 'FC02'                 TO MBCA-PROGRAM-LOCATION.
018900     SET MBIORO-READ-SEQ         TO TRUE.
019000     PERFORM MMTCAO-ACCESS       THRU MMTCAO-ACCESS-EXIT.
019100*
019200     IF  MMTC-ORG    IS GREATER THAN MBCA-MBDX-ORG
019300         GO TO 1020-END-BROWSE.
019400*
019500     PERFORM 9500-BUILD-SCREEN-LINE
019600                                 THRU 9599-BSL-EXIT.
019700*
019800     IF  X-TXN-INDEX IS EQUAL TO +1
019900         MOVE MMTC-TXN-CODE      TO MBCA-MBDX-BACK-TXN-CODE.
020000*
020100     IF  X-TXN-INDEX IS LESS THAN +15
020200         SET X-TXN-INDEX         UP BY +1
020300         GO TO 1020-READ-LOOP
020400     ELSE
020500         MOVE MMTC-TXN-CODE      TO MBCA-MBDX-FWD-TXN-CODE
020600         PERFORM 9400-READ-AHEAD THRU 9499-RA-EXIT
020700         SET X-TXN-INDEX         UP BY +1.
020800*
020900 1020-END-BROWSE.
021000*
021100****************************************************************
021200*    END BROWSE THE MONETARY TRANS FILE                        *
021300****************************************************************
021400*
021500     MOVE 'FC03'                 TO MBCA-PROGRAM-LOCATION.
021600     SET MBIORO-ENDBR            TO TRUE.
021700     PERFORM MMTCAO-ACCESS       THRU MMTCAO-ACCESS-EXIT.
021800*
021900 1060-SET-ATTRIBUTE.
022000*
022100     IF  X-TXN-INDEX IS EQUAL TO +1
022200         IF  MBCA-MBDX-RETURN-NORMAL
022300             SET MBCA-INITIAL-SCREEN-NBR
022400                                 TO TRUE
022500             MOVE 'PC02'         TO MBCA-PROGRAM-LOCATION
022600             PERFORM MB70PD-XCTL-TO-MBOXCTL
022700                                 THRU MB70PD-XTM-EXIT
022800         ELSE
022900             MOVE MBCA-MBDX-BACK-TXN-CODE
023000                                 TO MBCA-MBDX-FWD-TXN-CODE
023100             GO TO 1015-READ-MMTC.
023200*
023300     IF  X-TXN-INDEX IS LESS THAN +16
023400         SET X-MBDXTS-INDEX      TO X-TXN-INDEX
023500         MOVE ZEROES             TO MBCA-MBDX-FWD-TXN-CODE
023600                                    WS-FWD-TXN-CODE
023700                                    MBDXTS-TXN-CODE
023800                                    (X-MBDXTS-INDEX)
023900                                    MBDXTS-LOGIC-MODULE
024000                                    (X-MBDXTS-INDEX)
024100                                    MBDXTS-STATUS-CODE
024200                                    (X-MBDXTS-INDEX)
024300         MOVE SPACES             TO MBDXTS-DESCRIPTION
024400                                    (X-MBDXTS-INDEX)
024500                                    MBDXTS-GL-DR-DESC
024600                                    (X-MBDXTS-INDEX)
024700                                    MBDXTS-GL-CR-DESC
024800                                    (X-MBDXTS-INDEX)
024900         MOVE DFHBMASK           TO DX01-SELECT-A
025000                                    (X-TXN-INDEX)
025100         MOVE DFHBMDAS           TO DX01-DIRECTORY-LINE-A
025200                                    (X-TXN-INDEX)
025300                                    DX01-SELECT-LP-A
025400                                    (X-TXN-INDEX)
025500                                    DX01-SELECT-RP-A
025600                                    (X-TXN-INDEX)
025700         SET X-TXN-INDEX         UP BY +1
025800         GO TO 1060-SET-ATTRIBUTE.
025900*
026000 1080-CONTINUE.
026100*
026200     IF  MBCA-MBDX-BACK-TXN-CODE IS NOT EQUAL
026300                                 TO MBCA-MBDX-FIRST-TXN-CODE
026400         MOVE DFHBMASB           TO DX01-FWD-BACK-IND-A (1).
026500*
026600     IF  WS-FWD-TXN-CODE IS NOT EQUAL TO ZEROES
026700         MOVE DFHBMASB           TO DX01-FWD-BACK-IND-A (15).
026800*
026900****************************************************************
027000*    WRITE THE TEMP STORAGE RECORD                             *
027100****************************************************************
027200*
027300     MOVE 'TS04'                 TO MBCA-PROGRAM-LOCATION.
027400     PERFORM 8400-WRITE-QUEUE    THRU 8499-WQ-EXIT.
027500*
027600     PERFORM 9100-SET-ATTRIBUTE  THRU 9199-SA-EXIT
027700         VARYING X-TXN-INDEX     FROM +1 BY +1
027800         UNTIL   X-TXN-INDEX IS GREATER THAN +15.
027900*
028000     SET X-TXN-INDEX             TO +1.
028100*
028200 1090-CURSOR-LOOP.
028300*
028400     IF  X-TXN-INDEX IS GREATER THAN +15
028500         MOVE SS08WS-CURSOR      TO DX01-ALT-TRANID-L
028600         GO TO 1100-CONTINUE.
028700*
028800     IF  DX01-SELECT-A (X-TXN-INDEX)
028900                                 IS EQUAL TO DFHBMASK
029000         SET X-TXN-INDEX         UP BY +1
029100         GO TO 1090-CURSOR-LOOP
029200     ELSE
029300         MOVE SS08WS-CURSOR      TO DX01-SELECT-L
029400                                    (X-TXN-INDEX).
029500*
029600 1100-CONTINUE.
029700*
029800     MOVE '*TOP*'                TO SS08WS-LINE-24-PF-KEY-FUNC(3).
029900     MOVE '*BOT*'                TO SS08WS-LINE-24-PF-KEY-FUNC(4).
030000     MOVE '*FWD*'                TO SS08WS-LINE-24-PF-KEY-FUNC(5).
030100     MOVE '*BWD*'                TO SS08WS-LINE-24-PF-KEY-FUNC(6).
030200     MOVE SS08WS-LINE-24         TO DX01-PF-KEYS.
030300     MOVE 'RESV'                 TO MBCA-PGMX-PF-TRANS-ID (3).
030400     MOVE 'RESV'                 TO MBCA-PGMX-PF-TRANS-ID (4).
030500     MOVE 'RESV'                 TO MBCA-PGMX-PF-TRANS-ID (5).
030600     MOVE 'RESV'                 TO MBCA-PGMX-PF-TRANS-ID (6).
030700*
030800     MOVE DFHBMASK               TO DX01-CURRENT-PAGE-A.
030900*
031000****************************************************************
031100*    SEND THE MAP                                              *
031200****************************************************************
031300*
031400     MOVE 'BM01'                 TO MBCA-PROGRAM-LOCATION.
031500     PERFORM MB60PD-SEND-MAP-WITH-ERASE
031600                                 THRU MB60PD-SMWE-EXIT.
031700*
031800****************************************************************
031900*    RETURN TO CICS                                            *
032000****************************************************************
032100*
032200     MOVE 'PC03'                 TO MBCA-PROGRAM-LOCATION.
032300     PERFORM MB70PD-RETURN-TRANS-ID
032400                                 THRU MB70PD-RTI-EXIT.
032500/
032600 2000-RECEIVE-SCREEN SECTION.
032700*
032800     IF  MBCA-EIBAID-CLEAR
032900         MOVE 'TS05'             TO MBCA-PROGRAM-LOCATION
033000         PERFORM 8300-TEMP-STORAGE-DELETE
033100                                 THRU 8399-TSD-EXIT
033200         MOVE 'PC04'             TO MBCA-PROGRAM-LOCATION
033300         PERFORM MB70PD-ON-LINE-HOUSEKEEPING
033400                                 THRU MB70PD-OLH-EXIT.
033500*
033600****************************************************************
033700*    THIS SECTION RECEIVES THE 01 SCREEN                       *
033800****************************************************************
033900*
034000     MOVE 'BM02'                 TO MBCA-PROGRAM-LOCATION.
034100     PERFORM MB60PD-RECEIVE-MAP  THRU MB60PD-RM-EXIT.
034200*
034300*****************************************************
034400*    ACQUIRE MAIN STORAGE FOR TEMP STORAGE RECORD   *
034500*****************************************************
034600*
034700     MOVE 'TS06'                 TO MBCA-PROGRAM-LOCATION.
034800     PERFORM 8100-TEMP-STORAGE-GETMAIN
034900                                 THRU 8199-TSG-EXIT.
035000*
035100***********************************************
035200*    READ THE TEMP STORAGE RECORD             *
035300***********************************************
035400*
035500     MOVE 'TS07'                 TO MBCA-PROGRAM-LOCATION.
035600     PERFORM 8200-TEMP-STORAGE-READ
035700                                 THRU 8299-TSR-EXIT.
035800*
035900***********************************************
036000*    DELETE THE TEMP STORAGE RECORD           *
036100***********************************************
036200*
036300     MOVE 'TS08'                 TO MBCA-PROGRAM-LOCATION.
036400     PERFORM 8300-TEMP-STORAGE-DELETE
036500                                 THRU 8399-TSD-EXIT.
036600*
036700****************************************************************
036800*    CHECK FOR ANOTHER TRANSACTION ID ENTERED BY THE USER      *
036900****************************************************************
037000*
037100     MOVE 'PC05'                 TO MBCA-PROGRAM-LOCATION.
037200     PERFORM MB60PD-NEW-TRANS-ROUTINE
037300                                 THRU MB60PD-NTR-EXIT.
037400*
037500 2005-EDIT-SELECT.
037600*
037700****************************************************************
037800*    EDIT SELECT FIELD                                         *
037900****************************************************************
038000*
038100     PERFORM 8600-EDIT-SELECT    THRU 8699-ES-EXIT.
038200*
038300 2090-CHECK-ERROR.
038400*
038500     IF  SS08WS-ERROR-SW-NO
038600         GO TO 2400-CHECK-SELECT.
038700*
038800 2300-SEND-MAP.
038900*
039000***********************************************
039100*    WRITE THE TEMP STORAGE RECORD            *
039200***********************************************
039300*
039400     MOVE 'TS09'                 TO MBCA-PROGRAM-LOCATION.
039500     PERFORM 8400-WRITE-QUEUE    THRU 8499-WQ-EXIT.
039600*
039700****************************************************************
039800*    SEND THE MAP                                              *
039900****************************************************************
040000*
040100     PERFORM MB60PD-INIT-STD-MAP-LINES
040200                                 THRU MB60PD-ISML-EXIT.
040300*
040400     MOVE '*TOP*'                TO SS08WS-LINE-24-PF-KEY-FUNC(3).
040500     MOVE '*BOT*'                TO SS08WS-LINE-24-PF-KEY-FUNC(4).
040600     MOVE '*FWD*'                TO SS08WS-LINE-24-PF-KEY-FUNC(5).
040700     MOVE '*BWD*'                TO SS08WS-LINE-24-PF-KEY-FUNC(6).
040800     MOVE SS08WS-LINE-24         TO DX01-PF-KEYS.
040900     MOVE 'RESV'                 TO MBCA-PGMX-PF-TRANS-ID (3).
041000     MOVE 'RESV'                 TO MBCA-PGMX-PF-TRANS-ID (4).
041100     MOVE 'RESV'                 TO MBCA-PGMX-PF-TRANS-ID (5).
041200     MOVE 'RESV'                 TO MBCA-PGMX-PF-TRANS-ID (6).
041300*
041400     MOVE DFHBMASK               TO DX01-CURRENT-PAGE-A.
041500*
041600     MOVE 'BM03'                 TO MBCA-PROGRAM-LOCATION.
041700     PERFORM MB60PD-SEND-MAP-DATA-ONLY
041800                                 THRU MB60PD-SMDO-EXIT.
041900*
042000****************************************************************
042100*    RETURN TO CICS                                            *
042200****************************************************************
042300*
042400     MOVE 'PC06'                 TO MBCA-PROGRAM-LOCATION.
042500     PERFORM MB70PD-RETURN-TRANS-ID
042600                                 THRU MB70PD-RTI-EXIT.
042700/
042800 2400-CHECK-SELECT.
042900*
043000     IF  WS-SELECT-YES
043100         SET X-MBDXTS-INDEX      TO X-TXN-INDEX
043200         MOVE MBDXTS-TXN-CODE (X-MBDXTS-INDEX)
043300                                 TO MBCA-CHAIN
043400                                    MBCA-MBMX-BEG-TXN-2
043500                                    MBCA-MBMX-END-TXN-2
043600         COMPUTE MBCA-MBMX-END-TXN-2 = MBCA-MBMX-END-TXN-2 - 1
043700         EVALUATE TRUE
043800           WHEN MBCA-MBMX-END-TXN-2 IS LESS THAN 1
043900             MOVE 1              TO MBCA-MBMX-END-TXN-2
044000         END-EVALUATE
044100         MOVE MBIOWS-MMTC-DIRECT-KEY-CODE
044200                                 TO MBCA-KEY-CODE
044300         SET MBCA-INITIAL-SCREEN-NBR
044400                                 TO TRUE
044500         MOVE MBIOWS-MMGD-DIRECT-KEY-CODE
044600                                 TO MBCA-KEY-CODE
044700         MOVE MBCA-MBDX-ORG      TO MBCA-ORG
044800         MOVE MBCA-MBDX-ORG-NAME
044900                                 TO MBCA-MBMX-ORG-NAME
045000         MOVE '03'               TO MBCA-TRANS-LOOP-CONTROL
045100         MOVE 53                 TO MBCA-SCREEN-NBR
045200         IF  DX01-VALID-INQUIRY (X-TXN-INDEX)
045300             MOVE '..QX'         TO SS08WS-WORK-TRANS-ID
045400                                    MBCA-PREV-TRANS-ID
045500             GO TO 2690-PF-KEY-BYPASS
045600         ELSE
045700             IF  DX01-VALID-MAINT (X-TXN-INDEX)
045800                 MOVE '..MX'     TO SS08WS-WORK-TRANS-ID
045900                                    MBCA-PREV-TRANS-ID
046000                 GO TO 2690-PF-KEY-BYPASS.
046100/
046200 2600-SETUP-COMMAREA.
046300*
046400****************************************************************
046500*    SET UP COMMAREA FIELDS AND TRANSFER TO THE NEXT PROGRAM   *
046600****************************************************************
046700*
046800     MOVE MBCA-EIBAID            TO SS08WS-EIBAID.
046900*
047000     IF  SS08WS-VALID-PF3
047100     OR  SS08WS-EIBAID-VALID-PF3
047200         MOVE 51                 TO MBCA-SCREEN-NBR
047300         MOVE MBCA-MBDX-FIRST-TXN-CODE
047400                                 TO MBCA-MBDX-FWD-TXN-CODE
047500         MOVE ' '                TO MBCA-MBDX-RETURN-FLAG
047600         GO TO 2690-PF-KEY-BYPASS.
047700*
047800     IF  SS08WS-VALID-PF4
047900     OR  SS08WS-EIBAID-VALID-PF4
048000         MOVE 51                 TO MBCA-SCREEN-NBR
048100         IF (MBDXTS-TXN-CODE (1) IS GREATER THAN ZEROES
048200         AND MBDXTS-TXN-CODE (15) IS EQUAL TO ZEROES)
048300         OR (MBCA-MBDX-FWD-TXN-CODE IS EQUAL TO ZEROES)
048400             MOVE ' '            TO MBCA-MBDX-RETURN-FLAG
048500             MOVE ZEROES         TO MBCA-MBDX-FWD-TXN-CODE
048600             MOVE 'TS10'         TO MBCA-PROGRAM-LOCATION
048700             PERFORM 8400-WRITE-QUEUE
048800                                 THRU 8499-WQ-EXIT
048900             GO TO 2690-PF-KEY-BYPASS
049000         ELSE
049100             MOVE 'E'            TO MBCA-MBDX-RETURN-FLAG
049200             GO TO 2690-PF-KEY-BYPASS.
049300*
049400     IF  SS08WS-VALID-PF5
049500     OR  SS08WS-EIBAID-VALID-PF5
049600         MOVE 51                 TO MBCA-SCREEN-NBR
049700         IF (MBDXTS-TXN-CODE (1) IS GREATER THAN ZEROES
049800         AND MBDXTS-TXN-CODE (15) IS EQUAL TO ZEROES)
049900         OR (MBCA-MBDX-FWD-TXN-CODE IS EQUAL TO ZEROES)
050000             MOVE ' '            TO MBCA-MBDX-RETURN-FLAG
050100             MOVE ZEROES         TO MBCA-MBDX-FWD-TXN-CODE
050200             MOVE 'TS11'         TO MBCA-PROGRAM-LOCATION
050300             PERFORM 8400-WRITE-QUEUE
050400                                 THRU 8499-WQ-EXIT
050500             GO TO 2690-PF-KEY-BYPASS
050600         ELSE
050700             MOVE 'F'            TO MBCA-MBDX-RETURN-FLAG
050800             ADD 1               TO MBCA-MBDX-FWD-TXN-CODE
050900             GO TO 2690-PF-KEY-BYPASS.
051000*
051100     IF  SS08WS-VALID-PF6
051200     OR  SS08WS-EIBAID-VALID-PF6
051300         MOVE 51                 TO MBCA-SCREEN-NBR
051400         IF  MBCA-MBDX-BACK-TXN-CODE IS EQUAL
051500                                 TO MBCA-MBDX-FIRST-TXN-CODE
051600             MOVE ' '            TO MBCA-MBDX-RETURN-FLAG
051700             MOVE 'TS12'         TO MBCA-PROGRAM-LOCATION
051800             PERFORM 8400-WRITE-QUEUE
051900                                 THRU 8499-WQ-EXIT
052000             GO TO 2690-PF-KEY-BYPASS
052100         ELSE
052200             MOVE MBCA-MBDX-BACK-TXN-CODE
052300                                 TO MBCA-MBDX-FWD-TXN-CODE
052400             MOVE 'B'            TO MBCA-MBDX-RETURN-FLAG
052500             GO TO 2690-PF-KEY-BYPASS.
052600*
052700     IF  SS08WS-VALID-PF-KEY
052800     OR  SS08WS-EIBAID-VALID-PF-KEY
052900     OR  MBDXTS-TXN-CODE (15) IS EQUAL TO ZEROES
053000     OR  MBCA-MBDX-FWD-TXN-CODE IS EQUAL TO ZEROES
053100         SET MBCA-INITIAL-SCREEN-NBR
053200                                 TO TRUE
053300         MOVE MBIOWS-MMTC-KEY-CODE
053400                                 TO MBCA-KEY-CODE
053500         MOVE ' '                TO MBCA-MBDX-RETURN-FLAG
053600         GO TO 2690-PF-KEY-BYPASS.
053700*
053800     MOVE 51                     TO MBCA-SCREEN-NBR.
053900     ADD 1                       TO MBCA-MBDX-FWD-TXN-CODE.
054000     MOVE ' '                    TO MBCA-MBDX-RETURN-FLAG.
054100*
054200 2690-PF-KEY-BYPASS.
054300*
054400     MOVE 'PC07'                 TO MBCA-PROGRAM-LOCATION.
054500     PERFORM MB70PD-XCTL-TO-MBOXCTL
054600                                 THRU MB70PD-XTM-EXIT.
054700/
054800 8000-PERFORMED-ROUTINES-SECT SECTION.
054900*
055000 8100-TEMP-STORAGE-GETMAIN.
055100*
055200     EXEC CICS GETMAIN
055300               FLENGTH (LENGTH  OF MBDXTS-RECORD)
055400               SET     (ADDRESS OF MBDXTS-RECORD)
055500          END-EXEC.
055600*
055700 8199-TSG-EXIT.
055800     EXIT.
055900*
056000 8200-TEMP-STORAGE-READ.
056100*
056200     EXEC CICS READQ TS
056300               QUEUE   (TS-QUEUE-NAME)
056400               INTO    (MBDXTS-RECORD)
056500               LENGTH  (LENGTH  OF MBDXTS-RECORD)
056600               ITEM    (1)
056700          END-EXEC.
056800*
056900 8299-TSR-EXIT.
057000     EXIT.
057100*
057200 8300-TEMP-STORAGE-DELETE.
057300*
057400     EXEC CICS IGNORE CONDITION
057500               QIDERR
057600          END-EXEC.
057700*
057800     EXEC CICS DELETEQ TS
057900               QUEUE  (TS-QUEUE-NAME)
058000          END-EXEC.
058100*
058200 8399-TSD-EXIT.
058300     EXIT.
058400*
058500 8400-WRITE-QUEUE.
058600*
058700     EXEC CICS WRITEQ TS
058800               QUEUE   (TS-QUEUE-NAME)
058900               FROM    (MBDXTS-RECORD)
059000               LENGTH  (LENGTH  OF MBDXTS-RECORD)
059100          END-EXEC.
059200*
059300 8499-WQ-EXIT.
059400     EXIT.
059500*
059600 8600-EDIT-SELECT.
059700*
059800     SET X-TXN-INDEX             TO +1.
059900*
060000 8600-EDIT-LOOP.
060100*
060200     IF  DX01-SELECT-L (X-TXN-INDEX) IS GREATER THAN ZERO
060300         IF  DX01-VALID-SELECT (X-TXN-INDEX)
060400             MOVE DFHBMASF       TO DX01-SELECT-A
060500                                    (X-TXN-INDEX)
060600             MOVE DFHBMDAS       TO DX01-SELECT-LP-A
060700                                    (X-TXN-INDEX)
060800                                    DX01-SELECT-RP-A
060900                                    (X-TXN-INDEX)
061000             IF  DX01-VALID-INQUIRY-MAINT (X-TXN-INDEX)
061100                 MOVE 'Y'        TO WS-SELECT-SW
061200                 GO TO 8699-ES-EXIT
061300             ELSE
061400                 NEXT SENTENCE
061500         ELSE
061600             SET SS08WS-ERROR-SW-YES TO TRUE
061700             MOVE SS08WS-CURSOR  TO DX01-SELECT-L
061800                                    (X-TXN-INDEX)
061900             MOVE DFHBMUBF       TO DX01-SELECT-A
062000                                    (X-TXN-INDEX)
062100             MOVE DFHBMASB       TO DX01-SELECT-LP-A
062200                                    (X-TXN-INDEX)
062300                                    DX01-SELECT-RP-A
062400                                    (X-TXN-INDEX)
062500             GO TO 8699-ES-EXIT.
062600*
062700     IF  X-TXN-INDEX IS LESS THAN +15
062800         SET X-TXN-INDEX         UP BY +1
062900         GO TO 8600-EDIT-LOOP.
063000*
063100 8699-ES-EXIT.
063200     EXIT.
063300*
063400 8800-BUILD-SCREEN.
063500*
063600     SET X-TXN-INDEX             TO +1.
063700*
063800 8800-BUILD-LOOP.
063900*
064000     SET X-MBDXTS-INDEX          TO X-TXN-INDEX.
064100*
064200     IF  MBDXTS-TXN-CODE (X-MBDXTS-INDEX)
064300                                 IS GREATER THAN ZEROES
064400         MOVE MBDXTS-TXN-CODE (X-MBDXTS-INDEX)
064500                                 TO WS-TXN-CODE
064600         MOVE MBDXTS-LOGIC-MODULE (X-MBDXTS-INDEX)
064700                                 TO WS-LOGIC-MODULE
064800         MOVE MBDXTS-DESCRIPTION (X-MBDXTS-INDEX)
064900                                 TO WS-DESCRIPTION
065000         MOVE MBDXTS-GL-DR-DESC (X-MBDXTS-INDEX)
065100                                 TO WS-GL-DR-DESC
065200         MOVE MBDXTS-GL-CR-DESC (X-MBDXTS-INDEX)
065300                                 TO WS-GL-CR-DESC
065400         MOVE MBDXTS-STATUS-CODE (X-MBDXTS-INDEX)
065500                                 TO WS-STATUS-CODE
065600         MOVE WS-DETAIL-LINE     TO DX01-DIRECTORY-LINE
065700                                    (X-TXN-INDEX)
065800     ELSE
065900         MOVE DFHBMASK           TO DX01-SELECT-A
066000                                    (X-TXN-INDEX)
066100         MOVE DFHBMDAS           TO DX01-DIRECTORY-LINE-A
066200                                    (X-TXN-INDEX)
066300                                    DX01-SELECT-LP-A
066400                                    (X-TXN-INDEX)
066500                                    DX01-SELECT-RP-A
066600                                    (X-TXN-INDEX).
066700*
066800     IF  X-TXN-INDEX IS LESS THAN +15
066900         SET X-TXN-INDEX         UP BY +1
067000         GO TO 8800-BUILD-LOOP
067100     ELSE
067200         MOVE MBCA-MBDX-FWD-TXN-CODE
067300                                 TO WS-FWD-TXN-CODE.
067400*
067500 8899-BS-EXIT.
067600     EXIT.
067700*
067800 8900-LAST-SCREEN.
067900*
068000****************************************************************
068100*    START BROWSE THE MONETARY TRANS FILE                      *
068200****************************************************************
068300*
068400     MOVE 'FC04'                 TO MBCA-PROGRAM-LOCATION.
068500     MOVE MBCA-MBDX-ORG          TO MBIOWS-MMTC-ORG.
068600     MOVE 999                    TO MBIOWS-MMTC-TXN-CODE.
068700     SET MBIORO-STARTBR-GTE      TO TRUE.
068800     PERFORM MMTCAO-ACCESS       THRU MMTCAO-ACCESS-EXIT.
068900*
069000****************************************************************
069100*    READNEXT THE MONETARY TRANS FILE                          *
069200****************************************************************
069300*
069400     MOVE 'FC05'                 TO MBCA-PROGRAM-LOCATION.
069500     SET MBIORO-READ-SEQ         TO TRUE.
069600     PERFORM MMTCAO-ACCESS       THRU MMTCAO-ACCESS-EXIT.
069700*
069800****************************************************************
069900*    READPREV THE MONETARY TRANS FILE                          *
070000****************************************************************
070100*
070200     MOVE 'FC06'                 TO MBCA-PROGRAM-LOCATION.
070300     SET MBIORO-READ-PREV        TO TRUE.
070400     PERFORM MMTCAO-ACCESS       THRU MMTCAO-ACCESS-EXIT.
070500*
070600     SET X-TXN-INDEX             TO +15.
070700     MOVE 'N'                    TO WS-BYPASS-SW.
070800*
070900 8900-READ-MMTC-FILE.
071000*
071100****************************************************************
071200*    READPREV THE MONETARY TRANS FILE                          *
071300****************************************************************
071400*
071500     MOVE 'FC07'                 TO MBCA-PROGRAM-LOCATION.
071600     SET MBIORO-READ-PREV        TO TRUE.
071700     PERFORM MMTCAO-ACCESS       THRU MMTCAO-ACCESS-EXIT.
071800*
071900 8900-BUILD-LOOP.
072000*
072100     IF (MMTC-ORG    IS LESS THAN MBCA-MBDX-ORG)
072200     OR (MMTC-ORG    IS EQUAL TO MBCA-MBDX-ORG
072300     AND MMTC-TXN-CODE IS LESS THAN MBCA-MBDX-FIRST-TXN-CODE)
072400         GO TO 8900-END-BROWSE.
072500*
072600     IF  MMTC-TXN-CODE IS EQUAL TO MBCA-MBDX-FIRST-TXN-CODE
072700     AND X-TXN-INDEX IS GREATER THAN +1
072800         MOVE ' '                TO MBCA-MBDX-RETURN-FLAG
072900         MOVE MBCA-MBDX-FIRST-TXN-CODE
073000                                 TO MBCA-MBDX-FWD-TXN-CODE
073100         MOVE 'Y'                TO WS-BYPASS-SW
073200         GO TO 8900-END-BROWSE.
073300*
073400     PERFORM 9500-BUILD-SCREEN-LINE
073500                                 THRU 9599-BSL-EXIT.
073600*
073700     IF  X-TXN-INDEX IS GREATER THAN +1
073800         SET X-TXN-INDEX         DOWN BY +1
073900         GO TO 8900-READ-MMTC-FILE
074000     ELSE
074100         MOVE MMTC-TXN-CODE      TO MBCA-MBDX-BACK-TXN-CODE.
074200*
074300 8900-END-BROWSE.
074400*
074500****************************************************************
074600*    END BROWSE THE MONETARY TRANS FILE                        *
074700****************************************************************
074800*
074900     MOVE 'FC08'                 TO MBCA-PROGRAM-LOCATION.
075000     SET MBIORO-ENDBR            TO TRUE.
075100     PERFORM MMTCAO-ACCESS       THRU MMTCAO-ACCESS-EXIT.
075200*
075300     IF  WS-BYPASS-YES
075400         GO TO 8999-LS-EXIT.
075500*
075600     MOVE ZEROES                 TO MBCA-MBDX-FWD-TXN-CODE
075700                                    WS-FWD-TXN-CODE.
075800*
075900 8999-LS-EXIT.
076000     EXIT.
076100*
076200 9000-BACK-SCREEN.
076300*
076400****************************************************************
076500*    START BROWSE THE MONETARY TRANS FILE                      *
076600****************************************************************
076700*
076800     MOVE 'FC09'                 TO MBCA-PROGRAM-LOCATION.
076900     MOVE MBCA-MBDX-ORG          TO MBIOWS-MMTC-ORG.
077000     MOVE MBCA-MBDX-FWD-TXN-CODE
077100                                 TO MBIOWS-MMTC-TXN-CODE.
077200     SET MBIORO-STARTBR-GTE      TO TRUE.
077300     PERFORM MMTCAO-ACCESS       THRU MMTCAO-ACCESS-EXIT.
077400*
077500****************************************************************
077600*    READNEXT THE MONETARY TRANS FILE                          *
077700****************************************************************
077800*
077900     MOVE 'FC10'                 TO MBCA-PROGRAM-LOCATION.
078000     SET MBIORO-READ-SEQ         TO TRUE.
078100     PERFORM MMTCAO-ACCESS       THRU MMTCAO-ACCESS-EXIT.
078200*
078300****************************************************************
078400*    READPREV THE MONETARY TRANS FILE                          *
078500****************************************************************
078600*
078700     MOVE 'FC11'                 TO MBCA-PROGRAM-LOCATION.
078800     SET MBIORO-READ-PREV        TO TRUE.
078900     PERFORM MMTCAO-ACCESS       THRU MMTCAO-ACCESS-EXIT.
079000*
079100     SET X-TXN-INDEX             TO +15.
079200     MOVE 'N'                    TO WS-BYPASS-SW.
079300*
079400 9000-READ-MMTC-FILE.
079500*
079600****************************************************************
079700*    READPREV THE MONETARY TRANS FILE                          *
079800****************************************************************
079900*
080000     MOVE 'FC12'                 TO MBCA-PROGRAM-LOCATION.
080100     SET MBIORO-READ-PREV        TO TRUE.
080200     PERFORM MMTCAO-ACCESS       THRU MMTCAO-ACCESS-EXIT.
080300*
080400 9000-BUILD-LOOP.
080500*
080600     IF  X-TXN-INDEX IS GREATER THAN +1
080700     AND MMTC-TXN-CODE IS EQUAL TO MBCA-MBDX-FIRST-TXN-CODE
080800         MOVE ' '                TO MBCA-MBDX-RETURN-FLAG
080900         MOVE MBCA-MBDX-FIRST-TXN-CODE
081000                                 TO MBCA-MBDX-FWD-TXN-CODE
081100         MOVE 'Y'                TO WS-BYPASS-SW
081200         GO TO 9000-END-BROWSE.
081300*
081400     IF  MMTC-TXN-CODE IS EQUAL TO MBCA-MBDX-BACK-TXN-CODE
081500     AND X-TXN-INDEX IS EQUAL TO +15
081600         GO TO 9000-READ-MMTC-FILE.
081700*
081800     PERFORM 9500-BUILD-SCREEN-LINE
081900                                 THRU 9599-BSL-EXIT.
082000*
082100     IF  X-TXN-INDEX IS EQUAL TO +15
082200         MOVE MMTC-TXN-CODE      TO MBCA-MBDX-FWD-TXN-CODE
082300                                    WS-FWD-TXN-CODE.
082400*
082500     IF  X-TXN-INDEX IS GREATER THAN +1
082600         SET X-TXN-INDEX         DOWN BY +1
082700         GO TO 9000-READ-MMTC-FILE
082800     ELSE
082900         MOVE MMTC-TXN-CODE      TO MBCA-MBDX-BACK-TXN-CODE.
083000*
083100 9000-END-BROWSE.
083200*
083300****************************************************************
083400*    END BROWSE THE MONETARY TRANS FILE                        *
083500****************************************************************
083600*
083700     MOVE 'FC13'                 TO MBCA-PROGRAM-LOCATION.
083800     SET MBIORO-ENDBR            TO TRUE.
083900     PERFORM MMTCAO-ACCESS       THRU MMTCAO-ACCESS-EXIT.
084000*
084100 9099-BS-EXIT.
084200     EXIT.
084300*
084400 9100-SET-ATTRIBUTE.
084500*
084600     SET X-MBDXTS-INDEX          TO X-TXN-INDEX.
084700*
084800     IF  MBDXTS-STATUS-INCOMPLETE (X-MBDXTS-INDEX)
084900     OR  MBDXTS-STATUS-PURGED (X-MBDXTS-INDEX)
085000         MOVE DFHBMASK           TO DX01-SELECT-A
085100                                    (X-TXN-INDEX)
085200         MOVE DFHBMDAS           TO DX01-SELECT-LP-A
085300                                    (X-TXN-INDEX)
085400                                    DX01-SELECT-RP-A
085500                                    (X-TXN-INDEX).
085600*
085700 9199-SA-EXIT.
085800     EXIT.
085900*
086000 9400-READ-AHEAD.
086100*
086200****************************************************************
086300*    READNEXT THE MONETARY TRANS FILE                          *
086400****************************************************************
086500*
086600     MOVE 'FC14'                 TO MBCA-PROGRAM-LOCATION.
086700     SET MBIORO-READ-SEQ         TO TRUE.
086800     PERFORM MMTCAO-ACCESS       THRU MMTCAO-ACCESS-EXIT.
086900*
087000     IF  MMTC-ORG    IS GREATER THAN MBCA-MBDX-ORG
087100         MOVE ZEROES             TO WS-FWD-TXN-CODE
087200                                    MBCA-MBDX-FWD-TXN-CODE
087300         GO TO 9499-RA-EXIT.
087400*
087500     MOVE MMTC-TXN-CODE          TO WS-FWD-TXN-CODE.
087600*
087700 9499-RA-EXIT.
087800     EXIT.
087900*
088000 9500-BUILD-SCREEN-LINE.
088100*
088200     SET X-MBDXTS-INDEX          TO X-TXN-INDEX.
088300*
088400     MOVE MMTC-TXN-CODE          TO WS-TXN-CODE
088500                                    MBDXTS-TXN-CODE
088600                                    (X-MBDXTS-INDEX).
088700*
088800     MOVE MMTC-LOGIC-MODULE      TO WS-LOGIC-MODULE
088900                                    MBDXTS-LOGIC-MODULE
089000                                    (X-MBDXTS-INDEX).
089100*
089200     MOVE MMTC-RPT-DESC          TO WS-DESCRIPTION
089300                                    MBDXTS-DESCRIPTION
089400                                    (X-MBDXTS-INDEX).
089500*
089600     MOVE MMTC-GL-DR-DESC        TO WS-GL-DR-DESC
089700                                    MBDXTS-GL-DR-DESC
089800                                    (X-MBDXTS-INDEX).
089900*
090000     MOVE MMTC-GL-CR-DESC        TO WS-GL-CR-DESC
090100                                    MBDXTS-GL-CR-DESC
090200                                    (X-MBDXTS-INDEX).
090300*
090400     MOVE MMTC-REC-STATUS        TO WS-STATUS-CODE
090500                                    MBDXTS-STATUS-CODE
090600                                    (X-MBDXTS-INDEX).
090700*
090800     MOVE WS-DETAIL-LINE         TO DX01-DIRECTORY-LINE
090900                                    (X-TXN-INDEX).
091000*
091100 9599-BSL-EXIT.
091200     EXIT.
091300/         JULIAN TO GREGORIAN DATE ROUTINE
091400     COPY SS08PD.
091500/
091600     COPY SS26PD.
091700/
091800     COPY SS27PD.
091900/         LINE 24 PF KEYS ROUTINE
092000     COPY SS15PD.
092100/         MONETARY TRANS RECORD 0 ACCESS ROUTINES
092200     COPY MMTCAO.
092300/         ON-LINE MAP ROUTINES
092400     COPY MB60PD REPLACING 'MBMAPXX' BY 'MBDX01 '
092500                           MBMAPXXI BY MBDX01I
092600                           MBMAPXXO BY MBDX01O.
092700/         ON-LINE PROCEDURES
092800     COPY MB70PD.
092900/
093000     COPY SMFTPXO.
