000100 IDENTIFICATION DIVISION.
000200 PROGRAM-ID. MBOIB00.
000201*       RELEASE DATE=08/24/01.        REVISION LEVEL=08.06      *
000202*****************************************************************
000203*WARNING.  THIS COMPUTER PROGRAM IS PROTECTED BY COPYRIGHT LAW  *
000204*AND INTERNATIONAL TREATIES.  UNAUTHORIZED REPRODUCTION OR      *
000205*DISTRIBUTION OF THIS PROGRAM, OR ANY PORTION OF IT, MAY RESULT *
000206*IN SEVERE CIVIL AND CRIMINAL PENATLIES, AND WILL BE PROSECUTED *
000207*TO THE MAXIMUM EXTENT POSSIBLE UNDER THE LAW.                  *
000208*COPYRIGHT 1999 PAYSYS INTERNATIONAL, INC.  ALL RIGHTS RESERVED.*
000209*****************************************************************
000300*****************************************************************
000400*                                                               *
000500*   V - PLUS  M E R C H A N T   B A N K C A R D   S Y S T E M   *
000600*                                                               *
000700*      MBOIB00 - ON-LINE BATCH INQUIRY LOCATE                   *
000800*                LOCATE SCREEN 00                               *
000900*                                                               *
001000*              1. TRANSID                                       *
001100*                 A. MBIB                                       *
001200*              2. MAPS USED -                                   *
001300*                 A. MBIB00 (LOCATE MAP)                        *
001400*              3. FILES USED -                                  *
001500*                 A. MMSM (STORE MASTER)                        *
001600*                 B. MMD3 (DEPOSIT DETAIL HISTORY REC 3)        *
001700*                 C. MMD4 (DEPOSIT DETAIL HISTORY REC 4)        *
001800*                                                               *
001900*****************************************************************
002000*
002100 ENVIRONMENT DIVISION.
002200*
002300 DATA DIVISION.
002400*
002500 WORKING-STORAGE SECTION.
002600*
002700 01  FILLER                  PIC  X(12)      VALUE
002800     '** WS-BEG **'.
002900*
003000 01  FILLER                  PIC  X(14)      VALUE
003100     'MISCELLANEOUS:'.
003200*
003300 01  WS-MISCELLANEOUS.
003400     03  WS-ORG-LOW          PIC S9(03)      COMP-3
003500                                             VALUE +001.
003600     03  WS-ORG-HIGH         PIC S9(03)      COMP-3
003700                                             VALUE +998.
003800     03  WS-START-D3-SW      PIC  X(01)      VALUE SPACES.
003900         88  WS-START-D3-SW-OK               VALUE 'Y'.
004000         88  WS-START-D3-ERROR               VALUE 'N'.
004100     03  WS-START-D4-SW      PIC  X(01)      VALUE SPACES.
004200         88  WS-START-D4-SW-OK               VALUE 'Y'.
004300         88  WS-START-D4-ERROR               VALUE 'N'.
004400     03  WS-SWITCH           PIC  X(01)      VALUE SPACES.
004500         88  WS-READ                         VALUE 'R'.
004600         88  WS-ENDBR                        VALUE 'E'.
004700     03  TS-QUEUE-NAME.
004800         05  TS-QN-TERMID    PIC  X(04)      VALUE SPACES.
004900         05  TS-QN-TRANID    PIC  X(04)      VALUE 'MBIB'.
005000/
005100 01  FILLER                  PIC  X(29)      VALUE
005200     'I/O REQUEST BLOCK WORK AREAS:'.
005300*
005400     COPY MBIOWS.
005500/
005600 01  FILLER                  PIC  X(18)      VALUE
005700     'I/O REQUEST BLOCK:'.
005800*
005900     COPY MBIORO.
006000/
006100**************************************************
006200*    WORK DEPOSIT DETAIL HISTORY RECORD 3 LAYOUT *
006300**************************************************
006400*
006500     COPY MMD3RL REPLACING ==:MMD3:== BY ==MWD3==.
006600/
006700 01  FILLER                  PIC  X(21)      VALUE
006800     'ERROR MESSAGES TABLE:'.
006900*
007000     COPY MBEMWS.
007100/
007200 01  FILLER                  PIC  X(20)      VALUE
007300     'CCS DATE WORK AREAS:'.
007400*
007500     COPY SS01WS.
007600/
007700 01  FILLER                  PIC  X(27)      VALUE
007800     'CCS CHECK DIGIT WORK AREAS:'.
007900*
008000     COPY SS05WS.
008100/
008200 01  FILLER                  PIC  X(15)      VALUE
008300     'CCS WORK AREAS:'.
008400*
008500     COPY SS08WS.
008600/
008700     COPY SS00WS.
008800/
008900     COPY SMFTWS.
009000/
009100     COPY SMPTRL REPLACING ==:SMPT:== BY ==SMPT==.
009200/
009300     COPY MB61LK.
009400/
009500 01  FILLER                  PIC  X(12)      VALUE
009600     '** WS-END **'.
009700/
009800 LINKAGE SECTION.
009900*
010000 01  DFHCOMMAREA.
010100*
010200     COPY MB60WS.
010300/
010400****************************************
010500*    BATCH INQUIRY LOCATE MAP          *
010600****************************************
010700*
010800     COPY MBIB00.
010900/
011000****************************************************
011100*    BATCH INQUIRY LOCATE MAP REDEFINITION         *
011200****************************************************
011300*
011400     COPY MBIB00R.
011500/
011600***************************
011700*    ORG RECORD LAYOUT    *
011800***************************
011900*
012000     COPY MMOCRL.
012100/
012200***************************************
012300*    STORE MASTER RECORD LAYOUT       *
012400***************************************
012500*
012600     COPY MMSMRL.
012700/
012800*********************************************
012900*    DEPOSIT DETAIL HISTORY RECORD 3 LAYOUT *
013000*********************************************
013100*
013200     COPY MMD3RL REPLACING ==:MMD3:== BY ==MMD3==.
013300/
013400*********************************************
013500*    DEPOSIT DETAIL HISTORY RECORD 4 LAYOUT *
013600*********************************************
013700*
013800     COPY MMD3RL REPLACING ==:MMD3:== BY ==MMD4==.
013900/
014000 PROCEDURE DIVISION.
014100*
014200 A000-HOUSEKEEPING SECTION.
014300*
014400 A020-INIT.
014500*
014600     MOVE 'PC01'                 TO MBCA-PROGRAM-LOCATION.
014700     PERFORM MB70PD-ON-LINE-HOUSEKEEPING
014800                                 THRU MB70PD-OLH-EXIT.
014900*
015000     SET MBCA-MBIB-1ST-TIME-YES  TO TRUE.
015100     MOVE ZEROS                  TO MBCA-MBIB-1ST-BATCH-SEQ
015200                                    MBCA-MBIB-1ST-SEQ-NBR
015300                                    MBCA-MBIB-1ST-MERCHANT.
015400*
015500     IF  MBCA-RECEIVE-SCREEN
015600         GO TO C000-RECEIVE-SCREEN.
015700/
015800 B000-SEND-SCREEN SECTION.
015900*
016000     EXEC CICS IGNORE CONDITION
016100               QIDERR
016200          END-EXEC.
016300*
016400     MOVE MBCA-TERMINAL-ID       TO TS-QN-TERMID.
016500     MOVE 'SC02'                 TO MBCA-PROGRAM-LOCATION.
016600*
016700     EXEC CICS DELETEQ TS
016800               QUEUE  (TS-QUEUE-NAME)
016900          END-EXEC.
017000*********************************************
017100*    GET CICS STORAGE NEEDED FOR THE MAP    *
017200*********************************************
017300*
017400     MOVE 'SC01'                 TO MBCA-PROGRAM-LOCATION.
017500     PERFORM MB60PD-GETMAIN-FOR-MAP
017600                                 THRU MB60PD-GFM-EXIT.
017700*
017800*
017900*****************************************************************
018000*    SEE IF THE MBCA-MERCHANT-ORG IS GREATER THAN ZERO. IF IT   *
018100*    IS, PLUG IT INTO THE MAP. THE THE MBCA-MERCHANT IS GREATER *
018200*    THAN ZERO, PLUG IT INTO THE MAP.                           *
018300*****************************************************************
018400*
018500     IF  MBCA-INITIAL-KEY-CODE
018600         GO TO B020-BUILD-SCREEN.
018700*
018800     IF  MBCA-MMMM-KEY-CODE
018900         IF  MBCA-MERCHANT-ORG IS GREATER THAN ZERO
019000         AND MBCA-MERCHANT      IS GREATER THAN ZERO
019100         AND MBCA-S-M           IS EQUAL TO 'M'
019200             MOVE MBCA-MERCHANT-ORG
019300                                 TO IB00-ORG
019400             MOVE MBCA-MERCHANT  TO IB00-MERCHANT
019500             MOVE MBCA-S-M       TO IB00-SM-FLAG
019600             MOVE DFHBMUNF       TO IB00-ORG-A
019700                                    IB00-MERCHANT-A
019800             MOVE DFHBMFSE       TO IB00-SM-FLAG-A
019900                 GO TO B020-BUILD-SCREEN.
020000*
020100     IF  MBCA-MMMM-KEY-CODE
020200         IF  MBCA-MERCHANT-ORG IS GREATER THAN ZERO
020300         AND MBCA-MERCHANT      IS GREATER THAN ZERO
020400         AND MBCA-S-M           IS EQUAL TO 'S'
020500             MOVE MBCA-MERCHANT-ORG
020600                                 TO IB00-ORG
020700             MOVE MBCA-MERCHANT  TO IB00-MERCHANT
020800             MOVE MBCA-S-M       TO IB00-SM-FLAG
020900             MOVE DFHBMUNF       TO IB00-ORG-A
021000                                    IB00-MERCHANT-A
021100             MOVE DFHBMFSE       TO IB00-SM-FLAG-A
021200                 GO TO B020-BUILD-SCREEN.
021300*
021400     IF  MBCA-VALID-KEY-CODES
021500         IF  MBCA-MERCHANT-ORG IS GREATER THAN ZERO
021600             MOVE MBCA-MERCHANT-ORG
021700                                 TO IB00-ORG
021800             MOVE DFHBMUNF       TO IB00-ORG-A
021900             IF  MBCA-MERCHANT IS GREATER THAN ZERO
022000                 MOVE MBCA-MERCHANT
022100                                 TO IB00-MERCHANT
022200                 MOVE DFHBMUNF   TO IB00-MERCHANT-A
022300                 MOVE MBCA-S-M   TO IB00-SM-FLAG
022400                 MOVE DFHBMFSE   TO IB00-SM-FLAG-A.
022500*
022600 B020-BUILD-SCREEN.
022700*
022800*******************************************
022900*    INITIALIZE THE STANDARD MAP LINES    *
023000*******************************************
023100*
023200     MOVE SS08WS-CURSOR          TO IB00-ORG-L.
023300     MOVE 00                     TO MBCA-SCREEN-NBR.
023400     PERFORM MB60PD-INIT-STD-MAP-LINES
023500                                 THRU MB60PD-ISML-EXIT.
023600*
023700     MOVE DFHBMASK               TO IB00-CURRENT-PAGE-A.
023800*
023900**********************
024000*    SEND THE MAP    *
024100**********************
024200*
024300     MOVE 'BM01'                 TO MBCA-PROGRAM-LOCATION.
024400     PERFORM MB60PD-SEND-MAP-WITH-ERASE
024500                                 THRU MB60PD-SMWE-EXIT.
024600*
024700************************
024800*    RETURN TO CICS    *
024900************************
025000*
025100     MOVE 'PC02'                 TO MBCA-PROGRAM-LOCATION.
025200     PERFORM MB70PD-RETURN-TRANS-ID
025300                                 THRU MB70PD-RTI-EXIT.
025400/
025500 C000-RECEIVE-SCREEN SECTION.
025600*
025700*************************************************
025800*    THIS SECTION RECEIVES THE LOCATE SCREEN    *
025900*************************************************
026000*
026100     MOVE 'BM02'                 TO MBCA-PROGRAM-LOCATION.
026200     PERFORM MB60PD-RECEIVE-MAP  THRU MB60PD-RM-EXIT.
026300*
026400**************************************************************
026500*    CHECK FOR ANOTHER TRANSACTION ID ENTERED BY THE USER    *
026600**************************************************************
026700*
026800     MOVE 'PC03'                 TO MBCA-PROGRAM-LOCATION.
026900     PERFORM MB60PD-NEW-TRANS-ROUTINE
027000                                 THRU MB60PD-NTR-EXIT.
027100*
027200 C020-FIELD-EDITS.
027300*
027400     MOVE 'N'                    TO SS08WS-ERROR.
027500     MOVE MBCA-EIBAID            TO SS08WS-EIBAID.
027600*
027700     IF  (IB00-ORG-L IS LESS THAN 1
027800     AND  IB00-MERCHANT-L IS LESS THAN 1
027900     AND  IB00-SM-FLAG-L IS LESS THAN 1)
028000     AND (SS08WS-VALID-PF-KEY
028100     OR   SS08WS-EIBAID-VALID-PF-KEY)
028200         SET MBCA-INITIAL-SCREEN-NBR
028300                                 TO TRUE
028400         GO TO F090-TRANSFER-XCTL.
028500*
028600******************************************************
028700*    RESET THE FIELD ATTRIBUTES TO THEIR NORMAL      *
028800*    PRIOR STATE PRIOR TO ANY EDITING BEING DONE.    *
028900******************************************************
029000*
029100     MOVE DFHBMUNN               TO IB00-ORG-A
029200                                    IB00-MERCHANT-A
029300                                    IB00-BATCH-NBR-A
029400                                    IB00-BATCH-SOURCE-A.
029500     MOVE DFHBMUNP               TO IB00-SM-FLAG-A
029600                                    IB00-BATCH-DATE-A.
029700     MOVE DFHBMASK               TO IB00-ORG-LP-A
029800                                    IB00-ORG-RP-A
029900                                    IB00-MERCHANT-LP-A
030000                                    IB00-MERCHANT-RP-A
030100                                    IB00-SM-FLAG-LP-A
030200                                    IB00-SM-FLAG-RP-A
030300                                    IB00-BATCH-DATE-LP-A
030400                                    IB00-BATCH-DATE-RP-A
030500                                    IB00-BATCH-SOURCE-LP-A
030600                                    IB00-BATCH-SOURCE-RP-A
030700                                    IB00-BATCH-NBR-LP-A
030800                                    IB00-BATCH-NBR-RP-A.
030900*
031000*
031100 C040-EDIT-ORG.
031200*
031300     IF  IB00-ORG-L IS EQUAL TO ZERO
031400     OR  IB00-ORG IS NOT NUMERIC
031500     OR  IB00-ORG IS LESS THAN MBCA-ORG-LOW
031600     OR  IB00-ORG IS GREATER THAN MBCA-ORG-HIGH
031700     OR  IB00-ORG IS LESS THAN WS-ORG-LOW
031800     OR  IB00-ORG IS GREATER THAN WS-ORG-HIGH
031900         MOVE MBEMWS-INVALID-ORG TO IB00-ERR-MESSAGE
032000         GO TO C048-ORG-ERROR.
032100*
032200 C042-READ-ORG.
032300*
032400************************************************
032500*    READ THE ORGANIZATION RECORD.  IT MUST    *
032600*    BE ON FILE AND AN ACTIVE RECORD.          *
032700************************************************
032800*
032900     MOVE IB00-ORG               TO MBIOWS-MMOC-ORG.
033000     MOVE 'FC01'                 TO MBCA-PROGRAM-LOCATION.
033100     MOVE SS08WS-CICS-FC-NOTFND  TO MBIORO-TEMP-STATUS-1.
033200     SET MBIORO-READ-RANDOM      TO TRUE.
033300     PERFORM MMOCAO-ACCESS       THRU MMOCAO-ACCESS-EXIT.
033400*
033500     IF  SS08WS-RC-FC-NOTFND
033600         MOVE MBEMWS-NOT-ON-FILE TO IB00-ERR-MESSAGE
033700     ELSE
033800         IF  MMOC-ADD-PENDING
033900             MOVE MBEMWS-ADD-PENDING
034000                                 TO IB00-ERR-MESSAGE
034100         ELSE
034200             IF  MMOC-REC-PURGED
034300                 MOVE MBEMWS-NOT-ACTIVE
034400                                 TO IB00-ERR-MESSAGE
034500             ELSE
034600                 MOVE MMOC-CURRENCY-CODE
034700                                 TO MBCA-CURRENCY-CODE
034800                 MOVE MMOC-CURRENCY-NOD
034900                                 TO MBCA-CURRENCY-NOD
035000                 MOVE MMOC-PER-ITEM-NOD
035100                                 TO MBCA-PER-ITEM-NOD
035200                 MOVE MMOC-PERCENT-NOD
035300                                 TO MBCA-PERCENT-NOD
035400                 MOVE DFHBMUNF   TO IB00-ORG-A
035500                 MOVE IB00-ORG   TO MBCA-MERCHANT-ORG
035600                                    MBCA-MBIB-1ST-ORG
035700                 GO TO C060-EDIT-MERCHANT.
035800*
035900 C048-ORG-ERROR.
036000*
036100     SET SS08WS-ERROR-SW-YES     TO TRUE.
036200     MOVE DFHBMASB               TO IB00-ORG-LP-A
036300                                    IB00-ORG-RP-A.
036400     MOVE SS08WS-CURSOR          TO IB00-ORG-L.
036500     MOVE DFHBMNBF               TO IB00-ORG-A.
036600     MOVE DFHBMUNF               TO IB00-MERCHANT-A
036700                                    IB00-BATCH-NBR-A
036800                                    IB00-BATCH-SOURCE-A.
036900     MOVE DFHBMFSE               TO IB00-SM-FLAG-A
037000                                    IB00-BATCH-DATE-A.
037100     GO TO D000-RETURN-ERRORS.
037200*
037300 C060-EDIT-MERCHANT.
037400*
037500     IF  IB00-MERCHANT-L IS EQUAL TO ZERO
037600     OR  IB00-MERCHANT IS NOT NUMERIC
037700     OR  IB00-MERCHANT IS EQUAL TO ZEROS OR 999999999
037800         NEXT SENTENCE
037900     ELSE
038000         MOVE DFHBMUNF           TO IB00-MERCHANT-A
038100         GO TO C080-EDIT-SM-FLAG.
038200*
038300 C065-MERCHANT-ERROR.
038400*
038500     SET SS08WS-ERROR-SW-YES     TO TRUE.
038600     MOVE DFHBMASB               TO IB00-MERCHANT-LP-A
038700                                    IB00-MERCHANT-RP-A.
038800     MOVE SS08WS-CURSOR          TO IB00-MERCHANT-L.
038900     MOVE DFHBMNBF               TO IB00-MERCHANT-A.
039000     GO TO D000-RETURN-ERRORS.
039100*
039200 C080-EDIT-SM-FLAG.
039300*
039400     IF  IB00-SM-FLAG-L IS GREATER THAN ZEROS
039500     AND IB00-VALID-SM-FLAG
039600         MOVE DFHBMFSE           TO IB00-SM-FLAG-A
039700         MOVE IB00-SM-FLAG       TO MBCA-S-M
039800         GO TO C100-READ-MASTER-FILE
039900     ELSE
040000         MOVE MBEMWS-INVALID-S-M
040100                                 TO IB00-ERR-MESSAGE
040200         GO TO C085-SM-ERROR.
040300*
040400 C085-SM-ERROR.
040500*
040600     SET SS08WS-ERROR-SW-YES     TO TRUE.
040700     MOVE DFHBMASB               TO IB00-SM-FLAG-LP-A
040800                                    IB00-SM-FLAG-RP-A.
040900     MOVE SS08WS-CURSOR          TO IB00-SM-FLAG-L.
041000     MOVE DFHBMUNF               TO IB00-MERCHANT-A.
041100     MOVE DFHBMUBF               TO IB00-SM-FLAG-A.
041200     GO TO D000-RETURN-ERRORS.
041300*
041400 C100-READ-MASTER-FILE.
041500*
041600*************************************************************
041700*    READ THE MERCHANT MASTER RECORD OR STORE MASTER        *
041800*    RECORD, DEPENDING ON THE S/M FLAG.  THE MERCHANT OR    *
041900*    STORE MUST BE ON FILE AND AN ACTIVE RECORD.            *
042000*************************************************************
042100*
042200     IF  IB00-SM-FLAG IS EQUAL TO 'S'
042300         MOVE 'FC02'             TO MBCA-PROGRAM-LOCATION
042400         PERFORM Y520-READ-MMSM  THRU Y529-READ-MMSM-EXIT
042500         IF  (SS08WS-RC-FC-VALID-RTN-CODE
042600         AND NOT MMSM-REC-PURGED)
042700             MOVE IB00-MERCHANT  TO MBCA-MERCHANT
042800             MOVE MMSM-MERCHANT-ID
042900                                 TO MBCA-MBIB-1ST-MERCHANT
043000             MOVE MMSM-STORE     TO MBCA-MBIB-1ST-STORE
043100             GO TO C120-EDIT-BATCH-DATE
043200         ELSE
043300             IF  NOT SS08WS-RC-FC-VALID-RTN-CODE
043400                 MOVE MBEMWS-NOT-ON-STORE-MASTER
043500                                 TO IB00-ERR-MESSAGE
043600                 GO TO C065-MERCHANT-ERROR
043700             ELSE
043800                 MOVE MBEMWS-MERCH-NOT-ACTIVE
043900                                 TO IB00-ERR-MESSAGE
044000                 GO TO C065-MERCHANT-ERROR
044100     ELSE
044200         IF  IB00-SM-FLAG IS EQUAL TO 'M'
044300             MOVE IB00-MERCHANT  TO MBCA-MERCHANT
044400                                    MBCA-MBIB-1ST-MERCHANT
044500             MOVE ZEROS          TO MBCA-MBIB-1ST-STORE
044600             GO TO C120-EDIT-BATCH-DATE.
044700*
044800 C120-EDIT-BATCH-DATE.
044900*
045000     MOVE DFHBMDAS               TO IB00-BATCH-DATE-LP-A
045100                                    IB00-BATCH-DATE-RP-A.
045200     MOVE DFHBMASK               TO IB00-BATCH-DATE-A.
045300*
045400     IF  IB00-BATCH-DATE-L IS EQUAL TO ZERO
045500         MOVE ZEROS              TO MBCA-MBIB-1ST-BATCH-DATE
045600         GO TO C140-EDIT-BATCH-NBR.
045700*
045800     IF  IB00-BATCH-DATE IS NOT NUMERIC
045900         GO TO C127-BATCH-DATE-ERROR.
046000*
046100     IF  IB00-BATCH-DATE IS LESS THAN 1000000
046200         MOVE IB00-BATCH-DATE    TO SS01WS-MDY
046300         MOVE SS01WS-MDYZ        TO SS01WS-DATEZ
046400     ELSE
046500         MOVE IB00-BATCH-DATE    TO SS01WS-DATE.
046600*
046700     PERFORM SS05PD-DATE-VALIDATION
046800                                 THRU SS05PD-DV-EXIT.
046900*
047000     IF  SS01WS-DATE-IS-INVALID
047100         GO TO C127-BATCH-DATE-ERROR
047200     ELSE
047300         MOVE SS01WS-DATE        TO IB00-BATCH-DATE
047400         PERFORM SS07PD-GREG-TO-JUL
047500                                 THRU SS07PD-GTJ-EXIT
047600         MOVE SS01WS-JULIAN      TO MBCA-MBIB-1ST-BATCH-DATE.
047700*
047800     IF  IB00-BATCH-DATE-L IS GREATER THAN ZERO
047900         MOVE DFHBMASF           TO IB00-BATCH-DATE-A
048000         GO TO C140-EDIT-BATCH-NBR.
048100*
048200 C127-BATCH-DATE-ERROR.
048300*
048400     IF  IB00-BATCH-DATE-L IS GREATER THAN ZERO
048500         MOVE DFHBMNBF           TO IB00-BATCH-DATE-A
048600     ELSE
048700         MOVE DFHBMUNB           TO IB00-BATCH-DATE-A.
048800*
048900     MOVE DFHBMUNF               TO IB00-BATCH-NBR-A
049000                                    IB00-BATCH-SOURCE-A.
049100
049200     SET SS08WS-ERROR-SW-YES     TO TRUE.
049300     MOVE DFHBMASB               TO IB00-BATCH-DATE-LP-A
049400                                    IB00-BATCH-DATE-RP-A.
049500     MOVE SS08WS-CURSOR          TO IB00-BATCH-DATE-L.
049600     GO TO D000-RETURN-ERRORS.
049700*
049800 C140-EDIT-BATCH-NBR.
049900*
050000     MOVE DFHBMDAS               TO IB00-BATCH-NBR-LP-A
050100                                    IB00-BATCH-NBR-RP-A.
050200     MOVE DFHBMASK               TO IB00-BATCH-NBR-A.
050300*
050400     IF  IB00-BATCH-NBR-L IS GREATER THAN ZERO
050500         MOVE DFHBMASF           TO IB00-BATCH-NBR-A
050600         IF  IB00-BATCH-NBR IS NOT NUMERIC
050700             GO TO C148-BATCH-NBR-ERROR
050800         ELSE
050900             MOVE IB00-BATCH-NBR TO MBCA-MBIB-1ST-BATCH-NBR
051000     ELSE
051100         MOVE ZEROS              TO MBCA-MBIB-1ST-BATCH-NBR.
051200*
051300     GO TO C160-EDIT-BATCH-SOURCE.
051400*
051500 C148-BATCH-NBR-ERROR.
051600*
051700     IF  IB00-BATCH-NBR-L IS GREATER THAN ZERO
051800         MOVE DFHBMNBF           TO IB00-BATCH-NBR-A
051900     ELSE
052000         MOVE DFHBMUNB           TO IB00-BATCH-NBR-A.
052100*
052200     SET SS08WS-ERROR-SW-YES     TO TRUE.
052300     MOVE DFHBMASB               TO IB00-BATCH-NBR-LP-A
052400                                    IB00-BATCH-NBR-RP-A.
052500     MOVE SS08WS-CURSOR          TO IB00-BATCH-NBR-L.
052600     GO TO D000-RETURN-ERRORS.
052700*
052800 C160-EDIT-BATCH-SOURCE.
052900*
053000     MOVE DFHBMDAS               TO IB00-BATCH-SOURCE-LP-A
053100                                    IB00-BATCH-SOURCE-RP-A.
053200     MOVE DFHBMASK               TO IB00-BATCH-SOURCE-A.
053300*
053400     IF  IB00-BATCH-SOURCE-L IS GREATER THAN ZERO
053500         MOVE DFHBMASF           TO IB00-BATCH-SOURCE-A
053600         IF  IB00-BATCH-SOURCE IS NOT NUMERIC
053700             GO TO C168-BATCH-SOURCE-ERROR
053800         ELSE
053900             MOVE IB00-BATCH-SOURCE
054000                                 TO MBCA-MBIB-1ST-BATCH-SOURCE
054100     ELSE
054200         MOVE ZEROS              TO MBCA-MBIB-1ST-BATCH-SOURCE.
054300*
054400     GO TO C200-SET-SEARCH-FLAG.
054500*
054600 C168-BATCH-SOURCE-ERROR.
054700*
054800     IF  IB00-BATCH-SOURCE-L IS GREATER THAN ZERO
054900         MOVE DFHBMNBF           TO IB00-BATCH-SOURCE-A
055000     ELSE
055100         MOVE DFHBMUNB           TO IB00-BATCH-SOURCE-A.
055200*
055300     SET SS08WS-ERROR-SW-YES     TO TRUE.
055400     MOVE DFHBMASB               TO IB00-BATCH-SOURCE-LP-A
055500                                    IB00-BATCH-SOURCE-RP-A.
055600     MOVE SS08WS-CURSOR          TO IB00-BATCH-SOURCE-L.
055700     GO TO D000-RETURN-ERRORS.
055800*
055900 C200-SET-SEARCH-FLAG.
056000*
056100     IF  MBCA-MBIB-1ST-ORG IS GREATER THAN ZEROS
056200     AND MBCA-MBIB-1ST-MERCHANT IS GREATER THAN ZEROS
056300     AND MBCA-MBIB-1ST-STORE IS GREATER THAN ZEROS
056400     AND MBCA-MBIB-1ST-BATCH-DATE IS GREATER THAN ZEROS
056500     AND MBCA-MBIB-1ST-BATCH-SOURCE IS GREATER THAN ZEROS
056600     AND MBCA-MBIB-1ST-BATCH-NBR IS GREATER THAN ZEROS
056700         MOVE '6'                TO MBCA-MBIB-SEARCH-KEY
056800         GO TO C500-CHECK-MMD3-RECORD.
056900*
057000     IF  MBCA-MBIB-1ST-ORG IS GREATER THAN ZEROS
057100     AND MBCA-MBIB-1ST-MERCHANT IS GREATER THAN ZEROS
057200     AND MBCA-MBIB-1ST-STORE IS GREATER THAN ZEROS
057300     AND MBCA-MBIB-1ST-BATCH-DATE IS GREATER THAN ZEROS
057400     AND MBCA-MBIB-1ST-BATCH-SOURCE IS GREATER THAN ZEROS
057500         MOVE '5'                TO MBCA-MBIB-SEARCH-KEY
057600         GO TO C500-CHECK-MMD3-RECORD.
057700*
057800     IF  MBCA-MBIB-1ST-ORG IS GREATER THAN ZEROS
057900     AND MBCA-MBIB-1ST-MERCHANT IS GREATER THAN ZEROS
058000     AND MBCA-MBIB-1ST-STORE IS GREATER THAN ZEROS
058100     AND MBCA-MBIB-1ST-BATCH-DATE IS GREATER THAN ZEROS
058200         MOVE '4'                TO MBCA-MBIB-SEARCH-KEY
058300         GO TO C500-CHECK-MMD3-RECORD.
058400*
058500     IF  MBCA-MBIB-1ST-ORG IS GREATER THAN ZEROS
058600     AND MBCA-MBIB-1ST-MERCHANT IS GREATER THAN ZEROS
058700     AND MBCA-MBIB-1ST-STORE IS GREATER THAN ZEROS
058800         MOVE '3'                TO MBCA-MBIB-SEARCH-KEY
058900         GO TO C500-CHECK-MMD3-RECORD.
059000*
059100     IF  MBCA-MBIB-1ST-ORG IS GREATER THAN ZEROS
059200     AND MBCA-MBIB-1ST-MERCHANT IS GREATER THAN ZEROS
059300         MOVE '2'                TO MBCA-MBIB-SEARCH-KEY
059400         GO TO C500-CHECK-MMD3-RECORD.
059500*
059600     IF  MBCA-MBIB-1ST-ORG IS GREATER THAN ZEROS
059700         MOVE '1'                TO MBCA-MBIB-SEARCH-KEY
059800         GO TO C500-CHECK-MMD3-RECORD.
059900*
060000**********************************************************
060100*    READ THE DEPOSIT DETAIL RECORD USING THE KEY        *
060200*    INFORMATION PROVIDED TO DO A START BROWSE           *
060300**********************************************************
060400*
060500 C500-CHECK-MMD3-RECORD.
060600*
060700     MOVE SPACES                 TO MBCA-MBIB-RETURN-FLAG.
060800     SET MBCA-MBIB-FILE3         TO TRUE.
060900*
061000     PERFORM Y530-START-MMD3     THRU Y539-MMD3-EXIT.
061100*
061200     IF  WS-START-D3-SW-OK
061300         MOVE MBCA-MBIB-1ST-KEY  TO MBCA-MBIB-FWD-KEY
061400                                    MBCA-MBIB-PAGE-1-KEY
061500         GO TO F000-SETUP-COMMAREA
061600     ELSE
061700         SET MBCA-MBIB-FILE4     TO TRUE.
061800*
061900     PERFORM Y540-START-MMD4     THRU Y549-MMD4-EXIT.
062000*
062100     IF  WS-START-D4-SW-OK
062200         MOVE MBCA-MBIB-1ST-KEY  TO MBCA-MBIB-FWD-KEY
062300                                    MBCA-MBIB-PAGE-1-KEY
062400         GO TO F000-SETUP-COMMAREA.
062500*
062600     IF  SS08WS-ERROR-SW-YES
062700         MOVE DFHBMASK           TO IB00-ORG-LP-A
062800                                    IB00-ORG-RP-A
062900                                    IB00-MERCHANT-LP-A
063000                                    IB00-MERCHANT-RP-A
063100                                    IB00-SM-FLAG-LP-A
063200                                    IB00-SM-FLAG-RP-A
063300                                    IB00-BATCH-DATE-LP-A
063400                                    IB00-BATCH-DATE-RP-A
063500                                    IB00-BATCH-NBR-LP-A
063600                                    IB00-BATCH-NBR-RP-A
063700                                    IB00-BATCH-SOURCE-LP-A
063800                                    IB00-BATCH-SOURCE-RP-A
063900         MOVE SS08WS-CURSOR      TO IB00-ORG-L
064000         MOVE DFHBMUNF           TO IB00-ORG-A
064100                                    IB00-MERCHANT-A
064200                                    IB00-BATCH-NBR-A
064300                                    IB00-BATCH-SOURCE-A
064400                                    IB00-BATCH-DATE-A
064500         MOVE DFHBMFSE           TO IB00-SM-FLAG-A
064600         GO TO D000-RETURN-ERRORS.
064700/
064800*
064900 D000-RETURN-ERRORS SECTION.
065000*
065100     IF  SS08WS-ERROR-SW-NO
065200         GO TO F000-SETUP-COMMAREA
065300     ELSE
065400         IF  SS08WS-VALID-PF-KEY
065500         OR  SS08WS-EIBAID-VALID-PF-KEY
065600             SET MBCA-INITIAL-SCREEN-NBR
065700                                 TO TRUE
065800             GO TO F090-TRANSFER-XCTL.
065900*
066000***************************************************************
066100*    INITIALIZE THE STANDARD MAP LINES.  IN AN ERROR          *
066200*    CONDITION, THIS ROUTINE IS PERFORMED PRIMARILY           *
066300*    TO UPDATE THE DATE AND TIME ON THE SCREEN.               *
066400***************************************************************
066500*
066600     PERFORM MB60PD-INIT-STD-MAP-LINES
066700                                 THRU MB60PD-ISML-EXIT.
066800*
066900     MOVE DFHBMASK               TO IB00-CURRENT-PAGE-A.
067000*
067100**********************
067200*    SEND THE MAP    *
067300**********************
067400*
067500     MOVE 'BM03'                 TO MBCA-PROGRAM-LOCATION.
067600     PERFORM MB60PD-SEND-MAP-WITH-ERASE
067700                                 THRU MB60PD-SMWE-EXIT.
067800*
067900************************
068000*    RETURN TO CICS    *
068100************************
068200*
068300     MOVE 'PC04'                 TO MBCA-PROGRAM-LOCATION.
068400     PERFORM MB70PD-RETURN-TRANS-ID
068500                                 THRU MB70PD-RTI-EXIT.
068600/
068700 F000-SETUP-COMMAREA SECTION.
068800*
068900***************************************************************
069000*  SET UP COMMAREA FIELDS AND TRANSFER TO THE NEXT PROGRAM    *
069100***************************************************************
069200*
069300     MOVE MBCA-EIBAID            TO SS08WS-EIBAID.
069400*
069500     MOVE MBIOWS-MMMM-DIRECT-KEY-CODE
069600                                 TO MBCA-KEY-CODE.
069700*
069800     PERFORM MB60PD-EDIT-PAGE-NBR
069900                                 THRU MB60PD-EPN-EXIT.
070000*
070100     IF  SS08WS-VALID-PF-KEY
070200     OR  SS08WS-EIBAID-VALID-PF-KEY
070300         SET MBCA-INITIAL-SCREEN-NBR
070400                                 TO TRUE.
070500*
070600 F090-TRANSFER-XCTL.
070700*
070800     SET MBCA-MBIB-FILE3         TO TRUE.
070900     MOVE 'PC05'                 TO MBCA-PROGRAM-LOCATION.
071000     PERFORM MB70PD-XCTL-TO-MBOXCTL
071100                                 THRU MB70PD-XTM-EXIT.
071200/
071300 Y000-PERFORMED-ROUTINES SECTION.
071400*
071500 Y520-READ-MMSM.
071600*
071700      MOVE IB00-ORG              TO MBIOWS-MMSM-ORG.
071800      MOVE IB00-MERCHANT         TO MBIOWS-MMSM-STORE.
071900      SET MBIORO-READ-RANDOM     TO TRUE.
072000      MOVE SS08WS-CICS-FC-NOTFND TO MBIORO-TEMP-STATUS-1.
072100      PERFORM MMSMAO-ACCESS      THRU MMSMAO-ACCESS-EXIT.
072200*
072300 Y529-READ-MMSM-EXIT.
072400      EXIT.
072500*
072600 Y530-START-MMD3.
072700*
072800     MOVE MBCA-MBIB-1ST-KEY      TO MBIOWS-MMD3-KEY.
072900     MOVE 'FC03'                 TO MBCA-PROGRAM-LOCATION.
073000     MOVE SS08WS-CICS-FC-NOTFND  TO MBIORO-TEMP-STATUS-1.
073100     SET MBIORO-STARTBR-GTE      TO TRUE.
073200     PERFORM MMD3AO-ACCESS       THRU MMD3AO-ACCESS-EXIT.
073300*
073400     IF  SS08WS-RC-FC-NOTFND
073500         GO TO Y539-MMD3-EXIT.
073600*
073700 Y531-READ-MMD3.
073800*
073900     MOVE 'FC04'                 TO MBCA-PROGRAM-LOCATION.
074000     SET MBIORO-READ-SEQ         TO TRUE.
074100     PERFORM MMD3AO-ACCESS       THRU MMD3AO-ACCESS-EXIT.
074200*
074300     MOVE MMD3-RECORD            TO MWD3-RECORD.
074400*
074500     IF  MMD3-HEADER
074600         GO TO Y531-READ-MMD3.
074700*
074800     IF  MMD3-TRAILER
074900         SET MBCA-MBIB-FILE4     TO TRUE
075000         GO TO Y535-MMD3-ENDBR.
075100*
075200     IF  MBCA-MBIB-SEARCH-KEY IS EQUAL TO '6'
075300         MOVE SPACES             TO WS-SWITCH
075400         PERFORM Y770-SEARCH-6   THRU Y779-EXIT
075500         IF  WS-READ
075600             GO TO Y531-READ-MMD3
075700         ELSE
075800             IF  WS-ENDBR
075900                 GO TO Y535-MMD3-ENDBR.
076000*
076100     IF  MBCA-MBIB-SEARCH-KEY IS EQUAL TO '5'
076200         MOVE SPACES             TO WS-SWITCH
076300         PERFORM Y780-SEARCH-5   THRU Y789-EXIT
076400         IF  WS-READ
076500             GO TO Y531-READ-MMD3
076600         ELSE
076700             IF  WS-ENDBR
076800                 GO TO Y535-MMD3-ENDBR.
076900*
077000     IF  MBCA-MBIB-SEARCH-KEY IS EQUAL TO '4'
077100         MOVE SPACES             TO WS-SWITCH
077200         PERFORM Y790-SEARCH-4   THRU Y799-EXIT
077300         IF  WS-READ
077400             GO TO Y531-READ-MMD3
077500         ELSE
077600             IF  WS-ENDBR
077700                 GO TO Y535-MMD3-ENDBR.
077800*
077900     IF  MBCA-MBIB-SEARCH-KEY IS EQUAL TO '3'
078000         MOVE SPACES             TO WS-SWITCH
078100         PERFORM Y800-SEARCH-3   THRU Y809-EXIT
078200         IF  WS-READ
078300             GO TO Y531-READ-MMD3
078400         ELSE
078500             IF  WS-ENDBR
078600                 GO TO Y535-MMD3-ENDBR.
078700*
078800     IF  MBCA-MBIB-SEARCH-KEY IS EQUAL TO '2'
078900         MOVE SPACES             TO WS-SWITCH
079000         PERFORM Y810-SEARCH-2   THRU Y819-EXIT
079100         IF  WS-READ
079200             GO TO Y531-READ-MMD3
079300         ELSE
079400             IF  WS-ENDBR
079500                 GO TO Y535-MMD3-ENDBR.
079600*
079700     IF  MBCA-MBIB-SEARCH-KEY IS EQUAL TO '1'
079800         MOVE SPACES             TO WS-SWITCH
079900         PERFORM Y820-SEARCH-1   THRU Y829-EXIT
080000         IF  WS-READ
080100             GO TO Y531-READ-MMD3
080200         ELSE
080300             IF  WS-ENDBR
080400                 GO TO Y535-MMD3-ENDBR.
080500*
080600 Y535-MMD3-ENDBR.
080700*
080800     MOVE 'FC05'                 TO MBCA-PROGRAM-LOCATION.
080900     SET MBIORO-ENDBR            TO TRUE.
081000     PERFORM MMD3AO-ACCESS       THRU MMD3AO-ACCESS-EXIT.
081100*
081200 Y539-MMD3-EXIT.
081300      EXIT.
081400*
081500 Y540-START-MMD4.
081600*
081700     MOVE MBCA-MBIB-1ST-KEY      TO MBIOWS-MMD4-KEY.
081800     MOVE 'FC06'                 TO MBCA-PROGRAM-LOCATION.
081900     MOVE SS08WS-CICS-FC-NOTFND  TO MBIORO-TEMP-STATUS-1.
082000     SET MBIORO-STARTBR-GTE      TO TRUE.
082100     PERFORM MMD4AO-ACCESS       THRU MMD4AO-ACCESS-EXIT.
082200*
082300     IF  SS08WS-RC-FC-NOTFND
082400         SET SS08WS-ERROR-SW-YES     TO TRUE
082500         GO TO Y549-MMD4-EXIT.
082600*
082700 Y541-READ-MMD4.
082800*
082900     MOVE 'FC07'                 TO MBCA-PROGRAM-LOCATION.
083000     SET MBIORO-READ-SEQ         TO TRUE.
083100     PERFORM MMD4AO-ACCESS       THRU MMD4AO-ACCESS-EXIT.
083200*
083300     MOVE MMD4-RECORD            TO MWD3-RECORD.
083400*
083500     IF  MMD4-HEADER
083600         GO TO Y541-READ-MMD4.
083700*
083800     IF  MMD4-TRAILER
083900         MOVE MBEMWS-NOT-ON-FILE TO IB00-ERR-MESSAGE
084000         SET SS08WS-ERROR-SW-YES TO TRUE
084100         SET WS-START-D4-ERROR   TO TRUE
084200         GO TO Y545-MMD4-ENDBR.
084300*
084400     IF  MBCA-MBIB-SEARCH-KEY IS EQUAL TO '6'
084500         MOVE SPACES             TO WS-SWITCH
084600         PERFORM Y770-SEARCH-6   THRU Y779-EXIT
084700         IF  WS-READ
084800             GO TO Y541-READ-MMD4
084900         ELSE
085000             IF  WS-ENDBR
085100                 GO TO Y545-MMD4-ENDBR.
085200*
085300     IF  MBCA-MBIB-SEARCH-KEY IS EQUAL TO '5'
085400         MOVE SPACES             TO WS-SWITCH
085500         PERFORM Y780-SEARCH-5   THRU Y789-EXIT
085600         IF  WS-READ
085700             GO TO Y541-READ-MMD4
085800         ELSE
085900             IF  WS-ENDBR
086000                 GO TO Y545-MMD4-ENDBR.
086100*
086200     IF  MBCA-MBIB-SEARCH-KEY IS EQUAL TO '4'
086300         MOVE SPACES             TO WS-SWITCH
086400         PERFORM Y790-SEARCH-4   THRU Y799-EXIT
086500         IF  WS-READ
086600             GO TO Y541-READ-MMD4
086700         ELSE
086800             IF  WS-ENDBR
086900                 GO TO Y545-MMD4-ENDBR.
087000*
087100     IF  MBCA-MBIB-SEARCH-KEY IS EQUAL TO '3'
087200         MOVE SPACES             TO WS-SWITCH
087300         PERFORM Y800-SEARCH-3   THRU Y809-EXIT
087400         IF  WS-READ
087500             GO TO Y541-READ-MMD4
087600         ELSE
087700             IF  WS-ENDBR
087800                 GO TO Y545-MMD4-ENDBR.
087900*
088000     IF  MBCA-MBIB-SEARCH-KEY IS EQUAL TO '2'
088100         MOVE SPACES             TO WS-SWITCH
088200         PERFORM Y810-SEARCH-2   THRU Y819-EXIT
088300         IF  WS-READ
088400             GO TO Y541-READ-MMD4
088500         ELSE
088600             IF  WS-ENDBR
088700                 GO TO Y545-MMD4-ENDBR.
088800*
088900     IF  MBCA-MBIB-SEARCH-KEY IS EQUAL TO '1'
089000         MOVE SPACES             TO WS-SWITCH
089100         PERFORM Y820-SEARCH-1   THRU Y829-EXIT
089200         IF  WS-READ
089300             GO TO Y541-READ-MMD4
089400         ELSE
089500             IF  WS-ENDBR
089600                 GO TO Y545-MMD4-ENDBR.
089700*
089800*
089900 Y545-MMD4-ENDBR.
090000*
090100     MOVE 'FC08'                 TO MBCA-PROGRAM-LOCATION.
090200     SET MBIORO-ENDBR            TO TRUE.
090300     PERFORM MMD4AO-ACCESS       THRU MMD4AO-ACCESS-EXIT.
090400*
090500 Y549-MMD4-EXIT.
090600      EXIT.
090700*
090800 Y770-SEARCH-6.
090900*
091000     IF  MWD3-KEY (1:27) IS GREATER THAN
091100                              MBCA-MBIB-1ST-KEY (1:27)
091200         IF  MBCA-MBIB-FILE3
091300             SET WS-START-D3-ERROR
091400                                 TO TRUE
091500             SET WS-ENDBR        TO TRUE
091600             SET MBCA-MBIB-FILE4 TO TRUE
091700         ELSE
091800             MOVE MBEMWS-NOT-ON-FILE
091900                                 TO IB00-ERR-MESSAGE
092000             SET SS08WS-ERROR-SW-YES TO TRUE
092100             SET WS-START-D4-ERROR
092200                                 TO TRUE
092300             SET WS-ENDBR        TO TRUE
092400     ELSE
092500         IF  MWD3-KEY (1:27) IS LESS THAN
092600                              MBCA-MBIB-1ST-KEY (1:27)
092700             SET WS-READ         TO TRUE
092800         ELSE
092900             MOVE MWD3-KEY       TO MBCA-MBIB-1ST-KEY
093000             MOVE 01             TO MBCA-SCREEN-NBR
093100             SET WS-ENDBR        TO TRUE.
093200*
093300 Y779-EXIT.
093400     EXIT.
093500*
093600 Y780-SEARCH-5.
093700*
093800     IF  MWD3-KEY (1:24) IS GREATER THAN
093900                              MBCA-MBIB-1ST-KEY (1:24)
094000         IF  MBCA-MBIB-FILE3
094100             SET WS-START-D3-ERROR
094200                                 TO TRUE
094300             SET WS-ENDBR        TO TRUE
094400             SET MBCA-MBIB-FILE4 TO TRUE
094500             GO TO Y789-EXIT
094600         ELSE
094700             MOVE MBEMWS-NOT-ON-FILE
094800                                 TO IB00-ERR-MESSAGE
094900             SET SS08WS-ERROR-SW-YES TO TRUE
095000             SET WS-START-D4-ERROR
095100                                 TO TRUE
095200             SET WS-ENDBR        TO TRUE
095300             GO TO Y789-EXIT.
095400*
095500     IF  MWD3-KEY (1:24) IS LESS THAN
095600                              MBCA-MBIB-1ST-KEY (1:24)
095700         SET WS-READ             TO TRUE
095800         GO TO Y789-EXIT.
095900*
096000     IF  MWD3-BATCH-SEQ IS NOT EQUAL TO ZEROS
096100         SET WS-READ             TO TRUE
096200         GO TO Y789-EXIT
096300     ELSE
096400         EVALUATE TRUE
096500           WHEN MBCA-MBIB-FILE3
096600             SET WS-START-D3-SW-OK
096700                                 TO TRUE
096800           WHEN MBCA-MBIB-FILE4
096900             SET WS-START-D4-SW-OK
097000                                 TO TRUE
097100         END-EVALUATE
097200         MOVE MWD3-ORG           TO MBCA-MBIB-1ST-ORG
097300         MOVE MWD3-MERCHANT      TO MBCA-MBIB-1ST-MERCHANT
097400         MOVE MWD3-STORE         TO MBCA-MBIB-1ST-STORE
097500         MOVE MWD3-BATCH-DATE    TO MBCA-MBIB-1ST-BATCH-DATE
097600         MOVE MWD3-BATCH-SOURCE  TO MBCA-MBIB-1ST-BATCH-SOURCE
097700         SET WS-ENDBR            TO TRUE.
097800*
097900 Y789-EXIT.
098000     EXIT.
098100*
098200 Y790-SEARCH-4.
098300*
098400     IF  MWD3-KEY (1:21) IS GREATER THAN
098500                              MBCA-MBIB-1ST-KEY (1:21)
098600         IF  MBCA-MBIB-FILE3
098700             SET WS-START-D3-ERROR
098800                                 TO TRUE
098900             SET WS-ENDBR        TO TRUE
099000             SET MBCA-MBIB-FILE4 TO TRUE
099100             GO TO Y799-EXIT
099200         ELSE
099300             MOVE MBEMWS-NOT-ON-FILE
099400                                 TO IB00-ERR-MESSAGE
099500             SET SS08WS-ERROR-SW-YES TO TRUE
099600             SET WS-START-D4-ERROR
099700                                 TO TRUE
099800             SET WS-ENDBR        TO TRUE
099900             GO TO Y799-EXIT.
100000*
100100     IF  MWD3-KEY (1:21) IS LESS THAN
100200                                 MBCA-MBIB-1ST-KEY (1:21)
100300         SET WS-READ             TO TRUE
100400         GO TO Y799-EXIT.
100500*
100600     IF  MWD3-BATCH-SEQ IS NOT EQUAL TO ZEROS
100700         SET WS-READ             TO TRUE
100800         GO TO Y799-EXIT.
100900*
101000     IF  MBCA-MBIB-1ST-BATCH-NBR IS GREATER THAN ZERO
101100         IF  MWD3-BATCH-NBR IS EQUAL
101200                                 TO MBCA-MBIB-1ST-BATCH-NBR
101300             EVALUATE TRUE
101400               WHEN MBCA-MBIB-FILE3
101500                 SET WS-START-D3-SW-OK
101600                                 TO TRUE
101700               WHEN MBCA-MBIB-FILE4
101800                 SET WS-START-D4-SW-OK
101900                                 TO TRUE
102000             END-EVALUATE
102100             MOVE MWD3-ORG       TO MBCA-MBIB-1ST-ORG
102200             MOVE MWD3-MERCHANT  TO MBCA-MBIB-1ST-MERCHANT
102300             MOVE MWD3-STORE     TO MBCA-MBIB-1ST-STORE
102400             MOVE MWD3-BATCH-DATE
102500                                 TO MBCA-MBIB-1ST-BATCH-DATE
102600             SET WS-ENDBR        TO TRUE
102700         ELSE
102800             SET WS-READ TO TRUE
102900     ELSE
103000         EVALUATE TRUE
103100           WHEN MBCA-MBIB-FILE3
103200             SET WS-START-D3-SW-OK
103300                                 TO TRUE
103400           WHEN MBCA-MBIB-FILE4
103500             SET WS-START-D4-SW-OK
103600                                 TO TRUE
103700          END-EVALUATE
103800          MOVE MWD3-ORG          TO MBCA-MBIB-1ST-ORG
103900          MOVE MWD3-MERCHANT     TO MBCA-MBIB-1ST-MERCHANT
104000          MOVE MWD3-STORE        TO MBCA-MBIB-1ST-STORE
104100          MOVE MWD3-BATCH-DATE   TO MBCA-MBIB-1ST-BATCH-DATE
104200          SET WS-ENDBR           TO TRUE.
104300*
104400 Y799-EXIT.
104500     EXIT.
104600*
104700 Y800-SEARCH-3.
104800*
104900     IF  MWD3-KEY (1:17) IS GREATER THAN
105000                              MBCA-MBIB-1ST-KEY (1:17)
105100         IF  MBCA-MBIB-FILE3
105200             SET WS-START-D3-ERROR
105300                                 TO TRUE
105400             SET WS-ENDBR        TO TRUE
105500             SET MBCA-MBIB-FILE4 TO TRUE
105600             GO TO Y809-EXIT
105700         ELSE
105800             MOVE MBEMWS-NOT-ON-FILE
105900                                 TO IB00-ERR-MESSAGE
106000             SET SS08WS-ERROR-SW-YES TO TRUE
106100             SET WS-START-D4-ERROR
106200                                 TO TRUE
106300             SET WS-ENDBR        TO TRUE
106400             GO TO Y809-EXIT.
106500*
106600     IF  MWD3-KEY (1:17) IS LESS THAN
106700                                 MBCA-MBIB-1ST-KEY (1:17)
106800         SET WS-READ             TO TRUE
106900         GO TO Y809-EXIT.
107000*
107100     IF  MWD3-BATCH-SEQ IS NOT EQUAL TO ZEROS
107200         SET WS-READ             TO TRUE
107300         GO TO Y809-EXIT.
107400*
107500     IF  MBCA-MBIB-1ST-BATCH-DATE IS EQUAL TO ZEROS
107600         NEXT SENTENCE
107700     ELSE
107800         IF  MWD3-BATCH-DATE IS EQUAL
107900                                 TO MBCA-MBIB-1ST-BATCH-DATE
108000             NEXT SENTENCE
108100         ELSE
108200             SET WS-READ         TO TRUE
108300             GO TO Y809-EXIT.
108400*
108500     IF  MBCA-MBIB-1ST-BATCH-SOURCE IS EQUAL TO ZEROS
108600         NEXT SENTENCE
108700     ELSE
108800         IF  MWD3-BATCH-SOURCE IS EQUAL
108900                                 TO MBCA-MBIB-1ST-BATCH-SOURCE
109000             NEXT SENTENCE
109100         ELSE
109200             SET WS-READ         TO TRUE
109300             GO TO Y809-EXIT.
109400*
109500     IF  MBCA-MBIB-1ST-BATCH-NBR IS EQUAL TO ZEROS
109600         EVALUATE TRUE
109700           WHEN MBCA-MBIB-FILE3
109800             SET WS-START-D3-SW-OK
109900                                 TO TRUE
110000           WHEN MBCA-MBIB-FILE4
110100             SET WS-START-D4-SW-OK
110200                                 TO TRUE
110300         END-EVALUATE
110400         MOVE MWD3-ORG           TO MBCA-MBIB-1ST-ORG
110500         MOVE MWD3-MERCHANT      TO MBCA-MBIB-1ST-MERCHANT
110600         MOVE MWD3-STORE         TO MBCA-MBIB-1ST-STORE
110700         SET WS-ENDBR            TO TRUE
110800         GO TO Y809-EXIT
110900     ELSE
111000         IF  MWD3-BATCH-NBR IS EQUAL
111100                                 TO MBCA-MBIB-1ST-BATCH-NBR
111200             EVALUATE TRUE
111300               WHEN MBCA-MBIB-FILE3
111400                 SET WS-START-D3-SW-OK
111500                                 TO TRUE
111600               WHEN MBCA-MBIB-FILE4
111700                 SET WS-START-D4-SW-OK
111800                                 TO TRUE
111900             END-EVALUATE
112000             MOVE MWD3-ORG       TO MBCA-MBIB-1ST-ORG
112100             MOVE MWD3-MERCHANT  TO MBCA-MBIB-1ST-MERCHANT
112200             MOVE MWD3-STORE     TO MBCA-MBIB-1ST-STORE
112300             SET WS-ENDBR        TO TRUE
112400             GO TO Y809-EXIT
112500         ELSE
112600             SET WS-READ             TO TRUE
112700             GO TO Y809-EXIT.
112800*
112900 Y809-EXIT.
113000     EXIT.
113100*
113200 Y810-SEARCH-2.
113300*
113400     IF  MWD3-KEY (1:12) IS GREATER THAN
113500                              MBCA-MBIB-1ST-KEY (1:12)
113600         IF  MBCA-MBIB-FILE3
113700             SET WS-START-D3-ERROR
113800                                 TO TRUE
113900             SET WS-ENDBR        TO TRUE
114000             SET MBCA-MBIB-FILE4 TO TRUE
114100             GO TO Y819-EXIT
114200         ELSE
114300             MOVE MBEMWS-NOT-ON-FILE
114400                                 TO IB00-ERR-MESSAGE
114500             SET SS08WS-ERROR-SW-YES TO TRUE
114600             SET WS-START-D4-ERROR
114700                                 TO TRUE
114800             SET WS-ENDBR        TO TRUE
114900             GO TO Y819-EXIT.
115000*
115100     IF  MWD3-KEY (1:12) IS LESS THAN
115200                                 MBCA-MBIB-1ST-KEY (1:12)
115300         SET WS-READ             TO TRUE
115400         GO TO Y819-EXIT.
115500*
115600*
115700*
115800*
115900*
116000     IF  MBCA-MBIB-1ST-BATCH-DATE IS EQUAL TO ZEROS
116100         NEXT SENTENCE
116200     ELSE
116300         IF  MWD3-BATCH-DATE IS EQUAL
116400                                 TO MBCA-MBIB-1ST-BATCH-DATE
116500             NEXT SENTENCE
116600         ELSE
116700             SET WS-READ         TO TRUE
116800             GO TO Y819-EXIT.
116900*
117000     IF  MBCA-MBIB-1ST-BATCH-SOURCE IS EQUAL TO ZEROS
117100         NEXT SENTENCE
117200     ELSE
117300         IF  MWD3-BATCH-SOURCE IS EQUAL
117400                                 TO MBCA-MBIB-1ST-BATCH-SOURCE
117500             NEXT SENTENCE
117600         ELSE
117700             SET WS-READ         TO TRUE
117800             GO TO Y819-EXIT.
117900*
118000     IF  MBCA-MBIB-1ST-BATCH-NBR IS EQUAL TO ZEROS
118100         EVALUATE TRUE
118200           WHEN MBCA-MBIB-FILE3
118300             SET WS-START-D3-SW-OK
118400                                 TO TRUE
118500           WHEN MBCA-MBIB-FILE4
118600             SET WS-START-D4-SW-OK
118700                                 TO TRUE
118800         END-EVALUATE
118900         MOVE MWD3-ORG           TO MBCA-MBIB-1ST-ORG
119000         MOVE MWD3-MERCHANT      TO MBCA-MBIB-1ST-MERCHANT
119100         SET WS-ENDBR            TO TRUE
119200         GO TO Y819-EXIT
119300     ELSE
119400         IF  MWD3-BATCH-NBR IS EQUAL
119500                                 TO MBCA-MBIB-1ST-BATCH-NBR
119600             EVALUATE TRUE
119700               WHEN MBCA-MBIB-FILE3
119800                 SET WS-START-D3-SW-OK
119900                                 TO TRUE
120000               WHEN MBCA-MBIB-FILE4
120100                 SET WS-START-D4-SW-OK
120200                                 TO TRUE
120300             END-EVALUATE
120400             MOVE MWD3-ORG       TO MBCA-MBIB-1ST-ORG
120500             MOVE MWD3-MERCHANT  TO MBCA-MBIB-1ST-MERCHANT
120600             SET WS-ENDBR        TO TRUE
120700             GO TO Y819-EXIT
120800         ELSE
120900             SET WS-READ             TO TRUE
121000             GO TO Y819-EXIT.
121100*
121200 Y819-EXIT.
121300     EXIT.
121400*
121500 Y820-SEARCH-1.
121600*
121700     IF  MWD3-KEY (1:3) IS GREATER THAN
121800                              MBCA-MBIB-1ST-KEY (1:3)
121900         IF  MBCA-MBIB-FILE3
122000             SET WS-START-D3-ERROR
122100                                 TO TRUE
122200             SET WS-ENDBR        TO TRUE
122300             SET MBCA-MBIB-FILE4 TO TRUE
122400             GO TO Y829-EXIT
122500         ELSE
122600             MOVE MBEMWS-NOT-ON-FILE
122700                                 TO IB00-ERR-MESSAGE
122800             SET SS08WS-ERROR-SW-YES TO TRUE
122900             SET WS-START-D4-ERROR
123000                                 TO TRUE
123100             SET WS-ENDBR        TO TRUE
123200             GO TO Y829-EXIT.
123300*
123400     IF  MWD3-KEY (1:3) IS LESS THAN
123500                                 MBCA-MBIB-1ST-KEY (1:3)
123600         SET WS-READ             TO TRUE
123700         GO TO Y829-EXIT.
123800*
123900     IF  MBCA-MBIB-1ST-STORE IS EQUAL TO ZEROS
124000         NEXT SENTENCE
124100     ELSE
124200         IF  MWD3-STORE IS EQUAL
124300                                 TO MBCA-MBIB-1ST-STORE
124400             NEXT SENTENCE
124500         ELSE
124600             SET WS-READ         TO TRUE
124700             GO TO Y829-EXIT.
124800*
124900     IF  MBCA-MBIB-1ST-BATCH-DATE IS EQUAL TO ZEROS
125000         NEXT SENTENCE
125100     ELSE
125200         IF  MWD3-BATCH-DATE IS EQUAL
125300                                 TO MBCA-MBIB-1ST-BATCH-DATE
125400             NEXT SENTENCE
125500         ELSE
125600             SET WS-READ         TO TRUE
125700             GO TO Y829-EXIT.
125800*
125900     IF  MBCA-MBIB-1ST-BATCH-SOURCE IS EQUAL TO ZEROS
126000         NEXT SENTENCE
126100     ELSE
126200         IF  MWD3-BATCH-SOURCE IS EQUAL
126300                                 TO MBCA-MBIB-1ST-BATCH-SOURCE
126400             NEXT SENTENCE
126500         ELSE
126600             SET WS-READ         TO TRUE
126700             GO TO Y829-EXIT.
126800*
126900     IF  MBCA-MBIB-1ST-BATCH-NBR IS EQUAL TO ZEROS
127000         MOVE MWD3-ORG           TO MBCA-MBIB-1ST-ORG
127100         SET WS-ENDBR            TO TRUE
127200         GO TO Y829-EXIT
127300     ELSE
127400         IF  MWD3-BATCH-NBR IS EQUAL
127500                                 TO MBCA-MBIB-1ST-BATCH-NBR
127600             MOVE MWD3-ORG       TO MBCA-MBIB-1ST-ORG
127700             SET WS-ENDBR        TO TRUE
127800             GO TO Y829-EXIT
127900         ELSE
128000             SET WS-READ             TO TRUE
128100             GO TO Y829-EXIT.
128200*
128300 Y829-EXIT.
128400     EXIT.
128500*
128600/
128700 Z000-COPIED-ROUTINES SECTION.
128800*
128900*********************************
129000*    DATE VALIDATION ROUTINE    *
129100*********************************
129200*
129300     COPY SS05PD.
129400/
129500**********************************
129600*    GREG TO JUL DATE ROUTINE    *
129700**********************************
129800*
129900     COPY SS07PD.
130000/
130100**********************************
130200*    JUL TO GREG DATE ROUTINE    *
130300**********************************
130400*
130500     COPY SS08PD.
130600/
130700     COPY SS26PD.
130800/
130900     COPY SS27PD.
131000/
131100*********************************
131200*    LINE 24 PF KEYS ROUTINE    *
131300*********************************
131400*
131500     COPY SS15PD.
131600/
131700*******************************************
131800*    ORG FILE RECORD 1 ACCESS ROUTINES    *
131900*******************************************
132000*
132100     COPY MMOCAO.
132200/
132300*********************************************
132400*    STORE MASTER RECORD ACCESS ROUTINES    *
132500*********************************************
132600*
132700     COPY MMSMAO.
132800/
132900*************************************************
133000*    TERMINATED MERCHANT RECORD ACCESS ROUTINES *
133100*************************************************
133200*
133300     COPY MMD3AO.
133400/
133500*************************************************
133600*    TERMINATED MERCHANT RECORD ACCESS ROUTINES *
133700*************************************************
133800*
133900     COPY MMD4AO.
134000/
134100*****************************
134200*    ONLINE MAP ROUTINES    *
134300*****************************
134400*
134500     COPY MB60PD REPLACING 'MBMAPXX' BY 'MBIB00 '
134600                           MBMAPXXI BY MBIB00I
134700                           MBMAPXXO BY MBIB00O.
134800/
134900***************************
135000*    ONLINE PROCEDURES    *
135100***************************
135200*
135300     COPY MB70PD.
135400/
135500     COPY SMFTPXO.
