000100 IDENTIFICATION DIVISION.
000200 PROGRAM-ID. MBOIB01.
000201*       RELEASE DATE=08/24/01.        REVISION LEVEL=08.06      *
000202*****************************************************************
000203*WARNING.  THIS COMPUTER PROGRAM IS PROTECTED BY COPYRIGHT LAW  *
000204*AND INTERNATIONAL TREATIES.  UNAUTHORIZED REPRODUCTION OR      *
000205*DISTRIBUTION OF THIS PROGRAM, OR ANY PORTION OF IT, MAY RESULT *
000206*IN SEVERE CIVIL AND CRIMINAL PENATLIES, AND WILL BE PROSECUTED *
000207*TO THE MAXIMUM EXTENT POSSIBLE UNDER THE LAW.                  *
000208*COPYRIGHT 1999 PAYSYS INTERNATIONAL, INC.  ALL RIGHTS RESERVED.*
000209*****************************************************************
000300*****************************************************************
000400*                                                               *
000500*   V - PLUS  M E R C H A N T   B A N K C A R D   S Y S T E M   *
000600*                                                               *
000700*      MBOIB01 - ON-LINE DEPOSIT BATCH DIRECTORY                *
000800*                SCREEN 01                                      *
000900*                                                               *
001000*              1. TRANSIDS                                      *
001100*                 A. MBIB                                       *
001200*              2. MAPS USED -                                   *
001300*                 A. MBIB01 (SCREEN 01)                         *
001400*              3. FILES USED -                                  *
001500*                 A. MMD3   (DEPOSIT BATCH D3)                  *
001600*                 B. MMD4   (DEPOSIT BATCH D4)                  *
001700*                                                               *
001800*****************************************************************
001900*
002000 ENVIRONMENT DIVISION.
002100 DATA DIVISION.
002200 WORKING-STORAGE SECTION.
002300 01  FILLER                  PIC  X(12)      VALUE '** WS-BEG **'.
002400*         I/O REQUEST BLOCK WORK AREAS
002500     COPY MBIOWS.
002600/         I/O REQUEST BLOCK
002700     COPY MBIORO.
002800/         DEPOSIT BATCH MASTER RECORD LAYOUT WORK FILE 3
002900     COPY MMD3RL REPLACING ==:MMD3:== BY ==MWD3==.
003000/         DATE WORK AREAS
003100     COPY SS01WS.
003200/         ONLINE WORK AREAS
003300     COPY SS08WS.
003400/
003500     COPY SS00WS.
003600/
003700     COPY SMFTWS.
003800/
003900     COPY SMPTRL REPLACING ==:SMPT:== BY ==SMPT==.
004000/
004100     COPY MB61LK.
004200/
004300 01  WS-MISCELLANEOUS.
004400     03  WS-SAVE-EIBAID      PIC  X(01)      VALUE SPACES.
004500     03  WS-SELECT-SW        PIC  X(01)      VALUE 'N'.
004600         88  WS-SELECT-NO                    VALUE 'N'.
004700         88  WS-SELECT-YES                   VALUE 'Y'.
004800     03  WS-BYPASS-SW        PIC  X(01)      VALUE 'N'.
004900         88  WS-BYPASS-NO                    VALUE 'N'.
005000         88  WS-BYPASS-YES                   VALUE 'Y'.
005100     03  WS-FWD-SW           PIC  X(01)      VALUE 'N'.
005200         88  WS-FWD-NO                       VALUE 'N'.
005300         88  WS-FWD-YES                      VALUE 'Y'.
005400     03  WS-SWITCH           PIC  X(01)      VALUE SPACES.
005500         88  WS-READ                         VALUE 'R'.
005600         88  WS-ENDBR                        VALUE 'E'.
005700     03  WS-RECORD-SW        PIC  X(01)      VALUE 'N'.
005800         88  WS-NO-REC                       VALUE 'N'.
005900         88  WS-REC-FOUND                    VALUE 'Y'.
006000     03  TS-QUEUE-NAME.
006100         05  TS-QN-TERMID    PIC  X(04)      VALUE SPACES.
006200         05  TS-QN-TRANID    PIC  X(04)      VALUE 'MBIB'.
006300/
006400 01  FILLER                  PIC  X(36)      VALUE
006500     'FORMAT NBR AND AMTS BY CURRENCY CODE'.
006600*
006700     COPY MB00WS.
006800*
006900     COPY SS95WS.
007000*
007100 01  FILLER                  PIC  X(12)      VALUE '** WS-END **'.
007200/
007300 LINKAGE SECTION.
007400 01  DFHCOMMAREA.
007500     COPY MB60WS.
007600/         DEPOSIT BATCH DIRECTORY SCREEN 01 MAP DSECT
007700     COPY MBIB01.
007800/         DEPOSIT BATCH DIRECTORY SCREEN 01 MAP REDEFINITION
007900     COPY MBIB01R.
008000/         DEPOSIT BATCH MASTER RECORD LAYOUT FILE 3
008100     COPY MMD3RL REPLACING ==:MMD3:== BY ==MMD3==.
008200/         ORG RECORD LAYOUT
008300     COPY MMOCRL.
008400/         DEPOSIT BATCH MASTER RECORD LAYOUT FILE 4
008500     COPY MMD3RL REPLACING ==:MMD3:== BY ==MMD4==.
008600/         BATCH INQUIRY TEMPORARY STORAGE
008700     COPY MBIBTS1.
008800/
008900 PROCEDURE DIVISION.
009000 0000-HOUSEKEEPING SECTION.
009100 0100-INIT.
009200*
009300     MOVE MBCA-EIBAID            TO WS-SAVE-EIBAID.
009400     SET MBCA-EIBAID-ENTER       TO TRUE.
009500*
009600     MOVE 'PC01'                 TO MBCA-PROGRAM-LOCATION.
009700     PERFORM MB70PD-ON-LINE-HOUSEKEEPING
009800                                 THRU MB70PD-OLH-EXIT.
009900*
010000     SET SS95WS-FUNCTION-INITIALIZE
010100                            TO TRUE.
010200     PERFORM SS95PD-NAP-ROUTINE
010300        THRU SS95PD-NAP-EXIT.
010400*
010500     MOVE WS-SAVE-EIBAID         TO MBCA-EIBAID.
010600     MOVE MBCA-TERMINAL-ID       TO TS-QN-TERMID.
010700     MOVE MBCA-CURRENCY-CODE     TO SS95WS-CURRENCY-CODE.
010800*
010900     IF  MBCA-RECEIVE-SCREEN
011000         GO TO 2000-RECEIVE-SCREEN.
011100*
011200 1000-SEND-SCREEN SECTION.
011300*
011400****************************************************************
011500*    GET CICS STORAGE NEEDED FOR THE MAP                       *
011600****************************************************************
011700*
011800     MOVE 'SC01'                 TO MBCA-PROGRAM-LOCATION.
011900     PERFORM MB60PD-GETMAIN-FOR-MAP
012000                                 THRU MB60PD-GFM-EXIT.
012100*
012200************************************************
012300*    READ THE ORGANIZATION RECORD              *
012400*    FOR THE ORG NAME                          *
012500************************************************
012600*
012700     MOVE MBCA-MBIB-1ST-ORG      TO MBIOWS-MMOC-ORG.
012800     MOVE 'FC01'                 TO MBCA-PROGRAM-LOCATION.
012900     SET MBIORO-READ-RANDOM      TO TRUE.
013000     PERFORM MMOCAO-ACCESS       THRU MMOCAO-ACCESS-EXIT.
013100*
013200     MOVE MBCA-MBIB-1ST-ORG      TO IB01-ORG.
013300     MOVE MMOC-NA-LINE (1 1)     TO IB01-ORG-NAME.
013400     MOVE 01                     TO MBCA-SCREEN-NBR.
013500*
013600****************************************************************
013700*    INITIALIZE THE STANDARD MAP LINES                         *
013800****************************************************************
013900*
014000     PERFORM MB60PD-INIT-STD-MAP-LINES
014100                                 THRU MB60PD-ISML-EXIT.
014200*
014300****************************************************************
014400*    ACQUIRE MAIN STORAGE FOR TEMP STORAGE RECORD              *
014500****************************************************************
014600*
014700     MOVE 'TS01'                 TO MBCA-PROGRAM-LOCATION.
014800     PERFORM 8100-TEMP-STORAGE-GETMAIN
014900                                 THRU 8199-TSG-EXIT.
015000*
015100     EXEC CICS HANDLE CONDITION
015200               QIDERR (1010-CHECK-RETURN-FLAG)
015300          END-EXEC.
015400*
015500***********************************************
015600*    READ THE TEMP STORAGE RECORD             *
015700***********************************************
015800*
015900     MOVE 'TS02'                 TO MBCA-PROGRAM-LOCATION.
016000     PERFORM 8200-TEMP-STORAGE-READ
016100                                 THRU 8299-TSR-EXIT.
016200*
016300***********************************************
016400*    DELETE THE TEMP STORAGE RECORD           *
016500***********************************************
016600*
016700     MOVE 'TS03'                 TO MBCA-PROGRAM-LOCATION.
016800     PERFORM 8300-TEMP-STORAGE-DELETE
016900                                 THRU 8399-TSD-EXIT.
017000*
017100     IF  MBCA-MBIB-FILE-CHANGED
017200     AND TS-IB01-MERCHANT (1) IS GREATER THAN ZEROS
017300     AND TS-IB01-MERCHANT (6) IS GREATER THAN ZEROS
017400         GO TO 1015-READ-DEPOSITS.
017500*
017600     PERFORM 8800-BUILD-SCREEN   THRU 8899-BS-EXIT.
017700     GO TO 1080-CONTINUE.
017800*
017900 1010-CHECK-RETURN-FLAG.
018000*
018100     MOVE ZEROS                  TO TS-IB01-MERCHANT (1)
018200                                    TS-IB01-MERCHANT (6).
018300*
018400 1015-READ-DEPOSITS.
018500*
018600     SET X-MBIB-BATCH-INDEX      TO +1.
018700*
018800     IF  MBCA-MBIB-FILE4
018900         GO TO 1015-CONTINUE.
019000*
019100     PERFORM 9630-START-MMD3     THRU 9639-MMD3-EXIT.
019200*
019300     IF  X-MBIB-BATCH-INDEX IS GREATER THAN 6
019400         GO TO 1080-CONTINUE.
019500*
019600 1015-CONTINUE.
019700*
019800     PERFORM 9640-START-MMD4     THRU 9649-MMD4-EXIT.
019900*
020000     IF  WS-NO-REC
020100     AND MBCA-MBIB-FILE-CHANGED
020200     AND TS-IB01-MERCHANT (1) IS GREATER THAN ZEROS
020300     AND TS-IB01-MERCHANT (6) IS GREATER THAN ZEROS
020400         PERFORM 8800-BUILD-SCREEN
020500                                 THRU 8899-BS-EXIT
020600         SET MBCA-MBIB-FILE-NOT-CHANGED
020700                                 TO TRUE
020800         GO TO 1080-CONTINUE.
020900*
021000     IF  X-MBIB-BATCH-INDEX IS GREATER THAN 6
021100         GO TO 1080-CONTINUE.
021200*
021300 1060-SET-ATTRIBUTE.
021400*
021500     IF  X-MBIB-BATCH-INDEX IS LESS THAN +7
021600         SET X-TS-IB01-INDEX     TO X-MBIB-BATCH-INDEX
021700         MOVE DFHBMASK           TO IB01-SELECT-A
021800                                    (X-MBIB-BATCH-INDEX)
021900         MOVE DFHBMDAS           TO IB01-MERCHANT-A
022000                                    (X-MBIB-BATCH-INDEX)
022100                                    IB01-MERCHANT-A
022200                                    (X-MBIB-BATCH-INDEX)
022300                                    IB01-MERCH-LIT-A
022400                                    (X-MBIB-BATCH-INDEX)
022500                                    IB01-BATCH-DATE-A
022600                                    (X-MBIB-BATCH-INDEX)
022700                                    IB01-BATCH-DATE-LIT-A
022800                                    (X-MBIB-BATCH-INDEX)
022900                                    IB01-BATCH-NBR-A
023000                                    (X-MBIB-BATCH-INDEX)
023100                                    IB01-BATCH-NBR-LIT-A
023200                                    (X-MBIB-BATCH-INDEX)
023300                                    IB01-BATCH-SOURCE-A
023400                                    (X-MBIB-BATCH-INDEX)
023500                                    IB01-BATCH-SOURCE-LIT-A
023600                                    (X-MBIB-BATCH-INDEX)
023700                                    IB01-REJ-REENTRY-A
023800                                    (X-MBIB-BATCH-INDEX)
023900                                    IB01-REJ-REENTRY-LIT-A
024000                                    (X-MBIB-BATCH-INDEX)
024100                                    IB01-STORE-A
024200                                    (X-MBIB-BATCH-INDEX)
024300                                    IB01-STORE-LIT-A
024400                                    (X-MBIB-BATCH-INDEX)
024500                                    IB01-POST-DATE-A
024600                                    (X-MBIB-BATCH-INDEX)
024700                                    IB01-POST-DATE-LIT-A
024800                                    (X-MBIB-BATCH-INDEX)
024900                                    IB01-AMOUNT-A
025000                                    (X-MBIB-BATCH-INDEX)
025100                                    IB01-SELECT-LP-A
025200                                    (X-MBIB-BATCH-INDEX)
025300                                    IB01-SELECT-RP-A
025400                                    (X-MBIB-BATCH-INDEX)
025500         MOVE ZEROS              TO TS-IB01-MERCHANT
025600                                    (X-TS-IB01-INDEX)
025700                                    TS-IB01-BATCH-DATE
025800                                    (X-TS-IB01-INDEX)
025900                                    TS-IB01-BATCH-NBR
026000                                    (X-TS-IB01-INDEX)
026100                                    TS-IB01-BATCH-SOURCE
026200                                    (X-TS-IB01-INDEX)
026300                                    TS-IB01-STORE
026400                                    (X-TS-IB01-INDEX)
026500                                    TS-IB01-POST-DATE
026600                                    (X-TS-IB01-INDEX)
026700                                    TS-IB01-AMOUNT
026800                                    (X-TS-IB01-INDEX)
026900                                    TS-IB01-SEQ-NBR
027000                                    (X-TS-IB01-INDEX)
027100         MOVE SPACES             TO TS-IB01-REJ-REENTRY
027200                                    (X-TS-IB01-INDEX)
027300         SET X-MBIB-BATCH-INDEX  UP BY +1
027400         GO TO 1060-SET-ATTRIBUTE.
027500*
027600 1080-CONTINUE.
027700*
027800     IF  MBCA-MBIB-SAVE-MERCHANT IS NOT EQUAL TO ZEROES
027900         MOVE DFHBMASB           TO IB01-BACK-IND-A.
028000*
028100****************************************************************
028200*    WRITE THE TEMP STORAGE RECORD                             *
028300****************************************************************
028400*
028500     MOVE 'TS04'                 TO MBCA-PROGRAM-LOCATION.
028600     PERFORM 8400-WRITE-QUEUE    THRU 8499-WQ-EXIT.
028700*
028800     SET X-MBIB-BATCH-INDEX      TO +1.
028900*
029000 1090-CURSOR-LOOP.
029100*
029200     IF  X-MBIB-BATCH-INDEX IS GREATER THAN +6
029300         MOVE SS08WS-CURSOR      TO IB01-ALT-TRANID-L
029400         GO TO 1100-CONTINUE.
029500*
029600     IF  IB01-SELECT-A (X-MBIB-BATCH-INDEX)
029700                                 IS EQUAL TO DFHBMASK
029800         SET X-MBIB-BATCH-INDEX  UP BY +1
029900         GO TO 1090-CURSOR-LOOP
030000     ELSE
030100         MOVE SS08WS-CURSOR      TO IB01-SELECT-L
030200                                    (X-MBIB-BATCH-INDEX).
030300*
030400 1100-CONTINUE.
030500*
030600     MOVE '*TOP*'                TO SS08WS-LINE-24-PF-KEY-FUNC(3).
030700     MOVE 'RESV*'                TO SS08WS-LINE-24-PF-KEY-FUNC(4).
030800     MOVE '*FWD*'                TO SS08WS-LINE-24-PF-KEY-FUNC(5).
030900     MOVE 'RESV*'                TO SS08WS-LINE-24-PF-KEY-FUNC(6).
031000     MOVE SS08WS-LINE-24         TO IB01-PF-KEYS.
031100     MOVE 'RESV'                 TO MBCA-PGMX-PF-TRANS-ID (3).
031200     MOVE 'RESV'                 TO MBCA-PGMX-PF-TRANS-ID (4).
031300     MOVE 'RESV'                 TO MBCA-PGMX-PF-TRANS-ID (5).
031400     MOVE 'RESV'                 TO MBCA-PGMX-PF-TRANS-ID (6).
031500*
031600     MOVE DFHBMASK               TO IB01-CURRENT-PAGE-A.
031700*
031800*
031900***********************************************************
032000*    SET THE CURRENCY CODE, CURRENCY NOD                  *
032100*            PER ITEM NOD, PERCENT NOD.                   *
032200***********************************************************
032300     IF IB01-ERR-MESSAGE IS EQUAL TO SPACES OR LOW-VALUES
032400        PERFORM MB06PD-FORMAT-MESSAGE-LINE
032500                                 THRU MB06PD-FML-EXIT
032600        MOVE SS08WS-FORMATTED-MSG   TO IB01-ERR-MESSAGE
032700     END-IF.
032800*
032900****************************************************************
033000*    SEND THE MAP                                              *
033100****************************************************************
033200*
033300     MOVE 'BM01'                 TO MBCA-PROGRAM-LOCATION.
033400     PERFORM MB60PD-SEND-MAP-WITH-ERASE
033500                                 THRU MB60PD-SMWE-EXIT.
033600*
033700****************************************************************
033800*    RETURN TO CICS                                            *
033900****************************************************************
034000*
034100     MOVE 'PC02'                 TO MBCA-PROGRAM-LOCATION.
034200     PERFORM MB70PD-RETURN-TRANS-ID
034300                                 THRU MB70PD-RTI-EXIT.
034400/
034500 2000-RECEIVE-SCREEN SECTION.
034600*
034700     IF  MBCA-EIBAID-CLEAR
034800         MOVE 'TS05'             TO MBCA-PROGRAM-LOCATION
034900         PERFORM 8300-TEMP-STORAGE-DELETE
035000                                 THRU 8399-TSD-EXIT
035100         MOVE 'PC03'             TO MBCA-PROGRAM-LOCATION
035200         PERFORM MB70PD-ON-LINE-HOUSEKEEPING
035300                                 THRU MB70PD-OLH-EXIT.
035400*
035500****************************************************************
035600*    THIS SECTION RECEIVES THE 01 SCREEN                       *
035700****************************************************************
035800*
035900     MOVE 'BM02'                 TO MBCA-PROGRAM-LOCATION.
036000     PERFORM MB60PD-RECEIVE-MAP  THRU MB60PD-RM-EXIT.
036100*
036200*****************************************************
036300*    ACQUIRE MAIN STORAGE FOR TEMP STORAGE RECORD   *
036400*****************************************************
036500*
036600     MOVE 'TS06'                 TO MBCA-PROGRAM-LOCATION.
036700     PERFORM 8100-TEMP-STORAGE-GETMAIN
036800                                 THRU 8199-TSG-EXIT.
036900*
037000***********************************************
037100*    READ THE TEMP STORAGE RECORD             *
037200***********************************************
037300*
037400     MOVE 'TS07'                 TO MBCA-PROGRAM-LOCATION.
037500     PERFORM 8200-TEMP-STORAGE-READ
037600                                 THRU 8299-TSR-EXIT.
037700*
037800***********************************************
037900*    DELETE THE TEMP STORAGE RECORD           *
038000***********************************************
038100*
038200     MOVE 'TS08'                 TO MBCA-PROGRAM-LOCATION.
038300     PERFORM 8300-TEMP-STORAGE-DELETE
038400                                 THRU 8399-TSD-EXIT.
038500*
038600****************************************************************
038700*    CHECK FOR ANOTHER TRANSACTION ID ENTERED BY THE USER      *
038800****************************************************************
038900*
039000     MOVE 'PC04'                 TO MBCA-PROGRAM-LOCATION.
039100     PERFORM MB60PD-NEW-TRANS-ROUTINE
039200                                 THRU MB60PD-NTR-EXIT.
039300*
039400 2005-EDIT-SELECT.
039500*
039600****************************************************************
039700*    EDIT SELECT FIELD                                         *
039800****************************************************************
039900*
040000     PERFORM 8600-EDIT-SELECT    THRU 8699-ES-EXIT.
040100*
040200 2090-CHECK-ERROR.
040300*
040400     IF  SS08WS-ERROR-SW-NO
040500         GO TO 2400-CHECK-SELECT.
040600*
040700 2300-SEND-MAP.
040800*
040900***********************************************
041000*    WRITE THE TEMP STORAGE RECORD            *
041100***********************************************
041200*
041300     MOVE 'TS09'                 TO MBCA-PROGRAM-LOCATION.
041400     PERFORM 8400-WRITE-QUEUE    THRU 8499-WQ-EXIT.
041500*
041600****************************************************************
041700*    SEND THE MAP                                              *
041800****************************************************************
041900*
042000     PERFORM MB60PD-INIT-STD-MAP-LINES
042100                                 THRU MB60PD-ISML-EXIT.
042200*
042300***********************************************************
042400*    SET THE CURRENCY CODE, CURRENCY NOD                  *
042500*            PER ITEM NOD, PERCENT NOD.                   *
042600***********************************************************
042700     IF IB01-ERR-MESSAGE IS EQUAL TO SPACES OR LOW-VALUES
042800        PERFORM MB06PD-FORMAT-MESSAGE-LINE
042900                                 THRU MB06PD-FML-EXIT
043000        MOVE SS08WS-FORMATTED-MSG   TO IB01-ERR-MESSAGE
043100     END-IF.
043200*
043300     MOVE '*TOP*'                TO SS08WS-LINE-24-PF-KEY-FUNC(3).
043400     MOVE 'RESV*'                TO SS08WS-LINE-24-PF-KEY-FUNC(4).
043500     MOVE '*FWD*'                TO SS08WS-LINE-24-PF-KEY-FUNC(5).
043600     MOVE 'RESV*'                TO SS08WS-LINE-24-PF-KEY-FUNC(6).
043700     MOVE SS08WS-LINE-24         TO IB01-PF-KEYS.
043800     MOVE 'RESV'                 TO MBCA-PGMX-PF-TRANS-ID (3).
043900     MOVE 'RESV'                 TO MBCA-PGMX-PF-TRANS-ID (4).
044000     MOVE 'RESV'                 TO MBCA-PGMX-PF-TRANS-ID (5).
044100     MOVE 'RESV'                 TO MBCA-PGMX-PF-TRANS-ID (6).
044200*
044300     MOVE DFHBMASK               TO IB01-CURRENT-PAGE-A.
044400*
044500     MOVE 'BM03'                 TO MBCA-PROGRAM-LOCATION.
044600     PERFORM MB60PD-SEND-MAP-DATA-ONLY
044700                                 THRU MB60PD-SMDO-EXIT.
044800*
044900****************************************************************
045000*    RETURN TO CICS                                            *
045100****************************************************************
045200*
045300     MOVE 'PC05'                 TO MBCA-PROGRAM-LOCATION.
045400     PERFORM MB70PD-RETURN-TRANS-ID
045500                                 THRU MB70PD-RTI-EXIT.
045600/
045700 2400-CHECK-SELECT.
045800*
045900     MOVE MBCA-EIBAID            TO SS08WS-EIBAID.
046000*
046100     IF  SS08WS-VALID-PF3
046200     OR  SS08WS-EIBAID-VALID-PF3
046300         GO TO 2600-SETUP-COMMAREA.
046400*
046500     IF  SS08WS-VALID-PF5
046600     OR  SS08WS-EIBAID-VALID-PF5
046700         GO TO 2600-SETUP-COMMAREA.
046800*
046900     IF  WS-SELECT-YES
047000         SET X-TS-IB01-INDEX     TO X-MBIB-BATCH-INDEX
047100         MOVE MBCA-MBIB-BACK-KEY TO MBCA-MBIB-1ST-KEY
047200                                    MBCA-MBIB-HDR-KEY
047300                                    MBCA-MBIB-FWD-KEY
047400         MOVE ZEROS              TO MBCA-MBIB-FWD-SEQ-NBR
047500         MOVE 1                  TO MBCA-MBIB-FWD-BATCH-SEQ
047600         MOVE MBCA-MBIB-FWD-KEY  TO MBCA-MBIB-1ST-KEY
047700         MOVE MBCA-MBIB-FWD-KEY  TO MBCA-MBIB-PAGE-2-3-KEY.
047800*
047900/
048000 2600-SETUP-COMMAREA.
048100*
048200****************************************************************
048300*    SET UP COMMAREA FIELDS AND TRANSFER TO THE NEXT PROGRAM   *
048400****************************************************************
048500*
048600     MOVE MBCA-EIBAID            TO SS08WS-EIBAID.
048700*
048800     IF  SS08WS-VALID-PF3
048900     OR  SS08WS-EIBAID-VALID-PF3
049000         MOVE 51                 TO MBCA-SCREEN-NBR
049100         MOVE MBCA-MBIB-1ST-KEY  TO MBCA-MBIB-FWD-KEY
049200         SET MBCA-MBIB-FILE3     TO TRUE
049300         GO TO 2690-PF-KEY-BYPASS.
049400*
049500     IF  SS08WS-VALID-PF5
049600     OR  SS08WS-EIBAID-VALID-PF5
049700         MOVE 51                 TO MBCA-SCREEN-NBR
049800         IF (TS-IB01-MERCHANT (1) IS GREATER THAN ZEROES
049900         AND TS-IB01-MERCHANT (6) IS EQUAL TO ZEROES)
050000         OR (MBCA-MBIB-SAVE-MERCHANT IS EQUAL TO ZEROES)
050100             SET MBCA-MBIB-RETURN-NORMAL
050200                                 TO TRUE
050300             MOVE 'TS10'         TO MBCA-PROGRAM-LOCATION
050400             PERFORM 8400-WRITE-QUEUE
050500                                 THRU 8499-WQ-EXIT
050600             GO TO 2690-PF-KEY-BYPASS
050700         ELSE
050800             SET MBCA-MBIB-RETURN-FWD
050900                                 TO TRUE
051000             MOVE TS-IB01-SEQ-NBR (6)
051100                                 TO MBCA-MBIB-FWD-SEQ-NBR
051200             ADD 1               TO MBCA-MBIB-FWD-SEQ-NBR
051300             GO TO 2690-PF-KEY-BYPASS.
051400*
051500     IF  SS08WS-VALID-PF-KEY
051600     OR  SS08WS-EIBAID-VALID-PF-KEY
051700         SET MBCA-INITIAL-SCREEN-NBR
051800                                 TO TRUE
051900         GO TO 2690-PF-KEY-BYPASS.
052000*
052100     IF  WS-SELECT-YES
052200         MOVE 52                 TO MBCA-SCREEN-NBR
052300     ELSE
052400         MOVE 51                 TO MBCA-SCREEN-NBR.
052500*
052600 2690-PF-KEY-BYPASS.
052700*
052800     IF  SS08WS-VALID-PF5
052900     OR  SS08WS-EIBAID-VALID-PF5
053000         NEXT SENTENCE
053100     ELSE
053200         SET MBCA-MBIB-FILE3     TO TRUE.
053300*
053400     MOVE 'PC06'                 TO MBCA-PROGRAM-LOCATION.
053500     PERFORM MB70PD-XCTL-TO-MBOXCTL
053600                                 THRU MB70PD-XTM-EXIT.
053700/
053800 8000-PERFORMED-ROUTINES-SECT SECTION.
053900*
054000 8100-TEMP-STORAGE-GETMAIN.
054100*
054200     EXEC CICS GETMAIN
054300               FLENGTH (LENGTH  OF MBIBTS-RECORD-1)
054400
054500               SET     (ADDRESS OF MBIBTS-RECORD-1)
054600
054700          END-EXEC.
054800*
054900 8199-TSG-EXIT.
055000     EXIT.
055100*
055200 8200-TEMP-STORAGE-READ.
055300*
055400     EXEC CICS READQ TS
055500               QUEUE   (TS-QUEUE-NAME)
055600               INTO    (MBIBTS-RECORD-1)
055700               LENGTH  (LENGTH  OF MBIBTS-RECORD-1)
055800
055900               ITEM    (1)
056000          END-EXEC.
056100*
056200 8299-TSR-EXIT.
056300     EXIT.
056400*
056500 8300-TEMP-STORAGE-DELETE.
056600*
056700     EXEC CICS IGNORE CONDITION
056800               QIDERR
056900          END-EXEC.
057000*
057100     EXEC CICS DELETEQ TS
057200               QUEUE  (TS-QUEUE-NAME)
057300          END-EXEC.
057400*
057500 8399-TSD-EXIT.
057600     EXIT.
057700*
057800 8400-WRITE-QUEUE.
057900*
058000     EXEC CICS WRITEQ TS
058100               QUEUE   (TS-QUEUE-NAME)
058200               FROM    (MBIBTS-RECORD-1)
058300               LENGTH  (LENGTH  OF MBIBTS-RECORD-1)
058400
058500          END-EXEC.
058600*
058700 8499-WQ-EXIT.
058800     EXIT.
058900*
059000 8600-EDIT-SELECT.
059100*
059200     SET X-MBIB-BATCH-INDEX      TO +1.
059300*
059400 8600-EDIT-LOOP.
059500*
059600     SET X-TS-IB01-INDEX         TO X-MBIB-BATCH-INDEX.
059700*
059800     IF  IB01-SELECT-L (X-MBIB-BATCH-INDEX) IS GREATER THAN ZERO
059900         IF  IB01-VALID-SELECT (X-MBIB-BATCH-INDEX)
060000             MOVE DFHBMASF       TO IB01-SELECT-A
060100                                    (X-MBIB-BATCH-INDEX)
060200             MOVE DFHBMDAS       TO IB01-SELECT-LP-A
060300                                    (X-MBIB-BATCH-INDEX)
060400                                    IB01-SELECT-RP-A
060500                                    (X-MBIB-BATCH-INDEX)
060600             IF  IB01-VALID-X (X-MBIB-BATCH-INDEX)
060700                 SET WS-SELECT-YES
060800                                 TO TRUE
060900                 MOVE TS-IB01-KEY (X-TS-IB01-INDEX)
061000                                 TO MBCA-MBIB-BACK-KEY
061100                 MOVE TS-IB01-MERCHANT (X-TS-IB01-INDEX)
061200                                 TO MBCA-MERCHANT
061300                 GO TO 8699-ES-EXIT
061400             ELSE
061500                 NEXT SENTENCE
061600         ELSE
061700             SET SS08WS-ERROR-SW-YES TO TRUE
061800             MOVE SS08WS-CURSOR  TO IB01-SELECT-L
061900                                    (X-MBIB-BATCH-INDEX)
062000             MOVE DFHBMUBF       TO IB01-SELECT-A
062100                                    (X-MBIB-BATCH-INDEX)
062200             MOVE DFHBMASB       TO IB01-SELECT-LP-A
062300                                    (X-MBIB-BATCH-INDEX)
062400                                    IB01-SELECT-RP-A
062500                                    (X-MBIB-BATCH-INDEX)
062600             GO TO 8699-ES-EXIT.
062700*
062800     IF  X-MBIB-BATCH-INDEX IS LESS THAN +6
062900         SET X-MBIB-BATCH-INDEX  UP BY +1
063000         GO TO 8600-EDIT-LOOP.
063100*
063200     MOVE +1                     TO IB01-SELECT-L (1).
063300     MOVE DFHBMASF               TO IB01-SELECT-A (1).
063400     MOVE DFHBMDAS               TO IB01-SELECT-LP-A (1)
063500                                    IB01-SELECT-RP-A (1).
063600     MOVE TS-IB01-MERCHANT (1)   TO MBCA-MERCHANT.
063700     SET X-MBIB-BATCH-INDEX      TO +1.
063800     SET X-TS-IB01-INDEX         TO +1.
063900     MOVE TS-IB01-KEY (X-TS-IB01-INDEX)
064000                                 TO MBCA-MBIB-BACK-KEY.
064100     SET WS-SELECT-YES           TO TRUE.
064200*
064300 8699-ES-EXIT.
064400     EXIT.
064500*
064600 8800-BUILD-SCREEN.
064700*
064800     SET X-MBIB-BATCH-INDEX      TO +1.
064900*
065000 8800-BUILD-LOOP.
065100*
065200     SET X-TS-IB01-INDEX         TO X-MBIB-BATCH-INDEX.
065300*
065400     IF  TS-IB01-MERCHANT (X-TS-IB01-INDEX)
065500                                 IS GREATER THAN ZEROES
065600         MOVE TS-IB01-MERCHANT (X-TS-IB01-INDEX)
065700                                 TO IB01-MERCHANT
065800                                    (X-MBIB-BATCH-INDEX)
065900*
066000         MOVE SPACES             TO SS01WS-EDIT-X
066100         MOVE TS-IB01-BATCH-DATE (X-TS-IB01-INDEX)
066200                                 TO SS01WS-JULIAN
066300         PERFORM SS26PD-NUMERICALLY-EDIT-DATE
066400            THRU SS26PD-NED-EXIT
066500         MOVE SS01WS-XX-XX-YYYY  TO IB01-BATCH-DATE
066600                                    (X-MBIB-BATCH-INDEX)
066700         MOVE TS-IB01-BATCH-NBR  (X-TS-IB01-INDEX)
066800                                 TO IB01-BATCH-NBR
066900                                    (X-MBIB-BATCH-INDEX)
067000         MOVE TS-IB01-BATCH-SOURCE (X-TS-IB01-INDEX)
067100                                 TO IB01-BATCH-SOURCE
067200                                    (X-MBIB-BATCH-INDEX)
067300         MOVE TS-IB01-REJ-REENTRY (X-TS-IB01-INDEX)
067400                                 TO IB01-REJ-REENTRY
067500                                    (X-MBIB-BATCH-INDEX)
067600         MOVE TS-IB01-STORE (X-TS-IB01-INDEX)
067700                                 TO IB01-STORE
067800                                    (X-MBIB-BATCH-INDEX)
067900*
068000         MOVE SPACES             TO SS01WS-EDIT-X
068100         MOVE TS-IB01-POST-DATE (X-TS-IB01-INDEX)
068200                                 TO SS01WS-JULIAN
068300         PERFORM SS26PD-NUMERICALLY-EDIT-DATE
068400            THRU SS26PD-NED-EXIT
068500         MOVE SS01WS-XX-XX-YYYY  TO IB01-POST-DATE
068600                                    (X-MBIB-BATCH-INDEX)
068700*
068800         MOVE TS-IB01-AMOUNT (X-TS-IB01-INDEX)
068900                                 TO SS95WS-IN-AMT
069000         PERFORM SS95PD-NAP-ROUTINE
069100                                 THRU SS95PD-NAP-EXIT
069200         MOVE SS95WS-OUT-AMT-L23 TO IB01-AMOUNT
069300                                    (X-MBIB-BATCH-INDEX)
069400     ELSE
069500         MOVE DFHBMASK           TO IB01-SELECT-A
069600                                    (X-MBIB-BATCH-INDEX)
069700         MOVE DFHBMDAS           TO IB01-AMOUNT-A
069800                                    (X-MBIB-BATCH-INDEX)
069900                                    IB01-SELECT-LP-A
070000                                    (X-MBIB-BATCH-INDEX)
070100                                    IB01-SELECT-RP-A
070200                                    (X-MBIB-BATCH-INDEX)
070300         MOVE DFHBMASK           TO IB01-SELECT-A
070400                                    (X-MBIB-BATCH-INDEX)
070500         MOVE DFHBMDAS           TO IB01-MERCHANT-A
070600                                    (X-MBIB-BATCH-INDEX)
070700                                    IB01-MERCH-LIT-A
070800                                    (X-MBIB-BATCH-INDEX)
070900                                    IB01-BATCH-DATE-A
071000                                    (X-MBIB-BATCH-INDEX)
071100                                    IB01-BATCH-DATE-LIT-A
071200                                    (X-MBIB-BATCH-INDEX)
071300                                    IB01-BATCH-NBR-A
071400                                    (X-MBIB-BATCH-INDEX)
071500                                    IB01-BATCH-NBR-LIT-A
071600                                    (X-MBIB-BATCH-INDEX)
071700                                    IB01-BATCH-SOURCE-A
071800                                    (X-MBIB-BATCH-INDEX)
071900                                    IB01-BATCH-SOURCE-LIT-A
072000                                    (X-MBIB-BATCH-INDEX)
072100                                    IB01-REJ-REENTRY-A
072200                                    (X-MBIB-BATCH-INDEX)
072300                                    IB01-REJ-REENTRY-LIT-A
072400                                    (X-MBIB-BATCH-INDEX)
072500                                    IB01-STORE-A
072600                                    (X-MBIB-BATCH-INDEX)
072700                                    IB01-STORE-LIT-A
072800                                    (X-MBIB-BATCH-INDEX)
072900                                    IB01-POST-DATE-A
073000                                    (X-MBIB-BATCH-INDEX)
073100                                    IB01-POST-DATE-LIT-A
073200                                    (X-MBIB-BATCH-INDEX)
073300                                    IB01-AMOUNT-A
073400                                    (X-MBIB-BATCH-INDEX)
073500                                    IB01-SELECT-LP-A
073600                                    (X-MBIB-BATCH-INDEX)
073700                                    IB01-SELECT-RP-A
073800                                    (X-MBIB-BATCH-INDEX).
073900*
074000     MOVE DFHBMASB               TO IB01-MERCHANT-A
074100                                    (X-MBIB-BATCH-INDEX)
074200                                    IB01-BATCH-DATE-A
074300                                    (X-MBIB-BATCH-INDEX)
074400                                    IB01-BATCH-NBR-A
074500                                    (X-MBIB-BATCH-INDEX)
074600                                    IB01-BATCH-SOURCE-A
074700                                    (X-MBIB-BATCH-INDEX)
074800                                    IB01-REJ-REENTRY-A
074900                                    (X-MBIB-BATCH-INDEX)
075000                                    IB01-STORE-A
075100                                    (X-MBIB-BATCH-INDEX)
075200                                    IB01-POST-DATE-A
075300                                    (X-MBIB-BATCH-INDEX)
075400                                    IB01-AMOUNT-A
075500                                    (X-MBIB-BATCH-INDEX).
075600*
075700     IF  X-MBIB-BATCH-INDEX IS LESS THAN +6
075800         SET X-MBIB-BATCH-INDEX  UP BY +1
075900         GO TO 8800-BUILD-LOOP.
076000*
076100 8899-BS-EXIT.
076200     EXIT.
076300*
076400*
076500 9500-BUILD-SCREEN-LINE.
076600*
076700     SET X-TS-IB01-INDEX         TO X-MBIB-BATCH-INDEX.
076800*
076900     MOVE MWD3-KEY               TO TS-IB01-KEY
077000                                    (X-TS-IB01-INDEX).
077100*
077200     MOVE MWD3-MERCHANT          TO IB01-MERCHANT
077300                                    (X-MBIB-BATCH-INDEX)
077400                                    TS-IB01-MERCHANT
077500                                    (X-TS-IB01-INDEX).
077600*
077700     MOVE SPACES                 TO SS01WS-EDIT-X.
077800     MOVE MWD3-BATCH-DATE        TO SS01WS-JULIAN
077900                                    TS-IB01-BATCH-DATE
078000                                    (X-TS-IB01-INDEX).
078100     PERFORM SS26PD-NUMERICALLY-EDIT-DATE
078200        THRU SS26PD-NED-EXIT.
078300     MOVE SS01WS-XX-XX-YYYY      TO IB01-BATCH-DATE
078400                                    (X-MBIB-BATCH-INDEX).
078500*
078600     MOVE MWD3-BATCH-NBR         TO IB01-BATCH-NBR
078700                                    (X-MBIB-BATCH-INDEX)
078800                                    TS-IB01-BATCH-NBR
078900                                    (X-TS-IB01-INDEX).
079000*
079100     MOVE MWD3-BATCH-SOURCE      TO IB01-BATCH-SOURCE
079200                                    (X-MBIB-BATCH-INDEX)
079300                                    TS-IB01-BATCH-SOURCE
079400                                    (X-TS-IB01-INDEX).
079500*
079600     MOVE MWD3-SEQ-NBR           TO TS-IB01-SEQ-NBR
079700                                    (X-TS-IB01-INDEX).
079800*
079900     MOVE MWD3-REJECT-REENTRY-FLAG
080000                                 TO IB01-REJ-REENTRY
080100                                    (X-MBIB-BATCH-INDEX)
080200                                    TS-IB01-REJ-REENTRY
080300                                    (X-TS-IB01-INDEX).
080400*
080500     MOVE MWD3-STORE             TO IB01-STORE
080600                                    (X-MBIB-BATCH-INDEX)
080700                                    TS-IB01-STORE
080800                                    (X-TS-IB01-INDEX).
080900*
081000     MOVE SPACES                 TO SS01WS-EDIT-X.
081100     MOVE MWD3-POST-DATE         TO SS01WS-JULIAN
081200                                    TS-IB01-POST-DATE
081300                                    (X-TS-IB01-INDEX).
081400     PERFORM SS26PD-NUMERICALLY-EDIT-DATE
081500        THRU SS26PD-NED-EXIT.
081600     MOVE SS01WS-XX-XX-YYYY     TO IB01-POST-DATE
081700                                    (X-MBIB-BATCH-INDEX).
081800*
081900     IF  MWD3-TF-DEBIT
082000         COMPUTE MWD3-AMOUNT = 0 - MWD3-AMOUNT.
082100*
082200     MOVE MWD3-AMOUNT            TO SS95WS-IN-AMT
082300                                    TS-IB01-AMOUNT
082400                                    (X-TS-IB01-INDEX).
082500     PERFORM SS95PD-NAP-ROUTINE
082600                                 THRU SS95PD-NAP-EXIT.
082700     MOVE SS95WS-OUT-AMT-L23     TO IB01-AMOUNT
082800                                    (X-MBIB-BATCH-INDEX).
082900*
083000     MOVE DFHBMASB               TO IB01-MERCHANT-A
083100                                    (X-MBIB-BATCH-INDEX)
083200                                    IB01-BATCH-DATE-A
083300                                    (X-MBIB-BATCH-INDEX)
083400                                    IB01-BATCH-NBR-A
083500                                    (X-MBIB-BATCH-INDEX)
083600                                    IB01-BATCH-SOURCE-A
083700                                    (X-MBIB-BATCH-INDEX)
083800                                    IB01-REJ-REENTRY-A
083900                                    (X-MBIB-BATCH-INDEX)
084000                                    IB01-STORE-A
084100                                    (X-MBIB-BATCH-INDEX)
084200                                    IB01-POST-DATE-A
084300                                    (X-MBIB-BATCH-INDEX)
084400                                    IB01-AMOUNT-A
084500                                    (X-MBIB-BATCH-INDEX).
084600*
084700     IF  X-MBIB-BATCH-INDEX IS EQUAL TO 6
084800         SET WS-ENDBR            TO TRUE
084900         SET WS-FWD-YES          TO TRUE.
085000*
085100     SET X-MBIB-BATCH-INDEX      UP BY 1.
085200*
085300 9599-BSL-EXIT.
085400     EXIT.
085500*
085600 9630-START-MMD3.
085700*
085800     MOVE MBCA-MBIB-FWD-KEY      TO MBIOWS-MMD3-KEY.
085900     MOVE 'FC02'                 TO MBCA-PROGRAM-LOCATION.
086000     MOVE SS08WS-CICS-FC-NOTFND  TO MBIORO-TEMP-STATUS-1.
086100     SET MBIORO-STARTBR-GTE      TO TRUE.
086200     PERFORM MMD3AO-ACCESS       THRU MMD3AO-ACCESS-EXIT.
086300     SET MBCA-MBIB-1ST-TIME-YES  TO TRUE.
086400*
086500     IF  SS08WS-RC-FC-NOTFND
086600         SET SS08WS-ERROR-SW-YES     TO TRUE
086700         GO TO 9639-MMD3-EXIT.
086800*
086900 9631-READ-MMD3.
087000*
087100     MOVE 'FC03'                 TO MBCA-PROGRAM-LOCATION.
087200     SET MBIORO-READ-SEQ         TO TRUE.
087300     PERFORM MMD3AO-ACCESS       THRU MMD3AO-ACCESS-EXIT.
087400*
087500     MOVE MMD3-RECORD            TO MWD3-RECORD.
087600*
087700     IF  MMD3-HEADER
087800         GO TO 9631-READ-MMD3.
087900*
088000     IF  MMD3-TRAILER
088100         SET MBCA-MBIB-FILE4     TO TRUE
088200         GO TO 9635-MMD3-ENDBR.
088300*
088400     IF  MBCA-MBIB-SEARCH-KEY IS EQUAL TO '6'
088500         MOVE SPACES             TO WS-SWITCH
088600         PERFORM 9770-SEARCH-6   THRU 9779-EXIT
088700         IF  WS-READ
088800             GO TO 9631-READ-MMD3
088900         ELSE
089000             IF  WS-ENDBR
089100                 IF  X-MBIB-BATCH-INDEX IS GREATER THAN 6
089200                 AND WS-FWD-YES
089300                     GO TO 9631-READ-MMD3
089400                 ELSE
089500                     GO TO 9635-MMD3-ENDBR
089600             ELSE
089700                 GO TO 9635-MMD3-ENDBR.
089800*
089900     IF  MBCA-MBIB-SEARCH-KEY IS EQUAL TO '5'
090000         MOVE SPACES             TO WS-SWITCH
090100         PERFORM 9780-SEARCH-5   THRU 9789-EXIT
090200         IF  WS-READ
090300             GO TO 9631-READ-MMD3
090400         ELSE
090500             IF  WS-ENDBR
090600                 IF  X-MBIB-BATCH-INDEX IS GREATER THAN 6
090700                 AND WS-FWD-YES
090800                     GO TO 9631-READ-MMD3
090900                 ELSE
091000                     GO TO 9635-MMD3-ENDBR
091100             ELSE
091200                 GO TO 9635-MMD3-ENDBR.
091300*
091400     IF  MBCA-MBIB-SEARCH-KEY IS EQUAL TO '4'
091500         MOVE SPACES             TO WS-SWITCH
091600         PERFORM 9790-SEARCH-4   THRU 9799-EXIT
091700         IF  WS-READ
091800             GO TO 9631-READ-MMD3
091900         ELSE
092000             IF  WS-ENDBR
092100                 IF  X-MBIB-BATCH-INDEX IS GREATER THAN 6
092200                 AND WS-FWD-YES
092300                     GO TO 9631-READ-MMD3
092400                 ELSE
092500                     GO TO 9635-MMD3-ENDBR
092600             ELSE
092700                 GO TO 9635-MMD3-ENDBR.
092800*
092900     IF  MBCA-MBIB-SEARCH-KEY IS EQUAL TO '3'
093000         MOVE SPACES             TO WS-SWITCH
093100         PERFORM 9800-SEARCH-3   THRU 9809-EXIT
093200         IF  WS-READ
093300             GO TO 9631-READ-MMD3
093400         ELSE
093500             IF  WS-ENDBR
093600                 IF  X-MBIB-BATCH-INDEX IS GREATER THAN 6
093700                 AND WS-FWD-YES
093800                     GO TO 9631-READ-MMD3
093900                 ELSE
094000                     GO TO 9635-MMD3-ENDBR
094100             ELSE
094200                 GO TO 9635-MMD3-ENDBR.
094300*
094400     IF  MBCA-MBIB-SEARCH-KEY IS EQUAL TO '2'
094500         MOVE SPACES             TO WS-SWITCH
094600         PERFORM 9810-SEARCH-2   THRU 9819-EXIT
094700         IF  WS-READ
094800             GO TO 9631-READ-MMD3
094900         ELSE
095000             IF  WS-ENDBR
095100                 IF  X-MBIB-BATCH-INDEX IS GREATER THAN 6
095200                 AND WS-FWD-YES
095300                     GO TO 9631-READ-MMD3
095400                 ELSE
095500                     GO TO 9635-MMD3-ENDBR
095600             ELSE
095700                 GO TO 9635-MMD3-ENDBR.
095800*
095900     IF  MBCA-MBIB-SEARCH-KEY IS EQUAL TO '1'
096000         MOVE SPACES             TO WS-SWITCH
096100         PERFORM 9820-SEARCH-1   THRU 9829-EXIT
096200         IF  WS-READ
096300             GO TO 9631-READ-MMD3
096400         ELSE
096500             IF  WS-ENDBR
096600                 AND WS-FWD-YES
096700                 IF  X-MBIB-BATCH-INDEX IS GREATER THAN 6
096800                     GO TO 9631-READ-MMD3
096900                 ELSE
097000                     GO TO 9635-MMD3-ENDBR
097100             ELSE
097200                 GO TO 9635-MMD3-ENDBR.
097300*
097400 9635-MMD3-ENDBR.
097500*
097600     MOVE 'FC04'                 TO MBCA-PROGRAM-LOCATION.
097700     SET MBIORO-ENDBR            TO TRUE.
097800     PERFORM MMD3AO-ACCESS       THRU MMD3AO-ACCESS-EXIT.
097900*
098000 9639-MMD3-EXIT.
098100      EXIT.
098200*
098300 9640-START-MMD4.
098400*
098500     IF  MBCA-MBIB-1ST-TIME-YES
098600         MOVE MBCA-MBIB-1ST-KEY  TO MBIOWS-MMD4-KEY
098700         SET MBCA-MBIB-1ST-TIME-NO
098800                                 TO TRUE
098900     ELSE
099000         MOVE MBCA-MBIB-FWD-KEY  TO MBIOWS-MMD4-KEY.
099100*
099200     MOVE 'FC05'                 TO MBCA-PROGRAM-LOCATION.
099300     MOVE SS08WS-CICS-FC-NOTFND  TO MBIORO-TEMP-STATUS-1.
099400     SET MBIORO-STARTBR-GTE      TO TRUE.
099500     PERFORM MMD4AO-ACCESS       THRU MMD4AO-ACCESS-EXIT.
099600*
099700     IF  SS08WS-RC-FC-NOTFND
099800         SET SS08WS-ERROR-SW-YES     TO TRUE
099900         GO TO 9649-MMD4-EXIT.
100000*
100100 9641-READ-MMD4.
100200*
100300     MOVE 'FC06'                 TO MBCA-PROGRAM-LOCATION.
100400     SET MBIORO-READ-SEQ         TO TRUE.
100500     PERFORM MMD4AO-ACCESS       THRU MMD4AO-ACCESS-EXIT.
100600*
100700     MOVE MMD4-RECORD            TO MWD3-RECORD.
100800*
100900     IF  MMD4-HEADER
101000         GO TO 9641-READ-MMD4.
101100*
101200     IF  MMD4-TRAILER
101300         SET MBCA-MBIB-FILE3     TO TRUE
101400         GO TO 9645-MMD4-ENDBR.
101500*
101600     IF  MBCA-MBIB-SEARCH-KEY IS EQUAL TO '6'
101700         MOVE SPACES             TO WS-SWITCH
101800         PERFORM 9770-SEARCH-6   THRU 9779-EXIT
101900         IF  WS-READ
102000             GO TO 9641-READ-MMD4
102100         ELSE
102200             IF  WS-ENDBR
102300                 IF  X-MBIB-BATCH-INDEX IS GREATER THAN 6
102400                 AND WS-FWD-YES
102500                     GO TO 9641-READ-MMD4
102600                 ELSE
102700                     GO TO 9645-MMD4-ENDBR
102800             ELSE
102900                 GO TO 9645-MMD4-ENDBR.
103000*
103100     IF  MBCA-MBIB-SEARCH-KEY IS EQUAL TO '5'
103200         MOVE SPACES             TO WS-SWITCH
103300         PERFORM 9780-SEARCH-5   THRU 9789-EXIT
103400         IF  WS-READ
103500             GO TO 9641-READ-MMD4
103600         ELSE
103700             IF  WS-ENDBR
103800                 IF  X-MBIB-BATCH-INDEX IS GREATER THAN 6
103900                 AND WS-FWD-YES
104000                     GO TO 9641-READ-MMD4
104100                 ELSE
104200                     GO TO 9645-MMD4-ENDBR
104300             ELSE
104400                 GO TO 9645-MMD4-ENDBR.
104500*
104600     IF  MBCA-MBIB-SEARCH-KEY IS EQUAL TO '4'
104700         MOVE SPACES             TO WS-SWITCH
104800         PERFORM 9790-SEARCH-4   THRU 9799-EXIT
104900         IF  WS-READ
105000             GO TO 9641-READ-MMD4
105100         ELSE
105200             IF  WS-ENDBR
105300                 IF  X-MBIB-BATCH-INDEX IS GREATER THAN 6
105400                 AND WS-FWD-YES
105500                     GO TO 9641-READ-MMD4
105600                 ELSE
105700                     GO TO 9645-MMD4-ENDBR
105800             ELSE
105900                 GO TO 9645-MMD4-ENDBR.
106000*
106100     IF  MBCA-MBIB-SEARCH-KEY IS EQUAL TO '3'
106200         MOVE SPACES             TO WS-SWITCH
106300         PERFORM 9800-SEARCH-3   THRU 9809-EXIT
106400         IF  WS-READ
106500             GO TO 9641-READ-MMD4
106600         ELSE
106700             IF  WS-ENDBR
106800                 IF  X-MBIB-BATCH-INDEX IS GREATER THAN 6
106900                 AND WS-FWD-YES
107000                     GO TO 9641-READ-MMD4
107100                 ELSE
107200                     GO TO 9645-MMD4-ENDBR
107300             ELSE
107400                 GO TO 9645-MMD4-ENDBR.
107500*
107600     IF  MBCA-MBIB-SEARCH-KEY IS EQUAL TO '2'
107700         MOVE SPACES             TO WS-SWITCH
107800         PERFORM 9810-SEARCH-2   THRU 9819-EXIT
107900         IF  WS-READ
108000             GO TO 9641-READ-MMD4
108100         ELSE
108200             IF  WS-ENDBR
108300                 IF  X-MBIB-BATCH-INDEX IS GREATER THAN 6
108400                 AND WS-FWD-YES
108500                     GO TO 9641-READ-MMD4
108600                 ELSE
108700                     GO TO 9645-MMD4-ENDBR
108800             ELSE
108900                 GO TO 9645-MMD4-ENDBR.
109000*
109100     IF  MBCA-MBIB-SEARCH-KEY IS EQUAL TO '1'
109200         MOVE SPACES             TO WS-SWITCH
109300         PERFORM 9820-SEARCH-1   THRU 9829-EXIT
109400         IF  WS-READ
109500             GO TO 9641-READ-MMD4
109600         ELSE
109700             IF  WS-ENDBR
109800                 IF  X-MBIB-BATCH-INDEX IS GREATER THAN 6
109900                 AND WS-FWD-YES
110000                     GO TO 9641-READ-MMD4
110100                 ELSE
110200                     GO TO 9645-MMD4-ENDBR
110300             ELSE
110400                 GO TO 9645-MMD4-ENDBR.
110500*
110600*
110700 9645-MMD4-ENDBR.
110800*
110900     MOVE 'FC07'                 TO MBCA-PROGRAM-LOCATION.
111000     SET MBIORO-ENDBR            TO TRUE.
111100     PERFORM MMD4AO-ACCESS       THRU MMD4AO-ACCESS-EXIT.
111200*
111300 9649-MMD4-EXIT.
111400      EXIT.
111500*
111600 9770-SEARCH-6.
111700*
111800     IF  MWD3-KEY (1:27) IS GREATER THAN
111900                              MBCA-MBIB-1ST-KEY (1:27)
112000         EVALUATE TRUE
112100             WHEN MBCA-MBIB-FILE3
112200                 SET MBCA-MBIB-FILE4 TO TRUE
112300             SET MBCA-MBIB-FILE-CHANGED
112400                                 TO TRUE
112500         END-EVALUATE
112600         IF  X-MBIB-BATCH-INDEX IS GREATER THAN 6
112700             SET WS-FWD-NO       TO TRUE
112800             INITIALIZE          MBCA-MBIB-SAVE-MERCHANT
112900             SET WS-ENDBR        TO TRUE
113000         ELSE
113100             SET WS-ENDBR        TO TRUE
113200     ELSE
113300         IF  MWD3-KEY (1:27) IS LESS THAN
113400                              MBCA-MBIB-1ST-KEY (1:27)
113500             SET WS-READ         TO TRUE
113600         ELSE
113700             IF  MWD3-BATCH-SEQ IS NOT EQUAL TO ZEROS
113800                 SET WS-READ             TO TRUE
113900             ELSE
114000                 IF  X-MBIB-BATCH-INDEX IS GREATER THAN 6
114100                     SET WS-ENDBR
114200                                 TO TRUE
114300                     SET WS-FWD-NO
114400                                 TO TRUE
114500                     MOVE MWD3-KEY
114600                                 TO MBCA-MBIB-FWD-KEY
114700         MOVE MWD3-MERCHANT      TO MBCA-MBIB-SAVE-MERCHANT
114800                     ADD 1       TO MBCA-MBIB-FWD-SEQ-NBR
114900                 ELSE
115000                     SET WS-READ TO TRUE
115100                     INITIALIZE  MBCA-MBIB-SAVE-MERCHANT
115200                     SET WS-REC-FOUND
115300                                 TO TRUE
115400                     PERFORM 9500-BUILD-SCREEN-LINE
115500                                 THRU 9599-BSL-EXIT.
115600*
115700 9779-EXIT.
115800     EXIT.
115900*
116000 9780-SEARCH-5.
116100*
116200     IF  MWD3-KEY (1:24) IS GREATER THAN
116300                              MBCA-MBIB-1ST-KEY (1:24)
116400         EVALUATE TRUE
116500             WHEN MBCA-MBIB-FILE3
116600                 SET MBCA-MBIB-FILE4 TO TRUE
116700             SET MBCA-MBIB-FILE-CHANGED
116800                                 TO TRUE
116900         END-EVALUATE
117000         IF  X-MBIB-BATCH-INDEX IS GREATER THAN 6
117100             SET WS-FWD-NO       TO TRUE
117200             INITIALIZE          MBCA-MBIB-SAVE-MERCHANT
117300             SET WS-ENDBR        TO TRUE
117400         ELSE
117500             SET WS-ENDBR        TO TRUE
117600     ELSE
117700         IF  MWD3-KEY (1:24) IS LESS THAN
117800                              MBCA-MBIB-1ST-KEY (1:24)
117900             SET WS-READ         TO TRUE
118000         ELSE
118100             IF  MWD3-BATCH-SEQ IS NOT EQUAL TO ZEROS
118200                 SET WS-READ     TO TRUE
118300             ELSE
118400                 IF  X-MBIB-BATCH-INDEX IS GREATER THAN 6
118500                     SET WS-ENDBR
118600                                 TO TRUE
118700                     SET WS-FWD-NO
118800                                 TO TRUE
118900                     MOVE MWD3-KEY
119000                                 TO MBCA-MBIB-FWD-KEY
119100                     MOVE MWD3-MERCHANT
119200                                 TO MBCA-MBIB-SAVE-MERCHANT
119300                     ADD 1       TO MBCA-MBIB-FWD-SEQ-NBR
119400                 ELSE
119500                     SET WS-READ TO TRUE
119600                     INITIALIZE  MBCA-MBIB-SAVE-MERCHANT
119700                     SET WS-REC-FOUND
119800                                 TO TRUE
119900                     PERFORM 9500-BUILD-SCREEN-LINE
120000                                 THRU 9599-BSL-EXIT.
120100*
120200 9789-EXIT.
120300     EXIT.
120400*
120500 9790-SEARCH-4.
120600*
120700     IF  MWD3-KEY (1:21) IS GREATER THAN
120800                              MBCA-MBIB-1ST-KEY (1:21)
120900         EVALUATE TRUE
121000             WHEN MBCA-MBIB-FILE3
121100                 SET MBCA-MBIB-FILE4 TO TRUE
121200             SET MBCA-MBIB-FILE-CHANGED
121300                                 TO TRUE
121400         END-EVALUATE
121500         IF  X-MBIB-BATCH-INDEX IS GREATER THAN 6
121600             SET WS-FWD-NO       TO TRUE
121700             INITIALIZE          MBCA-MBIB-SAVE-MERCHANT
121800             SET WS-ENDBR        TO TRUE
121900             GO TO 9799-EXIT
122000         ELSE
122100             SET WS-ENDBR        TO TRUE
122200             GO TO 9799-EXIT.
122300*
122400     IF  MWD3-KEY (1:21) IS LESS THAN
122500                              MBCA-MBIB-1ST-KEY (1:21)
122600         SET WS-READ         TO TRUE
122700         GO TO 9799-EXIT.
122800*
122900     IF  MWD3-BATCH-SEQ IS NOT EQUAL TO ZEROS
123000         SET WS-READ     TO TRUE
123100         GO TO 9799-EXIT.
123200*
123300     IF  MBCA-MBIB-1ST-BATCH-NBR IS GREATER THAN ZERO
123400         IF  MWD3-BATCH-NBR IS EQUAL
123500                                 TO MBCA-MBIB-1ST-BATCH-NBR
123600             IF  X-MBIB-BATCH-INDEX IS GREATER THAN 6
123700                 SET WS-ENDBR    TO TRUE
123800                 SET WS-FWD-NO   TO TRUE
123900                 MOVE MWD3-KEY   TO MBCA-MBIB-FWD-KEY
124000                 MOVE MWD3-MERCHANT
124100                                 TO MBCA-MBIB-SAVE-MERCHANT
124200                 ADD 1           TO MBCA-MBIB-FWD-SEQ-NBR
124300             ELSE
124400                 SET WS-READ     TO TRUE
124500                 INITIALIZE      MBCA-MBIB-SAVE-MERCHANT
124600                 SET WS-REC-FOUND
124700                                 TO TRUE
124800                 PERFORM 9500-BUILD-SCREEN-LINE
124900                                 THRU 9599-BSL-EXIT
125000         ELSE
125100             SET WS-READ         TO TRUE
125200     ELSE
125300         IF  X-MBIB-BATCH-INDEX IS GREATER THAN 6
125400             SET WS-ENDBR        TO TRUE
125500             SET WS-FWD-NO       TO TRUE
125600             MOVE MWD3-KEY       TO MBCA-MBIB-FWD-KEY
125700             MOVE MWD3-MERCHANT  TO MBCA-MBIB-SAVE-MERCHANT
125800             ADD 1               TO MBCA-MBIB-FWD-SEQ-NBR
125900         ELSE
126000             SET WS-READ         TO TRUE
126100             INITIALIZE          MBCA-MBIB-SAVE-MERCHANT
126200             SET WS-REC-FOUND    TO TRUE
126300             PERFORM 9500-BUILD-SCREEN-LINE
126400                                 THRU 9599-BSL-EXIT.
126500*
126600 9799-EXIT.
126700     EXIT.
126800*
126900 9800-SEARCH-3.
127000*
127100     IF  MWD3-KEY (1:17) IS GREATER THAN
127200                              MBCA-MBIB-1ST-KEY (1:17)
127300         EVALUATE TRUE
127400             WHEN MBCA-MBIB-FILE3
127500                 SET MBCA-MBIB-FILE4 TO TRUE
127600             SET MBCA-MBIB-FILE-CHANGED
127700                                 TO TRUE
127800         END-EVALUATE
127900         IF  X-MBIB-BATCH-INDEX IS GREATER THAN 6
128000             SET WS-FWD-NO       TO TRUE
128100             INITIALIZE          MBCA-MBIB-SAVE-MERCHANT
128200             SET WS-ENDBR        TO TRUE
128300             GO TO 9809-EXIT
128400         ELSE
128500             SET WS-ENDBR        TO TRUE
128600             GO TO 9809-EXIT.
128700*
128800     IF  MWD3-KEY (1:17) IS LESS THAN
128900                                 MBCA-MBIB-1ST-KEY (1:17)
129000         SET WS-READ             TO TRUE
129100         GO TO 9809-EXIT.
129200*
129300     IF  MWD3-BATCH-SEQ IS NOT EQUAL TO ZEROS
129400         SET WS-READ     TO TRUE
129500         GO TO 9809-EXIT.
129600*
129700     IF  MBCA-MBIB-1ST-BATCH-SOURCE IS EQUAL TO ZEROS
129800         NEXT SENTENCE
129900     ELSE
130000         IF  MWD3-BATCH-SOURCE IS EQUAL
130100                                 TO MBCA-MBIB-1ST-BATCH-SOURCE
130200             NEXT SENTENCE
130300         ELSE
130400             SET WS-READ         TO TRUE
130500             GO TO 9809-EXIT.
130600*
130700     IF  MBCA-MBIB-1ST-BATCH-NBR IS EQUAL TO ZEROS
130800         IF  X-MBIB-BATCH-INDEX IS GREATER THAN 6
130900             SET WS-ENDBR        TO TRUE
131000             SET WS-FWD-NO       TO TRUE
131100             MOVE MWD3-KEY       TO MBCA-MBIB-FWD-KEY
131200             MOVE MWD3-MERCHANT  TO MBCA-MBIB-SAVE-MERCHANT
131300             ADD 1               TO MBCA-MBIB-FWD-SEQ-NBR
131400         ELSE
131500             SET WS-READ         TO TRUE
131600             INITIALIZE          MBCA-MBIB-SAVE-MERCHANT
131700             SET WS-REC-FOUND    TO TRUE
131800             PERFORM 9500-BUILD-SCREEN-LINE
131900                                 THRU 9599-BSL-EXIT
132000     ELSE
132100         IF  MWD3-BATCH-NBR IS EQUAL
132200                                 TO MBCA-MBIB-1ST-BATCH-NBR
132300             IF  X-MBIB-BATCH-INDEX IS GREATER THAN 6
132400                 SET WS-ENDBR    TO TRUE
132500                 SET WS-FWD-NO   TO TRUE
132600                 MOVE MWD3-KEY   TO MBCA-MBIB-FWD-KEY
132700                 MOVE MWD3-MERCHANT
132800                                 TO MBCA-MBIB-SAVE-MERCHANT
132900                 ADD 1           TO MBCA-MBIB-FWD-SEQ-NBR
133000             ELSE
133100                 SET WS-READ     TO TRUE
133200                 INITIALIZE      MBCA-MBIB-SAVE-MERCHANT
133300                 SET WS-REC-FOUND
133400                                 TO TRUE
133500                 PERFORM 9500-BUILD-SCREEN-LINE
133600                                 THRU 9599-BSL-EXIT
133700         ELSE
133800             SET WS-READ             TO TRUE.
133900*
134000 9809-EXIT.
134100     EXIT.
134200*
134300 9810-SEARCH-2.
134400*
134500     IF  MWD3-KEY (1:12) IS GREATER THAN
134600                              MBCA-MBIB-1ST-KEY (1:12)
134700         EVALUATE TRUE
134800             WHEN MBCA-MBIB-FILE3
134900                 SET MBCA-MBIB-FILE4 TO TRUE
135000             SET MBCA-MBIB-FILE-CHANGED
135100                                 TO TRUE
135200         END-EVALUATE
135300         IF  X-MBIB-BATCH-INDEX IS GREATER THAN 6
135400             SET WS-FWD-NO       TO TRUE
135500             INITIALIZE          MBCA-MBIB-SAVE-MERCHANT
135600             SET WS-ENDBR        TO TRUE
135700             GO TO 9819-EXIT
135800         ELSE
135900             SET WS-ENDBR        TO TRUE
136000             GO TO 9819-EXIT.
136100*
136200     IF  MWD3-KEY (1:12) IS LESS THAN
136300                                 MBCA-MBIB-1ST-KEY (1:12)
136400         SET WS-READ             TO TRUE
136500         GO TO 9819-EXIT.
136600*
136700     IF  MWD3-BATCH-SEQ IS NOT EQUAL TO ZEROS
136800         SET WS-READ             TO TRUE
136900         GO TO 9819-EXIT.
137000*
137100     IF  MBCA-MBIB-1ST-BATCH-DATE IS EQUAL TO ZEROS
137200         NEXT SENTENCE
137300     ELSE
137400         IF  MWD3-BATCH-DATE IS EQUAL
137500                                 TO MBCA-MBIB-1ST-BATCH-DATE
137600             NEXT SENTENCE
137700         ELSE
137800             SET WS-READ         TO TRUE
137900             GO TO 9819-EXIT.
138000*
138100     IF  MBCA-MBIB-1ST-BATCH-SOURCE IS EQUAL TO ZEROS
138200         NEXT SENTENCE
138300     ELSE
138400         IF  MWD3-BATCH-SOURCE IS EQUAL
138500                                 TO MBCA-MBIB-1ST-BATCH-SOURCE
138600             NEXT SENTENCE
138700         ELSE
138800             SET WS-READ         TO TRUE
138900             GO TO 9819-EXIT.
139000*
139100     IF  MBCA-MBIB-1ST-BATCH-NBR IS EQUAL TO ZEROS
139200         IF  X-MBIB-BATCH-INDEX IS GREATER THAN 6
139300             SET WS-ENDBR        TO TRUE
139400             SET WS-FWD-NO       TO TRUE
139500             MOVE MWD3-KEY       TO MBCA-MBIB-FWD-KEY
139600             MOVE MWD3-MERCHANT  TO MBCA-MBIB-SAVE-MERCHANT
139700             ADD 1               TO MBCA-MBIB-FWD-SEQ-NBR
139800         ELSE
139900             SET WS-READ         TO TRUE
140000             SET WS-REC-FOUND    TO TRUE
140100             PERFORM 9500-BUILD-SCREEN-LINE
140200                                 THRU 9599-BSL-EXIT
140300             INITIALIZE          MBCA-MBIB-SAVE-MERCHANT
140400     ELSE
140500         IF  MWD3-BATCH-NBR IS EQUAL
140600                                 TO MBCA-MBIB-1ST-BATCH-NBR
140700             IF  X-MBIB-BATCH-INDEX IS GREATER THAN 6
140800                 SET WS-ENDBR    TO TRUE
140900                 SET WS-FWD-NO   TO TRUE
141000                 MOVE MWD3-KEY   TO MBCA-MBIB-FWD-KEY
141100                 MOVE MWD3-MERCHANT
141200                                 TO MBCA-MBIB-SAVE-MERCHANT
141300                 ADD 1           TO MBCA-MBIB-FWD-SEQ-NBR
141400             ELSE
141500                 SET WS-READ     TO TRUE
141600             SET WS-REC-FOUND    TO TRUE
141700                 PERFORM 9500-BUILD-SCREEN-LINE
141800                                 THRU 9599-BSL-EXIT
141900                 INITIALIZE      MBCA-MBIB-SAVE-MERCHANT
142000         ELSE
142100             SET WS-READ         TO TRUE.
142200*
142300 9819-EXIT.
142400     EXIT.
142500*
142600 9820-SEARCH-1.
142700*
142800     IF  MWD3-KEY (1:3) IS GREATER THAN
142900                              MBCA-MBIB-1ST-KEY (1:3)
143000         EVALUATE TRUE
143100             WHEN MBCA-MBIB-FILE3
143200                 SET MBCA-MBIB-FILE4 TO TRUE
143300             SET MBCA-MBIB-FILE-CHANGED
143400                                 TO TRUE
143500         END-EVALUATE
143600         IF  X-MBIB-BATCH-INDEX IS GREATER THAN 6
143700             SET WS-FWD-NO       TO TRUE
143800             INITIALIZE          MBCA-MBIB-SAVE-MERCHANT
143900             SET WS-ENDBR        TO TRUE
144000             GO TO 9829-EXIT
144100         ELSE
144200             SET WS-ENDBR        TO TRUE
144300             GO TO 9829-EXIT.
144400*
144500     IF  MWD3-KEY (1:3) IS LESS THAN
144600                                 MBCA-MBIB-1ST-KEY (1:3)
144700         SET WS-READ             TO TRUE
144800         GO TO 9829-EXIT.
144900*
145000     IF  MWD3-BATCH-SEQ IS NOT EQUAL TO ZEROS
145100         SET WS-READ             TO TRUE
145200         GO TO 9829-EXIT.
145300*
145400     IF  MBCA-MBIB-1ST-STORE IS EQUAL TO ZEROS
145500         NEXT SENTENCE
145600     ELSE
145700         IF  MWD3-STORE IS EQUAL
145800                                 TO MBCA-MBIB-1ST-STORE
145900             NEXT SENTENCE
146000         ELSE
146100             SET WS-READ         TO TRUE
146200             GO TO 9829-EXIT.
146300*
146400     IF  MBCA-MBIB-1ST-BATCH-DATE IS EQUAL TO ZEROS
146500         NEXT SENTENCE
146600     ELSE
146700         IF  MWD3-BATCH-DATE IS EQUAL
146800                                 TO MBCA-MBIB-1ST-BATCH-DATE
146900             NEXT SENTENCE
147000         ELSE
147100             SET WS-READ         TO TRUE
147200             GO TO 9829-EXIT.
147300*
147400     IF  MBCA-MBIB-1ST-BATCH-SOURCE IS EQUAL TO ZEROS
147500         NEXT SENTENCE
147600     ELSE
147700         IF  MWD3-BATCH-SOURCE IS EQUAL
147800                                 TO MBCA-MBIB-1ST-BATCH-SOURCE
147900             NEXT SENTENCE
148000         ELSE
148100             SET WS-READ         TO TRUE
148200             GO TO 9829-EXIT.
148300*
148400     IF  MBCA-MBIB-1ST-BATCH-NBR IS EQUAL TO ZEROS
148500         IF  X-MBIB-BATCH-INDEX IS GREATER THAN 6
148600             SET WS-ENDBR        TO TRUE
148700             SET WS-FWD-NO       TO TRUE
148800             MOVE MWD3-KEY       TO MBCA-MBIB-FWD-KEY
148900             MOVE MWD3-MERCHANT  TO MBCA-MBIB-SAVE-MERCHANT
149000             ADD 1               TO MBCA-MBIB-FWD-SEQ-NBR
149100         ELSE
149200             SET WS-READ         TO TRUE
149300             SET WS-REC-FOUND    TO TRUE
149400             PERFORM 9500-BUILD-SCREEN-LINE
149500                                 THRU 9599-BSL-EXIT
149600             INITIALIZE          MBCA-MBIB-SAVE-MERCHANT
149700     ELSE
149800         IF  MWD3-BATCH-NBR IS EQUAL
149900                                 TO MBCA-MBIB-1ST-BATCH-NBR
150000             IF  X-MBIB-BATCH-INDEX IS GREATER THAN 6
150100                 SET WS-ENDBR    TO TRUE
150200                 SET WS-FWD-NO   TO TRUE
150300                 MOVE MWD3-KEY   TO MBCA-MBIB-FWD-KEY
150400                 MOVE MWD3-MERCHANT
150500                                 TO MBCA-MBIB-SAVE-MERCHANT
150600                 ADD 1           TO MBCA-MBIB-FWD-SEQ-NBR
150700             ELSE
150800                 SET WS-READ     TO TRUE
150900                 SET WS-REC-FOUND
151000                                 TO TRUE
151100                 PERFORM 9500-BUILD-SCREEN-LINE
151200                                 THRU 9599-BSL-EXIT
151300                 INITIALIZE      MBCA-MBIB-SAVE-MERCHANT
151400         ELSE
151500             SET WS-READ         TO TRUE.
151600*
151700 9829-EXIT.
151800     EXIT.
151900*
152000/         JULIAN TO GREGORIAN DATE ROUTINE
152100     COPY SS08PD.
152200/
152300     COPY SS26PD.
152400/
152500     COPY SS27PD.
152600/         LINE 24 PF KEYS ROUTINE
152700     COPY SS15PD.
152800/         DEPOSIT BATCH D3 RECORD ACCESS ROUTINES
152900     COPY MMD3AO.
153000/         ORG FILE RECORD 1 ACCESS ROUTINES
153100     COPY MMOCAO.
153200/         DEPOSIT BATCH D4 RECORD ACCESS ROUTINES
153300     COPY MMD4AO.
153400/         FORMAT NBR AND AMOUNTS BY CURRENCY CODE
153500     COPY SS95PDO REPLACING ==:XXCA:== BY ==MBCA==.
153600/
153700     COPY MB60PD REPLACING 'MBMAPXX' BY 'MBIB01 '
153800                           MBMAPXXI BY MBIB01I
153900                           MBMAPXXO BY MBIB01O.
154000/         FORMAT MESSAGE LINE BUILDER
154100     COPY MB06PD.
154200/         ON-LINE PROCEDURES
154300     COPY MB70PD.
154400/
154500     COPY SMFTPXO.
