000100 IDENTIFICATION DIVISION.
000200 PROGRAM-ID. MBOIB04.
000201*       RELEASE DATE=08/24/01.        REVISION LEVEL=08.06      * ++++++++
000202***************************************************************** ++++++++
000203*WARNING.  THIS COMPUTER PROGRAM IS PROTECTED BY COPYRIGHT LAW  * ++++++++
000204*AND INTERNATIONAL TREATIES.  UNAUTHORIZED REPRODUCTION OR      * ++++++++
000205*DISTRIBUTION OF THIS PROGRAM, OR ANY PORTION OF IT, MAY RESULT * ++++++++
000206*IN SEVERE CIVIL AND CRIMINAL PENATLIES, AND WILL BE PROSECUTED * ++++++++
000207*TO THE MAXIMUM EXTENT POSSIBLE UNDER THE LAW.                  * ++++++++
000208*COPYRIGHT 1999 PAYSYS INTERNATIONAL, INC.  ALL RIGHTS RESERVED.* ++++++++
000209***************************************************************** ++++++++
000300*****************************************************************
000400*                                                               *
000500*   V - PLUS  M E R C H A N T   B A N K C A R D   S Y S T E M   *
000600*                                                               *
000700*      MBOIB04 - ON-LINE DEPOSIT BATCH DIRECTORY                *
000800*                SCREEN 04                                      *
000900*                                                               *
001000*              1. TRANSIDS                                      *
001100*                 A. MBIB                                       *
001200*              2. MAPS USED -                                   *
001300*                 A. MBIB04 (SCREEN 04)                         *
001400*              3. FILES USED -                                  *
001500*                 A. MMD3   (DEPOSIT BATCH D3)                  *
001600*                 B. MMD4   (DEPOSIT BATCH D4)                  *
001700*                                                               *
001800*****************************************************************
001900*
002000 ENVIRONMENT DIVISION.
002100 DATA DIVISION.
002200 WORKING-STORAGE SECTION.
002300 01  FILLER                  PIC  X(12)      VALUE '** WS-BEG **'.
002400*         I/O REQUEST BLOCK WORK AREAS
002500     COPY MBIOWS.
002600/         I/O REQUEST BLOCK
002700     COPY MBIORO.
002800/         DEPOSIT BATCH MASTER RECORD LAYOUT WORK FILE 3
002900     COPY MMD3RL REPLACING ==:MMD3:== BY ==MWD3==.
003000/         DATE WORK AREAS
003100     COPY SS01WS.
003200/         ONLINE WORK AREAS
003300     COPY SS08WS.
003400/
003500     COPY SS00WS.
003600/
003700     COPY SMFTWS.
003800/
003900     COPY SMPTRL REPLACING ==:SMPT:== BY ==SMPT==.
004000/
004100     COPY MB61LK.
004110/                                                                 RG800902
004112     COPY MTPTWS REPLACING ==:MTPT:== BY ==MTPT==.                RG800902
004114/                                                                 RG800902
004116     COPY SS31WS.                                                 RG800902
004200/
004300 01  WS-MISCELLANEOUS.
004400     03  WS-SAVE-EIBAID      PIC  X(01)      VALUE SPACES.
004500     03  WS-FWD-KEY.
004600         05  WS-FWD-ORG      PIC  9(03).
004700         05  WS-FWD-MERCHANT
004800                             PIC  9(09).
004900         05  WS-FWD-STORE    PIC  9(09).
005000         05  WS-FWD-BATCH-DATE
005100                             PIC S9(07)      COMP-3.
005200         05  WS-FWD-BATCH-SOURCE
005300                             PIC S9(05)      COMP-3.
005400         05  WS-FWD-BATCH-NBR
005500                             PIC S9(05)      COMP-3.
005600         05  WS-FWD-BATCH-SEQ
005700                             PIC S9(08)      BINARY.
005800         05  WS-FWD-SEQ-NBR  PIC S9(08)      BINARY.
005900     03  WS-READ-FILE-MMD4   PIC  X(01)      VALUE 'N'.
006000         88  WS-READ-FILE4                   VALUE 'Y'.
006100         88  WS-DO-NOT-READ-FILE4            VALUE 'N'.
006200     03  WS-SETT-FLAG-X.
006300         05  WS-SETT-FLAG    PIC  X(01).
006400         05  WS-SETT-ACCT    PIC  9(01).
006500*
006600     COPY MB00WS.
006700*
006800     COPY SS95WS.
006900*
007000 01  FILLER                  PIC  X(12)      VALUE '** WS-END **'.
007100/
007200 LINKAGE SECTION.
007300 01  DFHCOMMAREA.
007400     COPY MB60WS.
007500/         DEPOSIT DIRECTORY SCREEN 04 MAP DSECT
007600     COPY MBIB04.
007700/         DEPOSIT DIRECTORY SCREEN 04 MAP REDEFINITION
007800     COPY MBIB04R.
007900/         DEPOSIT BATCH MASTER RECORD LAYOUT FILE 3
008000     COPY MMD3RL REPLACING ==:MMD3:== BY ==MMD3==.
008100/         DEPOSIT BATCH MASTER RECORD LAYOUT FILE 4
008200     COPY MMD3RL REPLACING ==:MMD3:== BY ==MMD4==.
008300/
008400 PROCEDURE DIVISION.
008500 0000-HOUSEKEEPING SECTION.
008600 0100-INIT.
008700*
008800     MOVE 'PC01'                 TO MBCA-PROGRAM-LOCATION.
008900     PERFORM MB70PD-ON-LINE-HOUSEKEEPING
009000                                 THRU MB70PD-OLH-EXIT.
009100*
009200     SET SS95WS-FUNCTION-INITIALIZE
009300                           TO TRUE.
009400     PERFORM SS95PD-NAP-ROUTINE
009500        THRU SS95PD-NAP-EXIT.
009600*
009700     MOVE MBCA-CURRENCY-CODE     TO SS95WS-CURRENCY-CODE.
009800*
009900     IF  MBCA-RECEIVE-SCREEN
010000         GO TO 2000-RECEIVE-SCREEN.
010100*
010200 1000-SEND-SCREEN SECTION.
010300*
010400****************************************************************
010500*    GET CICS STORAGE NEEDED FOR THE MAP                       *
010600****************************************************************
010700*
010800     MOVE 'SC01'                 TO MBCA-PROGRAM-LOCATION.
010900     PERFORM MB60PD-GETMAIN-FOR-MAP
011000                                 THRU MB60PD-GFM-EXIT.
011100*
011200*******************************************
011300*    READ THE DEPOSIT BATCH RECORD HEADER *
011400*    TO DISPLAY HEADER INFORMATION        *
011500*******************************************
011600*
011700     MOVE MBCA-MBIB-HDR-KEY      TO MBIOWS-MMD3-KEY.
011800     MOVE ZEROS                  TO MBIOWS-MMD3-BATCH-SEQ.
011900     MOVE 'FC01'                 TO MBCA-PROGRAM-LOCATION.
012000     SET MBIORO-READ-RANDOM      TO TRUE.
012100     MOVE SS08WS-CICS-FC-NOTFND  TO MBIORO-TEMP-STATUS-1.
012200     PERFORM MMD3AO-ACCESS       THRU MMD3AO-ACCESS-EXIT.
012300*
012400     IF  SS08WS-RC-FC-NOTFND
012500         MOVE MBCA-MBIB-HDR-KEY  TO MBIOWS-MMD4-KEY
012600         MOVE ZEROS              TO MBIOWS-MMD4-BATCH-SEQ
012700         MOVE 'FC02'             TO MBCA-PROGRAM-LOCATION
012800         SET MBIORO-READ-RANDOM  TO TRUE
012900         PERFORM MMD4AO-ACCESS   THRU MMD4AO-ACCESS-EXIT
013000         MOVE MMD4-RECORD        TO MWD3-RECORD
013100     ELSE
013200         MOVE MMD3-RECORD        TO MWD3-RECORD.
013300*
013400     MOVE MWD3-ORG               TO IB04-ORG.
013500*
013600     MOVE SPACES                 TO SS01WS-EDIT-X.
013700     MOVE MWD3-BATCH-DATE        TO SS01WS-JULIAN
013800     PERFORM SS26PD-NUMERICALLY-EDIT-DATE
013900        THRU SS26PD-NED-EXIT.
014000     MOVE SS01WS-XX-XX-YYYY      TO IB04-BATCH-DATE.
014100*
014200     MOVE MWD3-BATCH-NBR         TO IB04-BATCH-NBR.
014300     MOVE MWD3-BATCH-SOURCE      TO IB04-BATCH-SOURCE.
014400     MOVE MWD3-MERCHANT          TO IB04-MERCHANT.
014500*
014600     MOVE SPACES                 TO SS01WS-EDIT-X.
014700     MOVE MWD3-REF-BATCH-DATE    TO SS01WS-JULIAN
014800     PERFORM SS26PD-NUMERICALLY-EDIT-DATE
014900        THRU SS26PD-NED-EXIT.
015000     MOVE SS01WS-XX-XX-YYYY      TO IB04-REF-DATE.
015100*
015200     MOVE MWD3-REF-BATCH-NBR     TO IB04-REF-NBR.
015300     MOVE MWD3-REF-BATCH-SOURCE  TO IB04-REF-SOURCE.
015400     MOVE MWD3-STORE             TO IB04-STORE.
015500*
015600     MOVE SPACES                 TO SS01WS-EDIT-X.
015700     MOVE MWD3-POST-DATE         TO SS01WS-JULIAN
015800     PERFORM SS26PD-NUMERICALLY-EDIT-DATE
015900        THRU SS26PD-NED-EXIT.
016000     MOVE SS01WS-XX-XX-YYYY      TO IB04-HDR-POST-DATE
016100*
016200     MOVE MWD3-REJECT-REENTRY-FLAG
016300                                 TO IB04-REJ-REENTRY.
016400     MOVE MWD3-SETT-FLAG         TO IB04-SETT-FLAG.
016500     MOVE MWD3-STMT-FLAG         TO IB04-STMT-FLAG.
016600     MOVE MWD3-DESC              TO IB04-ORG-NAME.
016700     MOVE MWD3-NBR-ITEMS         TO IB04-HDR-NBR-ITEMS.
016800     MOVE MWD3-SETT-FLAG         TO WS-SETT-FLAG.
016900     MOVE MWD3-SETT-ACCT         TO WS-SETT-ACCT.
017000     MOVE WS-SETT-FLAG-X         TO IB04-SETT-FLAG.
017100*
017200     IF  MWD3-TF-DEBIT
017300         COMPUTE MWD3-AMOUNT = 0 - MWD3-AMOUNT.
017400*
017500     MOVE MWD3-AMOUNT            TO SS95WS-IN-AMT.
017600     PERFORM SS95PD-NAP-ROUTINE
017700                                 THRU SS95PD-NAP-EXIT.
017800     MOVE SS95WS-OUT-AMT-L23     TO IB04-HDR-AMOUNT.
017900*
018000     MOVE 04                     TO MBCA-SCREEN-NBR.
018100*
018200****************************************************************
018300*    INITIALIZE THE STANDARD MAP LINES                         *
018400****************************************************************
018500*
018600     PERFORM MB60PD-INIT-STD-MAP-LINES
018700                                 THRU MB60PD-ISML-EXIT.
018800*
018900 1015-READ-DEPOSITS.
019000*
019100     IF  MBCA-MBIB-FILE3
019200         PERFORM 9630-START-MMD3 THRU 9639-MMD3-EXIT
019300         EVALUATE TRUE
019400           WHEN WS-READ-FILE4
019500             PERFORM 9640-START-MMD4
019600                                 THRU 9649-MMD4-EXIT
019700             SET WS-DO-NOT-READ-FILE4
019800                                 TO TRUE
019900         END-EVALUATE
020000     ELSE
020100         PERFORM 9640-START-MMD4 THRU 9649-MMD4-EXIT.
020200*
020300     IF  WS-FWD-MERCHANT IS NOT EQUAL TO ZEROES
020400         MOVE DFHBMASB           TO IB04-BACK-IND-A.
020500*
020600     MOVE SS08WS-CURSOR          TO IB04-ALT-TRANID-L.
020700*
020800 1100-CONTINUE.
020900*
021000     MOVE '*TOP*'                TO SS08WS-LINE-24-PF-KEY-FUNC(3).
021100     MOVE 'RESV*'                TO SS08WS-LINE-24-PF-KEY-FUNC(4).
021200     MOVE '*FWD*'                TO SS08WS-LINE-24-PF-KEY-FUNC(5).
021300     MOVE 'RESV*'                TO SS08WS-LINE-24-PF-KEY-FUNC(6).
021400     MOVE SS08WS-LINE-24         TO IB04-PF-KEYS.
021500     MOVE 'RESV'                 TO MBCA-PGMX-PF-TRANS-ID (3).
021600     MOVE 'RESV'                 TO MBCA-PGMX-PF-TRANS-ID (4).
021700     MOVE 'RESV'                 TO MBCA-PGMX-PF-TRANS-ID (5).
021800     MOVE 'RESV'                 TO MBCA-PGMX-PF-TRANS-ID (6).
021900*
022000*
022100***********************************************************
022200*    SET THE CURRENCY CODE, CURRENCY NOD                  *
022300*            PER ITEM NOD, PERCENT NOD.                   *
022400***********************************************************
022500     IF IB04-ERR-MESSAGE IS EQUAL TO SPACES OR LOW-VALUES
022600        PERFORM MB06PD-FORMAT-MESSAGE-LINE
022700                                  THRU MB06PD-FML-EXIT
022800        MOVE SS08WS-FORMATTED-MSG   TO IB04-ERR-MESSAGE
022900     END-IF.
023000*
023100****************************************************************
023200*    SEND THE MAP                                              *
023300****************************************************************
023400*
023500     MOVE 'BM01'                 TO MBCA-PROGRAM-LOCATION.
023600     PERFORM MB60PD-SEND-MAP-WITH-ERASE
023700                                 THRU MB60PD-SMWE-EXIT.
023800*
023900****************************************************************
024000*    RETURN TO CICS                                            *
024100****************************************************************
024200*
024300     MOVE 'PC02'                 TO MBCA-PROGRAM-LOCATION.
024400     PERFORM MB70PD-RETURN-TRANS-ID
024500                                 THRU MB70PD-RTI-EXIT.
024600/
024700 2000-RECEIVE-SCREEN SECTION.
024800*
024900****************************************************************
025000*    THIS SECTION RECEIVES THE 01 SCREEN                       *
025100****************************************************************
025200*
025300     MOVE 'BM02'                 TO MBCA-PROGRAM-LOCATION.
025400     PERFORM MB60PD-RECEIVE-MAP  THRU MB60PD-RM-EXIT.
025500*
025600****************************************************************
025700*    CHECK FOR ANOTHER TRANSACTION ID ENTERED BY THE USER      *
025800****************************************************************
025900*
026000     MOVE 'PC03'                 TO MBCA-PROGRAM-LOCATION.
026100     PERFORM MB60PD-NEW-TRANS-ROUTINE
026200                                 THRU MB60PD-NTR-EXIT.
026300*
026400 2090-CHECK-ERROR.
026500*
026600     IF  SS08WS-ERROR-SW-NO
026700         GO TO 2600-SETUP-COMMAREA.
026800*
026900 2300-SEND-MAP.
027000*
027100****************************************************************
027200*    SEND THE MAP                                              *
027300****************************************************************
027400*
027500     PERFORM MB60PD-INIT-STD-MAP-LINES
027600                                 THRU MB60PD-ISML-EXIT.
027700*
027800***************************************************************
027900*    SET THE CURRENCY CODE, CURRENCY NOD                      *
028000*            PER ITEM NOD, PERCENT NOD.                       *
028100***************************************************************
028200     IF IB04-ERR-MESSAGE IS EQUAL TO SPACES OR LOW-VALUES
028300        PERFORM MB06PD-FORMAT-MESSAGE-LINE
028400                                 THRU MB06PD-FML-EXIT
028500        MOVE SS08WS-FORMATTED-MSG   TO IB04-ERR-MESSAGE
028600     END-IF.
028700*
028800     MOVE '*TOP*'                TO SS08WS-LINE-24-PF-KEY-FUNC(3).
028900     MOVE 'RESV*'                TO SS08WS-LINE-24-PF-KEY-FUNC(4).
029000     MOVE '*FWD*'                TO SS08WS-LINE-24-PF-KEY-FUNC(5).
029100     MOVE 'RESV*'                TO SS08WS-LINE-24-PF-KEY-FUNC(6).
029200     MOVE SS08WS-LINE-24         TO IB04-PF-KEYS.
029300     MOVE 'RESV'                 TO MBCA-PGMX-PF-TRANS-ID (3).
029400     MOVE 'RESV'                 TO MBCA-PGMX-PF-TRANS-ID (4).
029500     MOVE 'RESV'                 TO MBCA-PGMX-PF-TRANS-ID (5).
029600     MOVE 'RESV'                 TO MBCA-PGMX-PF-TRANS-ID (6).
029700*
029800     MOVE 'BM03'                 TO MBCA-PROGRAM-LOCATION.
029900     PERFORM MB60PD-SEND-MAP-DATA-ONLY
030000                                 THRU MB60PD-SMDO-EXIT.
030100*
030200****************************************************************
030300*    RETURN TO CICS                                            *
030400****************************************************************
030500*
030600     MOVE 'PC04'                 TO MBCA-PROGRAM-LOCATION.
030700     PERFORM MB70PD-RETURN-TRANS-ID
030800                                 THRU MB70PD-RTI-EXIT.
030900/
031000 2600-SETUP-COMMAREA.
031100*
031200****************************************************************
031300*    SET UP COMMAREA FIELDS AND TRANSFER TO THE NEXT PROGRAM   *
031400****************************************************************
031500*
031600     MOVE MBCA-EIBAID            TO SS08WS-EIBAID.
031700*
031800     SET MBCA-MBIB-RETURN-NORMAL TO TRUE.
031900*
032000     IF  SS08WS-VALID-PF3
032100     OR  SS08WS-EIBAID-VALID-PF3
032200         MOVE 54                 TO MBCA-SCREEN-NBR
032300         MOVE MBCA-MBIB-1ST-KEY  TO MBCA-MBIB-FWD-KEY
032400         SET MBCA-MBIB-FILE3     TO TRUE
032500         GO TO 2690-PF-KEY-BYPASS.
032600*
032700     IF  SS08WS-VALID-PF5
032800     OR  SS08WS-EIBAID-VALID-PF5
032900         MOVE 54                 TO MBCA-SCREEN-NBR
033000         MOVE MBCA-MBIB-BACK-KEY TO MBCA-MBIB-FWD-KEY
033100         GO TO 2690-PF-KEY-BYPASS.
033200*
033300     IF  IB04-CURRENT-PAGE-L IS GREATER THAN ZERO
033400     AND IB04-CURRENT-PAGE   IS NUMERIC
033500         IF  IB04-CURRENT-PAGE IS EQUAL TO 1
033600             MOVE MBCA-MBIB-PAGE-1-KEY
033700                                 TO MBCA-MBIB-FWD-KEY
033800                                    MBCA-MBIB-1ST-KEY
033900             SET MBCA-MBIB-FILE3 TO TRUE
034000             MOVE 51             TO MBCA-SCREEN-NBR
034100             GO TO 2690-PF-KEY-BYPASS
034200         ELSE
034300             IF  IB04-CURRENT-PAGE IS EQUAL TO 2
034400                 MOVE MBCA-MBIB-PAGE-2-3-KEY
034500                                 TO MBCA-MBIB-FWD-KEY
034600                                    MBCA-MBIB-1ST-KEY
034700                 SET MBCA-MBIB-FILE3
034800                                 TO TRUE
034900                 MOVE 52         TO MBCA-SCREEN-NBR
035000                 GO TO 2690-PF-KEY-BYPASS
035100             ELSE
035200                 IF  IB04-CURRENT-PAGE IS EQUAL TO 3
035300                     MOVE MBCA-MBIB-PAGE-2-3-KEY
035400                                 TO MBCA-MBIB-FWD-KEY
035500                                    MBCA-MBIB-1ST-KEY
035600                     SET MBCA-MBIB-FILE3
035700                                 TO TRUE
035800                     MOVE 53     TO MBCA-SCREEN-NBR
035900                     GO TO 2690-PF-KEY-BYPASS
036000                 ELSE
036100                     SET MBCA-INITIAL-SCREEN-NBR
036200                                 TO TRUE
036300                     SET MBCA-MBIB-RETURN-NORMAL
036400                                 TO TRUE
036500                     GO TO 2690-PF-KEY-BYPASS.
036600*
036700     PERFORM MB60PD-EDIT-PAGE-NBR
036800                                 THRU MB60PD-EPN-EXIT.
036900*
037000     IF  SS08WS-VALID-PF-KEY
037100     OR  SS08WS-EIBAID-VALID-PF-KEY
037200         SET MBCA-INITIAL-SCREEN-NBR
037300                                 TO TRUE
037400         MOVE MBIOWS-MMD3-KEY-CODE
037500                                 TO MBCA-KEY-CODE.
037600*
037700*
037800 2690-PF-KEY-BYPASS.
037900*
038000     IF  SS08WS-VALID-PF5
038100     OR  SS08WS-EIBAID-VALID-PF5
038200         NEXT SENTENCE
038300     ELSE
038400         SET MBCA-MBIB-FILE3     TO TRUE.
038500*
038600     MOVE 'PC05'                 TO MBCA-PROGRAM-LOCATION.
038700     PERFORM MB70PD-XCTL-TO-MBOXCTL
038800                                 THRU MB70PD-XTM-EXIT.
038900/
039000 8000-PERFORMED-ROUTINES-SECT SECTION.
039100*
039200 9500-BUILD-SCREEN-LINE.
039300*
039400     MOVE MWD3-TRANS-CODE        TO IB04-TRANS-CODE.
039500     MOVE MWD3-LOGIC-MODULE      TO IB04-LOGIC-MODULE.
039600     MOVE MWD3-PRODUCT           TO IB04-CARD-PRODUCT.
039700     MOVE MWD3-PLAN              TO IB04-PLAN.
039800     MOVE MWD3-QUAL-LEVEL        TO IB04-QUAL-LEVEL.
039900     MOVE MWD3-RPT-DESC          TO IB04-RPT-DESC.
040000     EVALUATE TRUE
040100         WHEN MWD3-QI-INTRACHANGE-DIFF
040200             MOVE 'INTRACHANGE'  TO IB04-QUAL-IND
040300         WHEN MWD3-QI-INTRACHANGE-ONUS
040400             MOVE 'ON US'        TO IB04-QUAL-IND
040500         WHEN MWD3-QI-DOMESTIC-NORMAL
040600             MOVE 'DOMESTIC'     TO IB04-QUAL-IND
040700         WHEN MWD3-QI-INTERNATIONAL-NORMAL
040800             MOVE 'INTERNATIONL' TO IB04-QUAL-IND
040900         WHEN OTHER
041000             MOVE MWD3-QUAL-INDICATOR
041100                                 TO IB04-QUAL-IND
041200     END-EVALUATE.
041300     MOVE MWD3-NBR-ITEMS         TO IB04-NBR-ITEMS.
041400*
041500     IF  MWD3-TF-DEBIT
041600         COMPUTE MWD3-AMOUNT = 0 - MWD3-AMOUNT.
041700*
041800     MOVE MWD3-AMOUNT            TO SS95WS-IN-AMT.
041900     PERFORM SS95PD-NAP-ROUTINE
042000                                 THRU SS95PD-NAP-EXIT.
042100     MOVE SS95WS-OUT-AMT-L23     TO IB04-TRAN-AMOUNT
042200*
042300*
042400     IF  MWD3-VDI-NOT-PRESENT
042500         MOVE SPACES             TO IB04-DISC-RATE
042600         MOVE ZEROS              TO IB04-PART-AMT
042700                                    IB04-DISC-AMT
042800                                    IB04-PART-RATE
042900                                    IB04-REF-TRAN-CODE
043000                                    IB04-REF-ORG
043100         MOVE SPACES             TO IB04-ACCOUNT
043200                                    IB04-AUTH
043300     ELSE
043400         COMPUTE MWD3-INDIV-DISC-RATE = MWD3-INDIV-DISC-RATE
043500                                  + MWD3-INDIV-DISC-ADJ-RATE
043600*
043700         IF  MWD3-IDI-IS-RATE
043800             MOVE MWD3-INDIV-DISC-RATE
043900                                 TO SS95WS-IN-PCT
044000             MOVE MBCA-PERCENT-NOD   TO SS95WS-IN-PCT-NOD
044100             PERFORM SS95PD-NAP-ROUTINE
044200                                 THRU SS95PD-NAP-EXIT
044300             MOVE SS95WS-OUT-PCT-L10
044400                                 TO IB04-DISC-RATE
044500         ELSE
044600             MOVE MWD3-INDIV-DISC-PER-ITEM
044700                                 TO SS95WS-IN-PCT
044800             MOVE MBCA-PER-ITEM-NOD  TO SS95WS-IN-PCT-NOD
044900             PERFORM SS95PD-NAP-ROUTINE
045000                                 THRU SS95PD-NAP-EXIT
045100             MOVE SS95WS-OUT-PCT-L10
045200                                 TO IB04-DISC-RATE
045300         END-IF
045400*
045500         MOVE MWD3-INDIV-PART-AMT
045600                                 TO SS95WS-IN-AMT
045700         PERFORM SS95PD-NAP-ROUTINE
045800                                 THRU SS95PD-NAP-EXIT
045900         MOVE SS95WS-OUT-AMT-L23 TO IB04-PART-AMT
046000*
046100         MOVE MWD3-INDIV-DISC-AMT
046200                                 TO SS95WS-IN-AMT
046300         PERFORM SS95PD-NAP-ROUTINE
046400                                 THRU SS95PD-NAP-EXIT
046500         MOVE SS95WS-OUT-AMT-L23 TO IB04-DISC-AMT
046600*
046700         COMPUTE MWD3-INDIV-PART-RATE = MWD3-INDIV-PART-RATE
046800                                  + MWD3-INDIV-PART-ADJ-RATE
046900*
047000         IF  MWD3-IPI-IS-RATE
047100             MOVE MBCA-PERCENT-NOD TO SS95WS-IN-PCT-NOD
047200             MOVE MWD3-INDIV-PART-RATE
047300                                 TO SS95WS-IN-PCT
047400             PERFORM SS95PD-NAP-ROUTINE
047500                                 THRU SS95PD-NAP-EXIT
047600             MOVE SS95WS-OUT-PCT-L10
047700                                 TO IB04-PART-RATE
047800         ELSE
047900             MOVE MBCA-PER-ITEM-NOD TO SS95WS-IN-PCT-NOD
048000             MOVE MWD3-INDIV-PART-PER-ITEM
048100                                 TO SS95WS-IN-PCT
048200             PERFORM SS95PD-NAP-ROUTINE
048300                                 THRU SS95PD-NAP-EXIT
048400             MOVE SS95WS-OUT-PCT-L10
048500                                 TO IB04-PART-RATE
048600         END-IF
048700         MOVE MWD3-AR-TRANS-CODE TO IB04-REF-TRAN-CODE
048800         MOVE MWD3-AR-ORG        TO IB04-REF-ORG
048900         MOVE MWD3-AR-ACCT       TO IB04-ACCOUNT
049000         MOVE MWD3-AR-AUTH-CODE  TO IB04-AUTH
049100     END-IF.
049200*
049300     MOVE SPACES                 TO SS01WS-EDIT-X.
049400     MOVE MWD3-ENTRY-DATE        TO SS01WS-JULIAN
049500     PERFORM SS26PD-NUMERICALLY-EDIT-DATE
049600        THRU SS26PD-NED-EXIT.
049700     MOVE SS01WS-XX-XX-YYYY      TO IB04-ENTRY-DATE.
049800*
049900     MOVE MWD3-DESC              TO IB04-DESCRIPTION.
050000     MOVE MWD3-DEPT-CODE         TO IB04-DEPARTMENT.
050100     MOVE MWD3-REF-PRODUCT       TO IB04-REF-CARD-PRODUCT.
050200     MOVE MWD3-REF-PLAN          TO IB04-REF-PLAN.
050300     MOVE MWD3-REF-QUAL-LEVEL    TO IB04-REF-QUAL-LEVEL.
050400     MOVE MWD3-LOGO              TO IB04-LOGO.
050500*
050510     MOVE MWD3-MERCH-DUP-IND     TO SS31WS-BYTE.                  RG800902
050512*                                                                 RG800902
050514     PERFORM SS31PD-EXPAND-BYTE                                   RG800902
050516        THRU SS31PD-EB-EXIT.                                      RG800902
050518     MOVE SS31WS-EXPANDED-BITS-X TO MTPTWS-MERCH-DUP-FIELDS.      RG800902
050520*                                                                 RG800902
050600     IF  MTPTWS-MERCH-DUP-IN-BATCH                                RG800902
050700     AND MTPTWS-MERCH-DUP-BY-DAY                                  RG800902
050800         MOVE 'IN BATCH'         TO IB04-DUPLICATE
050900     ELSE
051000         IF  MTPTWS-MERCH-DUP-IN-BATCH                            RG800902
051100             MOVE 'IN BATCH'     TO IB04-DUPLICATE
051200         ELSE
051300             IF  MTPTWS-MERCH-DUP-BY-DAY                          RG800902
051400                 MOVE 'IN DAY  ' TO IB04-DUPLICATE.
051500*
051600     MOVE MWD3-GOVERNING-STATE   TO IB04-GOV-STATE.
051700     MOVE MWD3-SKU-NBR           TO IB04-SKU.
051800     MOVE MWD3-REF-NBR           TO IB04-REF-NUMBER.
051900     MOVE MWD3-ORIG-OPERATOR     TO IB04-ORIG-OPER.
052000     MOVE MWD3-LAST-OPERATOR     TO IB04-LAST-OPER.
052100     MOVE MWD3-REF-NBR-ITEMS     TO IB04-REF-NBR-ITEMS.
052200     MOVE MWD3-REF-BATCH-SEQ     TO IB04-FILE-SEQ.
052300*
052400     MOVE MWD3-REF-AMOUNT-1      TO SS95WS-IN-AMT.
052500     PERFORM SS95PD-NAP-ROUTINE
052600                                 THRU SS95PD-NAP-EXIT.
052700     MOVE SS95WS-OUT-AMT-L23     TO IB04-REF-AMOUNT-1.
052800*
052900     MOVE MWD3-REF-AMOUNT-2      TO SS95WS-IN-AMT.
053000     PERFORM SS95PD-NAP-ROUTINE
053100                                 THRU SS95PD-NAP-EXIT.
053200     MOVE SS95WS-OUT-AMT-L23     TO IB04-REF-AMOUNT-2.
053300*
053400     MOVE MWD3-TRANS-FLAG        TO IB04-TRANS-FLAG.
053500     MOVE MWD3-ORIG-GL-SOURCE    TO IB04-GL-SOURCE.
053600     MOVE MWD3-AR-MT-TYPE        TO IB04-AR-TYPE-FLAG.
053700     MOVE MWD3-AR-LOGIC-MODULE   TO IB04-AR-LOGIC-MOD.
053800     MOVE MWD3-AR-POST-FLAG      TO IB04-AR-POST-FLAG.
053900     MOVE MWD3-AR-CURR-INPUT-SOURCE
054000                                 TO IB04-AR-CURR-SRC.
054100*
054200 9599-BSL-EXIT.
054300     EXIT.
054400*
054500 9630-START-MMD3.
054600*
054700     MOVE MBCA-MBIB-FWD-KEY      TO MBIOWS-MMD3-KEY.
054800     MOVE 'FC03'                 TO MBCA-PROGRAM-LOCATION.
054900     MOVE SS08WS-CICS-FC-NOTFND  TO MBIORO-TEMP-STATUS-1.
055000     SET MBIORO-STARTBR-GTE      TO TRUE.
055100     PERFORM MMD3AO-ACCESS       THRU MMD3AO-ACCESS-EXIT.
055200     SET MBCA-MBIB-1ST-TIME-YES  TO TRUE.
055300*
055400     IF  SS08WS-RC-FC-NOTFND
055500         SET SS08WS-ERROR-SW-YES TO TRUE
055600         GO TO 9639-MMD3-EXIT.
055700*
055800 9631-READ-MMD3.
055900*
056000     MOVE 'FC04'                 TO MBCA-PROGRAM-LOCATION.
056100     SET MBIORO-READ-SEQ         TO TRUE.
056200     PERFORM MMD3AO-ACCESS       THRU MMD3AO-ACCESS-EXIT.
056300*
056400     IF  MMD3-HEADER
056500         GO TO 9631-READ-MMD3.
056600*
056700     IF  MMD3-TRAILER
056800         SET MBCA-MBIB-FILE4     TO TRUE
056900         SET WS-READ-FILE4       TO TRUE
057000         GO TO 9635-MMD3-ENDBR.
057100*
057200     IF  MMD3-KEY (1:27) IS GREATER THAN
057300                                    MBCA-MBIB-FWD-KEY (1:27)
057400         SET MBCA-MBIB-FILE4     TO TRUE
057500         SET WS-READ-FILE4       TO TRUE
057600     ELSE
057700         MOVE MMD3-RECORD        TO MWD3-RECORD
057800         MOVE MWD3-KEY           TO MBCA-MBIB-FWD-KEY
057900         INITIALIZE              WS-FWD-KEY
058000         PERFORM 9650-READ-AHEAD-MMD3
058100                                 THRU 9659-RAMMD3-EXIT
058200         PERFORM 9500-BUILD-SCREEN-LINE
058300                                 THRU 9599-BSL-EXIT.
058400*
058500 9635-MMD3-ENDBR.
058600*
058700     MOVE 'FC05'                 TO MBCA-PROGRAM-LOCATION.
058800     SET MBIORO-ENDBR            TO TRUE.
058900     PERFORM MMD3AO-ACCESS       THRU MMD3AO-ACCESS-EXIT.
059000*
059100 9639-MMD3-EXIT.
059200      EXIT.
059300*
059400 9640-START-MMD4.
059500*
059600     IF  MBCA-MBIB-1ST-TIME-YES
059700         MOVE MBCA-MBIB-1ST-KEY  TO MBIOWS-MMD4-KEY
059800         SET MBCA-MBIB-1ST-TIME-NO
059900                                 TO TRUE
060000     ELSE
060100         MOVE MBCA-MBIB-FWD-KEY  TO MBIOWS-MMD4-KEY.
060200*
060300     MOVE 'FC06'                 TO MBCA-PROGRAM-LOCATION.
060400     MOVE SS08WS-CICS-FC-NOTFND  TO MBIORO-TEMP-STATUS-1.
060500     SET MBIORO-STARTBR-GTE      TO TRUE.
060600     PERFORM MMD4AO-ACCESS       THRU MMD4AO-ACCESS-EXIT.
060700*
060800     IF  SS08WS-RC-FC-NOTFND
060900         SET SS08WS-ERROR-SW-YES TO TRUE
061000         GO TO 9649-MMD4-EXIT.
061100*
061200 9641-READ-MMD4.
061300*
061400     MOVE 'FC07'                 TO MBCA-PROGRAM-LOCATION.
061500     SET MBIORO-READ-SEQ         TO TRUE.
061600     PERFORM MMD4AO-ACCESS       THRU MMD4AO-ACCESS-EXIT.
061700*
061800     IF  MMD4-HEADER
061900         GO TO 9641-READ-MMD4.
062000*
062100     IF  MMD4-TRAILER
062200         SET MBCA-MBIB-FILE4     TO TRUE
062300         GO TO 9645-MMD4-ENDBR.
062400*
062500     IF  MMD4-KEY (1:27) IS GREATER THAN
062600                                    MBCA-MBIB-1ST-KEY (1:27)
062700         SET SS08WS-ERROR-SW-YES TO TRUE
062800         SET MBCA-MBIB-FILE3     TO TRUE
062900     ELSE
063000         MOVE MMD4-RECORD        TO MWD3-RECORD
063100         MOVE MWD3-KEY           TO MBCA-MBIB-FWD-KEY
063200         INITIALIZE              WS-FWD-KEY
063300         PERFORM 9660-READ-AHEAD-MMD4
063400                             THRU 9669-RAMMD4-EXIT
063500         PERFORM 9500-BUILD-SCREEN-LINE
063600                                 THRU 9599-BSL-EXIT.
063700*
063800 9645-MMD4-ENDBR.
063900*
064000     MOVE 'FC08'                 TO MBCA-PROGRAM-LOCATION.
064100     SET MBIORO-ENDBR            TO TRUE.
064200     PERFORM MMD4AO-ACCESS       THRU MMD4AO-ACCESS-EXIT.
064300*
064400 9649-MMD4-EXIT.
064500      EXIT.
064600*
064700 9650-READ-AHEAD-MMD3.
064800*
064900     MOVE 'FC09'                 TO MBCA-PROGRAM-LOCATION.
065000     SET MBIORO-READ-SEQ         TO TRUE.
065100     PERFORM MMD3AO-ACCESS       THRU MMD3AO-ACCESS-EXIT.
065200*
065300     IF  MMD3-KEY (1:27) IS GREATER THAN
065400                                    MBCA-MBIB-1ST-KEY (1:27)
065500     OR  MMD3-TRAILER
065600         SET MBCA-MBIB-FILE4     TO TRUE
065700         PERFORM 9700-START-MMD4-FWD
065800                                 THRU 9709-MMD4-EXIT
065900     ELSE
066000         SET MBCA-MBIB-FILE3     TO TRUE
066100         MOVE MMD3-KEY           TO MBCA-MBIB-BACK-KEY
066200                                    WS-FWD-KEY.
066300*
066400 9659-RAMMD3-EXIT.
066500      EXIT.
066600*
066700 9660-READ-AHEAD-MMD4.
066800*
066900     MOVE 'FC10'                 TO MBCA-PROGRAM-LOCATION.
067000     SET MBIORO-READ-SEQ         TO TRUE.
067100     PERFORM MMD4AO-ACCESS       THRU MMD4AO-ACCESS-EXIT.
067200*
067300     IF  MMD4-KEY (1:27) IS GREATER THAN
067400                                    MBCA-MBIB-1ST-KEY (1:27)
067500     OR  MMD4-TRAILER
067600         SET MBCA-MBIB-FILE3     TO TRUE
067700         MOVE MWD3-KEY           TO MBCA-MBIB-BACK-KEY
067800         MOVE ZEROS              TO WS-FWD-KEY
067900     ELSE
068000         SET MBCA-MBIB-FILE4     TO TRUE
068100         MOVE MMD4-KEY           TO MBCA-MBIB-BACK-KEY
068200                                    WS-FWD-KEY.
068300*
068400 9669-RAMMD4-EXIT.
068500      EXIT.
068600*
068700 9700-START-MMD4-FWD.
068800*
068900     MOVE MBCA-MBIB-1ST-KEY      TO MBIOWS-MMD4-KEY.
069000*
069100     MOVE 'FC11'                 TO MBCA-PROGRAM-LOCATION.
069200     MOVE SS08WS-CICS-FC-NOTFND  TO MBIORO-TEMP-STATUS-1.
069300     SET MBIORO-STARTBR-GTE      TO TRUE.
069400     PERFORM MMD4AO-ACCESS       THRU MMD4AO-ACCESS-EXIT.
069500*
069600     IF  SS08WS-RC-FC-NOTFND
069700         SET SS08WS-ERROR-SW-YES TO TRUE
069800         GO TO 9709-MMD4-EXIT.
069900*
070000 9701-READ-MMD4.
070100*
070200     MOVE 'FC12'                 TO MBCA-PROGRAM-LOCATION.
070300     SET MBIORO-READ-SEQ         TO TRUE.
070400     PERFORM MMD4AO-ACCESS       THRU MMD4AO-ACCESS-EXIT.
070500*
070600     IF  MMD4-HEADER
070700         GO TO 9701-READ-MMD4.
070800*
070900     IF  MMD4-TRAILER
071000         SET MBCA-MBIB-FILE4     TO TRUE
071100         GO TO 9705-MMD4-ENDBR.
071200*
071300     IF  MMD4-KEY (1:27) IS GREATER THAN
071400                                    MBCA-MBIB-1ST-KEY (1:27)
071500     OR  MMD4-TRAILER
071600         SET MBCA-MBIB-FILE3     TO TRUE
071700         MOVE MWD3-KEY           TO MBCA-MBIB-BACK-KEY
071800         MOVE ZEROS              TO WS-FWD-KEY
071900     ELSE
072000         SET MBCA-MBIB-FILE4     TO TRUE
072100         MOVE MMD4-KEY           TO MBCA-MBIB-BACK-KEY
072200                                    WS-FWD-KEY.
072300*
072400 9705-MMD4-ENDBR.
072500*
072600     MOVE 'FC13'                 TO MBCA-PROGRAM-LOCATION.
072700     SET MBIORO-ENDBR            TO TRUE.
072800     PERFORM MMD4AO-ACCESS       THRU MMD4AO-ACCESS-EXIT.
072900*
073000 9709-MMD4-EXIT.
073100      EXIT.
073200/         JULIAN TO GREGORIAN DATE ROUTINE
073300     COPY SS08PD.
073400/
073500     COPY SS26PD.
073600/
073700     COPY SS27PD.
073800/         LINE 24 PF KEYS ROUTINE
073900     COPY SS15PD.
073910/         EXPAND/COMPRESS BITS TO BYTES ROUTINE                   RG800902
073912     COPY SS31PD.                                                 RG800902
074000/         DEPOSIT BATCH D3 RECORD ACCESS ROUTINES
074100     COPY MMD3AO.
074200/         DEPOSIT BATCH D4 RECORD ACCESS ROUTINES
074300     COPY MMD4AO.
074400/         FORMAT NBR AND AMOUNTS BY CURRENCY CODE
074500     COPY SS95PDO REPLACING ==:XXCA:== BY ==MBCA==.
074600/         ON-LINE MAP ROUTINES
074700     COPY MB60PD REPLACING 'MBMAPXX' BY 'MBIB04 '
074800                           MBMAPXXI BY MBIB04I
074900                           MBMAPXXO BY MBIB04O.
075000/         FORMAT MESSAGE LINE BUILDER
075100     COPY MB06PD.
075200/         ON-LINE PROCEDURES
075300     COPY MB70PD.
075400/
075500     COPY SMFTPXO.
