000100 IDENTIFICATION DIVISION.
000200 PROGRAM-ID. MBOIB05.
000201*       RELEASE DATE=08/24/01.        REVISION LEVEL=08.06      *
000202*****************************************************************
000203*WARNING.  THIS COMPUTER PROGRAM IS PROTECTED BY COPYRIGHT LAW  *
000204*AND INTERNATIONAL TREATIES.  UNAUTHORIZED REPRODUCTION OR      *
000205*DISTRIBUTION OF THIS PROGRAM, OR ANY PORTION OF IT, MAY RESULT *
000206*IN SEVERE CIVIL AND CRIMINAL PENATLIES, AND WILL BE PROSECUTED *
000207*TO THE MAXIMUM EXTENT POSSIBLE UNDER THE LAW.                  *
000208*COPYRIGHT 1999 PAYSYS INTERNATIONAL, INC.  ALL RIGHTS RESERVED.*
000209*****************************************************************
000300*****************************************************************
000400*                                                               *
000500*   V - PLUS  M E R C H A N T   B A N K C A R D   S Y S T E M   *
000600*                                                               *
000700*      MBOIB05 - ON-LINE INVENTORY DIRECTORY                    *
000800*                SCREEN 05                                      *
000900*                                                               *
001000*              1. TRANSIDS                                      *
001100*                 A. MBIB                                       *
001200*              2. MAPS USED -                                   *
001300*                 A. MBIB05 (SCREEN 05)                         *
001400*              3. FILES USED -                                  *
001500*                 A. MMD3   (DEPOSIT BATCH D3)                  *
001600*                 B. MMD4   (DEPOSIT BATCH D4)                  *
001700*                                                               *
001800*****************************************************************
001900*
002000 ENVIRONMENT DIVISION.
002100 DATA DIVISION.
002200 WORKING-STORAGE SECTION.
002300 01  FILLER                  PIC  X(12)      VALUE '** WS-BEG **'.
002400*         I/O REQUEST BLOCK WORK AREAS
002500     COPY MBIOWS.
002600/         I/O REQUEST BLOCK
002700     COPY MBIORO.
002800/         DEPOSIT BATCH MASTER RECORD LAYOUT WORK FILE 3
002900     COPY MMD3RL REPLACING ==:MMD3:== BY ==MWD3==.
003000/         DATE WORK AREAS
003100     COPY SS01WS.
003200/         ONLINE WORK AREAS
003300     COPY SS08WS.
003400/
003500     COPY SS00WS.
003600/
003700     COPY SMFTWS.
003800/
003900     COPY SMPTRL REPLACING ==:SMPT:== BY ==SMPT==.
004000/
004100     COPY MB61LK.
004200/
004300 01  WS-MISCELLANEOUS.
004400     03  WS-SAVE-EIBAID      PIC  X(01)      VALUE SPACES.
004500     03  WS-READ-FILE-MMD4   PIC  X(01)      VALUE 'N'.
004600         88  WS-READ-FILE4                   VALUE 'Y'.
004700         88  WS-DO-NOT-READ-FILE4            VALUE 'N'.
004800     03  WS-SETT-FLAG-X.
004900         05  WS-SETT-FLAG    PIC  X(01).
005000         05  WS-SETT-ACCT    PIC  9(01).
005100*
005200     COPY MTPTIR REPLACING ==:MTPT:== BY ==MTPT==.
005300*
005400     COPY MB00WS.
005500*
005600     COPY SS95WS.
005700*
005800 01  FILLER                  PIC  X(12)      VALUE '** WS-END **'.
005900/
006000 LINKAGE SECTION.
006100 01  DFHCOMMAREA.
006200     COPY MB60WS.
006300/         INVENTORY DIRECTORY SCREEN 01 MAP DSECT
006400     COPY MBIB05.
006500/         INVENTORY DIRECTORY SCREEN 01 MAP REDEFINITION
006600     COPY MBIB05R.
006700/         DEPOSIT BATCH MASTER RECORD LAYOUT FILE 3
006800     COPY MMD3RL REPLACING ==:MMD3:== BY ==MMD3==.
006900/         DEPOSIT BATCH MASTER RECORD LAYOUT FILE 4
007000     COPY MMD3RL REPLACING ==:MMD3:== BY ==MMD4==.
007100/
007200 PROCEDURE DIVISION.
007300 0000-HOUSEKEEPING SECTION.
007400 0100-INIT.
007500*
007600     MOVE 'PC01'                 TO MBCA-PROGRAM-LOCATION.
007700     PERFORM MB70PD-ON-LINE-HOUSEKEEPING
007800                                 THRU MB70PD-OLH-EXIT.
007900*
008000     SET SS95WS-FUNCTION-INITIALIZE
008100                           TO TRUE.
008200     PERFORM SS95PD-NAP-ROUTINE
008300       THRU SS95PD-NAP-EXIT.
008400*
008500     MOVE MBCA-CURRENCY-CODE     TO SS95WS-CURRENCY-CODE.
008600*
008700     IF  MBCA-RECEIVE-SCREEN
008800         GO TO 2000-RECEIVE-SCREEN.
008900*
009000 1000-SEND-SCREEN SECTION.
009100*
009200****************************************************************
009300*    GET CICS STORAGE NEEDED FOR THE MAP                       *
009400****************************************************************
009500*
009600     MOVE 'SC01'                 TO MBCA-PROGRAM-LOCATION.
009700     PERFORM MB60PD-GETMAIN-FOR-MAP
009800                                 THRU MB60PD-GFM-EXIT.
009900*
010000*******************************************
010100*    READ THE DEPOSIT BATCH RECORD HEADER *
010200*    TO DISPLAY HEADER INFORMATION        *
010300*******************************************
010400*
010500     MOVE MBCA-MBIB-HDR-KEY      TO MBIOWS-MMD3-KEY.
010600     MOVE ZEROS                  TO MBIOWS-MMD3-BATCH-SEQ.
010700     MOVE 'FC01'                 TO MBCA-PROGRAM-LOCATION.
010800     SET MBIORO-READ-RANDOM      TO TRUE.
010900     MOVE SS08WS-CICS-FC-NOTFND  TO MBIORO-TEMP-STATUS-1.
011000     PERFORM MMD3AO-ACCESS       THRU MMD3AO-ACCESS-EXIT.
011100*
011200     IF  SS08WS-RC-FC-NOTFND
011300         MOVE MBCA-MBIB-HDR-KEY  TO MBIOWS-MMD4-KEY
011400         MOVE ZEROS              TO MBIOWS-MMD4-BATCH-SEQ
011500         MOVE 'FC02'             TO MBCA-PROGRAM-LOCATION
011600         SET MBIORO-READ-RANDOM  TO TRUE
011700         PERFORM MMD4AO-ACCESS   THRU MMD4AO-ACCESS-EXIT
011800         MOVE MMD4-RECORD        TO MWD3-RECORD
011900     ELSE
012000         MOVE MMD3-RECORD        TO MWD3-RECORD.
012100*
012200     MOVE MWD3-ORG               TO IB05-ORG.
012300*
012400     MOVE SPACES                 TO SS01WS-EDIT-X.
012500     MOVE MWD3-BATCH-DATE        TO SS01WS-JULIAN
012600     PERFORM SS26PD-NUMERICALLY-EDIT-DATE
012700        THRU SS26PD-NED-EXIT.
012800     MOVE SS01WS-XX-XX-YYYY      TO IB05-BATCH-DATE.
012900*
013000     MOVE MWD3-BATCH-NBR         TO IB05-BATCH-NBR.
013100     MOVE MWD3-BATCH-SOURCE      TO IB05-BATCH-SOURCE.
013200     MOVE MWD3-MERCHANT          TO IB05-MERCHANT.
013300*
013400     MOVE SPACES                 TO SS01WS-EDIT-X.
013500     MOVE MWD3-REF-BATCH-DATE    TO SS01WS-JULIAN
013600     PERFORM SS26PD-NUMERICALLY-EDIT-DATE
013700        THRU SS26PD-NED-EXIT.
013800     MOVE SS01WS-XX-XX-YYYY      TO IB05-REF-DATE.
013900*
014000     MOVE MWD3-REF-BATCH-NBR     TO IB05-REF-NBR.
014100     MOVE MWD3-REF-BATCH-SOURCE  TO IB05-REF-SOURCE.
014200     MOVE MWD3-STORE             TO IB05-STORE.
014300*
014400     MOVE SPACES                 TO SS01WS-EDIT-X.
014500     MOVE MWD3-POST-DATE         TO SS01WS-JULIAN
014600     PERFORM SS26PD-NUMERICALLY-EDIT-DATE
014700        THRU SS26PD-NED-EXIT.
014800     MOVE SS01WS-XX-XX-YYYY      TO IB05-HDR-POST-DATE
014900*
015000     MOVE MWD3-REJECT-REENTRY-FLAG
015100                                 TO IB05-REJ-REENTRY.
015200     MOVE MWD3-SETT-FLAG         TO WS-SETT-FLAG.
015300     MOVE MWD3-SETT-ACCT         TO WS-SETT-ACCT.
015400     MOVE WS-SETT-FLAG-X         TO IB05-SETT-FLAG.
015500     MOVE MWD3-STMT-FLAG         TO IB05-STMT-FLAG.
015600     MOVE MWD3-DESC              TO IB05-ORG-NAME.
015700     MOVE MWD3-NBR-ITEMS         TO IB05-HDR-NBR-ITEMS.
015800*
015900     IF  MWD3-TF-DEBIT
016000         COMPUTE MWD3-AMOUNT = 0 - MWD3-AMOUNT.
016100*
016200     MOVE MWD3-AMOUNT            TO SS95WS-IN-AMT.
016300     PERFORM SS95PD-NAP-ROUTINE
016400                                 THRU SS95PD-NAP-EXIT.
016500     MOVE SS95WS-OUT-AMT-L23     TO IB05-HDR-AMOUNT.
016600*
016700     MOVE MWD3-TRANS-CODE        TO IB05-TRANS-CODE.
016800     MOVE MWD3-TRANS-FLAG        TO IB05-TRANS-FLAG.
016900     MOVE MWD3-LOGIC-MODULE      TO IB05-LOGIC-MODULE.
017000     MOVE MWD3-PRODUCT           TO IB05-CARD-PRODUCT.
017100     MOVE MWD3-PLAN              TO IB05-PLAN.
017200     MOVE MWD3-QUAL-LEVEL        TO IB05-QUAL-LEVEL.
017300     MOVE MWD3-RPT-DESC          TO IB05-RPT-DESC.
017400     EVALUATE TRUE
017500         WHEN MWD3-QI-INTRACHANGE-DIFF
017600             MOVE 'INTRACHANGE'  TO IB05-QUAL-IND
017700         WHEN MWD3-QI-INTRACHANGE-ONUS
017800             MOVE 'ON US'        TO IB05-QUAL-IND
017900         WHEN MWD3-QI-DOMESTIC-NORMAL
018000             MOVE 'DOMESTIC'     TO IB05-QUAL-IND
018100         WHEN MWD3-QI-INTERNATIONAL-NORMAL
018200             MOVE 'INTERNATIONL' TO IB05-QUAL-IND
018300         WHEN OTHER
018400             MOVE MWD3-QUAL-INDICATOR
018500                                 TO IB05-QUAL-IND
018600     END-EVALUATE.
018700     MOVE MWD3-NBR-ITEMS         TO IB05-NBR-ITEMS.
018800     MOVE MWD3-ORIG-GL-SOURCE    TO IB05-GL-SOURCE.
018900*
019000     IF  MWD3-TF-DEBIT
019100         COMPUTE MWD3-AMOUNT = 0 - MWD3-AMOUNT.
019200*
019300     MOVE MWD3-AMOUNT            TO SS95WS-IN-AMT.
019400     PERFORM SS95PD-NAP-ROUTINE
019500                                 THRU SS95PD-NAP-EXIT.
019600     MOVE SS95WS-OUT-AMT-L23     TO IB05-TRAN-AMOUNT
019700*
019800     IF  NOT MWD3-VDI-HEADER-DATA
019900         MOVE MTPTIR-HEADER-DATA-INIT
020000                                 TO MWD3-VARIABLE-DATA.
020100*
020200     MOVE MWD3-SALES-AMT         TO SS95WS-IN-AMT.
020300     MOVE MWD3-SALES-NBR         TO SS95WS-IN-NBR.
020400     PERFORM SS95PD-NAP-ROUTINE
020500                                 THRU SS95PD-NAP-EXIT.
020600     MOVE SS95WS-OUT-AMT-L23     TO IB05-REF-SALES-AMT.
020700     MOVE SS95WS-OUT-NBR-L09     TO IB05-REF-SALES-NBR.
020800*
020900     MOVE MWD3-SALES-REV-AMT     TO SS95WS-IN-AMT.
021000     MOVE MWD3-SALES-REV-NBR     TO SS95WS-IN-NBR.
021100     PERFORM SS95PD-NAP-ROUTINE
021200                                 THRU SS95PD-NAP-EXIT.
021300     MOVE SS95WS-OUT-AMT-L23     TO IB05-REF-SALES-REV-AMT.
021400     MOVE SS95WS-OUT-NBR-L09     TO IB05-REF-SALES-REV-NBR.
021500*
021600     MOVE MWD3-RETURNS-AMT       TO SS95WS-IN-AMT.
021700     MOVE MWD3-RETURNS-NBR       TO SS95WS-IN-NBR.
021800     PERFORM SS95PD-NAP-ROUTINE
021900                                 THRU SS95PD-NAP-EXIT.
022000     MOVE SS95WS-OUT-AMT-L23     TO IB05-REF-RETURN-AMT.
022100     MOVE SS95WS-OUT-NBR-L09     TO IB05-REF-RETURN-NBR.
022200*
022300     MOVE MWD3-RETURNS-REV-AMT   TO SS95WS-IN-AMT.
022400     MOVE MWD3-RETURNS-REV-NBR   TO SS95WS-IN-NBR.
022500     PERFORM SS95PD-NAP-ROUTINE
022600                                 THRU SS95PD-NAP-EXIT.
022700     MOVE SS95WS-OUT-AMT-L23     TO IB05-REF-RETURN-REV-AMT.
022800     MOVE SS95WS-OUT-NBR-L09     TO IB05-REF-RETURN-REV-NBR.
022900*
023000     MOVE MWD3-MEMO-AMT          TO SS95WS-IN-AMT.
023100     MOVE MWD3-MEMO-NBR          TO SS95WS-IN-NBR.
023200     PERFORM SS95PD-NAP-ROUTINE
023300                                 THRU SS95PD-NAP-EXIT.
023400     MOVE SS95WS-OUT-AMT-L23     TO IB05-REF-MEMO-AMT.
023500     MOVE SS95WS-OUT-NBR-L09     TO IB05-REF-MEMO-NBR.
023600*
023700     MOVE 05                     TO MBCA-SCREEN-NBR.
023800*
023900****************************************************************
024000*    INITIALIZE THE STANDARD MAP LINES                         *
024100****************************************************************
024200*
024300     PERFORM MB60PD-INIT-STD-MAP-LINES
024400                                 THRU MB60PD-ISML-EXIT.
024500*
024600     MOVE SS08WS-CURSOR          TO IB05-ALT-TRANID-L.
024700*
024800 1100-SEND-MAP.
024900*
025000**************************************************************
025100*    SET THE CURRENCY CODE, CURRENCY NOD                     *
025200*            PER ITEM NOD, PERCENT NOD.                      *
025300**************************************************************
025400     IF IB05-ERR-MESSAGE IS EQUAL TO SPACES OR LOW-VALUES
025500        PERFORM MB06PD-FORMAT-MESSAGE-LINE
025600                                 THRU MB06PD-FML-EXIT
025700        MOVE SS08WS-FORMATTED-MSG   TO IB05-ERR-MESSAGE
025800     END-IF.
025900*
026000****************************************************************
026100*    SEND THE MAP                                              *
026200****************************************************************
026300*
026400     MOVE 'BM01'                 TO MBCA-PROGRAM-LOCATION.
026500     PERFORM MB60PD-SEND-MAP-WITH-ERASE
026600                                 THRU MB60PD-SMWE-EXIT.
026700*
026800****************************************************************
026900*    RETURN TO CICS                                            *
027000****************************************************************
027100*
027200     MOVE 'PC02'                 TO MBCA-PROGRAM-LOCATION.
027300     PERFORM MB70PD-RETURN-TRANS-ID
027400                                 THRU MB70PD-RTI-EXIT.
027500/
027600 2000-RECEIVE-SCREEN SECTION.
027700*
027800****************************************************************
027900*    THIS SECTION RECEIVES THE 01 SCREEN                       *
028000****************************************************************
028100*
028200     MOVE 'BM02'                 TO MBCA-PROGRAM-LOCATION.
028300     PERFORM MB60PD-RECEIVE-MAP  THRU MB60PD-RM-EXIT.
028400*
028500****************************************************************
028600*    CHECK FOR ANOTHER TRANSACTION ID ENTERED BY THE USER      *
028700****************************************************************
028800*
028900     MOVE 'PC03'                 TO MBCA-PROGRAM-LOCATION.
029000     PERFORM MB60PD-NEW-TRANS-ROUTINE
029100                                 THRU MB60PD-NTR-EXIT.
029200/
029300 2600-SETUP-COMMAREA.
029400*
029500****************************************************************
029600*    SET UP COMMAREA FIELDS AND TRANSFER TO THE NEXT PROGRAM   *
029700****************************************************************
029800*
029900     MOVE MBCA-EIBAID            TO SS08WS-EIBAID.
030000*
030100     IF  IB05-CURRENT-PAGE-L IS GREATER THAN ZERO
030200     AND IB05-CURRENT-PAGE   IS NUMERIC
030300         IF  IB05-CURRENT-PAGE IS EQUAL TO 4
030400             MOVE 55             TO MBCA-SCREEN-NBR
030500             GO TO 2690-PF-KEY-BYPASS
030600         ELSE
030700             IF  IB05-CURRENT-PAGE IS EQUAL TO 1
030800                 SET MBCA-MBIB-FILE3 TO TRUE
030900                 MOVE 51         TO MBCA-SCREEN-NBR
031000                 MOVE MBCA-MBIB-PAGE-1-KEY
031100                                 TO MBCA-MBIB-FWD-KEY
031200                                    MBCA-MBIB-1ST-KEY
031300                 GO TO 2690-PF-KEY-BYPASS.
031400*
031500     PERFORM MB60PD-EDIT-PAGE-NBR
031600                                 THRU MB60PD-EPN-EXIT.
031700*
031800     IF  SS08WS-VALID-PF-KEY
031900     OR  SS08WS-EIBAID-VALID-PF-KEY
032000         SET MBCA-INITIAL-SCREEN-NBR
032100                                 TO TRUE.
032200*
032300*
032400 2690-PF-KEY-BYPASS.
032500*
032600     MOVE 'PC04'                 TO MBCA-PROGRAM-LOCATION.
032700     PERFORM MB70PD-XCTL-TO-MBOXCTL
032800                                 THRU MB70PD-XTM-EXIT.
032900*
033000/         JULIAN TO GREGORIAN DATE ROUTINE
033100     COPY SS08PD.
033200/
033300     COPY SS26PD.
033400/
033500     COPY SS27PD.
033600/         LINE 24 PF KEYS ROUTINE
033700     COPY SS15PD.
033800/         DEPOSIT BATCH D3 RECORD ACCESS ROUTINES
033900     COPY MMD3AO.
034000/         DEPOSIT BATCH D4 RECORD ACCESS ROUTINES
034100     COPY MMD4AO.
034200/         FORMAT NBR AND AMOUNTS BY CURRENCY CODE
034300     COPY SS95PDO REPLACING ==:XXCA:== BY ==MBCA==.
034400/         ON-LINE MAP ROUTINES
034500     COPY MB60PD REPLACING 'MBMAPXX' BY 'MBIB05 '
034600                           MBMAPXXI BY MBIB05I
034700                           MBMAPXXO BY MBIB05O.
034800/         FORMAT MESSAGE LINE BUILDER
034900     COPY MB06PD.
035000/         ON-LINE PROCEDURES
035100     COPY MB70PD.
035200/
035300     COPY SMFTPXO.
