000100 IDENTIFICATION DIVISION.
000200 PROGRAM-ID. MBOIC01.
000201*       RELEASE DATE=08/24/01.        REVISION LEVEL=08.06      *
000202*****************************************************************
000203*WARNING.  THIS COMPUTER PROGRAM IS PROTECTED BY COPYRIGHT LAW  *
000204*AND INTERNATIONAL TREATIES.  UNAUTHORIZED REPRODUCTION OR      *
000205*DISTRIBUTION OF THIS PROGRAM, OR ANY PORTION OF IT, MAY RESULT *
000206*IN SEVERE CIVIL AND CRIMINAL PENATLIES, AND WILL BE PROSECUTED *
000207*TO THE MAXIMUM EXTENT POSSIBLE UNDER THE LAW.                  *
000208*COPYRIGHT 1999 PAYSYS INTERNATIONAL, INC.  ALL RIGHTS RESERVED.*
000209*****************************************************************
000300*****************************************************************
000400*                                                               *
000500*   V - PLUS  M E R C H A N T   B A N K C A R D   S Y S T E M   *
000600*                                                               *
000700*      MBOIC01 - CAHIN SUMMARY INQUIRY                          *
000800*                SCREEN 01                                      *
000900*                                                               *
001000*              1. TRANSID                                       *
001100*                 B. MBIC                                       *
001200*              2. MAPS USED -                                   *
001300*                 A. MBIC01 (SCREEN 01)                         *
001400*              3. FILES USED -                                  *
001500*                 A. MMRC (RELATIONSHIP CONTROL FILE)           *
001600*                 B. MMRD (RELATIONSHIP DETAIL)                 *
001700*                                                               *
001800*****************************************************************
001900*
002000 ENVIRONMENT DIVISION.
002100*
002200 DATA DIVISION.
002300*
002400 WORKING-STORAGE SECTION.
002500*
002600 01  FILLER                  PIC  X(12)      VALUE '** WS-BEG **'.
002700*
002800 01  FILLER                  PIC  X(14)      VALUE
002900     'MISCELLANEOUS:'.
003000*
003100 01  WS-MISCELLANEOUS.
003200     03  WS-FIELD-POSITION   PIC S9(03)      VALUE ZEROES COMP-3.
003300     03  WS-NBR-MERCH        PIC S9(09)      VALUE ZEROES COMP-3.
003400*
003500 01  FILLER                  PIC  X(17)      VALUE
003600     'PROGRAM SWITCHES:'.
003700*
003800/
003900 01  FILLER                  PIC  X(29)      VALUE
004000     'I/O REQUEST BLOCK WORK AREAS:'.
004100*
004200     COPY MBIOWS.
004300/
004400 01  FILLER                  PIC  X(18)      VALUE
004500     'I/O REQUEST BLOCK:'.
004600*
004700     COPY MBIORO.
004800/
004900 01  FILLER                  PIC  X(20)      VALUE
005000     'CCS DATE WORK AREAS:'.
005100*
005200     COPY SS01WS.
005300/
005400 01  FILLER                  PIC  X(15)      VALUE
005500     'CCS WORK AREAS:'.
005600*
005700     COPY SS08WS.
005800/
005900     COPY SS00WS.
006000/
006100     COPY SMFTWS.
006200/
006300     COPY SMPTRL REPLACING ==:SMPT:== BY ==SMPT==.
006400/
006500     COPY MB61LK.
006600/
006700     COPY SS12WS.
006800/
006900 01  FILLER                  PIC  X(28)      VALUE
007000     'DYNAMICALY CALLED SUBROUINES'.
007100*
007200     COPY MB00WS.
007300/
007400 01  FILLER                  PIC  X(36)      VALUE
007500     'FORMAT NBR AND AMTS BY CURRENCY CODE'.
007600*
007700     COPY SS95WS.
007800*
007900 01  FILLER                  PIC  X(12)      VALUE '** WS-END **'.
008000/
008100 LINKAGE SECTION.
008200*
008300 01  DFHCOMMAREA.
008400*
008500     COPY MB60WS.
008600/
008700*********************************
008800*    CHAIN SUMMARY MAP          *
008900*********************************
009000*
009100     COPY MBIC01.
009200/
009300**********************************************
009400*    CHAIN SUMMARY MAP REDEFINITION          *
009500**********************************************
009600*
009700     COPY MBIC01R.
009800/
009900******************************************
010000*    CHAIN CONTROL RECORD LAYOUT         *
010100******************************************
010200*
010300     COPY MMRCRL.
010400/
010500******************************************
010600*    CHAIN DETAIL RECORD LAYOUT          *
010700******************************************
010800*
010900     COPY MMRDRL REPLACING ==:MMRD:== BY ==MMRD==.
011000/
011100 PROCEDURE DIVISION.
011200*
011300 A000-HOUSEKEEPING SECTION.
011400*
011500 A020-INIT.
011600*
011700     MOVE 'PC01'                 TO MBCA-PROGRAM-LOCATION.
011800     PERFORM MB70PD-ON-LINE-HOUSEKEEPING
011900                                 THRU MB70PD-OLH-EXIT.
012000*
012100     SET SS12WS-ENVIRONMENT-ON-LINE
012200                                 TO TRUE.
012300     SET SS12WS-FUNCTION-INITIALIZE
012400                                 TO TRUE.
012500     PERFORM SS12PD-FORMAT-DEMOGRAPHICS
012600        THRU SS12PD-FD-EXIT.
012700*
012800     SET SS95WS-FUNCTION-INITIALIZE
012900                           TO TRUE.
013000     PERFORM SS95PD-NAP-ROUTINE
013100        THRU SS95PD-NAP-EXIT.
013200     MOVE MBCA-CURRENCY-CODE     TO SS95WS-CURRENCY-CODE.
013300*
013400     IF  MBCA-RECEIVE-SCREEN
013500         GO TO C000-RECEIVE-SCREEN.
013600/
013700 B000-SEND-SCREEN SECTION.
013800*
013900*********************************************
014000*    GET CICS STORAGE NEEDED FOR THE MAP    *
014100*********************************************
014200*
014300     MOVE 'SC01'                 TO MBCA-PROGRAM-LOCATION.
014400     PERFORM MB60PD-GETMAIN-FOR-MAP
014500                                 THRU MB60PD-GFM-EXIT.
014600*
014700*******************************************
014800*    INITIALIZE THE STANDARD MAP LINES    *
014900*******************************************
015000*
015100     PERFORM MB60PD-INIT-STD-MAP-LINES
015200                                 THRU MB60PD-ISML-EXIT.
015300*
015400**********************************************************
015500*    READ THE CHAIN CONTROL RECORD FOR SUBSEQUENT        *
015600*    DISPLAY.                                            *
015700**********************************************************
015800*
015900     MOVE MBCA-MERCHANT-ORG      TO MBIOWS-MMRC-ORG.
016000     MOVE MBCA-CHAIN             TO MBIOWS-MMRC-CHAIN.
016100     MOVE 'FC01'                 TO MBCA-PROGRAM-LOCATION.
016200     SET MBIORO-READ-RANDOM      TO TRUE.
016300     PERFORM MMRCAO-ACCESS       THRU MMRCAO-ACCESS-EXIT.
016400*
016500 B020-MOVE-FIELDS-TO-SCREEN.
016600*
016700*********************************************
016800*    MOVE THE CHAIN CONTROL MASTER FIELDS   *
016900*    FROM THE RECORD TO THE SCREEN          *
017000*********************************************
017100*
017200     MOVE MMRC-ORG               TO IC01-ORG.
017300     MOVE MMRC-CHAIN             TO IC01-CHAIN.
017400     MOVE SPACES                 TO SS12WS-NAME-ADDR-GROUP.
017500     SET X-MMRC-NA               TO +1.
017600     MOVE MMRC-NA-LINE (X-MMRC-NA)
017700                                 TO SS12WS-NAME-ADDR (1).
017800     SET X-MMRC-NA               TO +2.
017900     MOVE MMRC-NA-LINE (X-MMRC-NA)
018000                                 TO SS12WS-NAME-ADDR (2).
018100     SET X-MMRC-NA               TO +3.
018200     MOVE MMRC-NA-LINE (X-MMRC-NA)
018300                                 TO SS12WS-NAME-ADDR (3).
018400     SET X-MMRC-NA               TO +4.
018500     MOVE MMRC-NA-LINE (X-MMRC-NA)
018600                                 TO SS12WS-NAME-ADDR (4).
018700     SET X-MMRC-NA               TO +5.
018800     MOVE MMRC-NA-LINE (X-MMRC-NA)
018900                                 TO SS12WS-NAME-ADDR (5).
019000     MOVE MMRC-POSTAL-CODE       TO SS12WS-POSTAL-CODE.
019100     MOVE MMRC-STATE-CODE        TO SS12WS-STATE-CODE.
019200     MOVE MMRC-COUNTRY-CODE      TO SS12WS-COUNTRY-CODE.
019300*
019400     PERFORM SS12PD-FORMAT-DEMOGRAPHICS
019500                                 THRU SS12PD-FD-EXIT.
019600*
019700     MOVE SS12WS-MAIL-LINE (1)
019800                                 TO IC01-CHAIN-NAME.
019900     MOVE SS12WS-MAIL-LINE (2)
020000                                 TO IC01-ADDR1.
020100     MOVE SS12WS-MAIL-LINE (3)
020200                                 TO IC01-ADDR2.
020300     MOVE SS12WS-MAIL-LINE (4)
020400                                 TO IC01-ADDR3.
020500     MOVE SS12WS-MAIL-LINE (5)
020600                                 TO IC01-ADDR4.
020700*
020800     MOVE MMRC-PHONE             TO IC01-PHONE-NBR.
020900     MOVE MMRC-FAX               TO IC01-FAX-NBR.
021000     MOVE MMRC-STMT-OPTION       TO IC01-STATEMENT.
021100     MOVE MMRC-STMT-FREQ-1       TO IC01-STMT-FREQ1.
021200     MOVE MMRC-STMT-FREQ-2       TO IC01-STMT-FREQ2.
021300     MOVE MMRC-DATE-LAST-STMT    TO SS01WS-JULIAN.
021400     PERFORM SS26PD-NUMERICALLY-EDIT-DATE
021500        THRU SS26PD-NED-EXIT.
021600     MOVE SS01WS-XX-XX-YYYY      TO IC01-LAST-STMT-DATE.
021700     MOVE MMRC-STMT-FLAG         TO IC01-STMT-PRINT.
021800*
021900     PERFORM F100-START-DETAIL-FILE
022000                                 THRU F199-SDF-EXIT.
022100*
022200     MOVE WS-NBR-MERCH           TO SS95WS-IN-NBR.
022300     PERFORM SS95PD-NAP-ROUTINE
022400                                 THRU SS95PD-NAP-EXIT.
022500     MOVE SS95WS-OUT-NBR-L12     TO IC01-NBR-OF-MERCH.
022600*
022700     MOVE SS08WS-CURSOR          TO IC01-ALT-TRANID-L.
022800     COMPUTE MBCA-SCREEN-NBR     =  MBCA-SCREEN-NBR - 50.
022900*
023000**********************
023100*    SEND THE MAP    *
023200**********************
023300*
023400     MOVE 'BM01'                 TO MBCA-PROGRAM-LOCATION.
023500     PERFORM MB60PD-SEND-MAP-WITH-ERASE
023600                                 THRU MB60PD-SMWE-EXIT.
023700*
023800************************
023900*    RETURN TO CICS    *
024000************************
024100*
024200     MOVE 'PC02'                 TO MBCA-PROGRAM-LOCATION.
024300     PERFORM MB70PD-RETURN-TRANS-ID
024400                                 THRU MB70PD-RTI-EXIT.
024500/
024600 C000-RECEIVE-SCREEN SECTION.
024700*
024800******************************************
024900*    THIS SECTION RECEIVES THE SCREEN    *
025000******************************************
025100*
025200     MOVE 'BM02'                 TO MBCA-PROGRAM-LOCATION.
025300     PERFORM MB60PD-RECEIVE-MAP  THRU MB60PD-RM-EXIT.
025400*
025500**************************************************************
025600*    CHECK FOR ANOTHER TRANSACTION ID ENTERED BY THE USER    *
025700**************************************************************
025800*
025900     MOVE 'PC03'                 TO MBCA-PROGRAM-LOCATION.
026000     PERFORM MB60PD-NEW-TRANS-ROUTINE
026100                                 THRU MB60PD-NTR-EXIT.
026200/
026300 F000-SETUP-COMMAREA SECTION.
026400*
026500***************************************************************
026600*  SET UP COMMAREA FIELDS AND TRANSFER TO THE NEXT PROGRAM    *
026700***************************************************************
026800*
026900     MOVE MBCA-EIBAID            TO SS08WS-EIBAID.
027000*
027100     PERFORM MB60PD-EDIT-PAGE-NBR
027200                                 THRU MB60PD-EPN-EXIT.
027300*
027400     IF  SS08WS-VALID-PF-KEY
027500     OR  SS08WS-EIBAID-VALID-PF-KEY
027600         SET MBCA-INITIAL-SCREEN-NBR
027700                                 TO TRUE.
027800*
027900 F090-TRANSFER-XCTL.
028000*
028100     MOVE 'PC04'                 TO MBCA-PROGRAM-LOCATION.
028200     PERFORM MB70PD-XCTL-TO-MBOXCTL
028300                                 THRU MB70PD-XTM-EXIT.
028400*
028500 F100-START-DETAIL-FILE.
028600*
028700****************************************************************
028800*    START BROWSE THE CHAIN DETAIL FILE                        *
028900****************************************************************
029000*
029100     MOVE 'FC02'                 TO MBCA-PROGRAM-LOCATION.
029200     MOVE MBCA-MERCHANT-ORG      TO MBIOWS-MMRD-ORG.
029300     MOVE MBCA-CHAIN             TO MBIOWS-MMRD-CHAIN.
029400     MOVE ZEROS                  TO MBIOWS-MMRD-SEQ-NBR.
029500     SET MBIORO-STARTBR-GTE      TO TRUE.
029600     PERFORM MMRDAO-ACCESS       THRU MMRDAO-ACCESS-EXIT.
029700*
029800 F100-READ-LOOP.
029900*
030000****************************************************************
030100*    READNEXT THE CHAIN DEATAIL FILE                          *
030200****************************************************************
030300*
030400     MOVE 'FC03'                 TO MBCA-PROGRAM-LOCATION.
030500     SET MBIORO-READ-SEQ         TO TRUE.
030600     PERFORM MMRDAO-ACCESS       THRU MMRDAO-ACCESS-EXIT.
030700*
030800     IF  MMRD-ORG-CHAIN IS GREATER THAN MBCA-MBIC-ORG-CHAIN
030900         GO TO F100-END-BROWSE.
031000*
031100     IF  NOT MMRD-REC-ACTIVE
031200         GO TO F100-READ-LOOP.
031300*
031400     COMPUTE WS-NBR-MERCH = WS-NBR-MERCH + MMRD-NBR-OF-MEMBERS.
031500*
031600     GO TO F100-READ-LOOP.
031700*
031800 F100-END-BROWSE.
031900*
032000****************************************************************
032100*    END BROWSE THE CHAIN DETAIL FILE                          *
032200****************************************************************
032300*
032400     MOVE 'FC04'                 TO MBCA-PROGRAM-LOCATION.
032500     SET MBIORO-ENDBR            TO TRUE.
032600     PERFORM MMRDAO-ACCESS       THRU MMRDAO-ACCESS-EXIT.
032700*
032800 F199-SDF-EXIT.
032900     EXIT.
033000*
033100*
033200/
033300 Z000-COPIED-ROUTINES SECTION.
033400*
033500**********************************
033600*    JUL TO GREG DATE ROUTINE    *
033700**********************************
033800*
033900     COPY SS08PD.
034000/
034100     COPY SS26PD.
034200/
034300     COPY SS27PD.
034400/
034500**********************************
034600*    GREG TO JUL DATE ROUTINE    *
034700**********************************
034800*
034900     COPY SS07PD.
035000/
035100**********************************
035200*    DATE VALIDATION ROUTINE     *
035300**********************************
035400*
035500     COPY SS05PD.
035600/
035700******************************************
035800*    FORMAT NAME/ADDR DEMOGRAPHICS       *
035900******************************************
036000     COPY SS12PD.
036100/
036200*********************************
036300*    LINE 24 PF KEYS ROUTINE    *
036400*********************************
036500*
036600     COPY SS15PD.
036700/
036800**************************************************
036900*    CHAIN CONTROL MASTER RECORD ACCESS ROUTINES *
037000**************************************************
037100*
037200     COPY MMRCAO.
037300/
037400**************************************************
037500*    CHAIN DEATAIL MASTER RECORD ACCESS ROUTINES *
037600**************************************************
037700*
037800     COPY MMRDAO.
037900/
038000***************************************************
038100*    FORMAT NBR AND AMOUNTS BY CURRENCY CODE      *
038200***************************************************
038300*
038400     COPY SS95PDO REPLACING ==:XXCA:== BY ==MBCA==.
038500/
038600*****************************
038700*    ONLINE MAP ROUTINES    *
038800*****************************
038900*
039000     COPY MB60PD REPLACING 'MBMAPXX' BY 'MBIC01 '
039100                           MBMAPXXI BY MBIC01I
039200                           MBMAPXXO BY MBIC01O.
039300/
039400***************************
039500*    ONLINE PROCEDURES    *
039600***************************
039700*
039800     COPY MB70PD.
039900/
040000     COPY SMFTPXO.
