000100 IDENTIFICATION DIVISION.
000200 PROGRAM-ID. MBOIC04.
000201*       RELEASE DATE=08/24/01.        REVISION LEVEL=08.06      *
000202*****************************************************************
000203*WARNING.  THIS COMPUTER PROGRAM IS PROTECTED BY COPYRIGHT LAW  *
000204*AND INTERNATIONAL TREATIES.  UNAUTHORIZED REPRODUCTION OR      *
000205*DISTRIBUTION OF THIS PROGRAM, OR ANY PORTION OF IT, MAY RESULT *
000206*IN SEVERE CIVIL AND CRIMINAL PENATLIES, AND WILL BE PROSECUTED *
000207*TO THE MAXIMUM EXTENT POSSIBLE UNDER THE LAW.                  *
000208*COPYRIGHT 1999 PAYSYS INTERNATIONAL, INC.  ALL RIGHTS RESERVED.*
000209*****************************************************************
000300*****************************************************************
000400*                                                               *
000500*   V - PLUS  M E R C H A N T   B A N K C A R D   S Y S T E M   *
000600*                                                               *
000700*      MBOIC04 - CAHIN SUMMARY INQUIRY                          *
000800*                SCREEN 04                                      *
000900*                                                               *
001000*              1. TRANSID                                       *
001100*                 B. MBIM                                       *
001200*              2. MAPS USED -                                   *
001300*                 A. MBIC04 (SCREEN 04)                         *
001400*              3. FILES USED -                                  *
001500*                 A. MMPG (PRODUCT STATISTICS FILE)             *
001600*                                                               *
001700*****************************************************************
001800*
001900 ENVIRONMENT DIVISION.
002000*
002100 DATA DIVISION.
002200*
002300 WORKING-STORAGE SECTION.
002400*
002500 01  FILLER                  PIC  X(12)      VALUE '** WS-BEG **'.
002600*
002700 01  FILLER                  PIC  X(14)      VALUE
002800     'MISCELLANEOUS:'.
002900*
003000 01  WS-MISCELLANEOUS.
003100*
003200     03  WS-TOTALS.
003300         05  WS-TOTALS-X                     OCCURS 3 TIMES
003400                                             INDEXED BY
003500                                             X-WS-TOT.
003600             07  WS-DISCOUNT
003700                             PIC S9(17)      VALUE ZEROES COMP-3.
003800             07  WS-MBS-FEES
003900                             PIC S9(17)      VALUE ZEROES COMP-3.
004000             07  WS-REFUND
004100                             PIC S9(17)      VALUE ZEROES COMP-3.
004200             07  WS-USER-FEES
004300                             PIC S9(17)      VALUE ZEROES COMP-3.
004400             07  WS-PART-EARNED
004500                             PIC S9(17)      VALUE ZEROES COMP-3.
004600             07  WS-INTCHG-FEES
004700                             PIC S9(17)      VALUE ZEROES COMP-3.
004800             07  WS-PART-OWED
004900                             PIC S9(17)      VALUE ZEROES COMP-3.
005000*
005100 01  FILLER                  PIC  X(17)      VALUE
005200     'PROGRAM SWITCHES:'.
005300*
005400 01  WS-SWITCHES.
005500     05  WS-DATA-SW          PIC  X(01)      VALUE 'N'.
005600         88  WS-NO-DATA                      VALUE 'N'.
005700         88  WS-HAVE-DATA                    VALUE 'Y'.
005800*
005900/
006000 01  FILLER                  PIC  X(29)      VALUE
006100     'I/O REQUEST BLOCK WORK AREAS:'.
006200*
006300     COPY MBIOWS.
006400/
006500 01  FILLER                  PIC  X(18)      VALUE
006600     'I/O REQUEST BLOCK:'.
006700*
006800     COPY MBIORO.
006900/
007000 01  FILLER                  PIC  X(22)      VALUE
007100     'PROD STAT LOGIC MODULE'.
007200*
007300     COPY MMTCWS.
007400/
007500 01  FILLER                  PIC  X(20)      VALUE
007600     'CCS DATE WORK AREAS:'.
007700*
007800     COPY SS01WS.
007900/
008000 01  FILLER                  PIC  X(15)      VALUE
008100     'CCS WORK AREAS:'.
008200*
008300     COPY SS08WS.
008400/
008500     COPY SS00WS.
008600/
008700     COPY SMFTWS.
008800/
008900     COPY SMPTRL REPLACING ==:SMPT:== BY ==SMPT==.
009000/
009100     COPY MB61LK.
009200/
009300 01  FILLER                  PIC  X(28)      VALUE
009400     'DYNAMICALY CALLED SUBROUINES'.
009500*
009600     COPY MB00WS.
009700/
009800 01  FILLER                  PIC  X(36)      VALUE
009900     'FORMAT NBR AND AMTS BY CURRENCY CODE'.
010000*
010100     COPY SS95WS.
010200*
010300 01  FILLER                  PIC  X(12)      VALUE '** WS-END **'.
010400/
010500 LINKAGE SECTION.
010600*
010700 01  DFHCOMMAREA.
010800*
010900     COPY MB60WS.
011000/
011100*********************************
011200*    CAHIN SUMMARY MAP          *
011300*********************************
011400*
011500     COPY MBIC04.
011600/
011700**********************************************
011800*    CAHIN SUMMARY MAP REDEFINITION          *
011900**********************************************
012000*
012100     COPY MBIC04R.
012200/
012300*********************************************
012400*    PRODUCT STATISTICS RECORD LAYOUT       *
012500*********************************************
012600*
012700     COPY MMPARL REPLACING ==:MMPA:== BY ==MMPG==.
012800/
012900 PROCEDURE DIVISION.
013000*
013100 A000-HOUSEKEEPING SECTION.
013200*
013300 A020-INIT.
013400*
013500     MOVE 'PC01'                 TO MBCA-PROGRAM-LOCATION.
013600     PERFORM MB70PD-ON-LINE-HOUSEKEEPING
013700                                 THRU MB70PD-OLH-EXIT.
013800*
013900     SET SS95WS-FUNCTION-INITIALIZE
014000                           TO TRUE.
014100     PERFORM SS95PD-NAP-ROUTINE
014200        THRU SS95PD-NAP-EXIT.
014300*
014400     MOVE MBCA-CURRENCY-CODE     TO SS95WS-CURRENCY-CODE.
014500*
014600     IF  MBCA-RECEIVE-SCREEN
014700         GO TO C000-RECEIVE-SCREEN.
014800/
014900 B000-SEND-SCREEN SECTION.
015000*
015100*********************************************
015200*    GET CICS STORAGE NEEDED FOR THE MAP    *
015300*********************************************
015400*
015500     MOVE 'SC01'                 TO MBCA-PROGRAM-LOCATION.
015600     PERFORM MB60PD-GETMAIN-FOR-MAP
015700                                 THRU MB60PD-GFM-EXIT.
015800*
015900*******************************************
016000*    INITIALIZE THE STANDARD MAP LINES    *
016100*******************************************
016200*
016300     PERFORM MB60PD-INIT-STD-MAP-LINES
016400                                 THRU MB60PD-ISML-EXIT.
016500*
016600****************************************************************
016700*    START BROWSE THE PRODUCT STATISTICE FILE                  *
016800****************************************************************
016900*
017000     MOVE 'FC01'                 TO MBCA-PROGRAM-LOCATION.
017100     MOVE MBCA-MERCHANT-ORG      TO MBIOWS-MMPG-ORG.
017200     MOVE MBCA-CHAIN             TO MBIOWS-MMPG-ACCT.
017300     MOVE 8                      TO MBIOWS-MMPG-REC-TYPE.
017400     MOVE ZERO                   TO MBIOWS-MMPG-LOGIC-MODULE.
017500     MOVE ZERO                   TO MBIOWS-MMPG-MINOR-KEY.
017600     MOVE SS08WS-CICS-FC-ENDFILE TO MBIORO-TEMP-STATUS-1.
017700     SET MBIORO-STARTBR-GTE      TO TRUE.
017800     PERFORM MMPGAO-ACCESS       THRU MMPGAO-ACCESS-EXIT.
017900*
018000     IF SS08WS-RC-FC-ENDFILE
018100         GO TO B900-SEND-MAP.
018200*
018300 B300-READ-LOOP.
018400*
018500****************************************************************
018600*    READNEXT THE MERCHANT CHAIN RELATIONSHIP FILE             *
018700****************************************************************
018800*
018900     MOVE 'FC02'                 TO MBCA-PROGRAM-LOCATION.
019000     SET MBIORO-READ-SEQ         TO TRUE.
019100     PERFORM MMPGAO-ACCESS       THRU MMPGAO-ACCESS-EXIT.
019200*
019300     IF  MMPG-TRAILER
019400     OR  MMPG-ORG-ACCT  IS GREATER THAN MBCA-MBIC-ORG-CHAIN
019500     OR  MMPG-REC-TYPE IS GREATER THAN 8
019600     OR  MMPG-PRODUCT  IS GREATER THAN ZEROS
019700         SET X-WS-TOT            TO +1
019800         SET X-IC04-RD           TO +1
019900         GO TO B600-MOVE-FIELDS-TO-SCREEN
020000     END-IF.
020100*
020200     IF  NOT MMPG-REC-ACTIVE
020300         GO TO B300-READ-LOOP.
020400*
020500     MOVE MMPG-LOGIC-MODULE      TO MMTCWS-LOGIC-MODULE.
020600*
020700****************************************************************
020800*    ACCUMULATE FIELD TOTALS                                   *
020900*    OCCURS:                                                   *
021000*          13 - TODAYS                                         *
021100*          15 - YEAR-TO-DATE                                   *
021200*          16 - CYCLE-TO-DATE                                  *
021300****************************************************************
021400*
021500     EVALUATE TRUE
021600         WHEN MMTCWS-LM-DISCOUNT
021700              SET WS-HAVE-DATA   TO TRUE
021800              ADD MMPG-AMT (13)  TO WS-DISCOUNT (1)
021900              ADD MMPG-AMT (15)  TO WS-DISCOUNT (3)
022000              ADD MMPG-AMT (16)  TO WS-DISCOUNT (2)
022100         WHEN MMTCWS-LM-SYSTEM-FEES-DR
022200              SET WS-HAVE-DATA   TO TRUE
022300              ADD MMPG-AMT (13)  TO WS-MBS-FEES (1)
022400              ADD MMPG-AMT (15)  TO WS-MBS-FEES (3)
022500              ADD MMPG-AMT (16)  TO WS-MBS-FEES (2)
022600         WHEN MMTCWS-LM-SYSTEM-FEES-CR
022700              SET WS-HAVE-DATA   TO TRUE
022800              SUBTRACT MMPG-AMT (13)
022900                                 FROM WS-MBS-FEES (1)
023000              SUBTRACT MMPG-AMT (15)
023100                                 FROM WS-MBS-FEES (3)
023200              SUBTRACT MMPG-AMT (16)
023300                                 FROM WS-MBS-FEES (2)
023400         WHEN MMTCWS-LM-REFUND
023500              SET WS-HAVE-DATA   TO TRUE
023600              ADD MMPG-AMT (13)  TO WS-REFUND (1)
023700              ADD MMPG-AMT (15)  TO WS-REFUND (3)
023800              ADD MMPG-AMT (16)  TO WS-REFUND (2)
023900         WHEN MMTCWS-LM-USER-FEES-DR
024000              SET WS-HAVE-DATA   TO TRUE
024100              ADD MMPG-AMT (13)  TO WS-USER-FEES (1)
024200              ADD MMPG-AMT (15)  TO WS-USER-FEES (3)
024300              ADD MMPG-AMT (16)  TO WS-USER-FEES (2)
024400         WHEN MMTCWS-LM-USER-FEES-CR
024500              SET WS-HAVE-DATA   TO TRUE
024600              SUBTRACT MMPG-AMT (13)
024700                                 FROM WS-USER-FEES (1)
024800              SUBTRACT MMPG-AMT (15)
024900                                 FROM WS-USER-FEES (3)
025000              SUBTRACT MMPG-AMT (16)
025100                                 FROM WS-USER-FEES (2)
025200         WHEN MMTCWS-LM-PART-CR
025300              SET WS-HAVE-DATA   TO TRUE
025400              ADD MMPG-AMT (13)  TO WS-PART-EARNED (1)
025500              ADD MMPG-AMT (15)  TO WS-PART-EARNED (3)
025600              ADD MMPG-AMT (16)  TO WS-PART-EARNED (2)
025700         WHEN MMTCWS-LM-INTCHG-FEES-DR
025800              SET WS-HAVE-DATA   TO TRUE
025900              ADD MMPG-AMT (13)  TO WS-INTCHG-FEES (1)
026000              ADD MMPG-AMT (15)  TO WS-INTCHG-FEES (3)
026100              ADD MMPG-AMT (16)  TO WS-INTCHG-FEES (2)
026200         WHEN MMTCWS-LM-INTCHG-FEES-CR
026300              SET WS-HAVE-DATA   TO TRUE
026400              SUBTRACT MMPG-AMT (13)
026500                                 FROM WS-INTCHG-FEES (1)
026600              SUBTRACT MMPG-AMT (15)
026700                                 FROM WS-INTCHG-FEES (3)
026800              SUBTRACT MMPG-AMT (16)
026900                                 FROM WS-INTCHG-FEES (2)
027000         WHEN MMTCWS-LM-PART-DR
027100              SET WS-HAVE-DATA   TO TRUE
027200              ADD MMPG-AMT (13)  TO WS-PART-OWED (1)
027300              ADD MMPG-AMT (15)  TO WS-PART-OWED (3)
027400              ADD MMPG-AMT (16)  TO WS-PART-OWED (2)
027500     END-EVALUATE.
027600*
027700     GO TO B300-READ-LOOP.
027800*
027900 B600-MOVE-FIELDS-TO-SCREEN.
028000*
028100***********************************************
028200*    MOVE THE TOTAL FIELDS TO THE SCREN       *
028300***********************************************
028400*
028500     MOVE MBCA-MERCHANT-ORG      TO IC04-ORG.
028600     MOVE MBCA-CHAIN             TO IC04-CHAIN.
028700     MOVE MBCA-MBIC-CHAIN-NAME   TO IC04-CHAIN-NAME.
028800*
028900     PERFORM UNTIL X-WS-TOT IS GREATER THAN +3
029000         MOVE WS-DISCOUNT    (X-WS-TOT)
029100                                 TO SS95WS-IN-AMT
029200         PERFORM SS95PD-NAP-ROUTINE
029300                                 THRU SS95PD-NAP-EXIT
029400         MOVE SS95WS-OUT-AMT-L22 TO IC04-DISC        (X-IC04-RD)
029500         MOVE WS-MBS-FEES    (X-WS-TOT)
029600                                 TO SS95WS-IN-AMT
029700         PERFORM SS95PD-NAP-ROUTINE
029800                                 THRU SS95PD-NAP-EXIT
029900         MOVE SS95WS-OUT-AMT-L22 TO IC04-MBS-FEE     (X-IC04-RD)
030000         MOVE WS-REFUND      (X-WS-TOT)
030100                                 TO SS95WS-IN-AMT
030200         PERFORM SS95PD-NAP-ROUTINE
030300                                 THRU SS95PD-NAP-EXIT
030400         MOVE SS95WS-OUT-AMT-L22 TO IC04-REFUND      (X-IC04-RD)
030500         MOVE WS-USER-FEES   (X-WS-TOT)
030600                                 TO SS95WS-IN-AMT
030700         PERFORM SS95PD-NAP-ROUTINE
030800                                 THRU SS95PD-NAP-EXIT
030900         MOVE SS95WS-OUT-AMT-L22 TO IC04-USER-FEE    (X-IC04-RD)
031000         MOVE WS-PART-EARNED (X-WS-TOT)
031100                                 TO SS95WS-IN-AMT
031200         PERFORM SS95PD-NAP-ROUTINE
031300                                 THRU SS95PD-NAP-EXIT
031400         MOVE SS95WS-OUT-AMT-L22 TO IC04-PART-EARN   (X-IC04-RD)
031500         MOVE WS-INTCHG-FEES (X-WS-TOT)
031600                                 TO SS95WS-IN-AMT
031700         PERFORM SS95PD-NAP-ROUTINE
031800                                 THRU SS95PD-NAP-EXIT
031900         MOVE SS95WS-OUT-AMT-L22 TO IC04-INTCHG      (X-IC04-RD)
032000         MOVE WS-PART-OWED   (X-WS-TOT)
032100                                 TO SS95WS-IN-AMT
032200         PERFORM SS95PD-NAP-ROUTINE
032300                                 THRU SS95PD-NAP-EXIT
032400         MOVE SS95WS-OUT-AMT-L22 TO IC04-PART-OWED   (X-IC04-RD)
032500         COMPUTE SS95WS-IN-AMT   = WS-MBS-FEES       (X-WS-TOT)
032600                                 + WS-USER-FEES      (X-WS-TOT)
032700                                 + WS-INTCHG-FEES    (X-WS-TOT)
032800         PERFORM SS95PD-NAP-ROUTINE
032900                                 THRU SS95PD-NAP-EXIT
033000         MOVE SS95WS-OUT-AMT-L22 TO IC04-FEE-REVNU   (X-IC04-RD)
033100         COMPUTE SS95WS-IN-AMT   = SS95WS-IN-AMT
033200                                 + WS-DISCOUNT       (X-WS-TOT)
033300         PERFORM SS95PD-NAP-ROUTINE
033400                                 THRU SS95PD-NAP-EXIT
033500         MOVE SS95WS-OUT-AMT-L22 TO IC04-TOTAL       (X-IC04-RD)
033600         SET X-WS-TOT            UP BY +1
033700         SET X-IC04-RD           UP BY +1
033800     END-PERFORM.
033900*
034000 B700-END-BROWSE.
034100*
034200****************************************************************
034300*    END BROWSE THE PRODUCT STATISTICE FILE                    *
034400****************************************************************
034500*
034600     MOVE 'FC03'                 TO MBCA-PROGRAM-LOCATION.
034700     SET MBIORO-ENDBR            TO TRUE.
034800     PERFORM MMPGAO-ACCESS       THRU MMPGAO-ACCESS-EXIT.
034900*
035000**********************
035100*    SEND THE MAP    *
035200**********************
035300*
035400 B900-SEND-MAP.
035500*
035600     MOVE SS08WS-CURSOR          TO IC04-ALT-TRANID-L.
035700     COMPUTE MBCA-SCREEN-NBR     =  MBCA-SCREEN-NBR - 50.
035800*
035900*    IF  WS-NO-DATA
036000*        MOVE 'NO APPLICABLE STATISTICS FOR THIS CHAIN '
036100*                                TO IC04-ERR-MESSAGE.
036200*
036300***********************************************************
036400*    SET THE CURRENCY CODE, CURRENCY NOD                  *
036500*            PER ITEM NOD, PERCENT NOD.                   *
036600***********************************************************
036700     IF IC04-ERR-MESSAGE IS EQUAL TO SPACES OR LOW-VALUES
036800        PERFORM MB06PD-FORMAT-MESSAGE-LINE
036900                                 THRU MB06PD-FML-EXIT
037000        MOVE SS08WS-FORMATTED-MSG   TO IC04-ERR-MESSAGE
037100     END-IF.
037200*
037300     MOVE 'BM01'                 TO MBCA-PROGRAM-LOCATION.
037400     PERFORM MB60PD-SEND-MAP-WITH-ERASE
037500                                 THRU MB60PD-SMWE-EXIT.
037600*
037700************************
037800*    RETURN TO CICS    *
037900************************
038000*
038100     MOVE 'PC02'                 TO MBCA-PROGRAM-LOCATION.
038200     PERFORM MB70PD-RETURN-TRANS-ID
038300                                 THRU MB70PD-RTI-EXIT.
038400/
038500 C000-RECEIVE-SCREEN SECTION.
038600*
038700******************************************
038800*    THIS SECTION RECEIVES THE SCREEN    *
038900******************************************
039000*
039100     MOVE 'BM02'                 TO MBCA-PROGRAM-LOCATION.
039200     PERFORM MB60PD-RECEIVE-MAP  THRU MB60PD-RM-EXIT.
039300*
039400**************************************************************
039500*    CHECK FOR ANOTHER TRANSACTION ID ENTERED BY THE USER    *
039600**************************************************************
039700*
039800     MOVE 'PC03'                 TO MBCA-PROGRAM-LOCATION.
039900     PERFORM MB60PD-NEW-TRANS-ROUTINE
040000                                 THRU MB60PD-NTR-EXIT.
040100/
040200 F000-SETUP-COMMAREA SECTION.
040300*
040400***************************************************************
040500*  SET UP COMMAREA FIELDS AND TRANSFER TO THE NEXT PROGRAM    *
040600***************************************************************
040700*
040800     MOVE MBCA-EIBAID            TO SS08WS-EIBAID.
040900*
041000     PERFORM MB60PD-EDIT-PAGE-NBR
041100                                 THRU MB60PD-EPN-EXIT.
041200*
041300     IF  SS08WS-VALID-PF-KEY
041400     OR  SS08WS-EIBAID-VALID-PF-KEY
041500         SET MBCA-INITIAL-SCREEN-NBR
041600                                 TO TRUE.
041700*
041800 F090-TRANSFER-XCTL.
041900*
042000     MOVE 'PC04'                 TO MBCA-PROGRAM-LOCATION.
042100     PERFORM MB70PD-XCTL-TO-MBOXCTL
042200                                 THRU MB70PD-XTM-EXIT.
042300/
042400 Z000-COPIED-ROUTINES SECTION.
042500*
042600**********************************
042700*    JUL TO GREG DATE ROUTINE    *
042800**********************************
042900*
043000     COPY SS08PD.
043100/
043200     COPY SS26PD.
043300/
043400     COPY SS27PD.
043500/
043600**********************************
043700*    GREG TO JUL DATE ROUTINE    *
043800**********************************
043900*
044000     COPY SS07PD.
044100/
044200**********************************
044300*    DATE VALIDATION ROUTINE     *
044400**********************************
044500*
044600     COPY SS05PD.
044700/
044800*********************************
044900*    LINE 24 PF KEYS ROUTINE    *
045000*********************************
045100*
045200     COPY SS15PD.
045300/
045400***************************************************
045500*    PRODUCT STATISTICS RECORD ACCESS ROUTINES    *
045600***************************************************
045700*
045800     COPY MMPGAO.
045900/
046000***************************************************
046100*    FORMAT NBR AND AMOUNTS BY CURRENCY CODE      *
046200***************************************************
046300*
046400     COPY SS95PDO REPLACING ==:XXCA:== BY ==MBCA==.
046500/
046600*****************************
046700*    ONLINE MAP ROUTINES    *
046800*****************************
046900*
047000     COPY MB60PD REPLACING 'MBMAPXX' BY 'MBIC04 '
047100                           MBMAPXXI BY MBIC04I
047200                           MBMAPXXO BY MBIC04O.
047300/
047400***********************************
047500*    FORMAT MESSAGE LINE BUILDER  *
047600***********************************
047700*
047800     COPY MB06PD.
047900/
048000***************************
048100*    ONLINE PROCEDURES    *
048200***************************
048300*
048400     COPY MB70PD.
048500/
048600     COPY SMFTPXO.
