000100 IDENTIFICATION DIVISION.
000200 PROGRAM-ID. MBOIC09.
000201*       RELEASE DATE=08/24/01.        REVISION LEVEL=08.06      *
000202*****************************************************************
000203*WARNING.  THIS COMPUTER PROGRAM IS PROTECTED BY COPYRIGHT LAW  *
000204*AND INTERNATIONAL TREATIES.  UNAUTHORIZED REPRODUCTION OR      *
000205*DISTRIBUTION OF THIS PROGRAM, OR ANY PORTION OF IT, MAY RESULT *
000206*IN SEVERE CIVIL AND CRIMINAL PENATLIES, AND WILL BE PROSECUTED *
000207*TO THE MAXIMUM EXTENT POSSIBLE UNDER THE LAW.                  *
000208*COPYRIGHT 1999 PAYSYS INTERNATIONAL, INC.  ALL RIGHTS RESERVED.*
000209*****************************************************************
000300*****************************************************************
000400*                                                               *
000500*   V - PLUS  M E R C H A N T   B A N K C A R D   S Y S T E M   *
000600*                                                               *
000700*      MBOIC09 - CHAIN SUMMARY INQUIRY                          *
000800*                SCREEN 09                                      *
000900*                                                               *
001000*              1. TRANSID                                       *
001100*                 B. MBIC                                       *
001200*              2. MAPS USED -                                   *
001300*                 A. MBIC09 (SCREEN 09)                         *
001400*              3. FILES USED -                                  *
001500*                 A. MMRC (MERCHANT CHAIN MASTER FILE)          *
001600*                 A. MMPG (GROUP PRODUCT STATISTICS FILE)       *
001700*                                                               *
001800*****************************************************************
001900*
002000 ENVIRONMENT DIVISION.
002100*
002200 DATA DIVISION.
002300*
002400 WORKING-STORAGE SECTION.
002500*
002600 01  FILLER                  PIC  X(12)      VALUE '** WS-BEG **'.
002700*
002800 01  FILLER                  PIC  X(14)      VALUE
002900     'MISCELLANEOUS:'.
003000*
003100 01  WS-MISCELLANEOUS.
003200*
003300     03  WS-STATISTICS.
003400         05  WS-LOGIC-MODULE-LEVEL           OCCURS 6 TIMES
003500                                             INDEXED BY
003600                                             X-WS-LM.
003700             07  WS-STATS-TABLE              OCCURS 18 TIMES
003800                                             INDEXED BY
003900                                             X-WS-STATS.
004000                 09  WS-STATS-NBR
004100                             PIC S9(09)      COMP-3.
004200                 09  WS-STATS-AMT
004300                             PIC S9(17)      COMP-3.
004400 01  WS-TOTALS.
004500     05  WS-TOTAL-TOTALS-NBR PIC S9(09)      VALUE ZEROS COMP-3.
004600     05  WS-TOTAL-TOTALS-AMT PIC S9(17)      VALUE ZEROS COMP-3.
004700     05  WS-TOTAL-CHRGBACK-NBR
004800                             PIC S9(09)      VALUE ZEROS COMP-3.
004900     05  WS-TOTAL-CHRGBACK-AMT
005000                             PIC S9(17)      VALUE ZEROS COMP-3.
005100*
005200/
005300 01  FILLER                  PIC  X(29)      VALUE
005400     'I/O REQUEST BLOCK WORK AREAS:'.
005500*
005600     COPY MBIOWS.
005700/
005800 01  FILLER                  PIC  X(18)      VALUE
005900     'I/O REQUEST BLOCK:'.
006000*
006100     COPY MBIORO.
006200/
006300 01  FILLER                  PIC  X(32)      VALUE
006400     'CHAIN MASTER WORKING STORAGE:'.
006500*
006600     COPY MMRCWS.
006700/
006800 01  FILLER                  PIC  X(32)      VALUE
006900     'CHAIN MASTER INITIALIZE REC :'.
007000*
007100     COPY MMRCIR.
007200/
007300 01  FILLER                  PIC  X(22)      VALUE
007400     'PROD STAT LOGIC MODULE'.
007500*
007600     COPY MMTCWS.
007700/
007800 01  FILLER                  PIC  X(20)      VALUE
007900     'CCS DATE WORK AREAS:'.
008000*
008100     COPY SS01WS.
008200/
008300 01  FILLER                  PIC  X(15)      VALUE
008400     'CCS WORK AREAS:'.
008500*
008600     COPY SS08WS.
008700/
008800     COPY SS00WS.
008900/
009000     COPY SMFTWS.
009100/
009200     COPY SMPTRL REPLACING ==:SMPT:== BY ==SMPT==.
009300/
009400     COPY MB61LK.
009500/
009600 01  FILLER                  PIC  X(28)      VALUE
009700     'DYNAMICALY CALLED SUBROUINES'.
009800*
009900     COPY MB00WS.
010000/
010100 01  FILLER                  PIC  X(36)      VALUE
010200     'FORMAT NBR AND AMTS BY CURRENCY CODE'.
010300*
010400     COPY SS95WS.
010500*
010600 01  FILLER                  PIC  X(12)      VALUE '** WS-END **'.
010700/
010800 LINKAGE SECTION.
010900*
011000 01  DFHCOMMAREA.
011100*
011200     COPY MB60WS.
011300/
011400*********************************
011500*    CHAIN SUMMARY MAP          *
011600*********************************
011700*
011800     COPY MBIC09.
011900/
012000**********************************************
012100*    CHAIN SUMMARY MAP REDEFINITION          *
012200**********************************************
012300*
012400     COPY MBIC09R.
012500/
012600******************************************
012700*    CHAIN MASTER RECORD LAYOUT          *
012800******************************************
012900*
013000     COPY MMRCRL.
013100/
013200*********************************************
013300*    PRODUCT STATISTICS RECORD LAYOUT       *
013400*********************************************
013500*
013600     COPY MMPARL REPLACING ==:MMPA:== BY ==MMPG==.
013700/
013800 PROCEDURE DIVISION.
013900*
014000 A000-HOUSEKEEPING SECTION.
014100*
014200 A020-INIT.
014300*
014400     MOVE 'PC01'                 TO MBCA-PROGRAM-LOCATION.
014500     PERFORM MB70PD-ON-LINE-HOUSEKEEPING
014600                                 THRU MB70PD-OLH-EXIT.
014700*
014800     SET SS95WS-FUNCTION-INITIALIZE
014900                           TO TRUE.
015000     PERFORM SS95PD-NAP-ROUTINE
015100        THRU SS95PD-NAP-EXIT.
015200*
015300     IF  MBCA-RECEIVE-SCREEN
015400         GO TO C000-RECEIVE-SCREEN.
015500/
015600 B000-SEND-SCREEN SECTION.
015700*
015800*********************************************
015900*    GET CICS STORAGE NEEDED FOR THE MAP    *
016000*********************************************
016100*
016200     MOVE 'SC01'                 TO MBCA-PROGRAM-LOCATION.
016300     PERFORM MB60PD-GETMAIN-FOR-MAP
016400                                 THRU MB60PD-GFM-EXIT.
016500*
016600*******************************************
016700*    INITIALIZE THE STANDARD MAP LINES    *
016800*******************************************
016900*
017000     PERFORM MB60PD-INIT-STD-MAP-LINES
017100                                 THRU MB60PD-ISML-EXIT.
017200*
017300**********************************************************
017400*    READ THE CHAIN CHAIN RECORD FOR SUBSEQUENT          *
017500*    DISPLAY.                                            *
017600**********************************************************
017700*
017800     MOVE MBCA-MERCHANT-ORG      TO MBIOWS-MMRC-ORG.
017900     MOVE MBCA-CHAIN             TO MBIOWS-MMRC-CHAIN.
018000     MOVE 'FC01'                 TO MBCA-PROGRAM-LOCATION.
018100     SET MBIORO-READ-RANDOM      TO TRUE.
018200     PERFORM MMRCAO-ACCESS       THRU MMRCAO-ACCESS-EXIT.
018300*
018400**********************************************************
018500*    READ THE CHAIN PRODUCT STATS FILE RANDOMLY FOR      *
018600*    THE SALES TOTAL RECORD.                             *
018700**********************************************************
018800*
018900     MOVE MBCA-MERCHANT-ORG      TO MBIOWS-MMPG-ORG.
019000     MOVE MBCA-CHAIN             TO MBIOWS-MMPG-ACCT.
019100     MOVE ZERO                   TO MBIOWS-MMPG-MINOR-KEY.
019200     SET MBIOWS-MMPG-TOTALS      TO TRUE.
019300     SET MMTCWS-LM-SALE          TO TRUE.
019400     MOVE MMTCWS-LOGIC-MODULE    TO MBIOWS-MMPG-LOGIC-MODULE.
019500     MOVE SS08WS-CICS-FC-NOTFND  TO MBIORO-TEMP-STATUS-1.
019600     MOVE 'FC01'                 TO MBCA-PROGRAM-LOCATION.
019700     SET MBIORO-READ-RANDOM      TO TRUE.
019800     PERFORM MMPGAO-ACCESS       THRU MMPGAO-ACCESS-EXIT.
019900*
020000     IF  SS08WS-RC-FC-NOTFND
020100         INITIALIZE              WS-LOGIC-MODULE-LEVEL (1)
020200     ELSE
020300         MOVE MMPG-TOTALS-DATA   TO WS-LOGIC-MODULE-LEVEL (1).
020400*
020500*
020600**********************************************************
020700*    READ THE CHAIN PRODUCT STATS FILE RANDOMLY FOR      *
020800*    THE SALE REVERSALS TOTAL RECORD.                    *
020900**********************************************************
021000*
021100     MOVE MBCA-MERCHANT-ORG      TO MBIOWS-MMPG-ORG.
021200     MOVE MBCA-CHAIN             TO MBIOWS-MMPG-ACCT.
021300     MOVE ZERO                   TO MBIOWS-MMPG-MINOR-KEY.
021400     SET MBIOWS-MMPG-TOTALS      TO TRUE.
021500     SET MMTCWS-LM-SALE-REV      TO TRUE.
021600     MOVE MMTCWS-LOGIC-MODULE    TO MBIOWS-MMPG-LOGIC-MODULE.
021700     MOVE SS08WS-CICS-FC-NOTFND  TO MBIORO-TEMP-STATUS-1.
021800     MOVE 'FC01'                 TO MBCA-PROGRAM-LOCATION.
021900     SET MBIORO-READ-RANDOM      TO TRUE.
022000     PERFORM MMPGAO-ACCESS       THRU MMPGAO-ACCESS-EXIT.
022100*
022200     IF  SS08WS-RC-FC-NOTFND
022300         INITIALIZE              WS-LOGIC-MODULE-LEVEL (2)
022400     ELSE
022500         MOVE MMPG-TOTALS-DATA   TO WS-LOGIC-MODULE-LEVEL (2).
022600*
022700**********************************************************
022800*    READ THE CHAIN PRODUCT STATS FILE RANDOMLY FOR      *
022900*    THE RETURNS TOTALS RECORD.                          *
023000**********************************************************
023100*
023200     MOVE MBCA-MERCHANT-ORG      TO MBIOWS-MMPG-ORG.
023300     MOVE MBCA-CHAIN             TO MBIOWS-MMPG-ACCT.
023400     MOVE ZERO                   TO MBIOWS-MMPG-MINOR-KEY.
023500     SET MBIOWS-MMPG-TOTALS      TO TRUE.
023600     SET MMTCWS-LM-RETURN        TO TRUE.
023700     MOVE MMTCWS-LOGIC-MODULE    TO MBIOWS-MMPG-LOGIC-MODULE.
023800     MOVE SS08WS-CICS-FC-NOTFND  TO MBIORO-TEMP-STATUS-1.
023900     MOVE 'FC01'                 TO MBCA-PROGRAM-LOCATION.
024000     SET MBIORO-READ-RANDOM      TO TRUE.
024100     PERFORM MMPGAO-ACCESS       THRU MMPGAO-ACCESS-EXIT.
024200*
024300     IF  SS08WS-RC-FC-NOTFND
024400         INITIALIZE              WS-LOGIC-MODULE-LEVEL (3)
024500     ELSE
024600         MOVE MMPG-TOTALS-DATA   TO WS-LOGIC-MODULE-LEVEL (3).
024700*
024800**********************************************************
024900*    READ THE CHAIN PRODUCT STATS FILE RANDOMLY FOR      *
025000*    THE RETURN REVERSALS TOTAL RECORD.                  *
025100**********************************************************
025200*
025300     MOVE MBCA-MERCHANT-ORG      TO MBIOWS-MMPG-ORG.
025400     MOVE MBCA-CHAIN             TO MBIOWS-MMPG-ACCT.
025500     MOVE ZERO                   TO MBIOWS-MMPG-MINOR-KEY.
025600     SET MBIOWS-MMPG-TOTALS      TO TRUE.
025700     SET MMTCWS-LM-RETURN-REV    TO TRUE.
025800     MOVE MMTCWS-LOGIC-MODULE    TO MBIOWS-MMPG-LOGIC-MODULE.
025900     MOVE SS08WS-CICS-FC-NOTFND  TO MBIORO-TEMP-STATUS-1.
026000     MOVE 'FC01'                 TO MBCA-PROGRAM-LOCATION.
026100     SET MBIORO-READ-RANDOM      TO TRUE.
026200     PERFORM MMPGAO-ACCESS       THRU MMPGAO-ACCESS-EXIT.
026300*
026400     IF  SS08WS-RC-FC-NOTFND
026500         INITIALIZE              WS-LOGIC-MODULE-LEVEL (4)
026600     ELSE
026700         MOVE MMPG-TOTALS-DATA   TO WS-LOGIC-MODULE-LEVEL (4).
026800*
026900**********************************************************
027000*    READ THE CHAIN PRODUCT STATS FILE RANDOMLY FOR      *
027100*    THE CHARGEBACK CREDITS TOTALS RECORD.               *
027200**********************************************************
027300*
027400     MOVE MBCA-MERCHANT-ORG      TO MBIOWS-MMPG-ORG.
027500     MOVE MBCA-CHAIN             TO MBIOWS-MMPG-ACCT.
027600     MOVE ZERO                   TO MBIOWS-MMPG-MINOR-KEY.
027700     SET MBIOWS-MMPG-TOTALS      TO TRUE.
027800     SET MMTCWS-LM-CHGBACK-CR    TO TRUE.
027900     MOVE MMTCWS-LOGIC-MODULE    TO MBIOWS-MMPG-LOGIC-MODULE.
028000     MOVE SS08WS-CICS-FC-NOTFND  TO MBIORO-TEMP-STATUS-1.
028100     MOVE 'FC01'                 TO MBCA-PROGRAM-LOCATION.
028200     SET MBIORO-READ-RANDOM      TO TRUE.
028300     PERFORM MMPGAO-ACCESS       THRU MMPGAO-ACCESS-EXIT.
028400*
028500     IF  SS08WS-RC-FC-NOTFND
028600         INITIALIZE              WS-LOGIC-MODULE-LEVEL (5)
028700     ELSE
028800         MOVE MMPG-TOTALS-DATA   TO WS-LOGIC-MODULE-LEVEL (5).
028900*
029000**********************************************************
029100*    READ THE CHAIN PRODUCT STATS FILE RANDOMLY FOR      *
029200*    THE CHARGEBACK DEBITS TOTALS RECORD.                *
029300**********************************************************
029400*
029500     MOVE MBCA-MERCHANT-ORG      TO MBIOWS-MMPG-ORG.
029600     MOVE MBCA-CHAIN             TO MBIOWS-MMPG-ACCT.
029700     MOVE ZERO                   TO MBIOWS-MMPG-MINOR-KEY.
029800     SET MBIOWS-MMPG-TOTALS      TO TRUE.
029900     SET MMTCWS-LM-CHGBACK-DR    TO TRUE.
030000     MOVE MMTCWS-LOGIC-MODULE    TO MBIOWS-MMPG-LOGIC-MODULE.
030100     MOVE SS08WS-CICS-FC-NOTFND  TO MBIORO-TEMP-STATUS-1.
030200     MOVE 'FC01'                 TO MBCA-PROGRAM-LOCATION.
030300     SET MBIORO-READ-RANDOM      TO TRUE.
030400     PERFORM MMPGAO-ACCESS       THRU MMPGAO-ACCESS-EXIT.
030500*
030600     IF  SS08WS-RC-FC-NOTFND
030700         INITIALIZE              WS-LOGIC-MODULE-LEVEL (6)
030800     ELSE
030900         MOVE MMPG-TOTALS-DATA   TO WS-LOGIC-MODULE-LEVEL (6).
031000*
031100*
031200     MOVE MBCA-CURRENCY-CODE     TO SS95WS-CURRENCY-CODE.
031300     MOVE MMRC-ORG               TO IC09-ORG.
031400     MOVE MMRC-CHAIN             TO IC09-CHAIN.
031500     MOVE MMRC-NA-LINE (1)       TO IC09-CHAIN-NAME.
031600*
031700****************************************************************
031800*    ACCUMULATE TOTALS AND CHRGBACK                            *
031900****************************************************************R
032000*
032100***  CURRENT TOTALS ***
032200*
032300     COMPUTE SS95WS-IN-NBR       =  WS-STATS-NBR (1 13)
032400                                 +  WS-STATS-NBR (2 13)
032500                                 +  WS-STATS-NBR (3 13)
032600                                 +  WS-STATS-NBR (4 13).
032700     COMPUTE SS95WS-IN-AMT       =  WS-STATS-AMT (1 13)
032800                                 -  WS-STATS-AMT (2 13)
032900                                 -  WS-STATS-AMT (3 13)
033000                                 +  WS-STATS-AMT (4 13).
033100     PERFORM SS95PD-NAP-ROUTINE
033200                                 THRU SS95PD-NAP-EXIT.
033300     MOVE SS95WS-OUT-NBR-L09     TO IC09-YEST-TOTALS-NBR.
033400     MOVE SS95WS-OUT-AMT-L20     TO IC09-YEST-TOTALS-AMT.
033500*
033600***  CURRENT CHRGBACK ***
033700*
033800     COMPUTE SS95WS-IN-NBR       =  WS-STATS-NBR (5 13)
033900                                 +  WS-STATS-NBR (6 13).
034000     COMPUTE SS95WS-IN-AMT       =  WS-STATS-AMT (5 13)
034100                                 -  WS-STATS-AMT (6 13).
034200     PERFORM SS95PD-NAP-ROUTINE
034300                                 THRU SS95PD-NAP-EXIT.
034400     MOVE SS95WS-OUT-NBR-L09     TO IC09-YEST-CHRGBACK-NBR.
034500     MOVE SS95WS-OUT-AMT-L20     TO IC09-YEST-CHRGBACK-AMT.
034600*
034700***  CYCLE TO DATE TOTALS ***
034800*
034900     COMPUTE SS95WS-IN-NBR       =  WS-STATS-NBR (1 16)
035000                                 +  WS-STATS-NBR (2 16)
035100                                 +  WS-STATS-NBR (3 16)
035200                                 +  WS-STATS-NBR (4 16).
035300     COMPUTE SS95WS-IN-AMT       =  WS-STATS-AMT (1 16)
035400                                 -  WS-STATS-AMT (2 16)
035500                                 -  WS-STATS-AMT (3 16)
035600                                 +  WS-STATS-AMT (4 16).
035700     PERFORM SS95PD-NAP-ROUTINE
035800                                 THRU SS95PD-NAP-EXIT.
035900     MOVE SS95WS-OUT-NBR-L09     TO IC09-CTD-TOTALS-NBR.
036000     MOVE SS95WS-OUT-AMT-L20     TO IC09-CTD-TOTALS-AMT.
036100*
036200***  CYCLE TO DATE CHRGBACK ***
036300*
036400     COMPUTE SS95WS-IN-NBR       =  WS-STATS-NBR (5 16)
036500                                 +  WS-STATS-NBR (6 16).
036600     COMPUTE SS95WS-IN-AMT       =  WS-STATS-AMT (5 16)
036700                                 -  WS-STATS-AMT (6 16).
036800     PERFORM SS95PD-NAP-ROUTINE
036900                                 THRU SS95PD-NAP-EXIT.
037000     MOVE SS95WS-OUT-NBR-L09     TO IC09-CTD-CHRGBACK-NBR.
037100     MOVE SS95WS-OUT-AMT-L20     TO IC09-CTD-CHRGBACK-AMT.
037200*
037300***  MONTH TO DATE TOTALS ***
037400*
037500     COMPUTE SS95WS-IN-NBR       =  WS-STATS-NBR (1 14)
037600                                 +  WS-STATS-NBR (2 14)
037700                                 +  WS-STATS-NBR (3 14)
037800                                 +  WS-STATS-NBR (4 14).
037900     COMPUTE SS95WS-IN-AMT       =  WS-STATS-AMT (1 14)
038000                                 -  WS-STATS-AMT (2 14)
038100                                 -  WS-STATS-AMT (3 14)
038200                                 +  WS-STATS-AMT (4 14).
038300     PERFORM SS95PD-NAP-ROUTINE
038400                                 THRU SS95PD-NAP-EXIT.
038500     MOVE SS95WS-OUT-NBR-L09     TO IC09-MTD-TOTALS-NBR.
038600     MOVE SS95WS-OUT-AMT-L20     TO IC09-MTD-TOTALS-AMT.
038700*
038800***  MONTH TO DATE CHRGBACK ***
038900*
039000     COMPUTE SS95WS-IN-NBR       =  WS-STATS-NBR (5 14)
039100                                 +  WS-STATS-NBR (6 14).
039200     COMPUTE SS95WS-IN-AMT       =  WS-STATS-AMT (5 14)
039300                                 -  WS-STATS-AMT (6 14).
039400     PERFORM SS95PD-NAP-ROUTINE
039500                                 THRU SS95PD-NAP-EXIT.
039600     MOVE SS95WS-OUT-NBR-L09     TO IC09-MTD-CHRGBACK-NBR.
039700     MOVE SS95WS-OUT-AMT-L20     TO IC09-MTD-CHRGBACK-AMT.
039800*
039900***  YEAR TO DATE TOTALS ***
040000*
040100     COMPUTE SS95WS-IN-NBR       =  WS-STATS-NBR (1 15)
040200                                 +  WS-STATS-NBR (2 15)
040300                                 +  WS-STATS-NBR (3 15)
040400                                 +  WS-STATS-NBR (4 15).
040500     COMPUTE SS95WS-IN-AMT       =  WS-STATS-AMT (1 15)
040600                                 -  WS-STATS-AMT (2 15)
040700                                 -  WS-STATS-AMT (3 15)
040800                                 +  WS-STATS-AMT (4 15).
040900     PERFORM SS95PD-NAP-ROUTINE
041000                                 THRU SS95PD-NAP-EXIT.
041100     MOVE SS95WS-OUT-NBR-L09     TO IC09-YTD-TOTALS-NBR.
041200     MOVE SS95WS-OUT-AMT-L20     TO IC09-YTD-TOTALS-AMT.
041300*
041400***  YEAR TO DATE CHRGBACK ***
041500*
041600     COMPUTE SS95WS-IN-NBR       =  WS-STATS-NBR (5 15)
041700                                 +  WS-STATS-NBR (6 15).
041800     COMPUTE SS95WS-IN-AMT       =  WS-STATS-AMT (5 15)
041900                                 -  WS-STATS-AMT (6 15).
042000     PERFORM SS95PD-NAP-ROUTINE
042100                                 THRU SS95PD-NAP-EXIT.
042200     MOVE SS95WS-OUT-NBR-L09     TO IC09-YTD-CHRGBACK-NBR.
042300     MOVE SS95WS-OUT-AMT-L20     TO IC09-YTD-CHRGBACK-AMT.
042400*
042500*** CALCULATE FOR MONTHS 1-12
042600*
042700     PERFORM
042800         VARYING X-IC09-MONTH FROM 1 BY 1
042900         UNTIL X-IC09-MONTH IS GREATER THAN 12
043000         EVALUATE TRUE
043100             WHEN X-IC09-MONTH IS EQUAL TO 1
043200                 MOVE 'JAN'     TO MMRCWS-OID-SEARCH
043300             WHEN X-IC09-MONTH IS EQUAL TO 2
043400                 MOVE 'FEB'     TO MMRCWS-OID-SEARCH
043500             WHEN X-IC09-MONTH IS EQUAL TO 3
043600                 MOVE 'MAR'     TO MMRCWS-OID-SEARCH
043700             WHEN X-IC09-MONTH IS EQUAL TO 4
043800                 MOVE 'APR'     TO MMRCWS-OID-SEARCH
043900             WHEN X-IC09-MONTH IS EQUAL TO 5
044000                 MOVE 'MAY'     TO MMRCWS-OID-SEARCH
044100             WHEN X-IC09-MONTH IS EQUAL TO 6
044200                 MOVE 'JUN'     TO MMRCWS-OID-SEARCH
044300             WHEN X-IC09-MONTH IS EQUAL TO 7
044400                 MOVE 'JUL'     TO MMRCWS-OID-SEARCH
044500             WHEN X-IC09-MONTH IS EQUAL TO 8
044600                 MOVE 'AUG'     TO MMRCWS-OID-SEARCH
044700             WHEN X-IC09-MONTH IS EQUAL TO 9
044800                 MOVE 'SEP'     TO MMRCWS-OID-SEARCH
044900             WHEN X-IC09-MONTH IS EQUAL TO 10
045000                 MOVE 'OCT'     TO MMRCWS-OID-SEARCH
045100             WHEN X-IC09-MONTH IS EQUAL TO 11
045200                 MOVE 'NOV'     TO MMRCWS-OID-SEARCH
045300             WHEN X-IC09-MONTH IS EQUAL TO 12
045400                 MOVE 'DEC'     TO MMRCWS-OID-SEARCH
045500         END-EVALUATE
045600         PERFORM MMRCPX-FIND-OCCURRENCE
045700                                 THRU MMRCPX-FO-EXIT
045800         IF  MMRCWS-OID-INDEX IS EQUAL TO ZERO
045900             MOVE 1              TO MMRCWS-OID-INDEX
046000         END-IF
046100         SET X-WS-STATS          TO MMRCWS-OID-INDEX
046200         SET X-MMRC              TO MMRCWS-OID-INDEX
046300         MOVE MMRC-OCCURRENCE-YEAR (X-MMRC)
046400                                 TO IC09-MONTH-YEAR (X-IC09-MONTH)
046500         COMPUTE SS95WS-IN-NBR   =  WS-STATS-NBR (1 X-WS-STATS)
046600                                 +  WS-STATS-NBR (2 X-WS-STATS)
046700                                 +  WS-STATS-NBR (3 X-WS-STATS)
046800                                 +  WS-STATS-NBR (4 X-WS-STATS)
046900         COMPUTE SS95WS-IN-AMT   =  WS-STATS-AMT (1 X-WS-STATS)
047000                                 -  WS-STATS-AMT (2 X-WS-STATS)
047100                                 -  WS-STATS-AMT (3 X-WS-STATS)
047200                                 +  WS-STATS-AMT (4 X-WS-STATS)
047300         ADD SS95WS-IN-NBR       TO WS-TOTAL-TOTALS-NBR
047400         ADD SS95WS-IN-AMT       TO WS-TOTAL-TOTALS-AMT
047500         PERFORM SS95PD-NAP-ROUTINE
047600                                 THRU SS95PD-NAP-EXIT
047700         MOVE SS95WS-OUT-NBR-L09 TO IC09-MONTH-TOTALS-NBR
047800                                    (X-IC09-MONTH)
047900         MOVE SS95WS-OUT-AMT-L20 TO IC09-MONTH-TOTALS-AMT
048000                                    (X-IC09-MONTH)
048100*
048200***   CHRGBACK  ***
048300*
048400         COMPUTE SS95WS-IN-NBR   =  WS-STATS-NBR (5 X-WS-STATS)
048500                                 +  WS-STATS-NBR (6 X-WS-STATS)
048600         COMPUTE SS95WS-IN-AMT   =  WS-STATS-AMT (5 X-WS-STATS)
048700                                 -  WS-STATS-AMT (6 X-WS-STATS)
048800         ADD SS95WS-IN-NBR       TO WS-TOTAL-CHRGBACK-NBR
048900         ADD SS95WS-IN-AMT       TO WS-TOTAL-CHRGBACK-AMT
049000         PERFORM SS95PD-NAP-ROUTINE
049100                                 THRU SS95PD-NAP-EXIT
049200         MOVE SS95WS-OUT-NBR-L09 TO IC09-MONTH-CHRGBACK-NBR
049300                                    (X-IC09-MONTH)
049400         MOVE SS95WS-OUT-AMT-L20 TO IC09-MONTH-CHRGBACK-AMT
049500                                    (X-IC09-MONTH)
049600     END-PERFORM
049700*
049800***  ROLLING TOTALS TOTALS ***
049900*
050000     MOVE WS-TOTAL-TOTALS-NBR    TO SS95WS-IN-NBR.
050100     MOVE WS-TOTAL-TOTALS-AMT    TO SS95WS-IN-AMT.
050200     PERFORM SS95PD-NAP-ROUTINE
050300                                 THRU SS95PD-NAP-EXIT.
050400     MOVE SS95WS-OUT-NBR-L09     TO IC09-ROLLING-TOTALS-NBR.
050500     MOVE SS95WS-OUT-AMT-L20     TO IC09-ROLLING-TOTALS-AMT.
050600*
050700***  ROLLING CHRGBACK TOTALS ***
050800*
050900     MOVE WS-TOTAL-CHRGBACK-NBR  TO SS95WS-IN-NBR.
051000     MOVE WS-TOTAL-CHRGBACK-AMT  TO SS95WS-IN-AMT.
051100     PERFORM SS95PD-NAP-ROUTINE
051200                                 THRU SS95PD-NAP-EXIT.
051300     MOVE SS95WS-OUT-NBR-L09     TO IC09-ROLLING-CHRGBACK-NBR.
051400     MOVE SS95WS-OUT-AMT-L20     TO IC09-ROLLING-CHRGBACK-AMT.
051500*
051600***********************************************************
051700*    SET THE CURRENCY CODE, CURRENCY NOD                  *
051800*            PER ITEM NOD, PERCENT NOD.                   *
051900***********************************************************
052000     IF IC09-ERR-MESSAGE IS EQUAL TO SPACES OR LOW-VALUES
052100        PERFORM MB06PD-FORMAT-MESSAGE-LINE
052200                                 THRU MB06PD-FML-EXIT
052300        MOVE SS08WS-FORMATTED-MSG  TO IC09-ERR-MESSAGE
052400     END-IF.
052500*
052600**********************
052700*    SEND THE MAP    *
052800**********************
052900*
053000 B900-SEND-MAP.
053100*
053200     MOVE SS08WS-CURSOR          TO IC09-ALT-TRANID-L.
053300     COMPUTE MBCA-SCREEN-NBR     =  MBCA-SCREEN-NBR - 50.
053400*
053500     MOVE 'BM01'                 TO MBCA-PROGRAM-LOCATION.
053600     PERFORM MB60PD-SEND-MAP-WITH-ERASE
053700                                 THRU MB60PD-SMWE-EXIT.
053800*
053900************************
054000*    RETURN   TO CICS  *
054100************************
054200*
054300     MOVE 'PC02'                 TO MBCA-PROGRAM-LOCATION.
054400     PERFORM MB70PD-RETURN-TRANS-ID
054500                                 THRU MB70PD-RTI-EXIT.
054600/
054700 C000-RECEIVE-SCREEN SECTION.
054800*
054900******************************************
055000*    THIS SECTION RECEIVES THE SCREEN    *
055100******************************************
055200*
055300     MOVE 'BM02'                 TO MBCA-PROGRAM-LOCATION.
055400     PERFORM MB60PD-RECEIVE-MAP  THRU MB60PD-RM-EXIT.
055500*
055600**************************************************************
055700*    CHECK FOR ANOTHER TRANSACTION ID ENTERED BY THE USER    *
055800**************************************************************
055900*
056000     MOVE 'PC03'                 TO MBCA-PROGRAM-LOCATION.
056100     PERFORM MB60PD-NEW-TRANS-ROUTINE
056200                                 THRU MB60PD-NTR-EXIT.
056300/
056400 F000-SETUP-COMMAREA SECTION.
056500*
056600***************************************************************
056700*  SET UP COMMAREA FIELDS AND TRANSFER TO THE NEXT PROGRAM    *
056800***************************************************************
056900*
057000     MOVE MBCA-EIBAID            TO SS08WS-EIBAID.
057100*
057200     PERFORM MB60PD-EDIT-PAGE-NBR
057300                                 THRU MB60PD-EPN-EXIT.
057400*
057500     IF  SS08WS-VALID-PF-KEY
057600     OR  SS08WS-EIBAID-VALID-PF-KEY
057700         SET MBCA-INITIAL-SCREEN-NBR
057800                                 TO TRUE.
057900*
058000 F090-TRANSFER-XCTL.
058100*
058200     MOVE 'PC04'                 TO MBCA-PROGRAM-LOCATION.
058300     PERFORM MB70PD-XCTL-TO-MBOXCTL
058400                                 THRU MB70PD-XTM-EXIT.
058500/
058600 Z000-COPIED-ROUTINES SECTION.
058700*
058800*
058900**********************************
059000*    JUL TO GREG DATE ROUTINE    *
059100**********************************
059200*
059300     COPY SS08PD.
059400/
059500     COPY SS26PD.
059600/
059700     COPY SS27PD.
059800/
059900**********************************
060000*    GREG TO JUL DATE ROUTINE    *
060100**********************************
060200*
060300     COPY SS07PD.
060400/
060500**********************************
060600*    DATE VALIDATION ROUTINE     *
060700**********************************
060800*
060900     COPY SS05PD.
061000/
061100*********************************
061200*    LINE 24 PF KEYS ROUTINE    *
061300*********************************
061400*
061500     COPY SS15PD.
061600/
061700************************************************
061800*    CHAIN MASTER STATS OCCURANCE DEFINES      *
061900************************************************
062000*
062100     COPY MMRCPX.
062200/
062300************************************************
062400*    CHAIN MASTER RECORD ACCESS ROUTINES       *
062500************************************************
062600*
062700     COPY MMRCAO.
062800/
062900***************************************************
063000*    PRODUCT STATISTICS RECORD ACCESS ROUTINES    *
063100***************************************************
063200*
063300     COPY MMPGAO.
063400/
063500***************************************************
063600*    FORMAT NBR AND AMOUNTS BY CURRENCY CODE      *
063700***************************************************
063800*
063900     COPY SS95PDO REPLACING ==:XXCA:== BY ==MBCA==.
064000/
064100*****************************
064200*    ONLINE MAP ROUTINES    *
064300*****************************
064400*
064500     COPY MB60PD REPLACING 'MBMAPXX' BY 'MBIC09 '
064600                           MBMAPXXI BY MBIC09I
064700                           MBMAPXXO BY MBIC09O.
064800/
064900*********************************
065000*    FORMAT MESSAGE LINE BUILDER*
065100*********************************
065200*
065300     COPY MB06PD.
065400/
065500***************************
065600*    ONLINE PROCEDURES    *
065700***************************
065800*
065900     COPY MB70PD.
066000/
066100     COPY SMFTPXO.
