000100 IDENTIFICATION DIVISION.
000200 PROGRAM-ID. MBOIM03.
000201*       RELEASE DATE=08/24/01.        REVISION LEVEL=08.06      *
000202*****************************************************************
000203*WARNING.  THIS COMPUTER PROGRAM IS PROTECTED BY COPYRIGHT LAW  *
000204*AND INTERNATIONAL TREATIES.  UNAUTHORIZED REPRODUCTION OR      *
000205*DISTRIBUTION OF THIS PROGRAM, OR ANY PORTION OF IT, MAY RESULT *
000206*IN SEVERE CIVIL AND CRIMINAL PENATLIES, AND WILL BE PROSECUTED *
000207*TO THE MAXIMUM EXTENT POSSIBLE UNDER THE LAW.                  *
000208*COPYRIGHT 1999 PAYSYS INTERNATIONAL, INC.  ALL RIGHTS RESERVED.*
000209*****************************************************************
000300*****************************************************************
000400*                                                               *
000500*   V - PLUS  M E R C H A N T   B A N K C A R D   S Y S T E M   *
000600*                                                               *
000700*      MBOIM03 - MERCHANT SUMMARY INQUIRY                       *
000800*                SCREEN 03                                      *
000900*                                                               *
001000*              1. TRANSID                                       *
001100*                 B. MBIM                                       *
001200*              2. MAPS USED -                                   *
001300*                 A. MBIM03 (SCREEN 03)                         *
001400*              3. FILES USED -                                  *
001500*                 A. MMMM (MERCHANT MASTER FILE)                *
001600*                 A. MMPA (PRODUCT STATISTICS FILE)             *
001700*                                                               *
001800*****************************************************************
001900*
002000 ENVIRONMENT DIVISION.
002100*
002200 DATA DIVISION.
002300*
002400 WORKING-STORAGE SECTION.
002500*
002600 01  FILLER                  PIC  X(12)      VALUE '** WS-BEG **'.
002700*
002800 01  FILLER                  PIC  X(14)      VALUE
002900     'MISCELLANEOUS:'.
003000*
003100 01  WS-MISCELLANEOUS.
003200*
003300     03  WS-TOTALS.
003400         05  WS-CR-DEPOSITS  PIC S9(17)      VALUE ZEROES COMP-3.
003500         05  WS-DB-WITHDRAWAL
003600                             PIC S9(17)      VALUE ZEROES COMP-3.
003700         05  WS-CR-RESV      PIC S9(17)      VALUE ZEROES COMP-3.
003800         05  WS-DB-RESV      PIC S9(17)      VALUE ZEROES COMP-3.
003900         05  WS-CR-DISC-REFUND
004000                             PIC S9(17)      VALUE ZEROES COMP-3.
004100         05  WS-DB-DISCOUNT  PIC S9(17)      VALUE ZEROES COMP-3.
004200         05  WS-CR-PART-EARNED
004300                             PIC S9(17)      VALUE ZEROES COMP-3.
004400         05  WS-DB-PART-OWED PIC S9(17)      VALUE ZEROES COMP-3.
004500         05  WS-CR-ADJ       PIC S9(17)      VALUE ZEROES COMP-3.
004600         05  WS-DB-ADJ       PIC S9(17)      VALUE ZEROES COMP-3.
004700         05  WS-CR-RCVRY-ADJ PIC S9(17)      VALUE ZEROES COMP-3.
004800         05  WS-DB-RCVRY-ADJ PIC S9(17)      VALUE ZEROES COMP-3.
004900         05  WS-CR-SYS-FEES  PIC S9(17)      VALUE ZEROES COMP-3.
005000         05  WS-DB-SYS-FEES  PIC S9(17)      VALUE ZEROES COMP-3.
005100         05  WS-CR-USER-FEES PIC S9(17)      VALUE ZEROES COMP-3.
005200         05  WS-DB-USER-FEES PIC S9(17)      VALUE ZEROES COMP-3.
005300         05  WS-CR-INTCHG-FEES
005400                             PIC S9(17)      VALUE ZEROES COMP-3.
005500         05  WS-DB-INTCHG-FEES
005600                             PIC S9(17)      VALUE ZEROES COMP-3.
005700         05  WS-CR-USERS-CREDITS
005800                             PIC S9(17)      VALUE ZEROES COMP-3.
005900         05  WS-DB-USERS-DEBITS
006000                             PIC S9(17)      VALUE ZEROES COMP-3.
006100*
006200 01  FILLER                  PIC  X(17)      VALUE
006300     'PROGRAM SWITCHES:'.
006400*
006500 01  WS-SWITCHES.
006600     05  WS-DATA-SW          PIC  X(01)      VALUE 'N'.
006700         88  WS-NO-DATA                      VALUE 'N'.
006800         88  WS-HAVE-DATA                    VALUE 'Y'.
006900*
007000/
007100 01  FILLER                  PIC  X(29)      VALUE
007200     'I/O REQUEST BLOCK WORK AREAS:'.
007300*
007400     COPY MBIOWS.
007500/
007600 01  FILLER                  PIC  X(18)      VALUE
007700     'I/O REQUEST BLOCK:'.
007800*
007900     COPY MBIORO.
008000/
008100 01  FILLER                  PIC  X(22)      VALUE
008200     'PROD STAT LOGIC MODULE'.
008300*
008400     COPY MMTCWS.
008500/
008600 01  FILLER                  PIC  X(20)      VALUE
008700     'CCS DATE WORK AREAS:'.
008800*
008900     COPY SS01WS.
009000/
009100 01  FILLER                  PIC  X(15)      VALUE
009200     'CCS WORK AREAS:'.
009300*
009400     COPY SS08WS.
009500/
009600     COPY SS00WS.
009700/
009800     COPY SMFTWS.
009900/
010000     COPY SMPTRL REPLACING ==:SMPT:== BY ==SMPT==.
010100/
010200     COPY MB61LK.
010300/
010400 01  FILLER                  PIC  X(28)      VALUE
010500     'DYNAMICALY CALLED SUBROUINES'.
010600*
010700     COPY MB00WS.
010800/
010900 01  FILLER                  PIC  X(36)      VALUE
011000     'FORMAT NBR AND AMTS BY CURRENCY CODE'.
011100*
011200     COPY SS95WS.
011300*
011400 01  FILLER                  PIC  X(12)      VALUE '** WS-END **'.
011500/
011600 LINKAGE SECTION.
011700*
011800 01  DFHCOMMAREA.
011900*
012000     COPY MB60WS.
012100/
012200*********************************
012300*    MERCHANT SUMMARY MAP       *
012400*********************************
012500*
012600     COPY MBIM03.
012700/
012800**********************************************
012900*    MERCHANT SUMMARY MAP REDEFINITION       *
013000**********************************************
013100*
013200     COPY MBIM03R.
013300/
013400******************************************
013500*    MERCHANT MASTER RECORD LAYOUT       *
013600******************************************
013700*
013800     COPY MMMMRL.
013900/
014000*********************************************
014100*    PRODUCT STATISTICS RECORD LAYOUT       *
014200*********************************************
014300*
014400     COPY MMPARL REPLACING ==:MMPA:== BY ==MMPA==.
014500/
014600 PROCEDURE DIVISION.
014700*
014800 A000-HOUSEKEEPING SECTION.
014900*
015000 A020-INIT.
015100*
015200     MOVE 'PC01'                 TO MBCA-PROGRAM-LOCATION.
015300     PERFORM MB70PD-ON-LINE-HOUSEKEEPING
015400                                 THRU MB70PD-OLH-EXIT.
015500*
015600     SET SS95WS-FUNCTION-INITIALIZE
015700                                 TO TRUE.
015800     PERFORM SS95PD-NAP-ROUTINE
015900        THRU SS95PD-NAP-EXIT.
016000*
016100     IF  MBCA-RECEIVE-SCREEN
016200         GO TO C000-RECEIVE-SCREEN.
016300/
016400 B000-SEND-SCREEN SECTION.
016500*
016600*********************************************
016700*    GET CICS STORAGE NEEDED FOR THE MAP    *
016800*********************************************
016900*
017000     MOVE 'SC01'                 TO MBCA-PROGRAM-LOCATION.
017100     PERFORM MB60PD-GETMAIN-FOR-MAP
017200                                 THRU MB60PD-GFM-EXIT.
017300*
017400*******************************************
017500*    INITIALIZE THE STANDARD MAP LINES    *
017600*******************************************
017700*
017800     PERFORM MB60PD-INIT-STD-MAP-LINES
017900                                 THRU MB60PD-ISML-EXIT.
018000*
018100**********************************************************
018200*    READ THE MERCHANT MERCHANT RECORD FOR SUBSEQUENT    *
018300*    DISPLAY.                                            *
018400**********************************************************
018500*
018600     MOVE MBCA-MERCHANT-ORG      TO MBIOWS-MMMM-ORG.
018700     MOVE MBCA-MERCHANT          TO MBIOWS-MMMM-MERCHANT.
018800     MOVE 'FC01'                 TO MBCA-PROGRAM-LOCATION.
018900     SET MBIORO-READ-RANDOM      TO TRUE.
019000     PERFORM MMMMAO-ACCESS       THRU MMMMAO-ACCESS-EXIT.
019100*
019200****************************************************************
019300*    START BROWSE THE PRODUCT STATISTICE FILE                  *
019400****************************************************************
019500*
019600     MOVE 'FC02'                 TO MBCA-PROGRAM-LOCATION.
019700     MOVE MBCA-MERCHANT-ORG      TO MBIOWS-MMPA-ORG.
019800     MOVE MBCA-MERCHANT          TO MBIOWS-MMPA-ACCT.
019900     MOVE 8                      TO MBIOWS-MMPA-REC-TYPE.
020000     MOVE ZERO                   TO MBIOWS-MMPA-MINOR-KEY.
020100     MOVE ZERO                   TO MBIOWS-MMPA-LOGIC-MODULE.
020200     MOVE SS08WS-CICS-FC-ENDFILE TO MBIORO-TEMP-STATUS-1.
020300     SET MBIORO-STARTBR-GTE      TO TRUE.
020400     PERFORM MMPAAO-ACCESS       THRU MMPAAO-ACCESS-EXIT.
020500*
020600     IF SS08WS-RC-FC-ENDFILE
020700         GO TO B900-SEND-MAP.
020800*
020900 B300-READ-LOOP.
021000*
021100****************************************************************
021200*    READNEXT THE MERCHANT RELATIONSHIP FILE                   *
021300****************************************************************
021400*
021500     MOVE 'FC03'                 TO MBCA-PROGRAM-LOCATION.
021600     SET MBIORO-READ-SEQ         TO TRUE.
021700     PERFORM MMPAAO-ACCESS       THRU MMPAAO-ACCESS-EXIT.
021800*
021900     IF  MMPA-TRAILER
022000     OR  MMPA-ALIGN-KEY IS GREATER THAN MMMM-KEY
022100     OR  MMPA-REC-TYPE IS GREATER THAN 8
022200     OR  MMPA-PRODUCT  IS GREATER THAN ZEROS
022300         GO TO B600-MOVE-FIELDS-TO-SCREEN.
022400*
022500     IF  NOT MMPA-REC-ACTIVE
022600         GO TO B300-READ-LOOP.
022700*
022800     MOVE MMPA-LOGIC-MODULE      TO MMTCWS-LOGIC-MODULE.
022900*
023000****************************************************************
023100*    ACCUMULATE FIELD TOTALS                                   *
023200****************************************************************
023300*
023400     EVALUATE TRUE
023500         WHEN MMTCWS-LM-BATCH-HDR-CR
023600              SET WS-HAVE-DATA   TO TRUE
023700              ADD MMPA-AMT (16)  TO WS-CR-DEPOSITS
023800         WHEN MMTCWS-LM-BATCH-HDR-DR
023900              SET WS-HAVE-DATA   TO TRUE
024000              ADD MMPA-AMT (16)  TO WS-DB-WITHDRAWAL
024100         WHEN MMTCWS-LM-VALID-RESV-SETT-CR
024200              SET WS-HAVE-DATA   TO TRUE
024300              ADD MMPA-AMT (16)  TO WS-CR-RESV
024400         WHEN MMTCWS-LM-VALID-RESV-SETT-DR
024500              SET WS-HAVE-DATA   TO TRUE
024600              ADD MMPA-AMT (16)  TO WS-DB-RESV
024700         WHEN MMTCWS-LM-REFUND
024800              SET WS-HAVE-DATA   TO TRUE
024900              ADD MMPA-AMT (16)  TO WS-CR-DISC-REFUND
025000         WHEN MMTCWS-LM-DISCOUNT
025100              SET WS-HAVE-DATA   TO TRUE
025200              ADD MMPA-AMT (16)  TO WS-DB-DISCOUNT
025300         WHEN MMTCWS-LM-PART-CR
025400              SET WS-HAVE-DATA   TO TRUE
025500              ADD MMPA-AMT (16)  TO WS-CR-PART-EARNED
025600         WHEN MMTCWS-LM-PART-DR
025700              SET WS-HAVE-DATA   TO TRUE
025800              ADD MMPA-AMT (16)  TO WS-DB-PART-OWED
025900         WHEN MMTCWS-LM-ADJ-CR
026000              SET WS-HAVE-DATA   TO TRUE
026100              ADD MMPA-AMT (16)  TO WS-CR-ADJ
026200         WHEN MMTCWS-LM-ADJ-DR
026300              SET WS-HAVE-DATA   TO TRUE
026400              ADD MMPA-AMT (16)  TO WS-DB-ADJ
026500         WHEN MMTCWS-LM-RECOVERY-ADJ-CR
026600              SET WS-HAVE-DATA   TO TRUE
026700              ADD MMPA-AMT (16)  TO WS-CR-RCVRY-ADJ
026800         WHEN MMTCWS-LM-RECOVERY-ADJ-DR
026900              SET WS-HAVE-DATA   TO TRUE
027000              ADD MMPA-AMT (16)  TO WS-DB-RCVRY-ADJ
027100         WHEN MMTCWS-LM-SYSTEM-FEES-CR
027200              SET WS-HAVE-DATA   TO TRUE
027300              ADD MMPA-AMT (16)  TO WS-CR-SYS-FEES
027400         WHEN MMTCWS-LM-SYSTEM-FEES-DR
027500              SET WS-HAVE-DATA   TO TRUE
027600              ADD MMPA-AMT (16)  TO WS-DB-SYS-FEES
027700         WHEN MMTCWS-LM-INTCHG-FEES-CR
027800              SET WS-HAVE-DATA   TO TRUE
027900              ADD MMPA-AMT (16)  TO WS-CR-INTCHG-FEES
028000         WHEN MMTCWS-LM-INTCHG-FEES-DR
028100              SET WS-HAVE-DATA   TO TRUE
028200              ADD MMPA-AMT (16)  TO WS-DB-INTCHG-FEES
028300         WHEN MMTCWS-LM-USER-CREDITS
028400              SET WS-HAVE-DATA   TO TRUE
028500              ADD MMPA-AMT (16)  TO WS-CR-USERS-CREDITS
028600         WHEN MMTCWS-LM-USER-FEES-DR
028700              SET WS-HAVE-DATA   TO TRUE
028800              ADD MMPA-AMT (16)  TO WS-DB-USER-FEES
028900*        WHEN MMTCWS-LM-USER-FEES-CR
029000*             SET WS-HAVE-DATA   TO TRUE
029100*             ADD MMPA-AMT (16)  TO WS-CR-USER-FEES
029200*        WHEN MMTCWS-LM-USER-DEBITS
029300*             SET WS-HAVE-DATA   TO TRUE
029400*             ADD MMPA-AMT (16)  TO WS-DB-USERS-DEBITS
029500     END-EVALUATE.
029600*
029700     GO TO B300-READ-LOOP.
029800*
029900*
030000 B600-MOVE-FIELDS-TO-SCREEN.
030100*
030200***********************************************
030300*    MOVE THE TOTAL FIELDS AND THE SETTLEMENT *
030400*    BALANCE FIELD TO THE SCREEN.             *
030500***********************************************
030600*
030700     MOVE MBCA-CURRENCY-CODE     TO SS95WS-CURRENCY-CODE.
030800     MOVE MMMM-ORG               TO IM03-ORG.
030900     MOVE MMMM-MERCHANT          TO IM03-MERCHANT.
031000     MOVE MBCA-MBIM-MERCHANT-NAME
031100                                 TO IM03-MERCH-NME.
031200*
031300     IF  WS-NO-DATA
031400         MOVE ZEROS              TO SS95WS-IN-AMT
031500         PERFORM SS95PD-NAP-ROUTINE
031600                                 THRU SS95PD-NAP-EXIT
031700         MOVE SS95WS-OUT-AMT-L22 TO IM03-DEPOSIT
031800                                    IM03-WITHDRAWAL
031900                                    IM03-RESV-CR
032000                                    IM03-RESV-DB
032100                                    IM03-DISC-REFUND
032200                                    IM03-DISCOUNT
032300                                    IM03-PART-EARNED
032400                                    IM03-PART-OWED
032500                                    IM03-CR-ADJ
032600                                    IM03-DB-ADJ
032700                                    IM03-RCVRY-CR-ADJ
032800                                    IM03-RCVRY-DB-ADJ
032900                                    IM03-SYS-CR-FEE
033000                                    IM03-SYS-DB-FEE
033100                                    IM03-INTCHG-CR-FEE
033200                                    IM03-INTCHG-DB-FEE
033300                                    IM03-USERS-CR
033400                                    IM03-USER-DB-FEE
033500                                    IM03-SETT-BAL.
033600*
033700     MOVE WS-CR-DEPOSITS         TO SS95WS-IN-AMT.
033800     PERFORM SS95PD-NAP-ROUTINE
033900                                 THRU SS95PD-NAP-EXIT.
034000     MOVE SS95WS-OUT-AMT-L22     TO IM03-DEPOSIT.
034100*
034200     MOVE WS-DB-WITHDRAWAL       TO SS95WS-IN-AMT.
034300     PERFORM SS95PD-NAP-ROUTINE
034400                                 THRU SS95PD-NAP-EXIT.
034500     MOVE SS95WS-OUT-AMT-L22     TO IM03-WITHDRAWAL.
034600*
034700     MOVE WS-CR-RESV             TO SS95WS-IN-AMT.
034800     PERFORM SS95PD-NAP-ROUTINE
034900                                 THRU SS95PD-NAP-EXIT.
035000     MOVE SS95WS-OUT-AMT-L22     TO IM03-RESV-CR.
035100*
035200     MOVE WS-DB-RESV             TO SS95WS-IN-AMT.
035300     PERFORM SS95PD-NAP-ROUTINE
035400                                 THRU SS95PD-NAP-EXIT.
035500     MOVE SS95WS-OUT-AMT-L22     TO IM03-RESV-DB.
035600*
035700     MOVE WS-CR-DISC-REFUND      TO SS95WS-IN-AMT.
035800     PERFORM SS95PD-NAP-ROUTINE
035900                                 THRU SS95PD-NAP-EXIT.
036000     MOVE SS95WS-OUT-AMT-L22     TO IM03-DISC-REFUND.
036100*
036200     MOVE WS-DB-DISCOUNT         TO SS95WS-IN-AMT.
036300     PERFORM SS95PD-NAP-ROUTINE
036400                                 THRU SS95PD-NAP-EXIT.
036500     MOVE SS95WS-OUT-AMT-L22     TO IM03-DISCOUNT.
036600*
036700     MOVE WS-CR-PART-EARNED      TO SS95WS-IN-AMT
036800     PERFORM SS95PD-NAP-ROUTINE
036900                                 THRU SS95PD-NAP-EXIT.
037000     MOVE SS95WS-OUT-AMT-L22     TO IM03-PART-EARNED.
037100*
037200     MOVE WS-DB-PART-OWED        TO SS95WS-IN-AMT.
037300     PERFORM SS95PD-NAP-ROUTINE
037400                                 THRU SS95PD-NAP-EXIT.
037500     MOVE SS95WS-OUT-AMT-L22     TO IM03-PART-OWED.
037600*
037700     MOVE WS-CR-ADJ              TO SS95WS-IN-AMT.
037800     PERFORM SS95PD-NAP-ROUTINE
037900                                 THRU SS95PD-NAP-EXIT.
038000     MOVE SS95WS-OUT-AMT-L22     TO IM03-CR-ADJ.
038100*
038200     MOVE WS-DB-ADJ              TO SS95WS-IN-AMT.
038300     PERFORM SS95PD-NAP-ROUTINE
038400                                 THRU SS95PD-NAP-EXIT.
038500     MOVE SS95WS-OUT-AMT-L22     TO IM03-DB-ADJ.
038600*
038700     MOVE WS-CR-RCVRY-ADJ        TO SS95WS-IN-AMT.
038800     PERFORM SS95PD-NAP-ROUTINE
038900                                 THRU SS95PD-NAP-EXIT.
039000     MOVE SS95WS-OUT-AMT-L22     TO IM03-RCVRY-CR-ADJ.
039100*
039200     MOVE WS-DB-RCVRY-ADJ        TO SS95WS-IN-AMT.
039300     PERFORM SS95PD-NAP-ROUTINE
039400                                 THRU SS95PD-NAP-EXIT.
039500     MOVE SS95WS-OUT-AMT-L22     TO IM03-RCVRY-DB-ADJ.
039600*
039700     MOVE WS-CR-SYS-FEES         TO SS95WS-IN-AMT.
039800     PERFORM SS95PD-NAP-ROUTINE
039900                                 THRU SS95PD-NAP-EXIT.
040000     MOVE SS95WS-OUT-AMT-L22     TO IM03-SYS-CR-FEE.
040100*
040200     MOVE WS-DB-SYS-FEES         TO SS95WS-IN-AMT.
040300     PERFORM SS95PD-NAP-ROUTINE
040400                                 THRU SS95PD-NAP-EXIT.
040500     MOVE SS95WS-OUT-AMT-L22     TO IM03-SYS-DB-FEE.
040600*
040700     MOVE WS-CR-INTCHG-FEES      TO SS95WS-IN-AMT.
040800     PERFORM SS95PD-NAP-ROUTINE
040900                                 THRU SS95PD-NAP-EXIT.
041000     MOVE SS95WS-OUT-AMT-L22     TO IM03-INTCHG-CR-FEE.
041100*
041200     MOVE WS-DB-INTCHG-FEES      TO SS95WS-IN-AMT.
041300     PERFORM SS95PD-NAP-ROUTINE
041400                                 THRU SS95PD-NAP-EXIT.
041500     MOVE SS95WS-OUT-AMT-L22     TO IM03-INTCHG-DB-FEE.
041600*
041700     MOVE WS-CR-USERS-CREDITS    TO SS95WS-IN-AMT.
041800     PERFORM SS95PD-NAP-ROUTINE
041900                                 THRU SS95PD-NAP-EXIT.
042000     MOVE SS95WS-OUT-AMT-L22     TO IM03-USERS-CR.
042100*
042200     MOVE WS-DB-USER-FEES        TO SS95WS-IN-AMT.
042300     PERFORM SS95PD-NAP-ROUTINE
042400                                 THRU SS95PD-NAP-EXIT.
042500     MOVE SS95WS-OUT-AMT-L22     TO IM03-USER-DB-FEE.
042600*
042700*    MOVE WS-CR-USER-FEES        TO SS95WS-IN-AMT.
042800*    PERFORM SS95PD-NAP-ROUTINE
042900*                                THRU SS95PD-NAP-EXIT.
043000*    MOVE SS95WS-OUT-AMT-L22     TO IM03-USER-CR-FEE.
043100*
043200*    MOVE WS-DB-USERS-DEBITS     TO SS95WS-IN-AMT.
043300*    PERFORM SS95PD-NAP-ROUTINE
043400*                                THRU SS95PD-NAP-EXIT.
043500*    MOVE SS95WS-OUT-AMT-L22     TO IM03-USERS-DB.
043600     MOVE MMMM-BAL-SETT          TO SS95WS-IN-AMT.
043700     PERFORM SS95PD-NAP-ROUTINE
043800                                 THRU SS95PD-NAP-EXIT.
043900     MOVE SS95WS-OUT-AMT-L22     TO IM03-SETT-BAL.
044000*
044100 B700-END-BROWSE.
044200*
044300****************************************************************
044400*    END BROWSE THE PRODUCT STATISTICE FILE                    *
044500****************************************************************
044600*
044700     MOVE 'FC04'                 TO MBCA-PROGRAM-LOCATION.
044800     SET MBIORO-ENDBR            TO TRUE.
044900     PERFORM MMPAAO-ACCESS       THRU MMPAAO-ACCESS-EXIT.
045000*
045100**********************
045200*    SEND THE MAP    *
045300**********************
045400*
045500 B900-SEND-MAP.
045600*
045700     MOVE SS08WS-CURSOR          TO IM03-ALT-TRANID-L.
045800     COMPUTE MBCA-SCREEN-NBR     =  MBCA-SCREEN-NBR - 50.
045900*
046000     IF  WS-NO-DATA
046100         MOVE 'NO APPLICABLE STATISTICS FOR THIS MERCHANT'
046200                                 TO IM03-ERR-MESSAGE.
046300*
046400***********************************************************
046500*    SET THE CURRENCY CODE, CURRENCY NOD                  *
046600*            PER ITEM NOD, PERCENT NOD.                   *
046700***********************************************************
046800     IF IM03-ERR-MESSAGE IS EQUAL TO SPACES OR LOW-VALUES
046900        PERFORM MB06PD-FORMAT-MESSAGE-LINE
047000                                 THRU MB06PD-FML-EXIT
047100        MOVE SS08WS-FORMATTED-MSG   TO IM03-ERR-MESSAGE
047200     END-IF.
047300*
047400     MOVE 'BM01'                 TO MBCA-PROGRAM-LOCATION.
047500     PERFORM MB60PD-SEND-MAP-WITH-ERASE
047600                                 THRU MB60PD-SMWE-EXIT.
047700*
047800************************
047900*    RETURN TO CICS    *
048000************************
048100*
048200     MOVE 'PC02'                 TO MBCA-PROGRAM-LOCATION.
048300     PERFORM MB70PD-RETURN-TRANS-ID
048400                                 THRU MB70PD-RTI-EXIT.
048500/
048600 C000-RECEIVE-SCREEN SECTION.
048700*
048800******************************************
048900*    THIS SECTION RECEIVES THE SCREEN    *
049000******************************************
049100*
049200     MOVE 'BM02'                 TO MBCA-PROGRAM-LOCATION.
049300     PERFORM MB60PD-RECEIVE-MAP  THRU MB60PD-RM-EXIT.
049400*
049500**************************************************************
049600*    CHECK FOR ANOTHER TRANSACTION ID ENTERED BY THE USER    *
049700**************************************************************
049800*
049900     MOVE 'PC03'                 TO MBCA-PROGRAM-LOCATION.
050000     PERFORM MB60PD-NEW-TRANS-ROUTINE
050100                                 THRU MB60PD-NTR-EXIT.
050200/
050300 F000-SETUP-COMMAREA SECTION.
050400*
050500***************************************************************
050600*  SET UP COMMAREA FIELDS AND TRANSFER TO THE NEXT PROGRAM    *
050700***************************************************************
050800*
050900     MOVE MBCA-EIBAID            TO SS08WS-EIBAID.
051000*
051100     PERFORM MB60PD-EDIT-PAGE-NBR
051200                                 THRU MB60PD-EPN-EXIT.
051300*
051400     IF  SS08WS-VALID-PF-KEY
051500     OR  SS08WS-EIBAID-VALID-PF-KEY
051600         SET MBCA-INITIAL-SCREEN-NBR
051700                                 TO TRUE.
051800*
051900 F090-TRANSFER-XCTL.
052000*
052100     MOVE 'PC04'                 TO MBCA-PROGRAM-LOCATION.
052200     PERFORM MB70PD-XCTL-TO-MBOXCTL
052300                                 THRU MB70PD-XTM-EXIT.
052400/
052500 Z000-COPIED-ROUTINES SECTION.
052600*
052700**********************************
052800*    JUL TO GREG DATE ROUTINE    *
052900**********************************
053000*
053100     COPY SS08PD.
053200/
053300     COPY SS26PD.
053400/
053500     COPY SS27PD.
053600/
053700**********************************
053800*    GREG TO JUL DATE ROUTINE    *
053900**********************************
054000*
054100     COPY SS07PD.
054200/
054300**********************************
054400*    DATE VALIDATION ROUTINE     *
054500**********************************
054600*
054700     COPY SS05PD.
054800/
054900*********************************
055000*    LINE 24 PF KEYS ROUTINE    *
055100*********************************
055200*
055300     COPY SS15PD.
055400/
055500************************************************
055600*    MERCHANT MASTER RECORD ACCESS ROUTINES    *
055700************************************************
055800*
055900     COPY MMMMAO.
056000/
056100***************************************************
056200*    PRODUCT STATISTICS RECORD ACCESS ROUTINES    *
056300***************************************************
056400*
056500     COPY MMPAAO.
056600/
056700***************************************************
056800*    FORMAT NBR AND AMOUNTS BY CURRENCY CODE      *
056900***************************************************
057000*
057100     COPY SS95PDO REPLACING ==:XXCA:== BY ==MBCA==.
057200/
057300*****************************
057400*    ONLINE MAP ROUTINES    *
057500*****************************
057600*
057700     COPY MB60PD REPLACING 'MBMAPXX' BY 'MBIM03 '
057800                           MBMAPXXI BY MBIM03I
057900                           MBMAPXXO BY MBIM03O.
058000/
058100***********************************
058200*    FORMAT MESSAGE LINE BUILDER  *
058300***********************************
058400     COPY MB06PD.
058500/
058600***************************
058700*    ONLINE PROCEDURES    *
058800***************************
058900*
059000     COPY MB70PD.
059100/
059200     COPY SMFTPXO.
