000100 IDENTIFICATION DIVISION.
000200 PROGRAM-ID. MBOIM06.
000201*       RELEASE DATE=08/24/01.        REVISION LEVEL=08.06      * ++++++++
000202***************************************************************** ++++++++
000203*WARNING.  THIS COMPUTER PROGRAM IS PROTECTED BY COPYRIGHT LAW  * ++++++++
000204*AND INTERNATIONAL TREATIES.  UNAUTHORIZED REPRODUCTION OR      * ++++++++
000205*DISTRIBUTION OF THIS PROGRAM, OR ANY PORTION OF IT, MAY RESULT * ++++++++
000206*IN SEVERE CIVIL AND CRIMINAL PENATLIES, AND WILL BE PROSECUTED * ++++++++
000207*TO THE MAXIMUM EXTENT POSSIBLE UNDER THE LAW.                  * ++++++++
000208*COPYRIGHT 1999 PAYSYS INTERNATIONAL, INC.  ALL RIGHTS RESERVED.* ++++++++
000209***************************************************************** ++++++++
000300*****************************************************************
000400*                                                               *
000500*   V - PLUS  M E R C H A N T   B A N K C A R D   S Y S T E M   *
000600*                                                               *
000700*      MBOIM06 - MERCHANT SUMMARY INQUIRY                       *
000800*                SCREEN 06,07,08                                *
000900*                                                               *
001000*              1. TRANSID                                       *
001100*                 B. MBIM                                       *
001200*              2. MAPS USED -                                   *
001300*                 A. MBIM06 (SCREEN 06)                         *
001400*              3. FILES USED -                                  *
001500*                 A. MMFA (FEE ACTIVITY FILE)                   *
001600*                                                               *
001700*****************************************************************
001800*
001900 ENVIRONMENT DIVISION.
002000*
002100 DATA DIVISION.
002200*
002300 WORKING-STORAGE SECTION.
002400*
002500 01  FILLER                  PIC  X(12)      VALUE '** WS-BEG **'.
002600*
002700 01  FILLER                  PIC  X(14)      VALUE
002800     'MISCELLANEOUS:'.
002900*
003000 01  WS-MISCELLANEOUS.
003100*
003200     03  WS-TOTALS.
003300         05  WS-TOTAL-SALES-AMT
003400                             PIC S9(17)      VALUE ZEROES COMP-3. RG800902
003500         05  WS-TOTAL-SALES-NBR
003600                             PIC S9(09)      VALUE ZEROES COMP-3. RG800902
003700         05  WS-TOTAL-RETURNS-AMT
003800                             PIC S9(17)      VALUE ZEROES COMP-3. RG800902
003900         05  WS-TOTAL-RETURNS-NBR
004000                             PIC S9(09)      VALUE ZEROES COMP-3. RG800902
004100         05  WS-TOTAL-DEPOSITS-AMT
004200                             PIC S9(17)      VALUE ZEROES COMP-3. RG800902
004300         05  WS-TOTAL-DEPOSITS-NBR
004400                             PIC S9(09)      VALUE ZEROES COMP-3. RG800902
004410         05  WS-TOTAL-CHGBACKS-AMT                                RG800902
004412                             PIC S9(17)      VALUE ZEROES COMP-3. RG800902
004414         05  WS-TOTAL-CHGBACKS-NBR                                RG800902
004416                             PIC S9(09)      VALUE ZEROES COMP-3. RG800902
004500*
004600 01  FILLER                  PIC  X(17)      VALUE
004700     'PROGRAM SWITCHES:'.
004800*
004900 01  WS-SWITCHES.
005000     05  WS-1ST-TIME-SW      PIC  X(01)      VALUE 'Y'.
005100         88  WS-1ST-TIME                     VALUE 'Y'.
005200         88  WS-NOT-1ST-TIME                 VALUE 'N'.
005300*
005400/
005500 01  FILLER                  PIC  X(29)      VALUE
005600     'I/O REQUEST BLOCK WORK AREAS:'.
005700*
005800     COPY MBIOWS.
005900/
006000 01  FILLER                  PIC  X(18)      VALUE
006100     'I/O REQUEST BLOCK:'.
006200*
006300     COPY MBIORO.
006400/
006500 01  FILLER                  PIC  X(20)      VALUE
006600     'CCS DATE WORK AREAS:'.
006700*
006800     COPY SS01WS.
006900/
007000 01  FILLER                  PIC  X(15)      VALUE
007100     'CCS WORK AREAS:'.
007200*
007300     COPY SS08WS.
007400/
007500     COPY SS00WS.
007600/
007700     COPY SMFTWS.
007800/
007900     COPY SMPTRL REPLACING ==:SMPT:== BY ==SMPT==.
008000/
008100     COPY MB61LK.
008200/
008300 01  FILLER                  PIC  X(28)      VALUE
008400     'DYNAMICALY CALLED SUBROUINES'.
008500*
008600     COPY MB00WS.
008700/
008800 01  FILLER                  PIC  X(36)      VALUE
008900     'FORMAT NBR AND AMTS BY CURRENCY CODE'.
009000*
009100     COPY SS95WS.
009200*
009300 01  FILLER                  PIC  X(12)      VALUE '** WS-END **'.
009400/
009500 LINKAGE SECTION.
009600*
009700 01  DFHCOMMAREA.
009800*
009900     COPY MB60WS.
010000/
010100*********************************
010200*    MERCH SUMMARY MAP          *
010300*********************************
010400*
010500     COPY MBIM06.
010600/
010700**********************************************
010800*    MERCH SUMMARY MAP REDEFINITION          *
010900**********************************************
011000*
011100     COPY MBIM06R.
011200/
011300*********************************************
011400*    FEE ACTIVITY RECORD LAYOUT             *
011500*********************************************
011600*
011700     COPY MMFARL REPLACING ==:MMFA:== BY ==MMFA==.
011800/
011900 PROCEDURE DIVISION.
012000*
012100 A000-HOUSEKEEPING SECTION.
012200*
012300 A020-INIT.
012400*
012500     MOVE 'PC01'                 TO MBCA-PROGRAM-LOCATION.
012600     PERFORM MB70PD-ON-LINE-HOUSEKEEPING
012700                                 THRU MB70PD-OLH-EXIT.
012800*
012900     SET SS95WS-FUNCTION-INITIALIZE
013000                           TO TRUE.
013100     PERFORM SS95PD-NAP-ROUTINE
013200        THRU SS95PD-NAP-EXIT.
013300*
013400     IF  MBCA-RECEIVE-SCREEN
013500         GO TO C000-RECEIVE-SCREEN.
013600/
013700 B000-SEND-SCREEN SECTION.
013800*
013900*********************************************
014000*    GET CICS STORAGE NEEDED FOR THE MAP    *
014100*********************************************
014200*
014300     MOVE 'SC01'                 TO MBCA-PROGRAM-LOCATION.
014400     PERFORM MB60PD-GETMAIN-FOR-MAP
014500                                 THRU MB60PD-GFM-EXIT.
014600*
014700*******************************************
014800*    INITIALIZE THE STANDARD MAP LINES    *
014900*******************************************
015000*
015100     PERFORM MB60PD-INIT-STD-MAP-LINES
015200                                 THRU MB60PD-ISML-EXIT.
015300*
015400****************************************************************
015500*    READ RANDOM THE FEE ACTIVITY FILE                         *
015600****************************************************************
015700*
015800     MOVE 'FC01'                 TO MBCA-PROGRAM-LOCATION.
015900     MOVE MBCA-MERCHANT-ORG      TO MBIOWS-MMFA-ORG.
016000     MOVE MBCA-MERCHANT          TO MBIOWS-MMFA-MERCHANT.
016100     SET MBIORO-READ-RANDOM      TO TRUE.
016200     PERFORM MMFAAO-ACCESS       THRU MMFAAO-ACCESS-EXIT.
016300*
016400     EVALUATE TRUE
016500         WHEN MBCA-SCREEN-NBR IS EQUAL TO 56
016600             SET X-MMFA-WTD-ACT  TO 1
016700         WHEN MBCA-SCREEN-NBR IS EQUAL TO 57
016800             SET X-MMFA-WTD-ACT  TO 3
016900         WHEN MBCA-SCREEN-NBR IS EQUAL TO 58
017000             SET X-MMFA-WTD-ACT  TO 6
017100     END-EVALUATE.
017200*
017300     PERFORM B100-MOVE-FIELDS-TO-SCREEN
017400                                 THRU B199-MFTS-EXIT
017500             VARYING X-IM06-DEP-ACT FROM 1 BY 1
017600             UNTIL X-IM06-DEP-ACT IS GREATER THAN 3.
017700*
017800     GO TO B900-SEND-MAP.
017900*
018000 B100-MOVE-FIELDS-TO-SCREEN.
018100*
018200***********************************************
018300*    MOVE THE TOTAL FIELDS TO THE SCREN       *
018400***********************************************
018500*
018600     MOVE MBCA-CURRENCY-CODE     TO SS95WS-CURRENCY-CODE.
018700*
018800     MOVE MBCA-MERCHANT-ORG      TO IM06-ORG.
018900     MOVE MBCA-MERCHANT          TO IM06-MERCH.
019000     MOVE MBCA-MBIM-MERCHANT-NAME
019100                                 TO IM06-MERCH-NAME.
019200*
019300     IF  X-MMFA-WTD-ACT IS EQUAL TO 1
019400     AND WS-1ST-TIME
019500         PERFORM
019600           VARYING X-MMFA-WTD-ACT FROM 1 BY 1
019700           UNTIL X-MMFA-WTD-ACT IS GREATER THAN 7
019800             COMPUTE WS-TOTAL-SALES-AMT                           RG800902
019900                             = WS-TOTAL-SALES-AMT                 RG800902
019910                             + MMFA-WTD-SALES-AMT                 RG800902
019912                               (X-MMFA-WTD-ACT)                   RG800902
019914                             - MMFA-WTD-SALES-REV-AMT             RG800902
019916                               (X-MMFA-WTD-ACT)                   RG800902
020000             COMPUTE WS-TOTAL-SALES-NBR                           RG800902
020100                             = WS-TOTAL-SALES-NBR                 RG800902
020110                             + MMFA-WTD-SALES-NBR                 RG800902
020112                               (X-MMFA-WTD-ACT)                   RG800902
020114                             - MMFA-WTD-SALES-REV-NBR             RG800902
020116                               (X-MMFA-WTD-ACT)                   RG800902
020200             COMPUTE WS-TOTAL-RETURNS-AMT                         RG800902
020300                             = WS-TOTAL-RETURNS-AMT               RG800902
020310                             + MMFA-WTD-RETURNS-AMT               RG800902
020312                               (X-MMFA-WTD-ACT)                   RG800902
020314                             - MMFA-WTD-RETURNS-REV-AMT           RG800902
020316                               (X-MMFA-WTD-ACT)                   RG800902
020400             COMPUTE WS-TOTAL-RETURNS-NBR                         RG800902
020500                             = WS-TOTAL-RETURNS-NBR               RG800902
020510                             + MMFA-WTD-RETURNS-NBR               RG800902
020512                               (X-MMFA-WTD-ACT)                   RG800902
020514                             - MMFA-WTD-RETURNS-REV-NBR           RG800902
020516                               (X-MMFA-WTD-ACT)                   RG800902
020600             ADD MMFA-WTD-DEPOSITS-AMT (X-MMFA-WTD-ACT)
020700                                 TO WS-TOTAL-DEPOSITS-AMT
020800             ADD MMFA-WTD-DEPOSITS-NBR (X-MMFA-WTD-ACT)
020900                                 TO WS-TOTAL-DEPOSITS-NBR
020910             ADD MMFA-WTD-CHGBACK-AMT (X-MMFA-WTD-ACT)            RG800902
020912                                 TO WS-TOTAL-CHGBACKS-AMT         RG800902
020914             ADD MMFA-WTD-CHGBACK-NBR (X-MMFA-WTD-ACT)            RG800902
020916                                 TO WS-TOTAL-CHGBACKS-NBR         RG800902
021000         END-PERFORM
021100         SET X-MMFA-WTD-ACT      TO 1
021200         SET WS-NOT-1ST-TIME     TO TRUE
021300         MOVE WS-TOTAL-SALES-AMT TO SS95WS-IN-AMT
021400         MOVE WS-TOTAL-SALES-NBR TO SS95WS-IN-NBR
021500         PERFORM SS95PD-NAP-ROUTINE
021600                                 THRU SS95PD-NAP-EXIT
021700         MOVE SS95WS-OUT-AMT-L22 TO IM06-TOT-SALES-AMT
021800                                    (X-IM06-DEP-ACT)
021900         MOVE SS95WS-OUT-NBR-L12 TO IM06-TOT-SALES-NBR
022000                                    (X-IM06-DEP-ACT)
022100*
022200         MOVE WS-TOTAL-RETURNS-AMT TO SS95WS-IN-AMT
022300         MOVE WS-TOTAL-RETURNS-NBR TO SS95WS-IN-NBR
022400         PERFORM SS95PD-NAP-ROUTINE
022500                                 THRU SS95PD-NAP-EXIT
022600         MOVE SS95WS-OUT-AMT-L22 TO IM06-TOT-RETURNS-AMT
022700                                    (X-IM06-DEP-ACT)
022800         MOVE SS95WS-OUT-NBR-L12 TO IM06-TOT-RETURNS-NBR
022900                                    (X-IM06-DEP-ACT)
023000*
023100         MOVE WS-TOTAL-DEPOSITS-AMT TO SS95WS-IN-AMT
023200         MOVE WS-TOTAL-DEPOSITS-NBR TO SS95WS-IN-NBR
023300         PERFORM SS95PD-NAP-ROUTINE
023400                                 THRU SS95PD-NAP-EXIT
023500         MOVE SS95WS-OUT-AMT-L22 TO IM06-TOT-DEPOSITS-AMT
023600                                    (X-IM06-DEP-ACT)
023700         MOVE SS95WS-OUT-NBR-L12 TO IM06-TOT-DEPOSITS-NBR
023800                                    (X-IM06-DEP-ACT)
023810*                                                                 RG800902
023812         MOVE WS-TOTAL-CHGBACKS-AMT TO SS95WS-IN-AMT              RG800902
023814         MOVE WS-TOTAL-CHGBACKS-NBR TO SS95WS-IN-NBR              RG800902
023816         PERFORM SS95PD-NAP-ROUTINE                               RG800902
023818                                 THRU SS95PD-NAP-EXIT             RG800902
023820         MOVE SS95WS-OUT-AMT-L22 TO IM06-TOT-CHGBACKS-AMT         RG800902
023822                                    (X-IM06-DEP-ACT)              RG800902
023824         MOVE SS95WS-OUT-NBR-L12 TO IM06-TOT-CHGBACKS-NBR         RG800902
023826                                    (X-IM06-DEP-ACT)              RG800902
023900         MOVE 'WTD TOTAL         '
024000                                 TO IM06-DESC-DAY-LIT
024100                                    (X-IM06-DEP-ACT)
024200         GO TO B199-MFTS-EXIT.
024300*
024400     MOVE MMFA-WTD-DEPOSITS-AMT (X-MMFA-WTD-ACT)
024500                                 TO SS95WS-IN-AMT.
024600     MOVE MMFA-WTD-DEPOSITS-NBR (X-MMFA-WTD-ACT)
024700                                 TO SS95WS-IN-NBR.
024800     PERFORM SS95PD-NAP-ROUTINE
024900                                 THRU SS95PD-NAP-EXIT.
025000     MOVE SS95WS-OUT-AMT-L22     TO IM06-TOT-DEPOSITS-AMT
025100                                    (X-IM06-DEP-ACT).
025200     MOVE SS95WS-OUT-NBR-L12     TO IM06-TOT-DEPOSITS-NBR
025300                                    (X-IM06-DEP-ACT).
025400*
025500     COMPUTE SS95WS-IN-AMT       = MMFA-WTD-SALES-AMT             RG800902
025600                                   (X-MMFA-WTD-ACT)               RG800902
025610                                 - MMFA-WTD-SALES-REV-AMT         RG800902
025612                                   (X-MMFA-WTD-ACT).              RG800902
025700     COMPUTE SS95WS-IN-NBR       = MMFA-WTD-SALES-NBR             RG800902
025800                                   (X-MMFA-WTD-ACT)               RG800902
025810                                 - MMFA-WTD-SALES-REV-NBR         RG800902
025812                                   (X-MMFA-WTD-ACT).              RG800902
025900     PERFORM SS95PD-NAP-ROUTINE
026000                                 THRU SS95PD-NAP-EXIT.
026100     MOVE SS95WS-OUT-AMT-L22     TO IM06-TOT-SALES-AMT
026200                                    (X-IM06-DEP-ACT).
026300     MOVE SS95WS-OUT-NBR-L12     TO IM06-TOT-SALES-NBR
026400                                    (X-IM06-DEP-ACT).
026500*
026600     COMPUTE SS95WS-IN-AMT       = MMFA-WTD-RETURNS-AMT           RG800902
026700                                   (X-MMFA-WTD-ACT)               RG800902
026710                                 - MMFA-WTD-RETURNS-REV-AMT       RG800902
026712                                   (X-MMFA-WTD-ACT).              RG800902
026800     COMPUTE SS95WS-IN-NBR       = MMFA-WTD-RETURNS-NBR           RG800902
026900                                   (X-MMFA-WTD-ACT)               RG800902
026910                                 - MMFA-WTD-RETURNS-REV-NBR       RG800902
026912                                   (X-MMFA-WTD-ACT).              RG800902
027000     PERFORM SS95PD-NAP-ROUTINE
027100                                 THRU SS95PD-NAP-EXIT.
027200     MOVE SS95WS-OUT-AMT-L22     TO IM06-TOT-RETURNS-AMT
027300                                    (X-IM06-DEP-ACT).
027400     MOVE SS95WS-OUT-NBR-L12     TO IM06-TOT-RETURNS-NBR
027500                                    (X-IM06-DEP-ACT).
027600*
027610*                                                                 RG800902
027612     MOVE MMFA-WTD-CHGBACK-AMT (X-MMFA-WTD-ACT)                   RG800902
027614                                 TO SS95WS-IN-AMT.                RG800902
027616     MOVE MMFA-WTD-CHGBACK-NBR (X-MMFA-WTD-ACT)                   RG800902
027618                                 TO SS95WS-IN-NBR.                RG800902
027620     PERFORM SS95PD-NAP-ROUTINE                                   RG800902
027622                                 THRU SS95PD-NAP-EXIT.            RG800902
027624     MOVE SS95WS-OUT-AMT-L22     TO IM06-TOT-CHGBACKS-AMT         RG800902
027626                                    (X-IM06-DEP-ACT).             RG800902
027628     MOVE SS95WS-OUT-NBR-L12     TO IM06-TOT-CHGBACKS-NBR         RG800902
027630                                    (X-IM06-DEP-ACT).             RG800902
027700     EVALUATE TRUE
027800         WHEN X-MMFA-WTD-ACT IS EQUAL TO 1
027900             MOVE 'DAY ONE           '
028000                                 TO IM06-DESC-DAY-LIT
028100                                    (X-IM06-DEP-ACT)
028200         WHEN X-MMFA-WTD-ACT IS EQUAL TO 2
028300             MOVE 'DAY TWO           '
028400                                 TO IM06-DESC-DAY-LIT
028500                                    (X-IM06-DEP-ACT)
028600         WHEN X-MMFA-WTD-ACT IS EQUAL TO 3
028700             MOVE 'DAY THREE         '
028800                                 TO IM06-DESC-DAY-LIT
028900                                    (X-IM06-DEP-ACT)
029000         WHEN X-MMFA-WTD-ACT IS EQUAL TO 4
029100             MOVE 'DAY FOUR          '
029200                                 TO IM06-DESC-DAY-LIT
029300                                    (X-IM06-DEP-ACT)
029400         WHEN X-MMFA-WTD-ACT IS EQUAL TO 5
029500             MOVE 'DAY FIVE          '
029600                                 TO IM06-DESC-DAY-LIT
029700                                    (X-IM06-DEP-ACT)
029800         WHEN X-MMFA-WTD-ACT IS EQUAL TO 6
029900             MOVE 'DAY SIX           '
030000                                 TO IM06-DESC-DAY-LIT
030100                                    (X-IM06-DEP-ACT)
030200         WHEN X-MMFA-WTD-ACT IS EQUAL TO 7
030300             MOVE 'DAY SEVEN         '
030400                                 TO IM06-DESC-DAY-LIT
030500                                    (X-IM06-DEP-ACT)
030600     END-EVALUATE.
030700*
030800     SET X-MMFA-WTD-ACT          UP BY 1.
030900*
031000     IF  X-MMFA-WTD-ACT IS GREATER THAN 7
031100         SET X-IM06-DEP-ACT      TO 3
031200         MOVE DFHBMDAS           TO IM06-DESC-DAY-LIT-A
031300                                    (X-IM06-DEP-ACT)
031400                                    IM06-DESC-1-LIT-A
031500                                    (X-IM06-DEP-ACT)
031600                                    IM06-TOT-SALES-LIT-A
031700                                    (X-IM06-DEP-ACT)
031800                                    IM06-TOT-SALES-NBR-A
031900                                    (X-IM06-DEP-ACT)
032000                                    IM06-TOT-SALES-AMT-A
032100                                    (X-IM06-DEP-ACT)
032200                                    IM06-TOT-RETURNS-LIT-A
032300                                    (X-IM06-DEP-ACT)
032400                                    IM06-TOT-RETURNS-NBR-A
032500                                    (X-IM06-DEP-ACT)
032600                                    IM06-TOT-RETURNS-AMT-A
032700                                    (X-IM06-DEP-ACT)
032800                                    IM06-TOT-DEPOSITS-LIT-A
032900                                    (X-IM06-DEP-ACT)
033000                                    IM06-TOT-DEPOSITS-NBR-A
033100                                    (X-IM06-DEP-ACT)
033200                                    IM06-TOT-DEPOSITS-AMT-A
033300                                    (X-IM06-DEP-ACT)
033310                                    IM06-TOT-CHGBACKS-LIT-A       RG800902
033312                                    (X-IM06-DEP-ACT)              RG800902
033314                                    IM06-TOT-CHGBACKS-NBR-A       RG800902
033316                                    (X-IM06-DEP-ACT)              RG800902
033318                                    IM06-TOT-CHGBACKS-AMT-A       RG800902
033320                                    (X-IM06-DEP-ACT)              RG800902
033400         SET X-IM06-DEP-ACT      UP BY 1.
033500*
033600 B199-MFTS-EXIT.
033700     EXIT.
033800*
033900**********************
034000*    SEND THE MAP    *
034100**********************
034200*
034300 B900-SEND-MAP.
034400*
034500***********************************************************
034600*    SET THE CURRENCY CODE, CURRENCY NOD                  *
034700*            PER ITEM NOD, PERCENT NOD.                   *
034800***********************************************************
034900     IF IM06-ERR-MESSAGE IS EQUAL TO SPACES OR LOW-VALUES
035000        PERFORM MB06PD-FORMAT-MESSAGE-LINE
035100                                 THRU MB06PD-FML-EXIT
035200        MOVE SS08WS-FORMATTED-MSG   TO IM06-ERR-MESSAGE
035300     END-IF.
035400*
035500     MOVE SS08WS-CURSOR          TO IM06-ALT-TRANID-L.
035600     COMPUTE MBCA-SCREEN-NBR     =  MBCA-SCREEN-NBR - 50.
035700*
035800     MOVE 'BM01'                 TO MBCA-PROGRAM-LOCATION.
035900     PERFORM MB60PD-SEND-MAP-WITH-ERASE
036000                                 THRU MB60PD-SMWE-EXIT.
036100*
036200************************
036300*    RETURN TO CICS    *
036400************************
036500*
036600     MOVE 'PC02'                 TO MBCA-PROGRAM-LOCATION.
036700     PERFORM MB70PD-RETURN-TRANS-ID
036800                                 THRU MB70PD-RTI-EXIT.
036900/
037000 C000-RECEIVE-SCREEN SECTION.
037100*
037200******************************************
037300*    THIS SECTION RECEIVES THE SCREEN    *
037400******************************************
037500*
037600     MOVE 'BM02'                 TO MBCA-PROGRAM-LOCATION.
037700     PERFORM MB60PD-RECEIVE-MAP  THRU MB60PD-RM-EXIT.
037800*
037900**************************************************************
038000*    CHECK FOR ANOTHER TRANSACTION ID ENTERED BY THE USER    *
038100**************************************************************
038200*
038300     MOVE 'PC03'                 TO MBCA-PROGRAM-LOCATION.
038400     PERFORM MB60PD-NEW-TRANS-ROUTINE
038500                                 THRU MB60PD-NTR-EXIT.
038600/
038700 F000-SETUP-COMMAREA SECTION.
038800*
038900***************************************************************
039000*  SET UP COMMAREA FIELDS AND TRANSFER TO THE NEXT PROGRAM    *
039100***************************************************************
039200*
039300     MOVE MBCA-EIBAID            TO SS08WS-EIBAID.
039400*
039500     PERFORM MB60PD-EDIT-PAGE-NBR
039600                                 THRU MB60PD-EPN-EXIT.
039700*
039800     IF  SS08WS-VALID-PF-KEY
039900     OR  SS08WS-EIBAID-VALID-PF-KEY
040000         SET MBCA-INITIAL-SCREEN-NBR
040100                                 TO TRUE.
040200*
040300 F090-TRANSFER-XCTL.
040400*
040500     MOVE 'PC04'                 TO MBCA-PROGRAM-LOCATION.
040600     PERFORM MB70PD-XCTL-TO-MBOXCTL
040700                                 THRU MB70PD-XTM-EXIT.
040800/
040900 Z000-COPIED-ROUTINES SECTION.
041000*
041100**********************************
041200*    JUL TO GREG DATE ROUTINE    *
041300**********************************
041400*
041500     COPY SS08PD.
041600/
041700     COPY SS26PD.
041800/
041900     COPY SS27PD.
042000/
042100**********************************
042200*    GREG TO JUL DATE ROUTINE    *
042300**********************************
042400*
042500     COPY SS07PD.
042600/
042700**********************************
042800*    DATE VALIDATION ROUTINE     *
042900**********************************
043000*
043100     COPY SS05PD.
043200/
043300*********************************
043400*    LINE 24 PF KEYS ROUTINE    *
043500*********************************
043600*
043700     COPY SS15PD.
043800/
043900***************************************************
044000*    FEE ACTIVITY RECORD ACCESS ROUTINES          *
044100***************************************************
044200*
044300     COPY MMFAAO.
044400/
044500***************************************************
044600*    FORMAT NBR AND AMOUNTS BY CURRENCY CODE      *
044700***************************************************
044800*
044900     COPY SS95PDO REPLACING ==:XXCA:== BY ==MBCA==.
045000/
045100*****************************
045200*    ONLINE MAP ROUTINES    *
045300*****************************
045400*
045500     COPY MB60PD REPLACING 'MBMAPXX' BY 'MBIM06 '
045600                           MBMAPXXI BY MBIM06I
045700                           MBMAPXXO BY MBIM06O.
045800/
045900***********************************
046000*    FORMAT MESSAGE LINE BUILDER  *
046100***********************************
046200*
046300     COPY MB06PD.
046400/
046500***************************
046600*    ONLINE PROCEDURES    *
046700***************************
046800*
046900     COPY MB70PD.
047000/
047100     COPY SMFTPXO.
