000100 IDENTIFICATION DIVISION.
000200 PROGRAM-ID. MBOIOAO.
000201*       RELEASE DATE=08/24/01.        REVISION LEVEL=08.06      *
000202*****************************************************************
000203*WARNING.  THIS COMPUTER PROGRAM IS PROTECTED BY COPYRIGHT LAW  *
000204*AND INTERNATIONAL TREATIES.  UNAUTHORIZED REPRODUCTION OR      *
000205*DISTRIBUTION OF THIS PROGRAM, OR ANY PORTION OF IT, MAY RESULT *
000206*IN SEVERE CIVIL AND CRIMINAL PENATLIES, AND WILL BE PROSECUTED *
000207*TO THE MAXIMUM EXTENT POSSIBLE UNDER THE LAW.                  *
000208*COPYRIGHT 1999 PAYSYS INTERNATIONAL, INC.  ALL RIGHTS RESERVED.*
000209*****************************************************************
000300*****************************************************************
000400*                                                               *
000500*   V - PLUS  M E R C H A N T   B A N K C A R D   S Y S T E M   *
000600*                                                               *
000700*       MBOIOAO - MBS COMMON ONLINE ACCESS ROUTINE              *
000800*                                                               *
000900*              1. TRANSID - NONE                                *
001000*              2. MAP USED - NONE                               *
001100*              3. FILES USED -                                  *
001200*                 A. XXXX (XXXXXXXXXXXXXXXX)                    *
001300*                                                               *
001400*    THIS PROGRAM IS THE COMMON ONLINE I/O ROUTINE FOR          *
001500*    MBS. IT IS "CALLED" FROM ALL ONLINE PROGRAMS               *
001600*    THAT ATTEMPT TO ACCESS AN ONLINE DATASET.                  *
001700*                                                               *
001800*    SPECIFIC PARAMETERS MUST BE PASSED DEPENDING ON THE        *
001900*    FUNCTION BEING PERFORMED.                                  *
002000*                                                               *
002100******************************************************************
002200 ENVIRONMENT DIVISION.
002300 CONFIGURATION SECTION.
002400 SOURCE-COMPUTER.            IBM-4341.
002500 OBJECT-COMPUTER.            IBM-4341.
002600*
002700 DATA DIVISION.
002800 WORKING-STORAGE SECTION.
002900*
003000 01  FILLER                      PIC  X(12)  VALUE
003100     '** WS-BEG **'.
003200*
003300 01  WS-WORK-AREAS.
003400*
003500     03  WS-WORK-FIELD           PIC  X(01)  VALUE SPACE.
003600     03  WS-FIXED-LENGTH         PIC S9(08)  BINARY.
003700*
003800************************
003900*    CCS WORK AREAS    *
004000************************
004100*
004200     COPY SS01WS.
004300/
004400     COPY SS08WS.
004500/
004600     COPY SS00WS.
004700/
004800     COPY SMFTWS.
004900/
005000     COPY SMPTRL REPLACING ==:SMPT:== BY ==SMPT==.
005100/
005200     COPY MB61LK.
005300/
005400     COPY MBIOWS.
005500/
005600 01  FILLER                      PIC  X(12)  VALUE
005700     '** WS-END **'.
005800/
005900 LINKAGE SECTION.
006000*
006100 01  DFHCOMMAREA.
006200*
006300     COPY MB60WS.
006400/
006500     COPY MBIORO.
006600/
006700 01  MBOIOAO-RECORD1             PIC  X(16374).
006800*
006900 01  MBOIOAO-RECORD2             PIC  X(16374).
007000*
007100 01  MBOIOAO-RECORD3             PIC  X(16374).
007200*
007300 01  MBOIOAO-RECORD4             PIC  X(16374).
007400*
007500 01  MBOIOAO-RECORD5             PIC  X(16374).
007600*
007700/
007800 PROCEDURE DIVISION USING MBIORO-REQUEST-BLOCK.
007900*
008000 A100-BEGIN.
008100*
008200     SET  SMFTWS-AC-IS-MBS       TO TRUE.
008300     MOVE MBCA-FILE-TABLE        TO SMFTWS-FILE-TABLE.
008400     PERFORM SMFTPXO-FILE-TABLE
008500        THRU SMFTPXO-FT-EXIT.
008600*
008700     MOVE SMFTWS-RECORD          TO MBOFILE-RECORD.
008800     MOVE MBCA-PGM-TABLE-HEADER  TO SMPT-RECORD.
008900*
009000     SET MBIORO-IO-REQUEST-IS-VALID
009100                                 TO TRUE.
009200     MOVE ZEROES                 TO MBIORO-STATUS.
009300     MOVE LOW-VALUES             TO SS08WS-RTN-CODE.
009400*
009500     EXEC CICS IGNORE CONDITION
009600               ERROR
009700          END-EXEC.
009800*
009900     SET X-MBOFILE               TO MBIORO-FILE-NBR.
010000     MOVE MBOFILE-FILE-NAME (X-MBOFILE)
010100                                 TO MBIORO-FILE-NAME.
010200     MOVE MBIORO-FIXED-LENGTH    TO SS08WS-LENGTH
010300                                    SS08WS-FLENGTH.
010400*
010500 MBOIOAO-CONTROL.
010600*
010700     GO TO    MBOIOAO-READ-SEQ
010800              MBOIOAO-READ-RANDOM
010900              MBOIOAO-WRITE
011000              MBOIOAO-REWRITE
011100              MBOIOAO-STARTBR-GTE
011200              MBOIOAO-STARTBR-EQUAL
011300              MBOIOAO-INVALID-REQUEST
011400              MBOIOAO-INVALID-REQUEST
011500              MBOIOAO-INVALID-REQUEST
011600              MBOIOAO-INVALID-REQUEST
011700              MBOIOAO-GETMAIN
011800              MBOIOAO-READ-RANDOM-WITH-UPDT
011900              MBOIOAO-READ-PREV
012000              MBOIOAO-UNLOCK
012100              MBOIOAO-ENDBR
012200              MBOIOAO-FREEMAIN
012300              MBOIOAO-DELETE
012400              MBOIOAO-DELETE-UPDATE
012500              MBOIOAO-INVALID-REQUEST
012600              MBOIOAO-INVALID-REQUEST
012700              DEPENDING ON MBIORO-IO-REQUEST.
012800*
012900 MBOIOAO-INVALID-REQUEST.
013000*
013100     MOVE 'INVALID FILE REQUEST' TO MBCA-ERRR-MSG1.
013200     MOVE LOW-VALUES             TO MBCA-ERRR-EIBFN-CODES.
013300     MOVE LOW-VALUES             TO MBCA-ERRR-EIBRCODE.
013400     SET MBIORO-IO-REQUEST-IS-INVALID
013500                                 TO TRUE.
013600     GO TO MBOIOAO-ABORT.
013700*
013800*****************************
013900*    OBTAIN MAIN STORAGE    *
014000*****************************
014100*
014200 MBOIOAO-GETMAIN.
014300*
014400     PERFORM MBOIOAO-CHECK-GETMAIN
014500                                 THRU MBOIOAO-CG-EXIT.
014600*
014700     GO TO MBOIOAO-ACCESS-RESET.
014800*
014900 MBOIOAO-CHECK-GETMAIN.
015000*
015100     IF  MBIORO-GETMAIN1-COMPLETED
015200         GO TO MBOIOAO-CG-EXIT.
015300*
015400     EXEC CICS GETMAIN
015500               FLENGTH   (SS08WS-FLENGTH)
015600               SET       (ADDRESS OF MBOIOAO-RECORD1)
015700               INITIMG   (SS08WS-SPACE)
015800          END-EXEC.
015900*
016000     MOVE EIBRCODE               TO SS08WS-RTN-CODE.
016100     MOVE SS08WS-RC              TO MBIORO-STATUS.
016200*
016300     IF  SS08WS-RC-FC-VALID-RTN-CODE
016400         NEXT SENTENCE
016500     ELSE
016600         MOVE 'GETMAIN1 FAILURE' TO MBCA-ERRR-MSG1
016700         SET MBIORO-IO-REQUEST-IS-INVALID
016800                                 TO TRUE
016900         GO TO MBOIOAO-ABORT.
017000*
017100     SET MBIORO-POINTER1         TO ADDRESS OF MBOIOAO-RECORD1.
017200     SET MBIORO-GETMAIN1-COMPLETED
017300                                 TO TRUE.
017400*
017500 MBOIOAO-CG-EXIT.
017600     EXIT.
017700*
017800*************************
017900*    RELEASE STORAGE    *
018000*************************
018100*
018200 MBOIOAO-FREEMAIN.
018300*
018400     SET ADDRESS OF MBOIOAO-RECORD1
018500                                 TO MBIORO-POINTER1.
018600*
018700     EXEC CICS FREEMAIN
018800               DATA (MBOIOAO-RECORD1)
018900          END-EXEC.
019000*
019100     PERFORM MBOIOAO-CHECK-STATUS
019200                                 THRU MBOIOAO-CS-EXIT.
019300*
019400     IF  MBIORO-IO-REQUEST-IS-INVALID
019500         MOVE 'FREEMAIN ERROR'   TO MBCA-ERRR-MSG1
019600         GO TO MBOIOAO-ABORT.
019700*
019800     GO TO MBOIOAO-ACCESS-RESET.
019900*
020000***********************
020100*    READ A RECORD    *
020200***********************
020300*
020400 MBOIOAO-READ-SEQ.
020500*
020600     SET ADDRESS OF MBOIOAO-RECORD1
020700                                 TO MBIORO-POINTER1.
020800*
020900     PERFORM MBOIOAO-CHECK-GETMAIN
021000                                 THRU MBOIOAO-CG-EXIT.
021100*
021200     EXEC CICS READNEXT
021300               DATASET    (MBIORO-FILE-NAME)
021400               INTO       (MBOIOAO-RECORD1)
021500               RIDFLD     (MBIORO-RECORD-KEY)
021600               LENGTH     (SS08WS-LENGTH)
021700          END-EXEC.
021800*
021900     PERFORM MBOIOAO-CHECK-STATUS
022000                                 THRU MBOIOAO-CS-EXIT.
022100*
022200     IF  MBIORO-IO-REQUEST-IS-INVALID
022300         MOVE 'READNEXT ERROR'   TO MBCA-ERRR-MSG1
022400         GO TO MBOIOAO-ABORT.
022500*
022600     GO TO MBOIOAO-ACCESS-RESET.
022700*
022800 MBOIOAO-READ-RANDOM.
022900*
023000     SET ADDRESS OF MBOIOAO-RECORD1
023100                                 TO MBIORO-POINTER1.
023200*
023300     PERFORM MBOIOAO-CHECK-GETMAIN
023400                                 THRU MBOIOAO-CG-EXIT.
023500*
023600     EXEC CICS READ
023700               DATASET    (MBIORO-FILE-NAME)
023800               INTO       (MBOIOAO-RECORD1)
023900               RIDFLD     (MBIORO-RECORD-KEY)
024000               LENGTH     (SS08WS-LENGTH)
024100          END-EXEC.
024200*
024300     PERFORM MBOIOAO-CHECK-STATUS
024400                                 THRU MBOIOAO-CS-EXIT.
024500*
024600     IF  MBIORO-IO-REQUEST-IS-INVALID
024700         MOVE 'RANDOM READ ERROR'
024800                                 TO MBCA-ERRR-MSG1
024900         GO TO MBOIOAO-ABORT.
025000*
025100     GO TO MBOIOAO-ACCESS-RESET.
025200*
025300 MBOIOAO-READ-RANDOM-WITH-UPDT.
025400*
025500     SET ADDRESS OF MBOIOAO-RECORD1
025600                                 TO MBIORO-POINTER1.
025700*
025800     PERFORM MBOIOAO-CHECK-GETMAIN
025900                                 THRU MBOIOAO-CG-EXIT.
026000*
026100     EXEC CICS READ
026200               DATASET    (MBIORO-FILE-NAME)
026300               INTO       (MBOIOAO-RECORD1)
026400               RIDFLD     (MBIORO-RECORD-KEY)
026500               LENGTH     (SS08WS-LENGTH)
026600               UPDATE
026700          END-EXEC.
026800*
026900     PERFORM MBOIOAO-CHECK-STATUS
027000                                 THRU MBOIOAO-CS-EXIT.
027100*
027200     IF  MBIORO-IO-REQUEST-IS-INVALID
027300         MOVE 'READ FOR UPDATE ERROR'
027400                                 TO MBCA-ERRR-MSG1
027500         GO TO MBOIOAO-ABORT.
027600*
027700     GO TO MBOIOAO-ACCESS-RESET.
027800*
027900 MBOIOAO-READ-PREV.
028000*
028100     SET ADDRESS OF MBOIOAO-RECORD1
028200                                 TO MBIORO-POINTER1.
028300*
028400     PERFORM MBOIOAO-CHECK-GETMAIN
028500                                 THRU MBOIOAO-CG-EXIT.
028600*
028700     EXEC CICS READPREV
028800               DATASET    (MBIORO-FILE-NAME)
028900               INTO       (MBOIOAO-RECORD1)
029000               RIDFLD     (MBIORO-RECORD-KEY)
029100               LENGTH     (SS08WS-LENGTH)
029200          END-EXEC.
029300*
029400     PERFORM MBOIOAO-CHECK-STATUS
029500                                 THRU MBOIOAO-CS-EXIT.
029600*
029700     IF  MBIORO-IO-REQUEST-IS-INVALID
029800         MOVE 'READPREV ERROR'   TO MBCA-ERRR-MSG1
029900         GO TO MBOIOAO-ABORT.
030000*
030100     GO TO MBOIOAO-ACCESS-RESET.
030200*
030300*********************
030400*    BROWSE FILE    *
030500*********************
030600*
030700 MBOIOAO-STARTBR-GTE.
030800*
030900     EXEC CICS STARTBR
031000               DATASET    (MBIORO-FILE-NAME)
031100               RIDFLD     (MBIORO-RECORD-KEY)
031200               GTEQ
031300          END-EXEC.
031400*
031500     PERFORM MBOIOAO-CHECK-STATUS
031600                                 THRU MBOIOAO-CS-EXIT.
031700*
031800     IF  MBIORO-IO-REQUEST-IS-INVALID
031900         MOVE 'STARTBROWSE ERROR (GTEQ)'
032000                                 TO MBCA-ERRR-MSG1
032100         GO TO MBOIOAO-ABORT.
032200*
032300     GO TO MBOIOAO-ACCESS-RESET.
032400*
032500 MBOIOAO-STARTBR-EQUAL.
032600*
032700     EXEC CICS STARTBR
032800               DATASET    (MBIORO-FILE-NAME)
032900               RIDFLD     (MBIORO-RECORD-KEY)
033000               EQUAL
033100          END-EXEC.
033200*
033300     PERFORM MBOIOAO-CHECK-STATUS
033400                                 THRU MBOIOAO-CS-EXIT.
033500*
033600     IF  MBIORO-IO-REQUEST-IS-INVALID
033700         MOVE 'STARTBROWSE ERROR (EQUAL)'
033800                                 TO MBCA-ERRR-MSG1
033900         GO TO MBOIOAO-ABORT.
034000*
034100     GO TO MBOIOAO-ACCESS-RESET.
034200*
034300 MBOIOAO-ENDBR.
034400*
034500     EXEC CICS ENDBR
034600               DATASET    (MBIORO-FILE-NAME)
034700          END-EXEC.
034800*
034900     PERFORM MBOIOAO-CHECK-STATUS
035000                                 THRU MBOIOAO-CS-EXIT.
035100*
035200     IF  MBIORO-IO-REQUEST-IS-INVALID
035300         MOVE 'ENDBROWSE ERROR'  TO MBCA-ERRR-MSG1
035400         GO TO MBOIOAO-ABORT.
035500*
035600     GO TO MBOIOAO-ACCESS-RESET.
035700*
035800***********************
035900*    WRITE A RECORD   *
036000***********************
036100*
036200 MBOIOAO-WRITE.
036300*
036400     SET ADDRESS OF MBOIOAO-RECORD1
036500                                 TO MBIORO-POINTER1.
036600*
036700     EXEC CICS WRITE
036800               DATASET    (MBIORO-FILE-NAME)
036900               FROM       (MBOIOAO-RECORD1)
037000               RIDFLD     (MBIORO-RECORD-KEY)
037100               LENGTH     (SS08WS-LENGTH)
037200          END-EXEC.
037300*
037400     PERFORM MBOIOAO-CHECK-STATUS
037500                                 THRU MBOIOAO-CS-EXIT.
037600*
037700     IF  MBIORO-IO-REQUEST-IS-INVALID
037800         MOVE 'WRITE ERROR'      TO MBCA-ERRR-MSG1
037900         GO TO MBOIOAO-ABORT.
038000*
038100     GO TO MBOIOAO-ACCESS-RESET.
038200*
038300 MBOIOAO-REWRITE.
038400*
038500     SET ADDRESS OF MBOIOAO-RECORD1
038600                                 TO MBIORO-POINTER1.
038700*
038800     EXEC CICS REWRITE
038900               DATASET    (MBIORO-FILE-NAME)
039000               FROM       (MBOIOAO-RECORD1)
039100               LENGTH     (SS08WS-LENGTH)
039200          END-EXEC.
039300*
039400     PERFORM MBOIOAO-CHECK-STATUS
039500                                 THRU MBOIOAO-CS-EXIT.
039600*
039700     IF  MBIORO-IO-REQUEST-IS-INVALID
039800         MOVE 'REWRITE ERROR'    TO MBCA-ERRR-MSG1
039900         GO TO MBOIOAO-ABORT.
040000*
040100     GO TO MBOIOAO-ACCESS-RESET.
040200*
040300************************
040400*    UNLOCK A RECORD   *
040500************************
040600*
040700 MBOIOAO-UNLOCK.
040800*
040900     EXEC CICS UNLOCK
041000               DATASET    (MBIORO-FILE-NAME)
041100          END-EXEC.
041200*
041300     PERFORM MBOIOAO-CHECK-STATUS
041400                                 THRU MBOIOAO-CS-EXIT.
041500*
041600     IF  MBIORO-IO-REQUEST-IS-INVALID
041700         MOVE 'UNLOCK ERROR'     TO MBCA-ERRR-MSG1
041800         GO TO MBOIOAO-ABORT.
041900*
042000     GO TO MBOIOAO-ACCESS-RESET.
042100*
042200************************
042300*    DELETE A RECORD   *
042400************************
042500*
042600 MBOIOAO-DELETE.
042700*
042800     EXEC CICS DELETE
042900               DATASET    (MBIORO-FILE-NAME)
043000               RIDFLD     (MBIORO-RECORD-KEY)
043100          END-EXEC.
043200*
043300     PERFORM MBOIOAO-CHECK-STATUS
043400                                 THRU MBOIOAO-CS-EXIT.
043500*
043600     IF  MBIORO-IO-REQUEST-IS-INVALID
043700         MOVE 'DELETE RECORD ERROR'
043800                                 TO MBCA-ERRR-MSG1
043900         GO TO MBOIOAO-ABORT.
044000*
044100     GO TO MBOIOAO-ACCESS-RESET.
044200*
044300 MBOIOAO-DELETE-UPDATE.
044400*
044500     EXEC CICS DELETE
044600               DATASET    (MBIORO-FILE-NAME)
044700          END-EXEC.
044800*
044900     PERFORM MBOIOAO-CHECK-STATUS
045000                                 THRU MBOIOAO-CS-EXIT.
045100*
045200     IF  MBIORO-IO-REQUEST-IS-INVALID
045300         MOVE 'DELETE RECORD (UPD) ERROR'
045400                                 TO MBCA-ERRR-MSG1
045500         GO TO MBOIOAO-ABORT.
045600*
045700     GO TO MBOIOAO-ACCESS-RESET.
045800*
045900 MBOIOAO-CHECK-STATUS.
046000*
046100     MOVE EIBRCODE               TO SS08WS-RTN-CODE.
046200*
046300     IF  SS08WS-RC-FC-VALID-RTN-CODE
046400         MOVE ZERO               TO MBIORO-STATUS
046500     ELSE
046600         MOVE SS08WS-RC          TO MBIORO-STATUS.
046700*
046800     IF  MBIORO-STATUS IS EQUAL TO MBIORO-TEMP-STATUS-1
046900     OR  MBIORO-STATUS IS EQUAL TO MBIORO-TEMP-STATUS-2
047000     OR  MBIORO-STATUS IS EQUAL TO MBIORO-PERM-STATUS-1
047100     OR  MBIORO-STATUS IS EQUAL TO MBIORO-PERM-STATUS-2
047200     OR  MBIORO-STATUS IS EQUAL TO MBIORO-PERM-STATUS-3
047300     OR  MBIORO-STATUS IS EQUAL TO MBIORO-PERM-STATUS-4
047400     OR  MBIORO-STATUS IS EQUAL TO MBIORO-PERM-STATUS-5
047500         SET MBIORO-IO-REQUEST-IS-VALID
047600                                 TO TRUE
047700     ELSE
047800         SET MBIORO-IO-REQUEST-IS-INVALID
047900                                 TO TRUE.
048000*
048100     MOVE SS08WS-RC              TO MBIORO-STATUS.
048200*
048300 MBOIOAO-CS-EXIT.
048400     EXIT.
048500*
048600 MBOIOAO-ABORT.
048700*
048800     MOVE 'CONTACT PROGRAMMING DEPARTMENT'
048900                                 TO MBCA-ERRR-MSG2.
049000*
049100     IF  SS08WS-RC-FC-NOTOPEN
049200         MOVE '***    T H E   F I L E S   A R E     ***'
049300                                 TO MBCA-ERRR-MSG1
049400         MOVE '***    N O T   O P E N E D ! ! ! !   ***'
049500                                 TO MBCA-ERRR-MSG2.
049600*
049700     MOVE MBIORO-IO-REQUEST      TO MBCA-ERRR-IO-REQUEST.
049800     MOVE MBIORO-FILE-NAME       TO MBCA-ERRR-EIBDS.
049900     MOVE EIBFN                  TO MBCA-ERRR-EIBFN-CODES.
050000     MOVE MBCA-PROGRAM-ID        TO MBCA-ERRR-BAD-PROGRAM.
050100     MOVE MBCA-TRANS-ID          TO MBCA-ERRR-BAD-TRANSID.
050200     SET MBCA-ERROR-MSGS-PROVIDED
050300                                 TO TRUE.
050400*
050500 MBOIOAO-ACCESS-RESET.
050600*
050700     MOVE ZERO                   TO MBIORO-TEMP-STATUS-1.
050800     MOVE ZERO                   TO MBIORO-TEMP-STATUS-2.
050900     MOVE EIBRCODE               TO MBCA-ERRR-EIBRCODE.
051000*
051100 MBOIOAO-GOBACK.
051200*
051300     GOBACK.
051400/
051500     COPY MB70PD.
051600/
051700     COPY SMFTPXO.
