000100 IDENTIFICATION DIVISION.
000200 PROGRAM-ID. MBOIS01.
000201*       RELEASE DATE=08/24/01.        REVISION LEVEL=08.06      *
000202*****************************************************************
000203*WARNING.  THIS COMPUTER PROGRAM IS PROTECTED BY COPYRIGHT LAW  *
000204*AND INTERNATIONAL TREATIES.  UNAUTHORIZED REPRODUCTION OR      *
000205*DISTRIBUTION OF THIS PROGRAM, OR ANY PORTION OF IT, MAY RESULT *
000206*IN SEVERE CIVIL AND CRIMINAL PENATLIES, AND WILL BE PROSECUTED *
000207*TO THE MAXIMUM EXTENT POSSIBLE UNDER THE LAW.                  *
000208*COPYRIGHT 1999 PAYSYS INTERNATIONAL, INC.  ALL RIGHTS RESERVED.*
000209*****************************************************************
000300*****************************************************************
000400*                                                               *
000500*   V - 2 1   M E R C H A N T   B A N K C A R D   S Y S T E M   *
000600*                                                               *
000700*      MBOIS01 - ON-LINE STATEMENT                              *
000800*                SCREEN 01                                      *
000900*                                                               *
001000*              1. TRANSID                                       *
001100*                 A. MBIS                                       *
001200*              2. MAPS USED -                                   *
001300*                 A. MBIS01 (SCREEN 01)                         *
001400*              3. FILES USED -                                  *
001500*                 A. MMMM (MERCHANT MASTER FILE)                *
001600*                 B. MMS1 (STATEMENT FILE 1)                    *
001700*                 C. MMS2 (STATEMENT FILE 2)                    *
001800*                                                               *
001900*****************************************************************
002000*
002100 ENVIRONMENT DIVISION.
002200*
002300 DATA DIVISION.
002400*
002500 WORKING-STORAGE SECTION.
002600*
002700 01  FILLER                  PIC  X(12)      VALUE '** WS-BEG **'.
002800*
002900 01  FILLER                  PIC  X(14)      VALUE
003000     'MISCELLANEOUS:'.
003100*
003200*
003300 01  WS-TEMP-STORAGE-RECORD.
003400     03  WS-TS-ARRAY                         OCCURS 40 TIMES
003500                                             INDEXED BY
003600                                             X-WS-TS-ARRAY.
003700         05  WS-TS-ARRAY-ITEM.
003800             07  WS-TS-STMT-ID-CODE
003900                             PIC S9(08)      COMP.
004000             07  WS-TS-DATE  PIC  X(10).
004100                 88  WS-TS-NO-DATA           VALUE SPACES.
004200             07  WS-TS-FILE  PIC  X(01).
004300*
004400 01  WS-TEMP-AREAS.
004500     03  WS-TEMP-STORAGE-NBR PIC S9(4)       COMP
004600                                             VALUE +0001.
004700     03  WS-MBIS-QUEUE-ID-NAME.
004800         05  WS-MBIS-TERMINAL-ID
004900                             PIC X(4)        VALUE SPACES.
005000         05  WS-MBIS-QUEUE-LIT
005100                             PIC X(4)        VALUE 'IS01'.
005200*
005300 01  WS-MISC-AREAS.
005400*
005500     03  WS-WORK-AREAS.
005600         05  WS-HOT-INDEX    PIC S9(04)      COMP VALUE ZERO.
005700         05  WS-READ-REC-000 PIC  X(04)      VALUE '0000'.
005800         05  WS-STMT-SW      PIC  X(01)      VALUE 'N'.
005900             88  WS-STMT-SEL-MADE            VALUE 'Y'.
006000             88  WS-STMT-SEL-NOT-MADE        VALUE 'N'.
006100     03  WS-DISP-MERCH-NA    PIC X(01)       VALUE 'M'.
006200         88 WS-DISP-MERCH-ADDR               VALUE 'M'.
006300         88 WS-DISP-STMT-ADDR                VALUE 'S'.
006400*
006500 01  FILLER                  PIC  X(17)      VALUE
006600     'PROGRAM SWITCHES:'.
006700*
006800/
006900 01  FILLER                  PIC  X(22)      VALUE
007000     'STATEMENT WORK AREAS: '.
007100*
007200     COPY MB50WS.
007300/
007400 01  FILLER                  PIC  X(29)      VALUE
007500     'I/O REQUEST BLOCK WORK AREAS:'.
007600*
007700     COPY MBIOWS.
007800/
007900 01  FILLER                  PIC  X(18)      VALUE
008000     'I/O REQUEST BLOCK:'.
008100*
008200     COPY MBIORO.
008300/
008400 01  FILLER                  PIC  X(20)      VALUE
008500     'CCS DATE WORK AREAS:'.
008600*
008700     COPY SS01WS.
008800/
008900 01  FILLER                  PIC  X(15)      VALUE
009000     'CCS WORK AREAS:'.
009100*
009200     COPY SS08WS.
009300/
009400     COPY SS00WS.
009500/
009600     COPY SMFTWS.
009700/
009800     COPY SMPTRL REPLACING ==:SMPT:== BY ==SMPT==.
009900/
010000     COPY MB61LK.
010100/
010200     COPY SS12WS.
010300*
010400 01  FILLER                  PIC  X(12)      VALUE '** WS-END **'.
010500/
010600 LINKAGE SECTION.
010700*
010800 01  DFHCOMMAREA.
010900     COPY MB60WS.
011000/
011100*********************************
011200*    ON-LINE STATEMENT MAP      *
011300*********************************
011400*
011500     COPY MBIS01.
011600/
011700**********************************************
011800*    ON-LINE STATEMENT MAP REDEFINITION      *
011900**********************************************
012000*
012100     COPY MBIS01R.
012200/
012300******************************************
012400*    MERCHANT MASTER RECORD LAYOUT       *
012500******************************************
012600*
012700     COPY MMMMRL.
012800/
012900******************************************
013000*    CHAIN MASTER RECORD LAYOUT          *
013100******************************************
013200*
013300     COPY MMRCRL.
013400/
013500*********************************************
013600*    STATEMENT FILE 1 RECORD LAYOUT         *
013700*********************************************
013800*
013900     COPY MMS1RL REPLACING ==:MMS1:== BY ==MMS1==.
014000/
014100*********************************************
014200*    STATEMENT FILE 2 RECORD LAYOUT         *
014300*********************************************
014400*
014500     COPY MMS1RL REPLACING ==:MMS1:== BY ==MMS2==.
014600/
014700 PROCEDURE DIVISION.
014800*
014900 A000-HOUSEKEEPING SECTION.
015000*
015100 A020-INIT.
015200*
015300     SET SS12WS-ENVIRONMENT-ON-LINE
015400                                 TO TRUE.
015500     SET SS12WS-FUNCTION-INITIALIZE
015600                                 TO TRUE.
015700     PERFORM SS12PD-FORMAT-DEMOGRAPHICS
015800        THRU SS12PD-FD-EXIT.
015900*
016000     MOVE 'PC01'                 TO MBCA-PROGRAM-LOCATION.
016100     PERFORM MB70PD-ON-LINE-HOUSEKEEPING
016200        THRU MB70PD-OLH-EXIT.
016300*
016400     MOVE MBCA-TERMINAL-ID       TO WS-MBIS-TERMINAL-ID.
016500     MOVE 'IS01'                 TO WS-MBIS-QUEUE-LIT.
016600*
016700     MOVE 'FC20'                 TO MBCA-PROGRAM-LOCATION.
016800     SET MBIORO-GETMAIN          TO TRUE.
016900     PERFORM MMS1AO-ACCESS
017000        THRU MMS1AO-ACCESS-EXIT.
017100*
017200     MOVE 'FC21'                 TO MBCA-PROGRAM-LOCATION.
017300     SET MBIORO-GETMAIN          TO TRUE.
017400     PERFORM MMS2AO-ACCESS
017500        THRU MMS2AO-ACCESS-EXIT.
017600*
017700     IF  MBCA-RECEIVE-SCREEN
017800         GO TO C000-RECEIVE-SCREEN
017900     END-IF.
018000/
018100 B000-BUILD-SCREEN.
018200*
018300*********************************************
018400*    GET CICS STORAGE NEEDED FOR THE MAP    *
018500*********************************************
018600*
018700     MOVE 'SC01'                 TO MBCA-PROGRAM-LOCATION.
018800     PERFORM MB60PD-GETMAIN-FOR-MAP
018900        THRU MB60PD-GFM-EXIT.
019000*
019100 B050-FORMAT-SCREEN.
019200*
019300*******************************************
019400*    INITIALIZE THE STANDARD MAP LINES    *
019500*******************************************
019600*
019700     PERFORM MB60PD-INIT-STD-MAP-LINES
019800        THRU MB60PD-ISML-EXIT.
019900*
020000**********************************************************
020100*    READ THE MERCHANT OR CHAIN RECORD                   *
020200**********************************************************
020300*
020400     MOVE MBCA-ORG               TO IS01-ORG.
020500     MOVE MBCA-MERCHANT          TO IS01-MERCHANT.
020600*
020700     IF  MBCA-MBIS-MERCH
020800         PERFORM Y200-FORMAT-MERCH
020900            THRU Y299-FM-EXIT
021000     ELSE
021100         MOVE 'CHAIN'            TO IS01-MERCHANT-LIT
021200         PERFORM Y300-FORMAT-CHAIN
021300            THRU Y399-FC-EXIT
021400     END-IF.
021500*
021600     IF  MBCA-MBIS-P1-TS-BUILT
021700         CONTINUE
021800     ELSE
021900         MOVE ZERO               TO WS-HOT-INDEX
022000         MOVE 1                  TO MBCA-MBIS-P1-CURR-PAGE
022100         MOVE 1                  TO MBCA-MBIS-P1-TOT-PAGES
022200         SET X-WS-TS-ARRAY       TO 1
022300         MOVE SPACES             TO WS-TEMP-STORAGE-RECORD
022400         PERFORM Y700-DELETEQ-TS
022500            THRU Y799-DTS-EXIT
022600         SET  MBCA-MBIS-MMS1     TO TRUE
022700         PERFORM Y500-BUILD-TEMP-STORAGE
022800            THRU Y599-BTS-EXIT
022900         SET  MBCA-MBIS-P1-TS-BUILT
023000                                 TO TRUE
023100     END-IF.
023200*
023300     PERFORM Y600-BUILD-TEXT-LINES
023400        THRU Y699-BTL-EXIT.
023500*
023600     IF  WS-HOT-INDEX IS GREATER THAN ZERO
023700         SET  X-IS01-SD          TO WS-HOT-INDEX
023800         MOVE 'X'                TO IS01-SEL(X-IS01-SD)
023900         MOVE DFHBMFSE           TO IS01-SEL-A(X-IS01-SD)
024000     END-IF.
024100*
024200     MOVE ZERO                   TO WS-HOT-INDEX.
024300*
024400     MOVE 01                     TO MBCA-SCREEN-NBR.
024500     MOVE 'BM02'                 TO MBCA-PROGRAM-LOCATION.
024600     PERFORM MB60PD-INIT-STD-MAP-LINES
024700        THRU MB60PD-ISML-EXIT.
024800*
024900******************************************************************
025000*    THIS PROGRAM WILL DO SPECIAL FUNCTIONS WITH PF KEYS.        *
025100*    SO WE NEED TO BUILD LINE TO DISPLAY PFKEY FUNCTIONS.        *
025200*    PF1 = NORMAL                                                *
025300*    PF2 = NORMAL                                                *
025400*    PF3 = TOP OF FILE                                           *
025500*    PF4 = BOTTOM OF FILE                                        *
025600*    PF5 = PAGE SCREEN BACKWARDS                                 *
025700*    PF6 = PAGE SCREEN FORWARDS                                  *
025800******************************************************************
025900*
026000     MOVE '*TOP*'           TO SS08WS-LINE-24-PF-KEY-FUNC (3).
026100     MOVE 'RESV'            TO MBCA-PGMX-PF-TRANS-ID (3).
026200     MOVE '*BOT*'           TO SS08WS-LINE-24-PF-KEY-FUNC (4).
026300     MOVE 'RESV'            TO MBCA-PGMX-PF-TRANS-ID (4).
026400     MOVE '*BWD*'           TO SS08WS-LINE-24-PF-KEY-FUNC (5).
026500     MOVE 'RESV'            TO MBCA-PGMX-PF-TRANS-ID (5).
026600     MOVE '*FWD*'           TO SS08WS-LINE-24-PF-KEY-FUNC (6).
026700     MOVE 'RESV'            TO MBCA-PGMX-PF-TRANS-ID (6).
026800     MOVE SS08WS-LINE-24    TO TTN2401I.
026900     MOVE DFHBMABF          TO TTN2401A.
027000     MOVE DFHBMASK          TO TTN0162A.
027100*
027200**********************
027300*    SEND THE MAP    *
027400**********************
027500*
027600     MOVE 'BM01'                 TO MBCA-PROGRAM-LOCATION.
027700     PERFORM MB60PD-SEND-MAP-WITH-ERASE
027800        THRU MB60PD-SMWE-EXIT.
027900*
028000************************
028100*    RETURN TO CICS    *
028200************************
028300*
028400     MOVE 'PC02'                 TO MBCA-PROGRAM-LOCATION.
028500     PERFORM MB70PD-RETURN-TRANS-ID
028600        THRU MB70PD-RTI-EXIT.
028700/
028800 C000-RECEIVE-SCREEN SECTION.
028900*
029000******************************************
029100*    THIS SECTION RECEIVES THE SCREEN    *
029200******************************************
029300*
029400     MOVE 'BM02'                 TO MBCA-PROGRAM-LOCATION.
029500     PERFORM MB60PD-RECEIVE-MAP
029600        THRU MB60PD-RM-EXIT.
029700*
029800**************************************************************
029900*    CHECK FOR ANOTHER TRANSACTION ID ENTERED BY THE USER    *
030000**************************************************************
030100*
030200     MOVE 'PC03'                 TO MBCA-PROGRAM-LOCATION.
030300     PERFORM MB60PD-NEW-TRANS-ROUTINE
030400        THRU MB60PD-NTR-EXIT.
030500*
030600**************************************************************
030700*    CHECK SCREEN FOR A SELECTED STATEMENT                   *
030800**************************************************************
030900*
031000     MOVE MBCA-ORG               TO IS01-ORG.
031100     MOVE MBCA-MERCHANT          TO IS01-MERCHANT.
031200*
031300     IF  MBCA-MBIS-MERCH
031400         PERFORM Y200-FORMAT-MERCH
031500            THRU Y299-FM-EXIT
031600     ELSE
031700         MOVE 'CHAIN'            TO IS01-MERCHANT-LIT
031800         PERFORM Y300-FORMAT-CHAIN
031900            THRU Y399-FC-EXIT
032000     END-IF.
032100*
032200     PERFORM Y800-READQ-TS
032300        THRU Y899-RTS-EXIT.
032400*
032500     SET  X-IS01-SD              TO 1.
032600     SET  WS-STMT-SEL-NOT-MADE   TO TRUE.
032700*
032800     PERFORM
032900         UNTIL X-IS01-SD    IS GREATER THAN 40
033000            OR WS-HOT-INDEX IS GREATER THAN ZERO
033100            OR WS-STMT-SEL-MADE
033200         SET  X-WS-TS-ARRAY      TO X-IS01-SD
033300         EVALUATE TRUE
033400             WHEN WS-TS-NO-DATA(X-WS-TS-ARRAY)
033500                 MOVE DFHBMDAS   TO IS01-SEL-LP-A(X-IS01-SD)
033600                 MOVE DFHBMDAS   TO IS01-SEL-A   (X-IS01-SD)
033700                 MOVE DFHBMDAS   TO IS01-SEL-RP-A(X-IS01-SD)
033800                 MOVE DFHBMDAS   TO IS01-STMT-DATE-A(X-IS01-SD)
033900             WHEN (IS01-SEL-L(X-IS01-SD) IS GREATER THAN ZERO
034000              AND  IS01-SEL  (X-IS01-SD) IS EQUAL TO 'X')
034100                 MOVE DFHBMASF   TO IS01-SEL-LP-A(X-IS01-SD)
034200                 MOVE DFHBMFSE   TO IS01-SEL-A   (X-IS01-SD)
034300                 MOVE DFHBMASF   TO IS01-SEL-RP-A(X-IS01-SD)
034400                 MOVE DFHBMASF   TO IS01-STMT-DATE-A(X-IS01-SD)
034500                 MOVE WS-TS-DATE(X-WS-TS-ARRAY)
034600                                 TO MBCA-MBIS-STMT-DATE
034700                 MOVE WS-TS-STMT-ID-CODE(X-WS-TS-ARRAY)
034800                                 TO MBCA-MBIS-STMT-ID-CODE
034900                 MOVE WS-TS-FILE(X-WS-TS-ARRAY)
035000                                 TO MBCA-MBIS-FILE-NUMBER
035100                 SET  WS-STMT-SEL-MADE
035200                                 TO TRUE
035300             WHEN (IS01-SEL-L(X-IS01-SD) IS GREATER THAN ZERO
035400              AND  IS01-SEL  (X-IS01-SD) IS EQUAL TO 'D')
035500                 MOVE DFHBMASF   TO IS01-SEL-LP-A(X-IS01-SD)
035600                 MOVE DFHBMFSE   TO IS01-SEL-A   (X-IS01-SD)
035700                 MOVE DFHBMASF   TO IS01-SEL-RP-A(X-IS01-SD)
035800                 MOVE DFHBMASF   TO IS01-STMT-DATE-A(X-IS01-SD)
035900                 MOVE 'X'        TO IS01-SEL        (X-IS01-SD)
036000                 MOVE WS-TS-STMT-ID-CODE(X-WS-TS-ARRAY)
036100                                 TO MBCA-MBIS-STMT-ID-CODE
036200                 MOVE WS-TS-FILE(X-WS-TS-ARRAY)
036300                                 TO MBCA-MBIS-FILE-NUMBER
036400                 MOVE SS08WS-CURSOR
036500                                 TO IS01-SEL-L(X-IS01-SD)
036600                 SET  WS-DISP-STMT-ADDR
036700                                 TO TRUE
036800                 SET  WS-HOT-INDEX
036900                                 TO X-IS01-SD
037000             WHEN IS01-SEL-L(X-IS01-SD) IS GREATER THAN ZERO
037100                 MOVE DFHBMABF   TO IS01-SEL-LP-A(X-IS01-SD)
037200                 MOVE DFHBMUBF   TO IS01-SEL-A   (X-IS01-SD)
037300                 MOVE DFHBMABF   TO IS01-SEL-RP-A(X-IS01-SD)
037400                 MOVE DFHBMABF   TO IS01-STMT-DATE-A(X-IS01-SD)
037500             WHEN OTHER
037600                 MOVE DFHBMASF   TO IS01-SEL-LP-A(X-IS01-SD)
037700                 MOVE DFHBMUNP   TO IS01-SEL-A   (X-IS01-SD)
037800                 MOVE DFHBMASF   TO IS01-SEL-RP-A(X-IS01-SD)
037900                 MOVE DFHBMASF   TO IS01-STMT-DATE-A(X-IS01-SD)
038000         END-EVALUATE
038100         SET  X-IS01-SD          UP BY 1
038200     END-PERFORM.
038300*
038400 D000-RETURN-SCREEN.
038500*
038600     MOVE MBCA-EIBAID            TO SS08WS-EIBAID.
038700     PERFORM MB60PD-EDIT-PAGE-NBR
038800        THRU MB60PD-EPN-EXIT.
038900     MOVE 51                     TO MBCA-SCREEN-NBR.
039000*
039100     IF  WS-STMT-SEL-MADE
039200         PERFORM Y000-FORMAT-TITLES
039300            THRU Y099-FT-EXIT
039400         MOVE 52                 TO MBCA-SCREEN-NBR
039500         GO TO F000-SETUP-COMMAREA
039600     END-IF.
039700*
039800     IF  SS08WS-VALID-PF-KEY
039900     OR  SS08WS-EIBAID-VALID-PF-KEY
040000         SET MBCA-INITIAL-SCREEN-NBR
040100                                 TO TRUE
040200     END-IF.
040300*
040400     IF  SS08WS-VALID-PF6
040500     OR  SS08WS-EIBAID-VALID-PF6
040600         ADD 1                   TO MBCA-MBIS-P1-CURR-PAGE
040700         MOVE 51                 TO MBCA-SCREEN-NBR
040800         IF  MBCA-MBIS-P1-CURR-PAGE IS GREATER THAN
040900                                    MBCA-MBIS-P1-TOT-PAGES
041000             MOVE MBCA-MBIS-P1-TOT-PAGES
041100                                 TO MBCA-MBIS-P1-CURR-PAGE
041200         END-IF
041300         GO TO F000-SETUP-COMMAREA
041400     END-IF.
041500*
041600     IF  SS08WS-VALID-PF5
041700     OR  SS08WS-EIBAID-VALID-PF5
041800         SUBTRACT 1            FROM MBCA-MBIS-P1-CURR-PAGE
041900         MOVE 51                 TO MBCA-SCREEN-NBR
042000         IF  MBCA-MBIS-P1-CURR-PAGE IS LESS THAN 1
042100             MOVE 1              TO MBCA-MBIS-P1-CURR-PAGE
042200         END-IF
042300         GO TO F000-SETUP-COMMAREA
042400     END-IF.
042500*
042600     IF  SS08WS-VALID-PF4 OR
042700         SS08WS-EIBAID-VALID-PF4
042800         MOVE 51                 TO MBCA-SCREEN-NBR
042900         MOVE MBCA-MBIS-P1-TOT-PAGES
043000                                 TO MBCA-MBIS-P1-CURR-PAGE
043100         GO TO F000-SETUP-COMMAREA
043200     END-IF.
043300*
043400     IF  SS08WS-VALID-PF3 OR
043500         SS08WS-EIBAID-VALID-PF3
043600         MOVE 51                 TO MBCA-SCREEN-NBR
043700         MOVE 1                  TO MBCA-MBIS-P1-CURR-PAGE
043800         GO TO F000-SETUP-COMMAREA
043900     END-IF.
044000*
044100     IF  SS08WS-VALID-PF2
044200     OR  SS08WS-EIBAID-VALID-PF2
044300     OR  SS08WS-VALID-PF1
044400     OR  SS08WS-EIBAID-VALID-PF1
044500         PERFORM Y700-DELETEQ-TS
044600            THRU Y799-DTS-EXIT
044700         GO TO F000-SETUP-COMMAREA
044800     END-IF.
044900*
045000     IF  WS-HOT-INDEX IS GREATER THAN ZERO
045100         GO TO B050-FORMAT-SCREEN
045200     END-IF.
045300*
045400     GO TO F000-SETUP-COMMAREA.
045500/
045600 F000-SETUP-COMMAREA SECTION.
045700*
045800***************************************************************
045900*  SET UP COMMAREA FIELDS AND TRANSFER TO THE NEXT PROGRAM    *
046000***************************************************************
046100*
046200     MOVE DFHBMASK               TO TTN0162A.
046300*
046400 F090-TRANSFER-XCTL.
046500*
046600     MOVE 'PC05'                 TO MBCA-PROGRAM-LOCATION.
046700     PERFORM MB70PD-XCTL-TO-MBOXCTL
046800        THRU MB70PD-XTM-EXIT.
046900/
047000 Y000-PERFORMED-ROUTINES SECTION.
047100*
047200 Y000-FORMAT-TITLES.
047300*
047400     PERFORM
047500         VARYING X-MBCA-TITLE FROM 1 BY 1
047600         UNTIL X-MBCA-TITLE IS GREATER THAN 6
047700             MOVE SPACES TO MBCA-MBIS-POS-DEV-TITLE(X-MBCA-TITLE)
047800     END-PERFORM.
047900*
048000**************************************************************
048100*    IF STATEMENT SELECTED IS ON THE MMS2 FILE THE MMS2      *
048200*    RECORD IS MOVED TO THE MMS1 RECORD FOR PROCESSING.      *
048300**************************************************************
048400*
048500     IF  MBCA-MBIS-MMS1
048600         MOVE MBCA-ORG-MERCHANT  TO MBIOWS-MMS1-ORG-MERCHANT
048700         MOVE MBCA-MBIS-REC-TYPE TO MBIOWS-MMS1-KEY-TYPE
048800         MOVE MBCA-MBIS-STMT-ID-CODE
048900                                 TO MBIOWS-MMS1-STMT-ID-CODE
049000         MOVE WS-READ-REC-000    TO MBIOWS-MMS1-REC-ID
049100         MOVE SS08WS-CICS-FC-NOTFND
049200                                 TO MBIORO-TEMP-STATUS-1
049300         MOVE 'FC07'             TO MBCA-PROGRAM-LOCATION
049400         SET MBIORO-READ-RANDOM  TO TRUE
049500         PERFORM MMS1AO-ACCESS
049600            THRU MMS1AO-ACCESS-EXIT
049700     ELSE
049800         MOVE MBCA-ORG-MERCHANT  TO MBIOWS-MMS2-ORG-MERCHANT
049900         MOVE MBCA-MBIS-REC-TYPE TO MBIOWS-MMS2-KEY-TYPE
050000         MOVE MBCA-MBIS-STMT-ID-CODE
050100                                 TO MBIOWS-MMS2-STMT-ID-CODE
050200         MOVE WS-READ-REC-000    TO MBIOWS-MMS2-REC-ID
050300         MOVE SS08WS-CICS-FC-NOTFND
050400                                 TO MBIORO-TEMP-STATUS-1
050500         MOVE 'FC08'             TO MBCA-PROGRAM-LOCATION
050600         SET MBIORO-READ-RANDOM  TO TRUE
050700         PERFORM MMS2AO-ACCESS
050800            THRU MMS2AO-ACCESS-EXIT
050900         MOVE MMS2-RECORD        TO MMS1-RECORD
051000     END-IF.
051100*
051200     IF  SS08WS-RC-FC-NOTFND
051300         GO TO Y099-FT-EXIT
051400     END-IF.
051500*
051600     MOVE MMS1-REC-TYPE-DATA     TO MB50WS-REC-ID-0000.
051700     MOVE MB50WS-R0000-NAME-ADDR (2)
051800                                 TO IS01-ADDR1.
051900     MOVE MB50WS-R0000-NAME-ADDR (3)
052000                                 TO IS01-ADDR2.
052100     MOVE MB50WS-R0000-NAME-ADDR (4)
052200                                 TO IS01-ADDR3.
052300     MOVE MB50WS-R0000-NAME-ADDR (5)
052400                                 TO IS01-ADDR4.
052500     MOVE MB50WS-IMP-DEV-TITLE   (1)
052600                                 TO MBCA-MBIS-TITLE (1).
052700     MOVE MB50WS-IMP-DEV-TITLE   (2)
052800                                 TO MBCA-MBIS-TITLE (2).
052900     MOVE MB50WS-IMP-DEV-TITLE   (3)
053000                                 TO MBCA-MBIS-TITLE (3).
053100     MOVE MB50WS-POS-DEV-TITLE   (1)
053200                                 TO MBCA-MBIS-TITLE (4).
053300     MOVE MB50WS-POS-DEV-TITLE   (2)
053400                                 TO MBCA-MBIS-TITLE (5).
053500     MOVE MB50WS-POS-DEV-TITLE   (3)
053600                                 TO MBCA-MBIS-TITLE (6).
053700*
053800 Y099-FT-EXIT.
053900     EXIT.
054000/
054100********************************************
054200*    MOVE STATEMENT DATES TO THE SCREEN    *
054300********************************************
054400*
054500 Y100-MOVE-DATE.
054600*
054700     MOVE MMS1-STMT-ID-CODE      TO WS-TS-STMT-ID-CODE
054800                                    (X-WS-TS-ARRAY).
054900     COMPUTE SS01WS-JULIAN       =  0 - MMS1-STMT-ID-CODE.
055000     PERFORM SS26PD-NUMERICALLY-EDIT-DATE
055100        THRU SS26PD-NED-EXIT.
055200     MOVE SS01WS-XX-XX-YYYY      TO WS-TS-DATE (X-WS-TS-ARRAY).
055300     MOVE MBCA-MBIS-FILE-NUMBER  TO WS-TS-FILE (X-WS-TS-ARRAY).
055400*
055500     SET X-WS-TS-ARRAY           UP BY 1.
055600*
055700     IF  X-WS-TS-ARRAY IS GREATER THAN 40
055800         PERFORM Y900-WRITE-TS
055900            THRU Y999-WTS-EXIT
056000         SET X-WS-TS-ARRAY       TO 1
056100         MOVE SPACES             TO WS-TEMP-STORAGE-RECORD
056200     END-IF.
056300*
056400 Y199-MD-EXIT.
056500     EXIT.
056600*
056700******************************************
056800*    MOVE MERCHANT DATA TO THE SCREEN    *
056900******************************************
057000*
057100 Y200-FORMAT-MERCH.
057200*
057300     MOVE MBCA-ORG-MERCHANT      TO MBIOWS-MMMM-KEY.
057400     MOVE 'FC09'                 TO MBCA-PROGRAM-LOCATION.
057500     SET MBIORO-READ-RANDOM      TO TRUE.
057600     PERFORM MMMMAO-ACCESS
057700        THRU MMMMAO-ACCESS-EXIT.
057800*
057900     IF  MMMM-SAC-USE-PRIMARY
058000         SET X-MMMM-DEMOGRAPHICS
058100                                 TO 1
058200     ELSE
058300         SET X-MMMM-DEMOGRAPHICS
058400                                 TO 2
058500     END-IF.
058600*
058700     MOVE SPACES                 TO SS12WS-NAME-ADDR-GROUP.
058800*
058900     SET X-MMMM-NA               TO +1.
059000     MOVE MMMM-NA-LINE           (X-MMMM-DEMOGRAPHICS X-MMMM-NA)
059100                                 TO SS12WS-NAME-ADDR (1)
059200     SET X-MMMM-NA               TO +2.
059300     MOVE MMMM-NA-LINE           (X-MMMM-DEMOGRAPHICS X-MMMM-NA)
059400                                 TO SS12WS-NAME-ADDR (2)
059500     SET X-MMMM-NA               TO +3.
059600     MOVE MMMM-NA-LINE           (X-MMMM-DEMOGRAPHICS X-MMMM-NA)
059700                                 TO SS12WS-NAME-ADDR (3)
059800     SET X-MMMM-NA               TO +4.
059900     MOVE MMMM-NA-LINE           (X-MMMM-DEMOGRAPHICS X-MMMM-NA)
060000                                 TO SS12WS-NAME-ADDR (4)
060100     SET X-MMMM-NA               TO +5.
060200     MOVE MMMM-NA-LINE           (X-MMMM-DEMOGRAPHICS X-MMMM-NA)
060300                                 TO SS12WS-NAME-ADDR (5)
060400     MOVE MMMM-POSTAL-CODE (X-MMMM-DEMOGRAPHICS)
060500                                 TO SS12WS-POSTAL-CODE.
060600     MOVE MMMM-STATE-CODE (X-MMMM-DEMOGRAPHICS)
060700                                 TO SS12WS-STATE-CODE.
060800     MOVE MMMM-COUNTRY-CODE (1)  TO SS12WS-COUNTRY-CODE.
060900*
061000     PERFORM SS12PD-FORMAT-DEMOGRAPHICS
061100                                 THRU SS12PD-FD-EXIT.
061200*
061300     MOVE SS12WS-MAIL-LINE (1)
061400                                 TO IS01-NAME
061500                                    MBCA-MBIS-NAME.
061600     MOVE SS12WS-MAIL-LINE (2)
061700                                 TO IS01-ADDR1.
061800     MOVE SS12WS-MAIL-LINE (3)
061900                                 TO IS01-ADDR2.
062000     MOVE SS12WS-MAIL-LINE (4)
062100                                 TO IS01-ADDR3.
062200     MOVE SS12WS-MAIL-LINE (5)
062300                                 TO IS01-ADDR4.
062400*
062500     MOVE MMMM-PHONE             (X-MMMM-DEMOGRAPHICS)
062600                                 TO IS01-PHONE.
062700     MOVE MMMM-FAX               (X-MMMM-DEMOGRAPHICS)
062800                                 TO IS01-FAX.
062900*
063000     EVALUATE TRUE
063100         WHEN WS-DISP-STMT-ADDR
063200              PERFORM Y400-FORMAT-STMT-ADDR
063300                 THRU Y499-FSA-EXIT
063400     END-EVALUATE.
063500*
063600 Y299-FM-EXIT.
063700     EXIT.
063800*
063900***************************************
064000*    MOVE CHAIN DATA TO THE SCREEN    *
064100***************************************
064200*
064300 Y300-FORMAT-CHAIN.
064400*
064500     MOVE MBCA-ORG-MERCHANT      TO MBIOWS-MMRC-KEY.
064600     MOVE 'FC10'                 TO MBCA-PROGRAM-LOCATION.
064700     SET MBIORO-READ-RANDOM      TO TRUE.
064800     PERFORM MMRCAO-ACCESS
064900        THRU MMRCAO-ACCESS-EXIT.
065000*
065100     MOVE SPACES                 TO SS12WS-NAME-ADDR-GROUP.
065200*
065300     MOVE MMRC-NA-LINES-TABLE    (1)
065400                                 TO SS12WS-NAME-ADDR (1).
065500     MOVE MMRC-NA-LINES-TABLE    (2)
065600                                 TO SS12WS-NAME-ADDR (2).
065700     MOVE MMRC-NA-LINES-TABLE    (3)
065800                                 TO SS12WS-NAME-ADDR (3).
065900     MOVE MMRC-NA-LINES-TABLE    (4)
066000                                 TO SS12WS-NAME-ADDR (4).
066100     MOVE MMRC-NA-LINES-TABLE    (5)
066200                                 TO SS12WS-NAME-ADDR (5).
066300     MOVE MMRC-PHONE             TO IS01-PHONE.
066400     MOVE MMRC-FAX               TO IS01-FAX.
066500     MOVE MMRC-POSTAL-CODE       TO SS12WS-POSTAL-CODE.
066600     MOVE MMRC-STATE-CODE        TO SS12WS-STATE-CODE.
066700     MOVE MMRC-COUNTRY-CODE      TO SS12WS-COUNTRY-CODE.
066800*
066900     PERFORM SS12PD-FORMAT-DEMOGRAPHICS
067000                                 THRU SS12PD-FD-EXIT.
067100*
067200     MOVE SS12WS-MAIL-LINE (1)
067300                                 TO IS01-NAME
067400                                    MBCA-MBIS-NAME.
067500     MOVE SS12WS-MAIL-LINE (2)
067600                                 TO IS01-ADDR1.
067700     MOVE SS12WS-MAIL-LINE (3)
067800                                 TO IS01-ADDR2.
067900     MOVE SS12WS-MAIL-LINE (4)
068000                                 TO IS01-ADDR3.
068100     MOVE SS12WS-MAIL-LINE (5)
068200                                 TO IS01-ADDR4.
068300*
068400     EVALUATE TRUE
068500         WHEN WS-DISP-STMT-ADDR
068600              PERFORM Y400-FORMAT-STMT-ADDR
068700                 THRU Y499-FSA-EXIT
068800     END-EVALUATE.
068900*
069000 Y399-FC-EXIT.
069100     EXIT.
069200/
069300***************************************************************
069400*    READ THE NAME AND ADDRESS RECORD ON THE STATEMENT FILE   *
069500*    AND MOVE THE MAILED TO ADDRESS TO THE DISPLAY ADDRESS.   *
069600***************************************************************
069700*
069800 Y400-FORMAT-STMT-ADDR.
069900*
070000**************************************************************
070100*    IF STATEMENT SELECTED IS ON THE MMS2 FILE THE MMS2      *
070200*    RECORD IS MOVED TO THE MMS1 RECORD FOR PROCESSING.      *
070300**************************************************************
070400*
070500     IF  MBCA-MBIS-MMS1
070600         MOVE MBCA-ORG-MERCHANT  TO MBIOWS-MMS1-ORG-MERCHANT
070700         MOVE MBCA-MBIS-REC-TYPE TO MBIOWS-MMS1-KEY-TYPE
070800         MOVE MBCA-MBIS-STMT-ID-CODE
070900                                 TO MBIOWS-MMS1-STMT-ID-CODE
071000         MOVE WS-READ-REC-000    TO MBIOWS-MMS1-REC-ID
071100         MOVE SS08WS-CICS-FC-NOTFND
071200                                 TO MBIORO-TEMP-STATUS-1
071300         MOVE 'FC11'             TO MBCA-PROGRAM-LOCATION
071400         SET MBIORO-READ-RANDOM  TO TRUE
071500         PERFORM MMS1AO-ACCESS
071600            THRU MMS1AO-ACCESS-EXIT
071700     ELSE
071800         MOVE MBCA-ORG-MERCHANT  TO MBIOWS-MMS2-ORG-MERCHANT
071900         MOVE MBCA-MBIS-REC-TYPE TO MBIOWS-MMS2-KEY-TYPE
072000         MOVE MBCA-MBIS-STMT-ID-CODE
072100                                 TO MBIOWS-MMS2-STMT-ID-CODE
072200         MOVE WS-READ-REC-000    TO MBIOWS-MMS2-REC-ID
072300         MOVE SS08WS-CICS-FC-NOTFND
072400                                 TO MBIORO-TEMP-STATUS-1
072500         MOVE 'FC12'             TO MBCA-PROGRAM-LOCATION
072600         SET MBIORO-READ-RANDOM  TO TRUE
072700         PERFORM MMS2AO-ACCESS
072800            THRU MMS2AO-ACCESS-EXIT
072900         MOVE MMS2-RECORD        TO MMS1-RECORD
073000     END-IF.
073100*
073200     MOVE ZERO                   TO MBIOWS-MMS1-STMT-ID-CODE.
073300*
073400     IF  SS08WS-RC-FC-NOTFND
073500         GO TO Y499-FSA-EXIT
073600     END-IF.
073700*
073800     MOVE MMS1-REC-TYPE-DATA     TO MB50WS-REC-ID-0000.
073900*
074000     MOVE MB50WS-R0000-NAME-ADDR (1)
074100                                 TO IS01-NAME
074200                                    MBCA-MBIS-NAME.
074300     MOVE MB50WS-R0000-NAME-ADDR (2)
074400                                 TO IS01-ADDR1.
074500     MOVE MB50WS-R0000-NAME-ADDR (3)
074600                                 TO IS01-ADDR2.
074700     MOVE MB50WS-R0000-NAME-ADDR (4)
074800                                 TO IS01-ADDR3.
074900     MOVE MB50WS-R0000-NAME-ADDR (5)
075000                                 TO IS01-ADDR4.
075100*
075200     MOVE ZERO                   TO MBIOWS-MMS1-STMT-ID-CODE.
075300     MOVE ZERO                   TO MBIOWS-MMS2-STMT-ID-CODE.
075400*
075500 Y499-FSA-EXIT.
075600     EXIT.
075700/
075800 Y500-BUILD-TEMP-STORAGE.
075900*
076000**************************************************************
076100*    IF STATEMENT SELECTED IS ON THE MMS2 FILE THE MMS2      *
076200*    RECORD IS MOVED TO THE MMS1 RECORD FOR PROCESSING.      *
076300**************************************************************
076400*
076500     IF  MBCA-MBIS-MMS1
076600         MOVE LOW-VALUES         TO MBIOWS-MMS1-KEY
076700         MOVE MBCA-ORG-MERCHANT  TO MBIOWS-MMS1-ORG-MERCHANT
076800         MOVE MBCA-MBIS-REC-TYPE TO MBIOWS-MMS1-KEY-TYPE
076900         MOVE 'FC01'             TO MBCA-PROGRAM-LOCATION
077000         SET MBIORO-STARTBR-GTE  TO TRUE
077100         PERFORM MMS1AO-ACCESS
077200            THRU MMS1AO-ACCESS-EXIT
077300     ELSE
077400         MOVE LOW-VALUES         TO MBIOWS-MMS2-KEY
077500         MOVE MBCA-ORG-MERCHANT  TO MBIOWS-MMS2-ORG-MERCHANT
077600         MOVE MBCA-MBIS-REC-TYPE TO MBIOWS-MMS2-KEY-TYPE
077700         MOVE 'FC02'             TO MBCA-PROGRAM-LOCATION
077800         SET MBIORO-STARTBR-GTE  TO TRUE
077900         PERFORM MMS2AO-ACCESS
078000            THRU MMS2AO-ACCESS-EXIT
078100     END-IF.
078200*
078300****************************************************************
078400*    READNEXT THE STATEMENT FILE                               *
078500****************************************************************
078600*
078700 Y500-READ-NEXT-STMT.
078800*
078900     IF  MBCA-MBIS-MMS1
079000         MOVE 'FC03'             TO MBCA-PROGRAM-LOCATION
079100         SET MBIORO-READ-SEQ     TO TRUE
079200         PERFORM MMS1AO-ACCESS
079300            THRU MMS1AO-ACCESS-EXIT
079400     ELSE
079500         MOVE 'FC04'             TO MBCA-PROGRAM-LOCATION
079600         SET MBIORO-READ-SEQ     TO TRUE
079700         PERFORM MMS2AO-ACCESS
079800            THRU MMS2AO-ACCESS-EXIT
079900         MOVE MMS2-RECORD        TO MMS1-RECORD
080000     END-IF.
080100*
080200     IF  MBCA-MBIS-P1-TOT-PAGES IS GREATER THAN 9998
080300     OR  MMS1-ORG-MERCHANT IS NOT EQUAL TO MBCA-ORG-MERCHANT
080400         GO TO Y500-END-BROWSE-STMT
080500     END-IF.
080600*
080700     EVALUATE TRUE
080800         WHEN MMS1-TRAILER
080900             GO TO Y500-END-BROWSE-STMT
081000         WHEN OTHER
081100             EVALUATE TRUE ALSO TRUE
081200                 WHEN MBCA-MBIS-MERCH
081300                 ALSO MMS1-KT-MERCHANT
081400                 WHEN MBCA-MBIS-CHAIN
081500                 ALSO MMS1-KT-CHAIN
081600                     EVALUATE TRUE
081700                         WHEN MMS1-O50-NA-RECORD
081800                              PERFORM Y100-MOVE-DATE
081900                                 THRU Y199-MD-EXIT
082000                     END-EVALUATE
082100             END-EVALUATE
082200     END-EVALUATE.
082300*
082400     GO TO Y500-READ-NEXT-STMT.
082500*
082600 Y500-END-BROWSE-STMT.
082700*
082800     IF  MBCA-MBIS-MMS1
082900         MOVE 'FC05'             TO MBCA-PROGRAM-LOCATION
083000         SET MBIORO-ENDBR        TO TRUE
083100         PERFORM MMS1AO-ACCESS
083200            THRU MMS1AO-ACCESS-EXIT
083300         SET MBCA-MBIS-MMS2      TO TRUE
083400         GO TO Y500-BUILD-TEMP-STORAGE
083500     ELSE
083600         MOVE 'FC06'             TO MBCA-PROGRAM-LOCATION
083700         SET MBIORO-ENDBR        TO TRUE
083800         PERFORM MMS2AO-ACCESS
083900            THRU MMS2AO-ACCESS-EXIT
084000     END-IF.
084100*
084200     PERFORM Y900-WRITE-TS
084300        THRU Y999-WTS-EXIT.
084400*
084500     EVALUATE TRUE
084600         WHEN MBCA-MBIS-P1-TOT-PAGES IS GREATER THAN ZERO
084700             SET  X-IS01-SD      TO 1
084800             MOVE SS08WS-CURSOR  TO IS01-SEL-L(X-IS01-SD)
084900         WHEN OTHER
085000             MOVE SS08WS-CURSOR  TO IS01-ALT-TRANID-L
085100             MOVE 'NO STATEMENTS FOR THIS ACCOUNT'
085200                                 TO IS01-ERR-MESSAGE
085300     END-EVALUATE.
085400*
085500 Y599-BTS-EXIT.
085600     EXIT.
085700*
085800 Y600-BUILD-TEXT-LINES.
085900*
086000     PERFORM Y800-READQ-TS
086100        THRU Y899-RTS-EXIT.
086200*
086300     PERFORM
086400         VARYING X-IS01-SD FROM 1 BY 1
086500         UNTIL   X-IS01-SD IS GREATER THAN 40
086600         SET  X-WS-TS-ARRAY      TO X-IS01-SD
086700         EVALUATE TRUE
086800             WHEN WS-TS-NO-DATA (X-WS-TS-ARRAY)
086900                 MOVE DFHBMDAS   TO IS01-SEL-LP-A(X-IS01-SD)
087000                 MOVE DFHBMDAS   TO IS01-SEL-A   (X-IS01-SD)
087100                 MOVE DFHBMDAS   TO IS01-SEL-RP-A(X-IS01-SD)
087200                 MOVE DFHBMDAS   TO IS01-STMT-DATE-A(X-IS01-SD)
087300             WHEN OTHER
087400                 MOVE DFHBMASF   TO IS01-SEL-LP-A(X-IS01-SD)
087500                 MOVE DFHBMUNP   TO IS01-SEL-A   (X-IS01-SD)
087600                 MOVE DFHBMASF   TO IS01-SEL-RP-A(X-IS01-SD)
087700                 MOVE DFHBMASF   TO IS01-STMT-DATE-A(X-IS01-SD)
087800                 MOVE WS-TS-DATE (X-WS-TS-ARRAY)
087900                                 TO IS01-STMT-DATE(X-IS01-SD)
088000         END-EVALUATE
088100     END-PERFORM.
088200*
088300     IF  WS-TS-NO-DATA(40)
088400         MOVE 'NO MORE STATEMENTS FOR THIS ACCOUNT'
088500                                 TO IS01-ERR-MESSAGE
088600     ELSE
088700         MOVE '
088800-             'MORE......'
088900                                 TO IS01-ERR-MESSAGE
089000     END-IF.
089100*
089200     IF  WS-TS-NO-DATA(1)
089300         MOVE SS08WS-CURSOR      TO IS01-ALT-TRANID-L
089400     ELSE
089500         MOVE SS08WS-CURSOR      TO IS01-SEL-L(1)
089600     END-IF.
089700*
089800     MOVE DFHBMABF               TO IS12309A.
089900*
090000 Y699-BTL-EXIT.
090100     EXIT.
090200/
090300 Y700-DELETEQ-TS.
090400*
090500     EXEC CICS IGNORE CONDITION
090600               QIDERR
090700          END-EXEC.
090800*
090900     MOVE MBCA-TERMINAL-ID       TO WS-MBIS-TERMINAL-ID.
091000     MOVE 'IS01'                 TO WS-MBIS-QUEUE-LIT.
091100     MOVE 'SC02'                 TO MBCA-PROGRAM-LOCATION.
091200     EXEC CICS DELETEQ TS
091300               QUEUE (WS-MBIS-QUEUE-ID-NAME)
091400          END-EXEC.
091500*
091600 Y799-DTS-EXIT.
091700     EXIT.
091800*
091900*
092000*
092100 Y800-READQ-TS.
092200*
092300     MOVE MBCA-TERMINAL-ID       TO WS-MBIS-TERMINAL-ID.
092400     MOVE 'IS01'                 TO WS-MBIS-QUEUE-LIT.
092500     MOVE MBCA-MBIS-P1-CURR-PAGE TO WS-TEMP-STORAGE-NBR.
092600*
092700     MOVE 'SC17'                 TO MBCA-PROGRAM-LOCATION.
092800     EXEC CICS READQ TS
092900               QUEUE  (WS-MBIS-QUEUE-ID-NAME)
093000               INTO   (WS-TEMP-STORAGE-RECORD)
093100               LENGTH (LENGTH OF WS-TEMP-STORAGE-RECORD)
093200               ITEM   (WS-TEMP-STORAGE-NBR)
093300     END-EXEC.
093400*
093500 Y899-RTS-EXIT.
093600     EXIT.
093700*
093800*
093900*
094000 Y900-WRITE-TS.
094100*
094200     MOVE MBCA-TERMINAL-ID       TO WS-MBIS-TERMINAL-ID.
094300     MOVE 'IS01'                 TO WS-MBIS-QUEUE-LIT.
094400     MOVE 'SC16'                 TO MBCA-PROGRAM-LOCATION.
094500*
094600     EXEC CICS WRITEQ TS
094700               QUEUE  (WS-MBIS-QUEUE-ID-NAME)
094800               FROM   (WS-TEMP-STORAGE-RECORD)
094900               LENGTH (LENGTH OF WS-TEMP-STORAGE-RECORD)
095000               ITEM   (WS-TEMP-STORAGE-NBR)
095100          END-EXEC.
095200*
095300     MOVE WS-TEMP-STORAGE-NBR    TO MBCA-MBIS-P1-TOT-PAGES.
095400*
095500 Y999-WTS-EXIT.
095600     EXIT.
095700/
095800 Z000-COPIED-ROUTINES SECTION.
095900*
096000**********************************
096100*    JUL TO GREG DATE ROUTINE    *
096200**********************************
096300*
096400     COPY SS08PD.
096500/
096600     COPY SS26PD.
096700/
096800     COPY SS27PD.
096900/
097000**********************************
097100*    GREG TO JUL DATE ROUTINE    *
097200**********************************
097300*
097400     COPY SS07PD.
097500/
097600***************************************
097700*    FORMAT NAME/ADDR DEMOGRAPHICS    *
097800***************************************
097900*
098000     COPY SS12PD.
098100/
098200*********************************
098300*    LINE 24 PF KEYS ROUTINE    *
098400*********************************
098500*
098600     COPY SS15PD.
098700/
098800************************************************
098900*    MERCHANT MASTER RECORD ACCESS ROUTINES    *
099000************************************************
099100*
099200     COPY MMMMAO.
099300/
099400***************************************************
099500*    PRODUCT ASSIGNMENT RECORD ACCESS ROUTINES    *
099600***************************************************
099700*
099800     COPY MMRCAO.
099900/
100000***************************************************
100100*    STATEMENT FILE 1                             *
100200***************************************************
100300*
100400     COPY MMS1AO.
100500/
100600***************************************************
100700*    STATEMENT FILE 2                             *
100800***************************************************
100900*
101000     COPY MMS2AO.
101100/
101200*****************************
101300*    ONLINE MAP ROUTINES    *
101400*****************************
101500*
101600     COPY MB60PD REPLACING 'MBMAPXX' BY 'MBIS01 '
101700                           MBMAPXXI BY MBIS01I
101800                           MBMAPXXO BY MBIS01O.
101900/
102000***************************
102100*    ONLINE PROCEDURES    *
102200***************************
102300*
102400     COPY MB70PD.
102500/
102600     COPY SMFTPXO.
