000100 IDENTIFICATION DIVISION.
000200 PROGRAM-ID. MBOIS08.
000201*       RELEASE DATE=08/24/01.        REVISION LEVEL=08.06      *
000202*****************************************************************
000203*WARNING.  THIS COMPUTER PROGRAM IS PROTECTED BY COPYRIGHT LAW  *
000204*AND INTERNATIONAL TREATIES.  UNAUTHORIZED REPRODUCTION OR      *
000205*DISTRIBUTION OF THIS PROGRAM, OR ANY PORTION OF IT, MAY RESULT *
000206*IN SEVERE CIVIL AND CRIMINAL PENATLIES, AND WILL BE PROSECUTED *
000207*TO THE MAXIMUM EXTENT POSSIBLE UNDER THE LAW.                  *
000208*COPYRIGHT 1999 PAYSYS INTERNATIONAL, INC.  ALL RIGHTS RESERVED.*
000209*****************************************************************
000300*****************************************************************
000400*                                                               *
000500*   V - PLUS  M E R C H A N T   B A N K C A R D   S Y S T E M   *
000600*                                                               *
000700*      MBOIS08 - ON-LINE STATEMENT                              *
000800*                SCREEN 08                                      *
000900*                                                               *
001000*              1. TRANSID                                       *
001100*                 A. MBIS                                       *
001200*              2. MAPS USED -                                   *
001300*                 A. MBIS08 (SCREEN 08)                         *
001400*              3. FILES USED -                                  *
001500*                 A. MMS1 (STATEMENT FILE 1)                    *
001600*                 B. MMS2 (STATEMENT FILE 2)                    *
001700*                 C. MMOC (ORGANIZATION MASTER)                 *
001800*                                                               *
001900*****************************************************************
002000*
002100 ENVIRONMENT DIVISION.
002200*
002300 DATA DIVISION.
002400*
002500 WORKING-STORAGE SECTION.
002600*
002700 01  FILLER                  PIC  X(12)      VALUE '** WS-BEG **'.
002800*
002900 01  FILLER                  PIC  X(14)      VALUE
003000     'MISCELLANEOUS:'.
003100*
003200 01  WS-MISC-AREAS.
003300*
003400     03  WS-WORK-AREAS.
003500         05  WS-READ-REC-800 PIC  X(04)      VALUE '0800'.
003600         05  WS-GRS-TOT-AMT  PIC S9(17)      COMP-3 VALUE ZERO.
003700         05  WS-NET-TOT-AMT  PIC S9(17)      COMP-3 VALUE ZERO.
003800         05  WS-LAST-PAGE    PIC S9(04)      BINARY VALUE ZERO.
003900         05  WS-MBISTS-ITEM-NBR
004000                             PIC S9(04)      BINARY VALUE ZERO.
004100         05  WS-DESC-FIELD-BEG
004200                             PIC S9(04)      BINARY VALUE ZERO.
004300         05  WS-DESC-FIELD-TOT
004400                             PIC S9(04)      BINARY VALUE ZERO.
004500         05  WS-DESC-WORK-AREA
004600                             PIC  X(41).
004700*
004800     03  WS-TS-QUEUE-NAME.
004900         05  WS-TS-QN-TERMID PIC  X(04)      VALUE SPACES.
005000         05  WS-TS-QN-TRANID PIC  X(02)      VALUE 'IS'.
005100         05  WS-TS-QN-SCRNBR PIC  X(02)      VALUE '08'.
005200*
005300     03  WS-DISPLAY-PROD-LINES.
005400         05  WS-DISPLAY-PROD-LINE-X          OCCURS 16 TIMES
005500                                             INDEXED BY
005600                                             X-WS-PL.
005700             07  WS-DISPLAY-LINE.
005800                 09  WS-DISPLAY-TOT-DESC.
005900                     11  WS-DISP-LINE-DESC
006000                             PIC  X(44).
006100                     11  WS-DISP-LINE-NBR
006200                             PIC  X(12).
006300                  09  WS-DISP-LINE-AMT
006400                             PIC  X(22).
006500*
006600*****************************************************************
006700*        PRODUCT HEADER LINE                                    *
006800*****************************************************************
006900*
007000     03  WS-PROD-HEADER.
007100         05  WS-PROD-LIT-1   PIC  X(34)      VALUE
007200                    '------------------------ PRODUCT '.
007300         05  WS-PROD-NBR     PIC  9(02).
007400         05  WS-PROD-LIT-2   PIC  X(03)      VALUE ' - '.
007500         05  WS-PROD-DESC    PIC  X(15).
007600         05  WS-PROD-LIT-3   PIC  X(24)      VALUE
007700                    '------------------------'.
007800*
007900*****************************************************************
008000*        GROSS/NET LINE DESCRIPTIONS AND HEADER LITERAL         *
008100*****************************************************************
008200*
008300     03  WS-PROD-FEE-LITRALS.
008400         05  WS-PD-LIT-NET   PIC  X(56)      VALUE
008500                    'NET SALES ...................................
008600-                   '...........'.
008700         05  WS-PD-LIT-GRS   PIC  X(56)      VALUE
008800                    'GROSS ACTIVITY ..............................
008900-                   '...........'.
009000         05  WS-PD-LIT-HDR   PIC  X(74)      VALUE
009100                    '
009200-                   '   NUMBER              AMOUNT'.
009300*
009400     03  WS-STATEMENT-TABLE.
009500         05  WS-STMT-TABLE                   OCCURS 60 TIMES
009600                                             INDEXED BY
009700                                             X-WS-ST.
009800             07  WS-STMT-TBL-LM
009900                             PIC S9(03)      COMP-3.
010000             07  WS-STMT-TBL-NBR
010100                             PIC S9(09)      COMP-3.
010200             07  WS-STMT-TBL-AMT
010300                             PIC S9(17)      COMP-3.
010400*
010500 01  FILLER                  PIC  X(17)      VALUE
010600     'PROGRAM SWITCHES:'.
010700*
010800 01  WS-SWITCHES.
010900     03  WS-DATA-AVAILABLE   PIC  S9(01)     VALUE +1.
011000         88 WS-HAVE-NO-DATA                  VALUE +1.
011100         88 WS-HAVE-DATA                     VALUE +2.
011200     03  WS-800-RECORDS      PIC  S9(01)     VALUE +1.
011300         88 WS-NO-MORE-PROD-REC              VALUE +1.
011400         88 WS-MORE-PROD-REC                 VALUE +2.
011500     03  WS-DETAIL-AVAIL     PIC  S9(01)     VALUE +1.
011600         88 WS-HAVE-NO-DETAIL                VALUE +1.
011700         88 WS-HAVE-DETAIL                   VALUE +2.
011800     03  WS-STARTBR-SW       PIC  S9(01)     VALUE +1.
011900         88 WS-STARTBR-REQ                   VALUE +1.
012000         88 WS-STARTBR-COMPLETE              VALUE +2.
012100*
012200/
012300     COPY MTRFRL REPLACING ==:MTRF:== BY ==MTRF==.
012400/
012500 01  FILLER                  PIC  X(22)      VALUE
012600     'STATEMENT WORK AREAS: '.
012700*
012800     COPY MB50WS.
012900/
013000 01  FILLER                  PIC  X(24)      VALUE
013100     'LOGIC MODULE WORK AREA: '.
013200*
013300     COPY MMTCWS.
013400/
013500 01  FILLER                  PIC  X(27)      VALUE
013600     'LOGIC MODULE DESCRIPTIONS: '.
013700*
013800     COPY MMGDTB.
013900/
014000 01  FILLER                  PIC  X(29)      VALUE
014100     'I/O REQUEST BLOCK WORK AREAS:'.
014200*
014300     COPY MBIOWS.
014400/
014500 01  FILLER                  PIC  X(18)      VALUE
014600     'I/O REQUEST BLOCK:'.
014700*
014800     COPY MBIORO.
014900/
015000 01  FILLER                  PIC  X(20)      VALUE
015100     'CCS DATE WORK AREAS:'.
015200/
015300     COPY SS01WS.
015400/
015500 01  FILLER                  PIC  X(15)      VALUE
015600     'CCS WORK AREAS:'.
015700*
015800     COPY SS08WS.
015900/
016000     COPY SS00WS.
016100/
016200     COPY SMFTWS.
016300/
016400     COPY SMPTRL REPLACING ==:SMPT:== BY ==SMPT==.
016500/
016600     COPY MB61LK.
016700/
016800 01  FILLER                  PIC  X(28)      VALUE
016900     'DYNAMICALY CALLED SUBROUINES'.
017000*
017100     COPY MB00WS.
017200/
017300 01  FILLER                  PIC  X(36)      VALUE
017400     'FORMAT NBR AND AMTS BY CURRENCY CODE'.
017500*
017600     COPY SS95WS.
017700*
017800 01  FILLER                  PIC  X(12)      VALUE '** WS-END **'.
017900/
018000 LINKAGE SECTION.
018100*
018200 01  DFHCOMMAREA.
018300*
018400     COPY MB60WS.
018500/
018600*********************************
018700*    ON-LINE STATEMENT MAP      *
018800*********************************
018900*
019000     COPY MBIS08.
019100/
019200**********************************************
019300*    ON-LINE STATEMENT MAP REDEFINITION      *
019400**********************************************
019500*
019600     COPY MBIS08R.
019700/
019800*********************************************
019900*    STATEMENT FILE 1 RECORD LAYOUT         *
020000*********************************************
020100*
020200     COPY MMS1RL REPLACING ==:MMS1:== BY ==MMS1==.
020300/
020400*********************************************
020500*    STATEMENT FILE 2 RECORD LAYOUT         *
020600*********************************************
020700*
020800     COPY MMS1RL REPLACING ==:MMS1:== BY ==MMS2==.
020900/
021000*********************************************
021100*    ORGANIZATION-MASTER FILE               *
021200*********************************************
021300*
021400     COPY MMOCRL.
021500*
021600*********************************************
021700*    TEMPORARY STORAGE RECORD               *
021800*********************************************
021900*
022000     COPY MBISTS.
022100/
022200 PROCEDURE DIVISION.
022300*
022400 A000-HOUSEKEEPING SECTION.
022500*
022600 A020-INIT.
022700*
022800     IF  MBCA-EIBAID-CLEAR
022900         PERFORM Y980-TEMP-STORAGE-DELETE
023000                                 THRU Y989-TSD-EXIT.
023100*
023200     MOVE 'PC01'                 TO MBCA-PROGRAM-LOCATION.
023300     PERFORM MB70PD-ON-LINE-HOUSEKEEPING
023400                                 THRU MB70PD-OLH-EXIT.
023500*
023600     MOVE MBCA-TERMINAL-ID       TO WS-TS-QN-TERMID.
023700     SET SS95WS-FUNCTION-INITIALIZE
023800                                 TO TRUE.
023900     PERFORM SS95PD-NAP-ROUTINE
024000        THRU SS95PD-NAP-EXIT.
024100*
024200     MOVE MBCA-CURRENCY-CODE     TO SS95WS-CURRENCY-CODE.
024300*
024400     IF  MBCA-RECEIVE-SCREEN
024500         GO TO C000-RECEIVE-SCREEN.
024600/
024700 B000-SEND-SCREEN SECTION.
024800*
024900*********************************************
025000*    GET CICS STORAGE NEEDED FOR THE MAP    *
025100*********************************************
025200*
025300     MOVE 'SC01'                 TO MBCA-PROGRAM-LOCATION.
025400     PERFORM MB60PD-GETMAIN-FOR-MAP
025500                                 THRU MB60PD-GFM-EXIT.
025600*
025700*******************************************
025800*    INITIALIZE THE STANDARD MAP LINES    *
025900*******************************************
026000*
026100     PERFORM MB60PD-INIT-STD-MAP-LINES
026200                                 THRU MB60PD-ISML-EXIT.
026300*
026400 B200-FORMAT-SCREEN.
026500*
026600****************************************************************
026700*    ACQUIRE MAIN STORAGE FOR TEMP STORAGE RECORD              *
026800****************************************************************
026900*
027000     MOVE 'TS01'                 TO MBCA-PROGRAM-LOCATION.
027100     PERFORM Y960-TEMP-STORAGE-GETMAIN
027200                                 THRU Y969-TSG-EXIT.
027300*
027400     EXEC CICS HANDLE CONDITION
027500               QIDERR  (B400-LOAD-DATA)
027600               ITEMERR (B300-DELETE-TEMP-STORAGE)
027700          END-EXEC.
027800*
027900***********************************************
028000*    READ THE TEMP STORAGE RECORD             *
028100***********************************************
028200*
028300     MOVE 'TS02'                 TO MBCA-PROGRAM-LOCATION.
028400     PERFORM Y970-TEMP-STORAGE-READ
028500                                 THRU Y979-TSR-EXIT.
028600     GO TO B500-BYPASS-FORMAT-TS.
028700*
028800***********************************************
028900*    DELETE TEMP STORAGE                      *
029000***********************************************
029100*
029200 B300-DELETE-TEMP-STORAGE.
029300*
029400     MOVE 'TS05'                 TO MBCA-PROGRAM-LOCATION.
029500     PERFORM Y980-TEMP-STORAGE-DELETE
029600                                 THRU Y989-TSD-EXIT.
029700*
029800 B400-LOAD-DATA.
029900*
030000************************************************************
030100*    SINCE THERE WAS NO TEMPORARY STORAGE RECORD THIS IS   *
030200*    THE FIRST TIME IN THIS PROGRAM. READ THE STATEMENT    *
030300*    FILE AND FORMAT THE TEMPORARY STORAGE RECORD WITH     *
030400*    ALL THE SCREEN DATA REQUIRED FOR ALL PAGES TO BE      *
030500*    DISPLAYED. SET THE CURRENT PAGE TO +1. IF THERE IS    *
030600*    NO DATA TO BE DISPLAYED GET OUT OF THIS PROGRAM.      *
030700************************************************************
030800*
030900     INITIALIZE MBISTS-DATA-AREA.
031000     INITIALIZE WS-DISPLAY-PROD-LINES.
031100     SET WS-HAVE-NO-DATA         TO TRUE.
031200     SET X-WS-PL                 TO +1.
031300     MOVE ZERO                   TO MBCA-MBIS-CURRENT-PAGE.
031400     MOVE ZERO                   TO MBCA-MBIS-LAST-PAGE.
031500*
031600 B410-LOAD-NEXT-PRODUCT.
031700*
031800     PERFORM Y600-LOAD-MB50WS-600
031900                                 THRU Y649-LM8-EXIT.
032000*
032100     EVALUATE TRUE ALSO TRUE
032200         WHEN WS-NO-MORE-PROD-REC
032300         ALSO WS-HAVE-NO-DATA
032400              GO TO F000-SETUP-COMMAREA
032500         WHEN WS-NO-MORE-PROD-REC
032600         ALSO WS-HAVE-DATA
032700              EVALUATE TRUE
032800              WHEN WS-HAVE-DETAIL
032900                   PERFORM Y530-MOVE-TO-TS
033000                                 THRU Y539-MTT-EXIT
033100              END-EVALUATE
033200              GO TO B450-READ-TEMP-STORAGE
033300     END-EVALUATE.
033400*
033500     EVALUATE TRUE
033600         WHEN X-WS-PL IS GREATER THAN +1
033700              SET X-WS-PL        UP BY +2
033800     END-EVALUATE.
033900*
034000     PERFORM Y730-PRODUCT-DESCRIPTION
034100                                 THRU Y739-PD-EXIT.
034200     MOVE ZERO                   TO WS-NET-TOT-AMT.
034300     MOVE ZERO                   TO WS-GRS-TOT-AMT.
034400     SET WS-HAVE-NO-DETAIL       TO TRUE.
034500*
034600************************************************************
034700*    IF THE FIRST LOGIC MODULE IS 900 DISPLAY              *
034800*    'NO ACTIVITY' AND READ THE NEXT RECORD.               *
034900************************************************************
035000*
035100     EVALUATE TRUE
035200         WHEN  MB50WS-PROD-LM    (1)
035300                                 IS EQUAL TO 900
035400               SET WS-HAVE-DETAIL
035500                                 TO TRUE
035600               SET X-WS-PL       UP BY +1
035700               MOVE 'NO ACTIVITY'
035800                                 TO WS-DISP-LINE-DESC  (X-WS-PL)
035900               SET WS-HAVE-NO-DATA
036000                                 TO TRUE
036100               GO TO B410-LOAD-NEXT-PRODUCT
036200     END-EVALUATE.
036300*
036400************************************************************
036500*    FORMAT DETAIL PORTION OF THE DISPLAYS                 *
036600************************************************************
036700*
036800     PERFORM
036900         VARYING X-MB50WS-PROD FROM +1 BY +1
037000         UNTIL X-MB50WS-PROD     IS GREATER THAN +200
037100         OR    MB50WS-PROD-LM    (X-MB50WS-PROD)
037200                                 IS EQUAL TO 900
037300             MOVE MB50WS-PROD-LM (X-MB50WS-PROD)
037400                                 TO MMTCWS-LOGIC-MODULE
037500             EVALUATE TRUE
037600                 WHEN MMTCWS-LM-SALE
037700                      ADD  MB50WS-PROD-AMT (X-MB50WS-PROD)
037800                                 TO WS-NET-TOT-AMT
037900                      ADD  MB50WS-PROD-AMT (X-MB50WS-PROD)
038000                                 TO WS-GRS-TOT-AMT
038100                 WHEN MMTCWS-LM-SALE-REV
038200                      ADD MB50WS-PROD-AMT (X-MB50WS-PROD)
038300                                 TO WS-NET-TOT-AMT
038400                      ADD MB50WS-PROD-AMT (X-MB50WS-PROD)
038500                                 TO WS-GRS-TOT-AMT
038600                 WHEN MMTCWS-LM-RETURN
038700                      ADD  MB50WS-PROD-AMT (X-MB50WS-PROD)
038800                                 TO WS-NET-TOT-AMT
038900                      SUBTRACT MB50WS-PROD-AMT (X-MB50WS-PROD)
039000                                 FROM WS-GRS-TOT-AMT
039100                 WHEN MMTCWS-LM-RETURN-REV
039200                      ADD  MB50WS-PROD-AMT (X-MB50WS-PROD)
039300                                 TO WS-NET-TOT-AMT
039400                      SUBTRACT MB50WS-PROD-AMT (X-MB50WS-PROD)
039500                                 FROM WS-GRS-TOT-AMT
039600             END-EVALUATE
039700             EVALUATE TRUE
039800                 WHEN X-WS-PL    IS GREATER THAN +15
039900                      PERFORM Y530-MOVE-TO-TS
040000                                 THRU Y539-MTT-EXIT
040100                      PERFORM Y730-PRODUCT-DESCRIPTION
040200                                 THRU Y739-PD-EXIT
040300             END-EVALUATE
040400             PERFORM Y200-FORMAT-DETAIL-DATA
040500                                 THRU Y299-FFD-EXIT
040600     END-PERFORM.
040700*
040800     EVALUATE TRUE
040900         WHEN WS-HAVE-DETAIL
041000              PERFORM Y440-DISPLAY-SUB-TOT
041100                                 THRU Y449-DST-EXIT
041200     END-EVALUATE.
041300*
041400     GO TO B410-LOAD-NEXT-PRODUCT.
041500*
041600 B450-READ-TEMP-STORAGE.
041700*
041800     MOVE +1                     TO MBCA-MBIS-CURRENT-PAGE.
041900     MOVE WS-LAST-PAGE           TO MBCA-MBIS-LAST-PAGE.
042000*
042100***********************************************************
042200*    READ THE TEMP STORAGE RECORD TO GET THE FIRST PAGE   *
042300***********************************************************
042400*
042500     MOVE 'TS03'                 TO MBCA-PROGRAM-LOCATION.
042600     PERFORM Y970-TEMP-STORAGE-READ
042700                                 THRU Y979-TSR-EXIT.
042800*
042900*********************************
043000*    FORMAT MAP STATIC FIELDS   *
043100*********************************
043200*
043300 B500-BYPASS-FORMAT-TS.
043400*
043500     EVALUATE TRUE
043600         WHEN MBCA-MBIS-CHAIN
043700              MOVE 'CHAIN'       TO IS08-MERCHANT-LIT
043800     END-EVALUATE.
043900*
044000     MOVE MBCA-ORG               TO IS08-ORG.
044100     MOVE MBCA-MERCHANT          TO IS08-MERCHANT.
044200     MOVE MBCA-MBIS-NAME         TO IS08-NAME.
044300     MOVE MBCA-MBIS-STMT-DATE    TO IS08-STMT-DATE.
044400*
044500 B800-SEND-MAP.
044600*
044700********************************************************
044800*    MOVE THE WS DISPLAY LINES TO THE SCREEN           *
044900********************************************************
045000*
045100     PERFORM Y540-MOVE-TS-TO-MAP THRU Y549-MTTM-EXIT.
045200*
045300 B900-SEND-MAP.
045400*
045500     MOVE '*TOP*'                TO SS08WS-LINE-24-PF-KEY-FUNC(3).
045600     MOVE '*BOT*'                TO SS08WS-LINE-24-PF-KEY-FUNC(4).
045700     MOVE '*FWD*'                TO SS08WS-LINE-24-PF-KEY-FUNC(5).
045800     MOVE '*BWD*'                TO SS08WS-LINE-24-PF-KEY-FUNC(6).
045900     MOVE SS08WS-LINE-24         TO IS08-PF-KEYS.
046000     MOVE 'RESV'                 TO MBCA-PGMX-PF-TRANS-ID (3).
046100     MOVE 'RESV'                 TO MBCA-PGMX-PF-TRANS-ID (4).
046200     MOVE 'RESV'                 TO MBCA-PGMX-PF-TRANS-ID (5).
046300     MOVE 'RESV'                 TO MBCA-PGMX-PF-TRANS-ID (6).
046400*
046500********************************************
046600*  TO FORMAT AND POPULATE THE MESSAGE LINE *
046700********************************************
046800*
046900     PERFORM MB06PD-FORMAT-MESSAGE-LINE
047000        THRU MB06PD-FML-EXIT.
047100     MOVE SS08WS-FORMATTED-MSG   TO IS08-ERR-MESSAGE.
047200*
047300     MOVE SS08WS-CURSOR          TO IS08-ALT-TRANID-L.
047400     COMPUTE MBCA-SCREEN-NBR     =  MBCA-SCREEN-NBR - 50.
047500*
047600     MOVE 'BM01'                 TO MBCA-PROGRAM-LOCATION.
047700     PERFORM MB60PD-SEND-MAP-WITH-ERASE
047800                                 THRU MB60PD-SMWE-EXIT.
047900*
048000************************
048100*    RETURN TO CICS    *
048200************************
048300*
048400     MOVE 'PC02'                 TO MBCA-PROGRAM-LOCATION.
048500     PERFORM MB70PD-RETURN-TRANS-ID
048600                                 THRU MB70PD-RTI-EXIT.
048700/
048800 C000-RECEIVE-SCREEN SECTION.
048900*
049000******************************************
049100*    THIS SECTION RECEIVES THE SCREEN    *
049200******************************************
049300*
049400     MOVE 'BM02'                 TO MBCA-PROGRAM-LOCATION.
049500     PERFORM MB60PD-RECEIVE-MAP  THRU MB60PD-RM-EXIT.
049600*
049700     MOVE MBCA-EIBAID            TO SS08WS-EIBAID.
049800*
049900****************************************************************
050000*    ACQUIRE MAIN STORAGE FOR TEMP STORAGE RECORD              *
050100****************************************************************
050200*
050300     MOVE 'TS05'                 TO MBCA-PROGRAM-LOCATION.
050400     PERFORM Y960-TEMP-STORAGE-GETMAIN
050500                                 THRU Y969-TSG-EXIT.
050600*
050700***********************************************
050800*    READ THE TEMP STORAGE RECORD             *
050900***********************************************
051000*
051100     MOVE 'TS06'                 TO MBCA-PROGRAM-LOCATION.
051200     PERFORM Y970-TEMP-STORAGE-READ
051300                                 THRU Y979-TSR-EXIT.
051400*
051500***********************************************
051600*    IF PF3, PF4, PF5, OR PF6 WAS PRESSED     *
051700*    DO NOT DELETE TEMPORARY STORAGE.         *
051800***********************************************
051900*
052000     IF  SS08WS-VALID-PF3
052100     OR  SS08WS-EIBAID-VALID-PF3
052200     OR  SS08WS-VALID-PF4
052300     OR  SS08WS-EIBAID-VALID-PF4
052400     OR  SS08WS-VALID-PF5
052500     OR  SS08WS-EIBAID-VALID-PF5
052600     OR  SS08WS-VALID-PF6
052700     OR  SS08WS-EIBAID-VALID-PF6
052800         CONTINUE
052900     ELSE
053000         PERFORM Y980-TEMP-STORAGE-DELETE
053100                                 THRU Y989-TSD-EXIT
053200     END-IF.
053300*
053400**************************************************************
053500*    CHECK FOR ANOTHER TRANSACTION ID ENTERED BY THE USER    *
053600**************************************************************
053700*
053800 C050-CHECK-NEW-TRANS.
053900*
054000     MOVE 'PC03'                 TO MBCA-PROGRAM-LOCATION.
054100     PERFORM MB60PD-NEW-TRANS-ROUTINE
054200                                 THRU MB60PD-NTR-EXIT.
054300*
054400**************************************************************
054500*    CHECK SCREEN FOR SCROLLING                              *
054600**************************************************************
054700*
054800     IF  SS08WS-VALID-PF3
054900     OR  SS08WS-EIBAID-VALID-PF3
055000         MOVE 58                 TO MBCA-SCREEN-NBR
055100         MOVE +1                 TO MBCA-MBIS-CURRENT-PAGE
055200         GO TO F090-TRANSFER-XCTL.
055300*
055400     IF  SS08WS-VALID-PF4
055500     OR  SS08WS-EIBAID-VALID-PF4
055600         MOVE 58                 TO MBCA-SCREEN-NBR
055700         MOVE MBCA-MBIS-LAST-PAGE
055800                                 TO MBCA-MBIS-CURRENT-PAGE
055900         GO TO F090-TRANSFER-XCTL.
056000*
056100     IF  SS08WS-VALID-PF5
056200     OR  SS08WS-EIBAID-VALID-PF5
056300         MOVE 58                 TO MBCA-SCREEN-NBR
056400         COMPUTE MBCA-MBIS-CURRENT-PAGE
056500                                 = MBCA-MBIS-CURRENT-PAGE + 1
056600         EVALUATE TRUE
056700             WHEN MBCA-MBIS-CURRENT-PAGE
056800                             IS GREATER THAN MBCA-MBIS-LAST-PAGE
056900             MOVE MBCA-MBIS-LAST-PAGE
057000                                 TO MBCA-MBIS-CURRENT-PAGE
057100         END-EVALUATE
057200         GO TO F090-TRANSFER-XCTL.
057300*
057400     IF  SS08WS-VALID-PF6
057500     OR  SS08WS-EIBAID-VALID-PF6
057600         MOVE 58                 TO MBCA-SCREEN-NBR
057700         COMPUTE MBCA-MBIS-CURRENT-PAGE
057800                                 = MBCA-MBIS-CURRENT-PAGE - 1
057900         EVALUATE TRUE
058000             WHEN MBCA-MBIS-CURRENT-PAGE
058100                                 IS LESS THAN +1
058200             MOVE +1             TO MBCA-MBIS-CURRENT-PAGE
058300         END-EVALUATE
058400         GO TO F090-TRANSFER-XCTL.
058500*
058600     IF  SS08WS-VALID-PF-KEY
058700     OR  SS08WS-EIBAID-VALID-PF-KEY
058800         SET MBCA-INITIAL-SCREEN-NBR
058900                                 TO TRUE.
059000/
059100 F000-SETUP-COMMAREA SECTION.
059200*
059300***************************************************************
059400*  SET UP COMMAREA FIELDS AND TRANSFER TO THE NEXT PROGRAM    *
059500***************************************************************
059600*
059700     MOVE MBCA-EIBAID            TO SS08WS-EIBAID.
059800*
059900     PERFORM MB60PD-EDIT-PAGE-NBR
060000                                 THRU MB60PD-EPN-EXIT.
060100*
060200 F090-TRANSFER-XCTL.
060300*
060400     MOVE 'PC05'                 TO MBCA-PROGRAM-LOCATION.
060500     PERFORM MB70PD-XCTL-TO-MBOXCTL
060600                                 THRU MB70PD-XTM-EXIT.
060700/
060800 Y000-PERFORMED-ROUTINES SECTION.
060900*
061000*************************************************************
061100*    FORMAT THE SCREEN WITH DETAIL DATA                     *
061200*************************************************************
061300*
061400 Y200-FORMAT-DETAIL-DATA.
061500*
061600     SET WS-HAVE-DETAIL          TO TRUE.
061700     SET X-WS-PL                 UP BY +1.
061800*
061900     PERFORM Y700-SEARCH-MMGDTB  THRU Y709-SM-EXIT.
062000     MOVE MMGDTB-DT-DESC         (X-MMGDTB-DT-SEARCH)
062100                                 TO WS-DISP-LINE-DESC   (X-WS-PL).
062200     PERFORM Y720-DOT-THE-DESC   THRU Y729-DTD-EXIT.
062300     MOVE MB50WS-PROD-NBR        (X-MB50WS-PROD)
062400                                 TO SS95WS-IN-NBR.
062500     MOVE MB50WS-PROD-AMT        (X-MB50WS-PROD)
062600                                 TO SS95WS-IN-AMT.
062700     PERFORM SS95PD-NAP-ROUTINE
062800                                 THRU SS95PD-NAP-EXIT.
062900     MOVE SS95WS-OUT-NBR-L12     TO WS-DISP-LINE-NBR    (X-WS-PL).
063000     MOVE SS95WS-OUT-AMT-L22     TO WS-DISP-LINE-AMT    (X-WS-PL).
063100*
063200 Y299-FFD-EXIT.
063300     EXIT.
063400/
063500*************************************************************
063600*    MOVE SUB-TOTAL STAT TO THE DISPLAY AREA                *
063700*************************************************************
063800*
063900 Y440-DISPLAY-SUB-TOT.
064000*
064100     EVALUATE TRUE ALSO TRUE
064200         WHEN MMS1-O50-PRODUCT-SUMMARY
064300         ALSO MMS1-REC-SEQ       IS EQUAL TO ZERO
064400              GO TO Y449-DST-EXIT
064500     END-EVALUATE.
064600*
064700     SET X-WS-PL                 UP BY +2.
064800*
064900     EVALUATE TRUE
065000         WHEN X-WS-PL    IS GREATER THAN +15
065100              PERFORM Y530-MOVE-TO-TS
065200                                 THRU Y539-MTT-EXIT
065300              PERFORM Y730-PRODUCT-DESCRIPTION
065400                                 THRU Y739-PD-EXIT
065500     END-EVALUATE.
065600*
065700     SET WS-HAVE-DETAIL          TO TRUE.
065800     MOVE WS-PD-LIT-NET          TO WS-DISPLAY-TOT-DESC (X-WS-PL).
065900     MOVE WS-NET-TOT-AMT         TO SS95WS-IN-AMT.
066000     PERFORM SS95PD-NAP-ROUTINE
066100                                 THRU SS95PD-NAP-EXIT.
066200     MOVE SS95WS-OUT-AMT-L22     TO WS-DISP-LINE-AMT    (X-WS-PL).
066300     SET X-WS-PL                 UP BY +1.
066400     MOVE WS-PD-LIT-GRS          TO WS-DISPLAY-TOT-DESC (X-WS-PL).
066500     MOVE WS-GRS-TOT-AMT         TO SS95WS-IN-AMT.
066600     PERFORM SS95PD-NAP-ROUTINE
066700                                 THRU SS95PD-NAP-EXIT.
066800     MOVE SS95WS-OUT-AMT-L22     TO WS-DISP-LINE-AMT    (X-WS-PL).
066900     MOVE ZERO                   TO WS-NET-TOT-AMT.
067000     MOVE ZERO                   TO WS-GRS-TOT-AMT.
067100*
067200 Y449-DST-EXIT.
067300     EXIT.
067400/
067500******************************************************************
067600*    MOVE SCREEN DATA LINES TO TEMP STORAGE RECORD.              *
067700******************************************************************
067800*
067900 Y530-MOVE-TO-TS.
068000*
068100     EVALUATE TRUE
068200         WHEN WS-HAVE-NO-DETAIL
068300              GO TO Y539-MTT-EXIT
068400     END-EVALUATE.
068500*
068600     SET X-MBISTS-DA             TO +1.
068700*
068800     PERFORM
068900         VARYING X-WS-PL FROM +1 BY +1
069000         UNTIL X-WS-PL           IS GREATER THAN +16
069100             MOVE WS-DISPLAY-LINE                       (X-WS-PL)
069200                                 TO MBISTS-LINE     (X-MBISTS-DA)
069300             SET X-MBISTS-DA     UP BY +1
069400     END-PERFORM.
069500*
069600     INITIALIZE WS-DISPLAY-PROD-LINES.
069700     SET X-WS-PL                 TO +1.
069800     SET WS-HAVE-NO-DETAIL       TO TRUE.
069900     PERFORM Y990-TEMP-STORAGE-WRITE
070000                                 THRU Y999-TSW-EXIT.
070100*
070200 Y539-MTT-EXIT.
070300     EXIT.
070400/
070500******************************************************************
070600*    MOVE TEMP STORAGE DATA TO THE MAP                           *
070700******************************************************************
070800*
070900 Y540-MOVE-TS-TO-MAP.
071000*
071100     SET X-MBISTS-DA             TO +1.
071200*
071300     PERFORM
071400         VARYING X-IS08-PL FROM +1 BY +1
071500         UNTIL X-IS08-PL         IS GREATER THAN +16
071600             MOVE MBISTS-LINE    (X-MBISTS-DA)
071700                                 TO IS08-PROD-LINE    (X-IS08-PL)
071800             SET X-MBISTS-DA     UP BY +1
071900     END-PERFORM.
072000*
072100     EVALUATE TRUE ALSO TRUE
072200         WHEN MBCA-MBIS-CURRENT-PAGE
072300                                 IS EQUAL TO +1
072400         ALSO MBCA-MBIS-CURRENT-PAGE
072500                                 IS LESS THAN MBCA-MBIS-LAST-PAGE
072600              MOVE DFHBMASB      TO IS08-FWD-IND-A
072700         WHEN MBCA-MBIS-CURRENT-PAGE
072800                                 IS EQUAL TO MBCA-MBIS-LAST-PAGE
072900         ALSO MBCA-MBIS-CURRENT-PAGE
073000                                 IS GREATER THAN +1
073100              MOVE DFHBMASB      TO IS08-BACK-IND-A
073200         WHEN MBCA-MBIS-CURRENT-PAGE
073300                                 IS EQUAL TO MBCA-MBIS-LAST-PAGE
073400         ALSO MBCA-MBIS-CURRENT-PAGE
073500                                 IS EQUAL TO +1
073600              CONTINUE
073700         WHEN OTHER
073800              MOVE DFHBMASB      TO IS08-FWD-IND-A
073900              MOVE DFHBMASB      TO IS08-BACK-IND-A
074000     END-EVALUATE.
074100*
074200 Y549-MTTM-EXIT.
074300     EXIT.
074400/
074500******************************************************************
074600*    LOAD THE MB50WS RECORD 600 DATA AREA WITH FIELDS CONTAINED  *
074700*    ON THE STATEMENT FILE. IT IS POSSIBLE TO HAVE MORE THAN 1   *
074800*    STATEMENT RECORD.                                           *
074900******************************************************************
075000*
075100 Y600-LOAD-MB50WS-600.
075200*
075300     SET X-MB50WS-PROD           TO +1.
075400     INITIALIZE MB50WS-PROD-AREA.
075500*
075600****************************************************************
075700*    ONLY ONE START BROWSE IS REQUIRED                         *
075800****************************************************************
075900*
076000     EVALUATE TRUE
076100         WHEN WS-STARTBR-COMPLETE
076200              GO TO Y610-READ-LOOP
076300     END-EVALUATE.
076400*
076500**************************************************************
076600*    IF STATEMENT SELECTED IS ON THE MMS2 FILE THE MMS2      *
076700*    RECORD IS MOVED TO THE MMS1 RECORD FOR PROCESSING SO    *
076800*    A GETMAIN MUST PERFORMED TO PROVIDE THE WORK AREA.      *
076900**************************************************************
077000*
077100     EVALUATE TRUE ALSO TRUE
077200         WHEN MBCA-MBIS-MMS2
077300         ALSO MBIOWS-MMS1-GETMAIN-REQUIRED
077400              MOVE 'FC20'        TO MBCA-PROGRAM-LOCATION
077500              SET MBIORO-GETMAIN TO TRUE
077600              PERFORM MMS1AO-ACCESS
077700                                 THRU MMS1AO-ACCESS-EXIT
077800     END-EVALUATE.
077900*
078000****************************************************************
078100*    START BROWSE THE STATEMENT FILE                           *
078200****************************************************************
078300*
078400     IF  MBCA-MBIS-MMS1
078500         MOVE MBCA-ORG-MERCHANT  TO MBIOWS-MMS1-ORG-MERCHANT
078600         MOVE MBCA-MBIS-REC-TYPE TO MBIOWS-MMS1-KEY-TYPE
078700         MOVE MBCA-MBIS-STMT-ID-CODE
078800                                 TO MBIOWS-MMS1-STMT-ID-CODE
078900         MOVE WS-READ-REC-800    TO MBIOWS-MMS1-REC-ID
079000         MOVE SS08WS-CICS-FC-ENDFILE TO MBIORO-TEMP-STATUS-1
079100         MOVE 'FC01'             TO MBCA-PROGRAM-LOCATION
079200         SET MBIORO-STARTBR-GTE  TO TRUE
079300         PERFORM MMS1AO-ACCESS   THRU MMS1AO-ACCESS-EXIT
079400     ELSE
079500         MOVE MBCA-ORG-MERCHANT  TO MBIOWS-MMS2-ORG-MERCHANT
079600         MOVE MBCA-MBIS-REC-TYPE TO MBIOWS-MMS2-KEY-TYPE
079700         MOVE MBCA-MBIS-STMT-ID-CODE
079800                                 TO MBIOWS-MMS2-STMT-ID-CODE
079900         MOVE WS-READ-REC-800    TO MBIOWS-MMS2-REC-ID
080000         MOVE SS08WS-CICS-FC-ENDFILE TO MBIORO-TEMP-STATUS-1
080100         MOVE 'FC02'             TO MBCA-PROGRAM-LOCATION
080200         SET MBIORO-STARTBR-GTE  TO TRUE
080300         PERFORM MMS2AO-ACCESS   THRU MMS2AO-ACCESS-EXIT
080400         MOVE MMS2-RECORD        TO MMS1-RECORD.
080500*
080600     IF SS08WS-RC-FC-ENDFILE
080700         GO TO Y645-END-BROWSE.
080800*
080900     SET WS-STARTBR-COMPLETE     TO TRUE.
081000*
081100****************************************************************
081200*    READ ORGANIZATION FILE                                    *
081300****************************************************************
081400*
081500     MOVE MBCA-ORG               TO MBIOWS-MMOC-ORG.
081600     MOVE 'FC03'                 TO MBCA-PROGRAM-LOCATION.
081700     SET MBIORO-READ-RANDOM      TO TRUE.
081800     PERFORM MMOCAO-ACCESS       THRU MMOCAO-ACCESS-EXIT.
081900*
082000 Y610-READ-LOOP.
082100*
082200     SET X-WS-ST                 TO +1.
082300*
082400****************************************************************
082500*    READNEXT THE STATEMENT FILE                               *
082600****************************************************************
082700*
082800     IF  MBCA-MBIS-MMS1
082900         MOVE 'FC04'             TO MBCA-PROGRAM-LOCATION
083000         SET MBIORO-READ-SEQ     TO TRUE
083100         PERFORM MMS1AO-ACCESS   THRU MMS1AO-ACCESS-EXIT
083200     ELSE
083300         MOVE 'FC05'             TO MBCA-PROGRAM-LOCATION
083400         SET MBIORO-READ-SEQ     TO TRUE
083500         PERFORM MMS2AO-ACCESS   THRU MMS2AO-ACCESS-EXIT
083600         MOVE MMS2-RECORD        TO MMS1-RECORD.
083700*
083800     IF  NOT MMS1-O50-PRODUCT-SUMMARY
083900         SET WS-NO-MORE-PROD-REC TO TRUE
084000         GO TO Y645-END-BROWSE.
084100*
084200     MOVE MMS1-REC-TYPE-DATA     TO MTRF-O50-PROD-AREA.
084300     MOVE MTRF-O50-PROD-LM (1)   TO MMTCWS-LOGIC-MODULE.
084400*
084500     IF  MMTCWS-LM-VALID-DELETE
084600         GO TO Y610-READ-LOOP.
084700*
084800     SET WS-MORE-PROD-REC        TO TRUE.
084900     SET WS-HAVE-DATA            TO TRUE.
085000     MOVE MMS1-REC-TYPE-DATA     TO WS-STATEMENT-TABLE.
085100*
085200     PERFORM
085300         VARYING X-WS-ST FROM +1 BY +1
085400         UNTIL   X-WS-ST         IS GREATER THAN +20
085500         MOVE WS-STMT-TABLE      (X-WS-ST)
085600                                 TO MB50WS-PROD (X-MB50WS-PROD)
085700         SET X-MB50WS-PROD       UP BY +1
085800     END-PERFORM.
085900*
086000     EVALUATE TRUE
086100         WHEN MMS1-REC-ID-SEQ    IS EQUAL TO +999999999
086200              GO TO Y649-LM8-EXIT
086300         WHEN OTHER
086400              GO TO Y610-READ-LOOP
086500     END-EVALUATE.
086600*
086700****************************************************************
086800*    END BROWSE THE STATEMENT FILE                             *
086900****************************************************************
087000*
087100 Y645-END-BROWSE.
087200*
087300     IF  MBCA-MBIS-MMS1
087400         MOVE 'FC06'             TO MBCA-PROGRAM-LOCATION
087500         SET MBIORO-ENDBR        TO TRUE
087600         PERFORM MMS1AO-ACCESS   THRU MMS1AO-ACCESS-EXIT
087700     ELSE
087800         MOVE 'FC07'             TO MBCA-PROGRAM-LOCATION
087900         SET MBIORO-ENDBR        TO TRUE
088000         PERFORM MMS2AO-ACCESS   THRU MMS2AO-ACCESS-EXIT.
088100*
088200 Y649-LM8-EXIT.
088300     EXIT.
088400/
088500****************************************************************
088600*    FIND THE DETAIL LINE DESCRIPTION FOR DEFAULT TRANSACTIONS *
088700****************************************************************
088800*
088900 Y700-SEARCH-MMGDTB.
089000*
089100     SET X-MMGDTB-DT-SEARCH      TO 1.
089200     SEARCH MMGDTB-DT-TABLE VARYING X-MMGDTB-DT-SEARCH
089300         AT END
089400             SET X-MMGDTB-DT-SEARCH
089500                                 TO 495
089600             MOVE '***UNKNOWN L/M DESCRIPTION***'
089700                                 TO MMGDTB-DT-DESC (495)
089800             PERFORM Y710-SEARCH-GEN-TRANS
089900                                 THRU Y719-SGT-EXIT
090000         WHEN MB50WS-PROD-LM     (X-MB50WS-PROD)
090100                                 IS EQUAL TO MMGDTB-DT-LM
090200                                              (X-MMGDTB-DT-SEARCH)
090300              NEXT SENTENCE.
090400*
090500 Y709-SM-EXIT.
090600     EXIT.
090700/
090800*****************************************************************
090900*    FIND THE DETAIL LINE DESCRIPTION FOR GENRATED TRANSACTIONS *
091000*****************************************************************
091100*
091200 Y710-SEARCH-GEN-TRANS.
091300*
091400     SET X-MMGDTB-GT-SEARCH      TO 1.
091500     SEARCH MMGDTB-GT-TABLE VARYING X-MMGDTB-GT-SEARCH
091600         AT END
091700             SET X-MMGDTB-GT-SEARCH
091800                                 TO 495
091900             MOVE '***UNKNOWN L/M DESCRIPTION***'
092000                                 TO MMGDTB-GT-DESC (495)
092100         WHEN MB50WS-PROD-LM     (X-MB50WS-PROD)
092200                                 IS EQUAL TO MMGDTB-GT-LM
092300                                              (X-MMGDTB-GT-SEARCH)
092400              NEXT SENTENCE.
092500*
092600     MOVE MMGDTB-GT-DESC (X-MMGDTB-GT-SEARCH)
092700                                 TO MMGDTB-DT-DESC (495).
092800*
092900 Y719-SGT-EXIT.
093000     EXIT.
093100/
093200*****************************************************************
093300*    FLOAT DOTS INTO THE REMAINDER OF THE DESCRIPTION FIELD     *
093400*****************************************************************
093500*
093600 Y720-DOT-THE-DESC.
093700*
093800     MOVE WS-DISP-LINE-DESC      (X-WS-PL)
093900                                 TO WS-DESC-WORK-AREA.
094000     MOVE LENGTH OF WS-DESC-WORK-AREA
094100                                 TO WS-DESC-FIELD-TOT.
094200     MOVE LENGTH OF WS-DESC-WORK-AREA
094300                                 TO WS-DESC-FIELD-BEG.
094400*
094500     PERFORM
094600         VARYING WS-DESC-FIELD-BEG FROM WS-DESC-FIELD-TOT BY -1
094700         UNTIL   WS-DESC-FIELD-BEG
094800                               IS LESS THAN 2
094900            OR   WS-DESC-WORK-AREA
095000                               (WS-DESC-FIELD-BEG : 1)
095100                               IS NOT EQUAL TO SPACES
095200                 MOVE '.'      TO WS-DESC-WORK-AREA
095300                               (WS-DESC-FIELD-BEG : 1)
095400     END-PERFORM.
095500*
095600     MOVE WS-DESC-WORK-AREA      TO WS-DISP-LINE-DESC   (X-WS-PL).
095700*
095800 Y729-DTD-EXIT.
095900     EXIT.
096000/
096100*****************************************************************
096200*    FORMAT THE PRODUCT DESCRIPTION LINE                        *
096300*****************************************************************
096400*
096500 Y730-PRODUCT-DESCRIPTION.
096600*
096700     EVALUATE TRUE
096800         WHEN X-WS-PL IS GREATER THAN +13
096900              PERFORM Y530-MOVE-TO-TS
097000                                 THRU Y539-MTT-EXIT
097100     END-EVALUATE.
097200*
097300     MOVE MMS1-REC-SEQ           TO WS-PROD-NBR.
097400*
097500     IF  MMS1-REC-SEQ IS GREATER THAN ZERO
097600         SET X-MMOC-PROD         TO MMS1-REC-SEQ
097700         MOVE MMOC-PRODUCT-DESC  (X-MMOC-PROD)
097800                                 TO WS-PROD-DESC
097900     ELSE
098000         MOVE 'MERCHANT LEVEL '  TO WS-PROD-DESC
098100     END-IF.
098200*
098300     MOVE WS-PROD-HEADER         TO WS-DISPLAY-LINE     (X-WS-PL).
098400     SET X-WS-PL                 UP BY +1.
098500     MOVE WS-PD-LIT-HDR          TO WS-DISPLAY-LINE     (X-WS-PL).
098600*
098700 Y739-PD-EXIT.
098800     EXIT.
098900*
099000******************************************
099100*    GET STORAGE FOR TEMPORARY STORAGE   *
099200******************************************
099300*
099400 Y960-TEMP-STORAGE-GETMAIN.
099500*
099600     EXEC CICS GETMAIN
099700               FLENGTH (LENGTH  OF MBISTS-RECORD)
099800               SET     (ADDRESS OF MBISTS-RECORD)
099900          END-EXEC.
100000*
100100 Y969-TSG-EXIT.
100200     EXIT.
100300*
100400******************************************
100500*    READ TEMPROARY STORAGE              *
100600******************************************
100700*
100800 Y970-TEMP-STORAGE-READ.
100900*
101000     EXEC CICS READQ TS
101100               QUEUE   (WS-TS-QUEUE-NAME)
101200               INTO    (MBISTS-RECORD)
101300               LENGTH  (LENGTH OF MBISTS-RECORD)
101400               ITEM    (MBCA-MBIS-CURRENT-PAGE)
101500          END-EXEC.
101600*
101700 Y979-TSR-EXIT.
101800     EXIT.
101900*
102000******************************************
102100*    DELETE TEMPROARY STORAGE            *
102200******************************************
102300*
102400 Y980-TEMP-STORAGE-DELETE.
102500*
102600     EXEC CICS IGNORE CONDITION
102700               QIDERR
102800          END-EXEC.
102900*
103000     EXEC CICS DELETEQ TS
103100               QUEUE  (WS-TS-QUEUE-NAME)
103200          END-EXEC.
103300*
103400     MOVE ZERO                   TO MBCA-MBIS-CURRENT-PAGE.
103500     MOVE ZERO                   TO MBCA-MBIS-LAST-PAGE.
103600*
103700 Y989-TSD-EXIT.
103800     EXIT.
103900*
104000******************************************
104100*    WRITE TEMPROARY STORAGE             *
104200******************************************
104300*
104400 Y990-TEMP-STORAGE-WRITE.
104500*
104600     EXEC CICS WRITEQ TS
104700               QUEUE   (WS-TS-QUEUE-NAME)
104800               FROM    (MBISTS-RECORD)
104900               LENGTH  (LENGTH OF MBISTS-RECORD)
105000               ITEM    (WS-MBISTS-ITEM-NBR)
105100          END-EXEC.
105200*
105300     MOVE WS-MBISTS-ITEM-NBR     TO WS-LAST-PAGE.
105400*
105500 Y999-TSW-EXIT.
105600     EXIT.
105700*
105800/
105900 Z000-COPIED-ROUTINES SECTION.
106000*
106100**********************************
106200*    JUL TO GREG DATE ROUTINE    *
106300**********************************
106400*
106500     COPY SS08PD.
106600/
106700**********************************
106800* DATE AND TIME EDIT ROUTINES    *
106900**********************************
107000*
107100     COPY SS26PD.
107200     COPY SS27PD.
107300/
107400**********************************
107500*    GREG TO JUL DATE ROUTINE    *
107600**********************************
107700*
107800     COPY SS07PD.
107900/
108000*********************************
108100*    LINE 24 PF KEYS ROUTINE    *
108200*********************************
108300*
108400     COPY SS15PD.
108500/
108600***************************************************
108700*    STATEMENT FILE 1                             *
108800***************************************************
108900*
109000     COPY MMS1AO.
109100/
109200***************************************************
109300*    STATEMENT FILE 2                             *
109400***************************************************
109500*
109600     COPY MMS2AO.
109700/
109800***************************************************
109900*    ORGANIZATION MASTER FILE                     *
110000***************************************************
110100*
110200     COPY MMOCAO.
110300/
110400***************************************************
110500*    FORMAT NBR AND AMOUNTS BY CURRENCY CODE      *
110600***************************************************
110700*
110800     COPY SS95PDO REPLACING ==:XXCA:== BY ==MBCA==.
110900/
111000*****************************
111100*    ONLINE MAP ROUTINES    *
111200*****************************
111300*
111400     COPY MB60PD REPLACING 'MBMAPXX' BY 'MBIS08 '
111500                           MBMAPXXI BY MBIS08I
111600                           MBMAPXXO BY MBIS08O.
111700/
111800*****************************
111900*    FORMATTED MESSAGE LINE *
112000*****************************
112100*
112200     COPY MB06PD.
112300/
112400***************************
112500*    ONLINE PROCEDURES    *
112600***************************
112700*
112800     COPY MB70PD.
112900/
113000     COPY SMFTPXO.
