000100 IDENTIFICATION DIVISION.
000200 PROGRAM-ID. MBOIT00.
000201*       RELEASE DATE=08/24/01.        REVISION LEVEL=08.06      *
000202*****************************************************************
000203*WARNING.  THIS COMPUTER PROGRAM IS PROTECTED BY COPYRIGHT LAW  *
000204*AND INTERNATIONAL TREATIES.  UNAUTHORIZED REPRODUCTION OR      *
000205*DISTRIBUTION OF THIS PROGRAM, OR ANY PORTION OF IT, MAY RESULT *
000206*IN SEVERE CIVIL AND CRIMINAL PENATLIES, AND WILL BE PROSECUTED *
000207*TO THE MAXIMUM EXTENT POSSIBLE UNDER THE LAW.                  *
000208*COPYRIGHT 1999 PAYSYS INTERNATIONAL, INC.  ALL RIGHTS RESERVED.*
000209*****************************************************************
000300*****************************************************************
000400*                                                               *
000500*               M E R C H A N T   S Y S T E M                   *
000600*                                                               *
000700*      MBOIT00 - ON-LINE MERCHANT DETAIL HISTORY DISPLAY        *
000800*                LOCATE SCREEN 00                               *
000900*                                                               *
001000*              1. TRANSIDS                                      *
001100*                 A. MBIT                                       *
001200*              2. MAPS USED -                                   *
001300*                 A. MBIT00 (LOCATE MAP)                        *
001400*              3. FILES USED -                                  *
001500*                 A. MMOC   (ORG CONTROL FILE)                  *
001600*                 B. MMMM   (MERCHANT MASTER FILE)              *
001700*                 C. MMSM   (STORE MASTER FILE)                 *
001800*                 D. MMDH   (MERCHANT DETAIL HISTORY FILE)      *
001900*                                                               *
002000*****************************************************************
002100*
002200 ENVIRONMENT DIVISION.
002300 DATA DIVISION.
002400 WORKING-STORAGE SECTION.
002500 01  FILLER                  PIC  X(12)      VALUE '** WS-BEG **'.
002600*         I/O REQUEST BLOCK WORK AREAS
002700     COPY MBIOWS.
002800/         I/O REQUEST BLOCK
002900     COPY MBIORO.
003000/         DATE WORK AREAS
003100     COPY SS01WS.
003200/         ONLINE WORK AREAS
003300     COPY SS08WS.
003400/
003500     COPY SS00WS.
003600/
003700     COPY SMFTWS.
003800/
003900     COPY SMPTRL REPLACING ==:SMPT:== BY ==SMPT==.
004000/
004100     COPY MB61LK.
004200/         STANDARD ERROR MESSAGES
004300     COPY MBEMWS.
004400*
004500 01  WS-MISCELLANEOUS.
004600     03  WS-SAVE-EIBAID      PIC  X(01)      VALUE SPACES.
004700     03  WS-WORK-DATE        PIC  9(08)      VALUE ZEROES.
004800     03  WS-TWO-NINES        PIC  9(02)      VALUE 99.
004900     03  WS-NINES            PIC S9(17)      VALUE
005000                                             +99999999999999999.
005100     03  WS-HOLD-MER-STORE   PIC  9(09)      VALUE ZEROES.
005200     03  TS-QUEUE-NAME.
005300         05  TS-QN-TERMID    PIC  X(04)      VALUE SPACES.
005400         05  TS-QN-TRANID    PIC  X(04)      VALUE 'MBIT'.
005500*
005600 01  WS-PROGRAM-SWITCHES.
005700     03  WS-FR-AMT-ERROR-SW  PIC  X(01)      VALUE 'N'.
005800         88  FROM-AMT-IS-IN-ERROR            VALUE 'Y'.
005900     03  WS-TO-AMT-ERROR-SW  PIC  X(01)      VALUE 'N'.
006000         88  TO-AMT-IS-IN-ERROR              VALUE 'Y'.
006100     03  WS-ERR-MESSAGE      PIC  X(60)      VALUE SPACES.
006200*
006300 01  FILLER                  PIC  X(12)      VALUE '** WS-END **'.
006400/
006500 LINKAGE SECTION.
006600 01  DFHCOMMAREA.
006700     COPY MB60WS.
006800/         MERCHANT DETAIL HISTORY SCREEN 00 MAP DSECT
006900     COPY MBIT00.
007000/         MERCHANT DETAIL HISTORY SCREEN 00 MAP REDEFINITION
007100     COPY MBIT00R.
007200/         ORG RECORD LAYOUT
007300     COPY MMOCRL.
007400/         MERCHANT MASTER RECORD LAYOUT
007500     COPY MMMMRL.
007600/         STORE MASTER RECORD LAYOUT
007700     COPY MMSMRL.
007800/         MERCHANT DETAIL HISTORY RECORD LAYOUT
007900     COPY MMDHRL.
008000/         MERCHANT DETAIL HISTORY DISPLAY TEMPORARY STORAGE
008100     COPY MBITTS.
008200/
008300 PROCEDURE DIVISION.
008400 0000-HOUSEKEEPING SECTION.
008500 0100-INIT.
008600*
008700     MOVE MBCA-EIBAID            TO WS-SAVE-EIBAID.
008800     SET MBCA-EIBAID-ENTER       TO TRUE.
008900*
009000     MOVE 'PC01'                 TO MBCA-PROGRAM-LOCATION.
009100     PERFORM MB70PD-ON-LINE-HOUSEKEEPING
009200                                 THRU MB70PD-OLH-EXIT.
009300*
009400     MOVE WS-SAVE-EIBAID         TO MBCA-EIBAID.
009500     MOVE MBCA-TERMINAL-ID       TO TS-QN-TERMID.
009600*
009700     IF  MBCA-RECEIVE-SCREEN
009800         GO TO 2000-RECEIVE-SCREEN.
009900*
010000 1000-SEND-SCREEN SECTION.
010100*
010200****************************************************************
010300*    GET CICS STORAGE NEEDED FOR THE MAP                       *
010400****************************************************************
010500*
010600     MOVE 'SC01'                 TO MBCA-PROGRAM-LOCATION.
010700     PERFORM MB60PD-GETMAIN-FOR-MAP
010800                                 THRU MB60PD-GFM-EXIT.
010900*
011000****************************************************************
011100*    ACQUIRE MAIN STORAGE FOR TEMP STORAGE RECORD              *
011200****************************************************************
011300*
011400     MOVE 'TS01'                 TO MBCA-PROGRAM-LOCATION.
011500     PERFORM 9100-TEMP-STORAGE-GETMAIN
011600                                 THRU 9199-TSG-EXIT.
011700*
011800     EXEC CICS HANDLE CONDITION
011900               QIDERR (1100-BUILD-SCREEN)
012000          END-EXEC.
012100*
012200***********************************************
012300*    READ THE TEMP STORAGE RECORD             *
012400***********************************************
012500*
012600     MOVE 'TS02'                 TO MBCA-PROGRAM-LOCATION.
012700     PERFORM 9200-TEMP-STORAGE-READ
012800                                 THRU 9299-TSR-EXIT.
012900*
013000***********************************************
013100*    DELETE THE TEMP STORAGE RECORD           *
013200***********************************************
013300*
013400     MOVE 'TS03'                 TO MBCA-PROGRAM-LOCATION.
013500     PERFORM 9300-TEMP-STORAGE-DELETE
013600                                 THRU 9399-TSD-EXIT.
013700*
013800     PERFORM 9600-BUILD-SCREEN   THRU 9699-BS-EXIT.
013900*
014000 1100-BUILD-SCREEN.
014100*
014200****************************************************************
014300*    INITIALIZE THE STANDARD MAP LINES                         *
014400****************************************************************
014500*
014600     MOVE SS08WS-CURSOR          TO IT00-ORG-L.
014700     MOVE 00                     TO MBCA-SCREEN-NBR.
014800     PERFORM MB60PD-INIT-STD-MAP-LINES
014900                                 THRU MB60PD-ISML-EXIT.
015000*
015100     MOVE DFHBMASK               TO IT00-CURRENT-PAGE-A.
015200*
015300****************************************************************
015400*    SEND THE MAP                                              *
015500****************************************************************
015600*
015700     MOVE 'BM01'                 TO MBCA-PROGRAM-LOCATION.
015800     PERFORM MB60PD-SEND-MAP-WITH-ERASE
015900                                 THRU MB60PD-SMWE-EXIT.
016000*
016100****************************************************************
016200*    RETURN TO CICS                                            *
016300****************************************************************
016400*
016500     MOVE 'PC02'                 TO MBCA-PROGRAM-LOCATION.
016600     PERFORM MB70PD-RETURN-TRANS-ID
016700                                 THRU MB70PD-RTI-EXIT.
016800/
016900 2000-RECEIVE-SCREEN SECTION.
017000*
017100     IF  MBCA-EIBAID-CLEAR
017200         MOVE 'TS04'             TO MBCA-PROGRAM-LOCATION
017300         PERFORM 9300-TEMP-STORAGE-DELETE
017400                                 THRU 9399-TSD-EXIT
017500         MOVE 'PC03'             TO MBCA-PROGRAM-LOCATION
017600         PERFORM MB70PD-ON-LINE-HOUSEKEEPING
017700                                 THRU MB70PD-OLH-EXIT.
017800*
017900****************************************************************
018000*    THIS SECTION RECEIVES THE LOCATE SCREEN                   *
018100****************************************************************
018200*
018300     MOVE 'BM02'                 TO MBCA-PROGRAM-LOCATION.
018400     PERFORM MB60PD-RECEIVE-MAP  THRU MB60PD-RM-EXIT.
018500*
018600****************************************************************
018700*    CHECK FOR ANOTHER TRANSACTION ID ENTERED BY THE USER      *
018800****************************************************************
018900*
019000     MOVE 'PC04'                 TO MBCA-PROGRAM-LOCATION.
019100     PERFORM MB60PD-NEW-TRANS-ROUTINE
019200                                 THRU MB60PD-NTR-EXIT.
019300*
019400 2100-EDIT-SCREEN.
019500*
019600     MOVE 'N'                    TO SS08WS-ERROR.
019700     MOVE MBCA-EIBAID            TO SS08WS-EIBAID.
019800*
019900     IF  (IT00-ORG-L IS LESS THAN 1
020000     AND  IT00-FILE-NBR-L IS LESS THAN 1
020100     AND  IT00-TRANS-CODE-L IS LESS THAN 1
020200     AND  IT00-LOGIC-MODULE-L IS LESS THAN 1
020300     AND  IT00-CARD-PROD-L IS LESS THAN 1
020400     AND  IT00-QUAL-LEVEL-L IS LESS THAN 1
020500     AND  IT00-PLAN-NBR-L IS LESS THAN 1
020600     AND  IT00-BATCH-DATE-L IS LESS THAN 1
020700     AND  IT00-BATCH-NUMBER-L IS LESS THAN 1
020800     AND  IT00-BATCH-SOURCE-L IS LESS THAN 1
020900     AND  IT00-GL-SOURCE-L IS LESS THAN 1
021000     AND  IT00-POSTING-DATE-L IS LESS THAN 1
021100     AND  IT00-SETT-DEST-L IS LESS THAN 1
021200     AND  IT00-SETT-FLAG-L IS LESS THAN 1
021300     AND  IT00-STMT-FLAG-L IS LESS THAN 1
021400     AND  IT00-FROM-TRANS-AMT-L IS LESS THAN 1
021500     AND  IT00-TO-TRANS-AMT-L IS LESS THAN 1)
021600     AND (SS08WS-VALID-PF-KEY
021700     OR   SS08WS-EIBAID-VALID-PF-KEY)
021800         SET MBCA-INITIAL-SCREEN-NBR
021900                                 TO TRUE
022000         GO TO 2690-TRANSFER-XCTL.
022100*
022200*****************************************************
022300*    ACQUIRE MAIN STORAGE FOR TEMP STORAGE RECORD   *
022400*****************************************************
022500*
022600     MOVE SPACES                 TO WS-ERR-MESSAGE.
022700     MOVE SPACES                 TO IT00-ERR-MESSAGE.
022800*
022900     MOVE 'TS05'                 TO MBCA-PROGRAM-LOCATION.
023000     PERFORM 9100-TEMP-STORAGE-GETMAIN
023100                                 THRU 9199-TSG-EXIT.
023200*
023300     PERFORM 9700-INITIALIZE-SEL-AREA
023400                                 THRU 9799-ISA-EXIT
023500         VARYING X-MBCA-MBIT-CRIT FROM +1 BY +1
023600         UNTIL   X-MBCA-MBIT-CRIT IS GREATER THAN +13.
023700*
023800     SET X-MBCA-MBIT-CRIT        TO +1.
023900*
024000 2110-EDIT-ORG.
024100*
024200     MOVE DFHBMUNF               TO IT00-ORG-A.
024300     MOVE DFHBMASK               TO IT00-ORG-LP-A
024400                                    IT00-ORG-RP-A.
024500*
024600     IF  IT00-ORG-L IS EQUAL TO ZEROES
024700     OR  IT00-ORG IS NOT NUMERIC
024800         MOVE MBEMWS-INVALID-ORG TO WS-ERR-MESSAGE
024900         PERFORM 9800-MOVE-ERROR-MESSAGE
025000                                 THRU 9899-MEM-EXIT
025100         GO TO 2110-ORG-ERROR.
025200*
025300     IF  IT00-ORG IS LESS THAN MBCA-ORG-LOW
025400     OR  IT00-ORG IS GREATER THAN MBCA-ORG-HIGH
025500         MOVE MBEMWS-INVALID-ORG TO WS-ERR-MESSAGE
025600         PERFORM 9800-MOVE-ERROR-MESSAGE
025700                                 THRU 9899-MEM-EXIT
025800         GO TO 2110-ORG-ERROR.
025900*
026000 2110-READ-ORG.
026100*
026200****************************************************************
026300*    READ THE ORGANIZATION FILE                                *
026400****************************************************************
026500*
026600     MOVE IT00-ORG               TO MBIOWS-MMOC-ORG.
026700     MOVE 'FC01'                 TO MBCA-PROGRAM-LOCATION.
026800     MOVE SS08WS-CICS-FC-NOTFND  TO MBIORO-TEMP-STATUS-1.
026900     SET MBIORO-READ-RANDOM      TO TRUE.
027000     PERFORM MMOCAO-ACCESS       THRU MMOCAO-ACCESS-EXIT.
027100*
027200     IF  SS08WS-RC-FC-VALID-RTN-CODE
027300         MOVE MMOC-CURRENCY-CODE TO MBCA-CURRENCY-CODE
027400         MOVE MMOC-CURRENCY-NOD  TO MBCA-CURRENCY-NOD
027500         MOVE MMOC-PER-ITEM-NOD  TO MBCA-PER-ITEM-NOD
027600         MOVE MMOC-PERCENT-NOD   TO MBCA-PERCENT-NOD
027700         IF  MMOC-ADD-PENDING
027800             MOVE MBEMWS-ADD-PENDING
027900                                 TO WS-ERR-MESSAGE
028000             PERFORM 9800-MOVE-ERROR-MESSAGE
028100                                 THRU 9899-MEM-EXIT
028200         ELSE
028300             IF  MMOC-REC-INCOMPLETE
028400             OR  MMOC-REC-PURGED
028500                 MOVE MBEMWS-NOT-ACTIVE
028600                                 TO WS-ERR-MESSAGE
028700                 PERFORM 9800-MOVE-ERROR-MESSAGE
028800                                 THRU 9899-MEM-EXIT
028900             ELSE
029000                 MOVE IT00-ORG   TO MBCA-MERCHANT-ORG
029100                                    MBITTS-ORG
029200                 MOVE 'ORGANIZATION  '
029300                                 TO MBCA-MBIT-SEL-CRITERIA
029400                                    (X-MBCA-MBIT-CRIT)
029500                 SET X-MBCA-MBIT-CRIT
029600                                 UP BY +1
029700                 GO TO 2120-EDIT-FILE-TYPE
029800     ELSE
029900         MOVE MBEMWS-NOT-ON-FILE TO WS-ERR-MESSAGE
030000         PERFORM 9800-MOVE-ERROR-MESSAGE
030100                                 THRU 9899-MEM-EXIT.
030200*
030300 2110-ORG-ERROR.
030400*
030500     MOVE 'Y'                    TO SS08WS-ERROR.
030600     MOVE SS08WS-CURSOR          TO IT00-ORG-L.
030700     MOVE DFHBMASB               TO IT00-ORG-LP-A
030800                                    IT00-ORG-RP-A.
030900     MOVE DFHBMNBF               TO IT00-ORG-A.
031000*
031100 2120-EDIT-FILE-TYPE.
031200*
031300     IF  IT00-FILE-TYPE-L IS LESS THAN 1
031400         MOVE 'M'                TO MBITTS-FILE-TYPE
031500     ELSE
031600         IF  NOT IT00-VALID-FILE-TYPE
031700             MOVE DFHBMUBF       TO IT00-FILE-TYPE-A
031800             MOVE DFHBMASB       TO IT00-FILE-TYPE-LP-A
031900                                    IT00-FILE-TYPE-RP-A
032000             MOVE SS08WS-CURSOR  TO IT00-FILE-TYPE-L
032100             MOVE 'Y'            TO SS08WS-ERROR
032200             MOVE 'FILE TYPE MUST BE A  M  OR  S'
032300                                 TO WS-ERR-MESSAGE
032400             PERFORM 9800-MOVE-ERROR-MESSAGE
032500                                 THRU 9899-MEM-EXIT
032600         ELSE
032700             MOVE IT00-FILE-TYPE
032800                                 TO MBITTS-FILE-TYPE
032900             MOVE 'FILE TYPE   '
033000                                 TO MBCA-MBIT-SEL-CRITERIA
033100                                    (X-MBCA-MBIT-CRIT)
033200             SET X-MBCA-MBIT-CRIT
033300                                 UP BY +1
033400             MOVE DFHBMFSE       TO IT00-FILE-TYPE-A
033500             MOVE DFHBMASK       TO IT00-FILE-TYPE-LP-A
033600                                    IT00-FILE-TYPE-RP-A.
033700*
033800 2130-EDIT-FILE-NBR.
033900*
034000     IF  IT00-FILE-NBR IS NOT NUMERIC
034100         MOVE MBEMWS-INVALID-MERCHANT
034200                                 TO WS-ERR-MESSAGE
034300         PERFORM 9800-MOVE-ERROR-MESSAGE
034400                                 THRU 9899-MEM-EXIT
034500         GO TO 2130-FILE-NBR-ERROR
034600     ELSE
034700         MOVE IT00-FILE-NBR      TO WS-HOLD-MER-STORE.
034800*
034900     IF  IT00-STORE-FILE-TYPE
035000         GO TO 2130-STORE-READ
035100     ELSE
035200         MOVE ZEROES             TO MBITTS-STORE.
035300*
035400 2130-MERCHANT-READ.
035500*
035600****************************************************************
035700*    READ THE MERCHANT RECORD                                  *
035800****************************************************************
035900*
036000     IF  SS08WS-ERROR IS EQUAL TO 'Y'
036100         GO TO 2140-EDIT-TRANS-CODE.
036200*
036300     MOVE IT00-ORG               TO MBIOWS-MMMM-ORG.
036400     MOVE WS-HOLD-MER-STORE      TO MBIOWS-MMMM-MERCHANT.
036500     MOVE SS08WS-CICS-FC-NOTFND  TO MBIORO-TEMP-STATUS-1.
036600     MOVE 'FC02'                 TO MBCA-PROGRAM-LOCATION.
036700     SET MBIORO-READ-RANDOM      TO TRUE.
036800     PERFORM MMMMAO-ACCESS       THRU MMMMAO-ACCESS-EXIT.
036900*
037000     IF  SS08WS-RC-FC-NOTFND
037100         MOVE MBEMWS-NOT-ON-FILE TO WS-ERR-MESSAGE
037200         PERFORM 9800-MOVE-ERROR-MESSAGE
037300                                 THRU 9899-MEM-EXIT
037400     ELSE
037500         IF  MMMM-ADD-PENDING
037600             MOVE MBEMWS-ADD-PENDING
037700                                 TO WS-ERR-MESSAGE
037800             PERFORM 9800-MOVE-ERROR-MESSAGE
037900                                 THRU 9899-MEM-EXIT
038000         ELSE
038100             IF  MMMM-REC-INCOMPLETE
038200             OR  MMMM-REC-PURGING
038300                 MOVE MBEMWS-NOT-ACTIVE
038400                                 TO WS-ERR-MESSAGE
038500                 PERFORM 9800-MOVE-ERROR-MESSAGE
038600                                 THRU 9899-MEM-EXIT
038700             ELSE
038800                 IF  MMMM-REC-PURGED
038900                     MOVE MBEMWS-REC-PURGED
039000                                 TO WS-ERR-MESSAGE
039100                     PERFORM 9800-MOVE-ERROR-MESSAGE
039200                                 THRU 9899-MEM-EXIT
039300                 ELSE
039400                     MOVE WS-HOLD-MER-STORE
039500                                 TO MBITTS-MERCHANT
039600                                    MBCA-MERCHANT
039700                     MOVE 'MERCHANT      '
039800                                 TO MBCA-MBIT-SEL-CRITERIA
039900                                    (X-MBCA-MBIT-CRIT)
040000                     SET X-MBCA-MBIT-CRIT
040100                                 UP BY +1
040200                     GO TO 2140-EDIT-TRANS-CODE.
040300*
040400 2130-FILE-NBR-ERROR.
040500*
040600     MOVE 'Y'                    TO SS08WS-ERROR.
040700     MOVE SS08WS-CURSOR          TO IT00-FILE-NBR-L.
040800     MOVE DFHBMASB               TO IT00-FILE-NBR-LP-A
040900                                    IT00-FILE-NBR-RP-A.
041000     MOVE DFHBMNBF               TO IT00-FILE-NBR-A.
041100*
041200 2130-STORE-READ.
041300*
041400****************************************************************
041500*    READ THE STORE RECORD                                     *
041600****************************************************************
041700*
041800     IF  SS08WS-ERROR IS EQUAL TO 'Y'
041900         GO TO 2140-EDIT-TRANS-CODE.
042000*
042100     MOVE IT00-ORG               TO MBIOWS-MMSM-ORG.
042200     MOVE WS-HOLD-MER-STORE      TO MBIOWS-MMSM-STORE.
042300     MOVE SS08WS-CICS-FC-NOTFND  TO MBIORO-TEMP-STATUS-1.
042400     MOVE 'FC03'                 TO MBCA-PROGRAM-LOCATION.
042500     SET MBIORO-READ-RANDOM      TO TRUE.
042600     PERFORM MMSMAO-ACCESS       THRU MMSMAO-ACCESS-EXIT.
042700*
042800     IF  SS08WS-RC-FC-NOTFND
042900         MOVE MBEMWS-NOT-ON-FILE TO WS-ERR-MESSAGE
043000         PERFORM 9800-MOVE-ERROR-MESSAGE
043100                                 THRU 9899-MEM-EXIT
043200     ELSE
043300         IF  MMSM-ADD-PENDING
043400             MOVE MBEMWS-ADD-PENDING
043500                                 TO WS-ERR-MESSAGE
043600             PERFORM 9800-MOVE-ERROR-MESSAGE
043700                                 THRU 9899-MEM-EXIT
043800         ELSE
043900             IF  MMSM-REC-INCOMPLETE
044000             OR  MMSM-REC-PURGING
044100                 MOVE MBEMWS-NOT-ACTIVE
044200                                 TO WS-ERR-MESSAGE
044300                 PERFORM 9800-MOVE-ERROR-MESSAGE
044400                                 THRU 9899-MEM-EXIT
044500             ELSE
044600                 IF  MMSM-REC-PURGED
044700                     MOVE MBEMWS-REC-PURGED
044800                                 TO WS-ERR-MESSAGE
044900                     PERFORM 9800-MOVE-ERROR-MESSAGE
045000                                 THRU 9899-MEM-EXIT
045100                 ELSE
045200                     MOVE WS-HOLD-MER-STORE
045300                                 TO MBITTS-STORE
045400                                    MBCA-STORE
045500                     MOVE MMSM-MERCHANT-ID
045600                                 TO MBITTS-MERCHANT
045700                                    MBCA-MERCHANT
045800                     MOVE 'STORE       '
045900                                 TO MBCA-MBIT-SEL-CRITERIA
046000                                    (X-MBCA-MBIT-CRIT)
046100                     SET X-MBCA-MBIT-CRIT
046200                                 UP BY +1
046300                     GO TO 2140-EDIT-TRANS-CODE.
046400*
046500 2130-STORE-ERROR.
046600*
046700     MOVE 'Y'                    TO SS08WS-ERROR.
046800     MOVE SS08WS-CURSOR          TO IT00-FILE-NBR-L.
046900     MOVE DFHBMASB               TO IT00-FILE-NBR-LP-A
047000                                    IT00-FILE-NBR-RP-A.
047100     MOVE DFHBMNBF               TO IT00-FILE-NBR-A.
047200*
047300 2140-EDIT-TRANS-CODE.
047400*
047500     IF  IT00-TRANS-CODE-L IS LESS THAN 1
047600         MOVE ZEROES             TO MBITTS-TRANS-CODE
047700     ELSE
047800         IF  IT00-TRANS-CODE IS NOT NUMERIC
047900             MOVE DFHBMNBF       TO IT00-TRANS-CODE-A
048000             MOVE DFHBMASB       TO IT00-TRANS-CODE-LP-A
048100                                    IT00-TRANS-CODE-RP-A
048200             MOVE SS08WS-CURSOR  TO IT00-TRANS-CODE-L
048300             MOVE 'Y'            TO SS08WS-ERROR
048400             MOVE 'TRANS CODE IS NOT NUMERIC'
048500                                 TO WS-ERR-MESSAGE
048600             PERFORM 9800-MOVE-ERROR-MESSAGE
048700                                 THRU 9899-MEM-EXIT
048800         ELSE
048900             MOVE IT00-TRANS-CODE
049000                                 TO MBITTS-TRANS-CODE
049100             MOVE 'TRAN CODE     '
049200                                 TO MBCA-MBIT-SEL-CRITERIA
049300                                    (X-MBCA-MBIT-CRIT)
049400             SET X-MBCA-MBIT-CRIT
049500                                 UP BY +1
049600             MOVE DFHBMUNF       TO IT00-TRANS-CODE-A
049700             MOVE DFHBMASK       TO IT00-TRANS-CODE-LP-A
049800                                    IT00-TRANS-CODE-RP-A.
049900*
050000 2150-EDIT-LOGIC-MODULE.
050100*
050200     IF  IT00-LOGIC-MODULE-L IS LESS THAN 1
050300         SET MBITTS-LOGIC-MODULE-ALL
050400                                 TO TRUE
050500     ELSE
050600         IF  IT00-LOGIC-MODULE IS NOT NUMERIC
050700             MOVE DFHBMNBF       TO IT00-LOGIC-MODULE-A
050800             MOVE DFHBMASB       TO IT00-LOGIC-MODULE-LP-A
050900                                    IT00-LOGIC-MODULE-RP-A
051000             MOVE SS08WS-CURSOR  TO IT00-LOGIC-MODULE-L
051100             MOVE 'Y'            TO SS08WS-ERROR
051200             MOVE 'LOGIC MODULE IS NOT NUMERIC'
051300                                 TO WS-ERR-MESSAGE
051400             PERFORM 9800-MOVE-ERROR-MESSAGE
051500                                 THRU 9899-MEM-EXIT
051600         ELSE
051700             MOVE IT00-LOGIC-MODULE
051800                                 TO MBITTS-LOGIC-MODULE
051900             MOVE 'LOGIC MODULE'
052000                                 TO MBCA-MBIT-SEL-CRITERIA
052100                                    (X-MBCA-MBIT-CRIT)
052200             SET X-MBCA-MBIT-CRIT
052300                                 UP BY +1
052400             MOVE DFHBMUNF       TO IT00-LOGIC-MODULE-A
052500             MOVE DFHBMASK       TO IT00-LOGIC-MODULE-LP-A
052600                                    IT00-LOGIC-MODULE-RP-A.
052700*
052800 2160-EDIT-CARD-PROD.
052900*
053000     IF  IT00-CARD-PROD-L IS LESS THAN 1
053100         SET MBITTS-CARD-PROD-ALL
053200                                 TO TRUE
053300     ELSE
053400         IF  IT00-CARD-PROD IS NOT NUMERIC
053500             MOVE DFHBMNBF       TO IT00-CARD-PROD-A
053600             MOVE DFHBMASB       TO IT00-CARD-PROD-LP-A
053700                                    IT00-CARD-PROD-RP-A
053800             MOVE SS08WS-CURSOR  TO IT00-CARD-PROD-L
053900             MOVE 'Y'            TO SS08WS-ERROR
054000             MOVE 'CARD PROD IS NOT NUMERIC   '
054100                                 TO WS-ERR-MESSAGE
054200             PERFORM 9800-MOVE-ERROR-MESSAGE
054300                                 THRU 9899-MEM-EXIT
054400         ELSE
054500             MOVE IT00-CARD-PROD
054600                                 TO MBITTS-CARD-PROD
054700             MOVE 'CARD PROD     '
054800                                 TO MBCA-MBIT-SEL-CRITERIA
054900                                    (X-MBCA-MBIT-CRIT)
055000             SET X-MBCA-MBIT-CRIT
055100                                 UP BY +1
055200             MOVE DFHBMUNF       TO IT00-CARD-PROD-A
055300             MOVE DFHBMASK       TO IT00-CARD-PROD-LP-A
055400                                    IT00-CARD-PROD-RP-A.
055500*
055600 2170-EDIT-QUAL-LEVEL.
055700*
055800     IF  IT00-QUAL-LEVEL-L IS LESS THAN 1
055900         MOVE ZEROES             TO MBITTS-QUAL-LEVEL
056000     ELSE
056100         IF  IT00-QUAL-LEVEL IS NOT NUMERIC
056200             MOVE DFHBMNBF       TO IT00-QUAL-LEVEL-A
056300             MOVE DFHBMASB       TO IT00-QUAL-LEVEL-LP-A
056400                                    IT00-QUAL-LEVEL-RP-A
056500             MOVE SS08WS-CURSOR  TO IT00-QUAL-LEVEL-L
056600             MOVE 'Y'            TO SS08WS-ERROR
056700             MOVE 'CARD PROD IS NOT NUMERIC   '
056800                                 TO WS-ERR-MESSAGE
056900             PERFORM 9800-MOVE-ERROR-MESSAGE
057000                                 THRU 9899-MEM-EXIT
057100         ELSE
057200             MOVE IT00-QUAL-LEVEL
057300                                 TO MBITTS-QUAL-LEVEL
057400             MOVE 'QUAL LEVEL    '
057500                                 TO MBCA-MBIT-SEL-CRITERIA
057600                                    (X-MBCA-MBIT-CRIT)
057700             SET X-MBCA-MBIT-CRIT
057800                                 UP BY +1
057900             MOVE DFHBMUNF       TO IT00-QUAL-LEVEL-A
058000             MOVE DFHBMASK       TO IT00-QUAL-LEVEL-LP-A
058100                                    IT00-QUAL-LEVEL-RP-A.
058200*
058300 2180-EDIT-PLAN-NBR.
058400*
058500     IF  IT00-PLAN-NBR-L IS LESS THAN 1
058600         SET MBITTS-PLAN-NBR-ALL TO TRUE
058700     ELSE
058800         IF  IT00-PLAN-NBR IS NOT NUMERIC
058900             MOVE DFHBMNBF       TO IT00-PLAN-NBR-A
059000             MOVE DFHBMASB       TO IT00-PLAN-NBR-LP-A
059100                                    IT00-PLAN-NBR-RP-A
059200             MOVE SS08WS-CURSOR  TO IT00-PLAN-NBR-L
059300             MOVE 'Y'            TO SS08WS-ERROR
059400             MOVE 'PLAN NBR IS NOT NUMERIC    '
059500                                 TO WS-ERR-MESSAGE
059600             PERFORM 9800-MOVE-ERROR-MESSAGE
059700                                 THRU 9899-MEM-EXIT
059800         ELSE
059900             MOVE IT00-PLAN-NBR
060000                                 TO MBITTS-PLAN-NBR
060100             MOVE 'PLAN NBR    '
060200                                 TO MBCA-MBIT-SEL-CRITERIA
060300                                    (X-MBCA-MBIT-CRIT)
060400             SET X-MBCA-MBIT-CRIT
060500                                 UP BY +1
060600             MOVE DFHBMUNF       TO IT00-PLAN-NBR-A
060700             MOVE DFHBMASK       TO IT00-PLAN-NBR-LP-A
060800                                    IT00-PLAN-NBR-RP-A.
060900*
061000 2190-EDIT-BATCH-DATE.
061100*
061200     IF  IT00-BATCH-DATE-L IS LESS THAN 1
061300         MOVE ZEROES             TO MBITTS-BATCH-DATE
061400     ELSE
061500         IF  IT00-BATCH-DATE IS NOT NUMERIC
061600             MOVE DFHBMNBF       TO IT00-BATCH-DATE-A
061700             MOVE DFHBMASB       TO IT00-BATCH-DATE-LP-A
061800                                    IT00-BATCH-DATE-RP-A
061900             MOVE SS08WS-CURSOR  TO IT00-BATCH-DATE-L
062000             MOVE 'Y'            TO SS08WS-ERROR
062100             MOVE 'BATCH DATE IS NOT NUMERIC'
062200                                 TO WS-ERR-MESSAGE
062300             PERFORM 9800-MOVE-ERROR-MESSAGE
062400                                 THRU 9899-MEM-EXIT
062500         ELSE
062600             MOVE IT00-BATCH-DATE
062700                                 TO WS-WORK-DATE
062800             PERFORM 9500-VERIFY-DATE
062900                                 THRU 9599-VD-EXIT
063000             IF  SS01WS-DATE-IS-INVALID
063100                 MOVE DFHBMNBF   TO IT00-BATCH-DATE-A
063200                 MOVE DFHBMASB   TO IT00-BATCH-DATE-LP-A
063300                                    IT00-BATCH-DATE-RP-A
063400                 MOVE SS08WS-CURSOR TO IT00-BATCH-DATE-L
063500                 MOVE 'Y'        TO SS08WS-ERROR
063600                 MOVE 'BATCH DATE IS NOT CORRECT'
063700                                 TO WS-ERR-MESSAGE
063800                 PERFORM 9800-MOVE-ERROR-MESSAGE
063900                                 THRU 9899-MEM-EXIT
064000             ELSE
064100                 MOVE SS01WS-DATE
064200                                 TO IT00-BATCH-DATE
064300                 PERFORM SS07PD-GREG-TO-JUL
064400                                 THRU SS07PD-GTJ-EXIT
064500                 MOVE SS01WS-JULIAN
064600                                 TO MBITTS-BATCH-DATE
064700                 MOVE 'BATCH DATE    '
064800                                 TO MBCA-MBIT-SEL-CRITERIA
064900                                    (X-MBCA-MBIT-CRIT)
065000                 SET X-MBCA-MBIT-CRIT
065100                                 UP BY +1
065200                 MOVE DFHBMUNF   TO IT00-BATCH-DATE-A
065300                 MOVE DFHBMASK   TO IT00-BATCH-DATE-LP-A
065400                                    IT00-BATCH-DATE-RP-A.
065500*
065600 2200-EDIT-BATCH-NUMBER.
065700*
065800     IF  IT00-BATCH-NUMBER-L IS LESS THAN 1
065900         MOVE ZEROES             TO MBITTS-BATCH-NUMBER
066000     ELSE
066100         IF  IT00-BATCH-NUMBER IS NOT NUMERIC
066200             MOVE DFHBMNBF       TO IT00-BATCH-NUMBER-A
066300             MOVE DFHBMASB       TO IT00-BATCH-NUMBER-LP-A
066400                                    IT00-BATCH-NUMBER-RP-A
066500             MOVE SS08WS-CURSOR  TO IT00-BATCH-NUMBER-L
066600             MOVE 'Y'            TO SS08WS-ERROR
066700             MOVE 'BATCH NUMBER IS NOT NUMERIC'
066800                                 TO WS-ERR-MESSAGE
066900             PERFORM 9800-MOVE-ERROR-MESSAGE
067000                                 THRU 9899-MEM-EXIT
067100         ELSE
067200             MOVE IT00-BATCH-NUMBER
067300                                 TO MBITTS-BATCH-NUMBER
067400             MOVE 'BATCH NUMBER  '
067500                                 TO MBCA-MBIT-SEL-CRITERIA
067600                                    (X-MBCA-MBIT-CRIT)
067700             SET X-MBCA-MBIT-CRIT
067800                                 UP BY +1
067900             MOVE DFHBMUNF       TO IT00-BATCH-NUMBER-A
068000             MOVE DFHBMASK       TO IT00-BATCH-NUMBER-LP-A
068100                                    IT00-BATCH-NUMBER-RP-A.
068200*
068300 2210-EDIT-BATCH-SOURCE.
068400*
068500     IF  IT00-BATCH-SOURCE-L IS LESS THAN 1
068600         SET MBITTS-BATCH-SOURCE-ALL
068700                                 TO TRUE
068800     ELSE
068900         IF  IT00-BATCH-SOURCE IS NOT NUMERIC
069000             MOVE DFHBMNBF       TO IT00-BATCH-SOURCE-A
069100             MOVE DFHBMASB       TO IT00-BATCH-SOURCE-LP-A
069200                                    IT00-BATCH-SOURCE-RP-A
069300             MOVE SS08WS-CURSOR  TO IT00-BATCH-SOURCE-L
069400             MOVE 'Y'            TO SS08WS-ERROR
069500             MOVE 'BATCH SOURCE IS NOT NUMERIC'
069600                                 TO WS-ERR-MESSAGE
069700             PERFORM 9800-MOVE-ERROR-MESSAGE
069800                                 THRU 9899-MEM-EXIT
069900         ELSE
070000             MOVE IT00-BATCH-SOURCE
070100                                 TO MBITTS-BATCH-SOURCE
070200             MOVE 'BATCH SOURCE  '
070300                                 TO MBCA-MBIT-SEL-CRITERIA
070400                                    (X-MBCA-MBIT-CRIT)
070500             SET X-MBCA-MBIT-CRIT
070600                                 UP BY +1
070700             MOVE DFHBMUNF       TO IT00-BATCH-SOURCE-A
070800             MOVE DFHBMASK       TO IT00-BATCH-SOURCE-LP-A
070900                                    IT00-BATCH-SOURCE-RP-A.
071000*
071100 2220-EDIT-GL-SOURCE.
071200*
071300     IF  IT00-GL-SOURCE-L IS LESS THAN 1
071400         SET MBITTS-GL-SOURCE-ALL
071500                                 TO TRUE
071600     ELSE
071700         IF  IT00-GL-SOURCE IS NOT NUMERIC
071800             MOVE DFHBMNBF       TO IT00-GL-SOURCE-A
071900             MOVE DFHBMASB       TO IT00-GL-SOURCE-LP-A
072000                                    IT00-GL-SOURCE-RP-A
072100             MOVE SS08WS-CURSOR  TO IT00-GL-SOURCE-L
072200             MOVE 'Y'            TO SS08WS-ERROR
072300             MOVE 'GL SOURCE IS NOT NUMERIC'
072400                                 TO WS-ERR-MESSAGE
072500             PERFORM 9800-MOVE-ERROR-MESSAGE
072600                                 THRU 9899-MEM-EXIT
072700         ELSE
072800             MOVE IT00-GL-SOURCE
072900                                 TO MBITTS-GL-SOURCE
073000             MOVE 'GL SOURCE   '
073100                                 TO MBCA-MBIT-SEL-CRITERIA
073200                                    (X-MBCA-MBIT-CRIT)
073300             SET X-MBCA-MBIT-CRIT
073400                                 UP BY +1
073500             MOVE DFHBMUNF       TO IT00-GL-SOURCE-A
073600             MOVE DFHBMASK       TO IT00-GL-SOURCE-LP-A
073700                                    IT00-GL-SOURCE-RP-A.
073800*
073900 2230-EDIT-POSTING-DATE.
074000*
074100     IF  IT00-POSTING-DATE-L IS LESS THAN 1
074200         MOVE ZEROES             TO MBITTS-POSTING-DATE
074300     ELSE
074400         IF  IT00-POSTING-DATE IS NOT NUMERIC
074500             MOVE DFHBMNBF       TO IT00-POSTING-DATE-A
074600             MOVE DFHBMASB       TO IT00-POSTING-DATE-LP-A
074700                                    IT00-POSTING-DATE-RP-A
074800             MOVE SS08WS-CURSOR  TO IT00-POSTING-DATE-L
074900             MOVE 'Y'            TO SS08WS-ERROR
075000             MOVE 'POSTING DATE IS NOT NUMERIC'
075100                                 TO WS-ERR-MESSAGE
075200             PERFORM 9800-MOVE-ERROR-MESSAGE
075300                                 THRU 9899-MEM-EXIT
075400         ELSE
075500             MOVE IT00-POSTING-DATE
075600                                 TO WS-WORK-DATE
075700             PERFORM 9500-VERIFY-DATE
075800                                 THRU 9599-VD-EXIT
075900             IF  SS01WS-DATE-IS-INVALID
076000                 MOVE DFHBMNBF   TO IT00-POSTING-DATE-A
076100                 MOVE DFHBMASB   TO IT00-POSTING-DATE-LP-A
076200                                    IT00-POSTING-DATE-RP-A
076300                 MOVE SS08WS-CURSOR TO IT00-POSTING-DATE-L
076400                 MOVE 'Y'        TO SS08WS-ERROR
076500                 MOVE 'POSTING DATE IS NOT CORRECT'
076600                                 TO WS-ERR-MESSAGE
076700                 PERFORM 9800-MOVE-ERROR-MESSAGE
076800                                 THRU 9899-MEM-EXIT
076900             ELSE
077000                 MOVE SS01WS-DATE
077100                                 TO IT00-POSTING-DATE
077200                 PERFORM SS07PD-GREG-TO-JUL
077300                                 THRU SS07PD-GTJ-EXIT
077400                 MOVE SS01WS-JULIAN
077500                                 TO MBITTS-POSTING-DATE
077600                 MOVE 'POSTING DATE  '
077700                                 TO MBCA-MBIT-SEL-CRITERIA
077800                                    (X-MBCA-MBIT-CRIT)
077900                 SET X-MBCA-MBIT-CRIT
078000                                 UP BY +1
078100                 MOVE DFHBMUNF   TO IT00-POSTING-DATE-A
078200                 MOVE DFHBMASK   TO IT00-POSTING-DATE-LP-A
078300                                    IT00-POSTING-DATE-RP-A.
078400*
078500 2240-EDIT-SETT-DEST.
078600*
078700     IF  IT00-SETT-DEST-L IS LESS THAN 1
078800         SET MBITTS-SETT-DEST-ALL
078900                                 TO TRUE
079000     ELSE
079100         IF  NOT IT00-VALID-SETT-DEST
079200             MOVE DFHBMNBF       TO IT00-SETT-DEST-A
079300             MOVE DFHBMASB       TO IT00-SETT-DEST-LP-A
079400                                    IT00-SETT-DEST-RP-A
079500             MOVE SS08WS-CURSOR  TO IT00-SETT-DEST-L
079600             MOVE 'Y'            TO SS08WS-ERROR
079700             MOVE 'SETT DEST IS NOT VALID  '
079800                                 TO WS-ERR-MESSAGE
079900             PERFORM 9800-MOVE-ERROR-MESSAGE
080000                                 THRU 9899-MEM-EXIT
080100         ELSE
080200             MOVE IT00-SETT-DEST
080300                                 TO MBITTS-SETT-DEST
080400             MOVE 'SETT DEST   '
080500                                 TO MBCA-MBIT-SEL-CRITERIA
080600                                    (X-MBCA-MBIT-CRIT)
080700             SET X-MBCA-MBIT-CRIT
080800                                 UP BY +1
080900             MOVE DFHBMUNF       TO IT00-SETT-DEST-A
081000             MOVE DFHBMASK       TO IT00-SETT-DEST-LP-A
081100                                    IT00-SETT-DEST-RP-A.
081200*
081300 2250-EDIT-SETT-FLAG.
081400*
081500     IF  IT00-SETT-FLAG-L IS LESS THAN 1
081600         SET MBITTS-SETT-FLAG-ALL
081700                                 TO TRUE
081800     ELSE
081900         IF  NOT IT00-VALID-SETT-FLAG
082000             MOVE DFHBMUBF       TO IT00-SETT-FLAG-A
082100             MOVE DFHBMASB       TO IT00-SETT-FLAG-LP-A
082200                                    IT00-SETT-FLAG-RP-A
082300             MOVE SS08WS-CURSOR  TO IT00-SETT-FLAG-L
082400             MOVE 'Y'            TO SS08WS-ERROR
082500             MOVE 'SETT FLAG IS NOT VALID  '
082600                                 TO WS-ERR-MESSAGE
082700             PERFORM 9800-MOVE-ERROR-MESSAGE
082800                                 THRU 9899-MEM-EXIT
082900         ELSE
083000             MOVE IT00-SETT-FLAG
083100                                 TO MBITTS-SETT-FLAG
083200             MOVE 'SETT FLAG   '
083300                                 TO MBCA-MBIT-SEL-CRITERIA
083400                                    (X-MBCA-MBIT-CRIT)
083500             SET X-MBCA-MBIT-CRIT
083600                                 UP BY +1
083700             MOVE DFHBMFSE       TO IT00-SETT-FLAG-A
083800             MOVE DFHBMASK       TO IT00-SETT-FLAG-LP-A
083900                                    IT00-SETT-FLAG-RP-A.
084000*
084100 2260-EDIT-STMT-FLAG.
084200*
084300     IF  IT00-STMT-FLAG-L IS LESS THAN 1
084400         SET MBITTS-STMT-FLAG-ALL
084500                                 TO TRUE
084600     ELSE
084700         IF  NOT IT00-VALID-STMT-FLAG
084800             MOVE DFHBMUBF       TO IT00-STMT-FLAG-A
084900             MOVE DFHBMASB       TO IT00-STMT-FLAG-LP-A
085000                                    IT00-STMT-FLAG-RP-A
085100             MOVE SS08WS-CURSOR  TO IT00-STMT-FLAG-L
085200             MOVE 'Y'            TO SS08WS-ERROR
085300             MOVE 'STMT FLAG IS NOT VALID  '
085400                                 TO WS-ERR-MESSAGE
085500             PERFORM 9800-MOVE-ERROR-MESSAGE
085600                                 THRU 9899-MEM-EXIT
085700         ELSE
085800             MOVE IT00-STMT-FLAG
085900                                 TO MBITTS-STMT-FLAG
086000             MOVE 'STMT FLAG   '
086100                                 TO MBCA-MBIT-SEL-CRITERIA
086200                                    (X-MBCA-MBIT-CRIT)
086300             SET X-MBCA-MBIT-CRIT
086400                                 UP BY +1
086500             MOVE DFHBMFSE       TO IT00-STMT-FLAG-A
086600             MOVE DFHBMASK       TO IT00-STMT-FLAG-LP-A
086700                                    IT00-STMT-FLAG-RP-A.
086800*
086900 2280-EDIT-FROM-TRANS-AMT.
087000*
087100     IF  IT00-FROM-TRANS-AMT-L IS LESS THAN 1
087200         MOVE ZEROES             TO MBITTS-FROM-TRANS-AMT
087300     ELSE
087400         IF  IT00-FROM-TRANS-AMT IS NOT NUMERIC
087500             MOVE DFHBMNBF       TO IT00-FROM-TRANS-AMT-A
087600             MOVE DFHBMASB       TO IT00-FROM-TRANS-AMT-LP-A
087700                                    IT00-FROM-TRANS-AMT-RP-A
087800             MOVE SS08WS-CURSOR  TO IT00-FROM-TRANS-AMT-L
087900             MOVE 'Y'            TO SS08WS-ERROR
088000                                    WS-FR-AMT-ERROR-SW
088100             MOVE 'FROM TRANS AMT IS NOT NUMERIC'
088200                                 TO WS-ERR-MESSAGE
088300             PERFORM 9800-MOVE-ERROR-MESSAGE
088400                                 THRU 9899-MEM-EXIT
088500         ELSE
088600             MOVE IT00-FROM-TRANS-AMT
088700                                 TO MBITTS-FROM-TRANS-AMT
088800             MOVE 'TRANS AMOUNT  '
088900                                 TO MBCA-MBIT-SEL-CRITERIA
089000                                    (X-MBCA-MBIT-CRIT)
089100             MOVE DFHBMUNF       TO IT00-FROM-TRANS-AMT-A
089200             MOVE DFHBMASK       TO IT00-FROM-TRANS-AMT-LP-A
089300                                    IT00-FROM-TRANS-AMT-RP-A.
089400*
089500 2290-EDIT-TO-TRANS-AMT.
089600*
089700     IF  IT00-TO-TRANS-AMT-L IS LESS THAN 1
089800         MOVE WS-NINES           TO MBITTS-TO-TRANS-AMT
089900     ELSE
090000         IF  IT00-TO-TRANS-AMT IS NOT NUMERIC
090100             MOVE DFHBMNBF       TO IT00-TO-TRANS-AMT-A
090200             MOVE DFHBMASB       TO IT00-TO-TRANS-AMT-LP-A
090300                                    IT00-TO-TRANS-AMT-RP-A
090400             MOVE SS08WS-CURSOR  TO IT00-TO-TRANS-AMT-L
090500             MOVE 'Y'            TO SS08WS-ERROR
090600                                    WS-TO-AMT-ERROR-SW
090700             MOVE 'TO TRANS AMT IS NOT NUMERIC'
090800                                 TO WS-ERR-MESSAGE
090900             PERFORM 9800-MOVE-ERROR-MESSAGE
091000                                 THRU 9899-MEM-EXIT
091100         ELSE
091200             MOVE IT00-TO-TRANS-AMT
091300                                 TO MBITTS-TO-TRANS-AMT
091400             MOVE 'TRANS AMOUNT  '
091500                                 TO MBCA-MBIT-SEL-CRITERIA
091600                                    (X-MBCA-MBIT-CRIT)
091700             MOVE DFHBMUNF       TO IT00-TO-TRANS-AMT-A
091800             MOVE DFHBMASK       TO IT00-TO-TRANS-AMT-LP-A
091900                                    IT00-TO-TRANS-AMT-RP-A.
092000*
092100 2300-CROSS-EDIT-AMOUNTS.
092200*
092300     IF  FROM-AMT-IS-IN-ERROR
092400     OR  TO-AMT-IS-IN-ERROR
092500         GO TO 2400-VALIDATE-ITEMS.
092600*
092700     IF  MBITTS-TO-TRANS-AMT IS LESS THAN MBITTS-FROM-TRANS-AMT
092800         MOVE DFHBMNBF           TO IT00-FROM-TRANS-AMT-A
092900                                    IT00-TO-TRANS-AMT-A
093000         MOVE DFHBMASB           TO IT00-FROM-TRANS-AMT-LP-A
093100                                    IT00-FROM-TRANS-AMT-RP-A
093200                                    IT00-TO-TRANS-AMT-LP-A
093300                                    IT00-TO-TRANS-AMT-RP-A
093400         MOVE SS08WS-CURSOR      TO IT00-TO-TRANS-AMT-L
093500         MOVE 'Y'                TO SS08WS-ERROR
093600                                    WS-FR-AMT-ERROR-SW
093700                                    WS-TO-AMT-ERROR-SW
093800         MOVE 'TO AMT IS LESS THAN FROM AMT '
093900                                 TO WS-ERR-MESSAGE
094000         PERFORM 9800-MOVE-ERROR-MESSAGE
094100                                 THRU 9899-MEM-EXIT.
094200*
094300 2400-VALIDATE-ITEMS.
094400*
094500     IF  SS08WS-ERROR IS EQUAL TO 'Y'
094600         GO TO 2440-CHECK-ERROR.
094700*
094800****************************************************************
094900*    START BROWSE THE DETAIL HISTORY FILE                     *
095000****************************************************************
095100*
095200     MOVE IT00-ORG               TO MBIOWS-MMDH-ORG.
095300     MOVE MBCA-MERCHANT          TO MBIOWS-MMDH-MERCHANT.
095400     MOVE ZEROES                 TO MBIOWS-MMDH-SEQ-NBR.
095500     MOVE 'FC04'                 TO MBCA-PROGRAM-LOCATION.
095600     SET MBIORO-STARTBR-GTE      TO TRUE.
095700     PERFORM MMDHAO-ACCESS       THRU MMDHAO-ACCESS-EXIT.
095800*
095900 2410-READ-DETAIL-HISTORY.
096000*
096100****************************************************************
096200*    READNEXT THE MERCHANT DETAIL HISTORY FILE                 *
096300****************************************************************
096400*
096500     MOVE 'FC05'                 TO MBCA-PROGRAM-LOCATION.
096600     SET MBIORO-READ-SEQ         TO TRUE.
096700     PERFORM MMDHAO-ACCESS       THRU MMDHAO-ACCESS-EXIT.
096800*
096900     IF  MMDH-ORG IS GREATER THAN MBITTS-ORG
097000     OR  MMDH-MERCHANT IS GREATER THAN MBITTS-MERCHANT
097100         MOVE 'NO RECORDS ON FILE FOR THE SELECTION CRITERIA'
097200                                 TO WS-ERR-MESSAGE
097300         PERFORM 9800-MOVE-ERROR-MESSAGE
097400                                 THRU 9899-MEM-EXIT
097500         MOVE 'Y'                TO SS08WS-ERROR
097600         MOVE SS08WS-CURSOR      TO IT00-ORG-L
097700         GO TO 2420-END-BROWSE.
097800*
097900     IF  MBITTS-STORE IS NOT EQUAL TO ZEROES
098000         IF  MBITTS-STORE IS NOT EQUAL TO MMDH-STORE
098100             GO TO 2410-READ-DETAIL-HISTORY.
098200*
098300     IF  MBITTS-TRANS-CODE IS NOT EQUAL TO ZEROES
098400         IF  MMDH-TRANS-CODE IS NOT EQUAL
098500                                 TO MBITTS-TRANS-CODE
098600             GO TO 2410-READ-DETAIL-HISTORY.
098700*
098800     IF  MBITTS-LOGIC-MODULE-ALL
098900         NEXT SENTENCE
099000     ELSE
099100         IF  MMDH-LOGIC-MODULE IS NOT EQUAL
099200                                 TO MBITTS-LOGIC-MODULE
099300             GO TO 2410-READ-DETAIL-HISTORY.
099400*
099500     IF  MBITTS-CARD-PROD-ALL
099600         NEXT SENTENCE
099700     ELSE
099800         IF  MMDH-PRODUCT IS NOT EQUAL
099900                                 TO MBITTS-CARD-PROD
100000             GO TO 2410-READ-DETAIL-HISTORY.
100100*
100200     IF  MBITTS-QUAL-LEVEL IS NOT EQUAL TO ZEROES
100300         IF  MMDH-QUAL-LEVEL IS NOT EQUAL
100400                                 TO MBITTS-QUAL-LEVEL
100500             GO TO 2410-READ-DETAIL-HISTORY.
100600*
100700     IF  MBITTS-PLAN-NBR-ALL
100800         NEXT SENTENCE
100900     ELSE
101000         IF  MMDH-PLAN IS NOT EQUAL
101100                                 TO MBITTS-PLAN-NBR
101200             GO TO 2410-READ-DETAIL-HISTORY.
101300*
101400     IF  MMDH-BATCH-DATE IS LESS THAN MBITTS-BATCH-DATE
101500         GO TO 2410-READ-DETAIL-HISTORY.
101600*
101700     IF  MBITTS-BATCH-NUMBER IS NOT EQUAL TO ZEROES
101800         IF  MMDH-BATCH-NBR IS NOT EQUAL
101900                                 TO MBITTS-BATCH-NUMBER
102000             GO TO 2410-READ-DETAIL-HISTORY.
102100*
102200     IF  MBITTS-BATCH-SOURCE-ALL
102300         NEXT SENTENCE
102400     ELSE
102500         IF  MMDH-BATCH-SOURCE IS NOT EQUAL
102600                                 TO MBITTS-BATCH-SOURCE
102700             GO TO 2410-READ-DETAIL-HISTORY.
102800*
102900     IF  MBITTS-GL-SOURCE-ALL
103000         NEXT SENTENCE
103100     ELSE
103200         IF  MMDH-GL-SOURCE IS NOT EQUAL TO MBITTS-GL-SOURCE
103300             GO TO 2410-READ-DETAIL-HISTORY.
103400*
103500     IF  MMDH-POST-DATE IS LESS THAN MBITTS-POSTING-DATE
103600         GO TO 2410-READ-DETAIL-HISTORY.
103700*
103800     IF  MBITTS-SETT-DEST-ALL
103900         NEXT SENTENCE
104000     ELSE
104100         IF  MMDH-SETT-ACCT IS NOT EQUAL TO MBITTS-SETT-DEST
104200             GO TO 2410-READ-DETAIL-HISTORY.
104300*
104400     IF  MBITTS-SETT-FLAG-ALL
104500         NEXT SENTENCE
104600     ELSE
104700         IF  MMDH-SETT-FLAG IS NOT EQUAL TO MBITTS-SETT-FLAG
104800             GO TO 2410-READ-DETAIL-HISTORY.
104900*
105000     IF  MBITTS-STMT-FLAG-ALL
105100         NEXT SENTENCE
105200     ELSE
105300         IF  MMDH-STMT-FLAG IS NOT EQUAL TO MBITTS-STMT-FLAG
105400             GO TO 2410-READ-DETAIL-HISTORY.
105500*
105600     IF  MMDH-AMOUNT IS LESS THAN MBITTS-FROM-TRANS-AMT
105700     OR  MMDH-AMOUNT IS GREATER THAN MBITTS-TO-TRANS-AMT
105800         GO TO 2410-READ-DETAIL-HISTORY.
105900*
106000     MOVE MMDH-SEQ-NBR           TO MBCA-MBIT-FIRST-SEQ-NBR
106100                                    MBCA-MBIT-FWD-SEQ-NBR.
106200     MOVE ' '                    TO MBCA-MBIT-RETURN-FLAG.
106300     MOVE 'Y'                    TO MBCA-MBIT-FIRST-TIME-FLAG.
106400*
106500 2420-END-BROWSE.
106600*
106700****************************************************************
106800*    END BROWSE THE DETAIL HISTORY FILE                        *
106900****************************************************************
107000*
107100     MOVE 'FC06'                 TO MBCA-PROGRAM-LOCATION.
107200     SET MBIORO-ENDBR            TO TRUE.
107300     PERFORM MMDHAO-ACCESS       THRU MMDHAO-ACCESS-EXIT.
107400*
107500 2440-CHECK-ERROR.
107600*
107700     IF  SS08WS-ERROR IS EQUAL TO 'N'
107800         MOVE 'TS06'             TO MBCA-PROGRAM-LOCATION
107900         PERFORM 9400-WRITE-QUEUE
108000                                 THRU 9499-WQ-EXIT
108100         GO TO 2600-SETUP-COMMAREA
108200     ELSE
108300         IF  SS08WS-VALID-PF-KEY
108400         OR  SS08WS-EIBAID-VALID-PF-KEY
108500             SET MBCA-INITIAL-SCREEN-NBR
108600                                 TO TRUE
108700             GO TO 2690-TRANSFER-XCTL.
108800*
108900 2450-SEND-MAP.
109000*
109100****************************************************************
109200*    SEND THE MAP                                              *
109300****************************************************************
109400*
109500     PERFORM MB60PD-INIT-STD-MAP-LINES
109600                                 THRU MB60PD-ISML-EXIT.
109700*
109800     MOVE DFHBMASK               TO IT00-CURRENT-PAGE-A.
109900*
110000     MOVE 'BM03'                 TO MBCA-PROGRAM-LOCATION.
110100     PERFORM MB60PD-SEND-MAP-DATA-ONLY
110200                                 THRU MB60PD-SMDO-EXIT.
110300*
110400****************************************************************
110500*    RETURN TO CICS                                            *
110600****************************************************************
110700*
110800     MOVE 'PC05'                 TO MBCA-PROGRAM-LOCATION.
110900     PERFORM MB70PD-RETURN-TRANS-ID
111000                                 THRU MB70PD-RTI-EXIT.
111100/
111200 2600-SETUP-COMMAREA.
111300*
111400****************************************************************
111500*    SET UP COMMAREA FIELDS AND TRANSFER TO THE NEXT PROGRAM   *
111600****************************************************************
111700*
111800     MOVE MBCA-EIBAID            TO SS08WS-EIBAID.
111900*
112000     MOVE MBIOWS-MMDH-DIRECT-KEY-CODE
112100                                 TO MBCA-KEY-CODE.
112200*
112300     PERFORM MB60PD-EDIT-PAGE-NBR
112400                                 THRU MB60PD-EPN-EXIT.
112500*
112600     IF  SS08WS-VALID-PF-KEY
112700     OR  SS08WS-EIBAID-VALID-PF-KEY
112800         SET MBCA-INITIAL-SCREEN-NBR
112900                                 TO TRUE.
113000*
113100 2690-TRANSFER-XCTL.
113200*
113300     MOVE 'PC06'                 TO MBCA-PROGRAM-LOCATION.
113400     PERFORM MB70PD-XCTL-TO-MBOXCTL
113500                                 THRU MB70PD-XTM-EXIT.
113600/
113700 9000-PERFORMED-ROUTINES-SECT SECTION.
113800*
113900 9100-TEMP-STORAGE-GETMAIN.
114000*
114100     EXEC CICS GETMAIN
114200               FLENGTH (LENGTH  OF MBITTS-RECORD)
114300               SET     (ADDRESS OF MBITTS-RECORD)
114400          END-EXEC.
114500*
114600 9199-TSG-EXIT.
114700     EXIT.
114800*
114900 9200-TEMP-STORAGE-READ.
115000*
115100     EXEC CICS READQ TS
115200               QUEUE   (TS-QUEUE-NAME)
115300               INTO    (MBITTS-RECORD)
115400               LENGTH  (LENGTH  OF MBITTS-RECORD)
115500               ITEM    (1)
115600          END-EXEC.
115700*
115800 9299-TSR-EXIT.
115900     EXIT.
116000*
116100 9300-TEMP-STORAGE-DELETE.
116200*
116300     EXEC CICS IGNORE CONDITION
116400               QIDERR
116500          END-EXEC.
116600*
116700     EXEC CICS DELETEQ TS
116800               QUEUE  (TS-QUEUE-NAME)
116900          END-EXEC.
117000*
117100 9399-TSD-EXIT.
117200     EXIT.
117300*
117400 9400-WRITE-QUEUE.
117500*
117600     EXEC CICS WRITEQ TS
117700               QUEUE   (TS-QUEUE-NAME)
117800               FROM    (MBITTS-RECORD)
117900               LENGTH  (LENGTH  OF MBITTS-RECORD)
118000          END-EXEC.
118100*
118200 9499-WQ-EXIT.
118300     EXIT.
118400*
118500 9500-VERIFY-DATE.
118600*
118700     IF  WS-WORK-DATE IS LESS THAN 1000000
118800         MOVE WS-WORK-DATE       TO SS01WS-MDY
118900         MOVE SS01WS-MDYZ        TO SS01WS-DATEZ
119000     ELSE
119100         MOVE WS-WORK-DATE       TO SS01WS-DATE.
119200*
119300     PERFORM SS05PD-DATE-VALIDATION
119400                                 THRU SS05PD-DV-EXIT.
119500*
119600 9599-VD-EXIT.
119700     EXIT.
119800*
119900 9600-BUILD-SCREEN.
120000*
120100     MOVE MBITTS-ORG             TO IT00-ORG.
120200     MOVE DFHBMUNF               TO IT00-ORG-A.
120300*
120400     IF  MBITTS-FILE-TYPE-MERCHANT
120500         MOVE MBITTS-MERCHANT    TO IT00-FILE-NBR
120600     ELSE
120700         MOVE MBITTS-STORE       TO IT00-FILE-NBR.
120800*
120900     MOVE DFHBMUNF               TO IT00-FILE-NBR-A.
121000*
121100     MOVE MBITTS-FILE-TYPE       TO IT00-FILE-TYPE.
121200     MOVE DFHBMFSE               TO IT00-FILE-TYPE-A.
121300*
121400     IF  MBITTS-TRANS-CODE IS NOT EQUAL TO ZEROES
121500         MOVE MBITTS-TRANS-CODE  TO IT00-TRANS-CODE
121600         MOVE DFHBMUNF           TO IT00-TRANS-CODE-A.
121700*
121800     IF  MBITTS-LOGIC-MODULE-ALL
121900         NEXT SENTENCE
122000     ELSE
122100         MOVE MBITTS-LOGIC-MODULE
122200                                 TO IT00-LOGIC-MODULE
122300         MOVE DFHBMUNF           TO IT00-LOGIC-MODULE-A.
122400*
122500     IF  MBITTS-CARD-PROD-ALL
122600         NEXT SENTENCE
122700     ELSE
122800         MOVE MBITTS-CARD-PROD   TO IT00-CARD-PROD
122900         MOVE DFHBMUNF           TO IT00-CARD-PROD-A.
123000*
123100     IF  MBITTS-QUAL-LEVEL IS NOT EQUAL TO ZEROES
123200         MOVE MBITTS-QUAL-LEVEL  TO IT00-QUAL-LEVEL
123300         MOVE DFHBMUNF           TO IT00-QUAL-LEVEL-A.
123400*
123500     IF  MBITTS-PLAN-NBR-ALL
123600         NEXT SENTENCE
123700     ELSE
123800         MOVE MBITTS-PLAN-NBR    TO IT00-PLAN-NBR
123900         MOVE DFHBMUNF           TO IT00-PLAN-NBR-A.
124000*
124100     IF  MBITTS-BATCH-DATE IS NOT EQUAL TO ZEROES
124200         MOVE MBITTS-BATCH-DATE  TO SS01WS-JULIAN
124300         PERFORM SS08PD-JUL-TO-GREG
124400                                 THRU SS08PD-JTG-EXIT
124500         MOVE SS01WS-DATE        TO IT00-BATCH-DATE
124600         MOVE DFHBMUNF           TO IT00-BATCH-DATE-A.
124700*
124800     IF  MBITTS-BATCH-NUMBER IS NOT EQUAL TO ZEROES
124900         MOVE MBITTS-BATCH-NUMBER
125000                                 TO IT00-BATCH-NUMBER
125100         MOVE DFHBMUNF           TO IT00-BATCH-NUMBER-A.
125200*
125300     IF  MBITTS-BATCH-SOURCE-ALL
125400         NEXT SENTENCE
125500     ELSE
125600         MOVE MBITTS-BATCH-SOURCE
125700                                 TO IT00-BATCH-SOURCE
125800         MOVE DFHBMUNF           TO IT00-BATCH-SOURCE-A.
125900*
126000     IF  MBITTS-GL-SOURCE-ALL
126100         NEXT SENTENCE
126200     ELSE
126300         MOVE MBITTS-GL-SOURCE   TO IT00-GL-SOURCE
126400         MOVE DFHBMUNF           TO IT00-GL-SOURCE-A.
126500*
126600     IF  MBITTS-POSTING-DATE IS NOT EQUAL TO ZEROES
126700         MOVE MBITTS-POSTING-DATE
126800                                 TO SS01WS-JULIAN
126900         PERFORM SS08PD-JUL-TO-GREG
127000                                 THRU SS08PD-JTG-EXIT
127100         MOVE SS01WS-DATE        TO IT00-POSTING-DATE
127200         MOVE DFHBMUNF           TO IT00-POSTING-DATE-A.
127300*
127400     IF  MBITTS-SETT-DEST-ALL
127500         NEXT SENTENCE
127600     ELSE
127700         MOVE MBITTS-SETT-DEST   TO IT00-SETT-DEST
127800         MOVE DFHBMUNF           TO IT00-SETT-DEST-A.
127900*
128000     IF  MBITTS-SETT-FLAG-ALL
128100         NEXT SENTENCE
128200     ELSE
128300         MOVE MBITTS-SETT-FLAG   TO IT00-SETT-FLAG
128400         MOVE DFHBMFSE           TO IT00-SETT-FLAG-A.
128500*
128600     IF  MBITTS-STMT-FLAG-ALL
128700         NEXT SENTENCE
128800     ELSE
128900         MOVE MBITTS-STMT-FLAG   TO IT00-STMT-FLAG
129000         MOVE DFHBMFSE           TO IT00-STMT-FLAG-A.
129100*
129200     IF  MBITTS-FROM-TRANS-AMT IS NOT EQUAL TO ZEROES
129300         MOVE MBITTS-FROM-TRANS-AMT
129400                                 TO IT00-FROM-TRANS-AMT
129500         MOVE DFHBMUNF           TO IT00-FROM-TRANS-AMT-A.
129600*
129700     IF  MBITTS-TO-TRANS-AMT IS NOT EQUAL TO WS-NINES
129800         MOVE MBITTS-TO-TRANS-AMT
129900                                 TO IT00-TO-TRANS-AMT
130000         MOVE DFHBMUNF           TO IT00-TO-TRANS-AMT-A.
130100*
130200 9699-BS-EXIT.
130300     EXIT.
130400*
130500 9700-INITIALIZE-SEL-AREA.
130600*
130700     MOVE SPACES                 TO MBCA-MBIT-SEL-CRITERIA
130800                                    (X-MBCA-MBIT-CRIT).
130900*
131000 9799-ISA-EXIT.
131100     EXIT.
131200*
131300 9800-MOVE-ERROR-MESSAGE.
131400*
131500     IF  IT00-ERR-MESSAGE IS EQUAL TO SPACES
131600         MOVE WS-ERR-MESSAGE     TO IT00-ERR-MESSAGE.
131700*
131800 9899-MEM-EXIT.
131900     EXIT.
132000/         DATE VALIDATION ROUTINE
132100     COPY SS05PD.
132200/         GREGORIAN TO JULIAN DATE ROUTINE
132300     COPY SS07PD.
132400/         JULIAN TO GREGORIAN DATE ROUTINE
132500     COPY SS08PD.
132600/         DATE AND TIME EDIT ROUTINES
132700     COPY SS26PD.
132800     COPY SS27PD.
132900/         LINE 24 PF KEYS ROUTINE
133000     COPY SS15PD.
133100/         ORG RECORD ACCESS ROUTINES
133200     COPY MMOCAO.
133300/         MERCHANT FILE RECORD ACCESS ROUTINES
133400     COPY MMMMAO.
133500/         STORE FILE RECORD ACCESS ROUTINES
133600     COPY MMSMAO.
133700/         MERCHANT DETAIL HISTORY RECORD ACCESS ROUTINES
133800     COPY MMDHAO.
133900/         ON-LINE MAP ROUTINES
134000     COPY MB60PD REPLACING 'MBMAPXX' BY 'MBIT00 '
134100                           MBMAPXXI BY MBIT00I
134200                           MBMAPXXO BY MBIT00O.
134300/         ON-LINE PROCEDURES
134400     COPY MB70PD.
134500/
134600     COPY SMFTPXO.
