000100 IDENTIFICATION DIVISION.
000200 PROGRAM-ID. MBOIT01.
000201*       RELEASE DATE=08/24/01.        REVISION LEVEL=08.06      *
000202*****************************************************************
000203*WARNING.  THIS COMPUTER PROGRAM IS PROTECTED BY COPYRIGHT LAW  *
000204*AND INTERNATIONAL TREATIES.  UNAUTHORIZED REPRODUCTION OR      *
000205*DISTRIBUTION OF THIS PROGRAM, OR ANY PORTION OF IT, MAY RESULT *
000206*IN SEVERE CIVIL AND CRIMINAL PENATLIES, AND WILL BE PROSECUTED *
000207*TO THE MAXIMUM EXTENT POSSIBLE UNDER THE LAW.                  *
000208*COPYRIGHT 1999 PAYSYS INTERNATIONAL, INC.  ALL RIGHTS RESERVED.*
000209*****************************************************************
000300*****************************************************************
000400*                                                               *
000500*               M E R C H A N T   S Y S T E M                   *
000600*                                                               *
000700*      MBOIT01 - ON-LINE MERCHANT DETAIL HISTORY DISPLAY        *
000800*                SCREEN 01                                      *
000900*                                                               *
001000*              1. TRANSIDS                                      *
001100*                 A. MBIT                                       *
001200*              2. MAPS USED -                                   *
001300*                 A. MBIT01 (SCREEN 01)                         *
001400*              3. FILES USED -                                  *
001500*                 A. MMDH   (MERCHANT DETAIL HISTORY FILE)      *
001600*                                                               *
001700*****************************************************************
001800*
001900 ENVIRONMENT DIVISION.
002000 DATA DIVISION.
002100 WORKING-STORAGE SECTION.
002200 01  FILLER                  PIC  X(12)      VALUE '** WS-BEG **'.
002300*         I/O REQUEST BLOCK WORK AREAS
002400     COPY MBIOWS.
002500/         I/O REQUEST BLOCK
002600     COPY MBIORO.
002700/         FORMAT NBR AND \MT WORK AREAS
002800     COPY SS95WS.
002900/         DYNAMIC ALLOC ROUTINS
003000     COPY MB00WS.
003100/         DATE WORK AREAS
003200     COPY SS01WS.
003300/         ONLINE WORK AREAS
003400     COPY SS08WS.
003500/
003600     COPY SS00WS.
003700/
003800     COPY SMFTWS.
003900/
004000     COPY SMPTRL REPLACING ==:SMPT:== BY ==SMPT==.
004100/
004200     COPY MB61LK.
004300/
004400 01  WS-MISCELLANEOUS.
004500     03  WS-FWD-SEQ-NBR      PIC S9(08)      VALUE ZEROES BINARY.
004600     03  WS-TWO-NINES        PIC  9(02)      VALUE 99.
004700     03  WS-AMT-WORK-AREA.
004800         05  WS-AMT-WORK     PIC  X(20).
004900     03  WS-TRANS-CODE-AREA.
005000         05  FILLER          PIC  X(11)      VALUE SPACES.
005100         05  WS-TRANS-CODE   PIC  9(03)      BLANK WHEN ZEROES.
005200         05  WS-TRANS-FLAG   PIC  X(01)      VALUE SPACES.
005300         05  FILLER          PIC  X(03)      VALUE ' / '.
005400         05  WS-TRANS-LOGIC-MODULE
005500                             PIC  9(03).
005600     03  WS-NUMBER-ONE-AREA.
005700         05  FILLER          PIC  X(20)      VALUE SPACES.
005800         05  WS-NUMBER-ONE   PIC  9(01).
005900     03  WS-NUMBER-TWO-AREA.
006000         05  FILLER          PIC  X(19)      VALUE SPACES.
006100         05  WS-NUMBER-TWO   PIC  9(02).
006200     03  WS-NUMBER-THREE-AREA.
006300         05  FILLER          PIC  X(18)      VALUE SPACES.
006400         05  WS-NUMBER-THREE PIC  9(03).
006500     03  WS-NUMBER-FIVE-AREA.
006600         05  FILLER          PIC  X(16)      VALUE SPACES.
006700         05  WS-NUMBER-FIVE  PIC  9(05).
006800     03  WS-NUMBER-SEVEN-AREA.
006900         05  FILLER          PIC  X(14)      VALUE SPACES.
007000         05  WS-NUMBER-SEVEN PIC  9(07).
007100     03  WS-NUMBER-EIGHT-AREA.
007200         05  FILLER          PIC  X(13)      VALUE SPACES.
007300         05  WS-NUMBER-EIGHT PIC  9(08).
007400     03  WS-NUMBER-NINE-AREA.
007500         05  FILLER          PIC  X(12)      VALUE SPACES.
007600         05  WS-NUMBER-NINE  PIC  9(09).
007700     03  WS-DATE-WORK-AREA.
007800         05  FILLER          PIC  X(11)      VALUE SPACES.
007900         05  WS-DATE-WORK    PIC  X(10).
008000     03  WS-ALPHA-FOUR-AREA.
008100         05  FILLER          PIC  X(17)      VALUE SPACES.
008200         05  WS-ALPHA-FOUR   PIC  X(04)      VALUE SPACES.
008300     03  WS-ALPHA-TEN-AREA.
008400         05  FILLER          PIC  X(11)      VALUE SPACES.
008500         05  WS-ALPHA-TEN    PIC  X(10)      VALUE SPACES.
008600     03  WS-BYPASS-SW        PIC  X(01)      VALUE 'N'.
008700         88  WS-BYPASS-NO                    VALUE 'N'.
008800         88  WS-BYPASS-YES                   VALUE 'Y'.
008900     03  WS-DET-HIST-SW      PIC  X(01)      VALUE 'N'.
009000         88  WS-DET-HIST-NO                  VALUE 'N'.
009100         88  WS-DET-HIST-YES                 VALUE 'Y'.
009200     03  TS-QUEUE-NAME.
009300         05  TS-QN-TERMID    PIC  X(04)      VALUE SPACES.
009400         05  TS-QN-TRANID    PIC  X(04)      VALUE 'MBIT'.
009500*
009600 01  FILLER                  PIC  X(12)      VALUE '** WS-END **'.
009700/
009800 LINKAGE SECTION.
009900 01  DFHCOMMAREA.
010000     COPY MB60WS.
010100/         MERCHANT DETAIL HISTORY SCREEN 01 MAP DSECT
010200     COPY MBIT01.
010300/         MERCHANT DETAIL HISTORY SCREEN 01 MAP REDEFINITION
010400     COPY MBIT01R.
010500/         MERCHANT DETAIL HISTORY RECORD LAYOUT
010600     COPY MMDHRL.
010700/         MERCHANT DETAIL HISTORY DISPLAY TEMPORARY STORAGE
010800     COPY MBITTS.
010900/
011000 PROCEDURE DIVISION.
011100 0000-HOUSEKEEPING SECTION.
011200 0100-INIT.
011300*
011400     SET SS95WS-FUNCTION-INITIALIZE TO TRUE.
011500     PERFORM SS95PD-NAP-ROUTINE
011600        THRU SS95PD-NAP-EXIT.
011700*
011800     MOVE 'PC01'                 TO MBCA-PROGRAM-LOCATION.
011900     PERFORM MB70PD-ON-LINE-HOUSEKEEPING
012000                                 THRU MB70PD-OLH-EXIT.
012100*
012200     MOVE MBCA-TERMINAL-ID       TO TS-QN-TERMID.
012300*
012400     IF  MBCA-RECEIVE-SCREEN
012500         GO TO 2000-RECEIVE-SCREEN.
012600*
012700 1000-SEND-SCREEN SECTION.
012800*
012900****************************************************************
013000*    GET CICS STORAGE NEEDED FOR THE MAP                       *
013100****************************************************************
013200*
013300     MOVE 'SC01'                 TO MBCA-PROGRAM-LOCATION.
013400     PERFORM MB60PD-GETMAIN-FOR-MAP
013500                                 THRU MB60PD-GFM-EXIT.
013600*
013700     MOVE 01                     TO MBCA-SCREEN-NBR.
013800     MOVE MBCA-MERCHANT-ORG      TO IT01-ORG.
013900     MOVE MBCA-MERCHANT          TO IT01-MERCHANT.
014000*
014100     PERFORM 9100-BUILD-SELECTION-CRITERIA
014200                                 THRU 9199-BSC-EXIT
014300         VARYING X-SEL-CRIT-INDEX FROM +1 BY +1
014400         UNTIL   X-SEL-CRIT-INDEX IS GREATER THAN +13.
014500*
014600****************************************************************
014700*    INITIALIZE THE STANDARD MAP LINES                         *
014800****************************************************************
014900*
015000     PERFORM MB60PD-INIT-STD-MAP-LINES
015100                                 THRU MB60PD-ISML-EXIT.
015200*
015300****************************************************************
015400*    ACQUIRE MAIN STORAGE FOR TEMP STORAGE RECORD              *
015500****************************************************************
015600*
015700     MOVE 'TS01'                 TO MBCA-PROGRAM-LOCATION.
015800     PERFORM 8100-TEMP-STORAGE-GETMAIN
015900                                 THRU 8199-TSG-EXIT.
016000*
016100     EXEC CICS HANDLE CONDITION
016200               QIDERR (1010-CHECK-RETURN-FLAG)
016300          END-EXEC.
016400*
016500***********************************************
016600*    READ THE TEMP STORAGE RECORD             *
016700***********************************************
016800*
016900     MOVE 'TS02'                 TO MBCA-PROGRAM-LOCATION.
017000     PERFORM 8200-TEMP-STORAGE-READ
017100                                 THRU 8299-TSR-EXIT.
017200*
017300***********************************************
017400*    DELETE THE TEMP STORAGE RECORD           *
017500***********************************************
017600*
017700     MOVE 'TS03'                 TO MBCA-PROGRAM-LOCATION.
017800     PERFORM 8300-TEMP-STORAGE-DELETE
017900                                 THRU 8399-TSD-EXIT.
018000*
018100     IF  MBCA-MBIT-FIRST-TIME
018200         GO TO 1010-CHECK-RETURN-FLAG.
018300*
018400     PERFORM 8800-BUILD-SCREEN   THRU 8899-BS-EXIT.
018500     GO TO 1080-CONTINUE.
018600*
018700 1010-CHECK-RETURN-FLAG.
018800*
018900     MOVE 'N'                    TO MBCA-MBIT-FIRST-TIME-FLAG.
019000*
019100     IF  MBCA-MBIT-RETURN-BOTTOM
019200         PERFORM 8900-LAST-SCREEN
019300                                 THRU 8999-LS-EXIT
019400         IF  WS-BYPASS-YES
019500             GO TO 1015-START-BROWSE
019600         ELSE
019700             GO TO 1080-CONTINUE
019800     ELSE
019900         IF  MBCA-MBIT-RETURN-BWD
020000             PERFORM 9000-BACK-SCREEN
020100                                 THRU 9099-BS-EXIT
020200             IF  WS-BYPASS-YES
020300                 GO TO 1015-START-BROWSE
020400             ELSE
020500                 GO TO 1080-CONTINUE.
020600*
020700 1015-START-BROWSE.
020800*
020900****************************************************************
021000*    START BROWSE THE MERCHANT DETAIL HISTORY FILE             *
021100****************************************************************
021200*
021300     MOVE 'FC01'                 TO MBCA-PROGRAM-LOCATION.
021400     MOVE MBITTS-ORG             TO MBIOWS-MMDH-ORG.
021500     MOVE MBITTS-MERCHANT        TO MBIOWS-MMDH-MERCHANT.
021600     MOVE MBCA-MBIT-FWD-SEQ-NBR  TO MBIOWS-MMDH-SEQ-NBR.
021700     SET MBIORO-STARTBR-GTE      TO TRUE.
021800     PERFORM MMDHAO-ACCESS       THRU MMDHAO-ACCESS-EXIT.
021900*
022000     SET X-DET-HIST-INDEX        TO +1.
022100     SET X-DETAIL-INDEX          TO +1.
022200*
022300 1020-READ-DETAIL-HISTORY-FILE.
022400*
022500****************************************************************
022600*    READNEXT THE MERCHANT DETAIL HISTORY FILE                 *
022700****************************************************************
022800*
022900     MOVE 'FC02'                 TO MBCA-PROGRAM-LOCATION.
023000     SET MBIORO-READ-SEQ         TO TRUE.
023100     PERFORM MMDHAO-ACCESS       THRU MMDHAO-ACCESS-EXIT.
023200*
023300     IF  MMDH-ORG IS GREATER THAN MBITTS-ORG
023400     OR  MMDH-MERCHANT IS GREATER THAN MBITTS-MERCHANT
023500         GO TO 1050-END-BROWSE.
023600*
023700     PERFORM 9300-DET-HIST-SELECT
023800                                 THRU 9399-DHS-EXIT.
023900*
024000     IF  WS-DET-HIST-NO
024100         GO TO 1020-READ-DETAIL-HISTORY-FILE.
024200*
024300     IF  X-DETAIL-INDEX IS EQUAL TO +1
024400         MOVE MMDH-SEQ-NBR       TO MBCA-MBIT-BACK-SEQ-NBR.
024500*
024600     IF  X-DETAIL-INDEX IS LESS THAN +3
024700         SET X-DETAIL-INDEX    UP BY +1
024800         GO TO 1020-READ-DETAIL-HISTORY-FILE
024900     ELSE
025000         MOVE MMDH-SEQ-NBR       TO MBCA-MBIT-FWD-SEQ-NBR
025100         PERFORM 9400-READ-AHEAD THRU 9499-RA-EXIT
025200         SET X-DETAIL-INDEX      UP BY +1.
025300*
025400 1050-END-BROWSE.
025500*
025600****************************************************************
025700*    END BROWSE THE MERCHANT DETAIL HISTORY FILE               *
025800****************************************************************
025900*
026000     MOVE 'FC03'                 TO MBCA-PROGRAM-LOCATION.
026100     SET MBIORO-ENDBR            TO TRUE.
026200     PERFORM MMDHAO-ACCESS       THRU MMDHAO-ACCESS-EXIT.
026300*
026400 1060-SET-ATTRIBUTE.
026500*
026600     IF  X-DETAIL-INDEX IS EQUAL TO +1
026700         IF  MBCA-MBIT-RETURN-NORMAL
026800             SET MBCA-INITIAL-SCREEN-NBR
026900                                 TO TRUE
027000             MOVE MBIOWS-MMDH-KEY-CODE
027100                                 TO MBCA-KEY-CODE
027200             MOVE 'TS04'         TO MBCA-PROGRAM-LOCATION
027300             PERFORM 8400-WRITE-QUEUE
027400                                 THRU 8499-WQ-EXIT
027500             MOVE 'PC02'         TO MBCA-PROGRAM-LOCATION
027600             PERFORM MB70PD-XCTL-TO-MBOXCTL
027700                                 THRU MB70PD-XTM-EXIT
027800         ELSE
027900             MOVE MBCA-MBIT-BACK-SEQ-NBR
028000                                 TO MBCA-MBIT-FWD-SEQ-NBR
028100             GO TO 1015-START-BROWSE.
028200*
028300     IF  X-DETAIL-INDEX IS LESS THAN +4
028400         SET X-MBITTS-INDEX      TO X-DETAIL-INDEX
028500         MOVE ZEROES             TO MBCA-MBIT-FWD-SEQ-NBR
028600                                    WS-FWD-SEQ-NBR
028700                                    MBITTS-DET-SEQ-NBR
028800                                    (X-MBITTS-INDEX)
028900                                    MBITTS-DET-BATCH-DATE
029000                                    (X-MBITTS-INDEX)
029100                                    MBITTS-DET-BATCH-SOURCE
029200                                    (X-MBITTS-INDEX)
029300                                    MBITTS-DET-BATCH-NUMBER
029400                                    (X-MBITTS-INDEX)
029500                                    MBITTS-DET-BATCH-SEQ
029600                                    (X-MBITTS-INDEX)
029700                                    MBITTS-DET-TRANS-CODE
029800                                    (X-MBITTS-INDEX)
029900                                    MBITTS-DET-CARD-PROD
030000                                    (X-MBITTS-INDEX)
030100                                    MBITTS-DET-QUAL-LEVEL
030200                                    (X-MBITTS-INDEX)
030300                                    MBITTS-DET-AMOUNT
030400                                    (X-MBITTS-INDEX)
030500                                    MBITTS-DET-NBR-ITEMS
030600                                    (X-MBITTS-INDEX)
030700                                    MBITTS-DET-PLAN-NBR
030800                                    (X-MBITTS-INDEX)
030900                                    MBITTS-DET-STORE-NBR
031000                                    (X-MBITTS-INDEX)
031100                                    MBITTS-DET-LOGIC-MODULE
031200                                    (X-MBITTS-INDEX)
031300                                    MBITTS-DET-GL-SOURCE
031400                                    (X-MBITTS-INDEX)
031500                                    MBITTS-DET-POST-DATE
031600                                    (X-MBITTS-INDEX)
031700                                    MBITTS-DET-ENTRY-DATE
031800                                    (X-MBITTS-INDEX)
031900         MOVE SPACES             TO MBITTS-DET-RPT-DESC
032000                                    (X-MBITTS-INDEX)
032100                                    MBITTS-DET-TRANS-FLAG
032200                                    (X-MBITTS-INDEX)
032300         PERFORM 9200-SET-ATTRIBUTE
032400                                 THRU 9299-SA-EXIT
032500             VARYING X-DET-HIST-INDEX FROM +1 BY +1
032600             UNTIL   X-DET-HIST-INDEX IS GREATER THAN +15
032700         SET X-DETAIL-INDEX      UP BY +1
032800         GO TO 1060-SET-ATTRIBUTE.
032900*
033000 1080-CONTINUE.
033100*
033200     IF  MBCA-MBIT-BACK-SEQ-NBR IS NOT EQUAL
033300                                 TO MBCA-MBIT-FIRST-SEQ-NBR
033400         MOVE DFHBMASB           TO IT01-FWD-IND-A.
033500*
033600     IF  WS-FWD-SEQ-NBR IS GREATER THAN ZEROES
033700         MOVE DFHBMASB           TO IT01-BACK-IND-A.
033800*
033900****************************************************************
034000*    WRITE THE TEMP STORAGE RECORD                             *
034100****************************************************************
034200*
034300     MOVE 'TS05'                 TO MBCA-PROGRAM-LOCATION.
034400     PERFORM 8400-WRITE-QUEUE    THRU 8499-WQ-EXIT.
034500*
034600     MOVE SS08WS-CURSOR          TO IT01-ALT-TRANID-L.
034700*
034800     MOVE '*TOP*'                TO SS08WS-LINE-24-PF-KEY-FUNC(3).
034900     MOVE '*BOT*'                TO SS08WS-LINE-24-PF-KEY-FUNC(4).
035000     MOVE '*FWD*'                TO SS08WS-LINE-24-PF-KEY-FUNC(5).
035100     MOVE '*BWD*'                TO SS08WS-LINE-24-PF-KEY-FUNC(6).
035200     MOVE SS08WS-LINE-24         TO IT01-PF-KEYS.
035300     MOVE 'RESV'                 TO MBCA-PGMX-PF-TRANS-ID (3).
035400     MOVE 'RESV'                 TO MBCA-PGMX-PF-TRANS-ID (4).
035500     MOVE 'RESV'                 TO MBCA-PGMX-PF-TRANS-ID (5).
035600     MOVE 'RESV'                 TO MBCA-PGMX-PF-TRANS-ID (6).
035700*
035800     MOVE DFHBMASK               TO IT01-CURRENT-PAGE-A.
035900*
036000****************************************************************
036100*    FORMAT THE MESSAGE LINE                                   *
036200****************************************************************
036300*
036400     IF IT01-ERR-MESSAGE EQUAL TO SPACES OR LOW-VALUES
036500     PERFORM MB06PD-FORMAT-MESSAGE-LINE
036600        THRU MB06PD-FML-EXIT.
036700     MOVE SS08WS-FORMATTED-MSG TO IT01-ERR-MESSAGE.
036800*
036900****************************************************************
037000*    SEND THE MAP                                              *
037100****************************************************************
037200*
037300     MOVE 'BM01'                 TO MBCA-PROGRAM-LOCATION.
037400     PERFORM MB60PD-SEND-MAP-WITH-ERASE
037500                                 THRU MB60PD-SMWE-EXIT.
037600*
037700****************************************************************
037800*    RETURN TO CICS                                            *
037900****************************************************************
038000*
038100     MOVE 'PC03'                 TO MBCA-PROGRAM-LOCATION.
038200     PERFORM MB70PD-RETURN-TRANS-ID
038300                                 THRU MB70PD-RTI-EXIT.
038400/
038500 2000-RECEIVE-SCREEN SECTION.
038600*
038700****************************************************************
038800*    THIS SECTION RECEIVES THE 01 SCREEN                       *
038900****************************************************************
039000*
039100     MOVE 'BM02'                 TO MBCA-PROGRAM-LOCATION.
039200     PERFORM MB60PD-RECEIVE-MAP  THRU MB60PD-RM-EXIT.
039300*
039400*****************************************************
039500*    ACQUIRE MAIN STORAGE FOR TEMP STORAGE RECORD   *
039600*****************************************************
039700*
039800     MOVE 'TS06'                 TO MBCA-PROGRAM-LOCATION.
039900     PERFORM 8100-TEMP-STORAGE-GETMAIN
040000                                 THRU 8199-TSG-EXIT.
040100*
040200***********************************************
040300*    READ THE TEMP STORAGE RECORD             *
040400***********************************************
040500*
040600     MOVE 'TS07'                 TO MBCA-PROGRAM-LOCATION.
040700     PERFORM 8200-TEMP-STORAGE-READ
040800                                 THRU 8299-TSR-EXIT.
040900*
041000****************************************************************
041100*    CHECK FOR ANOTHER TRANSACTION ID ENTERED BY THE USER      *
041200****************************************************************
041300*
041400     MOVE 'PC04'                 TO MBCA-PROGRAM-LOCATION.
041500     PERFORM MB60PD-NEW-TRANS-ROUTINE
041600                                 THRU MB60PD-NTR-EXIT.
041700*
041800 2600-SETUP-COMMAREA.
041900*
042000****************************************************************
042100*    SET UP COMMAREA FIELDS AND TRANSFER TO THE NEXT PROGRAM   *
042200****************************************************************
042300*
042400     MOVE MBCA-EIBAID            TO SS08WS-EIBAID.
042500*
042600     IF  SS08WS-VALID-PF3
042700     OR  SS08WS-EIBAID-VALID-PF3
042800         MOVE 51                 TO MBCA-SCREEN-NBR
042900         IF  MBITTS-DET-SEQ-NBR (1) IS EQUAL
043000                                 TO MBCA-MBIT-FIRST-SEQ-NBR
043100             MOVE 'T'            TO MBCA-MBIT-RETURN-FLAG
043200             GO TO 2690-PF-KEY-BYPASS
043300         ELSE
043400             MOVE MBCA-MBIT-FIRST-SEQ-NBR
043500                                 TO MBCA-MBIT-FWD-SEQ-NBR
043600             MOVE ' '            TO MBCA-MBIT-RETURN-FLAG
043700             MOVE 'Y'            TO MBCA-MBIT-FIRST-TIME-FLAG
043800             GO TO 2690-PF-KEY-BYPASS.
043900*
044000     IF  SS08WS-VALID-PF4
044100     OR  SS08WS-EIBAID-VALID-PF4
044200         MOVE 51                 TO MBCA-SCREEN-NBR
044300         IF (MBITTS-DET-SEQ-NBR (1) IS GREATER THAN ZEROES
044400         AND MBITTS-DET-SEQ-NBR (3) IS EQUAL TO ZEROES)
044500         OR (MBCA-MBIT-FWD-SEQ-NBR IS EQUAL TO ZEROES)
044600             MOVE ' '            TO MBCA-MBIT-RETURN-FLAG
044700             GO TO 2690-PF-KEY-BYPASS
044800         ELSE
044900             MOVE 'E'            TO MBCA-MBIT-RETURN-FLAG
045000             MOVE 'Y'            TO MBCA-MBIT-FIRST-TIME-FLAG
045100             GO TO 2690-PF-KEY-BYPASS.
045200*
045300     IF  SS08WS-VALID-PF5
045400     OR  SS08WS-EIBAID-VALID-PF5
045500         MOVE 51                 TO MBCA-SCREEN-NBR
045600         IF (MBITTS-DET-SEQ-NBR (1) IS GREATER THAN ZEROES
045700         AND MBITTS-DET-SEQ-NBR (3) IS EQUAL TO ZEROES)
045800         OR (MBCA-MBIT-FWD-SEQ-NBR IS EQUAL TO ZEROES)
045900             MOVE ' '            TO MBCA-MBIT-RETURN-FLAG
046000             GO TO 2690-PF-KEY-BYPASS
046100         ELSE
046200             MOVE 'F'            TO MBCA-MBIT-RETURN-FLAG
046300             MOVE MBITTS-DET-SEQ-NBR (3)
046400                                 TO MBCA-MBIT-FWD-SEQ-NBR
046500             ADD +1              TO MBCA-MBIT-FWD-SEQ-NBR
046600             MOVE 'Y'            TO MBCA-MBIT-FIRST-TIME-FLAG
046700             GO TO 2690-PF-KEY-BYPASS.
046800*
046900     IF  SS08WS-VALID-PF6
047000     OR  SS08WS-EIBAID-VALID-PF6
047100         MOVE 51                 TO MBCA-SCREEN-NBR
047200         IF  MBITTS-DET-SEQ-NBR (1) IS EQUAL
047300                                 TO MBCA-MBIT-FIRST-SEQ-NBR
047400             MOVE ' '            TO MBCA-MBIT-RETURN-FLAG
047500             GO TO 2690-PF-KEY-BYPASS
047600         ELSE
047700             MOVE MBITTS-DET-SEQ-NBR (1)
047800                                 TO MBCA-MBIT-FWD-SEQ-NBR
047900             MOVE 'B'            TO MBCA-MBIT-RETURN-FLAG
048000             MOVE 'Y'            TO MBCA-MBIT-FIRST-TIME-FLAG
048100             GO TO 2690-PF-KEY-BYPASS.
048200*
048300     IF  SS08WS-VALID-PF-KEY
048400     OR  SS08WS-EIBAID-VALID-PF-KEY
048500     OR  MBITTS-DET-SEQ-NBR (3) IS EQUAL TO ZEROES
048600     OR  MBCA-MBIT-FWD-SEQ-NBR IS EQUAL TO ZEROES
048700         SET MBCA-INITIAL-SCREEN-NBR
048800                                 TO TRUE
048900         MOVE MBIOWS-MMDH-KEY-CODE
049000                                 TO MBCA-KEY-CODE
049100         MOVE ' '                TO MBCA-MBIT-RETURN-FLAG
049200         GO TO 2690-PF-KEY-BYPASS.
049300*
049400     MOVE 51                     TO MBCA-SCREEN-NBR.
049500     MOVE MBITTS-DET-SEQ-NBR (3)
049600                                 TO MBCA-MBIT-FWD-SEQ-NBR.
049700     ADD +1                      TO MBCA-MBIT-FWD-SEQ-NBR.
049800     MOVE ' '                    TO MBCA-MBIT-RETURN-FLAG.
049900     MOVE 'Y'                    TO MBCA-MBIT-FIRST-TIME-FLAG.
050000*
050100 2690-PF-KEY-BYPASS.
050200*
050300     MOVE 'PC05'                 TO MBCA-PROGRAM-LOCATION.
050400     PERFORM MB70PD-XCTL-TO-MBOXCTL
050500                                 THRU MB70PD-XTM-EXIT.
050600/
050700 8000-PERFORMED-ROUTINES-SECT SECTION.
050800*
050900 8100-TEMP-STORAGE-GETMAIN.
051000*
051100     EXEC CICS GETMAIN
051200               FLENGTH (LENGTH  OF MBITTS-RECORD)
051300               SET     (ADDRESS OF MBITTS-RECORD)
051400          END-EXEC.
051500*
051600 8199-TSG-EXIT.
051700     EXIT.
051800*
051900 8200-TEMP-STORAGE-READ.
052000*
052100     EXEC CICS READQ TS
052200               QUEUE   (TS-QUEUE-NAME)
052300               INTO    (MBITTS-RECORD)
052400               LENGTH  (LENGTH  OF MBITTS-RECORD)
052500               ITEM    (1)
052600          END-EXEC.
052700*
052800 8299-TSR-EXIT.
052900     EXIT.
053000*
053100 8300-TEMP-STORAGE-DELETE.
053200*
053300     EXEC CICS IGNORE CONDITION
053400               QIDERR
053500          END-EXEC.
053600*
053700     EXEC CICS DELETEQ TS
053800               QUEUE  (TS-QUEUE-NAME)
053900          END-EXEC.
054000*
054100 8399-TSD-EXIT.
054200     EXIT.
054300*
054400 8400-WRITE-QUEUE.
054500*
054600     EXEC CICS WRITEQ TS
054700               QUEUE   (TS-QUEUE-NAME)
054800               FROM    (MBITTS-RECORD)
054900               LENGTH  (LENGTH  OF MBITTS-RECORD)
055000          END-EXEC.
055100*
055200 8499-WQ-EXIT.
055300     EXIT.
055400*
055500 8800-BUILD-SCREEN.
055600*
055700     SET X-DETAIL-INDEX          TO +1.
055800*
055900 8800-BUILD-LOOP.
056000*
056100     MOVE MBCA-CURRENCY-CODE     TO SS95WS-CURRENCY-CODE.
056200*
056300     SET X-MBITTS-INDEX          TO X-DETAIL-INDEX.
056400     SET X-SETT-DATA-INDEX       TO X-DETAIL-INDEX.
056500     SET X-DET-HIST-INDEX        TO +1.
056600*
056700     MOVE MBITTS-DET-SETT-FLAG (X-MBITTS-INDEX)
056800                                 TO IT01-SETT-FLAG
056900                                    (X-SETT-DATA-INDEX).
057000     MOVE MBITTS-DET-SETT-ACCT (X-MBITTS-INDEX)
057100                                 TO IT01-SETT-ACCT
057200                                    (X-SETT-DATA-INDEX).
057300     MOVE MBITTS-DET-SETT-DATE (X-MBITTS-INDEX)
057400                                 TO SS01WS-JULIAN.
057500     PERFORM SS26PD-NUMERICALLY-EDIT-DATE THRU SS26PD-NED-EXIT.
057600     MOVE SS01WS-DATE            TO WS-DATE-WORK.
057700     MOVE WS-DATE-WORK           TO IT01-SETT-DATE
057800                                    (X-SETT-DATA-INDEX).
057900*
058000     IF  MBITTS-DET-SEQ-NBR (X-MBITTS-INDEX)
058100                                 IS GREATER THAN ZEROES
058200         MOVE MBITTS-DET-GL-SOURCE (X-MBITTS-INDEX)
058300                                 TO WS-NUMBER-ONE
058400         MOVE WS-NUMBER-ONE-AREA TO IT01-DETAIL-HIST
058500                                    (X-DET-HIST-INDEX
058600                                     X-DETAIL-INDEX)
058700         SET X-DET-HIST-INDEX    UP BY +1
058800         MOVE MBITTS-DET-NBR-ITEMS (X-MBITTS-INDEX)
058900                                 TO WS-NUMBER-SEVEN
059000         MOVE WS-NUMBER-SEVEN-AREA
059100                                 TO IT01-DETAIL-HIST
059200                                    (X-DET-HIST-INDEX
059300                                     X-DETAIL-INDEX)
059400         SET X-DET-HIST-INDEX    UP BY +1
059500         MOVE MBITTS-DET-AMOUNT (X-MBITTS-INDEX)
059600                                 TO SS95WS-IN-AMT
059700         PERFORM SS95PD-NAP-ROUTINE
059800                                 THRU SS95PD-NAP-EXIT
059900         MOVE SS95WS-OUT-AMT-L21
060000                                 TO IT01-DETAIL-HIST
060100                                    (X-DET-HIST-INDEX
060200                                     X-DETAIL-INDEX)
060300         SET X-DET-HIST-INDEX    UP BY +1
060400         MOVE MBITTS-DET-TRANS-CODE (X-MBITTS-INDEX)
060500                                 TO WS-TRANS-CODE
060600         MOVE MBITTS-DET-TRANS-FLAG (X-MBITTS-INDEX)
060700                                 TO WS-TRANS-FLAG
060800         MOVE MBITTS-DET-LOGIC-MODULE (X-MBITTS-INDEX)
060900                                 TO WS-TRANS-LOGIC-MODULE
061000         MOVE WS-TRANS-CODE-AREA TO IT01-DETAIL-HIST
061100                                    (X-DET-HIST-INDEX
061200                                     X-DETAIL-INDEX)
061300         SET X-DET-HIST-INDEX    UP BY +1
061400         MOVE MBITTS-DET-CARD-PROD (X-MBITTS-INDEX)
061500                                TO WS-NUMBER-TWO
061600         MOVE WS-NUMBER-TWO-AREA
061700                                TO IT01-DETAIL-HIST
061800                                    (X-DET-HIST-INDEX
061900                                     X-DETAIL-INDEX)
062000         SET X-DET-HIST-INDEX    UP BY +1
062100         MOVE MBITTS-DET-QUAL-LEVEL (X-MBITTS-INDEX)
062200                                 TO WS-NUMBER-TWO
062300         MOVE WS-NUMBER-TWO-AREA
062400                                TO IT01-DETAIL-HIST
062500                                    (X-DET-HIST-INDEX
062600                                     X-DETAIL-INDEX)
062700         SET X-DET-HIST-INDEX    UP BY +1
062800         MOVE MBITTS-DET-PLAN-NBR (X-MBITTS-INDEX)
062900                                 TO WS-NUMBER-FIVE
063000         MOVE WS-NUMBER-FIVE-AREA
063100                                 TO IT01-DETAIL-HIST
063200                                    (X-DET-HIST-INDEX
063300                                     X-DETAIL-INDEX)
063400         SET X-DET-HIST-INDEX    UP BY +1
063500         MOVE MBITTS-DET-STORE-NBR (X-MBITTS-INDEX)
063600                                 TO WS-NUMBER-NINE
063700         MOVE WS-NUMBER-NINE-AREA
063800                                 TO IT01-DETAIL-HIST
063900                                    (X-DET-HIST-INDEX
064000                                     X-DETAIL-INDEX)
064100         SET X-DET-HIST-INDEX    UP BY +1
064200         MOVE MBITTS-DET-BATCH-NUMBER (X-MBITTS-INDEX)
064300                                 TO WS-NUMBER-FIVE
064400         MOVE WS-NUMBER-FIVE-AREA
064500                                 TO IT01-DETAIL-HIST
064600                                    (X-DET-HIST-INDEX
064700                                     X-DETAIL-INDEX)
064800         SET X-DET-HIST-INDEX    UP BY +1
064900         MOVE MBITTS-DET-BATCH-DATE (X-MBITTS-INDEX)
065000                                 TO SS01WS-JULIAN
065100         PERFORM SS26PD-NUMERICALLY-EDIT-DATE
065200                                 THRU SS26PD-NED-EXIT
065300         MOVE SS01WS-DATE        TO WS-DATE-WORK
065400         MOVE WS-DATE-WORK-AREA  TO IT01-DETAIL-HIST
065500                                    (X-DET-HIST-INDEX
065600                                     X-DETAIL-INDEX)
065700         SET X-DET-HIST-INDEX    UP BY +1
065800         MOVE MBITTS-DET-BATCH-SOURCE (X-MBITTS-INDEX)
065900                                 TO WS-NUMBER-FIVE
066000         MOVE WS-NUMBER-FIVE-AREA
066100                                 TO IT01-DETAIL-HIST
066200                                    (X-DET-HIST-INDEX
066300                                     X-DETAIL-INDEX)
066400         SET X-DET-HIST-INDEX    UP BY +1
066500         MOVE MBITTS-DET-BATCH-SEQ (X-MBITTS-INDEX)
066600                                 TO WS-NUMBER-EIGHT
066700         MOVE WS-NUMBER-EIGHT-AREA
066800                                 TO IT01-DETAIL-HIST
066900                                    (X-DET-HIST-INDEX
067000                                     X-DETAIL-INDEX)
067100         SET X-DET-HIST-INDEX    UP BY +1
067200         MOVE MBITTS-DET-POST-DATE (X-MBITTS-INDEX)
067300                                 TO SS01WS-JULIAN
067400         PERFORM SS26PD-NUMERICALLY-EDIT-DATE
067500                                 THRU SS26PD-NED-EXIT
067600         MOVE SS01WS-DATE        TO WS-DATE-WORK
067700         MOVE WS-DATE-WORK-AREA  TO IT01-DETAIL-HIST
067800                                    (X-DET-HIST-INDEX
067900                                     X-DETAIL-INDEX)
068000         SET X-DET-HIST-INDEX    UP BY +1
068100         MOVE MBITTS-DET-ENTRY-DATE (X-MBITTS-INDEX)
068200                                 TO SS01WS-JULIAN
068300         PERFORM SS26PD-NUMERICALLY-EDIT-DATE
068400                                 THRU SS26PD-NED-EXIT
068500         MOVE SS01WS-DATE        TO WS-DATE-WORK
068600         MOVE WS-DATE-WORK-AREA  TO IT01-DETAIL-HIST
068700                                    (X-DET-HIST-INDEX
068800                                     X-DETAIL-INDEX)
068900         SET X-DET-HIST-INDEX    UP BY +1
069000         MOVE MBITTS-DET-RPT-DESC (X-MBITTS-INDEX)
069100                                 TO IT01-DETAIL-HIST
069200                                    (X-DET-HIST-INDEX
069300                                     X-DETAIL-INDEX).
069400*
069500     IF  X-DETAIL-INDEX IS EQUAL TO +1
069600         MOVE MBITTS-DET-SEQ-NBR (X-MBITTS-INDEX)
069700                                 TO MBCA-MBIT-BACK-SEQ-NBR.
069800*
069900     IF  X-DETAIL-INDEX IS LESS THAN +3
070000         SET X-DETAIL-INDEX      UP BY +1
070100         GO TO 8800-BUILD-LOOP
070200     ELSE
070300         MOVE MBCA-MBIT-FWD-SEQ-NBR
070400                                 TO WS-FWD-SEQ-NBR.
070500*
070600 8899-BS-EXIT.
070700     EXIT.
070800*
070900 8900-LAST-SCREEN.
071000*
071100****************************************************************
071200*    START BROWSE THE MERCHANT DETAIL HISTORY FILE             *
071300****************************************************************
071400*
071500     MOVE 'FC04'                 TO MBCA-PROGRAM-LOCATION.
071600     MOVE MBITTS-ORG             TO MBIOWS-MMDH-ORG.
071700     MOVE MBITTS-MERCHANT        TO MBIOWS-MMDH-MERCHANT.
071800     MOVE +99999999              TO MBIOWS-MMDH-SEQ-NBR.
071900     SET MBIORO-STARTBR-GTE      TO TRUE.
072000     PERFORM MMDHAO-ACCESS       THRU MMDHAO-ACCESS-EXIT.
072100*
072200****************************************************************
072300*    READNEXT THE MERCHANT DETAIL HISTORY FILE                 *
072400****************************************************************
072500*
072600     MOVE 'FC05'                 TO MBCA-PROGRAM-LOCATION.
072700     SET MBIORO-READ-SEQ         TO TRUE.
072800     PERFORM MMDHAO-ACCESS       THRU MMDHAO-ACCESS-EXIT.
072900*
073000****************************************************************
073100*    READPREV THE MERCHANT DETAIL HISTORY FILE                 *
073200****************************************************************
073300*
073400     MOVE 'FC06'                 TO MBCA-PROGRAM-LOCATION.
073500     SET MBIORO-READ-PREV        TO TRUE.
073600     PERFORM MMDHAO-ACCESS       THRU MMDHAO-ACCESS-EXIT.
073700*
073800     SET X-DETAIL-INDEX          TO +3.
073900     MOVE 'N'                    TO WS-BYPASS-SW.
074000*
074100 8900-READ-DETAIL-HISTORY-FILE.
074200*
074300****************************************************************
074400*    READPREV THE MERCHANT DETAIL HISTORY FILE                 *
074500****************************************************************
074600*
074700     MOVE 'FC07'                 TO MBCA-PROGRAM-LOCATION.
074800     SET MBIORO-READ-PREV        TO TRUE.
074900     PERFORM MMDHAO-ACCESS       THRU MMDHAO-ACCESS-EXIT.
075000*
075100     IF  MMDH-ORG IS NOT EQUAL TO MBITTS-ORG
075200     OR  MMDH-MERCHANT IS NOT EQUAL TO MBITTS-MERCHANT
075300         GO TO 8900-END-BROWSE.
075400*
075500     IF  MMDH-SEQ-NBR IS EQUAL TO MBCA-MBIT-FWD-SEQ-NBR
075600     AND X-DETAIL-INDEX IS LESS THAN +3
075700         MOVE ' '                TO MBCA-MBIT-RETURN-FLAG
075800         ADD +1                  TO MBCA-MBIT-FWD-SEQ-NBR
075900         MOVE 'Y'                TO WS-BYPASS-SW
076000         GO TO 8900-END-BROWSE.
076100*
076200     PERFORM 9300-DET-HIST-SELECT
076300                                 THRU 9399-DHS-EXIT.
076400*
076500     IF  WS-DET-HIST-NO
076600         GO TO 8900-READ-DETAIL-HISTORY-FILE.
076700*
076800     IF  X-DETAIL-INDEX IS GREATER THAN +1
076900         SET X-DETAIL-INDEX      DOWN BY +1
077000         GO TO 8900-READ-DETAIL-HISTORY-FILE
077100     ELSE
077200         MOVE MMDH-SEQ-NBR       TO MBCA-MBIT-BACK-SEQ-NBR.
077300*
077400 8900-END-BROWSE.
077500*
077600****************************************************************
077700*    END BROWSE THE MERCHANT DETAIL HISTORY FILE               *
077800****************************************************************
077900*
078000     MOVE 'FC08'                 TO MBCA-PROGRAM-LOCATION.
078100     SET MBIORO-ENDBR            TO TRUE.
078200     PERFORM MMDHAO-ACCESS       THRU MMDHAO-ACCESS-EXIT.
078300*
078400     IF  WS-BYPASS-YES
078500         GO TO 8999-LS-EXIT.
078600*
078700     MOVE ZEROES                 TO MBCA-MBIT-FWD-SEQ-NBR
078800                                    WS-FWD-SEQ-NBR.
078900*
079000 8999-LS-EXIT.
079100     EXIT.
079200*
079300 9000-BACK-SCREEN.
079400*
079500****************************************************************
079600*    START BROWSE THE MERCHANT DETAIL HISTORY FILE             *
079700****************************************************************
079800*
079900     MOVE 'FC09'                 TO MBCA-PROGRAM-LOCATION.
080000     MOVE MBITTS-ORG             TO MBIOWS-MMDH-ORG.
080100     MOVE MBITTS-MERCHANT        TO MBIOWS-MMDH-MERCHANT.
080200     MOVE MBCA-MBIT-FWD-SEQ-NBR  TO MBIOWS-MMDH-SEQ-NBR.
080300     SET MBIORO-STARTBR-GTE      TO TRUE.
080400     PERFORM MMDHAO-ACCESS       THRU MMDHAO-ACCESS-EXIT.
080500*
080600****************************************************************
080700*    READPREV THE MERCHANT DETAIL HISTORY FILE                 *
080800****************************************************************
080900*
081000     MOVE 'FC10'                 TO MBCA-PROGRAM-LOCATION.
081100     SET MBIORO-READ-PREV        TO TRUE.
081200     PERFORM MMDHAO-ACCESS       THRU MMDHAO-ACCESS-EXIT.
081300*
081400     SET X-DETAIL-INDEX          TO +3.
081500     MOVE 'N'                    TO WS-BYPASS-SW.
081600*
081700 9000-READ-DETAIL-HISTORY-FILE.
081800*
081900****************************************************************
082000*    READPREV THE MERCHANT DETAIL HISTORY FILE                 *
082100****************************************************************
082200*
082300     MOVE 'FC11'                 TO MBCA-PROGRAM-LOCATION.
082400     SET MBIORO-READ-PREV        TO TRUE.
082500     PERFORM MMDHAO-ACCESS       THRU MMDHAO-ACCESS-EXIT.
082600*
082700     IF  MMDH-ORG IS NOT EQUAL TO MBITTS-ORG
082800     OR  MMDH-MERCHANT IS NOT EQUAL TO MBITTS-MERCHANT
082900         GO TO 9000-END-BROWSE.
083000*
083100     IF  MMDH-SEQ-NBR IS EQUAL TO MBCA-MBIT-FIRST-SEQ-NBR
083200     AND X-DETAIL-INDEX IS GREATER THAN +1
083300         MOVE ' '                TO MBCA-MBIT-RETURN-FLAG
083400         MOVE MBCA-MBIT-FIRST-SEQ-NBR
083500                                 TO MBCA-MBIT-FWD-SEQ-NBR
083600         MOVE 'Y'                TO WS-BYPASS-SW
083700         GO TO 9000-END-BROWSE.
083800*
083900     PERFORM 9300-DET-HIST-SELECT
084000                                 THRU 9399-DHS-EXIT.
084100*
084200     IF  WS-DET-HIST-NO
084300         GO TO 9000-READ-DETAIL-HISTORY-FILE.
084400*
084500     IF  X-DETAIL-INDEX IS EQUAL TO +3
084600         MOVE MMDH-SEQ-NBR       TO MBCA-MBIT-FWD-SEQ-NBR
084700                                    WS-FWD-SEQ-NBR.
084800*
084900     IF  X-DETAIL-INDEX IS GREATER THAN +1
085000         SET X-DETAIL-INDEX      DOWN BY +1
085100         GO TO 9000-READ-DETAIL-HISTORY-FILE
085200     ELSE
085300         MOVE MMDH-SEQ-NBR       TO MBCA-MBIT-BACK-SEQ-NBR.
085400*
085500 9000-END-BROWSE.
085600*
085700****************************************************************
085800*    END BROWSE THE MERCHANT DETAIL HISTORY FILE               *
085900****************************************************************
086000*
086100     MOVE 'FC12'                 TO MBCA-PROGRAM-LOCATION.
086200     SET MBIORO-ENDBR            TO TRUE.
086300     PERFORM MMDHAO-ACCESS       THRU MMDHAO-ACCESS-EXIT.
086400*
086500 9099-BS-EXIT.
086600     EXIT.
086700*
086800 9100-BUILD-SELECTION-CRITERIA.
086900*
087000     SET X-MBCA-MBIT-CRIT        TO X-SEL-CRIT-INDEX.
087100*
087200     IF  MBCA-MBIT-SEL-CRITERIA (X-MBCA-MBIT-CRIT)
087300                                 IS NOT EQUAL TO SPACES
087400         MOVE MBCA-MBIT-SEL-CRITERIA (X-MBCA-MBIT-CRIT)
087500                                 TO IT01-SELECTION-LIT
087600                                    (X-SEL-CRIT-INDEX)
087700         MOVE DFHBMASB           TO IT01-SELECTION-LIT-A
087800                                    (X-SEL-CRIT-INDEX).
087900*
088000 9199-BSC-EXIT.
088100     EXIT.
088200*
088300 9200-SET-ATTRIBUTE.
088400*
088500     MOVE DFHBMDAS               TO IT01-DETAIL-HIST-A
088600                                    (X-DET-HIST-INDEX
088700                                     X-DETAIL-INDEX).
088800*
088900 9299-SA-EXIT.
089000     EXIT.
089100*
089200 9300-DET-HIST-SELECT.
089300*
089400     MOVE MBCA-CURRENCY-CODE     TO SS95WS-CURRENCY-CODE.
089500*
089600     MOVE 'N'                    TO WS-DET-HIST-SW.
089700*
089800     IF  MBITTS-STORE IS NOT EQUAL TO ZEROES
089900         IF  MBITTS-STORE IS NOT EQUAL TO MMDH-STORE
090000             GO TO 9399-DHS-EXIT.
090100*
090200     IF  MBITTS-TRANS-CODE IS NOT EQUAL TO ZEROES
090300         IF  MMDH-TRANS-CODE IS NOT EQUAL
090400                                 TO MBITTS-TRANS-CODE
090500             GO TO 9399-DHS-EXIT.
090600*
090700     IF  MBITTS-LOGIC-MODULE-ALL
090800         NEXT SENTENCE
090900     ELSE
091000         IF  MMDH-LOGIC-MODULE IS NOT EQUAL
091100                                 TO MBITTS-LOGIC-MODULE
091200             GO TO 9399-DHS-EXIT.
091300*
091400     IF  MBITTS-CARD-PROD-ALL
091500         NEXT SENTENCE
091600     ELSE
091700         IF  MMDH-PRODUCT IS NOT EQUAL
091800                                 TO MBITTS-CARD-PROD
091900             GO TO 9399-DHS-EXIT.
092000*
092100     IF  MBITTS-QUAL-LEVEL IS NOT EQUAL TO ZEROES
092200         IF  MMDH-QUAL-LEVEL IS NOT EQUAL
092300                                 TO MBITTS-QUAL-LEVEL
092400             GO TO 9399-DHS-EXIT.
092500*
092600     IF  MBITTS-PLAN-NBR-ALL
092700         NEXT SENTENCE
092800     ELSE
092900         IF  MMDH-PLAN IS NOT EQUAL
093000                                 TO MBITTS-PLAN-NBR
093100             GO TO 9399-DHS-EXIT.
093200*
093300     IF  MMDH-BATCH-DATE IS LESS THAN MBITTS-BATCH-DATE
093400         GO TO 9399-DHS-EXIT.
093500*
093600     IF  MBITTS-BATCH-NUMBER IS NOT EQUAL TO ZEROES
093700         IF  MMDH-BATCH-NBR IS NOT EQUAL
093800                                 TO MBITTS-BATCH-NUMBER
093900             GO TO 9399-DHS-EXIT.
094000*
094100     IF  MBITTS-BATCH-SOURCE-ALL
094200         NEXT SENTENCE
094300     ELSE
094400         IF  MMDH-BATCH-SOURCE IS NOT EQUAL
094500                                 TO MBITTS-BATCH-SOURCE
094600             GO TO 9399-DHS-EXIT.
094700*
094800     IF  MBITTS-GL-SOURCE-ALL
094900         NEXT SENTENCE
095000     ELSE
095100         IF  MMDH-GL-SOURCE IS NOT EQUAL TO MBITTS-GL-SOURCE
095200             GO TO 9399-DHS-EXIT.
095300*
095400     IF  MMDH-POST-DATE IS LESS THAN MBITTS-POSTING-DATE
095500         GO TO 9399-DHS-EXIT.
095600*
095700     IF  MBITTS-SETT-DEST-ALL
095800         NEXT SENTENCE
095900     ELSE
096000         IF  MMDH-SETT-ACCT IS NOT EQUAL TO MBITTS-SETT-DEST
096100             GO TO 9399-DHS-EXIT.
096200*
096300     IF  MBITTS-SETT-FLAG-ALL
096400         NEXT SENTENCE
096500     ELSE
096600         IF  MMDH-SETT-FLAG IS NOT EQUAL TO MBITTS-SETT-FLAG
096700             GO TO 9399-DHS-EXIT.
096800*
096900     IF  MBITTS-STMT-FLAG-ALL
097000         NEXT SENTENCE
097100     ELSE
097200         IF  MMDH-STMT-FLAG IS NOT EQUAL TO MBITTS-STMT-FLAG
097300             GO TO 9399-DHS-EXIT.
097400*
097500     IF  MMDH-AMOUNT IS LESS THAN MBITTS-FROM-TRANS-AMT
097600     OR  MMDH-AMOUNT IS GREATER THAN MBITTS-TO-TRANS-AMT
097700         GO TO 9399-DHS-EXIT.
097800*
097900     SET X-MBITTS-INDEX          TO X-DETAIL-INDEX.
098000     SET X-SETT-DATA-INDEX       TO X-DETAIL-INDEX.
098100     SET X-DET-HIST-INDEX        TO +1.
098200*
098300     MOVE MMDH-SEQ-NBR           TO MBITTS-DET-SEQ-NBR
098400                                    (X-MBITTS-INDEX).
098500*
098600     MOVE MMDH-GL-SOURCE         TO WS-NUMBER-ONE
098700                                    MBITTS-DET-GL-SOURCE
098800                                    (X-MBITTS-INDEX).
098900     MOVE WS-NUMBER-ONE-AREA     TO IT01-DETAIL-HIST
099000                                    (X-DET-HIST-INDEX
099100                                     X-DETAIL-INDEX).
099200*
099300     SET X-DET-HIST-INDEX        UP BY +1.
099400     MOVE MMDH-NBR-ITEMS         TO WS-NUMBER-EIGHT
099500                                    MBITTS-DET-NBR-ITEMS
099600                                    (X-MBITTS-INDEX).
099700     MOVE WS-NUMBER-EIGHT-AREA   TO IT01-DETAIL-HIST
099800                                    (X-DET-HIST-INDEX
099900                                     X-DETAIL-INDEX).
100000*
100100     SET X-DET-HIST-INDEX        UP BY +1.
100200     MOVE MMDH-AMOUNT            TO MBITTS-DET-AMOUNT
100300                                    (X-MBITTS-INDEX).
100400     MOVE MMDH-AMOUNT            TO SS95WS-IN-AMT.
100500     PERFORM SS95PD-NAP-ROUTINE
100600                                 THRU SS95PD-NAP-EXIT.
100700     MOVE SS95WS-OUT-AMT-L21     TO IT01-DETAIL-HIST
100800                                    (X-DET-HIST-INDEX
100900                                     X-DETAIL-INDEX).
101000*
101100     SET X-DET-HIST-INDEX        UP BY +1.
101200     MOVE MMDH-TRANS-CODE        TO WS-TRANS-CODE
101300                                    MBITTS-DET-TRANS-CODE
101400                                    (X-MBITTS-INDEX).
101500     MOVE MMDH-TRANS-FLAG        TO WS-TRANS-FLAG
101600                                    MBITTS-DET-TRANS-FLAG
101700                                    (X-MBITTS-INDEX).
101800     MOVE MMDH-LOGIC-MODULE      TO WS-TRANS-LOGIC-MODULE
101900                                    MBITTS-DET-LOGIC-MODULE
102000                                    (X-MBITTS-INDEX).
102100     MOVE WS-TRANS-CODE-AREA     TO IT01-DETAIL-HIST
102200                                    (X-DET-HIST-INDEX
102300                                     X-DETAIL-INDEX).
102400*
102500     SET X-DET-HIST-INDEX        UP BY +1.
102600     MOVE MMDH-PRODUCT           TO WS-NUMBER-TWO
102700                                    MBITTS-DET-CARD-PROD
102800                                    (X-MBITTS-INDEX).
102900     MOVE WS-NUMBER-TWO-AREA     TO IT01-DETAIL-HIST
103000                                    (X-DET-HIST-INDEX
103100                                     X-DETAIL-INDEX).
103200*
103300     SET X-DET-HIST-INDEX        UP BY +1.
103400     MOVE MMDH-QUAL-LEVEL        TO WS-NUMBER-TWO
103500                                    MBITTS-DET-QUAL-LEVEL
103600                                    (X-MBITTS-INDEX).
103700     MOVE WS-NUMBER-TWO-AREA     TO IT01-DETAIL-HIST
103800                                    (X-DET-HIST-INDEX
103900                                     X-DETAIL-INDEX).
104000*
104100     SET X-DET-HIST-INDEX        UP BY +1.
104200     MOVE MMDH-PLAN              TO WS-NUMBER-FIVE
104300                                    MBITTS-DET-PLAN-NBR
104400                                    (X-MBITTS-INDEX).
104500     MOVE WS-NUMBER-FIVE-AREA    TO IT01-DETAIL-HIST
104600                                    (X-DET-HIST-INDEX
104700                                     X-DETAIL-INDEX).
104800*
104900     SET X-DET-HIST-INDEX        UP BY +1.
105000     MOVE MMDH-STORE             TO WS-NUMBER-NINE
105100                                    MBITTS-DET-STORE-NBR
105200                                    (X-MBITTS-INDEX).
105300     MOVE WS-NUMBER-NINE-AREA    TO IT01-DETAIL-HIST
105400                                    (X-DET-HIST-INDEX
105500                                     X-DETAIL-INDEX).
105600*
105700     SET X-DET-HIST-INDEX        UP BY +1.
105800     MOVE MMDH-BATCH-NBR         TO WS-NUMBER-FIVE
105900                                    MBITTS-DET-BATCH-NUMBER
106000                                    (X-MBITTS-INDEX).
106100     MOVE WS-NUMBER-FIVE-AREA    TO IT01-DETAIL-HIST
106200                                    (X-DET-HIST-INDEX
106300                                     X-DETAIL-INDEX).
106400*
106500     SET X-DET-HIST-INDEX        UP BY +1.
106600     MOVE MMDH-BATCH-DATE        TO SS01WS-JULIAN
106700                                    MBITTS-DET-BATCH-DATE
106800                                    (X-MBITTS-INDEX).
106900     PERFORM SS26PD-NUMERICALLY-EDIT-DATE  THRU SS26PD-NED-EXIT.
107000     MOVE SS01WS-DATE            TO WS-DATE-WORK
107100     MOVE WS-DATE-WORK-AREA      TO IT01-DETAIL-HIST
107200                                    (X-DET-HIST-INDEX
107300                                     X-DETAIL-INDEX).
107400*
107500     SET X-DET-HIST-INDEX        UP BY +1.
107600     MOVE MMDH-BATCH-SOURCE      TO WS-NUMBER-FIVE
107700                                    MBITTS-DET-BATCH-SOURCE
107800                                    (X-MBITTS-INDEX).
107900     MOVE WS-NUMBER-FIVE-AREA    TO IT01-DETAIL-HIST
108000                                    (X-DET-HIST-INDEX
108100                                     X-DETAIL-INDEX).
108200*
108300     SET X-DET-HIST-INDEX        UP BY +1.
108400     MOVE MMDH-BATCH-SEQ         TO WS-NUMBER-EIGHT
108500                                    MBITTS-DET-BATCH-SEQ
108600                                    (X-MBITTS-INDEX).
108700     MOVE WS-NUMBER-EIGHT-AREA   TO IT01-DETAIL-HIST
108800                                    (X-DET-HIST-INDEX
108900                                     X-DETAIL-INDEX).
109000*
109100*
109200     SET X-DET-HIST-INDEX        UP BY +1.
109300     MOVE MMDH-POST-DATE         TO SS01WS-JULIAN
109400                                    MBITTS-DET-POST-DATE
109500                                    (X-MBITTS-INDEX).
109600     PERFORM SS26PD-NUMERICALLY-EDIT-DATE  THRU SS26PD-NED-EXIT.
109700     MOVE SS01WS-DATE            TO WS-DATE-WORK
109800     MOVE WS-DATE-WORK-AREA      TO IT01-DETAIL-HIST
109900                                    (X-DET-HIST-INDEX
110000                                     X-DETAIL-INDEX).
110100*
110200     SET X-DET-HIST-INDEX        UP BY +1.
110300     MOVE MMDH-ENTRY-DATE        TO SS01WS-JULIAN
110400                                    MBITTS-DET-ENTRY-DATE
110500                                    (X-MBITTS-INDEX).
110600     PERFORM SS26PD-NUMERICALLY-EDIT-DATE  THRU SS26PD-NED-EXIT.
110700     MOVE SS01WS-DATE            TO WS-DATE-WORK
110800     MOVE WS-DATE-WORK-AREA      TO IT01-DETAIL-HIST
110900                                    (X-DET-HIST-INDEX
111000                                     X-DETAIL-INDEX).
111100*
111200     SET X-DET-HIST-INDEX        UP BY +1.
111300     MOVE MMDH-RPT-DESC          TO IT01-DETAIL-HIST
111400                                    (X-DET-HIST-INDEX
111500                                     X-DETAIL-INDEX)
111600                                    MBITTS-DET-RPT-DESC
111700                                    (X-MBITTS-INDEX).
111800*
111900     MOVE MMDH-SETT-FLAG         TO IT01-SETT-FLAG
112000                                    (X-SETT-DATA-INDEX)
112100                                    MBITTS-DET-SETT-FLAG
112200                                    (X-MBITTS-INDEX).
112300*
112400     MOVE MMDH-SETT-ACCT         TO IT01-SETT-ACCT
112500                                    (X-SETT-DATA-INDEX)
112600                                    MBITTS-DET-SETT-ACCT
112700                                    (X-MBITTS-INDEX).
112800*
112900     MOVE MMDH-SETT-DATE         TO SS01WS-JULIAN
113000                                    MBITTS-DET-SETT-DATE
113100                                    (X-MBITTS-INDEX).
113200     PERFORM SS26PD-NUMERICALLY-EDIT-DATE  THRU SS26PD-NED-EXIT.
113300     MOVE SS01WS-DATE            TO WS-DATE-WORK
113400     MOVE WS-DATE-WORK           TO IT01-SETT-DATE
113500                                    (X-SETT-DATA-INDEX).
113600*
113700     MOVE 'Y'                    TO WS-DET-HIST-SW.
113800*
113900 9399-DHS-EXIT.
114000     EXIT.
114100*
114200 9400-READ-AHEAD.
114300*
114400****************************************************************
114500*    READNEXT THE MERCHANT DETAIL HISTORY FILE                 *
114600****************************************************************
114700*
114800     MOVE 'FC13'                 TO MBCA-PROGRAM-LOCATION.
114900     SET MBIORO-READ-SEQ         TO TRUE.
115000     PERFORM MMDHAO-ACCESS       THRU MMDHAO-ACCESS-EXIT.
115100*
115200     IF  MMDH-ORG IS GREATER THAN MBITTS-ORG
115300     OR  MMDH-MERCHANT IS GREATER THAN MBITTS-MERCHANT
115400         MOVE ZEROES             TO WS-FWD-SEQ-NBR
115500                                    MBCA-MBIT-FWD-SEQ-NBR
115600         GO TO 9499-RA-EXIT.
115700*
115800     IF  MBITTS-STORE IS NOT EQUAL TO ZEROES
115900         IF  MBITTS-STORE IS NOT EQUAL TO MMDH-STORE
116000             GO TO 9399-DHS-EXIT.
116100*
116200     IF  MBITTS-TRANS-CODE IS NOT EQUAL TO ZEROS
116300         IF  MMDH-TRANS-CODE IS NOT EQUAL TO MBITTS-TRANS-CODE
116400             GO TO 9400-READ-AHEAD.
116500*
116600     IF  MBITTS-LOGIC-MODULE-ALL
116700         NEXT SENTENCE
116800     ELSE
116900         IF  MMDH-LOGIC-MODULE IS NOT EQUAL
117000                                 TO MBITTS-LOGIC-MODULE
117100             GO TO 9400-READ-AHEAD.
117200*
117300     IF  MBITTS-CARD-PROD-ALL
117400         NEXT SENTENCE
117500     ELSE
117600         IF  MMDH-PRODUCT IS NOT EQUAL TO MBITTS-CARD-PROD
117700             GO TO 9400-READ-AHEAD.
117800*
117900     IF  MBITTS-QUAL-LEVEL IS NOT EQUAL TO ZEROS
118000         IF  MMDH-QUAL-LEVEL IS NOT EQUAL TO MBITTS-QUAL-LEVEL
118100             GO TO 9400-READ-AHEAD.
118200*
118300     IF  MBITTS-PLAN-NBR-ALL
118400         NEXT SENTENCE
118500     ELSE
118600         IF  MMDH-PLAN IS NOT EQUAL TO MBITTS-PLAN-NBR
118700             GO TO 9400-READ-AHEAD.
118800*
118900     IF  MMDH-BATCH-DATE IS LESS THAN MBITTS-BATCH-DATE
119000         GO TO 9400-READ-AHEAD.
119100*
119200     IF  MBITTS-BATCH-NUMBER IS NOT EQUAL TO ZEROES
119300         IF  MMDH-BATCH-NBR IS NOT EQUAL
119400                                 TO MBITTS-BATCH-NUMBER
119500             GO TO 9400-READ-AHEAD.
119600*
119700     IF  MBITTS-BATCH-SOURCE-ALL
119800         NEXT SENTENCE
119900     ELSE
120000         IF  MMDH-BATCH-SOURCE IS NOT EQUAL
120100                                 TO MBITTS-BATCH-SOURCE
120200             GO TO 9400-READ-AHEAD.
120300*
120400     IF  MBITTS-GL-SOURCE-ALL
120500         NEXT SENTENCE
120600     ELSE
120700         IF  MMDH-GL-SOURCE IS NOT EQUAL
120800                                 TO MBITTS-GL-SOURCE
120900             GO TO 9400-READ-AHEAD.
121000*
121100     IF  MMDH-POST-DATE IS LESS THAN MBITTS-POSTING-DATE
121200         GO TO 9400-READ-AHEAD.
121300*
121400     IF  MBITTS-SETT-DEST-ALL
121500         NEXT SENTENCE
121600     ELSE
121700         IF  MMDH-SETT-ACCT IS NOT EQUAL
121800                                 TO MBITTS-SETT-DEST
121900             GO TO 9400-READ-AHEAD.
122000*
122100     IF  MBITTS-SETT-FLAG-ALL
122200         NEXT SENTENCE
122300     ELSE
122400         IF  MMDH-SETT-FLAG IS NOT EQUAL
122500                                 TO MBITTS-SETT-FLAG
122600             GO TO 9400-READ-AHEAD.
122700*
122800     IF  MBITTS-STMT-FLAG-ALL
122900         NEXT SENTENCE
123000     ELSE
123100         IF  MMDH-STMT-FLAG IS NOT EQUAL
123200                                 TO MBITTS-STMT-FLAG
123300             GO TO 9400-READ-AHEAD.
123400*
123500     IF  MMDH-AMOUNT IS LESS THAN MBITTS-FROM-TRANS-AMT
123600     OR  MMDH-AMOUNT IS GREATER THAN MBITTS-TO-TRANS-AMT
123700         GO TO 9400-READ-AHEAD.
123800*
123900     MOVE MMDH-SEQ-NBR           TO WS-FWD-SEQ-NBR.
124000*
124100 9499-RA-EXIT.
124200     EXIT.
124300/         JULIAN TO GREGORIAN DATE ROUTINE
124400     COPY SS08PD.
124500/         DATE AND TIME EDIT ROUTINES
124600     COPY SS26PD.
124700     COPY SS27PD.
124800/         LINE 24 PF KEYS ROUTINE
124900     COPY SS15PD.
125000/         FORMAT NBR AND AMT PROCEDURS
125100     COPY SS95PDO REPLACING ==:XXCA:== BY ==MBCA==.
125200/         MERCHANT DETAIL HISTORY RECORD ACCESS ROUTINES
125300     COPY MMDHAO.
125400/         ON-LINE MAP ROUTINES
125500     COPY MB60PD REPLACING 'MBMAPXX' BY 'MBIT01 '
125600                           MBMAPXXI BY MBIT01I
125700                           MBMAPXXO BY MBIT01O.
125800/         ON-LINE PROCEDURES
125900     COPY MB70PD.
126000/         MESSAGE LINE FORMAT ROUTINE.
126100     COPY MB06PD.
126200/
126300     COPY SMFTPXO.
