000100 IDENTIFICATION DIVISION.
000200 PROGRAM-ID. MBOMA00.
000201*       RELEASE DATE=08/24/01.        REVISION LEVEL=08.06      *
000202*****************************************************************
000203*WARNING.  THIS COMPUTER PROGRAM IS PROTECTED BY COPYRIGHT LAW  *
000204*AND INTERNATIONAL TREATIES.  UNAUTHORIZED REPRODUCTION OR      *
000205*DISTRIBUTION OF THIS PROGRAM, OR ANY PORTION OF IT, MAY RESULT *
000206*IN SEVERE CIVIL AND CRIMINAL PENATLIES, AND WILL BE PROSECUTED *
000207*TO THE MAXIMUM EXTENT POSSIBLE UNDER THE LAW.                  *
000208*COPYRIGHT 1999 PAYSYS INTERNATIONAL, INC.  ALL RIGHTS RESERVED.*
000209*****************************************************************
000300*****************************************************************
000400*                                                               *
000500*               M E R C H A N T   S Y S T E M                   *
000600*                                                               *
000700*      MBOMA00 - ON-LINE MERCHANT ADJUSTMENTS                   *
000800*                SCREEN 00                                      *
000900*                                                               *
001000*              1. TRANSIDS                                      *
001100*                 A. MBMA                                       *
001200*              2. MAPS USED -                                   *
001300*                 A. MBMA00 (SCREEN 00)                         *
001400*              3. FILES USED -                                  *
001500*                 A. MMOC   (ORG CONTROL FILE)                  *
001600*                 B. MMMM   (MERCHANT MASTER FILE)              *
001700*                                                               *
001800*****************************************************************
001900*
002000 ENVIRONMENT DIVISION.
002100 DATA DIVISION.
002200 WORKING-STORAGE SECTION.
002300 01  FILLER                  PIC  X(12)      VALUE '** WS-BEG **'.
002400*         I/O REQUEST BLOCK WORK AREAS
002500     COPY MBIOWS.
002600/         I/O REQUEST BLOCK
002700     COPY MBIORO.
002800/         DATE WORK AREAS
002900     COPY SS01WS.
003000/         ONLINE WORK AREAS
003100     COPY SS08WS.
003200/
003300     COPY SS00WS.
003400/
003500     COPY SMFTWS.
003600/
003700     COPY SMPTRL REPLACING ==:SMPT:== BY ==SMPT==.
003800/
003900     COPY MB61LK.
004000/         STANDARD ERROR MESSAGES
004100     COPY MBEMWS.
004200*
004300 01  FILLER                  PIC  X(12)      VALUE '** WS-END **'.
004400/
004500 LINKAGE SECTION.
004600 01  DFHCOMMAREA.
004700     COPY MB60WS.
004800/         MERCHANT DIRECTORY SCREEN 00 MAP DSECT
004900     COPY MBMA00.
005000/         MERCHANT DIRECTORY SCREEN 00 MAP REDEFINITION
005100     COPY MBMA00R.
005200/         ORG CONTROL RECORD LAYOUT
005300     COPY MMOCRL.
005400/         MONETARY TRANSACTION RECORD LAYOUT
005500     COPY MTPTRL REPLACING ==:MTPT:== BY ==MMT1==.
005600/         MERCHANT RELATIONSHIP MASTER RECORD LAYOUT
005700     COPY MMMMRL.
005800/
005900 PROCEDURE DIVISION.
006000 0000-HOUSEKEEPING SECTION.
006100 0100-INIT.
006200*
006300     MOVE 'PC01'                 TO MBCA-PROGRAM-LOCATION.
006400     PERFORM MB70PD-ON-LINE-HOUSEKEEPING
006500                                 THRU MB70PD-OLH-EXIT.
006600*
006700     IF  MBCA-RECEIVE-SCREEN
006800         GO TO 2000-RECEIVE-SCREEN.
006900*
007000 1000-SEND-SCREEN SECTION.
007100*
007200****************************************************************
007300*    GET CICS STORAGE NEEDED FOR THE MAP                       *
007400****************************************************************
007500*
007600     MOVE 'SC01'                 TO MBCA-PROGRAM-LOCATION.
007700     PERFORM MB60PD-GETMAIN-FOR-MAP
007800                                 THRU MB60PD-GFM-EXIT.
007900*
008000*****************************************************************
008100*    CHECK KEY CODES                                            *
008200* 1. IF INITIAL KEY CODE, BYPASS CHECK OF KEY CODES.            *
008300* 2. IF MMMM KEY CODE, IT MUST BE A VALID CODE.  IF DIRECT, GO  *
008400*    TO THE RECEIVE EDITING ROUTINE SINCE WE HAVE PLUGGED THE   *
008500*    ORG AND MERCHANT INTO THE MAP. IF AN ERROR OCCURS IN THE   *
008600*    RECEIVE SCREEN ROUTINE, IT WILL HANDLE BUILDING THE MAP    *
008700*    AND IT WILL SEND ITS OWN SCREEN.  THIS IS WHY LOCATE       *
008800*    PROGRAMS ALWAYS SEND WITH ERASE NO MATTER WHICH ROUTINE    *
008900*    YOU ARE IN.  IF NOT DIRECT, PLUG ORG AND MERCHANT INTO THE *
009000*    MAP AND BYPASS ANY OTHER CHECKING OF THE KEY CODE.
009100* 3. IF 2 IS FALSE, SEE IF THE MBCA-MERCHANT-ORG                *
009200*    FIELD IS GREATER THAN ZERO.  IF SO, PLUG INTO MAP.         *
009300*    SEE IF THE MBCA-MERCHANT FIELD IS GREATER THAN ZERO. IF    *
009400*    SO, PLUG INTO MAP.                                         *
009500*    HANDLE IF THEY WERE NON-DIRECT.                            *
009600*****************************************************************
009700*
009800     IF  MBCA-INITIAL-KEY-CODE
009900     OR  MBCA-PTI-FUNCTION-IS-ADD
010000         GO TO 1100-BUILD-SCREEN.
010100*
010200     IF  MBCA-MMMM-KEY-CODE
010300         IF  MBCA-MERCHANT-ORG IS GREATER THAN ZERO
010400         AND MBCA-MERCHANT     IS GREATER THAN ZERO
010500             MOVE MBCA-MERCHANT-ORG
010600                                 TO MA00-ORG
010700             MOVE MBCA-MERCHANT  TO MA00-MERCHANT
010800             MOVE +9             TO MA00-MERCHANT-L
010900             MOVE DFHBMUNF       TO MA00-ORG-A
011000                                    MA00-MERCHANT-A
011100             IF  MBCA-DIRECT-TRANSFER-CODE
011200             AND MBCA-INITIAL-SCREEN-NBR
011300                 MOVE 00         TO MBCA-SCREEN-NBR
011400                 GO TO 2120-READ-ORG
011500             ELSE
011600                 GO TO 1100-BUILD-SCREEN.
011700*
011800     IF  MBCA-VALID-KEY-CODES
011900         IF  MBCA-MERCHANT-ORG IS GREATER THAN ZERO
012000             MOVE MBCA-MERCHANT-ORG
012100                                 TO MA00-ORG
012200             MOVE DFHBMUNF       TO MA00-ORG-A
012300             IF  MBCA-MERCHANT IS GREATER THAN ZERO
012400                 MOVE MBCA-MERCHANT
012500                                 TO MA00-MERCHANT
012600                 MOVE DFHBMUNF   TO MA00-MERCHANT-A.
012700*
012800 1100-BUILD-SCREEN.
012900*
013000****************************************************************
013100*    INITIALIZE THE STANDARD MAP LINES                         *
013200****************************************************************
013300*
013400     MOVE SS08WS-CURSOR          TO MA00-ORG-L.
013500     MOVE 00                     TO MBCA-SCREEN-NBR.
013600     PERFORM MB60PD-INIT-STD-MAP-LINES
013700                                 THRU MB60PD-ISML-EXIT.
013800*
013900     IF  MBCA-MERCHANT-ORG IS NUMERIC
014000     AND MBCA-MERCHANT-ORG IS GREATER THAN ZEROES
014100         MOVE MBCA-MERCHANT-ORG  TO MA00-ORG
014200         MOVE DFHBMUNF           TO MA00-ORG-A.
014300*
014400     IF  MBCA-MERCHANT IS NUMERIC
014500     AND MBCA-MERCHANT IS GREATER THAN ZEROES
014600         MOVE MBCA-MERCHANT      TO MA00-MERCHANT
014700         MOVE DFHBMUNF           TO MA00-MERCHANT-A.
014800*
014900     MOVE DFHBMASK               TO MA00-CURRENT-PAGE-A.
015000*
015100****************************************************************
015200*    SEND THE MAP                                              *
015300****************************************************************
015400*
015500     MOVE 'BM01'                 TO MBCA-PROGRAM-LOCATION.
015600     PERFORM MB60PD-SEND-MAP-WITH-ERASE
015700                                 THRU MB60PD-SMWE-EXIT.
015800*
015900****************************************************************
016000*    RETURN TO CICS                                            *
016100****************************************************************
016200*
016300     MOVE 'PC02'                 TO MBCA-PROGRAM-LOCATION.
016400     PERFORM MB70PD-RETURN-TRANS-ID
016500                                 THRU MB70PD-RTI-EXIT.
016600/
016700 2000-RECEIVE-SCREEN SECTION.
016800*
016900****************************************************************
017000*    THIS SECTION RECEIVES THE 00 SCREEN                       *
017100****************************************************************
017200*
017300     MOVE 'BM02'                 TO MBCA-PROGRAM-LOCATION.
017400     PERFORM MB60PD-RECEIVE-MAP  THRU MB60PD-RM-EXIT.
017500*
017600****************************************************************
017700*    CHECK FOR ANOTHER TRANSACTION ID ENTERED BY THE USER      *
017800****************************************************************
017900*
018000     MOVE 'PC03'                 TO MBCA-PROGRAM-LOCATION.
018100     PERFORM MB60PD-NEW-TRANS-ROUTINE
018200                                 THRU MB60PD-NTR-EXIT.
018300*
018400 2100-EDIT-SCREEN.
018500*
018600     SET SS08WS-ERROR-SW-NO      TO TRUE.
018700     MOVE MBCA-EIBAID            TO SS08WS-EIBAID.
018800*
018900     IF  (MA00-ORG-L IS LESS THAN 1
019000     AND  MA00-MERCHANT-L IS LESS THAN 1)
019100     AND (SS08WS-VALID-PF-KEY
019200     OR   SS08WS-EIBAID-VALID-PF-KEY)
019300         SET MBCA-INITIAL-SCREEN-NBR
019400                                 TO TRUE
019500         GO TO 2690-TRANSFER-XCTL.
019600*
019700 2110-EDIT-ORG.
019800*
019900     MOVE DFHBMUNF               TO MA00-ORG-A.
020000     MOVE DFHBMASK               TO MA00-ORG-LP-A
020100                                    MA00-ORG-RP-A.
020200*
020300     IF  MA00-ORG-L IS EQUAL TO ZERO
020400     OR  MA00-ORG IS NOT NUMERIC
020500         MOVE MBEMWS-INVALID-ORG TO MA00-ERR-MESSAGE
020600         GO TO 2130-ORG-ERROR.
020700*
020800     IF  MA00-ORG IS LESS THAN MBCA-ORG-LOW
020900     OR  MA00-ORG IS GREATER THAN MBCA-ORG-HIGH
021000         MOVE MBEMWS-INVALID-ORG TO MA00-ERR-MESSAGE
021100         GO TO 2130-ORG-ERROR.
021200*
021300 2120-READ-ORG.
021400*
021500****************************************************************
021600*    READ THE ORGANIZATION FILE RECORD                         *
021700****************************************************************
021800*
021900     MOVE 'FC01'                 TO MBCA-PROGRAM-LOCATION.
022000     MOVE MA00-ORG               TO MBIOWS-MMOC-ORG.
022100     MOVE SS08WS-CICS-FC-NOTFND  TO MBIORO-TEMP-STATUS-1.
022200     SET MBIORO-READ-RANDOM      TO TRUE.
022300     PERFORM MMOCAO-ACCESS       THRU MMOCAO-ACCESS-EXIT.
022400*
022500     IF  SS08WS-RC-FC-VALID-RTN-CODE
022600         MOVE MMOC-ORG           TO MBCA-MERCHANT-ORG
022700                                    MBCA-MBMA-ORG
022800         MOVE MMOC-CURRENCY-CODE
022900                                 TO MBCA-CURRENCY-CODE
023000         MOVE MMOC-CURRENCY-NOD
023100                                 TO MBCA-CURRENCY-NOD
023200         MOVE MMOC-PERCENT-NOD
023300                                 TO MBCA-PERCENT-NOD
023400         MOVE MMOC-PER-ITEM-NOD
023500                                 TO MBCA-PER-ITEM-NOD
023600         MOVE MMOC-TODAYS-JULIAN
023700                                 TO MBCA-MBMA-TODAYS-JULIAN
023800         IF  MMOC-ADD-PENDING
023900             MOVE MBEMWS-ADD-PENDING
024000                                 TO MA00-ERR-MESSAGE
024100         ELSE
024200             IF  MMOC-REC-INCOMPLETE
024300             OR  MMOC-REC-PURGED
024400                 MOVE MBEMWS-NOT-ACTIVE
024500                                 TO MA00-ERR-MESSAGE
024600             ELSE
024700                 GO TO 2140-EDIT-MERCHANT
024800     ELSE
024900         MOVE MBEMWS-NOT-ON-FILE TO MA00-ERR-MESSAGE.
025000*
025100 2130-ORG-ERROR.
025200*
025300     MOVE DFHBMNBF               TO MA00-ORG-A.
025400     MOVE DFHBMASB               TO MA00-ORG-LP-A
025500                                    MA00-ORG-RP-A.
025600     MOVE SS08WS-CURSOR          TO MA00-ORG-L.
025700     SET SS08WS-ERROR-SW-YES     TO TRUE.
025800*
025900 2140-EDIT-MERCHANT.
026000*
026100     MOVE DFHBMUNF               TO MA00-MERCHANT-A.
026200     MOVE DFHBMASK               TO MA00-MERCHANT-LP-A
026300                                    MA00-MERCHANT-RP-A.
026400*
026500     IF  MA00-MERCHANT-L IS EQUAL TO ZERO
026600         MOVE ZEROES             TO MA00-MERCHANT
026700     ELSE
026800         IF  MA00-MERCHANT IS NOT NUMERIC
026900             MOVE MBEMWS-INVALID-MERCHANT
027000                                 TO MA00-ERR-MESSAGE
027100             GO TO 2150-MERCHANT-ERROR.
027200*
027300     IF  SS08WS-ERROR-SW-YES
027400         GO TO 2190-CHECK-ERROR.
027500*
027600****************************************************************
027700*    READ RANDOM  THE MERCHANT FILE                            *
027800****************************************************************
027900*
028000     MOVE 'FC02'                 TO MBCA-PROGRAM-LOCATION.
028100     MOVE MBCA-MBMA-ORG          TO MBIOWS-MMMM-ORG.
028200*
028300     IF  MBCA-DIRECT-TRANSFER-CODE
028400     AND MBCA-INITIAL-SCREEN-NBR
028500         MOVE MBCA-MERCHANT      TO MBIOWS-MMMM-MERCHANT
028600     ELSE
028700         MOVE MA00-MERCHANT      TO MBIOWS-MMMM-MERCHANT.
028800*
028900     MOVE SS08WS-CICS-FC-NOTFND  TO MBIORO-TEMP-STATUS-1.
029000     SET MBIORO-READ-RANDOM      TO TRUE.
029100     PERFORM MMMMAO-ACCESS      THRU MMMMAO-ACCESS-EXIT.
029200*
029300     IF  SS08WS-RC-FC-VALID-RTN-CODE
029400         MOVE MMMM-MERCHANT      TO MBCA-MERCHANT
029500                                    MBCA-MBMA-MERCHANT
029600         MOVE MMMM-DBA-NAME      TO MBCA-MBMA-DBA-NAME
029700         MOVE MMMM-DBA-CITY      TO MBCA-MBMA-DBA-CITY
029800         MOVE MMMM-NA-LINE (1 1) TO MBCA-MBMA-MERCHANT-NAME
029900         MOVE MMMM-DBA-COUNTRY-CODE
030000                                 TO MBCA-MBMA-DBA-COUNTRY-CODE
030100         IF  MMMM-ADD-PENDING
030200             MOVE MBEMWS-ADD-PENDING
030300                                 TO MA00-ERR-MESSAGE
030400         ELSE
030500             IF  MMMM-REC-INCOMPLETE
030600             OR  MMMM-REC-PURGING
030700                 MOVE MBEMWS-NOT-ACTIVE
030800                                 TO MA00-ERR-MESSAGE
030900             ELSE
031000                 IF  MMMM-REC-PURGED
031100                     MOVE MBEMWS-REC-PURGED
031200                                 TO MA00-ERR-MESSAGE
031300                 ELSE
031400                     GO TO 2190-CHECK-ERROR
031500     ELSE
031600         MOVE MBEMWS-NOT-ON-FILE TO MA00-ERR-MESSAGE.
031700*
031800 2150-MERCHANT-ERROR.
031900*
032000     MOVE DFHBMNBF               TO MA00-MERCHANT-A.
032100     MOVE DFHBMASB               TO MA00-MERCHANT-LP-A
032200                                    MA00-MERCHANT-RP-A.
032300     MOVE SS08WS-CURSOR          TO MA00-MERCHANT-L.
032400     SET SS08WS-ERROR-SW-YES     TO TRUE.
032500*
032600 2190-CHECK-ERROR.
032700*
032800     IF  SS08WS-ERROR-SW-NO
032900         PERFORM 9100-START-BROWSE-MMT1
033000                                 THRU 9199-SBMMT1-EXIT.
033100*
033200     IF  SS08WS-ERROR-SW-NO
033300         GO TO 2600-SETUP-COMMAREA
033400     ELSE
033500         IF  SS08WS-VALID-PF-KEY
033600         OR  SS08WS-EIBAID-VALID-PF-KEY
033700             SET MBCA-INITIAL-SCREEN-NBR
033800                                 TO TRUE
033900             GO TO 2690-TRANSFER-XCTL.
034000*
034100 2300-SEND-MAP.
034200*
034300****************************************************************
034400*    SEND THE MAP                                              *
034500****************************************************************
034600*
034700     PERFORM MB60PD-INIT-STD-MAP-LINES
034800                                 THRU MB60PD-ISML-EXIT.
034900*
035000     MOVE DFHBMASK               TO MA00-CURRENT-PAGE-A.
035100*
035200     MOVE 'BM03'                 TO MBCA-PROGRAM-LOCATION.
035300     PERFORM MB60PD-SEND-MAP-WITH-ERASE
035400                                 THRU MB60PD-SMWE-EXIT.
035500*
035600****************************************************************
035700*    RETURN TO CICS                                            *
035800****************************************************************
035900*
036000     MOVE 'PC04'                 TO MBCA-PROGRAM-LOCATION.
036100     PERFORM MB70PD-RETURN-TRANS-ID
036200                                 THRU MB70PD-RTI-EXIT.
036300/
036400 2600-SETUP-COMMAREA.
036500*
036600****************************************************************
036700*    SET UP COMMAREA FIELDS AND TRANSFER TO THE NEXT PROGRAM   *
036800****************************************************************
036900*
037000     MOVE MBCA-EIBAID            TO SS08WS-EIBAID.
037100*
037200     MOVE MBIOWS-MMMM-KEY-CODE   TO MBCA-KEY-CODE.
037300*
037400     PERFORM MB60PD-EDIT-PAGE-NBR
037500                                 THRU MB60PD-EPN-EXIT.
037600*
037700     IF  MBCA-PTI-FUNCTION-IS-ADD
037800         MOVE 52                 TO MBCA-SCREEN-NBR.
037900*
038000     IF  SS08WS-VALID-PF-KEY
038100     OR  SS08WS-EIBAID-VALID-PF-KEY
038200         SET MBCA-INITIAL-SCREEN-NBR
038300                                 TO TRUE.
038400*
038500 2690-TRANSFER-XCTL.
038600*
038700     MOVE 'PC05'                 TO MBCA-PROGRAM-LOCATION.
038800     PERFORM MB70PD-XCTL-TO-MBOXCTL
038900                                 THRU MB70PD-XTM-EXIT.
039000/
039100 9000-PERFORMED-ROUTINES-SECT SECTION.
039200*
039300 9100-START-BROWSE-MMT1.
039400*
039500     IF  MBCA-PTI-FUNCTION-IS-MAINT
039600     OR  MBCA-PTI-FUNCTION-IS-INQUIRY
039700         MOVE 'FC03'             TO MBCA-PROGRAM-LOCATION
039800         MOVE MBCA-MBMA-ORG      TO MBIOWS-MMT1-ORG
039900         MOVE MBCA-MERCHANT      TO MBIOWS-MMT1-MERCHANT
040000         MOVE ZEROS              TO MBIOWS-MMT1-SEQ-NBR
040100         MOVE SS08WS-CICS-FC-NOTFND TO MBIORO-TEMP-STATUS-1
040200         SET MBIORO-STARTBR-GTE  TO TRUE
040300         PERFORM MMT1AO-ACCESS   THRU MMT1AO-ACCESS-EXIT
040400     ELSE
040500         MOVE 99999999           TO MBCA-MBMA-FIRST-SEQ-NBR
040600         GO TO 9199-SBMMT1-EXIT.
040700*
040800     IF  SS08WS-RC-FC-NOTFND
040900         MOVE MBEMWS-NOT-ON-FILE TO MA00-ERR-MESSAGE
041000         MOVE DFHBMNBF           TO MA00-MERCHANT-A
041100                                    MA00-ORG-A
041200         MOVE DFHBMASB           TO MA00-ORG-LP-A
041300                                    MA00-ORG-RP-A
041400                                    MA00-MERCHANT-LP-A
041500                                    MA00-MERCHANT-RP-A
041600         MOVE SS08WS-CURSOR      TO MA00-ORG-L
041700         SET SS08WS-ERROR-SW-YES TO TRUE
041800         GO TO 9199-SBMMT1-EXIT.
041900****************************************************************
042000*    READNEXT THE TRANSACTION FILE                             *
042100****************************************************************
042200*
042300     MOVE 'FC04'                 TO MBCA-PROGRAM-LOCATION.
042400     SET MBIORO-READ-SEQ         TO TRUE.
042500     PERFORM MMT1AO-ACCESS       THRU MMT1AO-ACCESS-EXIT.
042600*
042700     IF  MMT1-ORG IS EQUAL TO MBCA-MBMA-ORG
042800     AND MMT1-MERCHANT IS EQUAL TO MBCA-MERCHANT
042900     AND MMT1-SEQ-NBR IS GREATER THAN ZERO
043000         MOVE MMT1-SEQ-NBR       TO MBCA-MBMA-FIRST-SEQ-NBR
043100                                    MBCA-MBMA-FWD-SEQ-NBR
043200     ELSE
043300         MOVE MBEMWS-NOT-ON-FILE TO MA00-ERR-MESSAGE
043400         MOVE DFHBMNBF           TO MA00-MERCHANT-A
043500                                    MA00-ORG-A
043600         MOVE DFHBMASB           TO MA00-ORG-LP-A
043700                                    MA00-ORG-RP-A
043800                                    MA00-MERCHANT-LP-A
043900                                    MA00-MERCHANT-RP-A
044000         MOVE SS08WS-CURSOR      TO MA00-ORG-L
044100         SET SS08WS-ERROR-SW-YES TO TRUE.
044200*
044300****************************************************************
044400*    END BROWSE THE MONETARY TRANS FILE                       *
044500****************************************************************
044600*
044700     MOVE 'FC05'                 TO MBCA-PROGRAM-LOCATION.
044800     SET MBIORO-ENDBR            TO TRUE.
044900     PERFORM MMT1AO-ACCESS       THRU MMT1AO-ACCESS-EXIT.
045000*
045100*
045200 9199-SBMMT1-EXIT.
045300     EXIT.
045400*         JULIAN TO GREGORIAN DATE ROUTINE
045500     COPY SS08PD.
045600*         DATE AND TIME EDIT ROUTINES
045700     COPY SS26PD.
045800     COPY SS27PD.
045900/         LINE 24 PF KEYS ROUTINE
046000     COPY SS15PD.
046100/         ORG RECORD ACCESS ROUTINES
046200     COPY MMOCAO.
046300/         MONETARY TRANSACTION RECORD ACCESS ROUTINES
046400     COPY MMT1AO.
046500/         MERCHANT MASTER RECORD ACCESS ROUTINES
046600     COPY MMMMAO.
046700/         ON-LINE MAP ROUTINES
046800     COPY MB60PD REPLACING 'MBMAPXX' BY 'MBMA00 '
046900                           MBMAPXXI BY MBMA00I
047000                           MBMAPXXO BY MBMA00O.
047100/         ON-LINE PROCEDURES
047200     COPY MB70PD.
047300/
047400     COPY SMFTPXO.
