000100 IDENTIFICATION DIVISION.
000200 PROGRAM-ID. MBOMA03.
000201*       RELEASE DATE=08/24/01.        REVISION LEVEL=08.06      *
000202*****************************************************************
000203*WARNING.  THIS COMPUTER PROGRAM IS PROTECTED BY COPYRIGHT LAW  *
000204*AND INTERNATIONAL TREATIES.  UNAUTHORIZED REPRODUCTION OR      *
000205*DISTRIBUTION OF THIS PROGRAM, OR ANY PORTION OF IT, MAY RESULT *
000206*IN SEVERE CIVIL AND CRIMINAL PENATLIES, AND WILL BE PROSECUTED *
000207*TO THE MAXIMUM EXTENT POSSIBLE UNDER THE LAW.                  *
000208*COPYRIGHT 1999 PAYSYS INTERNATIONAL, INC.  ALL RIGHTS RESERVED.*
000209*****************************************************************
000300*****************************************************************
000400*                                                               *
000500*               M E R C H A N T   S Y S T E M                   *
000600*                                                               *
000700*      MBOMA03 - ON-LINE MONETARY TRANSACTION RECORDS           *
000800*                ADD/MAINTENANCE/INQUIRY SCREEN 03              *
000900*                                                               *
001000*              1. TRANSIDS                                      *
001100*                 A. MBAA                                       *
001200*                 B. MBMA                                       *
001300*                 C. MBQA                                       *
001400*              2. MAPS USED -                                   *
001500*                 A. MBMA03 (SCREEN 03)                         *
001600*              3. FILES USED -                                  *
001700*                 A. MML1   (LOG/JOURNAL FILE)                  *
001800*                 B. MMT1   (TRANSACTION ENTRY FILE)            *
001900*                 C. MMTC   (TRANSACTION CONTROL FILE)          *
002000*                 D. MMOC   (ORG CONTROL FILE )                 *
002100*                                                               *
002200*****************************************************************
002300*
002400 ENVIRONMENT DIVISION.
002500 DATA DIVISION.
002600 WORKING-STORAGE SECTION.
002700 01  FILLER                  PIC  X(12)      VALUE '** WS-BEG **'.
002800*         I/O REQUEST BLOCK WORK AREAS
002900     COPY MBIOWS.
003000/         I/O REQUEST BLOCK
003100     COPY MBIORO.
003200/         LOG/JOURNAL FILE WORK AREAS
003300     COPY MML1WS REPLACING ==:MML1:== BY ==MML1==.
003400/         TRANSACTION CONTROL FILE WORK AREAS
003500     COPY MMTCWS.
003600/         TRANSACTION ENTRY FILE INITIALIZE VALUES
003700     COPY MTPTIR REPLACING ==:MTPT:== BY ==MMT1==.
003800/         DATE WORK AREAS
003900     COPY SS01WS.
004000/         ONLINE WORK AREAS
004100     COPY SS08WS.
004200/
004300     COPY SS00WS.
004400/
004500     COPY SMFTWS.
004600/
004700     COPY SMPTRL REPLACING ==:SMPT:== BY ==SMPT==.
004800/
004900     COPY MB61LK.
005000/
005100 01  WS-MISCELLANEOUS.
005200     03  WS-SAVE-EIBAID      PIC  X(01)      VALUE SPACES.
005300     03  WS-TEMP-DATE        PIC  9(08)      VALUE ZERO.
005400     03  WS-UPDATE-SW        PIC  X(01)      VALUE 'N'.
005500         88  WS-UPDATE-SW-NO                 VALUE 'N'.
005600         88  WS-UPDATE-SW-YES                VALUE 'Y'.
005700     03  WS-TRAN-CODE-SW     PIC  X(01)      VALUE 'N'.
005800         88  WS-INVALID-TRAN-CODE            VALUE 'N'.
005900         88  WS-VALID-TRAN-CODE              VALUE 'Y'.
006000     03  WS-TRAN-STATUS-SW   PIC  X(01)      VALUE 'N'.
006100         88  WS-INVALID-TRAN-STATUS          VALUE 'N'.
006200         88  WS-VALID-TRAN-STATUS            VALUE 'Y'.
006300*
006400 01  WS-TRANS-CODE           PIC  9(03)      VALUE ZERO.
006500 01  FILLER                  PIC  X(12)      VALUE '** WS-END **'.
006600/
006700 LINKAGE SECTION.
006800 01  DFHCOMMAREA.
006900     COPY MB60WS.
007000/         MERCHANT TRANSACTION SCREEN 02 MAP DSECT
007100     COPY MBMA03.
007200/         MERCHANT TRANSACTION SCREEN 02 MAP REDEFINITION
007300     COPY MBMA03R.
007400/         LOG/JOURNAL RECORD LAYOUT
007500     COPY MML1RL REPLACING ==:MML1:== BY ==MML1==.
007600/         MONETARY TRANSACTION RECORD LAYOUT
007700     COPY MTPTRL REPLACING ==:MTPT:== BY ==MMT1==.
007800/         TRANSACTION CONTROL RECORD LAYOUT
007900     COPY MMTCRL.
008000/         ORG CONTROL FILE RECORD LAYOUT
008100     COPY MMOCRL.
008200/
008300 PROCEDURE DIVISION.
008400 0000-HOUSEKEEPING SECTION.
008500 0100-INIT.
008600*
008700     MOVE MBCA-EIBAID            TO WS-SAVE-EIBAID.
008800     SET MBCA-EIBAID-ENTER       TO TRUE.
008900*
009000     MOVE 'PC01'                 TO MBCA-PROGRAM-LOCATION.
009100     PERFORM MB70PD-ON-LINE-HOUSEKEEPING
009200                                 THRU MB70PD-OLH-EXIT.
009300*
009400     MOVE WS-SAVE-EIBAID         TO MBCA-EIBAID.
009500*
009600     IF  MBCA-RECEIVE-SCREEN
009700         GO TO 2000-RECEIVE-SCREEN.
009800*
009900 1000-SEND-SCREEN SECTION.
010000*
010100****************************************************************
010200*    GET CICS STORAGE NEEDED FOR THE MAP                       *
010300****************************************************************
010400*
010500     MOVE 'SC01'                 TO MBCA-PROGRAM-LOCATION.
010600     PERFORM MB60PD-GETMAIN-FOR-MAP
010700                                 THRU MB60PD-GFM-EXIT.
010800*
010900     MOVE MBCA-MERCHANT-ORG      TO MA03-ORG.
011000     MOVE MBCA-MERCHANT          TO MA03-MERCHANT.
011100     MOVE MBCA-MBMA-MERCHANT-NAME
011200                                 TO MA03-MERCHANT-NAME.
011300*
011400     MOVE 03                     TO MBCA-SCREEN-NBR.
011500*
011600****************************************************************
011700*    INITIALIZE THE STANDARD MAP LINES                         *
011800****************************************************************
011900*
012000     PERFORM MB60PD-INIT-STD-MAP-LINES
012100                                 THRU MB60PD-ISML-EXIT.
012200*
012300****************************************************************
012400*    GETMAIN FOR LOG/JOURNAL RECORD                            *
012500****************************************************************
012600*
012700     MOVE 'SC02'                 TO MBCA-PROGRAM-LOCATION.
012800     SET MBIORO-GETMAIN          TO TRUE.
012900     PERFORM MML1AO-ACCESS       THRU MML1AO-ACCESS-EXIT.
013000*
013100****************************************************************
013200*    READ RANDOM THE MONETARY TRANSACTION RECORD               *
013300****************************************************************
013400*
013500     MOVE 'FC01'                 TO MBCA-PROGRAM-LOCATION.
013600     MOVE MBCA-MERCHANT-ORG      TO MBIOWS-MMT1-ORG.
013700     MOVE MBCA-MERCHANT          TO MBIOWS-MMT1-MERCHANT.
013800     MOVE MBCA-MBMA-FIRST-SEQ-NBR
013900                                 TO MBIOWS-MMT1-SEQ-NBR.
014000     SET MBIORO-READ-RANDOM      TO TRUE.
014100     PERFORM MMT1AO-ACCESS       THRU MMT1AO-ACCESS-EXIT.
014200*
014300     IF  MMT1-VDI-DEPOSIT-DATA
014400         MOVE SS08WS-CURSOR      TO MA03-AR-ORG-L
014500         MOVE MMT1-AR-ORG        TO MA03-AR-ORG
014600         MOVE MMT1-AR-ACCT       TO MA03-AR-ACCT
014700         MOVE MMT1-AR-TRANS-CODE TO WS-TRANS-CODE
014800         MOVE WS-TRANS-CODE      TO MA03-AR-TRANS-CODE
014900         MOVE MMT1-AR-AUTH-CODE  TO MA03-AR-AUTH-CODE
015000         MOVE DFHBMDAS           TO MA03-FACTOR-NBR-LP-A
015100                                    MA03-FACTOR-NBR-RP-A
015200                                    MA03-FACTOR-NBR-A
015300                                    MA03-FACTOR-AMT-LP-A
015400                                    MA03-FACTOR-AMT-RP-A
015500                                    MA03-FACTOR-AMT-A
015600                                    MA03-INC-PER-ITEM-LP-A
015700                                    MA03-INC-PER-ITEM-RP-A
015800                                    MA03-INC-PER-ITEM-A
015900                                    MA03-INC-RATE-LP-A
016000                                    MA03-INC-RATE-RP-A
016100                                    MA03-INC-RATE-A
016200                                    MA03-EXP-PER-ITEM-LP-A
016300                                    MA03-EXP-PER-ITEM-RP-A
016400                                    MA03-EXP-PER-ITEM-A
016500                                    MA03-EXP-RATE-LP-A
016600                                    MA03-EXP-RATE-RP-A
016700                                    MA03-EXP-RATE-A
016800                                    MA03-EXP-AMOUNT-LP-A
016900                                    MA03-EXP-AMOUNT-RP-A
017000                                    MA03-EXP-AMOUNT-A
017100                                    MA03-HEADING-1-LIT-A
017200                                    MA03-HEADING-2-LIT-A
017300                                    MA03-HEADING-3-LIT-A
017400                                    MA03-HEADING-4-LIT-A.
017500*
017600     IF  MMT1-VDI-FEE-DATA
017700         MOVE SS08WS-CURSOR      TO MA03-FACTOR-NBR-L
017800         MOVE MMT1-FEE-FACTOR-NBR
017900                                 TO MA03-FACTOR-NBR
018000         MOVE MMT1-FEE-FACTOR-AMT
018100                                 TO MA03-FACTOR-AMT
018200         MOVE MMT1-FEE-INC-PER-ITEM
018300                                 TO MA03-INC-PER-ITEM
018400         MOVE MMT1-FEE-INC-RATE  TO MA03-INC-RATE
018500         MOVE MMT1-FEE-EXP-PER-ITEM
018600                                 TO MA03-EXP-PER-ITEM
018700         MOVE MMT1-FEE-EXP-AMOUNT
018800                                 TO MA03-EXP-AMOUNT
018900         MOVE MMT1-FEE-EXP-RATE  TO MA03-EXP-RATE
019000         MOVE MMT1-AR-ORG        TO MA03-AR-ORG
019100         MOVE MMT1-AR-ACCT       TO MA03-AR-ACCT
019200         MOVE MMT1-AR-TRANS-CODE TO WS-TRANS-CODE
019300         MOVE WS-TRANS-CODE      TO MA03-AR-TRANS-CODE
019400         MOVE DFHBMDAS           TO MA03-AR-AUTH-CODE-LIT-A
019500                                    MA03-AR-AUTH-CODE-LP-A
019600                                    MA03-AR-AUTH-CODE-RP-A
019700                                    MA03-AR-AUTH-CODE-A.
019800*
019900 1010-CONTINUE.
020000*
020100     MOVE DFHBMASK               TO MA03-CURRENT-PAGE-A.
020200*
020300****************************************************************
020400*    IF  INQUIRY, DARKEN PARENS AND ASKIP FIELDS               *
020500****************************************************************
020600*
020700     IF  MBCA-PTI-FUNCTION-IS-INQUIRY
020800         MOVE SS08WS-CURSOR      TO MA03-ALT-TRANID-L
020900         PERFORM 7700-SET-ATTRIBUTES
021000                                 THRU 7799-SA-EXIT.
021100*
021200****************************************************************
021300*    FORMAT THE MESSSAGE LINE                                  *
021400****************************************************************
021500*
021600     IF MA03-ERR-MESSAGE EQUAL TO SPACES OR LOW-VALUES
021700        PERFORM MB06PD-FORMAT-MESSAGE-LINE
021800            THRU MB06PD-FML-EXIT
021900        MOVE SS08WS-FORMATTED-MSG TO MA03-ERR-MESSAGE.
022000*
022100****************************************************************
022200*    SEND THE MAP                                              *
022300****************************************************************
022400*
022500     MOVE 'BM01'                 TO MBCA-PROGRAM-LOCATION.
022600     PERFORM MB60PD-SEND-MAP-WITH-ERASE
022700                                 THRU MB60PD-SMWE-EXIT.
022800*
022900****************************************************************
023000*    RETURN TO CICS                                            *
023100****************************************************************
023200*
023300     MOVE 'PC02'                 TO MBCA-PROGRAM-LOCATION.
023400     PERFORM MB70PD-RETURN-TRANS-ID
023500                                 THRU MB70PD-RTI-EXIT.
023600/
023700 2000-RECEIVE-SCREEN SECTION.
023800*
023900****************************************************************
024000*    THIS SECTION RECEIVES THE 01 SCREEN                       *
024100****************************************************************
024200*
024300****************************************************************
024400*    GETMAIN FOR LOG/JOURNAL RECORD                            *
024500****************************************************************
024600*
024700     MOVE 'SC03'                 TO MBCA-PROGRAM-LOCATION.
024800     SET MBIORO-GETMAIN          TO TRUE.
024900     PERFORM MML1AO-ACCESS       THRU MML1AO-ACCESS-EXIT.
025000*
025100****************************************************************
025200*    GETMAIN FOR MONETARY TRANSACTION RECORD                  *
025300****************************************************************
025400*
025500     MOVE 'SC04'                 TO MBCA-PROGRAM-LOCATION.
025600     SET MBIORO-GETMAIN          TO TRUE.
025700     PERFORM MMT1AO-ACCESS       THRU MMT1AO-ACCESS-EXIT.
025800*
025900     MOVE 'BM02'                 TO MBCA-PROGRAM-LOCATION.
026000     PERFORM MB60PD-RECEIVE-MAP  THRU MB60PD-RM-EXIT.
026100*
026200****************************************************************
026300*    CHECK FOR ANOTHER TRANSACTION ID ENTERED BY THE USER      *
026400****************************************************************
026500*
026600     MOVE 'PC03'                 TO MBCA-PROGRAM-LOCATION.
026700     PERFORM MB60PD-NEW-TRANS-ROUTINE
026800                                 THRU MB60PD-NTR-EXIT.
026900*
027000****************************************************************
027100*    BYPASS EDITS ON INQUIRY                                   *
027200****************************************************************
027300*
027400     IF  MBCA-PTI-FUNCTION-IS-INQUIRY
027500         GO TO 2600-SETUP-COMMAREA.
027600*
027700****************************************************************
027800*    READ RANDOM THE ORG CONTROL FILE                          *
027900****************************************************************
028000*
028100     MOVE 'FC02'                 TO MBCA-PROGRAM-LOCATION.
028200     MOVE MBCA-MERCHANT-ORG      TO MBIOWS-MMOC-ORG.
028300     SET MBIORO-READ-RANDOM      TO TRUE.
028400     PERFORM MMOCAO-ACCESS       THRU MMOCAO-ACCESS-EXIT.
028500*
028600****************************************************************
028700*    READ RANDOM THE MONETARY TRANSACTION RECORD               *
028800****************************************************************
028900*
029000     MOVE 'FC03'                 TO MBCA-PROGRAM-LOCATION.
029100     MOVE MBCA-MERCHANT-ORG      TO MBIOWS-MMT1-ORG.
029200     MOVE MBCA-MERCHANT          TO MBIOWS-MMT1-MERCHANT.
029300     MOVE MBCA-MBMA-FIRST-SEQ-NBR
029400                                 TO MBIOWS-MMT1-SEQ-NBR.
029500     SET MBIORO-READ-RANDOM      TO TRUE.
029600     PERFORM MMT1AO-ACCESS       THRU MMT1AO-ACCESS-EXIT.
029700*
029800****************************************************************
029900*    EDIT FIELDS                                               *
030000****************************************************************
030100*
030200     PERFORM 7900-EDIT-SCREEN    THRU 7999-ES-EXIT.
030300*
030400     IF  SS08WS-ERROR-SW-NO
030500         GO TO 2400-UPDATE-FILE.
030600*
030700 2300-SEND-MAP.
030800*
030900****************************************************************
031000*    SEND THE MAP                                              *
031100****************************************************************
031200*
031300     PERFORM MB60PD-INIT-STD-MAP-LINES
031400                                 THRU MB60PD-ISML-EXIT.
031500*
031600     IF MA03-ERR-MESSAGE EQUAL TO SPACES OR LOW-VALUES
031700          PERFORM MB06PD-FORMAT-MESSAGE-LINE
031800                THRU MB06PD-FML-EXIT
031900          MOVE SS08WS-FORMATTED-MSG TO MA03-ERR-MESSAGE.
032000*
032100*
032200     MOVE 'BM03'                 TO MBCA-PROGRAM-LOCATION.
032300     PERFORM MB60PD-SEND-MAP-DATA-ONLY
032400                                 THRU MB60PD-SMDO-EXIT.
032500*
032600****************************************************************
032700*    RETURN TO CICS                                            *
032800****************************************************************
032900*
033000     MOVE 'PC04'                 TO MBCA-PROGRAM-LOCATION.
033100     PERFORM MB70PD-RETURN-TRANS-ID
033200                                 THRU MB70PD-RTI-EXIT.
033300/
033400 2400-UPDATE-FILE.
033500*
033600     IF  WS-UPDATE-SW-NO
033700         GO TO 2600-SETUP-COMMAREA.
033800*
033900     PERFORM 9000-MAINT-RECORDS  THRU 9099-MR-EXIT.
034000*
034100 2600-SETUP-COMMAREA.
034200*
034300****************************************************************
034400*    SET UP COMMAREA FIELDS AND TRANSFER TO THE NEXT PROGRAM   *
034500****************************************************************
034600*
034700     MOVE MBCA-EIBAID            TO SS08WS-EIBAID.
034800*
034900     PERFORM MB60PD-EDIT-PAGE-NBR
035000                                 THRU MB60PD-EPN-EXIT.
035100*
035200     IF  SS08WS-VALID-PF-KEY
035300     OR  SS08WS-EIBAID-VALID-PF-KEY
035400         SET MBCA-INITIAL-SCREEN-NBR
035500                                 TO TRUE.
035600*
035700 2690-PF-KEY-BYPASS.
035800*
035900     MOVE 'PC05'                 TO MBCA-PROGRAM-LOCATION.
036000     PERFORM MB70PD-XCTL-TO-MBOXCTL
036100                                 THRU MB70PD-XTM-EXIT.
036200/
036300 7000-PERFORMED-ROUTINES-SECT SECTION.
036400*
036500 7500-CREATE-MAINT-RECORD.
036600*
036700     MOVE 'T1'                   TO MML1-FILE-CODE.
036800     MOVE ZEROES                 TO MML1-FIELD-CODE
036900                                    MML1-FIELD-OCCURRENCE
037000                                    MML1-FIELD-OCCURRENCE-2
037100                                    MML1-SOURCE-CODE.
037200     MOVE MMT1-ORG               TO MML1-MMT1-ORG.
037300     MOVE MMT1-MERCHANT          TO MML1-MMT1-MERCHANT.
037400     MOVE MMT1-SEQ-NBR           TO MML1-MMT1-SEQ-NBR.
037500     MOVE MBCA-SIGNON-NAME       TO MML1-SIGNON-NAME.
037600     MOVE MBCA-TERMINAL-ID       TO MML1-TERMINAL-ID.
037700     MOVE LENGTH OF MMT1-RECORD  TO MML1-VARIABLE-LENGTH.
037800     MOVE MMT1-RECORD            TO MML1-ADD-AREA.
037900*
038000****************************************************************
038100*    WRITE FOR THE LOG/JOURNAL FILE                            *
038200****************************************************************
038300*
038400     MOVE 'FC04'                 TO MBCA-PROGRAM-LOCATION.
038500     SET MBIORO-WRITE            TO TRUE.
038600     PERFORM MML1AO-ACCESS       THRU MML1AO-ACCESS-EXIT.
038700     MOVE SPACES                 TO MML1-VARIABLE-AREA.
038800*
038900 7599-CMR-EXIT.
039000     EXIT.
039100*
039200 7700-SET-ATTRIBUTES.
039300*
039400     IF  MMT1-VDI-DEPOSIT-DATA
039500         MOVE DFHBMDAS           TO MA03-FACTOR-NBR-LP-A
039600                                    MA03-FACTOR-NBR-RP-A
039700                                    MA03-FACTOR-NBR-A
039800                                    MA03-FACTOR-AMT-LP-A
039900                                    MA03-FACTOR-AMT-RP-A
040000                                    MA03-FACTOR-AMT-A
040100                                    MA03-INC-PER-ITEM-LP-A
040200                                    MA03-INC-PER-ITEM-RP-A
040300                                    MA03-INC-PER-ITEM-A
040400                                    MA03-INC-RATE-LP-A
040500                                    MA03-INC-RATE-RP-A
040600                                    MA03-INC-RATE-A
040700                                    MA03-EXP-PER-ITEM-LP-A
040800                                    MA03-EXP-PER-ITEM-RP-A
040900                                    MA03-EXP-PER-ITEM-A
041000                                    MA03-EXP-RATE-LP-A
041100                                    MA03-EXP-RATE-RP-A
041200                                    MA03-EXP-RATE-A
041300                                    MA03-EXP-AMOUNT-LP-A
041400                                    MA03-EXP-AMOUNT-RP-A
041500                                    MA03-EXP-AMOUNT-A
041600                                    MA03-HEADING-1-LIT-A
041700                                    MA03-HEADING-2-LIT-A
041800                                    MA03-HEADING-3-LIT-A
041900         MOVE DFHBMASB           TO MA03-AR-ORG-A
042000                                    MA03-AR-ACCT-A
042100                                    MA03-AR-TRANS-CODE-A
042200                                    MA03-AR-AUTH-CODE-A.
042300*
042400     IF  MMT1-VDI-FEE-DATA
042500         MOVE DFHBMDAS           TO MA03-AR-AUTH-CODE-LP-A
042600                                    MA03-AR-AUTH-CODE-RP-A
042700                                    MA03-AR-AUTH-CODE-A
042800                                    MA03-FACTOR-NBR-LP-A
042900                                    MA03-FACTOR-NBR-RP-A
043000                                    MA03-FACTOR-AMT-LP-A
043100                                    MA03-FACTOR-AMT-RP-A
043200                                    MA03-INC-PER-ITEM-LP-A
043300                                    MA03-INC-PER-ITEM-RP-A
043400                                    MA03-INC-RATE-LP-A
043500                                    MA03-INC-RATE-RP-A
043600                                    MA03-EXP-PER-ITEM-LP-A
043700                                    MA03-EXP-PER-ITEM-RP-A
043800                                    MA03-EXP-RATE-LP-A
043900                                    MA03-EXP-RATE-RP-A
044000                                    MA03-EXP-AMOUNT-LP-A
044100                                    MA03-EXP-AMOUNT-RP-A
044200                                    MA03-AR-ORG-LP-A
044300                                    MA03-AR-ORG-RP-A
044400                                    MA03-AR-ACCT-LP-A
044500                                    MA03-AR-ACCT-RP-A
044600                                    MA03-AR-TRANS-CODE-LP-A
044700                                    MA03-AR-TRANS-CODE-RP-A
044800         MOVE DFHBMASB           TO MA03-FACTOR-NBR-A
044900                                    MA03-FACTOR-AMT-A
045000                                    MA03-INC-PER-ITEM-A
045100                                    MA03-INC-RATE-A
045200                                    MA03-EXP-PER-ITEM-A
045300                                    MA03-EXP-RATE-A
045400                                    MA03-EXP-AMOUNT-A
045500                                    MA03-AR-ORG-A
045600                                    MA03-AR-ACCT-A
045700                                    MA03-AR-TRANS-CODE-A.
045800*
045900 7799-SA-EXIT.
046000     EXIT.
046100*
046200 7900-EDIT-SCREEN.
046300*
046400     IF  MMT1-VDI-DEPOSIT-DATA
046500         GO TO 7995-AR-ORG.
046600*
046700*            ***** FEE FACTOR NUMBER *****
046800*
046900     IF  MA03-FACTOR-NBR-L IS LESS THAN 1
047000         MOVE DFHBMUNF           TO MA03-FACTOR-NBR-A
047100         MOVE DFHBMASK           TO MA03-FACTOR-NBR-LP-A
047200                                    MA03-FACTOR-NBR-RP-A
047300         MOVE MMT1-FEE-FACTOR-NBR
047400                                 TO MA03-FACTOR-NBR
047500     ELSE
047600         IF  MA03-FACTOR-NBR NUMERIC
047700             MOVE DFHBMASF       TO MA03-FACTOR-NBR-A
047800             MOVE DFHBMDAS       TO MA03-FACTOR-NBR-LP-A
047900                                    MA03-FACTOR-NBR-RP-A
048000             SET WS-UPDATE-SW-YES
048100                                 TO TRUE
048200         ELSE
048300             MOVE DFHBMNBF       TO MA03-FACTOR-NBR-A
048400             MOVE DFHBMASB       TO MA03-FACTOR-NBR-LP-A
048500                                    MA03-FACTOR-NBR-RP-A
048600             MOVE SS08WS-CURSOR  TO MA03-FACTOR-NBR-L
048700             SET SS08WS-ERROR-SW-YES TO TRUE
048800             GO TO 7999-ES-EXIT.
048900*
049000*            ***** FEE INC RATE PER ITEM *****
049100*
049200     IF  MA03-INC-PER-ITEM-L IS LESS THAN 1
049300         MOVE DFHBMUNF           TO MA03-INC-PER-ITEM-A
049400         MOVE DFHBMASK           TO MA03-INC-PER-ITEM-LP-A
049500                                    MA03-INC-PER-ITEM-RP-A
049600         MOVE MMT1-FEE-INC-PER-ITEM
049700                                 TO MA03-INC-PER-ITEM
049800     ELSE
049900         IF  MA03-INC-PER-ITEM NUMERIC
050000             MOVE DFHBMASF       TO MA03-INC-PER-ITEM-A
050100             MOVE DFHBMDAS       TO MA03-INC-PER-ITEM-LP-A
050200                                    MA03-INC-PER-ITEM-RP-A
050300             SET WS-UPDATE-SW-YES
050400                                 TO TRUE
050500         ELSE
050600             MOVE DFHBMNBF       TO MA03-INC-PER-ITEM-A
050700             MOVE DFHBMASB       TO MA03-INC-PER-ITEM-LP-A
050800                                    MA03-INC-PER-ITEM-RP-A
050900             MOVE SS08WS-CURSOR  TO MA03-INC-PER-ITEM-L
051000             SET SS08WS-ERROR-SW-YES TO TRUE
051100             GO TO 7999-ES-EXIT.
051200*
051300*            ***** FEE EXP RATE PER ITEM *****
051400*
051500     IF  MA03-EXP-PER-ITEM-L IS LESS THAN 1
051600         MOVE DFHBMUNF           TO MA03-EXP-PER-ITEM-A
051700         MOVE DFHBMASK           TO MA03-EXP-PER-ITEM-LP-A
051800                                    MA03-EXP-PER-ITEM-RP-A
051900         MOVE MMT1-FEE-EXP-PER-ITEM
052000                                 TO MA03-EXP-PER-ITEM
052100     ELSE
052200         IF  MA03-EXP-PER-ITEM NUMERIC
052300             MOVE DFHBMASF       TO MA03-EXP-PER-ITEM-A
052400             MOVE DFHBMDAS       TO MA03-EXP-PER-ITEM-LP-A
052500                                    MA03-EXP-PER-ITEM-RP-A
052600             SET WS-UPDATE-SW-YES
052700                                 TO TRUE
052800         ELSE
052900             MOVE DFHBMNBF       TO MA03-EXP-PER-ITEM-A
053000             MOVE DFHBMASB       TO MA03-EXP-PER-ITEM-LP-A
053100                                    MA03-EXP-PER-ITEM-RP-A
053200             MOVE SS08WS-CURSOR  TO MA03-EXP-PER-ITEM-L
053300             SET SS08WS-ERROR-SW-YES TO TRUE
053400             GO TO 7999-ES-EXIT.
053500*
053600*            ***** FEE FACTOR AMOUNT *****
053700*
053800     IF  MA03-FACTOR-AMT-L IS LESS THAN 1
053900         MOVE DFHBMUNF           TO MA03-FACTOR-AMT-A
054000         MOVE DFHBMASK           TO MA03-FACTOR-AMT-LP-A
054100                                    MA03-FACTOR-AMT-RP-A
054200         MOVE MMT1-FEE-FACTOR-AMT
054300                                 TO MA03-FACTOR-AMT
054400     ELSE
054500         IF  MA03-FACTOR-AMT NUMERIC
054600             MOVE DFHBMASF       TO MA03-FACTOR-AMT-A
054700             MOVE DFHBMDAS       TO MA03-FACTOR-AMT-LP-A
054800                                    MA03-FACTOR-AMT-RP-A
054900             SET WS-UPDATE-SW-YES
055000                                 TO TRUE
055100         ELSE
055200             MOVE DFHBMNBF       TO MA03-FACTOR-AMT-A
055300             MOVE DFHBMASB       TO MA03-FACTOR-AMT-LP-A
055400                                    MA03-FACTOR-AMT-RP-A
055500             MOVE SS08WS-CURSOR  TO MA03-FACTOR-AMT-L
055600             SET SS08WS-ERROR-SW-YES TO TRUE
055700             GO TO 7999-ES-EXIT.
055800*
055900*            ***** FEE INC RATE *****
056000*
056100     IF  MA03-INC-RATE-L IS LESS THAN 1
056200         MOVE DFHBMUNF           TO MA03-INC-RATE-A
056300         MOVE DFHBMASK           TO MA03-INC-RATE-LP-A
056400                                    MA03-INC-RATE-RP-A
056500         MOVE MMT1-FEE-INC-RATE  TO MA03-INC-RATE
056600     ELSE
056700         IF  MA03-INC-RATE NUMERIC
056800             MOVE DFHBMASF       TO MA03-INC-RATE-A
056900             MOVE DFHBMDAS       TO MA03-INC-RATE-LP-A
057000                                    MA03-INC-RATE-RP-A
057100             SET WS-UPDATE-SW-YES
057200                                 TO TRUE
057300         ELSE
057400             MOVE DFHBMNBF       TO MA03-INC-RATE-A
057500             MOVE DFHBMASB       TO MA03-INC-RATE-LP-A
057600                                    MA03-INC-RATE-RP-A
057700             MOVE SS08WS-CURSOR  TO MA03-INC-RATE-L
057800             SET SS08WS-ERROR-SW-YES TO TRUE
057900             GO TO 7999-ES-EXIT.
058000*
058100*            ***** FEE EXP RATE *****
058200*
058300     IF  MA03-EXP-RATE-L IS LESS THAN 1
058400         MOVE DFHBMUNF           TO MA03-EXP-RATE-A
058500         MOVE DFHBMASK           TO MA03-EXP-RATE-LP-A
058600                                    MA03-EXP-RATE-RP-A
058700         MOVE MMT1-FEE-EXP-RATE  TO MA03-EXP-RATE
058800     ELSE
058900         IF  MA03-EXP-RATE NUMERIC
059000             MOVE DFHBMASF       TO MA03-EXP-RATE-A
059100             MOVE DFHBMDAS       TO MA03-EXP-RATE-LP-A
059200                                    MA03-EXP-RATE-RP-A
059300             SET WS-UPDATE-SW-YES
059400                                 TO TRUE
059500         ELSE
059600             MOVE DFHBMNBF       TO MA03-EXP-RATE-A
059700             MOVE DFHBMASB       TO MA03-EXP-RATE-LP-A
059800                                    MA03-EXP-RATE-RP-A
059900             MOVE SS08WS-CURSOR  TO MA03-EXP-RATE-L
060000             SET SS08WS-ERROR-SW-YES TO TRUE
060100             GO TO 7999-ES-EXIT.
060200*
060300*            ***** FEE EXP AMOUNT *****
060400*
060500     IF  MA03-EXP-AMOUNT-L IS LESS THAN 1
060600         MOVE DFHBMUNF           TO MA03-EXP-AMOUNT-A
060700         MOVE DFHBMASK           TO MA03-EXP-AMOUNT-LP-A
060800                                    MA03-EXP-AMOUNT-RP-A
060900         MOVE MMT1-FEE-EXP-AMOUNT
061000                                 TO MA03-EXP-AMOUNT
061100     ELSE
061200         IF  MA03-EXP-AMOUNT NUMERIC
061300             MOVE DFHBMASF       TO MA03-EXP-AMOUNT-A
061400             MOVE DFHBMDAS       TO MA03-EXP-AMOUNT-LP-A
061500                                    MA03-EXP-AMOUNT-RP-A
061600             SET WS-UPDATE-SW-YES
061700                                 TO TRUE
061800         ELSE
061900             MOVE DFHBMNBF       TO MA03-EXP-AMOUNT-A
062000             MOVE DFHBMASB       TO MA03-EXP-AMOUNT-LP-A
062100                                    MA03-EXP-AMOUNT-RP-A
062200             MOVE SS08WS-CURSOR  TO MA03-EXP-AMOUNT-L
062300             SET SS08WS-ERROR-SW-YES TO TRUE
062400             GO TO 7999-ES-EXIT.
062500*
062600 7995-AR-ORG.
062700*
062800*            ***** AR ORG *****
062900*
063000     IF  MA03-AR-ORG-L IS LESS THAN 1
063100         MOVE DFHBMUNF           TO MA03-AR-ORG-A
063200         MOVE DFHBMASK           TO MA03-AR-ORG-LP-A
063300                                    MA03-AR-ORG-RP-A
063400         MOVE MMT1-AR-ORG        TO MA03-AR-ORG
063500     ELSE
063600         IF  MA03-AR-ORG NUMERIC
063700             MOVE DFHBMASF       TO MA03-AR-ORG-A
063800             MOVE DFHBMDAS       TO MA03-AR-ORG-LP-A
063900                                    MA03-AR-ORG-RP-A
064000             SET WS-UPDATE-SW-YES
064100                                 TO TRUE
064200         ELSE
064300             MOVE DFHBMNBF       TO MA03-AR-ORG-A
064400             MOVE DFHBMASB       TO MA03-AR-ORG-LP-A
064500                                    MA03-AR-ORG-RP-A
064600             MOVE SS08WS-CURSOR  TO MA03-AR-ORG-L
064700             SET SS08WS-ERROR-SW-YES TO TRUE
064800             GO TO 7999-ES-EXIT.
064900*
065000*            ***** AR ACCOUNT *****
065100*
065200     IF  MA03-AR-ACCT-L IS LESS THAN 1
065300         MOVE DFHBMASK           TO MA03-AR-ACCT-A
065400         MOVE DFHBMDAS           TO MA03-AR-ACCT-LP-A
065500                                    MA03-AR-ACCT-RP-A
065600         MOVE MMT1-AR-ACCT       TO MA03-AR-ACCT
065700     ELSE
065800         MOVE DFHBMASF           TO MA03-AR-ACCT-A
065900         MOVE DFHBMDAS           TO MA03-AR-ACCT-LP-A
066000                                    MA03-AR-ACCT-RP-A
066100         SET WS-UPDATE-SW-YES    TO TRUE.
066200*
066300*            ***** AR TRANS CODE *****
066400*
066500     IF  MA03-AR-TRANS-CODE-L IS LESS THAN 1
066600         MOVE DFHBMUNF           TO MA03-AR-TRANS-CODE-A
066700         MOVE DFHBMASK           TO MA03-AR-TRANS-CODE-LP-A
066800                                    MA03-AR-TRANS-CODE-RP-A
066900         MOVE MMT1-AR-TRANS-CODE TO MA03-AR-TRANS-CODE
067000     ELSE
067100         IF  MA03-AR-TRANS-CODE NUMERIC
067200             MOVE DFHBMASF       TO MA03-AR-TRANS-CODE-A
067300             MOVE DFHBMDAS       TO MA03-AR-TRANS-CODE-LP-A
067400                                    MA03-AR-TRANS-CODE-RP-A
067500             SET WS-UPDATE-SW-YES
067600                                 TO TRUE
067700         ELSE
067800             MOVE DFHBMNBF       TO MA03-AR-TRANS-CODE-A
067900             MOVE DFHBMASB       TO MA03-AR-TRANS-CODE-LP-A
068000                                    MA03-AR-TRANS-CODE-RP-A
068100             MOVE SS08WS-CURSOR  TO MA03-AR-TRANS-CODE-L
068200             SET SS08WS-ERROR-SW-YES TO TRUE
068300             GO TO 7999-ES-EXIT.
068400*
068500     IF  MMT1-VDI-FEE-DATA
068600         GO TO 7999-ES-EXIT.
068700*
068800*            ***** AR AUTH CODE *****
068900*
069000     IF  MA03-AR-AUTH-CODE-L IS LESS THAN 1
069100         MOVE DFHBMASK           TO MA03-AR-AUTH-CODE-A
069200         MOVE DFHBMDAS           TO MA03-AR-AUTH-CODE-LP-A
069300                                    MA03-AR-AUTH-CODE-RP-A
069400         MOVE MMT1-AR-AUTH-CODE  TO MA03-AR-AUTH-CODE
069500     ELSE
069600         MOVE DFHBMASF           TO MA03-AR-AUTH-CODE-A
069700         MOVE DFHBMDAS           TO MA03-AR-AUTH-CODE-LP-A
069800                                    MA03-AR-AUTH-CODE-RP-A
069900         SET WS-UPDATE-SW-YES    TO TRUE.
070000*
070100*******************************************************
070200*
070300 7999-ES-EXIT.
070400     EXIT.
070500*
070600*
070700 8900-CREATE-MAINT-RECORD.
070800*
070900     MOVE 'T1'                   TO MML1-FILE-CODE.
071000     MOVE ZEROES                 TO MML1-FIELD-CODE
071100                                    MML1-FIELD-OCCURRENCE
071200                                    MML1-FIELD-OCCURRENCE-2
071300                                    MML1-SOURCE-CODE.
071400     MOVE MMT1-ORG               TO MML1-MMT1-ORG.
071500     MOVE MMT1-MERCHANT          TO MML1-MMT1-MERCHANT.
071600     MOVE MMT1-SEQ-NBR           TO MML1-MMT1-SEQ-NBR.
071700     MOVE MBCA-SIGNON-NAME       TO MML1-SIGNON-NAME.
071800     MOVE MBCA-TERMINAL-ID       TO MML1-TERMINAL-ID.
071900     MOVE LENGTH OF MMT1-RECORD  TO MML1-VARIABLE-LENGTH.
072000     MOVE MMT1-RECORD            TO MML1-ADD-AREA.
072100*
072200****************************************************************
072300*    WRITE FOR THE LOG/JOURNAL FILE                            *
072400****************************************************************
072500*
072600     MOVE 'FC05'                 TO MBCA-PROGRAM-LOCATION.
072700     SET MBIORO-WRITE            TO TRUE.
072800     PERFORM MML1AO-ACCESS       THRU MML1AO-ACCESS-EXIT.
072900     MOVE SPACES                 TO MML1-VARIABLE-AREA.
073000*
073100 8999-CMR-EXIT.
073200     EXIT.
073300*
073400 9000-MAINT-RECORDS.
073500*
073600     IF  MA03-FACTOR-NBR-L IS EQUAL TO ZERO
073700     AND MA03-FACTOR-AMT-L IS EQUAL TO ZERO
073800     AND MA03-INC-PER-ITEM-L IS EQUAL TO ZERO
073900     AND MA03-EXP-PER-ITEM-L IS EQUAL TO ZERO
074000     AND MA03-INC-RATE-L IS EQUAL TO ZERO
074100     AND MA03-EXP-RATE-L IS EQUAL TO ZERO
074200     AND MA03-EXP-AMOUNT-L IS EQUAL TO ZERO
074300     AND MA03-AR-ORG-L IS EQUAL TO ZERO
074400     AND MA03-AR-ACCT-L IS EQUAL TO ZERO
074500     AND MA03-AR-TRANS-CODE-L IS EQUAL TO ZERO
074600     AND MA03-AR-AUTH-CODE-L IS EQUAL TO ZERO
074700         GO TO 9099-MR-EXIT.
074800*
074900     MOVE MBCA-MERCHANT-ORG      TO MBIOWS-MMT1-ORG.
075000     MOVE MBCA-MERCHANT          TO MBIOWS-MMT1-MERCHANT.
075100     MOVE MBCA-MBMA-FIRST-SEQ-NBR
075200                                 TO MBIOWS-MMT1-SEQ-NBR.
075300*
075400****************************************************************
075500*    READ THE TRANSACTION RECORD FOR UPDATE                    *
075600****************************************************************
075700*
075800     MOVE 'FC06'                 TO MBCA-PROGRAM-LOCATION.
075900     SET MBIORO-READ-RANDOM-UPDATE
076000                                 TO TRUE.
076100     PERFORM MMT1AO-ACCESS       THRU MMT1AO-ACCESS-EXIT.
076200*
076300*        ***** FEE FACTOR NBR *****
076400*
076500     IF  MA03-FACTOR-NBR-L IS GREATER THAN ZERO
076600         MOVE MA03-FACTOR-NBR    TO MMT1-FEE-FACTOR-NBR.
076700*
076800*        ***** FEE FACTOR AMT *****
076900*
077000     IF  MA03-FACTOR-AMT-L IS GREATER THAN ZERO
077100         MOVE MA03-FACTOR-AMT    TO MMT1-FEE-FACTOR-AMT.
077200*
077300*        ***** FEE INC PER ITEM *****
077400*
077500     IF  MA03-INC-PER-ITEM-L IS GREATER THAN ZERO
077600         MOVE MA03-INC-PER-ITEM  TO MMT1-FEE-INC-PER-ITEM.
077700*
077800*        ***** FEE INC RATE *****
077900*
078000     IF  MA03-INC-RATE-L IS GREATER THAN ZERO
078100         MOVE MA03-INC-RATE      TO MMT1-FEE-INC-RATE.
078200*
078300*        ***** FEE EXP PER ITEM *****
078400*
078500     IF  MA03-EXP-PER-ITEM-L IS GREATER THAN ZERO
078600         MOVE MA03-EXP-PER-ITEM  TO MMT1-FEE-EXP-PER-ITEM.
078700*
078800*        ***** FEE EXP RATE *****
078900*
079000     IF  MA03-EXP-RATE-L IS GREATER THAN ZERO
079100         MOVE MA03-EXP-RATE      TO MMT1-FEE-EXP-RATE.
079200*
079300*        ***** FEE EXP RATE *****
079400*
079500     IF  MA03-EXP-AMOUNT-L IS GREATER THAN ZERO
079600         MOVE MA03-EXP-AMOUNT    TO MMT1-FEE-EXP-AMOUNT.
079700*
079800 9005-AR-ORG.
079900*
080000*        ***** AR ORG *****
080100*
080200     IF  MA03-AR-ORG-L IS GREATER THAN ZERO
080300         MOVE MA03-AR-ORG        TO MMT1-AR-ORG.
080400*
080500*        ***** AR ACCT *****
080600*
080700     IF  MA03-AR-ACCT-L IS GREATER THAN ZERO
080800         MOVE MA03-AR-ACCT       TO MMT1-AR-ACCT.
080900*
081000*        ***** AR TRANS CODE *****
081100*
081200     IF  MA03-AR-TRANS-CODE-L IS GREATER THAN ZERO
081300         MOVE MA03-AR-TRANS-CODE TO MMT1-AR-TRANS-CODE.
081400*
081500*        ***** AR AUTH CODE ****
081600*
081700     IF  MA03-AR-AUTH-CODE-L IS GREATER THAN ZERO
081800         MOVE MA03-AR-AUTH-CODE  TO MMT1-AR-AUTH-CODE.
081900*
082000*
082100     IF  MA03-FACTOR-NBR-L IS GREATER THAN ZERO
082200     OR  MA03-FACTOR-AMT-L IS GREATER THAN ZERO
082300     OR  MA03-INC-PER-ITEM-L IS GREATER THAN ZERO
082400     OR  MA03-EXP-PER-ITEM-L IS GREATER THAN ZERO
082500     OR  MA03-INC-RATE-L IS GREATER THAN ZERO
082600     OR  MA03-EXP-RATE-L IS GREATER THAN ZERO
082700     OR  MA03-EXP-AMOUNT-L IS GREATER THAN ZERO
082800     OR  MA03-AR-ORG-L IS GREATER THAN ZERO
082900     OR  MA03-AR-ACCT-L IS GREATER THAN ZERO
083000     OR  MA03-AR-TRANS-CODE-L IS GREATER THAN ZERO
083100     OR  MA03-AR-AUTH-CODE-L IS GREATER THAN ZERO
083200         MOVE MBCA-OPERATOR-ID   TO MMT1-LAST-OPERATOR
083300         PERFORM 8900-CREATE-MAINT-RECORD
083400                                 THRU 8999-CMR-EXIT.
083500*
083600****************************************************************
083700*    REWRITE THE TRANSACTION RECORD                            *
083800****************************************************************
083900*
084000     MOVE 'FC07'                 TO MBCA-PROGRAM-LOCATION.
084100     SET MBIORO-REWRITE          TO TRUE.
084200     PERFORM MMT1AO-ACCESS       THRU MMT1AO-ACCESS-EXIT.
084300*
084400 9099-MR-EXIT.
084500     EXIT.
084600*
084700/         DATE VALIDATION ROUTINE
084800     COPY SS05PD.
084900/         GREGORIAN TO JULIAN DATE ROUTINE
085000     COPY SS07PD.
085100/         JULIAN TO GREGORIAN DATE ROUTINE
085200     COPY SS08PD.
085300/         DATE AND TIME EDIT ROUTINES
085400     COPY SS26PD.
085500     COPY SS27PD.
085600/         LINE 24 PF KEYS ROUTINE
085700     COPY SS15PD.
085800/         LOG/JOURNAL RECORD ACCESS ROUTINES
085900     COPY MML1AO.
086000/         MERCHANT TRANSACTION RECORD ACCESS ROUTINES
086100     COPY MMT1AO.
086200/         TRANSACTION RECORD ACCESS ROUTINES
086300     COPY MMTCAO.
086400/         ORG CONTROL RECORD ACCESS ROUTINES
086500     COPY MMOCAO.
086600/         ON-LINE MAP ROUTINES
086700     COPY MB60PD REPLACING 'MBMAPXX' BY 'MBMA03 '
086800                           MBMAPXXI BY MBMA03I
086900                           MBMAPXXO BY MBMA03O.
087000/         MESSAGE FORMAT ROUTINE.
087100     COPY MB06PD.
087200/         ON-LINE PROCEDURES
087300     COPY MB70PD.
087400/
087500     COPY SMFTPXO.
