000100 IDENTIFICATION DIVISION.
000200 PROGRAM-ID. MBOMB01.
000201*       RELEASE DATE=08/24/01.        REVISION LEVEL=08.06      *
000202*****************************************************************
000203*WARNING.  THIS COMPUTER PROGRAM IS PROTECTED BY COPYRIGHT LAW  *
000204*AND INTERNATIONAL TREATIES.  UNAUTHORIZED REPRODUCTION OR      *
000205*DISTRIBUTION OF THIS PROGRAM, OR ANY PORTION OF IT, MAY RESULT *
000206*IN SEVERE CIVIL AND CRIMINAL PENATLIES, AND WILL BE PROSECUTED *
000207*TO THE MAXIMUM EXTENT POSSIBLE UNDER THE LAW.                  *
000208*COPYRIGHT 1999 PAYSYS INTERNATIONAL, INC.  ALL RIGHTS RESERVED.*
000209*****************************************************************
000300*****************************************************************
000400*                                                               *
000500*   V - PLUS  M E R C H A N T   B A N K C A R D   S Y S T E M   *
000600*                                                               *
000700*      MBOMB01 - ON-LINE BAR CODE ADD/MAINTENANCE/INQUIRY       *
000800*                SCREEN 01                                      *
000900*                                                               *
001000*              1. TRANSIDS                                      *
001100*                 A. MBAB                                       *
001200*                 B. MBMB                                       *
001300*                 C. MBQB                                       *
001400*              2. MAPS USED -                                   *
001500*                 A. MBMB01 (BAR CODE MAP 01)                   *
001600*              3. FILES USED -                                  *
001700*                 A. MMBC   (BAR CODE FILE)                     *
001800*                 B. MML1   (LOG/JOURNAL FILE)                  *
001900*                                                               *
002000*****************************************************************
002100* ************************************************************ *
002200*
002300 ENVIRONMENT DIVISION.
002400 DATA DIVISION.
002500*
002600 WORKING-STORAGE SECTION.
002700 01  FILLER                  PIC  X(12)      VALUE '** WS-BEG **'.
002800*         I/O REQUEST BLOCK WORK AREAS
002900     COPY MBIOWS.
003000/         I/O REQUEST BLOCK
003100     COPY MBIORO.
003200/         LOG/JOURNAL WORK AREAS
003300     COPY MML1WS REPLACING ==:MML1:== BY ==MML1==.
003400/         DATE WORK AREAS
003500     COPY SS01WS.
003600/         ONLINE WORK AREAS
003700     COPY SS08WS.
003800/
003900     COPY SS00WS.
004000/
004100     COPY SMFTWS.
004200/
004300     COPY SMPTRL REPLACING ==:SMPT:== BY ==SMPT==.
004400/
004500     COPY MB61LK.
004600/
004700 01  WS-WORKING-FIELDS.
004800*
004900     03  SS08WS-ERROR-SWITCH PIC  X(01)      VALUE 'N'.
005000     03  WS-UPDATE-SWITCH    PIC  X(01)      VALUE 'N'.
005100         88  WS-UPDATE-SW-YES                VALUE 'Y'.
005200         88  WS-UPDATE-SW-NO                 VALUE 'N'.
005300     03  WS-BEG-DATE         PIC S9(07)      VALUE ZEROS.
005400     03  WS-END-DATE         PIC S9(07)      VALUE ZEROS.
005500*
005600*
005700     03  WS-BC-MATRIX        PIC  X(27).
005800     03  WS-BC-MATRIX-X      REDEFINES WS-BC-MATRIX.
005900         05  WS-BLOCK-CODE   PIC  X(01)      OCCURS 27 TIMES
006000                                             INDEXED BY
006100                                             X-BC-MATRIX.
006200/
006300 LINKAGE SECTION.
006400 01  DFHCOMMAREA.
006500     COPY MB60WS.
006600/
006700/         ORG SCREEN 01 MAP DSECT
006800     COPY MBMB01.
006900/         ORG SCREEN 01 MAP REDEFINITION
007000     COPY MBMB01R.
007100/         BAR CODE FILE RECORD LAYOUT
007200     COPY MMBCRL.
007300/         LOG/JOURNAL FILE RECORD LAYOUT
007400     COPY MML1RL REPLACING ==:MML1:== BY ==MML1==.
007500/
007600 PROCEDURE DIVISION.
007700 0000-START-SECT SECTION.
007800*
007900     MOVE 'PC01'                 TO MBCA-PROGRAM-LOCATION.
008000     PERFORM MB70PD-ON-LINE-HOUSEKEEPING
008100                                 THRU MB70PD-OLH-EXIT.
008200*
008300     IF  MBCA-RECEIVE-SCREEN
008400         GO TO 2000-RECEIVE-SCREEN.
008500*
008600/
008700 1000-SEND-SCREEN SECTION.
008800*
008900****************************************************************
009000*    THIS SECTION BUILDS AND SENDS THE 01 SCREEN.              *
009100****************************************************************
009200*
009300****************************************************************
009400*    GET CICS STORAGE NEEDED FOR THE MAP                       *
009500****************************************************************
009600*
009700     MOVE 'SC01'                 TO MBCA-PROGRAM-LOCATION.
009800     PERFORM MB60PD-GETMAIN-FOR-MAP
009900                                 THRU MB60PD-GFM-EXIT.
010000*
010100     MOVE MBCA-MERCHANT-ORG      TO MB01-ORG.
010200     MOVE MBCA-INSERT-NBR        TO MB01-INSERT-NBR.
010300     MOVE 01                     TO MBCA-SCREEN-NBR.
010400*
010500****************************************************************
010600*    INITIALIZE THE STANDARD MAP LINES                         *
010700****************************************************************
010800*
010900     PERFORM MB60PD-INIT-STD-MAP-LINES
011000                                 THRU MB60PD-ISML-EXIT.
011100*
011200****************************************************************
011300*    READ THE BAR CODE FILE RECORD NUMBER                      *
011400****************************************************************
011500*
011600     MOVE 'FC01'                 TO MBCA-PROGRAM-LOCATION.
011700     MOVE MBCA-MERCHANT-ORG      TO MBIOWS-MMBC-ORG.
011800     MOVE MBCA-INSERT-NBR        TO MBIOWS-MMBC-INSERT-NBR.
011900     SET MBIORO-READ-RANDOM      TO TRUE.
012000     PERFORM MMBCAO-ACCESS       THRU MMBCAO-ACCESS-EXIT.
012100/
012200 1100-BUILD-SCREEN.
012300* ************************************************************ *
012400*            BUILD THE MAP FROM THE BAR CODE RECORD            *
012500* ************************************************************ *
012600*
012700     MOVE MMBC-REC-STATUS        TO MB01-STATUS.
012800     MOVE MMBC-LAST-MAINT-DATE   TO SS01WS-JULIAN.
012900     PERFORM SS26PD-NUMERICALLY-EDIT-DATE
013000        THRU SS26PD-NED-EXIT.
013100     MOVE SS01WS-XX-XX-YYYY      TO MB01-LAST-MAINT-DATE.
013200     MOVE MMBC-LAST-MAINT-OPER   TO MB01-LAST-MAINT-OPER.
013300     MOVE MMBC-DATE-OPENED-USE   TO MB01-DTE-OPEN-USE.
013400     MOVE MMBC-DATE-OPENED-IND   TO MB01-DTE-OPEN-IND.
013500     MOVE MMBC-DATE-OPENED-BEG
013600                                 TO SS01WS-JULIAN.
013700     PERFORM SS08PD-JUL-TO-GREG  THRU SS08PD-JTG-EXIT.
013800     MOVE SS01WS-DATE            TO MB01-DTE-OPEN-BEG.
013900     MOVE MMBC-DATE-OPENED-END
014000                                 TO SS01WS-JULIAN.
014100     PERFORM SS08PD-JUL-TO-GREG  THRU SS08PD-JTG-EXIT.
014200     MOVE SS01WS-DATE            TO MB01-DTE-OPEN-END.
014300     MOVE MMBC-DATE-LAST-ACTIVE-USE
014400                                 TO MB01-DTE-LAST-USE.
014500     MOVE MMBC-DATE-LAST-ACTIVE-IND
014600                                 TO MB01-DTE-LAST-IND.
014700     MOVE MMBC-DATE-LAST-ACTIVE-BEG
014800                                 TO SS01WS-JULIAN.
014900     PERFORM SS08PD-JUL-TO-GREG  THRU SS08PD-JTG-EXIT.
015000     MOVE SS01WS-DATE            TO MB01-DTE-LAST-BEG.
015100     MOVE MMBC-DATE-LAST-ACTIVE-END
015200                                 TO SS01WS-JULIAN.
015300     PERFORM SS08PD-JUL-TO-GREG  THRU SS08PD-JTG-EXIT.
015400     MOVE SS01WS-DATE            TO MB01-DTE-LAST-END.
015500     MOVE MMBC-BLOCK-CODE-USE    TO MB01-BLK-CODE-USE.
015600     MOVE MMBC-BLOCK-CODE-IND    TO MB01-BLK-CODE-IND.
015700     MOVE MMBC-STMT-CYCLE-USE    TO MB01-STMT-CYC-USE.
015800     MOVE MMBC-STMT-CYCLE-IND    TO MB01-STMT-CYC-IND.
015900     MOVE MMBC-STMT-MSG-FLAG-USE TO MB01-STMT-MSG-USE.
016000     MOVE MMBC-STMT-MSG-FLAG-IND TO MB01-STMT-MSG-IND.
016100*
016200***************************************************************
016300*    MOVE BLOCK CODE DATA                                     *
016400***************************************************************
016500*
016600     PERFORM
016700         VARYING X-MMBC-BLOCK-CODE
016800         FROM 1 BY 1
016900         UNTIL  X-MMBC-BLOCK-CODE IS GREATER THAN 18
017000         SET X-BLK-CODE          TO X-MMBC-BLOCK-CODE
017100         MOVE MMBC-BLOCK-CODE (X-MMBC-BLOCK-CODE)
017200                                 TO
017300                                 MB01-BLK-CODE-DATA (X-BLK-CODE)
017400     END-PERFORM.
017500*
017600***************************************************************
017700*    MOVE STATEMENT CYCLE DATE                                *
017800***************************************************************
017900*
018000     PERFORM
018100         VARYING X-MMBC-STMT-CYCLE
018200         FROM 1 BY 1
018300         UNTIL  X-MMBC-STMT-CYCLE IS GREATER THAN 18
018400         SET X-STMT-CYC          TO X-MMBC-STMT-CYCLE
018500         MOVE MMBC-STMT-CYCLE (X-MMBC-STMT-CYCLE)
018600                                 TO
018700                                 MB01-STMT-CYC-DATA (X-STMT-CYC)
018800     END-PERFORM.
018900*
019000***************************************************************
019100*    MOVE STATEMENT MESSAGE DATA                              *
019200***************************************************************
019300*
019400     PERFORM
019500         VARYING X-MMBC-STMT-MSG-FLAG
019600         FROM 1 BY 1
019700         UNTIL  X-MMBC-STMT-MSG-FLAG IS GREATER THAN 5
019800         SET X-STMT-MSG          TO X-MMBC-STMT-MSG-FLAG
019900         MOVE MMBC-STMT-MSG-FLAG (X-MMBC-STMT-MSG-FLAG)
020000                                 TO
020100                                 MB01-STMT-MSG-DATA (X-STMT-MSG)
020200     END-PERFORM.
020300*
020400/
020500****************************************************************
020600*    IF INQUIRY, DARKEN PARENS AND ASKIP FIELDS                *
020700****************************************************************
020800*
020900     MOVE SS08WS-CURSOR          TO MB01-DTE-OPEN-USE-L.
021000*
021100     MOVE DFHBMDAS               TO MB01-STATUS-LP-A
021200                                    MB01-STATUS-RP-A.
021300     MOVE DFHBMASB               TO MB01-STATUS-A.
021400*
021500     IF  MBCA-PTI-FUNCTION-IS-INQUIRY
021600         MOVE SS08WS-CURSOR      TO MB01-ALT-TRANID-L
021700         MOVE DFHBMASB           TO MB01-STATUS-A
021800                                    MB01-DTE-OPEN-USE-A
021900                                    MB01-DTE-OPEN-IND-A
022000                                    MB01-DTE-OPEN-BEG-A
022100                                    MB01-DTE-OPEN-END-A
022200                                    MB01-DTE-LAST-USE-A
022300                                    MB01-DTE-LAST-IND-A
022400                                    MB01-DTE-LAST-BEG-A
022500                                    MB01-DTE-LAST-END-A
022600                                    MB01-DTE-LAST-USE-A
022700                                    MB01-DTE-LAST-IND-A
022800                                    MB01-BLK-CODE-USE-A
022900                                    MB01-BLK-CODE-IND-A
023000                                    MB01-STMT-CYC-USE-A
023100                                    MB01-STMT-CYC-IND-A
023200                                    MB01-STMT-MSG-USE-A
023300                                    MB01-STMT-MSG-IND-A
023400         MOVE DFHBMDAS           TO MB01-STATUS-LP-A
023500                                    MB01-STATUS-RP-A
023600                                    MB01-DTE-OPEN-USE-LP-A
023700                                    MB01-DTE-OPEN-USE-RP-A
023800                                    MB01-DTE-OPEN-IND-LP-A
023900                                    MB01-DTE-OPEN-IND-RP-A
024000                                    MB01-DTE-OPEN-BEG-LP-A
024100                                    MB01-DTE-OPEN-BEG-RP-A
024200                                    MB01-DTE-OPEN-END-LP-A
024300                                    MB01-DTE-OPEN-END-RP-A
024400                                    MB01-DTE-LAST-USE-LP-A
024500                                    MB01-DTE-LAST-USE-RP-A
024600                                    MB01-DTE-LAST-IND-LP-A
024700                                    MB01-DTE-LAST-IND-RP-A
024800                                    MB01-DTE-LAST-BEG-LP-A
024900                                    MB01-DTE-LAST-BEG-RP-A
025000                                    MB01-DTE-LAST-END-LP-A
025100                                    MB01-DTE-LAST-END-RP-A
025200                                    MB01-DTE-LAST-USE-LP-A
025300                                    MB01-DTE-LAST-USE-RP-A
025400                                    MB01-DTE-LAST-IND-LP-A
025500                                    MB01-DTE-LAST-IND-RP-A
025600                                    MB01-BLK-CODE-USE-LP-A
025700                                    MB01-BLK-CODE-USE-RP-A
025800                                    MB01-BLK-CODE-IND-LP-A
025900                                    MB01-BLK-CODE-IND-RP-A
026000                                    MB01-STMT-CYC-USE-LP-A
026100                                    MB01-STMT-CYC-USE-RP-A
026200                                    MB01-STMT-CYC-IND-LP-A
026300                                    MB01-STMT-CYC-IND-RP-A
026400                                    MB01-STMT-MSG-USE-LP-A
026500                                    MB01-STMT-MSG-USE-RP-A
026600                                    MB01-STMT-MSG-IND-LP-A
026700                                    MB01-STMT-MSG-IND-RP-A
026800         PERFORM
026900             VARYING X-BLK-CODE
027000             FROM 1 BY 1
027100             UNTIL  X-BLK-CODE IS GREATER THAN 18
027200             MOVE DFHBMASB       TO
027300                                 MB01-BLK-CODE-DATA-A
027400                                 (X-BLK-CODE)
027500             MOVE DFHBMDAS       TO
027600                                 MB01-BLK-CODE-DATA-LP-A
027700                                 (X-BLK-CODE)
027800                                 MB01-BLK-CODE-DATA-RP-A
027900                                 (X-BLK-CODE)
028000         END-PERFORM
028100*
028200         PERFORM
028300             VARYING X-STMT-CYC
028400             FROM 1 BY 1
028500             UNTIL  X-STMT-CYC   IS GREATER THAN 18
028600             MOVE DFHBMASB       TO
028700                                 MB01-STMT-CYC-DATA-A
028800                                 (X-STMT-CYC)
028900             MOVE DFHBMDAS       TO
029000                                 MB01-STMT-CYC-DATA-LP-A
029100                                 (X-STMT-CYC)
029200                                 MB01-STMT-CYC-DATA-RP-A
029300                                 (X-STMT-CYC)
029400         END-PERFORM
029500*
029600*
029700         PERFORM
029800             VARYING X-STMT-MSG
029900             FROM 1 BY 1
030000             UNTIL  X-STMT-MSG   IS GREATER THAN 5
030100             MOVE DFHBMASB       TO
030200                                 MB01-STMT-MSG-DATA-A
030300                                 (X-STMT-MSG)
030400             MOVE DFHBMDAS       TO
030500                                 MB01-STMT-MSG-DATA-LP-A
030600                                 (X-STMT-MSG)
030700                                 MB01-STMT-MSG-DATA-RP-A
030800                                 (X-STMT-MSG)
030900         END-PERFORM.
031000*
031100*
031200     IF  MBCA-PTI-FUNCTION-IS-ADD
031300         MOVE DFHBMDAS           TO MB01-LAST-MAINT-LIT-A
031400                                    MB01-LAST-MAINT-DATE-A
031500                                    MB01-LAST-OPER-LIT-A
031600                                    MB01-LAST-MAINT-OPER-A.
031700*
031800****************************************************************
031900*    SEND THE MAP                                              *
032000****************************************************************
032100*
032200     MOVE 'BM01'                 TO MBCA-PROGRAM-LOCATION.
032300     PERFORM MB60PD-SEND-MAP-WITH-ERASE
032400                                 THRU MB60PD-SMWE-EXIT.
032500*
032600****************************************************************
032700*    RETURN TO CICS                                            *
032800****************************************************************
032900*
033000     MOVE 'PC02'                 TO MBCA-PROGRAM-LOCATION.
033100     PERFORM MB70PD-RETURN-TRANS-ID
033200                                 THRU MB70PD-RTI-EXIT.
033300*
033400/
033500 2000-RECEIVE-SCREEN SECTION.
033600*
033700****************************************************************
033800*    THIS SECTION RECEIVES THE FIRST SCREEN                    *
033900****************************************************************
034000*
034100     MOVE 'BM02'                 TO MBCA-PROGRAM-LOCATION.
034200     PERFORM MB60PD-RECEIVE-MAP  THRU MB60PD-RM-EXIT.
034300*
034400****************************************************************
034500*    CHECK FOR ANOTHER TRANSACTION ID ENTERED BY THE USER      *
034600****************************************************************
034700*
034800     MOVE 'PC03'                 TO MBCA-PROGRAM-LOCATION.
034900     PERFORM MB60PD-NEW-TRANS-ROUTINE
035000                                 THRU MB60PD-NTR-EXIT.
035100*
035200****************************************************************
035300*    BYPASS EDITS ON INQUIRY                                   *
035400****************************************************************
035500*
035600     IF  MBCA-PTI-FUNCTION-IS-INQUIRY
035700         GO TO 2600-SETUP-COMMAREA.
035800*
035900*
036000* ************************************************************ *
036100*            READ BAR CODE VARIABLES RECORD                    *
036200* ************************************************************ *
036300*
036400     MOVE 'FC02'                 TO MBCA-PROGRAM-LOCATION.
036500     MOVE MBCA-MERCHANT-ORG      TO MBIOWS-MMBC-ORG.
036600     MOVE MBCA-INSERT-NBR        TO MBIOWS-MMBC-INSERT-NBR.
036700     SET MBIORO-READ-RANDOM      TO TRUE.
036800     PERFORM MMBCAO-ACCESS       THRU MMBCAO-ACCESS-EXIT.
036900*
037000 2100-BEGIN-EDITS.
037100*
037200* ************************************************************ *
037300*        STATUS                                                *
037400* ************************************************************ *
037500*
037600     IF  MB01-STATUS-L IS LESS THAN 1
037700         MOVE MMBC-REC-STATUS    TO MB01-STATUS
037800         MOVE DFHBMASK           TO MB01-STATUS-A
037900         MOVE DFHBMDAS           TO MB01-STATUS-LP-A
038000                                    MB01-STATUS-RP-A
038100     ELSE
038200         IF  MB01-VALID-STATUS
038300             MOVE DFHBMASF       TO MB01-STATUS-A
038400             MOVE DFHBMDAS       TO MB01-STATUS-LP-A
038500                                    MB01-STATUS-RP-A
038600             SET WS-UPDATE-SW-YES
038700                                 TO TRUE
038800         ELSE
038900             MOVE DFHBMNBF       TO MB01-STATUS-A
039000             MOVE DFHBMASB       TO MB01-STATUS-LP-A
039100                                    MB01-STATUS-RP-A
039200             MOVE SS08WS-CURSOR  TO MB01-STATUS-L
039300             SET SS08WS-ERROR-SW-YES TO TRUE.
039400*
039500* ************************************************************ *
039600*        DATE OPENED USE                                       *
039700* ************************************************************ *
039800*
039900     IF  MB01-DTE-OPEN-USE-L IS LESS THAN 1
040000         MOVE MMBC-DATE-OPENED-USE
040100                                 TO MB01-DTE-OPEN-USE
040200         MOVE DFHBMASK           TO MB01-DTE-OPEN-USE-A
040300         MOVE DFHBMDAS           TO MB01-DTE-OPEN-USE-LP-A
040400                                    MB01-DTE-OPEN-USE-RP-A
040500     ELSE
040600         IF  MB01-VALID-DTE-OPEN-USE
040700             MOVE DFHBMASF       TO MB01-DTE-OPEN-USE-A
040800             MOVE DFHBMDAS       TO MB01-DTE-OPEN-USE-LP-A
040900                                    MB01-DTE-OPEN-USE-RP-A
041000             SET WS-UPDATE-SW-YES
041100                                 TO TRUE
041200         ELSE
041300             MOVE DFHBMUBF       TO MB01-DTE-OPEN-USE-A
041400                                    MB01-DTE-OPEN-IND-A
041500             MOVE DFHBMUNB       TO MB01-DTE-OPEN-BEG-A
041600                                    MB01-DTE-OPEN-END-A
041700             MOVE DFHBMASB       TO MB01-DTE-OPEN-USE-LP-A
041800                                    MB01-DTE-OPEN-USE-RP-A
041900                                    MB01-DTE-OPEN-IND-LP-A
042000                                    MB01-DTE-OPEN-IND-RP-A
042100                                    MB01-DTE-OPEN-BEG-LP-A
042200                                    MB01-DTE-OPEN-BEG-RP-A
042300                                    MB01-DTE-OPEN-END-LP-A
042400                                    MB01-DTE-OPEN-END-RP-A
042500             MOVE SS08WS-CURSOR  TO MB01-DTE-OPEN-USE-L
042600             SET SS08WS-ERROR-SW-YES TO TRUE.
042700*
042800* ************************************************************ *
042900*        DATE OPENED IND                                       *
043000* ************************************************************ *
043100*
043200     IF  MB01-DTE-OPEN-IND-L IS LESS THAN 1
043300         MOVE MMBC-DATE-OPENED-IND
043400                                 TO MB01-DTE-OPEN-IND
043500         MOVE DFHBMASK           TO MB01-DTE-OPEN-IND-A
043600         MOVE DFHBMDAS           TO MB01-DTE-OPEN-IND-LP-A
043700                                    MB01-DTE-OPEN-IND-RP-A
043800     ELSE
043900         IF  MB01-VALID-DTE-OPEN-IND
044000             MOVE DFHBMASF       TO MB01-DTE-OPEN-IND-A
044100             MOVE DFHBMDAS       TO MB01-DTE-OPEN-IND-LP-A
044200                                    MB01-DTE-OPEN-IND-RP-A
044300             SET WS-UPDATE-SW-YES
044400                                 TO TRUE
044500         ELSE
044600             MOVE DFHBMUBF       TO MB01-DTE-OPEN-IND-A
044700                                    MB01-DTE-OPEN-IND-A
044800             MOVE DFHBMUNB       TO MB01-DTE-OPEN-BEG-A
044900                                    MB01-DTE-OPEN-END-A
045000             MOVE DFHBMASB       TO MB01-DTE-OPEN-IND-LP-A
045100                                    MB01-DTE-OPEN-IND-RP-A
045200                                    MB01-DTE-OPEN-IND-LP-A
045300                                    MB01-DTE-OPEN-IND-RP-A
045400                                    MB01-DTE-OPEN-BEG-LP-A
045500                                    MB01-DTE-OPEN-BEG-RP-A
045600                                    MB01-DTE-OPEN-END-LP-A
045700                                    MB01-DTE-OPEN-END-RP-A
045800             MOVE SS08WS-CURSOR  TO MB01-DTE-OPEN-IND-L
045900             SET SS08WS-ERROR-SW-YES TO TRUE.
046000*
046100* ************************************************************ *
046200*        BEGINNING DATE OPENED                                 *
046300* ************************************************************ *
046400*
046500     IF  MB01-DTE-OPEN-BEG-L IS LESS THAN 1
046600         MOVE MMBC-DATE-OPENED-BEG
046700                                 TO SS01WS-JULIAN
046800         PERFORM SS08PD-JUL-TO-GREG
046900                                 THRU SS08PD-JTG-EXIT
047000         MOVE SS01WS-DATE        TO MB01-DTE-OPEN-BEG
047100         MOVE DFHBMASK           TO MB01-DTE-OPEN-BEG-A
047200         MOVE DFHBMDAS           TO MB01-DTE-OPEN-BEG-LP-A
047300                                    MB01-DTE-OPEN-BEG-RP-A
047400     ELSE
047500         IF  MB01-DTE-OPEN-BEG IS NOT NUMERIC
047600             MOVE DFHBMNBF       TO MB01-DTE-OPEN-BEG-A
047700             MOVE DFHBMASB       TO MB01-DTE-OPEN-BEG-LP-A
047800                                    MB01-DTE-OPEN-BEG-RP-A
047900             MOVE SS08WS-CURSOR  TO MB01-DTE-OPEN-BEG-L
048000             SET SS08WS-ERROR-SW-YES TO TRUE
048100         ELSE
048200             MOVE DFHBMASF       TO MB01-DTE-OPEN-BEG-A
048300             MOVE MB01-DTE-OPEN-BEG
048400                                 TO SS01WS-DATE
048500             PERFORM 9910-EDIT-DATE
048600                                 THRU 9910-EDIT-DATE-EXIT
048700             IF  SS01WS-DATE-IS-NOT-INVALID
048800                 MOVE SS01WS-DATE
048900                                 TO MB01-DTE-OPEN-BEG
049000                 MOVE DFHBMASF   TO MB01-DTE-OPEN-BEG-A
049100                 MOVE DFHBMDAS   TO MB01-DTE-OPEN-BEG-LP-A
049200                                    MB01-DTE-OPEN-BEG-RP-A
049300                 SET WS-UPDATE-SW-YES
049400                                 TO TRUE
049500             ELSE
049600                 MOVE DFHBMNBF   TO MB01-DTE-OPEN-BEG-A
049700                 MOVE DFHBMASB   TO MB01-DTE-OPEN-BEG-LP-A
049800                                    MB01-DTE-OPEN-BEG-RP-A
049900                 MOVE SS08WS-CURSOR TO MB01-DTE-OPEN-BEG-L
050000                 SET SS08WS-ERROR-SW-YES
050100                                 TO TRUE.
050200*
050300* ************************************************************ *
050400*        ENDING DATE OPENED                                    *
050500* ************************************************************ *
050600*
050700     IF  MB01-DTE-OPEN-END-L IS LESS THAN 1
050800         MOVE MMBC-DATE-OPENED-END
050900                                 TO SS01WS-JULIAN
051000         PERFORM SS08PD-JUL-TO-GREG
051100                                 THRU SS08PD-JTG-EXIT
051200         MOVE SS01WS-DATE        TO MB01-DTE-OPEN-END
051300         MOVE DFHBMASK           TO MB01-DTE-OPEN-END-A
051400         MOVE DFHBMDAS           TO MB01-DTE-OPEN-END-LP-A
051500                                    MB01-DTE-OPEN-END-RP-A
051600     ELSE
051700         IF  MB01-DTE-OPEN-END IS NOT NUMERIC
051800             MOVE DFHBMNBF       TO MB01-DTE-OPEN-END-A
051900             MOVE DFHBMASB       TO MB01-DTE-OPEN-END-LP-A
052000                                    MB01-DTE-OPEN-END-RP-A
052100             MOVE SS08WS-CURSOR  TO MB01-DTE-OPEN-END-L
052200             SET SS08WS-ERROR-SW-YES TO TRUE
052300         ELSE
052400             MOVE MB01-DTE-OPEN-END
052500                                 TO SS01WS-DATE
052600             PERFORM 9910-EDIT-DATE
052700                                 THRU 9910-EDIT-DATE-EXIT
052800             IF  SS01WS-DATE-IS-NOT-INVALID
052900                 MOVE SS01WS-DATE
053000                                 TO MB01-DTE-OPEN-END
053100                 MOVE DFHBMASF   TO MB01-DTE-OPEN-END-A
053200                 MOVE DFHBMDAS   TO MB01-DTE-OPEN-END-LP-A
053300                                    MB01-DTE-OPEN-END-RP-A
053400                 SET WS-UPDATE-SW-YES
053500                                 TO TRUE
053600             ELSE
053700                 MOVE DFHBMNBF   TO MB01-DTE-OPEN-END-A
053800                 MOVE DFHBMASB   TO MB01-DTE-OPEN-END-LP-A
053900                                    MB01-DTE-OPEN-END-RP-A
054000                 MOVE SS08WS-CURSOR TO MB01-DTE-OPEN-END-L
054100                 SET SS08WS-ERROR-SW-YES
054200                                 TO TRUE.
054300*
054400*
054500* ************************************************************ *
054600*        DATE LAST ACTIVE USE                                  *
054700* ************************************************************ *
054800*
054900     IF  MB01-DTE-LAST-USE-L IS LESS THAN 1
055000         MOVE MMBC-DATE-LAST-ACTIVE-USE
055100                                 TO MB01-DTE-LAST-USE
055200         MOVE DFHBMASK           TO MB01-DTE-LAST-USE-A
055300         MOVE DFHBMDAS           TO MB01-DTE-LAST-USE-LP-A
055400                                    MB01-DTE-LAST-USE-RP-A
055500     ELSE
055600         IF  MB01-VALID-DTE-LAST-USE
055700             MOVE DFHBMASF       TO MB01-DTE-LAST-USE-A
055800             MOVE DFHBMDAS       TO MB01-DTE-LAST-USE-LP-A
055900                                    MB01-DTE-LAST-USE-RP-A
056000             SET WS-UPDATE-SW-YES
056100                                 TO TRUE
056200         ELSE
056300             MOVE DFHBMUBF       TO MB01-DTE-LAST-USE-A
056400                                    MB01-DTE-LAST-IND-A
056500             MOVE DFHBMUNB       TO MB01-DTE-LAST-BEG-A
056600                                    MB01-DTE-LAST-END-A
056700             MOVE DFHBMASB       TO MB01-DTE-LAST-USE-LP-A
056800                                    MB01-DTE-LAST-USE-RP-A
056900                                    MB01-DTE-LAST-IND-LP-A
057000                                    MB01-DTE-LAST-IND-RP-A
057100                                    MB01-DTE-LAST-BEG-LP-A
057200                                    MB01-DTE-LAST-BEG-RP-A
057300                                    MB01-DTE-LAST-END-LP-A
057400                                    MB01-DTE-LAST-END-RP-A
057500             MOVE SS08WS-CURSOR  TO MB01-DTE-LAST-USE-L
057600             SET SS08WS-ERROR-SW-YES TO TRUE.
057700*
057800* ************************************************************ *
057900*        DATE LAST ACTIVE IND                                  *
058000* ************************************************************ *
058100*
058200     IF  MB01-DTE-LAST-IND-L IS LESS THAN 1
058300         MOVE MMBC-DATE-LAST-ACTIVE-IND
058400                                 TO MB01-DTE-LAST-IND
058500         MOVE DFHBMASK           TO MB01-DTE-LAST-IND-A
058600         MOVE DFHBMDAS           TO MB01-DTE-LAST-IND-LP-A
058700                                    MB01-DTE-LAST-IND-RP-A
058800     ELSE
058900         IF  MB01-VALID-DTE-LAST-IND
059000             MOVE DFHBMASF       TO MB01-DTE-LAST-IND-A
059100             MOVE DFHBMDAS       TO MB01-DTE-LAST-IND-LP-A
059200                                    MB01-DTE-LAST-IND-RP-A
059300             SET WS-UPDATE-SW-YES
059400                                 TO TRUE
059500         ELSE
059600             MOVE DFHBMUBF       TO MB01-DTE-LAST-IND-A
059700                                    MB01-DTE-LAST-IND-A
059800             MOVE DFHBMUNB       TO MB01-DTE-LAST-BEG-A
059900                                    MB01-DTE-LAST-END-A
060000             MOVE DFHBMASB       TO MB01-DTE-LAST-IND-LP-A
060100                                    MB01-DTE-LAST-IND-RP-A
060200                                    MB01-DTE-LAST-IND-LP-A
060300                                    MB01-DTE-LAST-IND-RP-A
060400                                    MB01-DTE-LAST-BEG-LP-A
060500                                    MB01-DTE-LAST-BEG-RP-A
060600                                    MB01-DTE-LAST-END-LP-A
060700                                    MB01-DTE-LAST-END-RP-A
060800             MOVE SS08WS-CURSOR  TO MB01-DTE-LAST-IND-L
060900             SET SS08WS-ERROR-SW-YES TO TRUE.
061000*
061100* ************************************************************ *
061200*        BEGINNING DATE LAST ACTIVE                            *
061300* ************************************************************ *
061400*
061500     IF  MB01-DTE-LAST-BEG-L IS LESS THAN 1
061600         MOVE MMBC-DATE-LAST-ACTIVE-BEG
061700                                 TO SS01WS-JULIAN
061800         PERFORM SS08PD-JUL-TO-GREG
061900                                 THRU SS08PD-JTG-EXIT
062000         MOVE SS01WS-DATE        TO MB01-DTE-LAST-BEG
062100         MOVE DFHBMASK           TO MB01-DTE-LAST-BEG-A
062200         MOVE DFHBMDAS           TO MB01-DTE-LAST-BEG-LP-A
062300                                    MB01-DTE-LAST-BEG-RP-A
062400     ELSE
062500         IF  MB01-DTE-LAST-BEG IS NOT NUMERIC
062600             MOVE DFHBMNBF       TO MB01-DTE-LAST-BEG-A
062700             MOVE DFHBMASB       TO MB01-DTE-LAST-BEG-LP-A
062800                                    MB01-DTE-LAST-BEG-RP-A
062900             MOVE SS08WS-CURSOR  TO MB01-DTE-LAST-BEG-L
063000             SET SS08WS-ERROR-SW-YES TO TRUE
063100         ELSE
063200             MOVE MB01-DTE-LAST-BEG
063300                                 TO SS01WS-DATE
063400             PERFORM 9910-EDIT-DATE
063500                                 THRU 9910-EDIT-DATE-EXIT
063600             IF  SS01WS-DATE-IS-NOT-INVALID
063700                 MOVE SS01WS-DATE
063800                                 TO MB01-DTE-LAST-BEG
063900                 MOVE DFHBMASF   TO MB01-DTE-LAST-BEG-A
064000                 MOVE DFHBMDAS   TO MB01-DTE-LAST-BEG-LP-A
064100                                    MB01-DTE-LAST-BEG-RP-A
064200                 SET WS-UPDATE-SW-YES
064300                                 TO TRUE
064400             ELSE
064500                 MOVE DFHBMNBF   TO MB01-DTE-LAST-BEG-A
064600                 MOVE DFHBMASB   TO MB01-DTE-LAST-BEG-LP-A
064700                                    MB01-DTE-LAST-BEG-RP-A
064800                 MOVE SS08WS-CURSOR TO MB01-DTE-LAST-BEG-L
064900                 SET SS08WS-ERROR-SW-YES
065000                                 TO TRUE.
065100*
065200* ************************************************************ *
065300*        ENDING DATE LAST ACTIVE                               *
065400* ************************************************************ *
065500*
065600     IF  MB01-DTE-LAST-END-L IS LESS THAN 1
065700         MOVE MMBC-DATE-LAST-ACTIVE-END
065800                                 TO SS01WS-JULIAN
065900         PERFORM SS08PD-JUL-TO-GREG
066000                                 THRU SS08PD-JTG-EXIT
066100         MOVE SS01WS-DATE        TO MB01-DTE-LAST-END
066200         MOVE DFHBMASK           TO MB01-DTE-LAST-END-A
066300         MOVE DFHBMDAS           TO MB01-DTE-LAST-END-LP-A
066400                                    MB01-DTE-LAST-END-RP-A
066500     ELSE
066600         IF  MB01-DTE-LAST-END IS NOT NUMERIC
066700             MOVE DFHBMNBF       TO MB01-DTE-LAST-END-A
066800             MOVE DFHBMASB       TO MB01-DTE-LAST-END-LP-A
066900                                    MB01-DTE-LAST-END-RP-A
067000             MOVE SS08WS-CURSOR  TO MB01-DTE-LAST-END-L
067100             SET SS08WS-ERROR-SW-YES TO TRUE
067200         ELSE
067300             MOVE MB01-DTE-LAST-END
067400                                 TO SS01WS-DATE
067500             PERFORM 9910-EDIT-DATE
067600                                 THRU 9910-EDIT-DATE-EXIT
067700             IF  SS01WS-DATE-IS-NOT-INVALID
067800                 MOVE SS01WS-DATE
067900                                 TO MB01-DTE-LAST-END
068000                 MOVE DFHBMASF   TO MB01-DTE-LAST-END-A
068100                 MOVE DFHBMDAS   TO MB01-DTE-LAST-END-LP-A
068200                                    MB01-DTE-LAST-END-RP-A
068300                 SET WS-UPDATE-SW-YES
068400                                 TO TRUE
068500             ELSE
068600                 MOVE DFHBMNBF   TO MB01-DTE-LAST-END-A
068700                 MOVE DFHBMASB   TO MB01-DTE-LAST-END-LP-A
068800                                    MB01-DTE-LAST-END-RP-A
068900                 MOVE SS08WS-CURSOR TO MB01-DTE-LAST-END-L
069000                 SET SS08WS-ERROR-SW-YES
069100                                 TO TRUE.
069200*
069300*
069400* ************************************************************ *
069500*        BLOCK CODE USE                                        *
069600* ************************************************************ *
069700*
069800     IF  MB01-BLK-CODE-USE-L IS LESS THAN 1
069900         MOVE MMBC-BLOCK-CODE-USE
070000                                 TO MB01-BLK-CODE-USE
070100         MOVE DFHBMASK           TO MB01-BLK-CODE-USE-A
070200         MOVE DFHBMDAS           TO MB01-BLK-CODE-USE-LP-A
070300                                    MB01-BLK-CODE-USE-RP-A
070400     ELSE
070500         IF  MB01-VALID-BLK-CODE-USE
070600             MOVE DFHBMASF       TO MB01-BLK-CODE-USE-A
070700             MOVE DFHBMDAS       TO MB01-BLK-CODE-USE-LP-A
070800                                    MB01-BLK-CODE-USE-RP-A
070900             SET WS-UPDATE-SW-YES
071000                                 TO TRUE
071100         ELSE
071200             MOVE DFHBMUBF       TO MB01-BLK-CODE-USE-A
071300             MOVE DFHBMASB       TO MB01-BLK-CODE-USE-LP-A
071400                                    MB01-BLK-CODE-USE-RP-A
071500             MOVE SS08WS-CURSOR  TO MB01-BLK-CODE-USE-L
071600             SET SS08WS-ERROR-SW-YES TO TRUE.
071700*
071800* ************************************************************ *
071900*        BLOCK CODE IND                                        *
072000* ************************************************************ *
072100*
072200     IF  MB01-BLK-CODE-IND-L IS LESS THAN 1
072300         MOVE MMBC-BLOCK-CODE-IND
072400                                 TO MB01-BLK-CODE-IND
072500         MOVE DFHBMASK           TO MB01-BLK-CODE-IND-A
072600         MOVE DFHBMDAS           TO MB01-BLK-CODE-IND-LP-A
072700                                    MB01-BLK-CODE-IND-RP-A
072800     ELSE
072900         IF  MB01-VALID-BLK-CODE-IND
073000             MOVE DFHBMASF       TO MB01-BLK-CODE-IND-A
073100             MOVE DFHBMDAS       TO MB01-BLK-CODE-IND-LP-A
073200                                    MB01-BLK-CODE-IND-RP-A
073300             SET WS-UPDATE-SW-YES
073400                                 TO TRUE
073500         ELSE
073600             MOVE DFHBMUBF       TO MB01-BLK-CODE-IND-A
073700             MOVE DFHBMASB       TO MB01-BLK-CODE-IND-LP-A
073800                                    MB01-BLK-CODE-IND-RP-A
073900             MOVE SS08WS-CURSOR  TO MB01-BLK-CODE-IND-L
074000             SET SS08WS-ERROR-SW-YES TO TRUE.
074100*
074200* ************************************************************ *
074300*        BLOCK CODE DATA                                       *
074400* ************************************************************ *
074500*
074600     PERFORM
074700         VARYING X-BLK-CODE
074800         FROM 1 BY 1
074900         UNTIL X-BLK-CODE IS GREATER THAN 18
075000         SET X-MMBC-BLOCK-CODE   TO X-BLK-CODE
075100         IF  MB01-BLK-CODE-DATA-L (X-BLK-CODE) IS LESS THAN 1
075200             MOVE MMBC-BLOCK-CODE (X-MMBC-BLOCK-CODE)
075300                                 TO MB01-BLK-CODE-DATA
075400                                    (X-BLK-CODE)
075500             MOVE DFHBMASK       TO MB01-BLK-CODE-DATA-A
075600                                    (X-BLK-CODE)
075700             MOVE DFHBMDAS       TO MB01-BLK-CODE-DATA-LP-A
075800                                    (X-BLK-CODE)
075900                                    MB01-BLK-CODE-DATA-RP-A
076000                                    (X-BLK-CODE)
076100         ELSE
076200             MOVE DFHBMASF       TO MB01-BLK-CODE-DATA-A
076300                                    (X-BLK-CODE)
076400             MOVE DFHBMDAS       TO MB01-BLK-CODE-DATA-LP-A
076500                                    (X-BLK-CODE)
076600                                    MB01-BLK-CODE-DATA-RP-A
076700                                    (X-BLK-CODE)
076800             SET WS-UPDATE-SW-YES
076900                                 TO TRUE
077000         END-IF
077100      END-PERFORM.
077200*
077300* ************************************************************ *
077400*        STATEMENT CYCLE USE                                   *
077500* ************************************************************ *
077600*
077700     IF  MB01-STMT-CYC-USE-L IS LESS THAN 1
077800         MOVE MMBC-STMT-CYCLE-USE
077900                                 TO MB01-STMT-CYC-USE
078000         MOVE DFHBMASK           TO MB01-STMT-CYC-USE-A
078100         MOVE DFHBMDAS           TO MB01-STMT-CYC-USE-LP-A
078200                                    MB01-STMT-CYC-USE-RP-A
078300     ELSE
078400         IF  MB01-VALID-STMT-CYC-USE
078500             MOVE DFHBMASF       TO MB01-STMT-CYC-USE-A
078600             MOVE DFHBMDAS       TO MB01-STMT-CYC-USE-LP-A
078700                                    MB01-STMT-CYC-USE-RP-A
078800             SET WS-UPDATE-SW-YES
078900                                 TO TRUE
079000         ELSE
079100             MOVE DFHBMUBF       TO MB01-STMT-CYC-USE-A
079200             MOVE DFHBMASB       TO MB01-STMT-CYC-USE-LP-A
079300                                    MB01-STMT-CYC-USE-RP-A
079400             MOVE SS08WS-CURSOR  TO MB01-STMT-CYC-USE-L
079500             SET SS08WS-ERROR-SW-YES TO TRUE.
079600*
079700* ************************************************************ *
079800*        STATEMENT CYCLE IND                                   *
079900* ************************************************************ *
080000*
080100     IF  MB01-STMT-CYC-IND-L IS LESS THAN 1
080200         MOVE MMBC-STMT-CYCLE-IND
080300                                 TO MB01-STMT-CYC-IND
080400         MOVE DFHBMASK           TO MB01-STMT-CYC-IND-A
080500         MOVE DFHBMDAS           TO MB01-STMT-CYC-IND-LP-A
080600                                    MB01-STMT-CYC-IND-RP-A
080700     ELSE
080800         IF  MB01-VALID-STMT-CYC-IND
080900             MOVE DFHBMASF       TO MB01-STMT-CYC-IND-A
081000             MOVE DFHBMDAS       TO MB01-STMT-CYC-IND-LP-A
081100                                    MB01-STMT-CYC-IND-RP-A
081200             SET WS-UPDATE-SW-YES
081300                                 TO TRUE
081400         ELSE
081500             MOVE DFHBMUBF       TO MB01-STMT-CYC-IND-A
081600             MOVE DFHBMASB       TO MB01-STMT-CYC-IND-LP-A
081700                                    MB01-STMT-CYC-IND-RP-A
081800             MOVE SS08WS-CURSOR  TO MB01-STMT-CYC-IND-L
081900             SET SS08WS-ERROR-SW-YES TO TRUE.
082000*
082100* ************************************************************ *
082200*        STATEMENT CYCLE DATA                                  *
082300* ************************************************************ *
082400*
082500     PERFORM
082600         VARYING X-STMT-CYC
082700         FROM 1 BY 1
082800         UNTIL X-STMT-CYC IS GREATER THAN 18
082900         SET X-MMBC-STMT-CYCLE   TO X-STMT-CYC
083000         IF  MB01-STMT-CYC-DATA-L (X-STMT-CYC) IS LESS THAN 1
083100             MOVE MMBC-STMT-CYCLE (X-MMBC-STMT-CYCLE)
083200                                 TO MB01-STMT-CYC-DATA
083300                                    (X-STMT-CYC)
083400             MOVE DFHBMASK       TO MB01-STMT-CYC-DATA-A
083500                                    (X-STMT-CYC)
083600             MOVE DFHBMDAS       TO MB01-STMT-CYC-DATA-LP-A
083700                                    (X-STMT-CYC)
083800                                    MB01-STMT-CYC-DATA-RP-A
083900                                    (X-STMT-CYC)
084000         ELSE
084100             IF  MB01-STMT-CYC-DATA (X-STMT-CYC)
084200                                    IS NOT NUMERIC
084300                 MOVE DFHBMNBF   TO MB01-STMT-CYC-DATA-A
084400                                    (X-STMT-CYC)
084500                 MOVE DFHBMASB   TO MB01-STMT-CYC-DATA-LP-A
084600                                    (X-STMT-CYC)
084700                                    MB01-STMT-CYC-DATA-RP-A
084800                                    (X-STMT-CYC)
084900                 MOVE SS08WS-CURSOR TO MB01-STMT-CYC-DATA-L
085000                                    (X-STMT-CYC)
085100                 SET SS08WS-ERROR-SW-YES
085200                                 TO TRUE
085300             ELSE
085400                 MOVE DFHBMASF   TO MB01-STMT-CYC-DATA-A
085500                                    (X-STMT-CYC)
085600                 MOVE DFHBMDAS   TO MB01-STMT-CYC-DATA-LP-A
085700                                    (X-STMT-CYC)
085800                                    MB01-STMT-CYC-DATA-RP-A
085900                                    (X-STMT-CYC)
086000                 SET WS-UPDATE-SW-YES
086100                                 TO TRUE
086200             END-IF
086300         END-IF
086400      END-PERFORM.
086500*
086600* ************************************************************ *
086700*        STATEMENT MSG FLAG USE                                *
086800* ************************************************************ *
086900*
087000     IF  MB01-STMT-MSG-USE-L IS LESS THAN 1
087100         MOVE MMBC-STMT-MSG-FLAG-USE
087200                                 TO MB01-STMT-MSG-USE
087300         MOVE DFHBMASK           TO MB01-STMT-MSG-USE-A
087400         MOVE DFHBMDAS           TO MB01-STMT-MSG-USE-LP-A
087500                                    MB01-STMT-MSG-USE-RP-A
087600     ELSE
087700         IF  MB01-VALID-STMT-MSG-USE
087800             MOVE DFHBMASF       TO MB01-STMT-MSG-USE-A
087900             MOVE DFHBMDAS       TO MB01-STMT-MSG-USE-LP-A
088000                                    MB01-STMT-MSG-USE-RP-A
088100             SET WS-UPDATE-SW-YES
088200                                 TO TRUE
088300         ELSE
088400             MOVE DFHBMUBF       TO MB01-STMT-MSG-USE-A
088500             MOVE DFHBMASB       TO MB01-STMT-MSG-USE-LP-A
088600                                    MB01-STMT-MSG-USE-RP-A
088700             MOVE SS08WS-CURSOR  TO MB01-STMT-MSG-USE-L
088800             SET SS08WS-ERROR-SW-YES TO TRUE.
088900*
089000* ************************************************************ *
089100*        STATEMENT MSG FLAG IND                                *
089200* ************************************************************ *
089300*
089400     IF  MB01-STMT-MSG-IND-L IS LESS THAN 1
089500         MOVE MMBC-STMT-MSG-FLAG-IND
089600                                 TO MB01-STMT-MSG-IND
089700         MOVE DFHBMASK           TO MB01-STMT-MSG-IND-A
089800         MOVE DFHBMDAS           TO MB01-STMT-MSG-IND-LP-A
089900                                    MB01-STMT-MSG-IND-RP-A
090000     ELSE
090100         IF  MB01-VALID-STMT-MSG-IND
090200             MOVE DFHBMASF       TO MB01-STMT-MSG-IND-A
090300             MOVE DFHBMDAS       TO MB01-STMT-MSG-IND-LP-A
090400                                    MB01-STMT-MSG-IND-RP-A
090500             SET WS-UPDATE-SW-YES
090600                                 TO TRUE
090700         ELSE
090800             MOVE DFHBMUBF       TO MB01-STMT-MSG-IND-A
090900             MOVE DFHBMASB       TO MB01-STMT-MSG-IND-LP-A
091000                                    MB01-STMT-MSG-IND-RP-A
091100             MOVE SS08WS-CURSOR  TO MB01-STMT-MSG-IND-L
091200             SET SS08WS-ERROR-SW-YES TO TRUE.
091300*
091400* ************************************************************ *
091500*        STATEMENT MSG FLAG DATA                               *
091600* ************************************************************ *
091700*
091800     PERFORM
091900         VARYING X-STMT-MSG
092000         FROM 1 BY 1
092100         UNTIL X-STMT-MSG IS GREATER THAN 5
092200         SET X-MMBC-STMT-MSG-FLAG
092300                                 TO X-STMT-MSG
092400         IF  MB01-STMT-MSG-DATA-L (X-STMT-MSG) IS LESS THAN 1
092500             MOVE MMBC-STMT-MSG-FLAG (X-MMBC-STMT-MSG-FLAG)
092600                                 TO MB01-STMT-MSG-DATA
092700                                    (X-STMT-MSG)
092800             MOVE DFHBMASK       TO MB01-STMT-MSG-DATA-A
092900                                    (X-STMT-MSG)
093000             MOVE DFHBMDAS       TO MB01-STMT-MSG-DATA-LP-A
093100                                    (X-STMT-MSG)
093200                                    MB01-STMT-MSG-DATA-RP-A
093300                                    (X-STMT-MSG)
093400         ELSE
093500             IF  MB01-VALID-STMT-MSG-DATA (X-STMT-MSG)
093600                 MOVE DFHBMASF   TO MB01-STMT-MSG-DATA-A
093700                                    (X-STMT-MSG)
093800                 MOVE DFHBMDAS   TO MB01-STMT-MSG-DATA-LP-A
093900                                    (X-STMT-MSG)
094000                                    MB01-STMT-MSG-DATA-RP-A
094100                                    (X-STMT-MSG)
094200                 SET WS-UPDATE-SW-YES
094300                                 TO TRUE
094400             ELSE
094500                 MOVE DFHBMUBF   TO MB01-STMT-MSG-DATA-A
094600                                    (X-STMT-MSG)
094700                 MOVE DFHBMASB   TO MB01-STMT-MSG-DATA-LP-A
094800                                    (X-STMT-MSG)
094900                                    MB01-STMT-MSG-DATA-RP-A
095000                                    (X-STMT-MSG)
095100                 MOVE SS08WS-CURSOR TO MB01-STMT-MSG-DATA-L
095200                                    (X-STMT-MSG)
095300                 SET SS08WS-ERROR-SW-YES
095400                                 TO TRUE
095500             END-IF
095600         END-IF
095700      END-PERFORM.
095800*
095900* ************************************************************ *
096000*        CROSS EDITS FOR DATE OPEN AND DATE LAST ACT           *
096100* ************************************************************ *
096200*
096300     IF  MB01-DTE-OPEN-USE IS EQUAL TO 'Y'
096400         IF  MB01-DTE-OPEN-IND IS EQUAL TO 'L'
096500         OR  MB01-DTE-OPEN-IND IS EQUAL TO 'G'
096600             EVALUATE TRUE
096700                 WHEN MB01-DTE-OPEN-BEG IS LESS THAN 100000
096800                     MOVE DFHBMNBF
096900                                 TO MB01-DTE-OPEN-BEG-A
097000                     MOVE DFHBMASB
097100                                 TO MB01-DTE-OPEN-BEG-LP-A
097200                                    MB01-DTE-OPEN-BEG-RP-A
097300                     MOVE SS08WS-CURSOR
097400                                 TO MB01-DTE-OPEN-BEG-L
097500                     SET SS08WS-ERROR-SW-YES
097600                                 TO TRUE
097700             END-EVALUATE
097800             EVALUATE TRUE
097900                 WHEN MB01-DTE-OPEN-END IS GREATER THAN ZEROS
098000                     MOVE DFHBMNBF
098100                                 TO MB01-DTE-OPEN-END-A
098200                     MOVE DFHBMASB
098300                                 TO MB01-DTE-OPEN-END-LP-A
098400                                    MB01-DTE-OPEN-END-RP-A
098500                     MOVE SS08WS-CURSOR
098600                                 TO MB01-DTE-OPEN-END-L
098700                     SET SS08WS-ERROR-SW-YES
098800                                 TO TRUE
098900             END-EVALUATE
099000         END-IF
099100         IF  MB01-DTE-OPEN-IND IS EQUAL TO 'E'
099200             EVALUATE TRUE
099300                 WHEN MB01-DTE-OPEN-BEG IS LESS THAN 100000
099400                     MOVE DFHBMNBF
099500                                 TO MB01-DTE-OPEN-BEG-A
099600                     MOVE DFHBMASB
099700                                 TO MB01-DTE-OPEN-BEG-LP-A
099800                                    MB01-DTE-OPEN-BEG-RP-A
099900                     MOVE SS08WS-CURSOR
100000                                 TO MB01-DTE-OPEN-BEG-L
100100                     SET SS08WS-ERROR-SW-YES
100200                                 TO TRUE
100300             END-EVALUATE
100400             EVALUATE TRUE
100500                 WHEN MB01-DTE-OPEN-END IS LESS THAN 100000
100600                     MOVE DFHBMNBF
100700                                 TO MB01-DTE-OPEN-END-A
100800                     MOVE DFHBMASB
100900                                 TO MB01-DTE-OPEN-END-LP-A
101000                                    MB01-DTE-OPEN-END-RP-A
101100                     MOVE SS08WS-CURSOR
101200                                 TO MB01-DTE-OPEN-END-L
101300                     SET SS08WS-ERROR-SW-YES
101400                                 TO TRUE
101500             END-EVALUATE
101600         END-IF
101700     ELSE
101800         EVALUATE TRUE
101900             WHEN MB01-DTE-OPEN-BEG IS GREATER THAN ZEROS
102000                 MOVE DFHBMNBF   TO MB01-DTE-OPEN-BEG-A
102100                 MOVE DFHBMUBF   TO MB01-DTE-OPEN-USE-A
102200                 MOVE DFHBMASB   TO MB01-DTE-OPEN-BEG-LP-A
102300                                    MB01-DTE-OPEN-BEG-RP-A
102400                                    MB01-DTE-OPEN-USE-LP-A
102500                                    MB01-DTE-OPEN-USE-RP-A
102600                 MOVE SS08WS-CURSOR TO MB01-DTE-OPEN-USE-L
102700                 SET SS08WS-ERROR-SW-YES
102800                                 TO TRUE
102900         END-EVALUATE
103000         EVALUATE TRUE
103100             WHEN MB01-DTE-OPEN-END IS GREATER THAN ZEROS
103200                 MOVE DFHBMNBF   TO MB01-DTE-OPEN-END-A
103300                 MOVE DFHBMUBF   TO MB01-DTE-OPEN-USE-A
103400                 MOVE DFHBMASB   TO MB01-DTE-OPEN-END-LP-A
103500                                    MB01-DTE-OPEN-END-RP-A
103600                                    MB01-DTE-OPEN-USE-LP-A
103700                                    MB01-DTE-OPEN-USE-RP-A
103800                 MOVE SS08WS-CURSOR TO MB01-DTE-OPEN-USE-L
103900                 SET SS08WS-ERROR-SW-YES
104000                                 TO TRUE
104100         END-EVALUATE.
104200*
104300*
104400*
104500     IF  MB01-DTE-LAST-USE IS EQUAL TO 'Y'
104600         IF  MB01-DTE-LAST-IND IS EQUAL TO 'L'
104700         OR  MB01-DTE-LAST-IND IS EQUAL TO 'G'
104800             EVALUATE TRUE
104900                 WHEN MB01-DTE-LAST-BEG IS LESS THAN 100000
105000                     MOVE DFHBMNBF
105100                                 TO MB01-DTE-LAST-BEG-A
105200                     MOVE DFHBMASB
105300                                 TO MB01-DTE-LAST-BEG-LP-A
105400                                    MB01-DTE-LAST-BEG-RP-A
105500                     MOVE SS08WS-CURSOR
105600                                 TO MB01-DTE-LAST-BEG-L
105700                     SET SS08WS-ERROR-SW-YES
105800                                 TO TRUE
105900             END-EVALUATE
106000             EVALUATE TRUE
106100                 WHEN MB01-DTE-LAST-END IS GREATER THAN ZEROS
106200                     MOVE DFHBMNBF
106300                                 TO MB01-DTE-LAST-END-A
106400                     MOVE DFHBMASB
106500                                 TO MB01-DTE-LAST-END-LP-A
106600                                    MB01-DTE-LAST-END-RP-A
106700                     MOVE SS08WS-CURSOR
106800                                 TO MB01-DTE-LAST-END-L
106900                     SET SS08WS-ERROR-SW-YES
107000                                 TO TRUE
107100             END-EVALUATE
107200         END-IF
107300         IF  MB01-DTE-LAST-IND IS EQUAL TO 'E'
107400             EVALUATE TRUE
107500                 WHEN MB01-DTE-LAST-BEG IS LESS THAN 100000
107600                     MOVE DFHBMNBF
107700                                 TO MB01-DTE-LAST-BEG-A
107800                     MOVE DFHBMASB
107900                                 TO MB01-DTE-LAST-BEG-LP-A
108000                                    MB01-DTE-LAST-BEG-RP-A
108100                     MOVE SS08WS-CURSOR
108200                                 TO MB01-DTE-LAST-BEG-L
108300                     SET SS08WS-ERROR-SW-YES
108400                                 TO TRUE
108500             END-EVALUATE
108600             EVALUATE TRUE
108700                 WHEN MB01-DTE-LAST-END IS LESS THAN 100000
108800                     MOVE DFHBMNBF
108900                                 TO MB01-DTE-LAST-END-A
109000                     MOVE DFHBMASB
109100                                 TO MB01-DTE-LAST-END-LP-A
109200                                    MB01-DTE-LAST-END-RP-A
109300                     MOVE SS08WS-CURSOR
109400                                 TO MB01-DTE-LAST-END-L
109500                     SET SS08WS-ERROR-SW-YES
109600                                 TO TRUE
109700             END-EVALUATE
109800         END-IF
109900     ELSE
110000         EVALUATE TRUE
110100             WHEN MB01-DTE-LAST-BEG IS GREATER THAN ZEROS
110200                 MOVE DFHBMNBF   TO MB01-DTE-LAST-BEG-A
110300                 MOVE DFHBMUBF   TO MB01-DTE-LAST-USE-A
110400                 MOVE DFHBMASB   TO MB01-DTE-LAST-BEG-LP-A
110500                                    MB01-DTE-LAST-BEG-RP-A
110600                                    MB01-DTE-LAST-USE-LP-A
110700                                    MB01-DTE-LAST-USE-RP-A
110800                 MOVE SS08WS-CURSOR TO MB01-DTE-LAST-USE-L
110900                 SET SS08WS-ERROR-SW-YES
111000                                 TO TRUE
111100         END-EVALUATE
111200         EVALUATE TRUE
111300             WHEN MB01-DTE-LAST-END IS GREATER THAN ZEROS
111400                 MOVE DFHBMNBF   TO MB01-DTE-LAST-END-A
111500                 MOVE DFHBMUBF   TO MB01-DTE-LAST-USE-A
111600                 MOVE DFHBMASB   TO MB01-DTE-LAST-END-LP-A
111700                                    MB01-DTE-LAST-END-RP-A
111800                                    MB01-DTE-LAST-USE-LP-A
111900                                    MB01-DTE-LAST-USE-RP-A
112000                 MOVE SS08WS-CURSOR TO MB01-DTE-LAST-USE-L
112100                 SET SS08WS-ERROR-SW-YES
112200                                 TO TRUE
112300         END-EVALUATE.
112400*
112500     IF  SS08WS-ERROR-SW-NO
112600         IF  MB01-DTE-OPEN-IND IS EQUAL TO 'E'
112700             MOVE MB01-DTE-OPEN-BEG
112800                                 TO SS01WS-DATE
112900             PERFORM SS07PD-GREG-TO-JUL
113000                                 THRU SS07PD-GTJ-EXIT
113100             MOVE SS01WS-JULIAN  TO WS-BEG-DATE
113200             MOVE MB01-DTE-OPEN-END
113300                                 TO SS01WS-DATE
113400             PERFORM SS07PD-GREG-TO-JUL
113500                                 THRU SS07PD-GTJ-EXIT
113600             MOVE SS01WS-JULIAN  TO WS-END-DATE
113700             IF  WS-BEG-DATE IS GREATER THAN
113800                                    WS-END-DATE
113900                 MOVE DFHBMNBF   TO MB01-DTE-OPEN-BEG-A
114000                                    MB01-DTE-OPEN-END-A
114100                 MOVE DFHBMASB   TO MB01-DTE-OPEN-BEG-LP-A
114200                                    MB01-DTE-OPEN-BEG-RP-A
114300                                    MB01-DTE-OPEN-END-LP-A
114400                                    MB01-DTE-OPEN-END-RP-A
114500                 MOVE SS08WS-CURSOR TO MB01-DTE-OPEN-BEG-L
114600                 SET SS08WS-ERROR-SW-YES
114700                                 TO TRUE
114800             END-IF
114900         END-IF
115000         IF  MB01-DTE-LAST-IND IS EQUAL TO 'E'
115100             MOVE MB01-DTE-LAST-BEG
115200                                 TO SS01WS-DATE
115300             PERFORM SS07PD-GREG-TO-JUL
115400                                 THRU SS07PD-GTJ-EXIT
115500             MOVE SS01WS-JULIAN  TO WS-BEG-DATE
115600             MOVE MB01-DTE-LAST-END
115700                                 TO SS01WS-DATE
115800             PERFORM SS07PD-GREG-TO-JUL
115900                                 THRU SS07PD-GTJ-EXIT
116000             MOVE SS01WS-JULIAN  TO WS-END-DATE
116100             IF  WS-BEG-DATE IS GREATER THAN
116200                                    WS-END-DATE
116300                 MOVE DFHBMNBF   TO MB01-DTE-LAST-BEG-A
116400                                    MB01-DTE-LAST-END-A
116500                 MOVE DFHBMASB   TO MB01-DTE-LAST-BEG-LP-A
116600                                    MB01-DTE-LAST-BEG-RP-A
116700                                    MB01-DTE-LAST-END-LP-A
116800                                    MB01-DTE-LAST-END-RP-A
116900                 MOVE SS08WS-CURSOR TO MB01-DTE-LAST-BEG-L
117000                 SET SS08WS-ERROR-SW-YES
117100                                 TO TRUE.
117200*
117300 2300-CONTINUE.
117400*
117500     IF  SS08WS-ERROR-SW-NO
117600         GO TO 2400-UPDATE-FILE.
117700*
117800****************************************************************
117900*    SEND THE MAP                                              *
118000****************************************************************
118100*
118200     PERFORM MB60PD-INIT-STD-MAP-LINES
118300                                 THRU MB60PD-ISML-EXIT.
118400     MOVE 'BM03'                 TO MBCA-PROGRAM-LOCATION.
118500     PERFORM MB60PD-SEND-MAP-DATA-ONLY
118600                                 THRU MB60PD-SMDO-EXIT.
118700*
118800****************************************************************
118900*    RETURN TO CICS                                            *
119000****************************************************************
119100*
119200     MOVE 'PC04'                 TO MBCA-PROGRAM-LOCATION.
119300     MOVE 01                     TO MBCA-SCREEN-NBR.
119400     PERFORM MB70PD-RETURN-TRANS-ID
119500                                 THRU MB70PD-RTI-EXIT.
119600/
119700 2400-UPDATE-FILE.
119800*
119900     IF  MBCA-PTI-FUNCTION-IS-ADD
120000         NEXT SENTENCE
120100     ELSE
120200         IF  WS-UPDATE-SW-NO
120300             GO TO 2600-SETUP-COMMAREA.
120400*
120500****************************************************************
120600*    GETMAIN FOR LOG/JOURNAL RECORD                            *
120700****************************************************************
120800*
120900     MOVE 'SC02'                 TO MBCA-PROGRAM-LOCATION.
121000     SET MBIORO-GETMAIN          TO TRUE.
121100     PERFORM MML1AO-ACCESS       THRU MML1AO-ACCESS-EXIT.
121200*
121300* ************************************************************ *
121400*            READ BAR CODE FOR UPDATE                          *
121500* ************************************************************ *
121600*
121700     MOVE 'FC03'                 TO MBCA-PROGRAM-LOCATION.
121800     MOVE MBCA-MERCHANT-ORG      TO MBIOWS-MMBC-ORG.
121900     MOVE MBCA-INSERT-NBR        TO MBIOWS-MMBC-INSERT-NBR.
122000     SET MBIORO-READ-RANDOM-UPDATE
122100                                 TO TRUE
122200     PERFORM MMBCAO-ACCESS       THRU MMBCAO-ACCESS-EXIT.
122300*
122400*************************************************
122500*    SET UP THE COMMON PORTION OF THE RECORD    *
122600*************************************************
122700*
122800     MOVE 'BC'                   TO MML1-FILE-CODE.
122900     MOVE MBCA-MERCHANT-ORG      TO MML1-MMBC-ORG.
123000     MOVE MBCA-INSERT-NBR        TO MML1-MMBC-INSERT-NBR.
123100     MOVE MBCA-SIGNON-NAME       TO MML1-SIGNON-NAME.
123200     MOVE MBCA-TERMINAL-ID       TO MML1-TERMINAL-ID.
123300     MOVE ZEROS                  TO MML1-SOURCE-CODE.
123400*
123500 2410-UPDATE-FIELDS.
123600*
123700* ************************************************************ *
123800*        STATUS                                                *
123900* ************************************************************ *
124000*
124100     IF  MB01-STATUS-L IS GREATER THAN ZEROS
124200         MOVE ZEROS              TO MML1-FIELD-OCCURRENCE
124300         MOVE 0101               TO MML1-FIELD-CODE
124400         MOVE MML1WS-VL-01       TO MML1-VARIABLE-LENGTH
124500         MOVE MMBC-REC-STATUS    TO MML1-VL01-B-DATA-9
124600         MOVE MB01-STATUS        TO MMBC-REC-STATUS
124700         MOVE MMBC-REC-STATUS    TO MML1-VL01-A-DATA-9
124800         PERFORM 9050-CREATE-MAINT-RECORD
124900                                 THRU 9099-CMR-EXIT.
125000*
125100* ************************************************************ *
125200*        DATE OPENED USE                                       *
125300* ************************************************************ *
125400*
125500     IF  MB01-DTE-OPEN-USE-L IS GREATER THAN ZEROS
125600         MOVE ZEROS              TO MML1-FIELD-OCCURRENCE
125700         MOVE 0102               TO MML1-FIELD-CODE
125800         MOVE MML1WS-VL-01       TO MML1-VARIABLE-LENGTH
125900         MOVE MMBC-DATE-OPENED-USE
126000                                 TO MML1-VL01-B-DATA-X
126100         MOVE MB01-DTE-OPEN-USE  TO MMBC-DATE-OPENED-USE
126200         MOVE MMBC-DATE-OPENED-USE
126300                                 TO MML1-VL01-A-DATA-X
126400         PERFORM 9050-CREATE-MAINT-RECORD
126500                                 THRU 9099-CMR-EXIT.
126600*
126700* ************************************************************ *
126800*        DATE OPENED IND                                       *
126900* ************************************************************ *
127000*
127100     IF  MB01-DTE-OPEN-IND-L IS GREATER THAN ZEROS
127200         MOVE ZEROS              TO MML1-FIELD-OCCURRENCE
127300         MOVE 0103               TO MML1-FIELD-CODE
127400         MOVE MML1WS-VL-01       TO MML1-VARIABLE-LENGTH
127500         MOVE MMBC-DATE-OPENED-IND
127600                                 TO MML1-VL01-B-DATA-X
127700         MOVE MB01-DTE-OPEN-IND  TO MMBC-DATE-OPENED-IND
127800         MOVE MMBC-DATE-OPENED-IND
127900                                 TO MML1-VL01-A-DATA-X
128000         PERFORM 9050-CREATE-MAINT-RECORD
128100                                 THRU 9099-CMR-EXIT.
128200*
128300* ************************************************************ *
128400*        DATE OPENED BEG                                       *
128500* ************************************************************ *
128600*
128700     IF  MB01-DTE-OPEN-BEG-L IS GREATER THAN ZEROS
128800         MOVE ZEROS              TO MML1-FIELD-OCCURRENCE
128900         MOVE 0104               TO MML1-FIELD-CODE
129000         MOVE MML1WS-VL-07       TO MML1-VARIABLE-LENGTH
129100         MOVE MMBC-DATE-OPENED-BEG
129200                                 TO MML1-VL07-B-DATA-9
129300         MOVE MB01-DTE-OPEN-BEG  TO SS01WS-DATE
129400         PERFORM SS07PD-GREG-TO-JUL
129500                                 THRU SS07PD-GTJ-EXIT
129600         MOVE SS01WS-JULIAN      TO MMBC-DATE-OPENED-BEG
129700         MOVE MMBC-DATE-OPENED-BEG
129800                                 TO MML1-VL07-A-DATA-9
129900         PERFORM 9050-CREATE-MAINT-RECORD
130000                                 THRU 9099-CMR-EXIT.
130100*
130200* ************************************************************ *
130300*        DATE OPENED END                                       *
130400* ************************************************************ *
130500*
130600     IF  MB01-DTE-OPEN-END-L IS GREATER THAN ZEROS
130700         MOVE ZEROS              TO MML1-FIELD-OCCURRENCE
130800         MOVE 0105               TO MML1-FIELD-CODE
130900         MOVE MML1WS-VL-07       TO MML1-VARIABLE-LENGTH
131000         MOVE MMBC-DATE-OPENED-END
131100                                 TO MML1-VL07-B-DATA-9
131200         MOVE MB01-DTE-OPEN-END  TO SS01WS-DATE
131300         PERFORM SS07PD-GREG-TO-JUL
131400                                 THRU SS07PD-GTJ-EXIT
131500         MOVE SS01WS-JULIAN      TO MMBC-DATE-OPENED-END
131600         MOVE MMBC-DATE-OPENED-END
131700                                 TO MML1-VL07-A-DATA-9
131800         PERFORM 9050-CREATE-MAINT-RECORD
131900                                 THRU 9099-CMR-EXIT.
132000*
132100* ************************************************************ *
132200*        DATE LAST ACTIVE USE                                  *
132300* ************************************************************ *
132400*
132500     IF  MB01-DTE-LAST-USE-L IS GREATER THAN ZEROS
132600         MOVE ZEROS              TO MML1-FIELD-OCCURRENCE
132700         MOVE 0106               TO MML1-FIELD-CODE
132800         MOVE MML1WS-VL-01       TO MML1-VARIABLE-LENGTH
132900         MOVE MMBC-DATE-LAST-ACTIVE-USE
133000                                 TO MML1-VL01-B-DATA-X
133100         MOVE MB01-DTE-LAST-USE  TO MMBC-DATE-LAST-ACTIVE-USE
133200         MOVE MMBC-DATE-LAST-ACTIVE-USE
133300                                 TO MML1-VL01-A-DATA-X
133400         PERFORM 9050-CREATE-MAINT-RECORD
133500                                 THRU 9099-CMR-EXIT.
133600*
133700* ************************************************************ *
133800*        DATE LAST ACTIVE IND                                  *
133900* ************************************************************ *
134000*
134100     IF  MB01-DTE-LAST-IND-L IS GREATER THAN ZEROS
134200         MOVE ZEROS              TO MML1-FIELD-OCCURRENCE
134300         MOVE 0107               TO MML1-FIELD-CODE
134400         MOVE MML1WS-VL-01       TO MML1-VARIABLE-LENGTH
134500         MOVE MMBC-DATE-LAST-ACTIVE-IND
134600                                 TO MML1-VL01-B-DATA-X
134700         MOVE MB01-DTE-LAST-IND  TO MMBC-DATE-LAST-ACTIVE-IND
134800         MOVE MMBC-DATE-LAST-ACTIVE-IND
134900                                 TO MML1-VL01-A-DATA-X
135000         PERFORM 9050-CREATE-MAINT-RECORD
135100                                 THRU 9099-CMR-EXIT.
135200*
135300* ************************************************************ *
135400*        DATE LAST ACTIVE BEG DATE                             *
135500* ************************************************************ *
135600*
135700     IF  MB01-DTE-LAST-BEG-L IS GREATER THAN ZEROS
135800         MOVE ZEROS              TO MML1-FIELD-OCCURRENCE
135900         MOVE 0108               TO MML1-FIELD-CODE
136000         MOVE MML1WS-VL-07       TO MML1-VARIABLE-LENGTH
136100         MOVE MMBC-DATE-LAST-ACTIVE-BEG
136200                                 TO MML1-VL07-B-DATA-9
136300         MOVE MB01-DTE-LAST-BEG  TO SS01WS-DATE
136400         PERFORM SS07PD-GREG-TO-JUL
136500                                 THRU SS07PD-GTJ-EXIT
136600         MOVE SS01WS-JULIAN      TO MMBC-DATE-LAST-ACTIVE-BEG
136700         MOVE MMBC-DATE-LAST-ACTIVE-BEG
136800                                 TO MML1-VL07-A-DATA-9
136900         PERFORM 9050-CREATE-MAINT-RECORD
137000                                 THRU 9099-CMR-EXIT.
137100*
137200* ************************************************************ *
137300*        DATE LAST ACTIVE END DATE                             *
137400* ************************************************************ *
137500*
137600     IF  MB01-DTE-LAST-END-L IS GREATER THAN ZEROS
137700         MOVE ZEROS              TO MML1-FIELD-OCCURRENCE
137800         MOVE 0109               TO MML1-FIELD-CODE
137900         MOVE MML1WS-VL-07       TO MML1-VARIABLE-LENGTH
138000         MOVE MMBC-DATE-LAST-ACTIVE-END
138100                                 TO MML1-VL07-B-DATA-9
138200         MOVE MB01-DTE-LAST-END  TO SS01WS-DATE
138300         PERFORM SS07PD-GREG-TO-JUL
138400                                 THRU SS07PD-GTJ-EXIT
138500         MOVE SS01WS-JULIAN      TO MMBC-DATE-LAST-ACTIVE-END
138600         MOVE MMBC-DATE-LAST-ACTIVE-END
138700                                 TO MML1-VL07-A-DATA-9
138800         PERFORM 9050-CREATE-MAINT-RECORD
138900                                 THRU 9099-CMR-EXIT.
139000*
139100* ************************************************************ *
139200*        BLOCK CODE USE                                        *
139300* ************************************************************ *
139400*
139500     IF  MB01-BLK-CODE-USE-L IS GREATER THAN ZEROS
139600         MOVE ZEROS              TO MML1-FIELD-OCCURRENCE
139700         MOVE 0110               TO MML1-FIELD-CODE
139800         MOVE MML1WS-VL-01       TO MML1-VARIABLE-LENGTH
139900         MOVE MMBC-BLOCK-CODE-USE
140000                                 TO MML1-VL01-B-DATA-X
140100         MOVE MB01-BLK-CODE-USE  TO MMBC-BLOCK-CODE-USE
140200         MOVE MMBC-BLOCK-CODE-USE
140300                                 TO MML1-VL01-A-DATA-X
140400         PERFORM 9050-CREATE-MAINT-RECORD
140500                                 THRU 9099-CMR-EXIT.
140600*
140700* ************************************************************ *
140800*        BLOCK CODE IND                                        *
140900* ************************************************************ *
141000*
141100     IF  MB01-BLK-CODE-IND-L IS GREATER THAN ZEROS
141200         MOVE ZEROS              TO MML1-FIELD-OCCURRENCE
141300         MOVE 0111               TO MML1-FIELD-CODE
141400         MOVE MML1WS-VL-01       TO MML1-VARIABLE-LENGTH
141500         MOVE MMBC-BLOCK-CODE-IND
141600                                 TO MML1-VL01-B-DATA-X
141700         MOVE MB01-BLK-CODE-IND  TO MMBC-BLOCK-CODE-IND
141800         MOVE MMBC-BLOCK-CODE-IND
141900                                 TO MML1-VL01-A-DATA-X
142000         PERFORM 9050-CREATE-MAINT-RECORD
142100                                 THRU 9099-CMR-EXIT.
142200*
142300* ************************************************************ *
142400*        BLOCK CODE DATA                                       *
142500* ************************************************************ *
142600*
142700     PERFORM
142800         VARYING X-BLK-CODE
142900         FROM 1 BY 1
143000         UNTIL X-BLK-CODE IS GREATER THAN 18
143100         SET X-MMBC-BLOCK-CODE   TO X-BLK-CODE
143200         IF  MB01-BLK-CODE-DATA-L (X-BLK-CODE)
143300             IS GREATER THAN ZEROS
143400             SET MML1-FIELD-OCCURRENCE
143500                                 TO X-BLK-CODE
143600             MOVE 0112           TO MML1-FIELD-CODE
143700             MOVE MML1WS-VL-01   TO MML1-VARIABLE-LENGTH
143800             MOVE MMBC-BLOCK-CODE (X-MMBC-BLOCK-CODE)
143900                                 TO MML1-VL01-B-DATA-X
144000             MOVE MB01-BLK-CODE-DATA (X-BLK-CODE)
144100                                 TO MMBC-BLOCK-CODE
144200                                    (X-MMBC-BLOCK-CODE)
144300             MOVE MMBC-BLOCK-CODE (X-MMBC-BLOCK-CODE)
144400                                 TO MML1-VL01-A-DATA-X
144500             PERFORM 9050-CREATE-MAINT-RECORD
144600                                 THRU 9099-CMR-EXIT
144700         END-IF
144800     END-PERFORM.
144900*
145000* ************************************************************ *
145100*        STATEMENT CYCLE USE                                   *
145200* ************************************************************ *
145300*
145400     IF  MB01-STMT-CYC-USE-L IS GREATER THAN ZEROS
145500         MOVE ZEROS              TO MML1-FIELD-OCCURRENCE
145600         MOVE 0113               TO MML1-FIELD-CODE
145700         MOVE MML1WS-VL-01       TO MML1-VARIABLE-LENGTH
145800         MOVE MMBC-STMT-CYCLE-USE
145900                                 TO MML1-VL01-B-DATA-X
146000         MOVE MB01-STMT-CYC-USE  TO MMBC-STMT-CYCLE-USE
146100         MOVE MMBC-STMT-CYCLE-USE
146200                                 TO MML1-VL01-A-DATA-X
146300         PERFORM 9050-CREATE-MAINT-RECORD
146400                                 THRU 9099-CMR-EXIT.
146500*
146600* ************************************************************ *
146700*        STATEMENT CYCLE IND                                   *
146800* ************************************************************ *
146900*
147000     IF  MB01-STMT-CYC-IND-L IS GREATER THAN ZEROS
147100         MOVE ZEROS              TO MML1-FIELD-OCCURRENCE
147200         MOVE 0114               TO MML1-FIELD-CODE
147300         MOVE MML1WS-VL-01       TO MML1-VARIABLE-LENGTH
147400         MOVE MMBC-STMT-CYCLE-IND
147500                                 TO MML1-VL01-B-DATA-X
147600         MOVE MB01-STMT-CYC-IND  TO MMBC-STMT-CYCLE-IND
147700         MOVE MMBC-STMT-CYCLE-IND
147800                                 TO MML1-VL01-A-DATA-X
147900         PERFORM 9050-CREATE-MAINT-RECORD
148000                                 THRU 9099-CMR-EXIT.
148100*
148200* ************************************************************ *
148300*        STATEMENT CYCLE DATA                                  *
148400* ************************************************************ *
148500*
148600     PERFORM
148700         VARYING X-STMT-CYC
148800         FROM 1 BY 1
148900         UNTIL X-STMT-CYC IS GREATER THAN 18
149000         SET X-MMBC-STMT-CYCLE   TO X-STMT-CYC
149100         IF  MB01-STMT-CYC-DATA-L (X-STMT-CYC)
149200             IS GREATER THAN ZEROS
149300             SET MML1-FIELD-OCCURRENCE
149400                                 TO X-STMT-CYC
149500             MOVE 0115           TO MML1-FIELD-CODE
149600             MOVE MML1WS-VL-02   TO MML1-VARIABLE-LENGTH
149700             MOVE MMBC-STMT-CYCLE (X-MMBC-STMT-CYCLE)
149800                                 TO MML1-VL02-B-DATA-9
149900             MOVE MB01-STMT-CYC-DATA (X-STMT-CYC)
150000                                 TO MMBC-STMT-CYCLE
150100                                    (X-MMBC-STMT-CYCLE)
150200             MOVE MMBC-STMT-CYCLE (X-MMBC-STMT-CYCLE)
150300                                 TO MML1-VL02-A-DATA-9
150400             PERFORM 9050-CREATE-MAINT-RECORD
150500                                 THRU 9099-CMR-EXIT
150600         END-IF
150700     END-PERFORM.
150800*
150900* ************************************************************ *
151000*        STATEMENT MSG FLAG USE                                *
151100* ************************************************************ *
151200*
151300     IF  MB01-STMT-MSG-USE-L IS GREATER THAN ZEROS
151400         MOVE ZEROS              TO MML1-FIELD-OCCURRENCE
151500         MOVE 0116               TO MML1-FIELD-CODE
151600         MOVE MML1WS-VL-01       TO MML1-VARIABLE-LENGTH
151700         MOVE MMBC-STMT-MSG-FLAG-USE
151800                                 TO MML1-VL01-B-DATA-X
151900         MOVE MB01-STMT-MSG-USE  TO MMBC-STMT-MSG-FLAG-USE
152000         MOVE MMBC-STMT-MSG-FLAG-USE
152100                                 TO MML1-VL01-A-DATA-X
152200         PERFORM 9050-CREATE-MAINT-RECORD
152300                                 THRU 9099-CMR-EXIT.
152400*
152500* ************************************************************ *
152600*        STATEMENT MSG FLAG IND                                *
152700* ************************************************************ *
152800*
152900     IF  MB01-STMT-MSG-IND-L IS GREATER THAN ZEROS
153000         MOVE ZEROS              TO MML1-FIELD-OCCURRENCE
153100         MOVE 0117               TO MML1-FIELD-CODE
153200         MOVE MML1WS-VL-01       TO MML1-VARIABLE-LENGTH
153300         MOVE MMBC-STMT-MSG-FLAG-IND
153400                                 TO MML1-VL01-B-DATA-X
153500         MOVE MB01-STMT-MSG-IND  TO MMBC-STMT-MSG-FLAG-IND
153600         MOVE MMBC-STMT-MSG-FLAG-IND
153700                                 TO MML1-VL01-A-DATA-X
153800         PERFORM 9050-CREATE-MAINT-RECORD
153900                                 THRU 9099-CMR-EXIT.
154000*
154100* ************************************************************ *
154200*        STATEMENT MSG FLAG DATA                               *
154300* ************************************************************ *
154400*
154500     PERFORM
154600         VARYING X-STMT-MSG
154700         FROM 1 BY 1
154800         UNTIL X-STMT-MSG      IS GREATER THAN 5
154900         SET X-MMBC-STMT-MSG-FLAG
155000                                 TO X-STMT-MSG
155100         IF  MB01-STMT-MSG-DATA-L (X-STMT-MSG)
155200             IS GREATER THAN ZEROS
155300             SET MML1-FIELD-OCCURRENCE
155400                                 TO X-STMT-MSG
155500             MOVE 0118           TO MML1-FIELD-CODE
155600             MOVE MML1WS-VL-01   TO MML1-VARIABLE-LENGTH
155700             MOVE MMBC-STMT-MSG-FLAG (X-MMBC-STMT-MSG-FLAG)
155800                                 TO MML1-VL01-B-DATA-X
155900             MOVE MB01-STMT-MSG-DATA (X-STMT-MSG)
156000                                 TO MMBC-STMT-MSG-FLAG
156100                                    (X-MMBC-STMT-MSG-FLAG)
156200             MOVE MMBC-STMT-MSG-FLAG (X-MMBC-STMT-MSG-FLAG)
156300                                 TO MML1-VL01-A-DATA-X
156400             PERFORM 9050-CREATE-MAINT-RECORD
156500                                 THRU 9099-CMR-EXIT
156600         END-IF
156700     END-PERFORM.
156800*
156900     IF  MBCA-PTI-FUNCTION-IS-ADD
157000         GO TO 2500-REWRITE-BAR-CODE.
157100*
157200*            ***** LAST MAINT DATE AND OPERATOR ID *****       *
157300*
157400     MOVE ZEROES                 TO MML1-FIELD-OCCURRENCE.
157500     MOVE 0199                   TO MML1-FIELD-CODE.
157600     MOVE MML1WS-VL-07           TO MML1-VARIABLE-LENGTH.
157700     MOVE MMBC-LAST-MAINT-DATE   TO MML1-VL07-B-DATA-9.
157800     MOVE MBCA-START-DATE        TO MMBC-LAST-MAINT-DATE.
157900     MOVE MMBC-LAST-MAINT-DATE   TO MML1-VL07-A-DATA-9.
158000     PERFORM 9050-CREATE-MAINT-RECORD
158100                                 THRU 9099-CMR-EXIT.
158200     MOVE 0198                   TO MML1-FIELD-CODE.
158300     MOVE MML1WS-VL-03           TO MML1-VARIABLE-LENGTH.
158400     MOVE MMBC-LAST-MAINT-OPER   TO MML1-VL03-B-DATA-X.
158500     MOVE MBCA-OPERATOR-ID       TO MMBC-LAST-MAINT-OPER.
158600     MOVE MMBC-LAST-MAINT-OPER   TO MML1-VL03-A-DATA-X.
158700     PERFORM 9050-CREATE-MAINT-RECORD
158800                                 THRU 9099-CMR-EXIT.
158900*
159000*
159100 2500-REWRITE-BAR-CODE.
159200*
159300     IF  MBCA-PTI-FUNCTION-IS-ADD
159400         MOVE 01                 TO MMBC-ONLINE-STATUS.
159500*
159600     MOVE MBCA-MERCHANT-ORG      TO MMBC-ORG.
159700     MOVE MBCA-INSERT-NBR        TO MMBC-INSERT-NBR.
159800     MOVE 'FC04'                 TO MBCA-PROGRAM-LOCATION.
159900     SET MBIORO-REWRITE          TO TRUE.
160000     PERFORM MMBCAO-ACCESS       THRU MMBCAO-ACCESS-EXIT.
160100*
160200 2600-SETUP-COMMAREA.
160300*
160400* ************************************************************ *
160500*  SET UP THE COMM AREA FIELDS AND TRANSFER TO THE NEXT PROGRAM*
160600* ************************************************************ *
160700*
160800     PERFORM MB60PD-EDIT-PAGE-NBR
160900                                 THRU MB60PD-EPN-EXIT.
161000*
161100     MOVE MBCA-EIBAID            TO SS08WS-EIBAID.
161200*
161300     IF  SS08WS-VALID-PF-KEY OR
161400         SS08WS-EIBAID-VALID-PF-KEY
161500         SET MBCA-INITIAL-SCREEN-NBR
161600                                 TO TRUE.
161700*
161800     PERFORM MB70PD-XCTL-TO-MBOXCTL
161900                                 THRU MB70PD-XTM-EXIT.
162000*
162100*
162200 9000-PERFORMED-ROUTINES-SECT SECTION.
162300*
162400 9050-CREATE-MAINT-RECORD.
162500*
162600*****************************************************************
162700*    THIS ROUTINE WILL CREATE THE COMMON DATA FOR ALL OF THE    *
162800*    LOG/JOURNAL TRANSACTIONS                                   *
162900*****************************************************************
163000*
163100     IF  MBCA-PTI-FUNCTION-IS-ADD
163200         GO TO 9099-CMR-EXIT.
163300*
163400     MOVE 'BC'                   TO MML1-FILE-CODE.
163500     MOVE MBCA-MERCHANT-ORG      TO MML1-MMBC-ORG.
163600     MOVE MBCA-INSERT-NBR        TO MML1-MMBC-INSERT-NBR.
163700     MOVE MBCA-SIGNON-NAME       TO MML1-SIGNON-NAME.
163800     MOVE MBCA-TERMINAL-ID       TO MML1-TERMINAL-ID.
163900     MOVE ZEROES                 TO MML1-SOURCE-CODE
164000                                    MML1-FIELD-OCCURRENCE-2.
164100*
164200*****************************************************************
164300*    WRITE THE LOG/JOURNAL FILE RECORD                          *
164400*****************************************************************
164500*
164600     MOVE 'FC05'                 TO MBCA-PROGRAM-LOCATION.
164700     SET MBIORO-WRITE            TO TRUE.
164800     PERFORM MML1AO-ACCESS       THRU MML1AO-ACCESS-EXIT.
164900     MOVE SPACES                 TO MML1-VARIABLE-AREA.
165000*
165100 9099-CMR-EXIT.
165200     EXIT.
165300*
165400/
165500 9910-EDIT-DATE.
165600*
165700     IF  SS01WS-DATE IS LESS THAN 1000000
165800         MOVE SS01WS-DATE        TO SS01WS-MDY
165900         MOVE SS01WS-MDYZ        TO SS01WS-DATEZ.
166000*
166100     PERFORM SS05PD-DATE-VALIDATION
166200                                 THRU SS05PD-DV-EXIT.
166300*
166400 9910-EDIT-DATE-EXIT.
166500     EXIT.
166600*
166700     COPY SS15PD.
166800/
166900     COPY SS05PD.
167000/
167100     COPY SS07PD.
167200/
167300     COPY SS08PD.
167400/
167500     COPY SS26PD.
167600/
167700     COPY SS27PD.
167800/
167900     COPY MMBCAO.
168000/
168100     COPY MML1AO.
168200/
168300     COPY MB60PD REPLACING 'MBMAPXX' BY 'MBMB01 '
168400                          MBMAPXXO BY MBMB01O
168500                          MBMAPXXI BY MBMB01I.
168600/
168700     COPY MB70PD.
168800/
168900     COPY SMFTPXO.
