000100 IDENTIFICATION DIVISION.
000200 PROGRAM-ID. MBOMB02.
000201*       RELEASE DATE=08/24/01.        REVISION LEVEL=08.06      *
000202*****************************************************************
000203*WARNING.  THIS COMPUTER PROGRAM IS PROTECTED BY COPYRIGHT LAW  *
000204*AND INTERNATIONAL TREATIES.  UNAUTHORIZED REPRODUCTION OR      *
000205*DISTRIBUTION OF THIS PROGRAM, OR ANY PORTION OF IT, MAY RESULT *
000206*IN SEVERE CIVIL AND CRIMINAL PENATLIES, AND WILL BE PROSECUTED *
000207*TO THE MAXIMUM EXTENT POSSIBLE UNDER THE LAW.                  *
000208*COPYRIGHT 1999 PAYSYS INTERNATIONAL, INC.  ALL RIGHTS RESERVED.*
000209*****************************************************************
000300*****************************************************************
000400*                                                               *
000500*   V - PLUS  M E R C H A N T   B A N K C A R D   S Y S T E M   *
000600*                                                               *
000700*      MBOMB02 - ON-LINE BAR CODE ADD/MAINTENANCE/INQUIRY       *
000800*                SCREEN 02                                      *
000900*                                                               *
001000*              1. TRANSIDS                                      *
001100*                 A. MBAB                                       *
001200*                 B. MBMB                                       *
001300*                 C. MBQB                                       *
001400*              2. MAPS USED -                                   *
001500*                 A. MBMB02 (BAR CODE MAP 02)                   *
001600*              3. FILES USED -                                  *
001700*                 A. MMBC   (BAR CODE FILE)                     *
001800*                 B. MML1   (LOG/JOURNAL FILE)                  *
001900*                                                               *
002000*****************************************************************
002100* ************************************************************ *
002200*
002300 ENVIRONMENT DIVISION.
002400 DATA DIVISION.
002500*
002600 WORKING-STORAGE SECTION.
002700 01  FILLER                  PIC  X(12)      VALUE '** WS-BEG **'.
002800*         I/O REQUEST BLOCK WORK AREAS
002900     COPY MBIOWS.
003000/         I/O REQUEST BLOCK
003100     COPY MBIORO.
003200/         LOG/JOURNAL WORK AREAS
003300     COPY MML1WS REPLACING ==:MML1:== BY ==MML1==.
003400/         DATE WORK AREAS
003500     COPY SS01WS.
003600/         ONLINE WORK AREAS
003700     COPY SS08WS.
003800/
003900     COPY SS00WS.
004000/
004100     COPY SMFTWS.
004200/
004300     COPY SMPTRL REPLACING ==:SMPT:== BY ==SMPT==.
004400/
004500     COPY MB61LK.
004600/
004700 01  WS-WORKING-FIELDS.
004800*
004900     03  SS08WS-ERROR-SWITCH PIC  X(01)      VALUE 'N'.
005000     03  WS-UPDATE-SWITCH    PIC  X(01)      VALUE 'N'.
005100         88  WS-UPDATE-SW-YES                VALUE 'Y'.
005200         88  WS-UPDATE-SW-NO                 VALUE 'N'.
005300*
005400 01  FILLER                  PIC  X(12)      VALUE '** WS-END **'.
005500/
005600 LINKAGE SECTION.
005700 01  DFHCOMMAREA.
005800     COPY MB60WS.
005900/         ORG SCREEN 01 MAP DSECT
006000     COPY MBMB02.
006100/         ORG SCREEN 01 MAP REDEFINITION
006200     COPY MBMB02R.
006300/         BAR CODE FILE RECORD LAYOUT
006400     COPY MMBCRL.
006500/         LOG/JOURNAL FILE RECORD LAYOUT
006600     COPY MML1RL REPLACING ==:MML1:== BY ==MML1==.
006700/
006800 PROCEDURE DIVISION.
006900 0000-START-SECT SECTION.
007000*
007100     MOVE 'PC01'                 TO MBCA-PROGRAM-LOCATION.
007200     PERFORM MB70PD-ON-LINE-HOUSEKEEPING
007300                                 THRU MB70PD-OLH-EXIT.
007400*
007500     IF  MBCA-RECEIVE-SCREEN
007600         GO TO 2000-RECEIVE-SCREEN.
007700*
007800/
007900 1000-SEND-SCREEN SECTION.
008000*
008100****************************************************************
008200*    THIS SECTION BUILDS AND SENDS THE 01 SCREEN.              *
008300****************************************************************
008400*
008500****************************************************************
008600*    GET CICS STORAGE NEEDED FOR THE MAP                       *
008700****************************************************************
008800*
008900     MOVE 'SC01'                 TO MBCA-PROGRAM-LOCATION.
009000     PERFORM MB60PD-GETMAIN-FOR-MAP
009100                                 THRU MB60PD-GFM-EXIT.
009200*
009300     MOVE MBCA-MERCHANT-ORG      TO MB02-ORG.
009400     MOVE MBCA-INSERT-NBR        TO MB02-INSERT-NBR.
009500     MOVE 02                     TO MBCA-SCREEN-NBR.
009600*
009700****************************************************************
009800*    INITIALIZE THE STANDARD MAP LINES                         *
009900****************************************************************
010000*
010100     PERFORM MB60PD-INIT-STD-MAP-LINES
010200                                 THRU MB60PD-ISML-EXIT.
010300*
010400****************************************************************
010500*    READ THE BAR CODE FILE RECORD NUMBER                      *
010600****************************************************************
010700*
010800     MOVE 'FC01'                 TO MBCA-PROGRAM-LOCATION.
010900     MOVE MBCA-MERCHANT-ORG      TO MBIOWS-MMBC-ORG.
011000     MOVE MBCA-INSERT-NBR        TO MBIOWS-MMBC-INSERT-NBR.
011100     SET MBIORO-READ-RANDOM      TO TRUE.
011200     PERFORM MMBCAO-ACCESS       THRU MMBCAO-ACCESS-EXIT.
011300/
011400 1100-BUILD-SCREEN.
011500* ************************************************************ *
011600*            BUILD THE MAP FROM THE BAR CODE RECORD            *
011700* ************************************************************ *
011800     MOVE MMBC-POSTAL-CODE-USE   TO MB02-ZIP-CODE-USE.
011900     MOVE MMBC-POSTAL-CODE-IND   TO MB02-ZIP-CODE-IND.
012000*
012100***************************************************************
012200*    MOVE ZIP CODE DATA                                       *
012300***************************************************************
012400*
012500     PERFORM
012600         VARYING X-MMBC-POSTAL-CODE
012700         FROM 1 BY 1
012800         UNTIL  X-MMBC-POSTAL-CODE IS GREATER THAN 18
012900         SET X-ZIP-CODE          TO X-MMBC-POSTAL-CODE
013000         MOVE MMBC-POSTAL-CODE (X-MMBC-POSTAL-CODE)
013100                                 TO
013200                                 MB02-ZIP-CODE (X-ZIP-CODE)
013300     END-PERFORM.
013400*
013500/
013600****************************************************************
013700*    IF INQUIRY, DARKEN PARENS AND ASKIP FIELDS                *
013800****************************************************************
013900*
014000     MOVE SS08WS-CURSOR          TO MB02-ZIP-CODE-USE-L.
014100*
014200     IF  MBCA-PTI-FUNCTION-IS-INQUIRY
014300         MOVE SS08WS-CURSOR      TO MB02-ALT-TRANID-L
014400         MOVE DFHBMASB           TO MB02-ZIP-CODE-USE-A
014500                                    MB02-ZIP-CODE-IND-A
014600         MOVE DFHBMDAS           TO MB02-ZIP-CODE-USE-LP-A
014700                                    MB02-ZIP-CODE-USE-RP-A
014800                                    MB02-ZIP-CODE-IND-LP-A
014900                                    MB02-ZIP-CODE-IND-RP-A
015000*
015100         PERFORM
015200             VARYING X-ZIP-CODE
015300             FROM 1 BY 1
015400             UNTIL  X-ZIP-CODE IS GREATER THAN 18
015500             MOVE DFHBMASB       TO
015600                                 MB02-ZIP-CODE-A
015700                                 (X-ZIP-CODE)
015800             MOVE DFHBMDAS       TO
015900                                 MB02-ZIP-CODE-LP-A
016000                                 (X-ZIP-CODE)
016100                                 MB02-ZIP-CODE-RP-A
016200                                 (X-ZIP-CODE)
016300         END-PERFORM.
016400*
016500*
016600****************************************************************
016700*    SEND THE MAP                                              *
016800****************************************************************
016900*
017000     MOVE 'BM01'                 TO MBCA-PROGRAM-LOCATION.
017100     PERFORM MB60PD-SEND-MAP-WITH-ERASE
017200                                 THRU MB60PD-SMWE-EXIT.
017300*
017400****************************************************************
017500*    RETURN TO CICS                                            *
017600****************************************************************
017700*
017800     MOVE 'PC02'                 TO MBCA-PROGRAM-LOCATION.
017900     PERFORM MB70PD-RETURN-TRANS-ID
018000                                 THRU MB70PD-RTI-EXIT.
018100*
018200/
018300 2000-RECEIVE-SCREEN SECTION.
018400*
018500****************************************************************
018600*    THIS SECTION RECEIVES THE FIRST SCREEN                    *
018700****************************************************************
018800*
018900     MOVE 'BM02'                 TO MBCA-PROGRAM-LOCATION.
019000     PERFORM MB60PD-RECEIVE-MAP  THRU MB60PD-RM-EXIT.
019100*
019200****************************************************************
019300*    CHECK FOR ANOTHER TRANSACTION ID ENTERED BY THE USER      *
019400****************************************************************
019500*
019600     MOVE 'PC03'                 TO MBCA-PROGRAM-LOCATION.
019700     PERFORM MB60PD-NEW-TRANS-ROUTINE
019800                                 THRU MB60PD-NTR-EXIT.
019900*
020000****************************************************************
020100*    BYPASS EDITS ON INQUIRY                                   *
020200****************************************************************
020300*
020400     IF  MBCA-PTI-FUNCTION-IS-INQUIRY
020500         GO TO 2600-SETUP-COMMAREA.
020600*
020700*
020800* ************************************************************ *
020900*            READ BAR CODE VARIABLES RECORD                    *
021000* ************************************************************ *
021100*
021200     MOVE 'FC02'                 TO MBCA-PROGRAM-LOCATION.
021300     MOVE MBCA-MERCHANT-ORG      TO MBIOWS-MMBC-ORG.
021400     MOVE MBCA-INSERT-NBR        TO MBIOWS-MMBC-INSERT-NBR.
021500     SET MBIORO-READ-RANDOM      TO TRUE.
021600     PERFORM MMBCAO-ACCESS       THRU MMBCAO-ACCESS-EXIT.
021700*
021800 2100-BEGIN-EDITS.
021900*
022000* ************************************************************ *
022100*        ZIP CODE USE                                          *
022200* ************************************************************ *
022300*
022400     IF  MB02-ZIP-CODE-USE-L IS LESS THAN 1
022500         MOVE MMBC-POSTAL-CODE-USE
022600                                 TO MB02-ZIP-CODE-USE
022700         MOVE DFHBMASK           TO MB02-ZIP-CODE-USE-A
022800         MOVE DFHBMDAS           TO MB02-ZIP-CODE-USE-LP-A
022900                                    MB02-ZIP-CODE-USE-RP-A
023000     ELSE
023100         IF  MB02-VALID-ZIP-CODE-USE
023200             MOVE DFHBMASF       TO MB02-ZIP-CODE-USE-A
023300             MOVE DFHBMDAS       TO MB02-ZIP-CODE-USE-LP-A
023400                                    MB02-ZIP-CODE-USE-RP-A
023500             SET WS-UPDATE-SW-YES
023600                                 TO TRUE
023700         ELSE
023800             MOVE DFHBMUBF       TO MB02-ZIP-CODE-USE-A
023900             MOVE DFHBMASB       TO MB02-ZIP-CODE-USE-LP-A
024000                                    MB02-ZIP-CODE-USE-RP-A
024100             MOVE SS08WS-CURSOR  TO MB02-ZIP-CODE-USE-L
024200             SET SS08WS-ERROR-SW-YES TO TRUE.
024300*
024400* ************************************************************ *
024500*        ZIP CODE IND                                          *
024600* ************************************************************ *
024700*
024800     IF  MB02-ZIP-CODE-IND-L IS LESS THAN 1
024900         MOVE MMBC-POSTAL-CODE-IND
025000                                 TO MB02-ZIP-CODE-IND
025100         MOVE DFHBMASK           TO MB02-ZIP-CODE-IND-A
025200         MOVE DFHBMDAS           TO MB02-ZIP-CODE-IND-LP-A
025300                                    MB02-ZIP-CODE-IND-RP-A
025400     ELSE
025500         IF  MB02-VALID-ZIP-CODE-IND
025600             MOVE DFHBMASF       TO MB02-ZIP-CODE-IND-A
025700             MOVE DFHBMDAS       TO MB02-ZIP-CODE-IND-LP-A
025800                                    MB02-ZIP-CODE-IND-RP-A
025900             SET WS-UPDATE-SW-YES
026000                                 TO TRUE
026100         ELSE
026200             MOVE DFHBMUBF       TO MB02-ZIP-CODE-IND-A
026300             MOVE DFHBMASB       TO MB02-ZIP-CODE-IND-LP-A
026400                                    MB02-ZIP-CODE-IND-RP-A
026500             MOVE SS08WS-CURSOR  TO MB02-ZIP-CODE-IND-L
026600             SET SS08WS-ERROR-SW-YES TO TRUE.
026700*
026800* ************************************************************ *
026900*        ZIP CODE DATA                                         *
027000* ************************************************************ *
027100*
027200     PERFORM
027300         VARYING X-ZIP-CODE
027400         FROM 1 BY 1
027500         UNTIL X-ZIP-CODE IS GREATER THAN 18
027600         SET X-MMBC-POSTAL-CODE  TO X-ZIP-CODE
027700         IF  MB02-ZIP-CODE-L (X-ZIP-CODE) IS LESS THAN 1
027800             MOVE MMBC-POSTAL-CODE (X-MMBC-POSTAL-CODE)
027900                                 TO MB02-ZIP-CODE
028000                                    (X-ZIP-CODE)
028100             MOVE DFHBMASK       TO MB02-ZIP-CODE-A
028200                                    (X-ZIP-CODE)
028300             MOVE DFHBMDAS       TO MB02-ZIP-CODE-LP-A
028400                                    (X-ZIP-CODE)
028500                                    MB02-ZIP-CODE-RP-A
028600                                    (X-ZIP-CODE)
028700         ELSE
028800             MOVE DFHBMASF       TO MB02-ZIP-CODE-A
028900                                    (X-ZIP-CODE)
029000             MOVE DFHBMDAS       TO MB02-ZIP-CODE-LP-A
029100                                    (X-ZIP-CODE)
029200                                    MB02-ZIP-CODE-RP-A
029300                                    (X-ZIP-CODE)
029400             SET WS-UPDATE-SW-YES
029500                                 TO TRUE
029600         END-IF
029700      END-PERFORM.
029800*
029900*
030000 2300-CONTINUE.
030100*
030200     IF  SS08WS-ERROR-SW-NO
030300         GO TO 2400-UPDATE-FILE.
030400*
030500****************************************************************
030600*    SEND THE MAP                                              *
030700****************************************************************
030800*
030900     PERFORM MB60PD-INIT-STD-MAP-LINES
031000                                 THRU MB60PD-ISML-EXIT.
031100     MOVE 'BM03'                 TO MBCA-PROGRAM-LOCATION.
031200     PERFORM MB60PD-SEND-MAP-DATA-ONLY
031300                                 THRU MB60PD-SMDO-EXIT.
031400*
031500****************************************************************
031600*    RETURN TO CICS                                            *
031700****************************************************************
031800*
031900     MOVE 'PC04'                 TO MBCA-PROGRAM-LOCATION.
032000     MOVE 02                     TO MBCA-SCREEN-NBR.
032100     PERFORM MB70PD-RETURN-TRANS-ID
032200                                 THRU MB70PD-RTI-EXIT.
032300/
032400 2400-UPDATE-FILE.
032500*
032600     IF  MBCA-PTI-FUNCTION-IS-ADD
032700         NEXT SENTENCE
032800     ELSE
032900         IF  WS-UPDATE-SW-NO
033000             GO TO 2600-SETUP-COMMAREA.
033100*
033200****************************************************************
033300*    GETMAIN FOR LOG/JOURNAL RECORD                            *
033400****************************************************************
033500*
033600     MOVE 'SC02'                 TO MBCA-PROGRAM-LOCATION.
033700     SET MBIORO-GETMAIN          TO TRUE.
033800     PERFORM MML1AO-ACCESS       THRU MML1AO-ACCESS-EXIT.
033900*
034000* ************************************************************ *
034100*            READ BAR CODE FOR UPDATE                          *
034200* ************************************************************ *
034300*
034400     MOVE 'FC03'                 TO MBCA-PROGRAM-LOCATION.
034500     MOVE MBCA-MERCHANT-ORG      TO MBIOWS-MMBC-ORG.
034600     MOVE MBCA-INSERT-NBR        TO MBIOWS-MMBC-INSERT-NBR.
034700     SET MBIORO-READ-RANDOM-UPDATE
034800                                 TO TRUE
034900     PERFORM MMBCAO-ACCESS       THRU MMBCAO-ACCESS-EXIT.
035000*
035100*************************************************
035200*    SET UP THE COMMON PORTION OF THE RECORD    *
035300*************************************************
035400*
035500     MOVE 'BC'                   TO MML1-FILE-CODE.
035600     MOVE MBCA-MERCHANT-ORG      TO MML1-MMBC-ORG.
035700     MOVE MBCA-INSERT-NBR        TO MML1-MMBC-INSERT-NBR.
035800     MOVE MBCA-SIGNON-NAME       TO MML1-SIGNON-NAME.
035900     MOVE MBCA-TERMINAL-ID       TO MML1-TERMINAL-ID.
036000     MOVE ZEROS                  TO MML1-SOURCE-CODE.
036100*
036200 2410-UPDATE-FIELDS.
036300*
036400*
036500* ************************************************************ *
036600*        ZIP CODE USE                                          *
036700* ************************************************************ *
036800*
036900     IF  MB02-ZIP-CODE-USE-L IS GREATER THAN ZEROS
037000         MOVE ZEROS              TO MML1-FIELD-OCCURRENCE
037100         MOVE 0204               TO MML1-FIELD-CODE
037200         MOVE MML1WS-VL-01       TO MML1-VARIABLE-LENGTH
037300         MOVE MMBC-POSTAL-CODE-USE TO MML1-VL01-B-DATA-X
037400         MOVE MB02-ZIP-CODE-USE  TO MMBC-POSTAL-CODE-USE
037500         MOVE MMBC-POSTAL-CODE-USE
037600                                 TO MML1-VL01-A-DATA-X
037700         PERFORM 9050-CREATE-MAINT-RECORD
037800                                 THRU 9099-CMR-EXIT.
037900*
038000* ************************************************************ *
038100*        ZIP CODE IND                                          *
038200* ************************************************************ *
038300*
038400     IF  MB02-ZIP-CODE-IND-L IS GREATER THAN ZEROS
038500         MOVE ZEROS              TO MML1-FIELD-OCCURRENCE
038600         MOVE 0205               TO MML1-FIELD-CODE
038700         MOVE MML1WS-VL-01       TO MML1-VARIABLE-LENGTH
038800         MOVE MMBC-POSTAL-CODE-IND TO MML1-VL01-B-DATA-X
038900         MOVE MB02-ZIP-CODE-IND  TO MMBC-POSTAL-CODE-IND
039000         MOVE MMBC-POSTAL-CODE-IND TO MML1-VL01-A-DATA-X
039100         PERFORM 9050-CREATE-MAINT-RECORD
039200                                 THRU 9099-CMR-EXIT.
039300*
039400* ************************************************************ *
039500*        ZIP CODE DATA                                         *
039600* ************************************************************ *
039700*
039800     PERFORM
039900         VARYING X-ZIP-CODE
040000         FROM 1 BY 1
040100         UNTIL X-ZIP-CODE IS GREATER THAN 18
040200         SET X-MMBC-POSTAL-CODE  TO X-ZIP-CODE
040300         IF  MB02-ZIP-CODE-L (X-ZIP-CODE)
040400             IS GREATER THAN ZEROS
040500             SET MML1-FIELD-OCCURRENCE
040600                                 TO X-ZIP-CODE
040700             MOVE 0206           TO MML1-FIELD-CODE
040800             MOVE MML1WS-VL-10   TO MML1-VARIABLE-LENGTH
040900             MOVE MMBC-POSTAL-CODE (X-MMBC-POSTAL-CODE)
041000                                 TO MML1-VL10-B-DATA-X
041100             MOVE MB02-ZIP-CODE (X-ZIP-CODE)
041200                                 TO MMBC-POSTAL-CODE
041300                                    (X-MMBC-POSTAL-CODE)
041400             MOVE MMBC-POSTAL-CODE (X-MMBC-POSTAL-CODE)
041500                                 TO MML1-VL10-A-DATA-X
041600             PERFORM 9050-CREATE-MAINT-RECORD
041700                                 THRU 9099-CMR-EXIT
041800         END-IF
041900     END-PERFORM.
042000*
042100     IF  MBCA-PTI-FUNCTION-IS-ADD
042200         GO TO 2500-REWRITE-BAR-CODE.
042300*
042400*            ***** LAST MAINT DATE AND OPERATOR ID *****       *
042500*
042600     MOVE ZEROES                 TO MML1-FIELD-OCCURRENCE.
042700     MOVE 0199                   TO MML1-FIELD-CODE.
042800     MOVE MML1WS-VL-07           TO MML1-VARIABLE-LENGTH.
042900     MOVE MMBC-LAST-MAINT-DATE   TO MML1-VL07-B-DATA-9.
043000     MOVE MBCA-START-DATE        TO MMBC-LAST-MAINT-DATE.
043100     MOVE MMBC-LAST-MAINT-DATE   TO MML1-VL07-A-DATA-9.
043200     PERFORM 9050-CREATE-MAINT-RECORD
043300                                 THRU 9099-CMR-EXIT.
043400     MOVE 0198                   TO MML1-FIELD-CODE.
043500     MOVE MML1WS-VL-03           TO MML1-VARIABLE-LENGTH.
043600     MOVE MMBC-LAST-MAINT-OPER   TO MML1-VL03-B-DATA-X.
043700     MOVE MBCA-OPERATOR-ID       TO MMBC-LAST-MAINT-OPER.
043800     MOVE MMBC-LAST-MAINT-OPER   TO MML1-VL03-A-DATA-X.
043900     PERFORM 9050-CREATE-MAINT-RECORD
044000                                 THRU 9099-CMR-EXIT.
044100*
044200*
044300 2500-REWRITE-BAR-CODE.
044400*
044500     IF  MBCA-PTI-FUNCTION-IS-ADD
044600         SET MMBC-ADD-COMPLETED  TO TRUE
044700         SET MMBC-REC-ACTIVE     TO TRUE
044800         MOVE ZEROES             TO MML1-FIELD-CODE
044900         MOVE LENGTH OF MMBC-RECORD
045000                                 TO MML1-VARIABLE-LENGTH
045100         MOVE MMBC-RECORD        TO MML1-ADD-AREA
045200         MOVE 'FC04'             TO MBCA-PROGRAM-LOCATION
045300         SET MBIORO-WRITE        TO TRUE
045400         PERFORM MML1AO-ACCESS   THRU MML1AO-ACCESS-EXIT.
045500*
045600     MOVE MBCA-MERCHANT-ORG      TO MMBC-ORG.
045700     MOVE MBCA-INSERT-NBR        TO MMBC-INSERT-NBR.
045800     MOVE 'FC05'                 TO MBCA-PROGRAM-LOCATION.
045900     SET MBIORO-REWRITE          TO TRUE.
046000     PERFORM MMBCAO-ACCESS       THRU MMBCAO-ACCESS-EXIT.
046100*
046200 2600-SETUP-COMMAREA.
046300*
046400* ************************************************************ *
046500*  SET UP THE COMM AREA FIELDS AND TRANSFER TO THE NEXT PROGRAM*
046600* ************************************************************ *
046700*
046800     PERFORM MB60PD-EDIT-PAGE-NBR
046900                                 THRU MB60PD-EPN-EXIT.
047000*
047100     MOVE MBCA-EIBAID            TO SS08WS-EIBAID.
047200*
047300     IF  SS08WS-VALID-PF-KEY OR
047400         SS08WS-EIBAID-VALID-PF-KEY
047500         SET MBCA-INITIAL-SCREEN-NBR
047600                                 TO TRUE.
047700*
047800     PERFORM MB70PD-XCTL-TO-MBOXCTL
047900                                 THRU MB70PD-XTM-EXIT.
048000*
048100*
048200 9000-PERFORMED-ROUTINES-SECT SECTION.
048300*
048400 9050-CREATE-MAINT-RECORD.
048500*
048600*****************************************************************
048700*    THIS ROUTINE WILL CREATE THE COMMON DATA FOR ALL OF THE    *
048800*    LOG/JOURNAL TRANSACTIONS                                   *
048900*****************************************************************
049000*
049100     IF  MBCA-PTI-FUNCTION-IS-ADD
049200         GO TO 9099-CMR-EXIT.
049300*
049400     MOVE 'BC'                   TO MML1-FILE-CODE.
049500     MOVE MBCA-MERCHANT-ORG      TO MML1-MMBC-ORG.
049600     MOVE MBCA-INSERT-NBR        TO MML1-MMBC-INSERT-NBR.
049700     MOVE MBCA-SIGNON-NAME       TO MML1-SIGNON-NAME.
049800     MOVE MBCA-TERMINAL-ID       TO MML1-TERMINAL-ID.
049900     MOVE ZEROES                 TO MML1-SOURCE-CODE
050000                                    MML1-FIELD-OCCURRENCE-2.
050100*
050200*****************************************************************
050300*    WRITE THE LOG/JOURNAL FILE RECORD                          *
050400*****************************************************************
050500*
050600     MOVE 'FC06'                 TO MBCA-PROGRAM-LOCATION.
050700     SET MBIORO-WRITE            TO TRUE.
050800     PERFORM MML1AO-ACCESS       THRU MML1AO-ACCESS-EXIT.
050900     MOVE SPACES                 TO MML1-VARIABLE-AREA.
051000*
051100 9099-CMR-EXIT.
051200     EXIT.
051300*
051400     COPY SS15PD.
051500/
051600     COPY SS05PD.
051700/
051800     COPY SS07PD.
051900/
052000     COPY SS08PD.
052100/
052200     COPY SS26PD.
052300/
052400     COPY SS27PD.
052500/
052600     COPY MMBCAO.
052700/
052800     COPY MML1AO.
052900/
053000     COPY MB60PD REPLACING 'MBMAPXX' BY 'MBMB02 '
053100                          MBMAPXXO BY MBMB02O
053200                          MBMAPXXI BY MBMB02I.
053300/
053400     COPY MB70PD.
053500/
053600     COPY SMFTPXO.
