000100 IDENTIFICATION DIVISION.
000200 PROGRAM-ID. MBOMC00.
000201*       RELEASE DATE=08/24/01.        REVISION LEVEL=08.06      *
000202*****************************************************************
000203*WARNING.  THIS COMPUTER PROGRAM IS PROTECTED BY COPYRIGHT LAW  *
000204*AND INTERNATIONAL TREATIES.  UNAUTHORIZED REPRODUCTION OR      *
000205*DISTRIBUTION OF THIS PROGRAM, OR ANY PORTION OF IT, MAY RESULT *
000206*IN SEVERE CIVIL AND CRIMINAL PENATLIES, AND WILL BE PROSECUTED *
000207*TO THE MAXIMUM EXTENT POSSIBLE UNDER THE LAW.                  *
000208*COPYRIGHT 1999 PAYSYS INTERNATIONAL, INC.  ALL RIGHTS RESERVED.*
000209*****************************************************************
000300*****************************************************************
000400*                                                               *
000500*   V - PLUS  M E R C H A N T   B A N K C A R D   S Y S T E M   *
000600*                                                               *
000700*      MBOMC00 - MERCH CHAIN DEFINITION ADD/MAINT/INQ           *
000800*                LOCATE SCREEN 00                               *
000900*                                                               *
001000*              1. TRANSIDS                                      *
001100*                 A. MBAC                                       *
001200*                 B. MBMC                                       *
001300*                 C. MBQC                                       *
001400*              2. MAPS USED -                                   *
001500*                 A. MBMC00 (LOCATE MAP)                        *
001600*              3. FILES USED -                                  *
001700*                 A. MMOC (ORG CONTROL FILE)                    *
001800*                 B. MMRC (MERCHANT RELATIONSHIP CONTROL)       *
001900*                 C. MMRD (MERCHANT RELATIONSHIP DETAIL)        *
002000*                                                               *
002100*****************************************************************
002200*
002300 ENVIRONMENT DIVISION.
002400*
002500 DATA DIVISION.
002600*
002700 WORKING-STORAGE SECTION.
002800*
002900 01  FILLER                  PIC  X(12)      VALUE
003000     '** WS-BEG **'.
003100*
003200 01  FILLER                  PIC  X(14)      VALUE
003300     'MISCELLANEOUS:'.
003400*
003500 01  WS-MISCELLANEOUS.
003600     03  WS-ORG-LOW          PIC S9(03)      COMP-3
003700                                             VALUE +001.
003800     03  WS-ORG-HIGH         PIC S9(03)      COMP-3
003900                                             VALUE +998.
004000     03  WS-COPY-SW          PIC  X(01)      VALUE 'N'.
004100         88  WS-COPY-SW-NO                   VALUE 'N'.
004200         88  WS-COPY-SW-YES                  VALUE 'Y'.
004300     03  TS-QUEUE-NAME.
004400         05  TS-QN-TERMID    PIC  X(04)      VALUE SPACES.
004500         05  TS-QN-TRANID    PIC  X(04)      VALUE 'MBUI'.
004600/
004700 01  FILLER                  PIC  X(29)      VALUE
004800     'I/O REQUEST BLOCK WORK AREAS:'.
004900*
005000     COPY MBIOWS.
005100/
005200 01  FILLER                  PIC  X(18)      VALUE
005300     'I/O REQUEST BLOCK:'.
005400*
005500     COPY MBIORO.
005600/
005700 01  FILLER                  PIC  X(21)      VALUE
005800     'ERROR MESSAGES TABLE:'.
005900*
006000     COPY MBEMWS.
006100/
006200 01  FILLER                  PIC  X(42)      VALUE
006300     'MERCH RELATION CONTROL INITIALIZER RECORD:'.
006400*
006500     COPY MMRCIR.
006600/
006700 01  FILLER                  PIC  X(41)      VALUE
006800     'MERCH RELATION DETAIL INITIALIZER RECORD:'.
006900*
007000     COPY MMRDIR REPLACING ==:MMRD:== BY ==MMRD==.
007100/
007200 01  FILLER                  PIC  X(20)      VALUE
007300     'CCS DATE WORK AREAS:'.
007400*
007500     COPY SS01WS.
007600/
007700 01  FILLER                  PIC  X(15)      VALUE
007800     'CCS WORK AREAS:'.
007900*
008000     COPY SS08WS.
008100/
008200     COPY SS00WS.
008300/
008400     COPY SMFTWS.
008500/
008600     COPY SMPTRL REPLACING ==:SMPT:== BY ==SMPT==.
008700/
008800     COPY MB61LK.
008900/
009000 01  FILLER                  PIC  X(12)      VALUE
009100     '** WS-END **'.
009200/
009300 LINKAGE SECTION.
009400*
009500 01  DFHCOMMAREA.
009600*
009700     COPY MB60WS.
009800/
009900******************************************
010000*    MERCHANT RELATIONSHIP LOCATE MAP    *
010100******************************************
010200*
010300     COPY MBMC00.
010400/
010500*******************************************************
010600*    MERCHANT RELATIONSHIP LOCATE MAP REDEFINITION    *
010700*******************************************************
010800*
010900     COPY MBMC00R.
011000/
011100***************************
011200*    ORG RECORD LAYOUT    *
011300***************************
011400*
011500     COPY MMOCRL.
011600/
011700*****************************************************
011800*    MERCHANT RELATIONSHIP CONTROL RECORD LAYOUT    *
011900*****************************************************
012000*
012100     COPY MMRCRL.
012200/
012300****************************************************
012400*    MERCHANT RELATIONSHIP DETAIL RECORD LAYOUT    *
012500****************************************************
012600*
012700     COPY MMRDRL REPLACING ==:MMRD:== BY ==MMRD==.
012800/
012900***************************************
013000*    USER INPUT TEMP STORAGE RECORD   *
013100***************************************
013200*
013300     COPY MBUITS.
013400/
013500 PROCEDURE DIVISION.
013600*
013700 A000-HOUSEKEEPING SECTION.
013800*
013900 A020-INIT.
014000*
014100     MOVE 'PC01'                 TO MBCA-PROGRAM-LOCATION.
014200     PERFORM MB70PD-ON-LINE-HOUSEKEEPING
014300                                 THRU MB70PD-OLH-EXIT.
014400*
014500     IF  MBCA-MBUI-UI-YES
014600         NEXT SENTENCE
014700     ELSE
014800         SET MBCA-MBUI-UI-NO     TO TRUE.
014900*
015000     MOVE MBCA-TERMINAL-ID       TO TS-QN-TERMID.
015100*
015200     IF  MBCA-RECEIVE-SCREEN
015300         GO TO C000-RECEIVE-SCREEN.
015400/
015500 B000-SEND-SCREEN SECTION.
015600*
015700*********************************************
015800*    GET CICS STORAGE NEEDED FOR THE MAP    *
015900*********************************************
016000*
016100     MOVE 'SC01'                 TO MBCA-PROGRAM-LOCATION.
016200     PERFORM MB60PD-GETMAIN-FOR-MAP
016300                                 THRU MB60PD-GFM-EXIT.
016400*
016500*****************************************************************
016600*    CHECK KEY CODES                                            *
016700* 1. IF ADD FUNCTION, BYPASS CHECK OF KEY CODES.                *
016800* 2. IF INITIAL KEY CODE, BYPASS CHECK OF KEY CODES.            *
016900* 3. IF MMRC KEY CODE, IT MUST HAVE AN ORGANIZATION NUMBER      *
017000*    GREATER THAN ZERO AND A VALID CHAIN.    IF                 *
017100*    DIRECT, GO TO THE RECEIVE EDITING ROUTINE SINCE WE HAVE    *
017200*    PLUGGED THE ORGANIZATION AND CHAIN IN THE MAP.    IF AN    *
017300*    ERROR OCCURS IN THE RECEIVE SCREEN ROUTINE, IT WILL        *
017400*    HANDLE BUILDING THE MAP AND IT WILL SEND ITS OWN SCREEN.   *
017500*    THIS IS WHY LOCATE PROGRAMS ALWAYS SEND WITH ERASE         *
017600*    NO MATTER WHICH ROUTINE YOU ARE IN.  IF NOT DIRECT, PLUG   *
017700*    THE ORGANIZATION AND CHAIN INTO THE MAP AND BYPASS         *
017800*    ANY OTHER CHECKING OF THE KEY CODE.                        *
017900* 4. IF 2 AND 3 ARE FALSE, SEE IF THE MBCA-MERCHANT-ORG IS      *
018000*    GREATER THAN ZERO.  IF IT IS, PLUG IT INTO THE MAP.  IF    *
018100*    THE MBCA-CHAIN IS GREATER THAN LOW-VALUE, PLUG IT INTO     *
018200*    THE MAP.                                                   *
018300*****************************************************************
018400*
018500     IF  MBCA-INITIAL-KEY-CODE
018600     OR  MBCA-PTI-FUNCTION-IS-ADD
018700         GO TO B020-BUILD-SCREEN.
018800*
018900     IF  MBCA-MMRC-KEY-CODE
019000         IF  MBCA-MERCHANT-ORG IS GREATER THAN ZERO
019100         AND MBCA-CHAIN         IS GREATER THAN LOW-VALUE
019200             MOVE MBCA-MERCHANT-ORG
019300                                 TO MC00-ORG
019400             MOVE MBCA-CHAIN     TO MC00-CHAIN
019500             MOVE DFHBMUNF       TO MC00-ORG-A
019600                                    MC00-CHAIN-A
019700             IF  MBCA-DIRECT-TRANSFER-CODE
019800             AND MBCA-INITIAL-SCREEN-NBR
019900                 MOVE 00         TO MBCA-SCREEN-NBR
020000                 GO TO C082-READ-ORG
020100             ELSE
020200                 GO TO B020-BUILD-SCREEN.
020300*
020400     IF  MBCA-VALID-KEY-CODES
020500         IF  MBCA-MERCHANT-ORG IS GREATER THAN ZERO
020600             MOVE MBCA-MERCHANT-ORG
020700                                 TO MC00-ORG
020800             MOVE DFHBMUNF       TO MC00-ORG-A
020900             IF  MBCA-CHAIN IS GREATER THAN LOW-VALUE
021000                 MOVE MBCA-CHAIN
021100                                 TO MC00-CHAIN
021200                 MOVE DFHBMUNF   TO MC00-CHAIN-A.
021300*
021400 B020-BUILD-SCREEN.
021500*
021600*******************************************
021700*    INITIALIZE THE STANDARD MAP LINES    *
021800*******************************************
021900*
022000     MOVE SS08WS-CURSOR          TO MC00-ORG-L.
022100     MOVE 00                     TO MBCA-SCREEN-NBR.
022200     PERFORM MB60PD-INIT-STD-MAP-LINES
022300                                 THRU MB60PD-ISML-EXIT.
022400*
022500     IF  MBCA-PTI-FUNCTION-MAINT-OR-INQ
022600         MOVE DFHBMDAS           TO MC00-COPY-ORG-LIT-A
022700                                    MC00-COPY-ORG-LP-A
022800                                    MC00-COPY-ORG-RP-A
022900                                    MC00-COPY-CHAIN-LIT-A
023000                                    MC00-COPY-CHAIN-LP-A
023100                                    MC00-COPY-CHAIN-RP-A
023200         MOVE DFHBMASK           TO MC00-COPY-ORG-A
023300                                    MC00-COPY-CHAIN-A
023400         IF  MBCA-MERCHANT-ORG IS GREATER THAN ZEROS
023500             MOVE MBCA-MERCHANT-ORG
023600                                 TO MC00-ORG
023700             MOVE DFHBMUNF       TO MC00-ORG-A
023800             IF  MBCA-CHAIN IS GREATER THAN ZEROS
023900                 MOVE MBCA-CHAIN TO MC00-CHAIN
024000                 MOVE DFHBMUNF   TO MC00-CHAIN-A.
024100*
024200**********************
024300*    SEND THE MAP    *
024400**********************
024500*
024600     MOVE 'BM01'                 TO MBCA-PROGRAM-LOCATION.
024700     PERFORM MB60PD-SEND-MAP-WITH-ERASE
024800                                 THRU MB60PD-SMWE-EXIT.
024900*
025000************************
025100*    RETURN TO CICS    *
025200************************
025300*
025400     MOVE 'PC02'                 TO MBCA-PROGRAM-LOCATION.
025500     PERFORM MB70PD-RETURN-TRANS-ID
025600                                 THRU MB70PD-RTI-EXIT.
025700/
025800 C000-RECEIVE-SCREEN SECTION.
025900*
026000*************************************************
026100*    THIS SECTION RECEIVES THE LOCATE SCREEN    *
026200*************************************************
026300*
026400     IF  MBCA-MBUI-UI-YES
026500*
026600****************************************************************
026700*    ACQUIRE MAIN STORAGE FOR TEMP STORAGE RECORD              *
026800****************************************************************
026900*
027000         MOVE 'TS01'             TO MBCA-PROGRAM-LOCATION
027100         EXEC CICS GETMAIN
027200                   FLENGTH (LENGTH  OF MBUITS-RECORD)
027300
027400                   SET     (ADDRESS OF MBUITS-RECORD)
027500
027600              END-EXEC
027700*
027800*
027900***********************************************
028000*    READ THE TEMP STORAGE RECORD             *
028100***********************************************
028200*
028300         MOVE 'TS02'             TO MBCA-PROGRAM-LOCATION
028400*
028500         EXEC CICS READQ TS
028600                   QUEUE   (TS-QUEUE-NAME)
028700                   INTO    (MBUITS-RECORD)
028800                   LENGTH  (LENGTH  OF MBUITS-RECORD)
028900                   ITEM    (1)
029000              END-EXEC
029100*
029200***********************************************
029300*    DELETE THE TEMP STORAGE RECORD           *
029400***********************************************
029500*
029600         MOVE 'TS03'             TO MBCA-PROGRAM-LOCATION
029700*
029800         EXEC CICS IGNORE CONDITION
029900                   QIDERR
030000              END-EXEC
030100*
030200         EXEC CICS DELETEQ TS
030300                   QUEUE  (TS-QUEUE-NAME)
030400              END-EXEC
030500         MOVE 'SC02'             TO MBCA-PROGRAM-LOCATION
030600         PERFORM MB60PD-GETMAIN-FOR-MAP
030700                                 THRU MB60PD-GFM-EXIT
030800         MOVE MBUITS-VAR-DATA    TO MBMC00I
030900     ELSE
031000         MOVE 'BM02'             TO MBCA-PROGRAM-LOCATION
031100         PERFORM MB60PD-RECEIVE-MAP
031200                                 THRU MB60PD-RM-EXIT.
031300*
031400**************************************************************
031500*    CHECK FOR ANOTHER TRANSACTION ID ENTERED BY THE USER    *
031600**************************************************************
031700*
031800     MOVE 'PC03'                 TO MBCA-PROGRAM-LOCATION.
031900     PERFORM MB60PD-NEW-TRANS-ROUTINE
032000                                 THRU MB60PD-NTR-EXIT.
032100*
032200 C020-EDIT-SCREEN.
032300*
032400     SET SS08WS-ERROR-SW-NO      TO TRUE.
032500     MOVE MBCA-EIBAID            TO SS08WS-EIBAID.
032600*
032700     IF  (MC00-ORG-L IS LESS THAN 1
032800     AND  MC00-CHAIN-L IS LESS THAN 1
032900     AND  MC00-COPY-ORG-L IS LESS THAN 1
033000     AND  MC00-COPY-CHAIN-L IS LESS THAN 1)
033100     AND (SS08WS-VALID-PF-KEY
033200     OR   SS08WS-EIBAID-VALID-PF-KEY)
033300         SET MBCA-INITIAL-SCREEN-NBR
033400                                 TO TRUE
033500         GO TO F090-TRANSFER-XCTL.
033600*
033700******************************************************
033800*    RESET THE FIELD ARRIBUTES TO THEIR NORMAL       *
033900*    PRIOR STATE PRIOR TO ANY EDITING BEING DONE.    *
034000******************************************************
034100*
034200     MOVE DFHBMUNN               TO MC00-ORG-A
034300                                    MC00-CHAIN-A.
034400     MOVE DFHBMASK               TO MC00-ORG-LP-A
034500                                    MC00-ORG-RP-A
034600                                    MC00-CHAIN-LP-A
034700                                    MC00-CHAIN-RP-A.
034800*
034900     IF  MBCA-PTI-FUNCTION-IS-ADD
035000         MOVE DFHBMUNN           TO MC00-COPY-ORG-A
035100                                    MC00-COPY-CHAIN-A
035200         MOVE DFHBMASK           TO MC00-COPY-ORG-LP-A
035300                                    MC00-COPY-ORG-RP-A
035400                                    MC00-COPY-CHAIN-LP-A
035500                                    MC00-COPY-CHAIN-RP-A
035600     ELSE
035700         GO TO C080-EDIT-ORG.
035800*
035900************************************************
036000*    BYPASS THE COPY EDITS IF NEITHER THE      *
036100*    COPY ORG OR COPY CHAIN WERE ENTERED.      *
036200************************************************
036300*
036400     IF  MC00-COPY-ORG-L IS EQUAL TO ZERO
036500     AND MC00-COPY-CHAIN-L IS EQUAL TO ZERO
036600         GO TO C080-EDIT-ORG.
036700*
036800 C040-EDIT-COPY-ORG.
036900*
037000     IF  MC00-COPY-ORG-L IS EQUAL TO ZERO
037100     OR  MC00-COPY-ORG IS NOT NUMERIC
037200     OR  MC00-COPY-ORG IS LESS THAN MBCA-ORG-LOW
037300     OR  MC00-COPY-ORG IS GREATER THAN MBCA-ORG-HIGH
037400     OR  MC00-COPY-ORG IS LESS THAN WS-ORG-LOW
037500     OR  MC00-COPY-ORG IS GREATER THAN WS-ORG-HIGH
037600         MOVE MBEMWS-INVALID-ORG TO MC00-ERR-MESSAGE
037700         GO TO C058-COPY-ORG-ERROR.
037800*
037900************************************************
038000*    READ THE COPY ORGANIZATION RECORD.  IT    *
038100*    MUST BE ON FILE AND AN ACTIVE RECORD.     *
038200************************************************
038300*
038400     MOVE MC00-COPY-ORG          TO MBIOWS-MMOC-ORG.
038500     MOVE SS08WS-CICS-FC-NOTFND  TO MBIORO-TEMP-STATUS-1.
038600     MOVE 'FC01'                 TO MBCA-PROGRAM-LOCATION.
038700     SET MBIORO-READ-RANDOM      TO TRUE.
038800     PERFORM MMOCAO-ACCESS       THRU MMOCAO-ACCESS-EXIT.
038900*
039000     IF  SS08WS-RC-FC-NOTFND
039100         MOVE MBEMWS-NOT-ON-FILE TO MC00-ERR-MESSAGE
039200     ELSE
039300         IF  MMOC-ADD-PENDING
039400             MOVE MBEMWS-ADD-PENDING
039500                                 TO MC00-ERR-MESSAGE
039600         ELSE
039700             IF  MMOC-REC-PURGED
039800                 MOVE MBEMWS-REC-PURGED
039900                                 TO MC00-ERR-MESSAGE
040000             ELSE
040100                 MOVE DFHBMUNF   TO MC00-COPY-ORG-A
040200                 GO TO C060-EDIT-COPY-CHAIN.
040300*
040400 C058-COPY-ORG-ERROR.
040500*
040600     SET SS08WS-ERROR-SW-YES     TO TRUE.
040700     MOVE DFHBMASB               TO MC00-COPY-ORG-LP-A
040800                                    MC00-COPY-ORG-RP-A.
040900     MOVE SS08WS-CURSOR          TO MC00-COPY-ORG-L.
041000     MOVE DFHBMNBF               TO MC00-COPY-ORG-A.
041100     MOVE DFHBMUNF               TO MC00-ORG-A
041200                                    MC00-COPY-CHAIN-A
041300                                    MC00-CHAIN-A.
041400     GO TO D000-RETURN-ERRORS.
041500*
041600 C060-EDIT-COPY-CHAIN.
041700*
041800***********************************************************
041900*    THE LENGTH FIELD COULD BE CHECKED HERE TO            *
042000*    SEE IF ANYTHING WAS KEYED.                           *
042100***********************************************************
042200*
042300     IF  MC00-COPY-CHAIN IS EQUAL ZEROS
042400         MOVE MBEMWS-INVALID-CHAIN
042500                                 TO MC00-ERR-MESSAGE
042600         GO TO C078-COPY-CHAIN-ERROR.
042700*
042800*****************************************************************
042900*    READ THE MERCH RELATIONSHIP FILE TO ENSURE THAT THE CHAIN  *
043000*    TO BE COPIED IS ON FILE AND AN ACTIVE RECORD.              *
043100*****************************************************************
043200*
043300     MOVE MC00-COPY-ORG          TO MBIOWS-MMRC-ORG.
043400     MOVE MC00-COPY-CHAIN        TO MBIOWS-MMRC-CHAIN.
043500     MOVE SS08WS-CICS-FC-NOTFND  TO MBIORO-TEMP-STATUS-1.
043600     MOVE 'FC02'                 TO MBCA-PROGRAM-LOCATION.
043700     SET MBIORO-READ-RANDOM      TO TRUE.
043800     PERFORM MMRCAO-ACCESS       THRU MMRCAO-ACCESS-EXIT.
043900*
044000     IF  SS08WS-RC-FC-NOTFND
044100         MOVE MBEMWS-NOT-ON-FILE TO MC00-ERR-MESSAGE
044200     ELSE
044300         IF  MMRC-ADD-PENDING
044400             MOVE MBEMWS-ADD-PENDING
044500                                 TO MC00-ERR-MESSAGE
044600         ELSE
044700             IF  MMRC-REC-PURGED
044800                 MOVE MBEMWS-REC-PURGED
044900                                 TO MC00-ERR-MESSAGE
045000             ELSE
045100                 SET WS-COPY-SW-YES
045200                                 TO TRUE
045300                 MOVE DFHBMUNF   TO MC00-COPY-CHAIN-A
045400                 GO TO C080-EDIT-ORG.
045500*
045600 C078-COPY-CHAIN-ERROR.
045700*
045800     SET SS08WS-ERROR-SW-YES     TO TRUE.
045900     MOVE DFHBMASB               TO MC00-COPY-CHAIN-LP-A
046000                                    MC00-COPY-CHAIN-RP-A.
046100     MOVE SS08WS-CURSOR          TO MC00-COPY-CHAIN-L.
046200     MOVE DFHBMUNF               TO MC00-COPY-CHAIN-A
046300                                    MC00-ORG-A
046400                                    MC00-CHAIN-A.
046500     GO TO D000-RETURN-ERRORS.
046600*
046700 C080-EDIT-ORG.
046800*
046900     IF  MC00-ORG-L IS EQUAL TO ZERO
047000     OR  MC00-ORG IS NOT NUMERIC
047100     OR  MC00-ORG IS LESS THAN MBCA-ORG-LOW
047200     OR  MC00-ORG IS GREATER THAN MBCA-ORG-HIGH
047300     OR  MC00-ORG IS LESS THAN WS-ORG-LOW
047400     OR  MC00-ORG IS GREATER THAN WS-ORG-HIGH
047500         MOVE MBEMWS-INVALID-ORG TO MC00-ERR-MESSAGE
047600         GO TO C098-ORG-ERROR.
047700*
047800 C082-READ-ORG.
047900*
048000************************************************
048100*    READ THE ORGANIZATION RECORD.  IT MUST    *
048200*    BE ON FILE AND AN ACTIVE RECORD.          *
048300************************************************
048400*
048500     MOVE MC00-ORG               TO MBIOWS-MMOC-ORG.
048600     MOVE 'FC03'                 TO MBCA-PROGRAM-LOCATION.
048700     MOVE SS08WS-CICS-FC-NOTFND  TO MBIORO-TEMP-STATUS-1.
048800     SET MBIORO-READ-RANDOM      TO TRUE.
048900     PERFORM MMOCAO-ACCESS       THRU MMOCAO-ACCESS-EXIT.
049000*
049100     IF  SS08WS-RC-FC-NOTFND
049200         MOVE MBEMWS-NOT-ON-FILE TO MC00-ERR-MESSAGE
049300     ELSE
049400         IF  MMOC-ADD-PENDING
049500             MOVE MBEMWS-ADD-PENDING
049600                                 TO MC00-ERR-MESSAGE
049700         ELSE
049800             IF  MMOC-REC-PURGED
049900                 MOVE MBEMWS-REC-PURGED
050000                                 TO MC00-ERR-MESSAGE
050100             ELSE
050200                 MOVE DFHBMUNF   TO MC00-ORG-A
050300                 MOVE MC00-ORG   TO MBCA-MERCHANT-ORG
050400                 GO TO C100-EDIT-CHAIN.
050500*
050600 C098-ORG-ERROR.
050700*
050800     SET SS08WS-ERROR-SW-YES     TO TRUE.
050900     MOVE DFHBMASB               TO MC00-ORG-LP-A
051000                                    MC00-ORG-RP-A.
051100     MOVE SS08WS-CURSOR          TO MC00-ORG-L.
051200     MOVE DFHBMNBF               TO MC00-ORG-A
051300                                    MC00-CHAIN-A.
051400     GO TO D000-RETURN-ERRORS.
051500*
051600 C100-EDIT-CHAIN.
051700*
051800***********************************************************
051900*    THE LENGTH FIELD COULD BE CHECKED HERE TO            *
052000*    SEE IF ANYTHING WAS KEYED.                           *
052100***********************************************************
052200*
052300     IF  MC00-CHAIN IS EQUAL TO ZEROS
052400     OR  MC00-CHAIN IS NOT NUMERIC
052500     OR  MC00-CHAIN IS EQUAL TO ZEROS OR 999999999
052600         MOVE MBEMWS-INVALID-CHAIN
052700                                 TO MC00-ERR-MESSAGE
052800         GO TO C118-CHAIN-ERROR.
052900*
053000 C102-READ-CHAIN.
053100*
053200***************************************************************
053300*    READ THE CHAIN RECORD.    IT MUST BE ON FILE AND         *
053400*    AN ACTIVE RECORD IF IN MAINTENANCE OR INQUIRY.  IT MUST  *
053500*    NOT BE ON FILE (OR IN AN ADD PENDING STATE), IF IN ADD.  *
053600***************************************************************
053700*
053800     MOVE MC00-ORG               TO MBIOWS-MMRC-ORG.
053900     MOVE MC00-CHAIN             TO MBIOWS-MMRC-CHAIN.
054000     MOVE SS08WS-CICS-FC-NOTFND  TO MBIORO-TEMP-STATUS-1.
054100     MOVE 'FC04'                 TO MBCA-PROGRAM-LOCATION.
054200     SET MBIORO-READ-RANDOM      TO TRUE.
054300     PERFORM MMRCAO-ACCESS       THRU MMRCAO-ACCESS-EXIT.
054400*
054500     IF  SS08WS-RC-FC-VALID-RTN-CODE
054600         MOVE MC00-CHAIN         TO MBCA-CHAIN.
054700*
054800     IF  MBCA-PTI-FUNCTION-IS-INQUIRY
054900         IF  SS08WS-RC-FC-VALID-RTN-CODE
055000             IF  MMRC-ADD-PENDING
055100                 MOVE MBEMWS-ADD-PENDING
055200                                 TO MC00-ERR-MESSAGE
055300                 GO TO C118-CHAIN-ERROR
055400             ELSE
055500                 GO TO F000-SETUP-COMMAREA
055600         ELSE
055700             MOVE MBEMWS-NOT-ON-FILE
055800                                 TO MC00-ERR-MESSAGE
055900             GO TO C118-CHAIN-ERROR.
056000*
056100     IF  MBCA-PTI-FUNCTION-IS-ADD
056200     AND SS08WS-RC-FC-NOTFND
056300         GO TO E000-UPDATE-FILE.
056400*
056500     IF  MBCA-PTI-FUNCTION-IS-ADD
056600     AND MMRC-ADD-PENDING
056700         IF  WS-COPY-SW-NO
056800             MOVE MMRC-ONLINE-STATUS
056900                                 TO MBCA-SCREEN-NBR
057000             GO TO F000-SETUP-COMMAREA
057100         ELSE
057200             MOVE MBEMWS-ADD-PENDING
057300                                 TO MC00-ERR-MESSAGE
057400             GO TO C118-CHAIN-ERROR.
057500*
057600     IF  MBCA-PTI-FUNCTION-IS-ADD
057700         MOVE MBEMWS-ALREADY-ON-FILE
057800                                 TO MC00-ERR-MESSAGE
057900         GO TO C118-CHAIN-ERROR.
058000*
058100     IF  MBCA-PTI-FUNCTION-IS-MAINT
058200     AND SS08WS-RC-FC-NOTFND
058300         MOVE MBEMWS-NOT-ON-FILE TO MC00-ERR-MESSAGE
058400         GO TO C118-CHAIN-ERROR.
058500*
058600     IF  MBCA-PTI-FUNCTION-IS-MAINT
058700     AND MMRC-ADD-PENDING
058800         MOVE MBEMWS-ADD-PENDING TO MC00-ERR-MESSAGE
058900         GO TO C118-CHAIN-ERROR.
059000*
059100     IF  MBCA-PTI-FUNCTION-IS-MAINT
059200     AND MMRC-REC-PURGED
059300         MOVE MBEMWS-REC-PURGED  TO MC00-ERR-MESSAGE
059400         GO TO C118-CHAIN-ERROR.
059500***********************************************
059600*    OTHERWISE, WE PASSED THE CHAIN EDIT      *
059700***********************************************
059800*
059900     GO TO F000-SETUP-COMMAREA.
060000*
060100 C118-CHAIN-ERROR.
060200*
060300     SET SS08WS-ERROR-SW-YES     TO TRUE.
060400     MOVE DFHBMASB               TO MC00-CHAIN-LP-A
060500                                    MC00-CHAIN-RP-A.
060600     MOVE SS08WS-CURSOR          TO MC00-CHAIN-L.
060700     MOVE DFHBMNBF               TO MC00-CHAIN-A.
060800/
060900 D000-RETURN-ERRORS SECTION.
061000*
061100     IF  SS08WS-ERROR-SW-NO
061200         GO TO E000-UPDATE-FILE
061300     ELSE
061400         IF  SS08WS-VALID-PF-KEY
061500         OR  SS08WS-EIBAID-VALID-PF-KEY
061600             SET MBCA-INITIAL-SCREEN-NBR
061700                                 TO TRUE
061800             GO TO F090-TRANSFER-XCTL.
061900*
062000     IF  MBCA-MBUI-UI-YES
062100         MOVE 'MBUI'             TO MBCA-TRANS-ID
062200                                    MBCA-PREV-TRANS-ID
062300         MOVE 01                 TO MBCA-SCREEN-NBR
062400         SET MBCA-MBUI-ERROR-YES TO TRUE
062500         GO TO F090-TRANSFER-XCTL.
062600*
062700***************************************************************
062800*    INITIALIZE THE STANDARD MAP LINES.  IN AN ERROR          *
062900*    CONDITION, THIS ROUTINE IS PERFORMED PRIMARILY           *
063000*    TO UPDATE THE DATE AND TIME ON THE SCREEN.               *
063100***************************************************************
063200*
063300     PERFORM MB60PD-INIT-STD-MAP-LINES
063400                                 THRU MB60PD-ISML-EXIT.
063500*
063600     IF  MBCA-PTI-FUNCTION-IS-MAINT
063700     OR  MBCA-PTI-FUNCTION-IS-INQUIRY
063800         MOVE DFHBMDAS           TO MC00-COPY-ORG-LIT-A
063900                                    MC00-COPY-ORG-LP-A
064000                                    MC00-COPY-ORG-RP-A
064100                                    MC00-COPY-CHAIN-LIT-A
064200                                    MC00-COPY-CHAIN-LP-A
064300                                    MC00-COPY-CHAIN-RP-A
064400         MOVE DFHBMASK           TO MC00-COPY-ORG-A
064500                                    MC00-COPY-CHAIN-A.
064600*
064700**********************
064800*    SEND THE MAP    *
064900**********************
065000*
065100     MOVE 'BM03'                 TO MBCA-PROGRAM-LOCATION.
065200     PERFORM MB60PD-SEND-MAP-WITH-ERASE
065300                                 THRU MB60PD-SMWE-EXIT.
065400*
065500************************
065600*    RETURN TO CICS    *
065700************************
065800*
065900     MOVE 'PC04'                 TO MBCA-PROGRAM-LOCATION.
066000     PERFORM MB70PD-RETURN-TRANS-ID
066100                                 THRU MB70PD-RTI-EXIT.
066200/
066300 E000-UPDATE-FILE SECTION.
066400*
066500     IF  MBCA-MBUI-UI-YES
066600         SET MBCA-MBUI-ERROR-NO  TO TRUE.
066700*
066800     IF  MBCA-MBUI-UI-YES
066900     AND MBCA-MBUI-UI-UPDATE-NO
067000         GO TO F090-TRANSFER-XCTL.
067100*
067200********************************************************
067300*    WRITE THE NEW SECURITY CHAIN RECORD FROM THE      *
067400*    INITIALIZER RECORD OR FROM THE CHAIN RECORD       *
067500*    THAT IS BEING COPIED.                             *
067600********************************************************
067700*
067800     IF  WS-COPY-SW-YES
067900         GO TO E040-COPY-ADD.
068000*
068100 E020-ADD-NEW-RECORD.
068200*
068300********************************************************
068400*    SET UP THE RECORD.  USE THE INITIALIZER RECORD    *
068500*    (MMRCIR0) AS THE FIELD DEFAULTS.                  *
068600********************************************************
068700*
068800     MOVE MMRCIR-RECORD          TO MMRC-RECORD.
068900     MOVE MC00-ORG               TO MMRC-ORG.
069000     MOVE MC00-CHAIN             TO MMRC-CHAIN.
069100     MOVE MBCA-START-DATE        TO MMRC-LAST-MAINT-DATE.
069200     MOVE MBCA-OPERATOR-ID       TO MMRC-LAST-MAINT-OPER.
069300*
069400     GO TO E060-WRITE-MMRC.
069500*
069600 E040-COPY-ADD.
069700*
069800*********************************************************
069900*    RE-READ THE MERCH RELATIONSHIP RECORD TO BE COPIED.*
070000*********************************************************
070100*
070200     MOVE MC00-COPY-ORG          TO MBIOWS-MMRC-ORG.
070300     MOVE MC00-COPY-CHAIN        TO MBIOWS-MMRC-CHAIN.
070400     MOVE 'FC05'                 TO MBCA-PROGRAM-LOCATION.
070500     SET MBIORO-READ-RANDOM      TO TRUE.
070600     PERFORM MMRCAO-ACCESS       THRU MMRCAO-ACCESS-EXIT.
070700*
070800***************************
070900*    SET UP THE RECORD    *
071000***************************
071100*
071200     MOVE MC00-ORG               TO MMRC-ORG.
071300     MOVE MC00-CHAIN             TO MMRC-CHAIN.
071400     MOVE MMRCIR-REC-STATUS      TO MMRC-REC-STATUS.
071500     MOVE MMRCIR-ONLINE-STATUS   TO MMRC-ONLINE-STATUS.
071600     MOVE MBCA-START-DATE        TO MMRC-LAST-MAINT-DATE.
071700     MOVE MBCA-OPERATOR-ID       TO MMRC-LAST-MAINT-OPER.
071800*
071900*************************************************************
072000*    INITIALIZE THE FIELDS THAT ARE NOT PART OF THE COPY    *
072100*************************************************************
072200*
072300     INITIALIZE                  MMRC-DEMOGRAPHICS-AREA.
072400*
072500 E060-WRITE-MMRC.
072600*
072700     MOVE ZERO                   TO MMRC-OCCURRENCE-YEAR (15).
072800*
072900     MOVE 'FC06'                 TO MBCA-PROGRAM-LOCATION.
073000     SET MBIORO-WRITE            TO TRUE.
073100     PERFORM MMRCAO-ACCESS       THRU MMRCAO-ACCESS-EXIT.
073200*
073300     MOVE MC00-CHAIN             TO MBCA-CHAIN.
073400/
073500 F000-SETUP-COMMAREA SECTION.
073600*
073700***************************************************************
073800*  SET UP COMMAREA FIELDS AND TRANSFER TO THE NEXT PROGRAM    *
073900***************************************************************
074000*
074100     MOVE MBCA-EIBAID            TO SS08WS-EIBAID.
074200*
074300     MOVE MBIOWS-MMRC-DIRECT-KEY-CODE
074400                                 TO MBCA-KEY-CODE.
074500*
074600     PERFORM MB60PD-EDIT-PAGE-NBR
074700                                 THRU MB60PD-EPN-EXIT.
074800*
074900     IF  SS08WS-VALID-PF-KEY
075000     OR  SS08WS-EIBAID-VALID-PF-KEY
075100         SET MBCA-INITIAL-SCREEN-NBR
075200                                 TO TRUE.
075300*
075400 F090-TRANSFER-XCTL.
075500*
075600     IF  MBCA-MBUI-UI-YES
075700         MOVE 'MBUI'             TO MBCA-TRANS-ID
075800                                    MBCA-PREV-TRANS-ID
075900         MOVE 01                 TO MBCA-SCREEN-NBR
076000         MOVE MBMC00I            TO MBUITS-VAR-DATA
076100         MOVE LENGTH OF MBMC00I  TO MBUITS-VAR-LENGTH
076200         MOVE 'TS10'             TO MBCA-PROGRAM-LOCATION
076300         EXEC CICS WRITEQ TS
076400                   QUEUE   (TS-QUEUE-NAME)
076500                   FROM    (MBUITS-RECORD)
076600                   LENGTH  (LENGTH  OF MBUITS-RECORD)
076700
076800              END-EXEC.
076900*
077000     MOVE 'PC05'                 TO MBCA-PROGRAM-LOCATION.
077100     PERFORM MB70PD-XCTL-TO-MBOXCTL
077200                                 THRU MB70PD-XTM-EXIT.
077300/
077400 Z000-COPIED-ROUTINES SECTION.
077500*
077600**********************************
077700*    JUL TO GREG DATE ROUTINE    *
077800**********************************
077900*
078000     COPY SS08PD.
078100/
078200**********************************
078300*    DATE AND TIME EDIT ROUTINES *
078400**********************************
078500*
078600     COPY SS26PD.
078700     COPY SS27PD.
078800/
078900*********************************
079000*    LINE 24 PF KEYS ROUTINE    *
079100*********************************
079200*
079300     COPY SS15PD.
079400/
079500*******************************************
079600*    ORG FILE ACCESS ROUTINES             *
079700*******************************************
079800*
079900     COPY MMOCAO.
080000/
080100******************************************************
080200*    MERCHANT RELATIONSHIP RECORD ACCESS ROUTINES    *
080300******************************************************
080400*
080500     COPY MMRCAO.
080600/
080700*****************************
080800*    ONLINE MAP ROUTINES    *
080900*****************************
081000*
081100     COPY MB60PD REPLACING 'MBMAPXX' BY 'MBMC00 '
081200                           MBMAPXXI BY MBMC00I
081300                           MBMAPXXO BY MBMC00O.
081400/
081500***************************
081600*    ONLINE PROCEDURES    *
081700***************************
081800*
081900     COPY MB70PD.
082000/
082100     COPY SMFTPXO.
