000100 IDENTIFICATION DIVISION.
000200 PROGRAM-ID. MBOME01.
000201*       RELEASE DATE=08/24/01.        REVISION LEVEL=08.06      *
000202*****************************************************************
000203*WARNING.  THIS COMPUTER PROGRAM IS PROTECTED BY COPYRIGHT LAW  *
000204*AND INTERNATIONAL TREATIES.  UNAUTHORIZED REPRODUCTION OR      *
000205*DISTRIBUTION OF THIS PROGRAM, OR ANY PORTION OF IT, MAY RESULT *
000206*IN SEVERE CIVIL AND CRIMINAL PENATLIES, AND WILL BE PROSECUTED *
000207*TO THE MAXIMUM EXTENT POSSIBLE UNDER THE LAW.                  *
000208*COPYRIGHT 1999 PAYSYS INTERNATIONAL, INC.  ALL RIGHTS RESERVED.*
000209*****************************************************************
000300*****************************************************************
000400*                                                               *
000500*   V - PLUS  M E R C H A N T   B A N K C A R D   S Y S T E M   *
000600*                                                               *
000700*      MBOME01 - ON-LINE MERCHANT EXPENSE FACTORS RECORD        *
000800*                ADD/MAINTENANCE/INQUIRY                        *
000900*                SCREEN 01                                      *
001000*                                                               *
001100*              1. TRANSIDS                                      *
001200*                 A. MBAE                                       *
001300*                 B. MBME                                       *
001400*                 C. MBQE                                       *
001500*              2. MAPS USED -                                   *
001600*                 A. MBME01 (MAP 01)                            *
001700*              3. FILES USED -                                  *
001800*                 A. MMEF   (MERCHANT EXPENSE FACTORS FILE)     *
001900*                 B. MML1   (LOG/JOURNAL FILE)                  *
002000*****************************************************************
002100*
002200 ENVIRONMENT DIVISION.
002300 DATA DIVISION.
002400 WORKING-STORAGE SECTION.
002500 01  FILLER                  PIC  X(12)      VALUE '** WS-BEG **'.
002600*         I/O REQUEST BLOCK WORK AREAS
002700     COPY MBIOWS.
002800/         I/O REQUEST BLOCK
002900     COPY MBIORO.
003000/         LOG/JOURNAL WORK AREAS
003100     COPY MML1WS REPLACING ==:MML1:== BY ==MML1==.
003200/         DATE WORK AREAS
003300     COPY SS01WS.
003400/         ONLINE WORK AREAS
003500     COPY SS08WS.
003600/
003700     COPY SS00WS.
003800/
003900     COPY SMFTWS.
004000/
004100     COPY SMPTRL REPLACING ==:SMPT:== BY ==SMPT==.
004200/
004300     COPY MB61LK.
004400/         CHECK DIGIT WORK FIELDS
004500     COPY SS05WS.
004600/
004700 01  WS-WORK-AREAS.
004800     03  WS-UPDATE-SW        PIC  X(01)      VALUE 'N'.
004900         88  WS-UPDATE-SW-NO                 VALUE 'N'.
005000         88  WS-UPDATE-SW-YES                VALUE 'Y'.
005100 01  FILLER                  PIC  X(12)      VALUE '** WS-END **'.
005200/
005300 LINKAGE SECTION.
005400 01  DFHCOMMAREA.
005500     COPY MB60WS.
005600/         ORG SCREEN 01 MAP DSECT
005700     COPY MBME01.
005800/         ORG SCREEN 01 MAP REDEFINITION
005900     COPY MBME01R.
006000/         MERCHANT EXPENSE FACTORS RECORD LAYOUT
006100     COPY MMIFRL REPLACING ==:MMIF:== BY ==MMEF==.
006200/         LOG/JOURNAL FILE RECORD LAYOUT
006300     COPY MML1RL REPLACING ==:MML1:== BY ==MML1==.
006400/
006500 PROCEDURE DIVISION.
006600 0000-HOUSEKEEPING SECTION.
006700 0100-INIT.
006800*
006900     MOVE 'PC01'                 TO MBCA-PROGRAM-LOCATION.
007000     PERFORM MB70PD-ON-LINE-HOUSEKEEPING
007100                                 THRU MB70PD-OLH-EXIT.
007200*
007300     IF  MBCA-RECEIVE-SCREEN
007400         GO TO 2000-RECEIVE-SCREEN.
007500/
007600 1000-SEND-SCREEN SECTION.
007700*
007800****************************************************************
007900*    THIS SECTION BUILDS AND SENDS THE 01 SCREEN.              *
008000****************************************************************
008100*
008200****************************************************************
008300*    GET CICS STORAGE NEEDED FOR THE MAP                       *
008400****************************************************************
008500*
008600     MOVE 'SC01'                 TO MBCA-PROGRAM-LOCATION.
008700     PERFORM MB60PD-GETMAIN-FOR-MAP
008800                                 THRU MB60PD-GFM-EXIT.
008900*
009000     MOVE MBCA-MERCHANT-ORG      TO ME01-ORG.
009100     MOVE MBCA-TABLE             TO ME01-TABLE-NBR.
009200     MOVE DFHBMASB               TO ME01-ORG-A
009300                                    ME01-TABLE-NBR-A.
009400     MOVE 01                     TO MBCA-SCREEN-NBR.
009500*
009600****************************************************************
009700*    INITIALIZE THE STANDARD MAP LINES                         *
009800****************************************************************
009900*
010000     PERFORM MB60PD-INIT-STD-MAP-LINES
010100                                 THRU MB60PD-ISML-EXIT.
010200*
010300****************************************************************
010400*    READ THE EXPENSE FACTORS FILE                            *
010500****************************************************************
010600*
010700     MOVE 'FC01'                 TO MBCA-PROGRAM-LOCATION.
010800     MOVE MBCA-MERCHANT-ORG      TO MBIOWS-MMEF-ORG.
010900     MOVE MBCA-TABLE             TO MBIOWS-MMEF-TABLE.
011000     SET MBIORO-READ-RANDOM      TO TRUE.
011100     PERFORM MMEFAO-ACCESS       THRU MMEFAO-ACCESS-EXIT.
011200/
011300 1100-BUILD-SCREEN.
011400*
011500****************************************************************
011600*    BUILD THE MAP FROM THE EXPENSE RECORD                     *
011700****************************************************************
011800*
011900     MOVE MMEF-TABLE-NAME        TO ME01-TABLE-NAME.
012000     MOVE MMEF-SALES-FEE         TO ME01-SALES.
012100     MOVE MMEF-RETRIEVAL-FEE     TO ME01-RETRIEVAL.
012200     MOVE MMEF-LOCATION-FEE      TO ME01-LOCATION-FEE.
012300     MOVE MMEF-RETURNS-FEE       TO ME01-RETURN.
012400     MOVE MMEF-BULLETIN-FEE      TO ME01-BULLETIN-FEE.
012500     MOVE MMEF-BATCH-HDR-FEE     TO ME01-BATCH-HDR.
012600     MOVE MMEF-STATEMENT-FEE     TO ME01-STATEMENT.
012700     MOVE MMEF-KEYED-FEE         TO ME01-KEYED-TXN.
012800     MOVE MMEF-MEMBERSHIP-FEE    TO ME01-MEMBERSHIP.
012900     MOVE MMEF-SWIPED-FEE        TO ME01-SWIPED-TXN.
013000     MOVE MMEF-USER-INP-FEE      TO ME01-USER-INPUT.
013100     MOVE MMEF-SETUP-FEE         TO ME01-SETUP.
013200     MOVE MMEF-LOCAL-INP-FEE     TO ME01-LOCAL-INPUT.
013300     MOVE MMEF-ADMIN-FEE         TO ME01-ADMINIST.
013400     MOVE MMEF-CHECK-APPR-FEE    TO ME01-CHECK.
013500     MOVE MMEF-ADJ-INPUT-FEE     TO ME01-ADJUSTMENT.
013600     MOVE MMEF-CHGBACK-FEE       TO ME01-CHARGEBACK.
013700     MOVE MMEF-ACH-FEE           TO ME01-ACH-FEE.
013800     MOVE MMEF-POS-1-CAP-FEE     TO ME01-POS-1-CAPTURE.
013900     MOVE MMEF-POS-2-CAP-FEE     TO ME01-POS-2-CAPTURE.
014000     MOVE MMEF-POS-3-CAP-FEE     TO ME01-POS-3-CAPTURE.
014100     MOVE MMEF-IN-STORE-PMT-FEE  TO ME01-IN-STORE-PMT.
014200/
014300****************************************************************
014400*    IF INQUIRY, DARKEN PARENS AND ASKIP FIELDS                *
014500****************************************************************
014600*
014700     MOVE SS08WS-CURSOR          TO ME01-TABLE-NAME-L.
014800*
014900     IF  MBCA-PTI-FUNCTION-IS-INQUIRY
015000         MOVE SS08WS-CURSOR      TO ME01-ALT-TRANID-L
015100         MOVE DFHBMASB           TO ME01-TABLE-NAME-A
015200                                    ME01-SALES-A
015300                                    ME01-RETRIEVAL-A
015400                                    ME01-LOCATION-FEE-A
015500                                    ME01-RETURN-A
015600                                    ME01-BULLETIN-FEE-A
015700                                    ME01-BATCH-HDR-A
015800                                    ME01-STATEMENT-A
015900                                    ME01-KEYED-TXN-A
016000                                    ME01-MEMBERSHIP-A
016100                                    ME01-SWIPED-TXN-A
016200                                    ME01-USER-INPUT-A
016300                                    ME01-SETUP-A
016400                                    ME01-LOCAL-INPUT-A
016500                                    ME01-ADMINIST-A
016600                                    ME01-CHECK-A
016700                                    ME01-ADJUSTMENT-A
016800                                    ME01-CHARGEBACK-A
016900                                    ME01-ACH-FEE-A
017000                                    ME01-POS-1-CAPTURE-A
017100                                    ME01-POS-2-CAPTURE-A
017200                                    ME01-POS-3-CAPTURE-A
017300                                    ME01-IN-STORE-PMT-A
017400         MOVE DFHBMDAS           TO ME01-TABLE-NAME-LP-A
017500                                    ME01-TABLE-NAME-RP-A
017600                                    ME01-SALES-LP-A
017700                                    ME01-SALES-RP-A
017800                                    ME01-RETRIEVAL-LP-A
017900                                    ME01-RETRIEVAL-RP-A
018000                                    ME01-LOCATION-FEE-LP-A
018100                                    ME01-LOCATION-FEE-RP-A
018200                                    ME01-RETURN-LP-A
018300                                    ME01-RETURN-RP-A
018400                                    ME01-BULLETIN-FEE-LP-A
018500                                    ME01-BULLETIN-FEE-RP-A
018600                                    ME01-BATCH-HDR-LP-A
018700                                    ME01-BATCH-HDR-RP-A
018800                                    ME01-STATEMENT-LP-A
018900                                    ME01-STATEMENT-RP-A
019000                                    ME01-KEYED-TXN-LP-A
019100                                    ME01-KEYED-TXN-RP-A
019200                                    ME01-MEMBERSHIP-LP-A
019300                                    ME01-MEMBERSHIP-RP-A
019400                                    ME01-SWIPED-TXN-LP-A
019500                                    ME01-SWIPED-TXN-RP-A
019600                                    ME01-USER-INPUT-LP-A
019700                                    ME01-USER-INPUT-RP-A
019800                                    ME01-SETUP-LP-A
019900                                    ME01-SETUP-RP-A
020000                                    ME01-LOCAL-INPUT-LP-A
020100                                    ME01-LOCAL-INPUT-RP-A
020200                                    ME01-ADMINIST-LP-A
020300                                    ME01-ADMINIST-RP-A
020400                                    ME01-CHECK-LP-A
020500                                    ME01-CHECK-RP-A
020600                                    ME01-ADJUSTMENT-LP-A
020700                                    ME01-ADJUSTMENT-RP-A
020800                                    ME01-CHARGEBACK-LP-A
020900                                    ME01-CHARGEBACK-RP-A
021000                                    ME01-ACH-FEE-LP-A
021100                                    ME01-ACH-FEE-RP-A
021200                                    ME01-POS-1-CAPTURE-LP-A
021300                                    ME01-POS-1-CAPTURE-RP-A
021400                                    ME01-POS-2-CAPTURE-LP-A
021500                                    ME01-POS-2-CAPTURE-RP-A
021600                                    ME01-POS-3-CAPTURE-LP-A
021700                                    ME01-POS-3-CAPTURE-RP-A
021800                                    ME01-IN-STORE-PMT-LP-A
021900                                    ME01-IN-STORE-PMT-RP-A.
022000*
022100     IF  MBCA-PTI-FUNCTION-IS-ADD
022200         MOVE DFHBMDAS           TO ME01-LAST-MAINT-LIT-A
022300                                    ME01-LAST-MAINT-DATE-A
022400                                    ME01-LAST-MAINT-OPER-LIT-A
022500                                    ME01-LAST-MAINT-OPER-A
022600     ELSE
022700         MOVE MMEF-LAST-MAINT-DATE
022800                                 TO SS01WS-JULIAN
022900         PERFORM SS26PD-NUMERICALLY-EDIT-DATE
023000                                 THRU SS26PD-NED-EXIT
023100         MOVE SS01WS-XX-XX-YYYY  TO ME01-LAST-MAINT-DATE
023200         MOVE MMEF-LAST-MAINT-OPER
023300                                 TO ME01-LAST-MAINT-OPER
023400         MOVE DFHBMASB           TO ME01-LAST-MAINT-DATE-A
023500                                    ME01-LAST-MAINT-OPER-A.
023600*
023700****************************************************************
023800*    FORMAT THE MESSAGE LINE                                   *
023900****************************************************************
024000*
024100     IF ME01-ERR-MESSAGE EQUAL TO SPACES OR LOW-VALUES
024200        PERFORM MB06PD-FORMAT-MESSAGE-LINE
024300           THRU MB06PD-FML-EXIT
024400        MOVE SS08WS-FORMATTED-MSG TO ME01-ERR-MESSAGE.
024500*
024600****************************************************************
024700*    SEND THE MAP                                              *
024800****************************************************************
024900*
025000     MOVE 'BM01'                 TO MBCA-PROGRAM-LOCATION.
025100     PERFORM MB60PD-SEND-MAP-WITH-ERASE
025200                                 THRU MB60PD-SMWE-EXIT.
025300*
025400****************************************************************
025500*    RETURN TO CICS                                            *
025600****************************************************************
025700*
025800     MOVE 'PC02'                 TO MBCA-PROGRAM-LOCATION.
025900     PERFORM MB70PD-RETURN-TRANS-ID
026000                                 THRU MB70PD-RTI-EXIT.
026100/
026200 2000-RECEIVE-SCREEN SECTION.
026300*
026400****************************************************************
026500*    THIS SECTION RECEIVES THE 01 SCREEN                       *
026600****************************************************************
026700*
026800     MOVE 'BM02'                 TO MBCA-PROGRAM-LOCATION.
026900     PERFORM MB60PD-RECEIVE-MAP  THRU MB60PD-RM-EXIT.
027000*
027100****************************************************************
027200*    CHECK FOR ANOTHER TRANSACTION ID ENTERED BY THE USER      *
027300****************************************************************
027400*
027500     MOVE 'PC03'                 TO MBCA-PROGRAM-LOCATION.
027600     PERFORM MB60PD-NEW-TRANS-ROUTINE
027700                                 THRU MB60PD-NTR-EXIT.
027800*
027900****************************************************************
028000*    BYPASS EDITS ON INQUIRY                                   *
028100****************************************************************
028200*
028300     IF  MBCA-PTI-FUNCTION-IS-INQUIRY
028400         GO TO 2600-SETUP-COMMAREA.
028500*
028600****************************************************************
028700*    READ THE EXPENSE FILE                                     *
028800****************************************************************
028900*
029000     MOVE 'FC02'                 TO MBCA-PROGRAM-LOCATION.
029100     MOVE MBCA-MERCHANT-ORG      TO MBIOWS-MMEF-ORG.
029200     MOVE MBCA-TABLE             TO MBIOWS-MMEF-TABLE.
029300     SET MBIORO-READ-RANDOM      TO TRUE.
029400     PERFORM MMEFAO-ACCESS       THRU MMEFAO-ACCESS-EXIT.
029500*
029600****************************************************************
029700*    EDIT FIELDS                                               *
029800****************************************************************
029900*
030000*            ***** TABLE NAME *****                            *
030100*
030200     IF  ME01-TABLE-NAME-L IS LESS THAN 1
030300         MOVE DFHBMASK           TO ME01-TABLE-NAME-A
030400         MOVE DFHBMDAS           TO ME01-TABLE-NAME-LP-A
030500                                    ME01-TABLE-NAME-RP-A
030600         MOVE MMEF-TABLE-NAME    TO ME01-TABLE-NAME
030700     ELSE
030800         MOVE DFHBMASF           TO ME01-TABLE-NAME-A
030900         MOVE DFHBMDAS           TO ME01-TABLE-NAME-LP-A
031000                                    ME01-TABLE-NAME-RP-A
031100         SET WS-UPDATE-SW-YES    TO TRUE.
031200*
031300*            ***** SALES FEE ******                            *
031400*
031500     IF  ME01-SALES-L IS LESS THAN 1
031600         MOVE DFHBMASK           TO ME01-SALES-A
031700         MOVE DFHBMDAS           TO ME01-SALES-LP-A
031800                                    ME01-SALES-RP-A
031900         MOVE MMEF-SALES-FEE     TO ME01-SALES
032000     ELSE
032100         IF  ME01-SALES IS NUMERIC
032200             MOVE DFHBMASF       TO ME01-SALES-A
032300             MOVE DFHBMDAS       TO ME01-SALES-LP-A
032400                                    ME01-SALES-RP-A
032500             SET WS-UPDATE-SW-YES
032600                                 TO TRUE
032700         ELSE
032800             MOVE DFHBMNBF       TO ME01-SALES-A
032900             MOVE DFHBMASB       TO ME01-SALES-LP-A
033000                                    ME01-SALES-RP-A
033100             MOVE SS08WS-CURSOR  TO ME01-SALES-L
033200             SET SS08WS-ERROR-SW-YES TO TRUE.
033300*
033400*            ***** RETRIEVAL FEE ******                        *
033500*
033600     IF  ME01-RETRIEVAL-L IS LESS THAN 1
033700         MOVE DFHBMASK           TO ME01-RETRIEVAL-A
033800         MOVE DFHBMDAS           TO ME01-RETRIEVAL-LP-A
033900                                    ME01-RETRIEVAL-RP-A
034000         MOVE MMEF-RETRIEVAL-FEE TO ME01-RETRIEVAL
034100     ELSE
034200         IF  ME01-RETRIEVAL IS NUMERIC
034300             MOVE DFHBMASF       TO ME01-RETRIEVAL-A
034400             MOVE DFHBMDAS       TO ME01-RETRIEVAL-LP-A
034500                                    ME01-RETRIEVAL-RP-A
034600             SET WS-UPDATE-SW-YES
034700                                 TO TRUE
034800         ELSE
034900             MOVE DFHBMNBF       TO ME01-RETRIEVAL-A
035000             MOVE DFHBMASB       TO ME01-RETRIEVAL-LP-A
035100                                    ME01-RETRIEVAL-RP-A
035200             MOVE SS08WS-CURSOR  TO ME01-RETRIEVAL-L
035300             SET SS08WS-ERROR-SW-YES TO TRUE.
035400*
035500*            ***** LOCATION FEE ******                         *
035600*
035700     IF  ME01-LOCATION-FEE-L IS LESS THAN 1
035800         MOVE DFHBMASK           TO ME01-LOCATION-FEE-A
035900         MOVE DFHBMDAS           TO ME01-LOCATION-FEE-LP-A
036000                                    ME01-LOCATION-FEE-RP-A
036100         MOVE MMEF-LOCATION-FEE  TO ME01-LOCATION-FEE
036200     ELSE
036300         IF  ME01-LOCATION-FEE IS NUMERIC
036400             MOVE DFHBMASF       TO ME01-LOCATION-FEE-A
036500             MOVE DFHBMDAS       TO ME01-LOCATION-FEE-LP-A
036600                                    ME01-LOCATION-FEE-RP-A
036700             SET WS-UPDATE-SW-YES
036800                                 TO TRUE
036900         ELSE
037000             MOVE DFHBMNBF       TO ME01-LOCATION-FEE-A
037100             MOVE DFHBMASB       TO ME01-LOCATION-FEE-LP-A
037200                                    ME01-LOCATION-FEE-RP-A
037300             MOVE SS08WS-CURSOR  TO ME01-LOCATION-FEE-L
037400             SET SS08WS-ERROR-SW-YES TO TRUE.
037500*
037600*            ***** RETURNS FEE *****                           *
037700*
037800     IF  ME01-RETURN-L IS LESS THAN 1
037900         MOVE DFHBMASK           TO ME01-RETURN-A
038000         MOVE DFHBMDAS           TO ME01-RETURN-LP-A
038100                                    ME01-RETURN-RP-A
038200         MOVE MMEF-RETURNS-FEE   TO ME01-RETURN
038300     ELSE
038400         IF  ME01-RETURN IS NUMERIC
038500             MOVE DFHBMASF       TO ME01-RETURN-A
038600             MOVE DFHBMDAS       TO ME01-RETURN-LP-A
038700                                    ME01-RETURN-RP-A
038800             SET WS-UPDATE-SW-YES
038900                                 TO TRUE
039000         ELSE
039100             MOVE DFHBMNBF       TO ME01-RETURN-A
039200             MOVE DFHBMASB       TO ME01-RETURN-LP-A
039300                                    ME01-RETURN-RP-A
039400             MOVE SS08WS-CURSOR  TO ME01-RETURN-L
039500             SET SS08WS-ERROR-SW-YES TO TRUE.
039600*
039700*            ***** BULLETIN FEE ******                         *
039800*
039900     IF  ME01-BULLETIN-FEE-L IS LESS THAN 1
040000         MOVE DFHBMASK           TO ME01-BULLETIN-FEE-A
040100         MOVE DFHBMDAS           TO ME01-BULLETIN-FEE-LP-A
040200                                    ME01-BULLETIN-FEE-RP-A
040300         MOVE MMEF-BULLETIN-FEE  TO ME01-BULLETIN-FEE
040400     ELSE
040500         IF  ME01-BULLETIN-FEE IS NUMERIC
040600             MOVE DFHBMASF       TO ME01-BULLETIN-FEE-A
040700             MOVE DFHBMDAS       TO ME01-BULLETIN-FEE-LP-A
040800                                    ME01-BULLETIN-FEE-RP-A
040900             SET WS-UPDATE-SW-YES
041000                                 TO TRUE
041100         ELSE
041200             MOVE DFHBMNBF       TO ME01-BULLETIN-FEE-A
041300             MOVE DFHBMASB       TO ME01-BULLETIN-FEE-LP-A
041400                                    ME01-BULLETIN-FEE-RP-A
041500             MOVE SS08WS-CURSOR  TO ME01-BULLETIN-FEE-L
041600             SET SS08WS-ERROR-SW-YES TO TRUE.
041700*
041800*            ***** BATCH HEADER FEE *****                     *
041900*
042000     IF  ME01-BATCH-HDR-L IS LESS THAN 1
042100         MOVE DFHBMASK           TO ME01-BATCH-HDR-A
042200         MOVE DFHBMDAS           TO ME01-BATCH-HDR-LP-A
042300                                    ME01-BATCH-HDR-RP-A
042400         MOVE MMEF-BATCH-HDR-FEE TO ME01-BATCH-HDR
042500     ELSE
042600         IF  ME01-BATCH-HDR IS NUMERIC
042700             MOVE DFHBMASF       TO ME01-BATCH-HDR-A
042800             MOVE DFHBMDAS       TO ME01-BATCH-HDR-LP-A
042900                                    ME01-BATCH-HDR-RP-A
043000             SET WS-UPDATE-SW-YES
043100                                 TO TRUE
043200         ELSE
043300             MOVE DFHBMNBF       TO ME01-BATCH-HDR-A
043400             MOVE DFHBMASB       TO ME01-BATCH-HDR-LP-A
043500                                    ME01-BATCH-HDR-RP-A
043600             MOVE SS08WS-CURSOR  TO ME01-BATCH-HDR-L
043700             SET SS08WS-ERROR-SW-YES TO TRUE.
043800*
043900*            ***** STATEMENT FEE *****                         *
044000*
044100     IF  ME01-STATEMENT-L IS LESS THAN 1
044200         MOVE DFHBMASK           TO ME01-STATEMENT-A
044300         MOVE DFHBMDAS           TO ME01-STATEMENT-LP-A
044400                                    ME01-STATEMENT-RP-A
044500         MOVE MMEF-STATEMENT-FEE TO ME01-STATEMENT
044600     ELSE
044700         IF  ME01-STATEMENT IS NUMERIC
044800             MOVE DFHBMASF       TO ME01-STATEMENT-A
044900             MOVE DFHBMDAS       TO ME01-STATEMENT-LP-A
045000                                    ME01-STATEMENT-RP-A
045100             SET WS-UPDATE-SW-YES
045200                                 TO TRUE
045300         ELSE
045400             MOVE DFHBMNBF       TO ME01-STATEMENT-A
045500             MOVE DFHBMASB       TO ME01-STATEMENT-LP-A
045600                                    ME01-STATEMENT-RP-A
045700             MOVE SS08WS-CURSOR  TO ME01-STATEMENT-L
045800             SET SS08WS-ERROR-SW-YES TO TRUE.
045900*
046000*            ***** KEYED TXN FEE *****                        *
046100*
046200     IF  ME01-KEYED-TXN-L IS LESS THAN 1
046300         MOVE DFHBMASK           TO ME01-KEYED-TXN-A
046400         MOVE DFHBMDAS           TO ME01-KEYED-TXN-LP-A
046500                                    ME01-KEYED-TXN-RP-A
046600         MOVE MMEF-KEYED-FEE     TO ME01-KEYED-TXN
046700     ELSE
046800         IF  ME01-KEYED-TXN IS NUMERIC
046900             MOVE DFHBMASF       TO ME01-KEYED-TXN-A
047000             MOVE DFHBMDAS       TO ME01-KEYED-TXN-LP-A
047100                                    ME01-KEYED-TXN-RP-A
047200             SET WS-UPDATE-SW-YES
047300                                 TO TRUE
047400         ELSE
047500             MOVE DFHBMNBF       TO ME01-KEYED-TXN-A
047600             MOVE DFHBMASB       TO ME01-KEYED-TXN-LP-A
047700                                    ME01-KEYED-TXN-RP-A
047800             MOVE SS08WS-CURSOR  TO ME01-KEYED-TXN-L
047900             SET SS08WS-ERROR-SW-YES TO TRUE.
048000*
048100*            ***** MEMBERSHIP FEE *****                        *
048200*
048300     IF  ME01-MEMBERSHIP-L IS LESS THAN 1
048400         MOVE DFHBMASK           TO ME01-MEMBERSHIP-A
048500         MOVE DFHBMDAS           TO ME01-MEMBERSHIP-LP-A
048600                                    ME01-MEMBERSHIP-RP-A
048700         MOVE MMEF-MEMBERSHIP-FEE
048800                                 TO ME01-MEMBERSHIP
048900     ELSE
049000         IF  ME01-MEMBERSHIP IS NUMERIC
049100             MOVE DFHBMASF       TO ME01-MEMBERSHIP-A
049200             MOVE DFHBMDAS       TO ME01-MEMBERSHIP-LP-A
049300                                    ME01-MEMBERSHIP-RP-A
049400             SET WS-UPDATE-SW-YES
049500                                 TO TRUE
049600         ELSE
049700             MOVE DFHBMNBF       TO ME01-MEMBERSHIP-A
049800             MOVE DFHBMASB       TO ME01-MEMBERSHIP-LP-A
049900                                    ME01-MEMBERSHIP-RP-A
050000             MOVE SS08WS-CURSOR  TO ME01-MEMBERSHIP-L
050100             SET SS08WS-ERROR-SW-YES TO TRUE.
050200*
050300*            ***** SWIPED TXN FEE *****                       *
050400*
050500     IF  ME01-SWIPED-TXN-L IS LESS THAN 1
050600         MOVE DFHBMASK           TO ME01-SWIPED-TXN-A
050700         MOVE DFHBMDAS           TO ME01-SWIPED-TXN-LP-A
050800                                    ME01-SWIPED-TXN-RP-A
050900         MOVE MMEF-SWIPED-FEE    TO ME01-SWIPED-TXN
051000     ELSE
051100         IF  ME01-SWIPED-TXN IS NUMERIC
051200             MOVE DFHBMASF       TO ME01-SWIPED-TXN-A
051300             MOVE DFHBMDAS       TO ME01-SWIPED-TXN-LP-A
051400                                    ME01-SWIPED-TXN-RP-A
051500             SET WS-UPDATE-SW-YES
051600                                 TO TRUE
051700         ELSE
051800             MOVE DFHBMNBF       TO ME01-SWIPED-TXN-A
051900             MOVE DFHBMASB       TO ME01-SWIPED-TXN-LP-A
052000                                    ME01-SWIPED-TXN-RP-A
052100             MOVE SS08WS-CURSOR  TO ME01-SWIPED-TXN-L
052200             SET SS08WS-ERROR-SW-YES TO TRUE.
052300*
052400*            ***** USER INPUT FEE *****                       *
052500*
052600     IF  ME01-USER-INPUT-L IS LESS THAN 1
052700         MOVE DFHBMASK           TO ME01-USER-INPUT-A
052800         MOVE DFHBMDAS           TO ME01-USER-INPUT-LP-A
052900                                    ME01-USER-INPUT-RP-A
053000         MOVE MMEF-USER-INP-FEE  TO ME01-USER-INPUT
053100     ELSE
053200         IF  ME01-USER-INPUT IS NUMERIC
053300             MOVE DFHBMASF       TO ME01-USER-INPUT-A
053400             MOVE DFHBMDAS       TO ME01-USER-INPUT-LP-A
053500                                    ME01-USER-INPUT-RP-A
053600             SET WS-UPDATE-SW-YES
053700                                 TO TRUE
053800         ELSE
053900             MOVE DFHBMNBF       TO ME01-USER-INPUT-A
054000             MOVE DFHBMASB       TO ME01-USER-INPUT-LP-A
054100                                    ME01-USER-INPUT-RP-A
054200             MOVE SS08WS-CURSOR  TO ME01-USER-INPUT-L
054300             SET SS08WS-ERROR-SW-YES TO TRUE.
054400*
054500*            ***** SETUP FEE *****                             *
054600*
054700     IF  ME01-SETUP-L IS LESS THAN 1
054800         MOVE DFHBMASK           TO ME01-SETUP-A
054900         MOVE DFHBMDAS           TO ME01-SETUP-LP-A
055000                                    ME01-SETUP-RP-A
055100         MOVE MMEF-SETUP-FEE     TO ME01-SETUP
055200     ELSE
055300         IF  ME01-SETUP IS NUMERIC
055400             MOVE DFHBMASF       TO ME01-SETUP-A
055500             MOVE DFHBMDAS       TO ME01-SETUP-LP-A
055600                                    ME01-SETUP-RP-A
055700             SET WS-UPDATE-SW-YES
055800                                 TO TRUE
055900         ELSE
056000             MOVE DFHBMNBF       TO ME01-SETUP-A
056100             MOVE DFHBMASB       TO ME01-SETUP-LP-A
056200                                    ME01-SETUP-RP-A
056300             MOVE SS08WS-CURSOR  TO ME01-SETUP-L
056400             SET SS08WS-ERROR-SW-YES TO TRUE.
056500*
056600*            ***** LOCAL INPUT FEE *****                       *
056700*
056800     IF  ME01-LOCAL-INPUT-L IS LESS THAN 1
056900         MOVE DFHBMASK           TO ME01-LOCAL-INPUT-A
057000         MOVE DFHBMDAS           TO ME01-LOCAL-INPUT-LP-A
057100                                    ME01-LOCAL-INPUT-RP-A
057200         MOVE MMEF-LOCAL-INP-FEE TO ME01-LOCAL-INPUT
057300     ELSE
057400         IF  ME01-LOCAL-INPUT IS NUMERIC
057500             MOVE DFHBMASF       TO ME01-LOCAL-INPUT-A
057600             MOVE DFHBMDAS       TO ME01-LOCAL-INPUT-LP-A
057700                                    ME01-LOCAL-INPUT-RP-A
057800             SET WS-UPDATE-SW-YES
057900                                 TO TRUE
058000         ELSE
058100             MOVE DFHBMNBF       TO ME01-LOCAL-INPUT-A
058200             MOVE DFHBMASB       TO ME01-LOCAL-INPUT-LP-A
058300                                    ME01-LOCAL-INPUT-RP-A
058400             MOVE SS08WS-CURSOR  TO ME01-LOCAL-INPUT-L
058500             SET SS08WS-ERROR-SW-YES TO TRUE.
058600*
058700*            ***** ADMIN FEE *****                             *
058800*
058900     IF  ME01-ADMINIST-L IS LESS THAN 1
059000         MOVE DFHBMASK           TO ME01-ADMINIST-A
059100         MOVE DFHBMDAS           TO ME01-ADMINIST-LP-A
059200                                    ME01-ADMINIST-RP-A
059300         MOVE MMEF-ADMIN-FEE     TO ME01-ADMINIST
059400     ELSE
059500         IF  ME01-ADMINIST IS NUMERIC
059600             MOVE DFHBMASF       TO ME01-ADMINIST-A
059700             MOVE DFHBMDAS       TO ME01-ADMINIST-LP-A
059800                                    ME01-ADMINIST-RP-A
059900             SET WS-UPDATE-SW-YES
060000                                 TO TRUE
060100         ELSE
060200             MOVE DFHBMNBF       TO ME01-ADMINIST-A
060300             MOVE DFHBMASB       TO ME01-ADMINIST-LP-A
060400                                    ME01-ADMINIST-RP-A
060500             MOVE SS08WS-CURSOR  TO ME01-ADMINIST-L
060600             SET SS08WS-ERROR-SW-YES TO TRUE.
060700*
060800*            ***** CHECK FEE *****                             *
060900*
061000     IF  ME01-CHECK-L IS LESS THAN 1
061100         MOVE DFHBMASK           TO ME01-CHECK-A
061200         MOVE DFHBMDAS           TO ME01-CHECK-LP-A
061300                                    ME01-CHECK-RP-A
061400         MOVE MMEF-CHECK-APPR-FEE
061500                                 TO ME01-CHECK
061600     ELSE
061700         IF  ME01-CHECK IS NUMERIC
061800             MOVE DFHBMASF       TO ME01-CHECK-A
061900             MOVE DFHBMDAS       TO ME01-CHECK-LP-A
062000                                    ME01-CHECK-RP-A
062100             SET WS-UPDATE-SW-YES
062200                                 TO TRUE
062300         ELSE
062400             MOVE DFHBMNBF       TO ME01-CHECK-A
062500             MOVE DFHBMASB       TO ME01-CHECK-LP-A
062600                                    ME01-CHECK-RP-A
062700             MOVE SS08WS-CURSOR  TO ME01-CHECK-L
062800             SET SS08WS-ERROR-SW-YES TO TRUE.
062900*
063000*            ***** ADJUSTMENT FEE *****                        *
063100*
063200     IF  ME01-ADJUSTMENT-L IS LESS THAN 1
063300         MOVE DFHBMASK           TO ME01-ADJUSTMENT-A
063400         MOVE DFHBMDAS           TO ME01-ADJUSTMENT-LP-A
063500                                    ME01-ADJUSTMENT-RP-A
063600         MOVE MMEF-ADJ-INPUT-FEE TO ME01-ADJUSTMENT
063700     ELSE
063800         IF  ME01-ADJUSTMENT IS NUMERIC
063900             MOVE DFHBMASF       TO ME01-ADJUSTMENT-A
064000             MOVE DFHBMDAS       TO ME01-ADJUSTMENT-LP-A
064100                                    ME01-ADJUSTMENT-RP-A
064200             SET WS-UPDATE-SW-YES
064300                                 TO TRUE
064400         ELSE
064500             MOVE DFHBMNBF       TO ME01-ADJUSTMENT-A
064600             MOVE DFHBMASB       TO ME01-ADJUSTMENT-LP-A
064700                                    ME01-ADJUSTMENT-RP-A
064800             MOVE SS08WS-CURSOR  TO ME01-ADJUSTMENT-L
064900             SET SS08WS-ERROR-SW-YES TO TRUE.
065000*
065100*            ***** CHARGE BACK FEE *****                       *
065200*
065300     IF  ME01-CHARGEBACK-L IS LESS THAN 1
065400         MOVE DFHBMASK           TO ME01-CHARGEBACK-A
065500         MOVE DFHBMDAS           TO ME01-CHARGEBACK-LP-A
065600                                    ME01-CHARGEBACK-RP-A
065700         MOVE MMEF-CHGBACK-FEE   TO ME01-CHARGEBACK
065800     ELSE
065900         IF  ME01-CHARGEBACK IS NUMERIC
066000             MOVE DFHBMASF       TO ME01-CHARGEBACK-A
066100             MOVE DFHBMDAS       TO ME01-CHARGEBACK-LP-A
066200                                    ME01-CHARGEBACK-RP-A
066300             SET WS-UPDATE-SW-YES
066400                                 TO TRUE
066500         ELSE
066600             MOVE DFHBMNBF       TO ME01-CHARGEBACK-A
066700             MOVE DFHBMASB       TO ME01-CHARGEBACK-LP-A
066800                                    ME01-CHARGEBACK-RP-A
066900             MOVE SS08WS-CURSOR  TO ME01-CHARGEBACK-L
067000             SET SS08WS-ERROR-SW-YES TO TRUE.
067100*
067200*            ***** ACH FEE *****                               *
067300*
067400     IF  ME01-ACH-FEE-L IS LESS THAN 1
067500         MOVE DFHBMASK           TO ME01-ACH-FEE-A
067600         MOVE DFHBMDAS           TO ME01-ACH-FEE-LP-A
067700                                    ME01-ACH-FEE-RP-A
067800         MOVE MMEF-ACH-FEE       TO ME01-ACH-FEE
067900     ELSE
068000         IF  ME01-ACH-FEE IS NUMERIC
068100             MOVE DFHBMASF       TO ME01-ACH-FEE-A
068200             MOVE DFHBMDAS       TO ME01-ACH-FEE-LP-A
068300                                    ME01-ACH-FEE-RP-A
068400             SET WS-UPDATE-SW-YES
068500                                 TO TRUE
068600         ELSE
068700             MOVE DFHBMNBF       TO ME01-ACH-FEE-A
068800             MOVE DFHBMASB       TO ME01-ACH-FEE-LP-A
068900                                    ME01-ACH-FEE-RP-A
069000             MOVE SS08WS-CURSOR  TO ME01-ACH-FEE-L
069100             SET SS08WS-ERROR-SW-YES TO TRUE.
069200*
069300*            ***** POS 1 CAPTURE FEE *****                     *
069400*
069500     IF  ME01-POS-1-CAPTURE-L IS LESS THAN 1
069600         MOVE DFHBMASK           TO ME01-POS-1-CAPTURE-A
069700         MOVE DFHBMDAS           TO ME01-POS-1-CAPTURE-LP-A
069800                                    ME01-POS-1-CAPTURE-RP-A
069900         MOVE MMEF-POS-1-CAP-FEE TO ME01-POS-1-CAPTURE
070000     ELSE
070100         IF  ME01-POS-1-CAPTURE IS NUMERIC
070200             MOVE DFHBMASF       TO ME01-POS-1-CAPTURE-A
070300             MOVE DFHBMDAS       TO ME01-POS-1-CAPTURE-LP-A
070400                                    ME01-POS-1-CAPTURE-RP-A
070500             SET WS-UPDATE-SW-YES
070600                                 TO TRUE
070700         ELSE
070800             MOVE DFHBMNBF       TO ME01-POS-1-CAPTURE-A
070900             MOVE DFHBMASB       TO ME01-POS-1-CAPTURE-LP-A
071000                                    ME01-POS-1-CAPTURE-RP-A
071100             MOVE SS08WS-CURSOR  TO ME01-POS-1-CAPTURE-L
071200             SET SS08WS-ERROR-SW-YES TO TRUE.
071300*
071400*            ***** POS 2 CAPTURE FEE *****                     *
071500*
071600     IF  ME01-POS-2-CAPTURE-L IS LESS THAN 1
071700         MOVE DFHBMASK           TO ME01-POS-2-CAPTURE-A
071800         MOVE DFHBMDAS           TO ME01-POS-2-CAPTURE-LP-A
071900                                    ME01-POS-2-CAPTURE-RP-A
072000         MOVE MMEF-POS-2-CAP-FEE TO ME01-POS-2-CAPTURE
072100     ELSE
072200         IF  ME01-POS-2-CAPTURE IS NUMERIC
072300             MOVE DFHBMASF       TO ME01-POS-2-CAPTURE-A
072400             MOVE DFHBMDAS       TO ME01-POS-2-CAPTURE-LP-A
072500                                    ME01-POS-2-CAPTURE-RP-A
072600             SET WS-UPDATE-SW-YES
072700                                 TO TRUE
072800         ELSE
072900             MOVE DFHBMNBF       TO ME01-POS-2-CAPTURE-A
073000             MOVE DFHBMASB       TO ME01-POS-2-CAPTURE-LP-A
073100                                    ME01-POS-2-CAPTURE-RP-A
073200             MOVE SS08WS-CURSOR  TO ME01-POS-2-CAPTURE-L
073300             SET SS08WS-ERROR-SW-YES TO TRUE.
073400*
073500*            ***** POS 3 CAPTURE FEE *****                     *
073600*
073700     IF  ME01-POS-3-CAPTURE-L IS LESS THAN 1
073800         MOVE DFHBMASK           TO ME01-POS-3-CAPTURE-A
073900         MOVE DFHBMDAS           TO ME01-POS-3-CAPTURE-LP-A
074000                                    ME01-POS-3-CAPTURE-RP-A
074100         MOVE MMEF-POS-3-CAP-FEE TO ME01-POS-3-CAPTURE
074200     ELSE
074300         IF  ME01-POS-3-CAPTURE IS NUMERIC
074400             MOVE DFHBMASF       TO ME01-POS-3-CAPTURE-A
074500             MOVE DFHBMDAS       TO ME01-POS-3-CAPTURE-LP-A
074600                                    ME01-POS-3-CAPTURE-RP-A
074700             SET WS-UPDATE-SW-YES
074800                                 TO TRUE
074900         ELSE
075000             MOVE DFHBMNBF       TO ME01-POS-3-CAPTURE-A
075100             MOVE DFHBMASB       TO ME01-POS-3-CAPTURE-LP-A
075200                                    ME01-POS-3-CAPTURE-RP-A
075300             MOVE SS08WS-CURSOR  TO ME01-POS-3-CAPTURE-L
075400             SET SS08WS-ERROR-SW-YES TO TRUE.
075500*
075600*            ***** IN STORE PMT FEE *****                      *
075700*
075800     IF  ME01-IN-STORE-PMT-L IS LESS THAN 1
075900         MOVE DFHBMASK           TO ME01-IN-STORE-PMT-A
076000         MOVE DFHBMDAS           TO ME01-IN-STORE-PMT-LP-A
076100                                    ME01-IN-STORE-PMT-RP-A
076200         MOVE MMEF-IN-STORE-PMT-FEE
076300                                 TO ME01-IN-STORE-PMT
076400     ELSE
076500         IF  ME01-IN-STORE-PMT IS NUMERIC
076600             MOVE DFHBMASF       TO ME01-IN-STORE-PMT-A
076700             MOVE DFHBMDAS       TO ME01-IN-STORE-PMT-LP-A
076800                                    ME01-IN-STORE-PMT-RP-A
076900             SET WS-UPDATE-SW-YES
077000                                 TO TRUE
077100         ELSE
077200             MOVE DFHBMNBF       TO ME01-IN-STORE-PMT-A
077300             MOVE DFHBMASB       TO ME01-IN-STORE-PMT-LP-A
077400                                    ME01-IN-STORE-PMT-RP-A
077500             MOVE SS08WS-CURSOR  TO ME01-IN-STORE-PMT-L
077600             SET SS08WS-ERROR-SW-YES TO TRUE.
077700*
077800     IF  SS08WS-ERROR-SW-NO
077900         GO TO 2400-UPDATE-FILE.
078000*
078100****************************************************************
078200*    FORMAT THE MESSAGE LINE                                   *
078300****************************************************************
078400*
078500     IF ME01-ERR-MESSAGE EQUAL TO SPACES OR LOW-VALUES
078600          PERFORM MB06PD-FORMAT-MESSAGE-LINE
078700                THRU MB06PD-FML-EXIT
078800          MOVE SS08WS-FORMATTED-MSG TO ME01-ERR-MESSAGE.
078900*
079000****************************************************************
079100*    SEND THE MAP                                              *
079200****************************************************************
079300*
079400     PERFORM MB60PD-INIT-STD-MAP-LINES
079500                                 THRU MB60PD-ISML-EXIT.
079600     MOVE 'BM03'                 TO MBCA-PROGRAM-LOCATION.
079700     PERFORM MB60PD-SEND-MAP-DATA-ONLY
079800                                 THRU MB60PD-SMDO-EXIT.
079900*
080000****************************************************************
080100*    RETURN TO CICS                                            *
080200****************************************************************
080300*
080400     MOVE 'PC04'                 TO MBCA-PROGRAM-LOCATION.
080500     MOVE 01                     TO MBCA-SCREEN-NBR.
080600     PERFORM MB70PD-RETURN-TRANS-ID
080700                                 THRU MB70PD-RTI-EXIT.
080800/
080900 2400-UPDATE-FILE.
081000*
081100     IF  WS-UPDATE-SW-NO
081200         IF  MBCA-PTI-FUNCTION-IS-ADD
081300             MOVE 'FC03'         TO MBCA-PROGRAM-LOCATION
081400             MOVE MBCA-MERCHANT-ORG
081500                                 TO MBIOWS-MMEF-ORG
081600             MOVE MBCA-TABLE     TO MBIOWS-MMEF-TABLE
081700             SET MBIORO-READ-RANDOM-UPDATE
081800                                 TO TRUE
081900             PERFORM MMEFAO-ACCESS
082000                                 THRU MMEFAO-ACCESS-EXIT
082100             MOVE MBCA-SCREEN-NBR
082200                                 TO MMEF-ONLINE-STATUS
082300             MOVE 'FC04'         TO MBCA-PROGRAM-LOCATION
082400             SET MBIORO-REWRITE  TO TRUE
082500             PERFORM MMEFAO-ACCESS
082600                                 THRU MMEFAO-ACCESS-EXIT
082700             GO TO 2600-SETUP-COMMAREA
082800         ELSE
082900             GO TO 2600-SETUP-COMMAREA.
083000*
083100****************************************************************
083200*    GETMAIN FOR LOG/JOURNAL RECORD                            *
083300****************************************************************
083400*
083500     MOVE 'SC02'                 TO MBCA-PROGRAM-LOCATION.
083600     SET MBIORO-GETMAIN          TO TRUE.
083700     PERFORM MML1AO-ACCESS       THRU MML1AO-ACCESS-EXIT.
083800*
083900****************************************************************
084000*    READ THE EXPENSE RECORD FOR UPDATE                        *
084100****************************************************************
084200*
084300     MOVE 'FC05'                 TO MBCA-PROGRAM-LOCATION.
084400     MOVE MBCA-MERCHANT-ORG      TO MBIOWS-MMEF-ORG.
084500     MOVE MBCA-TABLE             TO MBIOWS-MMEF-TABLE.
084600     SET MBIORO-READ-RANDOM-UPDATE
084700                                 TO TRUE.
084800     PERFORM MMEFAO-ACCESS       THRU MMEFAO-ACCESS-EXIT.
084900*
085000*            ***** TABLE NAME *****                            *
085100*
085200     IF  ME01-TABLE-NAME-L IS GREATER THAN ZERO
085300         MOVE ZEROES             TO MML1-FIELD-OCCURRENCE
085400         MOVE 0101               TO MML1-FIELD-CODE
085500         MOVE MML1WS-VL-30       TO MML1-VARIABLE-LENGTH
085600         MOVE MMEF-TABLE-NAME    TO MML1-VL30-B-DATA-X
085700         MOVE ME01-TABLE-NAME    TO MMEF-TABLE-NAME
085800         MOVE MMEF-TABLE-NAME    TO MML1-VL30-A-DATA-X
085900         PERFORM 9050-CREATE-MAINT-RECORD
086000                                 THRU 9099-CMR-EXIT.
086100*
086200*            ***** SALES FEE *****                            *
086300*
086400     IF  ME01-SALES-L IS GREATER THAN ZEROES
086500         MOVE ZEROES             TO MML1-FIELD-OCCURRENCE
086600         MOVE 0102               TO MML1-FIELD-CODE
086700         MOVE MML1WS-VL-20       TO MML1-VARIABLE-LENGTH
086800         MOVE MMEF-SALES-FEE     TO MML1-VL20-B-NBR-NO-DEC
086900         MOVE ME01-SALES         TO MMEF-SALES-FEE
087000         MOVE MMEF-SALES-FEE     TO MML1-VL20-A-NBR-NO-DEC
087100         PERFORM 9050-CREATE-MAINT-RECORD
087200                                 THRU 9099-CMR-EXIT.
087300*
087400*            ***** RETRIEVAL FEE *****                        *
087500*
087600     IF  ME01-RETRIEVAL-L IS GREATER THAN ZEROES
087700         MOVE ZEROES             TO MML1-FIELD-OCCURRENCE
087800         MOVE 0123               TO MML1-FIELD-CODE
087900         MOVE MML1WS-VL-20       TO MML1-VARIABLE-LENGTH
088000         MOVE MMEF-RETRIEVAL-FEE TO MML1-VL20-B-NBR-NO-DEC
088100         MOVE ME01-RETRIEVAL     TO MMEF-RETRIEVAL-FEE
088200         MOVE MMEF-RETRIEVAL-FEE TO MML1-VL20-A-NBR-NO-DEC
088300         PERFORM 9050-CREATE-MAINT-RECORD
088400                                 THRU 9099-CMR-EXIT.
088500*
088600*            ***** LOCATION FEE *****                     *
088700*
088800     IF  ME01-LOCATION-FEE-L IS GREATER THAN ZEROES
088900         MOVE ZEROES             TO MML1-FIELD-OCCURRENCE
089000         MOVE 0103               TO MML1-FIELD-CODE
089100         MOVE MML1WS-VL-20       TO MML1-VARIABLE-LENGTH
089200         MOVE MMEF-LOCATION-FEE  TO MML1-VL20-B-NBR-NO-DEC
089300         MOVE ME01-LOCATION-FEE  TO MMEF-LOCATION-FEE
089400         MOVE MMEF-LOCATION-FEE  TO MML1-VL20-A-NBR-NO-DEC
089500         PERFORM 9050-CREATE-MAINT-RECORD
089600                                 THRU 9099-CMR-EXIT.
089700*
089800*            ***** RETURN FEE *****                           *
089900*
090000     IF  ME01-RETURN-L IS GREATER THAN ZEROES
090100         MOVE ZEROES             TO MML1-FIELD-OCCURRENCE
090200         MOVE 0104               TO MML1-FIELD-CODE
090300         MOVE MML1WS-VL-20       TO MML1-VARIABLE-LENGTH
090400         MOVE MMEF-RETURNS-FEE   TO MML1-VL20-B-NBR-NO-DEC
090500         MOVE ME01-RETURN        TO MMEF-RETURNS-FEE
090600         MOVE MMEF-RETURNS-FEE   TO MML1-VL20-A-NBR-NO-DEC
090700         PERFORM 9050-CREATE-MAINT-RECORD
090800                                 THRU 9099-CMR-EXIT.
090900*
091000*            ***** BULLETIN FEE *****                     *
091100*
091200     IF  ME01-BULLETIN-FEE-L IS GREATER THAN ZEROES
091300         MOVE ZEROES             TO MML1-FIELD-OCCURRENCE
091400         MOVE 0105               TO MML1-FIELD-CODE
091500         MOVE MML1WS-VL-20       TO MML1-VARIABLE-LENGTH
091600         MOVE MMEF-BULLETIN-FEE  TO MML1-VL20-B-NBR-NO-DEC
091700         MOVE ME01-BULLETIN-FEE  TO MMEF-BULLETIN-FEE
091800         MOVE MMEF-BULLETIN-FEE  TO MML1-VL20-A-NBR-NO-DEC
091900         PERFORM 9050-CREATE-MAINT-RECORD
092000                                 THRU 9099-CMR-EXIT.
092100*
092200*            ***** BATCH HDR FEE *****                        *
092300*
092400     IF  ME01-BATCH-HDR-L IS GREATER THAN ZEROES
092500         MOVE ZEROES             TO MML1-FIELD-OCCURRENCE
092600         MOVE 0106               TO MML1-FIELD-CODE
092700         MOVE MML1WS-VL-20       TO MML1-VARIABLE-LENGTH
092800         MOVE MMEF-BATCH-HDR-FEE
092900                                 TO MML1-VL20-B-NBR-NO-DEC
093000         MOVE ME01-BATCH-HDR     TO MMEF-BATCH-HDR-FEE
093100         MOVE MMEF-BATCH-HDR-FEE
093200                                 TO MML1-VL20-A-NBR-NO-DEC
093300         PERFORM 9050-CREATE-MAINT-RECORD
093400                                 THRU 9099-CMR-EXIT.
093500*
093600*            ***** STATEMENT FEE *****                         *
093700*
093800     IF  ME01-STATEMENT-L IS GREATER THAN ZEROES
093900         MOVE ZEROES             TO MML1-FIELD-OCCURRENCE
094000         MOVE 0107               TO MML1-FIELD-CODE
094100         MOVE MML1WS-VL-20       TO MML1-VARIABLE-LENGTH
094200         MOVE MMEF-STATEMENT-FEE TO MML1-VL20-B-NBR-NO-DEC
094300         MOVE ME01-STATEMENT     TO MMEF-STATEMENT-FEE
094400         MOVE MMEF-STATEMENT-FEE TO MML1-VL20-A-NBR-NO-DEC
094500         PERFORM 9050-CREATE-MAINT-RECORD
094600                                 THRU 9099-CMR-EXIT.
094700*
094800*            ***** KEYED TXN FEE *****                        *
094900*
095000     IF  ME01-KEYED-TXN-L IS GREATER THAN ZEROES
095100         MOVE ZEROES             TO MML1-FIELD-OCCURRENCE
095200         MOVE 0108               TO MML1-FIELD-CODE
095300         MOVE MML1WS-VL-20       TO MML1-VARIABLE-LENGTH
095400         MOVE MMEF-KEYED-FEE     TO MML1-VL20-B-NBR-NO-DEC
095500         MOVE ME01-KEYED-TXN     TO MMEF-KEYED-FEE
095600         MOVE MMEF-KEYED-FEE     TO MML1-VL20-A-NBR-NO-DEC
095700         PERFORM 9050-CREATE-MAINT-RECORD
095800                                 THRU 9099-CMR-EXIT.
095900*
096000*            ***** MEMBERSHIP FEE *****                        *
096100*
096200     IF  ME01-MEMBERSHIP-L IS GREATER THAN ZEROES
096300         MOVE ZEROES             TO MML1-FIELD-OCCURRENCE
096400         MOVE 0109               TO MML1-FIELD-CODE
096500         MOVE MML1WS-VL-20       TO MML1-VARIABLE-LENGTH
096600         MOVE MMEF-MEMBERSHIP-FEE
096700                                 TO MML1-VL20-B-NBR-NO-DEC
096800         MOVE ME01-MEMBERSHIP    TO MMEF-MEMBERSHIP-FEE
096900         MOVE MMEF-MEMBERSHIP-FEE
097000                                 TO MML1-VL20-A-NBR-NO-DEC
097100         PERFORM 9050-CREATE-MAINT-RECORD
097200                                 THRU 9099-CMR-EXIT.
097300*
097400*            ***** SWIPED TXN FEE *****                       *
097500*
097600     IF  ME01-SWIPED-TXN-L IS GREATER THAN ZEROES
097700         MOVE ZEROES             TO MML1-FIELD-OCCURRENCE
097800         MOVE 0110               TO MML1-FIELD-CODE
097900         MOVE MML1WS-VL-20       TO MML1-VARIABLE-LENGTH
098000         MOVE MMEF-SWIPED-FEE    TO MML1-VL20-B-NBR-NO-DEC
098100         MOVE ME01-SWIPED-TXN    TO MMEF-SWIPED-FEE
098200         MOVE MMEF-SWIPED-FEE    TO MML1-VL20-A-NBR-NO-DEC
098300         PERFORM 9050-CREATE-MAINT-RECORD
098400                                 THRU 9099-CMR-EXIT.
098500*
098600*            ***** USER INPUT FEE *****                       *
098700*
098800     IF  ME01-USER-INPUT-L IS GREATER THAN ZEROES
098900         MOVE ZEROES             TO MML1-FIELD-OCCURRENCE
099000         MOVE 0111               TO MML1-FIELD-CODE
099100         MOVE MML1WS-VL-20       TO MML1-VARIABLE-LENGTH
099200         MOVE MMEF-USER-INP-FEE  TO MML1-VL20-B-NBR-NO-DEC
099300         MOVE ME01-USER-INPUT    TO MMEF-USER-INP-FEE
099400         MOVE MMEF-USER-INP-FEE  TO MML1-VL20-A-NBR-NO-DEC
099500         PERFORM 9050-CREATE-MAINT-RECORD
099600                                 THRU 9099-CMR-EXIT.
099700*
099800*            ***** SETUP FEE *****                             *
099900*
100000     IF  ME01-SETUP-L IS GREATER THAN ZEROES
100100         MOVE ZEROES             TO MML1-FIELD-OCCURRENCE
100200         MOVE 0112               TO MML1-FIELD-CODE
100300         MOVE MML1WS-VL-20       TO MML1-VARIABLE-LENGTH
100400         MOVE MMEF-SETUP-FEE     TO MML1-VL20-B-NBR-NO-DEC
100500         MOVE ME01-SETUP         TO MMEF-SETUP-FEE
100600         MOVE MMEF-SETUP-FEE     TO MML1-VL20-A-NBR-NO-DEC
100700         PERFORM 9050-CREATE-MAINT-RECORD
100800                                 THRU 9099-CMR-EXIT.
100900*
101000*            ***** LOCAL INPUT FEE *****                       *
101100*
101200     IF  ME01-LOCAL-INPUT-L IS GREATER THAN ZEROES
101300         MOVE ZEROES             TO MML1-FIELD-OCCURRENCE
101400         MOVE 0113               TO MML1-FIELD-CODE
101500         MOVE MML1WS-VL-20       TO MML1-VARIABLE-LENGTH
101600         MOVE MMEF-LOCAL-INP-FEE TO MML1-VL20-B-NBR-NO-DEC
101700         MOVE ME01-LOCAL-INPUT   TO MMEF-LOCAL-INP-FEE
101800         MOVE MMEF-LOCAL-INP-FEE TO MML1-VL20-A-NBR-NO-DEC
101900         PERFORM 9050-CREATE-MAINT-RECORD
102000                                 THRU 9099-CMR-EXIT.
102100*
102200*            ***** ADMINISTRATOR FEE *****                     *
102300*
102400     IF  ME01-ADMINIST-L IS GREATER THAN ZEROES
102500         MOVE ZEROES             TO MML1-FIELD-OCCURRENCE
102600         MOVE 0114               TO MML1-FIELD-CODE
102700         MOVE MML1WS-VL-20       TO MML1-VARIABLE-LENGTH
102800         MOVE MMEF-ADMIN-FEE     TO MML1-VL20-B-NBR-NO-DEC
102900         MOVE ME01-ADMINIST      TO MMEF-ADMIN-FEE
103000         MOVE MMEF-ADMIN-FEE     TO MML1-VL20-A-NBR-NO-DEC
103100         PERFORM 9050-CREATE-MAINT-RECORD
103200                                 THRU 9099-CMR-EXIT.
103300*
103400*            ***** CHECK FEE *****                             *
103500*
103600     IF  ME01-CHECK-L IS GREATER THAN ZEROES
103700         MOVE ZEROES             TO MML1-FIELD-OCCURRENCE
103800         MOVE 0115               TO MML1-FIELD-CODE
103900         MOVE MML1WS-VL-20       TO MML1-VARIABLE-LENGTH
104000         MOVE MMEF-CHECK-APPR-FEE
104100                                 TO MML1-VL20-B-NBR-NO-DEC
104200         MOVE ME01-CHECK         TO MMEF-CHECK-APPR-FEE
104300         MOVE MMEF-CHECK-APPR-FEE
104400                                 TO MML1-VL20-A-NBR-NO-DEC
104500         PERFORM 9050-CREATE-MAINT-RECORD
104600                                 THRU 9099-CMR-EXIT.
104700*
104800*            ***** ADJUSTMENT FEE *****                        *
104900*
105000     IF  ME01-ADJUSTMENT-L IS GREATER THAN ZEROES
105100         MOVE ZEROES             TO MML1-FIELD-OCCURRENCE
105200         MOVE 0116               TO MML1-FIELD-CODE
105300         MOVE MML1WS-VL-20       TO MML1-VARIABLE-LENGTH
105400         MOVE MMEF-ADJ-INPUT-FEE TO MML1-VL20-B-NBR-NO-DEC
105500         MOVE ME01-ADJUSTMENT    TO MMEF-ADJ-INPUT-FEE
105600         MOVE MMEF-ADJ-INPUT-FEE TO MML1-VL20-A-NBR-NO-DEC
105700         PERFORM 9050-CREATE-MAINT-RECORD
105800                                 THRU 9099-CMR-EXIT.
105900*
106000*            ***** CHARGE BACK FEE *****                       *
106100*
106200     IF  ME01-CHARGEBACK-L IS GREATER THAN ZEROES
106300         MOVE ZEROES             TO MML1-FIELD-OCCURRENCE
106400         MOVE 0117               TO MML1-FIELD-CODE
106500         MOVE MML1WS-VL-20       TO MML1-VARIABLE-LENGTH
106600         MOVE MMEF-CHGBACK-FEE   TO MML1-VL20-B-NBR-NO-DEC
106700         MOVE ME01-CHARGEBACK    TO MMEF-CHGBACK-FEE
106800         MOVE MMEF-CHGBACK-FEE   TO MML1-VL20-A-NBR-NO-DEC
106900         PERFORM 9050-CREATE-MAINT-RECORD
107000                                 THRU 9099-CMR-EXIT.
107100*
107200*            ***** ACH FEE *****                               *
107300*
107400     IF  ME01-ACH-FEE-L IS GREATER THAN ZEROES
107500         MOVE ZEROES             TO MML1-FIELD-OCCURRENCE
107600         MOVE 0118               TO MML1-FIELD-CODE
107700         MOVE MML1WS-VL-20       TO MML1-VARIABLE-LENGTH
107800         MOVE MMEF-ACH-FEE       TO MML1-VL20-B-NBR-NO-DEC
107900         MOVE ME01-ACH-FEE       TO MMEF-ACH-FEE
108000         MOVE MMEF-ACH-FEE       TO MML1-VL20-A-NBR-NO-DEC
108100         PERFORM 9050-CREATE-MAINT-RECORD
108200                                 THRU 9099-CMR-EXIT.
108300*
108400*            ***** POS 1 CAPTURE FEE *****                     *
108500*
108600     IF  ME01-POS-1-CAPTURE-L IS GREATER THAN ZEROES
108700         MOVE ZEROES             TO MML1-FIELD-OCCURRENCE
108800         MOVE 0119               TO MML1-FIELD-CODE
108900         MOVE MML1WS-VL-20       TO MML1-VARIABLE-LENGTH
109000         MOVE MMEF-POS-1-CAP-FEE TO MML1-VL20-B-NBR-NO-DEC
109100         MOVE ME01-POS-1-CAPTURE TO MMEF-POS-1-CAP-FEE
109200         MOVE MMEF-POS-1-CAP-FEE TO MML1-VL20-A-NBR-NO-DEC
109300         PERFORM 9050-CREATE-MAINT-RECORD
109400                                 THRU 9099-CMR-EXIT.
109500*
109600*            ***** POS 2 CAPTURE FEE *****                     *
109700*
109800     IF  ME01-POS-2-CAPTURE-L IS GREATER THAN ZEROES
109900         MOVE ZEROES             TO MML1-FIELD-OCCURRENCE
110000         MOVE 0120               TO MML1-FIELD-CODE
110100         MOVE MML1WS-VL-20       TO MML1-VARIABLE-LENGTH
110200         MOVE MMEF-POS-2-CAP-FEE TO MML1-VL20-B-NBR-NO-DEC
110300         MOVE ME01-POS-2-CAPTURE TO MMEF-POS-2-CAP-FEE
110400         MOVE MMEF-POS-2-CAP-FEE TO MML1-VL20-A-NBR-NO-DEC
110500         PERFORM 9050-CREATE-MAINT-RECORD
110600                                 THRU 9099-CMR-EXIT.
110700*
110800*            ***** POS 3 CAPTURE FEE *****                     *
110900*
111000     IF  ME01-POS-3-CAPTURE-L IS GREATER THAN ZEROES
111100         MOVE ZEROES             TO MML1-FIELD-OCCURRENCE
111200         MOVE 0121               TO MML1-FIELD-CODE
111300         MOVE MML1WS-VL-20       TO MML1-VARIABLE-LENGTH
111400         MOVE MMEF-POS-3-CAP-FEE TO MML1-VL20-B-NBR-NO-DEC
111500         MOVE ME01-POS-3-CAPTURE TO MMEF-POS-3-CAP-FEE
111600         MOVE MMEF-POS-3-CAP-FEE TO MML1-VL20-A-NBR-NO-DEC
111700         PERFORM 9050-CREATE-MAINT-RECORD
111800                                 THRU 9099-CMR-EXIT.
111900*
112000*            ***** IN STORE PMT FEE  *****                     *
112100*
112200     IF  ME01-IN-STORE-PMT-L IS GREATER THAN ZEROES
112300         MOVE ZEROES             TO MML1-FIELD-OCCURRENCE
112400         MOVE 0122               TO MML1-FIELD-CODE
112500         MOVE MML1WS-VL-20       TO MML1-VARIABLE-LENGTH
112600         MOVE MMEF-IN-STORE-PMT-FEE
112700                                 TO MML1-VL20-B-NBR-NO-DEC
112800         MOVE ME01-IN-STORE-PMT  TO MMEF-IN-STORE-PMT-FEE
112900         MOVE MMEF-IN-STORE-PMT-FEE
113000                                 TO MML1-VL20-A-NBR-NO-DEC
113100         PERFORM 9050-CREATE-MAINT-RECORD
113200                                 THRU 9099-CMR-EXIT.
113300*
113400     IF  MBCA-PTI-FUNCTION-IS-ADD
113500         MOVE 01                 TO MMEF-ONLINE-STATUS.
113600*
113700*            ***** LAST MAINT DATE AND OPERATOR ID *****       *
113800*
113900     MOVE ZEROES                 TO MML1-FIELD-OCCURRENCE.
114000     MOVE 0199                   TO MML1-FIELD-CODE.
114100     MOVE MML1WS-VL-07           TO MML1-VARIABLE-LENGTH.
114200     MOVE MMEF-LAST-MAINT-DATE
114300                                 TO MML1-VL07-B-DATA-9.
114400     MOVE MBCA-START-DATE        TO MMEF-LAST-MAINT-DATE.
114500     MOVE MMEF-LAST-MAINT-DATE
114600                                 TO MML1-VL07-A-DATA-9.
114700     PERFORM 9050-CREATE-MAINT-RECORD
114800                                 THRU 9099-CMR-EXIT.
114900     MOVE 0198                   TO MML1-FIELD-CODE.
115000     MOVE MML1WS-VL-03           TO MML1-VARIABLE-LENGTH.
115100     MOVE MMEF-LAST-MAINT-OPER
115200                                 TO MML1-VL03-B-DATA-X.
115300     MOVE MBCA-OPERATOR-ID       TO MMEF-LAST-MAINT-OPER.
115400     MOVE MMEF-LAST-MAINT-OPER
115500                                 TO MML1-VL03-A-DATA-X.
115600     PERFORM 9050-CREATE-MAINT-RECORD
115700                                 THRU 9099-CMR-EXIT.
115800*
115900****************************************************************
116000*    UPDATE THE EXPENSE FILE                                   *
116100****************************************************************
116200*
116300     MOVE 'FC06'                 TO MBCA-PROGRAM-LOCATION.
116400     SET MBIORO-REWRITE          TO TRUE.
116500     PERFORM MMEFAO-ACCESS       THRU MMEFAO-ACCESS-EXIT.
116600*
116700 2600-SETUP-COMMAREA.
116800*
116900****************************************************************
117000*    SET UP COMMAREA FIELDS AND TRANSFER TO THE NEXT PROGRAM   *
117100****************************************************************
117200*
117300     MOVE MBCA-EIBAID            TO SS08WS-EIBAID.
117400*
117500     PERFORM MB60PD-EDIT-PAGE-NBR
117600                                 THRU MB60PD-EPN-EXIT.
117700*
117800     IF  SS08WS-VALID-PF-KEY
117900     OR  SS08WS-EIBAID-VALID-PF-KEY
118000         SET MBCA-INITIAL-SCREEN-NBR
118100                                 TO TRUE.
118200*
118300     MOVE 'PC05'                 TO MBCA-PROGRAM-LOCATION.
118400     PERFORM MB70PD-XCTL-TO-MBOXCTL
118500                                 THRU MB70PD-XTM-EXIT.
118600/
118700 9000-PERFORMED-ROUTINES-SECT SECTION.
118800*
118900 9050-CREATE-MAINT-RECORD.
119000*
119100*****************************************************************
119200*    THIS ROUTINE WILL CREATE THE COMMON DATA FOR ALL OF THE    *
119300*    LOG/JOURNAL TRANSACTIONS                                   *
119400*****************************************************************
119500*
119600     IF  MBCA-PTI-FUNCTION-IS-ADD
119700         GO TO 9099-CMR-EXIT.
119800*
119900     MOVE 'EF'                   TO MML1-FILE-CODE.
120000     MOVE MBCA-MERCHANT-ORG      TO MML1-MMEF-ORG.
120100     MOVE MBCA-TABLE             TO MML1-MMEF-TABLE-NBR.
120200     MOVE MBCA-SIGNON-NAME       TO MML1-SIGNON-NAME.
120300     MOVE MBCA-TERMINAL-ID       TO MML1-TERMINAL-ID.
120400     MOVE ZEROES                 TO MML1-SOURCE-CODE
120500                                    MML1-FIELD-OCCURRENCE-2.
120600*
120700*****************************************************************
120800*    WRITE THE LOG/JOURNAL FILE RECORD                          *
120900*****************************************************************
121000*
121100     MOVE 'FC07'                 TO MBCA-PROGRAM-LOCATION.
121200     SET MBIORO-WRITE            TO TRUE.
121300     PERFORM MML1AO-ACCESS       THRU MML1AO-ACCESS-EXIT.
121400     MOVE SPACES                 TO MML1-VARIABLE-AREA.
121500*
121600 9099-CMR-EXIT.
121700     EXIT.
121800/         JULIAN TO GREGORIAN DATE ROUTINE.
121900     COPY SS08PD.
122000/         DATE AND TIME EDIT ROUTINES.
122100     COPY SS26PD.
122200     COPY SS27PD.
122300/         CHECK DIGIT ROUTINE.
122400     COPY SS09PD.
122500/         LINE 24 PF KEYS ROUTINE
122600     COPY SS15PD.
122700/         EXPENSE RECORD ACCESS ROUTINES
122800     COPY MMEFAO.
122900/         LOG/JOURNAL ACCESS ROUTINES
123000     COPY MML1AO.
123100/         ON-LINE MAP ROUTINES
123200     COPY MB60PD REPLACING 'MBMAPXX' BY 'MBME01 '
123300                           MBMAPXXI BY MBME01I
123400                           MBMAPXXO BY MBME01O.
123500/         ON-LINE PROCEDURES
123600     COPY MB70PD.
123700/         MESSAGE FORMAT ROUTINE
123800     COPY MB06PD.
123900/
124000     COPY SMFTPXO.
