000100 IDENTIFICATION DIVISION.
000200 PROGRAM-ID. MBOME03.
000201*       RELEASE DATE=08/24/01.        REVISION LEVEL=08.06      *
000202*****************************************************************
000203*WARNING.  THIS COMPUTER PROGRAM IS PROTECTED BY COPYRIGHT LAW  *
000204*AND INTERNATIONAL TREATIES.  UNAUTHORIZED REPRODUCTION OR      *
000205*DISTRIBUTION OF THIS PROGRAM, OR ANY PORTION OF IT, MAY RESULT *
000206*IN SEVERE CIVIL AND CRIMINAL PENATLIES, AND WILL BE PROSECUTED *
000207*TO THE MAXIMUM EXTENT POSSIBLE UNDER THE LAW.                  *
000208*COPYRIGHT 1999 PAYSYS INTERNATIONAL, INC.  ALL RIGHTS RESERVED.*
000209*****************************************************************
000300*****************************************************************
000400*                                                               *
000500*   V - PLUS  M E R C H A N T   B A N K C A R D   S Y S T E M   *
000600*                                                               *
000700*      MBOME03 - ON-LINE MERCHANT EXPENSE FACTORS RECORD        *
000800*                ADD/MAINTENANCE/INQUIRY                        *
000900*                SCREEN 03                                      *
001000*                                                               *
001100*              1. TRANSIDS                                      *
001200*                 A. MBAE                                       *
001300*                 B. MBME                                       *
001400*                 C. MBQE                                       *
001500*              2. MAPS USED -                                   *
001600*                 A. MBME03 (MAP 03)                            *
001700*              3. FILES USED -                                  *
001800*                 A. MMEF   (MERCHANT EXPENSE FACTORS FILE)     *
001900*                 B. MML1   (LOG/JOURNAL FILE)                  *
002000*                                                               *
002100*****************************************************************
002200*
002300 ENVIRONMENT DIVISION.
002400 DATA DIVISION.
002500 WORKING-STORAGE SECTION.
002600 01  FILLER                  PIC  X(12)      VALUE '** WS-BEG **'.
002700*         I/O REQUEST BLOCK WORK AREAS
002800     COPY MBIOWS.
002900/         I/O REQUEST BLOCK
003000     COPY MBIORO.
003100/         LOG/JOURNAL WORK AREAS
003200     COPY MML1WS REPLACING ==:MML1:== BY ==MML1==.
003300/         DATE WORK AREAS
003400     COPY SS01WS.
003500/         ONLINE WORK AREAS
003600     COPY SS08WS.
003700/
003800     COPY SS00WS.
003900/
004000     COPY SMFTWS.
004100/
004200     COPY SMPTRL REPLACING ==:SMPT:== BY ==SMPT==.
004300/
004400     COPY MB61LK.
004500/         CHECK DIGIT WORK FIELDS
004600     COPY SS05WS.
004700/
004800 01  WS-WORK-AREAS.
004900     03  WS-UPDATE-SW        PIC  X(01)      VALUE 'N'.
005000         88  WS-UPDATE-SW-NO                 VALUE 'N'.
005100         88  WS-UPDATE-SW-YES                VALUE 'Y'.
005200     03  WS-INDEX            PIC S9(04)      BINARY.
005300 01  FILLER                  PIC  X(12)      VALUE '** WS-END **'.
005400/
005500 LINKAGE SECTION.
005600 01  DFHCOMMAREA.
005700     COPY MB60WS.
005800/         ORG SCREEN 03 MAP DSECT
005900     COPY MBME03.
006000/         ORG SCREEN 03 MAP REDEFINITION
006100     COPY MBME03R.
006200/         MERCHANT EXPENSE FACTORS RECORD LAYOUT
006300     COPY MMIFRL REPLACING ==:MMIF:== BY ==MMEF==.
006400/         LOG/JOURNAL FILE RECORD LAYOUT
006500     COPY MML1RL REPLACING ==:MML1:== BY ==MML1==.
006600/
006700 PROCEDURE DIVISION.
006800 0000-HOUSEKEEPING SECTION.
006900 0100-INIT.
007000*
007100     MOVE 'PC01'                 TO MBCA-PROGRAM-LOCATION.
007200     PERFORM MB70PD-ON-LINE-HOUSEKEEPING
007300                                 THRU MB70PD-OLH-EXIT.
007400*
007500     IF  MBCA-RECEIVE-SCREEN
007600         GO TO 2000-RECEIVE-SCREEN.
007700/
007800 1000-SEND-SCREEN SECTION.
007900*
008000****************************************************************
008100*    THIS SECTION BUILDS AND SENDS THE 03 SCREEN.              *
008200****************************************************************
008300*
008400****************************************************************
008500*    GET CICS STORAGE NEEDED FOR THE MAP                       *
008600****************************************************************
008700*
008800     MOVE 'SC01'                 TO MBCA-PROGRAM-LOCATION.
008900     PERFORM MB60PD-GETMAIN-FOR-MAP
009000                                 THRU MB60PD-GFM-EXIT.
009100*
009200     MOVE MBCA-MERCHANT-ORG      TO ME03-ORG.
009300     MOVE MBCA-TABLE             TO ME03-TABLE-NBR.
009400     MOVE DFHBMASB               TO ME03-ORG-A
009500                                    ME03-TABLE-NBR-A.
009600     MOVE 03                     TO MBCA-SCREEN-NBR.
009700*
009800****************************************************************
009900*    INITIALIZE THE STANDARD MAP LINES                         *
010000****************************************************************
010100*
010200     PERFORM MB60PD-INIT-STD-MAP-LINES
010300                                 THRU MB60PD-ISML-EXIT.
010400*
010500****************************************************************
010600*    READ THE EXPENSE FACTORS FILE                            *
010700****************************************************************
010800*
010900     MOVE 'FC01'                 TO MBCA-PROGRAM-LOCATION.
011000     MOVE MBCA-MERCHANT-ORG      TO MBIOWS-MMEF-ORG.
011100     MOVE MBCA-TABLE             TO MBIOWS-MMEF-TABLE.
011200     SET MBIORO-READ-RANDOM      TO TRUE.
011300     PERFORM MMEFAO-ACCESS       THRU MMEFAO-ACCESS-EXIT.
011400/
011500 1100-BUILD-SCREEN.
011600*
011700****************************************************************
011800*    BUILD THE MAP FROM THE EXPENSE RECORD                     *
011900****************************************************************
012000*
012100     MOVE MMEF-TABLE-NAME        TO ME03-TABLE-NAME.
012200     MOVE DFHBMASB               TO ME03-TABLE-NAME-A.
012300*
012400     PERFORM
012500         VARYING X-MMEF-UFT FROM 1 BY 1
012600         UNTIL X-MMEF-UFT IS GREATER THAN 10
012700         SET X-ME03-UFT          TO X-MMEF-UFT
012800         MOVE MMEF-USER-FEE-AMT (X-MMEF-UFT)
012900                                 TO ME03-PERCENT-AMT (X-ME03-UFT)
013000         MOVE MMEF-USER-FEE-IND (X-MMEF-UFT)
013100                                 TO ME03-INDICATOR (X-ME03-UFT)
013200     END-PERFORM.
013300/
013400****************************************************************
013500*    IF INQUIRY, DARKEN PARENS AND ASKIP FIELDS                *
013600****************************************************************
013700*
013800     MOVE SS08WS-CURSOR          TO ME03-PERCENT-AMT-L (1).
013900*
014000     IF  MBCA-PTI-FUNCTION-IS-INQUIRY
014100         MOVE SS08WS-CURSOR      TO ME03-ALT-TRANID-L
014200         PERFORM
014300             VARYING X-ME03-UFT FROM 1 BY 1
014400             UNTIL X-ME03-UFT IS GREATER THAN 10
014500             MOVE DFHBMASB       TO ME03-PERCENT-AMT-A
014600                                    (X-ME03-UFT)
014700                                    ME03-INDICATOR-A
014800                                    (X-ME03-UFT)
014900         END-PERFORM
015000         PERFORM
015100             VARYING X-ME03-UFT FROM 1 BY 1
015200             UNTIL X-ME03-UFT IS GREATER THAN 10
015300             MOVE DFHBMDAS       TO ME03-PERCENT-AMT-LP-A
015400                                    (X-ME03-UFT)
015500                                    ME03-PERCENT-AMT-RP-A
015600                                    (X-ME03-UFT)
015700                                    ME03-INDICATOR-LP-A
015800                                    (X-ME03-UFT)
015900                                    ME03-INDICATOR-RP-A
016000                                    (X-ME03-UFT)
016100         END-PERFORM.
016200*
016300****************************************************************
016400*    FORMAT THE MESSAGE LINE                                   *
016500****************************************************************
016600*
016700     IF ME03-ERR-MESSAGE EQUAL TO SPACES OR LOW-VALUES
016800        PERFORM MB06PD-FORMAT-MESSAGE-LINE
016900           THRU MB06PD-FML-EXIT
017000        MOVE SS08WS-FORMATTED-MSG TO ME03-ERR-MESSAGE.
017100*
017200****************************************************************
017300*    SEND THE MAP                                              *
017400****************************************************************
017500*
017600     MOVE 'BM01'                 TO MBCA-PROGRAM-LOCATION.
017700     PERFORM MB60PD-SEND-MAP-WITH-ERASE
017800                                 THRU MB60PD-SMWE-EXIT.
017900*
018000****************************************************************
018100*    RETURN TO CICS                                            *
018200****************************************************************
018300*
018400     MOVE 'PC02'                 TO MBCA-PROGRAM-LOCATION.
018500     PERFORM MB70PD-RETURN-TRANS-ID
018600                                 THRU MB70PD-RTI-EXIT.
018700/
018800 2000-RECEIVE-SCREEN SECTION.
018900*
019000****************************************************************
019100*    THIS SECTION RECEIVES THE 03 SCREEN                       *
019200****************************************************************
019300*
019400     MOVE 'BM02'                 TO MBCA-PROGRAM-LOCATION.
019500     PERFORM MB60PD-RECEIVE-MAP  THRU MB60PD-RM-EXIT.
019600*
019700****************************************************************
019800*    CHECK FOR ANOTHER TRANSACTION ID ENTERED BY THE USER      *
019900****************************************************************
020000*
020100     MOVE 'PC03'                 TO MBCA-PROGRAM-LOCATION.
020200     PERFORM MB60PD-NEW-TRANS-ROUTINE
020300                                 THRU MB60PD-NTR-EXIT.
020400*
020500****************************************************************
020600*    BYPASS EDITS ON INQUIRY                                   *
020700****************************************************************
020800*
020900     IF  MBCA-PTI-FUNCTION-IS-INQUIRY
021000         GO TO 2600-SETUP-COMMAREA.
021100*
021200****************************************************************
021300*    READ THE EXPENSE FILE                                     *
021400****************************************************************
021500*
021600     MOVE 'FC02'                 TO MBCA-PROGRAM-LOCATION.
021700     MOVE MBCA-MERCHANT-ORG      TO MBIOWS-MMEF-ORG.
021800     MOVE MBCA-TABLE             TO MBIOWS-MMEF-TABLE.
021900     SET MBIORO-READ-RANDOM      TO TRUE.
022000     PERFORM MMEFAO-ACCESS       THRU MMEFAO-ACCESS-EXIT.
022100*
022200****************************************************************
022300*    EDIT FIELDS                                               *
022400****************************************************************
022500     PERFORM
022600         VARYING X-ME03-UFT FROM 1 BY 1
022700         UNTIL X-ME03-UFT IS GREATER THAN 10
022800         SET X-MMEF-UFT          TO X-ME03-UFT
022900*
023000*            ***** INDICATOR  *****                            *
023100*
023200         IF  ME03-INDICATOR-L (X-ME03-UFT) IS LESS THAN 1
023300             MOVE DFHBMASK       TO ME03-INDICATOR-A (X-ME03-UFT)
023400             MOVE DFHBMDAS       TO ME03-INDICATOR-LP-A
023500                                    (X-ME03-UFT)
023600                                    ME03-INDICATOR-RP-A
023700                                    (X-ME03-UFT)
023800             MOVE MMEF-USER-FEE-IND (X-MMEF-UFT)
023900                                 TO ME03-INDICATOR (X-ME03-UFT)
024000         ELSE
024100             IF  ME03-INDICATOR (X-ME03-UFT) IS EQUAL TO 'A'
024200             OR  ME03-INDICATOR (X-ME03-UFT) IS EQUAL TO 'P'
024300                 MOVE DFHBMASF   TO ME03-INDICATOR-A (X-ME03-UFT)
024400                 MOVE DFHBMDAS   TO ME03-INDICATOR-LP-A
024500                                    (X-ME03-UFT)
024600                                    ME03-INDICATOR-RP-A
024700                                    (X-ME03-UFT)
024800                 SET WS-UPDATE-SW-YES
024900                                 TO TRUE
025000             ELSE
025100                 MOVE DFHBMUBF   TO ME03-INDICATOR-A
025200                                   (X-ME03-UFT)
025300                 MOVE DFHBMASB   TO ME03-INDICATOR-LP-A
025400                                    (X-ME03-UFT)
025500                                    ME03-INDICATOR-RP-A
025600                                    (X-ME03-UFT)
025700                 MOVE SS08WS-CURSOR TO ME03-INDICATOR-L
025800                                    (X-ME03-UFT)
025900                 SET SS08WS-ERROR-SW-YES
026000                                 TO TRUE
026100             END-IF
026200         END-IF
026300*
026400*            ***** PERCENT AMOUNT *****                      *
026500*
026600         IF  ME03-PERCENT-AMT-L (X-ME03-UFT) IS LESS THAN 1
026700             MOVE DFHBMASK       TO ME03-PERCENT-AMT-A
026800                                    (X-ME03-UFT)
026900             MOVE DFHBMDAS       TO ME03-PERCENT-AMT-LP-A
027000                                    (X-ME03-UFT)
027100                                    ME03-PERCENT-AMT-RP-A
027200                                    (X-ME03-UFT)
027300             MOVE MMEF-USER-FEE-AMT (X-MMEF-UFT)
027400                                 TO ME03-PERCENT-AMT (X-ME03-UFT)
027500         ELSE
027600             IF  ME03-PERCENT-AMT (X-ME03-UFT) IS NUMERIC
027700                 MOVE DFHBMASF   TO ME03-PERCENT-AMT-A
027800                                    (X-ME03-UFT)
027900                 MOVE DFHBMDAS   TO ME03-PERCENT-AMT-LP-A
028000                                    (X-ME03-UFT)
028100                                    ME03-PERCENT-AMT-RP-A
028200                                    (X-ME03-UFT)
028300                 SET WS-UPDATE-SW-YES
028400                                 TO TRUE
028500             ELSE
028600                 MOVE DFHBMNBF   TO ME03-PERCENT-AMT-A
028700                                   (X-ME03-UFT)
028800                 MOVE DFHBMASB   TO ME03-PERCENT-AMT-LP-A
028900                                    (X-ME03-UFT)
029000                                    ME03-PERCENT-AMT-RP-A
029100                                    (X-ME03-UFT)
029200                 MOVE SS08WS-CURSOR TO ME03-PERCENT-AMT-L
029300                                    (X-ME03-UFT)
029400                 SET SS08WS-ERROR-SW-YES
029500                                 TO TRUE
029600             END-IF
029700         END-IF
029800*
029900         IF (ME03-INDICATOR(X-ME03-UFT) EQUAL 'P' AND
030000             ME03-PERCENT-AMT(X-ME03-UFT)(1:2) NOT EQUAL 00)
030100             MOVE DFHBMNBF   TO ME03-PERCENT-AMT-A
030200                                 (X-ME03-UFT)
030300             MOVE DFHBMASB   TO ME03-PERCENT-AMT-LP-A
030400                                 (X-ME03-UFT)
030500                                ME03-PERCENT-AMT-RP-A
030600                                 (X-ME03-UFT)
030700             MOVE SS08WS-CURSOR TO ME03-PERCENT-AMT-L
030800                                 (X-ME03-UFT)
030900             SET SS08WS-ERROR-SW-YES
031000                              TO TRUE
031100             SET WS-UPDATE-SW-NO
031200                              TO TRUE
031300             MOVE 'NOT A VALID PERCENT' TO ME03-ERR-MESSAGE
031400         ELSE
031500             SET WS-UPDATE-SW-YES
031600                              TO TRUE
031700         END-IF
031800     END-PERFORM.
031900*
032000     IF  SS08WS-ERROR-SW-NO
032100         GO TO 2400-UPDATE-FILE.
032200*
032300****************************************************************
032400*    FORMAT THE MESSGAE LINE                                   *
032500****************************************************************
032600*
032700     IF ME03-ERR-MESSAGE EQUAL TO SPACES OR LOW-VALUES
032800        PERFORM MB06PD-FORMAT-MESSAGE-LINE
032900          THRU MB06PD-FML-EXIT
033000        MOVE SS08WS-FORMATTED-MSG TO ME03-ERR-MESSAGE.
033100
033200*
033300****************************************************************
033400*    SEND THE MAP                                              *
033500****************************************************************
033600*
033700     PERFORM MB60PD-INIT-STD-MAP-LINES
033800                                 THRU MB60PD-ISML-EXIT.
033900     MOVE 'BM03'                 TO MBCA-PROGRAM-LOCATION.
034000     PERFORM MB60PD-SEND-MAP-DATA-ONLY
034100                                 THRU MB60PD-SMDO-EXIT.
034200*
034300****************************************************************
034400*    RETURN TO CICS                                            *
034500****************************************************************
034600*
034700     MOVE 'PC04'                 TO MBCA-PROGRAM-LOCATION.
034800     MOVE 03                     TO MBCA-SCREEN-NBR.
034900     PERFORM MB70PD-RETURN-TRANS-ID
035000                                 THRU MB70PD-RTI-EXIT.
035100/
035200 2400-UPDATE-FILE.
035300*
035400     IF  WS-UPDATE-SW-NO
035500         IF  MBCA-PTI-FUNCTION-IS-ADD
035600             MOVE 'FC03'         TO MBCA-PROGRAM-LOCATION
035700             MOVE MBCA-MERCHANT-ORG
035800                                 TO MBIOWS-MMEF-ORG
035900             MOVE MBCA-TABLE     TO MBIOWS-MMEF-TABLE
036000             SET MBIORO-READ-RANDOM-UPDATE
036100                                 TO TRUE
036200             PERFORM MMEFAO-ACCESS
036300                                 THRU MMEFAO-ACCESS-EXIT
036400             MOVE MBCA-SCREEN-NBR
036500                                 TO MMEF-ONLINE-STATUS
036600             MOVE 'FC04'         TO MBCA-PROGRAM-LOCATION
036700             SET MBIORO-REWRITE  TO TRUE
036800             PERFORM MMEFAO-ACCESS
036900                                 THRU MMEFAO-ACCESS-EXIT
037000             GO TO 2600-SETUP-COMMAREA
037100         ELSE
037200             GO TO 2600-SETUP-COMMAREA.
037300*
037400****************************************************************
037500*    GETMAIN FOR LOG/JOURNAL RECORD                            *
037600****************************************************************
037700*
037800     MOVE 'SC02'                 TO MBCA-PROGRAM-LOCATION.
037900     SET MBIORO-GETMAIN          TO TRUE.
038000     PERFORM MML1AO-ACCESS       THRU MML1AO-ACCESS-EXIT.
038100*
038200****************************************************************
038300*    READ THE EXPENSE RECORD FOR UPDATE                        *
038400****************************************************************
038500*
038600     MOVE 'FC05'                 TO MBCA-PROGRAM-LOCATION.
038700     MOVE MBCA-MERCHANT-ORG      TO MBIOWS-MMEF-ORG.
038800     MOVE MBCA-TABLE             TO MBIOWS-MMEF-TABLE.
038900     SET MBIORO-READ-RANDOM-UPDATE
039000                                 TO TRUE.
039100     PERFORM MMEFAO-ACCESS       THRU MMEFAO-ACCESS-EXIT.
039200*
039300     PERFORM
039400         VARYING X-ME03-UFT FROM 1 BY 1
039500         UNTIL X-ME03-UFT IS GREATER THAN 10
039600         SET X-MMEF-UFT          TO X-ME03-UFT
039700         SET WS-INDEX            TO X-ME03-UFT
039800*
039900*            ***** INDICATOR *****                             *
040000*
040100         IF  ME03-INDICATOR-L (X-ME03-UFT)
040200                                 IS GREATER THAN ZEROES
040300             MOVE WS-INDEX       TO MML1-FIELD-OCCURRENCE
040400             MOVE 0302           TO MML1-FIELD-CODE
040500             MOVE MML1WS-VL-01   TO MML1-VARIABLE-LENGTH
040600             MOVE MMEF-USER-FEE-IND (X-MMEF-UFT)
040700                                 TO MML1-VL01-B-DATA-X
040800             MOVE ME03-INDICATOR (X-ME03-UFT)
040900                                 TO MMEF-USER-FEE-IND (X-MMEF-UFT)
041000             MOVE MMEF-USER-FEE-IND (X-MMEF-UFT)
041100                                 TO MML1-VL01-A-DATA-X
041200             PERFORM 9050-CREATE-MAINT-RECORD
041300                                 THRU 9099-CMR-EXIT
041400         END-IF
041500*
041600*            ***** PERCENT AMOUNT *****                        *
041700*
041800         IF  ME03-PERCENT-AMT-L (X-ME03-UFT)
041900                                 IS GREATER THAN ZEROES
042000             MOVE WS-INDEX       TO MML1-FIELD-OCCURRENCE
042100             MOVE 0301           TO MML1-FIELD-CODE
042200             MOVE MML1WS-VL-20   TO MML1-VARIABLE-LENGTH
042300             MOVE MMEF-USER-FEE-AMT (X-MMEF-UFT)
042400                                 TO MML1-VL20-B-NBR-NO-DEC
042500             MOVE ME03-PERCENT-AMT (X-ME03-UFT)
042600                                 TO MMEF-USER-FEE-AMT (X-MMEF-UFT)
042700             MOVE MMEF-USER-FEE-AMT (X-MMEF-UFT)
042800                                 TO MML1-VL20-A-NBR-NO-DEC
042900             PERFORM 9050-CREATE-MAINT-RECORD
043000                                 THRU 9099-CMR-EXIT
043100         END-IF
043200     END-PERFORM.
043300*
043400     IF  MBCA-PTI-FUNCTION-IS-ADD
043500         MOVE 03                 TO MMEF-ONLINE-STATUS.
043600*
043700*            ***** LAST MAINT DATE AND OPERATOR ID *****       *
043800*
043900     MOVE ZEROES                 TO MML1-FIELD-OCCURRENCE.
044000     MOVE 0199                   TO MML1-FIELD-CODE.
044100     MOVE MML1WS-VL-07           TO MML1-VARIABLE-LENGTH.
044200     MOVE MMEF-LAST-MAINT-DATE
044300                                 TO MML1-VL07-B-DATA-9.
044400     MOVE MBCA-START-DATE        TO MMEF-LAST-MAINT-DATE.
044500     MOVE MMEF-LAST-MAINT-DATE   TO MML1-VL07-A-DATA-9.
044600     PERFORM 9050-CREATE-MAINT-RECORD
044700                                 THRU 9099-CMR-EXIT.
044800     MOVE 0198                   TO MML1-FIELD-CODE.
044900     MOVE MML1WS-VL-03           TO MML1-VARIABLE-LENGTH.
045000     MOVE MMEF-LAST-MAINT-OPER   TO MML1-VL03-B-DATA-X.
045100     MOVE MBCA-OPERATOR-ID       TO MMEF-LAST-MAINT-OPER.
045200     MOVE MMEF-LAST-MAINT-OPER
045300                                 TO MML1-VL03-A-DATA-X.
045400     PERFORM 9050-CREATE-MAINT-RECORD
045500                                 THRU 9099-CMR-EXIT.
045600*
045700****************************************************************
045800*    UPDATE THE EXPENSE FILE                                   *
045900****************************************************************
046000*
046100     MOVE 'FC06'                 TO MBCA-PROGRAM-LOCATION.
046200     SET MBIORO-REWRITE          TO TRUE.
046300     PERFORM MMEFAO-ACCESS       THRU MMEFAO-ACCESS-EXIT.
046400*
046500 2600-SETUP-COMMAREA.
046600*
046700****************************************************************
046800*    SET UP COMMAREA FIELDS AND TRANSFER TO THE NEXT PROGRAM   *
046900****************************************************************
047000*
047100     MOVE MBCA-EIBAID            TO SS08WS-EIBAID.
047200*
047300     PERFORM MB60PD-EDIT-PAGE-NBR
047400                                 THRU MB60PD-EPN-EXIT.
047500*
047600     IF  SS08WS-VALID-PF-KEY
047700     OR  SS08WS-EIBAID-VALID-PF-KEY
047800         SET MBCA-INITIAL-SCREEN-NBR
047900                                 TO TRUE.
048000*
048100     MOVE 'PC05'                 TO MBCA-PROGRAM-LOCATION.
048200     PERFORM MB70PD-XCTL-TO-MBOXCTL
048300                                 THRU MB70PD-XTM-EXIT.
048400/
048500 9000-PERFORMED-ROUTINES-SECT SECTION.
048600*
048700 9050-CREATE-MAINT-RECORD.
048800*
048900*****************************************************************
049000*    THIS ROUTINE WILL CREATE THE COMMON DATA FOR ALL OF THE    *
049100*    LOG/JOURNAL TRANSACTIONS                                   *
049200*****************************************************************
049300*
049400     IF  MBCA-PTI-FUNCTION-IS-ADD
049500         GO TO 9099-CMR-EXIT.
049600*
049700     MOVE 'EF'                   TO MML1-FILE-CODE.
049800     MOVE MBCA-MERCHANT-ORG      TO MML1-MMEF-ORG.
049900     MOVE MBCA-TABLE             TO MML1-MMEF-TABLE-NBR.
050000     MOVE MBCA-SIGNON-NAME       TO MML1-SIGNON-NAME.
050100     MOVE MBCA-TERMINAL-ID       TO MML1-TERMINAL-ID.
050200     MOVE ZEROES                 TO MML1-SOURCE-CODE
050300                                    MML1-FIELD-OCCURRENCE-2.
050400*
050500*****************************************************************
050600*    WRITE THE LOG/JOURNAL FILE RECORD                          *
050700*****************************************************************
050800*
050900     MOVE 'FC07'                 TO MBCA-PROGRAM-LOCATION.
051000     SET MBIORO-WRITE            TO TRUE.
051100     PERFORM MML1AO-ACCESS       THRU MML1AO-ACCESS-EXIT.
051200     MOVE SPACES                 TO MML1-VARIABLE-AREA.
051300*
051400 9099-CMR-EXIT.
051500     EXIT.
051600/         JULIAN TO GREGORIAN DATE ROUTINE.
051700     COPY SS08PD.
051800/         DATE AND TIME EDIT ROUTINES.
051900     COPY SS26PD.
052000     COPY SS27PD.
052100/         CHECK DIGIT ROUTINE.
052200     COPY SS09PD.
052300/         LINE 24 PF KEYS ROUTINE
052400     COPY SS15PD.
052500/         EXPENSE RECORD ACCESS ROUTINES
052600     COPY MMEFAO.
052700/         LOG/JOURNAL ACCESS ROUTINES
052800     COPY MML1AO.
052900/         ON-LINE MAP ROUTINES
053000     COPY MB60PD REPLACING 'MBMAPXX' BY 'MBME03 '
053100                           MBMAPXXI BY MBME03I
053200                           MBMAPXXO BY MBME03O.
053300/         ON-LINE PROCEDURES
053400     COPY MB70PD.
053500/         MESSAGE FORMAT ROUTINE
053600     COPY MB06PD.
053700/
053800     COPY SMFTPXO.
