000100 IDENTIFICATION DIVISION.
000200 PROGRAM-ID. MBOME04.
000201*       RELEASE DATE=08/24/01.        REVISION LEVEL=08.06      *
000202*****************************************************************
000203*WARNING.  THIS COMPUTER PROGRAM IS PROTECTED BY COPYRIGHT LAW  *
000204*AND INTERNATIONAL TREATIES.  UNAUTHORIZED REPRODUCTION OR      *
000205*DISTRIBUTION OF THIS PROGRAM, OR ANY PORTION OF IT, MAY RESULT *
000206*IN SEVERE CIVIL AND CRIMINAL PENATLIES, AND WILL BE PROSECUTED *
000207*TO THE MAXIMUM EXTENT POSSIBLE UNDER THE LAW.                  *
000208*COPYRIGHT 1999 PAYSYS INTERNATIONAL, INC.  ALL RIGHTS RESERVED.*
000209*****************************************************************
000300*****************************************************************
000400*                                                               *
000500*   V - PLUS  M E R C H A N T   B A N K C A R D   S Y S T E M   *
000600*                                                               *
000700*      MBOME04 - ON-LINE EXPENSE FACTORS SCREEN                 *
000800*                SCREENS 04                                     *
000900*                                                               *
001000*              1. TRANSIDS                                      *
001100*                 A. MBME                                       *
001200*              2. MAPS USED -                                   *
001300*                 A. MBME04 (SCREENS 04)                        *
001400*              3. FILES USED -                                  *
001500*                 A. MMEF   (EXPENSE FACTORS FILE)              *
001600*                 B. MMOC   (ORG CONTROL FILE)                  *
001700*                 C. MML1   (LOG FILE)                          *
001800*                                                               *
001900*****************************************************************
002000*
002100 ENVIRONMENT DIVISION.
002200 DATA DIVISION.
002300 WORKING-STORAGE SECTION.
002400 01  FILLER                  PIC  X(12)      VALUE '** WS-BEG **'.
002500*         I/O REQUEST BLOCK WORK AREAS
002600     COPY MBIOWS.
002700/         I/O REQUEST BLOCK
002800     COPY MBIORO.
002900/         LOG/JOURNAL WORK AREAS
003000     COPY MML1WS REPLACING ==:MML1:== BY ==MML1==.
003100/         DESC TABLE FOR VISA MC AND PL
003200     COPY MB80WS.
003300/         DATE WORK AREAS
003400     COPY SS01WS.
003500/         ONLINE WORK AREAS
003600     COPY SS08WS.
003700/
003800     COPY SS00WS.
003900/
004000     COPY SMFTWS.
004100/
004200     COPY SMPTRL REPLACING ==:SMPT:== BY ==SMPT==.
004300/
004400     COPY MB61LK.
004500/
004600 01  WS-MISCELLANEOUS.
004700     03  WS-UPDATE-SW        PIC  X(01)      VALUE 'N'.
004800         88  WS-UPDATE-SW-NO                 VALUE 'N'.
004900         88  WS-UPDATE-SW-YES                VALUE 'Y'.
005000     03  WS-INDEX            PIC S9(04)      BINARY.
005100     03  WS-NBR-INDEX        PIC S9(04)      BINARY.
005200*
005300 01  FILLER                  PIC  X(12)      VALUE '** WS-END **'.
005400/
005500 LINKAGE SECTION.
005600 01  DFHCOMMAREA.
005700     COPY MB60WS.
005800/         MERCHANT EXPENSE FACTORS SCREEN 04 MAP DSECT
005900     COPY MBME04.
006000/         MERCHANT EXPENSE FACTORS SCREEN 04 MAP REDEFINITION
006100     COPY MBME04R.
006200/         EXPENSE FILE MASTER RECORD LAYOUT
006300     COPY MMIFRL REPLACING ==:MMIF:== BY ==MMEF==.
006400/         ORG CONTROL FILE MASTER RECORD LAYOUT
006500     COPY MMOCRL.
006600/         LOG/JOURNAL FILE RECORD LAYOUT
006700     COPY MML1RL REPLACING ==:MML1:== BY ==MML1==.
006800/
006900 PROCEDURE DIVISION.
007000 0000-HOUSEKEEPING SECTION.
007100 0100-INIT.
007200*
007300     MOVE 'PC01'                 TO MBCA-PROGRAM-LOCATION.
007400     PERFORM MB70PD-ON-LINE-HOUSEKEEPING
007500                                 THRU MB70PD-OLH-EXIT.
007600*
007700     IF  MBCA-RECEIVE-SCREEN
007800         GO TO 2000-RECEIVE-SCREEN.
007900*
008000 1000-SEND-SCREEN SECTION.
008100*
008200****************************************************************
008300*    THIS SECTION BUILDS AND SENDS THE SCREENS 04              *
008400****************************************************************
008500*
008600****************************************************************
008700*    GET CICS STORAGE NEEDED FOR THE MAP                       *
008800****************************************************************
008900*
009000     MOVE 'SC01'                 TO MBCA-PROGRAM-LOCATION.
009100     PERFORM MB60PD-GETMAIN-FOR-MAP
009200                                 THRU MB60PD-GFM-EXIT.
009300*
009400     MOVE MBCA-MERCHANT-ORG      TO ME04-ORG.
009500     MOVE MBCA-TABLE             TO ME04-EXPENSE-NBR.
009600*
009700****************************************************************
009800*    INITIALIZE THE STANDARD MAP LINES                         *
009900****************************************************************
010000*
010100     PERFORM MB60PD-INIT-STD-MAP-LINES
010200                                 THRU MB60PD-ISML-EXIT.
010300*
010400*
010500****************************************************************
010600*    READ THE ORG CONTROL FILE                                 *
010700****************************************************************
010800*
010900     MOVE 'FC01'                 TO MBCA-PROGRAM-LOCATION.
011000     MOVE MBCA-MERCHANT-ORG      TO MBIOWS-MMOC-ORG.
011100     SET MBIORO-READ-RANDOM      TO TRUE.
011200     PERFORM MMOCAO-ACCESS       THRU MMOCAO-ACCESS-EXIT.
011300*
011400****************************************************************
011500*    READ THE MERCHANT EXPENSE FILE                            *
011600****************************************************************
011700*
011800     MOVE 'FC02'                 TO MBCA-PROGRAM-LOCATION.
011900     MOVE MBCA-MERCHANT-ORG      TO MBIOWS-MMEF-ORG.
012000     MOVE MBCA-TABLE             TO MBIOWS-MMEF-TABLE.
012100     SET MBIORO-READ-RANDOM      TO TRUE.
012200     PERFORM MMEFAO-ACCESS       THRU MMEFAO-ACCESS-EXIT.
012300*
012400 1010-CHECK-PRODUCT.
012500*
012600     IF  MBCA-SCREEN-NBR IS EQUAL TO 54
012700         SET X-MMOC-PROD         TO 1
012800         MOVE 1                  TO MBCA-MBME-IFT-INDEX
012900         IF  MMOC-PRODUCT-ACTIVE (X-MMOC-PROD)
013000             MOVE 04             TO MBCA-SCREEN-NBR
013100             MOVE MMOC-PRODUCT-DESC (X-MMOC-PROD)
013200                                 TO ME04-CARD-PROD-DESC
013300             MOVE 01             TO ME04-CARD-PROD
013400             MOVE DFHBMASB       TO ME04-CARD-PROD-DESC-A
013500                                    ME04-CARD-PROD-A
013600             SET X-MMEF-IFT      TO 1
013700             SET X-MMEF-PROD-FEES
013800                                 TO 1
013900             SET X-MB80WS-IFT    TO 1
014000             GO TO 1050-BUILD-SCREEN
014100         ELSE
014200             MOVE 55             TO MBCA-SCREEN-NBR.
014300*
014400     IF  MBCA-SCREEN-NBR IS EQUAL TO 55
014500         SET X-MMOC-PROD         TO 2
014600         MOVE 2                  TO MBCA-MBME-IFT-INDEX
014700         IF  MMOC-PRODUCT-ACTIVE (X-MMOC-PROD)
014800             MOVE 05             TO MBCA-SCREEN-NBR
014900             MOVE MMOC-PRODUCT-DESC (X-MMOC-PROD)
015000                                 TO ME04-CARD-PROD-DESC
015100             MOVE 02             TO ME04-CARD-PROD
015200             MOVE DFHBMASB       TO ME04-CARD-PROD-DESC-A
015300                                    ME04-CARD-PROD-A
015400             SET X-MMEF-IFT      TO 2
015500             SET X-MMEF-PROD-FEES
015600                                 TO 2
015700             SET X-MB80WS-IFT    TO 2
015800             GO TO 1050-BUILD-SCREEN.
015900*
016000     MOVE 56                    TO MBCA-SCREEN-NBR.
016100     MOVE 'PC02'                TO MBCA-PROGRAM-LOCATION.
016200     PERFORM MB70PD-XCTL-TO-MBOXCTL
016300                                 THRU MB70PD-XTM-EXIT.
016400*
016500 1050-BUILD-SCREEN.
016600*
016700     PERFORM 9500-BUILD-SCREEN   THRU 9599-BS-EXIT.
016800*
016900 1060-SET-ATTRIBUTE.
017000*
017100     MOVE SS08WS-CURSOR          TO ME04-AUTH-APPR-L.
017200*
017300****************************************************************
017400*    IF  INQUIRY, DARKEN PARENS AND ASKIP FIELDS               *
017500****************************************************************
017600*
017700     IF  MBCA-PTI-FUNCTION-IS-INQUIRY
017800         MOVE SS08WS-CURSOR      TO ME04-ALT-TRANID-L
017900         MOVE DFHBMASB           TO ME04-AUTH-APPR-A
018000                                    ME04-AUTH-DECL-A
018100         PERFORM
018200             VARYING X-ME04-PUF FROM 1 BY 1
018300             UNTIL X-ME04-PUF IS GREATER THAN 3
018400             MOVE DFHBMASB       TO ME04-PUF-IND-A
018500                                    (X-ME04-PUF)
018600                                    ME04-PUF-AMT-A
018700                                    (X-ME04-PUF)
018800         END-PERFORM
018900         PERFORM
019000             VARYING X-ME04-QL FROM 1 BY 1
019100             UNTIL X-ME04-QL IS GREATER THAN 9
019200             MOVE DFHBMASB       TO ME04-INTCHG-RATE-A
019300                                    (X-ME04-QL)
019400                                    ME04-INTCHG-PER-ITEM-A
019500                                    (X-ME04-QL)
019600         END-PERFORM
019700         MOVE DFHBMDAS           TO ME04-AUTH-APPR-LP-A
019800                                    ME04-AUTH-APPR-RP-A
019900                                    ME04-AUTH-DECL-LP-A
020000                                    ME04-AUTH-DECL-RP-A
020100         PERFORM
020200             VARYING X-ME04-PUF FROM 1 BY 1
020300             UNTIL X-ME04-PUF IS GREATER THAN 3
020400             MOVE DFHBMDAS       TO ME04-PUF-IND-LP-A
020500                                    (X-ME04-PUF)
020600                                    ME04-PUF-IND-RP-A
020700                                    (X-ME04-PUF)
020800                                    ME04-PUF-AMT-LP-A
020900                                    (X-ME04-PUF)
021000                                    ME04-PUF-AMT-RP-A
021100                                    (X-ME04-PUF)
021200         END-PERFORM
021300         PERFORM
021400             VARYING X-ME04-QL FROM 1 BY 1
021500             UNTIL X-ME04-QL IS GREATER THAN 9
021600             MOVE DFHBMDAS       TO ME04-INTCHG-RATE-LP-A
021700                                    (X-ME04-QL)
021800                                    ME04-INTCHG-RATE-RP-A
021900                                    (X-ME04-QL)
022000                                    ME04-INTCHG-PER-ITEM-LP-A
022100                                    (X-ME04-QL)
022200                                    ME04-INTCHG-PER-ITEM-RP-A
022300                                    (X-ME04-QL)
022400         END-PERFORM.
022500*
022600     PERFORM
022700         VARYING X-ME04-QL FROM 1 BY 1
022800         UNTIL X-ME04-QL IS GREATER THAN 9
022900         MOVE DFHBMASK       TO ME04-INTCHG-DESC-A
023000                                (X-ME04-QL)
023100     END-PERFORM.
023200*
023300 1100-CONTINUE.
023400*
023500     MOVE '*TOP*'                TO SS08WS-LINE-24-PF-KEY-FUNC(3).
023600     MOVE '*BOT*'                TO SS08WS-LINE-24-PF-KEY-FUNC(4).
023700     MOVE '*FWD*'                TO SS08WS-LINE-24-PF-KEY-FUNC(5).
023800     MOVE '*BWD*'                TO SS08WS-LINE-24-PF-KEY-FUNC(6).
023900     MOVE SS08WS-LINE-24         TO ME04-PF-KEYS.
024000     MOVE 'RESV'                 TO MBCA-PGMX-PF-TRANS-ID (3).
024100     MOVE 'RESV'                 TO MBCA-PGMX-PF-TRANS-ID (4).
024200     MOVE 'RESV'                 TO MBCA-PGMX-PF-TRANS-ID (5).
024300     MOVE 'RESV'                 TO MBCA-PGMX-PF-TRANS-ID (6).
024400*
024500****************************************************************
024600*    FORMAT THE MESSAGE LINE                                   *
024700****************************************************************
024800*
024900     IF ME04-ERR-MESSAGE EQUAL TO SPACES OR LOW-VALUES
025000        PERFORM MB06PD-FORMAT-MESSAGE-LINE
025100           THRU MB06PD-FML-EXIT
025200        MOVE SS08WS-FORMATTED-MSG TO ME04-ERR-MESSAGE.
025300*
025400****************************************************************
025500*    SEND THE MAP                                              *
025600****************************************************************
025700*
025800     MOVE 'BM01'                 TO MBCA-PROGRAM-LOCATION.
025900     PERFORM MB60PD-SEND-MAP-WITH-ERASE
026000                                 THRU MB60PD-SMWE-EXIT.
026100*
026200****************************************************************
026300*    RETURN TO CICS                                            *
026400****************************************************************
026500*
026600     MOVE 'PC03'                 TO MBCA-PROGRAM-LOCATION.
026700     PERFORM MB70PD-RETURN-TRANS-ID
026800                                 THRU MB70PD-RTI-EXIT.
026900/
027000 2000-RECEIVE-SCREEN SECTION.
027100*
027200****************************************************************
027300*    THIS SECTION RECEIVES THE 04 SCREEN                       *
027400****************************************************************
027500*
027600     MOVE 'BM02'                 TO MBCA-PROGRAM-LOCATION.
027700     PERFORM MB60PD-RECEIVE-MAP  THRU MB60PD-RM-EXIT.
027800*
027900****************************************************************
028000*    CHECK FOR ANOTHER TRANSACTION ID ENTERED BY THE USER      *
028100****************************************************************
028200*
028300     MOVE 'PC04'                 TO MBCA-PROGRAM-LOCATION.
028400     PERFORM MB60PD-NEW-TRANS-ROUTINE
028500                                 THRU MB60PD-NTR-EXIT.
028600*
028700****************************************************************
028800*    BYPASS EDITS ON INQUIRY                                   *
028900****************************************************************
029000*
029100     SET X-MMEF-PROD-FEES        TO MBCA-MBME-IFT-INDEX.
029200     SET X-MMEF-IFT              TO MBCA-MBME-IFT-INDEX.
029300*
029400     IF  MBCA-PTI-FUNCTION-IS-INQUIRY
029500         GO TO 2600-SETUP-COMMAREA.
029600*
029700****************************************************************
029800*    READ RANDOM THE EXPENSE RECORD                            *
029900****************************************************************
030000*
030100     MOVE 'FC03'                 TO MBCA-PROGRAM-LOCATION.
030200     MOVE MBCA-MERCHANT-ORG      TO MBIOWS-MMEF-ORG.
030300     MOVE MBCA-TABLE             TO MBIOWS-MMEF-TABLE.
030400     SET MBIORO-READ-RANDOM      TO TRUE.
030500     PERFORM MMEFAO-ACCESS       THRU MMEFAO-ACCESS-EXIT.
030600*
030700****************************************************************
030800*    EDIT FIELDS                                               *
030900****************************************************************
031000*
031100****************************************************************
031200*                  AUTH APPROVAL                               *
031300****************************************************************
031400*
031500     IF  ME04-AUTH-APPR-L        IS LESS THAN 1
031600         MOVE DFHBMASK           TO ME04-AUTH-APPR-A
031700         MOVE DFHBMDAS           TO ME04-AUTH-APPR-LP-A
031800                                    ME04-AUTH-APPR-RP-A
031900         MOVE MMEF-PROD-AUTH-APPR-FEE (X-MMEF-PROD-FEES)
032000                                 TO ME04-AUTH-APPR
032100     ELSE
032200         IF  ME04-AUTH-APPR IS NUMERIC
032300             MOVE DFHBMASF       TO ME04-AUTH-APPR-A
032400             MOVE DFHBMDAS       TO ME04-AUTH-APPR-LP-A
032500                                    ME04-AUTH-APPR-RP-A
032600             SET WS-UPDATE-SW-YES
032700                                 TO TRUE
032800         ELSE
032900             MOVE DFHBMNBF       TO ME04-AUTH-APPR-A
033000             MOVE DFHBMASB       TO ME04-AUTH-APPR-LP-A
033100                                    ME04-AUTH-APPR-RP-A
033200             MOVE SS08WS-CURSOR  TO ME04-AUTH-APPR-L
033300             SET SS08WS-ERROR-SW-YES TO TRUE.
033400*
033500****************************************************************
033600*                  AUTH DECLINE                                *
033700****************************************************************
033800*
033900     IF  ME04-AUTH-DECL-L        IS LESS THAN 1
034000         MOVE DFHBMASK           TO ME04-AUTH-DECL-A
034100         MOVE DFHBMDAS           TO ME04-AUTH-DECL-LP-A
034200                                    ME04-AUTH-DECL-RP-A
034300         MOVE MMEF-PROD-AUTH-DECL-FEE (X-MMEF-PROD-FEES)
034400                                 TO ME04-AUTH-DECL
034500     ELSE
034600         IF  ME04-AUTH-DECL IS NUMERIC
034700             MOVE DFHBMASF       TO ME04-AUTH-DECL-A
034800             MOVE DFHBMDAS       TO ME04-AUTH-DECL-LP-A
034900                                    ME04-AUTH-DECL-RP-A
035000             SET WS-UPDATE-SW-YES
035100                                 TO TRUE
035200         ELSE
035300             MOVE DFHBMNBF       TO ME04-AUTH-DECL-A
035400             MOVE DFHBMASB       TO ME04-AUTH-DECL-LP-A
035500                                    ME04-AUTH-DECL-RP-A
035600             MOVE SS08WS-CURSOR  TO ME04-AUTH-DECL-L
035700             SET SS08WS-ERROR-SW-YES TO TRUE.
035800*
035900****************************************************************
036000*                PRODUCT USER FEES INDICATOR                   *
036100****************************************************************
036200*
036300     PERFORM
036400         VARYING X-ME04-PUF FROM 1 BY 1
036500         UNTIL X-ME04-PUF IS GREATER THAN 3
036600         SET X-MMEF-PUF          TO X-ME04-PUF
036700         IF ME04-PUF-IND-L (X-ME04-PUF) IS LESS THAN 1
036800             MOVE DFHBMASK       TO ME04-PUF-IND-A (X-ME04-PUF)
036900             MOVE DFHBMDAS       TO ME04-PUF-IND-LP-A (X-ME04-PUF)
037000                                    ME04-PUF-IND-RP-A (X-ME04-PUF)
037100             MOVE MMEF-PUF-IND (X-MMEF-PROD-FEES X-MMEF-PUF)
037200                                 TO ME04-PUF-IND (X-ME04-PUF)
037300         ELSE
037400             IF  ME04-VALID-PUF-IND (X-ME04-PUF)
037500                 MOVE DFHBMASF   TO ME04-PUF-IND-A (X-ME04-PUF)
037600                 MOVE DFHBMDAS   TO ME04-PUF-IND-LP-A (X-ME04-PUF)
037700                                    ME04-PUF-IND-RP-A (X-ME04-PUF)
037800                 SET WS-UPDATE-SW-YES
037900                                 TO TRUE
038000             ELSE
038100                 MOVE DFHBMUBF   TO ME04-PUF-IND-A (X-ME04-PUF)
038200                 MOVE DFHBMASB   TO ME04-PUF-IND-LP-A (X-ME04-PUF)
038300                                    ME04-PUF-IND-RP-A (X-ME04-PUF)
038400                 MOVE SS08WS-CURSOR TO ME04-PUF-IND-L (X-ME04-PUF)
038500                 SET SS08WS-ERROR-SW-YES
038600                                 TO TRUE
038700             END-IF
038800         END-IF
038900     END-PERFORM.
039000*
039100****************************************************************
039200*                PRODUCT USER FEES AMOUNT                      *
039300****************************************************************
039400*
039500     PERFORM
039600         VARYING X-ME04-PUF FROM 1 BY 1
039700         UNTIL X-ME04-PUF IS GREATER THAN 3
039800         SET X-MMEF-PUF          TO X-ME04-PUF
039900         IF  ME04-PUF-AMT-L (X-ME04-PUF) IS LESS THAN 1
040000             MOVE DFHBMASK       TO ME04-PUF-AMT-A (X-ME04-PUF)
040100             MOVE DFHBMDAS       TO ME04-PUF-AMT-LP-A (X-ME04-PUF)
040200                                    ME04-PUF-AMT-RP-A (X-ME04-PUF)
040300             MOVE MMEF-PUF-AMT (X-MMEF-PROD-FEES X-MMEF-PUF)
040400                                 TO ME04-PUF-AMT (X-ME04-PUF)
040500         ELSE
040600             IF  ME04-PUF-AMT (X-ME04-PUF) IS NUMERIC
040700                 MOVE DFHBMASF   TO ME04-PUF-AMT-A (X-ME04-PUF)
040800                 MOVE DFHBMDAS   TO ME04-PUF-AMT-LP-A (X-ME04-PUF)
040900                                    ME04-PUF-AMT-RP-A (X-ME04-PUF)
041000                 SET WS-UPDATE-SW-YES
041100                                 TO TRUE
041200             ELSE
041300                 MOVE DFHBMNBF   TO ME04-PUF-AMT-A (X-ME04-PUF)
041400                 MOVE DFHBMASB   TO ME04-PUF-AMT-LP-A (X-ME04-PUF)
041500                                    ME04-PUF-AMT-RP-A (X-ME04-PUF)
041600                 MOVE SS08WS-CURSOR TO ME04-PUF-AMT-L (X-ME04-PUF)
041700                 SET SS08WS-ERROR-SW-YES
041800                                 TO TRUE
041900             END-IF
042000         END-IF
042100         IF (ME04-PUF-IND(X-ME04-PUF) EQUAL 'P' AND
042200             ME04-PUF-AMT(X-ME04-PUF)(1:2) NOT EQUAL 00)
042300             MOVE DFHBMNBF   TO ME04-PUF-AMT-A
042400                                 (X-ME04-PUF)
042500             MOVE DFHBMASB   TO ME04-PUF-AMT-LP-A
042600                                 (X-ME04-PUF)
042700                                ME04-PUF-AMT-RP-A
042800                                 (X-ME04-PUF)
042900             MOVE SS08WS-CURSOR TO ME04-PUF-AMT-L
043000                                 (X-ME04-PUF)
043100             SET SS08WS-ERROR-SW-YES
043200                              TO TRUE
043300             SET WS-UPDATE-SW-NO
043400                              TO TRUE
043500             MOVE 'NOT A VALID PERCENT' TO ME04-ERR-MESSAGE
043600         ELSE
043700             SET WS-UPDATE-SW-YES
043800                              TO TRUE
043900         END-IF
044000     END-PERFORM.
044100*
044200****************************************************************
044300*                INTERCHANGE RATE                              *
044400****************************************************************
044500*
044600     SET X-MMEF-QL               TO MBCA-MBME-QL-INDEX.
044700*
044800     PERFORM
044900         VARYING X-ME04-QL FROM 1 BY 1
045000         UNTIL X-ME04-QL IS GREATER THAN 9
045100         IF ME04-INTCHG-RATE-L (X-ME04-QL) IS LESS THAN 1
045200             MOVE DFHBMASK       TO ME04-INTCHG-RATE-A (X-ME04-QL)
045300             MOVE DFHBMDAS       TO ME04-INTCHG-RATE-LP-A
045400                                    (X-ME04-QL)
045500                                    ME04-INTCHG-RATE-RP-A
045600                                    (X-ME04-QL)
045700             MOVE MMEF-INTCHG-RATE (X-MMEF-IFT X-MMEF-QL)
045800                                 TO ME04-INTCHG-RATE (X-ME04-QL)
045900             SET X-MMEF-QL       UP BY 1
046000         ELSE
046100             IF  ME04-INTCHG-RATE (X-ME04-QL) IS NUMERIC
046200                 MOVE DFHBMASF   TO ME04-INTCHG-RATE-A (X-ME04-QL)
046300                 MOVE DFHBMDAS   TO ME04-INTCHG-RATE-LP-A
046400                                    (X-ME04-QL)
046500                                    ME04-INTCHG-RATE-RP-A
046600                                    (X-ME04-QL)
046700                 SET WS-UPDATE-SW-YES
046800                                 TO TRUE
046900                 SET X-MMEF-QL   UP BY 1
047000             ELSE
047100                 MOVE DFHBMNBF   TO ME04-INTCHG-RATE-A (X-ME04-QL)
047200                 MOVE DFHBMASB   TO ME04-INTCHG-RATE-LP-A
047300                                    (X-ME04-QL)
047400                                    ME04-INTCHG-RATE-RP-A
047500                                    (X-ME04-QL)
047600                 MOVE SS08WS-CURSOR TO ME04-INTCHG-RATE-L
047700                                    (X-ME04-QL)
047800                 SET SS08WS-ERROR-SW-YES
047900                                 TO TRUE
048000                 SET X-MMEF-QL   UP BY 1
048100             END-IF
048200         END-IF
048300     END-PERFORM.
048400*
048500****************************************************************
048600*                INTERCHANGE PER ITEM                          *
048700****************************************************************
048800*
048900     SET X-MMEF-QL               TO MBCA-MBME-QL-INDEX.
049000*
049100     PERFORM
049200         VARYING X-ME04-QL FROM 1 BY 1
049300         UNTIL X-ME04-QL IS GREATER THAN 9
049400         IF ME04-INTCHG-PER-ITEM-L (X-ME04-QL) IS LESS THAN 1
049500             MOVE DFHBMASK       TO ME04-INTCHG-PER-ITEM-A
049600                                    (X-ME04-QL)
049700             MOVE DFHBMDAS       TO ME04-INTCHG-PER-ITEM-LP-A
049800                                    (X-ME04-QL)
049900                                    ME04-INTCHG-PER-ITEM-RP-A
050000                                    (X-ME04-QL)
050100             MOVE MMEF-INTCHG-PER-ITEM (X-MMEF-IFT X-MMEF-QL)
050200                                 TO ME04-INTCHG-PER-ITEM
050300                                    (X-ME04-QL)
050400             SET X-MMEF-QL       UP BY 1
050500         ELSE
050600             IF  ME04-INTCHG-PER-ITEM (X-ME04-QL) IS NUMERIC
050700                 MOVE DFHBMASF   TO ME04-INTCHG-PER-ITEM-A
050800                                    (X-ME04-QL)
050900                 MOVE DFHBMDAS   TO ME04-INTCHG-PER-ITEM-LP-A
051000                                    (X-ME04-QL)
051100                                    ME04-INTCHG-PER-ITEM-RP-A
051200                                    (X-ME04-QL)
051300                 SET WS-UPDATE-SW-YES
051400                                 TO TRUE
051500                 SET X-MMEF-QL   UP BY 1
051600             ELSE
051700                 MOVE DFHBMNBF   TO ME04-INTCHG-PER-ITEM-A
051800                                    (X-ME04-QL)
051900                 MOVE DFHBMASB   TO ME04-INTCHG-PER-ITEM-LP-A
052000                                    (X-ME04-QL)
052100                                    ME04-INTCHG-PER-ITEM-RP-A
052200                                    (X-ME04-QL)
052300                 MOVE SS08WS-CURSOR TO ME04-INTCHG-PER-ITEM-L
052400                                    (X-ME04-QL)
052500                 SET SS08WS-ERROR-SW-YES
052600                                 TO TRUE
052700                 SET X-MMEF-QL   UP BY 1
052800             END-IF
052900         END-IF
053000     END-PERFORM.
053100*
053200     SET X-MMEF-QL               TO MBCA-MBME-QL-INDEX.
053300*
053400     IF  SS08WS-ERROR-SW-NO
053500         GO TO 2400-UPDATE-FILE.
053600*
053700 2300-SEND-MAP.
053800*
053900****************************************************************
054000*    SEND THE MAP                                              *
054100****************************************************************
054200*
054300     PERFORM MB60PD-INIT-STD-MAP-LINES
054400                                 THRU MB60PD-ISML-EXIT.
054500*
054600     MOVE '*TOP*'                TO SS08WS-LINE-24-PF-KEY-FUNC(3).
054700     MOVE '*BOT*'                TO SS08WS-LINE-24-PF-KEY-FUNC(4).
054800     MOVE '*FWD*'                TO SS08WS-LINE-24-PF-KEY-FUNC(5).
054900     MOVE '*BWD*'                TO SS08WS-LINE-24-PF-KEY-FUNC(6).
055000     MOVE SS08WS-LINE-24         TO ME04-PF-KEYS.
055100     MOVE 'RESV'                 TO MBCA-PGMX-PF-TRANS-ID (3).
055200     MOVE 'RESV'                 TO MBCA-PGMX-PF-TRANS-ID (4).
055300     MOVE 'RESV'                 TO MBCA-PGMX-PF-TRANS-ID (5).
055400     MOVE 'RESV'                 TO MBCA-PGMX-PF-TRANS-ID (6).
055500*
055600*
055700     IF ME04-ERR-MESSAGE EQUAL TO SPACES OR LOW-VALUES
055800        PERFORM MB06PD-FORMAT-MESSAGE-LINE
055900             THRU MB06PD-FML-EXIT
056000        MOVE SS08WS-FORMATTED-MSG TO ME04-ERR-MESSAGE.
056100*
056200*
056300     MOVE 'BM03'                 TO MBCA-PROGRAM-LOCATION.
056400     PERFORM MB60PD-SEND-MAP-DATA-ONLY
056500                                 THRU MB60PD-SMDO-EXIT.
056600*
056700****************************************************************
056800*    RETURN TO CICS                                            *
056900****************************************************************
057000*
057100     MOVE 'PC05'                 TO MBCA-PROGRAM-LOCATION.
057200     PERFORM MB70PD-RETURN-TRANS-ID
057300                                 THRU MB70PD-RTI-EXIT.
057400/
057500 2400-UPDATE-FILE.
057600*
057700****************************************************
057800*    READ THE EXPENSE FILE RECORD FOR UPDATE       *
057900****************************************************
058000*
058100     MOVE 'FC04'                 TO MBCA-PROGRAM-LOCATION.
058200     SET MBIORO-READ-RANDOM-UPDATE
058300                                 TO TRUE.
058400     PERFORM MMEFAO-ACCESS       THRU MMEFAO-ACCESS-EXIT.
058500*
058600*************************************
058700*    OBTAIN STORAGE FOR LOG FILE    *
058800*    RECORD IF DOING MAINTENANCE    *
058900*************************************
059000*
059100     MOVE 'SC02'                 TO MBCA-PROGRAM-LOCATION.
059200     SET MBIORO-GETMAIN          TO TRUE.
059300     PERFORM MML1AO-ACCESS       THRU MML1AO-ACCESS-EXIT.
059400*
059500 2500-UPDATE-FIELDS.
059600*
059700*
059800*            ***** AUTH APPROVAL *****                         *
059900*
060000     IF  ME04-AUTH-APPR-L IS GREATER THAN ZERO
060100         MOVE MBCA-MBME-IFT-INDEX
060200                                 TO MML1-FIELD-OCCURRENCE
060300         MOVE ZEROS              TO MML1-FIELD-OCCURRENCE-2
060400         MOVE 0401               TO MML1-FIELD-CODE
060500         MOVE MML1WS-VL-20       TO MML1-VARIABLE-LENGTH
060600         MOVE MMEF-PROD-AUTH-APPR-FEE (X-MMEF-PROD-FEES)
060700                                 TO MML1-VL20-B-NBR-NO-DEC
060800         MOVE ME04-AUTH-APPR     TO MMEF-PROD-AUTH-APPR-FEE
060900                                    (X-MMEF-PROD-FEES)
061000         MOVE MMEF-PROD-AUTH-APPR-FEE (X-MMEF-PROD-FEES)
061100                                 TO MML1-VL20-A-NBR-NO-DEC
061200         PERFORM 9050-WRITE-LOG-REC
061300                                 THRU 9099-WLR-EXIT.
061400*
061500*            ***** AUTH DECLINE  *****                         *
061600*
061700     IF  ME04-AUTH-DECL-L IS GREATER THAN ZERO
061800         MOVE MBCA-MBME-IFT-INDEX
061900                                 TO MML1-FIELD-OCCURRENCE
062000         MOVE ZEROS              TO MML1-FIELD-OCCURRENCE-2
062100         MOVE 0402               TO MML1-FIELD-CODE
062200         MOVE MML1WS-VL-20       TO MML1-VARIABLE-LENGTH
062300         MOVE MMEF-PROD-AUTH-DECL-FEE (X-MMEF-PROD-FEES)
062400                                 TO MML1-VL20-B-NBR-NO-DEC
062500         MOVE ME04-AUTH-DECL     TO MMEF-PROD-AUTH-DECL-FEE
062600                                    (X-MMEF-PROD-FEES)
062700         MOVE MMEF-PROD-AUTH-DECL-FEE (X-MMEF-PROD-FEES)
062800                                 TO MML1-VL20-A-NBR-NO-DEC
062900         PERFORM 9050-WRITE-LOG-REC
063000                                 THRU 9099-WLR-EXIT.
063100*
063200*            ***** PRODUCT USER FEE INDICATOR *****             *
063300*
063400     PERFORM
063500         VARYING X-ME04-PUF FROM 1 BY 1
063600         UNTIL X-ME04-PUF IS GREATER THAN 3
063700         SET X-MMEF-PUF          TO X-ME04-PUF
063800         SET WS-INDEX            TO X-ME04-PUF
063900         IF  ME04-PUF-IND-L (X-ME04-PUF) IS GREATER THAN ZERO
064000             MOVE MBCA-MBME-IFT-INDEX
064100                                 TO MML1-FIELD-OCCURRENCE
064200             MOVE WS-INDEX       TO MML1-FIELD-OCCURRENCE-2
064300             MOVE 0403           TO MML1-FIELD-CODE
064400             MOVE MML1WS-VL-01   TO MML1-VARIABLE-LENGTH
064500             MOVE MMEF-PUF-IND (X-MMEF-PROD-FEES X-MMEF-PUF)
064600                                     TO MML1-VL01-B-DATA-X
064700             MOVE ME04-PUF-IND (X-ME04-PUF)
064800                                 TO MMEF-PUF-IND
064900                                    (X-MMEF-PROD-FEES X-MMEF-PUF)
065000             MOVE MMEF-PUF-IND (X-MMEF-PROD-FEES X-MMEF-PUF)
065100                                     TO MML1-VL01-A-DATA-X
065200             PERFORM 9050-WRITE-LOG-REC
065300                                     THRU 9099-WLR-EXIT
065400         END-IF
065500     END-PERFORM.
065600*
065700*            ***** PRODUCT USER FEE AMOUNT *****                *
065800*
065900     PERFORM
066000         VARYING X-ME04-PUF FROM 1 BY 1
066100         UNTIL X-ME04-PUF IS GREATER THAN 3
066200         SET X-MMEF-PUF          TO X-ME04-PUF
066300         SET WS-INDEX            TO X-ME04-PUF
066400         IF  ME04-PUF-AMT-L (X-ME04-PUF) IS GREATER THAN ZERO
066500             MOVE MBCA-MBME-IFT-INDEX
066600                                 TO MML1-FIELD-OCCURRENCE
066700             MOVE WS-INDEX       TO MML1-FIELD-OCCURRENCE-2
066800             MOVE 0404           TO MML1-FIELD-CODE
066900             MOVE MML1WS-VL-20   TO MML1-VARIABLE-LENGTH
067000             MOVE MMEF-PUF-AMT (X-MMEF-PROD-FEES X-MMEF-PUF)
067100                                     TO MML1-VL20-B-NBR-NO-DEC
067200             MOVE ME04-PUF-AMT (X-ME04-PUF)
067300                                 TO MMEF-PUF-AMT
067400                                    (X-MMEF-PROD-FEES X-MMEF-PUF)
067500             MOVE MMEF-PUF-AMT (X-MMEF-PROD-FEES X-MMEF-PUF)
067600                                     TO MML1-VL20-A-NBR-NO-DEC
067700             PERFORM 9050-WRITE-LOG-REC
067800                                     THRU 9099-WLR-EXIT
067900         END-IF
068000     END-PERFORM.
068100*
068200*            ***** INTCHG RATE *****                            *
068300*
068400     SET X-MMEF-QL               TO MBCA-MBME-QL-INDEX.
068500*
068600     PERFORM
068700         VARYING X-ME04-QL FROM 1 BY 1
068800         UNTIL X-ME04-QL IS GREATER THAN 9
068900         SET WS-INDEX            TO X-MMEF-QL
069000         IF  ME04-INTCHG-RATE-L (X-ME04-QL) IS GREATER THAN ZERO
069100             MOVE MBCA-MBME-IFT-INDEX
069200                                 TO MML1-FIELD-OCCURRENCE
069300             MOVE WS-INDEX       TO MML1-FIELD-OCCURRENCE-2
069400             MOVE 0405           TO MML1-FIELD-CODE
069500             MOVE MML1WS-VL-20   TO MML1-VARIABLE-LENGTH
069600             MOVE MMEF-INTCHG-RATE (X-MMEF-IFT X-MMEF-QL)
069700                                 TO MML1-VL20-B-NBR-NO-DEC
069800             MOVE ME04-INTCHG-RATE (X-ME04-QL)
069900                                 TO MMEF-INTCHG-RATE
070000                                    (X-MMEF-IFT X-MMEF-QL)
070100             MOVE MMEF-INTCHG-RATE (X-MMEF-IFT X-MMEF-QL)
070200                                 TO MML1-VL20-A-NBR-NO-DEC
070300             PERFORM 9050-WRITE-LOG-REC
070400                                 THRU 9099-WLR-EXIT
070500             SET X-MMEF-QL       UP BY 1
070600         ELSE
070700             SET X-MMEF-QL       UP BY 1
070800         END-IF
070900     END-PERFORM.
071000*
071100*            ***** INTCHG PER ITEM *****                        *
071200*
071300     SET X-MMEF-QL               TO MBCA-MBME-QL-INDEX.
071400*
071500     PERFORM
071600         VARYING X-ME04-QL FROM 1 BY 1
071700         UNTIL X-ME04-QL IS GREATER THAN 9
071800         SET WS-INDEX            TO X-MMEF-QL
071900         IF  ME04-INTCHG-PER-ITEM-L (X-ME04-QL)
072000                                 IS GREATER THAN ZERO
072100             MOVE MBCA-MBME-IFT-INDEX
072200                                 TO MML1-FIELD-OCCURRENCE
072300             MOVE WS-INDEX       TO MML1-FIELD-OCCURRENCE-2
072400             MOVE 0406           TO MML1-FIELD-CODE
072500             MOVE MML1WS-VL-20   TO MML1-VARIABLE-LENGTH
072600             MOVE MMEF-INTCHG-PER-ITEM (X-MMEF-IFT X-MMEF-QL)
072700                                 TO MML1-VL20-B-NBR-NO-DEC
072800             MOVE ME04-INTCHG-PER-ITEM (X-ME04-QL)
072900                                 TO MMEF-INTCHG-PER-ITEM
073000                                    (X-MMEF-IFT X-MMEF-QL)
073100             MOVE MMEF-INTCHG-PER-ITEM (X-MMEF-IFT X-MMEF-QL)
073200                                 TO MML1-VL20-A-NBR-NO-DEC
073300             PERFORM 9050-WRITE-LOG-REC
073400                                 THRU 9099-WLR-EXIT
073500             SET X-MMEF-QL       UP BY 1
073600         ELSE
073700             SET X-MMEF-QL       UP BY 1
073800         END-IF
073900     END-PERFORM.
074000*
074100     SET X-MMEF-QL               TO MBCA-MBME-QL-INDEX.
074200*
074300 2650-UPDATE-MMEF.
074400*
074500     IF  MBCA-PTI-FUNCTION-IS-ADD
074600         MOVE MBCA-SCREEN-NBR    TO MMEF-ONLINE-STATUS
074700         MOVE MBCA-START-DATE    TO MMEF-LAST-MAINT-DATE
074800         MOVE MBCA-OPERATOR-ID   TO MMEF-LAST-MAINT-OPER
074900         SET WS-UPDATE-SW-YES    TO TRUE.
075000*
075100**************************************************************
075200*    WRITE A LOG RECORD TO SHOW THAT THE LAST MAINT DATE     *
075300*    AND OPERATOR HAS BEEN UPDATED IF FIELDS WERE CHANGED    *
075400*    ON THE SCREEN                                           *
075500**************************************************************
075600*
075700     IF  MBCA-PTI-FUNCTION-IS-MAINT
075800     AND WS-UPDATE-SW-YES
075900         MOVE 0198               TO MML1-FIELD-CODE
076000         MOVE ZEROES             TO MML1-FIELD-OCCURRENCE
076100                                    MML1-FIELD-OCCURRENCE-2
076200         MOVE MML1WS-VL-03       TO MML1-VARIABLE-LENGTH
076300         MOVE MMEF-LAST-MAINT-OPER
076400                                 TO MML1-VL03-B-DATA-X
076500         MOVE MBCA-OPERATOR-ID   TO MMEF-LAST-MAINT-OPER
076600         MOVE MMEF-LAST-MAINT-OPER
076700                                 TO MML1-VL03-A-DATA-X
076800         MOVE 'FC05'             TO MBCA-PROGRAM-LOCATION
076900         PERFORM 9050-WRITE-LOG-REC
077000                                 THRU 9099-WLR-EXIT
077100         MOVE 0199               TO MML1-FIELD-CODE
077200         MOVE MML1WS-VL-07       TO MML1-VARIABLE-LENGTH
077300         MOVE MMEF-LAST-MAINT-DATE
077400                                 TO MML1-VL07-B-DATA-9
077500         MOVE MBCA-START-DATE    TO MMEF-LAST-MAINT-DATE
077600         MOVE MMEF-LAST-MAINT-DATE
077700                                 TO MML1-VL07-A-DATA-9
077800         MOVE 'FC06'             TO MBCA-PROGRAM-LOCATION
077900         PERFORM 9050-WRITE-LOG-REC
078000                                 THRU 9099-WLR-EXIT.
078100*
078200****************************************************
078300*    REWRITE THE MERCHANT EXPENSE RECORD IF        *
078400*    FIELDS HAVE BEEN CHANGED ON THE SCREEN, OR    *
078500*    UNLOCK IT IF THEY HAVE NOT                    *
078600****************************************************
078700*
078800     IF  WS-UPDATE-SW-YES
078900         MOVE 'FC07'             TO MBCA-PROGRAM-LOCATION
079000         SET MBIORO-REWRITE      TO TRUE
079100         PERFORM MMEFAO-ACCESS   THRU MMEFAO-ACCESS-EXIT
079200     ELSE
079300         MOVE 'FC08'             TO MBCA-PROGRAM-LOCATION
079400         SET MBIORO-UNLOCK       TO TRUE
079500         PERFORM MMEFAO-ACCESS   THRU MMEFAO-ACCESS-EXIT.
079600/
079700 2600-SETUP-COMMAREA.
079800*
079900****************************************************************
080000*    SET UP COMMAREA FIELDS AND TRANSFER TO THE NEXT PROGRAM   *
080100****************************************************************
080200*
080300     MOVE MBCA-EIBAID            TO SS08WS-EIBAID.
080400*
080500     IF  SS08WS-VALID-PF3
080600     OR  SS08WS-EIBAID-VALID-PF3
080700         MOVE 1                  TO MBCA-MBME-QL-INDEX
080800         IF  MBCA-MBME-IFT-INDEX IS EQUAL TO 1
080900             MOVE 54             TO MBCA-SCREEN-NBR
081000             GO TO 2690-PF-KEY-BYPASS
081100         ELSE
081200             MOVE 55             TO MBCA-SCREEN-NBR
081300             GO TO 2690-PF-KEY-BYPASS.
081400*
081500     IF  SS08WS-VALID-PF4
081600     OR  SS08WS-EIBAID-VALID-PF4
081700         MOVE 91                 TO MBCA-MBME-QL-INDEX
081800         IF  MBCA-MBME-IFT-INDEX IS EQUAL TO 1
081900             MOVE 54             TO MBCA-SCREEN-NBR
082000             GO TO 2690-PF-KEY-BYPASS
082100         ELSE
082200             MOVE 55             TO MBCA-SCREEN-NBR
082300             GO TO 2690-PF-KEY-BYPASS.
082400*
082500     IF  SS08WS-VALID-PF5
082600     OR  SS08WS-EIBAID-VALID-PF5
082700         IF  MBCA-MBME-QL-INDEX IS GREATER THAN 90
082800             MOVE 91             TO MBCA-MBME-QL-INDEX
082900             IF  MBCA-MBME-IFT-INDEX IS EQUAL TO 1
083000                 MOVE 54         TO MBCA-SCREEN-NBR
083100                 GO TO 2690-PF-KEY-BYPASS
083200             ELSE
083300                 MOVE 55         TO MBCA-SCREEN-NBR
083400                 GO TO 2690-PF-KEY-BYPASS
083500         ELSE
083600             COMPUTE MBCA-MBME-QL-INDEX
083700                                 = MBCA-MBME-QL-INDEX
083800                                 + 9
083900             IF  MBCA-MBME-IFT-INDEX IS EQUAL TO 1
084000                 MOVE 54         TO MBCA-SCREEN-NBR
084100                 GO TO 2690-PF-KEY-BYPASS
084200             ELSE
084300                 MOVE 55         TO MBCA-SCREEN-NBR
084400                 GO TO 2690-PF-KEY-BYPASS.
084500*
084600     IF  SS08WS-VALID-PF6
084700     OR  SS08WS-EIBAID-VALID-PF6
084800         IF  MBCA-MBME-QL-INDEX IS LESS THAN 10
084900             MOVE 1              TO MBCA-MBME-QL-INDEX
085000             IF  MBCA-MBME-IFT-INDEX IS EQUAL TO 1
085100                 MOVE 54         TO MBCA-SCREEN-NBR
085200                 GO TO 2690-PF-KEY-BYPASS
085300             ELSE
085400                 MOVE 55         TO MBCA-SCREEN-NBR
085500                 GO TO 2690-PF-KEY-BYPASS
085600         ELSE
085700             COMPUTE MBCA-MBME-QL-INDEX
085800                                 = MBCA-MBME-QL-INDEX
085900                                 - 9
086000             IF  MBCA-MBME-IFT-INDEX IS EQUAL TO 1
086100                 MOVE 54         TO MBCA-SCREEN-NBR
086200                 GO TO 2690-PF-KEY-BYPASS
086300             ELSE
086400                 MOVE 55         TO MBCA-SCREEN-NBR
086500                 GO TO 2690-PF-KEY-BYPASS.
086600*
086700     IF  SS08WS-VALID-PF-KEY
086800     OR  SS08WS-EIBAID-VALID-PF-KEY
086900         SET MBCA-INITIAL-SCREEN-NBR
087000                                 TO TRUE
087100         GO TO 2690-PF-KEY-BYPASS.
087200*
087300     IF  TTN0162L IS GREATER THAN ZERO
087400     AND TTN0162I IS NUMERIC
087500         IF  TTN0162I IS NOT GREATER THAN MBCA-MAX-SCREEN-NBR
087600             MOVE TTN0162I       TO MBCA-SCREEN-NBR
087700             MOVE TTN0162I       TO MBCA-SAVE-SCREEN-NBR
087800             MOVE 1              TO MBCA-MBME-QL-INDEX
087900             MOVE 1              TO MBCA-MBME-IFT-INDEX
088000             ADD 50              TO MBCA-SCREEN-NBR
088100             GO TO 2690-PF-KEY-BYPASS.
088200*
088300     IF  MBCA-MBME-IFT-INDEX IS EQUAL TO 2
088400         MOVE 56                 TO MBCA-SCREEN-NBR
088500         MOVE 1                  TO MBCA-MBME-QL-INDEX
088600         MOVE 1                  TO MBCA-MBME-IFT-INDEX
088700     ELSE
088800         MOVE 55                 TO MBCA-SCREEN-NBR
088900         MOVE 1                  TO MBCA-MBME-QL-INDEX
089000         MOVE 2                  TO MBCA-MBME-IFT-INDEX.
089100*
089200 2690-PF-KEY-BYPASS.
089300*
089400     MOVE 'PC06'                 TO MBCA-PROGRAM-LOCATION.
089500     PERFORM MB70PD-XCTL-TO-MBOXCTL
089600                                 THRU MB70PD-XTM-EXIT.
089700/
089800 9000-PERFORMED-ROUTINES-SECT SECTION.
089900*
090000*
090100 9050-WRITE-LOG-REC.
090200*
090300*****************************************************************
090400*    WRITE THE LOG/JOURNAL FILE RECORD                          *
090500*****************************************************************
090600*
090700     IF  MBCA-PTI-FUNCTION-IS-ADD
090800         GO TO 9099-WLR-EXIT.
090900*
091000     MOVE 'EF'                   TO MML1-FILE-CODE.
091100     MOVE MBCA-MERCHANT-ORG      TO MML1-MMEF-ORG.
091200     MOVE MBCA-TABLE             TO MML1-MMEF-TABLE-NBR.
091300     MOVE MBCA-SIGNON-NAME       TO MML1-SIGNON-NAME.
091400     MOVE MBCA-TERMINAL-ID       TO MML1-TERMINAL-ID.
091500     MOVE ZEROES                 TO MML1-SOURCE-CODE.
091600*
091700     MOVE 'FC09'                 TO MBCA-PROGRAM-LOCATION.
091800     SET MBIORO-WRITE            TO TRUE.
091900     PERFORM MML1AO-ACCESS       THRU MML1AO-ACCESS-EXIT.
092000     MOVE SPACES                 TO MML1-VARIABLE-AREA.
092100*
092200 9099-WLR-EXIT.
092300     EXIT.
092400*
092500 9500-BUILD-SCREEN.
092600*
092700*
092800     MOVE MMEF-PROD-AUTH-APPR-FEE (X-MMEF-PROD-FEES)
092900                                 TO ME04-AUTH-APPR.
093000*
093100     MOVE MMEF-PROD-AUTH-DECL-FEE (X-MMEF-PROD-FEES)
093200                                 TO ME04-AUTH-DECL.
093300*
093400     PERFORM
093500         VARYING X-MMEF-PUF FROM 1 BY 1
093600         UNTIL X-MMEF-PUF IS GREATER THAN 3
093700         SET X-ME04-PUF          TO X-MMEF-PUF
093800         MOVE MMEF-PUF-IND (X-MMEF-PROD-FEES X-MMEF-PUF)
093900                                 TO ME04-PUF-IND (X-ME04-PUF)
094000         MOVE MMEF-PUF-AMT (X-MMEF-PROD-FEES X-MMEF-PUF)
094100                                 TO ME04-PUF-AMT (X-ME04-PUF)
094200     END-PERFORM.
094300*
094400     SET X-MMEF-QL               TO MBCA-MBME-QL-INDEX.
094500     SET X-MB80WS-QL             TO MBCA-MBME-QL-INDEX.
094600*
094700     PERFORM
094800         VARYING X-ME04-QL FROM 1 BY 1
094900         UNTIL X-ME04-QL IS GREATER THAN 9
095000         SET WS-NBR-INDEX        TO X-MMEF-QL
095100         MOVE WS-NBR-INDEX       TO ME04-PROD-NUMBER
095200                                    (X-ME04-QL)
095300         MOVE '.'                TO ME04-PROD-PERIOD
095400                                    (X-ME04-QL)
095500         MOVE DFHBMASK           TO ME04-PROD-NBR-A
095600                                    (X-ME04-QL)
095700         MOVE MB80WS-INTCHG-QL-DESC (X-MB80WS-IFT X-MB80WS-QL)
095800                                 TO ME04-INTCHG-DESC (X-ME04-QL)
095900         MOVE MMEF-INTCHG-RATE (X-MMEF-IFT X-MMEF-QL)
096000                                 TO ME04-INTCHG-RATE (X-ME04-QL)
096100         MOVE MMEF-INTCHG-PER-ITEM (X-MMEF-IFT X-MMEF-QL)
096200                                 TO ME04-INTCHG-PER-ITEM
096300                                    (X-ME04-QL)
096400         SET X-MMEF-QL           UP BY 1
096500         SET X-MB80WS-QL         UP BY 1
096600     END-PERFORM.
096700*
096800     SET X-MMEF-QL               TO MBCA-MBME-QL-INDEX.
096900     SET X-MB80WS-QL             TO MBCA-MBME-QL-INDEX.
097000*
097100 9599-BS-EXIT.
097200     EXIT.
097300*
097400/         JULIAN TO GREGORIAN DATE ROUTINE
097500     COPY SS08PD.
097600/         DATE AND TIME EDIT ROUTINES
097700     COPY SS26PD.
097800     COPY SS27PD.
097900/         LINE 24 PF KEYS ROUTINE
098000     COPY SS15PD.
098100/         ORGANIZATION FILE ACCESS ROUTINES
098200     COPY MMOCAO.
098300/         MERCHANT EXPENSE FILE ACCESS ROUTINES
098400     COPY MMEFAO.
098500/         LOG/JOURNAL ACCESS ROUTINES
098600     COPY MML1AO.
098700/         ON-LINE MAP ROUTINES
098800     COPY MB60PD REPLACING 'MBMAPXX' BY 'MBME04 '
098900                           MBMAPXXI BY MBME04I
099000                           MBMAPXXO BY MBME04O.
099100/         ON-LINE PROCEDURES
099200     COPY MB70PD.
099300/         MESSAGE FORMAT ROUTINE
099400     COPY MB06PD.
099500/
099600     COPY SMFTPXO.
