000100 IDENTIFICATION DIVISION.
000200 PROGRAM-ID. MBOME06.
000201*       RELEASE DATE=08/24/01.        REVISION LEVEL=08.06      * ++++++++
000202***************************************************************** ++++++++
000203*WARNING.  THIS COMPUTER PROGRAM IS PROTECTED BY COPYRIGHT LAW  * ++++++++
000204*AND INTERNATIONAL TREATIES.  UNAUTHORIZED REPRODUCTION OR      * ++++++++
000205*DISTRIBUTION OF THIS PROGRAM, OR ANY PORTION OF IT, MAY RESULT * ++++++++
000206*IN SEVERE CIVIL AND CRIMINAL PENATLIES, AND WILL BE PROSECUTED * ++++++++
000207*TO THE MAXIMUM EXTENT POSSIBLE UNDER THE LAW.                  * ++++++++
000208*COPYRIGHT 1999 PAYSYS INTERNATIONAL, INC.  ALL RIGHTS RESERVED.* ++++++++
000209***************************************************************** ++++++++
000300*****************************************************************
000400*                                                               *
000500*   V - PLUS  M E R C H A N T   B A N K C A R D   S Y S T E M   *
000600*                                                               *
000700*      MBOME06 - ON-LINE EXPENSE FACTORS SCREEN                 *
000800*                SCREENS 06                                     *
000900*                                                               *
001000*              1. TRANSIDS                                      *
001100*                 A. MBME                                       *
001200*              2. MAPS USED -                                   *
001300*                 A. MBME06 (SCREENS 06)                        *
001400*              3. FILES USED -                                  *
001500*                 A. MMEF   (EXPENSE FACTOS FILE)               *
001600*                 B. MMOC   (ORG CONTROL FILE)                  *
001700*                 C. MML1   (LOG FILE)                          *
001800*                                                               *
001900*****************************************************************
002000*
002100 ENVIRONMENT DIVISION.
002200 DATA DIVISION.
002300 WORKING-STORAGE SECTION.
002400 01  FILLER                  PIC  X(12)      VALUE '** WS-BEG **'.
002500*         I/O REQUEST BLOCK WORK AREAS
002600     COPY MBIOWS.
002700/         TABLE DESC FOR VISA MC AND PL
002800     COPY MB80WS.
002900/         LOG/JOURNAL WORK AREAS
003000     COPY MML1WS REPLACING ==:MML1:== BY ==MML1==.
003100/         I/O REQUEST BLOCK
003200     COPY MBIORO.
003300/         EXPENSE FILE INITILIZER RECORD
003400     COPY MMIFIR REPLACING ==:MMIF:== BY ==MMEF==.
003500/         STANDARD ERROR MESSAGES
003600     COPY MBEMWS.
003700/         DATE WORK AREAS
003800     COPY SS01WS.
003900/         ONLINE WORK AREAS
004000     COPY SS08WS.
004100/
004200     COPY SS00WS.
004300/
004400     COPY SMFTWS.
004500/
004600     COPY SMPTRL REPLACING ==:SMPT:== BY ==SMPT==.
004700/
004800     COPY MB61LK.
004900/
005000 01  WS-MISCELLANEOUS.
005100     03  WS-INDEX            PIC S9(04)      BINARY.
005200     03  WS-NBR-INDEX        PIC S9(04)      BINARY.
005300     03  WS-MIN              PIC S9(04)      VALUE 4.
005400     03  WS-UPDATE-SW        PIC  X(01)      VALUE 'N'.
005500         88  WS-UPDATE-SW-NO                 VALUE 'N'.
005600         88  WS-UPDATE-SW-YES                VALUE 'Y'.
005700*
005800 01  FILLER                  PIC  X(12)      VALUE '** WS-END **'.
005900/
006000 LINKAGE SECTION.
006100 01  DFHCOMMAREA.
006200     COPY MB60WS.
006300/         MERCHANT EXPENSE FACTORS SCREEN 06 MAP DSECT
006400     COPY MBME06.
006500/         MERCHANT EXPENSE FACTORS SCREEN 06 MAP REDEFINITION
006600     COPY MBME06R.
006700/         EXPENSE FILE MASTER RECORD LAYOUT
006800     COPY MMIFRL REPLACING ==:MMIF:== BY ==MMEF==.
006900/         ORG CONTROL FILE MASTER RECORD LAYOUT
007000     COPY MMOCRL.
007100/         LOG/JOURNAL FILE RECORD LAYOUT
007200     COPY MML1RL REPLACING ==:MML1:== BY ==MML1==.
007300/
007400 PROCEDURE DIVISION.
007500 0000-HOUSEKEEPING SECTION.
007600 0100-INIT.
007700*
007800     MOVE 'PC01'                 TO MBCA-PROGRAM-LOCATION.
007900     PERFORM MB70PD-ON-LINE-HOUSEKEEPING
008000                                 THRU MB70PD-OLH-EXIT.
008100*
008200     IF  MBCA-RECEIVE-SCREEN
008300         GO TO 2000-RECEIVE-SCREEN.
008400*
008500 1000-SEND-SCREEN SECTION.
008600*
008700****************************************************************
008800*    THIS SECTION BUILDS AND SENDS SCREEN 06                   *
008900****************************************************************
009000*
009100****************************************************************
009200*    GET CICS STORAGE NEEDED FOR THE MAP                       *
009300****************************************************************
009400*
009500     MOVE 'SC01'                 TO MBCA-PROGRAM-LOCATION.
009600     PERFORM MB60PD-GETMAIN-FOR-MAP
009700                                 THRU MB60PD-GFM-EXIT.
009800*
009900     MOVE MBCA-MERCHANT-ORG      TO ME06-ORG.
010000     MOVE MBCA-TABLE             TO ME06-TABLE-NBR.
010100*
010200****************************************************************
010300*    INITIALIZE THE STANDARD MAP LINES                         *
010400****************************************************************
010500*
010600     PERFORM MB60PD-INIT-STD-MAP-LINES
010700                                 THRU MB60PD-ISML-EXIT.
010800*
010900*
011000****************************************************************
011100*    READ THE ORG CONTROL FILE                                 *
011200****************************************************************
011300*
011400     MOVE 'FC01'                 TO MBCA-PROGRAM-LOCATION.
011500     MOVE MBCA-MERCHANT-ORG      TO MBIOWS-MMOC-ORG.
011600     SET MBIORO-READ-RANDOM      TO TRUE.
011700     PERFORM MMOCAO-ACCESS       THRU MMOCAO-ACCESS-EXIT.
011800*
011900****************************************************************
012000*    READ THE MERCHANT EXPENSE FILE                            *
012100****************************************************************
012200*
012300     MOVE 'FC02'                 TO MBCA-PROGRAM-LOCATION.
012400     MOVE MBCA-MERCHANT-ORG      TO MBIOWS-MMEF-ORG.
012500     MOVE MBCA-TABLE             TO MBIOWS-MMEF-TABLE.
012600     SET MBIORO-READ-RANDOM      TO TRUE.
012700     PERFORM MMEFAO-ACCESS       THRU MMEFAO-ACCESS-EXIT.
012800*
012900 1050-BUILD-SCREEN.
013000*
013100     PERFORM
013200         VARYING X-MMOC-PROD FROM 99 BY -1
013300         UNTIL MMOC-PRODUCT-ACTIVE (X-MMOC-PROD)
013400         OR X-MMOC-PROD IS LESS THAN 3
013500         CONTINUE
013600     END-PERFORM.
013700     IF  MMOC-PRODUCT-ACTIVE (X-MMOC-PROD)
013800     AND X-MMOC-PROD IS GREATER THAN 2
013900         SET MBCA-MBME-MAX-INDEX TO X-MMOC-PROD
014000     ELSE
014100         MOVE 3                  TO MBCA-MBME-MAX-INDEX
014200         GO TO 2400-UPDATE-FILE.
014300*
014400 1050-LOOP.
014500*
014600     SET X-MMOC-PROD             TO MBCA-MBME-PL-INDEX.
014700*
014800     IF  MBCA-MBME-PL-INDEX IS GREATER THAN MBCA-MBME-MAX-INDEX
014900     OR  MBCA-MBME-PL-INDEX IS LESS THAN 3
015000         MOVE MBEMWS-INVALID-CARD-PROD
015100                                 TO ME06-ERR-MESSAGE
015200         MOVE MBCA-MBME-PL-INDEX TO ME06-NEXT-PROD
015300         MOVE MBCA-MBME-PREV-PROD
015400                                 TO ME06-CARD-PROD
015500         SET X-MMOC-PROD         TO MBCA-MBME-PREV-PROD
015600         SET X-MMEF-PL-IFT       TO MBCA-MBME-PREV-PROD
015700         SET X-MMEF-PROD-FEES    TO MBCA-MBME-PREV-PROD
015800         SET X-MB80WS-PL-IFT     TO MBCA-MBME-PREV-PROD
015900         MOVE MMOC-PRODUCT-DESC (X-MMOC-PROD)
016000                                 TO ME06-CARD-PROD-DESC
016100         MOVE 06                 TO MBCA-SCREEN-NBR
016200         PERFORM 9500-BUILD-SCREEN
016300                                 THRU 9599-BS-EXIT
016400         PERFORM 9600-SET-FOR-NOT-FOUND
016500                                 THRU 9699-SFNF-EXIT
016600         MOVE SS08WS-CURSOR      TO ME06-NEXT-PROD-L
016700         GO TO 1100-CONTINUE.
016800*
016900     IF  MBCA-MBME-NEXT-PROD-YES
017000         IF  MMOC-PRODUCT-ACTIVE (X-MMOC-PROD)
017100             MOVE MMOC-PRODUCT-DESC (X-MMOC-PROD)
017200                                 TO ME06-CARD-PROD-DESC
017300             SET ME06-CARD-PROD  TO X-MMOC-PROD
017400             MOVE DFHBMASB       TO ME06-CARD-PROD-DESC-A
017500                                    ME06-CARD-PROD-A
017600             MOVE 06             TO MBCA-SCREEN-NBR
017700             SET X-MMEF-PL-IFT   TO MBCA-MBME-PL-INDEX
017800             SET X-MMEF-PROD-FEES
017900                                 TO MBCA-MBME-PL-INDEX
018000             SET X-MB80WS-PL-IFT TO MBCA-MBME-PL-INDEX
018100             MOVE MBCA-MBME-PL-INDEX
018200                                 TO MBCA-MBME-PREV-PROD
018300         ELSE
018400             MOVE MBEMWS-INVALID-CARD-PROD
018500                                 TO ME06-ERR-MESSAGE
018600             MOVE MBCA-MBME-PL-INDEX
018700                                 TO ME06-NEXT-PROD
018800             MOVE MBCA-MBME-PREV-PROD
018900                                 TO ME06-CARD-PROD
019000             SET X-MMOC-PROD     TO MBCA-MBME-PREV-PROD
019100             SET X-MMEF-PL-IFT   TO MBCA-MBME-PREV-PROD
019200             SET X-MMEF-PROD-FEES
019300                                 TO MBCA-MBME-PREV-PROD
019400             SET X-MB80WS-PL-IFT TO MBCA-MBME-PREV-PROD
019500             MOVE MMOC-PRODUCT-DESC (X-MMOC-PROD)
019600                                 TO ME06-CARD-PROD-DESC
019700             MOVE 06                 TO MBCA-SCREEN-NBR
019800             PERFORM 9500-BUILD-SCREEN
019900                                 THRU 9599-BS-EXIT
020000             PERFORM 9600-SET-FOR-NOT-FOUND
020100                                 THRU 9699-SFNF-EXIT
020200             MOVE SS08WS-CURSOR      TO ME06-NEXT-PROD-L
020300             GO TO 1100-CONTINUE
020400     ELSE
020500         IF  MMOC-PRODUCT-ACTIVE (X-MMOC-PROD)
020600             MOVE MMOC-PRODUCT-DESC (X-MMOC-PROD)
020700                                 TO ME06-CARD-PROD-DESC
020800             SET ME06-CARD-PROD  TO X-MMOC-PROD
020900             MOVE DFHBMASB       TO ME06-CARD-PROD-DESC-A
021000                                    ME06-CARD-PROD-A
021100             MOVE 06             TO MBCA-SCREEN-NBR
021200             SET X-MMEF-PL-IFT   TO MBCA-MBME-PL-INDEX
021300             SET X-MMEF-PROD-FEES
021400                                 TO MBCA-MBME-PL-INDEX
021500             SET X-MB80WS-PL-IFT TO MBCA-MBME-PL-INDEX
021600             MOVE MBCA-MBME-PL-INDEX
021700                                 TO MBCA-MBME-PREV-PROD
021800         ELSE
021900             ADD 1               TO MBCA-MBME-PL-INDEX
022000             GO TO 1050-LOOP.
022100*
022200     PERFORM 9500-BUILD-SCREEN   THRU 9599-BS-EXIT.
022300*
022400 1060-SET-ATTRIBUTE.
022500*
022600     IF  MBCA-PTI-FUNCTION-IS-ADD
022700         MOVE SS08WS-CURSOR      TO ME06-AUTH-APPR-L
022800     ELSE
022900         MOVE SS08WS-CURSOR      TO ME06-NEXT-PROD-L.
023000*
023100****************************************************************
023200*    IF  INQUIRY, DARKEN PARENS AND ASKIP FIELDS               *
023300****************************************************************
023400*
023500     IF  MBCA-PTI-FUNCTION-IS-INQUIRY
023600         MOVE SS08WS-CURSOR      TO ME06-ALT-TRANID-L
023700         MOVE DFHBMASB           TO ME06-AUTH-APPR-A
023800                                    ME06-AUTH-DECL-A
023900         PERFORM
024000             VARYING X-ME06-PUF FROM 1 BY 1
024100             UNTIL X-ME06-PUF IS GREATER THAN 3
024200             MOVE DFHBMASB       TO ME06-PUF-IND-A
024300                                    (X-ME06-PUF)
024400                                    ME06-PUF-AMT-A
024500                                    (X-ME06-PUF)
024600         END-PERFORM
024700         PERFORM
024800             VARYING X-ME06-PL-QL FROM 1 BY 1
024900             UNTIL X-ME06-PL-QL IS GREATER THAN 9
025000             MOVE DFHBMASB       TO ME06-INTCHG-RATE-A
025100                                    (X-ME06-PL-QL)
025200                                    ME06-INTCHG-PER-ITEM-A
025300                                    (X-ME06-PL-QL)
025400         END-PERFORM
025500         MOVE DFHBMDAS           TO ME06-AUTH-APPR-LP-A
025600                                    ME06-AUTH-APPR-RP-A
025700                                    ME06-AUTH-DECL-LP-A
025800                                    ME06-AUTH-DECL-RP-A
025900         PERFORM
026000             VARYING X-ME06-PUF FROM 1 BY 1
026100             UNTIL X-ME06-PUF IS GREATER THAN 3
026200             MOVE DFHBMDAS       TO ME06-PUF-IND-LP-A
026300                                    (X-ME06-PUF)
026400                                    ME06-PUF-IND-RP-A
026500                                    (X-ME06-PUF)
026600                                    ME06-PUF-AMT-LP-A
026700                                    (X-ME06-PUF)
026800                                    ME06-PUF-AMT-RP-A
026900                                    (X-ME06-PUF)
027000         END-PERFORM
027100         PERFORM
027200             VARYING X-ME06-PL-QL FROM 1 BY 1
027300             UNTIL X-ME06-PL-QL IS GREATER THAN 9
027400             MOVE DFHBMDAS       TO ME06-INTCHG-RATE-LP-A
027500                                    (X-ME06-PL-QL)
027600                                    ME06-INTCHG-RATE-RP-A
027700                                    (X-ME06-PL-QL)
027800                                    ME06-INTCHG-PER-ITEM-LP-A
027900                                    (X-ME06-PL-QL)
028000                                    ME06-INTCHG-PER-ITEM-RP-A
028100                                    (X-ME06-PL-QL)
028200         END-PERFORM.
028300*
028400     IF  MBCA-PTI-FUNCTION-IS-ADD
028500         MOVE DFHBMDAS           TO ME06-NEXT-PROD-LIT-A
028600                                    ME06-NEXT-PROD-LP-A
028700                                    ME06-NEXT-PROD-RP-A
028800                                    ME06-NEXT-PROD-A.
028900*
029000 1100-CONTINUE.
029100*
029200     MOVE '*TOP*'                TO SS08WS-LINE-24-PF-KEY-FUNC(3).
029300     MOVE '*BOT*'                TO SS08WS-LINE-24-PF-KEY-FUNC(4).
029400     MOVE '*FWD*'                TO SS08WS-LINE-24-PF-KEY-FUNC(5).
029500     MOVE '*BWD*'                TO SS08WS-LINE-24-PF-KEY-FUNC(6).
029600     MOVE SS08WS-LINE-24         TO ME06-PF-KEYS.
029700     MOVE 'RESV'                 TO MBCA-PGMX-PF-TRANS-ID (3).
029800     MOVE 'RESV'                 TO MBCA-PGMX-PF-TRANS-ID (4).
029900     MOVE 'RESV'                 TO MBCA-PGMX-PF-TRANS-ID (5).
030000     MOVE 'RESV'                 TO MBCA-PGMX-PF-TRANS-ID (6).
030100*
030200     IF  MBCA-MBME-PRODS-YES
030300     AND NOT MMEF-REC-ACTIVE
030400         EVALUATE TRUE                                            FX800006
030410             WHEN MMEF-REC-INACTIVE                               FX800006
030412                 MOVE '    PRODUCTS REMAINING - RECORD INACTIVE  'FX800006
030414                                 TO ME06-ERR-MESSAGE              FX800006
030500             WHEN OTHER                                           FX800006
030510                 MOVE '    PRODUCTS REMAINING - RECORD INCOMPLETE'FX800006
030512                                 TO ME06-ERR-MESSAGE              FX800006
030514         END-EVALUATE                                             FX800006
030600         SET MBCA-MBME-PRODS-NO  TO TRUE.
030700*
030800****************************************************************
030900*    FORMAT THE MESSAGE LINE                                   *
031000****************************************************************
031100*
031200     IF ME06-ERR-MESSAGE EQUAL TO SPACES OR LOW-VALUES
031300        PERFORM MB06PD-FORMAT-MESSAGE-LINE
031400           THRU MB06PD-FML-EXIT
031500        MOVE SS08WS-FORMATTED-MSG TO ME06-ERR-MESSAGE.
031600*
031700****************************************************************
031800*    SEND THE MAP                                              *
031900****************************************************************
032000*
032100     MOVE 'BM01'                 TO MBCA-PROGRAM-LOCATION.
032200     PERFORM MB60PD-SEND-MAP-WITH-ERASE
032300                                 THRU MB60PD-SMWE-EXIT.
032400*
032500****************************************************************
032600*    RETURN TO CICS                                            *
032700****************************************************************
032800*
032900     MOVE 'PC02'                 TO MBCA-PROGRAM-LOCATION.
033000     PERFORM MB70PD-RETURN-TRANS-ID
033100                                 THRU MB70PD-RTI-EXIT.
033200/
033300 2000-RECEIVE-SCREEN SECTION.
033400*
033500****************************************************************
033600*    THIS SECTION RECEIVES THE 06 SCREEN                       *
033700****************************************************************
033800*
033900     MOVE 'BM02'                 TO MBCA-PROGRAM-LOCATION.
034000     PERFORM MB60PD-RECEIVE-MAP  THRU MB60PD-RM-EXIT.
034100     MOVE DFHBMASK               TO ME06-CURRENT-PAGE-A.
034200*
034300****************************************************************
034400*    CHECK FOR ANOTHER TRANSACTION ID ENTERED BY THE USER      *
034500****************************************************************
034600*
034700     MOVE 'PC03'                 TO MBCA-PROGRAM-LOCATION.
034800     PERFORM MB60PD-NEW-TRANS-ROUTINE
034900                                 THRU MB60PD-NTR-EXIT.
035000*
035100****************************************************************
035200*    READ THE ORG CONTROL FILE                                 *
035300****************************************************************
035400*
035500     MOVE 'FC03'                 TO MBCA-PROGRAM-LOCATION.
035600     MOVE MBCA-MERCHANT-ORG      TO MBIOWS-MMOC-ORG.
035700     SET MBIORO-READ-RANDOM      TO TRUE.
035800     PERFORM MMOCAO-ACCESS       THRU MMOCAO-ACCESS-EXIT.
035900*
036000****************************************************************
036100*    BYPASS EDITS ON INQUIRY                                   *
036200****************************************************************
036300*
036400     SET X-MMEF-PROD-FEES         TO MBCA-MBME-PL-INDEX.
036500     SET X-MMEF-PL-IFT            TO MBCA-MBME-PL-INDEX.
036600*
036700****************************************************************
036800*    READ RANDOM THE EXPENSE RECORD                            *
036900****************************************************************
037000*
037100     MOVE 'FC04'                 TO MBCA-PROGRAM-LOCATION.
037200     MOVE MBCA-MERCHANT-ORG      TO MBIOWS-MMEF-ORG.
037300     MOVE MBCA-TABLE             TO MBIOWS-MMEF-TABLE.
037400     SET MBIORO-READ-RANDOM      TO TRUE.
037500     PERFORM MMEFAO-ACCESS       THRU MMEFAO-ACCESS-EXIT.
037600*
037700     IF  MBCA-PTI-FUNCTION-IS-INQUIRY
037800         GO TO 2600-SETUP-COMMAREA.
037900*
038000****************************************************************
038100*                    EDIT FIELDS                               *
038200****************************************************************
038300*
038400****************************************************************
038500*                  NEXT PRODUCT                                *
038600****************************************************************
038700*
038800     IF  ME06-NEXT-PROD-L        IS LESS THAN 1
038900         MOVE DFHBMASK           TO ME06-NEXT-PROD-A
039000         MOVE DFHBMDAS           TO ME06-NEXT-PROD-LP-A
039100                                    ME06-NEXT-PROD-RP-A
039200         MOVE MBCA-MBME-PL-INDEX TO ME06-NEXT-PROD
039300     ELSE
039400         IF  ME06-NEXT-PROD IS NUMERIC
039500             MOVE DFHBMASF       TO ME06-NEXT-PROD-A
039600             MOVE DFHBMDAS       TO ME06-NEXT-PROD-LP-A
039700                                    ME06-NEXT-PROD-RP-A
039800         ELSE
039900             MOVE DFHBMNBF       TO ME06-NEXT-PROD-A
040000             MOVE DFHBMASB       TO ME06-NEXT-PROD-LP-A
040100                                    ME06-NEXT-PROD-RP-A
040200             MOVE SS08WS-CURSOR  TO ME06-NEXT-PROD-L
040300             SET SS08WS-ERROR-SW-YES TO TRUE.
040400*
040500****************************************************************
040600*                  AUTH APPROVAL                               *
040700****************************************************************
040800*
040900     IF  ME06-AUTH-APPR-L        IS LESS THAN 1
041000         MOVE DFHBMASK           TO ME06-AUTH-APPR-A
041100         MOVE DFHBMDAS           TO ME06-AUTH-APPR-LP-A
041200                                    ME06-AUTH-APPR-RP-A
041300         MOVE MMEF-PROD-AUTH-APPR-FEE (X-MMEF-PROD-FEES)
041400                                 TO ME06-AUTH-APPR
041500     ELSE
041600         IF  ME06-AUTH-APPR IS NUMERIC
041700             MOVE DFHBMASF       TO ME06-AUTH-APPR-A
041800             MOVE DFHBMDAS       TO ME06-AUTH-APPR-LP-A
041900                                    ME06-AUTH-APPR-RP-A
042000             SET WS-UPDATE-SW-YES
042100                                 TO TRUE
042200         ELSE
042300             MOVE DFHBMNBF       TO ME06-AUTH-APPR-A
042400             MOVE DFHBMASB       TO ME06-AUTH-APPR-LP-A
042500                                    ME06-AUTH-APPR-RP-A
042600             MOVE SS08WS-CURSOR  TO ME06-AUTH-APPR-L
042700             SET SS08WS-ERROR-SW-YES TO TRUE.
042800*
042900****************************************************************
043000*                  AUTH DECLINE                                *
043100****************************************************************
043200*
043300     IF  ME06-AUTH-DECL-L        IS LESS THAN 1
043400         MOVE DFHBMASK           TO ME06-AUTH-DECL-A
043500         MOVE DFHBMDAS           TO ME06-AUTH-DECL-LP-A
043600                                    ME06-AUTH-DECL-RP-A
043700         MOVE MMEF-PROD-AUTH-DECL-FEE (X-MMEF-PROD-FEES)
043800                                 TO ME06-AUTH-DECL
043900     ELSE
044000         IF  ME06-AUTH-DECL IS NUMERIC
044100             MOVE DFHBMASF       TO ME06-AUTH-DECL-A
044200             MOVE DFHBMDAS       TO ME06-AUTH-DECL-LP-A
044300                                    ME06-AUTH-DECL-RP-A
044400             SET WS-UPDATE-SW-YES
044500                                 TO TRUE
044600         ELSE
044700             MOVE DFHBMNBF       TO ME06-AUTH-DECL-A
044800             MOVE DFHBMASB       TO ME06-AUTH-DECL-LP-A
044900                                    ME06-AUTH-DECL-RP-A
045000             MOVE SS08WS-CURSOR  TO ME06-AUTH-DECL-L
045100             SET SS08WS-ERROR-SW-YES TO TRUE.
045200*
045300****************************************************************
045400*                PRODUCT USER FEES INDICATOR                   *
045500****************************************************************
045600*
045700     PERFORM
045800         VARYING X-ME06-PUF FROM 1 BY 1
045900         UNTIL X-ME06-PUF IS GREATER THAN 3
046000         SET X-MMEF-PUF          TO X-ME06-PUF
046100         IF ME06-PUF-IND-L (X-ME06-PUF) IS LESS THAN 1
046200             MOVE DFHBMASK       TO ME06-PUF-IND-A (X-ME06-PUF)
046300             MOVE DFHBMDAS       TO ME06-PUF-IND-LP-A (X-ME06-PUF)
046400                                    ME06-PUF-IND-RP-A (X-ME06-PUF)
046500             MOVE MMEF-PUF-IND (X-MMEF-PROD-FEES X-MMEF-PUF)
046600                                 TO ME06-PUF-IND (X-ME06-PUF)
046700         ELSE
046800             IF  ME06-VALID-PUF-IND (X-ME06-PUF)
046900                 MOVE DFHBMASF   TO ME06-PUF-IND-A (X-ME06-PUF)
047000                 MOVE DFHBMDAS   TO ME06-PUF-IND-LP-A (X-ME06-PUF)
047100                                    ME06-PUF-IND-RP-A (X-ME06-PUF)
047200                 SET WS-UPDATE-SW-YES
047300                                 TO TRUE
047400             ELSE
047500                 MOVE DFHBMUBF   TO ME06-PUF-IND-A (X-ME06-PUF)
047600                 MOVE DFHBMASB   TO ME06-PUF-IND-LP-A (X-ME06-PUF)
047700                                    ME06-PUF-IND-RP-A (X-ME06-PUF)
047800                 MOVE SS08WS-CURSOR TO ME06-PUF-IND-L (X-ME06-PUF)
047900                 SET SS08WS-ERROR-SW-YES
048000                                 TO TRUE
048100             END-IF
048200         END-IF
048300     END-PERFORM.
048400*
048500****************************************************************
048600*                PRODUCT USER FEES AMOUNT                      *
048700****************************************************************
048800*
048900     PERFORM
049000         VARYING X-ME06-PUF FROM 1 BY 1
049100         UNTIL X-ME06-PUF IS GREATER THAN 3
049200         SET X-MMEF-PUF          TO X-ME06-PUF
049300         IF ME06-PUF-AMT-L (X-ME06-PUF) IS LESS THAN 1
049400             MOVE DFHBMASK       TO ME06-PUF-AMT-A (X-ME06-PUF)
049500             MOVE DFHBMDAS       TO ME06-PUF-AMT-LP-A (X-ME06-PUF)
049600                                    ME06-PUF-AMT-RP-A (X-ME06-PUF)
049700             MOVE MMEF-PUF-AMT (X-MMEF-PROD-FEES X-MMEF-PUF)
049800                                 TO ME06-PUF-AMT (X-ME06-PUF)
049900         ELSE
050000             IF  ME06-PUF-AMT (X-ME06-PUF) IS NUMERIC
050100                 MOVE DFHBMASF   TO ME06-PUF-AMT-A (X-ME06-PUF)
050200                 MOVE DFHBMDAS   TO ME06-PUF-AMT-LP-A (X-ME06-PUF)
050300                                    ME06-PUF-AMT-RP-A (X-ME06-PUF)
050400                 SET WS-UPDATE-SW-YES
050500                                 TO TRUE
050600             ELSE
050700                 MOVE DFHBMNBF   TO ME06-PUF-AMT-A (X-ME06-PUF)
050800                 MOVE DFHBMASB   TO ME06-PUF-AMT-LP-A (X-ME06-PUF)
050900                                    ME06-PUF-AMT-RP-A (X-ME06-PUF)
051000                 MOVE SS08WS-CURSOR TO ME06-PUF-AMT-L (X-ME06-PUF)
051100                 SET SS08WS-ERROR-SW-YES
051200                                 TO TRUE
051300             END-IF
051400         END-IF
051500         IF (ME06-PUF-IND(X-ME06-PUF) EQUAL 'P' AND
051600             ME06-PUF-AMT(X-ME06-PUF)(1:2) NOT EQUAL 00)
051700             MOVE DFHBMNBF   TO ME06-PUF-AMT-A
051800                                 (X-ME06-PUF)
051900             MOVE DFHBMASB   TO ME06-PUF-AMT-LP-A
052000                                 (X-ME06-PUF)
052100                                ME06-PUF-AMT-RP-A
052200                                 (X-ME06-PUF)
052300             MOVE SS08WS-CURSOR TO ME06-PUF-AMT-L
052400                                 (X-ME06-PUF)
052500             SET SS08WS-ERROR-SW-YES
052600                              TO TRUE
052700             SET WS-UPDATE-SW-NO
052800                              TO TRUE
052900             MOVE 'NOT A VALID PERCENT' TO ME06-ERR-MESSAGE
053000         ELSE
053100             SET WS-UPDATE-SW-YES
053200                              TO TRUE
053300         END-IF
053400     END-PERFORM.
053500*
053600****************************************************************
053700*                INTERCHANGE RATE                              *
053800****************************************************************
053900*
054000     PERFORM
054100         VARYING X-ME06-PL-QL FROM 1 BY 1
054200         UNTIL X-ME06-PL-QL IS GREATER THAN 9
054300         SET X-MMEF-PL-QL        TO X-ME06-PL-QL
054400         IF ME06-INTCHG-RATE-L (X-ME06-PL-QL) IS LESS THAN 1
054500             MOVE DFHBMASK       TO ME06-INTCHG-RATE-A
054600                                    (X-ME06-PL-QL)
054700             MOVE DFHBMDAS       TO ME06-INTCHG-RATE-LP-A
054800                                    (X-ME06-PL-QL)
054900                                    ME06-INTCHG-RATE-RP-A
055000                                    (X-ME06-PL-QL)
055100             MOVE MMEF-PL-INTCHG-RATE (X-MMEF-PL-IFT X-MMEF-PL-QL)
055200                                 TO ME06-INTCHG-RATE
055300                                    (X-ME06-PL-QL)
055400         ELSE
055500             IF  ME06-INTCHG-RATE (X-ME06-PL-QL) IS NUMERIC
055600                 MOVE DFHBMASF   TO ME06-INTCHG-RATE-A
055700                                    (X-ME06-PL-QL)
055800                 MOVE DFHBMDAS   TO ME06-INTCHG-RATE-LP-A
055900                                    (X-ME06-PL-QL)
056000                                    ME06-INTCHG-RATE-RP-A
056100                                    (X-ME06-PL-QL)
056200                 SET WS-UPDATE-SW-YES
056300                                 TO TRUE
056400             ELSE
056500                 MOVE DFHBMNBF   TO ME06-INTCHG-RATE-A
056600                                    (X-ME06-PL-QL)
056700                 MOVE DFHBMASB   TO ME06-INTCHG-RATE-LP-A
056800                                    (X-ME06-PL-QL)
056900                                    ME06-INTCHG-RATE-RP-A
057000                                    (X-ME06-PL-QL)
057100                 MOVE SS08WS-CURSOR TO ME06-INTCHG-RATE-L
057200                                    (X-ME06-PL-QL)
057300                 SET SS08WS-ERROR-SW-YES
057400                                 TO TRUE
057500             END-IF
057600         END-IF
057700     END-PERFORM.
057800*
057900****************************************************************
058000*                INTERCHANGE PER ITEM                          *
058100****************************************************************
058200*
058300     PERFORM
058400         VARYING X-ME06-PL-QL FROM 1 BY 1
058500         UNTIL X-ME06-PL-QL IS GREATER THAN 9
058600         SET X-MMEF-PL-QL        TO X-ME06-PL-QL
058700         IF ME06-INTCHG-PER-ITEM-L (X-ME06-PL-QL) IS LESS THAN 1
058800             MOVE DFHBMASK       TO ME06-INTCHG-PER-ITEM-A
058900                                    (X-ME06-PL-QL)
059000             MOVE DFHBMDAS       TO ME06-INTCHG-PER-ITEM-LP-A
059100                                    (X-ME06-PL-QL)
059200                                    ME06-INTCHG-PER-ITEM-RP-A
059300                                    (X-ME06-PL-QL)
059400             MOVE MMEF-PL-INTCHG-PER-ITEM
059500                                    (X-MMEF-PL-IFT X-MMEF-PL-QL)
059600                                 TO ME06-INTCHG-PER-ITEM
059700                                    (X-ME06-PL-QL)
059800         ELSE
059900             IF  ME06-INTCHG-PER-ITEM (X-ME06-PL-QL) IS NUMERIC
060000                 MOVE DFHBMASF   TO ME06-INTCHG-PER-ITEM-A
060100                                    (X-ME06-PL-QL)
060200                 MOVE DFHBMDAS   TO ME06-INTCHG-PER-ITEM-LP-A
060300                                    (X-ME06-PL-QL)
060400                                    ME06-INTCHG-PER-ITEM-RP-A
060500                                    (X-ME06-PL-QL)
060600                 SET WS-UPDATE-SW-YES
060700                                 TO TRUE
060800             ELSE
060900                 MOVE DFHBMNBF   TO ME06-INTCHG-PER-ITEM-A
061000                                    (X-ME06-PL-QL)
061100                 MOVE DFHBMASB   TO ME06-INTCHG-PER-ITEM-LP-A
061200                                    (X-ME06-PL-QL)
061300                                    ME06-INTCHG-PER-ITEM-RP-A
061400                                    (X-ME06-PL-QL)
061500                 MOVE SS08WS-CURSOR TO ME06-INTCHG-PER-ITEM-L
061600                                    (X-ME06-PL-QL)
061700                 SET SS08WS-ERROR-SW-YES
061800                                 TO TRUE
061900             END-IF
062000         END-IF
062100     END-PERFORM.
062200*
062300     IF  SS08WS-ERROR-SW-NO
062400         GO TO 2400-UPDATE-FILE.
062500*
062600 2300-SEND-MAP.
062700*
062800****************************************************************
062900*    SEND THE MAP                                              *
063000****************************************************************
063100*
063200     PERFORM MB60PD-INIT-STD-MAP-LINES
063300                                 THRU MB60PD-ISML-EXIT.
063400*
063500     MOVE '*TOP*'                TO SS08WS-LINE-24-PF-KEY-FUNC(3).
063600     MOVE '*BOT*'                TO SS08WS-LINE-24-PF-KEY-FUNC(4).
063700     MOVE '*FWD*'                TO SS08WS-LINE-24-PF-KEY-FUNC(5).
063800     MOVE '*BWD*'                TO SS08WS-LINE-24-PF-KEY-FUNC(6).
063900     MOVE SS08WS-LINE-24         TO ME06-PF-KEYS.
064000     MOVE 'RESV'                 TO MBCA-PGMX-PF-TRANS-ID (3).
064100     MOVE 'RESV'                 TO MBCA-PGMX-PF-TRANS-ID (4).
064200     MOVE 'RESV'                 TO MBCA-PGMX-PF-TRANS-ID (5).
064300     MOVE 'RESV'                 TO MBCA-PGMX-PF-TRANS-ID (6).
064400*
064500     IF ME06-ERR-MESSAGE EQUAL TO SPACES OR LOW-VALUES
064600         PERFORM MB06PD-FORMAT-MESSAGE-LINE
064700              THRU MB06PD-FML-EXIT
064800         MOVE SS08WS-FORMATTED-MSG TO ME06-ERR-MESSAGE.
064900*
065000     MOVE 'BM03'                 TO MBCA-PROGRAM-LOCATION.
065100     PERFORM MB60PD-SEND-MAP-DATA-ONLY
065200                                 THRU MB60PD-SMDO-EXIT.
065300*
065400****************************************************************
065500*    RETURN TO CICS                                            *
065600****************************************************************
065700*
065800     MOVE 'PC04'                 TO MBCA-PROGRAM-LOCATION.
065900     PERFORM MB70PD-RETURN-TRANS-ID
066000                                 THRU MB70PD-RTI-EXIT.
066100/
066200 2400-UPDATE-FILE.
066300*
066400****************************************************
066500*    READ THE EXPENSE RECORD FOR UPDATE            *
066600****************************************************
066700*
066800     MOVE 'FC05'                 TO MBCA-PROGRAM-LOCATION.
066900     SET MBIORO-READ-RANDOM-UPDATE
067000                                 TO TRUE.
067100     PERFORM MMEFAO-ACCESS       THRU MMEFAO-ACCESS-EXIT.
067200*
067300     IF  WS-UPDATE-SW-NO
067400         IF  MBCA-PTI-FUNCTION-IS-ADD
067500             MOVE 'SC02'         TO MBCA-PROGRAM-LOCATION
067600             SET MBIORO-GETMAIN  TO TRUE
067700             PERFORM MML1AO-ACCESS
067800                                 THRU MML1AO-ACCESS-EXIT
067900             GO TO 2450-UPDATE-MMEF
068000         ELSE
068100             MOVE 'FC06'         TO MBCA-PROGRAM-LOCATION
068200             SET MBIORO-UNLOCK   TO TRUE
068300             PERFORM MMEFAO-ACCESS
068400                                 THRU MMEFAO-ACCESS-EXIT
068500             GO TO 2600-SETUP-COMMAREA.
068600*
068700****************************************************************
068800*    GETMAIN FOR LOG/JOURNAL RECORD                            *
068900****************************************************************
069000*
069100     MOVE 'SC03'                 TO MBCA-PROGRAM-LOCATION.
069200     SET MBIORO-GETMAIN          TO TRUE.
069300     PERFORM MML1AO-ACCESS       THRU MML1AO-ACCESS-EXIT.
069400*
069500*
069600 2410-UPDATE-FIELDS.
069700*
069800     SET X-MMEF-PROD-FEES        TO MBCA-MBME-PL-INDEX.
069900     SET X-MMEF-PL-IFT           TO MBCA-MBME-PL-INDEX.
070000*
070100*            ***** AUTH APPROVAL *****                         *
070200*
070300     IF  ME06-AUTH-APPR-L IS GREATER THAN ZERO
070400         SET WS-INDEX            TO X-MMEF-PROD-FEES
070500         MOVE WS-INDEX           TO MML1-FIELD-OCCURRENCE
070600         MOVE ZEROS              TO MML1-FIELD-OCCURRENCE-2
070700         MOVE 0401               TO MML1-FIELD-CODE
070800         MOVE MML1WS-VL-20       TO MML1-VARIABLE-LENGTH
070900         MOVE MMEF-PROD-AUTH-APPR-FEE (X-MMEF-PROD-FEES)
071000                                 TO MML1-VL20-B-NBR-NO-DEC
071100         MOVE ME06-AUTH-APPR     TO MMEF-PROD-AUTH-APPR-FEE
071200                                    (X-MMEF-PROD-FEES)
071300         MOVE MMEF-PROD-AUTH-APPR-FEE (X-MMEF-PROD-FEES)
071400                                 TO MML1-VL20-A-NBR-NO-DEC
071500         PERFORM 9100-WRITE-LOG-RECORD
071600                                 THRU 9199-WLR-EXIT.
071700*
071800*            ***** AUTH DECLINE  *****                         *
071900*
072000     IF  ME06-AUTH-DECL-L IS GREATER THAN ZERO
072100         SET WS-INDEX            TO X-MMEF-PROD-FEES
072200         MOVE WS-INDEX           TO MML1-FIELD-OCCURRENCE
072300         MOVE ZEROS              TO MML1-FIELD-OCCURRENCE-2
072400         MOVE 0402               TO MML1-FIELD-CODE
072500         MOVE MML1WS-VL-20       TO MML1-VARIABLE-LENGTH
072600         MOVE MMEF-PROD-AUTH-DECL-FEE (X-MMEF-PROD-FEES)
072700                                 TO MML1-VL20-B-NBR-NO-DEC
072800         MOVE ME06-AUTH-DECL     TO MMEF-PROD-AUTH-DECL-FEE
072900                                    (X-MMEF-PROD-FEES)
073000         MOVE MMEF-PROD-AUTH-DECL-FEE (X-MMEF-PROD-FEES)
073100                                 TO MML1-VL20-A-NBR-NO-DEC
073200         PERFORM 9100-WRITE-LOG-RECORD
073300                                 THRU 9199-WLR-EXIT.
073400*
073500*            ***** PRODUCT USER FEE INDICATOR *****             *
073600*
073700     PERFORM
073800         VARYING X-ME06-PUF FROM 1 BY 1
073900         UNTIL X-ME06-PUF IS GREATER THAN 3
074000         SET X-MMEF-PUF          TO X-ME06-PUF
074100         SET WS-INDEX            TO X-ME06-PUF
074200         IF  ME06-PUF-IND-L (X-ME06-PUF) IS GREATER THAN ZERO
074300             MOVE MBCA-MBME-PL-INDEX
074400                                 TO MML1-FIELD-OCCURRENCE
074500             MOVE WS-INDEX       TO MML1-FIELD-OCCURRENCE-2
074600             MOVE 0403           TO MML1-FIELD-CODE
074700             MOVE MML1WS-VL-01   TO MML1-VARIABLE-LENGTH
074800             MOVE MMEF-PUF-IND (X-MMEF-PROD-FEES X-MMEF-PUF)
074900                                 TO MML1-VL01-B-DATA-X
075000             MOVE ME06-PUF-IND (X-ME06-PUF)
075100                                 TO MMEF-PUF-IND
075200                                    (X-MMEF-PROD-FEES X-MMEF-PUF)
075300             MOVE MMEF-PUF-IND (X-MMEF-PROD-FEES X-MMEF-PUF)
075400                                 TO MML1-VL01-A-DATA-X
075500             PERFORM 9100-WRITE-LOG-RECORD
075600                                     THRU 9199-WLR-EXIT
075700         END-IF
075800     END-PERFORM.
075900*
076000*            ***** PRODUCT USER FEE AMOUNT *****                *
076100*
076200     PERFORM
076300         VARYING X-ME06-PUF FROM 1 BY 1
076400         UNTIL X-ME06-PUF IS GREATER THAN 3
076500         SET X-MMEF-PUF          TO X-ME06-PUF
076600         SET WS-INDEX            TO X-ME06-PUF
076700         IF  ME06-PUF-AMT-L (X-ME06-PUF) IS GREATER THAN ZERO
076800             MOVE MBCA-MBME-PL-INDEX
076900                                 TO MML1-FIELD-OCCURRENCE
077000             MOVE WS-INDEX       TO MML1-FIELD-OCCURRENCE-2
077100             MOVE 0404           TO MML1-FIELD-CODE
077200             MOVE MML1WS-VL-20   TO MML1-VARIABLE-LENGTH
077300             MOVE MMEF-PUF-AMT (X-MMEF-PROD-FEES X-MMEF-PUF)
077400                                 TO MML1-VL20-B-NBR-NO-DEC
077500             MOVE ME06-PUF-AMT (X-ME06-PUF)
077600                                 TO MMEF-PUF-AMT
077700                                    (X-MMEF-PROD-FEES X-MMEF-PUF)
077800             MOVE MMEF-PUF-AMT (X-MMEF-PROD-FEES X-MMEF-PUF)
077900                                 TO MML1-VL20-A-NBR-NO-DEC
078000             PERFORM 9100-WRITE-LOG-RECORD
078100                                 THRU 9199-WLR-EXIT
078200         END-IF
078300     END-PERFORM.
078400*
078500*            ***** INTCHG RATE *****                            *
078600*
078700     PERFORM
078800         VARYING X-ME06-PL-QL FROM 1 BY 1
078900         UNTIL X-ME06-PL-QL IS GREATER THAN 9
079000         SET WS-INDEX            TO X-ME06-PL-QL
079100         SET X-MMEF-PL-QL        TO X-ME06-PL-QL
079200         IF  ME06-INTCHG-RATE-L (X-ME06-PL-QL)
079300                                IS GREATER THAN ZERO
079400             MOVE MBCA-MBME-PL-INDEX
079500                                 TO MML1-FIELD-OCCURRENCE
079600             MOVE WS-INDEX       TO MML1-FIELD-OCCURRENCE-2
079700             MOVE 0605           TO MML1-FIELD-CODE
079800             MOVE MML1WS-VL-20   TO MML1-VARIABLE-LENGTH
079900             MOVE MMEF-PL-INTCHG-RATE (X-MMEF-PL-IFT X-MMEF-PL-QL)
080000                                 TO MML1-VL20-B-NBR-NO-DEC
080100             MOVE ME06-INTCHG-RATE (X-ME06-PL-QL)
080200                                 TO MMEF-PL-INTCHG-RATE
080300                                    (X-MMEF-PL-IFT X-MMEF-PL-QL)
080400             MOVE MMEF-PL-INTCHG-RATE (X-MMEF-PL-IFT X-MMEF-PL-QL)
080500                                 TO MML1-VL20-A-NBR-NO-DEC
080600             PERFORM 9100-WRITE-LOG-RECORD
080700                                 THRU 9199-WLR-EXIT
080800         END-IF
080900     END-PERFORM.
081000*
081100*            ***** INTCHG PER ITEM *****                        *
081200*
081300     PERFORM
081400         VARYING X-ME06-PL-QL FROM 1 BY 1
081500         UNTIL X-ME06-PL-QL IS GREATER THAN 9
081600         SET WS-INDEX            TO X-ME06-PL-QL
081700         SET X-MMEF-PL-QL        TO X-ME06-PL-QL
081800         IF  ME06-INTCHG-PER-ITEM-L (X-ME06-PL-QL)
081900                                 IS GREATER THAN ZERO
082000             MOVE MBCA-MBME-PL-INDEX
082100                                 TO MML1-FIELD-OCCURRENCE
082200             MOVE WS-INDEX       TO MML1-FIELD-OCCURRENCE-2
082300             MOVE 0606           TO MML1-FIELD-CODE
082400             MOVE MML1WS-VL-20   TO MML1-VARIABLE-LENGTH
082500             MOVE MMEF-PL-INTCHG-PER-ITEM
082600                                    (X-MMEF-PL-IFT X-MMEF-PL-QL)
082700                                 TO MML1-VL20-B-NBR-NO-DEC
082800             MOVE ME06-INTCHG-PER-ITEM (X-ME06-PL-QL)
082900                                 TO MMEF-PL-INTCHG-PER-ITEM
083000                                    (X-MMEF-PL-IFT X-MMEF-PL-QL)
083100             MOVE MMEF-PL-INTCHG-PER-ITEM
083200                                    (X-MMEF-PL-IFT X-MMEF-PL-QL)
083300                                 TO MML1-VL20-A-NBR-NO-DEC
083400             PERFORM 9100-WRITE-LOG-RECORD
083500                                 THRU 9199-WLR-EXIT
083600         END-IF
083700     END-PERFORM.
083800*
083900 2450-UPDATE-MMEF.
084000*
084100     IF  MBCA-PTI-FUNCTION-IS-ADD
084200         MOVE MBCA-START-DATE    TO MMEF-LAST-MAINT-DATE
084300         MOVE MBCA-OPERATOR-ID   TO MMEF-LAST-MAINT-OPER
084400         SET WS-UPDATE-SW-YES    TO TRUE
084500         IF  MBCA-MBME-PL-INDEX IS EQUAL TO MBCA-MBME-MAX-INDEX
084600         AND MBCA-EIBAID-ENTER
084700             SET MMEF-REC-ACTIVE TO TRUE
084800             SET MMEF-ADD-COMPLETED
084900                                 TO TRUE
085000             MOVE ZEROES         TO MML1-FIELD-CODE
085100                                    MML1-FIELD-OCCURRENCE
085200                                    MML1-FIELD-OCCURRENCE-2
085300             MOVE LENGTH OF MMEF-RECORD
085400                                 TO MML1-VARIABLE-LENGTH
085500             MOVE 'EF'           TO MML1-FILE-CODE
085600             MOVE MBCA-MERCHANT-ORG
085700                                 TO MML1-MMEF-ORG
085800             MOVE MBCA-TABLE     TO MML1-MMEF-TABLE-NBR
085900             MOVE MBCA-SIGNON-NAME
086000                                 TO MML1-SIGNON-NAME
086100             MOVE MBCA-TERMINAL-ID
086200                                 TO MML1-TERMINAL-ID
086300             MOVE MMEF-RECORD    TO MML1-ADD-AREA
086400             MOVE 'FC07'         TO MBCA-PROGRAM-LOCATION
086500             SET MBIORO-WRITE    TO TRUE
086600             PERFORM MML1AO-ACCESS
086700                                 THRU MML1AO-ACCESS-EXIT.
086800**************************************************************
086900*    WRITE A LOG RECORD TO SHOW THAT THE LAST MAINT DATE     *
087000*    AND OPERATOR HAS BEEN UPDATED IF FIELDS WERE CHANGED    *
087100*    ON THIS SCREEN.                                         *
087200**************************************************************
087300*
087400     IF  MBCA-PTI-FUNCTION-IS-MAINT
087500     AND WS-UPDATE-SW-YES
087600         MOVE 0198               TO MML1-FIELD-CODE
087700         MOVE ZEROES             TO MML1-FIELD-OCCURRENCE
087800                                    MML1-FIELD-OCCURRENCE-2
087900         MOVE MML1WS-VL-03       TO MML1-VARIABLE-LENGTH
088000         MOVE MMEF-LAST-MAINT-OPER
088100                                 TO MML1-VL03-B-DATA-X
088200         MOVE MBCA-OPERATOR-ID   TO MMEF-LAST-MAINT-OPER
088300         MOVE MMEF-LAST-MAINT-OPER
088400                                 TO MML1-VL03-A-DATA-X
088500         MOVE 'FC08'             TO MBCA-PROGRAM-LOCATION
088600         PERFORM 9100-WRITE-LOG-RECORD
088700                                 THRU 9199-WLR-EXIT
088800         MOVE 0199               TO MML1-FIELD-CODE
088900         MOVE MML1WS-VL-07       TO MML1-VARIABLE-LENGTH
089000         MOVE MMEF-LAST-MAINT-DATE
089100                                 TO MML1-VL07-B-DATA-9
089200         MOVE MBCA-START-DATE    TO MMEF-LAST-MAINT-DATE
089300         MOVE MMEF-LAST-MAINT-DATE
089400                                 TO MML1-VL07-A-DATA-9
089500         MOVE 'FC09'             TO MBCA-PROGRAM-LOCATION
089600         PERFORM 9100-WRITE-LOG-RECORD
089700                                 THRU 9199-WLR-EXIT.
089800*
089900****************************************************************
090000*    UPDATE THE MERCHANT EXPENSE RECORD                        *
090100****************************************************************
090200*
090300     IF  WS-UPDATE-SW-YES
090400         MOVE 'FC10'             TO MBCA-PROGRAM-LOCATION
090500         SET MBIORO-REWRITE      TO TRUE
090600         PERFORM MMEFAO-ACCESS   THRU MMEFAO-ACCESS-EXIT
090700     ELSE
090800         MOVE 'FC11'             TO MBCA-PROGRAM-LOCATION
090900         SET MBIORO-UNLOCK       TO TRUE
091000         PERFORM MMEFAO-ACCESS   THRU MMEFAO-ACCESS-EXIT.
091100/
091200 2600-SETUP-COMMAREA.
091300*
091400****************************************************************
091500*    SET UP COMMAREA FIELDS AND TRANSFER TO THE NEXT PROGRAM   *
091600****************************************************************
091700*
091800     MOVE MBCA-EIBAID            TO SS08WS-EIBAID.
091900*
092000     IF (SS08WS-VALID-PF5
092100     OR  SS08WS-EIBAID-VALID-PF5)
092200     AND MBCA-MBME-NEXT-PROD-YES
092300         SET X-MMOC-PROD         TO MBCA-MBME-PREV-PROD
092400     ELSE
092500         SET X-MMOC-PROD         TO MBCA-MBME-PL-INDEX.
092600*
092700     SET MBCA-MBME-NEXT-PROD-NO  TO TRUE.
092800*
092900     IF  ME06-NEXT-PROD-L        IS GREATER THAN 0
093000         MOVE 56                 TO MBCA-SCREEN-NBR
093100         MOVE ME06-NEXT-PROD     TO MBCA-MBME-PL-INDEX
093200         SET MBCA-MBME-NEXT-PROD-YES
093300                                 TO TRUE
093400         GO TO 2690-PF-KEY-BYPASS.
093500*
093600     IF  SS08WS-VALID-PF3
093700     OR  SS08WS-EIBAID-VALID-PF3
093800         MOVE 56                 TO MBCA-SCREEN-NBR
093900         MOVE 3                  TO MBCA-MBME-PL-INDEX
094000         GO TO 2690-PF-KEY-BYPASS.
094100*
094200     IF  SS08WS-VALID-PF4
094300     OR  SS08WS-EIBAID-VALID-PF4
094400         MOVE 56                 TO MBCA-SCREEN-NBR
094500         MOVE MBCA-MBME-MAX-INDEX
094600                                 TO MBCA-MBME-PL-INDEX
094700         GO TO 2690-PF-KEY-BYPASS.
094800*
094900     IF  SS08WS-VALID-PF5
095000     OR  SS08WS-EIBAID-VALID-PF5
095100         SET X-MMOC-PROD         UP BY 1
095200         PERFORM
095300             VARYING X-MMOC-PROD FROM X-MMOC-PROD BY 1
095400             UNTIL MMOC-PRODUCT-ACTIVE (X-MMOC-PROD)
095500             OR X-MMOC-PROD IS GREATER THAN MBCA-MBME-MAX-INDEX
095600             CONTINUE
095700         END-PERFORM
095800         IF  MMOC-PRODUCT-ACTIVE (X-MMOC-PROD)
095900             MOVE 56             TO MBCA-SCREEN-NBR
096000             SET MBCA-MBME-PL-INDEX
096100                                 TO X-MMOC-PROD
096200             GO TO 2690-PF-KEY-BYPASS
096300         ELSE
096400             MOVE 56             TO MBCA-SCREEN-NBR
096500             GO TO 2690-PF-KEY-BYPASS.
096600*
096700     IF  SS08WS-VALID-PF6
096800     OR  SS08WS-EIBAID-VALID-PF6
096900         SET X-MMOC-PROD         DOWN BY 1
097000         PERFORM
097100             VARYING X-MMOC-PROD FROM X-MMOC-PROD BY -1
097200             UNTIL MMOC-PRODUCT-ACTIVE (X-MMOC-PROD)
097300             OR X-MMOC-PROD IS LESS THAN WS-MIN
097400             CONTINUE
097500         END-PERFORM
097600         EVALUATE TRUE
097700           WHEN MMOC-PRODUCT-ACTIVE (X-MMOC-PROD)
097800             MOVE 56         TO MBCA-SCREEN-NBR
097900             SET MBCA-MBME-PL-INDEX
098000                                 TO X-MMOC-PROD
098100             GO TO 2690-PF-KEY-BYPASS
098200           WHEN OTHER
098300             MOVE 56             TO MBCA-SCREEN-NBR
098400             GO TO 2690-PF-KEY-BYPASS
098500         END-EVALUATE.
098600*
098700     IF  SS08WS-VALID-PF-KEY
098800     OR  SS08WS-EIBAID-VALID-PF-KEY
098900         SET MBCA-INITIAL-SCREEN-NBR
099000                                 TO TRUE.
099100*
099200     IF  TTN0162L IS GREATER THAN ZERO
099300     AND TTN0162I IS NUMERIC
099400         IF  TTN0162I IS NOT GREATER THAN MBCA-MAX-SCREEN-NBR
099500             MOVE TTN0162I       TO MBCA-SCREEN-NBR
099600             MOVE TTN0162I       TO MBCA-SAVE-SCREEN-NBR
099700             MOVE 3              TO MBCA-MBME-PL-INDEX
099800             ADD 50              TO MBCA-SCREEN-NBR
099900             GO TO 2690-PF-KEY-BYPASS.
100000*
100100     IF  MBCA-EIBAID-ENTER
100200     AND NOT MMEF-REC-ACTIVE
100210     AND  MBCA-MBME-MAX-INDEX > 3                                 FX800036
100300         MOVE 56                 TO MBCA-SCREEN-NBR
100400         SET MBCA-MBME-PRODS-YES TO TRUE
100500     ELSE
100600         SET MBCA-INITIAL-SCREEN-NBR
100700                                 TO TRUE
100800         MOVE 3                  TO MBCA-MBME-PL-INDEX.
100900*
101000 2690-PF-KEY-BYPASS.
101100*
101200     MOVE 'PC05'                 TO MBCA-PROGRAM-LOCATION.
101300     PERFORM MB70PD-XCTL-TO-MBOXCTL
101400                                 THRU MB70PD-XTM-EXIT.
101500/
101600 8000-PERFORMED-ROUTINES-SECT SECTION.
101700*
101800*
101900 9100-WRITE-LOG-RECORD.
102000*
102100     IF  MBCA-PTI-FUNCTION-IS-ADD
102200         GO TO 9199-WLR-EXIT.
102300*
102400     MOVE 'EF'                   TO MML1-FILE-CODE.
102500     MOVE MBCA-MERCHANT-ORG      TO MML1-MMEF-ORG.
102600     MOVE MBCA-TABLE             TO MML1-MMEF-TABLE-NBR.
102700     MOVE MBCA-SIGNON-NAME       TO MML1-SIGNON-NAME.
102800     MOVE MBCA-TERMINAL-ID       TO MML1-TERMINAL-ID.
102900     MOVE ZEROS                  TO MML1-SOURCE-CODE.
103000*
103100     SET MBIORO-WRITE            TO TRUE.
103200     PERFORM MML1AO-ACCESS       THRU MML1AO-ACCESS-EXIT.
103300     MOVE SPACES                 TO MML1-VARIABLE-AREA.
103400*
103500 9199-WLR-EXIT.
103600     EXIT.
103700*
103800 9500-BUILD-SCREEN.
103900*
104000*
104100     MOVE MMEF-PROD-AUTH-APPR-FEE (X-MMEF-PROD-FEES)
104200                                 TO ME06-AUTH-APPR.
104300*
104400     MOVE MMEF-PROD-AUTH-DECL-FEE (X-MMEF-PROD-FEES)
104500                                 TO ME06-AUTH-DECL.
104600*
104700     PERFORM
104800         VARYING X-MMEF-PUF FROM 1 BY 1
104900         UNTIL X-MMEF-PUF IS GREATER THAN 3
105000         SET X-ME06-PUF          TO X-MMEF-PUF
105100         MOVE MMEF-PUF-IND (X-MMEF-PROD-FEES X-MMEF-PUF)
105200                                 TO ME06-PUF-IND (X-ME06-PUF)
105300         MOVE MMEF-PUF-AMT (X-MMEF-PROD-FEES X-MMEF-PUF)
105400                                 TO ME06-PUF-AMT (X-ME06-PUF)
105500     END-PERFORM.
105600*
105700     PERFORM
105800         VARYING X-ME06-PL-QL FROM 1 BY 1
105900         UNTIL X-ME06-PL-QL IS GREATER THAN 9
106000         SET X-MB80WS-PL-QL      TO X-ME06-PL-QL
106100         SET X-MMEF-PL-QL        TO X-ME06-PL-QL
106200         SET WS-NBR-INDEX        TO X-MMEF-PL-QL
106300         MOVE WS-NBR-INDEX       TO ME06-PROD-NUMBER
106400                                    (X-ME06-PL-QL)
106500         MOVE '.'                TO ME06-PROD-PERIOD
106600                                    (X-ME06-PL-QL)
106700         MOVE DFHBMASK           TO ME06-PROD-NBR-A
106800                                    (X-ME06-PL-QL)
106900         MOVE MB80WS-PL-INTCHG-QL-DESC
107000                                 (X-MB80WS-PL-IFT X-MB80WS-PL-QL)
107100                                 TO ME06-INTCHG-DESC
107200                                    (X-ME06-PL-QL)
107300         MOVE MMEF-PL-INTCHG-RATE (X-MMEF-PL-IFT X-MMEF-PL-QL)
107400                                 TO ME06-INTCHG-RATE
107500                                    (X-ME06-PL-QL)
107600         MOVE MMEF-PL-INTCHG-PER-ITEM (X-MMEF-PL-IFT X-MMEF-PL-QL)
107700                                 TO ME06-INTCHG-PER-ITEM
107800                                    (X-ME06-PL-QL)
107900         MOVE DFHBMASK           TO ME06-INTCHG-DESC-A
108000                                    (X-ME06-PL-QL)
108100     END-PERFORM.
108200*
108300*
108400 9599-BS-EXIT.
108500     EXIT.
108600*
108700 9600-SET-FOR-NOT-FOUND.
108800*
108900     MOVE DFHBMASB               TO ME06-CARD-PROD-DESC-A
109000                                    ME06-CARD-PROD-A.
109100     MOVE DFHBMASB               TO ME06-AUTH-APPR-A
109200                                    ME06-AUTH-DECL-A.
109300     PERFORM
109400         VARYING X-ME06-PUF FROM 1 BY 1
109500         UNTIL X-ME06-PUF IS GREATER THAN 3
109600         MOVE DFHBMASB           TO ME06-PUF-IND-A
109700                                (X-ME06-PUF)
109800                                ME06-PUF-AMT-A
109900                                (X-ME06-PUF)
110000     END-PERFORM.
110100     PERFORM
110200         VARYING X-ME06-PL-QL FROM 1 BY 1
110300         UNTIL X-ME06-PL-QL IS GREATER THAN 9
110400         MOVE DFHBMASB           TO ME06-INTCHG-RATE-A
110500                                (X-ME06-PL-QL)
110600                                ME06-INTCHG-PER-ITEM-A
110700                                (X-ME06-PL-QL)
110800     END-PERFORM.
110900     MOVE DFHBMDAS               TO ME06-AUTH-APPR-LP-A
111000                                    ME06-AUTH-APPR-RP-A
111100                                    ME06-AUTH-APPR-LP-A
111200                                    ME06-AUTH-APPR-RP-A.
111300     PERFORM
111400         VARYING X-ME06-PUF FROM 1 BY 1
111500         UNTIL X-ME06-PUF IS GREATER THAN 3
111600         MOVE DFHBMDAS           TO ME06-PUF-IND-LP-A
111700                                    (X-ME06-PUF)
111800                                    ME06-PUF-IND-RP-A
111900                                    (X-ME06-PUF)
112000                                    ME06-PUF-AMT-LP-A
112100                                    (X-ME06-PUF)
112200                                    ME06-PUF-AMT-RP-A
112300                                    (X-ME06-PUF)
112400     END-PERFORM.
112500     PERFORM
112600         VARYING X-ME06-PL-QL FROM 1 BY 1
112700         UNTIL X-ME06-PL-QL IS GREATER THAN 9
112800         MOVE DFHBMDAS           TO ME06-INTCHG-RATE-LP-A
112900                                    (X-ME06-PL-QL)
113000                                    ME06-INTCHG-RATE-RP-A
113100                                    (X-ME06-PL-QL)
113200                                    ME06-INTCHG-PER-ITEM-LP-A
113300                                    (X-ME06-PL-QL)
113400                                    ME06-INTCHG-PER-ITEM-RP-A
113500                                    (X-ME06-PL-QL)
113600     END-PERFORM.
113700*
113800 9699-SFNF-EXIT.
113900     EXIT.
114000*
114100*
114200/         JULIAN TO GREGORIAN DATE ROUTINE
114300     COPY SS08PD.
114400/         DATE AND TIME EDIT ROITINES
114500     COPY SS26PD.
114600     COPY SS27PD.
114700/         LINE 24 PF KEYS ROUTINE
114800     COPY SS15PD.
114900/         ORGANIZATION FILE ACCESS ROUTINES
115000     COPY MMOCAO.
115100/         MERCHANT EXPENSE FILE ACCESS ROUTINES
115200     COPY MMEFAO.
115300/         LOG/JOURNAL ACCESS ROUTINES
115400     COPY MML1AO.
115500/         ON-LINE MAP ROUTINES
115600     COPY MB60PD REPLACING 'MBMAPXX' BY 'MBME06 '
115700                           MBMAPXXI BY MBME06I
115800                           MBMAPXXO BY MBME06O.
115900/         ON-LINE PROCEDURES
116000     COPY MB70PD.
116100/         MESSAGE FORMAT ROUTINE
116200     COPY MB06PD.
116300/
116400     COPY SMFTPXO.
