000100 IDENTIFICATION DIVISION.
000200 PROGRAM-ID. MBOMF00.
000201*       RELEASE DATE=08/24/01.        REVISION LEVEL=08.06      *
000202*****************************************************************
000203*WARNING.  THIS COMPUTER PROGRAM IS PROTECTED BY COPYRIGHT LAW  *
000204*AND INTERNATIONAL TREATIES.  UNAUTHORIZED REPRODUCTION OR      *
000205*DISTRIBUTION OF THIS PROGRAM, OR ANY PORTION OF IT, MAY RESULT *
000206*IN SEVERE CIVIL AND CRIMINAL PENATLIES, AND WILL BE PROSECUTED *
000207*TO THE MAXIMUM EXTENT POSSIBLE UNDER THE LAW.                  *
000208*COPYRIGHT 1999 PAYSYS INTERNATIONAL, INC.  ALL RIGHTS RESERVED.*
000209*****************************************************************
000300*****************************************************************
000400*                                                               *
000500*               M E R C H A N T   S Y S T E M                   *
000600*                                                               *
000700*      MBOMF00 - ON-LINE FIELD SECURITY ADD/MAINT/INQ           *
000800*                LOCATE SCREEN 00                               *
000900*                                                               *
001000*              1. TRANSIDS                                      *
001100*                 A. MBAF                                       *
001200*                 B. MBMF                                       *
001300*                 C. MBQF                                       *
001400*              2. MAPS USED -                                   *
001500*                 A. MBMF00 (LOCATE MAP)                        *
001600*              3. FILES USED -                                  *
001700*                 A. MMOC (ORG CONTROL FILE)                    *
001800*                 B. MMFS (FIELD SECURITY FILE)                 *
001900*                                                               *
002000*****************************************************************
002100*
002200 ENVIRONMENT DIVISION.
002300*
002400 DATA DIVISION.
002500*
002600 WORKING-STORAGE SECTION.
002700*
002800 01  FILLER                  PIC  X(12)      VALUE
002900     '** WS-BEG **'.
003000*
003100 01  FILLER                  PIC  X(14)      VALUE
003200     'MISCELLANEOUS:'.
003300*
003400 01  WS-MISCELLANEOUS.
003500     03  WS-ORG-LOW          PIC S9(03)      COMP-3
003600                                             VALUE +001.
003700     03  WS-ORG-HIGH         PIC S9(03)      COMP-3
003800                                             VALUE +998.
003900     03  WS-PROFILE          PIC  X(01)      VALUE SPACE.
004000         88  WS-VALID-PROFILE                VALUE SPACE
004100                                                   'A' THRU 'Z'
004200                                                   '0' THRU '9'.
004300     03  WS-COPY-SW          PIC  X(01)      VALUE 'N'.
004400         88  WS-COPY-SW-NO                   VALUE 'N'.
004500         88  WS-COPY-SW-YES                  VALUE 'Y'.
004600/
004700 01  FILLER                  PIC  X(29)      VALUE
004800     'I/O REQUEST BLOCK WORK AREAS:'.
004900*
005000     COPY MBIOWS.
005100/
005200 01  FILLER                  PIC  X(18)      VALUE
005300     'I/O REQUEST BLOCK:'.
005400*
005500     COPY MBIORO.
005600/
005700 01  FILLER                  PIC  X(21)      VALUE
005800     'ERROR MESSAGES TABLE:'.
005900*
006000     COPY MBEMWS.
006100/
006200 01  FILLER                  PIC  X(34)      VALUE
006300     'FIELD SECURITY INITIALIZER RECORD:'.
006400*
006500     COPY MMFSIR.
006600/
006700 01  FILLER                  PIC  X(20)      VALUE
006800     'CCS DATE WORK AREAS:'.
006900*
007000     COPY SS01WS.
007100/
007200 01  FILLER                  PIC  X(15)      VALUE
007300     'CCS WORK AREAS:'.
007400*
007500     COPY SS08WS.
007600/
007700     COPY SS00WS.
007800/
007900     COPY SMFTWS.
008000/
008100     COPY SMPTRL REPLACING ==:SMPT:== BY ==SMPT==.
008200/
008300     COPY MB61LK.
008400/
008500 01  FILLER                  PIC  X(12)      VALUE
008600     '** WS-END **'.
008700/
008800 LINKAGE SECTION.
008900*
009000 01  DFHCOMMAREA.
009100*
009200     COPY MB60WS.
009300/
009400***********************************
009500*    FIELD SECURITY LOCATE MAP    *
009600***********************************
009700*
009800     COPY MBMF00.
009900/
010000************************************************
010100*    FIELD SECURITY LOCATE MAP REDEFINITION    *
010200************************************************
010300*
010400     COPY MBMF00R.
010500/
010600***************************
010700*    ORG RECORD LAYOUT    *
010800***************************
010900*
011000     COPY MMOCRL.
011100/
011200**************************************
011300*    FIELD SECURITY RECORD LAYOUT    *
011400**************************************
011500*
011600     COPY MMFSRL.
011700/
011800 PROCEDURE DIVISION.
011900*
012000 A000-HOUSEKEEPING SECTION.
012100*
012200 A020-INIT.
012300*
012400     MOVE 'PC01'                 TO MBCA-PROGRAM-LOCATION.
012500     PERFORM MB70PD-ON-LINE-HOUSEKEEPING
012600                                 THRU MB70PD-OLH-EXIT.
012700*
012800     IF  MBCA-RECEIVE-SCREEN
012900         GO TO C000-RECEIVE-SCREEN.
013000/
013100 B000-SEND-SCREEN SECTION.
013200*
013300*********************************************
013400*    GET CICS STORAGE NEEDED FOR THE MAP    *
013500*********************************************
013600*
013700     MOVE 'SC01'                 TO MBCA-PROGRAM-LOCATION.
013800     PERFORM MB60PD-GETMAIN-FOR-MAP
013900                                 THRU MB60PD-GFM-EXIT.
014000*
014100     MOVE 1                      TO MBCA-MBMF-INDEX.
014200*
014300*****************************************************************
014400*    CHECK KEY CODES                                            *
014500* 1. IF ADD FUNCTION, BYPASS CHECK OF KEY CODES.                *
014600* 2. IF INITIAL KEY CODE, BYPASS CHECK OF KEY CODES.            *
014700* 3. IF MMFS KEY CODE, IT MUST HAVE AN ORGANIZATION NUMBER      *
014800*    GREATER THAN ZERO AND A VALID PROFILE.  IF                 *
014900*    DIRECT, GO TO THE RECEIVE EDITING ROUTINE SINCE WE HAVE    *
015000*    PLUGGED THE ORGANIZATION AND PROFILE IN THE MAP.  IF AN    *
015100*    ERROR OCCURS IN THE RECEIVE SCREEN ROUTINE, IT WILL        *
015200*    HANDLE BUILDING THE MAP AND IT WILL SEND ITS OWN SCREEN.   *
015300*    THIS IS WHY LOCATE PROGRAMS ALWAYS SEND WITH ERASE         *
015400*    NO MATTER WHICH ROUTINE YOU ARE IN.  IF NOT DIRECT, PLUG   *
015500*    THE ORGANIZATION AND PROFILE INTO THE MAP AND BYPASS       *
015600*    ANY OTHER CHECKING OF THE KEY CODE.                        *
015700* 4. IF 2 AND 3 ARE FALSE, SEE IF THE MBCA-MERCHANT-ORG IS      *
015800*    GREATER THAN ZERO.  IF IT IS, PLUG IT INTO THE MAP.  IF    *
015900*    THE MBCA-PROFILE IS GREATER THAN LOW-VALUE, PLUG IT INTO   *
016000*    THE MAP.                                                   *
016100*****************************************************************
016200*
016300     IF  MBCA-INITIAL-KEY-CODE
016400     OR  MBCA-PTI-FUNCTION-IS-ADD
016500         GO TO B020-BUILD-SCREEN.
016600*
016700     IF  MBCA-MMFS-KEY-CODE
016800         IF  MBCA-MERCHANT-ORG IS GREATER THAN ZERO
016900         AND MBCA-PROFILE       IS GREATER THAN LOW-VALUE
017000             MOVE MBCA-MERCHANT-ORG
017100                                 TO MF00-ORG
017200             MOVE MBCA-PROFILE   TO MF00-PROFILE
017300             MOVE DFHBMUNF       TO MF00-ORG-A
017400             MOVE DFHBMFSE       TO MF00-PROFILE-A
017500             IF  MBCA-DIRECT-TRANSFER-CODE
017600             AND MBCA-INITIAL-SCREEN-NBR
017700                 MOVE 00         TO MBCA-SCREEN-NBR
017800                 GO TO C082-READ-ORG
017900             ELSE
018000                 GO TO B020-BUILD-SCREEN.
018100*
018200     IF  MBCA-VALID-KEY-CODES
018300         IF  MBCA-MERCHANT-ORG IS GREATER THAN ZERO
018400             MOVE MBCA-MERCHANT-ORG
018500                                 TO MF00-ORG
018600             MOVE DFHBMUNF       TO MF00-ORG-A
018700             IF  MBCA-PROFILE IS GREATER THAN LOW-VALUE
018800                 MOVE MBCA-PROFILE
018900                                 TO MF00-PROFILE
019000                 MOVE DFHBMFSE   TO MF00-PROFILE-A.
019100*
019200 B020-BUILD-SCREEN.
019300*
019400*******************************************
019500*    INITIALIZE THE STANDARD MAP LINES    *
019600*******************************************
019700*
019800     MOVE SS08WS-CURSOR          TO MF00-ORG-L.
019900     MOVE 00                     TO MBCA-SCREEN-NBR.
020000     PERFORM MB60PD-INIT-STD-MAP-LINES
020100                                 THRU MB60PD-ISML-EXIT.
020200*
020300     IF  MBCA-PTI-FUNCTION-IS-MAINT
020400     OR  MBCA-PTI-FUNCTION-IS-INQUIRY
020500         MOVE DFHBMDAS           TO MF00-COPY-ORG-LIT-A
020600                                    MF00-COPY-ORG-LP-A
020700                                    MF00-COPY-ORG-RP-A
020800                                    MF00-COPY-PROFILE-LIT-A
020900                                    MF00-COPY-PROFILE-LP-A
021000                                    MF00-COPY-PROFILE-RP-A
021100         MOVE DFHBMASK           TO MF00-COPY-ORG-A
021200                                    MF00-COPY-PROFILE-A.
021300*
021400     IF  MBCA-PTI-FUNCTION-IS-ADD
021500         MOVE ZERO               TO MF00-PROFILE-L
021600         MOVE DFHBMUNP           TO MF00-PROFILE-A
021700         MOVE LOW-VALUE          TO MF00-PROFILE.
021800*
021900**********************
022000*    SEND THE MAP    *
022100**********************
022200*
022300     MOVE 'BM01'                 TO MBCA-PROGRAM-LOCATION.
022400     PERFORM MB60PD-SEND-MAP-WITH-ERASE
022500                                 THRU MB60PD-SMWE-EXIT.
022600*
022700************************
022800*    RETURN TO CICS    *
022900************************
023000*
023100     MOVE 'PC02'                 TO MBCA-PROGRAM-LOCATION.
023200     PERFORM MB70PD-RETURN-TRANS-ID
023300                                 THRU MB70PD-RTI-EXIT.
023400/
023500 C000-RECEIVE-SCREEN SECTION.
023600*
023700*************************************************
023800*    THIS SECTION RECEIVES THE LOCATE SCREEN    *
023900*************************************************
024000*
024100     MOVE 'BM02'                 TO MBCA-PROGRAM-LOCATION.
024200     PERFORM MB60PD-RECEIVE-MAP  THRU MB60PD-RM-EXIT.
024300*
024400**************************************************************
024500*    CHECK FOR ANOTHER TRANSACTION ID ENTERED BY THE USER    *
024600**************************************************************
024700*
024800     MOVE 'PC03'                 TO MBCA-PROGRAM-LOCATION.
024900     PERFORM MB60PD-NEW-TRANS-ROUTINE
025000                                 THRU MB60PD-NTR-EXIT.
025100*
025200 C020-EDIT-SCREEN.
025300*
025400     MOVE 'N'                    TO SS08WS-ERROR.
025500     MOVE MBCA-EIBAID            TO SS08WS-EIBAID.
025600*
025700     IF  (MF00-ORG-L IS LESS THAN 1
025800     AND  MF00-PROFILE-L IS LESS THAN 1
025900     AND  MF00-COPY-ORG-L IS LESS THAN 1
026000     AND  MF00-COPY-PROFILE-L IS LESS THAN 1)
026100     AND (SS08WS-VALID-PF-KEY
026200     OR   SS08WS-EIBAID-VALID-PF-KEY)
026300         MOVE 99                 TO MBCA-SCREEN-NBR
026400         GO TO F090-TRANSFER-XCTL.
026500*
026600******************************************************
026700*    RESET THE FIELD ARRIBUTES TO THEIR NORMAL       *
026800*    PRIOR STATE PRIOR TO ANY EDITING BEING DONE.    *
026900******************************************************
027000*
027100     MOVE DFHBMUNN               TO MF00-ORG-A.
027200     MOVE DFHBMUNP               TO MF00-PROFILE-A.
027300     MOVE DFHBMASK               TO MF00-ORG-LP-A
027400                                    MF00-ORG-RP-A
027500                                    MF00-PROFILE-LP-A
027600                                    MF00-PROFILE-RP-A.
027700*
027800     IF  MBCA-PTI-FUNCTION-IS-ADD
027900         MOVE DFHBMUNN           TO MF00-COPY-ORG-A
028000         MOVE DFHBMUNP           TO MF00-COPY-PROFILE-A
028100         MOVE DFHBMASK           TO MF00-COPY-ORG-LP-A
028200                                    MF00-COPY-ORG-RP-A
028300                                    MF00-COPY-PROFILE-LP-A
028400                                    MF00-COPY-PROFILE-RP-A
028500     ELSE
028600         GO TO C080-EDIT-ORG.
028700*
028800************************************************
028900*    BYPASS THE COPY EDITS IF NEITHER THE      *
029000*    COPY ORG OR COPY PROFILE WERE ENTERED.    *
029100************************************************
029200*
029300     IF  MF00-COPY-ORG-L IS EQUAL TO ZERO
029400     AND MF00-COPY-PROFILE-L IS EQUAL TO ZERO
029500         GO TO C080-EDIT-ORG.
029600*
029700 C040-EDIT-COPY-ORG.
029800*
029900     IF  MF00-COPY-ORG-L IS EQUAL TO ZERO
030000     OR  MF00-COPY-ORG IS NOT NUMERIC
030100     OR  MF00-COPY-ORG IS LESS THAN MBCA-ORG-LOW
030200     OR  MF00-COPY-ORG IS GREATER THAN MBCA-ORG-HIGH
030300     OR  MF00-COPY-ORG IS LESS THAN WS-ORG-LOW
030400     OR  MF00-COPY-ORG IS GREATER THAN WS-ORG-HIGH
030500         MOVE MBEMWS-INVALID-ORG TO MF00-ERR-MESSAGE
030600         GO TO C058-COPY-ORG-ERROR.
030700*
030800************************************************
030900*    READ THE COPY ORGANIZATION RECORD.  IT    *
031000*    MUST BE ON FILE AND AN ACTIVE RECORD.     *
031100************************************************
031200*
031300     MOVE MF00-COPY-ORG          TO MBIOWS-MMOC-ORG.
031400     MOVE SS08WS-CICS-FC-NOTFND  TO MBIORO-TEMP-STATUS-1.
031500     MOVE 'FC01'                 TO MBCA-PROGRAM-LOCATION.
031600     SET MBIORO-READ-RANDOM      TO TRUE.
031700     PERFORM MMOCAO-ACCESS       THRU MMOCAO-ACCESS-EXIT.
031800*
031900     IF  SS08WS-RC-FC-NOTFND
032000         MOVE MBEMWS-NOT-ON-FILE TO MF00-ERR-MESSAGE
032100     ELSE
032200         IF  MMOC-ADD-PENDING
032300             MOVE MBEMWS-ADD-PENDING
032400                                 TO MF00-ERR-MESSAGE
032500         ELSE
032600             IF  MMOC-REC-PURGED
032700                 MOVE MBEMWS-REC-PURGED
032800                                 TO MF00-ERR-MESSAGE
032900             ELSE
033000                 MOVE DFHBMUNF   TO MF00-COPY-ORG-A
033100                 GO TO C060-EDIT-COPY-PROFILE.
033200*
033300 C058-COPY-ORG-ERROR.
033400*
033500     MOVE 'Y'                    TO SS08WS-ERROR.
033600     MOVE DFHBMASB               TO MF00-COPY-ORG-LP-A
033700                                    MF00-COPY-ORG-RP-A.
033800     MOVE SS08WS-CURSOR          TO MF00-COPY-ORG-L.
033900     MOVE DFHBMNBF               TO MF00-COPY-ORG-A.
034000     MOVE DFHBMUNF               TO MF00-ORG-A.
034100     MOVE DFHBMFSE               TO MF00-COPY-PROFILE-A
034200                                    MF00-PROFILE-A.
034300     GO TO D000-RETURN-ERRORS.
034400*
034500 C060-EDIT-COPY-PROFILE.
034600*
034700***********************************************************
034800*    THE LENGTH FIELD COULD BE CHECKED HERE TO            *
034900*    SEE IF ANYTHING WAS KEYED.  BUT, SINCE THIS          *
035000*    IS AN ALPHANUMERIC FIELD, AND SOMETHING MUST         *
035100*    BE KEYED IN ORDER TO PASS THE EDIT, THE CONTENTS     *
035200*    OF THE FIELD IS MOVED TO A WORK FIELD.  THERE,       *
035300*    THE VALIDITY OF THE FIELD MAY BE CHECKED.  IF        *
035400*    NOTHING WERE KEYED, LOW-VALUES WOULD BE RECEIVED,    *
035500*    AND WOULD FAIL THE VALIDITY CHECK.                   *
035600***********************************************************
035700*
035800     MOVE MF00-COPY-PROFILE      TO WS-PROFILE.
035900*
036000     IF  NOT WS-VALID-PROFILE
036100         MOVE MBEMWS-INVALID-PROFILE
036200                                 TO MF00-ERR-MESSAGE
036300         GO TO C078-COPY-PROFILE-ERROR.
036400*
036500*****************************************************************
036600*    READ THE FIELD SECURITY FILE TO ENSURE THAT THE PROFILE    *
036700*    TO BE COPIED IS ON FILE AND AN ACTIVE RECORD.              *
036800*****************************************************************
036900*
037000     MOVE MF00-COPY-ORG          TO MBIOWS-MMFS-ORG.
037100     MOVE MF00-COPY-PROFILE      TO MBIOWS-MMFS-FS-CODE.
037200     MOVE SS08WS-CICS-FC-NOTFND  TO MBIORO-TEMP-STATUS-1.
037300     MOVE 'FC02'                 TO MBCA-PROGRAM-LOCATION.
037400     SET MBIORO-READ-RANDOM      TO TRUE.
037500     PERFORM MMFSAO-ACCESS       THRU MMFSAO-ACCESS-EXIT.
037600*
037700     IF  SS08WS-RC-FC-NOTFND
037800         MOVE MBEMWS-NOT-ON-FILE TO MF00-ERR-MESSAGE
037900     ELSE
038000         IF  MMFS-ADD-PENDING
038100             MOVE MBEMWS-ADD-PENDING
038200                                 TO MF00-ERR-MESSAGE
038300         ELSE
038400             IF  MMFS-REC-PURGED
038500                 MOVE MBEMWS-REC-PURGED
038600                                 TO MF00-ERR-MESSAGE
038700             ELSE
038800                 MOVE 'Y'        TO WS-COPY-SW
038900                 MOVE DFHBMFSE   TO MF00-COPY-PROFILE-A
039000                 GO TO C080-EDIT-ORG.
039100*
039200 C078-COPY-PROFILE-ERROR.
039300*
039400     MOVE 'Y'                    TO SS08WS-ERROR.
039500     MOVE DFHBMASB               TO MF00-COPY-PROFILE-LP-A
039600                                    MF00-COPY-PROFILE-RP-A.
039700     MOVE SS08WS-CURSOR          TO MF00-COPY-PROFILE-L.
039800     MOVE DFHBMUBF               TO MF00-COPY-PROFILE-A.
039900     MOVE DFHBMUNF               TO MF00-ORG-A.
040000     MOVE DFHBMFSE               TO MF00-PROFILE-A.
040100     GO TO D000-RETURN-ERRORS.
040200*
040300 C080-EDIT-ORG.
040400*
040500     IF  MF00-ORG-L IS EQUAL TO ZERO
040600     OR  MF00-ORG IS NOT NUMERIC
040700     OR  MF00-ORG IS LESS THAN MBCA-ORG-LOW
040800     OR  MF00-ORG IS GREATER THAN MBCA-ORG-HIGH
040900     OR  MF00-ORG IS LESS THAN WS-ORG-LOW
041000     OR  MF00-ORG IS GREATER THAN WS-ORG-HIGH
041100         MOVE MBEMWS-INVALID-ORG TO MF00-ERR-MESSAGE
041200         GO TO C098-ORG-ERROR.
041300*
041400 C082-READ-ORG.
041500*
041600************************************************
041700*    READ THE ORGANIZATION RECORD.  IT MUST    *
041800*    BE ON FILE AND AN ACTIVE RECORD.          *
041900************************************************
042000*
042100     MOVE MF00-ORG               TO MBIOWS-MMOC-ORG.
042200     MOVE 'FC03'                 TO MBCA-PROGRAM-LOCATION.
042300     MOVE SS08WS-CICS-FC-NOTFND  TO MBIORO-TEMP-STATUS-1.
042400     SET MBIORO-READ-RANDOM      TO TRUE.
042500     PERFORM MMOCAO-ACCESS       THRU MMOCAO-ACCESS-EXIT.
042600*
042700     IF  SS08WS-RC-FC-NOTFND
042800         MOVE MBEMWS-NOT-ON-FILE TO MF00-ERR-MESSAGE
042900     ELSE
043000         IF  MMOC-ADD-PENDING
043100             MOVE MBEMWS-ADD-PENDING
043200                                 TO MF00-ERR-MESSAGE
043300         ELSE
043400             IF  MMOC-REC-PURGED
043500                 MOVE MBEMWS-REC-PURGED
043600                                 TO MF00-ERR-MESSAGE
043700             ELSE
043800                 MOVE DFHBMUNF   TO MF00-ORG-A
043900                 MOVE MF00-ORG   TO MBCA-MERCHANT-ORG
044000                 GO TO C100-EDIT-PROFILE.
044100*
044200 C098-ORG-ERROR.
044300*
044400     MOVE 'Y'                    TO SS08WS-ERROR.
044500     MOVE DFHBMASB               TO MF00-ORG-LP-A
044600                                    MF00-ORG-RP-A.
044700     MOVE SS08WS-CURSOR          TO MF00-ORG-L.
044800     MOVE DFHBMNBF               TO MF00-ORG-A.
044900     MOVE DFHBMFSE               TO MF00-PROFILE-A.
045000     GO TO D000-RETURN-ERRORS.
045100*
045200 C100-EDIT-PROFILE.
045300*
045400***********************************************************
045500*    THE LENGTH FIELD COULD BE CHECKED HERE TO            *
045600*    SEE IF ANYTHING WAS KEYED.  BUT, SINCE THIS          *
045700*    IS AN ALPHANUMERIC FIELD, AND SOMETHING MUST         *
045800*    BE KEYED IN ORDER TO PASS THE EDIT, THE CONTENTS     *
045900*    OF THE FIELD IS MOVED TO A WORK FIELD.  THERE,       *
046000*    THE VALIDITY OF THE FIELD MAY BE CHECKED.  IF        *
046100*    NOTHING WERE KEYED, LOW-VALUES WOULD BE RECEIVED,    *
046200*    AND WOULD FAIL THE VALIDITY CHECK.                   *
046300***********************************************************
046400*
046500     MOVE MF00-PROFILE           TO WS-PROFILE.
046600*
046700     IF  NOT WS-VALID-PROFILE
046800         MOVE MBEMWS-INVALID-PROFILE
046900                                 TO MF00-ERR-MESSAGE
047000         GO TO C118-PROFILE-ERROR.
047100*
047200 C102-READ-PROFILE.
047300*
047400***************************************************************
047500*    READ THE PROFILE RECORD.  IT MUST BE ON FILE AND         *
047600*    AN ACTIVE RECORD IF IN MAINTENANCE OR INQUIRY.  IT MUST  *
047700*    NOT BE ON FILE (OR IN AN ADD PENDING STATE), IF IN ADD.  *
047800***************************************************************
047900*
048000     MOVE MF00-ORG               TO MBIOWS-MMFS-ORG.
048100     MOVE MF00-PROFILE           TO MBIOWS-MMFS-FS-CODE.
048200     MOVE SS08WS-CICS-FC-NOTFND  TO MBIORO-TEMP-STATUS-1.
048300     MOVE 'FC04'                 TO MBCA-PROGRAM-LOCATION.
048400     SET MBIORO-READ-RANDOM      TO TRUE.
048500     PERFORM MMFSAO-ACCESS       THRU MMFSAO-ACCESS-EXIT.
048600*
048700     IF  SS08WS-RC-FC-VALID-RTN-CODE
048800         MOVE MF00-PROFILE       TO MBCA-PROFILE.
048900*
049000     IF (MBCA-PTI-FUNCTION-IS-INQUIRY)
049100         IF  SS08WS-RC-FC-VALID-RTN-CODE
049200             IF  MMFS-ADD-PENDING
049300                 MOVE MBEMWS-ADD-PENDING
049400                                 TO MF00-ERR-MESSAGE
049500                 GO TO C118-PROFILE-ERROR
049600             ELSE
049700                 GO TO F000-SETUP-COMMAREA
049800         ELSE
049900             MOVE MBEMWS-NOT-ON-FILE
050000                                 TO MF00-ERR-MESSAGE
050100             GO TO C118-PROFILE-ERROR.
050200*
050300     IF  MBCA-PTI-FUNCTION-IS-ADD
050400     AND SS08WS-RC-FC-NOTFND
050500         GO TO E000-UPDATE-FILE.
050600*
050700     IF  MBCA-PTI-FUNCTION-IS-ADD
050800     AND MMFS-ADD-PENDING
050900         IF  WS-COPY-SW-NO
051000             MOVE MMFS-ONLINE-STATUS
051100                                 TO MBCA-SCREEN-NBR
051200             GO TO F000-SETUP-COMMAREA
051300         ELSE
051400             MOVE MBEMWS-ADD-PENDING
051500                                 TO MF00-ERR-MESSAGE
051600             GO TO C118-PROFILE-ERROR.
051700*
051800     IF  MBCA-PTI-FUNCTION-IS-ADD
051900         MOVE MBEMWS-ALREADY-ON-FILE
052000                                 TO MF00-ERR-MESSAGE
052100         GO TO C118-PROFILE-ERROR.
052200*
052300     IF  MBCA-PTI-FUNCTION-IS-MAINT
052400     AND SS08WS-RC-FC-NOTFND
052500         MOVE MBEMWS-NOT-ON-FILE TO MF00-ERR-MESSAGE
052600         GO TO C118-PROFILE-ERROR.
052700*
052800     IF  MBCA-PTI-FUNCTION-IS-MAINT
052900     AND MMFS-ADD-PENDING
053000         MOVE MBEMWS-ADD-PENDING TO MF00-ERR-MESSAGE
053100         GO TO C118-PROFILE-ERROR.
053200*
053300     IF  MBCA-PTI-FUNCTION-IS-MAINT
053400     AND MMFS-REC-PURGED
053500         MOVE MBEMWS-REC-PURGED  TO MF00-ERR-MESSAGE
053600         GO TO C118-PROFILE-ERROR.
053700*
053800***********************************************
053900*    OTHERWISE, WE PASSED THE PROFILE EDIT    *
054000***********************************************
054100*
054200     GO TO F000-SETUP-COMMAREA.
054300*
054400 C118-PROFILE-ERROR.
054500*
054600     MOVE 'Y'                    TO SS08WS-ERROR.
054700     MOVE DFHBMASB               TO MF00-PROFILE-LP-A
054800                                    MF00-PROFILE-RP-A.
054900     MOVE SS08WS-CURSOR          TO MF00-PROFILE-L.
055000     MOVE DFHBMUBF               TO MF00-PROFILE-A.
055100/
055200 D000-RETURN-ERRORS SECTION.
055300*
055400     IF  SS08WS-ERROR IS EQUAL TO 'N'
055500         GO TO E000-UPDATE-FILE
055600     ELSE
055700         IF  SS08WS-VALID-PF-KEY
055800         OR  SS08WS-EIBAID-VALID-PF-KEY
055900             MOVE 99             TO MBCA-SCREEN-NBR
056000             GO TO F090-TRANSFER-XCTL.
056100*
056200***************************************************************
056300*    INITIALIZE THE STANDARD MAP LINES.  IN AN ERROR          *
056400*    CONDITION, THIS ROUTINE IS PERFORMED PRIMARILY           *
056500*    TO UPDATE THE DATE AND TIME ON THE SCREEN.               *
056600***************************************************************
056700*
056800     PERFORM MB60PD-INIT-STD-MAP-LINES
056900                                 THRU MB60PD-ISML-EXIT.
057000*
057100     IF  MBCA-PTI-FUNCTION-IS-MAINT
057200     OR  MBCA-PTI-FUNCTION-IS-INQUIRY
057300         MOVE DFHBMDAS           TO MF00-COPY-ORG-LIT-A
057400                                    MF00-COPY-ORG-LP-A
057500                                    MF00-COPY-ORG-RP-A
057600                                    MF00-COPY-PROFILE-LIT-A
057700                                    MF00-COPY-PROFILE-LP-A
057800                                    MF00-COPY-PROFILE-RP-A
057900         MOVE DFHBMASK           TO MF00-COPY-ORG-A
058000                                    MF00-COPY-PROFILE-A.
058100*
058200**********************
058300*    SEND THE MAP    *
058400**********************
058500*
058600     MOVE 'BM03'                 TO MBCA-PROGRAM-LOCATION.
058700     PERFORM MB60PD-SEND-MAP-WITH-ERASE
058800                                 THRU MB60PD-SMWE-EXIT.
058900*
059000************************
059100*    RETURN TO CICS    *
059200************************
059300*
059400     MOVE 'PC04'                 TO MBCA-PROGRAM-LOCATION.
059500     PERFORM MB70PD-RETURN-TRANS-ID
059600                                 THRU MB70PD-RTI-EXIT.
059700/
059800 E000-UPDATE-FILE SECTION.
059900*
060000********************************************************
060100*    WRITE THE NEW SECURITY PROFILE RECORD FROM THE    *
060200*    INITIALIZER RECORD OR FROM THE PROFILE RECORD     *
060300*    THAT IS BEING COPIED.                             *
060400********************************************************
060500*
060600     IF  WS-COPY-SW-YES
060700         GO TO E040-COPY-ADD.
060800*
060900 E020-ADD-NEW-RECORD.
061000*
061100********************************************************
061200*    SET UP THE RECORD.  USE THE INITIALIZER RECORD    *
061300*    (MMFSIR) AS THE FIELD DEFAULTS.                   *
061400********************************************************
061500*
061600     MOVE MMFSIR-RECORD          TO MMFS-RECORD.
061700     MOVE MF00-ORG               TO MMFS-ORG.
061800     MOVE MF00-PROFILE           TO MMFS-FS-CODE.
061900     MOVE MBCA-START-DATE        TO MMFS-LAST-MAINT-DATE.
062000     MOVE MBCA-OPERATOR-ID       TO MMFS-LAST-MAINT-OPER.
062100     MOVE 1                      TO MMFS-MT-FIELD-ATTR (168).
062200     MOVE 6                      TO MMFS-MT-FIELD-ATTR (107)
062300                                    MMFS-MT-FIELD-ATTR (108)
062400                                    MMFS-MT-FIELD-ATTR (111)
062500                                    MMFS-MT-FIELD-ATTR (113)
062600                                    MMFS-MT-FIELD-ATTR (114)
062700                                    MMFS-MT-FIELD-ATTR (117)
062800                                    MMFS-MT-FIELD-ATTR (123)
062900                                    MMFS-MT-FIELD-ATTR (124)
063000                                    MMFS-MT-FIELD-ATTR (127)
063100                                    MMFS-MT-FIELD-ATTR (129)
063200                                    MMFS-MT-FIELD-ATTR (130)
063300                                    MMFS-MT-FIELD-ATTR (133)
063400                                    MMFS-MT-FIELD-ATTR (139)
063500                                    MMFS-MT-FIELD-ATTR (140)
063600                                    MMFS-MT-FIELD-ATTR (143)
063700                                    MMFS-MT-FIELD-ATTR (145)
063800                                    MMFS-MT-FIELD-ATTR (146)
063900                                    MMFS-MT-FIELD-ATTR (149)
064000                                    MMFS-MT-FIELD-ATTR (155)
064100                                    MMFS-MT-FIELD-ATTR (156)
064200                                    MMFS-MT-FIELD-ATTR (159)
064300                                    MMFS-MT-FIELD-ATTR (161)
064400                                    MMFS-MT-FIELD-ATTR (162)
064500                                    MMFS-MT-FIELD-ATTR (165).
064600*
064700     GO TO E060-WRITE-MMFS.
064800*
064900 E040-COPY-ADD.
065000*
065100*********************************************************
065200*    RE-READ THE FIELD SECURITY RECORD TO BE COPIED.    *
065300*********************************************************
065400*
065500     MOVE MF00-COPY-ORG          TO MBIOWS-MMFS-ORG.
065600     MOVE MF00-COPY-PROFILE      TO MBIOWS-MMFS-FS-CODE.
065700     MOVE 'FC05'                 TO MBCA-PROGRAM-LOCATION.
065800     SET MBIORO-READ-RANDOM      TO TRUE.
065900     PERFORM MMFSAO-ACCESS       THRU MMFSAO-ACCESS-EXIT.
066000*
066100***************************
066200*    SET UP THE RECORD    *
066300***************************
066400*
066500     MOVE MF00-ORG               TO MMFS-ORG.
066600     MOVE MF00-PROFILE           TO MMFS-FS-CODE.
066700     MOVE MMFSIR-REC-STATUS      TO MMFS-REC-STATUS.
066800     MOVE MMFSIR-ONLINE-STATUS   TO MMFS-ONLINE-STATUS.
066900     MOVE MBCA-START-DATE        TO MMFS-LAST-MAINT-DATE.
067000     MOVE MBCA-OPERATOR-ID       TO MMFS-LAST-MAINT-OPER.
067100*
067200*************************************************************
067300*    INITIALIZE THE FIELDS THAT ARE NOT PART OF THE COPY    *
067400*************************************************************
067500*
067600     MOVE MMFSIR-NAME            TO MMFS-NAME.
067700*
067800 E060-WRITE-MMFS.
067900*
068000     MOVE 'FC06'                 TO MBCA-PROGRAM-LOCATION.
068100     SET MBIORO-WRITE            TO TRUE.
068200     PERFORM MMFSAO-ACCESS       THRU MMFSAO-ACCESS-EXIT.
068300*
068400     MOVE MF00-PROFILE           TO MBCA-PROFILE.
068500/
068600 F000-SETUP-COMMAREA SECTION.
068700*
068800***************************************************************
068900*  SET UP COMMAREA FIELDS AND TRANSFER TO THE NEXT PROGRAM    *
069000***************************************************************
069100*
069200     MOVE MBCA-EIBAID            TO SS08WS-EIBAID.
069300*
069400     MOVE MBIOWS-MMFS-DIRECT-KEY-CODE
069500                                 TO MBCA-KEY-CODE.
069600*
069700     PERFORM MB60PD-EDIT-PAGE-NBR
069800                                 THRU MB60PD-EPN-EXIT.
069900*
070000     IF  SS08WS-VALID-PF-KEY
070100     OR  SS08WS-EIBAID-VALID-PF-KEY
070200         MOVE 99                 TO MBCA-SCREEN-NBR.
070300*
070400 F090-TRANSFER-XCTL.
070500*
070600     MOVE 'PC05'                 TO MBCA-PROGRAM-LOCATION.
070700     PERFORM MB70PD-XCTL-TO-MBOXCTL
070800                                 THRU MB70PD-XTM-EXIT.
070900/
071000 Z000-COPIED-ROUTINES SECTION.
071100*
071200**********************************
071300*    JUL TO GREG DATE ROUTINE    *
071400**********************************
071500*
071600     COPY SS08PD.
071700/
071800**********************************
071900*    DATE AND TIME EDIT ROUTINES *
072000**********************************
072100*
072200     COPY SS26PD.
072300     COPY SS27PD.
072400/
072500*********************************
072600*    LINE 24 PF KEYS ROUTINE    *
072700*********************************
072800*
072900     COPY SS15PD.
073000/
073100*******************************************
073200*    ORG FILE RECORD ACCESS ROUTINES      *
073300*******************************************
073400*
073500     COPY MMOCAO.
073600/
073700***********************************************
073800*    FIELD SECURITY RECORD ACCESS ROUTINES    *
073900***********************************************
074000*
074100     COPY MMFSAO.
074200/
074300*****************************
074400*    ONLINE MAP ROUTINES    *
074500*****************************
074600*
074700     COPY MB60PD REPLACING 'MBMAPXX' BY 'MBMF00 '
074800                           MBMAPXXI BY MBMF00I
074900                           MBMAPXXO BY MBMF00O.
075000/
075100***************************
075200*    ONLINE PROCEDURES    *
075300***************************
075400*
075500     COPY MB70PD.
075600/
075700     COPY SMFTPXO.
