000100 IDENTIFICATION DIVISION.
000200 PROGRAM-ID. MBOMF01.
000201*       RELEASE DATE=08/24/01.        REVISION LEVEL=08.06      *
000202*****************************************************************
000203*WARNING.  THIS COMPUTER PROGRAM IS PROTECTED BY COPYRIGHT LAW  *
000204*AND INTERNATIONAL TREATIES.  UNAUTHORIZED REPRODUCTION OR      *
000205*DISTRIBUTION OF THIS PROGRAM, OR ANY PORTION OF IT, MAY RESULT *
000206*IN SEVERE CIVIL AND CRIMINAL PENATLIES, AND WILL BE PROSECUTED *
000207*TO THE MAXIMUM EXTENT POSSIBLE UNDER THE LAW.                  *
000208*COPYRIGHT 1999 PAYSYS INTERNATIONAL, INC.  ALL RIGHTS RESERVED.*
000209*****************************************************************
000300*****************************************************************
000400*                                                               *
000500*               M E R C H A N T   S Y S T E M                   *
000600*                                                               *
000700*      MBOMF01 - ON-LINE FIELD SECURITY ADD/MAINT/INQ           *
000800*                ALL SCREENS                                    *
000900*                                                               *
001000*              1. TRANSIDS                                      *
001100*                 A. MBAF                                       *
001200*                 B. MBMF                                       *
001300*                 C. MBQF                                       *
001400*              2. MAPS USED -                                   *
001500*                 A. MBMF01 (USED FOR ALL PAGES)                *
001600*              3. FILES USED -                                  *
001700*                 A. MMFS (FIELD SECURITY FILE)                 *
001800*                 B. MML1 (LOG FILE)                            *
001900*                                                               *
002000*****************************************************************
002100*
002200 ENVIRONMENT DIVISION.
002300*
002400 DATA DIVISION.
002500*
002600 WORKING-STORAGE SECTION.
002700*
002800 01  FILLER                  PIC  X(12)      VALUE
002900     '** WS-BEG **'.
003000*
003100 01  FILLER                  PIC  X(14)      VALUE
003200     'MISCELLANEOUS:'.
003300*
003400 01  WS-MISCELLANEOUS.
003500     03  WS-MAX-LINES        PIC S9(04)      BINARY
003600                                             VALUE +378.
003700     03  WS-FIELD-ATTR-ERROR-SW
003800                             PIC  X(01)      VALUE 'N'.
003900         88  FIELD-ATTR-IN-ERROR             VALUE 'Y'.
004000         88  FIELD-ATTR-NOT-IN-ERROR         VALUE 'N'.
004100     03  WS-UPDATE-SW        PIC  X(01)      VALUE 'N'.
004200         88  FIELDS-WERE-UPDATED             VALUE 'Y'.
004300         88  NO-FIELDS-WERE-UPDATED          VALUE 'N'.
004400     03  WS-INDEX-X.
004500         05  WS-INDEX        PIC  9(04)      VALUE ZEROS.
004600/
004700 01  FILLER                  PIC  X(29)      VALUE
004800     'I/O REQUEST BLOCK WORK AREAS:'.
004900*
005000     COPY MBIOWS.
005100/
005200 01  FILLER                  PIC  X(18)      VALUE
005300     'I/O REQUEST BLOCK:'.
005400*
005500     COPY MBIORO.
005600/
005700 01  FILLER                  PIC  X(25)      VALUE
005800     'LOG RECORD REQUEST BLOCK:'.
005900*
006000     COPY MML1WS REPLACING ==:MML1:== BY ==MML1==.
006100/
006200 01  FILLER                  PIC  X(29)      VALUE
006300     'MERCHANT MASTER FIELDS TABLE:'.
006400*
006500     COPY MMMMTB.
006600/
006700 01  FILLER                  PIC  X(20)      VALUE
006800     'CCS DATE WORK AREAS:'.
006900*
007000     COPY SS01WS.
007100/
007200 01  FILLER                  PIC  X(15)      VALUE
007300     'CCS WORK AREAS:'.
007400*
007500     COPY SS08WS.
007600/
007700     COPY SS00WS.
007800/
007900     COPY SMFTWS.
008000/
008100     COPY SMPTRL REPLACING ==:SMPT:== BY ==SMPT==.
008200/
008300     COPY MB61LK.
008400/
008500 01  FILLER                  PIC  X(12)      VALUE
008600     '** WS-END **'.
008700/
008800 LINKAGE SECTION.
008900*
009000 01  DFHCOMMAREA.
009100*
009200     COPY MB60WS.
009300/
009400****************************
009500*    FIELD SECURITY MAP    *
009600****************************
009700*
009800     COPY MBMF01.
009900/
010000*****************************************
010100*    FIELD SECURITY MAP REDEFINITION    *
010200*****************************************
010300*
010400     COPY MBMF01R.
010500/
010600**************************************
010700*    FIELD SECURITY RECORD LAYOUT    *
010800**************************************
010900*
011000     COPY MMFSRL.
011100/
011200***************************
011300*    LOG RECORD LAYOUT    *
011400***************************
011500*
011600     COPY MML1RL REPLACING ==:MML1:== BY ==MML1==.
011700/
011800 PROCEDURE DIVISION.
011900*
012000 A000-HOUSEKEEPING SECTION.
012100*
012200 A020-INIT.
012300*
012400     MOVE 'PC01'                 TO MBCA-PROGRAM-LOCATION.
012500     PERFORM MB70PD-ON-LINE-HOUSEKEEPING
012600                                 THRU MB70PD-OLH-EXIT.
012700*
012800     IF  MBCA-RECEIVE-SCREEN
012900         GO TO C000-RECEIVE-SCREEN.
013000/
013100 B000-SEND-SCREEN SECTION.
013200*
013300*********************************************
013400*    GET CICS STORAGE NEEDED FOR THE MAP    *
013500*********************************************
013600*
013700     MOVE 'SC01'                 TO MBCA-PROGRAM-LOCATION.
013800     PERFORM MB60PD-GETMAIN-FOR-MAP
013900                                 THRU MB60PD-GFM-EXIT.
014000*
014100*******************************************
014200*    INITIALIZE THE STANDARD MAP LINES    *
014300*******************************************
014400*
014500     PERFORM MB60PD-INIT-STD-MAP-LINES
014600                                 THRU MB60PD-ISML-EXIT.
014700*
014800***************************************************************
014900*    READ THE FIELD SECURITY RECORD FOR SUBSEQUENT DISPLAY    *
015000***************************************************************
015100*
015200     MOVE MBCA-MERCHANT-ORG      TO MBIOWS-MMFS-ORG
015300                                    MF01-ORG.
015400     MOVE MBCA-PROFILE           TO MBIOWS-MMFS-FS-CODE
015500                                    MF01-PROFILE.
015600     MOVE 'FC01'                 TO MBCA-PROGRAM-LOCATION.
015700     SET MBIORO-READ-RANDOM      TO TRUE.
015800     PERFORM MMFSAO-ACCESS       THRU MMFSAO-ACCESS-EXIT.
015900*
016000***********************************************************
016100*    MOVE THE LAST MAINT DATE AND LAST MAINT OPERATOR     *
016200*    TO THE SCREEN, DEPENDING ON THE SCREEN NUMBER AND    *
016300*    FUNCTION                                             *
016400***********************************************************
016500*
016600     IF  MBCA-MBMF-INDEX IS GREATER THAN 1
016700     OR  MBCA-PTI-FUNCTION-IS-ADD
016800         MOVE DFHBMDAS           TO MF01-MAINT-DATE-LIT-A
016900                                    MF01-MAINT-DATE-A
017000                                    MF01-MAINT-OPER-LIT-A
017100                                    MF01-MAINT-OPER-A
017200     ELSE
017300         MOVE MMFS-LAST-MAINT-DATE
017400                                 TO SS01WS-JULIAN
017500         PERFORM SS26PD-NUMERICALLY-EDIT-DATE
017600                                 THRU SS26PD-NED-EXIT
017700         MOVE SS01WS-XX-XX-YYYY  TO MF01-MAINT-DATE
017800         MOVE MMFS-LAST-MAINT-OPER
017900                                 TO MF01-MAINT-OPER.
018000*
018100 B020-MOVE-FIELDS.
018200*
018300**************************************************************
018400*    DETERMINE THE PLACE IN THE FIELD NAME TABLE (MMMMTB)    *
018500*    AND MERCHANT RECORD FROM WHICH TO BEGIN THE DISPLAY     *
018600**************************************************************
018700*
018800     PERFORM Y020-MOVE-NAME      THRU Y039-MN-EXIT.
018900*
019000     PERFORM Y040-MOVE-FIELD-ATTRIBUTES
019100                                 THRU Y059-MFA-EXIT.
019200*
019300     PERFORM Y060-MOVE-AUDIT-CODES
019400                                 THRU Y079-MAC-EXIT.
019500*
019600*****************************************************
019700*    BRIGHTEN AND PROTECT THE NAME IF IN INQUIRY    *
019800*    OR IF IN ADD OR MAINT AND NOT ON SCREEN 01     *
019900*****************************************************
020000*
020100     IF  MBCA-MBMF-INDEX IS GREATER THAN 1
020200     OR  MBCA-PTI-FUNCTION-IS-INQUIRY
020300         MOVE DFHBMASB           TO MF01-NAME-A
020400         MOVE DFHBMDAS           TO MF01-NAME-LP-A
020500                                    MF01-NAME-RP-A.
020600*
020700******************************************
020800*    SET THE CURSOR AND SCREEN NUMBER    *
020900******************************************
021000*
021100     IF  MBCA-PTI-FUNCTION-ADD-OR-MAINT
021200         IF  MBCA-MBMF-INDEX IS EQUAL TO 1
021300             MOVE SS08WS-CURSOR  TO MF01-NAME-L
021400         ELSE
021500             MOVE SS08WS-CURSOR  TO MF01-FIELD-ATTR-L (1)
021600     ELSE
021700         MOVE SS08WS-CURSOR      TO MF01-ALT-TRANID-L.
021800     MOVE 01                     TO MBCA-SCREEN-NBR.
021900*
022000**************************************
022100*    SET THE SCREEN TITLE HEADING    *
022200**************************************
022300*
022400     MOVE '        MERCHANT FIELD SECURITY         '
022500                                 TO MF01-SCREEN-DESC.
022600*
022700 B030-CONTINUE.
022800*
022900     MOVE '*TOP*'                TO SS08WS-LINE-24-PF-KEY-FUNC(3).
023000     MOVE '*BOT*'                TO SS08WS-LINE-24-PF-KEY-FUNC(4).
023100     MOVE '*FWD*'                TO SS08WS-LINE-24-PF-KEY-FUNC(5).
023200     MOVE '*BWD*'                TO SS08WS-LINE-24-PF-KEY-FUNC(6).
023300     MOVE SS08WS-LINE-24         TO MF01-PF-KEYS.
023400     MOVE 'RESV'                 TO MBCA-PGMX-PF-TRANS-ID (3).
023500     MOVE 'RESV'                 TO MBCA-PGMX-PF-TRANS-ID (4).
023600     MOVE 'RESV'                 TO MBCA-PGMX-PF-TRANS-ID (5).
023700     MOVE 'RESV'                 TO MBCA-PGMX-PF-TRANS-ID (6).
023800*
023900**********************
024000*    SEND THE MAP    *
024100**********************
024200*
024300     MOVE 'BM01'                 TO MBCA-PROGRAM-LOCATION.
024400*
024500     PERFORM MB60PD-SEND-MAP-WITH-ERASE
024600                                 THRU MB60PD-SMWE-EXIT.
024700*
024800************************
024900*    RETURN TO CICS    *
025000************************
025100*
025200     MOVE 'PC02'                 TO MBCA-PROGRAM-LOCATION.
025300     PERFORM MB70PD-RETURN-TRANS-ID
025400                                 THRU MB70PD-RTI-EXIT.
025500/
025600 C000-RECEIVE-SCREEN SECTION.
025700*
025800******************************************
025900*    THIS SECTION RECEIVES THE SCREEN    *
026000******************************************
026100*
026200     MOVE 'BM02'                 TO MBCA-PROGRAM-LOCATION.
026300     PERFORM MB60PD-RECEIVE-MAP  THRU MB60PD-RM-EXIT.
026400*
026500**************************************************************
026600*    CHECK FOR ANOTHER TRANSACTION ID ENTERED BY THE USER    *
026700**************************************************************
026800*
026900     MOVE 'PC03'                 TO MBCA-PROGRAM-LOCATION.
027000     PERFORM MB60PD-NEW-TRANS-ROUTINE
027100                                 THRU MB60PD-NTR-EXIT.
027200*
027300****************************************************
027400*    BYPASS ALL SCREEN EDITS IF THIS IS INQUIRY    *
027500****************************************************
027600*
027700     IF  MBCA-PTI-FUNCTION-IS-INQUIRY
027800         GO TO F000-SETUP-COMMAREA.
027900*
028000****************************************
028100*    READ THE FIELD SECURITY RECORD    *
028200****************************************
028300*
028400     MOVE MBCA-MERCHANT-ORG      TO MBIOWS-MMFS-ORG
028500                                    MF01-ORG.
028600     MOVE MBCA-PROFILE           TO MBIOWS-MMFS-FS-CODE
028700                                    MF01-PROFILE.
028800     MOVE 'FC02'                 TO MBCA-PROGRAM-LOCATION.
028900     SET MBIORO-READ-RANDOM      TO TRUE.
029000     PERFORM MMFSAO-ACCESS       THRU MMFSAO-ACCESS-EXIT.
029100*
029200***********************************************************
029300*    MOVE THE LAST MAINT DATE AND LAST MAINT OPERATOR,    *
029400*    DEPENDING ON THE SCREEN NUMBER AND FUNCTION          *
029500***********************************************************
029600*
029700     IF  MBCA-MBMF-INDEX IS GREATER THAN 1
029800     OR  MBCA-PTI-FUNCTION-IS-ADD
029900         MOVE DFHBMDAS           TO MF01-MAINT-DATE-LIT-A
030000                                    MF01-MAINT-DATE-A
030100                                    MF01-MAINT-OPER-LIT-A
030200                                    MF01-MAINT-OPER-A
030300     ELSE
030400         MOVE MMFS-LAST-MAINT-DATE
030500                                 TO SS01WS-JULIAN
030600         PERFORM SS26PD-NUMERICALLY-EDIT-DATE
030700                                 THRU SS26PD-NED-EXIT
030800         MOVE SS01WS-XX-XX-YYYY  TO MF01-MAINT-DATE
030900         MOVE MMFS-LAST-MAINT-OPER
031000                                 TO MF01-MAINT-OPER.
031100*
031200 C020-EDIT-FIELDS.
031300*
031400**************************************************************
031500*    DETERMINE THE PLACE IN THE FIELD NAME TABLE (MMMMTB)    *
031600*    AND MERCHANT RECORD FROM WHICH TO BEGIN THE EDITS       *
031700**************************************************************
031800*
031900     PERFORM W020-EDIT-NAME      THRU W039-EN-EXIT.
032000*
032100     PERFORM W040-EDIT-FIELD-ATTRIBUTES
032200                                 THRU W059-EFA-EXIT.
032300*
032400     PERFORM W060-EDIT-AUDIT-CODES
032500                                 THRU W079-EAC-EXIT.
032600/
032700 D000-RETURN-ERRORS SECTION.
032800*
032900     IF  SS08WS-ERROR IS EQUAL TO 'N'
033000         GO TO E000-UPDATE-FILE.
033100*
033200***************************************************************
033300*    INITIALIZE THE STANDARD MAP LINES.  IN AN ERROR          *
033400*    CONDITION, THIS ROUTINE IS PERFORMED PRIMARILY           *
033500*    TO UPDATE THE DATE AND TIME ON THE SCREEN.               *
033600***************************************************************
033700*
033800     PERFORM MB60PD-INIT-STD-MAP-LINES
033900                                 THRU MB60PD-ISML-EXIT.
034000*
034100**************************************
034200*    SET THE SCREEN TITLE HEADING    *
034300**************************************
034400*
034500     MOVE '        MERCHANT FIELD SECURITY         '
034600                                 TO MF01-SCREEN-DESC.
034700*
034800     MOVE '*TOP*'                TO SS08WS-LINE-24-PF-KEY-FUNC(3).
034900     MOVE '*BOT*'                TO SS08WS-LINE-24-PF-KEY-FUNC(4).
035000     MOVE '*FWD*'                TO SS08WS-LINE-24-PF-KEY-FUNC(5).
035100     MOVE '*BWD*'                TO SS08WS-LINE-24-PF-KEY-FUNC(6).
035200     MOVE SS08WS-LINE-24         TO MF01-PF-KEYS.
035300     MOVE 'RESV'                 TO MBCA-PGMX-PF-TRANS-ID (3).
035400     MOVE 'RESV'                 TO MBCA-PGMX-PF-TRANS-ID (4).
035500     MOVE 'RESV'                 TO MBCA-PGMX-PF-TRANS-ID (5).
035600     MOVE 'RESV'                 TO MBCA-PGMX-PF-TRANS-ID (6).
035700*
035800**********************
035900*    SEND THE MAP    *
036000**********************
036100*
036200     MOVE 'BM03'                 TO MBCA-PROGRAM-LOCATION.
036300     PERFORM MB60PD-SEND-MAP-DATA-ONLY
036400                                 THRU MB60PD-SMDO-EXIT.
036500*
036600************************
036700*    RETURN TO CICS    *
036800************************
036900*
037000     MOVE 'PC04'                 TO MBCA-PROGRAM-LOCATION.
037100     PERFORM MB70PD-RETURN-TRANS-ID
037200                                 THRU MB70PD-RTI-EXIT.
037300/
037400 E000-UPDATE-FILE SECTION.
037500*
037600***************************************************
037700*    READ THE FIELD SECURITY RECORD FOR UPDATE    *
037800***************************************************
037900*
038000     MOVE 'FC03'                 TO MBCA-PROGRAM-LOCATION.
038100     SET MBIORO-READ-RANDOM-UPDATE
038200                                 TO TRUE.
038300     PERFORM MMFSAO-ACCESS       THRU MMFSAO-ACCESS-EXIT.
038400*
038500*********************************************************
038600*    OBTAIN STORAGE FOR LOG FILE RECORD IF DOING        *
038700*    MAINTENANCE OR IF IN THE LAST SCREEN OF THE ADD    *
038800*********************************************************
038900*
039000     IF  MBCA-PTI-FUNCTION-IS-ADD
039100         GO TO E020-UPDATE-FIELDS.
039200*
039300     MOVE 'SC02'                 TO MBCA-PROGRAM-LOCATION.
039400     SET MBIORO-GETMAIN          TO TRUE.
039500     PERFORM MML1AO-ACCESS       THRU MML1AO-ACCESS-EXIT.
039600*
039700*************************************************
039800*    SET UP THE COMMON PORTION OF THE RECORD    *
039900*************************************************
040000*
040100     MOVE 'FS'                   TO MML1-FILE-CODE.
040200     MOVE MBCA-MERCHANT-ORG      TO MML1-MMFS-ORG.
040300     MOVE MBCA-PROFILE           TO MML1-MMFS-FS-CODE.
040400     MOVE MBCA-SIGNON-NAME       TO MML1-SIGNON-NAME.
040500     MOVE MBCA-TERMINAL-ID       TO MML1-TERMINAL-ID.
040600     MOVE ZEROS                  TO MML1-SOURCE-CODE.
040700*
040800 E020-UPDATE-FIELDS.
040900*
041000************************************************
041100*    DETERMINE THE PLACE IN THE MERCHANT       *
041200*    RECORD FROM WHICH TO BEGIN THE UPDATES    *
041300************************************************
041400*
041500     PERFORM X020-UPDATE-NAME    THRU X039-UN-EXIT.
041600*
041700     PERFORM X040-UPDATE-FIELD-ATTRIBUTES
041800                                 THRU X059-UFA-EXIT.
041900*
042000     PERFORM X060-UPDATE-AUDIT-CODES
042100                                 THRU X079-UAC-EXIT.
042200*
042300 E040-UPDATE-MMFS.
042400*
042500     IF  MBCA-PTI-FUNCTION-IS-ADD
042600         MOVE 'Y'                TO WS-UPDATE-SW
042700         MOVE MBCA-SCREEN-NBR    TO MMFS-ONLINE-STATUS
042800         MOVE MBCA-START-DATE    TO MMFS-LAST-MAINT-DATE
042900         MOVE MBCA-OPERATOR-ID   TO MMFS-LAST-MAINT-OPER.
043000*
043100**************************************************************
043200*    WRITE A LOG RECORD TO SHOW THAT THE LAST MAINT DATE     *
043300*    AND OPERATOR HAS BEEN UPDATED IF FIELDS WERE CHANGED    *
043400*    ON THE SCREEN                                           *
043500**************************************************************
043600*
043700     IF  MBCA-PTI-FUNCTION-IS-MAINT
043800     AND FIELDS-WERE-UPDATED
043900         MOVE 0198               TO MML1-FIELD-CODE
044000         MOVE ZEROES             TO MML1-FIELD-OCCURRENCE
044100                                    MML1-FIELD-OCCURRENCE-2
044200         MOVE MML1WS-VL-03       TO MML1-VARIABLE-LENGTH
044300         MOVE MMFS-LAST-MAINT-OPER
044400                                 TO MML1-VL03-B-DATA-X
044500         MOVE MBCA-OPERATOR-ID   TO MMFS-LAST-MAINT-OPER
044600         MOVE MMFS-LAST-MAINT-OPER
044700                                 TO MML1-VL03-A-DATA-X
044800         MOVE 'FC05'             TO MBCA-PROGRAM-LOCATION
044900         PERFORM Y900-WRITE-LOG-RECORD
045000                                 THRU Y919-WLR-EXIT
045100         MOVE 0199               TO MML1-FIELD-CODE
045200         MOVE MML1WS-VL-07       TO MML1-VARIABLE-LENGTH
045300         MOVE MMFS-LAST-MAINT-DATE
045400                                 TO MML1-VL07-B-DATA-9
045500         MOVE MBCA-START-DATE    TO MMFS-LAST-MAINT-DATE
045600         MOVE MMFS-LAST-MAINT-DATE
045700                                 TO MML1-VL07-A-DATA-9
045800         MOVE 'FC06'             TO MBCA-PROGRAM-LOCATION
045900         PERFORM Y900-WRITE-LOG-RECORD
046000                                 THRU Y919-WLR-EXIT.
046100*
046200*************************************************
046300*    REWRITE THE FIELD SECURITY RECORD IF       *
046400*    FIELDS HAVE BEEN CHANGED ON THE SCREEN,    *
046500*    OR UNLOCK IT IF THEY HAVE NOT              *
046600*************************************************
046700*
046800     IF  FIELDS-WERE-UPDATED
046900         MOVE 'FC07'             TO MBCA-PROGRAM-LOCATION
047000         SET MBIORO-REWRITE      TO TRUE
047100         PERFORM MMFSAO-ACCESS   THRU MMFSAO-ACCESS-EXIT
047200     ELSE
047300         MOVE 'FC08'             TO MBCA-PROGRAM-LOCATION
047400         SET MBIORO-UNLOCK       TO TRUE
047500         PERFORM MMFSAO-ACCESS   THRU MMFSAO-ACCESS-EXIT.
047600/
047700 F000-SETUP-COMMAREA SECTION.
047800*
047900***************************************************************
048000*  SET UP COMMAREA FIELDS AND TRANSFER TO THE NEXT PROGRAM    *
048100***************************************************************
048200*
048300     MOVE MBCA-EIBAID            TO SS08WS-EIBAID.
048400*
048500     IF  SS08WS-VALID-PF3
048600     OR  SS08WS-EIBAID-VALID-PF3
048700         MOVE 1                  TO MBCA-MBMF-INDEX
048800         MOVE 51                 TO MBCA-SCREEN-NBR
048900         GO TO F020-PF-KEY-BYPASS.
049000*
049100     IF  SS08WS-VALID-PF4
049200     OR  SS08WS-EIBAID-VALID-PF4
049300         COMPUTE MBCA-MBMF-INDEX = MMMMTB-NBR-ELEMENTS - 41
049400         MOVE 51                 TO MBCA-SCREEN-NBR
049500         GO TO F020-PF-KEY-BYPASS.
049600*
049700     IF  SS08WS-VALID-PF5
049800     OR  SS08WS-EIBAID-VALID-PF5
049900         COMPUTE MBCA-MBMF-INDEX = MBCA-MBMF-INDEX + 42
050000         IF  MBCA-MBMF-INDEX IS GREATER THAN WS-MAX-LINES
050100             COMPUTE MBCA-MBMF-INDEX = MMMMTB-NBR-ELEMENTS - 41
050200             MOVE 51             TO MBCA-SCREEN-NBR
050300             GO TO F020-PF-KEY-BYPASS
050400         ELSE
050500             MOVE 51             TO MBCA-SCREEN-NBR
050600             GO TO F020-PF-KEY-BYPASS.
050700*
050800     IF  SS08WS-VALID-PF6
050900     OR  SS08WS-EIBAID-VALID-PF6
051000         IF  MBCA-MBMF-INDEX IS LESS THAN 43
051100             MOVE 1              TO MBCA-MBMF-INDEX
051200             MOVE 51             TO MBCA-SCREEN-NBR
051300             GO TO F020-PF-KEY-BYPASS
051400         ELSE
051500             COMPUTE MBCA-MBMF-INDEX = MBCA-MBMF-INDEX - 42
051600             MOVE 51         TO MBCA-SCREEN-NBR
051700             GO TO F020-PF-KEY-BYPASS.
051800*
051900     PERFORM MB60PD-EDIT-PAGE-NBR
052000                                 THRU MB60PD-EPN-EXIT.
052100*
052200     MOVE 1                      TO MBCA-MBMF-INDEX.
052300*
052400     IF  SS08WS-VALID-PF-KEY
052500     OR  SS08WS-EIBAID-VALID-PF-KEY
052600         MOVE 99                 TO MBCA-SCREEN-NBR.
052700*
052800 F020-PF-KEY-BYPASS.
052900*
053000     MOVE 'PC05'                 TO MBCA-PROGRAM-LOCATION.
053100     PERFORM MB70PD-XCTL-TO-MBOXCTL
053200                                 THRU MB70PD-XTM-EXIT.
053300/
053400 W000-FIELD-EDITS SECTION.
053500*
053600 W020-EDIT-NAME.
053700*
053800     IF  MF01-NAME-L IS EQUAL TO ZERO
053900     OR  MBCA-MBMF-INDEX IS GREATER THAN 1
054000         MOVE MMFS-NAME          TO MF01-NAME
054100         MOVE DFHBMDAS           TO MF01-NAME-LP-A
054200                                    MF01-NAME-RP-A.
054300*
054400     IF  MBCA-MBMF-INDEX IS EQUAL TO 1
054500         MOVE DFHBMASK           TO MF01-NAME-A
054600     ELSE
054700         MOVE DFHBMASB           TO MF01-NAME-A.
054800*
054900     IF  MF01-NAME-L IS GREATER THAN ZERO
055000         MOVE DFHBMASF           TO MF01-NAME-A.
055100*
055200 W039-EN-EXIT.
055300     EXIT.
055400*
055500 W040-EDIT-FIELD-ATTRIBUTES.
055600*
055700     SET X-MMMMTB-FIELD          TO MBCA-MBMF-INDEX.
055800     SET X-MF01-FS-ITEM          TO 1.
055900     SET X-MMFS-MERCH            TO MBCA-MBMF-INDEX.
056000*
056100 W042-EFA-LOOP.
056200*
056300**************************************************
056400*    SET THE FIELD ATTRIBUTES TO THE STATE IN    *
056500*    WHICH THEY WOULD BE IF ALL EDITS WERE OK    *
056600**************************************************
056700*
056800     MOVE DFHBMDAS               TO MF01-FIELD-DATA-LP-A
056900                                        (X-MF01-FS-ITEM)
057000                                    MF01-FIELD-DATA-RP-A
057100                                        (X-MF01-FS-ITEM).
057200     MOVE DFHBMASK               TO MF01-FIELD-ATTR-A
057300                                        (X-MF01-FS-ITEM).
057400*
057500     IF  MMMMTB-FIELD-NAME (X-MMMMTB-FIELD) IS EQUAL TO SPACES
057600         GO TO W058-INCREMENT-INDEXES.
057700*
057800     MOVE MMMMTB-FIELD-NAME (X-MMMMTB-FIELD)
057900                                 TO MF01-FIELD-NAME
058000                                        (X-MF01-FS-ITEM).
058100*
058200*****************************
058300*    EDIT FOR VALID DATA    *
058400*****************************
058500*
058600     IF  MF01-FIELD-ATTR-L (X-MF01-FS-ITEM) IS EQUAL TO ZERO
058700         MOVE MMFS-MT-FIELD-ATTR (X-MMFS-MERCH)
058800                                 TO MF01-FIELD-ATTR
058900                                        (X-MF01-FS-ITEM).
059000*
059100     IF  MF01-FIELD-ATTR (X-MF01-FS-ITEM) IS NOT NUMERIC
059200         GO TO W044-FIELD-ATTR-ERROR.
059300*
059400     MOVE MF01-FIELD-ATTR (X-MF01-FS-ITEM)
059500                                 TO MMFS-MT-FIELD-ATTR
059600                                        (X-MMFS-MERCH).
059700*
059800     IF  NOT MMFS-MT-VALID-FIELD-ATTR (X-MMFS-MERCH)
059900         GO TO W044-FIELD-ATTR-ERROR
060000     ELSE
060100         MOVE 'N'                TO WS-FIELD-ATTR-ERROR-SW
060200         PERFORM Y800-MERCHANT-FIELD-EXCEPTIONS
060300                                 THRU Y819-MFE-EXIT
060400         IF  FIELD-ATTR-IN-ERROR
060500             GO TO W044-FIELD-ATTR-ERROR
060600         ELSE
060700             MOVE DFHBMASF       TO MF01-FIELD-ATTR-A
060800                                    (X-MF01-FS-ITEM)
060900             GO TO W058-INCREMENT-INDEXES.
061000*
061100 W044-FIELD-ATTR-ERROR.
061200*
061300     MOVE 'Y'                    TO SS08WS-ERROR.
061400     MOVE SS08WS-CURSOR          TO MF01-FIELD-ATTR-L
061500                                        (X-MF01-FS-ITEM).
061600     MOVE DFHBMNBF               TO MF01-FIELD-ATTR-A
061700                                        (X-MF01-FS-ITEM).
061800     MOVE DFHBMASB               TO MF01-FIELD-DATA-LP-A
061900                                        (X-MF01-FS-ITEM)
062000                                    MF01-FIELD-DATA-RP-A
062100                                        (X-MF01-FS-ITEM).
062200*
062300 W058-INCREMENT-INDEXES.
062400*
062500*
062600     IF  X-MF01-FS-ITEM IS LESS THAN 42
062700         SET X-MF01-FS-ITEM      UP BY 1
062800         SET X-MMMMTB-FIELD      UP BY 1
062900         SET X-MMFS-MERCH        UP BY 1
063000         GO TO W042-EFA-LOOP.
063100*
063200 W059-EFA-EXIT.
063300     EXIT.
063400*
063500 W060-EDIT-AUDIT-CODES.
063600*
063700     SET X-MMMMTB-FIELD          TO MBCA-MBMF-INDEX.
063800     SET X-MF01-FS-ITEM          TO 1.
063900     SET X-MMFS-MERCH            TO MBCA-MBMF-INDEX.
064000*
064100 W062-EAC-LOOP.
064200*
064300**************************************************
064400*    SET THE FIELD ATTRIBUTES TO THE STATE IN    *
064500*    WHICH THEY WOULD BE IF ALL EDITS WERE OK    *
064600**************************************************
064700*
064800     MOVE DFHBMASK               TO MF01-AUDIT-CODE-A
064900                                        (X-MF01-FS-ITEM).
065000*
065100     IF  MMMMTB-FIELD-NAME (X-MMMMTB-FIELD) IS EQUAL TO SPACES
065200         GO TO W078-INCREMENT-INDEXES.
065300*
065400     IF  MF01-AUDIT-CODE-L (X-MF01-FS-ITEM) IS EQUAL TO ZERO
065500         MOVE MMFS-MT-AUDIT-CODE (X-MMFS-MERCH)
065600                                 TO MF01-AUDIT-CODE
065700                                        (X-MF01-FS-ITEM)
065800         GO TO W078-INCREMENT-INDEXES.
065900*
066000     MOVE MF01-AUDIT-CODE (X-MF01-FS-ITEM)
066100                                 TO MMFS-MT-AUDIT-CODE
066200                                        (X-MMFS-MERCH).
066300     IF  MMFS-MT-VALID-AUDIT-CODE (X-MMFS-MERCH)
066400         MOVE DFHBMASF           TO MF01-AUDIT-CODE-A
066500                                        (X-MF01-FS-ITEM)
066600         GO TO W078-INCREMENT-INDEXES.
066700*
066800 W064-AUDIT-CODE-ERROR.
066900*
067000     MOVE 'Y'                    TO SS08WS-ERROR.
067100     MOVE SS08WS-CURSOR          TO MF01-AUDIT-CODE-L
067200                                        (X-MF01-FS-ITEM).
067300     MOVE DFHBMUBF               TO MF01-AUDIT-CODE-A
067400                                        (X-MF01-FS-ITEM).
067500     MOVE DFHBMASB               TO MF01-FIELD-DATA-LP-A
067600                                        (X-MF01-FS-ITEM)
067700                                    MF01-FIELD-DATA-RP-A
067800                                        (X-MF01-FS-ITEM).
067900*
068000 W078-INCREMENT-INDEXES.
068100*
068200     IF  X-MF01-FS-ITEM IS LESS THAN 42
068300         SET X-MMFS-MERCH        UP BY 1.
068400*
068500     IF  X-MF01-FS-ITEM IS LESS THAN 42
068600         SET X-MMMMTB-FIELD      UP BY 1
068700         SET X-MF01-FS-ITEM      UP BY 1
068800         GO TO W062-EAC-LOOP.
068900*
069000 W079-EAC-EXIT.
069100     EXIT.
069200/
069300 X000-UPDATE-FIELDS SECTION.
069400*
069500 X020-UPDATE-NAME.
069600*
069700     IF  MF01-NAME-L IS GREATER THAN ZERO
069800         IF  MF01-NAME IS NOT EQUAL TO MMFS-NAME
069900             MOVE 'Y'            TO WS-UPDATE-SW
070000             IF  MBCA-PTI-FUNCTION-IS-MAINT
070100                 MOVE 0101       TO MML1-FIELD-CODE
070200                 MOVE ZEROES     TO MML1-FIELD-OCCURRENCE
070300                                    MML1-FIELD-OCCURRENCE-2
070400                 MOVE MML1WS-VL-30
070500                                 TO MML1-VARIABLE-LENGTH
070600                 MOVE MMFS-NAME  TO MML1-VL30-B-DATA-X
070700                 MOVE MF01-NAME  TO MMFS-NAME
070800                 MOVE MMFS-NAME  TO MML1-VL30-A-DATA-X
070900                 PERFORM Y900-WRITE-LOG-RECORD
071000                                 THRU Y919-WLR-EXIT
071100             ELSE
071200                 MOVE MF01-NAME  TO MMFS-NAME.
071300*
071400 X039-UN-EXIT.
071500     EXIT.
071600*
071700 X040-UPDATE-FIELD-ATTRIBUTES.
071800*
071900     SET X-MF01-FS-ITEM          TO 1.
072000*
072100     SET X-MMFS-MERCH            TO MBCA-MBMF-INDEX.
072200*
072300 X042-UFA-LOOP.
072400*
072500     IF  MF01-FIELD-ATTR-L (X-MF01-FS-ITEM) IS GREATER THAN ZERO
072600         IF  MF01-FIELD-ATTR (X-MF01-FS-ITEM) IS NOT EQUAL TO
072700             MMFS-MT-FIELD-ATTR (X-MMFS-MERCH)
072800             MOVE 'Y'            TO WS-UPDATE-SW
072900             IF  MBCA-PTI-FUNCTION-IS-MAINT
073000                 MOVE 0102       TO MML1-FIELD-CODE
073100                 SET MML1-FIELD-OCCURRENCE
073200                                 TO X-MMFS-MERCH
073300                 MOVE ZEROES     TO MML1-FIELD-OCCURRENCE-2
073400                 MOVE MML1WS-VL-01
073500                                 TO MML1-VARIABLE-LENGTH
073600                 MOVE MMFS-MT-FIELD-ATTR (X-MMFS-MERCH)
073700                                 TO MML1-VL01-B-DATA-X
073800                 MOVE MF01-FIELD-ATTR    (X-MF01-FS-ITEM)
073900                                 TO MMFS-MT-FIELD-ATTR
074000                                         (X-MMFS-MERCH)
074100                 MOVE MMFS-MT-FIELD-ATTR (X-MMFS-MERCH)
074200                                 TO MML1-VL01-A-DATA-X
074300                 MOVE 'FC09'     TO MBCA-PROGRAM-LOCATION
074400                 PERFORM Y900-WRITE-LOG-RECORD
074500                                 THRU Y919-WLR-EXIT
074600             ELSE
074700                 MOVE MF01-FIELD-ATTR    (X-MF01-FS-ITEM)
074800                                 TO MMFS-MT-FIELD-ATTR
074900                                         (X-MMFS-MERCH).
075000*
075100 X058-INCREMENT-INDEXES.
075200*
075300     IF  X-MF01-FS-ITEM IS LESS THAN 42
075400         SET X-MMFS-MERCH        UP BY 1.
075500*
075600     IF  X-MF01-FS-ITEM IS LESS THAN 42
075700         SET X-MF01-FS-ITEM      UP BY 1
075800         GO TO X042-UFA-LOOP.
075900*
076000 X059-UFA-EXIT.
076100     EXIT.
076200*
076300 X060-UPDATE-AUDIT-CODES.
076400*
076500     SET X-MF01-FS-ITEM          TO 1.
076600*
076700     SET X-MMFS-MERCH            TO MBCA-MBMF-INDEX.
076800*
076900 X062-UAC-LOOP.
077000*
077100     IF  MF01-AUDIT-CODE-L   (X-MF01-FS-ITEM) IS GREATER THAN ZERO
077200         IF  MF01-AUDIT-CODE (X-MF01-FS-ITEM) IS NOT EQUAL TO
077300             MMFS-MT-AUDIT-CODE (X-MMFS-MERCH)
077400             MOVE 'Y'            TO WS-UPDATE-SW
077500             IF  MBCA-PTI-FUNCTION-IS-MAINT
077600                 MOVE 0103       TO MML1-FIELD-CODE
077700                 SET MML1-FIELD-OCCURRENCE
077800                                 TO X-MMFS-MERCH
077900                 MOVE ZEROES     TO MML1-FIELD-OCCURRENCE-2
078000                 MOVE MML1WS-VL-01
078100                                 TO MML1-VARIABLE-LENGTH
078200                 MOVE MMFS-MT-AUDIT-CODE (X-MMFS-MERCH)
078300                                 TO MML1-VL01-B-DATA-X
078400                 MOVE MF01-AUDIT-CODE    (X-MF01-FS-ITEM)
078500                                 TO MMFS-MT-AUDIT-CODE
078600                                         (X-MMFS-MERCH)
078700                 MOVE MMFS-MT-AUDIT-CODE (X-MMFS-MERCH)
078800                                 TO MML1-VL01-A-DATA-X
078900                 MOVE 'FC11'     TO MBCA-PROGRAM-LOCATION
079000                 PERFORM Y900-WRITE-LOG-RECORD
079100                                 THRU Y919-WLR-EXIT
079200             ELSE
079300                 MOVE MF01-AUDIT-CODE    (X-MF01-FS-ITEM)
079400                                 TO MMFS-MT-AUDIT-CODE
079500                                         (X-MMFS-MERCH).
079600*
079700 X078-INCREMENT-INDEXES.
079800*
079900     IF  X-MF01-FS-ITEM IS LESS THAN 42
080000         SET X-MMFS-MERCH        UP BY 1.
080100*
080200     IF  X-MF01-FS-ITEM IS LESS THAN 42
080300         SET X-MF01-FS-ITEM      UP BY 1
080400         GO TO X062-UAC-LOOP.
080500*
080600 X079-UAC-EXIT.
080700     EXIT.
080800/
080900 Y000-PERFORMED-ROUTINES SECTION.
081000*
081100 Y020-MOVE-NAME.
081200*
081300     MOVE MMFS-NAME              TO MF01-NAME.
081400*
081500 Y039-MN-EXIT.
081600     EXIT.
081700*
081800 Y040-MOVE-FIELD-ATTRIBUTES.
081900*
082000     SET X-MMMMTB-FIELD          TO MBCA-MBMF-INDEX.
082100     SET X-MF01-FS-ITEM          TO 1.
082200     SET X-MMFS-MERCH            TO MBCA-MBMF-INDEX.
082300*
082400***************************************************
082500*    MOVE THE FIELD TITLES FROM THE TABLE AND     *
082600*    FIELD ATTRIBUTES FROM THE RECORD TO THE      *
082700*    SCREEN                                       *
082800***************************************************
082900*
083000 Y042-MFA-LOOP.
083100*
083200     IF  MMMMTB-FIELD-NAME (X-MMMMTB-FIELD) IS EQUAL TO SPACES
083300         MOVE DFHBMDAS           TO MF01-FIELD-NAME-A
083400                                        (X-MF01-FS-ITEM)
083500                                    MF01-FIELD-ATTR-A
083600                                        (X-MF01-FS-ITEM)
083700                                    MF01-FIELD-DATA-LP-A
083800                                        (X-MF01-FS-ITEM)
083900                                    MF01-FIELD-DATA-RP-A
084000                                        (X-MF01-FS-ITEM)
084100         GO TO Y058-INCREMENT-INDEXES.
084200*
084300     MOVE MMMMTB-FIELD-NAME  (X-MMMMTB-FIELD)
084400                                 TO MF01-FIELD-NAME
084500                                        (X-MF01-FS-ITEM).
084600*
084700     MOVE MMFS-MT-FIELD-ATTR (X-MMFS-MERCH)
084800                                 TO MF01-FIELD-ATTR
084900                                        (X-MF01-FS-ITEM).
085000*
085100********************************************
085200*    DARKEN THE PARENS AND BRIGHTEN THE    *
085300*    DATA ELEMENTS IF IN INQUIRY           *
085400********************************************
085500*
085600     IF  MBCA-PTI-FUNCTION-IS-INQUIRY
085700         MOVE DFHBMASB           TO MF01-FIELD-ATTR-A
085800                                        (X-MF01-FS-ITEM)
085900         MOVE DFHBMDAS           TO MF01-FIELD-DATA-LP-A
086000                                        (X-MF01-FS-ITEM)
086100                                    MF01-FIELD-DATA-RP-A
086200                                        (X-MF01-FS-ITEM).
086300*
086400 Y058-INCREMENT-INDEXES.
086500*
086600     IF  X-MF01-FS-ITEM IS LESS THAN 42
086700         SET X-MMFS-MERCH        UP BY 1.
086800*
086900     IF  X-MF01-FS-ITEM IS LESS THAN 42
087000         SET X-MMMMTB-FIELD      UP BY 1
087100         SET X-MF01-FS-ITEM      UP BY 1
087200         GO TO Y042-MFA-LOOP.
087300*
087400 Y059-MFA-EXIT.
087500     EXIT.
087600*
087700 Y060-MOVE-AUDIT-CODES.
087800*
087900     SET X-MMMMTB-FIELD          TO MBCA-MBMF-INDEX.
088000     SET X-MF01-FS-ITEM          TO 1.
088100     SET X-MMFS-MERCH            TO MBCA-MBMF-INDEX.
088200*
088300 Y062-MAC-LOOP.
088400*
088500     IF  MMMMTB-FIELD-NAME (X-MMMMTB-FIELD) IS EQUAL TO SPACES
088600         MOVE DFHBMDAS           TO MF01-AUDIT-CODE-A
088700                                        (X-MF01-FS-ITEM)
088800         GO TO Y078-INCREMENT-INDEXES.
088900*
089000     MOVE MMFS-MT-AUDIT-CODE (X-MMFS-MERCH)
089100                                 TO MF01-AUDIT-CODE
089200                                        (X-MF01-FS-ITEM).
089300*
089400********************************************
089500*    DARKEN THE PARENS AND BRIGHTEN THE    *
089600*    DATA ELEMENTS IF IN INQUIRY           *
089700********************************************
089800*
089900     IF  MBCA-PTI-FUNCTION-IS-INQUIRY
090000         MOVE DFHBMASB           TO MF01-AUDIT-CODE-A
090100                                        (X-MF01-FS-ITEM).
090200*
090300 Y078-INCREMENT-INDEXES.
090400*
090500     IF  X-MF01-FS-ITEM IS LESS THAN 42
090600         SET X-MMFS-MERCH        UP BY 1.
090700*
090800     IF  X-MF01-FS-ITEM IS LESS THAN 42
090900         SET X-MMMMTB-FIELD      UP BY 1
091000         SET X-MF01-FS-ITEM      UP BY 1
091100         GO TO Y062-MAC-LOOP.
091200*
091300 Y079-MAC-EXIT.
091400     EXIT.
091500*
091600 Y800-MERCHANT-FIELD-EXCEPTIONS.
091700*
091800****************************************************************
091900*    PRIMARY NAME LINE 1 MUST BE REQUIRED IN ADD MODE          *
092000****************************************************************
092100*
092200     MOVE MMMMTB-PRIM-ADDR1 (1:4)
092300                               TO WS-INDEX-X.
092400*
092500     IF  X-MMFS-MERCH IS EQUAL TO WS-INDEX
092600         IF  MMFS-MT-REQUIRED (X-MMFS-MERCH)
092700             GO TO Y819-MFE-EXIT
092800         ELSE
092900             MOVE 'Y'            TO WS-FIELD-ATTR-ERROR-SW
093000             GO TO Y819-MFE-EXIT.
093100*
093200****************************************************************
093300*    PRIMARY POSTAL CODE MUST BE REQUIRED IN ADD MODE          *
093400****************************************************************
093500*
093600     MOVE MMMMTB-PRIM-POSTAL-CODE (1:4)
093700                               TO WS-INDEX-X.
093800*
093900     IF  X-MMFS-MERCH IS EQUAL TO WS-INDEX
094000         IF  MMFS-MT-REQUIRED (X-MMFS-MERCH)
094100             GO TO Y819-MFE-EXIT
094200         ELSE
094300             MOVE 'Y'            TO WS-FIELD-ATTR-ERROR-SW
094400             GO TO Y819-MFE-EXIT.
094500*
094600****************************************************************
094700*    STATEMENT FREQUENCY 1 MUST BE REQUIRED IN ADD MODE        *
094800****************************************************************
094900*
095000     MOVE MMMMTB-STMT-FREQ-1 (1:4)
095100                               TO WS-INDEX-X.
095200*
095300     IF  X-MMFS-MERCH IS EQUAL TO WS-INDEX
095400         IF  MMFS-MT-REQUIRED (X-MMFS-MERCH)
095500             GO TO Y819-MFE-EXIT
095600         ELSE
095700             MOVE 'Y'            TO WS-FIELD-ATTR-ERROR-SW
095800             GO TO Y819-MFE-EXIT.
095900*
096000****************************************************************
096100*    SETTLEMENT FREQUENCY 1 MUST BE REQUIRED IN ADD MODE       *
096200****************************************************************
096300*
096400     MOVE MMMMTB-SETT-FREQ-1 (1:4)
096500                               TO WS-INDEX-X.
096600*
096700     IF  X-MMFS-MERCH IS EQUAL TO WS-INDEX
096800         IF  MMFS-MT-REQUIRED (X-MMFS-MERCH)
096900             GO TO Y819-MFE-EXIT
097000         ELSE
097100             MOVE 'Y'            TO WS-FIELD-ATTR-ERROR-SW
097200             GO TO Y819-MFE-EXIT.
097300*
097400****************************************************************
097500*    ACTIVE SETTLEMENT (ACH) DR AND CR                        *
097600****************************************************************
097700*
097800     MOVE MMMMTB-ACTIVE-CR-RT-1 (1:4)
097900                               TO WS-INDEX-X.
098000*
098100     IF  X-MMFS-MERCH IS EQUAL TO WS-INDEX
098200         IF  MMFS-MT-NO-ACCESS (X-MMFS-MERCH)
098300         OR  MMFS-MT-INQ-ONLY (X-MMFS-MERCH)
098400             GO TO Y819-MFE-EXIT
098500         ELSE
098600             MOVE 'Y'            TO WS-FIELD-ATTR-ERROR-SW
098700             GO TO Y819-MFE-EXIT.
098800*
098900     MOVE MMMMTB-ACTIVE-CR-RT-2 (1:4)
099000                               TO WS-INDEX-X.
099100*
099200     IF  X-MMFS-MERCH IS EQUAL TO WS-INDEX
099300         IF  MMFS-MT-NO-ACCESS (X-MMFS-MERCH)
099400         OR  MMFS-MT-INQ-ONLY (X-MMFS-MERCH)
099500             GO TO Y819-MFE-EXIT
099600         ELSE
099700             MOVE 'Y'            TO WS-FIELD-ATTR-ERROR-SW
099800             GO TO Y819-MFE-EXIT.
099900*
100000     MOVE MMMMTB-ACTIVE-CR-RT-3 (1:4)
100100                               TO WS-INDEX-X.
100200*
100300     IF  X-MMFS-MERCH IS EQUAL TO WS-INDEX
100400         IF  MMFS-MT-NO-ACCESS (X-MMFS-MERCH)
100500         OR  MMFS-MT-INQ-ONLY (X-MMFS-MERCH)
100600             GO TO Y819-MFE-EXIT
100700         ELSE
100800             MOVE 'Y'            TO WS-FIELD-ATTR-ERROR-SW
100900             GO TO Y819-MFE-EXIT.
101000*
101100     MOVE MMMMTB-ACTIVE-CR-RT-4 (1:4)
101200                               TO WS-INDEX-X.
101300*
101400     IF  X-MMFS-MERCH IS EQUAL TO WS-INDEX
101500         IF  MMFS-MT-NO-ACCESS (X-MMFS-MERCH)
101600         OR  MMFS-MT-INQ-ONLY (X-MMFS-MERCH)
101700             GO TO Y819-MFE-EXIT
101800         ELSE
101900             MOVE 'Y'            TO WS-FIELD-ATTR-ERROR-SW
102000             GO TO Y819-MFE-EXIT.
102100*
102200     MOVE MMMMTB-ACTIVE-CR-ACCT-1 (1:4)
102300                               TO WS-INDEX-X.
102400*
102500     IF  X-MMFS-MERCH IS EQUAL TO WS-INDEX
102600         IF  MMFS-MT-NO-ACCESS (X-MMFS-MERCH)
102700         OR  MMFS-MT-INQ-ONLY (X-MMFS-MERCH)
102800             GO TO Y819-MFE-EXIT
102900         ELSE
103000             MOVE 'Y'            TO WS-FIELD-ATTR-ERROR-SW
103100             GO TO Y819-MFE-EXIT.
103200*
103300     MOVE MMMMTB-ACTIVE-CR-ACCT-2 (1:4)
103400                               TO WS-INDEX-X.
103500*
103600     IF  X-MMFS-MERCH IS EQUAL TO WS-INDEX
103700         IF  MMFS-MT-NO-ACCESS (X-MMFS-MERCH)
103800         OR  MMFS-MT-INQ-ONLY (X-MMFS-MERCH)
103900             GO TO Y819-MFE-EXIT
104000         ELSE
104100             MOVE 'Y'            TO WS-FIELD-ATTR-ERROR-SW
104200             GO TO Y819-MFE-EXIT.
104300*
104400     MOVE MMMMTB-ACTIVE-CR-ACCT-3 (1:4)
104500                               TO WS-INDEX-X.
104600*
104700     IF  X-MMFS-MERCH IS EQUAL TO WS-INDEX
104800         IF  MMFS-MT-NO-ACCESS (X-MMFS-MERCH)
104900         OR  MMFS-MT-INQ-ONLY (X-MMFS-MERCH)
105000             GO TO Y819-MFE-EXIT
105100         ELSE
105200             MOVE 'Y'            TO WS-FIELD-ATTR-ERROR-SW
105300             GO TO Y819-MFE-EXIT.
105400*
105500     MOVE MMMMTB-ACTIVE-CR-ACCT-4 (1:4)
105600                               TO WS-INDEX-X.
105700*
105800     IF  X-MMFS-MERCH IS EQUAL TO WS-INDEX
105900         IF  MMFS-MT-NO-ACCESS (X-MMFS-MERCH)
106000         OR  MMFS-MT-INQ-ONLY (X-MMFS-MERCH)
106100             GO TO Y819-MFE-EXIT
106200         ELSE
106300             MOVE 'Y'            TO WS-FIELD-ATTR-ERROR-SW
106400             GO TO Y819-MFE-EXIT.
106500*
106600     MOVE MMMMTB-ACTIVE-CR-TYPE-1 (1:4)
106700                               TO WS-INDEX-X.
106800*
106900     IF  X-MMFS-MERCH IS EQUAL TO WS-INDEX
107000         IF  MMFS-MT-NO-ACCESS (X-MMFS-MERCH)
107100         OR  MMFS-MT-INQ-ONLY (X-MMFS-MERCH)
107200             GO TO Y819-MFE-EXIT
107300         ELSE
107400             MOVE 'Y'            TO WS-FIELD-ATTR-ERROR-SW
107500             GO TO Y819-MFE-EXIT.
107600*
107700     MOVE MMMMTB-ACTIVE-CR-TYPE-2 (1:4)
107800                               TO WS-INDEX-X.
107900*
108000     IF  X-MMFS-MERCH IS EQUAL TO WS-INDEX
108100         IF  MMFS-MT-NO-ACCESS (X-MMFS-MERCH)
108200         OR  MMFS-MT-INQ-ONLY (X-MMFS-MERCH)
108300             GO TO Y819-MFE-EXIT
108400         ELSE
108500             MOVE 'Y'            TO WS-FIELD-ATTR-ERROR-SW
108600             GO TO Y819-MFE-EXIT.
108700*
108800     MOVE MMMMTB-ACTIVE-CR-TYPE-3 (1:4)
108900                               TO WS-INDEX-X.
109000*
109100     IF  X-MMFS-MERCH IS EQUAL TO WS-INDEX
109200         IF  MMFS-MT-NO-ACCESS (X-MMFS-MERCH)
109300         OR  MMFS-MT-INQ-ONLY (X-MMFS-MERCH)
109400             GO TO Y819-MFE-EXIT
109500         ELSE
109600             MOVE 'Y'            TO WS-FIELD-ATTR-ERROR-SW
109700             GO TO Y819-MFE-EXIT.
109800*
109900     MOVE MMMMTB-ACTIVE-CR-TYPE-4 (1:4)
110000                               TO WS-INDEX-X.
110100*
110200     IF  X-MMFS-MERCH IS EQUAL TO WS-INDEX
110300         IF  MMFS-MT-NO-ACCESS (X-MMFS-MERCH)
110400         OR  MMFS-MT-INQ-ONLY (X-MMFS-MERCH)
110500             GO TO Y819-MFE-EXIT
110600         ELSE
110700             MOVE 'Y'            TO WS-FIELD-ATTR-ERROR-SW
110800             GO TO Y819-MFE-EXIT.
110900*
111000     MOVE MMMMTB-ACTIVE-DR-RT-1 (1:4)
111100                               TO WS-INDEX-X.
111200*
111300     IF  X-MMFS-MERCH IS EQUAL TO WS-INDEX
111400         IF  MMFS-MT-NO-ACCESS (X-MMFS-MERCH)
111500         OR  MMFS-MT-INQ-ONLY (X-MMFS-MERCH)
111600             GO TO Y819-MFE-EXIT
111700         ELSE
111800             MOVE 'Y'            TO WS-FIELD-ATTR-ERROR-SW
111900             GO TO Y819-MFE-EXIT.
112000*
112100     MOVE MMMMTB-ACTIVE-DR-RT-2 (1:4)
112200                               TO WS-INDEX-X.
112300*
112400     IF  X-MMFS-MERCH IS EQUAL TO WS-INDEX
112500         IF  MMFS-MT-NO-ACCESS (X-MMFS-MERCH)
112600         OR  MMFS-MT-INQ-ONLY (X-MMFS-MERCH)
112700             GO TO Y819-MFE-EXIT
112800         ELSE
112900             MOVE 'Y'            TO WS-FIELD-ATTR-ERROR-SW
113000             GO TO Y819-MFE-EXIT.
113100*
113200     MOVE MMMMTB-ACTIVE-DR-RT-3 (1:4)
113300                               TO WS-INDEX-X.
113400*
113500     IF  X-MMFS-MERCH IS EQUAL TO WS-INDEX
113600         IF  MMFS-MT-NO-ACCESS (X-MMFS-MERCH)
113700         OR  MMFS-MT-INQ-ONLY (X-MMFS-MERCH)
113800             GO TO Y819-MFE-EXIT
113900         ELSE
114000             MOVE 'Y'            TO WS-FIELD-ATTR-ERROR-SW
114100             GO TO Y819-MFE-EXIT.
114200*
114300     MOVE MMMMTB-ACTIVE-DR-RT-4 (1:4)
114400                               TO WS-INDEX-X.
114500*
114600     IF  X-MMFS-MERCH IS EQUAL TO WS-INDEX
114700         IF  MMFS-MT-NO-ACCESS (X-MMFS-MERCH)
114800         OR  MMFS-MT-INQ-ONLY (X-MMFS-MERCH)
114900             GO TO Y819-MFE-EXIT
115000         ELSE
115100             MOVE 'Y'            TO WS-FIELD-ATTR-ERROR-SW
115200             GO TO Y819-MFE-EXIT.
115300*
115400     MOVE MMMMTB-ACTIVE-DR-ACCT-1 (1:4)
115500                               TO WS-INDEX-X.
115600*
115700     IF  X-MMFS-MERCH IS EQUAL TO WS-INDEX
115800         IF  MMFS-MT-NO-ACCESS (X-MMFS-MERCH)
115900         OR  MMFS-MT-INQ-ONLY (X-MMFS-MERCH)
116000             GO TO Y819-MFE-EXIT
116100         ELSE
116200             MOVE 'Y'            TO WS-FIELD-ATTR-ERROR-SW
116300             GO TO Y819-MFE-EXIT.
116400*
116500     MOVE MMMMTB-ACTIVE-DR-ACCT-2 (1:4)
116600                               TO WS-INDEX-X.
116700*
116800     IF  X-MMFS-MERCH IS EQUAL TO WS-INDEX
116900         IF  MMFS-MT-NO-ACCESS (X-MMFS-MERCH)
117000         OR  MMFS-MT-INQ-ONLY (X-MMFS-MERCH)
117100             GO TO Y819-MFE-EXIT
117200         ELSE
117300             MOVE 'Y'            TO WS-FIELD-ATTR-ERROR-SW
117400             GO TO Y819-MFE-EXIT.
117500*
117600     MOVE MMMMTB-ACTIVE-DR-ACCT-3 (1:4)
117700                               TO WS-INDEX-X.
117800*
117900     IF  X-MMFS-MERCH IS EQUAL TO WS-INDEX
118000         IF  MMFS-MT-NO-ACCESS (X-MMFS-MERCH)
118100         OR  MMFS-MT-INQ-ONLY (X-MMFS-MERCH)
118200             GO TO Y819-MFE-EXIT
118300         ELSE
118400             MOVE 'Y'            TO WS-FIELD-ATTR-ERROR-SW
118500             GO TO Y819-MFE-EXIT.
118600*
118700     MOVE MMMMTB-ACTIVE-DR-ACCT-4 (1:4)
118800                               TO WS-INDEX-X.
118900*
119000     IF  X-MMFS-MERCH IS EQUAL TO WS-INDEX
119100         IF  MMFS-MT-NO-ACCESS (X-MMFS-MERCH)
119200         OR  MMFS-MT-INQ-ONLY (X-MMFS-MERCH)
119300             GO TO Y819-MFE-EXIT
119400         ELSE
119500             MOVE 'Y'            TO WS-FIELD-ATTR-ERROR-SW
119600             GO TO Y819-MFE-EXIT.
119700*
119800     MOVE MMMMTB-ACTIVE-DR-TYPE-1 (1:4)
119900                               TO WS-INDEX-X.
120000*
120100     IF  X-MMFS-MERCH IS EQUAL TO WS-INDEX
120200         IF  MMFS-MT-NO-ACCESS (X-MMFS-MERCH)
120300         OR  MMFS-MT-INQ-ONLY (X-MMFS-MERCH)
120400             GO TO Y819-MFE-EXIT
120500         ELSE
120600             MOVE 'Y'            TO WS-FIELD-ATTR-ERROR-SW
120700             GO TO Y819-MFE-EXIT.
120800*
120900     MOVE MMMMTB-ACTIVE-DR-TYPE-2 (1:4)
121000                               TO WS-INDEX-X.
121100*
121200     IF  X-MMFS-MERCH IS EQUAL TO WS-INDEX
121300         IF  MMFS-MT-NO-ACCESS (X-MMFS-MERCH)
121400         OR  MMFS-MT-INQ-ONLY (X-MMFS-MERCH)
121500             GO TO Y819-MFE-EXIT
121600         ELSE
121700             MOVE 'Y'            TO WS-FIELD-ATTR-ERROR-SW
121800             GO TO Y819-MFE-EXIT.
121900*
122000     MOVE MMMMTB-ACTIVE-DR-TYPE-3 (1:4)
122100                               TO WS-INDEX-X.
122200*
122300     IF  X-MMFS-MERCH IS EQUAL TO WS-INDEX
122400         IF  MMFS-MT-NO-ACCESS (X-MMFS-MERCH)
122500         OR  MMFS-MT-INQ-ONLY (X-MMFS-MERCH)
122600             GO TO Y819-MFE-EXIT
122700         ELSE
122800             MOVE 'Y'            TO WS-FIELD-ATTR-ERROR-SW
122900             GO TO Y819-MFE-EXIT.
123000*
123100     MOVE MMMMTB-ACTIVE-DR-TYPE-4 (1:4)
123200                               TO WS-INDEX-X.
123300*
123400     IF  X-MMFS-MERCH IS EQUAL TO WS-INDEX
123500         IF  MMFS-MT-NO-ACCESS (X-MMFS-MERCH)
123600         OR  MMFS-MT-INQ-ONLY (X-MMFS-MERCH)
123700             GO TO Y819-MFE-EXIT
123800         ELSE
123900             MOVE 'Y'            TO WS-FIELD-ATTR-ERROR-SW
124000             GO TO Y819-MFE-EXIT.
124100*
124200 Y819-MFE-EXIT.
124300     EXIT.
124400*
124500 Y900-WRITE-LOG-RECORD.
124600*
124700     SET MBIORO-WRITE            TO TRUE.
124800     PERFORM MML1AO-ACCESS       THRU MML1AO-ACCESS-EXIT.
124900     MOVE SPACES                 TO MML1-VARIABLE-AREA.
125000*
125100 Y919-WLR-EXIT.
125200     EXIT.
125300/
125400 Z000-COPIED-ROUTINES SECTION.
125500*
125600**********************************
125700*    JUL TO GREG DATE ROUTINE    *
125800**********************************
125900*
126000     COPY SS08PD.
126100/
126200**********************************
126300*    DATE AND TIME EDIT ROUTINES *
126400**********************************
126500*
126600     COPY SS26PD.
126700     COPY SS27PD.
126800/
126900*********************************
127000*    LINE 24 PF KEYS ROUTINE    *
127100*********************************
127200*
127300     COPY SS15PD.
127400/
127500***********************************************
127600*    FIELD SECURITY RECORD ACCESS ROUTINES    *
127700***********************************************
127800*
127900     COPY MMFSAO.
128000/
128100*****************************************
128200*    LOG FILE RECORD ACCESS ROUTINES    *
128300*****************************************
128400*
128500     COPY MML1AO.
128600/
128700*****************************
128800*    ONLINE MAP ROUTINES    *
128900*****************************
129000*
129100     COPY MB60PD REPLACING 'MBMAPXX' BY 'MBMF01 '
129200                           MBMAPXXI BY MBMF01I
129300                           MBMAPXXO BY MBMF01O.
129400/
129500***************************
129600*    ONLINE PROCEDURES    *
129700***************************
129800*
129900     COPY MB70PD.
130000/
130100     COPY SMFTPXO.
