000100 IDENTIFICATION DIVISION.
000200 PROGRAM-ID. MBOMF02.
000201*       RELEASE DATE=08/24/01.        REVISION LEVEL=08.06      *
000202*****************************************************************
000203*WARNING.  THIS COMPUTER PROGRAM IS PROTECTED BY COPYRIGHT LAW  *
000204*AND INTERNATIONAL TREATIES.  UNAUTHORIZED REPRODUCTION OR      *
000205*DISTRIBUTION OF THIS PROGRAM, OR ANY PORTION OF IT, MAY RESULT *
000206*IN SEVERE CIVIL AND CRIMINAL PENATLIES, AND WILL BE PROSECUTED *
000207*TO THE MAXIMUM EXTENT POSSIBLE UNDER THE LAW.                  *
000208*COPYRIGHT 1999 PAYSYS INTERNATIONAL, INC.  ALL RIGHTS RESERVED.*
000209*****************************************************************
000300*****************************************************************
000400*                                                               *
000500*               M E R C H A N T   S Y S T E M                   *
000600*                                                               *
000700*      MBOMF02 - ON-LINE FIELD SECURITY ADD/MAINT/INQ           *
000800*                ALL SCREENS                                    *
000900*                                                               *
001000*              1. TRANSIDS                                      *
001100*                 A. MBAF                                       *
001200*                 B. MBMF                                       *
001300*                 C. MBQF                                       *
001400*              2. MAPS USED -                                   *
001500*                 A. MBMF02 (USED FOR ALL PAGES)                *
001600*              3. FILES USED -                                  *
001700*                 A. MMFS (FIELD SECURITY FILE)                 *
001800*                 B. MML1 (LOG FILE)                            *
001900*                                                               *
002000*****************************************************************
002100*
002200 ENVIRONMENT DIVISION.
002300*
002400 DATA DIVISION.
002500*
002600 WORKING-STORAGE SECTION.
002700*
002800 01  FILLER                  PIC  X(12)      VALUE
002900     '** WS-BEG **'.
003000*
003100 01  FILLER                  PIC  X(14)      VALUE
003200     'MISCELLANEOUS:'.
003300*
003400 01  WS-MISCELLANEOUS.
003500     03  WS-MAX-LINES        PIC S9(04)      BINARY
003600                                             VALUE +210.
003700     03  WS-FIELD-ATTR-ERROR-SW
003800                             PIC  X(01)      VALUE 'N'.
003900         88  FIELD-ATTR-IN-ERROR             VALUE 'Y'.
004000         88  FIELD-ATTR-NOT-IN-ERROR         VALUE 'N'.
004100     03  WS-UPDATE-SW        PIC  X(01)      VALUE 'N'.
004200         88  FIELDS-WERE-UPDATED             VALUE 'Y'.
004300         88  NO-FIELDS-WERE-UPDATED          VALUE 'N'.
004400     03  WS-INDEX-X.
004500         05  WS-INDEX        PIC  9(04)      VALUE ZEROS.
004600/
004700 01  FILLER                  PIC  X(29)      VALUE
004800     'I/O REQUEST BLOCK WORK AREAS:'.
004900*
005000     COPY MBIOWS.
005100/
005200 01  FILLER                  PIC  X(18)      VALUE
005300     'I/O REQUEST BLOCK:'.
005400*
005500     COPY MBIORO.
005600/
005700 01  FILLER                  PIC  X(25)      VALUE
005800     'LOG RECORD REQUEST BLOCK:'.
005900*
006000     COPY MML1WS REPLACING ==:MML1:== BY ==MML1==.
006100/
006200 01  FILLER                  PIC  X(26)      VALUE
006300     'STORE MASTER FIELDS TABLE:'.
006400*
006500     COPY MMSMTB.
006600/
006700 01  FILLER                  PIC  X(20)      VALUE
006800     'CCS DATE WORK AREAS:'.
006900*
007000     COPY SS01WS.
007100/
007200 01  FILLER                  PIC  X(15)      VALUE
007300     'CCS WORK AREAS:'.
007400*
007500     COPY SS08WS.
007600/
007700     COPY SS00WS.
007800/
007900     COPY SMFTWS.
008000/
008100     COPY SMPTRL REPLACING ==:SMPT:== BY ==SMPT==.
008200/
008300     COPY MB61LK.
008400/
008500 01  FILLER                  PIC  X(12)      VALUE
008600     '** WS-END **'.
008700/
008800 LINKAGE SECTION.
008900*
009000 01  DFHCOMMAREA.
009100*
009200     COPY MB60WS.
009300/
009400****************************
009500*    FIELD SECURITY MAP    *
009600****************************
009700*
009800     COPY MBMF02.
009900/
010000*****************************************
010100*    FIELD SECURITY MAP REDEFINITION    *
010200*****************************************
010300*
010400     COPY MBMF02R.
010500/
010600**************************************
010700*    FIELD SECURITY RECORD LAYOUT    *
010800**************************************
010900*
011000     COPY MMFSRL.
011100/
011200***************************
011300*    LOG RECORD LAYOUT    *
011400***************************
011500*
011600     COPY MML1RL REPLACING ==:MML1:== BY ==MML1==.
011700/
011800 PROCEDURE DIVISION.
011900*
012000 A000-HOUSEKEEPING SECTION.
012100*
012200 A020-INIT.
012300*
012400     MOVE 'PC01'                 TO MBCA-PROGRAM-LOCATION.
012500     PERFORM MB70PD-ON-LINE-HOUSEKEEPING
012600                                 THRU MB70PD-OLH-EXIT.
012700*
012800     IF  MBCA-RECEIVE-SCREEN
012900         GO TO C000-RECEIVE-SCREEN.
013000/
013100 B000-SEND-SCREEN SECTION.
013200*
013300*********************************************
013400*    GET CICS STORAGE NEEDED FOR THE MAP    *
013500*********************************************
013600*
013700     MOVE 'SC01'                 TO MBCA-PROGRAM-LOCATION.
013800     PERFORM MB60PD-GETMAIN-FOR-MAP
013900                                 THRU MB60PD-GFM-EXIT.
014000*
014100*******************************************
014200*    INITIALIZE THE STANDARD MAP LINES    *
014300*******************************************
014400*
014500     PERFORM MB60PD-INIT-STD-MAP-LINES
014600                                 THRU MB60PD-ISML-EXIT.
014700*
014800***************************************************************
014900*    READ THE FIELD SECURITY RECORD FOR SUBSEQUENT DISPLAY    *
015000***************************************************************
015100*
015200     MOVE MBCA-MERCHANT-ORG      TO MBIOWS-MMFS-ORG
015300                                    MF02-ORG.
015400     MOVE MBCA-PROFILE           TO MBIOWS-MMFS-FS-CODE
015500                                    MF02-PROFILE.
015600     MOVE 'FC01'                 TO MBCA-PROGRAM-LOCATION.
015700     SET MBIORO-READ-RANDOM      TO TRUE.
015800     PERFORM MMFSAO-ACCESS       THRU MMFSAO-ACCESS-EXIT.
015900*
016000 B020-MOVE-FIELDS.
016100*
016200**************************************************************
016300*    DETERMINE THE PLACE IN THE FIELD NAME TABLE (MMSMTB)    *
016400*    AND MERCHANT RECORD FROM WHICH TO BEGIN THE DISPLAY     *
016500**************************************************************
016600*
016700     MOVE MMFS-NAME              TO MF02-NAME.
016800*
016900     PERFORM Y040-MOVE-FIELD-ATTRIBUTES
017000                                 THRU Y059-MFA-EXIT.
017100*
017200     PERFORM Y060-MOVE-AUDIT-CODES
017300                                 THRU Y079-MAC-EXIT.
017400*
017500******************************************
017600*    SET THE CURSOR AND SCREEN NUMBER    *
017700******************************************
017800*
017900     IF  MBCA-PTI-FUNCTION-ADD-OR-MAINT
018000         MOVE SS08WS-CURSOR      TO MF02-FIELD-ATTR-L (1)
018100     ELSE
018200         MOVE SS08WS-CURSOR      TO MF02-ALT-TRANID-L.
018300*
018400     MOVE 02                     TO MBCA-SCREEN-NBR.
018500*
018600**************************************
018700*    SET THE SCREEN TITLE HEADING    *
018800**************************************
018900*
019000     MOVE '          STORE FIELD SECURITY          '
019100                                 TO MF02-SCREEN-DESC.
019200*
019300 B030-CONTINUE.
019400*
019500     MOVE '*TOP*'                TO SS08WS-LINE-24-PF-KEY-FUNC(3).
019600     MOVE '*BOT*'                TO SS08WS-LINE-24-PF-KEY-FUNC(4).
019700     MOVE '*FWD*'                TO SS08WS-LINE-24-PF-KEY-FUNC(5).
019800     MOVE '*BWD*'                TO SS08WS-LINE-24-PF-KEY-FUNC(6).
019900     MOVE SS08WS-LINE-24         TO MF02-PF-KEYS.
020000     MOVE 'RESV'                 TO MBCA-PGMX-PF-TRANS-ID (3).
020100     MOVE 'RESV'                 TO MBCA-PGMX-PF-TRANS-ID (4).
020200     MOVE 'RESV'                 TO MBCA-PGMX-PF-TRANS-ID (5).
020300     MOVE 'RESV'                 TO MBCA-PGMX-PF-TRANS-ID (6).
020400*
020500**********************
020600*    SEND THE MAP    *
020700**********************
020800*
020900     MOVE 'BM01'                 TO MBCA-PROGRAM-LOCATION.
021000*
021100     PERFORM MB60PD-SEND-MAP-WITH-ERASE
021200                                 THRU MB60PD-SMWE-EXIT.
021300*
021400************************
021500*    RETURN TO CICS    *
021600************************
021700*
021800     MOVE 'PC02'                 TO MBCA-PROGRAM-LOCATION.
021900     PERFORM MB70PD-RETURN-TRANS-ID
022000                                 THRU MB70PD-RTI-EXIT.
022100/
022200 C000-RECEIVE-SCREEN SECTION.
022300*
022400******************************************
022500*    THIS SECTION RECEIVES THE SCREEN    *
022600******************************************
022700*
022800     MOVE 'BM02'                 TO MBCA-PROGRAM-LOCATION.
022900     PERFORM MB60PD-RECEIVE-MAP  THRU MB60PD-RM-EXIT.
023000*
023100**************************************************************
023200*    CHECK FOR ANOTHER TRANSACTION ID ENTERED BY THE USER    *
023300**************************************************************
023400*
023500     MOVE 'PC03'                 TO MBCA-PROGRAM-LOCATION.
023600     PERFORM MB60PD-NEW-TRANS-ROUTINE
023700                                 THRU MB60PD-NTR-EXIT.
023800*
023900****************************************************
024000*    BYPASS ALL SCREEN EDITS IF THIS IS INQUIRY    *
024100****************************************************
024200*
024300     IF  MBCA-PTI-FUNCTION-IS-INQUIRY
024400         GO TO F000-SETUP-COMMAREA.
024500*
024600****************************************
024700*    READ THE FIELD SECURITY RECORD    *
024800****************************************
024900*
025000     MOVE MBCA-MERCHANT-ORG      TO MBIOWS-MMFS-ORG
025100                                    MF02-ORG.
025200     MOVE MBCA-PROFILE           TO MBIOWS-MMFS-FS-CODE
025300                                    MF02-PROFILE.
025400     MOVE 'FC02'                 TO MBCA-PROGRAM-LOCATION.
025500     SET MBIORO-READ-RANDOM      TO TRUE.
025600     PERFORM MMFSAO-ACCESS       THRU MMFSAO-ACCESS-EXIT.
025700*
025800     MOVE MMFS-NAME              TO MF02-NAME.
025900*
026000 C020-EDIT-FIELDS.
026100*
026200**************************************************************
026300*    DETERMINE THE PLACE IN THE FIELD NAME TABLE (MMSMTB)    *
026400*    AND MERCHANT RECORD FROM WHICH TO BEGIN THE EDITS       *
026500**************************************************************
026600*
026700     PERFORM W040-EDIT-FIELD-ATTRIBUTES
026800                                 THRU W059-EFA-EXIT.
026900*
027000     PERFORM W060-EDIT-AUDIT-CODES
027100                                 THRU W079-EAC-EXIT.
027200/
027300 D000-RETURN-ERRORS SECTION.
027400*
027500     IF  SS08WS-ERROR IS EQUAL TO 'N'
027600         GO TO E000-UPDATE-FILE.
027700*
027800***************************************************************
027900*    INITIALIZE THE STANDARD MAP LINES.  IN AN ERROR          *
028000*    CONDITION, THIS ROUTINE IS PERFORMED PRIMARILY           *
028100*    TO UPDATE THE DATE AND TIME ON THE SCREEN.               *
028200***************************************************************
028300*
028400     PERFORM MB60PD-INIT-STD-MAP-LINES
028500                                 THRU MB60PD-ISML-EXIT.
028600*
028700**************************************
028800*    SET THE SCREEN TITLE HEADING    *
028900**************************************
029000*
029100     MOVE '          STORE FIELD SECURITY          '
029200                                 TO MF02-SCREEN-DESC.
029300*
029400     MOVE '*TOP*'                TO SS08WS-LINE-24-PF-KEY-FUNC(3).
029500     MOVE '*BOT*'                TO SS08WS-LINE-24-PF-KEY-FUNC(4).
029600     MOVE '*FWD*'                TO SS08WS-LINE-24-PF-KEY-FUNC(5).
029700     MOVE '*BWD*'                TO SS08WS-LINE-24-PF-KEY-FUNC(6).
029800     MOVE SS08WS-LINE-24         TO MF02-PF-KEYS.
029900     MOVE 'RESV'                 TO MBCA-PGMX-PF-TRANS-ID (3).
030000     MOVE 'RESV'                 TO MBCA-PGMX-PF-TRANS-ID (4).
030100     MOVE 'RESV'                 TO MBCA-PGMX-PF-TRANS-ID (5).
030200     MOVE 'RESV'                 TO MBCA-PGMX-PF-TRANS-ID (6).
030300*
030400**********************
030500*    SEND THE MAP    *
030600**********************
030700*
030800     MOVE 'BM03'                 TO MBCA-PROGRAM-LOCATION.
030900     PERFORM MB60PD-SEND-MAP-DATA-ONLY
031000                                 THRU MB60PD-SMDO-EXIT.
031100*
031200************************
031300*    RETURN TO CICS    *
031400************************
031500*
031600     MOVE 'PC04'                 TO MBCA-PROGRAM-LOCATION.
031700     PERFORM MB70PD-RETURN-TRANS-ID
031800                                 THRU MB70PD-RTI-EXIT.
031900/
032000 E000-UPDATE-FILE SECTION.
032100*
032200***************************************************
032300*    READ THE FIELD SECURITY RECORD FOR UPDATE    *
032400***************************************************
032500*
032600     MOVE 'FC03'                 TO MBCA-PROGRAM-LOCATION.
032700     SET MBIORO-READ-RANDOM-UPDATE
032800                                 TO TRUE.
032900     PERFORM MMFSAO-ACCESS       THRU MMFSAO-ACCESS-EXIT.
033000*
033100*********************************************************
033200*    OBTAIN STORAGE FOR LOG FILE RECORD IF DOING        *
033300*    MAINTENANCE OR IF IN THE LAST SCREEN OF THE ADD    *
033400*********************************************************
033500*
033600     IF  MBCA-PTI-FUNCTION-IS-ADD
033700         IF  MBCA-SCREEN-NBR IS LESS THAN MBCA-MAX-SCREEN-NBR
033800             GO TO E020-UPDATE-FIELDS.
033900*
034000     MOVE 'SC02'                 TO MBCA-PROGRAM-LOCATION.
034100     SET MBIORO-GETMAIN          TO TRUE.
034200     PERFORM MML1AO-ACCESS       THRU MML1AO-ACCESS-EXIT.
034300*
034400*************************************************
034500*    SET UP THE COMMON PORTION OF THE RECORD    *
034600*************************************************
034700*
034800     MOVE 'FS'                   TO MML1-FILE-CODE.
034900     MOVE MBCA-MERCHANT-ORG      TO MML1-MMFS-ORG.
035000     MOVE MBCA-PROFILE           TO MML1-MMFS-FS-CODE.
035100     MOVE MBCA-SIGNON-NAME       TO MML1-SIGNON-NAME.
035200     MOVE MBCA-TERMINAL-ID       TO MML1-TERMINAL-ID.
035300     MOVE ZEROS                  TO MML1-SOURCE-CODE.
035400*
035500 E020-UPDATE-FIELDS.
035600*
035700************************************************
035800*    DETERMINE THE PLACE IN THE MERCHANT       *
035900*    RECORD FROM WHICH TO BEGIN THE UPDATES    *
036000************************************************
036100*
036200     PERFORM X040-UPDATE-FIELD-ATTRIBUTES
036300                                 THRU X059-UFA-EXIT.
036400*
036500     PERFORM X060-UPDATE-AUDIT-CODES
036600                                 THRU X079-UAC-EXIT.
036700*
036800 E040-UPDATE-MMFS.
036900*
037000     IF  MBCA-PTI-FUNCTION-IS-ADD
037100         MOVE 'Y'                TO WS-UPDATE-SW
037200         MOVE MBCA-SCREEN-NBR    TO MMFS-ONLINE-STATUS
037300         MOVE MBCA-START-DATE    TO MMFS-LAST-MAINT-DATE
037400         MOVE MBCA-OPERATOR-ID   TO MMFS-LAST-MAINT-OPER
037500         IF  MMFS-ONLINE-STATUS IS EQUAL TO MBCA-MAX-SCREEN-NBR
037600             SET MMFS-ADD-COMPLETE
037700                                 TO TRUE
037800             SET MMFS-REC-ACTIVE TO TRUE
037900             MOVE ZEROES         TO MML1-FIELD-CODE
038000                                    MML1-FIELD-OCCURRENCE
038100                                    MML1-FIELD-OCCURRENCE-2
038200             MOVE LENGTH OF MMFS-RECORD
038300                                 TO MML1-VARIABLE-LENGTH
038400             MOVE MMFS-RECORD    TO MML1-ADD-AREA
038500             MOVE 'FC04'         TO MBCA-PROGRAM-LOCATION
038600             PERFORM Y900-WRITE-LOG-RECORD
038700                                 THRU Y919-WLR-EXIT.
038800*
038900**************************************************************
039000*    WRITE A LOG RECORD TO SHOW THAT THE LAST MAINT DATE     *
039100*    AND OPERATOR HAS BEEN UPDATED IF FIELDS WERE CHANGED    *
039200*    ON THE SCREEN                                           *
039300**************************************************************
039400*
039500     IF  MBCA-PTI-FUNCTION-IS-MAINT
039600     AND FIELDS-WERE-UPDATED
039700         MOVE 0198               TO MML1-FIELD-CODE
039800         MOVE ZEROES             TO MML1-FIELD-OCCURRENCE
039900                                    MML1-FIELD-OCCURRENCE-2
040000         MOVE MML1WS-VL-03       TO MML1-VARIABLE-LENGTH
040100         MOVE MMFS-LAST-MAINT-OPER
040200                                 TO MML1-VL03-B-DATA-X
040300         MOVE MBCA-OPERATOR-ID   TO MMFS-LAST-MAINT-OPER
040400         MOVE MMFS-LAST-MAINT-OPER
040500                                 TO MML1-VL03-A-DATA-X
040600         MOVE 'FC05'             TO MBCA-PROGRAM-LOCATION
040700         PERFORM Y900-WRITE-LOG-RECORD
040800                                 THRU Y919-WLR-EXIT
040900         MOVE 0199               TO MML1-FIELD-CODE
041000         MOVE MML1WS-VL-07       TO MML1-VARIABLE-LENGTH
041100         MOVE MMFS-LAST-MAINT-DATE
041200                                 TO MML1-VL07-B-DATA-9
041300         MOVE MBCA-START-DATE    TO MMFS-LAST-MAINT-DATE
041400         MOVE MMFS-LAST-MAINT-DATE
041500                                 TO MML1-VL07-A-DATA-9
041600         MOVE 'FC06'             TO MBCA-PROGRAM-LOCATION
041700         PERFORM Y900-WRITE-LOG-RECORD
041800                                 THRU Y919-WLR-EXIT.
041900*
042000*************************************************
042100*    REWRITE THE FIELD SECURITY RECORD IF       *
042200*    FIELDS HAVE BEEN CHANGED ON THE SCREEN,    *
042300*    OR UNLOCK IT IF THEY HAVE NOT              *
042400*************************************************
042500*
042600     IF  FIELDS-WERE-UPDATED
042700         MOVE 'FC07'             TO MBCA-PROGRAM-LOCATION
042800         SET MBIORO-REWRITE      TO TRUE
042900         PERFORM MMFSAO-ACCESS   THRU MMFSAO-ACCESS-EXIT
043000     ELSE
043100         MOVE 'FC08'             TO MBCA-PROGRAM-LOCATION
043200         SET MBIORO-UNLOCK       TO TRUE
043300         PERFORM MMFSAO-ACCESS   THRU MMFSAO-ACCESS-EXIT.
043400/
043500 F000-SETUP-COMMAREA SECTION.
043600*
043700***************************************************************
043800*  SET UP COMMAREA FIELDS AND TRANSFER TO THE NEXT PROGRAM    *
043900***************************************************************
044000*
044100     MOVE MBCA-EIBAID            TO SS08WS-EIBAID.
044200*
044300     IF  SS08WS-VALID-PF3
044400     OR  SS08WS-EIBAID-VALID-PF3
044500         MOVE 1                  TO MBCA-MBMF-INDEX
044600         MOVE 52                 TO MBCA-SCREEN-NBR
044700         GO TO F020-PF-KEY-BYPASS.
044800*
044900     IF  SS08WS-VALID-PF4
045000     OR  SS08WS-EIBAID-VALID-PF4
045100         COMPUTE MBCA-MBMF-INDEX = MMSMTB-NBR-ELEMENTS - 41
045200         MOVE 52                 TO MBCA-SCREEN-NBR
045300         GO TO F020-PF-KEY-BYPASS.
045400*
045500     IF  SS08WS-VALID-PF5
045600     OR  SS08WS-EIBAID-VALID-PF5
045700         COMPUTE MBCA-MBMF-INDEX = MBCA-MBMF-INDEX + 42
045800         IF  MBCA-MBMF-INDEX IS GREATER THAN WS-MAX-LINES
045900             COMPUTE MBCA-MBMF-INDEX = MMSMTB-NBR-ELEMENTS - 41
046000             MOVE 52             TO MBCA-SCREEN-NBR
046100             GO TO F020-PF-KEY-BYPASS
046200         ELSE
046300             MOVE 52             TO MBCA-SCREEN-NBR
046400             GO TO F020-PF-KEY-BYPASS.
046500*
046600     IF  SS08WS-VALID-PF6
046700     OR  SS08WS-EIBAID-VALID-PF6
046800         IF  MBCA-MBMF-INDEX IS LESS THAN 43
046900             MOVE 1              TO MBCA-MBMF-INDEX
047000             MOVE 52             TO MBCA-SCREEN-NBR
047100             GO TO F020-PF-KEY-BYPASS
047200         ELSE
047300             COMPUTE MBCA-MBMF-INDEX = MBCA-MBMF-INDEX - 42
047400             MOVE 52         TO MBCA-SCREEN-NBR
047500             GO TO F020-PF-KEY-BYPASS.
047600*
047700     PERFORM MB60PD-EDIT-PAGE-NBR
047800                                 THRU MB60PD-EPN-EXIT.
047900*
048000     IF  SS08WS-VALID-PF-KEY
048100     OR  SS08WS-EIBAID-VALID-PF-KEY
048200         MOVE 99                 TO MBCA-SCREEN-NBR.
048300*
048400 F020-PF-KEY-BYPASS.
048500*
048600     MOVE 'PC05'                 TO MBCA-PROGRAM-LOCATION.
048700     PERFORM MB70PD-XCTL-TO-MBOXCTL
048800                                 THRU MB70PD-XTM-EXIT.
048900/
049000 W000-FIELD-EDITS SECTION.
049100*
049200 W040-EDIT-FIELD-ATTRIBUTES.
049300*
049400     SET X-MMSMTB-FIELD          TO MBCA-MBMF-INDEX.
049500     SET X-MF02-FS-ITEM          TO 1.
049600     SET X-MMFS-STORE            TO MBCA-MBMF-INDEX.
049700*
049800 W042-EFA-LOOP.
049900*
050000**************************************************
050100*    SET THE FIELD ATTRIBUTES TO THE STATE IN    *
050200*    WHICH THEY WOULD BE IF ALL EDITS WERE OK    *
050300**************************************************
050400*
050500     MOVE DFHBMDAS               TO MF02-FIELD-DATA-LP-A
050600                                        (X-MF02-FS-ITEM)
050700                                    MF02-FIELD-DATA-RP-A
050800                                        (X-MF02-FS-ITEM).
050900     MOVE DFHBMASK               TO MF02-FIELD-ATTR-A
051000                                        (X-MF02-FS-ITEM).
051100*
051200     IF  MMSMTB-FIELD-NAME (X-MMSMTB-FIELD) IS EQUAL TO SPACES
051300         GO TO W058-INCREMENT-INDEXES.
051400*
051500     MOVE MMSMTB-FIELD-NAME (X-MMSMTB-FIELD)
051600                                 TO MF02-FIELD-NAME
051700                                        (X-MF02-FS-ITEM).
051800*
051900*****************************
052000*    EDIT FOR VALID DATA    *
052100*****************************
052200*
052300     IF  MF02-FIELD-ATTR-L (X-MF02-FS-ITEM) IS EQUAL TO ZERO
052400         MOVE MMFS-ST-FIELD-ATTR (X-MMFS-STORE)
052500                                 TO MF02-FIELD-ATTR
052600                                        (X-MF02-FS-ITEM).
052700*
052800     IF  MF02-FIELD-ATTR (X-MF02-FS-ITEM) IS NOT NUMERIC
052900         GO TO W044-FIELD-ATTR-ERROR.
053000*
053100     MOVE MF02-FIELD-ATTR (X-MF02-FS-ITEM)
053200                                 TO MMFS-ST-FIELD-ATTR
053300                                        (X-MMFS-STORE).
053400*
053500     IF  NOT MMFS-ST-VALID-FIELD-ATTR (X-MMFS-STORE)
053600         GO TO W044-FIELD-ATTR-ERROR
053700     ELSE
053800         MOVE 'N'                TO WS-FIELD-ATTR-ERROR-SW
053900         PERFORM Y800-STORE-FIELD-EXCEPTIONS
054000                                 THRU Y819-SFE-EXIT
054100         IF  FIELD-ATTR-IN-ERROR
054200             GO TO W044-FIELD-ATTR-ERROR
054300         ELSE
054400             MOVE DFHBMASF       TO MF02-FIELD-ATTR-A
054500                                    (X-MF02-FS-ITEM)
054600             GO TO W058-INCREMENT-INDEXES.
054700*
054800 W044-FIELD-ATTR-ERROR.
054900*
055000     MOVE 'Y'                    TO SS08WS-ERROR.
055100     MOVE SS08WS-CURSOR          TO MF02-FIELD-ATTR-L
055200                                        (X-MF02-FS-ITEM).
055300     MOVE DFHBMNBF               TO MF02-FIELD-ATTR-A
055400                                        (X-MF02-FS-ITEM).
055500     MOVE DFHBMASB               TO MF02-FIELD-DATA-LP-A
055600                                        (X-MF02-FS-ITEM)
055700                                    MF02-FIELD-DATA-RP-A
055800                                        (X-MF02-FS-ITEM).
055900*
056000 W058-INCREMENT-INDEXES.
056100*
056200*
056300     IF  X-MF02-FS-ITEM IS LESS THAN 42
056400         SET X-MF02-FS-ITEM      UP BY 1
056500         SET X-MMSMTB-FIELD      UP BY 1
056600         SET X-MMFS-STORE        UP BY 1
056700         GO TO W042-EFA-LOOP.
056800*
056900 W059-EFA-EXIT.
057000     EXIT.
057100*
057200 W060-EDIT-AUDIT-CODES.
057300*
057400     SET X-MMSMTB-FIELD          TO MBCA-MBMF-INDEX.
057500     SET X-MF02-FS-ITEM          TO 1.
057600     SET X-MMFS-STORE            TO MBCA-MBMF-INDEX.
057700*
057800 W062-EAC-LOOP.
057900*
058000**************************************************
058100*    SET THE FIELD ATTRIBUTES TO THE STATE IN    *
058200*    WHICH THEY WOULD BE IF ALL EDITS WERE OK    *
058300**************************************************
058400*
058500     MOVE DFHBMASK               TO MF02-AUDIT-CODE-A
058600                                        (X-MF02-FS-ITEM).
058700*
058800     IF  MMSMTB-FIELD-NAME (X-MMSMTB-FIELD) IS EQUAL TO SPACES
058900         GO TO W078-INCREMENT-INDEXES.
059000*
059100     IF  MF02-AUDIT-CODE-L (X-MF02-FS-ITEM) IS EQUAL TO ZERO
059200         MOVE MMFS-ST-AUDIT-CODE (X-MMFS-STORE)
059300                                 TO MF02-AUDIT-CODE
059400                                        (X-MF02-FS-ITEM)
059500         GO TO W078-INCREMENT-INDEXES.
059600*
059700     MOVE MF02-AUDIT-CODE (X-MF02-FS-ITEM)
059800                                 TO MMFS-ST-AUDIT-CODE
059900                                        (X-MMFS-STORE).
060000     IF  MMFS-ST-VALID-AUDIT-CODE (X-MMFS-STORE)
060100         MOVE DFHBMASF           TO MF02-AUDIT-CODE-A
060200                                        (X-MF02-FS-ITEM)
060300         GO TO W078-INCREMENT-INDEXES.
060400*
060500 W064-AUDIT-CODE-ERROR.
060600*
060700     MOVE 'Y'                    TO SS08WS-ERROR.
060800     MOVE SS08WS-CURSOR          TO MF02-AUDIT-CODE-L
060900                                        (X-MF02-FS-ITEM).
061000     MOVE DFHBMUBF               TO MF02-AUDIT-CODE-A
061100                                        (X-MF02-FS-ITEM).
061200     MOVE DFHBMASB               TO MF02-FIELD-DATA-LP-A
061300                                        (X-MF02-FS-ITEM)
061400                                    MF02-FIELD-DATA-RP-A
061500                                        (X-MF02-FS-ITEM).
061600*
061700 W078-INCREMENT-INDEXES.
061800*
061900     IF  X-MF02-FS-ITEM IS LESS THAN 42
062000         SET X-MMFS-STORE        UP BY 1.
062100*
062200     IF  X-MF02-FS-ITEM IS LESS THAN 42
062300         SET X-MMSMTB-FIELD      UP BY 1
062400         SET X-MF02-FS-ITEM      UP BY 1
062500         GO TO W062-EAC-LOOP.
062600*
062700 W079-EAC-EXIT.
062800     EXIT.
062900/
063000 X000-UPDATE-FIELDS SECTION.
063100*
063200 X040-UPDATE-FIELD-ATTRIBUTES.
063300*
063400     SET X-MF02-FS-ITEM          TO 1.
063500*
063600     SET X-MMFS-STORE            TO MBCA-MBMF-INDEX.
063700*
063800 X042-UFA-LOOP.
063900*
064000     IF  MF02-FIELD-ATTR-L (X-MF02-FS-ITEM) IS GREATER THAN ZERO
064100         IF  MF02-FIELD-ATTR (X-MF02-FS-ITEM) IS NOT EQUAL TO
064200             MMFS-ST-FIELD-ATTR (X-MMFS-STORE)
064300             MOVE 'Y'            TO WS-UPDATE-SW
064400             IF  MBCA-PTI-FUNCTION-IS-MAINT
064500                 MOVE 0202       TO MML1-FIELD-CODE
064600                 SET MML1-FIELD-OCCURRENCE
064700                                 TO X-MMFS-STORE
064800                 MOVE ZEROES     TO MML1-FIELD-OCCURRENCE-2
064900                 MOVE MML1WS-VL-01
065000                                 TO MML1-VARIABLE-LENGTH
065100                 MOVE MMFS-ST-FIELD-ATTR (X-MMFS-STORE)
065200                                 TO MML1-VL01-B-DATA-X
065300                 MOVE MF02-FIELD-ATTR    (X-MF02-FS-ITEM)
065400                                 TO MMFS-ST-FIELD-ATTR
065500                                         (X-MMFS-STORE)
065600                 MOVE MMFS-ST-FIELD-ATTR (X-MMFS-STORE)
065700                                 TO MML1-VL01-A-DATA-X
065800                 MOVE 'FC09'     TO MBCA-PROGRAM-LOCATION
065900                 PERFORM Y900-WRITE-LOG-RECORD
066000                                 THRU Y919-WLR-EXIT
066100             ELSE
066200                 MOVE MF02-FIELD-ATTR    (X-MF02-FS-ITEM)
066300                                 TO MMFS-ST-FIELD-ATTR
066400                                         (X-MMFS-STORE).
066500*
066600 X058-INCREMENT-INDEXES.
066700*
066800     IF  X-MF02-FS-ITEM IS LESS THAN 42
066900         SET X-MMFS-STORE        UP BY 1.
067000*
067100     IF  X-MF02-FS-ITEM IS LESS THAN 42
067200         SET X-MF02-FS-ITEM      UP BY 1
067300         GO TO X042-UFA-LOOP.
067400*
067500 X059-UFA-EXIT.
067600     EXIT.
067700*
067800 X060-UPDATE-AUDIT-CODES.
067900*
068000     SET X-MF02-FS-ITEM          TO 1.
068100*
068200     SET X-MMFS-STORE            TO MBCA-MBMF-INDEX.
068300*
068400 X062-UAC-LOOP.
068500*
068600     IF  MF02-AUDIT-CODE-L (X-MF02-FS-ITEM) IS GREATER THAN ZERO
068700         IF  MF02-AUDIT-CODE (X-MF02-FS-ITEM) IS NOT EQUAL TO
068800             MMFS-ST-AUDIT-CODE (X-MMFS-STORE)
068900             MOVE 'Y'            TO WS-UPDATE-SW
069000             IF  MBCA-PTI-FUNCTION-IS-MAINT
069100                 MOVE 0203       TO MML1-FIELD-CODE
069200                 SET MML1-FIELD-OCCURRENCE
069300                                 TO X-MMFS-STORE
069400                 MOVE ZEROES     TO MML1-FIELD-OCCURRENCE-2
069500                 MOVE MML1WS-VL-01
069600                                 TO MML1-VARIABLE-LENGTH
069700                 MOVE MMFS-ST-AUDIT-CODE (X-MMFS-STORE)
069800                                 TO MML1-VL01-B-DATA-X
069900                 MOVE MF02-AUDIT-CODE    (X-MF02-FS-ITEM)
070000                                 TO MMFS-ST-AUDIT-CODE
070100                                         (X-MMFS-STORE)
070200                 MOVE MMFS-ST-AUDIT-CODE (X-MMFS-STORE)
070300                                 TO MML1-VL01-A-DATA-X
070400                 MOVE 'FC11'     TO MBCA-PROGRAM-LOCATION
070500                 PERFORM Y900-WRITE-LOG-RECORD
070600                                 THRU Y919-WLR-EXIT
070700             ELSE
070800                 MOVE MF02-AUDIT-CODE    (X-MF02-FS-ITEM)
070900                                 TO MMFS-ST-AUDIT-CODE
071000                                         (X-MMFS-STORE).
071100*
071200 X078-INCREMENT-INDEXES.
071300*
071400     IF  X-MF02-FS-ITEM IS LESS THAN 42
071500         SET X-MMFS-STORE        UP BY 1.
071600*
071700     IF  X-MF02-FS-ITEM IS LESS THAN 42
071800         SET X-MF02-FS-ITEM      UP BY 1
071900         GO TO X062-UAC-LOOP.
072000*
072100 X079-UAC-EXIT.
072200     EXIT.
072300/
072400 Y000-PERFORMED-ROUTINES SECTION.
072500*
072600 Y040-MOVE-FIELD-ATTRIBUTES.
072700*
072800     SET X-MMSMTB-FIELD          TO MBCA-MBMF-INDEX.
072900     SET X-MF02-FS-ITEM          TO 1.
073000     SET X-MMFS-STORE            TO MBCA-MBMF-INDEX.
073100*
073200***************************************************
073300*    MOVE THE FIELD TITLES FROM THE TABLE AND     *
073400*    FIELD ATTRIBUTES FROM THE RECORD TO THE      *
073500*    SCREEN                                       *
073600***************************************************
073700*
073800 Y042-MFA-LOOP.
073900*
074000     IF  MMSMTB-FIELD-NAME (X-MMSMTB-FIELD) IS EQUAL TO SPACES
074100         MOVE DFHBMDAS           TO MF02-FIELD-NAME-A
074200                                        (X-MF02-FS-ITEM)
074300                                    MF02-FIELD-ATTR-A
074400                                        (X-MF02-FS-ITEM)
074500                                    MF02-FIELD-DATA-LP-A
074600                                        (X-MF02-FS-ITEM)
074700                                    MF02-FIELD-DATA-RP-A
074800                                        (X-MF02-FS-ITEM)
074900         GO TO Y058-INCREMENT-INDEXES.
075000*
075100     MOVE MMSMTB-FIELD-NAME  (X-MMSMTB-FIELD)
075200                                 TO MF02-FIELD-NAME
075300                                        (X-MF02-FS-ITEM).
075400*
075500     MOVE MMFS-ST-FIELD-ATTR (X-MMFS-STORE)
075600                                 TO MF02-FIELD-ATTR
075700                                        (X-MF02-FS-ITEM).
075800*
075900********************************************
076000*    DARKEN THE PARENS AND BRIGHTEN THE    *
076100*    DATA ELEMENTS IF IN INQUIRY           *
076200********************************************
076300*
076400     IF  MBCA-PTI-FUNCTION-IS-INQUIRY
076500         MOVE DFHBMASB           TO MF02-FIELD-ATTR-A
076600                                        (X-MF02-FS-ITEM)
076700         MOVE DFHBMDAS           TO MF02-FIELD-DATA-LP-A
076800                                        (X-MF02-FS-ITEM)
076900                                    MF02-FIELD-DATA-RP-A
077000                                        (X-MF02-FS-ITEM).
077100*
077200 Y058-INCREMENT-INDEXES.
077300*
077400     IF  X-MF02-FS-ITEM IS LESS THAN 42
077500         SET X-MMFS-STORE        UP BY 1.
077600*
077700     IF  X-MF02-FS-ITEM IS LESS THAN 42
077800         SET X-MMSMTB-FIELD      UP BY 1
077900         SET X-MF02-FS-ITEM      UP BY 1
078000         GO TO Y042-MFA-LOOP.
078100*
078200 Y059-MFA-EXIT.
078300     EXIT.
078400*
078500 Y060-MOVE-AUDIT-CODES.
078600*
078700     SET X-MMSMTB-FIELD          TO MBCA-MBMF-INDEX.
078800     SET X-MF02-FS-ITEM          TO 1.
078900     SET X-MMFS-STORE            TO MBCA-MBMF-INDEX.
079000*
079100 Y062-MAC-LOOP.
079200*
079300     IF  MMSMTB-FIELD-NAME (X-MMSMTB-FIELD) IS EQUAL TO SPACES
079400         MOVE DFHBMDAS           TO MF02-AUDIT-CODE-A
079500                                        (X-MF02-FS-ITEM)
079600         GO TO Y078-INCREMENT-INDEXES.
079700*
079800     MOVE MMFS-ST-AUDIT-CODE (X-MMFS-STORE)
079900                                 TO MF02-AUDIT-CODE
080000                                        (X-MF02-FS-ITEM).
080100*
080200********************************************
080300*    DARKEN THE PARENS AND BRIGHTEN THE    *
080400*    DATA ELEMENTS IF IN INQUIRY           *
080500********************************************
080600*
080700     IF  MBCA-PTI-FUNCTION-IS-INQUIRY
080800         MOVE DFHBMASB           TO MF02-AUDIT-CODE-A
080900                                        (X-MF02-FS-ITEM).
081000*
081100 Y078-INCREMENT-INDEXES.
081200*
081300     IF  X-MF02-FS-ITEM IS LESS THAN 42
081400         SET X-MMFS-STORE        UP BY 1.
081500*
081600     IF  X-MF02-FS-ITEM IS LESS THAN 42
081700         SET X-MMSMTB-FIELD      UP BY 1
081800         SET X-MF02-FS-ITEM      UP BY 1
081900         GO TO Y062-MAC-LOOP.
082000*
082100 Y079-MAC-EXIT.
082200     EXIT.
082300*
082400 Y800-STORE-FIELD-EXCEPTIONS.
082500*
082600****************************************************************
082700*    PRIMARY NAME LINE 1 MUST BE REQUIRED IN ADD MODE          *
082800****************************************************************
082900*
083000     MOVE MMSMTB-PRIM-ADDR1 (1:4)
083100                               TO WS-INDEX-X.
083200*
083300     IF  X-MMFS-STORE IS EQUAL TO WS-INDEX
083400         IF  MMFS-ST-REQUIRED (X-MMFS-STORE)
083500             GO TO Y819-SFE-EXIT
083600         ELSE
083700             MOVE 'Y'            TO WS-FIELD-ATTR-ERROR-SW
083800             GO TO Y819-SFE-EXIT.
083900*
084000****************************************************************
084100*    PRIMARY POSTAL CODE MUST BE REQUIRED IN ADD MODE          *
084200****************************************************************
084300*
084400     MOVE MMSMTB-PRIM-POSTAL-CODE (1:4)
084500                               TO WS-INDEX-X.
084600*
084700     IF  X-MMFS-STORE IS EQUAL TO WS-INDEX
084800         IF  MMFS-ST-REQUIRED (X-MMFS-STORE)
084900             GO TO Y819-SFE-EXIT
085000         ELSE
085100             MOVE 'Y'            TO WS-FIELD-ATTR-ERROR-SW
085200             GO TO Y819-SFE-EXIT.
085300*
085400****************************************************************
085500*    MERCHANT ID  CODE MUST BE REQUIRED IN ADD MODE            *
085600****************************************************************
085700*
085800     MOVE MMSMTB-MERCHANT-ID (1:4)
085900                               TO WS-INDEX-X.
086000*
086100     IF  X-MMFS-STORE IS EQUAL TO WS-INDEX
086200         IF  MMFS-ST-REQUIRED (X-MMFS-STORE)
086300             GO TO Y819-SFE-EXIT
086400         ELSE
086500             MOVE 'Y'            TO WS-FIELD-ATTR-ERROR-SW
086600             GO TO Y819-SFE-EXIT.
086700*
086800 Y819-SFE-EXIT.
086900     EXIT.
087000*
087100 Y900-WRITE-LOG-RECORD.
087200*
087300     SET MBIORO-WRITE            TO TRUE.
087400     PERFORM MML1AO-ACCESS       THRU MML1AO-ACCESS-EXIT.
087500     MOVE SPACES                 TO MML1-VARIABLE-AREA.
087600*
087700 Y919-WLR-EXIT.
087800     EXIT.
087900/
088000 Z000-COPIED-ROUTINES SECTION.
088100*
088200**********************************
088300*    JUL TO GREG DATE ROUTINE    *
088400**********************************
088500*
088600     COPY SS08PD.
088700/
088800**********************************
088900*    DATE AND TIME EDIT ROUTINES *
089000**********************************
089100*
089200     COPY SS26PD.
089300     COPY SS27PD.
089400/
089500*********************************
089600*    LINE 24 PF KEYS ROUTINE    *
089700*********************************
089800*
089900     COPY SS15PD.
090000/
090100***********************************************
090200*    FIELD SECURITY RECORD ACCESS ROUTINES    *
090300***********************************************
090400*
090500     COPY MMFSAO.
090600/
090700*****************************************
090800*    LOG FILE RECORD ACCESS ROUTINES    *
090900*****************************************
091000*
091100     COPY MML1AO.
091200/
091300*****************************
091400*    ONLINE MAP ROUTINES    *
091500*****************************
091600*
091700     COPY MB60PD REPLACING 'MBMAPXX' BY 'MBMF02 '
091800                           MBMAPXXI BY MBMF02I
091900                           MBMAPXXO BY MBMF02O.
092000/
092100***************************
092200*    ONLINE PROCEDURES    *
092300***************************
092400*
092500     COPY MB70PD.
092600/
092700     COPY SMFTPXO.
