000100 IDENTIFICATION DIVISION.
000200 PROGRAM-ID. MBOMG00.
000201*       RELEASE DATE=08/24/01.        REVISION LEVEL=08.06      *
000202*****************************************************************
000203*WARNING.  THIS COMPUTER PROGRAM IS PROTECTED BY COPYRIGHT LAW  *
000204*AND INTERNATIONAL TREATIES.  UNAUTHORIZED REPRODUCTION OR      *
000205*DISTRIBUTION OF THIS PROGRAM, OR ANY PORTION OF IT, MAY RESULT *
000206*IN SEVERE CIVIL AND CRIMINAL PENATLIES, AND WILL BE PROSECUTED *
000207*TO THE MAXIMUM EXTENT POSSIBLE UNDER THE LAW.                  *
000208*COPYRIGHT 1999 PAYSYS INTERNATIONAL, INC.  ALL RIGHTS RESERVED.*
000209*****************************************************************
000300*****************************************************************
000400*                                                               *
000500*   V - PLUS  M E R C H A N T   B A N K C A R D   S Y S T E M   *
000600*                                                               *
000700*      MBOMG00 - STORE CHAIN DEFINITION ADD/MAINT/INQ           *
000800*                LOCATE SCREEN 00                               *
000900*                                                               *
001000*              1. TRANSIDS                                      *
001100*                 A. MBAG                                       *
001200*                 B. MBMG                                       *
001300*                 C. MBQG                                       *
001400*              2. MAPS USED -                                   *
001500*                 A. MBMG00 (LOCATE MAP)                        *
001600*              3. FILES USED -                                  *
001700*                 A. MMOC (ORG CONTROL FILE)                    *
001800*                 B. MMSR (STORE RELATIONSHIP CONTROL)          *
001900*                 C. MMSD (STORE RELATIONSHIP DETAIL)           *
002000*                                                               *
002100*****************************************************************
002200*
002300 ENVIRONMENT DIVISION.
002400*
002500 DATA DIVISION.
002600*
002700 WORKING-STORAGE SECTION.
002800*
002900 01  FILLER                  PIC  X(12)      VALUE
003000     '** WS-BEG **'.
003100*
003200 01  FILLER                  PIC  X(14)      VALUE
003300     'MISCELLANEOUS:'.
003400*
003500 01  WS-MISCELLANEOUS.
003600     03  WS-ORG-LOW          PIC S9(03)      COMP-3
003700                                             VALUE +001.
003800     03  WS-ORG-HIGH         PIC S9(03)      COMP-3
003900                                             VALUE +998.
004000     03  TS-QUEUE-NAME.
004100         05  TS-QN-TERMID    PIC  X(04)      VALUE SPACES.
004200         05  TS-QN-TRANID    PIC  X(04)      VALUE 'MBUI'.
004300/
004400 01  FILLER                  PIC  X(29)      VALUE
004500     'I/O REQUEST BLOCK WORK AREAS:'.
004600*
004700     COPY MBIOWS.
004800/
004900 01  FILLER                  PIC  X(18)      VALUE
005000     'I/O REQUEST BLOCK:'.
005100*
005200     COPY MBIORO.
005300/
005400 01  FILLER                  PIC  X(21)      VALUE
005500     'ERROR MESSAGES TABLE:'.
005600*
005700     COPY MBEMWS.
005800/
005900 01  FILLER                  PIC  X(42)      VALUE
006000     'STORE RELATION CONTROL INITIALIZER RECORD:'.
006100*
006200     COPY MMSRIR.
006300/
006400 01  FILLER                  PIC  X(41)      VALUE
006500     'STORE RELATION DETAIL INITIALIZER RECORD:'.
006600*
006700     COPY MMSDIR REPLACING ==:MMSD:== BY ==MMSD==.
006800/
006900 01  FILLER                  PIC  X(20)      VALUE
007000     'CCS DATE WORK AREAS:'.
007100*
007200     COPY SS01WS.
007300/
007400 01  FILLER                  PIC  X(15)      VALUE
007500     'CCS WORK AREAS:'.
007600*
007700     COPY SS08WS.
007800/
007900     COPY SS00WS.
008000/
008100     COPY SMFTWS.
008200/
008300     COPY SMPTRL REPLACING ==:SMPT:== BY ==SMPT==.
008400/
008500     COPY MB61LK.
008600/
008700 01  FILLER                  PIC  X(12)      VALUE
008800     '** WS-END **'.
008900/
009000 LINKAGE SECTION.
009100*
009200 01  DFHCOMMAREA.
009300*
009400     COPY MB60WS.
009500/
009600******************************************
009700*    STORE RELATIONSHIP LOCATE MAP       *
009800******************************************
009900*
010000     COPY MBMG00.
010100/
010200*******************************************************
010300*    STORE RELATIONSHIP LOCATE MAP REDEFINITION       *
010400*******************************************************
010500*
010600     COPY MBMG00R.
010700/
010800***************************
010900*    ORG RECORD LAYOUT    *
011000***************************
011100*
011200     COPY MMOCRL.
011300/
011400*****************************************************
011500*    STORE RELATIONSHIP CONTROL RECORD LAYOUT       *
011600*****************************************************
011700*
011800     COPY MMSRRL.
011900/
012000****************************************************
012100*    STORE RELATIONSHIP DETAIL RECORD LAYOUT       *
012200****************************************************
012300*
012400     COPY MMSDRL REPLACING ==:MMSD:== BY ==MMSD==.
012500/
012600***************************************
012700*    USER INPUT TEMP STORAGE RECORD   *
012800***************************************
012900*
013000     COPY MBUITS.
013100/
013200 PROCEDURE DIVISION.
013300*
013400 A000-HOUSEKEEPING SECTION.
013500*
013600 A020-INIT.
013700*
013800     MOVE 'PC01'                 TO MBCA-PROGRAM-LOCATION.
013900     PERFORM MB70PD-ON-LINE-HOUSEKEEPING
014000                                 THRU MB70PD-OLH-EXIT.
014100*
014200     IF  MBCA-MBUI-UI-YES
014300         NEXT SENTENCE
014400     ELSE
014500         SET MBCA-MBUI-UI-NO     TO TRUE.
014600*
014700     MOVE MBCA-TERMINAL-ID       TO TS-QN-TERMID.
014800*
014900     IF  MBCA-RECEIVE-SCREEN
015000         GO TO C000-RECEIVE-SCREEN.
015100/
015200 B000-SEND-SCREEN SECTION.
015300*
015400*********************************************
015500*    GET CICS STORAGE NEEDED FOR THE MAP    *
015600*********************************************
015700*
015800     MOVE 'SC01'                 TO MBCA-PROGRAM-LOCATION.
015900     PERFORM MB60PD-GETMAIN-FOR-MAP
016000                                 THRU MB60PD-GFM-EXIT.
016100*
016200*****************************************************************
016300*    CHECK KEY CODES                                            *
016400* 1. IF ADD FUNCTION, BYPASS CHECK OF KEY CODES.                *
016500* 2. IF INITIAL KEY CODE, BYPASS CHECK OF KEY CODES.            *
016600* 3. IF MMSR KEY CODE, IT MUST HAVE AN ORGANIZATION NUMBER      *
016700*    GREATER THAN ZERO AND A VALID CHAIN.    IF                 *
016800*    DIRECT, GO TO THE RECEIVE EDITING ROUTINE SINCE WE HAVE    *
016900*    PLUGGED THE ORGANIZATION AND CHAIN IN THE MAP.    IF AN    *
017000*    ERROR OCCURS IN THE RECEIVE SCREEN ROUTINE, IT WILL        *
017100*    HANDLE BUILDING THE MAP AND IT WILL SEND ITS OWN SCREEN.   *
017200*    THIS IS WHY LOCATE PROGRAMS ALWAYS SEND WITH ERASE         *
017300*    NO MATTER WHICH ROUTINE YOU ARE IN.  IF NOT DIRECT, PLUG   *
017400*    THE ORGANIZATION AND CHAIN INTO THE MAP AND BYPASS         *
017500*    ANY OTHER CHECKING OF THE KEY CODE.                        *
017600* 4. IF 2 AND 3 ARE FALSE, SEE IF THE MBCA-MERCHANT-ORG IS      *
017700*    GREATER THAN ZERO.  IF IT IS, PLUG IT INTO THE MAP.  IF    *
017800*    THE MBCA-S-CHAIN IS GREATER THAN LOW-VALUE, PLUG IT INTO   *
017900*    THE MAP.                                                   *
018000*****************************************************************
018100*
018200     IF  MBCA-INITIAL-KEY-CODE
018300     OR  MBCA-PTI-FUNCTION-IS-ADD
018400         GO TO B020-BUILD-SCREEN.
018500*
018600     IF  MBCA-MMSR-KEY-CODE
018700         IF  MBCA-MERCHANT-ORG IS GREATER THAN ZERO
018800         AND MBCA-S-CHAIN       IS GREATER THAN LOW-VALUE
018900             MOVE MBCA-MERCHANT-ORG
019000                                 TO MG00-ORG
019100             MOVE MBCA-S-CHAIN   TO MG00-CHAIN
019200             MOVE DFHBMUNF       TO MG00-ORG-A
019300                                    MG00-CHAIN-A
019400             IF  MBCA-DIRECT-TRANSFER-CODE
019500             AND MBCA-INITIAL-SCREEN-NBR
019600                 MOVE 00         TO MBCA-SCREEN-NBR
019700                 GO TO C082-READ-ORG
019800             ELSE
019900                 GO TO B020-BUILD-SCREEN.
020000*
020100     IF  MBCA-VALID-KEY-CODES
020200         IF  MBCA-MERCHANT-ORG IS GREATER THAN ZERO
020300             MOVE MBCA-MERCHANT-ORG
020400                                 TO MG00-ORG
020500             MOVE DFHBMUNF       TO MG00-ORG-A
020600             IF  MBCA-S-CHAIN IS GREATER THAN LOW-VALUE
020700                 MOVE MBCA-S-CHAIN
020800                                 TO MG00-CHAIN
020900                 MOVE DFHBMUNF   TO MG00-CHAIN-A.
021000*
021100 B020-BUILD-SCREEN.
021200*
021300*******************************************
021400*    INITIALIZE THE STANDARD MAP LINES    *
021500*******************************************
021600*
021700     MOVE SS08WS-CURSOR          TO MG00-ORG-L.
021800     MOVE 00                     TO MBCA-SCREEN-NBR.
021900     PERFORM MB60PD-INIT-STD-MAP-LINES
022000                                 THRU MB60PD-ISML-EXIT.
022100*
022200     IF  MBCA-PTI-FUNCTION-MAINT-OR-INQ
022300         IF  MBCA-MERCHANT-ORG IS GREATER THAN ZEROS
022400             MOVE MBCA-MERCHANT-ORG
022500                                 TO MG00-ORG
022600             MOVE DFHBMUNF       TO MG00-ORG-A
022700             IF  MBCA-S-CHAIN IS GREATER THAN ZEROS
022800                 MOVE MBCA-S-CHAIN TO MG00-CHAIN
022900                 MOVE DFHBMUNF   TO MG00-CHAIN-A.
023000*
023100**********************
023200*    SEND THE MAP    *
023300**********************
023400*
023500     MOVE 'BM01'                 TO MBCA-PROGRAM-LOCATION.
023600     PERFORM MB60PD-SEND-MAP-WITH-ERASE
023700                                 THRU MB60PD-SMWE-EXIT.
023800*
023900************************
024000*    RETURN TO CICS    *
024100************************
024200*
024300     MOVE 'PC02'                 TO MBCA-PROGRAM-LOCATION.
024400     PERFORM MB70PD-RETURN-TRANS-ID
024500                                 THRU MB70PD-RTI-EXIT.
024600/
024700 C000-RECEIVE-SCREEN SECTION.
024800*
024900*************************************************
025000*    THIS SECTION RECEIVES THE LOCATE SCREEN    *
025100*************************************************
025200*
025300     IF  MBCA-MBUI-UI-YES
025400*
025500****************************************************************
025600*    ACQUIRE MAIN STORAGE FOR TEMP STORAGE RECORD              *
025700****************************************************************
025800*
025900         MOVE 'TS01'             TO MBCA-PROGRAM-LOCATION
026000         EXEC CICS GETMAIN
026100                   FLENGTH (LENGTH  OF MBUITS-RECORD)
026200
026300                   SET     (ADDRESS OF MBUITS-RECORD)
026400
026500              END-EXEC
026600*
026700*
026800***********************************************
026900*    READ THE TEMP STORAGE RECORD             *
027000***********************************************
027100*
027200         MOVE 'TS02'             TO MBCA-PROGRAM-LOCATION
027300*
027400         EXEC CICS READQ TS
027500                   QUEUE   (TS-QUEUE-NAME)
027600                   INTO    (MBUITS-RECORD)
027700                   LENGTH  (LENGTH  OF MBUITS-RECORD)
027800                   ITEM    (1)
027900              END-EXEC
028000*
028100***********************************************
028200*    DELETE THE TEMP STORAGE RECORD           *
028300***********************************************
028400*
028500         MOVE 'TS03'             TO MBCA-PROGRAM-LOCATION
028600*
028700         EXEC CICS IGNORE CONDITION
028800                   QIDERR
028900              END-EXEC
029000*
029100         EXEC CICS DELETEQ TS
029200                   QUEUE  (TS-QUEUE-NAME)
029300              END-EXEC
029400         MOVE 'SC02'             TO MBCA-PROGRAM-LOCATION
029500         PERFORM MB60PD-GETMAIN-FOR-MAP
029600                                 THRU MB60PD-GFM-EXIT
029700         MOVE MBUITS-VAR-DATA    TO MBMG00I
029800     ELSE
029900         MOVE 'BM02'             TO MBCA-PROGRAM-LOCATION
030000         PERFORM MB60PD-RECEIVE-MAP
030100                                 THRU MB60PD-RM-EXIT.
030200*
030300**************************************************************
030400*    CHECK FOR ANOTHER TRANSACTION ID ENTERED BY THE USER    *
030500**************************************************************
030600*
030700     MOVE 'PC03'                 TO MBCA-PROGRAM-LOCATION.
030800     PERFORM MB60PD-NEW-TRANS-ROUTINE
030900                                 THRU MB60PD-NTR-EXIT.
031000*
031100 C020-EDIT-SCREEN.
031200*
031300     SET SS08WS-ERROR-SW-NO      TO TRUE.
031400     MOVE MBCA-EIBAID            TO SS08WS-EIBAID.
031500*
031600     IF  ((MG00-ORG-L IS LESS THAN 1
031700     AND  MG00-CHAIN-L IS LESS THAN 1
031800     AND  SS08WS-VALID-PF-KEY)
031900     OR   SS08WS-EIBAID-VALID-PF-KEY)
032000         SET MBCA-INITIAL-SCREEN-NBR
032100                                 TO TRUE
032200         GO TO F090-TRANSFER-XCTL.
032300*
032400******************************************************
032500*    RESET THE FIELD ARRIBUTES TO THEIR NORMAL       *
032600*    PRIOR STATE PRIOR TO ANY EDITING BEING DONE.    *
032700******************************************************
032800*
032900     MOVE DFHBMUNN               TO MG00-ORG-A
033000                                    MG00-CHAIN-A.
033100     MOVE DFHBMASK               TO MG00-ORG-LP-A
033200                                    MG00-ORG-RP-A
033300                                    MG00-CHAIN-LP-A
033400                                    MG00-CHAIN-RP-A.
033500*
033600 C080-EDIT-ORG.
033700*
033800     IF  MG00-ORG-L IS EQUAL TO ZERO
033900     OR  MG00-ORG IS NOT NUMERIC
034000     OR  MG00-ORG IS LESS THAN MBCA-ORG-LOW
034100     OR  MG00-ORG IS GREATER THAN MBCA-ORG-HIGH
034200     OR  MG00-ORG IS LESS THAN WS-ORG-LOW
034300     OR  MG00-ORG IS GREATER THAN WS-ORG-HIGH
034400         MOVE MBEMWS-INVALID-ORG TO MG00-ERR-MESSAGE
034500         GO TO C098-ORG-ERROR.
034600*
034700 C082-READ-ORG.
034800*
034900************************************************
035000*    READ THE ORGANIZATION RECORD.  IT MUST    *
035100*    BE ON FILE AND AN ACTIVE RECORD.          *
035200************************************************
035300*
035400     MOVE MG00-ORG               TO MBIOWS-MMOC-ORG.
035500     MOVE 'FC01'                 TO MBCA-PROGRAM-LOCATION.
035600     MOVE SS08WS-CICS-FC-NOTFND  TO MBIORO-TEMP-STATUS-1.
035700     SET MBIORO-READ-RANDOM      TO TRUE.
035800     PERFORM MMOCAO-ACCESS       THRU MMOCAO-ACCESS-EXIT.
035900*
036000     IF  SS08WS-RC-FC-NOTFND
036100         MOVE MBEMWS-NOT-ON-FILE TO MG00-ERR-MESSAGE
036200     ELSE
036300         IF  MMOC-ADD-PENDING
036400             MOVE MBEMWS-ADD-PENDING
036500                                 TO MG00-ERR-MESSAGE
036600         ELSE
036700             IF  MMOC-REC-PURGED
036800                 MOVE MBEMWS-REC-PURGED
036900                                 TO MG00-ERR-MESSAGE
037000             ELSE
037100                 MOVE DFHBMUNF   TO MG00-ORG-A
037200                 MOVE MG00-ORG   TO MBCA-MERCHANT-ORG
037300                 GO TO C100-EDIT-CHAIN.
037400*
037500 C098-ORG-ERROR.
037600*
037700     SET SS08WS-ERROR-SW-YES     TO TRUE.
037800     MOVE DFHBMASB               TO MG00-ORG-LP-A
037900                                    MG00-ORG-RP-A.
038000     MOVE SS08WS-CURSOR          TO MG00-ORG-L.
038100     MOVE DFHBMNBF               TO MG00-ORG-A
038200                                    MG00-CHAIN-A.
038300     GO TO D000-RETURN-ERRORS.
038400*
038500 C100-EDIT-CHAIN.
038600*
038700***********************************************************
038800*    THE LENGTH FIELD COULD BE CHECKED HERE TO            *
038900*    SEE IF ANYTHING WAS KEYED.                           *
039000***********************************************************
039100*
039200     IF  MG00-CHAIN IS EQUAL TO ZEROS
039300     OR  MG00-CHAIN IS NOT NUMERIC
039400     OR  MG00-CHAIN IS EQUAL TO ZEROS OR 999999999
039500         MOVE MBEMWS-INVALID-CHAIN
039600                                 TO MG00-ERR-MESSAGE
039700         GO TO C118-CHAIN-ERROR.
039800*
039900 C102-READ-CHAIN.
040000*
040100***************************************************************
040200*    READ THE CHAIN RECORD.    IT MUST BE ON FILE AND         *
040300*    AN ACTIVE RECORD IF IN MAINTENANCE OR INQUIRY.  IT MUST  *
040400*    NOT BE ON FILE (OR IN AN ADD PENDING STATE), IF IN ADD.  *
040500***************************************************************
040600*
040700     MOVE MG00-ORG               TO MBIOWS-MMSR-ORG.
040800     MOVE MG00-CHAIN             TO MBIOWS-MMSR-CHAIN.
040900     MOVE SS08WS-CICS-FC-NOTFND  TO MBIORO-TEMP-STATUS-1.
041000     MOVE 'FC02'                 TO MBCA-PROGRAM-LOCATION.
041100     SET MBIORO-READ-RANDOM      TO TRUE.
041200     PERFORM MMSRAO-ACCESS       THRU MMSRAO-ACCESS-EXIT.
041300*
041400     IF  SS08WS-RC-FC-VALID-RTN-CODE
041500         MOVE MG00-CHAIN         TO MBCA-S-CHAIN.
041600*
041700     IF  MBCA-PTI-FUNCTION-IS-INQUIRY
041800         IF  SS08WS-RC-FC-VALID-RTN-CODE
041900             IF  MMSR-ADD-PENDING
042000                 MOVE MBEMWS-ADD-PENDING
042100                                 TO MG00-ERR-MESSAGE
042200                 GO TO C118-CHAIN-ERROR
042300             ELSE
042400                 GO TO F000-SETUP-COMMAREA
042500         ELSE
042600             MOVE MBEMWS-NOT-ON-FILE
042700                                 TO MG00-ERR-MESSAGE
042800             GO TO C118-CHAIN-ERROR.
042900*
043000     IF  MBCA-PTI-FUNCTION-IS-ADD
043100     AND SS08WS-RC-FC-NOTFND
043200         GO TO E000-UPDATE-FILE.
043300*
043400     IF  MBCA-PTI-FUNCTION-IS-ADD
043500     AND MMSR-ADD-PENDING
043600         MOVE MMSR-ONLINE-STATUS
043700                                 TO MBCA-SCREEN-NBR
043800         GO TO F000-SETUP-COMMAREA.
043900*
044000     IF  MBCA-PTI-FUNCTION-IS-ADD
044100         MOVE MBEMWS-ALREADY-ON-FILE
044200                                 TO MG00-ERR-MESSAGE
044300         GO TO C118-CHAIN-ERROR.
044400*
044500     IF  MBCA-PTI-FUNCTION-IS-MAINT
044600     AND SS08WS-RC-FC-NOTFND
044700         MOVE MBEMWS-NOT-ON-FILE TO MG00-ERR-MESSAGE
044800         GO TO C118-CHAIN-ERROR.
044900*
045000     IF  MBCA-PTI-FUNCTION-IS-MAINT
045100     AND MMSR-ADD-PENDING
045200         MOVE MBEMWS-ADD-PENDING TO MG00-ERR-MESSAGE
045300         GO TO C118-CHAIN-ERROR.
045400*
045500     IF  MBCA-PTI-FUNCTION-IS-MAINT
045600     AND MMSR-REC-PURGED
045700         MOVE MBEMWS-REC-PURGED  TO MG00-ERR-MESSAGE
045800         GO TO C118-CHAIN-ERROR.
045900*
046000***********************************************
046100*    OTHERWISE, WE PASSED THE CHAIN EDIT      *
046200***********************************************
046300*
046400     GO TO F000-SETUP-COMMAREA.
046500*
046600 C118-CHAIN-ERROR.
046700*
046800     SET SS08WS-ERROR-SW-YES     TO TRUE.
046900     MOVE DFHBMASB               TO MG00-CHAIN-LP-A
047000                                    MG00-CHAIN-RP-A.
047100     MOVE SS08WS-CURSOR          TO MG00-CHAIN-L.
047200     MOVE DFHBMNBF               TO MG00-CHAIN-A.
047300/
047400 D000-RETURN-ERRORS SECTION.
047500*
047600     IF  SS08WS-ERROR-SW-NO
047700         GO TO E000-UPDATE-FILE
047800     ELSE
047900         IF  SS08WS-VALID-PF-KEY
048000         OR  SS08WS-EIBAID-VALID-PF-KEY
048100             SET MBCA-INITIAL-SCREEN-NBR
048200                                 TO TRUE
048300             GO TO F090-TRANSFER-XCTL.
048400*
048500     IF  MBCA-MBUI-UI-YES
048600         MOVE 'MBUI'             TO MBCA-TRANS-ID
048700                                    MBCA-PREV-TRANS-ID
048800         MOVE 01                 TO MBCA-SCREEN-NBR
048900         SET MBCA-MBUI-ERROR-YES TO TRUE
049000         GO TO F090-TRANSFER-XCTL.
049100*
049200***************************************************************
049300*    INITIALIZE THE STANDARD MAP LINES.  IN AN ERROR          *
049400*    CONDITION, THIS ROUTINE IS PERFORMED PRIMARILY           *
049500*    TO UPDATE THE DATE AND TIME ON THE SCREEN.               *
049600***************************************************************
049700*
049800     PERFORM MB60PD-INIT-STD-MAP-LINES
049900                                 THRU MB60PD-ISML-EXIT.
050000*
050100**********************
050200*    SEND THE MAP    *
050300**********************
050400*
050500     MOVE 'BM03'                 TO MBCA-PROGRAM-LOCATION.
050600     PERFORM MB60PD-SEND-MAP-WITH-ERASE
050700                                 THRU MB60PD-SMWE-EXIT.
050800*
050900************************
051000*    RETURN TO CICS    *
051100************************
051200*
051300     MOVE 'PC04'                 TO MBCA-PROGRAM-LOCATION.
051400     PERFORM MB70PD-RETURN-TRANS-ID
051500                                 THRU MB70PD-RTI-EXIT.
051600/
051700 E000-UPDATE-FILE SECTION.
051800*
051900     IF  MBCA-MBUI-UI-YES
052000         SET MBCA-MBUI-ERROR-NO  TO TRUE.
052100*
052200     IF  MBCA-MBUI-UI-YES
052300     AND MBCA-MBUI-UI-UPDATE-NO
052400         GO TO F090-TRANSFER-XCTL.
052500*
052600********************************************************
052700*    WRITE THE NEW SECURITY CHAIN RECORD FROM THE      *
052800*    INITIALIZER RECORD OR FROM THE CHAIN RECORD       *
052900*    THAT IS BEING COPIED.                             *
053000********************************************************
053100*
053200 E020-ADD-NEW-RECORD.
053300*
053400********************************************************
053500*    SET UP THE RECORD.  USE THE INITIALIZER RECORD    *
053600*    (MMSRIR0) AS THE FIELD DEFAULTS.                  *
053700********************************************************
053800*
053900     MOVE MMSRIR-RECORD          TO MMSR-RECORD.
054000     MOVE MG00-ORG               TO MMSR-ORG.
054100     MOVE MG00-CHAIN             TO MMSR-CHAIN.
054200     MOVE MBCA-START-DATE        TO MMSR-LAST-MAINT-DATE.
054300     MOVE MBCA-OPERATOR-ID       TO MMSR-LAST-MAINT-OPER.
054400     MOVE ZERO                   TO MMSR-OCCURRENCE-YEAR (15).
054500*
054600     MOVE 'FC03'                 TO MBCA-PROGRAM-LOCATION.
054700     SET MBIORO-WRITE            TO TRUE.
054800     PERFORM MMSRAO-ACCESS       THRU MMSRAO-ACCESS-EXIT.
054900*
055000     MOVE MG00-CHAIN             TO MBCA-S-CHAIN.
055100/
055200 F000-SETUP-COMMAREA SECTION.
055300*
055400***************************************************************
055500*  SET UP COMMAREA FIELDS AND TRANSFER TO THE NEXT PROGRAM    *
055600***************************************************************
055700*
055800     MOVE MBCA-EIBAID            TO SS08WS-EIBAID.
055900*
056000     MOVE MBIOWS-MMSR-DIRECT-KEY-CODE
056100                                 TO MBCA-KEY-CODE.
056200*
056300     PERFORM MB60PD-EDIT-PAGE-NBR
056400                                 THRU MB60PD-EPN-EXIT.
056500*
056600     IF  SS08WS-VALID-PF-KEY
056700     OR  SS08WS-EIBAID-VALID-PF-KEY
056800         SET MBCA-INITIAL-SCREEN-NBR
056900                                 TO TRUE.
057000*
057100 F090-TRANSFER-XCTL.
057200*
057300     MOVE 'PC05'                 TO MBCA-PROGRAM-LOCATION.
057400*
057500     IF  MBCA-MBUI-UI-YES
057600         MOVE 'MBUI'             TO MBCA-TRANS-ID
057700                                    MBCA-PREV-TRANS-ID
057800         MOVE 01                 TO MBCA-SCREEN-NBR
057900         MOVE MBMG00I            TO MBUITS-VAR-DATA
058000         MOVE LENGTH OF MBMG00I  TO MBUITS-VAR-LENGTH
058100         MOVE 'TS10'             TO MBCA-PROGRAM-LOCATION
058200         EXEC CICS WRITEQ TS
058300                   QUEUE   (TS-QUEUE-NAME)
058400                   FROM    (MBUITS-RECORD)
058500                   LENGTH  (LENGTH  OF MBUITS-RECORD)
058600
058700              END-EXEC.
058800*
058900     PERFORM MB70PD-XCTL-TO-MBOXCTL
059000                                 THRU MB70PD-XTM-EXIT.
059100/
059200 Z000-COPIED-ROUTINES SECTION.
059300*
059400**********************************
059500*    JUL TO GREG DATE ROUTINE    *
059600**********************************
059700*
059800     COPY SS08PD.
059900/
060000**********************************
060100*    DATE AND TIME EDIT ROUTINES *
060200**********************************
060300*
060400     COPY SS26PD.
060500     COPY SS27PD.
060600/
060700*********************************
060800*    LINE 24 PF KEYS ROUTINE    *
060900*********************************
061000*
061100     COPY SS15PD.
061200/
061300*******************************************
061400*    ORG FILE ACCESS ROUTINES             *
061500*******************************************
061600*
061700     COPY MMOCAO.
061800/
061900******************************************************
062000*    STORE RELATIONSHIP RECORD ACCESS ROUTINES       *
062100******************************************************
062200*
062300     COPY MMSRAO.
062400/
062500*****************************
062600*    ONLINE MAP ROUTINES    *
062700*****************************
062800*
062900     COPY MB60PD REPLACING 'MBMAPXX' BY 'MBMG00 '
063000                           MBMAPXXI BY MBMG00I
063100                           MBMAPXXO BY MBMG00O.
063200/
063300***************************
063400*    ONLINE PROCEDURES    *
063500***************************
063600*
063700     COPY MB70PD.
063800/
063900     COPY SMFTPXO.
