000100 IDENTIFICATION DIVISION.
000200 PROGRAM-ID. MBOMI01.
000201*       RELEASE DATE=08/24/01.        REVISION LEVEL=08.06      *
000202*****************************************************************
000203*WARNING.  THIS COMPUTER PROGRAM IS PROTECTED BY COPYRIGHT LAW  *
000204*AND INTERNATIONAL TREATIES.  UNAUTHORIZED REPRODUCTION OR      *
000205*DISTRIBUTION OF THIS PROGRAM, OR ANY PORTION OF IT, MAY RESULT *
000206*IN SEVERE CIVIL AND CRIMINAL PENATLIES, AND WILL BE PROSECUTED *
000207*TO THE MAXIMUM EXTENT POSSIBLE UNDER THE LAW.                  *
000208*COPYRIGHT 1999 PAYSYS INTERNATIONAL, INC.  ALL RIGHTS RESERVED.*
000209*****************************************************************
000300*****************************************************************
000400*                                                               *
000500*   V - PLUS  M E R C H A N T   B A N K C A R D   S Y S T E M   *
000600*                                                               *
000700*      MBOMI01 - ON-LINE MERCHANT INCOME  FACTORS RECORD        *
000800*                ADD/MAINTENANCE/INQUIRY                        *
000900*                SCREEN 01                                      *
001000*                                                               *
001100*              1. TRANSIDS                                      *
001200*                 A. MBAI                                       *
001300*                 B. MBMI                                       *
001400*                 C. MBQI                                       *
001500*              2. MAPS USED -                                   *
001600*                 A. MBMI01 (MAP 01)                            *
001700*              3. FILES USED -                                  *
001800*                 A. MMIF   (MERCHANT INCOME  FACTORS FILE)     *
001900*                 B. MML1   (LOG/JOURNAL FILE)                  *
002000*                                                               *
002100*****************************************************************
002200*
002300 ENVIRONMENT DIVISION.
002400 DATA DIVISION.
002500 WORKING-STORAGE SECTION.
002600 01  FILLER                  PIC  X(12)      VALUE '** WS-BEG **'.
002700*         I/O REQUEST BLOCK WORK AREAS
002800     COPY MBIOWS.
002900/         I/O REQUEST BLOCK
003000     COPY MBIORO.
003100/         LOG/JOURNAL WORK AREAS
003200     COPY MML1WS REPLACING ==:MML1:== BY ==MML1==.
003300/         DATE WORK AREAS
003400     COPY SS01WS.
003500/         ONLINE WORK AREAS
003600     COPY SS08WS.
003700/
003800     COPY SS00WS.
003900/
004000     COPY SMFTWS.
004100/
004200     COPY SMPTRL REPLACING ==:SMPT:== BY ==SMPT==.
004300/
004400     COPY MB61LK.
004500/         CHECK DIGIT WORK FIELDS
004600     COPY SS05WS.
004700/
004800 01  WS-WORK-AREAS.
004900     03  WS-UPDATE-SW        PIC  X(01)      VALUE 'N'.
005000         88  WS-UPDATE-SW-NO                 VALUE 'N'.
005100         88  WS-UPDATE-SW-YES                VALUE 'Y'.
005200 01  FILLER                  PIC  X(12)      VALUE '** WS-END **'.
005300/
005400 LINKAGE SECTION.
005500 01  DFHCOMMAREA.
005600     COPY MB60WS.
005700/         ORG SCREEN 01 MAP DSECT
005800     COPY MBMI01.
005900/         ORG SCREEN 01 MAP REDEFINITION
006000     COPY MBMI01R.
006100/         MERCHANT INCOME  FACTORS RECORD LAYOUT
006200     COPY MMIFRL REPLACING ==:MMIF:== BY ==MMIF==.
006300/         LOG/JOURNAL FILE RECORD LAYOUT
006400     COPY MML1RL REPLACING ==:MML1:== BY ==MML1==.
006500/
006600 PROCEDURE DIVISION.
006700 0000-HOUSEKEEPING SECTION.
006800 0100-INIT.
006900*
007000     MOVE 'PC01'                 TO MBCA-PROGRAM-LOCATION.
007100     PERFORM MB70PD-ON-LINE-HOUSEKEEPING
007200                                 THRU MB70PD-OLH-EXIT.
007300*
007400     IF  MBCA-RECEIVE-SCREEN
007500         GO TO 2000-RECEIVE-SCREEN.
007600/
007700 1000-SEND-SCREEN SECTION.
007800*
007900****************************************************************
008000*    THIS SECTION BUILDS AND SENDS THE 01 SCREEN.              *
008100****************************************************************
008200*
008300****************************************************************
008400*    GET CICS STORAGE NEEDED FOR THE MAP                       *
008500****************************************************************
008600*
008700     MOVE 'SC01'                 TO MBCA-PROGRAM-LOCATION.
008800     PERFORM MB60PD-GETMAIN-FOR-MAP
008900                                 THRU MB60PD-GFM-EXIT.
009000*
009100     MOVE MBCA-MERCHANT-ORG      TO MI01-ORG.
009200     MOVE MBCA-TABLE             TO MI01-TABLE-NBR.
009300     MOVE DFHBMASB               TO MI01-ORG-A
009400                                    MI01-TABLE-NBR-A.
009500     MOVE 01                     TO MBCA-SCREEN-NBR.
009600*
009700****************************************************************
009800*    INITIALIZE THE STANDARD MAP LINES                         *
009900****************************************************************
010000*
010100     PERFORM MB60PD-INIT-STD-MAP-LINES
010200                                 THRU MB60PD-ISML-EXIT.
010300*
010400****************************************************************
010500*    READ THE INCOME  FACTORS FILE                            *
010600****************************************************************
010700*
010800     MOVE 'FC01'                 TO MBCA-PROGRAM-LOCATION.
010900     MOVE MBCA-MERCHANT-ORG      TO MBIOWS-MMIF-ORG.
011000     MOVE MBCA-TABLE             TO MBIOWS-MMIF-TABLE.
011100     SET MBIORO-READ-RANDOM      TO TRUE.
011200     PERFORM MMIFAO-ACCESS       THRU MMIFAO-ACCESS-EXIT.
011300/
011400 1100-BUILD-SCREEN.
011500*
011600****************************************************************
011700*    BUILD THE MAP FROM THE INCOME  RECORD                     *
011800****************************************************************
011900*
012000     MOVE MMIF-TABLE-NAME        TO MI01-TABLE-NAME.
012100     MOVE MMIF-SALES-FEE         TO MI01-SALES.
012200     MOVE MMIF-RETRIEVAL-FEE     TO MI01-RETRIEVAL.
012300     MOVE MMIF-LOCATION-FEE      TO MI01-LOCATION-FEE.
012400     MOVE MMIF-RETURNS-FEE       TO MI01-RETURN.
012500     MOVE MMIF-BULLETIN-FEE      TO MI01-BULLETIN-FEE.
012600     MOVE MMIF-BATCH-HDR-FEE     TO MI01-BATCH-HDR.
012700     MOVE MMIF-STATEMENT-FEE     TO MI01-STATEMENT.
012800     MOVE MMIF-KEYED-FEE         TO MI01-KEYED-TXN.
012900     MOVE MMIF-MEMBERSHIP-FEE    TO MI01-MEMBERSHIP.
013000     MOVE MMIF-SWIPED-FEE        TO MI01-SWIPED-TXN.
013100     MOVE MMIF-USER-INP-FEE      TO MI01-USER-INPUT.
013200     MOVE MMIF-SETUP-FEE         TO MI01-SETUP.
013300     MOVE MMIF-LOCAL-INP-FEE     TO MI01-LOCAL-INPUT.
013400     MOVE MMIF-ADMIN-FEE         TO MI01-ADMINIST.
013500     MOVE MMIF-CHECK-APPR-FEE    TO MI01-CHECK.
013600     MOVE MMIF-ADJ-INPUT-FEE     TO MI01-ADJUSTMENT.
013700     MOVE MMIF-CHGBACK-FEE       TO MI01-CHARGEBACK.
013800     MOVE MMIF-ACH-FEE           TO MI01-ACH-FEE.
013900     MOVE MMIF-POS-1-CAP-FEE     TO MI01-POS-1-CAPTURE.
014000     MOVE MMIF-POS-2-CAP-FEE     TO MI01-POS-2-CAPTURE.
014100     MOVE MMIF-POS-3-CAP-FEE     TO MI01-POS-3-CAPTURE.
014200     MOVE MMIF-IN-STORE-PMT-FEE  TO MI01-IN-STORE-PMT.
014300/
014400****************************************************************
014500*    IF INQUIRY, DARKEN PARENS AND ASKIP FIELDS                *
014600****************************************************************
014700*
014800     MOVE SS08WS-CURSOR          TO MI01-TABLE-NAME-L.
014900*
015000     IF  MBCA-PTI-FUNCTION-IS-INQUIRY
015100         MOVE SS08WS-CURSOR      TO MI01-ALT-TRANID-L
015200         MOVE DFHBMASB           TO MI01-TABLE-NAME-A
015300                                    MI01-SALES-A
015400                                    MI01-RETRIEVAL-A
015500                                    MI01-LOCATION-FEE-A
015600                                    MI01-RETURN-A
015700                                    MI01-BULLETIN-FEE-A
015800                                    MI01-BATCH-HDR-A
015900                                    MI01-STATEMENT-A
016000                                    MI01-KEYED-TXN-A
016100                                    MI01-MEMBERSHIP-A
016200                                    MI01-SWIPED-TXN-A
016300                                    MI01-USER-INPUT-A
016400                                    MI01-SETUP-A
016500                                    MI01-LOCAL-INPUT-A
016600                                    MI01-ADMINIST-A
016700                                    MI01-CHECK-A
016800                                    MI01-ADJUSTMENT-A
016900                                    MI01-CHARGEBACK-A
017000                                    MI01-ACH-FEE-A
017100                                    MI01-POS-1-CAPTURE-A
017200                                    MI01-POS-2-CAPTURE-A
017300                                    MI01-POS-3-CAPTURE-A
017400                                    MI01-IN-STORE-PMT-A
017500         MOVE DFHBMDAS           TO MI01-TABLE-NAME-LP-A
017600                                    MI01-TABLE-NAME-RP-A
017700                                    MI01-SALES-LP-A
017800                                    MI01-SALES-RP-A
017900                                    MI01-RETRIEVAL-LP-A
018000                                    MI01-RETRIEVAL-RP-A
018100                                    MI01-LOCATION-FEE-LP-A
018200                                    MI01-LOCATION-FEE-RP-A
018300                                    MI01-RETURN-LP-A
018400                                    MI01-RETURN-RP-A
018500                                    MI01-BULLETIN-FEE-LP-A
018600                                    MI01-BULLETIN-FEE-RP-A
018700                                    MI01-BATCH-HDR-LP-A
018800                                    MI01-BATCH-HDR-RP-A
018900                                    MI01-STATEMENT-LP-A
019000                                    MI01-STATEMENT-RP-A
019100                                    MI01-KEYED-TXN-LP-A
019200                                    MI01-KEYED-TXN-RP-A
019300                                    MI01-MEMBERSHIP-LP-A
019400                                    MI01-MEMBERSHIP-RP-A
019500                                    MI01-SWIPED-TXN-LP-A
019600                                    MI01-SWIPED-TXN-RP-A
019700                                    MI01-USER-INPUT-LP-A
019800                                    MI01-USER-INPUT-RP-A
019900                                    MI01-SETUP-LP-A
020000                                    MI01-SETUP-RP-A
020100                                    MI01-LOCAL-INPUT-LP-A
020200                                    MI01-LOCAL-INPUT-RP-A
020300                                    MI01-ADMINIST-LP-A
020400                                    MI01-ADMINIST-RP-A
020500                                    MI01-CHECK-LP-A
020600                                    MI01-CHECK-RP-A
020700                                    MI01-ADJUSTMENT-LP-A
020800                                    MI01-ADJUSTMENT-RP-A
020900                                    MI01-CHARGEBACK-LP-A
021000                                    MI01-CHARGEBACK-RP-A
021100                                    MI01-ACH-FEE-LP-A
021200                                    MI01-ACH-FEE-RP-A
021300                                    MI01-POS-1-CAPTURE-LP-A
021400                                    MI01-POS-1-CAPTURE-RP-A
021500                                    MI01-POS-2-CAPTURE-LP-A
021600                                    MI01-POS-2-CAPTURE-RP-A
021700                                    MI01-POS-3-CAPTURE-LP-A
021800                                    MI01-POS-3-CAPTURE-RP-A
021900                                    MI01-IN-STORE-PMT-LP-A
022000                                    MI01-IN-STORE-PMT-RP-A.
022100*
022200     IF  MBCA-PTI-FUNCTION-IS-ADD
022300         MOVE DFHBMDAS           TO MI01-LAST-MAINT-LIT-A
022400                                    MI01-LAST-MAINT-DATE-A
022500                                    MI01-LAST-MAINT-OPER-LIT-A
022600                                    MI01-LAST-MAINT-OPER-A
022700     ELSE
022800         MOVE MMIF-LAST-MAINT-DATE
022900                                 TO SS01WS-JULIAN
023000         PERFORM SS26PD-NUMERICALLY-EDIT-DATE
023100                                 THRU SS26PD-NED-EXIT
023200         MOVE SS01WS-XX-XX-YYYY  TO MI01-LAST-MAINT-DATE
023300         MOVE MMIF-LAST-MAINT-OPER
023400                                 TO MI01-LAST-MAINT-OPER
023500         MOVE DFHBMASB           TO MI01-LAST-MAINT-DATE-A
023600                                    MI01-LAST-MAINT-OPER-A.
023700*
023800****************************************************************
023900*    FORMAT THE MESSAGE LINE                                   *
024000****************************************************************
024100*
024200     IF MI01-ERR-MESSAGE EQUAL TO SPACES OR LOW-VALUES
024300        PERFORM MB06PD-FORMAT-MESSAGE-LINE
024400          THRU MB06PD-FML-EXIT
024500        MOVE SS08WS-FORMATTED-MSG TO MI01-ERR-MESSAGE.
024600*
024700****************************************************************
024800*    SEND THE MAP                                              *
024900****************************************************************
025000*
025100     MOVE 'BM01'                 TO MBCA-PROGRAM-LOCATION.
025200     PERFORM MB60PD-SEND-MAP-WITH-ERASE
025300                                 THRU MB60PD-SMWE-EXIT.
025400*
025500****************************************************************
025600*    RETURN TO CICS                                            *
025700****************************************************************
025800*
025900     MOVE 'PC02'                 TO MBCA-PROGRAM-LOCATION.
026000     PERFORM MB70PD-RETURN-TRANS-ID
026100                                 THRU MB70PD-RTI-EXIT.
026200/
026300 2000-RECEIVE-SCREEN SECTION.
026400*
026500****************************************************************
026600*    THIS SECTION RECEIVES THE 01 SCREEN                       *
026700****************************************************************
026800*
026900     MOVE 'BM02'                 TO MBCA-PROGRAM-LOCATION.
027000     PERFORM MB60PD-RECEIVE-MAP  THRU MB60PD-RM-EXIT.
027100*
027200****************************************************************
027300*    CHECK FOR ANOTHER TRANSACTION ID ENTERED BY THE USER      *
027400****************************************************************
027500*
027600     MOVE 'PC03'                 TO MBCA-PROGRAM-LOCATION.
027700     PERFORM MB60PD-NEW-TRANS-ROUTINE
027800                                 THRU MB60PD-NTR-EXIT.
027900*
028000****************************************************************
028100*    BYPASS EDITS ON INQUIRY                                   *
028200****************************************************************
028300*
028400     IF  MBCA-PTI-FUNCTION-IS-INQUIRY
028500         GO TO 2600-SETUP-COMMAREA.
028600*
028700****************************************************************
028800*    READ THE INCOME  FILE                                     *
028900****************************************************************
029000*
029100     MOVE 'FC02'                 TO MBCA-PROGRAM-LOCATION.
029200     MOVE MBCA-MERCHANT-ORG      TO MBIOWS-MMIF-ORG.
029300     MOVE MBCA-TABLE             TO MBIOWS-MMIF-TABLE.
029400     SET MBIORO-READ-RANDOM      TO TRUE.
029500     PERFORM MMIFAO-ACCESS       THRU MMIFAO-ACCESS-EXIT.
029600*
029700****************************************************************
029800*    EDIT FIELDS                                               *
029900****************************************************************
030000*
030100*            ***** TABLE NAME *****                            *
030200*
030300     IF  MI01-TABLE-NAME-L IS LESS THAN 1
030400         MOVE DFHBMASK           TO MI01-TABLE-NAME-A
030500         MOVE DFHBMDAS           TO MI01-TABLE-NAME-LP-A
030600                                    MI01-TABLE-NAME-RP-A
030700         MOVE MMIF-TABLE-NAME    TO MI01-TABLE-NAME
030800     ELSE
030900         MOVE DFHBMASF           TO MI01-TABLE-NAME-A
031000         MOVE DFHBMDAS           TO MI01-TABLE-NAME-LP-A
031100                                    MI01-TABLE-NAME-RP-A
031200         SET WS-UPDATE-SW-YES    TO TRUE.
031300*
031400*            ***** SALES FEE ******                            *
031500*
031600     IF  MI01-SALES-L IS LESS THAN 1
031700         MOVE DFHBMASK           TO MI01-SALES-A
031800         MOVE DFHBMDAS           TO MI01-SALES-LP-A
031900                                    MI01-SALES-RP-A
032000         MOVE MMIF-SALES-FEE     TO MI01-SALES
032100     ELSE
032200         IF  MI01-SALES IS NUMERIC
032300             MOVE DFHBMASF       TO MI01-SALES-A
032400             MOVE DFHBMDAS       TO MI01-SALES-LP-A
032500                                    MI01-SALES-RP-A
032600             SET WS-UPDATE-SW-YES
032700                                 TO TRUE
032800         ELSE
032900             MOVE DFHBMNBF       TO MI01-SALES-A
033000             MOVE DFHBMASB       TO MI01-SALES-LP-A
033100                                    MI01-SALES-RP-A
033200             MOVE SS08WS-CURSOR  TO MI01-SALES-L
033300             SET SS08WS-ERROR-SW-YES TO TRUE.
033400*
033500*            ***** RETRIEVAL FEE ******                        *
033600*
033700     IF  MI01-RETRIEVAL-L IS LESS THAN 1
033800         MOVE DFHBMASK           TO MI01-RETRIEVAL-A
033900         MOVE DFHBMDAS           TO MI01-RETRIEVAL-LP-A
034000                                    MI01-RETRIEVAL-RP-A
034100         MOVE MMIF-RETRIEVAL-FEE TO MI01-RETRIEVAL
034200     ELSE
034300         IF  MI01-RETRIEVAL IS NUMERIC
034400             MOVE DFHBMASF       TO MI01-RETRIEVAL-A
034500             MOVE DFHBMDAS       TO MI01-RETRIEVAL-LP-A
034600                                    MI01-RETRIEVAL-RP-A
034700             SET WS-UPDATE-SW-YES
034800                                 TO TRUE
034900         ELSE
035000             MOVE DFHBMNBF       TO MI01-RETRIEVAL-A
035100             MOVE DFHBMASB       TO MI01-RETRIEVAL-LP-A
035200                                    MI01-RETRIEVAL-RP-A
035300             MOVE SS08WS-CURSOR  TO MI01-RETRIEVAL-L
035400             SET SS08WS-ERROR-SW-YES TO TRUE.
035500*
035600*            ***** LOCATION FEE ******                         *
035700*
035800     IF  MI01-LOCATION-FEE-L IS LESS THAN 1
035900         MOVE DFHBMASK           TO MI01-LOCATION-FEE-A
036000         MOVE DFHBMDAS           TO MI01-LOCATION-FEE-LP-A
036100                                    MI01-LOCATION-FEE-RP-A
036200         MOVE MMIF-LOCATION-FEE  TO MI01-LOCATION-FEE
036300     ELSE
036400         IF  MI01-LOCATION-FEE IS NUMERIC
036500             MOVE DFHBMASF       TO MI01-LOCATION-FEE-A
036600             MOVE DFHBMDAS       TO MI01-LOCATION-FEE-LP-A
036700                                    MI01-LOCATION-FEE-RP-A
036800             SET WS-UPDATE-SW-YES
036900                                 TO TRUE
037000         ELSE
037100             MOVE DFHBMNBF       TO MI01-LOCATION-FEE-A
037200             MOVE DFHBMASB       TO MI01-LOCATION-FEE-LP-A
037300                                    MI01-LOCATION-FEE-RP-A
037400             MOVE SS08WS-CURSOR  TO MI01-LOCATION-FEE-L
037500             SET SS08WS-ERROR-SW-YES TO TRUE.
037600*
037700*            ***** RETURNS FEE *****                           *
037800*
037900     IF  MI01-RETURN-L IS LESS THAN 1
038000         MOVE DFHBMASK           TO MI01-RETURN-A
038100         MOVE DFHBMDAS           TO MI01-RETURN-LP-A
038200                                    MI01-RETURN-RP-A
038300         MOVE MMIF-RETURNS-FEE   TO MI01-RETURN
038400     ELSE
038500         IF  MI01-RETURN IS NUMERIC
038600             MOVE DFHBMASF       TO MI01-RETURN-A
038700             MOVE DFHBMDAS       TO MI01-RETURN-LP-A
038800                                    MI01-RETURN-RP-A
038900             SET WS-UPDATE-SW-YES
039000                                 TO TRUE
039100         ELSE
039200             MOVE DFHBMNBF       TO MI01-RETURN-A
039300             MOVE DFHBMASB       TO MI01-RETURN-LP-A
039400                                    MI01-RETURN-RP-A
039500             MOVE SS08WS-CURSOR  TO MI01-RETURN-L
039600             SET SS08WS-ERROR-SW-YES TO TRUE.
039700*
039800*            ***** BULLETIN FEE ******                         *
039900*
040000     IF  MI01-BULLETIN-FEE-L IS LESS THAN 1
040100         MOVE DFHBMASK           TO MI01-BULLETIN-FEE-A
040200         MOVE DFHBMDAS           TO MI01-BULLETIN-FEE-LP-A
040300                                    MI01-BULLETIN-FEE-RP-A
040400         MOVE MMIF-BULLETIN-FEE  TO MI01-BULLETIN-FEE
040500     ELSE
040600         IF  MI01-BULLETIN-FEE IS NUMERIC
040700             MOVE DFHBMASF       TO MI01-BULLETIN-FEE-A
040800             MOVE DFHBMDAS       TO MI01-BULLETIN-FEE-LP-A
040900                                    MI01-BULLETIN-FEE-RP-A
041000             SET WS-UPDATE-SW-YES
041100                                 TO TRUE
041200         ELSE
041300             MOVE DFHBMNBF       TO MI01-BULLETIN-FEE-A
041400             MOVE DFHBMASB       TO MI01-BULLETIN-FEE-LP-A
041500                                    MI01-BULLETIN-FEE-RP-A
041600             MOVE SS08WS-CURSOR  TO MI01-BULLETIN-FEE-L
041700             SET SS08WS-ERROR-SW-YES TO TRUE.
041800*
041900*            ***** BATCH HEADER FEE *****                     *
042000*
042100     IF  MI01-BATCH-HDR-L IS LESS THAN 1
042200         MOVE DFHBMASK           TO MI01-BATCH-HDR-A
042300         MOVE DFHBMDAS           TO MI01-BATCH-HDR-LP-A
042400                                    MI01-BATCH-HDR-RP-A
042500         MOVE MMIF-BATCH-HDR-FEE TO MI01-BATCH-HDR
042600     ELSE
042700         IF  MI01-BATCH-HDR IS NUMERIC
042800             MOVE DFHBMASF       TO MI01-BATCH-HDR-A
042900             MOVE DFHBMDAS       TO MI01-BATCH-HDR-LP-A
043000                                    MI01-BATCH-HDR-RP-A
043100             SET WS-UPDATE-SW-YES
043200                                 TO TRUE
043300         ELSE
043400             MOVE DFHBMNBF       TO MI01-BATCH-HDR-A
043500             MOVE DFHBMASB       TO MI01-BATCH-HDR-LP-A
043600                                    MI01-BATCH-HDR-RP-A
043700             MOVE SS08WS-CURSOR  TO MI01-BATCH-HDR-L
043800             SET SS08WS-ERROR-SW-YES TO TRUE.
043900*
044000*            ***** STATEMENT FEE *****                         *
044100*
044200     IF  MI01-STATEMENT-L IS LESS THAN 1
044300         MOVE DFHBMASK           TO MI01-STATEMENT-A
044400         MOVE DFHBMDAS           TO MI01-STATEMENT-LP-A
044500                                    MI01-STATEMENT-RP-A
044600         MOVE MMIF-STATEMENT-FEE TO MI01-STATEMENT
044700     ELSE
044800         IF  MI01-STATEMENT IS NUMERIC
044900             MOVE DFHBMASF       TO MI01-STATEMENT-A
045000             MOVE DFHBMDAS       TO MI01-STATEMENT-LP-A
045100                                    MI01-STATEMENT-RP-A
045200             SET WS-UPDATE-SW-YES
045300                                 TO TRUE
045400         ELSE
045500             MOVE DFHBMNBF       TO MI01-STATEMENT-A
045600             MOVE DFHBMASB       TO MI01-STATEMENT-LP-A
045700                                    MI01-STATEMENT-RP-A
045800             MOVE SS08WS-CURSOR  TO MI01-STATEMENT-L
045900             SET SS08WS-ERROR-SW-YES TO TRUE.
046000*
046100*            ***** KEYED TXN FEE *****                        *
046200*
046300     IF  MI01-KEYED-TXN-L IS LESS THAN 1
046400         MOVE DFHBMASK           TO MI01-KEYED-TXN-A
046500         MOVE DFHBMDAS           TO MI01-KEYED-TXN-LP-A
046600                                    MI01-KEYED-TXN-RP-A
046700         MOVE MMIF-KEYED-FEE     TO MI01-KEYED-TXN
046800     ELSE
046900         IF  MI01-KEYED-TXN IS NUMERIC
047000             MOVE DFHBMASF       TO MI01-KEYED-TXN-A
047100             MOVE DFHBMDAS       TO MI01-KEYED-TXN-LP-A
047200                                    MI01-KEYED-TXN-RP-A
047300             SET WS-UPDATE-SW-YES
047400                                 TO TRUE
047500         ELSE
047600             MOVE DFHBMNBF       TO MI01-KEYED-TXN-A
047700             MOVE DFHBMASB       TO MI01-KEYED-TXN-LP-A
047800                                    MI01-KEYED-TXN-RP-A
047900             MOVE SS08WS-CURSOR  TO MI01-KEYED-TXN-L
048000             SET SS08WS-ERROR-SW-YES TO TRUE.
048100*
048200*            ***** MEMBERSHIP FEE *****                        *
048300*
048400     IF  MI01-MEMBERSHIP-L IS LESS THAN 1
048500         MOVE DFHBMASK           TO MI01-MEMBERSHIP-A
048600         MOVE DFHBMDAS           TO MI01-MEMBERSHIP-LP-A
048700                                    MI01-MEMBERSHIP-RP-A
048800         MOVE MMIF-MEMBERSHIP-FEE
048900                                 TO MI01-MEMBERSHIP
049000     ELSE
049100         IF  MI01-MEMBERSHIP IS NUMERIC
049200             MOVE DFHBMASF       TO MI01-MEMBERSHIP-A
049300             MOVE DFHBMDAS       TO MI01-MEMBERSHIP-LP-A
049400                                    MI01-MEMBERSHIP-RP-A
049500             SET WS-UPDATE-SW-YES
049600                                 TO TRUE
049700         ELSE
049800             MOVE DFHBMNBF       TO MI01-MEMBERSHIP-A
049900             MOVE DFHBMASB       TO MI01-MEMBERSHIP-LP-A
050000                                    MI01-MEMBERSHIP-RP-A
050100             MOVE SS08WS-CURSOR  TO MI01-MEMBERSHIP-L
050200             SET SS08WS-ERROR-SW-YES TO TRUE.
050300*
050400*            ***** SWIPED TXN FEE *****                       *
050500*
050600     IF  MI01-SWIPED-TXN-L IS LESS THAN 1
050700         MOVE DFHBMASK           TO MI01-SWIPED-TXN-A
050800         MOVE DFHBMDAS           TO MI01-SWIPED-TXN-LP-A
050900                                    MI01-SWIPED-TXN-RP-A
051000         MOVE MMIF-SWIPED-FEE    TO MI01-SWIPED-TXN
051100     ELSE
051200         IF  MI01-SWIPED-TXN IS NUMERIC
051300             MOVE DFHBMASF       TO MI01-SWIPED-TXN-A
051400             MOVE DFHBMDAS       TO MI01-SWIPED-TXN-LP-A
051500                                    MI01-SWIPED-TXN-RP-A
051600             SET WS-UPDATE-SW-YES
051700                                 TO TRUE
051800         ELSE
051900             MOVE DFHBMNBF       TO MI01-SWIPED-TXN-A
052000             MOVE DFHBMASB       TO MI01-SWIPED-TXN-LP-A
052100                                    MI01-SWIPED-TXN-RP-A
052200             MOVE SS08WS-CURSOR  TO MI01-SWIPED-TXN-L
052300             SET SS08WS-ERROR-SW-YES TO TRUE.
052400*
052500*            ***** USER INPUT FEE *****                       *
052600*
052700     IF  MI01-USER-INPUT-L IS LESS THAN 1
052800         MOVE DFHBMASK           TO MI01-USER-INPUT-A
052900         MOVE DFHBMDAS           TO MI01-USER-INPUT-LP-A
053000                                    MI01-USER-INPUT-RP-A
053100         MOVE MMIF-USER-INP-FEE  TO MI01-USER-INPUT
053200     ELSE
053300         IF  MI01-USER-INPUT IS NUMERIC
053400             MOVE DFHBMASF       TO MI01-USER-INPUT-A
053500             MOVE DFHBMDAS       TO MI01-USER-INPUT-LP-A
053600                                    MI01-USER-INPUT-RP-A
053700             SET WS-UPDATE-SW-YES
053800                                 TO TRUE
053900         ELSE
054000             MOVE DFHBMNBF       TO MI01-USER-INPUT-A
054100             MOVE DFHBMASB       TO MI01-USER-INPUT-LP-A
054200                                    MI01-USER-INPUT-RP-A
054300             MOVE SS08WS-CURSOR  TO MI01-USER-INPUT-L
054400             SET SS08WS-ERROR-SW-YES TO TRUE.
054500*
054600*            ***** SETUP FEE *****                             *
054700*
054800     IF  MI01-SETUP-L IS LESS THAN 1
054900         MOVE DFHBMASK           TO MI01-SETUP-A
055000         MOVE DFHBMDAS           TO MI01-SETUP-LP-A
055100                                    MI01-SETUP-RP-A
055200         MOVE MMIF-SETUP-FEE     TO MI01-SETUP
055300     ELSE
055400         IF  MI01-SETUP IS NUMERIC
055500             MOVE DFHBMASF       TO MI01-SETUP-A
055600             MOVE DFHBMDAS       TO MI01-SETUP-LP-A
055700                                    MI01-SETUP-RP-A
055800             SET WS-UPDATE-SW-YES
055900                                 TO TRUE
056000         ELSE
056100             MOVE DFHBMNBF       TO MI01-SETUP-A
056200             MOVE DFHBMASB       TO MI01-SETUP-LP-A
056300                                    MI01-SETUP-RP-A
056400             MOVE SS08WS-CURSOR  TO MI01-SETUP-L
056500             SET SS08WS-ERROR-SW-YES TO TRUE.
056600*
056700*            ***** LOCAL INPUT FEE *****                       *
056800*
056900     IF  MI01-LOCAL-INPUT-L IS LESS THAN 1
057000         MOVE DFHBMASK           TO MI01-LOCAL-INPUT-A
057100         MOVE DFHBMDAS           TO MI01-LOCAL-INPUT-LP-A
057200                                    MI01-LOCAL-INPUT-RP-A
057300         MOVE MMIF-LOCAL-INP-FEE TO MI01-LOCAL-INPUT
057400     ELSE
057500         IF  MI01-LOCAL-INPUT IS NUMERIC
057600             MOVE DFHBMASF       TO MI01-LOCAL-INPUT-A
057700             MOVE DFHBMDAS       TO MI01-LOCAL-INPUT-LP-A
057800                                    MI01-LOCAL-INPUT-RP-A
057900             SET WS-UPDATE-SW-YES
058000                                 TO TRUE
058100         ELSE
058200             MOVE DFHBMNBF       TO MI01-LOCAL-INPUT-A
058300             MOVE DFHBMASB       TO MI01-LOCAL-INPUT-LP-A
058400                                    MI01-LOCAL-INPUT-RP-A
058500             MOVE SS08WS-CURSOR  TO MI01-LOCAL-INPUT-L
058600             SET SS08WS-ERROR-SW-YES TO TRUE.
058700*
058800*            ***** ADMIN FEE *****                             *
058900*
059000     IF  MI01-ADMINIST-L IS LESS THAN 1
059100         MOVE DFHBMASK           TO MI01-ADMINIST-A
059200         MOVE DFHBMDAS           TO MI01-ADMINIST-LP-A
059300                                    MI01-ADMINIST-RP-A
059400         MOVE MMIF-ADMIN-FEE     TO MI01-ADMINIST
059500     ELSE
059600         IF  MI01-ADMINIST IS NUMERIC
059700             MOVE DFHBMASF       TO MI01-ADMINIST-A
059800             MOVE DFHBMDAS       TO MI01-ADMINIST-LP-A
059900                                    MI01-ADMINIST-RP-A
060000             SET WS-UPDATE-SW-YES
060100                                 TO TRUE
060200         ELSE
060300             MOVE DFHBMNBF       TO MI01-ADMINIST-A
060400             MOVE DFHBMASB       TO MI01-ADMINIST-LP-A
060500                                    MI01-ADMINIST-RP-A
060600             MOVE SS08WS-CURSOR  TO MI01-ADMINIST-L
060700             SET SS08WS-ERROR-SW-YES TO TRUE.
060800*
060900*            ***** CHECK FEE *****                             *
061000*
061100     IF  MI01-CHECK-L IS LESS THAN 1
061200         MOVE DFHBMASK           TO MI01-CHECK-A
061300         MOVE DFHBMDAS           TO MI01-CHECK-LP-A
061400                                    MI01-CHECK-RP-A
061500         MOVE MMIF-CHECK-APPR-FEE
061600                                 TO MI01-CHECK
061700     ELSE
061800         IF  MI01-CHECK IS NUMERIC
061900             MOVE DFHBMASF       TO MI01-CHECK-A
062000             MOVE DFHBMDAS       TO MI01-CHECK-LP-A
062100                                    MI01-CHECK-RP-A
062200             SET WS-UPDATE-SW-YES
062300                                 TO TRUE
062400         ELSE
062500             MOVE DFHBMNBF       TO MI01-CHECK-A
062600             MOVE DFHBMASB       TO MI01-CHECK-LP-A
062700                                    MI01-CHECK-RP-A
062800             MOVE SS08WS-CURSOR  TO MI01-CHECK-L
062900             SET SS08WS-ERROR-SW-YES TO TRUE.
063000*
063100*            ***** ADJUSTMENT FEE *****                        *
063200*
063300     IF  MI01-ADJUSTMENT-L IS LESS THAN 1
063400         MOVE DFHBMASK           TO MI01-ADJUSTMENT-A
063500         MOVE DFHBMDAS           TO MI01-ADJUSTMENT-LP-A
063600                                    MI01-ADJUSTMENT-RP-A
063700         MOVE MMIF-ADJ-INPUT-FEE TO MI01-ADJUSTMENT
063800     ELSE
063900         IF  MI01-ADJUSTMENT IS NUMERIC
064000             MOVE DFHBMASF       TO MI01-ADJUSTMENT-A
064100             MOVE DFHBMDAS       TO MI01-ADJUSTMENT-LP-A
064200                                    MI01-ADJUSTMENT-RP-A
064300             SET WS-UPDATE-SW-YES
064400                                 TO TRUE
064500         ELSE
064600             MOVE DFHBMNBF       TO MI01-ADJUSTMENT-A
064700             MOVE DFHBMASB       TO MI01-ADJUSTMENT-LP-A
064800                                    MI01-ADJUSTMENT-RP-A
064900             MOVE SS08WS-CURSOR  TO MI01-ADJUSTMENT-L
065000             SET SS08WS-ERROR-SW-YES TO TRUE.
065100*
065200*            ***** CHARGE BACK FEE *****                       *
065300*
065400     IF  MI01-CHARGEBACK-L IS LESS THAN 1
065500         MOVE DFHBMASK           TO MI01-CHARGEBACK-A
065600         MOVE DFHBMDAS           TO MI01-CHARGEBACK-LP-A
065700                                    MI01-CHARGEBACK-RP-A
065800         MOVE MMIF-CHGBACK-FEE   TO MI01-CHARGEBACK
065900     ELSE
066000         IF  MI01-CHARGEBACK IS NUMERIC
066100             MOVE DFHBMASF       TO MI01-CHARGEBACK-A
066200             MOVE DFHBMDAS       TO MI01-CHARGEBACK-LP-A
066300                                    MI01-CHARGEBACK-RP-A
066400             SET WS-UPDATE-SW-YES
066500                                 TO TRUE
066600         ELSE
066700             MOVE DFHBMNBF       TO MI01-CHARGEBACK-A
066800             MOVE DFHBMASB       TO MI01-CHARGEBACK-LP-A
066900                                    MI01-CHARGEBACK-RP-A
067000             MOVE SS08WS-CURSOR  TO MI01-CHARGEBACK-L
067100             SET SS08WS-ERROR-SW-YES TO TRUE.
067200*
067300*            ***** ACH FEE *****                               *
067400*
067500     IF  MI01-ACH-FEE-L IS LESS THAN 1
067600         MOVE DFHBMASK           TO MI01-ACH-FEE-A
067700         MOVE DFHBMDAS           TO MI01-ACH-FEE-LP-A
067800                                    MI01-ACH-FEE-RP-A
067900         MOVE MMIF-ACH-FEE       TO MI01-ACH-FEE
068000     ELSE
068100         IF  MI01-ACH-FEE IS NUMERIC
068200             MOVE DFHBMASF       TO MI01-ACH-FEE-A
068300             MOVE DFHBMDAS       TO MI01-ACH-FEE-LP-A
068400                                    MI01-ACH-FEE-RP-A
068500             SET WS-UPDATE-SW-YES
068600                                 TO TRUE
068700         ELSE
068800             MOVE DFHBMNBF       TO MI01-ACH-FEE-A
068900             MOVE DFHBMASB       TO MI01-ACH-FEE-LP-A
069000                                    MI01-ACH-FEE-RP-A
069100             MOVE SS08WS-CURSOR  TO MI01-ACH-FEE-L
069200             SET SS08WS-ERROR-SW-YES TO TRUE.
069300*
069400*            ***** POS 1 CAPTURE FEE *****                     *
069500*
069600     IF  MI01-POS-1-CAPTURE-L IS LESS THAN 1
069700         MOVE DFHBMASK           TO MI01-POS-1-CAPTURE-A
069800         MOVE DFHBMDAS           TO MI01-POS-1-CAPTURE-LP-A
069900                                    MI01-POS-1-CAPTURE-RP-A
070000         MOVE MMIF-POS-1-CAP-FEE TO MI01-POS-1-CAPTURE
070100     ELSE
070200         IF  MI01-POS-1-CAPTURE IS NUMERIC
070300             MOVE DFHBMASF       TO MI01-POS-1-CAPTURE-A
070400             MOVE DFHBMDAS       TO MI01-POS-1-CAPTURE-LP-A
070500                                    MI01-POS-1-CAPTURE-RP-A
070600             SET WS-UPDATE-SW-YES
070700                                 TO TRUE
070800         ELSE
070900             MOVE DFHBMNBF       TO MI01-POS-1-CAPTURE-A
071000             MOVE DFHBMASB       TO MI01-POS-1-CAPTURE-LP-A
071100                                    MI01-POS-1-CAPTURE-RP-A
071200             MOVE SS08WS-CURSOR  TO MI01-POS-1-CAPTURE-L
071300             SET SS08WS-ERROR-SW-YES TO TRUE.
071400*
071500*            ***** POS 2 CAPTURE FEE *****                     *
071600*
071700     IF  MI01-POS-2-CAPTURE-L IS LESS THAN 1
071800         MOVE DFHBMASK           TO MI01-POS-2-CAPTURE-A
071900         MOVE DFHBMDAS           TO MI01-POS-2-CAPTURE-LP-A
072000                                    MI01-POS-2-CAPTURE-RP-A
072100         MOVE MMIF-POS-2-CAP-FEE TO MI01-POS-2-CAPTURE
072200     ELSE
072300         IF  MI01-POS-2-CAPTURE IS NUMERIC
072400             MOVE DFHBMASF       TO MI01-POS-2-CAPTURE-A
072500             MOVE DFHBMDAS       TO MI01-POS-2-CAPTURE-LP-A
072600                                    MI01-POS-2-CAPTURE-RP-A
072700             SET WS-UPDATE-SW-YES
072800                                 TO TRUE
072900         ELSE
073000             MOVE DFHBMNBF       TO MI01-POS-2-CAPTURE-A
073100             MOVE DFHBMASB       TO MI01-POS-2-CAPTURE-LP-A
073200                                    MI01-POS-2-CAPTURE-RP-A
073300             MOVE SS08WS-CURSOR  TO MI01-POS-2-CAPTURE-L
073400             SET SS08WS-ERROR-SW-YES TO TRUE.
073500*
073600*            ***** POS 3 CAPTURE FEE *****                     *
073700*
073800     IF  MI01-POS-3-CAPTURE-L IS LESS THAN 1
073900         MOVE DFHBMASK           TO MI01-POS-3-CAPTURE-A
074000         MOVE DFHBMDAS           TO MI01-POS-3-CAPTURE-LP-A
074100                                    MI01-POS-3-CAPTURE-RP-A
074200         MOVE MMIF-POS-3-CAP-FEE TO MI01-POS-3-CAPTURE
074300     ELSE
074400         IF  MI01-POS-3-CAPTURE IS NUMERIC
074500             MOVE DFHBMASF       TO MI01-POS-3-CAPTURE-A
074600             MOVE DFHBMDAS       TO MI01-POS-3-CAPTURE-LP-A
074700                                    MI01-POS-3-CAPTURE-RP-A
074800             SET WS-UPDATE-SW-YES
074900                                 TO TRUE
075000         ELSE
075100             MOVE DFHBMNBF       TO MI01-POS-3-CAPTURE-A
075200             MOVE DFHBMASB       TO MI01-POS-3-CAPTURE-LP-A
075300                                    MI01-POS-3-CAPTURE-RP-A
075400             MOVE SS08WS-CURSOR  TO MI01-POS-3-CAPTURE-L
075500             SET SS08WS-ERROR-SW-YES TO TRUE.
075600*
075700*            ***** IN STORE PMT FEE *****                      *
075800*
075900     IF  MI01-IN-STORE-PMT-L IS LESS THAN 1
076000         MOVE DFHBMASK           TO MI01-IN-STORE-PMT-A
076100         MOVE DFHBMDAS           TO MI01-IN-STORE-PMT-LP-A
076200                                    MI01-IN-STORE-PMT-RP-A
076300         MOVE MMIF-IN-STORE-PMT-FEE
076400                                 TO MI01-IN-STORE-PMT
076500     ELSE
076600         IF  MI01-IN-STORE-PMT IS NUMERIC
076700             MOVE DFHBMASF       TO MI01-IN-STORE-PMT-A
076800             MOVE DFHBMDAS       TO MI01-IN-STORE-PMT-LP-A
076900                                    MI01-IN-STORE-PMT-RP-A
077000             SET WS-UPDATE-SW-YES
077100                                 TO TRUE
077200         ELSE
077300             MOVE DFHBMNBF       TO MI01-IN-STORE-PMT-A
077400             MOVE DFHBMASB       TO MI01-IN-STORE-PMT-LP-A
077500                                    MI01-IN-STORE-PMT-RP-A
077600             MOVE SS08WS-CURSOR  TO MI01-IN-STORE-PMT-L
077700             SET SS08WS-ERROR-SW-YES TO TRUE.
077800*
077900     IF  SS08WS-ERROR-SW-NO
078000         GO TO 2400-UPDATE-FILE.
078100*
078200****************************************************************
078300*    FORMAT THE MESSAGE LINE                                   *
078400****************************************************************
078500*
078600     IF MI01-ERR-MESSAGE EQUAL TO SPACES OR LOW-VALUES
078700         PERFORM MB06PD-FORMAT-MESSAGE-LINE
078800           THRU MB06PD-FML-EXIT
078900         MOVE SS08WS-FORMATTED-MSG TO MI01-ERR-MESSAGE.
079000
079100*
079200****************************************************************
079300*    SEND THE MAP                                              *
079400****************************************************************
079500*
079600     PERFORM MB60PD-INIT-STD-MAP-LINES
079700                                 THRU MB60PD-ISML-EXIT.
079800     MOVE 'BM03'                 TO MBCA-PROGRAM-LOCATION.
079900     PERFORM MB60PD-SEND-MAP-DATA-ONLY
080000                                 THRU MB60PD-SMDO-EXIT.
080100*
080200****************************************************************
080300*    RETURN TO CICS                                            *
080400****************************************************************
080500*
080600     MOVE 'PC04'                 TO MBCA-PROGRAM-LOCATION.
080700     MOVE 01                     TO MBCA-SCREEN-NBR.
080800     PERFORM MB70PD-RETURN-TRANS-ID
080900                                 THRU MB70PD-RTI-EXIT.
081000/
081100 2400-UPDATE-FILE.
081200*
081300     IF  WS-UPDATE-SW-NO
081400         IF  MBCA-PTI-FUNCTION-IS-ADD
081500             MOVE 'FC03'         TO MBCA-PROGRAM-LOCATION
081600             MOVE MBCA-MERCHANT-ORG
081700                                 TO MBIOWS-MMIF-ORG
081800             MOVE MBCA-TABLE     TO MBIOWS-MMIF-TABLE
081900             SET MBIORO-READ-RANDOM-UPDATE
082000                                 TO TRUE
082100             PERFORM MMIFAO-ACCESS
082200                                 THRU MMIFAO-ACCESS-EXIT
082300             MOVE MBCA-SCREEN-NBR
082400                                 TO MMIF-ONLINE-STATUS
082500             MOVE 'FC04'         TO MBCA-PROGRAM-LOCATION
082600             SET MBIORO-REWRITE  TO TRUE
082700             PERFORM MMIFAO-ACCESS
082800                                 THRU MMIFAO-ACCESS-EXIT
082900             GO TO 2600-SETUP-COMMAREA
083000         ELSE
083100             GO TO 2600-SETUP-COMMAREA.
083200*
083300****************************************************************
083400*    GETMAIN FOR LOG/JOURNAL RECORD                            *
083500****************************************************************
083600*
083700     MOVE 'SC02'                 TO MBCA-PROGRAM-LOCATION.
083800     SET MBIORO-GETMAIN          TO TRUE.
083900     PERFORM MML1AO-ACCESS       THRU MML1AO-ACCESS-EXIT.
084000*
084100****************************************************************
084200*    READ THE INCOME  RECORD FOR UPDATE                        *
084300****************************************************************
084400*
084500     MOVE 'FC05'                 TO MBCA-PROGRAM-LOCATION.
084600     MOVE MBCA-MERCHANT-ORG      TO MBIOWS-MMIF-ORG.
084700     MOVE MBCA-TABLE             TO MBIOWS-MMIF-TABLE.
084800     SET MBIORO-READ-RANDOM-UPDATE
084900                                 TO TRUE.
085000     PERFORM MMIFAO-ACCESS       THRU MMIFAO-ACCESS-EXIT.
085100*
085200*            ***** TABLE NAME *****                            *
085300*
085400     IF  MI01-TABLE-NAME-L IS GREATER THAN ZERO
085500         MOVE ZEROES             TO MML1-FIELD-OCCURRENCE
085600         MOVE 0101               TO MML1-FIELD-CODE
085700         MOVE MML1WS-VL-30       TO MML1-VARIABLE-LENGTH
085800         MOVE MMIF-TABLE-NAME    TO MML1-VL30-B-DATA-X
085900         MOVE MI01-TABLE-NAME    TO MMIF-TABLE-NAME
086000         MOVE MMIF-TABLE-NAME    TO MML1-VL30-A-DATA-X
086100         PERFORM 9050-CREATE-MAINT-RECORD
086200                                 THRU 9099-CMR-EXIT.
086300*
086400*            ***** SALES FEE *****                            *
086500*
086600     IF  MI01-SALES-L IS GREATER THAN ZEROES
086700         MOVE ZEROES             TO MML1-FIELD-OCCURRENCE
086800         MOVE 0102               TO MML1-FIELD-CODE
086900         MOVE MML1WS-VL-20       TO MML1-VARIABLE-LENGTH
087000         MOVE MMIF-SALES-FEE     TO MML1-VL20-B-NBR-NO-DEC
087100         MOVE MI01-SALES         TO MMIF-SALES-FEE
087200         MOVE MMIF-SALES-FEE     TO MML1-VL20-A-NBR-NO-DEC
087300         PERFORM 9050-CREATE-MAINT-RECORD
087400                                 THRU 9099-CMR-EXIT.
087500*
087600*            ***** RETRIEVAL FEE *****                        *
087700*
087800     IF  MI01-RETRIEVAL-L IS GREATER THAN ZEROES
087900         MOVE ZEROES             TO MML1-FIELD-OCCURRENCE
088000         MOVE 0123               TO MML1-FIELD-CODE
088100         MOVE MML1WS-VL-20       TO MML1-VARIABLE-LENGTH
088200         MOVE MMIF-RETRIEVAL-FEE TO MML1-VL20-B-NBR-NO-DEC
088300         MOVE MI01-RETRIEVAL     TO MMIF-RETRIEVAL-FEE
088400         MOVE MMIF-RETRIEVAL-FEE TO MML1-VL20-A-NBR-NO-DEC
088500         PERFORM 9050-CREATE-MAINT-RECORD
088600                                 THRU 9099-CMR-EXIT.
088700*
088800*            ***** LOCATION FEE *****                     *
088900*
089000     IF  MI01-LOCATION-FEE-L IS GREATER THAN ZEROES
089100         MOVE ZEROES             TO MML1-FIELD-OCCURRENCE
089200         MOVE 0103               TO MML1-FIELD-CODE
089300         MOVE MML1WS-VL-20       TO MML1-VARIABLE-LENGTH
089400         MOVE MMIF-LOCATION-FEE  TO MML1-VL20-B-NBR-NO-DEC
089500         MOVE MI01-LOCATION-FEE  TO MMIF-LOCATION-FEE
089600         MOVE MMIF-LOCATION-FEE  TO MML1-VL20-A-NBR-NO-DEC
089700         PERFORM 9050-CREATE-MAINT-RECORD
089800                                 THRU 9099-CMR-EXIT.
089900*
090000*            ***** RETURN FEE *****                           *
090100*
090200     IF  MI01-RETURN-L IS GREATER THAN ZEROES
090300         MOVE ZEROES             TO MML1-FIELD-OCCURRENCE
090400         MOVE 0104               TO MML1-FIELD-CODE
090500         MOVE MML1WS-VL-20       TO MML1-VARIABLE-LENGTH
090600         MOVE MMIF-RETURNS-FEE   TO MML1-VL20-B-NBR-NO-DEC
090700         MOVE MI01-RETURN        TO MMIF-RETURNS-FEE
090800         MOVE MMIF-RETURNS-FEE   TO MML1-VL20-A-NBR-NO-DEC
090900         PERFORM 9050-CREATE-MAINT-RECORD
091000                                 THRU 9099-CMR-EXIT.
091100*
091200*            ***** BULLETIN FEE *****                     *
091300*
091400     IF  MI01-BULLETIN-FEE-L IS GREATER THAN ZEROES
091500         MOVE ZEROES             TO MML1-FIELD-OCCURRENCE
091600         MOVE 0105               TO MML1-FIELD-CODE
091700         MOVE MML1WS-VL-20       TO MML1-VARIABLE-LENGTH
091800         MOVE MMIF-BULLETIN-FEE  TO MML1-VL20-B-NBR-NO-DEC
091900         MOVE MI01-BULLETIN-FEE  TO MMIF-BULLETIN-FEE
092000         MOVE MMIF-BULLETIN-FEE  TO MML1-VL20-A-NBR-NO-DEC
092100         PERFORM 9050-CREATE-MAINT-RECORD
092200                                 THRU 9099-CMR-EXIT.
092300*
092400*            ***** BATCH HDR FEE *****                        *
092500*
092600     IF  MI01-BATCH-HDR-L IS GREATER THAN ZEROES
092700         MOVE ZEROES             TO MML1-FIELD-OCCURRENCE
092800         MOVE 0106               TO MML1-FIELD-CODE
092900         MOVE MML1WS-VL-20       TO MML1-VARIABLE-LENGTH
093000         MOVE MMIF-BATCH-HDR-FEE
093100                                 TO MML1-VL20-B-NBR-NO-DEC
093200         MOVE MI01-BATCH-HDR     TO MMIF-BATCH-HDR-FEE
093300         MOVE MMIF-BATCH-HDR-FEE
093400                                 TO MML1-VL20-A-NBR-NO-DEC
093500         PERFORM 9050-CREATE-MAINT-RECORD
093600                                 THRU 9099-CMR-EXIT.
093700*
093800*            ***** STATEMENT FEE *****                         *
093900*
094000     IF  MI01-STATEMENT-L IS GREATER THAN ZEROES
094100         MOVE ZEROES             TO MML1-FIELD-OCCURRENCE
094200         MOVE 0107               TO MML1-FIELD-CODE
094300         MOVE MML1WS-VL-20       TO MML1-VARIABLE-LENGTH
094400         MOVE MMIF-STATEMENT-FEE TO MML1-VL20-B-NBR-NO-DEC
094500         MOVE MI01-STATEMENT     TO MMIF-STATEMENT-FEE
094600         MOVE MMIF-STATEMENT-FEE TO MML1-VL20-A-NBR-NO-DEC
094700         PERFORM 9050-CREATE-MAINT-RECORD
094800                                 THRU 9099-CMR-EXIT.
094900*
095000*            ***** KEYED TXN FEE *****                        *
095100*
095200     IF  MI01-KEYED-TXN-L IS GREATER THAN ZEROES
095300         MOVE ZEROES             TO MML1-FIELD-OCCURRENCE
095400         MOVE 0108               TO MML1-FIELD-CODE
095500         MOVE MML1WS-VL-20       TO MML1-VARIABLE-LENGTH
095600         MOVE MMIF-KEYED-FEE     TO MML1-VL20-B-NBR-NO-DEC
095700         MOVE MI01-KEYED-TXN     TO MMIF-KEYED-FEE
095800         MOVE MMIF-KEYED-FEE     TO MML1-VL20-A-NBR-NO-DEC
095900         PERFORM 9050-CREATE-MAINT-RECORD
096000                                 THRU 9099-CMR-EXIT.
096100*
096200*            ***** MEMBERSHIP FEE *****                        *
096300*
096400     IF  MI01-MEMBERSHIP-L IS GREATER THAN ZEROES
096500         MOVE ZEROES             TO MML1-FIELD-OCCURRENCE
096600         MOVE 0109               TO MML1-FIELD-CODE
096700         MOVE MML1WS-VL-20       TO MML1-VARIABLE-LENGTH
096800         MOVE MMIF-MEMBERSHIP-FEE
096900                                 TO MML1-VL20-B-NBR-NO-DEC
097000         MOVE MI01-MEMBERSHIP    TO MMIF-MEMBERSHIP-FEE
097100         MOVE MMIF-MEMBERSHIP-FEE
097200                                 TO MML1-VL20-A-NBR-NO-DEC
097300         PERFORM 9050-CREATE-MAINT-RECORD
097400                                 THRU 9099-CMR-EXIT.
097500*
097600*            ***** SWIPED TXN FEE *****                       *
097700*
097800     IF  MI01-SWIPED-TXN-L IS GREATER THAN ZEROES
097900         MOVE ZEROES             TO MML1-FIELD-OCCURRENCE
098000         MOVE 0110               TO MML1-FIELD-CODE
098100         MOVE MML1WS-VL-20       TO MML1-VARIABLE-LENGTH
098200         MOVE MMIF-SWIPED-FEE    TO MML1-VL20-B-NBR-NO-DEC
098300         MOVE MI01-SWIPED-TXN    TO MMIF-SWIPED-FEE
098400         MOVE MMIF-SWIPED-FEE    TO MML1-VL20-A-NBR-NO-DEC
098500         PERFORM 9050-CREATE-MAINT-RECORD
098600                                 THRU 9099-CMR-EXIT.
098700*
098800*            ***** USER INPUT FEE *****                       *
098900*
099000     IF  MI01-USER-INPUT-L IS GREATER THAN ZEROES
099100         MOVE ZEROES             TO MML1-FIELD-OCCURRENCE
099200         MOVE 0111               TO MML1-FIELD-CODE
099300         MOVE MML1WS-VL-20       TO MML1-VARIABLE-LENGTH
099400         MOVE MMIF-USER-INP-FEE  TO MML1-VL20-B-NBR-NO-DEC
099500         MOVE MI01-USER-INPUT    TO MMIF-USER-INP-FEE
099600         MOVE MMIF-USER-INP-FEE  TO MML1-VL20-A-NBR-NO-DEC
099700         PERFORM 9050-CREATE-MAINT-RECORD
099800                                 THRU 9099-CMR-EXIT.
099900*
100000*            ***** SETUP FEE *****                             *
100100*
100200     IF  MI01-SETUP-L IS GREATER THAN ZEROES
100300         MOVE ZEROES             TO MML1-FIELD-OCCURRENCE
100400         MOVE 0112               TO MML1-FIELD-CODE
100500         MOVE MML1WS-VL-20       TO MML1-VARIABLE-LENGTH
100600         MOVE MMIF-SETUP-FEE     TO MML1-VL20-B-NBR-NO-DEC
100700         MOVE MI01-SETUP         TO MMIF-SETUP-FEE
100800         MOVE MMIF-SETUP-FEE     TO MML1-VL20-A-NBR-NO-DEC
100900         PERFORM 9050-CREATE-MAINT-RECORD
101000                                 THRU 9099-CMR-EXIT.
101100*
101200*            ***** LOCAL INPUT FEE *****                       *
101300*
101400     IF  MI01-LOCAL-INPUT-L IS GREATER THAN ZEROES
101500         MOVE ZEROES             TO MML1-FIELD-OCCURRENCE
101600         MOVE 0113               TO MML1-FIELD-CODE
101700         MOVE MML1WS-VL-20       TO MML1-VARIABLE-LENGTH
101800         MOVE MMIF-LOCAL-INP-FEE TO MML1-VL20-B-NBR-NO-DEC
101900         MOVE MI01-LOCAL-INPUT   TO MMIF-LOCAL-INP-FEE
102000         MOVE MMIF-LOCAL-INP-FEE TO MML1-VL20-A-NBR-NO-DEC
102100         PERFORM 9050-CREATE-MAINT-RECORD
102200                                 THRU 9099-CMR-EXIT.
102300*
102400*            ***** ADMINISTRATOR FEE *****                     *
102500*
102600     IF  MI01-ADMINIST-L IS GREATER THAN ZEROES
102700         MOVE ZEROES             TO MML1-FIELD-OCCURRENCE
102800         MOVE 0114               TO MML1-FIELD-CODE
102900         MOVE MML1WS-VL-20       TO MML1-VARIABLE-LENGTH
103000         MOVE MMIF-ADMIN-FEE     TO MML1-VL20-B-NBR-NO-DEC
103100         MOVE MI01-ADMINIST      TO MMIF-ADMIN-FEE
103200         MOVE MMIF-ADMIN-FEE     TO MML1-VL20-A-NBR-NO-DEC
103300         PERFORM 9050-CREATE-MAINT-RECORD
103400                                 THRU 9099-CMR-EXIT.
103500*
103600*            ***** CHECK FEE *****                             *
103700*
103800     IF  MI01-CHECK-L IS GREATER THAN ZEROES
103900         MOVE ZEROES             TO MML1-FIELD-OCCURRENCE
104000         MOVE 0115               TO MML1-FIELD-CODE
104100         MOVE MML1WS-VL-20       TO MML1-VARIABLE-LENGTH
104200         MOVE MMIF-CHECK-APPR-FEE
104300                                 TO MML1-VL20-B-NBR-NO-DEC
104400         MOVE MI01-CHECK         TO MMIF-CHECK-APPR-FEE
104500         MOVE MMIF-CHECK-APPR-FEE
104600                                 TO MML1-VL20-A-NBR-NO-DEC
104700         PERFORM 9050-CREATE-MAINT-RECORD
104800                                 THRU 9099-CMR-EXIT.
104900*
105000*            ***** ADJUSTMENT FEE *****                        *
105100*
105200     IF  MI01-ADJUSTMENT-L IS GREATER THAN ZEROES
105300         MOVE ZEROES             TO MML1-FIELD-OCCURRENCE
105400         MOVE 0116               TO MML1-FIELD-CODE
105500         MOVE MML1WS-VL-20       TO MML1-VARIABLE-LENGTH
105600         MOVE MMIF-ADJ-INPUT-FEE TO MML1-VL20-B-NBR-NO-DEC
105700         MOVE MI01-ADJUSTMENT    TO MMIF-ADJ-INPUT-FEE
105800         MOVE MMIF-ADJ-INPUT-FEE TO MML1-VL20-A-NBR-NO-DEC
105900         PERFORM 9050-CREATE-MAINT-RECORD
106000                                 THRU 9099-CMR-EXIT.
106100*
106200*            ***** CHARGE BACK FEE *****                       *
106300*
106400     IF  MI01-CHARGEBACK-L IS GREATER THAN ZEROES
106500         MOVE ZEROES             TO MML1-FIELD-OCCURRENCE
106600         MOVE 0117               TO MML1-FIELD-CODE
106700         MOVE MML1WS-VL-20       TO MML1-VARIABLE-LENGTH
106800         MOVE MMIF-CHGBACK-FEE   TO MML1-VL20-B-NBR-NO-DEC
106900         MOVE MI01-CHARGEBACK    TO MMIF-CHGBACK-FEE
107000         MOVE MMIF-CHGBACK-FEE   TO MML1-VL20-A-NBR-NO-DEC
107100         PERFORM 9050-CREATE-MAINT-RECORD
107200                                 THRU 9099-CMR-EXIT.
107300*
107400*            ***** ACH FEE *****                               *
107500*
107600     IF  MI01-ACH-FEE-L IS GREATER THAN ZEROES
107700         MOVE ZEROES             TO MML1-FIELD-OCCURRENCE
107800         MOVE 0118               TO MML1-FIELD-CODE
107900         MOVE MML1WS-VL-20       TO MML1-VARIABLE-LENGTH
108000         MOVE MMIF-ACH-FEE       TO MML1-VL20-B-NBR-NO-DEC
108100         MOVE MI01-ACH-FEE       TO MMIF-ACH-FEE
108200         MOVE MMIF-ACH-FEE       TO MML1-VL20-A-NBR-NO-DEC
108300         PERFORM 9050-CREATE-MAINT-RECORD
108400                                 THRU 9099-CMR-EXIT.
108500*
108600*            ***** POS 1 CAPTURE FEE *****                     *
108700*
108800     IF  MI01-POS-1-CAPTURE-L IS GREATER THAN ZEROES
108900         MOVE ZEROES             TO MML1-FIELD-OCCURRENCE
109000         MOVE 0119               TO MML1-FIELD-CODE
109100         MOVE MML1WS-VL-20       TO MML1-VARIABLE-LENGTH
109200         MOVE MMIF-POS-1-CAP-FEE TO MML1-VL20-B-NBR-NO-DEC
109300         MOVE MI01-POS-1-CAPTURE TO MMIF-POS-1-CAP-FEE
109400         MOVE MMIF-POS-1-CAP-FEE TO MML1-VL20-A-NBR-NO-DEC
109500         PERFORM 9050-CREATE-MAINT-RECORD
109600                                 THRU 9099-CMR-EXIT.
109700*
109800*            ***** POS 2 CAPTURE FEE *****                     *
109900*
110000     IF  MI01-POS-2-CAPTURE-L IS GREATER THAN ZEROES
110100         MOVE ZEROES             TO MML1-FIELD-OCCURRENCE
110200         MOVE 0120               TO MML1-FIELD-CODE
110300         MOVE MML1WS-VL-20       TO MML1-VARIABLE-LENGTH
110400         MOVE MMIF-POS-2-CAP-FEE TO MML1-VL20-B-NBR-NO-DEC
110500         MOVE MI01-POS-2-CAPTURE TO MMIF-POS-2-CAP-FEE
110600         MOVE MMIF-POS-2-CAP-FEE TO MML1-VL20-A-NBR-NO-DEC
110700         PERFORM 9050-CREATE-MAINT-RECORD
110800                                 THRU 9099-CMR-EXIT.
110900*
111000*            ***** POS 3 CAPTURE FEE *****                     *
111100*
111200     IF  MI01-POS-3-CAPTURE-L IS GREATER THAN ZEROES
111300         MOVE ZEROES             TO MML1-FIELD-OCCURRENCE
111400         MOVE 0121               TO MML1-FIELD-CODE
111500         MOVE MML1WS-VL-20       TO MML1-VARIABLE-LENGTH
111600         MOVE MMIF-POS-3-CAP-FEE TO MML1-VL20-B-NBR-NO-DEC
111700         MOVE MI01-POS-3-CAPTURE TO MMIF-POS-3-CAP-FEE
111800         MOVE MMIF-POS-3-CAP-FEE TO MML1-VL20-A-NBR-NO-DEC
111900         PERFORM 9050-CREATE-MAINT-RECORD
112000                                 THRU 9099-CMR-EXIT.
112100*
112200*            ***** IN STORE PMT FEE  *****                     *
112300*
112400     IF  MI01-IN-STORE-PMT-L IS GREATER THAN ZEROES
112500         MOVE ZEROES             TO MML1-FIELD-OCCURRENCE
112600         MOVE 0122               TO MML1-FIELD-CODE
112700         MOVE MML1WS-VL-20       TO MML1-VARIABLE-LENGTH
112800         MOVE MMIF-IN-STORE-PMT-FEE
112900                                 TO MML1-VL20-B-NBR-NO-DEC
113000         MOVE MI01-IN-STORE-PMT  TO MMIF-IN-STORE-PMT-FEE
113100         MOVE MMIF-IN-STORE-PMT-FEE
113200                                 TO MML1-VL20-A-NBR-NO-DEC
113300         PERFORM 9050-CREATE-MAINT-RECORD
113400                                 THRU 9099-CMR-EXIT.
113500*
113600     IF  MBCA-PTI-FUNCTION-IS-ADD
113700         MOVE 01                 TO MMIF-ONLINE-STATUS.
113800*
113900*            ***** LAST MAINT DATE AND OPERATOR ID *****       *
114000*
114100     MOVE ZEROES                 TO MML1-FIELD-OCCURRENCE.
114200     MOVE 0199                   TO MML1-FIELD-CODE.
114300     MOVE MML1WS-VL-07           TO MML1-VARIABLE-LENGTH.
114400     MOVE MMIF-LAST-MAINT-DATE
114500                                 TO MML1-VL07-B-DATA-9.
114600     MOVE MBCA-START-DATE        TO MMIF-LAST-MAINT-DATE.
114700     MOVE MMIF-LAST-MAINT-DATE
114800                                 TO MML1-VL07-A-DATA-9.
114900     PERFORM 9050-CREATE-MAINT-RECORD
115000                                 THRU 9099-CMR-EXIT.
115100     MOVE 0198                   TO MML1-FIELD-CODE.
115200     MOVE MML1WS-VL-03           TO MML1-VARIABLE-LENGTH.
115300     MOVE MMIF-LAST-MAINT-OPER
115400                                 TO MML1-VL03-B-DATA-X.
115500     MOVE MBCA-OPERATOR-ID       TO MMIF-LAST-MAINT-OPER.
115600     MOVE MMIF-LAST-MAINT-OPER
115700                                 TO MML1-VL03-A-DATA-X.
115800     PERFORM 9050-CREATE-MAINT-RECORD
115900                                 THRU 9099-CMR-EXIT.
116000*
116100****************************************************************
116200*    UPDATE THE INCOME  FILE                                   *
116300****************************************************************
116400*
116500     MOVE 'FC06'                 TO MBCA-PROGRAM-LOCATION.
116600     SET MBIORO-REWRITE          TO TRUE.
116700     PERFORM MMIFAO-ACCESS       THRU MMIFAO-ACCESS-EXIT.
116800*
116900 2600-SETUP-COMMAREA.
117000*
117100****************************************************************
117200*    SET UP COMMAREA FIELDS AND TRANSFER TO THE NEXT PROGRAM   *
117300****************************************************************
117400*
117500     MOVE MBCA-EIBAID            TO SS08WS-EIBAID.
117600*
117700     PERFORM MB60PD-EDIT-PAGE-NBR
117800                                 THRU MB60PD-EPN-EXIT.
117900*
118000     IF  SS08WS-VALID-PF-KEY
118100     OR  SS08WS-EIBAID-VALID-PF-KEY
118200         SET MBCA-INITIAL-SCREEN-NBR
118300                                 TO TRUE.
118400*
118500     MOVE 'PC05'                 TO MBCA-PROGRAM-LOCATION.
118600     PERFORM MB70PD-XCTL-TO-MBOXCTL
118700                                 THRU MB70PD-XTM-EXIT.
118800/
118900 9000-PERFORMED-ROUTINES-SECT SECTION.
119000*
119100 9050-CREATE-MAINT-RECORD.
119200*
119300*****************************************************************
119400*    THIS ROUTINE WILL CREATE THE COMMON DATA FOR ALL OF THE    *
119500*    LOG/JOURNAL TRANSACTIONS                                   *
119600*****************************************************************
119700*
119800     IF  MBCA-PTI-FUNCTION-IS-ADD
119900         GO TO 9099-CMR-EXIT.
120000*
120100     MOVE 'IF'                   TO MML1-FILE-CODE.
120200     MOVE MBCA-MERCHANT-ORG      TO MML1-MMIF-ORG.
120300     MOVE MBCA-TABLE             TO MML1-MMIF-TABLE-NBR.
120400     MOVE MBCA-SIGNON-NAME       TO MML1-SIGNON-NAME.
120500     MOVE MBCA-TERMINAL-ID       TO MML1-TERMINAL-ID.
120600     MOVE ZEROES                 TO MML1-SOURCE-CODE
120700                                    MML1-FIELD-OCCURRENCE-2.
120800*
120900*****************************************************************
121000*    WRITE THE LOG/JOURNAL FILE RECORD                          *
121100*****************************************************************
121200*
121300     MOVE 'FC07'                 TO MBCA-PROGRAM-LOCATION.
121400     SET MBIORO-WRITE            TO TRUE.
121500     PERFORM MML1AO-ACCESS       THRU MML1AO-ACCESS-EXIT.
121600     MOVE SPACES                 TO MML1-VARIABLE-AREA.
121700*
121800 9099-CMR-EXIT.
121900     EXIT.
122000/         JULIAN TO GREGORIAN DATE ROUTINE.
122100     COPY SS08PD.
122200/         DATE AND TIME EDIT ROUTINES.
122300     COPY SS26PD.
122400     COPY SS27PD.
122500/         CHECK DIGIT ROUTINE.
122600     COPY SS09PD.
122700/         LINE 24 PF KEYS ROUTINE
122800     COPY SS15PD.
122900/         INCOME  RECORD ACCESS ROUTINES
123000     COPY MMIFAO.
123100/         LOG/JOURNAL ACCESS ROUTINES
123200     COPY MML1AO.
123300/         ON-LINE MAP ROUTINES
123400     COPY MB60PD REPLACING 'MBMAPXX' BY 'MBMI01 '
123500                           MBMAPXXI BY MBMI01I
123600                           MBMAPXXO BY MBMI01O.
123700/         ON-LINE PROCEDURES
123800     COPY MB70PD.
123900/         MESSAGE FORMAT ROUTINE
124000     COPY MB06PD.
124100/
124200     COPY SMFTPXO.
