000100 IDENTIFICATION DIVISION.
000200 PROGRAM-ID. MBOMM01.
000201*       RELEASE DATE=08/24/01.        REVISION LEVEL=08.06      *
000202*****************************************************************
000203*WARNING.  THIS COMPUTER PROGRAM IS PROTECTED BY COPYRIGHT LAW  *
000204*AND INTERNATIONAL TREATIES.  UNAUTHORIZED REPRODUCTION OR      *
000205*DISTRIBUTION OF THIS PROGRAM, OR ANY PORTION OF IT, MAY RESULT *
000206*IN SEVERE CIVIL AND CRIMINAL PENATLIES, AND WILL BE PROSECUTED *
000207*TO THE MAXIMUM EXTENT POSSIBLE UNDER THE LAW.                  *
000208*COPYRIGHT 1999 PAYSYS INTERNATIONAL, INC.  ALL RIGHTS RESERVED.*
000209*****************************************************************
000300*****************************************************************
000400*                                                               *
000500*   V - PLUS  M E R C H A N T   B A N K C A R D   S Y S T E M   *
000600*                                                               *
000700*      MBOMM01 - MERCHANT MASTER RECORD ADD/MAINT/INQ           *
000800*                SCREEN 01                                      *
000900*                                                               *
001000*              1. TRANSIDS                                      *
001100*                 A. MBAM                                       *
001200*                 B. MBMM                                       *
001300*                 C. MBQM                                       *
001400*              2. MAPS USED -                                   *
001500*                 A. MBMM01 (SCREEN 01)                         *
001600*              3. FILES USED -                                  *
001700*                 A. MMMM (MERCHANT MASTER FILE)                *
001800*                 B. MMFS (FIELD SECURITY FILE)                 *
001900*                 C. MMOC (CONTROL FILE)                        *
002000*                 D. MMNL (NAME LOCATE FILE)                    *
002100*                 E. MMSM (STORE MASTER FILE)                   *
002200*                 G. MMIC (INVENTORY CONTROL FILE)              *
002300*                 H. MMPF (PLATE FILE)                          *
002400*                 I. MMXR (STORE XREF)                          *
002500*                 J. MML1 (LOG FILE)                            *
002600*                                                               *
002700*****************************************************************
002800*
002900 ENVIRONMENT DIVISION.
003000*
003100 DATA DIVISION.
003200*
003300 WORKING-STORAGE SECTION.
003400*
003500 01  FILLER                  PIC  X(12)      VALUE '** WS-BEG **'.
003600*
003700 01  FILLER                  PIC  X(14)      VALUE
003800     'MISCELLANEOUS:'.
003900*
004000 01  WS-MISCELLANEOUS.
004100     03  WS-FIELD-POSITION   PIC S9(03)      VALUE ZEROES COMP-3.
004200     03  WS-CRB-FLAG         PIC  X(01)      VALUE SPACES.
004300*
004400 01  FILLER                  PIC  X(17)      VALUE
004500     'PROGRAM SWITCHES:'.
004600*
004700 01  WS-PROGRAM-SWITCHES.
004800     03  WS-UPDATE-SW        PIC  X(01)      VALUE 'N'.
004900         88  WS-UPDATE-SW-YES                VALUE 'Y'.
005000         88  WS-UPDATE-SW-NO                 VALUE 'N'.
005100     03  WS-STORE-XREF-SW    PIC  X(01)      VALUE 'N'.
005200         88  WS-STORE-XREF-YES               VALUE 'Y'.
005300     03  WS-MAINT-SSR-SW     PIC  X(01)      VALUE 'N'.
005400         88  WS-MAINT-SSR-SW-YES             VALUE 'Y'.
005500     03  WS-STORE-UPDATE-SW  PIC  X(01)      VALUE 'N'.
005600         88  WS-STORE-UPDATE-SW-YES          VALUE 'Y'.
005700         88  WS-STORE-UPDATE-SW-NO           VALUE 'N'.
005800     03  WS-STORE-CRB-UPDATE-SW
005900                             PIC  X(01)      VALUE 'N'.
006000         88  WS-STORE-CRB-UPDATE-SW-YES      VALUE 'Y'.
006100         88  WS-STORE-CRB-UPDATE-SW-NO       VALUE 'N'.
006200     03  WS-STORE-ADDR-SW    PIC  X(01)      VALUE 'N'.
006300         88  WS-STORE-ADDR-SW-YES            VALUE 'Y'.
006400         88  WS-STORE-ADDR-SW-NO             VALUE 'N'.
006500     03  WS-INDEX-X.
006600         05  WS-INDEX        PIC  9(04)      VALUE ZEROS.
006700     03  TS-QUEUE-NAME.
006800         05  TS-QN-TERMID    PIC  X(04)      VALUE SPACES.
006900         05  TS-QN-TRANID    PIC  X(04)      VALUE 'MBUI'.
007000/
007100 01  FILLER                  PIC  X(29)      VALUE
007200     'I/O REQUEST BLOCK WORK AREAS:'.
007300*
007400     COPY MBIOWS.
007500/
007600 01  FILLER                  PIC  X(18)      VALUE
007700     'I/O REQUEST BLOCK:'.
007800*
007900     COPY MBIORO.
008000/
008100 01  FILLER                  PIC  X(19)      VALUE
008200     'MERCHANT MASTER IO:'.
008300*
008400     COPY MMMMIO.
008500/
008600 01  FILLER                  PIC  X(35)      VALUE
008700     'MERCHANT MASTER INITIALIZER RECORD:'.
008800*
008900     COPY MMMMIR.
009000/
009100 01  FILLER                  PIC  X(16)      VALUE
009200     'STORE MASTER IO:'.
009300*
009400     COPY MMSMIO.
009500/
009600 01  FILLER                  PIC  X(20)      VALUE
009700     'STORE XREF INIT REC:'.
009800*
009900     COPY MMXRIR.
010000/
010100 01  FILLER                  PIC  X(25)      VALUE
010200     'LOG RECORD REQUEST BLOCK:'.
010300*
010400     COPY MML1WS REPLACING ==:MML1:== BY ==MML1==.
010500/
010600 01  FILLER                  PIC  X(29)      VALUE
010700     'MERCHANT MASTER FIELDS TABLE:'.
010800*
010900     COPY MMMMTB.
011000/
011100 01  FILLER                  PIC  X(26)      VALUE
011200     'STORE MASTER FIELDS TABLE:'.
011300*
011400     COPY MMSMTB.
011500/
011600 01  FILLER                  PIC  X(20)      VALUE
011700     'CCS DATE WORK AREAS:'.
011800*
011900     COPY SS01WS.
012000/
012100 01  FILLER                  PIC  X(15)      VALUE
012200     'CCS WORK AREAS:'.
012300*
012400     COPY SS08WS.
012500/
012600     COPY SS00WS.
012700/
012800     COPY SMFTWS.
012900/
013000     COPY SMPTRL REPLACING ==:SMPT:== BY ==SMPT==.
013100/
013200     COPY MB61LK.
013300/
013400     COPY SC00WS.
013500/
013600     COPY SMCOWS.
013700/
013800     COPY SMCORL.
013900/
014000 01  FILLER                  PIC  X(12)      VALUE '** WS-END **'.
014100/
014200 LINKAGE SECTION.
014300*
014400 01  DFHCOMMAREA.
014500*
014600     COPY MB60WS.
014700/
014800*****************************
014900*    MERCHANT MASTER MAP    *
015000*****************************
015100*
015200     COPY MBMM01.
015300/
015400******************************************
015500*    MERCHANT MASTER MAP REDEFINITION    *
015600******************************************
015700*
015800     COPY MBMM01R.
015900/
016000***************************************
016100*    MERCHANT MASTER RECORD LAYOUT    *
016200***************************************
016300*
016400     COPY MMMMRL.
016500/
016600***************************************
016700*    STORE MASTER RECORD LAYOUT       *
016800***************************************
016900*
017000     COPY MMSMRL.
017100/
017200**************************************
017300*    FIELD SECURITY RECORD LAYOUT    *
017400**************************************
017500*
017600     COPY MMFSRL.
017700/
017800**************************************
017900*    CONTROL FILE RECORD LAYOUT      *
018000**************************************
018100*
018200     COPY MMOCRL.
018300/
018400**************************************
018500*    INVENTORY CONTROL RECORD LAYOUT *
018600**************************************
018700*
018800     COPY MMICRL.
018900/
019000**************************************
019100*    PLATE REQUEST RECORD LAYOUT     *
019200**************************************
019300*
019400     COPY MMPFRL.
019500/
019600**************************************
019700*    STORE XREF RECORD LAYOUT        *
019800**************************************
019900*
020000     COPY MMXRRL.
020100/
020200**************************************
020300*    NAME LOCATE  RECORD LAYOUT      *
020400**************************************
020500*
020600     COPY MMNLRL.
020700/
020800***************************
020900*    LOG RECORD LAYOUT    *
021000***************************
021100*
021200     COPY MML1RL REPLACING ==:MML1:== BY ==MML1==.
021300/
021400***************************************
021500*    USER INPUT TEMP STORAGE RECORD   *
021600***************************************
021700*
021800     COPY MBUITS.
021900/
022000 PROCEDURE DIVISION.
022100*
022200 A000-HOUSEKEEPING SECTION.
022300*
022400 A020-INIT.
022500*
022600     MOVE 'PC01'                 TO MBCA-PROGRAM-LOCATION.
022700     PERFORM MB70PD-ON-LINE-HOUSEKEEPING
022800                                 THRU MB70PD-OLH-EXIT.
022900*
023000     IF  MBCA-MBUI-UI-YES
023100         NEXT SENTENCE
023200     ELSE
023300         SET MBCA-MBUI-UI-NO     TO TRUE.
023400*
023500     MOVE MBCA-TERMINAL-ID       TO TS-QN-TERMID.
023600*
023700     IF  MBCA-RECEIVE-SCREEN
023800         GO TO C000-RECEIVE-SCREEN.
023900/
024000 B000-SEND-SCREEN SECTION.
024100*
024200*********************************************
024300*    GET CICS STORAGE NEEDED FOR THE MAP    *
024400*********************************************
024500*
024600     MOVE 'SC01'                 TO MBCA-PROGRAM-LOCATION.
024700     PERFORM MB60PD-GETMAIN-FOR-MAP
024800                                 THRU MB60PD-GFM-EXIT.
024900*
025000*******************************************
025100*    INITIALIZE THE STANDARD MAP LINES    *
025200*******************************************
025300*
025400     PERFORM MB60PD-INIT-STD-MAP-LINES
025500                                 THRU MB60PD-ISML-EXIT.
025600*
025700*****************************************
025800*    READ THE MERCHANT MASTER RECORD    *
025900*    FOR SUBSEQUENT DISPLAY             *
026000*****************************************
026100*
026200     MOVE MBCA-MERCHANT-ORG      TO MBIOWS-MMMM-ORG
026300                                    MM01-ORG.
026400     MOVE MBCA-MERCHANT          TO MBIOWS-MMMM-MERCHANT
026500                                    MM01-MERCHANT.
026600     MOVE 'FC01'                 TO MBCA-PROGRAM-LOCATION.
026700     SET MBIORO-READ-RANDOM      TO TRUE.
026800     PERFORM MMMMAO-ACCESS       THRU MMMMAO-ACCESS-EXIT.
026900*
027000*****************************************
027100*    READ THE INVENTORY CONTROL RECORD  *
027200*****************************************
027300*
027400     MOVE MBCA-MERCHANT-ORG      TO MBIOWS-MMIC-ORG.
027500     MOVE MBCA-MERCHANT          TO MBIOWS-MMIC-MERCHANT.
027600     MOVE SS08WS-CICS-FC-NOTFND  TO MBIORO-TEMP-STATUS-1.
027700     SET MBIOWS-MMIC-TYPE-IS-MERCHANT
027800                                 TO TRUE.
027900     MOVE 'FC02'                 TO MBCA-PROGRAM-LOCATION.
028000     SET MBIORO-READ-RANDOM      TO TRUE.
028100     PERFORM MMICAO-ACCESS       THRU MMICAO-ACCESS-EXIT.
028200*
028300     IF  SS08WS-RC-FC-NOTFND
028400         MOVE 'N'                TO MM01-INVENTORY
028500     ELSE
028600         MOVE 'Y'                TO MM01-INVENTORY.
028700*
028800*****************************************
028900*    READ THE PLATE REQUEST RECORD      *
029000*****************************************
029100*
029200     MOVE MBCA-MERCHANT-ORG      TO MBIOWS-MMPF-ORG.
029300     MOVE MBCA-MERCHANT          TO MBIOWS-MMPF-MERCHANT.
029400     MOVE SS08WS-CICS-FC-NOTFND  TO MBIORO-TEMP-STATUS-1.
029500     SET MBIOWS-MMPF-TYPE-IS-MERCHANT
029600                                 TO TRUE.
029700     MOVE 'FC03'                 TO MBCA-PROGRAM-LOCATION.
029800     SET MBIORO-READ-RANDOM      TO TRUE.
029900     PERFORM MMPFAO-ACCESS       THRU MMPFAO-ACCESS-EXIT.
030000*
030100     IF  SS08WS-RC-FC-NOTFND
030200         MOVE 'N'                TO MM01-PLATE-FILE
030300     ELSE
030400         MOVE 'Y'                TO MM01-PLATE-FILE.
030500*
030600******************************************************
030700*    MOVE LAST MAINT DATE AND LAST MAINT OPERATOR    *
030800*    TO THE SCREEN, DEPENDING ON THE FUNCTION        *
030900******************************************************
031000*
031100     IF  MBCA-PTI-FUNCTION-IS-ADD
031200         MOVE DFHBMDAS           TO MM01-LAST-MAINT-DATE-LIT-A
031300                                    MM01-LAST-MAINT-DATE-A
031400                                    MM01-LAST-MAINT-OPER-LIT-A
031500                                    MM01-LAST-MAINT-OPER-A
031600                                    MM01-STATUS-LIT-A
031700                                    MM01-STATUS-A
031800                                    MM01-STATUS-OPER-LIT-A
031900                                    MM01-STATUS-OPER-A
032000                                    MM01-STATUS-DATE-LIT-A
032100                                    MM01-STATUS-DATE-A
032200                                    MM01-REASON-LIT-A
032300                                    MM01-REASON-A
032400                                    MM01-OUT-OF-BUS-DATE-LIT-A
032500                                    MM01-OUT-OF-BUS-DATE-A
032600                                    MM01-OWNERSHIP-CHG-DATE-LIT-A
032700                                    MM01-OWNERSHIP-CHG-DATE-A
032800     ELSE
032900         MOVE MMMM-LAST-MAINT-DATE
033000                                 TO SS01WS-JULIAN
033100         PERFORM SS26PD-NUMERICALLY-EDIT-DATE
033200                                 THRU SS26PD-NED-EXIT
033300         MOVE SS01WS-XX-XX-YYYY  TO MM01-LAST-MAINT-DATE
033400         MOVE MMMM-LAST-MAINT-OPER
033500                                 TO MM01-LAST-MAINT-OPER
033600         MOVE MMMM-OWNERSHIP-CHG-DATE
033700                                 TO SS01WS-JULIAN
033800         PERFORM SS26PD-NUMERICALLY-EDIT-DATE
033900                                 THRU SS26PD-NED-EXIT
034000         MOVE SS01WS-XX-XX-YYYY  TO MM01-OWNERSHIP-CHG-DATE
034100         MOVE DFHBMASB           TO MM01-OWNERSHIP-CHG-DATE-A
034200         IF  MMMM-REC-CLOSED
034300         OR  MMMM-REC-PENDING-PURGE
034400         OR  MMMM-REC-PURGING
034500             EVALUATE TRUE
034600                 WHEN MMMM-REC-CLOSED
034700                     MOVE MMMM-DATE-CLOSED
034800                                 TO SS01WS-JULIAN
034900                     PERFORM SS26PD-NUMERICALLY-EDIT-DATE
035000                                 THRU SS26PD-NED-EXIT
035100                     MOVE SS01WS-XX-XX-YYYY
035200                                 TO MM01-STATUS-DATE
035300                 WHEN MMMM-REC-PURGING
035400                     MOVE MMMM-PURGING-DATE
035500                                 TO SS01WS-JULIAN
035600                     PERFORM SS26PD-NUMERICALLY-EDIT-DATE
035700                                 THRU SS26PD-NED-EXIT
035800                     MOVE SS01WS-XX-XX-YYYY
035900                                 TO MM01-STATUS-DATE
036000                 WHEN OTHER
036100                     MOVE ZEROS
036200                                 TO SS01WS-JULIAN
036300                     PERFORM SS26PD-NUMERICALLY-EDIT-DATE
036400                                 THRU SS26PD-NED-EXIT
036500                     MOVE SS01WS-XX-XX-YYYY
036600                                 TO MM01-STATUS-DATE
036700             END-EVALUATE
036800             MOVE MMMM-REC-STATUS
036900                                 TO MM01-STATUS
037000             MOVE MMMM-STATUS-CHANGE-OPER
037100                                 TO MM01-STATUS-OPER
037200             MOVE MMMM-CLOSE-REASON
037300                                 TO MM01-REASON
037400             MOVE MMMM-OUT-OF-BUS-DATE
037500                                 TO SS01WS-JULIAN
037600             PERFORM SS26PD-NUMERICALLY-EDIT-DATE
037700                                 THRU SS26PD-NED-EXIT
037800             MOVE SS01WS-XX-XX-YYYY
037900                                 TO MM01-OUT-OF-BUS-DATE
038000             MOVE DFHBMASB       TO MM01-OUT-OF-BUS-DATE-A
038100         ELSE
038200             MOVE DFHBMDAS       TO MM01-STATUS-LIT-A
038300                                    MM01-STATUS-A
038400                                    MM01-STATUS-OPER-LIT-A
038500                                    MM01-STATUS-OPER-A
038600                                    MM01-STATUS-DATE-LIT-A
038700                                    MM01-STATUS-DATE-A
038800                                    MM01-REASON-LIT-A
038900                                    MM01-REASON-A
039000                                    MM01-OUT-OF-BUS-DATE-LIT-A
039100                                    MM01-OUT-OF-BUS-DATE-A.
039200*
039300****************************************
039400*    READ THE FIELD SECURITY RECORD    *
039500****************************************
039600*
039700     MOVE 'FC04'                 TO MBCA-PROGRAM-LOCATION.
039800     PERFORM Y900-READ-MMFS      THRU Y909-READ-MMFS-EXIT.
039900*
040000 B020-MOVE-FIELDS-TO-SCREEN.
040100*
040200*****************************************
040300*    MOVE THE MERCHANT MASTER FIELDS    *
040400*    FROM THE RECORD TO THE SCREEN      *
040500*****************************************
040600*
040700     SET X-MMMM-PRIMARY          TO 1.
040800*
040900     PERFORM Y010-MOVE-COUNTRY-CODE
041000                                 THRU Y019-EXIT.
041100*
041200     PERFORM Y030-MOVE-DBA-NAME  THRU Y039-EXIT.
041300*
041400     PERFORM Y050-MOVE-SINGLE-STORE-FLAG
041500                                 THRU Y059-EXIT.
041600*
041700     PERFORM Y070-MOVE-DBA-CITY  THRU Y079-EXIT.
041800*
041900     PERFORM Y090-MOVE-DBA-COUNTRY-CODE
042000                                 THRU Y099-EXIT.
042100*
042200     PERFORM Y110-MOVE-PRIM-ADDRESS1
042300                                 THRU Y119-EXIT.
042400*
042500     PERFORM Y130-MOVE-PRIM-ADDRESS2
042600                                 THRU Y139-EXIT.
042700*
042800     PERFORM Y150-MOVE-PRIM-ADDRESS3
042900                                 THRU Y159-EXIT.
043000*
043100     PERFORM Y170-MOVE-PRIM-ADDRESS4
043200                                 THRU Y179-EXIT.
043300*
043400     PERFORM Y190-MOVE-PRIM-ADDRESS5
043500                                 THRU Y199-EXIT.
043600*
043700     PERFORM Y210-MOVE-PRIM-STATE
043800                                 THRU Y219-EXIT.
043900*
044000     PERFORM Y230-MOVE-PRIM-PHONE
044100                                 THRU Y239-EXIT.
044200*
044300     PERFORM Y250-MOVE-PRIM-POSTAL-CODE
044400                                 THRU Y259-EXIT.
044500*
044600     PERFORM Y270-MOVE-PRIM-FAX  THRU Y279-EXIT.
044700*
044800******************************************
044900*    SET THE CURSOR AND SCREEN NUMBER    *
045000******************************************
045100*
045200     IF  MBCA-PTI-FUNCTION-IS-INQUIRY
045300         MOVE SS08WS-CURSOR      TO MM01-ALT-TRANID-L
045400     ELSE
045500         PERFORM Y800-SET-CURSOR THRU Y809-SC-EXIT.
045600*
045700     COMPUTE MBCA-SCREEN-NBR     =  MBCA-SCREEN-NBR - 50.
045800*
045900**********************
046000*    SEND THE MAP    *
046100**********************
046200*
046300     MOVE 'BM01'                 TO MBCA-PROGRAM-LOCATION.
046400     PERFORM MB60PD-SEND-MAP-WITH-ERASE
046500                                 THRU MB60PD-SMWE-EXIT.
046600*
046700************************
046800*    RETURN TO CICS    *
046900************************
047000*
047100     MOVE 'PC02'                 TO MBCA-PROGRAM-LOCATION.
047200     PERFORM MB70PD-RETURN-TRANS-ID
047300                                 THRU MB70PD-RTI-EXIT.
047400/
047500 C000-RECEIVE-SCREEN SECTION.
047600*
047700******************************************
047800*    THIS SECTION RECEIVES THE SCREEN    *
047900******************************************
048000*
048100     IF  MBCA-MBUI-UI-YES
048200*
048300****************************************************************
048400*    ACQUIRE MAIN STORAGE FOR TEMP STORAGE RECORD              *
048500****************************************************************
048600*
048700         MOVE 'TS01'             TO MBCA-PROGRAM-LOCATION
048800         EXEC CICS GETMAIN
048900                   FLENGTH (LENGTH  OF MBUITS-RECORD)
049000
049100                   SET     (ADDRESS OF MBUITS-RECORD)
049200
049300              END-EXEC
049400*
049500***********************************************
049600*    READ THE TEMP STORAGE RECORD             *
049700***********************************************
049800*
049900         MOVE 'TS02'             TO MBCA-PROGRAM-LOCATION
050000*
050100         EXEC CICS READQ TS
050200                   QUEUE   (TS-QUEUE-NAME)
050300                   INTO    (MBUITS-RECORD)
050400                   LENGTH  (LENGTH  OF MBUITS-RECORD)
050500                   ITEM    (1)
050600              END-EXEC
050700*
050800***********************************************
050900*    DELETE THE TEMP STORAGE RECORD           *
051000***********************************************
051100*
051200         MOVE 'TS03'             TO MBCA-PROGRAM-LOCATION
051300*
051400         EXEC CICS IGNORE CONDITION
051500                   QIDERR
051600              END-EXEC
051700*
051800         EXEC CICS DELETEQ TS
051900                   QUEUE  (TS-QUEUE-NAME)
052000              END-EXEC
052100         MOVE 'SC02'             TO MBCA-PROGRAM-LOCATION
052200         PERFORM MB60PD-GETMAIN-FOR-MAP
052300                                 THRU MB60PD-GFM-EXIT
052400         MOVE MBUITS-VAR-DATA    TO MBMM01I
052500     ELSE
052600         MOVE 'BM02'             TO MBCA-PROGRAM-LOCATION
052700         PERFORM MB60PD-RECEIVE-MAP
052800                                 THRU MB60PD-RM-EXIT.
052900*
053000**************************************************************
053100*    CHECK FOR ANOTHER TRANSACTION ID ENTERED BY THE USER    *
053200**************************************************************
053300*
053400     MOVE 'PC03'                 TO MBCA-PROGRAM-LOCATION.
053500     PERFORM MB60PD-NEW-TRANS-ROUTINE
053600                                 THRU MB60PD-NTR-EXIT.
053700*
053800****************************************************
053900*    BYPASS ALL SCREEN EDITS IF THIS IS INQIURY    *
054000****************************************************
054100*
054200     IF  MBCA-PTI-FUNCTION-IS-INQUIRY
054300         GO TO F000-SETUP-COMMAREA.
054400*
054500*****************************************
054600*    READ THE MERCHANT MASTER RECORD    *
054700*****************************************
054800*
054900     IF  MBCA-PTI-FUNCTION-IS-ADD
055000     AND MBCA-MBUI-UI-YES
055100     AND MBCA-MBUI-UI-UPDATE-NO
055200         MOVE 'SC03'             TO MBCA-PROGRAM-LOCATION
055300         SET MBIORO-GETMAIN      TO TRUE
055400         PERFORM MMMMAO-ACCESS   THRU MMMMAO-ACCESS-EXIT
055500         MOVE MMMMIR-RECORD      TO MMMM-RECORD
055600     ELSE
055700         MOVE SS08WS-CICS-FC-NOTFND TO MBIORO-TEMP-STATUS-1
055800         MOVE MBCA-MERCHANT-ORG  TO MBIOWS-MMMM-ORG
055900                                    MM01-ORG
056000         MOVE MBCA-MERCHANT      TO MBIOWS-MMMM-MERCHANT
056100                                    MM01-MERCHANT
056200         MOVE 'FC05'             TO MBCA-PROGRAM-LOCATION
056300         SET MBIORO-READ-RANDOM  TO TRUE
056400         PERFORM MMMMAO-ACCESS   THRU MMMMAO-ACCESS-EXIT
056500         IF  SS08WS-RC-FC-NOTFND
056600         AND MBCA-MBUI-UI-YES
056700             MOVE 'MBUI'         TO MBCA-TRANS-ID
056800                                    MBCA-PREV-TRANS-ID
056900             MOVE 01             TO MBCA-SCREEN-NBR
057000             MOVE 'MER'          TO MM01-FILLER
057100             SET MBCA-MBUI-ERROR-YES
057200                                 TO TRUE
057300             GO TO F000-SETUP-COMMAREA.
057400*
057500     IF (MBCA-PTI-FUNCTION-IS-MAINT
057600     AND MBCA-MBUI-UI-YES
057700     AND (MMMM-REC-PURGED
057800       OR MMMM-REC-INCOMPLETE))
057900     OR
058000        (MBCA-PTI-FUNCTION-IS-ADD
058100     AND MBCA-MBUI-UI-YES
058200     AND MMMM-REC-PURGED)
058300         MOVE 'MBUI'             TO MBCA-TRANS-ID
058400                                    MBCA-PREV-TRANS-ID
058500         MOVE 01                 TO MBCA-SCREEN-NBR
058600         MOVE 'MER'              TO MM01-FILLER
058700         SET MBCA-MBUI-ERROR-YES
058800                                 TO TRUE
058900         GO TO F000-SETUP-COMMAREA.
059000*
059100***********************************************************
059200*    MOVE THE LAST MAINT DATE AND LAST MAINT OPERATOR,    *
059300*    DEPENDING ON THE FUNCTION                            *
059400***********************************************************
059500*
059600     IF  MBCA-PTI-FUNCTION-IS-ADD
059700         MOVE DFHBMDAS           TO MM01-LAST-MAINT-DATE-LIT-A
059800                                    MM01-LAST-MAINT-DATE-A
059900                                    MM01-LAST-MAINT-OPER-LIT-A
060000                                    MM01-LAST-MAINT-OPER-A
060100                                    MM01-STATUS-LIT-A
060200                                    MM01-STATUS-A
060300                                    MM01-STATUS-OPER-LIT-A
060400                                    MM01-STATUS-OPER-A
060500                                    MM01-STATUS-DATE-LIT-A
060600                                    MM01-STATUS-DATE-A
060700                                    MM01-REASON-LIT-A
060800                                    MM01-REASON-A
060900                                    MM01-OUT-OF-BUS-DATE-LIT-A
061000                                    MM01-OUT-OF-BUS-DATE-A
061100                                    MM01-OWNERSHIP-CHG-DATE-LIT-A
061200                                    MM01-OWNERSHIP-CHG-DATE-A
061300     ELSE
061400         MOVE MMMM-LAST-MAINT-DATE
061500                                 TO SS01WS-JULIAN
061600         PERFORM SS26PD-NUMERICALLY-EDIT-DATE
061700                                 THRU SS26PD-NED-EXIT
061800         MOVE SS01WS-XX-XX-YYYY  TO MM01-LAST-MAINT-DATE
061900         MOVE MMMM-LAST-MAINT-OPER
062000                                 TO MM01-LAST-MAINT-OPER
062100         MOVE MMMM-OWNERSHIP-CHG-DATE
062200                                 TO SS01WS-JULIAN
062300         PERFORM SS26PD-NUMERICALLY-EDIT-DATE
062400                                 THRU SS26PD-NED-EXIT
062500         MOVE SS01WS-XX-XX-YYYY  TO MM01-OWNERSHIP-CHG-DATE
062600         MOVE DFHBMASB           TO MM01-OWNERSHIP-CHG-DATE-A
062700         IF  MMMM-REC-CLOSED
062800         OR  MMMM-REC-PENDING-PURGE
062900         OR  MMMM-REC-PURGING
063000             EVALUATE TRUE
063100                 WHEN MMMM-REC-CLOSED
063200                     MOVE MMMM-DATE-CLOSED
063300                                 TO SS01WS-JULIAN
063400                     PERFORM SS26PD-NUMERICALLY-EDIT-DATE
063500                                 THRU SS26PD-NED-EXIT
063600                     MOVE SS01WS-XX-XX-YYYY
063700                                 TO MM01-STATUS-DATE
063800                 WHEN MMMM-REC-PURGING
063900                     MOVE MMMM-PURGING-DATE
064000                                 TO SS01WS-JULIAN
064100                     PERFORM SS26PD-NUMERICALLY-EDIT-DATE
064200                        THRU SS26PD-NED-EXIT
064300                     MOVE SS01WS-XX-XX-YYYY
064400                                 TO MM01-STATUS-DATE
064500             END-EVALUATE
064600             MOVE MMMM-REC-STATUS
064700                                 TO MM01-STATUS
064800             MOVE MMMM-STATUS-CHANGE-OPER
064900                                 TO MM01-STATUS-OPER
065000             MOVE MMMM-CLOSE-REASON
065100                                 TO MM01-REASON
065200             MOVE MMMM-OUT-OF-BUS-DATE
065300                                 TO SS01WS-JULIAN
065400             PERFORM SS26PD-NUMERICALLY-EDIT-DATE
065500                                 THRU SS26PD-NED-EXIT
065600             MOVE SS01WS-XX-XX-YYYY
065700                                 TO MM01-OUT-OF-BUS-DATE
065800             MOVE DFHBMASB       TO MM01-OUT-OF-BUS-DATE-A
065900         ELSE
066000             MOVE DFHBMDAS       TO MM01-STATUS-LIT-A
066100                                    MM01-STATUS-A
066200                                    MM01-STATUS-OPER-LIT-A
066300                                    MM01-STATUS-OPER-A
066400                                    MM01-STATUS-DATE-LIT-A
066500                                    MM01-STATUS-DATE-A
066600                                    MM01-REASON-LIT-A
066700                                    MM01-REASON-A
066800                                    MM01-OUT-OF-BUS-DATE-LIT-A
066900                                    MM01-OUT-OF-BUS-DATE-A.
067000****************************************
067100*    READ THE FIELD SECURITY RECORD    *
067200****************************************
067300*
067400     MOVE 'FC06'                 TO MBCA-PROGRAM-LOCATION.
067500     PERFORM Y900-READ-MMFS      THRU Y909-READ-MMFS-EXIT.
067600*
067700 C020-FIELD-EDITS.
067800*
067900*********************
068000*    FIELD EDITS    *
068100*********************
068200*
068300     SET X-MMMM-PRIMARY          TO 1.
068400*
068500     PERFORM W010-EDIT-COUNTRY-CODE
068600                                 THRU W019-EDCC-EXIT.
068700*
068800     PERFORM W030-EDIT-DBA-NAME  THRU W039-EDN-EXIT.
068900*
069000     PERFORM W050-EDIT-SINGLE-STORE-FLAG
069100                                 THRU W059-ESSF-EXIT.
069200*
069300     IF  ((MM01-SINGLE-STORE-YES
069400     AND MMMM-STORE-NBR IS GREATER THAN ZEROS)
069500     OR  WS-STORE-UPDATE-SW-YES)
069600         MOVE 'FC07'             TO MBCA-PROGRAM-LOCATION
069700         MOVE MBCA-MERCHANT-ORG  TO MBIOWS-MMSM-ORG
069800         MOVE MMMM-STORE-NBR     TO MBIOWS-MMSM-STORE
069900         SET MBIORO-READ-RANDOM  TO TRUE
070000         PERFORM MMSMAO-ACCESS   THRU MMSMAO-ACCESS-EXIT.
070100*
070200     PERFORM W070-EDIT-DBA-CITY  THRU W079-EDC-EXIT.
070300*
070400     PERFORM W090-EDIT-DBA-COUNTRY-CODE
070500                                 THRU W099-EDCC-EXIT.
070600*
070700     PERFORM W110-EDIT-PRIM-ADDRESS1
070800                                 THRU W119-EPA1-EXIT.
070900*
071000     PERFORM W130-EDIT-PRIM-ADDRESS2
071100                                 THRU W139-EPA2-EXIT.
071200*
071300     PERFORM W150-EDIT-PRIM-ADDRESS3
071400                                 THRU W159-EPA3-EXIT.
071500*
071600     PERFORM W170-EDIT-PRIM-ADDRESS4
071700                                 THRU W179-EPA4-EXIT.
071800*
071900     PERFORM W190-EDIT-PRIM-ADDRESS5
072000                                 THRU W199-EPA5-EXIT.
072100*
072200     PERFORM W210-EDIT-PRIM-STATE
072300                                 THRU W219-EPS-EXIT.
072400*
072500     PERFORM W230-EDIT-PRIM-PHONE
072600                                 THRU W239-EPP-EXIT.
072700*
072800     PERFORM W250-EDIT-PRIM-POSTAL-CODE
072900                                 THRU W259-EPPC-EXIT.
073000*
073100     PERFORM W270-EDIT-PRIM-FAX  THRU W279-EPF-EXIT.
073200*
073300 C040-CROSS-EDITS.
073400*
073500     PERFORM W290-CROSS-EDIT-SINGLE-STORE
073600                                 THRU W299-EXIT.
073700*
073800     IF  MBCA-PTI-FUNCTION-IS-MAINT
073900     AND NOT MMMM-REC-MODEL
074000         PERFORM W300-CROSS-EDIT-CRB
074100                                 THRU W309-EXIT.
074200/
074300 D000-RETURN-ERRORS SECTION.
074400*
074500     IF  SS08WS-ERROR-SW-NO
074600         GO TO E000-UPDATE-FILE.
074700*
074800     IF  MBCA-MBUI-UI-YES
074900         MOVE 'MBUI'             TO MBCA-TRANS-ID
075000                                    MBCA-PREV-TRANS-ID
075100         MOVE 01                 TO MBCA-SCREEN-NBR
075200         SET MBCA-MBUI-ERROR-YES TO TRUE
075300         GO TO F090-TRANSFER-XCTL.
075400*
075500***************************************************************
075600*    INITIALIZE THE STANDARD MAP LINES.  IN AN ERROR          *
075700*    CONDITION, THIS ROUTINE IS PERFORMED PRIMARILY           *
075800*    TO UPDATE THE DATE AND TIME ON THE SCREEN.               *
075900***************************************************************
076000*
076100     PERFORM MB60PD-INIT-STD-MAP-LINES
076200                                 THRU MB60PD-ISML-EXIT.
076300*
076400**********************
076500*    SEND THE MAP    *
076600**********************
076700*
076800     MOVE 'BM03'                 TO MBCA-PROGRAM-LOCATION.
076900     PERFORM MB60PD-SEND-MAP-DATA-ONLY
077000                                 THRU MB60PD-SMDO-EXIT.
077100*
077200************************
077300*    RETURN TO CICS    *
077400************************
077500*
077600     MOVE 'PC04'                 TO MBCA-PROGRAM-LOCATION.
077700     PERFORM MB70PD-RETURN-TRANS-ID
077800                                 THRU MB70PD-RTI-EXIT.
077900/
078000 E000-UPDATE-FILE SECTION.
078100*
078200     IF  MBCA-MBUI-UI-YES
078300         SET MBCA-MBUI-ERROR-NO  TO TRUE.
078400*
078500     IF  MBCA-MBUI-UI-YES
078600     AND MBCA-MBUI-UI-UPDATE-NO
078700         GO TO F090-TRANSFER-XCTL.
078800*
078900****************************************************
079000*    READ THE MERCHANT MASTER RECORD FOR UPDATE    *
079100****************************************************
079200*
079300     MOVE MMMM-RECORD            TO MMMMIO-RECORD.
079400*
079500     MOVE 'FC08'                 TO MBCA-PROGRAM-LOCATION.
079600     SET MBIORO-READ-RANDOM-UPDATE
079700                                 TO TRUE.
079800     PERFORM MMMMAO-ACCESS       THRU MMMMAO-ACCESS-EXIT.
079900*
080000     MOVE MMMMIO-RECORD          TO MMMM-RECORD.
080100*
080200****************************************************
080300*    READ THE STORE MASTER RECORD FOR UPDATE       *
080400****************************************************
080500*
080600     IF   WS-STORE-UPDATE-SW-YES
080700     OR   WS-STORE-CRB-UPDATE-SW-YES
080800     OR   WS-STORE-ADDR-SW-YES
080900          MOVE MMSM-RECORD       TO MMSMIO-RECORD
081000          MOVE 'FC09'            TO MBCA-PROGRAM-LOCATION
081100          SET MBIORO-READ-RANDOM-UPDATE
081200                                 TO TRUE
081300          PERFORM MMSMAO-ACCESS  THRU MMSMAO-ACCESS-EXIT
081400          MOVE MMSMIO-RECORD     TO MMSM-RECORD.
081500*
081600*************************************
081700*    OBTAIN STORAGE FOR LOG FILE    *
081800*************************************
081900*
082000     MOVE 'SC04'                 TO MBCA-PROGRAM-LOCATION.
082100     SET MBIORO-GETMAIN          TO TRUE.
082200     PERFORM MML1AO-ACCESS       THRU MML1AO-ACCESS-EXIT.
082300*
082400     IF  MBCA-PTI-FUNCTION-IS-ADD
082500         GO TO E020-UPDATE-FIELDS.
082600*
082700*************************************************
082800*    SET UP THE COMMON PORTION OF THE RECORD    *
082900*************************************************
083000*
083100     MOVE 'MM'                   TO MML1-FILE-CODE.
083200     MOVE MBCA-MERCHANT-ORG      TO MML1-MMMM-ORG.
083300     MOVE MBCA-MERCHANT          TO MML1-MMMM-MERCHANT.
083400     MOVE MBCA-SIGNON-NAME       TO MML1-SIGNON-NAME.
083500     MOVE MBCA-TERMINAL-ID       TO MML1-TERMINAL-ID.
083600     MOVE ZEROS                  TO MML1-SOURCE-CODE.
083700     MOVE MBCA-FIELD-SECURITY    TO MML1-FIELD-SECURITY.
083800*
083900 E020-UPDATE-FIELDS.
084000*
084100     PERFORM X010-UPDATE-COUNTRY-CODE
084200                                 THRU X019-UCC-EXIT.
084300*
084400     PERFORM X030-UPDATE-DBA-NAME
084500                                 THRU X039-UDN-EXIT.
084600*
084700     PERFORM X070-UPDATE-DBA-CITY
084800                                 THRU X079-UDC-EXIT.
084900*
085000     PERFORM X090-UPDATE-DBA-COUNTRY-CODE
085100                                 THRU X099-UDCC-EXIT.
085200*
085300     PERFORM X110-UPDATE-PRIM-ADDRESS1
085400                                 THRU X119-UPA1-EXIT.
085500*
085600     PERFORM X130-UPDATE-PRIM-ADDRESS2
085700                                 THRU X139-UPA2-EXIT.
085800*
085900     PERFORM X150-UPDATE-PRIM-ADDRESS3
086000                                 THRU X159-UPA3-EXIT.
086100*
086200     PERFORM X170-UPDATE-PRIM-ADDRESS4
086300                                 THRU X179-UPA4-EXIT.
086400*
086500     PERFORM X190-UPDATE-PRIM-ADDRESS5
086600                                 THRU X199-UPA5-EXIT.
086700*
086800     PERFORM X210-UPDATE-PRIM-STATE
086900                                 THRU X219-UPS-EXIT.
087000*
087100     PERFORM X230-UPDATE-PRIM-PHONE
087200                                 THRU X239-UPP-EXIT.
087300*
087400     PERFORM X250-UPDATE-PRIM-POSTAL-CODE
087500                                 THRU X259-UPPC-EXIT.
087600*
087700     PERFORM X270-UPDATE-PRIM-FAX
087800                                 THRU X279-UPF-EXIT.
087900*
088000     PERFORM X290-UPDATE-INITIALIZED-FIELDS
088100                                 THRU X299-UIF-EXIT.
088200*
088300     PERFORM X050-UPDATE-SINGLE-STORE-FLAG
088400                                 THRU X059-USSF-EXIT.
088500*
088600 E040-UPDATE-MMMM.
088700*
088800     IF  MBCA-PTI-FUNCTION-IS-ADD
088900         MOVE MBCA-SCREEN-NBR    TO MMMM-ONLINE-STATUS
089000         MOVE MBCA-START-DATE    TO MMMM-LAST-MAINT-DATE
089100         MOVE MBCA-OPERATOR-ID   TO MMMM-LAST-MAINT-OPER
089200         SET WS-UPDATE-SW-YES    TO TRUE.
089300*
089400**************************************************************
089500*    WRITE A LOG RECORD TO SHOW THAT THE LAST MAINT DATE     *
089600*    AND OPERATOR HAS BEEN UPDATED IF FIELDS WERE CHANGED    *
089700*    ON THE SCREEN                                           *
089800**************************************************************
089900*
090000     IF  MBCA-PTI-FUNCTION-IS-MAINT
090100     AND WS-UPDATE-SW-YES
090200         MOVE 0198               TO MML1-FIELD-CODE
090300         MOVE ZEROES             TO MML1-FIELD-OCCURRENCE
090400                                    MML1-FIELD-OCCURRENCE-2
090500         MOVE MML1WS-VL-03       TO MML1-VARIABLE-LENGTH
090600         MOVE MMMM-LAST-MAINT-OPER
090700                                 TO MML1-VL03-B-DATA-X
090800         MOVE MBCA-OPERATOR-ID   TO MMMM-LAST-MAINT-OPER
090900         MOVE MMMM-LAST-MAINT-OPER
091000                                 TO MML1-VL03-A-DATA-X
091100         MOVE 'FC10'             TO MBCA-PROGRAM-LOCATION
091200         PERFORM Y910-WRITE-LOG-RECORD
091300                                 THRU Y919-WLR-EXIT
091400         MOVE 0199               TO MML1-FIELD-CODE
091500         MOVE MML1WS-VL-07       TO MML1-VARIABLE-LENGTH
091600         MOVE MMMM-LAST-MAINT-DATE
091700                                 TO MML1-VL07-B-DATA-9
091800         MOVE MBCA-START-DATE    TO MMMM-LAST-MAINT-DATE
091900         MOVE MMMM-LAST-MAINT-DATE
092000                                 TO MML1-VL07-A-DATA-9
092100         MOVE 'FC11'             TO MBCA-PROGRAM-LOCATION
092200         PERFORM Y910-WRITE-LOG-RECORD
092300                                 THRU Y919-WLR-EXIT.
092400*
092500****************************************************
092600*    REWRITE THE STORE MASTER RECORD IF            *
092700*    THE SINGLE STORE RELATIONSHIP FIELD HAS BEEN  *
092800*    CHANGED FROM A 'Y' TO A 'N'.                  *
092900*    OR THE CRB FLAG HAS BEEN CHANGED              *
093000****************************************************
093100*
093200     IF  WS-STORE-UPDATE-SW-YES
093300     OR  WS-STORE-CRB-UPDATE-SW-YES
093400     OR  WS-STORE-ADDR-SW-YES
093500         MOVE 'FC12'             TO MBCA-PROGRAM-LOCATION
093600         SET MBIORO-REWRITE      TO TRUE
093700         PERFORM MMSMAO-ACCESS   THRU MMSMAO-ACCESS-EXIT
093800     ELSE
093900         MOVE 'FC13'             TO MBCA-PROGRAM-LOCATION
094000         SET MBIORO-UNLOCK       TO TRUE
094100         PERFORM MMSMAO-ACCESS   THRU MMSMAO-ACCESS-EXIT.
094200*
094300****************************************************
094400*    REWRITE THE MERCHANT MASTER RECORD IF         *
094500*    FIELDS HAVE BEEN CHANGED ON THE SCREEN, OR    *
094600*    UNLOCK IT IF THEY HAVE NOT                    *
094700****************************************************
094800*
094900     IF  WS-UPDATE-SW-YES
095000         MOVE 'FC14'             TO MBCA-PROGRAM-LOCATION
095100         SET MBIORO-REWRITE      TO TRUE
095200         PERFORM MMMMAO-ACCESS   THRU MMMMAO-ACCESS-EXIT
095300     ELSE
095400         MOVE 'FC15'             TO MBCA-PROGRAM-LOCATION
095500         SET MBIORO-UNLOCK       TO TRUE
095600         PERFORM MMMMAO-ACCESS   THRU MMMMAO-ACCESS-EXIT.
095700*
095800     PERFORM Y930-READ-MMOC      THRU Y939-RMMOC-EXIT.
095900*
096000     MOVE 'SC05'                 TO MBCA-PROGRAM-LOCATION.
096100     SET MBIORO-GETMAIN          TO TRUE.
096200     PERFORM MMNLAO-ACCESS       THRU MMNLAO-ACCESS-EXIT.
096300*
096400     PERFORM Y920-WRITE-NAME-LOCATE-RECORD
096500                                 THRU Y929-WNLR-EXIT.
096600/
096700 F000-SETUP-COMMAREA SECTION.
096800*
096900***************************************************************
097000*  SET UP COMMAREA FIELDS AND TRANSFER TO THE NEXT PROGRAM    *
097100***************************************************************
097200*
097300     MOVE MBCA-EIBAID            TO SS08WS-EIBAID.
097400*
097500     IF  WS-MAINT-SSR-SW-YES
097600         MOVE 62                 TO MBCA-SCREEN-NBR
097700         GO TO F090-TRANSFER-XCTL.
097800*
097900     IF  MM01-CURRENT-PAGE-L IS GREATER THAN ZERO
098000     AND MM01-CURRENT-PAGE   IS NUMERIC
098100         IF  MM01-CURRENT-PAGE IS GREATER THAN 13
098200             MOVE 63             TO MBCA-SCREEN-NBR
098300             GO TO F090-TRANSFER-XCTL.
098400*
098500     PERFORM MB60PD-EDIT-PAGE-NBR
098600                                 THRU MB60PD-EPN-EXIT.
098700*
098800     IF  SS08WS-VALID-PF-KEY
098900     OR  SS08WS-EIBAID-VALID-PF-KEY
099000         SET MBCA-INITIAL-SCREEN-NBR
099100                                 TO TRUE.
099200*
099300 F090-TRANSFER-XCTL.
099400*
099500     IF  MBCA-MBUI-UI-YES
099600         MOVE 'MBUI'             TO MBCA-TRANS-ID
099700                                    MBCA-PREV-TRANS-ID
099800         MOVE 01                 TO MBCA-SCREEN-NBR
099900         MOVE MBMM01I            TO MBUITS-VAR-DATA
100000         MOVE LENGTH OF MBMM01I  TO MBUITS-VAR-LENGTH
100100         MOVE 'TS10'             TO MBCA-PROGRAM-LOCATION
100200         EXEC CICS WRITEQ TS
100300                   QUEUE   (TS-QUEUE-NAME)
100400                   FROM    (MBUITS-RECORD)
100500                   LENGTH  (LENGTH  OF MBUITS-RECORD)
100600
100700              END-EXEC.
100800*
100900     MOVE 'PC05'                 TO MBCA-PROGRAM-LOCATION.
101000     PERFORM MB70PD-XCTL-TO-MBOXCTL
101100                                 THRU MB70PD-XTM-EXIT.
101200/
101300 W000-FIELD-EDITS SECTION.
101400*
101500*********************************************************
101600*    EACH FIELD IS CODED IN A SEPERATE ROUTINE, AND     *
101700*    IN A LIKE MANNER.  THE COMMENTS FOR THE FLOW OF    *
101800*    THE EDIT ROUTINES CAN BE FOUND IN ROUTINES         *
101900*    'W010-EDIT-SINGLE-STORE-FLAG' THRU 'W019-EPGN-EXIT'*
102000*    EACH ROUTINE MAY CONTAIN COMMENTS, BUT THEY ARE    *
102100*    UNIQUE TO THAT ROUTINE.                            *
102200*********************************************************
102300*
102400 W010-EDIT-COUNTRY-CODE.
102500*
102600     MOVE DFHBMDAS               TO MM01-COUNTRY-CODE-LP-A
102700                                    MM01-COUNTRY-CODE-RP-A.
102800     MOVE DFHBMASK               TO MM01-COUNTRY-CODE-A.
102900*
103000     PERFORM Y015-COUNTRY-CODE-SECURITY
103100                                 THRU Y019-EXIT.
103200*
103300     PERFORM SMCOPXO-OBTAIN-COUNTRY-TABLE
103400        THRU SMCOPXO-OCT-EXIT.
103500*
103600     IF  SMCOWS-RC-NO-COUNTRY-FOUND
103700         GO TO W018-COUNTRY-CODE-ERROR.
103800*
103900     IF  MM01-COUNTRY-CODE-L IS GREATER THAN ZERO
104000         MOVE MM01-COUNTRY-CODE  TO SMCOWS-SEARCH-COUNTRY-CODE
104100         PERFORM SMCOPX-INTERROGATION-SEARCH
104200            THRU SMCOPX-IS-EXIT
104300         IF  SMCOWS-SEARCH-INDEX = ZERO
104400             GO TO W018-COUNTRY-CODE-ERROR
104500         END-IF
104600         MOVE DFHBMASF           TO MM01-COUNTRY-CODE-A
104700         GO TO W019-EDCC-EXIT
104800     ELSE
104900         MOVE MMMM-COUNTRY-CODE (X-MMMM-PRIMARY)
105000                                 TO MM01-COUNTRY-CODE
105100     END-IF.
105200*
105300     IF  MBCA-PTI-FUNCTION-IS-MAINT
105400     OR  NOT MMFS-MT-REQUIRED (X-MMFS-MERCH)
105500         GO TO W019-EDCC-EXIT.
105600*
105700 W018-COUNTRY-CODE-ERROR.
105800*
105900     IF  MM01-COUNTRY-CODE-L IS GREATER THAN ZERO
106000         MOVE DFHBMUBF           TO MM01-COUNTRY-CODE-A
106100     ELSE
106200         MOVE DFHBMBRY           TO MM01-COUNTRY-CODE-A.
106300*
106400     SET SS08WS-ERROR-SW-YES     TO TRUE.
106500     MOVE DFHBMASB               TO MM01-COUNTRY-CODE-LP-A
106600                                    MM01-COUNTRY-CODE-RP-A.
106700     MOVE SS08WS-CURSOR          TO MM01-COUNTRY-CODE-L.
106800*
106900 W019-EDCC-EXIT.
107000     EXIT.
107100*
107200 W030-EDIT-DBA-NAME.
107300*
107400     MOVE DFHBMDAS               TO MM01-DBA-NAME-LP-A
107500                                    MM01-DBA-NAME-RP-A.
107600     MOVE DFHBMASK               TO MM01-DBA-NAME-A.
107700*
107800     PERFORM Y035-DBA-NAME-SECURITY
107900                                 THRU Y039-EXIT.
108000*
108100     IF  MM01-DBA-NAME-L IS GREATER THAN ZERO
108200         MOVE DFHBMASF           TO MM01-DBA-NAME-A
108300         EVALUATE TRUE
108400           WHEN MM01-DBA-NAME  IS EQUAL TO SPACES
108500             CONTINUE
108600           WHEN MM01-DBA-NAME (1:1)
108700                                 IS EQUAL TO SPACE
108800             GO TO W038-DBA-NAME-ERROR
108900           WHEN OTHER
109000             CONTINUE
109100         END-EVALUATE
109200         GO TO W039-EDN-EXIT
109300     ELSE
109400         MOVE MMMM-DBA-NAME      TO MM01-DBA-NAME.
109500*
109600     IF  MBCA-PTI-FUNCTION-IS-MAINT
109700     OR  NOT MMFS-MT-REQUIRED (X-MMFS-MERCH)
109800         GO TO W039-EDN-EXIT.
109900*
110000 W038-DBA-NAME-ERROR.
110100*
110200     IF  MM01-DBA-NAME-L IS GREATER THAN ZERO
110300         MOVE DFHBMUBF           TO MM01-DBA-NAME-A
110400     ELSE
110500         MOVE DFHBMBRY           TO MM01-DBA-NAME-A.
110600*
110700     SET SS08WS-ERROR-SW-YES     TO TRUE.
110800     MOVE DFHBMASB               TO MM01-DBA-NAME-LP-A
110900                                    MM01-DBA-NAME-RP-A.
111000     MOVE SS08WS-CURSOR          TO MM01-DBA-NAME-L.
111100*
111200 W039-EDN-EXIT.
111300     EXIT.
111400*
111500 W050-EDIT-SINGLE-STORE-FLAG.
111600*
111700     MOVE DFHBMDAS               TO MM01-SINGLE-STORE-FLAG-LP-A
111800                                    MM01-SINGLE-STORE-FLAG-RP-A.
111900     MOVE DFHBMASK               TO MM01-SINGLE-STORE-FLAG-A.
112000*
112100     PERFORM Y055-SNGL-STORE-FLAG-SECURITY
112200                                 THRU Y059-EXIT.
112300*
112400     IF  MM01-SINGLE-STORE-FLAG-L IS GREATER THAN ZERO
112500         IF  MM01-VALID-SINGLE-STORE
112600             MOVE DFHBMASF       TO MM01-SINGLE-STORE-FLAG-A
112700         ELSE
112800             GO TO W058-SINGLE-STORE-FLAG-ERROR
112900     ELSE
113000         MOVE MMMM-SINGLE-STORE-FLAG
113100                                 TO MM01-SINGLE-STORE-FLAG.
113200*
113300     IF  MM01-SINGLE-STORE-FLAG-L IS GREATER THAN ZERO
113400     AND MM01-SINGLE-STORE-YES
113500     AND MBCA-PTI-FUNCTION-IS-MAINT
113600     AND NOT MMMM-REC-ACTIVE
113700         GO TO W058-SINGLE-STORE-FLAG-ERROR.
113800     IF  MM01-SINGLE-STORE-FLAG-L IS GREATER THAN ZERO
113900     AND MMMM-SINGLE-STORE-FLAG IS NOT EQUAL
114000                                 TO MM01-SINGLE-STORE-FLAG
114100     AND MM01-SINGLE-STORE-NO
114200     AND MMMM-STORE-NBR IS GREATER THAN ZEROS
114300         SET WS-STORE-UPDATE-SW-YES
114400                                 TO TRUE.
114500*
114600     IF  MMMM-REC-MODEL
114700         GO TO W059-ESSF-EXIT.
114800*
114900     IF  MBCA-PTI-FUNCTION-IS-MAINT
115000     OR  MM01-SINGLE-STORE-FLAG-L IS GREATER THAN ZERO
115100     OR  NOT MMFS-MT-REQUIRED (X-MMFS-MERCH)
115200         GO TO W059-ESSF-EXIT.
115300*
115400 W058-SINGLE-STORE-FLAG-ERROR.
115500*
115600     IF  MM01-SINGLE-STORE-FLAG-L IS GREATER THAN ZERO
115700         MOVE DFHBMUBF           TO MM01-SINGLE-STORE-FLAG-A
115800     ELSE
115900         MOVE DFHBMBRY           TO MM01-SINGLE-STORE-FLAG-A.
116000*
116100     SET SS08WS-ERROR-SW-YES     TO TRUE.
116200     MOVE DFHBMASB               TO MM01-SINGLE-STORE-FLAG-LP-A
116300                                    MM01-SINGLE-STORE-FLAG-RP-A.
116400     MOVE SS08WS-CURSOR          TO MM01-SINGLE-STORE-FLAG-L.
116500*
116600 W059-ESSF-EXIT.
116700     EXIT.
116800*
116900 W070-EDIT-DBA-CITY.
117000*
117100     MOVE DFHBMDAS               TO MM01-DBA-CITY-LP-A
117200                                    MM01-DBA-CITY-RP-A.
117300     MOVE DFHBMASK               TO MM01-DBA-CITY-A.
117400*
117500     PERFORM Y075-DBA-CITY-SECURITY
117600                                 THRU Y079-EXIT.
117700*
117800     IF  MM01-DBA-CITY-L IS GREATER THAN ZERO
117900         MOVE DFHBMASF           TO MM01-DBA-CITY-A
118000         EVALUATE TRUE
118100           WHEN MM01-DBA-CITY  IS EQUAL TO SPACES
118200             CONTINUE
118300           WHEN MM01-DBA-CITY (1:1)
118400                                 IS EQUAL TO SPACE
118500             GO TO W078-DBA-CITY-ERROR
118600           WHEN OTHER
118700             CONTINUE
118800         END-EVALUATE
118900         GO TO W079-EDC-EXIT
119000     ELSE
119100         MOVE MMMM-DBA-CITY      TO MM01-DBA-CITY.
119200*
119300     IF  MBCA-PTI-FUNCTION-IS-MAINT
119400     OR  NOT MMFS-MT-REQUIRED (X-MMFS-MERCH)
119500         GO TO W079-EDC-EXIT.
119600*
119700 W078-DBA-CITY-ERROR.
119800*
119900     IF  MM01-DBA-CITY-L IS GREATER THAN ZERO
120000         MOVE DFHBMUBF           TO MM01-DBA-CITY-A
120100     ELSE
120200         MOVE DFHBMBRY           TO MM01-DBA-CITY-A.
120300*
120400     SET SS08WS-ERROR-SW-YES     TO TRUE.
120500     MOVE DFHBMASB               TO MM01-DBA-CITY-LP-A
120600                                    MM01-DBA-CITY-RP-A.
120700     MOVE SS08WS-CURSOR          TO MM01-DBA-CITY-L.
120800*
120900 W079-EDC-EXIT.
121000     EXIT.
121100*
121200 W090-EDIT-DBA-COUNTRY-CODE.
121300*
121400     MOVE DFHBMDAS               TO MM01-DBA-STATE-LP-A
121500                                    MM01-DBA-STATE-RP-A.
121600     MOVE DFHBMASK               TO MM01-DBA-STATE-A.
121700*
121800     PERFORM Y095-DBA-COUNTRY-CODE-SECURITY
121900                                 THRU Y099-EXIT.
122000*
122100     IF  MM01-DBA-STATE-L IS GREATER THAN ZERO
122200         MOVE DFHBMASF           TO MM01-DBA-STATE-A
122300         EVALUATE TRUE
122400           WHEN MM01-DBA-STATE IS EQUAL TO SPACES
122500             CONTINUE
122600           WHEN MM01-DBA-STATE (1:1)
122700                                 IS EQUAL TO SPACE
122800             GO TO W098-DBA-COUNTRY-CODE-ERROR
122900           WHEN OTHER
123000             CONTINUE
123100         END-EVALUATE
123200         GO TO W099-EDCC-EXIT
123300     ELSE
123400         MOVE MMMM-DBA-COUNTRY-CODE
123500                                 TO MM01-DBA-STATE.
123600*
123700     IF  MBCA-PTI-FUNCTION-IS-MAINT
123800     OR  NOT MMFS-MT-REQUIRED (X-MMFS-MERCH)
123900         GO TO W099-EDCC-EXIT.
124000*
124100 W098-DBA-COUNTRY-CODE-ERROR.
124200*
124300     IF  MM01-DBA-STATE-L IS GREATER THAN ZERO
124400         MOVE DFHBMUBF           TO MM01-DBA-STATE-A
124500     ELSE
124600         MOVE DFHBMBRY           TO MM01-DBA-STATE-A.
124700*
124800     SET SS08WS-ERROR-SW-YES     TO TRUE.
124900     MOVE DFHBMASB               TO MM01-DBA-STATE-LP-A
125000                                    MM01-DBA-STATE-RP-A.
125100     MOVE SS08WS-CURSOR          TO MM01-DBA-STATE-L.
125200*
125300 W099-EDCC-EXIT.
125400     EXIT.
125500*
125600 W110-EDIT-PRIM-ADDRESS1.
125700*
125800     SET X-MM01-NA               TO 1.
125900     SET X-MMMM-NA               TO 1.
126000*
126100     MOVE DFHBMDAS               TO MM01-NA-LINE-LP-A (X-MM01-NA)
126200                                    MM01-NA-LINE-RP-A (X-MM01-NA).
126300     MOVE DFHBMASK               TO MM01-NA-LINE-A (X-MM01-NA).
126400*
126500     PERFORM Y115-PRIM-ADDRESS1-SECURITY
126600                                 THRU Y119-EXIT.
126700*
126800     IF  MM01-NA-LINE-L (X-MM01-NA) IS GREATER THAN ZERO
126900         MOVE DFHBMASF           TO MM01-NA-LINE-A (X-MM01-NA)
127000         GO TO W119-EPA1-EXIT
127100     ELSE
127200         MOVE MMMM-NA-LINE (X-MMMM-PRIMARY X-MMMM-NA)
127300                                 TO MM01-NA-LINE (X-MM01-NA).
127400*
127500     IF  MBCA-PTI-FUNCTION-IS-MAINT
127600     OR  NOT MMFS-MT-REQUIRED (X-MMFS-MERCH)
127700         GO TO W119-EPA1-EXIT.
127800*
127900 W118-PRIM-ADDRESS1-ERROR.
128000*
128100     IF  MM01-NA-LINE-L (X-MM01-NA) IS GREATER THAN ZERO
128200         MOVE DFHBMUBF           TO MM01-NA-LINE-A (X-MM01-NA)
128300     ELSE
128400         MOVE DFHBMBRY           TO MM01-NA-LINE-A (X-MM01-NA).
128500*
128600     SET SS08WS-ERROR-SW-YES     TO TRUE.
128700     MOVE DFHBMASB               TO MM01-NA-LINE-LP-A (X-MM01-NA)
128800                                    MM01-NA-LINE-RP-A (X-MM01-NA).
128900     MOVE SS08WS-CURSOR          TO MM01-NA-LINE-L (X-MM01-NA).
129000*
129100 W119-EPA1-EXIT.
129200     EXIT.
129300*
129400 W130-EDIT-PRIM-ADDRESS2.
129500*
129600     SET X-MM01-NA               TO 2.
129700     SET X-MMMM-NA               TO 2.
129800*
129900     MOVE DFHBMDAS               TO MM01-NA-LINE-LP-A (X-MM01-NA)
130000                                    MM01-NA-LINE-RP-A (X-MM01-NA).
130100     MOVE DFHBMASK               TO MM01-NA-LINE-A (X-MM01-NA).
130200*
130300     PERFORM Y135-PRIM-ADDRESS2-SECURITY
130400                                 THRU Y139-EXIT.
130500*
130600     IF  MM01-NA-LINE-L (X-MM01-NA) IS GREATER THAN ZERO
130700         MOVE DFHBMASF           TO MM01-NA-LINE-A (X-MM01-NA)
130800         GO TO W139-EPA2-EXIT
130900     ELSE
131000         MOVE MMMM-NA-LINE (X-MMMM-PRIMARY X-MMMM-NA)
131100                                 TO MM01-NA-LINE (X-MM01-NA).
131200*
131300     IF  MBCA-PTI-FUNCTION-IS-MAINT
131400     OR  NOT MMFS-MT-REQUIRED (X-MMFS-MERCH)
131500         GO TO W139-EPA2-EXIT.
131600*
131700 W138-PRIM-ADDRESS2-ERROR.
131800*
131900     IF  MM01-NA-LINE-L (X-MM01-NA) IS GREATER THAN ZERO
132000         MOVE DFHBMUBF           TO MM01-NA-LINE-A (X-MM01-NA)
132100     ELSE
132200         MOVE DFHBMBRY           TO MM01-NA-LINE-A (X-MM01-NA).
132300*
132400     SET SS08WS-ERROR-SW-YES     TO TRUE.
132500     MOVE DFHBMASB               TO MM01-NA-LINE-LP-A (X-MM01-NA)
132600                                    MM01-NA-LINE-RP-A (X-MM01-NA).
132700     MOVE SS08WS-CURSOR          TO MM01-NA-LINE-L (X-MM01-NA).
132800*
132900 W139-EPA2-EXIT.
133000     EXIT.
133100*
133200 W150-EDIT-PRIM-ADDRESS3.
133300*
133400     SET X-MM01-NA               TO 3.
133500     SET X-MMMM-NA               TO 3.
133600*
133700     MOVE DFHBMDAS               TO MM01-NA-LINE-LP-A (X-MM01-NA)
133800                                    MM01-NA-LINE-RP-A (X-MM01-NA).
133900     MOVE DFHBMASK               TO MM01-NA-LINE-A (X-MM01-NA).
134000*
134100     PERFORM Y155-PRIM-ADDRESS3-SECURITY
134200                                 THRU Y159-EXIT.
134300*
134400     IF  MM01-NA-LINE-L (X-MM01-NA) IS GREATER THAN ZERO
134500         MOVE DFHBMASF           TO MM01-NA-LINE-A (X-MM01-NA)
134600         GO TO W159-EPA3-EXIT
134700     ELSE
134800         MOVE MMMM-NA-LINE (X-MMMM-PRIMARY X-MMMM-NA)
134900                                 TO MM01-NA-LINE (X-MM01-NA).
135000*
135100     IF  MBCA-PTI-FUNCTION-IS-MAINT
135200     OR  NOT MMFS-MT-REQUIRED (X-MMFS-MERCH)
135300         GO TO W159-EPA3-EXIT.
135400*
135500 W158-PRIM-ADDRESS3-ERROR.
135600*
135700     IF  MM01-NA-LINE-L (X-MM01-NA) IS GREATER THAN ZERO
135800         MOVE DFHBMUBF           TO MM01-NA-LINE-A (X-MM01-NA)
135900     ELSE
136000         MOVE DFHBMBRY           TO MM01-NA-LINE-A (X-MM01-NA).
136100*
136200     SET SS08WS-ERROR-SW-YES     TO TRUE.
136300     MOVE DFHBMASB               TO MM01-NA-LINE-LP-A (X-MM01-NA)
136400                                    MM01-NA-LINE-RP-A (X-MM01-NA).
136500     MOVE SS08WS-CURSOR          TO MM01-NA-LINE-L (X-MM01-NA).
136600*
136700 W159-EPA3-EXIT.
136800     EXIT.
136900*
137000 W170-EDIT-PRIM-ADDRESS4.
137100*
137200     SET X-MM01-NA               TO 4.
137300     SET X-MMMM-NA               TO 4.
137400*
137500     MOVE DFHBMDAS               TO MM01-NA-LINE-LP-A (X-MM01-NA)
137600                                    MM01-NA-LINE-RP-A (X-MM01-NA).
137700     MOVE DFHBMASK               TO MM01-NA-LINE-A (X-MM01-NA).
137800*
137900     PERFORM Y175-PRIM-ADDRESS4-SECURITY
138000                                 THRU Y179-EXIT.
138100*
138200     IF  MM01-NA-LINE-L (X-MM01-NA) IS GREATER THAN ZERO
138300         MOVE DFHBMASF           TO MM01-NA-LINE-A (X-MM01-NA)
138400         GO TO W179-EPA4-EXIT
138500     ELSE
138600         MOVE MMMM-NA-LINE (X-MMMM-PRIMARY X-MMMM-NA)
138700                                 TO MM01-NA-LINE (X-MM01-NA).
138800*
138900     IF  MBCA-PTI-FUNCTION-IS-MAINT
139000     OR  NOT MMFS-MT-REQUIRED (X-MMFS-MERCH)
139100         GO TO W179-EPA4-EXIT.
139200*
139300 W178-PRIM-ADDRESS4-ERROR.
139400*
139500     IF  MM01-NA-LINE-L (X-MM01-NA) IS GREATER THAN ZERO
139600         MOVE DFHBMUBF           TO MM01-NA-LINE-A (X-MM01-NA)
139700     ELSE
139800         MOVE DFHBMBRY           TO MM01-NA-LINE-A (X-MM01-NA).
139900*
140000     SET SS08WS-ERROR-SW-YES     TO TRUE.
140100     MOVE DFHBMASB               TO MM01-NA-LINE-LP-A (X-MM01-NA)
140200                                    MM01-NA-LINE-RP-A (X-MM01-NA).
140300     MOVE SS08WS-CURSOR          TO MM01-NA-LINE-L (X-MM01-NA).
140400*
140500 W179-EPA4-EXIT.
140600     EXIT.
140700*
140800 W190-EDIT-PRIM-ADDRESS5.
140900*
141000     SET X-MM01-NA               TO 5.
141100     SET X-MMMM-NA               TO 5.
141200*
141300     MOVE DFHBMDAS               TO MM01-NA-LINE-LP-A (X-MM01-NA)
141400                                    MM01-NA-LINE-RP-A (X-MM01-NA).
141500     MOVE DFHBMASK               TO MM01-NA-LINE-A (X-MM01-NA).
141600*
141700     PERFORM Y195-PRIM-ADDRESS5-SECURITY
141800                                 THRU Y199-EXIT.
141900*
142000     IF  MM01-NA-LINE-L (X-MM01-NA) IS GREATER THAN ZERO
142100         MOVE DFHBMASF           TO MM01-NA-LINE-A (X-MM01-NA)
142200         GO TO W199-EPA5-EXIT
142300     ELSE
142400         MOVE MMMM-NA-LINE (X-MMMM-PRIMARY X-MMMM-NA)
142500                                 TO MM01-NA-LINE (X-MM01-NA).
142600*
142700     IF  MBCA-PTI-FUNCTION-IS-MAINT
142800     OR  NOT MMFS-MT-REQUIRED (X-MMFS-MERCH)
142900         GO TO W199-EPA5-EXIT.
143000*
143100 W198-PRIM-ADDRESS5-ERROR.
143200*
143300     IF  MM01-NA-LINE-L (X-MM01-NA) IS GREATER THAN ZERO
143400         MOVE DFHBMUBF           TO MM01-NA-LINE-A (X-MM01-NA)
143500     ELSE
143600         MOVE DFHBMBRY           TO MM01-NA-LINE-A (X-MM01-NA).
143700*
143800     SET SS08WS-ERROR-SW-YES     TO TRUE.
143900     MOVE DFHBMASB               TO MM01-NA-LINE-LP-A (X-MM01-NA)
144000                                    MM01-NA-LINE-RP-A (X-MM01-NA).
144100     MOVE SS08WS-CURSOR          TO MM01-NA-LINE-L (X-MM01-NA).
144200*
144300 W199-EPA5-EXIT.
144400     EXIT.
144500*
144600 W210-EDIT-PRIM-STATE.
144700*
144800     MOVE DFHBMDAS               TO MM01-STATE-CODE-LP-A
144900                                    MM01-STATE-CODE-RP-A.
145000     MOVE DFHBMASK               TO MM01-STATE-CODE-A.
145100*
145200     PERFORM Y215-PRIM-STATE-SECURITY
145300                                 THRU Y219-EXIT.
145400*
145500     IF  MM01-STATE-CODE-L IS GREATER THAN ZERO
145600         MOVE DFHBMASF           TO MM01-STATE-CODE-A
145700         GO TO W219-EPS-EXIT
145800     ELSE
145900         MOVE MMMM-STATE-CODE (X-MMMM-PRIMARY)
146000                                 TO MM01-STATE-CODE.
146100*
146200     IF  MBCA-PTI-FUNCTION-IS-MAINT
146300     OR  NOT MMFS-MT-REQUIRED (X-MMFS-MERCH)
146400         GO TO W219-EPS-EXIT.
146500*
146600 W218-PRIM-STATE-ERROR.
146700*
146800     IF  MM01-STATE-CODE-L IS GREATER THAN ZERO
146900         MOVE DFHBMUBF           TO MM01-STATE-CODE-A
147000     ELSE
147100         MOVE DFHBMBRY           TO MM01-STATE-CODE-A.
147200*
147300     SET SS08WS-ERROR-SW-YES     TO TRUE.
147400     MOVE DFHBMASB               TO MM01-STATE-CODE-LP-A
147500                                    MM01-STATE-CODE-RP-A.
147600     MOVE SS08WS-CURSOR          TO MM01-STATE-CODE-L.
147700*
147800 W219-EPS-EXIT.
147900     EXIT.
148000*
148100 W230-EDIT-PRIM-PHONE.
148200*
148300     MOVE DFHBMDAS               TO MM01-PHONE-LP-A
148400                                    MM01-PHONE-RP-A.
148500     MOVE DFHBMASK               TO MM01-PHONE-A.
148600*
148700     PERFORM Y235-PRIM-PHONE-SECURITY
148800                                 THRU Y239-EXIT.
148900*
149000     IF  MM01-PHONE-L IS GREATER THAN ZERO
149100         MOVE DFHBMASF           TO MM01-PHONE-A
149200         GO TO W239-EPP-EXIT
149300     ELSE
149400         MOVE MMMM-PHONE (X-MMMM-PRIMARY)
149500                                 TO MM01-PHONE.
149600*
149700     IF  MBCA-PTI-FUNCTION-IS-MAINT
149800     OR  NOT MMFS-MT-REQUIRED (X-MMFS-MERCH)
149900         GO TO W239-EPP-EXIT.
150000*
150100 W238-PRIM-PHONE-ERROR.
150200*
150300     IF  MM01-PHONE-L IS GREATER THAN ZERO
150400         MOVE DFHBMUBF           TO MM01-PHONE-A
150500     ELSE
150600         MOVE DFHBMBRY           TO MM01-PHONE-A.
150700*
150800     SET SS08WS-ERROR-SW-YES     TO TRUE.
150900     MOVE DFHBMASB               TO MM01-PHONE-LP-A
151000                                    MM01-PHONE-RP-A.
151100     MOVE SS08WS-CURSOR          TO MM01-PHONE-L.
151200*
151300 W239-EPP-EXIT.
151400     EXIT.
151500*
151600 W250-EDIT-PRIM-POSTAL-CODE.
151700*
151800     MOVE DFHBMDAS               TO MM01-POSTAL-CODE-LP-A
151900                                    MM01-POSTAL-CODE-RP-A.
152000     MOVE DFHBMASK               TO MM01-POSTAL-CODE-A.
152100*
152200     PERFORM Y255-PRIM-POSTAL-CODE-SECURITY
152300                                 THRU Y259-EXIT.
152400*
152500     IF  MM01-POSTAL-CODE-L IS GREATER THAN ZERO
152600         MOVE DFHBMASF           TO MM01-POSTAL-CODE-A
152700         GO TO W259-EPPC-EXIT
152800     ELSE
152900         MOVE MMMM-POSTAL-CODE (X-MMMM-PRIMARY)
153000                                 TO MM01-POSTAL-CODE.
153100*
153200     IF  MBCA-PTI-FUNCTION-IS-MAINT
153300     OR  NOT MMFS-MT-REQUIRED (X-MMFS-MERCH)
153400         GO TO W259-EPPC-EXIT.
153500*
153600 W258-PRIM-POSTAL-CODE-ERROR.
153700*
153800     IF  MM01-POSTAL-CODE-L IS GREATER THAN ZERO
153900         MOVE DFHBMUBF           TO MM01-POSTAL-CODE-A
154000     ELSE
154100         MOVE DFHBMBRY           TO MM01-POSTAL-CODE-A.
154200*
154300     SET SS08WS-ERROR-SW-YES     TO TRUE.
154400     MOVE DFHBMASB               TO MM01-POSTAL-CODE-LP-A
154500                                    MM01-POSTAL-CODE-RP-A.
154600     MOVE SS08WS-CURSOR          TO MM01-POSTAL-CODE-L.
154700*
154800 W259-EPPC-EXIT.
154900     EXIT.
155000*
155100 W270-EDIT-PRIM-FAX.
155200*
155300     MOVE DFHBMDAS               TO MM01-FAX-LP-A
155400                                    MM01-FAX-RP-A.
155500     MOVE DFHBMASK               TO MM01-FAX-A.
155600*
155700     PERFORM Y275-PRIM-FAX-SECURITY
155800                                 THRU Y279-EXIT.
155900*
156000     IF  MM01-FAX-L IS GREATER THAN ZERO
156100         MOVE DFHBMASF           TO MM01-FAX-A
156200         GO TO W279-EPF-EXIT
156300     ELSE
156400         MOVE MMMM-FAX (X-MMMM-PRIMARY)
156500                                 TO MM01-FAX.
156600*
156700     IF  MBCA-PTI-FUNCTION-IS-MAINT
156800     OR  NOT MMFS-MT-REQUIRED (X-MMFS-MERCH)
156900         GO TO W279-EPF-EXIT.
157000*
157100 W278-PRIM-FAX-ERROR.
157200*
157300     IF  MM01-FAX-L IS GREATER THAN ZERO
157400         MOVE DFHBMUBF           TO MM01-FAX-A
157500     ELSE
157600         MOVE DFHBMBRY           TO MM01-FAX-A.
157700*
157800     SET SS08WS-ERROR-SW-YES     TO TRUE.
157900     MOVE DFHBMASB               TO MM01-FAX-LP-A
158000                                    MM01-FAX-RP-A.
158100     MOVE SS08WS-CURSOR          TO MM01-FAX-L.
158200*
158300 W279-EPF-EXIT.
158400     EXIT.
158500*
158600 W290-CROSS-EDIT-SINGLE-STORE.
158700*
158800     IF  MBCA-PTI-FUNCTION-IS-MAINT
158900     AND MMMM-SINGLE-STORE-NO
159000     AND MM01-SINGLE-STORE-YES
159100         PERFORM Y950-VERIFY-MMXR
159200                                 THRU Y959-EXIT
159300         IF  WS-STORE-XREF-YES
159400             MOVE DFHBMUBF       TO MM01-SINGLE-STORE-FLAG-A
159500             SET SS08WS-ERROR-SW-YES TO TRUE
159600             MOVE DFHBMASB       TO MM01-SINGLE-STORE-FLAG-LP-A
159700                                    MM01-SINGLE-STORE-FLAG-RP-A
159800             MOVE SS08WS-CURSOR  TO MM01-SINGLE-STORE-FLAG-L
159900             GO TO W299-EXIT
160000         ELSE
160100             SET WS-MAINT-SSR-SW-YES
160200                                 TO TRUE.
160300*
160400     IF  MM01-SINGLE-STORE-YES
160500     AND MMMM-STORE-NBR IS GREATER THAN ZEROS
160600     AND (MM01-NA-LINE-L (1) IS GREATER THAN ZERO
160700      OR  MM01-NA-LINE-L (2) IS GREATER THAN ZERO
160800      OR  MM01-NA-LINE-L (3) IS GREATER THAN ZERO
160900      OR  MM01-NA-LINE-L (4) IS GREATER THAN ZERO
161000      OR  MM01-NA-LINE-L (5) IS GREATER THAN ZERO
161100      OR  MM01-STATE-CODE-L  IS GREATER THAN ZERO
161200      OR  MM01-PHONE-L       IS GREATER THAN ZERO
161300      OR  MM01-POSTAL-CODE-L IS GREATER THAN ZERO
161400      OR  MM01-FAX-L         IS GREATER THAN ZERO)
161500         SET WS-STORE-ADDR-SW-YES
161600                                 TO TRUE.
161700*
161800     IF  MM01-SINGLE-STORE-YES
161900     AND MMMM-STORE-NBR IS GREATER THAN ZEROS
162000     AND (MM01-DBA-NAME-L IS GREATER THAN ZERO
162100      OR  MM01-DBA-CITY-L IS GREATER THAN ZERO
162200      OR  MM01-COUNTRY-CODE-L IS GREATER THAN ZERO
162300      OR  MM01-DBA-STATE-L IS GREATER THAN ZERO)
162400         SET WS-STORE-ADDR-SW-YES
162500                                 TO TRUE.
162600*
162700     IF  MMMM-SINGLE-STORE-YES
162800     AND MM01-SINGLE-STORE-NO
162900     AND MMMM-STORE-NBR IS GREATER THAN ZEROS
163000         SET MMSM-SINGLE-STORE-NO
163100                                 TO TRUE
163200         SET WS-STORE-UPDATE-SW-YES
163300                                 TO TRUE.
163400*
163500 W299-EXIT.
163600     EXIT.
163700*
163800 W300-CROSS-EDIT-CRB.
163900*
164000     IF  MM01-SINGLE-STORE-YES
164100     AND MMMM-SAC-USE-PRIMARY
164200     AND (MM01-NA-LINE-L (1) IS GREATER THAN ZERO
164300      OR  MM01-NA-LINE-L (2) IS GREATER THAN ZERO
164400      OR  MM01-NA-LINE-L (3) IS GREATER THAN ZERO
164500      OR  MM01-NA-LINE-L (4) IS GREATER THAN ZERO
164600      OR  MM01-NA-LINE-L (5) IS GREATER THAN ZERO)
164700         NEXT SENTENCE
164800     ELSE
164900         GO TO W309-EXIT.
165000*
165100     IF  MMMM-STORE-NBR IS GREATER THAN ZEROS
165200         IF  MMSM-NBR-BULLETINS IS GREATER THAN ZEROS
165300         OR  MMSM-VI-FLOOR-LIMIT IS GREATER THAN ZEROS
165400         OR  MMSM-MC-FLOOR-LIMIT IS GREATER THAN ZEROS
165500             SET WS-STORE-CRB-UPDATE-SW-YES
165600                                 TO TRUE
165700             MOVE MMSM-CRB-FLAG  TO WS-CRB-FLAG
165800             SET MMSM-CRB-MAINT-STORE
165900                                 TO TRUE.
166000*
166100 W309-EXIT.
166200     EXIT.
166300/
166400 X000-UPDATE-FIELDS SECTION.
166500*
166600 X010-UPDATE-COUNTRY-CODE.
166700*
166800     IF  MM01-COUNTRY-CODE-L IS GREATER THAN ZERO
166900         IF  MM01-COUNTRY-CODE IS NOT EQUAL
167000                                 TO MMMM-COUNTRY-CODE
167100                                    (X-MMMM-PRIMARY)
167200             SET WS-UPDATE-SW-YES
167300                                 TO TRUE
167400             IF  MBCA-PTI-FUNCTION-IS-MAINT
167500                 MOVE MMMMTB-COUNTRY-CODE (1:4)
167600                                 TO WS-INDEX-X
167700                 SET X-MMFS-MERCH
167800                                 TO WS-INDEX
167900                 MOVE MMFS-MT-AUDIT-CODE (X-MMFS-MERCH)
168000                                 TO MML1-MMMM-AUDIT-CODE
168100                 MOVE 0101       TO MML1-FIELD-CODE
168200                 MOVE 1          TO MML1-FIELD-OCCURRENCE
168300                 MOVE ZEROS      TO MML1-FIELD-OCCURRENCE-2
168400                 MOVE MML1WS-VL-03
168500                                 TO MML1-VARIABLE-LENGTH
168600                 MOVE MMMM-COUNTRY-CODE (X-MMMM-PRIMARY)
168700                                 TO MML1-VL03-B-DATA-X
168800                 MOVE MM01-COUNTRY-CODE
168900                                 TO MMMM-COUNTRY-CODE
169000                                    (X-MMMM-PRIMARY)
169100                 MOVE MMMM-COUNTRY-CODE (X-MMMM-PRIMARY)
169200                                 TO MML1-VL03-A-DATA-X
169300                 MOVE 'FC16'     TO MBCA-PROGRAM-LOCATION
169400                 PERFORM Y910-WRITE-LOG-RECORD
169500                                 THRU Y919-WLR-EXIT
169600             ELSE
169700                 MOVE MM01-COUNTRY-CODE
169800                                 TO MMMM-COUNTRY-CODE
169900                                    (X-MMMM-PRIMARY).
170000*
170100 X019-UCC-EXIT.
170200     EXIT.
170300*
170400 X030-UPDATE-DBA-NAME.
170500*
170600     IF  MM01-DBA-NAME-L IS GREATER THAN ZERO
170700         IF  MM01-DBA-NAME IS NOT EQUAL TO MMMM-DBA-NAME
170800             SET WS-UPDATE-SW-YES
170900                                 TO TRUE
171000             IF  MBCA-PTI-FUNCTION-IS-MAINT
171100                 MOVE MMMMTB-DBA-NAME (1:4)
171200                                 TO WS-INDEX-X
171300                 SET X-MMFS-MERCH
171400                                 TO WS-INDEX
171500                 MOVE MMFS-MT-AUDIT-CODE (X-MMFS-MERCH)
171600                                 TO MML1-MMMM-AUDIT-CODE
171700                 MOVE 0102       TO MML1-FIELD-CODE
171800                 MOVE ZEROES     TO MML1-FIELD-OCCURRENCE
171900                                    MML1-FIELD-OCCURRENCE-2
172000                 MOVE MML1WS-VL-30
172100                                 TO MML1-VARIABLE-LENGTH
172200                 MOVE MMMM-DBA-NAME
172300                                 TO MML1-VL30-B-DATA-X
172400                 MOVE MM01-DBA-NAME
172500                                 TO MMMM-DBA-NAME
172600                 MOVE MMMM-DBA-NAME
172700                                 TO MML1-VL30-A-DATA-X
172800                 MOVE 'FC17'     TO MBCA-PROGRAM-LOCATION
172900                 PERFORM Y910-WRITE-LOG-RECORD
173000                                 THRU Y919-WLR-EXIT
173100             ELSE
173200                 MOVE MM01-DBA-NAME
173300                                 TO MMMM-DBA-NAME.
173400*
173500 X039-UDN-EXIT.
173600     EXIT.
173700*
173800 X050-UPDATE-SINGLE-STORE-FLAG.
173900*
174000     IF  MM01-SINGLE-STORE-FLAG-L IS GREATER THAN ZERO
174100         IF  MM01-SINGLE-STORE-FLAG IS NOT EQUAL TO
174200                                    MMMM-SINGLE-STORE-FLAG
174300             SET WS-UPDATE-SW-YES
174400                                 TO TRUE
174500             IF  MBCA-PTI-FUNCTION-IS-MAINT
174600                 MOVE MMMMTB-SINGLE-STORE-FLAG (1:4)
174700                                 TO WS-INDEX-X
174800                 SET X-MMFS-MERCH
174900                                 TO WS-INDEX
175000                 MOVE MMFS-MT-AUDIT-CODE (X-MMFS-MERCH)
175100                                 TO MML1-MMMM-AUDIT-CODE
175200                 MOVE 0103       TO MML1-FIELD-CODE
175300                 MOVE ZEROES     TO MML1-FIELD-OCCURRENCE
175400                                    MML1-FIELD-OCCURRENCE-2
175500                 MOVE MML1WS-VL-01
175600                                 TO MML1-VARIABLE-LENGTH
175700                 MOVE MMMM-SINGLE-STORE-FLAG
175800                                 TO MML1-VL01-B-DATA-X
175900                 MOVE MM01-SINGLE-STORE-FLAG
176000                                 TO MMMM-SINGLE-STORE-FLAG
176100                 MOVE MMMM-SINGLE-STORE-FLAG
176200                                 TO MML1-VL01-A-DATA-X
176300                 MOVE 'FC18'     TO MBCA-PROGRAM-LOCATION
176400                 PERFORM Y910-WRITE-LOG-RECORD
176500                                 THRU Y919-WLR-EXIT
176600             ELSE
176700                 MOVE MM01-SINGLE-STORE-FLAG
176800                                 TO MMMM-SINGLE-STORE-FLAG.
176900*
177000 X059-USSF-EXIT.
177100     EXIT.
177200*
177300 X070-UPDATE-DBA-CITY.
177400*
177500     IF  MM01-DBA-CITY-L IS GREATER THAN ZERO
177600         IF  MM01-DBA-CITY IS NOT EQUAL TO MMMM-DBA-CITY
177700             SET WS-UPDATE-SW-YES
177800                                 TO TRUE
177900             IF  MBCA-PTI-FUNCTION-IS-MAINT
178000                 MOVE MMMMTB-DBA-CITY (1:4)
178100                                 TO WS-INDEX-X
178200                 SET X-MMFS-MERCH
178300                                 TO WS-INDEX
178400                 MOVE MMFS-MT-AUDIT-CODE (X-MMFS-MERCH)
178500                                 TO MML1-MMMM-AUDIT-CODE
178600                 MOVE 0104       TO MML1-FIELD-CODE
178700                 MOVE ZEROES     TO MML1-FIELD-OCCURRENCE
178800                                    MML1-FIELD-OCCURRENCE-2
178900                 MOVE MML1WS-VL-30
179000                                 TO MML1-VARIABLE-LENGTH
179100                 MOVE MMMM-DBA-CITY
179200                                 TO MML1-VL30-B-DATA-X
179300                 MOVE MM01-DBA-CITY
179400                                 TO MMMM-DBA-CITY
179500                 MOVE MMMM-DBA-CITY
179600                                 TO MML1-VL30-A-DATA-X
179700                 MOVE 'FC19'     TO MBCA-PROGRAM-LOCATION
179800                 PERFORM Y910-WRITE-LOG-RECORD
179900                                 THRU Y919-WLR-EXIT
180000             ELSE
180100                 MOVE MM01-DBA-CITY
180200                                 TO MMMM-DBA-CITY.
180300*
180400 X079-UDC-EXIT.
180500     EXIT.
180600*
180700 X090-UPDATE-DBA-COUNTRY-CODE.
180800*
180900     IF  MM01-DBA-STATE-L IS GREATER THAN ZERO
181000         IF  MM01-DBA-STATE IS NOT EQUAL TO MMMM-DBA-COUNTRY-CODE
181100             SET WS-UPDATE-SW-YES
181200                                 TO TRUE
181300             IF  MBCA-PTI-FUNCTION-IS-MAINT
181400                 MOVE MMMMTB-DBA-COUNTRY-CODE (1:4)
181500                                 TO WS-INDEX-X
181600                 SET X-MMFS-MERCH
181700                                 TO WS-INDEX
181800                 MOVE MMFS-MT-AUDIT-CODE (X-MMFS-MERCH)
181900                                 TO MML1-MMMM-AUDIT-CODE
182000                 MOVE 0105       TO MML1-FIELD-CODE
182100                 MOVE ZEROES     TO MML1-FIELD-OCCURRENCE
182200                                    MML1-FIELD-OCCURRENCE-2
182300                 MOVE MML1WS-VL-03
182400                                 TO MML1-VARIABLE-LENGTH
182500                 MOVE MMMM-DBA-COUNTRY-CODE
182600                                 TO MML1-VL03-B-DATA-X
182700                 MOVE MM01-DBA-STATE
182800                                 TO MMMM-DBA-COUNTRY-CODE
182900                 MOVE MMMM-DBA-COUNTRY-CODE
183000                                 TO MML1-VL03-A-DATA-X
183100                 MOVE 'FC20'     TO MBCA-PROGRAM-LOCATION
183200                 PERFORM Y910-WRITE-LOG-RECORD
183300                                 THRU Y919-WLR-EXIT
183400             ELSE
183500                 MOVE MM01-DBA-STATE
183600                                 TO MMMM-DBA-COUNTRY-CODE.
183700*
183800 X099-UDCC-EXIT.
183900     EXIT.
184000*
184100 X110-UPDATE-PRIM-ADDRESS1.
184200*
184300     SET X-MMMM-NA               TO 1.
184400     SET X-MM01-NA               TO 1.
184500*
184600     IF  MM01-NA-LINE-L (X-MM01-NA) IS GREATER THAN ZERO
184700         IF  MM01-NA-LINE (X-MM01-NA) IS NOT EQUAL TO MMMM-NA-LINE
184800                                      (X-MMMM-PRIMARY X-MMMM-NA)
184900             SET WS-UPDATE-SW-YES
185000                                 TO TRUE
185100             IF  MBCA-PTI-FUNCTION-IS-MAINT
185200                 MOVE MMMMTB-PRIM-ADDR1 (1:4)
185300                                 TO WS-INDEX-X
185400                 SET X-MMFS-MERCH
185500                                 TO WS-INDEX
185600                 MOVE MMFS-MT-AUDIT-CODE (X-MMFS-MERCH)
185700                                 TO MML1-MMMM-AUDIT-CODE
185800                 MOVE 0106       TO MML1-FIELD-CODE
185900                 MOVE 1          TO MML1-FIELD-OCCURRENCE
186000                 MOVE 1          TO MML1-FIELD-OCCURRENCE-2
186100                 MOVE MML1WS-VL-40
186200                                 TO MML1-VARIABLE-LENGTH
186300                 MOVE MMMM-NA-LINE  (X-MMMM-PRIMARY X-MMMM-NA)
186400                                 TO MML1-VL40-B-DATA-X
186500                 MOVE MM01-NA-LINE (X-MM01-NA)
186600                                 TO MMMM-NA-LINE
186700                                    (X-MMMM-PRIMARY X-MMMM-NA)
186800                 MOVE MMMM-NA-LINE  (X-MMMM-PRIMARY X-MMMM-NA)
186900                                 TO MML1-VL40-A-DATA-X
187000                 MOVE 'FC21'     TO MBCA-PROGRAM-LOCATION
187100                 PERFORM Y910-WRITE-LOG-RECORD
187200                                 THRU Y919-WLR-EXIT
187300             ELSE
187400                 MOVE MM01-NA-LINE (X-MM01-NA)
187500                                 TO MMMM-NA-LINE
187600                                    (X-MMMM-PRIMARY X-MMMM-NA).
187700*
187800 X119-UPA1-EXIT.
187900     EXIT.
188000*
188100 X130-UPDATE-PRIM-ADDRESS2.
188200*
188300     SET X-MMMM-NA               TO 2.
188400     SET X-MM01-NA               TO 2.
188500*
188600     IF  MM01-NA-LINE-L (X-MM01-NA) IS GREATER THAN ZERO
188700         IF  MM01-NA-LINE (X-MM01-NA) IS NOT EQUAL TO MMMM-NA-LINE
188800                                      (X-MMMM-PRIMARY X-MMMM-NA)
188900             SET WS-UPDATE-SW-YES
189000                                 TO TRUE
189100             IF  MBCA-PTI-FUNCTION-IS-MAINT
189200                 MOVE MMMMTB-PRIM-ADDR2 (1:4)
189300                                 TO WS-INDEX-X
189400                 SET X-MMFS-MERCH
189500                                 TO WS-INDEX
189600                 MOVE MMFS-MT-AUDIT-CODE (X-MMFS-MERCH)
189700                                 TO MML1-MMMM-AUDIT-CODE
189800                 MOVE 0106       TO MML1-FIELD-CODE
189900                 MOVE 1          TO MML1-FIELD-OCCURRENCE
190000                 MOVE 2          TO MML1-FIELD-OCCURRENCE-2
190100                 MOVE MML1WS-VL-40
190200                                 TO MML1-VARIABLE-LENGTH
190300                 MOVE MMMM-NA-LINE  (X-MMMM-PRIMARY X-MMMM-NA)
190400                                 TO MML1-VL40-B-DATA-X
190500                 MOVE MM01-NA-LINE (X-MM01-NA)
190600                                 TO MMMM-NA-LINE
190700                                    (X-MMMM-PRIMARY X-MMMM-NA)
190800                 MOVE MMMM-NA-LINE  (X-MMMM-PRIMARY X-MMMM-NA)
190900                                 TO MML1-VL40-A-DATA-X
191000                 MOVE 'FC22'     TO MBCA-PROGRAM-LOCATION
191100                 PERFORM Y910-WRITE-LOG-RECORD
191200                                 THRU Y919-WLR-EXIT
191300             ELSE
191400                 MOVE MM01-NA-LINE (X-MM01-NA)
191500                                 TO MMMM-NA-LINE
191600                                    (X-MMMM-PRIMARY X-MMMM-NA).
191700*
191800 X139-UPA2-EXIT.
191900     EXIT.
192000*
192100 X150-UPDATE-PRIM-ADDRESS3.
192200*
192300     SET X-MMMM-NA               TO 3.
192400     SET X-MM01-NA               TO 3.
192500*
192600     IF  MM01-NA-LINE-L (X-MM01-NA) IS GREATER THAN ZERO
192700         IF  MM01-NA-LINE (X-MM01-NA) IS NOT EQUAL TO MMMM-NA-LINE
192800                                      (X-MMMM-PRIMARY X-MMMM-NA)
192900             SET WS-UPDATE-SW-YES
193000                                 TO TRUE
193100             IF  MBCA-PTI-FUNCTION-IS-MAINT
193200                 MOVE MMMMTB-PRIM-ADDR3 (1:4)
193300                                 TO WS-INDEX-X
193400                 SET X-MMFS-MERCH
193500                                 TO WS-INDEX
193600                 MOVE MMFS-MT-AUDIT-CODE (X-MMFS-MERCH)
193700                                 TO MML1-MMMM-AUDIT-CODE
193800                 MOVE 0106       TO MML1-FIELD-CODE
193900                 MOVE 1          TO MML1-FIELD-OCCURRENCE
194000                 MOVE 3          TO MML1-FIELD-OCCURRENCE-2
194100                 MOVE MML1WS-VL-40
194200                                 TO MML1-VARIABLE-LENGTH
194300                 MOVE MMMM-NA-LINE  (X-MMMM-PRIMARY X-MMMM-NA)
194400                                 TO MML1-VL40-B-DATA-X
194500                 MOVE MM01-NA-LINE (X-MM01-NA)
194600                                 TO MMMM-NA-LINE
194700                                    (X-MMMM-PRIMARY X-MMMM-NA)
194800                 MOVE MMMM-NA-LINE  (X-MMMM-PRIMARY X-MMMM-NA)
194900                                 TO MML1-VL40-A-DATA-X
195000                 MOVE 'FC23'     TO MBCA-PROGRAM-LOCATION
195100                 PERFORM Y910-WRITE-LOG-RECORD
195200                                 THRU Y919-WLR-EXIT
195300             ELSE
195400                 MOVE MM01-NA-LINE (X-MM01-NA)
195500                                 TO MMMM-NA-LINE
195600                                    (X-MMMM-PRIMARY X-MMMM-NA).
195700*
195800 X159-UPA3-EXIT.
195900     EXIT.
196000*
196100 X170-UPDATE-PRIM-ADDRESS4.
196200*
196300     SET X-MMMM-NA               TO 4.
196400     SET X-MM01-NA               TO 4.
196500*
196600     IF  MM01-NA-LINE-L (X-MM01-NA) IS GREATER THAN ZERO
196700         IF  MM01-NA-LINE (X-MM01-NA) IS NOT EQUAL TO MMMM-NA-LINE
196800                                      (X-MMMM-PRIMARY X-MMMM-NA)
196900             SET WS-UPDATE-SW-YES
197000                                 TO TRUE
197100             IF  MBCA-PTI-FUNCTION-IS-MAINT
197200                 MOVE MMMMTB-PRIM-ADDR4 (1:4)
197300                                 TO WS-INDEX-X
197400                 SET X-MMFS-MERCH
197500                                 TO WS-INDEX
197600                 MOVE MMFS-MT-AUDIT-CODE (X-MMFS-MERCH)
197700                                 TO MML1-MMMM-AUDIT-CODE
197800                 MOVE 0106       TO MML1-FIELD-CODE
197900                 MOVE 1          TO MML1-FIELD-OCCURRENCE
198000                 MOVE 4          TO MML1-FIELD-OCCURRENCE-2
198100                 MOVE MML1WS-VL-40
198200                                 TO MML1-VARIABLE-LENGTH
198300                 MOVE MMMM-NA-LINE  (X-MMMM-PRIMARY X-MMMM-NA)
198400                                 TO MML1-VL40-B-DATA-X
198500                 MOVE MM01-NA-LINE (X-MM01-NA)
198600                                 TO MMMM-NA-LINE
198700                                    (X-MMMM-PRIMARY X-MMMM-NA)
198800                 MOVE MMMM-NA-LINE  (X-MMMM-PRIMARY X-MMMM-NA)
198900                                 TO MML1-VL40-A-DATA-X
199000                 MOVE 'FC24'     TO MBCA-PROGRAM-LOCATION
199100                 PERFORM Y910-WRITE-LOG-RECORD
199200                                 THRU Y919-WLR-EXIT
199300             ELSE
199400                 MOVE MM01-NA-LINE (X-MM01-NA)
199500                                 TO MMMM-NA-LINE
199600                                    (X-MMMM-PRIMARY X-MMMM-NA).
199700*
199800 X179-UPA4-EXIT.
199900     EXIT.
200000*
200100 X190-UPDATE-PRIM-ADDRESS5.
200200*
200300     SET X-MMMM-NA               TO 5.
200400     SET X-MM01-NA               TO 5.
200500*
200600     IF  MM01-NA-LINE-L (X-MM01-NA) IS GREATER THAN ZERO
200700         IF  MM01-NA-LINE (X-MM01-NA) IS NOT EQUAL TO MMMM-NA-LINE
200800                                      (X-MMMM-PRIMARY X-MMMM-NA)
200900             SET WS-UPDATE-SW-YES
201000                                 TO TRUE
201100             IF  MBCA-PTI-FUNCTION-IS-MAINT
201200                 MOVE MMMMTB-PRIM-ADDR5 (1:4)
201300                                 TO WS-INDEX-X
201400                 SET X-MMFS-MERCH
201500                                 TO WS-INDEX
201600                 MOVE MMFS-MT-AUDIT-CODE (X-MMFS-MERCH)
201700                                 TO MML1-MMMM-AUDIT-CODE
201800                 MOVE 0106       TO MML1-FIELD-CODE
201900                 MOVE 1          TO MML1-FIELD-OCCURRENCE
202000                 MOVE 5          TO MML1-FIELD-OCCURRENCE-2
202100                 MOVE MML1WS-VL-40
202200                                 TO MML1-VARIABLE-LENGTH
202300                 MOVE MMMM-NA-LINE  (X-MMMM-PRIMARY X-MMMM-NA)
202400                                 TO MML1-VL40-B-DATA-X
202500                 MOVE MM01-NA-LINE (X-MM01-NA)
202600                                 TO MMMM-NA-LINE
202700                                    (X-MMMM-PRIMARY X-MMMM-NA)
202800                 MOVE MMMM-NA-LINE  (X-MMMM-PRIMARY X-MMMM-NA)
202900                                 TO MML1-VL40-A-DATA-X
203000                 MOVE 'FC25'     TO MBCA-PROGRAM-LOCATION
203100                 PERFORM Y910-WRITE-LOG-RECORD
203200                                 THRU Y919-WLR-EXIT
203300             ELSE
203400                 MOVE MM01-NA-LINE (X-MM01-NA)
203500                                 TO MMMM-NA-LINE
203600                                    (X-MMMM-PRIMARY X-MMMM-NA).
203700*
203800 X199-UPA5-EXIT.
203900     EXIT.
204000*
204100 X210-UPDATE-PRIM-STATE.
204200*
204300     IF  MM01-STATE-CODE-L IS GREATER THAN ZERO
204400         IF  MM01-STATE-CODE IS NOT EQUAL TO MMMM-STATE-CODE
204500                                       (X-MMMM-PRIMARY)
204600             SET WS-UPDATE-SW-YES
204700                                 TO TRUE
204800             IF  MBCA-PTI-FUNCTION-IS-MAINT
204900                 MOVE MMMMTB-PRIM-STATE (1:4)
205000                                 TO WS-INDEX-X
205100                 SET X-MMFS-MERCH
205200                                 TO WS-INDEX
205300                 MOVE MMFS-MT-AUDIT-CODE (X-MMFS-MERCH)
205400                                 TO MML1-MMMM-AUDIT-CODE
205500                 MOVE 0107       TO MML1-FIELD-CODE
205600                 MOVE 1          TO MML1-FIELD-OCCURRENCE
205700                 MOVE ZEROS      TO MML1-FIELD-OCCURRENCE-2
205800                 MOVE MML1WS-VL-03
205900                                 TO MML1-VARIABLE-LENGTH
206000                 MOVE MMMM-STATE-CODE (X-MMMM-PRIMARY)
206100                                 TO MML1-VL03-B-DATA-X
206200                 MOVE MM01-STATE-CODE
206300                                 TO MMMM-STATE-CODE
206400                                    (X-MMMM-PRIMARY)
206500                 MOVE MMMM-STATE-CODE (X-MMMM-PRIMARY)
206600                                 TO MML1-VL03-A-DATA-X
206700                 MOVE 'FC26'     TO MBCA-PROGRAM-LOCATION
206800                 PERFORM Y910-WRITE-LOG-RECORD
206900                                 THRU Y919-WLR-EXIT
207000             ELSE
207100                 MOVE MM01-STATE-CODE
207200                                 TO MMMM-STATE-CODE
207300                                    (X-MMMM-PRIMARY).
207400*
207500 X219-UPS-EXIT.
207600     EXIT.
207700*
207800 X230-UPDATE-PRIM-PHONE.
207900*
208000     IF  MM01-PHONE-L IS GREATER THAN ZERO
208100         IF  MM01-PHONE IS NOT EQUAL TO MMMM-PHONE
208200                                        (X-MMMM-PRIMARY)
208300             SET WS-UPDATE-SW-YES
208400                                 TO TRUE
208500             IF  MBCA-PTI-FUNCTION-IS-MAINT
208600                 MOVE MMMMTB-PRIM-PHONE (1:4)
208700                                 TO WS-INDEX-X
208800                 SET X-MMFS-MERCH
208900                                 TO WS-INDEX
209000                 MOVE MMFS-MT-AUDIT-CODE (X-MMFS-MERCH)
209100                                 TO MML1-MMMM-AUDIT-CODE
209200                 MOVE 0108       TO MML1-FIELD-CODE
209300                 MOVE 1          TO MML1-FIELD-OCCURRENCE
209400                 MOVE ZEROS      TO MML1-FIELD-OCCURRENCE-2
209500                 MOVE MML1WS-VL-20
209600                                 TO MML1-VARIABLE-LENGTH
209700                 MOVE MMMM-PHONE (X-MMMM-PRIMARY)
209800                                 TO MML1-VL20-B-DATA-X
209900                 MOVE MM01-PHONE TO MMMM-PHONE (X-MMMM-PRIMARY)
210000                 MOVE MMMM-PHONE (X-MMMM-PRIMARY)
210100                                 TO MML1-VL20-A-DATA-X
210200                 MOVE 'FC27'     TO MBCA-PROGRAM-LOCATION
210300                 PERFORM Y910-WRITE-LOG-RECORD
210400                                 THRU Y919-WLR-EXIT
210500             ELSE
210600                 MOVE MM01-PHONE TO MMMM-PHONE (X-MMMM-PRIMARY).
210700*
210800 X239-UPP-EXIT.
210900     EXIT.
211000*
211100 X250-UPDATE-PRIM-POSTAL-CODE.
211200*
211300     IF  MM01-POSTAL-CODE-L IS GREATER THAN ZERO
211400         IF  MM01-POSTAL-CODE IS NOT EQUAL TO MMMM-POSTAL-CODE
211500                                           (X-MMMM-PRIMARY)
211600             SET WS-UPDATE-SW-YES
211700                                 TO TRUE
211800             IF  MBCA-PTI-FUNCTION-IS-MAINT
211900                 MOVE MMMMTB-PRIM-POSTAL-CODE (1:4)
212000                                 TO WS-INDEX-X
212100                 SET X-MMFS-MERCH
212200                                 TO WS-INDEX
212300                 MOVE MMFS-MT-AUDIT-CODE (X-MMFS-MERCH)
212400                                 TO MML1-MMMM-AUDIT-CODE
212500                 MOVE 0109       TO MML1-FIELD-CODE
212600                 MOVE 1          TO MML1-FIELD-OCCURRENCE
212700                 MOVE ZEROS      TO MML1-FIELD-OCCURRENCE-2
212800                 MOVE MML1WS-VL-10
212900                                 TO MML1-VARIABLE-LENGTH
213000                 MOVE MMMM-POSTAL-CODE (X-MMMM-PRIMARY)
213100                                 TO MML1-VL10-B-DATA-X
213200                 MOVE MM01-POSTAL-CODE
213300                                 TO MMMM-POSTAL-CODE
213400                                    (X-MMMM-PRIMARY)
213500                 MOVE MMMM-POSTAL-CODE (X-MMMM-PRIMARY)
213600                                 TO MML1-VL10-A-DATA-X
213700                 MOVE 'FC28'     TO MBCA-PROGRAM-LOCATION
213800                 PERFORM Y910-WRITE-LOG-RECORD
213900                                 THRU Y919-WLR-EXIT
214000             ELSE
214100                 MOVE MM01-POSTAL-CODE
214200                                 TO MMMM-POSTAL-CODE
214300                                    (X-MMMM-PRIMARY).
214400*
214500 X259-UPPC-EXIT.
214600     EXIT.
214700*
214800 X270-UPDATE-PRIM-FAX.
214900*
215000     IF  MM01-FAX-L IS GREATER THAN ZERO
215100         IF  MM01-FAX IS NOT EQUAL TO MMMM-FAX (X-MMMM-PRIMARY)
215200             SET WS-UPDATE-SW-YES
215300                                 TO TRUE
215400             IF  MBCA-PTI-FUNCTION-IS-MAINT
215500                 MOVE MMMMTB-PRIM-FAX (1:4)
215600                                 TO WS-INDEX-X
215700                 SET X-MMFS-MERCH
215800                                 TO WS-INDEX
215900                 MOVE MMFS-MT-AUDIT-CODE (X-MMFS-MERCH)
216000                                 TO MML1-MMMM-AUDIT-CODE
216100                 MOVE 0110       TO MML1-FIELD-CODE
216200                 MOVE 1          TO MML1-FIELD-OCCURRENCE
216300                 MOVE ZEROS      TO MML1-FIELD-OCCURRENCE-2
216400                 MOVE MML1WS-VL-20
216500                                 TO MML1-VARIABLE-LENGTH
216600                 MOVE MMMM-FAX (X-MMMM-PRIMARY)
216700                                 TO MML1-VL20-B-DATA-X
216800                 MOVE MM01-FAX   TO MMMM-FAX (X-MMMM-PRIMARY)
216900                 MOVE MMMM-FAX (X-MMMM-PRIMARY)
217000                                 TO MML1-VL20-A-DATA-X
217100                 MOVE 'FC29'     TO MBCA-PROGRAM-LOCATION
217200                 PERFORM Y910-WRITE-LOG-RECORD
217300                                 THRU Y919-WLR-EXIT
217400             ELSE
217500                 MOVE MM01-FAX   TO MMMM-FAX (X-MMMM-PRIMARY).
217600*
217700 X279-UPF-EXIT.
217800     EXIT.
217900*
218000 X290-UPDATE-INITIALIZED-FIELDS.
218100*
218200     IF  WS-STORE-CRB-UPDATE-SW-YES
218300         MOVE 9010               TO MML1-FIELD-CODE
218400         MOVE ZEROS              TO MML1-FIELD-OCCURRENCE
218500                                    MML1-FIELD-OCCURRENCE-2
218600         MOVE MML1WS-VL-01       TO MML1-VARIABLE-LENGTH
218700         MOVE WS-CRB-FLAG        TO MML1-VL01-B-DATA-X
218800         MOVE MMSM-CRB-FLAG      TO MML1-VL01-A-DATA-X
218900         MOVE 'FC30'             TO MBCA-PROGRAM-LOCATION
219000         PERFORM Y969-WRITE-STORE-LOG
219100                                 THRU Y969-EXIT.
219200*
219300     IF  WS-STORE-UPDATE-SW-YES
219400         MOVE 9035               TO MML1-FIELD-CODE
219500         MOVE ZEROS              TO MML1-FIELD-OCCURRENCE
219600                                    MML1-FIELD-OCCURRENCE-2
219700         MOVE MML1WS-VL-01       TO MML1-VARIABLE-LENGTH
219800         MOVE MMSM-SINGLE-STORE-FLAG
219900                                 TO MML1-VL01-B-DATA-X
220000         MOVE MM01-SINGLE-STORE-FLAG
220100                                 TO MMSM-SINGLE-STORE-FLAG
220200         MOVE MMSM-SINGLE-STORE-FLAG
220300                                 TO MML1-VL01-A-DATA-X
220400         MOVE 'FC31'             TO MBCA-PROGRAM-LOCATION
220500         PERFORM Y969-WRITE-STORE-LOG
220600                                 THRU Y969-EXIT
220700         MOVE 'MM'               TO MML1-FILE-CODE
220800         MOVE MBCA-MERCHANT-ORG  TO MML1-MMMM-ORG
220900         MOVE MBCA-MERCHANT      TO MML1-MMMM-MERCHANT
221000         MOVE MBCA-SIGNON-NAME   TO MML1-SIGNON-NAME
221100         MOVE MBCA-TERMINAL-ID   TO MML1-TERMINAL-ID
221200         MOVE ZEROS              TO MML1-SOURCE-CODE
221300         MOVE MBCA-FIELD-SECURITY
221400                                 TO MML1-FIELD-SECURITY
221500         MOVE MMMMTB-STORE-NBR (1:4)
221600                                 TO WS-INDEX-X
221700         SET X-MMFS-MERCH        TO WS-INDEX
221800         MOVE MMFS-MT-AUDIT-CODE (X-MMFS-MERCH)
221900                                 TO MML1-MMMM-AUDIT-CODE
222000         MOVE 1201               TO MML1-FIELD-CODE
222100         MOVE ZEROS              TO MML1-FIELD-OCCURRENCE
222200                                    MML1-FIELD-OCCURRENCE-2
222300         MOVE MML1WS-VL-10       TO MML1-VARIABLE-LENGTH
222400         MOVE MMMM-STORE-NBR     TO MML1-VL10-B-DATA-9
222500         MOVE MMMMIR-STORE-NBR   TO MMMM-STORE-NBR
222600         MOVE MMMM-STORE-NBR     TO MML1-VL10-A-DATA-9
222700         MOVE 'FC32'             TO MBCA-PROGRAM-LOCATION
222800         PERFORM Y910-WRITE-LOG-RECORD
222900                                 THRU Y919-WLR-EXIT
223000         MOVE MMMMTB-NBR-STORES (1:4)
223100                                 TO WS-INDEX-X
223200         SET X-MMFS-MERCH        TO WS-INDEX
223300         MOVE MMFS-MT-AUDIT-CODE (X-MMFS-MERCH)
223400                                 TO MML1-MMMM-AUDIT-CODE
223500         MOVE 0910               TO MML1-FIELD-CODE
223600         MOVE ZEROS              TO MML1-FIELD-OCCURRENCE
223700                                    MML1-FIELD-OCCURRENCE-2
223800         MOVE MML1WS-VL-10       TO MML1-VARIABLE-LENGTH
223900         MOVE MMMM-NBR-STORES    TO MML1-VL10-B-DATA-9
224000         MOVE 1                  TO MMMM-NBR-STORES
224100         MOVE MMMM-NBR-STORES    TO MML1-VL10-A-DATA-9
224200         MOVE 'FC33'             TO MBCA-PROGRAM-LOCATION
224300         PERFORM Y910-WRITE-LOG-RECORD
224400                                 THRU Y919-WLR-EXIT.
224500*
224600     IF  MMMM-SINGLE-STORE-NO
224700         GO TO X299-UIF-EXIT.
224800*
224900     SET X-MMSM-PRIMARY          TO 1.
225000*
225100     IF  MM01-COUNTRY-CODE-L IS GREATER THAN ZERO
225200         IF  MM01-COUNTRY-CODE IS NOT EQUAL TO MMSM-COUNTRY-CODE
225300                                               (X-MMSM-PRIMARY)
225400             SET WS-STORE-UPDATE-SW-YES
225500                                 TO TRUE
225600             IF  MBCA-PTI-FUNCTION-IS-MAINT
225700                 MOVE MMSMTB-COUNTRY-CODE (1:4)
225800                                 TO WS-INDEX-X
225900                 SET X-MMFS-STORE
226000                                 TO WS-INDEX
226100                 MOVE MMFS-ST-AUDIT-CODE (X-MMFS-STORE)
226200                                 TO MML1-MMSM-AUDIT-CODE
226300                 MOVE 0101       TO MML1-FIELD-CODE
226400                 MOVE ZEROS      TO MML1-FIELD-OCCURRENCE
226500                                    MML1-FIELD-OCCURRENCE-2
226600                 MOVE MML1WS-VL-03
226700                                 TO MML1-VARIABLE-LENGTH
226800                 MOVE MMSM-COUNTRY-CODE (X-MMSM-PRIMARY)
226900                                 TO MML1-VL03-B-DATA-X
227000                 MOVE MM01-COUNTRY-CODE
227100                                 TO MMSM-COUNTRY-CODE
227200                                    (X-MMSM-PRIMARY)
227300                 MOVE MMSM-COUNTRY-CODE (X-MMSM-PRIMARY)
227400                                 TO MML1-VL03-A-DATA-X
227500                 MOVE 'FC34'     TO MBCA-PROGRAM-LOCATION
227600                 PERFORM Y969-WRITE-STORE-LOG
227700                                 THRU Y969-EXIT.
227800*
227900*
228000     SET X-MMSM-NA               TO 1.
228100     SET X-MM01-NA               TO 1.
228200*
228300     IF  MM01-NA-LINE-L (X-MM01-NA) IS GREATER THAN ZERO
228400         IF  MM01-NA-LINE (X-MM01-NA) IS NOT EQUAL TO MMSM-NA-LINE
228500                                      (X-MMSM-PRIMARY X-MMSM-NA)
228600             SET WS-STORE-UPDATE-SW-YES
228700                                 TO TRUE
228800             IF  MBCA-PTI-FUNCTION-IS-MAINT
228900                 MOVE MMSMTB-PRIM-ADDR1 (1:4)
229000                                 TO WS-INDEX-X
229100                 SET X-MMFS-STORE
229200                                 TO WS-INDEX
229300                 MOVE MMFS-ST-AUDIT-CODE (X-MMFS-STORE)
229400                                 TO MML1-MMSM-AUDIT-CODE
229500                 MOVE 0106       TO MML1-FIELD-CODE
229600                 MOVE 1          TO MML1-FIELD-OCCURRENCE
229700                 MOVE 1          TO MML1-FIELD-OCCURRENCE-2
229800                 MOVE MML1WS-VL-40
229900                                 TO MML1-VARIABLE-LENGTH
230000                 MOVE MMSM-NA-LINE  (X-MMSM-PRIMARY X-MMSM-NA)
230100                                 TO MML1-VL40-B-DATA-X
230200                 MOVE MM01-NA-LINE (X-MM01-NA)
230300                                 TO MMSM-NA-LINE
230400                                    (X-MMSM-PRIMARY X-MMSM-NA)
230500                 MOVE MMSM-NA-LINE  (X-MMSM-PRIMARY X-MMSM-NA)
230600                                 TO MML1-VL40-A-DATA-X
230700                 MOVE 'FC35'     TO MBCA-PROGRAM-LOCATION
230800                 PERFORM Y969-WRITE-STORE-LOG
230900                                 THRU Y969-EXIT.
231000*
231100     SET X-MMSM-NA               TO 2.
231200     SET X-MM01-NA               TO 2.
231300*
231400     IF  MM01-NA-LINE-L (X-MM01-NA) IS GREATER THAN ZERO
231500         IF  MM01-NA-LINE (X-MM01-NA) IS NOT EQUAL TO MMSM-NA-LINE
231600                                      (X-MMSM-PRIMARY X-MMSM-NA)
231700             SET WS-STORE-UPDATE-SW-YES
231800                                 TO TRUE
231900             IF  MBCA-PTI-FUNCTION-IS-MAINT
232000                 MOVE MMSMTB-PRIM-ADDR2 (1:4)
232100                                 TO WS-INDEX-X
232200                 SET X-MMFS-STORE
232300                                 TO WS-INDEX
232400                 MOVE MMFS-ST-AUDIT-CODE (X-MMFS-STORE)
232500                                 TO MML1-MMSM-AUDIT-CODE
232600                 MOVE 0106       TO MML1-FIELD-CODE
232700                 MOVE 1          TO MML1-FIELD-OCCURRENCE
232800                 MOVE 2          TO MML1-FIELD-OCCURRENCE-2
232900                 MOVE MML1WS-VL-40
233000                                 TO MML1-VARIABLE-LENGTH
233100                 MOVE MMSM-NA-LINE  (X-MMSM-PRIMARY X-MMSM-NA)
233200                                 TO MML1-VL40-B-DATA-X
233300                 MOVE MM01-NA-LINE (X-MM01-NA)
233400                                 TO MMSM-NA-LINE
233500                                    (X-MMSM-PRIMARY X-MMSM-NA)
233600                 MOVE MMSM-NA-LINE  (X-MMSM-PRIMARY X-MMSM-NA)
233700                                 TO MML1-VL40-A-DATA-X
233800                 MOVE 'FC36'     TO MBCA-PROGRAM-LOCATION
233900                 PERFORM Y969-WRITE-STORE-LOG
234000                                 THRU Y969-EXIT.
234100*
234200     SET X-MMSM-NA               TO 3.
234300     SET X-MM01-NA               TO 3.
234400*
234500     IF  MM01-NA-LINE-L (X-MM01-NA) IS GREATER THAN ZERO
234600         IF  MM01-NA-LINE (X-MM01-NA) IS NOT EQUAL TO MMSM-NA-LINE
234700                                      (X-MMSM-PRIMARY X-MMSM-NA)
234800             SET WS-STORE-UPDATE-SW-YES
234900                                 TO TRUE
235000             IF  MBCA-PTI-FUNCTION-IS-MAINT
235100                 MOVE MMSMTB-PRIM-ADDR3 (1:4)
235200                                 TO WS-INDEX-X
235300                 SET X-MMFS-STORE
235400                                 TO WS-INDEX
235500                 MOVE MMFS-ST-AUDIT-CODE (X-MMFS-STORE)
235600                                 TO MML1-MMSM-AUDIT-CODE
235700                 MOVE 0106       TO MML1-FIELD-CODE
235800                 MOVE 1          TO MML1-FIELD-OCCURRENCE
235900                 MOVE 3          TO MML1-FIELD-OCCURRENCE-2
236000                 MOVE MML1WS-VL-40
236100                                 TO MML1-VARIABLE-LENGTH
236200                 MOVE MMSM-NA-LINE  (X-MMSM-PRIMARY X-MMSM-NA)
236300                                 TO MML1-VL40-B-DATA-X
236400                 MOVE MM01-NA-LINE (X-MM01-NA)
236500                                 TO MMSM-NA-LINE
236600                                    (X-MMSM-PRIMARY X-MMSM-NA)
236700                 MOVE MMSM-NA-LINE  (X-MMSM-PRIMARY X-MMSM-NA)
236800                                 TO MML1-VL40-A-DATA-X
236900                 MOVE 'FC37'     TO MBCA-PROGRAM-LOCATION
237000                 PERFORM Y969-WRITE-STORE-LOG
237100                                 THRU Y969-EXIT.
237200*
237300     SET X-MMSM-NA               TO 4.
237400     SET X-MM01-NA               TO 4.
237500*
237600     IF  MM01-NA-LINE-L (X-MM01-NA) IS GREATER THAN ZERO
237700         IF  MM01-NA-LINE (X-MM01-NA) IS NOT EQUAL TO MMSM-NA-LINE
237800                                      (X-MMSM-PRIMARY X-MMSM-NA)
237900             SET WS-STORE-UPDATE-SW-YES
238000                                 TO TRUE
238100             IF  MBCA-PTI-FUNCTION-IS-MAINT
238200                 MOVE MMSMTB-PRIM-ADDR4 (1:4)
238300                                 TO WS-INDEX-X
238400                 SET X-MMFS-STORE
238500                                 TO WS-INDEX
238600                 MOVE MMFS-ST-AUDIT-CODE (X-MMFS-STORE)
238700                                 TO MML1-MMSM-AUDIT-CODE
238800                 MOVE 0106       TO MML1-FIELD-CODE
238900                 MOVE 1          TO MML1-FIELD-OCCURRENCE
239000                 MOVE 4          TO MML1-FIELD-OCCURRENCE-2
239100                 MOVE MML1WS-VL-40
239200                                 TO MML1-VARIABLE-LENGTH
239300                 MOVE MMSM-NA-LINE  (X-MMSM-PRIMARY X-MMSM-NA)
239400                                 TO MML1-VL40-B-DATA-X
239500                 MOVE MM01-NA-LINE (X-MM01-NA)
239600                                 TO MMSM-NA-LINE
239700                                    (X-MMSM-PRIMARY X-MMSM-NA)
239800                 MOVE MMSM-NA-LINE  (X-MMSM-PRIMARY X-MMSM-NA)
239900                                 TO MML1-VL40-A-DATA-X
240000                 MOVE 'FC38'     TO MBCA-PROGRAM-LOCATION
240100                 PERFORM Y969-WRITE-STORE-LOG
240200                                 THRU Y969-EXIT.
240300*
240400     SET X-MMSM-NA               TO 5.
240500     SET X-MM01-NA               TO 5.
240600*
240700     IF  MM01-NA-LINE-L (X-MM01-NA) IS GREATER THAN ZERO
240800         IF  MM01-NA-LINE (X-MM01-NA) IS NOT EQUAL TO MMSM-NA-LINE
240900                                      (X-MMSM-PRIMARY X-MMSM-NA)
241000             SET WS-STORE-UPDATE-SW-YES
241100                                 TO TRUE
241200             IF  MBCA-PTI-FUNCTION-IS-MAINT
241300                 MOVE MMSMTB-PRIM-ADDR5 (1:4)
241400                                 TO WS-INDEX-X
241500                 SET X-MMFS-STORE
241600                                 TO WS-INDEX
241700                 MOVE MMFS-ST-AUDIT-CODE (X-MMFS-STORE)
241800                                 TO MML1-MMSM-AUDIT-CODE
241900                 MOVE 0106       TO MML1-FIELD-CODE
242000                 MOVE 1          TO MML1-FIELD-OCCURRENCE
242100                 MOVE 5          TO MML1-FIELD-OCCURRENCE-2
242200                 MOVE MML1WS-VL-40
242300                                 TO MML1-VARIABLE-LENGTH
242400                 MOVE MMSM-NA-LINE  (X-MMSM-PRIMARY X-MMSM-NA)
242500                                 TO MML1-VL40-B-DATA-X
242600                 MOVE MM01-NA-LINE (X-MM01-NA)
242700                                 TO MMSM-NA-LINE
242800                                    (X-MMSM-PRIMARY X-MMSM-NA)
242900                 MOVE MMSM-NA-LINE  (X-MMSM-PRIMARY X-MMSM-NA)
243000                                 TO MML1-VL40-A-DATA-X
243100                 MOVE 'FC39'     TO MBCA-PROGRAM-LOCATION
243200                 PERFORM Y969-WRITE-STORE-LOG
243300                                 THRU Y969-EXIT.
243400*
243500     IF  MM01-STATE-CODE-L IS GREATER THAN ZERO
243600         IF  MM01-STATE-CODE IS NOT EQUAL TO MMSM-STATE-CODE
243700                                       (X-MMSM-PRIMARY)
243800             SET WS-STORE-UPDATE-SW-YES
243900                                 TO TRUE
244000             IF  MBCA-PTI-FUNCTION-IS-MAINT
244100                 MOVE MMSMTB-PRIM-STATE (1:4)
244200                                 TO WS-INDEX-X
244300                 SET X-MMFS-STORE
244400                                 TO WS-INDEX
244500                 MOVE MMFS-ST-AUDIT-CODE (X-MMFS-STORE)
244600                                 TO MML1-MMSM-AUDIT-CODE
244700                 MOVE 0107       TO MML1-FIELD-CODE
244800                 MOVE 1          TO MML1-FIELD-OCCURRENCE
244900                 MOVE ZEROS      TO MML1-FIELD-OCCURRENCE-2
245000                 MOVE MML1WS-VL-03
245100                                 TO MML1-VARIABLE-LENGTH
245200                 MOVE MMSM-STATE-CODE (X-MMSM-PRIMARY)
245300                                 TO MML1-VL03-B-DATA-X
245400                 MOVE MM01-STATE-CODE
245500                                 TO MMSM-STATE-CODE
245600                                    (X-MMSM-PRIMARY)
245700                 MOVE MMSM-STATE-CODE (X-MMSM-PRIMARY)
245800                                 TO MML1-VL03-A-DATA-X
245900                 MOVE 'FC40'     TO MBCA-PROGRAM-LOCATION
246000                 PERFORM Y969-WRITE-STORE-LOG
246100                                 THRU Y969-EXIT.
246200*
246300     IF  MM01-PHONE-L IS GREATER THAN ZERO
246400         IF  MM01-PHONE IS NOT EQUAL TO MMSM-PHONE
246500                                        (X-MMSM-PRIMARY)
246600             SET WS-STORE-UPDATE-SW-YES
246700                                 TO TRUE
246800             IF  MBCA-PTI-FUNCTION-IS-MAINT
246900                 MOVE MMSMTB-PRIM-PHONE (1:4)
247000                                 TO WS-INDEX-X
247100                 SET X-MMFS-STORE
247200                                 TO WS-INDEX
247300                 MOVE MMFS-ST-AUDIT-CODE (X-MMFS-STORE)
247400                                 TO MML1-MMSM-AUDIT-CODE
247500                 MOVE 0108       TO MML1-FIELD-CODE
247600                 MOVE 1          TO MML1-FIELD-OCCURRENCE
247700                 MOVE ZEROS      TO MML1-FIELD-OCCURRENCE-2
247800                 MOVE MML1WS-VL-20
247900                                 TO MML1-VARIABLE-LENGTH
248000                 MOVE MMSM-PHONE (X-MMSM-PRIMARY)
248100                                 TO MML1-VL20-B-DATA-X
248200                 MOVE MM01-PHONE TO MMSM-PHONE (X-MMSM-PRIMARY)
248300                 MOVE MMSM-PHONE (X-MMSM-PRIMARY)
248400                                 TO MML1-VL20-A-DATA-X
248500                 MOVE 'FC41'     TO MBCA-PROGRAM-LOCATION
248600                 PERFORM Y969-WRITE-STORE-LOG
248700                                 THRU Y969-EXIT.
248800*
248900     IF  MM01-POSTAL-CODE-L IS GREATER THAN ZERO
249000         IF  MM01-POSTAL-CODE IS NOT EQUAL TO MMSM-POSTAL-CODE
249100                                           (X-MMSM-PRIMARY)
249200             SET WS-STORE-UPDATE-SW-YES
249300                                 TO TRUE
249400             IF  MBCA-PTI-FUNCTION-IS-MAINT
249500                 MOVE MMSMTB-PRIM-POSTAL-CODE (1:4)
249600                                 TO WS-INDEX-X
249700                 SET X-MMFS-STORE
249800                                 TO WS-INDEX
249900                 MOVE MMFS-ST-AUDIT-CODE (X-MMFS-STORE)
250000                                 TO MML1-MMSM-AUDIT-CODE
250100                 MOVE 0109       TO MML1-FIELD-CODE
250200                 MOVE 1          TO MML1-FIELD-OCCURRENCE
250300                 MOVE ZEROS      TO MML1-FIELD-OCCURRENCE-2
250400                 MOVE MML1WS-VL-10
250500                                 TO MML1-VARIABLE-LENGTH
250600                 MOVE MMSM-POSTAL-CODE (X-MMSM-PRIMARY)
250700                                 TO MML1-VL10-B-DATA-X
250800                 MOVE MM01-POSTAL-CODE
250900                                 TO MMSM-POSTAL-CODE
251000                                    (X-MMSM-PRIMARY)
251100                 MOVE MMSM-POSTAL-CODE (X-MMSM-PRIMARY)
251200                                 TO MML1-VL10-A-DATA-X
251300                 MOVE 'FC42'     TO MBCA-PROGRAM-LOCATION
251400                 PERFORM Y969-WRITE-STORE-LOG
251500                                 THRU Y969-EXIT.
251600*
251700     IF  MM01-FAX-L IS GREATER THAN ZERO
251800         IF  MM01-FAX IS NOT EQUAL TO MMSM-FAX (X-MMSM-PRIMARY)
251900             SET WS-STORE-UPDATE-SW-YES
252000                                 TO TRUE
252100             IF  MBCA-PTI-FUNCTION-IS-MAINT
252200                 MOVE MMSMTB-PRIM-FAX (1:4)
252300                                 TO WS-INDEX-X
252400                 SET X-MMFS-STORE
252500                                 TO WS-INDEX
252600                 MOVE MMFS-ST-AUDIT-CODE (X-MMFS-STORE)
252700                                 TO MML1-MMSM-AUDIT-CODE
252800                 MOVE 0110       TO MML1-FIELD-CODE
252900                 MOVE 1          TO MML1-FIELD-OCCURRENCE
253000                 MOVE ZEROS      TO MML1-FIELD-OCCURRENCE-2
253100                 MOVE MML1WS-VL-20
253200                                 TO MML1-VARIABLE-LENGTH
253300                 MOVE MMSM-FAX (X-MMSM-PRIMARY)
253400                                 TO MML1-VL20-B-DATA-X
253500                 MOVE MM01-FAX   TO MMSM-FAX (X-MMSM-PRIMARY)
253600                 MOVE MMSM-FAX (X-MMSM-PRIMARY)
253700                                 TO MML1-VL20-A-DATA-X
253800                 MOVE 'FC43'     TO MBCA-PROGRAM-LOCATION
253900                 PERFORM Y969-WRITE-STORE-LOG
254000                                 THRU Y969-EXIT.
254100*
254200     IF  MM01-DBA-NAME-L IS GREATER THAN ZERO
254300         IF  MM01-DBA-NAME IS NOT EQUAL TO MMSM-DBA-NAME
254400             SET WS-STORE-UPDATE-SW-YES
254500                                 TO TRUE
254600             IF  MBCA-PTI-FUNCTION-IS-MAINT
254700                 MOVE MMSMTB-DBA-NAME (1:4)
254800                                 TO WS-INDEX-X
254900                 SET X-MMFS-STORE
255000                                 TO WS-INDEX
255100                 MOVE MMFS-ST-AUDIT-CODE (X-MMFS-STORE)
255200                                 TO MML1-MMSM-AUDIT-CODE
255300                 MOVE 0102       TO MML1-FIELD-CODE
255400                 MOVE ZEROS      TO MML1-FIELD-OCCURRENCE
255500                                    MML1-FIELD-OCCURRENCE-2
255600                 MOVE MML1WS-VL-30
255700                                 TO MML1-VARIABLE-LENGTH
255800                 MOVE MMSM-DBA-NAME
255900                                 TO MML1-VL30-B-DATA-X
256000                 MOVE MM01-DBA-NAME
256100                                 TO MMSM-DBA-NAME
256200                 MOVE MMSM-DBA-NAME
256300                                 TO MML1-VL30-A-DATA-X
256400                 MOVE 'FC44'     TO MBCA-PROGRAM-LOCATION
256500                 PERFORM Y969-WRITE-STORE-LOG
256600                                 THRU Y969-EXIT.
256700*
256800     IF  MM01-DBA-CITY-L IS GREATER THAN ZERO
256900         IF  MM01-DBA-CITY IS NOT EQUAL TO MMSM-DBA-CITY
257000             SET WS-STORE-UPDATE-SW-YES
257100                                 TO TRUE
257200             IF  MBCA-PTI-FUNCTION-IS-MAINT
257300                 MOVE MMSMTB-DBA-CITY (1:4)
257400                                 TO WS-INDEX-X
257500                 SET X-MMFS-STORE
257600                                 TO WS-INDEX
257700                 MOVE MMFS-ST-AUDIT-CODE (X-MMFS-STORE)
257800                                 TO MML1-MMSM-AUDIT-CODE
257900                 MOVE 0104       TO MML1-FIELD-CODE
258000                 MOVE ZEROS      TO MML1-FIELD-OCCURRENCE
258100                                    MML1-FIELD-OCCURRENCE-2
258200                 MOVE MML1WS-VL-30
258300                                 TO MML1-VARIABLE-LENGTH
258400                 MOVE MMSM-DBA-CITY
258500                                 TO MML1-VL30-B-DATA-X
258600                 MOVE MM01-DBA-CITY
258700                                 TO MMSM-DBA-CITY
258800                 MOVE MMSM-DBA-CITY
258900                                 TO MML1-VL30-A-DATA-X
259000                 MOVE 'FC45'     TO MBCA-PROGRAM-LOCATION
259100                 PERFORM Y969-WRITE-STORE-LOG
259200                                 THRU Y969-EXIT.
259300*
259400     IF  MM01-DBA-STATE-L IS GREATER THAN ZERO
259500         IF  MM01-DBA-STATE IS NOT EQUAL TO MMSM-DBA-COUNTRY-CODE
259600             SET WS-STORE-UPDATE-SW-YES
259700                                 TO TRUE
259800             IF  MBCA-PTI-FUNCTION-IS-MAINT
259900                 MOVE MMSMTB-DBA-COUNTRY-CODE (1:4)
260000                                 TO WS-INDEX-X
260100                 SET X-MMFS-STORE
260200                                 TO WS-INDEX
260300                 MOVE MMFS-ST-AUDIT-CODE (X-MMFS-STORE)
260400                                 TO MML1-MMSM-AUDIT-CODE
260500                 MOVE 0105       TO MML1-FIELD-CODE
260600                 MOVE ZEROS      TO MML1-FIELD-OCCURRENCE
260700                                    MML1-FIELD-OCCURRENCE-2
260800                 MOVE MML1WS-VL-03
260900                                 TO MML1-VARIABLE-LENGTH
261000                 MOVE MMSM-DBA-COUNTRY-CODE
261100                                 TO MML1-VL03-B-DATA-X
261200                 MOVE MM01-DBA-STATE
261300                                 TO MMSM-DBA-COUNTRY-CODE
261400                 MOVE MMSM-DBA-COUNTRY-CODE
261500                                 TO MML1-VL03-A-DATA-X
261600                 MOVE 'FC46'     TO MBCA-PROGRAM-LOCATION
261700                 PERFORM Y969-WRITE-STORE-LOG
261800                                 THRU Y969-EXIT.
261900*
262000     MOVE 'MM'                   TO MML1-FILE-CODE.
262100     MOVE MBCA-MERCHANT-ORG      TO MML1-MMMM-ORG.
262200     MOVE MBCA-MERCHANT          TO MML1-MMMM-MERCHANT.
262300     MOVE MBCA-SIGNON-NAME       TO MML1-SIGNON-NAME.
262400     MOVE MBCA-TERMINAL-ID       TO MML1-TERMINAL-ID.
262500     MOVE ZEROS                  TO MML1-SOURCE-CODE.
262600     MOVE MBCA-FIELD-SECURITY    TO MML1-FIELD-SECURITY.
262700*
262800*
262900 X299-UIF-EXIT.
263000     EXIT.
263100/
263200 Y000-PERFORMED-ROUTINES SECTION.
263300*
263400 Y010-MOVE-COUNTRY-CODE.
263500*
263600     MOVE MMMM-COUNTRY-CODE (X-MMMM-PRIMARY)
263700                                 TO MM01-COUNTRY-CODE.
263800*
263900 Y015-COUNTRY-CODE-SECURITY.
264000*
264100     MOVE MMMMTB-COUNTRY-CODE (1:4)
264200                                 TO WS-INDEX-X.
264300*
264400     SET  X-MMFS-MERCH           TO WS-INDEX.
264500*
264600     IF  MMFS-MT-NO-ACCESS (X-MMFS-MERCH)
264700         MOVE DFHBMDAS           TO MM01-COUNTRY-CODE-LIT-A
264800                                    MM01-COUNTRY-CODE-LP-A
264900                                    MM01-COUNTRY-CODE-RP-A
265000                                    MM01-COUNTRY-CODE-A
265100         MOVE ZERO               TO MM01-COUNTRY-CODE-L
265200         GO TO Y019-EXIT.
265300*
265400     IF  MBCA-PTI-FUNCTION-IS-INQUIRY
265500         MOVE DFHBMDAS           TO MM01-COUNTRY-CODE-LP-A
265600                                    MM01-COUNTRY-CODE-RP-A
265700         MOVE DFHBMASB           TO MM01-COUNTRY-CODE-A
265800         GO TO Y019-EXIT.
265900*
266000     IF  MMFS-MT-INQ-ONLY (X-MMFS-MERCH)
266100         MOVE DFHBMDAS           TO MM01-COUNTRY-CODE-LP-A
266200                                    MM01-COUNTRY-CODE-RP-A
266300         MOVE DFHBMASK           TO MM01-COUNTRY-CODE-A
266400         MOVE ZERO               TO MM01-COUNTRY-CODE-L
266500         GO TO Y019-EXIT.
266600*
266700     IF  MBCA-PTI-FUNCTION-IS-ADD
266800         IF  MMFS-MT-REQUIRED (X-MMFS-MERCH)
266900             MOVE DFHBMASB       TO MM01-COUNTRY-CODE-LIT-A
267000         ELSE
267100             IF  MMFS-MT-MAINT-ONLY (X-MMFS-MERCH)
267200                 MOVE ZERO       TO MM01-COUNTRY-CODE-L
267300                 MOVE DFHBMDAS   TO MM01-COUNTRY-CODE-LP-A
267400                                    MM01-COUNTRY-CODE-RP-A
267500                 MOVE DFHBMASK   TO MM01-COUNTRY-CODE-A.
267600*
267700     IF  MBCA-PTI-FUNCTION-IS-MAINT
267800         IF  MMFS-MT-NO-MAINT (X-MMFS-MERCH)
267900             MOVE ZERO           TO MM01-COUNTRY-CODE-L
268000             MOVE DFHBMDAS       TO MM01-COUNTRY-CODE-LP-A
268100                                    MM01-COUNTRY-CODE-RP-A
268200             MOVE DFHBMASK       TO MM01-COUNTRY-CODE-A.
268300*
268400 Y019-EXIT.
268500     EXIT.
268600*
268700 Y030-MOVE-DBA-NAME.
268800*
268900     MOVE MMMM-DBA-NAME          TO MM01-DBA-NAME.
269000*
269100 Y035-DBA-NAME-SECURITY.
269200*
269300     MOVE MMMMTB-DBA-NAME (1:4)
269400                                 TO WS-INDEX-X.
269500*
269600     SET  X-MMFS-MERCH           TO WS-INDEX.
269700*
269800     IF  MMFS-MT-NO-ACCESS (X-MMFS-MERCH)
269900         MOVE DFHBMDAS           TO MM01-DBA-NAME-LIT-A
270000                                    MM01-DBA-NAME-LP-A
270100                                    MM01-DBA-NAME-RP-A
270200                                    MM01-DBA-NAME-A
270300         MOVE ZERO               TO MM01-DBA-NAME-L
270400         GO TO Y039-EXIT.
270500*
270600     IF  MBCA-PTI-FUNCTION-IS-INQUIRY
270700         MOVE DFHBMDAS           TO MM01-DBA-NAME-LP-A
270800                                    MM01-DBA-NAME-RP-A
270900         MOVE DFHBMASB           TO MM01-DBA-NAME-A
271000         GO TO Y039-EXIT.
271100*
271200     IF  MMFS-MT-INQ-ONLY (X-MMFS-MERCH)
271300         MOVE DFHBMDAS           TO MM01-DBA-NAME-LP-A
271400                                    MM01-DBA-NAME-RP-A
271500         MOVE DFHBMASK           TO MM01-DBA-NAME-A
271600         MOVE ZERO               TO MM01-DBA-NAME-L
271700         GO TO Y039-EXIT.
271800*
271900     IF  MBCA-PTI-FUNCTION-IS-ADD
272000         IF  MMFS-MT-REQUIRED (X-MMFS-MERCH)
272100             MOVE DFHBMASB       TO MM01-DBA-NAME-LIT-A
272200         ELSE
272300             IF  MMFS-MT-MAINT-ONLY (X-MMFS-MERCH)
272400                 MOVE ZERO       TO MM01-DBA-NAME-L
272500                 MOVE DFHBMDAS   TO MM01-DBA-NAME-LP-A
272600                                    MM01-DBA-NAME-RP-A
272700                 MOVE DFHBMASK   TO MM01-DBA-NAME-A.
272800*
272900     IF  MBCA-PTI-FUNCTION-IS-MAINT
273000         IF  MMFS-MT-NO-MAINT (X-MMFS-MERCH)
273100             MOVE ZERO           TO MM01-DBA-NAME-L
273200             MOVE DFHBMDAS       TO MM01-DBA-NAME-LP-A
273300                                    MM01-DBA-NAME-RP-A
273400             MOVE DFHBMASK       TO MM01-DBA-NAME-A.
273500*
273600 Y039-EXIT.
273700     EXIT.
273800*
273900 Y050-MOVE-SINGLE-STORE-FLAG.
274000*
274100     MOVE MMMM-SINGLE-STORE-FLAG TO MM01-SINGLE-STORE-FLAG.
274200*
274300 Y055-SNGL-STORE-FLAG-SECURITY.
274400*
274500     IF  MMMM-REC-MODEL
274600         MOVE DFHBMDAS           TO MM01-SINGLE-STORE-FLAG-LIT-A
274700                                    MM01-SINGLE-STORE-FLAG-LP-A
274800                                    MM01-SINGLE-STORE-FLAG-RP-A
274900                                    MM01-SINGLE-STORE-FLAG-A
275000         GO TO Y059-EXIT.
275100*
275200     MOVE MMMMTB-SINGLE-STORE-FLAG (1:4)
275300                                 TO WS-INDEX-X.
275400*
275500     SET  X-MMFS-MERCH           TO WS-INDEX.
275600*
275700     IF  MMFS-MT-NO-ACCESS (X-MMFS-MERCH)
275800         MOVE DFHBMDAS           TO MM01-SINGLE-STORE-FLAG-LIT-A
275900                                    MM01-SINGLE-STORE-FLAG-LP-A
276000                                    MM01-SINGLE-STORE-FLAG-RP-A
276100                                    MM01-SINGLE-STORE-FLAG-A
276200         MOVE ZERO               TO MM01-SINGLE-STORE-FLAG-L
276300         GO TO Y059-EXIT.
276400*
276500     IF  MBCA-PTI-FUNCTION-IS-INQUIRY
276600         MOVE DFHBMDAS           TO MM01-SINGLE-STORE-FLAG-LP-A
276700                                    MM01-SINGLE-STORE-FLAG-RP-A
276800         MOVE DFHBMASB           TO MM01-SINGLE-STORE-FLAG-A
276900         GO TO Y059-EXIT.
277000*
277100     IF  MMFS-MT-NO-MAINT (X-MMFS-MERCH)
277200     OR  MMFS-MT-INQ-ONLY (X-MMFS-MERCH)
277300         MOVE ZERO               TO MM01-SINGLE-STORE-FLAG-L
277400         MOVE DFHBMDAS           TO MM01-SINGLE-STORE-FLAG-LP-A
277500                                    MM01-SINGLE-STORE-FLAG-RP-A
277600         MOVE DFHBMASK           TO MM01-SINGLE-STORE-FLAG-A
277700         GO TO Y059-EXIT.
277800*
277900     IF  MBCA-PTI-FUNCTION-IS-ADD
278000         IF  MMFS-MT-REQUIRED (X-MMFS-MERCH)
278100             MOVE DFHBMASB       TO MM01-SINGLE-STORE-FLAG-LIT-A.
278200*
278300 Y059-EXIT.
278400     EXIT.
278500*
278600 Y070-MOVE-DBA-CITY.
278700*
278800     MOVE MMMM-DBA-CITY          TO MM01-DBA-CITY.
278900*
279000 Y075-DBA-CITY-SECURITY.
279100*
279200     MOVE MMMMTB-DBA-CITY (1:4)
279300                                 TO WS-INDEX-X.
279400*
279500     SET  X-MMFS-MERCH           TO WS-INDEX.
279600*
279700     IF  MMFS-MT-NO-ACCESS (X-MMFS-MERCH)
279800         MOVE DFHBMDAS           TO MM01-DBA-CITY-LIT-A
279900                                    MM01-DBA-CITY-LP-A
280000                                    MM01-DBA-CITY-RP-A
280100                                    MM01-DBA-CITY-A
280200         MOVE ZERO               TO MM01-DBA-CITY-L
280300         GO TO Y079-EXIT.
280400*
280500     IF  MBCA-PTI-FUNCTION-IS-INQUIRY
280600         MOVE DFHBMDAS           TO MM01-DBA-CITY-LP-A
280700                                    MM01-DBA-CITY-RP-A
280800         MOVE DFHBMASB           TO MM01-DBA-CITY-A
280900         GO TO Y079-EXIT.
281000*
281100     IF  MMFS-MT-INQ-ONLY (X-MMFS-MERCH)
281200         MOVE ZERO               TO MM01-DBA-CITY-L
281300         MOVE DFHBMDAS           TO MM01-DBA-CITY-LP-A
281400                                    MM01-DBA-CITY-RP-A
281500         MOVE DFHBMASK           TO MM01-DBA-CITY-A
281600         GO TO Y079-EXIT.
281700*
281800     IF  MBCA-PTI-FUNCTION-IS-ADD
281900         IF  MMFS-MT-REQUIRED (X-MMFS-MERCH)
282000             MOVE DFHBMASB       TO MM01-DBA-CITY-LIT-A
282100         ELSE
282200             IF  MMFS-MT-MAINT-ONLY (X-MMFS-MERCH)
282300                 MOVE ZERO       TO MM01-DBA-CITY-L
282400                 MOVE DFHBMDAS   TO MM01-DBA-CITY-LP-A
282500                                    MM01-DBA-CITY-RP-A
282600                 MOVE DFHBMASK   TO MM01-DBA-CITY-A.
282700*
282800     IF  MBCA-PTI-FUNCTION-IS-MAINT
282900         IF  MMFS-MT-NO-MAINT (X-MMFS-MERCH)
283000             MOVE ZERO           TO MM01-DBA-CITY-L
283100             MOVE DFHBMDAS       TO MM01-DBA-CITY-LP-A
283200                                    MM01-DBA-CITY-RP-A
283300             MOVE DFHBMASK       TO MM01-DBA-CITY-A.
283400*
283500 Y079-EXIT.
283600     EXIT.
283700*
283800 Y090-MOVE-DBA-COUNTRY-CODE.
283900*
284000     MOVE MMMM-DBA-COUNTRY-CODE  TO MM01-DBA-STATE.
284100*
284200 Y095-DBA-COUNTRY-CODE-SECURITY.
284300*
284400     MOVE MMMMTB-DBA-COUNTRY-CODE (1:4)
284500                                 TO WS-INDEX-X.
284600*
284700     SET  X-MMFS-MERCH           TO WS-INDEX.
284800*
284900     IF  MMFS-MT-NO-ACCESS (X-MMFS-MERCH)
285000         MOVE DFHBMDAS           TO MM01-DBA-STATE-LIT-A
285100                                    MM01-DBA-STATE-LP-A
285200                                    MM01-DBA-STATE-RP-A
285300                                    MM01-DBA-STATE-A
285400         MOVE ZERO               TO MM01-DBA-STATE-L
285500         GO TO Y099-EXIT.
285600*
285700     IF  MBCA-PTI-FUNCTION-IS-INQUIRY
285800         MOVE DFHBMDAS           TO MM01-DBA-STATE-LP-A
285900                                    MM01-DBA-STATE-RP-A
286000         MOVE DFHBMASB           TO MM01-DBA-STATE-A
286100         GO TO Y099-EXIT.
286200*
286300     IF  MMFS-MT-INQ-ONLY (X-MMFS-MERCH)
286400         MOVE ZERO               TO MM01-DBA-STATE-L
286500         MOVE DFHBMDAS           TO MM01-DBA-STATE-LP-A
286600                                    MM01-DBA-STATE-RP-A
286700         MOVE DFHBMASK           TO MM01-DBA-STATE-A
286800         GO TO Y099-EXIT.
286900*
287000     IF  MBCA-PTI-FUNCTION-IS-ADD
287100         IF  MMFS-MT-REQUIRED (X-MMFS-MERCH)
287200             MOVE DFHBMASB       TO MM01-DBA-STATE-LIT-A
287300         ELSE
287400             IF  MMFS-MT-MAINT-ONLY (X-MMFS-MERCH)
287500                 MOVE ZERO       TO MM01-DBA-STATE-L
287600                 MOVE DFHBMDAS   TO MM01-DBA-STATE-LP-A
287700                                    MM01-DBA-STATE-RP-A
287800                 MOVE DFHBMASK   TO MM01-DBA-STATE-A.
287900*
288000     IF  MBCA-PTI-FUNCTION-IS-MAINT
288100         IF  MMFS-MT-NO-MAINT (X-MMFS-MERCH)
288200             MOVE ZERO           TO MM01-DBA-STATE-L
288300             MOVE DFHBMDAS       TO MM01-DBA-STATE-LP-A
288400                                    MM01-DBA-STATE-RP-A
288500             MOVE DFHBMASK       TO MM01-DBA-STATE-A.
288600*
288700 Y099-EXIT.
288800     EXIT.
288900*
289000 Y110-MOVE-PRIM-ADDRESS1.
289100*
289200     SET X-MM01-NA               TO 1.
289300     SET X-MMMM-NA               TO 1.
289400*
289500     MOVE MMMM-NA-LINE (X-MMMM-PRIMARY X-MMMM-NA)
289600                                 TO MM01-NA-LINE (X-MM01-NA).
289700*
289800 Y115-PRIM-ADDRESS1-SECURITY.
289900*
290000     MOVE MMMMTB-PRIM-ADDR1 (1:4)
290100                                 TO WS-INDEX-X.
290200*
290300     SET  X-MMFS-MERCH           TO WS-INDEX.
290400*
290500     IF  MMFS-MT-NO-ACCESS (X-MMFS-MERCH)
290600         MOVE DFHBMDAS           TO MM01-NA-LINE-LIT-A (X-MM01-NA)
290700                                    MM01-NA-LINE-LP-A (X-MM01-NA)
290800                                    MM01-NA-LINE-RP-A (X-MM01-NA)
290900                                    MM01-NA-LINE-A (X-MM01-NA)
291000         MOVE ZERO               TO MM01-NA-LINE-L (X-MM01-NA)
291100         GO TO Y119-EXIT.
291200*
291300     IF  MBCA-PTI-FUNCTION-IS-INQUIRY
291400         MOVE DFHBMDAS           TO MM01-NA-LINE-LP-A (X-MM01-NA)
291500                                    MM01-NA-LINE-RP-A (X-MM01-NA)
291600         MOVE DFHBMASB           TO MM01-NA-LINE-A (X-MM01-NA)
291700         GO TO Y119-EXIT.
291800*
291900     IF  MMFS-MT-INQ-ONLY (X-MMFS-MERCH)
292000         MOVE ZERO               TO MM01-NA-LINE-L (X-MM01-NA)
292100         MOVE DFHBMDAS           TO MM01-NA-LINE-LP-A (X-MM01-NA)
292200                                    MM01-NA-LINE-RP-A (X-MM01-NA)
292300         MOVE DFHBMASK           TO MM01-NA-LINE-A (X-MM01-NA)
292400         GO TO Y119-EXIT.
292500*
292600     IF  MBCA-PTI-FUNCTION-IS-ADD
292700         IF  MMFS-MT-REQUIRED (X-MMFS-MERCH)
292800             MOVE DFHBMASB       TO MM01-NA-LINE-LIT-A (X-MM01-NA)
292900         ELSE
293000             IF  MMFS-MT-MAINT-ONLY (X-MMFS-MERCH)
293100                 MOVE ZERO       TO MM01-NA-LINE-L (X-MM01-NA)
293200                 MOVE DFHBMDAS   TO MM01-NA-LINE-LP-A (X-MM01-NA)
293300                                    MM01-NA-LINE-RP-A (X-MM01-NA)
293400                 MOVE DFHBMASK   TO MM01-NA-LINE-A (X-MM01-NA).
293500*
293600     IF  MBCA-PTI-FUNCTION-IS-MAINT
293700         IF  MMFS-MT-NO-MAINT (X-MMFS-MERCH)
293800             MOVE ZERO           TO MM01-NA-LINE-L (X-MM01-NA)
293900             MOVE DFHBMDAS       TO MM01-NA-LINE-LP-A (X-MM01-NA)
294000                                    MM01-NA-LINE-RP-A (X-MM01-NA)
294100             MOVE DFHBMASK       TO MM01-NA-LINE-A (X-MM01-NA).
294200*
294300 Y119-EXIT.
294400     EXIT.
294500*
294600 Y130-MOVE-PRIM-ADDRESS2.
294700*
294800     SET X-MM01-NA               TO 2.
294900     SET X-MMMM-NA               TO 2.
295000*
295100     MOVE MMMM-NA-LINE (X-MMMM-PRIMARY X-MMMM-NA)
295200                                 TO MM01-NA-LINE (X-MM01-NA).
295300*
295400 Y135-PRIM-ADDRESS2-SECURITY.
295500*
295600     MOVE MMMMTB-PRIM-ADDR2 (1:4)
295700                                 TO WS-INDEX-X.
295800*
295900     SET  X-MMFS-MERCH           TO WS-INDEX.
296000*
296100     IF  MMFS-MT-NO-ACCESS (X-MMFS-MERCH)
296200         MOVE DFHBMDAS           TO MM01-NA-LINE-LIT-A (X-MM01-NA)
296300                                    MM01-NA-LINE-LP-A (X-MM01-NA)
296400                                    MM01-NA-LINE-RP-A (X-MM01-NA)
296500                                    MM01-NA-LINE-A (X-MM01-NA)
296600         MOVE ZERO               TO MM01-NA-LINE-L (X-MM01-NA)
296700         GO TO Y139-EXIT.
296800*
296900     IF  MBCA-PTI-FUNCTION-IS-INQUIRY
297000         MOVE DFHBMDAS           TO MM01-NA-LINE-LP-A (X-MM01-NA)
297100                                    MM01-NA-LINE-RP-A (X-MM01-NA)
297200         MOVE DFHBMASB           TO MM01-NA-LINE-A (X-MM01-NA)
297300         GO TO Y139-EXIT.
297400*
297500     IF  MMFS-MT-INQ-ONLY (X-MMFS-MERCH)
297600         MOVE DFHBMDAS           TO MM01-NA-LINE-LP-A (X-MM01-NA)
297700                                    MM01-NA-LINE-RP-A (X-MM01-NA)
297800         MOVE DFHBMASK           TO MM01-NA-LINE-A (X-MM01-NA)
297900         MOVE ZERO               TO MM01-NA-LINE-L (X-MM01-NA)
298000         GO TO Y139-EXIT.
298100*
298200     IF  MBCA-PTI-FUNCTION-IS-ADD
298300         IF  MMFS-MT-REQUIRED (X-MMFS-MERCH)
298400             MOVE DFHBMASB       TO MM01-NA-LINE-LIT-A (X-MM01-NA)
298500         ELSE
298600             IF  MMFS-MT-MAINT-ONLY (X-MMFS-MERCH)
298700                 MOVE ZERO       TO MM01-NA-LINE-L (X-MM01-NA)
298800                 MOVE DFHBMDAS   TO MM01-NA-LINE-LP-A (X-MM01-NA)
298900                                    MM01-NA-LINE-RP-A (X-MM01-NA)
299000                 MOVE DFHBMASK   TO MM01-NA-LINE-A (X-MM01-NA).
299100*
299200     IF  MBCA-PTI-FUNCTION-IS-MAINT
299300         IF  MMFS-MT-NO-MAINT (X-MMFS-MERCH)
299400             MOVE ZERO           TO MM01-NA-LINE-L (X-MM01-NA)
299500             MOVE DFHBMDAS       TO MM01-NA-LINE-LP-A (X-MM01-NA)
299600                                    MM01-NA-LINE-RP-A (X-MM01-NA)
299700             MOVE DFHBMASK       TO MM01-NA-LINE-A (X-MM01-NA).
299800*
299900 Y139-EXIT.
300000     EXIT.
300100*
300200 Y150-MOVE-PRIM-ADDRESS3.
300300*
300400     SET X-MM01-NA               TO 3.
300500     SET X-MMMM-NA               TO 3.
300600*
300700     MOVE MMMM-NA-LINE (X-MMMM-PRIMARY X-MMMM-NA)
300800                                 TO MM01-NA-LINE (X-MM01-NA).
300900*
301000 Y155-PRIM-ADDRESS3-SECURITY.
301100*
301200     MOVE MMMMTB-PRIM-ADDR3 (1:4)
301300                                 TO WS-INDEX-X.
301400*
301500     SET  X-MMFS-MERCH           TO WS-INDEX.
301600*
301700     IF  MMFS-MT-NO-ACCESS (X-MMFS-MERCH)
301800         MOVE DFHBMDAS           TO MM01-NA-LINE-LIT-A (X-MM01-NA)
301900                                    MM01-NA-LINE-LP-A (X-MM01-NA)
302000                                    MM01-NA-LINE-RP-A (X-MM01-NA)
302100                                    MM01-NA-LINE-A (X-MM01-NA)
302200         MOVE ZERO               TO MM01-NA-LINE-L (X-MM01-NA)
302300         GO TO Y159-EXIT.
302400*
302500     IF  MBCA-PTI-FUNCTION-IS-INQUIRY
302600         MOVE DFHBMDAS           TO MM01-NA-LINE-LP-A (X-MM01-NA)
302700                                    MM01-NA-LINE-RP-A (X-MM01-NA)
302800         MOVE DFHBMASB           TO MM01-NA-LINE-A (X-MM01-NA)
302900         GO TO Y159-EXIT.
303000*
303100     IF  MMFS-MT-INQ-ONLY (X-MMFS-MERCH)
303200         MOVE ZERO               TO MM01-NA-LINE-L (X-MM01-NA)
303300         MOVE DFHBMDAS           TO MM01-NA-LINE-LP-A (X-MM01-NA)
303400                                    MM01-NA-LINE-RP-A (X-MM01-NA)
303500         MOVE DFHBMASK           TO MM01-NA-LINE-A (X-MM01-NA)
303600         GO TO Y159-EXIT.
303700*
303800     IF  MBCA-PTI-FUNCTION-IS-ADD
303900         IF  MMFS-MT-REQUIRED (X-MMFS-MERCH)
304000             MOVE DFHBMASB       TO MM01-NA-LINE-LIT-A (X-MM01-NA)
304100         ELSE
304200             IF  MMFS-MT-MAINT-ONLY (X-MMFS-MERCH)
304300                 MOVE ZERO       TO MM01-NA-LINE-L (X-MM01-NA)
304400                 MOVE DFHBMDAS   TO MM01-NA-LINE-LP-A (X-MM01-NA)
304500                                    MM01-NA-LINE-RP-A (X-MM01-NA)
304600                 MOVE DFHBMASK   TO MM01-NA-LINE-A (X-MM01-NA).
304700*
304800     IF  MBCA-PTI-FUNCTION-IS-MAINT
304900         IF  MMFS-MT-NO-MAINT (X-MMFS-MERCH)
305000             MOVE ZERO           TO MM01-NA-LINE-L (X-MM01-NA)
305100             MOVE DFHBMDAS       TO MM01-NA-LINE-LP-A (X-MM01-NA)
305200                                    MM01-NA-LINE-RP-A (X-MM01-NA)
305300             MOVE DFHBMASK       TO MM01-NA-LINE-A (X-MM01-NA).
305400*
305500 Y159-EXIT.
305600     EXIT.
305700*
305800 Y170-MOVE-PRIM-ADDRESS4.
305900*
306000     SET X-MM01-NA               TO 4.
306100     SET X-MMMM-NA               TO 4.
306200*
306300     MOVE MMMM-NA-LINE (X-MMMM-PRIMARY X-MMMM-NA)
306400                                 TO MM01-NA-LINE (X-MM01-NA).
306500*
306600 Y175-PRIM-ADDRESS4-SECURITY.
306700*
306800     MOVE MMMMTB-PRIM-ADDR4 (1:4)
306900                                 TO WS-INDEX-X.
307000*
307100     SET  X-MMFS-MERCH           TO WS-INDEX.
307200*
307300     IF  MMFS-MT-NO-ACCESS (X-MMFS-MERCH)
307400         MOVE DFHBMDAS           TO MM01-NA-LINE-LIT-A (X-MM01-NA)
307500                                    MM01-NA-LINE-LP-A (X-MM01-NA)
307600                                    MM01-NA-LINE-RP-A (X-MM01-NA)
307700                                    MM01-NA-LINE-A (X-MM01-NA)
307800         MOVE ZERO               TO MM01-NA-LINE-L (X-MM01-NA)
307900         GO TO Y179-EXIT.
308000*
308100     IF  MBCA-PTI-FUNCTION-IS-INQUIRY
308200         MOVE DFHBMDAS           TO MM01-NA-LINE-LP-A (X-MM01-NA)
308300                                    MM01-NA-LINE-RP-A (X-MM01-NA)
308400         MOVE DFHBMASB           TO MM01-NA-LINE-A (X-MM01-NA)
308500         GO TO Y179-EXIT.
308600*
308700     IF  MMFS-MT-INQ-ONLY (X-MMFS-MERCH)
308800         MOVE ZERO               TO MM01-NA-LINE-L (X-MM01-NA)
308900         MOVE DFHBMDAS           TO MM01-NA-LINE-LP-A (X-MM01-NA)
309000                                    MM01-NA-LINE-RP-A (X-MM01-NA)
309100         MOVE DFHBMASK           TO MM01-NA-LINE-A (X-MM01-NA)
309200         GO TO Y179-EXIT.
309300*
309400     IF  MBCA-PTI-FUNCTION-IS-ADD
309500         IF  MMFS-MT-REQUIRED (X-MMFS-MERCH)
309600             MOVE DFHBMASB       TO MM01-NA-LINE-LIT-A (X-MM01-NA)
309700         ELSE
309800             IF  MMFS-MT-MAINT-ONLY (X-MMFS-MERCH)
309900                 MOVE ZERO       TO MM01-NA-LINE-L (X-MM01-NA)
310000                 MOVE DFHBMDAS   TO MM01-NA-LINE-LP-A (X-MM01-NA)
310100                                    MM01-NA-LINE-RP-A (X-MM01-NA)
310200                 MOVE DFHBMASK   TO MM01-NA-LINE-A (X-MM01-NA).
310300*
310400     IF  MBCA-PTI-FUNCTION-IS-MAINT
310500         IF  MMFS-MT-NO-MAINT (X-MMFS-MERCH)
310600             MOVE ZERO           TO MM01-NA-LINE-L (X-MM01-NA)
310700             MOVE DFHBMDAS       TO MM01-NA-LINE-LP-A (X-MM01-NA)
310800                                    MM01-NA-LINE-RP-A (X-MM01-NA)
310900             MOVE DFHBMASK       TO MM01-NA-LINE-A (X-MM01-NA).
311000*
311100 Y179-EXIT.
311200     EXIT.
311300*
311400 Y190-MOVE-PRIM-ADDRESS5.
311500*
311600     SET X-MM01-NA               TO 5.
311700     SET X-MMMM-NA               TO 5.
311800*
311900     MOVE MMMM-NA-LINE (X-MMMM-PRIMARY X-MMMM-NA)
312000                                 TO MM01-NA-LINE (X-MM01-NA).
312100*
312200 Y195-PRIM-ADDRESS5-SECURITY.
312300*
312400     MOVE MMMMTB-PRIM-ADDR5 (1:4)
312500                                 TO WS-INDEX-X.
312600*
312700     SET  X-MMFS-MERCH           TO WS-INDEX.
312800*
312900     IF  MMFS-MT-NO-ACCESS (X-MMFS-MERCH)
313000         MOVE DFHBMDAS           TO MM01-NA-LINE-LIT-A (X-MM01-NA)
313100                                    MM01-NA-LINE-LP-A (X-MM01-NA)
313200                                    MM01-NA-LINE-RP-A (X-MM01-NA)
313300                                    MM01-NA-LINE-A (X-MM01-NA)
313400         MOVE ZERO               TO MM01-NA-LINE-L (X-MM01-NA)
313500         GO TO Y199-EXIT.
313600*
313700     IF  MBCA-PTI-FUNCTION-IS-INQUIRY
313800         MOVE DFHBMDAS           TO MM01-NA-LINE-LP-A (X-MM01-NA)
313900                                    MM01-NA-LINE-RP-A (X-MM01-NA)
314000         MOVE DFHBMASB           TO MM01-NA-LINE-A (X-MM01-NA)
314100         GO TO Y199-EXIT.
314200*
314300     IF  MMFS-MT-INQ-ONLY (X-MMFS-MERCH)
314400         MOVE ZERO               TO MM01-NA-LINE-L (X-MM01-NA)
314500         MOVE DFHBMDAS           TO MM01-NA-LINE-LP-A (X-MM01-NA)
314600                                    MM01-NA-LINE-RP-A (X-MM01-NA)
314700         MOVE DFHBMASK           TO MM01-NA-LINE-A (X-MM01-NA)
314800         GO TO Y199-EXIT.
314900*
315000     IF  MBCA-PTI-FUNCTION-IS-ADD
315100         IF  MMFS-MT-REQUIRED (X-MMFS-MERCH)
315200             MOVE DFHBMASB       TO MM01-NA-LINE-LIT-A (X-MM01-NA)
315300         ELSE
315400             IF  MMFS-MT-MAINT-ONLY (X-MMFS-MERCH)
315500                 MOVE ZERO       TO MM01-NA-LINE-L (X-MM01-NA)
315600                 MOVE DFHBMDAS   TO MM01-NA-LINE-LP-A (X-MM01-NA)
315700                                    MM01-NA-LINE-RP-A (X-MM01-NA)
315800                 MOVE DFHBMASK   TO MM01-NA-LINE-A (X-MM01-NA).
315900*
316000     IF  MBCA-PTI-FUNCTION-IS-MAINT
316100         IF  MMFS-MT-NO-MAINT (X-MMFS-MERCH)
316200             MOVE ZERO           TO MM01-NA-LINE-L (X-MM01-NA)
316300             MOVE DFHBMDAS       TO MM01-NA-LINE-LP-A (X-MM01-NA)
316400                                    MM01-NA-LINE-RP-A (X-MM01-NA)
316500             MOVE DFHBMASK       TO MM01-NA-LINE-A (X-MM01-NA).
316600*
316700 Y199-EXIT.
316800     EXIT.
316900*
317000 Y210-MOVE-PRIM-STATE.
317100*
317200     MOVE MMMM-STATE-CODE (X-MMMM-PRIMARY)
317300                                 TO MM01-STATE-CODE.
317400*
317500 Y215-PRIM-STATE-SECURITY.
317600*
317700     MOVE MMMMTB-PRIM-STATE (1:4)
317800                                 TO WS-INDEX-X.
317900*
318000     SET  X-MMFS-MERCH           TO WS-INDEX.
318100*
318200     IF  MMFS-MT-NO-ACCESS (X-MMFS-MERCH)
318300         MOVE DFHBMDAS           TO MM01-STATE-CODE-LIT-A
318400                                    MM01-STATE-CODE-LP-A
318500                                    MM01-STATE-CODE-RP-A
318600                                    MM01-STATE-CODE-A
318700         MOVE ZERO               TO MM01-STATE-CODE-L
318800         GO TO Y219-EXIT.
318900*
319000     IF  MBCA-PTI-FUNCTION-IS-INQUIRY
319100         MOVE DFHBMDAS           TO MM01-STATE-CODE-LP-A
319200                                    MM01-STATE-CODE-RP-A
319300         MOVE DFHBMASB           TO MM01-STATE-CODE-A
319400         GO TO Y219-EXIT.
319500*
319600     IF  MMFS-MT-INQ-ONLY (X-MMFS-MERCH)
319700         MOVE ZERO               TO MM01-STATE-CODE-L
319800         MOVE DFHBMDAS           TO MM01-STATE-CODE-LP-A
319900                                    MM01-STATE-CODE-RP-A
320000         MOVE DFHBMASK           TO MM01-STATE-CODE-A
320100         GO TO Y219-EXIT.
320200*
320300     IF  MBCA-PTI-FUNCTION-IS-ADD
320400         IF  MMFS-MT-REQUIRED (X-MMFS-MERCH)
320500             MOVE DFHBMASB       TO MM01-STATE-CODE-LIT-A
320600         ELSE
320700             IF  MMFS-MT-MAINT-ONLY (X-MMFS-MERCH)
320800                 MOVE ZERO       TO MM01-STATE-CODE-L
320900                 MOVE DFHBMDAS   TO MM01-STATE-CODE-LP-A
321000                                    MM01-STATE-CODE-RP-A
321100                 MOVE DFHBMASK   TO MM01-STATE-CODE-A.
321200*
321300     IF  MBCA-PTI-FUNCTION-IS-MAINT
321400         IF  MMFS-MT-NO-MAINT (X-MMFS-MERCH)
321500             MOVE ZERO           TO MM01-STATE-CODE-L
321600             MOVE DFHBMDAS       TO MM01-STATE-CODE-LP-A
321700                                    MM01-STATE-CODE-RP-A
321800             MOVE DFHBMASK       TO MM01-STATE-CODE-A.
321900*
322000 Y219-EXIT.
322100     EXIT.
322200*
322300 Y230-MOVE-PRIM-PHONE.
322400*
322500     MOVE MMMM-PHONE (X-MMMM-PRIMARY)
322600                                 TO MM01-PHONE.
322700*
322800 Y235-PRIM-PHONE-SECURITY.
322900*
323000     MOVE MMMMTB-PRIM-PHONE (1:4)
323100                                 TO WS-INDEX-X.
323200*
323300     SET  X-MMFS-MERCH           TO WS-INDEX.
323400*
323500     IF  MMFS-MT-NO-ACCESS (X-MMFS-MERCH)
323600         MOVE ZERO               TO MM01-PHONE-L
323700         MOVE DFHBMDAS           TO MM01-PHONE-LIT-A
323800                                    MM01-PHONE-LP-A
323900                                    MM01-PHONE-RP-A
324000                                    MM01-PHONE-A
324100         GO TO Y239-EXIT.
324200*
324300     IF  MBCA-PTI-FUNCTION-IS-INQUIRY
324400         MOVE DFHBMDAS           TO MM01-PHONE-LP-A
324500                                    MM01-PHONE-RP-A
324600         MOVE DFHBMASB           TO MM01-PHONE-A
324700         GO TO Y239-EXIT.
324800*
324900     IF  MMFS-MT-INQ-ONLY (X-MMFS-MERCH)
325000         MOVE ZERO               TO MM01-PHONE-L
325100         MOVE DFHBMDAS           TO MM01-PHONE-LP-A
325200                                    MM01-PHONE-RP-A
325300         MOVE DFHBMASK           TO MM01-PHONE-A
325400         GO TO Y239-EXIT.
325500*
325600     IF  MBCA-PTI-FUNCTION-IS-ADD
325700         IF  MMFS-MT-REQUIRED (X-MMFS-MERCH)
325800             MOVE DFHBMASB       TO MM01-PHONE-LIT-A
325900         ELSE
326000             IF  MMFS-MT-MAINT-ONLY (X-MMFS-MERCH)
326100                 MOVE ZERO       TO MM01-PHONE-L
326200                 MOVE DFHBMDAS   TO MM01-PHONE-LP-A
326300                                    MM01-PHONE-RP-A
326400                 MOVE DFHBMASK   TO MM01-PHONE-A.
326500*
326600     IF  MBCA-PTI-FUNCTION-IS-MAINT
326700         IF  MMFS-MT-NO-MAINT (X-MMFS-MERCH)
326800             MOVE ZERO           TO MM01-PHONE-L
326900             MOVE DFHBMDAS       TO MM01-PHONE-LP-A
327000                                    MM01-PHONE-RP-A
327100             MOVE DFHBMASK       TO MM01-PHONE-A.
327200*
327300 Y239-EXIT.
327400     EXIT.
327500*
327600 Y250-MOVE-PRIM-POSTAL-CODE.
327700*
327800     MOVE MMMM-POSTAL-CODE (X-MMMM-PRIMARY)
327900                                 TO MM01-POSTAL-CODE.
328000*
328100 Y255-PRIM-POSTAL-CODE-SECURITY.
328200*
328300     MOVE MMMMTB-PRIM-POSTAL-CODE (1:4)
328400                                 TO WS-INDEX-X.
328500*
328600     SET  X-MMFS-MERCH           TO WS-INDEX.
328700*
328800     IF  MMFS-MT-NO-ACCESS (X-MMFS-MERCH)
328900         MOVE DFHBMDAS           TO MM01-POSTAL-CODE-LIT-A
329000                                    MM01-POSTAL-CODE-LP-A
329100                                    MM01-POSTAL-CODE-RP-A
329200                                    MM01-POSTAL-CODE-A
329300         MOVE ZERO               TO MM01-POSTAL-CODE-L
329400         GO TO Y259-EXIT.
329500*
329600     IF  MBCA-PTI-FUNCTION-IS-INQUIRY
329700         MOVE DFHBMDAS           TO MM01-POSTAL-CODE-LP-A
329800                                    MM01-POSTAL-CODE-RP-A
329900         MOVE DFHBMASB           TO MM01-POSTAL-CODE-A
330000         GO TO Y259-EXIT.
330100*
330200     IF  MMFS-MT-INQ-ONLY (X-MMFS-MERCH)
330300         MOVE DFHBMDAS           TO MM01-POSTAL-CODE-LP-A
330400                                    MM01-POSTAL-CODE-RP-A
330500         MOVE DFHBMASK           TO MM01-POSTAL-CODE-A
330600         MOVE ZERO               TO MM01-POSTAL-CODE-L
330700         GO TO Y259-EXIT.
330800*
330900     IF  MBCA-PTI-FUNCTION-IS-ADD
331000         IF  MMFS-MT-REQUIRED (X-MMFS-MERCH)
331100             MOVE DFHBMASB       TO MM01-POSTAL-CODE-LIT-A
331200         ELSE
331300             IF  MMFS-MT-MAINT-ONLY (X-MMFS-MERCH)
331400                 MOVE ZERO       TO MM01-POSTAL-CODE-L
331500                 MOVE DFHBMDAS   TO MM01-POSTAL-CODE-LP-A
331600                                    MM01-POSTAL-CODE-RP-A
331700                 MOVE DFHBMASK   TO MM01-POSTAL-CODE-A.
331800*
331900     IF  MBCA-PTI-FUNCTION-IS-MAINT
332000         IF  MMFS-MT-NO-MAINT (X-MMFS-MERCH)
332100             MOVE ZERO           TO MM01-POSTAL-CODE-L
332200             MOVE DFHBMDAS       TO MM01-POSTAL-CODE-LP-A
332300                                    MM01-POSTAL-CODE-RP-A
332400             MOVE DFHBMASK       TO MM01-POSTAL-CODE-A.
332500*
332600 Y259-EXIT.
332700     EXIT.
332800*
332900 Y270-MOVE-PRIM-FAX.
333000*
333100     MOVE MMMM-FAX (X-MMMM-PRIMARY)
333200                                 TO MM01-FAX.
333300*
333400 Y275-PRIM-FAX-SECURITY.
333500*
333600     MOVE MMMMTB-PRIM-FAX (1:4)
333700                                 TO WS-INDEX-X.
333800*
333900     SET  X-MMFS-MERCH           TO WS-INDEX.
334000*
334100     IF  MMFS-MT-NO-ACCESS (X-MMFS-MERCH)
334200         MOVE DFHBMDAS           TO MM01-FAX-LIT-A
334300                                    MM01-FAX-LP-A
334400                                    MM01-FAX-RP-A
334500                                    MM01-FAX-A
334600         MOVE ZERO               TO MM01-FAX-L
334700         GO TO Y279-EXIT.
334800*
334900     IF  MBCA-PTI-FUNCTION-IS-INQUIRY
335000         MOVE DFHBMDAS           TO MM01-FAX-LP-A
335100                                    MM01-FAX-RP-A
335200         MOVE DFHBMASB           TO MM01-FAX-A
335300         GO TO Y279-EXIT.
335400*
335500     IF  MMFS-MT-INQ-ONLY (X-MMFS-MERCH)
335600         MOVE ZERO               TO MM01-FAX-L
335700         MOVE DFHBMDAS           TO MM01-FAX-LP-A
335800                                    MM01-FAX-RP-A
335900         MOVE DFHBMASK           TO MM01-FAX-A
336000         GO TO Y279-EXIT.
336100*
336200     IF  MBCA-PTI-FUNCTION-IS-ADD
336300         IF  MMFS-MT-REQUIRED (X-MMFS-MERCH)
336400             MOVE DFHBMASB       TO MM01-FAX-LIT-A
336500         ELSE
336600             IF  MMFS-MT-MAINT-ONLY (X-MMFS-MERCH)
336700                 MOVE ZERO       TO MM01-FAX-L
336800                 MOVE DFHBMDAS   TO MM01-FAX-LP-A
336900                                    MM01-FAX-RP-A
337000                 MOVE DFHBMASK   TO MM01-FAX-A.
337100*
337200     IF  MBCA-PTI-FUNCTION-IS-MAINT
337300         IF  MMFS-MT-NO-MAINT (X-MMFS-MERCH)
337400             MOVE ZERO           TO MM01-FAX-L
337500             MOVE DFHBMDAS       TO MM01-FAX-LP-A
337600                                    MM01-FAX-RP-A
337700             MOVE DFHBMASK       TO MM01-FAX-A.
337800*
337900 Y279-EXIT.
338000     EXIT.
338100*
338200 Y800-SET-CURSOR.
338300*
338400************************************************************
338500*    THIS ROUTINE IS PERFORMED IF IN ADD OR MAINTENANCE    *
338600*    AND SETS THE CURSOR TO THE FIRST FIELD WHICH IS       *
338700*    OPEN FOR INPUT                                        *
338800************************************************************
338900*
339000     MOVE MMMMTB-COUNTRY-CODE (1:4)
339100                                 TO WS-INDEX-X.
339200*
339300     SET X-MMFS-MERCH            TO WS-INDEX.
339400*
339500 Y801-SC-LOOP.
339600*
339700     IF  MBCA-PTI-FUNCTION-IS-ADD
339800         IF  MMFS-MT-OPTIONAL (X-MMFS-MERCH)
339900         OR  MMFS-MT-REQUIRED (X-MMFS-MERCH)
340000             GO TO Y802-SC-DETERMINE-FIELD.
340100*
340200     IF  MBCA-PTI-FUNCTION-IS-MAINT
340300         IF  MMFS-MT-MAINT-ALLOWED (X-MMFS-MERCH)
340400             GO TO Y802-SC-DETERMINE-FIELD.
340500*
340600     MOVE MMMMTB-SEC-ADDR1 (1:4)
340700                                 TO WS-INDEX-X.
340800*
340900     IF  X-MMFS-MERCH IS LESS THAN WS-INDEX
341000         SET X-MMFS-MERCH        UP BY 1
341100         GO TO Y801-SC-LOOP.
341200*
341300 Y802-SC-DETERMINE-FIELD.
341400*
341500     MOVE MMMMTB-SEC-ADDR1 (1:4)
341600                                 TO WS-INDEX-X.
341700*
341800     IF  X-MMFS-MERCH IS EQUAL TO WS-INDEX
341900         MOVE SS08WS-CURSOR      TO MM01-ALT-TRANID-L
342000         GO TO Y809-SC-EXIT.
342100*
342200     SET WS-FIELD-POSITION       TO X-MMFS-MERCH.
342300*
342400     GO TO   Y803-COUNTRY-CODE
342500             Y803-DBA-NAME
342600             Y803-SINGLE-STORE-FLAG
342700             Y803-DBA-CITY
342800             Y803-DBA-COUNTRY-CODE
342900             Y803-PRIM-ADDR1
343000             Y803-PRIM-ADDR2
343100             Y803-PRIM-ADDR3
343200             Y803-PRIM-ADDR4
343300             Y803-PRIM-ADDR5
343400             Y803-PRIM-STATE
343500             Y803-PRIM-PHONE
343600             Y803-PRIM-POSTAL-CODE
343700             Y803-PRIM-FAX
343800         DEPENDING ON WS-FIELD-POSITION.
343900*
344000 Y803-COUNTRY-CODE.
344100*
344200     MOVE SS08WS-CURSOR          TO MM01-COUNTRY-CODE-L.
344300     GO TO Y809-SC-EXIT.
344400*
344500 Y803-DBA-NAME.
344600*
344700     MOVE SS08WS-CURSOR          TO MM01-DBA-NAME-L.
344800     GO TO Y809-SC-EXIT.
344900*
345000 Y803-SINGLE-STORE-FLAG.
345100*
345200     MOVE SS08WS-CURSOR          TO MM01-SINGLE-STORE-FLAG-L.
345300     GO TO Y809-SC-EXIT.
345400*
345500 Y803-DBA-CITY.
345600*
345700     MOVE SS08WS-CURSOR          TO MM01-DBA-CITY-L.
345800     GO TO Y809-SC-EXIT.
345900*
346000 Y803-DBA-COUNTRY-CODE.
346100*
346200     MOVE SS08WS-CURSOR          TO MM01-DBA-STATE-L.
346300     GO TO Y809-SC-EXIT.
346400*
346500 Y803-PRIM-ADDR1.
346600*
346700     MOVE SS08WS-CURSOR          TO MM01-NA-LINE-L (1).
346800     GO TO Y809-SC-EXIT.
346900*
347000 Y803-PRIM-ADDR2.
347100*
347200     MOVE SS08WS-CURSOR          TO MM01-NA-LINE-L (2).
347300     GO TO Y809-SC-EXIT.
347400*
347500 Y803-PRIM-ADDR3.
347600*
347700     MOVE SS08WS-CURSOR          TO MM01-NA-LINE-L (3).
347800     GO TO Y809-SC-EXIT.
347900*
348000 Y803-PRIM-ADDR4.
348100*
348200     MOVE SS08WS-CURSOR          TO MM01-NA-LINE-L (4).
348300     GO TO Y809-SC-EXIT.
348400*
348500 Y803-PRIM-ADDR5.
348600*
348700     MOVE SS08WS-CURSOR          TO MM01-NA-LINE-L (5).
348800     GO TO Y809-SC-EXIT.
348900*
349000 Y803-PRIM-STATE.
349100*
349200     MOVE SS08WS-CURSOR          TO MM01-STATE-CODE-L.
349300     GO TO Y809-SC-EXIT.
349400*
349500 Y803-PRIM-PHONE.
349600*
349700     MOVE SS08WS-CURSOR          TO MM01-PHONE-L.
349800     GO TO Y809-SC-EXIT.
349900*
350000 Y803-PRIM-POSTAL-CODE.
350100*
350200     MOVE SS08WS-CURSOR          TO MM01-POSTAL-CODE-L.
350300     GO TO Y809-SC-EXIT.
350400*
350500 Y803-PRIM-FAX.
350600*
350700     MOVE SS08WS-CURSOR          TO MM01-FAX-L.
350800     GO TO Y809-SC-EXIT.
350900*
351000 Y809-SC-EXIT.
351100     EXIT.
351200*
351300 Y900-READ-MMFS.
351400*
351500****************************************
351600*    READ THE FIELD SECURITY RECORD    *
351700*    TO OBTAIN THE SECURITY CODES      *
351800****************************************
351900*
352000     MOVE MBCA-MERCHANT-ORG      TO MBIOWS-MMFS-ORG.
352100     MOVE MBCA-FIELD-SECURITY    TO MBIOWS-MMFS-FS-CODE.
352200     SET MBIORO-READ-RANDOM      TO TRUE.
352300     PERFORM MMFSAO-ACCESS       THRU MMFSAO-ACCESS-EXIT.
352400*
352500     IF  NOT MMFS-REC-ACTIVE
352600         MOVE MBIORO-IO-REQUEST  TO MBCA-ERRR-IO-REQUEST
352700         MOVE MBIORO-FILE-NAME   TO MBCA-ERRR-EIBDS
352800         MOVE EIBFN              TO MBCA-ERRR-EIBFN-CODES
352900         MOVE MBCA-PROGRAM-ID    TO MBCA-ERRR-BAD-PROGRAM
353000         MOVE MBCA-TRANS-ID      TO MBCA-ERRR-BAD-TRANSID
353100         SET MBCA-ERROR-MSGS-PROVIDED
353200                                 TO TRUE
353300         MOVE 'READ ERROR - MMFSAO'
353400                                 TO MBCA-ERRR-MSG1
353500         MOVE 'FIELD SECURITY PROFILE IS NOT ACTIVE'
353600                                 TO MBCA-ERRR-MSG2
353700         GO TO MB70PD-ERROR-ROUTINE.
353800*
353900 Y909-READ-MMFS-EXIT.
354000     EXIT.
354100*
354200 Y910-WRITE-LOG-RECORD.
354300*
354400     SET MBIORO-WRITE            TO TRUE.
354500     PERFORM MML1AO-ACCESS       THRU MML1AO-ACCESS-EXIT.
354600     MOVE SPACES                 TO MML1-VARIABLE-AREA.
354700*
354800 Y919-WLR-EXIT.
354900     EXIT.
355000*
355100 Y920-WRITE-NAME-LOCATE-RECORD.
355200*
355300     IF  MMOC-MERCH-PRIMARY-ON
355400         IF MM01-NA-LINE-L (1) IS GREATER THAN ZERO
355500         OR MM01-NA-LINE-L (2) IS GREATER THAN ZERO
355600         OR MM01-NA-LINE-L (3) IS GREATER THAN ZERO
355700         OR MM01-NA-LINE-L (4) IS GREATER THAN ZERO
355800         OR MM01-NA-LINE-L (5) IS GREATER THAN ZERO
355900         OR MM01-STATE-CODE-L IS GREATER THAN ZERO
356000         OR MM01-POSTAL-CODE-L IS GREATER THAN ZERO
356100         OR MM01-PHONE-L IS GREATER THAN ZERO
356200         OR MM01-FAX-L IS GREATER THAN ZERO
356300         MOVE MBCA-MERCHANT-ORG  TO MMNL-ORG
356400         MOVE MMMM-MERCHANT      TO MMNL-FILE-NBR
356500         MOVE ZEROS              TO MMNL-TIE-BREAKER
356600         SET MMNL-FILE-IS-MERCH  TO TRUE
356700         SET MMNL-NAME-IS-PRIMARY
356800                                 TO TRUE
356900         MOVE MMMM-NA-LINE (1 1) TO MMNL-NAME
357000         MOVE MMMM-NA-LINE (1 2) TO MMNL-ADDR1
357100         MOVE MMMM-PHONE (1)     TO MMNL-PHONE
357200         MOVE MMMM-POSTAL-CODE (1)
357300                                 TO MMNL-POSTAL-CODE
357400         EVALUATE TRUE
357500           WHEN  MMMM-NA-LINE (1 5) IS NOT EQUAL TO SPACES
357600             MOVE MMMM-NA-LINE (1 5)
357700                                 TO MMNL-CITY
357800           WHEN  MMMM-NA-LINE (1 4) IS NOT EQUAL TO SPACES
357900             MOVE MMMM-NA-LINE (1 4)
358000                                 TO MMNL-CITY
358100           WHEN  MMMM-NA-LINE (1 3) IS NOT EQUAL TO SPACES
358200             MOVE MMMM-NA-LINE (1 3)
358300                                 TO MMNL-CITY
358400           WHEN  MMMM-NA-LINE (1 2) IS NOT EQUAL TO SPACES
358500             MOVE MMMM-NA-LINE (1 2)
358600                                 TO MMNL-CITY
358700           WHEN  MMMM-NA-LINE (1 1) IS NOT EQUAL TO SPACES
358800             MOVE MMMM-NA-LINE (1 1)
358900                                 TO MMNL-CITY
359000         END-EVALUATE
359100         MOVE MMMM-STATE-CODE (1)
359200                                 TO MMNL-STATE
359300         PERFORM Y940-WRITE-MMNL THRU Y949-WMMNL-EXIT.
359400*
359500     IF  MMOC-MERCH-DBA-ON
359600         IF MM01-DBA-NAME-L IS GREATER THAN ZERO
359700         OR MM01-DBA-CITY-L IS GREATER THAN ZERO
359800         OR MM01-DBA-STATE-L IS GREATER THAN ZERO
359900         MOVE MBCA-MERCHANT-ORG  TO MMNL-ORG
360000         MOVE MMMM-MERCHANT      TO MMNL-FILE-NBR
360100         MOVE ZEROS              TO MMNL-TIE-BREAKER
360200         SET MMNL-FILE-IS-MERCH  TO TRUE
360300         SET MMNL-NAME-IS-DBA    TO TRUE
360400         MOVE MMMM-DBA-NAME      TO MMNL-NAME
360500         MOVE MMMM-NA-LINE (1 2) TO MMNL-ADDR1
360600         MOVE MMMM-PHONE (1)     TO MMNL-PHONE
360700         MOVE MMMM-POSTAL-CODE (1)
360800                                 TO MMNL-POSTAL-CODE
360900         MOVE MMMM-DBA-CITY      TO MMNL-CITY
361000         MOVE MMMM-DBA-COUNTRY-CODE
361100                                 TO MMNL-STATE
361200         PERFORM Y940-WRITE-MMNL THRU Y949-WMMNL-EXIT.
361300*
361400 Y929-WNLR-EXIT.
361500     EXIT.
361600*
361700 Y930-READ-MMOC.
361800*
361900     MOVE MBCA-MERCHANT-ORG      TO MBIOWS-MMOC-ORG.
362000     SET MBIORO-READ-RANDOM      TO TRUE.
362100     PERFORM MMOCAO-ACCESS       THRU MMOCAO-ACCESS-EXIT.
362200*
362300 Y939-RMMOC-EXIT.
362400     EXIT.
362500*
362600 Y940-WRITE-MMNL.
362700*
362800     IF  MMNL-NAME IS EQUAL TO SPACES
362900         GO TO Y949-WMMNL-EXIT.
363000*
363100     MOVE 'FC47'                 TO MBCA-PROGRAM-LOCATION.
363200     MOVE SS08WS-CICS-FC-DUPREC  TO MBIORO-TEMP-STATUS-1.
363300     SET MBIORO-WRITE            TO TRUE.
363400     PERFORM MMNLAO-ACCESS       THRU MMNLAO-ACCESS-EXIT.
363500*
363600     IF  SS08WS-RC-FC-DUPREC
363700         ADD 1                   TO MMNL-TIE-BREAKER
363800         GO TO Y940-WRITE-MMNL.
363900*
364000 Y949-WMMNL-EXIT.
364100     EXIT.
364200*
364300 Y950-VERIFY-MMXR.
364400*
364500****************************************************************
364600*    START BROWSE THE STORE XREF FILE                          *
364700****************************************************************
364800*
364900     MOVE 'FC48'                 TO MBCA-PROGRAM-LOCATION.
365000     MOVE MBCA-MERCHANT-ORG      TO MBIOWS-MMXR-ORG.
365100     MOVE MBCA-MERCHANT          TO MBIOWS-MMXR-MERCHANT.
365200     MOVE ZEROS                  TO MBIOWS-MMXR-STORE.
365300     SET MBIORO-STARTBR-GTE      TO TRUE.
365400     PERFORM MMXRAO-ACCESS       THRU MMXRAO-ACCESS-EXIT.
365500*
365600 Y951-READ-LOOP.
365700*
365800****************************************************************
365900*    READNEXT THE STORE XREF FILE                              *
366000****************************************************************
366100*
366200     MOVE 'FC49'                 TO MBCA-PROGRAM-LOCATION.
366300     SET MBIORO-READ-SEQ         TO TRUE.
366400     PERFORM MMXRAO-ACCESS       THRU MMXRAO-ACCESS-EXIT.
366500*
366600*
366700     IF  MMXR-ORG-MERCHANT IS EQUAL TO MBCA-ORG-MERCHANT
366800     AND MMXR-STORE IS GREATER THAN ZEROS
366900     AND MMXR-REC-ACTIVE
367000         SET WS-STORE-XREF-YES   TO TRUE
367100     ELSE
367200         IF  MMXR-ORG-MERCHANT IS GREATER THAN MBCA-ORG-MERCHANT
367300             NEXT SENTENCE
367400         ELSE
367500             GO TO Y951-READ-LOOP.
367600*
367700****************************************************************
367800*    END BROWSE THE STORE XREF FILE                            *
367900****************************************************************
368000*
368100     MOVE 'FC50'                 TO MBCA-PROGRAM-LOCATION.
368200     SET MBIORO-ENDBR            TO TRUE.
368300     PERFORM MMXRAO-ACCESS       THRU MMXRAO-ACCESS-EXIT.
368400*
368500 Y959-EXIT.
368600     EXIT.
368700*
368800 Y969-WRITE-STORE-LOG.
368900*
369000*************************************************
369100*    SET UP THE COMMON PORTION OF THE RECORD    *
369200*************************************************
369300*
369400     MOVE 'SM'                   TO MML1-FILE-CODE.
369500     MOVE MBCA-MERCHANT-ORG      TO MML1-MMSM-ORG.
369600     MOVE MMMM-STORE-NBR         TO MML1-MMSM-STORE.
369700     MOVE MBCA-SIGNON-NAME       TO MML1-SIGNON-NAME.
369800     MOVE MBCA-TERMINAL-ID       TO MML1-TERMINAL-ID.
369900     MOVE ZEROS                  TO MML1-SOURCE-CODE.
370000     MOVE MBCA-FIELD-SECURITY    TO MML1-FIELD-SECURITY.
370100*
370200     SET MBIORO-WRITE            TO TRUE.
370300     PERFORM MML1AO-ACCESS       THRU MML1AO-ACCESS-EXIT.
370400     MOVE SPACES                 TO MML1-VARIABLE-AREA.
370500*
370600 Y969-EXIT.
370700     EXIT.
370800*
370900/
371000 Z000-COPIED-ROUTINES SECTION.
371100*
371200     COPY SMCOPX.
371300/
371400     COPY SMCOPXO REPLACING ==:XXCA:== BY ==MBCA==.
371500/
371600**********************************
371700*    JUL TO GREG DATE ROUTINE    *
371800**********************************
371900*
372000     COPY SS08PD.
372100/
372200**********************************
372300*    DATE AND TIME EDIT ROUTINES *
372400**********************************
372500*
372600     COPY SS26PD.
372700/
372800     COPY SS27PD.
372900/
373000*********************************
373100*    LINE 24 PF KEYS ROUTINE    *
373200*********************************
373300*
373400     COPY SS15PD.
373500/
373600************************************************
373700*    MERCHANT MASTER RECORD ACCESS ROUTINES    *
373800************************************************
373900*
374000     COPY MMMMAO.
374100/
374200************************************************
374300*    STORE MASTER RECORD ACCESS ROUTINES       *
374400************************************************
374500*
374600     COPY MMSMAO.
374700/
374800***********************************************
374900*    FIELD SECURITY RECORD ACCESS ROUTINES    *
375000***********************************************
375100*
375200     COPY MMFSAO.
375300/
375400***********************************************
375500*    CONTROL FILE RECORD ACCESS ROUTINES      *
375600***********************************************
375700*
375800     COPY MMOCAO.
375900/
376000***********************************************
376100*    INVENTORY CONTROL   ACCESS ROUTINES      *
376200***********************************************
376300*
376400     COPY MMICAO.
376500/
376600***********************************************
376700*    PLATE REQUEST FILE  ACCESS ROUTINES      *
376800***********************************************
376900*
377000     COPY MMPFAO.
377100/
377200***********************************************
377300*    STORE XREF FILE  ACCESS ROUTINES         *
377400***********************************************
377500*
377600     COPY MMXRAO.
377700/
377800***********************************************
377900*    NAME LOCATE  RECORD ACCESS ROUTINES      *
378000***********************************************
378100*
378200     COPY MMNLAO.
378300/
378400*****************************************
378500*    LOG FILE RECORD ACCESS ROUTINES    *
378600*****************************************
378700*
378800     COPY MML1AO.
378900/
379000*****************************
379100*    ONLINE MAP ROUTINES    *
379200*****************************
379300*
379400     COPY MB60PD REPLACING 'MBMAPXX' BY 'MBMM01 '
379500                           MBMAPXXI BY MBMM01I
379600                           MBMAPXXO BY MBMM01O.
379700/
379800***************************
379900*    ONLINE PROCEDURES    *
380000***************************
380100*
380200     COPY MB70PD.
380300/
380400     COPY SMFTPXO.
