000100 IDENTIFICATION DIVISION.
000200 PROGRAM-ID. MBOMM04.
000201*       RELEASE DATE=08/24/01.        REVISION LEVEL=08.06      *
000202*****************************************************************
000203*WARNING.  THIS COMPUTER PROGRAM IS PROTECTED BY COPYRIGHT LAW  *
000204*AND INTERNATIONAL TREATIES.  UNAUTHORIZED REPRODUCTION OR      *
000205*DISTRIBUTION OF THIS PROGRAM, OR ANY PORTION OF IT, MAY RESULT *
000206*IN SEVERE CIVIL AND CRIMINAL PENATLIES, AND WILL BE PROSECUTED *
000207*TO THE MAXIMUM EXTENT POSSIBLE UNDER THE LAW.                  *
000208*COPYRIGHT 1999 PAYSYS INTERNATIONAL, INC.  ALL RIGHTS RESERVED.*
000209*****************************************************************
000300*****************************************************************
000400*                                                               *
000500*               M E R C H A N T   S Y S T E M                   *
000600*                                                               *
000700*      MBOMM04 - MERCHANT MASTER RECORD ADD/MAINT/INQ           *
000800*                SCREENS 04                                     *
000900*                                                               *
001000*              1. TRANSIDS                                      *
001100*                 A. MBAM                                       *
001200*                 B. MMMM                                       *
001300*                 C. MBQM                                       *
001400*              2. MAPS USED -                                   *
001500*                 A. MMMM04 (SCREEN 04)                         *
001600*              3. FILES USED -                                  *
001700*                 A. MMMM (MERCHANT MASTER FILE)                *
001800*                 B. MMFS (FIELD SECURITY FILE)                 *
001900*                 C. MMOC (ORG CONTROL FILE)                    *
002000*                 D. MMRT (RATE TABLE FILE)                     *
002100*                 E. MML1 (LOG FILE)                            *
002200*                                                               *
002300*****************************************************************
002400*
002500 ENVIRONMENT DIVISION.
002600*
002700 DATA DIVISION.
002800*
002900 WORKING-STORAGE SECTION.
003000*
003100 01  FILLER                  PIC  X(12)      VALUE
003200     '** WS-BEG **'.
003300*
003400 01  FILLER                  PIC  X(14)      VALUE
003500     'MISCELLANEOUS:'.
003600*
003700 01  WS-MISCELLANEOUS.
003800     03  WS-BEG-MMMM-INDEX   PIC S9(04)      BINARY
003900                                             VALUE ZEROES.
004000     03  WS-MMFS-INDEX       PIC S9(04)      BINARY
004100                                             VALUE ZEROES.
004200     03  WS-FIELD-POSITION   PIC  9(03)      VALUE ZEROES.
004300     03  WS-INDEX-X.
004400         05  WS-INDEX        PIC  9(04)      VALUE ZEROS.
004500*
004600 01  FILLER                  PIC  X(17)      VALUE
004700     'PROGRAM SWITCHES:'.
004800*
004900 01  WS-PROGRAM-SWITCHES.
005000     03  WS-RESV-FREQ-ERROR-SW
005100                             PIC  X(01)      VALUE 'N'.
005200         88  RESV-FREQ-ERRORS-EXIST          VALUE 'Y'.
005300         88  NO-RESV-FREQ-ERRORS-EXIST       VALUE 'N'.
005400     03  WS-FLOOR-ERROR-SW   PIC  X(01)      VALUE 'N'.
005500         88  FLOOR-ERRORS-EXIST              VALUE 'Y'.
005600         88  NO-FLOOR-ERRORS-EXIST           VALUE 'N'.
005700     03  WS-CEILING-ERROR-SW PIC  X(01)      VALUE 'N'.
005800         88  CEILING-ERRORS-EXIST            VALUE 'Y'.
005900         88  NO-CEILING-ERRORS-EXIST         VALUE 'N'.
006000     03  WS-UPDATE-SW        PIC  X(01)      VALUE 'N'.
006100         88  FIELDS-WERE-UPDATED             VALUE 'Y'.
006200         88  NO-FIELDS-WERE-UPDATED          VALUE 'N'.
006300     03  WS-HOLD-SW          PIC  X(01)      VALUE 'N'.
006400         88  WS-HOLD-SW-YES                  VALUE 'Y'.
006500         88  WS-HOLD-SW-NO                   VALUE 'N'.
006600     03  WS-BILL-HOLD-FLAG   PIC  X(01)      VALUE 'N'.
006700         88  WS-BILL-HOLD-YES                VALUE 'Y'.
006800         88  WS-BILL-HOLD-NO                 VALUE 'N'.
006900     03  TS-QUEUE-NAME.
007000         05  TS-QN-TERMID    PIC  X(04)      VALUE SPACES.
007100         05  TS-QN-TRANID    PIC  X(04)      VALUE 'MBUI'.
007200/
007300 01  FILLER                  PIC  X(29)      VALUE
007400     'I/O REQUEST BLOCK WORK AREAS:'.
007500*
007600     COPY MBIOWS.
007700/
007800 01  FILLER                  PIC  X(18)      VALUE
007900     'I/O REQUEST BLOCK:'.
008000*
008100     COPY MBIORO.
008200/
008300 01  FILLER                  PIC  X(25)      VALUE
008400     'LOG RECORD REQUEST BLOCK:'.
008500*
008600     COPY MML1WS REPLACING ==:MML1:== BY ==MML1==.
008700/
008800 01  FILLER                  PIC  X(29)      VALUE
008900     'MERCHANT MASTER FIELDS TABLE:'.
009000*
009100     COPY MMMMTB.
009200/
009300 01  FILLER                  PIC  X(35)      VALUE
009400     'MERCHANT MASTER INITIALIZER RECORD:'.
009500*
009600     COPY MMMMIR.
009700/
009800 01  FILLER                  PIC  X(25)      VALUE
009900     'RATE TABLE VALID METHODS:'.
010000*
010100     COPY MMRTWS.
010200/
010300 01  FILLER                  PIC  X(20)      VALUE
010400     'CCS DATE WORK AREAS:'.
010500*
010600     COPY SS01WS.
010700/
010800 01  FILLER                  PIC  X(15)      VALUE
010900     'CCS WORK AREAS:'.
011000*
011100     COPY SS08WS.
011200/
011300     COPY SS00WS.
011400/
011500     COPY SMFTWS.
011600/
011700     COPY SMPTRL REPLACING ==:SMPT:== BY ==SMPT==.
011800/
011900     COPY MB61LK.
012000/
012100 01  FILLER                  PIC  X(12)      VALUE
012200     '** WS-END **'.
012300/
012400 LINKAGE SECTION.
012500*
012600 01  DFHCOMMAREA.
012700*
012800     COPY MB60WS.
012900/
013000*****************************
013100*    MERCHANT MASTER MAP    *
013200*****************************
013300*
013400     COPY MBMM04.
013500/
013600******************************************
013700*    MERCHANT MASTER MAP REDEFINITION    *
013800******************************************
013900*
014000     COPY MBMM04R.
014100/
014200****************************************
014300*    MERCHANT MASTER  RECORD LAYOUT    *
014400****************************************
014500*
014600     COPY MMMMRL.
014700/
014800****************************************
014900*    ORG CONTROL RECORD LAYOUT         *
015000****************************************
015100*
015200     COPY MMOCRL.
015300/
015400**************************************
015500*    RATE TABLE RECORD LAYOUT        *
015600**************************************
015700*
015800     COPY MMRTRL.
015900/
016000**************************************
016100*    FIELD SECURITY RECORD LAYOUT    *
016200**************************************
016300*
016400     COPY MMFSRL.
016500/
016600***************************
016700*    LOG RECORD LAYOUT    *
016800***************************
016900*
017000     COPY MML1RL REPLACING ==:MML1:== BY ==MML1==.
017100/
017200***************************************
017300*    USER INPUT TEMP STORAGE RECORD   *
017400***************************************
017500*
017600     COPY MBUITS.
017700/
017800 PROCEDURE DIVISION.
017900*
018000 A000-HOUSEKEEPING SECTION.
018100*
018200 A020-INIT.
018300*
018400     MOVE 'PC01'                 TO MBCA-PROGRAM-LOCATION.
018500     PERFORM MB70PD-ON-LINE-HOUSEKEEPING
018600                                 THRU MB70PD-OLH-EXIT.
018700*
018800     IF  MBCA-MBUI-UI-YES
018900         NEXT SENTENCE
019000     ELSE
019100         SET MBCA-MBUI-UI-NO     TO TRUE.
019200*
019300     MOVE MBCA-TERMINAL-ID       TO TS-QN-TERMID.
019400*
019500     IF  MBCA-RECEIVE-SCREEN
019600         GO TO C000-RECEIVE-SCREEN.
019700/
019800 B000-SEND-SCREEN SECTION.
019900*
020000*********************************************
020100*    GET CICS STORAGE NEEDED FOR THE MAP    *
020200*********************************************
020300*
020400     MOVE 'SC01'                 TO MBCA-PROGRAM-LOCATION.
020500     PERFORM MB60PD-GETMAIN-FOR-MAP
020600                                 THRU MB60PD-GFM-EXIT.
020700*
020800*******************************************
020900*    INITIALIZE THE STANDARD MAP LINES    *
021000*******************************************
021100*
021200     PERFORM MB60PD-INIT-STD-MAP-LINES
021300                                 THRU MB60PD-ISML-EXIT.
021400*
021500*****************************************
021600*    READ THE MERCHANT MASTER RECORD    *
021700*    FOR SUBSEQUENT DISPLAY             *
021800*****************************************
021900*
022000     MOVE 'FC01'                 TO MBCA-PROGRAM-LOCATION.
022100     PERFORM Y900-READ-MMMM      THRU Y909-READ-MMMM-EXIT.
022200*
022300*********************************************
022400*    MOVE THE PRIMARY NAME TO THE SCREEN    *
022500*********************************************
022600*
022700     MOVE MMMM-NA-LINE (1 1)     TO MM04-MERCHANT-NAME.
022800*
022900****************************************
023000*    READ THE FIELD SECURITY RECORD    *
023100****************************************
023200*
023300     MOVE 'FC02'                 TO MBCA-PROGRAM-LOCATION.
023400     PERFORM Y910-READ-MMFS      THRU Y919-READ-MMFS-EXIT.
023500*
023600 B020-MOVE-FIELDS-TO-SCREEN.
023700*
023800*****************************************
023900*    MOVE THE MERCHANT MASTER FIELDS    *
024000*    FROM THE RECORD TO THE SCREEN      *
024100*****************************************
024200*
024300     PERFORM Y010-MOVE-RESV-FREQ
024400                                 THRU Y019-EXIT.
024500*
024600     PERFORM Y030-MOVE-RESV-RATE-TABLE
024700                                 THRU Y039-EXIT.
024800*
024900     PERFORM Y050-MOVE-RESV-DESC THRU Y059-EXIT.
025000*
025100     PERFORM Y070-MOVE-RESV-LEVEL
025200                                 THRU Y079-EXIT.
025300*
025400     PERFORM Y090-MOVE-RESV-FEE-BASE
025500                                 THRU Y099-EXIT.
025600*
025700     PERFORM Y110-MOVE-RESV-FLOOR
025800                                 THRU Y119-EXIT.
025900*
026000     PERFORM Y130-MOVE-RESV-CEILING
026100                                 THRU Y139-EXIT.
026200*
026300     PERFORM Y150-MOVE-BILL-USE-FLAG
026400                                 THRU Y159-EXIT.
026500*
026600     PERFORM Y170-MOVE-BILLING-ORG
026700                                 THRU Y179-EXIT.
026800*
026900     PERFORM Y190-MOVE-BILLING-ACCT
027000                                 THRU Y199-EXIT.
027100*
027200********************************************
027300*  TO FORMAT AND POPULATE THE MESSAGE LINE *
027400********************************************
027500*
027600     IF MM04-ERR-MESSAGE IS EQUAL TO SPACES OR LOW-VALUES
027700        PERFORM MB06PD-FORMAT-MESSAGE-LINE
027800           THRU MB06PD-FML-EXIT
027900        MOVE SS08WS-FORMATTED-MSG   TO MM04-ERR-MESSAGE
028000     END-IF.
028100*
028200******************************************
028300*    SET THE CURSOR AND SCREEN NUMBER    *
028400******************************************
028500*
028600     IF  MBCA-PTI-FUNCTION-IS-INQUIRY
028700         MOVE SS08WS-CURSOR      TO MM04-ALT-TRANID-L
028800     ELSE
028900         PERFORM Y800-SET-CURSOR THRU Y809-SC-EXIT.
029000*
029100     COMPUTE MBCA-SCREEN-NBR     =  MBCA-SCREEN-NBR - 50.
029200*
029300**********************
029400*    SEND THE MAP    *
029500**********************
029600*
029700     MOVE 'BM01'                 TO MBCA-PROGRAM-LOCATION.
029800*
029900     PERFORM MB60PD-SEND-MAP-WITH-ERASE
030000                                 THRU MB60PD-SMWE-EXIT.
030100*
030200************************
030300*    RETURN TO CICS    *
030400************************
030500*
030600     MOVE 'PC02'                 TO MBCA-PROGRAM-LOCATION.
030700     PERFORM MB70PD-RETURN-TRANS-ID
030800                                 THRU MB70PD-RTI-EXIT.
030900/
031000 C000-RECEIVE-SCREEN SECTION.
031100*
031200******************************************
031300*    THIS SECTION RECEIVES THE SCREEN    *
031400******************************************
031500*
031600     IF  MBCA-MBUI-UI-YES
031700*
031800****************************************************************
031900*    ACQUIRE MAIN STORAGE FOR TEMP STORAGE RECORD              *
032000****************************************************************
032100*
032200         MOVE 'TS01'             TO MBCA-PROGRAM-LOCATION
032300         EXEC CICS GETMAIN
032400                   FLENGTH (LENGTH  OF MBUITS-RECORD)
032500
032600                   SET     (ADDRESS OF MBUITS-RECORD)
032700
032800              END-EXEC
032900*
033000***********************************************
033100*    READ THE TEMP STORAGE RECORD             *
033200***********************************************
033300*
033400         MOVE 'TS02'             TO MBCA-PROGRAM-LOCATION
033500*
033600         EXEC CICS READQ TS
033700                   QUEUE   (TS-QUEUE-NAME)
033800                   INTO    (MBUITS-RECORD)
033900                   LENGTH  (LENGTH  OF MBUITS-RECORD)
034000                   ITEM    (1)
034100              END-EXEC
034200*
034300***********************************************
034400*    DELETE THE TEMP STORAGE RECORD           *
034500***********************************************
034600*
034700         MOVE 'TS03'             TO MBCA-PROGRAM-LOCATION
034800*
034900         EXEC CICS IGNORE CONDITION
035000                   QIDERR
035100              END-EXEC
035200*
035300         EXEC CICS DELETEQ TS
035400                   QUEUE  (TS-QUEUE-NAME)
035500              END-EXEC
035600         MOVE 'SC02'             TO MBCA-PROGRAM-LOCATION
035700         PERFORM MB60PD-GETMAIN-FOR-MAP
035800                                 THRU MB60PD-GFM-EXIT
035900         MOVE MBUITS-VAR-DATA    TO MBMM04I
036000     ELSE
036100         MOVE 'BM02'             TO MBCA-PROGRAM-LOCATION
036200         PERFORM MB60PD-RECEIVE-MAP
036300                                 THRU MB60PD-RM-EXIT.
036400*
036500**************************************************************
036600*    CHECK FOR ANOTHER TRANSACTION ID ENTERED BY THE USER    *
036700**************************************************************
036800*
036900     MOVE 'PC03'                 TO MBCA-PROGRAM-LOCATION.
037000     PERFORM MB60PD-NEW-TRANS-ROUTINE
037100                                 THRU MB60PD-NTR-EXIT.
037200*
037300****************************************************
037400*    BYPASS ALL SCREEN EDITS IF THIS IS INQIURY    *
037500****************************************************
037600*
037700     IF  MBCA-PTI-FUNCTION-IS-INQUIRY
037800         GO TO F000-SETUP-COMMAREA.
037900*
038000*****************************************
038100*    READ THE MERCHANT MASTER RECORD    *
038200*****************************************
038300*
038400*
038500     IF  MBCA-PTI-FUNCTION-IS-ADD
038600     AND MBCA-MBUI-UI-YES
038700     AND MBCA-MBUI-UI-UPDATE-NO
038800         MOVE 'SC03'             TO MBCA-PROGRAM-LOCATION
038900         SET MBIORO-GETMAIN      TO TRUE
039000         PERFORM MMMMAO-ACCESS   THRU MMMMAO-ACCESS-EXIT
039100         MOVE MMMMIR-RECORD      TO MMMM-RECORD
039200     ELSE
039300         MOVE 'FC03'             TO MBCA-PROGRAM-LOCATION
039400         MOVE SS08WS-CICS-FC-NOTFND TO MBIORO-TEMP-STATUS-1
039500         PERFORM Y900-READ-MMMM  THRU Y909-READ-MMMM-EXIT
039600         IF  SS08WS-RC-FC-NOTFND
039700         AND MBCA-MBUI-UI-YES
039800             MOVE 'MBUI'         TO MBCA-TRANS-ID
039900                                    MBCA-PREV-TRANS-ID
040000             MOVE 01             TO MBCA-SCREEN-NBR
040100             MOVE 'MER'          TO MM04-FILLER
040200             SET MBCA-MBUI-ERROR-YES
040300                                 TO TRUE
040400             GO TO F000-SETUP-COMMAREA.
040500*
040600     IF (MBCA-PTI-FUNCTION-IS-MAINT
040700     AND MBCA-MBUI-UI-YES
040800     AND (MMMM-REC-PURGED
040900       OR MMMM-REC-INCOMPLETE))
041000     OR
041100        (MBCA-PTI-FUNCTION-IS-ADD
041200     AND MBCA-MBUI-UI-YES
041300     AND MMMM-REC-PURGED)
041400         MOVE 'MBUI'             TO MBCA-TRANS-ID
041500                                    MBCA-PREV-TRANS-ID
041600         MOVE 01                 TO MBCA-SCREEN-NBR
041700         MOVE 'MER'              TO MM04-FILLER
041800         SET MBCA-MBUI-ERROR-YES
041900                                 TO TRUE
042000         GO TO F000-SETUP-COMMAREA.
042100*
042200*********************************************
042300*    MOVE THE PRIMARY NAME TO THE SCREEN    *
042400*********************************************
042500*
042600     MOVE MMMM-NA-LINE (1 1)     TO MM04-MERCHANT-NAME.
042700*
042800****************************************
042900*    READ THE FIELD SECURITY RECORD    *
043000****************************************
043100*
043200     MOVE 'FC04'                 TO MBCA-PROGRAM-LOCATION.
043300     PERFORM Y910-READ-MMFS      THRU Y919-READ-MMFS-EXIT.
043400*
043500 C020-FIELD-EDITS.
043600*
043700*********************
043800*    FIELD EDITS    *
043900*********************
044000*
044100     PERFORM W010-EDIT-RESV-FREQ
044200                                 THRU W019-EXIT.
044300*
044400     PERFORM W030-EDIT-RESV-RATE-TABLE
044500                                 THRU W039-EXIT.
044600*
044700     PERFORM W050-EDIT-RESV-DESC THRU W059-EXIT.
044800*
044900     PERFORM W070-EDIT-RESV-LEVEL
045000                                 THRU W079-EXIT.
045100*
045200     PERFORM W090-EDIT-RESV-FEE-BASE
045300                                 THRU W099-EXIT.
045400*
045500     PERFORM W110-EDIT-RESV-FLOOR
045600                                 THRU W119-EXIT.
045700*
045800     PERFORM W130-EDIT-RESV-CEILING
045900                                 THRU W139-EXIT.
046000*
046100     PERFORM W150-EDIT-BILL-USE-FLAG
046200                                 THRU W159-EXIT.
046300*
046400     PERFORM W170-EDIT-BILLING-ORG
046500                                 THRU W179-EXIT.
046600*
046700     PERFORM W190-EDIT-BILLING-ACCT
046800                                 THRU W199-EXIT.
046900*
047000 C040-CROSS-EDITS.
047100*
047200*********************
047300*    CROSS EDITS    *
047400*********************
047500*
047600     PERFORM W510-RESERVE-CROSS-EDITS
047700                                 THRU W519-RCE-EXIT.
047800*
047900     PERFORM W520-BILLING-CROSS-EDITS
048000                                 THRU W529-BCE-EXIT.
048100/
048200 D000-RETURN-ERRORS SECTION.
048300*
048400     IF  SS08WS-ERROR IS EQUAL TO 'N'
048500         GO TO E000-UPDATE-FILE.
048600*
048700     IF  MBCA-MBUI-UI-YES
048800         MOVE 'MBUI'             TO MBCA-TRANS-ID
048900                                    MBCA-PREV-TRANS-ID
049000         MOVE 01                 TO MBCA-SCREEN-NBR
049100         SET MBCA-MBUI-ERROR-YES TO TRUE
049200         GO TO F090-TRANSFER-XCTL.
049300*
049400***************************************************************
049500*    INITIALIZE THE STANDARD MAP LINES.  IN AN ERROR          *
049600*    CONDITION, THIS ROUTINE IS PERFORMED PRIMARILY           *
049700*    TO UPDATE THE DATE AND TIME ON THE SCREEN.               *
049800***************************************************************
049900*
050000     PERFORM MB60PD-INIT-STD-MAP-LINES
050100                                 THRU MB60PD-ISML-EXIT.
050200*
050300********************************************
050400*  TO FORMAT AND POPULATE THE MESSAGE LINE *
050500********************************************
050600*
050700     IF MM04-ERR-MESSAGE IS EQUAL TO SPACES OR LOW-VALUES
050800        PERFORM MB06PD-FORMAT-MESSAGE-LINE
050900           THRU MB06PD-FML-EXIT
051000        MOVE SS08WS-FORMATTED-MSG   TO MM04-ERR-MESSAGE
051100     END-IF.
051200*
051300**********************
051400*    SEND THE MAP    *
051500**********************
051600*
051700     MOVE 'BM03'                 TO MBCA-PROGRAM-LOCATION.
051800     PERFORM MB60PD-SEND-MAP-DATA-ONLY
051900                                 THRU MB60PD-SMDO-EXIT.
052000*
052100************************
052200*    RETURN TO CICS    *
052300************************
052400*
052500     MOVE 'PC04'                 TO MBCA-PROGRAM-LOCATION.
052600     PERFORM MB70PD-RETURN-TRANS-ID
052700                                 THRU MB70PD-RTI-EXIT.
052800/
052900 E000-UPDATE-FILE SECTION.
053000*
053100     IF  MBCA-MBUI-UI-YES
053200         SET MBCA-MBUI-ERROR-NO  TO TRUE.
053300*
053400     IF  MBCA-MBUI-UI-YES
053500     AND MBCA-MBUI-UI-UPDATE-NO
053600         GO TO F090-TRANSFER-XCTL.
053700*
053800****************************************************
053900*    READ THE MERCHANT MASTER RECORD FOR UPDATE    *
054000****************************************************
054100*
054200     MOVE 'FC05'                 TO MBCA-PROGRAM-LOCATION.
054300     SET MBIORO-READ-RANDOM-UPDATE
054400                                 TO TRUE.
054500     PERFORM MMMMAO-ACCESS       THRU MMMMAO-ACCESS-EXIT.
054600*
054700*************************************
054800*    OBTAIN STORAGE FOR LOG FILE    *
054900*    RECORD IF DOING MAINTENANCE    *
055000*************************************
055100*
055200     IF  MBCA-PTI-FUNCTION-IS-ADD
055300         GO TO E020-UPDATE-FIELDS.
055400*
055500     MOVE 'SC04'                 TO MBCA-PROGRAM-LOCATION.
055600     SET MBIORO-GETMAIN          TO TRUE.
055700     PERFORM MML1AO-ACCESS       THRU MML1AO-ACCESS-EXIT.
055800*
055900*************************************************
056000*    SET UP THE COMMON PORTION OF THE RECORD    *
056100*************************************************
056200*
056300     MOVE 'MM'                   TO MML1-FILE-CODE.
056400     MOVE MBCA-MERCHANT-ORG      TO MML1-MMMM-ORG.
056500     MOVE MBCA-MERCHANT          TO MML1-MMMM-MERCHANT.
056600     MOVE MBCA-SIGNON-NAME       TO MML1-SIGNON-NAME.
056700     MOVE MBCA-TERMINAL-ID       TO MML1-TERMINAL-ID.
056800     MOVE ZEROS                  TO MML1-SOURCE-CODE.
056900     MOVE MBCA-FIELD-SECURITY    TO MML1-FIELD-SECURITY.
057000*
057100 E020-UPDATE-FIELDS.
057200*
057300     PERFORM X010-UPDATE-RESV-FREQ
057400                                 THRU X019-EXIT.
057500*
057600     PERFORM X030-UPDATE-RESV-RATE-TABLE
057700                                 THRU X039-EXIT.
057800*
057900     PERFORM X050-UPDATE-RESV-DESC
058000                                 THRU X059-EXIT.
058100*
058200     PERFORM X070-UPDATE-RESV-LEVEL
058300                                 THRU X079-EXIT.
058400*
058500     PERFORM X090-UPDATE-RESV-FEE-BASE
058600                                 THRU X099-EXIT.
058700*
058800     PERFORM X110-UPDATE-RESV-FLOOR
058900                                 THRU X119-EXIT.
059000*
059100     PERFORM X130-UPDATE-RESV-CEILING
059200                                 THRU X139-EXIT.
059300*
059400     PERFORM X150-UPDATE-BILL-USE-FLAG
059500                                 THRU X159-EXIT.
059600*
059700     PERFORM X170-UPDATE-BILLING-ORG
059800                                 THRU X179-EXIT.
059900*
060000     PERFORM X190-UPDATE-BILLING-ACCT
060100                                 THRU X199-EXIT.
060200*
060300 E040-UPDATE-MMMM.
060400*
060500     IF  MBCA-PTI-FUNCTION-IS-ADD
060600         MOVE MBCA-SCREEN-NBR    TO MMMM-ONLINE-STATUS
060700         MOVE MBCA-START-DATE    TO MMMM-LAST-MAINT-DATE
060800         MOVE MBCA-OPERATOR-ID   TO MMMM-LAST-MAINT-OPER
060900         MOVE 'Y'                TO WS-UPDATE-SW.
061000*
061100**************************************************************
061200*    WRITE A LOG RECORD TO SHOW THAT THE LAST MAINT DATE     *
061300*    AND OPERATOR HAS BEEN UPDATED IF FIELDS WERE CHANGED    *
061400*    ON THE SCREEN                                           *
061500**************************************************************
061600*
061700     IF  MBCA-PTI-FUNCTION-IS-MAINT
061800     AND FIELDS-WERE-UPDATED
061900         MOVE 0198               TO MML1-FIELD-CODE
062000         MOVE ZEROES             TO MML1-FIELD-OCCURRENCE
062100                                    MML1-FIELD-OCCURRENCE-2
062200         MOVE MML1WS-VL-03       TO MML1-VARIABLE-LENGTH
062300         MOVE MMMM-LAST-MAINT-OPER
062400                                 TO MML1-VL03-B-DATA-X
062500         MOVE MBCA-OPERATOR-ID   TO MMMM-LAST-MAINT-OPER
062600         MOVE MMMM-LAST-MAINT-OPER
062700                                 TO MML1-VL03-A-DATA-X
062800         MOVE 'FC06'             TO MBCA-PROGRAM-LOCATION
062900         PERFORM Y920-WRITE-LOG-RECORD
063000                                 THRU Y929-WLR-EXIT
063100         MOVE 0199               TO MML1-FIELD-CODE
063200         MOVE MML1WS-VL-07       TO MML1-VARIABLE-LENGTH
063300         MOVE MMMM-LAST-MAINT-DATE
063400                                 TO MML1-VL07-B-DATA-9
063500         MOVE MBCA-START-DATE    TO MMMM-LAST-MAINT-DATE
063600         MOVE MMMM-LAST-MAINT-DATE
063700                                 TO MML1-VL07-A-DATA-9
063800         MOVE 'FC07'             TO MBCA-PROGRAM-LOCATION
063900         PERFORM Y920-WRITE-LOG-RECORD
064000                                 THRU Y929-WLR-EXIT.
064100*
064200****************************************************
064300*    REWRITE THE MERCHANT MASTER RECORD IF         *
064400*    FIELDS HAVE BEEN CHANGED ON THE SCREEN, OR    *
064500*    UNLOCK IT IF THEY HAVE NOT                    *
064600****************************************************
064700*
064800     IF  FIELDS-WERE-UPDATED
064900         MOVE 'FC08'             TO MBCA-PROGRAM-LOCATION
065000         SET MBIORO-REWRITE      TO TRUE
065100         PERFORM MMMMAO-ACCESS   THRU MMMMAO-ACCESS-EXIT
065200     ELSE
065300         MOVE 'FC09'             TO MBCA-PROGRAM-LOCATION
065400         SET MBIORO-UNLOCK       TO TRUE
065500         PERFORM MMMMAO-ACCESS   THRU MMMMAO-ACCESS-EXIT.
065600/
065700 F000-SETUP-COMMAREA SECTION.
065800*
065900***************************************************************
066000*  SET UP COMMAREA FIELDS AND TRANSFER TO THE NEXT PROGRAM    *
066100***************************************************************
066200*
066300     MOVE MBCA-EIBAID            TO SS08WS-EIBAID.
066400*
066500     IF  MM04-CURRENT-PAGE-L IS GREATER THAN ZERO
066600     AND MM04-CURRENT-PAGE   IS NUMERIC
066700         IF  MM04-CURRENT-PAGE IS GREATER THAN 13
066800             MOVE 63             TO MBCA-SCREEN-NBR
066900             GO TO F090-TRANSFER-XCTL.
067000*
067100     PERFORM MB60PD-EDIT-PAGE-NBR
067200                                 THRU MB60PD-EPN-EXIT.
067300*
067400     IF  SS08WS-VALID-PF-KEY
067500     OR  SS08WS-EIBAID-VALID-PF-KEY
067600         MOVE 99                 TO MBCA-SCREEN-NBR.
067700*
067800 F090-TRANSFER-XCTL.
067900*
068000     IF  MBCA-MBUI-UI-YES
068100         MOVE 'MBUI'             TO MBCA-TRANS-ID
068200                                    MBCA-PREV-TRANS-ID
068300         MOVE 01                 TO MBCA-SCREEN-NBR
068400         MOVE MBMM04I            TO MBUITS-VAR-DATA
068500         MOVE LENGTH OF MBMM04I  TO MBUITS-VAR-LENGTH
068600         MOVE 'TS10'             TO MBCA-PROGRAM-LOCATION
068700         EXEC CICS WRITEQ TS
068800                   QUEUE   (TS-QUEUE-NAME)
068900                   FROM    (MBUITS-RECORD)
069000                   LENGTH  (LENGTH  OF MBUITS-RECORD)
069100
069200              END-EXEC.
069300*
069400     MOVE 'PC05'                 TO MBCA-PROGRAM-LOCATION.
069500     PERFORM MB70PD-XCTL-TO-MBOXCTL
069600                                 THRU MB70PD-XTM-EXIT.
069700/
069800 W000-FIELD-EDITS SECTION.
069900*
070000*********************************************************
070100*    EACH FIELD IS CODED IN A SEPERATE ROUTINE, AND     *
070200*    IN A LIKE MANNER.  THE COMMENTS FOR THE FLOW OF    *
070300*    THE EDIT ROUTINES CAN BE FOUND IN ROUTINES         *
070400*    'W010-EDIT-RESV-FREQ' THRU 'Y019-EUF-EXIT'.        *
070500*    EACH ROUTINE MAY CONTAIN COMMENTS, BUT THEY        *
070600*    ARE UNIQUE TO THAT ROUTINE.                        *
070700*********************************************************
070800*
070900 W010-EDIT-RESV-FREQ.
071000*
071100     SET X-MM04-RESV             TO 1.
071200     SET X-MMMM-RESV             TO 1.
071300     MOVE MMMMTB-RESV-FREQ-1 (1:4)
071400                                 TO WS-INDEX-X.
071500     SET X-MMFS-MERCH            TO WS-INDEX.
071600*
071700 W011-ERF-LOOP.
071800*
071900*****************************************************
072000*    SET THE ATTRIBUTES TO WHAT THEY WOULD BE IF    *
072100*    SOMETHING WERE KEYED AND THE EDITS PASSED.     *
072200*****************************************************
072300*
072400     MOVE DFHBMDAS               TO MM04-RESV-FREQ-LP-A
072500                                        (X-MM04-RESV)
072600                                    MM04-RESV-FREQ-RP-A
072700                                        (X-MM04-RESV).
072800     MOVE DFHBMASK               TO MM04-RESV-FREQ-A
072900                                        (X-MM04-RESV).
073000*
073100************************************************************
073200*    THE SECURITY ROUTINE IS PERFORMED TO SET THE FIELD    *
073300*    ATTRIBUTES ACCORDING TO THE SECURITY PROFILE.  IT     *
073400*    WAS ALSO PERFORMED IN THE B000-SEND-SCREEN SECTION    *
073500*    OF THIS PROGRAM.  IF THIS FIELD IS (OR WAS)           *
073600*    PROTECTED AS A RESULT OF THIS ROUTINE, THE LENGTH     *
073700*    RETURNED WILL BE ZERO.                                *
073800************************************************************
073900*
074000     PERFORM Y015-RESV-FREQ-SECURITY
074100                                 THRU Y016-EXIT.
074200*
074300************************
074400*    EDIT THE FIELD    *
074500************************
074600*
074700     IF  MM04-RESV-FREQ-L (X-MM04-RESV) IS GREATER THAN ZERO
074800         MOVE DFHBMASF           TO MM04-RESV-FREQ-A
074900                                        (X-MM04-RESV)
075000     ELSE
075100         MOVE MMMM-RESV-FREQ (X-MMMM-RESV)
075200                                 TO MM04-RESV-FREQ
075300                                        (X-MM04-RESV).
075400*
075500     MOVE MM04-RESV-FREQ (X-MM04-RESV)
075600                                 TO MMMM-RESV-FREQ
075700                                        (X-MMMM-RESV).
075800*
075900     IF  NOT MMMM-RF-VALID (X-MMMM-RESV)
076000         GO TO W017-RESV-FREQ-ERROR.
076100*
076200     IF  MBCA-PTI-FUNCTION-IS-MAINT
076300     OR  MM04-RESV-FREQ-L (X-MM04-RESV)
076400         IS GREATER THAN ZERO
076500     OR  NOT MMFS-MT-REQUIRED (X-MMFS-MERCH)
076600         GO TO W018-INCREMENT-INDEXES.
076700*
076800 W017-RESV-FREQ-ERROR.
076900*
077000*******************************************************
077100*    THE FIELD IS IN ERROR.  SET THE ERROR SWITCH,    *
077200*    BRIGHTEN THE PARENS, AND BRIGHTEN AND FSET       *
077300*    THE DATA ELEMENT.                                *
077400*******************************************************
077500*
077600     IF  MM04-RESV-FREQ-L (X-MM04-RESV)
077700         IS GREATER THAN ZERO
077800         MOVE DFHBMUBF           TO MM04-RESV-FREQ-A
077900                                        (X-MM04-RESV)
078000     ELSE
078100         MOVE DFHBMBRY           TO MM04-RESV-FREQ-A
078200                                        (X-MM04-RESV).
078300*
078400     MOVE 'Y'                    TO SS08WS-ERROR
078500                                    WS-RESV-FREQ-ERROR-SW.
078600     MOVE DFHBMASB               TO MM04-RESV-FREQ-LP-A
078700                                        (X-MM04-RESV)
078800                                    MM04-RESV-FREQ-RP-A
078900                                        (X-MM04-RESV).
079000     MOVE SS08WS-CURSOR          TO MM04-RESV-FREQ-L
079100                                        (X-MM04-RESV).
079200*
079300 W018-INCREMENT-INDEXES.
079400*
079500     IF  X-MM04-RESV IS LESS THAN 4
079600         SET X-MM04-RESV         UP BY 1
079700         SET X-MMMM-RESV         UP BY 1
079800         SET X-MMFS-MERCH        UP BY 7
079900         GO TO W011-ERF-LOOP.
080000*
080100 W019-EXIT.
080200     EXIT.
080300*
080400 W030-EDIT-RESV-RATE-TABLE.
080500*
080600     SET X-MM04-RESV             TO 1.
080700     SET X-MMMM-RESV             TO 1.
080800     MOVE MMMMTB-RESV-RATE-TABLE-1 (1:4)
080900                                 TO WS-INDEX-X.
081000     SET X-MMFS-MERCH            TO WS-INDEX.
081100*
081200 W031-ERRT-LOOP.
081300*
081400     MOVE DFHBMDAS               TO MM04-RESV-RATE-TABLE-LP-A
081500                                        (X-MM04-RESV)
081600                                    MM04-RESV-RATE-TABLE-RP-A
081700                                        (X-MM04-RESV).
081800     MOVE DFHBMASK               TO MM04-RESV-RATE-TABLE-A
081900                                        (X-MM04-RESV).
082000*
082100     PERFORM Y035-RESV-RATE-TABLE-SECURITY
082200                                 THRU Y036-EXIT.
082300*
082400     IF  MM04-RESV-RATE-TABLE-L (X-MM04-RESV)
082500                                    IS GREATER THAN ZERO
082600         MOVE DFHBMASF       TO MM04-RESV-RATE-TABLE-A
082700                                        (X-MM04-RESV)
082800     ELSE
082900         MOVE MMMM-RESV-RATE-TABLE (X-MMMM-RESV)
083000                                 TO MM04-RESV-RATE-TABLE
083100                                        (X-MM04-RESV).
083200*
083300     IF  MM04-RESV-RATE-TABLE (X-MM04-RESV) IS NOT NUMERIC
083400         GO TO W037-RRT-ERROR.
083500*
083600     IF  MM04-RESV-RATE-TABLE (X-MM04-RESV) IS EQUAL TO ZEROS
083700         GO TO W035-CONTINUE
083800     ELSE
083900         MOVE 'FC10'             TO MBCA-PROGRAM-LOCATION
084000         MOVE SS08WS-CICS-FC-NOTFND TO MBIORO-TEMP-STATUS-1
084100         MOVE MBCA-MERCHANT-ORG  TO MBIOWS-MMRT-ORG
084200         MOVE MM04-RESV-RATE-TABLE (X-MM04-RESV)
084300                                 TO MBIOWS-MMRT-TABLE-NBR
084400         SET MBIOWS-MMRT-TT-RESERVE
084500                                 TO TRUE
084600         SET MBIORO-READ-RANDOM  TO TRUE
084700         PERFORM MMRTAO-ACCESS   THRU MMRTAO-ACCESS-EXIT
084800         IF SS08WS-RC-FC-NOTFND
084900         OR MMRT-REC-INCOMPLETE
085000         OR MMRT-REC-PURGED
085100         OR MMRT-REC-INACTIVE
085200         OR MMRT-ADD-PENDING
085300             GO TO W037-RRT-ERROR.
085400*
085500     MOVE MMRT-METHOD            TO MMRTWS-METHOD.
085600*
085700     IF  MMRTWS-DTD-VOLUME-W-CR-PLAN
085800     OR  MMRTWS-PTD-VOLUME-W-CR-PLAN
085900     OR  MMRTWS-RESV-PCT-ON-VOL-PLAN
086000         MOVE 'FC11'             TO MBCA-PROGRAM-LOCATION
086100         MOVE MBCA-MERCHANT-ORG  TO MBIOWS-MMOC-ORG
086200         SET MBIORO-READ-RANDOM  TO TRUE
086300         PERFORM MMOCAO-ACCESS   THRU MMOCAO-ACCESS-EXIT
086400         IF  MMOC-CP-MERCH-NO
086500             GO TO W037-RRT-ERROR.
086600*
086700     IF  MMRTWS-VALID-RESV-METHODS
086800         NEXT SENTENCE
086900     ELSE
087000         GO TO W037-RRT-ERROR.
087100*
087200 W035-CONTINUE.
087300*
087400     IF  MBCA-PTI-FUNCTION-IS-MAINT
087500     OR  MM04-RESV-RATE-TABLE-L (X-MM04-RESV)
087600         IS GREATER THAN ZERO
087700     OR  NOT MMFS-MT-REQUIRED (X-MMFS-MERCH)
087800         GO TO W038-INCREMENT-INDEXES.
087900*
088000 W037-RRT-ERROR.
088100*
088200     IF  MM04-RESV-RATE-TABLE-L (X-MM04-RESV)
088300         IS GREATER THAN ZERO
088400         MOVE DFHBMNBF           TO MM04-RESV-RATE-TABLE-A
088500                                        (X-MM04-RESV)
088600     ELSE
088700         MOVE DFHBMUNB           TO MM04-RESV-RATE-TABLE-A
088800                                        (X-MM04-RESV).
088900*
089000     MOVE 'Y'                    TO SS08WS-ERROR.
089100     MOVE DFHBMASB               TO MM04-RESV-RATE-TABLE-LP-A
089200                                        (X-MM04-RESV)
089300                                    MM04-RESV-RATE-TABLE-RP-A
089400                                        (X-MM04-RESV).
089500     MOVE SS08WS-CURSOR          TO MM04-RESV-RATE-TABLE-L
089600                                        (X-MM04-RESV).
089700*
089800 W038-INCREMENT-INDEXES.
089900*
090000     IF  X-MM04-RESV IS LESS THAN 4
090100         SET X-MM04-RESV         UP BY 1
090200         SET X-MMMM-RESV         UP BY 1
090300         SET X-MMFS-MERCH        UP BY 7
090400         GO TO W031-ERRT-LOOP.
090500*
090600 W039-EXIT.
090700     EXIT.
090800*
090900 W050-EDIT-RESV-DESC.
091000*
091100     SET X-MM04-RESV             TO 1.
091200     SET X-MMMM-RESV             TO 1.
091300     MOVE MMMMTB-RESV-DESC-1 (1:4)
091400                                 TO WS-INDEX-X.
091500     SET X-MMFS-MERCH            TO WS-INDEX.
091600*
091700 W051-ED-LOOP.
091800*
091900     MOVE DFHBMDAS               TO MM04-RESV-DESC-LP-A
092000                                        (X-MM04-RESV)
092100                                    MM04-RESV-DESC-RP-A
092200                                        (X-MM04-RESV).
092300     MOVE DFHBMASK               TO MM04-RESV-DESC-A
092400                                        (X-MM04-RESV).
092500*
092600     PERFORM Y055-DESC-SECURITY  THRU Y056-EXIT.
092700*
092800     IF  MM04-RESV-DESC-L (X-MM04-RESV) IS GREATER THAN ZERO
092900         MOVE DFHBMASF           TO MM04-RESV-DESC-A
093000                                        (X-MM04-RESV)
093100     ELSE
093200         MOVE MMMM-RESV-DESC (X-MMMM-RESV)
093300                                 TO MM04-RESV-DESC
093400                                        (X-MM04-RESV).
093500*
093600     IF  MBCA-PTI-FUNCTION-IS-MAINT
093700     OR  MM04-RESV-DESC-L (X-MM04-RESV)
093800         IS GREATER THAN ZERO
093900     OR  NOT MMFS-MT-REQUIRED (X-MMFS-MERCH)
094000         GO TO W058-INCREMENT-INDEXES.
094100*
094200 W057-DESC-ERROR.
094300*
094400     IF  MM04-RESV-DESC-L (X-MM04-RESV)
094500         IS GREATER THAN ZERO
094600         MOVE DFHBMUBF           TO MM04-RESV-DESC-A
094700                                        (X-MM04-RESV)
094800     ELSE
094900         MOVE DFHBMBRY           TO MM04-RESV-DESC-A
095000                                        (X-MM04-RESV).
095100*
095200     MOVE 'Y'                    TO SS08WS-ERROR.
095300     MOVE DFHBMASB               TO MM04-RESV-DESC-LP-A
095400                                        (X-MM04-RESV)
095500                                    MM04-RESV-DESC-RP-A
095600                                        (X-MM04-RESV).
095700     MOVE SS08WS-CURSOR          TO MM04-RESV-DESC-L
095800                                        (X-MM04-RESV).
095900*
096000 W058-INCREMENT-INDEXES.
096100*
096200     IF  X-MM04-RESV IS LESS THAN 4
096300         SET X-MM04-RESV         UP BY 1
096400         SET X-MMMM-RESV         UP BY 1
096500         SET X-MMFS-MERCH        UP BY 7
096600         GO TO W051-ED-LOOP.
096700*
096800 W059-EXIT.
096900     EXIT.
097000*
097100 W070-EDIT-RESV-LEVEL.
097200*
097300     SET X-MM04-RESV             TO 1.
097400     SET X-MMMM-RESV             TO 1.
097500     MOVE MMMMTB-RESV-LEVEL-1 (1:4)
097600                                 TO WS-INDEX-X.
097700     SET X-MMFS-MERCH            TO WS-INDEX.
097800*
097900 W071-ERL-LOOP.
098000*
098100*****************************************************
098200*    SET THE ATTRIBUTES TO WHAT THEY WOULD BE IF    *
098300*    SOMETHING WERE KEYED AND THE EDITS PASSED.     *
098400*****************************************************
098500*
098600     MOVE DFHBMDAS               TO MM04-RESV-LEVEL-LP-A
098700                                        (X-MM04-RESV)
098800                                    MM04-RESV-LEVEL-RP-A
098900                                        (X-MM04-RESV).
099000     MOVE DFHBMASK               TO MM04-RESV-LEVEL-A
099100                                        (X-MM04-RESV).
099200*
099300************************************************************
099400*    THE SECURITY ROUTINE IS PERFORMED TO SET THE FIELD    *
099500*    ATTRIBUTES ACCORDING TO THE SECURITY PROFILE.  IT     *
099600*    WAS ALSO PERFORMED IN THE B000-SEND-SCREEN SECTION    *
099700*    OF THIS PROGRAM.  IF THIS FIELD IS (OR WAS)           *
099800*    PROTECTED AS A RESULT OF THIS ROUTINE, THE LENGTH     *
099900*    RETURNED WILL BE ZERO.                                *
100000************************************************************
100100*
100200     PERFORM Y075-RESV-LEVEL-SECURITY
100300                                 THRU Y076-EXIT.
100400*
100500************************
100600*    EDIT THE FIELD    *
100700************************
100800*
100900     IF  MM04-RESV-LEVEL-L (X-MM04-RESV) IS GREATER THAN ZERO
101000         MOVE DFHBMASF           TO MM04-RESV-LEVEL-A
101100                                        (X-MM04-RESV)
101200     ELSE
101300         MOVE MMMM-RESV-LEVEL (X-MMMM-RESV)
101400                                 TO MM04-RESV-LEVEL
101500                                        (X-MM04-RESV).
101600*
101700     MOVE MM04-RESV-LEVEL (X-MM04-RESV)
101800                                 TO MMMM-RESV-LEVEL
101900                                        (X-MMMM-RESV).
102000*
102100     IF  NOT MMMM-RL-VALID (X-MMMM-RESV)
102200         GO TO W077-RESV-LEVEL-ERROR.
102300*
102400     IF  MBCA-PTI-FUNCTION-IS-MAINT
102500     OR  MM04-RESV-LEVEL-L (X-MM04-RESV)
102600         IS GREATER THAN ZERO
102700     OR  NOT MMFS-MT-REQUIRED (X-MMFS-MERCH)
102800         GO TO W078-INCREMENT-INDEXES.
102900*
103000 W077-RESV-LEVEL-ERROR.
103100*
103200*******************************************************
103300*    THE FIELD IS IN ERROR.  SET THE ERROR SWITCH,    *
103400*    BRIGHTEN THE PARENS, AND BRIGHTEN AND FSET       *
103500*    THE DATA ELEMENT.                                *
103600*******************************************************
103700*
103800     IF  MM04-RESV-LEVEL-L (X-MM04-RESV)
103900         IS GREATER THAN ZERO
104000         MOVE DFHBMUBF           TO MM04-RESV-LEVEL-A
104100                                        (X-MM04-RESV)
104200     ELSE
104300         MOVE DFHBMBRY           TO MM04-RESV-LEVEL-A
104400                                        (X-MM04-RESV).
104500*
104600     MOVE 'Y'                    TO SS08WS-ERROR
104700                                    WS-RESV-FREQ-ERROR-SW.
104800     MOVE DFHBMASB               TO MM04-RESV-LEVEL-LP-A
104900                                        (X-MM04-RESV)
105000                                    MM04-RESV-LEVEL-RP-A
105100                                        (X-MM04-RESV).
105200     MOVE SS08WS-CURSOR          TO MM04-RESV-LEVEL-L
105300                                        (X-MM04-RESV).
105400*
105500 W078-INCREMENT-INDEXES.
105600*
105700     IF  X-MM04-RESV IS LESS THAN 4
105800         SET X-MM04-RESV         UP BY 1
105900         SET X-MMMM-RESV         UP BY 1
106000         SET X-MMFS-MERCH        UP BY 7
106100         GO TO W071-ERL-LOOP.
106200*
106300 W079-EXIT.
106400     EXIT.
106500*
106600 W090-EDIT-RESV-FEE-BASE.
106700*
106800     SET X-MM04-RESV             TO 1.
106900     SET X-MMMM-RESV             TO 1.
107000     MOVE MMMMTB-RESV-FEE-BASE-1 (1:4)
107100                                 TO WS-INDEX-X.
107200     SET X-MMFS-MERCH            TO WS-INDEX.
107300*
107400 W091-ERL-LOOP.
107500*
107600*****************************************************
107700*    SET THE ATTRIBUTES TO WHAT THEY WOULD BE IF    *
107800*    SOMETHING WERE KEYED AND THE EDITS PASSED.     *
107900*****************************************************
108000*
108100     MOVE DFHBMDAS               TO MM04-RESV-FEE-BASE-LP-A
108200                                        (X-MM04-RESV)
108300                                    MM04-RESV-FEE-BASE-RP-A
108400                                        (X-MM04-RESV).
108500     MOVE DFHBMASK               TO MM04-RESV-FEE-BASE-A
108600                                        (X-MM04-RESV).
108700*
108800************************************************************
108900*    THE SECURITY ROUTINE IS PERFORMED TO SET THE FIELD    *
109000*    ATTRIBUTES ACCORDING TO THE SECURITY PROFILE.  IT     *
109100*    WAS ALSO PERFORMED IN THE B000-SEND-SCREEN SECTION    *
109200*    OF THIS PROGRAM.  IF THIS FIELD IS (OR WAS)           *
109300*    PROTECTED AS A RESULT OF THIS ROUTINE, THE LENGTH     *
109400*    RETURNED WILL BE ZERO.                                *
109500************************************************************
109600*
109700     PERFORM Y095-RESV-FEE-BASE-SECURITY
109800                                 THRU Y096-EXIT.
109900*
110000************************
110100*    EDIT THE FIELD    *
110200************************
110300*
110400     IF  MM04-RESV-FEE-BASE-L (X-MM04-RESV) IS GREATER THAN ZERO
110500         MOVE DFHBMASF           TO MM04-RESV-FEE-BASE-A
110600                                        (X-MM04-RESV)
110700     ELSE
110800         MOVE MMMM-RESV-FEE-BASE (X-MMMM-RESV)
110900                                 TO MM04-RESV-FEE-BASE
111000                                        (X-MM04-RESV).
111100*
111200     MOVE MM04-RESV-FEE-BASE (X-MM04-RESV)
111300                                 TO MMMM-RESV-FEE-BASE
111400                                        (X-MMMM-RESV).
111500*
111600     IF  MMMM-RFB-VALID (X-MMMM-RESV)
111700         NEXT SENTENCE
111800     ELSE
111900         GO TO W097-RESV-FEE-BASE-ERROR.
112000*
112100     IF  MBCA-PTI-FUNCTION-IS-MAINT
112200     OR  MM04-RESV-FEE-BASE-L (X-MM04-RESV)
112300         IS GREATER THAN ZERO
112400     OR  NOT MMFS-MT-REQUIRED (X-MMFS-MERCH)
112500         GO TO W098-INCREMENT-INDEXES.
112600*
112700 W097-RESV-FEE-BASE-ERROR.
112800*
112900*******************************************************
113000*    THE FIELD IS IN ERROR.  SET THE ERROR SWITCH,    *
113100*    BRIGHTEN THE PARENS, AND BRIGHTEN AND FSET       *
113200*    THE DATA ELEMENT.                                *
113300*******************************************************
113400*
113500     IF  MM04-RESV-FEE-BASE-L (X-MM04-RESV)
113600         IS GREATER THAN ZERO
113700         MOVE DFHBMUBF           TO MM04-RESV-FEE-BASE-A
113800                                        (X-MM04-RESV)
113900     ELSE
114000         MOVE DFHBMBRY           TO MM04-RESV-FEE-BASE-A
114100                                        (X-MM04-RESV).
114200*
114300     MOVE 'Y'                    TO SS08WS-ERROR
114400                                    WS-RESV-FREQ-ERROR-SW.
114500     MOVE DFHBMASB               TO MM04-RESV-FEE-BASE-LP-A
114600                                        (X-MM04-RESV)
114700                                    MM04-RESV-FEE-BASE-RP-A
114800                                        (X-MM04-RESV).
114900     MOVE SS08WS-CURSOR          TO MM04-RESV-FEE-BASE-L
115000                                        (X-MM04-RESV).
115100*
115200 W098-INCREMENT-INDEXES.
115300*
115400     IF  X-MM04-RESV IS LESS THAN 4
115500         SET X-MM04-RESV         UP BY 1
115600         SET X-MMMM-RESV         UP BY 1
115700         SET X-MMFS-MERCH        UP BY 7
115800         GO TO W091-ERL-LOOP.
115900*
116000 W099-EXIT.
116100     EXIT.
116200*
116300 W110-EDIT-RESV-FLOOR.
116400*
116500     SET X-MM04-RESV             TO 1.
116600     SET X-MMMM-RESV             TO 1.
116700     MOVE MMMMTB-RESV-FLOOR-1 (1:4)
116800                                 TO WS-INDEX-X.
116900     SET X-MMFS-MERCH            TO WS-INDEX.
117000*
117100 W111-ERF-LOOP.
117200*
117300     MOVE DFHBMDAS               TO MM04-RESV-FLOOR-LP-A
117400                                        (X-MM04-RESV)
117500                                    MM04-RESV-FLOOR-RP-A
117600                                        (X-MM04-RESV).
117700     MOVE DFHBMASK               TO MM04-RESV-FLOOR-A
117800                                        (X-MM04-RESV).
117900*
118000     PERFORM Y115-FLOOR-SECURITY THRU Y116-EXIT.
118100*
118200     IF  MM04-RESV-FLOOR-L (X-MM04-RESV) IS GREATER THAN ZERO
118300         MOVE DFHBMASF           TO MM04-RESV-FLOOR-A
118400                                        (X-MM04-RESV)
118500     ELSE
118600         MOVE MMMM-RESV-FLOOR (X-MMMM-RESV)
118700                                 TO MM04-RESV-FLOOR
118800                                        (X-MM04-RESV).
118900*
119000     IF  MM04-RESV-FLOOR (X-MM04-RESV) IS NOT NUMERIC
119100         GO TO W117-FLOOR-ERROR.
119200*
119300     IF  MBCA-PTI-FUNCTION-IS-MAINT
119400     OR  MM04-RESV-FLOOR-L (X-MM04-RESV)
119500         IS GREATER THAN ZERO
119600     OR  NOT MMFS-MT-REQUIRED (X-MMFS-MERCH)
119700         GO TO W118-INCREMENT-INDEXES.
119800*
119900 W117-FLOOR-ERROR.
120000*
120100     IF  MM04-RESV-FLOOR-L (X-MM04-RESV)
120200         IS GREATER THAN ZERO
120300         MOVE DFHBMNBF           TO MM04-RESV-FLOOR-A
120400                                        (X-MM04-RESV)
120500     ELSE
120600         MOVE DFHBMUNB           TO MM04-RESV-FLOOR-A
120700                                        (X-MM04-RESV).
120800*
120900     MOVE 'Y'                    TO SS08WS-ERROR
121000                                    WS-FLOOR-ERROR-SW.
121100     MOVE DFHBMASB               TO MM04-RESV-FLOOR-LP-A
121200                                        (X-MM04-RESV)
121300                                    MM04-RESV-FLOOR-RP-A
121400                                        (X-MM04-RESV).
121500     MOVE SS08WS-CURSOR          TO MM04-RESV-FLOOR-L
121600                                        (X-MM04-RESV).
121700*
121800 W118-INCREMENT-INDEXES.
121900*
122000     IF  X-MM04-RESV IS LESS THAN 4
122100         SET X-MM04-RESV         UP BY 1
122200         SET X-MMMM-RESV         UP BY 1
122300         SET X-MMFS-MERCH        UP BY 7
122400         GO TO W111-ERF-LOOP.
122500*
122600 W119-EXIT.
122700     EXIT.
122800*
122900 W130-EDIT-RESV-CEILING.
123000*
123100     SET X-MM04-RESV             TO 1.
123200     SET X-MMMM-RESV             TO 1.
123300     MOVE MMMMTB-RESV-CEILING-1 (1:4)
123400                                 TO WS-INDEX-X.
123500     SET X-MMFS-MERCH            TO WS-INDEX.
123600*
123700 W131-ERC-LOOP.
123800*
123900     MOVE DFHBMDAS               TO MM04-RESV-CEILING-LP-A
124000                                        (X-MM04-RESV)
124100                                    MM04-RESV-CEILING-RP-A
124200                                        (X-MM04-RESV).
124300     MOVE DFHBMASK               TO MM04-RESV-CEILING-A
124400                                        (X-MM04-RESV).
124500*
124600     PERFORM Y135-CEILING-SECURITY
124700                                 THRU Y136-EXIT.
124800*
124900     IF  MM04-RESV-CEILING-L (X-MM04-RESV) IS GREATER THAN ZERO
125000         MOVE DFHBMASF           TO MM04-RESV-CEILING-A
125100                                        (X-MM04-RESV)
125200     ELSE
125300         MOVE MMMM-RESV-CEILING (X-MMMM-RESV)
125400                                 TO MM04-RESV-CEILING
125500                                        (X-MM04-RESV).
125600*
125700     IF  MM04-RESV-CEILING (X-MM04-RESV) IS NOT NUMERIC
125800         GO TO W137-CEILING-ERROR.
125900*
126000     IF  MBCA-PTI-FUNCTION-IS-MAINT
126100     OR  MM04-RESV-CEILING-L (X-MM04-RESV)
126200         IS GREATER THAN ZERO
126300     OR  NOT MMFS-MT-REQUIRED (X-MMFS-MERCH)
126400         GO TO W138-INCREMENT-INDEXES.
126500*
126600 W137-CEILING-ERROR.
126700*
126800     IF  MM04-RESV-CEILING-L (X-MM04-RESV)
126900         IS GREATER THAN ZERO
127000         MOVE DFHBMNBF           TO MM04-RESV-CEILING-A
127100                                        (X-MM04-RESV)
127200     ELSE
127300         MOVE DFHBMUNB           TO MM04-RESV-CEILING-A
127400                                        (X-MM04-RESV).
127500*
127600     MOVE 'Y'                    TO SS08WS-ERROR
127700                                    WS-FLOOR-ERROR-SW.
127800     MOVE DFHBMASB               TO MM04-RESV-CEILING-LP-A
127900                                        (X-MM04-RESV)
128000                                    MM04-RESV-CEILING-RP-A
128100                                        (X-MM04-RESV).
128200     MOVE SS08WS-CURSOR          TO MM04-RESV-CEILING-L
128300                                        (X-MM04-RESV).
128400*
128500 W138-INCREMENT-INDEXES.
128600*
128700     IF  X-MM04-RESV IS LESS THAN 4
128800         SET X-MM04-RESV         UP BY 1
128900         SET X-MMMM-RESV         UP BY 1
129000         SET X-MMFS-MERCH        UP BY 7
129100         GO TO W131-ERC-LOOP.
129200*
129300 W139-EXIT.
129400     EXIT.
129500*
129600 W150-EDIT-BILL-USE-FLAG.
129700*
129800     SET X-MM04-BILL             TO 1.
129900     SET X-MMMM-BILL             TO 1.
130000     MOVE MMMMTB-BILL-USE-FLAG-1 (1:4)
130100                                 TO WS-INDEX-X.
130200     SET X-MMFS-MERCH            TO WS-INDEX.
130300*
130400 W151-EBUF-LOOP.
130500*
130600*****************************************************
130700*    SET THE ATTRIBUTES TO WHAT THEY WOULD BE IF    *
130800*    SOMETHING WERE KEYED AND THE EDITS PASSED.     *
130900*****************************************************
131000*
131100     MOVE DFHBMDAS               TO MM04-BILL-USE-FLAG-LP-A
131200                                        (X-MM04-BILL)
131300                                    MM04-BILL-USE-FLAG-RP-A
131400                                        (X-MM04-BILL).
131500     MOVE DFHBMASK               TO MM04-BILL-USE-FLAG-A
131600                                        (X-MM04-BILL).
131700*
131800************************************************************
131900*    THE SECURITY ROUTINE IS PERFORMED TO SET THE FIELD    *
132000*    ATTRIBUTES ACCORDING TO THE SECURITY PROFILE.  IT     *
132100*    WAS ALSO PERFORMED IN THE B000-SEND-SCREEN SECTION    *
132200*    OF THIS PROGRAM.  IF THIS FIELD IS (OR WAS)           *
132300*    PROTECTED AS A RESULT OF THIS ROUTINE, THE LENGTH     *
132400*    RETURNED WILL BE ZERO.                                *
132500************************************************************
132600*
132700     PERFORM Y155-BILL-USE-FLAG-SECURITY
132800                                 THRU Y156-EXIT.
132900*
133000************************
133100*    EDIT THE FIELD    *
133200************************
133300*
133400     IF  MM04-BILL-USE-FLAG-L (X-MM04-BILL) IS GREATER THAN ZERO
133500         MOVE DFHBMASF           TO MM04-BILL-USE-FLAG-A
133600                                        (X-MM04-BILL)
133700     ELSE
133800         MOVE MMMM-BILL-USE-FLAG (X-MMMM-BILL)
133900                                 TO MM04-BILL-USE-FLAG
134000                                        (X-MM04-BILL).
134100*
134200     IF  NOT MM04-VALID-BILL-USE-FLAG (X-MM04-BILL)
134300         GO TO W157-BILL-USE-FLAG-ERROR.
134400*
134500     IF  MBCA-PTI-FUNCTION-IS-MAINT
134600     OR  MM04-BILL-USE-FLAG-L (X-MM04-BILL)
134700         IS GREATER THAN ZERO
134800     OR  NOT MMFS-MT-REQUIRED (X-MMFS-MERCH)
134900         GO TO W158-INCREMENT-INDEXES.
135000*
135100 W157-BILL-USE-FLAG-ERROR.
135200*
135300*******************************************************
135400*    THE FIELD IS IN ERROR.  SET THE ERROR SWITCH,    *
135500*    BRIGHTEN THE PARENS, AND BRIGHTEN AND FSET       *
135600*    THE DATA ELEMENT.                                *
135700*******************************************************
135800*
135900     IF  MM04-BILL-USE-FLAG-L (X-MM04-BILL)
136000         IS GREATER THAN ZERO
136100         MOVE DFHBMUBF           TO MM04-BILL-USE-FLAG-A
136200                                        (X-MM04-BILL)
136300     ELSE
136400         MOVE DFHBMBRY           TO MM04-BILL-USE-FLAG-A
136500                                        (X-MM04-BILL).
136600*
136700     MOVE 'Y'                    TO SS08WS-ERROR
136800                                    WS-RESV-FREQ-ERROR-SW.
136900     MOVE DFHBMASB               TO MM04-BILL-USE-FLAG-LP-A
137000                                        (X-MM04-BILL)
137100                                    MM04-BILL-USE-FLAG-RP-A
137200                                        (X-MM04-BILL).
137300     MOVE SS08WS-CURSOR          TO MM04-BILL-USE-FLAG-L
137400                                        (X-MM04-BILL).
137500*
137600 W158-INCREMENT-INDEXES.
137700*
137800     IF  X-MM04-BILL IS LESS THAN 4
137900         SET X-MM04-BILL         UP BY 1
138000         SET X-MMMM-BILL         UP BY 1
138100         SET X-MMFS-MERCH        UP BY 3
138200         GO TO W151-EBUF-LOOP.
138300*
138400 W159-EXIT.
138500     EXIT.
138600*
138700 W170-EDIT-BILLING-ORG.
138800*
138900*****************************************
139000*    READ THE ORG CONTROL RECORD        *
139100*****************************************
139200*
139300     MOVE MBCA-MERCHANT-ORG      TO MBIOWS-MMOC-ORG.
139400     SET MBIORO-READ-RANDOM      TO TRUE.
139500     PERFORM MMOCAO-ACCESS       THRU MMOCAO-ACCESS-EXIT.
139600*
139700     SET X-MM04-BILL             TO 1.
139800     SET X-MMMM-BILL             TO 1.
139900     MOVE MMMMTB-BILLING-ORG-1 (1:4)
140000                                 TO WS-INDEX-X.
140100     SET X-MMFS-MERCH            TO WS-INDEX.
140200*
140300 W171-EBO-LOOP.
140400*
140500     MOVE DFHBMDAS               TO MM04-BILLING-ORG-LP-A
140600                                        (X-MM04-BILL)
140700                                    MM04-BILLING-ORG-RP-A
140800                                        (X-MM04-BILL).
140900     MOVE DFHBMASK               TO MM04-BILLING-ORG-A
141000                                        (X-MM04-BILL).
141100*
141200     PERFORM Y175-BILLING-ORG-SECURITY
141300                                 THRU Y176-EXIT.
141400*
141500     IF  MM04-BILLING-ORG-L (X-MM04-BILL)
141600                                    IS GREATER THAN ZERO
141700         MOVE DFHBMASF           TO MM04-BILLING-ORG-A
141800                                        (X-MM04-BILL)
141900     ELSE
142000         IF  MM04-BILL-USE-FLAG-YES (X-MM04-BILL)
142100         OR  MM04-BILL-USE-FLAG-HOLD (X-MM04-BILL)
142200             MOVE MMOC-BILLING-ORG
142300                                 TO MM04-BILLING-ORG
142400                                        (X-MM04-BILL)
142500             MOVE +3             TO MM04-BILLING-ORG-L
142600                                        (X-MM04-BILL)
142700             MOVE DFHBMASF       TO MM04-BILLING-ORG-A
142800                                        (X-MM04-BILL)
142900         ELSE
143000             MOVE MMMM-BILLING-ORG (X-MMMM-BILL)
143100                                 TO MM04-BILLING-ORG
143200                                        (X-MM04-BILL).
143300*
143400     IF  MM04-BILLING-ORG (X-MM04-BILL) IS NOT NUMERIC
143500         GO TO W177-EBO-ERROR.
143600*
143700     IF  MBCA-PTI-FUNCTION-IS-MAINT
143800     OR  MM04-BILLING-ORG-L (X-MM04-BILL)
143900         IS GREATER THAN ZERO
144000     OR  NOT MMFS-MT-REQUIRED (X-MMFS-MERCH)
144100         GO TO W178-INCREMENT-INDEXES.
144200*
144300 W177-EBO-ERROR.
144400*
144500     IF  MM04-BILLING-ORG-L (X-MM04-BILL)
144600         IS GREATER THAN ZERO
144700         MOVE DFHBMNBF           TO MM04-BILLING-ORG-A
144800                                        (X-MM04-BILL)
144900     ELSE
145000         MOVE DFHBMUNB           TO MM04-BILLING-ORG-A
145100                                        (X-MM04-BILL).
145200*
145300     MOVE 'Y'                    TO SS08WS-ERROR.
145400     MOVE DFHBMASB               TO MM04-BILLING-ORG-LP-A
145500                                        (X-MM04-BILL)
145600                                    MM04-BILLING-ORG-RP-A
145700                                        (X-MM04-BILL).
145800     MOVE SS08WS-CURSOR          TO MM04-BILLING-ORG-L
145900                                        (X-MM04-BILL).
146000*
146100 W178-INCREMENT-INDEXES.
146200*
146300     IF  X-MM04-BILL IS LESS THAN 4
146400         SET X-MM04-BILL         UP BY 1
146500         SET X-MMMM-BILL         UP BY 1
146600         SET X-MMFS-MERCH        UP BY 3
146700         GO TO W171-EBO-LOOP.
146800*
146900 W179-EXIT.
147000     EXIT.
147100*
147200 W190-EDIT-BILLING-ACCT.
147300*
147400     SET X-MM04-BILL             TO 1.
147500     SET X-MMMM-BILL             TO 1.
147600     MOVE MMMMTB-BILLING-ACCT-1 (1:4)
147700                                 TO WS-INDEX-X.
147800     SET X-MMFS-MERCH            TO WS-INDEX.
147900*
148000 W191-EBA-LOOP.
148100*
148200*****************************************************
148300*    SET THE ATTRIBUTES TO WHAT THEY WOULD BE IF    *
148400*    SOMETHING WERE KEYED AND THE EDITS PASSED.     *
148500*****************************************************
148600*
148700     MOVE DFHBMDAS               TO MM04-BILLING-ACCT-LP-A
148800                                        (X-MM04-BILL)
148900                                    MM04-BILLING-ACCT-RP-A
149000                                        (X-MM04-BILL).
149100     MOVE DFHBMASK               TO MM04-BILLING-ACCT-A
149200                                        (X-MM04-BILL).
149300*
149400************************************************************
149500*    THE SECURITY ROUTINE IS PERFORMED TO SET THE FIELD    *
149600*    ATTRIBUTES ACCORDING TO THE SECURITY PROFILE.  IT     *
149700*    WAS ALSO PERFORMED IN THE B000-SEND-SCREEN SECTION    *
149800*    OF THIS PROGRAM.  IF THIS FIELD IS (OR WAS)           *
149900*    PROTECTED AS A RESULT OF THIS ROUTINE, THE LENGTH     *
150000*    RETURNED WILL BE ZERO.                                *
150100************************************************************
150200*
150300     PERFORM Y195-BILLING-ACCT-SECURITY
150400                                 THRU Y196-EXIT.
150500*
150600************************
150700*    EDIT THE FIELD    *
150800************************
150900*
151000     IF  MM04-BILLING-ACCT-L (X-MM04-BILL) IS GREATER THAN ZERO
151100         MOVE DFHBMASF           TO MM04-BILLING-ACCT-A
151200                                        (X-MM04-BILL)
151300     ELSE
151400         MOVE MMMM-BILLING-ACCT (X-MMMM-BILL)
151500                                 TO MM04-BILLING-ACCT
151600                                        (X-MM04-BILL).
151700*
151800     MOVE MM04-BILLING-ACCT (X-MM04-BILL)
151900                                 TO MMMM-BILLING-ACCT
152000                                        (X-MMMM-BILL).
152100*
152200     IF  MBCA-PTI-FUNCTION-IS-MAINT
152300     OR  MM04-BILLING-ACCT-L (X-MM04-BILL)
152400         IS GREATER THAN ZERO
152500     OR  NOT MMFS-MT-REQUIRED (X-MMFS-MERCH)
152600         GO TO W198-INCREMENT-INDEXES.
152700*
152800 W197-BILLING-ACCT-ERROR.
152900*
153000*******************************************************
153100*    THE FIELD IS IN ERROR.  SET THE ERROR SWITCH,    *
153200*    BRIGHTEN THE PARENS, AND BRIGHTEN AND FSET       *
153300*    THE DATA ELEMENT.                                *
153400*******************************************************
153500*
153600     IF  MM04-BILLING-ACCT-L (X-MM04-BILL)
153700         IS GREATER THAN ZERO
153800         MOVE DFHBMUBF           TO MM04-BILLING-ACCT-A
153900                                        (X-MM04-BILL)
154000     ELSE
154100         MOVE DFHBMBRY           TO MM04-BILLING-ACCT-A
154200                                        (X-MM04-BILL).
154300*
154400     MOVE 'Y'                    TO SS08WS-ERROR
154500                                    WS-RESV-FREQ-ERROR-SW.
154600     MOVE DFHBMASB               TO MM04-BILLING-ACCT-LP-A
154700                                        (X-MM04-BILL)
154800                                    MM04-BILLING-ACCT-RP-A
154900                                        (X-MM04-BILL).
155000     MOVE SS08WS-CURSOR          TO MM04-BILLING-ACCT-L
155100                                        (X-MM04-BILL).
155200*
155300 W198-INCREMENT-INDEXES.
155400*
155500     IF  X-MM04-BILL IS LESS THAN 4
155600         SET X-MM04-BILL         UP BY 1
155700         SET X-MMMM-BILL         UP BY 1
155800         SET X-MMFS-MERCH        UP BY 3
155900         GO TO W191-EBA-LOOP.
156000*
156100 W199-EXIT.
156200     EXIT.
156300*
156400 W510-RESERVE-CROSS-EDITS.
156500*
156600**************************************************************
156700*                                                            *
156800*    RESERVE CROSS EDITS ARE AS FOLLOWS:                     *
156900*                                                            *
157000*    .  IF THE RESERVE IS BEING USED, IT MUST HAVE A         *
157100*       DESCRIPTION OF SOMETHING OTHER THAN SPACES           *
157200*                                                            *
157300*       IF AN ERROR IS DETECTED, THE USED FLAG AND           *
157400*       DESCRIPTION FIELD ARE HIGHLIGHTED AND OPENED FOR     *
157500*       CORRECTION.                                          *
157600*                                                            *
157700*    - - - - - - - - - - - - - - - - - - - - - - - - - -     *
157800*                                                            *
157900*    .  THE CEILING AMOUNT CANNOT BE LESS THAN THE FLOOR     *
158000*       AMOUNT.                                              *
158100*                                                            *
158200*       IF AN ERROR IS DETECTED, THE FLOOR AMOUNT AND THE    *
158300*       CEILING AMOUNT ARE HIGHLIGHTED AND OPENED FOR        *
158400*       CORRECTION.                                          *
158500*                                                            *
158600*    - - - - - - - - - - - - - - - - - - - - - - - - - -     *
158700*                                                            *
158800**************************************************************
158900*
159000     PERFORM W511-DESC-CROSS-EDIT
159100                                 THRU W511-DCE-EXIT.
159200*
159300     PERFORM W512-FLOOR-CEILING-CROSS-EDITS
159400                                 THRU W512-FCCE-EXIT.
159500*
159600     PERFORM W513-TABLE-LEVEL-CROSS-EDITS
159700                                 THRU W513-TLCE-EXIT.
159800*
159900     GO TO W519-RCE-EXIT.
160000*
160100 W511-DESC-CROSS-EDIT.
160200*
160300     IF  RESV-FREQ-ERRORS-EXIST
160400         GO TO W511-DCE-EXIT.
160500*
160600     SET X-MM04-RESV             TO 1.
160700     SET X-MMMM-RESV             TO 1.
160800*
160900 W511-DCE-LOOP.
161000*
161100     IF  MMMM-RESV-NOT-ACTIVE (X-MMMM-RESV)
161200         GO TO W511-INCREMENT-INDEXES.
161300*
161400     IF  MM04-RESV-DESC (X-MM04-RESV) IS NOT EQUAL TO SPACES
161500         GO TO W511-INCREMENT-INDEXES.
161600*
161700 W511-DESC-ERROR.
161800*
161900     MOVE 'Y'                    TO SS08WS-ERROR
162000                                    WS-RESV-FREQ-ERROR-SW.
162100     MOVE DFHBMASB               TO MM04-RESV-FEE-BASE-LP-A
162200                                        (X-MM04-RESV)
162300                                    MM04-RESV-FEE-BASE-RP-A
162400                                        (X-MM04-RESV)
162500                                    MM04-RESV-DESC-LP-A
162600                                        (X-MM04-RESV)
162700                                    MM04-RESV-DESC-RP-A
162800                                        (X-MM04-RESV).
162900     MOVE DFHBMUBF               TO MM04-RESV-FEE-BASE-A
163000                                        (X-MM04-RESV)
163100                                    MM04-RESV-DESC-A
163200                                        (X-MM04-RESV).
163300     MOVE SS08WS-CURSOR          TO MM04-RESV-DESC-L
163400                                        (X-MM04-RESV).
163500*
163600 W511-INCREMENT-INDEXES.
163700*
163800     IF  X-MM04-RESV IS LESS THAN 4
163900         SET X-MM04-RESV        UP BY 1
164000         SET X-MMMM-RESV        UP BY 1
164100         GO TO W511-DCE-LOOP.
164200*
164300 W511-DCE-EXIT.
164400     EXIT.
164500*
164600 W512-FLOOR-CEILING-CROSS-EDITS.
164700*
164800     IF  FLOOR-ERRORS-EXIST
164900     OR  CEILING-ERRORS-EXIST
165000         GO TO W512-FCCE-EXIT.
165100*
165200     SET X-MM04-RESV             TO 1.
165300*
165400 W512-FCCE-LOOP.
165500*
165600     IF  MM04-RESV-FLOOR   (X-MM04-RESV) IS NOT GREATER THAN
165700         MM04-RESV-CEILING (X-MM04-RESV)
165800         GO TO W512-INCREMENT-INDEXES.
165900*
166000 W512-FLOOR-CEILING-ERROR.
166100*
166200     MOVE 'Y'                    TO SS08WS-ERROR
166300                                    WS-FLOOR-ERROR-SW
166400                                    WS-CEILING-ERROR-SW.
166500     MOVE DFHBMASB               TO MM04-RESV-FLOOR-LP-A
166600                                        (X-MM04-RESV)
166700                                    MM04-RESV-FLOOR-RP-A
166800                                        (X-MM04-RESV)
166900                                    MM04-RESV-CEILING-LP-A
167000                                        (X-MM04-RESV)
167100                                    MM04-RESV-CEILING-RP-A
167200                                        (X-MM04-RESV).
167300     MOVE DFHBMNBF               TO MM04-RESV-FLOOR-A
167400                                        (X-MM04-RESV)
167500                                    MM04-RESV-CEILING-A
167600                                        (X-MM04-RESV).
167700     MOVE SS08WS-CURSOR          TO MM04-RESV-FLOOR-L
167800                                        (X-MM04-RESV).
167900*
168000 W512-INCREMENT-INDEXES.
168100*
168200     IF  X-MM04-RESV IS LESS THAN 4
168300         SET X-MM04-RESV        UP BY 1
168400         GO TO W512-FCCE-LOOP.
168500*
168600 W512-FCCE-EXIT.
168700     EXIT.
168800*
168900 W513-TABLE-LEVEL-CROSS-EDITS.
169000*
169100     IF  FLOOR-ERRORS-EXIST
169200     OR  CEILING-ERRORS-EXIST
169300         GO TO W513-TLCE-EXIT.
169400*
169500     SET X-MM04-RESV             TO 1.
169600*
169700 W513-TLCE-LOOP.
169800*
169900     IF  MM04-RESV-RATE-TABLE (X-MM04-RESV)  GREATER THAN ZERO
170000     AND MM04-RESV-LEVEL (X-MM04-RESV) IS EQUAL TO 'P'
170100         GO TO W513-TABLE-LEVEL-ERROR.
170200*
170300     IF  MM04-RESV-RATE-TABLE (X-MM04-RESV)  GREATER THAN ZERO
170400         MOVE 'FC12'             TO MBCA-PROGRAM-LOCATION
170500         MOVE MBCA-MERCHANT-ORG  TO MBIOWS-MMRT-ORG
170600         MOVE MM04-RESV-RATE-TABLE (X-MM04-RESV)
170700                                 TO MBIOWS-MMRT-TABLE-NBR
170800         SET MBIOWS-MMRT-TT-RESERVE
170900                                 TO TRUE
171000         SET MBIORO-READ-RANDOM  TO TRUE
171100         MOVE SS08WS-CICS-FC-NOTFND TO MBIORO-TEMP-STATUS-1
171200         PERFORM MMRTAO-ACCESS   THRU MMRTAO-ACCESS-EXIT
171300*
171400         IF  SS08WS-RC-FC-NOTFND
171500         OR  MM04-RESV-LEVEL (X-MM04-RESV) IS NOT EQUAL
171600                                 TO MMRT-LEVEL
171700             GO TO W513-TABLE-LEVEL-ERROR.
171800*
171900     GO TO W513-INCREMENT-INDEXES.
172000*
172100 W513-TABLE-LEVEL-ERROR.
172200*
172300     MOVE 'Y'                    TO SS08WS-ERROR.
172400     MOVE DFHBMASB               TO MM04-RESV-RATE-TABLE-LP-A
172500                                        (X-MM04-RESV)
172600                                    MM04-RESV-RATE-TABLE-RP-A
172700                                        (X-MM04-RESV).
172800     MOVE DFHBMNBF               TO MM04-RESV-RATE-TABLE-A
172900                                        (X-MM04-RESV).
173000     MOVE SS08WS-CURSOR          TO MM04-RESV-RATE-TABLE-L
173100                                        (X-MM04-RESV).
173200*
173300 W513-INCREMENT-INDEXES.
173400*
173500     IF  X-MM04-RESV IS LESS THAN 4
173600         SET X-MM04-RESV        UP BY 1
173700         GO TO W513-TLCE-LOOP.
173800*
173900 W513-TLCE-EXIT.
174000     EXIT.
174100*
174200 W519-RCE-EXIT.
174300     EXIT.
174400*
174500 W520-BILLING-CROSS-EDITS.
174600*
174700     PERFORM
174800         VARYING X-MM04-BILL FROM 1 BY 1
174900         UNTIL X-MM04-BILL IS GREATER THAN 4
175000         EVALUATE TRUE
175100           WHEN MM04-BILL-USE-FLAG-NO (X-MM04-BILL)
175200             CONTINUE
175300           WHEN (MM04-BILL-USE-FLAG-YES (X-MM04-BILL)
175400             OR MM04-BILL-USE-FLAG-HOLD (X-MM04-BILL))
175500             EVALUATE TRUE
175600               WHEN MMOC-BILLING-STORE IS GREATER THAN ZERO
175700                 CONTINUE
175800               WHEN OTHER
175900                 MOVE DFHBMUBF   TO MM04-BILL-USE-FLAG-A
176000                                    (X-MM04-BILL)
176100                 MOVE 'Y'        TO SS08WS-ERROR
176200                 MOVE DFHBMASB   TO MM04-BILL-USE-FLAG-LP-A
176300                                    (X-MM04-BILL)
176400                                    MM04-BILL-USE-FLAG-RP-A
176500                                    (X-MM04-BILL)
176600                 MOVE SS08WS-CURSOR TO MM04-BILL-USE-FLAG-L
176700                                    (X-MM04-BILL)
176800             END-EVALUATE
176900             EVALUATE TRUE
177000               WHEN MM04-BILLING-ACCT (X-MM04-BILL)
177100                                    IS NOT EQUAL TO SPACES
177200                     CONTINUE
177300               WHEN  OTHER
177400                 MOVE DFHBMUBF   TO MM04-BILLING-ACCT-A
177500                                    (X-MM04-BILL)
177600                 MOVE 'Y'        TO SS08WS-ERROR
177700                 MOVE DFHBMASB   TO MM04-BILLING-ACCT-LP-A
177800                                    (X-MM04-BILL)
177900                                    MM04-BILLING-ACCT-RP-A
178000                                    (X-MM04-BILL)
178100                 MOVE SS08WS-CURSOR TO MM04-BILLING-ACCT-L
178200                                    (X-MM04-BILL)
178300             END-EVALUATE
178400         END-EVALUATE
178500     END-PERFORM.
178600*
178700     PERFORM
178800         VARYING X-MM04-BILL FROM 1 BY 1
178900         UNTIL X-MM04-BILL IS GREATER THAN 4
179000         EVALUATE TRUE
179100           WHEN MM04-BILL-USE-FLAG-HOLD (X-MM04-BILL)
179200           AND  WS-HOLD-SW-YES
179300                 MOVE DFHBMUBF   TO MM04-BILL-USE-FLAG-A (1)
179400                                    MM04-BILL-USE-FLAG-A (2)
179500                                    MM04-BILL-USE-FLAG-A (3)
179600                                    MM04-BILL-USE-FLAG-A (4)
179700                 MOVE 'Y'        TO SS08WS-ERROR
179800                 MOVE DFHBMASB   TO MM04-BILL-USE-FLAG-LP-A (1)
179900                                    MM04-BILL-USE-FLAG-RP-A (1)
180000                                    MM04-BILL-USE-FLAG-LP-A (2)
180100                                    MM04-BILL-USE-FLAG-RP-A (2)
180200                                    MM04-BILL-USE-FLAG-LP-A (3)
180300                                    MM04-BILL-USE-FLAG-RP-A (3)
180400                                    MM04-BILL-USE-FLAG-LP-A (4)
180500                                    MM04-BILL-USE-FLAG-RP-A (4)
180600                 MOVE SS08WS-CURSOR TO MM04-BILL-USE-FLAG-L (1)
180700           WHEN MM04-BILL-USE-FLAG-HOLD (X-MM04-BILL)
180800             SET WS-HOLD-SW-YES  TO TRUE
180900         END-EVALUATE
181000     END-PERFORM.
181100*
181200     PERFORM
181300         VARYING X-MM04-BILL FROM 1 BY 1
181400         UNTIL X-MM04-BILL IS GREATER THAN 4
181500         SET X-MMMM-BILL         TO X-MM04-BILL
181600         EVALUATE TRUE ALSO TRUE ALSO TRUE
181700           WHEN MM04-BILL-USE-FLAG-L (X-MM04-BILL)
181800                                 IS GREATER THAN ZERO
181900           ALSO MM04-BILL-USE-FLAG-YES-NO (X-MM04-BILL)
182000           ALSO MMMM-BUF-HOLDOVER-TO-XFER (X-MMMM-BILL)
182100              PERFORM
182200                VARYING X-MMMM-SETT-ACH FROM 1 BY 1
182300                UNTIL X-MMMM-SETT-ACH IS GREATER THAN 4
182400                SET X-MMMM-SETT-ACCT
182500                                 TO X-MMMM-SETT-ACH
182600                  EVALUATE TRUE
182700                    WHEN (MMMM-PSA-HOLDOVER-BILLED
182800                                 (X-MMMM-SETT-ACH)
182900                    OR MMMM-SA-HOLDOVER-BILLED
183000                                 (X-MMMM-SETT-ACCT)
183100                    OR MMMM-ISA-HOLDOVER-BILLED
183200                                 (X-MMMM-SETT-ACH))
183300                    PERFORM
183400                      VARYING X-MM04-BILL-1 FROM 1 BY 1
183500                      UNTIL X-MM04-BILL-1 IS GREATER THAN 4
183600                      EVALUATE TRUE
183700                        WHEN X-MM04-BILL-1 IS EQUAL
183800                                 TO X-MM04-BILL
183900                          CONTINUE
184000                        WHEN MM04-BILL-USE-FLAG-HOLD
184100                                    (X-MM04-BILL-1)
184200                          SET WS-BILL-HOLD-YES
184300                                 TO TRUE
184400                      END-EVALUATE
184500                    END-PERFORM
184600                    EVALUATE TRUE
184700                      WHEN WS-BILL-HOLD-YES
184800                        CONTINUE
184900                      WHEN OTHER
185000                        MOVE DFHBMUBF
185100                                 TO MM04-BILL-USE-FLAG-A
185200                                    (X-MM04-BILL)
185300                        MOVE 'Y' TO SS08WS-ERROR
185400                        MOVE DFHBMASB
185500                                 TO MM04-BILL-USE-FLAG-LP-A
185600                                    (X-MM04-BILL)
185700                                    MM04-BILL-USE-FLAG-RP-A
185800                                    (X-MM04-BILL)
185900                        MOVE SS08WS-CURSOR
186000                                 TO MM04-BILL-USE-FLAG-L
186100                                    (X-MM04-BILL)
186200                        SET X-MMMM-SETT-ACH
186300                                  TO 4
186400                    END-EVALUATE
186500                  END-EVALUATE
186600              END-PERFORM
186700         END-EVALUATE
186800     END-PERFORM.
186900*
187000     PERFORM
187100       VARYING X-MM04-BILL FROM 1 BY 1
187200       UNTIL X-MM04-BILL IS GREATER THAN 4
187300       IF  MM04-BILL-USE-FLAG-L (X-MM04-BILL)
187400                                 IS GREATER THAN ZERO
187500       AND MM04-BILL-USE-FLAG-NO (X-MM04-BILL)
187600         EVALUATE TRUE
187700           WHEN X-MM04-BILL IS EQUAL TO 1
187800           PERFORM
187900             VARYING X-MMMM-TAT FROM 1 BY 1
188000             UNTIL X-MMMM-TAT IS GREATER THAN 16
188100             IF  MMMM-TAT-ACCOUNT (X-MMMM-TAT)
188200                                 IS EQUAL TO 'B1'
188300                 MOVE DFHBMUBF   TO MM04-BILL-USE-FLAG-A
188400                                    (X-MM04-BILL)
188500                  MOVE 'Y'         TO SS08WS-ERROR
188600                  MOVE DFHBMASB  TO MM04-BILL-USE-FLAG-LP-A
188700                                    (X-MM04-BILL)
188800                                    MM04-BILL-USE-FLAG-RP-A
188900                                    (X-MM04-BILL)
189000                  MOVE SS08WS-CURSOR
189100                                 TO MM04-BILL-USE-FLAG-L
189200                                    (X-MM04-BILL)
189300             END-IF
189400           END-PERFORM
189500         END-EVALUATE
189600         EVALUATE TRUE
189700           WHEN X-MM04-BILL IS EQUAL TO 2
189800           PERFORM
189900             VARYING X-MMMM-TAT FROM 1 BY 1
190000             UNTIL X-MMMM-TAT IS GREATER THAN 16
190100             IF  MMMM-TAT-ACCOUNT (X-MMMM-TAT)
190200                                 IS EQUAL TO 'B2'
190300                 MOVE DFHBMUBF   TO MM04-BILL-USE-FLAG-A
190400                                    (X-MM04-BILL)
190500                 MOVE 'Y'        TO SS08WS-ERROR
190600                 MOVE DFHBMASB   TO MM04-BILL-USE-FLAG-LP-A
190700                                    (X-MM04-BILL)
190800                                    MM04-BILL-USE-FLAG-RP-A
190900                                    (X-MM04-BILL)
191000                 MOVE SS08WS-CURSOR TO MM04-BILL-USE-FLAG-L
191100                                    (X-MM04-BILL)
191200             END-IF
191300           END-PERFORM
191400         END-EVALUATE
191500         EVALUATE TRUE
191600           WHEN X-MM04-BILL IS EQUAL TO 3
191700           PERFORM
191800             VARYING X-MMMM-TAT FROM 1 BY 1
191900             UNTIL X-MMMM-TAT IS GREATER THAN 16
192000             IF  MMMM-TAT-ACCOUNT (X-MMMM-TAT)
192100                                 IS EQUAL TO 'B3'
192200                 MOVE DFHBMUBF   TO MM04-BILL-USE-FLAG-A
192300                                    (X-MM04-BILL)
192400                 MOVE 'Y'        TO SS08WS-ERROR
192500                 MOVE DFHBMASB   TO MM04-BILL-USE-FLAG-LP-A
192600                                    (X-MM04-BILL)
192700                                    MM04-BILL-USE-FLAG-RP-A
192800                                    (X-MM04-BILL)
192900                 MOVE SS08WS-CURSOR TO MM04-BILL-USE-FLAG-L
193000                                  (X-MM04-BILL)
193100             END-IF
193200           END-PERFORM
193300         END-EVALUATE
193400         EVALUATE TRUE
193500           WHEN X-MM04-BILL IS EQUAL TO 4
193600           PERFORM
193700             VARYING X-MMMM-TAT FROM 1 BY 1
193800             UNTIL X-MMMM-TAT IS GREATER THAN 16
193900             IF  MMMM-TAT-ACCOUNT (X-MMMM-TAT)
194000                                 IS EQUAL TO 'B4'
194100                 MOVE DFHBMUBF   TO MM04-BILL-USE-FLAG-A
194200                                    (X-MM04-BILL)
194300                 MOVE 'Y'        TO SS08WS-ERROR
194400                 MOVE DFHBMASB   TO MM04-BILL-USE-FLAG-LP-A
194500                                    (X-MM04-BILL)
194600                                    MM04-BILL-USE-FLAG-RP-A
194700                                    (X-MM04-BILL)
194800                 MOVE SS08WS-CURSOR TO MM04-BILL-USE-FLAG-L
194900                                    (X-MM04-BILL)
195000             END-IF
195100           END-PERFORM
195200         END-EVALUATE
195300       END-IF
195400     END-PERFORM.
195500*
195600 W529-BCE-EXIT.
195700     EXIT.
195800/
195900 X000-UPDATE-FIELDS SECTION.
196000*
196100 X010-UPDATE-RESV-FREQ.
196200*
196300     MOVE MMMMTB-RESV-FREQ-1 (1:4)
196400                                 TO WS-INDEX-X.
196500     SET X-MMFS-MERCH            TO WS-INDEX.
196600     SET X-MM04-RESV             TO 1.
196700     SET X-MMMM-RESV             TO 1.
196800*
196900 X011-URF-LOOP.
197000*
197100     IF  MM04-RESV-FREQ-L (X-MM04-RESV)
197200         IS GREATER THAN ZERO
197300         IF  MM04-RESV-FREQ (X-MM04-RESV) IS NOT EQUAL TO
197400             MMMM-RESV-FREQ (X-MMMM-RESV)
197500             MOVE 'Y'            TO WS-UPDATE-SW
197600             IF  MBCA-PTI-FUNCTION-IS-MAINT
197700                 MOVE MMFS-MT-AUDIT-CODE (X-MMFS-MERCH)
197800                                 TO MML1-MMMM-AUDIT-CODE
197900                 MOVE 0401       TO MML1-FIELD-CODE
198000                 SET MML1-FIELD-OCCURRENCE
198100                                 TO X-MMMM-RESV
198200                 MOVE ZEROES     TO MML1-FIELD-OCCURRENCE-2
198300                 MOVE MML1WS-VL-01
198400                                 TO MML1-VARIABLE-LENGTH
198500                 MOVE MMMM-RESV-FREQ (X-MMMM-RESV)
198600                                 TO MML1-VL01-B-DATA-X
198700                 MOVE MM04-RESV-FREQ (X-MM04-RESV)
198800                                 TO MMMM-RESV-FREQ
198900                                          (X-MMMM-RESV)
199000                 MOVE MMMM-RESV-FREQ (X-MMMM-RESV)
199100                                 TO MML1-VL01-A-DATA-X
199200                 MOVE 'FC13'     TO MBCA-PROGRAM-LOCATION
199300                 PERFORM Y920-WRITE-LOG-RECORD
199400                                 THRU Y929-WLR-EXIT
199500             ELSE
199600                 MOVE MM04-RESV-FREQ (X-MM04-RESV)
199700                                 TO MMMM-RESV-FREQ
199800                                          (X-MMMM-RESV).
199900*
200000 X018-INCREMENT-INDEXES.
200100*
200200     IF  X-MM04-RESV IS LESS THAN 4
200300         SET X-MM04-RESV         UP BY 1
200400         SET X-MMMM-RESV         UP BY 1
200500         SET X-MMFS-MERCH        UP BY 7
200600         GO TO X011-URF-LOOP.
200700*
200800 X019-EXIT.
200900     EXIT.
201000*
201100 X030-UPDATE-RESV-RATE-TABLE.
201200*
201300     MOVE MMMMTB-RESV-RATE-TABLE-1 (1:4)
201400                                 TO WS-INDEX-X.
201500     SET X-MMFS-MERCH            TO WS-INDEX.
201600     SET X-MM04-RESV             TO 1.
201700     SET X-MMMM-RESV             TO 1.
201800*
201900 X031-URRT-LOOP.
202000*
202100     IF  MM04-RESV-RATE-TABLE-L (X-MM04-RESV)
202200         IS GREATER THAN ZERO
202300         IF  MM04-RESV-RATE-TABLE (X-MM04-RESV) IS NOT EQUAL TO
202400             MMMM-RESV-RATE-TABLE (X-MMMM-RESV)
202500             MOVE 'Y'            TO WS-UPDATE-SW
202600             IF  MBCA-PTI-FUNCTION-IS-MAINT
202700                 MOVE MMFS-MT-AUDIT-CODE (X-MMFS-MERCH)
202800                                 TO MML1-MMMM-AUDIT-CODE
202900                 MOVE 0402       TO MML1-FIELD-CODE
203000                 SET MML1-FIELD-OCCURRENCE
203100                                 TO X-MMMM-RESV
203200                 MOVE ZEROES     TO MML1-FIELD-OCCURRENCE-2
203300                 MOVE MML1WS-VL-10
203400                                 TO MML1-VARIABLE-LENGTH
203500                 MOVE MMMM-RESV-RATE-TABLE (X-MMMM-RESV)
203600                                 TO MML1-VL10-B-DATA-9
203700                 MOVE MM04-RESV-RATE-TABLE (X-MM04-RESV)
203800                                 TO MMMM-RESV-RATE-TABLE
203900                                        (X-MMMM-RESV)
204000                 MOVE MMMM-RESV-RATE-TABLE (X-MMMM-RESV)
204100                                 TO MML1-VL10-A-DATA-9
204200                 MOVE 'FC14'     TO MBCA-PROGRAM-LOCATION
204300                 PERFORM Y920-WRITE-LOG-RECORD
204400                                 THRU Y929-WLR-EXIT
204500             ELSE
204600                 MOVE MM04-RESV-RATE-TABLE (X-MM04-RESV)
204700                                 TO MMMM-RESV-RATE-TABLE
204800                                        (X-MMMM-RESV).
204900*
205000 X038-INCREMENT-INDEXES.
205100*
205200     IF  X-MM04-RESV IS LESS THAN 4
205300         SET X-MM04-RESV         UP BY 1
205400         SET X-MMMM-RESV         UP BY 1
205500         SET X-MMFS-MERCH        UP BY 7
205600         GO TO X031-URRT-LOOP.
205700*
205800 X039-EXIT.
205900     EXIT.
206000*
206100 X050-UPDATE-RESV-DESC.
206200*
206300     MOVE MMMMTB-RESV-DESC-1 (1:4)
206400                                 TO WS-INDEX-X.
206500     SET X-MMFS-MERCH            TO WS-INDEX.
206600     SET X-MM04-RESV             TO 1.
206700     SET X-MMMM-RESV             TO 1.
206800*
206900 X051-UD-LOOP.
207000*
207100     IF  MM04-RESV-DESC-L (X-MM04-RESV)
207200         IS GREATER THAN ZERO
207300         IF  MM04-RESV-DESC (X-MM04-RESV) IS NOT EQUAL TO
207400             MMMM-RESV-DESC (X-MMMM-RESV)
207500             MOVE 'Y'            TO WS-UPDATE-SW
207600             IF  MBCA-PTI-FUNCTION-IS-MAINT
207700                 MOVE MMFS-MT-AUDIT-CODE (X-MMFS-MERCH)
207800                                 TO MML1-MMMM-AUDIT-CODE
207900                 MOVE 0403       TO MML1-FIELD-CODE
208000                 SET MML1-FIELD-OCCURRENCE
208100                                 TO X-MMMM-RESV
208200                 MOVE ZEROES     TO MML1-FIELD-OCCURRENCE-2
208300                 MOVE MML1WS-VL-30
208400                                 TO MML1-VARIABLE-LENGTH
208500                 MOVE MMMM-RESV-DESC    (X-MMMM-RESV)
208600                                 TO MML1-VL30-B-DATA-X
208700                 MOVE MM04-RESV-DESC    (X-MM04-RESV)
208800                                 TO MMMM-RESV-DESC
208900                                        (X-MMMM-RESV)
209000                 MOVE MMMM-RESV-DESC (X-MMMM-RESV)
209100                                 TO MML1-VL30-A-DATA-X
209200                 MOVE 'FC15'     TO MBCA-PROGRAM-LOCATION
209300                 PERFORM Y920-WRITE-LOG-RECORD
209400                                 THRU Y929-WLR-EXIT
209500             ELSE
209600                 MOVE MM04-RESV-DESC    (X-MM04-RESV)
209700                                 TO MMMM-RESV-DESC
209800                                        (X-MMMM-RESV).
209900*
210000 X058-INCREMENT-INDEXES.
210100*
210200     IF  X-MM04-RESV IS LESS THAN 4
210300         SET X-MM04-RESV         UP BY 1
210400         SET X-MMMM-RESV         UP BY 1
210500         SET X-MMFS-MERCH        UP BY 7
210600         GO TO X051-UD-LOOP.
210700*
210800 X059-EXIT.
210900     EXIT.
211000*
211100 X070-UPDATE-RESV-LEVEL.
211200*
211300     MOVE MMMMTB-RESV-LEVEL-1 (1:4)
211400                                 TO WS-INDEX-X.
211500     SET X-MMFS-MERCH            TO WS-INDEX.
211600     SET X-MM04-RESV             TO 1.
211700     SET X-MMMM-RESV             TO 1.
211800*
211900 X071-URL-LOOP.
212000*
212100     IF  MM04-RESV-LEVEL-L (X-MM04-RESV)
212200         IS GREATER THAN ZERO
212300         IF  MM04-RESV-LEVEL (X-MM04-RESV) IS NOT EQUAL TO
212400             MMMM-RESV-LEVEL (X-MMMM-RESV)
212500             MOVE 'Y'            TO WS-UPDATE-SW
212600             IF  MBCA-PTI-FUNCTION-IS-MAINT
212700                 MOVE MMFS-MT-AUDIT-CODE (X-MMFS-MERCH)
212800                                 TO MML1-MMMM-AUDIT-CODE
212900                 MOVE 0404       TO MML1-FIELD-CODE
213000                 SET MML1-FIELD-OCCURRENCE
213100                                 TO X-MMMM-RESV
213200                 MOVE ZEROES     TO MML1-FIELD-OCCURRENCE-2
213300                 MOVE MML1WS-VL-01
213400                                 TO MML1-VARIABLE-LENGTH
213500                 MOVE MMMM-RESV-LEVEL (X-MMMM-RESV)
213600                                 TO MML1-VL01-B-DATA-X
213700                 MOVE MM04-RESV-LEVEL (X-MM04-RESV)
213800                                 TO MMMM-RESV-LEVEL
213900                                        (X-MMMM-RESV)
214000                 MOVE MMMM-RESV-LEVEL (X-MMMM-RESV)
214100                                 TO MML1-VL01-A-DATA-X
214200                 MOVE 'FC16'     TO MBCA-PROGRAM-LOCATION
214300                 PERFORM Y920-WRITE-LOG-RECORD
214400                                 THRU Y929-WLR-EXIT
214500             ELSE
214600                 MOVE MM04-RESV-LEVEL (X-MM04-RESV)
214700                                 TO MMMM-RESV-LEVEL
214800                                        (X-MMMM-RESV).
214900*
215000 X078-INCREMENT-INDEXES.
215100*
215200     IF  X-MM04-RESV IS LESS THAN 4
215300         SET X-MM04-RESV         UP BY 1
215400         SET X-MMMM-RESV         UP BY 1
215500         SET X-MMFS-MERCH        UP BY 7
215600         GO TO X071-URL-LOOP.
215700*
215800 X079-EXIT.
215900     EXIT.
216000*
216100 X090-UPDATE-RESV-FEE-BASE.
216200*
216300     MOVE MMMMTB-RESV-FEE-BASE-1 (1:4)
216400                                 TO WS-INDEX-X.
216500     SET X-MMFS-MERCH            TO WS-INDEX.
216600     SET X-MM04-RESV             TO 1.
216700     SET X-MMMM-RESV             TO 1.
216800*
216900 X091-URFB-LOOP.
217000*
217100     IF  MM04-RESV-FEE-BASE-L (X-MM04-RESV)
217200         IS GREATER THAN ZERO
217300         IF  MM04-RESV-FEE-BASE (X-MM04-RESV) IS NOT EQUAL TO
217400             MMMM-RESV-FEE-BASE (X-MMMM-RESV)
217500             MOVE 'Y'            TO WS-UPDATE-SW
217600             IF  MBCA-PTI-FUNCTION-IS-MAINT
217700                 MOVE MMFS-MT-AUDIT-CODE (X-MMFS-MERCH)
217800                                 TO MML1-MMMM-AUDIT-CODE
217900                 MOVE 0405       TO MML1-FIELD-CODE
218000                 SET MML1-FIELD-OCCURRENCE
218100                                 TO X-MMMM-RESV
218200                 MOVE ZEROES     TO MML1-FIELD-OCCURRENCE-2
218300                 MOVE MML1WS-VL-01
218400                                 TO MML1-VARIABLE-LENGTH
218500                 MOVE MMMM-RESV-FEE-BASE (X-MMMM-RESV)
218600                                 TO MML1-VL01-B-DATA-X
218700                 MOVE MM04-RESV-FEE-BASE (X-MM04-RESV)
218800                                 TO MMMM-RESV-FEE-BASE
218900                                        (X-MMMM-RESV)
219000                 MOVE MMMM-RESV-FEE-BASE (X-MMMM-RESV)
219100                                 TO MML1-VL01-A-DATA-X
219200                 MOVE 'FC17'     TO MBCA-PROGRAM-LOCATION
219300                 PERFORM Y920-WRITE-LOG-RECORD
219400                                 THRU Y929-WLR-EXIT
219500             ELSE
219600                 MOVE MM04-RESV-FEE-BASE (X-MM04-RESV)
219700                                 TO MMMM-RESV-FEE-BASE
219800                                        (X-MMMM-RESV).
219900*
220000 X098-INCREMENT-INDEXES.
220100*
220200     IF  X-MM04-RESV IS LESS THAN 4
220300         SET X-MM04-RESV         UP BY 1
220400         SET X-MMMM-RESV         UP BY 1
220500         SET X-MMFS-MERCH        UP BY 7
220600         GO TO X091-URFB-LOOP.
220700*
220800 X099-EXIT.
220900     EXIT.
221000*
221100 X110-UPDATE-RESV-FLOOR.
221200*
221300     MOVE MMMMTB-RESV-FLOOR-1 (1:4)
221400                                 TO WS-INDEX-X.
221500     SET X-MMFS-MERCH            TO WS-INDEX.
221600     SET X-MM04-RESV             TO 1.
221700     SET X-MMMM-RESV             TO 1.
221800*
221900 X161-UF-LOOP.
222000*
222100     IF  MM04-RESV-FLOOR-L (X-MM04-RESV)
222200         IS GREATER THAN ZERO
222300         IF  MM04-RESV-FLOOR (X-MM04-RESV) IS NOT EQUAL TO
222400             MMMM-RESV-FLOOR (X-MMMM-RESV)
222500             MOVE 'Y'            TO WS-UPDATE-SW
222600             IF  MBCA-PTI-FUNCTION-IS-MAINT
222700                 MOVE MMFS-MT-AUDIT-CODE (X-MMFS-MERCH)
222800                                 TO MML1-MMMM-AUDIT-CODE
222900                 MOVE 0406       TO MML1-FIELD-CODE
223000                 SET MML1-FIELD-OCCURRENCE
223100                                 TO X-MMMM-RESV
223200                 MOVE ZEROES     TO MML1-FIELD-OCCURRENCE-2
223300                 MOVE MML1WS-VL-20
223400                                 TO MML1-VARIABLE-LENGTH
223500                 MOVE MMMM-RESV-FLOOR   (X-MMMM-RESV)
223600                                 TO MML1-VL20-B-NBR-NO-DEC
223700                 MOVE MM04-RESV-FLOOR   (X-MM04-RESV)
223800                                 TO MMMM-RESV-FLOOR
223900                                        (X-MMMM-RESV)
224000                 MOVE MMMM-RESV-FLOOR (X-MMMM-RESV)
224100                                 TO MML1-VL20-A-NBR-NO-DEC
224200                 MOVE 'FC18'     TO MBCA-PROGRAM-LOCATION
224300                 PERFORM Y920-WRITE-LOG-RECORD
224400                                 THRU Y929-WLR-EXIT
224500             ELSE
224600                 MOVE MM04-RESV-FLOOR   (X-MM04-RESV)
224700                                 TO MMMM-RESV-FLOOR
224800                                        (X-MMMM-RESV).
224900*
225000 X118-INCREMENT-INDEXES.
225100*
225200     IF  X-MM04-RESV IS LESS THAN 4
225300         SET X-MM04-RESV         UP BY 1
225400         SET X-MMMM-RESV         UP BY 1
225500         SET X-MMFS-MERCH        UP BY 7
225600         GO TO X161-UF-LOOP.
225700*
225800 X119-EXIT.
225900     EXIT.
226000*
226100 X130-UPDATE-RESV-CEILING.
226200*
226300     MOVE MMMMTB-RESV-CEILING-1 (1:4)
226400                                 TO WS-INDEX-X.
226500     SET X-MMFS-MERCH            TO WS-INDEX.
226600     SET X-MM04-RESV             TO 1.
226700     SET X-MMMM-RESV             TO 1.
226800*
226900 X131-UC-LOOP.
227000*
227100     IF  MM04-RESV-CEILING-L (X-MM04-RESV)
227200         IS GREATER THAN ZERO
227300         IF  MM04-RESV-CEILING (X-MM04-RESV) IS NOT EQUAL TO
227400             MMMM-RESV-CEILING (X-MMMM-RESV)
227500             MOVE 'Y'            TO WS-UPDATE-SW
227600             IF  MBCA-PTI-FUNCTION-IS-MAINT
227700                 MOVE MMFS-MT-AUDIT-CODE (X-MMFS-MERCH)
227800                                 TO MML1-MMMM-AUDIT-CODE
227900                 MOVE 0407       TO MML1-FIELD-CODE
228000                 SET MML1-FIELD-OCCURRENCE
228100                                 TO X-MMMM-RESV
228200                 MOVE ZEROES     TO MML1-FIELD-OCCURRENCE-2
228300                 MOVE MML1WS-VL-20
228400                                 TO MML1-VARIABLE-LENGTH
228500                 MOVE MMMM-RESV-CEILING (X-MMMM-RESV)
228600                                 TO MML1-VL20-B-NBR-NO-DEC
228700                 MOVE MM04-RESV-CEILING (X-MM04-RESV)
228800                                 TO MMMM-RESV-CEILING
228900                                        (X-MMMM-RESV)
229000                 MOVE MMMM-RESV-CEILING (X-MMMM-RESV)
229100                                 TO MML1-VL20-A-NBR-NO-DEC
229200                 MOVE 'FC19'     TO MBCA-PROGRAM-LOCATION
229300                 PERFORM Y920-WRITE-LOG-RECORD
229400                                 THRU Y929-WLR-EXIT
229500             ELSE
229600                 MOVE MM04-RESV-CEILING (X-MM04-RESV)
229700                                 TO MMMM-RESV-CEILING
229800                                        (X-MMMM-RESV).
229900*
230000 X138-INCREMENT-INDEXES.
230100*
230200     IF  X-MM04-RESV IS LESS THAN 4
230300         SET X-MM04-RESV         UP BY 1
230400         SET X-MMMM-RESV         UP BY 1
230500         SET X-MMFS-MERCH        UP BY 7
230600         GO TO X131-UC-LOOP.
230700*
230800 X139-EXIT.
230900     EXIT.
231000*
231100 X150-UPDATE-BILL-USE-FLAG.
231200*
231300     MOVE MMMMTB-BILL-USE-FLAG-1 (1:4)
231400                                 TO WS-INDEX-X.
231500     SET X-MMFS-MERCH            TO WS-INDEX.
231600     SET X-MM04-BILL             TO 1.
231700     SET X-MMMM-BILL             TO 1.
231800*
231900 X151-UBUF-LOOP.
232000*
232100     IF  MM04-BILL-USE-FLAG-L (X-MM04-BILL)
232200         IS GREATER THAN ZERO
232300         IF  MM04-BILL-USE-FLAG (X-MM04-BILL) IS NOT EQUAL TO
232400             MMMM-BILL-USE-FLAG (X-MMMM-BILL)
232500             MOVE 'Y'            TO WS-UPDATE-SW
232600             IF  MBCA-PTI-FUNCTION-IS-MAINT
232700                 MOVE MMFS-MT-AUDIT-CODE (X-MMFS-MERCH)
232800                                 TO MML1-MMMM-AUDIT-CODE
232900                 MOVE 0408       TO MML1-FIELD-CODE
233000                 SET MML1-FIELD-OCCURRENCE
233100                                 TO X-MMMM-BILL
233200                 MOVE ZEROES     TO MML1-FIELD-OCCURRENCE-2
233300                 MOVE MML1WS-VL-01
233400                                 TO MML1-VARIABLE-LENGTH
233500                 MOVE MMMM-BILL-USE-FLAG (X-MMMM-BILL)
233600                                 TO MML1-VL01-B-DATA-X
233700                 MOVE MM04-BILL-USE-FLAG (X-MM04-BILL)
233800                                 TO MMMM-BILL-USE-FLAG
233900                                        (X-MMMM-BILL)
234000                 MOVE MMMM-BILL-USE-FLAG (X-MMMM-BILL)
234100                                 TO MML1-VL01-A-DATA-X
234200                 MOVE 'FC20'     TO MBCA-PROGRAM-LOCATION
234300                 PERFORM Y920-WRITE-LOG-RECORD
234400                                 THRU Y929-WLR-EXIT
234500             ELSE
234600                 MOVE MM04-BILL-USE-FLAG (X-MM04-BILL)
234700                                 TO MMMM-BILL-USE-FLAG
234800                                        (X-MMMM-BILL).
234900*
235000 X158-INCREMENT-INDEXES.
235100*
235200     IF  X-MM04-BILL IS LESS THAN 4
235300         SET X-MM04-BILL         UP BY 1
235400         SET X-MMMM-BILL         UP BY 1
235500         SET X-MMFS-MERCH        UP BY 3
235600         GO TO X151-UBUF-LOOP.
235700*
235800 X159-EXIT.
235900     EXIT.
236000*
236100 X170-UPDATE-BILLING-ORG.
236200*
236300     MOVE MMMMTB-BILLING-ORG-1 (1:4)
236400                                 TO WS-INDEX-X.
236500     SET X-MMFS-MERCH            TO WS-INDEX.
236600     SET X-MM04-BILL             TO 1.
236700     SET X-MMMM-BILL             TO 1.
236800*
236900 X171-UBO-LOOP.
237000*
237100     IF  MM04-BILLING-ORG-L (X-MM04-BILL)
237200         IS GREATER THAN ZERO
237300         IF  MM04-BILLING-ORG (X-MM04-BILL) IS NOT EQUAL TO
237400             MMMM-BILLING-ORG (X-MMMM-BILL)
237500             MOVE 'Y'            TO WS-UPDATE-SW
237600             IF  MBCA-PTI-FUNCTION-IS-MAINT
237700                 MOVE MMFS-MT-AUDIT-CODE (X-MMFS-MERCH)
237800                                 TO MML1-MMMM-AUDIT-CODE
237900                 MOVE 0409       TO MML1-FIELD-CODE
238000                 SET MML1-FIELD-OCCURRENCE
238100                                 TO X-MMMM-BILL
238200                 MOVE ZEROES     TO MML1-FIELD-OCCURRENCE-2
238300                 MOVE MML1WS-VL-03
238400                                 TO MML1-VARIABLE-LENGTH
238500                 MOVE MMMM-BILLING-ORG (X-MMMM-BILL)
238600                                 TO MML1-VL03-B-DATA-9
238700                 MOVE MM04-BILLING-ORG (X-MM04-BILL)
238800                                 TO MMMM-BILLING-ORG
238900                                        (X-MMMM-BILL)
239000                 MOVE MMMM-BILLING-ORG (X-MMMM-BILL)
239100                                 TO MML1-VL03-A-DATA-9
239200                 MOVE 'FC21'     TO MBCA-PROGRAM-LOCATION
239300                 PERFORM Y920-WRITE-LOG-RECORD
239400                                 THRU Y929-WLR-EXIT
239500             ELSE
239600                 MOVE MM04-BILLING-ORG (X-MM04-BILL)
239700                                 TO MMMM-BILLING-ORG
239800                                        (X-MMMM-BILL).
239900*
240000 X178-INCREMENT-INDEXES.
240100*
240200     IF  X-MM04-BILL IS LESS THAN 4
240300         SET X-MM04-BILL         UP BY 1
240400         SET X-MMMM-BILL         UP BY 1
240500         SET X-MMFS-MERCH        UP BY 3
240600         GO TO X171-UBO-LOOP.
240700*
240800 X179-EXIT.
240900     EXIT.
241000*
241100 X190-UPDATE-BILLING-ACCT.
241200*
241300     MOVE MMMMTB-BILLING-ACCT-1 (1:4)
241400                                 TO WS-INDEX-X.
241500     SET X-MMFS-MERCH            TO WS-INDEX.
241600     SET X-MM04-BILL             TO 1.
241700     SET X-MMMM-BILL             TO 1.
241800*
241900 X191-UBA-LOOP.
242000*
242100     IF  MM04-BILLING-ACCT-L (X-MM04-BILL)
242200         IS GREATER THAN ZERO
242300         IF  MM04-BILLING-ACCT (X-MM04-BILL) IS NOT EQUAL TO
242400             MMMM-BILLING-ACCT (X-MMMM-BILL)
242500             MOVE 'Y'            TO WS-UPDATE-SW
242600             IF  MBCA-PTI-FUNCTION-IS-MAINT
242700                 MOVE MMFS-MT-AUDIT-CODE (X-MMFS-MERCH)
242800                                 TO MML1-MMMM-AUDIT-CODE
242900                 MOVE 0410       TO MML1-FIELD-CODE
243000                 SET MML1-FIELD-OCCURRENCE
243100                                 TO X-MMMM-BILL
243200                 MOVE ZEROES     TO MML1-FIELD-OCCURRENCE-2
243300                 MOVE MML1WS-VL-20
243400                                 TO MML1-VARIABLE-LENGTH
243500                 MOVE MMMM-BILLING-ACCT (X-MMMM-BILL)
243600                                 TO MML1-VL20-B-DATA-X
243700                 MOVE MM04-BILLING-ACCT (X-MM04-BILL)
243800                                 TO MMMM-BILLING-ACCT
243900                                        (X-MMMM-BILL)
244000                 MOVE MMMM-BILLING-ACCT (X-MMMM-BILL)
244100                                 TO MML1-VL20-A-DATA-X
244200                 MOVE 'FC22'     TO MBCA-PROGRAM-LOCATION
244300                 PERFORM Y920-WRITE-LOG-RECORD
244400                                 THRU Y929-WLR-EXIT
244500             ELSE
244600                 MOVE MM04-BILLING-ACCT (X-MM04-BILL)
244700                                 TO MMMM-BILLING-ACCT
244800                                        (X-MMMM-BILL).
244900*
245000 X198-INCREMENT-INDEXES.
245100*
245200     IF  X-MM04-BILL IS LESS THAN 4
245300         SET X-MM04-BILL         UP BY 1
245400         SET X-MMMM-BILL         UP BY 1
245500         SET X-MMFS-MERCH        UP BY 3
245600         GO TO X191-UBA-LOOP.
245700*
245800 X199-EXIT.
245900     EXIT.
246000/
246100 Y000-PERFORMED-ROUTINES SECTION.
246200*
246300 Y010-MOVE-RESV-FREQ.
246400*
246500     SET X-MM04-RESV             TO 1.
246600     SET X-MMMM-RESV             TO 1.
246700     MOVE MMMMTB-RESV-FREQ-1 (1:4)
246800                                 TO WS-INDEX-X.
246900     SET X-MMFS-MERCH            TO WS-INDEX.
247000*
247100 Y011-MSF-LOOP.
247200*
247300     MOVE MMMM-RESV-FREQ (X-MMMM-RESV)
247400                                 TO MM04-RESV-FREQ (X-MM04-RESV).
247500*
247600 Y015-RESV-FREQ-SECURITY.
247700*
247800     IF  MMFS-MT-NO-ACCESS (X-MMFS-MERCH)
247900*
248000*
248100         MOVE DFHBMDAS           TO MM04-RESV-FREQ-A
248200                                        (X-MM04-RESV)
248300                                    MM04-RESV-FREQ-LP-A
248400                                        (X-MM04-RESV)
248500                                    MM04-RESV-FREQ-RP-A
248600                                        (X-MM04-RESV)
248700                                    MM04-RESV-FREQ-A
248800                                        (X-MM04-RESV)
248900         MOVE ZERO               TO MM04-RESV-FREQ-L
249000                                        (X-MM04-RESV)
249100         GO TO Y016-EXIT.
249200*
249300     IF  MBCA-PTI-FUNCTION-IS-INQUIRY
249400         MOVE DFHBMDAS           TO MM04-RESV-FREQ-LP-A
249500                                        (X-MM04-RESV)
249600                                    MM04-RESV-FREQ-RP-A
249700                                        (X-MM04-RESV)
249800         MOVE DFHBMASB           TO MM04-RESV-FREQ-A
249900                                        (X-MM04-RESV)
250000         GO TO Y016-EXIT.
250100*
250200     IF  MMFS-MT-INQ-ONLY (X-MMFS-MERCH)
250300         MOVE ZERO               TO MM04-RESV-FREQ-L
250400                                        (X-MM04-RESV)
250500         MOVE DFHBMDAS           TO MM04-RESV-FREQ-LP-A
250600                                        (X-MM04-RESV)
250700                                    MM04-RESV-FREQ-RP-A
250800                                        (X-MM04-RESV)
250900         MOVE DFHBMASK           TO MM04-RESV-FREQ-A
251000                                        (X-MM04-RESV)
251100         GO TO Y016-EXIT.
251200*
251300     IF  MBCA-PTI-FUNCTION-IS-ADD
251400         IF  MMFS-MT-REQUIRED (X-MMFS-MERCH)
251500             MOVE DFHBMASB       TO MM04-RESV-FREQ-LIT-A
251600                                        (X-MM04-RESV)
251700         ELSE
251800             IF  MMFS-MT-MAINT-ONLY (X-MMFS-MERCH)
251900                 MOVE ZERO       TO MM04-RESV-FREQ-L
252000                                        (X-MM04-RESV)
252100                 MOVE DFHBMDAS   TO MM04-RESV-FREQ-LP-A
252200                                        (X-MM04-RESV)
252300                                    MM04-RESV-FREQ-RP-A
252400                                        (X-MM04-RESV)
252500                 MOVE DFHBMASK   TO MM04-RESV-FREQ-A
252600                                        (X-MM04-RESV).
252700*
252800     IF  MBCA-PTI-FUNCTION-IS-MAINT
252900         IF  MMFS-MT-NO-MAINT (X-MMFS-MERCH)
253000             MOVE ZERO           TO MM04-RESV-FREQ-L
253100                                        (X-MM04-RESV)
253200             MOVE DFHBMDAS       TO MM04-RESV-FREQ-LP-A
253300                                        (X-MM04-RESV)
253400                                    MM04-RESV-FREQ-RP-A
253500                                        (X-MM04-RESV)
253600             MOVE DFHBMASK       TO MM04-RESV-FREQ-A
253700                                        (X-MM04-RESV).
253800*
253900 Y016-EXIT.
254000     EXIT.
254100*
254200 Y018-INCREMENT-INDEX.
254300*
254400     IF  X-MM04-RESV IS LESS THAN 4
254500         SET X-MM04-RESV         UP BY 1
254600         SET X-MMMM-RESV         UP BY 1
254700         SET X-MMFS-MERCH        UP BY 7
254800         GO TO Y011-MSF-LOOP.
254900*
255000 Y019-EXIT.
255100     EXIT.
255200*
255300 Y030-MOVE-RESV-RATE-TABLE.
255400*
255500     SET X-MM04-RESV             TO 1.
255600     SET X-MMMM-RESV             TO 1.
255700     MOVE MMMMTB-RESV-RATE-TABLE-1 (1:4)
255800                                 TO WS-INDEX-X.
255900     SET X-MMFS-MERCH            TO WS-INDEX.
256000*
256100 Y031-MRRT-LOOP.
256200*
256300     MOVE MMMM-RESV-RATE-TABLE (X-MMMM-RESV)
256400                                 TO MM04-RESV-RATE-TABLE
256500                                        (X-MM04-RESV).
256600*
256700 Y035-RESV-RATE-TABLE-SECURITY.
256800*
256900     IF  MMFS-MT-NO-ACCESS (X-MMFS-MERCH)
257000         MOVE DFHBMDAS           TO MM04-RESV-RATE-TABLE-LIT-A
257100                                        (X-MM04-RESV)
257200                                    MM04-RESV-RATE-TABLE-LP-A
257300                                        (X-MM04-RESV)
257400                                    MM04-RESV-RATE-TABLE-RP-A
257500                                        (X-MM04-RESV)
257600                                    MM04-RESV-RATE-TABLE-A
257700                                        (X-MM04-RESV)
257800         MOVE ZERO               TO MM04-RESV-RATE-TABLE-L
257900                                        (X-MM04-RESV)
258000         GO TO Y036-EXIT.
258100*
258200     IF  MBCA-PTI-FUNCTION-IS-INQUIRY
258300         MOVE DFHBMDAS           TO MM04-RESV-RATE-TABLE-LP-A
258400                                        (X-MM04-RESV)
258500                                    MM04-RESV-RATE-TABLE-RP-A
258600                                        (X-MM04-RESV)
258700         MOVE DFHBMASB           TO MM04-RESV-RATE-TABLE-A
258800                                        (X-MM04-RESV)
258900         GO TO Y036-EXIT.
259000*
259100     IF  MMFS-MT-INQ-ONLY (X-MMFS-MERCH)
259200         MOVE ZERO               TO MM04-RESV-RATE-TABLE-L
259300                                        (X-MM04-RESV)
259400         MOVE DFHBMDAS           TO MM04-RESV-RATE-TABLE-LP-A
259500                                        (X-MM04-RESV)
259600                                    MM04-RESV-RATE-TABLE-RP-A
259700                                        (X-MM04-RESV)
259800         MOVE DFHBMASK           TO MM04-RESV-RATE-TABLE-A
259900                                        (X-MM04-RESV)
260000         GO TO Y036-EXIT.
260100*
260200     IF  MBCA-PTI-FUNCTION-IS-ADD
260300         IF  MMFS-MT-REQUIRED (X-MMFS-MERCH)
260400             MOVE DFHBMASB       TO MM04-RESV-RATE-TABLE-LIT-A
260500                                        (X-MM04-RESV)
260600         ELSE
260700             IF  MMFS-MT-MAINT-ONLY (X-MMFS-MERCH)
260800                 MOVE ZERO       TO MM04-RESV-RATE-TABLE-L
260900                                        (X-MM04-RESV)
261000                 MOVE DFHBMDAS   TO MM04-RESV-RATE-TABLE-LP-A
261100                                        (X-MM04-RESV)
261200                                    MM04-RESV-RATE-TABLE-RP-A
261300                                        (X-MM04-RESV)
261400                 MOVE DFHBMASK   TO MM04-RESV-RATE-TABLE-A
261500                                        (X-MM04-RESV).
261600*
261700     IF  MBCA-PTI-FUNCTION-IS-MAINT
261800         IF  MMFS-MT-NO-MAINT (X-MMFS-MERCH)
261900             MOVE ZERO           TO MM04-RESV-RATE-TABLE-L
262000                                        (X-MM04-RESV)
262100             MOVE DFHBMDAS       TO MM04-RESV-RATE-TABLE-LP-A
262200                                        (X-MM04-RESV)
262300                                    MM04-RESV-RATE-TABLE-RP-A
262400                                        (X-MM04-RESV)
262500             MOVE DFHBMASK       TO MM04-RESV-RATE-TABLE-A
262600                                        (X-MM04-RESV).
262700*
262800 Y036-EXIT.
262900     EXIT.
263000*
263100 Y038-INCREMENT-INDEX.
263200*
263300     IF  X-MM04-RESV IS LESS THAN 4
263400         SET X-MM04-RESV         UP BY 1
263500         SET X-MMMM-RESV         UP BY 1
263600         SET X-MMFS-MERCH        UP BY 7
263700         GO TO Y031-MRRT-LOOP.
263800*
263900 Y039-EXIT.
264000     EXIT.
264100*
264200 Y050-MOVE-RESV-DESC.
264300*
264400     SET X-MM04-RESV             TO 1.
264500     SET X-MMMM-RESV             TO 1.
264600     MOVE MMMMTB-RESV-DESC-1 (1:4)
264700                                 TO WS-INDEX-X.
264800     SET X-MMFS-MERCH            TO WS-INDEX.
264900*
265000 Y051-MD-LOOP.
265100*
265200     MOVE MMMM-RESV-DESC (X-MMMM-RESV)
265300                                 TO MM04-RESV-DESC
265400                                        (X-MM04-RESV).
265500*
265600 Y055-DESC-SECURITY.
265700*
265800     IF  MMFS-MT-NO-ACCESS (X-MMFS-MERCH)
265900         MOVE DFHBMDAS           TO MM04-RESV-DESC-LIT-A
266000                                        (X-MM04-RESV)
266100                                    MM04-RESV-DESC-LP-A
266200                                        (X-MM04-RESV)
266300                                    MM04-RESV-DESC-RP-A
266400                                        (X-MM04-RESV)
266500                                    MM04-RESV-DESC-A
266600                                        (X-MM04-RESV)
266700         MOVE ZERO               TO MM04-RESV-DESC-L
266800                                        (X-MM04-RESV)
266900         GO TO Y056-EXIT.
267000*
267100     IF  MBCA-PTI-FUNCTION-IS-INQUIRY
267200         MOVE DFHBMDAS           TO MM04-RESV-DESC-LP-A
267300                                        (X-MM04-RESV)
267400                                    MM04-RESV-DESC-RP-A
267500                                        (X-MM04-RESV)
267600         MOVE DFHBMASB           TO MM04-RESV-DESC-A
267700                                        (X-MM04-RESV)
267800         GO TO Y056-EXIT.
267900*
268000     IF  MMFS-MT-INQ-ONLY (X-MMFS-MERCH)
268100         MOVE ZERO               TO MM04-RESV-DESC-L
268200                                        (X-MM04-RESV)
268300         MOVE DFHBMDAS           TO MM04-RESV-DESC-LP-A
268400                                        (X-MM04-RESV)
268500                                    MM04-RESV-DESC-RP-A
268600                                        (X-MM04-RESV)
268700         MOVE DFHBMASK           TO MM04-RESV-DESC-A
268800                                        (X-MM04-RESV)
268900         GO TO Y056-EXIT.
269000*
269100     IF  MBCA-PTI-FUNCTION-IS-ADD
269200         IF  MMFS-MT-REQUIRED (X-MMFS-MERCH)
269300             MOVE DFHBMASB       TO MM04-RESV-DESC-LIT-A
269400                                        (X-MM04-RESV)
269500         ELSE
269600             IF  MMFS-MT-MAINT-ONLY (X-MMFS-MERCH)
269700                 MOVE ZERO       TO MM04-RESV-DESC-L
269800                                        (X-MM04-RESV)
269900                 MOVE DFHBMDAS   TO MM04-RESV-DESC-LP-A
270000                                        (X-MM04-RESV)
270100                                    MM04-RESV-DESC-RP-A
270200                                        (X-MM04-RESV)
270300                 MOVE DFHBMASK   TO MM04-RESV-DESC-A
270400                                        (X-MM04-RESV).
270500*
270600     IF  MBCA-PTI-FUNCTION-IS-MAINT
270700         IF  MMFS-MT-NO-MAINT (X-MMFS-MERCH)
270800             MOVE ZERO           TO MM04-RESV-DESC-L
270900                                        (X-MM04-RESV)
271000             MOVE DFHBMDAS       TO MM04-RESV-DESC-LP-A
271100                                        (X-MM04-RESV)
271200                                    MM04-RESV-DESC-RP-A
271300                                        (X-MM04-RESV)
271400             MOVE DFHBMASK       TO MM04-RESV-DESC-A
271500                                        (X-MM04-RESV).
271600*
271700 Y056-EXIT.
271800     EXIT.
271900*
272000 Y058-INCREMENT-INDEX.
272100*
272200     IF  X-MM04-RESV IS LESS THAN 4
272300         SET X-MM04-RESV         UP BY 1
272400         SET X-MMMM-RESV         UP BY 1
272500         SET X-MMFS-MERCH        UP BY 7
272600         GO TO Y051-MD-LOOP.
272700*
272800 Y059-EXIT.
272900     EXIT.
273000*
273100 Y070-MOVE-RESV-LEVEL.
273200*
273300     SET X-MM04-RESV             TO 1.
273400     SET X-MMMM-RESV             TO 1.
273500     MOVE MMMMTB-RESV-LEVEL-1 (1:4)
273600                                 TO WS-INDEX-X.
273700     SET X-MMFS-MERCH            TO WS-INDEX.
273800*
273900 Y071-MRL-LOOP.
274000*
274100     MOVE MMMM-RESV-LEVEL (X-MMMM-RESV)
274200                                 TO MM04-RESV-LEVEL (X-MM04-RESV).
274300*
274400 Y075-RESV-LEVEL-SECURITY.
274500*
274600     IF  MMFS-MT-NO-ACCESS (X-MMFS-MERCH)
274700         MOVE DFHBMDAS           TO MM04-RESV-LEVEL-LIT-A
274800                                        (X-MM04-RESV)
274900                                    MM04-RESV-LEVEL-A
275000                                        (X-MM04-RESV)
275100                                    MM04-RESV-LEVEL-LP-A
275200                                        (X-MM04-RESV)
275300                                    MM04-RESV-LEVEL-RP-A
275400                                        (X-MM04-RESV)
275500                                    MM04-RESV-LEVEL-A
275600                                        (X-MM04-RESV)
275700         MOVE ZERO               TO MM04-RESV-LEVEL-L
275800                                        (X-MM04-RESV)
275900         GO TO Y076-EXIT.
276000*
276100     IF  MBCA-PTI-FUNCTION-IS-INQUIRY
276200         MOVE DFHBMDAS           TO MM04-RESV-LEVEL-LP-A
276300                                        (X-MM04-RESV)
276400                                    MM04-RESV-LEVEL-RP-A
276500                                        (X-MM04-RESV)
276600         MOVE DFHBMASB           TO MM04-RESV-LEVEL-A
276700                                        (X-MM04-RESV)
276800         GO TO Y076-EXIT.
276900*
277000     IF  MMFS-MT-INQ-ONLY (X-MMFS-MERCH)
277100         MOVE ZERO               TO MM04-RESV-LEVEL-L
277200                                        (X-MM04-RESV)
277300         MOVE DFHBMDAS           TO MM04-RESV-LEVEL-LP-A
277400                                        (X-MM04-RESV)
277500                                    MM04-RESV-LEVEL-RP-A
277600                                        (X-MM04-RESV)
277700         MOVE DFHBMASK           TO MM04-RESV-LEVEL-A
277800                                        (X-MM04-RESV)
277900         GO TO Y076-EXIT.
278000*
278100     IF  MBCA-PTI-FUNCTION-IS-ADD
278200         IF  MMFS-MT-REQUIRED (X-MMFS-MERCH)
278300             MOVE DFHBMASB       TO MM04-RESV-LEVEL-LIT-A
278400                                        (X-MM04-RESV)
278500         ELSE
278600             IF  MMFS-MT-MAINT-ONLY (X-MMFS-MERCH)
278700                 MOVE ZERO       TO MM04-RESV-LEVEL-L
278800                                        (X-MM04-RESV)
278900                 MOVE DFHBMDAS   TO MM04-RESV-LEVEL-LP-A
279000                                        (X-MM04-RESV)
279100                                    MM04-RESV-LEVEL-RP-A
279200                                        (X-MM04-RESV)
279300                 MOVE DFHBMASK   TO MM04-RESV-LEVEL-A
279400                                        (X-MM04-RESV).
279500*
279600     IF  MBCA-PTI-FUNCTION-IS-MAINT
279700         IF  MMFS-MT-NO-MAINT (X-MMFS-MERCH)
279800             MOVE ZERO           TO MM04-RESV-LEVEL-L
279900                                        (X-MM04-RESV)
280000             MOVE DFHBMDAS       TO MM04-RESV-LEVEL-LP-A
280100                                        (X-MM04-RESV)
280200                                    MM04-RESV-LEVEL-RP-A
280300                                        (X-MM04-RESV)
280400             MOVE DFHBMASK       TO MM04-RESV-LEVEL-A
280500                                        (X-MM04-RESV).
280600*
280700 Y076-EXIT.
280800     EXIT.
280900*
281000 Y078-INCREMENT-INDEX.
281100*
281200     IF  X-MM04-RESV IS LESS THAN 4
281300         SET X-MM04-RESV         UP BY 1
281400         SET X-MMMM-RESV         UP BY 1
281500         SET X-MMFS-MERCH        UP BY 7
281600         GO TO Y071-MRL-LOOP.
281700*
281800 Y079-EXIT.
281900     EXIT.
282000*
282100 Y090-MOVE-RESV-FEE-BASE.
282200*
282300     SET X-MM04-RESV             TO 1.
282400     SET X-MMMM-RESV             TO 1.
282500     MOVE MMMMTB-RESV-FEE-BASE-1 (1:4)
282600                                 TO WS-INDEX-X.
282700     SET X-MMFS-MERCH            TO WS-INDEX.
282800*
282900 Y091-MRFB-LOOP.
283000*
283100     MOVE MMMM-RESV-FEE-BASE (X-MMMM-RESV)
283200                                 TO MM04-RESV-FEE-BASE
283300                                    (X-MM04-RESV).
283400*
283500 Y095-RESV-FEE-BASE-SECURITY.
283600*
283700     IF  MMFS-MT-NO-ACCESS (X-MMFS-MERCH)
283800         MOVE DFHBMDAS           TO MM04-RESV-FEE-BASE-LIT-A
283900                                        (X-MM04-RESV)
284000                                    MM04-RESV-FEE-BASE-A
284100                                        (X-MM04-RESV)
284200                                    MM04-RESV-FEE-BASE-LP-A
284300                                        (X-MM04-RESV)
284400                                    MM04-RESV-FEE-BASE-RP-A
284500                                        (X-MM04-RESV)
284600                                    MM04-RESV-FEE-BASE-A
284700                                        (X-MM04-RESV)
284800         MOVE ZERO               TO MM04-RESV-FEE-BASE-L
284900                                        (X-MM04-RESV)
285000         GO TO Y096-EXIT.
285100*
285200     IF  MBCA-PTI-FUNCTION-IS-INQUIRY
285300         MOVE DFHBMDAS           TO MM04-RESV-FEE-BASE-LP-A
285400                                        (X-MM04-RESV)
285500                                    MM04-RESV-FEE-BASE-RP-A
285600                                        (X-MM04-RESV)
285700         MOVE DFHBMASB           TO MM04-RESV-FEE-BASE-A
285800                                        (X-MM04-RESV)
285900         GO TO Y096-EXIT.
286000*
286100     IF  MMFS-MT-INQ-ONLY (X-MMFS-MERCH)
286200         MOVE ZERO               TO MM04-RESV-FEE-BASE-L
286300                                        (X-MM04-RESV)
286400         MOVE DFHBMDAS           TO MM04-RESV-FEE-BASE-LP-A
286500                                        (X-MM04-RESV)
286600                                    MM04-RESV-FEE-BASE-RP-A
286700                                        (X-MM04-RESV)
286800         MOVE DFHBMASK           TO MM04-RESV-FEE-BASE-A
286900                                        (X-MM04-RESV)
287000         GO TO Y096-EXIT.
287100*
287200     IF  MBCA-PTI-FUNCTION-IS-ADD
287300         IF  MMFS-MT-REQUIRED (X-MMFS-MERCH)
287400             MOVE DFHBMASB       TO MM04-RESV-FEE-BASE-LIT-A
287500                                        (X-MM04-RESV)
287600         ELSE
287700             IF  MMFS-MT-MAINT-ONLY (X-MMFS-MERCH)
287800                 MOVE ZERO       TO MM04-RESV-FEE-BASE-L
287900                                        (X-MM04-RESV)
288000                 MOVE DFHBMDAS   TO MM04-RESV-FEE-BASE-LP-A
288100                                        (X-MM04-RESV)
288200                                    MM04-RESV-FEE-BASE-RP-A
288300                                        (X-MM04-RESV)
288400                 MOVE DFHBMASK   TO MM04-RESV-FEE-BASE-A
288500                                        (X-MM04-RESV).
288600*
288700     IF  MBCA-PTI-FUNCTION-IS-MAINT
288800         IF  MMFS-MT-NO-MAINT (X-MMFS-MERCH)
288900             MOVE ZERO           TO MM04-RESV-FEE-BASE-L
289000                                        (X-MM04-RESV)
289100             MOVE DFHBMDAS       TO MM04-RESV-FEE-BASE-LP-A
289200                                        (X-MM04-RESV)
289300                                    MM04-RESV-FEE-BASE-RP-A
289400                                        (X-MM04-RESV)
289500             MOVE DFHBMASK       TO MM04-RESV-FEE-BASE-A
289600                                        (X-MM04-RESV).
289700*
289800 Y096-EXIT.
289900     EXIT.
290000*
290100 Y098-INCREMENT-INDEX.
290200*
290300     IF  X-MM04-RESV IS LESS THAN 4
290400         SET X-MM04-RESV         UP BY 1
290500         SET X-MMMM-RESV         UP BY 1
290600         SET X-MMFS-MERCH        UP BY 7
290700         GO TO Y091-MRFB-LOOP.
290800*
290900 Y099-EXIT.
291000     EXIT.
291100*
291200 Y110-MOVE-RESV-FLOOR.
291300*
291400     SET X-MM04-RESV             TO 1.
291500     SET X-MMMM-RESV             TO 1.
291600     MOVE MMMMTB-RESV-FLOOR-1 (1:4)
291700                                 TO WS-INDEX-X.
291800     SET X-MMFS-MERCH            TO WS-INDEX.
291900*
292000 Y111-MF-LOOP.
292100*
292200     MOVE MMMM-RESV-FLOOR (X-MMMM-RESV)
292300                                 TO MM04-RESV-FLOOR
292400                                        (X-MM04-RESV).
292500*
292600 Y115-FLOOR-SECURITY.
292700*
292800     IF  MMFS-MT-NO-ACCESS (X-MMFS-MERCH)
292900         MOVE DFHBMDAS           TO MM04-RESV-FLOOR-LIT-A
293000                                        (X-MM04-RESV)
293100                                    MM04-RESV-FLOOR-LP-A
293200                                        (X-MM04-RESV)
293300                                    MM04-RESV-FLOOR-RP-A
293400                                        (X-MM04-RESV)
293500                                    MM04-RESV-FLOOR-A
293600                                        (X-MM04-RESV)
293700         MOVE ZERO               TO MM04-RESV-FLOOR-L
293800                                        (X-MM04-RESV)
293900         GO TO Y116-EXIT.
294000*
294100     IF  MBCA-PTI-FUNCTION-IS-INQUIRY
294200         MOVE DFHBMDAS           TO MM04-RESV-FLOOR-LP-A
294300                                        (X-MM04-RESV)
294400                                    MM04-RESV-FLOOR-RP-A
294500                                        (X-MM04-RESV)
294600         MOVE DFHBMASB           TO MM04-RESV-FLOOR-A
294700                                        (X-MM04-RESV)
294800         GO TO Y116-EXIT.
294900*
295000     IF  MMFS-MT-INQ-ONLY (X-MMFS-MERCH)
295100         MOVE ZERO               TO MM04-RESV-FLOOR-L
295200                                        (X-MM04-RESV)
295300         MOVE DFHBMDAS           TO MM04-RESV-FLOOR-LP-A
295400                                        (X-MM04-RESV)
295500                                    MM04-RESV-FLOOR-RP-A
295600                                        (X-MM04-RESV)
295700         MOVE DFHBMASK           TO MM04-RESV-FLOOR-A
295800                                        (X-MM04-RESV)
295900         GO TO Y116-EXIT.
296000*
296100     IF  MBCA-PTI-FUNCTION-IS-ADD
296200         IF  MMFS-MT-REQUIRED (X-MMFS-MERCH)
296300             MOVE DFHBMASB       TO MM04-RESV-FLOOR-LIT-A
296400                                        (X-MM04-RESV)
296500         ELSE
296600             IF  MMFS-MT-MAINT-ONLY (X-MMFS-MERCH)
296700                 MOVE ZERO       TO MM04-RESV-FLOOR-L
296800                                        (X-MM04-RESV)
296900                 MOVE DFHBMDAS   TO MM04-RESV-FLOOR-LP-A
297000                                        (X-MM04-RESV)
297100                                    MM04-RESV-FLOOR-RP-A
297200                                        (X-MM04-RESV)
297300                 MOVE DFHBMASK   TO MM04-RESV-FLOOR-A
297400                                        (X-MM04-RESV).
297500*
297600     IF  MBCA-PTI-FUNCTION-IS-MAINT
297700         IF  MMFS-MT-NO-MAINT (X-MMFS-MERCH)
297800             MOVE ZERO           TO MM04-RESV-FLOOR-L
297900                                        (X-MM04-RESV)
298000             MOVE DFHBMDAS       TO MM04-RESV-FLOOR-LP-A
298100                                        (X-MM04-RESV)
298200                                    MM04-RESV-FLOOR-RP-A
298300                                        (X-MM04-RESV)
298400             MOVE DFHBMASK       TO MM04-RESV-FLOOR-A
298500                                        (X-MM04-RESV).
298600*
298700 Y116-EXIT.
298800     EXIT.
298900*
299000 Y118-INCREMENT-INDEX.
299100*
299200     IF  X-MM04-RESV IS LESS THAN 4
299300         SET X-MM04-RESV         UP BY 1
299400         SET X-MMMM-RESV         UP BY 1
299500         SET X-MMFS-MERCH        UP BY 7
299600         GO TO Y111-MF-LOOP.
299700*
299800 Y119-EXIT.
299900     EXIT.
300000*
300100 Y130-MOVE-RESV-CEILING.
300200*
300300     SET X-MM04-RESV             TO 1.
300400     SET X-MMMM-RESV             TO 1.
300500     MOVE MMMMTB-RESV-CEILING-1 (1:4)
300600                                 TO WS-INDEX-X.
300700     SET X-MMFS-MERCH            TO WS-INDEX.
300800*
300900 Y131-MC-LOOP.
301000*
301100     MOVE MMMM-RESV-CEILING (X-MMMM-RESV)
301200                                 TO MM04-RESV-CEILING
301300                                        (X-MM04-RESV).
301400*
301500 Y135-CEILING-SECURITY.
301600*
301700     IF  MMFS-MT-NO-ACCESS (X-MMFS-MERCH)
301800         MOVE DFHBMDAS           TO MM04-RESV-CEILING-LIT-A
301900                                        (X-MM04-RESV)
302000                                    MM04-RESV-CEILING-LP-A
302100                                        (X-MM04-RESV)
302200                                    MM04-RESV-CEILING-RP-A
302300                                        (X-MM04-RESV)
302400                                    MM04-RESV-CEILING-A
302500                                        (X-MM04-RESV)
302600         MOVE ZERO               TO MM04-RESV-CEILING-L
302700                                        (X-MM04-RESV)
302800         GO TO Y136-EXIT.
302900*
303000     IF  MBCA-PTI-FUNCTION-IS-INQUIRY
303100         MOVE DFHBMDAS           TO MM04-RESV-CEILING-LP-A
303200                                        (X-MM04-RESV)
303300                                    MM04-RESV-CEILING-RP-A
303400                                        (X-MM04-RESV)
303500         MOVE DFHBMASB           TO MM04-RESV-CEILING-A
303600                                        (X-MM04-RESV)
303700         GO TO Y136-EXIT.
303800*
303900     IF  MMFS-MT-INQ-ONLY (X-MMFS-MERCH)
304000         MOVE ZERO               TO MM04-RESV-CEILING-L
304100                                        (X-MM04-RESV)
304200         MOVE DFHBMDAS           TO MM04-RESV-CEILING-LP-A
304300                                        (X-MM04-RESV)
304400                                    MM04-RESV-CEILING-RP-A
304500                                        (X-MM04-RESV)
304600         MOVE DFHBMASK           TO MM04-RESV-CEILING-A
304700                                        (X-MM04-RESV)
304800         GO TO Y136-EXIT.
304900*
305000     IF  MBCA-PTI-FUNCTION-IS-ADD
305100         IF  MMFS-MT-REQUIRED (X-MMFS-MERCH)
305200             MOVE DFHBMASB       TO MM04-RESV-CEILING-LIT-A
305300                                        (X-MM04-RESV)
305400         ELSE
305500             IF  MMFS-MT-MAINT-ONLY (X-MMFS-MERCH)
305600                 MOVE ZERO       TO MM04-RESV-CEILING-L
305700                                        (X-MM04-RESV)
305800                 MOVE DFHBMDAS   TO MM04-RESV-CEILING-LP-A
305900                                        (X-MM04-RESV)
306000                                    MM04-RESV-CEILING-RP-A
306100                                        (X-MM04-RESV)
306200                 MOVE DFHBMASK   TO MM04-RESV-CEILING-A
306300                                        (X-MM04-RESV).
306400*
306500     IF  MBCA-PTI-FUNCTION-IS-MAINT
306600         IF  MMFS-MT-NO-MAINT (X-MMFS-MERCH)
306700             MOVE ZERO           TO MM04-RESV-CEILING-L
306800                                        (X-MM04-RESV)
306900             MOVE DFHBMDAS       TO MM04-RESV-CEILING-LP-A
307000                                        (X-MM04-RESV)
307100                                    MM04-RESV-CEILING-RP-A
307200                                        (X-MM04-RESV)
307300             MOVE DFHBMASK       TO MM04-RESV-CEILING-A
307400                                        (X-MM04-RESV).
307500*
307600 Y136-EXIT.
307700     EXIT.
307800*
307900 Y138-INCREMENT-INDEX.
308000*
308100     IF  X-MM04-RESV IS LESS THAN 4
308200         SET X-MM04-RESV         UP BY 1
308300         SET X-MMMM-RESV         UP BY 1
308400         SET X-MMFS-MERCH        UP BY 7
308500         GO TO Y131-MC-LOOP.
308600*
308700 Y139-EXIT.
308800     EXIT.
308900*
309000 Y150-MOVE-BILL-USE-FLAG.
309100*
309200     SET X-MM04-BILL             TO 1.
309300     SET X-MMMM-BILL             TO 1.
309400     MOVE MMMMTB-BILL-USE-FLAG-1 (1:4)
309500                                 TO WS-INDEX-X.
309600     SET X-MMFS-MERCH            TO WS-INDEX.
309700*
309800 Y151-MBUF-LOOP.
309900*
310000     MOVE MMMM-BILL-USE-FLAG (X-MMMM-BILL)
310100                                 TO MM04-BILL-USE-FLAG
310200                                    (X-MM04-BILL).
310300*
310400 Y155-BILL-USE-FLAG-SECURITY.
310500*
310600     IF  MMFS-MT-NO-ACCESS (X-MMFS-MERCH)
310700         MOVE DFHBMDAS           TO MM04-BILL-USE-FLAG-A
310800                                        (X-MM04-BILL)
310900                                    MM04-BILL-USE-FLAG-LP-A
311000                                        (X-MM04-BILL)
311100                                    MM04-BILL-USE-FLAG-RP-A
311200                                        (X-MM04-BILL)
311300                                    MM04-BILL-USE-FLAG-A
311400                                        (X-MM04-BILL)
311500         MOVE ZERO               TO MM04-BILL-USE-FLAG-L
311600                                        (X-MM04-BILL)
311700         GO TO Y156-EXIT.
311800*
311900     IF  MBCA-PTI-FUNCTION-IS-INQUIRY
312000         MOVE DFHBMDAS           TO MM04-BILL-USE-FLAG-LP-A
312100                                        (X-MM04-BILL)
312200                                    MM04-BILL-USE-FLAG-RP-A
312300                                        (X-MM04-BILL)
312400         MOVE DFHBMASB           TO MM04-BILL-USE-FLAG-A
312500                                        (X-MM04-BILL)
312600         GO TO Y156-EXIT.
312700*
312800     IF  MMFS-MT-INQ-ONLY (X-MMFS-MERCH)
312900         MOVE ZERO               TO MM04-BILL-USE-FLAG-L
313000                                        (X-MM04-BILL)
313100         MOVE DFHBMDAS           TO MM04-BILL-USE-FLAG-LP-A
313200                                        (X-MM04-BILL)
313300                                    MM04-BILL-USE-FLAG-RP-A
313400                                        (X-MM04-BILL)
313500         MOVE DFHBMASK           TO MM04-BILL-USE-FLAG-A
313600                                        (X-MM04-BILL)
313700         GO TO Y156-EXIT.
313800*
313900     IF  MBCA-PTI-FUNCTION-IS-ADD
314000         IF  MMFS-MT-MAINT-ONLY (X-MMFS-MERCH)
314100             MOVE ZERO           TO MM04-BILL-USE-FLAG-L
314200                                        (X-MM04-BILL)
314300             MOVE DFHBMDAS       TO MM04-BILL-USE-FLAG-LP-A
314400                                        (X-MM04-BILL)
314500                                    MM04-BILL-USE-FLAG-RP-A
314600                                        (X-MM04-BILL)
314700             MOVE DFHBMASK       TO MM04-BILL-USE-FLAG-A
314800                                        (X-MM04-BILL).
314900*
315000     IF  MBCA-PTI-FUNCTION-IS-MAINT
315100         IF  MMFS-MT-NO-MAINT (X-MMFS-MERCH)
315200             MOVE ZERO           TO MM04-BILL-USE-FLAG-L
315300                                        (X-MM04-BILL)
315400             MOVE DFHBMDAS       TO MM04-BILL-USE-FLAG-LP-A
315500                                        (X-MM04-BILL)
315600                                    MM04-BILL-USE-FLAG-RP-A
315700                                        (X-MM04-BILL)
315800             MOVE DFHBMASK       TO MM04-BILL-USE-FLAG-A
315900                                        (X-MM04-BILL).
316000*
316100 Y156-EXIT.
316200     EXIT.
316300*
316400 Y158-INCREMENT-INDEX.
316500*
316600     IF  X-MM04-BILL IS LESS THAN 4
316700         SET X-MM04-BILL         UP BY 1
316800         SET X-MMMM-BILL         UP BY 1
316900         SET X-MMFS-MERCH        UP BY 3
317000         GO TO Y151-MBUF-LOOP.
317100*
317200 Y159-EXIT.
317300     EXIT.
317400*
317500 Y170-MOVE-BILLING-ORG.
317600*
317700     SET X-MM04-BILL             TO 1.
317800     SET X-MMMM-BILL             TO 1.
317900     MOVE MMMMTB-BILLING-ORG-1 (1:4)
318000                                 TO WS-INDEX-X.
318100     SET X-MMFS-MERCH            TO WS-INDEX.
318200*
318300 Y171-MBO-LOOP.
318400*
318500     MOVE MMMM-BILLING-ORG (X-MMMM-BILL)
318600                                 TO MM04-BILLING-ORG
318700                                        (X-MM04-BILL).
318800*
318900 Y175-BILLING-ORG-SECURITY.
319000*
319100     MOVE DFHBMDAS               TO MM04-BILLING-ORG-LP-A
319200                                        (X-MM04-BILL)
319300                                    MM04-BILLING-ORG-RP-A
319400                                        (X-MM04-BILL).
319500     MOVE DFHBMASK               TO MM04-BILLING-ORG-A
319600                                        (X-MM04-BILL).
319700*
319800     IF  MMFS-MT-NO-ACCESS (X-MMFS-MERCH)
319900         MOVE DFHBMDAS           TO MM04-BILLING-ORG-LP-A
320000                                        (X-MM04-BILL)
320100                                    MM04-BILLING-ORG-RP-A
320200                                        (X-MM04-BILL)
320300                                    MM04-BILLING-ORG-A
320400                                        (X-MM04-BILL)
320500         MOVE ZERO               TO MM04-BILLING-ORG-L
320600                                        (X-MM04-BILL)
320700         GO TO Y176-EXIT.
320800*
320900     IF  MBCA-PTI-FUNCTION-IS-INQUIRY
321000         MOVE DFHBMDAS           TO MM04-BILLING-ORG-LP-A
321100                                        (X-MM04-BILL)
321200                                    MM04-BILLING-ORG-RP-A
321300                                        (X-MM04-BILL)
321400         MOVE DFHBMASB           TO MM04-BILLING-ORG-A
321500                                        (X-MM04-BILL)
321600         GO TO Y176-EXIT.
321700*
321800     IF  MMFS-MT-INQ-ONLY (X-MMFS-MERCH)
321900         MOVE ZERO               TO MM04-BILLING-ORG-L
322000                                        (X-MM04-BILL)
322100         MOVE DFHBMDAS           TO MM04-BILLING-ORG-LP-A
322200                                        (X-MM04-BILL)
322300                                    MM04-BILLING-ORG-RP-A
322400                                        (X-MM04-BILL)
322500         MOVE DFHBMASK           TO MM04-BILLING-ORG-A
322600                                        (X-MM04-BILL)
322700         GO TO Y176-EXIT.
322800*
322900     IF  MBCA-PTI-FUNCTION-IS-ADD
323000         IF  MMFS-MT-MAINT-ONLY (X-MMFS-MERCH)
323100             MOVE ZERO           TO MM04-BILLING-ORG-L
323200                                        (X-MM04-BILL)
323300             MOVE DFHBMDAS       TO MM04-BILLING-ORG-LP-A
323400                                        (X-MM04-BILL)
323500                                    MM04-BILLING-ORG-RP-A
323600                                        (X-MM04-BILL)
323700             MOVE DFHBMASK       TO MM04-BILLING-ORG-A
323800                                        (X-MM04-BILL).
323900*
324000     IF  MBCA-PTI-FUNCTION-IS-MAINT
324100         IF  MMFS-MT-NO-MAINT (X-MMFS-MERCH)
324200             MOVE ZERO           TO MM04-BILLING-ORG-L
324300                                        (X-MM04-BILL)
324400             MOVE DFHBMDAS       TO MM04-BILLING-ORG-LP-A
324500                                        (X-MM04-BILL)
324600                                    MM04-BILLING-ORG-RP-A
324700                                        (X-MM04-BILL)
324800             MOVE DFHBMASK       TO MM04-BILLING-ORG-A
324900                                        (X-MM04-BILL).
325000*
325100 Y176-EXIT.
325200     EXIT.
325300*
325400 Y178-INCREMENT-INDEX.
325500*
325600     IF  X-MM04-BILL IS LESS THAN 4
325700         SET X-MM04-BILL         UP BY 1
325800         SET X-MMMM-BILL         UP BY 1
325900         SET X-MMFS-MERCH        UP BY 3
326000         GO TO Y171-MBO-LOOP.
326100*
326200 Y179-EXIT.
326300     EXIT.
326400*
326500 Y190-MOVE-BILLING-ACCT.
326600*
326700     SET X-MM04-BILL             TO 1.
326800     SET X-MMMM-BILL             TO 1.
326900     MOVE MMMMTB-BILLING-ACCT-1 (1:4)
327000                                 TO WS-INDEX-X.
327100     SET X-MMFS-MERCH            TO WS-INDEX.
327200*
327300 Y191-MBUF-LOOP.
327400*
327500     MOVE MMMM-BILLING-ACCT (X-MMMM-BILL)
327600                                 TO MM04-BILLING-ACCT
327700                                    (X-MM04-BILL).
327800*
327900 Y195-BILLING-ACCT-SECURITY.
328000*
328100     IF  MMFS-MT-NO-ACCESS (X-MMFS-MERCH)
328200         MOVE DFHBMDAS           TO MM04-BILLING-ACCT-A
328300                                        (X-MM04-BILL)
328400                                    MM04-BILLING-ACCT-LP-A
328500                                        (X-MM04-BILL)
328600                                    MM04-BILLING-ACCT-RP-A
328700                                        (X-MM04-BILL)
328800                                    MM04-BILLING-ACCT-A
328900                                        (X-MM04-BILL)
329000         MOVE ZERO               TO MM04-BILLING-ACCT-L
329100                                        (X-MM04-BILL)
329200         GO TO Y196-EXIT.
329300*
329400     IF  MBCA-PTI-FUNCTION-IS-INQUIRY
329500         MOVE DFHBMDAS           TO MM04-BILLING-ACCT-LP-A
329600                                        (X-MM04-BILL)
329700                                    MM04-BILLING-ACCT-RP-A
329800                                        (X-MM04-BILL)
329900         MOVE DFHBMASB           TO MM04-BILLING-ACCT-A
330000                                        (X-MM04-BILL)
330100         GO TO Y196-EXIT.
330200*
330300     IF  MMFS-MT-INQ-ONLY (X-MMFS-MERCH)
330400         MOVE ZERO               TO MM04-BILLING-ACCT-L
330500                                        (X-MM04-BILL)
330600         MOVE DFHBMDAS           TO MM04-BILLING-ACCT-LP-A
330700                                        (X-MM04-BILL)
330800                                    MM04-BILLING-ACCT-RP-A
330900                                        (X-MM04-BILL)
331000         MOVE DFHBMASK           TO MM04-BILLING-ACCT-A
331100                                        (X-MM04-BILL)
331200         GO TO Y196-EXIT.
331300*
331400     IF  MBCA-PTI-FUNCTION-IS-ADD
331500         IF  MMFS-MT-MAINT-ONLY (X-MMFS-MERCH)
331600             MOVE ZERO           TO MM04-BILLING-ACCT-L
331700                                        (X-MM04-BILL)
331800             MOVE DFHBMDAS       TO MM04-BILLING-ACCT-LP-A
331900                                        (X-MM04-BILL)
332000                                    MM04-BILLING-ACCT-RP-A
332100                                        (X-MM04-BILL)
332200             MOVE DFHBMASK       TO MM04-BILLING-ACCT-A
332300                                        (X-MM04-BILL).
332400*
332500     IF  MBCA-PTI-FUNCTION-IS-MAINT
332600         IF  MMFS-MT-NO-MAINT (X-MMFS-MERCH)
332700             MOVE ZERO           TO MM04-BILLING-ACCT-L
332800                                        (X-MM04-BILL)
332900             MOVE DFHBMDAS       TO MM04-BILLING-ACCT-LP-A
333000                                        (X-MM04-BILL)
333100                                    MM04-BILLING-ACCT-RP-A
333200                                        (X-MM04-BILL)
333300             MOVE DFHBMASK       TO MM04-BILLING-ACCT-A
333400                                        (X-MM04-BILL).
333500*
333600 Y196-EXIT.
333700     EXIT.
333800*
333900 Y198-INCREMENT-INDEX.
334000*
334100     IF  X-MM04-BILL IS LESS THAN 4
334200         SET X-MM04-BILL         UP BY 1
334300         SET X-MMMM-BILL         UP BY 1
334400         SET X-MMFS-MERCH        UP BY 3
334500         GO TO Y191-MBUF-LOOP.
334600*
334700 Y199-EXIT.
334800     EXIT.
334900*
335000 Y800-SET-CURSOR.
335100*
335200************************************************************
335300*    THIS ROUTINE IS PERFORMED IF IN ADD OR MAINTENANCE    *
335400*    AND SETS THE CURSOR TO THE FIRST FIELD WHICH IS       *
335500*    OPEN FOR INPUT                                        *
335600************************************************************
335700*
335800     MOVE MMMMTB-RESV-FREQ-1 (1:4)
335900                                 TO WS-INDEX-X.
336000     SET X-MMFS-MERCH            TO WS-INDEX.
336100*
336200 Y801-SC-LOOP.
336300*
336400     IF  MBCA-PTI-FUNCTION-IS-ADD
336500         IF  MMFS-MT-OPTIONAL (X-MMFS-MERCH)
336600         OR  MMFS-MT-REQUIRED (X-MMFS-MERCH)
336700             GO TO Y802-SC-DETERMINE-FIELD.
336800*
336900     IF  MBCA-PTI-FUNCTION-IS-MAINT
337000         IF  MMFS-MT-MAINT-ALLOWED (X-MMFS-MERCH)
337100             GO TO Y802-SC-DETERMINE-FIELD.
337200*
337300     MOVE MMMMTB-PRENOTE-CTL-1 (1:4)
337400                                 TO WS-INDEX-X.
337500*
337600     IF  X-MMFS-MERCH IS LESS THAN WS-INDEX
337700         SET X-MMFS-MERCH        UP BY 1
337800         GO TO Y801-SC-LOOP.
337900*
338000 Y802-SC-DETERMINE-FIELD.
338100*
338200     MOVE MMMMTB-PRENOTE-CTL-1 (1:4)
338300                                 TO WS-INDEX-X.
338400*
338500     IF  X-MMFS-MERCH IS EQUAL TO WS-INDEX
338600         MOVE SS08WS-CURSOR      TO MM04-ALT-TRANID-L
338700         GO TO Y809-SC-EXIT.
338800
338900     SET WS-FIELD-POSITION       TO X-MMFS-MERCH.
339000*
339100     MOVE MMMMTB-DATE-LAST-PART-VOL (1:4)
339200                                 TO WS-INDEX-X.
339300*
339400     SUBTRACT WS-INDEX           FROM WS-FIELD-POSITION.
339500
339600     GO TO   Y803-RESV-1-FREQ
339700             Y803-RESV-1-TABLE
339800             Y803-RESV-1-DESC
339900             Y803-RESV-1-LEVEL
340000             Y803-RESV-1-FEE-BASE
340100             Y803-RESV-1-FLOOR
340200             Y803-RESV-1-CEILING
340300             Y803-RESV-2-FREQ
340400             Y803-RESV-2-TABLE
340500             Y803-RESV-2-DESC
340600             Y803-RESV-2-LEVEL
340700             Y803-RESV-2-FEE-BASE
340800             Y803-RESV-2-FLOOR
340900             Y803-RESV-2-CEILING
341000             Y803-RESV-3-FREQ
341100             Y803-RESV-3-TABLE
341200             Y803-RESV-3-DESC
341300             Y803-RESV-3-LEVEL
341400             Y803-RESV-3-FEE-BASE
341500             Y803-RESV-3-FLOOR
341600             Y803-RESV-3-CEILING
341700             Y803-RESV-4-FREQ
341800             Y803-RESV-4-TABLE
341900             Y803-RESV-4-DESC
342000             Y803-RESV-4-LEVEL
342100             Y803-RESV-4-FEE-BASE
342200             Y803-RESV-4-FLOOR
342300             Y803-RESV-4-CEILING
342400             Y803-BILL-1-USE-FLAG
342500             Y803-BILL-1-ORG
342600             Y803-BILL-1-ACCT
342700             Y803-BILL-2-USE-FLAG
342800             Y803-BILL-2-ORG
342900             Y803-BILL-2-ACCT
343000             Y803-BILL-3-USE-FLAG
343100             Y803-BILL-3-ORG
343200             Y803-BILL-3-ACCT
343300             Y803-BILL-4-USE-FLAG
343400             Y803-BILL-4-ORG
343500             Y803-BILL-4-ACCT
343600         DEPENDING ON WS-FIELD-POSITION.
343700*
343800 Y803-RESV-1-FREQ.
343900*
344000     SET  X-MM04-RESV            TO 1.
344100     MOVE SS08WS-CURSOR          TO MM04-RESV-FREQ-L
344200                                        (X-MM04-RESV).
344300     GO TO Y809-SC-EXIT.
344400*
344500 Y803-RESV-1-TABLE.
344600*
344700     SET  X-MM04-RESV            TO 1.
344800     MOVE SS08WS-CURSOR          TO MM04-RESV-RATE-TABLE-L
344900                                        (X-MM04-RESV).
345000     GO TO Y809-SC-EXIT.
345100*
345200 Y803-RESV-1-DESC.
345300*
345400     SET  X-MM04-RESV            TO 1.
345500     MOVE SS08WS-CURSOR          TO MM04-RESV-DESC-L
345600                                        (X-MM04-RESV).
345700     GO TO Y809-SC-EXIT.
345800*
345900 Y803-RESV-1-LEVEL.
346000*
346100     SET  X-MM04-RESV            TO 1.
346200     MOVE SS08WS-CURSOR          TO MM04-RESV-LEVEL-L
346300                                        (X-MM04-RESV).
346400     GO TO Y809-SC-EXIT.
346500*
346600 Y803-RESV-1-FEE-BASE.
346700*
346800     SET  X-MM04-RESV            TO 1.
346900     MOVE SS08WS-CURSOR          TO MM04-RESV-FEE-BASE-L
347000                                        (X-MM04-RESV).
347100     GO TO Y809-SC-EXIT.
347200*
347300 Y803-RESV-1-FLOOR.
347400*
347500     SET  X-MM04-RESV            TO 1.
347600     MOVE SS08WS-CURSOR          TO MM04-RESV-FLOOR-L
347700                                        (X-MM04-RESV).
347800     GO TO Y809-SC-EXIT.
347900*
348000 Y803-RESV-1-CEILING.
348100*
348200     SET  X-MM04-RESV            TO 1.
348300     MOVE SS08WS-CURSOR          TO MM04-RESV-CEILING-L
348400                                        (X-MM04-RESV).
348500     GO TO Y809-SC-EXIT.
348600*
348700 Y803-BILL-1-USE-FLAG.
348800*
348900     SET  X-MM04-BILL            TO 1.
349000     MOVE SS08WS-CURSOR          TO MM04-BILL-USE-FLAG-L
349100                                        (X-MM04-BILL).
349200     GO TO Y809-SC-EXIT.
349300*
349400 Y803-BILL-1-ORG.
349500*
349600     SET  X-MM04-BILL            TO 1.
349700     MOVE SS08WS-CURSOR          TO MM04-BILLING-ORG-L
349800                                        (X-MM04-BILL).
349900     GO TO Y809-SC-EXIT.
350000*
350100 Y803-BILL-1-ACCT.
350200*
350300     SET  X-MM04-BILL            TO 1.
350400     MOVE SS08WS-CURSOR          TO MM04-BILLING-ACCT-L
350500                                        (X-MM04-BILL).
350600     GO TO Y809-SC-EXIT.
350700*
350800 Y803-RESV-2-FREQ.
350900*
351000     SET  X-MM04-RESV            TO 2.
351100     MOVE SS08WS-CURSOR          TO MM04-RESV-FREQ-L
351200                                        (X-MM04-RESV).
351300     GO TO Y809-SC-EXIT.
351400*
351500 Y803-RESV-2-TABLE.
351600*
351700     SET  X-MM04-RESV            TO 2.
351800     MOVE SS08WS-CURSOR          TO MM04-RESV-RATE-TABLE-L
351900                                        (X-MM04-RESV).
352000     GO TO Y809-SC-EXIT.
352100*
352200 Y803-RESV-2-DESC.
352300*
352400     SET  X-MM04-RESV            TO 2.
352500     MOVE SS08WS-CURSOR          TO MM04-RESV-DESC-L
352600                                        (X-MM04-RESV).
352700     GO TO Y809-SC-EXIT.
352800*
352900 Y803-RESV-2-LEVEL.
353000*
353100     SET  X-MM04-RESV            TO 2.
353200     MOVE SS08WS-CURSOR          TO MM04-RESV-LEVEL-L
353300                                        (X-MM04-RESV).
353400     GO TO Y809-SC-EXIT.
353500*
353600 Y803-RESV-2-FEE-BASE.
353700*
353800     SET  X-MM04-RESV            TO 2.
353900     MOVE SS08WS-CURSOR          TO MM04-RESV-FEE-BASE-L
354000                                        (X-MM04-RESV).
354100     GO TO Y809-SC-EXIT.
354200*
354300 Y803-RESV-2-FLOOR.
354400*
354500     SET  X-MM04-RESV            TO 2.
354600     MOVE SS08WS-CURSOR          TO MM04-RESV-FLOOR-L
354700                                        (X-MM04-RESV).
354800     GO TO Y809-SC-EXIT.
354900*
355000 Y803-RESV-2-CEILING.
355100*
355200     SET  X-MM04-RESV            TO 2.
355300     MOVE SS08WS-CURSOR          TO MM04-RESV-CEILING-L
355400                                        (X-MM04-RESV).
355500     GO TO Y809-SC-EXIT.
355600*
355700 Y803-BILL-2-USE-FLAG.
355800*
355900     SET  X-MM04-BILL            TO 2.
356000     MOVE SS08WS-CURSOR          TO MM04-BILL-USE-FLAG-L
356100                                        (X-MM04-BILL).
356200     GO TO Y809-SC-EXIT.
356300*
356400 Y803-BILL-2-ORG.
356500*
356600     SET  X-MM04-BILL            TO 2.
356700     MOVE SS08WS-CURSOR          TO MM04-BILLING-ORG-L
356800                                        (X-MM04-BILL).
356900     GO TO Y809-SC-EXIT.
357000*
357100 Y803-BILL-2-ACCT.
357200*
357300     SET  X-MM04-BILL            TO 2.
357400     MOVE SS08WS-CURSOR          TO MM04-BILLING-ACCT-L
357500                                        (X-MM04-BILL).
357600     GO TO Y809-SC-EXIT.
357700*
357800 Y803-RESV-3-FREQ.
357900*
358000     SET  X-MM04-RESV            TO 3.
358100     MOVE SS08WS-CURSOR          TO MM04-RESV-FREQ-L
358200                                        (X-MM04-RESV).
358300     GO TO Y809-SC-EXIT.
358400*
358500 Y803-RESV-3-TABLE.
358600*
358700     SET  X-MM04-RESV            TO 3.
358800     MOVE SS08WS-CURSOR          TO MM04-RESV-RATE-TABLE-L
358900                                        (X-MM04-RESV).
359000     GO TO Y809-SC-EXIT.
359100*
359200 Y803-RESV-3-DESC.
359300*
359400     SET  X-MM04-RESV            TO 3.
359500     MOVE SS08WS-CURSOR          TO MM04-RESV-DESC-L
359600                                        (X-MM04-RESV).
359700     GO TO Y809-SC-EXIT.
359800*
359900 Y803-RESV-3-LEVEL.
360000*
360100     SET  X-MM04-RESV            TO 3.
360200     MOVE SS08WS-CURSOR          TO MM04-RESV-LEVEL-L
360300                                        (X-MM04-RESV).
360400     GO TO Y809-SC-EXIT.
360500*
360600 Y803-RESV-3-FEE-BASE.
360700*
360800     SET  X-MM04-RESV            TO 3.
360900     MOVE SS08WS-CURSOR          TO MM04-RESV-FEE-BASE-L
361000                                        (X-MM04-RESV).
361100     GO TO Y809-SC-EXIT.
361200*
361300 Y803-RESV-3-FLOOR.
361400*
361500     SET  X-MM04-RESV            TO 3.
361600     MOVE SS08WS-CURSOR          TO MM04-RESV-FLOOR-L
361700                                        (X-MM04-RESV).
361800     GO TO Y809-SC-EXIT.
361900*
362000 Y803-RESV-3-CEILING.
362100*
362200     SET  X-MM04-RESV            TO 3.
362300     MOVE SS08WS-CURSOR          TO MM04-RESV-CEILING-L
362400                                        (X-MM04-RESV).
362500     GO TO Y809-SC-EXIT.
362600*
362700 Y803-BILL-3-USE-FLAG.
362800*
362900     SET  X-MM04-BILL            TO 3.
363000     MOVE SS08WS-CURSOR          TO MM04-BILL-USE-FLAG-L
363100                                        (X-MM04-BILL).
363200     GO TO Y809-SC-EXIT.
363300*
363400 Y803-BILL-3-ORG.
363500*
363600     SET  X-MM04-BILL            TO 3.
363700     MOVE SS08WS-CURSOR          TO MM04-BILLING-ORG-L
363800                                        (X-MM04-BILL).
363900     GO TO Y809-SC-EXIT.
364000*
364100 Y803-BILL-3-ACCT.
364200*
364300     SET  X-MM04-BILL            TO 3.
364400     MOVE SS08WS-CURSOR          TO MM04-BILLING-ACCT-L
364500                                        (X-MM04-BILL).
364600     GO TO Y809-SC-EXIT.
364700*
364800 Y803-RESV-4-FREQ.
364900*
365000     SET  X-MM04-RESV            TO 4.
365100     MOVE SS08WS-CURSOR          TO MM04-RESV-FREQ-L
365200                                        (X-MM04-RESV).
365300     GO TO Y809-SC-EXIT.
365400*
365500 Y803-RESV-4-TABLE.
365600*
365700     SET  X-MM04-RESV            TO 4.
365800     MOVE SS08WS-CURSOR          TO MM04-RESV-RATE-TABLE-L
365900                                        (X-MM04-RESV).
366000     GO TO Y809-SC-EXIT.
366100*
366200 Y803-RESV-4-DESC.
366300*
366400     SET  X-MM04-RESV            TO 4.
366500     MOVE SS08WS-CURSOR          TO MM04-RESV-DESC-L
366600                                        (X-MM04-RESV).
366700     GO TO Y809-SC-EXIT.
366800*
366900 Y803-RESV-4-LEVEL.
367000*
367100     SET  X-MM04-RESV            TO 4.
367200     MOVE SS08WS-CURSOR          TO MM04-RESV-LEVEL-L
367300                                        (X-MM04-RESV).
367400     GO TO Y809-SC-EXIT.
367500*
367600 Y803-RESV-4-FEE-BASE.
367700*
367800     SET  X-MM04-RESV            TO 4.
367900     MOVE SS08WS-CURSOR          TO MM04-RESV-FEE-BASE-L
368000                                        (X-MM04-RESV).
368100     GO TO Y809-SC-EXIT.
368200*
368300 Y803-RESV-4-FLOOR.
368400*
368500     SET  X-MM04-RESV            TO 4.
368600     MOVE SS08WS-CURSOR          TO MM04-RESV-FLOOR-L
368700                                        (X-MM04-RESV).
368800     GO TO Y809-SC-EXIT.
368900*
369000 Y803-RESV-4-CEILING.
369100*
369200     SET  X-MM04-RESV            TO 4.
369300     MOVE SS08WS-CURSOR          TO MM04-RESV-CEILING-L
369400                                        (X-MM04-RESV).
369500     GO TO Y809-SC-EXIT.
369600*
369700 Y803-BILL-4-USE-FLAG.
369800*
369900     SET  X-MM04-BILL            TO 4.
370000     MOVE SS08WS-CURSOR          TO MM04-BILL-USE-FLAG-L
370100                                        (X-MM04-BILL).
370200     GO TO Y809-SC-EXIT.
370300*
370400 Y803-BILL-4-ORG.
370500*
370600     SET  X-MM04-BILL            TO 4.
370700     MOVE SS08WS-CURSOR          TO MM04-BILLING-ORG-L
370800                                        (X-MM04-BILL).
370900     GO TO Y809-SC-EXIT.
371000*
371100 Y803-BILL-4-ACCT.
371200*
371300     SET  X-MM04-BILL            TO 4.
371400     MOVE SS08WS-CURSOR          TO MM04-BILLING-ACCT-L
371500                                        (X-MM04-BILL).
371600     GO TO Y809-SC-EXIT.
371700*
371800 Y809-SC-EXIT.
371900     EXIT.
372000*
372100 Y900-READ-MMMM.
372200*
372300*****************************************
372400*    READ THE MERCHANT MASTER RECORD    *
372500*****************************************
372600*
372700     MOVE MBCA-MERCHANT-ORG      TO MBIOWS-MMMM-ORG
372800                                    MM04-ORG.
372900     MOVE MBCA-MERCHANT          TO MBIOWS-MMMM-MERCHANT
373000                                    MM04-MERCHANT.
373100     SET MBIORO-READ-RANDOM      TO TRUE.
373200     PERFORM MMMMAO-ACCESS       THRU MMMMAO-ACCESS-EXIT.
373300*
373400 Y909-READ-MMMM-EXIT.
373500     EXIT.
373600*
373700 Y910-READ-MMFS.
373800*
373900****************************************
374000*    READ THE FIELD SECURITY RECORD    *
374100*    TO OBTAIN THE SECURITY CODES      *
374200****************************************
374300*
374400     MOVE MBCA-MERCHANT-ORG      TO MBIOWS-MMFS-ORG.
374500     MOVE MBCA-FIELD-SECURITY    TO MBIOWS-MMFS-FS-CODE.
374600     SET MBIORO-READ-RANDOM      TO TRUE.
374700     PERFORM MMFSAO-ACCESS       THRU MMFSAO-ACCESS-EXIT.
374800*
374900     IF  NOT MMFS-REC-ACTIVE
375000         MOVE MBIORO-IO-REQUEST  TO MBCA-ERRR-IO-REQUEST
375100         MOVE ZERO               TO MBCA-ERROR-ROUTINE-SW
375200         MOVE SPACES             TO MBCA-TRANS-WORK-AREA
375300         MOVE 'READ ERROR - MMFSAO'
375400                                 TO MBCA-ERRR-MSG1
375500         MOVE 'FIELDS SECURITY PROFILE IS NOT ACTIVE'
375600                                 TO MBCA-ERRR-MSG2
375700         GO TO MB70PD-ERROR-ROUTINE.
375800*
375900 Y919-READ-MMFS-EXIT.
376000     EXIT.
376100*
376200 Y920-WRITE-LOG-RECORD.
376300*
376400     SET MBIORO-WRITE            TO TRUE.
376500     PERFORM MML1AO-ACCESS       THRU MML1AO-ACCESS-EXIT.
376600     MOVE SPACES                 TO MML1-VARIABLE-AREA.
376700*
376800 Y929-WLR-EXIT.
376900     EXIT.
377000/
377100 Z000-COPIED-ROUTINES SECTION.
377200*
377300**********************************
377400*    JUL TO GREG DATE ROUTINE    *
377500**********************************
377600*
377700     COPY SS08PD.
377800/
377900**********************************
378000*    DATE AND TIME EDIT ROUTINES *
378100**********************************
378200*
378300     COPY SS26PD.
378400     COPY SS27PD.
378500/
378600*********************************
378700*    LINE 24 PF KEYS ROUTINE    *
378800*********************************
378900*
379000     COPY SS15PD.
379100/
379200************************************************
379300*    MERCHANT MASTER RECORD ACCESS ROUTINES    *
379400************************************************
379500*
379600     COPY MMMMAO.
379700/
379800************************************************
379900*    ORG CONTROL RECORD ACCESS ROUTINES        *
380000************************************************
380100*
380200     COPY MMOCAO.
380300/
380400************************************************
380500*    RATE TABLE  RECORD ACCESS ROUTINES        *
380600************************************************
380700*
380800     COPY MMRTAO.
380900/
381000***********************************************
381100*    FIELD SECURITY RECORD ACCESS ROUTINES    *
381200***********************************************
381300*
381400     COPY MMFSAO.
381500/
381600*****************************************
381700*    LOG FILE RECORD ACCESS ROUTINES    *
381800*****************************************
381900*
382000     COPY MML1AO.
382100/
382200*****************************
382300*    FORMATTED MESSAGE LINE *
382400*****************************
382500*
382600     COPY MB06PD.
382700/
382800*****************************
382900*    ONLINE MAP ROUTINES    *
383000*****************************
383100*
383200     COPY MB60PD REPLACING 'MBMAPXX' BY 'MBMM04 '
383300                           MBMAPXXI BY MBMM04I
383400                           MBMAPXXO BY MBMM04O.
383500/
383600***************************
383700*    ONLINE PROCEDURES    *
383800***************************
383900*
384000     COPY MB70PD.
384100/
384200     COPY SMFTPXO.
