000100 IDENTIFICATION DIVISION.
000200 PROGRAM-ID. MBOMM07.
000201*       RELEASE DATE=08/24/01.        REVISION LEVEL=08.06      *
000202*****************************************************************
000203*WARNING.  THIS COMPUTER PROGRAM IS PROTECTED BY COPYRIGHT LAW  *
000204*AND INTERNATIONAL TREATIES.  UNAUTHORIZED REPRODUCTION OR      *
000205*DISTRIBUTION OF THIS PROGRAM, OR ANY PORTION OF IT, MAY RESULT *
000206*IN SEVERE CIVIL AND CRIMINAL PENATLIES, AND WILL BE PROSECUTED *
000207*TO THE MAXIMUM EXTENT POSSIBLE UNDER THE LAW.                  *
000208*COPYRIGHT 1999 PAYSYS INTERNATIONAL, INC.  ALL RIGHTS RESERVED.*
000209*****************************************************************
000300*****************************************************************
000400*                                                               *
000500*   V - PLUS  M E R C H A N T   B A N K C A R D   S Y S T E M   *
000600*                                                               *
000700*      MBOMM07 - MERCHANT MASTER RECORD ADD/MAINT/INQ           *
000800*                SCREEN 07                                      *
000900*                                                               *
001000*              1. TRANSIDS                                      *
001100*                 A. MBAM                                       *
001200*                 B. MBMM                                       *
001300*                 C. MBQM                                       *
001400*              2. MAPS USED -                                   *
001500*                 A. MBMM07 (SCREEN 07)                         *
001600*              3. FILES USED -                                  *
001700*                 A. MMMM (MERCHANT MASTER FILE)                *
001800*                 B. MMFS (FIELD SECURITY FILE)                 *
001900*                 C. MMPA (PROD ACTIVITY FILE)                  *
002000*                 D. MMRC (MERCH RELATIONSHIP CONTROL)          *
002100*                 E. MMOC (ORG CONTROL FILE)                    *
002200*                 F. MMXR (MERCH STORE XREF FILE)               *
002300*                 G. MMSM (STORE MASTER FILE)                   *
002400*                 H. MML1 (LOG FILE)                            *
002500*                                                               *
002600*****************************************************************
002700*
002800 ENVIRONMENT DIVISION.
002900*
003000 DATA DIVISION.
003100*
003200 WORKING-STORAGE SECTION.
003300*
003400 01  FILLER                  PIC  X(12)      VALUE '** WS-BEG **'.
003500*
003600 01  FILLER                  PIC  X(14)      VALUE
003700     'MISCELLANEOUS:'.
003800*
003900 01  WS-MISCELLANEOUS.
004000     03  WS-FIELD-POSITION   PIC  9(03)      VALUE ZEROES.
004100*
004200 01  FILLER                  PIC  X(17)      VALUE
004300     'PROGRAM SWITCHES:'.
004400*
004500 01  WS-PROGRAM-SWITCHES.
004600     03  WS-UPDATE-SW        PIC  X(01)      VALUE 'N'.
004700         88  WS-UPDATE-SW-YES                VALUE 'Y'.
004800         88  WS-UPDATE-SW-NO                 VALUE 'N'.
004900     03  WS-STORE-UPDATE-SW  PIC  X(01)      VALUE 'N'.
005000         88  WS-STORE-UPDATE-SW-YES          VALUE 'Y'.
005100         88  WS-STORE-UPDATE-SW-NO           VALUE 'N'.
005200     03  WS-ACCOUNT-ERROR-SW PIC  X(01)      VALUE 'N'.
005300         88  WS-ACCOUNT-ERROR-YES            VALUE 'Y'.
005400         88  WS-ACCOUNT-ERROR-NO             VALUE 'N'.
005500*
005600     03  WS-PENDING-PRENOTE-AREA             OCCURS 4 TIMES
005700                                             INDEXED BY
005800                                             X-PEND-PRE.
005900         05  WS-DATE-PENDING-FLAG
006000                             PIC  X(01)      VALUE 'N'.
006100             88  WS-DATE-PENDING-YES         VALUE 'Y'.
006200         05  WS-PRENOTE-FLAG PIC  X(01)      VALUE 'N'.
006300             88  WS-PRENOTE-YES              VALUE 'Y'.
006400         05  WS-DATE-PENDING PIC S9(07)      COMP-3  VALUE ZEROS.
006500         05  WS-DATE-PRENOTE PIC S9(07)      COMP-3  VALUE ZEROS.
006600         05  WS-PRENOTE-CONTROL
006700                             PIC  X(01)      VALUE SPACES.
006800     03  TS-QUEUE-NAME.
006900         05  TS-QN-TERMID    PIC  X(04)      VALUE SPACES.
007000         05  TS-QN-TRANID    PIC  X(04)      VALUE 'MBUI'.
007100*
007200     03  WS-INDEX-X.
007300         05  WS-INDEX        PIC  9(04)      VALUE ZEROS.
007400*
007500     03  WS-TAT-ACCOUNT.
007600         05  WS-TAT-1ST      PIC  X(01)      VALUE 'S'.
007700         05  WS-TAT-INDEX    PIC  9(01)      VALUE ZEROS.
007800/
007900 01  FILLER                  PIC  X(29)      VALUE
008000     'I/O REQUEST BLOCK WORK AREAS:'.
008100*
008200     COPY MBIOWS.
008300/
008400 01  FILLER                  PIC  X(18)      VALUE
008500     'I/O REQUEST BLOCK:'.
008600*
008700     COPY MBIORO.
008800/
008900 01  FILLER                  PIC  X(25)      VALUE
009000     'LOG RECORD REQUEST BLOCK:'.
009100*
009200     COPY MML1WS REPLACING ==:MML1:== BY ==MML1==.
009300/
009400 01  FILLER                  PIC  X(29)      VALUE
009500     'MERCHANT MASTER FIELDS TABLE:'.
009600*
009700     COPY MMMMTB.
009800/
009900 01  FILLER                  PIC  X(26)      VALUE
010000     'MERCHANT MASTER IO RECORD:'.
010100*
010200     COPY MMMMIO.
010300/
010400 01  FILLER                  PIC  X(35)      VALUE
010500     'MERCHANT MASTER INITIALIZER RECORD:'.
010600*
010700     COPY MMMMIR.
010800/
010900 01  FILLER                  PIC  X(20)      VALUE
011000     'CCS DATE WORK AREAS:'.
011100*
011200     COPY SS01WS.
011300/
011400 01  FILLER                  PIC  X(15)      VALUE
011500     'CCS WORK AREAS:'.
011600*
011700     COPY SS08WS.
011800/
011900     COPY SS00WS.
012000/
012100     COPY SMFTWS.
012200/
012300     COPY SMPTRL REPLACING ==:SMPT:== BY ==SMPT==.
012400/
012500     COPY MB61LK.
012600/
012700 01  FILLER                  PIC  X(12)      VALUE '** WS-END **'.
012800/
012900 LINKAGE SECTION.
013000*
013100 01  DFHCOMMAREA.
013200*
013300     COPY MB60WS.
013400/
013500*****************************
013600*    MERCHANT MASTER MAP    *
013700*****************************
013800*
013900     COPY MBMM07.
014000/
014100******************************************
014200*    MERCHANT MASTER MAP REDEFINITION    *
014300******************************************
014400*
014500     COPY MBMM07R.
014600/
014700****************************************
014800*    MERCHANT MASTER  RECORD LAYOUT    *
014900****************************************
015000*
015100     COPY MMMMRL.
015200/
015300****************************************
015400*    STORE MASTER  RECORD LAYOUT       *
015500****************************************
015600*
015700     COPY MMSMRL.
015800/
015900****************************************
016000*    MERCH STORE XREF RECORD LAYOUT    *
016100****************************************
016200*
016300     COPY MMXRRL.
016400/
016500**************************************************
016600*    MERCHANT RELATIONSHIP CONTROL RECORD LAYOUT *
016700**************************************************
016800*
016900     COPY MMRCRL.
017000/
017100******************************************
017200*    RATE TABLE RECORD LAYOUT            *
017300******************************************
017400*
017500     COPY MMRTRL.
017600/
017700**************************************
017800*    FIELD SECURITY RECORD LAYOUT    *
017900**************************************
018000*
018100     COPY MMFSRL.
018200/
018300*************************************
018400*    PROD ACTIVITY RECORD LAYOUT    *
018500*************************************
018600*
018700     COPY MMPARL REPLACING ==:MMPA:== BY ==MMPA==.
018800/
018900*************************************
019000*    ORG CONTROL RECORD   LAYOUT    *
019100*************************************
019200*
019300     COPY MMOCRL.
019400/
019500***************************
019600*    LOG RECORD LAYOUT    *
019700***************************
019800*
019900     COPY MML1RL REPLACING ==:MML1:== BY ==MML1==.
020000/
020100***************************************
020200*    USER INPUT TEMP STORAGE RECORD   *
020300***************************************
020400*
020500     COPY MBUITS.
020600/
020700 PROCEDURE DIVISION.
020800*
020900 A000-HOUSEKEEPING SECTION.
021000*
021100 A020-INIT.
021200*
021300     MOVE 'PC01'                 TO MBCA-PROGRAM-LOCATION.
021400     PERFORM MB70PD-ON-LINE-HOUSEKEEPING
021500                                 THRU MB70PD-OLH-EXIT.
021600*
021700     IF  MBCA-MBUI-UI-YES
021800         NEXT SENTENCE
021900     ELSE
022000         SET MBCA-MBUI-UI-NO     TO TRUE.
022100*
022200     MOVE MBCA-TERMINAL-ID       TO TS-QN-TERMID.
022300*
022400     IF  MBCA-RECEIVE-SCREEN
022500         GO TO C000-RECEIVE-SCREEN.
022600/
022700 B000-SEND-SCREEN SECTION.
022800*
022900*********************************************
023000*    GET CICS STORAGE NEEDED FOR THE MAP    *
023100*********************************************
023200*
023300     MOVE 'SC01'                 TO MBCA-PROGRAM-LOCATION.
023400     PERFORM MB60PD-GETMAIN-FOR-MAP
023500                                 THRU MB60PD-GFM-EXIT.
023600*
023700*******************************************
023800*    INITIALIZE THE STANDARD MAP LINES    *
023900*******************************************
024000*
024100     PERFORM MB60PD-INIT-STD-MAP-LINES
024200                                 THRU MB60PD-ISML-EXIT.
024300*
024400*
024500*****************************************
024600*    READ THE MERCHANT MASTER RECORD    *
024700*    FOR SUBSEQUENT DISPLAY             *
024800*****************************************
024900*
025000     MOVE MBCA-MERCHANT-ORG      TO MBIOWS-MMMM-ORG
025100                                    MM07-ORG.
025200     MOVE MBCA-MERCHANT          TO MBIOWS-MMMM-MERCHANT
025300                                    MM07-MERCHANT.
025400     MOVE 'FC01'                 TO MBCA-PROGRAM-LOCATION.
025500     SET MBIORO-READ-RANDOM      TO TRUE.
025600     PERFORM MMMMAO-ACCESS       THRU MMMMAO-ACCESS-EXIT.
025700*
025800*********************************************
025900*    MOVE THE PRIMARY NAME TO THE SCREEN    *
026000*********************************************
026100*
026200     MOVE MMMM-NA-LINE (1 1)     TO MM07-MERCHANT-NAME.
026300*
026400****************************************
026500*    READ THE FIELD SECURITY RECORD    *
026600****************************************
026700*
026800     MOVE 'FC02'                 TO MBCA-PROGRAM-LOCATION.
026900     PERFORM Y900-READ-MMFS      THRU Y909-READ-MMFS-EXIT.
027000*
027100 B020-MOVE-FIELDS-TO-SCREEN.
027200*
027300*****************************************
027400*    MOVE THE MERCHANT MASTER FIELDS    *
027500*    FROM THE RECORD TO THE SCREEN      *
027600*****************************************
027700*
027800     MOVE DFHBMDAS               TO MM07-TXN-ASSIGNMENT-LIT-A
027900                                    (14).
028000*
028100     PERFORM Y010-MOVE-POST-REJECTS-FLAG
028200                                 THRU Y019-EXIT.
028300*
028400     PERFORM Y020-MOVE-SETT-FREQ1
028500                                 THRU Y029-EXIT.
028600*
028700     PERFORM Y030-MOVE-SETT-FREQ2
028800                                 THRU Y039-EXIT.
028900*
029000     PERFORM Y050-MOVE-DEST-METHOD-1
029100                                 THRU Y059-EXIT.
029200*
029300     PERFORM Y070-MOVE-COMB-DEPOSIT-FLAG
029400                                 THRU Y079-EXIT.
029500*
029600     PERFORM Y090-MOVE-DEST-METHOD-2
029700                                 THRU Y099-EXIT.
029800*
029900     PERFORM Y110-MOVE-PRINT-FAX
030000                                 THRU Y119-EXIT.
030100*
030200     PERFORM Y130-MOVE-DEST-METHOD-3
030300                                 THRU Y139-EXIT.
030400*
030500     PERFORM Y150-MOVE-SETT-NOTICE-FLAG
030600                                 THRU Y159-EXIT.
030700*
030800     PERFORM Y170-MOVE-DEST-METHOD-4
030900                                 THRU Y179-EXIT.
031000*
031100     PERFORM Y190-MOVE-ASSIGN-ACCT
031200                                 THRU Y199-EXIT.
031300*
031400     PERFORM Y210-MOVE-ASSIGN-USER-CODE
031500                                 THRU Y219-EXIT.
031600*
031700******************************************
031800*    SET THE CURSOR AND SCREEN NUMBER    *
031900******************************************
032000*
032100     IF  MBCA-PTI-FUNCTION-IS-INQUIRY
032200         MOVE SS08WS-CURSOR      TO MM07-ALT-TRANID-L
032300     ELSE
032400         PERFORM Y800-SET-CURSOR THRU Y809-SC-EXIT.
032500*
032600     COMPUTE MBCA-SCREEN-NBR     =  MBCA-SCREEN-NBR - 50.
032700*
032800**********************
032900*    SEND THE MAP    *
033000**********************
033100*
033200     MOVE 'BM01'                 TO MBCA-PROGRAM-LOCATION.
033300*
033400     PERFORM MB60PD-SEND-MAP-WITH-ERASE
033500                                 THRU MB60PD-SMWE-EXIT.
033600*
033700************************
033800*    RETURN TO CICS    *
033900************************
034000*
034100     MOVE 'PC02'                 TO MBCA-PROGRAM-LOCATION.
034200     PERFORM MB70PD-RETURN-TRANS-ID
034300                                 THRU MB70PD-RTI-EXIT.
034400/
034500 C000-RECEIVE-SCREEN SECTION.
034600*
034700******************************************
034800*    THIS SECTION RECEIVES THE SCREEN    *
034900******************************************
035000*
035100     IF  MBCA-MBUI-UI-YES
035200*
035300****************************************************************
035400*    ACQUIRE MAIN STORAGE FOR TEMP STORAGE RECORD              *
035500****************************************************************
035600*
035700         MOVE 'TS01'             TO MBCA-PROGRAM-LOCATION
035800         EXEC CICS GETMAIN
035900                   FLENGTH (LENGTH  OF MBUITS-RECORD)
036000
036100                   SET     (ADDRESS OF MBUITS-RECORD)
036200
036300              END-EXEC
036400*
036500***********************************************
036600*    READ THE TEMP STORAGE RECORD             *
036700***********************************************
036800*
036900         MOVE 'TS02'             TO MBCA-PROGRAM-LOCATION
037000*
037100         EXEC CICS READQ TS
037200                   QUEUE   (TS-QUEUE-NAME)
037300                   INTO    (MBUITS-RECORD)
037400                   LENGTH  (LENGTH  OF MBUITS-RECORD)
037500                   ITEM    (1)
037600              END-EXEC
037700*
037800***********************************************
037900*    DELETE THE TEMP STORAGE RECORD           *
038000***********************************************
038100*
038200         MOVE 'TS03'             TO MBCA-PROGRAM-LOCATION
038300*
038400         EXEC CICS IGNORE CONDITION
038500                   QIDERR
038600              END-EXEC
038700*
038800         EXEC CICS DELETEQ TS
038900                   QUEUE  (TS-QUEUE-NAME)
039000              END-EXEC
039100         MOVE 'SC02'             TO MBCA-PROGRAM-LOCATION
039200         PERFORM MB60PD-GETMAIN-FOR-MAP
039300                                 THRU MB60PD-GFM-EXIT
039400         MOVE MBUITS-VAR-DATA    TO MBMM07I
039500     ELSE
039600         MOVE 'BM02'             TO MBCA-PROGRAM-LOCATION
039700         PERFORM MB60PD-RECEIVE-MAP
039800                                 THRU MB60PD-RM-EXIT.
039900*
040000**************************************************************
040100*    CHECK FOR ANOTHER TRANSACTION ID ENTERED BY THE USER    *
040200**************************************************************
040300*
040400     MOVE 'PC03'                 TO MBCA-PROGRAM-LOCATION.
040500     PERFORM MB60PD-NEW-TRANS-ROUTINE
040600                                 THRU MB60PD-NTR-EXIT.
040700*
040800****************************************************
040900*    BYPASS ALL SCREEN EDITS IF THIS IS INQIURY    *
041000****************************************************
041100*
041200     IF  MBCA-PTI-FUNCTION-IS-INQUIRY
041300         GO TO F000-SETUP-COMMAREA.
041400*
041500*****************************************
041600*    READ THE MERCHANT MASTER RECORD    *
041700*****************************************
041800*
041900*
042000     IF  MBCA-PTI-FUNCTION-IS-ADD
042100     AND MBCA-MBUI-UI-YES
042200     AND MBCA-MBUI-UI-UPDATE-NO
042300         MOVE 'SC03'             TO MBCA-PROGRAM-LOCATION
042400         SET MBIORO-GETMAIN      TO TRUE
042500         PERFORM MMMMAO-ACCESS   THRU MMMMAO-ACCESS-EXIT
042600         MOVE MMMMIR-RECORD      TO MMMM-RECORD
042700     ELSE
042800         MOVE SS08WS-CICS-FC-NOTFND TO MBIORO-TEMP-STATUS-1
042900         MOVE MBCA-MERCHANT-ORG  TO MBIOWS-MMMM-ORG
043000                                    MM07-ORG
043100         MOVE MBCA-MERCHANT      TO MBIOWS-MMMM-MERCHANT
043200                                    MM07-MERCHANT
043300         MOVE 'FC03'             TO MBCA-PROGRAM-LOCATION
043400         SET MBIORO-READ-RANDOM  TO TRUE
043500         PERFORM MMMMAO-ACCESS   THRU MMMMAO-ACCESS-EXIT
043600         IF  SS08WS-RC-FC-NOTFND
043700         AND MBCA-MBUI-UI-YES
043800             MOVE 'MBUI'         TO MBCA-TRANS-ID
043900                                    MBCA-PREV-TRANS-ID
044000             MOVE 01             TO MBCA-SCREEN-NBR
044100             MOVE 'MER'          TO MM07-FILLER
044200             SET MBCA-MBUI-ERROR-YES
044300                                 TO TRUE
044400             GO TO F000-SETUP-COMMAREA.
044500*
044600     IF (MBCA-PTI-FUNCTION-IS-MAINT
044700     AND MBCA-MBUI-UI-YES
044800     AND (MMMM-REC-PURGED
044900       OR MMMM-REC-INCOMPLETE))
045000     OR
045100        (MBCA-PTI-FUNCTION-IS-ADD
045200     AND MBCA-MBUI-UI-YES
045300     AND MMMM-REC-PURGED)
045400         MOVE 'MBUI'             TO MBCA-TRANS-ID
045500                                    MBCA-PREV-TRANS-ID
045600         MOVE 01                 TO MBCA-SCREEN-NBR
045700         MOVE 'MER'              TO MM07-FILLER
045800         SET MBCA-MBUI-ERROR-YES
045900                                 TO TRUE
046000         GO TO F000-SETUP-COMMAREA.
046100*
046200*****************************************
046300*    READ THE ORG CONTROL RECORD        *
046400*****************************************
046500*
046600     MOVE MBCA-MERCHANT-ORG      TO MBIOWS-MMOC-ORG.
046700     MOVE 'FC04'                 TO MBCA-PROGRAM-LOCATION.
046800     SET MBIORO-READ-RANDOM      TO TRUE.
046900     PERFORM MMOCAO-ACCESS       THRU MMOCAO-ACCESS-EXIT.
047000*
047100*********************************************
047200*    MOVE THE PRIMARY NAME TO THE SCREEN    *
047300*    AND OTHER FIELDS TO WS THAT ARE        *
047400*    NEEDED BY THE EDITS                    *
047500*********************************************
047600*
047700     MOVE MMMM-NA-LINE (1 1)     TO MM07-MERCHANT-NAME.
047800*
047900****************************************
048000*    READ THE FIELD SECURITY RECORD    *
048100****************************************
048200*
048300     MOVE 'FC05'                 TO MBCA-PROGRAM-LOCATION.
048400     PERFORM Y900-READ-MMFS      THRU Y909-READ-MMFS-EXIT.
048500*
048600 C020-FIELD-EDITS.
048700*
048800*********************
048900*    FIELD EDITS    *
049000*********************
049100*
049200     MOVE DFHBMDAS               TO MM07-TXN-ASSIGNMENT-LIT-A
049300                                    (14).
049400*
049500     PERFORM W010-EDIT-POST-REJECTS-FLAG
049600                                 THRU W019-EXIT.
049700*
049800     PERFORM W020-EDIT-SETT-FREQ1
049900                                 THRU W029-EXIT.
050000*
050100     PERFORM W030-EDIT-SETT-FREQ2
050200                                 THRU W039-EXIT.
050300*
050400     PERFORM W050-EDIT-DEST-METHOD-1
050500                                 THRU W059-EXIT.
050600*
050700     PERFORM W070-EDIT-COMB-DEPOSIT-FLAG
050800                                 THRU W079-EXIT.
050900*
051000     PERFORM W090-EDIT-DEST-METHOD-2
051100                                 THRU W099-EXIT.
051200*
051300     PERFORM W110-EDIT-PRINT-FAX
051400                                 THRU W119-EXIT.
051500*
051600     PERFORM W130-EDIT-DEST-METHOD-3
051700                                 THRU W139-EXIT.
051800*
051900     PERFORM W150-EDIT-SETT-NOTICE-FLAG
052000                                 THRU W159-EXIT.
052100*
052200     PERFORM W170-EDIT-DEST-METHOD-4
052300                                 THRU W179-EXIT.
052400*
052500     PERFORM W190-EDIT-ASSIGN-ACCT
052600                                 THRU W199-EXIT.
052700*
052800     PERFORM W210-EDIT-ASSIGN-USER-CODE
052900                                 THRU W219-EXIT.
053000*
053100***************************************************************
053200*                  CROSS EDITS                                *
053300***************************************************************
053400*
053500     IF  SS08WS-ERROR-SW-YES
053600         NEXT SENTENCE
053700     ELSE
053800         PERFORM W250-CROSS-EDIT-SETT
053900                                 THRU W259-EXIT.
054000/
054100 D000-RETURN-ERRORS SECTION.
054200*
054300     IF  SS08WS-ERROR-SW-NO
054400         GO TO E000-UPDATE-FILE.
054500*
054600     IF  MBCA-MBUI-UI-YES
054700         MOVE 'MBUI'             TO MBCA-TRANS-ID
054800                                    MBCA-PREV-TRANS-ID
054900         MOVE 01                 TO MBCA-SCREEN-NBR
055000         SET MBCA-MBUI-ERROR-YES TO TRUE
055100         GO TO F090-TRANSFER-XCTL.
055200*
055300***************************************************************
055400*    INITIALIZE THE STANDARD MAP LINES.  IN AN ERROR          *
055500*    CONDITION, THIS ROUTINE IS PERFORMED PRIMARILY           *
055600*    TO UPDATE THE DATE AND TIME ON THE SCREEN.               *
055700***************************************************************
055800*
055900     PERFORM MB60PD-INIT-STD-MAP-LINES
056000                                 THRU MB60PD-ISML-EXIT.
056100*
056200**********************
056300*    SEND THE MAP    *
056400**********************
056500*
056600     MOVE 'BM03'                 TO MBCA-PROGRAM-LOCATION.
056700     PERFORM MB60PD-SEND-MAP-DATA-ONLY
056800                                 THRU MB60PD-SMDO-EXIT.
056900*
057000************************
057100*    RETURN TO CICS    *
057200************************
057300*
057400     MOVE 'PC04'                 TO MBCA-PROGRAM-LOCATION.
057500     PERFORM MB70PD-RETURN-TRANS-ID
057600                                 THRU MB70PD-RTI-EXIT.
057700/
057800 E000-UPDATE-FILE SECTION.
057900*
058000     IF  MBCA-MBUI-UI-YES
058100         SET MBCA-MBUI-ERROR-NO  TO TRUE.
058200*
058300     IF  MBCA-MBUI-UI-YES
058400     AND MBCA-MBUI-UI-UPDATE-NO
058500         GO TO F090-TRANSFER-XCTL.
058600*
058700     MOVE MMMM-RECORD            TO MMMMIO-RECORD.
058800*
058900****************************************************
059000*    READ THE MERCHANT MASTER RECORD FOR UPDATE    *
059100****************************************************
059200*
059300     MOVE 'FC06'                 TO MBCA-PROGRAM-LOCATION.
059400     SET MBIORO-READ-RANDOM-UPDATE
059500                                 TO TRUE.
059600     PERFORM MMMMAO-ACCESS       THRU MMMMAO-ACCESS-EXIT.
059700*
059800     MOVE MMMMIO-RECORD          TO MMMM-RECORD.
059900*
060000*************************************
060100*    OBTAIN STORAGE FOR LOG FILE    *
060200*    RECORD IF DOING MAINTENANCE    *
060300*************************************
060400*
060500     MOVE 'SC04'                 TO MBCA-PROGRAM-LOCATION.
060600     SET MBIORO-GETMAIN          TO TRUE.
060700     PERFORM MML1AO-ACCESS       THRU MML1AO-ACCESS-EXIT.
060800*
060900*************************************************
061000*    SET UP THE COMMON PORTION OF THE RECORD    *
061100*************************************************
061200*
061300     MOVE 'MM'                   TO MML1-FILE-CODE.
061400     MOVE MBCA-MERCHANT-ORG      TO MML1-MMMM-ORG.
061500     MOVE MBCA-MERCHANT          TO MML1-MMMM-MERCHANT.
061600     MOVE MBCA-SIGNON-NAME       TO MML1-SIGNON-NAME.
061700     MOVE MBCA-TERMINAL-ID       TO MML1-TERMINAL-ID.
061800     MOVE ZEROS                  TO MML1-SOURCE-CODE.
061900     MOVE MBCA-FIELD-SECURITY    TO MML1-FIELD-SECURITY.
062000*
062100 E020-UPDATE-FIELDS.
062200*
062300     PERFORM X010-UPDATE-POST-REJECTS-FLAG
062400                                 THRU X019-EXIT.
062500*
062600     PERFORM X020-UPDATE-SETT-FREQ1
062700                                 THRU X029-EXIT.
062800*
062900     PERFORM X030-UPDATE-SETT-FREQ2
063000                                 THRU X039-EXIT.
063100*
063200     PERFORM X070-UPDATE-COMB-DEPOSIT-FLAG
063300                                 THRU X079-EXIT.
063400*
063500     PERFORM X110-UPDATE-PRINT-FAX
063600                                 THRU X119-EXIT.
063700*
063800     PERFORM X150-UPDATE-SETT-DETAIL-FLAG
063900                                 THRU X159-EXIT.
064000*
064100     PERFORM X190-UPDATE-ASSIGN-ACCT
064200                                 THRU X199-EXIT.
064300*
064400     PERFORM X210-UPDATE-ASSIGN-USER-CODE
064500                                 THRU X219-EXIT.
064600*
064700     PERFORM X230-UPDATE-PENDING-DATE
064800                                 THRU X239-EXIT.
064900*
065000     PERFORM X250-UPDATE-PRENOTE-DATA
065100                                 THRU X259-EXIT.
065200*
065300     IF  MBCA-PTI-FUNCTION-IS-MAINT
065400         PERFORM X170-UPDT-STORE-FREQS
065500                                 THRU X179-EXIT
065600         MOVE 'MM'               TO MML1-FILE-CODE
065700         MOVE MBCA-MERCHANT-ORG  TO MML1-MMMM-ORG
065800         MOVE MBCA-MERCHANT      TO MML1-MMMM-MERCHANT
065900         MOVE MBCA-SIGNON-NAME   TO MML1-SIGNON-NAME
066000         MOVE MBCA-TERMINAL-ID   TO MML1-TERMINAL-ID
066100         MOVE ZEROS              TO MML1-SOURCE-CODE
066200         MOVE MBCA-FIELD-SECURITY
066300                                 TO MML1-FIELD-SECURITY.
066400*
066500 E040-UPDATE-MMMM.
066600*
066700     IF  MBCA-PTI-FUNCTION-IS-ADD
066800         MOVE MBCA-SCREEN-NBR    TO MMMM-ONLINE-STATUS
066900         MOVE MBCA-START-DATE    TO MMMM-LAST-MAINT-DATE
067000         MOVE MBCA-OPERATOR-ID   TO MMMM-LAST-MAINT-OPER
067100         SET WS-UPDATE-SW-YES    TO TRUE.
067200*
067300**************************************************************
067400*    WRITE A LOG RECORD TO SHOW THAT THE LAST MAINT DATE     *
067500*    AND OPERATOR HAS BEEN UPDATED IF FIELDS WERE CHANGED    *
067600*    ON THE SCREEN                                           *
067700**************************************************************
067800*
067900     IF  MBCA-PTI-FUNCTION-IS-MAINT
068000     AND WS-UPDATE-SW-YES
068100         MOVE 0198               TO MML1-FIELD-CODE
068200         MOVE ZEROES             TO MML1-FIELD-OCCURRENCE
068300                                    MML1-FIELD-OCCURRENCE-2
068400         MOVE MML1WS-VL-03       TO MML1-VARIABLE-LENGTH
068500         MOVE MMMM-LAST-MAINT-OPER
068600                                 TO MML1-VL03-B-DATA-X
068700         MOVE MBCA-OPERATOR-ID   TO MMMM-LAST-MAINT-OPER
068800         MOVE MMMM-LAST-MAINT-OPER
068900                                 TO MML1-VL03-A-DATA-X
069000         MOVE 'FC07'             TO MBCA-PROGRAM-LOCATION
069100         PERFORM Y910-WRITE-LOG-RECORD
069200                                 THRU Y919-WLR-EXIT
069300         MOVE 0199               TO MML1-FIELD-CODE
069400         MOVE MML1WS-VL-07       TO MML1-VARIABLE-LENGTH
069500         MOVE MMMM-LAST-MAINT-DATE
069600                                 TO MML1-VL07-B-DATA-9
069700         MOVE MBCA-START-DATE    TO MMMM-LAST-MAINT-DATE
069800         MOVE MMMM-LAST-MAINT-DATE
069900                                 TO MML1-VL07-A-DATA-9
070000         MOVE 'FC08'             TO MBCA-PROGRAM-LOCATION
070100         PERFORM Y910-WRITE-LOG-RECORD
070200                                 THRU Y919-WLR-EXIT.
070300*
070400****************************************************
070500*    REWRITE THE MERCHANT MASTER RECORD IF         *
070600*    FIELDS HAVE BEEN CHANGED ON THE SCREEN, OR    *
070700*    UNLOCK IT IF THEY HAVE NOT                    *
070800****************************************************
070900*
071000     IF  WS-UPDATE-SW-YES
071100         MOVE 'FC09'             TO MBCA-PROGRAM-LOCATION
071200         SET MBIORO-REWRITE      TO TRUE
071300         PERFORM MMMMAO-ACCESS   THRU MMMMAO-ACCESS-EXIT
071400     ELSE
071500         MOVE 'FC10'             TO MBCA-PROGRAM-LOCATION
071600         SET MBIORO-UNLOCK       TO TRUE
071700         PERFORM MMMMAO-ACCESS   THRU MMMMAO-ACCESS-EXIT.
071800/
071900 F000-SETUP-COMMAREA SECTION.
072000*
072100***************************************************************
072200*  SET UP COMMAREA FIELDS AND TRANSFER TO THE NEXT PROGRAM    *
072300***************************************************************
072400*
072500     MOVE MBCA-EIBAID            TO SS08WS-EIBAID.
072600*
072700     IF  MM07-CURRENT-PAGE-L IS GREATER THAN ZERO
072800     AND MM07-CURRENT-PAGE   IS NUMERIC
072900         IF  MM07-CURRENT-PAGE IS GREATER THAN 13
073000             MOVE 63             TO MBCA-SCREEN-NBR
073100             GO TO F090-TRANSFER-XCTL.
073200*
073300     PERFORM MB60PD-EDIT-PAGE-NBR
073400                                 THRU MB60PD-EPN-EXIT.
073500*
073600     IF  SS08WS-VALID-PF-KEY
073700     OR  SS08WS-EIBAID-VALID-PF-KEY
073800         SET MBCA-INITIAL-SCREEN-NBR
073900                                 TO TRUE.
074000*
074100 F090-TRANSFER-XCTL.
074200*
074300     IF  MBCA-MBUI-UI-YES
074400         MOVE 'MBUI'             TO MBCA-TRANS-ID
074500                                    MBCA-PREV-TRANS-ID
074600         MOVE 01                 TO MBCA-SCREEN-NBR
074700         MOVE MBMM07I            TO MBUITS-VAR-DATA
074800         MOVE LENGTH OF MBMM07I  TO MBUITS-VAR-LENGTH
074900         MOVE 'TS10'             TO MBCA-PROGRAM-LOCATION
075000         EXEC CICS WRITEQ TS
075100                   QUEUE   (TS-QUEUE-NAME)
075200                   FROM    (MBUITS-RECORD)
075300                   LENGTH  (LENGTH  OF MBUITS-RECORD)
075400
075500              END-EXEC.
075600*
075700     MOVE 'PC05'                 TO MBCA-PROGRAM-LOCATION.
075800     PERFORM MB70PD-XCTL-TO-MBOXCTL
075900                                 THRU MB70PD-XTM-EXIT.
076000/
076100 W000-FIELD-EDITS SECTION.
076200*
076300*********************************************************
076400*    EACH FIELD IS CODED IN A SEPERATE ROUTINE, AND     *
076500*    IN A LIKE MANNER.  THE COMMENTS FOR THE FLOW OF    *
076600*    THE EDIT ROUTINES CAN BE FOUND IN ROUTINES         *
076700*    'W010-EDIT-POST-FLAG  ' THRU 'W019-EXIT'.          *
076800*    EACH ROUTINE MAY CONTAIN COMMENTS, BUT THEY        *
076900*    ARE UNIQUE TO THAT ROUTINE.                        *
077000*********************************************************
077100*
077200 W010-EDIT-POST-REJECTS-FLAG.
077300*
077400     MOVE DFHBMDAS               TO MM07-POST-REJECTS-FLAG-LP-A
077500                                    MM07-POST-REJECTS-FLAG-RP-A.
077600     MOVE DFHBMASK               TO MM07-POST-REJECTS-FLAG-A.
077700*
077800     PERFORM Y015-POST-REJECTS-SECURITY
077900                                 THRU Y019-EXIT.
078000*
078100     IF  MM07-POST-REJECTS-FLAG-L IS GREATER THAN ZERO
078200         MOVE DFHBMASF           TO MM07-POST-REJECTS-FLAG-A
078300     ELSE
078400         MOVE MMMM-POST-REJECTS-FLAG
078500                                 TO MM07-POST-REJECTS-FLAG.
078600*
078700     IF  MM07-VALID-POST-REJECTS-FLAG
078800         NEXT SENTENCE
078900     ELSE
079000         GO TO W018-POST-REJECTS-ERROR.
079100*
079200     IF  MBCA-PTI-FUNCTION-IS-MAINT
079300     OR  MM07-POST-REJECTS-FLAG-L IS GREATER THAN ZERO
079400     OR  NOT MMFS-MT-REQUIRED (X-MMFS-MERCH)
079500         GO TO W019-EXIT.
079600*
079700 W018-POST-REJECTS-ERROR.
079800*
079900     IF  MM07-POST-REJECTS-FLAG-L IS GREATER THAN ZERO
080000         MOVE DFHBMUBF           TO MM07-POST-REJECTS-FLAG-A
080100     ELSE
080200         MOVE DFHBMBRY           TO MM07-POST-REJECTS-FLAG-A.
080300*
080400     SET SS08WS-ERROR-SW-YES     TO TRUE.
080500     MOVE DFHBMASB               TO MM07-POST-REJECTS-FLAG-LP-A
080600                                    MM07-POST-REJECTS-FLAG-RP-A.
080700     MOVE SS08WS-CURSOR          TO MM07-POST-REJECTS-FLAG-L.
080800*
080900 W019-EXIT.
081000     EXIT.
081100*
081200 W020-EDIT-SETT-FREQ1.
081300*
081400     MOVE DFHBMDAS               TO MM07-SETT-FREQ1-LP-A
081500                                    MM07-SETT-FREQ1-RP-A.
081600     MOVE DFHBMASK               TO MM07-SETT-FREQ1-A.
081700*
081800     PERFORM Y025-SETT-FREQ1-SECURITY
081900                                 THRU Y029-EXIT.
082000*
082100     IF  MM07-SETT-FREQ1-L IS GREATER THAN ZERO
082200         MOVE DFHBMASF           TO MM07-SETT-FREQ1-A
082300     ELSE
082400         MOVE MMMM-SETT-FREQ-1   TO MM07-SETT-FREQ1.
082500*
082600     IF  MM07-SETT-FREQ1 IS NUMERIC
082700     AND MM07-SF1-VALID-FREQ-SETT
082800         NEXT SENTENCE
082900     ELSE
083000         GO TO W028-SETT-FREQ1-ERROR.
083100*
083200     IF  MBCA-PTI-FUNCTION-IS-MAINT
083300     OR  MM07-SETT-FREQ1-L IS GREATER THAN ZERO
083400     OR  NOT MMFS-MT-REQUIRED (X-MMFS-MERCH)
083500         GO TO W029-EXIT.
083600*
083700 W028-SETT-FREQ1-ERROR.
083800*
083900     IF  MM07-SETT-FREQ1-L IS GREATER THAN ZERO
084000         MOVE DFHBMNBF           TO MM07-SETT-FREQ1-A
084100     ELSE
084200         MOVE DFHBMUNB           TO MM07-SETT-FREQ1-A.
084300*
084400     SET SS08WS-ERROR-SW-YES     TO TRUE.
084500     MOVE DFHBMASB               TO MM07-SETT-FREQ1-LP-A
084600                                    MM07-SETT-FREQ1-RP-A.
084700     MOVE SS08WS-CURSOR          TO MM07-SETT-FREQ1-L.
084800*
084900 W029-EXIT.
085000     EXIT.
085100*
085200 W030-EDIT-SETT-FREQ2.
085300*
085400     MOVE DFHBMDAS               TO MM07-SETT-FREQ2-LP-A
085500                                    MM07-SETT-FREQ2-RP-A.
085600     MOVE DFHBMASK               TO MM07-SETT-FREQ2-A.
085700*
085800     PERFORM Y035-SETT-FREQ2-SECURITY
085900                                 THRU Y039-EXIT.
086000*
086100     IF  MM07-SETT-FREQ2-L IS GREATER THAN ZERO
086200         MOVE DFHBMASF           TO MM07-SETT-FREQ2-A
086300     ELSE
086400         MOVE MMMM-SETT-FREQ-2   TO MM07-SETT-FREQ2.
086500*
086600     IF  MM07-SETT-FREQ2 IS NUMERIC
086700     AND MM07-SF2-VALID-FREQ-SETT
086800         NEXT SENTENCE
086900     ELSE
087000         GO TO W038-SETT-FREQ2-ERROR.
087100*
087200     IF  MBCA-PTI-FUNCTION-IS-MAINT
087300     OR  MM07-SETT-FREQ2-L IS GREATER THAN ZERO
087400     OR  NOT MMFS-MT-REQUIRED (X-MMFS-MERCH)
087500         GO TO W039-EXIT.
087600*
087700 W038-SETT-FREQ2-ERROR.
087800*
087900     IF  MM07-SETT-FREQ2-L IS GREATER THAN ZERO
088000         MOVE DFHBMNBF           TO MM07-SETT-FREQ2-A
088100     ELSE
088200         MOVE DFHBMUNB           TO MM07-SETT-FREQ2-A.
088300*
088400     SET SS08WS-ERROR-SW-YES     TO TRUE.
088500     MOVE DFHBMASB               TO MM07-SETT-FREQ2-LP-A
088600                                    MM07-SETT-FREQ2-RP-A.
088700     MOVE SS08WS-CURSOR          TO MM07-SETT-FREQ2-L.
088800*
088900 W039-EXIT.
089000     EXIT.
089100*
089200 W050-EDIT-DEST-METHOD-1.
089300*
089400     MOVE DFHBMASK               TO MM07-SETT-ACCT-1-ACTIVE-A
089500                                    MM07-SETT-ACCT-1-INTERIM-A
089600                                    MM07-SETT-ACCT-1-MIGRAT-A.
089700*
089800     PERFORM Y055-DEST-METHOD-1-SECURITY
089900                                 THRU Y059-EXIT.
090000*
090100     MOVE MMMM-SETT-ACCT-1-METHOD
090200                                 TO MM07-SETT-ACCT-1-ACTIVE.
090300     MOVE MMMM-PENDING-SETT-ACCT-METH (1)
090400                                 TO MM07-SETT-ACCT-1-MIGRAT.
090500     MOVE MMMM-INTERIM-SETT-ACCT-METH (1)
090600                                 TO MM07-SETT-ACCT-1-INTERIM.
090700*
090800     GO TO W059-EXIT.
090900*
091000 W058-DEST-METHOD-1-ERROR.
091100*
091200     MOVE DFHBMBRY               TO MM07-SETT-ACCT-1-ACTIVE-A
091300                                    MM07-SETT-ACCT-1-MIGRAT-A
091400                                    MM07-SETT-ACCT-1-INTERIM-A.
091500*
091600     SET SS08WS-ERROR-SW-YES     TO TRUE.
091700     MOVE SS08WS-CURSOR          TO MM07-SETT-ACCT-1-ACTIVE-L.
091800*
091900 W059-EXIT.
092000     EXIT.
092100*
092200 W070-EDIT-COMB-DEPOSIT-FLAG.
092300*
092400     MOVE DFHBMDAS               TO MM07-ACH-DEPOSIT-LP-A
092500                                    MM07-ACH-DEPOSIT-RP-A.
092600     MOVE DFHBMASK               TO MM07-ACH-DEPOSIT-A.
092700*
092800     PERFORM Y075-ACH-DEPOSIT-SECURITY
092900                                 THRU Y079-EXIT.
093000*
093100     IF  MM07-ACH-DEPOSIT-L IS GREATER THAN ZERO
093200         MOVE DFHBMASF           TO MM07-ACH-DEPOSIT-A
093300     ELSE
093400         MOVE MMMM-SETT-COMB-DEPOSIT-FLAG
093500                                 TO MM07-ACH-DEPOSIT.
093600*
093700     IF  MM07-ACH-DEPOSIT-VALID
093800         NEXT SENTENCE
093900     ELSE
094000         GO TO W078-ACH-DEPOSIT-ERROR.
094100*
094200     IF  MBCA-PTI-FUNCTION-IS-MAINT
094300     OR  MM07-ACH-DEPOSIT-L IS GREATER THAN ZERO
094400     OR  NOT MMFS-MT-REQUIRED (X-MMFS-MERCH)
094500         GO TO W079-EXIT.
094600*
094700 W078-ACH-DEPOSIT-ERROR.
094800*
094900     IF  MM07-ACH-DEPOSIT-L IS GREATER THAN ZERO
095000         MOVE DFHBMUBF           TO MM07-ACH-DEPOSIT-A
095100     ELSE
095200         MOVE DFHBMBRY           TO MM07-ACH-DEPOSIT-A.
095300*
095400     SET SS08WS-ERROR-SW-YES     TO TRUE.
095500     MOVE DFHBMASB               TO MM07-ACH-DEPOSIT-LP-A
095600                                    MM07-ACH-DEPOSIT-RP-A.
095700     MOVE SS08WS-CURSOR          TO MM07-ACH-DEPOSIT-L.
095800*
095900 W079-EXIT.
096000     EXIT.
096100*
096200 W090-EDIT-DEST-METHOD-2.
096300*
096400     MOVE DFHBMASK               TO MM07-SETT-ACCT-2-ACTIVE-A
096500                                    MM07-SETT-ACCT-2-INTERIM-A
096600                                    MM07-SETT-ACCT-2-MIGRAT-A.
096700*
096800     PERFORM Y095-DEST-METHOD-2-SECURITY
096900                                 THRU Y099-EXIT.
097000*
097100     MOVE MMMM-SETT-ACCT-2-METHOD
097200                                 TO MM07-SETT-ACCT-2-ACTIVE.
097300     MOVE MMMM-PENDING-SETT-ACCT-METH (2)
097400                                 TO MM07-SETT-ACCT-2-MIGRAT.
097500     MOVE MMMM-INTERIM-SETT-ACCT-METH (2)
097600                                 TO MM07-SETT-ACCT-2-INTERIM.
097700*
097800     GO TO W099-EXIT.
097900*
098000 W098-DEST-METHOD-2-ERROR.
098100*
098200     MOVE DFHBMBRY               TO MM07-SETT-ACCT-2-ACTIVE-A
098300                                    MM07-SETT-ACCT-2-MIGRAT-A
098400                                    MM07-SETT-ACCT-2-INTERIM-A.
098500*
098600     SET SS08WS-ERROR-SW-YES     TO TRUE.
098700     MOVE SS08WS-CURSOR          TO MM07-SETT-ACCT-2-ACTIVE-L.
098800*
098900 W099-EXIT.
099000     EXIT.
099100*
099200 W110-EDIT-PRINT-FAX.
099300*
099400     MOVE DFHBMDAS               TO MM07-PRINT-FAX-LP-A
099500                                    MM07-PRINT-FAX-RP-A.
099600     MOVE DFHBMASK               TO MM07-PRINT-FAX-A.
099700*
099800     PERFORM Y115-PRINT-FAX-SECURITY
099900                                 THRU Y119-EXIT.
100000*
100100     IF  MM07-PRINT-FAX-L IS GREATER THAN ZERO
100200         MOVE DFHBMASF           TO MM07-PRINT-FAX-A
100300     ELSE
100400         MOVE MMMM-SETT-NOTICE-RPT-FLAG
100500                                 TO MM07-PRINT-FAX.
100600*
100700     IF  MM07-PRINT-FAX-VALID
100800         NEXT SENTENCE
100900     ELSE
101000         GO TO W118-PRINT-FAX-ERROR.
101100*
101200     IF  MBCA-PTI-FUNCTION-IS-MAINT
101300     OR  MM07-PRINT-FAX-L IS GREATER THAN ZERO
101400     OR  NOT MMFS-MT-REQUIRED (X-MMFS-MERCH)
101500         GO TO W119-EXIT.
101600*
101700 W118-PRINT-FAX-ERROR.
101800*
101900     IF  MM07-PRINT-FAX-L IS GREATER THAN ZERO
102000         MOVE DFHBMUBF           TO MM07-PRINT-FAX-A
102100     ELSE
102200         MOVE DFHBMBRY           TO MM07-PRINT-FAX-A.
102300*
102400     SET SS08WS-ERROR-SW-YES     TO TRUE.
102500     MOVE DFHBMASB               TO MM07-PRINT-FAX-LP-A
102600                                    MM07-PRINT-FAX-RP-A.
102700     MOVE SS08WS-CURSOR          TO MM07-PRINT-FAX-L.
102800*
102900 W119-EXIT.
103000     EXIT.
103100*
103200 W130-EDIT-DEST-METHOD-3.
103300*
103400     MOVE DFHBMASK               TO MM07-SETT-ACCT-3-ACTIVE-A
103500                                    MM07-SETT-ACCT-3-INTERIM-A
103600                                    MM07-SETT-ACCT-3-MIGRAT-A.
103700*
103800     PERFORM Y135-DEST-METHOD-3-SECURITY
103900                                 THRU Y139-EXIT.
104000*
104100     MOVE MMMM-SETT-ACCT-3-METHOD
104200                                 TO MM07-SETT-ACCT-3-ACTIVE.
104300     MOVE MMMM-PENDING-SETT-ACCT-METH (3)
104400                                 TO MM07-SETT-ACCT-3-MIGRAT.
104500     MOVE MMMM-INTERIM-SETT-ACCT-METH (3)
104600                                 TO MM07-SETT-ACCT-3-INTERIM.
104700*
104800     GO TO W139-EXIT.
104900*
105000 W138-DEST-METHOD-3-ERROR.
105100*
105200     MOVE DFHBMBRY               TO MM07-SETT-ACCT-3-ACTIVE-A
105300                                    MM07-SETT-ACCT-3-MIGRAT-A
105400                                    MM07-SETT-ACCT-3-INTERIM-A.
105500*
105600     SET SS08WS-ERROR-SW-YES     TO TRUE.
105700     MOVE SS08WS-CURSOR          TO MM07-SETT-ACCT-3-ACTIVE-L.
105800*
105900 W139-EXIT.
106000     EXIT.
106100*
106200 W150-EDIT-SETT-NOTICE-FLAG.
106300*
106400     MOVE DFHBMDAS               TO MM07-DETAIL-TXNS-LP-A
106500                                    MM07-DETAIL-TXNS-RP-A.
106600     MOVE DFHBMASK               TO MM07-DETAIL-TXNS-A.
106700*
106800     PERFORM Y155-SETT-NOTICE-FLAG-SECURITY
106900                                 THRU Y159-EXIT.
107000*
107100     IF  MM07-DETAIL-TXNS-L IS GREATER THAN ZERO
107200         MOVE DFHBMASF           TO MM07-DETAIL-TXNS-A
107300     ELSE
107400         MOVE MMMM-SETT-NOTICE-DETAIL-FLAG
107500                                 TO MM07-DETAIL-TXNS.
107600*
107700     IF  MM07-VALID-DETAIL-TXNS
107800         NEXT SENTENCE
107900     ELSE
108000         GO TO W158-SETT-NOTICE-ERROR.
108100*
108200     IF  MBCA-PTI-FUNCTION-IS-MAINT
108300     OR  MM07-DETAIL-TXNS-L IS GREATER THAN ZERO
108400     OR  NOT MMFS-MT-REQUIRED (X-MMFS-MERCH)
108500         GO TO W159-EXIT.
108600*
108700 W158-SETT-NOTICE-ERROR.
108800*
108900     IF  MM07-DETAIL-TXNS-L IS GREATER THAN ZERO
109000         MOVE DFHBMUBF           TO MM07-DETAIL-TXNS-A
109100     ELSE
109200         MOVE DFHBMBRY           TO MM07-DETAIL-TXNS-A.
109300*
109400     SET SS08WS-ERROR-SW-YES     TO TRUE.
109500     MOVE DFHBMASB               TO MM07-DETAIL-TXNS-LP-A
109600                                    MM07-DETAIL-TXNS-RP-A.
109700     MOVE SS08WS-CURSOR          TO MM07-DETAIL-TXNS-L.
109800*
109900 W159-EXIT.
110000     EXIT.
110100*
110200 W170-EDIT-DEST-METHOD-4.
110300*
110400     MOVE DFHBMASK               TO MM07-SETT-ACCT-4-ACTIVE-A
110500                                    MM07-SETT-ACCT-4-INTERIM-A
110600                                    MM07-SETT-ACCT-4-MIGRAT-A.
110700*
110800     PERFORM Y175-DEST-METHOD-4-SECURITY
110900                                 THRU Y179-EXIT.
111000*
111100     MOVE MMMM-SETT-ACCT-4-METHOD
111200                                 TO MM07-SETT-ACCT-4-ACTIVE.
111300     MOVE MMMM-PENDING-SETT-ACCT-METH (4)
111400                                 TO MM07-SETT-ACCT-4-MIGRAT.
111500     MOVE MMMM-INTERIM-SETT-ACCT-METH (4)
111600                                 TO MM07-SETT-ACCT-4-INTERIM.
111700*
111800     GO TO W179-EXIT.
111900*
112000 W178-DEST-METHOD-4-ERROR.
112100*
112200     MOVE DFHBMBRY               TO MM07-SETT-ACCT-4-ACTIVE-A
112300                                    MM07-SETT-ACCT-4-MIGRAT-A
112400                                    MM07-SETT-ACCT-4-INTERIM-A.
112500*
112600     SET SS08WS-ERROR-SW-YES     TO TRUE.
112700     MOVE SS08WS-CURSOR          TO MM07-SETT-ACCT-4-ACTIVE-L.
112800*
112900 W179-EXIT.
113000     EXIT.
113100*
113200 W190-EDIT-ASSIGN-ACCT.
113300*
113400     SET X-MM07-TAT              TO 1.
113500     SET X-MMMM-TAT              TO 1.
113600     MOVE MMMMTB-TAT-ACCT-1 (1:4)
113700                                 TO WS-INDEX-X.
113800     SET X-MMFS-MERCH            TO WS-INDEX.
113900*
114000 W191-TAT-ACCT-LOOP.
114100*
114200     MOVE DFHBMDAS               TO MM07-TAT-ACCOUNT-LP-A
114300                                    (X-MM07-TAT)
114400                                    MM07-TAT-ACCOUNT-RP-A
114500                                    (X-MM07-TAT).
114600     MOVE DFHBMASK               TO MM07-TAT-ACCOUNT-A
114700                                    (X-MM07-TAT).
114800*
114900     PERFORM Y195-ASSIGN-ACCT-SECURITY
115000                                 THRU Y196-EXIT.
115100*
115200     IF  X-MM07-TAT IS EQUAL TO 14
115300         GO TO W196-EXIT.
115400*
115500     IF  MM07-TAT-ACCOUNT-L (X-MM07-TAT)
115600                               IS GREATER THAN ZERO
115700         IF  MMFS-MT-REQUIRED (X-MMFS-MERCH)
115800             MOVE DFHBMASF       TO MM07-TAT-ACCOUNT-A
115900                                    (X-MM07-TAT)
116000             MOVE DFHBMDAS       TO MM07-TAT-ACCOUNT-LP-A
116100                                    (X-MM07-TAT)
116200                                    MM07-TAT-ACCOUNT-RP-A
116300                                    (X-MM07-TAT)
116400         ELSE
116500             MOVE DFHBMASF       TO MM07-TAT-ACCOUNT-A
116600                                    (X-MM07-TAT)
116700             MOVE DFHBMDAS       TO MM07-TAT-ACCOUNT-LP-A
116800                                    (X-MM07-TAT)
116900                                    MM07-TAT-ACCOUNT-RP-A
117000                                    (X-MM07-TAT)
117100     ELSE
117200         MOVE MMMM-TAT-ACCOUNT (X-MMMM-TAT)
117300                                 TO MM07-TAT-ACCOUNT
117400                                    (X-MM07-TAT).
117500*
117600     IF  MM07-TAT-VALID-ACCOUNTS (X-MM07-TAT)
117700         NEXT SENTENCE
117800     ELSE
117900         GO TO W198-TAT-ACCOUNT-ERROR.
118000*
118100     IF  X-MM07-TAT IS EQUAL TO 2
118200     OR  X-MM07-TAT IS EQUAL TO 16
118300         IF  MM07-TAT-VALID-S1-ACCOUNTS (X-MM07-TAT)
118400             NEXT SENTENCE
118500         ELSE
118600             GO TO W198-TAT-ACCOUNT-ERROR.
118700*
118800     IF  MBCA-PTI-FUNCTION-IS-MAINT
118900     OR  MM07-TAT-ACCOUNT-L (X-MM07-TAT)
119000                               IS GREATER THAN ZERO
119100     OR  NOT MMFS-MT-REQUIRED (X-MMFS-MERCH)
119200         GO TO W196-EXIT.
119300*
119400 W198-TAT-ACCOUNT-ERROR.
119500*
119600     IF  MM07-TAT-ACCOUNT-L (X-MM07-TAT)
119700                               IS GREATER THAN ZERO
119800         MOVE DFHBMUBF           TO MM07-TAT-ACCOUNT-A
119900                                    (X-MM07-TAT)
120000     ELSE
120100         MOVE DFHBMBRY           TO MM07-TAT-ACCOUNT-A
120200                                    (X-MM07-TAT).
120300*
120400     SET SS08WS-ERROR-SW-YES     TO TRUE.
120500     MOVE DFHBMASB               TO MM07-TAT-ACCOUNT-LP-A
120600                                    (X-MM07-TAT)
120700                                    MM07-TAT-ACCOUNT-RP-A
120800                                    (X-MM07-TAT).
120900     MOVE SS08WS-CURSOR          TO MM07-TAT-ACCOUNT-L
121000                                    (X-MM07-TAT).
121100*
121200 W196-EXIT.
121300     EXIT.
121400*
121500 W198-INCREMENT-INDEXES.
121600*
121700     IF  X-MM07-TAT IS LESS THAN 16
121800         SET X-MM07-TAT          UP BY 1
121900         SET X-MMMM-TAT          UP BY 1
122000         SET X-MMFS-MERCH        UP BY 2
122100         GO TO W191-TAT-ACCT-LOOP.
122200*
122300 W199-EXIT.
122400     EXIT.
122500*
122600 W210-EDIT-ASSIGN-USER-CODE.
122700*
122800     SET X-MM07-TAT              TO 1.
122900     SET X-MMMM-TAT              TO 1.
123000     MOVE MMMMTB-TAT-USER-CODE-1 (1:4)
123100                                 TO WS-INDEX-X.
123200     SET X-MMFS-MERCH            TO WS-INDEX.
123300*
123400 W211-TAT-USER-CODE-LOOP.
123500*
123600     MOVE DFHBMDAS               TO MM07-TAT-USER-CODE-LP-A
123700                                    (X-MM07-TAT)
123800                                    MM07-TAT-USER-CODE-RP-A
123900                                    (X-MM07-TAT).
124000     MOVE DFHBMASK               TO MM07-TAT-USER-CODE-A
124100                                    (X-MM07-TAT).
124200*
124300     PERFORM Y215-ASSIGN-USER-CODE-SECURITY
124400                                 THRU Y216-EXIT.
124500*
124600     IF  X-MM07-TAT IS EQUAL TO 14
124700         GO TO W216-EXIT.
124800*
124900     IF  MM07-TAT-USER-CODE-L (X-MM07-TAT)
125000                               IS GREATER THAN ZERO
125100         MOVE DFHBMASF           TO MM07-TAT-USER-CODE-A
125200                                    (X-MM07-TAT)
125300         MOVE DFHBMDAS           TO MM07-TAT-USER-CODE-LP-A
125400                                    (X-MM07-TAT)
125500                                    MM07-TAT-USER-CODE-RP-A
125600                                    (X-MM07-TAT)
125700     ELSE
125800         MOVE MMMM-TAT-USER-CODE (X-MMMM-TAT)
125900                                 TO MM07-TAT-USER-CODE
126000                                    (X-MM07-TAT).
126100*
126200     IF  MM07-TAT-VALID-USER-CODE (X-MM07-TAT)
126300         NEXT SENTENCE
126400     ELSE
126500         GO TO W215-TAT-USER-CODE-ERROR.
126600*
126700     IF  MBCA-PTI-FUNCTION-IS-MAINT
126800     OR  MM07-TAT-USER-CODE-L (X-MM07-TAT)
126900                               IS GREATER THAN ZERO
127000     OR  NOT MMFS-MT-REQUIRED (X-MMFS-MERCH)
127100         GO TO W216-EXIT.
127200*
127300 W215-TAT-USER-CODE-ERROR.
127400*
127500     IF  MM07-TAT-USER-CODE-L (X-MM07-TAT)
127600                               IS GREATER THAN ZERO
127700         MOVE DFHBMUBF           TO MM07-TAT-USER-CODE-A
127800                                    (X-MM07-TAT)
127900     ELSE
128000         MOVE DFHBMBRY           TO MM07-TAT-USER-CODE-A
128100                                    (X-MM07-TAT).
128200*
128300     SET SS08WS-ERROR-SW-YES     TO TRUE.
128400     MOVE DFHBMASB               TO MM07-TAT-USER-CODE-LP-A
128500                                    (X-MM07-TAT)
128600                                    MM07-TAT-USER-CODE-RP-A
128700                                    (X-MM07-TAT).
128800     MOVE SS08WS-CURSOR          TO MM07-TAT-USER-CODE-L
128900                                    (X-MM07-TAT).
129000*
129100 W216-EXIT.
129200     EXIT.
129300*
129400 W218-INCREMENT-INDEXES.
129500*
129600     IF  X-MM07-TAT IS LESS THAN 16
129700         SET X-MM07-TAT          UP BY 1
129800         SET X-MMMM-TAT          UP BY 1
129900         SET X-MMFS-MERCH        UP BY 2
130000         GO TO W211-TAT-USER-CODE-LOOP.
130100*
130200 W219-EXIT.
130300     EXIT.
130400*
130500 W250-CROSS-EDIT-SETT.
130600*
130700     PERFORM
130800         VARYING X-MM07-TAT FROM 1 BY 1
130900         UNTIL X-MM07-TAT IS GREATER THAN 16
131000         EVALUATE TRUE
131100           WHEN MM07-TAT-ACCOUNT (X-MM07-TAT)
131200                                 IS EQUAL TO 'S1'
131300             EVALUATE TRUE
131400               WHEN (MM07-SETT-ACCT-1-ACTIVE
131500                                 IS NOT EQUAL TO 'N0'
131600                 OR MM07-SETT-ACCT-1-INTERIM
131700                                 IS NOT EQUAL TO 'N0')
131800                    CONTINUE
131900               WHEN OTHER
132000                 SET WS-ACCOUNT-ERROR-YES
132100                                 TO TRUE
132200             END-EVALUATE
132300         END-EVALUATE
132400         EVALUATE TRUE
132500           WHEN MM07-TAT-ACCOUNT (X-MM07-TAT)
132600                                 IS EQUAL TO 'S2'
132700             EVALUATE TRUE
132800               WHEN (MM07-SETT-ACCT-2-ACTIVE
132900                                 IS NOT EQUAL TO 'N0'
133000                 OR MM07-SETT-ACCT-2-INTERIM
133100                                 IS NOT EQUAL TO 'N0')
133200                    CONTINUE
133300               WHEN OTHER
133400                 SET WS-ACCOUNT-ERROR-YES
133500                                 TO TRUE
133600             END-EVALUATE
133700         END-EVALUATE
133800         EVALUATE TRUE
133900           WHEN MM07-TAT-ACCOUNT (X-MM07-TAT)
134000                                 IS EQUAL TO 'S3'
134100             EVALUATE TRUE
134200               WHEN (MM07-SETT-ACCT-3-ACTIVE
134300                                 IS NOT EQUAL TO 'N0'
134400                 OR MM07-SETT-ACCT-3-INTERIM
134500                                 IS NOT EQUAL TO 'N0')
134600                    CONTINUE
134700               WHEN OTHER
134800                 SET WS-ACCOUNT-ERROR-YES
134900                                 TO TRUE
135000             END-EVALUATE
135100         END-EVALUATE
135200         EVALUATE TRUE
135300           WHEN MM07-TAT-ACCOUNT (X-MM07-TAT)
135400                                 IS EQUAL TO 'S4'
135500             EVALUATE TRUE
135600               WHEN (MM07-SETT-ACCT-4-ACTIVE
135700                                 IS NOT EQUAL TO 'N0'
135800                 OR MM07-SETT-ACCT-4-INTERIM
135900                                 IS NOT EQUAL TO 'N0')
136000                    CONTINUE
136100               WHEN OTHER
136200                 SET WS-ACCOUNT-ERROR-YES
136300                                 TO TRUE
136400             END-EVALUATE
136500         END-EVALUATE
136600         EVALUATE TRUE
136700           WHEN MM07-TAT-ACCOUNT (X-MM07-TAT)
136800                                 IS EQUAL TO 'B1'
136900             EVALUATE TRUE
137000               WHEN MMMM-BUF-NOT-ACTIVE (1)
137100                 SET WS-ACCOUNT-ERROR-YES
137200                                 TO TRUE
137300             END-EVALUATE
137400         END-EVALUATE
137500         EVALUATE TRUE
137600           WHEN MM07-TAT-ACCOUNT (X-MM07-TAT)
137700                                 IS EQUAL TO 'B2'
137800             EVALUATE TRUE
137900               WHEN MMMM-BUF-NOT-ACTIVE (2)
138000                 SET WS-ACCOUNT-ERROR-YES
138100                                 TO TRUE
138200             END-EVALUATE
138300         END-EVALUATE
138400         EVALUATE TRUE
138500           WHEN MM07-TAT-ACCOUNT (X-MM07-TAT)
138600                                 IS EQUAL TO 'B3'
138700             EVALUATE TRUE
138800               WHEN MMMM-BUF-NOT-ACTIVE (3)
138900                 SET WS-ACCOUNT-ERROR-YES
139000                                 TO TRUE
139100             END-EVALUATE
139200         END-EVALUATE
139300         EVALUATE TRUE
139400           WHEN MM07-TAT-ACCOUNT (X-MM07-TAT)
139500                                 IS EQUAL TO 'B4'
139600             EVALUATE TRUE
139700               WHEN MMMM-BUF-NOT-ACTIVE (4)
139800                 SET WS-ACCOUNT-ERROR-YES
139900                                 TO TRUE
140000             END-EVALUATE
140100         END-EVALUATE
140200         IF      WS-ACCOUNT-ERROR-YES
140300             SET WS-ACCOUNT-ERROR-NO
140400                                 TO TRUE
140500             MOVE DFHBMUBF       TO MM07-TAT-ACCOUNT-A
140600                                    (X-MM07-TAT)
140700             SET SS08WS-ERROR-SW-YES
140800                                 TO TRUE
140900             MOVE DFHBMASB       TO MM07-TAT-ACCOUNT-LP-A
141000                                    (X-MM07-TAT)
141100                                    MM07-TAT-ACCOUNT-RP-A
141200                                    (X-MM07-TAT)
141300             MOVE SS08WS-CURSOR  TO MM07-TAT-ACCOUNT-L
141400                                    (X-MM07-TAT)
141500         END-IF
141600     END-PERFORM.
141700*
141800*
141900 W259-EXIT.
142000     EXIT.
142100*
142200/
142300 X000-UPDATE-FIELDS SECTION.
142400*
142500 X010-UPDATE-POST-REJECTS-FLAG.
142600*
142700     IF  MM07-POST-REJECTS-FLAG-L IS GREATER THAN ZERO
142800         IF  MM07-POST-REJECTS-FLAG IS NOT EQUAL
142900                                 TO MMMM-POST-REJECTS-FLAG
143000             SET WS-UPDATE-SW-YES
143100                                 TO TRUE
143200             IF  MBCA-PTI-FUNCTION-IS-MAINT
143300                 MOVE MMMMTB-POST-REJECTS-FLAG (1:4)
143400                                 TO WS-INDEX-X
143500                 SET X-MMFS-MERCH
143600                                 TO WS-INDEX
143700                 MOVE MMFS-MT-AUDIT-CODE (X-MMFS-MERCH)
143800                                 TO MML1-MMMM-AUDIT-CODE
143900                 MOVE 0701       TO MML1-FIELD-CODE
144000                 MOVE ZEROES     TO MML1-FIELD-OCCURRENCE
144100                                    MML1-FIELD-OCCURRENCE-2
144200                 MOVE MML1WS-VL-01
144300                                 TO MML1-VARIABLE-LENGTH
144400                 MOVE MMMM-POST-REJECTS-FLAG
144500                                 TO MML1-VL01-B-DATA-X
144600                 MOVE MM07-POST-REJECTS-FLAG
144700                                 TO MMMM-POST-REJECTS-FLAG
144800                 MOVE MMMM-POST-REJECTS-FLAG
144900                                 TO MML1-VL01-A-DATA-X
145000                 MOVE 'FC11'     TO MBCA-PROGRAM-LOCATION
145100                 PERFORM Y910-WRITE-LOG-RECORD
145200                                 THRU Y919-WLR-EXIT
145300             ELSE
145400                 MOVE MM07-POST-REJECTS-FLAG
145500                                 TO MMMM-POST-REJECTS-FLAG.
145600*
145700 X019-EXIT.
145800     EXIT.
145900*
146000 X020-UPDATE-SETT-FREQ1.
146100*
146200     IF  MM07-SETT-FREQ1-L IS GREATER THAN ZERO
146300         IF  MM07-SETT-FREQ1 IS NOT EQUAL
146400                                 TO MMMM-SETT-FREQ-1
146500             SET WS-UPDATE-SW-YES
146600                                 TO TRUE
146700             IF  MBCA-PTI-FUNCTION-IS-MAINT
146800                 MOVE MMMMTB-SETT-FREQ-1 (1:4)
146900                                 TO WS-INDEX-X
147000                 SET X-MMFS-MERCH
147100                                 TO WS-INDEX
147200                 MOVE MMFS-MT-AUDIT-CODE (X-MMFS-MERCH)
147300                                 TO MML1-MMMM-AUDIT-CODE
147400                 MOVE 0702       TO MML1-FIELD-CODE
147500                 MOVE ZEROES     TO MML1-FIELD-OCCURRENCE
147600                                    MML1-FIELD-OCCURRENCE-2
147700                 MOVE MML1WS-VL-02
147800                                 TO MML1-VARIABLE-LENGTH
147900                 MOVE MMMM-SETT-FREQ-1
148000                                 TO MML1-VL02-B-DATA-9
148100                 MOVE MM07-SETT-FREQ1
148200                                 TO MMMM-SETT-FREQ-1
148300                 MOVE MMMM-SETT-FREQ-1
148400                                 TO MML1-VL02-A-DATA-9
148500                 MOVE 'FC12'     TO MBCA-PROGRAM-LOCATION
148600                 PERFORM Y910-WRITE-LOG-RECORD
148700                                 THRU Y919-WLR-EXIT
148800             ELSE
148900                 MOVE MM07-SETT-FREQ1
149000                                 TO MMMM-SETT-FREQ-1.
149100*
149200 X029-EXIT.
149300     EXIT.
149400*
149500 X030-UPDATE-SETT-FREQ2.
149600*
149700     IF  MM07-SETT-FREQ2-L IS GREATER THAN ZERO
149800         IF  MM07-SETT-FREQ2 IS NOT EQUAL
149900                                 TO MMMM-SETT-FREQ-2
150000             SET WS-UPDATE-SW-YES
150100                                 TO TRUE
150200             IF  MBCA-PTI-FUNCTION-IS-MAINT
150300                 MOVE MMMMTB-SETT-FREQ-2 (1:4)
150400                                 TO WS-INDEX-X
150500                 SET X-MMFS-MERCH
150600                                 TO WS-INDEX
150700                 MOVE MMFS-MT-AUDIT-CODE (X-MMFS-MERCH)
150800                                 TO MML1-MMMM-AUDIT-CODE
150900                 MOVE 0703       TO MML1-FIELD-CODE
151000                 MOVE ZEROES     TO MML1-FIELD-OCCURRENCE
151100                                    MML1-FIELD-OCCURRENCE-2
151200                 MOVE MML1WS-VL-02
151300                                 TO MML1-VARIABLE-LENGTH
151400                 MOVE MMMM-SETT-FREQ-2
151500                                 TO MML1-VL02-B-DATA-9
151600                 MOVE MM07-SETT-FREQ2
151700                                 TO MMMM-SETT-FREQ-2
151800                 MOVE MMMM-SETT-FREQ-2
151900                                 TO MML1-VL02-A-DATA-9
152000                 MOVE 'FC13'     TO MBCA-PROGRAM-LOCATION
152100                 PERFORM Y910-WRITE-LOG-RECORD
152200                                 THRU Y919-WLR-EXIT
152300             ELSE
152400                 MOVE MM07-SETT-FREQ2
152500                                 TO MMMM-SETT-FREQ-2.
152600*
152700 X039-EXIT.
152800     EXIT.
152900*
153000 X070-UPDATE-COMB-DEPOSIT-FLAG.
153100*
153200     IF  MM07-ACH-DEPOSIT-L IS GREATER THAN ZERO
153300         IF  MM07-ACH-DEPOSIT IS NOT EQUAL
153400                                 TO MMMM-SETT-COMB-DEPOSIT-FLAG
153500             SET WS-UPDATE-SW-YES
153600                                 TO TRUE
153700             IF  MBCA-PTI-FUNCTION-IS-MAINT
153800                 MOVE MMMMTB-SETT-DEPOSIT-FLAG (1:4)
153900                                 TO WS-INDEX-X
154000                 SET X-MMFS-MERCH
154100                                 TO WS-INDEX
154200                 MOVE MMFS-MT-AUDIT-CODE (X-MMFS-MERCH)
154300                                 TO MML1-MMMM-AUDIT-CODE
154400                 MOVE 0704       TO MML1-FIELD-CODE
154500                 MOVE ZEROES     TO MML1-FIELD-OCCURRENCE
154600                                    MML1-FIELD-OCCURRENCE-2
154700                 MOVE MML1WS-VL-01
154800                                 TO MML1-VARIABLE-LENGTH
154900                 MOVE MMMM-SETT-COMB-DEPOSIT-FLAG
155000                                 TO MML1-VL01-B-DATA-X
155100                 MOVE MM07-ACH-DEPOSIT
155200                                 TO MMMM-SETT-COMB-DEPOSIT-FLAG
155300                 MOVE MMMM-SETT-COMB-DEPOSIT-FLAG
155400                                 TO MML1-VL01-A-DATA-X
155500                 MOVE 'FC14'     TO MBCA-PROGRAM-LOCATION
155600                 PERFORM Y910-WRITE-LOG-RECORD
155700                                 THRU Y919-WLR-EXIT
155800             ELSE
155900                 MOVE MM07-ACH-DEPOSIT
156000                                 TO MMMM-SETT-COMB-DEPOSIT-FLAG.
156100*
156200 X079-EXIT.
156300     EXIT.
156400*
156500 X110-UPDATE-PRINT-FAX.
156600*
156700     IF  MM07-PRINT-FAX-L IS GREATER THAN ZERO
156800         IF  MM07-PRINT-FAX IS NOT EQUAL
156900                                 TO MMMM-SETT-NOTICE-RPT-FLAG
157000             SET WS-UPDATE-SW-YES
157100                                 TO TRUE
157200             IF  MBCA-PTI-FUNCTION-IS-MAINT
157300                 MOVE MMMMTB-SETT-NOTICE-RPT-FLAG (1:4)
157400                                 TO WS-INDEX-X
157500                 SET X-MMFS-MERCH
157600                                 TO WS-INDEX
157700                 MOVE MMFS-MT-AUDIT-CODE (X-MMFS-MERCH)
157800                                 TO MML1-MMMM-AUDIT-CODE
157900                 MOVE 0705       TO MML1-FIELD-CODE
158000                 MOVE ZEROES     TO MML1-FIELD-OCCURRENCE
158100                                    MML1-FIELD-OCCURRENCE-2
158200                 MOVE MML1WS-VL-01
158300                                 TO MML1-VARIABLE-LENGTH
158400                 MOVE MMMM-SETT-NOTICE-RPT-FLAG
158500                                 TO MML1-VL01-B-DATA-X
158600                 MOVE MM07-PRINT-FAX
158700                                 TO MMMM-SETT-NOTICE-RPT-FLAG
158800                 MOVE MMMM-SETT-NOTICE-RPT-FLAG
158900                                 TO MML1-VL01-A-DATA-X
159000                 MOVE 'FC15'     TO MBCA-PROGRAM-LOCATION
159100                 PERFORM Y910-WRITE-LOG-RECORD
159200                                 THRU Y919-WLR-EXIT
159300             ELSE
159400                 MOVE MM07-PRINT-FAX
159500                                 TO MMMM-SETT-NOTICE-RPT-FLAG.
159600*
159700 X119-EXIT.
159800     EXIT.
159900*
160000 X150-UPDATE-SETT-DETAIL-FLAG.
160100*
160200     IF  MM07-DETAIL-TXNS-L IS GREATER THAN ZERO
160300         IF  MM07-DETAIL-TXNS IS NOT EQUAL
160400                                 TO MMMM-SETT-NOTICE-DETAIL-FLAG
160500             SET WS-UPDATE-SW-YES
160600                                 TO TRUE
160700             IF  MBCA-PTI-FUNCTION-IS-MAINT
160800                 MOVE MMMMTB-SETT-NOTICE-DETAIL-FLAG (1:4)
160900                                 TO WS-INDEX-X
161000                 SET X-MMFS-MERCH
161100                                 TO WS-INDEX
161200                 MOVE MMFS-MT-AUDIT-CODE (X-MMFS-MERCH)
161300                                 TO MML1-MMMM-AUDIT-CODE
161400                 MOVE 0706       TO MML1-FIELD-CODE
161500                 MOVE ZEROES     TO MML1-FIELD-OCCURRENCE
161600                                    MML1-FIELD-OCCURRENCE-2
161700                 MOVE MML1WS-VL-01
161800                                 TO MML1-VARIABLE-LENGTH
161900                 MOVE MMMM-SETT-NOTICE-DETAIL-FLAG
162000                                 TO MML1-VL01-B-DATA-X
162100                 MOVE MM07-DETAIL-TXNS
162200                                 TO MMMM-SETT-NOTICE-DETAIL-FLAG
162300                 MOVE MMMM-SETT-NOTICE-DETAIL-FLAG
162400                                 TO MML1-VL01-A-DATA-X
162500                 MOVE 'FC16'     TO MBCA-PROGRAM-LOCATION
162600                 PERFORM Y910-WRITE-LOG-RECORD
162700                                 THRU Y919-WLR-EXIT
162800             ELSE
162900                 MOVE MM07-DETAIL-TXNS
163000                                 TO MMMM-SETT-NOTICE-DETAIL-FLAG.
163100*
163200 X159-EXIT.
163300     EXIT.
163400*
163500 X190-UPDATE-ASSIGN-ACCT.
163600*
163700     SET X-MMMM-TAT              TO 1.
163800     SET X-MM07-TAT              TO 1.
163900     MOVE MMMMTB-TAT-ACCT-1 (1:4)
164000                                 TO WS-INDEX-X.
164100     SET X-MMFS-MERCH            TO WS-INDEX.
164200*
164300 X191-ASSIGN-ACCT.
164400*
164500     IF  MM07-TAT-ACCOUNT-L (X-MM07-TAT)
164600                                 IS GREATER THAN ZERO
164700         IF  MM07-TAT-ACCOUNT (X-MM07-TAT) IS NOT EQUAL
164800                                 TO MMMM-TAT-ACCOUNT
164900                                    (X-MMMM-TAT)
165000             SET WS-UPDATE-SW-YES
165100                                 TO TRUE
165200             IF  MBCA-PTI-FUNCTION-IS-MAINT
165300                 MOVE MMFS-MT-AUDIT-CODE (X-MMFS-MERCH)
165400                                 TO MML1-MMMM-AUDIT-CODE
165500                 MOVE 0707       TO MML1-FIELD-CODE
165600                 SET MML1-FIELD-OCCURRENCE
165700                                 TO X-MM07-TAT
165800                 MOVE ZEROES     TO MML1-FIELD-OCCURRENCE-2
165900                 MOVE MML1WS-VL-02
166000                                 TO MML1-VARIABLE-LENGTH
166100                 MOVE MMMM-TAT-ACCOUNT (X-MMMM-TAT)
166200                                 TO MML1-VL02-B-DATA-X
166300                 MOVE MM07-TAT-ACCOUNT (X-MM07-TAT)
166400                                 TO MMMM-TAT-ACCOUNT
166500                                    (X-MMMM-TAT)
166600                 MOVE MMMM-TAT-ACCOUNT (X-MMMM-TAT)
166700                                 TO MML1-VL02-A-DATA-X
166800                 MOVE 'FC17'     TO MBCA-PROGRAM-LOCATION
166900                 PERFORM Y910-WRITE-LOG-RECORD
167000                                 THRU Y919-WLR-EXIT
167100             ELSE
167200                 MOVE MM07-TAT-ACCOUNT (X-MM07-TAT)
167300                                 TO MMMM-TAT-ACCOUNT
167400                                    (X-MMMM-TAT).
167500*
167600 X198-INCREMENT-INDEXES.
167700*
167800     IF  X-MM07-TAT IS LESS THAN 16
167900         SET X-MM07-TAT          UP BY 1
168000         SET X-MMMM-TAT          UP BY 1
168100         SET X-MMFS-MERCH        UP BY 2
168200         GO TO X191-ASSIGN-ACCT.
168300*
168400 X199-EXIT.
168500     EXIT.
168600*
168700 X210-UPDATE-ASSIGN-USER-CODE.
168800*
168900     SET X-MMMM-TAT              TO 1.
169000     SET X-MM07-TAT              TO 1.
169100     MOVE MMMMTB-TAT-USER-CODE-1 (1:4)
169200                                 TO WS-INDEX-X.
169300     SET X-MMFS-MERCH            TO WS-INDEX.
169400*
169500 X211-ASSIGN-USER-CODE.
169600*
169700     IF  MM07-TAT-USER-CODE-L (X-MM07-TAT)
169800                                 IS GREATER THAN ZERO
169900         IF  MM07-TAT-USER-CODE (X-MM07-TAT) IS NOT EQUAL
170000                                 TO MMMM-TAT-USER-CODE
170100                                    (X-MMMM-TAT)
170200             SET WS-UPDATE-SW-YES
170300                                 TO TRUE
170400             IF  MBCA-PTI-FUNCTION-IS-MAINT
170500                 MOVE MMFS-MT-AUDIT-CODE (X-MMFS-MERCH)
170600                                 TO MML1-MMMM-AUDIT-CODE
170700                 MOVE 0708       TO MML1-FIELD-CODE
170800                 SET MML1-FIELD-OCCURRENCE
170900                                 TO X-MM07-TAT
171000                 MOVE ZEROES     TO MML1-FIELD-OCCURRENCE-2
171100                 MOVE MML1WS-VL-01
171200                                 TO MML1-VARIABLE-LENGTH
171300                 MOVE MMMM-TAT-USER-CODE (X-MMMM-TAT)
171400                                 TO MML1-VL01-B-DATA-X
171500                 MOVE MM07-TAT-USER-CODE (X-MM07-TAT)
171600                                 TO MMMM-TAT-USER-CODE
171700                                    (X-MMMM-TAT)
171800                 MOVE MMMM-TAT-USER-CODE (X-MMMM-TAT)
171900                                 TO MML1-VL01-A-DATA-X
172000                 MOVE 'FC18'     TO MBCA-PROGRAM-LOCATION
172100                 PERFORM Y910-WRITE-LOG-RECORD
172200                                 THRU Y919-WLR-EXIT
172300             ELSE
172400                 MOVE MM07-TAT-USER-CODE (X-MM07-TAT)
172500                                 TO MMMM-TAT-USER-CODE
172600                                    (X-MMMM-TAT).
172700*
172800 X218-INCREMENT-INDEXES.
172900*
173000     IF  X-MM07-TAT IS LESS THAN 16
173100         SET X-MM07-TAT          UP BY 1
173200         SET X-MMMM-TAT          UP BY 1
173300         SET X-MMFS-MERCH        UP BY 2
173400         GO TO X211-ASSIGN-USER-CODE.
173500*
173600 X219-EXIT.
173700     EXIT.
173800*
173900 X230-UPDATE-PENDING-DATE.
174000*
174100     MOVE MMMMTB-ACTIVE-DATE-1 (1:4)
174200                                 TO WS-INDEX-X.
174300     SET X-MMFS-MERCH            TO WS-INDEX.
174400*
174500     PERFORM
174600         VARYING X-PEND-PRE FROM 1 BY 1
174700         UNTIL X-PEND-PRE IS GREATER THAN 4
174800         SET X-MMMM-SETT-ACH     TO X-PEND-PRE
174900         IF  WS-DATE-PENDING-YES (X-PEND-PRE)
175000             IF  MMMM-DATE-PENDING-ACH-ACTIVE (X-MMMM-SETT-ACH)
175100                                 IS NOT EQUAL
175200                                 TO WS-DATE-PENDING (X-PEND-PRE)
175300                 SET WS-UPDATE-SW-YES
175400                                 TO TRUE
175500                 IF  MBCA-PTI-FUNCTION-IS-MAINT
175600                     MOVE MMFS-MT-AUDIT-CODE (X-MMFS-MERCH)
175700                                 TO MML1-MMMM-AUDIT-CODE
175800                     MOVE 0504       TO MML1-FIELD-CODE
175900                     SET MML1-FIELD-OCCURRENCE
176000                                 TO X-PEND-PRE
176100                     MOVE ZEROES TO MML1-FIELD-OCCURRENCE-2
176200                     MOVE MML1WS-VL-07
176300                                 TO MML1-VARIABLE-LENGTH
176400                     MOVE WS-DATE-PENDING (X-PEND-PRE)
176500                                 TO MML1-VL07-B-DATA-9
176600                     MOVE MMMM-DATE-PENDING-ACH-ACTIVE
176700                                    (X-MMMM-SETT-ACH)
176800                                 TO MML1-VL07-A-DATA-9
176900                     MOVE 'FC19' TO MBCA-PROGRAM-LOCATION
177000                     PERFORM Y910-WRITE-LOG-RECORD
177100                                 THRU Y919-WLR-EXIT
177200                 END-IF
177300             END-IF
177400         END-IF
177500         SET X-MMFS-MERCH          UP BY 1
177600     END-PERFORM.
177700*
177800 X239-EXIT.
177900     EXIT.
178000*
178100 X250-UPDATE-PRENOTE-DATA.
178200*
178300     MOVE MMMMTB-PRENOTE-CTL-1 (1:4)
178400                                 TO WS-INDEX-X.
178500     SET X-MMFS-MERCH            TO WS-INDEX.
178600*
178700     PERFORM
178800         VARYING X-PEND-PRE FROM 1 BY 1
178900         UNTIL X-PEND-PRE IS GREATER THAN 4
179000         SET X-MMMM-SETT-ACH     TO X-PEND-PRE
179100         IF  WS-PRENOTE-YES (X-PEND-PRE)
179200             IF  MMMM-PRENOTE-CONTROL (X-MMMM-SETT-ACH)
179300                                 IS NOT EQUAL
179400                                 TO WS-PRENOTE-CONTROL
179500                                    (X-PEND-PRE)
179600                 SET WS-UPDATE-SW-YES
179700                                 TO TRUE
179800                 IF  MBCA-PTI-FUNCTION-IS-MAINT
179900                     MOVE MMFS-MT-AUDIT-CODE (X-MMFS-MERCH)
180000                                 TO MML1-MMMM-AUDIT-CODE
180100                     MOVE 0501       TO MML1-FIELD-CODE
180200                     SET MML1-FIELD-OCCURRENCE
180300                                 TO X-PEND-PRE
180400                     MOVE ZEROES TO MML1-FIELD-OCCURRENCE-2
180500                     MOVE MML1WS-VL-01
180600                                 TO MML1-VARIABLE-LENGTH
180700                     MOVE WS-PRENOTE-CONTROL (X-PEND-PRE)
180800                                 TO MML1-VL01-B-DATA-X
180900                     MOVE MMMM-PRENOTE-CONTROL
181000                                    (X-MMMM-SETT-ACH)
181100                                 TO MML1-VL01-A-DATA-X
181200                     MOVE 'FC20' TO MBCA-PROGRAM-LOCATION
181300                     PERFORM Y910-WRITE-LOG-RECORD
181400                                 THRU Y919-WLR-EXIT
181500                 END-IF
181600             END-IF
181700             SET X-MMFS-MERCH    UP BY 1
181800             IF  MMMM-DATE-PRENOTE-INIT (X-MMMM-SETT-ACH)
181900                                 IS NOT EQUAL
182000                                 TO WS-DATE-PRENOTE (X-PEND-PRE)
182100                 SET WS-UPDATE-SW-YES
182200                                 TO TRUE
182300                 IF  MBCA-PTI-FUNCTION-IS-MAINT
182400                     MOVE MMFS-MT-AUDIT-CODE (X-MMFS-MERCH)
182500                                 TO MML1-MMMM-AUDIT-CODE
182600                     MOVE 0502       TO MML1-FIELD-CODE
182700                     SET MML1-FIELD-OCCURRENCE
182800                                 TO X-PEND-PRE
182900                     MOVE ZEROES TO MML1-FIELD-OCCURRENCE-2
183000                     MOVE MML1WS-VL-07
183100                                 TO MML1-VARIABLE-LENGTH
183200                     MOVE WS-DATE-PRENOTE (X-PEND-PRE)
183300                                 TO MML1-VL07-B-DATA-9
183400                     MOVE MMMM-DATE-PRENOTE-INIT
183500                                    (X-MMMM-SETT-ACH)
183600                                 TO MML1-VL07-A-DATA-9
183700                     MOVE 'FC21' TO MBCA-PROGRAM-LOCATION
183800                     PERFORM Y910-WRITE-LOG-RECORD
183900                                 THRU Y919-WLR-EXIT
184000                 END-IF
184100             END-IF
184200         END-IF
184300         SET X-MMFS-MERCH          UP BY 14
184400     END-PERFORM.
184500*
184600 X259-EXIT.
184700     EXIT.
184800*
184900 X170-UPDT-STORE-FREQS.
185000*
185100****************************************************************
185200*    START BROWSE THE STORE MERCH XREF FILE                    *
185300****************************************************************
185400*
185500     MOVE 'FC22'                 TO MBCA-PROGRAM-LOCATION.
185600     MOVE MBCA-MERCHANT-ORG      TO MBIOWS-MMXR-ORG.
185700     MOVE MBCA-MERCHANT          TO MBIOWS-MMXR-MERCHANT.
185800     MOVE ZEROS                  TO MBIOWS-MMXR-STORE.
185900     SET MBIORO-STARTBR-GTE      TO TRUE.
186000     PERFORM MMXRAO-ACCESS       THRU MMXRAO-ACCESS-EXIT.
186100*
186200 X171-READ-LOOP.
186300*
186400****************************************************************
186500*    READNEXT THE STORE MERCH XREF FILE                        *
186600****************************************************************
186700*
186800     MOVE 'FC23'                 TO MBCA-PROGRAM-LOCATION.
186900     SET MBIORO-READ-SEQ         TO TRUE.
187000     PERFORM MMXRAO-ACCESS       THRU MMXRAO-ACCESS-EXIT.
187100*
187200     IF  MMXR-ORG-MERCHANT IS GREATER THAN MBCA-ORG-MERCHANT
187300         GO TO X178-END-BROWSE.
187400*
187500     MOVE 'SM'                   TO MML1-FILE-CODE.
187600     MOVE MBCA-MERCHANT-ORG      TO MML1-MMSM-ORG.
187700     MOVE MMXR-STORE             TO MML1-MMSM-STORE.
187800     MOVE MBCA-SIGNON-NAME       TO MML1-SIGNON-NAME.
187900     MOVE MBCA-TERMINAL-ID       TO MML1-TERMINAL-ID.
188000     MOVE ZEROS                  TO MML1-SOURCE-CODE.
188100     MOVE MBCA-FIELD-SECURITY    TO MML1-FIELD-SECURITY.
188200*
188300     MOVE 'FC24'                 TO MBCA-PROGRAM-LOCATION.
188400     MOVE MBCA-ORG-MERCHANT      TO MBIOWS-MMSM-ORG.
188500     MOVE MMXR-STORE             TO MBIOWS-MMSM-STORE.
188600     SET MBIORO-READ-RANDOM-UPDATE
188700                                 TO TRUE.
188800     PERFORM MMSMAO-ACCESS       THRU MMSMAO-ACCESS-EXIT.
188900*
189000     IF  MM07-SETT-FREQ1-L IS GREATER THAN ZERO
189100         IF  MM07-SETT-FREQ1 IS NOT EQUAL TO MMSM-SETT-FREQ-1
189200             SET WS-STORE-UPDATE-SW-YES
189300                                 TO TRUE
189400             MOVE 9008           TO MML1-FIELD-CODE
189500             MOVE ZEROES         TO MML1-FIELD-OCCURRENCE
189600                                    MML1-FIELD-OCCURRENCE-2
189700             MOVE MML1WS-VL-02   TO MML1-VARIABLE-LENGTH
189800             MOVE MMSM-SETT-FREQ-1
189900                                 TO MML1-VL02-B-DATA-9
190000             MOVE MM07-SETT-FREQ1
190100                                 TO MMSM-SETT-FREQ-1
190200             MOVE MMSM-SETT-FREQ-1
190300                                 TO MML1-VL02-A-DATA-9
190400             MOVE 'FC25'         TO MBCA-PROGRAM-LOCATION
190500             PERFORM Y910-WRITE-LOG-RECORD
190600                                 THRU Y919-WLR-EXIT.
190700*
190800     IF  MM07-SETT-FREQ2-L IS GREATER THAN ZERO
190900         IF  MM07-SETT-FREQ2 IS NOT EQUAL TO MMSM-SETT-FREQ-2
191000             SET WS-STORE-UPDATE-SW-YES
191100                                 TO TRUE
191200             MOVE 9009           TO MML1-FIELD-CODE
191300             MOVE ZEROES         TO MML1-FIELD-OCCURRENCE
191400                                    MML1-FIELD-OCCURRENCE-2
191500             MOVE MML1WS-VL-02   TO MML1-VARIABLE-LENGTH
191600             MOVE MMSM-SETT-FREQ-2
191700                                 TO MML1-VL02-B-DATA-9
191800             MOVE MM07-SETT-FREQ2
191900                                 TO MMSM-SETT-FREQ-2
192000             MOVE MMSM-SETT-FREQ-2
192100                                 TO MML1-VL02-A-DATA-9
192200             MOVE 'FC26'         TO MBCA-PROGRAM-LOCATION
192300             PERFORM Y910-WRITE-LOG-RECORD
192400                                 THRU Y919-WLR-EXIT.
192500*
192600     IF  WS-STORE-UPDATE-SW-YES
192700         MOVE 'FC27'             TO MBCA-PROGRAM-LOCATION
192800         SET MBIORO-REWRITE      TO TRUE
192900         PERFORM MMSMAO-ACCESS   THRU MMSMAO-ACCESS-EXIT
193000         SET WS-STORE-UPDATE-SW-NO
193100                                 TO TRUE
193200     ELSE
193300         MOVE 'FC28'             TO MBCA-PROGRAM-LOCATION
193400         SET MBIORO-UNLOCK       TO TRUE
193500         PERFORM MMSMAO-ACCESS   THRU MMSMAO-ACCESS-EXIT.
193600*
193700     GO TO X171-READ-LOOP.
193800*
193900 X178-END-BROWSE.
194000*
194100     MOVE 'FC29'                 TO MBCA-PROGRAM-LOCATION.
194200     SET MBIORO-ENDBR            TO TRUE.
194300     PERFORM MMXRAO-ACCESS       THRU MMXRAO-ACCESS-EXIT.
194400*
194500 X179-EXIT.
194600     EXIT.
194700*
194800/
194900 Y000-PERFORMED-ROUTINES SECTION.
195000*
195100 Y010-MOVE-POST-REJECTS-FLAG.
195200*
195300     MOVE MMMM-POST-REJECTS-FLAG
195400                                 TO MM07-POST-REJECTS-FLAG.
195500*
195600 Y015-POST-REJECTS-SECURITY.
195700*
195800     MOVE MMMMTB-POST-REJECTS-FLAG (1:4)
195900                                 TO WS-INDEX-X.
196000     SET  X-MMFS-MERCH           TO WS-INDEX.
196100*
196200     IF  MMFS-MT-NO-ACCESS (X-MMFS-MERCH)
196300         MOVE DFHBMDAS           TO MM07-POST-REJECTS-FLAG-LIT-A
196400                                    MM07-POST-REJECTS-FLAG-LP-A
196500                                    MM07-POST-REJECTS-FLAG-RP-A
196600                                    MM07-POST-REJECTS-FLAG-A
196700         MOVE ZERO               TO MM07-POST-REJECTS-FLAG-L
196800         GO TO Y019-EXIT.
196900*
197000     IF  MBCA-PTI-FUNCTION-IS-INQUIRY
197100         MOVE DFHBMDAS           TO MM07-POST-REJECTS-FLAG-LP-A
197200                                    MM07-POST-REJECTS-FLAG-RP-A
197300         MOVE DFHBMASB           TO MM07-POST-REJECTS-FLAG-A
197400         GO TO Y019-EXIT.
197500*
197600     IF  MMFS-MT-INQ-ONLY (X-MMFS-MERCH)
197700         MOVE ZERO               TO MM07-POST-REJECTS-FLAG-L
197800         MOVE DFHBMDAS           TO MM07-POST-REJECTS-FLAG-LP-A
197900                                    MM07-POST-REJECTS-FLAG-RP-A
198000         MOVE DFHBMASK           TO MM07-POST-REJECTS-FLAG-A
198100         GO TO Y019-EXIT.
198200*
198300     IF  MBCA-PTI-FUNCTION-IS-ADD
198400         IF  MMFS-MT-REQUIRED (X-MMFS-MERCH)
198500             MOVE DFHBMASB       TO MM07-POST-REJECTS-FLAG-LIT-A
198600         ELSE
198700             IF  MMFS-MT-MAINT-ONLY (X-MMFS-MERCH)
198800                 MOVE ZERO       TO MM07-POST-REJECTS-FLAG-L
198900                 MOVE DFHBMDAS   TO MM07-POST-REJECTS-FLAG-LP-A
199000                                    MM07-POST-REJECTS-FLAG-RP-A
199100                 MOVE DFHBMASK   TO MM07-POST-REJECTS-FLAG-A.
199200*
199300     IF  MBCA-PTI-FUNCTION-IS-MAINT
199400         IF  MMFS-MT-NO-MAINT (X-MMFS-MERCH)
199500             MOVE ZERO           TO MM07-POST-REJECTS-FLAG-L
199600             MOVE DFHBMDAS       TO MM07-POST-REJECTS-FLAG-LP-A
199700                                    MM07-POST-REJECTS-FLAG-RP-A
199800             MOVE DFHBMASK       TO MM07-POST-REJECTS-FLAG-A.
199900*
200000 Y019-EXIT.
200100     EXIT.
200200*
200300 Y020-MOVE-SETT-FREQ1.
200400*
200500     MOVE MMMM-SETT-FREQ-1       TO MM07-SETT-FREQ1.
200600*
200700 Y025-SETT-FREQ1-SECURITY.
200800*
200900     MOVE MMMMTB-SETT-FREQ-1 (1:4)
201000                                 TO WS-INDEX-X.
201100     SET  X-MMFS-MERCH           TO WS-INDEX.
201200*
201300     IF  MMFS-MT-NO-ACCESS (X-MMFS-MERCH)
201400         MOVE DFHBMDAS           TO MM07-SETT-FREQ-LIT-A
201500                                    MM07-SETT-FREQ1-LP-A
201600                                    MM07-SETT-FREQ1-RP-A
201700                                    MM07-SETT-FREQ1-A
201800         MOVE ZERO               TO MM07-SETT-FREQ1-L
201900         GO TO Y029-EXIT.
202000*
202100     IF  MBCA-PTI-FUNCTION-IS-INQUIRY
202200         MOVE DFHBMDAS           TO MM07-SETT-FREQ1-LP-A
202300                                    MM07-SETT-FREQ1-RP-A
202400         MOVE DFHBMASB           TO MM07-SETT-FREQ1-A
202500         GO TO Y029-EXIT.
202600*
202700     IF  MMFS-MT-INQ-ONLY (X-MMFS-MERCH)
202800         MOVE ZERO               TO MM07-SETT-FREQ1-L
202900         MOVE DFHBMDAS           TO MM07-SETT-FREQ1-LP-A
203000                                    MM07-SETT-FREQ1-RP-A
203100         MOVE DFHBMASK           TO MM07-SETT-FREQ1-A
203200         GO TO Y029-EXIT.
203300*
203400     IF  MBCA-PTI-FUNCTION-IS-ADD
203500         IF  MMFS-MT-REQUIRED (X-MMFS-MERCH)
203600             MOVE DFHBMASB       TO MM07-SETT-FREQ-LIT-A
203700         ELSE
203800             IF  MMFS-MT-MAINT-ONLY (X-MMFS-MERCH)
203900                 MOVE ZERO       TO MM07-SETT-FREQ1-L
204000                 MOVE DFHBMDAS   TO MM07-SETT-FREQ1-LP-A
204100                                    MM07-SETT-FREQ1-RP-A
204200                 MOVE DFHBMASK   TO MM07-SETT-FREQ1-A.
204300*
204400     IF  MBCA-PTI-FUNCTION-IS-MAINT
204500         IF  MMFS-MT-NO-MAINT (X-MMFS-MERCH)
204600             MOVE ZERO           TO MM07-SETT-FREQ1-L
204700             MOVE DFHBMDAS       TO MM07-SETT-FREQ1-LP-A
204800                                    MM07-SETT-FREQ1-RP-A
204900             MOVE DFHBMASK       TO MM07-SETT-FREQ1-A.
205000*
205100 Y029-EXIT.
205200     EXIT.
205300*
205400 Y030-MOVE-SETT-FREQ2.
205500*
205600     MOVE MMMM-SETT-FREQ-2       TO MM07-SETT-FREQ2.
205700*
205800 Y035-SETT-FREQ2-SECURITY.
205900*
206000     MOVE MMMMTB-SETT-FREQ-2 (1:4)
206100                                 TO WS-INDEX-X.
206200     SET  X-MMFS-MERCH           TO WS-INDEX.
206300*
206400     IF  MMFS-MT-NO-ACCESS (X-MMFS-MERCH)
206500         MOVE DFHBMDAS           TO MM07-SETT-FREQ2-LP-A
206600                                    MM07-SETT-FREQ2-RP-A
206700                                    MM07-SETT-FREQ2-A
206800         MOVE ZERO               TO MM07-SETT-FREQ2-L
206900         GO TO Y039-EXIT.
207000*
207100     IF  MBCA-PTI-FUNCTION-IS-INQUIRY
207200         MOVE DFHBMDAS           TO MM07-SETT-FREQ2-LP-A
207300                                    MM07-SETT-FREQ2-RP-A
207400         MOVE DFHBMASB           TO MM07-SETT-FREQ2-A
207500         GO TO Y039-EXIT.
207600*
207700     IF  MMFS-MT-INQ-ONLY (X-MMFS-MERCH)
207800         MOVE ZERO               TO MM07-SETT-FREQ2-L
207900         MOVE DFHBMDAS           TO MM07-SETT-FREQ2-LP-A
208000                                    MM07-SETT-FREQ2-RP-A
208100         MOVE DFHBMASK           TO MM07-SETT-FREQ2-A
208200         GO TO Y039-EXIT.
208300*
208400     IF  MBCA-PTI-FUNCTION-IS-ADD
208500         IF  MMFS-MT-REQUIRED (X-MMFS-MERCH)
208600             MOVE DFHBMASB       TO MM07-SETT-FREQ-LIT-A
208700         ELSE
208800             IF  MMFS-MT-MAINT-ONLY (X-MMFS-MERCH)
208900                 MOVE ZERO       TO MM07-SETT-FREQ2-L
209000                 MOVE DFHBMDAS   TO MM07-SETT-FREQ2-LP-A
209100                                    MM07-SETT-FREQ2-RP-A
209200                 MOVE DFHBMASK   TO MM07-SETT-FREQ2-A.
209300*
209400     IF  MBCA-PTI-FUNCTION-IS-MAINT
209500         IF  MMFS-MT-NO-MAINT (X-MMFS-MERCH)
209600             MOVE ZERO           TO MM07-SETT-FREQ2-L
209700             MOVE DFHBMDAS       TO MM07-SETT-FREQ2-LP-A
209800                                    MM07-SETT-FREQ2-RP-A
209900             MOVE DFHBMASK       TO MM07-SETT-FREQ2-A.
210000*
210100 Y039-EXIT.
210200     EXIT.
210300*
210400 Y050-MOVE-DEST-METHOD-1.
210500*
210600     MOVE MMMM-SETT-ACCT-1-METHOD
210700                                 TO MM07-SETT-ACCT-1-ACTIVE.
210800*
210900     MOVE MMMM-PENDING-SETT-ACCT-METH (1)
211000                                 TO MM07-SETT-ACCT-1-MIGRAT.
211100*
211200     MOVE MMMM-INTERIM-SETT-ACCT-METH (1)
211300                                 TO MM07-SETT-ACCT-1-INTERIM.
211400*
211500 Y055-DEST-METHOD-1-SECURITY.
211600*
211700     MOVE MMMMTB-METHOD-1 (1:4)
211800                                 TO WS-INDEX-X.
211900     SET  X-MMFS-MERCH           TO WS-INDEX.
212000*
212100     IF  MMFS-MT-NO-ACCESS (X-MMFS-MERCH)
212200         MOVE DFHBMDAS           TO MM07-SETT-ACCT-1-METH-LIT-A
212300                                    MM07-SETT-ACCT-1-ACTIVE-A
212400                                    MM07-SETT-ACCT-1-MIGRAT-A
212500                                    MM07-SETT-ACCT-1-INTERIM-A
212600         MOVE ZERO               TO MM07-SETT-ACCT-1-ACTIVE-L
212700                                    MM07-SETT-ACCT-1-MIGRAT-L
212800                                    MM07-SETT-ACCT-1-INTERIM-L
212900         GO TO Y059-EXIT.
213000*
213100     IF  MBCA-PTI-FUNCTION-IS-INQUIRY
213200         MOVE DFHBMASB           TO MM07-SETT-ACCT-1-ACTIVE-A
213300                                    MM07-SETT-ACCT-1-MIGRAT-A
213400                                    MM07-SETT-ACCT-1-INTERIM-A
213500         GO TO Y059-EXIT.
213600*
213700     IF  MMFS-MT-INQ-ONLY (X-MMFS-MERCH)
213800         MOVE ZERO               TO MM07-SETT-ACCT-1-ACTIVE-L
213900                                    MM07-SETT-ACCT-1-MIGRAT-L
214000                                    MM07-SETT-ACCT-1-INTERIM-L
214100         MOVE DFHBMASK           TO MM07-SETT-ACCT-1-ACTIVE-A
214200                                    MM07-SETT-ACCT-1-MIGRAT-A
214300                                    MM07-SETT-ACCT-1-INTERIM-A
214400         GO TO Y059-EXIT.
214500*
214600     MOVE DFHBMASK               TO MM07-SETT-ACCT-1-ACTIVE-A
214700                                    MM07-SETT-ACCT-1-MIGRAT-A
214800                                    MM07-SETT-ACCT-1-INTERIM-A.
214900*
215000 Y059-EXIT.
215100     EXIT.
215200*
215300 Y070-MOVE-COMB-DEPOSIT-FLAG.
215400*
215500     MOVE MMMM-SETT-COMB-DEPOSIT-FLAG
215600                                 TO MM07-ACH-DEPOSIT.
215700*
215800 Y075-ACH-DEPOSIT-SECURITY.
215900*
216000     MOVE MMMMTB-SETT-DEPOSIT-FLAG (1:4)
216100                                 TO WS-INDEX-X.
216200     SET  X-MMFS-MERCH           TO WS-INDEX.
216300*
216400     IF  MMFS-MT-NO-ACCESS (X-MMFS-MERCH)
216500         MOVE DFHBMDAS           TO MM07-ACH-DEPOSIT-LIT-A
216600                                    MM07-ACH-DEPOSIT-LP-A
216700                                    MM07-ACH-DEPOSIT-RP-A
216800                                    MM07-ACH-DEPOSIT-A
216900         MOVE ZERO               TO MM07-ACH-DEPOSIT-L
217000         GO TO Y079-EXIT.
217100*
217200     IF  MBCA-PTI-FUNCTION-IS-INQUIRY
217300         MOVE DFHBMDAS           TO MM07-ACH-DEPOSIT-LP-A
217400                                    MM07-ACH-DEPOSIT-RP-A
217500         MOVE DFHBMASB           TO MM07-ACH-DEPOSIT-A
217600         GO TO Y079-EXIT.
217700*
217800     IF  MMFS-MT-INQ-ONLY (X-MMFS-MERCH)
217900         MOVE ZERO               TO MM07-ACH-DEPOSIT-L
218000         MOVE DFHBMDAS           TO MM07-ACH-DEPOSIT-LP-A
218100                                    MM07-ACH-DEPOSIT-RP-A
218200         MOVE DFHBMASK           TO MM07-ACH-DEPOSIT-A
218300         GO TO Y079-EXIT.
218400*
218500     IF  MBCA-PTI-FUNCTION-IS-ADD
218600         IF  MMFS-MT-REQUIRED (X-MMFS-MERCH)
218700             MOVE DFHBMASB       TO MM07-ACH-DEPOSIT-LIT-A
218800         ELSE
218900             IF  MMFS-MT-MAINT-ONLY (X-MMFS-MERCH)
219000                 MOVE ZERO       TO MM07-ACH-DEPOSIT-L
219100                 MOVE DFHBMDAS   TO MM07-ACH-DEPOSIT-LP-A
219200                                    MM07-ACH-DEPOSIT-RP-A
219300                 MOVE DFHBMASK   TO MM07-ACH-DEPOSIT-A.
219400*
219500     IF  MBCA-PTI-FUNCTION-IS-MAINT
219600         IF  MMFS-MT-NO-MAINT (X-MMFS-MERCH)
219700             MOVE ZERO           TO MM07-ACH-DEPOSIT-L
219800             MOVE DFHBMDAS       TO MM07-ACH-DEPOSIT-LP-A
219900                                    MM07-ACH-DEPOSIT-RP-A
220000             MOVE DFHBMASK       TO MM07-ACH-DEPOSIT-A.
220100*
220200 Y079-EXIT.
220300     EXIT.
220400*
220500 Y090-MOVE-DEST-METHOD-2.
220600*
220700     MOVE MMMM-SETT-ACCT-2-METHOD
220800                                 TO MM07-SETT-ACCT-2-ACTIVE.
220900*
221000     MOVE MMMM-PENDING-SETT-ACCT-METH (2)
221100                                 TO MM07-SETT-ACCT-2-MIGRAT.
221200*
221300     MOVE MMMM-INTERIM-SETT-ACCT-METH (2)
221400                                 TO MM07-SETT-ACCT-2-INTERIM.
221500*
221600 Y095-DEST-METHOD-2-SECURITY.
221700*
221800     MOVE MMMMTB-METHOD-2 (1:4)
221900                                 TO WS-INDEX-X.
222000     SET  X-MMFS-MERCH           TO WS-INDEX.
222100*
222200     IF  MMFS-MT-NO-ACCESS (X-MMFS-MERCH)
222300         MOVE DFHBMDAS           TO MM07-SETT-ACCT-2-METH-LIT-A
222400                                    MM07-SETT-ACCT-2-ACTIVE-A
222500                                    MM07-SETT-ACCT-2-MIGRAT-A
222600                                    MM07-SETT-ACCT-2-INTERIM-A
222700         MOVE ZERO               TO MM07-SETT-ACCT-2-ACTIVE-L
222800                                    MM07-SETT-ACCT-2-MIGRAT-L
222900                                    MM07-SETT-ACCT-2-INTERIM-L
223000         GO TO Y099-EXIT.
223100*
223200     IF  MBCA-PTI-FUNCTION-IS-INQUIRY
223300         MOVE DFHBMASB           TO MM07-SETT-ACCT-2-ACTIVE-A
223400                                    MM07-SETT-ACCT-2-MIGRAT-A
223500                                    MM07-SETT-ACCT-2-INTERIM-A
223600         GO TO Y099-EXIT.
223700*
223800     IF  MMFS-MT-INQ-ONLY (X-MMFS-MERCH)
223900         MOVE ZERO               TO MM07-SETT-ACCT-2-ACTIVE-L
224000                                    MM07-SETT-ACCT-2-MIGRAT-L
224100                                    MM07-SETT-ACCT-2-INTERIM-L
224200         MOVE DFHBMASK           TO MM07-SETT-ACCT-2-ACTIVE-A
224300                                    MM07-SETT-ACCT-2-MIGRAT-A
224400                                    MM07-SETT-ACCT-2-INTERIM-A
224500         GO TO Y099-EXIT.
224600*
224700     MOVE DFHBMASK               TO MM07-SETT-ACCT-2-ACTIVE-A
224800                                    MM07-SETT-ACCT-2-MIGRAT-A
224900                                    MM07-SETT-ACCT-2-INTERIM-A.
225000*
225100 Y099-EXIT.
225200     EXIT.
225300*
225400 Y110-MOVE-PRINT-FAX.
225500*
225600     MOVE MMMM-SETT-NOTICE-RPT-FLAG
225700                                 TO MM07-PRINT-FAX.
225800*
225900 Y115-PRINT-FAX-SECURITY.
226000*
226100     MOVE MMMMTB-SETT-NOTICE-RPT-FLAG (1:4)
226200                                 TO WS-INDEX-X.
226300     SET  X-MMFS-MERCH           TO WS-INDEX.
226400*
226500     IF  MMFS-MT-NO-ACCESS (X-MMFS-MERCH)
226600         MOVE DFHBMDAS           TO MM07-PRINT-FAX-LIT-A
226700                                    MM07-PRINT-FAX-LP-A
226800                                    MM07-PRINT-FAX-RP-A
226900                                    MM07-PRINT-FAX-A
227000         MOVE ZERO               TO MM07-PRINT-FAX-L
227100         GO TO Y119-EXIT.
227200*
227300     IF  MBCA-PTI-FUNCTION-IS-INQUIRY
227400         MOVE DFHBMDAS           TO MM07-PRINT-FAX-LP-A
227500                                    MM07-PRINT-FAX-RP-A
227600         MOVE DFHBMASB           TO MM07-PRINT-FAX-A
227700         GO TO Y119-EXIT.
227800*
227900     IF  MMFS-MT-INQ-ONLY (X-MMFS-MERCH)
228000         MOVE ZERO               TO MM07-PRINT-FAX-L
228100         MOVE DFHBMDAS           TO MM07-PRINT-FAX-LP-A
228200                                    MM07-PRINT-FAX-RP-A
228300         MOVE DFHBMASK           TO MM07-PRINT-FAX-A
228400         GO TO Y119-EXIT.
228500*
228600     IF  MBCA-PTI-FUNCTION-IS-ADD
228700         IF  MMFS-MT-REQUIRED (X-MMFS-MERCH)
228800             MOVE DFHBMASB       TO MM07-PRINT-FAX-LIT-A
228900         ELSE
229000             IF  MMFS-MT-MAINT-ONLY (X-MMFS-MERCH)
229100                 MOVE ZERO       TO MM07-PRINT-FAX-L
229200                 MOVE DFHBMDAS   TO MM07-PRINT-FAX-LP-A
229300                                    MM07-PRINT-FAX-RP-A
229400                 MOVE DFHBMASK   TO MM07-PRINT-FAX-A.
229500*
229600     IF  MBCA-PTI-FUNCTION-IS-MAINT
229700         IF  MMFS-MT-NO-MAINT (X-MMFS-MERCH)
229800             MOVE ZERO           TO MM07-PRINT-FAX-L
229900             MOVE DFHBMDAS       TO MM07-PRINT-FAX-LP-A
230000                                    MM07-PRINT-FAX-RP-A
230100             MOVE DFHBMASK       TO MM07-PRINT-FAX-A.
230200*
230300 Y119-EXIT.
230400     EXIT.
230500*
230600 Y130-MOVE-DEST-METHOD-3.
230700*
230800     MOVE MMMM-SETT-ACCT-3-METHOD
230900                                 TO MM07-SETT-ACCT-3-ACTIVE.
231000*
231100     MOVE MMMM-PENDING-SETT-ACCT-METH (3)
231200                                 TO MM07-SETT-ACCT-3-MIGRAT.
231300*
231400     MOVE MMMM-INTERIM-SETT-ACCT-METH (3)
231500                                 TO MM07-SETT-ACCT-3-INTERIM.
231600*
231700 Y135-DEST-METHOD-3-SECURITY.
231800*
231900     MOVE MMMMTB-METHOD-3 (1:4)
232000                                 TO WS-INDEX-X.
232100     SET  X-MMFS-MERCH           TO WS-INDEX.
232200*
232300     IF  MMFS-MT-NO-ACCESS (X-MMFS-MERCH)
232400         MOVE DFHBMDAS           TO MM07-SETT-ACCT-3-METH-LIT-A
232500                                    MM07-SETT-ACCT-3-ACTIVE-A
232600                                    MM07-SETT-ACCT-3-MIGRAT-A
232700                                    MM07-SETT-ACCT-3-INTERIM-A
232800         MOVE ZERO               TO MM07-SETT-ACCT-3-ACTIVE-L
232900                                    MM07-SETT-ACCT-3-MIGRAT-L
233000                                    MM07-SETT-ACCT-3-INTERIM-L
233100         GO TO Y139-EXIT.
233200*
233300     IF  MBCA-PTI-FUNCTION-IS-INQUIRY
233400         MOVE DFHBMASB           TO MM07-SETT-ACCT-3-ACTIVE-A
233500                                    MM07-SETT-ACCT-3-MIGRAT-A
233600                                    MM07-SETT-ACCT-3-INTERIM-A
233700         GO TO Y139-EXIT.
233800*
233900     IF  MMFS-MT-INQ-ONLY (X-MMFS-MERCH)
234000         MOVE ZERO               TO MM07-SETT-ACCT-3-ACTIVE-L
234100                                    MM07-SETT-ACCT-3-MIGRAT-L
234200                                    MM07-SETT-ACCT-3-INTERIM-L
234300         MOVE DFHBMASK           TO MM07-SETT-ACCT-3-ACTIVE-A
234400                                    MM07-SETT-ACCT-3-MIGRAT-A
234500                                    MM07-SETT-ACCT-3-INTERIM-A
234600         GO TO Y139-EXIT.
234700*
234800     MOVE DFHBMASK               TO MM07-SETT-ACCT-3-ACTIVE-A
234900                                    MM07-SETT-ACCT-3-MIGRAT-A
235000                                    MM07-SETT-ACCT-3-INTERIM-A.
235100*
235200 Y139-EXIT.
235300     EXIT.
235400*
235500 Y150-MOVE-SETT-NOTICE-FLAG.
235600*
235700     MOVE MMMM-SETT-NOTICE-DETAIL-FLAG
235800                                 TO MM07-DETAIL-TXNS.
235900*
236000 Y155-SETT-NOTICE-FLAG-SECURITY.
236100*
236200     MOVE MMMMTB-SETT-NOTICE-DETAIL-FLAG (1:4)
236300                                 TO WS-INDEX-X.
236400     SET  X-MMFS-MERCH           TO WS-INDEX.
236500*
236600     IF  MMFS-MT-NO-ACCESS (X-MMFS-MERCH)
236700         MOVE DFHBMDAS           TO MM07-DETAIL-TXNS-LIT-A
236800                                    MM07-DETAIL-TXNS-LP-A
236900                                    MM07-DETAIL-TXNS-RP-A
237000                                    MM07-DETAIL-TXNS-A
237100         MOVE ZERO               TO MM07-DETAIL-TXNS-L
237200         GO TO Y159-EXIT.
237300*
237400     IF  MBCA-PTI-FUNCTION-IS-INQUIRY
237500         MOVE DFHBMDAS           TO MM07-DETAIL-TXNS-LP-A
237600                                    MM07-DETAIL-TXNS-RP-A
237700         MOVE DFHBMASB           TO MM07-DETAIL-TXNS-A
237800         GO TO Y159-EXIT.
237900*
238000     IF  MMFS-MT-INQ-ONLY (X-MMFS-MERCH)
238100         MOVE ZERO               TO MM07-DETAIL-TXNS-L
238200         MOVE DFHBMDAS           TO MM07-DETAIL-TXNS-LP-A
238300                                    MM07-DETAIL-TXNS-RP-A
238400         MOVE DFHBMASK           TO MM07-DETAIL-TXNS-A
238500         GO TO Y159-EXIT.
238600*
238700     IF  MBCA-PTI-FUNCTION-IS-ADD
238800         IF  MMFS-MT-REQUIRED (X-MMFS-MERCH)
238900             MOVE DFHBMASB       TO MM07-DETAIL-TXNS-LIT-A
239000         ELSE
239100             IF  MMFS-MT-MAINT-ONLY (X-MMFS-MERCH)
239200                 MOVE ZERO       TO MM07-DETAIL-TXNS-L
239300                 MOVE DFHBMDAS   TO MM07-DETAIL-TXNS-LP-A
239400                                    MM07-DETAIL-TXNS-RP-A
239500                 MOVE DFHBMASK   TO MM07-DETAIL-TXNS-A.
239600*
239700     IF  MBCA-PTI-FUNCTION-IS-MAINT
239800         IF  MMFS-MT-NO-MAINT (X-MMFS-MERCH)
239900             MOVE ZERO           TO MM07-DETAIL-TXNS-L
240000             MOVE DFHBMDAS       TO MM07-DETAIL-TXNS-LP-A
240100                                    MM07-DETAIL-TXNS-RP-A
240200             MOVE DFHBMASK       TO MM07-DETAIL-TXNS-A.
240300*
240400 Y159-EXIT.
240500     EXIT.
240600*
240700 Y170-MOVE-DEST-METHOD-4.
240800*
240900     MOVE MMMM-SETT-ACCT-4-METHOD
241000                                 TO MM07-SETT-ACCT-4-ACTIVE.
241100*
241200     MOVE MMMM-PENDING-SETT-ACCT-METH (4)
241300                                 TO MM07-SETT-ACCT-4-MIGRAT.
241400*
241500     MOVE MMMM-INTERIM-SETT-ACCT-METH (4)
241600                                 TO MM07-SETT-ACCT-4-INTERIM.
241700*
241800 Y175-DEST-METHOD-4-SECURITY.
241900*
242000     MOVE MMMMTB-METHOD-4 (1:4)
242100                                 TO WS-INDEX-X.
242200     SET  X-MMFS-MERCH           TO WS-INDEX.
242300*
242400     IF  MMFS-MT-NO-ACCESS (X-MMFS-MERCH)
242500         MOVE DFHBMDAS           TO MM07-SETT-ACCT-4-METH-LIT-A
242600                                    MM07-SETT-ACCT-4-ACTIVE-A
242700                                    MM07-SETT-ACCT-4-MIGRAT-A
242800                                    MM07-SETT-ACCT-4-INTERIM-A
242900         MOVE ZERO               TO MM07-SETT-ACCT-4-ACTIVE-A
243000                                    MM07-SETT-ACCT-4-MIGRAT-A
243100                                    MM07-SETT-ACCT-4-INTERIM-A
243200         GO TO Y179-EXIT.
243300*
243400     IF  MBCA-PTI-FUNCTION-IS-INQUIRY
243500         MOVE DFHBMASB           TO MM07-SETT-ACCT-4-ACTIVE-A
243600                                    MM07-SETT-ACCT-4-MIGRAT-A
243700                                    MM07-SETT-ACCT-4-INTERIM-A
243800         GO TO Y179-EXIT.
243900*
244000     IF  MMFS-MT-INQ-ONLY (X-MMFS-MERCH)
244100         MOVE ZERO               TO MM07-SETT-ACCT-4-ACTIVE-A
244200                                    MM07-SETT-ACCT-4-MIGRAT-A
244300                                    MM07-SETT-ACCT-4-INTERIM-A
244400         MOVE DFHBMASK           TO MM07-SETT-ACCT-4-ACTIVE-A
244500                                    MM07-SETT-ACCT-4-MIGRAT-A
244600                                    MM07-SETT-ACCT-4-INTERIM-A
244700         GO TO Y179-EXIT.
244800*
244900     MOVE DFHBMASK               TO MM07-SETT-ACCT-4-ACTIVE-A
245000                                    MM07-SETT-ACCT-4-MIGRAT-A
245100                                    MM07-SETT-ACCT-4-INTERIM-A.
245200*
245300 Y179-EXIT.
245400     EXIT.
245500*
245600 Y190-MOVE-ASSIGN-ACCT.
245700*
245800     SET X-MM07-TAT              TO 1.
245900     SET X-MMMM-TAT              TO 1.
246000     MOVE MMMMTB-TAT-ACCT-1 (1:4)
246100                                 TO WS-INDEX-X.
246200     SET X-MMFS-MERCH            TO WS-INDEX.
246300*
246400 Y191-ASSIGN-ACCT-LOOP.
246500*
246600     MOVE MMMM-TAT-ACCOUNT (X-MMMM-TAT)
246700                                 TO MM07-TAT-ACCOUNT
246800                                    (X-MM07-TAT).
246900*
247000 Y195-ASSIGN-ACCT-SECURITY.
247100*
247200     IF  X-MM07-TAT IS EQUAL TO 14
247300         MOVE DFHBMDAS           TO MM07-TAT-ACCOUNT-LP-A
247400                                    (X-MM07-TAT)
247500                                    MM07-TAT-ACCOUNT-RP-A
247600                                    (X-MM07-TAT)
247700                                    MM07-TAT-ACCOUNT-A
247800                                    (X-MM07-TAT)
247900         GO TO Y196-EXIT.
248000*
248100     IF  MMFS-MT-NO-ACCESS (X-MMFS-MERCH)
248200         MOVE DFHBMDAS           TO MM07-TAT-ACCOUNT-LP-A
248300                                    (X-MM07-TAT)
248400                                    MM07-TAT-ACCOUNT-RP-A
248500                                    (X-MM07-TAT)
248600                                    MM07-TAT-ACCOUNT-A
248700                                    (X-MM07-TAT)
248800         MOVE ZERO               TO MM07-TAT-ACCOUNT-L
248900                                    (X-MM07-TAT)
249000         GO TO Y196-EXIT.
249100*
249200     IF  MBCA-PTI-FUNCTION-IS-INQUIRY
249300         MOVE DFHBMDAS           TO MM07-TAT-ACCOUNT-LP-A
249400                                    (X-MM07-TAT)
249500                                    MM07-TAT-ACCOUNT-RP-A
249600                                    (X-MM07-TAT)
249700         MOVE DFHBMASB           TO MM07-TAT-ACCOUNT-A
249800                                    (X-MM07-TAT)
249900         GO TO Y196-EXIT.
250000*
250100     IF  MMFS-MT-INQ-ONLY (X-MMFS-MERCH)
250200         MOVE ZERO               TO MM07-TAT-ACCOUNT-L
250300                                    (X-MM07-TAT)
250400         MOVE DFHBMDAS           TO MM07-TAT-ACCOUNT-LP-A
250500                                    (X-MM07-TAT)
250600                                    MM07-TAT-ACCOUNT-RP-A
250700                                    (X-MM07-TAT)
250800         MOVE DFHBMASK           TO MM07-TAT-ACCOUNT-A
250900                                    (X-MM07-TAT)
251000         GO TO Y196-EXIT.
251100*
251200     IF  MBCA-PTI-FUNCTION-IS-ADD
251300         IF  MMFS-MT-REQUIRED (X-MMFS-MERCH)
251400             MOVE DFHBMASB       TO MM07-TXN-ASSIGNMENT-LIT-A
251500                                    (X-MM07-TAT)
251600         ELSE
251700             IF  MMFS-MT-MAINT-ONLY (X-MMFS-MERCH)
251800                 MOVE ZERO       TO MM07-TAT-ACCOUNT-L
251900                                    (X-MM07-TAT)
252000                 MOVE DFHBMDAS   TO MM07-TAT-ACCOUNT-LP-A
252100                                    (X-MM07-TAT)
252200                                    MM07-TAT-ACCOUNT-RP-A
252300                                    (X-MM07-TAT)
252400                 MOVE DFHBMASK   TO MM07-TAT-ACCOUNT-A
252500                                    (X-MM07-TAT).
252600*
252700     IF  MBCA-PTI-FUNCTION-IS-MAINT
252800         IF  MMFS-MT-NO-MAINT (X-MMFS-MERCH)
252900             MOVE ZERO           TO MM07-TAT-ACCOUNT-L
253000                                    (X-MM07-TAT)
253100             MOVE DFHBMDAS       TO MM07-TAT-ACCOUNT-LP-A
253200                                    (X-MM07-TAT)
253300                                    MM07-TAT-ACCOUNT-RP-A
253400                                    (X-MM07-TAT)
253500             MOVE DFHBMASK       TO MM07-TAT-ACCOUNT-A
253600                                    (X-MM07-TAT).
253700*
253800 Y196-EXIT.
253900     EXIT.
254000*
254100 Y198-INCREMENT-INDEX.
254200*
254300     IF  X-MM07-TAT IS LESS THAN 16
254400         SET X-MM07-TAT          UP BY 1
254500         SET X-MMMM-TAT          UP BY 1
254600         SET X-MMFS-MERCH        UP BY 2
254700         GO TO Y191-ASSIGN-ACCT-LOOP.
254800*
254900 Y199-EXIT.
255000     EXIT.
255100*
255200 Y210-MOVE-ASSIGN-USER-CODE.
255300*
255400     SET X-MM07-TAT              TO 1.
255500     SET X-MMMM-TAT              TO 1.
255600     MOVE MMMMTB-TAT-USER-CODE-1 (1:4)
255700                                 TO WS-INDEX-X.
255800     SET X-MMFS-MERCH            TO WS-INDEX.
255900*
256000 Y211-ASSIGN-USER-CODE-LOOP.
256100*
256200     MOVE MMMM-TAT-USER-CODE (X-MMMM-TAT)
256300                                 TO MM07-TAT-USER-CODE
256400                                    (X-MM07-TAT).
256500*
256600 Y215-ASSIGN-USER-CODE-SECURITY.
256700*
256800     IF  X-MM07-TAT IS EQUAL TO 14
256900         MOVE DFHBMDAS           TO MM07-TAT-USER-CODE-LP-A
257000                                    (X-MM07-TAT)
257100                                    MM07-TAT-USER-CODE-RP-A
257200                                    (X-MM07-TAT)
257300                                    MM07-TAT-USER-CODE-A
257400                                    (X-MM07-TAT)
257500         GO TO Y216-EXIT.
257600*
257700     IF  MMFS-MT-NO-ACCESS (X-MMFS-MERCH)
257800         MOVE DFHBMDAS           TO MM07-TAT-USER-CODE-LP-A
257900                                    (X-MM07-TAT)
258000                                    MM07-TAT-USER-CODE-RP-A
258100                                    (X-MM07-TAT)
258200                                    MM07-TAT-USER-CODE-A
258300                                    (X-MM07-TAT)
258400         MOVE ZERO               TO MM07-TAT-USER-CODE-L
258500                                    (X-MM07-TAT)
258600         GO TO Y216-EXIT.
258700*
258800     IF  MBCA-PTI-FUNCTION-IS-INQUIRY
258900         MOVE DFHBMDAS           TO MM07-TAT-USER-CODE-LP-A
259000                                    (X-MM07-TAT)
259100                                    MM07-TAT-USER-CODE-RP-A
259200                                    (X-MM07-TAT)
259300         MOVE DFHBMASB           TO MM07-TAT-USER-CODE-A
259400                                    (X-MM07-TAT)
259500         GO TO Y216-EXIT.
259600*
259700     IF  MMFS-MT-INQ-ONLY (X-MMFS-MERCH)
259800         MOVE ZERO               TO MM07-TAT-USER-CODE-L
259900                                    (X-MM07-TAT)
260000         MOVE DFHBMDAS           TO MM07-TAT-USER-CODE-LP-A
260100                                    (X-MM07-TAT)
260200                                    MM07-TAT-USER-CODE-RP-A
260300                                    (X-MM07-TAT)
260400         MOVE DFHBMASK           TO MM07-TAT-USER-CODE-A
260500                                    (X-MM07-TAT)
260600         GO TO Y216-EXIT.
260700*
260800     IF  MBCA-PTI-FUNCTION-IS-ADD
260900         IF  MMFS-MT-REQUIRED (X-MMFS-MERCH)
261000             MOVE DFHBMASB       TO MM07-TXN-ASSIGNMENT-LIT-A
261100                                    (X-MM07-TAT)
261200         ELSE
261300             IF  MMFS-MT-MAINT-ONLY (X-MMFS-MERCH)
261400                 MOVE ZERO       TO MM07-TAT-USER-CODE-L
261500                                    (X-MM07-TAT)
261600                 MOVE DFHBMDAS   TO MM07-TAT-USER-CODE-LP-A
261700                                    (X-MM07-TAT)
261800                                    MM07-TAT-USER-CODE-RP-A
261900                                    (X-MM07-TAT)
262000                 MOVE DFHBMASK   TO MM07-TAT-USER-CODE-A
262100                                    (X-MM07-TAT).
262200*
262300     IF  MBCA-PTI-FUNCTION-IS-MAINT
262400         IF  MMFS-MT-NO-MAINT (X-MMFS-MERCH)
262500             MOVE ZERO           TO MM07-TAT-USER-CODE-L
262600                                    (X-MM07-TAT)
262700             MOVE DFHBMDAS       TO MM07-TAT-USER-CODE-LP-A
262800                                    (X-MM07-TAT)
262900                                    MM07-TAT-USER-CODE-RP-A
263000                                    (X-MM07-TAT)
263100             MOVE DFHBMASK       TO MM07-TAT-USER-CODE-A
263200                                    (X-MM07-TAT).
263300*
263400 Y216-EXIT.
263500     EXIT.
263600*
263700 Y218-INCREMENT-INDEX.
263800*
263900     IF  X-MM07-TAT IS LESS THAN 16
264000         SET X-MM07-TAT          UP BY 1
264100         SET X-MMMM-TAT          UP BY 1
264200         SET X-MMFS-MERCH        UP BY 2
264300         GO TO Y211-ASSIGN-USER-CODE-LOOP.
264400*
264500 Y219-EXIT.
264600     EXIT.
264700*
264800 Y800-SET-CURSOR.
264900*
265000************************************************************
265100*    THIS ROUTINE IS PERFORMED IF IN ADD OR MAINTENANCE    *
265200*    AND SETS THE CURSOR TO THE FIRST FIELD WHICH IS       *
265300*    OPEN FOR INPUT                                        *
265400************************************************************
265500*
265600     MOVE MMMMTB-POST-REJECTS-FLAG (1:4)
265700                                 TO WS-INDEX-X.
265800     SET X-MMFS-MERCH            TO WS-INDEX.
265900*
266000 Y801-SC-LOOP.
266100*
266200     IF  MBCA-PTI-FUNCTION-IS-ADD
266300         IF  MMFS-MT-OPTIONAL (X-MMFS-MERCH)
266400         OR  MMFS-MT-REQUIRED (X-MMFS-MERCH)
266500             GO TO Y802-SC-DETERMINE-FIELD.
266600*
266700     IF  MBCA-PTI-FUNCTION-IS-MAINT
266800         IF  MMFS-MT-MAINT-ALLOWED (X-MMFS-MERCH)
266900             GO TO Y802-SC-DETERMINE-FIELD.
267000*
267100     MOVE MMMMTB-AGENT-BANK (1:4)
267200                                 TO WS-INDEX-X.
267300     IF  X-MMFS-MERCH IS LESS THAN WS-INDEX
267400         SET X-MMFS-MERCH        UP BY 1
267500         GO TO Y801-SC-LOOP.
267600*
267700 Y802-SC-DETERMINE-FIELD.
267800*
267900     MOVE MMMMTB-AGENT-BANK (1:4)
268000                                 TO WS-INDEX-X.
268100     IF  X-MMFS-MERCH IS EQUAL TO WS-INDEX
268200         MOVE SS08WS-CURSOR      TO MM07-ALT-TRANID-L
268300         GO TO Y809-SC-EXIT.
268400*
268500     SET WS-FIELD-POSITION       TO X-MMFS-MERCH.
268600     MOVE MMMMTB-PENDING-DR-ACCT-4 (1:4)
268700                                 TO WS-INDEX-X.
268800     SUBTRACT WS-INDEX           FROM WS-FIELD-POSITION.
268900*
269000       GO TO Y803-POST-REJECTS-FLAG
269100             Y803-SETT-FREQ-1
269200             Y803-SETT-FREQ-2
269300             Y803-ACH-DEPOSITS
269400             Y803-PRINT-FAX
269500             Y803-SETT-NOTICE-DETAIL-FLAG
269600             Y803-TAT-ACCOUNT-1
269700             Y803-TAT-USER-CODE-1
269800             Y803-TAT-ACCOUNT-2
269900             Y803-TAT-USER-CODE-2
270000             Y803-TAT-ACCOUNT-3
270100             Y803-TAT-USER-CODE-3
270200             Y803-TAT-ACCOUNT-4
270300             Y803-TAT-USER-CODE-4
270400             Y803-TAT-ACCOUNT-5
270500             Y803-TAT-USER-CODE-5
270600             Y803-TAT-ACCOUNT-6
270700             Y803-TAT-USER-CODE-6
270800             Y803-TAT-ACCOUNT-7
270900             Y803-TAT-USER-CODE-7
271000             Y803-TAT-ACCOUNT-8
271100             Y803-TAT-USER-CODE-8
271200             Y803-TAT-ACCOUNT-9
271300             Y803-TAT-USER-CODE-9
271400             Y803-TAT-ACCOUNT-10
271500             Y803-TAT-USER-CODE-10
271600             Y803-TAT-ACCOUNT-11
271700             Y803-TAT-USER-CODE-11
271800             Y803-TAT-ACCOUNT-12
271900             Y803-TAT-USER-CODE-12
272000             Y803-TAT-ACCOUNT-13
272100             Y803-TAT-USER-CODE-13
272200             Y803-TAT-ACCOUNT-14
272300             Y803-TAT-USER-CODE-14
272400             Y803-TAT-ACCOUNT-15
272500             Y803-TAT-USER-CODE-15
272600             Y803-TAT-ACCOUNT-16
272700             Y803-TAT-USER-CODE-16
272800         DEPENDING ON WS-FIELD-POSITION.
272900*
273000 Y803-POST-REJECTS-FLAG.
273100*
273200     MOVE SS08WS-CURSOR          TO MM07-POST-REJECTS-FLAG-L.
273300     GO TO Y809-SC-EXIT.
273400*
273500 Y803-SETT-FREQ-1.
273600*
273700     MOVE SS08WS-CURSOR          TO MM07-SETT-FREQ1-L.
273800     GO TO Y809-SC-EXIT.
273900*
274000 Y803-SETT-FREQ-2.
274100*
274200     MOVE SS08WS-CURSOR          TO MM07-SETT-FREQ2-L.
274300     GO TO Y809-SC-EXIT.
274400*
274500 Y803-ACH-DEPOSITS.
274600*
274700     MOVE SS08WS-CURSOR          TO MM07-ACH-DEPOSIT-L.
274800     GO TO Y809-SC-EXIT.
274900*
275000 Y803-PRINT-FAX.
275100*
275200     MOVE SS08WS-CURSOR          TO MM07-PRINT-FAX-L.
275300     GO TO Y809-SC-EXIT.
275400*
275500 Y803-SETT-NOTICE-DETAIL-FLAG.
275600*
275700     MOVE SS08WS-CURSOR          TO MM07-DETAIL-TXNS-L.
275800     GO TO Y809-SC-EXIT.
275900*
276000 Y803-TAT-ACCOUNT-1.
276100*
276200     MOVE SS08WS-CURSOR          TO MM07-TAT-ACCOUNT-L (1).
276300     GO TO Y809-SC-EXIT.
276400*
276500 Y803-TAT-USER-CODE-1.
276600*
276700     MOVE SS08WS-CURSOR          TO MM07-TAT-USER-CODE-L (1).
276800     GO TO Y809-SC-EXIT.
276900*
277000 Y803-TAT-ACCOUNT-2.
277100*
277200     MOVE SS08WS-CURSOR          TO MM07-TAT-ACCOUNT-L (2).
277300     GO TO Y809-SC-EXIT.
277400*
277500 Y803-TAT-USER-CODE-2.
277600*
277700     MOVE SS08WS-CURSOR          TO MM07-TAT-USER-CODE-L (2).
277800     GO TO Y809-SC-EXIT.
277900*
278000 Y803-TAT-ACCOUNT-3.
278100*
278200     MOVE SS08WS-CURSOR          TO MM07-TAT-ACCOUNT-L (3).
278300     GO TO Y809-SC-EXIT.
278400*
278500 Y803-TAT-USER-CODE-3.
278600*
278700     MOVE SS08WS-CURSOR          TO MM07-TAT-USER-CODE-L (3).
278800     GO TO Y809-SC-EXIT.
278900*
279000 Y803-TAT-ACCOUNT-4.
279100*
279200     MOVE SS08WS-CURSOR          TO MM07-TAT-ACCOUNT-L (4).
279300     GO TO Y809-SC-EXIT.
279400*
279500 Y803-TAT-USER-CODE-4.
279600*
279700     MOVE SS08WS-CURSOR          TO MM07-TAT-USER-CODE-L (4).
279800     GO TO Y809-SC-EXIT.
279900*
280000 Y803-TAT-ACCOUNT-5.
280100*
280200     MOVE SS08WS-CURSOR          TO MM07-TAT-ACCOUNT-L (5).
280300     GO TO Y809-SC-EXIT.
280400*
280500 Y803-TAT-USER-CODE-5.
280600*
280700     MOVE SS08WS-CURSOR          TO MM07-TAT-USER-CODE-L (5).
280800     GO TO Y809-SC-EXIT.
280900*
281000 Y803-TAT-ACCOUNT-6.
281100*
281200     MOVE SS08WS-CURSOR          TO MM07-TAT-ACCOUNT-L (6).
281300     GO TO Y809-SC-EXIT.
281400*
281500 Y803-TAT-USER-CODE-6.
281600*
281700     MOVE SS08WS-CURSOR          TO MM07-TAT-USER-CODE-L (6).
281800     GO TO Y809-SC-EXIT.
281900*
282000 Y803-TAT-ACCOUNT-7.
282100*
282200     MOVE SS08WS-CURSOR          TO MM07-TAT-ACCOUNT-L (7).
282300     GO TO Y809-SC-EXIT.
282400*
282500 Y803-TAT-USER-CODE-7.
282600*
282700     MOVE SS08WS-CURSOR          TO MM07-TAT-USER-CODE-L (7).
282800     GO TO Y809-SC-EXIT.
282900*
283000 Y803-TAT-ACCOUNT-8.
283100*
283200     MOVE SS08WS-CURSOR          TO MM07-TAT-ACCOUNT-L (8).
283300     GO TO Y809-SC-EXIT.
283400*
283500 Y803-TAT-USER-CODE-8.
283600*
283700     MOVE SS08WS-CURSOR          TO MM07-TAT-USER-CODE-L (8).
283800     GO TO Y809-SC-EXIT.
283900*
284000 Y803-TAT-ACCOUNT-9.
284100*
284200     MOVE SS08WS-CURSOR          TO MM07-TAT-ACCOUNT-L (9).
284300     GO TO Y809-SC-EXIT.
284400*
284500 Y803-TAT-USER-CODE-9.
284600*
284700     MOVE SS08WS-CURSOR          TO MM07-TAT-USER-CODE-L (9).
284800     GO TO Y809-SC-EXIT.
284900*
285000 Y803-TAT-ACCOUNT-10.
285100*
285200     MOVE SS08WS-CURSOR          TO MM07-TAT-ACCOUNT-L (10).
285300     GO TO Y809-SC-EXIT.
285400*
285500 Y803-TAT-USER-CODE-10.
285600*
285700     MOVE SS08WS-CURSOR          TO MM07-TAT-USER-CODE-L (10).
285800     GO TO Y809-SC-EXIT.
285900*
286000 Y803-TAT-ACCOUNT-11.
286100*
286200     MOVE SS08WS-CURSOR          TO MM07-TAT-ACCOUNT-L (11).
286300     GO TO Y809-SC-EXIT.
286400*
286500 Y803-TAT-USER-CODE-11.
286600*
286700     MOVE SS08WS-CURSOR          TO MM07-TAT-USER-CODE-L (11).
286800     GO TO Y809-SC-EXIT.
286900*
287000 Y803-TAT-ACCOUNT-12.
287100*
287200     MOVE SS08WS-CURSOR          TO MM07-TAT-ACCOUNT-L (12).
287300     GO TO Y809-SC-EXIT.
287400*
287500 Y803-TAT-USER-CODE-12.
287600*
287700     MOVE SS08WS-CURSOR          TO MM07-TAT-USER-CODE-L (12).
287800     GO TO Y809-SC-EXIT.
287900*
288000 Y803-TAT-ACCOUNT-13.
288100*
288200     MOVE SS08WS-CURSOR          TO MM07-TAT-ACCOUNT-L (13).
288300     GO TO Y809-SC-EXIT.
288400*
288500 Y803-TAT-USER-CODE-13.
288600*
288700     MOVE SS08WS-CURSOR          TO MM07-TAT-USER-CODE-L (13).
288800     GO TO Y809-SC-EXIT.
288900*
289000 Y803-TAT-ACCOUNT-14.
289100*
289200     MOVE SS08WS-CURSOR          TO MM07-TAT-ACCOUNT-L (14).
289300     GO TO Y809-SC-EXIT.
289400*
289500 Y803-TAT-USER-CODE-14.
289600*
289700     MOVE SS08WS-CURSOR          TO MM07-TAT-USER-CODE-L (14).
289800     GO TO Y809-SC-EXIT.
289900*
290000 Y803-TAT-ACCOUNT-15.
290100*
290200     MOVE SS08WS-CURSOR          TO MM07-TAT-ACCOUNT-L (15).
290300     GO TO Y809-SC-EXIT.
290400*
290500 Y803-TAT-USER-CODE-15.
290600*
290700     MOVE SS08WS-CURSOR          TO MM07-TAT-USER-CODE-L (15).
290800     GO TO Y809-SC-EXIT.
290900*
291000 Y803-TAT-ACCOUNT-16.
291100*
291200     MOVE SS08WS-CURSOR          TO MM07-TAT-ACCOUNT-L (16).
291300     GO TO Y809-SC-EXIT.
291400*
291500 Y803-TAT-USER-CODE-16.
291600*
291700     MOVE SS08WS-CURSOR          TO MM07-TAT-USER-CODE-L (16).
291800     GO TO Y809-SC-EXIT.
291900*
292000 Y809-SC-EXIT.
292100     EXIT.
292200*
292300 Y900-READ-MMFS.
292400*
292500****************************************
292600*    READ THE FIELD SECURITY RECORD    *
292700*    TO OBTAIN THE SECURITY CODES      *
292800****************************************
292900*
293000     MOVE MBCA-MERCHANT-ORG      TO MBIOWS-MMFS-ORG.
293100     MOVE MBCA-FIELD-SECURITY    TO MBIOWS-MMFS-FS-CODE.
293200     SET MBIORO-READ-RANDOM      TO TRUE.
293300     PERFORM MMFSAO-ACCESS       THRU MMFSAO-ACCESS-EXIT.
293400*
293500     IF  NOT MMFS-REC-ACTIVE
293600         MOVE MBIORO-IO-REQUEST  TO MBCA-ERRR-IO-REQUEST
293700         MOVE MBIORO-FILE-NAME   TO MBCA-ERRR-EIBDS
293800         MOVE EIBFN              TO MBCA-ERRR-EIBFN-CODES
293900         MOVE MBCA-PROGRAM-ID    TO MBCA-ERRR-BAD-PROGRAM
294000         MOVE MBCA-TRANS-ID      TO MBCA-ERRR-BAD-TRANSID
294100         SET MBCA-ERROR-MSGS-PROVIDED
294200                                 TO TRUE
294300         MOVE 'READ ERROR - MMFSAO'
294400                                 TO MBCA-ERRR-MSG1
294500         MOVE 'FIELDS SECURITY PROFILE IS NOT ACTIVE'
294600                                 TO MBCA-ERRR-MSG2
294700         GO TO MB70PD-ERROR-ROUTINE.
294800*
294900 Y909-READ-MMFS-EXIT.
295000     EXIT.
295100*
295200 Y910-WRITE-LOG-RECORD.
295300*
295400     SET MBIORO-WRITE            TO TRUE.
295500     PERFORM MML1AO-ACCESS       THRU MML1AO-ACCESS-EXIT.
295600     MOVE SPACES                 TO MML1-VARIABLE-AREA.
295700*
295800 Y919-WLR-EXIT.
295900     EXIT.
296000/
296100**********************************
296200*    JUL TO GREG DATE ROUTINE    *
296300**********************************
296400*
296500     COPY SS08PD.
296600/
296700**********************************
296800*    DATE AND TIME EDIT ROUTINES *
296900**********************************
297000*
297100     COPY SS26PD.
297200     COPY SS27PD.
297300/
297400*********************************
297500*    LINE 24 PF KEYS ROUTINE    *
297600*********************************
297700*
297800     COPY SS15PD.
297900/
298000************************************************
298100*    MERCHANT MASTER RECORD ACCESS ROUTINES    *
298200************************************************
298300*
298400     COPY MMMMAO.
298500/
298600************************************************
298700*    STORE MASTER RECORD ACCESS ROUTINES       *
298800************************************************
298900*
299000     COPY MMSMAO.
299100/
299200************************************************
299300*    MERCH STORE XREF RECORD ACCESS ROUTINES   *
299400************************************************
299500*
299600     COPY MMXRAO.
299700/
299800*************************************************************
299900*    MERCHANT RELATIONSHIP CONTROL RECORD ACCESS ROUTINES   *
300000*************************************************************
300100*
300200     COPY MMRCAO.
300300/
300400***********************************************
300500*    FIELD SECURITY RECORD ACCESS ROUTINES    *
300600***********************************************
300700*
300800     COPY MMFSAO.
300900/
301000***********************************************
301100*    RATE TABLE RECORD ACCESS ROUTINES        *
301200***********************************************
301300*
301400     COPY MMRTAO.
301500/
301600*********************************************
301700*    PROD ACTIVITY RECORD ACCESS ROUTINES   *
301800*********************************************
301900*
302000     COPY MMPAAO.
302100/
302200*********************************************
302300*    ORG CONTROL RECORD ACCESS ROUTINES     *
302400*********************************************
302500*
302600     COPY MMOCAO.
302700/
302800*****************************************
302900*    LOG FILE RECORD ACCESS ROUTINES    *
303000*****************************************
303100*
303200     COPY MML1AO.
303300/
303400*****************************
303500*    ONLINE MAP ROUTINES    *
303600*****************************
303700*
303800     COPY MB60PD REPLACING 'MBMAPXX' BY 'MBMM07 '
303900                           MBMAPXXI BY MBMM07I
304000                           MBMAPXXO BY MBMM07O.
304100/
304200***************************
304300*    ONLINE PROCEDURES    *
304400***************************
304500*
304600     COPY MB70PD.
304700/
304800     COPY SMFTPXO.
