000100 IDENTIFICATION DIVISION.
000200 PROGRAM-ID. MBOMO00.
000201*       RELEASE DATE=08/24/01.        REVISION LEVEL=08.06      *
000202*****************************************************************
000203*WARNING.  THIS COMPUTER PROGRAM IS PROTECTED BY COPYRIGHT LAW  *
000204*AND INTERNATIONAL TREATIES.  UNAUTHORIZED REPRODUCTION OR      *
000205*DISTRIBUTION OF THIS PROGRAM, OR ANY PORTION OF IT, MAY RESULT *
000206*IN SEVERE CIVIL AND CRIMINAL PENATLIES, AND WILL BE PROSECUTED *
000207*TO THE MAXIMUM EXTENT POSSIBLE UNDER THE LAW.                  *
000208*COPYRIGHT 1999 PAYSYS INTERNATIONAL, INC.  ALL RIGHTS RESERVED.*
000209*****************************************************************
000300*****************************************************************
000400*                                                               *
000500*   V - PLUS  M E R C H A N T   B A N K C A R D   S Y S T E M   *
000600*                                                               *
000700*      MBOMO00 - ON-LINE ORG RECORD ADD/MAINTENANCE/INQUIRY     *
000800*                LOCATE SCREEN 00                               *
000900*                                                               *
001000*              1. TRANSIDS                                      *
001100*                 A. MBAO                                       *
001200*                 B. MBMO                                       *
001300*                 C. MBQO                                       *
001400*              2. MAPS USED -                                   *
001500*                 A. MBMO00 (LOCATE MAP)                        *
001600*              3. FILES USED -                                  *
001700*                 A. MMOC   (ORG CONTROL FILE)                  *
001800*                                                               *
001900*****************************************************************
002000*
002100 ENVIRONMENT DIVISION.
002200 DATA DIVISION.
002300 WORKING-STORAGE SECTION.
002400 01  FILLER                  PIC  X(12)      VALUE '** WS-BEG **'.
002500/         I/O REQUEST BLOCK WORK AREAS
002600     COPY MBIOWS.
002700/         I/O REQUEST BLOCK
002800     COPY MBIORO.
002900/         ORG RECORD INITIALIZE VALUES
003000     COPY MMOCIR.
003100/         DATE WORK AREAS
003200     COPY SS01WS.
003300/         ONLINE WORK AREAS
003400     COPY SS08WS.
003500/
003600     COPY SS00WS.
003700/
003800     COPY SMFTWS.
003900/
004000     COPY SMPTRL REPLACING ==:SMPT:== BY ==SMPT==.
004100/
004200     COPY MB61LK.
004300/         STANDARD ERROR MESSAGES
004400     COPY MBEMWS.
004500*
004600 01  WS-MISCELLANEOUS.
004700     03  WS-ORG-LOW          PIC S9(03)      VALUE +001 COMP-3.
004800     03  WS-ORG-HIGH         PIC S9(03)      VALUE +998 COMP-3.
004900     03  WS-COPY-SW          PIC  X(01)      VALUE 'N'.
005000         88  WS-COPY-SW-NO                   VALUE 'N'.
005100         88  WS-COPY-SW-YES                  VALUE 'Y'.
005200*
005300 01  FILLER                  PIC  X(12)      VALUE '** WS-END **'.
005400/
005500 LINKAGE SECTION.
005600 01  DFHCOMMAREA.
005700     COPY MB60WS.
005800/         ORG SCREEN 00 MAP DSECT
005900     COPY MBMO00.
006000/         ORG SCREEN 00 MAP REDEFINITION
006100     COPY MBMO00R.
006200/         ORG RECORD LAYOUT
006300     COPY MMOCRL.
006400/
006500 PROCEDURE DIVISION.
006600 0000-HOUSEKEEPING SECTION.
006700 0100-INIT.
006800*
006900     MOVE 'PC01'                 TO MBCA-PROGRAM-LOCATION.
007000     PERFORM MB70PD-ON-LINE-HOUSEKEEPING
007100                                 THRU MB70PD-OLH-EXIT.
007200*
007300     IF  MBCA-RECEIVE-SCREEN
007400         GO TO 2000-RECEIVE-SCREEN.
007500*
007600 1000-SEND-SCREEN SECTION.
007700*
007800****************************************************************
007900*    GET CICS STORAGE NEEDED FOR THE MAP                       *
008000****************************************************************
008100*
008200     MOVE 'SC01'                 TO MBCA-PROGRAM-LOCATION.
008300     PERFORM MB60PD-GETMAIN-FOR-MAP
008400                                 THRU MB60PD-GFM-EXIT.
008500*
008600     MOVE 1                      TO MBCA-MBMO-PROD-INDEX.
008700*
008800     IF  MBCA-PTI-FUNCTION-MAINT-OR-INQ
008900         MOVE DFHBMDAS           TO MO00-COPY-ORG-LIT-A
009000                                    MO00-COPY-ORG-LP-A
009100                                    MO00-COPY-ORG-RP-A
009200         MOVE DFHBMASK           TO MO00-COPY-ORG-A
009300         PERFORM
009400             VARYING X-MO00-DIR-AREA FROM +1 BY +1
009500             UNTIL   X-MO00-DIR-AREA IS GREATER THAN +16
009600             MOVE DFHBMASF       TO MO00-SELECT-SCREEN-NBR-A
009700                                    (X-MO00-DIR-AREA)
009800         END-PERFORM
009900     ELSE
010000         MOVE DFHBMDAS           TO MO00-DIRECTORY-SEL-LIT-A
010100         PERFORM
010200             VARYING X-MO00-DIR-AREA FROM +1 BY +1
010300             UNTIL   X-MO00-DIR-AREA IS GREATER THAN +16
010400                 MOVE DFHBMDAS   TO MO00-SELECT-LP-A
010500                                    (X-MO00-DIR-AREA)
010600                                    MO00-SELECT-RP-A
010700                                    (X-MO00-DIR-AREA)
010800                                    MO00-SELECT-LIT1-A
010900                                    (X-MO00-DIR-AREA)
011000                                    MO00-SELECT-LIT2-A
011100                                    (X-MO00-DIR-AREA)
011200                                    MO00-SELECT-SCREEN-NBR-A
011300                                    (X-MO00-DIR-AREA)
011400                 MOVE DFHBMASK   TO MO00-SELECT-A
011500                                    (X-MO00-DIR-AREA)
011600         END-PERFORM.
011700*
011800*****************************************************************
011900*    CHECK KEY CODES                                            *
012000* 1. IF ADD FUNCTION, BYPASS CHECK OF KEY CODES.                *
012100* 2. IF INITIAL KEY CODE, BYPASS CHECK OF KEY CODES.            *
012200* 3. IF MMOC KEY CODE, IT MUST BE A VALID CODE.  IF DIRECT, GO  *
012300*    TO THE RECEIVE EDITING ROUTINE SINCE WE HAVE PLUGGED THE   *
012400*    ORG IN THE MAP.  IF AN ERROR OCCURS IN THE                 *
012500*    RECEIVE SCREEN ROUTINE, IT WILL HANDLE BUILDING THE MAP    *
012600*    AND IT WILL SEND ITS OWN SCREEN.  THIS IS WHY LOCATE       *
012700*    PROGRAMS ALWAYS SEND WITH ERASE NO MATTER WHICH ROUTINE    *
012800*    YOU ARE IN.  IF NOT DIRECT, PLUG ORG INTO MAP              *
012900*    AND BYPASS ANY OTHER CHECKING OF THE KEY CODE.             *
013000* 4. IF 2 AND 3 ARE FALSE, SEE IF THE MBCA-MERCHANT-ORG         *
013100*    FIELD IS GREATER THAN ZERO.  IF SO, PLUG INTO MAP          *
013200*    HANDLE IF THEY WERE NON-DIRECT.                            *
013300*****************************************************************
013400*
013500     IF  MBCA-PTI-FUNCTION-IS-ADD
013600     OR  MBCA-INITIAL-KEY-CODE
013700         GO TO 1100-BUILD-SCREEN.
013800*
013900     IF  MBCA-MMOC-KEY-CODE
014000     AND MBCA-MERCHANT-ORG IS GREATER THAN ZERO
014100         MOVE MBCA-MERCHANT-ORG  TO MO00-ORG
014200         MOVE DFHBMUNF           TO MO00-ORG-A
014300         IF  MBCA-DIRECT-TRANSFER-CODE
014400         AND MBCA-INITIAL-SCREEN-NBR
014500             MOVE 00             TO MBCA-SCREEN-NBR
014600             GO TO 2130-READ-ORG
014700         ELSE
014800             GO TO 1100-BUILD-SCREEN.
014900*
015000     IF  MBCA-VALID-KEY-CODES
015100     AND MBCA-MERCHANT-ORG IS GREATER THAN ZERO
015200         MOVE MBCA-MERCHANT-ORG  TO MO00-ORG
015300         MOVE DFHBMUNF           TO MO00-ORG-A.
015400*
015500 1100-BUILD-SCREEN.
015600*
015700****************************************************************
015800*    INITIALIZE THE STANDARD MAP LINES                         *
015900****************************************************************
016000*
016100     MOVE SS08WS-CURSOR          TO MO00-ORG-L.
016200     MOVE 00                     TO MBCA-SCREEN-NBR.
016300     PERFORM MB60PD-INIT-STD-MAP-LINES
016400                                 THRU MB60PD-ISML-EXIT.
016500*
016600     IF  MBCA-PTI-FUNCTION-IS-MAINT
016700     OR  MBCA-PTI-FUNCTION-IS-INQUIRY
016800         MOVE DFHBMDAS           TO MO00-COPY-ORG-LIT-A
016900                                    MO00-COPY-ORG-LP-A
017000                                    MO00-COPY-ORG-RP-A
017100         MOVE DFHBMASK           TO MO00-COPY-ORG-A.
017200*
017300     IF  MBCA-MERCHANT-ORG IS NUMERIC
017400     AND MBCA-MERCHANT-ORG IS GREATER THAN ZERO
017500         IF  MBCA-PTI-FUNCTION-IS-ADD
017600             NEXT SENTENCE
017700         ELSE
017800             MOVE DFHBMUNF       TO MO00-ORG-A
017900             MOVE MBCA-MERCHANT-ORG
018000                                 TO MO00-ORG.
018100*
018200****************************************************************
018300*    SEND THE MAP                                              *
018400****************************************************************
018500*
018600     MOVE 'BM01'                 TO MBCA-PROGRAM-LOCATION.
018700     PERFORM MB60PD-SEND-MAP-WITH-ERASE
018800                                 THRU MB60PD-SMWE-EXIT.
018900*
019000****************************************************************
019100*    RETURN TO CICS                                            *
019200****************************************************************
019300*
019400     MOVE 'PC02'                 TO MBCA-PROGRAM-LOCATION.
019500     PERFORM MB70PD-RETURN-TRANS-ID
019600                                 THRU MB70PD-RTI-EXIT.
019700/
019800 2000-RECEIVE-SCREEN SECTION.
019900*
020000****************************************************************
020100*    THIS SECTION RECEIVES THE LOCATE SCREEN                   *
020200****************************************************************
020300*
020400     MOVE 'BM02'                 TO MBCA-PROGRAM-LOCATION.
020500     PERFORM MB60PD-RECEIVE-MAP  THRU MB60PD-RM-EXIT.
020600*
020700****************************************************************
020800*    CHECK FOR ANOTHER TRANSACTION ID ENTERED BY THE USER      *
020900****************************************************************
021000*
021100     MOVE 'PC03'                 TO MBCA-PROGRAM-LOCATION.
021200     PERFORM MB60PD-NEW-TRANS-ROUTINE
021300                                 THRU MB60PD-NTR-EXIT.
021400*
021500 2100-EDIT-SCREEN.
021600*
021700     SET SS08WS-ERROR-SW-NO      TO TRUE.
021800     MOVE MBCA-EIBAID            TO SS08WS-EIBAID.
021900*
022000     IF  (MO00-ORG-L IS LESS THAN 1
022100     AND  MO00-COPY-ORG-L IS LESS THAN 1)
022200     AND (SS08WS-VALID-PF-KEY
022300     OR   SS08WS-EIBAID-VALID-PF-KEY)
022400         SET MBCA-INITIAL-SCREEN-NBR
022500                                 TO TRUE
022600         GO TO 2690-TRANSFER-XCTL.
022700*
022800     IF  MBCA-PTI-FUNCTION-IS-ADD
022900         NEXT SENTENCE
023000     ELSE
023100         GO TO 2120-EDIT-ORG.
023200*
023300 2110-EDIT-COPY-ORG.
023400*
023500     MOVE DFHBMUNF               TO MO00-COPY-ORG-A.
023600     MOVE DFHBMASK               TO MO00-COPY-ORG-LP-A
023700                                    MO00-COPY-ORG-RP-A.
023800     MOVE DFHBMDAS               TO MO00-DIRECTORY-SEL-LIT-A.
023900     PERFORM
024000         VARYING X-MO00-DIR-AREA FROM +1 BY +1
024100         UNTIL       X-MO00-DIR-AREA IS GREATER THAN +16
024200             MOVE DFHBMDAS       TO MO00-SELECT-LP-A
024300                                    (X-MO00-DIR-AREA)
024400                                    MO00-SELECT-RP-A
024500                                    (X-MO00-DIR-AREA)
024600                                    MO00-SELECT-LIT1-A
024700                                    (X-MO00-DIR-AREA)
024800                                    MO00-SELECT-LIT2-A
024900                                    (X-MO00-DIR-AREA)
025000                                    MO00-SELECT-SCREEN-NBR-A
025100                                    (X-MO00-DIR-AREA)
025200             MOVE DFHBMASK       TO MO00-SELECT-A
025300                                    (X-MO00-DIR-AREA)
025400     END-PERFORM.
025500*
025600     IF  MO00-COPY-ORG-L IS EQUAL TO ZERO
025700         GO TO 2120-EDIT-ORG.
025800*
025900     IF  MO00-COPY-ORG IS NOT NUMERIC
026000         MOVE MBEMWS-INVALID-ORG TO MO00-ERR-MESSAGE
026100         GO TO 2115-COPY-ORG-ERROR.
026200*
026300     IF  MO00-COPY-ORG IS EQUAL TO ZEROS
026400         MOVE MBEMWS-INVALID-ORG TO MO00-ERR-MESSAGE
026500         GO TO 2115-COPY-ORG-ERROR.
026600*
026700     IF  MO00-COPY-ORG IS LESS THAN MBCA-ORG-LOW
026800     OR  MO00-COPY-ORG IS GREATER THAN MBCA-ORG-HIGH
026900     OR  MO00-COPY-ORG IS LESS THAN WS-ORG-LOW
027000     OR  MO00-COPY-ORG IS GREATER THAN WS-ORG-HIGH
027100         MOVE MBEMWS-INVALID-ORG TO MO00-ERR-MESSAGE
027200         GO TO 2115-COPY-ORG-ERROR.
027300*
027400****************************************************************
027500*    READ THE COPY ORGANIZATION RECORD                         *
027600****************************************************************
027700*
027800     MOVE 'Y'                    TO WS-COPY-SW.
027900     MOVE MO00-COPY-ORG          TO MBIOWS-MMOC-ORG.
028000     MOVE SS08WS-CICS-FC-NOTFND  TO MBIORO-TEMP-STATUS-1.
028100     MOVE 'FC01'                 TO MBCA-PROGRAM-LOCATION.
028200     SET MBIORO-READ-RANDOM      TO TRUE.
028300     PERFORM MMOCAO-ACCESS       THRU MMOCAO-ACCESS-EXIT.
028400*
028500     IF  SS08WS-RC-FC-NOTFND
028600         MOVE MBEMWS-NOT-ON-FILE TO MO00-ERR-MESSAGE
028700     ELSE
028800         IF  MMOC-ADD-PENDING
028900             MOVE MBEMWS-ADD-PENDING
029000                                 TO MO00-ERR-MESSAGE
029100         ELSE
029200             IF  MMOC-REC-INCOMPLETE
029300                 MOVE MBEMWS-NOT-ACTIVE
029400                                 TO MO00-ERR-MESSAGE
029500             ELSE
029600                 IF  MMOC-REC-PURGED
029700                     MOVE MBEMWS-REC-PURGED
029800                                 TO MO00-ERR-MESSAGE
029900                 ELSE
030000                     GO TO 2120-EDIT-ORG.
030100*
030200 2115-COPY-ORG-ERROR.
030300*
030400     SET SS08WS-ERROR-SW-YES     TO TRUE.
030500     MOVE DFHBMASB               TO MO00-COPY-ORG-LP-A
030600                                    MO00-COPY-ORG-RP-A.
030700     MOVE SS08WS-CURSOR          TO MO00-COPY-ORG-L.
030800     MOVE DFHBMNBF               TO MO00-COPY-ORG-A.
030900     MOVE DFHBMUNF               TO MO00-ORG-A.
031000     GO TO 2200-VALIDATE-ORG.
031100*
031200 2120-EDIT-ORG.
031300*
031400     MOVE DFHBMUNF               TO MO00-ORG-A.
031500     MOVE DFHBMASK               TO MO00-ORG-LP-A
031600                                    MO00-ORG-RP-A.
031700*
031800     IF  MO00-ORG-L IS EQUAL TO ZERO
031900     OR  MO00-ORG IS NOT NUMERIC
032000         MOVE MBEMWS-INVALID-ORG TO MO00-ERR-MESSAGE
032100         GO TO 2140-ORG-ERROR.
032200*
032300     IF  MO00-ORG IS LESS THAN MBCA-ORG-LOW
032400     OR  MO00-ORG IS GREATER THAN MBCA-ORG-HIGH
032500     OR  MO00-ORG IS LESS THAN WS-ORG-LOW
032600     OR  MO00-ORG IS GREATER THAN WS-ORG-HIGH
032700         MOVE MBEMWS-INVALID-ORG TO MO00-ERR-MESSAGE
032800         GO TO 2140-ORG-ERROR.
032900*
033000 2130-READ-ORG.
033100*
033200     IF  MO00-ORG IS EQUAL TO ZEROS
033300         MOVE MBEMWS-INVALID-ORG TO MO00-ERR-MESSAGE
033400         GO TO 2140-ORG-ERROR.
033500*
033600****************************************************************
033700*    READ THE ORGANIZATION FILE RECORD                         *
033800****************************************************************
033900*
034000     MOVE MO00-ORG               TO MBIOWS-MMOC-ORG.
034100     MOVE 'FC02'                 TO MBCA-PROGRAM-LOCATION.
034200     MOVE SS08WS-CICS-FC-NOTFND  TO MBIORO-TEMP-STATUS-1.
034300     SET MBIORO-READ-RANDOM      TO TRUE.
034400     PERFORM MMOCAO-ACCESS       THRU MMOCAO-ACCESS-EXIT.
034500*
034600     IF  SS08WS-RC-FC-VALID-RTN-CODE
034700         MOVE MO00-ORG           TO MBCA-MERCHANT-ORG
034800         MOVE MMOC-NA-LINE (1 1) TO MBCA-MBMO-ORG-NAME.
034900*
035000     IF  MBCA-PTI-FUNCTION-IS-INQUIRY
035100         IF  SS08WS-RC-FC-VALID-RTN-CODE
035200             IF  MMOC-ADD-PENDING
035300                 MOVE MBEMWS-ADD-PENDING
035400                                 TO MO00-ERR-MESSAGE
035500                 GO TO 2140-ORG-ERROR
035600             ELSE
035700                 GO TO 2200-VALIDATE-ORG
035800         ELSE
035900             MOVE MBEMWS-NOT-ON-FILE
036000                                 TO MO00-ERR-MESSAGE
036100             GO TO 2140-ORG-ERROR.
036200*
036300     IF  MBCA-PTI-FUNCTION-IS-ADD
036400     AND SS08WS-RC-FC-NOTFND
036500         MOVE MO00-ORG           TO MBCA-MERCHANT-ORG
036600         GO TO 2200-VALIDATE-ORG.
036700*
036800     IF  MBCA-PTI-FUNCTION-IS-ADD
036900     AND MMOC-ADD-PENDING
037000         IF  WS-COPY-SW-NO
037100             MOVE MMOC-ONLINE-STATUS
037200                                 TO MBCA-SCREEN-NBR
037300             GO TO 2600-SETUP-COMMAREA
037400         ELSE
037500             MOVE MBEMWS-ADD-PENDING
037600                                 TO MO00-ERR-MESSAGE
037700             GO TO 2140-ORG-ERROR.
037800*
037900     IF  MBCA-PTI-FUNCTION-IS-ADD
038000         MOVE MBEMWS-ALREADY-ON-FILE
038100                                 TO MO00-ERR-MESSAGE
038200         GO TO 2140-ORG-ERROR.
038300*
038400     IF  MBCA-PTI-FUNCTION-IS-MAINT
038500     AND SS08WS-RC-FC-NOTFND
038600         MOVE MBEMWS-NOT-ON-FILE TO MO00-ERR-MESSAGE
038700         GO TO 2140-ORG-ERROR.
038800*
038900     IF  MBCA-PTI-FUNCTION-IS-MAINT
039000     AND MMOC-ADD-PENDING
039100         MOVE MBEMWS-ADD-PENDING TO MO00-ERR-MESSAGE
039200         GO TO 2140-ORG-ERROR.
039300*
039400     IF  MBCA-PTI-FUNCTION-IS-MAINT
039500     AND MMOC-ADD-PENDING
039600         MOVE MBEMWS-ADD-PENDING TO MO00-ERR-MESSAGE
039700         GO TO 2140-ORG-ERROR.
039800*
039900******************************************************************
040000*    OTHERWISE, WE PASSED THE ORG EDIT                           *
040100******************************************************************
040200*
040300     GO TO 2200-VALIDATE-ORG.
040400*
040500 2140-ORG-ERROR.
040600*
040700     SET SS08WS-ERROR-SW-YES     TO TRUE.
040800     MOVE DFHBMASB               TO MO00-ORG-LP-A
040900                                    MO00-ORG-RP-A.
041000     MOVE SS08WS-CURSOR          TO MO00-ORG-L.
041100     MOVE DFHBMNBF               TO MO00-ORG-A.
041200*
041300 2200-VALIDATE-ORG.
041400*
041500     IF  MBCA-PTI-FUNCTION-MAINT-OR-INQ
041600         PERFORM
041700             VARYING X-MO00-DIR-AREA FROM +1 BY +1
041800             UNTIL   X-MO00-DIR-AREA IS GREATER THAN +16
041900             MOVE DFHBMASF       TO MO00-SELECT-SCREEN-NBR-A
042000                                    (X-MO00-DIR-AREA)
042100         END-PERFORM.
042200*
042300     IF  MBCA-PTI-FUNCTION-MAINT-OR-INQ
042400         PERFORM 9300-EDIT-SELECT
042500                                 THRU 9399-ES-EXIT
042600             VARYING X-MO00-DIR-AREA FROM +1 BY +1
042700             UNTIL   X-MO00-DIR-AREA IS GREATER THAN +16.
042800*
042900*
043000*
043100 2290-CHECK-ERROR.
043200*
043300     IF  SS08WS-ERROR-SW-NO
043400         IF  MBCA-PTI-FUNCTION-IS-INQUIRY
043500             GO TO 2600-SETUP-COMMAREA
043600         ELSE
043700             GO TO 2400-UPDATE-FILE
043800     ELSE
043900         IF  SS08WS-VALID-PF-KEY
044000         OR  SS08WS-EIBAID-VALID-PF-KEY
044100             SET MBCA-INITIAL-SCREEN-NBR
044200                                 TO TRUE
044300             GO TO 2690-TRANSFER-XCTL.
044400*
044500 2300-SEND-MAP.
044600*
044700****************************************************************
044800*    SEND THE MAP                                              *
044900****************************************************************
045000*
045100     PERFORM MB60PD-INIT-STD-MAP-LINES
045200                                 THRU MB60PD-ISML-EXIT.
045300*
045400     IF  MBCA-PTI-FUNCTION-IS-MAINT
045500     OR  MBCA-PTI-FUNCTION-IS-INQUIRY
045600         MOVE DFHBMDAS           TO MO00-COPY-ORG-LIT-A
045700                                    MO00-COPY-ORG-LP-A
045800                                    MO00-COPY-ORG-RP-A
045900         MOVE DFHBMASK           TO MO00-COPY-ORG-A.
046000*
046100     MOVE 'BM03'                 TO MBCA-PROGRAM-LOCATION.
046200     PERFORM MB60PD-SEND-MAP-WITH-ERASE
046300                                 THRU MB60PD-SMWE-EXIT.
046400*
046500****************************************************************
046600*    RETURN TO CICS                                            *
046700****************************************************************
046800*
046900     MOVE 'PC04'                 TO MBCA-PROGRAM-LOCATION.
047000     PERFORM MB70PD-RETURN-TRANS-ID
047100                                 THRU MB70PD-RTI-EXIT.
047200/
047300 2400-UPDATE-FILE.
047400*
047500****************************************************************
047600*    WRITE THE NEW ORG FROM THE INITIALIZED RECORDS OR FROM    *
047700*    THE ORG THAT IS BEING COPIED.                             *
047800****************************************************************
047900*
048000     IF  MBCA-PTI-FUNCTION-IS-ADD
048100         IF  MO00-COPY-ORG-L IS GREATER THAN ZERO
048200             PERFORM 9100-COPY-ORG
048300                                 THRU 9199-CO-EXIT
048400         ELSE
048500             PERFORM 9200-ADD-ORG
048600                                 THRU 9299-AO-EXIT.
048700*
048800 2600-SETUP-COMMAREA.
048900*
049000****************************************************************
049100*    SET UP COMMAREA FIELDS AND TRANSFER TO THE NEXT PROGRAM   *
049200****************************************************************
049300*
049400     MOVE MBCA-EIBAID            TO SS08WS-EIBAID.
049500*
049600     IF  MBCA-PTI-FUNCTION-IS-ADD
049700         MOVE MBIOWS-MMOC-KEY-CODE
049800                                 TO MBCA-KEY-CODE
049900     ELSE
050000         MOVE MBIOWS-MMOC-DIRECT-KEY-CODE
050100                                 TO MBCA-KEY-CODE.
050200*
050300     PERFORM MB60PD-EDIT-PAGE-NBR
050400                                 THRU MB60PD-EPN-EXIT.
050500*
050600     IF  SS08WS-VALID-PF-KEY
050700     OR  SS08WS-EIBAID-VALID-PF-KEY
050800         SET MBCA-INITIAL-SCREEN-NBR
050900                                 TO TRUE.
051000*
051100 2690-TRANSFER-XCTL.
051200*
051300     MOVE 'PC05'                 TO MBCA-PROGRAM-LOCATION.
051400     PERFORM MB70PD-XCTL-TO-MBOXCTL
051500                                 THRU MB70PD-XTM-EXIT.
051600/
051700 9000-PERFORMED-ROUTINES-SECT SECTION.
051800*
051900 9100-COPY-ORG.
052000*
052100****************************************************************
052200*    READ THE COPY ORGANIZATION RECORD                         *
052300****************************************************************
052400*
052500     MOVE 'FC03'                 TO MBCA-PROGRAM-LOCATION.
052600     MOVE MO00-COPY-ORG          TO MBIOWS-MMOC-ORG.
052700     SET MBIORO-READ-RANDOM      TO TRUE.
052800     PERFORM MMOCAO-ACCESS       THRU MMOCAO-ACCESS-EXIT.
052900*
053000     MOVE MBCA-MERCHANT-ORG      TO MMOC-ORG.
053100*
053200     SET X-MMOC-CORR             TO 2.
053300*
053400     MOVE SPACES                 TO MMOC-LAST-MAINT-OPER
053500                                    MMOC-ACH-ORG-NAME
053600                                    MMOC-ACH-DR-PRENOTE-DESC
053700                                    MMOC-STATE-CODE (X-MMOC-CORR)
053800                                    MMOC-PHONE (X-MMOC-CORR)
053900                                    MMOC-POSTAL-CODE (X-MMOC-CORR)
054000                                    MMOC-FAX (X-MMOC-CORR)
054100                                    MMOC-ACH-CR-PRENOTE-DESC.
054200*
054300     SET X-MMOC-PRIMARY             TO 1.
054400*
054500     PERFORM
054600         VARYING X-MMOC-NA FROM 1 BY 1
054700         UNTIL X-MMOC-NA IS GREATER THAN 5
054800         MOVE SPACES             TO MMOC-NA-LINE
054900                                    (X-MMOC-PRIMARY X-MMOC-NA)
055000                                    MMOC-POSTAL-CODE
055100                                    (X-MMOC-PRIMARY)
055200                                    MMOC-PHONE
055300                                    (X-MMOC-PRIMARY)
055400                                    MMOC-FAX
055500                                    (X-MMOC-PRIMARY)
055600                                    MMOC-STATE-CODE
055700                                    (X-MMOC-PRIMARY)
055800     END-PERFORM.
055900*
056000     SET X-MMOC-PRIMARY             TO 2.
056100*
056200     PERFORM
056300         VARYING X-MMOC-NA FROM 1 BY 1
056400         UNTIL X-MMOC-NA IS GREATER THAN 5
056500         MOVE SPACES             TO MMOC-NA-LINE
056600                                    (X-MMOC-PRIMARY X-MMOC-NA)
056700     END-PERFORM.
056800*
056900     MOVE ZEROES                 TO MMOC-ONLINE-STATUS
057000                                    MMOC-REC-STATUS
057100                                    MMOC-LAST-MAINT-DATE
057200                                    MMOC-DATE-LAST-PROC
057300                                    MMOC-ACH-ABA-NBR
057400                                    MMOC-ACH-TAX-ID
057500                                    MMOC-ACH-RELEASE-DAYS
057600                                    MMOC-TODAYS-JULIAN
057700                                    MMOC-DATE-LAST-PROC.
057800*
057900     INITIALIZE                     MMOC-BILLING-INTERFACE.
058000*
058100****************************************************************
058200*    WRITE THE NEW ORGANIZATION RECORD                         *
058300****************************************************************
058400*
058500     MOVE 'FC04'                 TO MBCA-PROGRAM-LOCATION.
058600     SET MBIORO-WRITE            TO TRUE.
058700     PERFORM MMOCAO-ACCESS       THRU MMOCAO-ACCESS-EXIT.
058800*
058900 9199-CO-EXIT.
059000     EXIT.
059100*
059200 9200-ADD-ORG.
059300*
059400****************************************************************
059500*    GETMAIN FOR ORGANIZATION RECORD                           *
059600****************************************************************
059700*
059800     MOVE 'SC02'                 TO MBCA-PROGRAM-LOCATION.
059900     SET MBIORO-GETMAIN          TO TRUE.
060000     PERFORM MMOCAO-ACCESS       THRU MMOCAO-ACCESS-EXIT.
060100*
060200****************************************************************
060300*    INITIALIZE THE ORGANIZATION RECORDS                       *
060400****************************************************************
060500*
060600     PERFORM MMOCPX-INIT-ORG-RECORDS
060700                                 THRU MMOCPX-IOR-EXIT.
060800*
060900     MOVE MMOCIR-RECORD          TO MMOC-RECORD.
061000     MOVE MBCA-MERCHANT-ORG      TO MMOC-ORG.
061100     MOVE ZEROES                 TO MMOC-ONLINE-STATUS.
061200     SET  MMOC-OR-F1-DAILY (85)  TO TRUE.
061300     SET  MMOC-OR-F1-DAILY (86)  TO TRUE.
061400     SET  MMOC-OR-F1-DAILY (87)  TO TRUE.
061500     SET  MMOC-OR-F1-DAILY (88)  TO TRUE.
061600     SET  MMOC-OR-F1-DAILY (89)  TO TRUE.
061700     MOVE MBCA-START-DATE        TO MMOC-LAST-MAINT-DATE.
061800     MOVE MBCA-OPERATOR-ID       TO MMOC-LAST-MAINT-OPER.
061900*
062000****************************************************************
062100*    WRITE THE NEW INITIALIZED ORGANIZATION RECORD             *
062200****************************************************************
062300*
062400     MOVE 'FC05'                 TO MBCA-PROGRAM-LOCATION.
062500     SET MBIORO-WRITE            TO TRUE.
062600     PERFORM MMOCAO-ACCESS       THRU MMOCAO-ACCESS-EXIT.
062700*
062800     MOVE MMOCIR-RECORD          TO MMOC-RECORD.
062900     MOVE MBCA-MERCHANT-ORG      TO MMOC-ORG.
063000*
063100 9299-AO-EXIT.
063200     EXIT.
063300*
063400 9300-EDIT-SELECT.
063500*
063600     IF  MO00-SELECT-L (X-MO00-DIR-AREA) IS LESS THAN 1
063700         GO TO 9399-ES-EXIT.
063800*
063900     IF  MO00-SELECT-L (X-MO00-DIR-AREA) IS GREATER THAN ZERO
064000         IF  MO00-SELECT-VALID (X-MO00-DIR-AREA)
064100             IF  MO00-SELECT-SPACE (X-MO00-DIR-AREA)
064200                 MOVE 01         TO TTN0162I
064300                 MOVE +2         TO TTN0162L
064400                 MOVE DFHBMFSE   TO MO00-SELECT-A
064500                                    (X-MO00-DIR-AREA)
064600                 SET X-MO00-DIR-AREA
064700                                 TO +16
064800             ELSE
064900                 MOVE MO00-SELECT-SCREEN-NBR (X-MO00-DIR-AREA)
065000                                 TO TTN0162I
065100                 MOVE +2         TO TTN0162L
065200                 MOVE DFHBMFSE   TO MO00-SELECT-A
065300                                    (X-MO00-DIR-AREA)
065400                 SET X-MO00-DIR-AREA
065500                                 TO +16
065600         ELSE
065700             SET SS08WS-ERROR-SW-YES TO TRUE
065800             MOVE DFHBMASB       TO MO00-SELECT-LP-A
065900                                    (X-MO00-DIR-AREA)
066000                                    MO00-SELECT-RP-A
066100                                    (X-MO00-DIR-AREA)
066200             MOVE DFHBMUBF       TO MO00-SELECT-A
066300                                    (X-MO00-DIR-AREA)
066400             MOVE SS08WS-CURSOR  TO MO00-SELECT-L
066500                                    (X-MO00-DIR-AREA).
066600*
066700 9399-ES-EXIT.
066800     EXIT.
066900/         GREGORIAN TO JULIAN DATE ROUTINE
067000     COPY SS07PD.
067100/         JULIAN TO GREGORIAN DATE ROUTINE
067200     COPY SS08PD.
067300/         DATE AND TIME EDIT ROUTINES
067400     COPY SS26PD.
067500     COPY SS27PD.
067600/         LINE 24 PF KEYS ROUTINE
067700     COPY SS15PD.
067800/         ORG FILE INITIALIZE ROUTINES
067900     COPY MMOCPX.
068000/         ORG FILE RECORD ACCESS ROUTINES
068100     COPY MMOCAO.
068200/         ON-LINE MAP ROUTINES
068300     COPY MB60PD REPLACING 'MBMAPXX' BY 'MBMO00 '
068400                           MBMAPXXI BY MBMO00I
068500                           MBMAPXXO BY MBMO00O.
068600/         ON-LINE PROCEDURES
068700     COPY MB70PD.
068800/
068900     COPY SMFTPXO.
