000100 IDENTIFICATION DIVISION.
000200 PROGRAM-ID. MBOMO01.
000201*       RELEASE DATE=08/24/01.        REVISION LEVEL=08.06      *
000202*****************************************************************
000203*WARNING.  THIS COMPUTER PROGRAM IS PROTECTED BY COPYRIGHT LAW  *
000204*AND INTERNATIONAL TREATIES.  UNAUTHORIZED REPRODUCTION OR      *
000205*DISTRIBUTION OF THIS PROGRAM, OR ANY PORTION OF IT, MAY RESULT *
000206*IN SEVERE CIVIL AND CRIMINAL PENATLIES, AND WILL BE PROSECUTED *
000207*TO THE MAXIMUM EXTENT POSSIBLE UNDER THE LAW.                  *
000208*COPYRIGHT 1999 PAYSYS INTERNATIONAL, INC.  ALL RIGHTS RESERVED.*
000209*****************************************************************
000300*****************************************************************
000400*                                                               *
000500*   V - PLUS  M E R C H A N T   B A N K C A R D   S Y S T E M   *
000600*                                                               *
000700*      MBOMO01 - ON-LINE ORG RECORD ADD/MAINTENANCE/INQUIRY     *
000800*                SCREEN 01                                      *
000900*                                                               *
001000*              1. TRANSIDS                                      *
001100*                 A. MBAO                                       *
001200*                 B. MBMO                                       *
001300*                 C. MBQO                                       *
001400*              2. MAPS USED -                                   *
001500*                 A. MBMO01 (ORGANIZATION MAP 01)               *
001600*              3. FILES USED -                                  *
001700*                 A. MMOC   (ORG CONTROL FILE)                  *
001800*                 B. MML1   (LOG/JOURNAL FILE)                  *
001900*                                                               *
002000*****************************************************************
002100*
002200 ENVIRONMENT DIVISION.
002300 DATA DIVISION.
002400 WORKING-STORAGE SECTION.
002500 01  FILLER                  PIC  X(12)      VALUE '** WS-BEG **'.
002600*         I/O REQUEST BLOCK WORK AREAS
002700     COPY MBIOWS.
002800/         I/O REQUEST BLOCK
002900     COPY MBIORO.
003000/         LOG/JOURNAL WORK AREAS
003100     COPY MML1WS REPLACING ==:MML1:== BY ==MML1==.
003200/         DATE WORK AREAS
003300     COPY SS01WS.
003400/         ONLINE WORK AREAS
003500     COPY SS08WS.
003600/
003700     COPY SS00WS.
003800/
003900     COPY SMFTWS.
004000/
004100     COPY SMPTRL REPLACING ==:SMPT:== BY ==SMPT==.
004200/
004300     COPY MB61LK.
004400/
004500 01  WS-WORK-AREAS.
004600     03  WS-INDEX            PIC S9(04)      BINARY.
004700     03  WS-UPDATE-SW        PIC  X(01)      VALUE 'N'.
004800         88  WS-UPDATE-SW-NO                 VALUE 'N'.
004900         88  WS-UPDATE-SW-YES                VALUE 'Y'.
005000 01  WS-DATE-WORK.
005100     03  WS-DW-MM            PIC  9(02).
005200     03  WS-DW-DD            PIC  9(02).
005300 01  WS-BREAK-WW.
005400     03  WS-WORK-WK          PIC  X(01)      OCCURS 7 TIMES
005500                                             INDEXED BY X-WW.
005600 01  WS-WEEK-SWITCHES.
005700     03  WS-MISC-SW          PIC  X(01)      VALUE 'N'.
005800     03  WS-GOOD-WORK-WEEK   PIC  X(01)      VALUE 'N'.
005900         88  WS-VALID-WEEK                   VALUE 'Y'.
006000         88  WS-INVALID-WEEK                 VALUE 'N'.
006100 01  FILLER                  PIC  X(12)      VALUE '** WS-END **'.
006200/
006300 LINKAGE SECTION.
006400 01  DFHCOMMAREA.
006500     COPY MB60WS.
006600/         ORG SCREEN 01 MAP DSECT
006700     COPY MBMO01.
006800/         ORG SCREEN 01 MAP REDEFINITION
006900     COPY MBMO01R.
007000/         ORG CONTROL FILE RECORD LAYOUT
007100     COPY MMOCRL.
007200/         LOG/JOURNAL FILE RECORD LAYOUT
007300     COPY MML1RL REPLACING ==:MML1:== BY ==MML1==.
007400/
007500 PROCEDURE DIVISION.
007600 0000-HOUSEKEEPING SECTION.
007700 0100-INIT.
007800*
007900     MOVE 'PC01'                 TO MBCA-PROGRAM-LOCATION.
008000     PERFORM MB70PD-ON-LINE-HOUSEKEEPING
008100                                 THRU MB70PD-OLH-EXIT.
008200*
008300     IF  MBCA-RECEIVE-SCREEN
008400         GO TO 2000-RECEIVE-SCREEN.
008500/
008600 1000-SEND-SCREEN SECTION.
008700*
008800****************************************************************
008900*    THIS SECTION BUILDS AND SENDS THE 01 SCREEN.              *
009000****************************************************************
009100*
009200****************************************************************
009300*    GET CICS STORAGE NEEDED FOR THE MAP                       *
009400****************************************************************
009500*
009600     MOVE 'SC01'                 TO MBCA-PROGRAM-LOCATION.
009700     PERFORM MB60PD-GETMAIN-FOR-MAP
009800                                 THRU MB60PD-GFM-EXIT.
009900*
010000     MOVE MBCA-MERCHANT-ORG      TO MO01-ORG.
010100     MOVE 01                     TO MBCA-SCREEN-NBR.
010200*
010300****************************************************************
010400*    INITIALIZE THE STANDARD MAP LINES                         *
010500****************************************************************
010600*
010700     PERFORM MB60PD-INIT-STD-MAP-LINES
010800                                 THRU MB60PD-ISML-EXIT.
010900*
011000****************************************************************
011100*    READ THE ORGANIZATION FILE                                *
011200****************************************************************
011300*
011400     MOVE 'FC01'                 TO MBCA-PROGRAM-LOCATION.
011500     MOVE MBCA-MERCHANT-ORG      TO MBIOWS-MMOC-ORG.
011600     SET MBIORO-READ-RANDOM      TO TRUE.
011700     PERFORM MMOCAO-ACCESS       THRU MMOCAO-ACCESS-EXIT.
011800/
011900 1100-BUILD-SCREEN.
012000*
012100****************************************************************
012200*    BUILD THE MAP FROM THE ORGANIZATION                       *
012300****************************************************************
012400*
012500     MOVE MMOC-NA-LINE (1 1)     TO MO01-ORG-NAME.
012600*
012700     SET X-MMOC-PRIMARY          TO 1.
012800*
012900     PERFORM
013000         VARYING X-MO01-NA FROM 1 BY 1
013100         UNTIL X-MO01-NA IS GREATER THAN 5
013200         SET X-MMOC-NA           TO X-MO01-NA
013300         MOVE MMOC-NA-LINE (X-MMOC-PRIMARY X-MMOC-NA)
013400                                 TO MO01-NA-LINE (X-MO01-NA)
013500     END-PERFORM.
013600*
013700     MOVE MMOC-STATE-CODE (X-MMOC-PRIMARY)
013800                                 TO MO01-STATE.
013900     MOVE MMOC-PHONE (X-MMOC-PRIMARY)
014000                                 TO MO01-PHONE.
014100     MOVE MMOC-POSTAL-CODE (X-MMOC-PRIMARY)
014200                                 TO MO01-POSTAL-CODE.
014300     MOVE MMOC-FAX (X-MMOC-PRIMARY)
014400                                 TO MO01-FAX.
014500*
014600     IF  MMOC-LAST-MAINT-DATE    IS GREATER THAN ZEROES
014700     OR  MBCA-PTI-FUNCTION-IS-INQUIRY
014800         MOVE MMOC-LAST-MAINT-DATE
014900                                 TO SS01WS-JULIAN
015000         PERFORM SS26PD-NUMERICALLY-EDIT-DATE
015100                                 THRU SS26PD-NED-EXIT
015200         MOVE SS01WS-XX-XX-YYYY  TO MO01-LAST-MAINT-DATE
015300         MOVE MMOC-LAST-MAINT-OPER
015400                                 TO MO01-LAST-MAINT-OPER.
015500*
015600/
015700****************************************************************
015800*    IF INQUIRY, DARKEN PARENS AND ASKIP FIELDS                *
015900****************************************************************
016000*
016100     MOVE SS08WS-CURSOR          TO MO01-NA-LINE-L (1).
016200*
016300     IF  MBCA-PTI-FUNCTION-IS-INQUIRY
016400         MOVE SS08WS-CURSOR      TO MO01-ALT-TRANID-L
016500         PERFORM
016600             VARYING X-MO01-NA FROM 1 BY 1
016700             UNTIL X-MO01-NA IS GREATER THAN 5
016800             MOVE DFHBMASB       TO MO01-NA-LINE-A (X-MO01-NA)
016900         END-PERFORM
017000         MOVE DFHBMASB           TO MO01-STATE-A
017100                                    MO01-PHONE-A
017200                                    MO01-POSTAL-CODE-A
017300                                    MO01-FAX-A
017400         PERFORM
017500             VARYING X-MO01-NA FROM 1 BY 1
017600             UNTIL X-MO01-NA IS GREATER THAN 5
017700             MOVE DFHBMDAS       TO MO01-NA-LINE-LP-A (X-MO01-NA)
017800                                    MO01-NA-LINE-RP-A (X-MO01-NA)
017900         END-PERFORM
018000         MOVE DFHBMDAS           TO MO01-STATE-LP-A
018100                                    MO01-STATE-RP-A
018200                                    MO01-PHONE-LP-A
018300                                    MO01-PHONE-RP-A
018400                                    MO01-POSTAL-CODE-LP-A
018500                                    MO01-POSTAL-CODE-RP-A
018600                                    MO01-FAX-LP-A
018700                                    MO01-FAX-RP-A.
018800*
018900     IF  MBCA-PTI-FUNCTION-IS-ADD
019000         MOVE DFHBMDAS           TO MO01-LAST-MAINT-LIT-A
019100                                    MO01-LAST-MAINT-DATE-A
019200                                    MO01-LAST-MAINT-OPER-LIT-A
019300                                    MO01-LAST-MAINT-OPER-A.
019400*
019500****************************************************************
019600*    SEND THE MAP                                              *
019700****************************************************************
019800*
019900     MOVE 'BM01'                 TO MBCA-PROGRAM-LOCATION.
020000     PERFORM MB60PD-SEND-MAP-WITH-ERASE
020100                                 THRU MB60PD-SMWE-EXIT.
020200*
020300****************************************************************
020400*    RETURN TO CICS                                            *
020500****************************************************************
020600*
020700     MOVE 'PC02'                 TO MBCA-PROGRAM-LOCATION.
020800     PERFORM MB70PD-RETURN-TRANS-ID
020900                                 THRU MB70PD-RTI-EXIT.
021000/
021100 2000-RECEIVE-SCREEN SECTION.
021200*
021300****************************************************************
021400*    THIS SECTION RECEIVES THE FIRST SCREEN                    *
021500****************************************************************
021600*
021700     MOVE 'BM02'                 TO MBCA-PROGRAM-LOCATION.
021800     PERFORM MB60PD-RECEIVE-MAP  THRU MB60PD-RM-EXIT.
021900*
022000****************************************************************
022100*    CHECK FOR ANOTHER TRANSACTION ID ENTERED BY THE USER      *
022200****************************************************************
022300*
022400     MOVE 'PC03'                 TO MBCA-PROGRAM-LOCATION.
022500     PERFORM MB60PD-NEW-TRANS-ROUTINE
022600                                 THRU MB60PD-NTR-EXIT.
022700*
022800****************************************************************
022900*    BYPASS EDITS ON INQUIRY                                   *
023000****************************************************************
023100*
023200     IF  MBCA-PTI-FUNCTION-IS-INQUIRY
023300         GO TO 2600-SETUP-COMMAREA.
023400*
023500****************************************************************
023600*    READ THE ORGANIZATION FILE                                *
023700****************************************************************
023800*
023900     MOVE 'FC02'                 TO MBCA-PROGRAM-LOCATION.
024000     MOVE MBCA-MERCHANT-ORG      TO MBIOWS-MMOC-ORG.
024100     SET MBIORO-READ-RANDOM      TO TRUE.
024200     PERFORM MMOCAO-ACCESS       THRU MMOCAO-ACCESS-EXIT.
024300*
024400     SET X-MMOC-PRIMARY          TO 1.
024500*
024600****************************************************************
024700*    EDIT FIELDS                                               *
024800****************************************************************
024900*
025000*            ***** NAME ADDRESS LINES *****                    *
025100*
025200     PERFORM
025300         VARYING X-MO01-NA FROM 1 BY 1
025400         UNTIL X-MO01-NA IS GREATER THAN 5
025500         SET X-MMOC-NA           TO X-MO01-NA
025600         EVALUATE TRUE
025700         WHEN  (MO01-NA-LINE-L (X-MO01-NA) IS LESS THAN 1
025800          AND   MBCA-PTI-FUNCTION-IS-ADD
025900          AND   X-MO01-NA IS EQUAL TO 1
026000          AND   X-MMOC-PRIMARY IS EQUAL TO 1)
026100             MOVE DFHBMUBF       TO MO01-NA-LINE-A (X-MO01-NA)
026200             MOVE DFHBMASB       TO MO01-NA-LINE-LP-A (X-MO01-NA)
026300                                    MO01-NA-LINE-RP-A (X-MO01-NA)
026400             MOVE SS08WS-CURSOR  TO MO01-NA-LINE-L (X-MO01-NA)
026500             SET SS08WS-ERROR-SW-YES TO TRUE
026600         WHEN  MO01-NA-LINE-L (X-MO01-NA) IS LESS THAN 1
026700             MOVE DFHBMASK       TO MO01-NA-LINE-A (X-MO01-NA)
026800             MOVE DFHBMDAS       TO MO01-NA-LINE-LP-A (X-MO01-NA)
026900                                    MO01-NA-LINE-RP-A (X-MO01-NA)
027000             MOVE MMOC-NA-LINE (X-MMOC-PRIMARY X-MMOC-NA)
027100                                 TO MO01-NA-LINE (X-MO01-NA)
027200         WHEN OTHER
027300             MOVE DFHBMASF       TO MO01-NA-LINE-A (X-MO01-NA)
027400             MOVE DFHBMDAS       TO MO01-NA-LINE-LP-A (X-MO01-NA)
027500                                    MO01-NA-LINE-RP-A (X-MO01-NA)
027600             SET WS-UPDATE-SW-YES
027700                                 TO TRUE
027800         END-EVALUATE
027900     END-PERFORM.
028000*
028100*            ***** STATE/PROVINCE *****                        *
028200*
028300     IF  MO01-STATE-L IS LESS THAN 1
028400         MOVE DFHBMASK           TO MO01-STATE-A
028500         MOVE DFHBMDAS           TO MO01-STATE-LP-A
028600                                    MO01-STATE-RP-A
028700         MOVE MMOC-STATE-CODE (X-MMOC-PRIMARY)
028800                                 TO MO01-STATE
028900     ELSE
029000         MOVE DFHBMASF           TO MO01-STATE-A
029100         MOVE DFHBMDAS           TO MO01-STATE-LP-A
029200                                    MO01-STATE-RP-A
029300         SET WS-UPDATE-SW-YES    TO TRUE.
029400*
029500*            ***** PHONE NUMBER *****                          *
029600*
029700     IF  MO01-PHONE-L IS LESS THAN 1
029800         MOVE DFHBMASK           TO MO01-PHONE-A
029900         MOVE DFHBMDAS           TO MO01-PHONE-LP-A
030000                                    MO01-PHONE-RP-A
030100         MOVE MMOC-PHONE (X-MMOC-PRIMARY)
030200                                 TO MO01-PHONE
030300     ELSE
030400         MOVE DFHBMASF           TO MO01-PHONE-A
030500         MOVE DFHBMDAS           TO MO01-PHONE-LP-A
030600                                    MO01-PHONE-RP-A
030700         SET WS-UPDATE-SW-YES    TO TRUE.
030800*
030900*            ***** FAX PHONE NUMBER *****                      *
031000*
031100     IF  MO01-FAX-L IS LESS THAN 1
031200         MOVE DFHBMASK           TO MO01-FAX-A
031300         MOVE DFHBMDAS           TO MO01-FAX-LP-A
031400                                    MO01-FAX-RP-A
031500         MOVE MMOC-FAX (X-MMOC-PRIMARY)
031600                                 TO MO01-FAX
031700     ELSE
031800         MOVE DFHBMASF           TO MO01-FAX-A
031900         MOVE DFHBMDAS           TO MO01-FAX-LP-A
032000                                    MO01-FAX-RP-A
032100         SET WS-UPDATE-SW-YES    TO TRUE.
032200*
032300*            ***** POSTAL CODE *****                           *
032400*
032500     IF  MBCA-PTI-FUNCTION-IS-ADD
032600     AND MO01-POSTAL-CODE-L IS LESS THAN 1
032700         MOVE DFHBMUBF           TO MO01-POSTAL-CODE-A
032800         MOVE DFHBMASB           TO MO01-POSTAL-CODE-LP-A
032900                                    MO01-POSTAL-CODE-RP-A
033000         MOVE SS08WS-CURSOR      TO MO01-POSTAL-CODE-L
033100         SET SS08WS-ERROR-SW-YES TO TRUE
033200     ELSE
033300         IF  MO01-POSTAL-CODE-L IS LESS THAN 1
033400             MOVE DFHBMASK       TO MO01-POSTAL-CODE-A
033500             MOVE DFHBMDAS       TO MO01-POSTAL-CODE-LP-A
033600                                    MO01-POSTAL-CODE-RP-A
033700             MOVE MMOC-POSTAL-CODE (X-MMOC-PRIMARY)
033800                                 TO MO01-POSTAL-CODE
033900         ELSE
034000             IF  MO01-POSTAL-CODE IS EQUAL TO SPACES
034100                 MOVE DFHBMUBF   TO MO01-POSTAL-CODE-A
034200                 MOVE DFHBMASB   TO MO01-POSTAL-CODE-LP-A
034300                                    MO01-POSTAL-CODE-RP-A
034400                 MOVE SS08WS-CURSOR TO MO01-POSTAL-CODE-L
034500                 SET SS08WS-ERROR-SW-YES
034600                                 TO TRUE
034700             ELSE
034800                 MOVE DFHBMASF   TO MO01-POSTAL-CODE-A
034900                 MOVE DFHBMDAS   TO MO01-POSTAL-CODE-LP-A
035000                                    MO01-POSTAL-CODE-RP-A
035100                 SET WS-UPDATE-SW-YES
035200                                 TO TRUE.
035300*
035400 2300-CONTINUE.
035500*
035600     IF  SS08WS-ERROR-SW-NO
035700         GO TO 2400-UPDATE-FILE.
035800*
035900****************************************************************
036000*    SEND THE MAP                                              *
036100****************************************************************
036200*
036300     PERFORM MB60PD-INIT-STD-MAP-LINES
036400                                 THRU MB60PD-ISML-EXIT.
036500     MOVE 'BM03'                 TO MBCA-PROGRAM-LOCATION.
036600     PERFORM MB60PD-SEND-MAP-DATA-ONLY
036700                                 THRU MB60PD-SMDO-EXIT.
036800*
036900****************************************************************
037000*    RETURN TO CICS                                            *
037100****************************************************************
037200*
037300     MOVE 'PC04'                 TO MBCA-PROGRAM-LOCATION.
037400     MOVE 01                     TO MBCA-SCREEN-NBR.
037500     PERFORM MB70PD-RETURN-TRANS-ID
037600                                 THRU MB70PD-RTI-EXIT.
037700/
037800 2400-UPDATE-FILE.
037900*
038000     IF  WS-UPDATE-SW-NO
038100         GO TO 2600-SETUP-COMMAREA.
038200*
038300****************************************************************
038400*    GETMAIN FOR LOG/JOURNAL RECORD                            *
038500****************************************************************
038600*
038700     MOVE 'SC02'                 TO MBCA-PROGRAM-LOCATION.
038800     SET MBIORO-GETMAIN          TO TRUE.
038900     PERFORM MML1AO-ACCESS       THRU MML1AO-ACCESS-EXIT.
039000*
039100****************************************************************
039200*    READ THE ORGANIZATION FILE RECORD FOR UPDATE              *
039300****************************************************************
039400*
039500     MOVE 'FC03'                 TO MBCA-PROGRAM-LOCATION.
039600     MOVE MBCA-MERCHANT-ORG      TO MBIOWS-MMOC-ORG.
039700     SET MBIORO-READ-RANDOM-UPDATE
039800                                 TO TRUE.
039900     PERFORM MMOCAO-ACCESS       THRU MMOCAO-ACCESS-EXIT.
040000*
040100*            ***** NAME ADDRESS *****                          *
040200*
040300     PERFORM
040400         VARYING X-MMOC-NA FROM 1 BY 1
040500         UNTIL X-MMOC-NA IS GREATER THAN 5
040600         SET X-MO01-NA           TO X-MMOC-NA
040700         SET WS-INDEX            TO X-MMOC-NA
040800         IF MO01-NA-LINE-L (X-MO01-NA) IS GREATER THAN ZEROES
040900             SET MML1-FIELD-OCCURRENCE
041000                                 TO X-MMOC-PRIMARY
041100             MOVE WS-INDEX       TO MML1-FIELD-OCCURRENCE-2
041200             MOVE 0101           TO MML1-FIELD-CODE
041300             MOVE MML1WS-VL-40   TO MML1-VARIABLE-LENGTH
041400             MOVE MMOC-NA-LINE (X-MMOC-PRIMARY X-MMOC-NA)
041500                                 TO MML1-VL40-B-DATA-X
041600             MOVE MO01-NA-LINE (X-MO01-NA)
041700                                 TO MMOC-NA-LINE
041800                                    (X-MMOC-PRIMARY X-MMOC-NA)
041900             MOVE MMOC-NA-LINE (X-MMOC-PRIMARY X-MMOC-NA)
042000                                 TO MML1-VL40-A-DATA-X
042100             PERFORM 9050-CREATE-MAINT-RECORD
042200                                     THRU 9099-CMR-EXIT
042300         END-IF
042400     END-PERFORM.
042500*
042600*            ***** STATE *****                                 *
042700*
042800     IF  MO01-STATE-L IS GREATER THAN ZEROES
042900         SET MML1-FIELD-OCCURRENCE
043000                                 TO X-MMOC-PRIMARY
043100         MOVE ZEROS              TO MML1-FIELD-OCCURRENCE-2
043200         MOVE 0102               TO MML1-FIELD-CODE
043300         MOVE MML1WS-VL-03       TO MML1-VARIABLE-LENGTH
043400         MOVE MMOC-STATE-CODE (X-MMOC-PRIMARY)
043500                                 TO MML1-VL03-B-DATA-X
043600         MOVE MO01-STATE         TO MMOC-STATE-CODE
043700                                    (X-MMOC-PRIMARY)
043800         MOVE MMOC-STATE-CODE (X-MMOC-PRIMARY)
043900                                 TO MML1-VL03-A-DATA-X
044000         PERFORM 9050-CREATE-MAINT-RECORD
044100                                 THRU 9099-CMR-EXIT.
044200*
044300*            ***** PHONE NUMBER *****                          *
044400*
044500     IF  MO01-PHONE-L IS GREATER THAN ZEROES
044600         SET MML1-FIELD-OCCURRENCE
044700                                 TO X-MMOC-PRIMARY
044800         MOVE ZEROS              TO MML1-FIELD-OCCURRENCE-2
044900         MOVE 0103               TO MML1-FIELD-CODE
045000         MOVE MML1WS-VL-20       TO MML1-VARIABLE-LENGTH
045100         MOVE MMOC-PHONE (X-MMOC-PRIMARY)
045200                                 TO MML1-VL20-B-DATA-X
045300         MOVE MO01-PHONE         TO MMOC-PHONE (X-MMOC-PRIMARY)
045400         MOVE MMOC-PHONE (X-MMOC-PRIMARY)
045500                                 TO MML1-VL20-A-DATA-X
045600         PERFORM 9050-CREATE-MAINT-RECORD
045700                                 THRU 9099-CMR-EXIT.
045800*
045900*            ***** POSTAL CODE *****                           *
046000*
046100     IF  MO01-POSTAL-CODE-L IS GREATER THAN ZEROES
046200         SET MML1-FIELD-OCCURRENCE
046300                                 TO X-MMOC-PRIMARY
046400         MOVE ZEROS              TO MML1-FIELD-OCCURRENCE-2
046500         MOVE 0104               TO MML1-FIELD-CODE
046600         MOVE MML1WS-VL-10       TO MML1-VARIABLE-LENGTH
046700         MOVE MMOC-POSTAL-CODE (X-MMOC-PRIMARY)
046800                                 TO MML1-VL10-B-DATA-X
046900         MOVE MO01-POSTAL-CODE   TO MMOC-POSTAL-CODE
047000                                    (X-MMOC-PRIMARY)
047100         MOVE MMOC-POSTAL-CODE (X-MMOC-PRIMARY)
047200                                 TO MML1-VL10-A-DATA-X
047300         PERFORM 9050-CREATE-MAINT-RECORD
047400                                 THRU 9099-CMR-EXIT.
047500*
047600*            ***** FAX PHONE NUMBER *****                      *
047700*
047800     IF  MO01-FAX-L IS GREATER THAN ZEROES
047900         SET MML1-FIELD-OCCURRENCE
048000                                 TO X-MMOC-PRIMARY
048100         MOVE ZEROS              TO MML1-FIELD-OCCURRENCE-2
048200         MOVE 0105               TO MML1-FIELD-CODE
048300         MOVE MML1WS-VL-20       TO MML1-VARIABLE-LENGTH
048400         MOVE MMOC-FAX (X-MMOC-PRIMARY)
048500                                 TO MML1-VL20-B-DATA-X
048600         MOVE MO01-FAX           TO MMOC-FAX (X-MMOC-PRIMARY)
048700         MOVE MMOC-FAX (X-MMOC-PRIMARY)
048800                                 TO MML1-VL20-A-DATA-X
048900         PERFORM 9050-CREATE-MAINT-RECORD
049000                                 THRU 9099-CMR-EXIT.
049100*
049200     IF  MBCA-PTI-FUNCTION-IS-ADD
049300         MOVE MBCA-SCREEN-NBR    TO MMOC-ONLINE-STATUS.
049400*
049500*            ***** LAST MAINT DATE AND OPERATOR ID *****       *
049600*
049700     MOVE ZEROES                 TO MML1-FIELD-OCCURRENCE.
049800     MOVE 0199                   TO MML1-FIELD-CODE.
049900     MOVE MML1WS-VL-07           TO MML1-VARIABLE-LENGTH.
050000     MOVE MMOC-LAST-MAINT-DATE
050100                                 TO MML1-VL07-B-DATA-9.
050200     MOVE MBCA-START-DATE        TO MMOC-LAST-MAINT-DATE.
050300     MOVE MMOC-LAST-MAINT-DATE
050400                                 TO MML1-VL07-A-DATA-9.
050500     PERFORM 9050-CREATE-MAINT-RECORD
050600                                 THRU 9099-CMR-EXIT.
050700     MOVE 0198                   TO MML1-FIELD-CODE.
050800     MOVE MML1WS-VL-03           TO MML1-VARIABLE-LENGTH.
050900     MOVE MMOC-LAST-MAINT-OPER
051000                                 TO MML1-VL03-B-DATA-X.
051100     MOVE MBCA-OPERATOR-ID       TO MMOC-LAST-MAINT-OPER.
051200     MOVE MMOC-LAST-MAINT-OPER
051300                                 TO MML1-VL03-A-DATA-X.
051400     PERFORM 9050-CREATE-MAINT-RECORD
051500                                 THRU 9099-CMR-EXIT.
051600*
051700****************************************************************
051800*    UPDATE THE ORGANIZATION FILE                              *
051900****************************************************************
052000*
052100     MOVE 'FC04'                 TO MBCA-PROGRAM-LOCATION.
052200     SET MBIORO-REWRITE          TO TRUE.
052300     PERFORM MMOCAO-ACCESS       THRU MMOCAO-ACCESS-EXIT.
052400*
052500 2600-SETUP-COMMAREA.
052600*
052700****************************************************************
052800*    SET UP COMMAREA FIELDS AND TRANSFER TO THE NEXT PROGRAM   *
052900****************************************************************
053000*
053100     MOVE MBCA-EIBAID            TO SS08WS-EIBAID.
053200*
053300     PERFORM MB60PD-EDIT-PAGE-NBR
053400                                 THRU MB60PD-EPN-EXIT.
053500*
053600     IF  SS08WS-VALID-PF-KEY
053700     OR  SS08WS-EIBAID-VALID-PF-KEY
053800         SET MBCA-INITIAL-SCREEN-NBR
053900                                 TO TRUE.
054000*
054100     MOVE 'PC05'                 TO MBCA-PROGRAM-LOCATION.
054200     PERFORM MB70PD-XCTL-TO-MBOXCTL
054300                                 THRU MB70PD-XTM-EXIT.
054400/
054500 9000-PERFORMED-ROUTINES-SECT SECTION.
054600*
054700 9050-CREATE-MAINT-RECORD.
054800*
054900*****************************************************************
055000*    THIS ROUTINE WILL CREATE THE COMMON DATA FOR ALL OF THE    *
055100*    LOG/JOURNAL TRANSACTIONS                                   *
055200*****************************************************************
055300*
055400     IF  MBCA-PTI-FUNCTION-IS-ADD
055500         GO TO 9099-CMR-EXIT.
055600*
055700     MOVE 'OC'                   TO MML1-FILE-CODE.
055800     MOVE MBCA-MERCHANT-ORG      TO MML1-MMOC-ORG.
055900     MOVE MBCA-SIGNON-NAME       TO MML1-SIGNON-NAME.
056000     MOVE MBCA-TERMINAL-ID       TO MML1-TERMINAL-ID.
056100     MOVE ZEROES                 TO MML1-SOURCE-CODE.
056200*
056300*****************************************************************
056400*    WRITE THE LOG/JOURNAL FILE RECORD                          *
056500*****************************************************************
056600*
056700     MOVE 'FC05'                 TO MBCA-PROGRAM-LOCATION.
056800     SET MBIORO-WRITE            TO TRUE.
056900     PERFORM MML1AO-ACCESS       THRU MML1AO-ACCESS-EXIT.
057000     MOVE SPACES                 TO MML1-VARIABLE-AREA.
057100*
057200 9099-CMR-EXIT.
057300     EXIT.
057400/         DATE VALIDATION ROUTINE
057500     COPY SS05PD.
057600/         GREGORIAN TO JULIAN DATE ROUTINE
057700     COPY SS07PD.
057800/         JULIAN TO GREGORIAN DATE ROUTINE.
057900     COPY SS08PD.
058000/         DATE AND TIME EDIT ROUTINES.
058100     COPY SS26PD.
058200     COPY SS27PD.
058300/         LINE 24 PF KEYS ROUTINE
058400     COPY SS15PD.
058500/         ORGANIZATION RECORD ACCESS ROUTINES
058600     COPY MMOCAO.
058700/         LOG/JOURNAL ACCESS ROUTINES
058800     COPY MML1AO.
058900/         ON-LINE MAP ROUTINES
059000     COPY MB60PD REPLACING 'MBMAPXX' BY 'MBMO01 '
059100                           MBMAPXXI BY MBMO01I
059200                           MBMAPXXO BY MBMO01O.
059300/         ON-LINE PROCEDURES
059400     COPY MB70PD.
059500/
059600     COPY SMFTPXO.
