000100 IDENTIFICATION DIVISION.
000200 PROGRAM-ID. MBOMO02.
000201*       RELEASE DATE=08/24/01.        REVISION LEVEL=08.06      *
000202*****************************************************************
000203*WARNING.  THIS COMPUTER PROGRAM IS PROTECTED BY COPYRIGHT LAW  *
000204*AND INTERNATIONAL TREATIES.  UNAUTHORIZED REPRODUCTION OR      *
000205*DISTRIBUTION OF THIS PROGRAM, OR ANY PORTION OF IT, MAY RESULT *
000206*IN SEVERE CIVIL AND CRIMINAL PENATLIES, AND WILL BE PROSECUTED *
000207*TO THE MAXIMUM EXTENT POSSIBLE UNDER THE LAW.                  *
000208*COPYRIGHT 1999 PAYSYS INTERNATIONAL, INC.  ALL RIGHTS RESERVED.*
000209*****************************************************************
000300*****************************************************************
000400*                                                               *
000500*   V - PLUS  M E R C H A N T   B A N K C A R D   S Y S T E M   *
000600*                                                               *
000700*      MBOMO02 - ON-LINE ORG RECORD ADD/MAINTENANCE/INQUIRY     *
000800*                SCREEN 02                                      *
000900*                                                               *
001000*              1. TRANSIDS                                      *
001100*                 A. MBAO                                       *
001200*                 B. MBMO                                       *
001300*                 C. MBQO                                       *
001400*              2. MAPS USED -                                   *
001500*                 A. MBMO02 (ORGANIZATION MAP 02)               *
001600*              3. FILES USED -                                  *
001700*                 A. MMOC   (ORG CONTROL FILE)                  *
001800*                 B. MML1   (LOG/JOURNAL FILE)                  *
001900*                                                               *
002000*****************************************************************
002100*
002200 ENVIRONMENT DIVISION.
002300 DATA DIVISION.
002400 WORKING-STORAGE SECTION.
002500 01  FILLER                  PIC  X(12)      VALUE '** WS-BEG **'.
002600*         I/O REQUEST BLOCK WORK AREAS
002700     COPY MBIOWS.
002800/         I/O REQUEST BLOCK
002900     COPY MBIORO.
003000/         LOG/JOURNAL WORK AREAS
003100     COPY MML1WS REPLACING ==:MML1:== BY ==MML1==.
003200/         DATE WORK AREAS
003300     COPY SS01WS.
003400/         ONLINE WORK AREAS
003500     COPY SS08WS.
003600/
003700     COPY SS00WS.
003800/
003900     COPY SMFTWS.
004000/
004100     COPY SMPTRL REPLACING ==:SMPT:== BY ==SMPT==.
004200/
004300     COPY MB61LK.
004400/
004500 01  WS-WORK-AREAS.
004600     03  WS-INDEX            PIC S9(04)      BINARY.
004700     03  WS-UPDATE-SW        PIC  X(01)      VALUE 'N'.
004800         88  WS-UPDATE-SW-NO                 VALUE 'N'.
004900         88  WS-UPDATE-SW-YES                VALUE 'Y'.
005000 01  WS-DATE-WORK.
005100     03  WS-DW-MM            PIC  9(02).
005200     03  WS-DW-DD            PIC  9(02).
005300 01  WS-BREAK-WW.
005400     03  WS-WORK-WK          PIC  X(01)      OCCURS 7 TIMES
005500                                             INDEXED BY X-WW.
005600 01  WS-WEEK-SWITCHES.
005700     03  WS-MISC-SW          PIC  X(01)      VALUE 'N'.
005800     03  WS-GOOD-WORK-WEEK   PIC  X(01)      VALUE 'N'.
005900         88  WS-VALID-WEEK                   VALUE 'Y'.
006000         88  WS-INVALID-WEEK                 VALUE 'N'.
006100 01  FILLER                  PIC  X(12)      VALUE '** WS-END **'.
006200/
006300 LINKAGE SECTION.
006400 01  DFHCOMMAREA.
006500     COPY MB60WS.
006600/         ORG SCREEN 02 MAP DSECT
006700     COPY MBMO02.
006800/         ORG SCREEN 02 MAP REDEFINITION
006900     COPY MBMO02R.
007000/         ORG CONTROL FILE RECORD LAYOUT
007100     COPY MMOCRL.
007200/         LOG/JOURNAL FILE RECORD LAYOUT
007300     COPY MML1RL REPLACING ==:MML1:== BY ==MML1==.
007400/
007500 PROCEDURE DIVISION.
007600 0000-HOUSEKEEPING SECTION.
007700 0100-INIT.
007800*
007900     MOVE 'PC01'                 TO MBCA-PROGRAM-LOCATION.
008000     PERFORM MB70PD-ON-LINE-HOUSEKEEPING
008100                                 THRU MB70PD-OLH-EXIT.
008200*
008300     IF  MBCA-RECEIVE-SCREEN
008400         GO TO 2000-RECEIVE-SCREEN.
008500/
008600 1000-SEND-SCREEN SECTION.
008700*
008800****************************************************************
008900*    THIS SECTION BUILDS AND SENDS THE 02 SCREEN.              *
009000****************************************************************
009100*
009200****************************************************************
009300*    GET CICS STORAGE NEEDED FOR THE MAP                       *
009400****************************************************************
009500*
009600     MOVE 'SC01'                 TO MBCA-PROGRAM-LOCATION.
009700     PERFORM MB60PD-GETMAIN-FOR-MAP
009800                                 THRU MB60PD-GFM-EXIT.
009900*
010000     MOVE MBCA-MERCHANT-ORG      TO MO02-ORG.
010100     MOVE 02                     TO MBCA-SCREEN-NBR.
010200*
010300****************************************************************
010400*    INITIALIZE THE STANDARD MAP LINES                         *
010500****************************************************************
010600*
010700     PERFORM MB60PD-INIT-STD-MAP-LINES
010800                                 THRU MB60PD-ISML-EXIT.
010900*
011000****************************************************************
011100*    READ THE ORGANIZATION FILE                                *
011200****************************************************************
011300*
011400     MOVE 'FC01'                 TO MBCA-PROGRAM-LOCATION.
011500     MOVE MBCA-MERCHANT-ORG      TO MBIOWS-MMOC-ORG.
011600     SET MBIORO-READ-RANDOM      TO TRUE.
011700     PERFORM MMOCAO-ACCESS       THRU MMOCAO-ACCESS-EXIT.
011800/
011900 1100-BUILD-SCREEN.
012000*
012100****************************************************************
012200*    BUILD THE MAP FROM THE ORGANIZATION                       *
012300****************************************************************
012400*
012500     MOVE MMOC-NA-LINE (1 1)     TO MO02-ORG-NAME.
012600*
012700     SET X-MMOC-PRIMARY          TO 2.
012800*
012900     PERFORM
013000         VARYING X-MO02-NA FROM 1 BY 1
013100         UNTIL X-MO02-NA IS GREATER THAN 5
013200         SET X-MMOC-NA           TO X-MO02-NA
013300         MOVE MMOC-NA-LINE (X-MMOC-PRIMARY X-MMOC-NA)
013400                                 TO MO02-NA-LINE (X-MO02-NA)
013500     END-PERFORM.
013600*
013700     MOVE MMOC-STATE-CODE (X-MMOC-PRIMARY)
013800                                 TO MO02-STATE.
013900     MOVE MMOC-PHONE (X-MMOC-PRIMARY)
014000                                 TO MO02-PHONE.
014100     MOVE MMOC-POSTAL-CODE (X-MMOC-PRIMARY)
014200                                 TO MO02-POSTAL-CODE.
014300     MOVE MMOC-FAX (X-MMOC-PRIMARY)
014400                                 TO MO02-FAX.
014500*
014600/
014700****************************************************************
014800*    IF INQUIRY, DARKEN PARENS AND ASKIP FIELDS                *
014900****************************************************************
015000*
015100     MOVE SS08WS-CURSOR          TO MO02-NA-LINE-L (1).
015200*
015300     IF  MBCA-PTI-FUNCTION-IS-INQUIRY
015400         MOVE SS08WS-CURSOR      TO MO02-ALT-TRANID-L
015500         PERFORM
015600             VARYING X-MO02-NA FROM 1 BY 1
015700             UNTIL X-MO02-NA IS GREATER THAN 5
015800             MOVE DFHBMASB       TO MO02-NA-LINE-A (X-MO02-NA)
015900         END-PERFORM
016000         MOVE DFHBMASB           TO MO02-STATE-A
016100                                    MO02-PHONE-A
016200                                    MO02-POSTAL-CODE-A
016300                                    MO02-FAX-A
016400         PERFORM
016500             VARYING X-MO02-NA FROM 1 BY 1
016600             UNTIL X-MO02-NA IS GREATER THAN 5
016700             MOVE DFHBMDAS       TO MO02-NA-LINE-LP-A (X-MO02-NA)
016800                                    MO02-NA-LINE-RP-A (X-MO02-NA)
016900         END-PERFORM
017000         MOVE DFHBMDAS           TO MO02-STATE-LP-A
017100                                    MO02-STATE-RP-A
017200                                    MO02-PHONE-LP-A
017300                                    MO02-PHONE-RP-A
017400                                    MO02-POSTAL-CODE-LP-A
017500                                    MO02-POSTAL-CODE-RP-A
017600                                    MO02-FAX-LP-A
017700                                    MO02-FAX-RP-A.
017800*
017900****************************************************************
018000*    SEND THE MAP                                              *
018100****************************************************************
018200*
018300     MOVE 'BM01'                 TO MBCA-PROGRAM-LOCATION.
018400     PERFORM MB60PD-SEND-MAP-WITH-ERASE
018500                                 THRU MB60PD-SMWE-EXIT.
018600*
018700****************************************************************
018800*    RETURN TO CICS                                            *
018900****************************************************************
019000*
019100     MOVE 'PC02'                 TO MBCA-PROGRAM-LOCATION.
019200     PERFORM MB70PD-RETURN-TRANS-ID
019300                                 THRU MB70PD-RTI-EXIT.
019400/
019500 2000-RECEIVE-SCREEN SECTION.
019600*
019700****************************************************************
019800*    THIS SECTION RECEIVES THE FIRST SCREEN                    *
019900****************************************************************
020000*
020100     MOVE 'BM02'                 TO MBCA-PROGRAM-LOCATION.
020200     PERFORM MB60PD-RECEIVE-MAP  THRU MB60PD-RM-EXIT.
020300*
020400****************************************************************
020500*    CHECK FOR ANOTHER TRANSACTION ID ENTERED BY THE USER      *
020600****************************************************************
020700*
020800     MOVE 'PC03'                 TO MBCA-PROGRAM-LOCATION.
020900     PERFORM MB60PD-NEW-TRANS-ROUTINE
021000                                 THRU MB60PD-NTR-EXIT.
021100*
021200****************************************************************
021300*    BYPASS EDITS ON INQUIRY                                   *
021400****************************************************************
021500*
021600     IF  MBCA-PTI-FUNCTION-IS-INQUIRY
021700         GO TO 2600-SETUP-COMMAREA.
021800*
021900****************************************************************
022000*    READ THE ORGANIZATION FILE                                *
022100****************************************************************
022200*
022300     MOVE 'FC02'                 TO MBCA-PROGRAM-LOCATION.
022400     MOVE MBCA-MERCHANT-ORG      TO MBIOWS-MMOC-ORG.
022500     SET MBIORO-READ-RANDOM      TO TRUE.
022600     PERFORM MMOCAO-ACCESS       THRU MMOCAO-ACCESS-EXIT.
022700*
022800     SET X-MMOC-PRIMARY          TO 2.
022900*
023000****************************************************************
023100*    EDIT FIELDS                                               *
023200****************************************************************
023300*
023400*            ***** NAME ADDRESS LINES *****                    *
023500*
023600     PERFORM
023700         VARYING X-MO02-NA FROM 1 BY 1
023800         UNTIL X-MO02-NA IS GREATER THAN 5
023900         SET X-MMOC-NA           TO X-MO02-NA
024000         EVALUATE TRUE
024100         WHEN  (MO02-NA-LINE-L (X-MO02-NA) IS LESS THAN 1
024200          AND   MBCA-PTI-FUNCTION-IS-ADD
024300          AND   X-MO02-NA IS EQUAL TO 1
024400          AND   X-MMOC-PRIMARY IS EQUAL TO 1)
024500             MOVE DFHBMUBF       TO MO02-NA-LINE-A (X-MO02-NA)
024600             MOVE DFHBMASB       TO MO02-NA-LINE-LP-A (X-MO02-NA)
024700                                    MO02-NA-LINE-RP-A (X-MO02-NA)
024800             MOVE SS08WS-CURSOR  TO MO02-NA-LINE-L (X-MO02-NA)
024900             SET SS08WS-ERROR-SW-YES TO TRUE
025000         WHEN  MO02-NA-LINE-L (X-MO02-NA) IS LESS THAN 1
025100             MOVE DFHBMASK       TO MO02-NA-LINE-A (X-MO02-NA)
025200             MOVE DFHBMDAS       TO MO02-NA-LINE-LP-A (X-MO02-NA)
025300                                    MO02-NA-LINE-RP-A (X-MO02-NA)
025400             MOVE MMOC-NA-LINE (X-MMOC-PRIMARY X-MMOC-NA)
025500                                 TO MO02-NA-LINE (X-MO02-NA)
025600         WHEN OTHER
025700             MOVE DFHBMASF       TO MO02-NA-LINE-A (X-MO02-NA)
025800             MOVE DFHBMDAS       TO MO02-NA-LINE-LP-A (X-MO02-NA)
025900                                    MO02-NA-LINE-RP-A (X-MO02-NA)
026000             SET WS-UPDATE-SW-YES
026100                                 TO TRUE
026200         END-EVALUATE
026300     END-PERFORM.
026400*
026500*            ***** STATE/PROVINCE *****                        *
026600*
026700     IF  MO02-STATE-L IS LESS THAN 1
026800         MOVE DFHBMASK           TO MO02-STATE-A
026900         MOVE DFHBMDAS           TO MO02-STATE-LP-A
027000                                    MO02-STATE-RP-A
027100         MOVE MMOC-STATE-CODE (X-MMOC-PRIMARY)
027200                                 TO MO02-STATE
027300     ELSE
027400         MOVE DFHBMASF           TO MO02-STATE-A
027500         MOVE DFHBMDAS           TO MO02-STATE-LP-A
027600                                    MO02-STATE-RP-A
027700         SET WS-UPDATE-SW-YES    TO TRUE.
027800*
027900*            ***** PHONE NUMBER *****                          *
028000*
028100     IF  MO02-PHONE-L IS LESS THAN 1
028200         MOVE DFHBMASK           TO MO02-PHONE-A
028300         MOVE DFHBMDAS           TO MO02-PHONE-LP-A
028400                                    MO02-PHONE-RP-A
028500         MOVE MMOC-PHONE (X-MMOC-PRIMARY)
028600                                 TO MO02-PHONE
028700     ELSE
028800         MOVE DFHBMASF           TO MO02-PHONE-A
028900         MOVE DFHBMDAS           TO MO02-PHONE-LP-A
029000                                    MO02-PHONE-RP-A
029100         SET WS-UPDATE-SW-YES    TO TRUE.
029200*
029300*            ***** FAX PHONE NUMBER *****                      *
029400*
029500     IF  MO02-FAX-L IS LESS THAN 1
029600         MOVE DFHBMASK           TO MO02-FAX-A
029700         MOVE DFHBMDAS           TO MO02-FAX-LP-A
029800                                    MO02-FAX-RP-A
029900         MOVE MMOC-FAX (X-MMOC-PRIMARY)
030000                                 TO MO02-FAX
030100     ELSE
030200         MOVE DFHBMASF           TO MO02-FAX-A
030300         MOVE DFHBMDAS           TO MO02-FAX-LP-A
030400                                    MO02-FAX-RP-A
030500         SET WS-UPDATE-SW-YES    TO TRUE.
030600*
030700*            ***** POSTAL CODE *****                           *
030800*
030900     IF  MBCA-PTI-FUNCTION-IS-ADD
031000     AND MO02-POSTAL-CODE-L IS LESS THAN 1
031100         MOVE DFHBMUBF           TO MO02-POSTAL-CODE-A
031200         MOVE DFHBMASB           TO MO02-POSTAL-CODE-LP-A
031300                                    MO02-POSTAL-CODE-RP-A
031400         MOVE SS08WS-CURSOR      TO MO02-POSTAL-CODE-L
031500         SET SS08WS-ERROR-SW-YES TO TRUE
031600     ELSE
031700         IF  MO02-POSTAL-CODE-L IS LESS THAN 1
031800             MOVE DFHBMASK       TO MO02-POSTAL-CODE-A
031900             MOVE DFHBMDAS       TO MO02-POSTAL-CODE-LP-A
032000                                    MO02-POSTAL-CODE-RP-A
032100             MOVE MMOC-POSTAL-CODE (X-MMOC-PRIMARY)
032200                                 TO MO02-POSTAL-CODE
032300         ELSE
032400             IF  MO02-POSTAL-CODE IS EQUAL TO SPACES
032500                 MOVE DFHBMUBF   TO MO02-POSTAL-CODE-A
032600                 MOVE DFHBMASB   TO MO02-POSTAL-CODE-LP-A
032700                                    MO02-POSTAL-CODE-RP-A
032800                 MOVE SS08WS-CURSOR TO MO02-POSTAL-CODE-L
032900                 SET SS08WS-ERROR-SW-YES
033000                                 TO TRUE
033100             ELSE
033200                 MOVE DFHBMASF   TO MO02-POSTAL-CODE-A
033300                 MOVE DFHBMDAS   TO MO02-POSTAL-CODE-LP-A
033400                                    MO02-POSTAL-CODE-RP-A
033500                 SET WS-UPDATE-SW-YES
033600                                 TO TRUE.
033700*
033800 2300-CONTINUE.
033900*
034000     IF  SS08WS-ERROR-SW-NO
034100         GO TO 2400-UPDATE-FILE.
034200*
034300****************************************************************
034400*    SEND THE MAP                                              *
034500****************************************************************
034600*
034700     PERFORM MB60PD-INIT-STD-MAP-LINES
034800                                 THRU MB60PD-ISML-EXIT.
034900     MOVE 'BM03'                 TO MBCA-PROGRAM-LOCATION.
035000     PERFORM MB60PD-SEND-MAP-DATA-ONLY
035100                                 THRU MB60PD-SMDO-EXIT.
035200*
035300****************************************************************
035400*    RETURN TO CICS                                            *
035500****************************************************************
035600*
035700     MOVE 'PC04'                 TO MBCA-PROGRAM-LOCATION.
035800     MOVE 02                     TO MBCA-SCREEN-NBR.
035900     PERFORM MB70PD-RETURN-TRANS-ID
036000                                 THRU MB70PD-RTI-EXIT.
036100/
036200 2400-UPDATE-FILE.
036300*
036400     IF  WS-UPDATE-SW-NO
036500         GO TO 2600-SETUP-COMMAREA.
036600*
036700****************************************************************
036800*    GETMAIN FOR LOG/JOURNAL RECORD                            *
036900****************************************************************
037000*
037100     MOVE 'SC02'                 TO MBCA-PROGRAM-LOCATION.
037200     SET MBIORO-GETMAIN          TO TRUE.
037300     PERFORM MML1AO-ACCESS       THRU MML1AO-ACCESS-EXIT.
037400*
037500****************************************************************
037600*    READ THE ORGANIZATION FILE RECORD FOR UPDATE              *
037700****************************************************************
037800*
037900     MOVE 'FC03'                 TO MBCA-PROGRAM-LOCATION.
038000     MOVE MBCA-MERCHANT-ORG      TO MBIOWS-MMOC-ORG.
038100     SET MBIORO-READ-RANDOM-UPDATE
038200                                 TO TRUE.
038300     PERFORM MMOCAO-ACCESS       THRU MMOCAO-ACCESS-EXIT.
038400*
038500*            ***** NAME ADDRESS *****                          *
038600*
038700     PERFORM
038800         VARYING X-MMOC-NA FROM 1 BY 1
038900         UNTIL X-MMOC-NA IS GREATER THAN 5
039000         SET X-MO02-NA           TO X-MMOC-NA
039100         SET WS-INDEX            TO X-MMOC-NA
039200         IF MO02-NA-LINE-L (X-MO02-NA) IS GREATER THAN ZEROES
039300             SET MML1-FIELD-OCCURRENCE
039400                                 TO X-MMOC-PRIMARY
039500             MOVE WS-INDEX       TO MML1-FIELD-OCCURRENCE-2
039600             MOVE 0101           TO MML1-FIELD-CODE
039700             MOVE MML1WS-VL-40   TO MML1-VARIABLE-LENGTH
039800             MOVE MMOC-NA-LINE (X-MMOC-PRIMARY X-MMOC-NA)
039900                                 TO MML1-VL40-B-DATA-X
040000             MOVE MO02-NA-LINE (X-MO02-NA)
040100                                 TO MMOC-NA-LINE
040200                                    (X-MMOC-PRIMARY X-MMOC-NA)
040300             MOVE MMOC-NA-LINE (X-MMOC-PRIMARY X-MMOC-NA)
040400                                 TO MML1-VL40-A-DATA-X
040500             PERFORM 9050-CREATE-MAINT-RECORD
040600                                     THRU 9099-CMR-EXIT
040700         END-IF
040800     END-PERFORM.
040900*
041000*            ***** STATE *****                                 *
041100*
041200     IF  MO02-STATE-L IS GREATER THAN ZEROES
041300         SET MML1-FIELD-OCCURRENCE
041400                                 TO X-MMOC-PRIMARY
041500         MOVE ZEROS              TO MML1-FIELD-OCCURRENCE-2
041600         MOVE 0102               TO MML1-FIELD-CODE
041700         MOVE MML1WS-VL-03       TO MML1-VARIABLE-LENGTH
041800         MOVE MMOC-STATE-CODE (X-MMOC-PRIMARY)
041900                                 TO MML1-VL03-B-DATA-X
042000         MOVE MO02-STATE         TO MMOC-STATE-CODE
042100                                    (X-MMOC-PRIMARY)
042200         MOVE MMOC-STATE-CODE (X-MMOC-PRIMARY)
042300                                 TO MML1-VL03-A-DATA-X
042400         PERFORM 9050-CREATE-MAINT-RECORD
042500                                 THRU 9099-CMR-EXIT.
042600*
042700*            ***** PHONE NUMBER *****                          *
042800*
042900     IF  MO02-PHONE-L IS GREATER THAN ZEROES
043000         SET MML1-FIELD-OCCURRENCE
043100                                 TO X-MMOC-PRIMARY
043200         MOVE ZEROS              TO MML1-FIELD-OCCURRENCE-2
043300         MOVE 0103               TO MML1-FIELD-CODE
043400         MOVE MML1WS-VL-20       TO MML1-VARIABLE-LENGTH
043500         MOVE MMOC-PHONE (X-MMOC-PRIMARY)
043600                                 TO MML1-VL20-B-DATA-X
043700         MOVE MO02-PHONE         TO MMOC-PHONE (X-MMOC-PRIMARY)
043800         MOVE MMOC-PHONE (X-MMOC-PRIMARY)
043900                                 TO MML1-VL20-A-DATA-X
044000         PERFORM 9050-CREATE-MAINT-RECORD
044100                                 THRU 9099-CMR-EXIT.
044200*
044300*            ***** POSTAL CODE *****                           *
044400*
044500     IF  MO02-POSTAL-CODE-L IS GREATER THAN ZEROES
044600         SET MML1-FIELD-OCCURRENCE
044700                                 TO X-MMOC-PRIMARY
044800         MOVE ZEROS              TO MML1-FIELD-OCCURRENCE-2
044900         MOVE 0104               TO MML1-FIELD-CODE
045000         MOVE MML1WS-VL-10       TO MML1-VARIABLE-LENGTH
045100         MOVE MMOC-POSTAL-CODE (X-MMOC-PRIMARY)
045200                                 TO MML1-VL10-B-DATA-X
045300         MOVE MO02-POSTAL-CODE   TO MMOC-POSTAL-CODE
045400                                    (X-MMOC-PRIMARY)
045500         MOVE MMOC-POSTAL-CODE (X-MMOC-PRIMARY)
045600                                 TO MML1-VL10-A-DATA-X
045700         PERFORM 9050-CREATE-MAINT-RECORD
045800                                 THRU 9099-CMR-EXIT.
045900*
046000*            ***** FAX PHONE NUMBER *****                      *
046100*
046200     IF  MO02-FAX-L IS GREATER THAN ZEROES
046300         SET MML1-FIELD-OCCURRENCE
046400                                 TO X-MMOC-PRIMARY
046500         MOVE ZEROS              TO MML1-FIELD-OCCURRENCE-2
046600         MOVE 0105               TO MML1-FIELD-CODE
046700         MOVE MML1WS-VL-20       TO MML1-VARIABLE-LENGTH
046800         MOVE MMOC-FAX (X-MMOC-PRIMARY)
046900                                 TO MML1-VL20-B-DATA-X
047000         MOVE MO02-FAX           TO MMOC-FAX (X-MMOC-PRIMARY)
047100         MOVE MMOC-FAX (X-MMOC-PRIMARY)
047200                                 TO MML1-VL20-A-DATA-X
047300         PERFORM 9050-CREATE-MAINT-RECORD
047400                                 THRU 9099-CMR-EXIT.
047500*
047600     IF  MBCA-PTI-FUNCTION-IS-ADD
047700         MOVE MBCA-SCREEN-NBR    TO MMOC-ONLINE-STATUS.
047800*
047900*            ***** LAST MAINT DATE AND OPERATOR ID *****       *
048000*
048100     MOVE ZEROES                 TO MML1-FIELD-OCCURRENCE.
048200     MOVE 0199                   TO MML1-FIELD-CODE.
048300     MOVE MML1WS-VL-07           TO MML1-VARIABLE-LENGTH.
048400     MOVE MMOC-LAST-MAINT-DATE
048500                                 TO MML1-VL07-B-DATA-9.
048600     MOVE MBCA-START-DATE        TO MMOC-LAST-MAINT-DATE.
048700     MOVE MMOC-LAST-MAINT-DATE   TO MML1-VL07-A-DATA-9.
048800     PERFORM 9050-CREATE-MAINT-RECORD
048900                                 THRU 9099-CMR-EXIT.
049000     MOVE 0198                   TO MML1-FIELD-CODE.
049100     MOVE MML1WS-VL-03           TO MML1-VARIABLE-LENGTH.
049200     MOVE MMOC-LAST-MAINT-OPER   TO MML1-VL03-B-DATA-X.
049300     MOVE MBCA-OPERATOR-ID       TO MMOC-LAST-MAINT-OPER.
049400     MOVE MMOC-LAST-MAINT-OPER   TO MML1-VL03-A-DATA-X.
049500     PERFORM 9050-CREATE-MAINT-RECORD
049600                                 THRU 9099-CMR-EXIT.
049700*
049800****************************************************************
049900*    UPDATE THE ORGANIZATION FILE                              *
050000****************************************************************
050100*
050200     MOVE 'FC04'                 TO MBCA-PROGRAM-LOCATION.
050300     SET MBIORO-REWRITE          TO TRUE.
050400     PERFORM MMOCAO-ACCESS       THRU MMOCAO-ACCESS-EXIT.
050500*
050600 2600-SETUP-COMMAREA.
050700*
050800****************************************************************
050900*    SET UP COMMAREA FIELDS AND TRANSFER TO THE NEXT PROGRAM   *
051000****************************************************************
051100*
051200     MOVE MBCA-EIBAID            TO SS08WS-EIBAID.
051300*
051400     PERFORM MB60PD-EDIT-PAGE-NBR
051500                                 THRU MB60PD-EPN-EXIT.
051600*
051700     IF  SS08WS-VALID-PF-KEY
051800     OR  SS08WS-EIBAID-VALID-PF-KEY
051900         SET MBCA-INITIAL-SCREEN-NBR
052000                                 TO TRUE.
052100*
052200     MOVE 'PC05'                 TO MBCA-PROGRAM-LOCATION.
052300     PERFORM MB70PD-XCTL-TO-MBOXCTL
052400                                 THRU MB70PD-XTM-EXIT.
052500/
052600 9000-PERFORMED-ROUTINES-SECT SECTION.
052700*
052800 9050-CREATE-MAINT-RECORD.
052900*
053000*****************************************************************
053100*    THIS ROUTINE WILL CREATE THE COMMON DATA FOR ALL OF THE    *
053200*    LOG/JOURNAL TRANSACTIONS                                   *
053300*****************************************************************
053400*
053500     IF  MBCA-PTI-FUNCTION-IS-ADD
053600         GO TO 9099-CMR-EXIT.
053700*
053800     MOVE 'OC'                   TO MML1-FILE-CODE.
053900     MOVE MBCA-MERCHANT-ORG      TO MML1-MMOC-ORG.
054000     MOVE MBCA-SIGNON-NAME       TO MML1-SIGNON-NAME.
054100     MOVE MBCA-TERMINAL-ID       TO MML1-TERMINAL-ID.
054200     MOVE ZEROES                 TO MML1-SOURCE-CODE.
054300*
054400*****************************************************************
054500*    WRITE THE LOG/JOURNAL FILE RECORD                          *
054600*****************************************************************
054700*
054800     MOVE 'FC05'                 TO MBCA-PROGRAM-LOCATION.
054900     SET MBIORO-WRITE            TO TRUE.
055000     PERFORM MML1AO-ACCESS       THRU MML1AO-ACCESS-EXIT.
055100     MOVE SPACES                 TO MML1-VARIABLE-AREA.
055200*
055300 9099-CMR-EXIT.
055400     EXIT.
055500/         DATE VALIDATION ROUTINE
055600     COPY SS05PD.
055700/         GREGORIAN TO JULIAN DATE ROUTINE
055800     COPY SS07PD.
055900/         JULIAN TO GREGORIAN DATE ROUTINE.
056000     COPY SS08PD.
056100/         DATE AND TIME EDIT ROUTINES.
056200     COPY SS26PD.
056300     COPY SS27PD.
056400/         LINE 24 PF KEYS ROUTINE
056500     COPY SS15PD.
056600/         ORGANIZATION RECORD ACCESS ROUTINES
056700     COPY MMOCAO.
056800/         LOG/JOURNAL ACCESS ROUTINES
056900     COPY MML1AO.
057000/         ON-LINE MAP ROUTINES
057100     COPY MB60PD REPLACING 'MBMAPXX' BY 'MBMO02 '
057200                           MBMAPXXI BY MBMO02I
057300                           MBMAPXXO BY MBMO02O.
057400/         ON-LINE PROCEDURES
057500     COPY MB70PD.
057600/
057700     COPY SMFTPXO.
