000100 IDENTIFICATION DIVISION.
000200 PROGRAM-ID. MBOMO03.
000201*       RELEASE DATE=08/24/01.        REVISION LEVEL=08.06      *
000202*****************************************************************
000203*WARNING.  THIS COMPUTER PROGRAM IS PROTECTED BY COPYRIGHT LAW  *
000204*AND INTERNATIONAL TREATIES.  UNAUTHORIZED REPRODUCTION OR      *
000205*DISTRIBUTION OF THIS PROGRAM, OR ANY PORTION OF IT, MAY RESULT *
000206*IN SEVERE CIVIL AND CRIMINAL PENATLIES, AND WILL BE PROSECUTED *
000207*TO THE MAXIMUM EXTENT POSSIBLE UNDER THE LAW.                  *
000208*COPYRIGHT 1999 PAYSYS INTERNATIONAL, INC.  ALL RIGHTS RESERVED.*
000209*****************************************************************
000300*****************************************************************
000400*                                                               *
000500*   V - PLUS  M E R C H A N T   B A N K C A R D   S Y S T E M   *
000600*                                                               *
000700*      MBOMO03 - ON-LINE ORG RECORD ADD/MAINTENANCE/INQUIRY     *
000800*                SCREEN 03                                      *
000900*                                                               *
001000*              1. TRANSIDS                                      *
001100*                 A. MBAO                                       *
001200*                 B. MBMO                                       *
001300*                 C. MBQO                                       *
001400*              2. MAPS USED -                                   *
001500*                 A. MBMO03 (ORGANIZATION MAP 03)               *
001600*              3. FILES USED -                                  *
001700*                 A. MMOC   (ORG CONTROL FILE)                  *
001800*                 B. MMSC   (SYSTEM CONTROL FILE)               *
001900*                 C. MML1   (LOG/JOURNAL FILE)                  *
002000*                                                               *
002100*****************************************************************
002200*
002300 ENVIRONMENT DIVISION.
002400 DATA DIVISION.
002500 WORKING-STORAGE SECTION.
002600 01  FILLER                  PIC  X(12)      VALUE '** WS-BEG **'.
002700*         I/O REQUEST BLOCK WORK AREAS
002800     COPY MBIOWS.
002900/         I/O REQUEST BLOCK
003000     COPY MBIORO.
003100/         LOG/JOURNAL WORK AREAS
003200     COPY MML1WS REPLACING ==:MML1:== BY ==MML1==.
003300/         DATE WORK AREAS
003400     COPY SS01WS.
003500/         CHECK DIGIT WORK FIELDS
003600     COPY SS05WS.
003700/         ONLINE WORK AREAS
003800     COPY SS08WS.
003900/
004000     COPY SS00WS.
004100/
004200     COPY SMFTWS.
004300/
004400     COPY SMPTRL REPLACING ==:SMPT:== BY ==SMPT==.
004500/
004600     COPY MB61LK.
004700/
004800 01  WS-WORK-AREAS.
004900     03  WS-INDEX            PIC S9(04)      BINARY.
005000     03  WS-UPDATE-SW        PIC  X(01)      VALUE 'N'.
005100         88  WS-UPDATE-SW-NO                 VALUE 'N'.
005200         88  WS-UPDATE-SW-YES                VALUE 'Y'.
005300     03  WS-ACCR-THRU-DATE   PIC S9(07)      VALUE ZEROS.
005400     03  WS-NEXT-PROC-DATE   PIC S9(07)      VALUE ZEROS.
005500 01  WS-DATE-WORK.
005600     03  WS-DW-MM            PIC  9(02).
005700     03  WS-DW-DD            PIC  9(02).
005800 01  WS-BREAK-WW.
005900     03  WS-WORK-WK          PIC  X(01)      OCCURS 7 TIMES
006000                                             INDEXED BY X-WW.
006100 01  WS-WEEK-SWITCHES.
006200     03  WS-MISC-SW          PIC  X(01)      VALUE 'N'.
006300         88  WS-MISC-SW-NO                   VALUE 'N'.
006400         88  WS-MISC-SW-YES                  VALUE 'Y'.
006500     03  WS-GOOD-WORK-WEEK   PIC  X(01)      VALUE 'Y'.
006600         88  WS-VALID-WEEK                   VALUE 'Y'.
006700         88  WS-INVALID-WEEK                 VALUE 'N'.
006800     03  WS-GOOD-WORK-WEEK   PIC  X(01)      VALUE 'N'.
006900         88  WS-WORK-WEEK-OPEN               VALUE 'Y'.
007000         88  WS-WORK-WEEK-CLOSED             VALUE 'N'.
007100 01  FILLER                  PIC  X(12)      VALUE '** WS-END **'.
007200/
007300 LINKAGE SECTION.
007400 01  DFHCOMMAREA.
007500     COPY MB60WS.
007600/         ORG SCREEN 03 MAP DSECT
007700     COPY MBMO03.
007800/         ORG SCREEN 03 MAP REDEFINITION
007900     COPY MBMO03R.
008000/         ORG CONTROL FILE RECORD LAYOUT
008100     COPY MMOCRL.
008200/         SYSTEM CONTROL FILE RECORD LAYOUT
008300     COPY MMSCRL.
008400/         LOG/JOURNAL FILE RECORD LAYOUT
008500     COPY MML1RL REPLACING ==:MML1:== BY ==MML1==.
008600/
008700 PROCEDURE DIVISION.
008800 0000-HOUSEKEEPING SECTION.
008900 0100-INIT.
009000*
009100     MOVE 'PC01'                 TO MBCA-PROGRAM-LOCATION.
009200     PERFORM MB70PD-ON-LINE-HOUSEKEEPING
009300                                 THRU MB70PD-OLH-EXIT.
009400*
009500     IF  MBCA-RECEIVE-SCREEN
009600         GO TO 2000-RECEIVE-SCREEN.
009700/
009800 1000-SEND-SCREEN SECTION.
009900*
010000****************************************************************
010100*    THIS SECTION BUILDS AND SENDS THE 03 SCREEN.              *
010200****************************************************************
010300*
010400****************************************************************
010500*    GET CICS STORAGE NEEDED FOR THE MAP                       *
010600****************************************************************
010700*
010800     MOVE 'SC01'                 TO MBCA-PROGRAM-LOCATION.
010900     PERFORM MB60PD-GETMAIN-FOR-MAP
011000                                 THRU MB60PD-GFM-EXIT.
011100*
011200     MOVE MBCA-MERCHANT-ORG      TO MO03-ORG.
011300     MOVE 03                     TO MBCA-SCREEN-NBR.
011400*
011500****************************************************************
011600*    INITIALIZE THE STANDARD MAP LINES                         *
011700****************************************************************
011800*
011900     PERFORM MB60PD-INIT-STD-MAP-LINES
012000                                 THRU MB60PD-ISML-EXIT.
012100*
012200****************************************************************
012300*    READ THE SYSTEM RECORD                                    *
012400****************************************************************
012500*
012600     MOVE 'FC01'                 TO MBCA-PROGRAM-LOCATION.
012700     MOVE ZEROES                 TO MBIOWS-MMSC-KEY.
012800     SET MBIORO-READ-RANDOM      TO TRUE.
012900     PERFORM MMSCAO-ACCESS       THRU MMSCAO-ACCESS-EXIT.
013000*
013100****************************************************************
013200*    READ THE ORGANIZATION FILE RECORD                         *
013300****************************************************************
013400*
013500     MOVE 'FC02'                 TO MBCA-PROGRAM-LOCATION.
013600     MOVE MBCA-MERCHANT-ORG      TO MBIOWS-MMOC-ORG.
013700     SET MBIORO-READ-RANDOM      TO TRUE.
013800     PERFORM MMOCAO-ACCESS       THRU MMOCAO-ACCESS-EXIT.
013900/
014000 1100-BUILD-SCREEN.
014100*
014200****************************************************************
014300*    BUILD THE MAP FROM THE ORGANIZATION RECORD                *
014400****************************************************************
014500*
014600     MOVE MMOC-NA-LINE (1 1)     TO MO03-ORG-NAME
014700                                    MBCA-MBMO-ORG-NAME.
014800     MOVE MMOC-ACH-ORG-NAME      TO MO03-ACH-ORG-NAME.
014900     MOVE MMOC-ACH-ABA-NBR       TO MO03-ROUTE-TRANSIT.
015000     MOVE MMOC-ACH-TAX-ID        TO MO03-TAX-ID.
015100     MOVE MMOC-ACH-DR-PRENOTE-DESC
015200                                 TO MO03-DR-PRENOTE-DESC.
015300     MOVE MMOC-ACH-CR-PRENOTE-DESC
015400                                 TO MO03-CR-PRENOTE-DESC.
015500     MOVE MMOC-ACH-RELEASE-DAYS  TO MO03-ACH-REL-DAYS.
015600*
015700     MOVE MMOC-WORK-WEEK-R (1)   TO MO03-WORK-WEEK (1).
015800     MOVE MMOC-WORK-WEEK-R (2)   TO MO03-WORK-WEEK (2).
015900     MOVE MMOC-WORK-WEEK-R (3)   TO MO03-WORK-WEEK (3).
016000     MOVE MMOC-WORK-WEEK-R (4)   TO MO03-WORK-WEEK (4).
016100     MOVE MMOC-WORK-WEEK-R (5)   TO MO03-WORK-WEEK (5).
016200     MOVE MMOC-WORK-WEEK-R (6)   TO MO03-WORK-WEEK (6).
016300     MOVE MMOC-WORK-WEEK-R (7)   TO MO03-WORK-WEEK (7).
016400*
016500     SET X-MO03-HOLIDAY          TO 1.
016600*
016700 1200-BUILD-SCREEN-LOOP.
016800*
016900     SET X-MMOC-HOL              TO X-MO03-HOLIDAY.
017000*
017100     IF  MMOC-HOLIDAYS    (X-MMOC-HOL)    IS NOT EQUAL TO ZEROES
017200     OR  MBCA-PTI-FUNCTION-IS-INQUIRY
017300         MOVE MMOC-HOLIDAYS    (X-MMOC-HOL)
017400                                 TO SS01WS-JULIAN
017500         PERFORM SS08PD-JUL-TO-GREG
017600                                 THRU SS08PD-JTG-EXIT
017700         MOVE SS01WS-DATE        TO MO03-HOLIDAY (X-MO03-HOLIDAY).
017800*
017900     IF  X-MO03-HOLIDAY IS LESS THAN 25
018000         SET X-MO03-HOLIDAY      UP BY 1
018100         GO TO 1200-BUILD-SCREEN-LOOP.
018200*
018300     IF  MBCA-PTI-FUNCTION-IS-ADD
018400         MOVE MMSC-DATE-NEXT-PROC
018500                                 TO MMOC-DATE-NEXT-PROC
018600         MOVE MMSC-ACCR-THRU-DATE
018700                                 TO MMOC-ACCR-THRU-DATE.
018800*
018900     MOVE MMOC-TODAYS-JULIAN     TO SS01WS-JULIAN.
019000     PERFORM SS08PD-JUL-TO-GREG  THRU SS08PD-JTG-EXIT.
019100     MOVE SS01WS-DATE            TO MO03-DATE-LAST-PROC.
019200*
019300     IF  MMOC-ACCR-THRU-DATE    IS GREATER THAN ZEROES
019400     OR  MBCA-PTI-FUNCTION-IS-INQUIRY
019500         MOVE MMOC-ACCR-THRU-DATE
019600                                 TO SS01WS-JULIAN
019700         PERFORM SS08PD-JUL-TO-GREG
019800                                 THRU SS08PD-JTG-EXIT
019900         MOVE SS01WS-DATE        TO MO03-DATE-ACCRUED-THRU.
020000*
020100     IF  MMOC-DATE-NEXT-PROC    IS NOT EQUAL TO ZEROES
020200     OR  MBCA-PTI-FUNCTION-IS-INQUIRY
020300         MOVE MMOC-DATE-NEXT-PROC
020400                                 TO SS01WS-JULIAN
020500         PERFORM SS08PD-JUL-TO-GREG
020600                                 THRU SS08PD-JTG-EXIT
020700         MOVE SS01WS-DATE        TO MO03-DATE-NEXT-PROC.
020800*
020900     IF  MMSC-DATE-LAST-PROC    IS GREATER THAN ZEROES
021000     AND MMOC-DATE-LAST-PROC    IS GREATER THAN ZEROES
021100         MOVE DFHBMASK           TO MO03-DATE-ACCRUED-THRU-A
021200                                    MO03-DATE-NEXT-PROC-A
021300         MOVE DFHBMDAS           TO MO03-DATE-ACCRUED-THRU-LP-A
021400                                    MO03-DATE-ACCRUED-THRU-RP-A
021500                                    MO03-DATE-NEXT-PROC-LP-A
021600                                    MO03-DATE-NEXT-PROC-RP-A.
021700*
021800     IF  MBCA-PTI-FUNCTION-IS-ADD
021900         MOVE DFHBMNBF           TO MO03-DATE-ACCRUED-THRU-A
022000                                    MO03-DATE-NEXT-PROC-A
022100         MOVE DFHBMASB           TO MO03-DATE-ACCRUED-THRU-LP-A
022200                                    MO03-DATE-ACCRUED-THRU-RP-A
022300                                    MO03-DATE-NEXT-PROC-LP-A
022400                                    MO03-DATE-NEXT-PROC-RP-A.
022500*
022600/
022700****************************************************************
022800*    IF INQUIRY, DARKEN PARENS AND ASKIP FIELDS                *
022900****************************************************************
023000*
023100     MOVE SS08WS-CURSOR          TO MO03-WORK-WEEK-L (1).
023200*
023300     IF  MBCA-PTI-FUNCTION-IS-INQUIRY
023400         MOVE SS08WS-CURSOR      TO MO03-ALT-TRANID-L
023500         MOVE DFHBMASB           TO MO03-ACH-ORG-NAME-A
023600                                    MO03-ROUTE-TRANSIT-A
023700                                    MO03-TAX-ID-A
023800                                    MO03-DR-PRENOTE-DESC-A
023900                                    MO03-CR-PRENOTE-DESC-A
024000                                    MO03-ACH-REL-DAYS-A
024100                                    MO03-WORK-WEEK-A (1)
024200                                    MO03-WORK-WEEK-A (2)
024300                                    MO03-WORK-WEEK-A (3)
024400                                    MO03-WORK-WEEK-A (4)
024500                                    MO03-WORK-WEEK-A (5)
024600                                    MO03-WORK-WEEK-A (6)
024700                                    MO03-WORK-WEEK-A (7)
024800                                    MO03-DATE-LAST-PROC-A
024900                                    MO03-DATE-ACCRUED-THRU-A
025000                                    MO03-DATE-NEXT-PROC-A
025100         MOVE DFHBMDAS           TO MO03-ACH-ORG-NAME-LP-A
025200                                    MO03-ACH-ORG-NAME-RP-A
025300                                    MO03-ROUTE-TRANSIT-LP-A
025400                                    MO03-ROUTE-TRANSIT-RP-A
025500                                    MO03-TAX-ID-LP-A
025600                                    MO03-TAX-ID-RP-A
025700                                    MO03-DR-PRENOTE-DESC-LP-A
025800                                    MO03-DR-PRENOTE-DESC-RP-A
025900                                    MO03-CR-PRENOTE-DESC-LP-A
026000                                    MO03-CR-PRENOTE-DESC-RP-A
026100                                    MO03-ACH-REL-DAYS-LP-A
026200                                    MO03-ACH-REL-DAYS-RP-A
026300                                    MO03-WORK-WEEK-LP-A
026400                                    MO03-WORK-WEEK-RP-A
026500                                    MO03-DATE-ACCRUED-THRU-LP-A
026600                                    MO03-DATE-ACCRUED-THRU-RP-A
026700                                    MO03-DATE-NEXT-PROC-LP-A
026800                                    MO03-DATE-NEXT-PROC-RP-A
026900         PERFORM 9300-HOLIDAY-ATTRIBUTES
027000                                 THRU 9399-HA-EXIT.
027100*
027200****************************************************************
027300*    SEND THE MAP                                              *
027400****************************************************************
027500*
027600     MOVE 'BM01'                 TO MBCA-PROGRAM-LOCATION.
027700     PERFORM MB60PD-SEND-MAP-WITH-ERASE
027800                                 THRU MB60PD-SMWE-EXIT.
027900*
028000****************************************************************
028100*    RETURN TO CICS                                            *
028200****************************************************************
028300*
028400     MOVE 'PC02'                 TO MBCA-PROGRAM-LOCATION.
028500     PERFORM MB70PD-RETURN-TRANS-ID
028600                                 THRU MB70PD-RTI-EXIT.
028700/
028800 2000-RECEIVE-SCREEN SECTION.
028900*
029000****************************************************************
029100*    THIS SECTION RECEIVES THE FIRST SCREEN                    *
029200****************************************************************
029300*
029400     MOVE 'BM02'                 TO MBCA-PROGRAM-LOCATION.
029500     PERFORM MB60PD-RECEIVE-MAP  THRU MB60PD-RM-EXIT.
029600*
029700****************************************************************
029800*    CHECK FOR ANOTHER TRANSACTION ID ENTERED BY THE USER      *
029900****************************************************************
030000*
030100     MOVE 'PC03'                 TO MBCA-PROGRAM-LOCATION.
030200     PERFORM MB60PD-NEW-TRANS-ROUTINE
030300                                 THRU MB60PD-NTR-EXIT.
030400*
030500****************************************************************
030600*    BYPASS EDITS ON INQUIRY                                   *
030700****************************************************************
030800*
030900     IF  MBCA-PTI-FUNCTION-IS-INQUIRY
031000         GO TO 2600-SETUP-COMMAREA.
031100*
031200****************************************************************
031300*    READ THE ORGANIZATION FILE                                *
031400****************************************************************
031500*
031600     MOVE 'FC03'                 TO MBCA-PROGRAM-LOCATION.
031700     MOVE MBCA-MERCHANT-ORG      TO MBIOWS-MMOC-ORG.
031800     SET MBIORO-READ-RANDOM      TO TRUE.
031900     PERFORM MMOCAO-ACCESS       THRU MMOCAO-ACCESS-EXIT.
032000*
032100****************************************************************
032200*    EDIT FIELDS                                               *
032300****************************************************************
032400*
032500*            ***** ORG NAME *****                              *
032600*
032700     IF  MO03-ACH-ORG-NAME-L IS LESS THAN 1
032800         MOVE DFHBMASK           TO MO03-ACH-ORG-NAME-A
032900         MOVE DFHBMDAS           TO MO03-ACH-ORG-NAME-LP-A
033000                                    MO03-ACH-ORG-NAME-RP-A
033100         MOVE MMOC-ACH-ORG-NAME  TO MO03-ACH-ORG-NAME
033200     ELSE
033300         MOVE DFHBMASF           TO MO03-ACH-ORG-NAME-A
033400         MOVE DFHBMDAS           TO MO03-ACH-ORG-NAME-LP-A
033500                                    MO03-ACH-ORG-NAME-RP-A
033600         SET WS-UPDATE-SW-YES    TO TRUE.
033700*
033800*            ***** ROUTE/TRANSIT *****                         *
033900*
034000     IF  MO03-ROUTE-TRANSIT-L IS LESS THAN 1
034100         MOVE DFHBMASK           TO MO03-ROUTE-TRANSIT-A
034200         MOVE DFHBMDAS           TO MO03-ROUTE-TRANSIT-LP-A
034300                                    MO03-ROUTE-TRANSIT-RP-A
034400         MOVE MMOC-ACH-ABA-NBR   TO MO03-ROUTE-TRANSIT
034500     ELSE
034600         IF  MO03-ROUTE-TRANSIT IS NOT NUMERIC
034700             MOVE DFHBMNBF       TO MO03-ROUTE-TRANSIT-A
034800             MOVE DFHBMASB       TO MO03-ROUTE-TRANSIT-LP-A
034900                                    MO03-ROUTE-TRANSIT-RP-A
035000             MOVE SS08WS-CURSOR  TO MO03-ROUTE-TRANSIT-L
035100             SET SS08WS-ERROR-SW-YES TO TRUE
035200         ELSE
035300             MOVE MO03-ROUTE-TRANSIT
035400                                 TO SS05WS-NBR
035500             MOVE ZERO           TO SS05WS-OPTION
035600             PERFORM SS09PD-MOD10-137
035700                                 THRU SS09PD-M137-EXIT
035800             IF  SS05WS-CD-IS-INVALID
035900                 MOVE DFHBMNBF   TO MO03-ROUTE-TRANSIT-A
036000                 MOVE DFHBMASB   TO MO03-ROUTE-TRANSIT-LP-A
036100                                    MO03-ROUTE-TRANSIT-RP-A
036200                 MOVE SS08WS-CURSOR TO MO03-ROUTE-TRANSIT-L
036300                 SET SS08WS-ERROR-SW-YES
036400                                 TO TRUE
036500             ELSE
036600                 MOVE DFHBMASF   TO MO03-ROUTE-TRANSIT-A
036700                 MOVE DFHBMDAS   TO MO03-ROUTE-TRANSIT-LP-A
036800                                    MO03-ROUTE-TRANSIT-RP-A
036900                 SET WS-UPDATE-SW-YES
037000                                 TO TRUE.
037100*
037200*            ***** TAX ID *****                                *
037300*
037400     IF  MO03-TAX-ID-L IS LESS THAN 1
037500         MOVE DFHBMASK           TO MO03-TAX-ID-A
037600         MOVE DFHBMDAS           TO MO03-TAX-ID-LP-A
037700                                    MO03-TAX-ID-RP-A
037800         MOVE MMOC-ACH-TAX-ID    TO MO03-TAX-ID
037900     ELSE
038000         IF (MO03-TAX-ID(1:9) IS NUMERIC
038100         AND MMOC-COUNTRY-CODE(1) IS EQUAL TO 'USA')
038200         OR
038300            (MO03-TAX-ID(1:9) IS NUMERIC
038400         AND MMOC-COUNTRY-CODE(1) IS EQUAL TO '840')
038500         OR
038600            (MMOC-COUNTRY-CODE(1) IS NOT EQUAL TO 'USA'
038700         AND MMOC-COUNTRY-CODE(1) IS NOT EQUAL TO '840')
038800         OR
038900             MO03-TAX-ID IS EQUAL TO SPACES
039000             MOVE DFHBMASF       TO MO03-TAX-ID-A
039100             MOVE DFHBMDAS       TO MO03-TAX-ID-LP-A
039200                                    MO03-TAX-ID-RP-A
039300             SET WS-UPDATE-SW-YES
039400                                 TO TRUE
039500         ELSE
039600             MOVE DFHBMUBF       TO MO03-TAX-ID-A
039700             MOVE DFHBMASB       TO MO03-TAX-ID-LP-A
039800                                    MO03-TAX-ID-RP-A
039900             MOVE SS08WS-CURSOR  TO MO03-TAX-ID-L
040000             SET SS08WS-ERROR-SW-YES TO TRUE.
040100*
040200*            ***** PRENOTE DEBIT DESC *****                    *
040300*
040400     IF  MO03-DR-PRENOTE-DESC-L IS LESS THAN 1
040500         MOVE DFHBMASK           TO MO03-DR-PRENOTE-DESC-A
040600         MOVE DFHBMDAS           TO MO03-DR-PRENOTE-DESC-LP-A
040700                                    MO03-DR-PRENOTE-DESC-RP-A
040800         MOVE MMOC-ACH-DR-PRENOTE-DESC
040900                                 TO MO03-DR-PRENOTE-DESC
041000     ELSE
041100         MOVE DFHBMASF           TO MO03-DR-PRENOTE-DESC-A
041200         MOVE DFHBMDAS           TO MO03-DR-PRENOTE-DESC-LP-A
041300                                    MO03-DR-PRENOTE-DESC-RP-A
041400         SET WS-UPDATE-SW-YES    TO TRUE.
041500*
041600*            ***** PRENOTE CREDIT DESC *****                   *
041700*
041800     IF  MO03-CR-PRENOTE-DESC-L IS LESS THAN 1
041900         MOVE DFHBMASK           TO MO03-CR-PRENOTE-DESC-A
042000         MOVE DFHBMDAS           TO MO03-CR-PRENOTE-DESC-LP-A
042100                                    MO03-CR-PRENOTE-DESC-RP-A
042200         MOVE MMOC-ACH-CR-PRENOTE-DESC
042300                                 TO MO03-CR-PRENOTE-DESC
042400     ELSE
042500         MOVE DFHBMASF           TO MO03-CR-PRENOTE-DESC-A
042600         MOVE DFHBMDAS           TO MO03-CR-PRENOTE-DESC-LP-A
042700                                    MO03-CR-PRENOTE-DESC-RP-A
042800         SET WS-UPDATE-SW-YES    TO TRUE.
042900*
043000*            ***** RELEASE DAYS *****                         *
043100*
043200     IF  MO03-ACH-REL-DAYS-L IS LESS THAN 1
043300         MOVE DFHBMASK           TO MO03-ACH-REL-DAYS-A
043400         MOVE DFHBMDAS           TO MO03-ACH-REL-DAYS-LP-A
043500                                    MO03-ACH-REL-DAYS-RP-A
043600         MOVE MMOC-ACH-RELEASE-DAYS
043700                                 TO MO03-ACH-REL-DAYS
043800     ELSE
043900         IF  MO03-ACH-REL-DAYS IS NUMERIC
044000             MOVE DFHBMASF       TO MO03-ACH-REL-DAYS-A
044100             MOVE DFHBMDAS       TO MO03-ACH-REL-DAYS-LP-A
044200                                    MO03-ACH-REL-DAYS-RP-A
044300             SET WS-UPDATE-SW-YES
044400                                 TO TRUE
044500         ELSE
044600             MOVE DFHBMNBF       TO MO03-ACH-REL-DAYS-A
044700             MOVE DFHBMASB       TO MO03-ACH-REL-DAYS-LP-A
044800                                    MO03-ACH-REL-DAYS-RP-A
044900             MOVE SS08WS-CURSOR  TO MO03-ACH-REL-DAYS-L
045000             SET SS08WS-ERROR-SW-YES TO TRUE.
045100*
045200*             ***** WORK WEEK *****                             *
045300*
045400     PERFORM
045500         VARYING X-WORK-WEEK FROM 1 BY 1
045600         UNTIL X-WORK-WEEK IS GREATER THAN 7
045700         SET  X-MMOC-WW          TO X-WORK-WEEK
045800         EVALUATE TRUE
045900             WHEN MO03-WORK-WEEK-L (X-WORK-WEEK) IS LESS THAN 1
046000                 MOVE DFHBMASK   TO MO03-WORK-WEEK-A (X-WORK-WEEK)
046100                 MOVE MMOC-WORK-WEEK-R (X-MMOC-WW)
046200                                 TO MO03-WORK-WEEK (X-WORK-WEEK)
046300                 SET WS-MISC-SW-YES
046400                                 TO TRUE
046500             WHEN WS-INVALID-WEEK
046600                 CONTINUE
046700             WHEN (NOT MO03-WORK-WEEK-VALID (X-WORK-WEEK))
046800                 SET WS-INVALID-WEEK
046900                                 TO TRUE
047000                 MOVE SS08WS-CURSOR TO MO03-WORK-WEEK-L
047100                                       (X-WORK-WEEK)
047200             WHEN MO03-WORK-WEEK-VALID (X-WORK-WEEK)
047300                 MOVE DFHBMASF   TO MO03-WORK-WEEK-A (X-WORK-WEEK)
047400                 SET WS-MISC-SW-YES
047500                                 TO TRUE
047600                 SET WS-UPDATE-SW-YES
047700                                 TO TRUE
047800         END-EVALUATE
047900     END-PERFORM.
048000*
048100     PERFORM
048200         VARYING X-WORK-WEEK FROM 1 BY 1
048300         UNTIL X-WORK-WEEK IS GREATER THAN 7
048400         EVALUATE TRUE
048500           WHEN  MO03-WORK-WEEK-OPEN (X-WORK-WEEK)
048600                 SET WS-WORK-WEEK-OPEN
048700                                 TO TRUE
048800         END-EVALUATE
048900     END-PERFORM
049000*
049100     IF  WS-MISC-SW-NO
049200         SET WS-INVALID-WEEK        TO TRUE.
049300*
049400     IF  WS-INVALID-WEEK
049500     OR  WS-WORK-WEEK-CLOSED
049600         SET SS08WS-ERROR-SW-YES TO TRUE
049700         MOVE DFHBMUBF           TO MO03-WORK-WEEK-A (1)
049800                                    MO03-WORK-WEEK-A (2)
049900                                    MO03-WORK-WEEK-A (3)
050000                                    MO03-WORK-WEEK-A (4)
050100                                    MO03-WORK-WEEK-A (5)
050200                                    MO03-WORK-WEEK-A (6)
050300                                    MO03-WORK-WEEK-A (7)
050400         MOVE DFHBMASB           TO MO03-WORK-WEEK-LP-A
050500                                    MO03-WORK-WEEK-RP-A
050600         MOVE SS08WS-CURSOR      TO MO03-WORK-WEEK-L (1).
050700*
050800*            ***** HOLIDAYS *****                              *
050900*
051000     SET X-MO03-HOLIDAY          TO 1.
051100*
051200 2100-EDIT-DATE-LOOP.
051300*
051400     SET X-MMOC-HOL              TO X-MO03-HOLIDAY.
051500*
051600     IF  MO03-HOLIDAY-L (X-MO03-HOLIDAY) IS LESS THAN 1
051700         IF  MMOC-HOLIDAYS    (X-MMOC-HOL)    IS GREATER THAN ZERO
051800             MOVE MMOC-HOLIDAYS    (X-MMOC-HOL)
051900                                 TO SS01WS-JULIAN
052000             PERFORM SS08PD-JUL-TO-GREG
052100                                 THRU SS08PD-JTG-EXIT
052200             MOVE SS01WS-DATE    TO MO03-HOLIDAY
052300                                    (X-MO03-HOLIDAY)
052400             MOVE DFHBMASK       TO MO03-HOLIDAY-A
052500                                    (X-MO03-HOLIDAY)
052600             MOVE DFHBMDAS       TO MO03-HOLIDAY-LP-A
052700                                    (X-MO03-HOLIDAY)
052800                                    MO03-HOLIDAY-RP-A
052900                                    (X-MO03-HOLIDAY)
053000         ELSE
053100             MOVE DFHBMASK       TO MO03-HOLIDAY-A
053200                                    (X-MO03-HOLIDAY)
053300             MOVE DFHBMDAS       TO MO03-HOLIDAY-LP-A
053400                                    (X-MO03-HOLIDAY)
053500                                    MO03-HOLIDAY-RP-A
053600                                    (X-MO03-HOLIDAY)
053700     ELSE
053800         IF  MO03-HOLIDAY (X-MO03-HOLIDAY) IS NOT NUMERIC
053900             MOVE DFHBMNBF       TO MO03-HOLIDAY-A
054000                                    (X-MO03-HOLIDAY)
054100             MOVE DFHBMASB       TO MO03-HOLIDAY-LP-A
054200                                    (X-MO03-HOLIDAY)
054300                                    MO03-HOLIDAY-RP-A
054400                                    (X-MO03-HOLIDAY)
054500             MOVE SS08WS-CURSOR  TO MO03-HOLIDAY-L
054600                                    (X-MO03-HOLIDAY)
054700             SET SS08WS-ERROR-SW-YES TO TRUE
054800         ELSE
054900             PERFORM 9100-VERIFY-DATE
055000                                 THRU 9199-VD-EXIT
055100             IF  SS01WS-DATE-IS-INVALID
055200                 MOVE DFHBMNBF   TO MO03-HOLIDAY-A
055300                                    (X-MO03-HOLIDAY)
055400                 MOVE DFHBMASB   TO MO03-HOLIDAY-LP-A
055500                                    (X-MO03-HOLIDAY)
055600                                    MO03-HOLIDAY-RP-A
055700                                    (X-MO03-HOLIDAY)
055800                 MOVE SS08WS-CURSOR TO MO03-HOLIDAY-L
055900                                    (X-MO03-HOLIDAY)
056000                 SET SS08WS-ERROR-SW-YES
056100                                 TO TRUE
056200             ELSE
056300                 MOVE SS01WS-DATE
056400                                 TO MO03-HOLIDAY
056500                                    (X-MO03-HOLIDAY)
056600                 MOVE DFHBMASF   TO MO03-HOLIDAY-A
056700                                    (X-MO03-HOLIDAY)
056800                 MOVE DFHBMDAS   TO MO03-HOLIDAY-LP-A
056900                                    (X-MO03-HOLIDAY)
057000                                    MO03-HOLIDAY-RP-A
057100                                    (X-MO03-HOLIDAY)
057200                 SET WS-UPDATE-SW-YES
057300                                 TO TRUE.
057400*
057500     IF  X-MO03-HOLIDAY IS LESS THAN 25
057600         SET X-MO03-HOLIDAY      UP BY 1
057700         GO TO 2100-EDIT-DATE-LOOP.
057800*
057900*            ***** DATE LAST PROCESSED *****
058000*
058100     MOVE MMOC-TODAYS-JULIAN     TO SS01WS-JULIAN.
058200     PERFORM SS08PD-JUL-TO-GREG  THRU SS08PD-JTG-EXIT.
058300     MOVE SS01WS-DATE            TO MO03-DATE-LAST-PROC.
058400*
058500*            ***** DATE ACCRUED THRU *****                     *
058600*
058700     IF  MMOC-DATE-LAST-PROC    IS NOT EQUAL TO ZEROES
058800         GO TO 2200-NEXT-PROCESSING.
058900*
059000     IF  MO03-DATE-ACCRUED-THRU-L IS LESS THAN 1
059100         MOVE DFHBMASK           TO MO03-DATE-ACCRUED-THRU-A
059200         MOVE DFHBMDAS           TO MO03-DATE-ACCRUED-THRU-LP-A
059300                                    MO03-DATE-ACCRUED-THRU-RP-A
059400         MOVE MMOC-ACCR-THRU-DATE
059500                                 TO SS01WS-JULIAN
059600                                    WS-ACCR-THRU-DATE
059700         PERFORM SS08PD-JUL-TO-GREG
059800                                 THRU SS08PD-JTG-EXIT
059900         MOVE SS01WS-DATE        TO MO03-DATE-ACCRUED-THRU
060000         GO TO 2200-NEXT-PROCESSING.
060100*
060200     IF  MO03-DATE-ACCRUED-THRU IS NUMERIC
060300     AND MO03-DATE-ACCRUED-THRU IS LESS THAN 1000000
060400         MOVE MO03-DATE-ACCRUED-THRU
060500                                 TO SS01WS-MDY
060600         MOVE SS01WS-MDYZ        TO SS01WS-DATEZ
060700     ELSE
060800         MOVE MO03-DATE-ACCRUED-THRU
060900                                 TO SS01WS-DATE.
061000*
061100     PERFORM SS05PD-DATE-VALIDATION
061200                                 THRU SS05PD-DV-EXIT.
061300*
061400     IF  SS01WS-DATE-IS-INVALID
061500         MOVE DFHBMNBF           TO MO03-DATE-ACCRUED-THRU-A
061600         MOVE DFHBMASB           TO MO03-DATE-ACCRUED-THRU-LP-A
061700                                    MO03-DATE-ACCRUED-THRU-RP-A
061800         MOVE SS08WS-CURSOR      TO MO03-DATE-ACCRUED-THRU-L
061900         SET SS08WS-ERROR-SW-YES TO TRUE
062000     ELSE
062100         MOVE DFHBMASF           TO MO03-DATE-ACCRUED-THRU-A
062200         MOVE DFHBMDAS           TO MO03-DATE-ACCRUED-THRU-LP-A
062300                                    MO03-DATE-ACCRUED-THRU-RP-A
062400         SET WS-UPDATE-SW-YES    TO TRUE.
062500*
062600 2200-NEXT-PROCESSING.
062700*
062800*            ***** NEXT PROCESSING DATE *****                  *
062900*
063000     IF  MMOC-DATE-LAST-PROC    IS NOT EQUAL TO ZEROES
063100         GO TO 2300-CONTINUE.
063200*
063300     IF  MO03-DATE-NEXT-PROC-L IS LESS THAN 1
063400         MOVE DFHBMASK           TO MO03-DATE-NEXT-PROC-A
063500         MOVE DFHBMDAS           TO MO03-DATE-NEXT-PROC-LP-A
063600                                    MO03-DATE-NEXT-PROC-RP-A
063700         MOVE MMOC-DATE-NEXT-PROC
063800                                 TO SS01WS-JULIAN
063900                                    WS-NEXT-PROC-DATE
064000         PERFORM SS08PD-JUL-TO-GREG
064100                                 THRU SS08PD-JTG-EXIT
064200         MOVE SS01WS-DATE        TO MO03-DATE-NEXT-PROC
064300         GO TO 2250-CROSS-EDIT.
064400*
064500     IF  MO03-DATE-NEXT-PROC IS NUMERIC
064600     AND MO03-DATE-NEXT-PROC IS LESS THAN 1000000
064700         MOVE MO03-DATE-NEXT-PROC
064800                                 TO SS01WS-MDY
064900         MOVE SS01WS-MDYZ        TO SS01WS-DATEZ
065000     ELSE
065100         MOVE MO03-DATE-NEXT-PROC
065200                                 TO SS01WS-DATE.
065300*
065400     PERFORM SS05PD-DATE-VALIDATION
065500                                 THRU SS05PD-DV-EXIT.
065600*
065700     IF  SS01WS-DATE-IS-INVALID
065800         MOVE DFHBMNBF           TO MO03-DATE-NEXT-PROC-A
065900         MOVE DFHBMASB           TO MO03-DATE-NEXT-PROC-LP-A
066000                                    MO03-DATE-NEXT-PROC-RP-A
066100         MOVE SS08WS-CURSOR      TO MO03-DATE-NEXT-PROC-L
066200         SET SS08WS-ERROR-SW-YES TO TRUE
066300         GO TO 2300-CONTINUE
066400     ELSE
066500         MOVE DFHBMASF           TO MO03-DATE-NEXT-PROC-A
066600         MOVE DFHBMDAS           TO MO03-DATE-NEXT-PROC-LP-A
066700                                    MO03-DATE-NEXT-PROC-RP-A
066800         SET WS-UPDATE-SW-YES    TO TRUE.
066900*
067000 2250-CROSS-EDIT.
067100*
067200     IF  MO03-DATE-ACCRUED-THRU-L IS GREATER THAN ZERO
067300         MOVE MO03-DATE-ACCRUED-THRU
067400                                 TO SS01WS-DATE
067500         PERFORM SS07PD-GREG-TO-JUL
067600                                 THRU SS07PD-GTJ-EXIT
067700         MOVE SS01WS-JULIAN      TO WS-ACCR-THRU-DATE.
067800*
067900     IF  MO03-DATE-NEXT-PROC-L IS GREATER THAN ZERO
068000         MOVE MO03-DATE-NEXT-PROC
068100                                 TO SS01WS-DATE
068200         PERFORM SS07PD-GREG-TO-JUL
068300                                 THRU SS07PD-GTJ-EXIT
068400         MOVE SS01WS-JULIAN      TO WS-NEXT-PROC-DATE.
068500*
068600     IF  WS-ACCR-THRU-DATE IS GREATER THAN
068700                                    WS-NEXT-PROC-DATE
068800     OR  WS-ACCR-THRU-DATE IS EQUAL TO
068900                                    WS-NEXT-PROC-DATE
069000         MOVE DFHBMNBF           TO MO03-DATE-NEXT-PROC-A
069100                                    MO03-DATE-ACCRUED-THRU-A
069200         MOVE DFHBMASB           TO MO03-DATE-NEXT-PROC-LP-A
069300                                    MO03-DATE-NEXT-PROC-RP-A
069400                                    MO03-DATE-ACCRUED-THRU-LP-A
069500                                    MO03-DATE-ACCRUED-THRU-RP-A
069600         MOVE SS08WS-CURSOR      TO MO03-DATE-ACCRUED-THRU-L
069700         SET SS08WS-ERROR-SW-YES TO TRUE.
069800*
069900 2300-CONTINUE.
070000*
070100     IF  SS08WS-ERROR-SW-NO
070200         GO TO 2400-UPDATE-FILE.
070300*
070400****************************************************************
070500*    SEND THE MAP                                              *
070600****************************************************************
070700*
070800     PERFORM MB60PD-INIT-STD-MAP-LINES
070900                                 THRU MB60PD-ISML-EXIT.
071000     MOVE 'BM03'                 TO MBCA-PROGRAM-LOCATION.
071100     PERFORM MB60PD-SEND-MAP-DATA-ONLY
071200                                 THRU MB60PD-SMDO-EXIT.
071300*
071400****************************************************************
071500*    RETURN TO CICS                                            *
071600****************************************************************
071700*
071800     MOVE 'PC04'                 TO MBCA-PROGRAM-LOCATION.
071900     MOVE 03                     TO MBCA-SCREEN-NBR.
072000     PERFORM MB70PD-RETURN-TRANS-ID
072100                                 THRU MB70PD-RTI-EXIT.
072200/
072300 2400-UPDATE-FILE.
072400*
072500     IF  WS-UPDATE-SW-NO
072600         GO TO 2600-SETUP-COMMAREA.
072700*
072800****************************************************************
072900*    GETMAIN FOR LOG/JOURNAL RECORD                            *
073000****************************************************************
073100*
073200     MOVE 'SC02'                 TO MBCA-PROGRAM-LOCATION.
073300     SET MBIORO-GETMAIN          TO TRUE.
073400     PERFORM MML1AO-ACCESS       THRU MML1AO-ACCESS-EXIT.
073500*
073600****************************************************************
073700*    READ THE ORGANIZATION FILE RECORD FOR UPDATE              *
073800****************************************************************
073900*
074000     MOVE 'FC04'                 TO MBCA-PROGRAM-LOCATION.
074100     MOVE MBCA-MERCHANT-ORG      TO MBIOWS-MMOC-ORG.
074200     SET MBIORO-READ-RANDOM-UPDATE
074300                                 TO TRUE.
074400     PERFORM MMOCAO-ACCESS       THRU MMOCAO-ACCESS-EXIT.
074500*
074600*            ***** WORK WEEK *****                             *
074700*
074800     PERFORM
074900         VARYING X-WORK-WEEK FROM 1 BY 1
075000         UNTIL X-WORK-WEEK IS GREATER THAN 7
075100         SET  X-MMOC-WW          TO X-WORK-WEEK
075200         SET  WS-INDEX           TO X-WORK-WEEK
075300         EVALUATE TRUE
075400             WHEN MO03-WORK-WEEK-L (X-WORK-WEEK)
075500                                 IS GREATER THAN ZEROS
075600                 MOVE WS-INDEX   TO MML1-FIELD-OCCURRENCE
075700                 MOVE 0301       TO MML1-FIELD-CODE
075800                 MOVE MML1WS-VL-01
075900                                 TO MML1-VARIABLE-LENGTH
076000                 MOVE MMOC-WORK-WEEK-R (X-MMOC-WW)
076100                                 TO MML1-VL01-B-DATA-X
076200                 MOVE MO03-WORK-WEEK (X-WORK-WEEK)
076300                                 TO MMOC-WORK-WEEK-R (X-MMOC-WW)
076400                 MOVE MMOC-WORK-WEEK-R (X-MMOC-WW)
076500                                 TO MML1-VL01-A-DATA-X
076600                 PERFORM 9050-CREATE-MAINT-RECORD
076700                                         THRU 9099-CMR-EXIT
076800         END-EVALUATE
076900     END-PERFORM.
077000*
077100*            ***** DATE ACCRUED THRU *****                     *
077200*
077300     IF  MMOC-DATE-LAST-PROC    IS EQUAL TO ZEROES
077400     AND MO03-DATE-ACCRUED-THRU-L IS GREATER THAN ZEROES
077500         MOVE MO03-DATE-ACCRUED-THRU
077600                                 TO SS01WS-DATE
077700         PERFORM SS07PD-GREG-TO-JUL
077800                                 THRU SS07PD-GTJ-EXIT
077900         MOVE ZEROES             TO MML1-FIELD-OCCURRENCE
078000         MOVE 0302               TO MML1-FIELD-CODE
078100         MOVE MML1WS-VL-07       TO MML1-VARIABLE-LENGTH
078200         MOVE MMOC-ACCR-THRU-DATE
078300                                 TO MML1-VL07-B-DATA-9
078400         MOVE SS01WS-JULIAN      TO MMOC-ACCR-THRU-DATE
078500         MOVE MMOC-ACCR-THRU-DATE
078600                                 TO MML1-VL07-A-DATA-9
078700         PERFORM 9050-CREATE-MAINT-RECORD
078800                                 THRU 9099-CMR-EXIT.
078900*
079000*            ***** NEXT PROCESSING DATE *****                  *
079100*
079200     IF  MMOC-DATE-LAST-PROC    IS EQUAL TO ZEROES
079300     AND MO03-DATE-NEXT-PROC-L IS GREATER THAN ZEROES
079400         MOVE ZEROES             TO MML1-FIELD-OCCURRENCE
079500         MOVE 0303               TO MML1-FIELD-CODE
079600         MOVE MML1WS-VL-07       TO MML1-VARIABLE-LENGTH
079700         MOVE MMOC-DATE-NEXT-PROC
079800                                 TO MML1-VL07-B-DATA-9
079900         MOVE MO03-DATE-NEXT-PROC
080000                                 TO SS01WS-DATE
080100         PERFORM SS07PD-GREG-TO-JUL
080200                                 THRU SS07PD-GTJ-EXIT
080300         MOVE SS01WS-JULIAN      TO MML1-VL07-A-DATA-9
080400         PERFORM 9050-CREATE-MAINT-RECORD
080500                                 THRU 9099-CMR-EXIT
080600         MOVE SS01WS-JULIAN      TO MMOC-DATE-NEXT-PROC
080700         MOVE ZEROES             TO MML1-FIELD-OCCURRENCE
080800         MOVE 0304               TO MML1-FIELD-CODE
080900         MOVE MML1WS-VL-07       TO MML1-VARIABLE-LENGTH
081000         MOVE MMOC-TODAYS-JULIAN
081100                                 TO MML1-VL07-B-DATA-9
081200         MOVE SS01WS-JULIAN      TO MMOC-TODAYS-JULIAN
081300         MOVE MMOC-TODAYS-JULIAN
081400                                 TO MML1-VL07-A-DATA-9
081500         PERFORM 9050-CREATE-MAINT-RECORD
081600                                 THRU 9099-CMR-EXIT
081700         MOVE ZEROES             TO MML1-FIELD-OCCURRENCE
081800         MOVE 0305               TO MML1-FIELD-CODE
081900         MOVE MML1WS-VL-10       TO MML1-VARIABLE-LENGTH
082000         MOVE MMOC-TODAYS-CALENDAR
082100                                 TO MML1-VL10-B-DATA-9
082200         MOVE MMOC-TODAYS-JULIAN
082300                                 TO SS01WS-JULIAN
082400         PERFORM SS08PD-JUL-TO-GREG
082500                                 THRU SS08PD-JTG-EXIT
082600         MOVE SS01WS-DATE        TO MMOC-TODAYS-CALENDAR
082700         MOVE MMOC-TODAYS-CALENDAR
082800                                 TO MML1-VL10-A-DATA-9
082900         PERFORM 9050-CREATE-MAINT-RECORD
083000                                 THRU 9099-CMR-EXIT.
083100*
083200*            ***** HOLIDAYS *****                              *
083300*
083400     SET X-MO03-HOLIDAY          TO 1.
083500*
083600 2500-CHECK-DATE-LOOP.
083700*
083800     SET X-MMOC-HOL              TO X-MO03-HOLIDAY.
083900*
084000     IF  MO03-HOLIDAY-L (X-MO03-HOLIDAY) IS GREATER THAN ZEROES
084100         SET WS-INDEX            TO X-MMOC-HOL
084200         MOVE WS-INDEX           TO MML1-FIELD-OCCURRENCE
084300         MOVE 0306               TO MML1-FIELD-CODE
084400         MOVE MML1WS-VL-07       TO MML1-VARIABLE-LENGTH
084500         MOVE MMOC-HOLIDAYS    (X-MMOC-HOL)
084600                                 TO MML1-VL07-B-DATA-9
084700         MOVE MO03-HOLIDAY (X-MO03-HOLIDAY)
084800                                 TO SS01WS-DATE
084900         PERFORM SS07PD-GREG-TO-JUL
085000                                 THRU SS07PD-GTJ-EXIT
085100         MOVE SS01WS-JULIAN      TO MMOC-HOLIDAYS
085200                                    (X-MMOC-HOL)
085300         MOVE MMOC-HOLIDAYS    (X-MMOC-HOL)
085400                                 TO MML1-VL07-A-DATA-9
085500         PERFORM 9050-CREATE-MAINT-RECORD
085600                                 THRU 9099-CMR-EXIT.
085700*
085800     IF  X-MO03-HOLIDAY IS LESS THAN 25
085900         SET X-MO03-HOLIDAY      UP BY 1
086000         GO TO 2500-CHECK-DATE-LOOP.
086100*
086200*            ***** ORG NAME *****                              *
086300*
086400     IF  MO03-ACH-ORG-NAME-L IS GREATER THAN ZERO
086500         MOVE ZEROES             TO MML1-FIELD-OCCURRENCE
086600         MOVE 0307               TO MML1-FIELD-CODE
086700         MOVE MML1WS-VL-20       TO MML1-VARIABLE-LENGTH
086800         MOVE MMOC-ACH-ORG-NAME
086900                                 TO MML1-VL20-B-DATA-X
087000         MOVE MO03-ACH-ORG-NAME  TO MMOC-ACH-ORG-NAME
087100         MOVE MMOC-ACH-ORG-NAME
087200                                 TO MML1-VL20-A-DATA-X
087300         PERFORM 9050-CREATE-MAINT-RECORD
087400                                 THRU 9099-CMR-EXIT.
087500*
087600*            ***** ROUTE TRANSIT *****                         *
087700*
087800     IF  MO03-ROUTE-TRANSIT-L IS GREATER THAN ZERO
087900         MOVE ZEROES             TO MML1-FIELD-OCCURRENCE
088000         MOVE 0308               TO MML1-FIELD-CODE
088100         MOVE MML1WS-VL-20       TO MML1-VARIABLE-LENGTH
088200         MOVE MMOC-ACH-ABA-NBR
088300                                 TO MML1-VL20-B-NBR-NO-DEC
088400         MOVE MO03-ROUTE-TRANSIT TO MMOC-ACH-ABA-NBR
088500         MOVE MMOC-ACH-ABA-NBR
088600                                 TO MML1-VL20-A-NBR-NO-DEC
088700         PERFORM 9050-CREATE-MAINT-RECORD
088800                                 THRU 9099-CMR-EXIT.
088900*
089000*            ***** PRENOTE CREDIT DESC *****                    *
089100*
089200     IF  MO03-CR-PRENOTE-DESC-L IS GREATER THAN ZERO
089300         MOVE ZEROES             TO MML1-FIELD-OCCURRENCE
089400         MOVE 0309               TO MML1-FIELD-CODE
089500         MOVE MML1WS-VL-10       TO MML1-VARIABLE-LENGTH
089600         MOVE MMOC-ACH-CR-PRENOTE-DESC
089700                                 TO MML1-VL10-B-DATA-X
089800         MOVE MO03-CR-PRENOTE-DESC
089900                                 TO MMOC-ACH-CR-PRENOTE-DESC
090000         MOVE MMOC-ACH-CR-PRENOTE-DESC
090100                                 TO MML1-VL10-A-DATA-X
090200         PERFORM 9050-CREATE-MAINT-RECORD
090300                                 THRU 9099-CMR-EXIT.
090400*
090500*            ***** TAX ID *****                                *
090600*
090700     IF  MO03-TAX-ID-L IS GREATER THAN ZERO
090800         MOVE ZEROES             TO MML1-FIELD-OCCURRENCE
090900         MOVE 0310               TO MML1-FIELD-CODE
091000         MOVE MML1WS-VL-20       TO MML1-VARIABLE-LENGTH
091100         MOVE MMOC-ACH-TAX-ID    TO MML1-VL20-B-NBR-NO-DEC
091200         MOVE MO03-TAX-ID        TO MMOC-ACH-TAX-ID
091300         MOVE MMOC-ACH-TAX-ID    TO MML1-VL20-A-NBR-NO-DEC
091400         PERFORM 9050-CREATE-MAINT-RECORD
091500                                 THRU 9099-CMR-EXIT.
091600*
091700*            ***** PRENOTE DEBIT DESC *****                    *
091800*
091900     IF  MO03-DR-PRENOTE-DESC-L IS GREATER THAN ZERO
092000         MOVE ZEROES             TO MML1-FIELD-OCCURRENCE
092100         MOVE 0311               TO MML1-FIELD-CODE
092200         MOVE MML1WS-VL-10       TO MML1-VARIABLE-LENGTH
092300         MOVE MMOC-ACH-DR-PRENOTE-DESC
092400                                 TO MML1-VL10-B-DATA-X
092500         MOVE MO03-DR-PRENOTE-DESC
092600                                 TO MMOC-ACH-DR-PRENOTE-DESC
092700         MOVE MMOC-ACH-DR-PRENOTE-DESC
092800                                 TO MML1-VL10-A-DATA-X
092900         PERFORM 9050-CREATE-MAINT-RECORD
093000                                 THRU 9099-CMR-EXIT.
093100*
093200*            ***** RELEASE DAYS ******                        *
093300*
093400     IF  MO03-ACH-REL-DAYS-L IS GREATER THAN ZERO
093500         MOVE ZEROES             TO MML1-FIELD-OCCURRENCE
093600         MOVE 0312               TO MML1-FIELD-CODE
093700         MOVE MML1WS-VL-20       TO MML1-VARIABLE-LENGTH
093800         MOVE MMOC-ACH-RELEASE-DAYS
093900                                 TO MML1-VL20-B-NBR-NO-DEC
094000         MOVE MO03-ACH-REL-DAYS  TO MMOC-ACH-RELEASE-DAYS
094100         MOVE MMOC-ACH-RELEASE-DAYS
094200                                 TO MML1-VL20-A-NBR-NO-DEC
094300         PERFORM 9050-CREATE-MAINT-RECORD
094400                                 THRU 9099-CMR-EXIT.
094500*
094600     IF  MBCA-PTI-FUNCTION-IS-ADD
094700         MOVE 03                 TO MMOC-ONLINE-STATUS.
094800*
094900*            ***** LAST MAINT DATE AND OPERATOR ID *****       *
095000*
095100     MOVE ZEROES                 TO MML1-FIELD-OCCURRENCE.
095200     MOVE 0199                   TO MML1-FIELD-CODE.
095300     MOVE MML1WS-VL-07           TO MML1-VARIABLE-LENGTH.
095400     MOVE MMOC-LAST-MAINT-DATE
095500                                 TO MML1-VL07-B-DATA-9.
095600     MOVE MBCA-START-DATE        TO MMOC-LAST-MAINT-DATE.
095700     MOVE MMOC-LAST-MAINT-DATE
095800                                 TO MML1-VL07-A-DATA-9.
095900     PERFORM 9050-CREATE-MAINT-RECORD
096000                                 THRU 9099-CMR-EXIT.
096100     MOVE 0198                   TO MML1-FIELD-CODE.
096200     MOVE MML1WS-VL-03           TO MML1-VARIABLE-LENGTH.
096300     MOVE MMOC-LAST-MAINT-OPER
096400                                 TO MML1-VL03-B-DATA-X.
096500     MOVE MBCA-OPERATOR-ID       TO MMOC-LAST-MAINT-OPER.
096600     MOVE MMOC-LAST-MAINT-OPER
096700                                 TO MML1-VL03-A-DATA-X.
096800     PERFORM 9050-CREATE-MAINT-RECORD
096900                                 THRU 9099-CMR-EXIT.
097000*
097100****************************************************************
097200*    UPDATE THE ORGANIZATION FILE RECORD                       *
097300****************************************************************
097400*
097500     MOVE 'FC05'                 TO MBCA-PROGRAM-LOCATION.
097600     SET MBIORO-REWRITE          TO TRUE.
097700     PERFORM MMOCAO-ACCESS       THRU MMOCAO-ACCESS-EXIT.
097800*
097900 2600-SETUP-COMMAREA.
098000*
098100****************************************************************
098200*    SET UP COMMAREA FIELDS AND TRANSFER TO THE NEXT PROGRAM   *
098300****************************************************************
098400*
098500     MOVE MBCA-EIBAID            TO SS08WS-EIBAID.
098600*
098700     PERFORM MB60PD-EDIT-PAGE-NBR
098800                                 THRU MB60PD-EPN-EXIT.
098900*
099000     IF  SS08WS-VALID-PF-KEY
099100     OR  SS08WS-EIBAID-VALID-PF-KEY
099200         SET MBCA-INITIAL-SCREEN-NBR
099300                                 TO TRUE.
099400*
099500     MOVE 'PC05'                 TO MBCA-PROGRAM-LOCATION.
099600     PERFORM MB70PD-XCTL-TO-MBOXCTL
099700                                 THRU MB70PD-XTM-EXIT.
099800/
099900 9000-PERFORMED-ROUTINES-SECT SECTION.
100000*
100100 9050-CREATE-MAINT-RECORD.
100200*
100300*****************************************************************
100400*    THIS ROUTINE WILL CREATE THE COMMON DATA FOR ALL OF THE    *
100500*    LOG/JOURNAL TRANSACTIONS                                   *
100600*****************************************************************
100700*
100800     IF  MBCA-PTI-FUNCTION-IS-ADD
100900         GO TO 9099-CMR-EXIT.
101000*
101100     MOVE 'OC'                   TO MML1-FILE-CODE.
101200     MOVE MBCA-MERCHANT-ORG      TO MML1-MMOC-ORG.
101300     MOVE MBCA-SIGNON-NAME       TO MML1-SIGNON-NAME.
101400     MOVE MBCA-TERMINAL-ID       TO MML1-TERMINAL-ID.
101500     MOVE ZEROES                 TO MML1-SOURCE-CODE
101600                                    MML1-FIELD-OCCURRENCE-2.
101700*
101800*****************************************************************
101900*    WRITE THE LOG/JOURNAL FILE RECORD                          *
102000*****************************************************************
102100*
102200     MOVE 'FC06'                 TO MBCA-PROGRAM-LOCATION.
102300     SET MBIORO-WRITE            TO TRUE.
102400     PERFORM MML1AO-ACCESS       THRU MML1AO-ACCESS-EXIT.
102500     MOVE SPACES                 TO MML1-VARIABLE-AREA.
102600*
102700 9099-CMR-EXIT.
102800     EXIT.
102900*
103000 9100-VERIFY-DATE.
103100*
103200     IF  MO03-HOLIDAY (X-MO03-HOLIDAY) IS LESS THAN 1000000
103300         MOVE MO03-HOLIDAY (X-MO03-HOLIDAY)
103400                                 TO SS01WS-MDY
103500         MOVE SS01WS-MDYZ        TO SS01WS-DATEZ
103600     ELSE
103700         MOVE MO03-HOLIDAY (X-MO03-HOLIDAY)
103800                                 TO SS01WS-DATE.
103900*
104000     PERFORM SS05PD-DATE-VALIDATION
104100                                 THRU SS05PD-DV-EXIT.
104200*
104300 9199-VD-EXIT.
104400     EXIT.
104500*
104600 9300-HOLIDAY-ATTRIBUTES.
104700*
104800     SET X-MO03-HOLIDAY          TO 1.
104900*
105000 9300-HOLIDAY-LOOP.
105100*
105200     MOVE DFHBMASB               TO MO03-HOLIDAY-A
105300                                    (X-MO03-HOLIDAY).
105400     MOVE DFHBMDAS               TO MO03-HOLIDAY-LP-A
105500                                    (X-MO03-HOLIDAY)
105600                                    MO03-HOLIDAY-RP-A
105700                                    (X-MO03-HOLIDAY).
105800*
105900     IF  X-MO03-HOLIDAY IS LESS THAN 25
106000         SET X-MO03-HOLIDAY      UP BY 1
106100         GO TO 9300-HOLIDAY-LOOP.
106200*
106300 9399-HA-EXIT.
106400     EXIT.
106500/         DATE VALIDATION ROUTINE
106600     COPY SS05PD.
106700/         GREGORIAN TO JULIAN DATE ROUTINE
106800     COPY SS07PD.
106900/         JULIAN TO GREGORIAN DATE ROUTINE.
107000     COPY SS08PD.
107100/         DATE AND TIME EDIT ROUTINES.
107200     COPY SS26PD.
107300     COPY SS27PD.
107400/         CHECK DIGIT ROUTINE.
107500     COPY SS09PD.
107600/         LINE 24 PF KEYS ROUTINE
107700     COPY SS15PD.
107800/         ORGANIZATION RECORD ACCESS ROUTINES
107900     COPY MMOCAO.
108000/         SYSTEM RECORD ACCESS ROUTINES
108100     COPY MMSCAO.
108200/         LOG/JOURNAL ACCESS ROUTINES
108300     COPY MML1AO.
108400/         ON-LINE MAP ROUTINES
108500     COPY MB60PD REPLACING 'MBMAPXX' BY 'MBMO03 '
108600                           MBMAPXXI BY MBMO03I
108700                           MBMAPXXO BY MBMO03O.
108800/         ON-LINE PROCEDURES
108900     COPY MB70PD.
109000/
109100     COPY SMFTPXO.
