000100 IDENTIFICATION DIVISION.
000200 PROGRAM-ID. MBOMO04.
000201*       RELEASE DATE=08/24/01.        REVISION LEVEL=08.06      *
000202*****************************************************************
000203*WARNING.  THIS COMPUTER PROGRAM IS PROTECTED BY COPYRIGHT LAW  *
000204*AND INTERNATIONAL TREATIES.  UNAUTHORIZED REPRODUCTION OR      *
000205*DISTRIBUTION OF THIS PROGRAM, OR ANY PORTION OF IT, MAY RESULT *
000206*IN SEVERE CIVIL AND CRIMINAL PENATLIES, AND WILL BE PROSECUTED *
000207*TO THE MAXIMUM EXTENT POSSIBLE UNDER THE LAW.                  *
000208*COPYRIGHT 1999 PAYSYS INTERNATIONAL, INC.  ALL RIGHTS RESERVED.*
000209*****************************************************************
000300*****************************************************************
000400*                                                               *
000500*   V - PLUS  M E R C H A N T   B A N K C A R D   S Y S T E M   *
000600*                                                               *
000700*      MBOMO04 - ON-LINE ORG RECORD ADD/MAINTENANCE/INQUIRY     *
000800*                SCREEN 04                                      *
000900*                                                               *
001000*              1. TRANSIDS                                      *
001100*                 A. MBAO                                       *
001200*                 B. MBMO                                       *
001300*                 C. MBQO                                       *
001400*              2. MAPS USED -                                   *
001500*                 A. MBMO04 (ORGANIZATION MAP 04)               *
001600*              3. FILES USED -                                  *
001700*                 A. MMOC   (SYSTEM/ORG CONTROL FILE)           *
001800*                 B. MMSM   (STORE MASTER FILE)                 *
001900*                 C. MML1   (LOG/JOURNAL FILE)                  *
002000*                                                               *
002100*****************************************************************
002200*
002300 ENVIRONMENT DIVISION.
002400 DATA DIVISION.
002500 WORKING-STORAGE SECTION.
002600 01  FILLER                  PIC  X(12)      VALUE '** WS-BEG **'.
002700*         I/O REQUEST BLOCK WORK AREAS
002800     COPY MBIOWS.
002900/         I/O REQUEST BLOCK
003000     COPY MBIORO.
003100/         LOG/JOURNAL WORK AREAS
003200     COPY MML1WS REPLACING ==:MML1:== BY ==MML1==.
003300/         STANDARD ERROR MESSAGES
003400     COPY MBEMWS.
003500/         DATE WORK AREAS
003600     COPY SS01WS.
003700/         ONLINE WORK AREAS
003800     COPY SS08WS.
003900/
004000     COPY SS00WS.
004100/
004200     COPY SMFTWS.
004300/
004400     COPY SMPTRL REPLACING ==:SMPT:== BY ==SMPT==.
004500/
004600     COPY MB61LK.
004700/         CHECK DIGIT WORK FIELDS
004800     COPY SS05WS.
004900/
005000 01  WS-WORK-AREAS.
005100     03  WS-INDEX            PIC S9(04)      BINARY.
005200     03  WS-UPDATE-SW        PIC  X(01)      VALUE 'N'.
005300         88  WS-UPDATE-SW-NO                 VALUE 'N'.
005400         88  WS-UPDATE-SW-YES                VALUE 'Y'.
005500     03  WS-CROSS-EDIT-SW    PIC  X(01)      VALUE 'N'.
005600         88  WS-CROSS-EDIT-BILL-INVALID      VALUE 'Y'.
005700 01  FILLER                  PIC  X(12)      VALUE '** WS-END **'.
005800/
005900 LINKAGE SECTION.
006000 01  DFHCOMMAREA.
006100     COPY MB60WS.
006200/         ORG SCREEN 04 MAP DSECT
006300     COPY MBMO04.
006400/         ORG SCREEN 04 MAP REDEFINITION
006500     COPY MBMO04R.
006600/         ORG CONTROL FILE RECORD LAYOUT
006700     COPY MMOCRL.
006800/         STORE MASTER FILE RECORD LAYOUT
006900     COPY MMSMRL.
007000/         LOG/JOURNAL FILE RECORD LAYOUT
007100     COPY MML1RL REPLACING ==:MML1:== BY ==MML1==.
007200/
007300 PROCEDURE DIVISION.
007400 0000-HOUSEKEEPING SECTION.
007500 0100-INIT.
007600*
007700     MOVE 'PC01'                 TO MBCA-PROGRAM-LOCATION.
007800     PERFORM MB70PD-ON-LINE-HOUSEKEEPING
007900                                 THRU MB70PD-OLH-EXIT.
008000*
008100     IF  MBCA-RECEIVE-SCREEN
008200         GO TO 2000-RECEIVE-SCREEN.
008300/
008400 1000-SEND-SCREEN SECTION.
008500*
008600****************************************************************
008700*    THIS SECTION BUILDS AND SENDS THE 04 SCREEN.              *
008800****************************************************************
008900*
009000****************************************************************
009100*    GET CICS STORAGE NEEDED FOR THE MAP                       *
009200****************************************************************
009300*
009400     MOVE 'SC01'                 TO MBCA-PROGRAM-LOCATION.
009500     PERFORM MB60PD-GETMAIN-FOR-MAP
009600                                 THRU MB60PD-GFM-EXIT.
009700*
009800     MOVE MBCA-MERCHANT-ORG      TO MO04-ORG.
009900     MOVE 04                     TO MBCA-SCREEN-NBR.
010000*
010100****************************************************************
010200*    INITIALIZE THE STANDARD MAP LINES                         *
010300****************************************************************
010400*
010500     PERFORM MB60PD-INIT-STD-MAP-LINES
010600                                 THRU MB60PD-ISML-EXIT.
010700*
010800****************************************************************
010900*    READ THE ORGANIZATION FILE RECORD                         *
011000****************************************************************
011100*
011200     MOVE 'FC01'                 TO MBCA-PROGRAM-LOCATION.
011300     MOVE MBCA-MERCHANT-ORG      TO MBIOWS-MMOC-ORG.
011400     SET MBIORO-READ-RANDOM      TO TRUE.
011500     PERFORM MMOCAO-ACCESS       THRU MMOCAO-ACCESS-EXIT.
011600/
011700 1100-BUILD-SCREEN.
011800*
011900****************************************************************
012000*    BUILD THE MAP FROM THE ORGANIZATION RECORD                *
012100****************************************************************
012200*
012300     MOVE MMOC-NA-LINE (1 1)     TO MO04-ORG-NAME.
012400     MOVE MMOC-BILLING-ORG       TO MO04-STORE-ORG.
012500     MOVE MMOC-BILLING-STORE     TO MO04-STORE.
012600     PERFORM
012700         VARYING X-MMOC-ACH-DESC
012800         FROM 1 BY 1
012900         UNTIL X-MMOC-ACH-DESC IS GREATER THAN 12
013000         SET X-MMOC-BILLING      TO X-MMOC-ACH-DESC
013100         SET X-MO04-TRANS        TO X-MMOC-ACH-DESC
013200         MOVE MMOC-ACH-DR-DESC (X-MMOC-ACH-DESC)
013300                                 TO MO04-ACH-DR-DESC
013400                                    (X-MO04-TRANS)
013500         MOVE MMOC-ACH-CR-DESC (X-MMOC-ACH-DESC)
013600                                 TO MO04-ACH-CR-DESC
013700                                    (X-MO04-TRANS)
013800         EVALUATE TRUE
013900           WHEN X-MMOC-ACH-DESC IS GREATER THAN 10
014000             CONTINUE
014100           WHEN OTHER
014200             SET X-MMOC-SD       TO X-MMOC-ACH-DESC
014300             MOVE MMOC-STMT-DETAIL (X-MMOC-SD)
014400                                 TO MO04-STMT-FLAG (X-MO04-TRANS)
014500         END-EVALUATE
014600         MOVE MMOC-BILLING-DR-TC (X-MMOC-BILLING)
014700                                 TO
014800                                 MO04-DR-TRAN-CODE (X-MO04-TRANS)
014900         MOVE MMOC-BILLING-CR-TC (X-MMOC-BILLING)
015000                                 TO
015100                                 MO04-CR-TRAN-CODE (X-MO04-TRANS)
015200         MOVE MMOC-BILLING-PLAN (X-MMOC-BILLING)
015300                                 TO MO04-PLAN (X-MO04-TRANS)
015400     END-PERFORM.
015500/
015600****************************************************************
015700*    IF INQUIRY, DARKEN PARENS AND ASKIP FIELDS                *
015800****************************************************************
015900*
016000     MOVE SS08WS-CURSOR          TO MO04-ACH-DR-DESC-L (1).
016100*
016200     IF  MBCA-PTI-FUNCTION-IS-INQUIRY
016300         MOVE SS08WS-CURSOR      TO MO04-ALT-TRANID-L
016400         MOVE DFHBMASB           TO MO04-STORE-A
016500                                    MO04-STORE-ORG-A
016600         MOVE DFHBMDAS           TO MO04-STORE-LP-A
016700                                    MO04-STORE-RP-A
016800                                    MO04-STORE-ORG-LP-A
016900                                    MO04-STORE-ORG-RP-A
017000         PERFORM
017100             VARYING X-MO04-TRANS
017200             FROM 1 BY 1
017300             UNTIL X-MO04-TRANS IS GREATER THAN 12
017400             MOVE DFHBMASB       TO MO04-ACH-DR-DESC-A
017500                                    (X-MO04-TRANS)
017600                                    MO04-ACH-CR-DESC-A
017700                                    (X-MO04-TRANS)
017800                                    MO04-STMT-FLAG-A
017900                                    (X-MO04-TRANS)
018000                                    MO04-DR-TRAN-CODE-A
018100                                    (X-MO04-TRANS)
018200                                    MO04-CR-TRAN-CODE-A
018300                                    (X-MO04-TRANS)
018400                                    MO04-PLAN-A (X-MO04-TRANS)
018500             MOVE DFHBMDAS       TO MO04-ACH-DR-DESC-LP-A
018600                                    (X-MO04-TRANS)
018700                                    MO04-ACH-DR-DESC-RP-A
018800                                    (X-MO04-TRANS)
018900                                    MO04-ACH-CR-DESC-LP-A
019000                                    (X-MO04-TRANS)
019100                                    MO04-ACH-CR-DESC-RP-A
019200                                    (X-MO04-TRANS)
019300                                    MO04-STMT-FLAG-LP-A
019400                                    (X-MO04-TRANS)
019500                                    MO04-STMT-FLAG-RP-A
019600                                    (X-MO04-TRANS)
019700                                    MO04-DR-TRAN-CODE-LP-A
019800                                    (X-MO04-TRANS)
019900                                    MO04-DR-TRAN-CODE-RP-A
020000                                    (X-MO04-TRANS)
020100                                    MO04-CR-TRAN-CODE-LP-A
020200                                    (X-MO04-TRANS)
020300                                    MO04-CR-TRAN-CODE-RP-A
020400                                    (X-MO04-TRANS)
020500                                    MO04-PLAN-LP-A (X-MO04-TRANS)
020600                                    MO04-PLAN-RP-A (X-MO04-TRANS)
020700             EVALUATE TRUE
020800                 WHEN X-MO04-TRANS IS EQUAL TO 1
020900                     MOVE DFHBMDAS
021000                                 TO MO04-STMT-FLAG-A
021100                                    (X-MO04-TRANS)
021200                                    MO04-STMT-FLAG-LP-A
021300                                    (X-MO04-TRANS)
021400                                    MO04-STMT-FLAG-RP-A
021500                                    (X-MO04-TRANS)
021600                                    MO04-DR-TRAN-CODE-A
021700                                    (X-MO04-TRANS)
021800                                    MO04-DR-TRAN-CODE-LP-A
021900                                    (X-MO04-TRANS)
022000                                    MO04-DR-TRAN-CODE-RP-A
022100                                    (X-MO04-TRANS)
022200                                    MO04-CR-TRAN-CODE-A
022300                                    (X-MO04-TRANS)
022400                                    MO04-CR-TRAN-CODE-LP-A
022500                                    (X-MO04-TRANS)
022600                                    MO04-CR-TRAN-CODE-RP-A
022700                                    (X-MO04-TRANS)
022800                                    MO04-PLAN-A (X-MO04-TRANS)
022900                                    MO04-PLAN-LP-A (X-MO04-TRANS)
023000                                    MO04-PLAN-RP-A (X-MO04-TRANS)
023100                 WHEN X-MO04-TRANS IS EQUAL TO 2
023200                     MOVE DFHBMDAS
023300                                 TO MO04-CR-TRAN-CODE-A
023400                                    (X-MO04-TRANS)
023500                                    MO04-CR-TRAN-CODE-LP-A
023600                                    (X-MO04-TRANS)
023700                                    MO04-CR-TRAN-CODE-RP-A
023800                                    (X-MO04-TRANS)
023900                 WHEN X-MO04-TRANS IS EQUAL TO 8
024000                     MOVE DFHBMDAS
024100                                 TO MO04-CR-TRAN-CODE-A
024200                                    (X-MO04-TRANS)
024300                                    MO04-CR-TRAN-CODE-LP-A
024400                                    (X-MO04-TRANS)
024500                                    MO04-CR-TRAN-CODE-RP-A
024600                                    (X-MO04-TRANS)
024700                                    MO04-ACH-CR-DESC-A
024800                                    (X-MO04-TRANS)
024900                                    MO04-ACH-CR-DESC-LP-A
025000                                    (X-MO04-TRANS)
025100                                    MO04-ACH-CR-DESC-RP-A
025200                                    (X-MO04-TRANS)
025300                 WHEN X-MO04-TRANS IS EQUAL TO 10
025400                     MOVE DFHBMDAS
025500                                 TO MO04-DR-TRAN-CODE-A
025600                                    (X-MO04-TRANS)
025700                                    MO04-DR-TRAN-CODE-LP-A
025800                                    (X-MO04-TRANS)
025900                                    MO04-DR-TRAN-CODE-RP-A
026000                                    (X-MO04-TRANS)
026100                                    MO04-ACH-DR-DESC-A
026200                                    (X-MO04-TRANS)
026300                                    MO04-ACH-DR-DESC-LP-A
026400                                    (X-MO04-TRANS)
026500                                    MO04-ACH-DR-DESC-RP-A
026600                                    (X-MO04-TRANS)
026700                 WHEN X-MO04-TRANS IS EQUAL TO 11
026800                     MOVE DFHBMDAS
026900                                 TO MO04-CR-TRAN-CODE-A
027000                                    (X-MO04-TRANS)
027100                                    MO04-CR-TRAN-CODE-LP-A
027200                                    (X-MO04-TRANS)
027300                                    MO04-CR-TRAN-CODE-RP-A
027400                                    (X-MO04-TRANS)
027500                                    MO04-ACH-CR-DESC-A
027600                                    (X-MO04-TRANS)
027700                                    MO04-ACH-CR-DESC-LP-A
027800                                    (X-MO04-TRANS)
027900                                    MO04-ACH-CR-DESC-RP-A
028000                                    (X-MO04-TRANS)
028100                                    MO04-STMT-FLAG-A
028200                                    (X-MO04-TRANS)
028300                                    MO04-STMT-FLAG-LP-A
028400                                    (X-MO04-TRANS)
028500                                    MO04-STMT-FLAG-RP-A
028600                                    (X-MO04-TRANS)
028700                 WHEN X-MO04-TRANS IS EQUAL TO 12
028800                     MOVE DFHBMDAS
028900                                 TO MO04-CR-TRAN-CODE-A
029000                                    (X-MO04-TRANS)
029100                                    MO04-CR-TRAN-CODE-LP-A
029200                                    (X-MO04-TRANS)
029300                                    MO04-CR-TRAN-CODE-RP-A
029400                                    (X-MO04-TRANS)
029500                                    MO04-DR-TRAN-CODE-A
029600                                    (X-MO04-TRANS)
029700                                    MO04-DR-TRAN-CODE-LP-A
029800                                    (X-MO04-TRANS)
029900                                    MO04-DR-TRAN-CODE-RP-A
030000                                    (X-MO04-TRANS)
030100                                    MO04-ACH-CR-DESC-A
030200                                    (X-MO04-TRANS)
030300                                    MO04-ACH-CR-DESC-LP-A
030400                                    (X-MO04-TRANS)
030500                                    MO04-ACH-CR-DESC-RP-A
030600                                    (X-MO04-TRANS)
030700                                    MO04-STMT-FLAG-A
030800                                    (X-MO04-TRANS)
030900                                    MO04-STMT-FLAG-LP-A
031000                                    (X-MO04-TRANS)
031100                                    MO04-STMT-FLAG-RP-A
031200                                    (X-MO04-TRANS)
031300                                    MO04-PLAN-A (X-MO04-TRANS)
031400                                    MO04-PLAN-LP-A (X-MO04-TRANS)
031500                                    MO04-PLAN-RP-A (X-MO04-TRANS)
031600             END-EVALUATE
031700         END-PERFORM.
031800*
031900     IF  MBCA-PTI-FUNCTION-ADD-OR-MAINT
032000         PERFORM
032100             VARYING X-MO04-TRANS
032200             FROM 1 BY 1
032300             UNTIL X-MO04-TRANS IS GREATER THAN 12
032400             EVALUATE TRUE
032500                 WHEN X-MO04-TRANS IS EQUAL TO 1
032600                     MOVE DFHBMDAS
032700                                 TO MO04-STMT-FLAG-A
032800                                    (X-MO04-TRANS)
032900                                    MO04-STMT-FLAG-LP-A
033000                                    (X-MO04-TRANS)
033100                                    MO04-STMT-FLAG-RP-A
033200                                    (X-MO04-TRANS)
033300                                    MO04-DR-TRAN-CODE-A
033400                                    (X-MO04-TRANS)
033500                                    MO04-DR-TRAN-CODE-LP-A
033600                                    (X-MO04-TRANS)
033700                                    MO04-DR-TRAN-CODE-RP-A
033800                                    (X-MO04-TRANS)
033900                                    MO04-CR-TRAN-CODE-A
034000                                    (X-MO04-TRANS)
034100                                    MO04-CR-TRAN-CODE-LP-A
034200                                    (X-MO04-TRANS)
034300                                    MO04-CR-TRAN-CODE-RP-A
034400                                    (X-MO04-TRANS)
034500                                    MO04-PLAN-A (X-MO04-TRANS)
034600                                    MO04-PLAN-LP-A (X-MO04-TRANS)
034700                                    MO04-PLAN-RP-A (X-MO04-TRANS)
034800                 WHEN X-MO04-TRANS IS EQUAL TO 2
034900                     MOVE DFHBMDAS
035000                                 TO MO04-CR-TRAN-CODE-A
035100                                    (X-MO04-TRANS)
035200                                    MO04-CR-TRAN-CODE-LP-A
035300                                    (X-MO04-TRANS)
035400                                    MO04-CR-TRAN-CODE-RP-A
035500                                    (X-MO04-TRANS)
035600                 WHEN X-MO04-TRANS IS EQUAL TO 8
035700                     MOVE DFHBMDAS
035800                                 TO MO04-CR-TRAN-CODE-A
035900                                    (X-MO04-TRANS)
036000                                    MO04-CR-TRAN-CODE-LP-A
036100                                    (X-MO04-TRANS)
036200                                    MO04-CR-TRAN-CODE-RP-A
036300                                    (X-MO04-TRANS)
036400                                    MO04-ACH-CR-DESC-A
036500                                    (X-MO04-TRANS)
036600                                    MO04-ACH-CR-DESC-LP-A
036700                                    (X-MO04-TRANS)
036800                                    MO04-ACH-CR-DESC-RP-A
036900                                    (X-MO04-TRANS)
037000                 WHEN X-MO04-TRANS IS EQUAL TO 10
037100                     MOVE DFHBMDAS
037200                                 TO MO04-DR-TRAN-CODE-A
037300                                    (X-MO04-TRANS)
037400                                    MO04-DR-TRAN-CODE-LP-A
037500                                    (X-MO04-TRANS)
037600                                    MO04-DR-TRAN-CODE-RP-A
037700                                    (X-MO04-TRANS)
037800                                    MO04-ACH-DR-DESC-A
037900                                    (X-MO04-TRANS)
038000                                    MO04-ACH-DR-DESC-LP-A
038100                                    (X-MO04-TRANS)
038200                                    MO04-ACH-DR-DESC-RP-A
038300                                    (X-MO04-TRANS)
038400                 WHEN X-MO04-TRANS IS EQUAL TO 11
038500                     MOVE DFHBMDAS
038600                                 TO MO04-CR-TRAN-CODE-A
038700                                    (X-MO04-TRANS)
038800                                    MO04-CR-TRAN-CODE-LP-A
038900                                    (X-MO04-TRANS)
039000                                    MO04-CR-TRAN-CODE-RP-A
039100                                    (X-MO04-TRANS)
039200                                    MO04-ACH-CR-DESC-A
039300                                    (X-MO04-TRANS)
039400                                    MO04-ACH-CR-DESC-LP-A
039500                                    (X-MO04-TRANS)
039600                                    MO04-ACH-CR-DESC-RP-A
039700                                    (X-MO04-TRANS)
039800                                    MO04-STMT-FLAG-A
039900                                    (X-MO04-TRANS)
040000                                    MO04-STMT-FLAG-LP-A
040100                                    (X-MO04-TRANS)
040200                                    MO04-STMT-FLAG-RP-A
040300                                    (X-MO04-TRANS)
040400                 WHEN X-MO04-TRANS IS EQUAL TO 12
040500                     MOVE DFHBMDAS
040600                                 TO MO04-CR-TRAN-CODE-A
040700                                    (X-MO04-TRANS)
040800                                    MO04-CR-TRAN-CODE-LP-A
040900                                    (X-MO04-TRANS)
041000                                    MO04-CR-TRAN-CODE-RP-A
041100                                    (X-MO04-TRANS)
041200                                    MO04-DR-TRAN-CODE-A
041300                                    (X-MO04-TRANS)
041400                                    MO04-DR-TRAN-CODE-LP-A
041500                                    (X-MO04-TRANS)
041600                                    MO04-DR-TRAN-CODE-RP-A
041700                                    (X-MO04-TRANS)
041800                                    MO04-ACH-CR-DESC-A
041900                                    (X-MO04-TRANS)
042000                                    MO04-ACH-CR-DESC-LP-A
042100                                    (X-MO04-TRANS)
042200                                    MO04-ACH-CR-DESC-RP-A
042300                                    (X-MO04-TRANS)
042400                                    MO04-STMT-FLAG-A
042500                                    (X-MO04-TRANS)
042600                                    MO04-STMT-FLAG-LP-A
042700                                    (X-MO04-TRANS)
042800                                    MO04-STMT-FLAG-RP-A
042900                                    (X-MO04-TRANS)
043000                                    MO04-PLAN-A (X-MO04-TRANS)
043100                                    MO04-PLAN-LP-A (X-MO04-TRANS)
043200                                    MO04-PLAN-RP-A (X-MO04-TRANS)
043300             END-EVALUATE
043400         END-PERFORM.
043500*
043600     IF  MBCA-PTI-FUNCTION-IS-ADD
043700         MOVE DFHBMDAS           TO MO04-STORE-LIT-A
043800                                    MO04-STORE-A
043900                                    MO04-STORE-LP-A
044000                                    MO04-STORE-RP-A
044100                                    MO04-STORE-ORG-A
044200                                    MO04-STORE-ORG-LP-A
044300                                    MO04-STORE-ORG-RP-A
044400         PERFORM
044500             VARYING X-MO04-TRANS
044600             FROM 1 BY 1
044700             UNTIL X-MO04-TRANS IS GREATER THAN 12
044800             MOVE DFHBMDAS       TO MO04-DR-TRAN-CODE-A
044900                                    (X-MO04-TRANS)
045000                                    MO04-DR-TRAN-CODE-LP-A
045100                                    (X-MO04-TRANS)
045200                                    MO04-DR-TRAN-CODE-RP-A
045300                                    (X-MO04-TRANS)
045400                                    MO04-CR-TRAN-CODE-A
045500                                    (X-MO04-TRANS)
045600                                    MO04-CR-TRAN-CODE-LP-A
045700                                    (X-MO04-TRANS)
045800                                    MO04-CR-TRAN-CODE-RP-A
045900                                    (X-MO04-TRANS)
046000                                    MO04-PLAN-A (X-MO04-TRANS)
046100                                    MO04-PLAN-LP-A (X-MO04-TRANS)
046200                                    MO04-PLAN-RP-A (X-MO04-TRANS)
046300         END-PERFORM.
046400****************************************************************
046500*    SEND THE MAP                                              *
046600****************************************************************
046700*
046800     MOVE 'BM01'                 TO MBCA-PROGRAM-LOCATION.
046900     PERFORM MB60PD-SEND-MAP-WITH-ERASE
047000                                 THRU MB60PD-SMWE-EXIT.
047100*
047200****************************************************************
047300*    RETURN TO CICS                                            *
047400****************************************************************
047500*
047600     MOVE 'PC02'                 TO MBCA-PROGRAM-LOCATION.
047700     PERFORM MB70PD-RETURN-TRANS-ID
047800                                 THRU MB70PD-RTI-EXIT.
047900/
048000 2000-RECEIVE-SCREEN SECTION.
048100*
048200****************************************************************
048300*    THIS SECTION RECEIVES THE 04 SCREEN                       *
048400****************************************************************
048500*
048600     MOVE 'BM02'                 TO MBCA-PROGRAM-LOCATION.
048700     PERFORM MB60PD-RECEIVE-MAP  THRU MB60PD-RM-EXIT.
048800*
048900****************************************************************
049000*    CHECK FOR ANOTHER TRANSACTION ID ENTERED BY THE USER      *
049100****************************************************************
049200*
049300     MOVE 'PC03'                 TO MBCA-PROGRAM-LOCATION.
049400     PERFORM MB60PD-NEW-TRANS-ROUTINE
049500                                 THRU MB60PD-NTR-EXIT.
049600*
049700****************************************************************
049800*    BYPASS EDITS ON INQUIRY                                   *
049900****************************************************************
050000*
050100     IF  MBCA-PTI-FUNCTION-IS-INQUIRY
050200         GO TO 2600-SETUP-COMMAREA.
050300*
050400****************************************************************
050500*    READ THE ORGANIZATION FILE RECORD                         *
050600****************************************************************
050700*
050800     MOVE 'FC02'                 TO MBCA-PROGRAM-LOCATION.
050900     MOVE MBCA-MERCHANT-ORG      TO MBIOWS-MMOC-ORG.
051000     SET MBIORO-READ-RANDOM      TO TRUE.
051100     PERFORM MMOCAO-ACCESS       THRU MMOCAO-ACCESS-EXIT.
051200*
051300****************************************************************
051400*    EDIT FIELDS                                               *
051500****************************************************************
051600*
051700*            ***** ACH DEBIT DESCRIPTION *****             *
051800*
051900     PERFORM
052000         VARYING X-MO04-TRANS
052100         FROM 1 BY 1
052200         UNTIL X-MO04-TRANS IS GREATER THAN 12
052300         SET X-MMOC-ACH-DESC     TO X-MO04-TRANS
052400         EVALUATE TRUE
052500             WHEN X-MO04-TRANS IS EQUAL TO 10
052600                 CONTINUE
052700             WHEN OTHER
052800             IF  MO04-ACH-DR-DESC-L (X-MO04-TRANS) IS LESS THAN 1
052900                 MOVE DFHBMASK   TO MO04-ACH-DR-DESC-A
053000                                    (X-MO04-TRANS)
053100                 MOVE DFHBMDAS   TO MO04-ACH-DR-DESC-LP-A
053200                                    (X-MO04-TRANS)
053300                                    MO04-ACH-DR-DESC-RP-A
053400                                    (X-MO04-TRANS)
053500                 MOVE MMOC-ACH-DR-DESC (X-MMOC-ACH-DESC)
053600                                 TO MO04-ACH-DR-DESC
053700                                    (X-MO04-TRANS)
053800             ELSE
053900                 MOVE DFHBMASF   TO MO04-ACH-DR-DESC-A
054000                                    (X-MO04-TRANS)
054100                 MOVE DFHBMDAS   TO MO04-ACH-DR-DESC-LP-A
054200                                    (X-MO04-TRANS)
054300                                    MO04-ACH-DR-DESC-RP-A
054400                                    (X-MO04-TRANS)
054500                 SET WS-UPDATE-SW-YES
054600                                 TO TRUE
054700             END-IF
054800         END-EVALUATE
054900     END-PERFORM.
055000*
055100*            ***** ACH CREDIT DESCRIPTION *****             *
055200*
055300     PERFORM
055400         VARYING X-MO04-TRANS
055500         FROM 1 BY 1
055600         UNTIL X-MO04-TRANS IS GREATER THAN 12
055700         SET X-MMOC-ACH-DESC     TO X-MO04-TRANS
055800         EVALUATE TRUE
055900             WHEN X-MO04-TRANS IS EQUAL TO 8
056000                 CONTINUE
056100             WHEN X-MO04-TRANS IS EQUAL TO 11
056200                 CONTINUE
056300             WHEN X-MO04-TRANS IS EQUAL TO 12
056400                 CONTINUE
056500             WHEN OTHER
056600             IF  MO04-ACH-CR-DESC-L (X-MO04-TRANS) IS LESS THAN 1
056700                 MOVE DFHBMASK   TO MO04-ACH-CR-DESC-A
056800                                    (X-MO04-TRANS)
056900                 MOVE DFHBMDAS   TO MO04-ACH-CR-DESC-LP-A
057000                                    (X-MO04-TRANS)
057100                                    MO04-ACH-CR-DESC-RP-A
057200                                    (X-MO04-TRANS)
057300                 MOVE MMOC-ACH-CR-DESC (X-MMOC-ACH-DESC)
057400                                 TO MO04-ACH-CR-DESC
057500                                    (X-MO04-TRANS)
057600             ELSE
057700                 MOVE DFHBMASF   TO MO04-ACH-CR-DESC-A
057800                                    (X-MO04-TRANS)
057900                 MOVE DFHBMDAS   TO MO04-ACH-CR-DESC-LP-A
058000                                    (X-MO04-TRANS)
058100                                    MO04-ACH-CR-DESC-RP-A
058200                                    (X-MO04-TRANS)
058300                 SET WS-UPDATE-SW-YES
058400                                 TO TRUE
058500             END-IF
058600         END-EVALUATE
058700     END-PERFORM.
058800*
058900*            ***** STATEMENT FLAG  *****                  *
059000*
059100     PERFORM
059200         VARYING X-MO04-TRANS
059300         FROM 1 BY 1
059400         UNTIL X-MO04-TRANS IS GREATER THAN 12
059500         SET X-MMOC-SD           TO X-MO04-TRANS
059600         EVALUATE TRUE
059700             WHEN X-MO04-TRANS IS EQUAL TO 1
059800                 CONTINUE
059900             WHEN X-MO04-TRANS IS EQUAL TO 11
060000                 CONTINUE
060100             WHEN X-MO04-TRANS IS EQUAL TO 12
060200                 CONTINUE
060300             WHEN OTHER
060400             IF  MO04-STMT-FLAG-L (X-MO04-TRANS) IS LESS THAN 1
060500                 MOVE DFHBMASK   TO MO04-STMT-FLAG-A
060600                                    (X-MO04-TRANS)
060700                 MOVE DFHBMDAS   TO MO04-STMT-FLAG-LP-A
060800                                    (X-MO04-TRANS)
060900                                    MO04-STMT-FLAG-RP-A
061000                                    (X-MO04-TRANS)
061100                 MOVE MMOC-STMT-DETAIL (X-MMOC-SD)
061200                                 TO MO04-STMT-FLAG
061300                                    (X-MO04-TRANS)
061400             ELSE
061500                 IF  MO04-STMT-FLAG-VALID (X-MO04-TRANS)
061600                     MOVE DFHBMASF
061700                                 TO MO04-STMT-FLAG-A
061800                                    (X-MO04-TRANS)
061900                     MOVE DFHBMDAS
062000                                 TO MO04-STMT-FLAG-LP-A
062100                                    (X-MO04-TRANS)
062200                                    MO04-STMT-FLAG-RP-A
062300                                    (X-MO04-TRANS)
062400                     SET WS-UPDATE-SW-YES
062500                                 TO TRUE
062600                 ELSE
062700                     MOVE DFHBMUBF
062800                                 TO MO04-STMT-FLAG-A
062900                                    (X-MO04-TRANS)
063000                     MOVE DFHBMASB
063100                                 TO MO04-STMT-FLAG-LP-A
063200                                    (X-MO04-TRANS)
063300                                    MO04-STMT-FLAG-RP-A
063400                                    (X-MO04-TRANS)
063500                     MOVE SS08WS-CURSOR
063600                                 TO MO04-STMT-FLAG-L
063700                                    (X-MO04-TRANS)
063800                     SET SS08WS-ERROR-SW-YES TO TRUE
063900                 END-IF
064000             END-IF
064100         END-EVALUATE
064200     END-PERFORM.
064300*
064400*            ***** BILLING DEBIT TRAN CODE *****              *
064500*
064600     PERFORM
064700         VARYING X-MO04-TRANS
064800         FROM 1 BY 1
064900         UNTIL X-MO04-TRANS IS GREATER THAN 12
065000         SET X-MMOC-BILLING      TO X-MO04-TRANS
065100         EVALUATE TRUE
065200             WHEN X-MO04-TRANS IS EQUAL TO 1
065300                 CONTINUE
065400             WHEN X-MO04-TRANS IS EQUAL TO 10
065500                 CONTINUE
065600             WHEN X-MO04-TRANS IS EQUAL TO 12
065700                 CONTINUE
065800             WHEN OTHER
065900                 IF  MO04-DR-TRAN-CODE-L (X-MO04-TRANS)
066000                     IS LESS THAN 1
066100                     MOVE DFHBMASK
066200                                 TO MO04-DR-TRAN-CODE-A
066300                                    (X-MO04-TRANS)
066400                     MOVE DFHBMDAS
066500                                 TO MO04-DR-TRAN-CODE-LP-A
066600                                    (X-MO04-TRANS)
066700                                    MO04-DR-TRAN-CODE-RP-A
066800                                    (X-MO04-TRANS)
066900                     MOVE MMOC-BILLING-DR-TC (X-MMOC-BILLING)
067000                                 TO MO04-DR-TRAN-CODE
067100                                    (X-MO04-TRANS)
067200                 ELSE
067300                     IF  MO04-DR-TRAN-CODE (X-MO04-TRANS)
067400                                 IS NUMERIC
067500                         MOVE DFHBMASF
067600                                 TO MO04-DR-TRAN-CODE-A
067700                                    (X-MO04-TRANS)
067800                         MOVE DFHBMDAS
067900                                 TO MO04-DR-TRAN-CODE-LP-A
068000                                    (X-MO04-TRANS)
068100                                    MO04-DR-TRAN-CODE-RP-A
068200                                    (X-MO04-TRANS)
068300                         SET WS-UPDATE-SW-YES
068400                                 TO TRUE
068500                     ELSE
068600                         MOVE DFHBMNBF
068700                                 TO MO04-DR-TRAN-CODE-A
068800                                    (X-MO04-TRANS)
068900                         MOVE DFHBMASB
069000                                 TO MO04-DR-TRAN-CODE-LP-A
069100                                    (X-MO04-TRANS)
069200                                    MO04-DR-TRAN-CODE-RP-A
069300                                    (X-MO04-TRANS)
069400                         MOVE SS08WS-CURSOR
069500                                 TO MO04-DR-TRAN-CODE-L
069600                                    (X-MO04-TRANS)
069700                         SET SS08WS-ERROR-SW-YES
069800                                 TO TRUE
069900                     END-IF
070000                 END-IF
070100         END-EVALUATE
070200     END-PERFORM.
070300*
070400*            ***** BILLING CREDIT TRAN CODE *****              *
070500*
070600     PERFORM
070700         VARYING X-MO04-TRANS
070800         FROM 1 BY 1
070900         UNTIL X-MO04-TRANS IS GREATER THAN 12
071000         SET X-MMOC-BILLING      TO X-MO04-TRANS
071100         EVALUATE TRUE
071200             WHEN X-MO04-TRANS IS EQUAL TO 1
071300                 CONTINUE
071400             WHEN X-MO04-TRANS IS EQUAL TO 2
071500                 CONTINUE
071600             WHEN X-MO04-TRANS IS EQUAL TO 8
071700                 CONTINUE
071800             WHEN X-MO04-TRANS IS EQUAL TO 11
071900                 CONTINUE
072000             WHEN X-MO04-TRANS IS EQUAL TO 12
072100                 CONTINUE
072200             WHEN OTHER
072300                 IF  MO04-CR-TRAN-CODE-L (X-MO04-TRANS)
072400                     IS LESS THAN 1
072500                     MOVE DFHBMASK
072600                                 TO MO04-CR-TRAN-CODE-A
072700                                    (X-MO04-TRANS)
072800                     MOVE DFHBMDAS
072900                                 TO MO04-CR-TRAN-CODE-LP-A
073000                                    (X-MO04-TRANS)
073100                                    MO04-CR-TRAN-CODE-RP-A
073200                                    (X-MO04-TRANS)
073300                     MOVE MMOC-BILLING-CR-TC (X-MMOC-BILLING)
073400                                 TO MO04-CR-TRAN-CODE
073500                                    (X-MO04-TRANS)
073600                 ELSE
073700                     IF  MO04-CR-TRAN-CODE (X-MO04-TRANS)
073800                                 IS NUMERIC
073900                         MOVE DFHBMASF
074000                                 TO MO04-CR-TRAN-CODE-A
074100                                    (X-MO04-TRANS)
074200                         MOVE DFHBMDAS
074300                                 TO MO04-CR-TRAN-CODE-LP-A
074400                                    (X-MO04-TRANS)
074500                                    MO04-CR-TRAN-CODE-RP-A
074600                                    (X-MO04-TRANS)
074700                         SET WS-UPDATE-SW-YES
074800                                 TO TRUE
074900                     ELSE
075000                         MOVE DFHBMNBF
075100                                 TO MO04-CR-TRAN-CODE-A
075200                                    (X-MO04-TRANS)
075300                         MOVE DFHBMASB
075400                                 TO MO04-CR-TRAN-CODE-LP-A
075500                                    (X-MO04-TRANS)
075600                                    MO04-CR-TRAN-CODE-RP-A
075700                                    (X-MO04-TRANS)
075800                         MOVE SS08WS-CURSOR
075900                                 TO MO04-CR-TRAN-CODE-L
076000                                    (X-MO04-TRANS)
076100                         SET SS08WS-ERROR-SW-YES
076200                                 TO TRUE
076300                    END-IF
076400                 END-IF
076500         END-EVALUATE
076600     END-PERFORM.
076700*
076800*            ***** BILLING PLAN *****                           *
076900*
077000     PERFORM
077100         VARYING X-MO04-TRANS
077200         FROM 1 BY 1
077300         UNTIL X-MO04-TRANS IS GREATER THAN 12
077400         SET X-MMOC-BILLING      TO X-MO04-TRANS
077500         EVALUATE TRUE
077600             WHEN X-MO04-TRANS IS EQUAL TO 1
077700                 CONTINUE
077800             WHEN X-MO04-TRANS IS EQUAL TO 12
077900                 CONTINUE
078000             WHEN OTHER
078100                 IF  MO04-PLAN-L (X-MO04-TRANS)
078200                     IS LESS THAN 1
078300                     MOVE DFHBMASK
078400                                 TO MO04-PLAN-A
078500                                    (X-MO04-TRANS)
078600                     MOVE DFHBMDAS
078700                                 TO MO04-PLAN-LP-A
078800                                    (X-MO04-TRANS)
078900                                    MO04-PLAN-RP-A
079000                                    (X-MO04-TRANS)
079100                     MOVE MMOC-BILLING-PLAN (X-MMOC-BILLING)
079200                                 TO MO04-PLAN
079300                                    (X-MO04-TRANS)
079400                 ELSE
079500                     IF  MO04-PLAN (X-MO04-TRANS) IS NUMERIC
079600                         MOVE DFHBMASF
079700                                 TO MO04-PLAN-A
079800                                    (X-MO04-TRANS)
079900                         MOVE DFHBMDAS
080000                                 TO MO04-PLAN-LP-A
080100                                    (X-MO04-TRANS)
080200                                    MO04-PLAN-RP-A
080300                                    (X-MO04-TRANS)
080400                         SET WS-UPDATE-SW-YES
080500                                 TO TRUE
080600                     ELSE
080700                         MOVE DFHBMNBF
080800                                 TO MO04-PLAN-A
080900                                    (X-MO04-TRANS)
081000                         MOVE DFHBMASB
081100                                 TO MO04-PLAN-LP-A
081200                                    (X-MO04-TRANS)
081300                                    MO04-PLAN-RP-A
081400                                    (X-MO04-TRANS)
081500                         MOVE SS08WS-CURSOR
081600                                 TO MO04-PLAN-L
081700                                    (X-MO04-TRANS)
081800                         SET SS08WS-ERROR-SW-YES
081900                                 TO TRUE
082000                   END-IF
082100                 END-IF
082200         END-EVALUATE
082300     END-PERFORM.
082400*
082500*            ***** STORE ORG NUMBER *****                       *
082600*
082700     IF  MO04-STORE-ORG-L IS LESS THAN 1
082800         MOVE DFHBMASK           TO MO04-STORE-ORG-A
082900         MOVE DFHBMDAS           TO MO04-STORE-ORG-LP-A
083000                                    MO04-STORE-ORG-RP-A
083100         MOVE MMOC-BILLING-ORG   TO MO04-STORE-ORG
083200     ELSE
083300        IF  MO04-STORE-ORG IS NUMERIC
083400            MOVE DFHBMASF        TO MO04-STORE-ORG-A
083500            MOVE DFHBMDAS        TO MO04-STORE-ORG-LP-A
083600                                    MO04-STORE-ORG-RP-A
083700            SET WS-UPDATE-SW-YES TO TRUE
083800        ELSE
083900            MOVE DFHBMNBF        TO MO04-STORE-ORG-A
084000            MOVE DFHBMASB        TO MO04-STORE-ORG-LP-A
084100                                    MO04-STORE-ORG-RP-A
084200            MOVE SS08WS-CURSOR   TO MO04-STORE-ORG-L
084300            SET SS08WS-ERROR-SW-YES TO TRUE.
084400*
084500*            ***** STORE NUMBER *****                           *
084600*
084700     IF  MO04-STORE-L IS LESS THAN 1
084800         MOVE DFHBMASK           TO MO04-STORE-A
084900         MOVE DFHBMDAS           TO MO04-STORE-LP-A
085000                                    MO04-STORE-RP-A
085100         MOVE MMOC-BILLING-STORE TO MO04-STORE
085200     ELSE
085300        IF  MO04-STORE IS NUMERIC
085400            MOVE DFHBMASF        TO MO04-STORE-A
085500            MOVE DFHBMDAS        TO MO04-STORE-LP-A
085600                                    MO04-STORE-RP-A
085700            SET WS-UPDATE-SW-YES TO TRUE
085800        ELSE
085900            MOVE DFHBMNBF        TO MO04-STORE-A
086000            MOVE DFHBMASB        TO MO04-STORE-LP-A
086100                                    MO04-STORE-RP-A
086200            MOVE SS08WS-CURSOR   TO MO04-STORE-L
086300            SET SS08WS-ERROR-SW-YES TO TRUE.
086400*
086500     IF  MBCA-PTI-FUNCTION-IS-ADD
086600         MOVE DFHBMDAS           TO MO04-STORE-LIT-A
086700                                    MO04-STORE-A
086800                                    MO04-STORE-LP
086900                                    MO04-STORE-RP
087000                                    MO04-STORE-ORG-A
087100                                    MO04-STORE-ORG-LP
087200                                    MO04-STORE-ORG-RP
087300         PERFORM
087400             VARYING X-MO04-TRANS
087500             FROM 1 BY 1
087600             UNTIL X-MO04-TRANS IS GREATER THAN 12
087700             MOVE DFHBMDAS       TO MO04-DR-TRAN-CODE-A
087800                                    (X-MO04-TRANS)
087900                                    MO04-DR-TRAN-CODE-LP-A
088000                                    (X-MO04-TRANS)
088100                                    MO04-DR-TRAN-CODE-RP-A
088200                                    (X-MO04-TRANS)
088300                                    MO04-CR-TRAN-CODE-A
088400                                    (X-MO04-TRANS)
088500                                    MO04-CR-TRAN-CODE-LP-A
088600                                    (X-MO04-TRANS)
088700                                    MO04-CR-TRAN-CODE-RP-A
088800                                    (X-MO04-TRANS)
088900                                    MO04-PLAN-A (X-MO04-TRANS)
089000                                    MO04-PLAN-LP-A (X-MO04-TRANS)
089100                                    MO04-PLAN-RP-A (X-MO04-TRANS)
089200         END-PERFORM.
089300*
089400****************************************************************
089500***      CROSS EDITS                                           *
089600****************************************************************
089700*
089800     IF  MBCA-PTI-FUNCTION-IS-MAINT
089900         PERFORM 9100-CROSS-EDIT-STORE
090000                                    THRU 9199-CES-EXIT
090100         IF  SS08WS-ERROR-SW-NO
090200         AND MO04-STORE-ORG IS GREATER THAN ZERO
090300         AND MO04-STORE IS GREATER THAN ZERO
090400             PERFORM 9200-CROSS-EDIT-BILLING
090500                                    THRU 9299-CEB-EXIT.
090600*
090700     IF  SS08WS-ERROR-SW-NO
090800         GO TO 2400-UPDATE-FILE.
090900*
091000****************************************************************
091100*    SEND THE MAP                                              *
091200****************************************************************
091300*
091400     PERFORM MB60PD-INIT-STD-MAP-LINES
091500                                 THRU MB60PD-ISML-EXIT.
091600     MOVE 'BM03'                 TO MBCA-PROGRAM-LOCATION.
091700     PERFORM MB60PD-SEND-MAP-DATA-ONLY
091800                                 THRU MB60PD-SMDO-EXIT.
091900*
092000****************************************************************
092100*    RETURN TO CICS                                            *
092200****************************************************************
092300*
092400     MOVE 'PC04'                 TO MBCA-PROGRAM-LOCATION.
092500     MOVE 04                     TO MBCA-SCREEN-NBR.
092600     PERFORM MB70PD-RETURN-TRANS-ID
092700                                 THRU MB70PD-RTI-EXIT.
092800/
092900 2400-UPDATE-FILE.
093000*
093100     IF  WS-UPDATE-SW-NO
093200         IF  MBCA-PTI-FUNCTION-IS-ADD
093300             MOVE 'FC03'         TO MBCA-PROGRAM-LOCATION
093400             MOVE MBCA-MERCHANT-ORG
093500                                 TO MBIOWS-MMOC-ORG
093600             SET MBIORO-READ-RANDOM-UPDATE
093700                                 TO TRUE
093800             PERFORM MMOCAO-ACCESS
093900                                 THRU MMOCAO-ACCESS-EXIT
094000             MOVE MBCA-SCREEN-NBR
094100                                 TO MMOC-ONLINE-STATUS
094200             MOVE 'FC04'         TO MBCA-PROGRAM-LOCATION
094300             SET MBIORO-REWRITE  TO TRUE
094400             PERFORM MMOCAO-ACCESS
094500                                 THRU MMOCAO-ACCESS-EXIT
094600             GO TO 2600-SETUP-COMMAREA
094700         ELSE
094800             GO TO 2600-SETUP-COMMAREA.
094900*
095000****************************************************************
095100*    GETMAIN FOR LOG/JOURNAL RECORD                            *
095200****************************************************************
095300*
095400     MOVE 'SC02'                 TO MBCA-PROGRAM-LOCATION.
095500     SET MBIORO-GETMAIN          TO TRUE.
095600     PERFORM MML1AO-ACCESS       THRU MML1AO-ACCESS-EXIT.
095700*
095800****************************************************************
095900*    READ THE ORGANIZATION FILE RECORD FOR UPDATE              *
096000****************************************************************
096100*
096200     MOVE 'FC05'                 TO MBCA-PROGRAM-LOCATION.
096300     MOVE MBCA-MERCHANT-ORG      TO MBIOWS-MMOC-ORG.
096400     SET MBIORO-READ-RANDOM-UPDATE
096500                                 TO TRUE.
096600     PERFORM MMOCAO-ACCESS       THRU MMOCAO-ACCESS-EXIT.
096700*
096800*            ***** ACH DEBIT MERCHANT DESCRIPTION *****       *
096900*
097000     PERFORM
097100         VARYING X-MO04-TRANS
097200         FROM 1 BY 1
097300         UNTIL X-MO04-TRANS IS GREATER THAN 12
097400         SET X-MMOC-ACH-DESC     TO X-MO04-TRANS
097500         IF MO04-ACH-DR-DESC-L (X-MO04-TRANS)
097600                               IS GREATER THAN ZERO
097700             SET WS-INDEX        TO X-MO04-TRANS
097800             MOVE WS-INDEX       TO MML1-FIELD-OCCURRENCE
097900             MOVE 0401           TO MML1-FIELD-CODE
098000             MOVE MML1WS-VL-10   TO MML1-VARIABLE-LENGTH
098100             MOVE MMOC-ACH-DR-DESC (X-MMOC-ACH-DESC)
098200                                 TO MML1-VL10-B-DATA-X
098300             MOVE MO04-ACH-DR-DESC (X-MO04-TRANS)
098400                                 TO MMOC-ACH-DR-DESC
098500                                    (X-MMOC-ACH-DESC)
098600             MOVE MMOC-ACH-DR-DESC (X-MMOC-ACH-DESC)
098700                                 TO MML1-VL10-A-DATA-X
098800             PERFORM 9050-CREATE-MAINT-RECORD
098900                                 THRU 9099-CMR-EXIT
099000         END-IF
099100     END-PERFORM.
099200*
099300*            ***** ACH CREDIT MERCHANT DESCRIPTION *****        *
099400*
099500     PERFORM
099600         VARYING X-MO04-TRANS
099700         FROM 1 BY 1
099800         UNTIL X-MO04-TRANS IS GREATER THAN 12
099900         SET X-MMOC-ACH-DESC     TO X-MO04-TRANS
100000         IF MO04-ACH-CR-DESC-L (X-MO04-TRANS)
100100                               IS GREATER THAN ZERO
100200             SET WS-INDEX        TO X-MO04-TRANS
100300             MOVE WS-INDEX       TO MML1-FIELD-OCCURRENCE
100400             MOVE 0402           TO MML1-FIELD-CODE
100500             MOVE MML1WS-VL-10   TO MML1-VARIABLE-LENGTH
100600             MOVE MMOC-ACH-CR-DESC (X-MMOC-ACH-DESC)
100700                                 TO MML1-VL10-B-DATA-X
100800             MOVE MO04-ACH-CR-DESC (X-MO04-TRANS)
100900                                 TO MMOC-ACH-CR-DESC
101000                                    (X-MMOC-ACH-DESC)
101100             MOVE MMOC-ACH-CR-DESC (X-MMOC-ACH-DESC)
101200                                 TO MML1-VL10-A-DATA-X
101300             PERFORM 9050-CREATE-MAINT-RECORD
101400                                 THRU 9099-CMR-EXIT
101500         END-IF
101600     END-PERFORM.
101700*
101800*            ***** STATEMENT FLAG *****                        *
101900*
102000     PERFORM
102100         VARYING X-MO04-TRANS
102200         FROM 1 BY 1
102300         UNTIL X-MO04-TRANS IS GREATER THAN 12
102400         SET X-MMOC-SD           TO X-MO04-TRANS
102500         IF MO04-STMT-FLAG-L (X-MO04-TRANS)
102600                               IS GREATER THAN ZERO
102700             SET WS-INDEX        TO X-MO04-TRANS
102800             MOVE WS-INDEX       TO MML1-FIELD-OCCURRENCE
102900             MOVE 0403           TO MML1-FIELD-CODE
103000             MOVE MML1WS-VL-01   TO MML1-VARIABLE-LENGTH
103100             MOVE MMOC-STMT-DETAIL (X-MMOC-SD)
103200                                 TO MML1-VL01-B-DATA-X
103300             MOVE MO04-STMT-FLAG (X-MO04-TRANS)
103400                                 TO MMOC-STMT-DETAIL
103500                                    (X-MMOC-SD)
103600             MOVE MMOC-STMT-DETAIL (X-MMOC-SD)
103700                                 TO MML1-VL01-A-DATA-X
103800             PERFORM 9050-CREATE-MAINT-RECORD
103900                                 THRU 9099-CMR-EXIT
104000         END-IF
104100     END-PERFORM.
104200*
104300*            ***** BILLING DEBIT TRAN CODE *****               *
104400*
104500     PERFORM
104600         VARYING X-MO04-TRANS
104700         FROM 1 BY 1
104800         UNTIL X-MO04-TRANS IS GREATER THAN 12
104900         SET X-MMOC-BILLING      TO X-MO04-TRANS
105000         SET WS-INDEX            TO X-MO04-TRANS
105100         IF MO04-DR-TRAN-CODE-L (X-MO04-TRANS)
105200                               IS GREATER THAN ZERO
105300             MOVE WS-INDEX       TO MML1-FIELD-OCCURRENCE
105400             MOVE 0404           TO MML1-FIELD-CODE
105500             MOVE MML1WS-VL-03   TO MML1-VARIABLE-LENGTH
105600             MOVE MMOC-BILLING-DR-TC (X-MMOC-BILLING)
105700                                 TO MML1-VL03-B-DATA-9
105800             MOVE MO04-DR-TRAN-CODE (X-MO04-TRANS)
105900                                 TO MMOC-BILLING-DR-TC
106000                                    (X-MMOC-BILLING)
106100             MOVE MMOC-BILLING-DR-TC (X-MMOC-BILLING)
106200                                 TO MML1-VL03-A-DATA-9
106300             PERFORM 9050-CREATE-MAINT-RECORD
106400                                 THRU 9099-CMR-EXIT
106500         END-IF
106600     END-PERFORM.
106700*
106800*            ***** BILLING CREDIT TRAN CODE *****               *
106900*
107000     PERFORM
107100         VARYING X-MO04-TRANS
107200         FROM 1 BY 1
107300         UNTIL X-MO04-TRANS IS GREATER THAN 12
107400         SET X-MMOC-BILLING      TO X-MO04-TRANS
107500         SET WS-INDEX            TO X-MO04-TRANS
107600         IF MO04-CR-TRAN-CODE-L (X-MO04-TRANS)
107700                               IS GREATER THAN ZERO
107800             MOVE WS-INDEX       TO MML1-FIELD-OCCURRENCE
107900             MOVE 0405           TO MML1-FIELD-CODE
108000             MOVE MML1WS-VL-03   TO MML1-VARIABLE-LENGTH
108100             MOVE MMOC-BILLING-CR-TC (X-MMOC-BILLING)
108200                                 TO MML1-VL03-B-DATA-9
108300             MOVE MO04-CR-TRAN-CODE (X-MO04-TRANS)
108400                                 TO MMOC-BILLING-CR-TC
108500                                    (X-MMOC-BILLING)
108600             MOVE MMOC-BILLING-CR-TC (X-MMOC-BILLING)
108700                                 TO MML1-VL03-A-DATA-9
108800             PERFORM 9050-CREATE-MAINT-RECORD
108900                                 THRU 9099-CMR-EXIT
109000         END-IF
109100     END-PERFORM.
109200*
109300*            ***** BILLING PLAN  *****                       *
109400*
109500     PERFORM
109600         VARYING X-MO04-TRANS
109700         FROM 1 BY 1
109800         UNTIL X-MO04-TRANS IS GREATER THAN 12
109900         SET X-MMOC-BILLING      TO X-MO04-TRANS
110000         IF MO04-PLAN-L (X-MO04-TRANS)
110100                               IS GREATER THAN ZERO
110200             SET WS-INDEX        TO X-MO04-TRANS
110300             MOVE WS-INDEX       TO MML1-FIELD-OCCURRENCE
110400             MOVE 0406           TO MML1-FIELD-CODE
110500             MOVE MML1WS-VL-05   TO MML1-VARIABLE-LENGTH
110600             MOVE MMOC-BILLING-PLAN (X-MMOC-BILLING)
110700                                 TO MML1-VL05-B-DATA-9
110800             MOVE MO04-PLAN (X-MO04-TRANS)
110900                                 TO MMOC-BILLING-PLAN
111000                                    (X-MMOC-BILLING)
111100             MOVE MMOC-BILLING-PLAN (X-MMOC-BILLING)
111200                                 TO MML1-VL05-A-DATA-9
111300             PERFORM 9050-CREATE-MAINT-RECORD
111400                                 THRU 9099-CMR-EXIT
111500         END-IF
111600     END-PERFORM.
111700*
111800*            ***** STORE ORG NUMBER *****                    *
111900*
112000     IF  MO04-STORE-ORG-L IS GREATER THAN ZERO
112100         SET WS-INDEX            TO X-MO04-TRANS
112200         MOVE ZEROS              TO MML1-FIELD-OCCURRENCE
112300         MOVE 0408               TO MML1-FIELD-CODE
112400         MOVE MML1WS-VL-03       TO MML1-VARIABLE-LENGTH
112500         MOVE MMOC-BILLING-ORG   TO MML1-VL03-B-DATA-9
112600         MOVE MO04-STORE-ORG     TO MMOC-BILLING-ORG
112700         MOVE MMOC-BILLING-ORG   TO MML1-VL03-A-DATA-9
112800         PERFORM 9050-CREATE-MAINT-RECORD
112900                                 THRU 9099-CMR-EXIT.
113000*
113100*            ***** STORE NUMBER  *****                       *
113200*
113300     IF  MO04-STORE-L IS GREATER THAN ZERO
113400         SET WS-INDEX            TO X-MO04-TRANS
113500         MOVE ZEROS              TO MML1-FIELD-OCCURRENCE
113600         MOVE 0407               TO MML1-FIELD-CODE
113700         MOVE MML1WS-VL-10       TO MML1-VARIABLE-LENGTH
113800         MOVE MMOC-BILLING-STORE
113900                                 TO MML1-VL10-B-DATA-9
114000         MOVE MO04-STORE         TO MMOC-BILLING-STORE
114100         MOVE MMOC-BILLING-STORE
114200                                 TO MML1-VL10-A-DATA-9
114300         PERFORM 9050-CREATE-MAINT-RECORD
114400                                 THRU 9099-CMR-EXIT.
114500*
114600     IF  MBCA-PTI-FUNCTION-IS-ADD
114700         MOVE 04                 TO MMOC-ONLINE-STATUS.
114800*
114900*            ***** LAST MAINT DATE AND OPERATOR ID *****       *
115000*
115100     MOVE ZEROES                 TO MML1-FIELD-OCCURRENCE.
115200     MOVE 0199                   TO MML1-FIELD-CODE.
115300     MOVE MML1WS-VL-07           TO MML1-VARIABLE-LENGTH.
115400     MOVE MMOC-LAST-MAINT-DATE
115500                                 TO MML1-VL07-B-DATA-9.
115600     MOVE MBCA-START-DATE        TO MMOC-LAST-MAINT-DATE.
115700     MOVE MMOC-LAST-MAINT-DATE
115800                                 TO MML1-VL07-A-DATA-9.
115900     PERFORM 9050-CREATE-MAINT-RECORD
116000                                 THRU 9099-CMR-EXIT.
116100     MOVE 0198                   TO MML1-FIELD-CODE.
116200     MOVE MML1WS-VL-03           TO MML1-VARIABLE-LENGTH.
116300     MOVE MMOC-LAST-MAINT-OPER
116400                                 TO MML1-VL03-B-DATA-X.
116500     MOVE MBCA-OPERATOR-ID       TO MMOC-LAST-MAINT-OPER.
116600     MOVE MMOC-LAST-MAINT-OPER
116700                                 TO MML1-VL03-A-DATA-X.
116800     PERFORM 9050-CREATE-MAINT-RECORD
116900                                 THRU 9099-CMR-EXIT.
117000*
117100****************************************************************
117200*    UPDATE THE ORGANIZATION FILE RECORD                       *
117300****************************************************************
117400*
117500     MOVE 'FC06'                 TO MBCA-PROGRAM-LOCATION.
117600     SET MBIORO-REWRITE          TO TRUE.
117700     PERFORM MMOCAO-ACCESS       THRU MMOCAO-ACCESS-EXIT.
117800*
117900 2600-SETUP-COMMAREA.
118000*
118100****************************************************************
118200*    SET UP COMMAREA FIELDS AND TRANSFER TO THE NEXT PROGRAM   *
118300****************************************************************
118400*
118500     MOVE MBCA-EIBAID            TO SS08WS-EIBAID.
118600*
118700     PERFORM MB60PD-EDIT-PAGE-NBR
118800                                 THRU MB60PD-EPN-EXIT.
118900*
119000     IF  SS08WS-VALID-PF-KEY
119100     OR  SS08WS-EIBAID-VALID-PF-KEY
119200         SET MBCA-INITIAL-SCREEN-NBR
119300                                 TO TRUE.
119400*
119500     MOVE 'PC05'                 TO MBCA-PROGRAM-LOCATION.
119600     PERFORM MB70PD-XCTL-TO-MBOXCTL
119700                                 THRU MB70PD-XTM-EXIT.
119800/
119900 9000-PERFORMED-ROUTINES-SECT SECTION.
120000*
120100 9050-CREATE-MAINT-RECORD.
120200*
120300*****************************************************************
120400*    THIS ROUTINE WILL CREATE THE COMMON DATA FOR ALL OF THE    *
120500*    LOG/JOURNAL TRANSACTIONS                                   *
120600*****************************************************************
120700*
120800     IF  MBCA-PTI-FUNCTION-IS-ADD
120900         GO TO 9099-CMR-EXIT.
121000*
121100     MOVE 'OC'                   TO MML1-FILE-CODE.
121200     MOVE MBCA-MERCHANT-ORG      TO MML1-MMOC-ORG.
121300     MOVE MBCA-SIGNON-NAME       TO MML1-SIGNON-NAME.
121400     MOVE MBCA-TERMINAL-ID       TO MML1-TERMINAL-ID.
121500     MOVE ZEROES                 TO MML1-SOURCE-CODE
121600                                    MML1-FIELD-OCCURRENCE-2.
121700*
121800*****************************************************************
121900*    WRITE THE LOG/JOURNAL FILE RECORD                          *
122000*****************************************************************
122100*
122200     MOVE 'FC07'                 TO MBCA-PROGRAM-LOCATION.
122300     SET MBIORO-WRITE            TO TRUE.
122400     PERFORM MML1AO-ACCESS       THRU MML1AO-ACCESS-EXIT.
122500     MOVE SPACES                 TO MML1-VARIABLE-AREA.
122600*
122700 9099-CMR-EXIT.
122800     EXIT.
122900*
123000 9100-CROSS-EDIT-STORE.
123100*
123200     IF  MO04-STORE-L IS GREATER THAN ZERO
123300     OR  MO04-STORE-ORG-L IS GREATER THAN ZERO
123400         NEXT SENTENCE
123500     ELSE
123600         GO TO 9199-CES-EXIT.
123700*
123800     IF  MO04-STORE IS EQUAL TO ZEROS
123900     AND MO04-STORE-ORG IS EQUAL TO ZEROS
124000     AND MMOC-BILLING-ORG IS EQUAL TO ZEROS
124100     AND MMOC-BILLING-STORE IS EQUAL TO ZEROS
124200         GO TO 9199-CES-EXIT.
124300*
124400     MOVE 'FC08'                 TO MBCA-PROGRAM-LOCATION.
124500     MOVE MO04-STORE-ORG         TO MBIOWS-MMSM-ORG.
124600     MOVE MO04-STORE             TO MBIOWS-MMSM-STORE.
124700     MOVE SS08WS-CICS-FC-NOTFND  TO MBIORO-TEMP-STATUS-1.
124800     SET MBIORO-READ-RANDOM      TO TRUE.
124900     PERFORM MMSMAO-ACCESS       THRU MMSMAO-ACCESS-EXIT.
125000*
125100     IF  SS08WS-RC-FC-NOTFND
125200         MOVE MBEMWS-NOT-ON-FILE TO MO04-ERR-MESSAGE
125300         SET SS08WS-ERROR-SW-YES TO TRUE
125400         MOVE DFHBMNBF           TO MO04-STORE-A
125500                                    MO04-STORE-ORG-A
125600         MOVE DFHBMASB           TO MO04-STORE-LP-A
125700                                    MO04-STORE-RP-A
125800                                    MO04-STORE-ORG-LP-A
125900                                    MO04-STORE-ORG-RP-A
126000         MOVE SS08WS-CURSOR      TO MO04-STORE-ORG-L
126100         GO TO 9199-CES-EXIT
126200     ELSE
126300         IF  MMSM-ADD-PENDING
126400             MOVE MBEMWS-ADD-PENDING
126500                                 TO MO04-ERR-MESSAGE
126600             SET SS08WS-ERROR-SW-YES TO TRUE
126700             MOVE DFHBMNBF       TO MO04-STORE-A
126800                                    MO04-STORE-ORG-A
126900             MOVE DFHBMASB       TO MO04-STORE-LP-A
127000                                    MO04-STORE-RP-A
127100                                    MO04-STORE-ORG-LP-A
127200                                    MO04-STORE-ORG-RP-A
127300             MOVE SS08WS-CURSOR  TO MO04-STORE-ORG-L
127400             GO TO 9199-CES-EXIT
127500         ELSE
127600             IF  MMSM-REC-INCOMPLETE
127700             OR  MMSM-REC-PURGED
127800                 MOVE MBEMWS-NOT-ACTIVE
127900                                 TO MO04-ERR-MESSAGE
128000                 SET SS08WS-ERROR-SW-YES
128100                                 TO TRUE
128200                 MOVE DFHBMNBF   TO MO04-STORE-A
128300                                    MO04-STORE-ORG-A
128400                 MOVE DFHBMASB   TO MO04-STORE-LP-A
128500                                    MO04-STORE-RP-A
128600                                    MO04-STORE-ORG-LP-A
128700                                    MO04-STORE-ORG-RP-A
128800                 MOVE SS08WS-CURSOR TO MO04-STORE-ORG-L
128900                 GO TO 9199-CES-EXIT.
129000*
129100 9199-CES-EXIT.
129200     EXIT.
129300*
129400 9200-CROSS-EDIT-BILLING.
129500*
129600*            ***** BILLING DEBIT TRAN CODE *****              *
129700*                        CROSS EDIT                           *
129800*
129900     PERFORM
130000         VARYING X-MO04-TRANS
130100         FROM 1 BY 1
130200         UNTIL X-MO04-TRANS IS GREATER THAN 12
130300         EVALUATE TRUE
130400             WHEN X-MO04-TRANS IS EQUAL TO 1
130500                 CONTINUE
130600             WHEN X-MO04-TRANS IS EQUAL TO 10
130700                 CONTINUE
130800             WHEN X-MO04-TRANS IS EQUAL TO 12
130900                 CONTINUE
131000             WHEN OTHER
131100                 IF  MO04-DR-TRAN-CODE (X-MO04-TRANS)
131200                     IS LESS THAN 1
131300                     MOVE DFHBMNBF
131400                                 TO MO04-DR-TRAN-CODE-A
131500                                    (X-MO04-TRANS)
131600                     MOVE DFHBMASB
131700                                 TO MO04-DR-TRAN-CODE-LP-A
131800                                    (X-MO04-TRANS)
131900                                    MO04-DR-TRAN-CODE-RP-A
132000                                    (X-MO04-TRANS)
132100                     MOVE SS08WS-CURSOR
132200                                 TO MO04-DR-TRAN-CODE-L
132300                                    (X-MO04-TRANS)
132400                     SET SS08WS-ERROR-SW-YES
132500                                 TO TRUE
132600                 END-IF
132700         END-EVALUATE
132800*
132900         EVALUATE TRUE
133000             WHEN X-MO04-TRANS IS EQUAL TO 1
133100                 CONTINUE
133200             WHEN X-MO04-TRANS IS EQUAL TO 2
133300                 CONTINUE
133400             WHEN X-MO04-TRANS IS EQUAL TO 8
133500                 CONTINUE
133600             WHEN X-MO04-TRANS IS EQUAL TO 11
133700                 CONTINUE
133800             WHEN X-MO04-TRANS IS EQUAL TO 12
133900                 CONTINUE
134000             WHEN OTHER
134100                 IF  MO04-CR-TRAN-CODE (X-MO04-TRANS)
134200                     IS LESS THAN 1
134300                         MOVE DFHBMNBF
134400                                 TO MO04-CR-TRAN-CODE-A
134500                                    (X-MO04-TRANS)
134600                         MOVE DFHBMASB
134700                                 TO MO04-CR-TRAN-CODE-LP-A
134800                                    (X-MO04-TRANS)
134900                                    MO04-CR-TRAN-CODE-RP-A
135000                                    (X-MO04-TRANS)
135100                         MOVE SS08WS-CURSOR
135200                                 TO MO04-CR-TRAN-CODE-L
135300                                    (X-MO04-TRANS)
135400                         SET SS08WS-ERROR-SW-YES
135500                                 TO TRUE
135600                 END-IF
135700         END-EVALUATE
135800*
135900         EVALUATE TRUE
136000             WHEN X-MO04-TRANS IS EQUAL TO 1
136100                 CONTINUE
136200             WHEN X-MO04-TRANS IS EQUAL TO 12
136300                 CONTINUE
136400             WHEN OTHER
136500                 IF  MO04-PLAN (X-MO04-TRANS)
136600                     IS LESS THAN 1
136700                         MOVE DFHBMNBF
136800                                 TO MO04-PLAN-A
136900                                    (X-MO04-TRANS)
137000                         MOVE DFHBMASB
137100                                 TO MO04-PLAN-LP-A
137200                                    (X-MO04-TRANS)
137300                                    MO04-PLAN-RP-A
137400                                    (X-MO04-TRANS)
137500                         MOVE SS08WS-CURSOR
137600                                 TO MO04-PLAN-L
137700                                    (X-MO04-TRANS)
137800                         SET SS08WS-ERROR-SW-YES
137900                                 TO TRUE
138000                 END-IF
138100         END-EVALUATE
138200     END-PERFORM.
138300*
138400 9299-CEB-EXIT.
138500     EXIT.
138600*
138700/         JULIAN TO GREGORIAN DATE ROUTINE.
138800     COPY SS08PD.
138900/         DATE AND TIME EDIT ROUTINES.
139000     COPY SS26PD.
139100     COPY SS27PD.
139200/         CHECK DIGIT ROUTINE.
139300     COPY SS09PD.
139400/         LINE 24 PF KEYS ROUTINE
139500     COPY SS15PD.
139600/         ORGANIZATION RECORD ACCESS ROUTINES
139700     COPY MMOCAO.
139800/         STORE MASTER RECORD ACCESS ROUTINES
139900     COPY MMSMAO.
140000/         LOG/JOURNAL ACCESS ROUTINES
140100     COPY MML1AO.
140200/         ON-LINE MAP ROUTINES
140300     COPY MB60PD REPLACING 'MBMAPXX' BY 'MBMO04 '
140400                           MBMAPXXI BY MBMO04I
140500                           MBMAPXXO BY MBMO04O.
140600/         ON-LINE PROCEDURES
140700     COPY MB70PD.
140800/
140900     COPY SMFTPXO.
