000100 IDENTIFICATION DIVISION.
000200 PROGRAM-ID. MBOMO05.
000201*       RELEASE DATE=08/24/01.        REVISION LEVEL=08.06      * ++++++++
000202***************************************************************** ++++++++
000203*WARNING.  THIS COMPUTER PROGRAM IS PROTECTED BY COPYRIGHT LAW  * ++++++++
000204*AND INTERNATIONAL TREATIES.  UNAUTHORIZED REPRODUCTION OR      * ++++++++
000205*DISTRIBUTION OF THIS PROGRAM, OR ANY PORTION OF IT, MAY RESULT * ++++++++
000206*IN SEVERE CIVIL AND CRIMINAL PENATLIES, AND WILL BE PROSECUTED * ++++++++
000207*TO THE MAXIMUM EXTENT POSSIBLE UNDER THE LAW.                  * ++++++++
000208*COPYRIGHT 1999 PAYSYS INTERNATIONAL, INC.  ALL RIGHTS RESERVED.* ++++++++
000209***************************************************************** ++++++++
000300*****************************************************************
000400*                                                               *
000500*   V - PLUS  M E R C H A N T   B A N K C A R D   S Y S T E M   *
000600*                                                               *
000700*      MBOMO05 - ON-LINE ORG RECORD ADD/MAINTENANCE/INQUIRY     *
000800*                SCREEN 05                                      *
000900*                                                               *
001000*              1. TRANSIDS                                      *
001100*                 A. MBAO                                       *
001200*                 B. MBMO                                       *
001300*                 C. MBQO                                       *
001400*              2. MAPS USED -                                   *
001500*                 A. MBMO05 (ORGANIZATION MAP 05)               *
001600*              3. FILES USED -                                  *
001700*                 A. MMOC   (SYSTEM/ORG CONTROL FILE)           *
001800*                 B. MML1   (LOG/JOURNAL FILE)                  *
001900*                                                               *
002000*****************************************************************
002100*
002200 ENVIRONMENT DIVISION.
002300 DATA DIVISION.
002400 WORKING-STORAGE SECTION.
002500 01  FILLER                  PIC  X(12)      VALUE '** WS-BEG **'.
002600*         I/O REQUEST BLOCK WORK AREAS
002700     COPY MBIOWS.
002800/         I/O REQUEST BLOCK
002900     COPY MBIORO.
003000/         LOG/JOURNAL WORK AREAS
003100     COPY MML1WS REPLACING ==:MML1:== BY ==MML1==.
003200/         DATE WORK AREAS
003300     COPY SS01WS.
003400/         ONLINE WORK AREAS
003500     COPY SS08WS.
003600/
003700     COPY SS00WS.
003800/
003900     COPY SMFTWS.
004000/
004100     COPY SMPTRL REPLACING ==:SMPT:== BY ==SMPT==.
004200/
004300     COPY MB61LK.
004400/
004500     COPY SS05WS.
004600/
004700     COPY SC00WS.
004800/
004900     COPY SMCOWS.
005000/
005100     COPY SMCORL.
005200/
005300     COPY SMCUWS.
005400/
005500     COPY SMCURL.
005600/
005700 01  WS-WORK-AREAS.
005800     03  WS-UPDATE-SW        PIC  X(01)      VALUE 'N'.
005900         88  WS-UPDATE-SW-NO                 VALUE 'N'.
006000         88  WS-UPDATE-SW-YES                VALUE 'Y'.
006100 01  FILLER                  PIC  X(12)      VALUE '** WS-END **'.
006200/
006300 LINKAGE SECTION.
006400 01  DFHCOMMAREA.
006500     COPY MB60WS.
006600/         ORG SCREEN 05 MAP DSECT
006700     COPY MBMO05.
006800/         ORG SCREEN 05 MAP REDEFINITION
006900     COPY MBMO05R.
007000/         SYSTEM/ORG CONTROL FILE RECORD LAYOUT
007100     COPY MMOCRL.
007200/         LOG/JOURNAL FILE RECORD LAYOUT
007300     COPY MML1RL REPLACING ==:MML1:== BY ==MML1==.
007400/
007500 PROCEDURE DIVISION.
007600 0000-HOUSEKEEPING SECTION.
007700 0100-INIT.
007800*
007900     MOVE 'PC01'                 TO MBCA-PROGRAM-LOCATION.
008000     PERFORM MB70PD-ON-LINE-HOUSEKEEPING
008100                                 THRU MB70PD-OLH-EXIT.
008200*
008300     IF  MBCA-RECEIVE-SCREEN
008400         GO TO 2000-RECEIVE-SCREEN.
008500/
008600 1000-SEND-SCREEN SECTION.
008700*
008800****************************************************************
008900*    THIS SECTION BUILDS AND SENDS THE 05 SCREEN.              *
009000****************************************************************
009100*
009200****************************************************************
009300*    GET CICS STORAGE NEEDED FOR THE MAP                       *
009400****************************************************************
009500*
009600     MOVE 'SC01'                 TO MBCA-PROGRAM-LOCATION.
009700     PERFORM MB60PD-GETMAIN-FOR-MAP
009800                                 THRU MB60PD-GFM-EXIT.
009900*
010000     MOVE MBCA-MERCHANT-ORG      TO MO05-ORG.
010100     MOVE 05                     TO MBCA-SCREEN-NBR.
010200*
010300****************************************************************
010400*    INITIALIZE THE STANDARD MAP LINES                         *
010500****************************************************************
010600*
010700     PERFORM MB60PD-INIT-STD-MAP-LINES
010800                                 THRU MB60PD-ISML-EXIT.
010900*
011000****************************************************************
011100*    READ THE ORGANIZATION FILE RECORD                         *
011200****************************************************************
011300*
011400     MOVE 'FC01'                 TO MBCA-PROGRAM-LOCATION.
011500     MOVE MBCA-MERCHANT-ORG      TO MBIOWS-MMOC-ORG.
011600     SET MBIORO-READ-RANDOM      TO TRUE.
011700     PERFORM MMOCAO-ACCESS       THRU MMOCAO-ACCESS-EXIT.
011800/
011900 1100-BUILD-SCREEN.
012000*
012100****************************************************************
012200*    BUILD THE MAP FROM THE ORGANIZATION RECORD                *
012300****************************************************************
012400*
012500     MOVE MMOC-NA-LINE (1 1)     TO MO05-ORG-NAME.
012600     MOVE MMOC-STMTS-TO-RETAIN   TO MO05-STMTS-TO-RETAIN.
012700     MOVE MMOC-INTCHG-BIN        TO MO05-VI-BIN.
012800     MOVE MMOC-INTCHG-ICA        TO MO05-MC-ICA.                  RG800905
012810     MOVE MMOC-MC-INTCHG-BIN     TO MO05-MC-BIN.                  RG800905
012900     MOVE MMOC-LINES-PER-PAGE    TO MO05-LINES-PER-PAGE.
012902     MOVE MMOC-EUROPAY-CMID      TO MO05-EUROPAY-CMID.            EH800900
013000     MOVE MMOC-FORM              TO MO05-FORM-CODE.
013100     MOVE MMOC-MEMBER-ID         TO MO05-MEMBER-ID.
013200     MOVE MMOC-FICHE-FLAG        TO MO05-FICHE-FLAG.
013300     MOVE MMOC-COUNTRY-CODE (1)  TO MO05-COUNTRY-CODE.
013400     MOVE MMOC-TOP-MERCHANTS-NBR TO MO05-TOP-MERCHANTS-NBR.
013500     MOVE MMOC-CRB-TERM-MERCH-FLAG
013600                                 TO MO05-CRB-TERM-MERCH.
013700     MOVE MMOC-CURRENCY-CODE     TO MO05-CURRENCY-CODE.
013800     MOVE MMOC-CURRENCY-CODE     TO SMCUWS-CURRENCY-CODE.
013900     PERFORM SMCUPXO-OBTAIN-CURRENCY-DATA
014000        THRU SMCUPXO-OCD-EXIT.
014100     MOVE SMCUWS-RECORD          TO SMCU-RECORD.
014200*
014300     IF  SMCUWS-RC-CURRENCY-FOUND
014400         MOVE SMCU-CURRENCY-CODE-OTHER
014500                                 TO MO05-CURRENCY-CODE-OTHER.
014600*
014700     MOVE MMOC-CURRENCY-NOD      TO MO05-CURRENCY-NOD.
014800     MOVE MMOC-PERCENT-NOD       TO MO05-PERCENT-NOD.
014900     MOVE MMOC-PER-ITEM-NOD      TO MO05-PER-ITEM-NOD.
015000     MOVE MMOC-ISSUER-RR-FAX-NBR TO MO05-INTCHG-FAX.
015100     MOVE MMOC-MERCH-PRIMARY     TO MO05-MERCH-PRIM.
015200     MOVE MMOC-MERCHANT-MOD-CHECK
015300                                 TO MO05-CHK-DIGIT-MERCH.
015400     MOVE MMOC-MERCH-SECONDARY   TO MO05-MERCH-SEC.
015500     MOVE MMOC-MERCH-DBA         TO MO05-MERCH-DBA.
015600     MOVE MMOC-STORE-MOD-CHECK   TO MO05-CHK-DIGIT-STORE.
015700     MOVE MMOC-STORE-PRIMARY     TO MO05-STORE-PRIM.
015800     MOVE MMOC-STORE-SECONDARY   TO MO05-STORE-SEC.
015900     MOVE MMOC-STORE-DBA         TO MO05-STORE-DBA.
016000     MOVE MMOC-CR-PLAN-ON-MERCH  TO MO05-CR-PLAN-MERCH.
016100     MOVE MMOC-CHAIN-PRIMARY     TO MO05-CHAIN-PRIM.
016200     MOVE MMOC-CR-PLAN-ON-STORE  TO MO05-CR-PLAN-STORE.
016300     MOVE MMOC-CR-PLAN-ON-CHAIN  TO MO05-CR-PLAN-CHAIN.
016400     MOVE MMOC-STORE-CHAIN-PRIMARY
016500                                 TO MO05-STORE-CHAIN-PRIM.
016600     MOVE MMOC-CR-PLAN-ON-STORE-CHAIN
016700                                 TO MO05-CR-PLAN-S-CHAIN.
016800*
016900     SET X-MMOC-CO               TO 1.
017000     SET X-MMOC-PO               TO 1.
017100*
017200     MOVE MMOC-AUTO-CLOSE-FLAG (X-MMOC-CO)
017300                                 TO MO05-MERCH-CLOSE-FLAG.
017400     MOVE MMOC-AUTO-PURGE-FLAG (X-MMOC-PO)
017500                                 TO MO05-MERCH-PURGE-FLAG.
017600     MOVE MMOC-AUTO-CLOSE-MONTHS (X-MMOC-CO)
017700                                 TO MO05-MERCH-CLOSE-MOS.
017800     MOVE MMOC-AUTO-PURGE-MONTHS (X-MMOC-PO)
017900                                 TO MO05-MERCH-PURGE-MOS.
018000     MOVE MMOC-AUTO-CLOSE-FREQ-1 (X-MMOC-CO)
018100                                 TO MO05-MERCH-CLOSE-FREQ1.
018200     MOVE MMOC-AUTO-CLOSE-FREQ-2 (X-MMOC-CO)
018300                                 TO MO05-MERCH-CLOSE-FREQ2.
018400     MOVE MMOC-AUTO-PURGE-FREQ-1 (X-MMOC-PO)
018500                                 TO MO05-MERCH-PURGE-FREQ1.
018600     MOVE MMOC-AUTO-PURGE-FREQ-2 (X-MMOC-PO)
018700                                 TO MO05-MERCH-PURGE-FREQ2.
018800     MOVE MMOC-FINAL-PURGE-DAYS  TO MO05-MERCH-PURGE-DAYS.
018900*
019000     SET X-MMOC-CO               TO 2.
019100     SET X-MMOC-PO               TO 2.
019200*
019300     MOVE MMOC-AUTO-CLOSE-FLAG (X-MMOC-CO)
019400                                 TO MO05-STORE-CLOSE-FLAG.
019500     MOVE MMOC-AUTO-PURGE-FLAG (X-MMOC-PO)
019600                                 TO MO05-STORE-PURGE-FLAG.
019700     MOVE MMOC-AUTO-CLOSE-MONTHS (X-MMOC-CO)
019800                                 TO MO05-STORE-CLOSE-MOS.
019900     MOVE MMOC-AUTO-PURGE-MONTHS (X-MMOC-PO)
020000                                 TO MO05-STORE-PURGE-MOS.
020100     MOVE MMOC-AUTO-CLOSE-FREQ-1 (X-MMOC-CO)
020200                                 TO MO05-STORE-CLOSE-FREQ1.
020300     MOVE MMOC-AUTO-CLOSE-FREQ-2 (X-MMOC-CO)
020400                                 TO MO05-STORE-CLOSE-FREQ2.
020500     MOVE MMOC-AUTO-PURGE-FREQ-1 (X-MMOC-PO)
020600                                 TO MO05-STORE-PURGE-FREQ1.
020700     MOVE MMOC-AUTO-PURGE-FREQ-2 (X-MMOC-PO)
020800                                 TO MO05-STORE-PURGE-FREQ2.
020900     MOVE MMOC-MC-QTR-FLAG       TO MO05-MC-QTR-FLAG.             EH800900
020902     MOVE MMOC-VISA-QTR-FLAG     TO MO05-VISA-QTR-FLAG.           EH800900
021000/
021100****************************************************************
021200*    IF INQUIRY, DARKEN PARENS AND ASKIP FIELDS                *
021300****************************************************************
021400*
021500     MOVE SS08WS-CURSOR          TO MO05-STMTS-TO-RETAIN-L.
021600*
021700     MOVE DFHBMASK               TO MO05-CURRENCY-NOD-A.
021800     MOVE DFHBMDAS               TO MO05-CURRENCY-NOD-LP-A
021900                                    MO05-CURRENCY-NOD-RP-A.
021910     MOVE DFHBMASK               TO MO05-PERCENT-NOD-A.
021912     MOVE DFHBMDAS               TO MO05-PERCENT-NOD-LP-A
021914                                    MO05-PERCENT-NOD-RP-A.
021920     MOVE DFHBMASK               TO MO05-PER-ITEM-NOD-A.
021922     MOVE DFHBMDAS               TO MO05-PER-ITEM-NOD-LP-A
021924                                    MO05-PER-ITEM-NOD-RP-A.
021930*
021932     IF  MBCA-PTI-FUNCTION-IS-ADD
021934         MOVE '@@'               TO MBCA-TRANS-LOOP-CONTROL
021936         MOVE '?'                TO MO05-CURRENCY-NOD
021938         MOVE '?'                TO MO05-PERCENT-NOD
021940         MOVE '?'                TO MO05-PER-ITEM-NOD
021942     ELSE
021944         MOVE DFHBMASK           TO MO05-CURRENCY-CODE-A
021946         MOVE DFHBMDAS           TO MO05-CURRENCY-CODE-LP-A
021948                                    MO05-CURRENCY-CODE-RP-A
021950     END-IF.
021952*
022000*
022100     IF  MBCA-PTI-FUNCTION-IS-INQUIRY
022200         MOVE SS08WS-CURSOR      TO MO05-ALT-TRANID-L
022300         MOVE DFHBMASB           TO MO05-STMTS-TO-RETAIN-A
022400                                    MO05-VI-BIN-A
022499                                    MO05-MC-ICA-A                 RG800905
022500                                    MO05-MC-BIN-A
022600                                    MO05-LINES-PER-PAGE-A
022602                                    MO05-EUROPAY-CMID-A           EH800900
022700                                    MO05-FORM-CODE-A
022800                                    MO05-MEMBER-ID-A
022900                                    MO05-FICHE-FLAG-A
023000                                    MO05-COUNTRY-CODE-A
023100                                    MO05-TOP-MERCHANTS-NBR-A
023200                                    MO05-CRB-TERM-MERCH-A
023300                                    MO05-CURRENCY-CODE-A
023400                                    MO05-CURRENCY-CODE-OTHER-A
023500                                    MO05-CURRENCY-NOD-A
023600                                    MO05-PERCENT-NOD-A
023700                                    MO05-PER-ITEM-NOD-A
023800                                    MO05-INTCHG-FAX-A
023900                                    MO05-MERCH-PRIM-A
024000                                    MO05-CHK-DIGIT-MERCH-A
024100                                    MO05-MERCH-SEC-A
024200                                    MO05-MERCH-DBA-A
024300                                    MO05-CHK-DIGIT-STORE-A
024400                                    MO05-STORE-PRIM-A
024500                                    MO05-STORE-SEC-A
024600                                    MO05-STORE-DBA-A
024700                                    MO05-CR-PLAN-MERCH-A
024800                                    MO05-CHAIN-PRIM-A
024900                                    MO05-CR-PLAN-STORE-A
025000                                    MO05-CR-PLAN-CHAIN-A
025100                                    MO05-STORE-CHAIN-PRIM-A
025200                                    MO05-CR-PLAN-S-CHAIN-A
025300                                    MO05-MERCH-CLOSE-FLAG-A
025400                                    MO05-MERCH-PURGE-FLAG-A
025500                                    MO05-STORE-CLOSE-FLAG-A
025600                                    MO05-STORE-PURGE-FLAG-A
025700                                    MO05-MERCH-CLOSE-MOS-A
025800                                    MO05-MERCH-PURGE-MOS-A
025900                                    MO05-STORE-CLOSE-MOS-A
026000                                    MO05-STORE-PURGE-MOS-A
026100                                    MO05-MERCH-CLOSE-FREQ1-A
026200                                    MO05-MERCH-PURGE-FREQ1-A
026300                                    MO05-STORE-CLOSE-FREQ1-A
026400                                    MO05-STORE-PURGE-FREQ1-A
026500                                    MO05-MERCH-CLOSE-FREQ2-A
026600                                    MO05-MERCH-PURGE-FREQ2-A
026700                                    MO05-STORE-CLOSE-FREQ2-A
026800                                    MO05-STORE-PURGE-FREQ2-A
026900                                    MO05-MERCH-PURGE-DAYS-A
027000                                    MO05-MC-QTR-FLAG-A            EH800900
027002                                    MO05-VISA-QTR-FLAG-A          EH800900
027100         MOVE DFHBMDAS           TO MO05-STMTS-TO-RETAIN-LP-A
027200                                    MO05-STMTS-TO-RETAIN-RP-A
027300                                    MO05-VI-BIN-LP-A
027400                                    MO05-VI-BIN-RP-A
027480                                    MO05-MC-ICA-LP-A              RG800905
027490                                    MO05-MC-ICA-RP-A              RG800905
027500                                    MO05-MC-BIN-LP-A
027600                                    MO05-MC-BIN-RP-A
027700                                    MO05-LINES-PER-PAGE-LP-A
027800                                    MO05-LINES-PER-PAGE-RP-A
027802                                    MO05-EUROPAY-CMID-LP-A        EH800900
027804                                    MO05-EUROPAY-CMID-RP-A        EH800900
027900                                    MO05-FORM-CODE-LP-A
028000                                    MO05-FORM-CODE-RP-A
028100                                    MO05-MEMBER-ID-LP-A
028200                                    MO05-MEMBER-ID-RP-A
028300                                    MO05-FICHE-FLAG-LP-A
028400                                    MO05-FICHE-FLAG-RP-A
028500                                    MO05-COUNTRY-CODE-LP-A
028600                                    MO05-COUNTRY-CODE-RP-A
028700                                    MO05-TOP-MERCHANTS-NBR-LP-A
028800                                    MO05-TOP-MERCHANTS-NBR-RP-A
028900                                    MO05-CRB-TERM-MERCH-LP-A
029000                                    MO05-CRB-TERM-MERCH-RP-A
029100                                    MO05-CURRENCY-CODE-LP-A
029200                                    MO05-CURRENCY-CODE-RP-A
029300                                    MO05-CURRENCY-NOD-LP-A
029400                                    MO05-CURRENCY-NOD-RP-A
029500                                    MO05-PERCENT-NOD-LP-A
029600                                    MO05-PERCENT-NOD-RP-A
029700                                    MO05-PER-ITEM-NOD-LP-A
029800                                    MO05-PER-ITEM-NOD-RP-A
029900                                    MO05-INTCHG-FAX-LP-A
030000                                    MO05-INTCHG-FAX-RP-A
030100                                    MO05-MERCH-PRIM-LP-A
030200                                    MO05-MERCH-PRIM-RP-A
030300                                    MO05-CHK-DIGIT-MERCH-LP-A
030400                                    MO05-CHK-DIGIT-MERCH-RP-A
030500                                    MO05-MERCH-SEC-LP-A
030600                                    MO05-MERCH-SEC-RP-A
030700                                    MO05-MERCH-DBA-LP-A
030800                                    MO05-MERCH-DBA-RP-A
030900                                    MO05-CHK-DIGIT-STORE-LP-A
031000                                    MO05-CHK-DIGIT-STORE-RP-A
031100                                    MO05-STORE-PRIM-LP-A
031200                                    MO05-STORE-PRIM-RP-A
031300                                    MO05-STORE-SEC-LP-A
031400                                    MO05-STORE-SEC-RP-A
031500                                    MO05-STORE-DBA-LP-A
031600                                    MO05-STORE-DBA-RP-A
031700                                    MO05-CR-PLAN-MERCH-LP-A
031800                                    MO05-CR-PLAN-MERCH-RP-A
031900                                    MO05-CHAIN-PRIM-LP-A
032000                                    MO05-CHAIN-PRIM-RP-A
032100                                    MO05-CR-PLAN-STORE-LP-A
032200                                    MO05-CR-PLAN-STORE-RP-A
032300                                    MO05-CR-PLAN-CHAIN-LP-A
032400                                    MO05-CR-PLAN-CHAIN-RP-A
032500                                    MO05-STORE-CHAIN-PRIM-LP-A
032600                                    MO05-STORE-CHAIN-PRIM-RP-A
032700                                    MO05-CR-PLAN-S-CHAIN-LP-A
032800                                    MO05-CR-PLAN-S-CHAIN-RP-A
032900                                    MO05-MERCH-CLOSE-FLAG-LP-A
033000                                    MO05-MERCH-CLOSE-FLAG-RP-A
033100                                    MO05-MERCH-PURGE-FLAG-LP-A
033200                                    MO05-MERCH-PURGE-FLAG-RP-A
033300                                    MO05-STORE-CLOSE-FLAG-LP-A
033400                                    MO05-STORE-CLOSE-FLAG-RP-A
033500                                    MO05-STORE-PURGE-FLAG-LP-A
033600                                    MO05-STORE-PURGE-FLAG-RP-A
033700                                    MO05-MERCH-CLOSE-MOS-LP-A
033800                                    MO05-MERCH-CLOSE-MOS-RP-A
033900                                    MO05-MERCH-PURGE-MOS-LP-A
034000                                    MO05-MERCH-PURGE-MOS-RP-A
034100                                    MO05-STORE-CLOSE-MOS-LP-A
034200                                    MO05-STORE-CLOSE-MOS-RP-A
034300                                    MO05-STORE-PURGE-MOS-LP-A
034400                                    MO05-STORE-PURGE-MOS-RP-A
034500                                    MO05-MERCH-CLOSE-FREQS-LP-A
034600                                    MO05-MERCH-CLOSE-FREQS-RP-A
034700                                    MO05-MERCH-PURGE-FREQS-LP-A
034800                                    MO05-MERCH-PURGE-FREQS-RP-A
034900                                    MO05-STORE-CLOSE-FREQS-LP-A
035000                                    MO05-STORE-CLOSE-FREQS-RP-A
035100                                    MO05-STORE-PURGE-FREQS-LP-A
035200                                    MO05-STORE-PURGE-FREQS-RP-A
035300                                    MO05-MERCH-PURGE-DAYS-LP-A
035400                                    MO05-MERCH-PURGE-DAYS-RP-A
035500                                    MO05-MC-QTR-FLAG-LP-A         EH800900
035600                                    MO05-VISA-QTR-FLAG-LP-A       EH800900
035602                                    MO05-MC-QTR-FLAG-RP-A         EH800900
035604                                    MO05-VISA-QTR-FLAG-RP-A.      EH800900
035700*
035800****************************************************************
035900*    SEND THE MAP                                              *
036000****************************************************************
036100*
036200     MOVE 'BM01'                 TO MBCA-PROGRAM-LOCATION.
036300     PERFORM MB60PD-SEND-MAP-WITH-ERASE
036400                                 THRU MB60PD-SMWE-EXIT.
036500*
036600****************************************************************
036700*    RETURN TO CICS                                            *
036800****************************************************************
036900*
037000     MOVE 'PC02'                 TO MBCA-PROGRAM-LOCATION.
037100     PERFORM MB70PD-RETURN-TRANS-ID
037200                                 THRU MB70PD-RTI-EXIT.
037300/
037400 2000-RECEIVE-SCREEN SECTION.
037500*
037600****************************************************************
037700*    THIS SECTION RECEIVES THE 05 SCREEN                       *
037800****************************************************************
037900*
038000     MOVE 'BM02'                 TO MBCA-PROGRAM-LOCATION.
038100     PERFORM MB60PD-RECEIVE-MAP  THRU MB60PD-RM-EXIT.
038200*
038300****************************************************************
038400*    CHECK FOR ANOTHER TRANSACTION ID ENTERED BY THE USER      *
038500****************************************************************
038600*
038700     MOVE 'PC03'                 TO MBCA-PROGRAM-LOCATION.
038800     PERFORM MB60PD-NEW-TRANS-ROUTINE
038900                                 THRU MB60PD-NTR-EXIT.
039000*
039100****************************************************************
039200*    BYPASS EDITS ON INQUIRY                                   *
039300****************************************************************
039400*
039500     IF  MBCA-PTI-FUNCTION-IS-INQUIRY
039600         GO TO 2600-SETUP-COMMAREA.
039700*
039800****************************************************************
039900*    READ THE ORGANIZATION FILE RECORD                         *
040000****************************************************************
040100*
040200     MOVE 'FC02'                 TO MBCA-PROGRAM-LOCATION.
040300     MOVE MBCA-MERCHANT-ORG      TO MBIOWS-MMOC-ORG.
040400     SET MBIORO-READ-RANDOM      TO TRUE.
040500     PERFORM MMOCAO-ACCESS       THRU MMOCAO-ACCESS-EXIT.
040600*
040700****************************************************************
040800*    EDIT FIELDS                                               *
040900****************************************************************
041000*
041100*            ***** STATEMENTS TO RETAIN *****                  *
041200*
041300     IF  MO05-STMTS-TO-RETAIN-L IS LESS THAN 1
041400         MOVE DFHBMASK           TO MO05-STMTS-TO-RETAIN-A
041500         MOVE DFHBMDAS           TO MO05-STMTS-TO-RETAIN-LP-A
041600                                    MO05-STMTS-TO-RETAIN-RP-A
041700         MOVE MMOC-STMTS-TO-RETAIN
041800                                 TO MO05-STMTS-TO-RETAIN
041900     ELSE
042000         IF  MO05-STMTS-TO-RETAIN IS NUMERIC
042100             MOVE DFHBMASF       TO MO05-STMTS-TO-RETAIN-A
042200             MOVE DFHBMDAS       TO MO05-STMTS-TO-RETAIN-LP-A
042300                                    MO05-STMTS-TO-RETAIN-RP-A
042400             SET WS-UPDATE-SW-YES
042500                                 TO TRUE
042600         ELSE
042700             MOVE DFHBMNBF       TO MO05-STMTS-TO-RETAIN-A
042800             MOVE DFHBMASB       TO MO05-STMTS-TO-RETAIN-LP-A
042900                                    MO05-STMTS-TO-RETAIN-RP-A
043000             MOVE SS08WS-CURSOR  TO MO05-STMTS-TO-RETAIN-L
043100             SET SS08WS-ERROR-SW-YES TO TRUE.
043200*
043300*            ***** VISA BIN NBR *****                          *
043400*
043500     IF  MO05-VI-BIN-L IS LESS THAN 1
043600         MOVE DFHBMASK           TO MO05-VI-BIN-A
043700         MOVE DFHBMDAS           TO MO05-VI-BIN-LP-A
043800                                    MO05-VI-BIN-RP-A
043900         MOVE MMOC-INTCHG-BIN    TO MO05-VI-BIN
044000     ELSE
044100         IF  MO05-VI-BIN IS NOT NUMERIC
044200             MOVE DFHBMNBF       TO MO05-VI-BIN-A
044300             MOVE DFHBMASB       TO MO05-VI-BIN-LP-A
044400                                    MO05-VI-BIN-RP-A
044500             MOVE SS08WS-CURSOR  TO MO05-VI-BIN-L
044600             SET SS08WS-ERROR-SW-YES TO TRUE
044700         ELSE
044800             MOVE DFHBMASF       TO MO05-VI-BIN-A
044900             MOVE DFHBMDAS       TO MO05-VI-BIN-LP-A
045000                                    MO05-VI-BIN-RP-A
045100             SET WS-UPDATE-SW-YES
045200                                 TO TRUE.
045201*                                                                 RG800905
045203*            ***** M/C ICA NBR *****                          *   RG800905
045205*                                                                 RG800905
045207     IF  MO05-MC-ICA-L IS LESS THAN 1                             RG800905
045209         MOVE DFHBMASK           TO MO05-MC-ICA-A                 RG800905
045211         MOVE DFHBMDAS           TO MO05-MC-ICA-LP-A              RG800905
045213                                    MO05-MC-ICA-RP-A              RG800905
045215         MOVE MMOC-INTCHG-ICA    TO MO05-MC-ICA                   RG800905
045217     ELSE                                                         RG800905
045219         IF  MO05-MC-ICA IS NOT NUMERIC                           RG800905
045221             MOVE DFHBMNBF       TO MO05-MC-ICA-A                 RG800905
045223             MOVE DFHBMASB       TO MO05-MC-ICA-LP-A              RG800905
045225                                    MO05-MC-ICA-RP-A              RG800905
045227             MOVE SS08WS-CURSOR  TO MO05-MC-ICA-L                 RG800905
045229             SET SS08WS-ERROR-SW-YES TO TRUE                      RG800905
045231         ELSE                                                     RG800905
045233             MOVE DFHBMASF       TO MO05-MC-ICA-A                 RG800905
045235             MOVE DFHBMDAS       TO MO05-MC-ICA-LP-A              RG800905
045237                                    MO05-MC-ICA-RP-A              RG800905
045239             IF MO05-MC-BIN-L NOT GREATER THAN ZERO               RG800905
045240                 MOVE DFHBMUNF   TO MO05-MC-BIN-A                 RG800905
045241                 MOVE +0006      TO MO05-MC-BIN-L                 RG800905
045243                 MOVE MMOC-MC-INTCHG-BIN                          RG800905
045245                                 TO MO05-MC-BIN                   RG800905
045247                 SET WS-UPDATE-SW-YES                             RG800905
045249                                 TO TRUE.                         RG800905
045300*
045400*            ***** M/C BIN NBR *****                          *
045500*
045600     IF  MO05-MC-BIN-L IS LESS THAN 1 AND                         RG800905
045610         MO05-MC-ICA-L IS LESS THAN 1                             RG800905
045700         MOVE DFHBMASK           TO MO05-MC-BIN-A
045800         MOVE DFHBMDAS           TO MO05-MC-BIN-LP-A
045900                                    MO05-MC-BIN-RP-A
046000         MOVE MMOC-MC-INTCHG-BIN TO MO05-MC-BIN                   RG800905
046100     ELSE
046200         PERFORM 9100-ICA-BIN-XEDIT  THRU 9199-IBX-EXIT.          RG800905
046300*                                                                 RG800905
046400*                                                                 RG800905
046500*                                                                 RG800905
046600*                                                                 RG800905
046700*                                                                 RG800905
046800*                                                                 RG800905
046900*                                                                 RG800905
047000*                                                                 RG800905
047100*                                                                 RG800905
047200*                                                                 RG800905
047300*                                                                 RG800905
047400*
047500*            ***** LINES PER PAGE *****                        *
047600*
047700     IF  MO05-LINES-PER-PAGE-L IS LESS THAN 1
047800         MOVE DFHBMASK           TO MO05-LINES-PER-PAGE-A
047900         MOVE DFHBMDAS           TO MO05-LINES-PER-PAGE-LP-A
048000                                    MO05-LINES-PER-PAGE-RP-A
048100         MOVE MMOC-LINES-PER-PAGE
048200                                 TO MO05-LINES-PER-PAGE
048300     ELSE
048400         IF  MO05-LINES-PER-PAGE IS NOT NUMERIC
048500             MOVE DFHBMNBF       TO MO05-LINES-PER-PAGE-A
048600             MOVE DFHBMASB       TO MO05-LINES-PER-PAGE-LP-A
048700                                    MO05-LINES-PER-PAGE-RP-A
048800             MOVE SS08WS-CURSOR  TO MO05-LINES-PER-PAGE-L
048900             SET SS08WS-ERROR-SW-YES TO TRUE
049000         ELSE
049100             IF  MO05-VALID-LINES-PER-PAGE
049200                 MOVE DFHBMASK   TO MO05-LINES-PER-PAGE-A
049300                 MOVE DFHBMDAS   TO MO05-LINES-PER-PAGE-LP-A
049400                                    MO05-LINES-PER-PAGE-RP-A
049500                 SET WS-UPDATE-SW-YES
049600                                 TO TRUE
049700             ELSE
049800                 MOVE DFHBMNBF   TO MO05-LINES-PER-PAGE-A
049900                 MOVE DFHBMASB   TO MO05-LINES-PER-PAGE-LP-A
050000                                    MO05-LINES-PER-PAGE-RP-A
050100                 MOVE SS08WS-CURSOR TO MO05-LINES-PER-PAGE-L
050200                 SET SS08WS-ERROR-SW-YES
050300                                 TO TRUE.
050302*                                                                 EH800900
050304*            ***** EUROPAY CMID *****                         *   EH800900
050306*                                                                 EH800900
050308     IF  MO05-EUROPAY-CMID-L IS LESS THAN 1                       EH800900
050310         MOVE DFHBMASK           TO MO05-EUROPAY-CMID-A           EH800900
050312         MOVE DFHBMDAS           TO MO05-EUROPAY-CMID-LP-A        EH800900
050314                                    MO05-EUROPAY-CMID-RP-A        EH800900
050316         MOVE MMOC-EUROPAY-CMID  TO MO05-EUROPAY-CMID             EH800900
050318     ELSE                                                         EH800900
050320         IF  MO05-EUROPAY-CMID IS NOT NUMERIC                     EH800900
050322             MOVE DFHBMNBF       TO MO05-EUROPAY-CMID-A           EH800900
050324             MOVE DFHBMASB       TO MO05-EUROPAY-CMID-LP-A        EH800900
050326                                    MO05-EUROPAY-CMID-RP-A        EH800900
050328             MOVE SS08WS-CURSOR  TO MO05-EUROPAY-CMID-L           EH800900
050330             SET SS08WS-ERROR-SW-YES TO TRUE                      EH800900
050332         ELSE                                                     EH800900
050334             MOVE DFHBMASF       TO MO05-EUROPAY-CMID-A           EH800900
050336             MOVE DFHBMDAS       TO MO05-EUROPAY-CMID-LP-A        EH800900
050338                                    MO05-EUROPAY-CMID-RP-A        EH800900
050340             SET WS-UPDATE-SW-YES                                 EH800900
050342                                 TO TRUE.                         EH800900
050400*
050500*            ***** FORM CODE *****                             *
050600*
050700     IF  MO05-FORM-CODE-L IS LESS THAN 1
050800         MOVE DFHBMASK           TO MO05-FORM-CODE-A
050900         MOVE DFHBMDAS           TO MO05-FORM-CODE-LP-A
051000                                    MO05-FORM-CODE-RP-A
051100         MOVE MMOC-FORM          TO MO05-FORM-CODE
051200     ELSE
051300         IF  MO05-FORM-CODE IS NUMERIC
051400             MOVE DFHBMASF       TO MO05-FORM-CODE-A
051500             MOVE DFHBMDAS       TO MO05-FORM-CODE-LP-A
051600                                    MO05-FORM-CODE-RP-A
051700             SET WS-UPDATE-SW-YES
051800                                 TO TRUE
051900         ELSE
052000             MOVE DFHBMNBF       TO MO05-FORM-CODE-A
052100             MOVE DFHBMASB       TO MO05-FORM-CODE-LP-A
052200                                    MO05-FORM-CODE-RP-A
052300             MOVE SS08WS-CURSOR  TO MO05-FORM-CODE-L
052400             SET SS08WS-ERROR-SW-YES TO TRUE.
052500*
052600*            ***** MEMBER ID *****                             *
052700*
052800     IF  MO05-MEMBER-ID-L IS LESS THAN 1
052900         MOVE DFHBMASK           TO MO05-MEMBER-ID-A
053000         MOVE DFHBMDAS           TO MO05-MEMBER-ID-LP-A
053100                                    MO05-MEMBER-ID-RP-A
053200         MOVE MMOC-MEMBER-ID     TO MO05-MEMBER-ID
053300     ELSE
053400         IF  MO05-MEMBER-ID IS NUMERIC
053500             MOVE DFHBMASF       TO MO05-MEMBER-ID-A
053600             MOVE DFHBMDAS       TO MO05-MEMBER-ID-LP-A
053700                                    MO05-MEMBER-ID-RP-A
053800             SET WS-UPDATE-SW-YES
053900                                 TO TRUE
054000         ELSE
054100             MOVE DFHBMNBF       TO MO05-MEMBER-ID-A
054200             MOVE DFHBMASB       TO MO05-MEMBER-ID-LP-A
054300                                    MO05-MEMBER-ID-RP-A
054400             MOVE SS08WS-CURSOR  TO MO05-MEMBER-ID-L
054500             SET SS08WS-ERROR-SW-YES TO TRUE.
054600*
054700*            ***** FICHE FLAG *****                            *
054800*
054900     IF  MO05-FICHE-FLAG-L IS LESS THAN 1
055000         MOVE DFHBMASK           TO MO05-FICHE-FLAG-A
055100         MOVE DFHBMDAS           TO MO05-FICHE-FLAG-LP-A
055200                                    MO05-FICHE-FLAG-RP-A
055300         MOVE MMOC-FICHE-FLAG    TO MO05-FICHE-FLAG
055400     ELSE
055500         IF  MO05-FICHE-FLAG IS NUMERIC
055600         OR  MO05-FICHE-FLAG IS EQUAL TO 'A'
055700         OR  MO05-FICHE-FLAG IS EQUAL TO 'B'
055800         OR  MO05-FICHE-FLAG IS EQUAL TO 'C'
055900         OR  MO05-FICHE-FLAG IS EQUAL TO 'D'
056000         OR  MO05-FICHE-FLAG IS EQUAL TO 'E'
056100         OR  MO05-FICHE-FLAG IS EQUAL TO 'F'
056200         OR  MO05-FICHE-FLAG IS EQUAL TO 'G'
056300         OR  MO05-FICHE-FLAG IS EQUAL TO 'H'
056400         OR  MO05-FICHE-FLAG IS EQUAL TO 'I'
056500             MOVE DFHBMASF       TO MO05-FICHE-FLAG-A
056600             MOVE DFHBMDAS       TO MO05-FICHE-FLAG-LP-A
056700                                    MO05-FICHE-FLAG-RP-A
056800             SET WS-UPDATE-SW-YES
056900                                 TO TRUE
057000         ELSE
057100             MOVE DFHBMUBF       TO MO05-FICHE-FLAG-A
057200             MOVE DFHBMASB       TO MO05-FICHE-FLAG-LP-A
057300                                    MO05-FICHE-FLAG-RP-A
057400             MOVE SS08WS-CURSOR  TO MO05-FICHE-FLAG-L
057500             SET SS08WS-ERROR-SW-YES TO TRUE.
057600*
057700     PERFORM SMCOPXO-OBTAIN-COUNTRY-TABLE
057800        THRU SMCOPXO-OCT-EXIT.
057900*
058000*            ***** COUNTRY CODE *****                         *
058100*
058200     IF  MO05-COUNTRY-CODE-L IS LESS THAN 1
058300         MOVE DFHBMASK           TO MO05-COUNTRY-CODE-A
058400         MOVE DFHBMDAS           TO MO05-COUNTRY-CODE-LP-A
058500                                    MO05-COUNTRY-CODE-RP-A
058600         MOVE MMOC-COUNTRY-CODE (1)
058700                                 TO MO05-COUNTRY-CODE
058800     ELSE
058900         IF  SMCOWS-RC-NO-COUNTRY-FOUND
059000             MOVE DFHBMUBF       TO MO05-COUNTRY-CODE-A
059100             MOVE DFHBMASB       TO MO05-COUNTRY-CODE-LP-A
059200                                    MO05-COUNTRY-CODE-RP-A
059300             MOVE SS08WS-CURSOR  TO MO05-COUNTRY-CODE-L
059400             SET SS08WS-ERROR-SW-YES
059500                                 TO TRUE
059600         ELSE
059700             MOVE MO05-COUNTRY-CODE
059800                                 TO SMCOWS-SEARCH-COUNTRY-CODE
059900             PERFORM SMCOPX-INTERROGATION-SEARCH
060000                THRU SMCOPX-IS-EXIT
060100             IF  SMCOWS-SEARCH-INDEX = ZERO
060200                 MOVE DFHBMUBF   TO MO05-COUNTRY-CODE-A
060300                 MOVE DFHBMASB   TO MO05-COUNTRY-CODE-LP-A
060400                                    MO05-COUNTRY-CODE-RP-A
060500                 MOVE SS08WS-CURSOR
060600                                 TO MO05-COUNTRY-CODE-L
060700                 SET SS08WS-ERROR-SW-YES
060800                                 TO TRUE
060900             ELSE
061000                 MOVE DFHBMASF   TO MO05-COUNTRY-CODE-A
061100                 MOVE DFHBMDAS   TO MO05-COUNTRY-CODE-LP-A
061200                                    MO05-COUNTRY-CODE-RP-A
061300                 SET WS-UPDATE-SW-YES
061400                                 TO TRUE
061500             END-IF
061600          END-IF
061700     END-IF.
061800*
061900*            ***** TOP MERCHANTS NUMBER *****                  *
062000*
062100     IF  MO05-TOP-MERCHANTS-NBR-L IS LESS THAN 1
062200         MOVE DFHBMASK           TO MO05-TOP-MERCHANTS-NBR-A
062300         MOVE DFHBMDAS           TO MO05-TOP-MERCHANTS-NBR-LP-A
062400                                    MO05-TOP-MERCHANTS-NBR-RP-A
062500         MOVE MMOC-TOP-MERCHANTS-NBR
062600                                 TO MO05-TOP-MERCHANTS-NBR
062700     ELSE
062800         IF  MO05-TOP-MERCHANTS-NBR IS NUMERIC
062900         AND MO05-VALID-TOP-MERCHANTS-NBR
063000             MOVE DFHBMASF       TO MO05-TOP-MERCHANTS-NBR-A
063100             MOVE DFHBMDAS       TO MO05-TOP-MERCHANTS-NBR-LP-A
063200                                    MO05-TOP-MERCHANTS-NBR-RP-A
063300             SET WS-UPDATE-SW-YES
063400                                 TO TRUE
063500         ELSE
063600             MOVE DFHBMNBF       TO MO05-TOP-MERCHANTS-NBR-A
063700             MOVE DFHBMASB       TO MO05-TOP-MERCHANTS-NBR-LP-A
063800                                    MO05-TOP-MERCHANTS-NBR-RP-A
063900             MOVE SS08WS-CURSOR  TO MO05-TOP-MERCHANTS-NBR-L
064000             SET SS08WS-ERROR-SW-YES TO TRUE.
064100*
064200*            ***** CRB TERM MERCH  *****                 *
064300*
064400     IF  MO05-CRB-TERM-MERCH-L IS LESS THAN 1
064500         MOVE DFHBMASK           TO MO05-CRB-TERM-MERCH-A
064600         MOVE DFHBMDAS           TO MO05-CRB-TERM-MERCH-LP-A
064700                                    MO05-CRB-TERM-MERCH-RP-A
064800         MOVE MMOC-CRB-TERM-MERCH-FLAG
064900                                 TO MO05-CRB-TERM-MERCH
065000     ELSE
065100         IF  MO05-VALID-CRB-TERM-MERCH
065200             MOVE DFHBMASF       TO MO05-CRB-TERM-MERCH-A
065300             MOVE DFHBMDAS       TO MO05-CRB-TERM-MERCH-LP-A
065400                                    MO05-CRB-TERM-MERCH-RP-A
065500             SET WS-UPDATE-SW-YES
065600                                 TO TRUE
065700         ELSE
065800             MOVE DFHBMUBF       TO MO05-CRB-TERM-MERCH-A
065900             MOVE DFHBMASB       TO MO05-CRB-TERM-MERCH-LP-A
066000                                    MO05-CRB-TERM-MERCH-RP-A
066100             MOVE SS08WS-CURSOR  TO MO05-CRB-TERM-MERCH-L
066200             SET SS08WS-ERROR-SW-YES TO TRUE.
066300*
066400*            ***** CURRENCY CODE *****                         *
066500*
066600     MOVE MMOC-CURRENCY-CODE     TO SMCUWS-CURRENCY-CODE.
066700*
066800     IF  MO05-CURRENCY-CODE-L IS GREATER THAN ZERO
066900         MOVE MO05-CURRENCY-CODE TO SMCUWS-CURRENCY-CODE.
067000*
067100     PERFORM SMCUPXO-OBTAIN-CURRENCY-DATA
067200        THRU SMCUPXO-OCD-EXIT.
067300     MOVE SMCUWS-RECORD          TO SMCU-RECORD.
067400*
067500     IF  SMCUWS-RC-CURRENCY-FOUND
067600         MOVE SMCU-CURRENCY-CODE-OTHER
067700                                 TO MO05-CURRENCY-CODE-OTHER.
067800*
067810     IF  MBCA-TRANS-LOOP-CONTROL IS EQUAL TO '@@'
067812         MOVE 'VERIFY CURRENCY CODE AND PRESS ENTER'
067814                                 TO MO05-ERR-MESSAGE
067816     END-IF.
067818*
067900     IF (MO05-CURRENCY-CODE-L IS LESS THAN 1
068000     AND MMOC-CURRENCY-CODE IS EQUAL TO SPACES)
068100     OR
068200         SMCUWS-RC-NO-CURRENCY-FOUND
068210     OR
068212         MBCA-TRANS-LOOP-CONTROL IS EQUAL TO '@@'
068300         MOVE DFHBMUBF           TO MO05-CURRENCY-CODE-A
068400         MOVE DFHBMASB           TO MO05-CURRENCY-CODE-LP-A
068500                                    MO05-CURRENCY-CODE-RP-A
068600         MOVE SS08WS-CURSOR      TO MO05-CURRENCY-CODE-L
068700         SET SS08WS-ERROR-SW-YES TO TRUE
068800     ELSE
068900         IF  MO05-CURRENCY-CODE-L IS LESS THAN 1
069000             MOVE DFHBMASK       TO MO05-CURRENCY-CODE-A
069100             MOVE DFHBMDAS       TO MO05-CURRENCY-CODE-LP-A
069200                                    MO05-CURRENCY-CODE-RP-A
069300             MOVE MMOC-CURRENCY-CODE
069400                             TO MO05-CURRENCY-CODE
069500         ELSE
069600             MOVE MO05-CURRENCY-CODE
069700                                 TO SMCUWS-CURRENCY-CODE
069800             PERFORM SMCUPXO-OBTAIN-CURRENCY-DATA
069900                THRU SMCUPXO-OCD-EXIT
070000             MOVE SMCUWS-RECORD  TO SMCU-RECORD
070100             IF  SMCUWS-RC-NO-CURRENCY-FOUND
070200             OR  SMCU-REC-PURGED
070300                 MOVE DFHBMUBF   TO MO05-CURRENCY-CODE-A
070400                 MOVE DFHBMASB   TO MO05-CURRENCY-CODE-LP-A
070500                                    MO05-CURRENCY-CODE-RP-A
070600                 MOVE SS08WS-CURSOR
070700                                 TO MO05-CURRENCY-CODE-L
070800                 SET SS08WS-ERROR-SW-YES
070900                                 TO TRUE
071000                 MOVE SPACES     TO MO05-CURRENCY-CODE-OTHER
071100             ELSE
071200                 MOVE SMCU-CURRENCY-CODE-OTHER
071300                                 TO MO05-CURRENCY-CODE-OTHER
071400                 MOVE DFHBMASF   TO MO05-CURRENCY-CODE-A
071500                 MOVE DFHBMDAS   TO MO05-CURRENCY-CODE-LP-A
071600                                    MO05-CURRENCY-CODE-RP-A
071700                 SET WS-UPDATE-SW-YES
071800                                 TO TRUE.
071900*
072000*            ***** CURRENCY NOD  *****                         *
072100*
072200     IF  MBCA-PTI-FUNCTION-IS-INQUIRY
072300         MOVE DFHBMASB           TO MO05-CURRENCY-NOD-A
072400     ELSE
072500         MOVE DFHBMASK           TO MO05-CURRENCY-NOD-A.
072600*
072700     MOVE DFHBMDAS               TO MO05-CURRENCY-NOD-LP-A
072800                                    MO05-CURRENCY-NOD-RP-A.
072900     MOVE MMOC-CURRENCY-NOD      TO MO05-CURRENCY-NOD.
073000*
073100*            ***** PERCENT NOD  *****                         *
073200*
073300     IF  MO05-PERCENT-NOD-L IS LESS THAN 1
073400     AND MMOC-PERCENT-NOD IS NOT EQUAL TO SPACES
073500         MOVE DFHBMASK           TO MO05-PERCENT-NOD-A
073600         MOVE DFHBMDAS           TO MO05-PERCENT-NOD-LP-A
073700                                    MO05-PERCENT-NOD-RP-A
073800         MOVE MMOC-PERCENT-NOD
073900                                 TO MO05-PERCENT-NOD
074000     ELSE
074100         IF  MO05-PERCENT-NOD-L IS LESS THAN 1
074200             MOVE DFHBMUBF       TO MO05-PERCENT-NOD-A
074300             MOVE DFHBMASB       TO MO05-PERCENT-NOD-LP-A
074400                                    MO05-PERCENT-NOD-RP-A
074500             MOVE SS08WS-CURSOR  TO MO05-PERCENT-NOD-L
074600             SET SS08WS-ERROR-SW-YES TO TRUE
074700         ELSE
074800             MOVE DFHBMASF       TO MO05-PERCENT-NOD-A
074900             MOVE DFHBMDAS       TO MO05-PERCENT-NOD-LP-A
075000                                    MO05-PERCENT-NOD-RP-A
075100             SET WS-UPDATE-SW-YES
075200                                 TO TRUE
075300             EVALUATE TRUE
075400                WHEN (MO05-PERCENT-NOD LESS THAN 0 OR
075500                      MO05-PERCENT-NOD GREATER THAN 7)
075600                MOVE DFHBMUBF       TO MO05-PERCENT-NOD-A
075700                MOVE DFHBMASB       TO MO05-PERCENT-NOD-LP-A
075800                                       MO05-PERCENT-NOD-RP-A
075900                MOVE SS08WS-CURSOR  TO MO05-PERCENT-NOD-L
076000                SET SS08WS-ERROR-SW-YES TO TRUE
076100                SET WS-UPDATE-SW-NO
076200                                    TO TRUE
076300                MOVE 'NOT A VALID PERCENT NOD '
076400                                    TO MO05-ERR-MESSAGE
076500             END-EVALUATE
076600         END-IF
076700     END-IF
076800*            ***** PER-ITEM-NOD *****                         *
076900*
077000     IF  MO05-PER-ITEM-NOD-L IS LESS THAN 1
077100     AND MMOC-PER-ITEM-NOD IS NOT EQUAL TO SPACES
077200         MOVE DFHBMASK           TO MO05-PER-ITEM-NOD-A
077300         MOVE DFHBMDAS           TO MO05-PER-ITEM-NOD-LP-A
077400                                    MO05-PER-ITEM-NOD-RP-A
077500         MOVE MMOC-PER-ITEM-NOD
077600                                 TO MO05-PER-ITEM-NOD
077700     ELSE
077800         IF  MO05-PER-ITEM-NOD-L IS LESS THAN 1
077900             MOVE DFHBMUBF       TO MO05-PER-ITEM-NOD-A
078000             MOVE DFHBMASB       TO MO05-PER-ITEM-NOD-LP-A
078100                                    MO05-PER-ITEM-NOD-RP-A
078200             MOVE SS08WS-CURSOR  TO MO05-PER-ITEM-NOD-L
078300             SET SS08WS-ERROR-SW-YES TO TRUE
078400         ELSE
078500             MOVE DFHBMASF       TO MO05-PER-ITEM-NOD-A
078600             MOVE DFHBMDAS       TO MO05-PER-ITEM-NOD-LP-A
078700                                    MO05-PER-ITEM-NOD-RP-A
078800             SET WS-UPDATE-SW-YES
078900                                 TO TRUE
079000             EVALUATE TRUE
079100                WHEN (MO05-PER-ITEM-NOD LESS THAN 0 OR
079200                      MO05-PER-ITEM-NOD GREATER THAN 9)
079300                MOVE DFHBMUBF       TO MO05-PER-ITEM-NOD-A
079400                MOVE DFHBMASB       TO MO05-PER-ITEM-NOD-LP-A
079500                                       MO05-PER-ITEM-NOD-RP-A
079600                MOVE SS08WS-CURSOR  TO MO05-PER-ITEM-NOD-L
079700                SET SS08WS-ERROR-SW-YES TO TRUE
079800                SET WS-UPDATE-SW-NO
079900                                    TO TRUE
080000                MOVE 'NOT A VALID PER-ITEM NOD'
080100                                    TO MO05-ERR-MESSAGE
080200             END-EVALUATE
080300         END-IF
080400     END-IF
080500*            ***** INTERCHANGE FAX *****                      *
080600*
080700     IF  MO05-INTCHG-FAX-L IS LESS THAN 1
080800         MOVE DFHBMASK           TO MO05-INTCHG-FAX-A
080900         MOVE DFHBMDAS           TO MO05-INTCHG-FAX-LP-A
081000                                    MO05-INTCHG-FAX-RP-A
081100         MOVE MMOC-ISSUER-RR-FAX-NBR
081200                                 TO MO05-INTCHG-FAX
081300     ELSE
081400         MOVE DFHBMASF           TO MO05-INTCHG-FAX-A
081500         MOVE DFHBMDAS           TO MO05-INTCHG-FAX-LP-A
081600                                    MO05-INTCHG-FAX-RP-A
081700         SET WS-UPDATE-SW-YES    TO TRUE.
081800*
081900*            ***** MERCHANT PRIMARY  *****                  *
082000*
082100     IF  MO05-MERCH-PRIM-L IS LESS THAN 1
082200         MOVE DFHBMASK           TO MO05-MERCH-PRIM-A
082300         MOVE DFHBMDAS           TO MO05-MERCH-PRIM-LP-A
082400                                    MO05-MERCH-PRIM-RP-A
082500         MOVE MMOC-MERCH-PRIMARY
082600                                 TO MO05-MERCH-PRIM
082700     ELSE
082800         IF  MO05-VALID-MERCH-PRIM
082900             MOVE DFHBMASF       TO MO05-MERCH-PRIM-A
083000             MOVE DFHBMDAS       TO MO05-MERCH-PRIM-LP-A
083100                                    MO05-MERCH-PRIM-RP-A
083200             SET WS-UPDATE-SW-YES
083300                                 TO TRUE
083400         ELSE
083500             MOVE DFHBMUBF       TO MO05-MERCH-PRIM-A
083600             MOVE DFHBMASB       TO MO05-MERCH-PRIM-LP-A
083700                                    MO05-MERCH-PRIM-RP-A
083800             MOVE SS08WS-CURSOR  TO MO05-MERCH-PRIM-L
083900             SET SS08WS-ERROR-SW-YES TO TRUE.
084000*
084100*            ***** CHECK DIGIT MERCHANT *****                  *
084200*
084300     IF  MO05-CHK-DIGIT-MERCH-L IS LESS THAN 1
084400         MOVE DFHBMASK           TO MO05-CHK-DIGIT-MERCH-A
084500         MOVE DFHBMDAS           TO MO05-CHK-DIGIT-MERCH-LP-A
084600                                    MO05-CHK-DIGIT-MERCH-RP-A
084700         MOVE MMOC-MERCHANT-MOD-CHECK
084800                                 TO MO05-CHK-DIGIT-MERCH
084900     ELSE
085000         IF  MO05-VALID-CHK-DIGIT-MERCH
085100             MOVE DFHBMASF       TO MO05-CHK-DIGIT-MERCH-A
085200             MOVE DFHBMDAS       TO MO05-CHK-DIGIT-MERCH-LP-A
085300                                    MO05-CHK-DIGIT-MERCH-RP-A
085400             SET WS-UPDATE-SW-YES
085500                                 TO TRUE
085600         ELSE
085700             MOVE DFHBMUBF       TO MO05-CHK-DIGIT-MERCH-A
085800             MOVE DFHBMASB       TO MO05-CHK-DIGIT-MERCH-LP-A
085900                                    MO05-CHK-DIGIT-MERCH-RP-A
086000             MOVE SS08WS-CURSOR  TO MO05-CHK-DIGIT-MERCH-L
086100             SET SS08WS-ERROR-SW-YES TO TRUE.
086200*
086300*            ***** MERCHANT SECONDARY *****                 *
086400*
086500     IF  MO05-MERCH-SEC-L IS LESS THAN 1
086600         MOVE DFHBMASK           TO MO05-MERCH-SEC-A
086700         MOVE DFHBMDAS           TO MO05-MERCH-SEC-LP-A
086800                                    MO05-MERCH-SEC-RP-A
086900         MOVE MMOC-MERCH-SECONDARY
087000                                 TO MO05-MERCH-SEC
087100     ELSE
087200         IF  MO05-VALID-MERCH-SEC
087300             MOVE DFHBMASF       TO MO05-MERCH-SEC-A
087400             MOVE DFHBMDAS       TO MO05-MERCH-SEC-LP-A
087500                                    MO05-MERCH-SEC-RP-A
087600             SET WS-UPDATE-SW-YES
087700                                 TO TRUE
087800         ELSE
087900             MOVE DFHBMUBF       TO MO05-MERCH-SEC-A
088000             MOVE DFHBMASB       TO MO05-MERCH-SEC-LP-A
088100                                    MO05-MERCH-SEC-RP-A
088200             MOVE SS08WS-CURSOR  TO MO05-MERCH-SEC-L
088300             SET SS08WS-ERROR-SW-YES TO TRUE.
088400*
088500*            ***** MERCHANT DBA *****                 *
088600*
088700     IF  MO05-MERCH-DBA-L IS LESS THAN 1
088800         MOVE DFHBMASK           TO MO05-MERCH-DBA-A
088900         MOVE DFHBMDAS           TO MO05-MERCH-DBA-LP-A
089000                                    MO05-MERCH-DBA-RP-A
089100         MOVE MMOC-MERCH-DBA     TO MO05-MERCH-DBA
089200     ELSE
089300         IF  MO05-VALID-MERCH-DBA
089400             MOVE DFHBMASF       TO MO05-MERCH-DBA-A
089500             MOVE DFHBMDAS       TO MO05-MERCH-DBA-LP-A
089600                                    MO05-MERCH-DBA-RP-A
089700             SET WS-UPDATE-SW-YES
089800                                 TO TRUE
089900         ELSE
090000             MOVE DFHBMUBF       TO MO05-MERCH-DBA-A
090100             MOVE DFHBMASB       TO MO05-MERCH-DBA-LP-A
090200                                    MO05-MERCH-DBA-RP-A
090300             MOVE SS08WS-CURSOR  TO MO05-MERCH-DBA-L
090400             SET SS08WS-ERROR-SW-YES TO TRUE.
090500*
090600*            ***** CHECK DIGIT STORE *****                  *
090700*
090800     IF  MO05-CHK-DIGIT-STORE-L IS LESS THAN 1
090900         MOVE DFHBMASK           TO MO05-CHK-DIGIT-STORE-A
091000         MOVE DFHBMDAS           TO MO05-CHK-DIGIT-STORE-LP-A
091100                                    MO05-CHK-DIGIT-STORE-RP-A
091200         MOVE MMOC-STORE-MOD-CHECK
091300                                 TO MO05-CHK-DIGIT-STORE
091400     ELSE
091500         IF  MO05-VALID-CHK-DIGIT-STORE
091600             MOVE DFHBMASF       TO MO05-CHK-DIGIT-STORE-A
091700             MOVE DFHBMDAS       TO MO05-CHK-DIGIT-STORE-LP-A
091800                                    MO05-CHK-DIGIT-STORE-RP-A
091900             SET WS-UPDATE-SW-YES
092000                                 TO TRUE
092100         ELSE
092200             MOVE DFHBMUBF       TO MO05-CHK-DIGIT-STORE-A
092300             MOVE DFHBMASB       TO MO05-CHK-DIGIT-STORE-LP-A
092400                                    MO05-CHK-DIGIT-STORE-RP-A
092500             MOVE SS08WS-CURSOR  TO MO05-CHK-DIGIT-STORE-L
092600             SET SS08WS-ERROR-SW-YES TO TRUE.
092700*
092800*            ***** STORE PRIMARY  *****                  *
092900*
093000     IF  MO05-STORE-PRIM-L IS LESS THAN 1
093100         MOVE DFHBMASK           TO MO05-STORE-PRIM-A
093200         MOVE DFHBMDAS           TO MO05-STORE-PRIM-LP-A
093300                                    MO05-STORE-PRIM-RP-A
093400         MOVE MMOC-STORE-PRIMARY TO MO05-STORE-PRIM
093500     ELSE
093600         IF  MO05-VALID-STORE-PRIM
093700             MOVE DFHBMASF       TO MO05-STORE-PRIM-A
093800             MOVE DFHBMDAS       TO MO05-STORE-PRIM-LP-A
093900                                    MO05-STORE-PRIM-RP-A
094000             SET WS-UPDATE-SW-YES
094100                                 TO TRUE
094200         ELSE
094300             MOVE DFHBMUBF       TO MO05-STORE-PRIM-A
094400             MOVE DFHBMASB       TO MO05-STORE-PRIM-LP-A
094500                                    MO05-STORE-PRIM-RP-A
094600             MOVE SS08WS-CURSOR  TO MO05-STORE-PRIM-L
094700             SET SS08WS-ERROR-SW-YES TO TRUE.
094800*
094900*            ***** STORE SECONDARY *****                 *
095000*
095100     IF  MO05-STORE-SEC-L IS LESS THAN 1
095200         MOVE DFHBMASK           TO MO05-STORE-SEC-A
095300         MOVE DFHBMDAS           TO MO05-STORE-SEC-LP-A
095400                                    MO05-STORE-SEC-RP-A
095500         MOVE MMOC-STORE-SECONDARY
095600                                 TO MO05-STORE-SEC
095700     ELSE
095800         IF  MO05-VALID-STORE-SEC
095900             MOVE DFHBMASF       TO MO05-STORE-SEC-A
096000             MOVE DFHBMDAS       TO MO05-STORE-SEC-LP-A
096100                                    MO05-STORE-SEC-RP-A
096200             SET WS-UPDATE-SW-YES
096300                                 TO TRUE
096400         ELSE
096500             MOVE DFHBMUBF       TO MO05-STORE-SEC-A
096600             MOVE DFHBMASB       TO MO05-STORE-SEC-LP-A
096700                                    MO05-STORE-SEC-RP-A
096800             MOVE SS08WS-CURSOR  TO MO05-STORE-SEC-L
096900             SET SS08WS-ERROR-SW-YES TO TRUE.
097000*
097100*            ***** STORE    DBA *****                 *
097200*
097300     IF  MO05-STORE-DBA-L IS LESS THAN 1
097400         MOVE DFHBMASK           TO MO05-STORE-DBA-A
097500         MOVE DFHBMDAS           TO MO05-STORE-DBA-LP-A
097600                                    MO05-STORE-DBA-RP-A
097700         MOVE MMOC-STORE-DBA     TO MO05-STORE-DBA
097800     ELSE
097900         IF  MO05-VALID-STORE-DBA
098000             MOVE DFHBMASF       TO MO05-STORE-DBA-A
098100             MOVE DFHBMDAS       TO MO05-STORE-DBA-LP-A
098200                                    MO05-STORE-DBA-RP-A
098300             SET WS-UPDATE-SW-YES
098400                                 TO TRUE
098500         ELSE
098600             MOVE DFHBMUBF       TO MO05-STORE-DBA-A
098700             MOVE DFHBMASB       TO MO05-STORE-DBA-LP-A
098800                                    MO05-STORE-DBA-RP-A
098900             MOVE SS08WS-CURSOR  TO MO05-STORE-DBA-L
099000             SET SS08WS-ERROR-SW-YES TO TRUE.
099100*
099200*            ***** CREDIT PLAN STATS MERCHANT *****            *
099300*
099400     IF  MO05-CR-PLAN-MERCH-L IS LESS THAN 1
099500         MOVE DFHBMASK           TO MO05-CR-PLAN-MERCH-A
099600         MOVE DFHBMDAS           TO MO05-CR-PLAN-MERCH-LP-A
099700                                    MO05-CR-PLAN-MERCH-RP-A
099800         MOVE MMOC-CR-PLAN-ON-MERCH
099900                                 TO MO05-CR-PLAN-MERCH
100000     ELSE
100100         IF  MO05-VALID-CR-PLAN-MERCH
100200             MOVE DFHBMASF       TO MO05-CR-PLAN-MERCH-A
100300             MOVE DFHBMDAS       TO MO05-CR-PLAN-MERCH-LP-A
100400                                    MO05-CR-PLAN-MERCH-RP-A
100500             SET WS-UPDATE-SW-YES
100600                                 TO TRUE
100700         ELSE
100800             MOVE DFHBMUBF       TO MO05-CR-PLAN-MERCH-A
100900             MOVE DFHBMASB       TO MO05-CR-PLAN-MERCH-LP-A
101000                                    MO05-CR-PLAN-MERCH-RP-A
101100             MOVE SS08WS-CURSOR  TO MO05-CR-PLAN-MERCH-L
101200             SET SS08WS-ERROR-SW-YES TO TRUE.
101300*
101400*            ***** CHAIN PRIMARY *****                 *
101500*
101600     IF  MO05-CHAIN-PRIM-L IS LESS THAN 1
101700         MOVE DFHBMASK           TO MO05-CHAIN-PRIM-A
101800         MOVE DFHBMDAS           TO MO05-CHAIN-PRIM-LP-A
101900                                    MO05-CHAIN-PRIM-RP-A
102000         MOVE MMOC-CHAIN-PRIMARY TO MO05-CHAIN-PRIM
102100     ELSE
102200         IF  MO05-VALID-CHAIN-PRIM
102300             MOVE DFHBMASF       TO MO05-CHAIN-PRIM-A
102400             MOVE DFHBMDAS       TO MO05-CHAIN-PRIM-LP-A
102500                                    MO05-CHAIN-PRIM-RP-A
102600             SET WS-UPDATE-SW-YES
102700                                 TO TRUE
102800         ELSE
102900             MOVE DFHBMUBF       TO MO05-CHAIN-PRIM-A
103000             MOVE DFHBMASB       TO MO05-CHAIN-PRIM-LP-A
103100                                    MO05-CHAIN-PRIM-RP-A
103200             MOVE SS08WS-CURSOR  TO MO05-CHAIN-PRIM-L
103300             SET SS08WS-ERROR-SW-YES TO TRUE.
103400*
103500*            ***** CREDIT PLAN STATS STORE *****               *
103600*
103700     IF  MO05-CR-PLAN-STORE-L IS LESS THAN 1
103800         MOVE DFHBMASK           TO MO05-CR-PLAN-STORE-A
103900         MOVE DFHBMDAS           TO MO05-CR-PLAN-STORE-LP-A
104000                                    MO05-CR-PLAN-STORE-RP-A
104100         MOVE MMOC-CR-PLAN-ON-STORE
104200                                 TO MO05-CR-PLAN-STORE
104300     ELSE
104400         IF  MO05-VALID-CR-PLAN-STORE
104500             MOVE DFHBMASF       TO MO05-CR-PLAN-STORE-A
104600             MOVE DFHBMDAS       TO MO05-CR-PLAN-STORE-LP-A
104700                                    MO05-CR-PLAN-STORE-RP-A
104800             SET WS-UPDATE-SW-YES
104900                                 TO TRUE
105000         ELSE
105100             MOVE DFHBMUBF       TO MO05-CR-PLAN-STORE-A
105200             MOVE DFHBMASB       TO MO05-CR-PLAN-STORE-LP-A
105300                                    MO05-CR-PLAN-STORE-RP-A
105400             MOVE SS08WS-CURSOR  TO MO05-CR-PLAN-STORE-L
105500             SET SS08WS-ERROR-SW-YES TO TRUE.
105600*
105700*            ***** CREDIT PLAN STATS CHAIN *****               *
105800*
105900     IF  MO05-CR-PLAN-CHAIN-L IS LESS THAN 1
106000         MOVE DFHBMASK           TO MO05-CR-PLAN-CHAIN-A
106100         MOVE DFHBMDAS           TO MO05-CR-PLAN-CHAIN-LP-A
106200                                    MO05-CR-PLAN-CHAIN-RP-A
106300         MOVE MMOC-CR-PLAN-ON-CHAIN
106400                                 TO MO05-CR-PLAN-CHAIN
106500     ELSE
106600         IF  MO05-VALID-CR-PLAN-CHAIN
106700             MOVE DFHBMASF       TO MO05-CR-PLAN-CHAIN-A
106800             MOVE DFHBMDAS       TO MO05-CR-PLAN-CHAIN-LP-A
106900                                    MO05-CR-PLAN-CHAIN-RP-A
107000             SET WS-UPDATE-SW-YES
107100                                 TO TRUE
107200         ELSE
107300             MOVE DFHBMUBF       TO MO05-CR-PLAN-CHAIN-A
107400             MOVE DFHBMASB       TO MO05-CR-PLAN-CHAIN-LP-A
107500                                    MO05-CR-PLAN-CHAIN-RP-A
107600             MOVE SS08WS-CURSOR  TO MO05-CR-PLAN-CHAIN-L
107700             SET SS08WS-ERROR-SW-YES TO TRUE.
107800*
107900*            ***** STORE CHAIN PRIMARY *****            *
108000*
108100     IF  MO05-STORE-CHAIN-PRIM-L IS LESS THAN 1
108200         MOVE DFHBMASK           TO MO05-STORE-CHAIN-PRIM-A
108300         MOVE DFHBMDAS           TO MO05-STORE-CHAIN-PRIM-LP-A
108400                                    MO05-STORE-CHAIN-PRIM-RP-A
108500         MOVE MMOC-STORE-CHAIN-PRIMARY
108600                                 TO MO05-STORE-CHAIN-PRIM
108700     ELSE
108800         IF  MO05-VALID-STORE-CHAIN-PRIM
108900             MOVE DFHBMASF       TO MO05-STORE-CHAIN-PRIM-A
109000             MOVE DFHBMDAS       TO MO05-STORE-CHAIN-PRIM-LP-A
109100                                    MO05-STORE-CHAIN-PRIM-RP-A
109200             SET WS-UPDATE-SW-YES
109300                                 TO TRUE
109400         ELSE
109500             MOVE DFHBMUBF       TO MO05-STORE-CHAIN-PRIM-A
109600             MOVE DFHBMASB       TO MO05-STORE-CHAIN-PRIM-LP-A
109700                                    MO05-STORE-CHAIN-PRIM-RP-A
109800             MOVE SS08WS-CURSOR  TO MO05-STORE-CHAIN-PRIM-L
109900             SET SS08WS-ERROR-SW-YES TO TRUE.
110000*
110100*            ***** CREDIT PLAN STATS STORE CHAIN *****         *
110200*
110300     IF  MO05-CR-PLAN-S-CHAIN-L IS LESS THAN 1
110400         MOVE DFHBMASK           TO MO05-CR-PLAN-S-CHAIN-A
110500         MOVE DFHBMDAS           TO MO05-CR-PLAN-S-CHAIN-LP-A
110600                                    MO05-CR-PLAN-S-CHAIN-RP-A
110700         MOVE MMOC-CR-PLAN-ON-STORE-CHAIN
110800                                 TO MO05-CR-PLAN-S-CHAIN
110900     ELSE
111000         IF  MO05-VALID-CR-PLAN-S-CHAIN
111100             MOVE DFHBMASF       TO MO05-CR-PLAN-S-CHAIN-A
111200             MOVE DFHBMDAS       TO MO05-CR-PLAN-S-CHAIN-LP-A
111300                                    MO05-CR-PLAN-S-CHAIN-RP-A
111400             SET WS-UPDATE-SW-YES
111500                                 TO TRUE
111600         ELSE
111700             MOVE DFHBMUBF       TO MO05-CR-PLAN-S-CHAIN-A
111800             MOVE DFHBMASB       TO MO05-CR-PLAN-S-CHAIN-LP-A
111900                                    MO05-CR-PLAN-S-CHAIN-RP-A
112000             MOVE SS08WS-CURSOR  TO MO05-CR-PLAN-S-CHAIN-L
112100             SET SS08WS-ERROR-SW-YES TO TRUE.
112200*
112300*            ***** MERCH CLOSE FLAG     *****                  *
112400*
112500     IF  MO05-MERCH-CLOSE-FLAG-L IS LESS THAN 1
112600         MOVE DFHBMASK           TO MO05-MERCH-CLOSE-FLAG-A
112700         MOVE DFHBMDAS           TO MO05-MERCH-CLOSE-FLAG-LP-A
112800                                    MO05-MERCH-CLOSE-FLAG-RP-A
112900         MOVE MMOC-AUTO-CLOSE-FLAG (1)
113000                                 TO MO05-MERCH-CLOSE-FLAG
113100     ELSE
113200         IF  MO05-VALID-MERCH-CLOSE-FLAG
113300             MOVE DFHBMASF       TO MO05-MERCH-CLOSE-FLAG-A
113400             MOVE DFHBMDAS       TO MO05-MERCH-CLOSE-FLAG-LP-A
113500                                    MO05-MERCH-CLOSE-FLAG-RP-A
113600             SET WS-UPDATE-SW-YES
113700                                 TO TRUE
113800         ELSE
113900             MOVE DFHBMUBF       TO MO05-MERCH-CLOSE-FLAG-A
114000             MOVE DFHBMASB       TO MO05-MERCH-CLOSE-FLAG-LP-A
114100                                    MO05-MERCH-CLOSE-FLAG-RP-A
114200             MOVE SS08WS-CURSOR  TO MO05-MERCH-CLOSE-FLAG-L
114300             SET SS08WS-ERROR-SW-YES TO TRUE.
114400*
114500*            ***** MERCH CLOSE MONTHS   *****                  *
114600*
114700     IF  MO05-MERCH-CLOSE-MOS-L IS LESS THAN 1
114800         MOVE DFHBMASK           TO MO05-MERCH-CLOSE-MOS-A
114900         MOVE DFHBMDAS           TO MO05-MERCH-CLOSE-MOS-LP-A
115000                                    MO05-MERCH-CLOSE-MOS-RP-A
115100         MOVE MMOC-AUTO-CLOSE-MONTHS (1)
115200                                 TO MO05-MERCH-CLOSE-MOS
115300     ELSE
115400         IF  MO05-MERCH-CLOSE-MOS IS NUMERIC
115500         AND MO05-MERCH-CLOSE-MOS IS LESS THAN 13
115600             MOVE DFHBMASF       TO MO05-MERCH-CLOSE-MOS-A
115700             MOVE DFHBMDAS       TO MO05-MERCH-CLOSE-MOS-LP-A
115800                                    MO05-MERCH-CLOSE-MOS-RP-A
115900             SET WS-UPDATE-SW-YES
116000                                 TO TRUE
116100         ELSE
116200             MOVE DFHBMNBF       TO MO05-MERCH-CLOSE-MOS-A
116300             MOVE DFHBMASB       TO MO05-MERCH-CLOSE-MOS-LP-A
116400                                    MO05-MERCH-CLOSE-MOS-RP-A
116500             MOVE SS08WS-CURSOR  TO MO05-MERCH-CLOSE-MOS-L
116600             SET SS08WS-ERROR-SW-YES TO TRUE.
116700*
116800*            ***** MERCH CLOSE FREQ1    *****                  *
116900*
117000     MOVE DFHBMDAS               TO MO05-MERCH-CLOSE-FREQS-LP-A
117100                                    MO05-MERCH-CLOSE-FREQS-RP-A.
117200*
117300     IF  MO05-MERCH-CLOSE-FREQ1-L IS LESS THAN 1
117400         MOVE DFHBMASK           TO MO05-MERCH-CLOSE-FREQ1-A
117500         MOVE MMOC-AUTO-CLOSE-FREQ-1 (1)
117600                                 TO MO05-MERCH-CLOSE-FREQ1
117700     ELSE
117800         IF  MO05-MERCH-CLOSE-FREQ1 IS NUMERIC
117900         AND MO05-VALID-MERCH-CLOSE-FREQ1
118000             MOVE DFHBMASF       TO MO05-MERCH-CLOSE-FREQ1-A
118100             SET WS-UPDATE-SW-YES
118200                                 TO TRUE
118300         ELSE
118400             MOVE DFHBMNBF       TO MO05-MERCH-CLOSE-FREQ1-A
118500             MOVE DFHBMASB       TO MO05-MERCH-CLOSE-FREQS-LP-A
118600                                    MO05-MERCH-CLOSE-FREQS-RP-A
118700             MOVE SS08WS-CURSOR  TO MO05-MERCH-CLOSE-FREQ1-L
118800             SET SS08WS-ERROR-SW-YES TO TRUE.
118900*
119000*            ***** MERCH CLOSE FREQ2    *****                  *
119100*
119200     IF  MO05-MERCH-CLOSE-FREQ2-L IS LESS THAN 1
119300         MOVE DFHBMASK           TO MO05-MERCH-CLOSE-FREQ2-A
119400         MOVE MMOC-AUTO-CLOSE-FREQ-2 (1)
119500                                 TO MO05-MERCH-CLOSE-FREQ2
119600     ELSE
119700         IF  MO05-MERCH-CLOSE-FREQ2 IS NUMERIC
119800         AND MO05-VALID-MERCH-CLOSE-FREQ2
119900             MOVE DFHBMASF       TO MO05-MERCH-CLOSE-FREQ2-A
120000             SET WS-UPDATE-SW-YES
120100                                 TO TRUE
120200         ELSE
120300             MOVE DFHBMNBF       TO MO05-MERCH-CLOSE-FREQ2-A
120400             MOVE DFHBMASB       TO MO05-MERCH-CLOSE-FREQS-LP-A
120500                                    MO05-MERCH-CLOSE-FREQS-RP-A
120600             MOVE SS08WS-CURSOR  TO MO05-MERCH-CLOSE-FREQ2-L
120700             SET SS08WS-ERROR-SW-YES TO TRUE.
120800*
120900*            ***** MERCH PURGE FLAG     *****                  *
121000*
121100     IF  MO05-MERCH-PURGE-FLAG-L IS LESS THAN 1
121200         MOVE DFHBMASK           TO MO05-MERCH-PURGE-FLAG-A
121300         MOVE DFHBMDAS           TO MO05-MERCH-PURGE-FLAG-LP-A
121400                                    MO05-MERCH-PURGE-FLAG-RP-A
121500         MOVE MMOC-AUTO-PURGE-FLAG (1)
121600                                 TO MO05-MERCH-PURGE-FLAG
121700     ELSE
121800         IF  MO05-VALID-MERCH-PURGE-FLAG
121900             MOVE DFHBMASF       TO MO05-MERCH-PURGE-FLAG-A
122000             MOVE DFHBMDAS       TO MO05-MERCH-PURGE-FLAG-LP-A
122100                                    MO05-MERCH-PURGE-FLAG-RP-A
122200             SET WS-UPDATE-SW-YES
122300                                 TO TRUE
122400         ELSE
122500             MOVE DFHBMUBF       TO MO05-MERCH-PURGE-FLAG-A
122600             MOVE DFHBMASB       TO MO05-MERCH-PURGE-FLAG-LP-A
122700                                    MO05-MERCH-PURGE-FLAG-RP-A
122800             MOVE SS08WS-CURSOR  TO MO05-MERCH-PURGE-FLAG-L
122900             SET SS08WS-ERROR-SW-YES TO TRUE.
123000*
123100*            ***** MERCH PURGE MONTHS   *****                  *
123200*
123300     IF  MO05-MERCH-PURGE-MOS-L IS LESS THAN 1
123400         MOVE DFHBMASK           TO MO05-MERCH-PURGE-MOS-A
123500         MOVE DFHBMDAS           TO MO05-MERCH-PURGE-MOS-LP-A
123600                                    MO05-MERCH-PURGE-MOS-RP-A
123700         MOVE MMOC-AUTO-PURGE-MONTHS (1)
123800                                 TO MO05-MERCH-PURGE-MOS
123900     ELSE
124000         IF  MO05-MERCH-PURGE-MOS IS NUMERIC
124100         AND MO05-MERCH-PURGE-MOS IS LESS THAN 13
124200             MOVE DFHBMASF       TO MO05-MERCH-PURGE-MOS-A
124300             MOVE DFHBMDAS       TO MO05-MERCH-PURGE-MOS-LP-A
124400                                    MO05-MERCH-PURGE-MOS-RP-A
124500             SET WS-UPDATE-SW-YES
124600                                 TO TRUE
124700         ELSE
124800             MOVE DFHBMNBF       TO MO05-MERCH-PURGE-MOS-A
124900             MOVE DFHBMASB       TO MO05-MERCH-PURGE-MOS-LP-A
125000                                    MO05-MERCH-PURGE-MOS-RP-A
125100             MOVE SS08WS-CURSOR  TO MO05-MERCH-PURGE-MOS-L
125200             SET SS08WS-ERROR-SW-YES TO TRUE.
125300*
125400*            ***** MERCH PURGE FREQ1    *****                  *
125500*
125600     MOVE DFHBMDAS               TO MO05-MERCH-PURGE-FREQS-LP-A
125700                                    MO05-MERCH-PURGE-FREQS-RP-A.
125800*
125900     IF  MO05-MERCH-PURGE-FREQ1-L IS LESS THAN 1
126000         MOVE DFHBMASK           TO MO05-MERCH-PURGE-FREQ1-A
126100         MOVE MMOC-AUTO-PURGE-FREQ-1 (1)
126200                                 TO MO05-MERCH-PURGE-FREQ1
126300     ELSE
126400         IF  MO05-MERCH-PURGE-FREQ1 IS NUMERIC
126500         AND MO05-VALID-MERCH-PURGE-FREQ1
126600             MOVE DFHBMASF       TO MO05-MERCH-PURGE-FREQ1-A
126700             SET WS-UPDATE-SW-YES
126800                                 TO TRUE
126900         ELSE
127000             MOVE DFHBMNBF       TO MO05-MERCH-PURGE-FREQ1-A
127100             MOVE DFHBMASB       TO MO05-MERCH-PURGE-FREQS-LP-A
127200                                    MO05-MERCH-PURGE-FREQS-RP-A
127300             MOVE SS08WS-CURSOR  TO MO05-MERCH-PURGE-FREQ1-L
127400             SET SS08WS-ERROR-SW-YES TO TRUE.
127500*
127600*            ***** MERCH PURGE FREQ2    *****                  *
127700*
127800     IF  MO05-MERCH-PURGE-FREQ2-L IS LESS THAN 1
127900         MOVE DFHBMASK           TO MO05-MERCH-PURGE-FREQ2-A
128000         MOVE MMOC-AUTO-PURGE-FREQ-2 (1)
128100                                 TO MO05-MERCH-PURGE-FREQ2
128200     ELSE
128300         IF  MO05-MERCH-PURGE-FREQ2 IS NUMERIC
128400         AND MO05-VALID-MERCH-PURGE-FREQ2
128500             MOVE DFHBMASF       TO MO05-MERCH-PURGE-FREQ2-A
128600             SET WS-UPDATE-SW-YES
128700                                 TO TRUE
128800         ELSE
128900             MOVE DFHBMNBF       TO MO05-MERCH-PURGE-FREQ2-A
129000             MOVE DFHBMASB       TO MO05-MERCH-PURGE-FREQS-LP-A
129100                                    MO05-MERCH-PURGE-FREQS-RP-A
129200             MOVE SS08WS-CURSOR  TO MO05-MERCH-PURGE-FREQ2-L
129300             SET SS08WS-ERROR-SW-YES TO TRUE.
129400*
129500*            ***** MERCH PURGE DAYS     *****                  *
129600*
129700     IF  MO05-MERCH-PURGE-DAYS-L IS LESS THAN 1
129800         MOVE DFHBMASK           TO MO05-MERCH-PURGE-DAYS-A
129900         MOVE DFHBMDAS           TO MO05-MERCH-PURGE-DAYS-LP-A
130000                                    MO05-MERCH-PURGE-DAYS-RP-A
130100         MOVE MMOC-FINAL-PURGE-DAYS
130200                                 TO MO05-MERCH-PURGE-DAYS
130300     ELSE
130400         IF  MO05-MERCH-PURGE-DAYS IS NUMERIC
130500             MOVE DFHBMASF       TO MO05-MERCH-PURGE-DAYS-A
130600             MOVE DFHBMDAS       TO MO05-MERCH-PURGE-DAYS-LP-A
130700                                    MO05-MERCH-PURGE-DAYS-RP-A
130800             SET WS-UPDATE-SW-YES
130900                                 TO TRUE
131000         ELSE
131100             MOVE DFHBMNBF       TO MO05-MERCH-PURGE-DAYS-A
131200             MOVE DFHBMASB       TO MO05-MERCH-PURGE-DAYS-LP-A
131300                                    MO05-MERCH-PURGE-DAYS-RP-A
131400             MOVE SS08WS-CURSOR  TO MO05-MERCH-PURGE-DAYS-L
131500             SET SS08WS-ERROR-SW-YES TO TRUE.
131600*
131700*            ***** STORE CLOSE FLAG     *****                  *
131800*
131900     IF  MO05-STORE-CLOSE-FLAG-L IS LESS THAN 1
132000         MOVE DFHBMASK           TO MO05-STORE-CLOSE-FLAG-A
132100         MOVE DFHBMDAS           TO MO05-STORE-CLOSE-FLAG-LP-A
132200                                    MO05-STORE-CLOSE-FLAG-RP-A
132300         MOVE MMOC-AUTO-CLOSE-FLAG (2)
132400                                 TO MO05-STORE-CLOSE-FLAG
132500     ELSE
132600         IF  MO05-VALID-STORE-CLOSE-FLAG
132700             MOVE DFHBMASF       TO MO05-STORE-CLOSE-FLAG-A
132800             MOVE DFHBMDAS       TO MO05-STORE-CLOSE-FLAG-LP-A
132900                                    MO05-STORE-CLOSE-FLAG-RP-A
133000             SET WS-UPDATE-SW-YES
133100                                 TO TRUE
133200         ELSE
133300             MOVE DFHBMUBF       TO MO05-STORE-CLOSE-FLAG-A
133400             MOVE DFHBMASB       TO MO05-STORE-CLOSE-FLAG-LP-A
133500                                    MO05-STORE-CLOSE-FLAG-RP-A
133600             MOVE SS08WS-CURSOR  TO MO05-STORE-CLOSE-FLAG-L
133700             SET SS08WS-ERROR-SW-YES TO TRUE.
133800*
133900*            ***** STORE CLOSE MONTHS   *****                  *
134000*
134100     IF  MO05-STORE-CLOSE-MOS-L IS LESS THAN 1
134200         MOVE DFHBMASK           TO MO05-STORE-CLOSE-MOS-A
134300         MOVE DFHBMDAS           TO MO05-STORE-CLOSE-MOS-LP-A
134400                                    MO05-STORE-CLOSE-MOS-RP-A
134500         MOVE MMOC-AUTO-CLOSE-MONTHS (2)
134600                                 TO MO05-STORE-CLOSE-MOS
134700     ELSE
134800         IF  MO05-STORE-CLOSE-MOS IS NUMERIC
134900         AND MO05-STORE-CLOSE-MOS IS LESS THAN 13
135000             MOVE DFHBMASF       TO MO05-STORE-CLOSE-MOS-A
135100             MOVE DFHBMDAS       TO MO05-STORE-CLOSE-MOS-LP-A
135200                                    MO05-STORE-CLOSE-MOS-RP-A
135300             SET WS-UPDATE-SW-YES
135400                                 TO TRUE
135500         ELSE
135600             MOVE DFHBMNBF       TO MO05-STORE-CLOSE-MOS-A
135700             MOVE DFHBMASB       TO MO05-STORE-CLOSE-MOS-LP-A
135800                                    MO05-STORE-CLOSE-MOS-RP-A
135900             MOVE SS08WS-CURSOR  TO MO05-STORE-CLOSE-MOS-L
136000             SET SS08WS-ERROR-SW-YES TO TRUE.
136100*
136200*            ***** STORE CLOSE FREQ1    *****                  *
136300*
136400     MOVE DFHBMDAS               TO MO05-STORE-CLOSE-FREQS-LP-A
136500                                    MO05-STORE-CLOSE-FREQS-RP-A.
136600*
136700     IF  MO05-STORE-CLOSE-FREQ1-L IS LESS THAN 1
136800         MOVE DFHBMASK           TO MO05-STORE-CLOSE-FREQ1-A
136900         MOVE MMOC-AUTO-CLOSE-FREQ-1 (2)
137000                                 TO MO05-STORE-CLOSE-FREQ1
137100     ELSE
137200         IF  MO05-STORE-CLOSE-FREQ1 IS NUMERIC
137300         AND MO05-VALID-STORE-CLOSE-FREQ1
137400             MOVE DFHBMASF       TO MO05-STORE-CLOSE-FREQ1-A
137500             SET WS-UPDATE-SW-YES
137600                                 TO TRUE
137700         ELSE
137800             MOVE DFHBMNBF       TO MO05-STORE-CLOSE-FREQ1-A
137900             MOVE DFHBMASB       TO MO05-STORE-CLOSE-FREQS-LP-A
138000                                    MO05-STORE-CLOSE-FREQS-RP-A
138100             MOVE SS08WS-CURSOR  TO MO05-STORE-CLOSE-FREQ1-L
138200             SET SS08WS-ERROR-SW-YES TO TRUE.
138300*
138400*            ***** STORE CLOSE FREQ2    *****                  *
138500*
138600     IF  MO05-STORE-CLOSE-FREQ2-L IS LESS THAN 1
138700         MOVE DFHBMASK           TO MO05-STORE-CLOSE-FREQ2-A
138800         MOVE MMOC-AUTO-CLOSE-FREQ-2 (2)
138900                                 TO MO05-STORE-CLOSE-FREQ2
139000     ELSE
139100         IF  MO05-STORE-CLOSE-FREQ2 IS NUMERIC
139200         AND MO05-VALID-STORE-CLOSE-FREQ2
139300             MOVE DFHBMASF       TO MO05-STORE-CLOSE-FREQ2-A
139400             SET WS-UPDATE-SW-YES
139500                                 TO TRUE
139600         ELSE
139700             MOVE DFHBMNBF       TO MO05-STORE-CLOSE-FREQ2-A
139800             MOVE DFHBMASB       TO MO05-STORE-CLOSE-FREQS-LP-A
139900                                    MO05-STORE-CLOSE-FREQS-RP-A
140000             MOVE SS08WS-CURSOR  TO MO05-STORE-CLOSE-FREQ2-L
140100             SET SS08WS-ERROR-SW-YES TO TRUE.
140200*                                                                 EH800900
140300*            ***** M/C QUARTERLY REPORT FLAG                   *  EH800900
140400*                                                                 EH800900
140500     IF  MO05-MC-QTR-FLAG-L IS LESS THAN 1                        EH800900
140600         MOVE DFHBMASK           TO MO05-MC-QTR-FLAG-A            EH800900
140700         MOVE DFHBMDAS           TO MO05-MC-QTR-FLAG-LP-A         EH800900
140800                                    MO05-MC-QTR-FLAG-RP-A         EH800900
140900         MOVE MMOC-MC-QTR-FLAG TO MO05-MC-QTR-FLAG                EH800900
141000     ELSE                                                         EH800900
141100         IF  MO05-VALID-MC-QTR-FLAG                               EH800900
141200             MOVE DFHBMASF       TO MO05-MC-QTR-FLAG-A            EH800900
141300             MOVE DFHBMDAS       TO MO05-MC-QTR-FLAG-LP-A         EH800900
141400                                    MO05-MC-QTR-FLAG-RP-A         EH800900
141500             SET WS-UPDATE-SW-YES                                 EH800900
141600                                 TO TRUE                          EH800900
141700         ELSE                                                     EH800900
141800             MOVE DFHBMUBF       TO MO05-MC-QTR-FLAG-A            EH800900
141900             MOVE DFHBMASB       TO MO05-MC-QTR-FLAG-LP-A         EH800900
142000                                    MO05-MC-QTR-FLAG-RP-A         EH800900
142100             MOVE SS08WS-CURSOR  TO MO05-MC-QTR-FLAG-L            EH800900
142200             SET SS08WS-ERROR-SW-YES TO TRUE.
142210*                                                                 EH800900
142212*            ***** VISA QUARTERLY REPORT FLAG                  *  EH800900
142214*                                                                 EH800900
142216     IF  MO05-VISA-QTR-FLAG-L IS LESS THAN 1                      EH800900
142218         MOVE DFHBMASK           TO MO05-VISA-QTR-FLAG-A          EH800900
142220         MOVE DFHBMDAS           TO MO05-VISA-QTR-FLAG-LP-A       EH800900
142222                                    MO05-VISA-QTR-FLAG-RP-A       EH800900
142224         MOVE MMOC-VISA-QTR-FLAG TO MO05-VISA-QTR-FLAG            EH800900
142226     ELSE                                                         EH800900
142228         IF  MO05-VALID-VISA-QTR-FLAG                             EH800900
142230             MOVE DFHBMASF       TO MO05-VISA-QTR-FLAG-A          EH800900
142232             MOVE DFHBMDAS       TO MO05-VISA-QTR-FLAG-LP-A       EH800900
142234                                    MO05-VISA-QTR-FLAG-RP-A       EH800900
142236             SET WS-UPDATE-SW-YES                                 EH800900
142238                                 TO TRUE                          EH800900
142240         ELSE                                                     EH800900
142242             MOVE DFHBMUBF       TO MO05-VISA-QTR-FLAG-A          EH800900
142244             MOVE DFHBMASB       TO MO05-VISA-QTR-FLAG-LP-A       EH800900
142246                                    MO05-VISA-QTR-FLAG-RP-A       EH800900
142248             MOVE SS08WS-CURSOR  TO MO05-VISA-QTR-FLAG-L          EH800900
142250             SET SS08WS-ERROR-SW-YES TO TRUE.                     EH800900
142300*
142400*            ***** STORE PURGE FLAG     *****                  *
142500*
142600     IF  MO05-STORE-PURGE-FLAG-L IS LESS THAN 1
142700         MOVE DFHBMASK           TO MO05-STORE-PURGE-FLAG-A
142800         MOVE DFHBMDAS           TO MO05-STORE-PURGE-FLAG-LP-A
142900                                    MO05-STORE-PURGE-FLAG-RP-A
143000         MOVE MMOC-AUTO-PURGE-FLAG (2)
143100                                 TO MO05-STORE-PURGE-FLAG
143200     ELSE
143300         IF  MO05-VALID-STORE-PURGE-FLAG
143400             MOVE DFHBMASF       TO MO05-STORE-PURGE-FLAG-A
143500             MOVE DFHBMDAS       TO MO05-STORE-PURGE-FLAG-LP-A
143600                                    MO05-STORE-PURGE-FLAG-RP-A
143700             SET WS-UPDATE-SW-YES
143800                                 TO TRUE
143900         ELSE
144000             MOVE DFHBMUBF       TO MO05-STORE-PURGE-FLAG-A
144100             MOVE DFHBMASB       TO MO05-STORE-PURGE-FLAG-LP-A
144200                                    MO05-STORE-PURGE-FLAG-RP-A
144300             MOVE SS08WS-CURSOR  TO MO05-STORE-PURGE-FLAG-L
144400             SET SS08WS-ERROR-SW-YES TO TRUE.
144500*
144600*            ***** STORE PURGE MONTHS   *****                  *
144700*
144800     IF  MO05-STORE-PURGE-MOS-L IS LESS THAN 1
144900         MOVE DFHBMASK           TO MO05-STORE-PURGE-MOS-A
145000         MOVE DFHBMDAS           TO MO05-STORE-PURGE-MOS-LP-A
145100                                    MO05-STORE-PURGE-MOS-RP-A
145200         MOVE MMOC-AUTO-PURGE-MONTHS (2)
145300                                 TO MO05-STORE-PURGE-MOS
145400     ELSE
145500         IF  MO05-STORE-PURGE-MOS IS NUMERIC
145600         AND MO05-STORE-PURGE-MOS IS LESS THAN 13
145700             MOVE DFHBMASF       TO MO05-STORE-PURGE-MOS-A
145800             MOVE DFHBMDAS       TO MO05-STORE-PURGE-MOS-LP-A
145900                                    MO05-STORE-PURGE-MOS-RP-A
146000             SET WS-UPDATE-SW-YES
146100                                 TO TRUE
146200         ELSE
146300             MOVE DFHBMNBF       TO MO05-STORE-PURGE-MOS-A
146400             MOVE DFHBMASB       TO MO05-STORE-PURGE-MOS-LP-A
146500                                    MO05-STORE-PURGE-MOS-RP-A
146600             MOVE SS08WS-CURSOR  TO MO05-STORE-PURGE-MOS-L
146700             SET SS08WS-ERROR-SW-YES TO TRUE.
146800*
146900*            ***** STORE PURGE FREQ1    *****                  *
147000*
147100     MOVE DFHBMDAS               TO MO05-STORE-PURGE-FREQS-LP-A
147200                                    MO05-STORE-PURGE-FREQS-RP-A.
147300*
147400     IF  MO05-STORE-PURGE-FREQ1-L IS LESS THAN 1
147500         MOVE DFHBMASK           TO MO05-STORE-PURGE-FREQ1-A
147600         MOVE MMOC-AUTO-PURGE-FREQ-1 (2)
147700                                 TO MO05-STORE-PURGE-FREQ1
147800     ELSE
147900         IF  MO05-STORE-PURGE-FREQ1 IS NUMERIC
148000         AND MO05-VALID-STORE-PURGE-FREQ1
148100             MOVE DFHBMASF       TO MO05-STORE-PURGE-FREQ1-A
148200             SET WS-UPDATE-SW-YES
148300                                 TO TRUE
148400         ELSE
148500             MOVE DFHBMNBF       TO MO05-STORE-PURGE-FREQ1-A
148600             MOVE DFHBMASB       TO MO05-STORE-PURGE-FREQS-LP-A
148700                                    MO05-STORE-PURGE-FREQS-RP-A
148800             MOVE SS08WS-CURSOR  TO MO05-STORE-PURGE-FREQ1-L
148900             SET SS08WS-ERROR-SW-YES TO TRUE.
149000*
149100*            ***** STORE PURGE FREQ2    *****                  *
149200*
149300     IF  MO05-STORE-PURGE-FREQ2-L IS LESS THAN 1
149400         MOVE DFHBMASK           TO MO05-STORE-PURGE-FREQ2-A
149500         MOVE MMOC-AUTO-PURGE-FREQ-2 (2)
149600                                 TO MO05-STORE-PURGE-FREQ2
149700     ELSE
149800         IF  MO05-STORE-PURGE-FREQ2 IS NUMERIC
149900         AND MO05-VALID-STORE-PURGE-FREQ2
150000             MOVE DFHBMASF       TO MO05-STORE-PURGE-FREQ2-A
150100             SET WS-UPDATE-SW-YES
150200                                 TO TRUE
150300         ELSE
150400             MOVE DFHBMNBF       TO MO05-STORE-PURGE-FREQ2-A
150500             MOVE DFHBMASB       TO MO05-STORE-PURGE-FREQS-LP-A
150600                                    MO05-STORE-PURGE-FREQS-RP-A
150700             MOVE SS08WS-CURSOR  TO MO05-STORE-PURGE-FREQ2-L
150800             SET SS08WS-ERROR-SW-YES TO TRUE.
150900*
151000*
151100*            ***** CROSS EDIT CR PLAN STORES AND MERCHANTS *****
151200*
151300     IF  MO05-CR-PLAN-MERCH-NO
151400     AND MO05-CR-PLAN-CHAIN-YES
151500         MOVE DFHBMUBF           TO MO05-CR-PLAN-CHAIN-A
151600                                    MO05-CR-PLAN-MERCH-A
151700         MOVE DFHBMASB           TO MO05-CR-PLAN-CHAIN-LP-A
151800                                    MO05-CR-PLAN-CHAIN-RP-A
151900                                    MO05-CR-PLAN-MERCH-LP-A
152000                                    MO05-CR-PLAN-MERCH-RP-A
152100         MOVE SS08WS-CURSOR      TO MO05-CR-PLAN-MERCH-L
152200         SET SS08WS-ERROR-SW-YES TO TRUE.
152300*
152400     IF  MO05-CR-PLAN-STORE-NO
152500     AND MO05-CR-PLAN-S-CHAIN-YES
152600         MOVE DFHBMUBF           TO MO05-CR-PLAN-S-CHAIN-A
152700                                    MO05-CR-PLAN-STORE-A
152800         MOVE DFHBMASB           TO MO05-CR-PLAN-S-CHAIN-LP-A
152900                                    MO05-CR-PLAN-S-CHAIN-RP-A
153000                                    MO05-CR-PLAN-STORE-LP-A
153100                                    MO05-CR-PLAN-STORE-RP-A
153200         MOVE SS08WS-CURSOR      TO MO05-CR-PLAN-STORE-L
153300         SET SS08WS-ERROR-SW-YES TO TRUE.
153400*
153500     IF  SS08WS-ERROR-SW-NO
153600         GO TO 2400-UPDATE-FILE.
153700*
153800****************************************************************
153900*    SEND THE MAP                                              *
154000****************************************************************
154100*
154110     MOVE DFHBMASK               TO MO05-PERCENT-NOD-A.
154112     MOVE DFHBMDAS               TO MO05-PERCENT-NOD-LP-A
154114                                    MO05-PERCENT-NOD-RP-A.
154120     MOVE DFHBMASK               TO MO05-PER-ITEM-NOD-A.
154122     MOVE DFHBMDAS               TO MO05-PER-ITEM-NOD-LP-A
154124                                    MO05-PER-ITEM-NOD-RP-A.
154130*
154132     IF  MBCA-PTI-FUNCTION-IS-ADD
154134         MOVE SPACES             TO MBCA-TRANS-LOOP-CONTROL
154136     ELSE
154138         MOVE DFHBMASK           TO MO05-CURRENCY-CODE-A
154140         MOVE DFHBMDAS           TO MO05-CURRENCY-CODE-LP-A
154142                                    MO05-CURRENCY-CODE-RP-A
154144     END-IF.
154146*
154200     PERFORM MB60PD-INIT-STD-MAP-LINES
154300                                 THRU MB60PD-ISML-EXIT.
154400     MOVE 'BM03'                 TO MBCA-PROGRAM-LOCATION.
154500     PERFORM MB60PD-SEND-MAP-DATA-ONLY
154600                                 THRU MB60PD-SMDO-EXIT.
154700*
154800****************************************************************
154900*    RETURN TO CICS                                            *
155000****************************************************************
155100*
155200     MOVE 'PC04'                 TO MBCA-PROGRAM-LOCATION.
155300     MOVE 05                     TO MBCA-SCREEN-NBR.
155400     PERFORM MB70PD-RETURN-TRANS-ID
155500                                 THRU MB70PD-RTI-EXIT.
155600/
155700 2400-UPDATE-FILE.
155800*
155900     IF  WS-UPDATE-SW-NO
156000         IF  MBCA-PTI-FUNCTION-IS-ADD
156100             MOVE 'FC03'         TO MBCA-PROGRAM-LOCATION
156200             MOVE MBCA-MERCHANT-ORG
156300                                 TO MBIOWS-MMOC-ORG
156400             SET MBIORO-READ-RANDOM-UPDATE
156500                                 TO TRUE
156600             PERFORM MMOCAO-ACCESS
156700                                 THRU MMOCAO-ACCESS-EXIT
156800             MOVE MBCA-SCREEN-NBR
156900                                 TO MMOC-ONLINE-STATUS
157000             MOVE 'FC04'         TO MBCA-PROGRAM-LOCATION
157100             SET MBIORO-REWRITE  TO TRUE
157200             PERFORM MMOCAO-ACCESS
157300                                 THRU MMOCAO-ACCESS-EXIT
157400             GO TO 2600-SETUP-COMMAREA
157500         ELSE
157600             GO TO 2600-SETUP-COMMAREA.
157700*
157800****************************************************************
157900*    GETMAIN FOR LOG/JOURNAL RECORD                            *
158000****************************************************************
158100*
158200     MOVE 'SC02'                 TO MBCA-PROGRAM-LOCATION.
158300     SET MBIORO-GETMAIN          TO TRUE.
158400     PERFORM MML1AO-ACCESS       THRU MML1AO-ACCESS-EXIT.
158500*
158600****************************************************************
158700*    READ THE ORGANIZATION FILE RECORD FOR UPDATE              *
158800****************************************************************
158900*
159000     MOVE 'FC05'                 TO MBCA-PROGRAM-LOCATION.
159100     MOVE MBCA-MERCHANT-ORG      TO MBIOWS-MMOC-ORG.
159200     SET MBIORO-READ-RANDOM-UPDATE
159300                                 TO TRUE.
159400     PERFORM MMOCAO-ACCESS       THRU MMOCAO-ACCESS-EXIT.
159500*
159600*            ***** STATEMENTS TO RETAIN *****                  *
159700*
159800     IF  MO05-STMTS-TO-RETAIN-L IS GREATER THAN ZERO
159900         MOVE ZEROES             TO MML1-FIELD-OCCURRENCE
160000         MOVE 0501               TO MML1-FIELD-CODE
160100         MOVE MML1WS-VL-03       TO MML1-VARIABLE-LENGTH
160200         MOVE MMOC-STMTS-TO-RETAIN
160300                                 TO MML1-VL03-B-DATA-9
160400         MOVE MO05-STMTS-TO-RETAIN
160500                                 TO MMOC-STMTS-TO-RETAIN
160600         MOVE MMOC-STMTS-TO-RETAIN
160700                                 TO MML1-VL03-A-DATA-9
160800         PERFORM 9050-CREATE-MAINT-RECORD
160900                                 THRU 9099-CMR-EXIT.
161000*
161100*            ***** VISA BIN NBR *****                         *
161200*
161300     IF  MO05-VI-BIN-L IS GREATER THAN ZEROES
161400         MOVE ZEROES             TO MML1-FIELD-OCCURRENCE
161500         MOVE 0502               TO MML1-FIELD-CODE
161600         MOVE MML1WS-VL-07       TO MML1-VARIABLE-LENGTH
161700         MOVE MMOC-INTCHG-BIN    TO MML1-VL07-B-DATA-9
161800         MOVE MO05-VI-BIN        TO MMOC-INTCHG-BIN
161900         MOVE MMOC-INTCHG-BIN    TO MML1-VL07-A-DATA-9
162000         PERFORM 9050-CREATE-MAINT-RECORD
162100                                 THRU 9099-CMR-EXIT.
162105*                                                                 RG800905
162110*            ***** M/C ICA NBR *****                         *    RG800905
162115*                                                                 RG800905
162120     IF  MO05-MC-ICA-L IS GREATER THAN ZEROES                     RG800905
162125         MOVE ZEROES             TO MML1-FIELD-OCCURRENCE         RG800905
162130         MOVE 0503               TO MML1-FIELD-CODE               RG800905
162135         MOVE MML1WS-VL-04       TO MML1-VARIABLE-LENGTH          RG800905
162140         MOVE MMOC-INTCHG-ICA    TO MML1-VL04-B-DATA-9            RG800905
162145         MOVE MO05-MC-ICA        TO MMOC-INTCHG-ICA               RG800905
162150         MOVE MMOC-INTCHG-ICA                                     RG800905
162155                                 TO MML1-VL04-A-DATA-9            RG800905
162160         PERFORM 9050-CREATE-MAINT-RECORD                         RG800905
162165                                 THRU 9099-CMR-EXIT.              RG800905
162200*
162300*            ***** M/C BIN NBR *****                         *
162400*
162500     IF  MO05-MC-BIN-L IS GREATER THAN ZEROES
162600         MOVE ZEROES             TO MML1-FIELD-OCCURRENCE
162700         MOVE 0504               TO MML1-FIELD-CODE
162800         MOVE MML1WS-VL-07       TO MML1-VARIABLE-LENGTH          RG800905
162900         MOVE MMOC-MC-INTCHG-BIN TO MML1-VL07-B-DATA-9            RG800905
163000         MOVE MO05-MC-BIN        TO MMOC-MC-INTCHG-BIN            RG800905
163100         MOVE MMOC-MC-INTCHG-BIN                                  RG800905
163200                                 TO MML1-VL07-A-DATA-9            RG800905
163300         PERFORM 9050-CREATE-MAINT-RECORD
163400                                 THRU 9099-CMR-EXIT.
163500*
163600*            ***** LINES PER PAGE *****                        *
163700*
163800     IF  MO05-LINES-PER-PAGE-L IS GREATER THAN ZERO
163900         MOVE ZEROES             TO MML1-FIELD-OCCURRENCE
164000         MOVE 0505               TO MML1-FIELD-CODE
164100         MOVE MML1WS-VL-02       TO MML1-VARIABLE-LENGTH
164200         MOVE MMOC-LINES-PER-PAGE
164300                                 TO MML1-VL02-B-DATA-9
164400         MOVE MO05-LINES-PER-PAGE
164500                                 TO MMOC-LINES-PER-PAGE
164600         MOVE MMOC-LINES-PER-PAGE
164700                                 TO MML1-VL02-A-DATA-9
164800         PERFORM 9050-CREATE-MAINT-RECORD
164900                                 THRU 9099-CMR-EXIT.
164902*                                                                 EH800900
164904*            ***** EUROPAY CMID *****                        *    EH800900
164906*                                                                 EH800900
164908     IF  MO05-EUROPAY-CMID-L IS GREATER THAN ZEROES               EH800900
164910         MOVE ZEROES             TO MML1-FIELD-OCCURRENCE         EH800900
164912         MOVE 0549               TO MML1-FIELD-CODE               EH800900
164914         MOVE MML1WS-VL-10       TO MML1-VARIABLE-LENGTH          EH800900
164916         MOVE MMOC-EUROPAY-CMID  TO MML1-VL10-B-DATA-9            EH800900
164918         MOVE MO05-EUROPAY-CMID  TO MMOC-EUROPAY-CMID             EH800900
164920         MOVE MMOC-EUROPAY-CMID  TO MML1-VL10-A-DATA-9            EH800900
164922         PERFORM 9050-CREATE-MAINT-RECORD                         EH800900
164924                                 THRU 9099-CMR-EXIT.              EH800900
165000*
165100*            ***** FORM CODE *****                             *
165200*
165300     IF  MO05-FORM-CODE-L IS GREATER THAN ZERO
165400         MOVE ZEROES             TO MML1-FIELD-OCCURRENCE
165500         MOVE 0507               TO MML1-FIELD-CODE
165600         MOVE MML1WS-VL-02       TO MML1-VARIABLE-LENGTH
165700         MOVE MMOC-FORM          TO MML1-VL02-B-DATA-9
165800         MOVE MO05-FORM-CODE     TO MMOC-FORM
165900         MOVE MMOC-FORM          TO MML1-VL02-A-DATA-9
166000         PERFORM 9050-CREATE-MAINT-RECORD
166100                                 THRU 9099-CMR-EXIT.
166200*
166300*            ***** MEMBER ID *****                             *
166400*
166500     IF  MO05-MEMBER-ID-L IS GREATER THAN ZERO
166600         MOVE ZEROES             TO MML1-FIELD-OCCURRENCE
166700         MOVE 0526               TO MML1-FIELD-CODE
166800         MOVE MML1WS-VL-10       TO MML1-VARIABLE-LENGTH
166900         MOVE MMOC-MEMBER-ID     TO MML1-VL10-B-DATA-9
167000         MOVE MO05-MEMBER-ID     TO MMOC-MEMBER-ID
167100         MOVE MMOC-MEMBER-ID     TO MML1-VL10-A-DATA-9
167200         PERFORM 9050-CREATE-MAINT-RECORD
167300                                 THRU 9099-CMR-EXIT.
167400*
167500*            ***** FICHE FLAG *****                            *
167600*
167700     IF  MO05-FICHE-FLAG-L IS GREATER THAN ZERO
167800         MOVE ZEROES             TO MML1-FIELD-OCCURRENCE
167900         MOVE 0509               TO MML1-FIELD-CODE
168000         MOVE MML1WS-VL-01       TO MML1-VARIABLE-LENGTH
168100         MOVE MMOC-FICHE-FLAG    TO MML1-VL01-B-DATA-X
168200         MOVE MO05-FICHE-FLAG    TO MMOC-FICHE-FLAG
168300         MOVE MMOC-FICHE-FLAG    TO MML1-VL01-A-DATA-X
168400         PERFORM 9050-CREATE-MAINT-RECORD
168500                                 THRU 9099-CMR-EXIT.
168600*
168700*            ***** COUNTRY CODE *****                          *
168800*
168900     IF  MO05-COUNTRY-CODE-L IS GREATER THAN ZEROES
169000         MOVE 1                  TO MML1-FIELD-OCCURRENCE
169100         MOVE 0510               TO MML1-FIELD-CODE
169200         MOVE MML1WS-VL-03       TO MML1-VARIABLE-LENGTH
169300         MOVE MMOC-COUNTRY-CODE (1)
169400                                 TO MML1-VL03-B-DATA-X
169500         MOVE MO05-COUNTRY-CODE  TO MMOC-COUNTRY-CODE (1)
169600         MOVE MMOC-COUNTRY-CODE (1)
169700                                 TO MML1-VL03-A-DATA-X
169800         PERFORM 9050-CREATE-MAINT-RECORD
169900                                 THRU 9099-CMR-EXIT.
170000*
170100*            ***** TOP MERCHANTS NUMBER *****                  *
170200*
170300     IF  MO05-TOP-MERCHANTS-NBR-L IS GREATER THAN ZERO
170400         MOVE ZEROES             TO MML1-FIELD-OCCURRENCE
170500         MOVE 0511               TO MML1-FIELD-CODE
170600         MOVE MML1WS-VL-03       TO MML1-VARIABLE-LENGTH
170700         MOVE MMOC-TOP-MERCHANTS-NBR
170800                                 TO MML1-VL03-B-DATA-9
170900         MOVE MO05-TOP-MERCHANTS-NBR
171000                                 TO MMOC-TOP-MERCHANTS-NBR
171100         MOVE MMOC-TOP-MERCHANTS-NBR
171200                                 TO MML1-VL03-A-DATA-9
171300         PERFORM 9050-CREATE-MAINT-RECORD
171400                                 THRU 9099-CMR-EXIT.
171500*
171600*            ***** CRB TERM MERCH *****                      *
171700*
171800     IF  MO05-CRB-TERM-MERCH-L IS GREATER THAN ZERO
171900         MOVE ZEROS              TO MML1-FIELD-OCCURRENCE
172000                                    MML1-FIELD-OCCURRENCE-2
172100         MOVE 0524               TO MML1-FIELD-CODE
172200         MOVE MML1WS-VL-01       TO MML1-VARIABLE-LENGTH
172300         MOVE MMOC-CRB-TERM-MERCH-FLAG
172400                                 TO MML1-VL01-B-DATA-X
172500         MOVE MO05-CRB-TERM-MERCH
172600                                 TO MMOC-CRB-TERM-MERCH-FLAG
172700         MOVE MMOC-CRB-TERM-MERCH-FLAG
172800                                 TO MML1-VL01-A-DATA-X
172900         PERFORM 9050-CREATE-MAINT-RECORD
173000                                 THRU 9099-CMR-EXIT.
173100*
173200*            ***** CURRENCY CODE *****                         *
173300*
173400*
173500*            ***** CURRENCY NOD *****                         *
173600*
173700     IF  MO05-CURRENCY-CODE-L IS GREATER THAN ZEROES
173800         MOVE ZEROES             TO MML1-FIELD-OCCURRENCE
173900         MOVE 0512               TO MML1-FIELD-CODE
174000         MOVE MML1WS-VL-03       TO MML1-VARIABLE-LENGTH
174100         MOVE MMOC-CURRENCY-CODE
174200                                 TO MML1-VL03-B-DATA-X
174300         MOVE MO05-CURRENCY-CODE TO MMOC-CURRENCY-CODE
174400         MOVE MMOC-CURRENCY-CODE TO MML1-VL03-A-DATA-X
174500         PERFORM 9050-CREATE-MAINT-RECORD
174600                                 THRU 9099-CMR-EXIT
174700         MOVE ZEROES             TO MML1-FIELD-OCCURRENCE
174800         MOVE 0549               TO MML1-FIELD-CODE
174900         MOVE MML1WS-VL-01       TO MML1-VARIABLE-LENGTH
175000         MOVE MMOC-CURRENCY-NOD
175100                                 TO MML1-VL01-B-DATA-X
175200         MOVE SMCU-CURRENCY-NOD  TO MMOC-CURRENCY-NOD
175300         MOVE SMCU-CURRENCY-NOD  TO MO05-CURRENCY-NOD
175400         MOVE MMOC-CURRENCY-NOD  TO MML1-VL01-A-DATA-X
175500         PERFORM 9050-CREATE-MAINT-RECORD
175600                                 THRU 9099-CMR-EXIT
175610         MOVE SMCU-PERCENT-NOD   TO MO05-PERCENT-NOD
175612         MOVE SMCU-PER-ITEM-NOD  TO MO05-PER-ITEM-NOD
175614         MOVE 1                  TO MO05-PERCENT-NOD-L
175616         MOVE 1                  TO MO05-PER-ITEM-NOD-L
175618     END-IF.
175700*
175800*            ***** PERCENT NOD *****                         *
175900*
176000     IF  MO05-PERCENT-NOD-L IS GREATER THAN ZEROES
176100         MOVE ZEROES             TO MML1-FIELD-OCCURRENCE
176200         MOVE 0550               TO MML1-FIELD-CODE
176300         MOVE MML1WS-VL-01       TO MML1-VARIABLE-LENGTH
176400         MOVE MMOC-PERCENT-NOD
176500                                 TO MML1-VL01-B-DATA-X
176600         MOVE MO05-PERCENT-NOD   TO MMOC-PERCENT-NOD
176700         MOVE MMOC-PERCENT-NOD   TO MML1-VL01-A-DATA-X
176800         PERFORM 9050-CREATE-MAINT-RECORD
176900                                 THRU 9099-CMR-EXIT.
177000*
177100*            ***** PERITEM NOD *****                         *
177200*
177300     IF  MO05-PER-ITEM-NOD-L IS GREATER THAN ZEROES
177400         MOVE ZEROES             TO MML1-FIELD-OCCURRENCE
177500         MOVE 0551               TO MML1-FIELD-CODE
177600         MOVE MML1WS-VL-01       TO MML1-VARIABLE-LENGTH
177700         MOVE MMOC-PER-ITEM-NOD
177800                                 TO MML1-VL01-B-DATA-X
177900         MOVE MO05-PER-ITEM-NOD   TO MMOC-PER-ITEM-NOD
178000         MOVE MMOC-PER-ITEM-NOD   TO MML1-VL01-A-DATA-X
178100         PERFORM 9050-CREATE-MAINT-RECORD
178200                                 THRU 9099-CMR-EXIT.
178300*
178400*            ***** ISSUER FAX NUMBER *****                      *
178500*
178600     IF  MO05-INTCHG-FAX-L IS GREATER THAN ZERO
178700         MOVE ZEROES             TO MML1-FIELD-OCCURRENCE
178800         MOVE 0513               TO MML1-FIELD-CODE
178900         MOVE MML1WS-VL-20       TO MML1-VARIABLE-LENGTH
179000         MOVE MMOC-ISSUER-RR-FAX-NBR
179100                                 TO MML1-VL20-B-DATA-X
179200         MOVE MO05-INTCHG-FAX    TO MMOC-ISSUER-RR-FAX-NBR
179300         MOVE MMOC-ISSUER-RR-FAX-NBR
179400                                 TO MML1-VL20-A-DATA-X
179500         PERFORM 9050-CREATE-MAINT-RECORD
179600                                 THRU 9099-CMR-EXIT.
179700*
179800*            ***** MERCHANT PRIMARY *****                    *
179900*
180000     IF  MO05-MERCH-PRIM-L IS GREATER THAN ZERO
180100         MOVE ZEROS              TO MML1-FIELD-OCCURRENCE
180200                                    MML1-FIELD-OCCURRENCE-2
180300         MOVE 0514               TO MML1-FIELD-CODE
180400         MOVE MML1WS-VL-01       TO MML1-VARIABLE-LENGTH
180500         MOVE MMOC-MERCH-PRIMARY
180600                                 TO MML1-VL01-B-DATA-X
180700         MOVE MO05-MERCH-PRIM    TO MMOC-MERCH-PRIMARY
180800         MOVE MMOC-MERCH-PRIMARY
180900                                 TO MML1-VL01-A-DATA-X
181000         PERFORM 9050-CREATE-MAINT-RECORD
181100                                 THRU 9099-CMR-EXIT.
181200*
181300*            ***** MERCHANT CHECK DIGIT *****                  *
181400*
181500     IF  MO05-CHK-DIGIT-MERCH-L IS GREATER THAN ZEROES
181600         MOVE ZEROES             TO MML1-FIELD-OCCURRENCE
181700         MOVE 0515               TO MML1-FIELD-CODE
181800         MOVE MML1WS-VL-01       TO MML1-VARIABLE-LENGTH
181900         MOVE MMOC-MERCHANT-MOD-CHECK
182000                                 TO MML1-VL01-B-DATA-X
182100         MOVE MO05-CHK-DIGIT-MERCH
182200                                 TO MMOC-MERCHANT-MOD-CHECK
182300         MOVE MMOC-MERCHANT-MOD-CHECK
182400                                 TO MML1-VL01-A-DATA-X
182500         PERFORM 9050-CREATE-MAINT-RECORD
182600                                 THRU 9099-CMR-EXIT.
182700*
182800*            ***** MERCHANT SECONDARY *****                  *
182900*
183000     IF  MO05-MERCH-SEC-L IS GREATER THAN ZERO
183100         MOVE ZEROS              TO MML1-FIELD-OCCURRENCE
183200                                    MML1-FIELD-OCCURRENCE-2
183300         MOVE 0516               TO MML1-FIELD-CODE
183400         MOVE MML1WS-VL-01       TO MML1-VARIABLE-LENGTH
183500         MOVE MMOC-MERCH-SECONDARY
183600                                 TO MML1-VL01-B-DATA-X
183700         MOVE MO05-MERCH-SEC     TO MMOC-MERCH-SECONDARY
183800         MOVE MMOC-MERCH-SECONDARY
183900                                 TO MML1-VL01-A-DATA-X
184000         PERFORM 9050-CREATE-MAINT-RECORD
184100                                 THRU 9099-CMR-EXIT.
184200*
184300*            ***** MERCHANT DBA *****                  *
184400*
184500     IF  MO05-MERCH-DBA-L IS GREATER THAN ZERO
184600         MOVE ZEROS              TO MML1-FIELD-OCCURRENCE
184700                                    MML1-FIELD-OCCURRENCE-2
184800         MOVE 0527               TO MML1-FIELD-CODE
184900         MOVE MML1WS-VL-01       TO MML1-VARIABLE-LENGTH
185000         MOVE MMOC-MERCH-DBA     TO MML1-VL01-B-DATA-X
185100         MOVE MO05-MERCH-DBA     TO MMOC-MERCH-DBA
185200         MOVE MMOC-MERCH-DBA     TO MML1-VL01-A-DATA-X
185300         PERFORM 9050-CREATE-MAINT-RECORD
185400                                 THRU 9099-CMR-EXIT.
185500*
185600*            ***** STORE CHECK DIGIT *****                  *
185700*
185800     IF  MO05-CHK-DIGIT-STORE-L IS GREATER THAN ZEROES
185900         MOVE ZEROES             TO MML1-FIELD-OCCURRENCE
186000         MOVE 0517               TO MML1-FIELD-CODE
186100         MOVE MML1WS-VL-01       TO MML1-VARIABLE-LENGTH
186200         MOVE MMOC-STORE-MOD-CHECK
186300                                 TO MML1-VL01-B-DATA-X
186400         MOVE MO05-CHK-DIGIT-STORE
186500                                 TO MMOC-STORE-MOD-CHECK
186600         MOVE MMOC-STORE-MOD-CHECK
186700                                 TO MML1-VL01-A-DATA-X
186800         PERFORM 9050-CREATE-MAINT-RECORD
186900                                 THRU 9099-CMR-EXIT.
187000*
187100*            ***** STORE PRIMARY *****                    *
187200*
187300     IF  MO05-STORE-PRIM-L IS GREATER THAN ZERO
187400         MOVE ZEROS              TO MML1-FIELD-OCCURRENCE
187500                                    MML1-FIELD-OCCURRENCE-2
187600         MOVE 0518               TO MML1-FIELD-CODE
187700         MOVE MML1WS-VL-01       TO MML1-VARIABLE-LENGTH
187800         MOVE MMOC-STORE-PRIMARY
187900                                 TO MML1-VL01-B-DATA-X
188000         MOVE MO05-STORE-PRIM    TO MMOC-STORE-PRIMARY
188100         MOVE MMOC-STORE-PRIMARY
188200                                 TO MML1-VL01-A-DATA-X
188300         PERFORM 9050-CREATE-MAINT-RECORD
188400                                 THRU 9099-CMR-EXIT.
188500*
188600*            ***** STORE SECONDARY *****                  *
188700*
188800     IF  MO05-STORE-SEC-L IS GREATER THAN ZERO
188900         MOVE ZEROS              TO MML1-FIELD-OCCURRENCE
189000                                    MML1-FIELD-OCCURRENCE-2
189100         MOVE 0519               TO MML1-FIELD-CODE
189200         MOVE MML1WS-VL-01       TO MML1-VARIABLE-LENGTH
189300         MOVE MMOC-STORE-SECONDARY
189400                                 TO MML1-VL01-B-DATA-X
189500         MOVE MO05-STORE-SEC     TO MMOC-STORE-SECONDARY
189600         MOVE MMOC-STORE-SECONDARY
189700                                 TO MML1-VL01-A-DATA-X
189800         PERFORM 9050-CREATE-MAINT-RECORD
189900                                 THRU 9099-CMR-EXIT.
190000*
190100*            ***** STORE DBA *****                  *
190200*
190300     IF  MO05-STORE-DBA-L IS GREATER THAN ZERO
190400         MOVE ZEROS              TO MML1-FIELD-OCCURRENCE
190500                                    MML1-FIELD-OCCURRENCE-2
190600         MOVE 0528               TO MML1-FIELD-CODE
190700         MOVE MML1WS-VL-01       TO MML1-VARIABLE-LENGTH
190800         MOVE MMOC-STORE-DBA     TO MML1-VL01-B-DATA-X
190900         MOVE MO05-STORE-DBA     TO MMOC-STORE-DBA
191000         MOVE MMOC-STORE-DBA     TO MML1-VL01-A-DATA-X
191100         PERFORM 9050-CREATE-MAINT-RECORD
191200                                 THRU 9099-CMR-EXIT.
191300*
191400*            ***** CREDIT PLAN STATS MERCHANT *****            *
191500*
191600     IF  MO05-CR-PLAN-MERCH-L IS GREATER THAN ZEROES
191700         MOVE ZEROES             TO MML1-FIELD-OCCURRENCE
191800         MOVE 0520               TO MML1-FIELD-CODE
191900         MOVE MML1WS-VL-01       TO MML1-VARIABLE-LENGTH
192000         MOVE MMOC-CR-PLAN-ON-MERCH
192100                                 TO MML1-VL01-B-DATA-X
192200         MOVE MO05-CR-PLAN-MERCH
192300                                 TO MMOC-CR-PLAN-ON-MERCH
192400         MOVE MMOC-CR-PLAN-ON-MERCH
192500                                 TO MML1-VL01-A-DATA-X
192600         PERFORM 9050-CREATE-MAINT-RECORD
192700                                 THRU 9099-CMR-EXIT.
192800*
192900*            ***** CHAIN PRIMARY *****                  *
193000*
193100     IF  MO05-CHAIN-PRIM-L IS GREATER THAN ZERO
193200         MOVE ZEROS              TO MML1-FIELD-OCCURRENCE
193300                                    MML1-FIELD-OCCURRENCE-2
193400         MOVE 0521               TO MML1-FIELD-CODE
193500         MOVE MML1WS-VL-01       TO MML1-VARIABLE-LENGTH
193600         MOVE MMOC-CHAIN-PRIMARY
193700                                 TO MML1-VL01-B-DATA-X
193800         MOVE MO05-CHAIN-PRIM   TO MMOC-CHAIN-PRIMARY
193900         MOVE MMOC-CHAIN-PRIMARY
194000                                 TO MML1-VL01-A-DATA-X
194100         PERFORM 9050-CREATE-MAINT-RECORD
194200                                 THRU 9099-CMR-EXIT.
194300*
194400*            ***** CREDIT PLAN STATS STORE *****               *
194500*
194600     IF  MO05-CR-PLAN-STORE-L IS GREATER THAN ZEROES
194700         MOVE ZEROES             TO MML1-FIELD-OCCURRENCE
194800         MOVE 0522               TO MML1-FIELD-CODE
194900         MOVE MML1WS-VL-01       TO MML1-VARIABLE-LENGTH
195000         MOVE MMOC-CR-PLAN-ON-STORE
195100                                 TO MML1-VL01-B-DATA-X
195200         MOVE MO05-CR-PLAN-STORE
195300                                 TO MMOC-CR-PLAN-ON-STORE
195400         MOVE MMOC-CR-PLAN-ON-STORE
195500                                 TO MML1-VL01-A-DATA-X
195600         PERFORM 9050-CREATE-MAINT-RECORD
195700                                 THRU 9099-CMR-EXIT.
195800*
195900*            ***** CREDIT PLAN STATS CHAIN *****               *
196000*
196100     IF  MO05-CR-PLAN-CHAIN-L IS GREATER THAN ZEROES
196200         MOVE ZEROES             TO MML1-FIELD-OCCURRENCE
196300         MOVE 0523               TO MML1-FIELD-CODE
196400         MOVE MML1WS-VL-01       TO MML1-VARIABLE-LENGTH
196500         MOVE MMOC-CR-PLAN-ON-CHAIN
196600                                 TO MML1-VL01-B-DATA-X
196700         MOVE MO05-CR-PLAN-CHAIN
196800                                 TO MMOC-CR-PLAN-ON-CHAIN
196900         MOVE MMOC-CR-PLAN-ON-CHAIN
197000                                 TO MML1-VL01-A-DATA-X
197100         PERFORM 9050-CREATE-MAINT-RECORD
197200                                 THRU 9099-CMR-EXIT.
197300*
197400     IF  MO05-STORE-CHAIN-PRIM-L IS GREATER THAN ZERO
197500         MOVE ZEROS              TO MML1-FIELD-OCCURRENCE
197600                                    MML1-FIELD-OCCURRENCE-2
197700         MOVE 0529               TO MML1-FIELD-CODE
197800         MOVE MML1WS-VL-01       TO MML1-VARIABLE-LENGTH
197900         MOVE MMOC-STORE-CHAIN-PRIMARY
198000                                 TO MML1-VL01-B-DATA-X
198100         MOVE MO05-STORE-CHAIN-PRIM
198200                                 TO MMOC-STORE-CHAIN-PRIMARY
198300         MOVE MMOC-STORE-CHAIN-PRIMARY
198400                                 TO MML1-VL01-A-DATA-X
198500         PERFORM 9050-CREATE-MAINT-RECORD
198600                                 THRU 9099-CMR-EXIT.
198700*
198800*            ***** CREDIT PLAN STATS STORE CHAIN *****         *
198900*
199000     IF  MO05-CR-PLAN-S-CHAIN-L IS GREATER THAN ZEROES
199100         MOVE ZEROES             TO MML1-FIELD-OCCURRENCE
199200         MOVE 0530               TO MML1-FIELD-CODE
199300         MOVE MML1WS-VL-01       TO MML1-VARIABLE-LENGTH
199400         MOVE MMOC-CR-PLAN-ON-STORE-CHAIN
199500                                 TO MML1-VL01-B-DATA-X
199600         MOVE MO05-CR-PLAN-S-CHAIN
199700                                 TO MMOC-CR-PLAN-ON-STORE-CHAIN
199800         MOVE MMOC-CR-PLAN-ON-STORE-CHAIN
199900                                 TO MML1-VL01-A-DATA-X
200000         PERFORM 9050-CREATE-MAINT-RECORD
200100                                 THRU 9099-CMR-EXIT.
200200*
200300*            ***** MERCH CLOSE FLAG *****                      *
200400*
200500     IF  MO05-MERCH-CLOSE-FLAG-L IS GREATER THAN ZEROES
200600         MOVE ZEROES             TO MML1-FIELD-OCCURRENCE
200700         MOVE 0531               TO MML1-FIELD-CODE
200800         MOVE MML1WS-VL-01       TO MML1-VARIABLE-LENGTH
200900         MOVE MMOC-AUTO-CLOSE-FLAG (1)
201000                                 TO MML1-VL01-B-DATA-X
201100         MOVE MO05-MERCH-CLOSE-FLAG
201200                                 TO MMOC-AUTO-CLOSE-FLAG (1)
201300         MOVE MMOC-AUTO-CLOSE-FLAG (1)
201400                                 TO MML1-VL01-A-DATA-X
201500         PERFORM 9050-CREATE-MAINT-RECORD
201600                                 THRU 9099-CMR-EXIT.
201700*
201800*            ***** MERCH CLOSE MONTHS *****                    *
201900*
202000     IF  MO05-MERCH-CLOSE-MOS-L IS GREATER THAN ZEROES
202100         MOVE ZEROES             TO MML1-FIELD-OCCURRENCE
202200         MOVE 0532               TO MML1-FIELD-CODE
202300         MOVE MML1WS-VL-02       TO MML1-VARIABLE-LENGTH
202400         MOVE MMOC-AUTO-CLOSE-MONTHS (1)
202500                                 TO MML1-VL02-B-DATA-9
202600         MOVE MO05-MERCH-CLOSE-MOS
202700                                 TO MMOC-AUTO-CLOSE-MONTHS (1)
202800         MOVE MMOC-AUTO-CLOSE-MONTHS (1)
202900                                 TO MML1-VL02-A-DATA-9
203000         PERFORM 9050-CREATE-MAINT-RECORD
203100                                 THRU 9099-CMR-EXIT.
203200*
203300*            ***** MERCH CLOSE FREQ 1 *****                    *
203400*
203500     IF  MO05-MERCH-CLOSE-FREQ1-L IS GREATER THAN ZEROES
203600         MOVE ZEROES             TO MML1-FIELD-OCCURRENCE
203700         MOVE 0533               TO MML1-FIELD-CODE
203800         MOVE MML1WS-VL-02       TO MML1-VARIABLE-LENGTH
203900         MOVE MMOC-AUTO-CLOSE-FREQ-1 (1)
204000                                 TO MML1-VL02-B-DATA-9
204100         MOVE MO05-MERCH-CLOSE-FREQ1
204200                                 TO MMOC-AUTO-CLOSE-FREQ-1 (1)
204300         MOVE MMOC-AUTO-CLOSE-FREQ-1 (1)
204400                                 TO MML1-VL02-A-DATA-9
204500         PERFORM 9050-CREATE-MAINT-RECORD
204600                                 THRU 9099-CMR-EXIT.
204700*
204800*            ***** MERCH CLOSE FREQ 2 *****                    *
204900*
205000     IF  MO05-MERCH-CLOSE-FREQ2-L IS GREATER THAN ZEROES
205100         MOVE ZEROES             TO MML1-FIELD-OCCURRENCE
205200         MOVE 0534               TO MML1-FIELD-CODE
205300         MOVE MML1WS-VL-02       TO MML1-VARIABLE-LENGTH
205400         MOVE MMOC-AUTO-CLOSE-FREQ-2 (1)
205500                                 TO MML1-VL02-B-DATA-9
205600         MOVE MO05-MERCH-CLOSE-FREQ2
205700                                 TO MMOC-AUTO-CLOSE-FREQ-2 (1)
205800         MOVE MMOC-AUTO-CLOSE-FREQ-2 (1)
205900                                 TO MML1-VL02-A-DATA-9
206000         PERFORM 9050-CREATE-MAINT-RECORD
206100                                 THRU 9099-CMR-EXIT.
206200*
206300*            ***** MERCH PURGE FLAG *****                      *
206400*
206500     IF  MO05-MERCH-PURGE-FLAG-L IS GREATER THAN ZEROES
206600         MOVE ZEROES             TO MML1-FIELD-OCCURRENCE
206700         MOVE 0535               TO MML1-FIELD-CODE
206800         MOVE MML1WS-VL-01       TO MML1-VARIABLE-LENGTH
206900         MOVE MMOC-AUTO-PURGE-FLAG (1)
207000                                 TO MML1-VL01-B-DATA-X
207100         MOVE MO05-MERCH-PURGE-FLAG
207200                                 TO MMOC-AUTO-PURGE-FLAG (1)
207300         MOVE MMOC-AUTO-PURGE-FLAG (1)
207400                                 TO MML1-VL01-A-DATA-X
207500         PERFORM 9050-CREATE-MAINT-RECORD
207600                                 THRU 9099-CMR-EXIT.
207700*
207800*            ***** MERCH PURGE MONTHS *****                    *
207900*
208000     IF  MO05-MERCH-PURGE-MOS-L IS GREATER THAN ZEROES
208100         MOVE ZEROES             TO MML1-FIELD-OCCURRENCE
208200         MOVE 0536               TO MML1-FIELD-CODE
208300         MOVE MML1WS-VL-02       TO MML1-VARIABLE-LENGTH
208400         MOVE MMOC-AUTO-PURGE-MONTHS (1)
208500                                 TO MML1-VL02-B-DATA-9
208600         MOVE MO05-MERCH-PURGE-MOS
208700                                 TO MMOC-AUTO-PURGE-MONTHS (1)
208800         MOVE MMOC-AUTO-PURGE-MONTHS (1)
208900                                 TO MML1-VL02-A-DATA-9
209000         PERFORM 9050-CREATE-MAINT-RECORD
209100                                 THRU 9099-CMR-EXIT.
209200*
209300*            ***** MERCH PURGE FREQ 1 *****                    *
209400*
209500     IF  MO05-MERCH-PURGE-FREQ1-L IS GREATER THAN ZEROES
209600         MOVE ZEROES             TO MML1-FIELD-OCCURRENCE
209700         MOVE 0537               TO MML1-FIELD-CODE
209800         MOVE MML1WS-VL-02       TO MML1-VARIABLE-LENGTH
209900         MOVE MMOC-AUTO-PURGE-FREQ-1 (1)
210000                                 TO MML1-VL02-B-DATA-9
210100         MOVE MO05-MERCH-PURGE-FREQ1
210200                                 TO MMOC-AUTO-PURGE-FREQ-1 (1)
210300         MOVE MMOC-AUTO-PURGE-FREQ-1 (1)
210400                                 TO MML1-VL02-A-DATA-9
210500         PERFORM 9050-CREATE-MAINT-RECORD
210600                                 THRU 9099-CMR-EXIT.
210700*
210800*            ***** MERCH PURGE FREQ 2 *****                    *
210900*
211000     IF  MO05-MERCH-PURGE-FREQ2-L IS GREATER THAN ZEROES
211100         MOVE ZEROES             TO MML1-FIELD-OCCURRENCE
211200         MOVE 0538               TO MML1-FIELD-CODE
211300         MOVE MML1WS-VL-02       TO MML1-VARIABLE-LENGTH
211400         MOVE MMOC-AUTO-PURGE-FREQ-2 (1)
211500                                 TO MML1-VL02-B-DATA-9
211600         MOVE MO05-MERCH-PURGE-FREQ2
211700                                 TO MMOC-AUTO-PURGE-FREQ-2 (1)
211800         MOVE MMOC-AUTO-PURGE-FREQ-2 (1)
211900                                 TO MML1-VL02-A-DATA-9
212000         PERFORM 9050-CREATE-MAINT-RECORD
212100                                 THRU 9099-CMR-EXIT.
212200*
212300*            ***** MERCH PURGE DAYS   *****                    *
212400*
212500     IF  MO05-MERCH-PURGE-DAYS-L IS GREATER THAN ZEROES
212600         MOVE ZEROES             TO MML1-FIELD-OCCURRENCE
212700         MOVE 0539               TO MML1-FIELD-CODE
212800         MOVE MML1WS-VL-03       TO MML1-VARIABLE-LENGTH
212900         MOVE MMOC-FINAL-PURGE-DAYS
213000                                 TO MML1-VL03-B-DATA-9
213100         MOVE MO05-MERCH-PURGE-DAYS
213200                                 TO MMOC-FINAL-PURGE-DAYS
213300         MOVE MMOC-FINAL-PURGE-DAYS
213400                                 TO MML1-VL03-A-DATA-9
213500         PERFORM 9050-CREATE-MAINT-RECORD
213600                                 THRU 9099-CMR-EXIT.
213700*
213800*            ***** STORE CLOSE FLAG *****                      *
213900*
214000     IF  MO05-STORE-CLOSE-FLAG-L IS GREATER THAN ZEROES
214100         MOVE ZEROES             TO MML1-FIELD-OCCURRENCE
214200         MOVE 0540               TO MML1-FIELD-CODE
214300         MOVE MML1WS-VL-01       TO MML1-VARIABLE-LENGTH
214400         MOVE MMOC-AUTO-CLOSE-FLAG (2)
214500                                 TO MML1-VL01-B-DATA-X
214600         MOVE MO05-STORE-CLOSE-FLAG
214700                                 TO MMOC-AUTO-CLOSE-FLAG (2)
214800         MOVE MMOC-AUTO-CLOSE-FLAG (2)
214900                                 TO MML1-VL01-A-DATA-X
215000         PERFORM 9050-CREATE-MAINT-RECORD
215100                                 THRU 9099-CMR-EXIT.
215200*
215300*            ***** STORE CLOSE MONTHS *****                    *
215400*
215500     IF  MO05-STORE-CLOSE-MOS-L IS GREATER THAN ZEROES
215600         MOVE ZEROES             TO MML1-FIELD-OCCURRENCE
215700         MOVE 0541               TO MML1-FIELD-CODE
215800         MOVE MML1WS-VL-02       TO MML1-VARIABLE-LENGTH
215900         MOVE MMOC-AUTO-CLOSE-MONTHS (2)
216000                                 TO MML1-VL02-B-DATA-9
216100         MOVE MO05-STORE-CLOSE-MOS
216200                                 TO MMOC-AUTO-CLOSE-MONTHS (2)
216300         MOVE MMOC-AUTO-CLOSE-MONTHS (2)
216400                                 TO MML1-VL02-A-DATA-9
216500         PERFORM 9050-CREATE-MAINT-RECORD
216600                                 THRU 9099-CMR-EXIT.
216700*
216800*            ***** STORE CLOSE FREQ 1 *****                    *
216900*
217000     IF  MO05-STORE-CLOSE-FREQ1-L IS GREATER THAN ZEROES
217100         MOVE ZEROES             TO MML1-FIELD-OCCURRENCE
217200         MOVE 0542               TO MML1-FIELD-CODE
217300         MOVE MML1WS-VL-02       TO MML1-VARIABLE-LENGTH
217400         MOVE MMOC-AUTO-CLOSE-FREQ-1 (2)
217500                                 TO MML1-VL02-B-DATA-9
217600         MOVE MO05-STORE-CLOSE-FREQ1
217700                                 TO MMOC-AUTO-CLOSE-FREQ-1 (2)
217800         MOVE MMOC-AUTO-CLOSE-FREQ-1 (2)
217900                                 TO MML1-VL02-A-DATA-9
218000         PERFORM 9050-CREATE-MAINT-RECORD
218100                                 THRU 9099-CMR-EXIT.
218200*
218300*            ***** STORE CLOSE FREQ 2 *****                    *
218400*
218500     IF  MO05-STORE-CLOSE-FREQ2-L IS GREATER THAN ZEROES
218600         MOVE ZEROES             TO MML1-FIELD-OCCURRENCE
218700         MOVE 0543               TO MML1-FIELD-CODE
218800         MOVE MML1WS-VL-02       TO MML1-VARIABLE-LENGTH
218900         MOVE MMOC-AUTO-CLOSE-FREQ-2 (2)
219000                                 TO MML1-VL02-B-DATA-9
219100         MOVE MO05-STORE-CLOSE-FREQ2
219200                                 TO MMOC-AUTO-CLOSE-FREQ-2 (2)
219300         MOVE MMOC-AUTO-CLOSE-FREQ-2 (2)
219400                                 TO MML1-VL02-A-DATA-9
219500         PERFORM 9050-CREATE-MAINT-RECORD
219600                                 THRU 9099-CMR-EXIT.
219700*                                                                 EH800900
219800*            ***** M/C QUARTERLY REPORT FLAG                   *  EH800900
219900*                                                                 EH800900
220000     IF  MO05-MC-QTR-FLAG-L IS GREATER THAN ZEROES                EH800900
220100         MOVE ZEROES             TO MML1-FIELD-OCCURRENCE         EH800900
220200         MOVE 0548               TO MML1-FIELD-CODE               EH800900
220300         MOVE MML1WS-VL-01       TO MML1-VARIABLE-LENGTH          EH800900
220400         MOVE MMOC-MC-QTR-FLAG   TO MML1-VL01-B-DATA-X            EH800900
220500         MOVE MO05-MC-QTR-FLAG   TO MMOC-MC-QTR-FLAG              EH800900
220600         MOVE MMOC-MC-QTR-FLAG   TO MML1-VL01-A-DATA-X            EH800900
220700         PERFORM 9050-CREATE-MAINT-RECORD                         EH800900
220800                                 THRU 9099-CMR-EXIT.              EH800900
220810*                                                                 EH800900
220812*            ***** VISA QUARTERLY REPORT FLAG                  *  EH800900
220814*                                                                 EH800900
220816     IF  MO05-VISA-QTR-FLAG-L IS GREATER THAN ZEROES              EH800900
220818         MOVE ZEROES             TO MML1-FIELD-OCCURRENCE         EH800900
220820         MOVE 0549               TO MML1-FIELD-CODE               EH800900
220822         MOVE MML1WS-VL-01       TO MML1-VARIABLE-LENGTH          EH800900
220824         MOVE MMOC-VISA-QTR-FLAG TO MML1-VL01-B-DATA-X            EH800900
220826         MOVE MO05-VISA-QTR-FLAG TO MMOC-VISA-QTR-FLAG            EH800900
220828         MOVE MMOC-VISA-QTR-FLAG TO MML1-VL01-A-DATA-X            EH800900
220830         PERFORM 9050-CREATE-MAINT-RECORD                         EH800900
220832                                 THRU 9099-CMR-EXIT.              EH800900
220900*
221000*            ***** STORE PURGE FLAG *****                      *
221100*
221200     IF  MO05-STORE-PURGE-FLAG-L IS GREATER THAN ZEROES
221300         MOVE ZEROES             TO MML1-FIELD-OCCURRENCE
221400         MOVE 0544               TO MML1-FIELD-CODE
221500         MOVE MML1WS-VL-01       TO MML1-VARIABLE-LENGTH
221600         MOVE MMOC-AUTO-PURGE-FLAG (2)
221700                                 TO MML1-VL01-B-DATA-X
221800         MOVE MO05-STORE-PURGE-FLAG
221900                                 TO MMOC-AUTO-PURGE-FLAG (2)
222000         MOVE MMOC-AUTO-PURGE-FLAG (2)
222100                                 TO MML1-VL01-A-DATA-X
222200         PERFORM 9050-CREATE-MAINT-RECORD
222300                                 THRU 9099-CMR-EXIT.
222400*
222500*            ***** STORE PURGE MONTHS *****                    *
222600*
222700     IF  MO05-STORE-PURGE-MOS-L IS GREATER THAN ZEROES
222800         MOVE ZEROES             TO MML1-FIELD-OCCURRENCE
222900         MOVE 0545               TO MML1-FIELD-CODE
223000         MOVE MML1WS-VL-02       TO MML1-VARIABLE-LENGTH
223100         MOVE MMOC-AUTO-PURGE-MONTHS (2)
223200                                 TO MML1-VL02-B-DATA-9
223300         MOVE MO05-STORE-PURGE-MOS
223400                                 TO MMOC-AUTO-PURGE-MONTHS (2)
223500         MOVE MMOC-AUTO-PURGE-MONTHS (2)
223600                                 TO MML1-VL02-A-DATA-9
223700         PERFORM 9050-CREATE-MAINT-RECORD
223800                                 THRU 9099-CMR-EXIT.
223900*
224000*            ***** STORE PURGE FREQ 1 *****                    *
224100*
224200     IF  MO05-STORE-PURGE-FREQ1-L IS GREATER THAN ZEROES
224300         MOVE ZEROES             TO MML1-FIELD-OCCURRENCE
224400         MOVE 0546               TO MML1-FIELD-CODE
224500         MOVE MML1WS-VL-02       TO MML1-VARIABLE-LENGTH
224600         MOVE MMOC-AUTO-PURGE-FREQ-1 (2)
224700                                 TO MML1-VL02-B-DATA-9
224800         MOVE MO05-STORE-PURGE-FREQ1
224900                                 TO MMOC-AUTO-PURGE-FREQ-1 (2)
225000         MOVE MMOC-AUTO-PURGE-FREQ-1 (2)
225100                                 TO MML1-VL02-A-DATA-9
225200         PERFORM 9050-CREATE-MAINT-RECORD
225300                                 THRU 9099-CMR-EXIT.
225400*
225500*            ***** STORE PURGE FREQ 2 *****                    *
225600*
225700     IF  MO05-STORE-PURGE-FREQ2-L IS GREATER THAN ZEROES
225800         MOVE ZEROES             TO MML1-FIELD-OCCURRENCE
225900         MOVE 0547               TO MML1-FIELD-CODE
226000         MOVE MML1WS-VL-02       TO MML1-VARIABLE-LENGTH
226100         MOVE MMOC-AUTO-PURGE-FREQ-2 (2)
226200                                 TO MML1-VL02-B-DATA-9
226300         MOVE MO05-STORE-PURGE-FREQ2
226400                                 TO MMOC-AUTO-PURGE-FREQ-2 (2)
226500         MOVE MMOC-AUTO-PURGE-FREQ-2 (2)
226600                                 TO MML1-VL02-A-DATA-9
226700         PERFORM 9050-CREATE-MAINT-RECORD
226800                                 THRU 9099-CMR-EXIT.
226900*
227000     IF  MBCA-PTI-FUNCTION-IS-ADD
227100         MOVE 02                 TO MMOC-ONLINE-STATUS.
227200*
227300*            ***** LAST MAINT DATE AND OPERATOR ID *****       *
227400*
227500     MOVE ZEROES                 TO MML1-FIELD-OCCURRENCE.
227600     MOVE 0199                   TO MML1-FIELD-CODE.
227700     MOVE MML1WS-VL-07           TO MML1-VARIABLE-LENGTH.
227800     MOVE MMOC-LAST-MAINT-DATE
227900                                 TO MML1-VL07-B-DATA-9.
228000     MOVE MBCA-START-DATE        TO MMOC-LAST-MAINT-DATE.
228100     MOVE MMOC-LAST-MAINT-DATE
228200                                 TO MML1-VL07-A-DATA-9.
228300     PERFORM 9050-CREATE-MAINT-RECORD
228400                                 THRU 9099-CMR-EXIT.
228500     MOVE 0198                   TO MML1-FIELD-CODE.
228600     MOVE MML1WS-VL-03           TO MML1-VARIABLE-LENGTH.
228700     MOVE MMOC-LAST-MAINT-OPER
228800                                 TO MML1-VL03-B-DATA-X.
228900     MOVE MBCA-OPERATOR-ID       TO MMOC-LAST-MAINT-OPER.
229000     MOVE MMOC-LAST-MAINT-OPER
229100                                 TO MML1-VL03-A-DATA-X.
229200     PERFORM 9050-CREATE-MAINT-RECORD
229300                                 THRU 9099-CMR-EXIT.
229400*
229500****************************************************************
229600*    UPDATE THE ORGANIZATION FILE RECORD                       *
229700****************************************************************
229800*
229900     MOVE 'FC06'                 TO MBCA-PROGRAM-LOCATION.
230000     SET MBIORO-REWRITE          TO TRUE.
230100     PERFORM MMOCAO-ACCESS       THRU MMOCAO-ACCESS-EXIT.
230200*
230300 2600-SETUP-COMMAREA.
230400*
230500****************************************************************
230600*    SET UP COMMAREA FIELDS AND TRANSFER TO THE NEXT PROGRAM   *
230700****************************************************************
230800*
230900     MOVE MBCA-EIBAID            TO SS08WS-EIBAID.
231000*
231100     PERFORM MB60PD-EDIT-PAGE-NBR
231200                                 THRU MB60PD-EPN-EXIT.
231300*
231400     IF  SS08WS-VALID-PF-KEY
231500     OR  SS08WS-EIBAID-VALID-PF-KEY
231600         SET MBCA-INITIAL-SCREEN-NBR
231700                                 TO TRUE.
231800*
231900     MOVE 'PC05'                 TO MBCA-PROGRAM-LOCATION.
232000     PERFORM MB70PD-XCTL-TO-MBOXCTL
232100                                 THRU MB70PD-XTM-EXIT.
232200/
232300 9000-PERFORMED-ROUTINES-SECT SECTION.
232400*
232500 9050-CREATE-MAINT-RECORD.
232600*
232700*****************************************************************
232800*    THIS ROUTINE WILL CREATE THE COMMON DATA FOR ALL OF THE    *
232900*    LOG/JOURNAL TRANSACTIONS                                   *
233000*****************************************************************
233100*
233200     IF  MBCA-PTI-FUNCTION-IS-ADD
233300         GO TO 9099-CMR-EXIT.
233400*
233500     MOVE 'OC'                   TO MML1-FILE-CODE.
233600     MOVE MBCA-MERCHANT-ORG      TO MML1-MMOC-ORG.
233700     MOVE MBCA-SIGNON-NAME       TO MML1-SIGNON-NAME.
233800     MOVE MBCA-TERMINAL-ID       TO MML1-TERMINAL-ID.
233900     MOVE ZEROES                 TO MML1-SOURCE-CODE
234000                                    MML1-FIELD-OCCURRENCE-2.
234100*
234200*****************************************************************
234300*    WRITE THE LOG/JOURNAL FILE RECORD                          *
234400*****************************************************************
234500*
234600     MOVE 'FC07'                 TO MBCA-PROGRAM-LOCATION.
234700     SET MBIORO-WRITE            TO TRUE.
234800     PERFORM MML1AO-ACCESS       THRU MML1AO-ACCESS-EXIT.
234900     MOVE SPACES                 TO MML1-VARIABLE-AREA.
235000*
235100 9099-CMR-EXIT.
235200     EXIT.
235201*                                                                 RG800905
235202 9100-ICA-BIN-XEDIT.                                              RG800905
235204     IF  MO05-MC-BIN-L IS LESS THAN 1                             RG800905
235206         MOVE DFHBMASK           TO MO05-MC-BIN-A                 RG800905
235208         MOVE DFHBMDAS           TO MO05-MC-BIN-LP-A              RG800905
235210                                    MO05-MC-BIN-RP-A              RG800905
235212         MOVE MMOC-INTCHG-BIN    TO MO05-MC-BIN                   RG800905
235214         GO TO 9199-IBX-EXIT.                                     RG800905
235216     IF MO05-MC-BIN IS NOT NUMERIC                                RG800905
235218         MOVE DFHBMNBF           TO MO05-MC-BIN-A                 RG800905
235220         MOVE DFHBMASB           TO MO05-MC-BIN-LP-A              RG800905
235222                                    MO05-MC-BIN-RP-A              RG800905
235224         MOVE SS08WS-CURSOR      TO MO05-MC-BIN-L                 RG800905
235226         SET SS08WS-ERROR-SW-YES TO TRUE                          RG800905
235228         GO TO 9199-IBX-EXIT.                                     RG800905
235230     IF MO05-MC-ICA = ZERO                                        RG800905
235232         IF MO05-MC-BIN = ZERO                                    RG800905
235236             MOVE DFHBMASF       TO MO05-MC-BIN-A                 RG800905
235238             MOVE DFHBMDAS       TO MO05-MC-BIN-LP-A              RG800905
235240                                    MO05-MC-BIN-RP-A              RG800905
235242             SET WS-UPDATE-SW-YES                                 RG800905
235244                                 TO TRUE                          RG800905
235246             GO TO 9199-IBX-EXIT                                  RG800905
235248         ELSE                                                     RG800905
235250             MOVE DFHBMNBF       TO MO05-MC-BIN-A                 RG800905
235252             MOVE DFHBMASB       TO MO05-MC-BIN-LP-A              RG800905
235254                                    MO05-MC-BIN-RP-A              RG800905
235256             MOVE SS08WS-CURSOR  TO MO05-MC-BIN-L                 RG800905
235258             SET SS08WS-ERROR-SW-YES                              RG800905
235259                                 TO TRUE                          RG800905
235260             GO TO 9199-IBX-EXIT.                                 RG800905
235262     IF NOT MO05-VALID-MC-BIN                                     RG800905
235264         MOVE DFHBMNBF           TO MO05-MC-BIN-A                 RG800905
235266         MOVE DFHBMASB           TO MO05-MC-BIN-LP-A              RG800905
235268                                    MO05-MC-BIN-RP-A              RG800905
235270         MOVE SS08WS-CURSOR      TO MO05-MC-BIN-L                 RG800905
235272         SET SS08WS-ERROR-SW-YES TO TRUE                          RG800905
235274         GO TO 9199-IBX-EXIT.                                     RG800905
235276     MOVE DFHBMASF               TO MO05-MC-BIN-A.                RG800905
235278     MOVE DFHBMDAS               TO MO05-MC-BIN-LP-A              RG800905
235280                                    MO05-MC-BIN-RP-A.             RG800905
235282     SET WS-UPDATE-SW-YES        TO TRUE.                         RG800905
235298 9199-IBX-EXIT.                                                   RG800905
235299     EXIT.                                                        RG800905
235300/
235400     COPY SMCOPX.
235500/
235600     COPY SMCOPXO REPLACING ==:XXCA:== BY ==MBCA==.
235700/
235800     COPY SMCUPXO REPLACING ==:XXCA:== BY ==MBCA==.
235900/         JULIAN TO GREGORIAN DATE ROUTINE.
236000     COPY SS08PD.
236100/         DATE AND TIME EDIT ROUTINES.
236200     COPY SS26PD.
236300     COPY SS27PD.
236400/         CHECK DIGIT ROUTINE.
236500     COPY SS09PD.
236600/         LINE 24 PF KEYS ROUTINE
236700     COPY SS15PD.
236800/         ORGANIZATION RECORD ACCESS ROUTINES
236900     COPY MMOCAO.
237000/         LOG/JOURNAL ACCESS ROUTINES
237100     COPY MML1AO.
237200/         ON-LINE MAP ROUTINES
237300     COPY MB60PD REPLACING 'MBMAPXX' BY 'MBMO05 '
237400                           MBMAPXXI BY MBMO05I
237500                           MBMAPXXO BY MBMO05O.
237600/         ON-LINE PROCEDURES
237700     COPY MB70PD.
237800/
237900     COPY SMFTPXO.
