000100 IDENTIFICATION DIVISION.
000200 PROGRAM-ID. MBOMO09.
000201*       RELEASE DATE=08/24/01.        REVISION LEVEL=08.06      *
000202*****************************************************************
000203*WARNING.  THIS COMPUTER PROGRAM IS PROTECTED BY COPYRIGHT LAW  *
000204*AND INTERNATIONAL TREATIES.  UNAUTHORIZED REPRODUCTION OR      *
000205*DISTRIBUTION OF THIS PROGRAM, OR ANY PORTION OF IT, MAY RESULT *
000206*IN SEVERE CIVIL AND CRIMINAL PENATLIES, AND WILL BE PROSECUTED *
000207*TO THE MAXIMUM EXTENT POSSIBLE UNDER THE LAW.                  *
000208*COPYRIGHT 1999 PAYSYS INTERNATIONAL, INC.  ALL RIGHTS RESERVED.*
000209*****************************************************************
000300*****************************************************************
000400*                                                               *
000500*               M E R C H A N T   S Y S T E M                   *
000600*                                                               *
000700*      MBOMO09 - ON-LINE ORG RECORD ADD/MAINTENANCE/INQUIRY     *
000800*                SCREEN 09                                      *
000900*                                                               *
001000*              1. TRANSIDS                                      *
001100*                 A. MBAO                                       *
001200*                 B. MBMO                                       *
001300*                 C. MBQO                                       *
001400*              2. MAPS USED -                                   *
001500*                 A. MBMO09 (ORGANIZATION MAP 09)               *
001600*              3. FILES USED -                                  *
001700*                 A. MMOC   (SYSTEM/ORG CONTROL FILE)           *
001800*                 B. MML1   (LOG/JOURNAL FILE)                  *
001900*                                                               *
002000*****************************************************************
002100*
002200 ENVIRONMENT DIVISION.
002300 DATA DIVISION.
002400 WORKING-STORAGE SECTION.
002500 01  FILLER                  PIC  X(12)      VALUE '** WS-BEG **'.
002600*         I/O REQUEST BLOCK WORK AREAS
002700     COPY MBIOWS.
002800/         I/O REQUEST BLOCK
002900     COPY MBIORO.
003000/         LOG/JOURNAL WORK AREAS
003100     COPY MML1WS REPLACING ==:MML1:== BY ==MML1==.
003200/         DATE WORK AREAS
003300     COPY SS01WS.
003400/         ONLINE WORK AREAS
003500     COPY SS08WS.
003600/
003700     COPY SS00WS.
003800/
003900     COPY SMFTWS.
004000/
004100     COPY SMPTRL REPLACING ==:SMPT:== BY ==SMPT==.
004200/
004300     COPY MB61LK.
004400/
004500 01  WS-WORK-AREAS.
004600     03  WS-INDEX            PIC S9(04)      BINARY.
004700     03  WS-UPDATE-SW        PIC  X(01)      VALUE 'N'.
004800         88  WS-UPDATE-SW-NO                 VALUE 'N'.
004900         88  WS-UPDATE-SW-YES                VALUE 'Y'.
005000 01  FILLER                  PIC  X(12)      VALUE '** WS-END **'.
005100/
005200 LINKAGE SECTION.
005300 01  DFHCOMMAREA.
005400     COPY MB60WS.
005500/         ORG SCREEN 09 MAP DSECT
005600     COPY MBMO09.
005700/         ORG SCREEN 09 MAP REDEFINITION
005800     COPY MBMO09R.
005900/         SYSTEM/ORG CONTROL FILE RECORD LAYOUT
006000     COPY MMOCRL.
006100/         LOG/JOURNAL FILE RECORD LAYOUT
006200     COPY MML1RL REPLACING ==:MML1:== BY ==MML1==.
006300/
006400 PROCEDURE DIVISION.
006500 0000-HOUSEKEEPING SECTION.
006600 0100-INIT.
006700*
006800     MOVE 'PC01'                 TO MBCA-PROGRAM-LOCATION.
006900     PERFORM MB70PD-ON-LINE-HOUSEKEEPING
007000                                 THRU MB70PD-OLH-EXIT.
007100*
007200     IF  MBCA-RECEIVE-SCREEN
007300         GO TO 2000-RECEIVE-SCREEN.
007400/
007500 1000-SEND-SCREEN SECTION.
007600*
007700****************************************************************
007800*    THIS SECTION BUILDS AND SENDS THE 09 SCREEN.              *
007900****************************************************************
008000*
008100****************************************************************
008200*    GET CICS STORAGE NEEDED FOR THE MAP                       *
008300****************************************************************
008400*
008500     MOVE 'SC01'                 TO MBCA-PROGRAM-LOCATION.
008600     PERFORM MB60PD-GETMAIN-FOR-MAP
008700                                 THRU MB60PD-GFM-EXIT.
008800*
008900     MOVE MBCA-MERCHANT-ORG      TO MO09-ORG.
009000     MOVE 09                     TO MBCA-SCREEN-NBR.
009100*
009200****************************************************************
009300*    INITIALIZE THE STANDARD MAP LINES                         *
009400****************************************************************
009500*
009600     PERFORM MB60PD-INIT-STD-MAP-LINES
009700                                 THRU MB60PD-ISML-EXIT.
009800*
009900****************************************************************
010000*    READ THE ORGANIZATION FILE RECORD                         *
010100****************************************************************
010200*
010300     MOVE 'FC01'                 TO MBCA-PROGRAM-LOCATION.
010400     MOVE MBCA-MERCHANT-ORG      TO MBIOWS-MMOC-ORG.
010500     SET MBIORO-READ-RANDOM      TO TRUE.
010600     PERFORM MMOCAO-ACCESS       THRU MMOCAO-ACCESS-EXIT.
010700/
010800 1100-BUILD-SCREEN.
010900*
011000****************************************************************
011100*    BUILD THE MAP FROM THE ORGANIZATION RECORD                *
011200****************************************************************
011300*
011400     MOVE MMOC-NA-LINE (1 1)     TO MO09-ORG-NAME.
011500*
011600     PERFORM 9100-BUILD-STMT-MSG THRU 9199-BSM-EXIT
011700         VARYING X-MO09-STMT-MSG FROM +1 BY +1
011800         UNTIL   X-MO09-STMT-MSG IS GREATER THAN +4.
011900*
012000/
012100****************************************************************
012200*    IF INQUIRY, DARKEN PARENS AND ASKIP FIELDS                *
012300****************************************************************
012400*
012500     MOVE SS08WS-CURSOR          TO MO09-STATEMENT-MSG-01-L (01).
012600*
012700     IF  MBCA-PTI-FUNCTION-IS-INQUIRY
012800         MOVE SS08WS-CURSOR      TO MO09-ALT-TRANID-L
012900         PERFORM 9200-SET-STMT-MSG-ATTRIBUTES
013000                                 THRU 9299-SSMA-EXIT
013100             VARYING X-MO09-STMT-MSG FROM +1 BY +1
013200             UNTIL   X-MO09-STMT-MSG IS GREATER THAN +4.
013300*
013400****************************************************************
013500*    SEND THE MAP                                              *
013600****************************************************************
013700*
013800     MOVE 'BM01'                 TO MBCA-PROGRAM-LOCATION.
013900     PERFORM MB60PD-SEND-MAP-WITH-ERASE
014000                                 THRU MB60PD-SMWE-EXIT.
014100*
014200****************************************************************
014300*    RETURN TO CICS                                            *
014400****************************************************************
014500*
014600     MOVE 'PC02'                 TO MBCA-PROGRAM-LOCATION.
014700     PERFORM MB70PD-RETURN-TRANS-ID
014800                                 THRU MB70PD-RTI-EXIT.
014900/
015000 2000-RECEIVE-SCREEN SECTION.
015100*
015200****************************************************************
015300*    THIS SECTION RECEIVES THE 09 SCREEN                       *
015400****************************************************************
015500*
015600     MOVE 'BM02'                 TO MBCA-PROGRAM-LOCATION.
015700     PERFORM MB60PD-RECEIVE-MAP  THRU MB60PD-RM-EXIT.
015800*
015900****************************************************************
016000*    CHECK FOR ANOTHER TRANSACTION ID ENTERED BY THE USER      *
016100****************************************************************
016200*
016300     MOVE 'PC03'                 TO MBCA-PROGRAM-LOCATION.
016400     PERFORM MB60PD-NEW-TRANS-ROUTINE
016500                                 THRU MB60PD-NTR-EXIT.
016600*
016700****************************************************************
016800*    BYPASS EDITS ON INQUIRY                                   *
016900****************************************************************
017000*
017100     IF  MBCA-PTI-FUNCTION-IS-INQUIRY
017200         GO TO 2600-SETUP-COMMAREA.
017300*
017400****************************************************************
017500*    READ THE ORGANIZATION FILE RECORD                         *
017600****************************************************************
017700*
017800     MOVE 'FC02'                 TO MBCA-PROGRAM-LOCATION.
017900     MOVE MBCA-MERCHANT-ORG      TO MBIOWS-MMOC-ORG.
018000     SET MBIORO-READ-RANDOM      TO TRUE.
018100     PERFORM MMOCAO-ACCESS       THRU MMOCAO-ACCESS-EXIT.
018200*
018300****************************************************************
018400*    EDIT FIELDS                                               *
018500****************************************************************
018600*
018700*            ***** STATEMENT MESSAGES *****                    *
018800*
018900     PERFORM 9300-EDIT-STMT-MSG  THRU 9399-ESM-EXIT
019000         VARYING X-MO09-STMT-MSG FROM +1 BY +1
019100         UNTIL   X-MO09-STMT-MSG IS GREATER THAN +4.
019200*
019300     IF  SS08WS-ERROR-SW-NO
019400         GO TO 2400-UPDATE-FILE.
019500*
019600****************************************************************
019700*    SEND THE MAP                                              *
019800****************************************************************
019900*
020000     PERFORM MB60PD-INIT-STD-MAP-LINES
020100                                 THRU MB60PD-ISML-EXIT.
020200     MOVE 'BM03'                 TO MBCA-PROGRAM-LOCATION.
020300     PERFORM MB60PD-SEND-MAP-DATA-ONLY
020400                                 THRU MB60PD-SMDO-EXIT.
020500*
020600****************************************************************
020700*    RETURN TO CICS                                            *
020800****************************************************************
020900*
021000     MOVE 'PC04'                 TO MBCA-PROGRAM-LOCATION.
021100     MOVE 09                     TO MBCA-SCREEN-NBR.
021200     PERFORM MB70PD-RETURN-TRANS-ID
021300                                 THRU MB70PD-RTI-EXIT.
021400/
021500 2400-UPDATE-FILE.
021600*
021700     IF  WS-UPDATE-SW-NO
021800         IF  MBCA-PTI-FUNCTION-IS-ADD
021900             MOVE 'FC03'         TO MBCA-PROGRAM-LOCATION
022000             MOVE MBCA-MERCHANT-ORG
022100                                 TO MBIOWS-MMOC-ORG
022200             SET MBIORO-READ-RANDOM-UPDATE
022300                                 TO TRUE
022400             PERFORM MMOCAO-ACCESS
022500                                 THRU MMOCAO-ACCESS-EXIT
022600             MOVE MBCA-SCREEN-NBR
022700                                 TO MMOC-ONLINE-STATUS
022800             MOVE 'FC04'         TO MBCA-PROGRAM-LOCATION
022900             SET MBIORO-REWRITE  TO TRUE
023000             PERFORM MMOCAO-ACCESS
023100                                 THRU MMOCAO-ACCESS-EXIT
023200             GO TO 2600-SETUP-COMMAREA
023300         ELSE
023400             GO TO 2600-SETUP-COMMAREA.
023500*
023600****************************************************************
023700*    GETMAIN FOR LOG/JOURNAL RECORD                            *
023800****************************************************************
023900*
024000     MOVE 'SC02'                 TO MBCA-PROGRAM-LOCATION.
024100     SET MBIORO-GETMAIN          TO TRUE.
024200     PERFORM MML1AO-ACCESS       THRU MML1AO-ACCESS-EXIT.
024300*
024400****************************************************************
024500*    READ THE ORGANIZATION FILE RECORD FOR UPDATE              *
024600****************************************************************
024700*
024800     MOVE 'FC05'                 TO MBCA-PROGRAM-LOCATION.
024900     MOVE MBCA-MERCHANT-ORG      TO MBIOWS-MMOC-ORG.
025000     SET MBIORO-READ-RANDOM-UPDATE
025100                                 TO TRUE.
025200     PERFORM MMOCAO-ACCESS       THRU MMOCAO-ACCESS-EXIT.
025300*
025400     PERFORM 9400-STMT-MSG-LOG-RECORDS
025500                                 THRU 9499-SMLR-EXIT
025600         VARYING X-MO09-STMT-MSG FROM +1 BY +1
025700         UNTIL   X-MO09-STMT-MSG IS GREATER THAN +4.
025800*
025900     IF  MBCA-PTI-FUNCTION-IS-ADD
026000         MOVE 09                 TO MMOC-ONLINE-STATUS.
026100*
026200*            ***** LAST MAINT DATE AND OPERATOR ID *****       *
026300*
026400     MOVE ZEROES                 TO MML1-FIELD-OCCURRENCE.
026500     MOVE 0199                   TO MML1-FIELD-CODE.
026600     MOVE MML1WS-VL-07           TO MML1-VARIABLE-LENGTH.
026700     MOVE MMOC-LAST-MAINT-DATE
026800                                 TO MML1-VL07-B-DATA-9.
026900     MOVE MBCA-START-DATE        TO MMOC-LAST-MAINT-DATE.
027000     MOVE MMOC-LAST-MAINT-DATE
027100                                 TO MML1-VL07-A-DATA-9.
027200     PERFORM 9050-CREATE-MAINT-RECORD
027300                                 THRU 9099-CMR-EXIT.
027400     MOVE 0198                   TO MML1-FIELD-CODE.
027500     MOVE MML1WS-VL-03           TO MML1-VARIABLE-LENGTH.
027600     MOVE MMOC-LAST-MAINT-OPER
027700                                 TO MML1-VL03-B-DATA-X.
027800     MOVE MBCA-OPERATOR-ID       TO MMOC-LAST-MAINT-OPER.
027900     MOVE MMOC-LAST-MAINT-OPER
028000                                 TO MML1-VL03-A-DATA-X.
028100     PERFORM 9050-CREATE-MAINT-RECORD
028200                                 THRU 9099-CMR-EXIT.
028300*
028400****************************************************************
028500*    UPDATE THE ORGANIZATION FILE RECORD                       *
028600****************************************************************
028700*
028800     MOVE 'FC06'                 TO MBCA-PROGRAM-LOCATION.
028900     SET MBIORO-REWRITE          TO TRUE.
029000     PERFORM MMOCAO-ACCESS       THRU MMOCAO-ACCESS-EXIT.
029100*
029200 2600-SETUP-COMMAREA.
029300*
029400****************************************************************
029500*    SET UP COMMAREA FIELDS AND TRANSFER TO THE NEXT PROGRAM   *
029600****************************************************************
029700*
029800     MOVE MBCA-EIBAID            TO SS08WS-EIBAID.
029900*
030000     PERFORM MB60PD-EDIT-PAGE-NBR
030100                                 THRU MB60PD-EPN-EXIT.
030200*
030300     IF  SS08WS-VALID-PF-KEY
030400     OR  SS08WS-EIBAID-VALID-PF-KEY
030500         SET MBCA-INITIAL-SCREEN-NBR
030600                                 TO TRUE.
030700*
030800     MOVE 'PC05'                 TO MBCA-PROGRAM-LOCATION.
030900     PERFORM MB70PD-XCTL-TO-MBOXCTL
031000                                 THRU MB70PD-XTM-EXIT.
031100/
031200 9000-PERFORMED-ROUTINES-SECT SECTION.
031300*
031400 9050-CREATE-MAINT-RECORD.
031500*
031600*****************************************************************
031700*    THIS ROUTINE WILL CREATE THE COMMON DATA FOR ALL OF THE    *
031800*    LOG/JOURNAL TRANSACTIONS                                   *
031900*****************************************************************
032000*
032100     IF  MBCA-PTI-FUNCTION-IS-ADD
032200         GO TO 9099-CMR-EXIT.
032300*
032400     MOVE 'OC'                   TO MML1-FILE-CODE.
032500     MOVE MBCA-MERCHANT-ORG      TO MML1-MMOC-ORG.
032600     MOVE MBCA-SIGNON-NAME       TO MML1-SIGNON-NAME.
032700     MOVE MBCA-TERMINAL-ID       TO MML1-TERMINAL-ID.
032800     MOVE ZEROES                 TO MML1-SOURCE-CODE
032900                                    MML1-FIELD-OCCURRENCE-2.
033000*
033100*****************************************************************
033200*    WRITE THE LOG/JOURNAL FILE RECORD                          *
033300*****************************************************************
033400*
033500     MOVE 'FC07'                 TO MBCA-PROGRAM-LOCATION.
033600     SET MBIORO-WRITE            TO TRUE.
033700     PERFORM MML1AO-ACCESS       THRU MML1AO-ACCESS-EXIT.
033800     MOVE SPACES                 TO MML1-VARIABLE-AREA.
033900*
034000 9099-CMR-EXIT.
034100     EXIT.
034200*
034300 9100-BUILD-STMT-MSG.
034400*
034500     SET X-MMOC-STMT-MSG         TO X-MO09-STMT-MSG.
034600*
034700     MOVE MMOC-ORG-STMT-MSG-L1    (X-MMOC-STMT-MSG)
034800                                 TO MO09-STATEMENT-MSG-01
034900                                    (X-MO09-STMT-MSG).
035000*
035100     MOVE MMOC-ORG-STMT-MSG-L2    (X-MMOC-STMT-MSG)
035200                                 TO MO09-STATEMENT-MSG-02
035300                                    (X-MO09-STMT-MSG).
035400*
035500     MOVE MMOC-ORG-STMT-MSG-L3    (X-MMOC-STMT-MSG)
035600                                 TO MO09-STATEMENT-MSG-03
035700                                    (X-MO09-STMT-MSG).
035800*
035900 9199-BSM-EXIT.
036000     EXIT.
036100*
036200 9200-SET-STMT-MSG-ATTRIBUTES.
036300*
036400     MOVE DFHBMASB               TO MO09-STATEMENT-MSG-01-A
036500                                    (X-MO09-STMT-MSG)
036600                                    MO09-STATEMENT-MSG-02-A
036700                                    (X-MO09-STMT-MSG)
036800                                    MO09-STATEMENT-MSG-03-A
036900                                    (X-MO09-STMT-MSG).
037000     MOVE DFHBMDAS               TO MO09-STATEMENT-MSG-01-LP-A
037100                                    (X-MO09-STMT-MSG)
037200                                    MO09-STATEMENT-MSG-01-RP-A
037300                                    (X-MO09-STMT-MSG)
037400                                    MO09-STATEMENT-MSG-02-LP-A
037500                                    (X-MO09-STMT-MSG)
037600                                    MO09-STATEMENT-MSG-02-RP-A
037700                                    (X-MO09-STMT-MSG)
037800                                    MO09-STATEMENT-MSG-03-LP-A
037900                                    (X-MO09-STMT-MSG)
038000                                    MO09-STATEMENT-MSG-03-RP-A
038100                                    (X-MO09-STMT-MSG).
038200*
038300 9299-SSMA-EXIT.
038400     EXIT.
038500*
038600 9300-EDIT-STMT-MSG.
038700*
038800*            ***** STATEMENT MESSAGES *****                    *
038900*
039000     SET X-MMOC-STMT-MSG         TO X-MO09-STMT-MSG.
039100*
039200     IF  MO09-STATEMENT-MSG-01-L (X-MO09-STMT-MSG) IS LESS THAN 1
039300         MOVE DFHBMASK           TO MO09-STATEMENT-MSG-01-A
039400                                    (X-MO09-STMT-MSG)
039500         MOVE DFHBMDAS           TO MO09-STATEMENT-MSG-01-LP-A
039600                                    (X-MO09-STMT-MSG)
039700                                    MO09-STATEMENT-MSG-01-RP-A
039800                                    (X-MO09-STMT-MSG)
039900         MOVE MMOC-ORG-STMT-MSG-L1    (X-MMOC-STMT-MSG)
040000                                 TO MO09-STATEMENT-MSG-01
040100                                    (X-MO09-STMT-MSG)
040200     ELSE
040300         MOVE DFHBMASF           TO MO09-STATEMENT-MSG-01-A
040400                                    (X-MO09-STMT-MSG)
040500         MOVE DFHBMDAS           TO MO09-STATEMENT-MSG-01-LP-A
040600                                    (X-MO09-STMT-MSG)
040700                                    MO09-STATEMENT-MSG-01-RP-A
040800                                    (X-MO09-STMT-MSG)
040900         SET WS-UPDATE-SW-YES    TO TRUE.
041000*
041100     IF  MO09-STATEMENT-MSG-02-L (X-MO09-STMT-MSG) IS LESS THAN 1
041200         MOVE DFHBMASK           TO MO09-STATEMENT-MSG-02-A
041300                                    (X-MO09-STMT-MSG)
041400         MOVE DFHBMDAS           TO MO09-STATEMENT-MSG-02-LP-A
041500                                    (X-MO09-STMT-MSG)
041600                                    MO09-STATEMENT-MSG-02-RP-A
041700                                    (X-MO09-STMT-MSG)
041800         MOVE MMOC-ORG-STMT-MSG-L2    (X-MMOC-STMT-MSG)
041900                                 TO MO09-STATEMENT-MSG-02
042000                                    (X-MO09-STMT-MSG)
042100     ELSE
042200         MOVE DFHBMASF           TO MO09-STATEMENT-MSG-02-A
042300                                    (X-MO09-STMT-MSG)
042400         MOVE DFHBMDAS           TO MO09-STATEMENT-MSG-02-LP-A
042500                                    (X-MO09-STMT-MSG)
042600                                    MO09-STATEMENT-MSG-02-RP-A
042700                                    (X-MO09-STMT-MSG)
042800         SET WS-UPDATE-SW-YES    TO TRUE.
042900*
043000     IF  MO09-STATEMENT-MSG-03-L (X-MO09-STMT-MSG) IS LESS THAN 1
043100         MOVE DFHBMASK           TO MO09-STATEMENT-MSG-03-A
043200                                    (X-MO09-STMT-MSG)
043300         MOVE DFHBMDAS           TO MO09-STATEMENT-MSG-03-LP-A
043400                                    (X-MO09-STMT-MSG)
043500                                    MO09-STATEMENT-MSG-03-RP-A
043600                                    (X-MO09-STMT-MSG)
043700         MOVE MMOC-ORG-STMT-MSG-L3    (X-MMOC-STMT-MSG)
043800                                 TO MO09-STATEMENT-MSG-03
043900                                    (X-MO09-STMT-MSG)
044000     ELSE
044100         MOVE DFHBMASF           TO MO09-STATEMENT-MSG-03-A
044200                                    (X-MO09-STMT-MSG)
044300         MOVE DFHBMDAS           TO MO09-STATEMENT-MSG-03-LP-A
044400                                    (X-MO09-STMT-MSG)
044500                                    MO09-STATEMENT-MSG-03-RP-A
044600                                    (X-MO09-STMT-MSG)
044700         SET WS-UPDATE-SW-YES    TO TRUE.
044800*
044900 9399-ESM-EXIT.
045000     EXIT.
045100*
045200 9400-STMT-MSG-LOG-RECORDS.
045300*
045400*            ***** STATEMENT MESSAGES *****                    *
045500*
045600     SET X-MMOC-STMT-MSG         TO X-MO09-STMT-MSG.
045700     SET WS-INDEX                TO X-MO09-STMT-MSG.
045800*
045900     IF  MO09-STATEMENT-MSG-01-L (X-MO09-STMT-MSG)
046000                                 IS GREATER THAN ZERO
046100         MOVE WS-INDEX           TO MML1-FIELD-OCCURRENCE
046200         MOVE 0901               TO MML1-FIELD-CODE
046300         MOVE MML1WS-VL-50       TO MML1-VARIABLE-LENGTH
046400         MOVE MMOC-ORG-STMT-MSG-L1    (X-MMOC-STMT-MSG)
046500                                 TO MML1-VL50-B-DATA-X
046600         MOVE MO09-STATEMENT-MSG-01 (X-MO09-STMT-MSG)
046700                                 TO MMOC-ORG-STMT-MSG-L1
046800                                    (X-MMOC-STMT-MSG)
046900         MOVE MMOC-ORG-STMT-MSG-L1     (X-MMOC-STMT-MSG)
047000                                 TO MML1-VL50-A-DATA-X
047100         PERFORM 9050-CREATE-MAINT-RECORD
047200                                 THRU 9099-CMR-EXIT.
047300*
047400     IF  MO09-STATEMENT-MSG-02-L (X-MO09-STMT-MSG)
047500                                 IS GREATER THAN ZERO
047600         MOVE WS-INDEX           TO MML1-FIELD-OCCURRENCE
047700         MOVE 0902               TO MML1-FIELD-CODE
047800         MOVE MML1WS-VL-50       TO MML1-VARIABLE-LENGTH
047900         MOVE MMOC-ORG-STMT-MSG-L2    (X-MMOC-STMT-MSG)
048000                                 TO MML1-VL50-B-DATA-X
048100         MOVE MO09-STATEMENT-MSG-02 (X-MO09-STMT-MSG)
048200                                 TO MMOC-ORG-STMT-MSG-L2
048300                                    (X-MMOC-STMT-MSG)
048400         MOVE MMOC-ORG-STMT-MSG-L2     (X-MMOC-STMT-MSG)
048500                                 TO MML1-VL50-A-DATA-X
048600         PERFORM 9050-CREATE-MAINT-RECORD
048700                                 THRU 9099-CMR-EXIT.
048800*
048900     IF  MO09-STATEMENT-MSG-03-L (X-MO09-STMT-MSG)
049000                                 IS GREATER THAN ZERO
049100         MOVE WS-INDEX           TO MML1-FIELD-OCCURRENCE
049200         MOVE 0903               TO MML1-FIELD-CODE
049300         MOVE MML1WS-VL-50       TO MML1-VARIABLE-LENGTH
049400         MOVE MMOC-ORG-STMT-MSG-L3    (X-MMOC-STMT-MSG)
049500                                 TO MML1-VL50-B-DATA-X
049600         MOVE MO09-STATEMENT-MSG-03 (X-MO09-STMT-MSG)
049700                                 TO MMOC-ORG-STMT-MSG-L3
049800                                    (X-MMOC-STMT-MSG)
049900         MOVE MMOC-ORG-STMT-MSG-L3     (X-MMOC-STMT-MSG)
050000                                 TO MML1-VL50-A-DATA-X
050100         PERFORM 9050-CREATE-MAINT-RECORD
050200                                 THRU 9099-CMR-EXIT.
050300*
050400 9499-SMLR-EXIT.
050500     EXIT.
050600/         JULIAN TO GREGORIAN DATE ROUTINE.
050700     COPY SS08PD.
050800/         DATE AND TIME EDIT ROUTINES.
050900     COPY SS26PD.
051000     COPY SS27PD.
051100/         LINE 24 PF KEYS ROUTINE
051200     COPY SS15PD.
051300/         ORGANIZATION RECORD ACCESS ROUTINES
051400     COPY MMOCAO.
051500/         LOG/JOURNAL ACCESS ROUTINES
051600     COPY MML1AO.
051700/         ON-LINE MAP ROUTINES
051800     COPY MB60PD REPLACING 'MBMAPXX' BY 'MBMO09 '
051900                           MBMAPXXI BY MBMO09I
052000                           MBMAPXXO BY MBMO09O.
052100/         ON-LINE PROCEDURES
052200     COPY MB70PD.
052300/
052400     COPY SMFTPXO.
