000100 IDENTIFICATION DIVISION.
000200 PROGRAM-ID. MBOMO10.
000201*       RELEASE DATE=08/24/01.        REVISION LEVEL=08.06      *
000202*****************************************************************
000203*WARNING.  THIS COMPUTER PROGRAM IS PROTECTED BY COPYRIGHT LAW  *
000204*AND INTERNATIONAL TREATIES.  UNAUTHORIZED REPRODUCTION OR      *
000205*DISTRIBUTION OF THIS PROGRAM, OR ANY PORTION OF IT, MAY RESULT *
000206*IN SEVERE CIVIL AND CRIMINAL PENATLIES, AND WILL BE PROSECUTED *
000207*TO THE MAXIMUM EXTENT POSSIBLE UNDER THE LAW.                  *
000208*COPYRIGHT 1999 PAYSYS INTERNATIONAL, INC.  ALL RIGHTS RESERVED.*
000209*****************************************************************
000300*****************************************************************
000400*                                                               *
000500*               M E R C H A N T   S Y S T E M                   *
000600*                                                               *
000700*      MBOMO10 - ON-LINE ORG RECORD ADD/MAINTENANCE/INQUIRY     *
000800*                SCREEN 10                                      *
000900*                                                               *
001000*              1. TRANSIDS                                      *
001100*                 A. MBAO                                       *
001200*                 B. MBMO                                       *
001300*                 C. MBQO                                       *
001400*              2. MAPS USED -                                   *
001500*                 A. MBMO10 (ORGANIZATION MAP 10)               *
001600*              3. FILES USED -                                  *
001700*                 A. MMOC   (SYSTEM/ORG CONTROL FILE)           *
001800*                 B. MML1   (LOG/JOURNAL FILE)                  *
001900*                                                               *
002000*****************************************************************
002100*
002200 ENVIRONMENT DIVISION.
002300 DATA DIVISION.
002400 WORKING-STORAGE SECTION.
002500 01  FILLER                  PIC  X(12)      VALUE '** WS-BEG **'.
002600*         I/O REQUEST BLOCK WORK AREAS
002700     COPY MBIOWS.
002800/         I/O REQUEST BLOCK
002900     COPY MBIORO.
003000/         LOG/JOURNAL WORK AREAS
003100     COPY MML1WS REPLACING ==:MML1:== BY ==MML1==.
003200/         DATE WORK AREAS
003300     COPY SS01WS.
003400/         ONLINE WORK AREAS
003500     COPY SS08WS.
003600/
003700     COPY SS00WS.
003800/
003900     COPY SMFTWS.
004000/
004100     COPY SMPTRL REPLACING ==:SMPT:== BY ==SMPT==.
004200/
004300     COPY MB61LK.
004400/
004500 01  WS-WORK-AREAS.
004600     03  WS-INDEX            PIC S9(04)      BINARY.
004700     03  WS-UPDATE-SW        PIC  X(01)      VALUE 'N'.
004800         88  WS-UPDATE-SW-NO                 VALUE 'N'.
004900         88  WS-UPDATE-SW-YES                VALUE 'Y'.
005000 01  FILLER                  PIC  X(12)      VALUE '** WS-END **'.
005100/
005200 LINKAGE SECTION.
005300 01  DFHCOMMAREA.
005400     COPY MB60WS.
005500/         ORG SCREEN 10 MAP DSECT
005600     COPY MBMO10.
005700/         ORG SCREEN 10 MAP REDEFINITION
005800     COPY MBMO10R.
005900/         SYSTEM/ORG CONTROL FILE RECORD LAYOUT
006000     COPY MMOCRL.
006100/         LOG/JOURNAL FILE RECORD LAYOUT
006200     COPY MML1RL REPLACING ==:MML1:== BY ==MML1==.
006300/
006400 PROCEDURE DIVISION.
006500 0000-HOUSEKEEPING SECTION.
006600 0100-INIT.
006700*
006800     MOVE 'PC01'                 TO MBCA-PROGRAM-LOCATION.
006900     PERFORM MB70PD-ON-LINE-HOUSEKEEPING
007000                                 THRU MB70PD-OLH-EXIT.
007100*
007200     IF  MBCA-RECEIVE-SCREEN
007300         GO TO 2000-RECEIVE-SCREEN.
007400/
007500 1000-SEND-SCREEN SECTION.
007600*
007700****************************************************************
007800*    THIS SECTION BUILDS AND SENDS THE 10 SCREEN.              *
007900****************************************************************
008000*
008100****************************************************************
008200*    GET CICS STORAGE NEEDED FOR THE MAP                       *
008300****************************************************************
008400*
008500     MOVE 'SC01'                 TO MBCA-PROGRAM-LOCATION.
008600     PERFORM MB60PD-GETMAIN-FOR-MAP
008700                                 THRU MB60PD-GFM-EXIT.
008800*
008900     MOVE MBCA-MERCHANT-ORG      TO MO10-ORG.
009000     MOVE 10                     TO MBCA-SCREEN-NBR.
009100*
009200****************************************************************
009300*    INITIALIZE THE STANDARD MAP LINES                         *
009400****************************************************************
009500*
009600     PERFORM MB60PD-INIT-STD-MAP-LINES
009700                                 THRU MB60PD-ISML-EXIT.
009800*
009900****************************************************************
010000*    READ THE ORGANIZATION FILE RECORD                         *
010100****************************************************************
010200*
010300     MOVE 'FC01'                 TO MBCA-PROGRAM-LOCATION.
010400     MOVE MBCA-MERCHANT-ORG      TO MBIOWS-MMOC-ORG.
010500     SET MBIORO-READ-RANDOM      TO TRUE.
010600     PERFORM MMOCAO-ACCESS       THRU MMOCAO-ACCESS-EXIT.
010700/
010800 1100-BUILD-SCREEN.
010900*
011000****************************************************************
011100*    BUILD THE MAP FROM THE ORGANIZATION RECORD                *
011200****************************************************************
011300*
011400     MOVE MMOC-NA-LINE (1 1)     TO MO10-ORG-NAME.
011500*
011600     SET X-MMOC-STMT-MSG     TO 5.
011700     MOVE MMOC-ORG-STMT-MSG-L1 (X-MMOC-STMT-MSG)
011800                             TO MO10-STATEMENT-MSG-01.
011900     MOVE MMOC-ORG-STMT-MSG-L2 (X-MMOC-STMT-MSG)
012000                             TO MO10-STATEMENT-MSG-02.
012100     MOVE MMOC-ORG-STMT-MSG-L3 (X-MMOC-STMT-MSG)
012200                             TO MO10-STATEMENT-MSG-03.
012300*
012400     PERFORM
012500         VARYING X-MO10-TITLES FROM +1 BY +1
012600         UNTIL   X-MO10-TITLES IS GREATER THAN +10
012700         SET X-MMOC-UFT          TO X-MO10-TITLES
012800         MOVE MMOC-UF-TITLES-DESC    (X-MMOC-UFT)
012900                                 TO MO10-USER-FEE-TITLE
013000                                    (X-MO10-TITLES)
013100     END-PERFORM.
013200*
013300/
013400****************************************************************
013500*    IF INQUIRY, DARKEN PARENS AND ASKIP FIELDS                *
013600****************************************************************
013700*
013800     MOVE SS08WS-CURSOR          TO MO10-STATEMENT-MSG-01-L.
013900*
014000     IF  MBCA-PTI-FUNCTION-IS-INQUIRY
014100         MOVE SS08WS-CURSOR      TO MO10-ALT-TRANID-L
014200         MOVE DFHBMASB           TO MO10-STATEMENT-MSG-01-A
014300                                    MO10-STATEMENT-MSG-02-A
014400                                    MO10-STATEMENT-MSG-03-A
014500         MOVE DFHBMDAS           TO MO10-STATEMENT-MSG-01-LP-A
014600                                    MO10-STATEMENT-MSG-01-RP-A
014700                                    MO10-STATEMENT-MSG-02-LP-A
014800                                    MO10-STATEMENT-MSG-02-RP-A
014900                                    MO10-STATEMENT-MSG-03-LP-A
015000                                    MO10-STATEMENT-MSG-03-RP-A
015100         PERFORM
015200             VARYING X-MO10-TITLES FROM +1 BY +1
015300             UNTIL   X-MO10-TITLES IS GREATER THAN +10
015400             MOVE DFHBMASB       TO MO10-USER-FEE-TITLE-A
015500                                    (X-MO10-TITLES)
015600             MOVE DFHBMDAS       TO MO10-USER-FEE-TITLE-LP-A
015700                                    (X-MO10-TITLES)
015800                                    MO10-USER-FEE-TITLE-RP-A
015900                                    (X-MO10-TITLES)
016000         END-PERFORM.
016100*
016200*
016300****************************************************************
016400*    SEND THE MAP                                              *
016500****************************************************************
016600*
016700     MOVE 'BM01'                 TO MBCA-PROGRAM-LOCATION.
016800     PERFORM MB60PD-SEND-MAP-WITH-ERASE
016900                                 THRU MB60PD-SMWE-EXIT.
017000*
017100****************************************************************
017200*    RETURN TO CICS                                            *
017300****************************************************************
017400*
017500     MOVE 'PC02'                 TO MBCA-PROGRAM-LOCATION.
017600     PERFORM MB70PD-RETURN-TRANS-ID
017700                                 THRU MB70PD-RTI-EXIT.
017800/
017900 2000-RECEIVE-SCREEN SECTION.
018000*
018100****************************************************************
018200*    THIS SECTION RECEIVES THE 10 SCREEN                       *
018300****************************************************************
018400*
018500     MOVE 'BM02'                 TO MBCA-PROGRAM-LOCATION.
018600     PERFORM MB60PD-RECEIVE-MAP  THRU MB60PD-RM-EXIT.
018700*
018800****************************************************************
018900*    CHECK FOR ANOTHER TRANSACTION ID ENTERED BY THE USER      *
019000****************************************************************
019100*
019200     MOVE 'PC03'                 TO MBCA-PROGRAM-LOCATION.
019300     PERFORM MB60PD-NEW-TRANS-ROUTINE
019400                                 THRU MB60PD-NTR-EXIT.
019500*
019600****************************************************************
019700*    BYPASS EDITS ON INQUIRY                                   *
019800****************************************************************
019900*
020000     IF  MBCA-PTI-FUNCTION-IS-INQUIRY
020100         GO TO 2600-SETUP-COMMAREA.
020200*
020300****************************************************************
020400*    READ THE ORGANIZATION FILE RECORD                         *
020500****************************************************************
020600*
020700     MOVE 'FC02'                 TO MBCA-PROGRAM-LOCATION.
020800     MOVE MBCA-MERCHANT-ORG      TO MBIOWS-MMOC-ORG.
020900     SET MBIORO-READ-RANDOM      TO TRUE.
021000     PERFORM MMOCAO-ACCESS       THRU MMOCAO-ACCESS-EXIT.
021100*
021200****************************************************************
021300*    EDIT FIELDS                                               *
021400****************************************************************
021500*
021600*            ***** STATEMENT MESSAGES *****                    *
021700*
021800     SET X-MMOC-STMT-MSG         TO 5.
021900*
022000     IF  MO10-STATEMENT-MSG-01-L IS LESS THAN 1
022100         MOVE DFHBMASK           TO MO10-STATEMENT-MSG-01-A
022200         MOVE DFHBMDAS           TO MO10-STATEMENT-MSG-01-LP-A
022300                                    MO10-STATEMENT-MSG-01-RP-A
022400         MOVE MMOC-ORG-STMT-MSG-L1 (X-MMOC-STMT-MSG)
022500                                 TO MO10-STATEMENT-MSG-01
022600     ELSE
022700         MOVE DFHBMASF           TO MO10-STATEMENT-MSG-01-A
022800         MOVE DFHBMDAS           TO MO10-STATEMENT-MSG-01-LP-A
022900                                    MO10-STATEMENT-MSG-01-RP-A
023000         SET WS-UPDATE-SW-YES    TO TRUE.
023100*
023200     IF  MO10-STATEMENT-MSG-02-L IS LESS THAN 1
023300         MOVE DFHBMASK           TO MO10-STATEMENT-MSG-02-A
023400         MOVE DFHBMDAS           TO MO10-STATEMENT-MSG-02-LP-A
023500                                    MO10-STATEMENT-MSG-02-RP-A
023600         MOVE MMOC-ORG-STMT-MSG-L2 (X-MMOC-STMT-MSG)
023700                                 TO MO10-STATEMENT-MSG-02
023800     ELSE
023900         MOVE DFHBMASF           TO MO10-STATEMENT-MSG-02-A
024000         MOVE DFHBMDAS           TO MO10-STATEMENT-MSG-02-LP-A
024100                                    MO10-STATEMENT-MSG-02-RP-A
024200         SET WS-UPDATE-SW-YES    TO TRUE.
024300*
024400     IF  MO10-STATEMENT-MSG-03-L IS LESS THAN 1
024500         MOVE DFHBMASK           TO MO10-STATEMENT-MSG-03-A
024600         MOVE DFHBMDAS           TO MO10-STATEMENT-MSG-03-LP-A
024700                                    MO10-STATEMENT-MSG-03-RP-A
024800         MOVE MMOC-ORG-STMT-MSG-L3 (X-MMOC-STMT-MSG)
024900                                 TO MO10-STATEMENT-MSG-03
025000     ELSE
025100         MOVE DFHBMASF           TO MO10-STATEMENT-MSG-03-A
025200         MOVE DFHBMDAS           TO MO10-STATEMENT-MSG-03-LP-A
025300                                    MO10-STATEMENT-MSG-03-RP-A
025400         SET WS-UPDATE-SW-YES    TO TRUE.
025500*
025600*
025700*            ***** USER FEE TITLES *****                    *
025800*
025900     PERFORM
026000         VARYING X-MO10-TITLES FROM +1 BY +1
026100         UNTIL   X-MO10-TITLES IS GREATER THAN +10
026200         SET X-MMOC-UFT          TO X-MO10-TITLES
026300         IF  MO10-USER-FEE-TITLE-L (X-MO10-TITLES)
026400             IS LESS THAN 1
026500             MOVE DFHBMASK       TO MO10-USER-FEE-TITLE-A
026600                                    (X-MO10-TITLES)
026700             MOVE DFHBMDAS       TO MO10-USER-FEE-TITLE-LP-A
026800                                    (X-MO10-TITLES)
026900                                    MO10-USER-FEE-TITLE-RP-A
027000                                    (X-MO10-TITLES)
027100             MOVE MMOC-UF-TITLES-DESC    (X-MMOC-UFT)
027200                                 TO MO10-USER-FEE-TITLE
027300                                    (X-MO10-TITLES)
027400         ELSE
027500             MOVE DFHBMASF       TO MO10-USER-FEE-TITLE-A
027600                                    (X-MO10-TITLES)
027700             MOVE DFHBMDAS       TO MO10-USER-FEE-TITLE-LP-A
027800                                    (X-MO10-TITLES)
027900                                    MO10-USER-FEE-TITLE-RP-A
028000                                    (X-MO10-TITLES)
028100             SET WS-UPDATE-SW-YES
028200                                 TO TRUE
028300         END-IF
028400     END-PERFORM.
028500*
028600     IF  SS08WS-ERROR-SW-NO
028700         GO TO 2400-UPDATE-FILE.
028800*
028900****************************************************************
029000*    SEND THE MAP                                              *
029100****************************************************************
029200*
029300     PERFORM MB60PD-INIT-STD-MAP-LINES
029400                                 THRU MB60PD-ISML-EXIT.
029500     MOVE 'BM03'                 TO MBCA-PROGRAM-LOCATION.
029600     PERFORM MB60PD-SEND-MAP-DATA-ONLY
029700                                 THRU MB60PD-SMDO-EXIT.
029800*
029900****************************************************************
030000*    RETURN TO CICS                                            *
030100****************************************************************
030200*
030300     MOVE 'PC04'                 TO MBCA-PROGRAM-LOCATION.
030400     MOVE 10                     TO MBCA-SCREEN-NBR.
030500     PERFORM MB70PD-RETURN-TRANS-ID
030600                                 THRU MB70PD-RTI-EXIT.
030700/
030800 2400-UPDATE-FILE.
030900*
031000     IF  WS-UPDATE-SW-NO
031100         IF  MBCA-PTI-FUNCTION-IS-ADD
031200             MOVE 'FC03'         TO MBCA-PROGRAM-LOCATION
031300             MOVE MBCA-MERCHANT-ORG
031400                                 TO MBIOWS-MMOC-ORG
031500             SET MBIORO-READ-RANDOM-UPDATE
031600                                 TO TRUE
031700             PERFORM MMOCAO-ACCESS
031800                                 THRU MMOCAO-ACCESS-EXIT
031900             MOVE MBCA-SCREEN-NBR
032000                                 TO MMOC-ONLINE-STATUS
032100             MOVE 'FC04'         TO MBCA-PROGRAM-LOCATION
032200             SET MBIORO-REWRITE  TO TRUE
032300             PERFORM MMOCAO-ACCESS
032400                                 THRU MMOCAO-ACCESS-EXIT
032500             GO TO 2600-SETUP-COMMAREA
032600         ELSE
032700             GO TO 2600-SETUP-COMMAREA.
032800*
032900****************************************************************
033000*    GETMAIN FOR LOG/JOURNAL RECORD                            *
033100****************************************************************
033200*
033300     MOVE 'SC02'                 TO MBCA-PROGRAM-LOCATION.
033400     SET MBIORO-GETMAIN          TO TRUE.
033500     PERFORM MML1AO-ACCESS       THRU MML1AO-ACCESS-EXIT.
033600*
033700****************************************************************
033800*    READ THE ORGANIZATION FILE RECORD FOR UPDATE              *
033900****************************************************************
034000*
034100     MOVE 'FC05'                 TO MBCA-PROGRAM-LOCATION.
034200     MOVE MBCA-MERCHANT-ORG      TO MBIOWS-MMOC-ORG.
034300     SET MBIORO-READ-RANDOM-UPDATE
034400                                 TO TRUE.
034500     PERFORM MMOCAO-ACCESS       THRU MMOCAO-ACCESS-EXIT.
034600*
034700*            ***** STATEMENT MESSAGES *****                    *
034800*
034900     SET X-MMOC-STMT-MSG         TO 5.
035000     IF  MO10-STATEMENT-MSG-01-L IS GREATER THAN ZERO
035100         MOVE 5                  TO MML1-FIELD-OCCURRENCE
035200         MOVE 0901               TO MML1-FIELD-CODE
035300         MOVE MML1WS-VL-50       TO MML1-VARIABLE-LENGTH
035400         MOVE MMOC-ORG-STMT-MSG-L1 (X-MMOC-STMT-MSG)
035500                                 TO MML1-VL50-B-DATA-X
035600         MOVE MO10-STATEMENT-MSG-01
035700                                 TO MMOC-ORG-STMT-MSG-L1
035800                                    (X-MMOC-STMT-MSG)
035900         MOVE MMOC-ORG-STMT-MSG-L1 (X-MMOC-STMT-MSG)
036000                                 TO MML1-VL50-A-DATA-X
036100         PERFORM 9050-CREATE-MAINT-RECORD
036200                                 THRU 9099-CMR-EXIT.
036300*
036400     IF  MO10-STATEMENT-MSG-02-L IS GREATER THAN ZERO
036500         MOVE 5                  TO MML1-FIELD-OCCURRENCE
036600         MOVE 0902               TO MML1-FIELD-CODE
036700         MOVE MML1WS-VL-50       TO MML1-VARIABLE-LENGTH
036800         MOVE MMOC-ORG-STMT-MSG-L2 (X-MMOC-STMT-MSG)
036900                                 TO MML1-VL50-B-DATA-X
037000         MOVE MO10-STATEMENT-MSG-02
037100                                 TO MMOC-ORG-STMT-MSG-L2
037200                                    (X-MMOC-STMT-MSG)
037300         MOVE MMOC-ORG-STMT-MSG-L2 (X-MMOC-STMT-MSG)
037400                                 TO MML1-VL50-A-DATA-X
037500         PERFORM 9050-CREATE-MAINT-RECORD
037600                                 THRU 9099-CMR-EXIT.
037700*
037800     IF  MO10-STATEMENT-MSG-03-L IS GREATER THAN ZERO
037900         MOVE 5                  TO MML1-FIELD-OCCURRENCE
038000         MOVE 0903               TO MML1-FIELD-CODE
038100         MOVE MML1WS-VL-50       TO MML1-VARIABLE-LENGTH
038200         MOVE MMOC-ORG-STMT-MSG-L3 (X-MMOC-STMT-MSG)
038300                                 TO MML1-VL50-B-DATA-X
038400         MOVE MO10-STATEMENT-MSG-03
038500                                 TO MMOC-ORG-STMT-MSG-L3
038600                                   (X-MMOC-STMT-MSG)
038700         MOVE MMOC-ORG-STMT-MSG-L3 (X-MMOC-STMT-MSG)
038800                                 TO MML1-VL50-A-DATA-X
038900         PERFORM 9050-CREATE-MAINT-RECORD
039000                                 THRU 9099-CMR-EXIT.
039100*
039200     PERFORM 9500-UF-TITLES-LOG-RECORDS
039300                                 THRU 9599-UFT-EXIT
039400         VARYING X-MO10-TITLES   FROM +1 BY +1
039500         UNTIL   X-MO10-TITLES   IS GREATER THAN +10.
039600*
039700     IF  MBCA-PTI-FUNCTION-IS-ADD
039800         MOVE 10                 TO MMOC-ONLINE-STATUS.
039900*
040000*            ***** LAST MAINT DATE AND OPERATOR ID *****       *
040100*
040200     MOVE ZEROES                 TO MML1-FIELD-OCCURRENCE.
040300     MOVE 0199                   TO MML1-FIELD-CODE.
040400     MOVE MML1WS-VL-07           TO MML1-VARIABLE-LENGTH.
040500     MOVE MMOC-LAST-MAINT-DATE
040600                                 TO MML1-VL07-B-DATA-9.
040700     MOVE MBCA-START-DATE        TO MMOC-LAST-MAINT-DATE.
040800     MOVE MMOC-LAST-MAINT-DATE
040900                                 TO MML1-VL07-A-DATA-9.
041000     PERFORM 9050-CREATE-MAINT-RECORD
041100                                 THRU 9099-CMR-EXIT.
041200     MOVE 0198                   TO MML1-FIELD-CODE.
041300     MOVE MML1WS-VL-03           TO MML1-VARIABLE-LENGTH.
041400     MOVE MMOC-LAST-MAINT-OPER
041500                                 TO MML1-VL03-B-DATA-X.
041600     MOVE MBCA-OPERATOR-ID       TO MMOC-LAST-MAINT-OPER.
041700     MOVE MMOC-LAST-MAINT-OPER
041800                                 TO MML1-VL03-A-DATA-X.
041900     PERFORM 9050-CREATE-MAINT-RECORD
042000                                 THRU 9099-CMR-EXIT.
042100*
042200****************************************************************
042300*    UPDATE THE ORGANIZATION FILE RECORD                       *
042400****************************************************************
042500*
042600     MOVE 'FC06'                 TO MBCA-PROGRAM-LOCATION.
042700     SET MBIORO-REWRITE          TO TRUE.
042800     PERFORM MMOCAO-ACCESS       THRU MMOCAO-ACCESS-EXIT.
042900*
043000 2600-SETUP-COMMAREA.
043100*
043200****************************************************************
043300*    SET UP COMMAREA FIELDS AND TRANSFER TO THE NEXT PROGRAM   *
043400****************************************************************
043500*
043600     MOVE MBCA-EIBAID            TO SS08WS-EIBAID.
043700*
043800     PERFORM MB60PD-EDIT-PAGE-NBR
043900                                 THRU MB60PD-EPN-EXIT.
044000*
044100     IF  SS08WS-VALID-PF-KEY
044200     OR  SS08WS-EIBAID-VALID-PF-KEY
044300         SET MBCA-INITIAL-SCREEN-NBR
044400                                 TO TRUE.
044500*
044600     MOVE 'PC05'                 TO MBCA-PROGRAM-LOCATION.
044700     PERFORM MB70PD-XCTL-TO-MBOXCTL
044800                                 THRU MB70PD-XTM-EXIT.
044900/
045000 9000-PERFORMED-ROUTINES-SECT SECTION.
045100*
045200 9050-CREATE-MAINT-RECORD.
045300*
045400*****************************************************************
045500*    THIS ROUTINE WILL CREATE THE COMMON DATA FOR ALL OF THE    *
045600*    LOG/JOURNAL TRANSACTIONS                                   *
045700*****************************************************************
045800*
045900     IF  MBCA-PTI-FUNCTION-IS-ADD
046000         GO TO 9099-CMR-EXIT.
046100*
046200     MOVE 'OC'                   TO MML1-FILE-CODE.
046300     MOVE MBCA-MERCHANT-ORG      TO MML1-MMOC-ORG.
046400     MOVE MBCA-SIGNON-NAME       TO MML1-SIGNON-NAME.
046500     MOVE MBCA-TERMINAL-ID       TO MML1-TERMINAL-ID.
046600     MOVE ZEROES                 TO MML1-SOURCE-CODE
046700                                    MML1-FIELD-OCCURRENCE-2.
046800*
046900*****************************************************************
047000*    WRITE THE LOG/JOURNAL FILE RECORD                          *
047100*****************************************************************
047200*
047300     MOVE 'FC07'                 TO MBCA-PROGRAM-LOCATION.
047400     SET MBIORO-WRITE            TO TRUE.
047500     PERFORM MML1AO-ACCESS       THRU MML1AO-ACCESS-EXIT.
047600     MOVE SPACES                 TO MML1-VARIABLE-AREA.
047700*
047800 9099-CMR-EXIT.
047900     EXIT.
048000*
048100 9500-UF-TITLES-LOG-RECORDS.
048200*
048300*            ***** USER-FEE TITLES *****                    *
048400*
048500     SET X-MMOC-UFT              TO X-MO10-TITLES.
048600     IF  MO10-USER-FEE-TITLE-L (X-MO10-TITLES)
048700                                 IS GREATER THAN ZERO
048800         SET WS-INDEX            TO X-MO10-TITLES
048900         MOVE WS-INDEX           TO MML1-FIELD-OCCURRENCE
049000         MOVE 1001               TO MML1-FIELD-CODE
049100         MOVE MML1WS-VL-20       TO MML1-VARIABLE-LENGTH
049200         MOVE MMOC-UF-TITLES-DESC    (X-MMOC-UFT)
049300                                 TO MML1-VL20-B-DATA-X
049400         MOVE MO10-USER-FEE-TITLE (X-MO10-TITLES)
049500                                 TO MMOC-UF-TITLES-DESC
049600                                    (X-MMOC-UFT)
049700         MOVE MMOC-UF-TITLES-DESC     (X-MMOC-UFT)
049800                                 TO MML1-VL20-A-DATA-X
049900         PERFORM 9050-CREATE-MAINT-RECORD
050000                                 THRU 9099-CMR-EXIT.
050100*
050200*
050300 9599-UFT-EXIT.
050400     EXIT.
050500*
050600*
050700/         JULIAN TO GREGORIAN DATE ROUTINE.
050800     COPY SS08PD.
050900/         DATE AND TIME EDIT ROUTINES.
051000     COPY SS26PD.
051100     COPY SS27PD.
051200/         LINE 24 PF KEYS ROUTINE
051300     COPY SS15PD.
051400/         ORGANIZATION RECORD ACCESS ROUTINES
051500     COPY MMOCAO.
051600/         LOG/JOURNAL ACCESS ROUTINES
051700     COPY MML1AO.
051800/         ON-LINE MAP ROUTINES
051900     COPY MB60PD REPLACING 'MBMAPXX' BY 'MBMO10 '
052000                           MBMAPXXI BY MBMO10I
052100                           MBMAPXXO BY MBMO10O.
052200/         ON-LINE PROCEDURES
052300     COPY MB70PD.
052400/
052500     COPY SMFTPXO.
