000100 IDENTIFICATION DIVISION.
000200 PROGRAM-ID. MBOMO11.
000201*       RELEASE DATE=08/24/01.        REVISION LEVEL=08.06      *
000202*****************************************************************
000203*WARNING.  THIS COMPUTER PROGRAM IS PROTECTED BY COPYRIGHT LAW  *
000204*AND INTERNATIONAL TREATIES.  UNAUTHORIZED REPRODUCTION OR      *
000205*DISTRIBUTION OF THIS PROGRAM, OR ANY PORTION OF IT, MAY RESULT *
000206*IN SEVERE CIVIL AND CRIMINAL PENATLIES, AND WILL BE PROSECUTED *
000207*TO THE MAXIMUM EXTENT POSSIBLE UNDER THE LAW.                  *
000208*COPYRIGHT 1999 PAYSYS INTERNATIONAL, INC.  ALL RIGHTS RESERVED.*
000209*****************************************************************
000300*****************************************************************
000400*                                                               *
000500*   V - PLUS  M E R C H A N T   B A N K C A R D   S Y S T E M   *
000600*                                                               *
000700*      MBOMO11 - ON-LINE ORG RECORD ADD/MAINTENANCE/INQUIRY     *
000800*                SCREEN 11                                      *
000900*                                                               *
001000*              1. TRANSIDS                                      *
001100*                 A. MBAO                                       *
001200*                 B. MBMO                                       *
001300*                 C. MBQO                                       *
001400*              2. MAPS USED -                                   *
001500*                 A. MBMO11 (ORGANIZATION MAP 11)               *
001600*              3. FILES USED -                                  *
001700*                 A. MMOC   (SYSTEM/ORG CONTROL FILE)           *
001800*                 B. MML1   (LOG/JOURNAL FILE)                  *
001900*                                                               *
002000*****************************************************************
002100*
002200 ENVIRONMENT DIVISION.
002300 DATA DIVISION.
002400 WORKING-STORAGE SECTION.
002500 01  FILLER                  PIC  X(12)      VALUE '** WS-BEG **'.
002600*         I/O REQUEST BLOCK WORK AREAS
002700     COPY MBIOWS.
002800/         I/O REQUEST BLOCK
002900     COPY MBIORO.
003000/         LOG/JOURNAL WORK AREAS
003100     COPY MML1WS REPLACING ==:MML1:== BY ==MML1==.
003200/         DATE WORK AREAS
003300     COPY SS01WS.
003400/         ONLINE WORK AREAS
003500     COPY SS08WS.
003600/
003700     COPY SS00WS.
003800/
003900     COPY SMFTWS.
004000/
004100     COPY SMPTRL REPLACING ==:SMPT:== BY ==SMPT==.
004200/
004300     COPY MB61LK.
004400/
004500 01  WS-WORK-AREAS.
004600     03  WS-UPDATE-SW        PIC  X(01)      VALUE 'N'.
004700         88  WS-UPDATE-SW-NO                 VALUE 'N'.
004800         88  WS-UPDATE-SW-YES                VALUE 'Y'.
004900     03  WS-INDEX            PIC S9(04)      BINARY.
005000 01  FILLER                  PIC  X(12)      VALUE '** WS-END **'.
005100/
005200 LINKAGE SECTION.
005300 01  DFHCOMMAREA.
005400     COPY MB60WS.
005500/         ORG SCREEN 11 MAP DSECT
005600     COPY MBMO11.
005700/         ORG SCREEN 11 MAP REDEFINITION
005800     COPY MBMO11R.
005900/         SYSTEM/ORG CONTROL FILE RECORD LAYOUT
006000     COPY MMOCRL.
006100/         LOG/JOURNAL FILE RECORD LAYOUT
006200     COPY MML1RL REPLACING ==:MML1:== BY ==MML1==.
006300/
006400 PROCEDURE DIVISION.
006500 0000-HOUSEKEEPING SECTION.
006600 0100-INIT.
006700*
006800     MOVE 'PC01'                 TO MBCA-PROGRAM-LOCATION.
006900     PERFORM MB70PD-ON-LINE-HOUSEKEEPING
007000                                 THRU MB70PD-OLH-EXIT.
007100*
007200     IF  MBCA-RECEIVE-SCREEN
007300         GO TO 2000-RECEIVE-SCREEN.
007400/
007500 1000-SEND-SCREEN SECTION.
007600*
007700****************************************************************
007800*    THIS SECTION BUILDS AND SENDS THE 11 SCREEN               *
007900****************************************************************
008000*
008100****************************************************************
008200*    GET CICS STORAGE NEEDED FOR THE MAP                       *
008300****************************************************************
008400*
008500     MOVE 'SC01'                 TO MBCA-PROGRAM-LOCATION.
008600     PERFORM MB60PD-GETMAIN-FOR-MAP
008700                                 THRU MB60PD-GFM-EXIT.
008800*
008900     MOVE MBCA-MERCHANT-ORG      TO MO11-ORG.
009000*
009100     MOVE 11                     TO MBCA-SCREEN-NBR.
009200*
009300****************************************************************
009400*    INITIALIZE THE STANDARD MAP LINES                         *
009500****************************************************************
009600*
009700     PERFORM MB60PD-INIT-STD-MAP-LINES
009800                                 THRU MB60PD-ISML-EXIT.
009900*
010000****************************************************************
010100*    READ THE ORGANIZATION FILE RECORD                         *
010200****************************************************************
010300*
010400     MOVE 'FC01'                 TO MBCA-PROGRAM-LOCATION.
010500     MOVE MBCA-MERCHANT-ORG      TO MBIOWS-MMOC-ORG.
010600     SET MBIORO-READ-RANDOM      TO TRUE.
010700     PERFORM MMOCAO-ACCESS       THRU MMOCAO-ACCESS-EXIT.
010800/
010900 1100-BUILD-SCREEN.
011000*
011100****************************************************************
011200*    BUILD THE MAP FROM THE ORGANIZATION RECORD                *
011300****************************************************************
011400*
011500     MOVE MMOC-NA-LINE (1 1)     TO MO11-ORG-NAME.
011600*
011700     PERFORM 8100-BUILD-USER-DATA
011800                                 THRU 8199-BUD-EXIT
011900         VARYING X-MO11-USER-DATA FROM +1 BY +1
012000         UNTIL   X-MO11-USER-DATA IS GREATER THAN +8.
012100*
012200     PERFORM 8200-BUILD-USER-DATE
012300                                 THRU 8299-BUD-EXIT
012400         VARYING X-MO11-USER-DATE FROM +1 BY +1
012500         UNTIL   X-MO11-USER-DATE IS GREATER THAN +8.
012600*
012700     PERFORM 8300-BUILD-USER-AMOUNT
012800                                 THRU 8399-BUA-EXIT
012900         VARYING X-MO11-USER-AMT FROM +1 BY +1
013000         UNTIL   X-MO11-USER-AMT IS GREATER THAN +8.
013100/
013200****************************************************************
013300*    IF INQUIRY, DARKEN PARENS AND ASKIP FIELDS                *
013400****************************************************************
013500*
013600     SET X-MO11-USER-DATA        TO +1.
013700*
013800     MOVE SS08WS-CURSOR          TO MO11-USER-DATA-DESC-L
013900                                    (X-MO11-USER-DATA).
014000*
014100     IF  MBCA-PTI-FUNCTION-IS-INQUIRY
014200         MOVE SS08WS-CURSOR      TO MO11-ALT-TRANID-L
014300         PERFORM 8400-SET-USER-DATA-ATTRIBUTES
014400                                 THRU 8499-SUDA-EXIT
014500             VARYING X-MO11-USER-DATA FROM +1 BY +1
014600             UNTIL   X-MO11-USER-DATA IS GREATER THAN +8
014700         PERFORM 8500-SET-USER-DATE-ATTRIBUTES
014800                                 THRU 8599-SUDA-EXIT
014900             VARYING X-MO11-USER-DATE FROM +1 BY +1
015000             UNTIL   X-MO11-USER-DATE IS GREATER THAN +8
015100         PERFORM 8600-SET-USER-AMT-ATTRIBUTES
015200                                 THRU 8699-SUAA-EXIT
015300             VARYING X-MO11-USER-AMT FROM +1 BY +1
015400             UNTIL   X-MO11-USER-AMT IS GREATER THAN +8.
015500*
015600****************************************************************
015700*    SEND THE MAP                                              *
015800****************************************************************
015900*
016000     MOVE 'BM01'                 TO MBCA-PROGRAM-LOCATION.
016100     PERFORM MB60PD-SEND-MAP-WITH-ERASE
016200                                 THRU MB60PD-SMWE-EXIT.
016300*
016400****************************************************************
016500*    RETURN TO CICS                                            *
016600****************************************************************
016700*
016800     MOVE 'PC02'                 TO MBCA-PROGRAM-LOCATION.
016900     PERFORM MB70PD-RETURN-TRANS-ID
017000                                 THRU MB70PD-RTI-EXIT.
017100/
017200 2000-RECEIVE-SCREEN SECTION.
017300*
017400****************************************************************
017500*    THIS SECTION RECEIVES THE 11 SCREEN                       *
017600****************************************************************
017700*
017800     MOVE 'BM02'                 TO MBCA-PROGRAM-LOCATION.
017900     PERFORM MB60PD-RECEIVE-MAP  THRU MB60PD-RM-EXIT.
018000*
018100****************************************************************
018200*    CHECK FOR ANOTHER TRANSACTION ID ENTERED BY THE USER      *
018300****************************************************************
018400*
018500     MOVE 'PC03'                 TO MBCA-PROGRAM-LOCATION.
018600     PERFORM MB60PD-NEW-TRANS-ROUTINE
018700                                 THRU MB60PD-NTR-EXIT.
018800*
018900****************************************************************
019000*    BYPASS EDITS ON INQUIRY                                   *
019100****************************************************************
019200*
019300     IF  MBCA-PTI-FUNCTION-IS-INQUIRY
019400         GO TO 2600-SETUP-COMMAREA.
019500*
019600****************************************************************
019700*    READ THE ORGANIZATION FILE RECORD                         *
019800****************************************************************
019900*
020000     MOVE 'FC02'                 TO MBCA-PROGRAM-LOCATION.
020100     MOVE MBCA-MERCHANT-ORG      TO MBIOWS-MMOC-ORG.
020200     SET MBIORO-READ-RANDOM      TO TRUE.
020300     PERFORM MMOCAO-ACCESS       THRU MMOCAO-ACCESS-EXIT.
020400*
020500     PERFORM 8700-EDIT-USER-DATA THRU 8799-EUD-EXIT
020600         VARYING X-MO11-USER-DATA FROM +1 BY +1
020700         UNTIL   X-MO11-USER-DATA IS GREATER THAN +8.
020800*
020900     PERFORM 8800-EDIT-USER-DATE THRU 8899-EUD-EXIT
021000         VARYING X-MO11-USER-DATE FROM +1 BY +1
021100         UNTIL   X-MO11-USER-DATE IS GREATER THAN +8.
021200*
021300     PERFORM 8900-EDIT-USER-AMT THRU 8999-EUA-EXIT
021400         VARYING X-MO11-USER-AMT FROM +1 BY +1
021500         UNTIL   X-MO11-USER-AMT IS GREATER THAN +8.
021600*
021700     IF  SS08WS-ERROR-SW-NO
021800         GO TO 2400-UPDATE-FILE.
021900*
022000****************************************************************
022100*    SEND THE MAP                                              *
022200****************************************************************
022300*
022400     PERFORM MB60PD-INIT-STD-MAP-LINES
022500                                 THRU MB60PD-ISML-EXIT.
022600*
022700     MOVE 'BM03'                 TO MBCA-PROGRAM-LOCATION.
022800     PERFORM MB60PD-SEND-MAP-DATA-ONLY
022900                                 THRU MB60PD-SMDO-EXIT.
023000*
023100****************************************************************
023200*    RETURN TO CICS                                            *
023300****************************************************************
023400*
023500     MOVE 'PC04'                 TO MBCA-PROGRAM-LOCATION.
023600     PERFORM MB70PD-RETURN-TRANS-ID
023700                                 THRU MB70PD-RTI-EXIT.
023800/
023900 2400-UPDATE-FILE.
024000*
024100     IF  WS-UPDATE-SW-NO
024200         IF  MBCA-PTI-FUNCTION-IS-ADD
024300             MOVE 'FC03'         TO MBCA-PROGRAM-LOCATION
024400             MOVE MBCA-MERCHANT-ORG
024500                                 TO MBIOWS-MMOC-ORG
024600             SET MBIORO-READ-RANDOM-UPDATE
024700                                 TO TRUE
024800             PERFORM MMOCAO-ACCESS
024900                                 THRU MMOCAO-ACCESS-EXIT
025000             MOVE MBCA-SCREEN-NBR
025100                                 TO MMOC-ONLINE-STATUS
025200             MOVE 'FC04'         TO MBCA-PROGRAM-LOCATION
025300             SET MBIORO-REWRITE  TO TRUE
025400             PERFORM MMOCAO-ACCESS
025500                                 THRU MMOCAO-ACCESS-EXIT
025600             GO TO 2600-SETUP-COMMAREA
025700         ELSE
025800             GO TO 2600-SETUP-COMMAREA.
025900*
026000****************************************************************
026100*    GETMAIN FOR LOG/JOURNAL RECORD                            *
026200****************************************************************
026300*
026400     MOVE 'SC02'                 TO MBCA-PROGRAM-LOCATION.
026500     SET MBIORO-GETMAIN          TO TRUE.
026600     PERFORM MML1AO-ACCESS       THRU MML1AO-ACCESS-EXIT.
026700*
026800****************************************************************
026900*    READ THE ORGANIZATION FILE RECORD FOR UPDATE              *
027000****************************************************************
027100*
027200     MOVE 'FC05'                 TO MBCA-PROGRAM-LOCATION.
027300     MOVE MBCA-MERCHANT-ORG      TO MBIOWS-MMOC-ORG.
027400     SET MBIORO-READ-RANDOM-UPDATE
027500                                 TO TRUE.
027600     PERFORM MMOCAO-ACCESS       THRU MMOCAO-ACCESS-EXIT.
027700*
027800     PERFORM 9000-BUILD-DATA-LOG-RECORDS
027900                                 THRU 9099-BDLR-EXIT
028000         VARYING X-MO11-USER-DATA FROM +1 BY +1
028100         UNTIL   X-MO11-USER-DATA IS GREATER THAN +8.
028200*
028300     PERFORM 9100-BUILD-DATE-LOG-RECORDS
028400                                 THRU 9199-BDLR-EXIT
028500         VARYING X-MO11-USER-DATE FROM +1 BY +1
028600         UNTIL   X-MO11-USER-DATE IS GREATER THAN +8.
028700*
028800     PERFORM 9200-BUILD-AMT-LOG-RECORDS
028900                                 THRU 9299-BALR-EXIT
029000         VARYING X-MO11-USER-AMT FROM +1 BY +1
029100         UNTIL   X-MO11-USER-AMT IS GREATER THAN +8.
029200*
029300     IF  MBCA-PTI-FUNCTION-IS-ADD
029400         MOVE 11                 TO MMOC-ONLINE-STATUS.
029500*
029600*            ***** LAST MAINT DATE AND OPERATOR ID *****       *
029700*
029800     MOVE ZEROES                 TO MML1-FIELD-OCCURRENCE.
029900     MOVE 0199                   TO MML1-FIELD-CODE.
030000     MOVE MML1WS-VL-07           TO MML1-VARIABLE-LENGTH.
030100     MOVE MMOC-LAST-MAINT-DATE
030200                                 TO MML1-VL07-B-DATA-9.
030300     MOVE MBCA-START-DATE        TO MMOC-LAST-MAINT-DATE.
030400     MOVE MMOC-LAST-MAINT-DATE
030500                                 TO MML1-VL07-A-DATA-9.
030600     PERFORM 8050-CREATE-MAINT-RECORD
030700                                 THRU 8099-CMR-EXIT.
030800     MOVE 0198                   TO MML1-FIELD-CODE.
030900     MOVE MML1WS-VL-03           TO MML1-VARIABLE-LENGTH.
031000     MOVE MMOC-LAST-MAINT-OPER
031100                                 TO MML1-VL03-B-DATA-X.
031200     MOVE MBCA-OPERATOR-ID       TO MMOC-LAST-MAINT-OPER.
031300     MOVE MMOC-LAST-MAINT-OPER
031400                                 TO MML1-VL03-A-DATA-X.
031500     PERFORM 8050-CREATE-MAINT-RECORD
031600                                 THRU 8099-CMR-EXIT.
031700*
031800****************************************************************
031900*    UPDATE THE ORGANIZATION FILE RECORD                       *
032000****************************************************************
032100*
032200     MOVE 'FC06'                 TO MBCA-PROGRAM-LOCATION.
032300     SET MBIORO-REWRITE          TO TRUE.
032400     PERFORM MMOCAO-ACCESS       THRU MMOCAO-ACCESS-EXIT.
032500*
032600 2600-SETUP-COMMAREA.
032700*
032800****************************************************************
032900*    SET UP COMMAREA FIELDS AND TRANSFER TO THE NEXT PROGRAM   *
033000****************************************************************
033100*
033200     MOVE MBCA-EIBAID            TO SS08WS-EIBAID.
033300*
033400     PERFORM MB60PD-EDIT-PAGE-NBR
033500                                 THRU MB60PD-EPN-EXIT.
033600*
033700     IF  SS08WS-VALID-PF-KEY
033800     OR  SS08WS-EIBAID-VALID-PF-KEY
033900         SET MBCA-INITIAL-SCREEN-NBR
034000                                 TO TRUE.
034100*
034200     MOVE 'PC05'                 TO MBCA-PROGRAM-LOCATION.
034300     PERFORM MB70PD-XCTL-TO-MBOXCTL
034400                                 THRU MB70PD-XTM-EXIT.
034500/
034600 8000-PERFORMED-ROUTINES-SECT SECTION.
034700*
034800 8050-CREATE-MAINT-RECORD.
034900*
035000*****************************************************************
035100*    THIS ROUTINE WILL CREATE THE COMMON DATA FOR ALL OF THE    *
035200*    LOG/JOURNAL TRANSACTIONS                                   *
035300*****************************************************************
035400*
035500     IF  MBCA-PTI-FUNCTION-IS-ADD
035600         GO TO 8099-CMR-EXIT.
035700*
035800     MOVE 'OC'                   TO MML1-FILE-CODE.
035900     MOVE MBCA-MERCHANT-ORG      TO MML1-MMOC-ORG.
036000     MOVE MBCA-SIGNON-NAME       TO MML1-SIGNON-NAME.
036100     MOVE MBCA-TERMINAL-ID       TO MML1-TERMINAL-ID.
036200     MOVE ZEROES                 TO MML1-SOURCE-CODE
036300                                    MML1-FIELD-OCCURRENCE-2.
036400*
036500*****************************************************************
036600*    WRITE THE LOG/JOURNAL FILE RECORD                          *
036700*****************************************************************
036800*
036900     MOVE 'FC07'                 TO MBCA-PROGRAM-LOCATION.
037000     SET MBIORO-WRITE            TO TRUE.
037100     PERFORM MML1AO-ACCESS       THRU MML1AO-ACCESS-EXIT.
037200     MOVE SPACES                 TO MML1-VARIABLE-AREA.
037300*
037400 8099-CMR-EXIT.
037500     EXIT.
037600*
037700 8100-BUILD-USER-DATA.
037800*
037900     SET X-MMOC-MUC              TO X-MO11-USER-DATA.
038000*
038100     MOVE MMOC-MERCH-USER-CODE-DESC  (X-MMOC-MUC)
038200                                 TO MO11-USER-DATA-DESC
038300                                    (X-MO11-USER-DATA).
038400 8199-BUD-EXIT.
038500     EXIT.
038600*
038700 8200-BUILD-USER-DATE.
038800*
038900     SET X-MMOC-MUD              TO X-MO11-USER-DATE.
039000*
039100     MOVE MMOC-MERCH-USER-DATE-DESC  (X-MMOC-MUD)
039200                                 TO MO11-USER-DATE-DESC
039300                                    (X-MO11-USER-DATE).
039400 8299-BUD-EXIT.
039500     EXIT.
039600*
039700 8300-BUILD-USER-AMOUNT.
039800*
039900     SET X-MMOC-MUA              TO X-MO11-USER-AMT.
040000*
040100     MOVE MMOC-MERCH-USER-AMOUNT-DESC  (X-MMOC-MUA)
040200                                 TO MO11-USER-AMOUNT-DESC
040300                                    (X-MO11-USER-AMT).
040400 8399-BUA-EXIT.
040500     EXIT.
040600*
040700 8400-SET-USER-DATA-ATTRIBUTES.
040800*
040900     MOVE DFHBMASB               TO MO11-USER-DATA-DESC-A
041000                                    (X-MO11-USER-DATA).
041100     MOVE DFHBMDAS               TO MO11-USER-DATA-DESC-LP-A
041200                                    (X-MO11-USER-DATA)
041300                                    MO11-USER-DATA-DESC-RP-A
041400                                    (X-MO11-USER-DATA).
041500*
041600 8499-SUDA-EXIT.
041700     EXIT.
041800*
041900 8500-SET-USER-DATE-ATTRIBUTES.
042000*
042100     MOVE DFHBMASB               TO MO11-USER-DATE-DESC-A
042200                                    (X-MO11-USER-DATE).
042300     MOVE DFHBMDAS               TO MO11-USER-DATE-DESC-LP-A
042400                                    (X-MO11-USER-DATE)
042500                                    MO11-USER-DATE-DESC-RP-A
042600                                    (X-MO11-USER-DATE).
042700*
042800 8599-SUDA-EXIT.
042900     EXIT.
043000*
043100 8600-SET-USER-AMT-ATTRIBUTES.
043200*
043300     MOVE DFHBMASB               TO MO11-USER-AMOUNT-DESC-A
043400                                    (X-MO11-USER-AMT).
043500     MOVE DFHBMDAS               TO MO11-USER-AMOUNT-DESC-LP-A
043600                                    (X-MO11-USER-AMT)
043700                                    MO11-USER-AMOUNT-DESC-RP-A
043800                                    (X-MO11-USER-AMT).
043900*
044000 8699-SUAA-EXIT.
044100     EXIT.
044200*
044300 8700-EDIT-USER-DATA.
044400*
044500*            ***** USER DATA *****                             *
044600*
044700     SET X-MMOC-MUC              TO X-MO11-USER-DATA.
044800*
044900     IF  MO11-USER-DATA-DESC-L (X-MO11-USER-DATA) IS LESS THAN 1
045000         MOVE DFHBMASK           TO MO11-USER-DATA-DESC-A
045100                                    (X-MO11-USER-DATA)
045200         MOVE DFHBMDAS           TO MO11-USER-DATA-DESC-LP-A
045300                                    (X-MO11-USER-DATA)
045400                                    MO11-USER-DATA-DESC-RP-A
045500                                    (X-MO11-USER-DATA)
045600         MOVE MMOC-MERCH-USER-CODE-DESC  (X-MMOC-MUC)
045700                                 TO MO11-USER-DATA-DESC
045800                                    (X-MO11-USER-DATA)
045900     ELSE
046000         MOVE DFHBMASF           TO MO11-USER-DATA-DESC-A
046100                                    (X-MO11-USER-DATA)
046200         MOVE DFHBMDAS           TO MO11-USER-DATA-DESC-LP-A
046300                                    (X-MO11-USER-DATA)
046400                                    MO11-USER-DATA-DESC-RP-A
046500                                    (X-MO11-USER-DATA)
046600         SET WS-UPDATE-SW-YES    TO TRUE.
046700*
046800 8799-EUD-EXIT.
046900     EXIT.
047000*
047100 8800-EDIT-USER-DATE.
047200*
047300*            ***** USER DATE *****                             *
047400*
047500     SET X-MMOC-MUD              TO X-MO11-USER-DATE.
047600*
047700     IF  MO11-USER-DATE-DESC-L (X-MO11-USER-DATE) IS LESS THAN 1
047800         MOVE DFHBMASK           TO MO11-USER-DATE-DESC-A
047900                                    (X-MO11-USER-DATE)
048000         MOVE DFHBMDAS           TO MO11-USER-DATE-DESC-LP-A
048100                                    (X-MO11-USER-DATE)
048200                                    MO11-USER-DATE-DESC-RP-A
048300                                    (X-MO11-USER-DATE)
048400         MOVE MMOC-MERCH-USER-DATE-DESC  (X-MMOC-MUD)
048500                                 TO MO11-USER-DATE-DESC
048600                                    (X-MO11-USER-DATE)
048700     ELSE
048800         MOVE DFHBMASF           TO MO11-USER-DATE-DESC-A
048900                                    (X-MO11-USER-DATE)
049000         MOVE DFHBMDAS           TO MO11-USER-DATE-DESC-LP-A
049100                                    (X-MO11-USER-DATE)
049200                                    MO11-USER-DATE-DESC-RP-A
049300                                    (X-MO11-USER-DATE)
049400         SET WS-UPDATE-SW-YES    TO TRUE.
049500*
049600 8899-EUD-EXIT.
049700     EXIT.
049800*
049900 8900-EDIT-USER-AMT.
050000*
050100*            ***** USER AMOUNT *****                           *
050200*
050300     SET X-MMOC-MUA              TO X-MO11-USER-AMT.
050400*
050500     IF  MO11-USER-AMOUNT-DESC-L (X-MO11-USER-AMT) IS LESS THAN 1
050600         MOVE DFHBMASK           TO MO11-USER-AMOUNT-DESC-A
050700                                    (X-MO11-USER-AMT)
050800         MOVE DFHBMDAS           TO MO11-USER-AMOUNT-DESC-LP-A
050900                                    (X-MO11-USER-AMT)
051000                                    MO11-USER-AMOUNT-DESC-RP-A
051100                                    (X-MO11-USER-AMT)
051200         MOVE MMOC-MERCH-USER-AMOUNT-DESC  (X-MMOC-MUA)
051300                                 TO MO11-USER-AMOUNT-DESC
051400                                    (X-MO11-USER-AMT)
051500     ELSE
051600         MOVE DFHBMASF           TO MO11-USER-AMOUNT-DESC-A
051700                                    (X-MO11-USER-AMT)
051800         MOVE DFHBMDAS           TO MO11-USER-AMOUNT-DESC-LP-A
051900                                    (X-MO11-USER-AMT)
052000                                    MO11-USER-AMOUNT-DESC-RP-A
052100                                    (X-MO11-USER-AMT)
052200         SET WS-UPDATE-SW-YES    TO TRUE.
052300*
052400 8999-EUA-EXIT.
052500     EXIT.
052600*
052700 9000-BUILD-DATA-LOG-RECORDS.
052800*
052900     SET X-MMOC-MUC              TO X-MO11-USER-DATA.
053000     SET WS-INDEX                TO X-MO11-USER-DATA.
053100*
053200*            ***** USER DATA *****                             *
053300*
053400     IF  MO11-USER-DATA-DESC-L (X-MO11-USER-DATA)
053500                                 IS GREATER THAN ZERO
053600         MOVE WS-INDEX           TO MML1-FIELD-OCCURRENCE
053700         MOVE 1101               TO MML1-FIELD-CODE
053800         MOVE MML1WS-VL-20       TO MML1-VARIABLE-LENGTH
053900         MOVE MMOC-MERCH-USER-CODE-DESC  (X-MMOC-MUC)
054000                                 TO MML1-VL20-B-DATA-X
054100         MOVE MO11-USER-DATA-DESC (X-MO11-USER-DATA)
054200                                 TO MMOC-MERCH-USER-CODE-DESC
054300                                    (X-MMOC-MUC)
054400         MOVE MMOC-MERCH-USER-CODE-DESC  (X-MMOC-MUC)
054500                                 TO MML1-VL20-A-DATA-X
054600         PERFORM 8050-CREATE-MAINT-RECORD
054700                                 THRU 8099-CMR-EXIT.
054800*
054900 9099-BDLR-EXIT.
055000     EXIT.
055100*
055200 9100-BUILD-DATE-LOG-RECORDS.
055300*
055400     SET X-MMOC-MUD              TO X-MO11-USER-DATE.
055500     SET WS-INDEX                TO X-MO11-USER-DATE.
055600*
055700*            ***** USER DATE *****                             *
055800*
055900     IF  MO11-USER-DATE-DESC-L (X-MO11-USER-DATE)
056000                                 IS GREATER THAN ZERO
056100         MOVE WS-INDEX           TO MML1-FIELD-OCCURRENCE
056200         MOVE 1102               TO MML1-FIELD-CODE
056300         MOVE MML1WS-VL-20       TO MML1-VARIABLE-LENGTH
056400         MOVE MMOC-MERCH-USER-DATE-DESC  (X-MMOC-MUD)
056500                                 TO MML1-VL20-B-DATA-X
056600         MOVE MO11-USER-DATE-DESC (X-MO11-USER-DATE)
056700                                 TO MMOC-MERCH-USER-DATE-DESC
056800                                    (X-MMOC-MUD)
056900         MOVE MMOC-MERCH-USER-DATE-DESC  (X-MMOC-MUD)
057000                                 TO MML1-VL20-A-DATA-X
057100         PERFORM 8050-CREATE-MAINT-RECORD
057200                                 THRU 8099-CMR-EXIT.
057300*
057400 9199-BDLR-EXIT.
057500     EXIT.
057600*
057700 9200-BUILD-AMT-LOG-RECORDS.
057800*
057900     SET X-MMOC-MUA              TO X-MO11-USER-AMT.
058000     SET WS-INDEX                TO X-MO11-USER-AMT.
058100*
058200*            ***** USER AMOUNT *****                           *
058300*
058400     IF  MO11-USER-AMOUNT-DESC-L (X-MO11-USER-AMT)
058500                                 IS GREATER THAN ZERO
058600         MOVE WS-INDEX           TO MML1-FIELD-OCCURRENCE
058700         MOVE 1103               TO MML1-FIELD-CODE
058800         MOVE MML1WS-VL-20       TO MML1-VARIABLE-LENGTH
058900         MOVE MMOC-MERCH-USER-AMOUNT-DESC  (X-MMOC-MUA)
059000                                 TO MML1-VL20-B-DATA-X
059100         MOVE MO11-USER-AMOUNT-DESC (X-MO11-USER-AMT)
059200                                 TO MMOC-MERCH-USER-AMOUNT-DESC
059300                                    (X-MMOC-MUA)
059400         MOVE MMOC-MERCH-USER-AMOUNT-DESC  (X-MMOC-MUA)
059500                                 TO MML1-VL20-A-DATA-X
059600         PERFORM 8050-CREATE-MAINT-RECORD
059700                                 THRU 8099-CMR-EXIT.
059800*
059900 9299-BALR-EXIT.
060000     EXIT.
060100/         NEW ROUTINE FOR JULIAN TO GREGORIAN DATE CONVERSION
060200     COPY SS26PD.
060300/         ROUTINE TO NUMERICALLY EDIT TIME
060400     COPY SS27PD.
060500/         JULIAN TO GREGORIAN DATE ROUTINE.
060600     COPY SS08PD.
060700/         LINE 24 PF KEYS ROUTINE
060800     COPY SS15PD.
060900/         ORGANIZATION RECORD ACCESS ROUTINES
061000     COPY MMOCAO.
061100/         LOG/JOURNAL ACCESS ROUTINES
061200     COPY MML1AO.
061300/         ON-LINE MAP ROUTINES
061400     COPY MB60PD REPLACING 'MBMAPXX' BY 'MBMO11 '
061500                           MBMAPXXI BY MBMO11I
061600                           MBMAPXXO BY MBMO11O.
061700/         ON-LINE PROCEDURES
061800     COPY MB70PD.
061900/
062000     COPY SMFTPXO.
