000100 IDENTIFICATION DIVISION.
000200 PROGRAM-ID. MBOMO32.
000201*       RELEASE DATE=08/24/01.        REVISION LEVEL=08.06      *
000202*****************************************************************
000203*WARNING.  THIS COMPUTER PROGRAM IS PROTECTED BY COPYRIGHT LAW  *
000204*AND INTERNATIONAL TREATIES.  UNAUTHORIZED REPRODUCTION OR      *
000205*DISTRIBUTION OF THIS PROGRAM, OR ANY PORTION OF IT, MAY RESULT *
000206*IN SEVERE CIVIL AND CRIMINAL PENATLIES, AND WILL BE PROSECUTED *
000207*TO THE MAXIMUM EXTENT POSSIBLE UNDER THE LAW.                  *
000208*COPYRIGHT 1999 PAYSYS INTERNATIONAL, INC.  ALL RIGHTS RESERVED.*
000209*****************************************************************
000300*****************************************************************
000400*                                                               *
000500*   V - PLUS  M E R C H A N T   B A N K C A R D   S Y S T E M   *
000600*                                                               *
000700*      MBOMO32 - ON-LINE ORG RECORD ADD/MAINTENANCE/INQUIRY     *
000800*                SCREENS 32 AND 33                              *
000900*                                                               *
001000*              1. TRANSIDS                                      *
001100*                 A. MBAO                                       *
001200*                 B. MBMO                                       *
001300*                 C. MBQO                                       *
001400*              2. MAPS USED -                                   *
001500*                 A. MBMO32 (ORGANIZATION MAP 32 AND 33)        *
001600*              3. FILES USED -                                  *
001700*                 A. MMOC   (SYSTEM/ORG CONTROL FILE)           *
001800*                 B. MML1   (LOG/JOURNAL FILE)                  *
001900*                                                               *
002000*****************************************************************
002100*
002200 ENVIRONMENT DIVISION.
002300 DATA DIVISION.
002400 WORKING-STORAGE SECTION.
002500 01  FILLER                  PIC  X(12)      VALUE '** WS-BEG **'.
002600*         I/O REQUEST BLOCK WORK AREAS
002700     COPY MBIOWS.
002800/         I/O REQUEST BLOCK
002900     COPY MBIORO.
003000/         LOG/JOURNAL WORK AREAS
003100     COPY MML1WS REPLACING ==:MML1:== BY ==MML1==.
003200/         DATE WORK AREAS
003300     COPY SS01WS.
003400/         ONLINE WORK AREAS
003500     COPY SS08WS.
003600/
003700     COPY SS00WS.
003800/
003900     COPY SMFTWS.
004000/
004100     COPY SMPTRL REPLACING ==:SMPT:== BY ==SMPT==.
004200/
004300     COPY MB61LK.
004400/
004500 01  WS-WORK-AREAS.
004600     03  WS-UPDATE-SW        PIC  X(01)      VALUE 'N'.
004700         88  WS-UPDATE-SW-NO                 VALUE 'N'.
004800         88  WS-UPDATE-SW-YES                VALUE 'Y'.
004900     03  WS-INDEX            PIC S9(04)      BINARY.
005000     03  WS-NBR-INDEX        PIC S9(04)      BINARY.
005100 01  FILLER                  PIC  X(12)      VALUE '** WS-END **'.
005200/
005300 LINKAGE SECTION.
005400 01  DFHCOMMAREA.
005500     COPY MB60WS.
005600/         ORG SCREEN 32 AND 33 MAP DSECT
005700     COPY MBMO32.
005800/         ORG SCREEN 32 AND 33 MAP REDEFINITION
005900     COPY MBMO32R.
006000/         SYSTEM/ORG CONTROL FILE RECORD LAYOUT
006100     COPY MMOCRL.
006200/         LOG/JOURNAL FILE RECORD LAYOUT
006300     COPY MML1RL REPLACING ==:MML1:== BY ==MML1==.
006400/
006500 PROCEDURE DIVISION.
006600 0000-HOUSEKEEPING SECTION.
006700 0100-INIT.
006800*
006900     MOVE 'PC01'                 TO MBCA-PROGRAM-LOCATION.
007000     PERFORM MB70PD-ON-LINE-HOUSEKEEPING
007100                                 THRU MB70PD-OLH-EXIT.
007200*
007300     IF  MBCA-RECEIVE-SCREEN
007400         GO TO 2000-RECEIVE-SCREEN.
007500/
007600 1000-SEND-SCREEN SECTION.
007700*
007800****************************************************************
007900*    THIS SECTION BUILDS AND SENDS THE 32 AND 33 SCREENS       *
008000****************************************************************
008100*
008200****************************************************************
008300*    GET CICS STORAGE NEEDED FOR THE MAP                       *
008400****************************************************************
008500*
008600     MOVE 'SC01'                 TO MBCA-PROGRAM-LOCATION.
008700     PERFORM MB60PD-GETMAIN-FOR-MAP
008800                                 THRU MB60PD-GFM-EXIT.
008900*
009000     MOVE MBCA-MERCHANT-ORG      TO MO32-ORG.
009100     MOVE MBCA-MBMO-ORG-NAME     TO MO32-ORG-NAME.
009200*
009300     IF  MBCA-SCREEN-NBR IS EQUAL TO 82
009400         MOVE 32                 TO MBCA-SCREEN-NBR
009500     ELSE
009600         MOVE 33                 TO MBCA-SCREEN-NBR.
009700*
009800****************************************************************
009900*    INITIALIZE THE STANDARD MAP LINES                         *
010000****************************************************************
010100*
010200     PERFORM MB60PD-INIT-STD-MAP-LINES
010300                                 THRU MB60PD-ISML-EXIT.
010400*
010500****************************************************************
010600*    READ THE ORGANIZATION FILE RECORD                         *
010700****************************************************************
010800*
010900     MOVE 'FC01'                 TO MBCA-PROGRAM-LOCATION.
011000     MOVE MBCA-MERCHANT-ORG      TO MBIOWS-MMOC-ORG.
011100     SET MBIORO-READ-RANDOM      TO TRUE.
011200     PERFORM MMOCAO-ACCESS       THRU MMOCAO-ACCESS-EXIT.
011300/
011400 1100-BUILD-SCREEN.
011500*
011600****************************************************************
011700*    BUILD THE MAP FROM THE ORGANIZATION RECORD                *
011800****************************************************************
011900*
012000     MOVE MMOC-NA-LINE (1 1)     TO MO32-ORG-NAME.
012100*
012200     SET X-MMOC-UR               TO +1.
012300*
012400     IF  MBCA-SCREEN-NBR IS EQUAL TO 33
012500         SET X-MMOC-UR           TO +13.
012600*
012700     PERFORM VARYING X-MO32-RPT FROM +1 BY +1
012800             UNTIL   X-MO32-RPT IS GREATER THAN +12
012900         SET WS-NBR-INDEX        TO X-MMOC-UR
013000         MOVE WS-NBR-INDEX       TO MO32-REPORT-NUMBER
013100                                    (X-MO32-RPT)
013200         MOVE '.'                TO MO32-REPORT-PERIOD
013300                                    (X-MO32-RPT)
013400         MOVE MMOC-UR-REPORT-ID    (X-MMOC-UR)
013500                                 TO MO32-REPORT-ID
013600                                    (X-MO32-RPT)
013700         MOVE MMOC-UR-RPT-TITLE    (X-MMOC-UR)
013800                                 TO MO32-DESCRIPTION
013900                                    (X-MO32-RPT)
014000         SET X-MMOC-UR           UP BY 1
014100     END-PERFORM.
014200*
014300/
014400****************************************************************
014500*    IF INQUIRY, DARKEN PARENS AND ASKIP FIELDS                *
014600****************************************************************
014700*
014800     SET X-MO32-RPT              TO +1.
014900*
015000     MOVE SS08WS-CURSOR          TO MO32-REPORT-ID-L
015100                                    (X-MO32-RPT).
015200*
015300     IF  MBCA-PTI-FUNCTION-IS-INQUIRY
015400         MOVE SS08WS-CURSOR      TO MO32-ALT-TRANID-L
015500         PERFORM VARYING X-MO32-RPT FROM +1 BY +1
015600                 UNTIL   X-MO32-RPT IS GREATER THAN +12
015700             MOVE DFHBMASB       TO MO32-REPORT-ID-A
015800                                    (X-MO32-RPT)
015900                                    MO32-DESCRIPTION-A
016000                                    (X-MO32-RPT)
016100             MOVE DFHBMDAS       TO MO32-REPORT-ID-LP-A
016200                                    (X-MO32-RPT)
016300                                    MO32-REPORT-ID-RP-A
016400                                    (X-MO32-RPT)
016500                                    MO32-DESCRIPTION-LP-A
016600                                    (X-MO32-RPT)
016700                                    MO32-DESCRIPTION-RP-A
016800                                    (X-MO32-RPT)
016900         END-PERFORM.
017000*
017100****************************************************************
017200*    SEND THE MAP                                              *
017300****************************************************************
017400*
017500     MOVE 'BM01'                 TO MBCA-PROGRAM-LOCATION.
017600     PERFORM MB60PD-SEND-MAP-WITH-ERASE
017700                                 THRU MB60PD-SMWE-EXIT.
017800*
017900****************************************************************
018000*    RETURN TO CICS                                            *
018100****************************************************************
018200*
018300     MOVE 'PC02'                 TO MBCA-PROGRAM-LOCATION.
018400     PERFORM MB70PD-RETURN-TRANS-ID
018500                                 THRU MB70PD-RTI-EXIT.
018600/
018700 2000-RECEIVE-SCREEN SECTION.
018800*
018900****************************************************************
019000*    THIS SECTION RECEIVES THE 32 AND 33 SCREENS               *
019100****************************************************************
019200*
019300     MOVE 'BM02'                 TO MBCA-PROGRAM-LOCATION.
019400     PERFORM MB60PD-RECEIVE-MAP  THRU MB60PD-RM-EXIT.
019500*
019600****************************************************************
019700*    CHECK FOR ANOTHER TRANSACTION ID ENTERED BY THE USER      *
019800****************************************************************
019900*
020000     MOVE 'PC03'                 TO MBCA-PROGRAM-LOCATION.
020100     PERFORM MB60PD-NEW-TRANS-ROUTINE
020200                                 THRU MB60PD-NTR-EXIT.
020300*
020400****************************************************************
020500*    BYPASS EDITS ON INQUIRY                                   *
020600****************************************************************
020700*
020800     IF  MBCA-PTI-FUNCTION-IS-INQUIRY
020900         GO TO 2600-SETUP-COMMAREA.
021000*
021100****************************************************************
021200*    READ THE ORGANIZATION FILE RECORD                         *
021300****************************************************************
021400*
021500     MOVE 'FC02'                 TO MBCA-PROGRAM-LOCATION.
021600     MOVE MBCA-MERCHANT-ORG      TO MBIOWS-MMOC-ORG.
021700     SET MBIORO-READ-RANDOM      TO TRUE.
021800     PERFORM MMOCAO-ACCESS       THRU MMOCAO-ACCESS-EXIT.
021900*
022000     IF  MBCA-SCREEN-NBR IS EQUAL TO 32
022100         SET X-MMOC-UR           TO +1
022200     ELSE
022300         SET X-MMOC-UR           TO +13.
022400*
022500     PERFORM 9300-EDIT-USER-REPORTS
022600                                 THRU 9399-EUR-EXIT
022700         VARYING X-MO32-RPT FROM +1 BY +1
022800         UNTIL   X-MO32-RPT IS GREATER THAN +12.
022900*
023000     IF  SS08WS-ERROR-SW-NO
023100         GO TO 2400-UPDATE-FILE.
023200*
023300****************************************************************
023400*    SEND THE MAP                                              *
023500****************************************************************
023600*
023700     PERFORM MB60PD-INIT-STD-MAP-LINES
023800                                 THRU MB60PD-ISML-EXIT.
023900*
024000     MOVE 'BM03'                 TO MBCA-PROGRAM-LOCATION.
024100     PERFORM MB60PD-SEND-MAP-DATA-ONLY
024200                                 THRU MB60PD-SMDO-EXIT.
024300*
024400****************************************************************
024500*    RETURN TO CICS                                            *
024600****************************************************************
024700*
024800     MOVE 'PC04'                 TO MBCA-PROGRAM-LOCATION.
024900     PERFORM MB70PD-RETURN-TRANS-ID
025000                                 THRU MB70PD-RTI-EXIT.
025100/
025200 2400-UPDATE-FILE.
025300*
025400     IF  WS-UPDATE-SW-NO
025500         IF  MBCA-PTI-FUNCTION-IS-ADD
025600             MOVE 'FC03'         TO MBCA-PROGRAM-LOCATION
025700             SET MBIORO-GETMAIN  TO TRUE
025800             PERFORM MML1AO-ACCESS
025900                                 THRU MML1AO-ACCESS-EXIT
026000             MOVE 'FC04'         TO MBCA-PROGRAM-LOCATION
026100             MOVE MBCA-MERCHANT-ORG
026200                                 TO MBIOWS-MMOC-ORG
026300             SET MBIORO-READ-RANDOM-UPDATE
026400                                 TO TRUE
026500             PERFORM MMOCAO-ACCESS
026600                                 THRU MMOCAO-ACCESS-EXIT
026700             GO TO 2500-UPDATE-ORG-RECORD
026800         ELSE
026900             GO TO 2600-SETUP-COMMAREA.
027000*
027100****************************************************************
027200*    GETMAIN FOR LOG/JOURNAL RECORD                            *
027300****************************************************************
027400*
027500     MOVE 'SC02'                 TO MBCA-PROGRAM-LOCATION.
027600     SET MBIORO-GETMAIN          TO TRUE.
027700     PERFORM MML1AO-ACCESS       THRU MML1AO-ACCESS-EXIT.
027800*
027900****************************************************************
028000*    READ THE ORGANIZATION FILE RECORD FOR UPDATE              *
028100****************************************************************
028200*
028300     MOVE 'FC05'                 TO MBCA-PROGRAM-LOCATION.
028400     MOVE MBCA-MERCHANT-ORG      TO MBIOWS-MMOC-ORG.
028500     SET MBIORO-READ-RANDOM-UPDATE
028600                                 TO TRUE.
028700     PERFORM MMOCAO-ACCESS       THRU MMOCAO-ACCESS-EXIT.
028800*
028900     IF  MBCA-SCREEN-NBR IS EQUAL TO 32
029000         SET X-MMOC-UR               TO +1
029100     ELSE
029200         SET X-MMOC-UR               TO +13.
029300*
029400     PERFORM 9400-BUILD-RPT-LOG-RECORDS
029500                                 THRU 9499-BRLR-EXIT
029600         VARYING X-MO32-RPT FROM +1 BY +1
029700         UNTIL   X-MO32-RPT IS GREATER THAN +12.
029800*
029900 2500-UPDATE-ORG-RECORD.
030000*
030100****************************************************************
030200*    UPDATE THE ORGANIZATION FILE RECORD                       *
030300****************************************************************
030400*
030500     IF  MBCA-PTI-FUNCTION-IS-ADD
030600         MOVE MBCA-SCREEN-NBR    TO MMOC-ONLINE-STATUS
030700         IF  MMOC-ONLINE-STATUS    IS EQUAL TO MBCA-MAX-SCREEN-NBR
030800             SET MMOC-ADD-COMPLETED
030900                                 TO TRUE
031000             SET MMOC-REC-ACTIVE
031100                                 TO TRUE
031200             MOVE MBCA-START-DATE
031300                                 TO MMOC-LAST-MAINT-DATE
031400             MOVE MBCA-OPERATOR-ID
031500                                 TO MMOC-LAST-MAINT-OPER
031600             MOVE ZEROES         TO MML1-FIELD-CODE
031700                                    MML1-FIELD-OCCURRENCE
031800                                    MML1-FIELD-OCCURRENCE-2
031900             MOVE LENGTH OF MMOC-RECORD
032000                                 TO MML1-VARIABLE-LENGTH
032100             MOVE 'OC'           TO MML1-FILE-CODE
032200             MOVE MBCA-MERCHANT-ORG
032300                                 TO MML1-MMOC-ORG
032400             MOVE MBCA-SIGNON-NAME
032500                                 TO MML1-SIGNON-NAME
032600             MOVE MBCA-TERMINAL-ID
032700                                 TO MML1-TERMINAL-ID
032800             MOVE MMOC-RECORD    TO MML1-ADD-AREA
032900             MOVE 'FC06'         TO MBCA-PROGRAM-LOCATION
033000             SET MBIORO-WRITE    TO TRUE
033100             PERFORM MML1AO-ACCESS
033200                                 THRU MML1AO-ACCESS-EXIT.
033300*
033400*            ***** LAST MAINT DATE AND OPERATOR ID *****       *
033500*
033600     MOVE ZEROES                 TO MML1-FIELD-OCCURRENCE.
033700     MOVE 0199                   TO MML1-FIELD-CODE.
033800     MOVE MML1WS-VL-07           TO MML1-VARIABLE-LENGTH.
033900     MOVE MMOC-LAST-MAINT-DATE
034000                                 TO MML1-VL07-B-DATA-9.
034100     MOVE MBCA-START-DATE        TO MMOC-LAST-MAINT-DATE.
034200     MOVE MMOC-LAST-MAINT-DATE
034300                                 TO MML1-VL07-A-DATA-9.
034400     PERFORM 9050-CREATE-MAINT-RECORD
034500                                 THRU 9099-CMR-EXIT.
034600     MOVE 0198                   TO MML1-FIELD-CODE.
034700     MOVE MML1WS-VL-03           TO MML1-VARIABLE-LENGTH.
034800     MOVE MMOC-LAST-MAINT-OPER
034900                                 TO MML1-VL03-B-DATA-X.
035000     MOVE MBCA-OPERATOR-ID       TO MMOC-LAST-MAINT-OPER.
035100     MOVE MMOC-LAST-MAINT-OPER
035200                                 TO MML1-VL03-A-DATA-X.
035300     PERFORM 9050-CREATE-MAINT-RECORD
035400                                 THRU 9099-CMR-EXIT.
035500*
035600****************************************************************
035700*    UPDATE THE ORGANIZATION FILE RECORD                       *
035800****************************************************************
035900*
036000     MOVE 'FC07'                 TO MBCA-PROGRAM-LOCATION.
036100     SET MBIORO-REWRITE          TO TRUE.
036200     PERFORM MMOCAO-ACCESS       THRU MMOCAO-ACCESS-EXIT.
036300*
036400 2600-SETUP-COMMAREA.
036500*
036600****************************************************************
036700*    SET UP COMMAREA FIELDS AND TRANSFER TO THE NEXT PROGRAM   *
036800****************************************************************
036900*
037000     MOVE MBCA-EIBAID            TO SS08WS-EIBAID.
037100*
037200     PERFORM MB60PD-EDIT-PAGE-NBR
037300                                 THRU MB60PD-EPN-EXIT.
037400*
037500     IF  SS08WS-VALID-PF-KEY
037600     OR  SS08WS-EIBAID-VALID-PF-KEY
037700         SET MBCA-INITIAL-SCREEN-NBR
037800                                 TO TRUE.
037900*
038000     MOVE 'PC05'                 TO MBCA-PROGRAM-LOCATION.
038100     PERFORM MB70PD-XCTL-TO-MBOXCTL
038200                                 THRU MB70PD-XTM-EXIT.
038300/
038400 8000-PERFORMED-ROUTINES-SECT SECTION.
038500*
038600 9050-CREATE-MAINT-RECORD.
038700*
038800*****************************************************************
038900*    THIS ROUTINE WILL CREATE THE COMMON DATA FOR ALL OF THE    *
039000*    LOG/JOURNAL TRANSACTIONS                                   *
039100*****************************************************************
039200*
039300     IF  MBCA-PTI-FUNCTION-IS-ADD
039400         GO TO 9099-CMR-EXIT.
039500*
039600     MOVE 'OC'                   TO MML1-FILE-CODE.
039700     MOVE MBCA-MERCHANT-ORG      TO MML1-MMOC-ORG.
039800     MOVE MBCA-SIGNON-NAME       TO MML1-SIGNON-NAME.
039900     MOVE MBCA-TERMINAL-ID       TO MML1-TERMINAL-ID.
040000     MOVE ZEROES                 TO MML1-SOURCE-CODE
040100                                    MML1-FIELD-OCCURRENCE-2.
040200*
040300*****************************************************************
040400*    WRITE THE LOG/JOURNAL FILE RECORD                          *
040500*****************************************************************
040600*
040700     MOVE 'FC08'                 TO MBCA-PROGRAM-LOCATION.
040800     SET MBIORO-WRITE            TO TRUE.
040900     PERFORM MML1AO-ACCESS       THRU MML1AO-ACCESS-EXIT.
041000     MOVE SPACES                 TO MML1-VARIABLE-AREA.
041100*
041200 9099-CMR-EXIT.
041300     EXIT.
041400*
041500 9300-EDIT-USER-REPORTS.
041600*
041700*            ***** REPORT ID *****                             *
041800*
041900     IF  MO32-REPORT-ID-L (X-MO32-RPT) IS LESS THAN 1
042000         MOVE DFHBMASK           TO MO32-REPORT-ID-A
042100                                    (X-MO32-RPT)
042200         MOVE DFHBMDAS           TO MO32-REPORT-ID-LP-A
042300                                    (X-MO32-RPT)
042400                                    MO32-REPORT-ID-RP-A
042500                                    (X-MO32-RPT)
042600         MOVE MMOC-UR-REPORT-ID    (X-MMOC-UR)
042700                                 TO MO32-REPORT-ID
042800                                    (X-MO32-RPT)
042900     ELSE
043000         MOVE DFHBMASF           TO MO32-REPORT-ID-A
043100                                    (X-MO32-RPT)
043200         MOVE DFHBMDAS           TO MO32-REPORT-ID-LP-A
043300                                    (X-MO32-RPT)
043400                                    MO32-REPORT-ID-RP-A
043500                                    (X-MO32-RPT)
043600         SET WS-UPDATE-SW-YES    TO TRUE.
043700*
043800*            ***** DESCRIPTION *****                           *
043900*
044000     IF  MO32-DESCRIPTION-L (X-MO32-RPT) IS LESS THAN 1
044100         MOVE DFHBMASK           TO MO32-DESCRIPTION-A
044200                                    (X-MO32-RPT)
044300         MOVE DFHBMDAS           TO MO32-DESCRIPTION-LP-A
044400                                    (X-MO32-RPT)
044500                                    MO32-DESCRIPTION-RP-A
044600                                    (X-MO32-RPT)
044700         MOVE MMOC-UR-RPT-TITLE    (X-MMOC-UR)
044800                                 TO MO32-DESCRIPTION
044900                                    (X-MO32-RPT)
045000     ELSE
045100         MOVE DFHBMASF           TO MO32-DESCRIPTION-A
045200                                    (X-MO32-RPT)
045300         MOVE DFHBMDAS           TO MO32-DESCRIPTION-LP-A
045400                                    (X-MO32-RPT)
045500                                    MO32-DESCRIPTION-RP-A
045600                                    (X-MO32-RPT)
045700         SET WS-UPDATE-SW-YES    TO TRUE.
045800*
045900     SET X-MMOC-UR               UP BY 1.
046000*
046100 9399-EUR-EXIT.
046200     EXIT.
046300*
046400 9400-BUILD-RPT-LOG-RECORDS.
046500*
046600     SET WS-INDEX                TO X-MMOC-UR.
046700*
046800*            ***** REPORT ID *****                             *
046900*
047000     IF  MO32-REPORT-ID-L (X-MO32-RPT) IS GREATER THAN ZERO
047100         MOVE WS-INDEX           TO MML1-FIELD-OCCURRENCE
047200         MOVE 3201               TO MML1-FIELD-CODE
047300         MOVE MML1WS-VL-10       TO MML1-VARIABLE-LENGTH
047400         MOVE MMOC-UR-REPORT-ID    (X-MMOC-UR)
047500                                 TO MML1-VL10-B-DATA-X
047600         MOVE MO32-REPORT-ID (X-MO32-RPT)
047700                                 TO MMOC-UR-REPORT-ID
047800                                    (X-MMOC-UR)
047900         MOVE MMOC-UR-REPORT-ID    (X-MMOC-UR)
048000                                 TO MML1-VL10-A-DATA-X
048100         PERFORM 9050-CREATE-MAINT-RECORD
048200                                 THRU 9099-CMR-EXIT.
048300*
048400*            ***** DESCRIPTION *****                           *
048500*
048600     IF  MO32-DESCRIPTION-L (X-MO32-RPT)
048700                                 IS GREATER THAN ZERO
048800         MOVE WS-INDEX           TO MML1-FIELD-OCCURRENCE
048900         MOVE 3202               TO MML1-FIELD-CODE
049000         MOVE MML1WS-VL-30       TO MML1-VARIABLE-LENGTH
049100         MOVE MMOC-UR-RPT-TITLE    (X-MMOC-UR)
049200                                 TO MML1-VL30-B-DATA-X
049300         MOVE MO32-DESCRIPTION (X-MO32-RPT)
049400                                 TO MMOC-UR-RPT-TITLE
049500                                    (X-MMOC-UR)
049600         MOVE MMOC-UR-RPT-TITLE    (X-MMOC-UR)
049700                                 TO MML1-VL30-A-DATA-X
049800         PERFORM 9050-CREATE-MAINT-RECORD
049900                                 THRU 9099-CMR-EXIT.
050000*
050100     SET X-MMOC-UR               UP BY 1.
050200*
050300 9499-BRLR-EXIT.
050400     EXIT.
050500/    NEW ROUTINE FOR JULIAN TO GREGORIAN CONVERSION
050600     COPY SS26PD.
050700/    ROUTINE TO NUMERICALLY EDIT TIME
050800     COPY SS27PD.
050900/         JULIAN TO GREGORIAN DATE ROUTINE.
051000     COPY SS08PD.
051100/         LINE 24 PF KEYS ROUTINE
051200     COPY SS15PD.
051300/         ORGANIZATION RECORD ACCESS ROUTINES
051400     COPY MMOCAO.
051500/         LOG/JOURNAL ACCESS ROUTINES
051600     COPY MML1AO.
051700/         ON-LINE MAP ROUTINES
051800     COPY MB60PD REPLACING 'MBMAPXX' BY 'MBMO32 '
051900                           MBMAPXXI BY MBMO32I
052000                           MBMAPXXO BY MBMO32O.
052100/         ON-LINE PROCEDURES
052200     COPY MB70PD.
052300/
052400     COPY SMFTPXO.
