000100 IDENTIFICATION DIVISION.
000200 PROGRAM-ID. MBOMP01.
000201*       RELEASE DATE=08/24/01.        REVISION LEVEL=08.06      *
000202*****************************************************************
000203*WARNING.  THIS COMPUTER PROGRAM IS PROTECTED BY COPYRIGHT LAW  *
000204*AND INTERNATIONAL TREATIES.  UNAUTHORIZED REPRODUCTION OR      *
000205*DISTRIBUTION OF THIS PROGRAM, OR ANY PORTION OF IT, MAY RESULT *
000206*IN SEVERE CIVIL AND CRIMINAL PENATLIES, AND WILL BE PROSECUTED *
000207*TO THE MAXIMUM EXTENT POSSIBLE UNDER THE LAW.                  *
000208*COPYRIGHT 1999 PAYSYS INTERNATIONAL, INC.  ALL RIGHTS RESERVED.*
000209*****************************************************************
000300*****************************************************************
000400*                                                               *
000500*   V - PLUS  M E R C H A N T   B A N K C A R D   S Y S T E M   *
000600*                                                               *
000700*      MBOMP01 - ON-LINE PRODUCT DEFINITION                     *
000800*                SCREEN 01                                      *
000900*                                                               *
001000*              1. TRANSIDS                                      *
001100*                 A. MBAP                                       *
001200*                 B. MBMP                                       *
001300*                 C. MBQP                                       *
001400*              2. MAPS USED -                                   *
001500*                 A. MBMP01 (SCREEN 01)                         *
001600*              3. FILES USED -                                  *
001700*                 A. MMSS   (SOURCE DEFINITION FILE)            *
001800*                 B. MML1   (LOG/JOURNAL FILE)                  *
001900*                                                               *
002000*****************************************************************
002100*
002200 ENVIRONMENT DIVISION.
002300 DATA DIVISION.
002400 WORKING-STORAGE SECTION.
002500 01  FILLER                  PIC  X(12)      VALUE '** WS-BEG **'.
002600*         I/O REQUEST BLOCK WORK AREAS
002700     COPY MBIOWS.
002800/         I/O REQUEST BLOCK
002900     COPY MBIORO.
003000/         LOG/JOURNAL WORK AREAS
003100     COPY MML1WS REPLACING ==:MML1:== BY ==MML1==.
003200/         PRODUCT DEFINITION INITIALIZER RECORD
003300     COPY MMSSIR.
003400/         DATE WORK AREAS
003500     COPY SS01WS.
003600/         ONLINE WORK AREAS
003700     COPY SS08WS.
003800/
003900     COPY SS00WS.
004000/
004100     COPY SMFTWS.
004200/
004300     COPY SMPTRL REPLACING ==:SMPT:== BY ==SMPT==.
004400/
004500     COPY MB61LK.
004600/
004700 01  WS-MISCELLANEOUS.
004800     03  WS-SAVE-EIBAID      PIC  X(01)      VALUE SPACES.
004900     03  WS-FWD-SEQ          PIC S9(04)      BINARY VALUE ZEROES.
005000     03  WS-HOLD-SEQUENCE    PIC S9(04)      BINARY VALUE ZEROES.
005100     03  WS-REFMOD-1         PIC  9(02)      VALUE ZERO.
005200     03  WS-REFMOD-2         PIC  9(02)      VALUE ZERO.
005300     03  WS-REFMOD-ERROR     PIC  X(01)      VALUE 'N'.
005400*
005500     03  WS-BYPASS-SW        PIC  X(01)      VALUE 'N'.
005600         88  WS-BYPASS-NO                    VALUE 'N'.
005700         88  WS-BYPASS-YES                   VALUE 'Y'.
005800*
005900     03  TS-QUEUE-NAME.
006000         05  TS-QN-TERMID    PIC  X(04)      VALUE SPACES.
006100         05  TS-QN-TRANID    PIC  X(04)      VALUE 'MBMP'.
006200*
006300     03  WS-HOLD-FROM.
006400         05  WS-HOLD-FROM-DIGIT
006500                             PIC  X(01)      OCCURS 11 TIMES
006600                                             INDEXED BY
006700                                             X-HOLD-FROM-INDEX.
006800     03  WS-HOLD-TO.
006900         05  WS-HOLD-TO-DIGIT
007000                             PIC  X(01)      OCCURS 11 TIMES
007100                                             INDEXED BY
007200                                             X-HOLD-TO-INDEX.
007300*
007400 01  FILLER                  PIC  X(12)      VALUE '** WS-END **'.
007500/
007600 LINKAGE SECTION.
007700 01  DFHCOMMAREA.
007800     COPY MB60WS.
007900/         PRODUCT DEFINITION SCREEN 01 MAP DSECT
008000     COPY MBMP01.
008100/         PRODUCT DEFINITION SCREEN 01 MAP REDEFINITION
008200     COPY MBMP01R.
008300/         PRODUCT DEFINITION RECORD LAYOUT
008400     COPY MMSSRL.
008500/         LOG/JOURNAL FILE RECORD LAYOUT
008600     COPY MML1RL REPLACING ==:MML1:== BY ==MML1==.
008700/         PRODUCT DEFINITION TEMPORARY STORAGE
008800     COPY MBMPTS.
008900/
009000 PROCEDURE DIVISION.
009100 0000-HOUSEKEEPING SECTION.
009200 0100-INIT.
009300*
009400     IF  MBCA-INITIAL-SCREEN-NBR
009500     AND MBCA-EIBAID-CLEAR
009600         MOVE 'PC01'             TO MBCA-PROGRAM-LOCATION
009700         PERFORM MB70PD-ON-LINE-HOUSEKEEPING
009800                                 THRU MB70PD-OLH-EXIT.
009900*
010000     MOVE MBCA-EIBAID            TO WS-SAVE-EIBAID.
010100     SET MBCA-EIBAID-ENTER       TO TRUE.
010200*
010300     MOVE 'PC02'                 TO MBCA-PROGRAM-LOCATION.
010400     PERFORM MB70PD-ON-LINE-HOUSEKEEPING
010500                                 THRU MB70PD-OLH-EXIT.
010600*
010700     MOVE WS-SAVE-EIBAID         TO MBCA-EIBAID.
010800     MOVE MBCA-TERMINAL-ID       TO TS-QN-TERMID.
010900*
011000     IF  MBCA-RECEIVE-SCREEN
011100         GO TO 2000-RECEIVE-SCREEN.
011200*
011300 1000-SEND-SCREEN SECTION.
011400*
011500****************************************************************
011600*    GET CICS STORAGE NEEDED FOR THE MAP                       *
011700****************************************************************
011800*
011900     MOVE 'SC01'                 TO MBCA-PROGRAM-LOCATION.
012000     PERFORM MB60PD-GETMAIN-FOR-MAP
012100                                 THRU MB60PD-GFM-EXIT.
012200*
012300     IF  MBCA-PTI-FUNCTION-IS-ADD
012400         MOVE 01                 TO MBCA-SCREEN-NBR
012500         PERFORM MB60PD-INIT-STD-MAP-LINES
012600                                 THRU MB60PD-ISML-EXIT
012700         GO TO 1090-CURSOR.
012800*
012900****************************************************************
013000*    ACQUIRE MAIN STORAGE FOR TEMP STORAGE RECORD              *
013100****************************************************************
013200*
013300     MOVE 'TS01'                 TO MBCA-PROGRAM-LOCATION.
013400     PERFORM 8100-TEMP-STORAGE-GETMAIN
013500                                 THRU 8199-TSG-EXIT.
013600*
013700****************************************************************
013800*    INITIALIZE THE STANDARD MAP LINES                         *
013900****************************************************************
014000*
014100     IF  MBCA-INITIAL-SCREEN-NBR
014200         PERFORM 8500-INIT-COMMAREA
014300                                 THRU 8599-IC-EXIT
014400         IF  SS08WS-ERROR-SW-YES
014500             MOVE 01             TO MBCA-SCREEN-NBR
014600             PERFORM MB60PD-INIT-STD-MAP-LINES
014700                                 THRU MB60PD-ISML-EXIT
014800             SET X-MP01-SD       TO +1
014900             GO TO 1070-FILL-TEMP-STORAGE
015000         ELSE
015100             MOVE 01             TO MBCA-SCREEN-NBR
015200             PERFORM MB60PD-INIT-STD-MAP-LINES
015300                                 THRU MB60PD-ISML-EXIT
015400             GO TO 1010-CHECK-RETURN-FLAG
015500     ELSE
015600         MOVE 01                 TO MBCA-SCREEN-NBR
015700         PERFORM MB60PD-INIT-STD-MAP-LINES
015800                                 THRU MB60PD-ISML-EXIT.
015900*
016000     EXEC CICS HANDLE CONDITION
016100               QIDERR (1010-CHECK-RETURN-FLAG)
016200          END-EXEC.
016300*
016400***********************************************
016500*    READ THE TEMP STORAGE RECORD             *
016600***********************************************
016700*
016800     MOVE 'TS02'                 TO MBCA-PROGRAM-LOCATION.
016900     PERFORM 8200-TEMP-STORAGE-READ
017000                                 THRU 8299-TSR-EXIT.
017100*
017200***********************************************
017300*    DELETE THE TEMP STORAGE RECORD           *
017400***********************************************
017500*
017600     MOVE 'TS03'                 TO MBCA-PROGRAM-LOCATION.
017700     PERFORM 8300-TEMP-STORAGE-DELETE
017800                                 THRU 8399-TSD-EXIT.
017900*
018000     PERFORM 8800-BUILD-SCREEN   THRU 8899-BS-EXIT.
018100*
018200     IF  SS08WS-ERROR-SW-YES
018300         SET X-MP01-SD           TO +1
018400         GO TO 1070-FILL-TEMP-STORAGE.
018500*
018600     GO TO 1080-CONTINUE.
018700*
018800 1010-CHECK-RETURN-FLAG.
018900*
019000     IF  MBCA-MBMP-RETURN-BOTTOM
019100         PERFORM 8900-LAST-SCREEN
019200                                 THRU 8999-LS-EXIT
019300         IF  WS-BYPASS-YES
019400             GO TO 1015-READ-PRODUCT
019500         ELSE
019600             GO TO 1080-CONTINUE
019700     ELSE
019800         IF  MBCA-MBMP-RETURN-BWD
019900             PERFORM 9000-BACK-SCREEN
020000                                 THRU 9099-BS-EXIT
020100             IF  WS-BYPASS-YES
020200                 GO TO 1015-READ-PRODUCT
020300             ELSE
020400                 GO TO 1080-CONTINUE.
020500*
020600 1015-READ-PRODUCT.
020700*
020800****************************************************************
020900*    START BROWSE THE PRODUCT FILE                             *
021000****************************************************************
021100*
021200     MOVE 'FC01'                 TO MBCA-PROGRAM-LOCATION.
021300     MOVE ZEROES                 TO MBIOWS-MMSS-ORG.
021400     MOVE MBCA-MBMP-FWD-SEQ      TO MBIOWS-MMSS-SEQ.
021500     SET MBIORO-STARTBR-GTE      TO TRUE.
021600     PERFORM MMSSAO-ACCESS       THRU MMSSAO-ACCESS-EXIT.
021700*
021800     SET X-MP01-SD               TO +1.
021900*
022000 1020-READ-LOOP.
022100*
022200****************************************************************
022300*    READNEXT THE PRODUCT FILE                                 *
022400****************************************************************
022500*
022600     MOVE 'FC02'                 TO MBCA-PROGRAM-LOCATION.
022700     SET MBIORO-READ-SEQ         TO TRUE.
022800     PERFORM MMSSAO-ACCESS       THRU MMSSAO-ACCESS-EXIT.
022900*
023000     IF  MMSS-SEQ IS EQUAL TO ZEROES
023100         GO TO 1020-READ-LOOP.
023200*
023300     IF  MMSS-TRAILER
023400         GO TO 1020-END-BROWSE.
023500*
023600     PERFORM 9300-BUILD-SCREEN-LINE
023700                                 THRU 9399-BSL-EXIT.
023800*
023900     IF  X-MP01-SD IS EQUAL TO +1
024000         MOVE MMSS-SEQ           TO MBCA-MBMP-BACK-SEQ.
024100*
024200     IF  X-MP01-SD IS LESS THAN +8
024300         SET X-MP01-SD           UP BY +1
024400         GO TO 1020-READ-LOOP
024500     ELSE
024600         MOVE MMSS-SEQ           TO MBCA-MBMP-FWD-SEQ
024700         PERFORM 9200-READ-AHEAD THRU 9299-RA-EXIT
024800         SET X-MP01-SD           UP BY +1.
024900*
025000 1020-END-BROWSE.
025100*
025200****************************************************************
025300*    END BROWSE THE PRODUCT FILE                               *
025400****************************************************************
025500*
025600     MOVE 'FC03'                 TO MBCA-PROGRAM-LOCATION.
025700     SET MBIORO-ENDBR            TO TRUE.
025800     PERFORM MMSSAO-ACCESS       THRU MMSSAO-ACCESS-EXIT.
025900*
026000 1060-SET-ATTRIBUTE.
026100*
026200     IF  X-MP01-SD IS EQUAL TO +1
026300         IF  MBCA-MBMP-RETURN-NORMAL
026400             SET MBCA-INITIAL-SCREEN-NBR
026500                                 TO TRUE
026600             MOVE '..NU'         TO SS08WS-WORK-TRANS-ID
026700             MOVE 'PC03'         TO MBCA-PROGRAM-LOCATION
026800             PERFORM MB70PD-XCTL-TO-MBOXCTL
026900                                 THRU MB70PD-XTM-EXIT
027000         ELSE
027100             MOVE MBCA-MBMP-BACK-SEQ
027200                                 TO MBCA-MBMP-FWD-SEQ
027300             GO TO 1015-READ-PRODUCT.
027400*
027500 1070-FILL-TEMP-STORAGE.
027600*
027700     IF  X-MP01-SD IS LESS THAN +9
027800         SET X-MBMPTS-INDEX      TO X-MP01-SD
027900         MOVE ZEROES             TO MBCA-MBMP-FWD-SEQ
028000                                    WS-FWD-SEQ
028100                                    MBMPTS-SEQUENCE
028200                                    (X-MBMPTS-INDEX)
028300                                    MBMPTS-SOURCE-PROD
028400                                    (X-MBMPTS-INDEX)
028500                                    MBMPTS-SOURCE-ORG
028600                                    (X-MBMPTS-INDEX)
028700                                    MBMPTS-SOURCE-LOGO
028800                                    (X-MBMPTS-INDEX)
028900         MOVE SPACES             TO MBMPTS-SOURCE-CODE
029000                                    (X-MBMPTS-INDEX)
029100                                    MBMPTS-FROM-RANGE
029200                                    (X-MBMPTS-INDEX)
029300                                    MBMPTS-INDICATOR
029400                                    (X-MBMPTS-INDEX)
029500                                    MBMPTS-TO-RANGE
029600                                    (X-MBMPTS-INDEX)
029700         MOVE DFHBMDAS           TO MP01-SOURCE-LP-A
029800                                    (X-MP01-SD)
029900                                    MP01-SOURCE-RP-A
030000                                    (X-MP01-SD)
030100                                    MP01-PRODUCT-LP-A
030200                                    (X-MP01-SD)
030300                                    MP01-PRODUCT-RP-A
030400                                    (X-MP01-SD)
030500                                    MP01-ORG-LP-A
030600                                    (X-MP01-SD)
030700                                    MP01-ORG-RP-A
030800                                    (X-MP01-SD)
030900                                    MP01-LOGO-LP-A
031000                                    (X-MP01-SD)
031100                                    MP01-LOGO-RP-A
031200                                    (X-MP01-SD)
031300                                    MP01-FROM-RANGE-LP-A
031400                                    (X-MP01-SD)
031500                                    MP01-FROM-RANGE-RP-A
031600                                    (X-MP01-SD)
031700                                    MP01-TO-RANGE-LP-A
031800                                    (X-MP01-SD)
031900                                    MP01-TO-RANGE-RP-A
032000                                    (X-MP01-SD)
032100                                    MP01-INDICATOR-LP-A
032200                                    (X-MP01-SD)
032300                                    MP01-INDICATOR-RP-A
032400                                    (X-MP01-SD)
032500                                    MP01-DESC-LP-A
032600                                    (X-MP01-SD)
032700                                    MP01-DESC-RP-A
032800                                    (X-MP01-SD)
032900                                    MP01-SOURCE-A
033000                                    (X-MP01-SD)
033100                                    MP01-PRODUCT-A
033200                                    (X-MP01-SD)
033300                                    MP01-ORG-A
033400                                    (X-MP01-SD)
033500                                    MP01-LOGO-A
033600                                    (X-MP01-SD)
033700                                    MP01-FROM-RANGE-A
033800                                    (X-MP01-SD)
033900                                    MP01-TO-RANGE-A
034000                                    (X-MP01-SD)
034100                                    MP01-INDICATOR-A
034200                                    (X-MP01-SD)
034300                                    MP01-DESC-A
034400                                    (X-MP01-SD)
034500                                    MP01-DESC-LIT-A
034600                                    (X-MP01-SD)
034700         SET X-MP01-SD           UP BY +1
034800         GO TO 1060-SET-ATTRIBUTE.
034900*
035000 1080-CONTINUE.
035100*
035200     IF  MBCA-MBMP-BACK-SEQ IS NOT EQUAL
035300                                 TO MBCA-MBMP-FIRST-SEQ
035400         MOVE DFHBMASB           TO MP01-FWD-BACK-IND-A (1).
035500*
035600     IF  WS-FWD-SEQ IS NOT EQUAL TO ZEROES
035700         MOVE DFHBMASB           TO MP01-FWD-BACK-IND-A (8).
035800*
035900****************************************************************
036000*    WRITE THE TEMP STORAGE RECORD                             *
036100****************************************************************
036200*
036300     MOVE 'TS04'                 TO MBCA-PROGRAM-LOCATION.
036400     PERFORM 8400-WRITE-QUEUE    THRU 8499-WQ-EXIT.
036500*
036600 1090-CURSOR.
036700*
036800     SET X-MP01-SD               TO +1.
036900*
037000     IF  MBCA-PTI-FUNCTION-IS-INQUIRY
037100         MOVE SS08WS-CURSOR      TO MP01-ALT-TRANID-L
037200         PERFORM 9100-SET-ATTRIBUTE
037300                                 THRU 9199-SA-EXIT
037400     ELSE
037500         IF  MP01-SOURCE-A (X-MP01-SD) IS EQUAL TO DFHBMDAS
037600             MOVE SS08WS-CURSOR  TO MP01-ALT-TRANID-L
037700         ELSE
037800             MOVE SS08WS-CURSOR  TO MP01-SOURCE-L (X-MP01-SD).
037900*
038000 1100-CONTINUE.
038100*
038200     IF  MBCA-PTI-FUNCTION-MAINT-OR-INQ
038300         MOVE '*TOP*'            TO SS08WS-LINE-24-PF-KEY-FUNC(3)
038400         MOVE '*BOT*'            TO SS08WS-LINE-24-PF-KEY-FUNC(4)
038500         MOVE '*FWD*'            TO SS08WS-LINE-24-PF-KEY-FUNC(5)
038600         MOVE '*BWD*'            TO SS08WS-LINE-24-PF-KEY-FUNC(6)
038700         MOVE SS08WS-LINE-24     TO MP01-PF-KEYS
038800         MOVE 'RESV'             TO MBCA-PGMX-PF-TRANS-ID (3)
038900         MOVE 'RESV'             TO MBCA-PGMX-PF-TRANS-ID (4)
039000         MOVE 'RESV'             TO MBCA-PGMX-PF-TRANS-ID (5)
039100         MOVE 'RESV'             TO MBCA-PGMX-PF-TRANS-ID (6).
039200*
039300     MOVE DFHBMASK               TO MP01-CURRENT-PAGE-A.
039400*
039500****************************************************************
039600*    SEND THE MAP                                              *
039700****************************************************************
039800*
039900     MOVE 'BM01'                 TO MBCA-PROGRAM-LOCATION.
040000     PERFORM MB60PD-SEND-MAP-WITH-ERASE
040100                                 THRU MB60PD-SMWE-EXIT.
040200*
040300****************************************************************
040400*    RETURN TO CICS                                            *
040500****************************************************************
040600*
040700     MOVE 'PC04'                 TO MBCA-PROGRAM-LOCATION.
040800     PERFORM MB70PD-RETURN-TRANS-ID
040900                                 THRU MB70PD-RTI-EXIT.
041000/
041100 2000-RECEIVE-SCREEN SECTION.
041200*
041300     IF  MBCA-EIBAID-CLEAR
041400         MOVE 'TS05'             TO MBCA-PROGRAM-LOCATION
041500         PERFORM 8300-TEMP-STORAGE-DELETE
041600                                 THRU 8399-TSD-EXIT
041700         MOVE 'PC05'             TO MBCA-PROGRAM-LOCATION
041800         MOVE 98                 TO MBCA-SCREEN-NBR
041900         PERFORM MB70PD-ON-LINE-HOUSEKEEPING
042000                                 THRU MB70PD-OLH-EXIT.
042100*
042200****************************************************************
042300*    THIS SECTION RECEIVES THE 01 SCREEN                       *
042400****************************************************************
042500*
042600     MOVE 'BM02'                 TO MBCA-PROGRAM-LOCATION.
042700     PERFORM MB60PD-RECEIVE-MAP  THRU MB60PD-RM-EXIT.
042800*
042900     IF  MBCA-PTI-FUNCTION-IS-ADD
043000         MOVE 'SC02'             TO MBCA-PROGRAM-LOCATION
043100         SET MBIORO-GETMAIN      TO TRUE
043200         PERFORM MMSSAO-ACCESS   THRU MMSSAO-ACCESS-EXIT
043300         MOVE MMSSIR-RECORD      TO MMSS-RECORD
043400         GO TO 2010-CHECK-TRANS.
043500*
043600*****************************************************
043700*    ACQUIRE MAIN STORAGE FOR TEMP STORAGE RECORD   *
043800*****************************************************
043900*
044000     MOVE 'TS06'                 TO MBCA-PROGRAM-LOCATION.
044100     PERFORM 8100-TEMP-STORAGE-GETMAIN
044200                                 THRU 8199-TSG-EXIT.
044300*
044400***********************************************
044500*    READ THE TEMP STORAGE RECORD             *
044600***********************************************
044700*
044800     MOVE 'TS07'                 TO MBCA-PROGRAM-LOCATION.
044900     PERFORM 8200-TEMP-STORAGE-READ
045000                                 THRU 8299-TSR-EXIT.
045100*
045200***********************************************
045300*    DELETE THE TEMP STORAGE RECORD           *
045400***********************************************
045500*
045600     MOVE 'TS08'                 TO MBCA-PROGRAM-LOCATION.
045700     PERFORM 8300-TEMP-STORAGE-DELETE
045800                                 THRU 8399-TSD-EXIT.
045900*
046000 2010-CHECK-TRANS.
046100*
046200****************************************************************
046300*    CHECK FOR ANOTHER TRANSACTION ID ENTERED BY THE USER      *
046400****************************************************************
046500*
046600     MOVE 'PC06'                 TO MBCA-PROGRAM-LOCATION.
046700     PERFORM MB60PD-NEW-TRANS-ROUTINE
046800                                 THRU MB60PD-NTR-EXIT.
046900*
047000     IF  MBCA-PTI-FUNCTION-IS-INQUIRY
047100         GO TO 2600-SETUP-COMMAREA.
047200*
047300 2020-EDIT-SCREEN.
047400*
047500     PERFORM
047600         VARYING X-MP01-SD FROM +1 BY +1
047700         UNTIL   X-MP01-SD IS GREATER THAN +8
047800             PERFORM 9800-READ-RECORD
047900                                 THRU 9899-RR-EXIT
048000             PERFORM 6100-EDIT-SOURCE-CODE
048100                                 THRU 6199-ESC-EXIT
048200             PERFORM 6200-EDIT-SOURCE-PROD
048300                                 THRU 6299-ESP-EXIT
048400             PERFORM 6300-EDIT-SOURCE-ORG
048500                                 THRU 6399-ESO-EXIT
048600             PERFORM 6400-EDIT-SOURCE-LOGO
048700                                 THRU 6499-ESL-EXIT
048800             PERFORM 6500-EDIT-SOURCE-DESC
048900                                 THRU 6599-ESD-EXIT
049000             PERFORM 6600-EDIT-SOURCE-FROM
049100                                 THRU 6699-ESF-EXIT
049200             PERFORM 6700-EDIT-SOURCE-IND
049300                                 THRU 6799-ESI-EXIT
049400             PERFORM 6800-EDIT-SOURCE-TO
049500                                 THRU 6899-EST-EXIT
049600             PERFORM 6900-CROSS-EDITS
049700                                 THRU 6999-CE-EXIT
049800     END-PERFORM.
049900*
050000 2090-CHECK-ERROR.
050100*
050200     IF  SS08WS-ERROR-SW-NO
050300         GO TO 2400-CHECK-UPDATE.
050400*
050500 2300-SEND-MAP.
050600*
050700***********************************************
050800*    WRITE THE TEMP STORAGE RECORD            *
050900***********************************************
051000*
051100     IF  MBCA-PTI-FUNCTION-MAINT-OR-INQ
051200         MOVE 'TS09'             TO MBCA-PROGRAM-LOCATION
051300         PERFORM 8400-WRITE-QUEUE
051400                                 THRU 8499-WQ-EXIT.
051500*
051600****************************************************************
051700*    SEND THE MAP                                              *
051800****************************************************************
051900*
052000     PERFORM MB60PD-INIT-STD-MAP-LINES
052100                                 THRU MB60PD-ISML-EXIT.
052200*
052300     IF  MBCA-PTI-FUNCTION-MAINT-OR-INQ
052400         MOVE '*TOP*'            TO SS08WS-LINE-24-PF-KEY-FUNC(3)
052500         MOVE '*BOT*'            TO SS08WS-LINE-24-PF-KEY-FUNC(4)
052600         MOVE '*FWD*'            TO SS08WS-LINE-24-PF-KEY-FUNC(5)
052700         MOVE '*BWD*'            TO SS08WS-LINE-24-PF-KEY-FUNC(6)
052800         MOVE SS08WS-LINE-24     TO MP01-PF-KEYS
052900         MOVE 'RESV'             TO MBCA-PGMX-PF-TRANS-ID (3)
053000         MOVE 'RESV'             TO MBCA-PGMX-PF-TRANS-ID (4)
053100         MOVE 'RESV'             TO MBCA-PGMX-PF-TRANS-ID (5)
053200         MOVE 'RESV'             TO MBCA-PGMX-PF-TRANS-ID (6).
053300*
053400     MOVE DFHBMASK               TO MP01-CURRENT-PAGE-A.
053500*
053600     MOVE 'BM03'                 TO MBCA-PROGRAM-LOCATION.
053700     PERFORM MB60PD-SEND-MAP-DATA-ONLY
053800                                 THRU MB60PD-SMDO-EXIT.
053900*
054000****************************************************************
054100*    RETURN TO CICS                                            *
054200****************************************************************
054300*
054400     MOVE 'PC07'                 TO MBCA-PROGRAM-LOCATION.
054500     PERFORM MB70PD-RETURN-TRANS-ID
054600                                 THRU MB70PD-RTI-EXIT.
054700/
054800 2400-CHECK-UPDATE.
054900*
055000****************************************************************
055100*    GETMAIN FOR LOG/JOURNAL RECORD                            *
055200****************************************************************
055300*
055400     MOVE 'SC03'                 TO MBCA-PROGRAM-LOCATION.
055500     SET MBIORO-GETMAIN          TO TRUE.
055600     PERFORM MML1AO-ACCESS       THRU MML1AO-ACCESS-EXIT.
055700*
055800     SET MML1-FILE-IS-MMSS       TO TRUE.
055900     MOVE ZEROES                 TO MML1-FIELD-CODE
056000                                    MML1-FIELD-OCCURRENCE
056100                                    MML1-FIELD-OCCURRENCE-2
056200                                    MML1-SOURCE-CODE.
056300     MOVE MBCA-SIGNON-NAME       TO MML1-SIGNON-NAME.
056400     MOVE MBCA-TERMINAL-ID       TO MML1-TERMINAL-ID.
056500*
056600     IF  MBCA-PTI-FUNCTION-IS-ADD
056700         PERFORM 9400-ADD-RECORD THRU 9499-AR-EXIT
056800     ELSE
056900         PERFORM 9500-UPDATE-RECORD
057000                                 THRU 9599-UR-EXIT.
057100*
057200 2600-SETUP-COMMAREA.
057300*
057400****************************************************************
057500*    SET UP COMMAREA FIELDS AND TRANSFER TO THE NEXT PROGRAM   *
057600****************************************************************
057700*
057800     MOVE MBCA-EIBAID            TO SS08WS-EIBAID.
057900     MOVE MBIOWS-MMSS-KEY-CODE   TO MBCA-KEY-CODE.
058000*
058100     PERFORM MB60PD-EDIT-PAGE-NBR
058200                                 THRU MB60PD-EPN-EXIT.
058300*
058400     IF  MBCA-PTI-FUNCTION-IS-ADD
058500         IF  SS08WS-VALID-PF-KEY
058600         OR  SS08WS-EIBAID-VALID-PF-KEY
058700         OR  MP01-PRODUCT-L (8) IS EQUAL TO ZERO
058800             MOVE 99             TO MBCA-SCREEN-NBR
058900             GO TO 2690-PF-KEY-BYPASS
059000         ELSE
059100             MOVE 51             TO MBCA-SCREEN-NBR
059200             GO TO 2690-PF-KEY-BYPASS.
059300*
059400     IF  SS08WS-VALID-PF3
059500     OR  SS08WS-EIBAID-VALID-PF3
059600         MOVE 51                 TO MBCA-SCREEN-NBR
059700         SET MBCA-MBMP-RETURN-NORMAL
059800                                 TO TRUE
059900         IF  MBCA-MBMP-FIRST-SEQ IS EQUAL TO ZEROES
060000             MOVE ZEROES         TO MBCA-MBMP-FWD-SEQ
060100             MOVE 'TS10'         TO MBCA-PROGRAM-LOCATION
060200             PERFORM 8400-WRITE-QUEUE
060300                                 THRU 8499-WQ-EXIT
060400             GO TO 2690-PF-KEY-BYPASS
060500         ELSE
060600             MOVE MBCA-MBMP-FIRST-SEQ
060700                                 TO MBCA-MBMP-FWD-SEQ
060800             GO TO 2690-PF-KEY-BYPASS.
060900*
061000     IF  SS08WS-VALID-PF4
061100     OR  SS08WS-EIBAID-VALID-PF4
061200         MOVE 51                 TO MBCA-SCREEN-NBR
061300         IF (MBMPTS-SEQUENCE (1) IS GREATER THAN ZEROES
061400         AND MBMPTS-SEQUENCE (8) IS EQUAL TO ZEROES)
061500         OR (MBCA-MBMP-FWD-SEQ IS EQUAL TO ZEROES)
061600             SET MBCA-MBMP-RETURN-NORMAL
061700                                 TO TRUE
061800             MOVE ZEROES         TO MBCA-MBMP-FWD-SEQ
061900             MOVE 'TS11'         TO MBCA-PROGRAM-LOCATION
062000             PERFORM 8400-WRITE-QUEUE
062100                                 THRU 8499-WQ-EXIT
062200             GO TO 2690-PF-KEY-BYPASS
062300         ELSE
062400             SET MBCA-MBMP-RETURN-BOTTOM
062500                                 TO TRUE
062600             GO TO 2690-PF-KEY-BYPASS.
062700*
062800     IF  SS08WS-VALID-PF5
062900     OR  SS08WS-EIBAID-VALID-PF5
063000         MOVE 51                 TO MBCA-SCREEN-NBR
063100         IF (MBMPTS-SEQUENCE (1) IS GREATER THAN ZEROES
063200         AND MBMPTS-SEQUENCE (8) IS EQUAL TO ZEROES)
063300         OR (MBCA-MBMP-FWD-SEQ IS EQUAL TO ZEROES)
063400             SET MBCA-MBMP-RETURN-NORMAL
063500                                 TO TRUE
063600             MOVE ZEROES         TO MBCA-MBMP-FWD-SEQ
063700             MOVE 'TS12'         TO MBCA-PROGRAM-LOCATION
063800             PERFORM 8400-WRITE-QUEUE
063900                                 THRU 8499-WQ-EXIT
064000             GO TO 2690-PF-KEY-BYPASS
064100         ELSE
064200             SET MBCA-MBMP-RETURN-FWD
064300                                 TO TRUE
064400             ADD +1              TO MBCA-MBMP-FWD-SEQ
064500             GO TO 2690-PF-KEY-BYPASS.
064600*
064700     IF  SS08WS-VALID-PF6
064800     OR  SS08WS-EIBAID-VALID-PF6
064900         MOVE 51                 TO MBCA-SCREEN-NBR
065000         IF  MBCA-MBMP-BACK-SEQ IS EQUAL
065100                                 TO MBCA-MBMP-FIRST-SEQ
065200             SET MBCA-MBMP-RETURN-NORMAL
065300                                 TO TRUE
065400             MOVE 'TS13'         TO MBCA-PROGRAM-LOCATION
065500             PERFORM 8400-WRITE-QUEUE
065600                                 THRU 8499-WQ-EXIT
065700             GO TO 2690-PF-KEY-BYPASS
065800         ELSE
065900             MOVE MBCA-MBMP-BACK-SEQ
066000                                 TO MBCA-MBMP-FWD-SEQ
066100             SET MBCA-MBMP-RETURN-BWD
066200                                 TO TRUE
066300             GO TO 2690-PF-KEY-BYPASS.
066400*
066500     IF  SS08WS-VALID-PF-KEY
066600     OR  SS08WS-EIBAID-VALID-PF-KEY
066700         SET MBCA-INITIAL-SCREEN-NBR
066800                                 TO TRUE
066900         GO TO 2690-PF-KEY-BYPASS
067000     ELSE
067100         IF  MBMPTS-SEQUENCE (8) IS EQUAL TO ZEROES
067200         OR  MBCA-MBMP-FWD-SEQ IS EQUAL TO ZEROES
067300             SET MBCA-INITIAL-SCREEN-NBR
067400                                 TO TRUE
067500             MOVE '..NU'         TO SS08WS-WORK-TRANS-ID
067600             MOVE 'PC08'         TO MBCA-PROGRAM-LOCATION
067700             PERFORM MB70PD-XCTL-TO-MBOXCTL
067800                                 THRU MB70PD-XTM-EXIT.
067900*
068000     MOVE 51                     TO MBCA-SCREEN-NBR.
068100     ADD +1                      TO MBCA-MBMP-FWD-SEQ.
068200     SET MBCA-MBMP-RETURN-NORMAL TO TRUE.
068300*
068400 2690-PF-KEY-BYPASS.
068500*
068600     MOVE 'PC09'                 TO MBCA-PROGRAM-LOCATION.
068700     PERFORM MB70PD-XCTL-TO-MBOXCTL
068800                                 THRU MB70PD-XTM-EXIT.
068900/
069000 6000-PERFORMED-ROUTINES-SECT SECTION.
069100*
069200 6100-EDIT-SOURCE-CODE.
069300*
069400     MOVE DFHBMDAS               TO MP01-SOURCE-LP-A (X-MP01-SD)
069500                                    MP01-SOURCE-RP-A (X-MP01-SD).
069600     MOVE DFHBMASK               TO MP01-SOURCE-A (X-MP01-SD).
069700*
069800     IF  MP01-SOURCE-L (X-MP01-SD) IS GREATER THAN ZERO
069900         MOVE DFHBMASF           TO MP01-SOURCE-A (X-MP01-SD)
070000     ELSE
070100         IF  MMSS-SEQ IS GREATER THAN ZERO
070200             MOVE MMSS-SOURCE-CODE
070300                                 TO MP01-SOURCE (X-MP01-SD).
070400*
070500 6199-ESC-EXIT.
070600     EXIT.
070700*
070800 6200-EDIT-SOURCE-PROD.
070900*
071000     MOVE DFHBMDAS               TO MP01-PRODUCT-LP-A (X-MP01-SD)
071100                                    MP01-PRODUCT-RP-A (X-MP01-SD).
071200     MOVE DFHBMASK               TO MP01-PRODUCT-A (X-MP01-SD).
071300*
071400     IF  MP01-PRODUCT-L (X-MP01-SD) IS GREATER THAN ZERO
071500         IF  MP01-PRODUCT (X-MP01-SD) IS NUMERIC
071600             IF  MBCA-PTI-FUNCTION-IS-MAINT
071700             AND MP01-PRODUCT (X-MP01-SD) IS EQUAL TO ZEROES
071800                 MOVE DFHBMASF   TO MP01-PRODUCT-A (X-MP01-SD)
071900             ELSE
072000                 IF  MP01-PRODUCT-VALID (X-MP01-SD)
072100                     MOVE DFHBMASF
072200                                 TO MP01-PRODUCT-A (X-MP01-SD)
072300                 ELSE
072400                     SET SS08WS-ERROR-SW-YES
072500                                 TO TRUE
072600                     MOVE SS08WS-CURSOR
072700                                 TO MP01-PRODUCT-L (X-MP01-SD)
072800                     MOVE DFHBMASB
072900                                 TO MP01-PRODUCT-LP-A (X-MP01-SD)
073000                                    MP01-PRODUCT-RP-A (X-MP01-SD)
073100                     MOVE DFHBMNBF
073200                                 TO MP01-PRODUCT-A (X-MP01-SD)
073300         ELSE
073400             SET SS08WS-ERROR-SW-YES TO TRUE
073500             MOVE SS08WS-CURSOR  TO MP01-PRODUCT-L (X-MP01-SD)
073600             MOVE DFHBMASB       TO MP01-PRODUCT-LP-A (X-MP01-SD)
073700                                    MP01-PRODUCT-RP-A (X-MP01-SD)
073800             MOVE DFHBMNBF       TO MP01-PRODUCT-A (X-MP01-SD)
073900     ELSE
074000         IF  MMSS-SEQ IS GREATER THAN ZERO
074100             MOVE MMSS-SOURCE-PRODUCT
074200                                 TO MP01-PRODUCT (X-MP01-SD).
074300*
074400 6299-ESP-EXIT.
074500     EXIT.
074600*
074700 6300-EDIT-SOURCE-ORG.
074800*
074900     MOVE DFHBMDAS               TO MP01-ORG-LP-A (X-MP01-SD)
075000                                    MP01-ORG-RP-A (X-MP01-SD).
075100     MOVE DFHBMASK               TO MP01-ORG-A (X-MP01-SD).
075200*
075300     IF  MP01-ORG-L (X-MP01-SD) IS GREATER THAN ZERO
075400         IF  MP01-ORG (X-MP01-SD) IS NUMERIC
075500             IF  MP01-ORG (X-MP01-SD) IS EQUAL TO ZEROES
075600                 IF  MBCA-PTI-FUNCTION-IS-MAINT
075700                     MOVE DFHBMASF
075800                                 TO MP01-ORG-A (X-MP01-SD)
075900                 ELSE
076000                     MOVE ZEROES TO MP01-ORG-L (X-MP01-SD)
076100             ELSE
076200                 IF  MP01-ORG-VALID (X-MP01-SD)
076300                     MOVE DFHBMASF
076400                                 TO MP01-ORG-A (X-MP01-SD)
076500                 ELSE
076600                     SET SS08WS-ERROR-SW-YES
076700                                 TO TRUE
076800                     MOVE SS08WS-CURSOR
076900                                 TO MP01-ORG-L (X-MP01-SD)
077000                     MOVE DFHBMASB
077100                                 TO MP01-ORG-LP-A (X-MP01-SD)
077200                                    MP01-ORG-RP-A (X-MP01-SD)
077300                     MOVE DFHBMNBF
077400                                 TO MP01-ORG-A (X-MP01-SD)
077500         ELSE
077600             SET SS08WS-ERROR-SW-YES TO TRUE
077700             MOVE SS08WS-CURSOR  TO MP01-ORG-L (X-MP01-SD)
077800             MOVE DFHBMASB       TO MP01-ORG-LP-A (X-MP01-SD)
077900                                    MP01-ORG-RP-A (X-MP01-SD)
078000             MOVE DFHBMNBF       TO MP01-ORG-A (X-MP01-SD)
078100     ELSE
078200         IF  MMSS-SEQ IS GREATER THAN ZERO
078300             MOVE MMSS-SOURCE-ORG
078400                                 TO MP01-ORG (X-MP01-SD).
078500*
078600 6399-ESO-EXIT.
078700     EXIT.
078800*
078900 6400-EDIT-SOURCE-LOGO.
079000*
079100     MOVE DFHBMDAS               TO MP01-LOGO-LP-A (X-MP01-SD)
079200                                    MP01-LOGO-RP-A (X-MP01-SD).
079300     MOVE DFHBMASK               TO MP01-LOGO-A (X-MP01-SD).
079400*
079500     IF  MP01-LOGO-L (X-MP01-SD) IS GREATER THAN ZERO
079600         IF  MP01-LOGO (X-MP01-SD) IS NUMERIC
079700             IF  MP01-LOGO (X-MP01-SD) IS EQUAL TO ZEROES
079800                 IF  MBCA-PTI-FUNCTION-IS-MAINT
079900                     MOVE DFHBMASF
080000                                 TO MP01-LOGO-A (X-MP01-SD)
080100                 ELSE
080200                     MOVE ZEROES TO MP01-LOGO-L (X-MP01-SD)
080300             ELSE
080400                 IF  MP01-LOGO-VALID (X-MP01-SD)
080500                     MOVE DFHBMASF
080600                                 TO MP01-LOGO-A (X-MP01-SD)
080700                 ELSE
080800                     SET SS08WS-ERROR-SW-YES
080900                                 TO TRUE
081000                     MOVE SS08WS-CURSOR
081100                                 TO MP01-LOGO-L (X-MP01-SD)
081200                     MOVE DFHBMASB
081300                                 TO MP01-LOGO-LP-A (X-MP01-SD)
081400                                    MP01-LOGO-RP-A (X-MP01-SD)
081500                     MOVE DFHBMNBF
081600                                 TO MP01-LOGO-A (X-MP01-SD)
081700         ELSE
081800             SET SS08WS-ERROR-SW-YES TO TRUE
081900             MOVE SS08WS-CURSOR  TO MP01-LOGO-L (X-MP01-SD)
082000             MOVE DFHBMASB       TO MP01-LOGO-LP-A (X-MP01-SD)
082100                                    MP01-LOGO-RP-A (X-MP01-SD)
082200             MOVE DFHBMNBF       TO MP01-LOGO-A (X-MP01-SD)
082300     ELSE
082400         IF  MMSS-SEQ IS GREATER THAN ZERO
082500             MOVE MMSS-SOURCE-LOGO
082600                                 TO MP01-LOGO (X-MP01-SD).
082700*
082800 6499-ESL-EXIT.
082900     EXIT.
083000*
083100 6500-EDIT-SOURCE-DESC.
083200*
083300     MOVE DFHBMDAS               TO MP01-DESC-LP-A (X-MP01-SD)
083400                                    MP01-DESC-RP-A (X-MP01-SD).
083500     MOVE DFHBMASK               TO MP01-DESC-A (X-MP01-SD).
083600*
083700     IF  MP01-DESC-L (X-MP01-SD) IS GREATER THAN ZERO
083800         MOVE DFHBMASF           TO MP01-DESC-A (X-MP01-SD)
083900     ELSE
084000         IF  MMSS-SEQ IS GREATER THAN ZERO
084100             MOVE MMSS-SOURCE-DESC
084200                                 TO MP01-DESC (X-MP01-SD).
084300*
084400 6599-ESD-EXIT.
084500     EXIT.
084600*
084700 6600-EDIT-SOURCE-FROM.
084800*
084900     MOVE DFHBMDAS               TO MP01-FROM-RANGE-LP-A
085000                                    (X-MP01-SD)
085100                                    MP01-FROM-RANGE-RP-A
085200                                    (X-MP01-SD).
085300     MOVE DFHBMASK               TO MP01-FROM-RANGE-A
085400                                    (X-MP01-SD).
085500*
085600     IF  MP01-FROM-RANGE-L (X-MP01-SD) IS GREATER THAN ZERO
085700         MOVE DFHBMASF           TO MP01-FROM-RANGE-A
085800                                    (X-MP01-SD)
085900     ELSE
086000         IF  MMSS-SEQ IS GREATER THAN ZERO
086100             MOVE MMSS-SOURCE-FROM-PREFIX
086200                                 TO MP01-FROM-RANGE (X-MP01-SD).
086300*
086400 6699-ESF-EXIT.
086500     EXIT.
086600*
086700 6700-EDIT-SOURCE-IND.
086800*
086900     MOVE DFHBMDAS               TO MP01-INDICATOR-LP-A
087000                                    (X-MP01-SD)
087100                                    MP01-INDICATOR-RP-A
087200                                    (X-MP01-SD).
087300     MOVE DFHBMASK               TO MP01-INDICATOR-A
087400                                    (X-MP01-SD).
087500*
087600     IF  MP01-INDICATOR-L (X-MP01-SD) IS GREATER THAN ZERO
087700         IF  MP01-INDICATOR-VALID (X-MP01-SD)
087800             MOVE DFHBMASF       TO MP01-INDICATOR-A
087900                                    (X-MP01-SD)
088000         ELSE
088100             SET SS08WS-ERROR-SW-YES TO TRUE
088200             MOVE SS08WS-CURSOR  TO MP01-INDICATOR-L
088300                                    (X-MP01-SD)
088400             MOVE DFHBMASB       TO MP01-INDICATOR-LP-A
088500                                    (X-MP01-SD)
088600                                    MP01-INDICATOR-RP-A
088700                                    (X-MP01-SD)
088800             MOVE DFHBMUBF       TO MP01-INDICATOR-A
088900                                    (X-MP01-SD)
089000     ELSE
089100         IF  MMSS-SEQ IS GREATER THAN ZERO
089200             MOVE MMSS-SOURCE-CRITERIA-OPER
089300                                 TO MP01-INDICATOR
089400                                    (X-MP01-SD).
089500*
089600 6799-ESI-EXIT.
089700     EXIT.
089800*
089900 6800-EDIT-SOURCE-TO.
090000*
090100     MOVE DFHBMDAS               TO MP01-TO-RANGE-LP-A
090200                                    (X-MP01-SD)
090300                                    MP01-TO-RANGE-RP-A
090400                                    (X-MP01-SD).
090500     MOVE DFHBMASK               TO MP01-TO-RANGE-A
090600                                    (X-MP01-SD).
090700*
090800     IF  MP01-TO-RANGE-L (X-MP01-SD) IS GREATER THAN ZERO
090900         MOVE DFHBMASF           TO MP01-TO-RANGE-A
091000                                    (X-MP01-SD)
091100     ELSE
091200         IF  MMSS-SEQ IS GREATER THAN ZERO
091300             MOVE MMSS-SOURCE-TO-PREFIX
091400                                 TO MP01-TO-RANGE (X-MP01-SD).
091500*
091600 6899-EST-EXIT.
091700     EXIT.
091800*
091900 6900-CROSS-EDITS.
092000*
092100*********************************************************
092200*                                                       *
092300*    THE CROSS EDITS ARE AS FOLLOWS:                    *
092400*                                                       *
092500*    . IF NO FIELDS ARE ENTERED THE CROSS EDITS         *
092600*      ARE NOT DONE. (6910-)                            *
092700*                                                       *
092800*    . THERE MUST BE A PRODUCT AND ONE OTHER FIELD      *
092900*      ENTERED. (6910-)                                 *
093000*                                                       *
093100*    . IF ERRORS ALREADY EXIST IN THESE FIELDS, THE     *
093200*      CROSS EDITS ARE NOT DONE.                        *
093300*                                                       *
093400*    - - - - - - - - - - - - - - - - - - - - - - - -    *
093500*                                                       *
093600*    . IF A ORG OR LOGO IS ENTERED AS ZEROES,           *
093700*      IN AN ADD MODE THERE MUST BE AT LEAST A          *
093800*      PRODUCT AND ONE OTHER FIELD ENTERED.             *
093900*      IN AN MAINT MODE THERE MUST BE AT LEAST A        *
094000*      PRODUCT AND ONE OTHER FIELD VALID.               *
094100*      (6911-)                                          *
094200*                                                       *
094300*      IF AN ERROR IS DETECTED, THEN THE ORG AND/OR     *
094400*      LOGO FIELDS ARE HIGHLIGHTED AND OPENED           *
094500*      FOR CORRECTION.                                  *
094600*                                                       *
094700*    - - - - - - - - - - - - - - - - - - - - - - - -    *
094800*                                                       *
094900*    . IF A FROM PREFIX IS ENTERED THE CRITERIA         *
095000*      OPERATOR CANNOT BE EQUAL TO 'Z'.                 *
095100*    . IF A FROM PREFIX IS NOT ENTERED THE CRITERIA     *
095200*      OPERATOR MUST BE EQUAL TO A 'Z'.                 *
095300*      (6912-)                                          *
095400*                                                       *
095500*      IF AN ERROR IS DETECTED, THEN THE FROM PREFIX    *
095600*      AND THE CRITERIA OPERATOR FIELDS ARE             *
095700*      HIGHLIGHTED AND OPENED FOR CORRECTION.           *
095800*                                                       *
095900*    - - - - - - - - - - - - - - - - - - - - - - - -    *
096000*                                                       *
096100*    . IF A TO PREFIX IS ENTERED THE CRITERIA           *
096200*      OPERATOR MUST BE AN 'R'.                         *
096300*    . IF A TO PREFIX IS NOT ENTERED THE CRITERIA       *
096400*      OPERATOR MUST NOT BE EQUAL TO AN 'R'.            *
096500*      (6913-)                                          *
096600*                                                       *
096700*      IF AN ERROR IS DETECTED, THEN THE TO PREFIX      *
096800*      AND THE CRITERIA OPERATOR FIELDS ARE             *
096900*      HIGHLIGHTED AND OPENED FOR CORRECTION.           *
097000*                                                       *
097100*    - - - - - - - - - - - - - - - - - - - - - - - -    *
097200*                                                       *
097300*    . IF THE CRITERIA OPERATOR IS EQUAL TO AN 'R'      *
097400*      THE TO PREFIX MUST BE GREATER THAN OR EQUAL      *
097500*      TO THE FROM PREFIX.                              *
097600*      NO EMBEDDED SPACES IN THE FROM/TO RANGES MAY     *
097700*      OCCUR.                                           *
097800*      LEADING SPACES IN THE FROM/TO RANGES ARE NOT     *
097900*      ALLOWED.                                         *
098000*      (6914-)                                          *
098100*                                                       *
098200*    - - - - - - - - - - - - - - - - - - - - - - - -    *
098300*                                                       *
098400*    . IF THE CRITERIA OPERATOR IS EQUAL TO AN 'E'      *
098500*      THE TO-PREFIX MUST BE SPACES AND                 *
098600*      THE FROM-PREFIX MUST CONTAIN A VALID ACCOUNT     *
098700*      CHARACTER (A-Z, 0-9) IN ALL 11 POSITIONS OF THE  *
098800*      FROM-PREFIX.                                     *
098900*      TRAILING SPACES IN THE FROM-RANGE IS NOT         *
099000*      ALLOWED.                                         *
099100*      (6915-)                                          *
099200*                                                       *
099300*    - - - - - - - - - - - - - - - - - - - - - - - -    *
099400*                                                       *
099500*    . IF THE CRITERIA OPERATOR IS EQUAL TO A 'W'       *
099600*      THE TO-PREFIX MUST BE SPACES AND                 *
099700*      THE FROM-PREFIX MUST CONTAIN A VALID ACCOUNT     *
099800*      CHARACTER (A-Z, 0-9 OR '*') IN ALL 11 POSITIONS  *
099900*      OF THE FROM-PREFIX.                              *
100000*      TRAILING SPACES IN THE FROM-RANGE IS NOT         *
100100*      ALLOWED.                                         *
100200*      (6916-)                                          *
100300*                                                       *
100400*      IF AN ERROR IS DETECTED, THEN THE FROM PREFIX,   *
100500*      TO PREFIX AND THE CRITERIA OPERATOR FIELDS ARE   *
100600*      HIGHLIGHTED AND OPENED FOR CORRECTION.           *
100700*                                                       *
100800*    - - - - - - - - - - - - - - - - - - - - - - - -    *
100900*                                                       *
101000*********************************************************
101100*
101200 6910-CHECK-ALL-FIELDS.
101300*
101400     IF  MP01-PRODUCT-L (X-MP01-SD) IS EQUAL TO ZERO
101500     AND MP01-SOURCE-L (X-MP01-SD) IS EQUAL TO ZERO
101600     AND MP01-ORG-L (X-MP01-SD) IS EQUAL TO ZERO
101700     AND MP01-LOGO-L (X-MP01-SD) IS EQUAL TO ZERO
101800     AND MP01-FROM-RANGE-L (X-MP01-SD) IS EQUAL TO ZERO
101900     AND MP01-INDICATOR-L (X-MP01-SD) IS EQUAL TO ZERO
102000     AND MP01-TO-RANGE-L (X-MP01-SD) IS EQUAL TO ZERO
102100     AND MP01-DESC-L (X-MP01-SD) IS EQUAL TO ZERO
102200         GO TO 6999-CE-EXIT.
102300*
102400     IF  MP01-PRODUCT-L (X-MP01-SD) IS GREATER THAN ZERO
102500         IF (MBCA-PTI-FUNCTION-IS-ADD
102600         AND MP01-SOURCE-L (X-MP01-SD) IS EQUAL TO ZERO
102700         AND MP01-ORG-L (X-MP01-SD) IS EQUAL TO ZERO
102800         AND MP01-LOGO-L (X-MP01-SD) IS EQUAL TO ZERO
102900         AND MP01-FROM-RANGE-L (X-MP01-SD) IS EQUAL TO ZERO
103000         AND MP01-INDICATOR-L (X-MP01-SD) IS EQUAL TO ZERO
103100         AND MP01-TO-RANGE-L (X-MP01-SD) IS EQUAL TO ZERO)
103200         OR (MBCA-PTI-FUNCTION-IS-MAINT
103300         AND MP01-PRODUCT (X-MP01-SD) IS GREATER THAN ZERO
103400         AND MP01-SOURCE (X-MP01-SD) IS EQUAL TO SPACES
103500         AND MP01-ORG (X-MP01-SD) IS EQUAL TO ZERO
103600         AND MP01-LOGO (X-MP01-SD) IS EQUAL TO ZERO
103700         AND MP01-FROM-RANGE (X-MP01-SD) IS EQUAL TO SPACES
103800         AND MP01-INDICATOR (X-MP01-SD) IS EQUAL TO SPACES
103900         AND MP01-TO-RANGE (X-MP01-SD) IS EQUAL TO SPACES)
104000             MOVE DFHBMASK       TO MP01-SOURCE-LP-A
104100                                    (X-MP01-SD)
104200                                    MP01-SOURCE-RP-A
104300                                    (X-MP01-SD)
104400                                    MP01-ORG-LP-A
104500                                    (X-MP01-SD)
104600                                    MP01-ORG-RP-A
104700                                    (X-MP01-SD)
104800                                    MP01-LOGO-LP-A
104900                                    (X-MP01-SD)
105000                                    MP01-LOGO-RP-A
105100                                    (X-MP01-SD)
105200                                    MP01-FROM-RANGE-LP-A
105300                                    (X-MP01-SD)
105400                                    MP01-FROM-RANGE-RP-A
105500                                    (X-MP01-SD)
105600                                    MP01-TO-RANGE-LP-A
105700                                    (X-MP01-SD)
105800                                    MP01-TO-RANGE-RP-A
105900                                    (X-MP01-SD)
106000                                    MP01-INDICATOR-LP-A
106100                                    (X-MP01-SD)
106200                                    MP01-INDICATOR-RP-A
106300                                    (X-MP01-SD)
106400                                    MP01-DESC-LP-A
106500                                    (X-MP01-SD)
106600                                    MP01-DESC-RP-A
106700                                    (X-MP01-SD)
106800             MOVE DFHBMASB       TO MP01-PRODUCT-LP-A
106900                                    (X-MP01-SD)
107000                                    MP01-PRODUCT-RP-A
107100                                    (X-MP01-SD)
107200             MOVE DFHBMUNP       TO MP01-SOURCE-A
107300                                    (X-MP01-SD)
107400                                    MP01-FROM-RANGE-A
107500                                    (X-MP01-SD)
107600                                    MP01-TO-RANGE-A
107700                                    (X-MP01-SD)
107800                                    MP01-INDICATOR-A
107900                                    (X-MP01-SD)
108000                                    MP01-DESC-A
108100                                    (X-MP01-SD)
108200             MOVE DFHBMUNN       TO MP01-ORG-A
108300                                    (X-MP01-SD)
108400                                    MP01-LOGO-A
108500                                    (X-MP01-SD)
108600             MOVE DFHBMUBF       TO MP01-PRODUCT-A
108700                                    (X-MP01-SD)
108800             MOVE SS08WS-CURSOR  TO MP01-PRODUCT-L
108900                                    (X-MP01-SD)
109000             SET SS08WS-ERROR-SW-YES TO TRUE
109100             GO TO 6999-CE-EXIT.
109200*
109300     IF  MBCA-PTI-FUNCTION-IS-ADD
109400         IF  MP01-PRODUCT-L (X-MP01-SD) IS EQUAL TO ZERO
109500             IF  MP01-SOURCE-L (X-MP01-SD) IS GREATER THAN ZERO
109600             OR  MP01-ORG-L (X-MP01-SD) IS GREATER THAN ZERO
109700             OR  MP01-LOGO-L (X-MP01-SD) IS GREATER THAN ZERO
109800             OR  MP01-FROM-RANGE-L (X-MP01-SD) IS GREATER
109900                                 THAN ZERO
110000             OR  MP01-INDICATOR-L (X-MP01-SD) IS GREATER THAN ZERO
110100             OR  MP01-TO-RANGE-L (X-MP01-SD) IS GREATER THAN ZERO
110200             OR  MP01-DESC-L (X-MP01-SD) IS GREATER THAN ZERO
110300                 MOVE DFHBMASB   TO MP01-PRODUCT-LP-A
110400                                    (X-MP01-SD)
110500                                    MP01-PRODUCT-RP-A
110600                                    (X-MP01-SD)
110700                 MOVE DFHBMUBF   TO MP01-PRODUCT-A
110800                                    (X-MP01-SD)
110900                 MOVE SS08WS-CURSOR TO MP01-PRODUCT-L
111000                                    (X-MP01-SD)
111100                 SET SS08WS-ERROR-SW-YES
111200                                 TO TRUE.
111300*
111400     IF  MBCA-PTI-FUNCTION-IS-MAINT
111500         IF (MP01-SOURCE-L (X-MP01-SD) IS GREATER THAN ZERO
111600         AND MP01-SOURCE (X-MP01-SD) IS NOT EQUAL TO SPACES)
111700         OR (MP01-ORG-L (X-MP01-SD) IS GREATER THAN ZERO
111800         AND MP01-ORG (X-MP01-SD) IS GREATER THAN ZERO)
111900         OR (MP01-LOGO-L (X-MP01-SD) IS GREATER THAN ZERO
112000         AND MP01-LOGO (X-MP01-SD) IS GREATER THAN ZERO)
112100         OR (MP01-FROM-RANGE-L (X-MP01-SD) IS GREATER THAN ZERO
112200         AND MP01-FROM-RANGE (X-MP01-SD) IS NOT EQUAL TO SPACES)
112300         OR (MP01-INDICATOR-L (X-MP01-SD) IS GREATER THAN ZERO
112400         AND MP01-INDICATOR (X-MP01-SD) IS NOT EQUAL TO SPACES)
112500         OR (MP01-TO-RANGE-L (X-MP01-SD) IS GREATER THAN ZERO
112600         AND MP01-TO-RANGE (X-MP01-SD) IS NOT EQUAL TO SPACES)
112700         OR (MP01-DESC-L (X-MP01-SD) IS GREATER THAN ZERO
112800         AND MP01-DESC (X-MP01-SD) IS NOT EQUAL TO SPACES)
112900             IF (MP01-PRODUCT-L (X-MP01-SD) IS EQUAL TO ZERO
113000             AND MP01-PRODUCT (X-MP01-SD) IS EQUAL TO ZERO)
113100                 MOVE DFHBMASB   TO MP01-PRODUCT-LP-A
113200                                    (X-MP01-SD)
113300                                    MP01-PRODUCT-RP-A
113400                                    (X-MP01-SD)
113500                 MOVE DFHBMUBF   TO MP01-PRODUCT-A
113600                                    (X-MP01-SD)
113700                 MOVE SS08WS-CURSOR TO MP01-PRODUCT-L
113800                                    (X-MP01-SD)
113900                 SET SS08WS-ERROR-SW-YES
114000                                 TO TRUE.
114100*
114200     PERFORM 6911-CHECK-ORG-LOGO THRU 6911-COL-EXIT.
114300     PERFORM 6914-CHECK-CRIT-OPER
114400                                 THRU 6914-CCO-EXIT.
114500     PERFORM 6915-CHECK-EXACT-MATCH
114600                                 THRU 6915-CEM-EXIT.
114700     PERFORM 6916-CHECK-WILDCARD-MATCH
114800                                 THRU 6916-CWM-EXIT.
114900     PERFORM 6912-CHECK-FROM-RANGE
115000                                 THRU 6912-CFR-EXIT.
115100     PERFORM 6913-CHECK-TO-RANGE
115200                                 THRU 6913-CTR-EXIT.
115300     GO TO 6999-CE-EXIT.
115400*
115500 6911-CHECK-ORG-LOGO.
115600*
115700     IF  MP01-ORG-L (X-MP01-SD) IS LESS THAN +1
115800         GO TO 6911-CHECK-LOGO.
115900*
116000     IF  MP01-ORG (X-MP01-SD) IS EQUAL TO ZEROES
116100         IF  MBCA-PTI-FUNCTION-IS-ADD
116200             IF (MP01-PRODUCT-L (X-MP01-SD) IS EQUAL TO ZERO)
116300             OR (MP01-SOURCE-L (X-MP01-SD) IS EQUAL TO ZERO
116400             AND MP01-LOGO-L (X-MP01-SD) IS EQUAL TO ZERO
116500             AND MP01-FROM-RANGE-L (X-MP01-SD) IS EQUAL TO ZERO
116600             AND MP01-INDICATOR-L (X-MP01-SD) IS EQUAL TO ZERO
116700             AND MP01-TO-RANGE-L (X-MP01-SD) IS EQUAL TO ZERO
116800             AND MP01-DESC-L (X-MP01-SD) IS EQUAL TO ZERO)
116900                 MOVE DFHBMASB   TO MP01-ORG-LP-A
117000                                    (X-MP01-SD)
117100                                    MP01-ORG-RP-A
117200                                    (X-MP01-SD)
117300                 MOVE DFHBMNBF   TO MP01-ORG-A
117400                                    (X-MP01-SD)
117500                 MOVE SS08WS-CURSOR TO MP01-ORG-L
117600                                    (X-MP01-SD)
117700                 SET SS08WS-ERROR-SW-YES
117800                                 TO TRUE
117900             ELSE
118000                 NEXT SENTENCE
118100         ELSE
118200             IF (MP01-PRODUCT (X-MP01-SD) IS GREATER THAN ZEROES)
118300             AND (MP01-SOURCE (X-MP01-SD) IS EQUAL TO SPACES
118400             AND  MP01-LOGO (X-MP01-SD) IS EQUAL TO ZERO
118500             AND  MP01-FROM-RANGE (X-MP01-SD) IS EQUAL TO SPACES
118600             AND  MP01-INDICATOR (X-MP01-SD) IS EQUAL TO SPACES
118700             AND  MP01-TO-RANGE (X-MP01-SD) IS EQUAL TO SPACES
118800             AND  MP01-DESC (X-MP01-SD) IS EQUAL TO SPACES)
118900                 MOVE DFHBMASB   TO MP01-ORG-LP-A
119000                                    (X-MP01-SD)
119100                                    MP01-ORG-RP-A
119200                                    (X-MP01-SD)
119300                 MOVE DFHBMNBF   TO MP01-ORG-A
119400                                    (X-MP01-SD)
119500                 MOVE SS08WS-CURSOR TO MP01-ORG-L
119600                                    (X-MP01-SD)
119700                 SET SS08WS-ERROR-SW-YES
119800                                 TO TRUE.
119900*
120000 6911-CHECK-LOGO.
120100*
120200     IF  MP01-LOGO-L (X-MP01-SD) IS LESS THAN +1
120300         GO TO 6911-COL-EXIT.
120400*
120500     IF  MP01-LOGO (X-MP01-SD) IS EQUAL TO ZEROES
120600         IF  MBCA-PTI-FUNCTION-IS-ADD
120700             IF (MP01-PRODUCT-L (X-MP01-SD) IS EQUAL TO ZERO)
120800             OR (MP01-SOURCE-L (X-MP01-SD) IS EQUAL TO ZERO
120900             AND MP01-ORG-L (X-MP01-SD) IS EQUAL TO ZERO
121000             AND MP01-FROM-RANGE-L (X-MP01-SD) IS EQUAL TO ZERO
121100             AND MP01-INDICATOR-L (X-MP01-SD) IS EQUAL TO ZERO
121200             AND MP01-TO-RANGE-L (X-MP01-SD) IS EQUAL TO ZERO
121300             AND MP01-DESC-L (X-MP01-SD) IS EQUAL TO ZERO)
121400                 MOVE DFHBMASB   TO MP01-LOGO-LP-A
121500                                    (X-MP01-SD)
121600                                    MP01-LOGO-RP-A
121700                                    (X-MP01-SD)
121800                 MOVE DFHBMNBF   TO MP01-LOGO-A
121900                                    (X-MP01-SD)
122000                 MOVE SS08WS-CURSOR TO MP01-LOGO-L
122100                                    (X-MP01-SD)
122200                 SET SS08WS-ERROR-SW-YES
122300                                 TO TRUE
122400             ELSE
122500                 NEXT SENTENCE
122600         ELSE
122700             IF (MP01-PRODUCT (X-MP01-SD) IS GREATER THAN ZEROES)
122800             AND (MP01-SOURCE (X-MP01-SD) IS EQUAL TO SPACES
122900             AND  MP01-ORG (X-MP01-SD) IS EQUAL TO ZERO
123000             AND  MP01-FROM-RANGE (X-MP01-SD) IS EQUAL TO SPACES
123100             AND  MP01-INDICATOR (X-MP01-SD) IS EQUAL TO SPACES
123200             AND  MP01-TO-RANGE (X-MP01-SD) IS EQUAL TO SPACES
123300             AND  MP01-DESC (X-MP01-SD) IS EQUAL TO SPACES)
123400                 MOVE DFHBMASB   TO MP01-LOGO-LP-A
123500                                    (X-MP01-SD)
123600                                    MP01-LOGO-RP-A
123700                                    (X-MP01-SD)
123800                 MOVE DFHBMNBF   TO MP01-LOGO-A
123900                                    (X-MP01-SD)
124000                 MOVE SS08WS-CURSOR TO MP01-LOGO-L
124100                                    (X-MP01-SD)
124200                 SET SS08WS-ERROR-SW-YES
124300                                 TO TRUE.
124400*
124500 6911-COL-EXIT.
124600     EXIT.
124700*
124800 6912-CHECK-FROM-RANGE.
124900*
125000     IF  MP01-FROM-RANGE-L (X-MP01-SD) IS EQUAL TO SS08WS-CURSOR
125100     OR  MP01-INDICATOR-L (X-MP01-SD) IS EQUAL TO SS08WS-CURSOR
125200     OR  MP01-TO-RANGE-L (X-MP01-SD) IS EQUAL TO SS08WS-CURSOR
125300         GO TO 6912-CFR-EXIT.
125400*
125500     IF  MP01-FROM-RANGE-L (X-MP01-SD) IS EQUAL TO ZERO
125600         GO TO 6912-CFR-EXIT.
125700*
125800     IF  MP01-FROM-RANGE-L (X-MP01-SD) IS GREATER THAN ZERO
125900     AND MP01-FROM-RANGE (X-MP01-SD) IS EQUAL TO SPACES
126000     AND NOT MP01-INDICATOR-DEFAULT (X-MP01-SD)
126100         GO TO 6912-CHECK-FROM-RANGE-ERROR.
126200*
126300     IF  MP01-FROM-RANGE (X-MP01-SD) IS NOT EQUAL TO SPACES
126400     AND MP01-INDICATOR-DEFAULT (X-MP01-SD)
126500         GO TO 6912-CHECK-FROM-RANGE-ERROR.
126600*
126700     GO TO 6912-CFR-EXIT.
126800*
126900 6912-CHECK-FROM-RANGE-ERROR.
127000*
127100     SET SS08WS-ERROR-SW-YES     TO TRUE.
127200     MOVE DFHBMUBF               TO MP01-FROM-RANGE-A
127300                                    (X-MP01-SD)
127400                                    MP01-INDICATOR-A
127500                                    (X-MP01-SD).
127600     MOVE DFHBMASB               TO MP01-FROM-RANGE-LP-A
127700                                    (X-MP01-SD)
127800                                    MP01-FROM-RANGE-RP-A
127900                                    (X-MP01-SD)
128000                                    MP01-INDICATOR-LP-A
128100                                    (X-MP01-SD)
128200                                    MP01-INDICATOR-RP-A
128300                                    (X-MP01-SD).
128400     MOVE SS08WS-CURSOR          TO MP01-FROM-RANGE-L
128500                                    (X-MP01-SD).
128600*
128700 6912-CFR-EXIT.
128800     EXIT.
128900*
129000 6913-CHECK-TO-RANGE.
129100*
129200     IF  MP01-FROM-RANGE-L (X-MP01-SD) IS EQUAL TO SS08WS-CURSOR
129300     OR  MP01-INDICATOR-L (X-MP01-SD) IS EQUAL TO SS08WS-CURSOR
129400     OR  MP01-TO-RANGE-L (X-MP01-SD) IS EQUAL TO SS08WS-CURSOR
129500         GO TO 6913-CTR-EXIT.
129600*
129700     IF  MP01-TO-RANGE-L (X-MP01-SD) IS EQUAL TO ZERO
129800         GO TO 6913-CTR-EXIT.
129900*
130000     IF  MP01-TO-RANGE (X-MP01-SD) IS EQUAL TO SPACES
130100     AND MP01-INDICATOR-RANGE (X-MP01-SD)
130200         GO TO 6913-CHECK-TO-RANGE-ERROR.
130300*
130400     IF  MP01-TO-RANGE (X-MP01-SD) IS NOT EQUAL TO SPACES
130500     AND NOT MP01-INDICATOR-RANGE (X-MP01-SD)
130600         GO TO 6913-CHECK-TO-RANGE-ERROR.
130700*
130800     GO TO 6913-CTR-EXIT.
130900*
131000 6913-CHECK-TO-RANGE-ERROR.
131100*
131200     SET SS08WS-ERROR-SW-YES     TO TRUE.
131300     MOVE DFHBMUBF               TO MP01-INDICATOR-A
131400                                    (X-MP01-SD)
131500                                    MP01-TO-RANGE-A
131600                                    (X-MP01-SD).
131700     MOVE DFHBMASB               TO MP01-TO-RANGE-LP-A
131800                                    (X-MP01-SD)
131900                                    MP01-TO-RANGE-RP-A
132000                                    (X-MP01-SD)
132100                                    MP01-INDICATOR-LP-A
132200                                    (X-MP01-SD)
132300                                    MP01-INDICATOR-RP-A
132400                                    (X-MP01-SD).
132500     MOVE SS08WS-CURSOR          TO MP01-TO-RANGE-L
132600                                    (X-MP01-SD).
132700*
132800 6913-CTR-EXIT.
132900     EXIT.
133000*
133100 6914-CHECK-CRIT-OPER.
133200*
133300     IF  MP01-FROM-RANGE-L (X-MP01-SD) IS EQUAL TO SS08WS-CURSOR
133400     OR  MP01-INDICATOR-L (X-MP01-SD) IS EQUAL TO SS08WS-CURSOR
133500     OR  MP01-TO-RANGE-L (X-MP01-SD) IS EQUAL TO SS08WS-CURSOR
133600         GO TO 6914-CCO-EXIT.
133700*
133800     IF  MP01-INDICATOR-RANGE (X-MP01-SD)
133900         NEXT SENTENCE
134000     ELSE
134100         GO TO 6914-CCO-EXIT.
134200*
134300     IF  MP01-TO-RANGE   (X-MP01-SD) IS EQUAL TO SPACES
134400     AND MP01-FROM-RANGE (X-MP01-SD) IS EQUAL TO SPACES
134500         GO TO 6914-CHECK-CRIT-OPER-ERROR.
134600*
134700     IF  MP01-TO-RANGE (X-MP01-SD) IS LESS THAN
134800         MP01-FROM-RANGE (X-MP01-SD)
134900         GO TO 6914-CHECK-CRIT-OPER-ERROR.
135000*
135100     IF  MP01-TO-RANGE   (X-MP01-SD) (1:1)  IS EQUAL TO '*'
135200     OR  MP01-TO-RANGE   (X-MP01-SD) (2:1)  IS EQUAL TO '*'
135300     OR  MP01-TO-RANGE   (X-MP01-SD) (3:1)  IS EQUAL TO '*'
135400     OR  MP01-TO-RANGE   (X-MP01-SD) (4:1)  IS EQUAL TO '*'
135500     OR  MP01-TO-RANGE   (X-MP01-SD) (5:1)  IS EQUAL TO '*'
135600     OR  MP01-TO-RANGE   (X-MP01-SD) (6:1)  IS EQUAL TO '*'
135700     OR  MP01-TO-RANGE   (X-MP01-SD) (7:1)  IS EQUAL TO '*'
135800     OR  MP01-TO-RANGE   (X-MP01-SD) (8:1)  IS EQUAL TO '*'
135900     OR  MP01-TO-RANGE   (X-MP01-SD) (9:1)  IS EQUAL TO '*'
136000     OR  MP01-TO-RANGE   (X-MP01-SD) (10:1) IS EQUAL TO '*'
136100     OR  MP01-TO-RANGE   (X-MP01-SD) (11:1) IS EQUAL TO '*'
136200     OR  MP01-FROM-RANGE (X-MP01-SD) (1:1)  IS EQUAL TO '*'
136300     OR  MP01-FROM-RANGE (X-MP01-SD) (2:1)  IS EQUAL TO '*'
136400     OR  MP01-FROM-RANGE (X-MP01-SD) (3:1)  IS EQUAL TO '*'
136500     OR  MP01-FROM-RANGE (X-MP01-SD) (4:1)  IS EQUAL TO '*'
136600     OR  MP01-FROM-RANGE (X-MP01-SD) (5:1)  IS EQUAL TO '*'
136700     OR  MP01-FROM-RANGE (X-MP01-SD) (6:1)  IS EQUAL TO '*'
136800     OR  MP01-FROM-RANGE (X-MP01-SD) (7:1)  IS EQUAL TO '*'
136900     OR  MP01-FROM-RANGE (X-MP01-SD) (8:1)  IS EQUAL TO '*'
137000     OR  MP01-FROM-RANGE (X-MP01-SD) (9:1)  IS EQUAL TO '*'
137100     OR  MP01-FROM-RANGE (X-MP01-SD) (10:1) IS EQUAL TO '*'
137200     OR  MP01-FROM-RANGE (X-MP01-SD) (11:1) IS EQUAL TO '*'
137300         GO TO 6914-CHECK-CRIT-OPER-ERROR.
137400*
137500     MOVE 'N'                    TO WS-REFMOD-ERROR.
137600*
137700     PERFORM
137800         VARYING WS-REFMOD-1 FROM 1 BY 1
137900         UNTIL   WS-REFMOD-1 IS GREATER THAN 10
138000              OR WS-REFMOD-ERROR IS EQUAL TO 'Y'
138100         COMPUTE WS-REFMOD-2     =  WS-REFMOD-1 + 1
138200         IF  MP01-TO-RANGE (X-MP01-SD) (WS-REFMOD-1:1)
138300                                 IS EQUAL TO SPACES
138400         AND MP01-TO-RANGE (X-MP01-SD) (WS-REFMOD-2:1)
138500                                 IS NOT EQUAL TO SPACES
138600             MOVE 'Y'            TO WS-REFMOD-ERROR
138700         END-IF
138800         IF  MP01-FROM-RANGE (X-MP01-SD) (WS-REFMOD-1:1)
138900                                 IS EQUAL TO SPACES
139000         AND MP01-FROM-RANGE (X-MP01-SD) (WS-REFMOD-2:1)
139100                                 IS NOT EQUAL TO SPACES
139200             MOVE 'Y'            TO WS-REFMOD-ERROR
139300         END-IF
139400     END-PERFORM.
139500*
139600     IF  WS-REFMOD-ERROR IS EQUAL TO 'Y'
139700         GO TO 6914-CHECK-CRIT-OPER-ERROR.
139800*
139900     GO TO 6914-CCO-EXIT.
140000*
140100*
140200*
140300 6914-CHECK-CRIT-OPER-ERROR.
140400*
140500     SET SS08WS-ERROR-SW-YES     TO TRUE.
140600     MOVE DFHBMUBF               TO MP01-INDICATOR-A
140700                                    (X-MP01-SD)
140800                                    MP01-FROM-RANGE-A
140900                                    (X-MP01-SD)
141000                                    MP01-TO-RANGE-A
141100                                    (X-MP01-SD).
141200     MOVE DFHBMASB               TO MP01-FROM-RANGE-LP-A
141300                                    (X-MP01-SD)
141400                                    MP01-FROM-RANGE-RP-A
141500                                    (X-MP01-SD)
141600                                    MP01-TO-RANGE-LP-A
141700                                    (X-MP01-SD)
141800                                    MP01-TO-RANGE-RP-A
141900                                    (X-MP01-SD)
142000                                    MP01-INDICATOR-LP-A
142100                                    (X-MP01-SD)
142200                                    MP01-INDICATOR-RP-A
142300                                    (X-MP01-SD).
142400     MOVE SS08WS-CURSOR          TO MP01-INDICATOR-L
142500                                    (X-MP01-SD).
142600*
142700 6914-CCO-EXIT.
142800     EXIT.
142900*
143000 6915-CHECK-EXACT-MATCH.
143100*
143200     IF  MP01-FROM-RANGE-L (X-MP01-SD) IS EQUAL TO SS08WS-CURSOR
143300     OR  MP01-INDICATOR-L (X-MP01-SD) IS EQUAL TO SS08WS-CURSOR
143400     OR  MP01-TO-RANGE-L (X-MP01-SD) IS EQUAL TO SS08WS-CURSOR
143500         GO TO 6915-CEM-EXIT.
143600*
143700     IF  MP01-INDICATOR-EXACT (X-MP01-SD)
143800         NEXT SENTENCE
143900     ELSE
144000         GO TO 6915-CEM-EXIT.
144100*
144200     IF  MP01-FROM-RANGE (X-MP01-SD) (1:1)  IS EQUAL TO SPACES
144300     OR  MP01-FROM-RANGE (X-MP01-SD) (2:1)  IS EQUAL TO SPACES
144400     OR  MP01-FROM-RANGE (X-MP01-SD) (3:1)  IS EQUAL TO SPACES
144500     OR  MP01-FROM-RANGE (X-MP01-SD) (4:1)  IS EQUAL TO SPACES
144600     OR  MP01-FROM-RANGE (X-MP01-SD) (5:1)  IS EQUAL TO SPACES
144700     OR  MP01-FROM-RANGE (X-MP01-SD) (6:1)  IS EQUAL TO SPACES
144800     OR  MP01-FROM-RANGE (X-MP01-SD) (7:1)  IS EQUAL TO SPACES
144900     OR  MP01-FROM-RANGE (X-MP01-SD) (8:1)  IS EQUAL TO SPACES
145000     OR  MP01-FROM-RANGE (X-MP01-SD) (9:1)  IS EQUAL TO SPACES
145100     OR  MP01-FROM-RANGE (X-MP01-SD) (10:1) IS EQUAL TO SPACES
145200     OR  MP01-FROM-RANGE (X-MP01-SD) (11:1) IS EQUAL TO SPACES
145300         GO TO 6915-CEM-ERROR.
145400*
145500     IF  MP01-FROM-RANGE (X-MP01-SD) (1:1)  IS EQUAL TO '*'
145600     OR  MP01-FROM-RANGE (X-MP01-SD) (2:1)  IS EQUAL TO '*'
145700     OR  MP01-FROM-RANGE (X-MP01-SD) (3:1)  IS EQUAL TO '*'
145800     OR  MP01-FROM-RANGE (X-MP01-SD) (4:1)  IS EQUAL TO '*'
145900     OR  MP01-FROM-RANGE (X-MP01-SD) (5:1)  IS EQUAL TO '*'
146000     OR  MP01-FROM-RANGE (X-MP01-SD) (6:1)  IS EQUAL TO '*'
146100     OR  MP01-FROM-RANGE (X-MP01-SD) (7:1)  IS EQUAL TO '*'
146200     OR  MP01-FROM-RANGE (X-MP01-SD) (8:1)  IS EQUAL TO '*'
146300     OR  MP01-FROM-RANGE (X-MP01-SD) (9:1)  IS EQUAL TO '*'
146400     OR  MP01-FROM-RANGE (X-MP01-SD) (10:1) IS EQUAL TO '*'
146500     OR  MP01-FROM-RANGE (X-MP01-SD) (11:1) IS EQUAL TO '*'
146600         GO TO 6915-CEM-ERROR.
146700*
146800     IF  MP01-TO-RANGE   (X-MP01-SD) IS NOT EQUAL TO SPACES
146900         GO TO 6915-CEM-ERROR.
147000*
147100     GO TO 6915-CEM-EXIT.
147200*
147300*
147400*
147500 6915-CEM-ERROR.
147600*
147700     SET SS08WS-ERROR-SW-YES     TO TRUE.
147800     MOVE DFHBMUBF               TO MP01-INDICATOR-A
147900                                    (X-MP01-SD)
148000                                    MP01-FROM-RANGE-A
148100                                    (X-MP01-SD)
148200                                    MP01-TO-RANGE-A
148300                                    (X-MP01-SD).
148400     MOVE DFHBMASB               TO MP01-FROM-RANGE-LP-A
148500                                    (X-MP01-SD)
148600                                    MP01-FROM-RANGE-RP-A
148700                                    (X-MP01-SD)
148800                                    MP01-TO-RANGE-LP-A
148900                                    (X-MP01-SD)
149000                                    MP01-TO-RANGE-RP-A
149100                                    (X-MP01-SD)
149200                                    MP01-INDICATOR-LP-A
149300                                    (X-MP01-SD)
149400                                    MP01-INDICATOR-RP-A
149500                                    (X-MP01-SD).
149600     MOVE SS08WS-CURSOR          TO MP01-INDICATOR-L
149700                                    (X-MP01-SD).
149800*
149900 6915-CEM-EXIT.
150000     EXIT.
150100*
150200 6999-CE-EXIT.
150300     EXIT.
150400*
150500 6916-CHECK-WILDCARD-MATCH.
150600*
150700     IF  MP01-FROM-RANGE-L (X-MP01-SD) IS EQUAL TO SS08WS-CURSOR
150800     OR  MP01-INDICATOR-L (X-MP01-SD) IS EQUAL TO SS08WS-CURSOR
150900     OR  MP01-TO-RANGE-L (X-MP01-SD) IS EQUAL TO SS08WS-CURSOR
151000         GO TO 6916-CWM-EXIT.
151100*
151200     IF  MP01-INDICATOR-WILDCARD (X-MP01-SD)
151300         NEXT SENTENCE
151400     ELSE
151500         GO TO 6916-CWM-EXIT.
151600*
151700     IF  MP01-FROM-RANGE (X-MP01-SD) (1:1)  IS EQUAL TO SPACES
151800     OR  MP01-FROM-RANGE (X-MP01-SD) (2:1)  IS EQUAL TO SPACES
151900     OR  MP01-FROM-RANGE (X-MP01-SD) (3:1)  IS EQUAL TO SPACES
152000     OR  MP01-FROM-RANGE (X-MP01-SD) (4:1)  IS EQUAL TO SPACES
152100     OR  MP01-FROM-RANGE (X-MP01-SD) (5:1)  IS EQUAL TO SPACES
152200     OR  MP01-FROM-RANGE (X-MP01-SD) (6:1)  IS EQUAL TO SPACES
152300     OR  MP01-FROM-RANGE (X-MP01-SD) (7:1)  IS EQUAL TO SPACES
152400     OR  MP01-FROM-RANGE (X-MP01-SD) (8:1)  IS EQUAL TO SPACES
152500     OR  MP01-FROM-RANGE (X-MP01-SD) (9:1)  IS EQUAL TO SPACES
152600     OR  MP01-FROM-RANGE (X-MP01-SD) (10:1) IS EQUAL TO SPACES
152700     OR  MP01-FROM-RANGE (X-MP01-SD) (11:1) IS EQUAL TO SPACES
152800         GO TO 6916-CWM-ERROR.
152900*
153000     IF  MP01-TO-RANGE   (X-MP01-SD) IS NOT EQUAL TO SPACES
153100         GO TO 6916-CWM-ERROR.
153200*
153300     GO TO 6916-CWM-EXIT.
153400*
153500*
153600*
153700 6916-CWM-ERROR.
153800*
153900     SET SS08WS-ERROR-SW-YES     TO TRUE.
154000     MOVE DFHBMUBF               TO MP01-INDICATOR-A
154100                                    (X-MP01-SD)
154200                                    MP01-FROM-RANGE-A
154300                                    (X-MP01-SD)
154400                                    MP01-TO-RANGE-A
154500                                    (X-MP01-SD).
154600     MOVE DFHBMASB               TO MP01-FROM-RANGE-LP-A
154700                                    (X-MP01-SD)
154800                                    MP01-FROM-RANGE-RP-A
154900                                    (X-MP01-SD)
155000                                    MP01-TO-RANGE-LP-A
155100                                    (X-MP01-SD)
155200                                    MP01-TO-RANGE-RP-A
155300                                    (X-MP01-SD)
155400                                    MP01-INDICATOR-LP-A
155500                                    (X-MP01-SD)
155600                                    MP01-INDICATOR-RP-A
155700                                    (X-MP01-SD).
155800     MOVE SS08WS-CURSOR          TO MP01-INDICATOR-L
155900                                    (X-MP01-SD).
156000*
156100 6916-CWM-EXIT.
156200     EXIT.
156300*
156400 8100-TEMP-STORAGE-GETMAIN.
156500*
156600     EXEC CICS GETMAIN
156700               FLENGTH (LENGTH  OF MBMPTS-RECORD)
156800               SET     (ADDRESS OF MBMPTS-RECORD)
156900          END-EXEC.
157000*
157100 8199-TSG-EXIT.
157200     EXIT.
157300*
157400 8200-TEMP-STORAGE-READ.
157500*
157600     EXEC CICS READQ TS
157700               QUEUE   (TS-QUEUE-NAME)
157800               INTO    (MBMPTS-RECORD)
157900               LENGTH  (LENGTH  OF MBMPTS-RECORD)
158000               ITEM    (1)
158100          END-EXEC.
158200*
158300 8299-TSR-EXIT.
158400     EXIT.
158500*
158600 8300-TEMP-STORAGE-DELETE.
158700*
158800     EXEC CICS IGNORE CONDITION
158900               QIDERR
159000          END-EXEC.
159100*
159200     EXEC CICS DELETEQ TS
159300               QUEUE  (TS-QUEUE-NAME)
159400          END-EXEC.
159500*
159600 8399-TSD-EXIT.
159700     EXIT.
159800*
159900 8400-WRITE-QUEUE.
160000*
160100     EXEC CICS WRITEQ TS
160200               QUEUE   (TS-QUEUE-NAME)
160300               FROM    (MBMPTS-RECORD)
160400               LENGTH  (LENGTH  OF MBMPTS-RECORD)
160500          END-EXEC.
160600*
160700 8499-WQ-EXIT.
160800     EXIT.
160900*
161000 8500-INIT-COMMAREA.
161100*
161200     SET MBCA-MBMP-RETURN-NORMAL TO TRUE.
161300     MOVE ZEROES                 TO MBCA-MBMP-BACK-SEQ.
161400*
161500     MOVE 'TS14'                 TO MBCA-PROGRAM-LOCATION.
161600     PERFORM 8300-TEMP-STORAGE-DELETE
161700                                 THRU 8399-TSD-EXIT.
161800*
161900****************************************************************
162000*    START BROWSE THE PRODUCT FILE                             *
162100****************************************************************
162200*
162300     MOVE 'FC04'                 TO MBCA-PROGRAM-LOCATION.
162400     MOVE ZEROES                 TO MBIOWS-MMSS-ORG.
162500     MOVE +1                     TO MBIOWS-MMSS-SEQ.
162600     SET MBIORO-STARTBR-GTE      TO TRUE.
162700     PERFORM MMSSAO-ACCESS       THRU MMSSAO-ACCESS-EXIT.
162800*
162900****************************************************************
163000*    READNEXT THE PRODUCT FILE                                 *
163100****************************************************************
163200*
163300     MOVE 'FC05'                 TO MBCA-PROGRAM-LOCATION.
163400     SET MBIORO-READ-SEQ         TO TRUE.
163500     PERFORM MMSSAO-ACCESS       THRU MMSSAO-ACCESS-EXIT.
163600*
163700****************************************************************
163800*    END BROWSE THE PRODUCT FILE                               *
163900****************************************************************
164000*
164100     MOVE 'FC06'                 TO MBCA-PROGRAM-LOCATION.
164200     SET MBIORO-ENDBR            TO TRUE.
164300     PERFORM MMSSAO-ACCESS       THRU MMSSAO-ACCESS-EXIT.
164400*
164500     IF  MMSS-TRAILER
164600         MOVE 'NO RECORDS ON FILE'
164700                                 TO MP01-ERR-MESSAGE
164800         MOVE ZEROES             TO MBCA-MBMP-FIRST-SEQ
164900                                    MBCA-MBMP-FWD-SEQ
165000         MOVE DFHBMDAS           TO MP01-LIT-LINE-5-A
165100                                    MP01-LIT-LINE-5A-A
165200                                    MP01-LIT-LINE-6-A
165300         SET SS08WS-ERROR-SW-YES TO TRUE
165400     ELSE
165500         MOVE MMSS-SEQ           TO MBCA-MBMP-FIRST-SEQ
165600                                    MBCA-MBMP-FWD-SEQ.
165700*
165800 8599-IC-EXIT.
165900     EXIT.
166000*
166100 8800-BUILD-SCREEN.
166200*
166300     SET X-MP01-SD               TO +1.
166400*
166500 8800-BUILD-LOOP.
166600*
166700     IF  MBMPTS-SEQUENCE (1) IS EQUAL TO ZEROES
166800         MOVE 'NO RECORDS ON FILE'
166900                                 TO MP01-ERR-MESSAGE
167000         MOVE ZEROES             TO MBCA-MBMP-FIRST-SEQ
167100                                    MBCA-MBMP-FWD-SEQ
167200         MOVE DFHBMDAS           TO MP01-LIT-LINE-5-A
167300                                    MP01-LIT-LINE-5A-A
167400                                    MP01-LIT-LINE-6-A
167500         SET SS08WS-ERROR-SW-YES TO TRUE
167600         GO TO 8899-BS-EXIT.
167700*
167800     SET X-MBMPTS-INDEX          TO X-MP01-SD.
167900*
168000     IF  MBMPTS-SEQUENCE (X-MBMPTS-INDEX)
168100                                 IS GREATER THAN ZEROES
168200         MOVE MBMPTS-SOURCE-CODE (X-MBMPTS-INDEX)
168300                                 TO MP01-SOURCE
168400                                    (X-MP01-SD)
168500         MOVE MBMPTS-SOURCE-PROD (X-MBMPTS-INDEX)
168600                                 TO MP01-PRODUCT
168700                                    (X-MP01-SD)
168800         MOVE MBMPTS-SOURCE-ORG  (X-MBMPTS-INDEX)
168900                                 TO MP01-ORG
169000                                    (X-MP01-SD)
169100         MOVE MBMPTS-SOURCE-LOGO (X-MBMPTS-INDEX)
169200                                 TO MP01-LOGO
169300                                    (X-MP01-SD)
169400         MOVE MBMPTS-FROM-RANGE  (X-MBMPTS-INDEX)
169500                                 TO MP01-FROM-RANGE
169600                                    (X-MP01-SD)
169700         MOVE MBMPTS-TO-RANGE    (X-MBMPTS-INDEX)
169800                                 TO MP01-TO-RANGE
169900                                    (X-MP01-SD)
170000         MOVE MBMPTS-INDICATOR   (X-MBMPTS-INDEX)
170100                                 TO MP01-INDICATOR
170200                                    (X-MP01-SD)
170300         MOVE MBMPTS-SOURCE-DESC (X-MBMPTS-INDEX)
170400                                 TO MP01-DESC
170500                                    (X-MP01-SD)
170600     ELSE
170700         MOVE DFHBMDAS           TO MP01-SOURCE-LP-A
170800                                    (X-MP01-SD)
170900                                    MP01-SOURCE-RP-A
171000                                    (X-MP01-SD)
171100                                    MP01-PRODUCT-LP-A
171200                                    (X-MP01-SD)
171300                                    MP01-PRODUCT-RP-A
171400                                    (X-MP01-SD)
171500                                    MP01-ORG-LP-A
171600                                    (X-MP01-SD)
171700                                    MP01-ORG-RP-A
171800                                    (X-MP01-SD)
171900                                    MP01-LOGO-LP-A
172000                                    (X-MP01-SD)
172100                                    MP01-LOGO-RP-A
172200                                    (X-MP01-SD)
172300                                    MP01-FROM-RANGE-LP-A
172400                                    (X-MP01-SD)
172500                                    MP01-FROM-RANGE-RP-A
172600                                    (X-MP01-SD)
172700                                    MP01-TO-RANGE-LP-A
172800                                    (X-MP01-SD)
172900                                    MP01-TO-RANGE-RP-A
173000                                    (X-MP01-SD)
173100                                    MP01-INDICATOR-LP-A
173200                                    (X-MP01-SD)
173300                                    MP01-INDICATOR-RP-A
173400                                    (X-MP01-SD)
173500                                    MP01-DESC-LP-A
173600                                    (X-MP01-SD)
173700                                    MP01-DESC-RP-A
173800                                    (X-MP01-SD)
173900                                    MP01-SOURCE-A
174000                                    (X-MP01-SD)
174100                                    MP01-PRODUCT-A
174200                                    (X-MP01-SD)
174300                                    MP01-ORG-A
174400                                    (X-MP01-SD)
174500                                    MP01-LOGO-A
174600                                    (X-MP01-SD)
174700                                    MP01-FROM-RANGE-A
174800                                    (X-MP01-SD)
174900                                    MP01-TO-RANGE-A
175000                                    (X-MP01-SD)
175100                                    MP01-INDICATOR-A
175200                                    (X-MP01-SD)
175300                                    MP01-DESC-LIT-A
175400                                    (X-MP01-SD)
175500                                    MP01-DESC-A
175600                                    (X-MP01-SD).
175700*
175800     IF  X-MP01-SD IS LESS THAN +8
175900         SET X-MP01-SD           UP BY +1
176000         GO TO 8800-BUILD-LOOP
176100     ELSE
176200         MOVE MBCA-MBMP-FWD-SEQ  TO WS-FWD-SEQ.
176300*
176400 8899-BS-EXIT.
176500     EXIT.
176600*
176700 8900-LAST-SCREEN.
176800*
176900****************************************************************
177000*    START BROWSE THE PRODUCT FILE                             *
177100****************************************************************
177200*
177300     MOVE 'FC07'                 TO MBCA-PROGRAM-LOCATION.
177400     SET MBIOWS-MMSS-TRAILER     TO TRUE.
177500     MOVE ZEROES                 TO MBIOWS-MMSS-SEQ.
177600     SET MBIORO-STARTBR-GTE      TO TRUE.
177700     PERFORM MMSSAO-ACCESS       THRU MMSSAO-ACCESS-EXIT.
177800*
177900****************************************************************
178000*    READNEXT THE PRODUCT FILE                                 *
178100****************************************************************
178200*
178300     MOVE 'FC08'                 TO MBCA-PROGRAM-LOCATION.
178400     SET MBIORO-READ-SEQ         TO TRUE.
178500     PERFORM MMSSAO-ACCESS       THRU MMSSAO-ACCESS-EXIT.
178600*
178700****************************************************************
178800*    READPREV THE PRODUCT FILE                                 *
178900****************************************************************
179000*
179100     MOVE 'FC09'                 TO MBCA-PROGRAM-LOCATION.
179200     SET MBIORO-READ-PREV        TO TRUE.
179300     PERFORM MMSSAO-ACCESS       THRU MMSSAO-ACCESS-EXIT.
179400*
179500     SET X-MP01-SD               TO +8.
179600     SET WS-BYPASS-NO            TO TRUE.
179700*
179800 8900-READ-PRODUCT-FILE.
179900*
180000****************************************************************
180100*    READPREV THE PRODUCT FILE                                 *
180200****************************************************************
180300*
180400     MOVE 'FC10'                 TO MBCA-PROGRAM-LOCATION.
180500     SET MBIORO-READ-PREV        TO TRUE.
180600     PERFORM MMSSAO-ACCESS       THRU MMSSAO-ACCESS-EXIT.
180700*
180800 8900-BUILD-LOOP.
180900*
181000     IF (MMSS-SEQ IS EQUAL TO ZEROES)
181100     OR (MMSS-SEQ IS EQUAL TO MBCA-MBMP-FIRST-SEQ
181200     AND X-MP01-SD IS GREATER THAN +1)
181300         SET MBCA-MBMP-RETURN-NORMAL
181400                                 TO TRUE
181500         MOVE MBCA-MBMP-FIRST-SEQ
181600                                 TO MBCA-MBMP-FWD-SEQ
181700         SET WS-BYPASS-YES       TO TRUE
181800         GO TO 8900-END-BROWSE.
181900*
182000     PERFORM 9300-BUILD-SCREEN-LINE
182100                                 THRU 9399-BSL-EXIT.
182200*
182300     IF  X-MP01-SD IS GREATER THAN +1
182400         SET X-MP01-SD           DOWN BY +1
182500         GO TO 8900-READ-PRODUCT-FILE
182600     ELSE
182700         MOVE MMSS-SEQ           TO MBCA-MBMP-BACK-SEQ.
182800*
182900 8900-END-BROWSE.
183000*
183100****************************************************************
183200*    END BROWSE THE PRODUCT FILE                               *
183300****************************************************************
183400*
183500     MOVE 'FC11'                 TO MBCA-PROGRAM-LOCATION.
183600     SET MBIORO-ENDBR            TO TRUE.
183700     PERFORM MMSSAO-ACCESS       THRU MMSSAO-ACCESS-EXIT.
183800*
183900     IF  WS-BYPASS-YES
184000         GO TO 8999-LS-EXIT.
184100*
184200     MOVE ZEROES                 TO MBCA-MBMP-FWD-SEQ
184300                                    WS-FWD-SEQ.
184400*
184500 8999-LS-EXIT.
184600     EXIT.
184700*
184800 9000-BACK-SCREEN.
184900*
185000****************************************************************
185100*    START BROWSE THE PRODUCT FILE                             *
185200****************************************************************
185300*
185400     MOVE 'FC12'                 TO MBCA-PROGRAM-LOCATION.
185500     MOVE ZEROES                 TO MBIOWS-MMSS-ORG.
185600     MOVE MBCA-MBMP-FWD-SEQ      TO MBIOWS-MMSS-SEQ.
185700     SET MBIORO-STARTBR-GTE      TO TRUE.
185800     PERFORM MMSSAO-ACCESS       THRU MMSSAO-ACCESS-EXIT.
185900*
186000****************************************************************
186100*    READNEXT THE PRODUCT FILE                                 *
186200****************************************************************
186300*
186400     MOVE 'FC13'                 TO MBCA-PROGRAM-LOCATION.
186500     SET MBIORO-READ-SEQ         TO TRUE.
186600     PERFORM MMSSAO-ACCESS       THRU MMSSAO-ACCESS-EXIT.
186700*
186800****************************************************************
186900*    READPREV THE PRODUCT FILE                                 *
187000****************************************************************
187100*
187200     MOVE 'FC14'                 TO MBCA-PROGRAM-LOCATION.
187300     SET MBIORO-READ-PREV        TO TRUE.
187400     PERFORM MMSSAO-ACCESS       THRU MMSSAO-ACCESS-EXIT.
187500*
187600     SET X-MP01-SD               TO +8.
187700     SET WS-BYPASS-NO            TO TRUE.
187800*
187900 9000-READ-PRODUCT-FILE.
188000*
188100****************************************************************
188200*    READPREV THE PRODUCT FILE                                 *
188300****************************************************************
188400*
188500     MOVE 'FC15'                 TO MBCA-PROGRAM-LOCATION.
188600     SET MBIORO-READ-PREV        TO TRUE.
188700     PERFORM MMSSAO-ACCESS       THRU MMSSAO-ACCESS-EXIT.
188800*
188900 9000-BUILD-LOOP.
189000*
189100     IF (X-MP01-SD IS GREATER THAN +1
189200     AND MMSS-SEQ IS EQUAL TO MBCA-MBMP-FIRST-SEQ)
189300     OR (MMSS-SEQ IS EQUAL TO ZEROES)
189400         SET MBCA-MBMP-RETURN-NORMAL
189500                                 TO TRUE
189600         MOVE MBCA-MBMP-FIRST-SEQ
189700                                 TO MBCA-MBMP-FWD-SEQ
189800         SET WS-BYPASS-YES       TO TRUE
189900         GO TO 9000-END-BROWSE.
190000*
190100     IF  MMSS-SEQ IS EQUAL TO MBCA-MBMP-BACK-SEQ
190200     AND X-MP01-SD IS EQUAL TO +8
190300         GO TO 9000-READ-PRODUCT-FILE.
190400*
190500     PERFORM 9300-BUILD-SCREEN-LINE
190600                                 THRU 9399-BSL-EXIT.
190700*
190800     IF  X-MP01-SD IS EQUAL TO +8
190900         MOVE MMSS-SEQ           TO MBCA-MBMP-FWD-SEQ
191000                                    WS-FWD-SEQ.
191100*
191200     IF  X-MP01-SD IS GREATER THAN +1
191300         SET X-MP01-SD           DOWN BY +1
191400         GO TO 9000-READ-PRODUCT-FILE
191500     ELSE
191600         MOVE MMSS-SEQ           TO MBCA-MBMP-BACK-SEQ.
191700*
191800 9000-END-BROWSE.
191900*
192000****************************************************************
192100*    END BROWSE THE PRODUCT FILE                               *
192200****************************************************************
192300*
192400     MOVE 'FC16'                 TO MBCA-PROGRAM-LOCATION.
192500     SET MBIORO-ENDBR            TO TRUE.
192600     PERFORM MMSSAO-ACCESS       THRU MMSSAO-ACCESS-EXIT.
192700*
192800 9099-BS-EXIT.
192900     EXIT.
193000*
193100 9100-SET-ATTRIBUTE.
193200*
193300     PERFORM
193400         VARYING X-MP01-SD FROM +1 BY +1
193500         UNTIL   X-MP01-SD IS GREATER THAN +8
193600             MOVE DFHBMDAS       TO MP01-SOURCE-LP-A
193700                                    (X-MP01-SD)
193800                                    MP01-SOURCE-RP-A
193900                                    (X-MP01-SD)
194000                                    MP01-PRODUCT-LP-A
194100                                    (X-MP01-SD)
194200                                    MP01-PRODUCT-RP-A
194300                                    (X-MP01-SD)
194400                                    MP01-ORG-LP-A
194500                                    (X-MP01-SD)
194600                                    MP01-ORG-RP-A
194700                                    (X-MP01-SD)
194800                                    MP01-LOGO-LP-A
194900                                    (X-MP01-SD)
195000                                    MP01-LOGO-RP-A
195100                                    (X-MP01-SD)
195200                                    MP01-FROM-RANGE-LP-A
195300                                    (X-MP01-SD)
195400                                    MP01-FROM-RANGE-RP-A
195500                                    (X-MP01-SD)
195600                                    MP01-TO-RANGE-LP-A
195700                                    (X-MP01-SD)
195800                                    MP01-TO-RANGE-RP-A
195900                                    (X-MP01-SD)
196000                                    MP01-INDICATOR-LP-A
196100                                    (X-MP01-SD)
196200                                    MP01-INDICATOR-RP-A
196300                                    (X-MP01-SD)
196400                                    MP01-DESC-LP-A
196500                                    (X-MP01-SD)
196600                                    MP01-DESC-RP-A
196700                                    (X-MP01-SD)
196800             MOVE DFHBMASB       TO MP01-SOURCE-A
196900                                    (X-MP01-SD)
197000                                    MP01-PRODUCT-A
197100                                    (X-MP01-SD)
197200                                    MP01-ORG-A
197300                                    (X-MP01-SD)
197400                                    MP01-LOGO-A
197500                                    (X-MP01-SD)
197600                                    MP01-FROM-RANGE-A
197700                                    (X-MP01-SD)
197800                                    MP01-TO-RANGE-A
197900                                    (X-MP01-SD)
198000                                    MP01-INDICATOR-A
198100                                    (X-MP01-SD)
198200                                    MP01-DESC-A
198300                                    (X-MP01-SD)
198400     END-PERFORM.
198500*
198600 9199-SA-EXIT.
198700     EXIT.
198800*
198900 9200-READ-AHEAD.
199000*
199100****************************************************************
199200*    READNEXT THE PRODUCT FILE                                 *
199300****************************************************************
199400*
199500     MOVE 'FC17'                 TO MBCA-PROGRAM-LOCATION.
199600     SET MBIORO-READ-SEQ         TO TRUE.
199700     PERFORM MMSSAO-ACCESS       THRU MMSSAO-ACCESS-EXIT.
199800*
199900     IF  MMSS-TRAILER
200000         MOVE ZEROES             TO WS-FWD-SEQ
200100                                    MBCA-MBMP-FWD-SEQ
200200         GO TO 9299-RA-EXIT.
200300*
200400     MOVE MMSS-SEQ               TO WS-FWD-SEQ.
200500*
200600 9299-RA-EXIT.
200700     EXIT.
200800*
200900 9300-BUILD-SCREEN-LINE.
201000*
201100     SET X-MBMPTS-INDEX          TO X-MP01-SD.
201200*
201300     MOVE MMSS-SEQ               TO MBMPTS-SEQUENCE
201400                                    (X-MBMPTS-INDEX).
201500*
201600     MOVE MMSS-SOURCE-CODE       TO MP01-SOURCE
201700                                    (X-MP01-SD)
201800                                    MBMPTS-SOURCE-CODE
201900                                    (X-MBMPTS-INDEX).
202000*
202100     MOVE MMSS-SOURCE-DESC       TO MP01-DESC
202200                                    (X-MP01-SD)
202300                                    MBMPTS-SOURCE-DESC
202400                                    (X-MBMPTS-INDEX).
202500*
202600     MOVE MMSS-SOURCE-PRODUCT    TO MP01-PRODUCT
202700                                    (X-MP01-SD)
202800                                    MBMPTS-SOURCE-PROD
202900                                    (X-MBMPTS-INDEX).
203000*
203100     MOVE MMSS-SOURCE-ORG        TO MP01-ORG
203200                                    (X-MP01-SD)
203300                                    MBMPTS-SOURCE-ORG
203400                                    (X-MBMPTS-INDEX).
203500*
203600     MOVE MMSS-SOURCE-LOGO       TO MP01-LOGO
203700                                    (X-MP01-SD)
203800                                    MBMPTS-SOURCE-LOGO
203900                                    (X-MBMPTS-INDEX).
204000*
204100     MOVE MMSS-SOURCE-FROM-PREFIX
204200                                 TO MP01-FROM-RANGE
204300                                    (X-MP01-SD)
204400                                    MBMPTS-FROM-RANGE
204500                                    (X-MBMPTS-INDEX).
204600*
204700     MOVE MMSS-SOURCE-TO-PREFIX  TO MP01-TO-RANGE
204800                                    (X-MP01-SD)
204900                                    MBMPTS-TO-RANGE
205000                                    (X-MBMPTS-INDEX).
205100*
205200     MOVE MMSS-SOURCE-CRITERIA-OPER
205300                                 TO MP01-INDICATOR
205400                                    (X-MP01-SD)
205500                                    MBMPTS-INDICATOR
205600                                    (X-MBMPTS-INDEX).
205700*
205800 9399-BSL-EXIT.
205900     EXIT.
206000*
206100 9400-ADD-RECORD.
206200*
206300****************************************************************
206400*    START BROWSE THE PRODUCT FILE                             *
206500****************************************************************
206600*
206700     MOVE 'FC18'                 TO MBCA-PROGRAM-LOCATION.
206800     SET MBIOWS-MMSS-TRAILER     TO TRUE.
206900     MOVE ZEROES                 TO MBIOWS-MMSS-SEQ.
207000     SET MBIORO-STARTBR-GTE      TO TRUE.
207100     PERFORM MMSSAO-ACCESS       THRU MMSSAO-ACCESS-EXIT.
207200*
207300****************************************************************
207400*    READNEXT THE PRODUCT FILE                                 *
207500****************************************************************
207600*
207700     MOVE 'FC19'                 TO MBCA-PROGRAM-LOCATION.
207800     SET MBIORO-READ-SEQ         TO TRUE.
207900     PERFORM MMSSAO-ACCESS       THRU MMSSAO-ACCESS-EXIT.
208000*
208100****************************************************************
208200*    READPREV THE PRODUCT FILE                                 *
208300****************************************************************
208400*
208500     MOVE 'FC20'                 TO MBCA-PROGRAM-LOCATION.
208600     SET MBIORO-READ-PREV        TO TRUE.
208700     PERFORM MMSSAO-ACCESS       THRU MMSSAO-ACCESS-EXIT.
208800*
208900****************************************************************
209000*    READPREV THE PRODUCT FILE                                 *
209100****************************************************************
209200*
209300     MOVE 'FC21'                 TO MBCA-PROGRAM-LOCATION.
209400     SET MBIORO-READ-PREV        TO TRUE.
209500     PERFORM MMSSAO-ACCESS       THRU MMSSAO-ACCESS-EXIT.
209600*
209700     MOVE MMSS-SEQ               TO WS-HOLD-SEQUENCE.
209800     SET X-MP01-SD               TO +1.
209900*
210000****************************************************************
210100*    END BROWSE THE PLAN TRANSLATION FILE                      *
210200****************************************************************
210300*
210400     MOVE 'FC39'                 TO MBCA-PROGRAM-LOCATION.
210500     SET MBIORO-ENDBR            TO TRUE.
210600     PERFORM MMSSAO-ACCESS       THRU MMSSAO-ACCESS-EXIT.
210700*
210800 9400-LOOP.
210900*
211000     IF  MP01-PRODUCT-L (X-MP01-SD) IS EQUAL TO ZERO
211100     AND MP01-SOURCE-L (X-MP01-SD) IS EQUAL TO ZERO
211200     AND MP01-ORG-L (X-MP01-SD) IS EQUAL TO ZERO
211300     AND MP01-LOGO-L (X-MP01-SD) IS EQUAL TO ZERO
211400     AND MP01-FROM-RANGE-L (X-MP01-SD) IS EQUAL TO ZERO
211500     AND MP01-INDICATOR-L (X-MP01-SD) IS EQUAL TO ZERO
211600     AND MP01-TO-RANGE-L (X-MP01-SD) IS EQUAL TO ZERO
211700     AND MP01-DESC-L (X-MP01-SD) IS EQUAL TO ZERO
211800         SET X-MP01-SD           UP BY +1
211900         IF  X-MP01-SD IS LESS THAN +9
212000             GO TO 9400-LOOP
212100         ELSE
212200             GO TO 9499-AR-EXIT.
212300*
212400     ADD +1                      TO WS-HOLD-SEQUENCE.
212500     MOVE MMSSIR-RECORD          TO MMSS-RECORD.
212600     MOVE WS-HOLD-SEQUENCE       TO MMSS-SEQ.
212700     SET MMSS-REC-ACTIVE         TO TRUE.
212800     SET MMSS-ADD-COMPLETED      TO TRUE.
212900     MOVE MBCA-START-DATE        TO MMSS-LAST-MAINT-DATE.
213000     MOVE MBCA-OPERATOR-ID       TO MMSS-LAST-MAINT-OPER.
213100*
213200     PERFORM 9700-MOVE-FIELDS    THRU 9799-MF-EXIT.
213300*
213400 9400-WRITE-RECORD.
213500*
213600****************************************************************
213700*    WRITE THE PRODUCT FILE RECORD                             *
213800****************************************************************
213900*
214000     MOVE 'FC22'                 TO MBCA-PROGRAM-LOCATION.
214100     MOVE SS08WS-CICS-FC-DUPREC  TO MBIORO-TEMP-STATUS-1.
214200     SET MBIORO-WRITE            TO TRUE.
214300     PERFORM MMSSAO-ACCESS       THRU MMSSAO-ACCESS-EXIT.
214400*
214500     IF  SS08WS-RC-FC-DUPREC
214600         ADD +1                  TO WS-HOLD-SEQUENCE
214700         MOVE WS-HOLD-SEQUENCE   TO MMSS-SEQ
214800         GO TO 9400-WRITE-RECORD.
214900*
215000     MOVE MMSS-ORG               TO MML1-MMSS-ORG.
215100     MOVE MMSS-SEQ               TO MML1-MMSS-SEQ.
215200     MOVE LENGTH OF MMSS-RECORD  TO MML1-VARIABLE-LENGTH.
215300     MOVE MMSS-RECORD            TO MML1-ADD-AREA.
215400*
215500****************************************************************
215600*    WRITE FOR THE LOG/JOURNAL FILE                            *
215700****************************************************************
215800*
215900     MOVE 'FC23'                 TO MBCA-PROGRAM-LOCATION.
216000     SET MBIORO-WRITE            TO TRUE.
216100     PERFORM MML1AO-ACCESS       THRU MML1AO-ACCESS-EXIT.
216200     MOVE SPACES                 TO MML1-VARIABLE-AREA.
216300*
216400     SET X-MP01-SD               UP BY +1
216500*
216600     IF  X-MP01-SD IS LESS THAN +9
216700         GO TO 9400-LOOP.
216800*
216900 9499-AR-EXIT.
217000     EXIT.
217100*
217200 9500-UPDATE-RECORD.
217300*
217400     SET X-MP01-SD               TO +1.
217500*
217600 9500-LOOP.
217700*
217800     IF  MP01-PRODUCT-L (X-MP01-SD) IS EQUAL TO ZERO
217900     AND MP01-SOURCE-L (X-MP01-SD) IS EQUAL TO ZERO
218000     AND MP01-ORG-L (X-MP01-SD) IS EQUAL TO ZERO
218100     AND MP01-LOGO-L (X-MP01-SD) IS EQUAL TO ZERO
218200     AND MP01-FROM-RANGE-L (X-MP01-SD) IS EQUAL TO ZERO
218300     AND MP01-INDICATOR-L (X-MP01-SD) IS EQUAL TO ZERO
218400     AND MP01-TO-RANGE-L (X-MP01-SD) IS EQUAL TO ZERO
218500     AND MP01-DESC-L (X-MP01-SD) IS EQUAL TO ZERO
218600         SET X-MP01-SD           UP BY +1
218700         IF  X-MP01-SD IS LESS THAN +9
218800             GO TO 9500-LOOP
218900         ELSE
219000             GO TO 9599-UR-EXIT.
219100*
219200     SET X-MBMPTS-INDEX          TO X-MP01-SD.
219300*
219400****************************************************************
219500*    READ RANDOM UPDATE THE PRODUCT FILE                      *
219600****************************************************************
219700*
219800     MOVE 'FC24'                 TO MBCA-PROGRAM-LOCATION.
219900     MOVE ZEROES                 TO MBIOWS-MMSS-ORG.
220000     MOVE MBMPTS-SEQUENCE (X-MBMPTS-INDEX)
220100                                 TO MBIOWS-MMSS-SEQ.
220200     SET MBIORO-READ-RANDOM-UPDATE
220300                                 TO TRUE.
220400     PERFORM MMSSAO-ACCESS       THRU MMSSAO-ACCESS-EXIT.
220500*
220600     MOVE MMSS-ORG               TO MML1-MMSS-ORG.
220700     MOVE MMSS-SEQ               TO MML1-MMSS-SEQ.
220800*
220900     IF  MP01-PRODUCT-L (X-MP01-SD) IS GREATER THAN ZERO
221000     AND MP01-PRODUCT (X-MP01-SD) IS GREATER THAN ZERO
221100     AND MMSS-REC-PURGED
221200         SET MMSS-REC-ACTIVE     TO TRUE
221300         MOVE MBCA-START-DATE    TO MMSS-LAST-MAINT-DATE
221400         MOVE MBCA-OPERATOR-ID   TO MMSS-LAST-MAINT-OPER
221500         MOVE LENGTH OF MMSS-RECORD
221600                                 TO MML1-VARIABLE-LENGTH
221700         PERFORM 9700-MOVE-FIELDS
221800                                 THRU 9799-MF-EXIT
221900         MOVE MMSS-RECORD        TO MML1-ADD-AREA
222000         MOVE 0100               TO MML1-FIELD-CODE
222100         MOVE 'FC25'             TO MBCA-PROGRAM-LOCATION
222200         PERFORM 9600-WRITE-LOG-RECORD
222300                                 THRU 9699-WLR-EXIT
222400         GO TO 9560-REWRITE-RECORD.
222500*
222600     IF  MP01-PRODUCT-L (X-MP01-SD) IS GREATER THAN ZERO
222700     AND MP01-PRODUCT (X-MP01-SD) IS EQUAL TO ZERO
222800         MOVE SPACES             TO MP01-SOURCE (X-MP01-SD)
222900         MOVE LENGTH OF MP01-SOURCE (X-MP01-SD)
223000                                 TO MP01-SOURCE-L (X-MP01-SD)
223100         MOVE ZEROES             TO MP01-PRODUCT (X-MP01-SD)
223200         MOVE LENGTH OF MP01-PRODUCT (X-MP01-SD)
223300                                 TO MP01-PRODUCT-L (X-MP01-SD)
223400         MOVE ZEROES             TO MP01-ORG (X-MP01-SD)
223500         MOVE LENGTH OF MP01-ORG (X-MP01-SD)
223600                                 TO MP01-ORG-L (X-MP01-SD)
223700         MOVE ZEROES             TO MP01-LOGO (X-MP01-SD)
223800         MOVE LENGTH OF MP01-LOGO (X-MP01-SD)
223900                                 TO MP01-LOGO-L (X-MP01-SD)
224000         MOVE SPACES             TO MP01-FROM-RANGE (X-MP01-SD)
224100         MOVE LENGTH OF MP01-FROM-RANGE (X-MP01-SD)
224200                                 TO MP01-FROM-RANGE-L (X-MP01-SD)
224300         MOVE SPACES             TO MP01-INDICATOR (X-MP01-SD)
224400         MOVE LENGTH OF MP01-INDICATOR (X-MP01-SD)
224500                                 TO MP01-INDICATOR-L (X-MP01-SD)
224600         MOVE SPACES             TO MP01-TO-RANGE (X-MP01-SD)
224700         MOVE LENGTH OF MP01-TO-RANGE (X-MP01-SD)
224800                                 TO MP01-TO-RANGE-L (X-MP01-SD)
224900         MOVE SPACES             TO MP01-DESC (X-MP01-SD)
225000         MOVE LENGTH OF MP01-DESC (X-MP01-SD)
225100                                 TO MP01-DESC-L (X-MP01-SD)
225200         MOVE 0109               TO MML1-FIELD-CODE
225300         MOVE MML1WS-VL-01       TO MML1-VARIABLE-LENGTH
225400         MOVE MMSS-REC-STATUS    TO MML1-VL01-B-DATA-9
225500         SET MMSS-REC-PURGED     TO TRUE
225600         MOVE MMSS-REC-STATUS    TO MML1-VL01-A-DATA-9
225700         MOVE 'FC26'             TO MBCA-PROGRAM-LOCATION
225800         PERFORM 9600-WRITE-LOG-RECORD
225900                                 THRU 9699-WLR-EXIT.
226000*
226100     IF  MP01-SOURCE-L (X-MP01-SD) IS GREATER THAN ZERO
226200         IF  MP01-SOURCE (X-MP01-SD) IS NOT EQUAL
226300                                 TO MMSS-SOURCE-CODE
226400             MOVE 0101           TO MML1-FIELD-CODE
226500             MOVE MML1WS-VL-05   TO MML1-VARIABLE-LENGTH
226600             MOVE MMSS-SOURCE-CODE
226700                                 TO MML1-VL05-B-DATA-X
226800             MOVE MP01-SOURCE (X-MP01-SD)
226900                                 TO MMSS-SOURCE-CODE
227000             MOVE MMSS-SOURCE-CODE
227100                                 TO MML1-VL05-A-DATA-X
227200             MOVE 'FC27'         TO MBCA-PROGRAM-LOCATION
227300             PERFORM 9600-WRITE-LOG-RECORD
227400                                 THRU 9699-WLR-EXIT.
227500*
227600     IF  MP01-PRODUCT-L (X-MP01-SD) IS GREATER THAN ZERO
227700         IF  MP01-PRODUCT (X-MP01-SD) IS NOT EQUAL
227800                                 TO MMSS-SOURCE-PRODUCT
227900             MOVE 0102           TO MML1-FIELD-CODE
228000             MOVE MML1WS-VL-02   TO MML1-VARIABLE-LENGTH
228100             MOVE MMSS-SOURCE-PRODUCT
228200                                 TO MML1-VL02-B-DATA-9
228300             MOVE MP01-PRODUCT (X-MP01-SD)
228400                                 TO MMSS-SOURCE-PRODUCT
228500             MOVE MMSS-SOURCE-PRODUCT
228600                                 TO MML1-VL02-A-DATA-9
228700             MOVE 'FC28'         TO MBCA-PROGRAM-LOCATION
228800             PERFORM 9600-WRITE-LOG-RECORD
228900                                 THRU 9699-WLR-EXIT.
229000*
229100     IF  MP01-ORG-L (X-MP01-SD) IS GREATER THAN ZERO
229200         IF  MP01-ORG (X-MP01-SD) IS NOT EQUAL
229300                                 TO MMSS-SOURCE-ORG
229400             MOVE 0103           TO MML1-FIELD-CODE
229500             MOVE MML1WS-VL-03   TO MML1-VARIABLE-LENGTH
229600             MOVE MMSS-SOURCE-ORG
229700                                 TO MML1-VL03-B-DATA-9
229800             MOVE MP01-ORG (X-MP01-SD)
229900                                 TO MMSS-SOURCE-ORG
230000             MOVE MMSS-SOURCE-ORG
230100                                 TO MML1-VL03-A-DATA-9
230200             MOVE 'FC29'         TO MBCA-PROGRAM-LOCATION
230300             PERFORM 9600-WRITE-LOG-RECORD
230400                                 THRU 9699-WLR-EXIT.
230500*
230600     IF  MP01-LOGO-L (X-MP01-SD) IS GREATER THAN ZERO
230700         IF  MP01-LOGO (X-MP01-SD) IS NOT EQUAL
230800                                 TO MMSS-SOURCE-LOGO
230900             MOVE 0104           TO MML1-FIELD-CODE
231000             MOVE MML1WS-VL-03   TO MML1-VARIABLE-LENGTH
231100             MOVE MMSS-SOURCE-LOGO
231200                                 TO MML1-VL03-B-DATA-9
231300             MOVE MP01-LOGO (X-MP01-SD)
231400                                 TO MMSS-SOURCE-LOGO
231500             MOVE MMSS-SOURCE-LOGO
231600                                 TO MML1-VL03-A-DATA-9
231700             MOVE 'FC30'         TO MBCA-PROGRAM-LOCATION
231800             PERFORM 9600-WRITE-LOG-RECORD
231900                                 THRU 9699-WLR-EXIT.
232000*
232100     IF  MP01-FROM-RANGE-L (X-MP01-SD) IS GREATER THAN ZERO
232200         IF  MP01-FROM-RANGE (X-MP01-SD) IS NOT EQUAL
232300                                 TO MMSS-SOURCE-FROM-PREFIX
232400             MOVE 0105           TO MML1-FIELD-CODE
232500             MOVE MML1WS-VL-20   TO MML1-VARIABLE-LENGTH
232600             MOVE MMSS-SOURCE-FROM-PREFIX
232700                                 TO MML1-VL20-B-DATA-X
232800             MOVE MP01-FROM-RANGE (X-MP01-SD)
232900                                 TO MMSS-SOURCE-FROM-PREFIX
233000             MOVE MMSS-SOURCE-FROM-PREFIX
233100                                 TO MML1-VL20-A-DATA-X
233200             MOVE 'FC31'         TO MBCA-PROGRAM-LOCATION
233300             PERFORM 9600-WRITE-LOG-RECORD
233400                                 THRU 9699-WLR-EXIT.
233500*
233600     IF  MP01-INDICATOR-L (X-MP01-SD) IS GREATER THAN ZERO
233700         IF  MP01-INDICATOR (X-MP01-SD) IS NOT EQUAL
233800                                 TO MMSS-SOURCE-CRITERIA-OPER
233900             MOVE 0106           TO MML1-FIELD-CODE
234000             MOVE MML1WS-VL-01   TO MML1-VARIABLE-LENGTH
234100             MOVE MMSS-SOURCE-CRITERIA-OPER
234200                                 TO MML1-VL01-B-DATA-X
234300             MOVE MP01-INDICATOR (X-MP01-SD)
234400                                 TO MMSS-SOURCE-CRITERIA-OPER
234500             MOVE MMSS-SOURCE-CRITERIA-OPER
234600                                 TO MML1-VL01-A-DATA-X
234700             MOVE 'FC32'         TO MBCA-PROGRAM-LOCATION
234800             PERFORM 9600-WRITE-LOG-RECORD
234900                                 THRU 9699-WLR-EXIT.
235000*
235100     IF  MP01-TO-RANGE-L (X-MP01-SD) IS GREATER THAN ZERO
235200         IF  MP01-TO-RANGE (X-MP01-SD) IS NOT EQUAL
235300                                 TO MMSS-SOURCE-TO-PREFIX
235400             MOVE 0107           TO MML1-FIELD-CODE
235500             MOVE MML1WS-VL-20   TO MML1-VARIABLE-LENGTH
235600             MOVE MMSS-SOURCE-TO-PREFIX
235700                                 TO MML1-VL20-B-DATA-X
235800             MOVE MP01-TO-RANGE (X-MP01-SD)
235900                                 TO MMSS-SOURCE-TO-PREFIX
236000             MOVE MMSS-SOURCE-TO-PREFIX
236100                                 TO MML1-VL20-A-DATA-X
236200             MOVE 'FC33'         TO MBCA-PROGRAM-LOCATION
236300             PERFORM 9600-WRITE-LOG-RECORD
236400                                 THRU 9699-WLR-EXIT.
236500*
236600     IF  MP01-DESC-L (X-MP01-SD) IS GREATER THAN ZERO
236700         IF  MP01-DESC (X-MP01-SD) IS NOT EQUAL
236800                                 TO MMSS-SOURCE-DESC
236900             MOVE 0108           TO MML1-FIELD-CODE
237000             MOVE MML1WS-VL-20   TO MML1-VARIABLE-LENGTH
237100             MOVE MMSS-SOURCE-DESC
237200                                 TO MML1-VL20-B-DATA-X
237300             MOVE MP01-DESC (X-MP01-SD)
237400                                 TO MMSS-SOURCE-DESC
237500             MOVE MMSS-SOURCE-DESC
237600                                 TO MML1-VL20-A-DATA-X
237700             MOVE 'FC34'         TO MBCA-PROGRAM-LOCATION
237800             PERFORM 9600-WRITE-LOG-RECORD
237900                                 THRU 9699-WLR-EXIT.
238000*
238100     MOVE 0198                   TO MML1-FIELD-CODE.
238200     MOVE MML1WS-VL-03           TO MML1-VARIABLE-LENGTH.
238300     MOVE MMSS-LAST-MAINT-OPER   TO MML1-VL03-B-DATA-X.
238400     MOVE MBCA-OPERATOR-ID       TO MMSS-LAST-MAINT-OPER.
238500     MOVE MMSS-LAST-MAINT-OPER   TO MML1-VL03-A-DATA-X.
238600     MOVE 'FC35'                 TO MBCA-PROGRAM-LOCATION.
238700     PERFORM 9600-WRITE-LOG-RECORD
238800                                 THRU 9699-WLR-EXIT.
238900*
239000     MOVE 0199                   TO MML1-FIELD-CODE.
239100     MOVE MML1WS-VL-07           TO MML1-VARIABLE-LENGTH.
239200     MOVE MMSS-LAST-MAINT-DATE   TO MML1-VL07-B-DATA-9.
239300     MOVE MBCA-START-DATE        TO MMSS-LAST-MAINT-DATE.
239400     MOVE MMSS-LAST-MAINT-DATE   TO MML1-VL07-A-DATA-9.
239500     MOVE 'FC36'                 TO MBCA-PROGRAM-LOCATION.
239600     PERFORM 9600-WRITE-LOG-RECORD
239700                                 THRU 9699-WLR-EXIT.
239800*
239900 9560-REWRITE-RECORD.
240000*
240100****************************************************************
240200*    REWRITE THE PRODUCT FILE RECORD                           *
240300****************************************************************
240400*
240500     MOVE 'FC37'                 TO MBCA-PROGRAM-LOCATION.
240600     SET MBIORO-REWRITE          TO TRUE.
240700     PERFORM MMSSAO-ACCESS       THRU MMSSAO-ACCESS-EXIT.
240800*
240900 9580-SET-INDEX.
241000*
241100     SET X-MP01-SD               UP BY +1.
241200*
241300     IF  X-MP01-SD IS LESS THAN +9
241400         GO TO 9500-LOOP.
241500*
241600 9599-UR-EXIT.
241700     EXIT.
241800*
241900 9600-WRITE-LOG-RECORD.
242000*
242100     SET MBIORO-WRITE            TO TRUE.
242200     PERFORM MML1AO-ACCESS       THRU MML1AO-ACCESS-EXIT.
242300     MOVE SPACES                 TO MML1-VARIABLE-AREA.
242400*
242500 9699-WLR-EXIT.
242600     EXIT.
242700*
242800 9700-MOVE-FIELDS.
242900*
243000     IF  MP01-SOURCE-L (X-MP01-SD) IS GREATER THAN ZERO
243100         MOVE MP01-SOURCE (X-MP01-SD)
243200                                 TO MMSS-SOURCE-CODE.
243300*
243400     IF  MP01-DESC-L (X-MP01-SD) IS GREATER THAN ZERO
243500         MOVE MP01-DESC (X-MP01-SD)
243600                                 TO MMSS-SOURCE-DESC.
243700*
243800     IF  MP01-PRODUCT-L (X-MP01-SD) IS GREATER THAN ZERO
243900         MOVE MP01-PRODUCT (X-MP01-SD)
244000                                 TO MMSS-SOURCE-PRODUCT.
244100*
244200     IF  MP01-ORG-L (X-MP01-SD) IS GREATER THAN ZERO
244300         MOVE MP01-ORG (X-MP01-SD)
244400                                 TO MMSS-SOURCE-ORG.
244500*
244600     IF  MP01-LOGO-L (X-MP01-SD) IS GREATER THAN ZERO
244700         MOVE MP01-LOGO (X-MP01-SD)
244800                                 TO MMSS-SOURCE-LOGO.
244900*
245000     IF  MP01-FROM-RANGE-L (X-MP01-SD) IS GREATER THAN ZERO
245100         MOVE MP01-FROM-RANGE (X-MP01-SD)
245200                                 TO MMSS-SOURCE-FROM-PREFIX.
245300*
245400     IF  MP01-INDICATOR-L (X-MP01-SD) IS GREATER THAN ZERO
245500         MOVE MP01-INDICATOR (X-MP01-SD)
245600                                 TO MMSS-SOURCE-CRITERIA-OPER.
245700*
245800     IF  MP01-TO-RANGE-L (X-MP01-SD) IS GREATER THAN ZERO
245900         MOVE MP01-TO-RANGE (X-MP01-SD)
246000                                 TO MMSS-SOURCE-TO-PREFIX.
246100*
246200 9799-MF-EXIT.
246300     EXIT.
246400*
246500 9800-READ-RECORD.
246600*
246700     IF  MBCA-PTI-FUNCTION-IS-ADD
246800         GO TO 9899-RR-EXIT.
246900*
247000     SET X-MBMPTS-INDEX          TO X-MP01-SD.
247100*
247200     IF  MBMPTS-SEQUENCE (X-MBMPTS-INDEX) IS GREATER THAN ZEROES
247300         MOVE ZEROES             TO MBIOWS-MMSS-ORG
247400         MOVE MBMPTS-SEQUENCE (X-MBMPTS-INDEX)
247500                                 TO MBIOWS-MMSS-SEQ
247600     ELSE
247700         MOVE MMSSIR-RECORD      TO MMSS-RECORD
247800         GO TO 9899-RR-EXIT.
247900*
248000****************************************************************
248100*    READ RANDOM THE PRODUCT FILE RECORD                       *
248200****************************************************************
248300*
248400     MOVE 'FC38'                 TO MBCA-PROGRAM-LOCATION.
248500     SET MBIORO-READ-RANDOM      TO TRUE.
248600     PERFORM MMSSAO-ACCESS       THRU MMSSAO-ACCESS-EXIT.
248700*
248800 9899-RR-EXIT.
248900     EXIT.
249000/    NEW ROUTINE FOR JULIAN TO GREGORIAN CONVERSION
249100     COPY SS26PD.
249200/    ROUTINE TO NUMERICALLY EDIT TIME
249300     COPY SS27PD.
249400/         JULIAN TO GREGORIAN DATE ROUTINE
249500     COPY SS08PD.
249600/         LINE 24 PF KEYS ROUTINE
249700     COPY SS15PD.
249800/         PRODUCT RECORD ACCESS ROUTINES
249900     COPY MMSSAO.
250000/         LOG/JOURNAL ACCESS ROUTINES
250100     COPY MML1AO.
250200/         ON-LINE MAP ROUTINES
250300     COPY MB60PD REPLACING 'MBMAPXX' BY 'MBMP01 '
250400                           MBMAPXXI BY MBMP01I
250500                           MBMAPXXO BY MBMP01O.
250600/         ON-LINE PROCEDURES
250700     COPY MB70PD.
250800/
250900     COPY SMFTPXO.
