000100 IDENTIFICATION DIVISION.
000200 PROGRAM-ID. MBOMQ00.
000201*       RELEASE DATE=08/24/01.        REVISION LEVEL=08.06      *
000202*****************************************************************
000203*WARNING.  THIS COMPUTER PROGRAM IS PROTECTED BY COPYRIGHT LAW  *
000204*AND INTERNATIONAL TREATIES.  UNAUTHORIZED REPRODUCTION OR      *
000205*DISTRIBUTION OF THIS PROGRAM, OR ANY PORTION OF IT, MAY RESULT *
000206*IN SEVERE CIVIL AND CRIMINAL PENATLIES, AND WILL BE PROSECUTED *
000207*TO THE MAXIMUM EXTENT POSSIBLE UNDER THE LAW.                  *
000208*COPYRIGHT 1999 PAYSYS INTERNATIONAL, INC.  ALL RIGHTS RESERVED.*
000209*****************************************************************
000300*****************************************************************
000400*                                                               *
000500*   V - PLUS  M E R C H A N T   B A N K C A R D   S Y S T E M   *
000600*                                                               *
000700*      MBOMQ00 - EXAM MASTER ADD/MAINT/INQ                      *
000800*                LOCATE SCREEN 00                               *
000900*                                                               *
001000*              1. TRANSIDS                                      *
001100*                 A. MBAQ                                       *
001200*                 B. MBMQ                                       *
001300*                 C. MBQQ                                       *
001400*              2. MAPS USED -                                   *
001500*                 A. MBMQ00 (LOCATE MAP)                        *
001600*              3. FILES USED -                                  *
001700*                 A. MMOC (ORG CONTROL FILE)                    *
001800*                 B. MMEX (EXAM MASTER FILE)                    *
001900*                                                               *
002000*****************************************************************
002100*
002200 ENVIRONMENT DIVISION.
002300*
002400 DATA DIVISION.
002500*
002600 WORKING-STORAGE SECTION.
002700*
002800 01  FILLER                  PIC  X(12)      VALUE
002900     '** WS-BEG **'.
003000*
003100 01  FILLER                  PIC  X(14)      VALUE
003200     'MISCELLANEOUS:'.
003300*
003400 01  WS-MISCELLANEOUS.
003500     03  WS-ORG-LOW          PIC S9(03)      COMP-3
003600                                             VALUE +000.
003700     03  WS-ORG-HIGH         PIC S9(03)      COMP-3
003800                                             VALUE +998.
003900     03  WS-MMEX-ADD-PENDING-SW
004000                             PIC  X(01)      VALUE 'N'.
004100         88  MMEX-RECORD-IS-ADD-PENDING      VALUE 'Y'.
004200     03  WS-COPY-SW          PIC  X(01)      VALUE 'N'.
004300         88  WS-COPY-SW-NO                   VALUE 'N'.
004400         88  WS-COPY-SW-YES                  VALUE 'Y'.
004500     03  WS-SELECT-ERROR-SW  PIC  X(01)      VALUE 'N'.
004600         88  WS-SELECT-ERROR-NO              VALUE 'N'.
004700         88  WS-SELECT-ERROR-YES             VALUE 'Y'.
004800     03  WS-ORG-REQUEST.
004900         05  WS-ORG          PIC  9(03)      VALUE ZEROS.
005000         05  WS-REQUEST-NBR  PIC  9(05)      VALUE ZEROS.
005100/
005200 01  FILLER                  PIC  X(29)      VALUE
005300     'I/O REQUEST BLOCK WORK AREAS:'.
005400*
005500     COPY MBIOWS.
005600/
005700 01  FILLER                  PIC  X(18)      VALUE
005800     'I/O REQUEST BLOCK:'.
005900*
006000     COPY MBIORO.
006100/
006200 01  FILLER                  PIC  X(21)      VALUE
006300     'ERROR MESSAGES TABLE:'.
006400*
006500     COPY MBEMWS.
006600/
006700 01  FILLER                  PIC  X(35)      VALUE
006800     'EXAM MASTER INITIALIZER RECORD:'.
006900*
007000     COPY MMEXIR REPLACING ==:MMEX:== BY ==MMEX==.
007100/
007200 01  FILLER                  PIC  X(20)      VALUE
007300     'CCS DATE WORK AREAS:'.
007400*
007500     COPY SS01WS.
007600/
007700 01  FILLER                  PIC  X(27)      VALUE
007800     'CCS CHECK DIGIT WORK AREAS:'.
007900*
008000     COPY SS05WS.
008100/
008200 01  FILLER                  PIC  X(15)      VALUE
008300     'CCS WORK AREAS:'.
008400*
008500     COPY SS08WS.
008600/
008700     COPY SS00WS.
008800/
008900     COPY SMFTWS.
009000/
009100     COPY SMPTRL REPLACING ==:SMPT:== BY ==SMPT==.
009200/
009300     COPY MB61LK.
009400/
009500 01  FILLER                  PIC  X(12)      VALUE
009600     '** WS-END **'.
009700/
009800 LINKAGE SECTION.
009900*
010000 01  DFHCOMMAREA.
010100*
010200     COPY MB60WS.
010300/
010400************************************
010500*    EXAM MASTER LOCATE MAP        *
010600************************************
010700*
010800     COPY MBMQ00.
010900/
011000*************************************************
011100*    EXAM MASTER LOCATE MAP REDEFINITION        *
011200*************************************************
011300*
011400     COPY MBMQ00R.
011500/
011600***************************
011700*    ORG RECORD LAYOUT    *
011800***************************
011900*
012000     COPY MMOCRL.
012100/
012200***************************************
012300*    EXAM MASTER RECORD LAYOUT        *
012400***************************************
012500*
012600     COPY MMEXRL REPLACING ==:MMEX:== BY ==MMEX==.
012700/
012800 PROCEDURE DIVISION.
012900*
013000 A000-HOUSEKEEPING SECTION.
013100*
013200 A020-INIT.
013300*
013400     MOVE 'PC01'                 TO MBCA-PROGRAM-LOCATION.
013500     PERFORM MB70PD-ON-LINE-HOUSEKEEPING
013600                                 THRU MB70PD-OLH-EXIT.
013700*
013800     MOVE 1                      TO MBCA-MBMQ-SEL-INDEX.
013900     MOVE 1                      TO MBCA-MBMQ-TRANS-INDEX.
014000     MOVE 1                      TO MBCA-MBMQ-MAINT-INDEX.
014100     MOVE 'N'                    TO MBCA-MBMQ-COPY-SW.
014200*
014300     IF  MBCA-RECEIVE-SCREEN
014400         GO TO C000-RECEIVE-SCREEN.
014500/
014600 B000-SEND-SCREEN SECTION.
014700*
014800*********************************************
014900*    GET CICS STORAGE NEEDED FOR THE MAP    *
015000*********************************************
015100*
015200     MOVE 'SC01'                 TO MBCA-PROGRAM-LOCATION.
015300     PERFORM MB60PD-GETMAIN-FOR-MAP
015400                                 THRU MB60PD-GFM-EXIT.
015500*
015600     IF  MBCA-PTI-FUNCTION-MAINT-OR-INQ
015700         MOVE DFHBMDAS           TO MQ00-COPY-ORG-LIT-A
015800                                    MQ00-COPY-REQUEST-LIT-A
015900                                    MQ00-COPY-REQUEST-LP-A
016000                                    MQ00-COPY-REQUEST-RP-A
016100                                    MQ00-COPY-ORG-LP-A
016200                                    MQ00-COPY-ORG-RP-A
016300         MOVE DFHBMASK           TO MQ00-COPY-REQUEST-A
016400                                    MQ00-COPY-ORG-A
016500         PERFORM
016600             VARYING X-MQ00-DIR-AREA FROM +1 BY +1
016700             UNTIL   X-MQ00-DIR-AREA IS GREATER THAN +4
016800             MOVE DFHBMASF       TO MQ00-SELECT-SCREEN-NBR-A
016900                                    (X-MQ00-DIR-AREA)
017000         END-PERFORM
017100     ELSE
017200         PERFORM
017300             VARYING X-MQ00-DIR-AREA FROM +1 BY +1
017400             UNTIL   X-MQ00-DIR-AREA IS GREATER THAN +4
017500                 MOVE DFHBMDAS   TO MQ00-SELECT-LP-A
017600                                    (X-MQ00-DIR-AREA)
017700                                    MQ00-SELECT-RP-A
017800                                    (X-MQ00-DIR-AREA)
017900                                    MQ00-SELECT-LIT1-A
018000                                    (X-MQ00-DIR-AREA)
018100                                    MQ00-SELECT-LIT2-A
018200                                    (X-MQ00-DIR-AREA)
018300                                    MQ00-SELECT-SCREEN-NBR-A
018400                                    (X-MQ00-DIR-AREA)
018500                 MOVE DFHBMASK   TO MQ00-SELECT-A
018600                                    (X-MQ00-DIR-AREA)
018700         END-PERFORM.
018800*
018900*****************************************************************
019000*    CHECK KEY CODES                                            *
019100* 1. IF ADD FUNCTION, BYPASS CHECK OF KEY CODES.                *
019200* 2. IF INITIAL KEY CODE, BYPASS CHECK OF KEY CODES.            *
019300* 3. IF MMEX KEY CODE, IT MUST HAVE AN ORGANIZATION NUMBER      *
019400*    GREATER THAN ZERO AND A NUMERIC REQUEST  NUMBER.  IF       *
019500*    DIRECT, GO TO THE RECEIVE EDITING ROUTINE SINCE WE HAVE    *
019600*    PLUGGED THE ORGANIZATION AND REQUEST  IN THE MAP.  IF AN   *
019700*    ERROR OCCURS IN THE RECEIVE SCREEN ROUTINE, IT WILL        *
019800*    HANDLE BUILDING THE MAP AND IT WILL SEND ITS OWN SCREEN.   *
019900*    THIS IS WHY LOCATE PROGRAMS ALWAYS SEND WITH ERASE         *
020000*    NO MATTER WHICH ROUTINE YOU ARE IN.  IF NOT DIRECT, PLUG   *
020100*    THE ORGANIZATION AND REQUEST  INTO THE MAP AND BYPASS      *
020200*    ANY OTHER CHECKING OF THE KEY CODE.                        *
020300* 4. IF 2 AND 3 ARE FALSE, SEE IF THE MBCA-MERCHANT-ORG IS      *
020400*    GREATER THAN ZERO.  IF IT IS, PLUG IT INTO THE MAP.  IF    *
020500*    THE MBCA-REQUEST  IS GREATER THAN ZERO, PLUG IT INTO THE   *
020600*    MAP.                                                       *
020700*****************************************************************
020800*
020900     IF  MBCA-INITIAL-KEY-CODE
021000     OR  MBCA-PTI-FUNCTION-IS-ADD
021100         GO TO B020-BUILD-SCREEN.
021200*
021300     IF  MBCA-MMEX-KEY-CODE
021400         IF  MBCA-MERCHANT-ORG IS NUMERIC
021500         AND MBCA-REQUEST-NBR  IS GREATER THAN ZERO
021600             MOVE MBCA-MERCHANT-ORG
021700                                 TO MQ00-ORG
021800             MOVE MBCA-REQUEST-NBR
021900                                 TO MQ00-REQUEST-NBR
022000             MOVE DFHBMUNF       TO MQ00-ORG-A
022100                                    MQ00-REQUEST-NBR-A
022200             IF  MBCA-DIRECT-TRANSFER-CODE
022300             AND MBCA-INITIAL-SCREEN-NBR
022400                 MOVE 00         TO MBCA-SCREEN-NBR
022500                 GO TO C082-READ-ORG
022600             ELSE
022700                 GO TO B020-BUILD-SCREEN.
022800*
022900     IF  MBCA-VALID-KEY-CODES
023000         IF  MBCA-MERCHANT-ORG IS NUMERIC
023100             MOVE MBCA-MERCHANT-ORG
023200                                 TO MQ00-ORG
023300             MOVE DFHBMUNF       TO MQ00-ORG-A
023400             IF  MBCA-REQUEST-NBR IS GREATER THAN ZERO
023500                 MOVE MBCA-REQUEST-NBR
023600                                 TO MQ00-REQUEST-NBR
023700                 MOVE DFHBMUNF   TO MQ00-REQUEST-NBR-A.
023800*
023900 B020-BUILD-SCREEN.
024000*
024100*******************************************
024200*    INITIALIZE THE STANDARD MAP LINES    *
024300*******************************************
024400*
024500     MOVE SS08WS-CURSOR          TO MQ00-ORG-L.
024600     MOVE 00                     TO MBCA-SCREEN-NBR.
024700     PERFORM MB60PD-INIT-STD-MAP-LINES
024800                                 THRU MB60PD-ISML-EXIT.
024900*
025000     IF  MBCA-PTI-FUNCTION-IS-ADD
025100         MOVE ZERO               TO MQ00-REQUEST-NBR-L
025200         MOVE DFHBMUNN           TO MQ00-REQUEST-NBR-A
025300         MOVE LOW-VALUES         TO MQ00-REQUEST-NBR-X.
025400*
025500*
025600**********************
025700*    SEND THE MAP    *
025800**********************
025900*
026000     MOVE 'BM01'                 TO MBCA-PROGRAM-LOCATION.
026100     PERFORM MB60PD-SEND-MAP-WITH-ERASE
026200                                 THRU MB60PD-SMWE-EXIT.
026300*
026400************************
026500*    RETURN TO CICS    *
026600************************
026700*
026800     MOVE 'PC02'                 TO MBCA-PROGRAM-LOCATION.
026900     PERFORM MB70PD-RETURN-TRANS-ID
027000                                 THRU MB70PD-RTI-EXIT.
027100/
027200 C000-RECEIVE-SCREEN SECTION.
027300*
027400*************************************************
027500*    THIS SECTION RECEIVES THE LOCATE SCREEN    *
027600*************************************************
027700*
027800     MOVE 'BM02'                 TO MBCA-PROGRAM-LOCATION.
027900     PERFORM MB60PD-RECEIVE-MAP  THRU MB60PD-RM-EXIT.
028000*
028100**************************************************************
028200*    CHECK FOR ANOTHER TRANSACTION ID ENTERED BY THE USER    *
028300**************************************************************
028400*
028500     MOVE 'PC03'                 TO MBCA-PROGRAM-LOCATION.
028600     PERFORM MB60PD-NEW-TRANS-ROUTINE
028700                                 THRU MB60PD-NTR-EXIT.
028800*
028900 C020-FIELD-EDITS.
029000*
029100     MOVE MBCA-EIBAID            TO SS08WS-EIBAID.
029200*
029300     IF  (MQ00-ORG-L IS LESS THAN 1
029400     AND  MQ00-REQUEST-NBR-L IS LESS THAN 1
029500     AND  MQ00-COPY-ORG-L IS LESS THAN 1
029600     AND  MQ00-COPY-REQUEST-L IS LESS THAN 1)
029700     AND (SS08WS-VALID-PF-KEY
029800     OR   SS08WS-EIBAID-VALID-PF-KEY)
029900         SET MBCA-INITIAL-SCREEN-NBR
030000                                 TO TRUE
030100         GO TO F090-TRANSFER-XCTL.
030200*
030300******************************************************
030400*    RESET THE FIELD ATTRIBUTES TO THEIR NORMAL      *
030500*    PRIOR STATE PRIOR TO ANY EDITING BEING DONE.    *
030600******************************************************
030700*
030800     MOVE DFHBMUNN               TO MQ00-ORG-A
030900                                    MQ00-REQUEST-NBR-A.
031000     MOVE DFHBMASK               TO MQ00-ORG-LP-A
031100                                    MQ00-ORG-RP-A
031200                                    MQ00-REQUEST-NBR-LP-A
031300                                    MQ00-REQUEST-NBR-RP-A.
031400*
031500     IF  MBCA-PTI-FUNCTION-IS-ADD
031600         MOVE DFHBMUNN           TO MQ00-COPY-REQUEST-A
031700                                    MQ00-COPY-ORG-A
031800         MOVE DFHBMASK           TO MQ00-COPY-REQUEST-LP-A
031900                                    MQ00-COPY-REQUEST-RP-A
032000                                    MQ00-COPY-ORG-LP-A
032100                                    MQ00-COPY-ORG-RP-A
032200         PERFORM
032300             VARYING X-MQ00-DIR-AREA FROM +1 BY +1
032400             UNTIL   X-MQ00-DIR-AREA IS GREATER THAN +4
032500                 MOVE DFHBMDAS   TO MQ00-SELECT-LP-A
032600                                    (X-MQ00-DIR-AREA)
032700                                    MQ00-SELECT-RP-A
032800                                    (X-MQ00-DIR-AREA)
032900                                    MQ00-SELECT-LIT1-A
033000                                    (X-MQ00-DIR-AREA)
033100                                    MQ00-SELECT-LIT2-A
033200                                    (X-MQ00-DIR-AREA)
033300                                    MQ00-SELECT-SCREEN-NBR-A
033400                                    (X-MQ00-DIR-AREA)
033500                 MOVE DFHBMASK   TO MQ00-SELECT-A
033600                                    (X-MQ00-DIR-AREA)
033700         END-PERFORM
033800     ELSE
033900         MOVE DFHBMDAS           TO MQ00-COPY-REQUEST-LIT-A
034000                                    MQ00-COPY-REQUEST-LIT-A
034100                                    MQ00-COPY-REQUEST-LP-A
034200                                    MQ00-COPY-REQUEST-RP-A
034300                                    MQ00-COPY-ORG-LP-A
034400                                    MQ00-COPY-ORG-RP-A
034500         MOVE DFHBMASK           TO MQ00-COPY-REQUEST-A
034600                                    MQ00-COPY-ORG-A.
034700*
034800 C080-EDIT-ORG.
034900*
035000     IF  MQ00-ORG-L IS EQUAL TO ZERO
035100     OR  MQ00-ORG IS NOT NUMERIC
035200     OR  MQ00-ORG IS LESS THAN MBCA-ORG-LOW
035300     OR  MQ00-ORG IS GREATER THAN MBCA-ORG-HIGH
035400     OR  MQ00-ORG IS LESS THAN WS-ORG-LOW
035500     OR  MQ00-ORG IS GREATER THAN WS-ORG-HIGH
035600         MOVE MBEMWS-INVALID-ORG TO MQ00-ERR-MESSAGE
035700         GO TO C098-ORG-ERROR.
035800*
035900 C082-READ-ORG.
036000*
036100************************************************
036200*    READ THE ORGANIZATION RECORD.  IT MUST    *
036300*    BE ON FILE AND AN ACTIVE RECORD.          *
036400************************************************
036500*
036600     IF  MQ00-ORG IS EQUAL TO ZEROS
036700         MOVE MQ00-ORG           TO MBCA-MERCHANT-ORG
036800         MOVE DFHBMUNF           TO MQ00-ORG-A
036900         GO TO C100-EDIT-REQUEST.
037000*
037100     MOVE MQ00-ORG               TO MBIOWS-MMOC-ORG.
037200     MOVE 'FC01'                 TO MBCA-PROGRAM-LOCATION.
037300     MOVE SS08WS-CICS-FC-NOTFND  TO MBIORO-TEMP-STATUS-1.
037400     SET MBIORO-READ-RANDOM      TO TRUE.
037500     PERFORM MMOCAO-ACCESS       THRU MMOCAO-ACCESS-EXIT.
037600*
037700     IF  SS08WS-RC-FC-NOTFND
037800         MOVE MBEMWS-NOT-ON-FILE TO MQ00-ERR-MESSAGE
037900     ELSE
038000         IF  MMOC-ADD-PENDING
038100             MOVE MBEMWS-ADD-PENDING
038200                                 TO MQ00-ERR-MESSAGE
038300         ELSE
038400             IF  MMOC-REC-PURGED
038500                 MOVE MBEMWS-NOT-ACTIVE
038600                                 TO MQ00-ERR-MESSAGE
038700             ELSE
038800                 MOVE DFHBMUNF   TO MQ00-ORG-A
038900                 MOVE MQ00-ORG   TO MBCA-MERCHANT-ORG
039000                 GO TO C100-EDIT-REQUEST.
039100*
039200 C098-ORG-ERROR.
039300*
039400     SET SS08WS-ERROR-SW-YES     TO TRUE.
039500     MOVE DFHBMASB               TO MQ00-ORG-LP-A
039600                                    MQ00-ORG-RP-A.
039700     MOVE SS08WS-CURSOR          TO MQ00-ORG-L.
039800     MOVE DFHBMNBF               TO MQ00-ORG-A.
039900     MOVE DFHBMUNF               TO MQ00-REQUEST-NBR-A.
040000     GO TO C120-EDIT-COPY-ORG.
040100*
040200 C100-EDIT-REQUEST.
040300*
040400     IF  MBCA-DIRECT-TRANSFER-CODE
040500     AND
040600        (MBCA-PTI-FUNCTION-IS-MAINT
040700     OR  MBCA-PTI-FUNCTION-IS-INQUIRY)
040800         GO TO C102-READ-REQUEST.
040900*
041000     IF  MQ00-REQUEST-NBR-L IS EQUAL TO ZERO
041100     AND MBCA-PTI-FUNCTION-IS-ADD
041200         MOVE MQ00-ORG           TO WS-ORG
041300         MOVE 1                  TO WS-REQUEST-NBR
041400         PERFORM Y200-AUTO-ADD-REQUEST
041500                                 THRU Y299-AAR-EXIT.
041600*
041700     IF  MQ00-REQUEST-NBR IS NOT NUMERIC
041800     OR  MQ00-REQUEST-NBR IS EQUAL TO ZEROES OR 99999
041900         MOVE MBEMWS-INVALID-REQUEST-NBR
042000                                 TO MQ00-ERR-MESSAGE
042100         GO TO C118-REQUEST-ERROR.
042200*
042300 C102-READ-REQUEST.
042400*
042500***************************************************************
042600*    READ THE EXAM MASTER RECORD.      IT MUST BE ON          *
042700*    FILE AND AN ACTIVE RECORD IF IN MAINTENANCE OR INQUIRY.  *
042800*    IT MUST NOT BE ON FILE (OR IN AN ADD PENDING STATE),     *
042900*    IF IN ADD.                                               *
043000***************************************************************
043100*
043200     MOVE DFHBMUNF               TO MQ00-REQUEST-NBR-A.
043300*
043400     MOVE MQ00-ORG               TO MBIOWS-MMEX-ORG.
043500     MOVE MQ00-REQUEST-NBR       TO MBIOWS-MMEX-REQUEST-NBR.
043600     MOVE SS08WS-CICS-FC-NOTFND  TO MBIORO-TEMP-STATUS-1.
043700     MOVE 'FC02'                 TO MBCA-PROGRAM-LOCATION.
043800     SET MBIORO-READ-RANDOM      TO TRUE.
043900     PERFORM MMEXAO-ACCESS       THRU MMEXAO-ACCESS-EXIT.
044000*
044100     IF  SS08WS-RC-FC-VALID-RTN-CODE
044200         MOVE MQ00-REQUEST-NBR   TO MBCA-REQUEST-NBR.
044300*
044400     IF  MBCA-PTI-FUNCTION-IS-INQUIRY
044500         IF  SS08WS-RC-FC-VALID-RTN-CODE
044600             IF  MMEX-ADD-PENDING
044700                 MOVE MBEMWS-ADD-PENDING
044800                                 TO MQ00-ERR-MESSAGE
044900                 GO TO C118-REQUEST-ERROR
045000             ELSE
045100                 GO TO C120-EDIT-COPY-ORG
045200         ELSE
045300             MOVE MBEMWS-NOT-ON-FILE
045400                                 TO MQ00-ERR-MESSAGE
045500             GO TO C118-REQUEST-ERROR.
045600*
045700     IF  MBCA-PTI-FUNCTION-IS-ADD
045800     AND SS08WS-RC-FC-NOTFND
045900         GO TO C120-EDIT-COPY-ORG.
046000*
046100     IF  MBCA-PTI-FUNCTION-IS-ADD
046200     AND MMEX-ADD-PENDING
046300         IF  WS-COPY-SW-NO
046400             MOVE MMEX-ONLINE-STATUS
046500                                 TO MBCA-SCREEN-NBR
046600             SET MMEX-RECORD-IS-ADD-PENDING
046700                                 TO TRUE
046800             GO TO C120-EDIT-COPY-ORG
046900         ELSE
047000             MOVE MBEMWS-ADD-PENDING
047100                                 TO MQ00-ERR-MESSAGE
047200             GO TO C118-REQUEST-ERROR.
047300*
047400     IF  MBCA-PTI-FUNCTION-IS-ADD
047500         MOVE MBEMWS-ALREADY-ON-FILE
047600                                 TO MQ00-ERR-MESSAGE
047700         GO TO C118-REQUEST-ERROR.
047800*
047900     IF  MBCA-PTI-FUNCTION-IS-MAINT
048000     AND SS08WS-RC-FC-NOTFND
048100         MOVE MBEMWS-NOT-ON-FILE TO MQ00-ERR-MESSAGE
048200         GO TO C118-REQUEST-ERROR.
048300*
048400     IF  MBCA-PTI-FUNCTION-IS-MAINT
048500     AND MMEX-ADD-PENDING
048600         MOVE MBEMWS-ADD-PENDING TO MQ00-ERR-MESSAGE
048700         GO TO C118-REQUEST-ERROR.
048800*
048900************************************************
049000*    OTHERWISE, WE PASSED THE REQUEST EDIT     *
049100************************************************
049200*
049300     GO TO C120-EDIT-COPY-ORG.
049400*
049500 C118-REQUEST-ERROR.
049600*
049700     SET SS08WS-ERROR-SW-YES     TO TRUE.
049800     MOVE DFHBMASB               TO MQ00-REQUEST-NBR-LP-A
049900                                    MQ00-REQUEST-NBR-RP-A.
050000     MOVE SS08WS-CURSOR          TO MQ00-REQUEST-NBR-L.
050100     MOVE DFHBMNBF               TO MQ00-REQUEST-NBR-A.
050200*
050300 C120-EDIT-COPY-ORG.
050400*
050500************************************************
050600*    BYPASS THE COPY EDITS IF THE              *
050700*    COPY REQUEST WAS NOT ENTERED              *
050800************************************************
050900*
051000     IF  MQ00-COPY-ORG-L IS EQUAL TO ZERO
051100     AND MQ00-COPY-REQUEST-L IS EQUAL TO ZERO
051200         GO TO C150-EDIT-SELECT.
051300*
051400     IF  MQ00-COPY-ORG-L IS EQUAL TO ZERO
051500     OR  MQ00-COPY-ORG IS NOT NUMERIC
051600     OR  MQ00-COPY-ORG IS LESS THAN MBCA-ORG-LOW
051700     OR  MQ00-COPY-ORG IS GREATER THAN MBCA-ORG-HIGH
051800     OR  MQ00-COPY-ORG IS LESS THAN WS-ORG-LOW
051900     OR  MQ00-COPY-ORG IS GREATER THAN WS-ORG-HIGH
052000         MOVE MBEMWS-INVALID-ORG TO MQ00-ERR-MESSAGE
052100         GO TO C127-COPY-ORG-ERROR.
052200*
052300 C125-READ-ORG.
052400*
052500************************************************
052600*    READ THE ORGANIZATION RECORD.  IT MUST    *
052700*    BE ON FILE AND AN ACTIVE RECORD.          *
052800************************************************
052900*
053000     IF  MQ00-COPY-ORG IS EQUAL TO ZEROS
053100         MOVE DFHBMUNF           TO MQ00-COPY-ORG-A
053200         GO TO C130-EDIT-COPY-REQUEST.
053300*
053400     MOVE MQ00-COPY-ORG          TO MBIOWS-MMOC-ORG.
053500     MOVE 'FC03'                 TO MBCA-PROGRAM-LOCATION.
053600     MOVE SS08WS-CICS-FC-NOTFND  TO MBIORO-TEMP-STATUS-1.
053700     SET MBIORO-READ-RANDOM      TO TRUE.
053800     PERFORM MMOCAO-ACCESS       THRU MMOCAO-ACCESS-EXIT.
053900*
054000     IF  SS08WS-RC-FC-NOTFND
054100         MOVE MBEMWS-NOT-ON-FILE TO MQ00-ERR-MESSAGE
054200     ELSE
054300         IF  MMOC-ADD-PENDING
054400             MOVE MBEMWS-ADD-PENDING
054500                                 TO MQ00-ERR-MESSAGE
054600         ELSE
054700             IF  MMOC-REC-PURGED
054800                 MOVE MBEMWS-NOT-ACTIVE
054900                                 TO MQ00-ERR-MESSAGE
055000             ELSE
055100                 MOVE DFHBMUNF   TO MQ00-COPY-ORG-A
055200                 GO TO C130-EDIT-COPY-REQUEST.
055300*
055400 C127-COPY-ORG-ERROR.
055500*
055600     SET SS08WS-ERROR-SW-YES     TO TRUE.
055700     MOVE DFHBMASB               TO MQ00-COPY-ORG-LP-A
055800                                    MQ00-COPY-ORG-RP-A.
055900     MOVE SS08WS-CURSOR          TO MQ00-COPY-ORG-L.
056000     MOVE DFHBMNBF               TO MQ00-COPY-ORG-A.
056100     MOVE DFHBMUNF               TO MQ00-REQUEST-NBR-A.
056200*
056300 C130-EDIT-COPY-REQUEST.
056400*
056500*
056600     IF  MQ00-COPY-REQUEST-L IS EQUAL TO ZERO
056700     OR  MQ00-COPY-REQUEST IS NOT NUMERIC
056800     OR  MQ00-COPY-REQUEST IS EQUAL TO ZEROES OR 99999
056900         MOVE MBEMWS-INVALID-REQUEST-NBR
057000                                 TO MQ00-ERR-MESSAGE
057100         GO TO C135-COPY-REQUEST-ERROR.
057200*
057300     MOVE DFHBMUNF               TO MQ00-COPY-REQUEST-A.
057400*
057500     IF  MQ00-ORG-L IS EQUAL TO SS08WS-CURSOR
057600         GO TO C150-EDIT-SELECT.
057700*
057800*****************************************************************
057900*    READ THE EXAM MASTER FILE TO ENSURE THAT THE REQUEST       *
058000*    RECORD TO BE COPIED IS ON FILE AND AN ACTIVE RECORD        *
058100*****************************************************************
058200*
058300     MOVE MQ00-COPY-ORG          TO MBIOWS-MMEX-ORG.
058400     MOVE MQ00-COPY-REQUEST      TO MBIOWS-MMEX-REQUEST-NBR.
058500     MOVE SS08WS-CICS-FC-NOTFND  TO MBIORO-TEMP-STATUS-1.
058600     MOVE 'FC04'                 TO MBCA-PROGRAM-LOCATION.
058700     SET MBIORO-READ-RANDOM      TO TRUE.
058800     PERFORM MMEXAO-ACCESS       THRU MMEXAO-ACCESS-EXIT.
058900*
059000     IF  SS08WS-RC-FC-NOTFND
059100         MOVE MBEMWS-NOT-ON-FILE TO MQ00-ERR-MESSAGE
059200     ELSE
059300         IF  MMEX-ADD-PENDING
059400             MOVE MBEMWS-ADD-PENDING
059500                                 TO MQ00-ERR-MESSAGE
059600         ELSE
059700             IF  MMEX-STATUS-INCOMPLETE
059800             OR  MMEX-STATUS-PURGE
059900                 MOVE MBEMWS-NOT-ACTIVE
060000                                 TO MQ00-ERR-MESSAGE
060100             ELSE
060200                 SET WS-COPY-SW-YES
060300                                 TO TRUE
060400                 MOVE DFHBMUNF   TO MQ00-COPY-REQUEST-A
060500                 GO TO C150-EDIT-SELECT.
060600*
060700 C135-COPY-REQUEST-ERROR.
060800*
060900     SET SS08WS-ERROR-SW-YES     TO TRUE.
061000     MOVE DFHBMASB               TO MQ00-COPY-REQUEST-LP-A
061100                                    MQ00-COPY-REQUEST-RP-A.
061200     MOVE SS08WS-CURSOR          TO MQ00-COPY-REQUEST-L.
061300     MOVE DFHBMNBF               TO MQ00-COPY-REQUEST-A.
061400     MOVE DFHBMUNF               TO MQ00-ORG-A
061500                                    MQ00-REQUEST-NBR-A.
061600*
061700 C150-EDIT-SELECT.
061800*
061900     IF  MBCA-PTI-FUNCTION-MAINT-OR-INQ
062000         PERFORM
062100             VARYING X-MQ00-DIR-AREA FROM +1 BY +1
062200             UNTIL   X-MQ00-DIR-AREA IS GREATER THAN +4
062300             MOVE DFHBMASF       TO MQ00-SELECT-SCREEN-NBR-A
062400                                    (X-MQ00-DIR-AREA)
062500         END-PERFORM.
062600*
062700     IF  MBCA-PTI-FUNCTION-MAINT-OR-INQ
062800         PERFORM Y100-EDIT-SELECT
062900                                 THRU Y199-ES-EXIT
063000             VARYING X-MQ00-DIR-AREA FROM +1 BY +1
063100             UNTIL   X-MQ00-DIR-AREA IS GREATER THAN +4.
063200/
063300 D000-RETURN-ERRORS SECTION.
063400*
063500     IF  SS08WS-ERROR-SW-NO
063600         GO TO E000-UPDATE-FILE
063700     ELSE
063800         IF  SS08WS-VALID-PF-KEY
063900         OR  SS08WS-EIBAID-VALID-PF-KEY
064000             SET MBCA-INITIAL-SCREEN-NBR
064100                                 TO TRUE
064200             GO TO F090-TRANSFER-XCTL.
064300*
064400***************************************************************
064500*    INITIALIZE THE STANDARD MAP LINES.  IN AN ERROR          *
064600*    CONDITION, THIS ROUTINE IS PERFORMED PRIMARILY           *
064700*    TO UPDATE THE DATE AND TIME ON THE SCREEN.               *
064800***************************************************************
064900*
065000     PERFORM MB60PD-INIT-STD-MAP-LINES
065100                                 THRU MB60PD-ISML-EXIT.
065200*
065300**********************
065400*    SEND THE MAP    *
065500**********************
065600*
065700     MOVE 'BM03'                 TO MBCA-PROGRAM-LOCATION.
065800     PERFORM MB60PD-SEND-MAP-WITH-ERASE
065900                                 THRU MB60PD-SMWE-EXIT.
066000*
066100************************
066200*    RETURN TO CICS    *
066300************************
066400*
066500     MOVE 'PC04'                 TO MBCA-PROGRAM-LOCATION.
066600     PERFORM MB70PD-RETURN-TRANS-ID
066700                                 THRU MB70PD-RTI-EXIT.
066800/
066900 E000-UPDATE-FILE SECTION.
067000*
067100*************************************************
067200*    GO TO THE PROPER SECTION OF THE PROGRAM    *
067300*    DEPENDING ON THE FUNCTION BEING DONE       *
067400*************************************************
067500*
067600     IF  MBCA-PTI-FUNCTION-MAINT-OR-INQ
067700         GO TO F000-SETUP-COMMAREA.
067800*
067900**********************************
068000*    THIS IS THE ADD FUNCTION    *
068100**********************************
068200*
068300     IF  MMEX-RECORD-IS-ADD-PENDING
068400         GO TO F000-SETUP-COMMAREA.
068500*
068600*************************************************
068700*    WRITE THE NEW REQUEST RECORD FROM THE      *
068800*    INITIALIZED VALUES OR FROM THE REQUEST     *
068900*    RECORD THAT IS BEING COPIED.               *
069000*************************************************
069100*
069200     IF  WS-COPY-SW-YES
069300         GO TO E040-COPY-ADD.
069400*
069500 E020-ADD-NEW-RECORD.
069600*
069700*********************************************************
069800*    SET UP THE RECORD.  USE THE INITIALIZER RECORD     *
069900*    (MMEXIR) AS THE FIELD DEFAULTS.  CERTAIN FIELDS    *
070000*    FROM THE ORG ARE USED AS THE REQUEST DEFAULTS.     *
070100*********************************************************
070200*
070300     MOVE MMEXIR-RECORD          TO MMEX-RECORD.
070400     MOVE MQ00-ORG               TO MMEX-ORG.
070500     MOVE MQ00-REQUEST-NBR       TO MMEX-REQUEST-NBR.
070600     MOVE MBCA-START-DATE        TO MMEX-LAST-MAINT-DATE.
070700     MOVE MBCA-OPERATOR-ID       TO MMEX-LAST-MAINT-OPER.
070800*
070900     GO TO E060-WRITE-MMEX.
071000*
071100 E040-COPY-ADD.
071200*
071300**************************************************
071400*    RE-READ THE REQUEST RECORD TO BE COPIED     *
071500**************************************************
071600*
071700     MOVE MQ00-COPY-ORG          TO MBIOWS-MMEX-ORG.
071800     MOVE MQ00-COPY-REQUEST      TO MBIOWS-MMEX-REQUEST-NBR.
071900     MOVE 'FC06'                 TO MBCA-PROGRAM-LOCATION.
072000     SET MBIORO-READ-RANDOM      TO TRUE.
072100     PERFORM MMEXAO-ACCESS       THRU MMEXAO-ACCESS-EXIT.
072200*
072300     MOVE MQ00-ORG               TO MMEX-ORG.
072400     MOVE MQ00-REQUEST-NBR       TO MMEX-REQUEST-NBR.
072500     MOVE MMEXIR-STATUS-INFORMATION
072600                                 TO MMEX-STATUS-INFORMATION.
072700     MOVE MMEXIR-RUN-TIME-DATA   TO MMEX-RUN-TIME-DATA.
072800     MOVE 'Y'                    TO MBCA-MBMQ-COPY-SW.
072900*
073000 E060-WRITE-MMEX.
073100*
073200     MOVE 'FC07'                 TO MBCA-PROGRAM-LOCATION.
073300     SET MBIORO-WRITE            TO TRUE.
073400     PERFORM MMEXAO-ACCESS       THRU MMEXAO-ACCESS-EXIT.
073500*
073600     MOVE MQ00-REQUEST-NBR       TO MBCA-REQUEST-NBR.
073700/
073800 F000-SETUP-COMMAREA SECTION.
073900*
074000***************************************************************
074100*  SET UP COMMAREA FIELDS AND TRANSFER TO THE NEXT PROGRAM    *
074200***************************************************************
074300*
074400     MOVE MBCA-EIBAID            TO SS08WS-EIBAID.
074500*
074600     MOVE MBIOWS-MMEX-DIRECT-KEY-CODE
074700                                 TO MBCA-KEY-CODE.
074800*
074900     PERFORM MB60PD-EDIT-PAGE-NBR
075000                                 THRU MB60PD-EPN-EXIT.
075100*
075200     IF  SS08WS-VALID-PF-KEY
075300     OR  SS08WS-EIBAID-VALID-PF-KEY
075400         SET MBCA-INITIAL-SCREEN-NBR
075500                                 TO TRUE.
075600*
075700 F090-TRANSFER-XCTL.
075800*
075900     MOVE 'PC05'                 TO MBCA-PROGRAM-LOCATION.
076000     PERFORM MB70PD-XCTL-TO-MBOXCTL
076100                                 THRU MB70PD-XTM-EXIT.
076200/
076300 Y000-PERFORMED-ROUTINES SECTION.
076400*
076500 Y100-EDIT-SELECT.
076600*
076700     IF  MQ00-SELECT-L (X-MQ00-DIR-AREA) IS LESS THAN 1
076800         GO TO Y199-ES-EXIT.
076900*
077000     IF  MQ00-SELECT-L (X-MQ00-DIR-AREA) IS GREATER THAN ZERO
077100         IF  MQ00-SELECT-VALID (X-MQ00-DIR-AREA)
077200             MOVE MQ00-SELECT-SCREEN-NBR (X-MQ00-DIR-AREA)
077300                                 TO TTN0162I
077400                                    MBCA-CARD-PROD
077500             MOVE +2             TO TTN0162L
077600             MOVE DFHBMFSE       TO MQ00-SELECT-A
077700                                    (X-MQ00-DIR-AREA)
077800             SET X-MQ00-DIR-AREA TO +4
077900         ELSE
078000             SET SS08WS-ERROR-SW-YES TO TRUE
078100             MOVE DFHBMASB       TO MQ00-SELECT-LP-A
078200                                    (X-MQ00-DIR-AREA)
078300                                    MQ00-SELECT-RP-A
078400                                    (X-MQ00-DIR-AREA)
078500             MOVE DFHBMUBF       TO MQ00-SELECT-A
078600                                    (X-MQ00-DIR-AREA)
078700             MOVE SS08WS-CURSOR  TO MQ00-SELECT-L
078800                                    (X-MQ00-DIR-AREA).
078900*
079000 Y199-ES-EXIT.
079100     EXIT.
079200*
079300 Y200-AUTO-ADD-REQUEST.
079400*
079500     MOVE MQ00-ORG               TO MBIOWS-MMEX-ORG.
079600     MOVE WS-REQUEST-NBR         TO MBIOWS-MMEX-REQUEST-NBR.
079700     MOVE 'FC08'                 TO MBCA-PROGRAM-LOCATION.
079800     MOVE SS08WS-CICS-FC-NOTFND  TO MBIORO-TEMP-STATUS-1.
079900     SET MBIORO-STARTBR-GTE      TO TRUE.
080000     PERFORM MMEXAO-ACCESS       THRU MMEXAO-ACCESS-EXIT.
080100*
080200     IF  SS08WS-RC-FC-NOTFND
080300         SET SS08WS-ERROR-SW-YES     TO TRUE
080400         GO TO Y299-AAR-EXIT.
080500*
080600 Y205-READ-MMEX.
080700*
080800     MOVE 'FC09'                 TO MBCA-PROGRAM-LOCATION.
080900     SET MBIORO-READ-SEQ         TO TRUE.
081000     PERFORM MMEXAO-ACCESS       THRU MMEXAO-ACCESS-EXIT.
081100*
081200     IF  MMEX-ORG IS EQUAL TO WS-ORG
081300     AND MMEX-REQUEST-NBR IS EQUAL TO WS-REQUEST-NBR
081400         ADD 1                   TO WS-REQUEST-NBR
081500         GO TO Y205-READ-MMEX
081600     ELSE
081700         MOVE WS-REQUEST-NBR     TO MQ00-REQUEST-NBR
081800         MOVE +5                 TO MQ00-REQUEST-NBR-L.
081900*
082000****************************************************************
082100*    END BROWSE THE EXAM FILE                                  *
082200****************************************************************
082300*
082400     MOVE 'FC10'                 TO MBCA-PROGRAM-LOCATION.
082500     SET MBIORO-ENDBR            TO TRUE.
082600     PERFORM MMEXAO-ACCESS       THRU MMEXAO-ACCESS-EXIT.
082700*
082800 Y299-AAR-EXIT.
082900     EXIT.
083000*
083100/
083200 Z000-COPIED-ROUTINES SECTION.
083300*
083400*****************************
083500*    FUTURE DATE ROUTINE    *
083600*****************************
083700*
083800     COPY SS03PD.
083900/
084000**********************************
084100*    GREG TO JUL DATE ROUTINE    *
084200**********************************
084300*
084400     COPY SS07PD.
084500*
084600/    NEW ROUTINE FOR JULIAN TO GREGORIAN CONVERSION
084700     COPY SS26PD.
084800/    ROUTINE TO NUMERICALLY EDIT TIME
084900     COPY SS27PD.
085000**********************************
085100*    JUL TO GREG DATE ROUTINE    *
085200**********************************
085300*
085400     COPY SS08PD.
085500/
085600*****************************
085700*    CHECK DIGIT ROUITNE    *
085800*****************************
085900*
086000     COPY SS09PD.
086100/
086200*********************************
086300*    LINE 24 PF KEYS ROUTINE    *
086400*********************************
086500*
086600     COPY SS15PD.
086700/
086800*******************************************
086900*    ORG FILE RECORD 1 ACCESS ROUTINES    *
087000*******************************************
087100*
087200     COPY MMOCAO.
087300/
087400*********************************************
087500*    EXAM MASTER RECORD ACCESS ROUTINES *
087600*********************************************
087700*
087800     COPY MMEXAO.
087900/
088000*****************************
088100*    ONLINE MAP ROUTINES    *
088200*****************************
088300*
088400     COPY MB60PD REPLACING 'MBMAPXX' BY 'MBMQ00 '
088500                           MBMAPXXI BY MBMQ00I
088600                           MBMAPXXO BY MBMQ00O.
088700/
088800***************************
088900*    ONLINE PROCEDURES    *
089000***************************
089100*
089200     COPY MB70PD.
089300/
089400     COPY SMFTPXO.
