000100 IDENTIFICATION DIVISION.
000200 PROGRAM-ID. MBOMQ03.
000201*       RELEASE DATE=08/24/01.        REVISION LEVEL=08.06      *
000202*****************************************************************
000203*WARNING.  THIS COMPUTER PROGRAM IS PROTECTED BY COPYRIGHT LAW  *
000204*AND INTERNATIONAL TREATIES.  UNAUTHORIZED REPRODUCTION OR      *
000205*DISTRIBUTION OF THIS PROGRAM, OR ANY PORTION OF IT, MAY RESULT *
000206*IN SEVERE CIVIL AND CRIMINAL PENATLIES, AND WILL BE PROSECUTED *
000207*TO THE MAXIMUM EXTENT POSSIBLE UNDER THE LAW.                  *
000208*COPYRIGHT 1999 PAYSYS INTERNATIONAL, INC.  ALL RIGHTS RESERVED.*
000209*****************************************************************
000300*****************************************************************
000400*                                                               *
000500*   V - PLUS  M E R C H A N T   B A N K C A R D   S Y S T E M   *
000600*                                                               *
000700*      MBOMQ03 - EXAM MASTER FILE ADD/MAINTENANCE/INQUIRY       *
000800*                SCREENS 03                                     *
000900*                                                               *
001000*              1. TRANSIDS                                      *
001100*                 A. MBAQ                                       *
001200*                 B. MBMQ                                       *
001300*                 C. MBQQ                                       *
001400*              2. MAPS USED -                                   *
001500*                 A. MBMQ03 (SCREENS 03)                        *
001600*              3. FILES USED -                                  *
001700*                 A. MMEX   (EXAM FILE)                         *
001800*                 B. MML1   (LOG FILE)                          *
001900*                                                               *
002000*****************************************************************
002100*
002200 ENVIRONMENT DIVISION.
002300 DATA DIVISION.
002400 WORKING-STORAGE SECTION.
002500 01  FILLER                  PIC  X(12)      VALUE '** WS-BEG **'.
002600*         I/O REQUEST BLOCK WORK AREAS
002700     COPY MBIOWS.
002800/         I/O REQUEST BLOCK
002900     COPY MBIORO.
003000/         LOG/JOURNAL WORK AREAS
003100     COPY MML1WS REPLACING ==:MML1:== BY ==MML1==.
003200/         EXAM DATA DICTONARY
003300     COPY MMEXTB REPLACING ==:MMEX:== BY ==MMEX==.
003400/         EXAM WORK AREA
003500     COPY MMEXWS REPLACING ==:MMEX:== BY ==MMEX==.
003600/         EXAM MASTER INITIALIZER RECORD
003700     COPY MMEXIR REPLACING ==:MMEX:== BY ==MMEX==.
003800/         EXAM I/O ROUTINE RECORD
003900     COPY MMEXIO REPLACING ==:MMEX:== BY ==MMEX==.
004000/         DATE WORK AREAS
004100     COPY SS01WS.
004200/         ONLINE WORK AREAS
004300     COPY SS08WS.
004400/
004500     COPY SS00WS.
004600/
004700     COPY SMFTWS.
004800/
004900     COPY SMPTRL REPLACING ==:SMPT:== BY ==SMPT==.
005000/
005100     COPY MB61LK.
005200/
005300 01  WS-MISCELLANEOUS.
005400     03  WS-UPDATE-SW        PIC  X(01)      VALUE 'N'.
005500         88  WS-UPDATE-SW-NO                 VALUE 'N'.
005600         88  WS-UPDATE-SW-YES                VALUE 'Y'.
005700     03  WS-NBR-LENGTH       PIC  9(02).
005800     03  WS-BIN-LENGTH       PIC  9(02).
005900     03  WS-PACK-LENGTH      PIC  9(02).
006000     03  WS-FOUND-DATA-SW    PIC  X(01)      VALUE SPACES.
006100         88  WS-FOUND-DATA                   VALUE 'Y'.
006200     03  WS-ONE-BYTE         PIC  X(01).
006300         88  WS-VALID-ONE-BYTE               VALUE '$' '-' '+'
006400                                                   '.' ','.
006500     03  WS-INDEX-X.
006600         05  WS-INDEX        PIC  9(04)      VALUE ZEROS.
006700*
006800 01  FILLER                  PIC  X(12)      VALUE '** WS-END **'.
006900/
007000 LINKAGE SECTION.
007100 01  DFHCOMMAREA.
007200     COPY MB60WS.
007300/         EXAM SCREEN 03 MAP DSECT
007400     COPY MBMQ03.
007500/         EXAM SCREEN 03 MAP REDEFINITION
007600     COPY MBMQ03R.
007700/         EXAM FILE MASTER RECORD LAYOUT
007800     COPY MMEXRL REPLACING ==:MMEX:== BY ==MMEX==.
007900/         LOG/JOURNAL FILE RECORD LAYOUT
008000     COPY MML1RL REPLACING ==:MML1:== BY ==MML1==.
008100/
008200 PROCEDURE DIVISION.
008300 0000-HOUSEKEEPING SECTION.
008400 0100-INIT.
008500*
008600     MOVE 'PC01'                 TO MBCA-PROGRAM-LOCATION.
008700     PERFORM MB70PD-ON-LINE-HOUSEKEEPING
008800                                 THRU MB70PD-OLH-EXIT.
008900*
009000     IF  MBCA-RECEIVE-SCREEN
009100         GO TO 2000-RECEIVE-SCREEN.
009200*
009300 1000-SEND-SCREEN SECTION.
009400*
009500****************************************************************
009600*    THIS SECTION BUILDS AND SENDS THE SCREENS 03              *
009700****************************************************************
009800*
009900****************************************************************
010000*    GET CICS STORAGE NEEDED FOR THE MAP                       *
010100****************************************************************
010200*
010300     MOVE 'SC01'                 TO MBCA-PROGRAM-LOCATION.
010400     PERFORM MB60PD-GETMAIN-FOR-MAP
010500                                 THRU MB60PD-GFM-EXIT.
010600*
010700     MOVE MBCA-MERCHANT-ORG      TO MQ03-ORG.
010800     MOVE MBCA-REQUEST-NBR       TO MQ03-REQUEST-NBR.
010900*
011000****************************************************************
011100*    INITIALIZE THE STANDARD MAP LINES                         *
011200****************************************************************
011300*
011400     PERFORM MB60PD-INIT-STD-MAP-LINES
011500                                 THRU MB60PD-ISML-EXIT.
011600*
011700****************************************************************
011800*    READ THE EXAM FILE                                        *
011900****************************************************************
012000*
012100     MOVE 'FC02'                 TO MBCA-PROGRAM-LOCATION.
012200     MOVE MBCA-MERCHANT-ORG      TO MBIOWS-MMEX-ORG.
012300     MOVE MBCA-REQUEST-NBR       TO MBIOWS-MMEX-REQUEST-NBR.
012400     SET MBIORO-READ-RANDOM      TO TRUE.
012500     PERFORM MMEXAO-ACCESS       THRU MMEXAO-ACCESS-EXIT.
012600*
012700     IF  MMEX-MAINT-INTERFACE-NO
012800         MOVE 'FC05'             TO MBCA-PROGRAM-LOCATION
012900         MOVE 54                 TO MBCA-SCREEN-NBR
013000         PERFORM MB70PD-XCTL-TO-MBOXCTL
013100                                 THRU MB70PD-XTM-EXIT.
013200*
013300 1100-BUILD-SCREEN.
013400*
013500     EVALUATE TRUE
013600         WHEN MMEX-TARGET-STORE-YES
013700             MOVE 'STORE MASTER      '
013800                                 TO MQ03-TARGET-FILE
013900         WHEN MMEX-TARGET-MERCHANT-YES
014000             MOVE 'MERCHANT MASTER   '
014100                                 TO MQ03-TARGET-FILE
014200         WHEN MMEX-TARGET-PRODUCT-YES
014300             MOVE 'MERCHANT PRODUCT  '
014400                                 TO MQ03-TARGET-FILE
014500     END-EVALUATE.
014600*
014700     MOVE MMEX-DESC              TO MQ03-DESCRIPTION.
014800*
014900     SET X-MMEX-MAINT            TO MBCA-MBMQ-MAINT-INDEX.
015000*
015100     PERFORM
015200         VARYING X-MQ03-MAINT FROM 1 BY 1
015300         UNTIL X-MQ03-MAINT IS GREATER THAN 7
015400         MOVE MMEX-MAINT-FIELD-NBR (X-MMEX-MAINT)
015500                                 TO MQ03-FIELD-NBR
015600                                    (X-MQ03-MAINT)
015700         MOVE MMEX-MAINT-FIELD-DESC (X-MMEX-MAINT)
015800                                 TO MQ03-FIELD-DESC
015900                                    (X-MQ03-MAINT)
016000         MOVE MMEX-MAINT-MAP-CODE (X-MMEX-MAINT)
016100                                 TO MQ03-MAP-CODE
016200                                    (X-MQ03-MAINT)
016300*
016400         MOVE MMEX-MAINT-FILE-FORMAT (X-MMEX-MAINT)
016500                                 TO MMEXWS-FILE-FORMAT
016600         EVALUATE TRUE
016700           WHEN (MMEXWS-FF-PACKED-SIGNED
016800             OR  MMEXWS-FF-PACKED-UNSIGNED)
016900               COMPUTE WS-PACK-LENGTH = MMEX-MAINT-LENGTH
017000                                      (X-MMEX-MAINT) * 2 - 1
017100               MOVE WS-PACK-LENGTH
017200                                 TO MQ03-FIELD-LENGTH
017300                                    (X-MQ03-MAINT)
017400               MOVE ZEROS        TO WS-PACK-LENGTH
017500           WHEN (MMEXWS-FF-BINARY-SIGNED
017600             OR MMEXWS-FF-BINARY-UNSIGNED)
017700             EVALUATE TRUE
017800               WHEN MMEX-MAINT-LENGTH (X-MMEX-MAINT)
017900                                     IS EQUAL TO 2
018000                 MOVE 4          TO MQ03-FIELD-LENGTH
018100                                    (X-MQ03-MAINT)
018200               WHEN MMEX-MAINT-LENGTH (X-MMEX-MAINT)
018300                                     IS EQUAL TO 4
018400                 MOVE 9          TO MQ03-FIELD-LENGTH
018500                                    (X-MQ03-MAINT)
018600               WHEN MMEX-MAINT-LENGTH (X-MMEX-MAINT)
018700                                     IS EQUAL TO 8
018800                 MOVE 18         TO MQ03-FIELD-LENGTH
018900                                    (X-MQ03-MAINT)
019000             END-EVALUATE
019100           WHEN OTHER
019200             MOVE MMEX-MAINT-LENGTH (X-MMEX-MAINT)
019300                                 TO MQ03-FIELD-LENGTH
019400                                    (X-MQ03-MAINT)
019500         END-EVALUATE
019600         MOVE MMEX-MAINT-FIELD-VALUE (X-MMEX-MAINT)
019700                                 TO MQ03-MAINT-VALUE
019800                                    (X-MQ03-MAINT)
019900         MOVE MMEX-MAINT-ROUND-OPTION (X-MMEX-MAINT)
020000                                 TO MQ03-ROUNDING
020100                                    (X-MQ03-MAINT)
020200         SET X-MMEX-MAINT        UP BY 1
020300     END-PERFORM.
020400*
020500 1200-SET-ATTRIBUTE.
020600*
020700     MOVE SS08WS-CURSOR          TO MQ03-FIELD-NBR-L (1).
020800*
020900****************************************************************
021000*    IF  INQUIRY, DARKEN PARENS AND ASKIP FIELDS               *
021100****************************************************************
021200*
021300     IF  MBCA-PTI-FUNCTION-IS-INQUIRY
021400         MOVE SS08WS-CURSOR      TO MQ03-ALT-TRANID-L
021500         PERFORM
021600             VARYING X-MQ03-MAINT FROM 1 BY 1
021700             UNTIL X-MQ03-MAINT IS GREATER THAN 7
021800             MOVE DFHBMASB       TO MQ03-FIELD-NBR-A
021900                                    (X-MQ03-MAINT)
022000                                    MQ03-FIELD-DESC-A
022100                                    (X-MQ03-MAINT)
022200                                    MQ03-MAP-CODE-A
022300                                    (X-MQ03-MAINT)
022400                                    MQ03-FIELD-LENGTH-A
022500                                    (X-MQ03-MAINT)
022600                                    MQ03-MAINT-VALUE-A
022700                                    (X-MQ03-MAINT)
022800                                    MQ03-ROUNDING-A
022900                                    (X-MQ03-MAINT)
023000             MOVE DFHBMDAS       TO MQ03-FIELD-NBR-RP-A
023100                                    (X-MQ03-MAINT)
023200                                    MQ03-FIELD-NBR-LP-A
023300                                    (X-MQ03-MAINT)
023400                                    MQ03-MAINT-VALUE-RP-A
023500                                    (X-MQ03-MAINT)
023600                                    MQ03-MAINT-VALUE-LP-A
023700                                    (X-MQ03-MAINT)
023800                                    MQ03-ROUNDING-RP-A
023900                                    (X-MQ03-MAINT)
024000                                    MQ03-ROUNDING-LP-A
024100                                    (X-MQ03-MAINT)
024200         END-PERFORM
024300     END-IF.
024400*
024500*
024600 1300-CONTINUE.
024700*
024800     IF  MBCA-MBMQ-MAINT-INDEX IS GREATER THAN 7
024900         MOVE DFHBMASB           TO MQ03-BACK-IND-A.
025000*
025100     MOVE MBCA-MBMQ-MAINT-INDEX  TO WS-INDEX.
025200     ADD 7                       TO WS-INDEX.
025300*
025400     IF  MMEX-MAINT-FIELD-NBR (WS-INDEX) IS EQUAL TO ZERO
025500     OR  MBCA-MBMQ-MAINT-INDEX IS EQUAL TO 29
025600         NEXT SENTENCE
025700     ELSE
025800         MOVE DFHBMASB           TO MQ03-FWD-IND-A.
025900*
026000     IF  MBCA-PTI-FUNCTION-IS-ADD
026100         MOVE 'RESV '            TO SS08WS-LINE-24-PF-KEY-FUNC(3)
026200         MOVE 'RESV '            TO SS08WS-LINE-24-PF-KEY-FUNC(4)
026300         MOVE '*FWD*'            TO SS08WS-LINE-24-PF-KEY-FUNC(5)
026400         MOVE 'RESV '            TO SS08WS-LINE-24-PF-KEY-FUNC(6)
026500         MOVE SS08WS-LINE-24     TO MQ03-PF-KEYS
026600         MOVE 'RESV'             TO MBCA-PGMX-PF-TRANS-ID (3)
026700         MOVE 'RESV'             TO MBCA-PGMX-PF-TRANS-ID (4)
026800         MOVE 'RESV'             TO MBCA-PGMX-PF-TRANS-ID (5)
026900         MOVE 'RESV'             TO MBCA-PGMX-PF-TRANS-ID (6)
027000     ELSE
027100         MOVE '*TOP*'            TO SS08WS-LINE-24-PF-KEY-FUNC(3)
027200         MOVE '*BOT*'            TO SS08WS-LINE-24-PF-KEY-FUNC(4)
027300         MOVE '*FWD*'            TO SS08WS-LINE-24-PF-KEY-FUNC(5)
027400         MOVE '*BWD*'            TO SS08WS-LINE-24-PF-KEY-FUNC(6)
027500         MOVE SS08WS-LINE-24     TO MQ03-PF-KEYS
027600         MOVE 'RESV'             TO MBCA-PGMX-PF-TRANS-ID (3)
027700         MOVE 'RESV'             TO MBCA-PGMX-PF-TRANS-ID (4)
027800         MOVE 'RESV'             TO MBCA-PGMX-PF-TRANS-ID (5)
027900         MOVE 'RESV'             TO MBCA-PGMX-PF-TRANS-ID (6).
028000*
028100****************************************************************
028200*    SEND THE MAP                                              *
028300****************************************************************
028400*
028500     COMPUTE MBCA-SCREEN-NBR = MBCA-SCREEN-NBR - 50.
028600*
028700     MOVE 'BM01'                 TO MBCA-PROGRAM-LOCATION.
028800     PERFORM MB60PD-SEND-MAP-WITH-ERASE
028900                                 THRU MB60PD-SMWE-EXIT.
029000*
029100****************************************************************
029200*    RETURN TO CICS                                            *
029300****************************************************************
029400*
029500     MOVE 'PC03'                 TO MBCA-PROGRAM-LOCATION.
029600     PERFORM MB70PD-RETURN-TRANS-ID
029700                                 THRU MB70PD-RTI-EXIT.
029800/
029900 2000-RECEIVE-SCREEN SECTION.
030000*
030100****************************************************************
030200*    THIS SECTION RECEIVES THE 04 SCREEN                       *
030300****************************************************************
030400*
030500     MOVE 'BM02'                 TO MBCA-PROGRAM-LOCATION.
030600     PERFORM MB60PD-RECEIVE-MAP  THRU MB60PD-RM-EXIT.
030700*
030800****************************************************************
030900*    CHECK FOR ANOTHER TRANSACTION ID ENTERED BY THE USER      *
031000****************************************************************
031100*
031200     MOVE 'PC04'                 TO MBCA-PROGRAM-LOCATION.
031300     PERFORM MB60PD-NEW-TRANS-ROUTINE
031400                                 THRU MB60PD-NTR-EXIT.
031500*
031600     MOVE SPACES                 TO MQ03-ERR-MESSAGE.
031700*
031800*
031900     SET X-MMEX-MAINT            TO MBCA-MBMQ-MAINT-INDEX.
032000     SET X-MQ03-MAINT            TO 1.
032100*
032200****************************************************************
032300*    READ RANDOM THE EXAM RECORD                               *
032400****************************************************************
032500*
032600     MOVE 'FC03'                 TO MBCA-PROGRAM-LOCATION.
032700     MOVE MBCA-MERCHANT-ORG      TO MBIOWS-MMEX-ORG.
032800     MOVE MBCA-REQUEST-NBR       TO MBIOWS-MMEX-REQUEST-NBR.
032900     SET MBIORO-READ-RANDOM      TO TRUE.
033000     PERFORM MMEXAO-ACCESS       THRU MMEXAO-ACCESS-EXIT.
033100*
033200     PERFORM 2100-EDIT           THRU 2199-E-EXIT
033300         VARYING X-MQ03-MAINT FROM 1 BY 1
033400         UNTIL X-MQ03-MAINT IS GREATER THAN 7.
033500*
033600     GO TO 2200-CHECK-ERROR-SW.
033700*
033800 2100-EDIT.
033900*
034000****************************************************************
034100*                  FIELD NUMBER                                *
034200****************************************************************
034300*
034400     MOVE DFHBMASK               TO MQ03-FIELD-NBR-A
034500                                    (X-MQ03-MAINT).
034600     MOVE DFHBMDAS               TO MQ03-FIELD-NBR-LP-A
034700                                    (X-MQ03-MAINT)
034800                                    MQ03-FIELD-NBR-RP-A
034900                                    (X-MQ03-MAINT).
035000*
035100     IF  MQ03-FIELD-NBR-L (X-MQ03-MAINT) IS LESS THAN 1
035200         MOVE MMEX-MAINT-FIELD-NBR (X-MMEX-MAINT)
035300                                 TO MQ03-FIELD-NBR
035400                                    (X-MQ03-MAINT)
035500     ELSE
035600         IF  MQ03-FIELD-NBR (X-MQ03-MAINT) IS NUMERIC
035700             MOVE DFHBMASF       TO MQ03-FIELD-NBR-A
035800                                    (X-MQ03-MAINT)
035900             SET WS-UPDATE-SW-YES
036000                                 TO TRUE
036100         ELSE
036200             MOVE DFHBMNBF       TO MQ03-FIELD-NBR-A
036300                                    (X-MQ03-MAINT)
036400             MOVE DFHBMASB       TO MQ03-FIELD-NBR-LP-A
036500                                    (X-MQ03-MAINT)
036600                                    MQ03-FIELD-NBR-RP-A
036700                                    (X-MQ03-MAINT)
036800             MOVE SS08WS-CURSOR  TO MQ03-FIELD-NBR-L
036900                                    (X-MQ03-MAINT)
037000             SET SS08WS-ERROR-SW-YES TO TRUE.
037100*
037200****************************************************************
037300*                MAINTENANCE VALUE                             *
037400****************************************************************
037500*
037600     MOVE DFHBMASK               TO MQ03-MAINT-VALUE-A
037700                                    (X-MQ03-MAINT).
037800     MOVE DFHBMDAS               TO MQ03-MAINT-VALUE-LP-A
037900                                    (X-MQ03-MAINT)
038000                                    MQ03-MAINT-VALUE-RP-A
038100                                    (X-MQ03-MAINT).
038200*
038300     IF  MQ03-MAINT-VALUE-L (X-MQ03-MAINT) IS LESS THAN 1
038400         MOVE MMEX-MAINT-FIELD-VALUE (X-MMEX-MAINT)
038500                                 TO MQ03-MAINT-VALUE
038600                                    (X-MQ03-MAINT)
038700     ELSE
038800         MOVE DFHBMASF           TO MQ03-MAINT-VALUE-A
038900                                    (X-MQ03-MAINT)
039000         SET WS-UPDATE-SW-YES    TO TRUE.
039100*
039200****************************************************************
039300*                  ROUNDING OPTION                             *
039400****************************************************************
039500*
039600     MOVE DFHBMASK               TO MQ03-ROUNDING-A
039700                                    (X-MQ03-MAINT).
039800     MOVE DFHBMDAS               TO MQ03-ROUNDING-LP-A
039900                                    (X-MQ03-MAINT)
040000                                    MQ03-ROUNDING-RP-A
040100                                    (X-MQ03-MAINT).
040200*
040300     IF  MQ03-ROUNDING-L (X-MQ03-MAINT) IS LESS THAN 1
040400         MOVE MMEX-MAINT-ROUND-OPTION (X-MMEX-MAINT)
040500                                 TO MQ03-ROUNDING
040600                                    (X-MQ03-MAINT)
040700     ELSE
040800         IF  MQ03-VALID-ROUNDING (X-MQ03-MAINT)
040900             MOVE DFHBMASF       TO MQ03-ROUNDING-A
041000                                    (X-MQ03-MAINT)
041100             SET WS-UPDATE-SW-YES
041200                                 TO TRUE
041300         ELSE
041400             MOVE DFHBMUBF       TO MQ03-ROUNDING-A
041500                                    (X-MQ03-MAINT)
041600             MOVE DFHBMASB       TO MQ03-ROUNDING-LP-A
041700                                    (X-MQ03-MAINT)
041800                                    MQ03-ROUNDING-RP-A
041900                                    (X-MQ03-MAINT)
042000             MOVE SS08WS-CURSOR  TO MQ03-ROUNDING-L
042100                                    (X-MQ03-MAINT)
042200             SET SS08WS-ERROR-SW-YES TO TRUE.
042300*
042400************************************************************
042500*       CROSS EDITS BEGIN HERE                           ***
042600************************************************************
042700*
042800************************************************************
042900*       IF ZEROS ARE ENTERED IN THE FIELD NUMBER           *
043000*       THE OCCURANCE WILL BE INITIALIZED                  *
043100************************************************************
043200*
043300     IF  MQ03-FIELD-NBR-L (X-MQ03-MAINT) IS GREATER THAN 0
043400     AND MQ03-FIELD-NBR (X-MQ03-MAINT) IS EQUAL TO ZERO
043500         MOVE MMEXIR-MAINT-CRITERIA (X-MMEX-MAINT)
043600                                 TO MMEX-MAINT-CRITERIA
043700                                    (X-MMEX-MAINT)
043800         GO TO 2150-CONTINUE.
043900*
044000************************************************************
044100*       BY ZEROING OUT  THE FIELD NUMBER ALL MAINT CRITERIA*
044200*       WILL BE INITIALIZED.                               *
044300************************************************************
044400*
044500     IF  MQ03-FIELD-NBR-L (X-MQ03-MAINT) IS GREATER THAN 0
044600     AND MQ03-FIELD-NBR (X-MQ03-MAINT) IS EQUAL TO ZERO
044700         MOVE MMEXIR-MAINT-CRITERIA (X-MMEX-MAINT)
044800                                 TO MMEX-MAINT-CRITERIA
044900                                    (X-MMEX-MAINT)
045000         GO TO 2150-CONTINUE.
045100*
045200************************************************************
045300*       THE ROUNDING  WILL BE DEFAULED TO '0' IF NOTHING   *
045400*       IS ENTERED.                                        *
045500************************************************************
045600*
045700     IF  MQ03-FIELD-NBR-L (X-MQ03-MAINT) IS GREATER THAN 0
045800     AND MQ03-MAINT-VALUE-L (X-MQ03-MAINT) IS GREATER THAN 0
045900     AND MQ03-ROUNDING (X-MQ03-MAINT) IS EQUAL TO SPACES
046000         MOVE +1                 TO MQ03-ROUNDING-L
046100                                    (X-MQ03-MAINT)
046200         MOVE '0'                TO MQ03-ROUNDING
046300                                    (X-MQ03-MAINT).
046400*
046500************************************************************
046600*       SEARCH THE DATA DICTIONARY TABLE TO SEE IF A MATCH *
046700*       IS MADE FROM THE FILE-ID AND FIELD-NBR ENTERED     *
046800************************************************************
046900*
047000     IF  MQ03-FIELD-NBR (X-MQ03-MAINT) IS GREATER THAN ZERO
047100         PERFORM 9100-SEARCH-TABLE
047200                                 THRU 9199-ST-EXIT.
047300*
047400     PERFORM 9400-CROSS-EDIT-ALL-FIELDS
047500                                 THRU 9499-CEAF-EXIT.
047600*
047700     PERFORM 9200-CROSS-EDIT-MAINT-VALUE
047800                                 THRU 9299-CEMV-EXIT.
047900*
048000*
048100 2150-CONTINUE.
048200*
048300     SET X-MMEX-MAINT            UP BY 1.
048400*
048500 2199-E-EXIT.
048600     EXIT.
048700*
048800 2200-CHECK-ERROR-SW.
048900*
049000     IF  SS08WS-ERROR-SW-NO
049100         GO TO 2400-UPDATE-FILE.
049200*
049300 2300-SEND-MAP.
049400*
049500****************************************************************
049600*    SEND THE MAP                                              *
049700****************************************************************
049800*
049900     PERFORM MB60PD-INIT-STD-MAP-LINES
050000                                 THRU MB60PD-ISML-EXIT.
050100*
050200     IF  MBCA-PTI-FUNCTION-IS-ADD
050300         MOVE 'RESV '            TO SS08WS-LINE-24-PF-KEY-FUNC(3)
050400         MOVE 'RESV '            TO SS08WS-LINE-24-PF-KEY-FUNC(4)
050500         MOVE '*FWD*'            TO SS08WS-LINE-24-PF-KEY-FUNC(5)
050600         MOVE 'RESV '            TO SS08WS-LINE-24-PF-KEY-FUNC(6)
050700         MOVE SS08WS-LINE-24     TO MQ03-PF-KEYS
050800         MOVE 'RESV'             TO MBCA-PGMX-PF-TRANS-ID (3)
050900         MOVE 'RESV'             TO MBCA-PGMX-PF-TRANS-ID (4)
051000         MOVE 'RESV'             TO MBCA-PGMX-PF-TRANS-ID (5)
051100         MOVE 'RESV'             TO MBCA-PGMX-PF-TRANS-ID (6)
051200     ELSE
051300         MOVE '*TOP*'            TO SS08WS-LINE-24-PF-KEY-FUNC(3)
051400         MOVE '*BOT*'            TO SS08WS-LINE-24-PF-KEY-FUNC(4)
051500         MOVE '*FWD*'            TO SS08WS-LINE-24-PF-KEY-FUNC(5)
051600         MOVE '*BWD*'            TO SS08WS-LINE-24-PF-KEY-FUNC(6)
051700         MOVE SS08WS-LINE-24     TO MQ03-PF-KEYS
051800         MOVE 'RESV'             TO MBCA-PGMX-PF-TRANS-ID (3)
051900         MOVE 'RESV'             TO MBCA-PGMX-PF-TRANS-ID (4)
052000         MOVE 'RESV'             TO MBCA-PGMX-PF-TRANS-ID (5)
052100         MOVE 'RESV'             TO MBCA-PGMX-PF-TRANS-ID (6).
052200*
052300     MOVE 'BM03'                 TO MBCA-PROGRAM-LOCATION.
052400     PERFORM MB60PD-SEND-MAP-DATA-ONLY
052500                                 THRU MB60PD-SMDO-EXIT.
052600*
052700****************************************************************
052800*    RETURN TO CICS                                            *
052900****************************************************************
053000*
053100     MOVE 'PC05'                 TO MBCA-PROGRAM-LOCATION.
053200     PERFORM MB70PD-RETURN-TRANS-ID
053300                                 THRU MB70PD-RTI-EXIT.
053400/
053500 2400-UPDATE-FILE.
053600*
053700****************************************************
053800*    READ THE INCOME FILE RECORD FOR UPDATE        *
053900****************************************************
054000*
054100     MOVE MMEX-RECORD            TO MMEXIO-RECORD.
054200*
054300     MOVE 'FC04'                 TO MBCA-PROGRAM-LOCATION.
054400     SET MBIORO-READ-RANDOM-UPDATE
054500                                 TO TRUE.
054600     PERFORM MMEXAO-ACCESS       THRU MMEXAO-ACCESS-EXIT.
054700*
054800     MOVE MMEXIO-RECORD          TO MMEX-RECORD.
054900*
055000*************************************
055100*    OBTAIN STORAGE FOR LOG FILE    *
055200*    RECORD IF DOING MAINTENANCE    *
055300*************************************
055400*
055500     MOVE 'SC02'                 TO MBCA-PROGRAM-LOCATION.
055600     SET MBIORO-GETMAIN          TO TRUE.
055700     PERFORM MML1AO-ACCESS       THRU MML1AO-ACCESS-EXIT.
055800*
055900 2500-UPDATE-FIELDS.
056000*
056100     SET X-MMEX-MAINT            TO MBCA-MBMQ-MAINT-INDEX.
056200*
056300     PERFORM
056400         VARYING X-MQ03-MAINT FROM 1 BY 1
056500           UNTIL X-MQ03-MAINT IS GREATER THAN 7
056600*
056700*            ***** FIELD NUMBER *****
056800*
056900         IF MQ03-FIELD-NBR-L (X-MQ03-MAINT) IS GREATER THAN ZERO
057000             MOVE MQ03-FIELD-NBR (X-MQ03-MAINT)
057100                                 TO MMEX-MAINT-FIELD-NBR
057200                                    (X-MMEX-MAINT)
057300         END-IF
057400*
057500*            ***** FIELD VALUE *****
057600*
057700         IF MQ03-MAINT-VALUE-L (X-MQ03-MAINT) IS GREATER THAN ZERO
057800             MOVE MQ03-MAINT-VALUE (X-MQ03-MAINT)
057900                                 TO MMEX-MAINT-FIELD-VALUE
058000                                    (X-MMEX-MAINT)
058100         END-IF
058200*
058300*            ***** ROUNDING *****
058400*
058500         IF MQ03-ROUNDING-L (X-MQ03-MAINT) IS GREATER THAN ZERO
058600             MOVE MQ03-ROUNDING (X-MQ03-MAINT)
058700                                 TO MMEX-MAINT-ROUND-OPTION
058800                                    (X-MMEX-MAINT)
058900         END-IF
059000         SET X-MMEX-MAINT        UP BY 1
059100     END-PERFORM.
059200*
059300*
059400 2650-UPDATE-MMEX.
059500*
059600     IF  MBCA-PTI-FUNCTION-IS-ADD
059700         MOVE MBCA-SCREEN-NBR    TO MMEX-ONLINE-STATUS
059800         MOVE MBCA-START-DATE    TO MMEX-LAST-MAINT-DATE
059900         MOVE MBCA-OPERATOR-ID   TO MMEX-LAST-MAINT-OPER
060000         SET WS-UPDATE-SW-YES    TO TRUE.
060100*
060200**************************************************************
060300*    WRITE A LOG RECORD TO SHOW THAT THE LAST MAINT DATE     *
060400*    AND OPERATOR HAS BEEN UPDATED IF FIELDS WERE CHANGED    *
060500*    ON THE SCREEN                                           *
060600**************************************************************
060700*
060800     IF  MBCA-PTI-FUNCTION-IS-MAINT
060900     AND WS-UPDATE-SW-YES
061000         MOVE 0198               TO MML1-FIELD-CODE
061100         MOVE ZEROES             TO MML1-FIELD-OCCURRENCE
061200                                    MML1-FIELD-OCCURRENCE-2
061300         MOVE MML1WS-VL-03       TO MML1-VARIABLE-LENGTH
061400         MOVE MMEX-LAST-MAINT-OPER
061500                                 TO MML1-VL03-B-DATA-X
061600         MOVE MBCA-OPERATOR-ID   TO MMEX-LAST-MAINT-OPER
061700         MOVE MMEX-LAST-MAINT-OPER
061800                                 TO MML1-VL03-A-DATA-X
061900         MOVE 'FC05'             TO MBCA-PROGRAM-LOCATION
062000         PERFORM 9050-WRITE-LOG-REC
062100                                 THRU 9099-WLR-EXIT
062200         MOVE 0199               TO MML1-FIELD-CODE
062300         MOVE ZEROES             TO MML1-FIELD-OCCURRENCE
062400                                    MML1-FIELD-OCCURRENCE-2
062500         MOVE MML1WS-VL-07       TO MML1-VARIABLE-LENGTH
062600         MOVE MMEX-LAST-MAINT-DATE
062700                                 TO MML1-VL07-B-DATA-9
062800         MOVE MBCA-START-DATE    TO MMEX-LAST-MAINT-DATE
062900         MOVE MMEX-LAST-MAINT-DATE
063000                                 TO MML1-VL07-A-DATA-9
063100         MOVE 'FC06'             TO MBCA-PROGRAM-LOCATION
063200         PERFORM 9050-WRITE-LOG-REC
063300                                 THRU 9099-WLR-EXIT
063400         MOVE LENGTH OF MMEX-RECORD
063500                                 TO MML1-VARIABLE-LENGTH
063600         MOVE MMEX-RECORD        TO MML1-ADD-AREA
063700         MOVE 0100               TO MML1-FIELD-CODE
063800         MOVE ZEROES             TO MML1-FIELD-OCCURRENCE
063900                                    MML1-FIELD-OCCURRENCE-2
064000         PERFORM 9050-WRITE-LOG-REC
064100                                 THRU 9099-WLR-EXIT.
064200*
064300*            ***** LAST PROC REQUEST UPDATE  *****       *
064400*
064500     IF  MBCA-PTI-FUNCTION-IS-MAINT
064600     AND WS-UPDATE-SW-YES
064700     AND MMEX-LAST-RUN-DATE IS GREATER THAN ZEROS
064800         SET  MMEX-LAST-PROC-REQUEST-ON
064900                                 TO TRUE.
065000*
065100****************************************************
065200*    REWRITE THE EXAM RECORD IF                    *
065300*    FIELDS HAVE BEEN CHANGED ON THE SCREEN, OR    *
065400*    UNLOCK IT IF THEY HAVE NOT                    *
065500****************************************************
065600*
065700     IF  WS-UPDATE-SW-YES
065800         MOVE 'FC07'             TO MBCA-PROGRAM-LOCATION
065900         SET MBIORO-REWRITE      TO TRUE
066000         PERFORM MMEXAO-ACCESS   THRU MMEXAO-ACCESS-EXIT
066100     ELSE
066200         MOVE 'FC08'             TO MBCA-PROGRAM-LOCATION
066300         SET MBIORO-UNLOCK       TO TRUE
066400         PERFORM MMEXAO-ACCESS   THRU MMEXAO-ACCESS-EXIT.
066500/
066600 2600-SETUP-COMMAREA.
066700*
066800****************************************************************
066900*    SET UP COMMAREA FIELDS AND TRANSFER TO THE NEXT PROGRAM   *
067000****************************************************************
067100*
067200     MOVE MBCA-EIBAID            TO SS08WS-EIBAID.
067300*
067400     IF  (SS08WS-VALID-PF3
067500     OR  SS08WS-EIBAID-VALID-PF3)
067600         MOVE 1                  TO MBCA-MBMQ-MAINT-INDEX
067700         MOVE 53                 TO MBCA-SCREEN-NBR
067800         GO TO 2690-PF-KEY-BYPASS.
067900*
068000     IF  (SS08WS-VALID-PF4
068100     OR  SS08WS-EIBAID-VALID-PF4)
068200         PERFORM
068300             VARYING X-MMEX-MAINT FROM 35 BY -1
068400             UNTIL X-MMEX-MAINT IS LESS THAN 1
068500             IF  MMEX-MAINT-FILE-ID (X-MMEX-MAINT)
068600                                 IS NOT EQUAL TO SPACES
068700                 EVALUATE TRUE
068800                   WHEN X-MMEX-MAINT IS GREATER THAN 28
068900                     MOVE 29     TO MBCA-MBMQ-MAINT-INDEX
069000                   WHEN X-MMEX-MAINT IS GREATER THAN 21
069100                     MOVE 22     TO MBCA-MBMQ-MAINT-INDEX
069200                   WHEN X-MMEX-MAINT IS GREATER THAN 14
069300                     MOVE 15     TO MBCA-MBMQ-MAINT-INDEX
069400                   WHEN X-MMEX-MAINT IS GREATER THAN 7
069500                     MOVE 8      TO MBCA-MBMQ-MAINT-INDEX
069600                   WHEN OTHER
069700                     MOVE 1      TO MBCA-MBMQ-MAINT-INDEX
069800                 END-EVALUATE
069900                 MOVE 53     TO MBCA-SCREEN-NBR
070000                 GO TO 2690-PF-KEY-BYPASS
070100             END-IF
070200         END-PERFORM
070300         MOVE 1                  TO MBCA-MBMQ-MAINT-INDEX
070400         MOVE 53                 TO MBCA-SCREEN-NBR
070500         GO TO 2690-PF-KEY-BYPASS.
070600*
070700     IF  SS08WS-VALID-PF5
070800     OR  SS08WS-EIBAID-VALID-PF5
070900         IF  MBCA-MBMQ-MAINT-INDEX IS EQUAL TO 29
071000             MOVE 53             TO MBCA-SCREEN-NBR
071100             GO TO 2690-PF-KEY-BYPASS
071200         ELSE
071300             PERFORM
071400                 VARYING X-MQ03-MAINT FROM 1 BY 1
071500                 UNTIL X-MQ03-MAINT IS GREATER THAN 7
071600                 IF  MQ03-FIELD-NBR (X-MQ03-MAINT)
071700                                 IS EQUAL TO ZEROS
071800                     MOVE 53   TO MBCA-SCREEN-NBR
071900                     GO TO 2690-PF-KEY-BYPASS
072000                 END-IF
072100             END-PERFORM
072200             COMPUTE MBCA-MBMQ-MAINT-INDEX
072300                                 = MBCA-MBMQ-MAINT-INDEX
072400                                 + 7
072500             MOVE 53             TO MBCA-SCREEN-NBR
072600             GO TO 2690-PF-KEY-BYPASS.
072700*
072800     IF  (SS08WS-VALID-PF6
072900     OR  SS08WS-EIBAID-VALID-PF6)
073000         IF  MBCA-MBMQ-MAINT-INDEX IS LESS THAN 7
073100             MOVE 1              TO MBCA-MBMQ-MAINT-INDEX
073200             MOVE 53             TO MBCA-SCREEN-NBR
073300             GO TO 2690-PF-KEY-BYPASS
073400         ELSE
073500             COMPUTE MBCA-MBMQ-MAINT-INDEX
073600                                 = MBCA-MBMQ-MAINT-INDEX
073700                                 - 7
073800             MOVE 53             TO MBCA-SCREEN-NBR
073900             GO TO 2690-PF-KEY-BYPASS.
074000*
074100     PERFORM MB60PD-EDIT-PAGE-NBR
074200                                 THRU MB60PD-EPN-EXIT.
074300*
074400     IF  SS08WS-VALID-PF-KEY
074500     OR  SS08WS-EIBAID-VALID-PF-KEY
074600         SET MBCA-INITIAL-SCREEN-NBR
074700                                 TO TRUE.
074800*
074900 2690-PF-KEY-BYPASS.
075000*
075100     MOVE 'PC06'                 TO MBCA-PROGRAM-LOCATION.
075200     PERFORM MB70PD-XCTL-TO-MBOXCTL
075300                                 THRU MB70PD-XTM-EXIT.
075400/
075500 9000-PERFORMED-ROUTINES-SECT SECTION.
075600*
075700*
075800 9050-WRITE-LOG-REC.
075900*
076000*****************************************************************
076100*    WRITE THE LOG/JOURNAL FILE RECORD                          *
076200*****************************************************************
076300*
076400     IF  MBCA-PTI-FUNCTION-IS-ADD
076500         GO TO 9099-WLR-EXIT.
076600*
076700     MOVE 'EX'                   TO MML1-FILE-CODE.
076800     MOVE MBCA-MERCHANT-ORG      TO MML1-MMEX-ORG.
076900     MOVE MBCA-REQUEST-NBR       TO MML1-MMEX-REQUEST-NBR.
077000     MOVE MBCA-SIGNON-NAME       TO MML1-SIGNON-NAME.
077100     MOVE MBCA-TERMINAL-ID       TO MML1-TERMINAL-ID.
077200     MOVE ZEROES                 TO MML1-SOURCE-CODE.
077300*
077400     MOVE 'FC09'                 TO MBCA-PROGRAM-LOCATION.
077500     SET MBIORO-WRITE            TO TRUE.
077600     PERFORM MML1AO-ACCESS       THRU MML1AO-ACCESS-EXIT.
077700     MOVE SPACES                 TO MML1-VARIABLE-AREA.
077800*
077900 9099-WLR-EXIT.
078000     EXIT.
078100*
078200 9100-SEARCH-TABLE.
078300*
078400     SET X-MMEXTB                TO 1.
078500*
078600     EVALUATE TRUE
078700         WHEN MMEX-TARGET-STORE-YES
078800             MOVE 'SM'           TO MMEXWS-FILE-ID
078900         WHEN MMEX-TARGET-MERCHANT-YES
079000             MOVE 'MM'           TO MMEXWS-FILE-ID
079100         WHEN MMEX-TARGET-PRODUCT-YES
079200             MOVE 'MP'           TO MMEXWS-FILE-ID
079300     END-EVALUATE.
079400*
079500     MOVE MQ03-FIELD-NBR (X-MQ03-MAINT)
079600                                 TO MMEXWS-FIELD-NBR.
079700*
079800     SEARCH MMEXTB-DATA-DICTIONARY VARYING X-MMEXTB
079900         AT END
080000             SET X-MMEXTB        TO 1
080100         WHEN MMEXTB-FIELD-CODE (X-MMEXTB) IS EQUAL TO
080200                                    MMEXWS-FIELD-CODE
080300             MOVE MMEXTB-SEL-MAINT-DATA (X-MMEXTB)
080400                                 TO MMEX-MAINT-DICTIONARY-DATA
080500                                    (X-MMEX-MAINT)
080600             MOVE MMEXTB-DATA-DICTIONARY (X-MMEXTB)
080700                                 TO MMEXWS-DATA-DICTIONARY
080800             MOVE MMEXWS-FILE-ID TO MMEX-MAINT-FILE-ID
080900                                    (X-MMEX-MAINT).
081000*
081100     IF  X-MMEXTB IS EQUAL TO 1
081200     OR  MMEXWS-MC-NO-MAINT
081300         MOVE DFHBMNBF           TO MQ03-FIELD-NBR-A
081400                                    (X-MQ03-MAINT)
081500         MOVE DFHBMUBF           TO MQ03-MAINT-VALUE-A
081600                                    (X-MQ03-MAINT)
081700                                    MQ03-ROUNDING-A
081800                                    (X-MQ03-MAINT)
081900         MOVE DFHBMASB           TO MQ03-FIELD-NBR-LP-A
082000                                    (X-MQ03-MAINT)
082100                                    MQ03-FIELD-NBR-RP-A
082200                                    (X-MQ03-MAINT)
082300                                    MQ03-MAINT-VALUE-LP-A
082400                                    (X-MQ03-MAINT)
082500                                    MQ03-MAINT-VALUE-RP-A
082600                                    (X-MQ03-MAINT)
082700                                    MQ03-ROUNDING-LP-A
082800                                    (X-MQ03-MAINT)
082900                                    MQ03-ROUNDING-RP-A
083000                                    (X-MQ03-MAINT)
083100         MOVE SS08WS-CURSOR      TO MQ03-FIELD-NBR-L
083200                                    (X-MQ03-MAINT)
083300         MOVE 'FIELD NBR NOT VALID OR MAINT NOT ALLOWED'
083400                                 TO MQ03-ERR-MESSAGE
083500         SET SS08WS-ERROR-SW-YES TO TRUE.
083600*
083700 9199-ST-EXIT.
083800     EXIT.
083900*
084000 9200-CROSS-EDIT-MAINT-VALUE.
084100*
084200     MOVE ZEROS                  TO WS-NBR-LENGTH
084300                                    WS-BIN-LENGTH
084400                                    WS-PACK-LENGTH.
084500*
084600     IF  MQ03-MAINT-VALUE (X-MQ03-MAINT) IS EQUAL TO SPACES
084700     OR  SS08WS-ERROR-SW-YES
084800         GO TO 9299-CEMV-EXIT.
084900*
085000     IF  MQ03-MAINT-VALUE-L (X-MQ03-MAINT) IS EQUAL TO ZERO
085100     AND MQ03-FIELD-NBR-L (X-MQ03-MAINT) IS EQUAL TO ZERO
085200         GO TO 9299-CEMV-EXIT.
085300*
085400     MOVE 1                      TO MMEXWS-EA-REFMOD.
085500     MOVE ZEROS                  TO MMEXWS-EA-REFMOD-2.
085600     MOVE SPACES                 TO MMEXWS-FILE-AREA.
085700     MOVE MQ03-MAINT-VALUE (X-MQ03-MAINT)
085800                                 TO MMEXWS-FILE-AREA.
085900     MOVE SPACES                 TO MMEXWS-EXAM-AREA
086000                                    WS-FOUND-DATA-SW.
086100*
086200     IF  MMEXWS-SD-NUMERIC
086300         PERFORM
086400             VARYING MMEXWS-FA-REFMOD FROM 1 BY 1
086500             UNTIL MMEXWS-FA-REFMOD IS GREATER THAN 50
086600             IF  MMEXWS-FILE-AREA (MMEXWS-FA-REFMOD:1)
086700                                 IS NOT EQUAL TO SPACES
086800                 MOVE MMEXWS-FILE-AREA (MMEXWS-FA-REFMOD:1)
086900                                 TO MMEXWS-EXAM-AREA
087000                                   (MMEXWS-EA-REFMOD:1)
087100                 ADD 1           TO MMEXWS-EA-REFMOD
087200             END-IF
087300         END-PERFORM
087400     ELSE
087500         PERFORM
087600             VARYING MMEXWS-FA-REFMOD FROM 50 BY -1
087700             UNTIL MMEXWS-FA-REFMOD IS LESS THAN 1
087800             IF  MMEXWS-FILE-AREA (MMEXWS-FA-REFMOD:1)
087900                                 IS NOT EQUAL TO SPACES
088000             OR WS-FOUND-DATA
088100                 SET WS-FOUND-DATA
088200                                 TO TRUE
088300                 MOVE MMEXWS-FA-REFMOD
088400                                 TO MMEXWS-EA-REFMOD
088500                 MOVE MMEXWS-FILE-AREA (MMEXWS-FA-REFMOD:1)
088600                                 TO MMEXWS-EXAM-AREA
088700                                   (MMEXWS-EA-REFMOD:1)
088800                 ADD 1           TO MMEXWS-EA-REFMOD-2
088900             END-IF
089000         END-PERFORM
089100         MOVE MMEXWS-EA-REFMOD-2
089200                                 TO MMEXWS-EA-REFMOD
089300     END-IF.
089400*
089500     MOVE MMEXWS-EXAM-AREA       TO MQ03-MAINT-VALUE
089600                                    (X-MQ03-MAINT).
089700*
089800     EVALUATE TRUE
089900         WHEN MMEXWS-SD-VALID-DATE
090000             PERFORM 9300-DATE-VALIDATION
090100                                 THRU 9309-DV-EXIT
090200             GO TO 9299-CEMV-EXIT
090300         WHEN (MMEXWS-FF-PACKED-SIGNED
090400           OR MMEXWS-FF-PACKED-UNSIGNED)
090500             PERFORM 9310-PACKED-AMOUNT-EDIT
090600                                 THRU 9319-PAE-EXIT
090700             GO TO 9299-CEMV-EXIT
090800         WHEN (MMEXWS-FF-BINARY-SIGNED
090900           OR MMEXWS-FF-BINARY-UNSIGNED)
091000             PERFORM 9320-BINARY-AMOUNT-EDIT
091100                                 THRU 9329-BAE-EXIT
091200             GO TO 9299-CEMV-EXIT
091300         WHEN  MMEXWS-SD-NUMERIC
091400             PERFORM 9340-NUMERIC-ZD
091500                                 THRU 9349-NZ-EXIT
091600             GO TO 9299-CEMV-EXIT
091700     END-EVALUATE.
091800*
091900     IF  MMEXWS-EA-REFMOD IS GREATER THAN MMEXWS-LENGTH
092000         MOVE DFHBMNBF           TO MQ03-FIELD-NBR-A
092100                                    (X-MQ03-MAINT)
092200         MOVE DFHBMUBF           TO MQ03-MAINT-VALUE-A
092300                                    (X-MQ03-MAINT)
092400                                    MQ03-ROUNDING-A
092500                                    (X-MQ03-MAINT)
092600         MOVE DFHBMASB           TO MQ03-FIELD-NBR-LP-A
092700                                    (X-MQ03-MAINT)
092800                                    MQ03-FIELD-NBR-RP-A
092900                                    (X-MQ03-MAINT)
093000                                    MQ03-MAINT-VALUE-LP-A
093100                                    (X-MQ03-MAINT)
093200                                    MQ03-MAINT-VALUE-RP-A
093300                                    (X-MQ03-MAINT)
093400                                    MQ03-ROUNDING-LP-A
093500                                    (X-MQ03-MAINT)
093600                                    MQ03-ROUNDING-RP-A
093700                                    (X-MQ03-MAINT)
093800         MOVE SS08WS-CURSOR      TO MQ03-MAINT-VALUE-L
093900                                    (X-MQ03-MAINT)
094000         MOVE 'MAINTENANCE VALUE GREATER THAN FIELD LENGTH'
094100                                 TO MQ03-ERR-MESSAGE
094200         MOVE MMEXWS-LENGTH      TO MQ03-ERR-MESSAGE (45:2)
094300         SET SS08WS-ERROR-SW-YES TO TRUE.
094400*
094500 9299-CEMV-EXIT.
094600     EXIT.
094700*
094800 9300-DATE-VALIDATION.
094900*
095000     IF  MMEXWS-EXAM-AREA (9:1) IS NOT EQUAL TO SPACES
095100         MOVE DFHBMNBF           TO MQ03-FIELD-NBR-A
095200                                    (X-MQ03-MAINT)
095300         MOVE DFHBMUBF           TO MQ03-MAINT-VALUE-A
095400                                    (X-MQ03-MAINT)
095500                                    MQ03-ROUNDING-A
095600                                    (X-MQ03-MAINT)
095700         MOVE DFHBMASB           TO MQ03-FIELD-NBR-LP-A
095800                                    (X-MQ03-MAINT)
095900                                    MQ03-FIELD-NBR-RP-A
096000                                    (X-MQ03-MAINT)
096100                                    MQ03-MAINT-VALUE-LP-A
096200                                    (X-MQ03-MAINT)
096300                                    MQ03-MAINT-VALUE-RP-A
096400                                    (X-MQ03-MAINT)
096500                                    MQ03-ROUNDING-LP-A
096600                                    (X-MQ03-MAINT)
096700                                    MQ03-ROUNDING-RP-A
096800                                    (X-MQ03-MAINT)
096900         MOVE SS08WS-CURSOR      TO MQ03-MAINT-VALUE-L
097000                                    (X-MQ03-MAINT)
097100         MOVE 'MAINTENANCE VALUE GREATER THAN DATE LENGTH'
097200                                 TO MQ03-ERR-MESSAGE
097300         SET SS08WS-ERROR-SW-YES TO TRUE
097400         GO TO 9309-DV-EXIT.
097500*
097600     IF  MMEXWS-EXAM-AREA (1:8)  IS NOT NUMERIC
097700         IF  MMEXWS-EXAM-AREA (7:1)  IS NOT EQUAL TO SPACES
097800         OR  MMEXWS-EXAM-AREA (1:6)  IS NOT NUMERIC
097900             MOVE DFHBMNBF       TO MQ03-FIELD-NBR-A
098000                                    (X-MQ03-MAINT)
098100             MOVE DFHBMUBF       TO MQ03-MAINT-VALUE-A
098200                                    (X-MQ03-MAINT)
098300                                    MQ03-ROUNDING-A
098400                                    (X-MQ03-MAINT)
098500             MOVE DFHBMASB       TO MQ03-FIELD-NBR-LP-A
098600                                    (X-MQ03-MAINT)
098700                                    MQ03-FIELD-NBR-RP-A
098800                                    (X-MQ03-MAINT)
098900                                    MQ03-MAINT-VALUE-LP-A
099000                                    (X-MQ03-MAINT)
099100                                    MQ03-MAINT-VALUE-RP-A
099200                                    (X-MQ03-MAINT)
099300                                    MQ03-ROUNDING-LP-A
099400                                    (X-MQ03-MAINT)
099500                                    MQ03-ROUNDING-RP-A
099600                                    (X-MQ03-MAINT)
099700             MOVE SS08WS-CURSOR  TO MQ03-MAINT-VALUE-L
099800                                    (X-MQ03-MAINT)
099900             MOVE 'INVALID DATE ENTERED'
100000                                 TO MQ03-ERR-MESSAGE
100100             SET SS08WS-ERROR-SW-YES TO TRUE
100200             GO TO 9309-DV-EXIT
100300         ELSE
100400             MOVE MMEXWS-EXAM-AREA (1:6)
100500                                 TO SS01WS-MDY
100600             MOVE SS01WS-MDYZ    TO SS01WS-DATEZ
100700     ELSE
100800         MOVE MMEXWS-EXAM-AREA (1:8)
100900                                 TO SS01WS-DATE.
101000*
101100     PERFORM SS05PD-DATE-VALIDATION
101200                                 THRU SS05PD-DV-EXIT.
101300*
101400     IF  SS01WS-DATE-IS-INVALID
101500         MOVE DFHBMNBF           TO MQ03-FIELD-NBR-A
101600                                    (X-MQ03-MAINT)
101700         MOVE DFHBMUBF           TO MQ03-MAINT-VALUE-A
101800                                    (X-MQ03-MAINT)
101900                                    MQ03-ROUNDING-A
102000                                    (X-MQ03-MAINT)
102100         MOVE DFHBMASB           TO MQ03-FIELD-NBR-LP-A
102200                                    (X-MQ03-MAINT)
102300                                    MQ03-FIELD-NBR-RP-A
102400                                    (X-MQ03-MAINT)
102500                                    MQ03-MAINT-VALUE-LP-A
102600                                    (X-MQ03-MAINT)
102700                                    MQ03-MAINT-VALUE-RP-A
102800                                    (X-MQ03-MAINT)
102900                                    MQ03-ROUNDING-LP-A
103000                                    (X-MQ03-MAINT)
103100                                    MQ03-ROUNDING-RP-A
103200                                    (X-MQ03-MAINT)
103300         MOVE SS08WS-CURSOR      TO MQ03-MAINT-VALUE-L
103400                                    (X-MQ03-MAINT)
103500         MOVE 'INVALID DATE ENTERED'
103600                                 TO MQ03-ERR-MESSAGE
103700         SET SS08WS-ERROR-SW-YES TO TRUE.
103800*
103900 9309-DV-EXIT.
104000     EXIT.
104100*
104200 9310-PACKED-AMOUNT-EDIT.
104300*
104400     COMPUTE WS-PACK-LENGTH = MMEXWS-LENGTH * 2 - 1.
104500*
104600     MOVE SPACES                 TO MMEXWS-FILE-AREA.
104700     MOVE MMEXWS-EXAM-AREA       TO MMEXWS-FILE-AREA.
104800*
104900     PERFORM
105000         VARYING MMEXWS-FA-REFMOD FROM 1 BY 1
105100         UNTIL MMEXWS-FA-REFMOD IS GREATER THAN MMEXWS-EA-REFMOD
105200         MOVE MMEXWS-FILE-AREA (MMEXWS-FA-REFMOD:1)
105300                                 TO WS-ONE-BYTE
105400         IF  WS-VALID-ONE-BYTE
105500             CONTINUE
105600         ELSE
105700             IF  WS-ONE-BYTE IS NUMERIC
105800                 ADD 1           TO WS-NBR-LENGTH
105900             END-IF
106000         END-IF
106100     END-PERFORM.
106200*
106300     IF  WS-NBR-LENGTH IS GREATER THAN WS-PACK-LENGTH
106400     OR  WS-NBR-LENGTH IS EQUAL TO ZERO
106500         MOVE DFHBMNBF           TO MQ03-FIELD-NBR-A
106600                                    (X-MQ03-MAINT)
106700         MOVE DFHBMUBF           TO MQ03-MAINT-VALUE-A
106800                                    (X-MQ03-MAINT)
106900                                    MQ03-ROUNDING-A
107000                                    (X-MQ03-MAINT)
107100         MOVE DFHBMASB           TO MQ03-FIELD-NBR-LP-A
107200                                    (X-MQ03-MAINT)
107300                                    MQ03-FIELD-NBR-RP-A
107400                                    (X-MQ03-MAINT)
107500                                    MQ03-MAINT-VALUE-LP-A
107600                                    (X-MQ03-MAINT)
107700                                    MQ03-MAINT-VALUE-RP-A
107800                                    (X-MQ03-MAINT)
107900                                    MQ03-ROUNDING-LP-A
108000                                    (X-MQ03-MAINT)
108100                                    MQ03-ROUNDING-RP-A
108200                                    (X-MQ03-MAINT)
108300         MOVE SS08WS-CURSOR      TO MQ03-MAINT-VALUE-L
108400                                    (X-MQ03-MAINT)
108500         IF  WS-NBR-LENGTH IS EQUAL TO ZERO
108600             MOVE 'MAINTENANCE VALUE NOT NUMERIC'
108700                                 TO MQ03-ERR-MESSAGE
108800         ELSE
108900             MOVE 'MAINTENANCE VALUE GREATER THAN FIELD LENGTH'
109000                                 TO MQ03-ERR-MESSAGE
109100         END-IF
109200         SET SS08WS-ERROR-SW-YES TO TRUE
109300     END-IF.
109400*
109500 9319-PAE-EXIT.
109600     EXIT.
109700*
109800 9320-BINARY-AMOUNT-EDIT.
109900*
110000     MOVE ZEROS                  TO WS-NBR-LENGTH.
110100*
110200     EVALUATE TRUE
110300         WHEN MMEXWS-LENGTH IS EQUAL TO 2
110400             MOVE 4              TO WS-BIN-LENGTH
110500         WHEN MMEXWS-LENGTH IS EQUAL TO 4
110600             MOVE 9              TO WS-BIN-LENGTH
110700         WHEN MMEXWS-LENGTH IS EQUAL TO 8
110800             MOVE 18             TO WS-BIN-LENGTH
110900     END-EVALUATE.
111000*
111100     MOVE SPACES                 TO MMEXWS-FILE-AREA.
111200     MOVE MMEXWS-EXAM-AREA       TO MMEXWS-FILE-AREA.
111300*
111400     PERFORM
111500         VARYING MMEXWS-FA-REFMOD FROM 1 BY 1
111600         UNTIL MMEXWS-FA-REFMOD IS GREATER THAN MMEXWS-EA-REFMOD
111700         MOVE MMEXWS-FILE-AREA (MMEXWS-FA-REFMOD:1)
111800                                 TO WS-ONE-BYTE
111900         IF  WS-VALID-ONE-BYTE
112000             CONTINUE
112100         ELSE
112200             IF  WS-ONE-BYTE IS NUMERIC
112300                 ADD 1           TO WS-NBR-LENGTH
112400             END-IF
112500         END-IF
112600     END-PERFORM.
112700*
112800     IF  WS-NBR-LENGTH IS GREATER THAN WS-BIN-LENGTH
112900         MOVE DFHBMNBF           TO MQ03-FIELD-NBR-A
113000                                    (X-MQ03-MAINT)
113100         MOVE DFHBMUBF           TO MQ03-MAINT-VALUE-A
113200                                    (X-MQ03-MAINT)
113300                                    MQ03-ROUNDING-A
113400                                    (X-MQ03-MAINT)
113500         MOVE DFHBMASB           TO MQ03-FIELD-NBR-LP-A
113600                                    (X-MQ03-MAINT)
113700                                    MQ03-FIELD-NBR-RP-A
113800                                    (X-MQ03-MAINT)
113900                                    MQ03-MAINT-VALUE-LP-A
114000                                    (X-MQ03-MAINT)
114100                                    MQ03-MAINT-VALUE-RP-A
114200                                    (X-MQ03-MAINT)
114300                                    MQ03-ROUNDING-LP-A
114400                                    (X-MQ03-MAINT)
114500                                    MQ03-ROUNDING-RP-A
114600                                    (X-MQ03-MAINT)
114700         MOVE SS08WS-CURSOR      TO MQ03-MAINT-VALUE-L
114800                                    (X-MQ03-MAINT)
114900         MOVE 'MAINTENANCE VALUE GREATER THAN FIELD LENGTH'
115000                                 TO MQ03-ERR-MESSAGE
115100         SET SS08WS-ERROR-SW-YES TO TRUE.
115200*
115300 9329-BAE-EXIT.
115400     EXIT.
115500*
115600 9340-NUMERIC-ZD.
115700*
115800     MOVE ZEROS                  TO WS-NBR-LENGTH.
115900*
116000     MOVE SPACES                 TO MMEXWS-FILE-AREA.
116100     MOVE MMEXWS-EXAM-AREA       TO MMEXWS-FILE-AREA.
116200*
116300     PERFORM
116400         VARYING MMEXWS-FA-REFMOD FROM 1 BY 1
116500         UNTIL MMEXWS-FA-REFMOD IS GREATER THAN MMEXWS-EA-REFMOD
116600         MOVE MMEXWS-FILE-AREA (MMEXWS-FA-REFMOD:1)
116700                                 TO WS-ONE-BYTE
116800         IF  WS-VALID-ONE-BYTE
116900             CONTINUE
117000         ELSE
117100             IF  WS-ONE-BYTE IS NUMERIC
117200                 ADD 1           TO WS-NBR-LENGTH
117300             END-IF
117400         END-IF
117500     END-PERFORM.
117600*
117700     IF  WS-NBR-LENGTH IS GREATER THAN MMEXWS-LENGTH
117800     OR  WS-NBR-LENGTH IS EQUAL TO ZERO
117900         MOVE DFHBMNBF           TO MQ03-FIELD-NBR-A
118000                                    (X-MQ03-MAINT)
118100         MOVE DFHBMUBF           TO MQ03-MAINT-VALUE-A
118200                                    (X-MQ03-MAINT)
118300                                    MQ03-ROUNDING-A
118400                                    (X-MQ03-MAINT)
118500         MOVE DFHBMASB           TO MQ03-FIELD-NBR-LP-A
118600                                    (X-MQ03-MAINT)
118700                                    MQ03-FIELD-NBR-RP-A
118800                                    (X-MQ03-MAINT)
118900                                    MQ03-MAINT-VALUE-LP-A
119000                                    (X-MQ03-MAINT)
119100                                    MQ03-MAINT-VALUE-RP-A
119200                                    (X-MQ03-MAINT)
119300                                    MQ03-ROUNDING-LP-A
119400                                    (X-MQ03-MAINT)
119500                                    MQ03-ROUNDING-RP-A
119600                                    (X-MQ03-MAINT)
119700         MOVE SS08WS-CURSOR      TO MQ03-MAINT-VALUE-L
119800                                    (X-MQ03-MAINT)
119900         IF  WS-NBR-LENGTH IS EQUAL TO ZERO
120000             MOVE 'MAINTENANCE VALUE NOT NUMERIC'
120100                                 TO MQ03-ERR-MESSAGE
120200         ELSE
120300             MOVE 'MAINTENANCE VALUE GREATER THAN FIELD LENGTH'
120400                                 TO MQ03-ERR-MESSAGE
120500         END-IF
120600         SET SS08WS-ERROR-SW-YES TO TRUE.
120700*
120800 9349-NZ-EXIT.
120900     EXIT.
121000*
121100 9400-CROSS-EDIT-ALL-FIELDS.
121200*
121300     IF  MQ03-FIELD-NBR (X-MQ03-MAINT)
121400                                 IS GREATER THAN ZERO
121500     OR  MQ03-MAINT-VALUE (X-MQ03-MAINT)
121600                                 IS NOT EQUAL TO SPACES
121700         IF MQ03-FIELD-NBR (X-MQ03-MAINT)
121800                                 IS EQUAL TO ZERO
121900         OR MQ03-MAINT-VALUE (X-MQ03-MAINT)
122000                                 IS EQUAL TO SPACES
122100             MOVE DFHBMNBF       TO MQ03-FIELD-NBR-A
122200                                    (X-MQ03-MAINT)
122300             MOVE DFHBMUBF       TO MQ03-MAINT-VALUE-A
122400                                    (X-MQ03-MAINT)
122500             MOVE DFHBMASB       TO MQ03-FIELD-NBR-LP-A
122600                                    (X-MQ03-MAINT)
122700                                    MQ03-FIELD-NBR-RP-A
122800                                    (X-MQ03-MAINT)
122900                                    MQ03-MAINT-VALUE-LP-A
123000                                    (X-MQ03-MAINT)
123100                                    MQ03-MAINT-VALUE-RP-A
123200                                    (X-MQ03-MAINT)
123300             MOVE SS08WS-CURSOR  TO MQ03-FIELD-NBR-L
123400                                    (X-MQ03-MAINT)
123500             SET SS08WS-ERROR-SW-YES TO TRUE.
123600*
123700 9499-CEAF-EXIT.
123800     EXIT.
123900*
124000/         DATE VALIDATION ROUTINE
124100     COPY SS05PD.
124200/    NEW ROUTINE FOR JULIAN TO GREGORIAN CONVERSION
124300     COPY SS26PD.
124400/    ROUTINE TO NUMERICALLY EDIT TIME
124500     COPY SS27PD.
124600/         JULIAN TO GREGORIAN DATE ROUTINE
124700     COPY SS08PD.
124800/         LINE 24 PF KEYS ROUTINE
124900     COPY SS15PD.
125000/         EXAM FILE ACCESS ROUTINES
125100     COPY MMEXAO.
125200/         LOG/JOURNAL ACCESS ROUTINES
125300     COPY MML1AO.
125400/         ON-LINE MAP ROUTINES
125500     COPY MB60PD REPLACING 'MBMAPXX' BY 'MBMQ03 '
125600                           MBMAPXXI BY MBMQ03I
125700                           MBMAPXXO BY MBMQ03O.
125800/         ON-LINE PROCEDURES
125900     COPY MB70PD.
126000/
126100     COPY SMFTPXO.
