000100 IDENTIFICATION DIVISION.
000200 PROGRAM-ID. MBOMQ04.
000201*       RELEASE DATE=08/24/01.        REVISION LEVEL=08.06      *
000202*****************************************************************
000203*WARNING.  THIS COMPUTER PROGRAM IS PROTECTED BY COPYRIGHT LAW  *
000204*AND INTERNATIONAL TREATIES.  UNAUTHORIZED REPRODUCTION OR      *
000205*DISTRIBUTION OF THIS PROGRAM, OR ANY PORTION OF IT, MAY RESULT *
000206*IN SEVERE CIVIL AND CRIMINAL PENATLIES, AND WILL BE PROSECUTED *
000207*TO THE MAXIMUM EXTENT POSSIBLE UNDER THE LAW.                  *
000208*COPYRIGHT 1999 PAYSYS INTERNATIONAL, INC.  ALL RIGHTS RESERVED.*
000209*****************************************************************
000300*****************************************************************
000400*                                                               *
000500*   V - PLUS  M E R C H A N T   B A N K C A R D   S Y S T E M   *
000600*                                                               *
000700*      MBOMQ04 - EXAM MASTER FILE ADD/MAINTENANCE/INQUIRY       *
000800*                SCREENS 04                                     *
000900*                                                               *
001000*              1. TRANSIDS                                      *
001100*                 A. MBAQ                                       *
001200*                 B. MBMQ                                       *
001300*                 C. MBQQ                                       *
001400*              2. MAPS USED -                                   *
001500*                 A. MBMQ04 (SCREENS 04)                        *
001600*              3. FILES USED -                                  *
001700*                 A. MMEX   (EXAM FILE)                         *
001800*                 B. MML1   (LOG FILE)                          *
001900*                                                               *
002000*****************************************************************
002100*
002200 ENVIRONMENT DIVISION.
002300 DATA DIVISION.
002400 WORKING-STORAGE SECTION.
002500 01  FILLER                  PIC  X(12)      VALUE '** WS-BEG **'.
002600*         I/O REQUEST BLOCK WORK AREAS
002700     COPY MBIOWS.
002800/         I/O REQUEST BLOCK
002900     COPY MBIORO.
003000/         LOG/JOURNAL WORK AREAS
003100     COPY MML1WS REPLACING ==:MML1:== BY ==MML1==.
003200/         EXAM INITIALIZER RECORD
003300     COPY MMEXIR REPLACING ==:MMEX:== BY ==MMEX==.
003400/         EXAM DATA DICTONARY
003500     COPY MMEXTB REPLACING ==:MMEX:== BY ==MMEX==.
003600/         EXAM WORK AREA
003700     COPY MMEXWS REPLACING ==:MMEX:== BY ==MMEX==.
003800/         DATE WORK AREAS
003900     COPY SS01WS.
004000/         ONLINE WORK AREAS
004100     COPY SS08WS.
004200/
004300     COPY SS00WS.
004400/
004500     COPY SMFTWS.
004600/
004700     COPY SMPTRL REPLACING ==:SMPT:== BY ==SMPT==.
004800/
004900     COPY MB61LK.
005000/
005100 01  WS-MISCELLANEOUS.
005200     03  WS-UPDATE-SW        PIC  X(01)      VALUE 'N'.
005300         88  WS-UPDATE-SW-NO                 VALUE 'N'.
005400         88  WS-UPDATE-SW-YES                VALUE 'Y'.
005500*
005600 01  FILLER                  PIC  X(12)      VALUE '** WS-END **'.
005700/
005800 LINKAGE SECTION.
005900 01  DFHCOMMAREA.
006000     COPY MB60WS.
006100/         EXAM SCREEN 04 MAP DSECT
006200     COPY MBMQ04.
006300/         EXAM SCREEN 04 MAP REDEFINITION
006400     COPY MBMQ04R.
006500/         EXAM FILE MASTER RECORD LAYOUT
006600     COPY MMEXRL REPLACING ==:MMEX:== BY ==MMEX==.
006700/         LOG/JOURNAL FILE RECORD LAYOUT
006800     COPY MML1RL REPLACING ==:MML1:== BY ==MML1==.
006900/
007000 PROCEDURE DIVISION.
007100 0000-HOUSEKEEPING SECTION.
007200 0100-INIT.
007300*
007400     MOVE 'PC01'                 TO MBCA-PROGRAM-LOCATION.
007500     PERFORM MB70PD-ON-LINE-HOUSEKEEPING
007600                                 THRU MB70PD-OLH-EXIT.
007700*
007800     IF  MBCA-RECEIVE-SCREEN
007900         GO TO 2000-RECEIVE-SCREEN.
008000*
008100 1000-SEND-SCREEN SECTION.
008200*
008300****************************************************************
008400*    THIS SECTION BUILDS AND SENDS THE SCREENS 04              *
008500****************************************************************
008600*
008700****************************************************************
008800*    GET CICS STORAGE NEEDED FOR THE MAP                       *
008900****************************************************************
009000*
009100     MOVE 'SC01'                 TO MBCA-PROGRAM-LOCATION.
009200     PERFORM MB60PD-GETMAIN-FOR-MAP
009300                                 THRU MB60PD-GFM-EXIT.
009400*
009500     MOVE MBCA-MERCHANT-ORG      TO MQ04-ORG.
009600     MOVE MBCA-REQUEST-NBR       TO MQ04-REQUEST-NBR.
009700*
009800****************************************************************
009900*    INITIALIZE THE STANDARD MAP LINES                         *
010000****************************************************************
010100*
010200     PERFORM MB60PD-INIT-STD-MAP-LINES
010300                                 THRU MB60PD-ISML-EXIT.
010400*
010500 1050-SORT-SELECTION-DATA.
010600*
010700****************************************************************
010800*    READ THE EXAM FILE FOR UPDATE                             *
010900****************************************************************
011000*
011100     MOVE 'FC02'                 TO MBCA-PROGRAM-LOCATION.
011200     MOVE MBCA-MERCHANT-ORG      TO MBIOWS-MMEX-ORG.
011300     MOVE MBCA-REQUEST-NBR       TO MBIOWS-MMEX-REQUEST-NBR.
011400     SET MBIORO-READ-RANDOM-UPDATE
011500                                 TO TRUE.
011600     PERFORM MMEXAO-ACCESS       THRU MMEXAO-ACCESS-EXIT.
011700*
011800****************************************************************
011900*    REWRITE THE EXAM RECORD WITH SORTED SELECTION CRITERIA    *
012000****************************************************************
012100*
012200     PERFORM MMEXPX-SORT-SELECTION-CRITERIA
012300                                 THRU MMEXPX-SSC-EXIT.
012400*
012500     PERFORM MMEXPX-SCRUNCH-MAINT-CRITERIA
012600                                 THRU MMEXPX-SMC-EXIT.
012700*
012800     MOVE 'FC07'                 TO MBCA-PROGRAM-LOCATION.
012900     SET MBIORO-REWRITE          TO TRUE.
013000     PERFORM MMEXAO-ACCESS       THRU MMEXAO-ACCESS-EXIT.
013100*
013200 1100-BUILD-TRANSLATION-DATA.
013300*
013400****************************************************************
013500*    READ THE EXAM FILE                                        *
013600****************************************************************
013700*
013800     MOVE 'FC02'                 TO MBCA-PROGRAM-LOCATION.
013900     MOVE MBCA-MERCHANT-ORG      TO MBIOWS-MMEX-ORG.
014000     MOVE MBCA-REQUEST-NBR       TO MBIOWS-MMEX-REQUEST-NBR.
014100     SET MBIORO-READ-RANDOM      TO TRUE.
014200     PERFORM MMEXAO-ACCESS       THRU MMEXAO-ACCESS-EXIT.
014300*
014400     MOVE MMEX-DESC              TO MQ04-DESCRIPTION.
014500*
014600     PERFORM MMEXPX-INTERPRET-DATA
014700                                 THRU MMEXPX-ID-EXIT.
014800*
014900 1100-BUILD-SCREEN.
015000*
015100     EVALUATE TRUE
015200         WHEN MMEX-TARGET-STORE-YES
015300             MOVE 'STORE MASTER      '
015400                                 TO MQ04-TARGET-FILE
015500         WHEN MMEX-TARGET-MERCHANT-YES
015600             MOVE 'MERCHANT MASTER   '
015700                                 TO MQ04-TARGET-FILE
015800         WHEN MMEX-TARGET-PRODUCT-YES
015900             MOVE 'MERCHANT PRODUCT  '
016000                                 TO MQ04-TARGET-FILE
016100     END-EVALUATE.
016200*
016300     SET X-MMEXWS-IA             TO MBCA-MBMQ-TRANS-INDEX.
016400*
016500     PERFORM
016600         VARYING X-MQ04-TRANS FROM 1 BY 1
016700         UNTIL X-MQ04-TRANS IS GREATER THAN 16
016800         OR MMEXWS-IA-ENTRY (X-MMEXWS-IA) IS EQUAL TO SPACES
016900         MOVE MMEXWS-IA-ENTRY (X-MMEXWS-IA)
017000                                 TO MQ04-TRANSLATION
017100                                    (X-MQ04-TRANS)
017200         SET X-MMEXWS-IA         UP BY 1
017300     END-PERFORM.
017400*
017500 1200-SET-ATTRIBUTE.
017600*
017700     MOVE SS08WS-CURSOR          TO MQ04-ALT-TRANID-L.
017800*
017900*
018000 1300-CONTINUE.
018100*
018200     IF  MBCA-MBMQ-TRANS-INDEX IS GREATER THAN 16
018300         MOVE DFHBMASB           TO MQ04-BACK-IND-A.
018400*
018500     SET X-MMEXWS-IA             TO MBCA-MBMQ-TRANS-INDEX.
018600     SET X-MMEXWS-IA             UP BY 16.
018700*
018800     IF  MMEXWS-IA-ENTRY (X-MMEXWS-IA) IS EQUAL TO SPACES
018900         NEXT SENTENCE
019000     ELSE
019100         MOVE DFHBMASB           TO MQ04-FWD-IND-A.
019200*
019300     MOVE '*TOP*'                TO SS08WS-LINE-24-PF-KEY-FUNC(3).
019400     MOVE '*BOT*'                TO SS08WS-LINE-24-PF-KEY-FUNC(4).
019500     MOVE '*FWD*'                TO SS08WS-LINE-24-PF-KEY-FUNC(5).
019600     MOVE '*BWD*'                TO SS08WS-LINE-24-PF-KEY-FUNC(6).
019700     MOVE SS08WS-LINE-24         TO MQ04-PF-KEYS.
019800     MOVE 'RESV'                 TO MBCA-PGMX-PF-TRANS-ID (3).
019900     MOVE 'RESV'                 TO MBCA-PGMX-PF-TRANS-ID (4).
020000     MOVE 'RESV'                 TO MBCA-PGMX-PF-TRANS-ID (5).
020100     MOVE 'RESV'                 TO MBCA-PGMX-PF-TRANS-ID (6).
020200*
020300****************************************************************
020400*    SEND THE MAP                                              *
020500****************************************************************
020600*
020700     COMPUTE MBCA-SCREEN-NBR = MBCA-SCREEN-NBR - 50.
020800*
020900     MOVE 'BM01'                 TO MBCA-PROGRAM-LOCATION.
021000     PERFORM MB60PD-SEND-MAP-WITH-ERASE
021100                                 THRU MB60PD-SMWE-EXIT.
021200*
021300****************************************************************
021400*    RETURN TO CICS                                            *
021500****************************************************************
021600*
021700     MOVE 'PC03'                 TO MBCA-PROGRAM-LOCATION.
021800     PERFORM MB70PD-RETURN-TRANS-ID
021900                                 THRU MB70PD-RTI-EXIT.
022000/
022100 2000-RECEIVE-SCREEN SECTION.
022200*
022300****************************************************************
022400*    THIS SECTION RECEIVES THE 04 SCREEN                       *
022500****************************************************************
022600*
022700     MOVE 'BM02'                 TO MBCA-PROGRAM-LOCATION.
022800     PERFORM MB60PD-RECEIVE-MAP  THRU MB60PD-RM-EXIT.
022900*
023000****************************************************************
023100*    CHECK FOR ANOTHER TRANSACTION ID ENTERED BY THE USER      *
023200****************************************************************
023300*
023400     MOVE 'PC04'                 TO MBCA-PROGRAM-LOCATION.
023500     PERFORM MB60PD-NEW-TRANS-ROUTINE
023600                                 THRU MB60PD-NTR-EXIT.
023700*
023800     SET X-MMEXWS-IA             TO MBCA-MBMQ-TRANS-INDEX.
023900*
024000     IF  MBCA-PTI-FUNCTION-IS-INQUIRY
024100         GO TO 2600-SETUP-COMMAREA.
024200*
024300****************************************************************
024400*    READ RANDOM THE EXAM RECORD                               *
024500****************************************************************
024600*
024700     MOVE 'FC03'                 TO MBCA-PROGRAM-LOCATION.
024800     MOVE MBCA-MERCHANT-ORG      TO MBIOWS-MMEX-ORG.
024900     MOVE MBCA-REQUEST-NBR       TO MBIOWS-MMEX-REQUEST-NBR.
025000     SET MBIORO-READ-RANDOM-UPDATE
025100                                 TO TRUE.
025200     PERFORM MMEXAO-ACCESS       THRU MMEXAO-ACCESS-EXIT.
025300*
025400     PERFORM MMEXPX-INTERPRET-DATA
025500                                 THRU MMEXPX-ID-EXIT.
025600/
025700 2400-UPDATE-FILE.
025800*
025900*************************************
026000*    OBTAIN STORAGE FOR LOG FILE    *
026100*    RECORD IF DOING MAINTENANCE    *
026200*************************************
026300*
026400     MOVE 'SC02'                 TO MBCA-PROGRAM-LOCATION.
026500     SET MBIORO-GETMAIN          TO TRUE.
026600     PERFORM MML1AO-ACCESS       THRU MML1AO-ACCESS-EXIT.
026700*
026800 2650-UPDATE-MMEX.
026900*
027000     IF  MBCA-PTI-FUNCTION-IS-ADD
027100         SET MMEX-STATUS-COMPLETE
027200                                 TO TRUE
027300         SET MMEX-ADD-COMPLETED  TO TRUE
027400         MOVE MBCA-START-DATE    TO MMEX-LAST-MAINT-DATE
027500         MOVE MBCA-OPERATOR-ID   TO MMEX-LAST-MAINT-OPER
027600                                    MMEX-ORIG-OPER
027700         SET WS-UPDATE-SW-YES    TO TRUE
027800         MOVE LENGTH OF MMEX-RECORD
027900                                 TO MML1-VARIABLE-LENGTH
028000         MOVE MMEX-RECORD        TO MML1-ADD-AREA
028100         MOVE ZEROS              TO MML1-FIELD-CODE
028200                                    MML1-FIELD-OCCURRENCE
028300                                    MML1-FIELD-OCCURRENCE-2
028400         PERFORM 9050-WRITE-LOG-REC
028500                                 THRU 9099-WLR-EXIT.
028600*
028700****************************************************
028800*    REWRITE THE EXAM RECORD IF                    *
028900*    FIELDS HAVE BEEN CHANGED ON THE SCREEN, OR    *
029000*    UNLOCK IT IF THEY HAVE NOT                    *
029100****************************************************
029200*
029300     IF  WS-UPDATE-SW-YES
029400         MOVE 'FC07'             TO MBCA-PROGRAM-LOCATION
029500         SET MBIORO-REWRITE      TO TRUE
029600         PERFORM MMEXAO-ACCESS   THRU MMEXAO-ACCESS-EXIT
029700     ELSE
029800         MOVE 'FC08'             TO MBCA-PROGRAM-LOCATION
029900         SET MBIORO-UNLOCK       TO TRUE
030000         PERFORM MMEXAO-ACCESS   THRU MMEXAO-ACCESS-EXIT.
030100/
030200 2600-SETUP-COMMAREA.
030300*
030400****************************************************************
030500*    SET UP COMMAREA FIELDS AND TRANSFER TO THE NEXT PROGRAM   *
030600****************************************************************
030700*
030800     MOVE MBCA-EIBAID            TO SS08WS-EIBAID.
030900*
031000     IF  (SS08WS-VALID-PF3
031100     OR  SS08WS-EIBAID-VALID-PF3)
031200         MOVE 1                  TO MBCA-MBMQ-TRANS-INDEX
031300         MOVE 54                 TO MBCA-SCREEN-NBR
031400         GO TO 2690-PF-KEY-BYPASS.
031500*
031600     IF  (SS08WS-VALID-PF4
031700     OR  SS08WS-EIBAID-VALID-PF4)
031800         PERFORM
031900             VARYING X-MMEXWS-IA FROM 112 BY -1
032000             UNTIL X-MMEXWS-IA IS LESS THAN 1
032100             IF  MMEXWS-IA-TABLE (X-MMEXWS-IA)
032200                                 IS NOT EQUAL TO SPACES
032300                 IF  X-MMEXWS-IA IS LESS THAN 17
032400                     MOVE 1      TO MBCA-MBMQ-TRANS-INDEX
032500                     MOVE 54         TO MBCA-SCREEN-NBR
032600                     GO TO 2690-PF-KEY-BYPASS
032700                 ELSE
032800                     SET MBCA-MBMQ-TRANS-INDEX
032900                                 TO X-MMEXWS-IA
033000                     COMPUTE MBCA-MBMQ-TRANS-INDEX =
033100                             MBCA-MBMQ-TRANS-INDEX - 15
033200                     MOVE 54         TO MBCA-SCREEN-NBR
033300                     GO TO 2690-PF-KEY-BYPASS
033400                 END-IF
033500             END-IF
033600         END-PERFORM
033700         MOVE 1                  TO MBCA-MBMQ-TRANS-INDEX
033800         MOVE 54                 TO MBCA-SCREEN-NBR
033900         GO TO 2690-PF-KEY-BYPASS.
034000*
034100     IF  SS08WS-VALID-PF5
034200     OR  SS08WS-EIBAID-VALID-PF5
034300         IF  MBCA-MBMQ-TRANS-INDEX IS GREATER THAN 96
034400             MOVE 97             TO MBCA-MBMQ-TRANS-INDEX
034500             MOVE 54             TO MBCA-SCREEN-NBR
034600             GO TO 2690-PF-KEY-BYPASS
034700         ELSE
034800             ADD 16              TO MBCA-MBMQ-TRANS-INDEX
034900             SET X-MMEXWS-IA     TO MBCA-MBMQ-TRANS-INDEX
035000             IF  MMEXWS-IA-TABLE (X-MMEXWS-IA)
035100                                 IS EQUAL TO SPACES
035200                 SUBTRACT 16     FROM MBCA-MBMQ-TRANS-INDEX
035300                 MOVE 54         TO MBCA-SCREEN-NBR
035400                 GO TO 2690-PF-KEY-BYPASS
035500             ELSE
035600                 MOVE 54         TO MBCA-SCREEN-NBR
035700                 GO TO 2690-PF-KEY-BYPASS.
035800*
035900     IF  (SS08WS-VALID-PF6
036000     OR  SS08WS-EIBAID-VALID-PF6)
036100         IF  MBCA-MBMQ-TRANS-INDEX IS LESS THAN 16
036200             MOVE 1              TO MBCA-MBMQ-TRANS-INDEX
036300             MOVE 54             TO MBCA-SCREEN-NBR
036400             GO TO 2690-PF-KEY-BYPASS
036500         ELSE
036600             COMPUTE MBCA-MBMQ-TRANS-INDEX
036700                                 = MBCA-MBMQ-TRANS-INDEX
036800                                 - 16
036900             MOVE 54             TO MBCA-SCREEN-NBR
037000             GO TO 2690-PF-KEY-BYPASS.
037100*
037200     PERFORM MB60PD-EDIT-PAGE-NBR
037300                                 THRU MB60PD-EPN-EXIT.
037400*
037500     IF  SS08WS-VALID-PF-KEY
037600     OR  SS08WS-EIBAID-VALID-PF-KEY
037700         SET MBCA-INITIAL-SCREEN-NBR
037800                                 TO TRUE.
037900*
038000 2690-PF-KEY-BYPASS.
038100*
038200     MOVE 'PC06'                 TO MBCA-PROGRAM-LOCATION.
038300     PERFORM MB70PD-XCTL-TO-MBOXCTL
038400                                 THRU MB70PD-XTM-EXIT.
038500/
038600 9000-PERFORMED-ROUTINES-SECT SECTION.
038700*
038800*
038900 9050-WRITE-LOG-REC.
039000*
039100*****************************************************************
039200*    WRITE THE LOG/JOURNAL FILE RECORD                          *
039300*****************************************************************
039400*
039500     MOVE 'EX'                   TO MML1-FILE-CODE.
039600     MOVE MBCA-MERCHANT-ORG      TO MML1-MMEX-ORG.
039700     MOVE MBCA-REQUEST-NBR       TO MML1-MMEX-REQUEST-NBR.
039800     MOVE MBCA-SIGNON-NAME       TO MML1-SIGNON-NAME.
039900     MOVE MBCA-TERMINAL-ID       TO MML1-TERMINAL-ID.
040000     MOVE ZEROES                 TO MML1-SOURCE-CODE.
040100*
040200     MOVE 'FC09'                 TO MBCA-PROGRAM-LOCATION.
040300     SET MBIORO-WRITE            TO TRUE.
040400     PERFORM MML1AO-ACCESS       THRU MML1AO-ACCESS-EXIT.
040500     MOVE SPACES                 TO MML1-VARIABLE-AREA.
040600*
040700 9099-WLR-EXIT.
040800     EXIT.
040900*
041000/         DATE VALIDATION ROUTINE
041100     COPY SS05PD.
041200/    NEW ROUTINE FOR JULIAN TO GREGORIAN CONVERSION
041300     COPY SS26PD.
041400/    ROUTINE TO NUMERICALLY EDIT TIME
041500     COPY SS27PD.
041600/         JULIAN TO GREGORIAN DATE ROUTINE
041700     COPY SS08PD.
041800/         LINE 24 PF KEYS ROUTINE
041900     COPY SS15PD.
042000/         EXAM SORT SELECTION CRITERIA
042100     COPY MMEXPX.
042200/         EXAM FILE ACCESS ROUTINES
042300     COPY MMEXAO.
042400/         LOG/JOURNAL ACCESS ROUTINES
042500     COPY MML1AO.
042600/         ON-LINE MAP ROUTINES
042700     COPY MB60PD REPLACING 'MBMAPXX' BY 'MBMQ04 '
042800                           MBMAPXXI BY MBMQ04I
042900                           MBMAPXXO BY MBMQ04O.
043000/         ON-LINE PROCEDURES
043100     COPY MB70PD.
043200/
043300     COPY SMFTPXO.
