000100 IDENTIFICATION DIVISION.
000200 PROGRAM-ID. MBOMR00.
000201*       RELEASE DATE=08/24/01.        REVISION LEVEL=08.06      *
000202*****************************************************************
000203*WARNING.  THIS COMPUTER PROGRAM IS PROTECTED BY COPYRIGHT LAW  *
000204*AND INTERNATIONAL TREATIES.  UNAUTHORIZED REPRODUCTION OR      *
000205*DISTRIBUTION OF THIS PROGRAM, OR ANY PORTION OF IT, MAY RESULT *
000206*IN SEVERE CIVIL AND CRIMINAL PENATLIES, AND WILL BE PROSECUTED *
000207*TO THE MAXIMUM EXTENT POSSIBLE UNDER THE LAW.                  *
000208*COPYRIGHT 1999 PAYSYS INTERNATIONAL, INC.  ALL RIGHTS RESERVED.*
000209*****************************************************************
000300*****************************************************************
000400*                                                               *
000500*               M E R C H A N T   S Y S T E M                   *
000600*                                                               *
000700*      MBOMR00 - ON-LINE DISCOUNT RATE TABLE ADD/MAINT/INQ      *
000800*                LOCATE SCREEN 00                               *
000900*                                                               *
001000*              1. TRANSIDS                                      *
001100*                 A. MBAR                                       *
001200*                 B. MBMR                                       *
001300*                 C. MBQR                                       *
001400*              2. MAPS USED -                                   *
001500*                 A. MBMR00 (LOCATE MAP)                        *
001600*              3. FILES USED -                                  *
001700*                 A. MMOC (ORG CONTROL FILE)                    *
001800*                 B. MMRT (DISCOUNT RATE TABLE FILE)            *
001900*                                                               *
002000*****************************************************************
002100*
002200 ENVIRONMENT DIVISION.
002300*
002400 DATA DIVISION.
002500*
002600 WORKING-STORAGE SECTION.
002700*
002800 01  FILLER                  PIC  X(12)      VALUE
002900     '** WS-BEG **'.
003000*
003100 01  FILLER                  PIC  X(14)      VALUE
003200     'MISCELLANEOUS:'.
003300*
003400 01  WS-MISCELLANEOUS.
003500     03  WS-ORG-LOW          PIC S9(03)      COMP-3
003600                                             VALUE +001.
003700     03  WS-ORG-HIGH         PIC S9(03)      COMP-3
003800                                             VALUE +998.
003900     03  WS-COPY-SW          PIC  X(01)      VALUE 'N'.
004000         88  WS-COPY-SW-NO                   VALUE 'N'.
004100         88  WS-COPY-SW-YES                  VALUE 'Y'.
004200/
004300 01  FILLER                  PIC  X(29)      VALUE
004400     'I/O REQUEST BLOCK WORK AREAS:'.
004500*
004600     COPY MBIOWS.
004700/
004800 01  FILLER                  PIC  X(18)      VALUE
004900     'I/O REQUEST BLOCK:'.
005000*
005100     COPY MBIORO.
005200/
005300 01  FILLER                  PIC  X(21)      VALUE
005400     'ERROR MESSAGES TABLE:'.
005500*
005600     COPY MBEMWS.
005700/
005800 01  FILLER                  PIC  X(39)      VALUE
005900     'DISCOUNT RATE TABLE INITIALIZER RECORD:'.
006000*
006100     COPY MMRTIR.
006200/
006300 01  FILLER                  PIC  X(20)      VALUE
006400     'CCS DATE WORK AREAS:'.
006500*
006600     COPY SS01WS.
006700/
006800 01  FILLER                  PIC  X(15)      VALUE
006900     'CCS WORK AREAS:'.
007000*
007100     COPY SS08WS.
007200/
007300     COPY SS00WS.
007400/
007500     COPY SMFTWS.
007600/
007700     COPY SMPTRL REPLACING ==:SMPT:== BY ==SMPT==.
007800/
007900     COPY MB61LK.
008000/
008100 01  FILLER                  PIC  X(12)      VALUE
008200     '** WS-END **'.
008300/
008400 LINKAGE SECTION.
008500*
008600 01  DFHCOMMAREA.
008700*
008800     COPY MB60WS.
008900/
009000****************************************
009100*    DISCOUNT RATE TABLE LOCATE MAP    *
009200****************************************
009300*
009400     COPY MBMR00.
009500/
009600*****************************************************
009700*    DISCOUNT RATE TABLE LOCATE MAP REDEFINITION    *
009800*****************************************************
009900*
010000     COPY MBMR00R.
010100/
010200***************************
010300*    ORG RECORD LAYOUT    *
010400***************************
010500*
010600     COPY MMOCRL.
010700/
010800*******************************************
010900*    DISCOUNT RATE TABLE RECORD LAYOUT    *
011000*******************************************
011100*
011200     COPY MMRTRL.
011300/
011400 PROCEDURE DIVISION.
011500*
011600 A000-HOUSEKEEPING SECTION.
011700*
011800 A020-INIT.
011900*
012000     MOVE 'PC01'                 TO MBCA-PROGRAM-LOCATION.
012100     PERFORM MB70PD-ON-LINE-HOUSEKEEPING
012200                                 THRU MB70PD-OLH-EXIT.
012300*
012400     IF  MBCA-RECEIVE-SCREEN
012500         GO TO C000-RECEIVE-SCREEN.
012600/
012700 B000-SEND-SCREEN SECTION.
012800*
012900*********************************************
013000*    GET CICS STORAGE NEEDED FOR THE MAP    *
013100*********************************************
013200*
013300     MOVE 'SC01'                 TO MBCA-PROGRAM-LOCATION.
013400     PERFORM MB60PD-GETMAIN-FOR-MAP
013500                                 THRU MB60PD-GFM-EXIT.
013600*
013700*****************************************************************
013800*    CHECK KEY CODES                                            *
013900* 1. IF ADD FUNCTION, BYPASS CHECK OF KEY CODES.                *
014000* 2. IF INITIAL KEY CODE, BYPASS CHECK OF KEY CODES.            *
014100* 3. IF MMRT KEY CODE, IT MUST HAVE AN ORGANIZATION NUMBER      *
014200*    GREATER THAN ZERO AND A NUMERIC TABLE NUMBER.  IF          *
014300*    DIRECT, GO TO THE RECEIVE EDITING ROUTINE SINCE WE HAVE    *
014400*    PLUGGED THE ORGANIZATION AND TABLE IN THE MAP.  IF AN      *
014500*    ERROR OCCURS IN THE RECEIVE SCREEN ROUTINE, IT WILL        *
014600*    HANDLE BUILDING THE MAP AND IT WILL SEND ITS OWN SCREEN.   *
014700*    THIS IS WHY LOCATE PROGRAMS ALWAYS SEND WITH ERASE         *
014800*    NO MATTER WHICH ROUTINE YOU ARE IN.  IF NOT DIRECT, PLUG   *
014900*    THE ORGANIZATION AND TABLE INTO THE MAP AND BYPASS         *
015000*    ANY OTHER CHECKING OF THE KEY CODE.                        *
015100* 4. IF 2 AND 3 ARE FALSE, SEE IF THE MBCA-MERCHANT-ORG IS      *
015200*    GREATER THAN ZERO.  IF IT IS, PLUG IT INTO THE MAP.  IF    *
015300*    THE MBCA-TABLE IS GREATER THAN ZERO, PLUG IT INTO THE      *
015400*    MAP.                                                       *
015500*****************************************************************
015600*
015700     IF  MBCA-INITIAL-KEY-CODE
015800     OR  MBCA-PTI-FUNCTION-IS-ADD
015900         GO TO B020-BUILD-SCREEN.
016000*
016100     IF  MBCA-MMRT-KEY-CODE
016200         IF  MBCA-MERCHANT-ORG IS GREATER THAN ZERO
016300             MOVE MBCA-MERCHANT-ORG
016400                                 TO MR00-ORG
016500             MOVE DFHBMUNF       TO MR00-ORG-A
016600             MOVE 3              TO MR00-ORG-L
016700             IF  MBCA-TABLE         IS GREATER THAN ZERO
016800                 MOVE MBCA-TABLE TO MR00-TABLE
016900                 MOVE DFHBMUNF   TO MR00-TABLE-A
017000                 MOVE 9          TO MR00-TABLE-L
017100                 IF  MBCA-TT-VALID
017200                     MOVE MBCA-TABLE-TYPE
017300                                 TO MR00-TABLE-TYPE
017400                     MOVE DFHBMFSE
017500                                 TO MR00-TABLE-TYPE-A
017600                     MOVE 1      TO MR00-TABLE-TYPE-L
017700
017800                 ELSE
017900                     GO TO B010-CHECK-KEY-CODE
018000             ELSE
018100                 GO TO B010-CHECK-KEY-CODE
018200         ELSE
018300             GO TO B010-CHECK-KEY-CODE
018400     ELSE
018500         GO TO B010-CHECK-KEY-CODE.
018600*
018700     IF  MBCA-DIRECT-TRANSFER-CODE
018800     AND MBCA-INITIAL-SCREEN-NBR
018900         MOVE 00                 TO MBCA-SCREEN-NBR
019000         GO TO C282-READ-ORG
019100     ELSE
019200         GO TO B020-BUILD-SCREEN.
019300*
019400 B010-CHECK-KEY-CODE.
019500*
019600     IF  MBCA-VALID-KEY-CODES
019700         IF  MBCA-MERCHANT-ORG IS GREATER THAN ZERO
019800             MOVE MBCA-MERCHANT-ORG
019900                                 TO MR00-ORG
020000             MOVE DFHBMUNF       TO MR00-ORG-A
020100             IF  MBCA-TABLE IS GREATER THAN ZERO
020200                 MOVE MBCA-TABLE TO MR00-TABLE
020300                 MOVE DFHBMUNF   TO MR00-TABLE-A
020400                 IF  MBCA-TT-VALID
020500                     MOVE MBCA-TABLE-TYPE
020600                                 TO MR00-TABLE-TYPE
020700                     MOVE DFHBMFSE
020800                                 TO MR00-TABLE-TYPE-A.
020900*
021000 B020-BUILD-SCREEN.
021100*
021200*******************************************
021300*    INITIALIZE THE STANDARD MAP LINES    *
021400*******************************************
021500*
021600     MOVE SS08WS-CURSOR          TO MR00-ORG-L.
021700     MOVE 00                     TO MBCA-SCREEN-NBR.
021800     PERFORM MB60PD-INIT-STD-MAP-LINES
021900                                 THRU MB60PD-ISML-EXIT.
022000*
022100     IF  MBCA-PTI-FUNCTION-IS-MAINT
022200     OR  MBCA-PTI-FUNCTION-IS-INQUIRY
022300         MOVE DFHBMDAS           TO MR00-COPY-ORG-LIT-A
022400                                    MR00-COPY-ORG-LP-A
022500                                    MR00-COPY-ORG-RP-A
022600                                    MR00-COPY-TABLE-LIT-A
022700                                    MR00-COPY-TABLE-LP-A
022800                                    MR00-COPY-TABLE-RP-A
022900                                    MR00-COPY-TABLE-TYPE-LIT-A
023000                                    MR00-COPY-TABLE-TYPE-LP-A
023100                                    MR00-COPY-TABLE-TYPE-RP-A
023200         MOVE DFHBMASK           TO MR00-COPY-ORG-A
023300                                    MR00-COPY-TABLE-A
023400                                    MR00-COPY-TABLE-TYPE-A.
023500     IF  MBCA-PTI-FUNCTION-IS-ADD
023600         MOVE ZERO               TO MR00-TABLE-L
023700         MOVE DFHBMUNN           TO MR00-TABLE-A
023800         MOVE LOW-VALUES         TO MR00-TABLE-X.
023900*
024000**********************
024100*    SEND THE MAP    *
024200**********************
024300*
024400     MOVE 'BM01'                 TO MBCA-PROGRAM-LOCATION.
024500     PERFORM MB60PD-SEND-MAP-WITH-ERASE
024600                                 THRU MB60PD-SMWE-EXIT.
024700*
024800************************
024900*    RETURN TO CICS    *
025000************************
025100*
025200     MOVE 'PC02'                 TO MBCA-PROGRAM-LOCATION.
025300     PERFORM MB70PD-RETURN-TRANS-ID
025400                                 THRU MB70PD-RTI-EXIT.
025500/
025600 C000-RECEIVE-SCREEN SECTION.
025700*
025800*************************************************
025900*    THIS SECTION RECEIVES THE LOCATE SCREEN    *
026000*************************************************
026100*
026200     MOVE 'BM02'                 TO MBCA-PROGRAM-LOCATION.
026300     PERFORM MB60PD-RECEIVE-MAP  THRU MB60PD-RM-EXIT.
026400*
026500**************************************************************
026600*    CHECK FOR ANOTHER TRANSACTION ID ENTERED BY THE USER    *
026700**************************************************************
026800*
026900     MOVE 'PC03'                 TO MBCA-PROGRAM-LOCATION.
027000     PERFORM MB60PD-NEW-TRANS-ROUTINE
027100                                 THRU MB60PD-NTR-EXIT.
027200*
027300 C020-FIELD-EDITS.
027400*
027500     MOVE 'N'                    TO SS08WS-ERROR.
027600     MOVE MBCA-EIBAID            TO SS08WS-EIBAID.
027700*
027800     IF  (MR00-ORG-L IS LESS THAN 1
027900     AND  MR00-TABLE-L IS LESS THAN 1
028000     AND  MR00-TABLE-TYPE-L IS LESS THAN 1
028100     AND  MR00-COPY-ORG-L IS LESS THAN 1
028200     AND  MR00-COPY-TABLE-L IS LESS THAN 1
028300     AND  MR00-COPY-TABLE-TYPE-L IS LESS THAN 1)
028400     AND (SS08WS-VALID-PF-KEY
028500     OR   SS08WS-EIBAID-VALID-PF-KEY)
028600         SET MBCA-INITIAL-SCREEN-NBR
028700                                 TO TRUE
028800         GO TO F090-TRANSFER-XCTL.
028900*
029000******************************************************
029100*    RESET THE FIELD ARRIBUTES TO THEIR NORMAL       *
029200*    PRIOR STATE PRIOR TO ANY EDITING BEING DONE.    *
029300******************************************************
029400*
029500     MOVE DFHBMUNP               TO MR00-TABLE-TYPE-A.
029600     MOVE DFHBMUNN               TO MR00-ORG-A
029700                                    MR00-TABLE-A.
029800     MOVE DFHBMASK               TO MR00-ORG-LP-A
029900                                    MR00-ORG-RP-A
030000                                    MR00-TABLE-LP-A
030100                                    MR00-TABLE-RP-A
030200                                    MR00-TABLE-TYPE-LP-A
030300                                    MR00-TABLE-TYPE-RP-A.
030400*
030500     IF  MBCA-PTI-FUNCTION-IS-ADD
030600         MOVE DFHBMUNN           TO MR00-COPY-ORG-A
030700                                    MR00-COPY-TABLE-A
030800         MOVE DFHBMUNP           TO MR00-COPY-TABLE-TYPE-A
030900         MOVE DFHBMASK           TO MR00-COPY-ORG-LP-A
031000                                    MR00-COPY-ORG-RP-A
031100                                    MR00-COPY-TABLE-LP-A
031200                                    MR00-COPY-TABLE-RP-A
031300                                    MR00-COPY-TABLE-TYPE-LP-A
031400                                    MR00-COPY-TABLE-TYPE-RP-A
031500     ELSE
031600         GO TO C280-EDIT-ORG.
031700*
031800************************************************
031900*    BYPASS THE COPY EDITS IF NEITHER THE      *
032000*    COPY ORG OR COPY TABLE WERE ENTERED.      *
032100************************************************
032200*
032300     IF  MR00-COPY-ORG-L IS EQUAL TO ZERO
032400     AND MR00-COPY-TABLE-L IS EQUAL TO ZERO
032500     AND MR00-COPY-TABLE-TYPE-L IS EQUAL TO ZERO
032600         GO TO C280-EDIT-ORG.
032700*
032800 C090-EDIT-COPY-ORG.
032900*
033000     IF  MR00-COPY-ORG-L IS EQUAL TO ZERO
033100     OR  MR00-COPY-ORG IS NOT NUMERIC
033200     OR  MR00-COPY-ORG IS LESS THAN MBCA-ORG-LOW
033300     OR  MR00-COPY-ORG IS GREATER THAN MBCA-ORG-HIGH
033400     OR  MR00-COPY-ORG IS LESS THAN WS-ORG-LOW
033500     OR  MR00-COPY-ORG IS GREATER THAN WS-ORG-HIGH
033600         MOVE MBEMWS-INVALID-ORG TO MR00-ERR-MESSAGE
033700         GO TO C100-COPY-ORG-ERROR.
033800*
033900************************************************
034000*    READ THE COPY ORGANIZATION RECORD.  IT    *
034100*    MUST BE ON FILE AND AN ACTIVE RECORD.     *
034200************************************************
034300*
034400     MOVE MR00-COPY-ORG          TO MBIOWS-MMOC-ORG.
034500     MOVE SS08WS-CICS-FC-NOTFND  TO MBIORO-TEMP-STATUS-1.
034600     MOVE 'FC01'                 TO MBCA-PROGRAM-LOCATION.
034700     SET MBIORO-READ-RANDOM      TO TRUE.
034800     PERFORM MMOCAO-ACCESS       THRU MMOCAO-ACCESS-EXIT.
034900*
035000     IF  SS08WS-RC-FC-NOTFND
035100         MOVE MBEMWS-NOT-ON-FILE TO MR00-ERR-MESSAGE
035200     ELSE
035300         IF  MMOC-ADD-PENDING
035400             MOVE MBEMWS-ADD-PENDING
035500                                 TO MR00-ERR-MESSAGE
035600         ELSE
035700             IF  MMOC-REC-PURGED
035800                 MOVE MBEMWS-REC-PURGED
035900                                 TO MR00-ERR-MESSAGE
036000             ELSE
036100                 MOVE DFHBMUNF   TO MR00-COPY-ORG-A
036200                 GO TO C120-COPY-EDIT-TYPE.
036300*
036400 C100-COPY-ORG-ERROR.
036500*
036600     MOVE 'Y'                    TO SS08WS-ERROR.
036700     MOVE DFHBMASB               TO MR00-COPY-ORG-LP-A
036800                                    MR00-COPY-ORG-RP-A.
036900     MOVE SS08WS-CURSOR          TO MR00-COPY-ORG-L.
037000     MOVE DFHBMNBF               TO MR00-COPY-ORG-A.
037100     MOVE DFHBMUNF               TO MR00-ORG-A
037200                                    MR00-COPY-TABLE-A
037300                                    MR00-TABLE-A.
037400     MOVE DFHBMFSE               TO MR00-TABLE-TYPE-A
037500                                    MR00-COPY-TABLE-TYPE-A.
037600     GO TO D000-RETURN-ERRORS.
037700*
037800 C120-COPY-EDIT-TYPE.
037900*
038000     IF  MR00-COPY-TABLE-TYPE-L IS EQUAL TO ZERO
038100     OR  NOT MR00-COPY-TABLE-TYPE-VALID
038200         MOVE MBEMWS-INVALID-TYPE
038300                                 TO MR00-ERR-MESSAGE
038400         GO TO C140-COPY-TABLE-TYPE-ERROR.
038500*
038600     MOVE DFHBMFSE               TO MR00-COPY-TABLE-TYPE-A.
038700     MOVE MR00-TABLE-TYPE        TO MBCA-TABLE-TYPE.
038800     GO TO C160-EDIT-COPY-TABLE.
038900*
039000 C140-COPY-TABLE-TYPE-ERROR.
039100*
039200     MOVE 'Y'                    TO SS08WS-ERROR.
039300     MOVE DFHBMASB               TO MR00-COPY-TABLE-TYPE-LP-A
039400                                    MR00-COPY-TABLE-TYPE-RP-A.
039500     MOVE SS08WS-CURSOR          TO MR00-COPY-TABLE-TYPE-L.
039600     MOVE DFHBMUBF               TO MR00-COPY-TABLE-TYPE-A.
039700*
039800 C160-EDIT-COPY-TABLE.
039900*
040000     IF  MR00-COPY-TABLE-L IS EQUAL TO ZERO
040100     OR  MR00-COPY-TABLE   IS NOT NUMERIC
040200     OR  MR00-COPY-TABLE   IS EQUAL TO ZEROES
040300         MOVE MBEMWS-INVALID-TABLE
040400                                 TO MR00-ERR-MESSAGE
040500         GO TO C178-COPY-TABLE-ERROR.
040600*
040700*****************************************************************
040800*    READ THE DISCOUNT RATE TABLE TO ENSURE THAT THE TABLE      *
040900*    RECORD TO BE COPIED IS ON FILE AND AN ACTIVE RECORD        *
041000*****************************************************************
041100*
041200     MOVE MR00-COPY-ORG          TO MBIOWS-MMRT-ORG.
041300     MOVE MR00-COPY-TABLE        TO MBIOWS-MMRT-TABLE-NBR.
041400     MOVE MR00-COPY-TABLE-TYPE   TO MBIOWS-MMRT-TABLE-TYPE.
041500     MOVE SS08WS-CICS-FC-NOTFND  TO MBIORO-TEMP-STATUS-1.
041600     MOVE 'FC02'                 TO MBCA-PROGRAM-LOCATION.
041700     SET MBIORO-READ-RANDOM      TO TRUE.
041800     PERFORM MMRTAO-ACCESS       THRU MMRTAO-ACCESS-EXIT.
041900*
042000     IF  SS08WS-RC-FC-NOTFND
042100         MOVE MBEMWS-NOT-ON-FILE TO MR00-ERR-MESSAGE
042200     ELSE
042300         IF  MMRT-ADD-PENDING
042400             MOVE MBEMWS-ADD-PENDING
042500                                 TO MR00-ERR-MESSAGE
042600         ELSE
042700             IF  MMRT-REC-PURGED
042800                 MOVE MBEMWS-REC-PURGED
042900                                 TO MR00-ERR-MESSAGE
043000             ELSE
043100                 MOVE 'Y'        TO WS-COPY-SW
043200                 MOVE DFHBMUNF   TO MR00-COPY-TABLE-A
043300                 GO TO C280-EDIT-ORG.
043400*
043500 C178-COPY-TABLE-ERROR.
043600*
043700     MOVE 'Y'                    TO SS08WS-ERROR.
043800     MOVE DFHBMASB               TO MR00-COPY-TABLE-LP-A
043900                                    MR00-COPY-TABLE-RP-A
044000                                    MR00-COPY-TABLE-TYPE-LP-A
044100                                    MR00-COPY-TABLE-TYPE-RP-A.
044200     MOVE SS08WS-CURSOR          TO MR00-COPY-TABLE-L.
044300     MOVE DFHBMNBF               TO MR00-COPY-TABLE-A.
044400     MOVE DFHBMUBF               TO MR00-COPY-TABLE-TYPE-A.
044500     MOVE DFHBMUNF               TO MR00-ORG-A
044600                                    MR00-TABLE-A.
044700     MOVE DFHBMFSE               TO MR00-TABLE-TYPE-A.
044800     GO TO D000-RETURN-ERRORS.
044900*
045000 C280-EDIT-ORG.
045100*
045200     IF  MR00-ORG-L IS EQUAL TO ZERO
045300     OR  MR00-ORG IS NOT NUMERIC
045400     OR  MR00-ORG IS LESS THAN MBCA-ORG-LOW
045500     OR  MR00-ORG IS GREATER THAN MBCA-ORG-HIGH
045600     OR  MR00-ORG IS LESS THAN WS-ORG-LOW
045700     OR  MR00-ORG IS GREATER THAN WS-ORG-HIGH
045800         MOVE MBEMWS-INVALID-ORG TO MR00-ERR-MESSAGE
045900         GO TO C298-ORG-ERROR.
046000*
046100 C282-READ-ORG.
046200*
046300************************************************
046400*    READ THE ORGANIZATION RECORD.  IT MUST    *
046500*    BE ON FILE AND AN ACTIVE RECORD.          *
046600************************************************
046700*
046800     MOVE MR00-ORG               TO MBIOWS-MMOC-ORG.
046900     MOVE 'FC03'                 TO MBCA-PROGRAM-LOCATION.
047000     MOVE SS08WS-CICS-FC-NOTFND  TO MBIORO-TEMP-STATUS-1.
047100     SET MBIORO-READ-RANDOM      TO TRUE.
047200     PERFORM MMOCAO-ACCESS       THRU MMOCAO-ACCESS-EXIT.
047300*
047400     IF  SS08WS-RC-FC-NOTFND
047500         MOVE MBEMWS-NOT-ON-FILE TO MR00-ERR-MESSAGE
047600     ELSE
047700         IF  MMOC-ADD-PENDING
047800             MOVE MBEMWS-ADD-PENDING
047900                                 TO MR00-ERR-MESSAGE
048000         ELSE
048100             IF  MMOC-REC-PURGED
048200                 MOVE MBEMWS-REC-PURGED
048300                                 TO MR00-ERR-MESSAGE
048400             ELSE
048500                 MOVE DFHBMUNF   TO MR00-ORG-A
048600                 MOVE MR00-ORG   TO MBCA-MERCHANT-ORG
048700                 GO TO C300-EDIT-TYPE.
048800*
048900 C298-ORG-ERROR.
049000*
049100     MOVE 'Y'                    TO SS08WS-ERROR.
049200     MOVE DFHBMASB               TO MR00-ORG-LP-A
049300                                    MR00-ORG-RP-A.
049400     MOVE SS08WS-CURSOR          TO MR00-ORG-L.
049500     MOVE DFHBMNBF               TO MR00-ORG-A.
049600     MOVE DFHBMUNF               TO MR00-TABLE-A.
049700     MOVE DFHBMFSE               TO MR00-TABLE-TYPE-A.
049800     GO TO D000-RETURN-ERRORS.
049900*
050000 C300-EDIT-TYPE.
050100*
050200*TXH IF  MBCA-DIRECT-TRANSFER-CODE
050300*        GO TO C402-READ-TABLE.
050400*
050500     IF  NOT MR00-TABLE-TYPE-VALID
050600         MOVE MBEMWS-INVALID-TYPE
050700                                 TO MR00-ERR-MESSAGE
050800         GO TO C318-TYPE-ERROR.
050900*
051000     MOVE DFHBMFSE               TO MR00-TABLE-TYPE-A.
051100     MOVE MR00-TABLE-TYPE        TO MBCA-TABLE-TYPE.
051200     GO TO C400-EDIT-TABLE.
051300*
051400 C318-TYPE-ERROR.
051500*
051600     MOVE 'Y'                    TO SS08WS-ERROR.
051700     MOVE DFHBMASB               TO MR00-TABLE-TYPE-LP-A
051800                                    MR00-TABLE-TYPE-RP-A.
051900     MOVE SS08WS-CURSOR          TO MR00-TABLE-TYPE-L.
052000     MOVE DFHBMUBF               TO MR00-TABLE-TYPE-A.
052100     MOVE DFHBMNBF               TO MR00-TABLE-A.
052200     GO TO D000-RETURN-ERRORS.
052300*
052400 C400-EDIT-TABLE.
052500*
052600     IF  MBCA-DIRECT-TRANSFER-CODE
052700         GO TO C402-READ-TABLE.
052800*
052900     IF  MR00-TABLE-L IS EQUAL TO ZERO
053000     OR  MR00-TABLE   IS NOT NUMERIC
053100     OR  MR00-TABLE   IS EQUAL TO ZEROES OR 999999999
053200         MOVE MBEMWS-INVALID-TABLE
053300                                 TO MR00-ERR-MESSAGE
053400         GO TO C418-TABLE-ERROR.
053500*
053600 C402-READ-TABLE.
053700*
053800***************************************************************
053900*    READ THE DISCOUNT RATE TABLE RECORD.  IT MUST BE ON      *
054000*    FILE AND AN ACTIVE RECORD IF IN MAINTENANCE OR INQUIRY.  *
054100*    IT MUST NOT BE ON FILE (OR IN AN ADD PENDING STATE),     *
054200*    IF IN ADD.                                               *
054300***************************************************************
054400*
054500     MOVE MR00-ORG               TO MBIOWS-MMRT-ORG.
054600     MOVE MR00-TABLE             TO MBIOWS-MMRT-TABLE-NBR.
054700     MOVE MR00-TABLE-TYPE        TO MBIOWS-MMRT-TABLE-TYPE.
054800     MOVE SS08WS-CICS-FC-NOTFND  TO MBIORO-TEMP-STATUS-1.
054900     MOVE 'FC04'                 TO MBCA-PROGRAM-LOCATION.
055000     SET MBIORO-READ-RANDOM      TO TRUE.
055100     PERFORM MMRTAO-ACCESS       THRU MMRTAO-ACCESS-EXIT.
055200*
055300     IF  SS08WS-RC-FC-VALID-RTN-CODE
055400         MOVE MR00-TABLE         TO MBCA-TABLE.
055500*
055600     IF (MBCA-PTI-FUNCTION-IS-INQUIRY)
055700         IF  SS08WS-RC-FC-VALID-RTN-CODE
055800             IF  MMRT-ADD-PENDING
055900                 MOVE MBEMWS-ADD-PENDING
056000                                 TO MR00-ERR-MESSAGE
056100                 GO TO C418-TABLE-ERROR
056200             ELSE
056300                 GO TO F000-SETUP-COMMAREA
056400         ELSE
056500             MOVE MBEMWS-NOT-ON-FILE
056600                                 TO MR00-ERR-MESSAGE
056700             GO TO C418-TABLE-ERROR.
056800*
056900     IF  MBCA-PTI-FUNCTION-IS-ADD
057000     AND SS08WS-RC-FC-NOTFND
057100         GO TO E000-UPDATE-FILE.
057200*
057300     IF  MBCA-PTI-FUNCTION-IS-ADD
057400     AND MMRT-ADD-PENDING
057500         IF  WS-COPY-SW-NO
057600             MOVE MMRT-ONLINE-STATUS
057700                                 TO MBCA-SCREEN-NBR
057800             GO TO F000-SETUP-COMMAREA
057900         ELSE
058000             MOVE MBEMWS-ADD-PENDING
058100                                 TO MR00-ERR-MESSAGE
058200             GO TO C418-TABLE-ERROR.
058300*
058400     IF  MBCA-PTI-FUNCTION-IS-ADD
058500         MOVE MBEMWS-ALREADY-ON-FILE
058600                                 TO MR00-ERR-MESSAGE
058700         GO TO C418-TABLE-ERROR.
058800*
058900     IF  MBCA-PTI-FUNCTION-IS-MAINT
059000     AND SS08WS-RC-FC-NOTFND
059100         MOVE MBEMWS-NOT-ON-FILE TO MR00-ERR-MESSAGE
059200         GO TO C418-TABLE-ERROR.
059300*
059400     IF  MBCA-PTI-FUNCTION-IS-MAINT
059500     AND MMRT-ADD-PENDING
059600         MOVE MBEMWS-ADD-PENDING TO MR00-ERR-MESSAGE
059700         GO TO C418-TABLE-ERROR.
059800*
059900     IF  MBCA-PTI-FUNCTION-IS-MAINT
060000     AND MMRT-REC-PURGED
060100         MOVE MBEMWS-REC-PURGED  TO MR00-ERR-MESSAGE
060200         GO TO C418-TABLE-ERROR.
060300*
060400*********************************************
060500*    OTHERWISE, WE PASSED THE TABLE EDIT    *
060600*********************************************
060700*
060800     GO TO F000-SETUP-COMMAREA.
060900*
061000 C418-TABLE-ERROR.
061100*
061200     MOVE 'Y'                    TO SS08WS-ERROR.
061300     MOVE DFHBMASB               TO MR00-TABLE-LP-A
061400                                    MR00-TABLE-RP-A
061500                                    MR00-TABLE-TYPE-RP-A
061600                                    MR00-TABLE-TYPE-LP-A.
061700     MOVE SS08WS-CURSOR          TO MR00-TABLE-L.
061800     MOVE DFHBMNBF               TO MR00-TABLE-A.
061900     MOVE DFHBMUBF               TO MR00-TABLE-TYPE-A.
062000/
062100 D000-RETURN-ERRORS SECTION.
062200*
062300     IF  SS08WS-ERROR IS EQUAL TO 'N'
062400         GO TO E000-UPDATE-FILE
062500     ELSE
062600         IF  SS08WS-VALID-PF-KEY
062700         OR  SS08WS-EIBAID-VALID-PF-KEY
062800             SET MBCA-INITIAL-SCREEN-NBR
062900                                 TO TRUE
063000             GO TO F090-TRANSFER-XCTL.
063100*
063200***************************************************************
063300*    INITIALIZE THE STANDARD MAP LINES.  IN AN ERROR          *
063400*    CONDITION, THIS ROUTINE IS PERFORMED PRIMARILY           *
063500*    TO UPDATE THE DATE AND TIME ON THE SCREEN.               *
063600***************************************************************
063700*
063800     PERFORM MB60PD-INIT-STD-MAP-LINES
063900                                 THRU MB60PD-ISML-EXIT.
064000*
064100     IF  MBCA-PTI-FUNCTION-IS-MAINT
064200     OR  MBCA-PTI-FUNCTION-IS-INQUIRY
064300         MOVE DFHBMDAS           TO MR00-COPY-ORG-LIT-A
064400                                    MR00-COPY-ORG-LP-A
064500                                    MR00-COPY-ORG-RP-A
064600                                    MR00-COPY-TABLE-LIT-A
064700                                    MR00-COPY-TABLE-LP-A
064800                                    MR00-COPY-TABLE-RP-A
064900                                    MR00-COPY-TABLE-TYPE-LIT-A
065000                                    MR00-COPY-TABLE-TYPE-LP-A
065100                                    MR00-COPY-TABLE-TYPE-RP-A
065200         MOVE DFHBMASK           TO MR00-COPY-ORG-A
065300                                    MR00-COPY-TABLE-A
065400                                    MR00-COPY-TABLE-TYPE-A.
065500*
065600**********************
065700*    SEND THE MAP    *
065800**********************
065900*
066000     MOVE 'BM03'                 TO MBCA-PROGRAM-LOCATION.
066100     PERFORM MB60PD-SEND-MAP-WITH-ERASE
066200                                 THRU MB60PD-SMWE-EXIT.
066300*
066400************************
066500*    RETURN TO CICS    *
066600************************
066700*
066800     MOVE 'PC04'                 TO MBCA-PROGRAM-LOCATION.
066900     PERFORM MB70PD-RETURN-TRANS-ID
067000                                 THRU MB70PD-RTI-EXIT.
067100/
067200 E000-UPDATE-FILE SECTION.
067300*
067400*****************************************************
067500*    WRITE THE NEW TABLE DEFINITION RECORD FROM     *
067600*    INITIALIZED VALUES OR FROM THE TABLE RECORD    *
067700*    THAT IS BEING COPIED.                          *
067800*****************************************************
067900*
068000     IF  WS-COPY-SW-YES
068100         GO TO E040-COPY-ADD.
068200*
068300 E020-ADD-NEW-RECORD.
068400*
068500**********************************************************
068600*    SET UP THE RECORD.  USE THE INITIALIZER RECORD      *
068700*    (MMRTIR) AS THE FIELD DEFAULTS.                     *
068800**********************************************************
068900*
069000     MOVE MMRTIR-RECORD          TO MMRT-RECORD.
069100     MOVE MR00-ORG               TO MMRT-ORG.
069200     MOVE MR00-TABLE             TO MMRT-TABLE-NBR.
069300     MOVE MR00-TABLE-TYPE        TO MMRT-TABLE-TYPE.
069400     MOVE MBCA-START-DATE        TO MMRT-LAST-MAINT-DATE.
069500     MOVE MBCA-OPERATOR-ID       TO MMRT-LAST-MAINT-OPER.
069600*
069700     GO TO E060-WRITE-MMRT.
069800*
069900 E040-COPY-ADD.
070000*
070100********************************************************
070200*    RE-READ THE DISCOUNT TABLE RECORD TO BE COPIED    *
070300********************************************************
070400*
070500     MOVE MR00-COPY-ORG          TO MBIOWS-MMRT-ORG.
070600     MOVE MR00-COPY-TABLE        TO MBIOWS-MMRT-TABLE-NBR.
070700     MOVE MR00-COPY-TABLE-TYPE   TO MBIOWS-MMRT-TABLE-TYPE.
070800     MOVE 'FC05'                 TO MBCA-PROGRAM-LOCATION.
070900     SET MBIORO-READ-RANDOM      TO TRUE.
071000     PERFORM MMRTAO-ACCESS       THRU MMRTAO-ACCESS-EXIT.
071100*
071200***************************
071300*    SET UP THE RECORD    *
071400***************************
071500*
071600     MOVE MR00-ORG               TO MMRT-ORG.
071700     MOVE MR00-TABLE             TO MMRT-TABLE-NBR.
071800     MOVE MR00-TABLE-TYPE        TO MMRT-TABLE-TYPE.
071900     MOVE MMRTIR-REC-STATUS      TO MMRT-REC-STATUS.
072000     MOVE MMRTIR-ONLINE-STATUS   TO MMRT-ONLINE-STATUS.
072100     MOVE MBCA-START-DATE        TO MMRT-LAST-MAINT-DATE.
072200     MOVE MBCA-OPERATOR-ID       TO MMRT-LAST-MAINT-OPER.
072300*
072400*************************************************************
072500*    INITIALIZE THE FIELDS THAT ARE NOT PART OF THE COPY    *
072600*************************************************************
072700*
072800     MOVE MMRTIR-TITLE           TO MMRT-TITLE.
072900*
073000 E060-WRITE-MMRT.
073100*
073200     MOVE 'FC06'                 TO MBCA-PROGRAM-LOCATION.
073300     SET MBIORO-WRITE            TO TRUE.
073400     PERFORM MMRTAO-ACCESS       THRU MMRTAO-ACCESS-EXIT.
073500*
073600     MOVE MR00-TABLE             TO MBCA-TABLE.
073700/
073800 F000-SETUP-COMMAREA SECTION.
073900*
074000***************************************************************
074100*  SET UP COMMAREA FIELDS AND TRANSFER TO THE NEXT PROGRAM    *
074200***************************************************************
074300*
074400     MOVE MMOC-CURRENCY-CODE     TO MBCA-CURRENCY-CODE.
074500     MOVE MMOC-CURRENCY-NOD      TO MBCA-CURRENCY-NOD.
074600     MOVE MMOC-PERCENT-NOD       TO MBCA-PERCENT-NOD.
074700     MOVE MMOC-PER-ITEM-NOD      TO MBCA-PER-ITEM-NOD.
074800     MOVE MBCA-EIBAID            TO SS08WS-EIBAID.
074900*
075000     MOVE MBIOWS-MMRT-DIRECT-KEY-CODE
075100                                 TO MBCA-KEY-CODE.
075200*
075300     PERFORM MB60PD-EDIT-PAGE-NBR
075400                                 THRU MB60PD-EPN-EXIT.
075500*
075600     IF  SS08WS-VALID-PF-KEY
075700     OR  SS08WS-EIBAID-VALID-PF-KEY
075800         SET MBCA-INITIAL-SCREEN-NBR
075900                                 TO TRUE.
076000*
076100 F090-TRANSFER-XCTL.
076200*
076300     MOVE 'PC05'                 TO MBCA-PROGRAM-LOCATION.
076400     PERFORM MB70PD-XCTL-TO-MBOXCTL
076500                                 THRU MB70PD-XTM-EXIT.
076600/
076700 Z000-COPIED-ROUTINES SECTION.
076800*
076900/    NEW ROUTINE FOR JULIAN TO GREGORIAN CONVERSION
077000     COPY SS26PD.
077100/    ROUTINE TO NUMERICALLY EDIT TIME
077200     COPY SS27PD.
077300**********************************
077400*    JUL TO GREG DATE ROUTINE    *
077500**********************************
077600*
077700     COPY SS08PD.
077800/
077900*********************************
078000*    LINE 24 PF KEYS ROUTINE    *
078100*********************************
078200*
078300     COPY SS15PD.
078400/
078500*******************************************
078600*    ORG FILE ACCESS ROUTINES             *
078700*******************************************
078800*
078900     COPY MMOCAO.
079000/
079100****************************************************
079200*    DISCOUNT RATE TABLE RECORD ACCESS ROUTINES    *
079300****************************************************
079400*
079500     COPY MMRTAO.
079600/
079700*****************************
079800*    ONLINE MAP ROUTINES    *
079900*****************************
080000*
080100     COPY MB60PD REPLACING 'MBMAPXX' BY 'MBMR00 '
080200                           MBMAPXXI BY MBMR00I
080300                           MBMAPXXO BY MBMR00O.
080400/
080500***************************
080600*    ONLINE PROCEDURES    *
080700***************************
080800*
080900     COPY MB70PD.
081000/
081100     COPY SMFTPXO.
