000100 IDENTIFICATION DIVISION.
000200 PROGRAM-ID. MBOMR02.
000201*       RELEASE DATE=08/24/01.        REVISION LEVEL=08.06      *
000202*****************************************************************
000203*WARNING.  THIS COMPUTER PROGRAM IS PROTECTED BY COPYRIGHT LAW  *
000204*AND INTERNATIONAL TREATIES.  UNAUTHORIZED REPRODUCTION OR      *
000205*DISTRIBUTION OF THIS PROGRAM, OR ANY PORTION OF IT, MAY RESULT *
000206*IN SEVERE CIVIL AND CRIMINAL PENATLIES, AND WILL BE PROSECUTED *
000207*TO THE MAXIMUM EXTENT POSSIBLE UNDER THE LAW.                  *
000208*COPYRIGHT 1999 PAYSYS INTERNATIONAL, INC.  ALL RIGHTS RESERVED.*
000209*****************************************************************
000300*****************************************************************
000400*                                                               *
000500*   V - PLUS  M E R C H A N T   B A N K C A R D   S Y S T E M   *
000600*                                                               *
000700*      MBOMR02 - ON-LINE MERCHANT DISCOUNT TABLE RECORD         *
000800*                ADD/MAINTENANCE/INQUIRY                        *
000900*                SCREEN 02                                      *
001000*                                                               *
001100*              1. TRANSIDS                                      *
001200*                 A. MBAT                                       *
001300*                 B. MBMT                                       *
001400*                 C. MBQT                                       *
001500*              2. MAPS USED -                                   *
001600*                 A. MBMR02 (MAP 02)                            *
001700*              3. FILES USED -                                  *
001800*                 A. MMRT   (MERCHANT DISCOUNT RATE TABLE FILE) *
001900*                 B. MML1   (MERCHANT LOG/JOURNAL FILE)         *
002000*                                                               *
002100*****************************************************************
002200*
002300 ENVIRONMENT DIVISION.
002400 DATA DIVISION.
002500 WORKING-STORAGE SECTION.
002600 01  FILLER                  PIC  X(12)      VALUE '** WS-BEG **'.
002700*
002800/         I/O REQUEST BLOCK WORK AREAS
002900     COPY MBIOWS.
003000*
003100/         I/O REQUEST BLOCK
003200     COPY MBIORO.
003300*
003400/         LOG/JOURNAL WORK AREA.
003500     COPY MML1WS REPLACING ==:MML1:== BY ==MML1==.
003600*
003700/         DISCOUNT RATE TABLE INITIALIZER RECORD
003800     COPY MMRTIR.
003900*
004000/         DATE WORK AREAS
004100     COPY SS01WS.
004200*
004300/         ONLINE WORK AREAS
004400     COPY SS08WS.
004500/
004600     COPY SS00WS.
004700/
004800     COPY SMFTWS.
004900/
005000     COPY SMPTRL REPLACING ==:SMPT:== BY ==SMPT==.
005100/
005200     COPY MB61LK.
005300/         STANDARD ERROR MESSAGES
005400     COPY MBEMWS.
005500*
005600/         MERCHANT DISCOUNT RATE TABLE DESCRIPTIONS
005700     COPY MMRTTB.
005800*
005900/         MERCHANT DISCOUNT RATE TABLE METHODS
006000     COPY MMRTWS.
006100*
006200 01  WS-WORK-AREA.
006300     03  WS-UPDATE-SW        PIC  X(01)      VALUE 'N'.
006400         88  WS-UPDATE-SW-NO                 VALUE 'N'.
006500         88  WS-UPDATE-SW-YES                VALUE 'Y'.
006600     03  WS-SCREEN-BYPASS-SW PIC  X(01)      VALUE 'N'.
006700         88  THIS-SCREEN-IS-BYPASSED         VALUE 'Y'.
006800         88  THIS-SCREEN-IS-NOT-BYPASSED     VALUE 'N'.
006900*
007000     03  WS-INDEX            PIC S9(04)      BINARY.
007100*
007200     03  WS-RATE             PIC S9(09)      COMP-3
007300                                             VALUE ZEROES.
007400     03  WS-RATE-TOTAL       PIC S9(09)      COMP-3
007500                                             VALUE ZEROES.
007600*
007700 01  FILLER                  PIC  X(12)      VALUE '** WS-END **'.
007800/
007900 LINKAGE SECTION.
008000 01  DFHCOMMAREA.
008100*
008200     COPY MB60WS.
008300/         MERCHANT DISCOUNT RATE TABLE 02 MAP DSECT
008400     COPY MBMR02.
008500*
008600/         MERCHANT DISCOUNT RATE TABLE 02 REDEFINES
008700     COPY MBMR02R.
008800*
008900/         MERCHANT DISCOUNT RATE TABLE RECORD LAYOUT
009000     COPY MMRTRL.
009100*
009200/         LOG/JOURNAL FILE RECORD LAYOUT.
009300     COPY MML1RL REPLACING ==:MML1:== BY ==MML1==.
009400*
009500 PROCEDURE DIVISION.
009600 0000-HOUSEKEEPING SECTION.
009700 0100-INIT.
009800*
009900     MOVE 'PC01'                 TO MBCA-PROGRAM-LOCATION.
010000     PERFORM MB70PD-ON-LINE-HOUSEKEEPING
010100        THRU MB70PD-OLH-EXIT.
010200*
010300     IF  MBCA-RECEIVE-SCREEN
010400         GO TO 2000-RECEIVE-SCREEN.
010500*
010600 1000-SEND-SCREEN SECTION.
010700*
010800****************************************************************
010900*    THIS SECTION BUILDS AND SENDS THE 02 SCREEN.              *
011000****************************************************************
011100******************************************************************
011200*    READ THE DISCOUNT RATE TABLE RECORD AND BUILD THE MAP       *
011300******************************************************************
011400*
011500     MOVE 'FC01'                 TO MBCA-PROGRAM-LOCATION.
011600     MOVE MBCA-MERCHANT-ORG      TO MBIOWS-MMRT-ORG.
011700     MOVE MBCA-TABLE             TO MBIOWS-MMRT-TABLE-NBR.
011800     MOVE MBCA-TABLE-TYPE        TO MBIOWS-MMRT-TABLE-TYPE.
011900     SET MBIORO-READ-RANDOM      TO TRUE.
012000     PERFORM MMRTAO-ACCESS       THRU MMRTAO-ACCESS-EXIT.
012100*
012200***************************************************
012300*    IF THE PLAN EXCEPTION PRIORITY SPECIFIES     *
012400*    'NOT USED', BYPASS THIS SCREEN.  IF  THIS    *
012500*    IS THE ADD FUNCTION, BRANCH TO THE UPDATE    *
012600*    SECTION OF THE PROGRAM WHERE THE ONLINE      *
012700*    STATUS , MAINT DATE, AND MAINT OPERATOR      *
012800*    WILL BE UPDATED.                             *
012900***************************************************
013000*
013100     IF  MMRT-EXCEPTION-NOT-USED (1)
013200     AND MMRT-EXCEPTION-NOT-USED (3)
013300         COMPUTE MBCA-SCREEN-NBR = MBCA-SCREEN-NBR - 50
013400         IF  MBCA-PTI-FUNCTION-IS-ADD
013500             MOVE 'Y'            TO WS-SCREEN-BYPASS-SW
013600             GO TO 2400-UPDATE-FILE
013700         ELSE
013800             GO TO 2600-SETUP-COMMAREA.
013900*
014000****************************************************************
014100*    GET CICS STORAGE NEEDED FOR THE MAP                       *
014200****************************************************************
014300*
014400     MOVE 'SC01'                 TO MBCA-PROGRAM-LOCATION.
014500     PERFORM MB60PD-GETMAIN-FOR-MAP
014600        THRU MB60PD-GFM-EXIT.
014700*
014800     PERFORM MB60PD-INIT-STD-MAP-LINES
014900        THRU MB60PD-ISML-EXIT.
015000*
015100     COMPUTE MBCA-SCREEN-NBR     = MBCA-SCREEN-NBR  - 50.
015200*
015300 1100-BUILD-SCREEN.
015400*
015500****************************************************************
015600*    INITIALIZE THE STANDARD MAP LINES                         *
015700****************************************************************
015800*
015900     MOVE MBCA-MERCHANT-ORG      TO MR02-ORG.
016000     MOVE MBCA-TABLE             TO MR02-TABLE.
016100     MOVE MMRT-TITLE             TO MR02-TABLE-NAME.
016200     MOVE DFHBMASB               TO MR02-ORG-A
016300                                    MR02-TABLE-A.
016400*
016500     MOVE SS08WS-CURSOR          TO MR02-AVT-LIMIT-L (1).
016600*
016700*
016800     PERFORM 9100-BUILD-DISC-TABLE
016900        THRU 9199-BDT-EXIT.
017000*
017100****************************************************************
017200*    SEND THE MAP                                              *
017300****************************************************************
017400*
017500     MOVE 'BM01'                 TO MBCA-PROGRAM-LOCATION.
017600     PERFORM MB60PD-SEND-MAP-WITH-ERASE
017700        THRU MB60PD-SMWE-EXIT.
017800*
017900****************************************************************
018000*    RETURN TO CICS                                            *
018100****************************************************************
018200*
018300     MOVE 'PC02'                 TO MBCA-PROGRAM-LOCATION.
018400     PERFORM MB70PD-RETURN-TRANS-ID
018500        THRU MB70PD-RTI-EXIT.
018600/
018700 2000-RECEIVE-SCREEN SECTION.
018800*
018900****************************************************************
019000*    THIS SECTION RECEIVES THE LOCATE SCREEN                   *
019100****************************************************************
019200*
019300     MOVE 'BM02'                 TO MBCA-PROGRAM-LOCATION.
019400     PERFORM MB60PD-RECEIVE-MAP
019500        THRU MB60PD-RM-EXIT.
019600*
019700****************************************************************
019800*    CHECK FOR ANOTHER TRANSACTION ID ENTERED BY THE USER      *
019900****************************************************************
020000*
020100     MOVE 'PC03'                 TO MBCA-PROGRAM-LOCATION.
020200     PERFORM MB60PD-NEW-TRANS-ROUTINE
020300        THRU MB60PD-NTR-EXIT.
020400*
020500******************************************************************
020600*    READ THE DISCOUNT TABLE RECORD                              *
020700******************************************************************
020800*
020900     MOVE 'FC02'                 TO MBCA-PROGRAM-LOCATION.
021000     MOVE MBCA-MERCHANT-ORG      TO MBIOWS-MMRT-ORG
021100                                    MR02-ORG.
021200     MOVE MBCA-TABLE             TO MBIOWS-MMRT-TABLE-NBR
021300                                    MR02-TABLE.
021400     MOVE MBCA-TABLE-TYPE        TO MBIOWS-MMRT-TABLE-TYPE.
021500     SET MBIORO-READ-RANDOM      TO TRUE.
021600     PERFORM MMRTAO-ACCESS       THRU MMRTAO-ACCESS-EXIT.
021700*
021800******************************************************************
021900*    BYPASS ALL SCREEN EDITS IF THIS IS INQIURY                  *
022000******************************************************************
022100*
022200     IF  MBCA-PTI-FUNCTION-IS-INQUIRY
022300         GO TO 2600-SETUP-COMMAREA.
022400*
022500******************************************************************
022600*    FIELD EDITS                                                 *
022700******************************************************************
022800*
022900 2100-EDIT-SCREEN.
023000*
023100*            ***** SINGLE TKT BEG LIMIT *****                  *
023200*
023300     IF  MR02-TKT-BEG-L IS LESS THAN 1
023400         MOVE DFHBMASK           TO MR02-TKT-BEG-A
023500         MOVE DFHBMDAS           TO MR02-TKT-BEG-LP-A
023600                                    MR02-TKT-BEG-RP-A
023700         MOVE MMRT-SINGLE-TKT-BEG-LIMIT
023800                                 TO MR02-TKT-BEG
023900     ELSE
024000         IF  MR02-TKT-BEG IS NUMERIC
024100             MOVE DFHBMASF       TO MR02-TKT-BEG-A
024200             MOVE DFHBMDAS       TO MR02-TKT-BEG-LP-A
024300                                    MR02-TKT-BEG-RP-A
024400             SET WS-UPDATE-SW-YES
024500                                 TO TRUE
024600         ELSE
024700             MOVE DFHBMNBF       TO MR02-TKT-BEG-A
024800             MOVE DFHBMASB       TO MR02-TKT-BEG-LP-A
024900                                    MR02-TKT-BEG-RP-A
025000             MOVE SS08WS-CURSOR  TO MR02-TKT-BEG-L
025100             SET SS08WS-ERROR-SW-YES TO TRUE.
025200*
025300 2110-EDIT-AVG-TICKET-RATES.
025400*
025500     PERFORM
025600         VARYING X-MR02-AVT FROM 1 BY 1
025700         UNTIL X-MR02-AVT IS GREATER THAN 10
025800         SET X-MMRT-ATV          TO X-MR02-AVT
025900         EVALUATE TRUE
026000           WHEN MR02-AVT-LIMIT-L (X-MR02-AVT) IS LESS THAN 1
026100             MOVE MMRT-ATV-LIMIT (X-MMRT-ATV)
026200                                 TO MR02-AVT-LIMIT
026300                                     (X-MR02-AVT)
026400             MOVE DFHBMDAS       TO MR02-AVT-LIMIT-LP-A
026500                                     (X-MR02-AVT)
026600                                    MR02-AVT-LIMIT-RP-A
026700                                     (X-MR02-AVT)
026800             MOVE DFHBMASK       TO MR02-AVT-LIMIT-A
026900                                     (X-MR02-AVT)
027000           WHEN MR02-AVT-LIMIT  (X-MR02-AVT) IS NOT NUMERIC
027100             MOVE SS08WS-CURSOR  TO MR02-AVT-LIMIT-L
027200                                    (X-MR02-AVT)
027300             MOVE DFHBMASB       TO MR02-AVT-LIMIT-LP-A
027400                                    (X-MR02-AVT)
027500                                    MR02-AVT-LIMIT-RP-A
027600                                    (X-MR02-AVT)
027700             MOVE DFHBMNBF       TO MR02-AVT-LIMIT-A
027800                                    (X-MR02-AVT)
027900             SET SS08WS-ERROR-SW-YES TO TRUE
028000           WHEN OTHER
028100             MOVE DFHBMDAS       TO MR02-AVT-LIMIT-LP-A
028200                                    (X-MR02-AVT)
028300                                    MR02-AVT-LIMIT-RP-A
028400                                    (X-MR02-AVT)
028500             MOVE DFHBMASF       TO MR02-AVT-LIMIT-A
028600                                    (X-MR02-AVT)
028700             SET WS-UPDATE-SW-YES
028800                                 TO TRUE
028900         END-EVALUATE
029000         EVALUATE TRUE
029100           WHEN MR02-AVT-RATE-L (X-MR02-AVT) IS LESS THAN 1
029200             MOVE MMRT-ATV-RATE (X-MMRT-ATV)
029300                                 TO MR02-AVT-RATE
029400                                    (X-MR02-AVT)
029500             MOVE DFHBMDAS       TO MR02-AVT-RATE-LP-A
029600                                    (X-MR02-AVT)
029700                                    MR02-AVT-RATE-RP-A
029800                                    (X-MR02-AVT)
029900             MOVE DFHBMASK       TO MR02-AVT-RATE-A
030000                                    (X-MR02-AVT)
030100           WHEN MR02-AVT-RATE  (X-MR02-AVT) IS NOT NUMERIC
030200             MOVE DFHBMASB       TO MR02-AVT-RATE-LP-A
030300                                    (X-MR02-AVT)
030400                                    MR02-AVT-RATE-RP-A
030500                                    (X-MR02-AVT)
030600             MOVE DFHBMNBF       TO MR02-AVT-RATE-A
030700                                    (X-MR02-AVT)
030800             MOVE SS08WS-CURSOR  TO MR02-AVT-RATE-L
030900                                    (X-MR02-AVT)
031000             SET SS08WS-ERROR-SW-YES TO TRUE
031100           WHEN OTHER
031200             MOVE DFHBMDAS       TO MR02-AVT-RATE-LP-A
031300                                    (X-MR02-AVT)
031400                                    MR02-AVT-RATE-RP-A
031500                                    (X-MR02-AVT)
031600             MOVE DFHBMASF       TO MR02-AVT-RATE-A
031700                                    (X-MR02-AVT)
031800             SET WS-UPDATE-SW-YES
031900                                 TO TRUE
032000         END-EVALUATE
032100*
032200         EVALUATE TRUE
032300           WHEN (MR02-AVT-SIGN-L (X-MR02-AVT) GREATER THAN ZERO
032400            AND MR02-AVT-SIGN (X-MR02-AVT) IS NOT EQUAL TO '-'
032500            AND MR02-AVT-SIGN (X-MR02-AVT) IS NOT EQUAL TO '+')
032600             MOVE DFHBMUBF       TO MR02-AVT-SIGN-A
032700                                    (X-MR02-AVT)
032800             MOVE DFHBMASB       TO MR02-AVT-RATE-LP-A
032900                                    (X-MR02-AVT)
033000                                    MR02-AVT-RATE-RP-A
033100                                    (X-MR02-AVT)
033200             MOVE SS08WS-CURSOR  TO MR02-AVT-SIGN-L
033300                                    (X-MR02-AVT)
033400             SET SS08WS-ERROR-SW-YES TO TRUE
033500           WHEN OTHER
033600             EVALUATE TRUE
033700               WHEN (MMRT-ATV-RATE (X-MMRT-ATV) IS LESS THAN ZERO
033800                AND MR02-AVT-SIGN-L (X-MR02-AVT)
033900                                 IS LESS THAN 1)
034000                 MOVE '-'        TO MR02-AVT-SIGN
034100                                    (X-MR02-AVT)
034200                 MOVE DFHBMASF   TO MR02-AVT-SIGN-A
034300                                    (X-MR02-AVT)
034400               WHEN (MMRT-ATV-RATE (X-MMRT-ATV)
034500                                 IS NOT LESS THAN ZERO
034600                AND MR02-AVT-SIGN-L (X-MR02-AVT)
034700                                 IS LESS THAN 1)
034800                 MOVE '+'        TO MR02-AVT-SIGN
034900                                    (X-MR02-AVT)
035000                 MOVE DFHBMASF   TO MR02-AVT-SIGN-A
035100                                    (X-MR02-AVT)
035200               WHEN OTHER
035300                 MOVE DFHBMASF   TO MR02-AVT-SIGN-A
035400                                    (X-MR02-AVT)
035500             END-EVALUATE
035600         END-EVALUATE
035700     END-PERFORM.
035800*
035900 2120-EDIT-SINGLE-TICKET-RATES.
036000*
036100     PERFORM
036200         VARYING X-MR02-TKT FROM 1 BY 1
036300         UNTIL X-MR02-TKT IS GREATER THAN 10
036400         SET X-MMRT-SINGLE-TKT   TO X-MR02-TKT
036500         EVALUATE TRUE
036600           WHEN MR02-TKT-LIMIT-L (X-MR02-TKT) IS LESS THAN 1
036700             MOVE MMRT-SINGLE-TKT-LIMIT (X-MMRT-SINGLE-TKT)
036800                                 TO MR02-TKT-LIMIT
036900                                     (X-MR02-TKT)
037000             MOVE DFHBMDAS       TO MR02-TKT-LIMIT-LP-A
037100                                     (X-MR02-TKT)
037200                                    MR02-TKT-LIMIT-RP-A
037300                                     (X-MR02-TKT)
037400             MOVE DFHBMASK       TO MR02-TKT-LIMIT-A
037500                                     (X-MR02-TKT)
037600           WHEN MR02-TKT-LIMIT  (X-MR02-TKT) IS NOT NUMERIC
037700             MOVE SS08WS-CURSOR  TO MR02-TKT-LIMIT-L
037800                                    (X-MR02-TKT)
037900             MOVE DFHBMASB       TO MR02-TKT-LIMIT-LP-A
038000                                    (X-MR02-TKT)
038100                                    MR02-TKT-LIMIT-RP-A
038200                                    (X-MR02-TKT)
038300             MOVE DFHBMNBF       TO MR02-TKT-LIMIT-A
038400                                    (X-MR02-TKT)
038500             SET SS08WS-ERROR-SW-YES TO TRUE
038600           WHEN OTHER
038700             MOVE DFHBMDAS       TO MR02-TKT-LIMIT-LP-A
038800                                    (X-MR02-TKT)
038900                                    MR02-TKT-LIMIT-RP-A
039000                                    (X-MR02-TKT)
039100             MOVE DFHBMASF       TO MR02-TKT-LIMIT-A
039200                                    (X-MR02-TKT)
039300             SET WS-UPDATE-SW-YES
039400                                 TO TRUE
039500         END-EVALUATE
039600         EVALUATE TRUE
039700           WHEN MR02-TKT-RATE-L (X-MR02-TKT) IS LESS THAN 1
039800             MOVE MMRT-SINGLE-TKT-RATE (X-MMRT-SINGLE-TKT)
039900                                 TO MR02-TKT-RATE
040000                                    (X-MR02-TKT)
040100             MOVE DFHBMDAS       TO MR02-TKT-RATE-LP-A
040200                                    (X-MR02-TKT)
040300                                    MR02-TKT-RATE-RP-A
040400                                    (X-MR02-TKT)
040500             MOVE DFHBMASK       TO MR02-TKT-RATE-A
040600                                    (X-MR02-TKT)
040700           WHEN MR02-TKT-RATE  (X-MR02-TKT) IS NOT NUMERIC
040800             MOVE DFHBMASB       TO MR02-TKT-RATE-LP-A
040900                                    (X-MR02-TKT)
041000                                    MR02-TKT-RATE-RP-A
041100                                    (X-MR02-TKT)
041200             MOVE DFHBMNBF       TO MR02-TKT-RATE-A
041300                                    (X-MR02-TKT)
041400             MOVE SS08WS-CURSOR  TO MR02-TKT-RATE-L
041500                                    (X-MR02-TKT)
041600             SET SS08WS-ERROR-SW-YES TO TRUE
041700           WHEN OTHER
041800             MOVE DFHBMDAS       TO MR02-TKT-RATE-LP-A
041900                                    (X-MR02-TKT)
042000                                    MR02-TKT-RATE-RP-A
042100                                    (X-MR02-TKT)
042200             MOVE DFHBMASF       TO MR02-TKT-RATE-A
042300                                    (X-MR02-TKT)
042400             SET WS-UPDATE-SW-YES
042500                                 TO TRUE
042600         END-EVALUATE
042700*
042800         EVALUATE TRUE
042900           WHEN (MR02-TKT-SIGN-L (X-MR02-TKT) GREATER THAN ZERO
043000            AND MR02-TKT-SIGN (X-MR02-TKT) IS NOT EQUAL TO '-'
043100            AND MR02-TKT-SIGN (X-MR02-TKT) IS NOT EQUAL TO '+')
043200             MOVE DFHBMUBF       TO MR02-TKT-SIGN-A
043300                                    (X-MR02-TKT)
043400             MOVE DFHBMASB       TO MR02-TKT-RATE-LP-A
043500                                    (X-MR02-TKT)
043600                                    MR02-TKT-RATE-RP-A
043700                                    (X-MR02-TKT)
043800             MOVE SS08WS-CURSOR  TO MR02-TKT-SIGN-L
043900                                    (X-MR02-TKT)
044000             SET SS08WS-ERROR-SW-YES TO TRUE
044100           WHEN OTHER
044200             EVALUATE TRUE
044300               WHEN (MMRT-SINGLE-TKT-RATE (X-MMRT-SINGLE-TKT)
044400                                 IS LESS THAN ZERO
044500                AND MR02-TKT-SIGN-L (X-MR02-TKT)
044600                                 IS LESS THAN 1)
044700                 MOVE '-'        TO MR02-TKT-SIGN
044800                                    (X-MR02-TKT)
044900                 MOVE DFHBMASF   TO MR02-TKT-SIGN-A
045000                                    (X-MR02-TKT)
045100               WHEN (MMRT-SINGLE-TKT-RATE (X-MMRT-SINGLE-TKT)
045200                                 IS NOT LESS THAN ZERO
045300                AND MR02-TKT-SIGN-L (X-MR02-TKT)
045400                                 IS LESS THAN 1)
045500                 MOVE '+'        TO MR02-TKT-SIGN
045600                                    (X-MR02-TKT)
045700                 MOVE DFHBMASF   TO MR02-TKT-SIGN-A
045800                                    (X-MR02-TKT)
045900               WHEN OTHER
046000                 MOVE DFHBMASF   TO MR02-TKT-SIGN-A
046100                                    (X-MR02-TKT)
046200             END-EVALUATE
046300         END-EVALUATE
046400     END-PERFORM.
046500*
046600*
046700     IF  SS08WS-ERROR-SW-YES
046800         GO TO 2300-BYPASS-CROSS-EDITS.
046900*
047000     PERFORM 9300-CROSS-EDIT-LIMITS
047100                                 THRU 9399-EXIT.
047200*
047300     PERFORM 9400-CROSS-EDIT-AVT
047400                                 THRU 9499-EXIT.
047500*
047600     PERFORM 9500-CROSS-EDIT-TKT
047700                                 THRU 9599-EXIT.
047800*
047900     PERFORM 9600-CROSS-EDIT-SINGLE-TKT-BEG
048000                                 THRU 9699-EXIT.
048100*
048200     PERFORM 9700-CROSS-EDIT-AVG-TKT-LIMIT
048300                                 THRU 9769-CEATL-EXIT.
048400*
048500     PERFORM 9800-CROSS-EDIT-SNG-TKT-LIMIT
048600                                 THRU 9869-CESTL-EXIT.
048700*
048800     PERFORM 9900-CROSS-EDIT-SNG-AND-AVG
048900                                 THRU 9969-CESAA-EXIT.
049000*
049100 2300-BYPASS-CROSS-EDITS.
049200*
049300     IF  SS08WS-ERROR-SW-NO
049400         GO TO 2400-UPDATE-FILE.
049500*
049600****************************************************************
049700*    SEND THE MAP                                              *
049800****************************************************************
049900*
050000*
050100****************************************************************
050200*    TO ENTER THIS CODE WE HAVE ENTERED INVALID DATA INTO      *
050300*    THE MAP, AND IT HAS BEEN FLAGGED AS AN ERROR WE HAVE      *
050400*    HIGHLIGHTED THE FIELD AND ARE NOW GOING TO SEND THE ERROR *
050500*    SCREEN.                                                   *
050600****************************************************************
050700*
050800     IF  MBCA-PTI-FUNCTION-IS-ADD
050900     OR  MBCA-PTI-FUNCTION-IS-MAINT
051000         MOVE DFHBMDAS       TO MR02-AVT-LIMIT-LP-A (10)
051100                                MR02-AVT-LIMIT-RP-A (10)
051200         MOVE DFHBMASF       TO MR02-AVT-LIMIT-A    (10)
051300         MOVE DFHBMDAS       TO MR02-TKT-LIMIT-LP-A (10)
051400                                MR02-TKT-LIMIT-RP-A (10)
051500         MOVE DFHBMASF       TO MR02-TKT-LIMIT-A    (10).
051600*
051700     PERFORM MB60PD-INIT-STD-MAP-LINES
051800        THRU MB60PD-ISML-EXIT.
051900*
052000     MOVE 'BM03'                 TO MBCA-PROGRAM-LOCATION.
052100*
052200     PERFORM MB60PD-SEND-MAP-DATA-ONLY
052300        THRU MB60PD-SMDO-EXIT.
052400*
052500****************************************************************
052600*    RETURN TO CICS                                            *
052700****************************************************************
052800*
052900     MOVE 'PC04'                 TO MBCA-PROGRAM-LOCATION.
053000     PERFORM MB70PD-RETURN-TRANS-ID
053100        THRU MB70PD-RTI-EXIT.
053200*
053300/
053400 2400-UPDATE-FILE.
053500*
053600******************************************************************
053700*    READ THE DISCOUNT TABLE RECORD FOR UPDATE                   *
053800******************************************************************
053900*
054000     MOVE 'FC03'                 TO MBCA-PROGRAM-LOCATION.
054100     SET MBIORO-READ-RANDOM-UPDATE
054200                                 TO TRUE.
054300     PERFORM MMRTAO-ACCESS       THRU MMRTAO-ACCESS-EXIT.
054400*
054500******************************************************************
054600*    OBTAIN STORAGE FOR LOG FILE RECORD IF DOING MAINTENANCE     *
054700*    OR IF THE LAST SCREEN OF THE ADD                            *
054800******************************************************************
054900*
055000     IF  MBCA-PTI-FUNCTION-IS-ADD
055100         IF  THIS-SCREEN-IS-BYPASSED
055200             GO TO 2440-UPDATE-LOG-REC.
055300*
055400     MOVE 'SC02'                 TO MBCA-PROGRAM-LOCATION.
055500     SET MBIORO-GETMAIN          TO TRUE.
055600     PERFORM MML1AO-ACCESS       THRU MML1AO-ACCESS-EXIT.
055700*
055800******************************************************************
055900*    SET UP THE COMMON PORTION OF THE RECORD                     *
056000******************************************************************
056100*
056200     MOVE 'RT'                   TO MML1-FILE-CODE.
056300     MOVE MBCA-MERCHANT-ORG      TO MML1-MMRT-ORG.
056400     MOVE MBCA-TABLE             TO MML1-MMRT-TABLE-NBR.
056500     MOVE MBCA-TABLE-TYPE        TO MML1-MMRT-TABLE-TYPE
056600     MOVE MBCA-SIGNON-NAME       TO MML1-SIGNON-NAME.
056700     MOVE MBCA-TERMINAL-ID       TO MML1-TERMINAL-ID.
056800     MOVE ZEROES                 TO MML1-SOURCE-CODE.
056900     MOVE MBCA-FIELD-SECURITY    TO MML1-FIELD-SECURITY.
057000*
057100 2410-UPDATE-FIELDS.
057200*
057300*            ***** SINGLE TKT BEG LIMIT *****                  *
057400*
057500     IF  MR02-TKT-BEG-L IS GREATER THAN ZERO
057600         MOVE ZEROES             TO MML1-FIELD-OCCURRENCE
057700                                    MML1-FIELD-OCCURRENCE-2
057800         MOVE 0205               TO MML1-FIELD-CODE
057900         MOVE MML1WS-VL-20       TO MML1-VARIABLE-LENGTH
058000         MOVE MMRT-SINGLE-TKT-BEG-LIMIT
058100                                 TO MML1-VL20-B-NBR-NO-DEC
058200         MOVE MR02-TKT-BEG       TO MMRT-SINGLE-TKT-BEG-LIMIT
058300         MOVE MMRT-SINGLE-TKT-BEG-LIMIT
058400                                 TO MML1-VL20-A-NBR-NO-DEC
058500         IF  MBCA-PTI-FUNCTION-IS-MAINT
058600             PERFORM 9200-WRITE-LOG-RECORD
058700                                 THRU 9299-WLR-EXIT.
058800*
058900 2430-UPDATE-AVERAGE-TICKET.
059000*
059100     PERFORM
059200         VARYING X-MR02-AVT FROM 1 BY 1
059300         UNTIL X-MR02-AVT IS GREATER THAN 10
059400         SET X-MMRT-ATV          TO X-MR02-AVT
059500         SET WS-INDEX            TO X-MR02-AVT
059600         IF  MR02-AVT-LIMIT-L (X-MR02-AVT) GREATER THAN ZERO
059700             IF  MR02-AVT-LIMIT (X-MR02-AVT) IS NOT EQUAL
059800                                 TO MMRT-ATV-LIMIT (X-MMRT-ATV)
059900                 SET WS-UPDATE-SW-YES
060000                                 TO TRUE
060100                 IF  MBCA-PTI-FUNCTION-IS-MAINT
060200                     MOVE 0201       TO MML1-FIELD-CODE
060300                     SET MML1-FIELD-OCCURRENCE
060400                                 TO X-MMRT-ATV
060500                     MOVE ZEROES     TO MML1-FIELD-OCCURRENCE-2
060600                     MOVE MML1WS-VL-20
060700                                 TO MML1-VARIABLE-LENGTH
060800                     MOVE MMRT-ATV-LIMIT (X-MMRT-ATV)
060900                                 TO MML1-VL20-B-NBR-NO-DEC
061000                     MOVE MR02-AVT-LIMIT (X-MR02-AVT)
061100                                 TO MMRT-ATV-LIMIT (X-MMRT-ATV)
061200                     MOVE MMRT-ATV-LIMIT (X-MMRT-ATV)
061300                                 TO MML1-VL20-A-NBR-NO-DEC
061400                     MOVE 'FC04'     TO MBCA-PROGRAM-LOCATION
061500                     PERFORM 9200-WRITE-LOG-RECORD
061600                                 THRU 9299-WLR-EXIT
061700                 ELSE
061800                     MOVE MR02-AVT-LIMIT (X-MR02-AVT)
061900                                 TO MMRT-ATV-LIMIT
062000                                     (X-MMRT-ATV)
062100                 END-IF
062200             END-IF
062300         END-IF
062400         MOVE MMRT-ATV-RATE (X-MMRT-ATV)
062500                                  TO WS-RATE
062600         IF  MR02-AVT-SIGN-L (X-MR02-AVT) GREATER THAN ZERO
062700         OR  MR02-AVT-RATE-L   (X-MR02-AVT) GREATER THAN ZERO
062800             MOVE MR02-AVT-RATE (X-MR02-AVT)
062900                                 TO WS-RATE
063000             IF  MR02-AVT-SIGN (X-MR02-AVT) IS EQUAL TO '-'
063100                 COMPUTE WS-RATE = WS-RATE * -1
063200             END-IF
063300         END-IF
063400         IF  MR02-AVT-RATE-L (X-MR02-AVT) GREATER THAN ZERO
063500         OR  MR02-AVT-SIGN-L (X-MR02-AVT) GREATER THAN ZERO
063600             IF  WS-RATE IS NOT EQUAL TO MMRT-ATV-RATE
063700                                     (X-MMRT-ATV)
063800                 SET WS-UPDATE-SW-YES
063900                                 TO TRUE
064000                 IF  MBCA-PTI-FUNCTION-IS-MAINT
064100                     MOVE 0202   TO MML1-FIELD-CODE
064200                     SET MML1-FIELD-OCCURRENCE
064300                                 TO X-MMRT-ATV
064400                     MOVE ZEROES TO MML1-FIELD-OCCURRENCE-2
064500                     MOVE MML1WS-VL-20
064600                                 TO MML1-VARIABLE-LENGTH
064700                     MOVE MMRT-ATV-RATE (X-MMRT-ATV)
064800                                 TO MML1-VL20-B-NBR-NO-DEC
064900                     MOVE WS-RATE
065000                                 TO MMRT-ATV-RATE
065100                                    (X-MMRT-ATV)
065200                     MOVE MMRT-ATV-RATE (X-MMRT-ATV)
065300                                 TO MML1-VL20-A-NBR-NO-DEC
065400                     MOVE 'FC05' TO MBCA-PROGRAM-LOCATION
065500                     PERFORM 9200-WRITE-LOG-RECORD
065600                                 THRU 9299-WLR-EXIT
065700                 ELSE
065800                     MOVE WS-RATE
065900                                 TO MMRT-ATV-RATE
066000                                    (X-MMRT-ATV)
066100                 END-IF
066200             END-IF
066300         END-IF
066400     END-PERFORM.
066500*
066600 2440-UPDATE-SINGLE-TICKET.
066700*
066800     PERFORM
066900         VARYING X-MR02-TKT FROM 1 BY 1
067000         UNTIL X-MR02-TKT IS GREATER THAN 10
067100         SET X-MMRT-SINGLE-TKT   TO X-MR02-TKT
067200         SET WS-INDEX            TO X-MR02-TKT
067300         IF  MR02-TKT-LIMIT-L (X-MR02-TKT) GREATER THAN ZERO
067400             IF  MR02-TKT-LIMIT (X-MR02-TKT) IS NOT EQUAL
067500                                 TO MMRT-SINGLE-TKT-LIMIT
067600                                    (X-MMRT-SINGLE-TKT)
067700                 SET WS-UPDATE-SW-YES
067800                                 TO TRUE
067900                 IF  MBCA-PTI-FUNCTION-IS-MAINT
068000                     MOVE 0203       TO MML1-FIELD-CODE
068100                     SET MML1-FIELD-OCCURRENCE
068200                                 TO X-MMRT-SINGLE-TKT
068300                     MOVE ZEROES TO MML1-FIELD-OCCURRENCE-2
068400                     MOVE MML1WS-VL-20
068500                                 TO MML1-VARIABLE-LENGTH
068600                     MOVE MMRT-SINGLE-TKT-LIMIT
068700                                    (X-MMRT-SINGLE-TKT)
068800                                 TO MML1-VL20-B-NBR-NO-DEC
068900                     MOVE MR02-TKT-LIMIT (X-MR02-TKT)
069000                                 TO MMRT-SINGLE-TKT-LIMIT
069100                                    (X-MMRT-SINGLE-TKT)
069200                     MOVE MMRT-SINGLE-TKT-LIMIT
069300                                    (X-MMRT-SINGLE-TKT)
069400                                 TO MML1-VL20-A-NBR-NO-DEC
069500                     MOVE 'FC06'     TO MBCA-PROGRAM-LOCATION
069600                     PERFORM 9200-WRITE-LOG-RECORD
069700                                 THRU 9299-WLR-EXIT
069800                 ELSE
069900                     MOVE MR02-TKT-LIMIT (X-MR02-TKT)
070000                                 TO MMRT-SINGLE-TKT-LIMIT
070100                                     (X-MMRT-SINGLE-TKT)
070200                 END-IF
070300             END-IF
070400         END-IF
070500         MOVE MMRT-SINGLE-TKT-RATE (X-MMRT-SINGLE-TKT)
070600                                  TO WS-RATE
070700         IF  MR02-TKT-SIGN-L (X-MR02-TKT) GREATER THAN ZERO
070800         OR  MR02-TKT-RATE-L   (X-MR02-TKT) GREATER THAN ZERO
070900             MOVE MR02-TKT-RATE (X-MR02-TKT)
071000                                 TO WS-RATE
071100             IF  MR02-TKT-SIGN (X-MR02-TKT) IS EQUAL TO '-'
071200                 COMPUTE WS-RATE = WS-RATE * -1
071300             END-IF
071400         END-IF
071500         IF  MR02-TKT-RATE-L (X-MR02-TKT) GREATER THAN ZERO
071600         OR  MR02-TKT-SIGN-L (X-MR02-TKT) GREATER THAN ZERO
071700             IF  WS-RATE IS NOT EQUAL TO MMRT-SINGLE-TKT-RATE
071800                                     (X-MMRT-SINGLE-TKT)
071900                 SET WS-UPDATE-SW-YES
072000                                 TO TRUE
072100                 IF  MBCA-PTI-FUNCTION-IS-MAINT
072200                     MOVE 0204   TO MML1-FIELD-CODE
072300                     SET MML1-FIELD-OCCURRENCE
072400                                 TO X-MMRT-SINGLE-TKT
072500                     MOVE ZEROES TO MML1-FIELD-OCCURRENCE-2
072600                     MOVE MML1WS-VL-20
072700                                 TO MML1-VARIABLE-LENGTH
072800                     MOVE MMRT-SINGLE-TKT-RATE
072900                                    (X-MMRT-SINGLE-TKT)
073000                                 TO MML1-VL20-B-NBR-NO-DEC
073100                     MOVE WS-RATE
073200                                 TO MMRT-SINGLE-TKT-RATE
073300                                    (X-MMRT-SINGLE-TKT)
073400                     MOVE MMRT-SINGLE-TKT-RATE
073500                                    (X-MMRT-SINGLE-TKT)
073600                                 TO MML1-VL20-A-NBR-NO-DEC
073700                     MOVE 'FC07' TO MBCA-PROGRAM-LOCATION
073800                     PERFORM 9200-WRITE-LOG-RECORD
073900                                 THRU 9299-WLR-EXIT
074000                 ELSE
074100                     MOVE WS-RATE
074200                                 TO MMRT-SINGLE-TKT-RATE
074300                                    (X-MMRT-SINGLE-TKT)
074400                 END-IF
074500             END-IF
074600         END-IF
074700     END-PERFORM.
074800*
074900 2440-UPDATE-LOG-REC.
075000*
075100     IF  MBCA-PTI-FUNCTION-IS-ADD
075200         MOVE MBCA-SCREEN-NBR    TO MMRT-ONLINE-STATUS
075300         MOVE MBCA-START-DATE    TO MMRT-LAST-MAINT-DATE
075400         MOVE MBCA-OPERATOR-ID   TO MMRT-LAST-MAINT-OPER
075500         MOVE 'Y'                TO WS-UPDATE-SW.
075600*
075700**************************************************************
075800*    WRITE A LOG RECORD TO SHOW THAT THE LAST MAINT DATE     *
075900*    AND LAST-MAINT-OPERATOR HAS BEEN UPDATED IF FIELDS WERE CHANG
076000*    ON THE SCREEN                                           *
076100**************************************************************
076200*
076300     IF  MBCA-PTI-FUNCTION-IS-MAINT
076400     AND WS-UPDATE-SW-YES
076500         MOVE 0198               TO MML1-FIELD-CODE
076600         MOVE ZEROES             TO MML1-FIELD-OCCURRENCE
076700                                    MML1-FIELD-OCCURRENCE-2
076800         MOVE MML1WS-VL-03       TO MML1-VARIABLE-LENGTH
076900         MOVE MMRT-LAST-MAINT-OPER
077000                                 TO MML1-VL03-B-DATA-X
077100         MOVE MBCA-OPERATOR-ID   TO MMRT-LAST-MAINT-OPER
077200         MOVE MMRT-LAST-MAINT-OPER
077300                                 TO MML1-VL03-A-DATA-X
077400         MOVE 'FC08'             TO MBCA-PROGRAM-LOCATION
077500         PERFORM 9200-WRITE-LOG-RECORD
077600            THRU 9299-WLR-EXIT
077700         MOVE 0199               TO MML1-FIELD-CODE
077800         MOVE MML1WS-VL-07       TO MML1-VARIABLE-LENGTH
077900         MOVE MMRT-LAST-MAINT-DATE
078000                                 TO MML1-VL07-B-DATA-9
078100         MOVE MBCA-START-DATE    TO MMRT-LAST-MAINT-DATE
078200         MOVE MMRT-LAST-MAINT-DATE
078300                                 TO MML1-VL07-A-DATA-9
078400         MOVE 'FC09'             TO MBCA-PROGRAM-LOCATION
078500         PERFORM 9200-WRITE-LOG-RECORD
078600            THRU 9299-WLR-EXIT.
078700*
078800****************************************************************
078900*    REWRITE THE NEW RATE TABLE RECORD                         *
079000****************************************************************
079100*
079200     IF  WS-UPDATE-SW-YES
079300         MOVE 'FC10'             TO MBCA-PROGRAM-LOCATION
079400         SET MBIORO-REWRITE      TO TRUE
079500         PERFORM MMRTAO-ACCESS   THRU MMRTAO-ACCESS-EXIT
079600     ELSE
079700         MOVE 'FC11'             TO MBCA-PROGRAM-LOCATION
079800         SET MBIORO-UNLOCK       TO TRUE
079900         PERFORM MMRTAO-ACCESS   THRU MMRTAO-ACCESS-EXIT.
080000*
080100 2600-SETUP-COMMAREA.
080200*
080300****************************************************************
080400*    SET UP COMMAREA FIELDS AND TRANSFER TO THE NEXT PROGRAM   *
080500****************************************************************
080600*
080700     IF  MMRT-EXCEPTION-NOT-USED (1)
080800     AND MMRT-EXCEPTION-NOT-USED (3)
080900         COMPUTE MBCA-SCREEN-NBR = MBCA-SCREEN-NBR + 51
081000         GO TO F010-XCTL.
081100*
081200     MOVE MBCA-EIBAID            TO SS08WS-EIBAID.
081300*
081400     PERFORM MB60PD-EDIT-PAGE-NBR
081500                                 THRU MB60PD-EPN-EXIT.
081600*
081700     IF  SS08WS-VALID-PF-KEY
081800     OR  SS08WS-EIBAID-VALID-PF-KEY
081900         SET MBCA-INITIAL-SCREEN-NBR
082000                                 TO TRUE.
082100*
082200*
082300 F010-XCTL.
082400     MOVE 'PC05'                 TO MBCA-PROGRAM-LOCATION.
082500     PERFORM MB70PD-XCTL-TO-MBOXCTL
082600                                 THRU MB70PD-XTM-EXIT.
082700*
082800 9000-PERFORMED-ROUTINES-SECT SECTION.
082900*
083000 9100-BUILD-DISC-TABLE.
083100*
083200     MOVE MMRT-METHOD            TO MMRTWS-METHOD.
083300*
083400 9110-BUILD-DISC-TABLE-LOOP.
083500*
083600     MOVE MMRT-SINGLE-TKT-BEG-LIMIT
083700                                 TO MR02-TKT-BEG.
083800*
083900     IF  MBCA-PTI-FUNCTION-IS-INQUIRY
084000         MOVE DFHBMPRO           TO MR02-TKT-BEG-A
084100         MOVE DFHBMDAS           TO MR02-TKT-BEG-LP-A
084200                                    MR02-TKT-BEG-RP-A.
084300*
084400     PERFORM
084500         VARYING X-MR02-AVT FROM 1 BY 1
084600         UNTIL X-MR02-AVT IS GREATER THAN 10
084700         SET X-MMRT-ATV          TO X-MR02-AVT
084800         MOVE MMRT-ATV-LIMIT (X-MMRT-ATV)
084900                                 TO MR02-AVT-LIMIT
085000                                     (X-MR02-AVT)
085100         MOVE MMRT-ATV-RATE (X-MMRT-ATV)
085200                                 TO MR02-AVT-RATE
085300                                     (X-MR02-AVT)
085400         EVALUATE TRUE
085500             WHEN MMRT-ATV-RATE (X-MMRT-ATV) IS LESS THAN ZERO
085600                 MOVE '-'        TO MR02-AVT-SIGN
085700                                     (X-MR02-AVT)
085800             WHEN OTHER
085900                 MOVE '+'        TO MR02-AVT-SIGN
086000                                     (X-MR02-AVT)
086100         END-EVALUATE
086200         EVALUATE TRUE
086300           WHEN  MBCA-PTI-FUNCTION-IS-INQUIRY
086400             MOVE DFHBMDAS       TO MR02-AVT-LIMIT-LP-A
086500                                    (X-MR02-AVT)
086600                                    MR02-AVT-LIMIT-RP-A
086700                                    (X-MR02-AVT)
086800                                    MR02-AVT-RATE-LP-A
086900                                    (X-MR02-AVT)
087000                                    MR02-AVT-RATE-RP-A
087100                                    (X-MR02-AVT)
087200             MOVE DFHBMASB       TO MR02-AVT-LIMIT-A
087300                                    (X-MR02-AVT)
087400                                    MR02-AVT-RATE-A
087500                                    (X-MR02-AVT)
087600                                    MR02-AVT-SIGN-A
087700                                    (X-MR02-AVT)
087800           WHEN (X-MR02-AVT IS EQUAL TO 10
087900               AND MBCA-PTI-FUNCTION-IS-ADD
088000               OR  MBCA-PTI-FUNCTION-IS-MAINT)
088100             MOVE DFHBMDAS   TO MR02-AVT-LIMIT-LP-A (10)
088200                                MR02-AVT-LIMIT-RP-A (10)
088300             MOVE DFHBMASF   TO MR02-AVT-LIMIT-A    (10)
088400           WHEN OTHER
088500               CONTINUE
088600         END-EVALUATE
088700     END-PERFORM.
088800*
088900     PERFORM
089000         VARYING X-MR02-TKT FROM 1 BY 1
089100         UNTIL X-MR02-TKT IS GREATER THAN 10
089200         SET X-MMRT-SINGLE-TKT   TO X-MR02-TKT
089300         MOVE MMRT-SINGLE-TKT-LIMIT (X-MMRT-SINGLE-TKT)
089400                                 TO MR02-TKT-LIMIT
089500                                     (X-MR02-TKT)
089600         MOVE MMRT-SINGLE-TKT-RATE (X-MMRT-SINGLE-TKT)
089700                                 TO MR02-TKT-RATE
089800                                     (X-MR02-TKT)
089900         EVALUATE TRUE
090000             WHEN MMRT-SINGLE-TKT-RATE (X-MMRT-SINGLE-TKT)
090100                                    IS LESS THAN ZERO
090200                 MOVE '-'        TO MR02-TKT-SIGN
090300                                     (X-MR02-TKT)
090400             WHEN OTHER
090500                 MOVE '+'        TO MR02-TKT-SIGN
090600                                     (X-MR02-TKT)
090700         END-EVALUATE
090800         EVALUATE TRUE
090900           WHEN  MBCA-PTI-FUNCTION-IS-INQUIRY
091000             MOVE DFHBMDAS       TO MR02-TKT-LIMIT-LP-A
091100                                    (X-MR02-TKT)
091200                                    MR02-TKT-LIMIT-RP-A
091300                                    (X-MR02-TKT)
091400                                    MR02-TKT-RATE-LP-A
091500                                    (X-MR02-TKT)
091600                                    MR02-TKT-RATE-RP-A
091700                                    (X-MR02-TKT)
091800             MOVE DFHBMASB       TO MR02-TKT-LIMIT-A
091900                                    (X-MR02-TKT)
092000                                    MR02-TKT-RATE-A
092100                                    (X-MR02-TKT)
092200                                    MR02-TKT-SIGN-A
092300                                    (X-MR02-TKT)
092400           WHEN (X-MR02-TKT IS EQUAL TO 10
092500               AND MBCA-PTI-FUNCTION-IS-ADD
092600               OR  MBCA-PTI-FUNCTION-IS-MAINT)
092700             MOVE DFHBMDAS   TO MR02-TKT-LIMIT-LP-A (10)
092800                                MR02-TKT-LIMIT-RP-A (10)
092900             MOVE DFHBMASF   TO MR02-TKT-LIMIT-A    (10)
093000           WHEN OTHER
093100               CONTINUE
093200         END-EVALUATE
093300     END-PERFORM.
093400*
093500     IF  (MMRTWS-DTD-VOLUME-W-AVG-TKT
093600     OR  MMRTWS-PTD-VOLUME-W-AVG-TKT)
093700     AND NOT MMRT-EXCEPTION-NOT-USED (1)
093800         MOVE DFHBMASK           TO MR02-TKT-BEG-A
093900                                    MR02-TKT-BEG-LP-A
094000                                    MR02-TKT-BEG-RP-A
094100         PERFORM
094200             VARYING X-MR02-TKT FROM 1 BY 1
094300             UNTIL X-MR02-TKT IS GREATER THAN 10
094400             MOVE DFHBMASK       TO MR02-TKT-LIMIT-LP-A
094500                                        (X-MR02-TKT)
094600                                    MR02-TKT-LIMIT-RP-A
094700                                        (X-MR02-TKT)
094800                                    MR02-TKT-RATE-LP-A
094900                                        (X-MR02-TKT)
095000                                    MR02-TKT-RATE-RP-A
095100                                        (X-MR02-TKT)
095200                                    MR02-TKT-RATE-A
095300                                        (X-MR02-TKT)
095400                                    MR02-TKT-SIGN-A
095500                                        (X-MR02-TKT)
095600                                    MR02-TKT-LIMIT-A
095700                                        (X-MR02-TKT)
095800         END-PERFORM.
095900*
096000     IF  MMRTWS-DTD-AVG-TKT-CUM
096100     OR  MMRTWS-PTD-AVG-TKT-CUM
096200     OR  MMRTWS-ROLLING-1-MON-AVG-TKT
096300     OR  MMRTWS-ROLLING-3-MON-AVG-TKT
096400     OR  MMRTWS-ROLLING-6-MON-AVG-TKT
096500     OR  MMRTWS-ROLLING-12-MON-AVG-TKT
096600         PERFORM
096700             VARYING X-MR02-AVT FROM 1 BY 1
096800             UNTIL X-MR02-AVT IS GREATER THAN 10
096900             MOVE DFHBMASK       TO MR02-AVT-LIMIT-LP-A
097000                                        (X-MR02-AVT)
097100                                    MR02-AVT-LIMIT-RP-A
097200                                        (X-MR02-AVT)
097300                                    MR02-AVT-RATE-LP-A
097400                                        (X-MR02-AVT)
097500                                    MR02-AVT-RATE-RP-A
097600                                        (X-MR02-AVT)
097700                                    MR02-AVT-RATE-A
097800                                        (X-MR02-AVT)
097900                                    MR02-AVT-SIGN-A
098000                                        (X-MR02-AVT)
098100                                    MR02-AVT-LIMIT-A
098200                                        (X-MR02-AVT)
098300         END-PERFORM.
098400*
098500 9199-BDT-EXIT.
098600     EXIT.
098700*
098800*
098900*
099000 9200-WRITE-LOG-RECORD.
099100*
099200     SET MBIORO-WRITE            TO TRUE.
099300     PERFORM MML1AO-ACCESS       THRU MML1AO-ACCESS-EXIT.
099400     MOVE SPACES                 TO MML1-VARIABLE-AREA.
099500*
099600 9299-WLR-EXIT.
099700     EXIT.
099800*
099900 9300-CROSS-EDIT-LIMITS.
100000*
100100     IF  SS08WS-ERROR-SW-YES
100200         GO TO 9399-EXIT.
100300*
100400     IF (MR02-AVT-LIMIT (1) IS EQUAL TO  MR02-AVT-LIMIT (10)
100500     OR  MR02-AVT-LIMIT (1) IS LESS THAN MR02-AVT-LIMIT (2))
100600     AND
100700        (MR02-AVT-LIMIT (2) IS EQUAL TO  MR02-AVT-LIMIT (10)
100800     OR  MR02-AVT-LIMIT (2) IS LESS THAN MR02-AVT-LIMIT (3))
100900     AND
101000        (MR02-AVT-LIMIT (3) IS EQUAL TO  MR02-AVT-LIMIT (10)
101100     OR  MR02-AVT-LIMIT (3) IS LESS THAN MR02-AVT-LIMIT (4))
101200     AND
101300        (MR02-AVT-LIMIT (4) IS EQUAL TO  MR02-AVT-LIMIT (10)
101400     OR  MR02-AVT-LIMIT (4) IS LESS THAN MR02-AVT-LIMIT (5))
101500     AND
101600        (MR02-AVT-LIMIT (5) IS EQUAL TO  MR02-AVT-LIMIT (10)
101700     OR  MR02-AVT-LIMIT (5) IS LESS THAN MR02-AVT-LIMIT (6))
101800     AND
101900        (MR02-AVT-LIMIT (6) IS EQUAL TO  MR02-AVT-LIMIT (10)
102000     OR  MR02-AVT-LIMIT (6) IS LESS THAN MR02-AVT-LIMIT (7))
102100     AND
102200        (MR02-AVT-LIMIT (7) IS EQUAL TO  MR02-AVT-LIMIT (10)
102300     OR  MR02-AVT-LIMIT (7) IS LESS THAN MR02-AVT-LIMIT (8))
102400     AND
102500        (MR02-AVT-LIMIT (8) IS EQUAL TO  MR02-AVT-LIMIT (10)
102600     OR  MR02-AVT-LIMIT (8) IS LESS THAN MR02-AVT-LIMIT (9))
102700     AND
102800        (MR02-AVT-LIMIT (9) IS EQUAL TO  MR02-AVT-LIMIT (10)
102900     OR  MR02-AVT-LIMIT (9) IS LESS THAN MR02-AVT-LIMIT (10))
103000         NEXT SENTENCE
103100     ELSE
103200         MOVE SS08WS-CURSOR      TO MR02-AVT-LIMIT-L (1)
103300         SET SS08WS-ERROR-SW-YES TO TRUE
103400         PERFORM
103500             VARYING X-MR02-AVT FROM 1 BY 1
103600             UNTIL   X-MR02-AVT IS GREATER THAN 10
103700             MOVE DFHBMASB       TO MR02-AVT-LIMIT-LP-A
103800                                     (X-MR02-AVT)
103900                                    MR02-AVT-LIMIT-RP-A
104000                                     (X-MR02-AVT)
104100             MOVE DFHBMNBF       TO MR02-AVT-LIMIT-A
104200                                     (X-MR02-AVT)
104300         END-PERFORM.
104400*
104500     IF (MR02-TKT-LIMIT (1) IS EQUAL TO  MR02-TKT-LIMIT (10)
104600     OR  MR02-TKT-LIMIT (1) IS LESS THAN MR02-TKT-LIMIT (2))
104700     AND
104800        (MR02-TKT-LIMIT (2) IS EQUAL TO  MR02-TKT-LIMIT (10)
104900     OR  MR02-TKT-LIMIT (2) IS LESS THAN MR02-TKT-LIMIT (3))
105000     AND
105100        (MR02-TKT-LIMIT (3) IS EQUAL TO  MR02-TKT-LIMIT (10)
105200     OR  MR02-TKT-LIMIT (3) IS LESS THAN MR02-TKT-LIMIT (4))
105300     AND
105400        (MR02-TKT-LIMIT (4) IS EQUAL TO  MR02-TKT-LIMIT (10)
105500     OR  MR02-TKT-LIMIT (4) IS LESS THAN MR02-TKT-LIMIT (5))
105600     AND
105700        (MR02-TKT-LIMIT (5) IS EQUAL TO  MR02-TKT-LIMIT (10)
105800     OR  MR02-TKT-LIMIT (5) IS LESS THAN MR02-TKT-LIMIT (6))
105900     AND
106000        (MR02-TKT-LIMIT (6) IS EQUAL TO  MR02-TKT-LIMIT (10)
106100     OR  MR02-TKT-LIMIT (6) IS LESS THAN MR02-TKT-LIMIT (7))
106200     AND
106300        (MR02-TKT-LIMIT (7) IS EQUAL TO  MR02-TKT-LIMIT (10)
106400     OR  MR02-TKT-LIMIT (7) IS LESS THAN MR02-TKT-LIMIT (8))
106500     AND
106600        (MR02-TKT-LIMIT (8) IS EQUAL TO  MR02-TKT-LIMIT (10)
106700     OR  MR02-TKT-LIMIT (8) IS LESS THAN MR02-TKT-LIMIT (9))
106800     AND
106900        (MR02-TKT-LIMIT (9) IS EQUAL TO  MR02-TKT-LIMIT (10)
107000     OR  MR02-TKT-LIMIT (9) IS LESS THAN MR02-TKT-LIMIT (10))
107100         NEXT SENTENCE
107200     ELSE
107300         MOVE SS08WS-CURSOR      TO MR02-TKT-LIMIT-L (1)
107400         SET SS08WS-ERROR-SW-YES TO TRUE
107500         PERFORM
107600             VARYING X-MR02-TKT FROM 1 BY 1
107700             UNTIL   X-MR02-TKT IS GREATER THAN 10
107800             MOVE DFHBMASB       TO MR02-TKT-LIMIT-LP-A
107900                                     (X-MR02-TKT)
108000                                    MR02-TKT-LIMIT-RP-A
108100                                     (X-MR02-TKT)
108200             MOVE DFHBMNBF       TO MR02-TKT-LIMIT-A
108300                                     (X-MR02-TKT)
108400         END-PERFORM.
108500*
108600 9399-EXIT.
108700     EXIT.
108800*
108900 9400-CROSS-EDIT-AVT.
109000*
109100     IF  SS08WS-ERROR-SW-YES
109200         GO TO 9499-EXIT.
109300*
109400*************************
109500*    SET THE INDEXES    *
109600*************************
109700*
109800     SET X-MR02-AVT              TO 1.
109900     SET X-MMRT-ATV              TO WS-INDEX.
110000     SET X-MMRTIR-ATV            TO 1.
110100     SET X-MMRT-EXCEPTION        TO 1.
110200*
110300 9410-LOOP.
110400*
110500**************************************************************
110600*    AVT RATE CROSS EDITS ARE AS FOLLOWS:                    *
110700*                                                            *
110800*      . IF THE LIMIT FIELD IS THE INITIALIZER DEFAULT,      *
110900*        THE RATE FIELD MUST ALSO BE THE INITIALIZER         *
111000*        DEFAULT.                                            *
111100*      . IF THE LIMIT EXCEPTION IS OF A OVERRIDE             *
111200*        PRIORITY, NO RATE CAN BE NEGATIVE.                  *
111300*      . IF THE LIMIT EXCEPTION IS AN ADJUSTMENT,            *
111400*        NO RATE WHEN ADDED TO EACH PRIMARY RATE             *
111500*        (INDIVIDUALLY) CAN BE LESS THAN ZERO.               *
111600*                                                            *
111700*    IF THERE IS AN ERROR, THE LIMIT AND RATE ARE            *
111800*    HIGHLIGHTED.                                            *
111900**************************************************************
112000*
112100     IF  X-MR02-AVT IS EQUAL 10
112200         GO TO 9415-CONTINUE.
112300*
112400 9415-CONTINUE.
112500*
112600     IF  MMRT-EXCEPTION-IS-OVERRIDE (X-MMRT-EXCEPTION)
112700         IF  MR02-AVT-SIGN (X-MR02-AVT) IS EQUAL TO '-'
112800             GO TO 9440-CROSS-EDIT-AVT-ERROR
112900         ELSE
113000             GO TO 9450-INCREMENT-INDEXES.
113100*
113200     IF  MR02-AVT-SIGN (X-MR02-AVT) IS NOT EQUAL TO '-'
113300         GO TO 9450-INCREMENT-INDEXES.
113400*
113500************************************
113600*    SET THE PRIMARY RATE INDEX    *
113700************************************
113800*
113900     SET X-MMRT-PRIM             TO 1.
114000*
114100     MOVE MR02-AVT-RATE (X-MR02-AVT)
114200                                 TO WS-RATE.
114300     COMPUTE WS-RATE             = WS-RATE * -1.
114400*
114500 9420-PRIM-LOOP.
114600*
114700     COMPUTE WS-RATE-TOTAL =
114800         WS-RATE + MMRT-PRIM-RATE (X-MMRT-PRIM).
114900*
115000     IF  WS-RATE-TOTAL IS LESS THAN ZERO
115100         GO TO 9440-CROSS-EDIT-AVT-ERROR.
115200*
115300 9430-INCREMENT-INDEXES.
115400*
115500     IF  X-MMRT-PRIM IS LESS THAN 10
115600     AND MMRT-PRIM-LIMIT (X-MMRT-PRIM)
115700                             IS NOT EQUAL TO 99999999999999999
115800         SET X-MMRT-PRIM         UP BY 1
115900         GO TO 9420-PRIM-LOOP
116000     ELSE
116100         GO TO 9450-INCREMENT-INDEXES.
116200*
116300 9440-CROSS-EDIT-AVT-ERROR.
116400*
116500**********************************************
116600*    BRIGHTEN AND FSET THE DEPT AND RATE     *
116700**********************************************
116800*
116900     SET SS08WS-ERROR-SW-YES     TO TRUE.
117000     MOVE SS08WS-CURSOR          TO MR02-AVT-RATE-L
117100                                        (X-MR02-AVT).
117200     MOVE DFHBMASB               TO MR02-AVT-LIMIT-LP-A
117300                                        (X-MR02-AVT)
117400                                    MR02-AVT-LIMIT-RP-A
117500                                        (X-MR02-AVT)
117600                                    MR02-AVT-RATE-LP-A
117700                                        (X-MR02-AVT)
117800                                    MR02-AVT-RATE-RP-A
117900                                        (X-MR02-AVT).
118000     MOVE DFHBMNBF               TO MR02-AVT-RATE-A
118100                                        (X-MR02-AVT)
118200                                    MR02-AVT-LIMIT-A
118300                                        (X-MR02-AVT).
118400     MOVE DFHBMUBF               TO MR02-AVT-SIGN-A
118500                                        (X-MR02-AVT).
118600     GO TO 9499-EXIT.
118700*
118800 9450-INCREMENT-INDEXES.
118900*
119000     IF  X-MR02-AVT IS LESS THAN 10
119100         SET X-MR02-AVT          UP BY 1
119200         SET X-MMRTIR-ATV        UP BY 1
119300         GO TO 9410-LOOP.
119400*
119500 9499-EXIT.
119600     EXIT.
119700*
119800 9500-CROSS-EDIT-TKT.
119900*
120000     IF  SS08WS-ERROR-SW-YES
120100         GO TO 9599-EXIT.
120200*
120300*************************
120400*    SET THE INDEXES    *
120500*************************
120600*
120700     SET X-MR02-TKT              TO 1.
120800     SET X-MMRT-SINGLE-TKT       TO WS-INDEX.
120900     SET X-MMRTIR-SINGLE-TKT     TO 1.
121000     SET X-MMRT-EXCEPTION        TO 3.
121100*
121200 9510-LOOP.
121300*
121400**************************************************************
121500*    TKT RATE CROSS EDITS ARE AS FOLLOWS:                    *
121600*                                                            *
121700*      . IF THE LIMIT FIELD IS THE INITIALIZER DEFAULT,      *
121800*        THE RATE FIELD MUST ALSO BE THE INITIALIZER         *
121900*        DEFAULT.                                            *
122000*      . IF THE LIMIT EXCEPTION IS OF A OVERRIDE             *
122100*        PRIORITY, NO RATE CAN BE NEGATIVE.                  *
122200*      . IF THE LIMIT EXCEPTION IS AN ADJUSTMENT,            *
122300*        NO RATE WHEN ADDED TO EACH PRIMARY RATE             *
122400*        (INDIVIDUALLY) CAN BE LESS THAN ZERO.               *
122500*                                                            *
122600*    IF THERE IS AN ERROR, THE LIMIT AND RATE ARE            *
122700*    HIGHLIGHTED.                                            *
122800**************************************************************
122900*
123000     IF  X-MR02-TKT IS EQUAL 10
123100         GO TO 9515-CONTINUE.
123200*
123300 9515-CONTINUE.
123400*
123500     IF  MMRT-EXCEPTION-IS-OVERRIDE (X-MMRT-EXCEPTION)
123600         IF  MR02-TKT-SIGN (X-MR02-TKT) IS EQUAL TO '-'
123700             GO TO 9540-CROSS-EDIT-TKT-ERROR
123800         ELSE
123900             GO TO 9550-INCREMENT-INDEXES.
124000*
124100     IF  MR02-TKT-SIGN (X-MR02-TKT) IS NOT EQUAL TO '-'
124200         GO TO 9550-INCREMENT-INDEXES.
124300*
124400************************************
124500*    SET THE PRIMARY RATE INDEX    *
124600************************************
124700*
124800     SET X-MMRT-PRIM             TO 1.
124900*
125000     MOVE MR02-TKT-RATE (X-MR02-TKT)
125100                                 TO WS-RATE.
125200     COMPUTE WS-RATE             = WS-RATE * -1.
125300*
125400 9520-PRIM-LOOP.
125500*
125600     COMPUTE WS-RATE-TOTAL =
125700         WS-RATE + MMRT-PRIM-RATE (X-MMRT-PRIM).
125800*
125900     IF  WS-RATE-TOTAL IS LESS THAN ZERO
126000         GO TO 9540-CROSS-EDIT-TKT-ERROR.
126100*
126200 9530-INCREMENT-INDEXES.
126300*
126400     IF  X-MMRT-PRIM IS LESS THAN 10
126500     AND MMRT-PRIM-LIMIT (X-MMRT-PRIM)
126600                             IS NOT EQUAL TO 99999999999999999
126700         SET X-MMRT-PRIM         UP BY 1
126800         GO TO 9520-PRIM-LOOP
126900     ELSE
127000         GO TO 9550-INCREMENT-INDEXES.
127100*
127200 9540-CROSS-EDIT-TKT-ERROR.
127300*
127400**********************************************
127500*    BRIGHTEN AND FSET THE DEPT AND RATE     *
127600**********************************************
127700*
127800     SET SS08WS-ERROR-SW-YES     TO TRUE.
127900     MOVE SS08WS-CURSOR          TO MR02-TKT-RATE-L
128000                                        (X-MR02-TKT).
128100     MOVE DFHBMASB               TO MR02-TKT-LIMIT-LP-A
128200                                        (X-MR02-TKT)
128300                                    MR02-TKT-LIMIT-RP-A
128400                                        (X-MR02-TKT)
128500                                    MR02-TKT-RATE-LP-A
128600                                        (X-MR02-TKT)
128700                                    MR02-TKT-RATE-RP-A
128800                                        (X-MR02-TKT).
128900     MOVE DFHBMNBF               TO MR02-TKT-RATE-A
129000                                        (X-MR02-TKT)
129100                                    MR02-TKT-LIMIT-A
129200                                        (X-MR02-TKT).
129300     MOVE DFHBMUBF               TO MR02-TKT-SIGN-A
129400                                        (X-MR02-TKT).
129500     GO TO 9599-EXIT.
129600*
129700 9550-INCREMENT-INDEXES.
129800*
129900     IF  X-MR02-TKT IS LESS THAN 10
130000         SET X-MR02-TKT          UP BY 1
130100         SET X-MMRTIR-SINGLE-TKT UP BY 1
130200         GO TO 9510-LOOP.
130300*
130400 9599-EXIT.
130500     EXIT.
130600*
130700 9600-CROSS-EDIT-SINGLE-TKT-BEG.
130800*
130900     IF  SS08WS-ERROR-SW-YES
131000         GO TO 9699-EXIT.
131100*
131200*
131300**************************************************************
131400*    TKT RATE CROSS EDITS ARE AS FOLLOWS:                    *
131500*                                                            *
131600*      . THE BEGINNING LIMIT MUST BE LESS THAN THE 1ST       *
131700*        TIER OF THE SINGLE TKT LIMITS.                      *
131800**************************************************************
131900*
132000     IF  MR02-TKT-BEG IS LESS THAN
132100         MR02-TKT-LIMIT (1)
132200     OR  (MR02-TKT-BEG IS EQUAL TO 99999999999999999
132300     AND  MR02-TKT-LIMIT (1) IS EQUAL TO 99999999999999999)
132400         GO TO 9699-EXIT.
132500*
132600     SET SS08WS-ERROR-SW-YES     TO TRUE.
132700     MOVE SS08WS-CURSOR          TO MR02-TKT-BEG-L.
132800     MOVE DFHBMASB               TO MR02-TKT-BEG-LP-A
132900                                    MR02-TKT-BEG-RP-A.
133000     MOVE DFHBMNBF               TO MR02-TKT-BEG-A.
133100*
133200     PERFORM
133300         VARYING X-MR02-TKT FROM 1 BY 1
133400         UNTIL X-MR02-TKT IS GREATER THAN 10
133500         MOVE DFHBMASB           TO MR02-TKT-LIMIT-LP-A
133600                                        (X-MR02-TKT)
133700                                    MR02-TKT-LIMIT-RP-A
133800                                        (X-MR02-TKT)
133900                                    MR02-TKT-RATE-LP-A
134000                                        (X-MR02-TKT)
134100                                    MR02-TKT-RATE-RP-A
134200                                        (X-MR02-TKT)
134300         MOVE DFHBMNBF           TO MR02-TKT-RATE-A
134400                                        (X-MR02-TKT)
134500                                    MR02-TKT-LIMIT-A
134600                                        (X-MR02-TKT)
134700     END-PERFORM.
134800*
134900     MOVE DFHBMUBF               TO MR02-TKT-SIGN-A
135000                                        (X-MR02-TKT).
135100*
135200 9699-EXIT.
135300     EXIT.
135400*
135500 9700-CROSS-EDIT-AVG-TKT-LIMIT.
135600*
135700     IF  SS08WS-ERROR-SW-YES
135800         GO TO 9769-CEATL-EXIT.
135900*
136000***************************
136100*    RESET THE INDEXES    *
136200***************************
136300*
136400     SET X-MR02-AVT              TO 2.
136500*
136600 9752-CEL-LOOP.
136700*
136800**************************************************************
136900*    LIMIT CROSS EDITS ARE AS FOLLOWS:                       *
137000*                                                            *
137100*      . EACH LIMIT MUST BE GREATER THAN ITS PREDECESSOR     *
137200*        WITH ONE EXCEPTION:                                 *
137300*                                                            *
137400*      . IF A LIMIT IS EQUAL TO ITS PREDECESSOR, IT          *
137500*        MUST BE ALL 9'S, AND EACH SUCCEEDING LIMIT MUST     *
137600*        ALSO BE ALL 9'S.                                    *
137700*                                                            *
137800*    IF THERE IS AN ERROR, ALL LIMITS AND RATES ARE          *
137900*    OPENED TO THE OPERATOR FOR CORRECTION.                  *
138000**************************************************************
138100*
138200     IF  MR02-AVT-LIMIT (X-MR02-AVT) IS GREATER THAN
138300         MR02-AVT-LIMIT (X-MR02-AVT - 1)
138400         GO TO 9768-INCREMENT-INDEXES.
138500*
138600     IF  MR02-AVT-LIMIT (X-MR02-AVT) IS LESS THAN
138700         MR02-AVT-LIMIT (X-MR02-AVT - 1)
138800         GO TO 9754-CROSS-EDIT-LIMIT-ERROR.
138900*
139000     IF  X-MR02-AVT IS LESS THAN 9
139100         IF  MR02-AVT-LIMIT (X-MR02-AVT) IS EQUAL TO
139200             99999999999999999
139300         AND MR02-AVT-LIMIT (X-MR02-AVT + 1) IS EQUAL TO
139400             99999999999999999
139500             GO TO 9768-INCREMENT-INDEXES
139600         ELSE
139700             GO TO 9754-CROSS-EDIT-LIMIT-ERROR
139800     ELSE
139900         GO TO 9768-INCREMENT-INDEXES.
140000*
140100 9754-CROSS-EDIT-LIMIT-ERROR.
140200*
140300******************************************
140400*    BRIGHTEN AND FSET THIS LINE ITEM    *
140500******************************************
140600*
140700     MOVE 'Y'                    TO SS08WS-ERROR.
140800     MOVE SS08WS-CURSOR          TO MR02-AVT-LIMIT-L
140900                                        (X-MR02-AVT).
141000     MOVE DFHBMASB               TO MR02-AVT-LIMIT-LP-A
141100                                        (X-MR02-AVT)
141200                                    MR02-AVT-LIMIT-RP-A
141300                                        (X-MR02-AVT).
141400     MOVE DFHBMNBF               TO MR02-AVT-LIMIT-A
141500                                        (X-MR02-AVT).
141600*
141700********************************************************
141800*    UNPROTECT ALL LIMITS AND RATES FOR CORRECTION.    *
141900*    IF A FIELD WAS PREVEOUSLY KEYED (IT WOULD HAVE    *
142000*    BEEN SET TO DFHBMASF BY THE EDIT ROUTINES),       *
142100*    FSET IT HERE, ALSO.                               *
142200********************************************************
142300*
142400     SET X-MR02-AVT              TO 1.
142500*
142600 9756-CELE-LOOP.
142700*
142800******************************
142900*    UNPROTECT THE PARENS    *
143000******************************
143100*
143200     MOVE DFHBMASK               TO MR02-AVT-LIMIT-LP-A
143300                                        (X-MR02-AVT)
143400                                    MR02-AVT-LIMIT-RP-A
143500                                        (X-MR02-AVT)
143600                                    MR02-AVT-RATE-LP-A
143700                                        (X-MR02-AVT)
143800                                    MR02-AVT-RATE-RP-A
143900                                        (X-MR02-AVT).
144000*
144100     IF  MR02-AVT-LIMIT-A (X-MR02-AVT) IS EQUAL TO DFHBMASF
144200         MOVE DFHBMUNF           TO MR02-AVT-LIMIT-A
144300                                        (X-MR02-AVT).
144400*
144500     IF  MR02-AVT-LIMIT-A (X-MR02-AVT) IS EQUAL TO DFHBMASK
144600         MOVE DFHBMUNN           TO MR02-AVT-LIMIT-A
144700                                        (X-MR02-AVT).
144800*
144900     IF  MR02-AVT-RATE-A (X-MR02-AVT) IS EQUAL TO DFHBMASF
145000         MOVE DFHBMUNF           TO MR02-AVT-RATE-A
145100                                        (X-MR02-AVT).
145200*
145300     IF  MR02-AVT-RATE-A (X-MR02-AVT) IS EQUAL TO DFHBMASK
145400         MOVE DFHBMUNN           TO MR02-AVT-RATE-A
145500                                        (X-MR02-AVT).
145600*
145700 9758-INCREMENT-INDEXES.
145800*
145900     IF  X-MR02-AVT IS LESS THAN 10
146000         SET X-MR02-AVT          UP BY 1
146100         GO TO 9756-CELE-LOOP.
146200*
146300*************************************************************
146400*    DARKEN THE PARENS AND AUTOSKIP THE 10TH LIMIT FIELD    *
146500*************************************************************
146600*
146700     MOVE DFHBMDAS               TO MR02-AVT-LIMIT-LP-A
146800                                        (X-MR02-AVT)
146900                                    MR02-AVT-LIMIT-RP-A
147000                                        (X-MR02-AVT).
147100     MOVE DFHBMASK               TO MR02-AVT-LIMIT-A
147200                                        (X-MR02-AVT).
147300     GO TO 9769-CEATL-EXIT.
147400*
147500 9768-INCREMENT-INDEXES.
147600*
147700     IF  X-MR02-AVT IS LESS THAN 10
147800         SET X-MR02-AVT          UP BY 1
147900         GO TO 9752-CEL-LOOP.
148000*
148100 9769-CEATL-EXIT.
148200     EXIT.
148300*
148400 9800-CROSS-EDIT-SNG-TKT-LIMIT.
148500*
148600     IF  SS08WS-ERROR-SW-YES
148700         GO TO 9869-CESTL-EXIT.
148800*
148900***************************
149000*    RESET THE INDEXES    *
149100***************************
149200*
149300     SET X-MR02-TKT              TO 2.
149400*
149500 9852-CEL-LOOP.
149600*
149700**************************************************************
149800*    LIMIT CROSS EDITS ARE AS FOLLOWS:                       *
149900*                                                            *
150000*      . EACH LIMIT MUST BE GREATER THAN ITS PREDECESSOR     *
150100*        WITH ONE EXCEPTION:                                 *
150200*                                                            *
150300*      . IF A LIMIT IS EQUAL TO ITS PREDECESSOR, IT          *
150400*        MUST BE ALL 9'S, AND EACH SUCCEEDING LIMIT MUST     *
150500*        ALSO BE ALL 9'S.                                    *
150600*                                                            *
150700*    IF THERE IS AN ERROR, ALL LIMITS AND RATES ARE          *
150800*    OPENED TO THE OPERATOR FOR CORRECTION.                  *
150900**************************************************************
151000*
151100     IF  MR02-TKT-LIMIT (X-MR02-TKT) IS GREATER THAN
151200         MR02-TKT-LIMIT (X-MR02-TKT - 1)
151300         GO TO 9868-INCREMENT-INDEXES.
151400*
151500     IF  MR02-TKT-LIMIT (X-MR02-TKT) IS LESS THAN
151600         MR02-TKT-LIMIT (X-MR02-TKT - 1)
151700         GO TO 9854-CROSS-EDIT-LIMIT-ERROR.
151800*
151900     IF  X-MR02-TKT IS LESS THAN 9
152000         IF  MR02-TKT-LIMIT (X-MR02-TKT) IS EQUAL TO
152100             99999999999999999
152200         AND MR02-TKT-LIMIT (X-MR02-TKT + 1) IS EQUAL TO
152300             99999999999999999
152400             GO TO 9868-INCREMENT-INDEXES
152500         ELSE
152600             GO TO 9854-CROSS-EDIT-LIMIT-ERROR
152700     ELSE
152800         GO TO 9868-INCREMENT-INDEXES.
152900*
153000 9854-CROSS-EDIT-LIMIT-ERROR.
153100*
153200******************************************
153300*    BRIGHTEN AND FSET THIS LINE ITEM    *
153400******************************************
153500*
153600     MOVE 'Y'                    TO SS08WS-ERROR.
153700     MOVE SS08WS-CURSOR          TO MR02-TKT-LIMIT-L
153800                                        (X-MR02-TKT).
153900     MOVE DFHBMASB               TO MR02-TKT-LIMIT-LP-A
154000                                        (X-MR02-TKT)
154100                                    MR02-TKT-LIMIT-RP-A
154200                                        (X-MR02-TKT).
154300     MOVE DFHBMNBF               TO MR02-TKT-LIMIT-A
154400                                        (X-MR02-TKT).
154500*
154600********************************************************
154700*    UNPROTECT ALL LIMITS AND RATES FOR CORRECTION.    *
154800*    IF A FIELD WAS PREVEOUSLY KEYED (IT WOULD HAVE    *
154900*    BEEN SET TO DFHBMASF BY THE EDIT ROUTINES),       *
155000*    FSET IT HERE, ALSO.                               *
155100********************************************************
155200*
155300     SET X-MR02-TKT              TO 1.
155400*
155500 9856-CELE-LOOP.
155600*
155700******************************
155800*    UNPROTECT THE PARENS    *
155900******************************
156000*
156100     MOVE DFHBMASK               TO MR02-TKT-LIMIT-LP-A
156200                                        (X-MR02-TKT)
156300                                    MR02-TKT-LIMIT-RP-A
156400                                        (X-MR02-TKT)
156500                                    MR02-TKT-RATE-LP-A
156600                                        (X-MR02-TKT)
156700                                    MR02-TKT-RATE-RP-A
156800                                        (X-MR02-TKT).
156900*
157000     IF  MR02-TKT-LIMIT-A (X-MR02-TKT) IS EQUAL TO DFHBMASF
157100         MOVE DFHBMUNF           TO MR02-TKT-LIMIT-A
157200                                        (X-MR02-TKT).
157300*
157400     IF  MR02-TKT-LIMIT-A (X-MR02-TKT) IS EQUAL TO DFHBMASK
157500         MOVE DFHBMUNN           TO MR02-TKT-LIMIT-A
157600                                        (X-MR02-TKT).
157700*
157800     IF  MR02-TKT-RATE-A (X-MR02-TKT) IS EQUAL TO DFHBMASF
157900         MOVE DFHBMUNF           TO MR02-TKT-RATE-A
158000                                        (X-MR02-TKT).
158100*
158200     IF  MR02-TKT-RATE-A (X-MR02-TKT) IS EQUAL TO DFHBMASK
158300         MOVE DFHBMUNN           TO MR02-TKT-RATE-A
158400                                        (X-MR02-TKT).
158500*
158600 9858-INCREMENT-INDEXES.
158700*
158800     IF  X-MR02-TKT IS LESS THAN 10
158900         SET X-MR02-TKT          UP BY 1
159000         GO TO 9856-CELE-LOOP.
159100*
159200*************************************************************
159300*    DARKEN THE PARENS AND AUTOSKIP THE 10TH LIMIT FIELD    *
159400*************************************************************
159500*
159600     MOVE DFHBMDAS               TO MR02-TKT-LIMIT-LP-A
159700                                        (X-MR02-TKT)
159800                                    MR02-TKT-LIMIT-RP-A
159900                                        (X-MR02-TKT).
160000     MOVE DFHBMASK               TO MR02-TKT-LIMIT-A
160100                                        (X-MR02-TKT).
160200     GO TO 9869-CESTL-EXIT.
160300*
160400 9868-INCREMENT-INDEXES.
160500*
160600     IF  X-MR02-TKT IS LESS THAN 10
160700         SET X-MR02-TKT          UP BY 1
160800         GO TO 9852-CEL-LOOP.
160900*
161000 9869-CESTL-EXIT.
161100     EXIT.
161200*
161300 9900-CROSS-EDIT-SNG-AND-AVG.
161400*
161500     IF  SS08WS-ERROR-SW-YES
161600         GO TO 9969-CESAA-EXIT.
161700*
161800     MOVE MMRT-METHOD            TO MMRTWS-METHOD.
161900*
162000 9952-CEL-LOOP.
162100*
162200     IF  (MMRTWS-DTD-VOLUME-W-AVG-TKT
162300     OR  MMRTWS-PTD-VOLUME-W-AVG-TKT)
162400     AND NOT MMRT-EXCEPTION-NOT-USED (1)
162500         MOVE DFHBMASK           TO MR02-TKT-BEG-A
162600                                    MR02-TKT-BEG-LP-A
162700                                    MR02-TKT-BEG-RP-A
162800         PERFORM
162900             VARYING X-MR02-TKT FROM 1 BY 1
163000             UNTIL X-MR02-TKT IS GREATER THAN 10
163100             MOVE DFHBMASK       TO MR02-TKT-LIMIT-LP-A
163200                                        (X-MR02-TKT)
163300                                    MR02-TKT-LIMIT-RP-A
163400                                        (X-MR02-TKT)
163500                                    MR02-TKT-RATE-LP-A
163600                                        (X-MR02-TKT)
163700                                    MR02-TKT-RATE-RP-A
163800                                        (X-MR02-TKT)
163900                                    MR02-TKT-RATE-A
164000                                        (X-MR02-TKT)
164100                                    MR02-TKT-SIGN-A
164200                                        (X-MR02-TKT)
164300                                    MR02-TKT-LIMIT-A
164400                                        (X-MR02-TKT)
164500         END-PERFORM.
164600*
164700     IF  MMRTWS-DTD-AVG-TKT-CUM
164800     OR  MMRTWS-PTD-AVG-TKT-CUM
164900     OR  MMRTWS-ROLLING-1-MON-AVG-TKT
165000     OR  MMRTWS-ROLLING-3-MON-AVG-TKT
165100     OR  MMRTWS-ROLLING-6-MON-AVG-TKT
165200     OR  MMRTWS-ROLLING-12-MON-AVG-TKT
165300         PERFORM
165400             VARYING X-MR02-AVT FROM 1 BY 1
165500             UNTIL X-MR02-AVT IS GREATER THAN 10
165600             MOVE DFHBMASK       TO MR02-AVT-LIMIT-LP-A
165700                                        (X-MR02-AVT)
165800                                    MR02-AVT-LIMIT-RP-A
165900                                        (X-MR02-AVT)
166000                                    MR02-AVT-RATE-LP-A
166100                                        (X-MR02-AVT)
166200                                    MR02-AVT-RATE-RP-A
166300                                        (X-MR02-AVT)
166400                                    MR02-AVT-RATE-A
166500                                        (X-MR02-AVT)
166600                                    MR02-AVT-SIGN-A
166700                                        (X-MR02-AVT)
166800                                    MR02-AVT-LIMIT-A
166900                                        (X-MR02-AVT)
167000         END-PERFORM.
167100*
167200 9969-CESAA-EXIT.
167300     EXIT.
167400*
167500*
167600/         GREGORIAN TO JULIAN DATE ROUTINE
167700     COPY SS07PD.
167800*
167900/         NEW ROUTINE FOR JULIAN TO GREGORIAN CONVERSION
168000     COPY SS26PD.
168100*
168200/         ROUTINE TO NUMERICALLY EDIT TIME
168300     COPY SS27PD.
168400*
168500/         JULIAN TO GREGORIAN DATE ROUTINE
168600     COPY SS08PD.
168700*
168800/         LINE 24 PF KEYS ROUTINE
168900     COPY SS15PD.
169000*
169100/         DICOUNT RATE TABLE ACCESS ROUTINE
169200     COPY MMRTAO.
169300*
169400/         LOG REC FILE ACCESS ROUTINE
169500     COPY MML1AO.
169600*
169700/         ON-LINE MAP ROUTINES
169800     COPY MB60PD REPLACING 'MBMAPXX' BY 'MBMR02 '
169900                           MBMAPXXI BY MBMR02I
170000                           MBMAPXXO BY MBMR02O.
170100*
170200/         ON-LINE PROCEDURES
170300     COPY MB70PD.
170400/
170500     COPY SMFTPXO.
