000100 IDENTIFICATION DIVISION.
000200 PROGRAM-ID. MBOMR09.
000201*       RELEASE DATE=08/24/01.        REVISION LEVEL=08.06      *
000202*****************************************************************
000203*WARNING.  THIS COMPUTER PROGRAM IS PROTECTED BY COPYRIGHT LAW  *
000204*AND INTERNATIONAL TREATIES.  UNAUTHORIZED REPRODUCTION OR      *
000205*DISTRIBUTION OF THIS PROGRAM, OR ANY PORTION OF IT, MAY RESULT *
000206*IN SEVERE CIVIL AND CRIMINAL PENATLIES, AND WILL BE PROSECUTED *
000207*TO THE MAXIMUM EXTENT POSSIBLE UNDER THE LAW.                  *
000208*COPYRIGHT 1999 PAYSYS INTERNATIONAL, INC.  ALL RIGHTS RESERVED.*
000209*****************************************************************
000300*****************************************************************
000400*                                                               *
000500*               M E R C H A N T   S Y S T E M                   *
000600*                                                               *
000700*      MBOMR09 - ON-LINE DISCOUNT RATE TABLE ADD/MAINT/INQ      *
000800*                SCREEN 09                                      *
000900*                                                               *
001000*              1. TRANSIDS                                      *
001100*                 A. MBAR                                       *
001200*                 B. MBMR                                       *
001300*                 C. MBQR                                       *
001400*              2. MAPS USED -                                   *
001500*                 A. MBMR09 (SCREEN 09)                         *
001600*              3. FILES USED -                                  *
001700*                 A. MMRT (DISCOUNT RATE TABLE)                 *
001800*                 B. MML1 (LOG FILE)                            *
001900*                                                               *
002000*****************************************************************
002100*
002200 ENVIRONMENT DIVISION.
002300*
002400 DATA DIVISION.
002500*
002600 WORKING-STORAGE SECTION.
002700*
002800 01  FILLER                  PIC  X(12)      VALUE
002900     '** WS-BEG **'.
003000*
003100 01  FILLER                  PIC  X(14)      VALUE
003200     'MISCELLANEOUS:'.
003300*
003400 01  WS-MISCELLANEOUS.
003500     03  WS-INDEX            PIC S9(08)      BINARY.
003600     03  WS-RATE             PIC S9(09)      COMP-3
003700                                             VALUE ZEROES.
003800     03  WS-RATE-TOTAL       PIC S9(09)      COMP-3
003900                                             VALUE ZEROES.
004000     03  WS-SCREEN-BYPASS-SW PIC  X(01)      VALUE 'N'.
004100         88  THIS-SCREEN-IS-BYPASSED         VALUE 'Y'.
004200         88  THIS-SCREEN-IS-NOT-BYPASSED     VALUE 'N'.
004300     03  WS-UPDATE-SW        PIC  X(01)      VALUE 'N'.
004400         88  FIELDS-WERE-UPDATED             VALUE 'Y'.
004500         88  NO-FIELDS-WERE-UPDATED          VALUE 'N'.
004600     03  WS-RATE-ERROR-SW    PIC  X(01)      VALUE 'N'.
004700         88  RATE-ERRORS-EXIST               VALUE 'Y'.
004800         88  NO-RATE-ERRORS-EXIST            VALUE 'N'.
004900/
005000 01  FILLER                  PIC  X(29)      VALUE
005100     'I/O REQUEST BLOCK WORK AREAS:'.
005200*
005300     COPY MBIOWS.
005400/
005500 01  FILLER                  PIC  X(18)      VALUE
005600     'I/O REQUEST BLOCK:'.
005700*
005800     COPY MBIORO.
005900/
006000 01  FILLER                  PIC  X(25)      VALUE
006100     'LOG RECORD REQUEST BLOCK:'.
006200*
006300     COPY MML1WS REPLACING ==:MML1:== BY ==MML1==.
006400/
006500 01  FILLER                  PIC  X(39)      VALUE
006600     'DISCOUNT RATE TABLE INITIALIZER RECORD:'.
006700*
006800     COPY MMRTIR.
006900/
007000 01  FILLER                  PIC  X(23)      VALUE
007100     'RATE TABLES WORK AREAS:'.
007200*
007300     COPY MMRTWS.
007400/
007500 01  FILLER                  PIC  X(20)      VALUE
007600     'CCS DATE WORK AREAS:'.
007700*
007800     COPY SS01WS.
007900/
008000 01  FILLER                  PIC  X(15)      VALUE
008100     'CCS WORK AREAS:'.
008200*
008300     COPY SS08WS.
008400/
008500     COPY SS00WS.
008600/
008700     COPY SMFTWS.
008800/
008900     COPY SMPTRL REPLACING ==:SMPT:== BY ==SMPT==.
009000/
009100     COPY MB61LK.
009200/
009300 01  FILLER                  PIC  X(12)      VALUE
009400     '** WS-END **'.
009500/
009600 LINKAGE SECTION.
009700*
009800 01  DFHCOMMAREA.
009900*
010000     COPY MB60WS.
010100/
010200*********************************
010300*    DISCOUNT RATE TABLE MAP    *
010400*********************************
010500*
010600     COPY MBMR09.
010700/
010800**********************************************
010900*    DISCOUNT RATE TABLE MAP REDEFINITION    *
011000**********************************************
011100*
011200     COPY MBMR09R.
011300/
011400*******************************************
011500*    DISCOUNT RATE TABLE RECORD LAYOUT    *
011600*******************************************
011700*
011800     COPY MMRTRL.
011900/
012000***************************
012100*    LOG RECORD LAYOUT    *
012200***************************
012300*
012400     COPY MML1RL REPLACING ==:MML1:== BY ==MML1==.
012500/
012600 PROCEDURE DIVISION.
012700*
012800 A000-HOUSEKEEPING SECTION.
012900*
013000 A020-INIT.
013100*
013200     MOVE 'PC01'                 TO MBCA-PROGRAM-LOCATION.
013300     PERFORM MB70PD-ON-LINE-HOUSEKEEPING
013400                                 THRU MB70PD-OLH-EXIT.
013500*
013600     IF  MBCA-RECEIVE-SCREEN
013700         GO TO C000-RECEIVE-SCREEN.
013800/
013900 B000-SEND-SCREEN SECTION.
014000*
014100**************************************
014200*    READ THE DISCOUNT RATE TABLE    *
014300*    FOR SUBSEQUENT DISPLAY          *
014400**************************************
014500*
014600     MOVE MBCA-MERCHANT-ORG      TO MBIOWS-MMRT-ORG.
014700     MOVE MBCA-TABLE             TO MBIOWS-MMRT-TABLE-NBR.
014800     MOVE MBCA-TABLE-TYPE        TO MBIOWS-MMRT-TABLE-TYPE.
014900     MOVE 'FC01'                 TO MBCA-PROGRAM-LOCATION.
015000     SET MBIORO-READ-RANDOM      TO TRUE.
015100     PERFORM MMRTAO-ACCESS       THRU MMRTAO-ACCESS-EXIT.
015200*
015300***************************************************
015400*    IF THE LOGO EXCEPTION PRIORITY SPECIFIES     *
015500*    'NOT USED', BYPASS THIS SCREEN.  IF  THIS    *
015600*    IS THE ADD FUNCTION, BRANCH TO THE UPDATE    *
015700*    SECTION OF THE PROGRAM WHERE THE ONLINE      *
015800*    STATUS , MAINT DATE, AND MAINT OPERATOR      *
015900*    WILL BE UPDATED.                             *
016000***************************************************
016100*
016200     SET X-MMRT-EXCEPTION        TO 5.
016300*
016400     IF  MMRT-EXCEPTION-NOT-USED (X-MMRT-EXCEPTION)
016500         COMPUTE MBCA-SCREEN-NBR = MBCA-SCREEN-NBR - 50
016600         IF  MBCA-PTI-FUNCTION-IS-ADD
016700             MOVE 'Y'            TO WS-SCREEN-BYPASS-SW
016800             GO TO E000-UPDATE-FILE
016900         ELSE
017000             GO TO F000-SETUP-COMMAREA.
017100*
017200*
017300*********************************************
017400*    GET CICS STORAGE NEEDED FOR THE MAP    *
017500*********************************************
017600*
017700     MOVE 'SC01'                 TO MBCA-PROGRAM-LOCATION.
017800     PERFORM MB60PD-GETMAIN-FOR-MAP
017900                                 THRU MB60PD-GFM-EXIT.
018000*
018100*******************************************
018200*    INITIALIZE THE STANDARD MAP LINES    *
018300*******************************************
018400*
018500     PERFORM MB60PD-INIT-STD-MAP-LINES
018600                                 THRU MB60PD-ISML-EXIT.
018700*
018800****************************************************
018900*    MOVE THE KEY AND TABLE TITLE TO THE SCREEN    *
019000****************************************************
019100*
019200     MOVE MBCA-MERCHANT-ORG      TO MR09-ORG.
019300     MOVE MBCA-TABLE             TO MR09-TABLE.
019400     MOVE MMRT-TITLE             TO MR09-TITLE.
019500*
019600 B020-MOVE-FIELDS-TO-SCREEN.
019700*
019800*******************************************************
019900*    MOVE THE FIELDS FROM THE RECORD TO THE SCREEN    *
020000*******************************************************
020100*
020200     EVALUATE MBCA-SCREEN-NBR
020300         WHEN 59
020400             MOVE 09             TO MBCA-SCREEN-NBR
020500             MOVE 1              TO WS-INDEX
020600         WHEN 60
020700             MOVE 10             TO MBCA-SCREEN-NBR
020800             MOVE 29             TO WS-INDEX
020900     END-EVALUATE.
021000*
021100     PERFORM Y020-MOVE-LOGOS     THRU Y039-MD-EXIT.
021200*
021300     PERFORM Y040-MOVE-RATES     THRU Y059-MR-EXIT.
021400*
021500******************************************
021600*    SET THE CURSOR AND SCREEN NUMBER    *
021700******************************************
021800*
021900     IF  MBCA-PTI-FUNCTION-ADD-OR-MAINT
022000         MOVE SS08WS-CURSOR      TO MR09-LOGO-L (1)
022100     ELSE
022200         MOVE SS08WS-CURSOR      TO MR09-ALT-TRANID-L.
022300*
022400***********************************************************
022500*    SET THE CURRENCY CODE, CURRENCY NOD
022600*            PER ITEM NOD, PERCENT NOD.
022700***********************************************************
022800     IF MR09-ERROR-MESSAGE IS EQUAL TO SPACES OR LOW-VALUES
022900        PERFORM MB06PD-FORMAT-MESSAGE-LINE
023000                                 THRU MB06PD-FML-EXIT
023100        MOVE SS08WS-FORMATTED-MSG   TO MR09-ERROR-MESSAGE
023200     END-IF.
023300*
023400**********************
023500*    SEND THE MAP    *
023600**********************
023700*
023800     MOVE 'BM01'                 TO MBCA-PROGRAM-LOCATION.
023900*
024000     PERFORM MB60PD-SEND-MAP-WITH-ERASE
024100                                 THRU MB60PD-SMWE-EXIT.
024200*
024300************************
024400*    RETURN TO CICS    *
024500************************
024600*
024700     MOVE 'PC02'                 TO MBCA-PROGRAM-LOCATION.
024800     PERFORM MB70PD-RETURN-TRANS-ID
024900                                 THRU MB70PD-RTI-EXIT.
025000/
025100 C000-RECEIVE-SCREEN SECTION.
025200*
025300******************************************
025400*    THIS SECTION RECEIVES THE SCREEN    *
025500******************************************
025600*
025700     MOVE 'BM02'                 TO MBCA-PROGRAM-LOCATION.
025800     PERFORM MB60PD-RECEIVE-MAP  THRU MB60PD-RM-EXIT.
025900*
026000**************************************************************
026100*    CHECK FOR ANOTHER TRANSACTION ID ENTERED BY THE USER    *
026200**************************************************************
026300*
026400     MOVE 'PC03'                 TO MBCA-PROGRAM-LOCATION.
026500     PERFORM MB60PD-NEW-TRANS-ROUTINE
026600                                 THRU MB60PD-NTR-EXIT.
026700*
026800*********************************************
026900*    READ THE DISCOUNT RATE TABLE RECORD    *
027000*********************************************
027100*
027200     MOVE MBCA-MERCHANT-ORG      TO MBIOWS-MMRT-ORG
027300                                    MR09-ORG.
027400     MOVE MBCA-TABLE             TO MBIOWS-MMRT-TABLE-NBR
027500                                    MR09-TABLE.
027600     MOVE MBCA-TABLE-TYPE        TO MBIOWS-MMRT-TABLE-TYPE.
027700     MOVE 'FC02'                 TO MBCA-PROGRAM-LOCATION.
027800     SET MBIORO-READ-RANDOM      TO TRUE.
027900     PERFORM MMRTAO-ACCESS       THRU MMRTAO-ACCESS-EXIT.
028000     MOVE MMRT-METHOD            TO MMRTWS-METHOD.
028100*
028200     EVALUATE MBCA-SCREEN-NBR
028300         WHEN 09
028400             MOVE 1              TO WS-INDEX
028500         WHEN 10
028600             MOVE 29             TO WS-INDEX
028700     END-EVALUATE.
028800*
028900****************************************************
029000*    BYPASS ALL SCREEN EDITS IF THIS IS INQUIRY    *
029100****************************************************
029200*
029300     IF  MBCA-PTI-FUNCTION-IS-INQUIRY
029400         GO TO F000-SETUP-COMMAREA.
029500*
029600 C020-FIELD-EDITS.
029700*
029800*********************
029900*    FIELD EDITS    *
030000*********************
030100*
030200     PERFORM W020-EDIT-LOGOS     THRU W039-ED-EXIT.
030300*
030400     PERFORM W040-EDIT-RATES     THRU W059-ER-EXIT.
030500*
030600     PERFORM W060-CROSS-EDIT-RATES
030700                                 THRU W079-CER-EXIT.
030800/
030900 D000-RETURN-ERRORS SECTION.
031000*
031100     IF  SS08WS-ERROR IS EQUAL TO 'N'
031200         GO TO E000-UPDATE-FILE.
031300*
031400***************************************************************
031500*    INITIALIZE THE STANDARD MAP LINES.  IN AN ERROR          *
031600*    CONDITION, THIS ROUTINE IS PERFORMED PRIMARILY           *
031700*    TO UPDATE THE DATE AND TIME ON THE SCREEN.               *
031800***************************************************************
031900*
032000     PERFORM MB60PD-INIT-STD-MAP-LINES
032100                                 THRU MB60PD-ISML-EXIT.
032200*
032300***********************************************************
032400*    SET THE CURRENCY CODE, CURRENCY NOD
032500*            PER ITEM NOD, PERCENT NOD.
032600***********************************************************
032700     IF MR09-ERROR-MESSAGE IS EQUAL TO SPACES OR LOW-VALUES
032800        PERFORM MB06PD-FORMAT-MESSAGE-LINE
032900                                 THRU MB06PD-FML-EXIT
033000        MOVE SS08WS-FORMATTED-MSG   TO MR09-ERROR-MESSAGE
033100     END-IF.
033200*
033300**********************
033400*    SEND THE MAP    *
033500**********************
033600*
033700     MOVE 'BM03'                 TO MBCA-PROGRAM-LOCATION.
033800     PERFORM MB60PD-SEND-MAP-DATA-ONLY
033900                                 THRU MB60PD-SMDO-EXIT.
034000*
034100************************
034200*    RETURN TO CICS    *
034300************************
034400*
034500     MOVE 'PC04'                 TO MBCA-PROGRAM-LOCATION.
034600     PERFORM MB70PD-RETURN-TRANS-ID
034700                                 THRU MB70PD-RTI-EXIT.
034800/
034900 E000-UPDATE-FILE SECTION.
035000*
035100********************************************************
035200*    READ THE DISCOUNT RATE TABLE RECORD FOR UPDATE    *
035300********************************************************
035400*
035500     MOVE 'FC03'                 TO MBCA-PROGRAM-LOCATION.
035600     SET MBIORO-READ-RANDOM-UPDATE
035700                                 TO TRUE.
035800     PERFORM MMRTAO-ACCESS       THRU MMRTAO-ACCESS-EXIT.
035900*
036000********************************************
036100*    OBTAIN STORAGE FOR LOG FILE RECORD    *
036200*    IF DOING MAINTENANCE                  *
036300********************************************
036400*
036500     IF  MBCA-PTI-FUNCTION-IS-ADD
036600         IF  THIS-SCREEN-IS-BYPASSED
036700             GO TO E040-UPDATE-MMRT
036800         ELSE
036900             GO TO E020-UPDATE-FIELDS.
037000*
037100     MOVE 'SC02'                 TO MBCA-PROGRAM-LOCATION.
037200     SET MBIORO-GETMAIN          TO TRUE.
037300     PERFORM MML1AO-ACCESS       THRU MML1AO-ACCESS-EXIT.
037400*
037500*************************************************
037600*    SET UP THE COMMON PORTION OF THE RECORD    *
037700*************************************************
037800*
037900     MOVE 'RT'                   TO MML1-FILE-CODE.
038000     MOVE MBCA-MERCHANT-ORG      TO MML1-MMRT-ORG.
038100     MOVE MBCA-TABLE             TO MML1-MMRT-TABLE-NBR.
038200     MOVE MBCA-TABLE-TYPE        TO MML1-MMRT-TABLE-TYPE.
038300     MOVE MBCA-SIGNON-NAME       TO MML1-SIGNON-NAME.
038400     MOVE MBCA-TERMINAL-ID       TO MML1-TERMINAL-ID.
038500     MOVE ZEROS                  TO MML1-SOURCE-CODE.
038600*
038700 E020-UPDATE-FIELDS.
038800*
038900     PERFORM X020-UPDATE-LOGOS   THRU X039-UD-EXIT.
039000*
039100     PERFORM X040-UPDATE-RATES   THRU X059-UR-EXIT.
039200*
039300 E040-UPDATE-MMRT.
039400*
039500     IF  MBCA-PTI-FUNCTION-IS-ADD
039600         MOVE MBCA-SCREEN-NBR    TO MMRT-ONLINE-STATUS
039700         MOVE MBCA-START-DATE    TO MMRT-LAST-MAINT-DATE
039800         MOVE MBCA-OPERATOR-ID   TO MMRT-LAST-MAINT-OPER
039900         MOVE 'Y'                TO WS-UPDATE-SW.
040000*
040100**************************************************************
040200*    WRITE A LOG RECORD TO SHOW THAT THE LAST MAINT DATE     *
040300*    AND OPERATOR HAS BEEN UPDATED IF FIELDS WERE CHANGED    *
040400*    ON THE SCREEN                                           *
040500**************************************************************
040600*
040700     IF  MBCA-PTI-FUNCTION-IS-MAINT
040800     AND FIELDS-WERE-UPDATED
040900         MOVE 0198               TO MML1-FIELD-CODE
041000         MOVE ZEROES             TO MML1-FIELD-OCCURRENCE
041100                                    MML1-FIELD-OCCURRENCE-2
041200         MOVE MML1WS-VL-03       TO MML1-VARIABLE-LENGTH
041300         MOVE MMRT-LAST-MAINT-OPER
041400                                 TO MML1-VL03-B-DATA-X
041500         MOVE MBCA-OPERATOR-ID   TO MMRT-LAST-MAINT-OPER
041600         MOVE MMRT-LAST-MAINT-OPER
041700                                 TO MML1-VL03-A-DATA-X
041800         MOVE 'FC04'             TO MBCA-PROGRAM-LOCATION
041900         PERFORM Y060-WRITE-LOG-RECORD
042000                                 THRU Y079-WLR-EXIT
042100         MOVE 0199               TO MML1-FIELD-CODE
042200         MOVE MML1WS-VL-07       TO MML1-VARIABLE-LENGTH
042300         MOVE MMRT-LAST-MAINT-DATE
042400                                 TO MML1-VL07-B-DATA-9
042500         MOVE MBCA-START-DATE    TO MMRT-LAST-MAINT-DATE
042600         MOVE MMRT-LAST-MAINT-DATE
042700                                 TO MML1-VL07-A-DATA-9
042800         MOVE 'FC05'             TO MBCA-PROGRAM-LOCATION
042900         PERFORM Y060-WRITE-LOG-RECORD
043000                                 THRU Y079-WLR-EXIT.
043100*
043200****************************************************
043300*    REWRITE THE DISCOUNT RATE TABLE RECORD IF     *
043400*    FIELDS HAVE BEEN CHANGED ON THE SCREEN, OR    *
043500*    UNLOCK IT IF THEY HAVE NOT                    *
043600****************************************************
043700*
043800     IF  FIELDS-WERE-UPDATED
043900         MOVE 'FC06'             TO MBCA-PROGRAM-LOCATION
044000         SET MBIORO-REWRITE      TO TRUE
044100         PERFORM MMRTAO-ACCESS   THRU MMRTAO-ACCESS-EXIT
044200     ELSE
044300         MOVE 'FC07'             TO MBCA-PROGRAM-LOCATION
044400         SET MBIORO-UNLOCK       TO TRUE
044500         PERFORM MMRTAO-ACCESS   THRU MMRTAO-ACCESS-EXIT.
044600/
044700 F000-SETUP-COMMAREA SECTION.
044800*
044900***************************************************************
045000*  SET UP COMMAREA FIELDS AND TRANSFER TO THE NEXT PROGRAM    *
045100***************************************************************
045200*
045300     IF  MMRT-EXCEPTION-NOT-USED (X-MMRT-EXCEPTION)
045400         COMPUTE MBCA-SCREEN-NBR = MBCA-SCREEN-NBR + 51
045500         GO TO F010-XCTL.
045600*
045700     MOVE MBCA-EIBAID            TO SS08WS-EIBAID.
045800*
045900     PERFORM MB60PD-EDIT-PAGE-NBR
046000                                 THRU MB60PD-EPN-EXIT.
046100*
046200     IF  SS08WS-VALID-PF-KEY
046300     OR  SS08WS-EIBAID-VALID-PF-KEY
046400         SET MBCA-INITIAL-SCREEN-NBR
046500                                 TO TRUE.
046600*
046700 F010-XCTL.
046800*
046900     MOVE 'PC05'                 TO MBCA-PROGRAM-LOCATION.
047000     PERFORM MB70PD-XCTL-TO-MBOXCTL
047100                                 THRU MB70PD-XTM-EXIT.
047200/
047300 W000-FIELD-EDITS SECTION.
047400*
047500 W020-EDIT-LOGOS.
047600*
047700***********************************
047800*    SET THE BEGINNING INDEXES    *
047900***********************************
048000*
048100     SET X-MR09-LOGO             TO 1.
048200     SET X-MMRT-LOGO             TO WS-INDEX.
048300*
048400 W022-ED-LOOP.
048500*
048600**************************************************
048700*    SET THE FIELD ATTRIBUTES TO THE LOGO IN     *
048800*    WHICH THEY WOULD BE IF ALL EDITS WERE OK    *
048900**************************************************
049000*
049100     MOVE DFHBMDAS               TO MR09-LOGO-LP-A
049200                                        (X-MR09-LOGO)
049300                                    MR09-LOGO-RP-A
049400                                        (X-MR09-LOGO).
049500     MOVE DFHBMASK               TO MR09-LOGO-A
049600                                        (X-MR09-LOGO).
049700*
049800*****************************
049900*    EDIT FOR VALID DATA    *
050000*****************************
050100*
050200     IF  MR09-LOGO-L (X-MR09-LOGO) IS EQUAL TO ZERO
050300         MOVE MMRT-LOGO (X-MMRT-LOGO)
050400                                 TO MR09-LOGO (X-MR09-LOGO)
050500     ELSE
050600         IF  MR09-LOGO (X-MR09-LOGO) IS NUMERIC
050700             MOVE DFHBMASF       TO MR09-LOGO-A (X-MR09-LOGO)
050800             MOVE DFHBMDAS       TO MR09-LOGO-LP-A (X-MR09-LOGO)
050900                                    MR09-LOGO-RP-A (X-MR09-LOGO)
051000         ELSE
051100             MOVE DFHBMNBF       TO MR09-LOGO-A (X-MR09-LOGO)
051200             MOVE DFHBMASB       TO MR09-LOGO-LP-A (X-MR09-LOGO)
051300                                    MR09-LOGO-RP-A (X-MR09-LOGO)
051400             MOVE SS08WS-CURSOR  TO MR09-LOGO-L (X-MR09-LOGO)
051500             SET SS08WS-ERROR-SW-YES TO TRUE.
051600*
051700 W038-INCREMENT-INDEXES.
051800*
051900     IF  X-MR09-LOGO IS LESS THAN 28
052000         SET X-MR09-LOGO         UP BY 1
052100         SET X-MMRT-LOGO         UP BY 1
052200         GO TO W022-ED-LOOP.
052300*
052400 W039-ED-EXIT.
052500     EXIT.
052600*
052700 W040-EDIT-RATES.
052800*
052900***********************************
053000*    SET THE BEGINNING INDEXES    *
053100***********************************
053200*
053300     SET X-MR09-LOGO             TO 1.
053400     SET X-MMRT-LOGO             TO WS-INDEX.
053500*
053600 W042-ER-LOOP.
053700*
053800**************************************************
053900*    SET THE FIELD ATTRIBUTES TO THE LOGO IN     *
054000*    WHICH THEY WOULD BE IF ALL EDITS WERE OK    *
054100**************************************************
054200*
054300     MOVE DFHBMDAS               TO MR09-LOGO-RATE-LP-A
054400                                        (X-MR09-LOGO)
054500                                    MR09-LOGO-RATE-RP-A
054600                                        (X-MR09-LOGO).
054700     MOVE DFHBMASK               TO MR09-LOGO-RATE-A
054800                                        (X-MR09-LOGO)
054900                                    MR09-LOGO-RATE-SIGN-A
055000                                        (X-MR09-LOGO).
055100*
055200*************************************
055300*    EDIT FOR VALID NUMERIC DATA    *
055400*************************************
055500*
055600     IF  MR09-LOGO-RATE-L (X-MR09-LOGO) IS EQUAL TO ZERO
055700         MOVE MMRT-LOGO-RATE (X-MMRT-LOGO)
055800                                 TO MR09-LOGO-RATE
055900                                        (X-MR09-LOGO)
056000         GO TO W046-EDIT-RATE-SIGN.
056100*
056200     IF  MR09-LOGO-RATE (X-MR09-LOGO) IS NUMERIC
056300         MOVE DFHBMASF           TO MR09-LOGO-RATE-A
056400                                        (X-MR09-LOGO)
056500         GO TO W046-EDIT-RATE-SIGN.
056600*
056700 W044-RATE-ERROR.
056800*
056900     MOVE 'Y'                    TO SS08WS-ERROR
057000                                    WS-RATE-ERROR-SW.
057100     MOVE SS08WS-CURSOR          TO MR09-LOGO-RATE-L
057200                                        (X-MR09-LOGO).
057300     MOVE DFHBMNBF               TO MR09-LOGO-RATE-A
057400                                        (X-MR09-LOGO).
057500     MOVE DFHBMASB               TO MR09-LOGO-RATE-LP-A
057600                                        (X-MR09-LOGO)
057700                                    MR09-LOGO-RATE-RP-A
057800                                        (X-MR09-LOGO).
057900*
058000 W046-EDIT-RATE-SIGN.
058100*
058200*****************************
058300*    EDIT FOR VALID DATA    *
058400*****************************
058500*
058600     IF  MR09-LOGO-RATE-SIGN-L (X-MR09-LOGO) IS EQUAL TO ZERO
058700         IF  MMRT-LOGO-RATE (X-MMRT-LOGO)
058800             IS LESS THAN ZERO
058900             MOVE '-'            TO MR09-LOGO-RATE-SIGN
059000                                        (X-MR09-LOGO)
059100             GO TO W058-INCREMENT-INDEXES
059200         ELSE
059300             MOVE '+'            TO MR09-LOGO-RATE-SIGN
059400                                        (X-MR09-LOGO)
059500             GO TO W058-INCREMENT-INDEXES.
059600*
059700     IF  MR09-LOGO-RATE-SIGN (X-MR09-LOGO) IS EQUAL TO
059800         '-' OR '+'
059900         MOVE DFHBMASF           TO MR09-LOGO-RATE-SIGN-A
060000                                        (X-MR09-LOGO)
060100         GO TO W058-INCREMENT-INDEXES.
060200*
060300 W048-RATE-SIGN-ERROR.
060400*
060500     MOVE 'Y'                    TO SS08WS-ERROR
060600                                    WS-RATE-ERROR-SW.
060700     MOVE SS08WS-CURSOR          TO MR09-LOGO-RATE-SIGN-L
060800                                        (X-MR09-LOGO).
060900     MOVE DFHBMUBF               TO MR09-LOGO-RATE-SIGN-A
061000                                        (X-MR09-LOGO).
061100     MOVE DFHBMASB               TO MR09-LOGO-RATE-LP-A
061200                                        (X-MR09-LOGO)
061300                                    MR09-LOGO-RATE-RP-A
061400                                        (X-MR09-LOGO).
061500*
061600 W058-INCREMENT-INDEXES.
061700*
061800     IF  X-MR09-LOGO IS LESS THAN 28
061900         SET X-MR09-LOGO         UP BY 1
062000         SET X-MMRT-LOGO         UP BY 1
062100         GO TO W042-ER-LOOP.
062200*
062300 W059-ER-EXIT.
062400     EXIT.
062500*
062600 W060-CROSS-EDIT-RATES.
062700*
062800************************************************
062900*    BYPASS THE CROSS EDITS IF ERRORS EXIST    *
063000*    IN THE LOGO FIELDS OR RATE FIELDS         *
063100************************************************
063200*
063300     IF  RATE-ERRORS-EXIST
063400         GO TO W079-CER-EXIT.
063500*
063600*****************************************************************
063700*    RATE FIELD AMOUNT CAN NOT EXCEED 7 DIGITS IF THE METHOD IS
063800*    CIV, DCA, DCV, DIV, DCT, DCP, PCV, PIV, PCA, PCT, PCP, MIV
063900*    MCI, ICA, RCA, RCB, RCC, RCD, RCE, RCF, RCG, RCH, FPV, FPC
064000*****************************************************************
064100     PERFORM
064200         VARYING X-MR09-LOGO FROM 1 BY 1
064300         UNTIL   X-MR09-LOGO IS GREATER THAN 28
064400         EVALUATE TRUE
064500            WHEN   MMRTWS-RESV-FLAT-AMT
064600                     CONTINUE
064700            WHEN ( MMRTWS-VALID-METH-ON-AMOUNT AND
064800                       MR09-LOGO-RATE (X-MR09-LOGO)
064900                            IS GREATER THAN 9999999)
065000            SET SS08WS-ERROR-SW-YES TO TRUE
065100                MOVE DFHBMNBF
065200                             TO MR09-LOGO-RATE-A (X-MR09-LOGO)
065300                MOVE DFHBMASB
065400                             TO MR09-LOGO-RATE-LP-A (X-MR09-LOGO)
065500                                MR09-LOGO-RATE-RP-A (X-MR09-LOGO)
065600                MOVE SS08WS-CURSOR
065700                             TO MR09-LOGO-RATE-L (X-MR09-LOGO)
065800                IF MR09-ERROR-MESSAGE IS EQUAL TO SPACES
065900                                                   OR LOW-VALUES
066000                   MOVE 'ERROR RATE AMOUNT'
066100                             TO MR09-ERROR-MESSAGE
066200                END-IF
066300         END-EVALUATE
066400     END-PERFORM.
066500*************************
066600*    SET THE INDEXES    *
066700*************************
066800*
066900     SET X-MR09-LOGO             TO 1.
067000     SET X-MMRT-LOGO             TO WS-INDEX.
067100     SET X-MMRTIR-LOGO           TO 1.
067200     SET X-MMRT-EXCEPTION        TO 5.
067300*
067400 W062-CER-LOOP.
067500*
067600**************************************************************
067700*    RATE CROSS EDITS ARE AS FOLLOWS:                        *
067800*                                                            *
067900*      . IF THE LOGO FIELD IS THE INITIALIZER DEFAULT,       *
068000*        THE RATE FIELD MUST ALSO BE THE INITIALIZER         *
068100*        DEFAULT.                                            *
068200*      . IF THE LOGO EXCEPTION IS OF A OVERRIDE              *
068300*        PRIORITY, NO RATE CAN BE NEGATIVE.                  *
068400*      . IF THE LOGO EXCEPTION IS AN ADJUSTMENT,             *
068500*        NO RATE WHEN ADDED TO EACH PRIMARY RATE             *
068600*        (INDIVIDUALLY) CAN BE LESS THAN ZERO.               *
068700*                                                            *
068800*    IF THERE IS AN ERROR, THE LOGO AND RATE ARE             *
068900*    HIGHLIGHTED.                                            *
069000**************************************************************
069100*
069200     IF  MR09-LOGO     (X-MR09-LOGO) IS EQUAL TO
069300         MMRTIR-LOGO (X-MMRTIR-LOGO)
069400         IF  MR09-LOGO-RATE (X-MR09-LOGO) IS NOT EQUAL TO
069500             MMRTIR-LOGO-RATE (X-MMRTIR-LOGO)
069600             GO TO W068-CROSS-EDIT-RATE-ERROR.
069700*
069800     IF  MMRT-EXCEPTION-IS-OVERRIDE (X-MMRT-EXCEPTION)
069900         IF  MR09-LOGO-RATE-SIGN (X-MR09-LOGO) IS EQUAL TO '-'
070000             GO TO W068-CROSS-EDIT-RATE-ERROR
070100         ELSE
070200             GO TO W078-INCREMENT-INDEXES.
070300*
070400     IF  MR09-LOGO-RATE-SIGN (X-MR09-LOGO) IS NOT EQUAL TO '-'
070500         GO TO W078-INCREMENT-INDEXES.
070600*
070700************************************
070800*    SET THE PRIMARY RATE INDEX    *
070900************************************
071000*
071100     SET X-MMRT-PRIM             TO 1.
071200*
071300     MOVE MR09-LOGO-RATE (X-MR09-LOGO)
071400                                 TO WS-RATE.
071500     COMPUTE WS-RATE             = WS-RATE * -1.
071600*
071700 W064-CER-LOOP.
071800*
071900     COMPUTE WS-RATE-TOTAL =
072000         WS-RATE + MMRT-PRIM-RATE (X-MMRT-PRIM).
072100*
072200     IF  WS-RATE-TOTAL IS LESS THAN ZERO
072300         GO TO W068-CROSS-EDIT-RATE-ERROR.
072400*
072500 W066-INCREMENT-INDEXES.
072600*
072700     IF  X-MMRT-PRIM IS LESS THAN 10
072800     AND MMRT-PRIM-LIMIT (X-MMRT-PRIM)
072900                             IS NOT EQUAL TO 99999999999999999
073000         SET X-MMRT-PRIM         UP BY 1
073100         GO TO W064-CER-LOOP
073200     ELSE
073300         GO TO W078-INCREMENT-INDEXES.
073400*
073500 W068-CROSS-EDIT-RATE-ERROR.
073600*
073700**********************************************
073800*    BRIGHTEN AND FSET THE LOGO AND RATE     *
073900**********************************************
074000*
074100     MOVE 'Y'                    TO SS08WS-ERROR
074200                                    WS-RATE-ERROR-SW.
074300     MOVE SS08WS-CURSOR          TO MR09-LOGO-RATE-L
074400                                        (X-MR09-LOGO).
074500     MOVE DFHBMASB               TO MR09-LOGO-LP-A
074600                                        (X-MR09-LOGO)
074700                                    MR09-LOGO-RP-A
074800                                        (X-MR09-LOGO)
074900                                    MR09-LOGO-RATE-LP-A
075000                                        (X-MR09-LOGO)
075100                                    MR09-LOGO-RATE-RP-A
075200                                        (X-MR09-LOGO).
075300     MOVE DFHBMNBF               TO MR09-LOGO-RATE-A
075400                                        (X-MR09-LOGO).
075500     MOVE DFHBMUBF               TO MR09-LOGO-A
075600                                        (X-MR09-LOGO)
075700                                    MR09-LOGO-RATE-SIGN-A
075800                                        (X-MR09-LOGO).
075900*
076000 W078-INCREMENT-INDEXES.
076100*
076200     IF  X-MR09-LOGO IS LESS THAN 28
076300         SET X-MR09-LOGO         UP BY 1
076400         SET X-MMRTIR-LOGO       UP BY 1
076500         GO TO W062-CER-LOOP.
076600*
076700 W079-CER-EXIT.
076800     EXIT.
076900/
077000 X000-UPDATE-FIELDS SECTION.
077100*
077200 X020-UPDATE-LOGOS.
077300*
077400***********************************
077500*    SET THE BEGINNING INDEXES    *
077600***********************************
077700*
077800     SET X-MR09-LOGO             TO 1.
077900     SET X-MMRT-LOGO             TO WS-INDEX.
078000*
078100 X022-UD-LOOP.
078200*
078300     IF  MR09-LOGO-L       (X-MR09-LOGO) IS GREATER THAN ZERO
078400         IF  MR09-LOGO (X-MR09-LOGO) IS NOT EQUAL TO
078500             MMRT-LOGO (X-MMRT-LOGO)
078600             MOVE 'Y'            TO WS-UPDATE-SW
078700             IF  MBCA-PTI-FUNCTION-IS-MAINT
078800                 MOVE 0901       TO MML1-FIELD-CODE
078900                 SET MML1-FIELD-OCCURRENCE
079000                                 TO X-MMRT-LOGO
079100                 MOVE ZEROES     TO MML1-FIELD-OCCURRENCE-2
079200                 MOVE MML1WS-VL-03
079300                                 TO MML1-VARIABLE-LENGTH
079400                 MOVE MMRT-LOGO (X-MMRT-LOGO)
079500                                 TO MML1-VL03-B-DATA-X
079600                 MOVE MR09-LOGO          (X-MR09-LOGO)
079700                                 TO MMRT-LOGO
079800                                         (X-MMRT-LOGO)
079900                 MOVE MMRT-LOGO (X-MMRT-LOGO)
080000                                 TO MML1-VL03-A-DATA-X
080100                 PERFORM Y060-WRITE-LOG-RECORD
080200                                 THRU Y079-WLR-EXIT
080300             ELSE
080400                 MOVE MR09-LOGO          (X-MR09-LOGO)
080500                                 TO MMRT-LOGO
080600                                         (X-MMRT-LOGO).
080700*
080800 X038-INCREMENT-INDEXES.
080900*
081000     IF  X-MR09-LOGO IS LESS THAN 28
081100         SET X-MR09-LOGO         UP BY 1
081200         SET X-MMRT-LOGO         UP BY 1
081300         GO TO X022-UD-LOOP.
081400*
081500 X039-UD-EXIT.
081600     EXIT.
081700*
081800 X040-UPDATE-RATES.
081900*
082000***********************************
082100*    SET THE BEGINNING INDEXES    *
082200***********************************
082300*
082400     SET X-MR09-LOGO             TO 1.
082500     SET X-MMRT-LOGO             TO WS-INDEX.
082600*
082700 X042-UR-LOOP.
082800*
082900     IF  MR09-LOGO-RATE-L      (X-MR09-LOGO) IS GREATER THAN ZERO
083000     OR  MR09-LOGO-RATE-SIGN-L (X-MR09-LOGO)
083100                                    IS GREATER THAN ZERO
083200         MOVE MR09-LOGO-RATE (X-MR09-LOGO)
083300                                 TO WS-RATE
083400         IF  MR09-LOGO-RATE-SIGN (X-MR09-LOGO) IS EQUAL TO '-'
083500             COMPUTE WS-RATE = WS-RATE * -1.
083600*
083700     IF  MR09-LOGO-RATE-L      (X-MR09-LOGO) IS GREATER THAN ZERO
083800     OR  MR09-LOGO-RATE-SIGN-L (X-MR09-LOGO)
083900                                    IS GREATER THAN ZERO
084000         IF  WS-RATE IS NOT EQUAL TO
084100             MMRT-LOGO-RATE (X-MMRT-LOGO)
084200             MOVE 'Y'            TO WS-UPDATE-SW
084300             IF  MBCA-PTI-FUNCTION-IS-MAINT
084400                 MOVE 0902       TO MML1-FIELD-CODE
084500                 SET MML1-FIELD-OCCURRENCE
084600                                 TO X-MMRT-LOGO
084700                 MOVE ZEROES     TO MML1-FIELD-OCCURRENCE-2
084800                 MOVE MML1WS-VL-20
084900                                 TO MML1-VARIABLE-LENGTH
085000                 MOVE MMRT-LOGO-RATE (X-MMRT-LOGO)
085100                                 TO MML1-VL20-B-NBR-NO-DEC
085200                 MOVE WS-RATE    TO MMRT-LOGO-RATE
085300                                            (X-MMRT-LOGO)
085400                 MOVE MMRT-LOGO-RATE (X-MMRT-LOGO)
085500                                 TO MML1-VL20-A-NBR-NO-DEC
085600                 PERFORM Y060-WRITE-LOG-RECORD
085700                                 THRU Y079-WLR-EXIT
085800             ELSE
085900                 MOVE WS-RATE    TO MMRT-LOGO-RATE
086000                                         (X-MMRT-LOGO).
086100*
086200 X058-INCREMENT-INDEXES.
086300*
086400     IF  X-MR09-LOGO IS LESS THAN 28
086500         SET X-MR09-LOGO         UP BY 1
086600         SET X-MMRT-LOGO         UP BY 1
086700         GO TO X042-UR-LOOP.
086800*
086900 X059-UR-EXIT.
087000     EXIT.
087100/
087200 Y000-PERFORMED-ROUTINES SECTION.
087300*
087400 Y020-MOVE-LOGOS.
087500*
087600***********************************
087700*    SET THE BEGINNING INDEXES    *
087800***********************************
087900*
088000     SET X-MR09-LOGO             TO 1.
088100     SET X-MMRT-LOGO             TO WS-INDEX.
088200*
088300 Y022-MD-LOOP.
088400*
088500     MOVE MMRT-LOGO (X-MMRT-LOGO)
088600                                 TO MR09-LOGO (X-MR09-LOGO).
088700*
088800****************************************
088900*    DARKEN THE PARENS AND BRIGHTEN    *
089000*    THE DATA ELEMENT IF IN INQUIRY    *
089100****************************************
089200*
089300     IF  MBCA-PTI-FUNCTION-IS-INQUIRY
089400         MOVE DFHBMASB           TO MR09-LOGO-A
089500                                        (X-MR09-LOGO)
089600         MOVE DFHBMDAS           TO MR09-LOGO-LP-A
089700                                        (X-MR09-LOGO)
089800                                    MR09-LOGO-RP-A
089900                                        (X-MR09-LOGO).
090000*
090100 Y038-INCREMENT-INDEXES.
090200*
090300     IF  X-MR09-LOGO IS LESS THAN 28
090400         SET X-MR09-LOGO         UP BY 1
090500         SET X-MMRT-LOGO         UP BY 1
090600         GO TO Y022-MD-LOOP.
090700*
090800 Y039-MD-EXIT.
090900     EXIT.
091000*
091100 Y040-MOVE-RATES.
091200*
091300***********************************
091400*    SET THE BEGINNING INDEXES    *
091500***********************************
091600*
091700     SET X-MR09-LOGO             TO 1.
091800     SET X-MMRT-LOGO             TO WS-INDEX.
091900*
092000 Y042-MR-LOOP.
092100*
092200     MOVE MMRT-LOGO-RATE (X-MMRT-LOGO)
092300                                 TO MR09-LOGO-RATE
092400                                        (X-MR09-LOGO).
092500     IF  MMRT-LOGO-RATE (X-MMRT-LOGO) IS LESS THAN ZERO
092600         MOVE '-'                TO MR09-LOGO-RATE-SIGN
092700                                        (X-MR09-LOGO)
092800     ELSE
092900         MOVE '+'                TO MR09-LOGO-RATE-SIGN
093000                                        (X-MR09-LOGO).
093100*
093200*****************************************
093300*    DARKEN THE PARENS AND BRIGHTEN     *
093400*    THE DATA ELEMENTS IF IN INQUIRY    *
093500*****************************************
093600*
093700     IF  MBCA-PTI-FUNCTION-IS-INQUIRY
093800         MOVE DFHBMASB           TO MR09-LOGO-RATE-A
093900                                        (X-MR09-LOGO)
094000                                    MR09-LOGO-RATE-SIGN-A
094100                                        (X-MR09-LOGO)
094200         MOVE DFHBMDAS           TO MR09-LOGO-RATE-LP-A
094300                                        (X-MR09-LOGO)
094400                                    MR09-LOGO-RATE-RP-A
094500                                        (X-MR09-LOGO).
094600*
094700 Y058-INCREMENT-INDEXES.
094800*
094900     IF  X-MR09-LOGO IS LESS THAN 28
095000         SET X-MR09-LOGO         UP BY 1
095100         SET X-MMRT-LOGO         UP BY 1
095200         GO TO Y042-MR-LOOP.
095300*
095400 Y059-MR-EXIT.
095500     EXIT.
095600*
095700 Y060-WRITE-LOG-RECORD.
095800*
095900     MOVE 'FC08'                 TO MBCA-PROGRAM-LOCATION.
096000     SET MBIORO-WRITE            TO TRUE.
096100     PERFORM MML1AO-ACCESS       THRU MML1AO-ACCESS-EXIT.
096200     MOVE SPACES                 TO MML1-VARIABLE-AREA.
096300*
096400 Y079-WLR-EXIT.
096500     EXIT.
096600/
096700 Z000-COPIED-ROUTINES SECTION.
096800*
096900/    NEW ROUTINE FOR JULIAN TO GREGORIAN CONVERSION
097000     COPY SS26PD.
097100*
097200/    ROUTINE TO NUMERICALLY EDIT TIME
097300     COPY SS27PD.
097400*
097500**********************************
097600*    JUL TO GREG DATE ROUTINE    *
097700**********************************
097800*
097900     COPY SS08PD.
098000/    ROUTINE TO MOVE COMMAREA VARIABLES TO
098100*                    SS08-FORMATTED-MSG VARIABLE.
098200     COPY MB06PD.
098300/
098400*********************************
098500*    LINE 24 PF KEYS ROUTINE    *
098600*********************************
098700*
098800     COPY SS15PD.
098900/
099000****************************************************
099100*    DISCOUNT RATE TABLE RECORD ACCESS ROUTINES    *
099200****************************************************
099300*
099400     COPY MMRTAO.
099500/
099600*****************************************
099700*    LOG FILE RECORD ACCESS ROUTINES    *
099800*****************************************
099900*
100000     COPY MML1AO.
100100/
100200*****************************
100300*    ONLINE MAP ROUTINES    *
100400*****************************
100500*
100600     COPY MB60PD REPLACING 'MBMAPXX' BY 'MBMR09 '
100700                           MBMAPXXI BY MBMR09I
100800                           MBMAPXXO BY MBMR09O.
100900/
101000***************************
101100*    ONLINE PROCEDURES    *
101200***************************
101300*
101400     COPY MB70PD.
101500/
101600     COPY SMFTPXO.
