000100 IDENTIFICATION DIVISION.
000200 PROGRAM-ID. MBOMS06.
000201*       RELEASE DATE=08/24/01.        REVISION LEVEL=08.06      *
000202*****************************************************************
000203*WARNING.  THIS COMPUTER PROGRAM IS PROTECTED BY COPYRIGHT LAW  *
000204*AND INTERNATIONAL TREATIES.  UNAUTHORIZED REPRODUCTION OR      *
000205*DISTRIBUTION OF THIS PROGRAM, OR ANY PORTION OF IT, MAY RESULT *
000206*IN SEVERE CIVIL AND CRIMINAL PENATLIES, AND WILL BE PROSECUTED *
000207*TO THE MAXIMUM EXTENT POSSIBLE UNDER THE LAW.                  *
000208*COPYRIGHT 1999 PAYSYS INTERNATIONAL, INC.  ALL RIGHTS RESERVED.*
000209*****************************************************************
000300*****************************************************************
000400*                                                               *
000500*   V - PLUS  M E R C H A N T   B A N K C A R D   S Y S T E M   *
000600*                                                               *
000700*      MBOMS06 - STORE MASTER RECORD ADD/MAINT/INQ              *
000800*                SCREEN 06                                      *
000900*                                                               *
001000*              1. TRANSIDS                                      *
001100*                 A. MBAS                                       *
001200*                 B. MBMS                                       *
001300*                 C. MBQS                                       *
001400*              2. MAPS USED -                                   *
001500*                 A. MBMS06 (SCREEN 06)                         *
001600*              3. FILES USED -                                  *
001700*                 A. MMSM (STORE MASTER FILE)                   *
001800*                 B. MMFS (FIELD SECURITY FILE)                 *
001900*                 C. MML1 (LOG FILE)                            *
002000*                                                               *
002100*****************************************************************
002200*
002300 ENVIRONMENT DIVISION.
002400*
002500 DATA DIVISION.
002600*
002700 WORKING-STORAGE SECTION.
002800*
002900 01  FILLER                  PIC  X(12)      VALUE '** WS-BEG **'.
003000*
003100 01  FILLER                  PIC  X(14)      VALUE
003200     'MISCELLANEOUS:'.
003300*
003400 01  WS-MISCELLANEOUS.
003500     03  WS-FIELD-POSITION   PIC  9(03)      VALUE ZEROES.
003600     03  WS-INDEX-X.
003700         05  WS-INDEX        PIC  9(04)      VALUE ZEROS.
003800*
003900 01  FILLER                  PIC  X(17)      VALUE
004000     'PROGRAM SWITCHES:'.
004100*
004200 01  WS-PROGRAM-SWITCHES.
004300     03  WS-USER-DATA-ERROR-SW
004400                             PIC  X(01)      VALUE 'N'.
004500         88  USER-DATA-ERRORS-EXIST          VALUE 'Y'.
004600         88  NO-USER-DATA-ERRORS-EXIST       VALUE 'N'.
004700     03  WS-USER-DATE-ERROR-SW
004800                             PIC  X(01)      VALUE 'N'.
004900         88  USER-DATE-ERRORS-EXIST          VALUE 'Y'.
005000         88  NO-USER-DATE-ERRORS-EXIST       VALUE 'N'.
005100     03  WS-USER-AMT-ERROR-SW
005200                             PIC  X(01)      VALUE 'N'.
005300         88  USER-AMT-ERRORS-EXIST           VALUE 'Y'.
005400         88  NO-USER-AMT-ERRORS-EXIST        VALUE 'N'.
005500     03  WS-UPDATE-SW        PIC  X(01)      VALUE 'N'.
005600         88  WS-UPDATE-SW-YES                VALUE 'Y'.
005700         88  WS-UPDATE-SW-NO                 VALUE 'N'.
005800     03  TS-QUEUE-NAME.
005900         05  TS-QN-TERMID    PIC  X(04)      VALUE SPACES.
006000         05  TS-QN-TRANID    PIC  X(04)      VALUE 'MBUI'.
006100/
006200 01  FILLER                  PIC  X(29)      VALUE
006300     'I/O REQUEST BLOCK WORK AREAS:'.
006400*
006500     COPY MBIOWS.
006600/
006700 01  FILLER                  PIC  X(18)      VALUE
006800     'I/O REQUEST BLOCK:'.
006900*
007000     COPY MBIORO.
007100/
007200 01  FILLER                  PIC  X(25)      VALUE
007300     'LOG RECORD REQUEST BLOCK:'.
007400*
007500     COPY MML1WS REPLACING ==:MML1:== BY ==MML1==.
007600/
007700 01  FILLER                  PIC  X(29)      VALUE
007800     'STORE MASTER FIELDS TABLE:'.
007900*
008000     COPY MMSMTB.
008100/
008200 01  FILLER                  PIC  X(29)      VALUE
008300     'STORE INIT RECORD         '.
008400*
008500     COPY MMSMIR.
008600/
008700 01  FILLER                  PIC  X(20)      VALUE
008800     'CCS DATE WORK AREAS:'.
008900*
009000     COPY SS01WS.
009100/
009200 01  FILLER                  PIC  X(15)      VALUE
009300     'CCS WORK AREAS:'.
009400*
009500     COPY SS08WS.
009600/
009700     COPY SS00WS.
009800/
009900     COPY SMFTWS.
010000/
010100     COPY SMPTRL REPLACING ==:SMPT:== BY ==SMPT==.
010200/
010300     COPY MB61LK.
010400/
010500 01  FILLER                  PIC  X(12)      VALUE '** WS-END **'.
010600/
010700 LINKAGE SECTION.
010800*
010900 01  DFHCOMMAREA.
011000*
011100     COPY MB60WS.
011200/
011300*****************************
011400*    STORE MASTER MAP       *
011500*****************************
011600*
011700     COPY MBMS06.
011800/
011900******************************************
012000*    STORE MASTER MAP REDEFINITION       *
012100******************************************
012200*
012300     COPY MBMS06R.
012400/
012500****************************************
012600*    STORE MASTER     RECORD LAYOUT    *
012700****************************************
012800*
012900     COPY MMSMRL.
013000/
013100**************************************
013200*    FIELD SECURITY RECORD LAYOUT    *
013300**************************************
013400*
013500     COPY MMFSRL.
013600/
013700***************************
013800*    LOG RECORD LAYOUT    *
013900***************************
014000*
014100     COPY MML1RL REPLACING ==:MML1:== BY ==MML1==.
014200/
014300***************************************
014400*    USER INPUT TEMP STORAGE RECORD   *
014500***************************************
014600*
014700     COPY MBUITS.
014800/
014900 PROCEDURE DIVISION.
015000*
015100 A000-HOUSEKEEPING SECTION.
015200*
015300 A020-INIT.
015400*
015500     MOVE 'PC01'                 TO MBCA-PROGRAM-LOCATION.
015600     PERFORM MB70PD-ON-LINE-HOUSEKEEPING
015700                                 THRU MB70PD-OLH-EXIT.
015800*
015900     IF  MBCA-MBUI-UI-YES
016000         NEXT SENTENCE
016100     ELSE
016200         SET MBCA-MBUI-UI-NO     TO TRUE.
016300*
016400     MOVE MBCA-TERMINAL-ID       TO TS-QN-TERMID.
016500*
016600     IF  MBCA-RECEIVE-SCREEN
016700         GO TO C000-RECEIVE-SCREEN.
016800/
016900 B000-SEND-SCREEN SECTION.
017000*
017100*********************************************
017200*    GET CICS STORAGE NEEDED FOR THE MAP    *
017300*********************************************
017400*
017500     MOVE 'SC01'                 TO MBCA-PROGRAM-LOCATION.
017600     PERFORM MB60PD-GETMAIN-FOR-MAP
017700                                 THRU MB60PD-GFM-EXIT.
017800*
017900*******************************************
018000*    INITIALIZE THE STANDARD MAP LINES    *
018100*******************************************
018200*
018300     PERFORM MB60PD-INIT-STD-MAP-LINES
018400                                 THRU MB60PD-ISML-EXIT.
018500*
018600*****************************************
018700*    READ THE STORE MASTER RECORD       *
018800*    FOR SUBSEQUENT DISPLAY             *
018900*****************************************
019000*
019100     MOVE 'FC01'                 TO MBCA-PROGRAM-LOCATION.
019200     PERFORM Y900-READ-MMSM      THRU Y909-READ-MMSM-EXIT.
019300*
019400*********************************************
019500*    MOVE THE PRIMARY NAME TO THE SCREEN    *
019600*********************************************
019700*
019800     MOVE MMSM-NA-LINE (1 1)     TO MS06-STORE-NAME.
019900*
020000****************************************
020100*    READ THE FIELD SECURITY RECORD    *
020200****************************************
020300*
020400     MOVE 'FC02'                 TO MBCA-PROGRAM-LOCATION.
020500     PERFORM Y910-READ-MMFS      THRU Y919-READ-MMFS-EXIT.
020600*
020700 B020-MOVE-FIELDS-TO-SCREEN.
020800*
020900*****************************************
021000*    MOVE THE STORE MASTER FIELDS       *
021100*    FROM THE RECORD TO THE SCREEN      *
021200*****************************************
021300*
021400     PERFORM Y010-MOVE-USER-DATA-TITLES
021500                                 THRU Y019-MUDT-EXIT.
021600*
021700     PERFORM Y020-MOVE-USER-DATA THRU Y029-MUD-EXIT.
021800*
021900     PERFORM Y030-MOVE-USER-DATE-TITLES
022000                                 THRU Y039-MUDT-EXIT.
022100*
022200     PERFORM Y040-MOVE-USER-DATES
022300                                 THRU Y049-MUD-EXIT.
022400*
022500     PERFORM Y050-MOVE-USER-AMT-TITLES
022600                                 THRU Y059-MUAT-EXIT.
022700*
022800     PERFORM Y060-MOVE-USER-AMTS THRU Y069-MUA-EXIT.
022900*
023000******************************************
023100*    SET THE CURSOR AND SCREEN NUMBER    *
023200******************************************
023300*
023400     IF  MBCA-PTI-FUNCTION-IS-INQUIRY
023500         MOVE SS08WS-CURSOR      TO MS06-ALT-TRANID-L
023600     ELSE
023700         PERFORM Y800-SET-CURSOR THRU Y809-SC-EXIT.
023800*
023900     COMPUTE MBCA-SCREEN-NBR     =  MBCA-SCREEN-NBR - 50.
024000*
024100***********************************************************
024200*    SET THE CURRENCY CODE, CURRENCY NOD
024300*            PER ITEM NOD, PERCENT NOD.
024400***********************************************************
024500     IF MS06-ERROR-MESSAGE IS EQUAL TO SPACES OR LOW-VALUES
024600        PERFORM MB06PD-FORMAT-MESSAGE-LINE
024700                                 THRU MB06PD-FML-EXIT
024800        MOVE SS08WS-FORMATTED-MSG   TO MS06-ERROR-MESSAGE
024900     END-IF.
025000*
025100**********************
025200*    SEND THE MAP    *
025300**********************
025400*
025500     MOVE 'BM01'                 TO MBCA-PROGRAM-LOCATION.
025600     PERFORM MB60PD-SEND-MAP-WITH-ERASE
025700                                 THRU MB60PD-SMWE-EXIT.
025800*
025900************************
026000*    RETURN TO CICS    *
026100************************
026200*
026300     MOVE 'PC02'                 TO MBCA-PROGRAM-LOCATION.
026400     PERFORM MB70PD-RETURN-TRANS-ID
026500                                 THRU MB70PD-RTI-EXIT.
026600/
026700 C000-RECEIVE-SCREEN SECTION.
026800*
026900******************************************
027000*    THIS SECTION RECEIVES THE SCREEN    *
027100******************************************
027200*
027300     IF  MBCA-MBUI-UI-YES
027400*
027500****************************************************************
027600*    ACQUIRE MAIN STORAGE FOR TEMP STORAGE RECORD              *
027700****************************************************************
027800*
027900         MOVE 'TS01'             TO MBCA-PROGRAM-LOCATION
028000         EXEC CICS GETMAIN
028100                   FLENGTH (LENGTH  OF MBUITS-RECORD)
028200
028300                   SET     (ADDRESS OF MBUITS-RECORD)
028400
028500              END-EXEC
028600*
028700***********************************************
028800*    READ THE TEMP STORAGE RECORD             *
028900***********************************************
029000*
029100         MOVE 'TS02'             TO MBCA-PROGRAM-LOCATION
029200*
029300         EXEC CICS READQ TS
029400                   QUEUE   (TS-QUEUE-NAME)
029500                   INTO    (MBUITS-RECORD)
029600                   LENGTH  (LENGTH  OF MBUITS-RECORD)
029700                   ITEM    (1)
029800              END-EXEC
029900*
030000***********************************************
030100*    DELETE THE TEMP STORAGE RECORD           *
030200***********************************************
030300*
030400         MOVE 'TS03'             TO MBCA-PROGRAM-LOCATION
030500*
030600         EXEC CICS IGNORE CONDITION
030700                   QIDERR
030800              END-EXEC
030900*
031000         EXEC CICS DELETEQ TS
031100                   QUEUE  (TS-QUEUE-NAME)
031200              END-EXEC
031300         MOVE 'SC02'             TO MBCA-PROGRAM-LOCATION
031400         PERFORM MB60PD-GETMAIN-FOR-MAP
031500                                 THRU MB60PD-GFM-EXIT
031600         MOVE MBUITS-VAR-DATA    TO MBMS06I
031700     ELSE
031800         MOVE 'BM02'             TO MBCA-PROGRAM-LOCATION
031900         PERFORM MB60PD-RECEIVE-MAP
032000                                 THRU MB60PD-RM-EXIT.
032100*
032200**************************************************************
032300*    CHECK FOR ANOTHER TRANSACTION ID ENTERED BY THE USER    *
032400**************************************************************
032500*
032600     MOVE 'PC03'                 TO MBCA-PROGRAM-LOCATION.
032700     PERFORM MB60PD-NEW-TRANS-ROUTINE
032800                                 THRU MB60PD-NTR-EXIT.
032900*
033000*****************************************
033100*    READ THE STORE MASTER RECORD       *
033200*****************************************
033300*
033400     IF  MBCA-PTI-FUNCTION-IS-ADD
033500     AND MBCA-MBUI-UI-YES
033600     AND MBCA-MBUI-UI-UPDATE-NO
033700         MOVE 'SC03'             TO MBCA-PROGRAM-LOCATION
033800         SET MBIORO-GETMAIN      TO TRUE
033900         PERFORM MMSMAO-ACCESS   THRU MMSMAO-ACCESS-EXIT
034000         MOVE MMSMIR-RECORD      TO MMSM-RECORD
034100     ELSE
034200         MOVE 'FC03'             TO MBCA-PROGRAM-LOCATION
034300         MOVE SS08WS-CICS-FC-NOTFND TO MBIORO-TEMP-STATUS-1
034400         PERFORM Y900-READ-MMSM  THRU Y909-READ-MMSM-EXIT
034500         IF  SS08WS-RC-FC-NOTFND
034600         AND MBCA-MBUI-UI-YES
034700             MOVE 'MBUI'         TO MBCA-TRANS-ID
034800                                    MBCA-PREV-TRANS-ID
034900             MOVE 01             TO MBCA-SCREEN-NBR
035000             MOVE 'STR'          TO MS06-FILLER
035100             SET MBCA-MBUI-ERROR-YES
035200                                 TO TRUE
035300             GO TO F000-SETUP-COMMAREA.
035400*
035500     IF (MBCA-PTI-FUNCTION-IS-MAINT
035600     AND MBCA-MBUI-UI-YES
035700     AND (MMSM-REC-PURGED
035800       OR MMSM-REC-INCOMPLETE))
035900     OR
036000        (MBCA-PTI-FUNCTION-IS-ADD
036100     AND MBCA-MBUI-UI-YES
036200     AND MMSM-REC-PURGED)
036300         MOVE 'MBUI'             TO MBCA-TRANS-ID
036400                                    MBCA-PREV-TRANS-ID
036500         MOVE 01                 TO MBCA-SCREEN-NBR
036600         MOVE 'STR'              TO MS06-FILLER
036700         SET MBCA-MBUI-ERROR-YES
036800                                 TO TRUE
036900         GO TO F000-SETUP-COMMAREA.
037000*
037100****************************************************
037200*    BYPASS ALL SCREEN EDITS IF THIS IS INQIURY    *
037300****************************************************
037400*
037500     IF  MBCA-PTI-FUNCTION-IS-INQUIRY
037600         GO TO F000-SETUP-COMMAREA.
037700*
037800*********************************************
037900*    MOVE THE PRIMARY NAME TO THE SCREEN    *
038000*********************************************
038100*
038200     MOVE MMSM-NA-LINE (1 1)     TO MS06-STORE-NAME.
038300*
038400****************************************
038500*    READ THE FIELD SECURITY RECORD    *
038600****************************************
038700*
038800     MOVE 'FC04'                 TO MBCA-PROGRAM-LOCATION.
038900     PERFORM Y910-READ-MMFS      THRU Y919-READ-MMFS-EXIT.
039000*
039100 C020-FIELD-EDITS.
039200*
039300*********************
039400*    FIELD EDITS    *
039500*********************
039600*
039700     PERFORM W010-EDIT-USER-DATA-TITLES
039800                                 THRU W019-EUDT-EXIT.
039900*
040000     PERFORM W020-EDIT-USER-DATA THRU W029-EUD-EXIT.
040100*
040200     PERFORM W030-EDIT-USER-DATE-TITLES
040300                                 THRU W039-EUDT-EXIT.
040400*
040500     PERFORM W040-EDIT-USER-DATES
040600                                 THRU W049-EUD-EXIT.
040700*
040800     PERFORM W050-EDIT-USER-AMT-TITLES
040900                                 THRU W059-EUAT-EXIT.
041000*
041100     PERFORM W060-EDIT-USER-AMTS THRU W069-EUA-EXIT.
041200*
041300 C040-CROSS-EDITS.
041400*
041500*********************
041600*    CROSS EDITS    *
041700*********************
041800*
041900     PERFORM W510-USER-DATA-CROSS-EDITS
042000                                 THRU W519-UDCE-EXIT.
042100*
042200     PERFORM W520-USER-DATE-CROSS-EDITS
042300                                 THRU W529-UDCE-EXIT.
042400*
042500     PERFORM W530-USER-AMT-CROSS-EDITS
042600                                 THRU W539-UACE-EXIT.
042700/
042800 D000-RETURN-ERRORS SECTION.
042900*
043000     IF  SS08WS-ERROR-SW-NO
043100         GO TO E000-UPDATE-FILE.
043200*
043300     IF  MBCA-MBUI-UI-YES
043400         MOVE 'MBUI'             TO MBCA-TRANS-ID
043500                                    MBCA-PREV-TRANS-ID
043600         MOVE 01                 TO MBCA-SCREEN-NBR
043700         SET MBCA-MBUI-ERROR-YES TO TRUE
043800         GO TO F000-SETUP-COMMAREA.
043900*
044000***************************************************************
044100*    INITIALIZE THE STANDARD MAP LINES.  IN AN ERROR          *
044200*    CONDITION, THIS ROUTINE IS PERFORMED PRIMARILY           *
044300*    TO UPDATE THE DATE AND TIME ON THE SCREEN.               *
044400***************************************************************
044500*
044600     PERFORM MB60PD-INIT-STD-MAP-LINES
044700                                 THRU MB60PD-ISML-EXIT.
044800*
044900***********************************************************
045000*    SET THE CURRENCY CODE, CURRENCY NOD
045100*            PER ITEM NOD, PERCENT NOD.
045200***********************************************************
045300     IF MS06-ERROR-MESSAGE IS EQUAL TO SPACES OR LOW-VALUES
045400        PERFORM MB06PD-FORMAT-MESSAGE-LINE
045500                                 THRU MB06PD-FML-EXIT
045600        MOVE SS08WS-FORMATTED-MSG   TO MS06-ERROR-MESSAGE
045700     END-IF.
045800*
045900**********************
046000*    SEND THE MAP    *
046100**********************
046200*
046300     MOVE 'BM03'                 TO MBCA-PROGRAM-LOCATION.
046400     PERFORM MB60PD-SEND-MAP-DATA-ONLY
046500                                 THRU MB60PD-SMDO-EXIT.
046600*
046700************************
046800*    RETURN TO CICS    *
046900************************
047000*
047100     MOVE 'PC04'                 TO MBCA-PROGRAM-LOCATION.
047200     PERFORM MB70PD-RETURN-TRANS-ID
047300                                 THRU MB70PD-RTI-EXIT.
047400/
047500 E000-UPDATE-FILE SECTION.
047600*
047700     IF  MBCA-MBUI-UI-YES
047800         SET MBCA-MBUI-ERROR-NO  TO TRUE.
047900*
048000     IF  MBCA-MBUI-UI-YES
048100     AND MBCA-MBUI-UI-UPDATE-NO
048200         GO TO F000-SETUP-COMMAREA.
048300*
048400****************************************************
048500*    READ THE STORE MASTER RECORD FOR UPDATE       *
048600****************************************************
048700*
048800     MOVE 'FC05'                 TO MBCA-PROGRAM-LOCATION.
048900     SET MBIORO-READ-RANDOM-UPDATE
049000                                 TO TRUE.
049100     PERFORM MMSMAO-ACCESS       THRU MMSMAO-ACCESS-EXIT.
049200*
049300*************************************
049400*    OBTAIN STORAGE FOR LOG FILE    *
049500*    RECORD IF DOING MAINTENANCE    *
049600*************************************
049700*
049800     IF  MBCA-PTI-FUNCTION-IS-ADD
049900         GO TO E020-UPDATE-FIELDS.
050000*
050100     MOVE 'SC04'                 TO MBCA-PROGRAM-LOCATION.
050200     SET MBIORO-GETMAIN          TO TRUE.
050300     PERFORM MML1AO-ACCESS       THRU MML1AO-ACCESS-EXIT.
050400*
050500*************************************************
050600*    SET UP THE COMMON PORTION OF THE RECORD    *
050700*************************************************
050800*
050900     MOVE 'SM'                   TO MML1-FILE-CODE.
051000     MOVE MBCA-MERCHANT-ORG      TO MML1-MMSM-ORG.
051100     MOVE MBCA-STORE             TO MML1-MMSM-STORE.
051200     MOVE MBCA-SIGNON-NAME       TO MML1-SIGNON-NAME.
051300     MOVE MBCA-TERMINAL-ID       TO MML1-TERMINAL-ID.
051400     MOVE ZEROS                  TO MML1-SOURCE-CODE.
051500     MOVE MBCA-FIELD-SECURITY    TO MML1-FIELD-SECURITY.
051600*
051700 E020-UPDATE-FIELDS.
051800*
051900     PERFORM X010-UPDATE-USER-DATA-TITLES
052000                                 THRU X019-UUDT-EXIT.
052100*
052200     PERFORM X020-UPDATE-USER-DATA
052300                                 THRU X029-UUD-EXIT.
052400*
052500     PERFORM X030-UPDATE-USER-DATE-TITLES
052600                                 THRU X039-UUDT-EXIT.
052700*
052800     PERFORM X040-UPDATE-USER-DATES
052900                                 THRU X049-UUD-EXIT.
053000*
053100     PERFORM X050-UPDATE-USER-AMT-TITLES
053200                                 THRU X059-UUAT-EXIT.
053300*
053400     PERFORM X060-UPDATE-USER-AMTS
053500                                 THRU X069-UUA-EXIT.
053600*
053700 E040-UPDATE-MMSM.
053800*
053900     IF  MBCA-PTI-FUNCTION-IS-ADD
054000         MOVE MBCA-SCREEN-NBR    TO MMSM-ONLINE-STATUS
054100         MOVE MBCA-START-DATE    TO MMSM-LAST-MAINT-DATE
054200         MOVE MBCA-OPERATOR-ID   TO MMSM-LAST-MAINT-OPER
054300         SET WS-UPDATE-SW-YES    TO TRUE.
054400*
054500**************************************************************
054600*    WRITE A LOG RECORD TO SHOW THAT THE LAST MAINT DATE     *
054700*    AND OPERATOR HAS BEEN UPDATED IF FIELDS WERE CHANGED    *
054800*    ON THE SCREEN                                           *
054900**************************************************************
055000*
055100     IF  MBCA-PTI-FUNCTION-IS-MAINT
055200     AND WS-UPDATE-SW-YES
055300         MOVE 0198               TO MML1-FIELD-CODE
055400         MOVE ZEROES             TO MML1-FIELD-OCCURRENCE
055500                                    MML1-FIELD-OCCURRENCE-2
055600         MOVE MML1WS-VL-03       TO MML1-VARIABLE-LENGTH
055700         MOVE MMSM-LAST-MAINT-OPER
055800                                 TO MML1-VL03-B-DATA-X
055900         MOVE MBCA-OPERATOR-ID   TO MMSM-LAST-MAINT-OPER
056000         MOVE MMSM-LAST-MAINT-OPER
056100                                 TO MML1-VL03-A-DATA-X
056200         MOVE 'FC06'             TO MBCA-PROGRAM-LOCATION
056300         PERFORM Y920-WRITE-LOG-RECORD
056400                                 THRU Y929-WLR-EXIT
056500         MOVE 0199               TO MML1-FIELD-CODE
056600         MOVE MML1WS-VL-07       TO MML1-VARIABLE-LENGTH
056700         MOVE MMSM-LAST-MAINT-DATE
056800                                 TO MML1-VL07-B-DATA-9
056900         MOVE MBCA-START-DATE    TO MMSM-LAST-MAINT-DATE
057000         MOVE MMSM-LAST-MAINT-DATE
057100                                 TO MML1-VL07-A-DATA-9
057200         MOVE 'FC07'             TO MBCA-PROGRAM-LOCATION
057300         PERFORM Y920-WRITE-LOG-RECORD
057400                                 THRU Y929-WLR-EXIT.
057500*
057600****************************************************
057700*    REWRITE THE STORE MASTER RECORD IF            *
057800*    FIELDS HAVE BEEN CHANGED ON THE SCREEN, OR    *
057900*    UNLOCK IT IF THEY HAVE NOT                    *
058000****************************************************
058100*
058200     IF  WS-UPDATE-SW-YES
058300         MOVE 'FC08'             TO MBCA-PROGRAM-LOCATION
058400         SET MBIORO-REWRITE      TO TRUE
058500         PERFORM MMSMAO-ACCESS   THRU MMSMAO-ACCESS-EXIT
058600     ELSE
058700         MOVE 'FC09'             TO MBCA-PROGRAM-LOCATION
058800         SET MBIORO-UNLOCK       TO TRUE
058900         PERFORM MMSMAO-ACCESS   THRU MMSMAO-ACCESS-EXIT.
059000/
059100 F000-SETUP-COMMAREA SECTION.
059200*
059300***************************************************************
059400*  SET UP COMMAREA FIELDS AND TRANSFER TO THE NEXT PROGRAM    *
059500***************************************************************
059600*
059700     MOVE MBCA-EIBAID            TO SS08WS-EIBAID.
059800*
059900     PERFORM MB60PD-EDIT-PAGE-NBR
060000                                 THRU MB60PD-EPN-EXIT.
060100*
060200     IF  SS08WS-VALID-PF-KEY
060300     OR  SS08WS-EIBAID-VALID-PF-KEY
060400         SET MBCA-INITIAL-SCREEN-NBR
060500                                 TO TRUE.
060600*
060700     IF  SS08WS-VALID-PF5
060800     OR  SS08WS-EIBAID-VALID-PF5
060900         MOVE MMSM-MERCHANT-ID   TO MBCA-MERCHANT.
061000*
061100     IF  MBCA-MBUI-UI-YES
061200         MOVE 'MBUI'             TO MBCA-TRANS-ID
061300                                    MBCA-PREV-TRANS-ID
061400         MOVE 01                 TO MBCA-SCREEN-NBR
061500         MOVE MBMS06I            TO MBUITS-VAR-DATA
061600         MOVE LENGTH OF MBMS06I  TO MBUITS-VAR-LENGTH
061700         MOVE 'TS10'             TO MBCA-PROGRAM-LOCATION
061800         EXEC CICS WRITEQ TS
061900                   QUEUE   (TS-QUEUE-NAME)
062000                   FROM    (MBUITS-RECORD)
062100                   LENGTH  (LENGTH  OF MBUITS-RECORD)
062200
062300              END-EXEC.
062400*
062500     MOVE 'PC05'                 TO MBCA-PROGRAM-LOCATION.
062600     PERFORM MB70PD-XCTL-TO-MBOXCTL
062700                                 THRU MB70PD-XTM-EXIT.
062800/
062900 W000-FIELD-EDITS SECTION.
063000*
063100*********************************************************
063200*    EACH FIELD IS CODED IN A SEPERATE ROUTINE, AND     *
063300*    IN A LIKE MANNER.  THE COMMENTS FOR THE FLOW OF    *
063400*    THE EDIT ROUTINES CAN BE FOUND IN ROUTINES         *
063500*    'W010-EDIT-USER-DATA-TITLES' THRU                  *
063600*    'W019-EUDT-EXIT'.  EACH ROUTINE MAY CONTAIN        *
063700*    COMMENTS, BUT THEY ARE UNIQUE TO THAT ROUTINE.     *
063800*********************************************************
063900*
064000 W010-EDIT-USER-DATA-TITLES.
064100*
064200     MOVE MMSMTB-USER-DATA-1-DESC (1:4)
064300                                 TO WS-INDEX-X.
064400     SET  X-MMFS-STORE           TO WS-INDEX.
064500     SET  X-MMSM-USER-DATA       TO 1.
064600     SET  X-MS06-USER-DATA       TO 1.
064700*
064800 W011-EUDT-LOOP.
064900*
065000*****************************************************
065100*    SET THE ATTRIBUTES TO WHAT THEY WOULD BE IF    *
065200*    SOMETHING WERE KEYED AND THE EDITS PASSED.     *
065300*****************************************************
065400*
065500     MOVE DFHBMDAS               TO MS06-USER-DATA-TITLE-LP-A
065600                                    (X-MS06-USER-DATA)
065700                                    MS06-USER-DATA-TITLE-RP-A
065800                                    (X-MS06-USER-DATA).
065900     MOVE DFHBMASK               TO MS06-USER-DATA-TITLE-A
066000                                    (X-MS06-USER-DATA).
066100*
066200************************************************************
066300*    THE SECURITY ROUTINE IS PERFORMED TO SET THE FIELD    *
066400*    ATTRIBUTES ACCORDING TO THE SECURITY PROFILE.  IT     *
066500*    WAS ALSO PERFORMED IN THE B000-SEND-SCREEN SECTION    *
066600*    OF THIS PROGRAM.  IF THIS FIELD IS (OR WAS)           *
066700*    PROTECTED AS A RESULT OF THIS ROUTINE, THE LENGTH     *
066800*    RETURNED WILL BE ZERO.                                *
066900************************************************************
067000*
067100     PERFORM Y015-USER-DATA-TITLE-SECURITY
067200                                 THRU Y016-UDTS-EXIT.
067300*
067400************************
067500*    EDIT THE FIELD    *
067600************************
067700*
067800     IF  MS06-USER-DATA-TITLE-L (X-MS06-USER-DATA)
067900                                 IS EQUAL TO ZERO
068000         MOVE MMSM-USER-DATA-TITLE (X-MMSM-USER-DATA)
068100                                 TO MS06-USER-DATA-TITLE
068200                                    (X-MS06-USER-DATA).
068300*
068400     IF  MS06-USER-DATA-TITLE-L (X-MS06-USER-DATA)
068500                                 IS GREATER THAN ZERO
068600         IF  MBCA-PTI-FUNCTION-IS-ADD
068700         AND MMFS-ST-REQUIRED (X-MMFS-STORE)
068800             MOVE DFHBMABF       TO MS06-USER-DATA-TITLE-A
068900                                    (X-MS06-USER-DATA)
069000             GO TO W018-INCREMENT-INDEXES
069100         ELSE
069200             MOVE DFHBMASF       TO MS06-USER-DATA-TITLE-A
069300                                    (X-MS06-USER-DATA)
069400             GO TO W018-INCREMENT-INDEXES.
069500*
069600     IF  MBCA-PTI-FUNCTION-IS-MAINT
069700     OR  NOT MMFS-ST-REQUIRED (X-MMFS-STORE)
069800         GO TO W018-INCREMENT-INDEXES.
069900*
070000 W017-USER-DATA-TITLE-ERROR.
070100*
070200*******************************************************
070300*    THE FIELD IS IN ERROR.  SET THE ERROR SWITCH,    *
070400*    BRIGHTEN THE PARENS, AND BRIGHTEN AND FSET       *
070500*    THE DATA ELEMENT.                                *
070600*******************************************************
070700*
070800     IF  MS06-USER-DATA-TITLE-L (X-MS06-USER-DATA)
070900                                 IS GREATER THAN ZERO
071000         MOVE DFHBMUBF           TO MS06-USER-DATA-TITLE-A
071100                                    (X-MS06-USER-DATA)
071200     ELSE
071300         MOVE DFHBMBRY           TO MS06-USER-DATA-TITLE-A
071400                                    (X-MS06-USER-DATA).
071500
071600     SET SS08WS-ERROR-SW-YES     TO TRUE.
071700     SET USER-DATA-ERRORS-EXIST  TO TRUE.
071800     MOVE DFHBMASB               TO MS06-USER-DATA-TITLE-LP-A
071900                                    (X-MS06-USER-DATA)
072000                                    MS06-USER-DATA-TITLE-RP-A
072100                                    (X-MS06-USER-DATA).
072200     MOVE SS08WS-CURSOR          TO MS06-USER-DATA-TITLE-L
072300                                    (X-MS06-USER-DATA).
072400*
072500 W018-INCREMENT-INDEXES.
072600*
072700     IF  X-MS06-USER-DATA IS LESS THAN 8
072800         SET X-MS06-USER-DATA    UP BY 1
072900         SET X-MMSM-USER-DATA    UP BY 1
073000         SET X-MMFS-STORE        UP BY 2
073100         GO TO W011-EUDT-LOOP.
073200*
073300 W019-EUDT-EXIT.
073400     EXIT.
073500*
073600 W020-EDIT-USER-DATA.
073700*
073800     MOVE MMSMTB-USER-DATA-1 (1:4)
073900                                 TO WS-INDEX-X.
074000     SET  X-MMFS-STORE           TO WS-INDEX.
074100     SET  X-MMSM-USER-DATA       TO 1.
074200     SET  X-MS06-USER-DATA       TO 1.
074300*
074400 W021-EUD-LOOP.
074500*
074600     MOVE DFHBMDAS               TO MS06-USER-DATA-LP-A
074700                                    (X-MS06-USER-DATA)
074800                                    MS06-USER-DATA-RP-A
074900                                    (X-MS06-USER-DATA).
075000     MOVE DFHBMASK               TO MS06-USER-DATA-A
075100                                    (X-MS06-USER-DATA).
075200*
075300     PERFORM Y025-USER-DATA-SECURITY
075400                                 THRU Y026-UDS-EXIT.
075500*
075600     IF  MS06-USER-DATA-L (X-MS06-USER-DATA) IS EQUAL TO ZERO
075700         MOVE MMSM-USER-DATA (X-MMSM-USER-DATA)
075800                                 TO MS06-USER-DATA
075900                                    (X-MS06-USER-DATA).
076000*
076100     IF  MS06-USER-DATA-L (X-MS06-USER-DATA) IS GREATER THAN ZERO
076200         IF  MBCA-PTI-FUNCTION-IS-ADD
076300         AND MMFS-ST-REQUIRED (X-MMFS-STORE)
076400             MOVE DFHBMABF       TO MS06-USER-DATA-A
076500                                    (X-MS06-USER-DATA)
076600             GO TO W028-INCREMENT-INDEXES
076700         ELSE
076800             MOVE DFHBMASF       TO MS06-USER-DATA-A
076900                                    (X-MS06-USER-DATA)
077000             GO TO W028-INCREMENT-INDEXES.
077100*
077200     IF  MBCA-PTI-FUNCTION-IS-MAINT
077300     OR  NOT MMFS-ST-REQUIRED (X-MMFS-STORE)
077400         GO TO W028-INCREMENT-INDEXES.
077500*
077600 W027-USER-DATA-ERROR.
077700*
077800     IF  MS06-USER-DATA-L (X-MS06-USER-DATA) IS GREATER THAN ZERO
077900         MOVE DFHBMUBF           TO MS06-USER-DATA-A
078000                                    (X-MS06-USER-DATA)
078100     ELSE
078200         MOVE DFHBMBRY           TO MS06-USER-DATA-A
078300                                    (X-MS06-USER-DATA).
078400
078500     SET SS08WS-ERROR-SW-YES     TO TRUE.
078600     SET USER-DATA-ERRORS-EXIST  TO TRUE.
078700     MOVE DFHBMASB               TO MS06-USER-DATA-LP-A
078800                                    (X-MS06-USER-DATA)
078900                                    MS06-USER-DATA-RP-A
079000                                    (X-MS06-USER-DATA).
079100     MOVE SS08WS-CURSOR          TO MS06-USER-DATA-L
079200                                    (X-MS06-USER-DATA).
079300*
079400 W028-INCREMENT-INDEXES.
079500*
079600     IF  X-MS06-USER-DATA IS LESS THAN 8
079700         SET X-MS06-USER-DATA    UP BY 1
079800         SET X-MMSM-USER-DATA    UP BY 1
079900         SET X-MMFS-STORE        UP BY 2
080000         GO TO W021-EUD-LOOP.
080100*
080200 W029-EUD-EXIT.
080300     EXIT.
080400*
080500 W030-EDIT-USER-DATE-TITLES.
080600*
080700     MOVE MMSMTB-USER-DATE-1-DESC (1:4)
080800                                 TO WS-INDEX-X.
080900     SET  X-MMFS-STORE           TO WS-INDEX.
081000     SET  X-MMSM-USER-DATE       TO 1.
081100     SET  X-MS06-USER-DATE       TO 1.
081200*
081300 W031-EUDT-LOOP.
081400*
081500     MOVE DFHBMDAS               TO MS06-USER-DATE-TITLE-LP-A
081600                                    (X-MS06-USER-DATE)
081700                                    MS06-USER-DATE-TITLE-RP-A
081800                                    (X-MS06-USER-DATE).
081900     MOVE DFHBMASK               TO MS06-USER-DATE-TITLE-A
082000                                    (X-MS06-USER-DATE).
082100*
082200     PERFORM Y035-USER-DATE-TITLE-SECURITY
082300                                 THRU Y036-UDTS-EXIT.
082400*
082500     IF  MS06-USER-DATE-TITLE-L (X-MS06-USER-DATE)
082600                                 IS EQUAL TO ZERO
082700         MOVE MMSM-USER-DATE-TITLE (X-MMSM-USER-DATE)
082800                                 TO MS06-USER-DATE-TITLE
082900                                    (X-MS06-USER-DATE).
083000*
083100     IF  MS06-USER-DATE-TITLE-L (X-MS06-USER-DATE)
083200                                 IS GREATER THAN ZERO
083300         IF  MBCA-PTI-FUNCTION-IS-ADD
083400         AND MMFS-ST-REQUIRED (X-MMFS-STORE)
083500             MOVE DFHBMABF       TO MS06-USER-DATE-TITLE-A
083600                                    (X-MS06-USER-DATE)
083700             GO TO W038-INCREMENT-INDEXES
083800         ELSE
083900             MOVE DFHBMASF       TO MS06-USER-DATE-TITLE-A
084000                                    (X-MS06-USER-DATE)
084100             GO TO W038-INCREMENT-INDEXES.
084200*
084300     IF  MBCA-PTI-FUNCTION-IS-MAINT
084400     OR  NOT MMFS-ST-REQUIRED (X-MMFS-STORE)
084500         GO TO W038-INCREMENT-INDEXES.
084600*
084700 W037-USER-DATE-TITLE-ERROR.
084800*
084900     IF  MS06-USER-DATE-TITLE-L (X-MS06-USER-DATE)
085000                                 IS GREATER THAN ZERO
085100         MOVE DFHBMUBF           TO MS06-USER-DATE-TITLE-A
085200                                    (X-MS06-USER-DATE)
085300     ELSE
085400         MOVE DFHBMBRY           TO MS06-USER-DATE-TITLE-A
085500                                    (X-MS06-USER-DATE).
085600*
085700     SET SS08WS-ERROR-SW-YES     TO TRUE.
085800     SET USER-DATE-ERRORS-EXIST  TO TRUE.
085900     MOVE DFHBMASB               TO MS06-USER-DATE-TITLE-LP-A
086000                                    (X-MS06-USER-DATE)
086100                                    MS06-USER-DATE-TITLE-RP-A
086200                                    (X-MS06-USER-DATE).
086300     MOVE SS08WS-CURSOR          TO MS06-USER-DATE-TITLE-L
086400                                    (X-MS06-USER-DATE).
086500*
086600 W038-INCREMENT-INDEXES.
086700*
086800     IF  X-MS06-USER-DATE IS LESS THAN 8
086900         SET X-MS06-USER-DATE    UP BY 1
087000         SET X-MMSM-USER-DATE    UP BY 1
087100         SET X-MMFS-STORE        UP BY 2
087200         GO TO W031-EUDT-LOOP.
087300*
087400 W039-EUDT-EXIT.
087500     EXIT.
087600*
087700 W040-EDIT-USER-DATES.
087800*
087900     MOVE MMSMTB-USER-DATE-1 (1:4)
088000                                 TO WS-INDEX-X.
088100     SET  X-MMFS-STORE           TO WS-INDEX.
088200     SET  X-MMSM-USER-DATE       TO 1.
088300     SET  X-MS06-USER-DATE       TO 1.
088400*
088500 W041-EUD-LOOP.
088600*
088700     MOVE DFHBMDAS               TO MS06-USER-DATE-LP-A
088800                                    (X-MS06-USER-DATE)
088900                                    MS06-USER-DATE-RP-A
089000                                    (X-MS06-USER-DATE).
089100     MOVE DFHBMASK               TO MS06-USER-DATE-A
089200                                    (X-MS06-USER-DATE).
089300*
089400     PERFORM Y045-USER-DATE-SECURITY
089500                                 THRU Y046-UDS-EXIT.
089600*
089700     IF  MS06-USER-DATE-L (X-MS06-USER-DATE) IS EQUAL TO ZERO
089800         MOVE MMSM-USER-DATE (X-MMSM-USER-DATE)
089900                                 TO SS01WS-JULIAN
090000         PERFORM SS08PD-JUL-TO-GREG
090100                                 THRU SS08PD-JTG-EXIT
090200         MOVE SS01WS-DATE        TO MS06-USER-DATE
090300                                    (X-MS06-USER-DATE).
090400*
090500     IF  MS06-USER-DATE (X-MS06-USER-DATE) IS NOT NUMERIC
090600         GO TO W047-USER-DATE-ERROR.
090700*
090800     IF  MS06-USER-DATE (X-MS06-USER-DATE) IS LESS THAN 1000000
090900         MOVE MS06-USER-DATE (X-MS06-USER-DATE)
091000                                 TO SS01WS-MDY
091100         MOVE SS01WS-MDYZ        TO SS01WS-DATEZ
091200     ELSE
091300         MOVE MS06-USER-DATE (X-MS06-USER-DATE)
091400                                 TO SS01WS-DATE.
091500*
091600     PERFORM SS05PD-DATE-VALIDATION
091700                                 THRU SS05PD-DV-EXIT.
091800*
091900     IF  SS01WS-DATE-IS-INVALID
092000         GO TO W047-USER-DATE-ERROR
092100     ELSE
092200         MOVE SS01WS-DATE        TO MS06-USER-DATE
092300                                    (X-MS06-USER-DATE).
092400*
092500     IF  MS06-USER-DATE-L (X-MS06-USER-DATE) IS GREATER THAN ZERO
092600         IF  MBCA-PTI-FUNCTION-IS-ADD
092700         AND MMFS-ST-REQUIRED (X-MMFS-STORE)
092800             MOVE DFHBMABF       TO MS06-USER-DATE-A
092900                                    (X-MS06-USER-DATE)
093000             GO TO W048-INCREMENT-INDEXES
093100         ELSE
093200             MOVE DFHBMASF       TO MS06-USER-DATE-A
093300                                    (X-MS06-USER-DATE)
093400             GO TO W048-INCREMENT-INDEXES.
093500*
093600     IF  MBCA-PTI-FUNCTION-IS-MAINT
093700     OR  NOT MMFS-ST-REQUIRED (X-MMFS-STORE)
093800         GO TO W048-INCREMENT-INDEXES.
093900*
094000 W047-USER-DATE-ERROR.
094100*
094200     IF  MS06-USER-DATE-L (X-MS06-USER-DATE) IS GREATER THAN ZERO
094300         MOVE DFHBMNBF           TO MS06-USER-DATE-A
094400                                    (X-MS06-USER-DATE)
094500     ELSE
094600         MOVE DFHBMUNB           TO MS06-USER-DATE-A
094700                                    (X-MS06-USER-DATE).
094800
094900     SET SS08WS-ERROR-SW-YES     TO TRUE.
095000     SET USER-DATE-ERRORS-EXIST  TO TRUE.
095100     MOVE DFHBMASB               TO MS06-USER-DATE-LP-A
095200                                    (X-MS06-USER-DATE)
095300                                    MS06-USER-DATE-RP-A
095400                                    (X-MS06-USER-DATE).
095500     MOVE SS08WS-CURSOR          TO MS06-USER-DATE-L
095600                                    (X-MS06-USER-DATE).
095700*
095800 W048-INCREMENT-INDEXES.
095900*
096000     IF  X-MS06-USER-DATE IS LESS THAN 8
096100         SET X-MS06-USER-DATE    UP BY 1
096200         SET X-MMSM-USER-DATE    UP BY 1
096300         SET X-MMFS-STORE        UP BY 2
096400         GO TO W041-EUD-LOOP.
096500*
096600 W049-EUD-EXIT.
096700     EXIT.
096800*
096900 W050-EDIT-USER-AMT-TITLES.
097000*
097100     MOVE MMSMTB-USER-AMT-1-DESC (1:4)
097200                                 TO WS-INDEX-X.
097300     SET  X-MMFS-STORE           TO WS-INDEX.
097400     SET  X-MMSM-USER-AMT        TO 1.
097500     SET  X-MS06-USER-AMT        TO 1.
097600*
097700 W051-EUAT-LOOP.
097800*
097900     MOVE DFHBMDAS               TO MS06-USER-AMT-TITLE-LP-A
098000                                    (X-MS06-USER-AMT)
098100                                    MS06-USER-AMT-TITLE-RP-A
098200                                    (X-MS06-USER-AMT).
098300     MOVE DFHBMASK               TO MS06-USER-AMT-TITLE-A
098400                                    (X-MS06-USER-AMT).
098500*
098600     PERFORM Y055-USER-AMT-TITLE-SECURITY
098700                                 THRU Y056-UATS-EXIT.
098800*
098900     IF  MS06-USER-AMT-TITLE-L (X-MS06-USER-AMT)
099000                                 IS EQUAL TO ZERO
099100         MOVE MMSM-USER-AMT-TITLE (X-MMSM-USER-AMT)
099200                                 TO MS06-USER-AMT-TITLE
099300                                    (X-MS06-USER-AMT).
099400*
099500     IF  MS06-USER-AMT-TITLE-L (X-MS06-USER-AMT)
099600                                 IS GREATER THAN ZERO
099700         IF  MBCA-PTI-FUNCTION-IS-ADD
099800         AND MMFS-ST-REQUIRED (X-MMFS-STORE)
099900             MOVE DFHBMABF       TO MS06-USER-AMT-TITLE-A
100000                                    (X-MS06-USER-AMT)
100100             GO TO W058-INCREMENT-INDEXES
100200         ELSE
100300             MOVE DFHBMASF       TO MS06-USER-AMT-TITLE-A
100400                                    (X-MS06-USER-AMT)
100500             GO TO W058-INCREMENT-INDEXES.
100600*
100700     IF  MBCA-PTI-FUNCTION-IS-MAINT
100800     OR  NOT MMFS-ST-REQUIRED (X-MMFS-STORE)
100900         GO TO W058-INCREMENT-INDEXES.
101000*
101100 W057-USER-AMT-TITLE-ERROR.
101200*
101300     IF  MS06-USER-AMT-TITLE-L (X-MS06-USER-AMT)
101400                                 IS GREATER THAN ZERO
101500         MOVE DFHBMUBF           TO MS06-USER-AMT-TITLE-A
101600                                    (X-MS06-USER-AMT)
101700     ELSE
101800         MOVE DFHBMBRY           TO MS06-USER-AMT-TITLE-A
101900                                    (X-MS06-USER-AMT).
102000
102100     SET SS08WS-ERROR-SW-YES     TO TRUE.
102200     SET USER-AMT-ERRORS-EXIST   TO TRUE.
102300     MOVE DFHBMASB               TO MS06-USER-AMT-TITLE-LP-A
102400                                    (X-MS06-USER-AMT)
102500                                    MS06-USER-AMT-TITLE-RP-A
102600                                    (X-MS06-USER-AMT).
102700     MOVE SS08WS-CURSOR          TO MS06-USER-AMT-TITLE-L
102800                                    (X-MS06-USER-AMT).
102900*
103000 W058-INCREMENT-INDEXES.
103100*
103200     IF  X-MS06-USER-AMT IS LESS THAN 8
103300         SET X-MS06-USER-AMT     UP BY 1
103400         SET X-MMSM-USER-AMT     UP BY 1
103500         SET X-MMFS-STORE        UP BY 2
103600         GO TO W051-EUAT-LOOP.
103700*
103800 W059-EUAT-EXIT.
103900     EXIT.
104000*
104100 W060-EDIT-USER-AMTS.
104200*
104300     MOVE MMSMTB-USER-AMT-1 (1:4)
104400                                 TO WS-INDEX-X.
104500     SET  X-MMFS-STORE           TO WS-INDEX.
104600     SET  X-MMSM-USER-AMT        TO 1.
104700     SET  X-MS06-USER-AMT        TO 1.
104800*
104900 W061-EUA-LOOP.
105000*
105100     MOVE DFHBMDAS               TO MS06-USER-AMT-LP-A
105200                                    (X-MS06-USER-AMT)
105300                                    MS06-USER-AMT-RP-A
105400                                    (X-MS06-USER-AMT).
105500     MOVE DFHBMASK               TO MS06-USER-AMT-A
105600                                    (X-MS06-USER-AMT).
105700*
105800     PERFORM Y065-USER-AMT-SECURITY
105900                                 THRU Y066-UAS-EXIT.
106000*
106100     IF  MS06-USER-AMT-L (X-MS06-USER-AMT) IS EQUAL TO ZERO
106200         MOVE MMSM-USER-AMT (X-MMSM-USER-AMT)
106300                                 TO MS06-USER-AMT
106400                                    (X-MS06-USER-AMT).
106500*
106600     IF  MS06-USER-AMT (X-MS06-USER-AMT) IS NOT NUMERIC
106700         GO TO W067-USER-AMT-ERROR.
106800*
106900     IF  MS06-USER-AMT-L (X-MS06-USER-AMT) IS GREATER THAN ZERO
107000         IF  MBCA-PTI-FUNCTION-IS-ADD
107100         AND MMFS-ST-REQUIRED (X-MMFS-STORE)
107200             MOVE DFHBMABF       TO MS06-USER-AMT-A
107300                                    (X-MS06-USER-AMT)
107400             GO TO W068-INCREMENT-INDEXES
107500         ELSE
107600             MOVE DFHBMASF       TO MS06-USER-AMT-A
107700                                    (X-MS06-USER-AMT)
107800             GO TO W068-INCREMENT-INDEXES.
107900*
108000     IF  MBCA-PTI-FUNCTION-IS-MAINT
108100     OR  NOT MMFS-ST-REQUIRED (X-MMFS-STORE)
108200         GO TO W068-INCREMENT-INDEXES.
108300*
108400 W067-USER-AMT-ERROR.
108500*
108600     IF  MS06-USER-AMT-L (X-MS06-USER-AMT) IS GREATER THAN ZERO
108700         MOVE DFHBMNBF           TO MS06-USER-AMT-A
108800                                    (X-MS06-USER-AMT)
108900     ELSE
109000         MOVE DFHBMUNB           TO MS06-USER-AMT-A
109100                                    (X-MS06-USER-AMT).
109200
109300     SET SS08WS-ERROR-SW-YES     TO TRUE.
109400     SET USER-AMT-ERRORS-EXIST   TO TRUE.
109500     MOVE DFHBMASB               TO MS06-USER-AMT-LP-A
109600                                    (X-MS06-USER-AMT)
109700                                    MS06-USER-AMT-RP-A
109800                                    (X-MS06-USER-AMT).
109900     MOVE SS08WS-CURSOR          TO MS06-USER-AMT-L
110000                                    (X-MS06-USER-AMT).
110100*
110200 W068-INCREMENT-INDEXES.
110300*
110400     IF  X-MS06-USER-AMT IS LESS THAN 8
110500         SET X-MS06-USER-AMT     UP BY 1
110600         SET X-MMSM-USER-AMT     UP BY 1
110700         SET X-MMFS-STORE        UP BY 2
110800         GO TO W061-EUA-LOOP.
110900*
111000 W069-EUA-EXIT.
111100     EXIT.
111200*
111300 W510-USER-DATA-CROSS-EDITS.
111400*
111500**************************************************************
111600*                                                            *
111700*    USER DATA CROSS EDITS ARE AS FOLLOWS:                   *
111800*                                                            *
111900*    . A DESCRIPTION OF SOMETHING OTHER THAN SPACES          *
112000*      MUST BE ENTERED IF THE CORRESPONDING DATA FIELD       *
112100*      IS SOMETHING OTHER THAN SPACES                        *
112200*                                                            *
112300*      IF AN ERROR IS DETECTED, THE USER DATA DESCRIPITON    *
112400*      AND DATA FIELDS ARE HIGHLIGHTED AND OPENED FOR        *
112500*      CORRECTION.                                           *
112600*                                                            *
112700**************************************************************
112800*
112900     IF  USER-DATA-ERRORS-EXIST
113000         GO TO W519-UDCE-EXIT.
113100*
113200     SET X-MS06-USER-DATA        TO 1.
113300*
113400 W511-UDCE-LOOP.
113500*
113600     IF  MS06-USER-DATA (X-MS06-USER-DATA) IS EQUAL TO SPACES
113700         GO TO W518-INCREMENT-INDEX.
113800*
113900     IF  MS06-USER-DATA-TITLE (X-MS06-USER-DATA)
114000                                 IS NOT EQUAL TO SPACES
114100         GO TO W518-INCREMENT-INDEX.
114200*
114300 W517-USER-DATA-ERROR.
114400*
114500     SET SS08WS-ERROR-SW-YES     TO TRUE.
114600     SET USER-DATA-ERRORS-EXIST  TO TRUE.
114700     MOVE SS08WS-CURSOR          TO MS06-USER-DATA-TITLE-L
114800                                    (X-MS06-USER-DATA).
114900     MOVE DFHBMASB               TO MS06-USER-DATA-TITLE-LP-A
115000                                    (X-MS06-USER-DATA)
115100                                    MS06-USER-DATA-TITLE-RP-A
115200                                    (X-MS06-USER-DATA)
115300                                    MS06-USER-DATA-LP-A
115400                                    (X-MS06-USER-DATA)
115500                                    MS06-USER-DATA-RP-A
115600                                    (X-MS06-USER-DATA).
115700     MOVE DFHBMUBF               TO MS06-USER-DATA-TITLE-A
115800                                    (X-MS06-USER-DATA)
115900                                    MS06-USER-DATA-A
116000                                    (X-MS06-USER-DATA).
116100*
116200 W518-INCREMENT-INDEX.
116300*
116400     IF  X-MS06-USER-DATA IS LESS THAN 8
116500         SET X-MS06-USER-DATA    UP BY 1
116600         GO TO W511-UDCE-LOOP.
116700*
116800 W519-UDCE-EXIT.
116900     EXIT.
117000*
117100 W520-USER-DATE-CROSS-EDITS.
117200*
117300**************************************************************
117400*                                                            *
117500*    USER DATE CROSS EDITS ARE AS FOLLOWS:                   *
117600*                                                            *
117700*    . A DESCRIPTION OF SOMETHING OTHER THAN SPACES          *
117800*      MUST BE ENTERED IF THE CORRESPONDING DATE FIELD       *
117900*      IS SOMETHING OTHER THAN ZERO.                         *
118000*                                                            *
118100*      IF AN ERROR IS DETECTED, THE DATE DESCRIPTION AND     *
118200*      DATE FIELDS ARE HIGHLIGHTED AND OPENED FOR            *
118300*      CORRECTION.                                           *
118400*                                                            *
118500**************************************************************
118600*
118700     IF  USER-DATE-ERRORS-EXIST
118800         GO TO W529-UDCE-EXIT.
118900*
119000     SET X-MS06-USER-DATE        TO 1.
119100*
119200 W521-UDCE-LOOP.
119300*
119400     IF  MS06-USER-DATE (X-MS06-USER-DATE) IS EQUAL TO ZERO
119500         GO TO W528-INCREMENT-INDEX.
119600*
119700     IF  MS06-USER-DATE-TITLE (X-MS06-USER-DATE)
119800                                 IS NOT EQUAL TO SPACES
119900         GO TO W528-INCREMENT-INDEX.
120000*
120100 W527-USER-DATE-ERROR.
120200*
120300     SET SS08WS-ERROR-SW-YES     TO TRUE.
120400     SET USER-DATE-ERRORS-EXIST  TO TRUE.
120500     MOVE SS08WS-CURSOR          TO MS06-USER-DATE-TITLE-L
120600                                    (X-MS06-USER-DATE).
120700     MOVE DFHBMASB               TO MS06-USER-DATE-TITLE-LP-A
120800                                    (X-MS06-USER-DATE)
120900                                    MS06-USER-DATE-TITLE-RP-A
121000                                    (X-MS06-USER-DATE)
121100                                    MS06-USER-DATE-LP-A
121200                                    (X-MS06-USER-DATE)
121300                                    MS06-USER-DATE-RP-A
121400                                    (X-MS06-USER-DATE).
121500     MOVE DFHBMUBF               TO MS06-USER-DATE-TITLE-A
121600                                    (X-MS06-USER-DATE).
121700     MOVE DFHBMNBF               TO MS06-USER-DATE-A
121800                                    (X-MS06-USER-DATE).
121900*
122000 W528-INCREMENT-INDEX.
122100*
122200     IF  X-MS06-USER-DATE IS LESS THAN 8
122300         SET X-MS06-USER-DATE    UP BY 1
122400         GO TO W521-UDCE-LOOP.
122500*
122600 W529-UDCE-EXIT.
122700     EXIT.
122800*
122900 W530-USER-AMT-CROSS-EDITS.
123000*
123100**************************************************************
123200*                                                            *
123300*    USER AMT CROSS EDITS ARE AS FOLLOWS:                    *
123400*                                                            *
123500*    . A DESCRIPTION OF SOMETHING OTHER THAN SPACES          *
123600*      MUST BE ENTERED IF THE CORRESPONDING AMOUNT FIELD     *
123700*      IS SOMETHING OTHER THAN ZERO.                         *
123800*                                                            *
123900*      IF AN ERROR IS DETECTED, THE AMOUNT DESCRIPTION       *
124000*      AND AMOUNT FIELDS ARE HIGHLIGHTED AND OPENED FOR      *
124100*      CORRECTION.                                           *
124200*                                                            *
124300**************************************************************
124400*
124500     IF  USER-AMT-ERRORS-EXIST
124600         GO TO W539-UACE-EXIT.
124700*
124800     SET X-MS06-USER-AMT         TO 1.
124900*
125000 W531-UACE-LOOP.
125100*
125200     IF  MS06-USER-AMT (X-MS06-USER-AMT) IS EQUAL TO ZERO
125300         GO TO W538-INCREMENT-INDEX.
125400*
125500     IF  MS06-USER-AMT-TITLE (X-MS06-USER-AMT)
125600                                 IS NOT EQUAL TO SPACES
125700         GO TO W538-INCREMENT-INDEX.
125800*
125900 W537-USER-AMT-ERROR.
126000*
126100     SET SS08WS-ERROR-SW-YES     TO TRUE.
126200     SET USER-AMT-ERRORS-EXIST   TO TRUE.
126300     MOVE SS08WS-CURSOR          TO MS06-USER-AMT-TITLE-L
126400                                    (X-MS06-USER-AMT).
126500     MOVE DFHBMASB               TO MS06-USER-AMT-TITLE-LP-A
126600                                    (X-MS06-USER-AMT)
126700                                    MS06-USER-AMT-TITLE-RP-A
126800                                    (X-MS06-USER-AMT)
126900                                    MS06-USER-AMT-LP-A
127000                                    (X-MS06-USER-AMT)
127100                                    MS06-USER-AMT-RP-A
127200                                    (X-MS06-USER-AMT).
127300     MOVE DFHBMUBF               TO MS06-USER-AMT-TITLE-A
127400                                    (X-MS06-USER-AMT).
127500     MOVE DFHBMNBF               TO MS06-USER-AMT-A
127600                                    (X-MS06-USER-AMT).
127700*
127800 W538-INCREMENT-INDEX.
127900*
128000     IF  X-MS06-USER-AMT IS LESS THAN 8
128100         SET X-MS06-USER-AMT     UP BY 1
128200         GO TO W531-UACE-LOOP.
128300*
128400 W539-UACE-EXIT.
128500     EXIT.
128600/
128700 X000-UPDATE-FIELDS SECTION.
128800*
128900 X010-UPDATE-USER-DATA-TITLES.
129000*
129100     MOVE MMSMTB-USER-DATA-1-DESC (1:4)
129200                                 TO WS-INDEX-X.
129300     SET X-MMFS-STORE            TO WS-INDEX.
129400     SET X-MMSM-USER-DATA        TO 1.
129500     SET X-MS06-USER-DATA        TO 1.
129600*
129700 X011-UUDT-LOOP.
129800*
129900     IF  MS06-USER-DATA-TITLE-L (X-MS06-USER-DATA)
130000                                 IS GREATER THAN ZERO
130100         IF  MS06-USER-DATA-TITLE (X-MS06-USER-DATA) IS NOT EQUAL
130200                                 TO MMSM-USER-DATA-TITLE
130300                                    (X-MMSM-USER-DATA)
130400             SET WS-UPDATE-SW-YES
130500                                 TO TRUE
130600             IF  MBCA-PTI-FUNCTION-IS-MAINT
130700                 MOVE MMFS-ST-AUDIT-CODE (X-MMFS-STORE)
130800                                 TO MML1-MMSM-AUDIT-CODE
130900                 MOVE 0601       TO MML1-FIELD-CODE
131000                 SET MML1-FIELD-OCCURRENCE
131100                                 TO X-MS06-USER-DATA
131200                 MOVE ZEROES     TO MML1-FIELD-OCCURRENCE-2
131300                 MOVE MML1WS-VL-20
131400                                 TO MML1-VARIABLE-LENGTH
131500                 MOVE MMSM-USER-DATA-TITLE (X-MMSM-USER-DATA)
131600                                 TO MML1-VL20-B-DATA-X
131700                 MOVE MS06-USER-DATA-TITLE (X-MS06-USER-DATA)
131800                                 TO MMSM-USER-DATA-TITLE
131900                                    (X-MMSM-USER-DATA)
132000                 MOVE MMSM-USER-DATA-TITLE (X-MMSM-USER-DATA)
132100                                 TO MML1-VL20-A-DATA-X
132200                 MOVE 'FC10'     TO MBCA-PROGRAM-LOCATION
132300                 PERFORM Y920-WRITE-LOG-RECORD
132400                                 THRU Y929-WLR-EXIT
132500             ELSE
132600                 MOVE MS06-USER-DATA-TITLE (X-MS06-USER-DATA)
132700                                 TO MMSM-USER-DATA-TITLE
132800                                    (X-MMSM-USER-DATA).
132900*
133000 X018-INCREMENT-INDEXES.
133100*
133200     IF  X-MS06-USER-DATA IS LESS THAN 8
133300         SET X-MS06-USER-DATA    UP BY 1
133400         SET X-MMSM-USER-DATA    UP BY 1
133500         SET X-MMFS-STORE        UP BY 2
133600         GO TO X011-UUDT-LOOP.
133700*
133800 X019-UUDT-EXIT.
133900     EXIT.
134000*
134100 X020-UPDATE-USER-DATA.
134200*
134300     MOVE MMSMTB-USER-DATA-1 (1:4)
134400                                 TO WS-INDEX-X.
134500     SET X-MMFS-STORE            TO WS-INDEX.
134600     SET X-MMSM-USER-DATA        TO 1.
134700     SET X-MS06-USER-DATA        TO 1.
134800*
134900 X021-UUD-LOOP.
135000*
135100     IF  MS06-USER-DATA-L (X-MS06-USER-DATA) IS GREATER THAN ZERO
135200         IF  MS06-USER-DATA (X-MS06-USER-DATA) IS NOT EQUAL
135300                                 TO MMSM-USER-DATA
135400                                    (X-MMSM-USER-DATA)
135500             SET WS-UPDATE-SW-YES
135600                                 TO TRUE
135700             IF  MBCA-PTI-FUNCTION-IS-MAINT
135800                 MOVE MMFS-ST-AUDIT-CODE (X-MMFS-STORE)
135900                                 TO MML1-MMSM-AUDIT-CODE
136000                 MOVE 0602       TO MML1-FIELD-CODE
136100                 SET MML1-FIELD-OCCURRENCE
136200                                 TO X-MS06-USER-DATA
136300                 MOVE ZEROES     TO MML1-FIELD-OCCURRENCE-2
136400                 MOVE MML1WS-VL-20
136500                                 TO MML1-VARIABLE-LENGTH
136600                 MOVE MMSM-USER-DATA (X-MMSM-USER-DATA)
136700                                 TO MML1-VL20-B-DATA-X
136800                 MOVE MS06-USER-DATA (X-MS06-USER-DATA)
136900                                 TO MMSM-USER-DATA
137000                                    (X-MMSM-USER-DATA)
137100                 MOVE MMSM-USER-DATA (X-MMSM-USER-DATA)
137200                                 TO MML1-VL20-A-DATA-X
137300                 MOVE 'FC11'     TO MBCA-PROGRAM-LOCATION
137400                 PERFORM Y920-WRITE-LOG-RECORD
137500                                 THRU Y929-WLR-EXIT
137600             ELSE
137700                 MOVE MS06-USER-DATA (X-MS06-USER-DATA)
137800                                 TO MMSM-USER-DATA
137900                                    (X-MMSM-USER-DATA).
138000*
138100 X028-INCREMENT-INDEXES.
138200*
138300     IF  X-MS06-USER-DATA IS LESS THAN 8
138400         SET X-MS06-USER-DATA    UP BY 1
138500         SET X-MMSM-USER-DATA    UP BY 1
138600         SET X-MMFS-STORE        UP BY 2
138700         GO TO X021-UUD-LOOP.
138800*
138900 X029-UUD-EXIT.
139000     EXIT.
139100*
139200 X030-UPDATE-USER-DATE-TITLES.
139300*
139400     MOVE MMSMTB-USER-DATE-1-DESC (1:4)
139500                                 TO WS-INDEX-X.
139600     SET X-MMFS-STORE            TO WS-INDEX.
139700     SET X-MMSM-USER-DATE        TO 1.
139800     SET X-MS06-USER-DATE        TO 1.
139900*
140000 X031-UUDT-LOOP.
140100*
140200     IF  MS06-USER-DATE-TITLE-L (X-MS06-USER-DATE)
140300                                 IS GREATER THAN ZERO
140400         IF  MS06-USER-DATE-TITLE (X-MS06-USER-DATE) IS NOT EQUAL
140500                                 TO MMSM-USER-DATE-TITLE
140600                                    (X-MMSM-USER-DATE)
140700             SET WS-UPDATE-SW-YES
140800                                 TO TRUE
140900             IF  MBCA-PTI-FUNCTION-IS-MAINT
141000                 MOVE MMFS-ST-AUDIT-CODE (X-MMFS-STORE)
141100                                 TO MML1-MMSM-AUDIT-CODE
141200                 MOVE 0603       TO MML1-FIELD-CODE
141300                 SET MML1-FIELD-OCCURRENCE
141400                                 TO X-MS06-USER-DATE
141500                 MOVE ZEROES     TO MML1-FIELD-OCCURRENCE-2
141600                 MOVE MML1WS-VL-20
141700                                 TO MML1-VARIABLE-LENGTH
141800                 MOVE MMSM-USER-DATE-TITLE (X-MMSM-USER-DATE)
141900                                 TO MML1-VL20-B-DATA-X
142000                 MOVE MS06-USER-DATE-TITLE (X-MS06-USER-DATE)
142100                                 TO MMSM-USER-DATE-TITLE
142200                                    (X-MMSM-USER-DATE)
142300                 MOVE MMSM-USER-DATE-TITLE (X-MMSM-USER-DATE)
142400                                 TO MML1-VL20-A-DATA-X
142500                 MOVE 'FC12'     TO MBCA-PROGRAM-LOCATION
142600                 PERFORM Y920-WRITE-LOG-RECORD
142700                                 THRU Y929-WLR-EXIT
142800             ELSE
142900                 MOVE MS06-USER-DATE-TITLE (X-MS06-USER-DATE)
143000                                 TO MMSM-USER-DATE-TITLE
143100                                    (X-MMSM-USER-DATE).
143200*
143300 X038-INCREMENT-INDEXES.
143400*
143500     IF  X-MS06-USER-DATE IS LESS THAN 8
143600         SET X-MS06-USER-DATE    UP BY 1
143700         SET X-MMSM-USER-DATE    UP BY 1
143800         SET X-MMFS-STORE        UP BY 2
143900         GO TO X031-UUDT-LOOP.
144000*
144100 X039-UUDT-EXIT.
144200     EXIT.
144300*
144400 X040-UPDATE-USER-DATES.
144500*
144600     MOVE MMSMTB-USER-DATE-1 (1:4)
144700                                 TO WS-INDEX-X.
144800     SET X-MMFS-STORE            TO WS-INDEX.
144900     SET X-MMSM-USER-DATE        TO 1.
145000     SET X-MS06-USER-DATE        TO 1.
145100*
145200 X041-UUD-LOOP.
145300*
145400     IF  MS06-USER-DATE-L (X-MS06-USER-DATE) IS GREATER THAN ZERO
145500         MOVE MS06-USER-DATE (X-MS06-USER-DATE)
145600                                 TO SS01WS-DATE
145700         PERFORM SS07PD-GREG-TO-JUL
145800                                 THRU SS07PD-GTJ-EXIT
145900         IF  SS01WS-JULIAN IS NOT EQUAL TO MMSM-USER-DATE
146000                                           (X-MMSM-USER-DATE)
146100             SET WS-UPDATE-SW-YES
146200                                 TO TRUE
146300             IF  MBCA-PTI-FUNCTION-IS-MAINT
146400                 MOVE MMFS-ST-AUDIT-CODE (X-MMFS-STORE)
146500                                 TO MML1-MMSM-AUDIT-CODE
146600                 MOVE 0604       TO MML1-FIELD-CODE
146700                 SET MML1-FIELD-OCCURRENCE
146800                                 TO X-MS06-USER-DATE
146900                 MOVE ZEROES     TO MML1-FIELD-OCCURRENCE-2
147000                 MOVE MML1WS-VL-07
147100                                 TO MML1-VARIABLE-LENGTH
147200                 MOVE MMSM-USER-DATE (X-MMSM-USER-DATE)
147300                                 TO MML1-VL07-B-DATA-9
147400                 MOVE SS01WS-JULIAN
147500                                 TO MMSM-USER-DATE
147600                                    (X-MMSM-USER-DATE)
147700                 MOVE MMSM-USER-DATE (X-MMSM-USER-DATE)
147800                                 TO MML1-VL07-A-DATA-9
147900                 MOVE 'FC13'     TO MBCA-PROGRAM-LOCATION
148000                 PERFORM Y920-WRITE-LOG-RECORD
148100                                 THRU Y929-WLR-EXIT
148200             ELSE
148300                 MOVE SS01WS-JULIAN
148400                                 TO MMSM-USER-DATE
148500                                    (X-MMSM-USER-DATE).
148600*
148700 X048-INCREMENT-INDEXES.
148800*
148900     IF  X-MS06-USER-DATE IS LESS THAN 8
149000         SET X-MS06-USER-DATE    UP BY 1
149100         SET X-MMSM-USER-DATE    UP BY 1
149200         SET X-MMFS-STORE        UP BY 2
149300         GO TO X041-UUD-LOOP.
149400*
149500 X049-UUD-EXIT.
149600     EXIT.
149700*
149800 X050-UPDATE-USER-AMT-TITLES.
149900*
150000     MOVE MMSMTB-USER-AMT-1-DESC (1:4)
150100                                 TO WS-INDEX-X.
150200     SET X-MMFS-STORE            TO WS-INDEX.
150300     SET X-MMSM-USER-AMT         TO 1.
150400     SET X-MS06-USER-AMT         TO 1.
150500*
150600 X051-UUAT-LOOP.
150700*
150800     IF  MS06-USER-AMT-TITLE-L (X-MS06-USER-AMT)
150900                                 IS GREATER THAN ZERO
151000         IF  MS06-USER-AMT-TITLE (X-MS06-USER-AMT) IS NOT EQUAL
151100                                 TO MMSM-USER-AMT-TITLE
151200                                    (X-MMSM-USER-AMT)
151300             SET WS-UPDATE-SW-YES
151400                                 TO TRUE
151500             IF  MBCA-PTI-FUNCTION-IS-MAINT
151600                 MOVE MMFS-ST-AUDIT-CODE (X-MMFS-STORE)
151700                                 TO MML1-MMSM-AUDIT-CODE
151800                 MOVE 0605       TO MML1-FIELD-CODE
151900                 SET MML1-FIELD-OCCURRENCE
152000                                 TO X-MS06-USER-AMT
152100                 MOVE ZEROES     TO MML1-FIELD-OCCURRENCE-2
152200                 MOVE MML1WS-VL-20
152300                                 TO MML1-VARIABLE-LENGTH
152400                 MOVE MMSM-USER-AMT-TITLE (X-MMSM-USER-AMT)
152500                                 TO MML1-VL20-B-DATA-X
152600                 MOVE MS06-USER-AMT-TITLE (X-MS06-USER-AMT)
152700                                 TO MMSM-USER-AMT-TITLE
152800                                    (X-MMSM-USER-AMT)
152900                 MOVE MMSM-USER-AMT-TITLE (X-MMSM-USER-AMT)
153000                                 TO MML1-VL20-A-DATA-X
153100                 MOVE 'FC14'     TO MBCA-PROGRAM-LOCATION
153200                 PERFORM Y920-WRITE-LOG-RECORD
153300                                 THRU Y929-WLR-EXIT
153400             ELSE
153500                 MOVE MS06-USER-AMT-TITLE (X-MS06-USER-AMT)
153600                                 TO MMSM-USER-AMT-TITLE
153700                                    (X-MMSM-USER-AMT).
153800*
153900 X058-INCREMENT-INDEXES.
154000*
154100     IF  X-MS06-USER-AMT IS LESS THAN 8
154200         SET X-MS06-USER-AMT     UP BY 1
154300         SET X-MMSM-USER-AMT     UP BY 1
154400         SET X-MMFS-STORE        UP BY 2
154500         GO TO X051-UUAT-LOOP.
154600*
154700 X059-UUAT-EXIT.
154800     EXIT.
154900*
155000 X060-UPDATE-USER-AMTS.
155100*
155200     MOVE MMSMTB-USER-AMT-1 (1:4)
155300                                 TO WS-INDEX-X.
155400     SET X-MMFS-STORE            TO WS-INDEX.
155500     SET X-MMSM-USER-AMT         TO 1.
155600     SET X-MS06-USER-AMT         TO 1.
155700*
155800 X061-UUA-LOOP.
155900*
156000     IF  MS06-USER-AMT-L (X-MS06-USER-AMT) IS GREATER THAN ZERO
156100         IF  MS06-USER-AMT (X-MS06-USER-AMT) IS NOT EQUAL
156200                                 TO MMSM-USER-AMT
156300                                    (X-MMSM-USER-AMT)
156400             SET WS-UPDATE-SW-YES
156500                                 TO TRUE
156600             IF  MBCA-PTI-FUNCTION-IS-MAINT
156700                 MOVE MMFS-ST-AUDIT-CODE (X-MMFS-STORE)
156800                                 TO MML1-MMSM-AUDIT-CODE
156900                 MOVE 0606       TO MML1-FIELD-CODE
157000                 SET MML1-FIELD-OCCURRENCE
157100                                 TO X-MS06-USER-AMT
157200                 MOVE ZEROES     TO MML1-FIELD-OCCURRENCE-2
157300                 MOVE MML1WS-VL-20
157400                                 TO MML1-VARIABLE-LENGTH
157500                 MOVE MMSM-USER-AMT (X-MMSM-USER-AMT)
157600                                 TO MML1-VL20-B-NBR-NO-DEC
157700                 MOVE MS06-USER-AMT (X-MS06-USER-AMT)
157800                                 TO MMSM-USER-AMT
157900                                    (X-MMSM-USER-AMT)
158000                 MOVE MMSM-USER-AMT (X-MMSM-USER-AMT)
158100                                 TO MML1-VL20-A-NBR-NO-DEC
158200                 MOVE 'FC15'     TO MBCA-PROGRAM-LOCATION
158300                 PERFORM Y920-WRITE-LOG-RECORD
158400                                 THRU Y929-WLR-EXIT
158500             ELSE
158600                 MOVE MS06-USER-AMT (X-MS06-USER-AMT)
158700                                 TO MMSM-USER-AMT
158800                                    (X-MMSM-USER-AMT).
158900*
159000 X068-INCREMENT-INDEXES.
159100*
159200     IF  X-MS06-USER-AMT IS LESS THAN 8
159300         SET X-MS06-USER-AMT     UP BY 1
159400         SET X-MMSM-USER-AMT     UP BY 1
159500         SET X-MMFS-STORE        UP BY 2
159600         GO TO X061-UUA-LOOP.
159700*
159800 X069-UUA-EXIT.
159900     EXIT.
160000/
160100 Y000-PERFORMED-ROUTINES SECTION.
160200*
160300 Y010-MOVE-USER-DATA-TITLES.
160400*
160500     MOVE MMSMTB-USER-DATA-1-DESC (1:4)
160600                                 TO WS-INDEX-X.
160700     SET  X-MMFS-STORE           TO WS-INDEX.
160800     SET  X-MMSM-USER-DATA       TO 1.
160900     SET  X-MS06-USER-DATA       TO 1.
161000*
161100 Y011-MUDT-LOOP.
161200*
161300     MOVE MMSM-USER-DATA-TITLE (X-MMSM-USER-DATA)
161400                                 TO MS06-USER-DATA-TITLE
161500                                    (X-MS06-USER-DATA).
161600*
161700 Y015-USER-DATA-TITLE-SECURITY.
161800*
161900     IF  MMFS-ST-NO-ACCESS (X-MMFS-STORE)
162000         MOVE DFHBMDAS           TO MS06-USER-DATA-TITLE-A
162100                                    (X-MS06-USER-DATA)
162200                                    MS06-USER-DATA-TITLE-LP-A
162300                                    (X-MS06-USER-DATA)
162400                                    MS06-USER-DATA-TITLE-RP-A
162500                                    (X-MS06-USER-DATA)
162600                                    MS06-USER-DATA-TITLE-A
162700                                    (X-MS06-USER-DATA)
162800         MOVE ZERO               TO MS06-USER-DATA-TITLE-L
162900                                    (X-MS06-USER-DATA)
163000         GO TO Y016-UDTS-EXIT.
163100*
163200     IF  MBCA-PTI-FUNCTION-IS-INQUIRY
163300         MOVE DFHBMDAS           TO MS06-USER-DATA-TITLE-LP-A
163400                                    (X-MS06-USER-DATA)
163500                                    MS06-USER-DATA-TITLE-RP-A
163600                                    (X-MS06-USER-DATA)
163700         MOVE DFHBMASB           TO MS06-USER-DATA-TITLE-A
163800                                    (X-MS06-USER-DATA)
163900         GO TO Y016-UDTS-EXIT.
164000*
164100     IF  MMFS-ST-INQ-ONLY (X-MMFS-STORE)
164200         MOVE ZERO               TO MS06-USER-DATA-TITLE-L
164300                                    (X-MS06-USER-DATA)
164400         MOVE DFHBMDAS           TO MS06-USER-DATA-TITLE-LP-A
164500                                    (X-MS06-USER-DATA)
164600                                    MS06-USER-DATA-TITLE-RP-A
164700                                    (X-MS06-USER-DATA)
164800         MOVE DFHBMASK           TO MS06-USER-DATA-TITLE-A
164900                                    (X-MS06-USER-DATA)
165000         GO TO Y016-UDTS-EXIT.
165100*
165200     IF  MBCA-PTI-FUNCTION-IS-ADD
165300         IF  MMFS-ST-REQUIRED (X-MMFS-STORE)
165400             MOVE DFHBMBRY       TO MS06-USER-DATA-TITLE-A
165500                                    (X-MS06-USER-DATA)
165600         ELSE
165700             IF  MMFS-ST-MAINT-ONLY (X-MMFS-STORE)
165800                 MOVE ZERO       TO MS06-USER-DATA-TITLE-L
165900                                    (X-MS06-USER-DATA)
166000                 MOVE DFHBMDAS   TO MS06-USER-DATA-TITLE-LP-A
166100                                    (X-MS06-USER-DATA)
166200                                    MS06-USER-DATA-TITLE-RP-A
166300                                    (X-MS06-USER-DATA)
166400                 MOVE DFHBMASK   TO MS06-USER-DATA-TITLE-A
166500                                    (X-MS06-USER-DATA).
166600*
166700     IF  MBCA-PTI-FUNCTION-IS-MAINT
166800         IF  MMFS-ST-NO-MAINT (X-MMFS-STORE)
166900             MOVE ZERO           TO MS06-USER-DATA-TITLE-L
167000                                    (X-MS06-USER-DATA)
167100             MOVE DFHBMDAS       TO MS06-USER-DATA-TITLE-LP-A
167200                                    (X-MS06-USER-DATA)
167300                                    MS06-USER-DATA-TITLE-RP-A
167400                                    (X-MS06-USER-DATA)
167500             MOVE DFHBMASK       TO MS06-USER-DATA-TITLE-A
167600                                    (X-MS06-USER-DATA).
167700*
167800 Y016-UDTS-EXIT.
167900     EXIT.
168000*
168100 Y018-INCREMENT-INDEXES.
168200*
168300     IF  X-MS06-USER-DATA IS LESS THAN 8
168400         SET X-MS06-USER-DATA    UP BY 1
168500         SET X-MMSM-USER-DATA    UP BY 1
168600         SET X-MMFS-STORE        UP BY 2
168700         GO TO Y011-MUDT-LOOP.
168800*
168900 Y019-MUDT-EXIT.
169000     EXIT.
169100*
169200 Y020-MOVE-USER-DATA.
169300*
169400     MOVE MMSMTB-USER-DATA-1 (1:4)
169500                                 TO WS-INDEX-X.
169600     SET  X-MMFS-STORE           TO WS-INDEX.
169700     SET  X-MMSM-USER-DATA       TO 1.
169800     SET  X-MS06-USER-DATA       TO 1.
169900*
170000 Y021-MUD-LOOP.
170100*
170200     MOVE MMSM-USER-DATA (X-MMSM-USER-DATA)
170300                                 TO MS06-USER-DATA
170400                                    (X-MS06-USER-DATA).
170500*
170600 Y025-USER-DATA-SECURITY.
170700*
170800     IF  MMFS-ST-NO-ACCESS (X-MMFS-STORE)
170900         MOVE DFHBMDAS           TO MS06-USER-DATA-A
171000                                    (X-MS06-USER-DATA)
171100                                    MS06-USER-DATA-LP-A
171200                                    (X-MS06-USER-DATA)
171300                                    MS06-USER-DATA-RP-A
171400                                    (X-MS06-USER-DATA)
171500                                    MS06-USER-DATA-A
171600                                    (X-MS06-USER-DATA)
171700         MOVE ZERO               TO MS06-USER-DATA-L
171800                                    (X-MS06-USER-DATA)
171900         GO TO Y026-UDS-EXIT.
172000*
172100     IF  MBCA-PTI-FUNCTION-IS-INQUIRY
172200         MOVE DFHBMDAS           TO MS06-USER-DATA-LP-A
172300                                    (X-MS06-USER-DATA)
172400                                    MS06-USER-DATA-RP-A
172500                                    (X-MS06-USER-DATA)
172600         MOVE DFHBMASB           TO MS06-USER-DATA-A
172700                                    (X-MS06-USER-DATA)
172800         GO TO Y026-UDS-EXIT.
172900*
173000     IF  MMFS-ST-INQ-ONLY (X-MMFS-STORE)
173100         MOVE ZERO               TO MS06-USER-DATA-L
173200                                    (X-MS06-USER-DATA)
173300         MOVE DFHBMDAS           TO MS06-USER-DATA-LP-A
173400                                    (X-MS06-USER-DATA)
173500                                    MS06-USER-DATA-RP-A
173600                                    (X-MS06-USER-DATA)
173700         MOVE DFHBMASK           TO MS06-USER-DATA-A
173800                                    (X-MS06-USER-DATA)
173900         GO TO Y026-UDS-EXIT.
174000*
174100     IF  MBCA-PTI-FUNCTION-IS-ADD
174200         IF  MMFS-ST-REQUIRED (X-MMFS-STORE)
174300             MOVE DFHBMBRY       TO MS06-USER-DATA-A
174400                                    (X-MS06-USER-DATA)
174500         ELSE
174600             IF  MMFS-ST-MAINT-ONLY (X-MMFS-STORE)
174700                 MOVE ZERO       TO MS06-USER-DATA-L
174800                                    (X-MS06-USER-DATA)
174900                 MOVE DFHBMDAS   TO MS06-USER-DATA-LP-A
175000                                    (X-MS06-USER-DATA)
175100                                    MS06-USER-DATA-RP-A
175200                                    (X-MS06-USER-DATA)
175300                 MOVE DFHBMASK   TO MS06-USER-DATA-A
175400                                    (X-MS06-USER-DATA).
175500*
175600     IF  MBCA-PTI-FUNCTION-IS-MAINT
175700         IF  MMFS-ST-NO-MAINT (X-MMFS-STORE)
175800             MOVE ZERO           TO MS06-USER-DATA-L
175900                                    (X-MS06-USER-DATA)
176000             MOVE DFHBMDAS       TO MS06-USER-DATA-LP-A
176100                                    (X-MS06-USER-DATA)
176200                                    MS06-USER-DATA-RP-A
176300                                    (X-MS06-USER-DATA)
176400             MOVE DFHBMASK       TO MS06-USER-DATA-A
176500                                    (X-MS06-USER-DATA).
176600*
176700 Y026-UDS-EXIT.
176800     EXIT.
176900*
177000 Y028-INCREMENT-INDEXES.
177100*
177200     IF  X-MS06-USER-DATA IS LESS THAN 8
177300         IF  X-MS06-USER-DATA IS EQUAL TO 7
177400             MOVE MMSMTB-USER-DATA-8 (1:4)
177500                                 TO WS-INDEX-X
177600             SET  X-MMFS-STORE   TO WS-INDEX
177700             SET X-MS06-USER-DATA
177800                                 UP BY 1
177900             SET X-MMSM-USER-DATA
178000                                 UP BY 1
178100             GO TO Y021-MUD-LOOP
178200         ELSE
178300             SET X-MS06-USER-DATA
178400                                 UP BY 1
178500             SET X-MMSM-USER-DATA
178600                                 UP BY 1
178700             SET X-MMFS-STORE    UP BY 2
178800             GO TO Y021-MUD-LOOP.
178900*
179000 Y029-MUD-EXIT.
179100     EXIT.
179200*
179300 Y030-MOVE-USER-DATE-TITLES.
179400*
179500     MOVE MMSMTB-USER-DATE-1-DESC (1:4)
179600                                 TO WS-INDEX-X.
179700     SET  X-MMFS-STORE           TO WS-INDEX.
179800     SET  X-MMSM-USER-DATE       TO 1.
179900     SET  X-MS06-USER-DATE       TO 1.
180000*
180100 Y031-MUDT-LOOP.
180200*
180300     MOVE MMSM-USER-DATE-TITLE (X-MMSM-USER-DATE)
180400                                 TO MS06-USER-DATE-TITLE
180500                                    (X-MS06-USER-DATE).
180600*
180700 Y035-USER-DATE-TITLE-SECURITY.
180800*
180900     IF  MMFS-ST-NO-ACCESS (X-MMFS-STORE)
181000         MOVE DFHBMDAS           TO MS06-USER-DATE-TITLE-A
181100                                    (X-MS06-USER-DATE)
181200                                    MS06-USER-DATE-TITLE-LP-A
181300                                    (X-MS06-USER-DATE)
181400                                    MS06-USER-DATE-TITLE-RP-A
181500                                    (X-MS06-USER-DATE)
181600                                    MS06-USER-DATE-TITLE-A
181700                                    (X-MS06-USER-DATE)
181800         MOVE ZERO               TO MS06-USER-DATE-TITLE-L
181900                                    (X-MS06-USER-DATE)
182000         GO TO Y036-UDTS-EXIT.
182100*
182200     IF  MBCA-PTI-FUNCTION-IS-INQUIRY
182300         MOVE DFHBMDAS           TO MS06-USER-DATE-TITLE-LP-A
182400                                    (X-MS06-USER-DATE)
182500                                    MS06-USER-DATE-TITLE-RP-A
182600                                    (X-MS06-USER-DATE)
182700         MOVE DFHBMASB           TO MS06-USER-DATE-TITLE-A
182800                                    (X-MS06-USER-DATE)
182900         GO TO Y036-UDTS-EXIT.
183000*
183100     IF  MMFS-ST-INQ-ONLY (X-MMFS-STORE)
183200         MOVE ZERO               TO MS06-USER-DATE-TITLE-L
183300                                    (X-MS06-USER-DATE)
183400         MOVE DFHBMDAS           TO MS06-USER-DATE-TITLE-LP-A
183500                                    (X-MS06-USER-DATE)
183600                                    MS06-USER-DATE-TITLE-RP-A
183700                                    (X-MS06-USER-DATE)
183800         MOVE DFHBMASK           TO MS06-USER-DATE-TITLE-A
183900                                    (X-MS06-USER-DATE)
184000         GO TO Y036-UDTS-EXIT.
184100*
184200     IF  MBCA-PTI-FUNCTION-IS-ADD
184300         IF  MMFS-ST-REQUIRED (X-MMFS-STORE)
184400             MOVE DFHBMBRY       TO MS06-USER-DATE-TITLE-A
184500                                    (X-MS06-USER-DATE)
184600         ELSE
184700             IF  MMFS-ST-MAINT-ONLY (X-MMFS-STORE)
184800                 MOVE ZERO       TO MS06-USER-DATE-TITLE-L
184900                                    (X-MS06-USER-DATE)
185000                 MOVE DFHBMDAS   TO MS06-USER-DATE-TITLE-LP-A
185100                                    (X-MS06-USER-DATE)
185200                                    MS06-USER-DATE-TITLE-RP-A
185300                                    (X-MS06-USER-DATE)
185400                 MOVE DFHBMASK   TO MS06-USER-DATE-TITLE-A
185500                                    (X-MS06-USER-DATE).
185600*
185700     IF  MBCA-PTI-FUNCTION-IS-MAINT
185800         IF  MMFS-ST-NO-MAINT (X-MMFS-STORE)
185900             MOVE ZERO           TO MS06-USER-DATE-TITLE-L
186000                                    (X-MS06-USER-DATE)
186100             MOVE DFHBMDAS       TO MS06-USER-DATE-TITLE-LP-A
186200                                    (X-MS06-USER-DATE)
186300                                    MS06-USER-DATE-TITLE-RP-A
186400                                    (X-MS06-USER-DATE)
186500             MOVE DFHBMASK       TO MS06-USER-DATE-TITLE-A
186600                                    (X-MS06-USER-DATE).
186700*
186800 Y036-UDTS-EXIT.
186900     EXIT.
187000*
187100 Y038-INCREMENT-INDEXES.
187200*
187300     IF  X-MS06-USER-DATE IS LESS THAN 8
187400         SET X-MS06-USER-DATE    UP BY 1
187500         SET X-MMSM-USER-DATE    UP BY 1
187600         SET X-MMFS-STORE        UP BY 2
187700         GO TO Y031-MUDT-LOOP.
187800*
187900 Y039-MUDT-EXIT.
188000     EXIT.
188100*
188200 Y040-MOVE-USER-DATES.
188300*
188400     MOVE MMSMTB-USER-DATE-1 (1:4)
188500                                 TO WS-INDEX-X.
188600     SET  X-MMFS-STORE           TO WS-INDEX.
188700     SET  X-MMSM-USER-DATE       TO 1.
188800     SET  X-MS06-USER-DATE       TO 1.
188900*
189000 Y041-MUD-LOOP.
189100*
189200     MOVE MMSM-USER-DATE (X-MMSM-USER-DATE)
189300                                 TO SS01WS-JULIAN.
189400     PERFORM SS08PD-JUL-TO-GREG  THRU SS08PD-JTG-EXIT.
189500     MOVE SS01WS-DATE            TO MS06-USER-DATE
189600                                    (X-MS06-USER-DATE).
189700*
189800 Y045-USER-DATE-SECURITY.
189900*
190000     IF  MMFS-ST-NO-ACCESS (X-MMFS-STORE)
190100         MOVE DFHBMDAS           TO MS06-USER-DATE-A
190200                                    (X-MS06-USER-DATE)
190300                                    MS06-USER-DATE-LP-A
190400                                    (X-MS06-USER-DATE)
190500                                    MS06-USER-DATE-RP-A
190600                                    (X-MS06-USER-DATE)
190700                                    MS06-USER-DATE-A
190800                                    (X-MS06-USER-DATE)
190900         MOVE ZERO               TO MS06-USER-DATE-L
191000                                    (X-MS06-USER-DATE)
191100         GO TO Y046-UDS-EXIT.
191200*
191300     IF  MBCA-PTI-FUNCTION-IS-INQUIRY
191400         MOVE DFHBMDAS           TO MS06-USER-DATE-LP-A
191500                                    (X-MS06-USER-DATE)
191600                                    MS06-USER-DATE-RP-A
191700                                    (X-MS06-USER-DATE)
191800         MOVE DFHBMASB           TO MS06-USER-DATE-A
191900                                    (X-MS06-USER-DATE)
192000         GO TO Y046-UDS-EXIT.
192100*
192200     IF  MMFS-ST-INQ-ONLY (X-MMFS-STORE)
192300         MOVE ZERO               TO MS06-USER-DATE-L
192400                                    (X-MS06-USER-DATE)
192500         MOVE DFHBMDAS           TO MS06-USER-DATE-LP-A
192600                                    (X-MS06-USER-DATE)
192700                                    MS06-USER-DATE-RP-A
192800                                    (X-MS06-USER-DATE)
192900         MOVE DFHBMASK           TO MS06-USER-DATE-A
193000                                    (X-MS06-USER-DATE)
193100         GO TO Y046-UDS-EXIT.
193200*
193300     IF  MBCA-PTI-FUNCTION-IS-ADD
193400         IF  MMFS-ST-REQUIRED (X-MMFS-STORE)
193500             MOVE DFHBMUNB       TO MS06-USER-DATE-A
193600                                    (X-MS06-USER-DATE)
193700         ELSE
193800             IF  MMFS-ST-MAINT-ONLY (X-MMFS-STORE)
193900                 MOVE ZERO       TO MS06-USER-DATE-L
194000                                    (X-MS06-USER-DATE)
194100                 MOVE DFHBMDAS   TO MS06-USER-DATE-LP-A
194200                                    (X-MS06-USER-DATE)
194300                                    MS06-USER-DATE-RP-A
194400                                    (X-MS06-USER-DATE)
194500                 MOVE DFHBMASK   TO MS06-USER-DATE-A
194600                                    (X-MS06-USER-DATE).
194700*
194800     IF  MBCA-PTI-FUNCTION-IS-MAINT
194900         IF  MMFS-ST-NO-MAINT (X-MMFS-STORE)
195000             MOVE ZERO           TO MS06-USER-DATE-L
195100                                    (X-MS06-USER-DATE)
195200             MOVE DFHBMDAS       TO MS06-USER-DATE-LP-A
195300                                    (X-MS06-USER-DATE)
195400                                    MS06-USER-DATE-RP-A
195500                                    (X-MS06-USER-DATE)
195600             MOVE DFHBMASK       TO MS06-USER-DATE-A
195700                                    (X-MS06-USER-DATE).
195800*
195900 Y046-UDS-EXIT.
196000     EXIT.
196100*
196200 Y048-INCREMENT-INDEXES.
196300*
196400     IF  X-MS06-USER-DATE IS LESS THAN 8
196500         SET X-MS06-USER-DATE    UP BY 1
196600         SET X-MMSM-USER-DATE    UP BY 1
196700         SET X-MMFS-STORE        UP BY 2
196800         GO TO Y041-MUD-LOOP.
196900*
197000 Y049-MUD-EXIT.
197100     EXIT.
197200*
197300 Y050-MOVE-USER-AMT-TITLES.
197400*
197500     MOVE MMSMTB-USER-AMT-1-DESC (1:4)
197600                                 TO WS-INDEX-X.
197700     SET  X-MMFS-STORE           TO WS-INDEX.
197800     SET  X-MMSM-USER-AMT        TO 1.
197900     SET  X-MS06-USER-AMT        TO 1.
198000*
198100 Y051-MUAT-LOOP.
198200*
198300     MOVE MMSM-USER-AMT-TITLE (X-MMSM-USER-AMT)
198400                                 TO MS06-USER-AMT-TITLE
198500                                    (X-MS06-USER-AMT).
198600*
198700 Y055-USER-AMT-TITLE-SECURITY.
198800*
198900     IF  MMFS-ST-NO-ACCESS (X-MMFS-STORE)
199000         MOVE DFHBMDAS           TO MS06-USER-AMT-TITLE-A
199100                                    (X-MS06-USER-AMT)
199200                                    MS06-USER-AMT-TITLE-LP-A
199300                                    (X-MS06-USER-AMT)
199400                                    MS06-USER-AMT-TITLE-RP-A
199500                                    (X-MS06-USER-AMT)
199600                                    MS06-USER-AMT-TITLE-A
199700                                    (X-MS06-USER-AMT)
199800         MOVE ZERO               TO MS06-USER-AMT-TITLE-L
199900                                    (X-MS06-USER-AMT)
200000         GO TO Y056-UATS-EXIT.
200100*
200200     IF  MBCA-PTI-FUNCTION-IS-INQUIRY
200300         MOVE DFHBMDAS           TO MS06-USER-AMT-TITLE-LP-A
200400                                    (X-MS06-USER-AMT)
200500                                    MS06-USER-AMT-TITLE-RP-A
200600                                    (X-MS06-USER-AMT)
200700         MOVE DFHBMASB           TO MS06-USER-AMT-TITLE-A
200800                                    (X-MS06-USER-AMT)
200900         GO TO Y056-UATS-EXIT.
201000*
201100     IF  MMFS-ST-INQ-ONLY (X-MMFS-STORE)
201200         MOVE ZERO               TO MS06-USER-AMT-TITLE-L
201300                                    (X-MS06-USER-AMT)
201400         MOVE DFHBMDAS           TO MS06-USER-AMT-TITLE-LP-A
201500                                    (X-MS06-USER-AMT)
201600                                    MS06-USER-AMT-TITLE-RP-A
201700                                    (X-MS06-USER-AMT)
201800         MOVE DFHBMASK           TO MS06-USER-AMT-TITLE-A
201900                                    (X-MS06-USER-AMT)
202000         GO TO Y056-UATS-EXIT.
202100*
202200     IF  MBCA-PTI-FUNCTION-IS-ADD
202300         IF  MMFS-ST-REQUIRED (X-MMFS-STORE)
202400             MOVE DFHBMBRY       TO MS06-USER-AMT-TITLE-A
202500                                    (X-MS06-USER-AMT)
202600         ELSE
202700             IF  MMFS-ST-MAINT-ONLY (X-MMFS-STORE)
202800                 MOVE ZERO       TO MS06-USER-AMT-TITLE-L
202900                                    (X-MS06-USER-AMT)
203000                 MOVE DFHBMDAS   TO MS06-USER-AMT-TITLE-LP-A
203100                                    (X-MS06-USER-AMT)
203200                                    MS06-USER-AMT-TITLE-RP-A
203300                                    (X-MS06-USER-AMT)
203400                 MOVE DFHBMASK   TO MS06-USER-AMT-TITLE-A
203500                                    (X-MS06-USER-AMT).
203600*
203700     IF  MBCA-PTI-FUNCTION-IS-MAINT
203800         IF  MMFS-ST-NO-MAINT (X-MMFS-STORE)
203900             MOVE ZERO           TO MS06-USER-AMT-TITLE-L
204000                                    (X-MS06-USER-AMT)
204100             MOVE DFHBMDAS       TO MS06-USER-AMT-TITLE-LP-A
204200                                    (X-MS06-USER-AMT)
204300                                    MS06-USER-AMT-TITLE-RP-A
204400                                    (X-MS06-USER-AMT)
204500             MOVE DFHBMASK       TO MS06-USER-AMT-TITLE-A
204600                                    (X-MS06-USER-AMT).
204700*
204800 Y056-UATS-EXIT.
204900     EXIT.
205000*
205100 Y058-INCREMENT-INDEXES.
205200*
205300     IF  X-MS06-USER-AMT IS LESS THAN 8
205400         SET X-MS06-USER-AMT     UP BY 1
205500         SET X-MMSM-USER-AMT     UP BY 1
205600         SET X-MMFS-STORE        UP BY 2
205700         GO TO Y051-MUAT-LOOP.
205800*
205900 Y059-MUAT-EXIT.
206000     EXIT.
206100*
206200 Y060-MOVE-USER-AMTS.
206300*
206400     MOVE MMSMTB-USER-AMT-1 (1:4)
206500                                 TO WS-INDEX-X.
206600     SET  X-MMFS-STORE           TO WS-INDEX.
206700     SET  X-MMSM-USER-AMT        TO 1.
206800     SET  X-MS06-USER-AMT        TO 1.
206900*
207000 Y061-MUA-LOOP.
207100*
207200     MOVE MMSM-USER-AMT (X-MMSM-USER-AMT)
207300                                 TO MS06-USER-AMT
207400                                    (X-MS06-USER-AMT).
207500*
207600 Y065-USER-AMT-SECURITY.
207700*
207800     IF  MMFS-ST-NO-ACCESS (X-MMFS-STORE)
207900         MOVE DFHBMDAS           TO MS06-USER-AMT-A
208000                                    (X-MS06-USER-AMT)
208100                                    MS06-USER-AMT-LP-A
208200                                    (X-MS06-USER-AMT)
208300                                    MS06-USER-AMT-RP-A
208400                                    (X-MS06-USER-AMT)
208500                                    MS06-USER-AMT-A
208600                                    (X-MS06-USER-AMT)
208700         MOVE ZERO               TO MS06-USER-AMT-L
208800                                    (X-MS06-USER-AMT)
208900         GO TO Y066-UAS-EXIT.
209000*
209100     IF  MBCA-PTI-FUNCTION-IS-INQUIRY
209200         MOVE DFHBMDAS           TO MS06-USER-AMT-LP-A
209300                                    (X-MS06-USER-AMT)
209400                                    MS06-USER-AMT-RP-A
209500                                    (X-MS06-USER-AMT)
209600         MOVE DFHBMASB           TO MS06-USER-AMT-A
209700                                    (X-MS06-USER-AMT)
209800         GO TO Y066-UAS-EXIT.
209900*
210000     IF  MMFS-ST-INQ-ONLY (X-MMFS-STORE)
210100         MOVE ZERO               TO MS06-USER-AMT-L
210200                                    (X-MS06-USER-AMT)
210300         MOVE DFHBMDAS           TO MS06-USER-AMT-LP-A
210400                                    (X-MS06-USER-AMT)
210500                                    MS06-USER-AMT-RP-A
210600                                    (X-MS06-USER-AMT)
210700         MOVE DFHBMASK           TO MS06-USER-AMT-A
210800                                    (X-MS06-USER-AMT)
210900         GO TO Y066-UAS-EXIT.
211000*
211100     IF  MBCA-PTI-FUNCTION-IS-ADD
211200         IF  MMFS-ST-REQUIRED (X-MMFS-STORE)
211300             MOVE DFHBMUNB       TO MS06-USER-AMT-A
211400                                    (X-MS06-USER-AMT)
211500         ELSE
211600             IF  MMFS-ST-MAINT-ONLY (X-MMFS-STORE)
211700                 MOVE ZERO       TO MS06-USER-AMT-L
211800                                    (X-MS06-USER-AMT)
211900                 MOVE DFHBMDAS   TO MS06-USER-AMT-LP-A
212000                                    (X-MS06-USER-AMT)
212100                                    MS06-USER-AMT-RP-A
212200                                    (X-MS06-USER-AMT)
212300                 MOVE DFHBMASK   TO MS06-USER-AMT-A
212400                                    (X-MS06-USER-AMT).
212500*
212600     IF  MBCA-PTI-FUNCTION-IS-MAINT
212700         IF  MMFS-ST-NO-MAINT (X-MMFS-STORE)
212800             MOVE ZERO           TO MS06-USER-AMT-L
212900                                    (X-MS06-USER-AMT)
213000             MOVE DFHBMDAS       TO MS06-USER-AMT-LP-A
213100                                    (X-MS06-USER-AMT)
213200                                    MS06-USER-AMT-RP-A
213300                                    (X-MS06-USER-AMT)
213400             MOVE DFHBMASK       TO MS06-USER-AMT-A
213500                                    (X-MS06-USER-AMT).
213600*
213700 Y066-UAS-EXIT.
213800     EXIT.
213900*
214000 Y068-INCREMENT-INDEXES.
214100*
214200     IF  X-MS06-USER-AMT IS LESS THAN 8
214300         SET X-MS06-USER-AMT     UP BY 1
214400         SET X-MMSM-USER-AMT     UP BY 1
214500         SET X-MMFS-STORE        UP BY 2
214600         GO TO Y061-MUA-LOOP.
214700*
214800 Y069-MUA-EXIT.
214900     EXIT.
215000*
215100 Y800-SET-CURSOR.
215200*
215300************************************************************
215400*    THIS ROUTINE IS PERFORMED IF IN ADD OR MAINTENANCE    *
215500*    AND SETS THE CURSOR TO THE FIRST FIELD WHICH IS       *
215600*    OPEN FOR INPUT                                        *
215700************************************************************
215800*
215900     MOVE MMSMTB-USER-DATA-1-DESC (1:4)
216000                                 TO WS-INDEX-X.
216100     SET X-MMFS-STORE            TO WS-INDEX.
216200     SET X-MMSMTB-FIELD          TO WS-INDEX.
216300*
216400 Y801-SC-LOOP.
216500*
216600     IF  MMSMTB-FIELD-NAME (X-MMSMTB-FIELD) IS EQUAL TO SPACES
216700     AND MMSMTB-INDEX (X-MMSMTB-FIELD) IS LESS THAN 160
216800         SET X-MMFS-STORE        UP BY 1
216900         SET X-MMSMTB-FIELD      UP BY 1
217000         GO TO Y801-SC-LOOP.
217100*
217200     IF  MBCA-PTI-FUNCTION-IS-ADD
217300         IF  MMFS-ST-OPTIONAL (X-MMFS-STORE)
217400         OR  MMFS-ST-REQUIRED (X-MMFS-STORE)
217500             GO TO Y802-SC-DETERMINE-FIELD.
217600*
217700     IF  MBCA-PTI-FUNCTION-IS-MAINT
217800         IF  MMFS-ST-MAINT-ALLOWED (X-MMFS-STORE)
217900             GO TO Y802-SC-DETERMINE-FIELD.
218000*
218100     MOVE MMSMTB-VI-DBA-NAME (1:4)
218200                                 TO WS-INDEX-X.
218300     IF  X-MMFS-STORE IS LESS THAN WS-INDEX
218400         SET X-MMFS-STORE        UP BY 1
218500         SET X-MMSMTB-FIELD      UP BY 1
218600         GO TO Y801-SC-LOOP.
218700*
218800 Y802-SC-DETERMINE-FIELD.
218900*
219000     MOVE MMSMTB-VI-DBA-NAME (1:4)
219100                                 TO WS-INDEX-X.
219200     IF  X-MMFS-STORE IS EQUAL TO WS-INDEX
219300         MOVE SS08WS-CURSOR      TO MS06-ALT-TRANID-L
219400         GO TO Y809-SC-EXIT.
219500
219600     SET WS-FIELD-POSITION       TO X-MMFS-STORE.
219700     MOVE MMSMTB-CUSTOMER-MSG-3 (1:4)
219800                                 TO WS-INDEX-X.
219900     SUBTRACT WS-INDEX           FROM WS-FIELD-POSITION.
220000
220100     GO TO   Y803-USER-DATA-1-TITLE
220200             Y803-USER-DATA-1
220300             Y803-USER-DATA-2-TITLE
220400             Y803-USER-DATA-2
220500             Y803-USER-DATA-3-TITLE
220600             Y803-USER-DATA-3
220700             Y803-USER-DATA-4-TITLE
220800             Y803-USER-DATA-4
220900             Y803-USER-DATA-5-TITLE
221000             Y803-USER-DATA-5
221100             Y803-USER-DATA-6-TITLE
221200             Y803-USER-DATA-6
221300             Y803-USER-DATA-7-TITLE
221400             Y803-USER-DATA-7
221500             Y803-USER-DATA-8-TITLE
221600             Y803-USER-DATA-8
221700             Y803-USER-DATE-1-TITLE
221800             Y803-USER-DATE-1
221900             Y803-USER-DATE-2-TITLE
222000             Y803-USER-DATE-2
222100             Y803-USER-DATE-3-TITLE
222200             Y803-USER-DATE-3
222300             Y803-USER-DATE-4-TITLE
222400             Y803-USER-DATE-4
222500             Y803-USER-DATE-5-TITLE
222600             Y803-USER-DATE-5
222700             Y803-USER-DATE-6-TITLE
222800             Y803-USER-DATE-6
222900             Y803-USER-DATE-7-TITLE
223000             Y803-USER-DATE-7
223100             Y803-USER-DATE-8-TITLE
223200             Y803-USER-DATE-8
223300             Y803-USER-AMT-1-TITLE
223400             Y803-USER-AMT-1
223500             Y803-USER-AMT-2-TITLE
223600             Y803-USER-AMT-2
223700             Y803-USER-AMT-3-TITLE
223800             Y803-USER-AMT-3
223900             Y803-USER-AMT-4-TITLE
224000             Y803-USER-AMT-4
224100             Y803-USER-AMT-5-TITLE
224200             Y803-USER-AMT-5
224300             Y803-USER-AMT-6-TITLE
224400             Y803-USER-AMT-6
224500             Y803-USER-AMT-7-TITLE
224600             Y803-USER-AMT-7
224700             Y803-USER-AMT-8-TITLE
224800             Y803-USER-AMT-8
224900         DEPENDING ON WS-FIELD-POSITION.
225000*
225100 Y803-USER-DATA-1-TITLE.
225200*
225300     SET  X-MS06-USER-DATA       TO 1.
225400     MOVE SS08WS-CURSOR          TO MS06-USER-DATA-TITLE-L
225500                                    (X-MS06-USER-DATA).
225600     GO TO Y809-SC-EXIT.
225700*
225800 Y803-USER-DATA-1.
225900*
226000     SET  X-MS06-USER-DATA       TO 1.
226100     MOVE SS08WS-CURSOR          TO MS06-USER-DATA-L
226200                                    (X-MS06-USER-DATA).
226300     GO TO Y809-SC-EXIT.
226400*
226500 Y803-USER-DATA-2-TITLE.
226600*
226700     SET  X-MS06-USER-DATA       TO 2.
226800     MOVE SS08WS-CURSOR          TO MS06-USER-DATA-TITLE-L
226900                                    (X-MS06-USER-DATA).
227000     GO TO Y809-SC-EXIT.
227100*
227200 Y803-USER-DATA-2.
227300*
227400     SET  X-MS06-USER-DATA       TO 2.
227500     MOVE SS08WS-CURSOR          TO MS06-USER-DATA-L
227600                                    (X-MS06-USER-DATA).
227700     GO TO Y809-SC-EXIT.
227800*
227900 Y803-USER-DATA-3-TITLE.
228000*
228100     SET  X-MS06-USER-DATA       TO 3.
228200     MOVE SS08WS-CURSOR          TO MS06-USER-DATA-TITLE-L
228300                                    (X-MS06-USER-DATA).
228400     GO TO Y809-SC-EXIT.
228500*
228600 Y803-USER-DATA-3.
228700*
228800     SET  X-MS06-USER-DATA       TO 3.
228900     MOVE SS08WS-CURSOR          TO MS06-USER-DATA-L
229000                                    (X-MS06-USER-DATA).
229100     GO TO Y809-SC-EXIT.
229200*
229300 Y803-USER-DATA-4-TITLE.
229400*
229500     SET  X-MS06-USER-DATA       TO 4.
229600     MOVE SS08WS-CURSOR          TO MS06-USER-DATA-TITLE-L
229700                                    (X-MS06-USER-DATA).
229800     GO TO Y809-SC-EXIT.
229900*
230000 Y803-USER-DATA-4.
230100*
230200     SET  X-MS06-USER-DATA       TO 4.
230300     MOVE SS08WS-CURSOR          TO MS06-USER-DATA-L
230400                                    (X-MS06-USER-DATA).
230500     GO TO Y809-SC-EXIT.
230600*
230700 Y803-USER-DATA-5-TITLE.
230800*
230900     SET  X-MS06-USER-DATA       TO 5.
231000     MOVE SS08WS-CURSOR          TO MS06-USER-DATA-TITLE-L
231100                                    (X-MS06-USER-DATA).
231200     GO TO Y809-SC-EXIT.
231300*
231400 Y803-USER-DATA-5.
231500*
231600     SET  X-MS06-USER-DATA       TO 5.
231700     MOVE SS08WS-CURSOR          TO MS06-USER-DATA-L
231800                                    (X-MS06-USER-DATA).
231900     GO TO Y809-SC-EXIT.
232000*
232100 Y803-USER-DATA-6-TITLE.
232200*
232300     SET  X-MS06-USER-DATA       TO 6.
232400     MOVE SS08WS-CURSOR          TO MS06-USER-DATA-TITLE-L
232500                                    (X-MS06-USER-DATA).
232600     GO TO Y809-SC-EXIT.
232700*
232800 Y803-USER-DATA-6.
232900*
233000     SET  X-MS06-USER-DATA       TO 6.
233100     MOVE SS08WS-CURSOR          TO MS06-USER-DATA-L
233200                                    (X-MS06-USER-DATA).
233300     GO TO Y809-SC-EXIT.
233400*
233500 Y803-USER-DATA-7-TITLE.
233600*
233700     SET  X-MS06-USER-DATA       TO 7.
233800     MOVE SS08WS-CURSOR          TO MS06-USER-DATA-TITLE-L
233900                                    (X-MS06-USER-DATA).
234000     GO TO Y809-SC-EXIT.
234100*
234200 Y803-USER-DATA-7.
234300*
234400     SET  X-MS06-USER-DATA       TO 7.
234500     MOVE SS08WS-CURSOR          TO MS06-USER-DATA-L
234600                                    (X-MS06-USER-DATA).
234700     GO TO Y809-SC-EXIT.
234800*
234900 Y803-USER-DATA-8-TITLE.
235000*
235100     SET  X-MS06-USER-DATA       TO 8.
235200     MOVE SS08WS-CURSOR          TO MS06-USER-DATA-TITLE-L
235300                                    (X-MS06-USER-DATA).
235400     GO TO Y809-SC-EXIT.
235500*
235600 Y803-USER-DATA-8.
235700*
235800     SET  X-MS06-USER-DATA       TO 8.
235900     MOVE SS08WS-CURSOR          TO MS06-USER-DATA-L
236000                                    (X-MS06-USER-DATA).
236100     GO TO Y809-SC-EXIT.
236200*
236300 Y803-USER-DATE-1-TITLE.
236400*
236500     SET  X-MS06-USER-DATE       TO 1.
236600     MOVE SS08WS-CURSOR          TO MS06-USER-DATE-TITLE-L
236700                                    (X-MS06-USER-DATE).
236800     GO TO Y809-SC-EXIT.
236900*
237000 Y803-USER-DATE-1.
237100*
237200     SET  X-MS06-USER-DATE       TO 1.
237300     MOVE SS08WS-CURSOR          TO MS06-USER-DATE-L
237400                                    (X-MS06-USER-DATE).
237500     GO TO Y809-SC-EXIT.
237600*
237700 Y803-USER-DATE-2-TITLE.
237800*
237900     SET  X-MS06-USER-DATE       TO 2.
238000     MOVE SS08WS-CURSOR          TO MS06-USER-DATE-TITLE-L
238100                                    (X-MS06-USER-DATE).
238200     GO TO Y809-SC-EXIT.
238300*
238400 Y803-USER-DATE-2.
238500*
238600     SET  X-MS06-USER-DATE       TO 2.
238700     MOVE SS08WS-CURSOR          TO MS06-USER-DATE-L
238800                                    (X-MS06-USER-DATE).
238900     GO TO Y809-SC-EXIT.
239000*
239100 Y803-USER-DATE-3-TITLE.
239200*
239300     SET  X-MS06-USER-DATE       TO 3.
239400     MOVE SS08WS-CURSOR          TO MS06-USER-DATE-TITLE-L
239500                                    (X-MS06-USER-DATE).
239600     GO TO Y809-SC-EXIT.
239700*
239800 Y803-USER-DATE-3.
239900*
240000     SET  X-MS06-USER-DATE       TO 3.
240100     MOVE SS08WS-CURSOR          TO MS06-USER-DATE-L
240200                                    (X-MS06-USER-DATE).
240300     GO TO Y809-SC-EXIT.
240400*
240500 Y803-USER-DATE-4-TITLE.
240600*
240700     SET  X-MS06-USER-DATE       TO 4.
240800     MOVE SS08WS-CURSOR          TO MS06-USER-DATE-TITLE-L
240900                                    (X-MS06-USER-DATE).
241000     GO TO Y809-SC-EXIT.
241100*
241200 Y803-USER-DATE-4.
241300*
241400     SET  X-MS06-USER-DATE       TO 4.
241500     MOVE SS08WS-CURSOR          TO MS06-USER-DATE-L
241600                                    (X-MS06-USER-DATE).
241700     GO TO Y809-SC-EXIT.
241800*
241900 Y803-USER-DATE-5-TITLE.
242000*
242100     SET  X-MS06-USER-DATE       TO 5.
242200     MOVE SS08WS-CURSOR          TO MS06-USER-DATE-TITLE-L
242300                                    (X-MS06-USER-DATE).
242400     GO TO Y809-SC-EXIT.
242500*
242600 Y803-USER-DATE-5.
242700*
242800     SET  X-MS06-USER-DATE       TO 5.
242900     MOVE SS08WS-CURSOR          TO MS06-USER-DATE-L
243000                                    (X-MS06-USER-DATE).
243100     GO TO Y809-SC-EXIT.
243200*
243300 Y803-USER-DATE-6-TITLE.
243400*
243500     SET  X-MS06-USER-DATE       TO 6.
243600     MOVE SS08WS-CURSOR          TO MS06-USER-DATE-TITLE-L
243700                                    (X-MS06-USER-DATE).
243800     GO TO Y809-SC-EXIT.
243900*
244000 Y803-USER-DATE-6.
244100*
244200     SET  X-MS06-USER-DATE       TO 6.
244300     MOVE SS08WS-CURSOR          TO MS06-USER-DATE-L
244400                                    (X-MS06-USER-DATE).
244500     GO TO Y809-SC-EXIT.
244600*
244700 Y803-USER-DATE-7-TITLE.
244800*
244900     SET  X-MS06-USER-DATE       TO 7.
245000     MOVE SS08WS-CURSOR          TO MS06-USER-DATE-TITLE-L
245100                                    (X-MS06-USER-DATE).
245200     GO TO Y809-SC-EXIT.
245300*
245400 Y803-USER-DATE-7.
245500*
245600     SET  X-MS06-USER-DATE       TO 7.
245700     MOVE SS08WS-CURSOR          TO MS06-USER-DATE-L
245800                                    (X-MS06-USER-DATE).
245900     GO TO Y809-SC-EXIT.
246000*
246100 Y803-USER-DATE-8-TITLE.
246200*
246300     SET  X-MS06-USER-DATE       TO 8.
246400     MOVE SS08WS-CURSOR          TO MS06-USER-DATE-TITLE-L
246500                                    (X-MS06-USER-DATE).
246600     GO TO Y809-SC-EXIT.
246700*
246800 Y803-USER-DATE-8.
246900*
247000     SET  X-MS06-USER-DATE       TO 8.
247100     MOVE SS08WS-CURSOR          TO MS06-USER-DATE-L
247200                                    (X-MS06-USER-DATE).
247300     GO TO Y809-SC-EXIT.
247400*
247500 Y803-USER-AMT-1-TITLE.
247600*
247700     SET  X-MS06-USER-AMT        TO 1.
247800     MOVE SS08WS-CURSOR          TO MS06-USER-AMT-TITLE-L
247900                                    (X-MS06-USER-AMT).
248000     GO TO Y809-SC-EXIT.
248100*
248200 Y803-USER-AMT-1.
248300*
248400     SET  X-MS06-USER-AMT        TO 1.
248500     MOVE SS08WS-CURSOR          TO MS06-USER-AMT-L
248600                                    (X-MS06-USER-AMT).
248700     GO TO Y809-SC-EXIT.
248800*
248900 Y803-USER-AMT-2-TITLE.
249000*
249100     SET  X-MS06-USER-AMT        TO 2.
249200     MOVE SS08WS-CURSOR          TO MS06-USER-AMT-TITLE-L
249300                                    (X-MS06-USER-AMT).
249400     GO TO Y809-SC-EXIT.
249500*
249600 Y803-USER-AMT-2.
249700*
249800     SET  X-MS06-USER-AMT        TO 2.
249900     MOVE SS08WS-CURSOR          TO MS06-USER-AMT-L
250000                                    (X-MS06-USER-AMT).
250100     GO TO Y809-SC-EXIT.
250200*
250300 Y803-USER-AMT-3-TITLE.
250400*
250500     SET  X-MS06-USER-AMT        TO 3.
250600     MOVE SS08WS-CURSOR          TO MS06-USER-AMT-TITLE-L
250700                                    (X-MS06-USER-AMT).
250800     GO TO Y809-SC-EXIT.
250900*
251000 Y803-USER-AMT-3.
251100*
251200     SET  X-MS06-USER-AMT        TO 3.
251300     MOVE SS08WS-CURSOR          TO MS06-USER-AMT-L
251400                                    (X-MS06-USER-AMT).
251500     GO TO Y809-SC-EXIT.
251600*
251700 Y803-USER-AMT-4-TITLE.
251800*
251900     SET  X-MS06-USER-AMT        TO 4.
252000     MOVE SS08WS-CURSOR          TO MS06-USER-AMT-TITLE-L
252100                                    (X-MS06-USER-AMT).
252200     GO TO Y809-SC-EXIT.
252300*
252400 Y803-USER-AMT-4.
252500*
252600     SET  X-MS06-USER-AMT        TO 4.
252700     MOVE SS08WS-CURSOR          TO MS06-USER-AMT-L
252800                                    (X-MS06-USER-AMT).
252900     GO TO Y809-SC-EXIT.
253000*
253100 Y803-USER-AMT-5-TITLE.
253200*
253300     SET  X-MS06-USER-AMT        TO 5.
253400     MOVE SS08WS-CURSOR          TO MS06-USER-AMT-TITLE-L
253500                                    (X-MS06-USER-AMT).
253600     GO TO Y809-SC-EXIT.
253700*
253800 Y803-USER-AMT-5.
253900*
254000     SET  X-MS06-USER-AMT        TO 5.
254100     MOVE SS08WS-CURSOR          TO MS06-USER-AMT-L
254200                                    (X-MS06-USER-AMT).
254300     GO TO Y809-SC-EXIT.
254400*
254500 Y803-USER-AMT-6-TITLE.
254600*
254700     SET  X-MS06-USER-AMT        TO 6.
254800     MOVE SS08WS-CURSOR          TO MS06-USER-AMT-TITLE-L
254900                                    (X-MS06-USER-AMT).
255000     GO TO Y809-SC-EXIT.
255100*
255200 Y803-USER-AMT-6.
255300*
255400     SET  X-MS06-USER-AMT        TO 6.
255500     MOVE SS08WS-CURSOR          TO MS06-USER-AMT-L
255600                                    (X-MS06-USER-AMT).
255700     GO TO Y809-SC-EXIT.
255800*
255900 Y803-USER-AMT-7-TITLE.
256000*
256100     SET  X-MS06-USER-AMT        TO 7.
256200     MOVE SS08WS-CURSOR          TO MS06-USER-AMT-TITLE-L
256300                                    (X-MS06-USER-AMT).
256400     GO TO Y809-SC-EXIT.
256500*
256600 Y803-USER-AMT-7.
256700*
256800     SET  X-MS06-USER-AMT        TO 7.
256900     MOVE SS08WS-CURSOR          TO MS06-USER-AMT-L
257000                                    (X-MS06-USER-AMT).
257100     GO TO Y809-SC-EXIT.
257200*
257300 Y803-USER-AMT-8-TITLE.
257400*
257500     SET  X-MS06-USER-AMT        TO 8.
257600     MOVE SS08WS-CURSOR          TO MS06-USER-AMT-TITLE-L
257700                                    (X-MS06-USER-AMT).
257800     GO TO Y809-SC-EXIT.
257900*
258000 Y803-USER-AMT-8.
258100*
258200     SET  X-MS06-USER-AMT        TO 8.
258300     MOVE SS08WS-CURSOR          TO MS06-USER-AMT-L
258400                                    (X-MS06-USER-AMT).
258500     GO TO Y809-SC-EXIT.
258600*
258700 Y809-SC-EXIT.
258800     EXIT.
258900*
259000 Y900-READ-MMSM.
259100*
259200*****************************************
259300*    READ THE STORE MASTER RECORD       *
259400*****************************************
259500*
259600     MOVE MBCA-MERCHANT-ORG      TO MBIOWS-MMSM-ORG
259700                                    MS06-ORG.
259800     MOVE MBCA-STORE             TO MBIOWS-MMSM-STORE
259900                                    MS06-STORE.
260000     SET MBIORO-READ-RANDOM      TO TRUE.
260100     PERFORM MMSMAO-ACCESS       THRU MMSMAO-ACCESS-EXIT.
260200*
260300 Y909-READ-MMSM-EXIT.
260400     EXIT.
260500*
260600 Y910-READ-MMFS.
260700*
260800****************************************
260900*    READ THE FIELD SECURITY RECORD    *
261000*    TO OBTAIN THE SECURITY CODES      *
261100****************************************
261200*
261300     MOVE MBCA-MERCHANT-ORG      TO MBIOWS-MMFS-ORG.
261400     MOVE MBCA-FIELD-SECURITY    TO MBIOWS-MMFS-FS-CODE.
261500     SET MBIORO-READ-RANDOM      TO TRUE.
261600     PERFORM MMFSAO-ACCESS       THRU MMFSAO-ACCESS-EXIT.
261700*
261800     IF  NOT MMFS-REC-ACTIVE
261900         MOVE MBIORO-IO-REQUEST  TO MBCA-ERRR-IO-REQUEST
262000         MOVE MBIORO-FILE-NAME   TO MBCA-ERRR-EIBDS
262100         MOVE EIBFN              TO MBCA-ERRR-EIBFN-CODES
262200         MOVE MBCA-PROGRAM-ID    TO MBCA-ERRR-BAD-PROGRAM
262300         MOVE MBCA-TRANS-ID      TO MBCA-ERRR-BAD-TRANSID
262400         SET MBCA-ERROR-MSGS-PROVIDED
262500                                 TO TRUE
262600         MOVE 'READ ERROR - MMFSAO'
262700                                 TO MBCA-ERRR-MSG1
262800         MOVE 'FIELDS SECURITY PROFILE IS NOT ACTIVE'
262900                                 TO MBCA-ERRR-MSG2
263000         GO TO MB70PD-ERROR-ROUTINE.
263100*
263200 Y919-READ-MMFS-EXIT.
263300     EXIT.
263400*
263500 Y920-WRITE-LOG-RECORD.
263600*
263700     SET MBIORO-WRITE            TO TRUE.
263800     PERFORM MML1AO-ACCESS       THRU MML1AO-ACCESS-EXIT.
263900     MOVE SPACES                 TO MML1-VARIABLE-AREA.
264000*
264100 Y929-WLR-EXIT.
264200     EXIT.
264300/
264400 Z000-COPIED-ROUTINES SECTION.
264500*
264600*********************************
264700*    DATE VALIDATION ROUTINE    *
264800*********************************
264900*
265000     COPY SS05PD.
265100/
265200**********************************
265300*    GREG TO JUL DATE ROUTINE    *
265400**********************************
265500*
265600     COPY SS07PD.
265700/    NEW ROUTINE FOR JULIAN TO GREGORIAN CONVERSION
265800     COPY SS26PD.
265900*
266000/    ROUTINE TO NUMERICALLY EDIT TIME
266100     COPY SS27PD.
266200*
266300/    ROUTINE TO MOVE COMMAREA VARIABLES TO
266400*                    SS08-FORMATTED-MSG VARIABLE.
266500     COPY MB06PD.
266600*
266700/
266800**********************************
266900*    JUL TO GREG DATE ROUTINE    *
267000**********************************
267100*
267200     COPY SS08PD.
267300/
267400*********************************
267500*    LINE 24 PF KEYS ROUTINE    *
267600*********************************
267700*
267800     COPY SS15PD.
267900/
268000************************************************
268100*    STORE MASTER RECORD ACCESS ROUTINES       *
268200************************************************
268300*
268400     COPY MMSMAO.
268500/
268600***********************************************
268700*    FIELD SECURITY RECORD ACCESS ROUTINES    *
268800***********************************************
268900*
269000     COPY MMFSAO.
269100/
269200*****************************************
269300*    LOG FILE RECORD ACCESS ROUTINES    *
269400*****************************************
269500*
269600     COPY MML1AO.
269700/
269800*****************************
269900*    ONLINE MAP ROUTINES    *
270000*****************************
270100*
270200     COPY MB60PD REPLACING 'MBMAPXX' BY 'MBMS06 '
270300                           MBMAPXXI BY MBMS06I
270400                           MBMAPXXO BY MBMS06O.
270500/
270600***************************
270700*    ONLINE PROCEDURES    *
270800***************************
270900*
271000     COPY MB70PD.
271100/
271200     COPY SMFTPXO.
