000100 IDENTIFICATION DIVISION.
000200 PROGRAM-ID. MBOMS07.
000201*       RELEASE DATE=08/24/01.        REVISION LEVEL=08.06      * ++++++++
000202***************************************************************** ++++++++
000203*WARNING.  THIS COMPUTER PROGRAM IS PROTECTED BY COPYRIGHT LAW  * ++++++++
000204*AND INTERNATIONAL TREATIES.  UNAUTHORIZED REPRODUCTION OR      * ++++++++
000205*DISTRIBUTION OF THIS PROGRAM, OR ANY PORTION OF IT, MAY RESULT * ++++++++
000206*IN SEVERE CIVIL AND CRIMINAL PENATLIES, AND WILL BE PROSECUTED * ++++++++
000207*TO THE MAXIMUM EXTENT POSSIBLE UNDER THE LAW.                  * ++++++++
000208*COPYRIGHT 1999 PAYSYS INTERNATIONAL, INC.  ALL RIGHTS RESERVED.* ++++++++
000209***************************************************************** ++++++++
000300*****************************************************************
000400*                                                               *
000500*   V - PLUS  M E R C H A N T   B A N K C A R D   S Y S T E M   *
000600*                                                               *
000700*      MBOMS07 - STORE MASTER RECORD ADD/MAINT/INQ              *
000800*                SCREEN 07                                      *
000900*                                                               *
001000*              1. TRANSIDS                                      *
001100*                 A. MBAS                                       *
001200*                 B. MBMS                                       *
001300*                 C. MBQS                                       *
001400*              2. MAPS USED -                                   *
001500*                 A. MBMS07 (SCREEN 07)                         *
001600*              3. FILES USED -                                  *
001700*                 A. MMFS (FIELD SECURITY FILE)                 *
001800*                 B. MMSM (STORE MASTER FILE)                   *
001900*                 C. MMOC (ORG CONTROL RECORD)                  *
002000*                 D. MMMP (MERCH PRODUCT FILE)                  *
002100*                 E. MML1 (LOG FILE)                            *
002200*                                                               *
002300*****************************************************************
002400*
002500 ENVIRONMENT DIVISION.
002600*
002700 DATA DIVISION.
002800*
002900 WORKING-STORAGE SECTION.
003000*
003100 01  FILLER                  PIC  X(12)      VALUE '** WS-BEG **'.
003200*
003300 01  FILLER                  PIC  X(14)      VALUE
003400     'MISCELLANEOUS:'.
003500*
003600 01  WS-MISCELLANEOUS.
003700     03  WS-FIELD-POSITION   PIC S9(03)      VALUE ZEROES COMP-3.
003800     03  WS-INDEX-X.
003900         05  WS-INDEX        PIC  9(04)      VALUE ZEROS.
004000     03  WS-POS-MODE.
004100         05  WS-POS-MODE-1   PIC  X(01)      VALUE SPACES.
004200         05  WS-POS-MODE-2   PIC  X(01)      VALUE SPACES.
004300     03  TS-QUEUE-NAME.
004400         05  TS-QN-TERMID    PIC  X(04)      VALUE SPACES.
004500         05  TS-QN-TRANID    PIC  X(04)      VALUE 'MBUI'.
004600*
004700 01  FILLER                  PIC  X(17)      VALUE
004800     'PROGRAM SWITCHES:'.
004900*
005000 01  WS-PROGRAM-SWITCHES.
005100     03  WS-UPDATE-MMSM-SW   PIC  X(01)      VALUE 'N'.
005200         88  WS-UPDATE-MMSM-SW-YES           VALUE 'Y'.
005300         88  WS-UPDATE-MMSM-SW-NO            VALUE 'N'.
005400/
005500 01  FILLER                  PIC  X(29)      VALUE
005600     'I/O REQUEST BLOCK WORK AREAS:'.
005700*
005800     COPY MBIOWS.
005900/
006000 01  FILLER                  PIC  X(18)      VALUE
006100     'I/O REQUEST BLOCK:'.
006200*
006300     COPY MBIORO.
006400/
006500 01  FILLER                  PIC  X(25)      VALUE
006600     'LOG RECORD REQUEST BLOCK:'.
006700*
006800     COPY MML1WS REPLACING ==:MML1:== BY ==MML1==.
006900/
007000 01  FILLER                  PIC  X(26)      VALUE
007100     'STORE MASTER FIELDS TABLE:'.
007200*
007300     COPY MMSMTB.
007400/
007500 01  FILLER                  PIC  X(29)      VALUE
007600     'STORE INIT RECORD         '.
007700*
007800     COPY MMSMIR.
007900/
008000 01  FILLER                  PIC  X(20)      VALUE
008100     'CCS DATE WORK AREAS:'.
008200*
008300     COPY SS01WS.
008400/
008500 01  FILLER                  PIC  X(15)      VALUE
008600     'CCS WORK AREAS:'.
008700*
008800     COPY SS08WS.
008900/
009000     COPY SS00WS.
009100/
009200     COPY SMFTWS.
009300/
009400     COPY SMPTRL REPLACING ==:SMPT:== BY ==SMPT==.
009500/
009600     COPY MB61LK.
009700/
009800     COPY SMCAWS.
009900/
010000     COPY SMCARL.
010100/
010200     COPY SC00WS.
010300/
010400 01  FILLER                  PIC  X(12)      VALUE '** WS-END **'.
010500/
010600 LINKAGE SECTION.
010700*
010800 01  DFHCOMMAREA.
010900*
011000     COPY MB60WS.
011100/
011200*****************************
011300*    STORE MASTER MAP       *
011400*****************************
011500*
011600     COPY MBMS07.
011700/
011800******************************************
011900*    STORE MASTER MAP REDEFINITION       *
012000******************************************
012100*
012200     COPY MBMS07R.
012300/
012400************************************************
012500*    STORE MASTER RECORD LAYOUT                *
012600************************************************
012700*
012800     COPY MMSMRL.
012900/
013000************************************************
013100*    MERCHANT PRODUCT RECORD LAYOUT            *
013200************************************************
013300*
013400     COPY MMMPRL.
013500/
013600************************************************
013700*    ORG CONTROL  RECORD LAYOUT                *
013800************************************************
013900*
014000     COPY MMOCRL.
014100/
014200**************************************
014300*    FIELD SECURITY RECORD LAYOUT    *
014400**************************************
014500*
014600     COPY MMFSRL.
014700/
014800***************************
014900*    LOG RECORD LAYOUT    *
015000***************************
015100*
015200     COPY MML1RL REPLACING ==:MML1:== BY ==MML1==.
015300/
015400***************************************
015500*    USER INPUT TEMP STORAGE RECORD   *
015600***************************************
015700*
015800     COPY MBUITS.
015900/
016000 PROCEDURE DIVISION.
016100*
016200 A000-HOUSEKEEPING SECTION.
016300*
016400 A020-INIT.
016500*
016600     MOVE 'PC01'                 TO MBCA-PROGRAM-LOCATION.
016700     PERFORM MB70PD-ON-LINE-HOUSEKEEPING
016800                                 THRU MB70PD-OLH-EXIT.
016900*
017000     IF  MBCA-MBUI-UI-YES
017100         NEXT SENTENCE
017200     ELSE
017300         SET MBCA-MBUI-UI-NO     TO TRUE.
017400*
017500     MOVE MBCA-TERMINAL-ID       TO TS-QN-TERMID.
017600*
017700     IF  MBCA-RECEIVE-SCREEN
017800         GO TO C000-RECEIVE-SCREEN.
017900/
018000 B000-SEND-SCREEN SECTION.
018100*
018200*********************************************
018300*    GET CICS STORAGE NEEDED FOR THE MAP    *
018400*********************************************
018500*
018600     MOVE 'SC01'                 TO MBCA-PROGRAM-LOCATION.
018700     PERFORM MB60PD-GETMAIN-FOR-MAP
018800                                 THRU MB60PD-GFM-EXIT.
018900*
019000*******************************************
019100*    INITIALIZE THE STANDARD MAP LINES    *
019200*******************************************
019300*
019400     PERFORM MB60PD-INIT-STD-MAP-LINES
019500                                 THRU MB60PD-ISML-EXIT.
019600*
019700*****************************************
019800*    READ THE STORE MASTER FILE         *
019900*****************************************
020000*
020100     MOVE MBCA-MERCHANT-ORG      TO MBIOWS-MMSM-ORG
020200                                    MS07-ORG.
020300     MOVE MBCA-STORE             TO MBIOWS-MMSM-STORE
020400                                    MS07-STORE.
020500     MOVE 'FC01'                 TO MBCA-PROGRAM-LOCATION.
020600     SET MBIORO-READ-RANDOM      TO TRUE.
020700     PERFORM MMSMAO-ACCESS       THRU MMSMAO-ACCESS-EXIT.
020800*
020900*****************************************
021000*    EDIT FOR SINGLE STORE RECORD       *
021100*****************************************
021200*
021300     IF  MBCA-PTI-FUNCTION-IS-MAINT
021400     AND MMSM-REC-SINGLE-STORE
021500         MOVE 58                 TO MBCA-SCREEN-NBR
021600         MOVE 'PC09'             TO MBCA-PROGRAM-LOCATION
021700         PERFORM MB70PD-XCTL-TO-MBOXCTL
021800                                 THRU MB70PD-XTM-EXIT.
021900*
022000     MOVE MMSM-NA-LINE (1 1)     TO MS07-STORE-NAME.
022100*
022200*************************************************
022300*    IF VI-STATUS IS NOT ACTIVE GO TO NEXT PAGE *
022400*************************************************
022500*
022600     MOVE MBCA-MERCHANT-ORG      TO MBIOWS-MMMP-ORG.
022700     MOVE MMSM-MERCHANT-ID       TO MBIOWS-MMMP-MERCHANT.
022800     MOVE 01                     TO MBIOWS-MMMP-PRODUCT.
022900     MOVE SS08WS-CICS-FC-NOTFND  TO MBIORO-TEMP-STATUS-1.
023000     MOVE 'FC02'                 TO MBCA-PROGRAM-LOCATION.
023100     SET MBIORO-READ-RANDOM      TO TRUE.
023200     PERFORM MMMPAO-ACCESS       THRU MMMPAO-ACCESS-EXIT.
023300*
023400     IF  SS08WS-RC-FC-NOTFND
023500         MOVE 58                TO MBCA-SCREEN-NBR
023600         MOVE 'PC02'            TO MBCA-PROGRAM-LOCATION
023700         PERFORM MB70PD-XCTL-TO-MBOXCTL
023800                                 THRU MB70PD-XTM-EXIT
023900     ELSE
024000         IF  NOT MMMP-PROD-ACTIVE
024100             MOVE 58            TO MBCA-SCREEN-NBR
024200             MOVE 'PC02'        TO MBCA-PROGRAM-LOCATION
024300             PERFORM MB70PD-XCTL-TO-MBOXCTL
024400                                 THRU MB70PD-XTM-EXIT.
024500*
024600*****************************************
024700*    READ THE ORG CONTROL MASTER FILE   *
024800*****************************************
024900*
025000     MOVE MBCA-MERCHANT-ORG      TO MBIOWS-MMOC-ORG.
025100     MOVE 'FC03'                 TO MBCA-PROGRAM-LOCATION.
025200     SET MBIORO-READ-RANDOM      TO TRUE.
025300     PERFORM MMOCAO-ACCESS       THRU MMOCAO-ACCESS-EXIT.
025400*
025500****************************************
025600*    READ THE FIELD SECURITY RECORD    *
025700****************************************
025800*
025900     MOVE 'FC04'                 TO MBCA-PROGRAM-LOCATION.
026000     PERFORM Y900-READ-MMFS      THRU Y909-READ-MMFS-EXIT.
026100*
026200 B020-MOVE-FIELDS-TO-SCREEN.
026300*
026400*****************************************
026500*    MOVE THE MERCHANT MASTER FIELDS    *
026600*    FROM THE RECORD TO THE SCREEN      *
026700*****************************************
026800*
026900*
027000     PERFORM Y060-MOVE-DBA-NAME
027100                                 THRU Y069-EXIT.
027200*
027300     PERFORM Y100-MOVE-INTCHG-IND
027400                                 THRU Y109-EXIT.
027500*
027600     PERFORM Y120-MOVE-VISA-MEMBER-ID
027700                                 THRU Y129-EXIT.
027800*
027900     PERFORM Y140-MOVE-SPECIAL-COND-1
028000                                 THRU Y149-EXIT.
028100*
028200     PERFORM Y160-MOVE-SPECIAL-COND-2
028300                                 THRU Y169-EXIT.
028400*
028500     PERFORM Y180-MOVE-MAIL-PHONE-IND
028600                                 THRU Y189-EXIT.
028700*
028800     PERFORM Y200-MOVE-CH-TERM-IND
028900                                 THRU Y209-EXIT.
029000*
029100     PERFORM Y280-MOVE-RPT-THSHOLD
029200                                 THRU Y289-EXIT.
029210*                                                                 RG802901
029220     PERFORM Y300-MOVE-CONTACT-IND                                RG802901
029230                                 THRU Y309-EXIT.                  RG802901
029300*
029400     PERFORM Y320-MOVE-CRB-REGION
029500                                 THRU Y329-EXIT.
029600*
029700     PERFORM Y340-MOVE-REG-ADDR-IND1
029800                                 THRU Y349-EXIT.
029900*
030000     PERFORM Y360-MOVE-REG-ADDR-IND2
030100                                 THRU Y369-EXIT.
030200*
030300     PERFORM Y380-MOVE-CATEGORY-CODE
030400                                 THRU Y389-EXIT.
030500*
030600     PERFORM Y400-MOVE-FLOOR-LIMIT
030700                                 THRU Y409-EXIT.
030800*
030900     PERFORM Y440-MOVE-VOLUME-IND
031000                                 THRU Y449-EXIT.
031010*                                                                 RG800914
031020     PERFORM Y460-MOVE-SVC-DVLP-IND                               RG800914
031030                                 THRU Y469-EXIT.                  RG800914
031100*
031200******************************************
031300*    SET THE CURSOR AND SCREEN NUMBER    *
031400******************************************
031500*
031600     IF  MBCA-PTI-FUNCTION-IS-INQUIRY
031700         MOVE SS08WS-CURSOR      TO MS07-ALT-TRANID-L
031800     ELSE
031900         PERFORM Y800-SET-CURSOR THRU Y809-SC-EXIT.
032000*
032100     COMPUTE MBCA-SCREEN-NBR     =  MBCA-SCREEN-NBR - 50.
032200*
032300***********************************************************
032400*    SET THE CURRENCY CODE, CURRENCY NOD
032500*            PER ITEM NOD, PERCENT NOD.
032600***********************************************************
032700     IF MS07-ERROR-MESSAGE IS EQUAL TO SPACES OR LOW-VALUES
032800        PERFORM MB06PD-FORMAT-MESSAGE-LINE
032900                                 THRU MB06PD-FML-EXIT
033000        MOVE SS08WS-FORMATTED-MSG   TO MS07-ERROR-MESSAGE
033100     END-IF.
033200*
033300**********************
033400*    SEND THE MAP    *
033500**********************
033600*
033700     MOVE 'BM01'                 TO MBCA-PROGRAM-LOCATION.
033800     PERFORM MB60PD-SEND-MAP-WITH-ERASE
033900                                 THRU MB60PD-SMWE-EXIT.
034000*
034100************************
034200*    RETURN TO CICS    *
034300************************
034400*
034500     MOVE 'PC03'                 TO MBCA-PROGRAM-LOCATION.
034600     PERFORM MB70PD-RETURN-TRANS-ID
034700                                 THRU MB70PD-RTI-EXIT.
034800/
034900 C000-RECEIVE-SCREEN SECTION.
035000*
035100******************************************
035200*    THIS SECTION RECEIVES THE SCREEN    *
035300******************************************
035400*
035500     IF  MBCA-MBUI-UI-YES
035600*
035700****************************************************************
035800*    ACQUIRE MAIN STORAGE FOR TEMP STORAGE RECORD              *
035900****************************************************************
036000*
036100         MOVE 'TS01'             TO MBCA-PROGRAM-LOCATION
036200         EXEC CICS GETMAIN
036300                   FLENGTH (LENGTH  OF MBUITS-RECORD)
036400
036500                   SET     (ADDRESS OF MBUITS-RECORD)
036600
036700              END-EXEC
036800*
036900***********************************************
037000*    READ THE TEMP STORAGE RECORD             *
037100***********************************************
037200*
037300         MOVE 'TS02'             TO MBCA-PROGRAM-LOCATION
037400*
037500         EXEC CICS READQ TS
037600                   QUEUE   (TS-QUEUE-NAME)
037700                   INTO    (MBUITS-RECORD)
037800                   LENGTH  (LENGTH  OF MBUITS-RECORD)
037900                   ITEM    (1)
038000              END-EXEC
038100*
038200***********************************************
038300*    DELETE THE TEMP STORAGE RECORD           *
038400***********************************************
038500*
038600         MOVE 'TS03'             TO MBCA-PROGRAM-LOCATION
038700*
038800         EXEC CICS IGNORE CONDITION
038900                   QIDERR
039000              END-EXEC
039100*
039200         EXEC CICS DELETEQ TS
039300                   QUEUE  (TS-QUEUE-NAME)
039400              END-EXEC
039500         MOVE 'SC02'             TO MBCA-PROGRAM-LOCATION
039600         PERFORM MB60PD-GETMAIN-FOR-MAP
039700                                 THRU MB60PD-GFM-EXIT
039800         MOVE MBUITS-VAR-DATA    TO MBMS07I
039900     ELSE
040000         MOVE 'BM02'             TO MBCA-PROGRAM-LOCATION
040100         PERFORM MB60PD-RECEIVE-MAP
040200                                 THRU MB60PD-RM-EXIT.
040300*
040400**************************************************************
040500*    CHECK FOR ANOTHER TRANSACTION ID ENTERED BY THE USER    *
040600**************************************************************
040700*
040800     MOVE 'PC04'                 TO MBCA-PROGRAM-LOCATION.
040900     PERFORM MB60PD-NEW-TRANS-ROUTINE
041000                                 THRU MB60PD-NTR-EXIT.
041100*
041200****************************************************
041300*    BYPASS ALL SCREEN EDITS IF THIS IS INQIURY    *
041400****************************************************
041500*
041600     IF  MBCA-PTI-FUNCTION-IS-INQUIRY
041700         GO TO F000-SETUP-COMMAREA.
041800*
041900************************************************
042000*    READ THE STORE MASTER RECORD              *
042100************************************************
042200*
042300*
042400     IF  MBCA-PTI-FUNCTION-IS-ADD
042500     AND MBCA-MBUI-UI-YES
042600     AND MBCA-MBUI-UI-UPDATE-NO
042700         MOVE 'SC03'             TO MBCA-PROGRAM-LOCATION
042800         SET MBIORO-GETMAIN      TO TRUE
042900         PERFORM MMSMAO-ACCESS   THRU MMSMAO-ACCESS-EXIT
043000         MOVE MMSMIR-RECORD      TO MMSM-RECORD
043100     ELSE
043200         MOVE SS08WS-CICS-FC-NOTFND TO MBIORO-TEMP-STATUS-1
043300         MOVE MBCA-MERCHANT-ORG  TO MBIOWS-MMSM-ORG
043400                                    MS07-ORG
043500         MOVE MBCA-STORE         TO MBIOWS-MMSM-STORE
043600                                    MS07-STORE
043700         MOVE 'FC05'             TO MBCA-PROGRAM-LOCATION
043800         SET MBIORO-READ-RANDOM  TO TRUE
043900         PERFORM MMSMAO-ACCESS   THRU MMSMAO-ACCESS-EXIT
044000         IF  SS08WS-RC-FC-NOTFND
044100         AND MBCA-MBUI-UI-YES
044200             MOVE 'MBUI'         TO MBCA-TRANS-ID
044300                                    MBCA-PREV-TRANS-ID
044400             MOVE 01             TO MBCA-SCREEN-NBR
044500             MOVE 'STR'          TO MS07-FILLER
044600             SET MBCA-MBUI-ERROR-YES
044700                                 TO TRUE
044800             GO TO F000-SETUP-COMMAREA.
044900*
045000     IF (MBCA-PTI-FUNCTION-IS-MAINT
045100     AND MBCA-MBUI-UI-YES
045200     AND (MMSM-REC-PURGED
045300       OR MMSM-REC-INCOMPLETE))
045400     OR
045500        (MBCA-PTI-FUNCTION-IS-ADD
045600     AND MBCA-MBUI-UI-YES
045700     AND MMSM-REC-PURGED)
045800         MOVE 'MBUI'             TO MBCA-TRANS-ID
045900                                    MBCA-PREV-TRANS-ID
046000         MOVE 01                 TO MBCA-SCREEN-NBR
046100         MOVE 'STR'              TO MS07-FILLER
046200         SET MBCA-MBUI-ERROR-YES
046300                                 TO TRUE
046400         GO TO F000-SETUP-COMMAREA.
046500*
046600*****************************************
046700*    READ THE ORG CONTROL MASTER FILE   *
046800*****************************************
046900*
047000     MOVE MBCA-MERCHANT-ORG      TO MBIOWS-MMOC-ORG.
047100     MOVE 'FC06'                 TO MBCA-PROGRAM-LOCATION.
047200     SET MBIORO-READ-RANDOM      TO TRUE.
047300     PERFORM MMOCAO-ACCESS       THRU MMOCAO-ACCESS-EXIT.
047400*
047500****************************************
047600*    READ THE FIELD SECURITY RECORD    *
047700****************************************
047800*
047900     MOVE 'FC07'                 TO MBCA-PROGRAM-LOCATION.
048000     PERFORM Y900-READ-MMFS      THRU Y909-READ-MMFS-EXIT.
048100*
048200 C020-FIELD-EDITS.
048300*
048400*********************
048500*    FIELD EDITS    *
048600*********************
048700*
048800     PERFORM W060-EDIT-DBA-NAME  THRU W069-EXIT.
048900*
049000     PERFORM W100-EDIT-INTCHG-IND
049100                                 THRU W109-EXIT.
049200*
049300     PERFORM W120-EDIT-VISA-MEMBER-ID
049400                                 THRU W129-EXIT.
049500*
049600     PERFORM W140-EDIT-SPECIAL-COND-1
049700                                 THRU W149-EXIT.
049800*
049900     PERFORM W160-EDIT-SPECIAL-COND-2
050000                                 THRU W169-EXIT.
050100*
050200     PERFORM W180-EDIT-MAIL-PHONE-IND
050300                                 THRU W189-EXIT.
050400*
050500     PERFORM W200-EDIT-CH-ACCT-IND
050600                                 THRU W209-EXIT.
050700*
050800     PERFORM W280-EDIT-RPT-THRESHOLD
050900                                 THRU W289-EXIT.
050910*                                                                 RG802901
050920     PERFORM W300-EDIT-CONTACT-IND                                RG802901
050930                                 THRU W309-EXIT.                  RG802901
051000*
051100     PERFORM W320-EDIT-CRB-REGION
051200                                 THRU W329-EXIT.
051300*
051400     PERFORM W340-EDIT-REG-ADDR-IND1
051500                                 THRU W349-EXIT.
051600*
051700     PERFORM W360-EDIT-REG-ADDR-IND2
051800                                 THRU W369-EXIT.
051900*
052000     PERFORM W380-EDIT-CATEGORY  THRU W389-EXIT.
052100*
052200     PERFORM W400-EDIT-FLOOR-LIMIT
052300                                 THRU W409-EXIT.
052400*
052500     PERFORM W440-EDIT-VOLUME-IND
052600                                 THRU W449-EXIT.
052620*                                                                 RG800914
052622     PERFORM W450-EDIT-SVC-DVLP-IND                               RG800914
052624                                 THRU W459-EXIT.                  RG800914
052700*
052800     PERFORM W420-CROSS-EDIT-MPEC-IND
052900                                 THRU W429-EXIT.
053000*                                                                 RG802901
053100     PERFORM W460-CROSS-EDIT-CONTACT-IND                          RG802901
053200                                 THRU W469-EXIT.                  RG802901
053300/
053400 D000-RETURN-ERRORS SECTION.
053500*
053600     IF  SS08WS-ERROR-SW-NO
053700         GO TO E000-UPDATE-FILE.
053800*
053900     IF  MBCA-MBUI-UI-YES
054000         MOVE 'MBUI'             TO MBCA-TRANS-ID
054100                                    MBCA-PREV-TRANS-ID
054200         MOVE 01                 TO MBCA-SCREEN-NBR
054300         SET MBCA-MBUI-ERROR-YES TO TRUE
054400         GO TO F000-SETUP-COMMAREA.
054500*
054600***************************************************************
054700*    INITIALIZE THE STANDARD MAP LINES.  IN AN ERROR          *
054800*    CONDITION, THIS ROUTINE IS PERFORMED PRIMARILY           *
054900*    TO UPDATE THE DATE AND TIME ON THE SCREEN.               *
055000***************************************************************
055100*
055200     PERFORM MB60PD-INIT-STD-MAP-LINES
055300                                 THRU MB60PD-ISML-EXIT.
055400*
055500***********************************************************
055600*    SET THE CURRENCY CODE, CURRENCY NOD
055700*            PER ITEM NOD, PERCENT NOD.
055800***********************************************************
055900     IF MS07-ERROR-MESSAGE IS EQUAL TO SPACES OR LOW-VALUES
056000        PERFORM MB06PD-FORMAT-MESSAGE-LINE
056100                                 THRU MB06PD-FML-EXIT
056200        MOVE SS08WS-FORMATTED-MSG   TO MS07-ERROR-MESSAGE
056300     END-IF.
056400*
056500*
056600**********************
056700*    SEND THE MAP    *
056800**********************
056900*
057000     MOVE 'BM03'                 TO MBCA-PROGRAM-LOCATION.
057100     PERFORM MB60PD-SEND-MAP-DATA-ONLY
057200                                 THRU MB60PD-SMDO-EXIT.
057300*
057400************************
057500*    RETURN TO CICS    *
057600************************
057700*
057800     MOVE 'PC05'                 TO MBCA-PROGRAM-LOCATION.
057900     PERFORM MB70PD-RETURN-TRANS-ID
058000                                 THRU MB70PD-RTI-EXIT.
058100/
058200 E000-UPDATE-FILE SECTION.
058300*
058400     IF  MBCA-MBUI-UI-YES
058500         SET MBCA-MBUI-ERROR-NO  TO TRUE.
058600*
058700     IF  MBCA-MBUI-UI-YES
058800     AND MBCA-MBUI-UI-UPDATE-NO
058900         GO TO F000-SETUP-COMMAREA.
059000*
059100**********************************************************
059200*    READ THE STORE MASTER RECORD FOR UPDATE             *
059300**********************************************************
059400*
059500     MOVE 'FC08'                 TO MBCA-PROGRAM-LOCATION.
059600     MOVE MBCA-MERCHANT-ORG      TO MBIOWS-MMSM-ORG.
059700     MOVE MBCA-STORE             TO MBIOWS-MMSM-STORE.
059800     SET MBIORO-READ-RANDOM-UPDATE
059900                                 TO TRUE.
060000     PERFORM MMSMAO-ACCESS       THRU MMSMAO-ACCESS-EXIT.
060100*
060200*************************************
060300*    OBTAIN STORAGE FOR LOG FILE    *
060400*    RECORD IF DOING MAINTENANCE    *
060500*************************************
060600*
060700     IF  MBCA-PTI-FUNCTION-IS-ADD
060800         GO TO E020-UPDATE-FIELDS.
060900*
061000     MOVE 'SC04'                 TO MBCA-PROGRAM-LOCATION.
061100     SET MBIORO-GETMAIN          TO TRUE.
061200     PERFORM MML1AO-ACCESS       THRU MML1AO-ACCESS-EXIT.
061300*
061400*************************************************
061500*    SET UP THE COMMON PORTION OF THE RECORD    *
061600*************************************************
061700*
061800     MOVE 'SM'                   TO MML1-FILE-CODE.
061900     MOVE MBCA-MERCHANT-ORG      TO MML1-MMSM-ORG.
062000     MOVE MBCA-STORE             TO MML1-MMSM-STORE.
062100     MOVE MBCA-SIGNON-NAME       TO MML1-SIGNON-NAME.
062200     MOVE MBCA-TERMINAL-ID       TO MML1-TERMINAL-ID.
062300     MOVE ZEROS                  TO MML1-SOURCE-CODE.
062400     MOVE MBCA-FIELD-SECURITY    TO MML1-FIELD-SECURITY.
062500*
062600 E020-UPDATE-FIELDS.
062700*
062800*
062900     PERFORM X060-UPDATE-DBA-NAME
063000                                 THRU X069-EXIT.
063100*
063200     PERFORM X100-UPDATE-INTCHG-IND
063300                                 THRU X109-EXIT.
063400*
063500     PERFORM X120-UPDATE-VISA-MEMBER-ID
063600                                 THRU X129-EXIT.
063700*
063800     PERFORM X140-UPDATE-SPECIAL-COND-1
063900                                 THRU X149-EXIT.
064000*
064100     PERFORM X160-UPDATE-SPECIAL-COND-2
064200                                 THRU X169-EXIT.
064300*
064400     PERFORM X180-UPDATE-MAIL-PHONE-IND
064500                                 THRU X189-EXIT.
064600*
064700     PERFORM X200-UPDATE-CH-TERM-IND
064800                                 THRU X209-EXIT.
064900*
065000     PERFORM X280-UPDATE-RPT-THSHOLD
065100                                 THRU X289-EXIT.
065110*                                                                 RG802901
065120     PERFORM X300-UPDATE-CONTACT-IND                              RG802901
065130                                 THRU X309-EXIT.                  RG802901
065200*
065300     PERFORM X320-UPDATE-CRB-REGION
065400                                 THRU X329-EXIT.
065500*
065600     PERFORM X340-UPDATE-REG-ADDR-IND1
065700                                 THRU X349-EXIT.
065800*
065900     PERFORM X360-UPDATE-REG-ADDR-IND2
066000                                 THRU X369-EXIT.
066100*
066200     PERFORM X380-UPDATE-CATEGORY-CODE
066300                                 THRU X389-EXIT.
066400*
066500     PERFORM X400-UPDATE-FLOOR-LIMIT
066600                                 THRU X409-EXIT.
066700*
066800     PERFORM X440-UPDATE-VOLUME-IND
066900                                 THRU X449-EXIT.
066910*                                                                 RG800914
066920     PERFORM X460-UPDATE-SVC-DVLP-IND                             RG800914
066930                                 THRU X469-EXIT.                  RG800914
067000*
067100 E040-UPDATE-MMSM.
067200*
067300     IF  MBCA-PTI-FUNCTION-IS-ADD
067400         MOVE MBCA-SCREEN-NBR    TO MMSM-ONLINE-STATUS
067500         MOVE MBCA-START-DATE    TO MMSM-LAST-MAINT-DATE
067600         MOVE MBCA-OPERATOR-ID   TO MMSM-LAST-MAINT-OPER
067700         SET WS-UPDATE-MMSM-SW-YES
067800                                 TO TRUE.
067900*
068000**************************************************************
068100*    WRITE A LOG RECORD TO SHOW THAT THE LAST MAINT DATE     *
068200*    AND OPERATOR HAS BEEN UPDATED IF FIELDS WERE CHANGED    *
068300*    ON THE SCREEN                                           *
068400**************************************************************
068500*
068600     IF  MBCA-PTI-FUNCTION-IS-MAINT
068700     AND WS-UPDATE-MMSM-SW-YES
068800         MOVE 0198               TO MML1-FIELD-CODE
068900         MOVE ZEROES             TO MML1-FIELD-OCCURRENCE
069000                                    MML1-FIELD-OCCURRENCE-2
069100         MOVE MML1WS-VL-03       TO MML1-VARIABLE-LENGTH
069200         MOVE MMSM-LAST-MAINT-OPER
069300                                 TO MML1-VL03-B-DATA-X
069400         MOVE MBCA-OPERATOR-ID   TO MMSM-LAST-MAINT-OPER
069500         MOVE MMSM-LAST-MAINT-OPER
069600                                 TO MML1-VL03-A-DATA-X
069700         MOVE 'FC09'             TO MBCA-PROGRAM-LOCATION
069800         PERFORM Y920-WRITE-LOG-RECORD
069900                                 THRU Y929-WLR-EXIT
070000         MOVE 0199               TO MML1-FIELD-CODE
070100         MOVE MML1WS-VL-07       TO MML1-VARIABLE-LENGTH
070200         MOVE MMSM-LAST-MAINT-DATE
070300                                 TO MML1-VL07-B-DATA-9
070400         MOVE MBCA-START-DATE    TO MMSM-LAST-MAINT-DATE
070500         MOVE MMSM-LAST-MAINT-DATE
070600                                 TO MML1-VL07-A-DATA-9
070700         MOVE 'FC10'             TO MBCA-PROGRAM-LOCATION
070800         PERFORM Y920-WRITE-LOG-RECORD
070900                                 THRU Y929-WLR-EXIT.
071000*
071100****************************************************
071200*    REWRITE THE STORE    MASTER RECORD IF         *
071300*    FIELDS HAVE BEEN CHANGED ON THE SCREEN, OR    *
071400*    UNLOCK IT IF THEY HAVE NOT                    *
071500****************************************************
071600*
071700     IF  WS-UPDATE-MMSM-SW-YES
071800         MOVE 'FC11'             TO MBCA-PROGRAM-LOCATION
071900         SET MBIORO-REWRITE      TO TRUE
072000         PERFORM MMSMAO-ACCESS   THRU MMSMAO-ACCESS-EXIT
072100     ELSE
072200         MOVE 'FC12'             TO MBCA-PROGRAM-LOCATION
072300         SET MBIORO-UNLOCK       TO TRUE
072400         PERFORM MMSMAO-ACCESS   THRU MMSMAO-ACCESS-EXIT.
072500*
072600/
072700 F000-SETUP-COMMAREA SECTION.
072800*
072900***************************************************************
073000*  SET UP COMMAREA FIELDS AND TRANSFER TO THE NEXT PROGRAM    *
073100***************************************************************
073200*
073300     MOVE MBCA-EIBAID            TO SS08WS-EIBAID.
073400*
073500     PERFORM MB60PD-EDIT-PAGE-NBR
073600                                 THRU MB60PD-EPN-EXIT.
073700*
073800     IF  SS08WS-VALID-PF-KEY
073900     OR  SS08WS-EIBAID-VALID-PF-KEY
074000         SET MBCA-INITIAL-SCREEN-NBR
074100                                 TO TRUE.
074200*
074300     IF  MBCA-MBUI-UI-YES
074400         MOVE 'MBUI'             TO MBCA-TRANS-ID
074500                                    MBCA-PREV-TRANS-ID
074600         MOVE 01                 TO MBCA-SCREEN-NBR
074700         MOVE MBMS07I            TO MBUITS-VAR-DATA
074800         MOVE LENGTH OF MBMS07I  TO MBUITS-VAR-LENGTH
074900         MOVE 'TS10'             TO MBCA-PROGRAM-LOCATION
075000         EXEC CICS WRITEQ TS
075100                   QUEUE   (TS-QUEUE-NAME)
075200                   FROM    (MBUITS-RECORD)
075300                   LENGTH  (LENGTH  OF MBUITS-RECORD)
075400
075500              END-EXEC.
075600*
075700     MOVE 'PC06'                 TO MBCA-PROGRAM-LOCATION.
075800     PERFORM MB70PD-XCTL-TO-MBOXCTL
075900                                 THRU MB70PD-XTM-EXIT.
076000/
076100 W000-FIELD-EDITS SECTION.
076200*
076300 W060-EDIT-DBA-NAME.
076400*
076500     MOVE DFHBMDAS               TO MS07-VI-DBA-NAME-LP-A
076600                                    MS07-VI-DBA-NAME-RP-A.
076700     MOVE DFHBMASK               TO MS07-VI-DBA-NAME-A.
076800*
076900     PERFORM Y065-DBA-NAME-SECURITY
077000                                 THRU Y069-EXIT.
077100*
077200     IF  MS07-VI-DBA-NAME-L IS GREATER THAN ZERO
077300         MOVE DFHBMASF           TO MS07-VI-DBA-NAME-A
077400         EVALUATE TRUE
077500           WHEN MS07-VI-DBA-NAME IS EQUAL TO SPACES
077600             CONTINUE
077700           WHEN MS07-VI-DBA-NAME (1:1)
077800                                 IS EQUAL TO SPACE
077900             GO TO W068-DBA-NAME-ERROR
078000           WHEN OTHER
078100             CONTINUE
078200         END-EVALUATE
078300     ELSE
078400         MOVE MMSM-VI-DBA-NAME   TO MS07-VI-DBA-NAME.
078500*
078600     IF  MS07-VI-DBA-NAME IS EQUAL TO SPACES
078700         MOVE MMSM-DBA-NAME      TO MS07-VI-DBA-NAME
078800         MOVE +25                TO MS07-VI-DBA-NAME-L.
078900*
079000     IF  MBCA-PTI-FUNCTION-IS-MAINT
079100     OR  MS07-VI-DBA-NAME-L IS GREATER THAN ZERO
079200     OR  NOT MMFS-ST-REQUIRED (X-MMFS-STORE)
079300         GO TO W069-EXIT.
079400*
079500 W068-DBA-NAME-ERROR.
079600*
079700     IF  MS07-VI-DBA-NAME-L IS GREATER THAN ZERO
079800         MOVE DFHBMUBF           TO MS07-VI-DBA-NAME-A
079900     ELSE
080000         MOVE DFHBMBRY           TO MS07-VI-DBA-NAME-A.
080100*
080200     SET SS08WS-ERROR-SW-YES     TO TRUE.
080300     MOVE DFHBMASB               TO MS07-VI-DBA-NAME-LP-A
080400                                    MS07-VI-DBA-NAME-RP-A.
080500     MOVE SS08WS-CURSOR          TO MS07-VI-DBA-NAME-L.
080600*
080700 W069-EXIT.
080800     EXIT.
080900*
081000 W100-EDIT-INTCHG-IND.
081100*
081200     MOVE DFHBMDAS               TO MS07-VI-INTCHG-FLAG-LP-A
081300                                    MS07-VI-INTCHG-FLAG-RP-A.
081400     MOVE DFHBMASK               TO MS07-VI-INTCHG-FLAG-A.
081500*
081600     PERFORM Y105-INTCHG-FLAG-SECURITY
081700                                 THRU Y109-EXIT.
081800*
081900     IF  MS07-VI-INTCHG-FLAG-L IS GREATER THAN ZERO
082000         MOVE DFHBMASF           TO MS07-VI-INTCHG-FLAG-A
082100     ELSE
082200         MOVE MMSM-VI-INTCHG-FLAG
082300                                 TO MS07-VI-INTCHG-FLAG.
082400*
082500     IF  MS07-VI-INTCHG-FLAG-VALID
082600         NEXT SENTENCE
082700     ELSE
082800         GO TO W108-INTCHG-FLAG-ERROR.
082900*
083000     IF  MBCA-PTI-FUNCTION-IS-MAINT
083100     OR  MS07-VI-INTCHG-FLAG-L IS GREATER THAN ZERO
083200     OR  NOT MMFS-ST-REQUIRED (X-MMFS-STORE)
083300         GO TO W109-EXIT.
083400*
083500 W108-INTCHG-FLAG-ERROR.
083600*
083700     IF  MS07-VI-INTCHG-FLAG-L IS GREATER THAN ZERO
083800         MOVE DFHBMUBF           TO MS07-VI-INTCHG-FLAG-A
083900     ELSE
084000         MOVE DFHBMBRY           TO MS07-VI-INTCHG-FLAG-A.
084100*
084200     SET SS08WS-ERROR-SW-YES     TO TRUE.
084300     MOVE DFHBMASB               TO MS07-VI-INTCHG-FLAG-LP-A
084400                                    MS07-VI-INTCHG-FLAG-RP-A.
084500     MOVE SS08WS-CURSOR          TO MS07-VI-INTCHG-FLAG-L.
084600*
084700 W109-EXIT.
084800     EXIT.
084900*
085000 W120-EDIT-VISA-MEMBER-ID.
085100*
085200     MOVE DFHBMDAS               TO MS07-VI-MEMBER-ID-LP-A
085300                                    MS07-VI-MEMBER-ID-RP-A.
085400     MOVE DFHBMASK               TO MS07-VI-MEMBER-ID-A.
085500*
085600     PERFORM Y125-VI-MEMBER-ID-SECURITY
085700                                 THRU Y129-EXIT.
085800*
085900     GO TO W129-EXIT.
086000*
086100     IF  MS07-VI-MEMBER-ID-L IS GREATER THAN ZERO
086200         MOVE DFHBMASF           TO MS07-VI-MEMBER-ID-A
086300     ELSE
086400         MOVE MMSM-VI-MEMBER-ID  TO MS07-VI-MEMBER-ID.
086500*
086600     IF  MS07-VI-MEMBER-ID IS NOT NUMERIC
086700         GO TO W128-VI-MEMBER-ID-ERROR.
086800*
086900     IF  MBCA-PTI-FUNCTION-IS-MAINT
087000     OR  MS07-VI-MEMBER-ID-L IS GREATER THAN ZERO
087100     OR  NOT MMFS-ST-REQUIRED (X-MMFS-STORE)
087200         GO TO W129-EXIT.
087300*
087400 W128-VI-MEMBER-ID-ERROR.
087500*
087600     IF  MS07-VI-MEMBER-ID-L IS GREATER THAN ZERO
087700         MOVE DFHBMNBF           TO MS07-VI-MEMBER-ID-A
087800     ELSE
087900         MOVE DFHBMUNB           TO MS07-VI-MEMBER-ID-A.
088000*
088100     SET SS08WS-ERROR-SW-YES     TO TRUE.
088200     MOVE DFHBMASB               TO MS07-VI-MEMBER-ID-LP-A
088300                                    MS07-VI-MEMBER-ID-RP-A.
088400     MOVE SS08WS-CURSOR          TO MS07-VI-MEMBER-ID-L.
088500*
088600 W129-EXIT.
088700     EXIT.
088800*
088900 W140-EDIT-SPECIAL-COND-1.
089000*
089100     MOVE DFHBMDAS               TO MS07-VI-SPECIAL-COND-1-LP-A
089200                                    MS07-VI-SPECIAL-COND-1-RP-A.
089300     MOVE DFHBMASK               TO MS07-VI-SPECIAL-COND-1-A.
089400*
089500     PERFORM Y145-SPECIAL-COND-1-SECURITY
089600                                 THRU Y149-EXIT.
089700*
089800     IF  MS07-VI-SPECIAL-COND-1-L IS GREATER THAN ZERO
089900         MOVE DFHBMASF           TO MS07-VI-SPECIAL-COND-1-A
090000     ELSE
090100         MOVE MMSM-VI-SPECIAL-COND-1
090200                                 TO MS07-VI-SPECIAL-COND-1.
090300*
090400     IF  NOT MS07-VALID-SPECIAL-COND-1
090500         GO TO W148-SPECIAL-COND-1-ERROR.
090600*
090700     IF  MBCA-PTI-FUNCTION-IS-MAINT
090800     OR  MS07-VI-SPECIAL-COND-1-L IS GREATER THAN ZERO
090900     OR  NOT MMFS-ST-REQUIRED (X-MMFS-STORE)
091000         GO TO W149-EXIT.
091100*
091200 W148-SPECIAL-COND-1-ERROR.
091300*
091400     IF  MS07-VI-SPECIAL-COND-1-L IS GREATER THAN ZERO
091500         MOVE DFHBMUBF           TO MS07-VI-SPECIAL-COND-1-A
091600     ELSE
091700         MOVE DFHBMBRY           TO MS07-VI-SPECIAL-COND-1-A.
091800*
091900     SET SS08WS-ERROR-SW-YES     TO TRUE.
092000     MOVE DFHBMASB               TO MS07-VI-SPECIAL-COND-1-LP-A
092100                                    MS07-VI-SPECIAL-COND-1-RP-A.
092200     MOVE SS08WS-CURSOR          TO MS07-VI-SPECIAL-COND-1-L.
092300*
092400 W149-EXIT.
092500     EXIT.
092600*
092700 W160-EDIT-SPECIAL-COND-2.
092800*
092900     MOVE DFHBMDAS               TO MS07-VI-SPECIAL-COND-2-LP-A
093000                                    MS07-VI-SPECIAL-COND-2-RP-A.
093100     MOVE DFHBMASK               TO MS07-VI-SPECIAL-COND-2-A.
093200*
093300     PERFORM Y165-SPECIAL-COND-2-SECURITY
093400                                 THRU Y169-EXIT.
093500*
093600     IF  MS07-VI-SPECIAL-COND-2-L IS GREATER THAN ZERO
093700         MOVE DFHBMASF           TO MS07-VI-SPECIAL-COND-2-A
093800     ELSE
093900         MOVE MMSM-VI-SPECIAL-COND-2
094000                                 TO MS07-VI-SPECIAL-COND-2.
094100*
094200     IF  NOT MS07-VALID-SPECIAL-COND-2
094300         GO TO W168-SPECIAL-COND-2-ERROR.
094400*
094500     IF  MBCA-PTI-FUNCTION-IS-MAINT
094600     OR  MS07-VI-SPECIAL-COND-2-L IS GREATER THAN ZERO
094700     OR  NOT MMFS-ST-REQUIRED (X-MMFS-STORE)
094800         GO TO W169-EXIT.
094900*
095000 W168-SPECIAL-COND-2-ERROR.
095100*
095200     IF  MS07-VI-SPECIAL-COND-2-L IS GREATER THAN ZERO
095300         MOVE DFHBMUBF           TO MS07-VI-SPECIAL-COND-2-A
095400     ELSE
095500         MOVE DFHBMBRY           TO MS07-VI-SPECIAL-COND-2-A.
095600*
095700     SET SS08WS-ERROR-SW-YES     TO TRUE.
095800     MOVE DFHBMASB               TO MS07-VI-SPECIAL-COND-2-LP-A
095900                                    MS07-VI-SPECIAL-COND-2-RP-A.
096000     MOVE SS08WS-CURSOR          TO MS07-VI-SPECIAL-COND-2-L.
096100*
096200 W169-EXIT.
096300     EXIT.
096400*
096500 W180-EDIT-MAIL-PHONE-IND.
096600*
096700     MOVE DFHBMDAS               TO MS07-VI-MAIL-PHONE-IND-LP-A
096800                                    MS07-VI-MAIL-PHONE-IND-RP-A.
096900     MOVE DFHBMASK               TO MS07-VI-MAIL-PHONE-IND-A.
097000*
097100     PERFORM Y185-MAIL-PHONE-SECURITY
097200                                 THRU Y189-EXIT.
097300*
097400     IF  MS07-VI-MAIL-PHONE-IND-L IS GREATER THAN ZERO
097500         MOVE DFHBMASF           TO MS07-VI-MAIL-PHONE-IND-A
097600     ELSE
097700         MOVE MMSM-VI-MAIL-PHONE-IND
097800                                 TO MS07-VI-MAIL-PHONE-IND.
097900*
098000     IF  NOT MS07-VALID-MAIL-PHONE-IND
098100         GO TO W188-MAIL-PHONE-IND-ERROR.
098200*
098300     IF  MBCA-PTI-FUNCTION-IS-MAINT
098400     OR  MS07-VI-MAIL-PHONE-IND-L IS GREATER THAN ZERO
098500     OR  NOT MMFS-ST-REQUIRED (X-MMFS-STORE)
098600         GO TO W189-EXIT.
098700*
098800 W188-MAIL-PHONE-IND-ERROR.
098900*
099000     IF  MS07-VI-MAIL-PHONE-IND-L IS GREATER THAN ZERO
099100         MOVE DFHBMUBF           TO MS07-VI-MAIL-PHONE-IND-A
099200     ELSE
099300         MOVE DFHBMBRY           TO MS07-VI-MAIL-PHONE-IND-A.
099400*
099500     SET SS08WS-ERROR-SW-YES     TO TRUE.
099600     MOVE DFHBMASB               TO MS07-VI-MAIL-PHONE-IND-LP-A
099700                                    MS07-VI-MAIL-PHONE-IND-RP-A.
099800     MOVE SS08WS-CURSOR          TO MS07-VI-MAIL-PHONE-IND-L.
099900*
100000 W189-EXIT.
100100     EXIT.
100200*
100300 W200-EDIT-CH-ACCT-IND.
100400*
100500     MOVE DFHBMDAS               TO MS07-VI-CH-TERM-IND-LP-A
100600                                    MS07-VI-CH-TERM-IND-RP-A.
100700     MOVE DFHBMASK               TO MS07-VI-CH-TERM-IND-A.
100800*
100900     PERFORM Y205-CH-TERM-IND-SECURITY
101000                                 THRU Y209-EXIT.
101100*
101200     IF  MS07-VI-CH-TERM-IND-L IS GREATER THAN ZERO
101300         MOVE DFHBMASF           TO MS07-VI-CH-TERM-IND-A
101400     ELSE
101500         MOVE MMSM-VI-CH-TERM-IND
101600                                 TO MS07-VI-CH-TERM-IND.
101700*
101800     IF  NOT MS07-VALID-VI-CH-TERM-IND
101900         GO TO W208-CH-TERM-IND-ERROR.
102000*
102100     IF  MBCA-PTI-FUNCTION-IS-MAINT
102200     OR  MS07-VI-CH-TERM-IND-L IS GREATER THAN ZERO
102300     OR  NOT MMFS-ST-REQUIRED (X-MMFS-STORE)
102400         GO TO W209-EXIT.
102500*
102600 W208-CH-TERM-IND-ERROR.
102700*
102800     IF  MS07-VI-CH-TERM-IND-L IS GREATER THAN ZERO
102900         MOVE DFHBMUBF           TO MS07-VI-CH-TERM-IND-A
103000     ELSE
103100         MOVE DFHBMBRY           TO MS07-VI-CH-TERM-IND-A.
103200*
103300     SET SS08WS-ERROR-SW-YES     TO TRUE.
103400     MOVE DFHBMASB               TO MS07-VI-CH-TERM-IND-LP-A
103500                                    MS07-VI-CH-TERM-IND-RP-A.
103600     MOVE SS08WS-CURSOR          TO MS07-VI-CH-TERM-IND-L.
103700*
103800 W209-EXIT.
103900     EXIT.
104000*
104100 W280-EDIT-RPT-THRESHOLD.
104200*
104300     MOVE DFHBMDAS               TO MS07-VI-RPT-THSHOLD-LP-A
104400                                    MS07-VI-RPT-THSHOLD-RP-A.
104500     MOVE DFHBMASK               TO MS07-VI-RPT-THSHOLD-A.
104600*
104700     PERFORM Y285-RPT-THSHOLD-SECURITY
104800                                 THRU Y289-EXIT.
104900*
105000     IF  MS07-VI-RPT-THSHOLD-L IS GREATER THAN ZERO
105100         MOVE DFHBMASF           TO MS07-VI-RPT-THSHOLD-A
105200     ELSE
105300         MOVE MMSM-VI-RPT-THSHOLD
105400                                 TO MS07-VI-RPT-THSHOLD.
105500*
105600     IF  NOT MS07-VALID-RPT-THSHOLD
105700         GO TO W288-RPT-THSHOLD-ERROR.
105800*
105900     IF  MBCA-PTI-FUNCTION-IS-MAINT
106000     OR  MS07-VI-RPT-THSHOLD-L IS GREATER THAN ZERO
106100     OR  NOT MMFS-ST-REQUIRED (X-MMFS-STORE)
106200         GO TO W289-EXIT.
106300*
106400 W288-RPT-THSHOLD-ERROR.
106500*
106600     IF  MS07-VI-RPT-THSHOLD-L IS GREATER THAN ZERO
106700         MOVE DFHBMUBF           TO MS07-VI-RPT-THSHOLD-A
106800     ELSE
106900         MOVE DFHBMBRY           TO MS07-VI-RPT-THSHOLD-A.
107000*
107100     SET SS08WS-ERROR-SW-YES     TO TRUE.
107200     MOVE DFHBMASB               TO MS07-VI-RPT-THSHOLD-LP-A
107300                                    MS07-VI-RPT-THSHOLD-RP-A.
107400     MOVE SS08WS-CURSOR          TO MS07-VI-RPT-THSHOLD-L.
107500*
107600 W289-EXIT.
107700     EXIT.
107702*                                                                 RG802901
107704 W300-EDIT-CONTACT-IND.                                           RG802901
107706*                                                                 RG802901
107708     MOVE DFHBMDAS               TO MS07-VI-CONTACT-IND-LP-A      RG802901
107710                                    MS07-VI-CONTACT-IND-RP-A.     RG802901
107712     MOVE DFHBMASK               TO MS07-VI-CONTACT-IND-A.        RG802901
107714*                                                                 RG802901
107716     PERFORM Y305-CONTACT-IND-SECURITY                            RG802901
107718                                 THRU Y309-EXIT.                  RG802901
107720*                                                                 RG802901
107722     IF  MS07-VI-CONTACT-IND-L IS GREATER THAN ZERO               RG802901
107724         MOVE DFHBMASF           TO MS07-VI-CONTACT-IND-A         RG802901
107726     ELSE                                                         RG802901
107728         MOVE MMSM-VI-CONTACT-IND                                 RG802901
107730                                 TO MS07-VI-CONTACT-IND.          RG802901
107732*                                                                 RG802901
107734     IF  NOT MS07-VALID-CONTACT-IND                               RG802901
107736         GO TO W308-CONTACT-IND-ERROR.                            RG802901
107738*                                                                 RG802901
107740     IF  MBCA-PTI-FUNCTION-IS-MAINT                               RG802901
107742     OR  MS07-VI-CONTACT-IND-L IS GREATER THAN ZERO               RG802901
107744     OR  NOT MMFS-ST-REQUIRED (X-MMFS-STORE)                      RG802901
107746         GO TO W309-EXIT.                                         RG802901
107748*                                                                 RG802901
107750 W308-CONTACT-IND-ERROR.                                          RG802901
107752*                                                                 RG802901
107754     IF  MS07-VI-CONTACT-IND-L IS GREATER THAN ZERO               RG802901
107756         MOVE DFHBMUBF           TO MS07-VI-CONTACT-IND-A         RG802901
107758     ELSE                                                         RG802901
107760         MOVE DFHBMBRY           TO MS07-VI-CONTACT-IND-A.        RG802901
107762*                                                                 RG802901
107764     SET SS08WS-ERROR-SW-YES     TO TRUE.                         RG802901
107766     MOVE DFHBMASB               TO MS07-VI-CONTACT-IND-LP-A      RG802901
107768                                    MS07-VI-CONTACT-IND-RP-A.     RG802901
107770     MOVE SS08WS-CURSOR          TO MS07-VI-CONTACT-IND-L.        RG802901
107772*                                                                 RG802901
107774 W309-EXIT.                                                       RG802901
107776     EXIT.                                                        RG802901
107800*
107900 W320-EDIT-CRB-REGION.
108000*
108100     MOVE DFHBMDAS               TO MS07-VI-CRB-REGION-LP-A
108200                                    MS07-VI-CRB-REGION-RP-A.
108300     MOVE DFHBMASK               TO MS07-VI-CRB-REGION-A.
108400*
108500     PERFORM Y325-CRB-REGION-SECURITY
108600                                 THRU Y329-EXIT.
108700*
108800     IF  MS07-VI-CRB-REGION-L IS GREATER THAN ZERO
108900         MOVE DFHBMASF           TO MS07-VI-CRB-REGION-A
109000     ELSE
109100         MOVE MMSM-VI-CRB-REGION
109200                                 TO MS07-VI-CRB-REGION.
109300*
109400     IF  MBCA-PTI-FUNCTION-IS-MAINT
109500     OR  MS07-VI-CRB-REGION-L IS GREATER THAN ZERO
109600     OR  NOT MMFS-ST-REQUIRED (X-MMFS-STORE)
109700         GO TO W329-EXIT.
109800*
109900 W328-CRB-REGION-ERROR.
110000*
110100     IF  MS07-VI-CRB-REGION-L IS GREATER THAN ZERO
110200         MOVE DFHBMUBF           TO MS07-VI-CRB-REGION-A
110300     ELSE
110400         MOVE DFHBMBRY           TO MS07-VI-CRB-REGION-A.
110500*
110600     SET SS08WS-ERROR-SW-YES     TO TRUE.
110700     MOVE DFHBMASB               TO MS07-VI-CRB-REGION-LP-A
110800                                    MS07-VI-CRB-REGION-RP-A.
110900     MOVE SS08WS-CURSOR          TO MS07-VI-CRB-REGION-L.
111000*
111100 W329-EXIT.
111200     EXIT.
111300*
111400 W340-EDIT-REG-ADDR-IND1.
111500*
111600     MOVE DFHBMDAS               TO MS07-VI-REG-ADDR-IND-LP-A
111700                                    MS07-VI-REG-ADDR-IND-RP-A.
111800     MOVE DFHBMASK               TO MS07-VI-REG-ADDR-IND1-A.
111900*
112000     PERFORM Y345-REG-ADDR-IND1-SECURITY
112100                                 THRU Y349-EXIT.
112200*
112300     IF  MS07-VI-REG-ADDR-IND1-L IS GREATER THAN ZERO
112400         MOVE DFHBMASF           TO MS07-VI-REG-ADDR-IND1-A
112500     ELSE
112600         MOVE MMSM-VI-REG-ADDR-IND
112700                                 TO MS07-VI-REG-ADDR-IND1.
112800*
112900     IF  MS07-VALID-VI-REG-ADDR-IND1
113000         NEXT SENTENCE
113100     ELSE
113200         GO TO W348-REG-ADDR-IND1-ERROR.
113300*
113400     IF  MBCA-PTI-FUNCTION-IS-MAINT
113500     OR  MS07-VI-REG-ADDR-IND1-L IS GREATER THAN ZERO
113600     OR  NOT MMFS-ST-REQUIRED (X-MMFS-STORE)
113700         GO TO W349-EXIT.
113800*
113900 W348-REG-ADDR-IND1-ERROR.
114000*
114100     IF  MS07-VI-REG-ADDR-IND1-L IS GREATER THAN ZERO
114200         MOVE DFHBMUBF           TO MS07-VI-REG-ADDR-IND1-A
114300     ELSE
114400         MOVE DFHBMBRY           TO MS07-VI-REG-ADDR-IND1-A.
114500*
114600     SET SS08WS-ERROR-SW-YES     TO TRUE.
114700     MOVE DFHBMASB               TO MS07-VI-REG-ADDR-IND-LP-A
114800                                    MS07-VI-REG-ADDR-IND-RP-A.
114900     MOVE SS08WS-CURSOR          TO MS07-VI-REG-ADDR-IND1-L.
115000*
115100 W349-EXIT.
115200     EXIT.
115300*
115400 W360-EDIT-REG-ADDR-IND2.
115500*
115600     MOVE DFHBMDAS               TO MS07-VI-REG-ADDR-IND-LP-A
115700                                    MS07-VI-REG-ADDR-IND-RP-A.
115800     MOVE DFHBMASK               TO MS07-VI-REG-ADDR-IND2-A.
115900*
116000     PERFORM Y365-REG-ADDR-IND2-SECURITY
116100                                 THRU Y369-EXIT.
116200*
116300     IF  MS07-VI-REG-ADDR-IND2-L IS GREATER THAN ZERO
116400         MOVE DFHBMASF           TO MS07-VI-REG-ADDR-IND2-A
116500     ELSE
116600         MOVE MMSM-VI-REG-ADDR-LINE
116700                                 TO MS07-VI-REG-ADDR-IND2.
116800*
116900     IF  MS07-VALID-VI-REG-ADDR-IND2
117000         NEXT SENTENCE
117100     ELSE
117200         GO TO W368-REG-ADDR-IND2-ERROR.
117300*
117400     IF  MBCA-PTI-FUNCTION-IS-MAINT
117500     OR  MS07-VI-REG-ADDR-IND2-L IS GREATER THAN ZERO
117600     OR  NOT MMFS-ST-REQUIRED (X-MMFS-STORE)
117700         GO TO W369-EXIT.
117800*
117900 W368-REG-ADDR-IND2-ERROR.
118000*
118100     IF  MS07-VI-REG-ADDR-IND2-L IS GREATER THAN ZERO
118200         MOVE DFHBMUBF           TO MS07-VI-REG-ADDR-IND2-A
118300     ELSE
118400         MOVE DFHBMBRY           TO MS07-VI-REG-ADDR-IND2-A.
118500*
118600     SET SS08WS-ERROR-SW-YES     TO TRUE.
118700     MOVE DFHBMASB               TO MS07-VI-REG-ADDR-IND-LP-A
118800                                    MS07-VI-REG-ADDR-IND-RP-A.
118900     MOVE SS08WS-CURSOR          TO MS07-VI-REG-ADDR-IND2-L.
119000*
119100 W369-EXIT.
119200     EXIT.
119300*
119400 W380-EDIT-CATEGORY.
119500*
119600     MOVE DFHBMDAS               TO MS07-VI-CATEGORY-CODE-LP-A
119700                                    MS07-VI-CATEGORY-CODE-RP-A.
119800     MOVE DFHBMASK               TO MS07-VI-CATEGORY-CODE-A.
119900*
120000     PERFORM Y385-CATEGORY-CODE-SECURITY
120100                                 THRU Y389-EXIT.
120200*
120300     IF  MS07-VI-CATEGORY-CODE-L IS GREATER THAN ZERO
120400         MOVE DFHBMASF           TO MS07-VI-CATEGORY-CODE-A
120500     ELSE
120600         MOVE MMSM-VI-CATEGORY-CODE
120700                                 TO MS07-VI-CATEGORY-CODE.
120800*
120900     IF  MS07-VI-CATEGORY-CODE IS NOT NUMERIC
121000         GO TO W388-PROD-CATEGORY-ERROR.
121100*
121200     MOVE MS07-VI-CATEGORY-CODE  TO SMCAWS-CATEGORY-CODE.
121300     PERFORM SMCAPXO-OBTAIN-CAT-CODE-DATA
121400        THRU SMCAPXO-OCCD-EXIT.
121500*
121600     IF  SMCAWS-RC-NO-CATEGORY-FOUND
121700         GO TO W388-PROD-CATEGORY-ERROR.
121800*
121900     MOVE SMCAWS-RECORD          TO SMCA-RECORD.
122000*
122100     IF  SMCA-HEADER
122200     OR  SMCA-TRAILER
122300     OR  SMCA-REC-PURGED
122400     OR  SMCA-ADD-PENDING
122500         GO TO W388-PROD-CATEGORY-ERROR.
122600*
122700     IF  SMCA-REC-ACTIVE
122710     AND SMCA-VI-IS-VALID
122800         CONTINUE
122900     ELSE
123000         GO TO W388-PROD-CATEGORY-ERROR.
123100*
123200     IF  MBCA-PTI-FUNCTION-IS-MAINT
123300     OR  MS07-VI-CATEGORY-CODE-L IS GREATER THAN ZERO
123400     OR  NOT MMFS-ST-REQUIRED (X-MMFS-STORE)
123500         GO TO W389-EXIT.
123600*
123700 W388-PROD-CATEGORY-ERROR.
123800*
123900     IF  MS07-VI-CATEGORY-CODE-L IS GREATER THAN ZERO
124000         MOVE DFHBMNBF           TO MS07-VI-CATEGORY-CODE-A
124100     ELSE
124200         MOVE DFHBMUNB           TO MS07-VI-CATEGORY-CODE-A.
124300*
124400     SET SS08WS-ERROR-SW-YES     TO TRUE.
124500     MOVE DFHBMASB               TO MS07-VI-CATEGORY-CODE-LP-A
124600                                    MS07-VI-CATEGORY-CODE-RP-A.
124700     MOVE SS08WS-CURSOR          TO MS07-VI-CATEGORY-CODE-L.
124800*
124900 W389-EXIT.
125000     EXIT.
125100*
125200 W400-EDIT-FLOOR-LIMIT.
125300*
125400     MOVE DFHBMDAS               TO MS07-VI-FLOOR-LIMIT-LP-A
125500                                    MS07-VI-FLOOR-LIMIT-RP-A.
125600     MOVE DFHBMASK               TO MS07-VI-FLOOR-LIMIT-A.
125700*
125800     PERFORM Y405-FLOOR-LIMIT-SECURITY
125900                                 THRU Y409-EXIT.
126000*
126100     IF  MS07-VI-FLOOR-LIMIT-L IS GREATER THAN ZERO
126200         MOVE DFHBMASF           TO MS07-VI-FLOOR-LIMIT-A
126300     ELSE
126400         MOVE MMSM-VI-FLOOR-LIMIT
126500                                 TO MS07-VI-FLOOR-LIMIT.
126600*
126700     IF  MS07-VI-FLOOR-LIMIT IS NOT NUMERIC
126800         GO TO W408-VI-FLOOR-LIMIT-ERROR.
126900*
127000     IF  MBCA-PTI-FUNCTION-IS-MAINT
127100     OR  MS07-VI-FLOOR-LIMIT-L IS GREATER THAN ZERO
127200     OR  NOT MMFS-ST-REQUIRED (X-MMFS-STORE)
127300         GO TO W409-EXIT.
127400*
127500 W408-VI-FLOOR-LIMIT-ERROR.
127600*
127700     IF  MS07-VI-FLOOR-LIMIT-L IS GREATER THAN ZERO
127800         MOVE DFHBMNBF           TO MS07-VI-FLOOR-LIMIT-A
127900     ELSE
128000         MOVE DFHBMUNB           TO MS07-VI-FLOOR-LIMIT-A.
128100*
128200     SET SS08WS-ERROR-SW-YES     TO TRUE.
128300     MOVE DFHBMASB               TO MS07-VI-FLOOR-LIMIT-LP-A
128400                                    MS07-VI-FLOOR-LIMIT-RP-A.
128500     MOVE SS08WS-CURSOR          TO MS07-VI-FLOOR-LIMIT-L.
128600*
128700 W409-EXIT.
128800     EXIT.
128900*
129000 W420-CROSS-EDIT-MPEC-IND.
129100*
129200     IF  MS07-VI-MAIL-PHONE-IND-L IS GREATER THAN ZERO
129300         IF  MS07-VALID-MAIL-BASE-II
129400             IF  MMSM-STORE-TYPE IS EQUAL TO 09
129500                 NEXT SENTENCE
129600             ELSE
129700                 MOVE DFHBMUBF   TO MS07-VI-MAIL-PHONE-IND-A
129800                 SET SS08WS-ERROR-SW-YES
129900                                 TO TRUE
130000                 MOVE DFHBMASB   TO MS07-VI-MAIL-PHONE-IND-LP-A
130100                                    MS07-VI-MAIL-PHONE-IND-RP-A
130200                 MOVE SS08WS-CURSOR TO MS07-VI-MAIL-PHONE-IND-L.
130300*
130400 W429-EXIT.
130500     EXIT.
130600*
130700 W440-EDIT-VOLUME-IND.
130800*
130900     MOVE DFHBMDAS               TO MS07-VI-VOLUME-IND-LP-A
131000                                    MS07-VI-VOLUME-IND-RP-A.
131100     MOVE DFHBMASK               TO MS07-VI-VOLUME-IND-A.
131200*
131300     PERFORM Y445-VOLUME-IND-SECURITY
131400                                 THRU Y449-EXIT.
131500*
131600     IF  MS07-VI-VOLUME-IND-L IS GREATER THAN ZERO
131700         MOVE DFHBMASF           TO MS07-VI-VOLUME-IND-A
131800     ELSE
131900         MOVE MMSM-VI-VOLUME-IND
132000                                 TO MS07-VI-VOLUME-IND.
132100*
132200     IF (MS07-VI-VOLUME-IND IS EQUAL TO SPACES
132300     OR  MS07-VI-VOLUME-IND IS NUMERIC)
132400     AND MS07-VALID-VOLUME-IND
132500         NEXT SENTENCE
132600     ELSE
132700         GO TO W448-VOLUME-IND-ERROR.
132800*
132900     IF  MBCA-PTI-FUNCTION-IS-MAINT
133000     OR  MS07-VI-VOLUME-IND-L IS GREATER THAN ZERO
133100     OR  NOT MMFS-ST-REQUIRED (X-MMFS-STORE)
133200         GO TO W449-EXIT.
133300*
133400 W448-VOLUME-IND-ERROR.
133500*
133600     IF  MS07-VI-VOLUME-IND-L IS GREATER THAN ZERO
133700         MOVE DFHBMUBF           TO MS07-VI-VOLUME-IND-A
133800     ELSE
133900         MOVE DFHBMBRY           TO MS07-VI-VOLUME-IND-A.
134000*
134100     SET SS08WS-ERROR-SW-YES     TO TRUE.
134200     MOVE DFHBMASB               TO MS07-VI-VOLUME-IND-LP-A
134300                                    MS07-VI-VOLUME-IND-RP-A.
134400     MOVE SS08WS-CURSOR          TO MS07-VI-VOLUME-IND-L.
134500*
134600 W449-EXIT.
134700     EXIT.
134702*                                                                 RG802901
134704 W460-CROSS-EDIT-CONTACT-IND.                                     RG802901
134706*                                                                 RG802901
134708     IF MS07-VI-CONTACT-IND-L IS NOT GREATER THAN ZERO            RG802901
134710         GO TO W469-EXIT                                          RG802901
134712     END-IF.                                                      RG802901
134714     IF MS07-VALID-CONTACT-IND                                    RG802901
134716         NEXT SENTENCE                                            RG802901
134718      ELSE                                                        RG802901
134720         MOVE DFHBMUBF           TO MS07-VI-CONTACT-IND-A         RG802901
134722         SET SS08WS-ERROR-SW-YES TO TRUE                          RG802901
134724         MOVE DFHBMASB           TO MS07-VI-CONTACT-IND-LP-A      RG802901
134726                                    MS07-VI-CONTACT-IND-RP-A      RG802901
134728         MOVE SS08WS-CURSOR      TO MS07-VI-CONTACT-IND-L         RG802901
134730         GO TO W469-EXIT                                          RG802901
134732     END-IF.                                                      RG802901
134734     IF MS07-VI-USE-PHONE                                         RG802901
134736         GO TO W469-EXIT                                          RG802901
134738     END-IF.                                                      RG802901
134740     IF MS07-VI-USE-URL-EMAIL    AND                              RG802901
134742        MMSM-VI-URL-EMAIL GREATER THAN SPACES                     RG802901
134744         NEXT SENTENCE                                            RG802901
134746      ELSE                                                        RG802901
134748         MOVE DFHBMUBF           TO MS07-VI-CONTACT-IND-A         RG802901
134750         SET SS08WS-ERROR-SW-YES TO TRUE                          RG802901
134752         MOVE DFHBMASB           TO MS07-VI-CONTACT-IND-LP-A      RG802901
134754                                    MS07-VI-CONTACT-IND-RP-A      RG802901
134756         MOVE SS08WS-CURSOR      TO MS07-VI-CONTACT-IND-L         RG802901
134758         GO TO W469-EXIT                                          RG802901
134760     END-IF.                                                      RG802901
134762*                                                                 RG802901
134764 W469-EXIT.                                                       RG802901
134766     EXIT.                                                        RG802901
134800*
134802 W450-EDIT-SVC-DVLP-IND.                                          RG800914
134804*                                                                 RG800914
134806     MOVE DFHBMDAS               TO MS07-VI-SVC-DVLP-IND-LP-A     RG800914
134808                                    MS07-VI-SVC-DVLP-IND-RP-A.    RG800914
134810     MOVE DFHBMASK               TO MS07-VI-SVC-DVLP-IND-A.       RG800914
134812*                                                                 RG800914
134814     PERFORM Y465-SVC-DVLP-IND                                    RG800914
134816                                 THRU Y469-EXIT.                  RG800914
134818*                                                                 RG800914
134820     IF  MS07-VI-SVC-DVLP-IND-L IS GREATER THAN ZERO              RG800914
134822         MOVE DFHBMASF           TO MS07-VI-SVC-DVLP-IND-A        RG800914
134824     ELSE                                                         RG800914
134826         MOVE MMSM-VI-SVC-DVLP-IND                                RG800914
134828                                 TO MS07-VI-SVC-DVLP-IND.         RG800914
134830*                                                                 RG800914
134832     IF  NOT MS07-VALID-SVC-DVLP-IND                              RG800914
134834         GO TO W458-SVC-DVLP-IND-ERROR.                           RG800914
134836*                                                                 RG800914
134838     IF  MBCA-PTI-FUNCTION-IS-MAINT                               RG800914
134840     OR  MS07-VI-SVC-DVLP-IND-L IS GREATER THAN ZERO              RG800914
134842     OR  NOT MMFS-ST-REQUIRED (X-MMFS-STORE)                      RG800914
134844         GO TO W459-EXIT.                                         RG800914
134846*                                                                 RG800914
134848 W458-SVC-DVLP-IND-ERROR.                                         RG800914
134850*                                                                 RG800914
134852     IF  MS07-VI-SVC-DVLP-IND-L IS GREATER THAN ZERO              RG800914
134854         MOVE DFHBMUBF           TO MS07-VI-SVC-DVLP-IND-A        RG800914
134856     ELSE                                                         RG800914
134858         MOVE DFHBMBRY           TO MS07-VI-SVC-DVLP-IND-A.       RG800914
134860*                                                                 RG800914
134862     SET SS08WS-ERROR-SW-YES     TO TRUE.                         RG800914
134864     MOVE DFHBMASB               TO MS07-VI-SVC-DVLP-IND-LP-A     RG800914
134866                                    MS07-VI-SVC-DVLP-IND-RP-A.    RG800914
134868     MOVE SS08WS-CURSOR          TO MS07-VI-SVC-DVLP-IND-L.       RG800914
134870*                                                                 RG800914
134872 W459-EXIT.                                                       RG800914
134874     EXIT.                                                        RG800914
134900*
135000*
135100/
135200 X000-UPDATE-FIELDS SECTION.
135300*
135400 X060-UPDATE-DBA-NAME.
135500*
135600     IF  MS07-VI-DBA-NAME-L IS GREATER THAN ZERO
135700         IF  MS07-VI-DBA-NAME IS NOT EQUAL TO
135800                                    MMSM-VI-DBA-NAME
135900             SET WS-UPDATE-MMSM-SW-YES
136000                                 TO TRUE
136100             IF  MBCA-PTI-FUNCTION-IS-MAINT
136200             AND MMSM-ADD-COMPLETED
136300                 MOVE MMSMTB-VI-DBA-NAME (1:4)
136400                                 TO WS-INDEX-X
136500                 SET X-MMFS-STORE
136600                                 TO WS-INDEX
136700                 MOVE MMFS-ST-AUDIT-CODE (X-MMFS-STORE)
136800                                 TO MML1-MMSM-AUDIT-CODE
136900                 MOVE 0701       TO MML1-FIELD-CODE
137000                 MOVE ZEROES     TO MML1-FIELD-OCCURRENCE
137100                                    MML1-FIELD-OCCURRENCE-2
137200                 MOVE MML1WS-VL-30
137300                                 TO MML1-VARIABLE-LENGTH
137400                 MOVE MMSM-VI-DBA-NAME
137500                                 TO MML1-VL30-B-DATA-X
137600                 MOVE MS07-VI-DBA-NAME
137700                                 TO MMSM-VI-DBA-NAME
137800                 MOVE MMSM-VI-DBA-NAME
137900                                 TO MML1-VL30-A-DATA-X
138000                 MOVE 'FC13'     TO MBCA-PROGRAM-LOCATION
138100                 PERFORM Y920-WRITE-LOG-RECORD
138200                                 THRU Y929-WLR-EXIT
138300             ELSE
138400                 MOVE MS07-VI-DBA-NAME
138500                                 TO MMSM-VI-DBA-NAME.
138600*
138700 X069-EXIT.
138800     EXIT.
138900*
139000 X100-UPDATE-INTCHG-IND.
139100*
139200     IF  MS07-VI-INTCHG-FLAG-L IS GREATER THAN ZERO
139300         IF  MS07-VI-INTCHG-FLAG IS NOT EQUAL TO
139400                                    MMSM-VI-INTCHG-FLAG
139500             SET WS-UPDATE-MMSM-SW-YES
139600                                 TO TRUE
139700             IF  MBCA-PTI-FUNCTION-IS-MAINT
139800             AND MMSM-ADD-COMPLETED
139900                 MOVE MMSMTB-VI-INTCHG-IND (1:4)
140000                                 TO WS-INDEX-X
140100                 SET X-MMFS-STORE
140200                                 TO WS-INDEX
140300                 MOVE MMFS-ST-AUDIT-CODE (X-MMFS-STORE)
140400                                 TO MML1-MMSM-AUDIT-CODE
140500                 MOVE 0703       TO MML1-FIELD-CODE
140600                 MOVE ZEROES     TO MML1-FIELD-OCCURRENCE
140700                                    MML1-FIELD-OCCURRENCE-2
140800                 MOVE MML1WS-VL-01
140900                                 TO MML1-VARIABLE-LENGTH
141000                 MOVE MMSM-VI-INTCHG-FLAG
141100                                 TO MML1-VL01-B-DATA-X
141200                 MOVE MS07-VI-INTCHG-FLAG
141300                                 TO MMSM-VI-INTCHG-FLAG
141400                 MOVE MMSM-VI-INTCHG-FLAG
141500                                 TO MML1-VL01-A-DATA-X
141600                 MOVE 'FC14'     TO MBCA-PROGRAM-LOCATION
141700                 PERFORM Y920-WRITE-LOG-RECORD
141800                                 THRU Y929-WLR-EXIT
141900             ELSE
142000                 MOVE MS07-VI-INTCHG-FLAG
142100                                 TO MMSM-VI-INTCHG-FLAG.
142200*
142300 X109-EXIT.
142400     EXIT.
142500*
142600 X120-UPDATE-VISA-MEMBER-ID.
142700*
142800     IF  MS07-VI-MEMBER-ID-L IS GREATER THAN ZERO
142900         IF  MS07-VI-MEMBER-ID IS NOT EQUAL TO
143000                                    MMSM-VI-MEMBER-ID
143100             SET WS-UPDATE-MMSM-SW-YES
143200                                 TO TRUE
143300             IF  MBCA-PTI-FUNCTION-IS-MAINT
143400             AND MMSM-ADD-COMPLETED
143500                 MOVE MMSMTB-VI-MEMBER-ID (1:4)
143600                                 TO WS-INDEX-X
143700                 SET X-MMFS-STORE
143800                                 TO WS-INDEX
143900                 MOVE MMFS-ST-AUDIT-CODE (X-MMFS-STORE)
144000                                 TO MML1-MMSM-AUDIT-CODE
144100                 MOVE 0704       TO MML1-FIELD-CODE
144200                 MOVE ZEROES     TO MML1-FIELD-OCCURRENCE
144300                                    MML1-FIELD-OCCURRENCE-2
144400                 MOVE MML1WS-VL-10
144500                                 TO MML1-VARIABLE-LENGTH
144600                 MOVE MMSM-VI-MEMBER-ID
144700                                 TO MML1-VL10-B-DATA-9
144800                 MOVE MS07-VI-MEMBER-ID
144900                                 TO MMSM-VI-MEMBER-ID
145000                 MOVE MMSM-VI-MEMBER-ID
145100                                 TO MML1-VL10-A-DATA-9
145200                 MOVE 'FC15'     TO MBCA-PROGRAM-LOCATION
145300                 PERFORM Y920-WRITE-LOG-RECORD
145400                                 THRU Y929-WLR-EXIT
145500             ELSE
145600                 MOVE MS07-VI-MEMBER-ID
145700                                 TO MMSM-VI-MEMBER-ID.
145800*
145900 X129-EXIT.
146000     EXIT.
146100*
146200 X140-UPDATE-SPECIAL-COND-1.
146300*
146400     IF  MS07-VI-SPECIAL-COND-1-L IS GREATER THAN ZERO
146500         IF  MS07-VI-SPECIAL-COND-1 IS NOT EQUAL TO
146600                                    MMSM-VI-SPECIAL-COND-1
146700             SET WS-UPDATE-MMSM-SW-YES
146800                                 TO TRUE
146900             IF  MBCA-PTI-FUNCTION-IS-MAINT
147000             AND MMSM-ADD-COMPLETED
147100                 MOVE MMSMTB-VI-SPECIAL-COND-1 (1:4)
147200                                 TO WS-INDEX-X
147300                 SET X-MMFS-STORE
147400                                 TO WS-INDEX
147500                 MOVE MMFS-ST-AUDIT-CODE (X-MMFS-STORE)
147600                                 TO MML1-MMSM-AUDIT-CODE
147700                 MOVE 0705       TO MML1-FIELD-CODE
147800                 MOVE ZEROES     TO MML1-FIELD-OCCURRENCE
147900                                    MML1-FIELD-OCCURRENCE-2
148000                 MOVE MML1WS-VL-01
148100                                 TO MML1-VARIABLE-LENGTH
148200                 MOVE MMSM-VI-SPECIAL-COND-1
148300                                 TO MML1-VL01-B-DATA-X
148400                 MOVE MS07-VI-SPECIAL-COND-1
148500                                 TO MMSM-VI-SPECIAL-COND-1
148600                 MOVE MMSM-VI-SPECIAL-COND-1
148700                                 TO MML1-VL01-A-DATA-X
148800                 MOVE 'FC16'     TO MBCA-PROGRAM-LOCATION
148900                 PERFORM Y920-WRITE-LOG-RECORD
149000                                 THRU Y929-WLR-EXIT
149100             ELSE
149200                 MOVE MS07-VI-SPECIAL-COND-1
149300                                 TO MMSM-VI-SPECIAL-COND-1.
149400*
149500 X149-EXIT.
149600     EXIT.
149700*
149800 X160-UPDATE-SPECIAL-COND-2.
149900*
150000     IF  MS07-VI-SPECIAL-COND-2-L IS GREATER THAN ZERO
150100         IF  MS07-VI-SPECIAL-COND-2 IS NOT EQUAL TO
150200                                    MMSM-VI-SPECIAL-COND-2
150300             SET WS-UPDATE-MMSM-SW-YES
150400                                 TO TRUE
150500             IF  MBCA-PTI-FUNCTION-IS-MAINT
150600             AND MMSM-ADD-COMPLETED
150700                 MOVE MMSMTB-VI-SPECIAL-COND-2 (1:4)
150800                                 TO WS-INDEX-X
150900                 SET X-MMFS-STORE
151000                                 TO WS-INDEX
151100                 MOVE MMFS-ST-AUDIT-CODE (X-MMFS-STORE)
151200                                 TO MML1-MMSM-AUDIT-CODE
151300                 MOVE 0706       TO MML1-FIELD-CODE
151400                 MOVE ZEROES     TO MML1-FIELD-OCCURRENCE
151500                                    MML1-FIELD-OCCURRENCE-2
151600                 MOVE MML1WS-VL-01
151700                                 TO MML1-VARIABLE-LENGTH
151800                 MOVE MMSM-VI-SPECIAL-COND-2
151900                                 TO MML1-VL01-B-DATA-X
152000                 MOVE MS07-VI-SPECIAL-COND-2
152100                                 TO MMSM-VI-SPECIAL-COND-2
152200                 MOVE MMSM-VI-SPECIAL-COND-2
152300                                 TO MML1-VL01-A-DATA-X
152400                 MOVE 'FC17'     TO MBCA-PROGRAM-LOCATION
152500                 PERFORM Y920-WRITE-LOG-RECORD
152600                                 THRU Y929-WLR-EXIT
152700             ELSE
152800                 MOVE MS07-VI-SPECIAL-COND-2
152900                                 TO MMSM-VI-SPECIAL-COND-2.
153000*
153100 X169-EXIT.
153200     EXIT.
153300*
153400 X180-UPDATE-MAIL-PHONE-IND.
153500*
153600     IF  MS07-VI-MAIL-PHONE-IND-L IS GREATER THAN ZERO
153700         IF  MS07-VI-MAIL-PHONE-IND IS NOT EQUAL TO
153800                                    MMSM-VI-MAIL-PHONE-IND
153900             SET WS-UPDATE-MMSM-SW-YES
154000                                 TO TRUE
154100             IF  MBCA-PTI-FUNCTION-IS-MAINT
154200             AND MMSM-ADD-COMPLETED
154300                 MOVE MMSMTB-VI-MAIL-PHONE-IND (1:4)
154400                                 TO WS-INDEX-X
154500                 SET X-MMFS-STORE
154600                                 TO WS-INDEX
154700                 MOVE MMFS-ST-AUDIT-CODE (X-MMFS-STORE)
154800                                 TO MML1-MMSM-AUDIT-CODE
154900                 MOVE 0707       TO MML1-FIELD-CODE
155000                 MOVE ZEROES     TO MML1-FIELD-OCCURRENCE
155100                                    MML1-FIELD-OCCURRENCE-2
155200                 MOVE MML1WS-VL-01
155300                                 TO MML1-VARIABLE-LENGTH
155400                 MOVE MMSM-VI-MAIL-PHONE-IND
155500                                 TO MML1-VL01-B-DATA-X
155600                 MOVE MS07-VI-MAIL-PHONE-IND
155700                                 TO MMSM-VI-MAIL-PHONE-IND
155800                 MOVE MMSM-VI-MAIL-PHONE-IND
155900                                 TO MML1-VL01-A-DATA-X
156000                 MOVE 'FC18'     TO MBCA-PROGRAM-LOCATION
156100                 PERFORM Y920-WRITE-LOG-RECORD
156200                                 THRU Y929-WLR-EXIT
156300             ELSE
156400                 MOVE MS07-VI-MAIL-PHONE-IND
156500                                 TO MMSM-VI-MAIL-PHONE-IND.
156600*
156700 X189-EXIT.
156800     EXIT.
156900*
157000 X200-UPDATE-CH-TERM-IND.
157100*
157200     IF  MS07-VI-CH-TERM-IND-L IS GREATER THAN ZERO
157300         IF  MS07-VI-CH-TERM-IND IS NOT EQUAL TO
157400                                    MMSM-VI-CH-TERM-IND
157500             SET WS-UPDATE-MMSM-SW-YES
157600                                 TO TRUE
157700             IF  MBCA-PTI-FUNCTION-IS-MAINT
157800             AND MMSM-ADD-COMPLETED
157900                 MOVE MMSMTB-VI-CH-TERM-IND (1:4)
158000                                 TO WS-INDEX-X
158100                 SET X-MMFS-STORE
158200                                 TO WS-INDEX
158300                 MOVE MMFS-ST-AUDIT-CODE (X-MMFS-STORE)
158400                                 TO MML1-MMSM-AUDIT-CODE
158500                 MOVE 0708       TO MML1-FIELD-CODE
158600                 MOVE ZEROES     TO MML1-FIELD-OCCURRENCE
158700                                    MML1-FIELD-OCCURRENCE-2
158800                 MOVE MML1WS-VL-01
158900                                 TO MML1-VARIABLE-LENGTH
159000                 MOVE MMSM-VI-CH-TERM-IND
159100                                 TO MML1-VL01-B-DATA-X
159200                 MOVE MS07-VI-CH-TERM-IND
159300                                 TO MMSM-VI-CH-TERM-IND
159400                 MOVE MMSM-VI-CH-TERM-IND
159500                                 TO MML1-VL01-A-DATA-X
159600                 MOVE 'FC19'     TO MBCA-PROGRAM-LOCATION
159700                 PERFORM Y920-WRITE-LOG-RECORD
159800                                 THRU Y929-WLR-EXIT
159900             ELSE
160000                 MOVE MS07-VI-CH-TERM-IND
160100                                 TO MMSM-VI-CH-TERM-IND.
160200*
160300 X209-EXIT.
160400     EXIT.
160500*
160600 X280-UPDATE-RPT-THSHOLD.
160700*
160800     IF  MS07-VI-RPT-THSHOLD-L IS GREATER THAN ZERO
160900         IF  MS07-VI-RPT-THSHOLD IS NOT EQUAL TO
161000                                    MMSM-VI-RPT-THSHOLD
161100             SET WS-UPDATE-MMSM-SW-YES
161200                                 TO TRUE
161300             IF  MBCA-PTI-FUNCTION-IS-MAINT
161400             AND MMSM-ADD-COMPLETED
161500                 MOVE MMSMTB-VI-RPT-THSHOLD (1:4)
161600                                 TO WS-INDEX-X
161700                 SET X-MMFS-STORE
161800                                 TO WS-INDEX
161900                 MOVE MMFS-ST-AUDIT-CODE (X-MMFS-STORE)
162000                                 TO MML1-MMSM-AUDIT-CODE
162100                 MOVE 0712       TO MML1-FIELD-CODE
162200                 MOVE ZEROES     TO MML1-FIELD-OCCURRENCE
162300                                    MML1-FIELD-OCCURRENCE-2
162400                 MOVE MML1WS-VL-01
162500                                 TO MML1-VARIABLE-LENGTH
162600                 MOVE MMSM-VI-RPT-THSHOLD
162700                                 TO MML1-VL01-B-DATA-X
162800                 MOVE MS07-VI-RPT-THSHOLD
162900                                 TO MMSM-VI-RPT-THSHOLD
163000                 MOVE MMSM-VI-RPT-THSHOLD
163100                                 TO MML1-VL01-A-DATA-X
163200                 MOVE 'FC20'     TO MBCA-PROGRAM-LOCATION
163300                 PERFORM Y920-WRITE-LOG-RECORD
163400                                 THRU Y929-WLR-EXIT
163500             ELSE
163600                 MOVE MS07-VI-RPT-THSHOLD
163700                                 TO MMSM-VI-RPT-THSHOLD.
163800*
163900 X289-EXIT.
164000     EXIT.
164002*                                                                 RG802901
164004 X300-UPDATE-CONTACT-IND.                                         RG802901
164006*                                                                 RG802901
164008     IF  MS07-VI-CONTACT-IND-L IS GREATER THAN ZERO               RG802901
164010        IF  MS07-VI-CONTACT-IND IS NOT EQUAL TO                   RG802901
164012                                    MMSM-VI-CONTACT-IND           RG802901
164014             SET WS-UPDATE-MMSM-SW-YES                            RG802901
164016                                 TO TRUE                          RG802901
164018             IF  MBCA-PTI-FUNCTION-IS-MAINT                       RG802901
164020             AND MMSM-ADD-COMPLETED                               RG802901
164022                 MOVE MMSMTB-VI-CONTACT-IND (1:4)                 RG802901
164024                                 TO WS-INDEX-X                    RG802901
164026                 SET X-MMFS-STORE                                 RG802901
164028                                 TO WS-INDEX                      RG802901
164030                 MOVE MMFS-ST-AUDIT-CODE (X-MMFS-STORE)           RG802901
164032                                 TO MML1-MMSM-AUDIT-CODE          RG802901
164034                 MOVE 0720       TO MML1-FIELD-CODE               RG802901
164036                 MOVE ZEROES     TO MML1-FIELD-OCCURRENCE         RG802901
164038                                    MML1-FIELD-OCCURRENCE-2       RG802901
164040                 MOVE MML1WS-VL-01                                RG802901
164042                                 TO MML1-VARIABLE-LENGTH          RG802901
164044                 MOVE MMSM-VI-CONTACT-IND                         RG802901
164046                                 TO MML1-VL01-B-DATA-X            RG802901
164048                 MOVE MS07-VI-CONTACT-IND                         RG802901
164050                                 TO MMSM-VI-CONTACT-IND           RG802901
164052                 MOVE MMSM-VI-CONTACT-IND                         RG802901
164054                                 TO MML1-VL01-A-DATA-X            RG802901
164056                 MOVE 'FC21'     TO MBCA-PROGRAM-LOCATION         RG802901
164058                 PERFORM Y920-WRITE-LOG-RECORD                    RG802901
164060                                 THRU Y929-WLR-EXIT               RG802901
164062             ELSE                                                 RG802901
164064                 MOVE MS07-VI-CONTACT-IND                         RG802901
164066                                 TO MMSM-VI-CONTACT-IND.          RG802901
164068*                                                                 RG802901
164070 X309-EXIT.                                                       RG802901
164072     EXIT.                                                        RG802901
164100*
164200 X320-UPDATE-CRB-REGION.
164300*
164400     IF  MS07-VI-CRB-REGION-L IS GREATER THAN ZERO
164500         IF  MS07-VI-CRB-REGION IS NOT EQUAL TO
164600                                    MMSM-VI-CRB-REGION
164700             SET WS-UPDATE-MMSM-SW-YES
164800                                 TO TRUE
164900             IF  MBCA-PTI-FUNCTION-IS-MAINT
165000             AND MMSM-ADD-COMPLETED
165100                 MOVE MMSMTB-VI-CRB-REGION (1:4)
165200                                 TO WS-INDEX-X
165300                 SET X-MMFS-STORE
165400                                 TO WS-INDEX
165500                 MOVE MMFS-ST-AUDIT-CODE (X-MMFS-STORE)
165600                                 TO MML1-MMSM-AUDIT-CODE
165700                 MOVE 0714       TO MML1-FIELD-CODE
165800                 MOVE ZEROES     TO MML1-FIELD-OCCURRENCE
165900                                    MML1-FIELD-OCCURRENCE-2
166000                 MOVE MML1WS-VL-02
166100                                 TO MML1-VARIABLE-LENGTH
166200                 MOVE MMSM-VI-CRB-REGION
166300                                 TO MML1-VL02-B-DATA-X
166400                 MOVE MS07-VI-CRB-REGION
166500                                 TO MMSM-VI-CRB-REGION
166600                 MOVE MMSM-VI-CRB-REGION
166700                                 TO MML1-VL02-A-DATA-X
166800                 MOVE 'FC22'     TO MBCA-PROGRAM-LOCATION
166900                 PERFORM Y920-WRITE-LOG-RECORD
167000                                 THRU Y929-WLR-EXIT
167100             ELSE
167200                 MOVE MS07-VI-CRB-REGION
167300                                 TO MMSM-VI-CRB-REGION.
167400*
167500 X329-EXIT.
167600     EXIT.
167700*
167800 X340-UPDATE-REG-ADDR-IND1.
167900*
168000     IF  MS07-VI-REG-ADDR-IND1-L IS GREATER THAN ZERO
168100         IF  MS07-VI-REG-ADDR-IND1 IS NOT EQUAL TO
168200                                    MMSM-VI-REG-ADDR-IND
168300             SET WS-UPDATE-MMSM-SW-YES
168400                                 TO TRUE
168500             IF  MBCA-PTI-FUNCTION-IS-MAINT
168600             AND MMSM-ADD-COMPLETED
168700                 MOVE MMSMTB-VI-REG-ADDR-IND1 (1:4)
168800                                 TO WS-INDEX-X
168900                 SET X-MMFS-STORE
169000                                 TO WS-INDEX
169100                 MOVE MMFS-ST-AUDIT-CODE (X-MMFS-STORE)
169200                                 TO MML1-MMSM-AUDIT-CODE
169300                 MOVE 0715       TO MML1-FIELD-CODE
169400                 MOVE ZEROES     TO MML1-FIELD-OCCURRENCE
169500                                    MML1-FIELD-OCCURRENCE-2
169600                 MOVE MML1WS-VL-01
169700                                 TO MML1-VARIABLE-LENGTH
169800                 MOVE MMSM-VI-REG-ADDR-IND
169900                                 TO MML1-VL01-B-DATA-X
170000                 MOVE MS07-VI-REG-ADDR-IND1
170100                                 TO MMSM-VI-REG-ADDR-IND
170200                 MOVE MMSM-VI-REG-ADDR-IND
170300                                 TO MML1-VL01-A-DATA-X
170400                 MOVE 'FC23'     TO MBCA-PROGRAM-LOCATION
170500                 PERFORM Y920-WRITE-LOG-RECORD
170600                                 THRU Y929-WLR-EXIT
170700             ELSE
170800                 MOVE MS07-VI-REG-ADDR-IND1
170900                                 TO MMSM-VI-REG-ADDR-IND.
171000*
171100 X349-EXIT.
171200     EXIT.
171300*
171400 X360-UPDATE-REG-ADDR-IND2.
171500*
171600     IF  MS07-VI-REG-ADDR-IND2-L IS GREATER THAN ZERO
171700         IF  MS07-VI-REG-ADDR-IND2 IS NOT EQUAL TO
171800                                    MMSM-VI-REG-ADDR-LINE
171900             SET WS-UPDATE-MMSM-SW-YES
172000                                 TO TRUE
172100             IF  MBCA-PTI-FUNCTION-IS-MAINT
172200             AND MMSM-ADD-COMPLETED
172300                 MOVE MMSMTB-VI-REG-ADDR-IND2 (1:4)
172400                                 TO WS-INDEX-X
172500                 SET X-MMFS-STORE
172600                                 TO WS-INDEX
172700                 MOVE MMFS-ST-AUDIT-CODE (X-MMFS-STORE)
172800                                 TO MML1-MMSM-AUDIT-CODE
172900                 MOVE 0716       TO MML1-FIELD-CODE
173000                 MOVE ZEROES     TO MML1-FIELD-OCCURRENCE
173100                                    MML1-FIELD-OCCURRENCE-2
173200                 MOVE MML1WS-VL-01
173300                                 TO MML1-VARIABLE-LENGTH
173400                 MOVE MMSM-VI-REG-ADDR-LINE
173500                                 TO MML1-VL01-B-DATA-9
173600                 MOVE MS07-VI-REG-ADDR-IND2
173700                                 TO MMSM-VI-REG-ADDR-LINE
173800                 MOVE MMSM-VI-REG-ADDR-LINE
173900                                 TO MML1-VL01-A-DATA-9
174000                 MOVE 'FC24'     TO MBCA-PROGRAM-LOCATION
174100                 PERFORM Y920-WRITE-LOG-RECORD
174200                                 THRU Y929-WLR-EXIT
174300             ELSE
174400                 MOVE MS07-VI-REG-ADDR-IND2
174500                                 TO MMSM-VI-REG-ADDR-LINE.
174600*
174700 X369-EXIT.
174800     EXIT.
174900*
175000 X380-UPDATE-CATEGORY-CODE.
175100*
175200     IF  MS07-VI-CATEGORY-CODE-L IS GREATER THAN ZERO
175300         IF  MS07-VI-CATEGORY-CODE IS NOT EQUAL TO
175400                                    MMSM-VI-CATEGORY-CODE
175500             SET WS-UPDATE-MMSM-SW-YES
175600                                 TO TRUE
175700             IF  MBCA-PTI-FUNCTION-IS-MAINT
175800             AND MMSM-ADD-COMPLETED
175900                 MOVE MMSMTB-VI-CATEGORY-CODE (1:4)
176000                                 TO WS-INDEX-X
176100                 SET X-MMFS-STORE
176200                                 TO WS-INDEX
176300                 MOVE MMFS-ST-AUDIT-CODE (X-MMFS-STORE)
176400                                 TO MML1-MMSM-AUDIT-CODE
176500                 MOVE 0717       TO MML1-FIELD-CODE
176600                 MOVE ZEROES     TO MML1-FIELD-OCCURRENCE
176700                                    MML1-FIELD-OCCURRENCE-2
176800                 MOVE MML1WS-VL-04
176900                                 TO MML1-VARIABLE-LENGTH
177000                 MOVE MMSM-VI-CATEGORY-CODE
177100                                 TO MML1-VL04-B-DATA-9
177200                 MOVE MS07-VI-CATEGORY-CODE
177300                                 TO MMSM-VI-CATEGORY-CODE
177400                 MOVE MMSM-VI-CATEGORY-CODE
177500                                 TO MML1-VL04-A-DATA-9
177600                 MOVE 'FC25'     TO MBCA-PROGRAM-LOCATION
177700                 PERFORM Y920-WRITE-LOG-RECORD
177800                                 THRU Y929-WLR-EXIT
177900             ELSE
178000                 MOVE MS07-VI-CATEGORY-CODE
178100                                 TO MMSM-VI-CATEGORY-CODE.
178200*
178300 X389-EXIT.
178400     EXIT.
178500*
178600 X400-UPDATE-FLOOR-LIMIT.
178700*
178800     IF  MS07-VI-FLOOR-LIMIT-L IS GREATER THAN ZERO
178900         IF  MS07-VI-FLOOR-LIMIT IS NOT EQUAL TO
179000                                    MMSM-VI-FLOOR-LIMIT
179100             SET WS-UPDATE-MMSM-SW-YES
179200                                 TO TRUE
179300             IF  MBCA-PTI-FUNCTION-IS-MAINT
179400             AND MMSM-ADD-COMPLETED
179500                 MOVE MMSMTB-VI-FLOOR-LIMIT (1:4)
179600                                 TO WS-INDEX-X
179700                 SET X-MMFS-STORE
179800                                 TO WS-INDEX
179900                 MOVE MMFS-ST-AUDIT-CODE (X-MMFS-STORE)
180000                                 TO MML1-MMSM-AUDIT-CODE
180100                 MOVE 0718       TO MML1-FIELD-CODE
180200                 MOVE ZEROES     TO MML1-FIELD-OCCURRENCE
180300                                    MML1-FIELD-OCCURRENCE-2
180400                 MOVE MML1WS-VL-20
180500                                 TO MML1-VARIABLE-LENGTH
180600                 MOVE MMSM-VI-FLOOR-LIMIT
180700                                 TO MML1-VL20-B-NBR-NO-DEC
180800                 MOVE MS07-VI-FLOOR-LIMIT
180900                                 TO MMSM-VI-FLOOR-LIMIT
181000                 MOVE MMSM-VI-FLOOR-LIMIT
181100                                 TO MML1-VL20-A-NBR-NO-DEC
181200                 MOVE 'FC26'     TO MBCA-PROGRAM-LOCATION
181300                 PERFORM Y920-WRITE-LOG-RECORD
181400                                 THRU Y929-WLR-EXIT
181500             ELSE
181600                 MOVE MS07-VI-FLOOR-LIMIT
181700                                 TO MMSM-VI-FLOOR-LIMIT.
181800*
181900 X409-EXIT.
182000     EXIT.
182100/
182200 X440-UPDATE-VOLUME-IND.
182300*
182400     IF  MS07-VI-VOLUME-IND-L IS GREATER THAN ZERO
182500         IF  MS07-VI-VOLUME-IND IS NOT EQUAL TO
182600                                    MMSM-VI-VOLUME-IND
182700             SET WS-UPDATE-MMSM-SW-YES
182800                                 TO TRUE
182900             IF  MBCA-PTI-FUNCTION-IS-MAINT
183000             AND MMSM-ADD-COMPLETED
183100                 MOVE MMSMTB-VI-VOLUME-IND (1:4)
183200                                 TO WS-INDEX-X
183300                 SET X-MMFS-STORE
183400                                 TO WS-INDEX
183500                 MOVE MMFS-ST-AUDIT-CODE (X-MMFS-STORE)
183600                                 TO MML1-MMSM-AUDIT-CODE
183700                 MOVE 0719       TO MML1-FIELD-CODE
183800                 MOVE ZEROES     TO MML1-FIELD-OCCURRENCE
183900                                    MML1-FIELD-OCCURRENCE-2
184000                 MOVE MML1WS-VL-02
184100                                 TO MML1-VARIABLE-LENGTH
184200                 MOVE MMSM-VI-VOLUME-IND
184300                                 TO MML1-VL02-B-DATA-X
184400                 MOVE MS07-VI-VOLUME-IND
184500                                 TO MMSM-VI-VOLUME-IND
184600                 MOVE MMSM-VI-VOLUME-IND
184700                                 TO MML1-VL02-A-DATA-X
184800                 MOVE 'FC27'     TO MBCA-PROGRAM-LOCATION         RG800914
184900                 PERFORM Y920-WRITE-LOG-RECORD
185000                                 THRU Y929-WLR-EXIT
185100             ELSE
185200                 MOVE MS07-VI-VOLUME-IND
185300                                 TO MMSM-VI-VOLUME-IND.
185400*
185500 X449-EXIT.
185600     EXIT.
185602*                                                                 RG800914
185604 X460-UPDATE-SVC-DVLP-IND.                                        RG800914
185606*                                                                 RG800914
185608     IF  MS07-VI-SVC-DVLP-IND-L IS GREATER THAN ZERO              RG800914
185610         IF  MS07-VI-SVC-DVLP-IND IS NOT EQUAL TO                 RG800914
185612                                    MMSM-VI-SVC-DVLP-IND          RG800914
185614             SET WS-UPDATE-MMSM-SW-YES                            RG800914
185616                                 TO TRUE                          RG800914
185618             IF  MBCA-PTI-FUNCTION-IS-MAINT                       RG800914
185620             AND MMSM-ADD-COMPLETED                               RG800914
185622                 MOVE MMSMTB-VI-SVC-DVLP-IND (1:4)                RG800914
185624                                 TO WS-INDEX-X                    RG800914
185626                 SET X-MMFS-STORE                                 RG800914
185628                                 TO WS-INDEX                      RG800914
185630                 MOVE MMFS-ST-AUDIT-CODE (X-MMFS-STORE)           RG800914
185632                                 TO MML1-MMSM-AUDIT-CODE          RG800914
185634                 MOVE 0721       TO MML1-FIELD-CODE               RG800914
185636                 MOVE ZEROES     TO MML1-FIELD-OCCURRENCE         RG800914
185638                                    MML1-FIELD-OCCURRENCE-2       RG800914
185640                 MOVE MML1WS-VL-01                                RG800914
185642                                 TO MML1-VARIABLE-LENGTH          RG800914
185644                 MOVE MMSM-VI-SVC-DVLP-IND                        RG800914
185646                                 TO MML1-VL01-B-DATA-X            RG800914
185648                 MOVE MS07-VI-SVC-DVLP-IND                        RG800914
185650                                 TO MMSM-VI-SVC-DVLP-IND          RG800914
185652                 MOVE MMSM-VI-SVC-DVLP-IND                        RG800914
185654                                 TO MML1-VL01-A-DATA-X            RG800914
185656                 MOVE 'FC28'     TO MBCA-PROGRAM-LOCATION         RG800914
185658                 PERFORM Y920-WRITE-LOG-RECORD                    RG800914
185660                                 THRU Y929-WLR-EXIT               RG800914
185662             ELSE                                                 RG800914
185664                 MOVE MS07-VI-SVC-DVLP-IND                        RG800914
185666                                 TO MMSM-VI-SVC-DVLP-IND.         RG800914
185668*                                                                 RG800914
185670 X469-EXIT.                                                       RG800914
185672     EXIT.                                                        RG800914
185674/                                                                 RG800914
185700/
185800 Y000-PERFORMED-ROUTINES SECTION.
185900*
186000 Y060-MOVE-DBA-NAME.
186100*
186200     MOVE MMSM-VI-DBA-NAME       TO MS07-VI-DBA-NAME.
186300*
186400 Y065-DBA-NAME-SECURITY.
186500*
186600     MOVE MMSMTB-VI-DBA-NAME (1:4)
186700                                 TO WS-INDEX-X.
186800     SET  X-MMFS-STORE           TO WS-INDEX.
186900*
187000     IF  MMFS-ST-NO-ACCESS (X-MMFS-STORE)
187100         MOVE DFHBMDAS           TO MS07-VI-DBA-NAME-LIT-A
187200                                    MS07-VI-DBA-NAME-LP-A
187300                                    MS07-VI-DBA-NAME-RP-A
187400                                    MS07-VI-DBA-NAME-A
187500         MOVE ZERO               TO MS07-VI-DBA-NAME-L
187600         GO TO Y069-EXIT.
187700*
187800     IF  MBCA-PTI-FUNCTION-IS-INQUIRY
187900         MOVE DFHBMDAS           TO MS07-VI-DBA-NAME-LP-A
188000                                    MS07-VI-DBA-NAME-RP-A
188100         MOVE DFHBMASB           TO MS07-VI-DBA-NAME-A
188200         GO TO Y069-EXIT.
188300*
188400     IF  MMFS-ST-INQ-ONLY (X-MMFS-STORE)
188500         MOVE ZERO               TO MS07-VI-DBA-NAME-L
188600         MOVE DFHBMDAS           TO MS07-VI-DBA-NAME-LP-A
188700                                    MS07-VI-DBA-NAME-RP-A
188800         MOVE DFHBMASK           TO MS07-VI-DBA-NAME-A
188900         GO TO Y069-EXIT.
189000*
189100     IF  MBCA-PTI-FUNCTION-IS-ADD
189200         IF  MMFS-ST-REQUIRED (X-MMFS-STORE)
189300             MOVE DFHBMASB       TO MS07-VI-DBA-NAME-LIT-A
189400         ELSE
189500             IF  MMFS-ST-MAINT-ONLY (X-MMFS-STORE)
189600                 MOVE ZERO       TO MS07-VI-DBA-NAME-L
189700                 MOVE DFHBMDAS   TO MS07-VI-DBA-NAME-LP-A
189800                                    MS07-VI-DBA-NAME-RP-A
189900                 MOVE DFHBMASK   TO MS07-VI-DBA-NAME-A.
190000*
190100     IF  MBCA-PTI-FUNCTION-IS-MAINT
190200         IF  MMFS-ST-NO-MAINT (X-MMFS-STORE)
190300             MOVE ZERO           TO MS07-VI-DBA-NAME-L
190400             MOVE DFHBMDAS       TO MS07-VI-DBA-NAME-LP-A
190500                                    MS07-VI-DBA-NAME-RP-A
190600             MOVE DFHBMASK       TO MS07-VI-DBA-NAME-A.
190700*
190800 Y069-EXIT.
190900     EXIT.
191000*
191100 Y100-MOVE-INTCHG-IND.
191200*
191300     MOVE MMSM-VI-INTCHG-FLAG    TO MS07-VI-INTCHG-FLAG.
191400*
191500 Y105-INTCHG-FLAG-SECURITY.
191600*
191700     MOVE MMSMTB-VI-INTCHG-IND (1:4)
191800                                 TO WS-INDEX-X.
191900     SET  X-MMFS-STORE           TO WS-INDEX.
192000*
192100     IF  MMFS-ST-NO-ACCESS (X-MMFS-STORE)
192200         MOVE DFHBMDAS           TO MS07-VI-INTCHG-FLAG-LP-A
192300                                    MS07-VI-INTCHG-FLAG-RP-A
192400                                    MS07-VI-INTCHG-FLAG-A
192500         MOVE ZERO               TO MS07-VI-INTCHG-FLAG-L
192600         GO TO Y109-EXIT.
192700*
192800     IF  MBCA-PTI-FUNCTION-IS-INQUIRY
192900         MOVE DFHBMDAS           TO MS07-VI-INTCHG-FLAG-LP-A
193000                                    MS07-VI-INTCHG-FLAG-RP-A
193100         MOVE DFHBMASB           TO MS07-VI-INTCHG-FLAG-A
193200         GO TO Y109-EXIT.
193300*
193400     IF  MMFS-ST-INQ-ONLY (X-MMFS-STORE)
193500         MOVE ZERO               TO MS07-VI-INTCHG-FLAG-L
193600         MOVE DFHBMDAS           TO MS07-VI-INTCHG-FLAG-LP-A
193700                                    MS07-VI-INTCHG-FLAG-RP-A
193800         MOVE DFHBMASK           TO MS07-VI-INTCHG-FLAG-A
193900         GO TO Y109-EXIT.
194000*
194100     IF  MBCA-PTI-FUNCTION-IS-ADD
194200         IF  MMFS-ST-REQUIRED (X-MMFS-STORE)
194300             MOVE DFHBMASB       TO MS07-VI-INTCHG-FLAG-LIT-A
194400         ELSE
194500             IF  MMFS-ST-MAINT-ONLY (X-MMFS-STORE)
194600                 MOVE ZERO       TO MS07-VI-INTCHG-FLAG-L
194700                 MOVE DFHBMDAS   TO MS07-VI-INTCHG-FLAG-LP-A
194800                                    MS07-VI-INTCHG-FLAG-RP-A
194900                 MOVE DFHBMASK   TO MS07-VI-INTCHG-FLAG-A.
195000*
195100     IF  MBCA-PTI-FUNCTION-IS-MAINT
195200         IF  MMFS-ST-NO-MAINT (X-MMFS-STORE)
195300             MOVE ZERO           TO MS07-VI-INTCHG-FLAG-L
195400             MOVE DFHBMDAS       TO MS07-VI-INTCHG-FLAG-LP-A
195500                                    MS07-VI-INTCHG-FLAG-RP-A
195600             MOVE DFHBMASK       TO MS07-VI-INTCHG-FLAG-A.
195700*
195800 Y109-EXIT.
195900     EXIT.
196000*
196100 Y120-MOVE-VISA-MEMBER-ID.
196200*
196300     MOVE MMSM-VI-MEMBER-ID      TO MS07-VI-MEMBER-ID.
196400*
196500 Y125-VI-MEMBER-ID-SECURITY.
196600*
196700     MOVE DFHBMDAS               TO MS07-VI-MEMBER-ID-LIT-A
196800                                    MS07-VI-MEMBER-ID-LP-A
196900                                    MS07-VI-MEMBER-ID-RP-A
197000                                    MS07-VI-MEMBER-ID-A.
197100     GO TO Y129-EXIT.
197200*
197300     MOVE MMSMTB-VI-MEMBER-ID (1:4)
197400                                 TO WS-INDEX-X.
197500     SET  X-MMFS-STORE           TO WS-INDEX.
197600*
197700     IF  MMFS-ST-NO-ACCESS (X-MMFS-STORE)
197800         MOVE DFHBMDAS           TO MS07-VI-MEMBER-ID-LIT-A
197900                                    MS07-VI-MEMBER-ID-LP-A
198000                                    MS07-VI-MEMBER-ID-RP-A
198100                                    MS07-VI-MEMBER-ID-A
198200         MOVE ZERO               TO MS07-VI-MEMBER-ID-L
198300         GO TO Y129-EXIT.
198400*
198500     IF  MBCA-PTI-FUNCTION-IS-INQUIRY
198600         MOVE DFHBMDAS           TO MS07-VI-MEMBER-ID-LP-A
198700                                    MS07-VI-MEMBER-ID-RP-A
198800         MOVE DFHBMASB           TO MS07-VI-MEMBER-ID-A
198900         GO TO Y129-EXIT.
199000*
199100     IF  MMFS-ST-INQ-ONLY (X-MMFS-STORE)
199200         MOVE ZERO               TO MS07-VI-MEMBER-ID-L
199300         MOVE DFHBMDAS           TO MS07-VI-MEMBER-ID-LP-A
199400                                    MS07-VI-MEMBER-ID-RP-A
199500         MOVE DFHBMASK           TO MS07-VI-MEMBER-ID-A
199600         GO TO Y129-EXIT.
199700*
199800     IF  MBCA-PTI-FUNCTION-IS-ADD
199900         IF  MMFS-ST-REQUIRED (X-MMFS-STORE)
200000             MOVE DFHBMASB       TO MS07-VI-MEMBER-ID-LIT-A
200100         ELSE
200200             IF  MMFS-ST-MAINT-ONLY (X-MMFS-STORE)
200300                 MOVE ZERO       TO MS07-VI-MEMBER-ID-L
200400                 MOVE DFHBMDAS   TO MS07-VI-MEMBER-ID-LP-A
200500                                    MS07-VI-MEMBER-ID-RP-A
200600                 MOVE DFHBMASK   TO MS07-VI-MEMBER-ID-A.
200700*
200800     IF  MBCA-PTI-FUNCTION-IS-MAINT
200900         IF  MMFS-ST-NO-MAINT (X-MMFS-STORE)
201000             MOVE ZERO           TO MS07-VI-MEMBER-ID-L
201100             MOVE DFHBMDAS       TO MS07-VI-MEMBER-ID-LP-A
201200                                    MS07-VI-MEMBER-ID-RP-A
201300             MOVE DFHBMASK       TO MS07-VI-MEMBER-ID-A.
201400*
201500 Y129-EXIT.
201600     EXIT.
201700*
201800 Y140-MOVE-SPECIAL-COND-1.
201900*
202000     MOVE MMSM-VI-SPECIAL-COND-1 TO MS07-VI-SPECIAL-COND-1.
202100*
202200 Y145-SPECIAL-COND-1-SECURITY.
202300*
202400     MOVE MMSMTB-VI-SPECIAL-COND-1 (1:4)
202500                                 TO WS-INDEX-X.
202600     SET  X-MMFS-STORE           TO WS-INDEX.
202700*
202800     IF  MMFS-ST-NO-ACCESS (X-MMFS-STORE)
202900         MOVE DFHBMDAS           TO MS07-VI-SPECIAL-COND-LIT-A
203000                                    MS07-VI-SPECIAL-COND-1-LP-A
203100                                    MS07-VI-SPECIAL-COND-1-RP-A
203200                                    MS07-VI-SPECIAL-COND-1-A
203300         MOVE ZERO               TO MS07-VI-SPECIAL-COND-1-L
203400         GO TO Y149-EXIT.
203500*
203600     IF  MBCA-PTI-FUNCTION-IS-INQUIRY
203700         MOVE DFHBMDAS           TO MS07-VI-SPECIAL-COND-1-LP-A
203800                                    MS07-VI-SPECIAL-COND-1-RP-A
203900         MOVE DFHBMASB           TO MS07-VI-SPECIAL-COND-1-A
204000         GO TO Y149-EXIT.
204100*
204200     IF  MMFS-ST-INQ-ONLY (X-MMFS-STORE)
204300         MOVE ZERO               TO MS07-VI-SPECIAL-COND-1-L
204400         MOVE DFHBMDAS           TO MS07-VI-SPECIAL-COND-1-LP-A
204500                                    MS07-VI-SPECIAL-COND-1-RP-A
204600         MOVE DFHBMASK           TO MS07-VI-SPECIAL-COND-1-A
204700         GO TO Y149-EXIT.
204800*
204900     IF  MBCA-PTI-FUNCTION-IS-ADD
205000         IF  MMFS-ST-REQUIRED (X-MMFS-STORE)
205100             MOVE DFHBMASB       TO MS07-VI-SPECIAL-COND-LIT-A
205200         ELSE
205300             IF  MMFS-ST-MAINT-ONLY (X-MMFS-STORE)
205400                 MOVE ZERO       TO MS07-VI-SPECIAL-COND-1-L
205500                 MOVE DFHBMDAS   TO MS07-VI-SPECIAL-COND-1-LP-A
205600                                    MS07-VI-SPECIAL-COND-1-RP-A
205700                 MOVE DFHBMASK   TO MS07-VI-SPECIAL-COND-1-A.
205800*
205900     IF  MBCA-PTI-FUNCTION-IS-MAINT
206000         IF  MMFS-ST-NO-MAINT (X-MMFS-STORE)
206100             MOVE ZERO           TO MS07-VI-SPECIAL-COND-1-L
206200             MOVE DFHBMDAS       TO MS07-VI-SPECIAL-COND-1-LP-A
206300                                    MS07-VI-SPECIAL-COND-1-RP-A
206400             MOVE DFHBMASK       TO MS07-VI-SPECIAL-COND-1-A.
206500*
206600 Y149-EXIT.
206700     EXIT.
206800*
206900 Y160-MOVE-SPECIAL-COND-2.
207000*
207100     MOVE MMSM-VI-SPECIAL-COND-2 TO MS07-VI-SPECIAL-COND-2.
207200*
207300 Y165-SPECIAL-COND-2-SECURITY.
207400*
207500     MOVE MMSMTB-VI-SPECIAL-COND-2 (1:4)
207600                                 TO WS-INDEX-X.
207700     SET  X-MMFS-STORE           TO WS-INDEX.
207800*
207900     IF  MMFS-ST-NO-ACCESS (X-MMFS-STORE)
208000         MOVE DFHBMDAS           TO MS07-VI-SPECIAL-COND-LIT-A
208100                                    MS07-VI-SPECIAL-COND-2-LP-A
208200                                    MS07-VI-SPECIAL-COND-2-RP-A
208300                                    MS07-VI-SPECIAL-COND-2-A
208400         MOVE ZERO               TO MS07-VI-SPECIAL-COND-2-L
208500         GO TO Y169-EXIT.
208600*
208700     IF  MBCA-PTI-FUNCTION-IS-INQUIRY
208800         MOVE DFHBMDAS           TO MS07-VI-SPECIAL-COND-2-LP-A
208900                                    MS07-VI-SPECIAL-COND-2-RP-A
209000         MOVE DFHBMASB           TO MS07-VI-SPECIAL-COND-2-A
209100         GO TO Y169-EXIT.
209200*
209300     IF  MMFS-ST-INQ-ONLY (X-MMFS-STORE)
209400         MOVE ZERO               TO MS07-VI-SPECIAL-COND-2-L
209500         MOVE DFHBMDAS           TO MS07-VI-SPECIAL-COND-2-LP-A
209600                                    MS07-VI-SPECIAL-COND-2-RP-A
209700         MOVE DFHBMASK           TO MS07-VI-SPECIAL-COND-2-A
209800         GO TO Y169-EXIT.
209900*
210000     IF  MBCA-PTI-FUNCTION-IS-ADD
210100         IF  MMFS-ST-REQUIRED (X-MMFS-STORE)
210200             MOVE DFHBMASB       TO MS07-VI-SPECIAL-COND-LIT-A
210300         ELSE
210400             IF  MMFS-ST-MAINT-ONLY (X-MMFS-STORE)
210500                 MOVE ZERO       TO MS07-VI-SPECIAL-COND-2-L
210600                 MOVE DFHBMDAS   TO MS07-VI-SPECIAL-COND-2-LP-A
210700                                    MS07-VI-SPECIAL-COND-2-RP-A
210800                 MOVE DFHBMASK   TO MS07-VI-SPECIAL-COND-2-A.
210900*
211000     IF  MBCA-PTI-FUNCTION-IS-MAINT
211100         IF  MMFS-ST-NO-MAINT (X-MMFS-STORE)
211200             MOVE ZERO           TO MS07-VI-SPECIAL-COND-2-L
211300             MOVE DFHBMDAS       TO MS07-VI-SPECIAL-COND-2-LP-A
211400                                    MS07-VI-SPECIAL-COND-2-RP-A
211500             MOVE DFHBMASK       TO MS07-VI-SPECIAL-COND-2-A.
211600*
211700 Y169-EXIT.
211800     EXIT.
211900*
212000 Y180-MOVE-MAIL-PHONE-IND.
212100*
212200     MOVE MMSM-VI-MAIL-PHONE-IND TO MS07-VI-MAIL-PHONE-IND.
212300*
212400 Y185-MAIL-PHONE-SECURITY.
212500*
212600     MOVE MMSMTB-VI-MAIL-PHONE-IND (1:4)
212700                                 TO WS-INDEX-X.
212800     SET  X-MMFS-STORE           TO WS-INDEX.
212900*
213000     IF  MMFS-ST-NO-ACCESS (X-MMFS-STORE)
213100         MOVE DFHBMDAS           TO MS07-VI-MAIL-PHONE-IND-LIT-A
213200                                    MS07-VI-MAIL-PHONE-IND-LP-A
213300                                    MS07-VI-MAIL-PHONE-IND-RP-A
213400                                    MS07-VI-MAIL-PHONE-IND-A
213500         MOVE ZERO               TO MS07-VI-MAIL-PHONE-IND-L
213600         GO TO Y189-EXIT.
213700*
213800     IF  MBCA-PTI-FUNCTION-IS-INQUIRY
213900         MOVE DFHBMDAS           TO MS07-VI-MAIL-PHONE-IND-LP-A
214000                                    MS07-VI-MAIL-PHONE-IND-RP-A
214100         MOVE DFHBMASB           TO MS07-VI-MAIL-PHONE-IND-A
214200         GO TO Y189-EXIT.
214300*
214400     IF  MMFS-ST-INQ-ONLY (X-MMFS-STORE)
214500         MOVE ZERO               TO MS07-VI-MAIL-PHONE-IND-L
214600         MOVE DFHBMDAS           TO MS07-VI-MAIL-PHONE-IND-LP-A
214700                                    MS07-VI-MAIL-PHONE-IND-RP-A
214800         MOVE DFHBMASK           TO MS07-VI-MAIL-PHONE-IND-A
214900         GO TO Y189-EXIT.
215000*
215100     IF  MBCA-PTI-FUNCTION-IS-ADD
215200         IF  MMFS-ST-REQUIRED (X-MMFS-STORE)
215300             MOVE DFHBMASB       TO MS07-VI-MAIL-PHONE-IND-LIT-A
215400         ELSE
215500             IF  MMFS-ST-MAINT-ONLY (X-MMFS-STORE)
215600                 MOVE ZERO       TO MS07-VI-MAIL-PHONE-IND-L
215700                 MOVE DFHBMDAS   TO MS07-VI-MAIL-PHONE-IND-LP-A
215800                                    MS07-VI-MAIL-PHONE-IND-RP-A
215900                 MOVE DFHBMASK   TO MS07-VI-MAIL-PHONE-IND-A.
216000*
216100     IF  MBCA-PTI-FUNCTION-IS-MAINT
216200         IF  MMFS-ST-NO-MAINT (X-MMFS-STORE)
216300             MOVE ZERO           TO MS07-VI-MAIL-PHONE-IND-L
216400             MOVE DFHBMDAS       TO MS07-VI-MAIL-PHONE-IND-LP-A
216500                                    MS07-VI-MAIL-PHONE-IND-RP-A
216600             MOVE DFHBMASK       TO MS07-VI-MAIL-PHONE-IND-A.
216700*
216800 Y189-EXIT.
216900     EXIT.
217000*
217100 Y200-MOVE-CH-TERM-IND.
217200*
217300     MOVE MMSM-VI-CH-TERM-IND    TO MS07-VI-CH-TERM-IND.
217400*
217500 Y205-CH-TERM-IND-SECURITY.
217600*
217700     MOVE MMSMTB-VI-CH-TERM-IND (1:4)
217800                                 TO WS-INDEX-X.
217900     SET  X-MMFS-STORE           TO WS-INDEX.
218000*
218100     IF  MMFS-ST-NO-ACCESS (X-MMFS-STORE)
218200         MOVE DFHBMDAS           TO MS07-VI-CH-TERM-IND-LIT-A
218300                                    MS07-VI-CH-TERM-IND-LP-A
218400                                    MS07-VI-CH-TERM-IND-RP-A
218500                                    MS07-VI-CH-TERM-IND-A
218600         MOVE ZERO               TO MS07-VI-CH-TERM-IND-L
218700         GO TO Y209-EXIT.
218800*
218900     IF  MBCA-PTI-FUNCTION-IS-INQUIRY
219000         MOVE DFHBMDAS           TO MS07-VI-CH-TERM-IND-LP-A
219100                                    MS07-VI-CH-TERM-IND-RP-A
219200         MOVE DFHBMASB           TO MS07-VI-CH-TERM-IND-A
219300         GO TO Y209-EXIT.
219400*
219500     IF  MMFS-ST-INQ-ONLY (X-MMFS-STORE)
219600         MOVE ZERO               TO MS07-VI-CH-TERM-IND-L
219700         MOVE DFHBMDAS           TO MS07-VI-CH-TERM-IND-LP-A
219800                                    MS07-VI-CH-TERM-IND-RP-A
219900         MOVE DFHBMASK           TO MS07-VI-CH-TERM-IND-A
220000         GO TO Y209-EXIT.
220100*
220200     IF  MBCA-PTI-FUNCTION-IS-ADD
220300         IF  MMFS-ST-REQUIRED (X-MMFS-STORE)
220400             MOVE DFHBMASB       TO MS07-VI-CH-TERM-IND-LIT-A
220500         ELSE
220600             IF  MMFS-ST-MAINT-ONLY (X-MMFS-STORE)
220700                 MOVE ZERO       TO MS07-VI-CH-TERM-IND-L
220800                 MOVE DFHBMDAS   TO MS07-VI-CH-TERM-IND-LP-A
220900                                    MS07-VI-CH-TERM-IND-RP-A
221000                 MOVE DFHBMASK   TO MS07-VI-CH-TERM-IND-A.
221100*
221200     IF  MBCA-PTI-FUNCTION-IS-MAINT
221300         IF  MMFS-ST-NO-MAINT (X-MMFS-STORE)
221400             MOVE ZERO           TO MS07-VI-CH-TERM-IND-L
221500             MOVE DFHBMDAS       TO MS07-VI-CH-TERM-IND-LP-A
221600                                    MS07-VI-CH-TERM-IND-RP-A
221700             MOVE DFHBMASK       TO MS07-VI-CH-TERM-IND-A.
221800*
221900 Y209-EXIT.
222000     EXIT.
222100*
222200 Y280-MOVE-RPT-THSHOLD.
222300*
222400     MOVE MMSM-VI-RPT-THSHOLD    TO MS07-VI-RPT-THSHOLD.
222500*
222600 Y285-RPT-THSHOLD-SECURITY.
222700*
222800     MOVE MMSMTB-VI-RPT-THSHOLD (1:4)
222900                                 TO WS-INDEX-X.
223000     SET  X-MMFS-STORE           TO WS-INDEX.
223100*
223200     IF  MMFS-ST-NO-ACCESS (X-MMFS-STORE)
223300         MOVE DFHBMDAS           TO MS07-VI-RPT-THSHOLD-LIT-A
223400                                    MS07-VI-RPT-THSHOLD-LP-A
223500                                    MS07-VI-RPT-THSHOLD-RP-A
223600                                    MS07-VI-RPT-THSHOLD-A
223700         MOVE ZERO               TO MS07-VI-RPT-THSHOLD-L
223800         GO TO Y289-EXIT.
223900*
224000     IF  MBCA-PTI-FUNCTION-IS-INQUIRY
224100         MOVE DFHBMDAS           TO MS07-VI-RPT-THSHOLD-LP-A
224200                                    MS07-VI-RPT-THSHOLD-RP-A
224300         MOVE DFHBMASB           TO MS07-VI-RPT-THSHOLD-A
224400         GO TO Y289-EXIT.
224500*
224600     IF  MMFS-ST-INQ-ONLY (X-MMFS-STORE)
224700         MOVE ZERO               TO MS07-VI-RPT-THSHOLD-L
224800         MOVE DFHBMDAS           TO MS07-VI-RPT-THSHOLD-LP-A
224900                                    MS07-VI-RPT-THSHOLD-RP-A
225000         MOVE DFHBMASK           TO MS07-VI-RPT-THSHOLD-A
225100         GO TO Y289-EXIT.
225200*
225300     IF  MBCA-PTI-FUNCTION-IS-ADD
225400         IF  MMFS-ST-REQUIRED (X-MMFS-STORE)
225500             MOVE DFHBMASB       TO MS07-VI-RPT-THSHOLD-LIT-A
225600         ELSE
225700             IF  MMFS-ST-MAINT-ONLY (X-MMFS-STORE)
225800                 MOVE ZERO       TO MS07-VI-RPT-THSHOLD-L
225900                 MOVE DFHBMDAS   TO MS07-VI-RPT-THSHOLD-LP-A
226000                                    MS07-VI-RPT-THSHOLD-RP-A
226100                 MOVE DFHBMASK   TO MS07-VI-RPT-THSHOLD-A.
226200*
226300     IF  MBCA-PTI-FUNCTION-IS-MAINT
226400         IF  MMFS-ST-NO-MAINT (X-MMFS-STORE)
226500             MOVE ZERO           TO MS07-VI-RPT-THSHOLD-L
226600             MOVE DFHBMDAS       TO MS07-VI-RPT-THSHOLD-LP-A
226700                                    MS07-VI-RPT-THSHOLD-RP-A
226800             MOVE DFHBMASK       TO MS07-VI-RPT-THSHOLD-A.
226900*
227000 Y289-EXIT.
227100     EXIT.
227102*                                                                 RG802901
227104 Y300-MOVE-CONTACT-IND.                                           RG802901
227106*                                                                 RG802901
227108     MOVE MMSM-VI-CONTACT-IND    TO MS07-VI-CONTACT-IND.          RG802901
227110*                                                                 RG802901
227112 Y305-CONTACT-IND-SECURITY.                                       RG802901
227114*                                                                 RG802901
227116     MOVE MMSMTB-VI-CONTACT-IND (1:4)                             RG802901
227118                                 TO WS-INDEX-X.                   RG802901
227120     SET  X-MMFS-STORE           TO WS-INDEX.                     RG802901
227122*                                                                 RG802901
227124     IF  MMFS-ST-NO-ACCESS (X-MMFS-STORE)                         RG802901
227126         MOVE DFHBMDAS           TO MS07-VI-CONTACT-IND-LIT-A     RG802901
227128                                    MS07-VI-CONTACT-IND-LP-A      RG802901
227130                                    MS07-VI-CONTACT-IND-RP-A      RG802901
227132                                    MS07-VI-CONTACT-IND-A         RG802901
227134         MOVE ZERO               TO MS07-VI-CONTACT-IND-L         RG802901
227136         GO TO Y309-EXIT.                                         RG802901
227138*                                                                 RG802901
227140     IF  MBCA-PTI-FUNCTION-IS-INQUIRY                             RG802901
227142         MOVE DFHBMDAS           TO MS07-VI-CONTACT-IND-LP-A      RG802901
227144                                    MS07-VI-CONTACT-IND-RP-A      RG802901
227146         MOVE DFHBMASB           TO MS07-VI-CONTACT-IND-A         RG802901
227148         GO TO Y309-EXIT.                                         RG802901
227150*                                                                 RG802901
227152     IF  MMFS-ST-INQ-ONLY (X-MMFS-STORE)                          RG802901
227154         MOVE ZERO               TO MS07-VI-CONTACT-IND-L         RG802901
227156         MOVE DFHBMDAS           TO MS07-VI-CONTACT-IND-LP-A      RG802901
227158                                    MS07-VI-CONTACT-IND-RP-A      RG802901
227160         MOVE DFHBMASK           TO MS07-VI-CONTACT-IND-A         RG802901
227162         GO TO Y309-EXIT.                                         RG802901
227164*                                                                 RG802901
227166     IF  MBCA-PTI-FUNCTION-IS-ADD                                 RG802901
227168         IF  MMFS-ST-REQUIRED (X-MMFS-STORE)                      RG802901
227170             MOVE DFHBMASB       TO MS07-VI-CONTACT-IND-LIT-A     RG802901
227172         ELSE                                                     RG802901
227174             IF  MMFS-ST-MAINT-ONLY (X-MMFS-STORE)                RG802901
227176                 MOVE ZERO       TO MS07-VI-CONTACT-IND-L         RG802901
227178                 MOVE DFHBMDAS   TO MS07-VI-CONTACT-IND-LP-A      RG802901
227180                                    MS07-VI-CONTACT-IND-RP-A      RG802901
227182                 MOVE DFHBMASK   TO MS07-VI-CONTACT-IND-A.        RG802901
227184*                                                                 RG802901
227186     IF  MBCA-PTI-FUNCTION-IS-MAINT                               RG802901
227188         IF  MMFS-ST-NO-MAINT (X-MMFS-STORE)                      RG802901
227190             MOVE ZERO           TO MS07-VI-CONTACT-IND-L         RG802901
227191             MOVE DFHBMDAS       TO MS07-VI-CONTACT-IND-LP-A      RG802901
227192                                    MS07-VI-CONTACT-IND-RP-A      RG802901
227194             MOVE DFHBMASK       TO MS07-VI-CONTACT-IND-A.        RG802901
227195*                                                                 RG802901
227196 Y309-EXIT.                                                       RG802901
227197     EXIT.                                                        RG802901
227200*
227300 Y320-MOVE-CRB-REGION.
227400*
227500     MOVE MMSM-VI-CRB-REGION     TO MS07-VI-CRB-REGION.
227600*
227700 Y325-CRB-REGION-SECURITY.
227800*
227900     MOVE MMSMTB-VI-CRB-REGION (1:4)
228000                                 TO WS-INDEX-X.
228100     SET  X-MMFS-STORE           TO WS-INDEX.
228200*
228300     IF  MMFS-ST-NO-ACCESS (X-MMFS-STORE)
228400         MOVE DFHBMDAS           TO MS07-VI-CRB-REGION-LIT-A
228500                                    MS07-VI-CRB-REGION-LP-A
228600                                    MS07-VI-CRB-REGION-RP-A
228700                                    MS07-VI-CRB-REGION-A
228800         MOVE ZERO               TO MS07-VI-CRB-REGION-L
228900         GO TO Y329-EXIT.
229000*
229100     IF  MBCA-PTI-FUNCTION-IS-INQUIRY
229200         MOVE DFHBMDAS           TO MS07-VI-CRB-REGION-LP-A
229300                                    MS07-VI-CRB-REGION-RP-A
229400         MOVE DFHBMASB           TO MS07-VI-CRB-REGION-A
229500         GO TO Y329-EXIT.
229600*
229700     IF  MMFS-ST-INQ-ONLY (X-MMFS-STORE)
229800         MOVE ZERO               TO MS07-VI-CRB-REGION-L
229900         MOVE DFHBMDAS           TO MS07-VI-CRB-REGION-LP-A
230000                                    MS07-VI-CRB-REGION-RP-A
230100         MOVE DFHBMASK           TO MS07-VI-CRB-REGION-A
230200         GO TO Y329-EXIT.
230300*
230400     IF  MBCA-PTI-FUNCTION-IS-ADD
230500         IF  MMFS-ST-REQUIRED (X-MMFS-STORE)
230600             MOVE DFHBMASB       TO MS07-VI-CRB-REGION-LIT-A
230700         ELSE
230800             IF  MMFS-ST-MAINT-ONLY (X-MMFS-STORE)
230900                 MOVE ZERO       TO MS07-VI-CRB-REGION-L
231000                 MOVE DFHBMDAS   TO MS07-VI-CRB-REGION-LP-A
231100                                    MS07-VI-CRB-REGION-RP-A
231200                 MOVE DFHBMASK   TO MS07-VI-CRB-REGION-A.
231300*
231400     IF  MBCA-PTI-FUNCTION-IS-MAINT
231500         IF  MMFS-ST-NO-MAINT (X-MMFS-STORE)
231600             MOVE ZERO           TO MS07-VI-CRB-REGION-L
231700             MOVE DFHBMDAS       TO MS07-VI-CRB-REGION-LP-A
231800                                    MS07-VI-CRB-REGION-RP-A
231900             MOVE DFHBMASK       TO MS07-VI-CRB-REGION-A.
232000*
232100 Y329-EXIT.
232200     EXIT.
232300*
232400 Y340-MOVE-REG-ADDR-IND1.
232500*
232600     MOVE MMSM-VI-REG-ADDR-IND   TO MS07-VI-REG-ADDR-IND1.
232700*
232800 Y345-REG-ADDR-IND1-SECURITY.
232900*
233000     MOVE MMSMTB-VI-REG-ADDR-IND1 (1:4)
233100                                 TO WS-INDEX-X.
233200     SET  X-MMFS-STORE           TO WS-INDEX.
233300*
233400     IF  MMFS-ST-NO-ACCESS (X-MMFS-STORE)
233500         MOVE DFHBMDAS           TO MS07-VI-REG-ADDR-IND-LIT-A
233600                                    MS07-VI-REG-ADDR-IND-LP-A
233700                                    MS07-VI-REG-ADDR-IND-RP-A
233800                                    MS07-VI-REG-ADDR-IND1-A
233900         MOVE ZERO               TO MS07-VI-REG-ADDR-IND1-L
234000         GO TO Y349-EXIT.
234100*
234200     IF  MBCA-PTI-FUNCTION-IS-INQUIRY
234300         MOVE DFHBMDAS           TO MS07-VI-REG-ADDR-IND-LP-A
234400                                    MS07-VI-REG-ADDR-IND-RP-A
234500         MOVE DFHBMASB           TO MS07-VI-REG-ADDR-IND1-A
234600         GO TO Y349-EXIT.
234700*
234800     IF  MMFS-ST-INQ-ONLY (X-MMFS-STORE)
234900         MOVE ZERO               TO MS07-VI-REG-ADDR-IND1-L
235000         MOVE DFHBMDAS           TO MS07-VI-REG-ADDR-IND-LP-A
235100                                    MS07-VI-REG-ADDR-IND-RP-A
235200         MOVE DFHBMASK           TO MS07-VI-REG-ADDR-IND1-A
235300         GO TO Y349-EXIT.
235400*
235500     IF  MBCA-PTI-FUNCTION-IS-ADD
235600         IF  MMFS-ST-REQUIRED (X-MMFS-STORE)
235700             MOVE DFHBMASB       TO MS07-VI-REG-ADDR-IND-LIT-A
235800         ELSE
235900             IF  MMFS-ST-MAINT-ONLY (X-MMFS-STORE)
236000                 MOVE ZERO       TO MS07-VI-REG-ADDR-IND1-L
236100                 MOVE DFHBMDAS   TO MS07-VI-REG-ADDR-IND-LP-A
236200                                    MS07-VI-REG-ADDR-IND-RP-A
236300                 MOVE DFHBMASK   TO MS07-VI-REG-ADDR-IND1-A.
236400*
236500     IF  MBCA-PTI-FUNCTION-IS-MAINT
236600         IF  MMFS-ST-NO-MAINT (X-MMFS-STORE)
236700             MOVE ZERO           TO MS07-VI-REG-ADDR-IND1-L
236800             MOVE DFHBMDAS       TO MS07-VI-REG-ADDR-IND-LP-A
236900                                    MS07-VI-REG-ADDR-IND-RP-A
237000             MOVE DFHBMASK       TO MS07-VI-REG-ADDR-IND1-A.
237100*
237200 Y349-EXIT.
237300     EXIT.
237400*
237500 Y360-MOVE-REG-ADDR-IND2.
237600*
237700     MOVE MMSM-VI-REG-ADDR-LINE  TO MS07-VI-REG-ADDR-IND2.
237800*
237900 Y365-REG-ADDR-IND2-SECURITY.
238000*
238100     MOVE MMSMTB-VI-REG-ADDR-IND2 (1:4)
238200                                 TO WS-INDEX-X.
238300     SET  X-MMFS-STORE           TO WS-INDEX.
238400*
238500     IF  MMFS-ST-NO-ACCESS (X-MMFS-STORE)
238600         MOVE DFHBMDAS           TO MS07-VI-REG-ADDR-IND-LIT-A
238700                                    MS07-VI-REG-ADDR-IND-LP-A
238800                                    MS07-VI-REG-ADDR-IND-RP-A
238900                                    MS07-VI-REG-ADDR-IND2-A
239000         MOVE ZERO               TO MS07-VI-REG-ADDR-IND2-L
239100         GO TO Y369-EXIT.
239200*
239300     IF  MBCA-PTI-FUNCTION-IS-INQUIRY
239400         MOVE DFHBMDAS           TO MS07-VI-REG-ADDR-IND-LP-A
239500                                    MS07-VI-REG-ADDR-IND-RP-A
239600         MOVE DFHBMASB           TO MS07-VI-REG-ADDR-IND2-A
239700         GO TO Y369-EXIT.
239800*
239900     IF  MMFS-ST-INQ-ONLY (X-MMFS-STORE)
240000         MOVE ZERO               TO MS07-VI-REG-ADDR-IND2-L
240100         MOVE DFHBMDAS           TO MS07-VI-REG-ADDR-IND-LP-A
240200                                    MS07-VI-REG-ADDR-IND-RP-A
240300         MOVE DFHBMASK           TO MS07-VI-REG-ADDR-IND2-A
240400         GO TO Y369-EXIT.
240500*
240600     IF  MBCA-PTI-FUNCTION-IS-ADD
240700         IF  MMFS-ST-REQUIRED (X-MMFS-STORE)
240800             MOVE DFHBMASB       TO MS07-VI-REG-ADDR-IND-LIT-A
240900         ELSE
241000             IF  MMFS-ST-MAINT-ONLY (X-MMFS-STORE)
241100                 MOVE ZERO       TO MS07-VI-REG-ADDR-IND2-L
241200                 MOVE DFHBMDAS   TO MS07-VI-REG-ADDR-IND-LP-A
241300                                    MS07-VI-REG-ADDR-IND-RP-A
241400                 MOVE DFHBMASK   TO MS07-VI-REG-ADDR-IND2-A.
241500*
241600     IF  MBCA-PTI-FUNCTION-IS-MAINT
241700         IF  MMFS-ST-NO-MAINT (X-MMFS-STORE)
241800             MOVE ZERO           TO MS07-VI-REG-ADDR-IND2-L
241900             MOVE DFHBMDAS       TO MS07-VI-REG-ADDR-IND-LP-A
242000                                    MS07-VI-REG-ADDR-IND-RP-A
242100             MOVE DFHBMASK       TO MS07-VI-REG-ADDR-IND2-A.
242200*
242300 Y369-EXIT.
242400     EXIT.
242500*
242600 Y380-MOVE-CATEGORY-CODE.
242700*
242800     MOVE MMSM-VI-CATEGORY-CODE
242900                                 TO MS07-VI-CATEGORY-CODE.
243000*
243100 Y385-CATEGORY-CODE-SECURITY.
243200*
243300     MOVE MMSMTB-VI-CATEGORY-CODE (1:4)
243400                                 TO WS-INDEX-X.
243500     SET  X-MMFS-STORE           TO WS-INDEX.
243600*
243700     IF  MMFS-ST-NO-ACCESS (X-MMFS-STORE)
243800         MOVE DFHBMDAS           TO MS07-VI-CATEGORY-CODE-LIT-A
243900                                    MS07-VI-CATEGORY-CODE-LP-A
244000                                    MS07-VI-CATEGORY-CODE-RP-A
244100                                    MS07-VI-CATEGORY-CODE-A
244200         MOVE ZERO               TO MS07-VI-CATEGORY-CODE-L
244300         GO TO Y389-EXIT.
244400*
244500     IF  MBCA-PTI-FUNCTION-IS-INQUIRY
244600         MOVE DFHBMDAS           TO MS07-VI-CATEGORY-CODE-LP-A
244700                                    MS07-VI-CATEGORY-CODE-RP-A
244800         MOVE DFHBMASB           TO MS07-VI-CATEGORY-CODE-A
244900         GO TO Y389-EXIT.
245000*
245100     IF  MMFS-ST-INQ-ONLY (X-MMFS-STORE)
245200         MOVE ZERO               TO MS07-VI-CATEGORY-CODE-L
245300         MOVE DFHBMDAS           TO MS07-VI-CATEGORY-CODE-LP-A
245400                                    MS07-VI-CATEGORY-CODE-RP-A
245500         MOVE DFHBMASK           TO MS07-VI-CATEGORY-CODE-A
245600         GO TO Y389-EXIT.
245700*
245800     IF  MBCA-PTI-FUNCTION-IS-ADD
245900         IF  MMFS-ST-REQUIRED (X-MMFS-STORE)
246000             MOVE DFHBMASB       TO MS07-VI-CATEGORY-CODE-LIT-A
246100         ELSE
246200             IF  MMFS-ST-MAINT-ONLY (X-MMFS-STORE)
246300                 MOVE ZERO       TO MS07-VI-CATEGORY-CODE-L
246400                 MOVE DFHBMDAS   TO MS07-VI-CATEGORY-CODE-LP-A
246500                                    MS07-VI-CATEGORY-CODE-RP-A
246600                 MOVE DFHBMASK   TO MS07-VI-CATEGORY-CODE-A.
246700*
246800     IF  MBCA-PTI-FUNCTION-IS-MAINT
246900         IF  MMFS-ST-NO-MAINT (X-MMFS-STORE)
247000             MOVE ZERO           TO MS07-VI-CATEGORY-CODE-L
247100             MOVE DFHBMDAS       TO MS07-VI-CATEGORY-CODE-LP-A
247200                                    MS07-VI-CATEGORY-CODE-RP-A
247300             MOVE DFHBMASK       TO MS07-VI-CATEGORY-CODE-A.
247400*
247500 Y389-EXIT.
247600     EXIT.
247700*
247800 Y400-MOVE-FLOOR-LIMIT.
247900*
248000     MOVE MMSM-VI-FLOOR-LIMIT    TO MS07-VI-FLOOR-LIMIT.
248100*
248200 Y405-FLOOR-LIMIT-SECURITY.
248300*
248400     MOVE MMSMTB-VI-FLOOR-LIMIT (1:4)
248500                                 TO WS-INDEX-X.
248600     SET  X-MMFS-STORE           TO WS-INDEX.
248700*
248800     IF  MMFS-ST-NO-ACCESS (X-MMFS-STORE)
248900         MOVE DFHBMDAS           TO MS07-VI-FLOOR-LIMIT-LIT-A
249000                                    MS07-VI-FLOOR-LIMIT-LP-A
249100                                    MS07-VI-FLOOR-LIMIT-RP-A
249200                                    MS07-VI-FLOOR-LIMIT-A
249300         MOVE ZERO               TO MS07-VI-FLOOR-LIMIT-L
249400         GO TO Y409-EXIT.
249500*
249600     IF  MBCA-PTI-FUNCTION-IS-INQUIRY
249700         MOVE DFHBMDAS           TO MS07-VI-FLOOR-LIMIT-LP-A
249800                                    MS07-VI-FLOOR-LIMIT-RP-A
249900         MOVE DFHBMASB           TO MS07-VI-FLOOR-LIMIT-A
250000         GO TO Y409-EXIT.
250100*
250200     IF  MMFS-ST-INQ-ONLY (X-MMFS-STORE)
250300         MOVE ZERO               TO MS07-VI-FLOOR-LIMIT-L
250400         MOVE DFHBMDAS           TO MS07-VI-FLOOR-LIMIT-LP-A
250500                                    MS07-VI-FLOOR-LIMIT-RP-A
250600         MOVE DFHBMASK           TO MS07-VI-FLOOR-LIMIT-A
250700         GO TO Y409-EXIT.
250800*
250900     IF  MBCA-PTI-FUNCTION-IS-ADD
251000         IF  MMFS-ST-REQUIRED (X-MMFS-STORE)
251100             MOVE DFHBMASB       TO MS07-VI-FLOOR-LIMIT-LIT-A
251200         ELSE
251300             IF  MMFS-ST-MAINT-ONLY (X-MMFS-STORE)
251400                 MOVE ZERO       TO MS07-VI-FLOOR-LIMIT-L
251500                 MOVE DFHBMDAS   TO MS07-VI-FLOOR-LIMIT-LP-A
251600                                    MS07-VI-FLOOR-LIMIT-RP-A
251700                 MOVE DFHBMASK   TO MS07-VI-FLOOR-LIMIT-A.
251800*
251900     IF  MBCA-PTI-FUNCTION-IS-MAINT
252000         IF  MMFS-ST-NO-MAINT (X-MMFS-STORE)
252100             MOVE ZERO           TO MS07-VI-FLOOR-LIMIT-L
252200             MOVE DFHBMDAS       TO MS07-VI-FLOOR-LIMIT-LP-A
252300                                    MS07-VI-FLOOR-LIMIT-RP-A
252400             MOVE DFHBMASK       TO MS07-VI-FLOOR-LIMIT-A.
252500*
252600 Y409-EXIT.
252700     EXIT.
252800*
252900 Y440-MOVE-VOLUME-IND.
253000*
253100     MOVE MMSM-VI-VOLUME-IND     TO MS07-VI-VOLUME-IND.
253200*
253300 Y445-VOLUME-IND-SECURITY.
253400*
253500     MOVE MMSMTB-VI-VOLUME-IND (1:4)
253600                                 TO WS-INDEX-X.
253700     SET  X-MMFS-STORE           TO WS-INDEX.
253800*
253900     IF  MMFS-ST-NO-ACCESS (X-MMFS-STORE)
254000         MOVE DFHBMDAS           TO MS07-VI-VOLUME-IND-LIT-A
254100                                    MS07-VI-VOLUME-IND-LP-A
254200                                    MS07-VI-VOLUME-IND-RP-A
254300                                    MS07-VI-VOLUME-IND-A
254400         MOVE ZERO               TO MS07-VI-VOLUME-IND-L
254500         GO TO Y449-EXIT.
254600*
254700     IF  MBCA-PTI-FUNCTION-IS-INQUIRY
254800         MOVE DFHBMDAS           TO MS07-VI-VOLUME-IND-LP-A
254900                                    MS07-VI-VOLUME-IND-RP-A
255000         MOVE DFHBMASB           TO MS07-VI-VOLUME-IND-A
255100         GO TO Y449-EXIT.
255200*
255300     IF  MMFS-ST-INQ-ONLY (X-MMFS-STORE)
255400         MOVE ZERO               TO MS07-VI-VOLUME-IND-L
255500         MOVE DFHBMDAS           TO MS07-VI-VOLUME-IND-LP-A
255600                                    MS07-VI-VOLUME-IND-RP-A
255700         MOVE DFHBMASK           TO MS07-VI-VOLUME-IND-A
255800         GO TO Y449-EXIT.
255900*
256000     IF  MBCA-PTI-FUNCTION-IS-ADD
256100         IF  MMFS-ST-REQUIRED (X-MMFS-STORE)
256200             MOVE DFHBMASB       TO MS07-VI-VOLUME-IND-LIT-A
256300         ELSE
256400             IF  MMFS-ST-MAINT-ONLY (X-MMFS-STORE)
256500                 MOVE ZERO       TO MS07-VI-VOLUME-IND-L
256600                 MOVE DFHBMDAS   TO MS07-VI-VOLUME-IND-LP-A
256700                                    MS07-VI-VOLUME-IND-RP-A
256800                 MOVE DFHBMASK   TO MS07-VI-VOLUME-IND-A.
256900*
257000     IF  MBCA-PTI-FUNCTION-IS-MAINT
257100         IF  MMFS-ST-NO-MAINT (X-MMFS-STORE)
257200             MOVE ZERO           TO MS07-VI-VOLUME-IND-L
257300             MOVE DFHBMDAS       TO MS07-VI-VOLUME-IND-LP-A
257400                                    MS07-VI-VOLUME-IND-RP-A
257500             MOVE DFHBMASK       TO MS07-VI-VOLUME-IND-A.
257600*
257700 Y449-EXIT.
257800     EXIT.
257900*
257902 Y460-MOVE-SVC-DVLP-IND.                                          RG800914
257904*                                                                 RG800914
257906     MOVE MMSM-VI-SVC-DVLP-IND   TO MS07-VI-SVC-DVLP-IND.         RG800914
257908*                                                                 RG800914
257910 Y465-SVC-DVLP-IND.                                               RG800914
257912*                                                                 RG800914
257914     MOVE MMSMTB-VI-SVC-DVLP-IND (1:4)                            RG800914
257916                                 TO WS-INDEX-X.                   RG800914
257918     SET  X-MMFS-STORE           TO WS-INDEX.                     RG800914
257920*                                                                 RG800914
257922     IF  MMFS-ST-NO-ACCESS (X-MMFS-STORE)                         RG800914
257924         MOVE DFHBMDAS           TO MS07-VI-SVC-DVLP-IND-LIT-A    RG800914
257926                                    MS07-VI-SVC-DVLP-IND-LP-A     RG800914
257928                                    MS07-VI-SVC-DVLP-IND-RP-A     RG800914
257930                                    MS07-VI-SVC-DVLP-IND-A        RG800914
257932         MOVE ZERO               TO MS07-VI-SVC-DVLP-IND-L        RG800914
257934         GO TO Y469-EXIT.                                         RG800914
257936*                                                                 RG800914
257938     IF  MBCA-PTI-FUNCTION-IS-INQUIRY                             RG800914
257940         MOVE DFHBMDAS           TO MS07-VI-SVC-DVLP-IND-LP-A     RG800914
257942                                    MS07-VI-SVC-DVLP-IND-RP-A     RG800914
257944         MOVE DFHBMASB           TO MS07-VI-SVC-DVLP-IND-A        RG800914
257946         GO TO Y469-EXIT.                                         RG800914
257948*                                                                 RG800914
257950     IF  MMFS-ST-INQ-ONLY (X-MMFS-STORE)                          RG800914
257952         MOVE ZERO               TO MS07-VI-SVC-DVLP-IND-L        RG800914
257954         MOVE DFHBMDAS           TO MS07-VI-SVC-DVLP-IND-LP-A     RG800914
257956                                    MS07-VI-SVC-DVLP-IND-RP-A     RG800914
257958         MOVE DFHBMASK           TO MS07-VI-SVC-DVLP-IND-A        RG800914
257960         GO TO Y469-EXIT.                                         RG800914
257962*                                                                 RG800914
257964     IF  MBCA-PTI-FUNCTION-IS-ADD                                 RG800914
257966         IF  MMFS-ST-REQUIRED (X-MMFS-STORE)                      RG800914
257968             MOVE DFHBMASB       TO MS07-VI-SVC-DVLP-IND-LIT-A    RG800914
257970         ELSE                                                     RG800914
257972             IF  MMFS-ST-MAINT-ONLY (X-MMFS-STORE)                RG800914
257974                 MOVE ZERO       TO MS07-VI-SVC-DVLP-IND-L        RG800914
257976                 MOVE DFHBMDAS   TO MS07-VI-SVC-DVLP-IND-LP-A     RG800914
257978                                    MS07-VI-SVC-DVLP-IND-RP-A     RG800914
257980                 MOVE DFHBMASK   TO MS07-VI-SVC-DVLP-IND-A.       RG800914
257982*                                                                 RG800914
257984     IF  MBCA-PTI-FUNCTION-IS-MAINT                               RG800914
257986         IF  MMFS-ST-NO-MAINT (X-MMFS-STORE)                      RG800914
257988             MOVE ZERO           TO MS07-VI-SVC-DVLP-IND-L        RG800914
257990             MOVE DFHBMDAS       TO MS07-VI-SVC-DVLP-IND-LP-A     RG800914
257992                                    MS07-VI-SVC-DVLP-IND-RP-A     RG800914
257994             MOVE DFHBMASK       TO MS07-VI-SVC-DVLP-IND-A.       RG800914
257996*                                                                 RG800914
257998 Y469-EXIT.                                                       RG800914
258000     EXIT.                                                        RG800914
258002*                                                                 RG800914
258100 Y800-SET-CURSOR.                                                 RG800914
258120*                                                                 RG800914
258200************************************************************
258300*    THIS ROUTINE IS PERFORMED IF IN ADD OR MAINTENANCE    *
258400*    AND SETS THE CURSOR TO THE FIRST FIELD WHICH IS       *
258500*    OPEN FOR INPUT                                        *
258600************************************************************
258700*
258800* VISA DBA NAME
258900*
259000     MOVE MMSMTB-VI-DBA-NAME (1:4)
259100                                 TO WS-INDEX-X.
259200     SET X-MMFS-STORE            TO WS-INDEX.
259300*
259400     EVALUATE TRUE
259500         WHEN MBCA-PTI-FUNCTION-IS-ADD
259600             IF  MMFS-ST-OPTIONAL (X-MMFS-STORE)
259700             OR  MMFS-ST-REQUIRED (X-MMFS-STORE)
259800                 MOVE SS08WS-CURSOR
259900                                  TO MS07-VI-DBA-NAME-L
260000             END-IF
260100         WHEN MBCA-PTI-FUNCTION-IS-MAINT
260200             IF  MMFS-ST-MAINT-ALLOWED (X-MMFS-STORE)
260300                 MOVE SS08WS-CURSOR
260400                                  TO MS07-VI-DBA-NAME-L
260500             END-IF
260600     END-EVALUATE.
260700*
260800* VISA INTCHG IND
260900*
261000     MOVE MMSMTB-VI-INTCHG-IND (1:4)
261100                                 TO WS-INDEX-X.
261200     SET X-MMFS-STORE            TO WS-INDEX.
261300*
261400     EVALUATE TRUE
261500         WHEN MBCA-PTI-FUNCTION-IS-ADD
261600             IF  MMFS-ST-OPTIONAL (X-MMFS-STORE)
261700             OR  MMFS-ST-REQUIRED (X-MMFS-STORE)
261800                 MOVE SS08WS-CURSOR
261900                                  TO MS07-VI-INTCHG-FLAG-L
262000             END-IF
262100         WHEN MBCA-PTI-FUNCTION-IS-MAINT
262200             IF  MMFS-ST-MAINT-ALLOWED (X-MMFS-STORE)
262300                 MOVE SS08WS-CURSOR
262400                                  TO MS07-VI-INTCHG-FLAG-L
262500             END-IF
262600     END-EVALUATE.
262700*
262800* VISA MEMBER ID
262900*
263000     MOVE MMSMTB-VI-MEMBER-ID (1:4)
263100                                 TO WS-INDEX-X.
263200     SET X-MMFS-STORE            TO WS-INDEX.
263300*
263400     EVALUATE TRUE
263500         WHEN MBCA-PTI-FUNCTION-IS-ADD
263600             IF  MMFS-ST-OPTIONAL (X-MMFS-STORE)
263700             OR  MMFS-ST-REQUIRED (X-MMFS-STORE)
263800                 MOVE SS08WS-CURSOR
263900                                  TO MS07-VI-MEMBER-ID-L
264000             END-IF
264100         WHEN MBCA-PTI-FUNCTION-IS-MAINT
264200             IF  MMFS-ST-MAINT-ALLOWED (X-MMFS-STORE)
264300                 MOVE SS08WS-CURSOR
264400                                  TO MS07-VI-MEMBER-ID-L
264500             END-IF
264600     END-EVALUATE.
264700*
264800* VISA SPECIAL COND 1
264900*
265000     MOVE MMSMTB-VI-SPECIAL-COND-1 (1:4)
265100                                 TO WS-INDEX-X.
265200     SET X-MMFS-STORE            TO WS-INDEX.
265300*
265400     EVALUATE TRUE
265500         WHEN MBCA-PTI-FUNCTION-IS-ADD
265600             IF  MMFS-ST-OPTIONAL (X-MMFS-STORE)
265700             OR  MMFS-ST-REQUIRED (X-MMFS-STORE)
265800                 MOVE SS08WS-CURSOR
265900                                  TO MS07-VI-SPECIAL-COND-1-L
266000             END-IF
266100         WHEN MBCA-PTI-FUNCTION-IS-MAINT
266200             IF  MMFS-ST-MAINT-ALLOWED (X-MMFS-STORE)
266300                 MOVE SS08WS-CURSOR
266400                                  TO MS07-VI-SPECIAL-COND-1-L
266500             END-IF
266600     END-EVALUATE.
266700*
266800* VISA SPECIAL COND 2
266900*
267000     MOVE MMSMTB-VI-SPECIAL-COND-2 (1:4)
267100                                 TO WS-INDEX-X.
267200     SET X-MMFS-STORE            TO WS-INDEX.
267300*
267400     EVALUATE TRUE
267500         WHEN MBCA-PTI-FUNCTION-IS-ADD
267600             IF  MMFS-ST-OPTIONAL (X-MMFS-STORE)
267700             OR  MMFS-ST-REQUIRED (X-MMFS-STORE)
267800                 MOVE SS08WS-CURSOR
267900                                  TO MS07-VI-SPECIAL-COND-2-L
268000             END-IF
268100         WHEN MBCA-PTI-FUNCTION-IS-MAINT
268200             IF  MMFS-ST-MAINT-ALLOWED (X-MMFS-STORE)
268300                 MOVE SS08WS-CURSOR
268400                                  TO MS07-VI-SPECIAL-COND-2-L
268500             END-IF
268600     END-EVALUATE.
268700*
268800* VISA MAIL PHONE IND
268900*
269000     MOVE MMSMTB-VI-MAIL-PHONE-IND (1:4)
269100                                 TO WS-INDEX-X.
269200     SET X-MMFS-STORE            TO WS-INDEX.
269300*
269400     EVALUATE TRUE
269500         WHEN MBCA-PTI-FUNCTION-IS-ADD
269600             IF  MMFS-ST-OPTIONAL (X-MMFS-STORE)
269700             OR  MMFS-ST-REQUIRED (X-MMFS-STORE)
269800                 MOVE SS08WS-CURSOR
269900                                  TO MS07-VI-MAIL-PHONE-IND-L
270000             END-IF
270100         WHEN MBCA-PTI-FUNCTION-IS-MAINT
270200             IF  MMFS-ST-MAINT-ALLOWED (X-MMFS-STORE)
270300                 MOVE SS08WS-CURSOR
270400                                  TO MS07-VI-MAIL-PHONE-IND-L
270500             END-IF
270600     END-EVALUATE.
270700*
270800*  VISA CH TERM IND
270900*
271000     MOVE MMSMTB-VI-CH-TERM-IND (1:4)
271100                                 TO WS-INDEX-X.
271200     SET X-MMFS-STORE            TO WS-INDEX.
271300*
271400     EVALUATE TRUE
271500         WHEN MBCA-PTI-FUNCTION-IS-ADD
271600             IF  MMFS-ST-OPTIONAL (X-MMFS-STORE)
271700             OR  MMFS-ST-REQUIRED (X-MMFS-STORE)
271800                 MOVE SS08WS-CURSOR
271900                                  TO MS07-VI-CH-TERM-IND-L
272000             END-IF
272100         WHEN MBCA-PTI-FUNCTION-IS-MAINT
272200             IF  MMFS-ST-MAINT-ALLOWED (X-MMFS-STORE)
272300                 MOVE SS08WS-CURSOR
272400                                  TO MS07-VI-CH-TERM-IND-L
272500             END-IF
272600     END-EVALUATE.
272700*
272800* VISA VOLUME IND
272900*
273000     MOVE MMSMTB-VI-VOLUME-IND (1:4)
273100                                 TO WS-INDEX-X.
273200     SET X-MMFS-STORE            TO WS-INDEX.
273300*
273400     EVALUATE TRUE
273500         WHEN MBCA-PTI-FUNCTION-IS-ADD
273600             IF  MMFS-ST-OPTIONAL (X-MMFS-STORE)
273700             OR  MMFS-ST-REQUIRED (X-MMFS-STORE)
273800                 MOVE SS08WS-CURSOR
273900                                  TO MS07-VI-VOLUME-IND-L
274000             END-IF
274100         WHEN MBCA-PTI-FUNCTION-IS-MAINT
274200             IF  MMFS-ST-MAINT-ALLOWED (X-MMFS-STORE)
274300                 MOVE SS08WS-CURSOR
274400                                  TO MS07-VI-VOLUME-IND-L
274500             END-IF
274600     END-EVALUATE.
274700*
274800* VISA RPT-THSHOLD
274900*
275000     MOVE MMSMTB-VI-RPT-THSHOLD (1:4)
275100                                 TO WS-INDEX-X.
275200     SET X-MMFS-STORE            TO WS-INDEX.
275300*
275400     EVALUATE TRUE
275500         WHEN MBCA-PTI-FUNCTION-IS-ADD
275600             IF  MMFS-ST-OPTIONAL (X-MMFS-STORE)
275700             OR  MMFS-ST-REQUIRED (X-MMFS-STORE)
275800                 MOVE SS08WS-CURSOR
275900                                  TO MS07-VI-RPT-THSHOLD-L
276000             END-IF
276100         WHEN MBCA-PTI-FUNCTION-IS-MAINT
276200             IF  MMFS-ST-MAINT-ALLOWED (X-MMFS-STORE)
276300                 MOVE SS08WS-CURSOR
276400                                  TO MS07-VI-RPT-THSHOLD-L
276500             END-IF
276600     END-EVALUATE.
276602*                                                                 RG802901
276604* VISA CONTACT INDICATOR                                          RG802901
276606*                                                                 RG802901
276608     MOVE MMSMTB-VI-CONTACT-IND (1:4)                             RG802901
276610                                 TO WS-INDEX-X.                   RG802901
276612     SET X-MMFS-STORE            TO WS-INDEX.                     RG802901
276614*                                                                 RG802901
276616     IF  MBCA-PTI-FUNCTION-IS-ADD                                 RG802901
276618         IF  MMFS-ST-OPTIONAL (X-MMFS-STORE)                      RG802901
276620         OR  MMFS-ST-REQUIRED (X-MMFS-STORE)                      RG802901
276622             MOVE SS08WS-CURSOR  TO MS07-VI-CONTACT-IND-L         RG802901
276624             GO TO Y809-SC-EXIT.                                  RG802901
276626*                                                                 RG802901
276628     IF  MBCA-PTI-FUNCTION-IS-MAINT                               RG802901
276630         IF  MMFS-ST-MAINT-ALLOWED (X-MMFS-STORE)                 RG802901
276632             MOVE SS08WS-CURSOR  TO MS07-VI-CONTACT-IND-L         RG802901
276634             GO TO Y809-SC-EXIT.                                  RG802901
276639*                                                                 RG802901
276700*
276800* VISA CRB REGION
276900*
277000     MOVE MMSMTB-VI-CRB-REGION (1:4)
277100                                 TO WS-INDEX-X.
277200     SET X-MMFS-STORE            TO WS-INDEX.
277300*
277400     EVALUATE TRUE
277500         WHEN MBCA-PTI-FUNCTION-IS-ADD
277600             IF  MMFS-ST-OPTIONAL (X-MMFS-STORE)
277700             OR  MMFS-ST-REQUIRED (X-MMFS-STORE)
277800                 MOVE SS08WS-CURSOR
277900                                  TO MS07-VI-CRB-REGION-L
278000             END-IF
278100         WHEN MBCA-PTI-FUNCTION-IS-MAINT
278200             IF  MMFS-ST-MAINT-ALLOWED (X-MMFS-STORE)
278300                 MOVE SS08WS-CURSOR
278400                                  TO MS07-VI-CRB-REGION-L
278500             END-IF
278600     END-EVALUATE.
278700*
278800* VISA REG ADDR IND 1
278900*
279000     MOVE MMSMTB-VI-REG-ADDR-IND1 (1:4)
279100                                 TO WS-INDEX-X.
279200     SET X-MMFS-STORE            TO WS-INDEX.
279300*
279400     EVALUATE TRUE
279500         WHEN MBCA-PTI-FUNCTION-IS-ADD
279600             IF  MMFS-ST-OPTIONAL (X-MMFS-STORE)
279700             OR  MMFS-ST-REQUIRED (X-MMFS-STORE)
279800                 MOVE SS08WS-CURSOR
279900                                  TO MS07-VI-REG-ADDR-IND1-L
280000             END-IF
280100         WHEN MBCA-PTI-FUNCTION-IS-MAINT
280200             IF  MMFS-ST-MAINT-ALLOWED (X-MMFS-STORE)
280300                 MOVE SS08WS-CURSOR
280400                                  TO MS07-VI-REG-ADDR-IND1-L
280500             END-IF
280600     END-EVALUATE.
280700*
280800* VISA REG ADDR IND 2
280900*
281000     MOVE MMSMTB-VI-REG-ADDR-IND2 (1:4)
281100                                 TO WS-INDEX-X.
281200     SET X-MMFS-STORE            TO WS-INDEX.
281300*
281400     EVALUATE TRUE
281500         WHEN MBCA-PTI-FUNCTION-IS-ADD
281600             IF  MMFS-ST-OPTIONAL (X-MMFS-STORE)
281700             OR  MMFS-ST-REQUIRED (X-MMFS-STORE)
281800                 MOVE SS08WS-CURSOR
281900                                  TO MS07-VI-REG-ADDR-IND2-L
282000             END-IF
282100         WHEN MBCA-PTI-FUNCTION-IS-MAINT
282200             IF  MMFS-ST-MAINT-ALLOWED (X-MMFS-STORE)
282300                 MOVE SS08WS-CURSOR
282400                                  TO MS07-VI-REG-ADDR-IND2-L
282500             END-IF
282600     END-EVALUATE.
282700*
282800* VISA CATEGORY CODE
282900*
283000     MOVE MMSMTB-VI-CATEGORY-CODE (1:4)
283100                                 TO WS-INDEX-X.
283200     SET X-MMFS-STORE            TO WS-INDEX.
283300*
283400     EVALUATE TRUE
283500         WHEN MBCA-PTI-FUNCTION-IS-ADD
283600             IF  MMFS-ST-OPTIONAL (X-MMFS-STORE)
283700             OR  MMFS-ST-REQUIRED (X-MMFS-STORE)
283800                 MOVE SS08WS-CURSOR
283900                                  TO MS07-VI-CATEGORY-CODE-L
284000             END-IF
284100         WHEN MBCA-PTI-FUNCTION-IS-MAINT
284200             IF  MMFS-ST-MAINT-ALLOWED (X-MMFS-STORE)
284300                 MOVE SS08WS-CURSOR
284400                                  TO MS07-VI-CATEGORY-CODE-L
284500             END-IF
284600     END-EVALUATE.
284700*
284800* VISA FLOOR LIMIT
284900*
285000     MOVE MMSMTB-VI-FLOOR-LIMIT (1:4)
285100                                 TO WS-INDEX-X.
285200     SET X-MMFS-STORE            TO WS-INDEX.
285300*
285400     EVALUATE TRUE
285500         WHEN MBCA-PTI-FUNCTION-IS-ADD
285600             IF  MMFS-ST-OPTIONAL (X-MMFS-STORE)
285700             OR  MMFS-ST-REQUIRED (X-MMFS-STORE)
285800                 MOVE SS08WS-CURSOR
285900                                  TO MS07-VI-FLOOR-LIMIT-L
286000             END-IF
286100         WHEN MBCA-PTI-FUNCTION-IS-MAINT
286200             IF  MMFS-ST-MAINT-ALLOWED (X-MMFS-STORE)
286300                 MOVE SS08WS-CURSOR
286400                                  TO MS07-VI-FLOOR-LIMIT-L
286500             END-IF
286600     END-EVALUATE.
286700*
286800 Y809-SC-EXIT.
286900     EXIT.
287000*
287100 Y900-READ-MMFS.
287200*
287300****************************************
287400*    READ THE FIELD SECURITY RECORD    *
287500*    TO OBTAIN THE SECURITY CODES      *
287600****************************************
287700*
287800     MOVE MBCA-MERCHANT-ORG      TO MBIOWS-MMFS-ORG.
287900     MOVE MBCA-FIELD-SECURITY    TO MBIOWS-MMFS-FS-CODE.
288000     SET MBIORO-READ-RANDOM      TO TRUE.
288100     PERFORM MMFSAO-ACCESS       THRU MMFSAO-ACCESS-EXIT.
288200*
288300     IF  NOT MMFS-REC-ACTIVE
288400         MOVE MBIORO-IO-REQUEST  TO MBCA-ERRR-IO-REQUEST
288500         MOVE MBIORO-FILE-NAME   TO MBCA-ERRR-EIBDS
288600         MOVE EIBFN              TO MBCA-ERRR-EIBFN-CODES
288700         MOVE MBCA-PROGRAM-ID    TO MBCA-ERRR-BAD-PROGRAM
288800         MOVE MBCA-TRANS-ID      TO MBCA-ERRR-BAD-TRANSID
288900         SET MBCA-ERROR-MSGS-PROVIDED
289000                                 TO TRUE
289100         MOVE 'READ ERROR - MMFSAO'
289200                                 TO MBCA-ERRR-MSG1
289300         MOVE 'FIELD SECURITY PROFILE IS NOT ACTIVE'
289400                                 TO MBCA-ERRR-MSG2
289500         GO TO MB70PD-ERROR-ROUTINE.
289600*
289700 Y909-READ-MMFS-EXIT.
289800     EXIT.
289900*
290000 Y920-WRITE-LOG-RECORD.
290100*
290200     SET MBIORO-WRITE            TO TRUE.
290300     PERFORM MML1AO-ACCESS       THRU MML1AO-ACCESS-EXIT.
290400     MOVE SPACES                 TO MML1-VARIABLE-AREA.
290500*
290600 Y929-WLR-EXIT.
290700     EXIT.
290800/
290900 Z000-COPIED-ROUTINES SECTION.
291000*
291100*********************************
291200*    DATE VALIDATION ROUTINE    *
291300*********************************
291400*
291500     COPY SS05PD.
291600/
291700**********************************
291800*    GREG TO JUL DATE ROUTINE    *
291900**********************************
292000*
292100     COPY SS07PD.
292200*
292300/    NEW ROUTINE FOR JULIAN TO GREGORIAN CONVERSION
292400     COPY SS26PD.
292500*
292600/    ROUTINE TO NUMERICALLY EDIT TIME
292700     COPY SS27PD.
292800*
292900**********************************
293000*    JUL TO GREG DATE ROUTINE    *
293100**********************************
293200*
293300     COPY SS08PD.
293400*
293500/    ROUTINE TO MOVE COMMAREA VARIABLES TO
293600*                    SS08-FORMATTED-MSG VARIABLE.
293700     COPY MB06PD.
293800*
293900/
294000*********************************
294100*    LINE 24 PF KEYS ROUTINE    *
294200*********************************
294300*
294400     COPY SS15PD.
294500/
294600************************************************
294700*    STORE MASTER RECORD ACCESS ROUTINES       *
294800************************************************
294900*
295000     COPY MMSMAO.
295100/
295200************************************************
295300*    MERCHANT PRODUCT RECORD ACCESS ROUTINES   *
295400************************************************
295500*
295600     COPY MMMPAO.
295700/
295800************************************************
295900*    ORG CONTROL MASTER RECORD ACCESS ROUTINES *
296000************************************************
296100*
296200     COPY MMOCAO.
296300/
296400***********************************************
296500*    FIELD SECURITY RECORD ACCESS ROUTINES    *
296600***********************************************
296700*
296800     COPY MMFSAO.
296900/
297000*****************************************
297100*    LOG FILE RECORD ACCESS ROUTINES    *
297200*****************************************
297300*
297400     COPY MML1AO.
297500/
297600     COPY SMCAPXO REPLACING ==:XXCA:== BY ==MBCA==.
297700/
297800*****************************
297900*    ONLINE MAP ROUTINES    *
298000*****************************
298100*
298200     COPY MB60PD REPLACING 'MBMAPXX' BY 'MBMS07 '
298300                           MBMAPXXI BY MBMS07I
298400                           MBMAPXXO BY MBMS07O.
298500/
298600***************************
298700*    ONLINE PROCEDURES    *
298800***************************
298900*
299000     COPY MB70PD.
299100/
299200     COPY SMFTPXO.
