000100 IDENTIFICATION DIVISION.
000200 PROGRAM-ID. MBOMT01.
000201*       RELEASE DATE=08/24/01.        REVISION LEVEL=08.06      * ++++++++
000202***************************************************************** ++++++++
000203*WARNING.  THIS COMPUTER PROGRAM IS PROTECTED BY COPYRIGHT LAW  * ++++++++
000204*AND INTERNATIONAL TREATIES.  UNAUTHORIZED REPRODUCTION OR      * ++++++++
000205*DISTRIBUTION OF THIS PROGRAM, OR ANY PORTION OF IT, MAY RESULT * ++++++++
000206*IN SEVERE CIVIL AND CRIMINAL PENATLIES, AND WILL BE PROSECUTED * ++++++++
000207*TO THE MAXIMUM EXTENT POSSIBLE UNDER THE LAW.                  * ++++++++
000208*COPYRIGHT 1999 PAYSYS INTERNATIONAL, INC.  ALL RIGHTS RESERVED.* ++++++++
000209***************************************************************** ++++++++
000300*****************************************************************
000400*                                                               *
000500*   V - PLUS  M E R C H A N T   B A N K C A R D   S Y S T E M   *
000600*                                                               *
000700*      MBOMT01 - ON-LINE TRAN CODE TRANSLATION                  *
000800*                SCREEN 01                                      *
000900*                                                               *
001000*              1. TRANSIDS                                      *
001100*                 A. MBMT                                       *
001200*              2. MAPS USED -                                   *
001300*                 A. MBMT01 (SCREENS 04)                        *
001400*              3. FILES USED -                                  *
001500*                 A. MMXT   (TRAN CODE TRANSLATION FILE)        *
001600*                 B. MMTC   (TRAN CONTROL FILE)                 *
001700*                 C. MMOC   (ORG CONTROL FILE)                  *
001800*                 D. MML1   (LOG FILE)                          *
001900*                                                               *
002000*****************************************************************
002100*
002200 ENVIRONMENT DIVISION.
002300 DATA DIVISION.
002400 WORKING-STORAGE SECTION.
002500 01  FILLER                  PIC  X(12)      VALUE '** WS-BEG **'.
002600*         I/O REQUEST BLOCK WORK AREAS
002700     COPY MBIOWS.
002800/         I/O REQUEST BLOCK
002900     COPY MBIORO.
003000/         LOG/JOURNAL WORK AREAS
003100     COPY MML1WS REPLACING ==:MML1:== BY ==MML1==.
003200/         MONETARY TRANS CONTROL WORK AREA
003300     COPY MMTCWS.
003400/         DESC TABLE FOR VISA MC AND PL
003500     COPY MB80WS.
003600/         DATE WORK AREAS
003700     COPY SS01WS.
003800/         ONLINE WORK AREAS
003900     COPY SS08WS.
004000/
004100     COPY SS00WS.
004200/
004300     COPY SMFTWS.
004400/
004500     COPY SMPTRL REPLACING ==:SMPT:== BY ==SMPT==.
004600/
004700     COPY MB61LK.
004800/
004900 01  WS-MISCELLANEOUS.
005000     03  WS-UPDATE-SW        PIC  X(01)      VALUE 'N'.
005100         88  WS-UPDATE-SW-NO                 VALUE 'N'.
005200         88  WS-UPDATE-SW-YES                VALUE 'Y'.
005300     03  WS-INDEX            PIC S9(04)      BINARY.
005400     03  WS-NBR-INDEX        PIC S9(04)      BINARY.
005500*
005600 01  FILLER                  PIC  X(12)      VALUE '** WS-END **'.
005700/
005800 LINKAGE SECTION.
005900 01  DFHCOMMAREA.
006000     COPY MB60WS.
006100/         MERCHANT TRAN CODE TRANSLATION SCREEN 01 MAP DSECT
006200     COPY MBMT01.
006300/         MERCHANT TRAN CODE TRANSLATION SCREEN 01 MAP REDEF
006400     COPY MBMT01R.
006500/         MERCHANT TRAN CODE TRANSLATION MASTER RECORD LAYOUT
006600     COPY MMXTRL.
006700/         TRANSACTION CONTROL FILE MASTER RECORD LAYOUT
006800     COPY MMTCRL.
006900/         ORG CONTROL FILE MASTER RECORD LAYOUT
007000     COPY MMOCRL.
007100/         LOG/JOURNAL FILE RECORD LAYOUT
007200     COPY MML1RL REPLACING ==:MML1:== BY ==MML1==.
007300/
007400 PROCEDURE DIVISION.
007500 0000-HOUSEKEEPING SECTION.
007600 0100-INIT.
007700*
007800     MOVE 'PC01'                 TO MBCA-PROGRAM-LOCATION.
007900     PERFORM MB70PD-ON-LINE-HOUSEKEEPING
008000                                 THRU MB70PD-OLH-EXIT.
008100*
008200     IF  MBCA-RECEIVE-SCREEN
008300         GO TO 2000-RECEIVE-SCREEN.
008400*
008500 1000-SEND-SCREEN SECTION.
008600*
008700****************************************************************
008800*    THIS SECTION BUILDS AND SENDS THE SCREENS 01              *
008900****************************************************************
009000*
009100****************************************************************
009200*    GET CICS STORAGE NEEDED FOR THE MAP                       *
009300****************************************************************
009400*
009500     MOVE 'SC01'                 TO MBCA-PROGRAM-LOCATION.
009600     PERFORM MB60PD-GETMAIN-FOR-MAP
009700                                 THRU MB60PD-GFM-EXIT.
009800*
009900     MOVE MBCA-MERCHANT-ORG      TO MT01-ORG.
010000*
010100****************************************************************
010200*    READ THE ORG CONTROL FILE  FILE                           *
010300****************************************************************
010400*
010500     MOVE 'FC01'                 TO MBCA-PROGRAM-LOCATION.
010600     MOVE MBCA-MERCHANT-ORG      TO MBIOWS-MMOC-ORG.
010700     SET MBIORO-READ-RANDOM      TO TRUE.
010800     PERFORM MMOCAO-ACCESS       THRU MMOCAO-ACCESS-EXIT.
010900*
011000     MOVE MMOC-NA-LINE (1 1)     TO MT01-ORG-NAME.
011100*
011200****************************************************************
011300*    INITIALIZE THE STANDARD MAP LINES                         *
011400****************************************************************
011500*
011600     SET X-MMXT-TCTT             TO MBCA-MBMT-INDEX.
011700*
011800     IF  MBCA-PTI-FUNCTION-IS-ADD
011900         MOVE 01                 TO MBCA-SCREEN-NBR
012000         PERFORM MB60PD-INIT-STD-MAP-LINES
012100                                 THRU MB60PD-ISML-EXIT
012200         PERFORM
012300             VARYING X-MT01-XT FROM 1 BY 1
012400             UNTIL X-MT01-XT IS GREATER THAN 30
012500             SET WS-INDEX        TO X-MMXT-TCTT
012600             MOVE WS-INDEX       TO MT01-INDEX-NBR (X-MT01-XT)
012700             MOVE '.'            TO MT01-INDEX-PERIOD (X-MT01-XT)
012800             SET X-MMXT-TCTT     UP BY 1
012900         END-PERFORM
013000         SET X-MMXT-TCTT         TO MBCA-MBMT-INDEX
013100         GO TO 1060-SET-ATTRIBUTE.
013200*
013300     PERFORM MB60PD-INIT-STD-MAP-LINES
013400                                 THRU MB60PD-ISML-EXIT.
013500*
013600*
013700****************************************************************
013800*    READ THE TRAN CODE TRANSLATION FILE                       *
013900****************************************************************
014000*
014100     MOVE 'FC02'                 TO MBCA-PROGRAM-LOCATION.
014200     MOVE MBCA-MERCHANT-ORG      TO MBIOWS-MMXT-ORG.
014300     SET MBIORO-READ-RANDOM      TO TRUE.
014400     PERFORM MMXTAO-ACCESS       THRU MMXTAO-ACCESS-EXIT.
014500*
014600 1050-BUILD-SCREEN.
014700*
014800****************************************************************
014900*    IF  INQUIRY, DARKEN PARENS AND ASKIP FIELDS               *
015000****************************************************************
015100*
015200     IF  MBCA-PTI-FUNCTION-IS-INQUIRY
015300         MOVE SS08WS-CURSOR      TO MT01-ALT-TRANID-L
015400         PERFORM
015500             VARYING X-MT01-XT FROM 1 BY 1
015600             UNTIL X-MT01-XT IS GREATER THAN 30
015700             MOVE DFHBMASB       TO MT01-CMS-TC-A
015800                                    (X-MT01-XT)
015900                                    MT01-MBS-TC-A
016000                                    (X-MT01-XT)
016100             MOVE DFHBMDAS       TO MT01-CMS-TC-LP-A
016200                                    (X-MT01-XT)
016300                                    MT01-CMS-TC-RP-A
016400                                    (X-MT01-XT)
016500                                    MT01-MBS-TC-LP-A
016600                                    (X-MT01-XT)
016700                                    MT01-MBS-TC-RP-A
016800                                    (X-MT01-XT)
016900         END-PERFORM.
017000*
017100     PERFORM 9500-BUILD-SCREEN   THRU 9599-BS-EXIT.
017200*
017300 1060-SET-ATTRIBUTE.
017400*
017500     MOVE 01                     TO MBCA-SCREEN-NBR.
017600*
017700     MOVE SS08WS-CURSOR          TO MT01-CMS-TC-L (1).
017800*
017900 1100-CONTINUE.
018000*
018100     IF  MBCA-PTI-FUNCTION-MAINT-OR-INQ
018200         MOVE '*TOP*'            TO SS08WS-LINE-24-PF-KEY-FUNC(3)
018300         MOVE '*BOT*'            TO SS08WS-LINE-24-PF-KEY-FUNC(4)
018400         MOVE '*FWD*'            TO SS08WS-LINE-24-PF-KEY-FUNC(5)
018500         MOVE '*BWD*'            TO SS08WS-LINE-24-PF-KEY-FUNC(6)
018600         MOVE SS08WS-LINE-24     TO MT01-PF-KEYS
018700         MOVE 'RESV'             TO MBCA-PGMX-PF-TRANS-ID (3)
018800         MOVE 'RESV'             TO MBCA-PGMX-PF-TRANS-ID (4)
018900         MOVE 'RESV'             TO MBCA-PGMX-PF-TRANS-ID (5)
019000         MOVE 'RESV'             TO MBCA-PGMX-PF-TRANS-ID (6).
019100*
019200****************************************************************
019300*    SEND THE MAP                                              *
019400****************************************************************
019500*
019600     MOVE 'BM01'                 TO MBCA-PROGRAM-LOCATION.
019700     PERFORM MB60PD-SEND-MAP-WITH-ERASE
019800                                 THRU MB60PD-SMWE-EXIT.
019900*
020000****************************************************************
020100*    RETURN TO CICS                                            *
020200****************************************************************
020300*
020400     MOVE 'PC02'                 TO MBCA-PROGRAM-LOCATION.
020500     PERFORM MB70PD-RETURN-TRANS-ID
020600                                 THRU MB70PD-RTI-EXIT.
020700/
020800 2000-RECEIVE-SCREEN SECTION.
020900*
021000****************************************************************
021100*    THIS SECTION RECEIVES THE 04 SCREEN                       *
021200****************************************************************
021300*
021400     MOVE 'BM02'                 TO MBCA-PROGRAM-LOCATION.
021500     PERFORM MB60PD-RECEIVE-MAP  THRU MB60PD-RM-EXIT.
021600*
021700****************************************************************
021800*    CHECK FOR ANOTHER TRANSACTION ID ENTERED BY THE USER      *
021900****************************************************************
022000*
022100     MOVE 'PC03'                 TO MBCA-PROGRAM-LOCATION.
022200     PERFORM MB60PD-NEW-TRANS-ROUTINE
022300                                 THRU MB60PD-NTR-EXIT.
022400*
022500****************************************************************
022600*    BYPASS EDITS ON INQUIRY                                   *
022700****************************************************************
022800*
022900     SET X-MMXT-TCTT             TO MBCA-MBMT-INDEX.
023000*
023100     IF  MBCA-PTI-FUNCTION-IS-INQUIRY
023200         GO TO 2600-SETUP-COMMAREA.
023300*
023400****************************************************************
023500*    READ RANDOM THE TRAN CODE TRANSLATION FILE                *
023600****************************************************************
023700*
023800     MOVE 'FC03'                 TO MBCA-PROGRAM-LOCATION.
023900     MOVE MBCA-MERCHANT-ORG      TO MBIOWS-MMXT-ORG.
024000     SET MBIORO-READ-RANDOM      TO TRUE.
024100     PERFORM MMXTAO-ACCESS       THRU MMXTAO-ACCESS-EXIT.
024200*
024300****************************************************************
024400*    EDIT FIELDS                                               *
024500****************************************************************
024600*
024700****************************************************************
024800*                  TRANSCODE TRANSLATION (CMS MBS)             *
024900****************************************************************
025000*
025100     SET X-MMXT-TCTT             TO MBCA-MBMT-INDEX.
025200*
025300     PERFORM
025400         VARYING X-MT01-XT FROM 1 BY 1
025500         UNTIL X-MT01-XT IS GREATER THAN 30
025600         EVALUATE TRUE
025700           WHEN MT01-CMS-TC-L (X-MT01-XT) IS LESS THAN 1
025800             MOVE DFHBMASK       TO MT01-CMS-TC-A (X-MT01-XT)
025900             MOVE DFHBMDAS       TO MT01-CMS-TC-LP-A (X-MT01-XT)
026000                                    MT01-CMS-TC-RP-A (X-MT01-XT)
026100             IF  X-MMXT-TCTT IS GREATER THAN 998                  FX800023
026110                 MOVE DFHBMDAS   TO MT01-CMS-TC-LP-A              FX800023
026112                                    (X-MT01-XT)                   FX800023
026114                                    MT01-CMS-TC-RP-A              FX800023
026116                                    (X-MT01-XT)                   FX800023
026118                                    MT01-MBS-TC-LP-A              FX800023
026120                                    (X-MT01-XT)                   FX800023
026122                                    MT01-MBS-TC-RP-A              FX800023
026124                                    (X-MT01-XT)                   FX800023
026126                                    MT01-CMS-TC-A                 FX800023
026200                                    (X-MT01-XT)                   FX800023
026210                                    MT01-MBS-TC-A                 FX800023
026212                                    (X-MT01-XT)                   FX800023
026214                                    MT01-MBS-TC-DESC-A            FX800023
026216                                    (X-MT01-XT)                   FX800023
026218                                    MT01-INDEX-A                  FX800023
026220                                    (X-MT01-XT)                   FX800023
026222             ELSE                                                 FX800023
026224                 MOVE MMXT-CMS-TC (X-MMXT-TCTT)                   FX800023
026226                                 TO MT01-CMS-TC (X-MT01-XT)       FX800023
026228             END-IF                                               FX800023
026300           WHEN MT01-CMS-TC-L (X-MT01-XT) IS GREATER THAN ZEROS
026400             IF  MT01-CMS-TC (X-MT01-XT) IS NUMERIC
026500                 MOVE DFHBMASF   TO MT01-CMS-TC-A (X-MT01-XT)
026600                 MOVE DFHBMDAS   TO MT01-CMS-TC-LP-A (X-MT01-XT)
026700                                    MT01-CMS-TC-RP-A (X-MT01-XT)
026800                 SET WS-UPDATE-SW-YES
026900                                 TO TRUE
027000             ELSE
027100                 MOVE DFHBMNBF   TO MT01-CMS-TC-A (X-MT01-XT)
027200                 MOVE DFHBMASB   TO MT01-CMS-TC-LP-A (X-MT01-XT)
027300                                    MT01-CMS-TC-RP-A (X-MT01-XT)
027400                 MOVE SS08WS-CURSOR TO MT01-CMS-TC-L (X-MT01-XT)
027500                 SET SS08WS-ERROR-SW-YES
027600                                 TO TRUE
027700             END-IF
027800         END-EVALUATE
027900         EVALUATE TRUE
028000           WHEN MT01-MBS-TC-L (X-MT01-XT) IS LESS THAN 1
028100             MOVE DFHBMASK       TO MT01-MBS-TC-A (X-MT01-XT)
028200             MOVE DFHBMDAS       TO MT01-MBS-TC-LP-A (X-MT01-XT)
028300                                    MT01-MBS-TC-RP-A (X-MT01-XT)
028400             IF  X-MMXT-TCTT IS GREATER THAN 998                  FX800023
028410                 MOVE DFHBMDAS   TO MT01-CMS-TC-LP-A              FX800023
028412                                    (X-MT01-XT)                   FX800023
028414                                    MT01-CMS-TC-RP-A              FX800023
028416                                    (X-MT01-XT)                   FX800023
028418                                    MT01-MBS-TC-LP-A              FX800023
028420                                    (X-MT01-XT)                   FX800023
028422                                    MT01-MBS-TC-RP-A              FX800023
028424                                    (X-MT01-XT)                   FX800023
028426                                    MT01-CMS-TC-A                 FX800023
028500                                    (X-MT01-XT)                   FX800023
028510                                    MT01-MBS-TC-A                 FX800023
028512                                    (X-MT01-XT)                   FX800023
028514                                    MT01-MBS-TC-DESC-A            FX800023
028516                                    (X-MT01-XT)                   FX800023
028518                                    MT01-INDEX-A                  FX800023
028520                                    (X-MT01-XT)                   FX800023
028522             ELSE                                                 FX800023
028524                 MOVE MMXT-CMS-TC (X-MMXT-TCTT)                   FX800023
028526                                 TO MT01-CMS-TC (X-MT01-XT)       FX800023
028528             END-IF                                               FX800023
028600           WHEN MT01-MBS-TC-L (X-MT01-XT) IS GREATER THAN ZEROS
028700             IF  MT01-MBS-TC (X-MT01-XT) IS NUMERIC
028800               IF  MT01-MBS-TC (X-MT01-XT) IS EQUAL TO ZEROS
028900                   CONTINUE
029000               ELSE
029100                   PERFORM 9600-READ-MMTC
029200                                 THRU 9699-EXIT
029300                   IF  SS08WS-RC-FC-NOTFND
029400                   OR  NOT MMTCWS-LM-VALID-VIA-FRONT-END
029500                       MOVE DFHBMNBF
029600                                 TO MT01-MBS-TC-A (X-MT01-XT)
029700                       MOVE DFHBMASB
029800                                 TO MT01-MBS-TC-LP-A (X-MT01-XT)
029900                                    MT01-MBS-TC-RP-A (X-MT01-XT)
030000                       MOVE SS08WS-CURSOR
030100                                 TO MT01-MBS-TC-L (X-MT01-XT)
030200                       SET SS08WS-ERROR-SW-YES
030300                                 TO TRUE
030400                   ELSE
030500                       IF  MMTC-REC-DEFAULT
030600                       OR  MMTC-REC-USER-DEFINED
030700                           MOVE DFHBMASF
030800                                 TO MT01-MBS-TC-A (X-MT01-XT)
030900                           MOVE DFHBMDAS
031000                                 TO MT01-MBS-TC-LP-A (X-MT01-XT)
031100                                    MT01-MBS-TC-RP-A (X-MT01-XT)
031200                           SET WS-UPDATE-SW-YES
031300                                 TO TRUE
031400                       ELSE
031500                           MOVE DFHBMNBF
031600                                 TO MT01-MBS-TC-A (X-MT01-XT)
031700                           MOVE DFHBMASB
031800                                 TO MT01-MBS-TC-LP-A (X-MT01-XT)
031900                                    MT01-MBS-TC-RP-A (X-MT01-XT)
032000                           MOVE SS08WS-CURSOR
032100                                 TO MT01-MBS-TC-L (X-MT01-XT)
032200                           SET SS08WS-ERROR-SW-YES
032300                                 TO TRUE
032400                       END-IF
032500                   END-IF
032600               END-IF
032700             ELSE
032800                 MOVE DFHBMNBF   TO MT01-MBS-TC-A (X-MT01-XT)
032900                 MOVE DFHBMASB   TO MT01-MBS-TC-LP-A (X-MT01-XT)
033000                                    MT01-MBS-TC-RP-A (X-MT01-XT)
033100                 MOVE SS08WS-CURSOR TO MT01-MBS-TC-L (X-MT01-XT)
033200                 SET SS08WS-ERROR-SW-YES
033300                                 TO TRUE
033400             END-IF
033500         END-EVALUATE
033600         EVALUATE TRUE
033700           WHEN (MT01-MBS-TC (X-MT01-XT) IS GREATER THAN ZERO
033800            AND MT01-CMS-TC (X-MT01-XT) IS EQUAL TO ZERO)
033900                MOVE DFHBMNBF    TO MT01-MBS-TC-A (X-MT01-XT)
034000                                    MT01-CMS-TC-A (X-MT01-XT)
034100                MOVE DFHBMASB    TO MT01-MBS-TC-LP-A (X-MT01-XT)
034200                                    MT01-MBS-TC-RP-A (X-MT01-XT)
034300                                    MT01-CMS-TC-LP-A (X-MT01-XT)
034400                                    MT01-CMS-TC-RP-A (X-MT01-XT)
034500                MOVE SS08WS-CURSOR TO MT01-CMS-TC-L (X-MT01-XT)
034600                SET SS08WS-ERROR-SW-YES
034700                                 TO TRUE
034800         END-EVALUATE
034900         SET X-MMXT-TCTT         UP BY 1
035000     END-PERFORM.
035100*
035200     SET X-MMXT-TCTT             TO MBCA-MBMT-INDEX.
035300*
035400     IF  SS08WS-ERROR-SW-NO
035500         GO TO 2400-UPDATE-FILE.
035600*
035700 2300-SEND-MAP.
035800*
035900****************************************************************
036000*    SEND THE MAP                                              *
036100****************************************************************
036200*
036300     PERFORM MB60PD-INIT-STD-MAP-LINES
036400                                 THRU MB60PD-ISML-EXIT.
036500*
036600     IF  MBCA-PTI-FUNCTION-MAINT-OR-INQ
036700         MOVE '*TOP*'            TO SS08WS-LINE-24-PF-KEY-FUNC(3)
036800         MOVE '*BOT*'            TO SS08WS-LINE-24-PF-KEY-FUNC(4)
036900         MOVE '*FWD*'            TO SS08WS-LINE-24-PF-KEY-FUNC(5)
037000         MOVE '*BWD*'            TO SS08WS-LINE-24-PF-KEY-FUNC(6)
037100         MOVE SS08WS-LINE-24     TO MT01-PF-KEYS
037200         MOVE 'RESV'             TO MBCA-PGMX-PF-TRANS-ID (3)
037300         MOVE 'RESV'             TO MBCA-PGMX-PF-TRANS-ID (4)
037400         MOVE 'RESV'             TO MBCA-PGMX-PF-TRANS-ID (5)
037500         MOVE 'RESV'             TO MBCA-PGMX-PF-TRANS-ID (6).
037600*
037700     MOVE 'BM03'                 TO MBCA-PROGRAM-LOCATION.
037800     PERFORM MB60PD-SEND-MAP-DATA-ONLY
037900                                 THRU MB60PD-SMDO-EXIT.
038000*
038100****************************************************************
038200*    RETURN TO CICS                                            *
038300****************************************************************
038400*
038500     MOVE 'PC04'                 TO MBCA-PROGRAM-LOCATION.
038600     PERFORM MB70PD-RETURN-TRANS-ID
038700                                 THRU MB70PD-RTI-EXIT.
038800/
038900 2400-UPDATE-FILE.
039000*
039100***************************************************************
039200*    READ THE TRAN CODE TRANSLATION FILE RECORD FOR UPDATE    *
039300***************************************************************
039400*
039500     MOVE 'FC04'                 TO MBCA-PROGRAM-LOCATION.
039600     SET MBIORO-READ-RANDOM-UPDATE
039700                                 TO TRUE.
039800     PERFORM MMXTAO-ACCESS       THRU MMXTAO-ACCESS-EXIT.
039900*
040000*************************************
040100*    OBTAIN STORAGE FOR LOG FILE    *
040200*    RECORD IF DOING MAINTENANCE    *
040300*************************************
040400*
040500     MOVE 'SC02'                 TO MBCA-PROGRAM-LOCATION.
040600     SET MBIORO-GETMAIN          TO TRUE.
040700     PERFORM MML1AO-ACCESS       THRU MML1AO-ACCESS-EXIT.
040800*
040900 2500-UPDATE-FIELDS.
041000*
041100     SET X-MMXT-TCTT             TO MBCA-MBMT-INDEX.
041200*
041300*            ***** TRAN CODE TRANSALATION (CMS MBS) *****       *
041400*
041500     PERFORM
041600         VARYING X-MT01-XT FROM 1 BY 1
041700         UNTIL X-MT01-XT IS GREATER THAN 30
041800         EVALUATE TRUE
041900           WHEN  MT01-CMS-TC-L (X-MT01-XT) IS GREATER THAN ZERO
042000             IF  MBCA-PTI-FUNCTION-IS-MAINT
042100                 SET WS-INDEX    TO X-MMXT-TCTT
042200                 MOVE WS-INDEX   TO MML1-FIELD-OCCURRENCE
042300                 MOVE ZEROS      TO MML1-FIELD-OCCURRENCE-2
042400                 MOVE 0101       TO MML1-FIELD-CODE
042500                 MOVE MML1WS-VL-03
042600                                 TO MML1-VARIABLE-LENGTH
042700                 MOVE MMXT-CMS-TC (X-MMXT-TCTT)
042800                                 TO MML1-VL03-B-DATA-9
042900                 MOVE MT01-CMS-TC (X-MT01-XT)
043000                                 TO MMXT-CMS-TC
043100                                    (X-MMXT-TCTT)
043200                 MOVE MMXT-CMS-TC (X-MMXT-TCTT)
043300                                 TO MML1-VL03-A-DATA-9
043400                 PERFORM 9050-WRITE-LOG-REC
043500                                 THRU 9099-WLR-EXIT
043600             ELSE
043700                 MOVE MT01-CMS-TC (X-MT01-XT)
043800                                     TO MMXT-CMS-TC (X-MMXT-TCTT)
043900             END-IF
044000         END-EVALUATE
044100         EVALUATE TRUE
044200           WHEN  MT01-MBS-TC-L (X-MT01-XT) IS GREATER THAN ZERO
044300             IF  MBCA-PTI-FUNCTION-IS-MAINT
044400                 SET WS-INDEX    TO X-MMXT-TCTT
044500                 MOVE WS-INDEX   TO MML1-FIELD-OCCURRENCE
044600                 MOVE ZEROS      TO MML1-FIELD-OCCURRENCE-2
044700                 MOVE 0102       TO MML1-FIELD-CODE
044800                 MOVE MML1WS-VL-03
044900                                 TO MML1-VARIABLE-LENGTH
045000                 MOVE MMXT-MBS-TC (X-MMXT-TCTT)
045100                                 TO MML1-VL03-B-DATA-9
045200                 MOVE MT01-MBS-TC (X-MT01-XT)
045300                                 TO MMXT-MBS-TC
045400                                    (X-MMXT-TCTT)
045500                 MOVE MMXT-MBS-TC (X-MMXT-TCTT)
045600                                 TO MML1-VL03-A-DATA-9
045700                 PERFORM 9050-WRITE-LOG-REC
045800                                 THRU 9099-WLR-EXIT
045900             ELSE
046000                 MOVE MT01-MBS-TC (X-MT01-XT)
046100                                 TO MMXT-MBS-TC (X-MMXT-TCTT)
046200             END-IF
046300         END-EVALUATE
046400         SET X-MMXT-TCTT         UP BY 1
046500     END-PERFORM.
046600*
046700     SET X-MMXT-TCTT             TO MBCA-MBMT-INDEX.
046800*
046900 2650-UPDATE-MMXT.
047000*
047100     IF  MBCA-PTI-FUNCTION-IS-ADD
047200     AND MBCA-EIBAID-ENTER
047300     AND MT01-MBS-TC-L (30) IS LESS THAN 1
047400         SET MMXT-ADD-COMPLETED  TO TRUE
047500         SET MMXT-REC-ACTIVE     TO TRUE
047600         MOVE MBCA-START-DATE    TO MMXT-LAST-MAINT-DATE
047700         MOVE MBCA-OPERATOR-ID   TO MMXT-LAST-MAINT-OPER
047800         MOVE ZEROES             TO MML1-FIELD-CODE
047900                                    MML1-FIELD-OCCURRENCE
048000                                    MML1-FIELD-OCCURRENCE-2
048100         MOVE LENGTH OF MMXT-RECORD
048200                                 TO MML1-VARIABLE-LENGTH
048300         MOVE 'XT'               TO MML1-FILE-CODE
048400         MOVE MBCA-MERCHANT-ORG  TO MML1-MMXT-ORG
048500         MOVE MBCA-SIGNON-NAME   TO MML1-SIGNON-NAME
048600         MOVE MBCA-TERMINAL-ID   TO MML1-TERMINAL-ID
048700         MOVE MMXT-RECORD        TO MML1-ADD-AREA
048800         MOVE 'FC05'             TO MBCA-PROGRAM-LOCATION
048900         SET MBIORO-WRITE        TO TRUE
049000         PERFORM MML1AO-ACCESS
049100                                 THRU MML1AO-ACCESS-EXIT
049200         SET WS-UPDATE-SW-YES    TO TRUE.
049300*
049400**************************************************************
049500*    WRITE A LOG RECORD TO SHOW THAT THE LAST MAINT DATE     *
049600*    AND OPERATOR HAS BEEN UPDATED IF FIELDS WERE CHANGED    *
049700*    ON THE SCREEN                                           *
049800**************************************************************
049900*
050000     IF  MBCA-PTI-FUNCTION-IS-MAINT
050100     AND WS-UPDATE-SW-YES
050200         MOVE 0198               TO MML1-FIELD-CODE
050300         MOVE ZEROES             TO MML1-FIELD-OCCURRENCE
050400                                    MML1-FIELD-OCCURRENCE-2
050500         MOVE MML1WS-VL-03       TO MML1-VARIABLE-LENGTH
050600         MOVE MMXT-LAST-MAINT-OPER
050700                                 TO MML1-VL03-B-DATA-X
050800         MOVE MBCA-OPERATOR-ID   TO MMXT-LAST-MAINT-OPER
050900         MOVE MMXT-LAST-MAINT-OPER
051000                                 TO MML1-VL03-A-DATA-X
051100         MOVE 'FC06'             TO MBCA-PROGRAM-LOCATION
051200         PERFORM 9050-WRITE-LOG-REC
051300                                 THRU 9099-WLR-EXIT
051400         MOVE 0199               TO MML1-FIELD-CODE
051500         MOVE MML1WS-VL-07       TO MML1-VARIABLE-LENGTH
051600         MOVE MMXT-LAST-MAINT-DATE
051700                                 TO MML1-VL07-B-DATA-9
051800         MOVE MBCA-START-DATE    TO MMXT-LAST-MAINT-DATE
051900         MOVE MMXT-LAST-MAINT-DATE
052000                                 TO MML1-VL07-A-DATA-9
052100         MOVE 'FC07'             TO MBCA-PROGRAM-LOCATION
052200         PERFORM 9050-WRITE-LOG-REC
052300                                 THRU 9099-WLR-EXIT.
052400*
052500****************************************************
052600*    REWRITE THE MERCHANT TRAN CODE TRANSLATION    *
052700*    RECORD IF FIELDS HAVE BEEN CHANGED ON THE     *
052800*    SCREEN, OR UNLOCK IT IF THEY HAVE NOT         *
052900****************************************************
053000*
053100     IF  WS-UPDATE-SW-YES
053200         MOVE 'FC08'             TO MBCA-PROGRAM-LOCATION
053300         SET MBIORO-REWRITE      TO TRUE
053400         PERFORM MMXTAO-ACCESS   THRU MMXTAO-ACCESS-EXIT
053500     ELSE
053600         MOVE 'FC09'             TO MBCA-PROGRAM-LOCATION
053700         SET MBIORO-UNLOCK       TO TRUE
053800         PERFORM MMXTAO-ACCESS   THRU MMXTAO-ACCESS-EXIT.
053900/
054000 2600-SETUP-COMMAREA.
054100*
054200****************************************************************
054300*    SET UP COMMAREA FIELDS AND TRANSFER TO THE NEXT PROGRAM   *
054400****************************************************************
054500*
054600     MOVE MBCA-EIBAID            TO SS08WS-EIBAID.
054700*
054800     IF  SS08WS-VALID-PF3
054900     OR  SS08WS-EIBAID-VALID-PF3
055000         MOVE 1                  TO MBCA-MBMT-INDEX
055100         MOVE 51                 TO MBCA-SCREEN-NBR
055200         GO TO 2690-PF-KEY-BYPASS.
055300*
055400     IF  SS08WS-VALID-PF4
055500     OR  SS08WS-EIBAID-VALID-PF4
055600         MOVE 969                TO MBCA-MBMT-INDEX
055700         MOVE 51                 TO MBCA-SCREEN-NBR
055800         GO TO 2690-PF-KEY-BYPASS.
055900*
056000     IF  SS08WS-VALID-PF5
056100     OR  SS08WS-EIBAID-VALID-PF5
056200         IF  MBCA-MBMT-INDEX IS GREATER THAN 968
056300             MOVE 969            TO MBCA-MBMT-INDEX
056400             MOVE 51             TO MBCA-SCREEN-NBR
056500             GO TO 2690-PF-KEY-BYPASS
056600         ELSE
056700             COMPUTE MBCA-MBMT-INDEX
056800                                 = MBCA-MBMT-INDEX
056900                                 + 30
057000             MOVE 51             TO MBCA-SCREEN-NBR
057100             GO TO 2690-PF-KEY-BYPASS.
057200*
057300     IF  SS08WS-VALID-PF6
057400     OR  SS08WS-EIBAID-VALID-PF6
057500         IF  MBCA-MBMT-INDEX IS LESS THAN 30
057600             MOVE 1              TO MBCA-MBMT-INDEX
057700             MOVE 51             TO MBCA-SCREEN-NBR
057800             GO TO 2690-PF-KEY-BYPASS
057900         ELSE
058000             COMPUTE MBCA-MBMT-INDEX
058100                                 = MBCA-MBMT-INDEX
058200                                 - 30
058300             MOVE 51             TO MBCA-SCREEN-NBR
058400             GO TO 2690-PF-KEY-BYPASS.
058500*
058600     PERFORM MB60PD-EDIT-PAGE-NBR
058700                                 THRU MB60PD-EPN-EXIT.
058800*
058900     IF  MBCA-PTI-FUNCTION-IS-ADD
059000     AND MT01-MBS-TC-L (30) IS GREATER THAN ZEROS
059100         COMPUTE MBCA-MBMT-INDEX = MBCA-MBMT-INDEX
059200                                 + 30
059300         MOVE 51                 TO MBCA-SCREEN-NBR
059400         GO TO 2690-PF-KEY-BYPASS.
059500*
059600     IF  SS08WS-VALID-PF-KEY
059700     OR  SS08WS-EIBAID-VALID-PF-KEY
059800         SET MBCA-INITIAL-SCREEN-NBR
059900                                 TO TRUE.
060000*
060100 2690-PF-KEY-BYPASS.
060200*
060300     MOVE 'PC05'                 TO MBCA-PROGRAM-LOCATION.
060400     PERFORM MB70PD-XCTL-TO-MBOXCTL
060500                                 THRU MB70PD-XTM-EXIT.
060600/
060700 9000-PERFORMED-ROUTINES-SECT SECTION.
060800*
060900*
061000 9050-WRITE-LOG-REC.
061100*
061200*****************************************************************
061300*    WRITE THE LOG/JOURNAL FILE RECORD                          *
061400*****************************************************************
061500*
061600     IF  MBCA-PTI-FUNCTION-IS-ADD
061700         GO TO 9099-WLR-EXIT.
061800*
061900     MOVE 'XT'                   TO MML1-FILE-CODE.
062000     MOVE MBCA-MERCHANT-ORG      TO MML1-MMXT-ORG.
062100     MOVE MBCA-SIGNON-NAME       TO MML1-SIGNON-NAME.
062200     MOVE MBCA-TERMINAL-ID       TO MML1-TERMINAL-ID.
062300     MOVE ZEROES                 TO MML1-SOURCE-CODE.
062400*
062500     MOVE 'FC10'                 TO MBCA-PROGRAM-LOCATION.
062600     SET MBIORO-WRITE            TO TRUE.
062700     PERFORM MML1AO-ACCESS       THRU MML1AO-ACCESS-EXIT.
062800     MOVE SPACES                 TO MML1-VARIABLE-AREA.
062900*
063000 9099-WLR-EXIT.
063100     EXIT.
063200*
063300 9500-BUILD-SCREEN.
063400*
063500     SET X-MMXT-TCTT             TO MBCA-MBMT-INDEX.
063600*
063700     PERFORM
063800         VARYING X-MT01-XT FROM 1 BY 1
063900         UNTIL X-MT01-XT IS GREATER THAN 30
064000         IF  X-MMXT-TCTT IS GREATER THAN 998
064100             MOVE DFHBMDAS       TO MT01-CMS-TC-LP-A
064200                                    (X-MT01-XT)
064300                                    MT01-CMS-TC-RP-A
064400                                    (X-MT01-XT)
064500                                    MT01-MBS-TC-LP-A
064600                                    (X-MT01-XT)
064700                                    MT01-MBS-TC-RP-A
064800                                    (X-MT01-XT)
064900                                    MT01-CMS-TC-A
065000                                    (X-MT01-XT)
065100                                    MT01-MBS-TC-A
065200                                    (X-MT01-XT)
065300                                    MT01-MBS-TC-DESC-A
065400                                    (X-MT01-XT)
065500                                    MT01-INDEX-A
065600                                    (X-MT01-XT)
065700             MOVE ZERO           TO MT01-CMS-TC (X-MT01-XT)
065800             MOVE ZERO           TO MT01-MBS-TC (X-MT01-XT)
065900         ELSE
066000             MOVE MMXT-CMS-TC (X-MMXT-TCTT)
066100                                 TO MT01-CMS-TC (X-MT01-XT)
066200             MOVE MMXT-MBS-TC (X-MMXT-TCTT)
066300                                 TO MT01-MBS-TC (X-MT01-XT)
066400         END-IF
066500         IF  MT01-MBS-TC (X-MT01-XT) IS GREATER THAN ZEROS
066600             PERFORM 9600-READ-MMTC  THRU 9699-EXIT
066700             IF  SS08WS-RC-FC-NOTFND
066800                 CONTINUE
066900             ELSE
067000                 MOVE MMTC-RPT-DESC
067100                                 TO MT01-MBS-TC-DESC (X-MT01-XT)
067200             END-IF
067300         END-IF
067400         SET WS-INDEX            TO X-MMXT-TCTT
067500         MOVE WS-INDEX           TO MT01-INDEX-NBR (X-MT01-XT)
067600         MOVE '.'                TO MT01-INDEX-PERIOD (X-MT01-XT)
067700         SET X-MMXT-TCTT         UP BY 1
067800     END-PERFORM.
067900*
068000     SET X-MMXT-TCTT             TO MBCA-MBMT-INDEX.
068100*
068200 9599-BS-EXIT.
068300     EXIT.
068400*
068500 9600-READ-MMTC.
068600*
068700     MOVE 'FC11'                 TO MBCA-PROGRAM-LOCATION.
068800     MOVE SS08WS-CICS-FC-NOTFND  TO MBIORO-TEMP-STATUS-1.
068900     MOVE MBCA-MERCHANT-ORG      TO MBIOWS-MMTC-ORG.
069000     MOVE MT01-MBS-TC (X-MT01-XT)
069100                                 TO MBIOWS-MMTC-TXN-CODE.
069200     SET MBIORO-READ-RANDOM      TO TRUE.
069300     PERFORM MMTCAO-ACCESS       THRU MMTCAO-ACCESS-EXIT.
069400     MOVE MMTC-LOGIC-MODULE      TO MMTCWS-LOGIC-MODULE.
069500*
069600 9699-EXIT.
069700     EXIT.
069800*
069900*
070000/         NEW ROUTINE FOR JULIAN TO GREGORIAN CONVERSION
070100     COPY SS26PD.
070200/         ROUTINE TO NUMERICALLY EDIT TIME
070300     COPY SS27PD.
070400/         JULIAN TO GREGORIAN DATE ROUTINE
070500     COPY SS08PD.
070600/         LINE 24 PF KEYS ROUTINE
070700     COPY SS15PD.
070800/         TRAN CODE TRANSLATION FILE ACCESS ROUTINES
070900     COPY MMXTAO.
071000/         TRANSACTION CONTROL FILE ACCESS ROUTINES
071100     COPY MMTCAO.
071200/         ORG CONTROL FILE ACCESS ROUTINES
071300     COPY MMOCAO.
071400/         LOG/JOURNAL ACCESS ROUTINES
071500     COPY MML1AO.
071600/         ON-LINE MAP ROUTINES
071700     COPY MB60PD REPLACING 'MBMAPXX' BY 'MBMT01 '
071800                           MBMAPXXI BY MBMT01I
071900                           MBMAPXXO BY MBMT01O.
072000/         ON-LINE PROCEDURES
072100     COPY MB70PD.
072200/
072300     COPY SMFTPXO.
