000100 IDENTIFICATION DIVISION.
000200 PROGRAM-ID. MBOMU00.
000201*       RELEASE DATE=08/24/01.        REVISION LEVEL=08.06      * ++++++++
000202***************************************************************** ++++++++
000203*WARNING.  THIS COMPUTER PROGRAM IS PROTECTED BY COPYRIGHT LAW  * ++++++++
000204*AND INTERNATIONAL TREATIES.  UNAUTHORIZED REPRODUCTION OR      * ++++++++
000205*DISTRIBUTION OF THIS PROGRAM, OR ANY PORTION OF IT, MAY RESULT * ++++++++
000206*IN SEVERE CIVIL AND CRIMINAL PENATLIES, AND WILL BE PROSECUTED * ++++++++
000207*TO THE MAXIMUM EXTENT POSSIBLE UNDER THE LAW.                  * ++++++++
000208*COPYRIGHT 1999 PAYSYS INTERNATIONAL, INC.  ALL RIGHTS RESERVED.* ++++++++
000209***************************************************************** ++++++++
000300*****************************************************************
000400*                                                               *
000500*   V - PLUS  M E R C H A N T   B A N K C A R D   S Y S T E M   *
000600*                                                               *
000700*      MBOMU00 - FRAUD SELECTION ADD/MAINT/INQ                  *
000800*                LOCATE SCREEN 00                               *
000900*                                                               *
001000*              1. TRANSIDS                                      *
001100*                 A. MBAU                                       *
001200*                 B. MBMU                                       *
001300*                 C. MBQU                                       *
001400*              2. MAPS USED -                                   *
001500*                 A. MBMU00 (LOCATE MAP)                        *
001600*              3. FILES USED -                                  *
001700*                 A. MMOC (ORG CONTROL FILE)                    *
001800*                 B. MMFP (MERCHANT RELATIONSHIP)               *
001900*                                                               *
002000*****************************************************************
002100*
002200 ENVIRONMENT DIVISION.
002300*
002400 DATA DIVISION.
002500*
002600 WORKING-STORAGE SECTION.
002700*
002800 01  FILLER                  PIC  X(12)      VALUE
002900     '** WS-BEG **'.
003000*
003100 01  FILLER                  PIC  X(14)      VALUE
003200     'MISCELLANEOUS:'.
003300*
003400 01  WS-MISCELLANEOUS.
003500     03  WS-ORG-LOW          PIC S9(03)      COMP-3
003600                                             VALUE +001.
003700     03  WS-ORG-HIGH         PIC S9(03)      COMP-3
003800                                             VALUE +998.
003900     03  WS-COPY-SW          PIC  X(01)      VALUE 'N'.
004000         88  WS-COPY-SW-NO                   VALUE 'N'.
004100         88  WS-COPY-SW-YES                  VALUE 'Y'.
004200/
004300 01  FILLER                  PIC  X(29)      VALUE
004400     'I/O REQUEST BLOCK WORK AREAS:'.
004500*
004600     COPY MBIOWS.
004700/
004800 01  FILLER                  PIC  X(18)      VALUE
004900     'I/O REQUEST BLOCK:'.
005000*
005100     COPY MBIORO.
005200/
005300 01  FILLER                  PIC  X(21)      VALUE
005400     'ERROR MESSAGES TABLE:'.
005500*
005600     COPY MBEMWS.
005700/
005800 01  FILLER                  PIC  X(36)      VALUE
005900     'FRAUD PARAMETERS INITIALIZER RECORD:'.
006000*
006100     COPY MMFPIR.
006200/
006300 01  FILLER                  PIC  X(20)      VALUE
006400     'CCS DATE WORK AREAS:'.
006500*
006600     COPY SS01WS.
006700/
006800 01  FILLER                  PIC  X(15)      VALUE
006900     'CCS WORK AREAS:'.
007000*
007100     COPY SS08WS.
007200/
007300     COPY SS00WS.
007400/
007500     COPY SMFTWS.
007600/
007700     COPY SMPTRL REPLACING ==:SMPT:== BY ==SMPT==.
007800/
007900     COPY MB61LK.
008000/
008100 01  FILLER                  PIC  X(12)      VALUE
008200     '** WS-END **'.
008300/
008400 LINKAGE SECTION.
008500*
008600 01  DFHCOMMAREA.
008700*
008800     COPY MB60WS.
008900/
009000******************************************
009100*    FRAUD PARAMETERS LOCATE MAP         *
009200******************************************
009300*
009400     COPY MBMU00.
009500/
009600*******************************************************
009700*    FRAUD PARAMETERS LOCATE MAP REDEFINITION         *
009800*******************************************************
009900*
010000     COPY MBMU00R.
010100/
010200***************************
010300*    ORG RECORD LAYOUT    *
010400***************************
010500*
010600     COPY MMOCRL.
010700/
010800*********************************************
010900*    FRAUD PARAMETERS RECORD LAYOUT         *
011000*********************************************
011100*
011200     COPY MMFPRL.
011300/
011400 PROCEDURE DIVISION.
011500*
011600 A000-HOUSEKEEPING SECTION.
011700*
011800 A020-INIT.
011900*
012000     MOVE 'PC01'                 TO MBCA-PROGRAM-LOCATION.
012100     PERFORM MB70PD-ON-LINE-HOUSEKEEPING
012200                                 THRU MB70PD-OLH-EXIT.
012300*
012400     IF  MBCA-RECEIVE-SCREEN
012500         GO TO C000-RECEIVE-SCREEN.
012600/
012700 B000-SEND-SCREEN SECTION.
012800*
012900*********************************************
013000*    GET CICS STORAGE NEEDED FOR THE MAP    *
013100*********************************************
013200*
013300     MOVE 'SC01'                 TO MBCA-PROGRAM-LOCATION.
013400     PERFORM MB60PD-GETMAIN-FOR-MAP
013500                                 THRU MB60PD-GFM-EXIT.
013600*
013700*****************************************************************
013800*    CHECK KEY CODES                                            *
013900* 1. IF ADD FUNCTION, BYPASS CHECK OF KEY CODES.                *
014000* 2. IF INITIAL KEY CODE, BYPASS CHECK OF KEY CODES.            *
014100* 3. IF MMFP KEY CODE, IT MUST HAVE AN ORGANIZATION NUMBER      *
014200*    GREATER THAN ZERO AND A INSERT NBR. IF                     *
014300*    DIRECT, GO TO THE RECEIVE EDITING ROUTINE SINCE WE HAVE    *
014400*    PLUGGED THE ORGANIZATION AND INSERT NBR IN THE MAP. IF AN  *
014500*    ERROR OCCURS IN THE RECEIVE SCREEN ROUTINE, IT WILL        *
014600*    HANDLE BUILDING THE MAP AND IT WILL SEND ITS OWN SCREEN.   *
014700*    THIS IS WHY LOCATE PROGRAMS ALWAYS SEND WITH ERASE         *
014800*    NO MATTER WHICH ROUTINE YOU ARE IN.  IF NOT DIRECT, PLUG   *
014900*    THE ORGANIZATION AND TABLE NBR INTO THE MAP AND BYPASS     *
015000*    ANY OTHER CHECKING OF THE KEY CODE.                        *
015100* 4. IF 2 AND 3 ARE FALSE, SEE IF THE MBCA-MERCHANT-ORG IS      *
015200*    GREATER THAN ZERO.  IF IT IS, PLUG IT INTO THE MAP.  IF    *
015300*    THE MBCA-TABLE IS GREATER THAN LOW-VALUE, PLUG IT INTO     *
015400*    THE MAP.                                                   *
015500*****************************************************************
015600*
015700     IF  MBCA-INITIAL-KEY-CODE
015800     OR  MBCA-PTI-FUNCTION-IS-ADD
015900         GO TO B020-BUILD-SCREEN.
016000*
016100     IF  MBCA-MMFP-KEY-CODE
016200         IF  MBCA-MERCHANT-ORG IS GREATER THAN ZERO
016300         AND MBCA-TABLE        IS GREATER THAN LOW-VALUE
016400             MOVE MBCA-MERCHANT-ORG
016500                                 TO MU00-ORG
016600             MOVE MBCA-TABLE     TO MU00-TABLE-NBR
016700             MOVE DFHBMUNF       TO MU00-ORG-A
016800                                    MU00-TABLE-NBR-A
016900             IF  MBCA-DIRECT-TRANSFER-CODE
017000             AND MBCA-INITIAL-SCREEN-NBR
017100                 MOVE 00         TO MBCA-SCREEN-NBR
017200                 GO TO C082-READ-ORG
017300             ELSE
017400                 GO TO B020-BUILD-SCREEN.
017500*
017600     IF  MBCA-VALID-KEY-CODES
017700         IF  MBCA-MERCHANT-ORG IS GREATER THAN ZERO
017800             MOVE MBCA-MERCHANT-ORG
017900                                 TO MU00-ORG
018000             MOVE DFHBMUNF       TO MU00-ORG-A
018100             IF  MBCA-TABLE     IS GREATER THAN LOW-VALUE
018200                 MOVE MBCA-TABLE
018300                                 TO MU00-TABLE-NBR
018400                 MOVE DFHBMUNF   TO MU00-TABLE-NBR-A.
018500*
018600 B020-BUILD-SCREEN.
018700*
018800*******************************************
018900*    INITIALIZE THE STANDARD MAP LINES    *
019000*******************************************
019100*
019200     MOVE SS08WS-CURSOR          TO MU00-ORG-L.
019300     MOVE 00                     TO MBCA-SCREEN-NBR.
019400     PERFORM MB60PD-INIT-STD-MAP-LINES
019500                                 THRU MB60PD-ISML-EXIT.
019600*
019700     IF  MBCA-PTI-FUNCTION-MAINT-OR-INQ
019800         MOVE DFHBMDAS           TO MU00-COPY-ORG-LIT-A
019900                                    MU00-COPY-ORG-LP-A
020000                                    MU00-COPY-ORG-RP-A
020100                                    MU00-COPY-TABLE-NBR-LIT-A
020200                                    MU00-COPY-TABLE-NBR-LP-A
020300                                    MU00-COPY-TABLE-NBR-RP-A
020400         MOVE DFHBMASK           TO MU00-COPY-ORG-A
020500                                    MU00-COPY-TABLE-NBR-A.
020600*
020700**********************
020800*    SEND THE MAP    *
020900**********************
021000*
021100     MOVE 'BM01'                 TO MBCA-PROGRAM-LOCATION.
021200     PERFORM MB60PD-SEND-MAP-WITH-ERASE
021300                                 THRU MB60PD-SMWE-EXIT.
021400*
021500************************
021600*    RETURN TO CICS    *
021700************************
021800*
021900     MOVE 'PC02'                 TO MBCA-PROGRAM-LOCATION.
022000     PERFORM MB70PD-RETURN-TRANS-ID
022100                                 THRU MB70PD-RTI-EXIT.
022200/
022300 C000-RECEIVE-SCREEN SECTION.
022400*
022500*************************************************
022600*    THIS SECTION RECEIVES THE LOCATE SCREEN    *
022700*************************************************
022800*
022900     MOVE 'BM02'                 TO MBCA-PROGRAM-LOCATION.
023000     PERFORM MB60PD-RECEIVE-MAP  THRU MB60PD-RM-EXIT.
023100*
023200**************************************************************
023300*    CHECK FOR ANOTHER TRANSACTION ID ENTERED BY THE USER    *
023400**************************************************************
023500*
023600     MOVE 'PC03'                 TO MBCA-PROGRAM-LOCATION.
023700     PERFORM MB60PD-NEW-TRANS-ROUTINE
023800                                 THRU MB60PD-NTR-EXIT.
023900*
024000 C020-EDIT-SCREEN.
024100*
024200     SET SS08WS-ERROR-SW-NO      TO TRUE.
024300     MOVE MBCA-EIBAID            TO SS08WS-EIBAID.
024400*
024500     IF  (MU00-ORG-L IS LESS THAN 1
024600     AND  MU00-TABLE-NBR-L IS LESS THAN 1
024700     AND  MU00-COPY-ORG-L IS LESS THAN 1
024800     AND  MU00-COPY-TABLE-NBR-L IS LESS THAN 1)
024900     AND (SS08WS-VALID-PF-KEY
025000     OR   SS08WS-EIBAID-VALID-PF-KEY)
025100         SET MBCA-INITIAL-SCREEN-NBR
025200                                 TO TRUE
025300         GO TO F090-TRANSFER-XCTL.
025400*
025500******************************************************
025600*    RESET THE FIELD ARRIBUTES TO THEIR NORMAL       *
025700*    PRIOR STATE PRIOR TO ANY EDITING BEING DONE.    *
025800******************************************************
025900*
026000     MOVE DFHBMUNN               TO MU00-ORG-A
026100                                    MU00-TABLE-NBR-A.
026200     MOVE DFHBMASK               TO MU00-ORG-LP-A
026300                                    MU00-ORG-RP-A
026400                                    MU00-TABLE-NBR-LP-A
026500                                    MU00-TABLE-NBR-RP-A.
026600*
026700     IF  MBCA-PTI-FUNCTION-IS-ADD
026800         MOVE DFHBMUNN           TO MU00-COPY-ORG-A
026900                                    MU00-COPY-TABLE-NBR-A
027000         MOVE DFHBMASK           TO MU00-COPY-ORG-LP-A
027100                                    MU00-COPY-ORG-RP-A
027200                                    MU00-COPY-TABLE-NBR-LP-A
027300                                    MU00-COPY-TABLE-NBR-RP-A
027400     ELSE
027500         GO TO C080-EDIT-ORG.
027600*
027700************************************************
027800*    BYPASS THE COPY EDITS IF NEITHER THE      *
027900*    COPY ORG OR COPY TABLE-NBR WERE ENTERED. *
028000************************************************
028100*
028200     IF  MU00-COPY-ORG-L IS EQUAL TO ZERO
028300     AND MU00-COPY-TABLE-NBR-L IS EQUAL TO ZERO
028400         GO TO C080-EDIT-ORG.
028500*
028600 C040-EDIT-COPY-ORG.
028700*
028800     IF  MU00-COPY-ORG-L IS EQUAL TO ZERO
028900     OR  MU00-COPY-ORG IS NOT NUMERIC
029000     OR  MU00-COPY-ORG IS LESS THAN MBCA-ORG-LOW
029100     OR  MU00-COPY-ORG IS GREATER THAN MBCA-ORG-HIGH
029200     OR  MU00-COPY-ORG IS LESS THAN WS-ORG-LOW
029300     OR  MU00-COPY-ORG IS GREATER THAN WS-ORG-HIGH
029400         MOVE MBEMWS-INVALID-ORG TO MU00-ERR-MESSAGE
029500         GO TO C058-COPY-ORG-ERROR.
029600*
029700************************************************
029800*    READ THE COPY ORGANIZATION RECORD.  IT    *
029900*    MUST BE ON FILE AND AN ACTIVE RECORD.     *
030000************************************************
030100*
030200     MOVE MU00-COPY-ORG          TO MBIOWS-MMOC-ORG.
030300     MOVE SS08WS-CICS-FC-NOTFND  TO MBIORO-TEMP-STATUS-1.
030400     MOVE 'FC01'                 TO MBCA-PROGRAM-LOCATION.
030500     SET MBIORO-READ-RANDOM      TO TRUE.
030600     PERFORM MMOCAO-ACCESS       THRU MMOCAO-ACCESS-EXIT.
030700*
030800     IF  SS08WS-RC-FC-NOTFND
030900         MOVE MBEMWS-NOT-ON-FILE TO MU00-ERR-MESSAGE
031000     ELSE
031100         IF  MMOC-ADD-PENDING
031200             MOVE MBEMWS-ADD-PENDING
031300                                 TO MU00-ERR-MESSAGE
031400         ELSE
031500             IF  MMOC-REC-PURGED
031600                 MOVE MBEMWS-REC-PURGED
031700                                 TO MU00-ERR-MESSAGE
031800             ELSE
031900                 MOVE DFHBMUNF   TO MU00-COPY-ORG-A
032000                 GO TO C060-EDIT-COPY-TABLE-NBR.
032100*
032200 C058-COPY-ORG-ERROR.
032300*
032400     SET SS08WS-ERROR-SW-YES     TO TRUE.
032500     MOVE DFHBMASB               TO MU00-COPY-ORG-LP-A
032600                                    MU00-COPY-ORG-RP-A.
032700     MOVE SS08WS-CURSOR          TO MU00-COPY-ORG-L.
032800     MOVE DFHBMNBF               TO MU00-COPY-ORG-A.
032900     MOVE DFHBMUNF               TO MU00-ORG-A
033000                                    MU00-COPY-TABLE-NBR-A
033100                                    MU00-TABLE-NBR-A.
033200     GO TO D000-RETURN-ERRORS.
033300*
033400 C060-EDIT-COPY-TABLE-NBR.
033500*
033600***********************************************************
033700*    THE LENGTH FIELD COULD BE CHECKED HERE TO            *
033800*    SEE IF ANYTHING WAS KEYED.                           *
033900***********************************************************
034000*
034100     IF  MU00-COPY-TABLE-NBR IS EQUAL ZEROS
034200         MOVE MBEMWS-INVALID-TABLE
034300                                 TO MU00-ERR-MESSAGE
034400         GO TO C078-COPY-TABLE-NBR-ERROR.
034500*
034600*****************************************************************
034700*    READ THE FRAUD PARAMETERS FILE TO ENSURE THAT THE TABLE-NBR*
034800*    TO BE COPIED IS ON FILE AND AN ACTIVE RECORD.              *
034900*****************************************************************
035000*
035100     MOVE MU00-COPY-ORG          TO MBIOWS-MMFP-ORG.
035200     MOVE MU00-COPY-TABLE-NBR    TO MBIOWS-MMFP-TABLE-NBR.
035300     MOVE SS08WS-CICS-FC-NOTFND  TO MBIORO-TEMP-STATUS-1.
035400     MOVE 'FC02'                 TO MBCA-PROGRAM-LOCATION.
035500     SET MBIORO-READ-RANDOM      TO TRUE.
035600     PERFORM MMFPAO-ACCESS       THRU MMFPAO-ACCESS-EXIT.
035700*
035800     IF  SS08WS-RC-FC-NOTFND
035900         MOVE MBEMWS-NOT-ON-FILE TO MU00-ERR-MESSAGE
036000     ELSE
036100         IF  MMFP-ADD-PENDING
036200             MOVE MBEMWS-ADD-PENDING
036300                                 TO MU00-ERR-MESSAGE
036400         ELSE
036500             IF  MMFP-REC-PURGED
036600                 MOVE MBEMWS-REC-PURGED
036700                                 TO MU00-ERR-MESSAGE
036800             ELSE
036900                 SET WS-COPY-SW-YES
037000                                 TO TRUE
037100                 MOVE DFHBMUNF   TO MU00-COPY-TABLE-NBR-A
037200                 GO TO C080-EDIT-ORG.
037300*
037400 C078-COPY-TABLE-NBR-ERROR.
037500*
037600     SET SS08WS-ERROR-SW-YES     TO TRUE.
037700     MOVE DFHBMASB               TO MU00-COPY-TABLE-NBR-LP-A
037800                                    MU00-COPY-TABLE-NBR-RP-A.
037900     MOVE SS08WS-CURSOR          TO MU00-COPY-TABLE-NBR-L.
038000     MOVE DFHBMNBF               TO MU00-COPY-TABLE-NBR-A.
038100     MOVE DFHBMUNF               TO MU00-ORG-A
038200                                    MU00-TABLE-NBR-A.
038300     GO TO D000-RETURN-ERRORS.
038400*
038500 C080-EDIT-ORG.
038600*
038700     IF  MU00-ORG-L IS EQUAL TO ZERO
038800     OR  MU00-ORG IS NOT NUMERIC
038900     OR  MU00-ORG IS LESS THAN MBCA-ORG-LOW
039000     OR  MU00-ORG IS GREATER THAN MBCA-ORG-HIGH
039100     OR  MU00-ORG IS LESS THAN WS-ORG-LOW
039200     OR  MU00-ORG IS GREATER THAN WS-ORG-HIGH
039300         MOVE MBEMWS-INVALID-ORG TO MU00-ERR-MESSAGE
039400         GO TO C098-ORG-ERROR.
039500*
039600 C082-READ-ORG.
039700*
039800************************************************
039900*    READ THE ORGANIZATION RECORD.  IT MUST    *
040000*    BE ON FILE AND AN ACTIVE RECORD.          *
040100************************************************
040200*
040300     MOVE MU00-ORG               TO MBIOWS-MMOC-ORG.
040400     MOVE 'FC03'                 TO MBCA-PROGRAM-LOCATION.
040500     MOVE SS08WS-CICS-FC-NOTFND  TO MBIORO-TEMP-STATUS-1.
040600     SET MBIORO-READ-RANDOM      TO TRUE.
040700     PERFORM MMOCAO-ACCESS       THRU MMOCAO-ACCESS-EXIT.
040800*
040900     IF  SS08WS-RC-FC-NOTFND
041000         MOVE MBEMWS-NOT-ON-FILE TO MU00-ERR-MESSAGE
041100     ELSE
041200         IF  MMOC-ADD-PENDING
041300             MOVE MBEMWS-ADD-PENDING
041400                                 TO MU00-ERR-MESSAGE
041500         ELSE
041600             IF  MMOC-REC-PURGED
041700                 MOVE MBEMWS-REC-PURGED
041800                                 TO MU00-ERR-MESSAGE
041900             ELSE
042000                 MOVE DFHBMUNF   TO MU00-ORG-A
042100                 MOVE MU00-ORG   TO MBCA-MERCHANT-ORG
042200                 GO TO C100-EDIT-TABLE-NBR.
042300*
042400 C098-ORG-ERROR.
042500*
042600     SET SS08WS-ERROR-SW-YES     TO TRUE.
042700     MOVE DFHBMASB               TO MU00-ORG-LP-A
042800                                    MU00-ORG-RP-A.
042900     MOVE SS08WS-CURSOR          TO MU00-ORG-L.
043000     MOVE DFHBMNBF               TO MU00-ORG-A
043100                                    MU00-TABLE-NBR-A.
043200     GO TO D000-RETURN-ERRORS.
043300*
043400 C100-EDIT-TABLE-NBR.
043500*
043600***********************************************************
043700*    THE LENGTH FIELD COULD BE CHECKED HERE TO            *
043800*    SEE IF ANYTHING WAS KEYED.                           *
043900***********************************************************
044000*
044100     IF  MU00-TABLE-NBR-L IS GREATER THAN ZERO
044200     AND (MU00-TABLE-NBR IS NOT NUMERIC
044300     OR  MU00-TABLE-NBR IS EQUAL TO ZEROS OR 999999999)
044400         MOVE MBEMWS-INVALID-TABLE
044500                                 TO MU00-ERR-MESSAGE
044600         GO TO C118-TABLE-NBR-ERROR.
044700*
044800 C102-READ-TABLE-NBR.
044900*
045000***************************************************************
045100*    READ THE TABLE-NBR RECORD. IT MUST BE ON FILE AND        *
045200*    AN ACTIVE RECORD IF IN MAINTENANCE OR INQUIRY.  IT MUST  *
045300*    NOT BE ON FILE (OR IN AN ADD PENDING STATE), IF IN ADD.  *
045400***************************************************************
045500*
045600     MOVE MU00-ORG               TO MBIOWS-MMFP-ORG.
045700     MOVE MU00-TABLE-NBR         TO MBIOWS-MMFP-TABLE-NBR.
045800     MOVE SS08WS-CICS-FC-NOTFND  TO MBIORO-TEMP-STATUS-1.
045900     MOVE 'FC04'                 TO MBCA-PROGRAM-LOCATION.
046000     SET MBIORO-READ-RANDOM      TO TRUE.
046100     PERFORM MMFPAO-ACCESS       THRU MMFPAO-ACCESS-EXIT.
046200*
046300     IF  SS08WS-RC-FC-VALID-RTN-CODE
046400         MOVE MU00-TABLE-NBR     TO MBCA-TABLE.
046500*
046600     IF  MBCA-PTI-FUNCTION-IS-INQUIRY
046700         IF  SS08WS-RC-FC-VALID-RTN-CODE
046800             IF  MMFP-ADD-PENDING
046900                 MOVE MBEMWS-ADD-PENDING
047000                                 TO MU00-ERR-MESSAGE
047100                 GO TO C118-TABLE-NBR-ERROR
047200             ELSE
047300                 GO TO F000-SETUP-COMMAREA
047400         ELSE
047500             MOVE MBEMWS-NOT-ON-FILE
047600                                 TO MU00-ERR-MESSAGE
047700             GO TO C118-TABLE-NBR-ERROR.
047800*
047900     IF  MBCA-PTI-FUNCTION-IS-ADD
048000     AND SS08WS-RC-FC-NOTFND
048100         GO TO E000-UPDATE-FILE.
048200*
048300     IF  MBCA-PTI-FUNCTION-IS-ADD
048400     AND MMFP-ADD-PENDING
048500         IF  WS-COPY-SW-NO
048600             MOVE MMFP-ONLINE-STATUS
048700                                 TO MBCA-SCREEN-NBR
048800             GO TO F000-SETUP-COMMAREA
048900         ELSE
049000             MOVE MBEMWS-ADD-PENDING
049100                                 TO MU00-ERR-MESSAGE
049200             GO TO C118-TABLE-NBR-ERROR.
049300*
049400     IF  MBCA-PTI-FUNCTION-IS-ADD
049500         MOVE MBEMWS-ALREADY-ON-FILE
049600                                 TO MU00-ERR-MESSAGE
049700         GO TO C118-TABLE-NBR-ERROR.
049800*
049900     IF  MBCA-PTI-FUNCTION-IS-MAINT
050000     AND SS08WS-RC-FC-NOTFND
050100         MOVE MBEMWS-NOT-ON-FILE TO MU00-ERR-MESSAGE
050200         GO TO C118-TABLE-NBR-ERROR.
050300*
050400     IF  MBCA-PTI-FUNCTION-IS-MAINT
050500     AND MMFP-ADD-PENDING
050600         MOVE MBEMWS-ADD-PENDING TO MU00-ERR-MESSAGE
050700         GO TO C118-TABLE-NBR-ERROR.
050800*
050900     IF  MBCA-PTI-FUNCTION-IS-MAINT
051000     AND MMFP-ADD-PENDING
051100         MOVE MBEMWS-ADD-PENDING TO MU00-ERR-MESSAGE
051200         GO TO C118-TABLE-NBR-ERROR.
051300*
051400***********************************************
051500*    OTHERWISE, WE PASSED THE TABLE-NBR EDIT *
051600***********************************************
051700*
051800     GO TO F000-SETUP-COMMAREA.
051900*
052000 C118-TABLE-NBR-ERROR.
052100*
052200     SET SS08WS-ERROR-SW-YES     TO TRUE.
052300     MOVE DFHBMASB               TO MU00-TABLE-NBR-LP-A
052400                                    MU00-TABLE-NBR-RP-A.
052500     MOVE SS08WS-CURSOR          TO MU00-TABLE-NBR-L.
052600     MOVE DFHBMNBF               TO MU00-TABLE-NBR-A.
052700/
052800 D000-RETURN-ERRORS SECTION.
052900*
053000     IF  SS08WS-ERROR-SW-NO
053100         GO TO E000-UPDATE-FILE
053200     ELSE
053300         IF  SS08WS-VALID-PF-KEY
053400         OR  SS08WS-EIBAID-VALID-PF-KEY
053500             SET MBCA-INITIAL-SCREEN-NBR
053600                                 TO TRUE
053700             GO TO F090-TRANSFER-XCTL.
053800*
053900***************************************************************
054000*    INITIALIZE THE STANDARD MAP LINES.  IN AN ERROR          *
054100*    CONDITION, THIS ROUTINE IS PERFORMED PRIMARILY           *
054200*    TO UPDATE THE DATE AND TIME ON THE SCREEN.               *
054300***************************************************************
054400*
054500     PERFORM MB60PD-INIT-STD-MAP-LINES
054600                                 THRU MB60PD-ISML-EXIT.
054700*
054800     IF  MBCA-PTI-FUNCTION-MAINT-OR-INQ
054900         MOVE DFHBMDAS           TO MU00-COPY-ORG-LIT-A
055000                                    MU00-COPY-ORG-LP-A
055100                                    MU00-COPY-ORG-RP-A
055200                                    MU00-COPY-TABLE-NBR-LIT-A
055300                                    MU00-COPY-TABLE-NBR-LP-A
055400                                    MU00-COPY-TABLE-NBR-RP-A
055500         MOVE DFHBMASK           TO MU00-COPY-ORG-A
055600                                    MU00-COPY-TABLE-NBR-A.
055700*
055800**********************
055900*    SEND THE MAP    *
056000**********************
056100*
056200     MOVE 'BM03'                 TO MBCA-PROGRAM-LOCATION.
056300     PERFORM MB60PD-SEND-MAP-WITH-ERASE
056400                                 THRU MB60PD-SMWE-EXIT.
056500*
056600************************
056700*    RETURN TO CICS    *
056800************************
056900*
057000     MOVE 'PC04'                 TO MBCA-PROGRAM-LOCATION.
057100     PERFORM MB70PD-RETURN-TRANS-ID
057200                                 THRU MB70PD-RTI-EXIT.
057300/
057400 E000-UPDATE-FILE SECTION.
057500*
057600********************************************************
057700*    WRITE THE NEW FRAUD TABLE-NBR RECORD FROM THE     *
057800*    INITIALIZER RECORD OR FROM THE TABLE-NBR RECORD   *
057900*    THAT IS BEING COPIED.                             *
058000********************************************************
058100*
058200     IF  WS-COPY-SW-YES
058300         GO TO E040-COPY-ADD.
058400*
058500 E020-ADD-NEW-RECORD.
058600*
058700********************************************************
058800*    SET UP THE RECORD.  USE THE INITIALIZER RECORD    *
058900*    (MMFPIR) AS THE FIELD DEFAULTS.                   *
059000********************************************************
059100*
059200     MOVE MMFPIR-RECORD          TO MMFP-RECORD.
059300     MOVE MU00-ORG               TO MMFP-ORG.
059400     MOVE MU00-TABLE-NBR         TO MMFP-TABLE-NBR.
059500     MOVE MBCA-START-DATE        TO MMFP-LAST-MAINT-DATE.
059600     MOVE MBCA-OPERATOR-ID       TO MMFP-LAST-MAINT-OPER.
059700*
059800     GO TO E060-WRITE-MMFP.
059900*
060000 E040-COPY-ADD.
060100*
060200*********************************************************
060300*    RE-READ THE FRAUD PARAMETERS RECORD TO BE COPIED.  *
060400*********************************************************
060500*
060600     MOVE MU00-COPY-ORG          TO MBIOWS-MMFP-ORG.
060700     MOVE MU00-COPY-TABLE-NBR    TO MBIOWS-MMFP-TABLE-NBR.
060800     MOVE 'FC05'                 TO MBCA-PROGRAM-LOCATION.
060900     SET MBIORO-READ-RANDOM      TO TRUE.
061000     PERFORM MMFPAO-ACCESS       THRU MMFPAO-ACCESS-EXIT.
061100*
061200***************************
061300*    SET UP THE RECORD    *
061400***************************
061500*
061600     MOVE MU00-ORG               TO MMFP-ORG.
061700     MOVE MU00-TABLE-NBR         TO MMFP-TABLE-NBR.
061800     MOVE MMFPIR-REC-STATUS      TO MMFP-REC-STATUS.
061900     MOVE MMFPIR-ONLINE-STATUS   TO MMFP-ONLINE-STATUS.
062000     MOVE MBCA-START-DATE        TO MMFP-LAST-MAINT-DATE.
062100     MOVE MBCA-OPERATOR-ID       TO MMFP-LAST-MAINT-OPER.
062200*
062300*************************************************************
062400*    INITIALIZE THE FIELDS THAT ARE NOT PART OF THE COPY    *
062500*************************************************************
062600*
062700***  MOVE MMFPIR-NAME            TO MMFP-NAME.
062800*
062900 E060-WRITE-MMFP.
063000*
063100     MOVE 'FC06'                 TO MBCA-PROGRAM-LOCATION.
063200     SET MBIORO-WRITE            TO TRUE.
063300     PERFORM MMFPAO-ACCESS       THRU MMFPAO-ACCESS-EXIT.
063400*
063500     MOVE MU00-TABLE-NBR         TO MBCA-TABLE.
063600/
063700 F000-SETUP-COMMAREA SECTION.
063800*
063900***************************************************************
064000*  SET UP COMMAREA FIELDS AND TRANSFER TO THE NEXT PROGRAM    *
064100***************************************************************
064200*
064300     MOVE MMOC-CURRENCY-CODE     TO MBCA-CURRENCY-CODE.
064400     MOVE MMOC-CURRENCY-NOD      TO MBCA-CURRENCY-NOD.
064500     MOVE MMOC-PERCENT-NOD       TO MBCA-PERCENT-NOD.             FX800007
064600     MOVE MMOC-PER-ITEM-NOD      TO MBCA-PER-ITEM-NOD.            FX800007
064700     MOVE MBCA-EIBAID            TO SS08WS-EIBAID.
064800*
064900     MOVE MBIOWS-MMFP-DIRECT-KEY-CODE
065000                                 TO MBCA-KEY-CODE.
065100*
065200     PERFORM MB60PD-EDIT-PAGE-NBR
065300                                 THRU MB60PD-EPN-EXIT.
065400*
065500     IF  SS08WS-VALID-PF-KEY
065600     OR  SS08WS-EIBAID-VALID-PF-KEY
065700         SET MBCA-INITIAL-SCREEN-NBR
065800                                 TO TRUE.
065900*
066000 F090-TRANSFER-XCTL.
066100*
066200     MOVE 'PC05'                 TO MBCA-PROGRAM-LOCATION.
066300     PERFORM MB70PD-XCTL-TO-MBOXCTL
066400                                 THRU MB70PD-XTM-EXIT.
066500/
066600 Z000-COPIED-ROUTINES SECTION.
066700*
066800/    NEW ROUTINE FOR JULIAN TO GREGORIAN CONVERSION
066900     COPY SS26PD.
067000*
067100/    ROUTINE TO NUMERICALLY EDIT TIME
067200     COPY SS27PD.
067300*
067400**********************************
067500*    JUL TO GREG DATE ROUTINE    *
067600**********************************
067700*
067800     COPY SS08PD.
067900/
068000*********************************
068100*    LINE 24 PF KEYS ROUTINE    *
068200*********************************
068300*
068400     COPY SS15PD.
068500/
068600*******************************************
068700*    ORG FILE ACCESS ROUTINES             *
068800*******************************************
068900*
069000     COPY MMOCAO.
069100/
069200******************************************************
069300*    FRAUD PARAMETERS RECORD ACCESS ROUTINES         *
069400******************************************************
069500*
069600     COPY MMFPAO.
069700/
069800*****************************
069900*    ONLINE MAP ROUTINES    *
070000*****************************
070100*
070200     COPY MB60PD REPLACING 'MBMAPXX' BY 'MBMU00 '
070300                           MBMAPXXI BY MBMU00I
070400                           MBMAPXXO BY MBMU00O.
070500/
070600***************************
070700*    ONLINE PROCEDURES    *
070800***************************
070900*
071000     COPY MB70PD.
071100/
071200     COPY SMFTPXO.
