000100 IDENTIFICATION DIVISION.
000200 PROGRAM-ID. MBOMU01.
000201*       RELEASE DATE=08/24/01.        REVISION LEVEL=08.06      * ++++++++
000202***************************************************************** ++++++++
000203*WARNING.  THIS COMPUTER PROGRAM IS PROTECTED BY COPYRIGHT LAW  * ++++++++
000204*AND INTERNATIONAL TREATIES.  UNAUTHORIZED REPRODUCTION OR      * ++++++++
000205*DISTRIBUTION OF THIS PROGRAM, OR ANY PORTION OF IT, MAY RESULT * ++++++++
000206*IN SEVERE CIVIL AND CRIMINAL PENATLIES, AND WILL BE PROSECUTED * ++++++++
000207*TO THE MAXIMUM EXTENT POSSIBLE UNDER THE LAW.                  * ++++++++
000208*COPYRIGHT 1999 PAYSYS INTERNATIONAL, INC.  ALL RIGHTS RESERVED.* ++++++++
000209***************************************************************** ++++++++
000300*****************************************************************
000400*                                                               *
000500*   V - PLUS  M E R C H A N T   B A N K C A R D   S Y S T E M   *
000600*                                                               *
000700*      MBOMU01 - FRUAD RECORD ADD/MAINT/INQ                     *
000800*                SCREEN 01                                      *
000900*                                                               *
001000*              1. TRANSIDS                                      *
001100*                 A. MBAU                                       *
001200*                 B. MBMU                                       *
001300*                 C. MBQU                                       *
001400*              2. MAPS USED -                                   *
001500*                 A. MBMU01 (SCREEN 01)                         *
001600*              3. FILES USED -                                  *
001700*                 A. MMFP (FRAUD PARAMETERS FILE)               *
001800*                 B. MML1 (LOG FILE)                            *
001900*                                                               *
002000*****************************************************************
002100*
002200 ENVIRONMENT DIVISION.
002300*
002400 DATA DIVISION.
002500*
002600 WORKING-STORAGE SECTION.
002700*
002800 01  FILLER                  PIC  X(12)      VALUE '** WS-BEG **'.
002900*
003000 01  FILLER                  PIC  X(14)      VALUE
003100     'MISCELLANEOUS:'.
003200*
003300 01  FILLER                  PIC  X(17)      VALUE
003400     'PROGRAM SWITCHES:'.
003500*
003600 01  WS-PROGRAM-SWITCHES.
003700     03  WS-UPDATE-SW        PIC  X(01)      VALUE 'N'.
003800         88  WS-UPDATE-SW-YES                VALUE 'Y'.
003900         88  WS-UPDATE-SW-NO                 VALUE 'N'.
004000/
004100 01  FILLER                  PIC  X(29)      VALUE
004200     'I/O REQUEST BLOCK WORK AREAS:'.
004300*
004400     COPY MBIOWS.
004500/
004600 01  FILLER                  PIC  X(18)      VALUE
004700     'I/O REQUEST BLOCK:'.
004800*
004900     COPY MBIORO.
005000/
005100 01  FILLER                  PIC  X(25)      VALUE
005200     'LOG RECORD REQUEST BLOCK:'.
005300*
005400     COPY MML1WS REPLACING ==:MML1:== BY ==MML1==.
005500/
005600 01  FILLER                  PIC  X(16)      VALUE
005700     'DATE WORK AREAS:'.
005800*
005900     COPY SS01WS.
006000/
006100 01  FILLER                  PIC  X(11)      VALUE
006200     'WORK AREAS:'.
006300*
006400     COPY SS08WS.
006500/
006600     COPY SS00WS.
006700/
006800     COPY SMFTWS.
006900/
007000     COPY SMPTRL REPLACING ==:SMPT:== BY ==SMPT==.
007100/
007200     COPY MB61LK.
007300*
007400 01  FILLER                  PIC  X(12)      VALUE '** WS-END **'.
007500/
007600 LINKAGE SECTION.
007700*
007800 01  DFHCOMMAREA.
007900*
008000     COPY MB60WS.
008100/
008200*****************************
008300*    FRAUD PARAMETERS MAP   *
008400*****************************
008500*
008600     COPY MBMU01.
008700/
008800******************************************
008900*    FRAUD PARAMETERS MAP REDEFINITION   *
009000******************************************
009100*
009200     COPY MBMU01R.
009300/
009400****************************************
009500*    FRAUD PARAMETERS RECORD LAYOUT    *
009600****************************************
009700*
009800     COPY MMFPRL.
009900/
010000***************************
010100*    LOG RECORD LAYOUT    *
010200***************************
010300*
010400     COPY MML1RL REPLACING ==:MML1:== BY ==MML1==.
010500/
010600 PROCEDURE DIVISION.
010700*
010800 A000-HOUSEKEEPING SECTION.
010900*
011000 A020-INIT.
011100*
011200     MOVE 'PC01'                 TO MBCA-PROGRAM-LOCATION.
011300     PERFORM MB70PD-ON-LINE-HOUSEKEEPING
011400                                 THRU MB70PD-OLH-EXIT.
011500*
011600     IF  MBCA-RECEIVE-SCREEN
011700         GO TO C000-RECEIVE-SCREEN.
011800/
011900 B000-SEND-SCREEN SECTION.
012000*
012100*********************************************
012200*    GET CICS STORAGE NEEDED FOR THE MAP    *
012300*********************************************
012400*
012500     MOVE 'SC01'                 TO MBCA-PROGRAM-LOCATION.
012600     PERFORM MB60PD-GETMAIN-FOR-MAP
012700                                 THRU MB60PD-GFM-EXIT.
012800*
012900*******************************************
013000*    INITIALIZE THE STANDARD MAP LINES    *
013100*******************************************
013200*
013300     PERFORM MB60PD-INIT-STD-MAP-LINES
013400                                 THRU MB60PD-ISML-EXIT.
013500*
013600*****************************************
013700*    READ THE FRAUD PARAMETERS RECORD   *
013800*    FOR SUBSEQUENT DISPLAY             *
013900*****************************************
014000*
014100     MOVE 'FC01'                 TO MBCA-PROGRAM-LOCATION.
014200     PERFORM Y900-READ-MMFP      THRU Y909-READ-MMFP-EXIT.
014300*
014400******************************************************
014500*    MOVE LAST MAINT DATE AND LAST MAINT OPERATOR    *
014600*    TO THE SCREEN, DEPENDING ON THE FUNCTION        *
014700******************************************************
014800*
014900     IF  MBCA-PTI-FUNCTION-IS-ADD
015000         MOVE DFHBMDAS           TO MU01-LAST-MAINT-DATE-LIT-A
015100                                    MU01-LAST-MAINT-DATE-A
015200                                    MU01-LAST-MAINT-OPER-LIT-A
015300                                    MU01-LAST-MAINT-OPER-A
015400     ELSE
015500         MOVE MMFP-LAST-MAINT-DATE
015600                                 TO SS01WS-JULIAN
015700         PERFORM SS26PD-NUMERICALLY-EDIT-DATE
015800                                 THRU SS26PD-NED-EXIT
015900         MOVE SS01WS-XX-XX-YYYY  TO MU01-LAST-MAINT-DATE
016000         MOVE MMFP-LAST-MAINT-OPER
016100                                 TO MU01-LAST-MAINT-OPER
016200     END-IF.
016300*
016400 B020-MOVE-FIELDS-TO-SCREEN.
016500*
016600     MOVE MMFP-FRAUD-TABLE-DESC  TO MU01-TABLE-NBR-DESC.
016700     MOVE MMFP-FRAUD-SALE-EXCESS-AMT
016800                                 TO MU01-INDIVIDUAL-SALE.
016900     MOVE MMFP-FRAUD-AUTH-EXCESS-AMT
017000                                 TO MU01-INDIVIDUAL-AUTH.
017100     MOVE MMFP-FRAUD-LAST-DEP-EXCESS
017200                                 TO MU01-DAYS-LAST-DEP.
017300     MOVE MMFP-FRAUD-CHGBACK-EXCESS
017400                                 TO MU01-MONTHLY-CHARGEBACKS.
017500     MOVE MMFP-FRAUD-WEEK-EXCESS-SALES
017600                                 TO MU01-WEEKLY-GROSS-SALES.
017700     MOVE MMFP-FRAUD-AVG-NBR-MONTHS
017800                                 TO MU01-AVG-NBR-MONTHS.
017900     MOVE MMFP-FRAUD-AVG-ELAP-DAYS
018000                                 TO MU01-AVG-ELAP-DAYS.
018100*
018200     IF  MBCA-PTI-FUNCTION-IS-INQUIRY
018300         MOVE DFHBMDAS           TO MU01-TABLE-NBR-DESC-LP-A
018400                                    MU01-TABLE-NBR-DESC-RP-A
018500                                    MU01-AVG-NBR-MONTHS-LP-A
018600                                    MU01-INDIVIDUAL-SALE-LP-A
018700                                    MU01-INDIVIDUAL-SALE-RP-A
018800                                    MU01-INDIVIDUAL-AUTH-LP-A
018900                                    MU01-INDIVIDUAL-AUTH-RP-A
019000                                    MU01-DAYS-LAST-DEP-LP-A
019100                                    MU01-DAYS-LAST-DEP-RP-A
019200                                    MU01-MONTHLY-CHARGEBACKS-LP-A
019300                                    MU01-MONTHLY-CHARGEBACKS-RP-A
019400                                    MU01-WEEKLY-GROSS-SALES-LP-A
019500                                    MU01-WEEKLY-GROSS-SALES-RP-A
019600                                    MU01-AVG-NBR-MONTHS-RP-A
019700                                    MU01-AVG-ELAP-DAYS-LP-A
019800                                    MU01-AVG-ELAP-DAYS-RP-A
019900         MOVE DFHBMASB           TO MU01-TABLE-NBR-DESC-A
020000                                    MU01-INDIVIDUAL-SALE-A
020100                                    MU01-INDIVIDUAL-AUTH-A
020200                                    MU01-DAYS-LAST-DEP-A
020300                                    MU01-MONTHLY-CHARGEBACKS-A
020400                                    MU01-WEEKLY-GROSS-SALES-A
020500                                    MU01-AVG-NBR-MONTHS-A
020600                                    MU01-AVG-ELAP-DAYS-A
020700     END-IF.
020800*
020900******************************************
021000*    SET THE CURSOR AND SCREEN NUMBER    *
021100******************************************
021200*
021300     IF  MBCA-PTI-FUNCTION-IS-INQUIRY
021400         MOVE SS08WS-CURSOR      TO MU01-ALT-TRANID-L
021500     ELSE
021600         MOVE SS08WS-CURSOR      TO MU01-TABLE-NBR-DESC-L
021700     END-IF.
021800*
021900     COMPUTE MBCA-SCREEN-NBR     =  MBCA-SCREEN-NBR - 50.
022000*
022100**********************
022200*    SEND THE MAP    *
022300**********************
022400*
022500     MOVE 'BM01'                 TO MBCA-PROGRAM-LOCATION.
022600     PERFORM MB60PD-SEND-MAP-WITH-ERASE
022700                                 THRU MB60PD-SMWE-EXIT.
022800*
022900************************
023000*    RETURN TO CICS    *
023100************************
023200*
023300     MOVE 'PC02'                 TO MBCA-PROGRAM-LOCATION.
023400     PERFORM MB70PD-RETURN-TRANS-ID
023500                                 THRU MB70PD-RTI-EXIT.
023600/
023700 C000-RECEIVE-SCREEN SECTION.
023800*
023900******************************************
024000*    THIS SECTION RECEIVES THE SCREEN    *
024100******************************************
024200*
024300     MOVE 'BM02'                 TO MBCA-PROGRAM-LOCATION.
024400     PERFORM MB60PD-RECEIVE-MAP  THRU MB60PD-RM-EXIT.
024500*
024600**************************************************************
024700*    CHECK FOR ANOTHER TRANSACTION ID ENTERED BY THE USER    *
024800**************************************************************
024900*
025000     MOVE 'PC03'                 TO MBCA-PROGRAM-LOCATION.
025100     PERFORM MB60PD-NEW-TRANS-ROUTINE
025200                                 THRU MB60PD-NTR-EXIT.
025300*
025400****************************************************
025500*    BYPASS ALL SCREEN EDITS IF THIS IS INQIURY    *
025600****************************************************
025700*
025800     IF  MBCA-PTI-FUNCTION-IS-INQUIRY
025900         GO TO F000-SETUP-COMMAREA
026000     END-IF.
026100*
026200*****************************************
026300*    READ THE FRAUD PARAMETERS RECORD   *
026400*****************************************
026500*
026600     MOVE 'FC02'                 TO MBCA-PROGRAM-LOCATION.
026700     PERFORM Y900-READ-MMFP      THRU Y909-READ-MMFP-EXIT.
026800*
026900***********************************************************
027000*    MOVE THE LAST MAINT DATE AND LAST MAINT OPERATOR,    *
027100*    DEPENDING ON THE FUNCTION                            *
027200***********************************************************
027300*
027400     IF  MBCA-PTI-FUNCTION-IS-ADD
027500         MOVE DFHBMDAS           TO MU01-LAST-MAINT-DATE-LIT-A
027600                                    MU01-LAST-MAINT-DATE-A
027700                                    MU01-LAST-MAINT-OPER-LIT-A
027800                                    MU01-LAST-MAINT-OPER-A
027900     ELSE
028000         MOVE MMFP-LAST-MAINT-DATE
028100                                 TO SS01WS-JULIAN
028200         PERFORM SS26PD-NUMERICALLY-EDIT-DATE
028300                                 THRU SS26PD-NED-EXIT
028400         MOVE SS01WS-XX-XX-YYYY  TO MU01-LAST-MAINT-DATE
028500         MOVE MMFP-LAST-MAINT-OPER
028600                                 TO MU01-LAST-MAINT-OPER
028700     END-IF.
028800*
028900 C020-FIELD-EDITS.
029000*
029100*********************
029200*    FIELD EDITS    *
029300*********************
029400*
029500     PERFORM W010-EDIT-FRAUD-DESC
029600                                 THRU W019-EFD-EXIT.
029700*
029800     PERFORM W020-EDIT-FRAUD-SALE-AMT
029900                                 THRU W029-EFSA-EXIT.
030000*
030100     PERFORM W030-EDIT-FRAUD-AUTH-AMT
030200                                 THRU W039-EFAA-EXIT.
030300*
030400     PERFORM W040-EDIT-FRAUD-LAST-DEP
030500                                 THRU W049-EFLD-EXIT.
030600*
030700     PERFORM W050-EDIT-FRAUD-CHGBACK
030800                                 THRU W059-EFC-EXIT.
030900*
031000     PERFORM W060-EDIT-FRAUD-WEEK-SALES
031100                                 THRU W069-EFWS-EXIT.
031200*
031300     PERFORM W070-EDIT-AVG-NBR-MONTHS
031400                                 THRU W079-EANM-EXIT.
031500*
031600     PERFORM W080-EDIT-AVG-ELAP-DAYS
031700                                 THRU W089-EAED-EXIT.
031800*
031900/
032000 D000-RETURN-ERRORS SECTION.
032100*
032200     IF  SS08WS-ERROR-SW-NO
032300         GO TO E000-UPDATE-FILE
032400     END-IF.
032500*
032600***************************************************************
032700*    INITIALIZE THE STANDARD MAP LINES.  IN AN ERROR          *
032800*    CONDITION, THIS ROUTINE IS PERFORMED PRIMARILY           *
032900*    TO UPDATE THE DATE AND TIME ON THE SCREEN.               *
033000***************************************************************
033100*
033200     PERFORM MB60PD-INIT-STD-MAP-LINES
033300                                 THRU MB60PD-ISML-EXIT.
033400*
033500**********************
033600*    SEND THE MAP    *
033700**********************
033800*
033900     MOVE 'BM03'                 TO MBCA-PROGRAM-LOCATION.
034000     PERFORM MB60PD-SEND-MAP-DATA-ONLY
034100                                 THRU MB60PD-SMDO-EXIT.
034200*
034300************************
034400*    RETURN TO CICS    *
034500************************
034600*
034700     MOVE 'PC04'                 TO MBCA-PROGRAM-LOCATION.
034800     PERFORM MB70PD-RETURN-TRANS-ID
034900                                 THRU MB70PD-RTI-EXIT.
035000/
035100 E000-UPDATE-FILE SECTION.
035200*
035300****************************************************
035400*    READ THE FRAUD PARAMETERS RECORD FOR UPDATE   *
035500****************************************************
035600*
035700     MOVE 'FC03'                 TO MBCA-PROGRAM-LOCATION.
035800     SET MBIORO-READ-RANDOM-UPDATE
035900                                 TO TRUE.
036000     PERFORM MMFPAO-ACCESS       THRU MMFPAO-ACCESS-EXIT.
036100*
036200*************************************
036300*    OBTAIN STORAGE FOR LOG FILE    *
036400*************************************
036500*
036600     MOVE 'SC02'                 TO MBCA-PROGRAM-LOCATION.
036700     SET MBIORO-GETMAIN          TO TRUE.
036800     PERFORM MML1AO-ACCESS       THRU MML1AO-ACCESS-EXIT.
036900*
037000*************************************************
037100*    SET UP THE COMMON PORTION OF THE RECORD    *
037200*************************************************
037300*
037400     MOVE 'FP'                   TO MML1-FILE-CODE.
037500     MOVE MBCA-MERCHANT-ORG      TO MML1-MMFP-ORG.
037600     MOVE MBCA-TABLE             TO MML1-MMFP-TABLE-NBR.
037700     MOVE MBCA-SIGNON-NAME       TO MML1-SIGNON-NAME.
037800     MOVE MBCA-TERMINAL-ID       TO MML1-TERMINAL-ID.
037900     MOVE ZEROS                  TO MML1-SOURCE-CODE.
038000*
038100 E020-UPDATE-FIELDS.
038200*
038300     PERFORM X010-UPDATE-FRAUD-DESC
038400                                 THRU X019-UFD-EXIT.
038500*
038600     PERFORM X020-UPDATE-FRAUD-SALE-AMT
038700                                 THRU X029-UFSA-EXIT.
038800*
038900     PERFORM X030-UPDATE-FRAUD-AUTH-AMT
039000                                 THRU X039-UFAA-EXIT.
039100*
039200     PERFORM X040-UPDATE-FRAUD-LAST-DEP
039300                                 THRU X049-UFLD-EXIT.
039400*
039500     PERFORM X050-UPDATE-FRAUD-CHGBACK
039600                                 THRU X059-UFC-EXIT.
039700*
039800     PERFORM X060-UPDATE-FRAUD-WEEK-SALES
039900                                 THRU X069-UFWS-EXIT.
040000*
040100     PERFORM X070-UPDATE-AVG-NBR-MONTHS
040200                                 THRU X079-UANM-EXIT.
040300*
040400     PERFORM X080-UPDATE-AVG-ELAP-DAYS
040500                                 THRU X089-UAED-EXIT.
040600*
040700 E040-UPDATE-MMFP.
040800*
040900     IF  MBCA-PTI-FUNCTION-IS-ADD
041000         MOVE MBCA-SCREEN-NBR    TO MMFP-ONLINE-STATUS
041100         MOVE MBCA-START-DATE    TO MMFP-LAST-MAINT-DATE
041200         MOVE MBCA-OPERATOR-ID   TO MMFP-LAST-MAINT-OPER
041300         SET WS-UPDATE-SW-YES    TO TRUE
041400     END-IF.
041500*
041600**************************************************************
041700*    WRITE A LOG RECORD TO SHOW THAT THE LAST MAINT DATE     *
041800*    AND OPERATOR HAS BEEN UPDATED IF FIELDS WERE CHANGED    *
041900*    ON THE SCREEN                                           *
042000**************************************************************
042100*
042200     IF  MBCA-PTI-FUNCTION-IS-MAINT
042300     AND WS-UPDATE-SW-YES
042400         MOVE 0198               TO MML1-FIELD-CODE
042500         MOVE ZEROES             TO MML1-FIELD-OCCURRENCE
042600                                    MML1-FIELD-OCCURRENCE-2
042700         MOVE MML1WS-VL-03       TO MML1-VARIABLE-LENGTH
042800         MOVE MMFP-LAST-MAINT-OPER
042900                                 TO MML1-VL03-B-DATA-X
043000         MOVE MBCA-OPERATOR-ID   TO MMFP-LAST-MAINT-OPER
043100         MOVE MMFP-LAST-MAINT-OPER
043200                                 TO MML1-VL03-A-DATA-X
043300         MOVE 'FC04'             TO MBCA-PROGRAM-LOCATION
043400         PERFORM Y920-WRITE-LOG-RECORD
043500                                 THRU Y929-WLR-EXIT
043600         MOVE 0199               TO MML1-FIELD-CODE
043700         MOVE MML1WS-VL-07       TO MML1-VARIABLE-LENGTH
043800         MOVE MMFP-LAST-MAINT-DATE
043900                                 TO MML1-VL07-B-DATA-9
044000         MOVE MBCA-START-DATE    TO MMFP-LAST-MAINT-DATE
044100         MOVE MMFP-LAST-MAINT-DATE
044200                                 TO MML1-VL07-A-DATA-9
044300         MOVE 'FC05'             TO MBCA-PROGRAM-LOCATION
044400         PERFORM Y920-WRITE-LOG-RECORD
044500                                 THRU Y929-WLR-EXIT
044600     END-IF.
044700*
044800****************************************************
044900*    REWRITE THE FRAUD PARAMETERS RECORD IF        *
045000*    FIELDS HAVE BEEN CHANGED ON THE SCREEN, OR    *
045100*    UNLOCK IT IF THEY HAVE NOT                    *
045200****************************************************
045300*
045400     IF  WS-UPDATE-SW-YES
045500         MOVE 'FC06'             TO MBCA-PROGRAM-LOCATION
045600         SET MBIORO-REWRITE      TO TRUE
045700         PERFORM MMFPAO-ACCESS   THRU MMFPAO-ACCESS-EXIT
045800     ELSE
045900         MOVE 'FC07'             TO MBCA-PROGRAM-LOCATION
046000         SET MBIORO-UNLOCK       TO TRUE
046100         PERFORM MMFPAO-ACCESS   THRU MMFPAO-ACCESS-EXIT
046200     END-IF.
046300/
046400 F000-SETUP-COMMAREA SECTION.
046500*
046600***************************************************************
046700*  SET UP COMMAREA FIELDS AND TRANSFER TO THE NEXT PROGRAM    *
046800***************************************************************
046900*
047000     MOVE MBCA-EIBAID            TO SS08WS-EIBAID.
047100*
047200     PERFORM MB60PD-EDIT-PAGE-NBR
047300                                 THRU MB60PD-EPN-EXIT.
047400*
047500     IF  SS08WS-VALID-PF-KEY
047600     OR  SS08WS-EIBAID-VALID-PF-KEY
047700         SET MBCA-INITIAL-SCREEN-NBR
047800                                 TO TRUE
047900     END-IF.
048000*
048100     MOVE 'PC05'                 TO MBCA-PROGRAM-LOCATION.
048200     PERFORM MB70PD-XCTL-TO-MBOXCTL
048300                                 THRU MB70PD-XTM-EXIT.
048400/
048500 W000-FIELD-EDITS SECTION.
048600*
048700*********************************************************
048800*    EACH FIELD IS CODED IN A SEPERATE ROUTINE, AND     *
048900*    IN A LIKE MANNER.                                  *
049000*    EACH ROUTINE MAY CONTAIN COMMENTS, BUT THEY        *
049100*    ARE UNIQUE TO THAT ROUTINE.                        *
049200*********************************************************
049300*
049400 W010-EDIT-FRAUD-DESC.
049500*
049600     IF  MU01-TABLE-NBR-DESC-L IS LESS THAN 1
049700         MOVE DFHBMASK           TO MU01-TABLE-NBR-DESC-A
049800         MOVE DFHBMDAS           TO MU01-TABLE-NBR-DESC-LP-A
049900                                    MU01-TABLE-NBR-DESC-RP-A
050000         MOVE MMFP-FRAUD-TABLE-DESC
050100                                 TO MU01-TABLE-NBR-DESC
050200     ELSE
050300         MOVE DFHBMASF           TO MU01-TABLE-NBR-DESC-A
050400         MOVE DFHBMDAS           TO MU01-TABLE-NBR-DESC-LP-A
050500                                    MU01-TABLE-NBR-DESC-RP-A
050600         SET WS-UPDATE-SW-YES    TO TRUE
050700     END-IF.
050800*
050900 W019-EFD-EXIT.
051000     EXIT.
051100*
051200 W020-EDIT-FRAUD-SALE-AMT.
051300*
051400     IF  MU01-INDIVIDUAL-SALE-L IS LESS THAN 1
051500         MOVE DFHBMASK           TO MU01-INDIVIDUAL-SALE-A
051600         MOVE DFHBMDAS           TO MU01-INDIVIDUAL-SALE-LP-A
051700                                    MU01-INDIVIDUAL-SALE-RP-A
051800         MOVE MMFP-FRAUD-SALE-EXCESS-AMT
051900                                 TO MU01-INDIVIDUAL-SALE
052000     ELSE
052100         IF  MU01-INDIVIDUAL-SALE IS NOT NUMERIC
052200             MOVE DFHBMNBF       TO MU01-INDIVIDUAL-SALE-A
052300             MOVE DFHBMASB       TO MU01-INDIVIDUAL-SALE-LP-A
052400                                    MU01-INDIVIDUAL-SALE-RP-A
052500             MOVE SS08WS-CURSOR  TO MU01-INDIVIDUAL-SALE-L
052600             SET SS08WS-ERROR-SW-YES
052700                                 TO TRUE
052800         ELSE
052900             MOVE DFHBMASF       TO MU01-INDIVIDUAL-SALE-A
053000             MOVE DFHBMDAS       TO MU01-INDIVIDUAL-SALE-LP-A
053100                                    MU01-INDIVIDUAL-SALE-RP-A
053200             SET WS-UPDATE-SW-YES
053300                                 TO TRUE
053400         END-IF
053500     END-IF.
053600*
053700 W029-EFSA-EXIT.
053800     EXIT.
053900*
054000 W030-EDIT-FRAUD-AUTH-AMT.
054100*
054200     IF  MU01-INDIVIDUAL-AUTH-L IS LESS THAN 1
054300         MOVE DFHBMASK           TO MU01-INDIVIDUAL-AUTH-A
054400         MOVE DFHBMDAS           TO MU01-INDIVIDUAL-AUTH-LP-A
054500                                    MU01-INDIVIDUAL-AUTH-RP-A
054600         MOVE MMFP-FRAUD-AUTH-EXCESS-AMT
054700                                 TO MU01-INDIVIDUAL-AUTH
054800     ELSE
054900         IF  MU01-INDIVIDUAL-AUTH IS NOT NUMERIC
055000             MOVE DFHBMNBF       TO MU01-INDIVIDUAL-AUTH-A
055100             MOVE DFHBMASB       TO MU01-INDIVIDUAL-AUTH-LP-A
055200                                    MU01-INDIVIDUAL-AUTH-RP-A
055300             MOVE SS08WS-CURSOR  TO MU01-INDIVIDUAL-AUTH-L
055400             SET SS08WS-ERROR-SW-YES
055500                                 TO TRUE
055600         ELSE
055700             MOVE DFHBMASF       TO MU01-INDIVIDUAL-AUTH-A
055800             MOVE DFHBMDAS       TO MU01-INDIVIDUAL-AUTH-LP-A
055900                                    MU01-INDIVIDUAL-AUTH-RP-A
056000             SET WS-UPDATE-SW-YES
056100                                 TO TRUE
056200         END-IF
056300     END-IF.
056400*
056500 W039-EFAA-EXIT.
056600     EXIT.
056700*
056800 W040-EDIT-FRAUD-LAST-DEP.
056900*
057000     IF  MU01-DAYS-LAST-DEP-L IS LESS THAN 1
057100         MOVE DFHBMASK           TO MU01-DAYS-LAST-DEP-A
057200         MOVE DFHBMDAS           TO MU01-DAYS-LAST-DEP-LP-A
057300                                    MU01-DAYS-LAST-DEP-RP-A
057400         MOVE MMFP-FRAUD-LAST-DEP-EXCESS
057500                                 TO MU01-DAYS-LAST-DEP
057600     ELSE
057700         IF  MU01-DAYS-LAST-DEP IS NOT NUMERIC
057800             MOVE DFHBMNBF       TO MU01-DAYS-LAST-DEP-A
057900             MOVE DFHBMASB       TO MU01-DAYS-LAST-DEP-LP-A
058000                                    MU01-DAYS-LAST-DEP-RP-A
058100             MOVE SS08WS-CURSOR  TO MU01-DAYS-LAST-DEP-L
058200             SET SS08WS-ERROR-SW-YES
058300                                 TO TRUE
058400         ELSE
058500             MOVE DFHBMASF       TO MU01-DAYS-LAST-DEP-A
058600             MOVE DFHBMDAS       TO MU01-DAYS-LAST-DEP-LP-A
058700                                    MU01-DAYS-LAST-DEP-RP-A
058800             SET WS-UPDATE-SW-YES
058900                                 TO TRUE
059000         END-IF
059100     END-IF.
059200*
059300 W049-EFLD-EXIT.
059400     EXIT.
059500*
059600 W050-EDIT-FRAUD-CHGBACK.
059700*
059800     IF  MU01-MONTHLY-CHARGEBACKS-L IS LESS THAN 1
059900         MOVE DFHBMASK           TO MU01-MONTHLY-CHARGEBACKS-A
060000         MOVE DFHBMDAS           TO MU01-MONTHLY-CHARGEBACKS-LP-A
060100                                    MU01-MONTHLY-CHARGEBACKS-RP-A
060200         MOVE MMFP-FRAUD-CHGBACK-EXCESS
060300                                 TO MU01-MONTHLY-CHARGEBACKS
060400     ELSE
060500         IF  MU01-MONTHLY-CHARGEBACKS IS NOT NUMERIC
060600             MOVE DFHBMNBF       TO MU01-MONTHLY-CHARGEBACKS-A
060700             MOVE DFHBMASB       TO MU01-MONTHLY-CHARGEBACKS-LP-A
060800                                    MU01-MONTHLY-CHARGEBACKS-RP-A
060900             MOVE SS08WS-CURSOR  TO MU01-MONTHLY-CHARGEBACKS-L
061000             SET SS08WS-ERROR-SW-YES
061100                                 TO TRUE
061200         ELSE
061300             MOVE DFHBMASF       TO MU01-MONTHLY-CHARGEBACKS-A
061400             MOVE DFHBMDAS       TO MU01-MONTHLY-CHARGEBACKS-LP-A
061500                                    MU01-MONTHLY-CHARGEBACKS-RP-A
061600             SET WS-UPDATE-SW-YES
061700                                 TO TRUE
061800         END-IF
061900     END-IF.
062000*
062100 W059-EFC-EXIT.
062200     EXIT.
062300*
062400 W060-EDIT-FRAUD-WEEK-SALES.
062500*
062600     IF  MU01-WEEKLY-GROSS-SALES-L IS LESS THAN 1
062700         MOVE DFHBMASK           TO MU01-WEEKLY-GROSS-SALES-A
062800         MOVE DFHBMDAS           TO MU01-WEEKLY-GROSS-SALES-LP-A
062900                                    MU01-WEEKLY-GROSS-SALES-RP-A
063000         MOVE MMFP-FRAUD-WEEK-EXCESS-SALES
063100                                 TO MU01-WEEKLY-GROSS-SALES
063200     ELSE
063300         IF  MU01-WEEKLY-GROSS-SALES IS NOT NUMERIC
063400             MOVE DFHBMNBF       TO MU01-WEEKLY-GROSS-SALES-A
063500             MOVE DFHBMASB       TO MU01-WEEKLY-GROSS-SALES-LP-A
063600                                    MU01-WEEKLY-GROSS-SALES-RP-A
063700             MOVE SS08WS-CURSOR  TO MU01-WEEKLY-GROSS-SALES-L
063800             SET SS08WS-ERROR-SW-YES
063900                                 TO TRUE
064000         ELSE
064100             MOVE DFHBMASF       TO MU01-WEEKLY-GROSS-SALES-A
064200             MOVE DFHBMDAS       TO MU01-WEEKLY-GROSS-SALES-LP-A
064300                                    MU01-WEEKLY-GROSS-SALES-RP-A
064400             SET WS-UPDATE-SW-YES
064500                                 TO TRUE
064600         END-IF
064700     END-IF.
064800*
064900 W069-EFWS-EXIT.
065000     EXIT.
065100*
065200 W070-EDIT-AVG-NBR-MONTHS.
065300*
065400     IF  MU01-AVG-NBR-MONTHS-L IS LESS THAN 1
065500         MOVE DFHBMASK           TO MU01-AVG-NBR-MONTHS-A
065600         MOVE DFHBMDAS           TO MU01-AVG-NBR-MONTHS-LP-A
065700                                    MU01-AVG-NBR-MONTHS-RP-A
065800         MOVE MMFP-FRAUD-AVG-NBR-MONTHS
065900                                 TO MU01-AVG-NBR-MONTHS
066000     ELSE
066100         IF  MU01-AVG-NBR-MONTHS IS NOT NUMERIC
066200         OR  MU01-AVG-NBR-MONTHS IS GREATER THAN 12
066300             MOVE DFHBMNBF       TO MU01-AVG-NBR-MONTHS-A
066400             MOVE DFHBMASB       TO MU01-AVG-NBR-MONTHS-LP-A
066500                                    MU01-AVG-NBR-MONTHS-RP-A
066600             MOVE SS08WS-CURSOR  TO MU01-AVG-NBR-MONTHS-L
066700             SET SS08WS-ERROR-SW-YES
066800                                 TO TRUE
066900         ELSE
067000             MOVE DFHBMASF       TO MU01-AVG-NBR-MONTHS-A
067100             MOVE DFHBMDAS       TO MU01-AVG-NBR-MONTHS-LP-A
067200                                    MU01-AVG-NBR-MONTHS-RP-A
067300             SET WS-UPDATE-SW-YES
067400                                 TO TRUE
067500         END-IF
067600     END-IF.
067700*
067800 W079-EANM-EXIT.
067900     EXIT.
068000*
068100 W080-EDIT-AVG-ELAP-DAYS.
068200*
068300     IF  MU01-AVG-ELAP-DAYS-L  IS LESS THAN 1
068400         MOVE DFHBMASK           TO MU01-AVG-ELAP-DAYS-A
068500         MOVE DFHBMDAS           TO MU01-AVG-ELAP-DAYS-LP-A
068600                                    MU01-AVG-ELAP-DAYS-RP-A
068700         MOVE MMFP-FRAUD-AVG-ELAP-DAYS
068800                                 TO MU01-AVG-ELAP-DAYS
068900     ELSE
069000         IF  MU01-AVG-ELAP-DAYS IS NOT NUMERIC
069100         OR  MU01-AVG-ELAP-DAYS IS GREATER THAN 365
069200             MOVE DFHBMNBF       TO MU01-AVG-ELAP-DAYS-A
069300             MOVE DFHBMASB       TO MU01-AVG-ELAP-DAYS-LP-A
069400                                    MU01-AVG-ELAP-DAYS-RP-A
069500             MOVE SS08WS-CURSOR  TO MU01-AVG-ELAP-DAYS-L
069600             SET SS08WS-ERROR-SW-YES
069700                                 TO TRUE
069800         ELSE
069900             MOVE DFHBMASF       TO MU01-AVG-ELAP-DAYS-A
070000             MOVE DFHBMDAS       TO MU01-AVG-ELAP-DAYS-LP-A
070100                                    MU01-AVG-ELAP-DAYS-RP-A
070200             SET WS-UPDATE-SW-YES
070300                                 TO TRUE
070400         END-IF
070500     END-IF.
070600*
070700 W089-EAED-EXIT.
070800     EXIT.
070900/
071000 X000-UPDATE-FIELDS SECTION.
071100*
071200 X010-UPDATE-FRAUD-DESC.
071300*
071400     IF  MU01-TABLE-NBR-DESC-L IS GREATER THAN ZERO
071500         IF  MU01-TABLE-NBR-DESC IS NOT EQUAL
071600                                 TO MMFP-FRAUD-TABLE-DESC
071700             SET WS-UPDATE-SW-YES
071800                                 TO TRUE
071900             IF  MBCA-PTI-FUNCTION-IS-MAINT
072000                 MOVE 0101       TO MML1-FIELD-CODE
072100                 MOVE ZEROES     TO MML1-FIELD-OCCURRENCE
072200                                    MML1-FIELD-OCCURRENCE-2
072300                 MOVE MML1WS-VL-30
072400                                 TO MML1-VARIABLE-LENGTH
072500                 MOVE MMFP-FRAUD-TABLE-DESC
072600                                 TO MML1-VL30-B-DATA-X
072700                 MOVE MU01-TABLE-NBR-DESC
072800                                 TO MMFP-FRAUD-TABLE-DESC
072900                 MOVE MMFP-FRAUD-TABLE-DESC
073000                                 TO MML1-VL30-A-DATA-X
073100                 MOVE 'FC08'     TO MBCA-PROGRAM-LOCATION
073200                 PERFORM Y920-WRITE-LOG-RECORD
073300                                 THRU Y929-WLR-EXIT
073400             ELSE
073500                 MOVE MU01-TABLE-NBR-DESC
073600                                 TO MMFP-FRAUD-TABLE-DESC
073700             END-IF
073800         END-IF
073900     END-IF.
074000*
074100 X019-UFD-EXIT.
074200     EXIT.
074300*
074400 X020-UPDATE-FRAUD-SALE-AMT.
074500*
074600     IF  MU01-INDIVIDUAL-SALE-L IS GREATER THAN ZERO
074700         IF  MU01-INDIVIDUAL-SALE IS NOT EQUAL
074800                                 TO MMFP-FRAUD-SALE-EXCESS-AMT
074900             SET WS-UPDATE-SW-YES
075000                                 TO TRUE
075100             IF  MBCA-PTI-FUNCTION-IS-MAINT
075200                 MOVE 0102       TO MML1-FIELD-CODE
075300                 MOVE ZEROES     TO MML1-FIELD-OCCURRENCE
075400                                    MML1-FIELD-OCCURRENCE-2
075500                 MOVE MML1WS-VL-20
075600                                 TO MML1-VARIABLE-LENGTH
075700                 MOVE MMFP-FRAUD-SALE-EXCESS-AMT
075800                                 TO MML1-VL20-B-NBR-NO-DEC
075900                 MOVE MU01-INDIVIDUAL-SALE
076000                                 TO MMFP-FRAUD-SALE-EXCESS-AMT
076100                 MOVE MMFP-FRAUD-SALE-EXCESS-AMT
076200                                 TO MML1-VL20-A-NBR-NO-DEC
076300                 MOVE 'FC09'     TO MBCA-PROGRAM-LOCATION
076400                 PERFORM Y920-WRITE-LOG-RECORD
076500                                 THRU Y929-WLR-EXIT
076600             ELSE
076700                 MOVE MU01-INDIVIDUAL-SALE
076800                                 TO MMFP-FRAUD-SALE-EXCESS-AMT
076900             END-IF
077000         END-IF
077100     END-IF.
077200*
077300 X029-UFSA-EXIT.
077400     EXIT.
077500*
077600 X030-UPDATE-FRAUD-AUTH-AMT.
077700*
077800     IF  MU01-INDIVIDUAL-AUTH-L IS GREATER THAN ZERO
077900         IF  MU01-INDIVIDUAL-AUTH IS NOT EQUAL
078000                                 TO MMFP-FRAUD-AUTH-EXCESS-AMT
078100             SET WS-UPDATE-SW-YES
078200                                 TO TRUE
078300             IF  MBCA-PTI-FUNCTION-IS-MAINT
078400                 MOVE 0103       TO MML1-FIELD-CODE
078500                 MOVE ZEROES     TO MML1-FIELD-OCCURRENCE
078600                                    MML1-FIELD-OCCURRENCE-2
078700                 MOVE MML1WS-VL-20
078800                                 TO MML1-VARIABLE-LENGTH
078900                 MOVE MMFP-FRAUD-AUTH-EXCESS-AMT
079000                                 TO MML1-VL20-B-NBR-NO-DEC
079100                 MOVE MU01-INDIVIDUAL-AUTH
079200                                 TO MMFP-FRAUD-AUTH-EXCESS-AMT
079300                 MOVE MMFP-FRAUD-AUTH-EXCESS-AMT
079400                                 TO MML1-VL20-A-NBR-NO-DEC
079500                 MOVE 'FC10'     TO MBCA-PROGRAM-LOCATION
079600                 PERFORM Y920-WRITE-LOG-RECORD
079700                                 THRU Y929-WLR-EXIT
079800             ELSE
079900                 MOVE MU01-INDIVIDUAL-AUTH
080000                                 TO MMFP-FRAUD-AUTH-EXCESS-AMT
080100             END-IF
080200         END-IF
080300     END-IF.
080400*
080500 X039-UFAA-EXIT.
080600     EXIT.
080700*
080800 X040-UPDATE-FRAUD-LAST-DEP.
080900*
081000     IF  MU01-DAYS-LAST-DEP-L IS GREATER THAN ZERO
081100         IF  MU01-DAYS-LAST-DEP IS NOT EQUAL
081200                                 TO MMFP-FRAUD-LAST-DEP-EXCESS
081300             SET WS-UPDATE-SW-YES
081400                                 TO TRUE
081500             IF  MBCA-PTI-FUNCTION-IS-MAINT
081600                 MOVE 0104       TO MML1-FIELD-CODE
081700                 MOVE ZEROES     TO MML1-FIELD-OCCURRENCE
081800                                    MML1-FIELD-OCCURRENCE-2
081900                 MOVE MML1WS-VL-03
082000                                 TO MML1-VARIABLE-LENGTH
082100                 MOVE MMFP-FRAUD-LAST-DEP-EXCESS
082200                                 TO MML1-VL03-B-DATA-9
082300                 MOVE MU01-DAYS-LAST-DEP
082400                                 TO MMFP-FRAUD-LAST-DEP-EXCESS
082500                 MOVE MMFP-FRAUD-LAST-DEP-EXCESS
082600                                 TO MML1-VL03-A-DATA-9
082700                 MOVE 'FC11'     TO MBCA-PROGRAM-LOCATION
082800                 PERFORM Y920-WRITE-LOG-RECORD
082900                                 THRU Y929-WLR-EXIT
083000             ELSE
083100                 MOVE MU01-DAYS-LAST-DEP
083200                                 TO MMFP-FRAUD-LAST-DEP-EXCESS
083300             END-IF
083400         END-IF
083500     END-IF.
083600*
083700 X049-UFLD-EXIT.
083800     EXIT.
083900*
084000 X050-UPDATE-FRAUD-CHGBACK.
084100*
084200     IF  MU01-MONTHLY-CHARGEBACKS-L IS GREATER THAN ZERO
084300         IF  MU01-MONTHLY-CHARGEBACKS IS NOT EQUAL
084400                                 TO MMFP-FRAUD-CHGBACK-EXCESS
084500             SET WS-UPDATE-SW-YES
084600                                 TO TRUE
084700             IF  MBCA-PTI-FUNCTION-IS-MAINT
084800                 MOVE 0105       TO MML1-FIELD-CODE
084900                 MOVE ZEROES     TO MML1-FIELD-OCCURRENCE
085000                                    MML1-FIELD-OCCURRENCE-2
085100                 MOVE MML1WS-VL-03
085200                                 TO MML1-VARIABLE-LENGTH
085300                 MOVE MMFP-FRAUD-CHGBACK-EXCESS
085400                                 TO MML1-VL03-B-DATA-9
085500                 MOVE MU01-MONTHLY-CHARGEBACKS
085600                                 TO MMFP-FRAUD-CHGBACK-EXCESS
085700                 MOVE MMFP-FRAUD-CHGBACK-EXCESS
085800                                 TO MML1-VL03-A-DATA-9
085900                 MOVE 'FC12'     TO MBCA-PROGRAM-LOCATION
086000                 PERFORM Y920-WRITE-LOG-RECORD
086100                                 THRU Y929-WLR-EXIT
086200             ELSE
086300                 MOVE MU01-MONTHLY-CHARGEBACKS
086400                                 TO MMFP-FRAUD-CHGBACK-EXCESS
086500             END-IF
086600         END-IF
086700     END-IF.
086800*
086900 X059-UFC-EXIT.
087000     EXIT.
087100*
087200 X060-UPDATE-FRAUD-WEEK-SALES.
087300*
087400     IF  MU01-WEEKLY-GROSS-SALES-L IS GREATER THAN ZERO
087500         IF  MU01-WEEKLY-GROSS-SALES IS NOT EQUAL
087600                                 TO MMFP-FRAUD-WEEK-EXCESS-SALES
087700             SET WS-UPDATE-SW-YES
087800                                 TO TRUE
087900             IF  MBCA-PTI-FUNCTION-IS-MAINT
088000                 MOVE 0106       TO MML1-FIELD-CODE
088100                 MOVE ZEROES     TO MML1-FIELD-OCCURRENCE
088200                                    MML1-FIELD-OCCURRENCE-2
088300                 MOVE MML1WS-VL-20
088400                                 TO MML1-VARIABLE-LENGTH
088500                 MOVE MMFP-FRAUD-WEEK-EXCESS-SALES
088600                                 TO MML1-VL20-B-NBR-NO-DEC
088700                 MOVE MU01-WEEKLY-GROSS-SALES
088800                                 TO MMFP-FRAUD-WEEK-EXCESS-SALES
088900                 MOVE MMFP-FRAUD-WEEK-EXCESS-SALES
089000                                 TO MML1-VL20-A-NBR-NO-DEC
089100                 MOVE 'FC13'     TO MBCA-PROGRAM-LOCATION
089200                 PERFORM Y920-WRITE-LOG-RECORD
089300                                 THRU Y929-WLR-EXIT
089400             ELSE
089500                 MOVE MU01-WEEKLY-GROSS-SALES
089600                                 TO MMFP-FRAUD-WEEK-EXCESS-SALES
089700             END-IF
089800         END-IF
089900     END-IF.
090000*
090100 X069-UFWS-EXIT.
090200     EXIT.
090300*
090400 X070-UPDATE-AVG-NBR-MONTHS.
090500*
090600     IF  MU01-AVG-NBR-MONTHS-L IS GREATER THAN ZERO
090700         IF  MU01-AVG-NBR-MONTHS IS NOT EQUAL
090800                                 TO MMFP-FRAUD-AVG-NBR-MONTHS
090900             SET WS-UPDATE-SW-YES
091000                                 TO TRUE
091100             IF  MBCA-PTI-FUNCTION-IS-MAINT
091200                 MOVE 0107       TO MML1-FIELD-CODE
091300                 MOVE ZEROES     TO MML1-FIELD-OCCURRENCE
091400                                    MML1-FIELD-OCCURRENCE-2
091500                 MOVE MML1WS-VL-03
091600                                 TO MML1-VARIABLE-LENGTH
091700                 MOVE MMFP-FRAUD-AVG-NBR-MONTHS
091800                                 TO MML1-VL03-B-DATA-9
091900                 MOVE MU01-AVG-NBR-MONTHS
092000                                 TO MMFP-FRAUD-AVG-NBR-MONTHS
092100                 MOVE MMFP-FRAUD-AVG-NBR-MONTHS
092200                                 TO MML1-VL03-A-DATA-9
092300                 MOVE 'FC14'     TO MBCA-PROGRAM-LOCATION
092400                 PERFORM Y920-WRITE-LOG-RECORD
092500                                 THRU Y929-WLR-EXIT
092600             ELSE
092700                 MOVE MU01-AVG-NBR-MONTHS
092800                                 TO MMFP-FRAUD-AVG-NBR-MONTHS
092900             END-IF
093000         END-IF
093100     END-IF.
093200*
093300 X079-UANM-EXIT.
093400     EXIT.
093500*
093600 X080-UPDATE-AVG-ELAP-DAYS.
093700*
093800     IF  MU01-AVG-ELAP-DAYS-L IS GREATER THAN ZERO
093900         IF  MU01-AVG-ELAP-DAYS IS NOT EQUAL
094000                                 TO MMFP-FRAUD-AVG-ELAP-DAYS
094100             SET WS-UPDATE-SW-YES
094200                                 TO TRUE
094300             IF  MBCA-PTI-FUNCTION-IS-MAINT
094400                 MOVE 0108       TO MML1-FIELD-CODE
094500                 SET MML1-FIELD-OCCURRENCE
094600                                 TO X-MMFP-FRAUD
094700                 MOVE ZEROES     TO MML1-FIELD-OCCURRENCE
094800                                    MML1-FIELD-OCCURRENCE-2
094900                 MOVE MML1WS-VL-03
095000                                 TO MML1-VARIABLE-LENGTH
095100                 MOVE MMFP-FRAUD-AVG-ELAP-DAYS
095200                                 TO MML1-VL03-B-DATA-9
095300                 MOVE MU01-AVG-ELAP-DAYS
095400                                 TO MMFP-FRAUD-AVG-ELAP-DAYS
095500                 MOVE MMFP-FRAUD-AVG-ELAP-DAYS
095600                                 TO MML1-VL03-A-DATA-9
095700                 MOVE 'FC15'     TO MBCA-PROGRAM-LOCATION
095800                 PERFORM Y920-WRITE-LOG-RECORD
095900                                 THRU Y929-WLR-EXIT
096000             ELSE
096100                 MOVE MU01-AVG-ELAP-DAYS
096200                                 TO MMFP-FRAUD-AVG-ELAP-DAYS
096300             END-IF
096400         END-IF
096500     END-IF.
096600*
096700 X089-UAED-EXIT.
096800     EXIT.
096900/
097000 Y000-PERFORMED-ROUTINES SECTION.
097100*
097200 Y900-READ-MMFP.
097300*
097400*****************************************
097500*    READ THE FRAUD PARAMETERS RECORD   *
097600*****************************************
097700*
097800     MOVE MBCA-MERCHANT-ORG      TO MBIOWS-MMFP-ORG
097900                                    MU01-ORG.
098000     MOVE MBCA-TABLE             TO MBIOWS-MMFP-TABLE-NBR
098100                                    MU01-TABLE-NBR.
098200     SET MBIORO-READ-RANDOM      TO TRUE.
098300     PERFORM MMFPAO-ACCESS       THRU MMFPAO-ACCESS-EXIT.
098400*
098500 Y909-READ-MMFP-EXIT.
098600     EXIT.
098700*
098800 Y920-WRITE-LOG-RECORD.
098900*
099000     SET MBIORO-WRITE            TO TRUE.
099100     PERFORM MML1AO-ACCESS       THRU MML1AO-ACCESS-EXIT.
099200     MOVE SPACES                 TO MML1-VARIABLE-AREA.
099300*
099400 Y929-WLR-EXIT.
099500     EXIT.
099600/
099700 Z000-COPIED-ROUTINES SECTION.
099800*
099900**********************************
100000*    JUL TO GREG DATE ROUTINE    *
100100**********************************
100200*
100300     COPY SS08PD.
100400/
100500*********************************
100600*    LINE 24 PF KEYS ROUTINE    *
100700*********************************
100800*
100900     COPY SS15PD.
101000/
101100***************************************
101200*    NUMERICALLY EDIT DATE ROUTINE    *
101300***************************************
101400*
101500     COPY SS26PD.
101600/
101700***************************************
101800*    NUMERICALLY EDIT TIME ROUTINE    *
101900***************************************
102000*
102100     COPY SS27PD.
102200/
102300***********************************
102400*    OBTAIN FILE TABLE ROUTINE    *
102500***********************************
102600*
102700     COPY SMFTPXO.
102800/
102900************************************************
103000*    FRAUD PARAMETERS RECORD ACCESS ROUTINES   *
103100************************************************
103200*
103300     COPY MMFPAO.
103400/
103500*****************************************
103600*    LOG FILE RECORD ACCESS ROUTINES    *
103700*****************************************
103800*
103900     COPY MML1AO.
104000/
104100*****************************
104200*    ONLINE MAP ROUTINES    *
104300*****************************
104400*
104500     COPY MB60PD REPLACING 'MBMAPXX' BY 'MBMU01 '
104600                           MBMAPXXI  BY MBMU01I
104700                           MBMAPXXO  BY MBMU01O.
104800/
104900***************************
105000*    ONLINE PROCEDURES    *
105100***************************
105200*
105300     COPY MB70PD.
