000100 IDENTIFICATION DIVISION.
000200 PROGRAM-ID. MBOMV02.
000201*       RELEASE DATE=08/24/01.        REVISION LEVEL=08.06      *
000202*****************************************************************
000203*WARNING.  THIS COMPUTER PROGRAM IS PROTECTED BY COPYRIGHT LAW  *
000204*AND INTERNATIONAL TREATIES.  UNAUTHORIZED REPRODUCTION OR      *
000205*DISTRIBUTION OF THIS PROGRAM, OR ANY PORTION OF IT, MAY RESULT *
000206*IN SEVERE CIVIL AND CRIMINAL PENATLIES, AND WILL BE PROSECUTED *
000207*TO THE MAXIMUM EXTENT POSSIBLE UNDER THE LAW.                  *
000208*COPYRIGHT 1999 PAYSYS INTERNATIONAL, INC.  ALL RIGHTS RESERVED.*
000209*****************************************************************
000300*****************************************************************
000400*                                                               *
000500*               M E R C H A N T   S Y S T E M                   *
000600*                                                               *
000700*      MBOMV02 - ON-LINE INVENTORY CONTROL ADD/MAINT/INQ        *
000800*                SCREEN 02                                      *
000900*                                                               *
001000*              1. TRANSIDS                                      *
001100*                 A. MBAV                                       *
001200*                 B. MBMV                                       *
001300*                 C. MBQV                                       *
001400*              2. MAPS USED -                                   *
001500*                 A. MBMV02 (SCREEN 02)                         *
001600*              3. FILES USED -                                  *
001700*                 A. MMIC (INVENTORY CONTROL MASTER FILE)       *
001800*                 B. MML1 (LOG FILE)                            *
001900*                                                               *
002000*****************************************************************
002100*
002200 ENVIRONMENT DIVISION.
002300*
002400 DATA DIVISION.
002500*
002600 WORKING-STORAGE SECTION.
002700*
002800 01  FILLER                  PIC  X(12)      VALUE
002900     '** WS-BEG **'.
003000*
003100 01  FILLER                  PIC  X(14)      VALUE
003200     'MISCELLANEOUS:'.
003300*
003400 01  WS-MISCELLANEOUS.
003500     03  WS-UPDATE-SW        PIC  X(01)      VALUE 'N'.
003600         88  FIELDS-WERE-UPDATED             VALUE 'Y'.
003700         88  NO-FIELDS-WERE-UPDATED          VALUE 'N'.
003800     03  WS-INVENTORY-USED-FLAG
003900                             PIC  X(01)      VALUE 'N'.
004000         88  INVENTORY-IS-USED               VALUE 'Y'.
004100         88  INVENTORY-IS-NOT-USED           VALUE 'N'.
004200/
004300 01  FILLER                  PIC  X(29)      VALUE
004400     'I/O REQUEST BLOCK WORK AREAS:'.
004500*
004600     COPY MBIOWS.
004700/
004800 01  FILLER                  PIC  X(18)      VALUE
004900     'I/O REQUEST BLOCK:'.
005000*
005100     COPY MBIORO.
005200/
005300 01  FILLER                  PIC  X(25)      VALUE
005400     'LOG RECORD REQUEST BLOCK:'.
005500*
005600     COPY MML1WS REPLACING ==:MML1:== BY ==MML1==.
005700/
005800 01  FILLER                  PIC  X(20)      VALUE
005900     'CCS DATE WORK AREAS:'.
006000*
006100     COPY SS01WS.
006200/
006300 01  FILLER                  PIC  X(15)      VALUE
006400     'CCS WORK AREAS:'.
006500*
006600     COPY SS08WS.
006700/
006800     COPY SS00WS.
006900/
007000     COPY SMFTWS.
007100/
007200     COPY SMPTRL REPLACING ==:SMPT:== BY ==SMPT==.
007300/
007400     COPY MB61LK.
007500/
007600 01  FILLER                  PIC  X(12)      VALUE
007700     '** WS-END **'.
007800/
007900 LINKAGE SECTION.
008000*
008100 01  DFHCOMMAREA.
008200*
008300     COPY MB60WS.
008400/
008500***********************************
008600*    INVENTORY CONTROL MAP        *
008700***********************************
008800*
008900     COPY MBMV02.
009000/
009100************************************************
009200*    INVENTORY CONTROL MAP REDEFINITION        *
009300************************************************
009400*
009500     COPY MBMV02R.
009600/
009700*********************************************
009800*    INVENTORY CONTROL RECORD LAYOUT        *
009900*********************************************
010000*
010100     COPY MMICRL.
010200/
010300***************************
010400*    LOG RECORD LAYOUT    *
010500***************************
010600*
010700     COPY MML1RL REPLACING ==:MML1:== BY ==MML1==.
010800/
010900 PROCEDURE DIVISION.
011000*
011100 A000-HOUSEKEEPING SECTION.
011200*
011300 A020-INIT.
011400*
011500     MOVE 'PC01'                 TO MBCA-PROGRAM-LOCATION.
011600     PERFORM MB70PD-ON-LINE-HOUSEKEEPING
011700                                 THRU MB70PD-OLH-EXIT.
011800*
011900     IF  MBCA-RECEIVE-SCREEN
012000         GO TO C000-RECEIVE-SCREEN.
012100/
012200 B000-SEND-SCREEN SECTION.
012300*
012400*********************************************
012500*    GET CICS STORAGE NEEDED FOR THE MAP    *
012600*********************************************
012700*
012800     MOVE 'SC01'                 TO MBCA-PROGRAM-LOCATION.
012900     PERFORM MB60PD-GETMAIN-FOR-MAP
013000                                 THRU MB60PD-GFM-EXIT.
013100*
013200*******************************************
013300*    INITIALIZE THE STANDARD MAP LINES    *
013400*******************************************
013500*
013600     PERFORM MB60PD-INIT-STD-MAP-LINES
013700                                 THRU MB60PD-ISML-EXIT.
013800*
013900****************************************
014000*    READ THE INVENTORY CONTROL        *
014100*    RECORD FOR SUBSEQUENT DISPLAY     *
014200****************************************
014300*
014400     MOVE MBCA-MERCHANT-ORG      TO MBIOWS-MMIC-ORG
014500                                    MV02-ORG.
014600     MOVE MBCA-S-M               TO MBIOWS-MMIC-TYPE.
014700*
014800     IF  MBCA-S-M IS EQUAL TO 'M'
014900         MOVE MBCA-MERCHANT      TO MBIOWS-MMIC-MERCHANT
015000                                    MV02-MERCHANT
015100     ELSE
015200         MOVE MBCA-STORE         TO MBIOWS-MMIC-MERCHANT
015300                                    MV02-MERCHANT.
015400*
015500     MOVE 'FC01'                 TO MBCA-PROGRAM-LOCATION.
015600     SET MBIORO-READ-RANDOM      TO TRUE.
015700     PERFORM MMICAO-ACCESS       THRU MMICAO-ACCESS-EXIT.
015800*
015900     MOVE MMIC-NA-LINE (1 1)     TO MV02-NAME.
016000*
016100     IF  MMIC-TYPE-IS-MERCHANT
016200         MOVE 'MERCHANT'         TO MV02-MERCHANT-LIT
016300     ELSE
016400         MOVE '   STORE'         TO MV02-MERCHANT-LIT.
016500*
016600 B020-MOVE-FIELDS-TO-SCREEN.
016700*
016800*
016900     PERFORM Y010-MOVE-ASSOCIATION-IDS
017000                                 THRU Y019-MAI-EXIT.
017100*
017200******************************************
017300*    SET THE CURSOR AND SCREEN NUMBER    *
017400******************************************
017500*
017600     IF  MBCA-PTI-FUNCTION-ADD-OR-MAINT
017700         MOVE SS08WS-CURSOR      TO MV02-OTHER-ASSOC-ID-L (1)
017800     ELSE
017900         MOVE SS08WS-CURSOR      TO MV02-ALT-TRANID-L.
018000*
018100     COMPUTE MBCA-SCREEN-NBR     =  MBCA-SCREEN-NBR - 50.
018200*
018300**********************
018400*    SEND THE MAP    *
018500**********************
018600*
018700*
018800     MOVE 'BM01'                 TO MBCA-PROGRAM-LOCATION.
018900*
019000     PERFORM MB60PD-SEND-MAP-WITH-ERASE
019100                                 THRU MB60PD-SMWE-EXIT.
019200*
019300************************
019400*    RETURN TO CICS    *
019500************************
019600*
019700     MOVE 'PC02'                 TO MBCA-PROGRAM-LOCATION.
019800     PERFORM MB70PD-RETURN-TRANS-ID
019900                                 THRU MB70PD-RTI-EXIT.
020000/
020100 C000-RECEIVE-SCREEN SECTION.
020200*
020300******************************************
020400*    THIS SECTION RECEIVES THE SCREEN    *
020500******************************************
020600*
020700     MOVE 'BM02'                 TO MBCA-PROGRAM-LOCATION.
020800     PERFORM MB60PD-RECEIVE-MAP  THRU MB60PD-RM-EXIT.
020900*
021000**************************************************************
021100*    CHECK FOR ANOTHER TRANSACTION ID ENTERED BY THE USER    *
021200**************************************************************
021300*
021400     MOVE 'PC03'                 TO MBCA-PROGRAM-LOCATION.
021500     PERFORM MB60PD-NEW-TRANS-ROUTINE
021600                                 THRU MB60PD-NTR-EXIT.
021700*
021800***********************************************
021900*    READ THE INVENTORY CONTROL RECORD        *
022000***********************************************
022100*
022200     MOVE MBCA-MERCHANT-ORG      TO MBIOWS-MMIC-ORG
022300                                    MV02-ORG.
022400     MOVE MBCA-S-M               TO MBIOWS-MMIC-TYPE.
022500*
022600     IF  MBCA-S-M IS EQUAL TO 'M'
022700         MOVE MBCA-MERCHANT      TO MBIOWS-MMIC-MERCHANT
022800                                    MV02-MERCHANT
022900     ELSE
023000         MOVE MBCA-STORE         TO MBIOWS-MMIC-MERCHANT
023100                                    MV02-MERCHANT.
023200*
023300     MOVE 'FC02'                 TO MBCA-PROGRAM-LOCATION.
023400     SET MBIORO-READ-RANDOM      TO TRUE.
023500     PERFORM MMICAO-ACCESS       THRU MMICAO-ACCESS-EXIT.
023600*
023700     IF  MMIC-TYPE-IS-MERCHANT
023800         MOVE 'MERCHANT'         TO MV02-MERCHANT-LIT
023900     ELSE
024000         MOVE '   STORE'         TO MV02-MERCHANT-LIT.
024100*
024200     MOVE MMIC-INVENTORY-USED-FLAG
024300                                 TO WS-INVENTORY-USED-FLAG.
024400*
024500*********************************************
024600*    BYPASS THE EDITS IF THIS IS INQUIRY    *
024700*********************************************
024800*
024900     IF  MBCA-PTI-FUNCTION-IS-INQUIRY
025000         GO TO F000-SETUP-COMMAREA.
025100*
025200 C020-FIELD-EDITS.
025300*
025400*********************
025500*    FIELD EDITS    *
025600*********************
025700*
025800     PERFORM W010-EDIT-ASSOCIATION-IDS
025900                                 THRU W019-EAI-EXIT.
026000/
026100 D000-RETURN-ERRORS SECTION.
026200*
026300     IF  SS08WS-ERROR IS EQUAL TO 'N'
026400         GO TO E000-UPDATE-FILE.
026500*
026600***************************************************************
026700*    INITIALIZE THE STANDARD MAP LINES.  IN AN ERROR          *
026800*    CONDITION, THIS ROUTINE IS PERFORMED PRIMARILY           *
026900*    TO UPDATE THE DATE AND TIME ON THE SCREEN.               *
027000***************************************************************
027100*
027200     PERFORM MB60PD-INIT-STD-MAP-LINES
027300                                 THRU MB60PD-ISML-EXIT.
027400*
027500**********************
027600*    SEND THE MAP    *
027700**********************
027800*
027900     MOVE 'BM03'                 TO MBCA-PROGRAM-LOCATION.
028000     PERFORM MB60PD-SEND-MAP-DATA-ONLY
028100                                 THRU MB60PD-SMDO-EXIT.
028200*
028300************************
028400*    RETURN TO CICS    *
028500************************
028600*
028700     MOVE 'PC04'                 TO MBCA-PROGRAM-LOCATION.
028800     PERFORM MB70PD-RETURN-TRANS-ID
028900                                 THRU MB70PD-RTI-EXIT.
029000/
029100 E000-UPDATE-FILE SECTION.
029200*
029300********************************************************
029400*    READ THE INVENTORY CONTROL RECORD FOR UPDATE      *
029500********************************************************
029600*
029700     MOVE 'FC03'                 TO MBCA-PROGRAM-LOCATION.
029800     SET MBIORO-READ-RANDOM-UPDATE
029900                                 TO TRUE.
030000     PERFORM MMICAO-ACCESS       THRU MMICAO-ACCESS-EXIT.
030100*
030200*****************************************************
030300*    OBTAIN STORAGE FOR LOG FILE RECORD             *
030400*****************************************************
030500*
030600     MOVE 'SC02'                 TO MBCA-PROGRAM-LOCATION.
030700     SET MBIORO-GETMAIN          TO TRUE.
030800     PERFORM MML1AO-ACCESS       THRU MML1AO-ACCESS-EXIT.
030900*
031000*************************************************
031100*    SET UP THE COMMON PORTION OF THE RECORD    *
031200*************************************************
031300*
031400     MOVE 'IC'                   TO MML1-FILE-CODE.
031500     MOVE MBCA-MERCHANT-ORG      TO MML1-MMIC-ORG.
031600*
031700     IF  MBCA-S-M IS EQUAL TO 'S'
031800         MOVE MBCA-STORE         TO MML1-MMIC-MERCHANT
031900     ELSE
032000         MOVE MBCA-MERCHANT      TO MML1-MMIC-MERCHANT.
032100*
032200     MOVE MBCA-S-M               TO MML1-MMIC-TYPE.
032300     MOVE MBCA-SIGNON-NAME       TO MML1-SIGNON-NAME.
032400     MOVE MBCA-TERMINAL-ID       TO MML1-TERMINAL-ID.
032500     MOVE ZEROS                  TO MML1-SOURCE-CODE.
032600*
032700 E020-UPDATE-FIELDS.
032800*
032900*
033000     PERFORM X010-UPDATE-ASSOCIATION-IDS
033100                                 THRU X019-UAI-EXIT.
033200*
033300 E040-UPDATE-MMIC.
033400*
033500*******************************************************
033600*    IF THIS IS THE ADD FUNCTION AND THE INVENTORY    *
033700*    FEATURE OF THE SYSTEM IS NOT BEING USED, MAKE    *
033800*    THE INVENTORY CONTROL RECORD ACTIVE AND          *
033900*    WRITE THE LOG RECORD FOR THE ADD.                *
034000*******************************************************
034100*
034200     IF  MBCA-PTI-FUNCTION-IS-ADD
034300         MOVE 'Y'                TO WS-UPDATE-SW
034400         MOVE MBCA-START-DATE    TO MMIC-LAST-MAINT-DATE
034500         MOVE MBCA-OPERATOR-ID   TO MMIC-LAST-MAINT-OPER
034600         IF  INVENTORY-IS-NOT-USED
034700             MOVE 99             TO MMIC-ONLINE-STATUS
034800             MOVE 1              TO MMIC-REC-STATUS
034900             MOVE ZEROES         TO MML1-FIELD-CODE
035000                                    MML1-FIELD-OCCURRENCE
035100                                    MML1-FIELD-OCCURRENCE-2
035200             MOVE LENGTH OF MMIC-RECORD
035300                                 TO MML1-VARIABLE-LENGTH
035400             MOVE MMIC-RECORD    TO MML1-ADD-AREA
035500             MOVE 'FC04'         TO MBCA-PROGRAM-LOCATION
035600             PERFORM Y900-WRITE-LOG-RECORD
035700                                 THRU Y909-WLR-EXIT
035800         ELSE
035900             MOVE MBCA-SCREEN-NBR
036000                                 TO MMIC-ONLINE-STATUS.
036100*
036200**************************************************************
036300*    WRITE A LOG RECORD TO SHOW THAT THE LAST MAINT DATE     *
036400*    AND OPERATOR HAS BEEN UPDATED IF FIELDS WERE CHANGED    *
036500*    ON THE SCREEN                                           *
036600**************************************************************
036700*
036800     IF  MBCA-PTI-FUNCTION-IS-MAINT
036900     AND FIELDS-WERE-UPDATED
037000         MOVE 0198               TO MML1-FIELD-CODE
037100         MOVE ZEROES             TO MML1-FIELD-OCCURRENCE
037200                                    MML1-FIELD-OCCURRENCE-2
037300         MOVE MML1WS-VL-03       TO MML1-VARIABLE-LENGTH
037400         MOVE MMIC-LAST-MAINT-OPER
037500                                 TO MML1-VL03-B-DATA-X
037600         MOVE MBCA-OPERATOR-ID   TO MMIC-LAST-MAINT-OPER
037700         MOVE MMIC-LAST-MAINT-OPER
037800                                 TO MML1-VL03-A-DATA-X
037900         MOVE 'FC05'             TO MBCA-PROGRAM-LOCATION
038000         PERFORM Y900-WRITE-LOG-RECORD
038100                                 THRU Y909-WLR-EXIT
038200         MOVE 0199               TO MML1-FIELD-CODE
038300         MOVE MML1WS-VL-07       TO MML1-VARIABLE-LENGTH
038400         MOVE MMIC-LAST-MAINT-DATE
038500                                 TO MML1-VL07-B-DATA-9
038600         MOVE MBCA-START-DATE    TO MMIC-LAST-MAINT-DATE
038700         MOVE MMIC-LAST-MAINT-DATE
038800                                 TO MML1-VL07-A-DATA-9
038900         MOVE 'FC06'             TO MBCA-PROGRAM-LOCATION
039000         PERFORM Y900-WRITE-LOG-RECORD
039100                                 THRU Y909-WLR-EXIT.
039200*
039300*****************************************************
039400*    REWRITE THE INVENTORY/ASSOCIAITON RECORD IF    *
039500*    FIELDS HAVE BEEN CHANGED ON THE SCREEN, OR     *
039600*    UNLOCK IT IF THEY HAVE NOT                     *
039700*****************************************************
039800*
039900     IF  FIELDS-WERE-UPDATED
040000         MOVE 'FC07'             TO MBCA-PROGRAM-LOCATION
040100         SET MBIORO-REWRITE      TO TRUE
040200         PERFORM MMICAO-ACCESS   THRU MMICAO-ACCESS-EXIT
040300     ELSE
040400         MOVE 'FC08'             TO MBCA-PROGRAM-LOCATION
040500         SET MBIORO-UNLOCK       TO TRUE
040600         PERFORM MMICAO-ACCESS   THRU MMICAO-ACCESS-EXIT.
040700/
040800 F000-SETUP-COMMAREA SECTION.
040900*
041000***************************************************************
041100*  SET UP COMMAREA FIELDS AND TRANSFER TO THE NEXT PROGRAM    *
041200***************************************************************
041300*
041400     MOVE MBCA-EIBAID            TO SS08WS-EIBAID.
041500*
041600************************************************************
041700*    IF THE INVENTORY FEATURE OF THE SYSTEM IS NOT         *
041800*    BEING USED, SET THE MBCA-MAX-SCREEN-NBR TO THIS       *
041900*    SCREEN-NBR.                                           *
042000************************************************************
042100*
042200     IF  INVENTORY-IS-NOT-USED
042300         MOVE MBCA-SCREEN-NBR    TO MBCA-MAX-SCREEN-NBR.
042400*
042500     PERFORM MB60PD-EDIT-PAGE-NBR
042600                                 THRU MB60PD-EPN-EXIT.
042700*
042800     IF  SS08WS-VALID-PF-KEY
042900     OR  SS08WS-EIBAID-VALID-PF-KEY
043000         MOVE 99                 TO MBCA-SCREEN-NBR.
043100*
043200     MOVE 'PC05'                 TO MBCA-PROGRAM-LOCATION.
043300     PERFORM MB70PD-XCTL-TO-MBOXCTL
043400                                 THRU MB70PD-XTM-EXIT.
043500*
043600 W010-EDIT-ASSOCIATION-IDS.
043700*
043800     SET X-MV02-OTHER-ASSOC      TO 1.
043900     SET X-MMIC-OTHER-ASSOC      TO 1.
044000*
044100 W012-EAI-LOOP.
044200*
044300     MOVE DFHBMDAS               TO MV02-OTHER-ASSOC-ID-LP-A
044400                                        (X-MV02-OTHER-ASSOC)
044500                                    MV02-OTHER-ASSOC-ID-RP-A
044600                                        (X-MV02-OTHER-ASSOC).
044700*
044800     IF  MV02-OTHER-ASSOC-ID-L (X-MV02-OTHER-ASSOC)
044900         IS GREATER THAN ZERO
045000         MOVE DFHBMASF           TO MV02-OTHER-ASSOC-ID-A
045100                                        (X-MV02-OTHER-ASSOC)
045200     ELSE
045300         MOVE DFHBMASK           TO MV02-OTHER-ASSOC-ID-A
045400                                        (X-MV02-OTHER-ASSOC)
045500         MOVE MMIC-OTHER-ASSOC-ID (X-MMIC-OTHER-ASSOC)
045600                                 TO MV02-OTHER-ASSOC-ID
045700                                        (X-MV02-OTHER-ASSOC).
045800*
045900     IF  MV02-OTHER-ASSOC-ID (X-MV02-OTHER-ASSOC) IS NUMERIC
046000         GO TO W018-INCREMENT-INDEXES.
046100*
046200 W014-ASSOCIATION-ID-ERROR.
046300*
046400     MOVE 'Y'                    TO SS08WS-ERROR.
046500     MOVE SS08WS-CURSOR          TO MV02-OTHER-ASSOC-ID-L
046600                                        (X-MV02-OTHER-ASSOC).
046700     MOVE DFHBMNBF               TO MV02-OTHER-ASSOC-ID-A
046800                                        (X-MV02-OTHER-ASSOC).
046900     MOVE DFHBMASB               TO MV02-OTHER-ASSOC-ID-LP-A
047000                                        (X-MV02-OTHER-ASSOC)
047100                                    MV02-OTHER-ASSOC-ID-RP-A
047200                                        (X-MV02-OTHER-ASSOC).
047300*
047400 W018-INCREMENT-INDEXES.
047500*
047600     IF  X-MV02-OTHER-ASSOC IS LESS THAN 35
047700         SET X-MV02-OTHER-ASSOC  UP BY 1
047800         SET X-MMIC-OTHER-ASSOC  UP BY 1
047900         GO TO W012-EAI-LOOP.
048000*
048100 W019-EAI-EXIT.
048200     EXIT.
048300*
048400 X010-UPDATE-ASSOCIATION-IDS.
048500*
048600     SET X-MV02-OTHER-ASSOC      TO 1.
048700     SET X-MMIC-OTHER-ASSOC      TO 1.
048800*
048900 X012-UAI-LOOP.
049000*
049100     IF  MV02-OTHER-ASSOC-ID-L (X-MV02-OTHER-ASSOC)
049200         IS GREATER THAN ZERO
049300         IF  MV02-OTHER-ASSOC-ID (X-MV02-OTHER-ASSOC) NOT EQUAL
049400             MMIC-OTHER-ASSOC-ID (X-MMIC-OTHER-ASSOC)
049500             MOVE 'Y'            TO WS-UPDATE-SW
049600             IF  MBCA-PTI-FUNCTION-IS-MAINT
049700                 MOVE 0201       TO MML1-FIELD-CODE
049800                 SET MML1-FIELD-OCCURRENCE
049900                                 TO X-MMIC-OTHER-ASSOC
050000                 MOVE ZEROES     TO MML1-FIELD-OCCURRENCE-2
050100                 MOVE MML1WS-VL-10
050200                                 TO MML1-VARIABLE-LENGTH
050300                 MOVE MMIC-OTHER-ASSOC-ID (X-MMIC-OTHER-ASSOC)
050400                                 TO MML1-VL10-B-DATA-9
050500                 MOVE MV02-OTHER-ASSOC-ID (X-MV02-OTHER-ASSOC)
050600                                 TO MMIC-OTHER-ASSOC-ID
050700                                         (X-MMIC-OTHER-ASSOC)
050800                 MOVE MMIC-OTHER-ASSOC-ID (X-MMIC-OTHER-ASSOC)
050900                                 TO MML1-VL10-A-DATA-9
051000                 MOVE 'FC09'     TO MBCA-PROGRAM-LOCATION
051100                 PERFORM Y900-WRITE-LOG-RECORD
051200                                 THRU Y909-WLR-EXIT
051300             ELSE
051400                 MOVE MV02-OTHER-ASSOC-ID (X-MV02-OTHER-ASSOC)
051500                                 TO MMIC-OTHER-ASSOC-ID
051600                                         (X-MMIC-OTHER-ASSOC).
051700*
051800 X018-INCREMENT-INDEXES.
051900*
052000     IF  X-MV02-OTHER-ASSOC IS LESS THAN 35
052100         SET X-MV02-OTHER-ASSOC  UP BY 1
052200         SET X-MMIC-OTHER-ASSOC  UP BY 1
052300         GO TO X012-UAI-LOOP.
052400*
052500 X019-UAI-EXIT.
052600     EXIT.
052700*
052800 Y010-MOVE-ASSOCIATION-IDS.
052900*
053000     SET X-MV02-OTHER-ASSOC      TO 1.
053100     SET X-MMIC-OTHER-ASSOC      TO 1.
053200*
053300 Y012-MAI-LOOP.
053400*
053500     MOVE MMIC-OTHER-ASSOC-ID (X-MMIC-OTHER-ASSOC)
053600                                 TO MV02-OTHER-ASSOC-ID
053700                                        (X-MV02-OTHER-ASSOC).
053800*
053900     IF  MBCA-PTI-FUNCTION-IS-INQUIRY
054000         MOVE DFHBMDAS           TO MV02-OTHER-ASSOC-ID-LP-A
054100                                        (X-MV02-OTHER-ASSOC)
054200                                    MV02-OTHER-ASSOC-ID-RP-A
054300                                        (X-MV02-OTHER-ASSOC)
054400         MOVE DFHBMASB           TO MV02-OTHER-ASSOC-ID-A
054500                                        (X-MV02-OTHER-ASSOC).
054600*
054700     IF  X-MV02-OTHER-ASSOC IS LESS THAN 35
054800         SET X-MV02-OTHER-ASSOC  UP BY 1
054900         SET X-MMIC-OTHER-ASSOC  UP BY 1
055000         GO TO Y012-MAI-LOOP.
055100*
055200 Y019-MAI-EXIT.
055300     EXIT.
055400*
055500 Y900-WRITE-LOG-RECORD.
055600*
055700     SET MBIORO-WRITE            TO TRUE.
055800     PERFORM MML1AO-ACCESS       THRU MML1AO-ACCESS-EXIT.
055900     MOVE SPACES                 TO MML1-VARIABLE-AREA.
056000*
056100 Y909-WLR-EXIT.
056200     EXIT.
056300/
056400 Z000-COPIED-ROUTINES SECTION.
056500*
056600/    NEW ROUTINE FOR JULIAN TO GREGORIAN CONVERSION
056700     COPY SS26PD.
056800*
056900/    ROUTINE TO NUMERICALLY EDIT TIME
057000     COPY SS27PD.
057100*
057200**********************************
057300*    JUL TO GREG DATE ROUTINE    *
057400**********************************
057500*
057600     COPY SS08PD.
057700/
057800*********************************
057900*    LINE 24 PF KEYS ROUTINE    *
058000*********************************
058100*
058200     COPY SS15PD.
058300/
058400******************************************************
058500*    INVENTORY CONTROL RECORD ACCESS ROUTINES        *
058600******************************************************
058700*
058800     COPY MMICAO.
058900/
059000*****************************************
059100*    LOG FILE RECORD ACCESS ROUTINES    *
059200*****************************************
059300*
059400     COPY MML1AO.
059500/
059600*****************************
059700*    ONLINE MAP ROUTINES    *
059800*****************************
059900*
060000     COPY MB60PD REPLACING 'MBMAPXX' BY 'MBMV02 '
060100                           MBMAPXXI BY MBMV02I
060200                           MBMAPXXO BY MBMV02O.
060300/
060400***************************
060500*    ONLINE PROCEDURES    *
060600***************************
060700*
060800     COPY MB70PD.
060900/
061000     COPY SMFTPXO.
