000100 IDENTIFICATION DIVISION.
000200 PROGRAM-ID. MBOMX03.
000201*       RELEASE DATE=08/24/01.        REVISION LEVEL=08.06      *
000202*****************************************************************
000203*WARNING.  THIS COMPUTER PROGRAM IS PROTECTED BY COPYRIGHT LAW  *
000204*AND INTERNATIONAL TREATIES.  UNAUTHORIZED REPRODUCTION OR      *
000205*DISTRIBUTION OF THIS PROGRAM, OR ANY PORTION OF IT, MAY RESULT *
000206*IN SEVERE CIVIL AND CRIMINAL PENATLIES, AND WILL BE PROSECUTED *
000207*TO THE MAXIMUM EXTENT POSSIBLE UNDER THE LAW.                  *
000208*COPYRIGHT 1999 PAYSYS INTERNATIONAL, INC.  ALL RIGHTS RESERVED.*
000209*****************************************************************
000300*****************************************************************
000400*                                                               *
000500*               M E R C H A N T   S Y S T E M                   *
000600*                                                               *
000700*      MBOMX03 - ON-LINE MONETARY TRANSACTION CONTROL           *
000800*                ADD/MAINTENANCE/INQUIRY SCREEN 03              *
000900*                                                               *
001000*              1. TRANSIDS                                      *
001100*                 A. MBAX                                       *
001200*                 B. MBMX                                       *
001300*                 C. MBQX                                       *
001400*              2. MAPS USED -                                   *
001500*                 A. MBMX03 (SCREEN 03)                         *
001600*              3. FILES USED -                                  *
001700*                 A. MMTC   (MONETARY TRANSACTION CONTROL FILE) *
001800*                 B. MML1   (LOG/JOURNAL FILE)                  *
001900*                                                               *
002000*****************************************************************
002100*   SCREEN 03 OF TRANSACTION CONTROL (MMTC) RECORD              *
002200*   ADD/MAINT/INQUIRY FUNCTION.                                 *
002300*   THE MMTC RECORDS CONTAINING TRANS CODE 000 ARE SPECIAL      *
002400*   RECORDS AND ARE BYPASSED IN THIS PROGRAM.                   *
002500*****************************************************************
002600*
002700 ENVIRONMENT DIVISION.
002800 DATA DIVISION.
002900 WORKING-STORAGE SECTION.
003000*
003100 01  FILLER                  PIC  X(12)      VALUE '** WS-BEG **'.
003200*
003300 01  WS-WORKING-FIELDS.
003400     03  SS08WS-ERROR-SW     PIC  X(01)      VALUE 'N'.
003500     03  WS-UPD-SW           PIC  X(01)      VALUE 'N'.
003600     03  WS-BASE-PGM-NBR     PIC S9(04)      BINARY
003700                                             VALUE +1.
003800     03  WS-READ-COUNT       PIC S9(04)      BINARY
003900                                             VALUE ZERO.
004000     03  WS-END-OF-ORG-SW    PIC  X(01)      VALUE 'N'.
004100     03  WS-EOO-MSG-SW       PIC  X(01)      VALUE 'N'.
004200     03  WS-WORK-LM-SW       PIC  X(01)      VALUE 'N'.
004300         88  WS-LM-IS-VALID                  VALUE 'Y'.
004400         88  WS-LM-IS-INVALID                VALUE 'N'.
004500/
004600     COPY MBIOWS.
004700/
004800     COPY MBIORO.
004900/
005000     COPY SS01WS.
005100/
005200     COPY SS08WS.
005300/
005400     COPY SS00WS.
005500/
005600     COPY SMFTWS.
005700/
005800     COPY SMPTRL REPLACING ==:SMPT:== BY ==SMPT==.
005900/
006000     COPY MB61LK.
006100/
006200     COPY MMTCWS.
006300/
006400     COPY MMTCIR.
006500/
006600     COPY MML1WS REPLACING ==:MML1:== BY ==MML1==.
006700*
006800 01  FILLER                  PIC  X(12)      VALUE '** WS-END **'.
006900/
007000 LINKAGE SECTION.
007100 01  DFHCOMMAREA.
007200     COPY MB60WS.
007300/
007400     COPY MBMX03.
007500     COPY MBMX03R.
007600/
007700     COPY MMTCRL.
007800/
007900     COPY MML1RL REPLACING ==:MML1:== BY ==MML1==.
008000/
008100 PROCEDURE DIVISION.
008200 0000-START-OF-PROGRAM-SECT SECTION.
008300 0010-SOP-BEGIN.
008400*
008500     MOVE 'PC01'                 TO MBCA-PROGRAM-LOCATION.
008600     PERFORM MB70PD-ON-LINE-HOUSEKEEPING
008700                                 THRU MB70PD-OLH-EXIT.
008800*
008900     IF  MBCA-SCREEN-NBR IS LESS THAN 50
009000         GO TO 2000-RECEIVE-SCREEN-SECT.
009100*
009200     GO TO 1000-SEND-SCREEN-SECT.
009300*
009400 0999-SOP-EXIT.
009500     EXIT.
009600/
009700 1000-SEND-SCREEN-SECT SECTION.
009800 1010-SS-BEGIN.
009900*
010000     SUBTRACT 50                 FROM MBCA-SCREEN-NBR.
010100*
010200*****************************************************************
010300*    GET CICS STORAGE NEEDED FOR THE MAP.                       *
010400*****************************************************************
010500*
010600     MOVE 'SC01'                 TO MBCA-PROGRAM-LOCATION.
010700     PERFORM MB60PD-GETMAIN-FOR-MAP
010800                                 THRU MB60PD-GFM-EXIT.
010900*
011000     MOVE DFHBMASB               TO MX03-PLUS-TOP-A.
011100     MOVE DFHBMASB               TO MX03-PLUS-BOT-A.
011200*
011300*****************************************************************
011400*    READ THE TRANS CTL RECORD                                  *
011500*****************************************************************
011600*
011700     IF  MBCA-MBMX-BEG-TXN-2     IS NUMERIC
011800     AND MBCA-MBMX-END-TXN-2     IS NUMERIC
011900     AND MBCA-TRANS-LOOP-CONTROL IS EQUAL TO '03'
012000         NEXT SENTENCE
012100     ELSE
012200         MOVE DFHBMDAS           TO MX03-PLUS-TOP-A
012300         MOVE ZERO               TO MBCA-MBMX-BEG-TXN-2
012400         MOVE ZERO               TO MBCA-MBMX-END-TXN-2.
012500*
012600     MOVE '03'                   TO MBCA-TRANS-LOOP-CONTROL.
012700     COMPUTE SS08WS-WORK-INDEX   = ((MBCA-SCREEN-NBR
012800                                 -   WS-BASE-PGM-NBR) * 1) + 1.
012900*
013000     MOVE MBCA-ORG               TO MX03-ORG.
013100     MOVE DFHBMASB               TO MX03-ORG-A.
013200     MOVE MBCA-MBMX-ORG-NAME     TO MX03-ORG-NAME.
013300     MOVE DFHBMASB               TO MX03-ORG-NAME-A.
013400*
013500     IF  MBCA-PTI-FUNCTION-IS-ADD
013600         GO TO 1900-SS-ADD-BYPASS.
013700*
013800*****************************************************************
013900*    START THE MMTC FILE PRIOR TO READING THE FILE SEQUENTIALLY.*
014000*****************************************************************
014100*
014200     IF  MBCA-MBMX-BEG-TXN-2 IS EQUAL TO ZERO
014300         MOVE DFHBMDAS           TO MX03-PLUS-TOP-A.
014400*
014500     MOVE MBCA-ORG               TO MBIOWS-MMTC-ORG.
014600*
014700     IF  MBCA-MBMX-END-TXN-2 IS LESS THAN 999
014800         COMPUTE MBCA-MBMX-END-TXN-2
014900                                 =  MBCA-MBMX-END-TXN-2 + 1.
015000*
015100     MOVE MBCA-MBMX-END-TXN-2    TO MBIOWS-MMTC-TXN-CODE.
015200     MOVE MBCA-MBMX-END-TXN-2    TO MBCA-MBMX-BEG-TXN-2.
015300*
015400     MOVE 'FC01'                 TO MBCA-PROGRAM-LOCATION.
015500     SET MBIORO-STARTBR-GTE      TO TRUE.
015600     PERFORM MMTCAO-ACCESS       THRU MMTCAO-ACCESS-EXIT.
015700*
015800*    CLEAR THE COMMAREA TABLE.
015900*
016000     INITIALIZE MBCA-MBMX-TXN-CODE-TABLE-X.
016100*
016200     SET X-MX03-TC               TO 1.
016300*
016400 1100-SS-TRANS-LOOP.
016500*
016600     IF  X-MX03-TC IS GREATER THAN 3
016700         GO TO 1900-SS-ADD-BYPASS.
016800*
016900     SET X-MBCA-MBMX             TO X-MX03-TC.
017000*
017100     IF  WS-END-OF-ORG-SW IS EQUAL TO 'Y'
017200         GO TO 1150-SS-TL-NO-RECS-LEFT.
017300*
017400 1120-SS-TL-READ-LOOP.
017500*
017600     MOVE 'FC02'                 TO MBCA-PROGRAM-LOCATION.
017700     SET MBIORO-READ-SEQ         TO TRUE.
017800     PERFORM MMTCAO-ACCESS       THRU MMTCAO-ACCESS-EXIT.
017900*
018000     IF  MMTC-ORG IS NOT EQUAL TO MBCA-ORG
018100         MOVE 'Y'                TO WS-END-OF-ORG-SW
018200         MOVE 'Y'                TO WS-EOO-MSG-SW
018300         GO TO 1150-SS-TL-NO-RECS-LEFT.
018400*
018500     IF  MMTC-REC-ACTIVE
018600         NEXT SENTENCE
018700     ELSE
018800         GO TO 1120-SS-TL-READ-LOOP.
018900*
019000*****************************************************************
019100*    MOVE DATA FROM MMTC RECORD INTO THE MAP FIELDS AND         *
019200*    LOAD THE INFO IN THE COMMAREA TABLE.                       *
019300*****************************************************************
019400*
019500     MOVE MMTC-LOGIC-MODULE      TO MMTCWS-LOGIC-MODULE.
019600     MOVE MMTC-TXN-CODE          TO MX03-TC
019700                                    (X-MX03-TC).
019800     MOVE MMTC-LOGIC-MODULE      TO MX03-LM
019900                                    (X-MX03-TC).
020000     MOVE MMTC-RPT-DESC          TO MX03-RPT-DESC
020100                                    (X-MX03-TC).
020200     MOVE MMTC-GL-DR-ACCT        TO MX03-GL-DR-ACCT
020300                                    (X-MX03-TC).
020400     MOVE MMTC-GL-DR-DESC        TO MX03-GL-DR-DESC
020500                                    (X-MX03-TC).
020600     MOVE MMTC-GL-CR-ACCT        TO MX03-GL-CR-ACCT
020700                                    (X-MX03-TC).
020800     MOVE MMTC-GL-CR-DESC        TO MX03-GL-CR-DESC
020900                                    (X-MX03-TC).
021000     MOVE MMTC-DEFAULT-DESC      TO MX03-DEFAULT-DESC
021100                                    (X-MX03-TC).
021200*
021300     MOVE MMTC-TXN-CODE          TO MBCA-MBMX-TXN-CODE
021400                                    (X-MBCA-MBMX).
021500     MOVE MMTC-TXN-CODE          TO MBCA-MBMX-END-TXN-2.
021600     MOVE MMTC-LOGIC-MODULE      TO MBCA-MBMX-LOGIC-MODULE
021700                                    (X-MBCA-MBMX).
021800*
021900     GO TO 1160-SS-MAINT-INQ.
022000*
022100 1150-SS-TL-NO-RECS-LEFT.
022200*
022300     MOVE DFHBMDAS               TO MX03-RPT-DESC-LIT-A
022400                                    (X-MX03-TC).
022500     MOVE DFHBMDAS               TO MX03-GL-DR-ACCT-LIT-A
022600                                    (X-MX03-TC).
022700     MOVE DFHBMDAS               TO MX03-GL-DR-DESC-LIT-A
022800                                    (X-MX03-TC).
022900     MOVE DFHBMDAS               TO MX03-GL-CR-ACCT-LIT-A
023000                                    (X-MX03-TC).
023100     MOVE DFHBMDAS               TO MX03-GL-CR-DESC-LIT-A
023200                                    (X-MX03-TC).
023300     MOVE DFHBMDAS               TO MX03-DEFAULT-DESC-LIT-A
023400                                    (X-MX03-TC).
023500     MOVE DFHBMDAS               TO MX03-PLUS-BOT-A.
023600*
023700     MOVE DFHBMDAS               TO MX03-TC-LP-A
023800                                    (X-MX03-TC).
023900     MOVE DFHBMDAS               TO MX03-TC-A
024000                                    (X-MX03-TC).
024100     MOVE DFHBMDAS               TO MX03-TC-RP-A
024200                                    (X-MX03-TC).
024300     MOVE DFHBMDAS               TO MX03-LM-LP-A
024400                                    (X-MX03-TC).
024500     MOVE DFHBMDAS               TO MX03-LM-A
024600                                    (X-MX03-TC).
024700     MOVE DFHBMDAS               TO MX03-LM-RP-A
024800                                    (X-MX03-TC).
024900     MOVE DFHBMDAS               TO MX03-RPT-DESC-LP-A
025000                                    (X-MX03-TC).
025100     MOVE DFHBMDAS               TO MX03-RPT-DESC-A
025200                                    (X-MX03-TC).
025300     MOVE DFHBMDAS               TO MX03-RPT-DESC-RP-A
025400                                    (X-MX03-TC).
025500     MOVE DFHBMDAS               TO MX03-GL-DR-ACCT-LP-A
025600                                    (X-MX03-TC).
025700     MOVE DFHBMDAS               TO MX03-GL-DR-ACCT-A
025800                                    (X-MX03-TC).
025900     MOVE DFHBMDAS               TO MX03-GL-DR-ACCT-RP-A
026000                                    (X-MX03-TC).
026100     MOVE DFHBMDAS               TO MX03-GL-DR-DESC-LP-A
026200                                    (X-MX03-TC).
026300     MOVE DFHBMDAS               TO MX03-GL-DR-DESC-A
026400                                    (X-MX03-TC).
026500     MOVE DFHBMDAS               TO MX03-GL-DR-DESC-RP-A
026600                                    (X-MX03-TC).
026700     MOVE DFHBMDAS               TO MX03-GL-CR-ACCT-LP-A
026800                                    (X-MX03-TC).
026900     MOVE DFHBMDAS               TO MX03-GL-CR-ACCT-A
027000                                    (X-MX03-TC).
027100     MOVE DFHBMDAS               TO MX03-GL-CR-ACCT-RP-A
027200                                    (X-MX03-TC).
027300     MOVE DFHBMDAS               TO MX03-GL-CR-DESC-LP-A
027400                                    (X-MX03-TC).
027500     MOVE DFHBMDAS               TO MX03-GL-CR-DESC-A
027600                                    (X-MX03-TC).
027700     MOVE DFHBMDAS               TO MX03-GL-CR-DESC-RP-A
027800                                    (X-MX03-TC).
027900     MOVE DFHBMDAS               TO MX03-DEFAULT-DESC-LP-A
028000                                    (X-MX03-TC).
028100     MOVE DFHBMDAS               TO MX03-DEFAULT-DESC-A
028200                                    (X-MX03-TC).
028300     MOVE DFHBMDAS               TO MX03-DEFAULT-DESC-RP-A
028400                                    (X-MX03-TC).
028500*
028600     IF  WS-EOO-MSG-SW IS EQUAL TO 'Y'
028700         MOVE 'N'                TO WS-EOO-MSG-SW
028800         MOVE '********** END OF TRANSACTIONS *********'
028900                                 TO MX03-DEFAULT-DESC
029000                                    (X-MX03-TC)
029100         MOVE DFHBMASB           TO MX03-DEFAULT-DESC-A
029200                                    (X-MX03-TC).
029300*
029400     GO TO 1180-SS-TL-INCR-INDEX.
029500*
029600 1160-SS-MAINT-INQ.
029700*
029800     IF  MBCA-PTI-FUNCTION-IS-MAINT
029900         MOVE DFHBMDAS           TO MX03-TC-LP-A
030000                                    (X-MX03-TC)
030100         MOVE DFHBMDAS           TO MX03-TC-RP-A
030200                                    (X-MX03-TC)
030300         MOVE DFHBMASK           TO MX03-LM-LP-A
030400                                    (X-MX03-TC)
030500         MOVE DFHBMASK           TO MX03-LM-RP-A
030600                                    (X-MX03-TC)
030700         MOVE DFHBMASK           TO MX03-RPT-DESC-LP-A
030800                                    (X-MX03-TC)
030900         MOVE DFHBMASK           TO MX03-RPT-DESC-RP-A
031000                                    (X-MX03-TC)
031100         MOVE DFHBMASK           TO MX03-GL-DR-ACCT-LP-A
031200                                    (X-MX03-TC)
031300         MOVE DFHBMASK           TO MX03-GL-DR-ACCT-RP-A
031400                                    (X-MX03-TC)
031500         MOVE DFHBMASK           TO MX03-GL-DR-DESC-LP-A
031600                                    (X-MX03-TC)
031700         MOVE DFHBMASK           TO MX03-GL-DR-DESC-RP-A
031800                                    (X-MX03-TC)
031900         MOVE DFHBMASK           TO MX03-GL-CR-ACCT-LP-A
032000                                    (X-MX03-TC)
032100         MOVE DFHBMASK           TO MX03-GL-CR-ACCT-RP-A
032200                                    (X-MX03-TC)
032300         MOVE DFHBMASK           TO MX03-GL-CR-DESC-LP-A
032400                                    (X-MX03-TC)
032500         MOVE DFHBMASK           TO MX03-GL-CR-DESC-RP-A
032600                                    (X-MX03-TC)
032700         MOVE DFHBMASK           TO MX03-DEFAULT-DESC-LP-A
032800                                    (X-MX03-TC)
032900         MOVE DFHBMASK           TO MX03-DEFAULT-DESC-RP-A
033000                                    (X-MX03-TC)
033100         MOVE DFHBMASK           TO MX03-TC-A
033200                                    (X-MX03-TC)
033300         MOVE DFHBMUNN           TO MX03-LM-A
033400                                    (X-MX03-TC)
033500         MOVE DFHBMUNP           TO MX03-RPT-DESC-A
033600                                    (X-MX03-TC)
033700         MOVE DFHBMUNP           TO MX03-GL-DR-ACCT-A
033800                                    (X-MX03-TC)
033900         MOVE DFHBMUNP           TO MX03-GL-DR-DESC-A
034000                                    (X-MX03-TC)
034100         MOVE DFHBMUNP           TO MX03-GL-CR-ACCT-A
034200                                    (X-MX03-TC)
034300         MOVE DFHBMUNP           TO MX03-GL-CR-DESC-A
034400                                    (X-MX03-TC)
034500         MOVE DFHBMUNP           TO MX03-DEFAULT-DESC-A
034600                                    (X-MX03-TC)
034700     ELSE
034800         MOVE DFHBMDAS           TO MX03-TC-LP-A
034900                                    (X-MX03-TC)
035000         MOVE DFHBMDAS           TO MX03-TC-RP-A
035100                                    (X-MX03-TC)
035200         MOVE DFHBMDAS           TO MX03-LM-LP-A
035300                                    (X-MX03-TC)
035400         MOVE DFHBMDAS           TO MX03-LM-RP-A
035500                                    (X-MX03-TC)
035600         MOVE DFHBMDAS           TO MX03-RPT-DESC-LP-A
035700                                    (X-MX03-TC)
035800         MOVE DFHBMDAS           TO MX03-RPT-DESC-RP-A
035900                                    (X-MX03-TC)
036000         MOVE DFHBMDAS           TO MX03-GL-DR-ACCT-LP-A
036100                                    (X-MX03-TC)
036200         MOVE DFHBMDAS           TO MX03-GL-DR-ACCT-RP-A
036300                                    (X-MX03-TC)
036400         MOVE DFHBMDAS           TO MX03-GL-DR-DESC-LP-A
036500                                    (X-MX03-TC)
036600         MOVE DFHBMDAS           TO MX03-GL-DR-DESC-RP-A
036700                                    (X-MX03-TC)
036800         MOVE DFHBMDAS           TO MX03-GL-CR-ACCT-LP-A
036900                                    (X-MX03-TC)
037000         MOVE DFHBMDAS           TO MX03-GL-CR-ACCT-RP-A
037100                                    (X-MX03-TC)
037200         MOVE DFHBMDAS           TO MX03-GL-CR-DESC-LP-A
037300                                    (X-MX03-TC)
037400         MOVE DFHBMDAS           TO MX03-GL-CR-DESC-RP-A
037500                                    (X-MX03-TC)
037600         MOVE DFHBMDAS           TO MX03-DEFAULT-DESC-LP-A
037700                                    (X-MX03-TC)
037800         MOVE DFHBMDAS           TO MX03-DEFAULT-DESC-RP-A
037900                                    (X-MX03-TC)
038000         MOVE DFHBMASB           TO MX03-TC-A
038100                                    (X-MX03-TC)
038200         MOVE DFHBMASB           TO MX03-LM-A
038300                                    (X-MX03-TC)
038400         MOVE DFHBMASB           TO MX03-RPT-DESC-A
038500                                    (X-MX03-TC)
038600         MOVE DFHBMASB           TO MX03-GL-DR-ACCT-A
038700                                    (X-MX03-TC)
038800         MOVE DFHBMASB           TO MX03-GL-DR-DESC-A
038900                                    (X-MX03-TC)
039000         MOVE DFHBMASB           TO MX03-GL-CR-ACCT-A
039100                                    (X-MX03-TC)
039200         MOVE DFHBMASB           TO MX03-GL-CR-DESC-A
039300                                    (X-MX03-TC)
039400         MOVE DFHBMASB           TO MX03-DEFAULT-DESC-A
039500                                    (X-MX03-TC).
039600*
039700     IF  MBCA-PTI-FUNCTION-IS-MAINT
039800     AND
039900        (MMTC-REC-GENERATED
040000      OR MMTC-REC-DEFAULT)
040100         MOVE DFHBMDAS           TO MX03-LM-LP-A
040200                                    (X-MX03-TC)
040300         MOVE DFHBMDAS           TO MX03-LM-LP-A
040400                                    (X-MX03-TC)
040500         MOVE DFHBMDAS           TO MX03-LM-RP-A
040600                                    (X-MX03-TC)
040700         MOVE DFHBMASK           TO MX03-LM-A
040800                                    (X-MX03-TC)
040900         MOVE DFHBMASK           TO MX03-TC-TYPE-A
041000                                    (X-MX03-TC)
041100         EVALUATE TRUE
041200             WHEN MMTC-REC-GENERATED
041300                 MOVE 'G'        TO MX03-TC-TYPE
041400                                    (X-MX03-TC)
041500             WHEN OTHER
041600                 MOVE 'D'        TO MX03-TC-TYPE
041700                                    (X-MX03-TC)
041800         END-EVALUATE.
041900*
042000     IF  MBCA-PTI-FUNCTION-IS-INQUIRY
042100     AND
042200        (MMTC-REC-GENERATED
042300      OR MMTC-REC-DEFAULT)
042400         MOVE DFHBMDAS           TO MX03-LM-LP-A
042500                                    (X-MX03-TC)
042600         MOVE DFHBMDAS           TO MX03-LM-RP-A
042700                                    (X-MX03-TC)
042800         MOVE DFHBMASB           TO MX03-LM-A
042900                                    (X-MX03-TC)
043000         MOVE DFHBMASB           TO MX03-TC-TYPE-A
043100                                    (X-MX03-TC)
043200         EVALUATE TRUE
043300             WHEN MMTC-REC-GENERATED
043400                 MOVE 'G'        TO MX03-TC-TYPE
043500                                    (X-MX03-TC)
043600             WHEN OTHER
043700                 MOVE 'D'        TO MX03-TC-TYPE
043800                                    (X-MX03-TC)
043900         END-EVALUATE.
044000*
044100 1180-SS-TL-INCR-INDEX.
044200*
044300     SET X-MX03-TC               UP BY 1.
044400     GO TO 1100-SS-TRANS-LOOP.
044500*
044600 1900-SS-ADD-BYPASS.
044700*
044800     IF  MBCA-PTI-FUNCTION-IS-ADD
044900         MOVE SS08WS-CURSOR      TO MX03-TC-L (1)
045000     ELSE
045100         IF  MBCA-PTI-FUNCTION-IS-MAINT
045200             MOVE SS08WS-CURSOR  TO MX03-RPT-DESC-L (1)
045300         ELSE
045400             MOVE SS08WS-CURSOR  TO MX03-BEG-TC-L.
045500*
045600     IF  MBCA-PTI-FUNCTION-IS-MAINT
045700     AND MX03-TC-TYPE (1) IS NOT EQUAL TO 'G'
045800     AND MX03-TC-TYPE (1) IS NOT EQUAL TO 'D'
045900         MOVE SS08WS-CURSOR      TO MX03-LM-L (1)
046000         IF  MX03-LM-A (1) IS EQUAL TO DFHBMASK
046100         OR  MX03-LM-A (1) IS EQUAL TO DFHBMASB
046200         OR  MX03-LM-A (1) IS EQUAL TO DFHBMDAS
046300             MOVE SS08WS-CURSOR  TO MX03-BEG-TC-L.
046400*
046500     PERFORM MB60PD-INIT-STD-MAP-LINES
046600                                 THRU MB60PD-ISML-EXIT.
046700*
046800     IF  MBCA-PTI-FUNCTION-IS-ADD
046900         GO TO 1990-SS-BYPASS-PF-KEYS.
047000*
047100*****************************************************************
047200*    THIS PROGRAM WILL DO SPECIAL FUNCTIONS WITH PF KEYS.       *
047300*    PF1 = NORMAL                                               *
047400*    PF2 = NORMAL                                               *
047500*    PF3 = TOP OF TRANSACTION CODES                             *
047600*    PF4 = BOTTOM OF TRANSACTION CODES                          *
047700*    PF5 = PAGE SCREEN FOREWARDS                                *
047800*    PF6 = PAGE SCREEN BACKWARDS                                *
047900*****************************************************************
048000*
048100     MOVE '*TOP*'                TO SS08WS-LINE-24-PF-KEY-FUNC(3).
048200     MOVE '*BOT*'                TO SS08WS-LINE-24-PF-KEY-FUNC(4).
048300     MOVE '*FWD*'                TO SS08WS-LINE-24-PF-KEY-FUNC(5).
048400     MOVE '*BWD*'                TO SS08WS-LINE-24-PF-KEY-FUNC(6).
048500     MOVE SS08WS-LINE-24         TO TTN2401I.
048600     MOVE 'RESV'                 TO MBCA-PGMX-PF-TRANS-ID (3).
048700     MOVE 'RESV'                 TO MBCA-PGMX-PF-TRANS-ID (4).
048800     MOVE 'RESV'                 TO MBCA-PGMX-PF-TRANS-ID (5).
048900     MOVE 'RESV'                 TO MBCA-PGMX-PF-TRANS-ID (6).
049000*
049100 1990-SS-BYPASS-PF-KEYS.
049200*
049300     IF  MBCA-PTI-FUNCTION-IS-ADD
049400         MOVE DFHBMDAS           TO MX03-BEG-TC-LIT-A
049500         MOVE DFHBMDAS           TO MX03-BEG-TC-LP-A
049600         MOVE DFHBMDAS           TO MX03-BEG-TC-RP-A
049700         MOVE DFHBMDAS           TO MX03-BEG-TC-A.
049800*
049900     MOVE MBCA-ORG               TO MX03-ORG.
050000     MOVE DFHBMASB               TO MX03-ORG-A.
050100     MOVE MBCA-MBMX-ORG-NAME     TO MX03-ORG-NAME.
050200     MOVE DFHBMASB               TO MX03-ORG-NAME-A.
050300*
050400     MOVE '+'                    TO MX03-PLUS-TOP.
050500     MOVE '+'                    TO MX03-PLUS-BOT.
050600*
050700     MOVE 'BM01'                 TO MBCA-PROGRAM-LOCATION.
050800     PERFORM MB60PD-SEND-MAP-WITH-ERASE
050900                                 THRU MB60PD-SMWE-EXIT.
051000*
051100     MOVE 'PC02'                 TO MBCA-PROGRAM-LOCATION.
051200     PERFORM MB70PD-RETURN-TRANS-ID
051300                                 THRU MB70PD-RTI-EXIT.
051400*
051500 1999-SS-EXIT.
051600     EXIT.
051700/
051800 2000-RECEIVE-SCREEN-SECT SECTION.
051900 2010-RS-BEGIN.
052000*
052100     MOVE 'BM02'                 TO MBCA-PROGRAM-LOCATION.
052200     PERFORM MB60PD-RECEIVE-MAP  THRU MB60PD-RM-EXIT.
052300*
052400*****************************************************************
052500*    CHECK FOR ANOTHER TRANSACTION ID ENTERED BY THE USER.      *
052600*****************************************************************
052700*
052800     MOVE DFHBMASB               TO MX03-PLUS-TOP-A.
052900     MOVE DFHBMASB               TO MX03-PLUS-BOT-A.
053000*
053100     MOVE 'PC03'                 TO MBCA-PROGRAM-LOCATION.
053200     PERFORM MB60PD-NEW-TRANS-ROUTINE
053300                                 THRU MB60PD-NTR-EXIT.
053400*
053500     MOVE 'SC02'                 TO MBCA-PROGRAM-LOCATION.
053600     SET MBIORO-GETMAIN          TO TRUE.
053700     PERFORM MMTCAO-ACCESS       THRU MMTCAO-ACCESS-EXIT.
053800*
053900     MOVE DFHBMABF               TO MX03-ORG-A.
054000     MOVE DFHBMABF               TO MX03-ORG-NAME-A.
054100*
054200     COMPUTE SS08WS-WORK-INDEX   = ((MBCA-SCREEN-NBR
054300                                 -   WS-BASE-PGM-NBR) * 1) + 1.
054400*
054500     MOVE 'Y'                    TO WS-EOO-MSG-SW.
054600*
054700     IF  MBCA-PTI-FUNCTION-ADD-OR-MAINT
054800         GO TO 2100-RS-BEGIN-EDITS.
054900*
055000     GO TO 2900-RS-SETUP-COMMAREA.
055100*
055200 2100-RS-BEGIN-EDITS.
055300*
055400     SET X-MX03-TC               TO 1.
055500*
055600 2200-RS-EDIT-TRANS-LOOP.
055700*
055800     IF  X-MX03-TC IS GREATER THAN 3
055900         GO TO 2300-RS-CROSS-EDIT-TXN.
056000*
056100     SET X-MBCA-MBMX             TO X-MX03-TC.
056200*
056300     IF  MBCA-PTI-FUNCTION-IS-ADD
056400         GO TO 2210-RS-ADD-BYPASS.
056500*
056600     MOVE MBCA-ORG               TO MBIOWS-MMTC-ORG.
056700     MOVE MBCA-MBMX-TXN-CODE (X-MBCA-MBMX)
056800                                 TO MBIOWS-MMTC-TXN-CODE.
056900*
057000     IF  MBCA-MBMX-TXN-CODE (X-MBCA-MBMX) IS EQUAL TO ZERO
057100         GO TO 2270-RS-NO-RECS-LEFT.
057200*
057300     MOVE 'FC03'                 TO MBCA-PROGRAM-LOCATION.
057400     SET MBIORO-READ-RANDOM      TO TRUE.
057500     PERFORM MMTCAO-ACCESS       THRU MMTCAO-ACCESS-EXIT.
057600*
057700     MOVE MMTC-TXN-CODE          TO MX03-TC
057800                                    (X-MX03-TC).
057900     MOVE DFHBMASK               TO MX03-TC-A
058000                                    (X-MX03-TC).
058100     MOVE DFHBMDAS               TO MX03-TC-LP-A
058200                                    (X-MX03-TC).
058300     MOVE DFHBMDAS               TO MX03-TC-RP-A
058400                                    (X-MX03-TC).
058500*
058600     IF  MMTC-REC-GENERATED
058700     OR  MMTC-REC-DEFAULT
058800         MOVE MMTC-LOGIC-MODULE  TO MX03-LM
058900                                    (X-MX03-TC)
059000         MOVE DFHBMDAS           TO MX03-LM-LP-A
059100                                    (X-MX03-TC)
059200         MOVE DFHBMDAS           TO MX03-LM-RP-A
059300                                    (X-MX03-TC)
059400         MOVE DFHBMASK           TO MX03-LM-A
059500                                    (X-MX03-TC)
059600         MOVE DFHBMASK           TO MX03-TC-TYPE-A
059700                                    (X-MX03-TC)
059800         EVALUATE TRUE
059900             WHEN MMTC-REC-GENERATED
060000                 MOVE 'G'        TO MX03-TC-TYPE
060100                                    (X-MX03-TC)
060200             WHEN OTHER
060300                 MOVE 'D'        TO MX03-TC-TYPE
060400                                    (X-MX03-TC)
060500         END-EVALUATE
060600         GO TO 2230-RS-LOGIC-MOD-BYPASS.
060700*
060800     GO TO 2220-RS-MAINT-BYPASS.
060900*
061000 2210-RS-ADD-BYPASS.
061100*
061200*--> EDIT TRANSACTION CODE
061300*
061400     IF  MX03-TC-L (X-MX03-TC)
061500                                 IS LESS THAN 1
061600     AND MBCA-PTI-FUNCTION-IS-ADD
061700         MOVE DFHBMDAS           TO MX03-TC-A
061800                                    (X-MX03-TC)
061900         MOVE DFHBMDAS           TO MX03-TC-LP-A
062000                                    (X-MX03-TC)
062100         MOVE DFHBMDAS           TO MX03-TC-RP-A
062200                                    (X-MX03-TC)
062300         MOVE DFHBMDAS           TO MX03-LM-A
062400                                    (X-MX03-TC)
062500         MOVE DFHBMDAS           TO MX03-LM-LP-A
062600                                    (X-MX03-TC)
062700         MOVE DFHBMDAS           TO MX03-LM-RP-A
062800                                    (X-MX03-TC)
062900         MOVE DFHBMDAS           TO MX03-RPT-DESC-A
063000                                    (X-MX03-TC)
063100         MOVE DFHBMDAS           TO MX03-RPT-DESC-LP-A
063200                                    (X-MX03-TC)
063300         MOVE DFHBMDAS           TO MX03-RPT-DESC-RP-A
063400                                    (X-MX03-TC)
063500         MOVE DFHBMDAS           TO MX03-GL-DR-ACCT-A
063600                                    (X-MX03-TC)
063700         MOVE DFHBMDAS           TO MX03-GL-DR-ACCT-LP-A
063800                                    (X-MX03-TC)
063900         MOVE DFHBMDAS           TO MX03-GL-DR-ACCT-RP-A
064000                                    (X-MX03-TC)
064100         MOVE DFHBMDAS           TO MX03-GL-DR-DESC-A
064200                                    (X-MX03-TC)
064300         MOVE DFHBMDAS           TO MX03-GL-DR-DESC-LP-A
064400                                    (X-MX03-TC)
064500         MOVE DFHBMDAS           TO MX03-GL-DR-DESC-RP-A
064600                                    (X-MX03-TC)
064700         MOVE DFHBMDAS           TO MX03-GL-CR-ACCT-A
064800                                    (X-MX03-TC)
064900         MOVE DFHBMDAS           TO MX03-GL-CR-ACCT-LP-A
065000                                    (X-MX03-TC)
065100         MOVE DFHBMDAS           TO MX03-GL-CR-ACCT-RP-A
065200                                    (X-MX03-TC)
065300         MOVE DFHBMDAS           TO MX03-GL-CR-DESC-A
065400                                    (X-MX03-TC)
065500         MOVE DFHBMDAS           TO MX03-GL-CR-DESC-LP-A
065600                                    (X-MX03-TC)
065700         MOVE DFHBMDAS           TO MX03-GL-CR-DESC-RP-A
065800                                    (X-MX03-TC)
065900         MOVE DFHBMDAS           TO MX03-DEFAULT-DESC-A
066000                                    (X-MX03-TC)
066100         MOVE DFHBMDAS           TO MX03-DEFAULT-DESC-LP-A
066200                                    (X-MX03-TC)
066300         MOVE DFHBMDAS           TO MX03-DEFAULT-DESC-RP-A
066400                                    (X-MX03-TC)
066500         GO TO 2280-RS-INCR-INDEX.
066600*
066700     IF  MX03-TC-L (X-MX03-TC)
066800                                 IS LESS THAN 1
066900         MOVE DFHBMDAS           TO MX03-TC-A
067000                                    (X-MX03-TC)
067100         MOVE DFHBMDAS           TO MX03-TC-LP-A
067200                                    (X-MX03-TC)
067300         MOVE DFHBMDAS           TO MX03-TC-RP-A
067400                                    (X-MX03-TC)
067500         GO TO 2220-RS-MAINT-BYPASS
067600     ELSE
067700         IF  MX03-TC (X-MX03-TC)
067800                                    IS NUMERIC
067900         AND MX03-TC (X-MX03-TC)
068000                                    IS GREATER THAN ZERO
068100         AND MX03-TC (X-MX03-TC)
068200                                    IS LESS THAN 999
068300             MOVE DFHBMASF       TO MX03-TC-A
068400                                    (X-MX03-TC)
068500             MOVE DFHBMDAS       TO MX03-TC-LP-A
068600                                    (X-MX03-TC)
068700             MOVE DFHBMDAS       TO MX03-TC-RP-A
068800                                    (X-MX03-TC)
068900         ELSE
069000             MOVE DFHBMNBF       TO MX03-TC-A
069100                                    (X-MX03-TC)
069200             MOVE DFHBMASB       TO MX03-TC-LP-A
069300                                    (X-MX03-TC)
069400             MOVE DFHBMASB       TO MX03-TC-RP-A
069500                                    (X-MX03-TC)
069600             MOVE SS08WS-CURSOR  TO MX03-TC-L
069700                                    (X-MX03-TC)
069800             MOVE 'Y'            TO SS08WS-ERROR-SW
069900             GO TO 2220-RS-MAINT-BYPASS.
070000*
070100     MOVE MBCA-ORG               TO MBIOWS-MMTC-ORG.
070200     MOVE MX03-TC (X-MX03-TC)
070300                                 TO MBIOWS-MMTC-TXN-CODE.
070400*
070500     MOVE SS08WS-CICS-FC-NOTFND  TO MBIORO-TEMP-STATUS-1.
070600     MOVE 'FC04'                 TO MBCA-PROGRAM-LOCATION.
070700     SET MBIORO-READ-RANDOM      TO TRUE.
070800     PERFORM MMTCAO-ACCESS       THRU MMTCAO-ACCESS-EXIT.
070900*
071000     IF  SS08WS-RC-FC-NOTFND
071100         GO TO 2220-RS-MAINT-BYPASS.
071200*
071300     IF  MMTC-REC-PURGED
071400         GO TO 2220-RS-MAINT-BYPASS.
071500*
071600     MOVE DFHBMNBF               TO MX03-TC-A
071700                                    (X-MX03-TC).
071800     MOVE DFHBMASB               TO MX03-TC-LP-A
071900                                    (X-MX03-TC).
072000     MOVE DFHBMASB               TO MX03-TC-RP-A
072100                                    (X-MX03-TC).
072200     MOVE DFHBMUNF               TO MX03-LM-A
072300                                    (X-MX03-TC).
072400     MOVE DFHBMASK               TO MX03-LM-LP-A
072500                                    (X-MX03-TC).
072600     MOVE DFHBMASK               TO MX03-LM-RP-A
072700                                    (X-MX03-TC).
072800     MOVE DFHBMFSE               TO MX03-RPT-DESC-A
072900                                    (X-MX03-TC).
073000     MOVE DFHBMASK               TO MX03-RPT-DESC-LP-A
073100                                    (X-MX03-TC).
073200     MOVE DFHBMASK               TO MX03-RPT-DESC-RP-A
073300                                    (X-MX03-TC).
073400     MOVE DFHBMFSE               TO MX03-GL-DR-ACCT-A
073500                                    (X-MX03-TC).
073600     MOVE DFHBMASK               TO MX03-GL-DR-ACCT-LP-A
073700                                    (X-MX03-TC).
073800     MOVE DFHBMASK               TO MX03-GL-DR-ACCT-RP-A
073900                                    (X-MX03-TC).
074000     MOVE DFHBMFSE               TO MX03-GL-DR-DESC-A
074100                                    (X-MX03-TC).
074200     MOVE DFHBMASK               TO MX03-GL-DR-DESC-LP-A
074300                                    (X-MX03-TC).
074400     MOVE DFHBMASK               TO MX03-GL-DR-DESC-RP-A
074500                                    (X-MX03-TC).
074600     MOVE DFHBMFSE               TO MX03-GL-CR-ACCT-A
074700                                    (X-MX03-TC).
074800     MOVE DFHBMASK               TO MX03-GL-CR-ACCT-LP-A
074900                                    (X-MX03-TC).
075000     MOVE DFHBMASK               TO MX03-GL-CR-ACCT-RP-A
075100                                    (X-MX03-TC).
075200     MOVE DFHBMFSE               TO MX03-GL-CR-DESC-A
075300                                    (X-MX03-TC).
075400     MOVE DFHBMASK               TO MX03-GL-CR-DESC-LP-A
075500                                    (X-MX03-TC).
075600     MOVE DFHBMASK               TO MX03-GL-CR-DESC-RP-A
075700                                    (X-MX03-TC).
075800     MOVE DFHBMFSE               TO MX03-DEFAULT-DESC-A
075900                                    (X-MX03-TC).
076000*****MOVE 'ALREADY ADDED - EOF TO CLEAR'
076100*****                            TO MX03-DEFAULT-DESC
076200*****                               (X-MX03-TC).
076300     MOVE DFHBMASK               TO MX03-DEFAULT-DESC-LP-A
076400                                    (X-MX03-TC).
076500     MOVE DFHBMASK               TO MX03-DEFAULT-DESC-RP-A
076600                                    (X-MX03-TC).
076700     MOVE SS08WS-CURSOR          TO MX03-TC-L
076800                                    (X-MX03-TC).
076900     MOVE 'Y'                    TO SS08WS-ERROR-SW.
077000     GO TO 2280-RS-INCR-INDEX.
077100*
077200 2220-RS-MAINT-BYPASS.
077300*
077400*--> EDIT LOGIC MODULE
077500*
077600     IF  MX03-LM-L (X-MX03-TC)   IS LESS THAN 1
077700         MOVE DFHBMASK           TO MX03-LM-A
077800                                    (X-MX03-TC)
077900         MOVE DFHBMDAS           TO MX03-LM-LP-A
078000                                    (X-MX03-TC)
078100         MOVE DFHBMDAS           TO MX03-LM-RP-A
078200                                    (X-MX03-TC)
078300     ELSE
078400         PERFORM 9500-EDIT-LOGIC-MODULE
078500                                 THRU 9599-ELM-EXIT
078600         IF  WS-LM-IS-VALID
078700             MOVE DFHBMASF       TO MX03-LM-A
078800                                    (X-MX03-TC)
078900             MOVE DFHBMDAS       TO MX03-LM-LP-A
079000                                    (X-MX03-TC)
079100             MOVE DFHBMDAS       TO MX03-LM-RP-A
079200                                    (X-MX03-TC)
079300         ELSE
079400             MOVE DFHBMNBF       TO MX03-LM-A
079500                                    (X-MX03-TC)
079600             MOVE DFHBMASB       TO MX03-LM-LP-A
079700                                    (X-MX03-TC)
079800             MOVE DFHBMASB       TO MX03-LM-RP-A
079900                                    (X-MX03-TC)
080000             MOVE SS08WS-CURSOR  TO MX03-LM-L
080100                                    (X-MX03-TC)
080200             MOVE 'Y'            TO SS08WS-ERROR-SW.
080300*
080400 2230-RS-LOGIC-MOD-BYPASS.
080500*
080600*--> EDIT SHORT DESCRIPTION
080700*
080800     IF  MX03-RPT-DESC-L (X-MX03-TC)
080900                                 IS LESS THAN 1
081000         MOVE DFHBMASK           TO MX03-RPT-DESC-A
081100                                    (X-MX03-TC)
081200         MOVE DFHBMDAS           TO MX03-RPT-DESC-LP-A
081300                                    (X-MX03-TC)
081400         MOVE DFHBMDAS           TO MX03-RPT-DESC-RP-A
081500                                    (X-MX03-TC)
081600     ELSE
081700         IF  MX03-RPT-DESC (X-MX03-TC)
081800                                 IS NOT EQUAL TO SPACES
081900             MOVE DFHBMASF       TO MX03-RPT-DESC-A
082000                                    (X-MX03-TC)
082100             MOVE DFHBMDAS       TO MX03-RPT-DESC-LP-A
082200                                    (X-MX03-TC)
082300             MOVE DFHBMDAS       TO MX03-RPT-DESC-RP-A
082400                                    (X-MX03-TC)
082500         ELSE
082600             MOVE DFHBMUBF       TO MX03-RPT-DESC-A
082700                                    (X-MX03-TC)
082800             MOVE DFHBMASB       TO MX03-RPT-DESC-LP-A
082900                                    (X-MX03-TC)
083000             MOVE DFHBMASB       TO MX03-RPT-DESC-RP-A
083100                                    (X-MX03-TC)
083200             MOVE SS08WS-CURSOR  TO MX03-RPT-DESC-L
083300                                    (X-MX03-TC)
083400             MOVE 'Y'            TO SS08WS-ERROR-SW.
083500*
083600     IF  MBCA-PTI-FUNCTION-IS-MAINT
083700     AND MX03-RPT-DESC-L (X-MX03-TC)
083800                                 IS LESS THAN 1
083900     AND MX03-RPT-DESC-L (X-MX03-TC)
084000                                 IS GREATER THAN SS08WS-CURSOR
084100         MOVE MMTC-RPT-DESC      TO MX03-RPT-DESC
084200                                    (X-MX03-TC).
084300*
084400*--> EDIT FULL DESCRIPTION
084500*
084600     IF  MX03-DEFAULT-DESC-L (X-MX03-TC)
084700                                 IS LESS THAN 1
084800         MOVE DFHBMASK           TO MX03-DEFAULT-DESC-A
084900                                    (X-MX03-TC)
085000         MOVE DFHBMDAS           TO MX03-DEFAULT-DESC-LP-A
085100                                    (X-MX03-TC)
085200         MOVE DFHBMDAS           TO MX03-DEFAULT-DESC-RP-A
085300                                    (X-MX03-TC)
085400     ELSE
085500         IF  MX03-DEFAULT-DESC (X-MX03-TC)
085600                                 IS NOT EQUAL TO SPACES
085700             MOVE DFHBMASF       TO MX03-DEFAULT-DESC-A
085800                                    (X-MX03-TC)
085900             MOVE DFHBMDAS       TO MX03-DEFAULT-DESC-LP-A
086000                                    (X-MX03-TC)
086100             MOVE DFHBMDAS       TO MX03-DEFAULT-DESC-RP-A
086200                                    (X-MX03-TC)
086300         ELSE
086400             MOVE DFHBMUBF       TO MX03-DEFAULT-DESC-A
086500                                    (X-MX03-TC)
086600             MOVE DFHBMASB       TO MX03-DEFAULT-DESC-LP-A
086700                                    (X-MX03-TC)
086800             MOVE DFHBMASB       TO MX03-DEFAULT-DESC-RP-A
086900                                    (X-MX03-TC)
087000             MOVE SS08WS-CURSOR  TO MX03-DEFAULT-DESC-L
087100                                    (X-MX03-TC)
087200             MOVE 'Y'            TO SS08WS-ERROR-SW.
087300*
087400     IF  MBCA-PTI-FUNCTION-IS-MAINT
087500     AND MX03-DEFAULT-DESC-L (X-MX03-TC)
087600                                 IS LESS THAN 1
087700     AND MX03-DEFAULT-DESC-L (X-MX03-TC)
087800                                 IS GREATER THAN SS08WS-CURSOR
087900         MOVE MMTC-DEFAULT-DESC TO MX03-DEFAULT-DESC
088000                                    (X-MX03-TC).
088100*
088200*--> EDIT DR GL ACCOUNT
088300*
088400     IF  MX03-GL-DR-ACCT-L (X-MX03-TC)
088500                                 IS LESS THAN 1
088600         MOVE DFHBMASK           TO MX03-GL-DR-ACCT-A
088700                                    (X-MX03-TC)
088800         MOVE DFHBMDAS           TO MX03-GL-DR-ACCT-LP-A
088900                                    (X-MX03-TC)
089000         MOVE DFHBMDAS           TO MX03-GL-DR-ACCT-RP-A
089100                                    (X-MX03-TC)
089200     ELSE
089300         MOVE DFHBMASF           TO MX03-GL-DR-ACCT-A
089400                                    (X-MX03-TC)
089500         MOVE DFHBMDAS           TO MX03-GL-DR-ACCT-LP-A
089600                                    (X-MX03-TC)
089700         MOVE DFHBMDAS           TO MX03-GL-DR-ACCT-RP-A
089800                                    (X-MX03-TC).
089900*
090000     IF  MBCA-PTI-FUNCTION-IS-MAINT
090100     AND MX03-GL-DR-ACCT-L (X-MX03-TC)
090200                                 IS LESS THAN 1
090300     AND MX03-GL-DR-ACCT-L (X-MX03-TC)
090400                                 IS GREATER THAN SS08WS-CURSOR
090500         MOVE MMTC-GL-DR-ACCT    TO MX03-GL-DR-ACCT
090600                                    (X-MX03-TC).
090700*
090800*--> EDIT DR GL ACCOUNT DESC
090900*
091000     IF  MX03-GL-DR-DESC-L (X-MX03-TC)
091100                                 IS LESS THAN 1
091200         MOVE DFHBMASK           TO MX03-GL-DR-DESC-A
091300                                    (X-MX03-TC)
091400         MOVE DFHBMDAS           TO MX03-GL-DR-DESC-LP-A
091500                                    (X-MX03-TC)
091600         MOVE DFHBMDAS           TO MX03-GL-DR-DESC-RP-A
091700                                    (X-MX03-TC)
091800     ELSE
091900         MOVE DFHBMASF           TO MX03-GL-DR-DESC-A
092000                                    (X-MX03-TC)
092100         MOVE DFHBMDAS           TO MX03-GL-DR-DESC-LP-A
092200                                    (X-MX03-TC)
092300         MOVE DFHBMDAS           TO MX03-GL-DR-DESC-RP-A
092400                                    (X-MX03-TC).
092500*
092600     IF  MBCA-PTI-FUNCTION-IS-MAINT
092700     AND MX03-GL-DR-DESC-L (X-MX03-TC)
092800                                 IS LESS THAN 1
092900     AND MX03-GL-DR-DESC-L (X-MX03-TC)
093000                                 IS GREATER THAN SS08WS-CURSOR
093100         MOVE MMTC-GL-DR-DESC    TO MX03-GL-DR-DESC
093200                                    (X-MX03-TC).
093300*
093400*--> EDIT CR GL ACCOUNT
093500*
093600     IF  MX03-GL-CR-ACCT-L (X-MX03-TC)
093700                                 IS LESS THAN 1
093800         MOVE DFHBMASK           TO MX03-GL-CR-ACCT-A
093900                                    (X-MX03-TC)
094000         MOVE DFHBMDAS           TO MX03-GL-CR-ACCT-LP-A
094100                                    (X-MX03-TC)
094200         MOVE DFHBMDAS           TO MX03-GL-CR-ACCT-RP-A
094300                                    (X-MX03-TC)
094400     ELSE
094500         MOVE DFHBMASF           TO MX03-GL-CR-ACCT-A
094600                                    (X-MX03-TC)
094700         MOVE DFHBMDAS           TO MX03-GL-CR-ACCT-LP-A
094800                                    (X-MX03-TC)
094900         MOVE DFHBMDAS           TO MX03-GL-CR-ACCT-RP-A
095000                                    (X-MX03-TC).
095100*
095200     IF  MBCA-PTI-FUNCTION-IS-MAINT
095300     AND MX03-GL-CR-ACCT-L (X-MX03-TC)
095400                                 IS LESS THAN 1
095500     AND MX03-GL-CR-ACCT-L (X-MX03-TC)
095600                                 IS GREATER THAN SS08WS-CURSOR
095700         MOVE MMTC-GL-CR-ACCT    TO MX03-GL-CR-ACCT
095800                                    (X-MX03-TC).
095900*
096000*--> EDIT CR GL ACCOUNT DESC
096100*
096200     IF  MX03-GL-CR-DESC-L (X-MX03-TC)
096300                                 IS LESS THAN 1
096400         MOVE DFHBMASK           TO MX03-GL-CR-DESC-A
096500                                    (X-MX03-TC)
096600         MOVE DFHBMDAS           TO MX03-GL-CR-DESC-LP-A
096700                                    (X-MX03-TC)
096800         MOVE DFHBMDAS           TO MX03-GL-CR-DESC-RP-A
096900                                    (X-MX03-TC)
097000     ELSE
097100         MOVE DFHBMASF           TO MX03-GL-CR-DESC-A
097200                                    (X-MX03-TC)
097300         MOVE DFHBMDAS           TO MX03-GL-CR-DESC-LP-A
097400                                    (X-MX03-TC)
097500         MOVE DFHBMDAS           TO MX03-GL-CR-DESC-RP-A
097600                                    (X-MX03-TC).
097700*
097800     IF  MBCA-PTI-FUNCTION-IS-MAINT
097900     AND MX03-GL-CR-DESC-L (X-MX03-TC)
098000                                 IS LESS THAN 1
098100     AND MX03-GL-CR-DESC-L (X-MX03-TC)
098200                                 IS GREATER THAN SS08WS-CURSOR
098300         MOVE MMTC-GL-CR-DESC    TO MX03-GL-CR-DESC
098400                                    (X-MX03-TC).
098500*
098600*
098700*
098800     IF  MBCA-PTI-FUNCTION-IS-ADD
098900     AND MX03-TC-L (X-MX03-TC)
099000                                 IS NOT EQUAL TO SS08WS-CURSOR
099100     AND MX03-LM-L (X-MX03-TC)
099200                                 IS NOT EQUAL TO SS08WS-CURSOR
099300     AND MX03-RPT-DESC-L (X-MX03-TC)
099400                                 IS NOT EQUAL TO SS08WS-CURSOR
099500     AND MX03-GL-DR-ACCT-L (X-MX03-TC)
099600                                 IS NOT EQUAL TO SS08WS-CURSOR
099700     AND MX03-GL-DR-DESC-L (X-MX03-TC)
099800                                 IS NOT EQUAL TO SS08WS-CURSOR
099900     AND MX03-GL-CR-ACCT-L (X-MX03-TC)
100000                                 IS NOT EQUAL TO SS08WS-CURSOR
100100     AND MX03-GL-CR-DESC-L (X-MX03-TC)
100200                                 IS NOT EQUAL TO SS08WS-CURSOR
100300     AND MX03-DEFAULT-DESC-L (X-MX03-TC)
100400                                 IS NOT EQUAL TO SS08WS-CURSOR
100500     AND
100600        (MX03-TC-L (X-MX03-TC)
100700                                 IS GREATER THAN ZERO
100800     OR  MX03-LM-L (X-MX03-TC)
100900                                 IS GREATER THAN ZERO
101000     OR  MX03-RPT-DESC-L (X-MX03-TC)
101100                                 IS GREATER THAN ZERO
101200     OR  MX03-GL-DR-ACCT-L (X-MX03-TC)
101300                                 IS GREATER THAN ZERO
101400     OR  MX03-GL-DR-DESC-L (X-MX03-TC)
101500                                 IS GREATER THAN ZERO
101600     OR  MX03-GL-CR-ACCT-L (X-MX03-TC)
101700                                 IS GREATER THAN ZERO
101800     OR  MX03-GL-CR-DESC-L (X-MX03-TC)
101900                                 IS GREATER THAN ZERO
102000     OR  MX03-DEFAULT-DESC-L (X-MX03-TC)
102100                                 IS GREATER THAN ZERO)
102200     AND
102300        (MX03-TC-L (X-MX03-TC)
102400                                 IS LESS THAN 1
102500     OR  MX03-LM-L (X-MX03-TC)
102600                                 IS LESS THAN 1
102700     OR  MX03-RPT-DESC-L (X-MX03-TC)
102800                                 IS LESS THAN 1
102900     OR  MX03-GL-DR-ACCT-L (X-MX03-TC)
103000                                 IS LESS THAN 1
103100     OR  MX03-GL-DR-DESC-L (X-MX03-TC)
103200                                 IS LESS THAN 1
103300     OR  MX03-GL-CR-ACCT-L (X-MX03-TC)
103400                                 IS LESS THAN 1
103500     OR  MX03-GL-CR-DESC-L (X-MX03-TC)
103600                                 IS LESS THAN 1
103700     OR  MX03-DEFAULT-DESC-L (X-MX03-TC)
103800                                 IS LESS THAN 1)
103900         MOVE DFHBMNBF           TO MX03-TC-A
104000                                    (X-MX03-TC)
104100         MOVE DFHBMASB           TO MX03-TC-LP-A
104200                                    (X-MX03-TC)
104300         MOVE DFHBMASB           TO MX03-TC-RP-A
104400                                    (X-MX03-TC)
104500         MOVE DFHBMNBF           TO MX03-LM-A
104600                                    (X-MX03-TC)
104700         MOVE DFHBMASB           TO MX03-LM-LP-A
104800                                    (X-MX03-TC)
104900         MOVE DFHBMASB           TO MX03-LM-RP-A
105000                                    (X-MX03-TC)
105100         MOVE DFHBMUBF           TO MX03-RPT-DESC-A
105200                                    (X-MX03-TC)
105300         MOVE DFHBMASB           TO MX03-RPT-DESC-LP-A
105400                                    (X-MX03-TC)
105500         MOVE DFHBMASB           TO MX03-RPT-DESC-RP-A
105600                                    (X-MX03-TC)
105700         MOVE DFHBMUBF           TO MX03-GL-DR-ACCT-A
105800                                    (X-MX03-TC)
105900         MOVE DFHBMASB           TO MX03-GL-DR-ACCT-LP-A
106000                                    (X-MX03-TC)
106100         MOVE DFHBMASB           TO MX03-GL-DR-ACCT-RP-A
106200                                    (X-MX03-TC)
106300         MOVE DFHBMUBF           TO MX03-GL-DR-DESC-A
106400                                    (X-MX03-TC)
106500         MOVE DFHBMASB           TO MX03-GL-DR-DESC-LP-A
106600                                    (X-MX03-TC)
106700         MOVE DFHBMASB           TO MX03-GL-DR-DESC-RP-A
106800                                    (X-MX03-TC)
106900         MOVE DFHBMUBF           TO MX03-GL-CR-ACCT-A
107000                                    (X-MX03-TC)
107100         MOVE DFHBMASB           TO MX03-GL-CR-ACCT-LP-A
107200                                    (X-MX03-TC)
107300         MOVE DFHBMASB           TO MX03-GL-CR-ACCT-RP-A
107400                                    (X-MX03-TC)
107500         MOVE DFHBMUBF           TO MX03-GL-CR-DESC-A
107600                                    (X-MX03-TC)
107700         MOVE DFHBMASB           TO MX03-GL-CR-DESC-LP-A
107800                                    (X-MX03-TC)
107900         MOVE DFHBMASB           TO MX03-GL-CR-DESC-RP-A
108000                                    (X-MX03-TC)
108100         MOVE DFHBMUBF           TO MX03-DEFAULT-DESC-A
108200                                    (X-MX03-TC)
108300         MOVE DFHBMASB           TO MX03-DEFAULT-DESC-LP-A
108400                                    (X-MX03-TC)
108500         MOVE DFHBMASB           TO MX03-DEFAULT-DESC-RP-A
108600                                    (X-MX03-TC)
108700         MOVE SS08WS-CURSOR      TO MX03-TC-L
108800                                    (X-MX03-TC)
108900         MOVE 'Y'                TO SS08WS-ERROR-SW.
109000*
109100     GO TO 2280-RS-INCR-INDEX.
109200*
109300 2270-RS-NO-RECS-LEFT.
109400*
109500     MOVE DFHBMDAS               TO MX03-RPT-DESC-LIT-A
109600                                    (X-MX03-TC).
109700     MOVE DFHBMDAS               TO MX03-GL-DR-ACCT-LIT-A
109800                                    (X-MX03-TC).
109900     MOVE DFHBMDAS               TO MX03-GL-DR-DESC-LIT-A
110000                                    (X-MX03-TC).
110100     MOVE DFHBMDAS               TO MX03-GL-CR-ACCT-LIT-A
110200                                    (X-MX03-TC).
110300     MOVE DFHBMDAS               TO MX03-GL-CR-DESC-LIT-A
110400                                    (X-MX03-TC).
110500     MOVE DFHBMDAS               TO MX03-DEFAULT-DESC-LIT-A
110600                                    (X-MX03-TC).
110700     MOVE DFHBMDAS               TO MX03-PLUS-BOT-A.
110800*
110900     MOVE DFHBMDAS               TO MX03-TC-LP-A
111000                                    (X-MX03-TC).
111100     MOVE DFHBMDAS               TO MX03-TC-A
111200                                    (X-MX03-TC).
111300     MOVE DFHBMDAS               TO MX03-TC-RP-A
111400                                    (X-MX03-TC).
111500     MOVE DFHBMDAS               TO MX03-LM-LP-A
111600                                    (X-MX03-TC).
111700     MOVE DFHBMDAS               TO MX03-LM-A
111800                                    (X-MX03-TC).
111900     MOVE DFHBMDAS               TO MX03-LM-RP-A
112000                                    (X-MX03-TC).
112100     MOVE DFHBMDAS               TO MX03-RPT-DESC-LP-A
112200                                    (X-MX03-TC).
112300     MOVE DFHBMDAS               TO MX03-RPT-DESC-A
112400                                    (X-MX03-TC).
112500     MOVE DFHBMDAS               TO MX03-RPT-DESC-RP-A
112600                                    (X-MX03-TC).
112700     MOVE DFHBMDAS               TO MX03-GL-DR-ACCT-A
112800                                    (X-MX03-TC).
112900     MOVE DFHBMDAS               TO MX03-GL-DR-ACCT-RP-A
113000                                    (X-MX03-TC).
113100     MOVE DFHBMDAS               TO MX03-GL-DR-ACCT-LP-A
113200                                    (X-MX03-TC).
113300     MOVE DFHBMDAS               TO MX03-GL-DR-DESC-A
113400                                    (X-MX03-TC).
113500     MOVE DFHBMDAS               TO MX03-GL-DR-DESC-RP-A
113600                                    (X-MX03-TC).
113700     MOVE DFHBMDAS               TO MX03-GL-DR-DESC-LP-A
113800                                    (X-MX03-TC).
113900     MOVE DFHBMDAS               TO MX03-GL-CR-ACCT-A
114000                                    (X-MX03-TC).
114100     MOVE DFHBMDAS               TO MX03-GL-CR-ACCT-RP-A
114200                                    (X-MX03-TC).
114300     MOVE DFHBMDAS               TO MX03-GL-CR-ACCT-LP-A
114400                                    (X-MX03-TC).
114500     MOVE DFHBMDAS               TO MX03-GL-CR-DESC-A
114600                                    (X-MX03-TC).
114700     MOVE DFHBMDAS               TO MX03-GL-CR-DESC-RP-A
114800                                    (X-MX03-TC).
114900     MOVE DFHBMDAS               TO MX03-GL-CR-DESC-LP-A
115000                                    (X-MX03-TC).
115100     MOVE DFHBMDAS               TO MX03-DEFAULT-DESC-LP-A
115200                                    (X-MX03-TC).
115300     MOVE DFHBMDAS               TO MX03-DEFAULT-DESC-A
115400                                    (X-MX03-TC).
115500     MOVE DFHBMDAS               TO MX03-DEFAULT-DESC-RP-A
115600                                    (X-MX03-TC).
115700     IF  WS-EOO-MSG-SW IS EQUAL TO 'Y'
115800         MOVE 'N'                TO WS-EOO-MSG-SW
115900         MOVE '********** END OF TRANSACTIONS *********'
116000                                 TO MX03-DEFAULT-DESC
116100                                    (X-MX03-TC)
116200         MOVE DFHBMASB           TO MX03-DEFAULT-DESC-A
116300                                    (X-MX03-TC).
116400*
116500 2280-RS-INCR-INDEX.
116600*
116700     SET X-MX03-TC               UP BY 1.
116800     GO TO 2200-RS-EDIT-TRANS-LOOP.
116900*
117000 2300-RS-CROSS-EDIT-TXN.
117100*
117200     IF  MBCA-PTI-FUNCTION-IS-ADD
117300         NEXT SENTENCE
117400     ELSE
117500         GO TO 2700-RS-CHECK-CURSOR.
117600*
117700*****************************************************************
117800*    MAKE SURE THAT THE TRANSACTION CODE IS NOT DUPLICATED ON   *
117900*    THIS SCREEN.  IF SO FLAG AS AN ERROR.  THIS IS ONLY DONE IN*
118000*    THE ADD FUNCTION.                                          *
118100*****************************************************************
118200*
118300     SET X-MX03-TC-1             TO 1.
118400*
118500 2310-RS-CET-LOOP-1.
118600*
118700     IF  X-MX03-TC-1 IS GREATER THAN 3
118800         GO TO 2700-RS-CHECK-CURSOR.
118900*
119000     IF  MX03-TC-L (X-MX03-TC-1)
119100                                 IS LESS THAN 1
119200         SET X-MX03-TC-1         UP BY 1
119300         GO TO 2310-RS-CET-LOOP-1.
119400*
119500     SET X-MX03-TC-2             TO X-MX03-TC-1.
119600     SET X-MX03-TC-2             UP BY 1.
119700*
119800 2320-RS-CET-LOOP-2.
119900*
120000     IF  X-MX03-TC-2 IS GREATER THAN 3
120100         SET X-MX03-TC-1         UP BY 1
120200         GO TO 2310-RS-CET-LOOP-1.
120300*
120400     IF  MX03-TC-L (X-MX03-TC-2)
120500                                 IS LESS THAN 1
120600         SET X-MX03-TC-2         UP BY 1
120700         GO TO 2320-RS-CET-LOOP-2.
120800*
120900     IF  MX03-TC (X-MX03-TC-1)
121000         IS EQUAL TO
121100         MX03-TC (X-MX03-TC-2)
121200         MOVE DFHBMNBF           TO MX03-TC-A
121300                                    (X-MX03-TC-2)
121400         MOVE DFHBMASB           TO MX03-TC-LP-A
121500                                    (X-MX03-TC-2)
121600         MOVE DFHBMASB           TO MX03-TC-RP-A
121700                                    (X-MX03-TC-2)
121800         MOVE SS08WS-CURSOR      TO MX03-TC-L
121900                                    (X-MX03-TC-2)
122000         MOVE 'Y'                TO SS08WS-ERROR-SW.
122100*
122200     SET X-MX03-TC-2             UP BY 1.
122300     GO TO 2320-RS-CET-LOOP-2.
122400*
122500 2700-RS-CHECK-CURSOR.
122600*
122700     IF  SS08WS-ERROR-SW IS EQUAL TO 'Y'
122800         GO TO 2800-RS-SEND-ERROR-SCREEN.
122900*
123000     PERFORM 5000-BUILD-MAINT-SECT.
123100*
123200     GO TO 2900-RS-SETUP-COMMAREA.
123300/
123400 2800-RS-SEND-ERROR-SCREEN.
123500*
123600*****************************************************************
123700*   ERRORS WERE FOUND ON THIS SCREEN.  SEND AN ERROR SCREEN AND *
123800*   RETURN CONTROL TO CICS.                                     *
123900*****************************************************************
124000*
124100     IF  MBCA-PTI-FUNCTION-IS-ADD
124200         MOVE DFHBMDAS           TO MX03-BEG-TC-LIT-A
124300         MOVE DFHBMDAS           TO MX03-BEG-TC-LP-A
124400         MOVE DFHBMDAS           TO MX03-BEG-TC-RP-A
124500         MOVE DFHBMDAS           TO MX03-BEG-TC-A.
124600*
124700     MOVE 'FC05'                 TO MBCA-PROGRAM-LOCATION.
124800     SET MBIORO-UNLOCK           TO TRUE.
124900     PERFORM MMTCAO-ACCESS       THRU MMTCAO-ACCESS-EXIT.
125000*
125100     PERFORM MB60PD-INIT-STD-MAP-LINES
125200                                 THRU MB60PD-ISML-EXIT.
125300*
125400     IF  MBCA-PTI-FUNCTION-IS-ADD
125500         GO TO 2890-RS-BYPASS-PF-KEYS.
125600*
125700*****************************************************************
125800*    THIS PROGRAM WILL DO SPECIAL FUNCTIONS WITH PF KEYS.       *
125900*    PF1 = NORMAL                                               *
126000*    PF2 = NORMAL                                               *
126100*    PF3 = TOP OF TRANSACTION CODES                             *
126200*    PF4 = BOTTOM OF TRANSACTION CODES                          *
126300*    PF5 = PAGE SCREEN FOREWARDS                                *
126400*    PF6 = PAGE SCREEN BACKWARDS                                *
126500*****************************************************************
126600*
126700     MOVE '*TOP*'                TO SS08WS-LINE-24-PF-KEY-FUNC(3).
126800     MOVE '*BOT*'                TO SS08WS-LINE-24-PF-KEY-FUNC(4).
126900     MOVE '*FWD*'                TO SS08WS-LINE-24-PF-KEY-FUNC(5).
127000     MOVE '*BWD*'                TO SS08WS-LINE-24-PF-KEY-FUNC(6).
127100     MOVE SS08WS-LINE-24         TO TTN2401I.
127200     MOVE 'RESV'                 TO MBCA-PGMX-PF-TRANS-ID (3).
127300     MOVE 'RESV'                 TO MBCA-PGMX-PF-TRANS-ID (4).
127400     MOVE 'RESV'                 TO MBCA-PGMX-PF-TRANS-ID (5).
127500     MOVE 'RESV'                 TO MBCA-PGMX-PF-TRANS-ID (6).
127600*
127700 2890-RS-BYPASS-PF-KEYS.
127800*
127900     MOVE DFHBMDAS               TO MX03-PLUS-TOP-A.
128000     MOVE DFHBMDAS               TO MX03-PLUS-BOT-A.
128100     MOVE '+'                    TO MX03-PLUS-TOP.
128200     MOVE '+'                    TO MX03-PLUS-BOT.
128300*
128400     MOVE 'BM03'                 TO MBCA-PROGRAM-LOCATION.
128500     PERFORM MB60PD-SEND-MAP-DATA-ONLY
128600                                 THRU MB60PD-SMDO-EXIT.
128700*
128800     MOVE 'PC04'                 TO MBCA-PROGRAM-LOCATION.
128900     PERFORM MB70PD-RETURN-TRANS-ID
129000                                 THRU MB70PD-RTI-EXIT.
129100/
129200 2900-RS-SETUP-COMMAREA.
129300*
129400****************************************************************
129500*  SET UP THE COMM AREA FIELDS AND TRANSFER TO THE NEXT        *
129600*  TRANS CTL PROGRAM.                                          *
129700****************************************************************
129800*
129900     PERFORM MB60PD-EDIT-PAGE-NBR
130000                                 THRU MB60PD-EPN-EXIT.
130100*
130200     MOVE MBCA-EIBAID            TO SS08WS-EIBAID.
130300*
130400     IF  SS08WS-VALID-PF-KEY
130500     OR  SS08WS-EIBAID-VALID-PF-KEY
130600         MOVE 99                 TO MBCA-SCREEN-NBR.
130700*
130800     IF  MX03-BEG-TC-L IS GREATER THAN ZERO
130900         MOVE ZERO               TO MBCA-MBMX-BEG-TXN-2
131000         MOVE ZERO               TO MBCA-MBMX-END-TXN-2
131100         IF  MX03-BEG-TC IS NUMERIC
131200             EVALUATE TRUE
131300                 WHEN MX03-BEG-TC IS GREATER THAN ZERO
131400                     COMPUTE MBCA-MBMX-BEG-TXN-2
131500                                 =  MX03-BEG-TC - 1
131600                     END-COMPUTE
131700                     COMPUTE MBCA-MBMX-END-TXN-2
131800                                 =  MX03-BEG-TC - 1
131900                     END-COMPUTE
132000                 WHEN OTHER
132100                     MOVE MX03-BEG-TC
132200                                 TO MBCA-MBMX-BEG-TXN-2
132300                     MOVE MX03-BEG-TC
132400                                 TO MBCA-MBMX-END-TXN-2
132500             END-EVALUATE.
132600*
132700     IF  MX03-BEG-TC-L IS GREATER THAN ZERO
132800         MOVE 53                 TO MBCA-SCREEN-NBR
132900         MOVE '03'               TO MBCA-TRANS-LOOP-CONTROL
133000         GO TO 2990-RS-SC-BYPASS.
133100*
133200     MOVE SPACES                 TO MBCA-TRANS-LOOP-CONTROL.
133300*
133400     IF  MBCA-PTI-FUNCTION-IS-ADD
133500         IF  MX03-TC-L (01) IS LESS THAN 1
133600         AND MX03-TC-L (02) IS LESS THAN 1
133700         AND MX03-TC-L (03) IS LESS THAN 1
133800             NEXT SENTENCE
133900         ELSE
134000             MOVE 53             TO MBCA-SCREEN-NBR.
134100*
134200     IF  MBCA-PTI-FUNCTION-IS-ADD
134300         GO TO 2990-RS-SC-BYPASS.
134400*
134500     IF  SS08WS-VALID-PF3
134600     OR  SS08WS-EIBAID-VALID-PF3
134700         MOVE 53                 TO MBCA-SCREEN-NBR
134800         MOVE ZERO               TO MBCA-MBMX-BEG-TXN-2
134900         MOVE ZERO               TO MBCA-MBMX-END-TXN-2
135000         MOVE '03'               TO MBCA-TRANS-LOOP-CONTROL.
135100*
135200     IF  SS08WS-VALID-PF4
135300     OR  SS08WS-EIBAID-VALID-PF4
135400         MOVE 53                 TO MBCA-SCREEN-NBR
135500         MOVE 999                TO MBCA-MBMX-BEG-TXN-2
135600         MOVE 999                TO MBCA-MBMX-END-TXN-2
135700         PERFORM 8000-FIND-TOP-OF-PAGE-SECT
135800         MOVE '03'               TO MBCA-TRANS-LOOP-CONTROL.
135900*
136000     IF  SS08WS-VALID-PF5
136100     OR  SS08WS-EIBAID-VALID-PF5
136200         MOVE 53                 TO MBCA-SCREEN-NBR
136300         MOVE '03'               TO MBCA-TRANS-LOOP-CONTROL.
136400*
136500     IF  SS08WS-VALID-PF6
136600     OR  SS08WS-EIBAID-VALID-PF6
136700         MOVE 53                 TO MBCA-SCREEN-NBR
136800         PERFORM 8000-FIND-TOP-OF-PAGE-SECT
136900         MOVE '03'               TO MBCA-TRANS-LOOP-CONTROL
137000         IF  MBCA-MBMX-END-TXN-2 IS GREATER THAN 1
137100             SUBTRACT 1          FROM MBCA-MBMX-END-TXN-2.
137200*
137300 2990-RS-SC-BYPASS.
137400*
137500     MOVE 'PC05'                 TO MBCA-PROGRAM-LOCATION.
137600     PERFORM MB70PD-XCTL-TO-MBOXCTL
137700                                 THRU MB70PD-XTM-EXIT.
137800*
137900 2999-RS-EXIT.
138000     EXIT.
138100/
138200 5000-BUILD-MAINT-SECT SECTION.
138300 5010-BM-BEGIN.
138400*
138500     MOVE 'SC03'                 TO MBCA-PROGRAM-LOCATION.
138600     SET MBIORO-GETMAIN          TO TRUE.
138700     PERFORM MML1AO-ACCESS       THRU MML1AO-ACCESS-EXIT.
138800*
138900     MOVE LOW-VALUES             TO MML1-RECORD.
139000     SET MML1-FILE-IS-MMTC       TO TRUE.
139100     MOVE MBCA-ORG               TO MML1-MMTC-ORG.
139200     MOVE MBCA-SIGNON-NAME       TO MML1-SIGNON-NAME.
139300     MOVE MBCA-TERMINAL-ID       TO MML1-TERMINAL-ID.
139400     MOVE MBCA-FIELD-SECURITY    TO MML1-FIELD-SECURITY.
139500     MOVE ZERO                   TO MML1-SOURCE-CODE.
139600*
139700     IF  MBCA-PTI-FUNCTION-IS-ADD
139800         GO TO 5100-BM-ADD-RECORDS.
139900*
140000     GO TO 5300-BM-MAINT-RECORDS.
140100*
140200 5100-BM-ADD-RECORDS.
140300*
140400     SET X-MX03-TC               TO 1.
140500*
140600 5210-BM-AR-LOOP.
140700*
140800     IF  X-MX03-TC IS GREATER THAN 3
140900         GO TO 5999-BM-EXIT.
141000*
141100     IF  MX03-TC-L (X-MX03-TC)
141200                                 IS GREATER THAN ZERO
141300     AND MX03-LM-L (X-MX03-TC)
141400                                 IS GREATER THAN ZERO
141500     AND MX03-RPT-DESC-L (X-MX03-TC)
141600                                 IS GREATER THAN ZERO
141700     AND MX03-GL-DR-ACCT-L (X-MX03-TC)
141800                                 IS GREATER THAN ZERO
141900     AND MX03-GL-DR-DESC-L (X-MX03-TC)
142000                                 IS GREATER THAN ZERO
142100     AND MX03-GL-CR-ACCT-L (X-MX03-TC)
142200                                 IS GREATER THAN ZERO
142300     AND MX03-GL-CR-DESC-L (X-MX03-TC)
142400                                 IS GREATER THAN ZERO
142500     AND MX03-DEFAULT-DESC-L (X-MX03-TC)
142600                                 IS GREATER THAN ZERO
142700         MOVE ZERO               TO MML1-FIELD-OCCURRENCE
142800         MOVE ZERO               TO MML1-FIELD-CODE
142900         MOVE MMTCIR-RECORD      TO MMTC-RECORD
143000         MOVE MBCA-ORG TO MMTC-ORG
143100         MOVE MX03-TC (X-MX03-TC)
143200                                 TO MMTC-TXN-CODE
143300         MOVE MX03-TC (X-MX03-TC)
143400                                 TO MML1-MMTC-TXN-CODE
143500         MOVE MX03-LM (X-MX03-TC)
143600                                 TO MMTC-LOGIC-MODULE
143700         SET  MMTC-ADD-COMPLETED TO TRUE
143800         MOVE MX03-RPT-DESC (X-MX03-TC)
143900                                 TO MMTC-RPT-DESC
144000         MOVE MX03-GL-DR-ACCT (X-MX03-TC)
144100                                 TO MMTC-GL-DR-ACCT
144200         MOVE MX03-GL-DR-DESC (X-MX03-TC)
144300                                 TO MMTC-GL-DR-DESC
144400         MOVE MX03-GL-CR-ACCT (X-MX03-TC)
144500                                 TO MMTC-GL-CR-ACCT
144600         MOVE MX03-GL-CR-DESC (X-MX03-TC)
144700                                 TO MMTC-GL-CR-DESC
144800         MOVE MX03-DEFAULT-DESC (X-MX03-TC)
144900                                 TO MMTC-DEFAULT-DESC
145000         SET MMTC-REC-USER-DEFINED
145100                                 TO TRUE
145200         MOVE MBCA-START-DATE    TO MMTC-LAST-MAINT-DATE
145300         MOVE LENGTH OF MMTC-RECORD
145400                                 TO MML1-VARIABLE-LENGTH
145500         MOVE MMTC-RECORD        TO MML1-ADD-AREA
145600         MOVE MMTC-KEY           TO MBIOWS-MMTC-KEY
145700         MOVE SS08WS-CICS-FC-NOTFND TO MBIORO-TEMP-STATUS-1
145800         MOVE 'FC06'             TO MBCA-PROGRAM-LOCATION
145900         SET MBIORO-READ-RANDOM-UPDATE
146000                                 TO TRUE
146100         PERFORM MMTCAO-ACCESS   THRU MMTCAO-ACCESS-EXIT
146200         MOVE MML1-ADD-AREA      TO MMTC-RECORD
146300         IF  SS08WS-RC-FC-NOTFND
146400             PERFORM 5800-BM-WRITE-L1
146500                                 THRU 5899-BM-WL1-EXIT
146600             MOVE 'FC07'         TO MBCA-PROGRAM-LOCATION
146700             SET MBIORO-WRITE    TO TRUE
146800             PERFORM MMTCAO-ACCESS
146900                                 THRU MMTCAO-ACCESS-EXIT
147000         ELSE
147100             MOVE 0100           TO MML1-FIELD-CODE
147200             PERFORM 5800-BM-WRITE-L1
147300                                 THRU 5899-BM-WL1-EXIT
147400             MOVE 'FC08'         TO MBCA-PROGRAM-LOCATION
147500             SET MBIORO-REWRITE  TO TRUE
147600             PERFORM MMTCAO-ACCESS
147700                                 THRU MMTCAO-ACCESS-EXIT.
147800*
147900     SET X-MX03-TC               UP BY 1.
148000     GO TO 5210-BM-AR-LOOP.
148100*
148200*
148300*
148400 5300-BM-MAINT-RECORDS.
148500*
148600     SET X-MX03-TC               TO 1.
148700*
148800 5310-BM-MR-LOOP.
148900*
149000     IF  X-MX03-TC IS GREATER THAN 3
149100         GO TO 5999-BM-EXIT.
149200*
149300     SET X-MBCA-MBMX             TO X-MX03-TC.
149400*
149500     IF  MBCA-MBMX-TXN-CODE (X-MBCA-MBMX) IS EQUAL TO ZERO
149600         GO TO 5999-BM-EXIT.
149700*
149800     MOVE MBCA-ORG               TO MBIOWS-MMTC-ORG.
149900     MOVE MBCA-MBMX-TXN-CODE (X-MBCA-MBMX)
150000                                 TO MBIOWS-MMTC-TXN-CODE.
150100     MOVE MBCA-MBMX-TXN-CODE (X-MBCA-MBMX)
150200                                 TO MML1-MMTC-TXN-CODE.
150300     MOVE 'FC09'                 TO MBCA-PROGRAM-LOCATION.
150400     SET MBIORO-READ-RANDOM-UPDATE
150500                                 TO TRUE.
150600     PERFORM MMTCAO-ACCESS       THRU MMTCAO-ACCESS-EXIT.
150700*
150800     IF  MX03-LM-L (X-MX03-TC)   IS GREATER THAN ZERO
150900     AND
151000        (MMTC-REC-USER-DEFINED
151100     OR  MMTC-REC-PURGED)
151200         MOVE ZERO               TO MML1-FIELD-OCCURRENCE
151300         MOVE 0301               TO MML1-FIELD-CODE
151400         MOVE MMTC-LOGIC-MODULE  TO MML1-VL03-B-DATA-9
151500         MOVE MX03-LM (X-MX03-TC)
151600                                 TO MMTC-LOGIC-MODULE
151700         MOVE MMTC-LOGIC-MODULE  TO MML1-VL03-A-DATA-9
151800         MOVE MML1WS-VL-03       TO MML1-VARIABLE-LENGTH
151900         PERFORM 5800-BM-WRITE-L1
152000                                 THRU 5899-BM-WL1-EXIT.
152100*
152200     IF  MX03-RPT-DESC-L (X-MX03-TC)
152300                                 IS GREATER THAN ZERO
152400         MOVE ZERO               TO MML1-FIELD-OCCURRENCE
152500         MOVE 0302               TO MML1-FIELD-CODE
152600         MOVE MMTC-RPT-DESC      TO MML1-VL20-B-DATA-X
152700         MOVE MX03-RPT-DESC (X-MX03-TC)
152800                                 TO MMTC-RPT-DESC
152900         MOVE MMTC-RPT-DESC      TO MML1-VL20-A-DATA-X
153000         MOVE MML1WS-VL-20       TO MML1-VARIABLE-LENGTH
153100         PERFORM 5800-BM-WRITE-L1
153200                                 THRU 5899-BM-WL1-EXIT.
153300*
153400     IF  MX03-GL-DR-ACCT-L (X-MX03-TC)
153500                                 IS GREATER THAN ZERO
153600         MOVE ZERO               TO MML1-FIELD-OCCURRENCE
153700         MOVE 0303               TO MML1-FIELD-CODE
153800         MOVE MMTC-GL-DR-ACCT    TO MML1-VL20-B-DATA-X
153900         MOVE MX03-GL-DR-ACCT (X-MX03-TC)
154000                                 TO MMTC-GL-DR-ACCT
154100         MOVE MMTC-GL-DR-ACCT    TO MML1-VL20-A-DATA-X
154200         MOVE MML1WS-VL-20       TO MML1-VARIABLE-LENGTH
154300         PERFORM 5800-BM-WRITE-L1
154400                                 THRU 5899-BM-WL1-EXIT.
154500*
154600     IF  MX03-GL-DR-DESC-L (X-MX03-TC)
154700                                 IS GREATER THAN ZERO
154800         MOVE ZERO               TO MML1-FIELD-OCCURRENCE
154900         MOVE 0304               TO MML1-FIELD-CODE
155000         MOVE MMTC-GL-DR-DESC    TO MML1-VL20-B-DATA-X
155100         MOVE MX03-GL-DR-DESC (X-MX03-TC)
155200                                 TO MMTC-GL-DR-DESC
155300         MOVE MMTC-GL-DR-DESC    TO MML1-VL20-A-DATA-X
155400         MOVE MML1WS-VL-20       TO MML1-VARIABLE-LENGTH
155500         PERFORM 5800-BM-WRITE-L1
155600                                 THRU 5899-BM-WL1-EXIT.
155700*
155800     IF  MX03-GL-CR-ACCT-L (X-MX03-TC)
155900                                 IS GREATER THAN ZERO
156000         MOVE ZERO               TO MML1-FIELD-OCCURRENCE
156100         MOVE 0305               TO MML1-FIELD-CODE
156200         MOVE MMTC-GL-CR-ACCT    TO MML1-VL20-B-DATA-X
156300         MOVE MX03-GL-CR-ACCT (X-MX03-TC)
156400                                 TO MMTC-GL-CR-ACCT
156500         MOVE MMTC-GL-CR-ACCT    TO MML1-VL20-A-DATA-X
156600         MOVE MML1WS-VL-20       TO MML1-VARIABLE-LENGTH
156700         PERFORM 5800-BM-WRITE-L1
156800                                 THRU 5899-BM-WL1-EXIT.
156900*
157000     IF  MX03-GL-CR-DESC-L (X-MX03-TC)
157100                                 IS GREATER THAN ZERO
157200         MOVE ZERO               TO MML1-FIELD-OCCURRENCE
157300         MOVE 0306               TO MML1-FIELD-CODE
157400         MOVE MMTC-GL-CR-DESC    TO MML1-VL20-B-DATA-X
157500         MOVE MX03-GL-CR-DESC (X-MX03-TC)
157600                                 TO MMTC-GL-CR-DESC
157700         MOVE MMTC-GL-CR-DESC    TO MML1-VL20-A-DATA-X
157800         MOVE MML1WS-VL-20       TO MML1-VARIABLE-LENGTH
157900         PERFORM 5800-BM-WRITE-L1
158000                                 THRU 5899-BM-WL1-EXIT.
158100*
158200     IF  MX03-DEFAULT-DESC-L (X-MX03-TC)
158300                                 IS GREATER THAN ZERO
158400         MOVE ZERO               TO MML1-FIELD-OCCURRENCE
158500         MOVE 0307               TO MML1-FIELD-CODE
158600         MOVE MMTC-DEFAULT-DESC TO MML1-VL40-B-DATA-X
158700         MOVE MX03-DEFAULT-DESC (X-MX03-TC)
158800                                 TO MMTC-DEFAULT-DESC
158900         MOVE MMTC-DEFAULT-DESC TO MML1-VL40-A-DATA-X
159000         MOVE MML1WS-VL-40       TO MML1-VARIABLE-LENGTH
159100         PERFORM 5800-BM-WRITE-L1
159200                                 THRU 5899-BM-WL1-EXIT.
159300*
159400     MOVE MX03-LM (X-MX03-TC)    TO MMTCWS-LOGIC-MODULE.
159500*
159600     IF  MX03-LM-L (X-MX03-TC)   IS GREATER THAN ZERO
159700     AND MMTCWS-LM-VALID-DELETE
159800     AND
159900        (MMTC-REC-USER-DEFINED
160000     OR  MMTC-REC-PURGED)
160100         MOVE ZERO               TO MML1-FIELD-OCCURRENCE
160200         MOVE 0308               TO MML1-FIELD-CODE
160300         MOVE MMTC-REC-STATUS    TO MML1-VL01-B-DATA-9
160400         SET  MMTC-REC-PURGED    TO TRUE
160500         MOVE MMTC-REC-STATUS    TO MML1-VL01-A-DATA-9
160600         MOVE MML1WS-VL-01       TO MML1-VARIABLE-LENGTH
160700         PERFORM 5800-BM-WRITE-L1
160800                                 THRU 5899-BM-WL1-EXIT.
160900*
161000     IF  MX03-LM-L (X-MX03-TC)   IS GREATER THAN ZERO
161100     AND
161200        (MMTC-REC-USER-DEFINED
161300     OR  MMTC-REC-PURGED)
161400         IF  MMTCWS-LM-VALID-DELETE
161500             NEXT SENTENCE
161600         ELSE
161700             MOVE ZERO           TO MML1-FIELD-OCCURRENCE
161800             MOVE 0308           TO MML1-FIELD-CODE
161900             MOVE MMTC-REC-STATUS
162000                                 TO MML1-VL01-B-DATA-9
162100             SET MMTC-REC-USER-DEFINED
162200                                 TO TRUE
162300             MOVE MMTC-REC-STATUS
162400                                 TO MML1-VL01-A-DATA-9
162500             MOVE MML1WS-VL-01   TO MML1-VARIABLE-LENGTH
162600             PERFORM 5800-BM-WRITE-L1
162700                                 THRU 5899-BM-WL1-EXIT.
162800*
162900     IF  WS-UPD-SW IS EQUAL TO 'Y'
163000     AND
163100        (MX03-LM-L (X-MX03-TC)
163200                                 IS GREATER THAN ZERO
163300     OR  MX03-RPT-DESC-L (X-MX03-TC)
163400                                 IS GREATER THAN ZERO
163500     OR  MX03-GL-DR-ACCT-L (X-MX03-TC)
163600                                 IS GREATER THAN ZERO
163700     OR  MX03-GL-DR-DESC-L (X-MX03-TC)
163800                                 IS GREATER THAN ZERO
163900     OR  MX03-GL-CR-ACCT-L (X-MX03-TC)
164000                                 IS GREATER THAN ZERO
164100     OR  MX03-GL-CR-DESC-L (X-MX03-TC)
164200                                 IS GREATER THAN ZERO
164300     OR  MX03-DEFAULT-DESC-L (X-MX03-TC)
164400                                 IS GREATER THAN ZERO)
164500         MOVE ZERO               TO MML1-FIELD-OCCURRENCE
164600         MOVE 0199               TO MML1-FIELD-CODE
164700         MOVE MMTC-LAST-MAINT-DATE
164800                                 TO MML1-VL07-B-DATA-9
164900         MOVE MBCA-START-DATE    TO MMTC-LAST-MAINT-DATE
165000         MOVE MMTC-LAST-MAINT-DATE
165100                                 TO MML1-VL07-A-DATA-9
165200         MOVE MML1WS-VL-07       TO MML1-VARIABLE-LENGTH
165300         PERFORM 5800-BM-WRITE-L1
165400                                 THRU 5899-BM-WL1-EXIT
165500         MOVE 0198               TO MML1-FIELD-CODE
165600         MOVE MML1WS-VL-03       TO MML1-VARIABLE-LENGTH
165700         MOVE MMTC-LAST-MAINT-OPER
165800                                 TO MML1-VL03-B-DATA-X
165900         MOVE MBCA-OPERATOR-ID   TO MMTC-LAST-MAINT-OPER
166000         MOVE MMTC-LAST-MAINT-OPER
166100                                 TO MML1-VL03-A-DATA-X
166200         PERFORM 5800-BM-WRITE-L1
166300                                 THRU 5899-BM-WL1-EXIT.
166400*
166500     IF  WS-UPD-SW IS EQUAL TO 'Y'
166600     AND
166700        (MX03-LM-L (X-MX03-TC)
166800                                 IS GREATER THAN ZERO
166900     OR  MX03-RPT-DESC-L (X-MX03-TC)
167000                                 IS GREATER THAN ZERO
167100     OR  MX03-GL-DR-ACCT-L (X-MX03-TC)
167200                                 IS GREATER THAN ZERO
167300     OR  MX03-GL-DR-DESC-L (X-MX03-TC)
167400                                 IS GREATER THAN ZERO
167500     OR  MX03-GL-CR-ACCT-L (X-MX03-TC)
167600                                 IS GREATER THAN ZERO
167700     OR  MX03-GL-CR-DESC-L (X-MX03-TC)
167800                                 IS GREATER THAN ZERO
167900     OR  MX03-DEFAULT-DESC-L (X-MX03-TC)
168000                                 IS GREATER THAN ZERO)
168100         SET MBIORO-REWRITE      TO TRUE
168200     ELSE
168300         SET MBIORO-UNLOCK       TO TRUE.
168400*
168500     MOVE 'FC10'                 TO MBCA-PROGRAM-LOCATION.
168600     PERFORM MMTCAO-ACCESS       THRU MMTCAO-ACCESS-EXIT.
168700*
168800     SET X-MX03-TC               UP BY 1.
168900     GO TO 5310-BM-MR-LOOP.
169000*
169100*
169200*
169300 5800-BM-WRITE-L1.
169400*
169500     MOVE 'FC11'                 TO MBCA-PROGRAM-LOCATION.
169600     SET MBIORO-WRITE            TO TRUE.
169700     PERFORM MML1AO-ACCESS       THRU MML1AO-ACCESS-EXIT.
169800     MOVE ZERO                   TO MML1-FIELD-OCCURRENCE.
169900     MOVE ZERO                   TO MML1-FIELD-OCCURRENCE-2.
170000     MOVE ZERO                   TO MML1-FIELD-CODE.
170100     MOVE ZERO                   TO MML1-VARIABLE-LENGTH.
170200     MOVE LOW-VALUES             TO MML1-VARIABLE-AREA.
170300     MOVE 'Y'                    TO WS-UPD-SW.
170400*
170500 5899-BM-WL1-EXIT.
170600     EXIT.
170700*
170800*
170900*
171000 5999-BM-EXIT.
171100     EXIT.
171200/
171300 8000-FIND-TOP-OF-PAGE-SECT SECTION.
171400 8010-FTOP-BEGIN.
171500*****************************************************************
171600*    THE PURPOSE OF THIS ROUTINE IS TO FIND THE FIRST RECORD    *
171700*    WHICH IS TO APPEAR ON THE SCREEN WHEN SPECIFICALLY         *
171800*    SCROLLING BACKWARDS.                                       *
171900*****************************************************************
172000*    START THE FILE USING THE BEGINNING TRANSACTION CODE FOR    *
172100*    SCREEN 2 (LOCATED IN THE COMMAREA).                        *
172200*****************************************************************
172300*
172400     MOVE 'FC12'                 TO MBCA-PROGRAM-LOCATION.
172500     MOVE MBCA-ORG               TO MBIOWS-MMTC-ORG.
172600     MOVE MBCA-MBMX-BEG-TXN-2    TO MBIOWS-MMTC-TXN-CODE.
172700     SET MBIORO-STARTBR-GTE      TO TRUE.
172800     PERFORM MMTCAO-ACCESS       THRU MMTCAO-ACCESS-EXIT.
172900*
173000*****************************************************************
173100*    DO A READ NEXT OF THE FIRST RECORD.  THEN DO A READ PREV   *
173200*    TO POSITION THE FILE TO THE CORRECT PLACE.                 *
173300*****************************************************************
173400*
173500     MOVE 'FC13'                 TO MBCA-PROGRAM-LOCATION.
173600     SET MBIORO-READ-SEQ         TO TRUE.
173700     PERFORM MMTCAO-ACCESS       THRU MMTCAO-ACCESS-EXIT.
173800     MOVE 'FC14'                 TO MBCA-PROGRAM-LOCATION.
173900     SET MBIORO-READ-PREV        TO TRUE.
174000     PERFORM MMTCAO-ACCESS       THRU MMTCAO-ACCESS-EXIT.
174100*
174200     MOVE ZERO                   TO WS-READ-COUNT.
174300*
174400*****************************************************************
174500*    DO A READ PREVIOUS UNTIL 3 CONSECUTIVE READS ARE DONE OR   *
174600*    THE ORG NUMBER CHANGES.                                    *
174700*****************************************************************
174800 8020-FTOP-READ-LOOP.
174900*
175000     MOVE 'FC15'                 TO MBCA-PROGRAM-LOCATION.
175100     SET MBIORO-READ-PREV        TO TRUE.
175200     PERFORM MMTCAO-ACCESS       THRU MMTCAO-ACCESS-EXIT.
175300*
175400     IF  MBCA-ORG IS NOT EQUAL TO MMTC-ORG
175500         MOVE ZERO               TO MBCA-MBMX-BEG-TXN-2
175600         MOVE ZERO               TO MBCA-MBMX-END-TXN-2
175700         GO TO 8090-FTOP-ENDBR.
175800*
175900     ADD 1                       TO WS-READ-COUNT.
176000*
176100     IF  WS-READ-COUNT IS GREATER THAN 3
176200         GO TO 8090-FTOP-ENDBR.
176300*
176400     MOVE MMTC-TXN-CODE          TO MBCA-MBMX-BEG-TXN-2.
176500     MOVE MMTC-TXN-CODE          TO MBCA-MBMX-END-TXN-2.
176600     GO TO 8020-FTOP-READ-LOOP.
176700*
176800 8090-FTOP-ENDBR.
176900*
177000     MOVE 'FC16'                 TO MBCA-PROGRAM-LOCATION.
177100     SET MBIORO-ENDBR            TO TRUE.
177200     PERFORM MMTCAO-ACCESS       THRU MMTCAO-ACCESS-EXIT.
177300*
177400 8099-FTOP-EXIT.
177500     EXIT.
177600/
177700 9900-PERFORMED-ROUTINES-SECT SECTION.
177800 9500-EDIT-LOGIC-MODULE.
177900*
178000     MOVE 'N'                    TO WS-WORK-LM-SW.
178100*
178200     IF  MX03-LM (X-MX03-TC)     IS NOT NUMERIC
178300         GO TO 9599-ELM-EXIT.
178400*
178500     MOVE MX03-LM (X-MX03-TC)    TO MMTCWS-LOGIC-MODULE.
178600*
178700     IF  MMTCWS-LM-VALID-DELETE
178800         IF  MBCA-PTI-FUNCTION-IS-ADD
178900             GO TO 9599-ELM-EXIT.
179000*
179100     IF  MMTCWS-LM-VALID-LOGIC-MODULES
179200     OR  MMTCWS-LM-VALID-DELETE
179300         MOVE 'Y'                TO WS-WORK-LM-SW.
179400*
179500 9599-ELM-EXIT.
179600     EXIT.
179700/
179800     COPY SS26PD.
179900/
180000     COPY SS27PD.
180100/
180200     COPY SS08PD.
180300/
180400     COPY SS15PD.
180500/
180600     COPY MMTCAO.
180700/
180800     COPY MML1AO.
180900/
181000     COPY MB60PD REPLACING 'MBMAPXX' BY 'MBMX03 '
181100                           MBMAPXXI BY MBMX03I
181200                           MBMAPXXO BY MBMX03O.
181300/
181400     COPY MB70PD.
181500/
181600     COPY SMFTPXO.
