000100 IDENTIFICATION DIVISION.
000200 PROGRAM-ID. MBOMY01.
000201*       RELEASE DATE=08/24/01.        REVISION LEVEL=08.06      *
000202*****************************************************************
000203*WARNING.  THIS COMPUTER PROGRAM IS PROTECTED BY COPYRIGHT LAW  *
000204*AND INTERNATIONAL TREATIES.  UNAUTHORIZED REPRODUCTION OR      *
000205*DISTRIBUTION OF THIS PROGRAM, OR ANY PORTION OF IT, MAY RESULT *
000206*IN SEVERE CIVIL AND CRIMINAL PENATLIES, AND WILL BE PROSECUTED *
000207*TO THE MAXIMUM EXTENT POSSIBLE UNDER THE LAW.                  *
000208*COPYRIGHT 1999 PAYSYS INTERNATIONAL, INC.  ALL RIGHTS RESERVED.*
000209*****************************************************************
000300*****************************************************************
000400*                                                               *
000500*   V - PLUS  M E R C H A N T   B A N K C A R D   S Y S T E M   *
000600*                                                               *
000700*      MBOMY01 - ON-LINE SYSTEM RECORD MAINTENANCE/INQUIRY      *
000800*                SCREEN 01                                      *
000900*                                                               *
001000*              1. TRANSIDS                                      *
001100*                 A. MBMS                                       *
001200*                 B. MBQS                                       *
001300*              2. MAPS USED -                                   *
001400*                 A. MBMY01 (SYSTEM MAP 01)                     *
001500*              3. FILES USED -                                  *
001600*                 A. MMSC   (SYSTEM CONTROL FILE)               *
001700*                 B. MML1   (LOG/JOURNAL FILE)                  *
001800*                                                               *
001900*****************************************************************
002000*
002100 ENVIRONMENT DIVISION.
002200 DATA DIVISION.
002300 WORKING-STORAGE SECTION.
002400 01  FILLER                  PIC  X(12)      VALUE '** WS-BEG **'.
002500*         I/O REQUEST BLOCK WORK AREAS
002600     COPY MBIOWS.
002700/         I/O REQUEST BLOCK
002800     COPY MBIORO.
002900/         LOG/JOURNAL WORK AREAS
003000     COPY MML1WS REPLACING ==:MML1:== BY ==MML1==.
003100/         DATE WORK AREAS
003200     COPY SS01WS.
003300/         ONLINE WORK AREAS
003400     COPY SS08WS.
003500/
003600     COPY SS00WS.
003700/
003800     COPY SMFTWS.
003900/
004000     COPY SMPTRL REPLACING ==:SMPT:== BY ==SMPT==.
004100/
004200     COPY MB61LK.
004300/
004400     COPY SS83WS.
004500/
004600 01  WS-WORK-AREAS.
004700     03  WS-INDEX            PIC S9(04)      BINARY.
004800     03  WS-SAVE-EIBAID      PIC  X(01)      VALUE SPACES.
004900     03  WS-UPDATE-SW        PIC  X(01)      VALUE 'N'.
005000         88  WS-UPDATE-SW-NO                 VALUE 'N'.
005100         88  WS-UPDATE-SW-YES                VALUE 'Y'.
005200     03  WS-ACCR-THRU-DATE   PIC S9(07)      VALUE ZEROS.
005300     03  WS-NEXT-PROC-DATE   PIC S9(07)      VALUE ZEROS.
005400*
005500 01  WS-DATE-WORK.
005600     03  WS-DW-MM            PIC  9(02).
005700     03  WS-DW-DD            PIC  9(02).
005800 01  WS-WEEK-SWITCHES.
005900     03  WS-MISC-SW          PIC  X(01)      VALUE 'N'.
006000         88  WS-MISC-SW-NO                   VALUE 'N'.
006100         88  WS-MISC-SW-YES                  VALUE 'Y'.
006200     03  WS-GOOD-WORK-WEEK   PIC  X(01)      VALUE 'Y'.
006300         88  VALID-WEEK                      VALUE 'Y'.
006400         88  INVALID-WEEK                    VALUE 'N'.
006500     03  WS-GOOD-WORK-WEEK   PIC  X(01)      VALUE 'N'.
006600         88  WS-WORK-WEEK-OPEN               VALUE 'Y'.
006700         88  WS-WORK-WEEK-CLOSED             VALUE 'N'.
006800 01  FILLER                  PIC  X(12)      VALUE '** WS-END **'.
006900/
007000 LINKAGE SECTION.
007100 01  DFHCOMMAREA.
007200     COPY MB60WS.
007300/         SYSTEM SCREEN 01 MAP DSECT
007400     COPY MBMY01.
007500/         SYSTEM SCREEN 01 MAP REDEFINITION
007600     COPY MBMY01R.
007700/         SYSTEM CONTROL FILE RECORD LAYOUT
007800     COPY MMSCRL.
007900/         LOG/JOURNAL FILE RECORD LAYOUT
008000     COPY MML1RL REPLACING ==:MML1:== BY ==MML1==.
008100/
008200     COPY SMFTRL REPLACING ==:SMFT:== BY ==SMFT==.
008300/
008400 PROCEDURE DIVISION.
008500 0000-HOUSEKEEPING SECTION.
008600 0100-INIT.
008700*
008800     MOVE MBCA-EIBAID            TO WS-SAVE-EIBAID.
008900     SET MBCA-EIBAID-ENTER       TO TRUE.
009000*
009100     MOVE 'PC02'                 TO MBCA-PROGRAM-LOCATION.
009200     PERFORM MB70PD-ON-LINE-HOUSEKEEPING
009300                                 THRU MB70PD-OLH-EXIT.
009400*
009500     MOVE WS-SAVE-EIBAID         TO MBCA-EIBAID.
009600     MOVE MBIOWS-MMSC-KEY-CODE   TO MBCA-KEY-CODE.
009700*
009800     IF  MBCA-RECEIVE-SCREEN
009900         GO TO 2000-RECEIVE-SCREEN.
010000/
010100 1000-SEND-SCREEN SECTION.
010200*
010300****************************************************************
010400*    THIS SECTION BUILDS AND SENDS THE 01 SCREEN.              *
010500****************************************************************
010600*
010700     MOVE 01                     TO MBCA-SCREEN-NBR.
010800*
010900****************************************************************
011000*    GET CICS STORAGE NEEDED FOR THE MAP                       *
011100****************************************************************
011200*
011300     MOVE 'SC01'                 TO MBCA-PROGRAM-LOCATION.
011400     PERFORM MB60PD-GETMAIN-FOR-MAP
011500                                 THRU MB60PD-GFM-EXIT.
011600*
011700****************************************************************
011800*    INITIALIZE THE STANDARD MAP LINES                         *
011900****************************************************************
012000*
012100     PERFORM MB60PD-INIT-STD-MAP-LINES
012200                                 THRU MB60PD-ISML-EXIT.
012300*
012400****************************************************************
012500*    READ THE SYSTEM RECORD                                    *
012600****************************************************************
012700*
012800     MOVE 'FC01'                 TO MBCA-PROGRAM-LOCATION.
012900     MOVE ZEROES                 TO MBIOWS-MMSC-KEY.
013000     SET MBIORO-READ-RANDOM      TO TRUE.
013100     PERFORM MMSCAO-ACCESS       THRU MMSCAO-ACCESS-EXIT.
013200/
013300 1100-BUILD-SCREEN.
013400*
013500****************************************************************
013600*    BUILD THE MAP FROM THE MBS SYSTEM RECORD.                 *
013700****************************************************************
013800*
013900     MOVE MMSC-PROC-CENTER-ID    TO MY01-CENTER-NAME.
014000     MOVE MMSC-SCREEN-HEADER     TO MY01-SCREEN-TITLE.
014100     MOVE MMSC-WORK-WEEK-R (1)   TO MY01-WORK-WEEK (1).
014200     MOVE MMSC-WORK-WEEK-R (2)   TO MY01-WORK-WEEK (2).
014300     MOVE MMSC-WORK-WEEK-R (3)   TO MY01-WORK-WEEK (3).
014400     MOVE MMSC-WORK-WEEK-R (4)   TO MY01-WORK-WEEK (4).
014500     MOVE MMSC-WORK-WEEK-R (5)   TO MY01-WORK-WEEK (5).
014600     MOVE MMSC-WORK-WEEK-R (6)   TO MY01-WORK-WEEK (6).
014700     MOVE MMSC-WORK-WEEK-R (7)   TO MY01-WORK-WEEK (7).
014800*
014900     IF  MMSC-DATE-LAST-PROC    IS NOT EQUAL TO ZEROES
015000         MOVE DFHBMASK           TO MY01-DATE-ACCRUED-THRU-A
015100                                    MY01-DATE-NEXT-PROC-A
015200         MOVE DFHBMDAS           TO MY01-DATE-ACCRUED-THRU-LP-A
015300                                    MY01-DATE-ACCRUED-THRU-RP-A
015400                                    MY01-DATE-NEXT-PROC-LP-A
015500                                    MY01-DATE-NEXT-PROC-RP-A.
015600*
015700     SET X-SYS-HOLIDAY           TO 1.
015800*
015900 1200-BUILD-SCREEN-LOOP.
016000*
016100     SET X-MMSC-HOL              TO X-SYS-HOLIDAY.
016200*
016300     IF  MMSC-HOLIDAYS    (X-MMSC-HOL)    IS NOT EQUAL TO ZEROES
016400     OR  MBCA-PTI-FUNCTION-IS-INQUIRY
016500         MOVE MMSC-HOLIDAYS    (X-MMSC-HOL)
016600                                 TO SS01WS-JULIAN
016700         PERFORM SS08PD-JUL-TO-GREG
016800                                 THRU SS08PD-JTG-EXIT
016900         MOVE SS01WS-DATE        TO MY01-HOLIDAY (X-SYS-HOLIDAY).
017000*
017100     IF  X-SYS-HOLIDAY IS LESS THAN 25
017200         SET X-SYS-HOLIDAY       UP BY 1
017300         GO TO 1200-BUILD-SCREEN-LOOP.
017400*
017500     MOVE MMSC-TODAYS-JULIAN     TO SS01WS-JULIAN.
017600     PERFORM SS08PD-JUL-TO-GREG  THRU SS08PD-JTG-EXIT.
017700     MOVE SS01WS-DATE            TO MY01-DATE-LAST-PROC.
017800*
017900     IF  MMSC-ACCR-THRU-DATE    IS NOT EQUAL TO ZEROES
018000     OR  MBCA-PTI-FUNCTION-IS-INQUIRY
018100         MOVE MMSC-ACCR-THRU-DATE
018200                                 TO SS01WS-JULIAN
018300         PERFORM SS08PD-JUL-TO-GREG
018400                                 THRU SS08PD-JTG-EXIT
018500         MOVE SS01WS-DATE        TO MY01-DATE-ACCRUED-THRU.
018600*
018700     IF  MMSC-DATE-NEXT-PROC    IS NOT EQUAL TO ZEROES
018800     OR  MBCA-PTI-FUNCTION-IS-INQUIRY
018900         MOVE MMSC-DATE-NEXT-PROC
019000                                 TO SS01WS-JULIAN
019100         PERFORM SS08PD-JUL-TO-GREG
019200                                 THRU SS08PD-JTG-EXIT
019300         MOVE SS01WS-DATE        TO MY01-DATE-NEXT-PROC.
019400/
019500     IF  MMSC-LAST-MAINT-DATE    IS NOT EQUAL TO ZEROES
019600     OR  MBCA-PTI-FUNCTION-IS-INQUIRY
019700         MOVE MMSC-LAST-MAINT-DATE
019800                                 TO SS01WS-JULIAN
019900         PERFORM SS26PD-NUMERICALLY-EDIT-DATE
020000                                 THRU SS26PD-NED-EXIT
020100         MOVE SS01WS-XX-XX-YYYY  TO MY01-LAST-MAINT-DATE
020200         MOVE MMSC-LAST-MAINT-OPER
020300                                 TO MY01-LAST-MAINT-OPER.
020400*
020500/
020600****************************************************************
020700*    IF INQUIRY, DARKEN PARENS AND ASKIP FIELDS                *
020800****************************************************************
020900*
021000     MOVE SS08WS-CURSOR          TO MY01-CENTER-NAME-L.
021100*
021200     IF  MBCA-PTI-FUNCTION-IS-INQUIRY
021300         MOVE SS08WS-CURSOR      TO MY01-ALT-TRANID-L
021400         MOVE DFHBMASB           TO MY01-CENTER-NAME-A
021500                                    MY01-SCREEN-TITLE-A
021600                                    MY01-WORK-WEEK-A (1)
021700                                    MY01-WORK-WEEK-A (2)
021800                                    MY01-WORK-WEEK-A (3)
021900                                    MY01-WORK-WEEK-A (4)
022000                                    MY01-WORK-WEEK-A (5)
022100                                    MY01-WORK-WEEK-A (6)
022200                                    MY01-WORK-WEEK-A (7)
022300                                    MY01-DATE-LAST-PROC-A
022400                                    MY01-DATE-ACCRUED-THRU-A
022500                                    MY01-DATE-NEXT-PROC-A
022600         MOVE DFHBMDAS           TO MY01-CENTER-NAME-LP-A
022700                                    MY01-CENTER-NAME-RP-A
022800                                    MY01-SCREEN-TITLE-LP-A
022900                                    MY01-SCREEN-TITLE-RP-A
023000                                    MY01-WORK-WEEK-LP-A
023100                                    MY01-WORK-WEEK-RP-A
023200                                    MY01-DATE-ACCRUED-THRU-LP-A
023300                                    MY01-DATE-ACCRUED-THRU-RP-A
023400                                    MY01-DATE-NEXT-PROC-LP-A
023500                                    MY01-DATE-NEXT-PROC-RP-A
023600         PERFORM 9300-HOLIDAY-ATTRIBUTES
023700                                 THRU 9399-HA-EXIT.
023800*
023900****************************************************************
024000*    SEND THE MAP                                              *
024100****************************************************************
024200*
024300     MOVE 'BM01'                 TO MBCA-PROGRAM-LOCATION.
024400     PERFORM MB60PD-SEND-MAP-WITH-ERASE
024500                                 THRU MB60PD-SMWE-EXIT.
024600*
024700****************************************************************
024800*    RETURN TO CICS                                            *
024900****************************************************************
025000*
025100     MOVE 'PC04'                 TO MBCA-PROGRAM-LOCATION.
025200     PERFORM MB70PD-RETURN-TRANS-ID
025300                                 THRU MB70PD-RTI-EXIT.
025400/
025500 2000-RECEIVE-SCREEN SECTION.
025600*
025700****************************************************************
025800*    THIS SECTION RECEIVES THE FIRST SCREEN                    *
025900****************************************************************
026000*
026100     IF  MBCA-EIBAID-CLEAR
026200         MOVE 98                 TO MBCA-SCREEN-NBR
026300         MOVE 'PC03'             TO MBCA-PROGRAM-LOCATION
026400         PERFORM MB70PD-ON-LINE-HOUSEKEEPING
026500                                 THRU MB70PD-OLH-EXIT.
026600*
026700     MOVE 'BM02'                 TO MBCA-PROGRAM-LOCATION.
026800     PERFORM MB60PD-RECEIVE-MAP  THRU MB60PD-RM-EXIT.
026900*
027000****************************************************************
027100*    CHECK FOR ANOTHER TRANSACTION ID ENTERED BY THE USER      *
027200****************************************************************
027300*
027400     MOVE 'PC05'                 TO MBCA-PROGRAM-LOCATION.
027500     PERFORM MB60PD-NEW-TRANS-ROUTINE
027600                                 THRU MB60PD-NTR-EXIT.
027700*
027800****************************************************************
027900*    BYPASS EDITS ON INQUIRY                                   *
028000****************************************************************
028100*
028200     IF  MBCA-PTI-FUNCTION-IS-INQUIRY
028300         GO TO 2600-SETUP-COMMAREA.
028400*
028500****************************************************************
028600*    READ THE SYSTEM CONTROL FILE                              *
028700****************************************************************
028800*
028900     MOVE 'FC02'                 TO MBCA-PROGRAM-LOCATION.
029000     MOVE ZEROES                 TO MBIOWS-MMSC-KEY.
029100     SET MBIORO-READ-RANDOM      TO TRUE.
029200     PERFORM MMSCAO-ACCESS       THRU MMSCAO-ACCESS-EXIT.
029300*
029400****************************************************************
029500*    EDIT FIELDS                                               *
029600****************************************************************
029700*            ***** CENTER NAME *****                           *
029800*
029900     IF  MY01-CENTER-NAME-L IS LESS THAN 1
030000         MOVE DFHBMASK           TO MY01-CENTER-NAME-A
030100         MOVE DFHBMDAS           TO MY01-CENTER-NAME-LP-A
030200                                    MY01-CENTER-NAME-RP-A
030300         MOVE MMSC-PROC-CENTER-ID
030400                                 TO MY01-CENTER-NAME
030500     ELSE
030600         MOVE DFHBMASF           TO MY01-CENTER-NAME-A
030700         MOVE DFHBMDAS           TO MY01-CENTER-NAME-LP-A
030800                                    MY01-CENTER-NAME-RP-A
030900         SET WS-UPDATE-SW-YES    TO TRUE.
031000*
031100*            ***** SCREEN TITLE *****                          *
031200*
031300     IF  MY01-SCREEN-TITLE-L IS LESS THAN 1
031400         MOVE DFHBMASK           TO MY01-SCREEN-TITLE-A
031500         MOVE DFHBMDAS           TO MY01-SCREEN-TITLE-LP-A
031600                                    MY01-SCREEN-TITLE-RP-A
031700         MOVE MMSC-SCREEN-HEADER
031800                                 TO MY01-SCREEN-TITLE
031900     ELSE
032000         MOVE DFHBMASF           TO MY01-SCREEN-TITLE-A
032100         MOVE DFHBMDAS           TO MY01-SCREEN-TITLE-LP-A
032200                                    MY01-SCREEN-TITLE-RP-A
032300         SET WS-UPDATE-SW-YES    TO TRUE.
032400*
032500*             ***** WORK WEEK  *****                            *
032600*
032700     PERFORM
032800         VARYING X-WORK-WEEK FROM 1 BY 1
032900         UNTIL X-WORK-WEEK IS GREATER THAN 7
033000         SET  X-MMSC-WW          TO X-WORK-WEEK
033100         EVALUATE TRUE
033200             WHEN MY01-WORK-WEEK-L (X-WORK-WEEK) IS LESS THAN 1
033300                 MOVE DFHBMASK   TO MY01-WORK-WEEK-A (X-WORK-WEEK)
033400                 MOVE MMSC-WORK-WEEK-R (X-MMSC-WW)
033500                                 TO MY01-WORK-WEEK (X-WORK-WEEK)
033600                 SET WS-MISC-SW-YES
033700                                 TO TRUE
033800             WHEN INVALID-WEEK
033900                 CONTINUE
034000             WHEN (NOT MY01-WORK-WEEK-VALID (X-WORK-WEEK))
034100                 SET INVALID-WEEK
034200                                 TO TRUE
034300                 MOVE SS08WS-CURSOR
034400                                 TO MY01-WORK-WEEK-L (X-WORK-WEEK)
034500             WHEN MY01-WORK-WEEK-VALID (X-WORK-WEEK)
034600                 MOVE DFHBMASF   TO MY01-WORK-WEEK-A (X-WORK-WEEK)
034700                 SET WS-MISC-SW-YES
034800                                 TO TRUE
034900                 SET WS-UPDATE-SW-YES
035000                                 TO TRUE
035100         END-EVALUATE
035200     END-PERFORM.
035300*
035400     PERFORM
035500         VARYING X-WORK-WEEK FROM 1 BY 1
035600         UNTIL X-WORK-WEEK IS GREATER THAN 7
035700         EVALUATE TRUE
035800           WHEN  MY01-WORK-WEEK-OPEN (X-WORK-WEEK)
035900                 SET WS-WORK-WEEK-OPEN
036000                                 TO TRUE
036100         END-EVALUATE
036200     END-PERFORM
036300*
036400     IF  WS-MISC-SW-NO
036500         SET INVALID-WEEK        TO TRUE.
036600*
036700     IF  INVALID-WEEK
036800     OR  WS-WORK-WEEK-CLOSED
036900         SET SS08WS-ERROR-SW-YES TO TRUE
037000         MOVE DFHBMUBF           TO MY01-WORK-WEEK-A (1)
037100                                    MY01-WORK-WEEK-A (2)
037200                                    MY01-WORK-WEEK-A (3)
037300                                    MY01-WORK-WEEK-A (4)
037400                                    MY01-WORK-WEEK-A (5)
037500                                    MY01-WORK-WEEK-A (6)
037600                                    MY01-WORK-WEEK-A (7)
037700         MOVE DFHBMASB           TO MY01-WORK-WEEK-LP-A
037800                                    MY01-WORK-WEEK-RP-A
037900         MOVE SS08WS-CURSOR      TO MY01-WORK-WEEK-L (1).
038000*
038100*            ***** HOLIDAYS *****                              *
038200*
038300     SET X-SYS-HOLIDAY           TO 1.
038400*
038500 2100-EDIT-DATE-LOOP.
038600*
038700     SET X-MMSC-HOL              TO X-SYS-HOLIDAY.
038800*
038900     IF  MY01-HOLIDAY-L (X-SYS-HOLIDAY) IS LESS THAN 1
039000         IF  MMSC-HOLIDAYS    (X-MMSC-HOL)    IS GREATER THAN ZERO
039100             MOVE MMSC-HOLIDAYS    (X-MMSC-HOL)
039200                                 TO SS01WS-JULIAN
039300             PERFORM SS08PD-JUL-TO-GREG
039400                                 THRU SS08PD-JTG-EXIT
039500             MOVE SS01WS-DATE    TO MY01-HOLIDAY   (X-SYS-HOLIDAY)
039600             MOVE DFHBMASK       TO MY01-HOLIDAY-A (X-SYS-HOLIDAY)
039700             MOVE DFHBMDAS       TO MY01-HOLIDAY-LP-A
039800                                    (X-SYS-HOLIDAY)
039900                                    MY01-HOLIDAY-RP-A
040000                                    (X-SYS-HOLIDAY)
040100         ELSE
040200             MOVE DFHBMASK       TO MY01-HOLIDAY-A (X-SYS-HOLIDAY)
040300             MOVE DFHBMDAS       TO MY01-HOLIDAY-LP-A
040400                                    (X-SYS-HOLIDAY)
040500                                    MY01-HOLIDAY-RP-A
040600                                    (X-SYS-HOLIDAY)
040700     ELSE
040800         IF  MY01-HOLIDAY (X-SYS-HOLIDAY) IS NOT NUMERIC
040900             MOVE DFHBMNBF       TO MY01-HOLIDAY-A (X-SYS-HOLIDAY)
041000             MOVE DFHBMASB       TO MY01-HOLIDAY-LP-A
041100                                    (X-SYS-HOLIDAY)
041200                                    MY01-HOLIDAY-RP-A
041300                                    (X-SYS-HOLIDAY)
041400             MOVE SS08WS-CURSOR  TO MY01-HOLIDAY-L (X-SYS-HOLIDAY)
041500             SET SS08WS-ERROR-SW-YES TO TRUE
041600         ELSE
041700             PERFORM 9100-VERIFY-DATE
041800                                 THRU 9199-VD-EXIT
041900             IF  SS01WS-DATE-IS-INVALID
042000                 MOVE DFHBMNBF   TO MY01-HOLIDAY-A (X-SYS-HOLIDAY)
042100                 MOVE DFHBMASB   TO MY01-HOLIDAY-LP-A
042200                                    (X-SYS-HOLIDAY)
042300                                    MY01-HOLIDAY-RP-A
042400                                    (X-SYS-HOLIDAY)
042500                 MOVE SS08WS-CURSOR
042600                                 TO MY01-HOLIDAY-L (X-SYS-HOLIDAY)
042700                 SET SS08WS-ERROR-SW-YES
042800                                 TO TRUE
042900             ELSE
043000                 MOVE SS01WS-DATE
043100                                 TO MY01-HOLIDAY (X-SYS-HOLIDAY)
043200                 MOVE DFHBMASF   TO MY01-HOLIDAY-A (X-SYS-HOLIDAY)
043300                 MOVE DFHBMDAS   TO MY01-HOLIDAY-LP-A
043400                                    (X-SYS-HOLIDAY)
043500                                    MY01-HOLIDAY-RP-A
043600                                    (X-SYS-HOLIDAY)
043700                 SET WS-UPDATE-SW-YES
043800                                 TO TRUE.
043900*
044000     IF  X-SYS-HOLIDAY IS LESS THAN 25
044100         SET X-SYS-HOLIDAY       UP BY 1
044200         GO TO 2100-EDIT-DATE-LOOP.
044300*
044400*            ***** TODAYS DATE (DATE LAST PROC ON SCREEN) *****
044500*
044600     MOVE MMSC-TODAYS-JULIAN     TO SS01WS-JULIAN.
044700     PERFORM SS08PD-JUL-TO-GREG  THRU SS08PD-JTG-EXIT.
044800     MOVE SS01WS-DATE            TO MY01-DATE-LAST-PROC.
044900*
045000*            ***** DATE ACCRUED THRU *****                     *
045100*
045200     IF  MMSC-DATE-LAST-PROC    IS NOT EQUAL TO ZEROES
045300         GO TO 2200-NEXT-PROCESSING.
045400*
045500     IF  MY01-DATE-ACCRUED-THRU-L IS LESS THAN 1
045600         IF  MMSC-ACCR-THRU-DATE    IS EQUAL TO ZEROES
045700             MOVE DFHBMNBF       TO MY01-DATE-ACCRUED-THRU-A
045800             MOVE DFHBMASB       TO MY01-DATE-ACCRUED-THRU-LP-A
045900                                    MY01-DATE-ACCRUED-THRU-RP-A
046000             MOVE SS08WS-CURSOR  TO MY01-DATE-ACCRUED-THRU-L
046100             SET SS08WS-ERROR-SW-YES TO TRUE
046200             GO TO 2200-NEXT-PROCESSING
046300         ELSE
046400             MOVE DFHBMASK       TO MY01-DATE-ACCRUED-THRU-A
046500             MOVE DFHBMDAS       TO MY01-DATE-ACCRUED-THRU-LP-A
046600                                    MY01-DATE-ACCRUED-THRU-RP-A
046700             GO TO 2200-NEXT-PROCESSING.
046800*
046900     IF  MY01-DATE-ACCRUED-THRU IS NOT NUMERIC
047000         MOVE DFHBMNBF           TO MY01-DATE-ACCRUED-THRU-A
047100         MOVE DFHBMASB           TO MY01-DATE-ACCRUED-THRU-LP-A
047200                                    MY01-DATE-ACCRUED-THRU-RP-A
047300         MOVE SS08WS-CURSOR      TO MY01-DATE-ACCRUED-THRU-L
047400         SET SS08WS-ERROR-SW-YES TO TRUE
047500         GO TO 2200-NEXT-PROCESSING.
047600*
047700     IF  MY01-DATE-ACCRUED-THRU IS LESS THAN 1000000
047800         MOVE MY01-DATE-ACCRUED-THRU
047900                                 TO SS01WS-MDY
048000         MOVE SS01WS-MDYZ        TO SS01WS-DATEZ
048100     ELSE
048200         MOVE MY01-DATE-ACCRUED-THRU
048300                                 TO SS01WS-DATE.
048400*
048500     PERFORM SS05PD-DATE-VALIDATION
048600                                 THRU SS05PD-DV-EXIT.
048700*
048800     IF  SS01WS-DATE-IS-INVALID
048900         MOVE DFHBMNBF           TO MY01-DATE-ACCRUED-THRU-A
049000         MOVE DFHBMASB           TO MY01-DATE-ACCRUED-THRU-LP-A
049100                                    MY01-DATE-ACCRUED-THRU-RP-A
049200         MOVE SS08WS-CURSOR      TO MY01-DATE-ACCRUED-THRU-L
049300         SET SS08WS-ERROR-SW-YES TO TRUE
049400     ELSE
049500         MOVE DFHBMASF           TO MY01-DATE-ACCRUED-THRU-A
049600         MOVE DFHBMDAS           TO MY01-DATE-ACCRUED-THRU-LP-A
049700                                    MY01-DATE-ACCRUED-THRU-RP-A
049800         SET WS-UPDATE-SW-YES    TO TRUE.
049900*
050000 2200-NEXT-PROCESSING.
050100*
050200*            ***** NEXT PROCESSING DATE *****                  *
050300*
050400     IF  MMSC-DATE-LAST-PROC    IS NOT EQUAL TO ZEROES
050500         GO TO 2300-CONTINUE.
050600*
050700     IF  MY01-DATE-NEXT-PROC-L IS LESS THAN 1
050800         IF  MMSC-DATE-NEXT-PROC IS EQUAL TO ZEROES
050900             MOVE DFHBMNBF       TO MY01-DATE-NEXT-PROC-A
051000             MOVE DFHBMASB       TO MY01-DATE-NEXT-PROC-LP-A
051100                                    MY01-DATE-NEXT-PROC-RP-A
051200             MOVE SS08WS-CURSOR  TO MY01-DATE-NEXT-PROC-L
051300             SET SS08WS-ERROR-SW-YES TO TRUE
051400             GO TO 2300-CONTINUE
051500         ELSE
051600             MOVE DFHBMASK       TO MY01-DATE-NEXT-PROC-A
051700             MOVE DFHBMDAS       TO MY01-DATE-NEXT-PROC-LP-A
051800                                    MY01-DATE-NEXT-PROC-RP-A
051900             GO TO 2250-CROSS-EDIT.
052000*
052100     IF  MY01-DATE-NEXT-PROC IS NOT NUMERIC
052200         MOVE DFHBMNBF           TO MY01-DATE-NEXT-PROC-A
052300         MOVE DFHBMASB           TO MY01-DATE-NEXT-PROC-LP-A
052400                                    MY01-DATE-NEXT-PROC-RP-A
052500         MOVE SS08WS-CURSOR      TO MY01-DATE-NEXT-PROC-L
052600         SET SS08WS-ERROR-SW-YES TO TRUE
052700         GO TO 2300-CONTINUE.
052800*
052900     IF  MY01-DATE-NEXT-PROC IS LESS THAN 1000000
053000         MOVE MY01-DATE-NEXT-PROC
053100                                 TO SS01WS-MDY
053200         MOVE SS01WS-MDYZ        TO SS01WS-DATEZ
053300     ELSE
053400         MOVE MY01-DATE-NEXT-PROC
053500                                 TO SS01WS-DATE.
053600*
053700     PERFORM SS05PD-DATE-VALIDATION
053800                                 THRU SS05PD-DV-EXIT.
053900*
054000     IF  SS01WS-DATE-IS-INVALID
054100         MOVE DFHBMNBF           TO MY01-DATE-NEXT-PROC-A
054200         MOVE DFHBMASB           TO MY01-DATE-NEXT-PROC-LP-A
054300                                    MY01-DATE-NEXT-PROC-RP-A
054400         MOVE SS08WS-CURSOR      TO MY01-DATE-NEXT-PROC-L
054500         SET SS08WS-ERROR-SW-YES TO TRUE
054600         GO TO 2300-CONTINUE
054700     ELSE
054800         MOVE DFHBMASF           TO MY01-DATE-NEXT-PROC-A
054900         MOVE DFHBMDAS           TO MY01-DATE-NEXT-PROC-LP-A
055000                                    MY01-DATE-NEXT-PROC-RP-A
055100         SET WS-UPDATE-SW-YES    TO TRUE.
055200*
055300 2250-CROSS-EDIT.
055400*
055500     IF  MY01-DATE-ACCRUED-THRU-L IS LESS THAN 1
055600         MOVE MMSC-ACCR-THRU-DATE
055700                                 TO WS-ACCR-THRU-DATE
055800     ELSE
055900         MOVE MY01-DATE-ACCRUED-THRU
056000                                 TO SS01WS-DATE
056100         PERFORM SS07PD-GREG-TO-JUL
056200                                 THRU SS07PD-GTJ-EXIT
056300         MOVE SS01WS-JULIAN      TO WS-ACCR-THRU-DATE.
056400*
056500     IF  MY01-DATE-NEXT-PROC-L IS LESS THAN 1
056600         MOVE MMSC-DATE-NEXT-PROC
056700                                 TO WS-NEXT-PROC-DATE
056800     ELSE
056900         MOVE MY01-DATE-NEXT-PROC
057000                                 TO SS01WS-DATE
057100         PERFORM SS07PD-GREG-TO-JUL
057200                                 THRU SS07PD-GTJ-EXIT
057300         MOVE SS01WS-JULIAN      TO WS-NEXT-PROC-DATE.
057400*
057500     IF  WS-ACCR-THRU-DATE IS GREATER THAN
057600                                    WS-NEXT-PROC-DATE
057700     OR  WS-ACCR-THRU-DATE IS EQUAL TO
057800                                    WS-NEXT-PROC-DATE
057900         MOVE DFHBMNBF           TO MY01-DATE-NEXT-PROC-A
058000                                    MY01-DATE-ACCRUED-THRU-A
058100         MOVE DFHBMASB           TO MY01-DATE-NEXT-PROC-LP-A
058200                                    MY01-DATE-NEXT-PROC-RP-A
058300                                    MY01-DATE-ACCRUED-THRU-LP-A
058400                                    MY01-DATE-ACCRUED-THRU-RP-A
058500         MOVE SS08WS-CURSOR      TO MY01-DATE-ACCRUED-THRU-L
058600         SET SS08WS-ERROR-SW-YES TO TRUE.
058700*
058800 2300-CONTINUE.
058900*
059000     IF  SS08WS-ERROR-SW-NO
059100         GO TO 2400-UPDATE-FILE.
059200*
059300****************************************************************
059400*    SEND THE MAP                                              *
059500****************************************************************
059600*
059700     PERFORM MB60PD-INIT-STD-MAP-LINES
059800                                 THRU MB60PD-ISML-EXIT.
059900*
060000     MOVE 'BM03'                 TO MBCA-PROGRAM-LOCATION.
060100     PERFORM MB60PD-SEND-MAP-DATA-ONLY
060200                                 THRU MB60PD-SMDO-EXIT.
060300*
060400****************************************************************
060500*    RETURN TO CICS                                            *
060600****************************************************************
060700*
060800     MOVE 'PC06'                 TO MBCA-PROGRAM-LOCATION.
060900     MOVE 01                     TO MBCA-SCREEN-NBR.
061000     PERFORM MB70PD-RETURN-TRANS-ID
061100                                 THRU MB70PD-RTI-EXIT.
061200/
061300 2400-UPDATE-FILE.
061400*
061500     IF  WS-UPDATE-SW-NO
061600         GO TO 2600-SETUP-COMMAREA.
061700*
061800****************************************************************
061900*    GETMAIN FOR LOG/JOURNAL RECORD                            *
062000****************************************************************
062100*
062200     MOVE 'SC02'                 TO MBCA-PROGRAM-LOCATION.
062300     SET MBIORO-GETMAIN          TO TRUE.
062400     PERFORM MML1AO-ACCESS       THRU MML1AO-ACCESS-EXIT.
062500*
062600****************************************************************
062700*    READ THE SYSTEM CONTROL FILE FOR UPDATE                   *
062800****************************************************************
062900*
063000     MOVE 'FC03'                 TO MBCA-PROGRAM-LOCATION.
063100     MOVE ZEROES                 TO MBIOWS-MMSC-KEY.
063200     SET MBIORO-READ-RANDOM-UPDATE
063300                                 TO TRUE.
063400     PERFORM MMSCAO-ACCESS       THRU MMSCAO-ACCESS-EXIT.
063500*
063600*            ***** CENTER NAME *****                           *
063700*
063800     IF  MY01-CENTER-NAME-L IS GREATER THAN ZEROES
063900         MOVE ZEROES             TO MML1-FIELD-OCCURRENCE
064000         MOVE 0101               TO MML1-FIELD-CODE
064100         MOVE MML1WS-VL-30       TO MML1-VARIABLE-LENGTH
064200         MOVE MMSC-PROC-CENTER-ID
064300                                 TO MML1-VL30-B-DATA-X
064400         MOVE MY01-CENTER-NAME   TO MMSC-PROC-CENTER-ID
064500         MOVE MMSC-PROC-CENTER-ID
064600                                 TO MML1-VL30-A-DATA-X
064700         PERFORM 9050-CREATE-MAINT-RECORD
064800                                 THRU 9099-CMR-EXIT.
064900*
065000*            ***** SCREEN TITLE *****                          *
065100*
065200     IF  MY01-SCREEN-TITLE-L IS GREATER THAN ZEROES
065300         MOVE ZEROES             TO MML1-FIELD-OCCURRENCE
065400         MOVE 0102               TO MML1-FIELD-CODE
065500         MOVE MML1WS-VL-30       TO MML1-VARIABLE-LENGTH
065600         MOVE MMSC-SCREEN-HEADER
065700                                 TO MML1-VL30-B-DATA-X
065800         MOVE MY01-SCREEN-TITLE  TO MMSC-SCREEN-HEADER
065900                                    MBOFILE-SYSTEM-TITLE
066000         MOVE MMSC-SCREEN-HEADER
066100                                 TO MML1-VL30-A-DATA-X
066200         PERFORM 9400-UPDATE-SMFT
066300                                 THRU 9499-USMFT-EXIT
066400         PERFORM 9050-CREATE-MAINT-RECORD
066500                                 THRU 9099-CMR-EXIT.
066600*
066700*            ***** WORK WEEK *****                             *
066800*
066900     PERFORM
067000         VARYING X-WORK-WEEK FROM 1 BY 1
067100         UNTIL X-WORK-WEEK IS GREATER THAN 7
067200         SET  X-MMSC-WW          TO X-WORK-WEEK
067300         EVALUATE TRUE
067400             WHEN MY01-WORK-WEEK-L (X-WORK-WEEK)
067500                                 IS GREATER THAN ZEROS
067600                 SET MML1-FIELD-OCCURRENCE
067700                                 TO X-MMSC-WW
067800                 MOVE 0103       TO MML1-FIELD-CODE
067900                 MOVE MML1WS-VL-01
068000                                 TO MML1-VARIABLE-LENGTH
068100                 MOVE MMSC-WORK-WEEK-R (X-MMSC-WW)
068200                                 TO MML1-VL01-B-DATA-X
068300                 MOVE MY01-WORK-WEEK (X-WORK-WEEK)
068400                                 TO MMSC-WORK-WEEK-R (X-MMSC-WW)
068500                 MOVE MMSC-WORK-WEEK-R (X-MMSC-WW)
068600                                 TO MML1-VL01-A-DATA-X
068700                 PERFORM 9050-CREATE-MAINT-RECORD
068800                                         THRU 9099-CMR-EXIT
068900         END-EVALUATE
069000     END-PERFORM.
069100*
069200*            ***** HOLIDAYS *****                              *
069300*
069400     SET X-SYS-HOLIDAY           TO 1.
069500*
069600 2500-CHECK-DATE-LOOP.
069700*
069800     SET X-MMSC-HOL              TO X-SYS-HOLIDAY.
069900*
070000     IF  MY01-HOLIDAY-L (X-SYS-HOLIDAY) IS GREATER THAN ZEROES
070100         SET WS-INDEX            TO X-MMSC-HOL
070200         MOVE WS-INDEX           TO MML1-FIELD-OCCURRENCE
070300         MOVE 0104               TO MML1-FIELD-CODE
070400         MOVE MML1WS-VL-07       TO MML1-VARIABLE-LENGTH
070500         MOVE MMSC-HOLIDAYS    (X-MMSC-HOL)
070600                                 TO MML1-VL07-B-DATA-9
070700         MOVE MY01-HOLIDAY (X-SYS-HOLIDAY)
070800                                 TO SS01WS-DATE
070900         PERFORM SS07PD-GREG-TO-JUL
071000                                 THRU SS07PD-GTJ-EXIT
071100         MOVE SS01WS-JULIAN      TO MMSC-HOLIDAYS
071200                                    (X-MMSC-HOL)
071300         MOVE MMSC-HOLIDAYS    (X-MMSC-HOL)
071400                                 TO MML1-VL07-A-DATA-9
071500         PERFORM 9050-CREATE-MAINT-RECORD
071600                                 THRU 9099-CMR-EXIT.
071700*
071800     IF  X-SYS-HOLIDAY IS LESS THAN 25
071900         SET X-SYS-HOLIDAY       UP BY 1
072000         GO TO 2500-CHECK-DATE-LOOP.
072100*
072200*            ***** DATE ACCRUED THRU *****                     *
072300*
072400     IF  MMSC-DATE-LAST-PROC    IS EQUAL TO ZEROES
072500     AND MY01-DATE-ACCRUED-THRU-L IS GREATER THAN ZEROES
072600         MOVE MY01-DATE-ACCRUED-THRU
072700                                 TO SS01WS-DATE
072800         PERFORM SS07PD-GREG-TO-JUL
072900                                 THRU SS07PD-GTJ-EXIT
073000         MOVE ZEROES             TO MML1-FIELD-OCCURRENCE
073100         MOVE 0105               TO MML1-FIELD-CODE
073200         MOVE MML1WS-VL-07       TO MML1-VARIABLE-LENGTH
073300         MOVE MMSC-ACCR-THRU-DATE
073400                                 TO MML1-VL07-B-DATA-9
073500         MOVE SS01WS-JULIAN      TO MMSC-ACCR-THRU-DATE
073600         MOVE MMSC-ACCR-THRU-DATE
073700                                 TO MML1-VL07-A-DATA-9
073800         PERFORM 9050-CREATE-MAINT-RECORD
073900                                 THRU 9099-CMR-EXIT.
074000*
074100*            ***** NEXT PROCESSING DATE *****                  *
074200*
074300     IF  MMSC-DATE-LAST-PROC    IS EQUAL TO ZEROES
074400     AND MY01-DATE-NEXT-PROC-L IS GREATER THAN ZEROES
074500         MOVE ZEROES             TO MML1-FIELD-OCCURRENCE
074600         MOVE 0106               TO MML1-FIELD-CODE
074700         MOVE MML1WS-VL-07       TO MML1-VARIABLE-LENGTH
074800         MOVE MMSC-DATE-NEXT-PROC
074900                                 TO MML1-VL07-B-DATA-9
075000         MOVE MY01-DATE-NEXT-PROC
075100                                 TO SS01WS-DATE
075200         PERFORM SS07PD-GREG-TO-JUL
075300                                 THRU SS07PD-GTJ-EXIT
075400         MOVE SS01WS-JULIAN      TO MML1-VL07-A-DATA-9
075500         PERFORM 9050-CREATE-MAINT-RECORD
075600                                 THRU 9099-CMR-EXIT
075700         MOVE SS01WS-JULIAN      TO MMSC-DATE-NEXT-PROC
075800         MOVE ZEROES             TO MML1-FIELD-OCCURRENCE
075900         MOVE 0107               TO MML1-FIELD-CODE
076000         MOVE MML1WS-VL-07       TO MML1-VARIABLE-LENGTH
076100         MOVE MMSC-TODAYS-JULIAN
076200                                 TO MML1-VL07-B-DATA-9
076300         MOVE SS01WS-JULIAN      TO MMSC-TODAYS-JULIAN
076400         MOVE MMSC-TODAYS-JULIAN
076500                                 TO MML1-VL07-A-DATA-9
076600         PERFORM 9050-CREATE-MAINT-RECORD
076700                                 THRU 9099-CMR-EXIT
076800         MOVE ZEROES             TO MML1-FIELD-OCCURRENCE
076900         MOVE 0108               TO MML1-FIELD-CODE
077000         MOVE MML1WS-VL-10       TO MML1-VARIABLE-LENGTH
077100         MOVE MMSC-TODAYS-CALENDAR
077200                                 TO MML1-VL10-B-DATA-9
077300         MOVE MMSC-TODAYS-JULIAN
077400                                 TO SS01WS-JULIAN
077500         PERFORM SS08PD-JUL-TO-GREG
077600                                 THRU SS08PD-JTG-EXIT
077700         MOVE SS01WS-DATE        TO   MMSC-TODAYS-CALENDAR
077800         MOVE MMSC-TODAYS-CALENDAR
077900                                 TO MML1-VL10-A-DATA-9
078000         PERFORM 9050-CREATE-MAINT-RECORD
078100                                 THRU 9099-CMR-EXIT.
078200*
078300****************************************************************
078400*    UPDATE THE SYSTEM CONTROL RECORD                          *
078500****************************************************************
078600*
078700     MOVE ZEROES                 TO MML1-FIELD-OCCURRENCE.
078800     MOVE 0199                   TO MML1-FIELD-CODE.
078900     MOVE MML1WS-VL-07           TO MML1-VARIABLE-LENGTH.
079000     MOVE MMSC-LAST-MAINT-DATE
079100                                 TO MML1-VL07-B-DATA-9.
079200     MOVE MBCA-START-DATE        TO MMSC-LAST-MAINT-DATE.
079300     MOVE MMSC-LAST-MAINT-DATE
079400                                 TO MML1-VL07-A-DATA-9.
079500     PERFORM 9050-CREATE-MAINT-RECORD
079600                                 THRU 9099-CMR-EXIT.
079700     MOVE 0198                   TO MML1-FIELD-CODE.
079800     MOVE MML1WS-VL-03           TO MML1-VARIABLE-LENGTH.
079900     MOVE MMSC-LAST-MAINT-OPER
080000                                 TO MML1-VL03-B-DATA-X.
080100     MOVE MBCA-OPERATOR-ID       TO MMSC-LAST-MAINT-OPER.
080200     MOVE MMSC-LAST-MAINT-OPER
080300                                 TO MML1-VL03-A-DATA-X.
080400     PERFORM 9050-CREATE-MAINT-RECORD
080500                                 THRU 9099-CMR-EXIT.
080600*
080700     MOVE 'FC04'                 TO MBCA-PROGRAM-LOCATION.
080800     MOVE ZEROES                 TO MBIOWS-MMSC-KEY.
080900     SET MBIORO-REWRITE          TO TRUE.
081000     PERFORM MMSCAO-ACCESS       THRU MMSCAO-ACCESS-EXIT.
081100*
081200 2600-SETUP-COMMAREA.
081300*
081400****************************************************************
081500*    SET UP COMMAREA FIELDS AND TRANSFER TO THE NEXT PROGRAM   *
081600****************************************************************
081700*
081800     MOVE MBCA-EIBAID            TO SS08WS-EIBAID.
081900*
082000     PERFORM MB60PD-EDIT-PAGE-NBR
082100                                 THRU MB60PD-EPN-EXIT.
082200*
082300     IF  SS08WS-VALID-PF-KEY
082400     OR  SS08WS-EIBAID-VALID-PF-KEY
082500         SET MBCA-INITIAL-SCREEN-NBR
082600                                 TO TRUE.
082700*
082800     MOVE 'PC07'                 TO MBCA-PROGRAM-LOCATION.
082900     PERFORM MB70PD-XCTL-TO-MBOXCTL
083000                                 THRU MB70PD-XTM-EXIT.
083100/
083200*
083300 9050-CREATE-MAINT-RECORD.
083400*
083500*****************************************************************
083600*    THIS ROUTINE WILL CREATE THE COMMON DATA FOR ALL OF THE    *
083700*    LOG/JOURNAL TRANSACTIONS                                   *
083800*****************************************************************
083900*
084000     MOVE 'SC'                   TO MML1-FILE-CODE.
084100     MOVE ZEROES                 TO MML1-MMSC-ORG.
084200     MOVE MBCA-SIGNON-NAME       TO MML1-SIGNON-NAME.
084300     MOVE MBCA-TERMINAL-ID       TO MML1-TERMINAL-ID.
084400     MOVE ZEROES                 TO MML1-SOURCE-CODE.
084500     MOVE ZEROES                 TO MML1-FIELD-OCCURRENCE-2.
084600*
084700*****************************************************************
084800*    WRITE THE LOG/JOURNAL FILE RECORD                          *
084900*****************************************************************
085000*
085100     MOVE 'FC05'                 TO MBCA-PROGRAM-LOCATION.
085200     SET MBIORO-WRITE            TO TRUE.
085300     PERFORM MML1AO-ACCESS       THRU MML1AO-ACCESS-EXIT.
085400     MOVE SPACES                 TO MML1-VARIABLE-AREA.
085500*
085600 9099-CMR-EXIT.
085700     EXIT.
085800*
085900 9100-VERIFY-DATE.
086000*
086100     IF  MY01-HOLIDAY (X-SYS-HOLIDAY) IS LESS THAN 1000000
086200         MOVE MY01-HOLIDAY (X-SYS-HOLIDAY)
086300                                 TO SS01WS-MDY
086400         MOVE SS01WS-MDYZ        TO SS01WS-DATEZ
086500     ELSE
086600         MOVE MY01-HOLIDAY (X-SYS-HOLIDAY)
086700                                 TO SS01WS-DATE.
086800*
086900     PERFORM SS05PD-DATE-VALIDATION
087000                                 THRU SS05PD-DV-EXIT.
087100*
087200 9199-VD-EXIT.
087300     EXIT.
087400*
087500*
087600 9299-VWW-EXIT.
087700     EXIT.
087800*
087900 9300-HOLIDAY-ATTRIBUTES.
088000*
088100     SET X-SYS-HOLIDAY           TO 1.
088200*
088300 9300-HOLIDAY-LOOP.
088400*
088500     MOVE DFHBMASB               TO MY01-HOLIDAY-A
088600                                    (X-SYS-HOLIDAY).
088700     MOVE DFHBMDAS               TO MY01-HOLIDAY-LP-A
088800                                    (X-SYS-HOLIDAY)
088900                                    MY01-HOLIDAY-RP-A
089000                                    (X-SYS-HOLIDAY).
089100*
089200     IF  X-SYS-HOLIDAY IS LESS THAN 25
089300         SET X-SYS-HOLIDAY       UP BY 1
089400         GO TO 9300-HOLIDAY-LOOP.
089500*
089600 9399-HA-EXIT.
089700     EXIT.
089800/
089900 9400-UPDATE-SMFT.
090000*
090200     MOVE 'SC03'                 TO MBCA-PROGRAM-LOCATION.
090300     EXEC CICS GETMAIN
090400               SET     (ADDRESS OF SMFT-RECORD)
090500               FLENGTH (LENGTH  OF SMFT-RECORD)
090600               INITIMG (SS08WS-00)
090700     END-EXEC.
090800*
090900     SET  SMFT-AC-IS-MBS         TO TRUE.
091000     MOVE MBCA-FILE-TABLE        TO SMFT-FILE-TABLE.
091100*
091200     MOVE 'FC06'                 TO MBCA-PROGRAM-LOCATION.
091300     EXEC CICS READ
091400               DATASET (SS08WS-SMFT-FILE-NAME)
091500               RIDFLD  (SMFT-KEY)
091600               INTO    (SMFT-RECORD)
091700               UPDATE
091800     END-EXEC.
091900*
092000     MOVE MMSC-SCREEN-HEADER     TO SMFT-SYSTEM-TITLE.
092100*
092200     MOVE 'FC07'                 TO MBCA-PROGRAM-LOCATION.
092300     EXEC CICS REWRITE
092400               DATASET (SS08WS-SMFT-FILE-NAME)
092500               FROM (SMFT-RECORD)
092600     END-EXEC.
092700*
092800*
092900*
093000     SET  SMFT-AC-IS-MBS         TO TRUE.
093100     MOVE MBCA-FILE-TABLE        TO SMFT-FILE-TABLE.
093200*
093300     MOVE 'FC08'                 TO MBCA-PROGRAM-LOCATION.
093400     EXEC CICS READ
093500               DATASET (SS08WS-SMFT-DATA-TABLE)
093600               RIDFLD  (SMFT-KEY)
093700               INTO    (SMFT-RECORD)
093800               UPDATE
093900     END-EXEC.
094000*
094100     MOVE MMSC-SCREEN-HEADER     TO SMFT-SYSTEM-TITLE.
094200*
094300     MOVE 'FC09'                 TO MBCA-PROGRAM-LOCATION.
094400     EXEC CICS REWRITE
094500               DATASET (SS08WS-SMFT-DATA-TABLE)
094600               FROM (SMFT-RECORD)
094700     END-EXEC.
094800*
094900     MOVE SMFT-RECORD            TO MBOFILE-RECORD.
095000*
095100 9499-USMFT-EXIT.
095200     EXIT.
095300/         DATE VALIDATION ROUTINE
095400     COPY SS05PD.
095500/         GREGORIAN TO JULIAN DATE ROUTINE
095600     COPY SS07PD.
095700/         NEW ROUTINE FOR JULIAN TO GREGORIAN CONVERSION
095800     COPY SS26PD.
095900/         ROUTINE TO NUMERICALLY EDIT TIME
096000     COPY SS27PD.
096100/         JULIAN TO GREGORIAN DATE ROUTINE.
096200     COPY SS08PD.
096300/         LINE 24 PF KEYS ROUTINE
096400     COPY SS15PD.
096500/
096600     COPY SS83PD.
096700/         SYSTEM CONTROL ACCESS ROUTINES
096800     COPY MMSCAO.
096900/         LOG/JOURNAL ACCESS ROUTINES
097000     COPY MML1AO.
097100/         ON-LINE MAP ROUTINES
097200     COPY MB60PD REPLACING 'MBMAPXX' BY 'MBMY01 '
097300                           MBMAPXXI BY MBMY01I
097400                           MBMAPXXO BY MBMY01O.
097500/         ON-LINE PROCEDURES
097600     COPY MB70PD.
097700/
097800     COPY SMFTPXO.
