000100 IDENTIFICATION DIVISION.
000200 PROGRAM-ID. MBOOPEN.
000201*       RELEASE DATE=08/24/01.        REVISION LEVEL=08.06      *
000202*****************************************************************
000203*WARNING.  THIS COMPUTER PROGRAM IS PROTECTED BY COPYRIGHT LAW  *
000204*AND INTERNATIONAL TREATIES.  UNAUTHORIZED REPRODUCTION OR      *
000205*DISTRIBUTION OF THIS PROGRAM, OR ANY PORTION OF IT, MAY RESULT *
000206*IN SEVERE CIVIL AND CRIMINAL PENATLIES, AND WILL BE PROSECUTED *
000207*TO THE MAXIMUM EXTENT POSSIBLE UNDER THE LAW.                  *
000208*COPYRIGHT 1999 PAYSYS INTERNATIONAL, INC.  ALL RIGHTS RESERVED.*
000209*****************************************************************
000300******************************************************************
000400*                                                                *
000500*    PROGRAM: MBOOPEN - COMMAND LEVEL CICS OPEN/CLOSE MODULE     *
000600*----------------------------------------------------------------*
000700*       <->       ---->>>> N O T I C E <<<<----       <->        *
000800*    THIS PROGRAM CAN BE USED -O N L Y- WITH CICS RELEASE 1.7    *
000900*    OR GREATER.                                                 *
001000*                                                                *
001100*    -SP- NEEDS TO BE ADDED TO THE TRANSLATER OPTIONS IF USING   *
001200*         CICS RELEASE 3.0 OR GREATER                            *
001300*                                                                *
001400*----------------------------------------------------------------*
001500*                                                                *
001600 ENVIRONMENT DIVISION.
001700 CONFIGURATION SECTION.
001800 SOURCE-COMPUTER. IBM-370.
001900 OBJECT-COMPUTER. IBM-370.
002000 DATA DIVISION.
002100 WORKING-STORAGE SECTION.
002200*
002300 01  FILLER                  PIC  X(12)      VALUE '** WS-BEG **'.
002400*
002500 01  WS-DATA.
002600     03  WS-NBR-OF-FILENAME-ENTRIES
002700                             PIC S9(04)      BINARY VALUE +53.
002800*
002900 01  WS-MESSAGE.
003000     03  WS-NBR-ONE          PIC  9(02)      VALUE ZEROES.
003100     03  FILLER              PIC  X(21)      VALUE
003200                       ' MBS FILES HAVE BEEN '.
003300     03  WS-ACTION-1         PIC  X(06)      VALUE SPACES.
003400     03  FILLER              PIC  X(10)      VALUE SPACES.
003500     03  WS-NBR-TWO          PIC  9(02)      VALUE ZEROES.
003600     03  FILLER              PIC  X(25)      VALUE
003700                       ' MBS FILES HAVE NOT BEEN '.
003800     03  WS-ACTION-2         PIC  X(06)      VALUE SPACES.
003900/
004000     COPY MBIORO.
004100/
004200     COPY MBIOWS.
004300/
004400     COPY SS01WS.
004500/
004600     COPY SS08WS.
004700/
004800     COPY SS00WS.
004900/
005000     COPY SMFTWS.
005100/
005200     COPY SMPTRL REPLACING ==:SMPT:== BY ==SMPT==.
005300/
005400     COPY MB61LK.
005500/
005600     COPY SS84WS.
005700/
005800 01  FILLER                  PIC  X(12)      VALUE '** WS-END **'.
005900/
006000 LINKAGE SECTION.
006100*
006200 01  DFHCOMMAREA.
006300*
006400     COPY MB60WS.
006500/
006600 PROCEDURE DIVISION.
006700*
006800 A000-START-MBOOPEN.
006900*
007000     IF  MBCA-EIBAID-CLEAR
007100         SET MBCA-INITIAL-SCREEN-NBR
007200                                 TO TRUE
007300         MOVE '..NU'             TO SS08WS-WORK-TRANS-ID
007400         MOVE 'PC02'             TO MBCA-PROGRAM-LOCATION
007500         PERFORM MB70PD-XCTL-TO-MBOXCTL
007600                                 THRU MB70PD-XTM-EXIT.
007700*
007800     MOVE 'PC01'                 TO MBCA-PROGRAM-LOCATION.
007900     PERFORM MB70PD-ON-LINE-HOUSEKEEPING
008000                                 THRU MB70PD-OLH-EXIT.
008100*
008200     IF  MBCA-TI-POS-3-4 IS EQUAL TO 'OF'
008300         PERFORM B010-OPEN-FILES THRU B099-OF-EXIT
008400     ELSE
008500         PERFORM C010-CLOSE-FILES
008600                                 THRU C099-CF-EXIT.
008700*
008800     MOVE 'BM01'                 TO MBCA-PROGRAM-LOCATION.
008900     EXEC CICS SEND
009000               FROM  (WS-MESSAGE)
009100               ERASE
009200          END-EXEC.
009300*
009400     PERFORM MB70PD-RETURN-TO-CICS
009500                                 THRU MB70PD-RTC-EXIT.
009600*
009700 B010-OPEN-FILES.
009800*
009900     MOVE  'OPENED'              TO WS-ACTION-1
010000                                    WS-ACTION-2.
010100*
010200     PERFORM B100-OPEN-FILES     THRU B199-OF-EXIT
010300                                 VARYING X-MBOFILE FROM 1 BY 1
010400                                 UNTIL X-MBOFILE IS GREATER THAN
010500                                 WS-NBR-OF-FILENAME-ENTRIES.
010600*
010700 B099-OF-EXIT.
010800     EXIT.
010900*
011000 B100-OPEN-FILES.
011100*
011200     MOVE MBOFILE-FILE-NAME (X-MBOFILE)
011300                                 TO  SS84WS-FILE-NAME.
011400     SET  SS84WS-FUNCTION-OPEN   TO TRUE.
011500     PERFORM SS84PD-OPEN-CLOSE-FUNCTION
011600        THRU SS84PD-OCF-EXIT.
011700*
011800     IF  SS84WS-RC-SUCCESSFUL
011900         ADD 1                   TO WS-NBR-ONE
012000     ELSE
012100         ADD 1                   TO WS-NBR-TWO
012200     END-IF.
012300*
012400 B199-OF-EXIT.
012500     EXIT.
012600*
012700 C010-CLOSE-FILES.
012800*
012900     MOVE  'CLOSED'              TO WS-ACTION-1
013000                                    WS-ACTION-2.
013100*
013200     PERFORM C100-CLOSE-FILES    THRU C199-CF-EXIT
013300                                 VARYING X-MBOFILE FROM 1 BY 1
013400                                 UNTIL X-MBOFILE IS GREATER THAN
013500                                 WS-NBR-OF-FILENAME-ENTRIES.
013600*
013700 C099-CF-EXIT.
013800     EXIT.
013900*
014000 C100-CLOSE-FILES.
014100*
014200     MOVE MBOFILE-FILE-NAME (X-MBOFILE)
014300                                 TO  SS84WS-FILE-NAME.
014400     SET  SS84WS-FUNCTION-CLOSE  TO TRUE.
014500     PERFORM SS84PD-OPEN-CLOSE-FUNCTION
014600        THRU SS84PD-OCF-EXIT.
014700*
014800     IF  SS84WS-RC-SUCCESSFUL
014900         ADD 1                   TO WS-NBR-ONE
015000     ELSE
015100         ADD 1                   TO WS-NBR-TWO
015200     END-IF.
015300*
015400*
015500 C199-CF-EXIT.
015600     EXIT.
015700/
015800     COPY MB70PD.
015900/
016000     COPY SS84PD.
016100/
016200     COPY SMFTPXO.
