000100 IDENTIFICATION DIVISION.
000200 PROGRAM-ID. MBOPL02.
000201*       RELEASE DATE=08/24/01.        REVISION LEVEL=08.06      *
000202*****************************************************************
000203*WARNING.  THIS COMPUTER PROGRAM IS PROTECTED BY COPYRIGHT LAW  *
000204*AND INTERNATIONAL TREATIES.  UNAUTHORIZED REPRODUCTION OR      *
000205*DISTRIBUTION OF THIS PROGRAM, OR ANY PORTION OF IT, MAY RESULT *
000206*IN SEVERE CIVIL AND CRIMINAL PENATLIES, AND WILL BE PROSECUTED *
000207*TO THE MAXIMUM EXTENT POSSIBLE UNDER THE LAW.                  *
000208*COPYRIGHT 1999 PAYSYS INTERNATIONAL, INC.  ALL RIGHTS RESERVED.*
000209*****************************************************************
000300*****************************************************************
000400*                                                               *
000500*               M E R C H A N T   S Y S T E M                   *
000600*                                                               *
000700*      MBOPL02 - PLATE GENERATION                              *
000800*                SCREEN 02                                      *
000900*                                                               *
001000*              1. TRANSIDS                                      *
001100*                 A. MBPL                                       *
001200*              2. MAPS USED -                                   *
001300*                 A. MBPL02 (SCREEN 01)                         *
001400*              3. FILES USED -                                  *
001500*                 A. MMPF (PLATE FILE)                          *
001600*                 B. MMMM (MERCHANT MASTER FILE)                *
001700*                 C. MML1 (LOG FILE)                            *
001800*                                                               *
001900*****************************************************************
002000*
002100 ENVIRONMENT DIVISION.
002200*
002300 DATA DIVISION.
002400*
002500 WORKING-STORAGE SECTION.
002600*
002700 01  FILLER                  PIC  X(12)      VALUE
002800     '** WS-BEG **'.
002900*
003000 01  FILLER                  PIC  X(14)      VALUE
003100     'MISCELLANEOUS:'.
003200*
003300 01  FILLER                  PIC  X(17)      VALUE
003400     'PROGRAM SWITCHES:'.
003500*
003600 01  WS-PROGRAM-SWITCHES.
003700     03  WS-UPDATE-SW        PIC  X(01)      VALUE 'N'.
003800         88  WS-UPDATE-SW-YES                VALUE 'Y'.
003900         88  WS-UPDATE-SW-NO                 VALUE 'N'.
004000/
004100 01  FILLER                  PIC  X(29)      VALUE
004200     'I/O REQUEST BLOCK WORK AREAS:'.
004300*
004400     COPY MBIOWS.
004500/
004600 01  FILLER                  PIC  X(18)      VALUE
004700     'I/O REQUEST BLOCK:'.
004800*
004900     COPY MBIORO.
005000/
005100 01  FILLER                  PIC  X(25)      VALUE
005200     'LOG RECORD REQUEST BLOCK:'.
005300*
005400     COPY MML1WS REPLACING ==:MML1:== BY ==MML1==.
005500/
005600 01  FILLER                  PIC  X(20)      VALUE
005700     'CCS DATE WORK AREAS:'.
005800*
005900     COPY SS01WS.
006000/
006100 01  FILLER                  PIC  X(15)      VALUE
006200     'CCS WORK AREAS:'.
006300*
006400     COPY SS08WS.
006500/
006600     COPY SS00WS.
006700/
006800     COPY SMFTWS.
006900/
007000     COPY SMPTRL REPLACING ==:SMPT:== BY ==SMPT==.
007100/
007200     COPY MB61LK.
007300/
007400 01  FILLER                  PIC  X(12)      VALUE
007500     '** WS-END **'.
007600/
007700 LINKAGE SECTION.
007800*
007900 01  DFHCOMMAREA.
008000*
008100     COPY MB60WS.
008200/
008300************************
008400*    PLATE FILE MAP    *
008500************************
008600*
008700     COPY MBPL02.
008800/
008900*************************************
009000*    PLATE FILE MAP REDEFINITION    *
009100*************************************
009200*
009300     COPY MBPL02R.
009400/
009500**********************************
009600*    PLATE FILE RECORD LAYOUT    *
009700**********************************
009800*
009900     COPY MMPFRL.
010000/
010100***************************************
010200*    MERCHANT MASTER RECORD LAYOUT    *
010300***************************************
010400*
010500     COPY MMMMRL.
010600/
010700***************************
010800*    LOG RECORD LAYOUT    *
010900***************************
011000*
011100     COPY MML1RL REPLACING ==:MML1:== BY ==MML1==.
011200/
011300 PROCEDURE DIVISION.
011400*
011500 A000-HOUSEKEEPING SECTION.
011600*
011700 A020-INIT.
011800*
011900     MOVE 'PC01'                 TO MBCA-PROGRAM-LOCATION.
012000     PERFORM MB70PD-ON-LINE-HOUSEKEEPING
012100                                 THRU MB70PD-OLH-EXIT.
012200*
012300     IF  MBCA-RECEIVE-SCREEN
012400         GO TO C000-RECEIVE-SCREEN.
012500/
012600 B000-SEND-SCREEN SECTION.
012700*
012800*********************************************
012900*    GET CICS STORAGE NEEDED FOR THE MAP    *
013000*********************************************
013100*
013200     MOVE 'SC01'                 TO MBCA-PROGRAM-LOCATION.
013300     PERFORM MB60PD-GETMAIN-FOR-MAP
013400                                 THRU MB60PD-GFM-EXIT.
013500*
013600*******************************************
013700*    INITIALIZE THE STANDARD MAP LINES    *
013800*******************************************
013900*
014000     PERFORM MB60PD-INIT-STD-MAP-LINES
014100                                 THRU MB60PD-ISML-EXIT.
014200*
014300************************************
014400*    READ THE PLATE FILE RECORD    *
014500*    FOR SUBSEQUENT DISPLAY        *
014600************************************
014700*
014800     MOVE MBCA-MERCHANT-ORG      TO MBIOWS-MMPF-ORG
014900                                    PL02-ORG.
015000     MOVE MBCA-S-M               TO MBIOWS-MMPF-TYPE.
015100*
015200     IF  MBCA-S-M IS EQUAL TO 'M'
015300         MOVE MBCA-MERCHANT      TO MBIOWS-MMPF-MERCHANT
015400     ELSE
015500         MOVE MBCA-STORE         TO MBIOWS-MMPF-MERCHANT.
015600*
015700     MOVE SS08WS-CICS-FC-NOTFND  TO MBIORO-TEMP-STATUS-1.
015800*
015900     MOVE 'FC01'                 TO MBCA-PROGRAM-LOCATION.
016000     SET MBIORO-READ-RANDOM      TO TRUE.
016100     PERFORM MMPFAO-ACCESS       THRU MMPFAO-ACCESS-EXIT.
016200*
016300     IF  SS08WS-RC-FC-NOTFND
016400         SET MBCA-INITIAL-SCREEN-NBR TO TRUE
016500         MOVE 'PC02'             TO MBCA-PROGRAM-LOCATION
016600         PERFORM MB70PD-XCTL-TO-MBOXCTL
016700                                 THRU MB70PD-XTM-EXIT.
016800*
016900******************************************************************
017000*    MOVE LAST MAINT DATE AND LAST MAINT OPERATOR TO THE SCREEN  *
017100*    DEPENDING ON THE FUNCTION.                                  *
017200******************************************************************
017300*
017400     IF  MBCA-S-M IS EQUAL TO 'M'
017500         IF  MBCA-PTI-FUNCTION-IS-ADD
017600             MOVE DFHBMDAS       TO PL02-LAST-MAINT-LIT-A
017700                                    PL02-LAST-MAINT-DATE-A
017800                                    PL02-LAST-MAINT-OPER-LIT-A
017900                                    PL02-LAST-MAINT-OPER-A
018000         ELSE
018100             MOVE MMPF-LAST-MAINT-DATE
018200                                 TO SS01WS-JULIAN
018300             PERFORM SS26PD-NUMERICALLY-EDIT-DATE
018400                                 THRU SS26PD-NED-EXIT
018500             MOVE SS01WS-XX-XX-YYYY
018600                                 TO PL02-LAST-MAINT-DATE
018700             MOVE MMPF-LAST-MAINT-OPER
018800                                 TO PL02-LAST-MAINT-OPER
018900             MOVE DFHBMASB       TO PL02-LAST-MAINT-DATE-A
019000                                    PL02-LAST-MAINT-OPER-A
019100     ELSE
019200         MOVE DFHBMDAS           TO PL02-LAST-MAINT-LIT-A
019300                                    PL02-LAST-MAINT-DATE-A
019400                                    PL02-LAST-MAINT-OPER-LIT-A
019500                                    PL02-LAST-MAINT-OPER-A.
019600*
019700***********************************
019800*    READ THE MERCHANT RECORD     *
019900***********************************
020000*
020100     MOVE 'FC02'                 TO MBCA-PROGRAM-LOCATION.
020200     PERFORM Y910-READ-MMMM      THRU Y919-READ-MMMM-EXIT.
020300*
020400 B020-MOVE-FIELDS-TO-SCREEN.
020500*
020600**********************************
020700*    MOVE THE FIELDS FROM THE    *
020800*    RECORD TO THE SCREEN        *
020900**********************************
021000*
021100     MOVE MMPF-MERCHANT-ID           TO PL02-MERCHANT.
021200*
021300     IF  MMPF-SAC-USE-PRIMARY
021400         SET X-MMPF-M-PRIMARY        TO 1
021500     ELSE
021600         SET X-MMPF-M-PRIMARY        TO 2.
021700*
021800     MOVE MMPF-LAST-MAINT-OPER   TO PL02-LAST-MAINT-OPER.
021900*
022000     PERFORM
022100         VARYING X-PL02-PRD FROM 1 BY 1
022200         UNTIL X-PL02-PRD IS GREATER THAN 4
022300         SET X-MMPF-PRD          TO X-PL02-PRD
022400         MOVE MMPF-NBR-PLATES-REQ (X-MMPF-PRD)
022500                                 TO PL02-NBR-PLATES-REQ
022600                                    (X-PL02-PRD)
022700         MOVE MMPF-PLATE-TYPE (X-MMPF-PRD)
022800                                 TO PL02-PLATE-TYPE
022900                                    (X-PL02-PRD)
023000     END-PERFORM.
023100*
023200     MOVE MMPF-USER-DATA         TO PL02-USER-DATA.
023300*
023400     MOVE MMPF-ACTIVE-DR-RT      TO PL02-ACTIVE-DR-RT.
023500*
023600     MOVE MMPF-USER-CODE         TO PL02-USER-CODE.
023700*
023800     MOVE MMPF-USER-NBR-1        TO PL02-USER-NBR1.
023900*
024000     MOVE MMPF-USER-NBR-2        TO PL02-USER-NBR2.
024100*
024200     MOVE MMPF-ACTIVE-DR-ACCT    TO PL02-ACTIVE-DR-ACCT.
024300*
024400     MOVE MMPF-USER-PHONE        TO PL02-USER-PHONE.
024500*
024600     MOVE MMPF-USER-NAME         TO PL02-USER-NAME.
024700*
024800     PERFORM
024900         VARYING X-PL02-NA FROM 1 BY 1
025000         UNTIL X-PL02-NA IS GREATER THAN 5
025100         SET X-MMPF-M-NA         TO X-PL02-NA
025200         MOVE MMPF-M-NA-LINE (X-MMPF-M-PRIMARY X-MMPF-M-NA)
025300                                 TO PL02-NA-LINE (X-PL02-NA)
025400     END-PERFORM.
025500*
025600     MOVE MMPF-M-STATE-CODE (X-MMPF-M-PRIMARY)
025700                                 TO PL02-STATE.
025800     MOVE MMPF-M-PHONE (X-MMPF-M-PRIMARY)
025900                                 TO PL02-PHONE.
026000     MOVE MMPF-M-POSTAL-CODE (X-MMPF-M-PRIMARY)
026100                                 TO PL02-POSTAL-CODE.
026200     MOVE MMPF-M-FAX (X-MMPF-M-PRIMARY)
026300                                 TO PL02-FAX.
026400*
026500******************************************
026600*    SET THE CURSOR AND SCREEN NUMBER    *
026700******************************************
026800*
026900     MOVE SS08WS-CURSOR          TO PL02-PLATE-TYPE-L (1).
027000*
027100     COMPUTE MBCA-SCREEN-NBR     =  MBCA-SCREEN-NBR - 50.
027200*
027300     IF  MBCA-S-M IS EQUAL TO 'M'
027400         MOVE DFHBMASK           TO PL02-CURRENT-PAGE-A.
027500*
027600**********************
027700*    SEND THE MAP    *
027800**********************
027900*
028000     MOVE 'BM01'                 TO MBCA-PROGRAM-LOCATION.
028100*
028200     PERFORM MB60PD-SEND-MAP-WITH-ERASE
028300                                 THRU MB60PD-SMWE-EXIT.
028400*
028500************************
028600*    RETURN TO CICS    *
028700************************
028800*
028900     MOVE 'PC02'                 TO MBCA-PROGRAM-LOCATION.
029000     PERFORM MB70PD-RETURN-TRANS-ID
029100                                 THRU MB70PD-RTI-EXIT.
029200/
029300 C000-RECEIVE-SCREEN SECTION.
029400*
029500******************************************
029600*    THIS SECTION RECEIVES THE SCREEN    *
029700******************************************
029800*
029900     MOVE 'BM02'                 TO MBCA-PROGRAM-LOCATION.
030000     PERFORM MB60PD-RECEIVE-MAP  THRU MB60PD-RM-EXIT.
030100*
030200**************************************************************
030300*    CHECK FOR ANOTHER TRANSACTION ID ENTERED BY THE USER    *
030400**************************************************************
030500*
030600     MOVE 'PC03'                 TO MBCA-PROGRAM-LOCATION.
030700     PERFORM MB60PD-NEW-TRANS-ROUTINE
030800                                 THRU MB60PD-NTR-EXIT.
030900*
031000************************************
031100*    READ THE PLATE FILE RECORD    *
031200************************************
031300*
031400     MOVE MBCA-MERCHANT-ORG      TO MBIOWS-MMPF-ORG
031500                                    PL02-ORG.
031600     MOVE MBCA-S-M               TO MBIOWS-MMPF-TYPE.
031700*
031800     IF  MBCA-S-M IS EQUAL TO 'M'
031900         MOVE MBCA-MERCHANT      TO MBIOWS-MMPF-MERCHANT
032000     ELSE
032100         MOVE MBCA-STORE         TO MBIOWS-MMPF-MERCHANT.
032200*
032300     MOVE 'MERCHANT'             TO PL02-MERCHANT-LIT.
032400*
032500     MOVE 'FC04'                 TO MBCA-PROGRAM-LOCATION.
032600     SET MBIORO-READ-RANDOM      TO TRUE.
032700     PERFORM MMPFAO-ACCESS       THRU MMPFAO-ACCESS-EXIT.
032800*
032900***********************************
033000*    READ THE MERCHANT RECORD     *
033100***********************************
033200*
033300     MOVE 'FC05'                 TO MBCA-PROGRAM-LOCATION.
033400     PERFORM Y910-READ-MMMM      THRU Y919-READ-MMMM-EXIT.
033500*
033600 C020-FIELD-EDITS.
033700*
033800*********************
033900*    FIELD EDITS    *
034000*********************
034100*
034200     MOVE MMPF-MERCHANT-ID           TO PL02-MERCHANT.
034300*
034400     IF  MMPF-SAC-USE-PRIMARY
034500         SET X-MMPF-M-PRIMARY        TO 1
034600     ELSE
034700         SET X-MMPF-M-PRIMARY        TO 2.
034800*
034900     MOVE MMPF-ACTIVE-DR-RT      TO PL02-ACTIVE-DR-RT.
035000*
035100     MOVE MMPF-ACTIVE-DR-ACCT    TO PL02-ACTIVE-DR-ACCT.
035200*
035300*            ***** PLATE REQUESTED AND TYPE *****              *
035400*
035500     PERFORM
035600         VARYING X-PL02-PRD FROM 1 BY 1
035700         UNTIL X-PL02-PRD IS GREATER THAN 4
035800         SET X-MMPF-PRD          TO X-PL02-PRD
035900         EVALUATE TRUE
036000           WHEN  PL02-NBR-PLATES-REQ-L (X-PL02-PRD) IS LESS THAN 1
036100             MOVE DFHBMASK       TO PL02-NBR-PLATES-REQ-A
036200                                    (X-PL02-PRD)
036300             MOVE DFHBMDAS       TO PL02-NBR-PLATES-REQ-LP-A
036400                                    (X-PL02-PRD)
036500                                    PL02-NBR-PLATES-REQ-RP-A
036600                                    (X-PL02-PRD)
036700             MOVE MMPF-NBR-PLATES-REQ (X-MMPF-PRD)
036800                                 TO PL02-NBR-PLATES-REQ
036900                                    (X-PL02-PRD)
037000           WHEN OTHER
037100             MOVE DFHBMASF       TO PL02-NBR-PLATES-REQ-A
037200                                    (X-PL02-PRD)
037300             MOVE DFHBMDAS       TO PL02-NBR-PLATES-REQ-LP-A
037400                                    (X-PL02-PRD)
037500                                    PL02-NBR-PLATES-REQ-RP-A
037600                                    (X-PL02-PRD)
037700             SET WS-UPDATE-SW-YES
037800                                 TO TRUE
037900         END-EVALUATE
038000         EVALUATE TRUE
038100           WHEN  PL02-PLATE-TYPE-L (X-PL02-PRD) IS LESS THAN 1
038200             MOVE DFHBMASK       TO PL02-PLATE-TYPE-A
038300                                    (X-PL02-PRD)
038400             MOVE DFHBMDAS       TO PL02-PLATE-TYPE-LP-A
038500                                    (X-PL02-PRD)
038600                                    PL02-PLATE-TYPE-RP-A
038700                                    (X-PL02-PRD)
038800             MOVE MMPF-PLATE-TYPE (X-MMPF-PRD)
038900                                 TO PL02-PLATE-TYPE-RP-A
039000                                    (X-PL02-PRD)
039100           WHEN OTHER
039200             MOVE DFHBMASF       TO PL02-PLATE-TYPE-A
039300                                    (X-PL02-PRD)
039400             MOVE DFHBMDAS       TO PL02-PLATE-TYPE-LP-A
039500                                    (X-PL02-PRD)
039600                                    PL02-PLATE-TYPE-RP-A
039700                                    (X-PL02-PRD)
039800             SET WS-UPDATE-SW-YES
039900                                 TO TRUE
040000         END-EVALUATE
040100     END-PERFORM.
040200*
040300*            ***** USER DATA *****                             *
040400*
040500     IF  PL02-USER-DATA-L IS LESS THAN 1
040600         MOVE DFHBMASK           TO PL02-USER-DATA-A
040700         MOVE DFHBMDAS           TO PL02-USER-DATA-LP-A
040800                                    PL02-USER-DATA-RP-A
040900         MOVE MMPF-USER-DATA     TO PL02-USER-DATA
041000     ELSE
041100         MOVE DFHBMASF           TO PL02-USER-DATA-A
041200         MOVE DFHBMDAS           TO PL02-USER-DATA-LP-A
041300                                    PL02-USER-DATA-RP-A
041400         SET WS-UPDATE-SW-YES    TO TRUE.
041500*
041600*            ***** USER CODE *****                             *
041700*
041800     IF  PL02-USER-CODE-L IS LESS THAN 1
041900         MOVE DFHBMASK           TO PL02-USER-CODE-A
042000*
042100         MOVE DFHBMDAS           TO PL02-USER-CODE-LP-A
042200                                    PL02-USER-CODE-RP-A
042300         MOVE MMPF-USER-CODE     TO PL02-USER-CODE
042400     ELSE
042500         MOVE DFHBMASF           TO PL02-USER-CODE-A
042600         MOVE DFHBMDAS           TO PL02-USER-CODE-LP-A
042700                                    PL02-USER-CODE-RP-A
042800         SET WS-UPDATE-SW-YES    TO TRUE.
042900*            ***** USER NBR1 *****                             *
043000*
043100     IF  PL02-USER-NBR1-L IS LESS THAN 1
043200         MOVE DFHBMASK           TO PL02-USER-NBR1-A
043300         MOVE DFHBMDAS           TO PL02-USER-NBR1-LP-A
043400                                    PL02-USER-NBR1-RP-A
043500         MOVE MMPF-USER-NBR-1    TO PL02-USER-NBR1
043600     ELSE
043700         IF  PL02-USER-NBR1 IS NUMERIC
043800             MOVE DFHBMASF       TO PL02-USER-NBR1-A
043900             MOVE DFHBMDAS       TO PL02-USER-NBR1-LP-A
044000                                    PL02-USER-NBR1-RP-A
044100             SET WS-UPDATE-SW-YES
044200                                 TO TRUE
044300         ELSE
044400             MOVE DFHBMNBF       TO PL02-USER-NBR1-A
044500             MOVE DFHBMASB       TO PL02-USER-NBR1-LP-A
044600                                    PL02-USER-NBR1-RP-A
044700             SET SS08WS-ERROR-SW-YES
044800                                 TO TRUE
044900             MOVE SS08WS-CURSOR  TO PL02-USER-NBR1-L
045000             GO TO D000-RETURN-ERRORS.
045100*
045200*            ***** USER NBR2 *****                             *
045300*
045400     IF  PL02-USER-NBR2-L IS LESS THAN 1
045500         MOVE DFHBMASK           TO PL02-USER-NBR2-A
045600         MOVE DFHBMDAS           TO PL02-USER-NBR2-LP-A
045700                                    PL02-USER-NBR2-RP-A
045800         MOVE MMPF-USER-NBR-2    TO PL02-USER-NBR2
045900     ELSE
046000         IF  PL02-USER-NBR2 IS NUMERIC
046100             MOVE DFHBMASF       TO PL02-USER-NBR2-A
046200             MOVE DFHBMDAS       TO PL02-USER-NBR2-LP-A
046300                                    PL02-USER-NBR2-RP-A
046400             SET WS-UPDATE-SW-YES
046500                                 TO TRUE
046600         ELSE
046700             MOVE DFHBMNBF       TO PL02-USER-NBR2-A
046800             MOVE DFHBMASB       TO PL02-USER-NBR2-LP-A
046900                                    PL02-USER-NBR2-RP-A
047000             SET SS08WS-ERROR-SW-YES
047100                                 TO TRUE
047200             MOVE SS08WS-CURSOR  TO PL02-USER-NBR2-L
047300             GO TO D000-RETURN-ERRORS.
047400*
047500*            ***** USER PHONE *****                            *
047600*
047700     IF  PL02-USER-PHONE-L IS LESS THAN 1
047800         MOVE DFHBMASK           TO PL02-USER-PHONE-A
047900         MOVE DFHBMDAS           TO PL02-USER-PHONE-LP-A
048000                                    PL02-USER-PHONE-RP-A
048100         MOVE MMPF-USER-PHONE    TO PL02-USER-PHONE
048200     ELSE
048300         MOVE DFHBMASF           TO PL02-USER-PHONE-A
048400         MOVE DFHBMDAS           TO PL02-USER-PHONE-LP-A
048500                                    PL02-USER-PHONE-RP-A
048600         SET WS-UPDATE-SW-YES    TO TRUE.
048700*
048800*            ***** USER NAME *****                             *
048900*
049000     IF  PL02-USER-NAME-L IS LESS THAN 1
049100         MOVE DFHBMASK           TO PL02-USER-NAME-A
049200         MOVE DFHBMDAS           TO PL02-USER-NAME-LP-A
049300                                    PL02-USER-NAME-RP-A
049400         MOVE MMPF-USER-NAME     TO PL02-USER-NAME
049500     ELSE
049600         MOVE DFHBMASF           TO PL02-USER-NAME-A
049700         MOVE DFHBMDAS           TO PL02-USER-NAME-LP-A
049800                                    PL02-USER-NAME-RP-A
049900         SET WS-UPDATE-SW-YES    TO TRUE.
050000*
050100*            ***** NAME ADDRESS LINES *****                    *
050200*
050300     PERFORM
050400         VARYING X-PL02-NA FROM 1 BY 1
050500         UNTIL X-PL02-NA IS GREATER THAN 5
050600         SET X-MMPF-M-NA         TO X-PL02-NA
050700         EVALUATE TRUE
050800         WHEN  PL02-NA-LINE-L (X-PL02-NA) IS LESS THAN 1
050900             MOVE DFHBMASK       TO PL02-NA-LINE-A (X-PL02-NA)
051000             MOVE DFHBMDAS       TO PL02-NA-LINE-LP-A (X-PL02-NA)
051100                                    PL02-NA-LINE-RP-A (X-PL02-NA)
051200             MOVE MMPF-M-NA-LINE (X-MMPF-M-PRIMARY X-MMPF-M-NA)
051300                                 TO PL02-NA-LINE (X-PL02-NA)
051400         WHEN OTHER
051500             MOVE DFHBMASF       TO PL02-NA-LINE-A (X-PL02-NA)
051600             MOVE DFHBMDAS       TO PL02-NA-LINE-LP-A (X-PL02-NA)
051700                                    PL02-NA-LINE-RP-A (X-PL02-NA)
051800             SET WS-UPDATE-SW-YES
051900                                 TO TRUE
052000         END-EVALUATE
052100     END-PERFORM.
052200*
052300*            ***** STATE/PROVINCE *****                        *
052400*
052500     IF  PL02-STATE-L IS LESS THAN 1
052600         MOVE DFHBMASK           TO PL02-STATE-A
052700         MOVE DFHBMDAS           TO PL02-STATE-LP-A
052800                                    PL02-STATE-RP-A
052900         MOVE MMPF-M-STATE-CODE (X-MMPF-M-PRIMARY)
053000                                 TO PL02-STATE
053100     ELSE
053200         MOVE DFHBMASF           TO PL02-STATE-A
053300         MOVE DFHBMDAS           TO PL02-STATE-LP-A
053400                                    PL02-STATE-RP-A
053500         SET WS-UPDATE-SW-YES    TO TRUE.
053600*
053700*            ***** PHONE NUMBER *****                          *
053800*
053900     IF  PL02-PHONE-L IS LESS THAN 1
054000         MOVE DFHBMASK           TO PL02-PHONE-A
054100         MOVE DFHBMDAS           TO PL02-PHONE-LP-A
054200                                    PL02-PHONE-RP-A
054300         MOVE MMPF-M-PHONE (X-MMPF-M-PRIMARY)
054400                                 TO PL02-PHONE
054500     ELSE
054600         MOVE DFHBMASF           TO PL02-PHONE-A
054700         MOVE DFHBMDAS           TO PL02-PHONE-LP-A
054800                                    PL02-PHONE-RP-A
054900         SET WS-UPDATE-SW-YES    TO TRUE.
055000*
055100*            ***** FAX PHONE NUMBER *****                      *
055200*
055300     IF  PL02-FAX-L IS LESS THAN 1
055400         MOVE DFHBMASK           TO PL02-FAX-A
055500         MOVE DFHBMDAS           TO PL02-FAX-LP-A
055600                                    PL02-FAX-RP-A
055700         MOVE MMPF-M-FAX (X-MMPF-M-PRIMARY)
055800                                 TO PL02-FAX
055900     ELSE
056000         MOVE DFHBMASF           TO PL02-FAX-A
056100         MOVE DFHBMDAS           TO PL02-FAX-LP-A
056200                                    PL02-FAX-RP-A
056300         SET WS-UPDATE-SW-YES    TO TRUE.
056400*
056500*            ***** POSTAL CODE *****                           *
056600*
056700     IF  MBCA-PTI-FUNCTION-IS-ADD
056800     AND PL02-POSTAL-CODE-L IS LESS THAN 1
056900         MOVE DFHBMUBF           TO PL02-POSTAL-CODE-A
057000         MOVE DFHBMASB           TO PL02-POSTAL-CODE-LP-A
057100                                    PL02-POSTAL-CODE-RP-A
057200         MOVE SS08WS-CURSOR      TO PL02-POSTAL-CODE-L
057300         SET SS08WS-ERROR-SW-YES TO TRUE
057400     ELSE
057500         IF  PL02-POSTAL-CODE-L IS LESS THAN 1
057600             MOVE DFHBMASK       TO PL02-POSTAL-CODE-A
057700             MOVE DFHBMDAS       TO PL02-POSTAL-CODE-LP-A
057800                                    PL02-POSTAL-CODE-RP-A
057900             MOVE MMPF-M-POSTAL-CODE (X-MMPF-M-PRIMARY)
058000                                 TO PL02-POSTAL-CODE
058100         ELSE
058200             IF  PL02-POSTAL-CODE IS EQUAL TO SPACES
058300                 MOVE DFHBMUBF   TO PL02-POSTAL-CODE-A
058400                 MOVE DFHBMASB   TO PL02-POSTAL-CODE-LP-A
058500                                    PL02-POSTAL-CODE-RP-A
058600                 MOVE SS08WS-CURSOR TO PL02-POSTAL-CODE-L
058700                 SET SS08WS-ERROR-SW-YES
058800                                 TO TRUE
058900             ELSE
059000                 MOVE DFHBMASF   TO PL02-POSTAL-CODE-A
059100                 MOVE DFHBMDAS   TO PL02-POSTAL-CODE-LP-A
059200                                    PL02-POSTAL-CODE-RP-A
059300                 SET WS-UPDATE-SW-YES
059400                                 TO TRUE.
059500/
059600 D000-RETURN-ERRORS SECTION.
059700*
059800     IF  SS08WS-ERROR IS EQUAL TO 'N'
059900         GO TO E000-UPDATE-FILE.
060000*
060100***************************************************************
060200*    INITIALIZE THE STANDARD MAP LINES.  IN AN ERROR          *
060300*    CONDITION, THIS ROUTINE IS PERFORMED PRIMARILY           *
060400*    TO UPDATE THE DATE AND TIME ON THE SCREEN.               *
060500***************************************************************
060600*
060700     PERFORM MB60PD-INIT-STD-MAP-LINES
060800                                 THRU MB60PD-ISML-EXIT.
060900*
061000**********************
061100*    SEND THE MAP    *
061200**********************
061300*
061400     MOVE 'BM03'                 TO MBCA-PROGRAM-LOCATION.
061500     PERFORM MB60PD-SEND-MAP-DATA-ONLY
061600                                 THRU MB60PD-SMDO-EXIT.
061700*
061800************************
061900*    RETURN TO CICS    *
062000************************
062100*
062200     MOVE 'PC04'                 TO MBCA-PROGRAM-LOCATION.
062300     PERFORM MB70PD-RETURN-TRANS-ID
062400                                 THRU MB70PD-RTI-EXIT.
062500/
062600 E000-UPDATE-FILE SECTION.
062700*
062800**************************************************
062900*    READ THE PLATE FILE RECORD FOR UPDATE       *
063000**************************************************
063100*
063200     MOVE 'FC06'                 TO MBCA-PROGRAM-LOCATION.
063300     SET MBIORO-READ-RANDOM-UPDATE
063400                                 TO TRUE.
063500     PERFORM MMPFAO-ACCESS       THRU MMPFAO-ACCESS-EXIT.
063600*
063700*************************************
063800*    OBTAIN STORAGE FOR LOG FILE    *
063900*************************************
064000*
064100     MOVE 'SC02'                 TO MBCA-PROGRAM-LOCATION.
064200     SET MBIORO-GETMAIN          TO TRUE.
064300     PERFORM MML1AO-ACCESS       THRU MML1AO-ACCESS-EXIT.
064400*
064500*************************************************
064600*    SET UP THE COMMON PORTION OF THE RECORD    *
064700*************************************************
064800*
064900     MOVE 'PF'                   TO MML1-FILE-CODE.
065000     MOVE MBCA-MERCHANT-ORG      TO MML1-MMPF-ORG.
065100*
065200     IF  MBCA-S-M IS EQUAL TO 'M'
065300         MOVE MBCA-MERCHANT      TO MML1-MMPF-MERCHANT
065400     ELSE
065500         MOVE MBCA-STORE         TO MML1-MMPF-MERCHANT.
065600*
065700     MOVE MBCA-S-M               TO MML1-MMPF-TYPE.
065800     MOVE MBCA-SIGNON-NAME       TO MML1-SIGNON-NAME.
065900     MOVE MBCA-TERMINAL-ID       TO MML1-TERMINAL-ID.
066000     MOVE ZEROS                  TO MML1-SOURCE-CODE.
066100*
066200 E020-UPDATE-FIELDS.
066300*
066400     IF  MBCA-S-M IS EQUAL TO 'M'
066500         MOVE MMMM-BRANCH        TO MMPF-BRANCH
066600         MOVE MMMM-AGENT-BANK    TO MMPF-AGENT-BANK.
066700*
066800     PERFORM
066900         VARYING X-PL02-PRD FROM 1 BY 1
067000         UNTIL X-PL02-PRD IS GREATER THAN 4
067100         SET  X-MMPF-PRD         TO X-PL02-PRD
067200         EVALUATE TRUE
067300           WHEN (PL02-NBR-PLATES-REQ-L (X-PL02-PRD)
067400                                    IS GREATER THAN ZEROS
067500            AND PL02-NBR-PLATES-REQ (X-PL02-PRD) IS NOT EQUAL
067600                                 TO MMPF-NBR-PLATES-REQ
067700                                    (X-MMPF-PRD))
067800             MOVE 'Y'            TO WS-UPDATE-SW
067900             MOVE PL02-NBR-PLATES-REQ (X-PL02-PRD)
068000                                 TO MMPF-NBR-PLATES-REQ
068100                                    (X-MMPF-PRD)
068200         END-EVALUATE
068300         EVALUATE TRUE
068400           WHEN (PL02-PLATE-TYPE-L (X-PL02-PRD)
068500                                    IS GREATER THAN ZEROS
068600            AND PL02-PLATE-TYPE (X-PL02-PRD) IS NOT EQUAL
068700                                 TO MMPF-PLATE-TYPE
068800                                    (X-MMPF-PRD))
068900             MOVE 'Y'            TO WS-UPDATE-SW
069000             MOVE PL02-PLATE-TYPE (X-PL02-PRD)
069100                                 TO MMPF-PLATE-TYPE
069200                                    (X-MMPF-PRD)
069300         END-EVALUATE
069400     END-PERFORM.
069500*
069600     IF  PL02-USER-DATA-L IS GREATER THAN ZERO
069700         IF  PL02-USER-DATA IS NOT EQUAL TO MMPF-USER-DATA
069800             MOVE 'Y'            TO WS-UPDATE-SW
069900             MOVE PL02-USER-DATA
070000                                 TO MMPF-USER-DATA.
070100*
070200     IF  PL02-USER-CODE-L IS GREATER THAN ZERO
070300         IF  PL02-USER-CODE IS NOT EQUAL TO MMPF-USER-CODE
070400             MOVE 'Y'            TO WS-UPDATE-SW
070500             MOVE PL02-USER-CODE
070600                                 TO MMPF-USER-CODE.
070700*
070800     IF  PL02-USER-NBR1-L IS GREATER THAN ZERO
070900         IF  PL02-USER-NBR1 IS NOT EQUAL TO MMPF-USER-NBR-1
071000             MOVE 'Y'            TO WS-UPDATE-SW
071100             MOVE PL02-USER-NBR1
071200                                 TO MMPF-USER-NBR-1.
071300*
071400     IF  PL02-USER-NBR2-L IS GREATER THAN ZERO
071500         IF  PL02-USER-NBR2 IS NOT EQUAL TO MMPF-USER-NBR-2
071600             MOVE 'Y'            TO WS-UPDATE-SW
071700             MOVE PL02-USER-NBR2
071800                                 TO MMPF-USER-NBR-2.
071900*
072000     IF  PL02-USER-PHONE-L IS GREATER THAN ZERO
072100         IF  PL02-USER-PHONE IS NOT EQUAL TO MMPF-USER-PHONE
072200             MOVE 'Y'            TO WS-UPDATE-SW
072300             MOVE PL02-USER-PHONE
072400                                 TO MMPF-USER-PHONE.
072500*
072600     IF  PL02-USER-NAME-L IS GREATER THAN ZERO
072700         IF  PL02-USER-NAME IS NOT EQUAL TO MMPF-USER-NAME
072800             MOVE 'Y'            TO WS-UPDATE-SW
072900             MOVE PL02-USER-NAME
073000                                 TO MMPF-USER-NAME.
073100*
073200     SET X-MMPF-M-PRIMARY        TO 1.
073300*
073400     PERFORM
073500         VARYING X-PL02-NA FROM 1 BY 1
073600         UNTIL X-PL02-NA IS GREATER THAN 5
073700         SET  X-MMPF-M-NA        TO X-PL02-NA
073800         EVALUATE TRUE
073900           WHEN (PL02-NA-LINE-L (X-PL02-NA) IS GREATER THAN ZERO
074000            AND PL02-NA-LINE (X-PL02-NA) IS NOT EQUAL
074100                                 TO MMPF-M-NA-LINE
074200                                  (X-MMPF-M-PRIMARY X-MMPF-M-NA))
074300             MOVE 'Y'            TO WS-UPDATE-SW
074400             MOVE PL02-NA-LINE (X-PL02-NA)
074500                                 TO MMPF-M-NA-LINE
074600                                  (X-MMPF-M-PRIMARY X-MMPF-M-NA)
074700         END-EVALUATE
074800     END-PERFORM.
074900*
075000     IF  PL02-STATE-L IS GREATER THAN ZERO
075100         IF  PL02-STATE IS NOT EQUAL TO MMPF-M-STATE-CODE
075200                                        (X-MMPF-M-PRIMARY)
075300             MOVE 'Y'            TO WS-UPDATE-SW
075400             MOVE PL02-STATE     TO MMPF-M-STATE-CODE
075500                                  (X-MMPF-M-PRIMARY).
075600*
075700     IF  PL02-PHONE-L IS GREATER THAN ZERO
075800         IF  PL02-PHONE IS NOT EQUAL TO MMPF-M-PHONE
075900                                        (X-MMPF-M-PRIMARY)
076000             MOVE 'Y'            TO WS-UPDATE-SW
076100             MOVE PL02-PHONE     TO MMPF-M-PHONE
076200                                  (X-MMPF-M-PRIMARY).
076300*
076400     IF  PL02-POSTAL-CODE-L IS GREATER THAN ZERO
076500         IF  PL02-POSTAL-CODE IS NOT EQUAL TO MMPF-M-POSTAL-CODE
076600                                            (X-MMPF-M-PRIMARY)
076700             MOVE 'Y'            TO WS-UPDATE-SW
076800             MOVE PL02-POSTAL-CODE
076900                                 TO MMPF-M-POSTAL-CODE
077000                                  (X-MMPF-M-PRIMARY).
077100*
077200     IF  PL02-FAX-L IS GREATER THAN ZERO
077300         IF  PL02-FAX IS NOT EQUAL TO MMPF-M-FAX
077400                                            (X-MMPF-M-PRIMARY)
077500             MOVE 'Y'            TO WS-UPDATE-SW
077600             MOVE PL02-FAX       TO MMPF-M-FAX
077700                                  (X-MMPF-M-PRIMARY).
077800*
077900*
078000 E040-UPDATE-MMPF.
078100*
078200****************************************************
078300*    WRITE A LOG FILE ADD OR REPLACEMENT RECORD    *
078400****************************************************
078500*
078600     IF  MMPF-REC-ACTIVE
078700     AND WS-UPDATE-SW-YES
078800         MOVE MBCA-OPERATOR-ID   TO MMPF-LAST-MAINT-OPER
078900         MOVE MBCA-START-DATE    TO MMPF-LAST-MAINT-DATE
079000         MOVE 0100               TO MML1-FIELD-CODE
079100         MOVE ZEROES             TO MML1-FIELD-OCCURRENCE
079200                                    MML1-FIELD-OCCURRENCE-2
079300         MOVE LENGTH OF MMPF-RECORD
079400                                 TO MML1-VARIABLE-LENGTH
079500         MOVE MMPF-RECORD        TO MML1-ADD-AREA
079600         MOVE 'FC07'             TO MBCA-PROGRAM-LOCATION
079700         PERFORM Y930-WRITE-LOG-RECORD
079800                                 THRU Y939-WLR-EXIT.
079900*
080000     IF  MMPF-REC-INCOMPLETE
080100         MOVE MBCA-OPERATOR-ID   TO MMPF-LAST-MAINT-OPER
080200         MOVE MBCA-START-DATE    TO MMPF-LAST-MAINT-DATE
080300         SET MMPF-REC-ACTIVE     TO TRUE
080400         SET MMPF-ADD-COMPLETED  TO TRUE
080500         MOVE ZEROES             TO MML1-FIELD-CODE
080600                                    MML1-FIELD-OCCURRENCE
080700                                    MML1-FIELD-OCCURRENCE-2
080800         MOVE LENGTH OF MMPF-RECORD
080900                                 TO MML1-VARIABLE-LENGTH
081000         MOVE MMPF-RECORD        TO MML1-ADD-AREA
081100         MOVE 'FC08'             TO MBCA-PROGRAM-LOCATION
081200         PERFORM Y930-WRITE-LOG-RECORD
081300                                 THRU Y939-WLR-EXIT.
081400*
081500*************************************************
081600*    REWRITE THE PLATE FILE RECORD IF FIELDS    *
081700*    HAVE BEEN CHANGED.                         *
081800*************************************************
081900*
082000     MOVE 'FC09'                 TO MBCA-PROGRAM-LOCATION.
082100     SET MBIORO-REWRITE          TO TRUE.
082200     PERFORM MMPFAO-ACCESS       THRU MMPFAO-ACCESS-EXIT.
082300/
082400 F000-SETUP-COMMAREA SECTION.
082500*
082600***************************************************************
082700*  SET UP COMMAREA FIELDS AND TRANSFER TO THE NEXT PROGRAM    *
082800***************************************************************
082900*
083000     MOVE MBCA-EIBAID            TO SS08WS-EIBAID.
083100*
083200     PERFORM MB60PD-EDIT-PAGE-NBR
083300                                 THRU MB60PD-EPN-EXIT.
083400*
083500     IF  SS08WS-VALID-PF-KEY
083600     OR  SS08WS-EIBAID-VALID-PF-KEY
083700         MOVE 99                 TO MBCA-SCREEN-NBR.
083800*
083900     MOVE 'PC05'                 TO MBCA-PROGRAM-LOCATION.
084000     PERFORM MB70PD-XCTL-TO-MBOXCTL
084100                                 THRU MB70PD-XTM-EXIT.
084200*
084300 Y910-READ-MMMM.
084400*
084500     MOVE MMPF-ORG               TO MBIOWS-MMMM-ORG.
084600     MOVE MMPF-MERCHANT-ID       TO MBIOWS-MMMM-MERCHANT.
084700*
084800     SET MBIORO-READ-RANDOM      TO TRUE.
084900     PERFORM MMMMAO-ACCESS       THRU MMMMAO-ACCESS-EXIT.
085000*
085100 Y919-READ-MMMM-EXIT.
085200     EXIT.
085300*
085400 Y930-WRITE-LOG-RECORD.
085500*
085600     SET MBIORO-WRITE            TO TRUE.
085700     PERFORM MML1AO-ACCESS       THRU MML1AO-ACCESS-EXIT.
085800     MOVE SPACES                 TO MML1-VARIABLE-AREA.
085900*
086000 Y939-WLR-EXIT.
086100     EXIT.
086200/
086300 Z000-COPIED-ROUTINES SECTION.
086400*
086500/    NEW ROUTINE FOR JULIAN TO GREGORIAN CONVERSION
086600     COPY SS26PD.
086700*
086800/    ROUTINE TO NUMERICALLY EDIT TIME
086900     COPY SS27PD.
087000*
087100**********************************
087200*    JUL TO GREG DATE ROUTINE    *
087300**********************************
087400*
087500     COPY SS08PD.
087600/
087700*********************************
087800*    LINE 24 PF KEYS ROUTINE    *
087900*********************************
088000*
088100     COPY SS15PD.
088200/
088300*******************************************
088400*    PLATE FILE RECORD ACCESS ROUTINES    *
088500*******************************************
088600*
088700     COPY MMPFAO.
088800/
088900************************************************
089000*    MERCHANT MASTER RECORD ACCESS ROUTINES    *
089100************************************************
089200*
089300     COPY MMMMAO.
089400/
089500*****************************************
089600*    LOG FILE RECORD ACCESS ROUTINES    *
089700*****************************************
089800*
089900     COPY MML1AO.
090000/
090100*****************************
090200*    ONLINE MAP ROUTINES    *
090300*****************************
090400*
090500     COPY MB60PD REPLACING 'MBMAPXX' BY 'MBPL02 '
090600                           MBMAPXXI BY MBPL02I
090700                           MBMAPXXO BY MBPL02O.
090800/
090900***************************
091000*    ONLINE PROCEDURES    *
091100***************************
091200*
091300     COPY MB70PD.
091400/
091500     COPY SMFTPXO.
