000100 IDENTIFICATION DIVISION.
000200 PROGRAM-ID. MBORC00.
000201*       RELEASE DATE=08/24/01.        REVISION LEVEL=08.06      *
000202*****************************************************************
000203*WARNING.  THIS COMPUTER PROGRAM IS PROTECTED BY COPYRIGHT LAW  *
000204*AND INTERNATIONAL TREATIES.  UNAUTHORIZED REPRODUCTION OR      *
000205*DISTRIBUTION OF THIS PROGRAM, OR ANY PORTION OF IT, MAY RESULT *
000206*IN SEVERE CIVIL AND CRIMINAL PENATLIES, AND WILL BE PROSECUTED *
000207*TO THE MAXIMUM EXTENT POSSIBLE UNDER THE LAW.                  *
000208*COPYRIGHT 1999 PAYSYS INTERNATIONAL, INC.  ALL RIGHTS RESERVED.*
000209*****************************************************************
000300*****************************************************************
000400*                                                               *
000500*               M E R C H A N T   S Y S T E M                   *
000600*                                                               *
000700*      MBORC00 - ON-LINE MERCHANT RELATIONSHIPS                 *
000800*                INQUIRY LOCATE SCREEN 00                       *
000900*                                                               *
001000*              1. TRANSIDS                                      *
001100*                 A. MBRC                                       *
001200*              2. MAPS USED -                                   *
001300*                 A. MBRC00 (LOCATE MAP)                        *
001400*              3. FILES USED -                                  *
001500*                 A. MMOC   (ORG CONTROL FILE)                  *
001600*                 B. MMRD   (MERCHANT RELATIONSHIP DETAIL FILE) *
001700*                 C. MMRC   (MERCHANT RELATIONSHIP CONTROL FILE)*
001800*                                                               *
001900*****************************************************************
002000*
002100 ENVIRONMENT DIVISION.
002200 DATA DIVISION.
002300 WORKING-STORAGE SECTION.
002400 01  FILLER                  PIC  X(12)      VALUE '** WS-BEG **'.
002500*         I/O REQUEST BLOCK WORK AREAS
002600     COPY MBIOWS.
002700/         I/O REQUEST BLOCK
002800     COPY MBIORO.
002900/         DATE WORK AREAS
003000     COPY SS01WS.
003100/         ONLINE WORK AREAS
003200     COPY SS08WS.
003300/
003400     COPY SS00WS.
003500/
003600     COPY SMFTWS.
003700/
003800     COPY SMPTRL REPLACING ==:SMPT:== BY ==SMPT==.
003900/
004000     COPY MB61LK.
004100/         STANDARD ERROR MESSAGES
004200     COPY MBEMWS.
004300*
004400 01  WS-MISCELLANEOUS.
004500     03  WS-GROUP-LOW        PIC  9(02)      VALUE 01.
004600     03  WS-GROUP-HIGH       PIC  9(02)      VALUE 06.
004700     03  WS-GROUP-READ-SW    PIC  X(01)      VALUE 'N'.
004800         88  WS-GROUP-READ-NO                VALUE 'N'.
004900         88  WS-GROUP-READ-YES               VALUE 'Y'.
005000     03  WS-ORG-CHAIN-KEY.
005100         05  WS-ORG          PIC  9(03)      VALUE ZEROS.
005200         05  WS-CHAIN        PIC  9(09)      VALUE ZEROS.
005300*
005400 01  FILLER                  PIC  X(12)      VALUE '** WS-END **'.
005500/
005600 LINKAGE SECTION.
005700 01  DFHCOMMAREA.
005800     COPY MB60WS.
005900/         RELATIONSHIP SCREEN 00 MAP DSECT
006000     COPY MBRC00.
006100/         RELATIONSHIP SCREEN 00 MAP REDEFINITION
006200     COPY MBRC00R.
006300/         ORG RECORD LAYOUT
006400     COPY MMOCRL.
006500/         MERCHANT RELATIONSHIP DETAIL RECORD LAYOUT
006600     COPY MMRDRL REPLACING ==:MMRD:== BY ==MMRD==.
006700/         MERCHANT RELATIONSHIP CONTROL RECORD LAYOUT
006800     COPY MMRCRL.
006900/
007000 PROCEDURE DIVISION.
007100 0000-HOUSEKEEPING SECTION.
007200 0100-INIT.
007300*
007400     MOVE 'PC01'                 TO MBCA-PROGRAM-LOCATION.
007500     PERFORM MB70PD-ON-LINE-HOUSEKEEPING
007600                                 THRU MB70PD-OLH-EXIT.
007700*
007800     IF  MBCA-RECEIVE-SCREEN
007900         GO TO 2000-RECEIVE-SCREEN.
008000*
008100 1000-SEND-SCREEN SECTION.
008200*
008300****************************************************************
008400*    GET CICS STORAGE NEEDED FOR THE MAP                       *
008500****************************************************************
008600*
008700     MOVE 'SC01'                 TO MBCA-PROGRAM-LOCATION.
008800     PERFORM MB60PD-GETMAIN-FOR-MAP
008900                                 THRU MB60PD-GFM-EXIT.
009000*
009100*****************************************************************
009200*    CHECK KEY CODES                                            *
009300* 1. IF INITIAL KEY CODE, BYPASS CHECK OF KEY CODES.            *
009400* 2. IF MMRD KEY CODE, IT MUST BE A VALID CODE.  IF DIRECT, GO  *
009500*    TO THE RECEIVE EDITING ROUTINE SINCE WE HAVE PLUGGED THE   *
009600*    ORG, MERCHANT, AND GROUP NUMBER IN THE MAP. IF AN ERROR    *
009700*    OCCURS IN THE RECEIVE SCREEN ROUTINE, IT WILL HANDLE       *
009800*    BUILDING THE MAP AND IT WILL SEND ITS OWN SCREEN.  THIS IS *
009900*    WHY LOCATE PROGRAMS ALWAYS SEND WITH ERASE NO MATTER WHICH *
010000*    ROUTINE YOU ARE IN.  IF NOT DIRECT, PLUG ORG, MERCHANT     *
010100*    CHAIN AND GROUP NUMBER INTO THE MAP AND BYPASS ANY OTHER   *
010200*    CHECKING OF THE KEY CODE.                                  *
010300* 3. IF 2 IS FALSE, SEE IF THE MBCA-MERCHANT-ORG                *
010400*    FIELD IS GREATER THAN ZERO.  IF SO, PLUG INTO MAP. SEE IF  *
010500*    MBCA-CHAIN IS GREATER THAN ZERO. IF SO, PLUG INTO MAP.     *
010600*    SEE IF MBCA-GROUP-NBR IS GREATER THAN ZERO. IF SO, PLUG    *
010700*    INTO MAP. HANDLE IF THEY WERE NON-DIRECT.                  *
010800*****************************************************************
010900*
011000     IF  MBCA-INITIAL-KEY-CODE
011100         GO TO 1100-BUILD-SCREEN.
011200*
011300     IF  MBCA-MMRD-KEY-CODE
011400     AND MBCA-MERCHANT-ORG IS GREATER THAN ZERO
011500     AND MBCA-CHAIN         IS GREATER THAN ZERO
011600         MOVE MBCA-MERCHANT-ORG  TO RC00-ORG
011700         MOVE MBCA-CHAIN         TO RC00-CHAIN
011800         MOVE DFHBMUNF           TO RC00-ORG-A
011900                                    RC00-CHAIN-A
012000         IF  MBCA-DIRECT-TRANSFER-CODE
012100         AND MBCA-INITIAL-SCREEN-NBR
012200             MOVE 00             TO MBCA-SCREEN-NBR
012300             GO TO 2120-READ-ORG.
012400*
012500 1100-BUILD-SCREEN.
012600*
012700****************************************************************
012800*    INITIALIZE THE STANDARD MAP LINES                         *
012900****************************************************************
013000*
013100     MOVE SS08WS-CURSOR          TO RC00-ORG-L.
013200     MOVE 00                     TO MBCA-SCREEN-NBR.
013300     PERFORM MB60PD-INIT-STD-MAP-LINES
013400                                 THRU MB60PD-ISML-EXIT.
013500*
013600     IF  MBCA-VALID-KEY-CODES
013700     AND MBCA-MERCHANT-ORG IS GREATER THAN ZERO
013800         MOVE MBCA-MERCHANT-ORG TO RC00-ORG
013900         MOVE DFHBMUNF           TO RC00-ORG-A
014000         IF  MBCA-CHAIN IS GREATER THAN ZERO
014100             MOVE MBCA-CHAIN     TO RC00-CHAIN
014200             MOVE DFHBMUNF       TO RC00-CHAIN-A.
014300*
014400     MOVE DFHBMASK               TO RC00-CURRENT-PAGE-A.
014500*
014600****************************************************************
014700*    SEND THE MAP                                              *
014800****************************************************************
014900*
015000     MOVE 'BM01'                 TO MBCA-PROGRAM-LOCATION.
015100     PERFORM MB60PD-SEND-MAP-WITH-ERASE
015200                                 THRU MB60PD-SMWE-EXIT.
015300*
015400****************************************************************
015500*    RETURN TO CICS                                            *
015600****************************************************************
015700*
015800     MOVE 'PC02'                 TO MBCA-PROGRAM-LOCATION.
015900     PERFORM MB70PD-RETURN-TRANS-ID
016000                                 THRU MB70PD-RTI-EXIT.
016100/
016200 2000-RECEIVE-SCREEN SECTION.
016300*
016400****************************************************************
016500*    THIS SECTION RECEIVES THE LOCATE SCREEN                   *
016600****************************************************************
016700*
016800     MOVE 'BM02'                 TO MBCA-PROGRAM-LOCATION.
016900     PERFORM MB60PD-RECEIVE-MAP  THRU MB60PD-RM-EXIT.
017000*
017100****************************************************************
017200*    CHECK FOR ANOTHER TRANSACTION ID ENTERED BY THE USER      *
017300****************************************************************
017400*
017500     MOVE 'PC03'                 TO MBCA-PROGRAM-LOCATION.
017600     PERFORM MB60PD-NEW-TRANS-ROUTINE
017700                                 THRU MB60PD-NTR-EXIT.
017800*
017900 2100-EDIT-SCREEN.
018000*
018100     MOVE 'N'                    TO SS08WS-ERROR.
018200     MOVE MBCA-EIBAID            TO SS08WS-EIBAID.
018300*
018400     IF  (RC00-ORG-L IS LESS THAN 1
018500     AND  RC00-CHAIN-L IS LESS THAN 1)
018600     AND (SS08WS-VALID-PF-KEY
018700     OR   SS08WS-EIBAID-VALID-PF-KEY)
018800         MOVE 99                 TO MBCA-SCREEN-NBR
018900         GO TO 2690-TRANSFER-XCTL.
019000*
019100 2110-EDIT-ORG.
019200*
019300     MOVE DFHBMUNF               TO RC00-ORG-A.
019400     MOVE DFHBMASK               TO RC00-ORG-LP-A
019500                                    RC00-ORG-RP-A.
019600*
019700     IF  RC00-ORG-L IS EQUAL TO ZERO
019800     OR  RC00-ORG IS NOT NUMERIC
019900         MOVE MBEMWS-INVALID-ORG TO RC00-ERR-MESSAGE
020000         GO TO 2130-ORG-ERROR.
020100*
020200     IF  RC00-ORG IS LESS THAN MBCA-ORG-LOW
020300     OR  RC00-ORG IS GREATER THAN MBCA-ORG-HIGH
020400         MOVE MBEMWS-INVALID-ORG TO RC00-ERR-MESSAGE
020500         GO TO 2130-ORG-ERROR.
020600*
020700 2120-READ-ORG.
020800*
020900****************************************************************
021000*    READ THE ORGANIZATION FILE                                *
021100****************************************************************
021200*
021300     MOVE 'FC01'                 TO MBCA-PROGRAM-LOCATION.
021400     MOVE RC00-ORG               TO MBIOWS-MMOC-ORG.
021500     MOVE SS08WS-CICS-FC-NOTFND  TO MBIORO-TEMP-STATUS-1.
021600     SET MBIORO-READ-RANDOM      TO TRUE.
021700     PERFORM MMOCAO-ACCESS       THRU MMOCAO-ACCESS-EXIT.
021800*
021900     IF  SS08WS-RC-FC-VALID-RTN-CODE
022000         MOVE RC00-ORG           TO MBCA-MERCHANT-ORG
022100         IF  MMOC-ADD-PENDING
022200             MOVE MBEMWS-ADD-PENDING
022300                                 TO RC00-ERR-MESSAGE
022400         ELSE
022500             IF  MMOC-REC-INCOMPLETE
022600             OR  MMOC-REC-PURGED
022700                 MOVE MBEMWS-NOT-ACTIVE
022800                                 TO RC00-ERR-MESSAGE
022900             ELSE
023000                 GO TO 2140-EDIT-CHAIN
023100     ELSE
023200         MOVE MBEMWS-NOT-ON-FILE TO RC00-ERR-MESSAGE.
023300*
023400 2130-ORG-ERROR.
023500*
023600     MOVE DFHBMNBF               TO RC00-ORG-A.
023700     MOVE DFHBMASB               TO RC00-ORG-LP-A
023800                                    RC00-ORG-RP-A.
023900     MOVE SS08WS-CURSOR          TO RC00-ORG-L.
024000     MOVE 'Y'                    TO SS08WS-ERROR.
024100*
024200 2140-EDIT-CHAIN.
024300*
024400     MOVE DFHBMUNF               TO RC00-CHAIN-A.
024500     MOVE DFHBMASK               TO RC00-CHAIN-LP-A
024600                                    RC00-CHAIN-RP-A.
024700*
024800     IF  MBCA-DIRECT-TRANSFER-CODE
024900         GO TO 2145-CHAIN-READ.
025000*
025100     IF  RC00-CHAIN-L IS EQUAL TO ZERO
025200     OR  RC00-CHAIN IS NOT NUMERIC
025300         MOVE MBEMWS-INVALID-CHAIN
025400                                 TO RC00-ERR-MESSAGE
025500         GO TO 2150-CHAIN-ERROR.
025600*
025700 2145-CHAIN-READ.
025800*
025900****************************************************************
026000*    READ THE CHAIN CONTROL RECORD                             *
026100****************************************************************
026200*
026300     IF  SS08WS-ERROR IS EQUAL TO 'Y'
026400         GO TO 2160-READ-MMRD.
026500*
026600     MOVE 'FC02'                 TO MBCA-PROGRAM-LOCATION.
026700     MOVE RC00-ORG               TO MBIOWS-MMRC-ORG.
026800     MOVE RC00-CHAIN             TO MBIOWS-MMRC-CHAIN.
026900     MOVE SS08WS-CICS-FC-NOTFND  TO MBIORO-TEMP-STATUS-1.
027000     SET MBIORO-READ-RANDOM      TO TRUE.
027100     PERFORM MMRCAO-ACCESS       THRU MMRCAO-ACCESS-EXIT.
027200*
027300     IF  SS08WS-RC-FC-NOTFND
027400         MOVE MBEMWS-NOT-ON-FILE TO RC00-ERR-MESSAGE
027500     ELSE
027600         IF  MMRC-ADD-PENDING
027700             MOVE MBEMWS-ADD-PENDING
027800                                 TO RC00-ERR-MESSAGE
027900         ELSE
028000             IF  MMRC-REC-INCOMPLETE
028100             OR  MMRC-REC-PURGED
028200                 MOVE MBEMWS-NOT-ACTIVE
028300                                 TO RC00-ERR-MESSAGE
028400             ELSE
028500                 MOVE RC00-CHAIN
028600                                 TO MBCA-CHAIN
028700                 MOVE MMRC-NA-LINE (1)
028800                                 TO MBCA-MBRC-NAME
028900                 GO TO 2160-READ-MMRD.
029000*
029100 2150-CHAIN-ERROR.
029200*
029300     MOVE DFHBMNBF               TO RC00-CHAIN-A.
029400     MOVE DFHBMASB               TO RC00-CHAIN-LP-A
029500                                    RC00-CHAIN-RP-A.
029600     MOVE SS08WS-CURSOR          TO RC00-CHAIN-L.
029700     MOVE 'Y'                    TO SS08WS-ERROR.
029800*
029900 2160-READ-MMRD.
030000*
030100****************************************************************
030200*    READ THE CHAIN FILE GROUP RECORD                          *
030300****************************************************************
030400*
030500     IF  SS08WS-ERROR IS EQUAL TO 'Y'
030600         GO TO 2290-CHECK-ERROR.
030700*
030800****************************************************************
030900*    START BROWSE THE CHAIN FILE                               *
031000****************************************************************
031100*
031200     MOVE 'FC03'                 TO MBCA-PROGRAM-LOCATION.
031300     MOVE MBCA-MERCHANT-ORG      TO MBIOWS-MMRD-ORG.
031400     MOVE RC00-CHAIN             TO MBIOWS-MMRD-CHAIN.
031500     MOVE ZEROS                  TO MBIOWS-MMRD-SEQ-NBR.
031600     SET MBIORO-STARTBR-GTE      TO TRUE.
031700     PERFORM MMRDAO-ACCESS       THRU MMRDAO-ACCESS-EXIT.
031800*
031900 2165-READ-NEXT.
032000*
032100****************************************************************
032200*    READNEXT THE CHAIN FILE                                   *
032300****************************************************************
032400*
032500     MOVE 'FC04'                 TO MBCA-PROGRAM-LOCATION.
032600     SET MBIORO-READ-SEQ         TO TRUE.
032700     PERFORM MMRDAO-ACCESS       THRU MMRDAO-ACCESS-EXIT.
032800*
032900     MOVE MBCA-ORG-MERCHANT      TO WS-ORG.
033000     MOVE MBCA-CHAIN             TO WS-CHAIN.
033100*
033200     IF  MMRD-ORG-CHAIN IS GREATER THAN WS-ORG-CHAIN-KEY
033300         MOVE 'NO RECORDS ON FILE FOR THE SELECTION CRITERIA'
033400                                 TO RC00-ERR-MESSAGE
033500         MOVE DFHBMNBF           TO RC00-ORG-A
033600         MOVE DFHBMASB           TO RC00-ORG-LP-A
033700                                    RC00-ORG-RP-A
033800         MOVE SS08WS-CURSOR      TO RC00-ORG-L
033900     ELSE
034000         IF  MMRD-NBR-OF-MEMBERS IS EQUAL TO ZEROES
034100             GO TO 2165-READ-NEXT
034200         ELSE
034300             PERFORM 9100-FIND-FIRST-MEMBER
034400                                 THRU 9199-FFM-EXIT
034500             IF  WS-GROUP-READ-YES
034600                 GO TO 2165-READ-NEXT
034700             ELSE
034800                 SET MBCA-MBRC-FIRST-INDEX
034900                                 TO X-MMRD-MEMBER
035000                 SET MBCA-MBRC-FWD-INDEX
035100                                 TO X-MMRD-MEMBER
035200                 MOVE ' '        TO MBCA-MBRC-RETURN-FLAG
035300                 MOVE 'Y'        TO MBCA-MBRC-FIRST-TIME-FLAG
035400                 MOVE ZEROES     TO MBCA-MBRC-BACK-SEQ-NBR
035500                                    MBCA-MBRC-BACK-INDEX
035600                 MOVE MMRD-SEQ-NBR
035700                                 TO MBCA-MBRC-FIRST-SEQ-NBR
035800                                    MBCA-MBRC-FWD-SEQ-NBR
035900                 MOVE 'FC06'     TO MBCA-PROGRAM-LOCATION
036000                 SET MBIORO-ENDBR
036100                                 TO TRUE
036200                 PERFORM MMRDAO-ACCESS
036300                                 THRU MMRDAO-ACCESS-EXIT
036400                 GO TO 2290-CHECK-ERROR.
036500*
036600****************************************************************
036700*    END BROWSE THE CHAIN FILE                                 *
036800****************************************************************
036900*
037000     MOVE 'FC05'                 TO MBCA-PROGRAM-LOCATION.
037100     SET MBIORO-ENDBR            TO TRUE.
037200     PERFORM MMRDAO-ACCESS       THRU MMRDAO-ACCESS-EXIT.
037300*
037400 2170-CHAIN-DETAIL-ERROR.
037500*
037600     MOVE DFHBMNBF               TO RC00-CHAIN-A.
037700     MOVE DFHBMASB               TO RC00-CHAIN-LP-A
037800                                    RC00-CHAIN-RP-A.
037900     MOVE SS08WS-CURSOR          TO RC00-CHAIN-L.
038000     MOVE 'Y'                    TO SS08WS-ERROR.
038100*
038200 2290-CHECK-ERROR.
038300*
038400     IF  SS08WS-ERROR IS EQUAL TO 'N'
038500         GO TO 2600-SETUP-COMMAREA
038600     ELSE
038700         IF  SS08WS-VALID-PF-KEY
038800         OR  SS08WS-EIBAID-VALID-PF-KEY
038900             MOVE 99             TO MBCA-SCREEN-NBR
039000             GO TO 2690-TRANSFER-XCTL.
039100*
039200 2300-SEND-MAP.
039300*
039400****************************************************************
039500*    SEND THE MAP                                              *
039600****************************************************************
039700*
039800     PERFORM MB60PD-INIT-STD-MAP-LINES
039900                                 THRU MB60PD-ISML-EXIT.
040000*
040100     MOVE DFHBMASK               TO RC00-CURRENT-PAGE-A.
040200*
040300     MOVE 'BM03'                 TO MBCA-PROGRAM-LOCATION.
040400     PERFORM MB60PD-SEND-MAP-WITH-ERASE
040500                                 THRU MB60PD-SMWE-EXIT.
040600*
040700****************************************************************
040800*    RETURN TO CICS                                            *
040900****************************************************************
041000*
041100     MOVE 'PC04'                 TO MBCA-PROGRAM-LOCATION.
041200     PERFORM MB70PD-RETURN-TRANS-ID
041300                                 THRU MB70PD-RTI-EXIT.
041400/
041500 2600-SETUP-COMMAREA.
041600*
041700****************************************************************
041800*    SET UP COMMAREA FIELDS AND TRANSFER TO THE NEXT PROGRAM   *
041900****************************************************************
042000*
042100     MOVE MBCA-EIBAID            TO SS08WS-EIBAID.
042200*
042300     MOVE MBIOWS-MMRD-DIRECT-KEY-CODE
042400                                 TO MBCA-KEY-CODE.
042500*
042600     PERFORM MB60PD-EDIT-PAGE-NBR
042700                                 THRU MB60PD-EPN-EXIT.
042800*
042900     IF  SS08WS-VALID-PF-KEY
043000     OR  SS08WS-EIBAID-VALID-PF-KEY
043100         MOVE 99                 TO MBCA-SCREEN-NBR.
043200*
043300 2690-TRANSFER-XCTL.
043400*
043500     MOVE 'PC05'                 TO MBCA-PROGRAM-LOCATION.
043600     PERFORM MB70PD-XCTL-TO-MBOXCTL
043700                                 THRU MB70PD-XTM-EXIT.
043800/
043900*
044000 9100-FIND-FIRST-MEMBER.
044100*
044200     SET X-MMRD-MEMBER           TO +1.
044300     MOVE 'N'                    TO WS-GROUP-READ-SW.
044400*
044500 9100-FIND-LOOP.
044600*
044700     IF  X-MMRD-MEMBER IS GREATER THAN +800
044800         MOVE 'Y'                TO WS-GROUP-READ-SW
044900         GO TO 9199-FFM-EXIT.
045000*
045100     IF  MMRD-MEMBER (X-MMRD-MEMBER) IS EQUAL TO ZEROES
045200         SET X-MMRD-MEMBER       UP BY +1
045300         GO TO 9100-FIND-LOOP.
045400*
045500 9199-FFM-EXIT.
045600     EXIT.
045700/         NEW ROUTINE FOR JULIAN TO GREGORIAN CONVERSION
045800     COPY SS26PD.
045900/         ROUTINE TO NUMERICALLY EDIT TIME
046000     COPY SS27PD.
046100/         JULIAN TO GREGORIAN DATE ROUTINE
046200     COPY SS08PD.
046300/         LINE 24 PF KEYS ROUTINE
046400     COPY SS15PD.
046500/         ORG FILE RECORD 1 ACCESS ROUTINES
046600     COPY MMOCAO.
046700/         MERCHANT RELATIONSHIP FILE CONTROL ACCESS ROUTINES
046800     COPY MMRCAO.
046900/         MERCHANT RELATIONSHIP FILE DETAIL ACCESS ROUTINES
047000     COPY MMRDAO.
047100/         ON-LINE MAP ROUTINES
047200     COPY MB60PD REPLACING 'MBMAPXX' BY 'MBRC00 '
047300                           MBMAPXXI BY MBRC00I
047400                           MBMAPXXO BY MBRC00O.
047500/         ON-LINE PROCEDURES
047600     COPY MB70PD.
047700/
047800     COPY SMFTPXO.
