000100 IDENTIFICATION DIVISION.
000200 PROGRAM-ID. MBORG01.
000201*       RELEASE DATE=08/24/01.        REVISION LEVEL=08.06      *
000202*****************************************************************
000203*WARNING.  THIS COMPUTER PROGRAM IS PROTECTED BY COPYRIGHT LAW  *
000204*AND INTERNATIONAL TREATIES.  UNAUTHORIZED REPRODUCTION OR      *
000205*DISTRIBUTION OF THIS PROGRAM, OR ANY PORTION OF IT, MAY RESULT *
000206*IN SEVERE CIVIL AND CRIMINAL PENATLIES, AND WILL BE PROSECUTED *
000207*TO THE MAXIMUM EXTENT POSSIBLE UNDER THE LAW.                  *
000208*COPYRIGHT 1999 PAYSYS INTERNATIONAL, INC.  ALL RIGHTS RESERVED.*
000209*****************************************************************
000300*****************************************************************
000400*                                                               *
000500*               M E R C H A N T   S Y S T E M                   *
000600*                                                               *
000700*      MBORG01 - ON-LINE STORE RELATIONSHIPS                    *
000800*                INQUIRY SCREEN 01                              *
000900*                                                               *
001000*              1. TRANSIDS                                      *
001100*                 A. MBRG                                       *
001200*              2. MAPS USED -                                   *
001300*                 A. MBRG01 (SCREEN 01)                         *
001400*              3. FILES USED -                                  *
001500*                 A. MMSD   (STORE RELATIONSHIP FILE)           *
001600*                 B. MMSM   (STORE MASTER FILE)                 *
001700*                                                               *
001800*****************************************************************
001900*
002000 ENVIRONMENT DIVISION.
002100 DATA DIVISION.
002200 WORKING-STORAGE SECTION.
002300 01  FILLER                  PIC  X(12)      VALUE '** WS-BEG **'.
002400*         I/O REQUEST BLOCK WORK AREAS
002500     COPY MBIOWS.
002600/         I/O REQUEST BLOCK
002700     COPY MBIORO.
002800/         DATE WORK AREAS
002900     COPY SS01WS.
003000/         ONLINE WORK AREAS
003100     COPY SS08WS.
003200/
003300     COPY SS00WS.
003400/
003500     COPY SMFTWS.
003600/
003700     COPY SMPTRL REPLACING ==:SMPT:== BY ==SMPT==.
003800/
003900     COPY MB61LK.
004000/
004100 01  WS-MISCELLANEOUS.
004200     03  WS-SAVE-EIBAID      PIC  X(01)      VALUE SPACES.
004300     03  WS-FWD-INDEX        PIC S9(04)      VALUE ZEROES BINARY.
004400     03  WS-HOLD-FWD-SEQ-NBR PIC  S9(04)     BINARY VALUE ZERO.
004500     03  WS-SELECT-SW        PIC  X(01)      VALUE 'N'.
004600         88  WS-SELECT-NO                    VALUE 'N'.
004700         88  WS-SELECT-YES                   VALUE 'Y'.
004800     03  WS-BYPASS-SW        PIC  X(01)      VALUE 'N'.
004900         88  WS-BYPASS-NO                    VALUE 'N'.
005000         88  WS-BYPASS-YES                   VALUE 'Y'.
005100     03  TS-QUEUE-NAME.
005200         05  TS-QN-TERMID    PIC  X(04)      VALUE SPACES.
005300         05  TS-QN-TRANID    PIC  X(04)      VALUE 'MBRG'.
005400*
005500 01  WS-DETAIL-LINE.
005600     03  WS-STORE-NBR        PIC  9(09).
005700     03  FILLER              PIC  X(02)      VALUE SPACES.
005800     03  WS-STORE-NAME       PIC  X(30).
005900     03  FILLER              PIC  X(07)      VALUE SPACES.
006000     03  WS-AUTH-CODE        PIC  X(01).
006100     03  FILLER              PIC  X(07)      VALUE SPACES.
006200     03  WS-SETT-FLAG        PIC  X(01).
006300     03  FILLER              PIC  X(05)      VALUE SPACES.
006400     03  WS-REC-STATUS       PIC  9(01).
006500     03  FILLER              PIC  X(04)      VALUE SPACES.
006600*
006700 01  FILLER                  PIC  X(12)      VALUE '** WS-END **'.
006800/
006900 LINKAGE SECTION.
007000 01  DFHCOMMAREA.
007100     COPY MB60WS.
007200/         STORE RELATIONSHIP SCREEN 01 MAP DSECT
007300     COPY MBRG01.
007400/         STORE RELATIONSHIP SCREEN 01 MAP REDEFINITION
007500     COPY MBRG01R.
007600/         STORE RELATIONSHIP RECORD LAYOUT
007700     COPY MMSDRL REPLACING ==:MMSD:== BY ==MMSD==.
007800/         STORE MASTER RECORD LAYOUT
007900     COPY MMSMRL.
008000/         RELATIONSHIP TEMPORARY STORAGE
008100 01  TS-MBRG-RECORD.
008200     03  TS-MBRG-KEY-AREA                    OCCURS 15 TIMES
008300                                             INDEXED BY
008400                                             X-TS-MBRG-INDEX.
008500         05  TS-MBRG-STORE
008600                             PIC  9(09).
008700         05  TS-MBRG-STORE-NAME
008800                             PIC  X(30).
008900         05  TS-MBRG-AUTH-CODE
009000                             PIC  X(01).
009100         05  TS-MBRG-SETT-FLAG
009200                             PIC  X(01).
009300         05  TS-MBRG-REC-STATUS
009400                             PIC  9(01).
009500/
009600 PROCEDURE DIVISION.
009700 0000-HOUSEKEEPING SECTION.
009800 0100-INIT.
009900*
010000     MOVE MBCA-EIBAID            TO WS-SAVE-EIBAID.
010100     SET MBCA-EIBAID-ENTER       TO TRUE.
010200*
010300     MOVE 'PC01'                 TO MBCA-PROGRAM-LOCATION.
010400     PERFORM MB70PD-ON-LINE-HOUSEKEEPING
010500                                 THRU MB70PD-OLH-EXIT.
010600*
010700     MOVE WS-SAVE-EIBAID         TO MBCA-EIBAID.
010800     MOVE MBCA-TERMINAL-ID       TO TS-QN-TERMID.
010900*
011000     IF  MBCA-RECEIVE-SCREEN
011100         GO TO 2000-RECEIVE-SCREEN.
011200*
011300 1000-SEND-SCREEN SECTION.
011400*
011500****************************************************************
011600*    GET CICS STORAGE NEEDED FOR THE MAP                       *
011700****************************************************************
011800*
011900     MOVE 'SC01'                 TO MBCA-PROGRAM-LOCATION.
012000     PERFORM MB60PD-GETMAIN-FOR-MAP
012100                                 THRU MB60PD-GFM-EXIT.
012200*
012300     MOVE MBCA-MERCHANT-ORG      TO RG01-ORG
012400                                    MBIOWS-MMSM-ORG.
012500     MOVE MBCA-S-CHAIN           TO RG01-CHAIN.
012600     MOVE MBCA-MBRG-NAME         TO RG01-CHAIN-NAME.
012700     MOVE 01                     TO MBCA-SCREEN-NBR.
012800*
012900****************************************************************
013000*    INITIALIZE THE STANDARD MAP LINES                         *
013100****************************************************************
013200*
013300     PERFORM MB60PD-INIT-STD-MAP-LINES
013400                                 THRU MB60PD-ISML-EXIT.
013500*
013600****************************************************************
013700*    ACQUIRE MAIN STORAGE FOR STORE MASTER RECORD              *
013800****************************************************************
013900*
014000     MOVE 'SC02'                 TO MBCA-PROGRAM-LOCATION.
014100     SET MBIORO-GETMAIN          TO TRUE.
014200     PERFORM MMSMAO-ACCESS       THRU MMSMAO-ACCESS-EXIT.
014300*
014400     MOVE ZEROES                 TO MMSM-ORG
014500                                    MMSM-STORE.
014600*
014700****************************************************************
014800*    ACQUIRE MAIN STORAGE FOR TEMP STORAGE RECORD              *
014900****************************************************************
015000*
015100     MOVE 'TS01'                 TO MBCA-PROGRAM-LOCATION.
015200     PERFORM 8100-TEMP-STORAGE-GETMAIN
015300                                 THRU 8199-TSG-EXIT.
015400*
015500     EXEC CICS HANDLE CONDITION
015600               QIDERR (1010-CHECK-RETURN-FLAG)
015700          END-EXEC.
015800*
015900***********************************************
016000*    READ THE TEMP STORAGE RECORD             *
016100***********************************************
016200*
016300     MOVE 'TS02'                 TO MBCA-PROGRAM-LOCATION.
016400     PERFORM 8200-TEMP-STORAGE-READ
016500                                 THRU 8299-TSR-EXIT.
016600*
016700***********************************************
016800*    DELETE THE TEMP STORAGE RECORD           *
016900***********************************************
017000*
017100     MOVE 'TS03'                 TO MBCA-PROGRAM-LOCATION.
017200     PERFORM 8300-TEMP-STORAGE-DELETE
017300                                 THRU 8399-TSD-EXIT.
017400*
017500     IF  MBCA-MBRG-FIRST-TIME
017600         GO TO 1010-CHECK-RETURN-FLAG.
017700*
017800     PERFORM 8800-BUILD-SCREEN   THRU 8899-BS-EXIT.
017900     GO TO 1080-CONTINUE.
018000*
018100 1010-CHECK-RETURN-FLAG.
018200*
018300     MOVE 'N'                    TO MBCA-MBRG-FIRST-TIME-FLAG.
018400*
018500     IF  MBCA-MBRG-RETURN-BOTTOM
018600         PERFORM 8900-LAST-SCREEN
018700                                 THRU 8999-LS-EXIT
018800         IF  WS-BYPASS-YES
018900             GO TO 1015-READ-RELATIONSHIP
019000         ELSE
019100             GO TO 1080-CONTINUE
019200     ELSE
019300         IF  MBCA-MBRG-RETURN-BWD
019400             PERFORM 9000-BACK-SCREEN
019500                                 THRU 9099-BS-EXIT
019600             IF  WS-BYPASS-YES
019700                 GO TO 1015-READ-RELATIONSHIP
019800             ELSE
019900                 GO TO 1080-CONTINUE.
020000*
020100 1015-READ-RELATIONSHIP.
020200*
020300****************************************************************
020400*    READ RANDOM THE STORE RELATIONSHIP FILE                   *
020500****************************************************************
020600*
020700     MOVE 'FC01'                 TO MBCA-PROGRAM-LOCATION.
020800     PERFORM 9200-READ-RELATIONSHIP
020900                                 THRU 9299-RR-EXIT.
021000*
021100     SET X-STORE-INDEX           TO +1.
021200     SET X-MMSD-MEMBER           TO MBCA-MBRG-FWD-INDEX.
021300*
021400 1020-MEMBER-LOOP.
021500*
021600     IF  MBCA-MBRG-FWD-INDEX IS GREATER THAN +800
021700         COMPUTE MBCA-MBRG-FWD-SEQ-NBR
021800                                 = MBCA-MBRG-FWD-SEQ-NBR + 1
021900         PERFORM 9200-READ-RELATIONSHIP
022000                                 THRU 9299-RR-EXIT
022100         IF  SS08WS-RC-FC-NOTFND
022200             GO TO 1060-SET-ATTRIBUTE
022300         ELSE
022400             MOVE +1             TO MBCA-MBRG-FWD-INDEX
022500             SET X-MMSD-MEMBER
022600                                 TO MBCA-MBRG-FWD-INDEX.
022700*
022800     IF  MMSD-MEMBER (X-MMSD-MEMBER) IS EQUAL TO ZEROES
022900         SET X-MMSD-MEMBER       UP BY +1
023000         SET MBCA-MBRG-FWD-INDEX TO X-MMSD-MEMBER
023100         GO TO 1020-MEMBER-LOOP.
023200*
023300     PERFORM 9400-BUILD-SCREEN-LINE
023400                                 THRU 9499-BSL-EXIT.
023500*
023600     IF  X-STORE-INDEX IS EQUAL TO +1
023700         SET MBCA-MBRG-BACK-INDEX
023800                                 TO X-MMSD-MEMBER
023900         MOVE MMSD-SEQ-NBR       TO MBCA-MBRG-BACK-SEQ-NBR.
024000*
024100     IF  X-STORE-INDEX IS LESS THAN +15
024200         SET X-STORE-INDEX       UP BY +1
024300         SET X-MMSD-MEMBER       UP BY +1
024400         SET MBCA-MBRG-FWD-INDEX TO X-MMSD-MEMBER
024500         GO TO 1020-MEMBER-LOOP
024600     ELSE
024700         SET MBCA-MBRG-FWD-INDEX TO X-MMSD-MEMBER
024800         MOVE MMSD-SEQ-NBR       TO MBCA-MBRG-FWD-SEQ-NBR
024900         PERFORM 9300-READ-AHEAD THRU 9399-RA-EXIT
025000         SET X-STORE-INDEX       UP BY +1.
025100*
025200 1060-SET-ATTRIBUTE.
025300*
025400     IF  X-STORE-INDEX IS EQUAL TO +1
025500         IF  MBCA-MBRG-RETURN-NORMAL
025600             MOVE 99             TO MBCA-SCREEN-NBR
025700             MOVE MBIOWS-MMSD-KEY-CODE
025800                                 TO MBCA-KEY-CODE
025900             MOVE 'PC02'         TO MBCA-PROGRAM-LOCATION
026000             PERFORM MB70PD-XCTL-TO-MBOXCTL
026100                                 THRU MB70PD-XTM-EXIT
026200         ELSE
026300             MOVE MBCA-MBRG-BACK-INDEX
026400                                 TO MBCA-MBRG-FWD-INDEX
026500             MOVE MBCA-MBRG-BACK-SEQ-NBR
026600                                 TO MBCA-MBRG-FWD-SEQ-NBR
026700             SET X-MMSD-MEMBER   TO MBCA-MBRG-FWD-INDEX
026800             GO TO 1020-MEMBER-LOOP.
026900*
027000     IF  X-STORE-INDEX IS LESS THAN +16
027100         SET X-TS-MBRG-INDEX     TO X-STORE-INDEX
027200         MOVE ZEROES             TO MBCA-MBRG-FWD-INDEX
027300                                    WS-FWD-INDEX
027400                                    MBCA-MBRG-FWD-SEQ-NBR
027500                                    TS-MBRG-STORE
027600                                    (X-TS-MBRG-INDEX)
027700                                    TS-MBRG-REC-STATUS
027800                                    (X-TS-MBRG-INDEX)
027900         MOVE SPACES             TO TS-MBRG-STORE-NAME
028000                                    (X-TS-MBRG-INDEX)
028100                                    TS-MBRG-AUTH-CODE
028200                                    (X-TS-MBRG-INDEX)
028300                                    TS-MBRG-SETT-FLAG
028400                                    (X-TS-MBRG-INDEX)
028500         MOVE DFHBMASK           TO RG01-SELECT-A
028600                                    (X-STORE-INDEX)
028700         MOVE DFHBMDAS           TO RG01-DIRECTORY-LINE-A
028800                                    (X-STORE-INDEX)
028900                                    RG01-SELECT-LP-A
029000                                    (X-STORE-INDEX)
029100                                    RG01-SELECT-RP-A
029200                                    (X-STORE-INDEX)
029300         SET X-STORE-INDEX       UP BY +1
029400         GO TO 1060-SET-ATTRIBUTE.
029500*
029600 1080-CONTINUE.
029700*
029800     IF (MBCA-MBRG-BACK-SEQ-NBR IS NOT EQUAL
029900                                 TO MBCA-MBRG-FIRST-SEQ-NBR)
030000     OR (MBCA-MBRG-BACK-SEQ-NBR IS EQUAL
030100                                 TO MBCA-MBRG-FIRST-SEQ-NBR
030200     AND MBCA-MBRG-BACK-INDEX IS NOT EQUAL
030300                                 TO MBCA-MBRG-FIRST-INDEX)
030400         MOVE DFHBMASB           TO RG01-FWD-BACK-IND-A (1).
030500*
030600     IF  WS-FWD-INDEX IS GREATER THAN ZEROES
030700         MOVE DFHBMASB           TO RG01-FWD-BACK-IND-A (15).
030800*
030900****************************************************************
031000*    WRITE THE TEMP STORAGE RECORD                             *
031100****************************************************************
031200*
031300     MOVE 'TS04'                 TO MBCA-PROGRAM-LOCATION.
031400     PERFORM 8400-WRITE-QUEUE    THRU 8499-WQ-EXIT.
031500*
031600     IF  MBCA-PTI-FUNCTION-IS-INQUIRY
031700         MOVE SS08WS-CURSOR      TO RG01-ALT-TRANID-L
031800         PERFORM 8500-SET-ATTRIBUTES
031900                                 THRU 8599-SA-EXIT
032000             VARYING X-STORE-INDEX FROM +1 BY +1
032100             UNTIL   X-STORE-INDEX IS GREATER THAN +15
032200     ELSE
032300         MOVE SS08WS-CURSOR      TO RG01-SELECT-L (1).
032400*
032500     MOVE '*TOP*'                TO SS08WS-LINE-24-PF-KEY-FUNC(3).
032600     MOVE '*BOT*'                TO SS08WS-LINE-24-PF-KEY-FUNC(4).
032700     MOVE '*FWD*'                TO SS08WS-LINE-24-PF-KEY-FUNC(5).
032800     MOVE '*BWD*'                TO SS08WS-LINE-24-PF-KEY-FUNC(6).
032900     MOVE SS08WS-LINE-24         TO RG01-PF-KEYS.
033000     MOVE 'RESV'                 TO MBCA-PGMX-PF-TRANS-ID (3).
033100     MOVE 'RESV'                 TO MBCA-PGMX-PF-TRANS-ID (4).
033200     MOVE 'RESV'                 TO MBCA-PGMX-PF-TRANS-ID (5).
033300     MOVE 'RESV'                 TO MBCA-PGMX-PF-TRANS-ID (6).
033400*
033500     MOVE DFHBMASK               TO RG01-CURRENT-PAGE-A.
033600*
033700****************************************************************
033800*    SEND THE MAP                                              *
033900****************************************************************
034000*
034100     MOVE 'BM01'                 TO MBCA-PROGRAM-LOCATION.
034200     PERFORM MB60PD-SEND-MAP-WITH-ERASE
034300                                 THRU MB60PD-SMWE-EXIT.
034400*
034500****************************************************************
034600*    RETURN TO CICS                                            *
034700****************************************************************
034800*
034900     MOVE 'PC03'                 TO MBCA-PROGRAM-LOCATION.
035000     PERFORM MB70PD-RETURN-TRANS-ID
035100                                 THRU MB70PD-RTI-EXIT.
035200/
035300 2000-RECEIVE-SCREEN SECTION.
035400*
035500     IF  MBCA-EIBAID-CLEAR
035600         MOVE 'TS05'             TO MBCA-PROGRAM-LOCATION
035700         PERFORM 8300-TEMP-STORAGE-DELETE
035800                                 THRU 8399-TSD-EXIT
035900         MOVE 'PC04'             TO MBCA-PROGRAM-LOCATION
036000         PERFORM MB70PD-ON-LINE-HOUSEKEEPING
036100                                 THRU MB70PD-OLH-EXIT.
036200*
036300****************************************************************
036400*    THIS SECTION RECEIVES THE 01 SCREEN                       *
036500****************************************************************
036600*
036700     MOVE 'BM02'                 TO MBCA-PROGRAM-LOCATION.
036800     PERFORM MB60PD-RECEIVE-MAP  THRU MB60PD-RM-EXIT.
036900*
037000*****************************************************
037100*    ACQUIRE MAIN STORAGE FOR TEMP STORAGE RECORD   *
037200*****************************************************
037300*
037400     MOVE 'TS06'                 TO MBCA-PROGRAM-LOCATION.
037500     PERFORM 8100-TEMP-STORAGE-GETMAIN
037600                                 THRU 8199-TSG-EXIT.
037700*
037800***********************************************
037900*    READ THE TEMP STORAGE RECORD             *
038000***********************************************
038100*
038200     MOVE 'TS07'                 TO MBCA-PROGRAM-LOCATION.
038300     PERFORM 8200-TEMP-STORAGE-READ
038400                                 THRU 8299-TSR-EXIT.
038500*
038600***********************************************
038700*    DELETE THE TEMP STORAGE RECORD           *
038800***********************************************
038900*
039000     MOVE 'TS08'                 TO MBCA-PROGRAM-LOCATION.
039100     PERFORM 8300-TEMP-STORAGE-DELETE
039200                                 THRU 8399-TSD-EXIT.
039300*
039400****************************************************************
039500*    CHECK FOR ANOTHER TRANSACTION ID ENTERED BY THE USER      *
039600****************************************************************
039700*
039800     MOVE 'PC05'                 TO MBCA-PROGRAM-LOCATION.
039900     PERFORM MB60PD-NEW-TRANS-ROUTINE
040000                                 THRU MB60PD-NTR-EXIT.
040100*
040200*****************************************************
040300*    BYPASS EDITS ON INQUIRY                        *
040400*****************************************************
040500*
040600     IF  MBCA-PTI-FUNCTION-IS-INQUIRY
040700         GO TO 2600-SETUP-COMMAREA.
040800*
040900 2005-EDIT-SELECT.
041000*
041100****************************************************************
041200*    EDIT SELECT FIELD                                         *
041300****************************************************************
041400*
041500     PERFORM 8600-EDIT-SELECT    THRU 8699-ES-EXIT.
041600*
041700 2090-CHECK-ERROR.
041800*
041900     IF  SS08WS-ERROR IS EQUAL TO 'N'
042000         GO TO 2400-CHECK-SELECT.
042100*
042200 2300-SEND-MAP.
042300*
042400***********************************************
042500*    WRITE THE TEMP STORAGE RECORD            *
042600***********************************************
042700*
042800     MOVE 'TS09'                 TO MBCA-PROGRAM-LOCATION.
042900     PERFORM 8400-WRITE-QUEUE    THRU 8499-WQ-EXIT.
043000*
043100****************************************************************
043200*    SEND THE MAP                                              *
043300****************************************************************
043400*
043500     PERFORM MB60PD-INIT-STD-MAP-LINES
043600                                 THRU MB60PD-ISML-EXIT.
043700*
043800     MOVE '*TOP*'                TO SS08WS-LINE-24-PF-KEY-FUNC(3).
043900     MOVE '*BOT*'                TO SS08WS-LINE-24-PF-KEY-FUNC(4).
044000     MOVE '*FWD*'                TO SS08WS-LINE-24-PF-KEY-FUNC(5).
044100     MOVE '*BWD*'                TO SS08WS-LINE-24-PF-KEY-FUNC(6).
044200     MOVE SS08WS-LINE-24         TO RG01-PF-KEYS.
044300     MOVE 'RESV'                 TO MBCA-PGMX-PF-TRANS-ID (3).
044400     MOVE 'RESV'                 TO MBCA-PGMX-PF-TRANS-ID (4).
044500     MOVE 'RESV'                 TO MBCA-PGMX-PF-TRANS-ID (5).
044600     MOVE 'RESV'                 TO MBCA-PGMX-PF-TRANS-ID (6).
044700*
044800     MOVE DFHBMASK               TO RG01-CURRENT-PAGE-A.
044900*
045000     MOVE 'BM03'                 TO MBCA-PROGRAM-LOCATION.
045100     PERFORM MB60PD-SEND-MAP-DATA-ONLY
045200                                 THRU MB60PD-SMDO-EXIT.
045300*
045400****************************************************************
045500*    RETURN TO CICS                                            *
045600****************************************************************
045700*
045800     MOVE 'PC06'                 TO MBCA-PROGRAM-LOCATION.
045900     PERFORM MB70PD-RETURN-TRANS-ID
046000                                 THRU MB70PD-RTI-EXIT.
046100/
046200 2400-CHECK-SELECT.
046300*
046400     IF  WS-SELECT-YES
046500         SET X-TS-MBRG-INDEX     TO X-STORE-INDEX
046600         MOVE TS-MBRG-STORE (X-TS-MBRG-INDEX)
046700                                 TO MBCA-STORE
046800         MOVE MBIOWS-MMSM-DIRECT-KEY-CODE
046900                                 TO MBCA-KEY-CODE
047000         MOVE 99                 TO MBCA-SCREEN-NBR
047100         IF  RG01-VALID-INQUIRY (X-STORE-INDEX)
047200             MOVE '..QS'         TO SS08WS-WORK-TRANS-ID
047300             GO TO 2690-PF-KEY-BYPASS
047400         ELSE
047500             IF  RG01-VALID-MAINT (X-STORE-INDEX)
047600                 MOVE '..MS'     TO SS08WS-WORK-TRANS-ID
047700                 GO TO 2690-PF-KEY-BYPASS.
047800*
047900 2600-SETUP-COMMAREA.
048000*
048100****************************************************************
048200*    SET UP COMMAREA FIELDS AND TRANSFER TO THE NEXT PROGRAM   *
048300****************************************************************
048400*
048500     MOVE MBCA-EIBAID            TO SS08WS-EIBAID.
048600*
048700     IF  SS08WS-VALID-PF3
048800     OR  SS08WS-EIBAID-VALID-PF3
048900         MOVE 51                 TO MBCA-SCREEN-NBR
049000         MOVE 01                 TO MBCA-MBRG-FWD-SEQ-NBR
049100         MOVE +1                 TO MBCA-MBRG-FWD-INDEX
049200         MOVE ' '                TO MBCA-MBRG-RETURN-FLAG
049300         GO TO 2690-PF-KEY-BYPASS.
049400*
049500     IF  SS08WS-VALID-PF4
049600     OR  SS08WS-EIBAID-VALID-PF4
049700         MOVE 51                 TO MBCA-SCREEN-NBR
049800         IF (TS-MBRG-STORE (1) IS GREATER THAN ZEROES
049900         AND TS-MBRG-STORE (15) IS EQUAL TO ZEROES)
050000         OR (MBCA-MBRG-FWD-INDEX IS EQUAL TO ZEROES)
050100             MOVE ' '            TO MBCA-MBRG-RETURN-FLAG
050200             MOVE ZEROES         TO MBCA-MBRG-FWD-INDEX
050300                                    MBCA-MBRG-FWD-SEQ-NBR
050400             MOVE 'TS10'         TO MBCA-PROGRAM-LOCATION
050500             PERFORM 8400-WRITE-QUEUE
050600                                 THRU 8499-WQ-EXIT
050700             GO TO 2690-PF-KEY-BYPASS
050800         ELSE
050900             MOVE 'E'            TO MBCA-MBRG-RETURN-FLAG
051000             GO TO 2690-PF-KEY-BYPASS.
051100*
051200     IF  SS08WS-VALID-PF5
051300     OR  SS08WS-EIBAID-VALID-PF5
051400         MOVE 51                 TO MBCA-SCREEN-NBR
051500         IF (TS-MBRG-STORE (1) IS GREATER THAN ZEROES
051600         AND TS-MBRG-STORE (15) IS EQUAL TO ZEROES)
051700         OR (MBCA-MBRG-FWD-INDEX IS EQUAL TO ZEROES)
051800             MOVE ' '            TO MBCA-MBRG-RETURN-FLAG
051900             MOVE ZEROES         TO MBCA-MBRG-FWD-INDEX
052000                                    MBCA-MBRG-FWD-SEQ-NBR
052100             MOVE 'TS11'         TO MBCA-PROGRAM-LOCATION
052200             PERFORM 8400-WRITE-QUEUE
052300                                 THRU 8499-WQ-EXIT
052400             GO TO 2690-PF-KEY-BYPASS
052500         ELSE
052600             MOVE 'F'            TO MBCA-MBRG-RETURN-FLAG
052700             ADD +1              TO MBCA-MBRG-FWD-INDEX
052800             GO TO 2690-PF-KEY-BYPASS.
052900*
053000     IF  SS08WS-VALID-PF6
053100     OR  SS08WS-EIBAID-VALID-PF6
053200         MOVE 51                 TO MBCA-SCREEN-NBR
053300         IF  MBCA-MBRG-BACK-SEQ-NBR IS EQUAL
053400                                 TO MBCA-MBRG-FIRST-SEQ-NBR
053500         AND MBCA-MBRG-BACK-INDEX IS EQUAL
053600                                 TO MBCA-MBRG-FIRST-INDEX
053700             MOVE ' '            TO MBCA-MBRG-RETURN-FLAG
053800             MOVE 'TS12'         TO MBCA-PROGRAM-LOCATION
053900             PERFORM 8400-WRITE-QUEUE
054000                                 THRU 8499-WQ-EXIT
054100             GO TO 2690-PF-KEY-BYPASS
054200         ELSE
054300             SUBTRACT +1         FROM MBCA-MBRG-BACK-INDEX
054400             IF  MBCA-MBRG-BACK-SEQ-NBR IS EQUAL
054500                                 TO MBCA-MBRG-FIRST-SEQ-NBR
054600             AND MBCA-MBRG-BACK-INDEX IS EQUAL
054700                                 TO MBCA-MBRG-FIRST-INDEX
054800                 MOVE MBCA-MBRG-BACK-INDEX
054900                                 TO MBCA-MBRG-FWD-INDEX
055000                 MOVE MBCA-MBRG-BACK-SEQ-NBR
055100                                 TO MBCA-MBRG-FWD-SEQ-NBR
055200                 MOVE ' '        TO MBCA-MBRG-RETURN-FLAG
055300                 GO TO 2690-PF-KEY-BYPASS
055400             ELSE
055500                 MOVE MBCA-MBRG-BACK-INDEX
055600                                 TO MBCA-MBRG-FWD-INDEX
055700                 MOVE MBCA-MBRG-BACK-SEQ-NBR
055800                                 TO MBCA-MBRG-FWD-SEQ-NBR
055900                 MOVE 'B'        TO MBCA-MBRG-RETURN-FLAG
056000                 GO TO 2690-PF-KEY-BYPASS.
056100*
056200     IF  SS08WS-VALID-PF-KEY
056300     OR  SS08WS-EIBAID-VALID-PF-KEY
056400     OR  TS-MBRG-STORE (15) IS EQUAL TO ZEROES
056500     OR  MBCA-MBRG-FWD-INDEX IS EQUAL TO ZEROES
056600         MOVE 99                 TO MBCA-SCREEN-NBR
056700         MOVE MBIOWS-MMSD-KEY-CODE
056800                                 TO MBCA-KEY-CODE
056900         MOVE ' '                TO MBCA-MBRG-RETURN-FLAG
057000         GO TO 2690-PF-KEY-BYPASS.
057100*
057200     MOVE 51                     TO MBCA-SCREEN-NBR.
057300     ADD +1                      TO MBCA-MBRG-FWD-INDEX.
057400     MOVE ' '                    TO MBCA-MBRG-RETURN-FLAG.
057500*
057600 2690-PF-KEY-BYPASS.
057700*
057800     MOVE 'PC07'                 TO MBCA-PROGRAM-LOCATION.
057900     PERFORM MB70PD-XCTL-TO-MBOXCTL
058000                                 THRU MB70PD-XTM-EXIT.
058100/
058200*
058300 8100-TEMP-STORAGE-GETMAIN.
058400*
058500     EXEC CICS GETMAIN
058600               FLENGTH (LENGTH  OF TS-MBRG-RECORD)
058700               SET     (ADDRESS OF TS-MBRG-RECORD)
058800          END-EXEC.
058900*
059000 8199-TSG-EXIT.
059100     EXIT.
059200*
059300 8200-TEMP-STORAGE-READ.
059400*
059500     EXEC CICS READQ TS
059600               QUEUE   (TS-QUEUE-NAME)
059700               INTO    (TS-MBRG-RECORD)
059800               LENGTH  (LENGTH  OF TS-MBRG-RECORD)
059900               ITEM    (1)
060000          END-EXEC.
060100*
060200 8299-TSR-EXIT.
060300     EXIT.
060400*
060500 8300-TEMP-STORAGE-DELETE.
060600*
060700     EXEC CICS IGNORE CONDITION
060800               QIDERR
060900          END-EXEC.
061000*
061100     EXEC CICS DELETEQ TS
061200               QUEUE  (TS-QUEUE-NAME)
061300          END-EXEC.
061400*
061500 8399-TSD-EXIT.
061600     EXIT.
061700*
061800 8400-WRITE-QUEUE.
061900*
062000     EXEC CICS WRITEQ TS
062100               QUEUE   (TS-QUEUE-NAME)
062200               FROM    (TS-MBRG-RECORD)
062300               LENGTH  (LENGTH OF TS-MBRG-RECORD)
062400          END-EXEC.
062500*
062600 8499-WQ-EXIT.
062700     EXIT.
062800*
062900 8500-SET-ATTRIBUTES.
063000*
063100     MOVE DFHBMASK               TO RG01-SELECT-A
063200                                    (X-STORE-INDEX).
063300     MOVE DFHBMDAS               TO RG01-SELECT-LP-A
063400                                    (X-STORE-INDEX)
063500                                    RG01-SELECT-RP-A
063600                                    (X-STORE-INDEX).
063700     MOVE DFHBMASB               TO RG01-DIRECTORY-LINE-A
063800                                    (X-STORE-INDEX).
063900*
064000 8599-SA-EXIT.
064100     EXIT.
064200*
064300 8600-EDIT-SELECT.
064400*
064500     SET X-STORE-INDEX           TO +1.
064600*
064700 8600-EDIT-LOOP.
064800*
064900     IF  RG01-SELECT-L (X-STORE-INDEX) IS GREATER THAN ZERO
065000         IF  RG01-VALID-SELECT (X-STORE-INDEX)
065100             MOVE DFHBMASF       TO RG01-SELECT-A
065200                                    (X-STORE-INDEX)
065300             MOVE DFHBMDAS       TO RG01-SELECT-LP-A
065400                                    (X-STORE-INDEX)
065500                                    RG01-SELECT-RP-A
065600                                    (X-STORE-INDEX)
065700             IF  RG01-VALID-INQUIRY-MAINT (X-STORE-INDEX)
065800                 MOVE 'Y'        TO WS-SELECT-SW
065900                 GO TO 8699-ES-EXIT
066000             ELSE
066100                 NEXT SENTENCE
066200         ELSE
066300             MOVE 'Y'            TO SS08WS-ERROR
066400             MOVE SS08WS-CURSOR  TO RG01-SELECT-L
066500                                    (X-STORE-INDEX)
066600             MOVE DFHBMUBF       TO RG01-SELECT-A
066700                                    (X-STORE-INDEX)
066800             MOVE DFHBMASB       TO RG01-SELECT-LP-A
066900                                    (X-STORE-INDEX)
067000                                    RG01-SELECT-RP-A
067100                                    (X-STORE-INDEX)
067200             GO TO 8699-ES-EXIT.
067300*
067400     IF  X-STORE-INDEX IS LESS THAN +15
067500         SET X-STORE-INDEX       UP BY +1
067600         GO TO 8600-EDIT-LOOP.
067700*
067800 8699-ES-EXIT.
067900     EXIT.
068000*
068100 8800-BUILD-SCREEN.
068200*
068300     SET X-STORE-INDEX           TO +1.
068400*
068500 8800-BUILD-LOOP.
068600*
068700     SET X-TS-MBRG-INDEX         TO X-STORE-INDEX.
068800*
068900     IF  TS-MBRG-STORE (X-TS-MBRG-INDEX)
069000                                 IS GREATER THAN ZEROES
069100         MOVE TS-MBRG-STORE (X-TS-MBRG-INDEX)
069200                                 TO WS-STORE-NBR
069300         MOVE TS-MBRG-STORE-NAME (X-TS-MBRG-INDEX)
069400                                 TO WS-STORE-NAME
069500         MOVE TS-MBRG-AUTH-CODE (X-TS-MBRG-INDEX)
069600                                 TO WS-AUTH-CODE
069700         MOVE TS-MBRG-SETT-FLAG (X-TS-MBRG-INDEX)
069800                                 TO WS-SETT-FLAG
069900         MOVE TS-MBRG-REC-STATUS (X-TS-MBRG-INDEX)
070000                                 TO WS-REC-STATUS
070100         MOVE WS-DETAIL-LINE     TO RG01-DIRECTORY-LINE
070200                                    (X-STORE-INDEX)
070300     ELSE
070400         MOVE DFHBMASK           TO RG01-SELECT-A
070500                                    (X-STORE-INDEX)
070600         MOVE DFHBMDAS           TO RG01-DIRECTORY-LINE-A
070700                                    (X-STORE-INDEX)
070800                                    RG01-SELECT-LP-A
070900                                    (X-STORE-INDEX)
071000                                    RG01-SELECT-RP-A
071100                                    (X-STORE-INDEX).
071200*
071300     IF  X-STORE-INDEX IS LESS THAN +15
071400         SET X-STORE-INDEX       UP BY +1
071500         GO TO 8800-BUILD-LOOP
071600     ELSE
071700         MOVE MBCA-MBRG-FWD-INDEX
071800                                 TO WS-FWD-INDEX.
071900*
072000 8899-BS-EXIT.
072100     EXIT.
072200*
072300 8900-LAST-SCREEN.
072400*
072500****************************************************************
072600*    START BROWSE THE STORE RELATIONSHIP FILE                  *
072700****************************************************************
072800*
072900     MOVE 'FC02'                 TO MBCA-PROGRAM-LOCATION.
073000     MOVE MBCA-MERCHANT-ORG      TO MBIOWS-MMSD-ORG.
073100     MOVE MBCA-S-CHAIN           TO MBIOWS-MMSD-CHAIN.
073200     MOVE 99                     TO MBIOWS-MMSD-SEQ-NBR.
073300     SET MBIORO-STARTBR-GTE      TO TRUE.
073400     PERFORM MMSDAO-ACCESS       THRU MMSDAO-ACCESS-EXIT.
073500*
073600****************************************************************
073700*    READNEXT THE STORE RELATIONSHIP FILE                      *
073800****************************************************************
073900*
074000     MOVE 'FC03'                 TO MBCA-PROGRAM-LOCATION.
074100     SET MBIORO-READ-SEQ         TO TRUE.
074200     PERFORM MMSDAO-ACCESS       THRU MMSDAO-ACCESS-EXIT.
074300*
074400****************************************************************
074500*    READPREV THE STORE RELATIONSHIP FILE                      *
074600****************************************************************
074700*
074800     MOVE 'FC04'                 TO MBCA-PROGRAM-LOCATION.
074900     SET MBIORO-READ-PREV        TO TRUE.
075000     PERFORM MMSDAO-ACCESS       THRU MMSDAO-ACCESS-EXIT.
075100*
075200     SET X-STORE-INDEX           TO +15.
075300     MOVE 'N'                    TO WS-BYPASS-SW.
075400*
075500 8900-READ-RELATIONSHIP-FILE.
075600*
075700****************************************************************
075800*    READPREV THE STORE RELATIONSHIP FILE                      *
075900****************************************************************
076000*
076100     MOVE 'FC05'                 TO MBCA-PROGRAM-LOCATION.
076200     SET MBIORO-READ-PREV        TO TRUE.
076300     PERFORM MMSDAO-ACCESS       THRU MMSDAO-ACCESS-EXIT.
076400*
076500     SET X-MMSD-MEMBER           TO +800.
076600*
076700 8900-BUILD-LOOP.
076800*
076900     IF  X-MMSD-MEMBER IS LESS THAN +1
077000     AND MMSD-SEQ-NBR IS NOT EQUAL
077100                                 TO MBCA-MBRG-FIRST-SEQ-NBR
077200         GO TO 8900-READ-RELATIONSHIP-FILE.
077300*
077400     IF  X-MMSD-MEMBER IS EQUAL TO MBCA-MBRG-FIRST-INDEX
077500     AND MMSD-SEQ-NBR IS EQUAL TO MBCA-MBRG-FIRST-SEQ-NBR
077600     AND X-STORE-INDEX IS GREATER THAN +1
077700         MOVE ' '                TO MBCA-MBRG-RETURN-FLAG
077800         MOVE MBCA-MBRG-FIRST-INDEX
077900                                 TO MBCA-MBRG-FWD-INDEX
078000         MOVE MBCA-MBRG-FIRST-SEQ-NBR
078100                                 TO MBCA-MBRG-FWD-SEQ-NBR
078200         MOVE 'Y'                TO WS-BYPASS-SW
078300         GO TO 8900-END-BROWSE.
078400*
078500     IF  MMSD-MEMBER (X-MMSD-MEMBER) IS EQUAL TO ZEROES
078600         SET X-MMSD-MEMBER       DOWN BY +1
078700         GO TO 8900-BUILD-LOOP.
078800*
078900     PERFORM 9400-BUILD-SCREEN-LINE
079000                                 THRU 9499-BSL-EXIT.
079100*
079200     IF  X-STORE-INDEX IS GREATER THAN +1
079300         SET X-STORE-INDEX       DOWN BY +1
079400         SET X-MMSD-MEMBER       DOWN BY +1
079500         GO TO 8900-BUILD-LOOP
079600     ELSE
079700         SET MBCA-MBRG-BACK-INDEX
079800                                 TO X-MMSD-MEMBER
079900         MOVE MMSD-SEQ-NBR       TO MBCA-MBRG-BACK-SEQ-NBR.
080000*
080100 8900-END-BROWSE.
080200*
080300****************************************************************
080400*    END BROWSE THE STORE RELATIONSHIP FILE                    *
080500****************************************************************
080600*
080700     MOVE 'FC06'                 TO MBCA-PROGRAM-LOCATION.
080800     SET MBIORO-ENDBR            TO TRUE.
080900     PERFORM MMSDAO-ACCESS       THRU MMSDAO-ACCESS-EXIT.
081000*
081100     IF  WS-BYPASS-YES
081200         GO TO 8999-LS-EXIT.
081300*
081400     MOVE ZEROES                 TO MBCA-MBRG-FWD-INDEX
081500                                    MBCA-MBRG-FWD-SEQ-NBR
081600                                    WS-FWD-INDEX.
081700*
081800 8999-LS-EXIT.
081900     EXIT.
082000*
082100 9000-BACK-SCREEN.
082200*
082300****************************************************************
082400*    START BROWSE THE STORE RELATIONSHIP FILE                  *
082500****************************************************************
082600*
082700     MOVE 'FC07'                 TO MBCA-PROGRAM-LOCATION.
082800     MOVE MBCA-MERCHANT-ORG      TO MBIOWS-MMSD-ORG.
082900     MOVE MBCA-S-CHAIN           TO MBIOWS-MMSD-CHAIN.
083000     MOVE MBCA-MBRG-FWD-SEQ-NBR  TO MBIOWS-MMSD-SEQ-NBR.
083100     SET MBIORO-STARTBR-GTE      TO TRUE.
083200     PERFORM MMSDAO-ACCESS       THRU MMSDAO-ACCESS-EXIT.
083300*
083400     SET X-STORE-INDEX           TO +15.
083500     SET X-MMSD-MEMBER           TO MBCA-MBRG-FWD-INDEX.
083600     MOVE 'N'                    TO WS-BYPASS-SW.
083700*
083800 9000-READ-RELATIONSHIP-FILE.
083900*
084000****************************************************************
084100*    READPREV THE STORE RELATIONSHIP FILE                      *
084200****************************************************************
084300*
084400     MOVE 'FC08'                 TO MBCA-PROGRAM-LOCATION.
084500     SET MBIORO-READ-PREV        TO TRUE.
084600     PERFORM MMSDAO-ACCESS       THRU MMSDAO-ACCESS-EXIT.
084700*
084800 9000-BUILD-LOOP.
084900*
085000     IF  X-MMSD-MEMBER IS LESS THAN +1
085100         IF  MMSD-SEQ-NBR IS NOT EQUAL
085200                                 TO MBCA-MBRG-FIRST-SEQ-NBR
085300             SET X-MMSD-MEMBER
085400                                 TO +800
085500             GO TO 9000-READ-RELATIONSHIP-FILE
085600         ELSE
085700             IF  MMSD-SEQ-NBR IS EQUAL
085800                                 TO MBCA-MBRG-FIRST-SEQ-NBR
085900                 MOVE ' '        TO MBCA-MBRG-RETURN-FLAG
086000                 MOVE MBCA-MBRG-FIRST-INDEX
086100                                 TO MBCA-MBRG-FWD-INDEX
086200                 MOVE MBCA-MBRG-FIRST-SEQ-NBR
086300                                 TO MBCA-MBRG-FWD-SEQ-NBR
086400                 MOVE 'Y'        TO WS-BYPASS-SW
086500                 GO TO 9000-END-BROWSE.
086600*
086700     IF  MMSD-MEMBER (X-MMSD-MEMBER) IS EQUAL TO ZEROES
086800         SET X-MMSD-MEMBER       DOWN BY +1
086900         GO TO 9000-BUILD-LOOP.
087000*
087100     PERFORM 9400-BUILD-SCREEN-LINE
087200                                 THRU 9499-BSL-EXIT.
087300*
087400     IF  X-STORE-INDEX IS EQUAL TO +15
087500         SET MBCA-MBRG-FWD-INDEX TO X-MMSD-MEMBER
087600         SET WS-FWD-INDEX        TO X-MMSD-MEMBER
087700         MOVE MMSD-SEQ-NBR       TO MBCA-MBRG-FWD-SEQ-NBR.
087800*
087900     IF  X-STORE-INDEX IS GREATER THAN +1
088000         SET X-STORE-INDEX       DOWN BY +1
088100         SET X-MMSD-MEMBER       DOWN BY +1
088200         GO TO 9000-BUILD-LOOP
088300     ELSE
088400         SET MBCA-MBRG-BACK-INDEX
088500                                 TO X-MMSD-MEMBER
088600         MOVE MMSD-SEQ-NBR       TO MBCA-MBRG-BACK-SEQ-NBR.
088700*
088800 9000-END-BROWSE.
088900*
089000****************************************************************
089100*    END BROWSE THE STORE RELATIONSHIP FILE                    *
089200****************************************************************
089300*
089400     MOVE 'FC09'                 TO MBCA-PROGRAM-LOCATION.
089500     SET MBIORO-ENDBR            TO TRUE.
089600     PERFORM MMSDAO-ACCESS       THRU MMSDAO-ACCESS-EXIT.
089700*
089800 9099-BS-EXIT.
089900     EXIT.
090000*
090100 9100-READ-STORE.
090200*
090300     IF  MBIOWS-MMSM-KEY IS EQUAL TO MMSM-KEY
090400         GO TO 9199-RM-EXIT.
090500*
090600****************************************************************
090700*    READ RANDOM THE STORE MASTER FILE                         *
090800****************************************************************
090900*
091000     MOVE 'FC10'                 TO MBCA-PROGRAM-LOCATION.
091100     SET MBIORO-READ-RANDOM      TO TRUE.
091200     PERFORM MMSMAO-ACCESS       THRU MMSMAO-ACCESS-EXIT.
091300*
091400 9199-RM-EXIT.
091500     EXIT.
091600*
091700 9200-READ-RELATIONSHIP.
091800*
091900     MOVE MBCA-MERCHANT-ORG      TO MBIOWS-MMSD-ORG.
092000     MOVE MBCA-S-CHAIN           TO MBIOWS-MMSD-CHAIN.
092100     MOVE MBCA-MBRG-FWD-SEQ-NBR  TO MBIOWS-MMSD-SEQ-NBR.
092200     MOVE SS08WS-CICS-FC-NOTFND  TO MBIORO-TEMP-STATUS-1.
092300     SET MBIORO-READ-RANDOM      TO TRUE.
092400     PERFORM MMSDAO-ACCESS       THRU MMSDAO-ACCESS-EXIT.
092500*
092600 9299-RR-EXIT.
092700     EXIT.
092800*
092900 9300-READ-AHEAD.
093000*
093100     SET X-MMSD-MEMBER           UP BY +1.
093200     MOVE MBCA-MBRG-FWD-SEQ-NBR  TO WS-HOLD-FWD-SEQ-NBR.
093300*
093400 9300-READ-LOOP.
093500*
093600     IF  X-MMSD-MEMBER IS GREATER THAN +800
093700         COMPUTE MBCA-MBRG-FWD-SEQ-NBR
093800                                 = MBCA-MBRG-FWD-SEQ-NBR + 1
093900         PERFORM 9200-READ-RELATIONSHIP
094000                                 THRU 9299-RR-EXIT
094100         IF  SS08WS-RC-FC-NOTFND
094200             MOVE ZEROES         TO WS-FWD-INDEX
094300                                    MBCA-MBRG-FWD-INDEX
094400             GO TO 9300-RESET-SEQ-NBR.
094500*
094600     IF  MMSD-MEMBER (X-MMSD-MEMBER) IS EQUAL TO ZEROES
094700         SET X-MMSD-MEMBER       UP BY +1
094800         GO TO 9300-READ-LOOP.
094900*
095000     SET WS-FWD-INDEX            TO X-MMSD-MEMBER.
095100*
095200 9300-RESET-SEQ-NBR.
095300*
095400     MOVE WS-HOLD-FWD-SEQ-NBR    TO MBCA-MBRG-FWD-SEQ-NBR.
095500*
095600 9399-RA-EXIT.
095700     EXIT.
095800*
095900 9400-BUILD-SCREEN-LINE.
096000*
096100     SET X-TS-MBRG-INDEX         TO X-STORE-INDEX.
096200*
096300     MOVE MMSD-MEMBER (X-MMSD-MEMBER)
096400                                 TO WS-STORE-NBR
096500                                    MBIOWS-MMSM-STORE
096600                                    TS-MBRG-STORE
096700                                    (X-TS-MBRG-INDEX).
096800*
096900     PERFORM 9100-READ-STORE     THRU 9199-RM-EXIT.
097000*
097100     MOVE MMSM-NA-LINE (1 1)     TO WS-STORE-NAME
097200                                    TS-MBRG-STORE-NAME
097300                                    (X-TS-MBRG-INDEX).
097400*
097500     MOVE MMSM-AUTH-CODE         TO WS-AUTH-CODE
097600                                    TS-MBRG-AUTH-CODE
097700                                    (X-TS-MBRG-INDEX).
097800*
097900     MOVE MMSM-REC-STATUS        TO WS-REC-STATUS
098000                                    TS-MBRG-REC-STATUS
098100                                    (X-TS-MBRG-INDEX).
098200*
098300     MOVE MMSM-STORE-SETT-FLAG   TO WS-SETT-FLAG
098400                                    TS-MBRG-SETT-FLAG
098500                                    (X-TS-MBRG-INDEX).
098600*
098700     MOVE WS-DETAIL-LINE         TO RG01-DIRECTORY-LINE
098800                                    (X-STORE-INDEX).
098900*
099000 9499-BSL-EXIT.
099100     EXIT.
099200/         NEW ROUTINE FOR JULIAN TO GREGORIAN CONVERSION
099300     COPY SS26PD.
099400/         ROUTINE TO NUMERICALLY EDIT TIME
099500     COPY SS27PD.
099600/         JULIAN TO GREGORIAN DATE ROUTINE
099700     COPY SS08PD.
099800/         LINE 24 PF KEYS ROUTINE
099900     COPY SS15PD.
100000/         STORE RELATIONSHIP RECORD ACCESS ROUTINES
100100     COPY MMSDAO.
100200/         STORE MASTER RECORD ACCESS ROUTINES
100300     COPY MMSMAO.
100400/         ON-LINE MAP ROUTINES
100500     COPY MB60PD REPLACING 'MBMAPXX' BY 'MBRG01 '
100600                           MBMAPXXI BY MBRG01I
100700                           MBMAPXXO BY MBRG01O.
100800/         ON-LINE PROCEDURES
100900     COPY MB70PD.
101000/
101100     COPY SMFTPXO.
