000100 IDENTIFICATION DIVISION.
000200 PROGRAM-ID. MBORS00.
000201*       RELEASE DATE=08/24/01.        REVISION LEVEL=08.06      *
000202*****************************************************************
000203*WARNING.  THIS COMPUTER PROGRAM IS PROTECTED BY COPYRIGHT LAW  *
000204*AND INTERNATIONAL TREATIES.  UNAUTHORIZED REPRODUCTION OR      *
000205*DISTRIBUTION OF THIS PROGRAM, OR ANY PORTION OF IT, MAY RESULT *
000206*IN SEVERE CIVIL AND CRIMINAL PENATLIES, AND WILL BE PROSECUTED *
000207*TO THE MAXIMUM EXTENT POSSIBLE UNDER THE LAW.                  *
000208*COPYRIGHT 1999 PAYSYS INTERNATIONAL, INC.  ALL RIGHTS RESERVED.*
000209*****************************************************************
000300*****************************************************************
000400*                                                               *
000500*   V - PLUS  M E R C H A N T   B A N K C A R D   S Y S T E M   *
000600*                                                               *
000700*      MBORS00 - ON-LINE STORE RELATIONSHIP DIRECTORY           *
000800*                SCREEN 00                                      *
000900*                                                               *
001000*              1. TRANSIDS                                      *
001100*                 A. MBRS                                       *
001200*              2. MAPS USED -                                   *
001300*                 A. MBRS00 (SCREEN 00)                         *
001400*              3. FILES USED -                                  *
001500*                 A. MMOC   (ORG CONTROL FILE)                  *
001600*                 B. MMXR   (STORE/MERCHANT CROSS REF FILE)     *
001700*                 C. MMMM   (MERCHANT MASTER FILE)              *
001800*                                                               *
001900*****************************************************************
002000*
002100 ENVIRONMENT DIVISION.
002200 DATA DIVISION.
002300 WORKING-STORAGE SECTION.
002400 01  FILLER                  PIC  X(12)      VALUE '** WS-BEG **'.
002500*         I/O REQUEST BLOCK WORK AREAS
002600     COPY MBIOWS.
002700/         I/O REQUEST BLOCK
002800     COPY MBIORO.
002900/         DATE WORK AREAS
003000     COPY SS01WS.
003100/         ONLINE WORK AREAS
003200     COPY SS08WS.
003300/
003400     COPY SS00WS.
003500/
003600     COPY SMFTWS.
003700/
003800     COPY SMPTRL REPLACING ==:SMPT:== BY ==SMPT==.
003900/
004000     COPY MB61LK.
004100/         STANDARD ERROR MESSAGES
004200     COPY MBEMWS.
004300*
004400 01  FILLER                  PIC  X(12)      VALUE '** WS-END **'.
004500/
004600 LINKAGE SECTION.
004700 01  DFHCOMMAREA.
004800     COPY MB60WS.
004900/         STORE RELATIONSHIP DIRECTORY SCREEN 00 MAP DSECT
005000     COPY MBRS00.
005100/         STORE RELATIONSHIP DIRECTORY SCREEN 00 MAP REDEFINITION
005200     COPY MBRS00R.
005300/         ORG CONTROL RECORD LAYOUT
005400     COPY MMOCRL.
005500/         STORE/MERCHANT CROSS REF RECORD LAYOUT
005600     COPY MMXRRL.
005700/         MERCHANT MASTER RECORD LAYOUT
005800     COPY MMMMRL.
005900/
006000 PROCEDURE DIVISION.
006100 0000-HOUSEKEEPING SECTION.
006200 0100-INIT.
006300*
006400     MOVE 'PC01'                 TO MBCA-PROGRAM-LOCATION.
006500     PERFORM MB70PD-ON-LINE-HOUSEKEEPING
006600                                 THRU MB70PD-OLH-EXIT.
006700*
006800     IF  MBCA-RECEIVE-SCREEN
006900         GO TO 2000-RECEIVE-SCREEN.
007000*
007100 1000-SEND-SCREEN SECTION.
007200*
007300****************************************************************
007400*    GET CICS STORAGE NEEDED FOR THE MAP                       *
007500****************************************************************
007600*
007700     MOVE 'SC01'                 TO MBCA-PROGRAM-LOCATION.
007800     PERFORM MB60PD-GETMAIN-FOR-MAP
007900                                 THRU MB60PD-GFM-EXIT.
008000*
008100*****************************************************************
008200*    CHECK KEY CODES                                            *
008300* 1. IF INITIAL KEY CODE, BYPASS CHECK OF KEY CODES.            *
008400* 2. IF MMMM KEY CODE, IT MUST BE A VALID CODE.  IF DIRECT, GO  *
008500*    TO THE RECEIVE EDITING ROUTINE SINCE WE HAVE PLUGGED THE   *
008600*    ORG AND MERCHANT INTO THE MAP. IF AN ERROR OCCURS IN THE   *
008700*    RECEIVE SCREEN ROUTINE, IT WILL HANDLE BUILDING THE MAP    *
008800*    AND IT WILL SEND ITS OWN SCREEN.  THIS IS WHY LOCATE       *
008900*    PROGRAMS ALWAYS SEND WITH ERASE NO MATTER WHICH ROUTINE    *
009000*    YOU ARE IN.  IF NOT DIRECT, PLUG ORG AND MERCHANT INTO THE *
009100*    MAP AND BYPASS ANY OTHER CHECKING OF THE KEY CODE.         *
009200* 3. IF 2 IS FALSE, SEE IF THE MBCA-MERCHANT-ORG                *
009300*    FIELD IS GREATER THAN ZERO.  IF SO, PLUG INTO MAP.         *
009400*    SEE IF THE MBCA-MERCHANT FIELD IS GREATER THAN ZERO. IF SO,*
009500*    PLUG INTO MAP.                                             *
009600*    HANDLE IF THEY WERE NON-DIRECT.                            *
009700*****************************************************************
009800*
009900     IF  MBCA-INITIAL-KEY-CODE
010000         GO TO 1100-BUILD-SCREEN.
010100*
010200     IF  MBCA-MMMM-KEY-CODE
010300     AND MBCA-MERCHANT-ORG IS GREATER THAN ZERO
010400         MOVE MBCA-MERCHANT-ORG  TO RS00-ORG
010500         MOVE DFHBMUNF           TO RS00-ORG-A
010600         IF  MBCA-MERCHANT IS GREATER THAN ZEROES
010700             MOVE MBCA-MERCHANT  TO RS00-MERCHANT
010800             MOVE DFHBMUNF       TO RS00-MERCHANT-A
010900             IF  MBCA-DIRECT-TRANSFER-CODE
011000             AND MBCA-INITIAL-SCREEN-NBR
011100                 MOVE 00         TO MBCA-SCREEN-NBR
011200                 GO TO 2120-READ-ORG
011300             ELSE
011400                 GO TO 1100-BUILD-SCREEN.
011500*
011600 1050-SEND-SCREEN-CONTINUE.
011700*
011800     IF  MBCA-VALID-KEY-CODES
011900     AND MBCA-MERCHANT-ORG IS GREATER THAN ZERO
012000         MOVE MBCA-MERCHANT-ORG  TO RS00-ORG
012100         MOVE DFHBMUNF           TO RS00-ORG-A
012200         IF  MBCA-MERCHANT IS GREATER THAN ZEROES
012300             MOVE MBCA-MERCHANT  TO RS00-MERCHANT
012400             MOVE DFHBMUNF       TO RS00-MERCHANT-A.
012500*
012600 1100-BUILD-SCREEN.
012700*
012800****************************************************************
012900*    INITIALIZE THE STANDARD MAP LINES                         *
013000****************************************************************
013100*
013200     MOVE SS08WS-CURSOR          TO RS00-ORG-L.
013300     MOVE 00                     TO MBCA-SCREEN-NBR.
013400     PERFORM MB60PD-INIT-STD-MAP-LINES
013500                                 THRU MB60PD-ISML-EXIT.
013600*
013700     IF  MBCA-MERCHANT-ORG IS NUMERIC
013800     AND MBCA-MERCHANT-ORG IS GREATER THAN ZEROES
013900         MOVE MBCA-MERCHANT-ORG  TO RS00-ORG
014000         MOVE DFHBMUNF           TO RS00-ORG-A.
014100*
014200     IF  MBCA-MERCHANT IS NUMERIC
014300     AND MBCA-MERCHANT IS GREATER THAN ZEROES
014400         MOVE MBCA-MERCHANT      TO RS00-MERCHANT
014500         MOVE DFHBMUNF           TO RS00-MERCHANT-A.
014600*
014700     MOVE DFHBMASK               TO RS00-CURRENT-PAGE-A.
014800*
014900****************************************************************
015000*    SEND THE MAP                                              *
015100****************************************************************
015200*
015300     MOVE 'BM01'                 TO MBCA-PROGRAM-LOCATION.
015400     PERFORM MB60PD-SEND-MAP-WITH-ERASE
015500                                 THRU MB60PD-SMWE-EXIT.
015600*
015700****************************************************************
015800*    RETURN TO CICS                                            *
015900****************************************************************
016000*
016100     MOVE 'PC02'                 TO MBCA-PROGRAM-LOCATION.
016200     PERFORM MB70PD-RETURN-TRANS-ID
016300                                 THRU MB70PD-RTI-EXIT.
016400/
016500 2000-RECEIVE-SCREEN SECTION.
016600*
016700****************************************************************
016800*    THIS SECTION RECEIVES THE 00 SCREEN                       *
016900****************************************************************
017000*
017100     MOVE 'BM02'                 TO MBCA-PROGRAM-LOCATION.
017200     PERFORM MB60PD-RECEIVE-MAP  THRU MB60PD-RM-EXIT.
017300*
017400****************************************************************
017500*    CHECK FOR ANOTHER TRANSACTION ID ENTERED BY THE USER      *
017600****************************************************************
017700*
017800     MOVE 'PC03'                 TO MBCA-PROGRAM-LOCATION.
017900     PERFORM MB60PD-NEW-TRANS-ROUTINE
018000                                 THRU MB60PD-NTR-EXIT.
018100*
018200 2100-EDIT-SCREEN.
018300*
018400     SET SS08WS-ERROR-SW-NO      TO TRUE.
018500     MOVE MBCA-EIBAID            TO SS08WS-EIBAID.
018600*
018700     IF  (RS00-ORG-L IS LESS THAN 1
018800     AND  RS00-MERCHANT-L IS LESS THAN 1)
018900     AND (SS08WS-VALID-PF-KEY
019000     OR   SS08WS-EIBAID-VALID-PF-KEY)
019100         SET MBCA-INITIAL-SCREEN-NBR
019200                                 TO TRUE
019300         GO TO 2690-TRANSFER-XCTL.
019400*
019500 2110-EDIT-ORG.
019600*
019700     MOVE DFHBMUNF               TO RS00-ORG-A.
019800     MOVE DFHBMASK               TO RS00-ORG-LP-A
019900                                    RS00-ORG-RP-A.
020000*
020100     IF  RS00-ORG-L IS EQUAL TO ZERO
020200     OR  RS00-ORG IS NOT NUMERIC
020300         MOVE MBEMWS-INVALID-ORG TO RS00-ERR-MESSAGE
020400         GO TO 2130-ORG-ERROR.
020500*
020600     IF  RS00-ORG IS LESS THAN MBCA-ORG-LOW
020700     OR  RS00-ORG IS GREATER THAN MBCA-ORG-HIGH
020800         MOVE MBEMWS-INVALID-ORG TO RS00-ERR-MESSAGE
020900         GO TO 2130-ORG-ERROR.
021000*
021100 2120-READ-ORG.
021200*
021300****************************************************************
021400*    READ THE ORGANIZATION FILE                                *
021500****************************************************************
021600*
021700     MOVE 'FC01'                 TO MBCA-PROGRAM-LOCATION.
021800     MOVE RS00-ORG               TO MBIOWS-MMOC-ORG.
021900     MOVE SS08WS-CICS-FC-NOTFND  TO MBIORO-TEMP-STATUS-1.
022000     SET MBIORO-READ-RANDOM      TO TRUE.
022100     PERFORM MMOCAO-ACCESS       THRU MMOCAO-ACCESS-EXIT.
022200*
022300     IF  SS08WS-RC-FC-VALID-RTN-CODE
022400         MOVE MMOC-ORG           TO MBCA-MERCHANT-ORG
022500                                    MBCA-MBRS-ORG
022600         IF  MMOC-ADD-PENDING
022700             MOVE MBEMWS-ADD-PENDING
022800                                 TO RS00-ERR-MESSAGE
022900         ELSE
023000             IF  MMOC-REC-INCOMPLETE
023100             OR  MMOC-REC-PURGED
023200                 MOVE MBEMWS-NOT-ACTIVE
023300                                 TO RS00-ERR-MESSAGE
023400             ELSE
023500                 GO TO 2140-EDIT-MERCHANT
023600     ELSE
023700         MOVE MBEMWS-NOT-ON-FILE TO RS00-ERR-MESSAGE.
023800*
023900 2130-ORG-ERROR.
024000*
024100     MOVE DFHBMNBF               TO RS00-ORG-A.
024200     MOVE DFHBMASB               TO RS00-ORG-LP-A
024300                                    RS00-ORG-RP-A.
024400     MOVE SS08WS-CURSOR          TO RS00-ORG-L.
024500     SET SS08WS-ERROR-SW-YES     TO TRUE.
024600*
024700 2140-EDIT-MERCHANT.
024800*
024900     MOVE DFHBMUNF               TO RS00-MERCHANT-A.
025000     MOVE DFHBMASK               TO RS00-MERCHANT-LP-A
025100                                    RS00-MERCHANT-RP-A.
025200*
025300     IF  RS00-MERCHANT-L IS EQUAL TO ZERO
025400         IF  MBCA-DIRECT-TRANSFER-CODE
025500             MOVE RS00-MERCHANT  TO MBCA-MBRS-MERCHANT
025600         ELSE
025700             MOVE ZEROES         TO RS00-MERCHANT
025800     ELSE
025900         IF  RS00-MERCHANT IS NOT NUMERIC
026000             MOVE MBEMWS-INVALID-MERCHANT
026100                                 TO RS00-ERR-MESSAGE
026200             GO TO 2150-MERCHANT-ERROR
026300         ELSE
026400             MOVE RS00-MERCHANT  TO MBCA-MBRS-MERCHANT.
026500*
026600     IF  SS08WS-ERROR-SW-YES
026700         GO TO 2290-CHECK-ERROR.
026800*
026900****************************************************************
027000*    START BROWSE THE MMXR FILE                                *
027100****************************************************************
027200*
027300     MOVE 'FC02'                 TO MBCA-PROGRAM-LOCATION.
027400     MOVE RS00-ORG               TO MBIOWS-MMXR-ORG.
027500     MOVE RS00-MERCHANT          TO MBIOWS-MMXR-MERCHANT.
027600     MOVE ZEROS                  TO MBIOWS-MMXR-STORE.
027700     SET MBIORO-STARTBR-GTE      TO TRUE.
027800     PERFORM MMXRAO-ACCESS       THRU MMXRAO-ACCESS-EXIT.
027900*
028000****************************************************************
028100*    READNEXT THE MMXR FILE                                    *
028200****************************************************************
028300*
028400     MOVE 'FC03'                 TO MBCA-PROGRAM-LOCATION.
028500     SET MBIORO-READ-SEQ         TO TRUE.
028600     PERFORM MMXRAO-ACCESS       THRU MMXRAO-ACCESS-EXIT.
028700*
028800****************************************************************
028900*    END BROWSE THE MMXR FILE                                  *
029000****************************************************************
029100*
029200     MOVE 'FC04'                 TO MBCA-PROGRAM-LOCATION.
029300     SET MBIORO-ENDBR            TO TRUE.
029400     PERFORM MMXRAO-ACCESS       THRU MMXRAO-ACCESS-EXIT.
029500*
029600     IF  MMXR-ORG-MERCHANT IS NOT EQUAL TO MBCA-MBRS-ORG-MERCHANT
029700         MOVE 'NO RECORDS ON FILE FOR THE SELECTION CRITERIA'
029800                                 TO RS00-ERR-MESSAGE
029900     ELSE
030000         MOVE MMXR-MERCHANT      TO MBCA-MBRS-MERCHANT
030100                                    MBCA-MERCHANT
030200         MOVE MMXR-STORE         TO MBCA-MBRS-FIRST-STORE
030300                                    MBCA-MBRS-FWD-STORE
030400                                    MBCA-STORE
030500         MOVE SS08WS-CICS-FC-NOTFND TO MBIORO-TEMP-STATUS-1
030600         MOVE SPACES             TO MBCA-MBRS-RETURN-FLAG
030700         MOVE ZEROES             TO MBCA-MBRS-BACK-STORE
030800         MOVE 'FC05'             TO MBCA-PROGRAM-LOCATION
030900         MOVE MMXR-ORG           TO MBIOWS-MMMM-ORG
031000         MOVE MMXR-MERCHANT      TO MBIOWS-MMMM-MERCHANT
031100         MOVE SS08WS-CICS-FC-NOTFND TO MBIORO-TEMP-STATUS-1
031200         SET MBIORO-READ-RANDOM  TO TRUE
031300         PERFORM MMMMAO-ACCESS   THRU MMMMAO-ACCESS-EXIT
031400         IF SS08WS-RC-FC-NOTFND
031500             MOVE MBEMWS-NOT-ON-FILE
031600                                 TO RS00-ERR-MESSAGE
031700             GO TO 2150-MERCHANT-ERROR
031800         ELSE
031900             MOVE MMMM-DBA-NAME  TO MBCA-MBRS-DBA-NAME
032000             MOVE MMMM-DBA-CITY  TO MBCA-MBRS-DBA-CITY
032100             MOVE MMMM-DBA-COUNTRY-CODE
032200                                 TO MBCA-MBRS-DBA-STATE
032300             GO TO 2290-CHECK-ERROR.
032400*
032500 2150-MERCHANT-ERROR.
032600*
032700     MOVE DFHBMNBF               TO RS00-MERCHANT-A
032800                                    RS00-ORG-A
032900     MOVE DFHBMASB               TO RS00-MERCHANT-LP-A
033000                                    RS00-MERCHANT-RP-A
033100                                    RS00-ORG-LP-A
033200                                    RS00-ORG-RP-A.
033300     MOVE SS08WS-CURSOR          TO RS00-ORG-L
033400     SET SS08WS-ERROR-SW-YES     TO TRUE.
033500*
033600 2290-CHECK-ERROR.
033700*
033800     IF  SS08WS-ERROR-SW-NO
033900         GO TO 2600-SETUP-COMMAREA
034000     ELSE
034100         IF  SS08WS-VALID-PF-KEY
034200         OR  SS08WS-EIBAID-VALID-PF-KEY
034300             SET MBCA-INITIAL-SCREEN-NBR
034400                                 TO TRUE
034500             GO TO 2690-TRANSFER-XCTL.
034600*
034700 2300-SEND-MAP.
034800*
034900****************************************************************
035000*    SEND THE MAP                                              *
035100****************************************************************
035200*
035300     PERFORM MB60PD-INIT-STD-MAP-LINES
035400                                 THRU MB60PD-ISML-EXIT.
035500*
035600     IF  MBCA-DIRECT-TRANSFER-CODE
035700         GO TO 1050-SEND-SCREEN-CONTINUE.
035800*
035900     MOVE DFHBMASK               TO RS00-CURRENT-PAGE-A.
036000*
036100     MOVE 'BM03'                 TO MBCA-PROGRAM-LOCATION.
036200     PERFORM MB60PD-SEND-MAP-DATA-ONLY
036300                                 THRU MB60PD-SMDO-EXIT.
036400*
036500****************************************************************
036600*    RETURN TO CICS                                            *
036700****************************************************************
036800*
036900     MOVE 'PC04'                 TO MBCA-PROGRAM-LOCATION.
037000     PERFORM MB70PD-RETURN-TRANS-ID
037100                                 THRU MB70PD-RTI-EXIT.
037200/
037300 2600-SETUP-COMMAREA.
037400*
037500****************************************************************
037600*    SET UP COMMAREA FIELDS AND TRANSFER TO THE NEXT PROGRAM   *
037700****************************************************************
037800*
037900     MOVE MBCA-EIBAID            TO SS08WS-EIBAID.
038000*
038100     MOVE MBIOWS-MMXR-KEY-CODE   TO MBCA-KEY-CODE.
038200*
038300     PERFORM MB60PD-EDIT-PAGE-NBR
038400                                 THRU MB60PD-EPN-EXIT.
038500*
038600     IF  SS08WS-VALID-PF-KEY
038700     OR  SS08WS-EIBAID-VALID-PF-KEY
038800         SET MBCA-INITIAL-SCREEN-NBR
038900                                 TO TRUE.
039000*
039100 2690-TRANSFER-XCTL.
039200*
039300     MOVE 'PC05'                 TO MBCA-PROGRAM-LOCATION.
039400     PERFORM MB70PD-XCTL-TO-MBOXCTL
039500                                 THRU MB70PD-XTM-EXIT.
039600/
039700 9000-PERFORMED-ROUTINES-SECT SECTION.
039800/         NEW ROUTINE FOR JULIAN TO GREGORIAN CONVERSION
039900     COPY SS26PD.
040000/         ROUTINE TO NUMERICALLY EDIT TIME
040100     COPY SS27PD.
040200/         JULIAN TO GREGORIAN DATE ROUTINE
040300     COPY SS08PD.
040400/         LINE 24 PF KEYS ROUTINE
040500     COPY SS15PD.
040600/         ORG RECORD ACCESS ROUTINES
040700     COPY MMOCAO.
040800/         STORE/MERCHANT XREF RECORD ACCESS ROUTINES
040900     COPY MMXRAO.
041000/         MERCHANT RECORD ACCESS ROUTINES
041100     COPY MMMMAO.
041200/         ON-LINE MAP ROUTINES
041300     COPY MB60PD REPLACING 'MBMAPXX' BY 'MBRS00 '
041400                           MBMAPXXI BY MBRS00I
041500                           MBMAPXXO BY MBRS00O.
041600/         ON-LINE PROCEDURES
041700     COPY MB70PD.
041800/
041900     COPY SMFTPXO.
