000100 IDENTIFICATION DIVISION.
000200 PROGRAM-ID. MBORS01.
000201*       RELEASE DATE=08/24/01.        REVISION LEVEL=08.06      *
000202*****************************************************************
000203*WARNING.  THIS COMPUTER PROGRAM IS PROTECTED BY COPYRIGHT LAW  *
000204*AND INTERNATIONAL TREATIES.  UNAUTHORIZED REPRODUCTION OR      *
000205*DISTRIBUTION OF THIS PROGRAM, OR ANY PORTION OF IT, MAY RESULT *
000206*IN SEVERE CIVIL AND CRIMINAL PENATLIES, AND WILL BE PROSECUTED *
000207*TO THE MAXIMUM EXTENT POSSIBLE UNDER THE LAW.                  *
000208*COPYRIGHT 1999 PAYSYS INTERNATIONAL, INC.  ALL RIGHTS RESERVED.*
000209*****************************************************************
000300*****************************************************************
000400*                                                               *
000500*   V - PLUS  M E R C H A N T   B A N K C A R D   S Y S T E M   *
000600*                                                               *
000700*      MBORS01 - ON-LINE STORE RELATIONSHIP DIRECTORY           *
000800*                SCREEN 01                                      *
000900*                                                               *
001000*              1. TRANSIDS                                      *
001100*                 A. MBRS                                       *
001200*              2. MAPS USED -                                   *
001300*                 A. MBRS01 (SCREEN 01)                         *
001400*              3. FILES USED -                                  *
001500*                 A. MMXR   (STORE MERCHANT CROSS REF FILE)     *
001600*                 B. MMSM   (STORE MASTER FILE)                 *
001700*                                                               *
001800*****************************************************************
001900*
002000 ENVIRONMENT DIVISION.
002100 DATA DIVISION.
002200 WORKING-STORAGE SECTION.
002300 01  FILLER                  PIC  X(12)      VALUE '** WS-BEG **'.
002400*         I/O REQUEST BLOCK WORK AREAS
002500     COPY MBIOWS.
002600/         I/O REQUEST BLOCK
002700     COPY MBIORO.
002800/         DATE WORK AREAS
002900     COPY SS01WS.
003000/         ONLINE WORK AREAS
003100     COPY SS08WS.
003200/
003300     COPY SS00WS.
003400/
003500     COPY SMFTWS.
003600/
003700     COPY SMPTRL REPLACING ==:SMPT:== BY ==SMPT==.
003800/
003900     COPY MB61LK.
004000/
004100 01  WS-MISCELLANEOUS.
004200     03  WS-SAVE-EIBAID      PIC  X(01)      VALUE SPACES.
004300     03  WS-FWD-STORE        PIC  9(09)      VALUE ZEROES.
004400     03  WS-SELECT-SW        PIC  X(01)      VALUE 'N'.
004500         88  WS-SELECT-NO                    VALUE 'N'.
004600         88  WS-SELECT-YES                   VALUE 'Y'.
004700     03  WS-BYPASS-SW        PIC  X(01)      VALUE 'N'.
004800         88  WS-BYPASS-NO                    VALUE 'N'.
004900         88  WS-BYPASS-YES                   VALUE 'Y'.
005000     03  TS-QUEUE-NAME.
005100         05  TS-QN-TERMID    PIC  X(04)      VALUE SPACES.
005200         05  TS-QN-TRANID    PIC  X(04)      VALUE 'MBRS'.
005300*
005400 01  WS-DETAIL-LINE.
005500     03  WS-STORE-NBR        PIC  9(09).
005600     03  FILLER              PIC  X(02)      VALUE SPACES.
005700     03  WS-PRIM-NAME        PIC  X(30).
005800     03  FILLER              PIC  X(02)      VALUE SPACES.
005900     03  WS-PHONE-NUMBER     PIC  X(17).
006000     03  FILLER              PIC  X(02)      VALUE SPACES.
006100     03  WS-STATUS-CODE      PIC  9(01).
006200     03  FILLER              PIC  X(03)      VALUE SPACES.
006300     03  WS-AUTH-CODE        PIC  X(01).
006400*
006500 01  FILLER                  PIC  X(12)      VALUE '** WS-END **'.
006600/
006700 LINKAGE SECTION.
006800 01  DFHCOMMAREA.
006900     COPY MB60WS.
007000/         STORE RELATIONSHIP DIRECTORY SCREEN 01 MAP DSECT
007100     COPY MBRS01.
007200/         STORE RELATIONSHIP DIRECTORY SCREEN 01 MAP REDEFINITION
007300     COPY MBRS01R.
007400/         STORE FILE RECORD LAYOUT
007500     COPY MMSMRL.
007600/         STORE/MERCHANT XREF FILE RECORD LAYOUT
007700     COPY MMXRRL.
007800/         STORE RELATIONSHIP DIRECTORY TEMPORARY STORAGE
007900     COPY MBRSTS.
008000/
008100 PROCEDURE DIVISION.
008200 0000-HOUSEKEEPING SECTION.
008300 0100-INIT.
008400*
008500     MOVE MBCA-EIBAID            TO WS-SAVE-EIBAID.
008600     SET MBCA-EIBAID-ENTER       TO TRUE.
008700*
008800     MOVE 'PC01'                 TO MBCA-PROGRAM-LOCATION.
008900     PERFORM MB70PD-ON-LINE-HOUSEKEEPING
009000                                 THRU MB70PD-OLH-EXIT.
009100*
009200     MOVE WS-SAVE-EIBAID         TO MBCA-EIBAID.
009300     MOVE MBCA-TERMINAL-ID       TO TS-QN-TERMID.
009400*
009500     IF  MBCA-RECEIVE-SCREEN
009600         GO TO 2000-RECEIVE-SCREEN.
009700*
009800 1000-SEND-SCREEN SECTION.
009900*
010000****************************************************************
010100*    GET CICS STORAGE NEEDED FOR THE MAP                       *
010200****************************************************************
010300*
010400     MOVE 'SC01'                 TO MBCA-PROGRAM-LOCATION.
010500     PERFORM MB60PD-GETMAIN-FOR-MAP
010600                                 THRU MB60PD-GFM-EXIT.
010700*
010800     MOVE MBCA-MBRS-ORG          TO RS01-ORG.
010900     MOVE MBCA-MBRS-MERCHANT     TO RS01-MERCHANT.
011000     MOVE MBCA-MBRS-DBA-NAME     TO RS01-DBA-NAME.
011100     MOVE MBCA-MBRS-DBA-CITY     TO RS01-DBA-CITY.
011200     MOVE MBCA-MBRS-DBA-STATE    TO RS01-DBA-STATE.
011300     MOVE 01                     TO MBCA-SCREEN-NBR.
011400*
011500****************************************************************
011600*    INITIALIZE THE STANDARD MAP LINES                         *
011700****************************************************************
011800*
011900     PERFORM MB60PD-INIT-STD-MAP-LINES
012000                                 THRU MB60PD-ISML-EXIT.
012100*
012200****************************************************************
012300*    ACQUIRE MAIN STORAGE FOR TEMP STORAGE RECORD              *
012400****************************************************************
012500*
012600     MOVE 'TS01'                 TO MBCA-PROGRAM-LOCATION.
012700     PERFORM 8100-TEMP-STORAGE-GETMAIN
012800                                 THRU 8199-TSG-EXIT.
012900*
013000     EXEC CICS HANDLE CONDITION
013100               QIDERR (1010-CHECK-RETURN-FLAG)
013200          END-EXEC.
013300*
013400***********************************************
013500*    READ THE TEMP STORAGE RECORD             *
013600***********************************************
013700*
013800     MOVE 'TS02'                 TO MBCA-PROGRAM-LOCATION.
013900     PERFORM 8200-TEMP-STORAGE-READ
014000                                 THRU 8299-TSR-EXIT.
014100*
014200***********************************************
014300*    DELETE THE TEMP STORAGE RECORD           *
014400***********************************************
014500*
014600     MOVE 'TS03'                 TO MBCA-PROGRAM-LOCATION.
014700     PERFORM 8300-TEMP-STORAGE-DELETE
014800                                 THRU 8399-TSD-EXIT.
014900*
015000     PERFORM 8800-BUILD-SCREEN   THRU 8899-BS-EXIT.
015100     GO TO 1080-CONTINUE.
015200*
015300 1010-CHECK-RETURN-FLAG.
015400*
015500     IF  MBCA-MBRS-RETURN-BOTTOM
015600         PERFORM 8900-LAST-SCREEN
015700                                 THRU 8999-LS-EXIT
015800         IF  WS-BYPASS-YES
015900             GO TO 1015-READ-MMXR
016000         ELSE
016100             GO TO 1080-CONTINUE
016200     ELSE
016300         IF  MBCA-MBRS-RETURN-BWD
016400             PERFORM 9000-BACK-SCREEN
016500                                 THRU 9099-BS-EXIT
016600             IF  WS-BYPASS-YES
016700                 GO TO 1015-READ-MMXR
016800             ELSE
016900                 GO TO 1080-CONTINUE.
017000*
017100 1015-READ-MMXR.
017200*
017300****************************************************************
017400*    START BROWSE THE MMXR FILE                                *
017500****************************************************************
017600*
017700     MOVE 'FC01'                 TO MBCA-PROGRAM-LOCATION.
017800     MOVE MBCA-MBRS-ORG          TO MBIOWS-MMXR-ORG.
017900     MOVE MBCA-MBRS-MERCHANT     TO MBIOWS-MMXR-MERCHANT.
018000     MOVE MBCA-MBRS-FWD-STORE    TO MBIOWS-MMXR-STORE.
018100     SET MBIORO-STARTBR-GTE      TO TRUE.
018200     PERFORM MMXRAO-ACCESS       THRU MMXRAO-ACCESS-EXIT.
018300*
018400     SET X-STORE-INDEX           TO +1.
018500*
018600 1020-READ-LOOP.
018700*
018800****************************************************************
018900*    READNEXT THE MMXR FILE                                    *
019000****************************************************************
019100*
019200     MOVE 'FC02'                 TO MBCA-PROGRAM-LOCATION.
019300     SET MBIORO-READ-SEQ         TO TRUE.
019400     PERFORM MMXRAO-ACCESS       THRU MMXRAO-ACCESS-EXIT.
019500*
019600     IF  MMXR-ORG-MERCHANT IS GREATER THAN MBCA-MBRS-ORG-MERCHANT
019700         GO TO 1020-END-BROWSE.
019800*
019900     IF  MMXR-REC-PURGED
020000         GO TO 1020-READ-LOOP.
020100*
020200     PERFORM 9500-BUILD-SCREEN-LINE
020300                                 THRU 9599-BSL-EXIT.
020400*
020500     IF  X-STORE-INDEX IS EQUAL TO +1
020600         MOVE MMXR-STORE         TO MBCA-MBRS-BACK-STORE.
020700*
020800     IF  X-STORE-INDEX IS LESS THAN +15
020900         SET X-STORE-INDEX       UP BY +1
021000         GO TO 1020-READ-LOOP
021100     ELSE
021200         MOVE MMXR-STORE         TO MBCA-MBRS-FWD-STORE
021300         PERFORM 9400-READ-AHEAD THRU 9499-RA-EXIT
021400         SET X-STORE-INDEX       UP BY +1.
021500*
021600 1020-END-BROWSE.
021700*
021800****************************************************************
021900*    END BROWSE THE MMXR FILE                                  *
022000****************************************************************
022100*
022200     MOVE 'FC03'                 TO MBCA-PROGRAM-LOCATION.
022300     SET MBIORO-ENDBR            TO TRUE.
022400     PERFORM MMXRAO-ACCESS      THRU MMXRAO-ACCESS-EXIT.
022500*
022600 1060-SET-ATTRIBUTE.
022700*
022800     IF  X-STORE-INDEX IS EQUAL TO +1
022900         IF  MBCA-MBRS-RETURN-NORMAL
023000             SET MBCA-INITIAL-SCREEN-NBR
023100                                 TO TRUE
023200             MOVE 'PC02'         TO MBCA-PROGRAM-LOCATION
023300             PERFORM MB70PD-XCTL-TO-MBOXCTL
023400                                 THRU MB70PD-XTM-EXIT
023500         ELSE
023600             MOVE MBCA-MBRS-BACK-STORE
023700                                 TO MBCA-MBRS-FWD-STORE
023800             GO TO 1015-READ-MMXR.
023900*
024000     IF  X-STORE-INDEX IS LESS THAN +16
024100         SET X-MBRSTS-INDEX      TO X-STORE-INDEX
024200         MOVE ZEROES             TO MBCA-MBRS-FWD-STORE
024300                                    WS-FWD-STORE
024400                                    MBRSTS-STORE
024500                                    (X-MBRSTS-INDEX)
024600                                    MBRSTS-STATUS-CODE
024700                                    (X-MBRSTS-INDEX)
024800         MOVE SPACES             TO MBRSTS-PRIM-NAME
024900                                    (X-MBRSTS-INDEX)
025000                                    MBRSTS-PHONE-NUMBER
025100                                    (X-MBRSTS-INDEX)
025200                                    MBRSTS-AUTH-CODE
025300                                    (X-MBRSTS-INDEX)
025400         MOVE DFHBMASK           TO RS01-SELECT-A
025500                                    (X-STORE-INDEX)
025600         MOVE DFHBMDAS           TO RS01-DIRECTORY-LINE-A
025700                                    (X-STORE-INDEX)
025800                                    RS01-SELECT-LP-A
025900                                    (X-STORE-INDEX)
026000                                    RS01-SELECT-RP-A
026100                                    (X-STORE-INDEX)
026200         SET X-STORE-INDEX       UP BY +1
026300         GO TO 1060-SET-ATTRIBUTE.
026400*
026500 1080-CONTINUE.
026600*
026700     IF  MBCA-MBRS-BACK-STORE IS NOT EQUAL
026800                                 TO MBCA-MBRS-FIRST-STORE
026900         MOVE DFHBMASB           TO RS01-FWD-BACK-IND-A (1).
027000*
027100     IF  WS-FWD-STORE IS NOT EQUAL TO ZEROES
027200         MOVE DFHBMASB           TO RS01-FWD-BACK-IND-A (15).
027300*
027400****************************************************************
027500*    WRITE THE TEMP STORAGE RECORD                             *
027600****************************************************************
027700*
027800     MOVE 'TS04'                 TO MBCA-PROGRAM-LOCATION.
027900     PERFORM 8400-WRITE-QUEUE    THRU 8499-WQ-EXIT.
028000*
028100     PERFORM 9100-SET-ATTRIBUTE  THRU 9199-SA-EXIT
028200         VARYING X-STORE-INDEX FROM +1 BY +1
028300         UNTIL   X-STORE-INDEX IS GREATER THAN +15.
028400*
028500     SET X-STORE-INDEX           TO +1.
028600*
028700 1090-CURSOR-LOOP.
028800*
028900     IF  X-STORE-INDEX IS GREATER THAN +15
029000         MOVE SS08WS-CURSOR      TO RS01-ALT-TRANID-L
029100         GO TO 1100-CONTINUE.
029200*
029300     IF  RS01-SELECT-A (X-STORE-INDEX)
029400                                 IS EQUAL TO DFHBMASK
029500         SET X-STORE-INDEX       UP BY +1
029600         GO TO 1090-CURSOR-LOOP
029700     ELSE
029800         MOVE SS08WS-CURSOR      TO RS01-SELECT-L
029900                                    (X-STORE-INDEX).
030000*
030100 1100-CONTINUE.
030200*
030300     MOVE '*TOP*'                TO SS08WS-LINE-24-PF-KEY-FUNC(3).
030400     MOVE '*BOT*'                TO SS08WS-LINE-24-PF-KEY-FUNC(4).
030500     MOVE '*FWD*'                TO SS08WS-LINE-24-PF-KEY-FUNC(5).
030600     MOVE '*BWD*'                TO SS08WS-LINE-24-PF-KEY-FUNC(6).
030700     MOVE SS08WS-LINE-24         TO RS01-PF-KEYS.
030800     MOVE 'RESV'                 TO MBCA-PGMX-PF-TRANS-ID (3).
030900     MOVE 'RESV'                 TO MBCA-PGMX-PF-TRANS-ID (4).
031000     MOVE 'RESV'                 TO MBCA-PGMX-PF-TRANS-ID (5).
031100     MOVE 'RESV'                 TO MBCA-PGMX-PF-TRANS-ID (6).
031200*
031300     MOVE DFHBMASK               TO RS01-CURRENT-PAGE-A.
031400*
031500****************************************************************
031600*    SEND THE MAP                                              *
031700****************************************************************
031800*
031900     MOVE 'BM01'                 TO MBCA-PROGRAM-LOCATION.
032000     PERFORM MB60PD-SEND-MAP-WITH-ERASE
032100                                 THRU MB60PD-SMWE-EXIT.
032200*
032300****************************************************************
032400*    RETURN TO CICS                                            *
032500****************************************************************
032600*
032700     MOVE 'PC03'                 TO MBCA-PROGRAM-LOCATION.
032800     PERFORM MB70PD-RETURN-TRANS-ID
032900                                 THRU MB70PD-RTI-EXIT.
033000/
033100 2000-RECEIVE-SCREEN SECTION.
033200*
033300     IF  MBCA-EIBAID-CLEAR
033400         MOVE 'TS05'             TO MBCA-PROGRAM-LOCATION
033500         PERFORM 8300-TEMP-STORAGE-DELETE
033600                                 THRU 8399-TSD-EXIT
033700         MOVE 'PC04'             TO MBCA-PROGRAM-LOCATION
033800         PERFORM MB70PD-ON-LINE-HOUSEKEEPING
033900                                 THRU MB70PD-OLH-EXIT.
034000*
034100****************************************************************
034200*    THIS SECTION RECEIVES THE 01 SCREEN                       *
034300****************************************************************
034400*
034500     MOVE 'BM02'                 TO MBCA-PROGRAM-LOCATION.
034600     PERFORM MB60PD-RECEIVE-MAP  THRU MB60PD-RM-EXIT.
034700*
034800*****************************************************
034900*    ACQUIRE MAIN STORAGE FOR TEMP STORAGE RECORD   *
035000*****************************************************
035100*
035200     MOVE 'TS06'                 TO MBCA-PROGRAM-LOCATION.
035300     PERFORM 8100-TEMP-STORAGE-GETMAIN
035400                                 THRU 8199-TSG-EXIT.
035500*
035600***********************************************
035700*    READ THE TEMP STORAGE RECORD             *
035800***********************************************
035900*
036000     MOVE 'TS07'                 TO MBCA-PROGRAM-LOCATION.
036100     PERFORM 8200-TEMP-STORAGE-READ
036200                                 THRU 8299-TSR-EXIT.
036300*
036400***********************************************
036500*    DELETE THE TEMP STORAGE RECORD           *
036600***********************************************
036700*
036800     MOVE 'TS08'                 TO MBCA-PROGRAM-LOCATION.
036900     PERFORM 8300-TEMP-STORAGE-DELETE
037000                                 THRU 8399-TSD-EXIT.
037100*
037200****************************************************************
037300*    CHECK FOR ANOTHER TRANSACTION ID ENTERED BY THE USER      *
037400****************************************************************
037500*
037600     MOVE 'PC05'                 TO MBCA-PROGRAM-LOCATION.
037700     PERFORM MB60PD-NEW-TRANS-ROUTINE
037800                                 THRU MB60PD-NTR-EXIT.
037900*
038000 2005-EDIT-SELECT.
038100*
038200****************************************************************
038300*    EDIT SELECT FIELD                                         *
038400****************************************************************
038500*
038600     PERFORM 8600-EDIT-SELECT    THRU 8699-ES-EXIT.
038700*
038800 2090-CHECK-ERROR.
038900*
039000     IF  SS08WS-ERROR-SW-NO
039100         GO TO 2400-CHECK-SELECT.
039200*
039300 2300-SEND-MAP.
039400*
039500***********************************************
039600*    WRITE THE TEMP STORAGE RECORD            *
039700***********************************************
039800*
039900     MOVE 'TS09'                 TO MBCA-PROGRAM-LOCATION.
040000     PERFORM 8400-WRITE-QUEUE    THRU 8499-WQ-EXIT.
040100*
040200****************************************************************
040300*    SEND THE MAP                                              *
040400****************************************************************
040500*
040600     PERFORM MB60PD-INIT-STD-MAP-LINES
040700                                 THRU MB60PD-ISML-EXIT.
040800*
040900     MOVE '*TOP*'                TO SS08WS-LINE-24-PF-KEY-FUNC(3).
041000     MOVE '*BOT*'                TO SS08WS-LINE-24-PF-KEY-FUNC(4).
041100     MOVE '*FWD*'                TO SS08WS-LINE-24-PF-KEY-FUNC(5).
041200     MOVE '*BWD*'                TO SS08WS-LINE-24-PF-KEY-FUNC(6).
041300     MOVE SS08WS-LINE-24         TO RS01-PF-KEYS.
041400     MOVE 'RESV'                 TO MBCA-PGMX-PF-TRANS-ID (3).
041500     MOVE 'RESV'                 TO MBCA-PGMX-PF-TRANS-ID (4).
041600     MOVE 'RESV'                 TO MBCA-PGMX-PF-TRANS-ID (5).
041700     MOVE 'RESV'                 TO MBCA-PGMX-PF-TRANS-ID (6).
041800*
041900     MOVE DFHBMASK               TO RS01-CURRENT-PAGE-A.
042000*
042100     MOVE 'BM03'                 TO MBCA-PROGRAM-LOCATION.
042200     PERFORM MB60PD-SEND-MAP-DATA-ONLY
042300                                 THRU MB60PD-SMDO-EXIT.
042400*
042500****************************************************************
042600*    RETURN TO CICS                                            *
042700****************************************************************
042800*
042900     MOVE 'PC06'                 TO MBCA-PROGRAM-LOCATION.
043000     PERFORM MB70PD-RETURN-TRANS-ID
043100                                 THRU MB70PD-RTI-EXIT.
043200/
043300 2400-CHECK-SELECT.
043400*
043500     IF  WS-SELECT-YES
043600         SET X-MBRSTS-INDEX      TO X-STORE-INDEX
043700         MOVE MBRSTS-STORE (X-MBRSTS-INDEX)
043800                                 TO MBCA-STORE
043900         MOVE MBIOWS-MMMM-DIRECT-KEY-CODE
044000                                 TO MBCA-KEY-CODE
044100         SET MBCA-INITIAL-SCREEN-NBR
044200                                 TO TRUE
044300         IF  RS01-VALID-INQUIRY (X-STORE-INDEX)
044400             MOVE '..QS'         TO SS08WS-WORK-TRANS-ID
044500             GO TO 2690-PF-KEY-BYPASS
044600         ELSE
044700             IF  RS01-VALID-MAINT (X-STORE-INDEX)
044800                 MOVE '..MS'     TO SS08WS-WORK-TRANS-ID
044900                 GO TO 2690-PF-KEY-BYPASS.
045000/
045100 2600-SETUP-COMMAREA.
045200*
045300****************************************************************
045400*    SET UP COMMAREA FIELDS AND TRANSFER TO THE NEXT PROGRAM   *
045500****************************************************************
045600*
045700     MOVE MBCA-EIBAID            TO SS08WS-EIBAID.
045800*
045900     IF  SS08WS-VALID-PF3
046000     OR  SS08WS-EIBAID-VALID-PF3
046100         MOVE 51                 TO MBCA-SCREEN-NBR
046200         MOVE MBCA-MBRS-FIRST-STORE
046300                                 TO MBCA-MBRS-FWD-STORE
046400         SET MBCA-MBRS-RETURN-NORMAL
046500                                 TO TRUE
046600         GO TO 2690-PF-KEY-BYPASS.
046700*
046800     IF  SS08WS-VALID-PF4
046900     OR  SS08WS-EIBAID-VALID-PF4
047000         MOVE 51                 TO MBCA-SCREEN-NBR
047100         IF (MBRSTS-STORE (1) IS GREATER THAN ZEROES
047200         AND MBRSTS-STORE (15) IS EQUAL TO ZEROES)
047300         OR (MBCA-MBRS-FWD-STORE IS EQUAL TO ZEROES)
047400             SET MBCA-MBRS-RETURN-NORMAL
047500                                 TO TRUE
047600             MOVE ZEROES         TO MBCA-MBRS-FWD-STORE
047700             MOVE 'TS10'         TO MBCA-PROGRAM-LOCATION
047800             PERFORM 8400-WRITE-QUEUE
047900                                 THRU 8499-WQ-EXIT
048000             GO TO 2690-PF-KEY-BYPASS
048100         ELSE
048200             SET MBCA-MBRS-RETURN-BOTTOM
048300                                 TO TRUE
048400             GO TO 2690-PF-KEY-BYPASS.
048500*
048600     IF  SS08WS-VALID-PF5
048700     OR  SS08WS-EIBAID-VALID-PF5
048800         MOVE 51                 TO MBCA-SCREEN-NBR
048900         IF (MBRSTS-STORE (1) IS GREATER THAN ZEROES
049000         AND MBRSTS-STORE (15) IS EQUAL TO ZEROES)
049100         OR (MBCA-MBRS-FWD-STORE IS EQUAL TO ZEROES)
049200             SET MBCA-MBRS-RETURN-NORMAL
049300                                 TO TRUE
049400             MOVE ZEROES         TO MBCA-MBRS-FWD-STORE
049500             MOVE 'TS11'         TO MBCA-PROGRAM-LOCATION
049600             PERFORM 8400-WRITE-QUEUE
049700                                 THRU 8499-WQ-EXIT
049800             GO TO 2690-PF-KEY-BYPASS
049900         ELSE
050000             SET MBCA-MBRS-RETURN-FWD
050100                                 TO TRUE
050200             ADD 1               TO MBCA-MBRS-FWD-STORE
050300             GO TO 2690-PF-KEY-BYPASS.
050400*
050500     IF  SS08WS-VALID-PF6
050600     OR  SS08WS-EIBAID-VALID-PF6
050700         MOVE 51                 TO MBCA-SCREEN-NBR
050800         IF  MBCA-MBRS-BACK-STORE IS EQUAL
050900                                 TO MBCA-MBRS-FIRST-STORE
051000             SET MBCA-MBRS-RETURN-NORMAL
051100                                 TO TRUE
051200             MOVE 'TS12'         TO MBCA-PROGRAM-LOCATION
051300             PERFORM 8400-WRITE-QUEUE
051400                                 THRU 8499-WQ-EXIT
051500             GO TO 2690-PF-KEY-BYPASS
051600         ELSE
051700             MOVE MBCA-MBRS-BACK-STORE
051800                                 TO MBCA-MBRS-FWD-STORE
051900             SET MBCA-MBRS-RETURN-BWD
052000                                 TO TRUE
052100             GO TO 2690-PF-KEY-BYPASS.
052200*
052300     IF  SS08WS-VALID-PF-KEY
052400     OR  SS08WS-EIBAID-VALID-PF-KEY
052500     OR  MBRSTS-STORE (15) IS EQUAL TO ZEROES
052600     OR  MBCA-MBRS-FWD-STORE IS EQUAL TO ZEROES
052700         SET MBCA-INITIAL-SCREEN-NBR
052800                                 TO TRUE
052900         MOVE MBIOWS-MMMM-KEY-CODE
053000                                 TO MBCA-KEY-CODE
053100         SET MBCA-MBRS-RETURN-NORMAL
053200                                 TO TRUE
053300         GO TO 2690-PF-KEY-BYPASS.
053400*
053500     MOVE 51                     TO MBCA-SCREEN-NBR.
053600     ADD 1                       TO MBCA-MBRS-FWD-STORE.
053700     SET MBCA-MBRS-RETURN-NORMAL TO TRUE.
053800*
053900 2690-PF-KEY-BYPASS.
054000*
054100     MOVE 'PC07'                 TO MBCA-PROGRAM-LOCATION.
054200     PERFORM MB70PD-XCTL-TO-MBOXCTL
054300                                 THRU MB70PD-XTM-EXIT.
054400/
054500 8000-PERFORMED-ROUTINES-SECT SECTION.
054600*
054700 8100-TEMP-STORAGE-GETMAIN.
054800*
054900     EXEC CICS GETMAIN
055000               FLENGTH (LENGTH  OF MBRSTS-RECORD)
055100               SET     (ADDRESS OF MBRSTS-RECORD)
055200          END-EXEC.
055300*
055400 8199-TSG-EXIT.
055500     EXIT.
055600*
055700 8200-TEMP-STORAGE-READ.
055800*
055900     EXEC CICS READQ TS
056000               QUEUE   (TS-QUEUE-NAME)
056100               INTO    (MBRSTS-RECORD)
056200               LENGTH  (LENGTH  OF MBRSTS-RECORD)
056300               ITEM    (1)
056400          END-EXEC.
056500*
056600 8299-TSR-EXIT.
056700     EXIT.
056800*
056900 8300-TEMP-STORAGE-DELETE.
057000*
057100     EXEC CICS IGNORE CONDITION
057200               QIDERR
057300          END-EXEC.
057400*
057500     EXEC CICS DELETEQ TS
057600               QUEUE  (TS-QUEUE-NAME)
057700          END-EXEC.
057800*
057900 8399-TSD-EXIT.
058000     EXIT.
058100*
058200 8400-WRITE-QUEUE.
058300*
058400     EXEC CICS WRITEQ TS
058500               QUEUE   (TS-QUEUE-NAME)
058600               FROM    (MBRSTS-RECORD)
058700               LENGTH  (LENGTH  OF MBRSTS-RECORD)
058800          END-EXEC.
058900*
059000 8499-WQ-EXIT.
059100     EXIT.
059200*
059300 8600-EDIT-SELECT.
059400*
059500     SET X-STORE-INDEX           TO +1.
059600*
059700 8600-EDIT-LOOP.
059800*
059900     IF  RS01-SELECT-L (X-STORE-INDEX) IS GREATER THAN ZERO
060000         IF  RS01-VALID-SELECT (X-STORE-INDEX)
060100             MOVE DFHBMASF       TO RS01-SELECT-A
060200                                    (X-STORE-INDEX)
060300             MOVE DFHBMDAS       TO RS01-SELECT-LP-A
060400                                    (X-STORE-INDEX)
060500                                    RS01-SELECT-RP-A
060600                                    (X-STORE-INDEX)
060700             IF  RS01-VALID-INQUIRY-MAINT (X-STORE-INDEX)
060800                 SET WS-SELECT-YES
060900                                 TO TRUE
061000                 GO TO 8699-ES-EXIT
061100             ELSE
061200                 NEXT SENTENCE
061300         ELSE
061400             SET SS08WS-ERROR-SW-YES TO TRUE
061500             MOVE SS08WS-CURSOR  TO RS01-SELECT-L
061600                                    (X-STORE-INDEX)
061700             MOVE DFHBMUBF       TO RS01-SELECT-A
061800                                    (X-STORE-INDEX)
061900             MOVE DFHBMASB       TO RS01-SELECT-LP-A
062000                                    (X-STORE-INDEX)
062100                                    RS01-SELECT-RP-A
062200                                    (X-STORE-INDEX)
062300             GO TO 8699-ES-EXIT.
062400*
062500     IF  X-STORE-INDEX IS LESS THAN +15
062600         SET X-STORE-INDEX       UP BY +1
062700         GO TO 8600-EDIT-LOOP.
062800*
062900 8699-ES-EXIT.
063000     EXIT.
063100*
063200 8800-BUILD-SCREEN.
063300*
063400     SET X-STORE-INDEX           TO +1.
063500*
063600 8800-BUILD-LOOP.
063700*
063800     SET X-MBRSTS-INDEX          TO X-STORE-INDEX.
063900*
064000     IF  MBRSTS-STORE (X-MBRSTS-INDEX)
064100                                 IS GREATER THAN ZEROES
064200         MOVE MBRSTS-STORE (X-MBRSTS-INDEX)
064300                                 TO WS-STORE-NBR
064400         MOVE MBRSTS-PRIM-NAME (X-MBRSTS-INDEX)
064500                                 TO WS-PRIM-NAME
064600         MOVE MBRSTS-PHONE-NUMBER (X-MBRSTS-INDEX)
064700                                 TO WS-PHONE-NUMBER
064800         MOVE MBRSTS-STATUS-CODE (X-MBRSTS-INDEX)
064900                                 TO WS-STATUS-CODE
065000         MOVE MBRSTS-AUTH-CODE   (X-MBRSTS-INDEX)
065100                                 TO WS-AUTH-CODE
065200         MOVE WS-DETAIL-LINE     TO RS01-DIRECTORY-LINE
065300                                    (X-STORE-INDEX)
065400     ELSE
065500         MOVE DFHBMASK           TO RS01-SELECT-A
065600                                    (X-STORE-INDEX)
065700         MOVE DFHBMDAS           TO RS01-DIRECTORY-LINE-A
065800                                    (X-STORE-INDEX)
065900                                    RS01-SELECT-LP-A
066000                                    (X-STORE-INDEX)
066100                                    RS01-SELECT-RP-A
066200                                    (X-STORE-INDEX).
066300*
066400     IF  X-STORE-INDEX IS LESS THAN +15
066500         SET X-STORE-INDEX       UP BY +1
066600         GO TO 8800-BUILD-LOOP
066700     ELSE
066800         MOVE MBCA-MBRS-FWD-STORE
066900                                 TO WS-FWD-STORE.
067000*
067100 8899-BS-EXIT.
067200     EXIT.
067300*
067400 8900-LAST-SCREEN.
067500*
067600****************************************************************
067700*    START BROWSE THE MMXR FILE                                *
067800****************************************************************
067900*
068000     MOVE 'FC04'                 TO MBCA-PROGRAM-LOCATION.
068100     MOVE MBCA-MBRS-ORG          TO MBIOWS-MMXR-ORG.
068200     MOVE MBCA-MBRS-MERCHANT     TO MBIOWS-MMXR-MERCHANT.
068300     MOVE 999999999              TO MBIOWS-MMXR-STORE.
068400     SET MBIORO-STARTBR-GTE      TO TRUE.
068500     PERFORM MMXRAO-ACCESS       THRU MMXRAO-ACCESS-EXIT.
068600*
068700****************************************************************
068800*    READNEXT THE MMXR FILE                                    *
068900****************************************************************
069000*
069100     MOVE 'FC05'                 TO MBCA-PROGRAM-LOCATION.
069200     SET MBIORO-READ-SEQ         TO TRUE.
069300     PERFORM MMXRAO-ACCESS       THRU MMXRAO-ACCESS-EXIT.
069400*
069500****************************************************************
069600*    READPREV THE MMXR FILE                                    *
069700****************************************************************
069800*
069900     MOVE 'FC06'                 TO MBCA-PROGRAM-LOCATION.
070000     SET MBIORO-READ-PREV        TO TRUE.
070100     PERFORM MMXRAO-ACCESS       THRU MMXRAO-ACCESS-EXIT.
070200*
070300     SET X-STORE-INDEX           TO +15.
070400     SET WS-BYPASS-NO            TO TRUE.
070500*
070600 8900-READ-MMXR-FILE.
070700*
070800****************************************************************
070900*    READPREV THE MMXR FILE                                    *
071000****************************************************************
071100*
071200     MOVE 'FC07'                 TO MBCA-PROGRAM-LOCATION.
071300     SET MBIORO-READ-PREV        TO TRUE.
071400     PERFORM MMXRAO-ACCESS       THRU MMXRAO-ACCESS-EXIT.
071500*
071600 8900-BUILD-LOOP.
071700*
071800     IF  MMXR-ORG IS LESS THAN MBCA-MBRS-ORG
071900     OR  MMXR-MERCHANT IS LESS THAN MBCA-MBRS-MERCHANT
072000     OR  MMXR-STORE    IS LESS THAN MBCA-MBRS-FIRST-STORE
072100         GO TO 8900-END-BROWSE.
072200*
072300     IF  MMXR-STORE IS EQUAL TO MBCA-MBRS-FIRST-STORE
072400     AND X-STORE-INDEX IS GREATER THAN +1
072500         SET MBCA-MBRS-RETURN-NORMAL
072600                                 TO TRUE
072700         MOVE MBCA-MBRS-FIRST-STORE
072800                                 TO MBCA-MBRS-FWD-STORE
072900         SET WS-BYPASS-YES       TO TRUE
073000         GO TO 8900-END-BROWSE.
073100*
073200     PERFORM 9500-BUILD-SCREEN-LINE
073300                                 THRU 9599-BSL-EXIT.
073400*
073500     IF  X-STORE-INDEX IS GREATER THAN +1
073600         SET X-STORE-INDEX       DOWN BY +1
073700         GO TO 8900-READ-MMXR-FILE
073800     ELSE
073900         MOVE MMXR-STORE         TO MBCA-MBRS-BACK-STORE.
074000*
074100 8900-END-BROWSE.
074200*
074300****************************************************************
074400*    END BROWSE THE MMXR FILE                                  *
074500****************************************************************
074600*
074700     MOVE 'FC08'                 TO MBCA-PROGRAM-LOCATION.
074800     SET MBIORO-ENDBR            TO TRUE.
074900     PERFORM MMXRAO-ACCESS       THRU MMXRAO-ACCESS-EXIT.
075000*
075100     IF  WS-BYPASS-YES
075200         GO TO 8999-LS-EXIT.
075300*
075400     MOVE ZEROES                 TO MBCA-MBRS-FWD-STORE
075500                                    WS-FWD-STORE.
075600*
075700 8999-LS-EXIT.
075800     EXIT.
075900*
076000 9000-BACK-SCREEN.
076100*
076200****************************************************************
076300*    START BROWSE THE MMXR FILE                                *
076400****************************************************************
076500*
076600     MOVE 'FC09'                 TO MBCA-PROGRAM-LOCATION.
076700     MOVE MBCA-MBRS-ORG          TO MBIOWS-MMXR-ORG.
076800     MOVE MBCA-MBRS-MERCHANT     TO MBIOWS-MMXR-MERCHANT.
076900     MOVE MBCA-MBRS-FWD-STORE    TO MBIOWS-MMXR-STORE.
077000     SET MBIORO-STARTBR-GTE      TO TRUE.
077100     PERFORM MMXRAO-ACCESS       THRU MMXRAO-ACCESS-EXIT.
077200*
077300****************************************************************
077400*    READNEXT THE MMXR FILE                                    *
077500****************************************************************
077600*
077700     MOVE 'FC10'                 TO MBCA-PROGRAM-LOCATION.
077800     SET MBIORO-READ-SEQ         TO TRUE.
077900     PERFORM MMXRAO-ACCESS       THRU MMXRAO-ACCESS-EXIT.
078000*
078100****************************************************************
078200*    READPREV THE MMXR FILE                                    *
078300****************************************************************
078400*
078500     MOVE 'FC11'                 TO MBCA-PROGRAM-LOCATION.
078600     SET MBIORO-READ-PREV        TO TRUE.
078700     PERFORM MMXRAO-ACCESS       THRU MMXRAO-ACCESS-EXIT.
078800*
078900     SET X-STORE-INDEX           TO +15.
079000     SET WS-BYPASS-NO            TO TRUE.
079100*
079200 9000-READ-MMXR-FILE.
079300*
079400****************************************************************
079500*    READPREV THE MMXR FILE                                    *
079600****************************************************************
079700*
079800     MOVE 'FC12'                 TO MBCA-PROGRAM-LOCATION.
079900     SET MBIORO-READ-PREV        TO TRUE.
080000     PERFORM MMXRAO-ACCESS       THRU MMXRAO-ACCESS-EXIT.
080100*
080200 9000-BUILD-LOOP.
080300*
080400     IF  X-STORE-INDEX IS GREATER THAN +1
080500     AND MMXR-STORE    IS EQUAL TO MBCA-MBRS-FIRST-STORE
080600         SET MBCA-MBRS-RETURN-NORMAL
080700                                 TO TRUE
080800         MOVE MBCA-MBRS-FIRST-STORE
080900                                 TO MBCA-MBRS-FWD-STORE
081000         SET WS-BYPASS-YES       TO TRUE
081100         GO TO 9000-END-BROWSE.
081200*
081300     IF  MMXR-STORE    IS EQUAL TO MBCA-MBRS-BACK-STORE
081400     AND X-STORE-INDEX IS EQUAL TO +15
081500         GO TO 9000-READ-MMXR-FILE.
081600*
081700     PERFORM 9500-BUILD-SCREEN-LINE
081800                                 THRU 9599-BSL-EXIT.
081900*
082000     IF  X-STORE-INDEX IS EQUAL TO +15
082100         MOVE MMXR-STORE         TO MBCA-MBRS-FWD-STORE
082200                                    WS-FWD-STORE.
082300*
082400     IF  X-STORE-INDEX IS GREATER THAN +1
082500         SET X-STORE-INDEX       DOWN BY +1
082600         GO TO 9000-READ-MMXR-FILE
082700     ELSE
082800         MOVE MMXR-STORE         TO MBCA-MBRS-BACK-STORE.
082900*
083000 9000-END-BROWSE.
083100*
083200****************************************************************
083300*    END BROWSE THE MMXR FILE                                  *
083400****************************************************************
083500*
083600     MOVE 'FC13'                 TO MBCA-PROGRAM-LOCATION.
083700     SET MBIORO-ENDBR            TO TRUE.
083800     PERFORM MMXRAO-ACCESS       THRU MMXRAO-ACCESS-EXIT.
083900*
084000 9099-BS-EXIT.
084100     EXIT.
084200*
084300 9100-SET-ATTRIBUTE.
084400*
084500     SET X-MBRSTS-INDEX          TO X-STORE-INDEX.
084600*
084700     IF  MBRSTS-STATUS-INCOMPLETE   (X-MBRSTS-INDEX)
084800     OR  MBRSTS-STATUS-PURGED (X-MBRSTS-INDEX)
084900         MOVE DFHBMASK           TO RS01-SELECT-A
085000                                    (X-STORE-INDEX)
085100         MOVE DFHBMDAS           TO RS01-SELECT-LP-A
085200                                    (X-STORE-INDEX)
085300                                    RS01-SELECT-RP-A
085400                                    (X-STORE-INDEX).
085500*
085600 9199-SA-EXIT.
085700     EXIT.
085800*
085900 9400-READ-AHEAD.
086000*
086100****************************************************************
086200*    READNEXT THE MMXR FILE                                    *
086300****************************************************************
086400*
086500     MOVE 'FC14'                 TO MBCA-PROGRAM-LOCATION.
086600     SET MBIORO-READ-SEQ         TO TRUE.
086700     PERFORM MMXRAO-ACCESS       THRU MMXRAO-ACCESS-EXIT.
086800*
086900     IF  MMXR-ORG-MERCHANT IS GREATER THAN MBCA-MBRS-ORG-MERCHANT
087000         MOVE ZEROES             TO WS-FWD-STORE
087100                                    MBCA-MBRS-FWD-STORE
087200         GO TO 9499-RA-EXIT.
087300*
087400     MOVE MMXR-STORE             TO WS-FWD-STORE.
087500*
087600 9499-RA-EXIT.
087700     EXIT.
087800*
087900 9500-BUILD-SCREEN-LINE.
088000*
088100     SET X-MBRSTS-INDEX          TO X-STORE-INDEX.
088200*
088300     MOVE 'FC15'                 TO MBCA-PROGRAM-LOCATION.
088400     MOVE MMXR-ORG               TO MBIOWS-MMSM-ORG.
088500     MOVE MMXR-STORE             TO MBIOWS-MMSM-STORE.
088600     SET MBIORO-READ-RANDOM      TO TRUE.
088700     PERFORM MMSMAO-ACCESS       THRU MMSMAO-ACCESS-EXIT.
088800*
088900     MOVE MMXR-STORE             TO WS-STORE-NBR
089000                                    MBRSTS-STORE
089100                                    (X-MBRSTS-INDEX).
089200*
089300     MOVE MMSM-NA-LINE (1 1)     TO WS-PRIM-NAME
089400                                    MBRSTS-PRIM-NAME
089500                                    (X-MBRSTS-INDEX).
089600*
089700     MOVE MMSM-PHONE (1)         TO WS-PHONE-NUMBER
089800                                    MBRSTS-PHONE-NUMBER
089900                                    (X-MBRSTS-INDEX).
090000*
090100     MOVE MMSM-REC-STATUS        TO WS-STATUS-CODE
090200                                    MBRSTS-STATUS-CODE
090300                                    (X-MBRSTS-INDEX).
090400*
090500     MOVE MMSM-AUTH-CODE         TO WS-AUTH-CODE
090600                                    MBRSTS-AUTH-CODE
090700                                    (X-MBRSTS-INDEX).
090800*
090900     MOVE WS-DETAIL-LINE         TO RS01-DIRECTORY-LINE
091000                                    (X-STORE-INDEX).
091100*
091200 9599-BSL-EXIT.
091300     EXIT.
091400/         NEW ROUTINE FOR JULIAN TO GREGORIAN CONVERSION
091500     COPY SS26PD.
091600/         ROUTINE TO NUMERICALLY EDIT TIME
091700     COPY SS27PD.
091800/         JULIAN TO GREGORIAN DATE ROUTINE
091900     COPY SS08PD.
092000/         LINE 24 PF KEYS ROUTINE
092100     COPY SS15PD.
092200/         STORE RECORD ACCESS ROUTINES
092300     COPY MMSMAO.
092400/         STORE/MERCHANT XREF RECORD ACCESS ROUTINES
092500     COPY MMXRAO.
092600/         ON-LINE MAP ROUTINES
092700     COPY MB60PD REPLACING 'MBMAPXX' BY 'MBRS01 '
092800                           MBMAPXXI BY MBRS01I
092900                           MBMAPXXO BY MBRS01O.
093000/         ON-LINE PROCEDURES
093100     COPY MB70PD.
093200/
093300     COPY SMFTPXO.
