000100 IDENTIFICATION DIVISION.
000200 PROGRAM-ID. MBOSM00.
000201*       RELEASE DATE=08/24/01.        REVISION LEVEL=08.06      * ++++++++
000202***************************************************************** ++++++++
000203*WARNING.  THIS COMPUTER PROGRAM IS PROTECTED BY COPYRIGHT LAW  * ++++++++
000204*AND INTERNATIONAL TREATIES.  UNAUTHORIZED REPRODUCTION OR      * ++++++++
000205*DISTRIBUTION OF THIS PROGRAM, OR ANY PORTION OF IT, MAY RESULT * ++++++++
000206*IN SEVERE CIVIL AND CRIMINAL PENATLIES, AND WILL BE PROSECUTED * ++++++++
000207*TO THE MAXIMUM EXTENT POSSIBLE UNDER THE LAW.                  * ++++++++
000208*COPYRIGHT 1999 PAYSYS INTERNATIONAL, INC.  ALL RIGHTS RESERVED.* ++++++++
000209***************************************************************** ++++++++
000300*****************************************************************
000400*                                                               *
000500*               M E R C H A N T   S Y S T E M                   *
000600*                                                               *
000700*      MBOSM00 - ON-LINE MERCHANT STATISTICS                    *
000800*                INQUIRY LOCATE SCREEN 00                       *
000900*                                                               *
001000*              1. TRANSIDS                                      *
001100*                 A. MBSM                                       *
001200*              2. MAPS USED -                                   *
001300*                 A. MBSM00 (LOCATE MAP)                        *
001400*              3. FILES USED -                                  *
001500*                 A. MMCG   (MERCH PROD CRED PLAN GROUP STATS)  *
001600*                 B. MMCP   (MERCH PROD CRED PLAN STATISTICS)   *
001700*                 C. MMCS   (STORE PROD CRED PLAN STATS)        *
001800*                 D. MMMM   (MERCHANT MASTER FILE)              *
001900*                 E. MMOC   (ORG CONTROL FILE)                  *
002000*                 F. MMOG   (OUTGOING INTERCHANGE GROUP STATS)  *
002100*                 G. MMOI   (OUTGOING INTERCHANGE STATS)        *
002200*                 H. MMPA   (MERCHANT PROD STATISTICS)          *
002300*                 I. MMPG   (MERCHANT PROD GROUP STATS)         *
002400*                 J. MMPS   (STORE PRODUCT STATISTICS)          *
002500*                 K. MMRC   (MERCHANT RELATIONSHIP/CHAIN FILE)  *
002600*                 L. MMSM   (STORE MASTER FILE)                 *
002700*                 M. MMSR   (STORE RELATIONSHIP/CHAIN FILE)     *
002800*                 N. MMPE   (MERCHANT PROD EXPENSE STATISTICS)  *
002900*                 O. MMPX   (MERCHANT PROD EXPENSE GROUP STATS) *
003000*                 P. MMRG   (STORE PROD GROUP STATS)            *
003100*                 Q. MMLG   (STORE PROD CRED PLAN GROUP STATS)  *
003200*                                                               *
003300*****************************************************************
003400*
003500 ENVIRONMENT DIVISION.
003600 DATA DIVISION.
003700 WORKING-STORAGE SECTION.
003800 01  FILLER                  PIC  X(12)      VALUE '** WS-BEG **'.
003900*         I/O REQUEST BLOCK WORK AREAS
004000     COPY MBIOWS.
004100/         I/O REQUEST BLOCK
004200     COPY MBIORO.
004300/         DATE WORK AREAS
004400     COPY SS01WS.
004500/         ONLINE WORK AREAS
004600     COPY SS08WS.
004700/
004800     COPY SS00WS.
004900/
005000     COPY SMFTWS.
005100/
005200     COPY SMPTRL REPLACING ==:SMPT:== BY ==SMPT==.
005300/
005400     COPY MB61LK.
005500/         STANDARD ERROR MESSAGES
005600     COPY MBEMWS.
005700*
005800 01  WS-MISCELLANEOUS.
005900     03  WS-RESET-STAT-SW    PIC  X(01)      VALUE 'N'.
006000         88  WS-RESET-STAT-NO                VALUE 'N'.
006100         88  WS-RESET-STAT-YES               VALUE 'Y'.
006200     03  WS-SAVE-STATS-ONE   PIC  9(01)      VALUE ZEROES.
006300         88  WS-SAVE-STATS-ONE-ZERO          VALUE ZEROES.
006400         88  WS-SAVE-STATS-ONE-ONE           VALUE 1.
006500     03  WS-SAVE-STATS-TWO   PIC  9(01)      VALUE ZEROES.
006600         88  WS-SAVE-STATS-TWO-ZERO          VALUE ZEROES.
006700         88  WS-SAVE-STATS-TWO-TWO           VALUE 2.
006800     03  WS-GOT-MER-CHAIN-OR-STORE
006900                             PIC  X(01)      VALUE 'N'.
007000         88  WS-GOT-NOTHING                  VALUE 'N'.
007100         88  WS-GOT-MERCHANT-RECORD          VALUE 'M'.
007200         88  WS-GOT-STORE-RECORD             VALUE 'S'.
007300         88  WS-GOT-CHAIN-RECORD             VALUE 'C'.
007400         88  WS-GOT-S-CHAIN-RECORD           VALUE 'Z'.
007500     03  WS-ONE              PIC  9(01)      VALUE 1.
007600     03  WS-TWO              PIC  9(01)      VALUE 2.
007700     03  WS-ZEROES           PIC S9(04)      VALUE +0  BINARY.
007800     03  WS-NINETEEN         PIC S9(04)      VALUE +19 BINARY.
007900     03  WS-TRAN-COUNT       PIC S9(03)      VALUE +0.
008000*
008100     03  WS-MON-NAME-TABLE.
008200         05  FILLER          PIC X(09)       VALUE 'JANUARY  '.
008300         05  FILLER          PIC X(09)       VALUE 'FEBRUARY '.
008400         05  FILLER          PIC X(09)       VALUE 'MARCH    '.
008500         05  FILLER          PIC X(09)       VALUE 'APRIL    '.
008600         05  FILLER          PIC X(09)       VALUE 'MAY      '.
008700         05  FILLER          PIC X(09)       VALUE 'JUNE     '.
008800         05  FILLER          PIC X(09)       VALUE 'JULY     '.
008900         05  FILLER          PIC X(09)       VALUE 'AUGUST   '.
009000         05  FILLER          PIC X(09)       VALUE 'SEPTEMBER'.
009100         05  FILLER          PIC X(09)       VALUE 'OCTOBER  '.
009200         05  FILLER          PIC X(09)       VALUE 'NOVEMBER '.
009300         05  FILLER          PIC X(09)       VALUE 'DECEMBER '.
009400         05  FILLER          PIC X(09)       VALUE 'CUR      '.
009500         05  FILLER          PIC X(09)       VALUE 'MTD      '.
009600         05  FILLER          PIC X(09)       VALUE 'YTD      '.
009700         05  FILLER          PIC X(09)       VALUE 'CTD      '.
009800         05  FILLER          PIC X(09)       VALUE 'DTD      '.
009900         05  FILLER          PIC X(09)       VALUE 'PTD      '.
010000     03  WS-MON-NAME-TABLE-R REDEFINES WS-MON-NAME-TABLE.
010100         05  WS-MON-NAME-DES                 OCCURS 18 TIMES
010200                                             INDEXED BY
010300                                             X-WS-MON-NAME.
010400             07  WS-MON-NAME-OID
010500                             PIC X(03).
010600             07  FILLER
010700                             PIC X(06).
010800*
010900 01  FILLER                  PIC  X(12)      VALUE '** WS-END **'.
011000/
011100 LINKAGE SECTION.
011200 01  DFHCOMMAREA.
011300     COPY MB60WS.
011400/         MERCHANT STATISTICS SCREEN 00 MAP DSECT
011500     COPY MBSM00.
011600/         MERCHANT STATISTICS SCREEN 00 MAP REDEFINITION
011700     COPY MBSM00R.
011800/         MERCHANT PRODUCT CREDIT PLAN GROUP STATS RECORD LAYOUT
011900     COPY MMPARL REPLACING ==:MMPA:== BY ==MMCG==.
012000/         MERCHANT PRODUCT CREDIT PLAN STATISTICS RECORD LAYOUT
012100     COPY MMPARL REPLACING ==:MMPA:== BY ==MMCP==.
012200/         STORE PRODUCT CREDIT PLAN STATISTICS RECORD LAYOUT
012300     COPY MMPARL REPLACING ==:MMPA:== BY ==MMCS==.
012400/         STORE PRODUCT CREDIT PLAN GROUP STATS RECORD LAYOUT
012500     COPY MMPARL REPLACING ==:MMPA:== BY ==MMLG==.
012600/         MERCHANT MASTER RECORD LAYOUT
012700     COPY MMMMRL.
012800/         ORGANIZATION CONTROL RECORD LAYOUT
012900     COPY MMOCRL.
013000/         OUTGOING INTERCHANGE GROUP STATISTICS RECORD LAYOUT
013100     COPY MMPARL REPLACING ==:MMPA:== BY ==MMOG==.
013200/         OUTGOING INTERCHANGE STATISTICS RECORD LAYOUT
013300     COPY MMPARL REPLACING ==:MMPA:== BY ==MMOI==.
013400/         MERCHANT PRODUCT STATISTICS RECORD LAYOUT
013500     COPY MMPARL REPLACING ==:MMPA:== BY ==MMPA==.
013600/         MERCHANT PRODUCT EXPENSE STATISTICS RECORD LAYOUT
013700     COPY MMPARL REPLACING ==:MMPA:== BY ==MMPE==.
013800/         MERCHANT PRODUCT GROUP STATISTICS RECORD LAYOUT
013900     COPY MMPARL REPLACING ==:MMPA:== BY ==MMPG==.
014000/         STORE PRODUCT STATISTICS RECORD LAYOUT
014100     COPY MMPARL REPLACING ==:MMPA:== BY ==MMPS==.
014200/         MERCHANT PRODUCT EXPENSE GROUP STATISTICS RECORD LAYOUT
014300     COPY MMPARL REPLACING ==:MMPA:== BY ==MMPX==.
014400/         MERCHANT RELATIONSHIP MASTER RECORD LAYOUT
014500     COPY MMRCRL.
014600/         STORE PRODUCT GROUP STATISTICS RECORD LAYOUT
014700     COPY MMPARL REPLACING ==:MMPA:== BY ==MMRG==.
014800/         STORE MASTER RECORD LAYOUT
014900     COPY MMSMRL.
015000/         STORE RELATIONSHIP MASTER RECORD LAYOUT
015100     COPY MMSRRL.
015200/
015300 PROCEDURE DIVISION.
015400 0000-HOUSEKEEPING SECTION.
015500 0100-INIT.
015600*
015700     MOVE 'PC01'                 TO MBCA-PROGRAM-LOCATION.
015800     PERFORM MB70PD-ON-LINE-HOUSEKEEPING
015900                                 THRU MB70PD-OLH-EXIT.
016000*
016100     IF  MBCA-RECEIVE-SCREEN
016200         GO TO 2000-RECEIVE-SCREEN.
016300*
016400 1000-SEND-SCREEN SECTION.
016500*
016600****************************************************************
016700*    GET CICS STORAGE NEEDED FOR THE MAP                       *
016800****************************************************************
016900*
017000     MOVE 'SC01'                 TO MBCA-PROGRAM-LOCATION.
017100     PERFORM MB60PD-GETMAIN-FOR-MAP
017200                                 THRU MB60PD-GFM-EXIT.
017300*
017400*****************************************************************
017500*    CHECK KEY CODES                                            *
017600* 1. IF WE DON'T HAVE A VALID KEY TYPE (AS INDICATED BY         *
017700*    VALID-CM-FLAG AND VALID-SUB-FLAG), TRANSFER TO SS LOCATE   *
017800*    SO USER CAN ENTER KEY SELECTION INFORMATION.               *
017900*****************************************************************
018000*
018100     IF  NOT MBCA-MBSM-VALID-CM-FLAG
018200     OR  NOT MBCA-MBSM-VALID-SUB-FLAG
018300         MOVE '..SS'             TO SS08WS-WORK-TRANS-ID
018400         SET MBCA-INITIAL-SCREEN-NBR
018500                                 TO TRUE
018600         GO TO MB70PD-XCTL-TO-MBOXCTL.
018700*
018800 1100-BUILD-SCREEN.
018900*
019000****************************************************************
019100*    INITIALIZE THE STANDARD MAP LINES                         *
019200****************************************************************
019300*
019400     MOVE SS08WS-CURSOR          TO SM00-ORG-L.
019500     MOVE 00                     TO MBCA-SCREEN-NBR.
019600     MOVE +0                     TO MBCA-MBSM-TOTAL-INDEX.
019700     PERFORM MB60PD-INIT-STD-MAP-LINES
019800                                 THRU MB60PD-ISML-EXIT.
019900*
020000     PERFORM 8200-DARK-UNUSED-FIELDS
020100                                 THRU 8299-DUF-EXIT.
020200*
020300     IF  MBCA-VALID-KEY-CODES
020400     AND MBCA-MERCHANT-ORG IS GREATER THAN ZERO
020500         PERFORM 8100-READ-MER-CHAIN-OR-STORE
020600                                 THRU 8199-RMCOS-EXIT
020700         MOVE MBCA-MERCHANT-ORG  TO SM00-ORG
020800         MOVE DFHBMUNF           TO SM00-ORG-A
020900         EVALUATE TRUE
021000             WHEN MBCA-MBSM-VALID-CHAIN
021100                 MOVE MBCA-CHAIN TO SM00-CHAIN-MERCH
021200                 MOVE DFHBMUNF   TO SM00-CHAIN-MERCH-A
021300             WHEN MBCA-MBSM-VALID-MERCHANT
021400                 MOVE MBCA-MERCHANT
021500                                 TO SM00-CHAIN-MERCH
021600                 MOVE DFHBMUNF   TO SM00-CHAIN-MERCH-A
021700             WHEN MBCA-MBSM-VALID-STORE
021800                 MOVE MBCA-STORE TO SM00-CHAIN-MERCH
021900                 MOVE DFHBMUNF   TO SM00-CHAIN-MERCH-A
022000             WHEN MBCA-MBSM-VALID-S-CHAIN
022100                 MOVE MBCA-S-CHAIN
022200                                 TO SM00-CHAIN-MERCH
022300                 MOVE DFHBMUNF   TO SM00-CHAIN-MERCH-A
022400         END-EVALUATE
022500         EVALUATE TRUE
022600             WHEN MBCA-MBSM-VALID-PRODUCT
022700                 MOVE MBCA-CARD-PROD
022800                                 TO SM00-PROD
022900                 MOVE DFHBMUNF   TO SM00-PROD-A
023000             WHEN MBCA-MBSM-VALID-CRED-PLAN
023100                 MOVE MBCA-CARD-PROD
023200                                 TO SM00-PROD
023300                 MOVE DFHBMUNF   TO SM00-PROD-A
023400                 MOVE MBCA-PLAN  TO SM00-PLAN
023500                 MOVE DFHBMUNF   TO SM00-PLAN-A
023600             WHEN MBCA-MBSM-VALID-QUAL-LVL
023700                 MOVE MBCA-CARD-PROD
023800                                 TO SM00-PROD
023900                 MOVE DFHBMUNF   TO SM00-PROD-A
024000                 MOVE MBCA-QUAL-LEVEL
024100                                 TO SM00-QLVL
024200                 MOVE DFHBMUNF   TO SM00-QLVL-A
024300         END-EVALUATE
024400     END-IF.
024500*
024600     PERFORM 9400-STATS-DEFAULTS THRU 9499-SD-EXIT
024700         VARYING X-STATS-INDEX FROM +1 BY +1
024800         UNTIL   X-STATS-INDEX IS GREATER THAN +18.
024900*
025000     IF  SM00-ORG IS NUMERIC
025100         IF  SM00-ORG IS LESS THAN MBCA-ORG-LOW
025200         OR  SM00-ORG IS GREATER THAN MBCA-ORG-HIGH
025300             NEXT SENTENCE
025400         ELSE
025500             MOVE 'FC01'         TO MBCA-PROGRAM-LOCATION
025600             MOVE SM00-ORG       TO MBIOWS-MMOC-ORG
025700             MOVE SS08WS-CICS-FC-NOTFND
025800                                 TO MBIORO-TEMP-STATUS-1
025900             SET MBIORO-READ-RANDOM
026000                                 TO TRUE
026100             PERFORM MMOCAO-ACCESS
026200                                 THRU MMOCAO-ACCESS-EXIT
026300             IF  SS08WS-RC-FC-NOTFND
026400             OR  MMOC-ADD-PENDING
026500             OR  MMOC-REC-INCOMPLETE
026600             OR  MMOC-REC-PURGED
026700                 NEXT SENTENCE
026800             ELSE
026900                 MOVE MMOC-ORG   TO MBCA-MBSM-ORG
027000                                    MBCA-ORG
027100                                    MBCA-MERCHANT-ORG
027200                 MOVE MMOC-CURRENCY-CODE
027300                                 TO MBCA-CURRENCY-CODE
027400                 MOVE MMOC-CURRENCY-NOD
027500                                 TO  MBCA-CURRENCY-NOD
027600                 MOVE MMOC-PERCENT-NOD
027700                                 TO  MBCA-PERCENT-NOD             FX800007
027800                 MOVE MMOC-PER-ITEM-NOD
027900                                 TO  MBCA-PER-ITEM-NOD            FX800007
028000                 PERFORM 9500-STATS-DEFAULTS
028100                                 THRU 9599-SD-EXIT
028200     ELSE
028300         SET SM00-VALID-STATS-POS1 (1)
028400                                 TO TRUE.
028500*
028600 1200-SEND-MAP.
028700*
028800****************************************************************
028900*    SEND THE MAP                                              *
029000****************************************************************
029100*
029200     MOVE 'BM01'                 TO MBCA-PROGRAM-LOCATION.
029300     PERFORM MB60PD-SEND-MAP-WITH-ERASE
029400                                 THRU MB60PD-SMWE-EXIT.
029500*
029600****************************************************************
029700*    RETURN TO CICS                                            *
029800****************************************************************
029900*
030000     MOVE 'PC02'                 TO MBCA-PROGRAM-LOCATION.
030100     PERFORM MB70PD-RETURN-TRANS-ID
030200                                 THRU MB70PD-RTI-EXIT.
030300/
030400 2000-RECEIVE-SCREEN SECTION.
030500*
030600****************************************************************
030700*    THIS SECTION RECEIVES THE LOCATE SCREEN                   *
030800****************************************************************
030900*
031000     MOVE 'BM02'                 TO MBCA-PROGRAM-LOCATION.
031100     PERFORM MB60PD-RECEIVE-MAP  THRU MB60PD-RM-EXIT.
031200*
031300****************************************************************
031400*    CHECK FOR ANOTHER TRANSACTION ID ENTERED BY THE USER      *
031500****************************************************************
031600*
031700     MOVE 'PC03'                 TO MBCA-PROGRAM-LOCATION.
031800     PERFORM MB60PD-NEW-TRANS-ROUTINE
031900                                 THRU MB60PD-NTR-EXIT.
032000*
032100 2100-EDIT-SCREEN.
032200*
032300     SET SS08WS-ERROR-SW-NO      TO TRUE.
032400     MOVE MBCA-EIBAID            TO SS08WS-EIBAID.
032500*
032600     IF  (SM00-ORG-L IS LESS THAN 1
032700     AND  SM00-CHAIN-MERCH-L IS LESS THAN 1
032800     AND  SM00-PROD-L IS LESS THAN 1
032900     AND  SM00-PLAN-L IS LESS THAN 1
033000     AND  SM00-QLVL-L IS LESS THAN 1)
033100     AND (SS08WS-VALID-PF-KEY
033200     OR   SS08WS-EIBAID-VALID-PF-KEY)
033300         SET MBCA-INITIAL-SCREEN-NBR
033400                                 TO TRUE
033500         GO TO 2690-TRANSFER-XCTL.
033600*
033700 2110-EDIT-ORG.
033800*
033900     MOVE DFHBMUNF               TO SM00-ORG-A.
034000     MOVE DFHBMASK               TO SM00-ORG-LP-A
034100                                    SM00-ORG-RP-A.
034200*
034300     IF  SM00-ORG-L IS EQUAL TO ZERO
034400     OR  SM00-ORG IS NOT NUMERIC
034500     OR  SM00-ORG IS LESS THAN MBCA-ORG-LOW
034600     OR  SM00-ORG IS GREATER THAN MBCA-ORG-HIGH
034700         MOVE MBEMWS-INVALID-ORG TO SM00-ERR-MESSAGE
034800         GO TO 2130-ORG-ERROR.
034900*
035000 2120-READ-ORG.
035100*
035200****************************************************************
035300*    READ THE ORGANIZATION FILE RECORD                         *
035400****************************************************************
035500*
035600     MOVE 'FC02'                 TO MBCA-PROGRAM-LOCATION.
035700     MOVE SM00-ORG               TO MBIOWS-MMOC-ORG.
035800     MOVE SS08WS-CICS-FC-NOTFND  TO MBIORO-TEMP-STATUS-1.
035900     SET MBIORO-READ-RANDOM      TO TRUE.
036000     PERFORM MMOCAO-ACCESS       THRU MMOCAO-ACCESS-EXIT.
036100*
036200     IF  SS08WS-RC-FC-VALID-RTN-CODE
036300         MOVE SM00-ORG           TO MBCA-ORG
036400                                    MBCA-MERCHANT-ORG
036500                                    MBCA-MBSM-ORG
036600         MOVE MMOC-CURRENCY-CODE TO MBCA-CURRENCY-CODE
036700         MOVE MMOC-CURRENCY-NOD  TO  MBCA-CURRENCY-NOD
036800         MOVE MMOC-PERCENT-NOD   TO  MBCA-PERCENT-NOD             FX800007
036900         MOVE MMOC-PER-ITEM-NOD  TO  MBCA-PER-ITEM-NOD            FX800007
037000         IF  MMOC-ADD-PENDING
037100             MOVE MBEMWS-ADD-PENDING
037200                                 TO SM00-ERR-MESSAGE
037300         ELSE
037400             IF  MMOC-REC-INCOMPLETE
037500             OR  MMOC-REC-PURGED
037600                 MOVE MBEMWS-NOT-ACTIVE
037700                                 TO SM00-ERR-MESSAGE
037800             ELSE
037900                 EVALUATE TRUE
038000                   WHEN (MBCA-MBSM-VALID-MERCHANT
038100                    AND  MBCA-MBSM-VALID-CRED-PLAN
038200                    AND  MMOC-CP-MERCH-NO)
038300                    MOVE '*PLAN STATISTICS ARE NOT BEING BUILT*'
038400                                 TO SM00-ERR-MESSAGE
038500                   WHEN (MBCA-MBSM-VALID-STORE
038600                    AND  MBCA-MBSM-VALID-CRED-PLAN
038700                    AND  MMOC-CP-STORE-NO)
038800                    MOVE '*PLAN STATISTICS ARE NOT BEING BUILT*'
038900                                 TO SM00-ERR-MESSAGE
039000                   WHEN (MBCA-MBSM-VALID-CHAIN
039100                    AND  MBCA-MBSM-VALID-CRED-PLAN
039200                    AND  MMOC-CP-CHAIN-NO)
039300                    MOVE '*CHAIN STATISTICS ARE NOT BEING BUILT*'
039400                                 TO SM00-ERR-MESSAGE
039500                   WHEN (MBCA-MBSM-VALID-S-CHAIN
039600                    AND  MBCA-MBSM-VALID-CRED-PLAN
039700                    AND  MMOC-CP-STORE-CHAIN-NO)
039800                    MOVE '*CHAIN STATISTICS ARE NOT BEING BUILT*'
039900                                 TO SM00-ERR-MESSAGE
040000                   WHEN OTHER
040100                     GO TO 2140-EDIT-MERCHANT
040200                 END-EVALUATE
040300     ELSE
040400         MOVE MBEMWS-NOT-ON-FILE TO SM00-ERR-MESSAGE.
040500*
040600 2130-ORG-ERROR.
040700*
040800     MOVE DFHBMNBF               TO SM00-ORG-A.
040900     MOVE DFHBMASB               TO SM00-ORG-LP-A
041000                                    SM00-ORG-RP-A.
041100     MOVE SS08WS-CURSOR          TO SM00-ORG-L.
041200     SET SS08WS-ERROR-SW-YES     TO TRUE.
041300*
041400 2140-EDIT-MERCHANT.
041500*
041600     MOVE DFHBMUNF               TO SM00-CHAIN-MERCH-A.
041700     MOVE DFHBMASK               TO SM00-CHAIN-MERCH-LP-A
041800                                    SM00-CHAIN-MERCH-RP-A.
041900*
042000     IF  MBCA-MBSM-VALID-MERCHANT
042100         IF  SM00-CHAIN-MERCH-L IS EQUAL TO ZERO
042200         OR  SM00-CHAIN-MERCH IS NOT NUMERIC
042300             MOVE MBEMWS-INVALID-MERCHANT
042400                                 TO SM00-ERR-MESSAGE
042500             MOVE SS08WS-CURSOR  TO SM00-CHAIN-MERCH-L
042600             GO TO 2150-MERCHANT-ERROR.
042700*
042800     IF  MBCA-MBSM-VALID-CHAIN
042900         IF  SM00-CHAIN-MERCH-L IS EQUAL TO ZERO
043000         OR  SM00-CHAIN-MERCH IS NOT NUMERIC
043100             MOVE MBEMWS-INVALID-CHAIN
043200                                 TO SM00-ERR-MESSAGE
043300             MOVE SS08WS-CURSOR  TO SM00-CHAIN-MERCH-L
043400             GO TO 2150-MERCHANT-ERROR.
043500*
043600     IF  MBCA-MBSM-VALID-STORE
043700         IF  SM00-CHAIN-MERCH-L IS EQUAL TO ZERO
043800         OR  SM00-CHAIN-MERCH IS NOT NUMERIC
043900             MOVE MBEMWS-INVALID-STORE
044000                                 TO SM00-ERR-MESSAGE
044100             MOVE SS08WS-CURSOR  TO SM00-CHAIN-MERCH-L
044200             GO TO 2150-MERCHANT-ERROR.
044300*
044400     IF  MBCA-MBSM-VALID-S-CHAIN
044500         IF  SM00-CHAIN-MERCH-L IS EQUAL TO ZERO
044600         OR  SM00-CHAIN-MERCH IS NOT NUMERIC
044700             MOVE MBEMWS-INVALID-CHAIN
044800                                 TO SM00-ERR-MESSAGE
044900             MOVE SS08WS-CURSOR  TO SM00-CHAIN-MERCH-L
045000             GO TO 2150-MERCHANT-ERROR.
045100*
045200     IF  SM00-CHAIN-MERCH-L IS EQUAL TO ZERO
045300     OR  SM00-CHAIN-MERCH IS NOT NUMERIC
045400         MOVE MBEMWS-INVALID-CHAIN
045500                                 TO SM00-ERR-MESSAGE
045600         MOVE DFHBMNBF           TO SM00-CHAIN-MERCH-A
045700         MOVE DFHBMASB           TO SM00-CHAIN-MERCH-LP-A
045800                                    SM00-CHAIN-MERCH-RP-A
045900         MOVE SS08WS-CURSOR      TO SM00-CHAIN-MERCH-L
046000         SET SS08WS-ERROR-SW-YES TO TRUE.
046100*
046200 2145-MERCHANT-READ.
046300*
046400****************************************************************
046500*    READ THE MERCHANT RECORD                                  *
046600****************************************************************
046700*
046800     IF  SS08WS-ERROR-SW-YES
046900         GO TO 2160-EDIT-CARD-PROD
047000     END-IF.
047100*
047200     EVALUATE TRUE
047300         WHEN MBCA-MBSM-VALID-MERCHANT
047400             CONTINUE
047500         WHEN MBCA-MBSM-VALID-CHAIN
047600             GO TO 2147-CHAIN-READ
047700         WHEN MBCA-MBSM-VALID-STORE
047800             GO TO 2148-STORE-READ
047900         WHEN MBCA-MBSM-VALID-S-CHAIN
048000             GO TO 2149-S-CHAIN-READ
048100     END-EVALUATE.
048200*
048300     MOVE 'FC03'                 TO MBCA-PROGRAM-LOCATION.
048400     MOVE SM00-ORG               TO MBIOWS-MMMM-ORG.
048500     MOVE SM00-CHAIN-MERCH       TO MBIOWS-MMMM-MERCHANT.
048600     MOVE SS08WS-CICS-FC-NOTFND  TO MBIORO-TEMP-STATUS-1.
048700     SET MBIORO-READ-RANDOM      TO TRUE.
048800     PERFORM MMMMAO-ACCESS       THRU MMMMAO-ACCESS-EXIT.
048900*
049000     IF  SS08WS-RC-FC-NOTFND
049100         MOVE MBEMWS-NOT-ON-FILE TO SM00-ERR-MESSAGE
049200     ELSE
049300         IF  MMMM-ADD-PENDING
049400             MOVE MBEMWS-ADD-PENDING
049500                                 TO SM00-ERR-MESSAGE
049600         ELSE
049700             IF  MMMM-REC-INCOMPLETE
049800             OR  MMMM-REC-PURGED
049900                 MOVE MBEMWS-NOT-ACTIVE
050000                                 TO SM00-ERR-MESSAGE
050100             ELSE
050200                 MOVE SM00-CHAIN-MERCH
050300                                 TO MBCA-MERCHANT
050400                                    MBCA-MBSM-CHAIN-MERCH
050500                 MOVE MMMM-STATS-CONTROL-AREA
050600                                 TO MBCA-MBSM-STATS-CONTROL-AREA
050700                 GO TO 2160-EDIT-CARD-PROD.
050800*
050900     GO TO 2150-MERCHANT-ERROR.
051000*
051100 2147-CHAIN-READ.
051200*
051300****************************************************************
051400*    READ THE MERCHANT CHAIN RELATIONSHIP FILE
051500****************************************************************
051600*
051700     MOVE 'FC04'                 TO MBCA-PROGRAM-LOCATION.
051800     MOVE SM00-ORG               TO MBIOWS-MMRC-ORG.
051900     MOVE SM00-CHAIN-MERCH       TO MBIOWS-MMRC-CHAIN.
052000     MOVE SS08WS-CICS-FC-NOTFND  TO MBIORO-TEMP-STATUS-1.
052100     SET MBIORO-READ-RANDOM      TO TRUE.
052200     PERFORM MMRCAO-ACCESS       THRU MMRCAO-ACCESS-EXIT.
052300*
052400     IF  SS08WS-RC-FC-NOTFND
052500         MOVE MBEMWS-NOT-ON-FILE TO SM00-ERR-MESSAGE
052600     ELSE
052700         IF  MMRC-ADD-PENDING
052800             MOVE MBEMWS-ADD-PENDING
052900                                 TO SM00-ERR-MESSAGE
053000         ELSE
053100             IF  MMRC-REC-INCOMPLETE
053200             OR  MMRC-REC-PURGED
053300                 MOVE MBEMWS-NOT-ACTIVE
053400                                 TO SM00-ERR-MESSAGE
053500             ELSE
053600                 MOVE SM00-CHAIN-MERCH
053700                                 TO MBCA-CHAIN
053800                                    MBCA-MBSM-CHAIN-MERCH
053900                 MOVE MMRC-STATS-CONTROL-AREA
054000                                 TO MBCA-MBSM-STATS-CONTROL-AREA
054100                 GO TO 2160-EDIT-CARD-PROD.
054200*
054300     GO TO 2150-MERCHANT-ERROR.
054400*
054500 2148-STORE-READ.
054600*
054700****************************************************************
054800*    READ THE STORE MASTER FILE
054900****************************************************************
055000*
055100     MOVE 'FC05'                 TO MBCA-PROGRAM-LOCATION.
055200     MOVE SM00-ORG               TO MBIOWS-MMSM-ORG.
055300     MOVE SM00-CHAIN-MERCH       TO MBIOWS-MMSM-STORE.
055400     MOVE SS08WS-CICS-FC-NOTFND  TO MBIORO-TEMP-STATUS-1.
055500     SET MBIORO-READ-RANDOM      TO TRUE.
055600     PERFORM MMSMAO-ACCESS       THRU MMSMAO-ACCESS-EXIT.
055700*
055800     IF  SS08WS-RC-FC-NOTFND
055900         MOVE MBEMWS-NOT-ON-FILE TO SM00-ERR-MESSAGE
056000     ELSE
056100         IF  MMSM-ADD-PENDING
056200             MOVE MBEMWS-ADD-PENDING
056300                                 TO SM00-ERR-MESSAGE
056400         ELSE
056500             IF  MMSM-REC-INCOMPLETE
056600             OR  MMSM-REC-PURGED
056700                 MOVE MBEMWS-NOT-ACTIVE
056800                                 TO SM00-ERR-MESSAGE
056900             ELSE
057000                 MOVE SM00-CHAIN-MERCH
057100                                 TO MBCA-STORE
057200                                    MBCA-MBSM-CHAIN-MERCH
057300                 MOVE MMSM-STATS-CONTROL-AREA
057400                                 TO MBCA-MBSM-STATS-CONTROL-AREA
057500                 GO TO 2160-EDIT-CARD-PROD
057600             END-IF
057700         END-IF
057800     END-IF.
057900*
058000     GO TO 2150-MERCHANT-ERROR.
058100*
058200 2149-S-CHAIN-READ.
058300*
058400****************************************************************
058500*    READ THE STORE CHAIN RELATIONSHIP FILE
058600****************************************************************
058700*
058800     MOVE 'FC06'                 TO MBCA-PROGRAM-LOCATION.
058900     MOVE SM00-ORG               TO MBIOWS-MMSR-ORG.
059000     MOVE SM00-CHAIN-MERCH       TO MBIOWS-MMSR-CHAIN.
059100     MOVE SS08WS-CICS-FC-NOTFND  TO MBIORO-TEMP-STATUS-1.
059200     SET MBIORO-READ-RANDOM      TO TRUE.
059300     PERFORM MMSRAO-ACCESS       THRU MMSRAO-ACCESS-EXIT.
059400*
059500     IF  SS08WS-RC-FC-NOTFND
059600         MOVE MBEMWS-NOT-ON-FILE TO SM00-ERR-MESSAGE
059700     ELSE
059800         IF  MMSR-ADD-PENDING
059900             MOVE MBEMWS-ADD-PENDING
060000                                 TO SM00-ERR-MESSAGE
060100         ELSE
060200             IF  MMSR-REC-INCOMPLETE
060300             OR  MMSR-REC-PURGED
060400                 MOVE MBEMWS-NOT-ACTIVE
060500                                 TO SM00-ERR-MESSAGE
060600             ELSE
060700                 MOVE SM00-CHAIN-MERCH
060800                                 TO MBCA-S-CHAIN
060900                                    MBCA-MBSM-CHAIN-MERCH
061000                 MOVE MMSR-STATS-CONTROL-AREA
061100                                 TO MBCA-MBSM-STATS-CONTROL-AREA
061200                 GO TO 2160-EDIT-CARD-PROD.
061300*
061400 2150-MERCHANT-ERROR.
061500*
061600     MOVE DFHBMNBF               TO SM00-CHAIN-MERCH-A.
061700     MOVE DFHBMASB               TO SM00-CHAIN-MERCH-LP-A
061800                                    SM00-CHAIN-MERCH-RP-A.
061900     SET SS08WS-ERROR-SW-YES     TO TRUE.
062000     MOVE SS08WS-CURSOR          TO SM00-CHAIN-MERCH-L.
062100*
062200 2160-EDIT-CARD-PROD.
062300*
062400     IF  MBCA-MBSM-VALID-TOTALS
062500         MOVE ZEROES             TO SM00-PROD
062600                                    MBCA-CARD-PROD
062700                                    MBCA-MBSM-CARD-PROD
062800         GO TO 2165-CARD-PROD-READ.
062900*
063000     MOVE DFHBMUNF               TO SM00-PROD-A.
063100     MOVE DFHBMASK               TO SM00-PROD-LP-A
063200                                    SM00-PROD-RP-A.
063300     IF  MBCA-MBSM-VALID-CRED-PLAN
063400     AND SM00-PROD-L IS GREATER THAN ZERO
063500     AND SM00-PROD IS NUMERIC
063600         GO TO 2163-CONTINUE
063700     ELSE
063800         IF  MBCA-MBSM-VALID-CRED-PLAN
063900             MOVE MBEMWS-INVALID-PROD
064000                                 TO SM00-ERR-MESSAGE
064100             GO TO 2170-PROD-ERROR.
064200*
064300     IF  SM00-PROD-L IS GREATER THAN ZERO
064400     AND SM00-PROD IS NUMERIC
064500     AND SM00-PROD-VALID
064600         NEXT SENTENCE
064700     ELSE
064800         MOVE MBEMWS-INVALID-PROD
064900                                 TO SM00-ERR-MESSAGE
065000         GO TO 2170-PROD-ERROR.
065100*
065200 2163-CONTINUE.
065300*
065400     MOVE SM00-PROD              TO MBCA-CARD-PROD
065500                                    MBCA-MBSM-CARD-PROD.
065600*
065700 2165-CARD-PROD-READ.
065800*
065900****************************************************************
066000*    READ THE APPROPRIATE STATS FILE                           *
066100****************************************************************
066200*
066300     IF  SS08WS-ERROR-SW-YES
066400         GO TO 2190-EDIT-PLAN
066500     END-IF.
066600*
066700     MOVE 'FC07'                 TO MBCA-PROGRAM-LOCATION.
066800     SET MBIORO-STARTBR-GTE      TO TRUE.
066900*
067000     EVALUATE TRUE
067100         WHEN MBCA-MBSM-VALID-MERCHANT
067200           EVALUATE TRUE
067300             WHEN MBCA-MBSM-EXPENSE-SPACE
067400               MOVE SM00-ORG     TO MBIOWS-MMPA-ORG
067500               MOVE SM00-CHAIN-MERCH
067600                                 TO MBIOWS-MMPA-ACCT
067700               EVALUATE TRUE
067800                   WHEN MBCA-MBSM-VALID-TOTALS
067900                       SET MBIOWS-MMPA-TOTALS
068000                                 TO TRUE
068100                   WHEN OTHER
068200                       SET MBIOWS-MMPA-DETAIL
068300                                 TO TRUE
068400               END-EVALUATE
068500               MOVE ZERO         TO MBIOWS-MMPA-MINOR-KEY
068600               MOVE SM00-PROD    TO MBIOWS-MMPA-PRODUCT
068700               MOVE ZERO         TO MBIOWS-MMPA-LOGIC-MODULE
068800               PERFORM MMPAAO-ACCESS
068900                                 THRU MMPAAO-ACCESS-EXIT
069000             WHEN MBCA-MBSM-EXPENSE-VALID
069100               MOVE SM00-ORG     TO MBIOWS-MMPE-ORG
069200               MOVE SM00-CHAIN-MERCH
069300                                 TO MBIOWS-MMPE-ACCT
069400               EVALUATE TRUE
069500                   WHEN MBCA-MBSM-VALID-TOTALS
069600                       SET MBIOWS-MMPE-TOTALS
069700                                 TO TRUE
069800                   WHEN OTHER
069900                       SET MBIOWS-MMPE-DETAIL
070000                                 TO TRUE
070100               END-EVALUATE
070200               MOVE ZERO         TO MBIOWS-MMPE-MINOR-KEY
070300               MOVE SM00-PROD    TO MBIOWS-MMPE-PRODUCT
070400               MOVE ZERO         TO MBIOWS-MMPE-LOGIC-MODULE
070500               PERFORM MMPEAO-ACCESS
070600                                 THRU MMPEAO-ACCESS-EXIT
070700           END-EVALUATE
070800         WHEN MBCA-MBSM-VALID-CHAIN
070900           EVALUATE TRUE
071000             WHEN MBCA-MBSM-EXPENSE-SPACE
071100               MOVE SM00-ORG     TO MBIOWS-MMPG-ORG
071200               MOVE SM00-CHAIN-MERCH
071300                                 TO MBIOWS-MMPG-ACCT
071400               EVALUATE TRUE
071500                   WHEN MBCA-MBSM-VALID-TOTALS
071600                       SET MBIOWS-MMPG-TOTALS
071700                                 TO TRUE
071800                   WHEN OTHER
071900                       SET MBIOWS-MMPG-DETAIL
072000                                 TO TRUE
072100               END-EVALUATE
072200               MOVE ZERO         TO MBIOWS-MMPG-MINOR-KEY
072300               MOVE SM00-PROD    TO MBIOWS-MMPG-PRODUCT
072400               MOVE ZERO         TO MBIOWS-MMPG-LOGIC-MODULE
072500               PERFORM MMPGAO-ACCESS
072600                                 THRU MMPGAO-ACCESS-EXIT
072700             WHEN MBCA-MBSM-EXPENSE-VALID
072800               MOVE SM00-ORG     TO MBIOWS-MMPX-ORG
072900               MOVE SM00-CHAIN-MERCH
073000                                 TO MBIOWS-MMPX-ACCT
073100               EVALUATE TRUE
073200                   WHEN MBCA-MBSM-VALID-TOTALS
073300                       SET MBIOWS-MMPX-TOTALS
073400                                 TO TRUE
073500                   WHEN OTHER
073600                       SET MBIOWS-MMPX-DETAIL
073700                                 TO TRUE
073800               END-EVALUATE
073900               MOVE ZERO         TO MBIOWS-MMPX-MINOR-KEY
074000               MOVE SM00-PROD    TO MBIOWS-MMPX-PRODUCT
074100               MOVE ZERO         TO MBIOWS-MMPX-LOGIC-MODULE
074200               PERFORM MMPXAO-ACCESS
074300                                 THRU MMPXAO-ACCESS-EXIT
074400           END-EVALUATE
074500         WHEN MBCA-MBSM-VALID-STORE
074600             MOVE SM00-ORG       TO MBIOWS-MMPS-ORG
074700             MOVE SM00-CHAIN-MERCH
074800                                 TO MBIOWS-MMPS-ACCT
074900             EVALUATE TRUE
075000                 WHEN MBCA-MBSM-VALID-TOTALS
075100                     SET MBIOWS-MMPS-TOTALS
075200                                 TO TRUE
075300                 WHEN OTHER
075400                     SET MBIOWS-MMPS-DETAIL
075500                                 TO TRUE
075600             END-EVALUATE
075700             MOVE ZERO           TO MBIOWS-MMPS-MINOR-KEY
075800             MOVE SM00-PROD      TO MBIOWS-MMPS-PRODUCT
075900             MOVE ZERO           TO MBIOWS-MMPS-LOGIC-MODULE
076000             PERFORM MMPSAO-ACCESS
076100                                 THRU MMPSAO-ACCESS-EXIT
076200         WHEN MBCA-MBSM-VALID-S-CHAIN
076300             MOVE SM00-ORG       TO MBIOWS-MMRG-ORG
076400             MOVE SM00-CHAIN-MERCH
076500                                 TO MBIOWS-MMRG-ACCT
076600             EVALUATE TRUE
076700                 WHEN MBCA-MBSM-VALID-TOTALS
076800                     SET MBIOWS-MMRG-TOTALS
076900                                 TO TRUE
077000                 WHEN OTHER
077100                     SET MBIOWS-MMRG-DETAIL
077200                                 TO TRUE
077300             END-EVALUATE
077400             MOVE ZERO           TO MBIOWS-MMRG-MINOR-KEY
077500             MOVE SM00-PROD      TO MBIOWS-MMRG-PRODUCT
077600             MOVE ZERO           TO MBIOWS-MMRG-LOGIC-MODULE
077700             PERFORM MMRGAO-ACCESS
077800                                 THRU MMRGAO-ACCESS-EXIT
077900     END-EVALUATE.
078000*
078100     MOVE 'FC08'                 TO MBCA-PROGRAM-LOCATION.
078200     SET MBIORO-READ-SEQ         TO TRUE.
078300*
078400     EVALUATE TRUE
078500         WHEN MBCA-MBSM-VALID-MERCHANT
078600           EVALUATE TRUE
078700             WHEN MBCA-MBSM-EXPENSE-SPACE
078800               PERFORM MMPAAO-ACCESS
078900                                 THRU MMPAAO-ACCESS-EXIT
079000             WHEN MBCA-MBSM-EXPENSE-VALID
079100               PERFORM MMPEAO-ACCESS
079200                                 THRU MMPEAO-ACCESS-EXIT
079300           END-EVALUATE
079400         WHEN MBCA-MBSM-VALID-CHAIN
079500           EVALUATE TRUE
079600             WHEN MBCA-MBSM-EXPENSE-SPACE
079700               PERFORM MMPGAO-ACCESS
079800                                 THRU MMPGAO-ACCESS-EXIT
079900             WHEN MBCA-MBSM-EXPENSE-VALID
080000               PERFORM MMPXAO-ACCESS
080100                                 THRU MMPXAO-ACCESS-EXIT
080200           END-EVALUATE
080300         WHEN MBCA-MBSM-VALID-STORE
080400             PERFORM MMPSAO-ACCESS
080500                                 THRU MMPSAO-ACCESS-EXIT
080600         WHEN MBCA-MBSM-VALID-S-CHAIN
080700             PERFORM MMRGAO-ACCESS
080800                                 THRU MMRGAO-ACCESS-EXIT
080900     END-EVALUATE.
081000*
081100     MOVE 'FC09'                 TO MBCA-PROGRAM-LOCATION.
081200     SET MBIORO-ENDBR            TO TRUE.
081300*
081400     IF  MBCA-MBSM-VALID-MERCHANT
081500       EVALUATE TRUE
081600         WHEN MBCA-MBSM-EXPENSE-SPACE
081700           PERFORM MMPAAO-ACCESS THRU MMPAAO-ACCESS-EXIT
081800           IF  MMPA-ORG IS NOT EQUAL TO MBCA-MBSM-ORG
081900           OR  MMPA-ACCT     IS NOT EQUAL TO MBCA-MBSM-CHAIN-MERCH
082000               GO TO 2167-ERROR
082100           END-IF
082200           EVALUATE TRUE
082300               WHEN MBCA-MBSM-VALID-TOTALS
082400                   GO TO 2168-CHECK-ACTIVE
082500               WHEN OTHER
082600                   IF  MMPA-PRODUCT IS NOT EQUAL
082700                                 TO MBCA-MBSM-CARD-PROD
082800                       GO TO 2167-ERROR
082900                   ELSE
083000                       GO TO 2168-CHECK-ACTIVE
083100                   END-IF
083200           END-EVALUATE
083300         WHEN MBCA-MBSM-EXPENSE-VALID
083400           PERFORM MMPEAO-ACCESS THRU MMPEAO-ACCESS-EXIT
083500           IF  MMPE-ORG IS NOT EQUAL TO MBCA-MBSM-ORG
083600           OR  MMPE-ACCT     IS NOT EQUAL TO MBCA-MBSM-CHAIN-MERCH
083700               GO TO 2167-ERROR
083800           END-IF
083900           EVALUATE TRUE
084000               WHEN MBCA-MBSM-VALID-TOTALS
084100                   GO TO 2168-CHECK-ACTIVE
084200               WHEN OTHER
084300                   IF  MMPE-PRODUCT IS NOT EQUAL
084400                                 TO MBCA-MBSM-CARD-PROD
084500                       GO TO 2167-ERROR
084600                   ELSE
084700                       GO TO 2168-CHECK-ACTIVE
084800                   END-IF
084900           END-EVALUATE
085000       END-EVALUATE
085100     END-IF.
085200*
085300     IF  MBCA-MBSM-VALID-CHAIN
085400       EVALUATE TRUE
085500         WHEN MBCA-MBSM-EXPENSE-SPACE
085600           PERFORM MMPGAO-ACCESS THRU MMPGAO-ACCESS-EXIT
085700           IF  MMPG-ORG IS NOT EQUAL TO MBCA-MBSM-ORG
085800           OR  MMPG-ACCT  IS NOT EQUAL TO MBCA-MBSM-CHAIN-MERCH
085900               GO TO 2167-ERROR
086000           END-IF
086100           EVALUATE TRUE
086200               WHEN MBCA-MBSM-VALID-TOTALS
086300                   GO TO 2168-CHECK-ACTIVE
086400               WHEN OTHER
086500                   IF  MMPG-PRODUCT IS NOT EQUAL
086600                                 TO MBCA-MBSM-CARD-PROD
086700                       GO TO 2167-ERROR
086800                   ELSE
086900                       GO TO 2168-CHECK-ACTIVE
087000                   END-IF
087100           END-EVALUATE
087200         WHEN MBCA-MBSM-EXPENSE-VALID
087300           PERFORM MMPXAO-ACCESS THRU MMPXAO-ACCESS-EXIT
087400           IF  MMPX-ORG IS NOT EQUAL TO MBCA-MBSM-ORG
087500           OR  MMPX-ACCT  IS NOT EQUAL TO MBCA-MBSM-CHAIN-MERCH
087600               GO TO 2167-ERROR
087700           END-IF
087800           EVALUATE TRUE
087900               WHEN MBCA-MBSM-VALID-TOTALS
088000                   GO TO 2168-CHECK-ACTIVE
088100               WHEN OTHER
088200                   IF  MMPX-PRODUCT IS NOT EQUAL
088300                                 TO MBCA-MBSM-CARD-PROD
088400                       GO TO 2167-ERROR
088500                   ELSE
088600                       GO TO 2168-CHECK-ACTIVE
088700                   END-IF
088800           END-EVALUATE
088900       END-EVALUATE
089000     END-IF.
089100*
089200     IF  MBCA-MBSM-VALID-STORE
089300         PERFORM MMPSAO-ACCESS   THRU MMPSAO-ACCESS-EXIT
089400         IF  MMPS-ORG IS NOT EQUAL TO MBCA-MBSM-ORG
089500         OR  MMPS-ACCT  IS NOT EQUAL TO MBCA-MBSM-CHAIN-MERCH
089600             GO TO 2167-ERROR
089700         END-IF
089800         EVALUATE TRUE
089900             WHEN MBCA-MBSM-VALID-TOTALS
090000                 GO TO 2168-CHECK-ACTIVE
090100             WHEN OTHER
090200                 IF  MMPS-PRODUCT IS NOT EQUAL
090300                                 TO MBCA-MBSM-CARD-PROD
090400                     GO TO 2167-ERROR
090500                 ELSE
090600                     GO TO 2168-CHECK-ACTIVE
090700                 END-IF
090800         END-EVALUATE
090900     END-IF.
091000*
091100     IF  MBCA-MBSM-VALID-S-CHAIN
091200         PERFORM MMRGAO-ACCESS   THRU MMRGAO-ACCESS-EXIT
091300         IF  MMRG-ORG IS NOT EQUAL TO MBCA-MBSM-ORG
091400         OR  MMRG-ACCT  IS NOT EQUAL TO MBCA-MBSM-CHAIN-MERCH
091500             GO TO 2167-ERROR
091600         END-IF
091700         EVALUATE TRUE
091800             WHEN MBCA-MBSM-VALID-TOTALS
091900                 GO TO 2168-CHECK-ACTIVE
092000             WHEN OTHER
092100                 IF  MMRG-PRODUCT IS NOT EQUAL
092200                                 TO MBCA-MBSM-CARD-PROD
092300                     GO TO 2167-ERROR
092400                 ELSE
092500                     GO TO 2168-CHECK-ACTIVE
092600                 END-IF
092700         END-EVALUATE
092800     END-IF.
092900*
093000 2167-ERROR.
093100*
093200     EVALUATE TRUE
093300         WHEN MBCA-MBSM-VALID-TOTALS
093400             MOVE 'NO TOTALS RECORD ON FILE'
093500                                 TO SM00-ERR-MESSAGE
093600         WHEN OTHER
093700             MOVE 'NO DETAIL RECORDS ON FILE'
093800                                 TO SM00-ERR-MESSAGE
093900             GO TO 2170-PROD-ERROR
094000     END-EVALUATE.
094100*
094200     MOVE SS08WS-CURSOR          TO SM00-ORG-L.
094300     SET SS08WS-ERROR-SW-YES     TO TRUE.
094400     GO TO 2180-CHECK-PROD.
094500*
094600 2168-CHECK-ACTIVE.
094700*
094800     EVALUATE TRUE
094900       WHEN MBCA-MBSM-EXPENSE-SPACE
095000         EVALUATE TRUE
095100           WHEN ((MBCA-MBSM-VALID-MERCHANT
095200            AND MMPA-REC-PURGED)
095300             OR (MBCA-MBSM-VALID-CHAIN
095400            AND MMPG-REC-PURGED))
095500             MOVE MBEMWS-NOT-ACTIVE
095600                                 TO SM00-ERR-MESSAGE
095700             GO TO 2180-CHECK-PROD
095800         END-EVALUATE
095900       WHEN MBCA-MBSM-EXPENSE-VALID
096000         EVALUATE TRUE
096100           WHEN ((MBCA-MBSM-VALID-MERCHANT
096200            AND MMPE-REC-PURGED)
096300             OR (MBCA-MBSM-VALID-CHAIN
096400            AND MMPX-REC-PURGED))
096500             MOVE MBEMWS-NOT-ACTIVE
096600                                 TO SM00-ERR-MESSAGE
096700             GO TO 2180-CHECK-PROD
096800         END-EVALUATE
096900     END-EVALUATE.
097000*
097100     IF (MBCA-MBSM-VALID-STORE
097200     AND MMPS-REC-PURGED)
097300     OR (MBCA-MBSM-VALID-S-CHAIN
097400     AND MMRG-REC-PURGED)
097500         MOVE MBEMWS-NOT-ACTIVE  TO SM00-ERR-MESSAGE
097600         GO TO 2180-CHECK-PROD
097700     ELSE
097800         GO TO 2180-CHECK-PROD
097900     END-IF.
098000*
098100 2170-PROD-ERROR.
098200*
098300     MOVE DFHBMUBF               TO SM00-PROD-A.
098400     MOVE DFHBMASB               TO SM00-PROD-LP-A
098500                                    SM00-PROD-RP-A.
098600     MOVE SS08WS-CURSOR          TO SM00-PROD-L.
098700     SET SS08WS-ERROR-SW-YES     TO TRUE.
098800*
098900 2180-CHECK-PROD.
099000*
099100     IF  MBCA-MBSM-VALID-TOTALS
099200         GO TO 2470-CHECK-STAT-POS
099300     END-IF.
099400*
099500 2190-EDIT-PLAN.
099600*
099700     IF  MBCA-MBSM-VALID-PRODUCT
099800     OR  MBCA-MBSM-VALID-TOTALS
099900         GO TO 2470-CHECK-STAT-POS
100000     END-IF.
100100*
100200     IF  MBCA-MBSM-VALID-QUAL-LVL
100300         GO TO 2210-EDIT-QUAL-LVL
100400     END-IF.
100500*
100600     MOVE DFHBMUNF               TO SM00-PLAN-A.
100700     MOVE DFHBMASK               TO SM00-PLAN-LP-A
100800                                    SM00-PLAN-RP-A.
100900*
101000     IF (SM00-PLAN-L IS EQUAL TO ZERO)
101100     OR (SM00-PLAN IS NOT NUMERIC)
101200         MOVE MBEMWS-INVALID-PLAN
101300                                 TO SM00-ERR-MESSAGE
101400         GO TO 2200-PLAN-ERROR.
101500*
101600 2195-PLAN-READ.
101700*
101800****************************************************************
101900*    READ THE APPROPRIATE PLAN FILE                            *
102000****************************************************************
102100*
102200     IF  SS08WS-ERROR-SW-YES
102300         GO TO 2470-CHECK-STAT-POS.
102400*
102500     MOVE SM00-PLAN              TO MBCA-PLAN
102600                                    MBCA-MBSM-PLAN.
102700*
102800     MOVE 'FC10'                 TO MBCA-PROGRAM-LOCATION.
102900     SET MBIORO-STARTBR-GTE      TO TRUE.
103000*
103100     EVALUATE TRUE
103200         WHEN MBCA-MBSM-VALID-MERCHANT
103300             MOVE ZERO           TO MBIOWS-MMCP-MINOR-KEY
103400             MOVE SM00-ORG       TO MBIOWS-MMCP-ORG
103500             MOVE SM00-CHAIN-MERCH
103600                                 TO MBIOWS-MMCP-ACCT
103700             SET MBIOWS-MMCP-DETAIL
103800                                 TO TRUE
103900             MOVE SM00-PROD      TO MBIOWS-MMCP-PRODUCT
104000             MOVE SM00-PLAN      TO MBIOWS-MMCP-PLAN
104100             MOVE ZERO           TO MBIOWS-MMCP-LOGIC-MODULE
104200             PERFORM MMCPAO-ACCESS
104300                                 THRU MMCPAO-ACCESS-EXIT
104400         WHEN MBCA-MBSM-VALID-CHAIN
104500             MOVE ZERO           TO MBIOWS-MMCG-MINOR-KEY
104600             MOVE SM00-ORG       TO MBIOWS-MMCG-ORG
104700             MOVE SM00-CHAIN-MERCH
104800                                 TO MBIOWS-MMCG-ACCT
104900             SET MBIOWS-MMCG-DETAIL
105000                                 TO TRUE
105100             MOVE SM00-PROD      TO MBIOWS-MMCG-PRODUCT
105200             MOVE SM00-PLAN      TO MBIOWS-MMCG-PLAN
105300             MOVE ZERO           TO MBIOWS-MMCG-LOGIC-MODULE
105400             PERFORM MMCGAO-ACCESS
105500                                 THRU MMCGAO-ACCESS-EXIT
105600         WHEN MBCA-MBSM-VALID-STORE
105700             MOVE ZERO           TO MBIOWS-MMCS-MINOR-KEY
105800             MOVE SM00-ORG       TO MBIOWS-MMCS-ORG
105900             MOVE SM00-CHAIN-MERCH
106000                                 TO MBIOWS-MMCS-ACCT
106100             SET MBIOWS-MMCS-DETAIL
106200                                 TO TRUE
106300             MOVE SM00-PROD      TO MBIOWS-MMCS-PRODUCT
106400             MOVE SM00-PLAN      TO MBIOWS-MMCS-PLAN
106500             MOVE ZERO           TO MBIOWS-MMCS-LOGIC-MODULE
106600             PERFORM MMCSAO-ACCESS
106700                                 THRU MMCSAO-ACCESS-EXIT
106800         WHEN MBCA-MBSM-VALID-S-CHAIN
106900             MOVE ZERO           TO MBIOWS-MMLG-MINOR-KEY
107000             MOVE SM00-ORG       TO MBIOWS-MMLG-ORG
107100             MOVE SM00-CHAIN-MERCH
107200                                 TO MBIOWS-MMLG-ACCT
107300             SET MBIOWS-MMLG-DETAIL
107400                                 TO TRUE
107500             MOVE SM00-PROD      TO MBIOWS-MMLG-PRODUCT
107600             MOVE SM00-PLAN      TO MBIOWS-MMLG-PLAN
107700             MOVE ZERO           TO MBIOWS-MMLG-LOGIC-MODULE
107800             PERFORM MMLGAO-ACCESS
107900                                 THRU MMLGAO-ACCESS-EXIT
108000     END-EVALUATE.
108100*
108200     MOVE 'FC11'                 TO MBCA-PROGRAM-LOCATION.
108300     SET MBIORO-READ-SEQ         TO TRUE.
108400*
108500     EVALUATE TRUE
108600         WHEN MBCA-MBSM-VALID-MERCHANT
108700             PERFORM MMCPAO-ACCESS
108800                                 THRU MMCPAO-ACCESS-EXIT
108900         WHEN MBCA-MBSM-VALID-CHAIN
109000             PERFORM MMCGAO-ACCESS
109100                                 THRU MMCGAO-ACCESS-EXIT
109200         WHEN MBCA-MBSM-VALID-STORE
109300             PERFORM MMCSAO-ACCESS
109400                                 THRU MMCSAO-ACCESS-EXIT
109500         WHEN MBCA-MBSM-VALID-S-CHAIN
109600             PERFORM MMLGAO-ACCESS
109700                                 THRU MMLGAO-ACCESS-EXIT
109800     END-EVALUATE.
109900*
110000     MOVE 'FC12'                 TO MBCA-PROGRAM-LOCATION.
110100     SET MBIORO-ENDBR            TO TRUE.
110200*
110300     IF  MBCA-MBSM-VALID-MERCHANT
110400         PERFORM MMCPAO-ACCESS   THRU MMCPAO-ACCESS-EXIT
110500         IF  MMCP-ORG IS NOT EQUAL TO MBCA-MBSM-ORG
110600         OR  MMCP-ACCT     IS NOT EQUAL TO MBCA-MBSM-CHAIN-MERCH
110700         OR  MMCP-PRODUCT IS NOT EQUAL TO MBCA-MBSM-CARD-PROD
110800         OR  MMCP-PLAN IS NOT EQUAL TO MBCA-MBSM-PLAN
110900             GO TO 2195-ERROR
111000         ELSE
111100             GO TO 2198-CHECK-ACTIVE.
111200*
111300     IF  MBCA-MBSM-VALID-CHAIN
111400         PERFORM MMCGAO-ACCESS   THRU MMCGAO-ACCESS-EXIT
111500         IF  MMCG-ORG IS NOT EQUAL TO MBCA-MBSM-ORG
111600         OR  MMCG-ACCT  IS NOT EQUAL TO MBCA-MBSM-CHAIN-MERCH
111700         OR  MMCG-PRODUCT IS NOT EQUAL TO MBCA-MBSM-CARD-PROD
111800         OR  MMCG-PLAN IS NOT EQUAL TO MBCA-MBSM-PLAN
111900             GO TO 2195-ERROR
112000         ELSE
112100             GO TO 2198-CHECK-ACTIVE.
112200*
112300     IF  MBCA-MBSM-VALID-STORE
112400         PERFORM MMCSAO-ACCESS   THRU MMCSAO-ACCESS-EXIT
112500         IF  MMCS-ORG IS NOT EQUAL TO MBCA-MBSM-ORG
112600         OR  MMCS-ACCT  IS NOT EQUAL TO MBCA-MBSM-CHAIN-MERCH
112700         OR  MMCS-PRODUCT IS NOT EQUAL TO MBCA-MBSM-CARD-PROD
112800         OR  MMCS-PLAN IS NOT EQUAL TO MBCA-MBSM-PLAN
112900             GO TO 2195-ERROR
113000         ELSE
113100             GO TO 2198-CHECK-ACTIVE.
113200*
113300     IF  MBCA-MBSM-VALID-S-CHAIN
113400         PERFORM MMLGAO-ACCESS   THRU MMLGAO-ACCESS-EXIT
113500         IF  MMLG-ORG IS NOT EQUAL TO MBCA-MBSM-ORG
113600         OR  MMLG-ACCT  IS NOT EQUAL TO MBCA-MBSM-CHAIN-MERCH
113700         OR  MMLG-PRODUCT IS NOT EQUAL TO MBCA-MBSM-CARD-PROD
113800         OR  MMLG-PLAN IS NOT EQUAL TO MBCA-MBSM-PLAN
113900             GO TO 2195-ERROR
114000         ELSE
114100             GO TO 2198-CHECK-ACTIVE.
114200*
114300 2195-ERROR.
114400*
114500     MOVE 'NO RECORDS ON FILE FOR THIS PLAN'
114600                                 TO SM00-ERR-MESSAGE.
114700     GO TO 2200-PLAN-ERROR.
114800*
114900 2198-CHECK-ACTIVE.
115000*
115100     IF (MBCA-MBSM-VALID-MERCHANT
115200     AND MMCP-REC-PURGED)
115300     OR (MBCA-MBSM-VALID-CHAIN
115400     AND MMCG-REC-PURGED)
115500     OR (MBCA-MBSM-VALID-STORE
115600     AND MMCS-REC-PURGED)
115700     OR (MBCA-MBSM-VALID-S-CHAIN
115800     AND MMLG-REC-PURGED)
115900         MOVE MBEMWS-NOT-ACTIVE  TO SM00-ERR-MESSAGE
116000         GO TO 2200-PLAN-ERROR
116100     ELSE
116200         GO TO 2470-CHECK-STAT-POS
116300     END-IF.
116400*
116500 2200-PLAN-ERROR.
116600*
116700     MOVE DFHBMUBF               TO SM00-PLAN-A.
116800     MOVE DFHBMASB               TO SM00-PLAN-LP-A
116900                                    SM00-PLAN-RP-A.
117000     MOVE SS08WS-CURSOR          TO SM00-PLAN-L.
117100     SET SS08WS-ERROR-SW-YES     TO TRUE.
117200*
117300 2210-EDIT-QUAL-LVL.
117400*
117500     IF  NOT MBCA-MBSM-VALID-QUAL-LVL
117600         GO TO 2470-CHECK-STAT-POS
117700     END-IF.
117800*
117900     MOVE DFHBMUNF               TO SM00-QLVL-A.
118000     MOVE DFHBMASK               TO SM00-QLVL-LP-A
118100                                    SM00-QLVL-RP-A.
118200*
118300     IF  SM00-QLVL-L IS GREATER THAN ZERO
118400     AND SM00-QLVL IS NUMERIC
118500     AND SM00-QLVL-VALID
118600         NEXT SENTENCE
118700     ELSE
118800         MOVE MBEMWS-INVALID-QUAL-LVL
118900                                 TO SM00-ERR-MESSAGE
119000         GO TO 2220-QLVL-ERROR.
119100*
119200 2215-QUAL-LVL-READ.
119300*
119400****************************************************************
119500*    READ THE APPROPRIATE QUAL LVL FILE                        *
119600****************************************************************
119700*
119800     IF  SS08WS-ERROR-SW-YES
119900         GO TO 2470-CHECK-STAT-POS.
120000*
120100     MOVE SM00-QLVL              TO MBCA-QUAL-LEVEL
120200                                    MBCA-MBSM-QUAL-LEVEL.
120300*
120400     MOVE 'FC13'                 TO MBCA-PROGRAM-LOCATION.
120500     SET MBIORO-STARTBR-GTE      TO TRUE.
120600*
120700     EVALUATE TRUE
120800         WHEN MBCA-MBSM-VALID-MERCHANT
120900             MOVE ZERO           TO MBIOWS-MMOI-MINOR-KEY
121000             MOVE SM00-ORG       TO MBIOWS-MMOI-ORG
121100             MOVE SM00-CHAIN-MERCH
121200                                 TO MBIOWS-MMOI-ACCT
121300             SET MBIOWS-MMOI-DETAIL
121400                                 TO TRUE
121500             MOVE SM00-PROD      TO MBIOWS-MMOI-PRODUCT
121600             MOVE SM00-QLVL      TO MBIOWS-MMOI-QUAL-LEVEL
121700             MOVE ZERO           TO MBIOWS-MMOI-LOGIC-MODULE
121800             PERFORM MMOIAO-ACCESS
121900                                 THRU MMOIAO-ACCESS-EXIT
122000         WHEN MBCA-MBSM-VALID-CHAIN
122100             MOVE ZERO           TO MBIOWS-MMOG-MINOR-KEY
122200             MOVE SM00-ORG       TO MBIOWS-MMOG-ORG
122300             MOVE SM00-CHAIN-MERCH
122400                                 TO MBIOWS-MMOG-ACCT
122500             SET MBIOWS-MMOG-DETAIL
122600                                 TO TRUE
122700             MOVE SM00-PROD      TO MBIOWS-MMOG-PRODUCT
122800             MOVE SM00-QLVL      TO MBIOWS-MMOG-QUAL-LEVEL
122900             MOVE ZERO           TO MBIOWS-MMOG-LOGIC-MODULE
123000             PERFORM MMOGAO-ACCESS
123100                                 THRU MMOGAO-ACCESS-EXIT
123200     END-EVALUATE.
123300*
123400     MOVE 'FC14'                 TO MBCA-PROGRAM-LOCATION.
123500     SET MBIORO-READ-SEQ         TO TRUE.
123600*
123700     EVALUATE TRUE
123800         WHEN MBCA-MBSM-VALID-MERCHANT
123900             PERFORM MMOIAO-ACCESS
124000                                 THRU MMOIAO-ACCESS-EXIT
124100         WHEN MBCA-MBSM-VALID-CHAIN
124200             PERFORM MMOGAO-ACCESS
124300                                 THRU MMOGAO-ACCESS-EXIT
124400     END-EVALUATE.
124500*
124600     MOVE 'FC15'                 TO MBCA-PROGRAM-LOCATION.
124700     SET MBIORO-ENDBR            TO TRUE.
124800*
124900     IF  MBCA-MBSM-VALID-MERCHANT
125000         PERFORM MMOIAO-ACCESS   THRU MMOIAO-ACCESS-EXIT
125100         IF  MMOI-ORG IS NOT EQUAL TO MBCA-MBSM-ORG
125200         OR  MMOI-ACCT     IS NOT EQUAL TO MBCA-MBSM-CHAIN-MERCH
125300         OR  MMOI-PRODUCT IS NOT EQUAL TO MBCA-MBSM-CARD-PROD
125400         OR  MMOI-QUAL-LEVEL IS NOT EQUAL TO MBCA-MBSM-QUAL-LEVEL
125500             GO TO 2217-ERROR
125600         ELSE
125700             GO TO 2218-CHECK-ACTIVE.
125800*
125900     IF  MBCA-MBSM-VALID-CHAIN
126000         PERFORM MMOGAO-ACCESS   THRU MMOGAO-ACCESS-EXIT
126100         IF  MMOG-ORG IS NOT EQUAL TO MBCA-MBSM-ORG
126200         OR  MMOG-ACCT  IS NOT EQUAL TO MBCA-MBSM-CHAIN-MERCH
126300         OR  MMOG-PRODUCT IS NOT EQUAL TO MBCA-MBSM-CARD-PROD
126400         OR  MMOG-QUAL-LEVEL IS NOT EQUAL TO MBCA-MBSM-QUAL-LEVEL
126500             GO TO 2217-ERROR
126600         ELSE
126700             GO TO 2218-CHECK-ACTIVE.
126800*
126900 2217-ERROR.
127000*
127100     MOVE 'NO RECORDS ON FILE FOR THIS QUAL LEVEL'
127200                                 TO SM00-ERR-MESSAGE.
127300     GO TO 2220-QLVL-ERROR.
127400*
127500 2218-CHECK-ACTIVE.
127600*
127700     IF (MBCA-MBSM-VALID-MERCHANT
127800     AND MMOI-REC-PURGED)
127900     OR (MBCA-MBSM-VALID-CHAIN
128000     AND MMOG-REC-PURGED)
128100         MOVE MBEMWS-NOT-ACTIVE  TO SM00-ERR-MESSAGE
128200         GO TO 2220-QLVL-ERROR
128300     ELSE
128400         MOVE SM00-QLVL          TO MBCA-MBSM-PAGE-NBR
128500         GO TO 2470-CHECK-STAT-POS
128600     END-IF.
128700*
128800 2220-QLVL-ERROR.
128900*
129000     MOVE DFHBMUBF               TO SM00-QLVL-A.
129100     MOVE DFHBMASB               TO SM00-QLVL-LP-A
129200                                    SM00-QLVL-RP-A.
129300     MOVE SS08WS-CURSOR          TO SM00-QLVL-L.
129400     SET SS08WS-ERROR-SW-YES     TO TRUE.
129500*
129600 2470-CHECK-STAT-POS.
129700*
129800     MOVE ZEROES                 TO MBCA-MBSM-INDEX-1
129900                                    MBCA-MBSM-INDEX-2.
130000*
130100     PERFORM 9100-EDIT-STAT-POS  THRU 9199-ESP-EXIT
130200         VARYING X-STATS-INDEX FROM +1 BY +1
130300         UNTIL   X-STATS-INDEX IS GREATER THAN +18.
130400*
130500     IF  WS-SAVE-STATS-ONE-ZERO
130600     AND WS-SAVE-STATS-TWO-ZERO
130700         IF (SM00-ORG-L IS EQUAL TO ZERO
130800         OR  SM00-ORG IS NOT NUMERIC
130900         OR  SM00-ORG IS LESS THAN MBCA-ORG-LOW
131000         OR  SM00-ORG IS GREATER THAN MBCA-ORG-HIGH)
131100             NEXT SENTENCE
131200         ELSE
131300             PERFORM 9500-STATS-DEFAULTS
131400                                 THRU 9599-SD-EXIT
131500             PERFORM 9100-EDIT-STAT-POS
131600                                 THRU 9199-ESP-EXIT
131700                 VARYING X-STATS-INDEX FROM 1 BY 1
131800                 UNTIL   X-STATS-INDEX IS GREATER THAN 18
131900         END-IF
132000     END-IF.
132100*
132200     IF  WS-SAVE-STATS-ONE-ZERO
132300     AND WS-SAVE-STATS-TWO-ZERO
132400         PERFORM
132500             VARYING X-STATS-INDEX FROM 1 BY 1
132600             UNTIL   X-STATS-INDEX IS GREATER THAN 18
132700                 MOVE ZEROES TO SM00-STATS-POS
132800                                    (X-STATS-INDEX)
132900                 MOVE DFHBMNBF
133000                                 TO SM00-STATS-POS-A
133100                                    (X-STATS-INDEX)
133200                 MOVE DFHBMASB
133300                                 TO SM00-STATS-POS-LP-A
133400                                    (X-STATS-INDEX)
133500                                    SM00-STATS-POS-RP-A
133600                                    (X-STATS-INDEX)
133700         END-PERFORM
133800         SET SS08WS-ERROR-SW-YES TO TRUE
133900         MOVE 'YOU MUST SELECT AT LEAST ONE STAT GROUP'
134000                                 TO SM00-ERR-MESSAGE
134100         MOVE SS08WS-CURSOR      TO SM00-STATS-POS-L (1)
134200     END-IF.
134300*
134400*
134500 2500-CHECK-TRAN-TYPES.
134600*
134700     IF  MBCA-MBSM-VALID-TOTALS
134800     OR  MBCA-MBSM-VALID-PRODUCT
134900         NEXT SENTENCE
135000     ELSE
135100         GO TO 2580-CHECK-ERROR.
135200*
135300     MOVE SPACE                  TO MBCA-MBSM-TRAN-TYPES.
135400     MOVE ZEROES                 TO MBCA-MBSM-TOTAL-INDEX.
135500*
135600     PERFORM
135700         VARYING X-TRANS-INDEX FROM +1 BY +1
135800         UNTIL   X-TRANS-INDEX IS GREATER THAN +10
135900             SET X-MBCA-MBSM-TRAN
136000                                 TO X-TRANS-INDEX
136100             IF  SM00-TRANS-TYP-L (X-TRANS-INDEX) IS EQUAL TO ZERO
136200             OR  SM00-TRANS-TYP (X-TRANS-INDEX) IS EQUAL TO SPACE
136300                 MOVE SPACE      TO MBCA-MBSM-TRAN-TYPE
136400                                    (X-MBCA-MBSM-TRAN)
136500             ELSE
136600                 SET MBCA-MBSM-TRAN-TYPE-KEYED
136700                                    (X-MBCA-MBSM-TRAN)
136800                                 TO TRUE
136900                 MOVE DFHBMFSE   TO SM00-TRANS-TYP-A
137000                                    (X-TRANS-INDEX)
137100                 SET MBCA-MBSM-TOTAL-INDEX
137200                                 TO X-MBCA-MBSM-TRAN
137300                 ADD +1          TO WS-TRAN-COUNT
137400             END-IF
137500     END-PERFORM.
137600*
137700     IF  WS-TRAN-COUNT IS GREATER THAN +1
137800         MOVE 'YOU CAN ONLY SELECT ONE TRANS TYPE'
137900                                 TO SM00-ERR-MESSAGE
138000         MOVE SS08WS-CURSOR      TO SM00-TRANS-TYP-L (1)
138100         SET SS08WS-ERROR-SW-YES TO TRUE
138200     END-IF.
138300*
138400     IF  SS08WS-ERROR-SW-NO
138500         EVALUATE MBCA-MBSM-TOTAL-INDEX
138600             WHEN +1
138700                 MOVE 00         TO MBCA-SCREEN-NBR
138800             WHEN +2
138900                 MOVE 01         TO MBCA-SCREEN-NBR
139000             WHEN +3
139100                 MOVE 02         TO MBCA-SCREEN-NBR
139200             WHEN +4
139300                 MOVE 03         TO MBCA-SCREEN-NBR
139400             WHEN +5
139500                 MOVE 04         TO MBCA-SCREEN-NBR
139600             WHEN +6
139700                 MOVE 07         TO MBCA-SCREEN-NBR
139800             WHEN +7
139900                 MOVE 08         TO MBCA-SCREEN-NBR
140000             WHEN +8
140100                 MOVE 09         TO MBCA-SCREEN-NBR
140200             WHEN +9
140300                 MOVE 12         TO MBCA-SCREEN-NBR
140400             WHEN +10
140500                 MOVE 13         TO MBCA-SCREEN-NBR
140600             WHEN OTHER
140700                 MOVE 00         TO MBCA-SCREEN-NBR
140800         END-EVALUATE
140900     END-IF.
141000*
141100 2580-CHECK-ERROR.
141200*
141300     IF  SS08WS-ERROR-SW-NO
141400         GO TO 2600-SETUP-COMMAREA
141500     ELSE
141600         IF  SS08WS-VALID-PF-KEY
141700         OR  SS08WS-EIBAID-VALID-PF-KEY
141800             SET MBCA-INITIAL-SCREEN-NBR
141900                                 TO TRUE
142000             GO TO 2690-TRANSFER-XCTL.
142100*
142200 2590-SEND-MAP.
142300*
142400****************************************************************
142500*    SEND THE MAP                                              *
142600****************************************************************
142700*
142800     PERFORM MB60PD-INIT-STD-MAP-LINES
142900                                 THRU MB60PD-ISML-EXIT.
143000*
143100     PERFORM 8200-DARK-UNUSED-FIELDS
143200                                 THRU 8299-DUF-EXIT
143300*
143400     MOVE 'BM03'                 TO MBCA-PROGRAM-LOCATION.
143500     PERFORM MB60PD-SEND-MAP-WITH-ERASE
143600                                 THRU MB60PD-SMWE-EXIT.
143700*
143800****************************************************************
143900*    RETURN TO CICS                                            *
144000****************************************************************
144100*
144200     MOVE 'PC04'                 TO MBCA-PROGRAM-LOCATION.
144300     PERFORM MB70PD-RETURN-TRANS-ID
144400                                 THRU MB70PD-RTI-EXIT.
144500/
144600 2600-SETUP-COMMAREA.
144700*
144800****************************************************************
144900*    SET UP COMMAREA FIELDS AND TRANSFER TO THE NEXT PROGRAM   *
145000****************************************************************
145100*
145200     MOVE MBCA-EIBAID            TO SS08WS-EIBAID.
145300*
145400     MOVE MBIOWS-MMPA-DIRECT-KEY-CODE
145500                                 TO MBCA-KEY-CODE.
145600*
145700     PERFORM MB60PD-EDIT-PAGE-NBR
145800                                 THRU MB60PD-EPN-EXIT.
145900*
146000     IF  SS08WS-VALID-PF-KEY
146100     OR  SS08WS-EIBAID-VALID-PF-KEY
146200         SET MBCA-INITIAL-SCREEN-NBR
146300                                 TO TRUE
146400     ELSE
146500         MOVE +51                TO MBCA-MBSM-FIRST-SCREEN.
146600*
146700 2690-TRANSFER-XCTL.
146800*
146900     MOVE 'PC05'                 TO MBCA-PROGRAM-LOCATION.
147000     PERFORM MB70PD-XCTL-TO-MBOXCTL
147100                                 THRU MB70PD-XTM-EXIT.
147200/
147300 8100-READ-MER-CHAIN-OR-STORE.
147400*
147500     EVALUATE TRUE
147600         WHEN MBCA-MBSM-VALID-MERCHANT
147700             MOVE MBCA-MERCHANT-ORG
147800                                 TO MBIOWS-MMMM-ORG
147900             MOVE MBCA-MERCHANT  TO MBIOWS-MMMM-MERCHANT
148000         WHEN MBCA-MBSM-VALID-CHAIN
148100             MOVE MBCA-ORG       TO MBIOWS-MMRC-ORG
148200             MOVE MBCA-CHAIN     TO MBIOWS-MMRC-CHAIN
148300         WHEN MBCA-MBSM-VALID-STORE
148400             MOVE MBCA-ORG       TO MBIOWS-MMSM-ORG
148500             MOVE MBCA-STORE     TO MBIOWS-MMSM-STORE
148600         WHEN MBCA-MBSM-VALID-S-CHAIN
148700             MOVE MBCA-ORG       TO MBIOWS-MMSR-ORG
148800             MOVE MBCA-S-CHAIN   TO MBIOWS-MMSR-CHAIN
148900         WHEN MBCA-MERCHANT IS GREATER THAN ZERO
149000             SET MBCA-MBSM-VALID-MERCHANT
149100                                 TO TRUE
149200             MOVE MBCA-MERCHANT-ORG
149300                                 TO MBIOWS-MMMM-ORG
149400             MOVE MBCA-MERCHANT  TO MBIOWS-MMMM-MERCHANT
149500         WHEN MBCA-CHAIN IS GREATER THAN ZERO
149600             SET MBCA-MBSM-VALID-CHAIN
149700                                 TO TRUE
149800             MOVE MBCA-ORG       TO MBIOWS-MMRC-ORG
149900             MOVE MBCA-CHAIN     TO MBIOWS-MMRC-CHAIN
150000         WHEN MBCA-STORE IS GREATER THAN ZERO
150100             SET MBCA-MBSM-VALID-STORE
150200                                 TO TRUE
150300             MOVE MBCA-ORG       TO MBIOWS-MMSM-ORG
150400             MOVE MBCA-STORE     TO MBIOWS-MMSM-STORE
150500         WHEN MBCA-S-CHAIN IS GREATER THAN ZERO
150600             SET MBCA-MBSM-VALID-S-CHAIN
150700                                 TO TRUE
150800             MOVE MBCA-ORG       TO MBIOWS-MMSR-ORG
150900             MOVE MBCA-S-CHAIN   TO MBIOWS-MMSR-CHAIN
151000     END-EVALUATE.
151100*
151200     MOVE SS08WS-CICS-FC-NOTFND  TO MBIORO-TEMP-STATUS-1.
151300     SET MBIORO-READ-RANDOM      TO TRUE.
151400     SET WS-GOT-NOTHING          TO TRUE.
151500*
151600     EVALUATE TRUE
151700         WHEN MBCA-MBSM-VALID-MERCHANT
151800             MOVE 'FC16'         TO MBCA-PROGRAM-LOCATION
151900             PERFORM MMMMAO-ACCESS
152000                                 THRU MMMMAO-ACCESS-EXIT
152100             IF  NOT SS08WS-RC-FC-NOTFND
152200                 SET WS-GOT-MERCHANT-RECORD
152300                                 TO TRUE
152400             END-IF
152500         WHEN MBCA-MBSM-VALID-CHAIN
152600             MOVE 'FC17'         TO MBCA-PROGRAM-LOCATION
152700             PERFORM MMRCAO-ACCESS
152800                                 THRU MMRCAO-ACCESS-EXIT
152900             IF  NOT SS08WS-RC-FC-NOTFND
153000                 SET WS-GOT-CHAIN-RECORD
153100                                 TO TRUE
153200             END-IF
153300         WHEN MBCA-MBSM-VALID-STORE
153400             MOVE 'FC18'         TO MBCA-PROGRAM-LOCATION
153500             PERFORM MMSMAO-ACCESS
153600                                 THRU MMSMAO-ACCESS-EXIT
153700             IF  NOT SS08WS-RC-FC-NOTFND
153800                 SET WS-GOT-STORE-RECORD
153900                                 TO TRUE
154000             END-IF
154100         WHEN MBCA-MBSM-VALID-S-CHAIN
154200             MOVE 'FC19'         TO MBCA-PROGRAM-LOCATION
154300             PERFORM MMSRAO-ACCESS
154400                                 THRU MMSRAO-ACCESS-EXIT
154500             IF  NOT SS08WS-RC-FC-NOTFND
154600                 SET WS-GOT-S-CHAIN-RECORD
154700                                 TO TRUE
154800             END-IF
154900     END-EVALUATE.
155000*
155100     EVALUATE TRUE
155200         WHEN WS-GOT-MERCHANT-RECORD
155300             MOVE MMMM-STATS-CONTROL-AREA
155400                                 TO MBCA-MBSM-STATS-CONTROL-AREA
155500         WHEN WS-GOT-STORE-RECORD
155600             MOVE MMSM-STATS-CONTROL-AREA
155700                                 TO MBCA-MBSM-STATS-CONTROL-AREA
155800         WHEN WS-GOT-CHAIN-RECORD
155900             MOVE MMRC-STATS-CONTROL-AREA
156000                                 TO MBCA-MBSM-STATS-CONTROL-AREA
156100         WHEN WS-GOT-S-CHAIN-RECORD
156200             MOVE MMSR-STATS-CONTROL-AREA
156300                                 TO MBCA-MBSM-STATS-CONTROL-AREA
156400         WHEN OTHER
156500             INITIALIZE             MBCA-MBSM-STATS-CONTROL-AREA
156600     END-EVALUATE.
156700*
156800 8199-RMCOS-EXIT.
156900     EXIT.
157000/
157100 8200-DARK-UNUSED-FIELDS.
157200*
157300* INITIALIZE MERCHANT/STORE/CHAIN LITERAL
157400*
157500     EVALUATE TRUE
157600         WHEN MBCA-MBSM-VALID-MERCHANT
157700             MOVE 'MERCHANT'     TO SM00-CHAIN-MERCH-LIT
157800         WHEN MBCA-MBSM-VALID-CHAIN
157900             MOVE 'CHAIN   '     TO SM00-CHAIN-MERCH-LIT
158000         WHEN MBCA-MBSM-VALID-STORE
158100             MOVE 'STORE   '     TO SM00-CHAIN-MERCH-LIT
158200         WHEN MBCA-MBSM-VALID-S-CHAIN
158300             MOVE 'ST CHAIN'     TO SM00-CHAIN-MERCH-LIT
158400     END-EVALUATE.
158500*
158600* DARK UNUSED KEY LINE FIELDS
158700*
158800     EVALUATE TRUE
158900         WHEN MBCA-MBSM-VALID-TOTALS
159000             MOVE DFHBMDAS       TO SM00-PROD-LIT-A
159100                                    SM00-PROD-LP-A
159200                                    SM00-PROD-A
159300                                    SM00-PROD-RP-A
159400                                    SM00-PLAN-LIT-A
159500                                    SM00-PLAN-LP-A
159600                                    SM00-PLAN-A
159700                                    SM00-PLAN-RP-A
159800                                    SM00-QLVL-LIT-A
159900                                    SM00-QLVL-LP-A
160000                                    SM00-QLVL-A
160100                                    SM00-QLVL-RP-A
160200         WHEN MBCA-MBSM-VALID-PRODUCT
160300             MOVE DFHBMDAS       TO SM00-PLAN-LIT-A
160400                                    SM00-PLAN-LP-A
160500                                    SM00-PLAN-A
160600                                    SM00-PLAN-RP-A
160700                                    SM00-QLVL-LIT-A
160800                                    SM00-QLVL-LP-A
160900                                    SM00-QLVL-A
161000                                    SM00-QLVL-RP-A
161100         WHEN MBCA-MBSM-VALID-CRED-PLAN
161200             MOVE DFHBMDAS       TO SM00-QLVL-LIT-A
161300                                    SM00-QLVL-LP-A
161400                                    SM00-QLVL-A
161500                                    SM00-QLVL-RP-A
161600         WHEN MBCA-MBSM-VALID-QUAL-LVL
161700             MOVE DFHBMDAS       TO SM00-PLAN-LIT-A
161800                                    SM00-PLAN-LP-A
161900                                    SM00-PLAN-A
162000                                    SM00-PLAN-RP-A
162100     END-EVALUATE.
162200*
162300* DARK BOTTOM OF SCREEN, IF APPROPRIATE
162400*
162500     IF  (MBCA-MBSM-VALID-TOTALS
162600     OR   MBCA-MBSM-VALID-PRODUCT)
162700     AND (MBCA-MBSM-VALID-CHAIN
162800     OR   MBCA-MBSM-VALID-MERCHANT
162900     OR   MBCA-MBSM-VALID-STORE
163000     OR   MBCA-MBSM-VALID-S-CHAIN)
163100         NEXT SENTENCE
163200     ELSE
163300         MOVE DFHBMDAS           TO SM00-ASTER-2-LIT-A
163400     END-IF.
163500*
163600     PERFORM
163700         VARYING X-TRANS-INDEX FROM +1 BY +1
163800         UNTIL   X-TRANS-INDEX IS GREATER THAN +10
163900             IF  (MBCA-MBSM-VALID-TOTALS
164000             OR   MBCA-MBSM-VALID-PRODUCT)
164100             AND (MBCA-MBSM-VALID-CHAIN
164200             OR   MBCA-MBSM-VALID-MERCHANT
164300             OR   MBCA-MBSM-VALID-STORE
164400             OR   MBCA-MBSM-VALID-S-CHAIN)
164500                 MOVE DFHBMFSE   TO SM00-TRANS-TYP-A
164600                                    (X-TRANS-INDEX)
164700                 MOVE DFHBMASK   TO SM00-TRANS-TYP-LP-A
164800                                    (X-TRANS-INDEX)
164900                                    SM00-TRANS-TYP-RP-A
165000                                    (X-TRANS-INDEX)
165100                 SET X-MBCA-MBSM-TRAN
165200                                 TO X-TRANS-INDEX
165300                 MOVE MBCA-MBSM-TRAN-TYPE (X-MBCA-MBSM-TRAN)
165400                                 TO SM00-TRANS-TYP
165500                                    (X-TRANS-INDEX)
165600             ELSE
165700                 MOVE DFHBMDAS   TO SM00-TRANS-TYP-A
165800                                    (X-TRANS-INDEX)
165900                                    SM00-TRANS-TYP-LIT-A
166000                                    (X-TRANS-INDEX)
166100                                    SM00-TRANS-TYP-LP-A
166200                                    (X-TRANS-INDEX)
166300                                    SM00-TRANS-TYP-RP-A
166400                                    (X-TRANS-INDEX)
166500             END-IF
166600     END-PERFORM.
166700*
166800 8299-DUF-EXIT.
166900     EXIT.
167000/
167100 9100-EDIT-STAT-POS.
167200*
167300     IF  SM00-STATS-POS-L (X-STATS-INDEX) IS LESS THAN 1
167400         NEXT SENTENCE
167500     ELSE
167600         IF  SM00-STATS-POS (X-STATS-INDEX) IS NUMERIC
167700         AND SM00-VALID-STATS-POS (X-STATS-INDEX)
167800             MOVE DFHBMUNF       TO SM00-STATS-POS-A
167900                                    (X-STATS-INDEX)
168000             MOVE DFHBMASK       TO SM00-STATS-POS-LP-A
168100                                    (X-STATS-INDEX)
168200                                    SM00-STATS-POS-RP-A
168300                                    (X-STATS-INDEX)
168400             PERFORM 9200-CROSS-EDIT
168500                                 THRU 9299-CE-EXIT
168600         ELSE
168700             MOVE DFHBMNBF       TO SM00-STATS-POS-A
168800                                    (X-STATS-INDEX)
168900             MOVE DFHBMASB       TO SM00-STATS-POS-LP-A
169000                                    (X-STATS-INDEX)
169100                                    SM00-STATS-POS-RP-A
169200                                    (X-STATS-INDEX)
169300             MOVE SS08WS-CURSOR  TO SM00-STATS-POS-L
169400                                    (X-STATS-INDEX)
169500             SET SS08WS-ERROR-SW-YES TO TRUE
169600         END-IF
169700     END-IF.
169800*
169900 9199-ESP-EXIT.
170000     EXIT.
170100*
170200 9200-CROSS-EDIT.
170300*
170400     IF (SM00-VALID-STATS-POS1 (X-STATS-INDEX)
170500     AND WS-SAVE-STATS-ONE-ONE)
170600     OR (SM00-VALID-STATS-POS2 (X-STATS-INDEX)
170700     AND WS-SAVE-STATS-TWO-TWO)
170800         MOVE DFHBMNBF           TO SM00-STATS-POS-A
170900                                    (X-STATS-INDEX)
171000         MOVE DFHBMASB           TO SM00-STATS-POS-LP-A
171100                                    (X-STATS-INDEX)
171200                                    SM00-STATS-POS-RP-A
171300                                    (X-STATS-INDEX)
171400         MOVE SS08WS-CURSOR      TO SM00-STATS-POS-L
171500                                    (X-STATS-INDEX)
171600         SET SS08WS-ERROR-SW-YES TO TRUE.
171700*
171800     IF  SM00-VALID-STATS-POS1 (X-STATS-INDEX)
171900     AND WS-SAVE-STATS-ONE-ZERO
172000         SET MBCA-MBSM-INDEX-1   TO X-STATS-INDEX
172100         MOVE WS-ONE             TO WS-SAVE-STATS-ONE.
172200*
172300     IF  SM00-VALID-STATS-POS2 (X-STATS-INDEX)
172400     AND WS-SAVE-STATS-TWO-ZERO
172500         SET MBCA-MBSM-INDEX-2   TO X-STATS-INDEX
172600         MOVE WS-TWO             TO WS-SAVE-STATS-TWO.
172700*
172800 9299-CE-EXIT.
172900     EXIT.
173000*
173100 9400-STATS-DEFAULTS.
173200*
173300     SET X-MBCA-MBSM-STATS       TO X-STATS-INDEX.
173400*
173500     IF  MBCA-MBSM-OCCURENCE-ID (X-MBCA-MBSM-STATS)
173600                                 IS ALPHABETIC
173700     AND MBCA-MBSM-OCCURENCE-ID (X-MBCA-MBSM-STATS)
173800                                 IS NOT EQUAL TO SPACE
173900         PERFORM
174000             VARYING X-WS-MON-NAME FROM +1 BY +1
174100             UNTIL   X-WS-MON-NAME IS EQUAL TO +18
174200             OR  WS-MON-NAME-OID (X-WS-MON-NAME) IS EQUAL
174300                                 TO MBCA-MBSM-OCCURENCE-ID
174400                                    (X-MBCA-MBSM-STATS)
174500         END-PERFORM
174600         IF  X-WS-MON-NAME IS LESS THAN +13
174700             MOVE WS-MON-NAME-DES (X-WS-MON-NAME)
174800                                 TO SM00-ROLL-1-12-LIT
174900                                    (X-STATS-INDEX)
175000             MOVE MBCA-MBSM-OCCURENCE-YEAR (X-MBCA-MBSM-STATS)
175100                                 TO SM00-ROLL-1-12-LIT
175200                                    (X-STATS-INDEX) (11:4)
175300         END-IF
175400         MOVE ZEROES             TO SM00-STATS-POS
175500                                    (X-STATS-INDEX)
175600         MOVE DFHBMUNF           TO SM00-STATS-POS-A
175700                                    (X-STATS-INDEX)
175800         MOVE DFHBMASK           TO SM00-STATS-POS-LP-A
175900                                    (X-STATS-INDEX)
176000                                    SM00-STATS-POS-RP-A
176100                                    (X-STATS-INDEX)
176200     ELSE
176300         MOVE ZEROES             TO SM00-STATS-POS
176400                                    (X-STATS-INDEX)
176500         MOVE DFHBMUNF           TO SM00-STATS-POS-A
176600                                    (X-STATS-INDEX)
176700         MOVE DFHBMASK           TO SM00-STATS-POS-LP-A
176800                                    (X-STATS-INDEX)
176900                                    SM00-STATS-POS-RP-A
177000                                    (X-STATS-INDEX)
177100     END-IF.
177200*
177300 9499-SD-EXIT.
177400     EXIT.
177500*
177600 9500-STATS-DEFAULTS.
177700*
177800     PERFORM 9600-RESET-STATS    THRU 9699-RS-EXIT.
177900*
178000     IF  WS-RESET-STAT-YES
178100         GO TO 9599-SD-EXIT.
178200*
178300     EVALUATE TRUE
178400         WHEN MBCA-MBSM-VALID-STORE
178500             SET X-MMOC-STATS    TO +1
178600         WHEN MBCA-MBSM-VALID-MERCHANT
178700             EVALUATE TRUE
178800                 WHEN MBCA-MBSM-VALID-QUAL-LVL
178900                     SET X-MMOC-STATS
179000                                 TO +2
179100                 WHEN OTHER
179200                     SET X-MMOC-STATS
179300                                 TO +1
179400             END-EVALUATE
179500         WHEN MBCA-MBSM-VALID-CHAIN
179600             EVALUATE TRUE
179700                 WHEN MBCA-MBSM-VALID-QUAL-LVL
179800                     SET X-MMOC-STATS
179900                                 TO +4
180000                 WHEN OTHER
180100                     SET X-MMOC-STATS
180200                                 TO +3
180300             END-EVALUATE
180400         WHEN MBCA-MBSM-VALID-S-CHAIN
180500             EVALUATE TRUE
180600                 WHEN MBCA-MBSM-VALID-QUAL-LVL
180700                     SET X-MMOC-STATS
180800                                 TO +4
180900                 WHEN OTHER
181000                     SET X-MMOC-STATS
181100                                 TO +3
181200             END-EVALUATE
181300     END-EVALUATE.
181400*
181500     MOVE MMOC-STATS-YEST (X-MMOC-STATS)
181600                                 TO SM00-STATS-POS (13).
181700     MOVE MMOC-STATS-MTD  (X-MMOC-STATS)
181800                                 TO SM00-STATS-POS (14).
181900     MOVE MMOC-STATS-YTD  (X-MMOC-STATS)
182000                                 TO SM00-STATS-POS (15).
182100     MOVE MMOC-STATS-CTD  (X-MMOC-STATS)
182200                                 TO SM00-STATS-POS (16).
182300     MOVE MMOC-STATS-DTD  (X-MMOC-STATS)
182400                                 TO SM00-STATS-POS (17).
182500     MOVE MMOC-STATS-PTD  (X-MMOC-STATS)
182600                                 TO SM00-STATS-POS (18).
182700*
182800 9599-SD-EXIT.
182900     EXIT.
183000*
183100 9600-RESET-STATS.
183200*
183300     IF  MBCA-MBSM-INDEX-1 IS GREATER THAN WS-ZEROES
183400     AND MBCA-MBSM-INDEX-1 IS LESS THAN WS-NINETEEN
183500         SET WS-RESET-STAT-YES   TO TRUE
183600         SET X-STATS-INDEX       TO MBCA-MBSM-INDEX-1
183700         SET SM00-VALID-STATS-POS1 (X-STATS-INDEX)
183800                                 TO TRUE
183900         MOVE DFHBMUNF           TO SM00-STATS-POS-A
184000                                    (X-STATS-INDEX).
184100*
184200     IF  MBCA-MBSM-INDEX-2 IS GREATER THAN WS-ZEROES
184300     AND MBCA-MBSM-INDEX-2 IS LESS THAN WS-NINETEEN
184400         SET WS-RESET-STAT-YES   TO TRUE
184500         SET X-STATS-INDEX       TO MBCA-MBSM-INDEX-2
184600         SET SM00-VALID-STATS-POS2 (X-STATS-INDEX)
184700                                 TO TRUE
184800         MOVE DFHBMUNF           TO SM00-STATS-POS-A
184900                                    (X-STATS-INDEX).
185000*
185100 9699-RS-EXIT.
185200     EXIT.
185300/         NEW ROUTINE FOR JULIAN TO GREGORIAN CONVERSION
185400     COPY SS26PD.
185500/         ROUTINE TO NUMERICALLY EDIT TIME
185600     COPY SS27PD.
185700/         JULIAN TO GREGORIAN DATE ROUTINE
185800     COPY SS08PD.
185900/         LINE 24 PF KEYS ROUTINE
186000     COPY SS15PD.
186100/         MERCHANT PROD/CR PLAN GROUP STATS ACCESS ROUTINES
186200     COPY MMCGAO.
186300/         MERCHANT PROD/CR PLAN STATS ACCESS ROUTINES
186400     COPY MMCPAO.
186500/         STORE PROD/CR PLAN STATS ACCESS ROUTINES
186600     COPY MMCSAO.
186700/         STORE PROD/CR PLAN GROUP STATS ACCESS ROUTINES
186800     COPY MMLGAO.
186900/         MERCHANT MASTER FILE RECORD ACCESS ROUTINES
187000     COPY MMMMAO.
187100/         ORG FILE RECORD ACCESS ROUTINES
187200     COPY MMOCAO.
187300/         OUTGOING INT GROUP STATS ACCESS ROUTINES
187400     COPY MMOGAO.
187500/         OUTGOING INT STATS ACCESS ROUTINES
187600     COPY MMOIAO.
187700/         MERCHANT PROD STATS FILE RECORD ACCESS ROUTINES
187800     COPY MMPAAO.
187900/         MERCHANT PROD STATS EXPENSE FILE RECORD ACCESS ROUTINES
188000     COPY MMPEAO.
188100/         MERCHANT PROD GROUP STATS ACCESS ROUTINES
188200     COPY MMPGAO.
188300/         STORE PROD STATS ACCESS ROUTINES
188400     COPY MMPSAO.
188500/         MERCHANT PROD GROUP STATS EXPENSE ACCESS ROUTINES
188600     COPY MMPXAO.
188700/         MERCHANT RELATIONSHIP CONTROL ACCESS ROUTINES
188800     COPY MMRCAO.
188900/         STORE PROD GROUP STATS ACCESS ROUTINES
189000     COPY MMRGAO.
189100/         STORE MASTER ACCESS ROUTINES
189200     COPY MMSMAO.
189300/         STORE RELATIONSHIP CONTROL ACCESS ROUTINES
189400     COPY MMSRAO.
189500/         ON-LINE MAP ROUTINES
189600     COPY MB60PD REPLACING 'MBMAPXX' BY 'MBSM00 '
189700                           MBMAPXXI BY MBSM00I
189800                           MBMAPXXO BY MBSM00O.
189900/         ON-LINE PROCEDURES
190000     COPY MB70PD.
190100/
190200     COPY SMFTPXO.
