000100 IDENTIFICATION DIVISION.
000200 PROGRAM-ID. MBOTM00.
000201*       RELEASE DATE=08/24/01.        REVISION LEVEL=08.06      *
000202*****************************************************************
000203*WARNING.  THIS COMPUTER PROGRAM IS PROTECTED BY COPYRIGHT LAW  *
000204*AND INTERNATIONAL TREATIES.  UNAUTHORIZED REPRODUCTION OR      *
000205*DISTRIBUTION OF THIS PROGRAM, OR ANY PORTION OF IT, MAY RESULT *
000206*IN SEVERE CIVIL AND CRIMINAL PENATLIES, AND WILL BE PROSECUTED *
000207*TO THE MAXIMUM EXTENT POSSIBLE UNDER THE LAW.                  *
000208*COPYRIGHT 1999 PAYSYS INTERNATIONAL, INC.  ALL RIGHTS RESERVED.*
000209*****************************************************************
000300*****************************************************************
000400*                                                               *
000500*   V - PLUS  M E R C H A N T   B A N K C A R D   S Y S T E M   *
000600*                                                               *
000700*      MBOTM00 - ON-LINE TERMINATED MERCHANTS                   *
000800*                LOCATE SCREEN 00                               *
000900*                                                               *
001000*              1. TRANSID                                       *
001100*                 A. MBTM                                       *
001200*              2. MAPS USED -                                   *
001300*                 A. MBTM00 (LOCATE MAP)                        *
001400*              3. FILES USED -                                  *
001500*                 A. MMMM (MERCHANT MASTER)                     *
001600*                 B. MMSM (STORE MASTER)                        *
001700*                 C. MMTM (TERMINATED MERCHANTS)                *
001800*                                                               *
001900*****************************************************************
002000*
002100 ENVIRONMENT DIVISION.
002200*
002300 DATA DIVISION.
002400*
002500 WORKING-STORAGE SECTION.
002600*
002700 01  FILLER                  PIC  X(12)      VALUE
002800     '** WS-BEG **'.
002900*
003000 01  FILLER                  PIC  X(14)      VALUE
003100     'MISCELLANEOUS:'.
003200*
003300 01  WS-MISCELLANEOUS.
003400     03  WS-ORG-LOW          PIC S9(03)      COMP-3
003500                                             VALUE +001.
003600     03  WS-ORG-HIGH         PIC S9(03)      COMP-3
003700                                             VALUE +998.
003800     03  WS-ACTION-CODE.
003900         05  WS-ACTION-CODE-1
004000                             PIC  X(01)      VALUE SPACES.
004100         05  WS-ACTION-CODE-2
004200                             PIC  X(01)      VALUE 'M'.
004300/
004400 01  FILLER                  PIC  X(29)      VALUE
004500     'I/O REQUEST BLOCK WORK AREAS:'.
004600*
004700     COPY MBIOWS.
004800/
004900 01  FILLER                  PIC  X(18)      VALUE
005000     'I/O REQUEST BLOCK:'.
005100*
005200     COPY MBIORO.
005300/
005400 01  FILLER                  PIC  X(21)      VALUE
005500     'ERROR MESSAGES TABLE:'.
005600*
005700     COPY MBEMWS.
005800/
005900 01  FILLER                  PIC  X(27)      VALUE
006000     'MERCHANT MASTER WORK AREAS:'.
006100*
006200     COPY MMMMWS.
006300/
006400 01  FILLER                  PIC  X(20)      VALUE
006500     'CCS DATE WORK AREAS:'.
006600*
006700     COPY SS01WS.
006800/
006900 01  FILLER                  PIC  X(27)      VALUE
007000     'CCS CHECK DIGIT WORK AREAS:'.
007100*
007200     COPY SS05WS.
007300/
007400 01  FILLER                  PIC  X(15)      VALUE
007500     'CCS WORK AREAS:'.
007600*
007700     COPY SS08WS.
007800/
007900     COPY SS00WS.
008000/
008100     COPY SMFTWS.
008200/
008300     COPY SMPTRL REPLACING ==:SMPT:== BY ==SMPT==.
008400/
008500     COPY MB61LK.
008600/
008700 01  FILLER                  PIC  X(39)      VALUE
008800     'TERMINATED MERCHANTS INITIALIZER RECORD'.
008900*
009000     COPY MMTMIR.
009100*
009200 01  FILLER                  PIC  X(12)      VALUE
009300     '** WS-END **'.
009400/
009500 LINKAGE SECTION.
009600*
009700 01  DFHCOMMAREA.
009800*
009900     COPY MB60WS.
010000/
010100****************************************
010200*    TERMINATED MERCHANT LOCATE MAP    *
010300****************************************
010400*
010500     COPY MBTM00.
010600/
010700****************************************************
010800*    TERMINATED MASTER LOOCATE MAP REDEFINITION    *
010900****************************************************
011000*
011100     COPY MBTM00R.
011200/
011300***************************
011400*    ORG RECORD LAYOUT    *
011500***************************
011600*
011700     COPY MMOCRL.
011800/
011900***************************************
012000*    MERCHANT MASTER RECORD LAYOUT    *
012100***************************************
012200*
012300     COPY MMMMRL.
012400/
012500***************************************
012600*    STORE MASTER RECORD LAYOUT       *
012700***************************************
012800*
012900     COPY MMSMRL.
013000/
013100****************************************
013200*    TERMINATED MERCHANT RECORD LAYOUT *
013300****************************************
013400*
013500     COPY MMTMRL.
013600/
013700 PROCEDURE DIVISION.
013800*
013900 A000-HOUSEKEEPING SECTION.
014000*
014100 A020-INIT.
014200*
014300     MOVE 'PC01'                 TO MBCA-PROGRAM-LOCATION.
014400     PERFORM MB70PD-ON-LINE-HOUSEKEEPING
014500                                 THRU MB70PD-OLH-EXIT.
014600*
014700     MOVE 1                      TO MBCA-MBTM-PD-INDEX.
014800     SET MBCA-MBTM-STORE-FOUND   TO TRUE.
014900     SET MBCA-MBTM-MERCH-FOUND   TO TRUE.
015000*
015100     IF  MBCA-RECEIVE-SCREEN
015200         GO TO C000-RECEIVE-SCREEN.
015300/
015400 B000-SEND-SCREEN SECTION.
015500*
015600*********************************************
015700*    GET CICS STORAGE NEEDED FOR THE MAP    *
015800*********************************************
015900*
016000     MOVE 'SC01'                 TO MBCA-PROGRAM-LOCATION.
016100     PERFORM MB60PD-GETMAIN-FOR-MAP
016200                                 THRU MB60PD-GFM-EXIT.
016300*
016400*
016500*****************************************************************
016600*    SEE IF THE MBCA-MERCHANT-ORG IS GREATER THAN ZERO. IF IT   *
016700*    IS, PLUG IT INTO THE MAP. THE THE MBCA-MERCHANT IS GREATER *
016800*    THAN ZERO, PLUG IT INTO THE MAP.                           *
016900*****************************************************************
017000*
017100     IF  MBCA-INITIAL-KEY-CODE
017200         GO TO B020-BUILD-SCREEN.
017300*
017400     IF  MBCA-MMMM-KEY-CODE
017500         IF  MBCA-MERCHANT-ORG IS GREATER THAN ZERO
017600         AND MBCA-MERCHANT      IS GREATER THAN ZERO
017700         AND MBCA-S-M           IS EQUAL TO 'M'
017800             MOVE MBCA-MERCHANT-ORG
017900                                 TO TM00-ORG
018000             MOVE MBCA-MERCHANT  TO TM00-MERCHANT
018100             MOVE MBCA-S-M       TO TM00-SM-FLAG
018200             MOVE DFHBMUNF       TO TM00-ORG-A
018300                                    TM00-MERCHANT-A
018400             MOVE DFHBMFSE       TO TM00-SM-FLAG-A
018500             GO TO B020-BUILD-SCREEN.
018600*
018700     IF  MBCA-MMMM-KEY-CODE
018800         IF  MBCA-MERCHANT-ORG IS GREATER THAN ZERO
018900         AND MBCA-MERCHANT      IS GREATER THAN ZERO
019000         AND MBCA-S-M           IS EQUAL TO 'S'
019100             MOVE MBCA-MERCHANT-ORG
019200                                 TO TM00-ORG
019300             MOVE MBCA-MERCHANT  TO TM00-MERCHANT
019400             MOVE MBCA-S-M       TO TM00-SM-FLAG
019500             MOVE DFHBMUNF       TO TM00-ORG-A
019600                                    TM00-MERCHANT-A
019700             MOVE DFHBMFSE       TO TM00-SM-FLAG-A
019800             IF  MBCA-DIRECT-TRANSFER-CODE
019900             AND MBCA-INITIAL-SCREEN-NBR
020000                 MOVE 00         TO MBCA-SCREEN-NBR
020100                 GO TO C080-EDIT-ORG
020200             ELSE
020300                 GO TO B020-BUILD-SCREEN.
020400*
020500     IF  MBCA-VALID-KEY-CODES
020600         IF  MBCA-MERCHANT-ORG IS GREATER THAN ZERO
020700             MOVE MBCA-MERCHANT-ORG
020800                                 TO TM00-ORG
020900             MOVE DFHBMUNF       TO TM00-ORG-A
021000             IF  MBCA-MERCHANT IS GREATER THAN ZERO
021100                 MOVE MBCA-MERCHANT
021200                                 TO TM00-MERCHANT
021300                 MOVE DFHBMUNF   TO TM00-MERCHANT-A
021400                 MOVE 'M'        TO MBCA-S-M
021500                 MOVE MBCA-S-M   TO TM00-SM-FLAG
021600                 MOVE DFHBMFSE   TO TM00-SM-FLAG-A
021700             ELSE
021800                 IF  MBCA-MERCHANT IS GREATER THAN ZERO
021900                     MOVE MBCA-MERCHANT
022000                                 TO TM00-MERCHANT
022100                     MOVE DFHBMUNF
022200                                 TO TM00-MERCHANT-A
022300                     MOVE 'S'    TO MBCA-S-M
022400                     MOVE MBCA-S-M
022500                                 TO TM00-SM-FLAG
022600                     MOVE DFHBMFSE
022700                                 TO TM00-SM-FLAG-A.
022800*
022900 B020-BUILD-SCREEN.
023000*
023100*******************************************
023200*    INITIALIZE THE STANDARD MAP LINES    *
023300*******************************************
023400*
023500     MOVE SS08WS-CURSOR          TO TM00-ORG-L.
023600     MOVE 00                     TO MBCA-SCREEN-NBR.
023700     PERFORM MB60PD-INIT-STD-MAP-LINES
023800                                 THRU MB60PD-ISML-EXIT.
023900*
024000**********************
024100*    SEND THE MAP    *
024200**********************
024300*
024400     MOVE 'BM01'                 TO MBCA-PROGRAM-LOCATION.
024500     PERFORM MB60PD-SEND-MAP-WITH-ERASE
024600                                 THRU MB60PD-SMWE-EXIT.
024700*
024800************************
024900*    RETURN TO CICS    *
025000************************
025100*
025200     MOVE 'PC02'                 TO MBCA-PROGRAM-LOCATION.
025300     PERFORM MB70PD-RETURN-TRANS-ID
025400                                 THRU MB70PD-RTI-EXIT.
025500/
025600 C000-RECEIVE-SCREEN SECTION.
025700*
025800*************************************************
025900*    THIS SECTION RECEIVES THE LOCATE SCREEN    *
026000*************************************************
026100*
026200     MOVE 'BM02'                 TO MBCA-PROGRAM-LOCATION.
026300     PERFORM MB60PD-RECEIVE-MAP  THRU MB60PD-RM-EXIT.
026400*
026500**************************************************************
026600*    CHECK FOR ANOTHER TRANSACTION ID ENTERED BY THE USER    *
026700**************************************************************
026800*
026900     MOVE 'PC03'                 TO MBCA-PROGRAM-LOCATION.
027000     PERFORM MB60PD-NEW-TRANS-ROUTINE
027100                                 THRU MB60PD-NTR-EXIT.
027200*
027300 C020-FIELD-EDITS.
027400*
027500     MOVE 'N'                    TO SS08WS-ERROR.
027600     MOVE MBCA-EIBAID            TO SS08WS-EIBAID.
027700*
027800     IF  (TM00-ORG-L IS LESS THAN 1
027900     AND  TM00-MERCHANT-L IS LESS THAN 1
028000     AND  TM00-SM-FLAG-L IS LESS THAN 1)
028100     AND (SS08WS-VALID-PF-KEY
028200     OR   SS08WS-EIBAID-VALID-PF-KEY)
028300         SET MBCA-INITIAL-SCREEN-NBR
028400                                 TO TRUE
028500         GO TO F090-TRANSFER-XCTL.
028600*
028700******************************************************
028800*    RESET THE FIELD ATTRIBUTES TO THEIR NORMAL      *
028900*    PRIOR STATE PRIOR TO ANY EDITING BEING DONE.    *
029000******************************************************
029100*
029200     MOVE DFHBMUNN               TO TM00-ORG-A
029300                                    TM00-MERCHANT-A.
029400     MOVE DFHBMUNP               TO TM00-SM-FLAG-A
029500                                    TM00-ACTION-A.
029600     MOVE DFHBMASK               TO TM00-ORG-LP-A
029700                                    TM00-ORG-RP-A
029800                                    TM00-MERCHANT-LP-A
029900                                    TM00-MERCHANT-RP-A
030000                                    TM00-SM-FLAG-LP-A
030100                                    TM00-SM-FLAG-RP-A
030200                                    TM00-ACTION-LP-A
030300                                    TM00-ACTION-RP-A.
030400*
030500*
030600 C080-EDIT-ORG.
030700*
030800     IF  TM00-ORG-L IS EQUAL TO ZERO
030900     OR  TM00-ORG IS NOT NUMERIC
031000     OR  TM00-ORG IS LESS THAN MBCA-ORG-LOW
031100     OR  TM00-ORG IS GREATER THAN MBCA-ORG-HIGH
031200     OR  TM00-ORG IS LESS THAN WS-ORG-LOW
031300     OR  TM00-ORG IS GREATER THAN WS-ORG-HIGH
031400         MOVE MBEMWS-INVALID-ORG TO TM00-ERR-MESSAGE
031500         GO TO C098-ORG-ERROR.
031600*
031700 C082-READ-ORG.
031800*
031900************************************************
032000*    READ THE ORGANIZATION RECORD.  IT MUST    *
032100*    BE ON FILE AND AN ACTIVE RECORD.          *
032200************************************************
032300*
032400     MOVE TM00-ORG               TO MBIOWS-MMOC-ORG.
032500     MOVE 'FC01'                 TO MBCA-PROGRAM-LOCATION.
032600     MOVE SS08WS-CICS-FC-NOTFND  TO MBIORO-TEMP-STATUS-1.
032700     SET MBIORO-READ-RANDOM      TO TRUE.
032800     PERFORM MMOCAO-ACCESS       THRU MMOCAO-ACCESS-EXIT.
032900*
033000     IF  SS08WS-RC-FC-NOTFND
033100         MOVE MBEMWS-NOT-ON-FILE TO TM00-ERR-MESSAGE
033200     ELSE
033300         IF  MMOC-ADD-PENDING
033400             MOVE MBEMWS-ADD-PENDING
033500                                 TO TM00-ERR-MESSAGE
033600         ELSE
033700             IF  MMOC-REC-PURGED
033800                 MOVE MBEMWS-NOT-ACTIVE
033900                                 TO TM00-ERR-MESSAGE
034000             ELSE
034100                 MOVE DFHBMUNF   TO TM00-ORG-A
034200                 MOVE TM00-ORG   TO MBCA-MERCHANT-ORG
034300                 GO TO C100-EDIT-MERCHANT.
034400*
034500 C098-ORG-ERROR.
034600*
034700     SET SS08WS-ERROR-SW-YES     TO TRUE.
034800     MOVE DFHBMASB               TO TM00-ORG-LP-A
034900                                    TM00-ORG-RP-A.
035000     MOVE SS08WS-CURSOR          TO TM00-ORG-L.
035100     MOVE DFHBMNBF               TO TM00-ORG-A.
035200     MOVE DFHBMUNF               TO TM00-MERCHANT-A.
035300     MOVE DFHBMFSE               TO TM00-SM-FLAG-A
035400                                    TM00-ACTION-A.
035500     GO TO D000-RETURN-ERRORS.
035600*
035700 C100-EDIT-MERCHANT.
035800*
035900     IF  TM00-MERCHANT-L IS EQUAL TO ZERO
036000     OR  TM00-MERCHANT IS NOT NUMERIC
036100     OR  TM00-MERCHANT IS EQUAL TO ZEROES OR 999999999
036200         MOVE MBEMWS-INVALID-MERCHANT
036300                                 TO TM00-ERR-MESSAGE
036400         GO TO C118-MERCHANT-ERROR
036500     ELSE
036600         GO TO C200-EDIT-SM-FLAG.
036700*
036800 C118-MERCHANT-ERROR.
036900*
037000     SET SS08WS-ERROR-SW-YES     TO TRUE.
037100     MOVE DFHBMASB               TO TM00-MERCHANT-LP-A
037200                                    TM00-MERCHANT-RP-A.
037300     MOVE SS08WS-CURSOR          TO TM00-MERCHANT-L.
037400     MOVE DFHBMNBF               TO TM00-MERCHANT-A.
037500     MOVE DFHBMFSE               TO TM00-SM-FLAG-A
037600                                    TM00-ACTION-A.
037700     GO TO D000-RETURN-ERRORS.
037800*
037900 C200-EDIT-SM-FLAG.
038000*
038100     IF  TM00-VALID-SM-FLAG
038200         MOVE TM00-SM-FLAG       TO MBCA-S-M
038300         MOVE DFHBMFSE           TO TM00-SM-FLAG-A
038400         GO TO C220-EDIT-ACTION
038500     ELSE
038600         MOVE MBEMWS-INVALID-S-M
038700                                 TO TM00-ERR-MESSAGE
038800         GO TO C205-SM-ERROR.
038900*
039000 C205-SM-ERROR.
039100*
039200     MOVE 'Y'                    TO SS08WS-ERROR.
039300     MOVE DFHBMASB               TO TM00-SM-FLAG-LP-A
039400                                    TM00-SM-FLAG-RP-A.
039500     MOVE SS08WS-CURSOR          TO TM00-SM-FLAG-L.
039600     MOVE DFHBMUNF               TO TM00-MERCHANT-A.
039700     MOVE DFHBMUBF               TO TM00-SM-FLAG-A.
039800     MOVE DFHBMFSE               TO TM00-ACTION-A.
039900     GO TO D000-RETURN-ERRORS.
040000*
040100 C220-EDIT-ACTION.
040200*
040300     IF  TM00-ACTION-L IS EQUAL TO ZERO
040400     OR  NOT TM00-VALID-ACTION
040500         GO TO C221-ERROR
040600     ELSE
040700         MOVE DFHBMFSE           TO TM00-ACTION-A
040800         MOVE TM00-ACTION        TO WS-ACTION-CODE-1
040900         MOVE WS-ACTION-CODE     TO MBCA-ACTION-CODE
041000         GO TO C300-READ-MMMM-OR-MMSM.
041100*
041200 C221-ERROR.
041300*
041400     SET SS08WS-ERROR-SW-YES     TO TRUE.
041500     MOVE DFHBMASB               TO TM00-ACTION-LP-A
041600                                    TM00-ACTION-RP-A.
041700     MOVE SS08WS-CURSOR          TO TM00-ACTION-L.
041800     MOVE DFHBMUBF               TO TM00-ACTION-A.
041900     MOVE DFHBMUNF               TO TM00-ORG-A
042000                                    TM00-MERCHANT-A.
042100     MOVE DFHBMFSE               TO TM00-SM-FLAG-A.
042200     GO TO D000-RETURN-ERRORS.
042300*
042400 C300-READ-MMMM-OR-MMSM.
042500*
042600*************************************************************
042700*    READ THE MERCHANT MASTER RECORD OR STORE MASTER        *
042800*    RECORD, DEPENDING ON THE S/M FLAG.  THE MERCHANT OR    *
042900*    STORE MUST BE ON FILE AND AN ACTIVE RECORD.            *
043000*************************************************************
043100*
043200     IF  TM00-SM-FLAG IS EQUAL TO 'M'
043300         MOVE 'FC02'             TO MBCA-PROGRAM-LOCATION
043400         PERFORM Y900-READ-MMMM  THRU Y919-READ-MMMM-EXIT
043500         IF  SS08WS-RC-FC-VALID-RTN-CODE
043600         AND NOT MMMM-REC-PURGED
043700             MOVE DFHBMUNF       TO TM00-MERCHANT-A
043800             MOVE TM00-MERCHANT  TO MBCA-MERCHANT
043900             GO TO C500-CHECK-MMTM-RECORD
044000         ELSE
044100             IF  TM00-ACTION-INQ
044200                 MOVE DFHBMUNF   TO TM00-MERCHANT-A
044300                 SET MBCA-MBTM-MERCH-NOT-FND
044400                                 TO TRUE
044500                 SET MBCA-MBTM-STORE-NOT-FND
044600                                 TO TRUE
044700                 MOVE TM00-MERCHANT
044800                                 TO MBCA-MERCHANT
044900                 GO TO C500-CHECK-MMTM-RECORD
045000             ELSE
045100                 MOVE MBEMWS-NOT-ON-MERCHANT-MASTER
045200                                 TO TM00-ERR-MESSAGE
045300                 GO TO C398-MERCHANT-S-M-ERROR.
045400*
045500     IF  TM00-SM-FLAG IS EQUAL TO 'S'
045600         MOVE 'FC03'             TO MBCA-PROGRAM-LOCATION
045700         PERFORM Y920-READ-MMSM  THRU Y939-READ-MMSM-EXIT
045800         IF  SS08WS-RC-FC-VALID-RTN-CODE
045900         AND NOT MMSM-REC-PURGED
046000             MOVE TM00-MERCHANT  TO MBCA-MERCHANT
046100             GO TO C500-CHECK-MMTM-RECORD
046200         ELSE
046300             IF  TM00-ACTION-INQ
046400                 MOVE TM00-MERCHANT
046500                                 TO MBCA-MERCHANT
046600                 SET MBCA-MBTM-STORE-NOT-FND
046700                                 TO TRUE
046800                 SET MBCA-MBTM-MERCH-NOT-FND
046900                                 TO TRUE
047000                 GO TO C500-CHECK-MMTM-RECORD
047100             ELSE
047200                 MOVE MBEMWS-NOT-ON-STORE-MASTER
047300                                 TO TM00-ERR-MESSAGE
047400                 GO TO C398-MERCHANT-S-M-ERROR.
047500*
047600 C398-MERCHANT-S-M-ERROR.
047700*
047800     MOVE 'Y'                    TO SS08WS-ERROR.
047900     MOVE DFHBMASB               TO TM00-MERCHANT-LP-A
048000                                    TM00-MERCHANT-RP-A
048100                                    TM00-SM-FLAG-LP-A
048200                                    TM00-SM-FLAG-RP-A.
048300     MOVE SS08WS-CURSOR          TO TM00-MERCHANT-L.
048400     MOVE DFHBMNBF               TO TM00-MERCHANT-A.
048500     MOVE DFHBMUBF               TO TM00-SM-FLAG-A.
048600     MOVE DFHBMFSE               TO TM00-ACTION-A.
048700     GO TO D000-RETURN-ERRORS.
048800*
048900**********************************************************
049000*    READ THE TERMINATED MERCHANT RECORD TO SEE IF IT IS *
049100*    NECESSARY TO WRITE A NEW INITIALIZED RECORD.        *
049200**********************************************************
049300*
049400 C500-CHECK-MMTM-RECORD.
049500*
049600     MOVE MBCA-MERCHANT-ORG      TO MBIOWS-MMTM-ORG.
049700     MOVE MBCA-MERCHANT          TO MBIOWS-MMTM-MERCHANT.
049800     MOVE MBCA-S-M               TO MBIOWS-MMTM-FILE-TYPE.
049900     MOVE MBCA-ACTION-CODE       TO MBIOWS-MMTM-ACTION-CODE.
050000     MOVE 'FC04'                 TO MBCA-PROGRAM-LOCATION.
050100     MOVE SS08WS-CICS-FC-NOTFND  TO MBIORO-TEMP-STATUS-1.
050200     SET MBIORO-READ-RANDOM      TO TRUE.
050300     PERFORM MMTMAO-ACCESS       THRU MMTMAO-ACCESS-EXIT.
050400*
050500     EVALUATE TRUE
050600         WHEN  SS08WS-RC-FC-VALID-RTN-CODE
050700             EVALUATE TRUE
050800                WHEN MMTM-ADD-PENDING
050900                    EVALUATE TRUE
051000                        WHEN WS-ACTION-CODE IS NOT EQUAL TO
051100                             MMTM-ACTION-CODE
051200                             EVALUATE TRUE
051300                               WHEN TM00-ACTION-ADD
051400                                 MOVE MBEMWS-INQ-ALREADY-ON-FILE
051500                                 TO TM00-ERR-MESSAGE
051600                               WHEN OTHER
051700                                 MOVE MBEMWS-ADD-ALREADY-ON-FILE
051800                                 TO TM00-ERR-MESSAGE
051900                             END-EVALUATE
052000                             MOVE SS08WS-CURSOR
052100                                 TO TM00-ALT-TRANID-L
052200                             SET SS08WS-ERROR-SW-YES
052300                                 TO TRUE
052400                             GO TO D000-RETURN-ERRORS
052500                        WHEN OTHER
052600                            MOVE MMTM-ONLINE-STATUS
052700                                 TO MBCA-SCREEN-NBR
052800                            SET MBCA-MBTM-FUNCTION-ADD
052900                                 TO TRUE
053000                            GO TO F000-SETUP-COMMAREA
053100                    END-EVALUATE
053200                WHEN WS-ACTION-CODE IS NOT EQUAL TO
053300                     MMTM-ACTION-CODE
053400                    EVALUATE TRUE
053500                      WHEN TM00-ACTION-ADD
053600                        MOVE MBEMWS-INQ-ALREADY-ON-FILE
053700                                 TO TM00-ERR-MESSAGE
053800                      WHEN OTHER
053900                        MOVE MBEMWS-ADD-ALREADY-ON-FILE
054000                                 TO TM00-ERR-MESSAGE
054100                    END-EVALUATE
054200                    MOVE SS08WS-CURSOR
054300                                 TO TM00-ALT-TRANID-L
054400                    SET SS08WS-ERROR-SW-YES
054500                                 TO TRUE
054600                    GO TO D000-RETURN-ERRORS
054700                WHEN OTHER
054800                    SET MBCA-MBTM-FUNCTION-MAINT
054900                                 TO TRUE
055000                    GO TO F000-SETUP-COMMAREA
055100             END-EVALUATE
055200         WHEN OTHER
055300              CONTINUE
055400     END-EVALUATE.
055500*
055600*********************************************************
055700*    SET UP THE RECORD.  USE THE INITIALIZER RECORD     *
055800*    (MMTMIR) AS THE FIELD DEFAULTS.                    *
055900*********************************************************
056000*
056100     SET MBCA-MBTM-FUNCTION-ADD  TO TRUE.
056200*
056300     MOVE MMTMIR-MASTERCARD-DATA TO MMTMIR-DATA.
056400     SET MMTMIR-DF-MASTERCARD    TO TRUE.
056500     MOVE MMTMIR-RECORD          TO MMTM-RECORD.
056600     MOVE MBCA-MERCHANT-ORG      TO MMTM-ORG.
056700     MOVE MBCA-MERCHANT          TO MMTM-MERCHANT.
056800     MOVE MBCA-S-M               TO MMTM-FILE-TYPE.
056900*
057000     MOVE MBCA-ACTION-CODE       TO MMTM-ACTION-CODE.
057100*
057200     MOVE ZERO                   TO MMTM-ONLINE-STATUS.
057300     MOVE MBCA-START-DATE        TO MMTM-LAST-MAINT-DATE.
057400     MOVE MBCA-OPERATOR-ID       TO MMTM-LAST-MAINT-OPER.
057500*
057600*************************************
057700*    WRITE INITIALIZER RECORD TO    *
057800*    THE MMTM FILE.                 *
057900*************************************
058000*
058100     MOVE 'FC05'                 TO MBCA-PROGRAM-LOCATION.
058200     SET MBIORO-WRITE            TO TRUE.
058300     PERFORM MMTMAO-ACCESS       THRU MMTMAO-ACCESS-EXIT.
058400/
058500 D000-RETURN-ERRORS SECTION.
058600*
058700     IF  SS08WS-ERROR-SW-NO
058800         GO TO F000-SETUP-COMMAREA
058900     ELSE
059000         IF  SS08WS-VALID-PF-KEY
059100         OR  SS08WS-EIBAID-VALID-PF-KEY
059200             SET MBCA-INITIAL-SCREEN-NBR
059300                                 TO TRUE
059400             GO TO F090-TRANSFER-XCTL.
059500*
059600***************************************************************
059700*    INITIALIZE THE STANDARD MAP LINES.  IN AN ERROR          *
059800*    CONDITION, THIS ROUTINE IS PERFORMED PRIMARILY           *
059900*    TO UPDATE THE DATE AND TIME ON THE SCREEN.               *
060000***************************************************************
060100*
060200     PERFORM MB60PD-INIT-STD-MAP-LINES
060300                                 THRU MB60PD-ISML-EXIT.
060400*
060500**********************
060600*    SEND THE MAP    *
060700**********************
060800*
060900     MOVE 'BM03'                 TO MBCA-PROGRAM-LOCATION.
061000     PERFORM MB60PD-SEND-MAP-WITH-ERASE
061100                                 THRU MB60PD-SMWE-EXIT.
061200*
061300************************
061400*    RETURN TO CICS    *
061500************************
061600*
061700     MOVE 'PC04'                 TO MBCA-PROGRAM-LOCATION.
061800     PERFORM MB70PD-RETURN-TRANS-ID
061900                                 THRU MB70PD-RTI-EXIT.
062000/
062100 F000-SETUP-COMMAREA SECTION.
062200*
062300***************************************************************
062400*  SET UP COMMAREA FIELDS AND TRANSFER TO THE NEXT PROGRAM    *
062500***************************************************************
062600*
062700     MOVE MBCA-EIBAID            TO SS08WS-EIBAID.
062800*
062900     MOVE MBIOWS-MMMM-DIRECT-KEY-CODE
063000                                 TO MBCA-KEY-CODE.
063100*
063200     IF  MBCA-PTI-FUNCTION-IS-MODEL
063300         SET MBCA-PTI-FUNCTION-IS-ADD
063400                                 TO TRUE
063500         MOVE MBCA-PTI-POS-3-4   TO MBCA-TI-POS-3-4.
063600*
063700     PERFORM MB60PD-EDIT-PAGE-NBR
063800                                 THRU MB60PD-EPN-EXIT.
063900*
064000     IF  TM00-ACTION-ADD
064100         MOVE 51                 TO MBCA-SCREEN-NBR.
064200*
064300     IF  TM00-ACTION-INQ
064400         MOVE 52                 TO MBCA-SCREEN-NBR.
064500*
064600     IF  SS08WS-VALID-PF-KEY
064700     OR  SS08WS-EIBAID-VALID-PF-KEY
064800         SET MBCA-INITIAL-SCREEN-NBR
064900                                 TO TRUE.
065000*
065100 F090-TRANSFER-XCTL.
065200*
065300     MOVE 'PC05'                 TO MBCA-PROGRAM-LOCATION.
065400     PERFORM MB70PD-XCTL-TO-MBOXCTL
065500                                 THRU MB70PD-XTM-EXIT.
065600/
065700 Y000-PERFORMED-ROUTINES SECTION.
065800*
065900 Y900-READ-MMMM.
066000*
066100     MOVE TM00-ORG               TO MBIOWS-MMMM-ORG.
066200     MOVE TM00-MERCHANT          TO MBIOWS-MMMM-MERCHANT.
066300     SET MBIORO-READ-RANDOM      TO TRUE.
066400     MOVE SS08WS-CICS-FC-NOTFND  TO MBIORO-TEMP-STATUS-1.
066500*
066600     PERFORM MMMMAO-ACCESS       THRU MMMMAO-ACCESS-EXIT.
066700*
066800 Y919-READ-MMMM-EXIT.
066900     EXIT.
067000*
067100 Y920-READ-MMSM.
067200*
067300      MOVE TM00-ORG              TO MBIOWS-MMSM-ORG.
067400      MOVE TM00-MERCHANT         TO MBIOWS-MMSM-STORE.
067500      SET MBIORO-READ-RANDOM     TO TRUE.
067600      MOVE SS08WS-CICS-FC-NOTFND TO MBIORO-TEMP-STATUS-1.
067700      PERFORM MMSMAO-ACCESS      THRU MMSMAO-ACCESS-EXIT.
067800*
067900 Y939-READ-MMSM-EXIT.
068000      EXIT.
068100/
068200 Z000-COPIED-ROUTINES SECTION.
068300**********************************
068400*    JUL TO GREG DATE ROUTINE    *
068500**********************************
068600*
068700     COPY SS08PD.
068800/
068900*****************************
069000*    CHECK DIGIT ROUITNE    *
069100*****************************
069200*
069300     COPY SS09PD.
069400/
069500*********************************
069600*    LINE 24 PF KEYS ROUTINE    *
069700*********************************
069800*
069900     COPY SS15PD.
070000/
070100*********************************
070200*    JULIAN-TO-GREG  ROUTINE    *
070300*********************************
070400*
070500     COPY SS26PD.
070600/
070700*********************************
070800* NUMERICALLY EDIT TIME ROUTINE *
070900*********************************
071000*
071100     COPY SS27PD.
071200/
071300*******************************************
071400*    ORG FILE RECORD 1 ACCESS ROUTINES    *
071500*******************************************
071600*
071700     COPY MMOCAO.
071800/
071900*********************************************
072000*    MERCHANT MASTER RECORD ACCESS ROUTINES *
072100*********************************************
072200*
072300     COPY MMMMAO.
072400/
072500*********************************************
072600*    STORE MASTER RECORD ACCESS ROUTINES    *
072700*********************************************
072800*
072900     COPY MMSMAO.
073000/
073100*************************************************
073200*    TERMINATED MERCHANT RECORD ACCESS ROUTINES *
073300*************************************************
073400*
073500     COPY MMTMAO.
073600/
073700*****************************
073800*    ONLINE MAP ROUTINES    *
073900*****************************
074000*
074100     COPY MB60PD REPLACING 'MBMAPXX' BY 'MBTM00 '
074200                           MBMAPXXI BY MBTM00I
074300                           MBMAPXXO BY MBTM00O.
074400/
074500***************************
074600*    ONLINE PROCEDURES    *
074700***************************
074800*
074900     COPY MB70PD.
075000/
075100     COPY SMFTPXO.
