000100 IDENTIFICATION DIVISION.
000200 PROGRAM-ID. MBOTM01.
000201*       RELEASE DATE=08/24/01.        REVISION LEVEL=08.06      * ++++++++
000202***************************************************************** ++++++++
000203*WARNING.  THIS COMPUTER PROGRAM IS PROTECTED BY COPYRIGHT LAW  * ++++++++
000204*AND INTERNATIONAL TREATIES.  UNAUTHORIZED REPRODUCTION OR      * ++++++++
000205*DISTRIBUTION OF THIS PROGRAM, OR ANY PORTION OF IT, MAY RESULT * ++++++++
000206*IN SEVERE CIVIL AND CRIMINAL PENATLIES, AND WILL BE PROSECUTED * ++++++++
000207*TO THE MAXIMUM EXTENT POSSIBLE UNDER THE LAW.                  * ++++++++
000208*COPYRIGHT 1999 PAYSYS INTERNATIONAL, INC.  ALL RIGHTS RESERVED.* ++++++++
000209***************************************************************** ++++++++
000300*****************************************************************
000400*                                                               *
000500*   V - PLUS  M E R C H A N T   B A N K C A R D   S Y S T E M   *
000600*                                                               *
000700*      MBOTM01 - TERMINATED MERCHANTS ADD/MAINT/INQ             *
000800*                SCREEN 01                                      *
000900*                                                               *
001000*              1. TRANSID                                       *
001100*                 B. MBTM                                       *
001200*              2. MAPS USED -                                   *
001300*                 A. MBTM01 (SCREEN 01)                         *
001400*              3. FILES USED -                                  *
001500*                 A. MMTM (TERMINATED MERCHANTS FILE)           *
001600*                 B. MMMM (MERCHANT MASTER FILE)                *
001700*                 B. MMSM (STORE MASTER FILE)                   *
001800*                 C. MML1 (LOG FILE)                            *
001900*                                                               *
002000*****************************************************************
002100*
002200 ENVIRONMENT DIVISION.
002300*
002400 DATA DIVISION.
002500*
002600 WORKING-STORAGE SECTION.
002700*
002800 01  FILLER                  PIC  X(12)      VALUE '** WS-BEG **'.
002900*
003000 01  FILLER                  PIC  X(14)      VALUE
003100     'MISCELLANEOUS:'.
003200*
003300 01  WS-MISCELLANEOUS.
003400     03  WS-FIELD-POSITION   PIC S9(03)      VALUE ZEROES COMP-3.
003500*
003600 01  FILLER                  PIC  X(17)      VALUE
003700     'PROGRAM SWITCHES:'.
003800*
003900 01  WS-PROGRAM-SWITCHES.
004000     03  WS-UPDATE-SW        PIC  X(01)      VALUE 'N'.
004100         88  WS-UPDATE-SW-YES                VALUE 'Y'.
004200         88  WS-UPDATE-SW-NO                 VALUE 'N'.
004300     03  WS-INDEX-X.
004400         05  WS-INDEX        PIC  9(04)      VALUE ZEROS.
004500/
004600 01  FILLER                  PIC  X(29)      VALUE
004700     'I/O REQUEST BLOCK WORK AREAS:'.
004800*
004900     COPY MBIOWS.
005000/
005100 01  FILLER                  PIC  X(18)      VALUE
005200     'I/O REQUEST BLOCK:'.
005300*
005400     COPY MBIORO.
005500/
005600 01  FILLER                  PIC  X(23)      VALUE
005700     'TERMINATED MERCHANT I/O'.
005800*
005900     COPY MMTMIO.
006000/
006100 01  FILLER                  PIC  X(25)      VALUE
006200     'LOG RECORD REQUEST BLOCK:'.
006300*
006400     COPY MML1WS REPLACING ==:MML1:== BY ==MML1==.
006500/
006600 01  FILLER                  PIC  X(20)      VALUE
006700     'CCS DATE WORK AREAS:'.
006800*
006900     COPY SS01WS.
007000/
007100 01  FILLER                  PIC  X(15)      VALUE
007200     'CCS WORK AREAS:'.
007300*
007400     COPY SS08WS.
007500/
007600     COPY SS00WS.
007700/
007800     COPY SMFTWS.
007900/
008000     COPY SMPTRL REPLACING ==:SMPT:== BY ==SMPT==.
008100/
008200     COPY MB61LK.
008300/
008400 01  FILLER                  PIC  X(12)      VALUE '** WS-END **'.
008500/
008600 LINKAGE SECTION.
008700*
008800 01  DFHCOMMAREA.
008900*
009000     COPY MB60WS.
009100/
009200*********************************
009300*    TERMINATED MERCHANT MAP    *
009400*********************************
009500*
009600     COPY MBTM01.
009700/
009800**********************************************
009900*    TERMINATED MERCHANT MAP REDEFINITION    *
010000**********************************************
010100*
010200     COPY MBTM01R.
010300/
010400******************************************
010500*    TERMINATED MECHANT RECORD LAYOUT    *
010600******************************************
010700*
010800     COPY MMTMRL.
010900/
011000******************************************
011100*    MERCHANT MASTER    RECORD LAYOUT    *
011200******************************************
011300*
011400     COPY MMMMRL.
011500/
011600******************************************
011700*    STORE MASTER    RECORD LAYOUT       *
011800******************************************
011900*
012000     COPY MMSMRL.
012100/
012200***************************
012300*    LOG RECORD LAYOUT    *
012400***************************
012500*
012600     COPY MML1RL REPLACING ==:MML1:== BY ==MML1==.
012700/
012800 PROCEDURE DIVISION.
012900*
013000 A000-HOUSEKEEPING SECTION.
013100*
013200 A020-INIT.
013300*
013400     MOVE 'PC01'                 TO MBCA-PROGRAM-LOCATION.
013500     PERFORM MB70PD-ON-LINE-HOUSEKEEPING
013600                                 THRU MB70PD-OLH-EXIT.
013700*
013800     IF  MBCA-RECEIVE-SCREEN
013900         GO TO C000-RECEIVE-SCREEN.
014000/
014100 B000-SEND-SCREEN SECTION.
014200*
014300*********************************************
014400*    GET CICS STORAGE NEEDED FOR THE MAP    *
014500*********************************************
014600*
014700     MOVE 'SC01'                 TO MBCA-PROGRAM-LOCATION.
014800     PERFORM MB60PD-GETMAIN-FOR-MAP
014900                                 THRU MB60PD-GFM-EXIT.
015000*
015100*******************************************
015200*    INITIALIZE THE STANDARD MAP LINES    *
015300*******************************************
015400*
015500     PERFORM MB60PD-INIT-STD-MAP-LINES
015600                                 THRU MB60PD-ISML-EXIT.
015700*
015800********************************************************
015900*    READ THE TERMINATED MERCHANT RECORD FOR           *
016000*    SUBSEQUENT DISPLAY.                               *
016100********************************************************
016200*
016300     MOVE MBCA-MERCHANT-ORG      TO MBIOWS-MMTM-ORG.
016400     MOVE MBCA-MERCHANT          TO MBIOWS-MMTM-MERCHANT.
016500     MOVE MBCA-S-M               TO MBIOWS-MMTM-FILE-TYPE.
016600     MOVE MBCA-ACTION-CODE       TO MBIOWS-MMTM-ACTION-CODE.
016700*
016800     MOVE 'FC01'                 TO MBCA-PROGRAM-LOCATION.
016900     SET MBIORO-READ-RANDOM      TO TRUE.
017000     PERFORM MMTMAO-ACCESS       THRU MMTMAO-ACCESS-EXIT.
017100*
017200********************************************************
017300*    READ THE STORE OR MERCHANT RECORD FOR             *
017400*    DEPENDING ON THE STORE MERCHANT FLAG              *
017500********************************************************
017600*
017700     IF  MBCA-MBTM-FUNCTION-ADD
017800         IF  MBCA-S-M IS EQUAL TO 'M'
017900             MOVE MBCA-MERCHANT-ORG
018000                                 TO MBIOWS-MMMM-ORG
018100             MOVE MBCA-MERCHANT  TO MBIOWS-MMMM-MERCHANT
018200             MOVE 'FC02'         TO MBCA-PROGRAM-LOCATION
018300             SET MBIORO-READ-RANDOM
018400                                 TO TRUE
018500             PERFORM MMMMAO-ACCESS
018600                                 THRU MMMMAO-ACCESS-EXIT
018700             MOVE MMMM-NA-LINE (1 1)
018800                                 TO TM01-NAME
018900             MOVE MMMM-NA-LINE (1 2)
019000                                 TO TM01-ADDR-1
019100             MOVE MMMM-NA-LINE (1 3)
019200                                 TO TM01-ADDR-2
019300             MOVE MMMM-DBA-CITY  TO TM01-CITY
019400             MOVE MMMM-STATE-CODE (1)
019500                                 TO TM01-ST-PROV
019600             MOVE MMMM-COUNTRY-CODE (1)
019700                                 TO TM01-COUNTRY
019800             MOVE MMMM-POSTAL-CODE (1)
019900                                 TO TM01-POST-CD
020000             MOVE MMMM-PHONE (1) TO TM01-PHONE
020100             MOVE MMMM-TAX-ID    TO TM01-FED-TAX
020110             MOVE MMTM-CATEGORY-CODE                              FX800009
020120                                 TO TM01-CAT-CODE                 FX800009
020200             MOVE MMMM-DBA-NAME  TO TM01-DBA
020210             MOVE MMMM-DATE-OPENED                                FX800016
020212                                 TO MMTM-DATE-OPENED              FX800016
020214             MOVE DFHBMUNF       TO TM01-DATE-OPEN-A              FX800016
020216             MOVE MMMM-DATE-CLOSED                                FX800016
020218                                 TO MMTM-DATE-CLOSED              FX800016
020220             MOVE DFHBMUNF       TO TM01-DATE-CLS-A               FX800016
020240             EVALUATE TRUE                                        FX800016
020242                 WHEN MMMM-SINGLE-STORE-YES                       FX800016
020250                     MOVE MMMM-ORG                                FX800016
020252                                 TO MBIOWS-MMSM-ORG               FX800016
020254                     MOVE MMMM-STORE-NBR                          FX800016
020256                                 TO MBIOWS-MMSM-STORE             FX800016
020258                     MOVE 'FC29' TO MBCA-PROGRAM-LOCATION         FX800016
020260                     SET MBIORO-READ-RANDOM                       FX800016
020262                                 TO TRUE                          FX800016
020264                     PERFORM MMSMAO-ACCESS                        FX800016
020266                        THRU MMSMAO-ACCESS-EXIT                   FX800016
020268                     IF  MMSM-MC-CH-TERM-IND-NOT-USED             FX800016
020270                         MOVE 'N'                                 FX800016
020272                                 TO MMTM-CH-ACT-TERM-IND          FX800016
020274                     ELSE                                         FX800016
020276                         MOVE 'Y'                                 FX800016
020278                                 TO MMTM-CH-ACT-TERM-IND          FX800016
020280                     END-IF                                       FX800016
020282                     MOVE DFHBMFSE                                FX800016
020284                                 TO TM01-CH-ACT-TERM-A            FX800016
020286                     MOVE MMSM-MC-CATEGORY-CODE                   FX800016
020288                                 TO MMTM-CATEGORY-CODE            FX800016
020290                     MOVE DFHBMFSE                                FX800016
020292                                 TO TM01-CAT-CODE-A               FX800016
020294             END-EVALUATE                                         FX800016
020300         ELSE
020400             MOVE MBCA-MERCHANT-ORG
020500                                 TO MBIOWS-MMSM-ORG
020600             MOVE MBCA-MERCHANT  TO MBIOWS-MMSM-STORE
020700             MOVE 'FC03'         TO MBCA-PROGRAM-LOCATION
020800             SET MBIORO-READ-RANDOM
020900                                 TO TRUE
021000             PERFORM MMSMAO-ACCESS
021100                                 THRU MMSMAO-ACCESS-EXIT
021200             MOVE MMSM-NA-LINE (1 1)
021300                                 TO TM01-NAME
021400             MOVE MMSM-NA-LINE (1 2)
021500                                 TO TM01-ADDR-1
021600             MOVE MMSM-NA-LINE (1 3)
021700                                 TO TM01-ADDR-2
021800             MOVE MMSM-DBA-CITY  TO TM01-CITY
021900             MOVE MMSM-STATE-CODE (1)
022000                                 TO TM01-ST-PROV
022100             MOVE MMSM-COUNTRY-CODE (1)
022200                                 TO TM01-COUNTRY
022300             MOVE MMSM-POSTAL-CODE (1)
022400                                 TO TM01-POST-CD
022500             MOVE MMSM-PHONE (1) TO TM01-PHONE
022600             MOVE MMSM-MC-DBA-NAME
022700                                 TO TM01-DBA
022710             MOVE MMSM-MC-CATEGORY-CODE                           FX800009
022720                                 TO TM01-CAT-CODE                 FX800009
022800             MOVE MMSM-TAX-ID    TO TM01-FED-TAX
022810             MOVE MMSM-DATE-OPENED                                FX800016
022812                                 TO MMTM-DATE-OPENED              FX800016
022814             MOVE DFHBMUNF       TO TM01-DATE-OPEN-A              FX800016
022816             MOVE MMSM-DATE-CLOSED                                FX800016
022818                                 TO MMTM-DATE-CLOSED              FX800016
022820             MOVE DFHBMUNF       TO TM01-DATE-CLS-A               FX800016
022822             IF  MMSM-MC-CH-TERM-IND-NOT-USED                     FX800016
022824                 MOVE 'N'        TO MMTM-CH-ACT-TERM-IND          FX800016
022826             ELSE                                                 FX800016
022828                 MOVE 'Y'        TO MMTM-CH-ACT-TERM-IND          FX800016
022830             END-IF                                               FX800016
022832             MOVE DFHBMFSE       TO TM01-CH-ACT-TERM-A            FX800016
022834             MOVE MMSM-MC-CATEGORY-CODE                           FX800016
022836                                 TO MMTM-CATEGORY-CODE            FX800016
022838             MOVE DFHBMFSE       TO TM01-CAT-CODE-A               FX800016
022900     ELSE
023000         MOVE MMTM-NAME-LINE-1   TO TM01-NAME
023100         MOVE MMTM-ADDR-LINE-1   TO TM01-ADDR-1
023200         MOVE MMTM-ADDR-LINE-2   TO TM01-ADDR-2
023300         MOVE MMTM-CITY          TO TM01-CITY
023400         MOVE MMTM-STATE-PROV    TO TM01-ST-PROV
023500         MOVE MMTM-COUNTRY-CODE  TO TM01-COUNTRY
023600         MOVE MMTM-POSTAL-CODE   TO TM01-POST-CD
023700         MOVE MMTM-FED-TAX-ID    TO TM01-FED-TAX
023800         MOVE MMTM-DBA-NAME      TO TM01-DBA
023900         MOVE MMTM-PHONE         TO TM01-PHONE.
024000*
024100 B020-MOVE-FIELDS-TO-SCREEN.
024200*
024300*********************************************
024400*    MOVE THE TERMINATED MERCHANT FIELDS    *
024500*    FROM THE RECORD TO THE SCREEN          *
024600*********************************************
024700*
024800     MOVE MMTM-ORG               TO TM01-ORG.
024900     MOVE MMTM-MERCHANT          TO TM01-MERCHANT.
025000     MOVE MMTM-LAST-MAINT-DATE   TO SS01WS-JULIAN.
025100     PERFORM SS26PD-NUMERICALLY-EDIT-DATE
025200        THRU SS26PD-NED-EXIT.
025300     MOVE SS01WS-XX-XX-YYYY      TO TM01-LMAINT-DATE.
025400     MOVE MMTM-LAST-MAINT-OPER   TO TM01-LMAINT-OPR.
025500     MOVE 'ADD'                  TO TM01-ACTION.
025600     MOVE DFHBMASK               TO TM01-ACTION-A.
025700     MOVE MMTM-REASON-CODE       TO TM01-REASON.
025800     MOVE MMTM-DATE-OPENED       TO SS01WS-JULIAN.
025900     PERFORM SS08PD-JUL-TO-GREG THRU SS08PD-JTG-EXIT.
026000     MOVE SS01WS-DATE            TO TM01-DATE-OPEN.
026100*                                                                 FX800009
026200     MOVE MMTM-DATE-CLOSED       TO SS01WS-JULIAN.
026300     PERFORM SS08PD-JUL-TO-GREG THRU SS08PD-JTG-EXIT.
026400     MOVE SS01WS-DATE            TO TM01-DATE-CLS.
026500     MOVE MMTM-CH-ACT-TERM-IND   TO TM01-CH-ACT-TERM.
026600     MOVE MMTM-STATE-TAX-ID      TO TM01-ST-TAX.
026700*
026800     PERFORM VARYING
026900         X-MMTM-COMMENTS FROM 1 BY 1
027000         UNTIL X-MMTM-COMMENTS IS GREATER THAN 4
027100         SET X-TM01-COMMENTS     TO X-MMTM-COMMENTS
027200         MOVE MMTM-COMMENTS (X-MMTM-COMMENTS)
027300                                 TO
027400                                 TM01-COMMENTS (X-TM01-COMMENTS)
027500     END-PERFORM.
027600*
027700 B100-SEND-MAP.
027800*
027900     MOVE SS08WS-CURSOR          TO TM01-REASON-L.
028000     COMPUTE MBCA-SCREEN-NBR     =  MBCA-SCREEN-NBR - 50.
028100*
028200**********************
028300*    SEND THE MAP    *
028400**********************
028500*
028600     MOVE DFHBMASK               TO TM01-CURRENT-PAGE-A.
028700*
028800     MOVE 'BM01'                 TO MBCA-PROGRAM-LOCATION.
028900     PERFORM MB60PD-SEND-MAP-WITH-ERASE
029000                                 THRU MB60PD-SMWE-EXIT.
029100*
029200************************
029300*    RETURN TO CICS    *
029400************************
029500*
029600     MOVE 'PC02'                 TO MBCA-PROGRAM-LOCATION.
029700     PERFORM MB70PD-RETURN-TRANS-ID
029800                                 THRU MB70PD-RTI-EXIT.
029900/
030000 C000-RECEIVE-SCREEN SECTION.
030100*
030200******************************************
030300*    THIS SECTION RECEIVES THE SCREEN    *
030400******************************************
030500*
030600     MOVE 'BM02'                 TO MBCA-PROGRAM-LOCATION.
030700     PERFORM MB60PD-RECEIVE-MAP  THRU MB60PD-RM-EXIT.
030800*
030900**************************************************************
031000*    CHECK FOR ANOTHER TRANSACTION ID ENTERED BY THE USER    *
031100**************************************************************
031200*
031300     MOVE 'PC03'                 TO MBCA-PROGRAM-LOCATION.
031400     PERFORM MB60PD-NEW-TRANS-ROUTINE
031500                                 THRU MB60PD-NTR-EXIT.
031600*
031700*********************************************
031800*    READ THE TERMINATED MERCHANT RECORD    *
031900*********************************************
032000*
032100     MOVE MBCA-MERCHANT-ORG      TO MBIOWS-MMTM-ORG
032200                                    TM01-ORG.
032300     MOVE MBCA-MERCHANT          TO MBIOWS-MMTM-MERCHANT
032400                                    TM01-MERCHANT.
032500     MOVE MBCA-S-M               TO MBIOWS-MMTM-FILE-TYPE.
032600     MOVE MBCA-ACTION-CODE       TO MBIOWS-MMTM-ACTION-CODE.
032700     MOVE 'FC04'                 TO MBCA-PROGRAM-LOCATION.
032800     SET MBIORO-READ-RANDOM      TO TRUE.
032900     PERFORM MMTMAO-ACCESS       THRU MMTMAO-ACCESS-EXIT.
033000*
033100********************************************************
033200*    READ THE STORE OR MERCHANT RECORD FOR             *
033300*    DEPENDING ON THE STORE MERCHANT FLAG              *
033400********************************************************
033500*
033600     IF  MBCA-S-M IS EQUAL TO 'M'
033700         MOVE MBCA-MERCHANT-ORG  TO MBIOWS-MMMM-ORG
033800         MOVE MBCA-MERCHANT      TO MBIOWS-MMMM-MERCHANT
033900         MOVE 'FC05'             TO MBCA-PROGRAM-LOCATION
034000         SET MBIORO-READ-RANDOM  TO TRUE
034100         PERFORM MMMMAO-ACCESS   THRU MMMMAO-ACCESS-EXIT
034200     ELSE
034300         MOVE MBCA-MERCHANT-ORG  TO MBIOWS-MMSM-ORG
034400         MOVE MBCA-MERCHANT      TO MBIOWS-MMSM-STORE
034500         MOVE 'FC06'             TO MBCA-PROGRAM-LOCATION
034600         SET MBIORO-READ-RANDOM  TO TRUE
034700         PERFORM MMSMAO-ACCESS   THRU MMSMAO-ACCESS-EXIT.
034800*
034900***********************************************************
035000*    MOVE THE LAST MAINT DATE AND LAST MAINT OPERATOR,    *
035100*    DEPENDING ON THE FUNCTION                            *
035200***********************************************************
035300*
035400     MOVE MMTM-LAST-MAINT-DATE   TO SS01WS-JULIAN.
035500     PERFORM SS26PD-NUMERICALLY-EDIT-DATE
035600       THRU SS26PD-NED-EXIT.
035700     MOVE SS01WS-XX-XX-YYYY      TO TM01-LMAINT-DATE.
035800     MOVE MMTM-LAST-MAINT-OPER   TO TM01-LMAINT-OPR.
035900*
036000*********************
036100*    FIELD EDITS    *
036200*********************
036300*
036400 C010-EDIT-ACTION-CODE.
036500*
036600     MOVE DFHBMASK               TO TM01-ACTION-A.
036700     SET  TM01-ACTION-ADD        TO TRUE.
036800*
036900 C030-EDIT-REASON-CODE.
037000*
037100     MOVE DFHBMDAS               TO TM01-REASON-LP-A
037200                                    TM01-REASON-RP-A.
037300     MOVE DFHBMASK               TO TM01-REASON-A.
037400*
037500     IF  TM01-REASON-L IS LESS THAN 1
037600         MOVE MMTM-REASON-CODE   TO TM01-REASON
037700     ELSE
037800         MOVE DFHBMASF           TO TM01-REASON-A.
037900*
038000     IF  TM01-REASON IS NOT NUMERIC
038100     OR  TM01-REASON IS EQUAL TO ZEROS
038200         SET SS08WS-ERROR-SW-YES TO TRUE
038300         MOVE SS08WS-CURSOR      TO TM01-REASON-L
038400         MOVE DFHBMASB           TO TM01-REASON-LP-A
038500                                    TM01-REASON-RP-A
038600         MOVE DFHBMUBF           TO TM01-REASON-A.
038700*
038800 C050-EDIT-DBA-NAME.
038900*
039000     MOVE DFHBMDAS               TO TM01-DBA-LP-A
039100                                    TM01-DBA-RP-A.
039200     MOVE DFHBMASK               TO TM01-DBA-A.
039300*
039400     IF  TM01-DBA-L IS LESS THAN 1
039500         IF  MBCA-MBTM-FUNCTION-ADD
039600             IF  MBCA-S-M IS EQUAL TO 'S'
039700                 MOVE MMSM-MC-DBA-NAME
039800                                 TO TM01-DBA
039900                 MOVE DFHBMASF   TO TM01-DBA-A
040000                 MOVE 1          TO TM01-DBA-L
040100             ELSE
040200                 MOVE MMMM-DBA-NAME
040300                                 TO TM01-DBA
040400                 MOVE DFHBMASF   TO TM01-DBA-A
040500                 MOVE 1          TO TM01-DBA-L
040600         ELSE
040700             MOVE MMTM-DBA-NAME
040800                                 TO TM01-DBA
040900     ELSE
041000         MOVE DFHBMASF           TO TM01-DBA-A.
041100*
041200     IF  TM01-DBA IS EQUAL TO SPACES
041300         SET SS08WS-ERROR-SW-YES TO TRUE
041400         MOVE SS08WS-CURSOR      TO TM01-DBA-L
041500         MOVE DFHBMASB           TO TM01-DBA-LP-A
041600                                    TM01-DBA-RP-A
041700         MOVE DFHBMUBF           TO TM01-DBA-A.
041800*
041900 C070-EDIT-NAME.
042000*
042100     MOVE DFHBMDAS               TO TM01-NAME-LP-A
042200                                    TM01-NAME-RP-A.
042300     MOVE DFHBMASK               TO TM01-NAME-A.
042400*
042500     IF  TM01-NAME-L IS LESS THAN 1
042600         IF  MBCA-MBTM-FUNCTION-ADD
042700             IF  MBCA-S-M IS EQUAL TO 'S'
042800                 MOVE MMSM-NA-LINE (1 1)
042900                                 TO TM01-NAME
043000                 MOVE DFHBMASF   TO TM01-NAME-A
043100                 MOVE 1          TO TM01-NAME-L
043200             ELSE
043300                 MOVE MMMM-NA-LINE (1 1)
043400                                 TO TM01-NAME
043500                 MOVE DFHBMASF   TO TM01-NAME-A
043600                 MOVE 1          TO TM01-NAME-L
043700         ELSE
043800             MOVE MMTM-NAME-LINE-1
043900                                 TO TM01-NAME
044000     ELSE
044100         MOVE DFHBMASF           TO TM01-NAME-A.
044200*
044300     IF  TM01-NAME IS EQUAL TO SPACES
044400         SET SS08WS-ERROR-SW-YES TO TRUE
044500         MOVE SS08WS-CURSOR      TO TM01-NAME-L
044600         MOVE DFHBMASB           TO TM01-NAME-LP-A
044700                                    TM01-NAME-RP-A
044800         MOVE DFHBMUBF           TO TM01-NAME-A.
044900*
045000 C090-EDIT-ADDRESS1.
045100*
045200     MOVE DFHBMDAS               TO TM01-ADDR-1-LP-A
045300                                    TM01-ADDR-1-RP-A.
045400     MOVE DFHBMASK               TO TM01-ADDR-1-A.
045500*
045600     IF  TM01-ADDR-1-L IS LESS THAN 1
045700         IF  MBCA-MBTM-FUNCTION-ADD
045800             IF  MBCA-S-M IS EQUAL TO 'M'
045900                 MOVE MMMM-NA-LINE (1 2)
046000                                 TO TM01-ADDR-1
046100                 MOVE DFHBMASF   TO TM01-ADDR-1-A
046200                 MOVE 1          TO TM01-ADDR-1-L
046300             ELSE
046400                 MOVE MMSM-NA-LINE (1 2)
046500                                 TO TM01-ADDR-1
046600                 MOVE DFHBMASF   TO TM01-ADDR-1-A
046700                 MOVE 1          TO TM01-ADDR-1-L
046800         ELSE
046900             MOVE MMTM-ADDR-LINE-1
047000                                 TO TM01-ADDR-1
047100     ELSE
047200         MOVE DFHBMASF           TO TM01-ADDR-1-A.
047300*
047400*
047500     IF  TM01-ADDR-1 IS EQUAL TO SPACES
047600         SET SS08WS-ERROR-SW-YES TO TRUE
047700         MOVE SS08WS-CURSOR      TO TM01-ADDR-1-L
047800         MOVE DFHBMASB           TO TM01-ADDR-1-LP-A
047900                                    TM01-ADDR-1-RP-A
048000         MOVE DFHBMUBF           TO TM01-ADDR-1-A.
048100*
048200 C110-EDIT-ADDRESS2.
048300*
048400     MOVE DFHBMDAS               TO TM01-ADDR-2-LP-A
048500                                    TM01-ADDR-2-RP-A.
048600     MOVE DFHBMASK               TO TM01-ADDR-2-A.
048700*
048800     IF  TM01-ADDR-2-L IS LESS THAN 1
048900         IF  MBCA-MBTM-FUNCTION-ADD
049000             IF  MBCA-S-M IS EQUAL TO 'M'
049100                 MOVE MMMM-NA-LINE (1 3)
049200                                 TO TM01-ADDR-2
049300                 MOVE DFHBMASF   TO TM01-ADDR-2-A
049400                 MOVE 1          TO TM01-ADDR-2-L
049500             ELSE
049600                 MOVE MMSM-NA-LINE (1 3)
049700                                 TO TM01-ADDR-2
049800                 MOVE DFHBMASF   TO TM01-ADDR-2-A
049900                 MOVE 1          TO TM01-ADDR-2-L
050000         ELSE
050100             MOVE MMTM-ADDR-LINE-2
050200                                 TO TM01-ADDR-2
050300     ELSE
050400         MOVE DFHBMASF           TO TM01-ADDR-2-A.
050500*
050600 C130-EDIT-CITY.
050700*
050800     MOVE DFHBMDAS               TO TM01-CITY-LP-A
050900                                    TM01-CITY-RP-A.
051000     MOVE DFHBMASK               TO TM01-CITY-A.
051100*
051200     IF  TM01-CITY-L IS LESS THAN 1
051300         IF  MBCA-MBTM-FUNCTION-ADD
051400             IF  MBCA-S-M IS EQUAL TO 'M'
051500                 MOVE MMMM-DBA-CITY
051600                                 TO TM01-CITY
051700                 MOVE DFHBMASF   TO TM01-CITY-A
051800                 MOVE 1          TO TM01-CITY-L
051900             ELSE
052000                 MOVE MMSM-DBA-CITY
052100                                 TO TM01-CITY
052200                 MOVE DFHBMASF   TO TM01-CITY-A
052300                 MOVE 1          TO TM01-CITY-L
052400         ELSE
052500             MOVE MMTM-CITY      TO TM01-CITY
052600     ELSE
052700         MOVE DFHBMASF           TO TM01-CITY-A.
052800*
052900*
053000     IF  TM01-CITY IS EQUAL TO SPACES
053100         SET SS08WS-ERROR-SW-YES TO TRUE
053200         MOVE SS08WS-CURSOR      TO TM01-CITY-L
053300         MOVE DFHBMASB           TO TM01-CITY-LP-A
053400                                    TM01-CITY-RP-A
053500         MOVE DFHBMUBF           TO TM01-CITY-A.
053600*
053700 C150-EDIT-COUNTRY-CODE.
053800*
053900     MOVE DFHBMDAS               TO TM01-COUNTRY-LP-A
054000                                    TM01-COUNTRY-RP-A.
054100     MOVE DFHBMASK               TO TM01-COUNTRY-A.
054200*
054300     IF  TM01-COUNTRY-L IS LESS THAN 1
054400         IF  MBCA-MBTM-FUNCTION-ADD
054500             IF  MBCA-S-M IS EQUAL TO 'M'
054600                 MOVE MMMM-COUNTRY-CODE (1)
054700                                 TO TM01-COUNTRY
054800                 MOVE DFHBMASF   TO TM01-COUNTRY-A
054900                 MOVE 1          TO TM01-COUNTRY-L
055000             ELSE
055100                 MOVE MMSM-COUNTRY-CODE (1)
055200                                 TO TM01-COUNTRY
055300                 MOVE DFHBMASF   TO TM01-COUNTRY-A
055400                 MOVE 1          TO TM01-COUNTRY-L
055500         ELSE
055600             MOVE MMTM-COUNTRY-CODE
055700                                 TO TM01-COUNTRY
055800     ELSE
055900         MOVE DFHBMASF           TO TM01-COUNTRY-A.
056000*
056100*
056200     IF  TM01-COUNTRY IS EQUAL TO SPACES
056300         SET SS08WS-ERROR-SW-YES TO TRUE
056400         MOVE SS08WS-CURSOR      TO TM01-COUNTRY-L
056500         MOVE DFHBMASB           TO TM01-COUNTRY-LP-A
056600                                    TM01-COUNTRY-RP-A
056700         MOVE DFHBMUBF           TO TM01-COUNTRY-A.
056800*
056900 C170-EDIT-STATE-PROV.
057000*
057100     MOVE DFHBMDAS               TO TM01-ST-PROV-LP-A
057200                                    TM01-ST-PROV-RP-A.
057300     MOVE DFHBMASK               TO TM01-ST-PROV-A.
057400*
057500     IF  TM01-ST-PROV-L IS LESS THAN 1
057600         IF  MBCA-MBTM-FUNCTION-ADD
057700             IF  MBCA-S-M IS EQUAL TO 'M'
057800                 MOVE MMMM-STATE-CODE (1)
057900                                 TO TM01-ST-PROV
058000                 MOVE DFHBMASF   TO TM01-ST-PROV-A
058100                 MOVE 1          TO TM01-ST-PROV-L
058200             ELSE
058300                 MOVE MMSM-STATE-CODE (1)
058400                                 TO TM01-ST-PROV
058500                 MOVE DFHBMASF   TO TM01-ST-PROV-A
058600                 MOVE 1          TO TM01-ST-PROV-L
058700         ELSE
058800             MOVE MMTM-STATE-PROV
058900                                 TO TM01-ST-PROV
059000     ELSE
059100         MOVE DFHBMASF           TO TM01-ST-PROV-A.
059200*
059300*
059400     IF  TM01-ST-PROV IS EQUAL TO SPACES
059500     AND TM01-COUNTRY IS EQUAL TO 'USA'
059600         SET SS08WS-ERROR-SW-YES TO TRUE
059700         MOVE SS08WS-CURSOR      TO TM01-ST-PROV-L
059800         MOVE DFHBMASB           TO TM01-ST-PROV-LP-A
059900                                    TM01-ST-PROV-RP-A
060000         MOVE DFHBMUBF           TO TM01-ST-PROV-A.
060100*
060200 C190-EDIT-POSTAL-CODE.
060300*
060400     MOVE DFHBMDAS               TO TM01-POST-CD-LP-A
060500                                    TM01-POST-CD-RP-A.
060600     MOVE DFHBMASK               TO TM01-POST-CD-A.
060700*
060800     IF  TM01-POST-CD-L IS LESS THAN 1
060900         IF  MBCA-MBTM-FUNCTION-ADD
061000             IF  MBCA-S-M IS EQUAL TO 'M'
061100                 MOVE MMMM-POSTAL-CODE (1)
061200                                 TO TM01-POST-CD
061300                 MOVE DFHBMASF   TO TM01-POST-CD-A
061400                 MOVE 1          TO TM01-POST-CD-L
061500             ELSE
061600                 MOVE MMSM-POSTAL-CODE (1)
061700                                 TO TM01-POST-CD
061800                 MOVE DFHBMASF   TO TM01-POST-CD-A
061900                 MOVE 1          TO TM01-POST-CD-L
062000         ELSE
062100             MOVE MMTM-POSTAL-CODE
062200                                 TO TM01-POST-CD
062300     ELSE
062400         MOVE DFHBMASF           TO TM01-POST-CD-A.
062500*
062600*
062700*
062800     IF  TM01-POST-CD IS EQUAL TO SPACES
062900     AND TM01-COUNTRY IS EQUAL TO 'USA'
063000         SET SS08WS-ERROR-SW-YES TO TRUE
063100         MOVE SS08WS-CURSOR      TO TM01-POST-CD-L
063200         MOVE DFHBMASB           TO TM01-POST-CD-LP-A
063300                                    TM01-POST-CD-RP-A
063400         MOVE DFHBMUBF           TO TM01-POST-CD-A.
063500*
063600 C210-EDIT-PHONE.
063700*
063800     MOVE DFHBMDAS               TO TM01-PHONE-LP-A
063900                                    TM01-PHONE-RP-A.
064000     MOVE DFHBMASK               TO TM01-PHONE-A.
064100*
064200     IF  TM01-PHONE-L IS LESS THAN 1
064300         IF  MBCA-MBTM-FUNCTION-ADD
064400             IF  MBCA-S-M IS EQUAL TO 'M'
064500                 MOVE MMMM-PHONE (1)
064600                                 TO TM01-PHONE
064700                 MOVE DFHBMASF   TO TM01-PHONE-A
064800                 MOVE 1          TO TM01-PHONE-L
064900             ELSE
065000                 MOVE MMSM-PHONE (1)
065100                                 TO TM01-PHONE
065200                 MOVE DFHBMASF   TO TM01-PHONE-A
065300                 MOVE 1          TO TM01-PHONE-L
065400         ELSE
065500             MOVE MMTM-PHONE     TO TM01-PHONE
065600     ELSE
065700         MOVE DFHBMASF           TO TM01-PHONE-A.
065800*
065900*
066000     IF  TM01-PHONE IS EQUAL TO SPACES
066100     AND TM01-COUNTRY IS EQUAL TO 'USA'
066200         SET SS08WS-ERROR-SW-YES TO TRUE
066300         MOVE SS08WS-CURSOR      TO TM01-PHONE-L
066400         MOVE DFHBMASB           TO TM01-PHONE-LP-A
066500                                    TM01-PHONE-RP-A
066600         MOVE DFHBMUBF           TO TM01-PHONE-A.
066700*
066800 C230-EDIT-DATE-OPENED.
066900*
067000     MOVE DFHBMDAS               TO TM01-DATE-OPEN-LP-A
067100                                    TM01-DATE-OPEN-RP-A.
067200     MOVE DFHBMASK               TO TM01-DATE-OPEN-A.
067300*
067400     IF  TM01-DATE-OPEN-L IS LESS THAN 1
067500         MOVE MMTM-DATE-OPENED   TO SS01WS-JULIAN
067600         PERFORM SS08PD-JUL-TO-GREG THRU SS08PD-JTG-EXIT
067700         MOVE SS01WS-DATE        TO TM01-DATE-OPEN
067800     ELSE
067900         MOVE DFHBMASF           TO TM01-DATE-OPEN-A.
068000*
068100     IF  TM01-DATE-OPEN IS NOT NUMERIC
068200     OR  TM01-DATE-OPEN IS EQUAL TO ZEROS
068300         GO TO C235-DATE-OPEN-ERROR.
068400*
068500     IF  TM01-DATE-OPEN IS LESS THAN 1000000
068600         MOVE TM01-DATE-OPEN     TO SS01WS-MDY
068700         MOVE SS01WS-MDYZ        TO SS01WS-DATEZ
068800     ELSE
068900         MOVE TM01-DATE-OPEN     TO SS01WS-DATE.
069000*
069100     PERFORM SS05PD-DATE-VALIDATION
069200                                 THRU SS05PD-DV-EXIT.
069300*
069400     IF  SS01WS-DATE-IS-VALID
069500         MOVE SS01WS-DATE        TO TM01-DATE-OPEN
069600         GO TO C250-EDIT-CATEGORY-CODE.
069700*
069800 C235-DATE-OPEN-ERROR.
069900*
070000     SET SS08WS-ERROR-SW-YES     TO TRUE
070100     MOVE SS08WS-CURSOR          TO TM01-DATE-OPEN-L
070200     MOVE DFHBMASB               TO TM01-DATE-OPEN-LP-A
070300                                    TM01-DATE-OPEN-RP-A
070400     MOVE DFHBMUBF               TO TM01-DATE-OPEN-A.
070500*
070600 C250-EDIT-CATEGORY-CODE.
070700*
070800     MOVE DFHBMDAS               TO TM01-CAT-CODE-LP-A
070900                                    TM01-CAT-CODE-RP-A.
071000     MOVE DFHBMASK               TO TM01-CAT-CODE-A.
071100*
071200     IF  TM01-CAT-CODE-L IS EQUAL TO ZEROS
071300         IF  MBCA-MBTM-FUNCTION-ADD
071400             IF  MBCA-S-M IS EQUAL TO 'S'
071500                 MOVE MMSM-MC-CATEGORY-CODE
071600                                 TO TM01-CAT-CODE
071700                 MOVE DFHBMASF   TO TM01-CAT-CODE-A
071800                 MOVE 1          TO TM01-CAT-CODE-L
071900             ELSE
072000                 MOVE MMTM-CATEGORY-CODE
072100                                 TO TM01-CAT-CODE
072200         ELSE
072300             MOVE MMTM-CATEGORY-CODE
072400                                 TO TM01-CAT-CODE
072500     ELSE
072600         MOVE DFHBMASF           TO TM01-CAT-CODE-A.
072700*
072800     IF  TM01-CAT-CODE IS EQUAL TO ZEROS
072900         SET SS08WS-ERROR-SW-YES TO TRUE
073000         MOVE SS08WS-CURSOR      TO TM01-CAT-CODE-L
073100         MOVE DFHBMASB           TO TM01-CAT-CODE-LP-A
073200                                    TM01-CAT-CODE-RP-A
073300         MOVE DFHBMUBF           TO TM01-CAT-CODE-A.
073400*
073500 C270-EDIT-DATE-CLOSED.
073600*
073700     MOVE DFHBMDAS               TO TM01-DATE-CLS-LP-A
073800                                    TM01-DATE-CLS-RP-A.
073900     MOVE DFHBMASK               TO TM01-DATE-CLS-A.
074000*
074100     IF  TM01-DATE-CLS-L IS LESS THAN 1
074200         MOVE MMTM-DATE-CLOSED   TO SS01WS-JULIAN
074300         PERFORM SS08PD-JUL-TO-GREG THRU SS08PD-JTG-EXIT
074400         MOVE SS01WS-DATE        TO TM01-DATE-CLS
074500     ELSE
074600         MOVE DFHBMASF           TO TM01-DATE-CLS-A.
074700*
074800     IF  TM01-DATE-CLS IS NOT NUMERIC
074900     OR  TM01-DATE-CLS IS EQUAL TO ZEROS
075000         GO TO C275-DATE-CLOSED-ERROR.
075100*
075200     IF  TM01-DATE-CLS IS LESS THAN 1000000
075300         MOVE TM01-DATE-CLS      TO SS01WS-MDY
075400         MOVE SS01WS-MDYZ        TO SS01WS-DATEZ
075500     ELSE
075600         MOVE TM01-DATE-CLS      TO SS01WS-DATE.
075700*
075800     PERFORM SS05PD-DATE-VALIDATION
075900                                 THRU SS05PD-DV-EXIT.
076000*
076100     IF  SS01WS-DATE-IS-VALID
076200         MOVE SS01WS-DATE        TO TM01-DATE-CLS
076300         MOVE TM01-DATE-CLS      TO SS01WS-DATE
076400         PERFORM SS07PD-GREG-TO-JUL
076500                                 THRU SS07PD-GTJ-EXIT
076600         IF  SS01WS-JULIAN IS GREATER THAN
076700                                 MBCA-START-DATE
076800             NEXT SENTENCE
076900         ELSE
077000             GO TO C290-EDIT-CH-ACT-TERM-IND.
077100*
077200 C275-DATE-CLOSED-ERROR.
077300*
077400     SET SS08WS-ERROR-SW-YES     TO TRUE
077500     MOVE SS08WS-CURSOR          TO TM01-DATE-CLS-L
077600     MOVE DFHBMASB               TO TM01-DATE-CLS-LP-A
077700                                    TM01-DATE-CLS-RP-A
077800     MOVE DFHBMUBF               TO TM01-DATE-CLS-A.
077900*
078000 C290-EDIT-CH-ACT-TERM-IND.
078100*
078200     MOVE DFHBMDAS               TO TM01-CH-ACT-TERM-LP-A
078300                                    TM01-CH-ACT-TERM-RP-A.
078400     MOVE DFHBMASK               TO TM01-CH-ACT-TERM-A.
078500*
078600     IF  TM01-CH-ACT-TERM-L IS LESS THAN 1
078700         MOVE MMTM-CH-ACT-TERM-IND
078800                                 TO TM01-CH-ACT-TERM
078900     ELSE
079000         MOVE DFHBMASF           TO TM01-CH-ACT-TERM-A.
079100*
079200     IF  NOT TM01-VALID-CH-ACT-TERM
079300         SET SS08WS-ERROR-SW-YES TO TRUE
079400         MOVE SS08WS-CURSOR      TO TM01-CH-ACT-TERM-L
079500         MOVE DFHBMASB           TO TM01-CH-ACT-TERM-LP-A
079600                                    TM01-CH-ACT-TERM-RP-A
079700         MOVE DFHBMUBF           TO TM01-CH-ACT-TERM-A.
079800*
079900 C310-EDIT-FED-TAX-ID.
080000*
080100     MOVE DFHBMDAS               TO TM01-FED-TAX-LP-A
080200                                    TM01-FED-TAX-RP-A.
080300     MOVE DFHBMASK               TO TM01-FED-TAX-A.
080400*
080500     IF  TM01-FED-TAX-L IS LESS THAN 1
080600         IF  MBCA-MBTM-FUNCTION-ADD
080700             IF  MBCA-S-M IS EQUAL TO 'M'
080800                 MOVE MMMM-TAX-ID
080900                                 TO TM01-FED-TAX
081000                 MOVE DFHBMASF   TO TM01-FED-TAX-A
081100                 MOVE 1          TO TM01-FED-TAX-L
081200             ELSE
081300                 MOVE MMTM-FED-TAX-ID
081400                                 TO TM01-FED-TAX
081500         ELSE
081600             MOVE MMTM-FED-TAX-ID
081700                                 TO TM01-FED-TAX
081800     ELSE
081900         MOVE DFHBMASF           TO TM01-FED-TAX-A.
082000*
082100*
082200 C330-EDIT-STATE-TAX-ID.
082300*
082400     MOVE DFHBMDAS               TO TM01-ST-TAX-LP-A
082500                                    TM01-ST-TAX-RP-A.
082600     MOVE DFHBMASK               TO TM01-ST-TAX-A.
082700*
082800     IF  TM01-ST-TAX-L IS LESS THAN 1
082900         MOVE MMTM-STATE-TAX-ID  TO TM01-ST-TAX
083000     ELSE
083100         MOVE DFHBMASF           TO TM01-ST-TAX-A.
083200*
083300     IF  TM01-COUNTRY IS NOT EQUAL TO 'USA'
083400     AND TM01-ST-TAX  IS NOT EQUAL TO SPACES
083500         SET SS08WS-ERROR-SW-YES TO TRUE
083600         MOVE SS08WS-CURSOR      TO TM01-ST-TAX-L
083700         MOVE DFHBMASB           TO TM01-ST-TAX-LP-A
083800                                    TM01-ST-TAX-RP-A
083900         MOVE DFHBMUBF           TO TM01-ST-TAX-A.
084000*
084100 C350-EDIT-COMMENTS.
084200*
084300     PERFORM
084400         VARYING X-TM01-COMMENTS
084500         FROM 1 BY 1
084600         UNTIL X-TM01-COMMENTS IS GREATER THAN 4
084700         SET X-MMTM-COMMENTS     TO X-TM01-COMMENTS
084800         MOVE DFHBMDAS           TO TM01-COMMENTS-LP-A
084900                                    (X-TM01-COMMENTS)
085000                                    TM01-COMMENTS-RP-A
085100                                    (X-TM01-COMMENTS)
085200         MOVE DFHBMASK           TO TM01-COMMENTS-A
085300                                    (X-TM01-COMMENTS)
085400         IF  TM01-COMMENTS-L (X-TM01-COMMENTS) IS LESS THAN 1
085500             MOVE MMTM-COMMENTS (X-MMTM-COMMENTS)
085600                                 TO TM01-COMMENTS
085700                                    (X-TM01-COMMENTS)
085800         ELSE
085900             MOVE DFHBMASF       TO TM01-COMMENTS-A
086000                                    (X-TM01-COMMENTS)
086100         END-IF
086200     END-PERFORM.
086300*
086400/
086500 D000-RETURN-ERRORS SECTION.
086600*
086700     IF  SS08WS-ERROR-SW-NO
086800         GO TO E000-UPDATE-FILE.
086900*
087000***************************************************************
087100*    INITIALIZE THE STANDARD MAP LINES.  IN AN ERROR          *
087200*    CONDITION, THIS ROUTINE IS PERFORMED PRIMARILY           *
087300*    TO UPDATE THE DATE AND TIME ON THE SCREEN.               *
087400***************************************************************
087500*
087600     PERFORM MB60PD-INIT-STD-MAP-LINES
087700                                 THRU MB60PD-ISML-EXIT.
087800*
087900**********************
088000*    SEND THE MAP    *
088100**********************
088200*
088300     MOVE 'BM03'                 TO MBCA-PROGRAM-LOCATION.
088400     PERFORM MB60PD-SEND-MAP-DATA-ONLY
088500                                 THRU MB60PD-SMDO-EXIT.
088600*
088700************************
088800*    RETURN TO CICS    *
088900************************
089000*
089100     MOVE 'PC04'                 TO MBCA-PROGRAM-LOCATION.
089200     PERFORM MB70PD-RETURN-TRANS-ID
089300                                 THRU MB70PD-RTI-EXIT.
089400/
089500 E000-UPDATE-FILE SECTION.
089600*
089700********************************************************
089800*    READ THE TERMINATED MERCHANT RECORD FOR UPDATE    *
089900********************************************************
090000*
090100     MOVE MMTM-RECORD            TO MMTMIO-RECORD.
090200*
090300     MOVE 'FC07'                 TO MBCA-PROGRAM-LOCATION.
090400     SET MBIORO-READ-RANDOM-UPDATE
090500                                 TO TRUE.
090600     PERFORM MMTMAO-ACCESS       THRU MMTMAO-ACCESS-EXIT.
090700*
090800*************************************
090900*    OBTAIN STORAGE FOR LOG FILE    *
091000*    RECORD IF DOING MAINTENANCE    *
091100*************************************
091200*
091300     MOVE 'SC02'                 TO MBCA-PROGRAM-LOCATION.
091400     SET MBIORO-GETMAIN          TO TRUE.
091500     PERFORM MML1AO-ACCESS       THRU MML1AO-ACCESS-EXIT.
091600*
091700*************************************************
091800*    SET UP THE COMMON PORTION OF THE RECORD    *
091900*************************************************
092000*
092100     MOVE 'TM'                   TO MML1-FILE-CODE.
092200     MOVE MBCA-MERCHANT-ORG      TO MML1-MMTM-ORG.
092300     MOVE MBCA-MERCHANT          TO MML1-MMTM-MERCHANT.
092400     MOVE MBCA-SIGNON-NAME       TO MML1-SIGNON-NAME.
092500     MOVE MBCA-TERMINAL-ID       TO MML1-TERMINAL-ID.
092600     MOVE ZEROS                  TO MML1-SOURCE-CODE.
092700     MOVE MBCA-FIELD-SECURITY    TO MML1-FIELD-SECURITY.
092800*
092900 E020-UPDATE-FIELDS.
093000*
093100     IF  TM01-REASON-L IS GREATER THAN ZERO
093200         IF  TM01-REASON IS NOT EQUAL
093300                                 TO MMTM-REASON-CODE
093400             SET WS-UPDATE-SW-YES
093500                                 TO TRUE
093600             IF  MMTM-ADD-COMPLETED
093700                 MOVE 0102       TO MML1-FIELD-CODE
093800                 MOVE ZEROS      TO MML1-FIELD-OCCURRENCE
093900                                    MML1-FIELD-OCCURRENCE-2
094000                 MOVE MML1WS-VL-02
094100                                 TO MML1-VARIABLE-LENGTH
094200                 MOVE MMTM-REASON-CODE
094300                                 TO MML1-VL02-B-DATA-9
094400                 MOVE TM01-REASON
094500                                 TO MMTM-REASON-CODE
094600                 MOVE MMTM-REASON-CODE
094700                                 TO MML1-VL02-A-DATA-9
094800                 MOVE 'FC08'     TO MBCA-PROGRAM-LOCATION
094900                 PERFORM Y910-WRITE-LOG-RECORD
095000                                 THRU Y919-WLR-EXIT
095100             ELSE
095200                 MOVE TM01-REASON
095300                                 TO MMTM-REASON-CODE.
095400*
095500     IF  TM01-DBA-L IS GREATER THAN ZERO
095600         IF  TM01-DBA IS NOT EQUAL
095700                                 TO MMTM-DBA-NAME
095800             SET WS-UPDATE-SW-YES
095900                                 TO TRUE
096000             IF  MMTM-ADD-COMPLETED
096100                 MOVE 0103       TO MML1-FIELD-CODE
096200                 MOVE ZEROS      TO MML1-FIELD-OCCURRENCE
096300                 MOVE ZEROS      TO MML1-FIELD-OCCURRENCE-2
096400                 MOVE MML1WS-VL-30
096500                                 TO MML1-VARIABLE-LENGTH
096600                 MOVE MMTM-DBA-NAME
096700                                 TO MML1-VL30-B-DATA-X
096800                 MOVE TM01-DBA   TO MMTM-DBA-NAME
096900                 MOVE MMTM-DBA-NAME
097000                                 TO MML1-VL30-A-DATA-X
097100                 MOVE 'FC09'     TO MBCA-PROGRAM-LOCATION
097200                 PERFORM Y910-WRITE-LOG-RECORD
097300                                 THRU Y919-WLR-EXIT
097400             ELSE
097500                 MOVE TM01-DBA   TO MMTM-DBA-NAME.
097600*
097700     IF  TM01-NAME-L IS GREATER THAN ZERO
097800         IF  TM01-NAME IS NOT EQUAL
097900                                 TO MMTM-NAME-LINE-1
098000             SET WS-UPDATE-SW-YES
098100                                 TO TRUE
098200             IF  MMTM-ADD-COMPLETED
098300                 MOVE 0104       TO MML1-FIELD-CODE
098400                 MOVE ZEROS      TO MML1-FIELD-OCCURRENCE
098500                 MOVE ZEROS      TO MML1-FIELD-OCCURRENCE-2
098600                 MOVE MML1WS-VL-30
098700                                 TO MML1-VARIABLE-LENGTH
098800                 MOVE MMTM-NAME-LINE-1
098900                                 TO MML1-VL30-B-DATA-X
099000                 MOVE TM01-NAME
099100                                 TO MMTM-NAME-LINE-1
099200                 MOVE MMTM-NAME-LINE-1
099300                                 TO MML1-VL30-A-DATA-X
099400                 MOVE 'FC10'     TO MBCA-PROGRAM-LOCATION
099500                 PERFORM Y910-WRITE-LOG-RECORD
099600                                 THRU Y919-WLR-EXIT
099700             ELSE
099800                 MOVE TM01-NAME  TO MMTM-NAME-LINE-1.
099900*
100000     IF  TM01-ADDR-1-L IS GREATER THAN ZERO
100100         IF  TM01-ADDR-1 IS NOT EQUAL
100200                                 TO MMTM-ADDR-LINE-1
100300             SET WS-UPDATE-SW-YES
100400                                 TO TRUE
100500             IF  MMTM-ADD-COMPLETED
100600                 MOVE 0105       TO MML1-FIELD-CODE
100700                 MOVE ZEROS      TO MML1-FIELD-OCCURRENCE
100800                 MOVE ZEROS      TO MML1-FIELD-OCCURRENCE-2
100900                 MOVE MML1WS-VL-30
101000                                 TO MML1-VARIABLE-LENGTH
101100                 MOVE MMTM-ADDR-LINE-1
101200                                 TO MML1-VL30-B-DATA-X
101300                 MOVE TM01-ADDR-1
101400                                 TO MMTM-ADDR-LINE-1
101500                 MOVE MMTM-ADDR-LINE-1
101600                                 TO MML1-VL30-A-DATA-X
101700                 MOVE 'FC11'     TO MBCA-PROGRAM-LOCATION
101800                 PERFORM Y910-WRITE-LOG-RECORD
101900                                 THRU Y919-WLR-EXIT
102000             ELSE
102100                 MOVE TM01-ADDR-1
102200                                 TO MMTM-ADDR-LINE-1.
102300*
102400     IF  TM01-ADDR-2-L IS GREATER THAN ZERO
102500         IF  TM01-ADDR-2 IS NOT EQUAL
102600                                 TO MMTM-ADDR-LINE-2
102700             SET WS-UPDATE-SW-YES
102800                                 TO TRUE
102900             IF  MMTM-ADD-COMPLETED
103000                 MOVE 0106       TO MML1-FIELD-CODE
103100                 MOVE ZEROS      TO MML1-FIELD-OCCURRENCE
103200                 MOVE ZEROS      TO MML1-FIELD-OCCURRENCE-2
103300                 MOVE MML1WS-VL-30
103400                                 TO MML1-VARIABLE-LENGTH
103500                 MOVE MMTM-ADDR-LINE-2
103600                                 TO MML1-VL30-B-DATA-X
103700                 MOVE TM01-ADDR-2
103800                                 TO MMTM-ADDR-LINE-2
103900                 MOVE MMTM-ADDR-LINE-2
104000                                 TO MML1-VL30-A-DATA-X
104100                 MOVE 'FC12'     TO MBCA-PROGRAM-LOCATION
104200                 PERFORM Y910-WRITE-LOG-RECORD
104300                                 THRU Y919-WLR-EXIT
104400             ELSE
104500                 MOVE TM01-ADDR-2
104600                                 TO MMTM-ADDR-LINE-2.
104700*
104800     IF  TM01-CITY-L IS GREATER THAN ZERO
104900         IF  TM01-CITY IS NOT EQUAL
105000                                 TO MMTM-CITY
105100             SET WS-UPDATE-SW-YES
105200                                 TO TRUE
105300             IF  MMTM-ADD-COMPLETED
105400                 MOVE 0107       TO MML1-FIELD-CODE
105500                 MOVE ZEROS      TO MML1-FIELD-OCCURRENCE
105600                 MOVE ZEROS      TO MML1-FIELD-OCCURRENCE-2
105700                 MOVE MML1WS-VL-20
105800                                 TO MML1-VARIABLE-LENGTH
105900                 MOVE MMTM-CITY  TO MML1-VL20-B-DATA-X
106000                 MOVE TM01-CITY  TO MMTM-CITY
106100                 MOVE MMTM-CITY  TO MML1-VL20-A-DATA-X
106200                 MOVE 'FC13'     TO MBCA-PROGRAM-LOCATION
106300                 PERFORM Y910-WRITE-LOG-RECORD
106400                                 THRU Y919-WLR-EXIT
106500             ELSE
106600                 MOVE TM01-CITY  TO MMTM-CITY.
106700*
106800     IF  TM01-ST-PROV-L IS GREATER THAN ZERO
106900         IF  TM01-ST-PROV IS NOT EQUAL
107000                                 TO MMTM-STATE-PROV
107100             SET WS-UPDATE-SW-YES
107200                                 TO TRUE
107300             IF  MMTM-ADD-COMPLETED
107400                 MOVE 0108       TO MML1-FIELD-CODE
107500                 MOVE ZEROS      TO MML1-FIELD-OCCURRENCE
107600                 MOVE ZEROS      TO MML1-FIELD-OCCURRENCE-2
107700                 MOVE MML1WS-VL-02
107800                                 TO MML1-VARIABLE-LENGTH
107900                 MOVE MMTM-STATE-PROV
108000                                 TO MML1-VL02-B-DATA-X
108100                 MOVE TM01-ST-PROV
108200                                 TO MMTM-STATE-PROV
108300                 MOVE MMTM-STATE-PROV
108400                                 TO MML1-VL02-A-DATA-X
108500                 MOVE 'FC14'     TO MBCA-PROGRAM-LOCATION
108600                 PERFORM Y910-WRITE-LOG-RECORD
108700                                 THRU Y919-WLR-EXIT
108800             ELSE
108900                 MOVE TM01-ST-PROV
109000                                 TO MMTM-STATE-PROV.
109100*
109200     IF  TM01-COUNTRY-L IS GREATER THAN ZERO
109300         IF  TM01-COUNTRY IS NOT EQUAL
109400                                 TO MMTM-COUNTRY-CODE
109500             SET WS-UPDATE-SW-YES
109600                                 TO TRUE
109700             IF  MMTM-ADD-COMPLETED
109800                 MOVE 0109       TO MML1-FIELD-CODE
109900                 MOVE ZEROS      TO MML1-FIELD-OCCURRENCE
110000                 MOVE ZEROS      TO MML1-FIELD-OCCURRENCE-2
110100                 MOVE MML1WS-VL-03
110200                                 TO MML1-VARIABLE-LENGTH
110300                 MOVE MMTM-COUNTRY-CODE
110400                                 TO MML1-VL03-B-DATA-X
110500                 MOVE TM01-COUNTRY
110600                                 TO MMTM-COUNTRY-CODE
110700                 MOVE MMTM-COUNTRY-CODE
110800                                 TO MML1-VL03-A-DATA-X
110900                 MOVE 'FC15'     TO MBCA-PROGRAM-LOCATION
111000                 PERFORM Y910-WRITE-LOG-RECORD
111100                                 THRU Y919-WLR-EXIT
111200             ELSE
111300                 MOVE TM01-COUNTRY
111400                                 TO MMTM-COUNTRY-CODE.
111500*
111600     IF  TM01-POST-CD-L IS GREATER THAN ZERO
111700         IF  TM01-POST-CD IS NOT EQUAL
111800                                 TO MMTM-POSTAL-CODE
111900             SET WS-UPDATE-SW-YES
112000                                 TO TRUE
112100             IF  MMTM-ADD-COMPLETED
112200                 MOVE 0110       TO MML1-FIELD-CODE
112300                 MOVE ZEROS      TO MML1-FIELD-OCCURRENCE
112400                 MOVE ZEROS      TO MML1-FIELD-OCCURRENCE-2
112500                 MOVE MML1WS-VL-10
112600                                 TO MML1-VARIABLE-LENGTH
112700                 MOVE MMTM-POSTAL-CODE
112800                                 TO MML1-VL10-B-DATA-X
112900                 MOVE TM01-POST-CD
113000                                 TO MMTM-POSTAL-CODE
113100                 MOVE MMTM-POSTAL-CODE
113200                                 TO MML1-VL10-A-DATA-X
113300                 MOVE 'FC16'     TO MBCA-PROGRAM-LOCATION
113400                 PERFORM Y910-WRITE-LOG-RECORD
113500                                 THRU Y919-WLR-EXIT
113600             ELSE
113700                 MOVE TM01-POST-CD
113800                                 TO MMTM-POSTAL-CODE.
113900*
114000     IF  TM01-PHONE-L IS GREATER THAN ZERO
114100         IF  TM01-PHONE IS NOT EQUAL
114200                                 TO MMTM-PHONE
114300             SET WS-UPDATE-SW-YES
114400                                 TO TRUE
114500             IF  MMTM-ADD-COMPLETED
114600                 MOVE 0111       TO MML1-FIELD-CODE
114700                 MOVE ZEROS      TO MML1-FIELD-OCCURRENCE
114800                 MOVE ZEROS      TO MML1-FIELD-OCCURRENCE-2
114900                 MOVE MML1WS-VL-10
115000                                 TO MML1-VARIABLE-LENGTH
115100                 MOVE MMTM-PHONE TO MML1-VL10-B-DATA-X
115200                 MOVE TM01-PHONE TO MMTM-PHONE
115300                 MOVE MMTM-PHONE TO MML1-VL10-A-DATA-X
115400                 MOVE 'FC17'     TO MBCA-PROGRAM-LOCATION
115500                 PERFORM Y910-WRITE-LOG-RECORD
115600                                 THRU Y919-WLR-EXIT
115700             ELSE
115800                 MOVE TM01-PHONE TO MMTM-PHONE.
115900*
116000     IF  TM01-DATE-OPEN-L IS GREATER THAN ZERO
116100         MOVE TM01-DATE-OPEN     TO SS01WS-DATE
116200         PERFORM SS07PD-GREG-TO-JUL
116300                                 THRU SS07PD-GTJ-EXIT
116400         IF  SS01WS-JULIAN IS NOT EQUAL
116500                                 TO MMTM-DATE-OPENED
116600             SET WS-UPDATE-SW-YES
116700                                 TO TRUE
116800             IF  MMTM-ADD-COMPLETED
116900                 MOVE 0112       TO MML1-FIELD-CODE
117000                 MOVE ZEROS      TO MML1-FIELD-OCCURRENCE
117100                 MOVE ZEROS      TO MML1-FIELD-OCCURRENCE-2
117200                 MOVE MML1WS-VL-07
117300                                 TO MML1-VARIABLE-LENGTH
117400                 MOVE MMTM-DATE-OPENED
117500                                 TO MML1-VL07-B-DATA-9
117600                 MOVE SS01WS-JULIAN
117700                                 TO MMTM-DATE-OPENED
117800                 MOVE MMTM-DATE-OPENED
117900                                 TO MML1-VL07-A-DATA-9
118000                 MOVE 'FC18'     TO MBCA-PROGRAM-LOCATION
118100                 PERFORM Y910-WRITE-LOG-RECORD
118200                                 THRU Y919-WLR-EXIT
118300             ELSE
118400                 MOVE SS01WS-JULIAN
118500                                 TO MMTM-DATE-OPENED.
118600*
118700     IF  TM01-CAT-CODE-L IS GREATER THAN ZERO
118800         IF  TM01-CAT-CODE IS NOT EQUAL
118900                                 TO MMTM-CATEGORY-CODE
119000             SET WS-UPDATE-SW-YES
119100                                 TO TRUE
119200             IF  MMTM-ADD-COMPLETED
119300                 MOVE 0113       TO MML1-FIELD-CODE
119400                 MOVE ZEROS      TO MML1-FIELD-OCCURRENCE
119500                 MOVE ZEROS      TO MML1-FIELD-OCCURRENCE-2
119600                 MOVE MML1WS-VL-04
119700                                 TO MML1-VARIABLE-LENGTH
119800                 MOVE MMTM-CATEGORY-CODE
119900                                 TO MML1-VL04-B-DATA-9
120000                 MOVE TM01-CAT-CODE
120100                                 TO MMTM-CATEGORY-CODE
120200                 MOVE MMTM-CATEGORY-CODE
120300                                 TO MML1-VL04-A-DATA-9
120400                 MOVE 'FC19'     TO MBCA-PROGRAM-LOCATION
120500                 PERFORM Y910-WRITE-LOG-RECORD
120600                                 THRU Y919-WLR-EXIT
120700             ELSE
120800                 MOVE TM01-CAT-CODE
120900                                 TO MMTM-CATEGORY-CODE.
121000*
121100     IF  TM01-DATE-CLS-L IS GREATER THAN ZERO
121200         MOVE TM01-DATE-CLS      TO SS01WS-DATE
121300         PERFORM SS07PD-GREG-TO-JUL
121400                                 THRU SS07PD-GTJ-EXIT
121500         IF  SS01WS-JULIAN IS NOT EQUAL
121600                                 TO MMTM-DATE-CLOSED
121700             SET WS-UPDATE-SW-YES
121800                                 TO TRUE
121900             IF  MMTM-ADD-COMPLETED
122000                 MOVE 0114       TO MML1-FIELD-CODE
122100                 MOVE ZEROS      TO MML1-FIELD-OCCURRENCE
122200                 MOVE ZEROS      TO MML1-FIELD-OCCURRENCE-2
122300                 MOVE MML1WS-VL-07
122400                                 TO MML1-VARIABLE-LENGTH
122500                 MOVE MMTM-DATE-CLOSED
122600                                 TO MML1-VL07-B-DATA-9
122700                 MOVE SS01WS-JULIAN
122800                                 TO MMTM-DATE-CLOSED
122900                 MOVE MMTM-DATE-CLOSED
123000                                 TO MML1-VL07-A-DATA-9
123100                 MOVE 'FC20'     TO MBCA-PROGRAM-LOCATION
123200                 PERFORM Y910-WRITE-LOG-RECORD
123300                                 THRU Y919-WLR-EXIT
123400             ELSE
123500                 MOVE SS01WS-JULIAN
123600                                 TO MMTM-DATE-CLOSED.
123700*
123800     IF  TM01-CH-ACT-TERM-L IS GREATER THAN ZERO
123900         IF  TM01-CH-ACT-TERM IS NOT EQUAL
124000                                 TO MMTM-CH-ACT-TERM-IND
124100             SET WS-UPDATE-SW-YES
124200                                 TO TRUE
124300             IF  MMTM-ADD-COMPLETED
124400                 MOVE 0115       TO MML1-FIELD-CODE
124500                 MOVE ZEROS      TO MML1-FIELD-OCCURRENCE
124600                 MOVE ZEROS      TO MML1-FIELD-OCCURRENCE-2
124700                 MOVE MML1WS-VL-01
124800                                 TO MML1-VARIABLE-LENGTH
124900                 MOVE MMTM-CH-ACT-TERM-IND
125000                                 TO MML1-VL01-B-DATA-X
125100                 MOVE TM01-CH-ACT-TERM
125200                                 TO MMTM-CH-ACT-TERM-IND
125300                 MOVE MMTM-CH-ACT-TERM-IND
125400                                 TO MML1-VL01-A-DATA-X
125500                 MOVE 'FC21'     TO MBCA-PROGRAM-LOCATION
125600                 PERFORM Y910-WRITE-LOG-RECORD
125700                                 THRU Y919-WLR-EXIT
125800             ELSE
125900                 MOVE TM01-CH-ACT-TERM
126000                                 TO MMTM-CH-ACT-TERM-IND.
126100*
126200     IF  TM01-FED-TAX-L IS GREATER THAN ZERO
126300         IF  TM01-FED-TAX IS NOT EQUAL
126400                                 TO MMTM-FED-TAX-ID
126500             SET WS-UPDATE-SW-YES
126600                                 TO TRUE
126700             IF  MMTM-ADD-COMPLETED
126800                 MOVE 0116       TO MML1-FIELD-CODE
126900                 MOVE ZEROS      TO MML1-FIELD-OCCURRENCE
127000                 MOVE ZEROS      TO MML1-FIELD-OCCURRENCE-2
127100                 MOVE MML1WS-VL-10
127200                                 TO MML1-VARIABLE-LENGTH
127300                 MOVE MMTM-FED-TAX-ID
127400                                 TO MML1-VL10-B-DATA-X
127500                 MOVE TM01-FED-TAX
127600                                 TO MMTM-FED-TAX-ID
127700                 MOVE MMTM-FED-TAX-ID
127800                                 TO MML1-VL10-A-DATA-X
127900                 MOVE 'FC22'     TO MBCA-PROGRAM-LOCATION
128000                 PERFORM Y910-WRITE-LOG-RECORD
128100                                 THRU Y919-WLR-EXIT
128200             ELSE
128300                 MOVE TM01-FED-TAX
128400                                 TO MMTM-FED-TAX-ID.
128500*
128600     IF  TM01-ST-TAX-L IS GREATER THAN ZERO
128700         IF  TM01-ST-TAX IS NOT EQUAL
128800                                 TO MMTM-STATE-TAX-ID
128900             SET WS-UPDATE-SW-YES
129000                                 TO TRUE
129100             IF  MMTM-ADD-COMPLETED
129200                 MOVE 0117       TO MML1-FIELD-CODE
129300                 MOVE ZEROS      TO MML1-FIELD-OCCURRENCE
129400                 MOVE ZEROS      TO MML1-FIELD-OCCURRENCE-2
129500                 MOVE MML1WS-VL-10
129600                                 TO MML1-VARIABLE-LENGTH
129700                 MOVE MMTM-STATE-TAX-ID
129800                                 TO MML1-VL10-B-DATA-X
129900                 MOVE TM01-ST-TAX
130000                                 TO MMTM-STATE-TAX-ID
130100                 MOVE MMTM-STATE-TAX-ID
130200                                 TO MML1-VL10-A-DATA-X
130300                 MOVE 'FC23'     TO MBCA-PROGRAM-LOCATION
130400                 PERFORM Y910-WRITE-LOG-RECORD
130500                                 THRU Y919-WLR-EXIT
130600             ELSE
130700                 MOVE TM01-ST-TAX
130800                                 TO MMTM-STATE-TAX-ID.
130900*
131000     PERFORM
131100         VARYING X-TM01-COMMENTS
131200         FROM 1 BY 1
131300         UNTIL X-TM01-COMMENTS IS GREATER THAN 4
131400         SET  X-MMTM-COMMENTS    TO X-TM01-COMMENTS
131500         IF  TM01-COMMENTS-L (X-TM01-COMMENTS)
131600                                 IS GREATER THAN ZERO
131700             IF  TM01-COMMENTS (X-TM01-COMMENTS) IS NOT EQUAL
131800                                 TO MMTM-COMMENTS
131900                                    (X-MMTM-COMMENTS)
132000                 SET WS-UPDATE-SW-YES
132100                                 TO TRUE
132200                 IF  MMTM-ADD-COMPLETED
132300                     MOVE 0118   TO MML1-FIELD-CODE
132400                     SET MML1-FIELD-OCCURRENCE
132500                                 TO X-TM01-COMMENTS
132600                     MOVE ZEROS  TO MML1-FIELD-OCCURRENCE-2
132700                     MOVE MML1WS-VL-50
132800                                 TO MML1-VARIABLE-LENGTH
132900                     MOVE MMTM-COMMENTS (X-MMTM-COMMENTS)
133000                                 TO MML1-VL50-B-DATA-X
133100                     MOVE TM01-COMMENTS (X-TM01-COMMENTS)
133200                                 TO MMTM-COMMENTS
133300                                        (X-MMTM-COMMENTS)
133400                     MOVE MMTM-COMMENTS (X-MMTM-COMMENTS)
133500                                 TO MML1-VL50-A-DATA-X
133600                     MOVE 'FC24' TO MBCA-PROGRAM-LOCATION
133700                     PERFORM Y910-WRITE-LOG-RECORD
133800                                 THRU Y919-WLR-EXIT
133900                 ELSE
134000                     MOVE TM01-COMMENTS (X-TM01-COMMENTS)
134100                                 TO MMTM-COMMENTS
134200                                        (X-MMTM-COMMENTS)
134300                 END-IF
134400             END-IF
134500         END-IF
134600      END-PERFORM.
134700*
134800 E040-UPDATE-MMTM.
134900*
135000**************************************************************
135100*    WRITE A LOG RECORD TO SHOW THAT THE LAST MAINT DATE     *
135200*    AND OPERATOR HAS BEEN UPDATED IF FIELDS WERE CHANGED    *
135300*    ON THE SCREEN                                           *
135400**************************************************************
135500*
135600     IF  WS-UPDATE-SW-YES
135700         MOVE 0198               TO MML1-FIELD-CODE
135800         MOVE ZEROES             TO MML1-FIELD-OCCURRENCE
135900                                    MML1-FIELD-OCCURRENCE-2
136000         MOVE MML1WS-VL-03       TO MML1-VARIABLE-LENGTH
136100         MOVE MMTM-LAST-MAINT-OPER
136200                                 TO MML1-VL03-B-DATA-X
136300         MOVE MBCA-OPERATOR-ID   TO MMTM-LAST-MAINT-OPER
136400         MOVE MMTM-LAST-MAINT-OPER
136500                                 TO MML1-VL03-A-DATA-X
136600         MOVE 'FC25'             TO MBCA-PROGRAM-LOCATION
136700         PERFORM Y910-WRITE-LOG-RECORD
136800                                 THRU Y919-WLR-EXIT
136900         MOVE 0199               TO MML1-FIELD-CODE
137000         MOVE MML1WS-VL-07       TO MML1-VARIABLE-LENGTH
137100         MOVE MMTM-LAST-MAINT-DATE
137200                                 TO MML1-VL07-B-DATA-9
137300         MOVE MBCA-START-DATE    TO MMTM-LAST-MAINT-DATE
137400         MOVE MMTM-LAST-MAINT-DATE
137500                                 TO MML1-VL07-A-DATA-9
137600         MOVE 'FC26'             TO MBCA-PROGRAM-LOCATION
137700         PERFORM Y910-WRITE-LOG-RECORD
137800                                 THRU Y919-WLR-EXIT.
137900*
138000     IF  MMTM-ADD-PENDING
138100         MOVE MBCA-SCREEN-NBR    TO MMTM-ONLINE-STATUS.
138200*
138300****************************************************
138400*    REWRITE THE TERMINATED MERCHANT RECORD IF     *
138500*    FIELDS HAVE BEEN CHANGED ON THE SCREEN, OR    *
138600*    UNLOCK IT IF THEY HAVE NOT                    *
138700****************************************************
138800*
138900     IF  WS-UPDATE-SW-YES
139000         MOVE 'FC27'             TO MBCA-PROGRAM-LOCATION
139100         SET MBIORO-REWRITE      TO TRUE
139200         PERFORM MMTMAO-ACCESS   THRU MMTMAO-ACCESS-EXIT
139300     ELSE
139400         MOVE 'FC28'             TO MBCA-PROGRAM-LOCATION
139500         SET MBIORO-UNLOCK       TO TRUE
139600         PERFORM MMTMAO-ACCESS   THRU MMTMAO-ACCESS-EXIT.
139700/
139800 F000-SETUP-COMMAREA SECTION.
139900*
140000***************************************************************
140100*  SET UP COMMAREA FIELDS AND TRANSFER TO THE NEXT PROGRAM    *
140200***************************************************************
140300*
140400     MOVE MBCA-EIBAID            TO SS08WS-EIBAID.
140500*
140600     PERFORM MB60PD-EDIT-PAGE-NBR
140700                                 THRU MB60PD-EPN-EXIT.
140800*
140900     MOVE 53                     TO MBCA-SCREEN-NBR.
141000*
141100     IF  SS08WS-VALID-PF-KEY
141200     OR  SS08WS-EIBAID-VALID-PF-KEY
141300         SET MBCA-INITIAL-SCREEN-NBR
141400                                 TO TRUE.
141500*
141600     MOVE DFHBMASK               TO TM01-CURRENT-PAGE-A.
141700*
141800 F090-TRANSFER-XCTL.
141900*
142000     MOVE 'PC05'                 TO MBCA-PROGRAM-LOCATION.
142100     PERFORM MB70PD-XCTL-TO-MBOXCTL
142200                                 THRU MB70PD-XTM-EXIT.
142300*
142400 Y910-WRITE-LOG-RECORD.
142500*
142600     IF  MMTM-ADD-PENDING
142700         GO TO Y919-WLR-EXIT.
142800*
142900     SET MBIORO-WRITE            TO TRUE.
143000     PERFORM MML1AO-ACCESS       THRU MML1AO-ACCESS-EXIT.
143100     MOVE SPACES                 TO MML1-VARIABLE-AREA.
143200*
143300 Y919-WLR-EXIT.
143400     EXIT.
143500/
143600 Z000-COPIED-ROUTINES SECTION.
143700*
143800**********************************
143900*    JUL TO GREG DATE ROUTINE    *
144000**********************************
144100*
144200     COPY SS08PD.
144300/
144400     COPY SS26PD.
144500/
144600     COPY SS27PD.
144700/
144800**********************************
144900*    GREG TO JUL DATE ROUTINE    *
145000**********************************
145100*
145200     COPY SS07PD.
145300/
145400**********************************
145500*    DATE VALIDATION ROUTINE     *
145600**********************************
145700*
145800     COPY SS05PD.
145900/
146000*********************************
146100*    LINE 24 PF KEYS ROUTINE    *
146200*********************************
146300*
146400     COPY SS15PD.
146500/
146600****************************************************
146700*    TERMINATED MERCHANT RECORD ACCESS ROUTINES    *
146800****************************************************
146900*
147000     COPY MMTMAO.
147100/
147200****************************************************
147300*    MERCHANT MASTER RECORD ACCESS ROUTINES        *
147400****************************************************
147500*
147600     COPY MMMMAO.
147700/
147800****************************************************
147900*    STORE MASTER RECORD ACCESS ROUTINES           *
148000****************************************************
148100*
148200     COPY MMSMAO.
148300/
148400*****************************************
148500*    LOG FILE RECORD ACCESS ROUTINES    *
148600*****************************************
148700*
148800     COPY MML1AO.
148900/
149000*****************************
149100*    ONLINE MAP ROUTINES    *
149200*****************************
149300*
149400     COPY MB60PD REPLACING 'MBMAPXX' BY 'MBTM01 '
149500                           MBMAPXXI BY MBTM01I
149600                           MBMAPXXO BY MBTM01O.
149700/
149800***************************
149900*    ONLINE PROCEDURES    *
150000***************************
150100*
150200     COPY MB70PD.
150300/
150400     COPY SMFTPXO.
