000100 IDENTIFICATION DIVISION.
000200 PROGRAM-ID. MBOTM02.
000201*       RELEASE DATE=08/24/01.        REVISION LEVEL=08.06      *
000202*****************************************************************
000203*WARNING.  THIS COMPUTER PROGRAM IS PROTECTED BY COPYRIGHT LAW  *
000204*AND INTERNATIONAL TREATIES.  UNAUTHORIZED REPRODUCTION OR      *
000205*DISTRIBUTION OF THIS PROGRAM, OR ANY PORTION OF IT, MAY RESULT *
000206*IN SEVERE CIVIL AND CRIMINAL PENATLIES, AND WILL BE PROSECUTED *
000207*TO THE MAXIMUM EXTENT POSSIBLE UNDER THE LAW.                  *
000208*COPYRIGHT 1999 PAYSYS INTERNATIONAL, INC.  ALL RIGHTS RESERVED.*
000209*****************************************************************
000300*****************************************************************
000400*                                                               *
000500*   V - PLUS  M E R C H A N T   B A N K C A R D   S Y S T E M   *
000600*                                                               *
000700*      MBOTM02 - TERMINATED MERCHANTS ADD/MAINT/INQ             *
000800*                SCREEN 02                                      *
000900*                                                               *
001000*              1. TRANSID                                       *
001100*                 B. MBTM                                       *
001200*              2. MAPS USED -                                   *
001300*                 A. MBTM02 (SCREEN 02)                         *
001400*              3. FILES USED -                                  *
001500*                 A. MMTM (TERMINATED MERCHANTS FILE)           *
001600*                 B. MMMM (MERCHANT MASTER FILE)                *
001700*                 B. MMSM (STORE MASTER FILE)                   *
001800*                 C. MML1 (LOG FILE)                            *
001900*                                                               *
002000*****************************************************************
002100*
002200 ENVIRONMENT DIVISION.
002300*
002400 DATA DIVISION.
002500*
002600 WORKING-STORAGE SECTION.
002700*
002800 01  FILLER                  PIC  X(12)      VALUE '** WS-BEG **'.
002900*
003000 01  FILLER                  PIC  X(14)      VALUE
003100     'MISCELLANEOUS:'.
003200*
003300 01  WS-MISCELLANEOUS.
003400     03  WS-FIELD-POSITION   PIC S9(03)      VALUE ZEROES COMP-3.
003500*
003600 01  FILLER                  PIC  X(17)      VALUE
003700     'PROGRAM SWITCHES:'.
003800*
003900 01  WS-PROGRAM-SWITCHES.
004000     03  WS-UPDATE-SW        PIC  X(01)      VALUE 'N'.
004100         88  WS-UPDATE-SW-YES                VALUE 'Y'.
004200         88  WS-UPDATE-SW-NO                 VALUE 'N'.
004300     03  WS-INDEX-X.
004400         05  WS-INDEX        PIC  9(04)      VALUE ZEROS.
004500/
004600 01  FILLER                  PIC  X(29)      VALUE
004700     'I/O REQUEST BLOCK WORK AREAS:'.
004800*
004900     COPY MBIOWS.
005000/
005100 01  FILLER                  PIC  X(18)      VALUE
005200     'I/O REQUEST BLOCK:'.
005300*
005400     COPY MBIORO.
005500/
005600 01  FILLER                  PIC  X(23)      VALUE
005700     'TERMINATED MERCHANT I/O'.
005800*
005900     COPY MMTMIO.
006000/
006100 01  FILLER                  PIC  X(25)      VALUE
006200     'LOG RECORD REQUEST BLOCK:'.
006300*
006400     COPY MML1WS REPLACING ==:MML1:== BY ==MML1==.
006500/
006600 01  FILLER                  PIC  X(21)      VALUE
006700     'ERROR MESSAGES TABLE:'.
006800*
006900     COPY MBEMWS.
007000/
007100 01  FILLER                  PIC  X(20)      VALUE
007200     'CCS DATE WORK AREAS:'.
007300*
007400     COPY SS01WS.
007500/
007600 01  FILLER                  PIC  X(15)      VALUE
007700     'CCS WORK AREAS:'.
007800*
007900     COPY SS08WS.
008000/
008100     COPY SS00WS.
008200/
008300     COPY SMFTWS.
008400/
008500     COPY SMPTRL REPLACING ==:SMPT:== BY ==SMPT==.
008600/
008700     COPY MB61LK.
008800/
008900 01  FILLER                  PIC  X(12)      VALUE '** WS-END **'.
009000/
009100 LINKAGE SECTION.
009200*
009300 01  DFHCOMMAREA.
009400*
009500     COPY MB60WS.
009600/
009700*********************************
009800*    TERMINATED MERCHANT MAP    *
009900*********************************
010000*
010100     COPY MBTM02.
010200/
010300**********************************************
010400*    TERMINATED MERCHANT MAP REDEFINITION    *
010500**********************************************
010600*
010700     COPY MBTM02R.
010800/
010900******************************************
011000*    TERMINATED MECHANT RECORD LAYOUT    *
011100******************************************
011200*
011300     COPY MMTMRL.
011400/
011500******************************************
011600*    MERCHANT MASTER    RECORD LAYOUT    *
011700******************************************
011800*
011900     COPY MMMMRL.
012000/
012100******************************************
012200*    STORE MASTER    RECORD LAYOUT       *
012300******************************************
012400*
012500     COPY MMSMRL.
012600/
012700***************************
012800*    LOG RECORD LAYOUT    *
012900***************************
013000*
013100     COPY MML1RL REPLACING ==:MML1:== BY ==MML1==.
013200/
013300 PROCEDURE DIVISION.
013400*
013500 A000-HOUSEKEEPING SECTION.
013600*
013700 A020-INIT.
013800*
013900     MOVE 'PC01'                 TO MBCA-PROGRAM-LOCATION.
014000     PERFORM MB70PD-ON-LINE-HOUSEKEEPING
014100                                 THRU MB70PD-OLH-EXIT.
014200*
014300     IF  MBCA-RECEIVE-SCREEN
014400         GO TO C000-RECEIVE-SCREEN.
014500/
014600 B000-SEND-SCREEN SECTION.
014700*
014800*********************************************
014900*    GET CICS STORAGE NEEDED FOR THE MAP    *
015000*********************************************
015100*
015200     MOVE 'SC01'                 TO MBCA-PROGRAM-LOCATION.
015300     PERFORM MB60PD-GETMAIN-FOR-MAP
015400                                 THRU MB60PD-GFM-EXIT.
015500*
015600*******************************************
015700*    INITIALIZE THE STANDARD MAP LINES    *
015800*******************************************
015900*
016000     PERFORM MB60PD-INIT-STD-MAP-LINES
016100                                 THRU MB60PD-ISML-EXIT.
016200*
016300********************************************************
016400*    READ THE TERMINATED MERCHANT RECORD FOR           *
016500*    SUBSEQUENT DISPLAY.                               *
016600********************************************************
016700*
016800     MOVE MBCA-MERCHANT-ORG      TO MBIOWS-MMTM-ORG.
016900     MOVE MBCA-MERCHANT          TO MBIOWS-MMTM-MERCHANT.
017000     MOVE MBCA-S-M               TO MBIOWS-MMTM-FILE-TYPE.
017100     MOVE MBCA-ACTION-CODE       TO MBIOWS-MMTM-ACTION-CODE.
017200*
017300     MOVE 'FC01'                 TO MBCA-PROGRAM-LOCATION.
017400     SET MBIORO-READ-RANDOM      TO TRUE.
017500     PERFORM MMTMAO-ACCESS       THRU MMTMAO-ACCESS-EXIT.
017600*
017700********************************************************
017800*    READ THE STORE OR MERCHANT RECORD FOR             *
017900*    DEPENDING ON THE STORE MERCHANT FLAG              *
018000********************************************************
018100*
018200     IF  MBCA-MBTM-FUNCTION-ADD
018300         IF  MBCA-S-M IS EQUAL TO 'M'
018400             MOVE MBCA-MERCHANT-ORG
018500                                 TO MBIOWS-MMMM-ORG
018600             MOVE MBCA-MERCHANT  TO MBIOWS-MMMM-MERCHANT
018700             MOVE SS08WS-CICS-FC-NOTFND
018800                                 TO MBIORO-TEMP-STATUS-1
018900             MOVE 'FC02'         TO MBCA-PROGRAM-LOCATION
019000             SET MBIORO-READ-RANDOM
019100                                 TO TRUE
019200             PERFORM MMMMAO-ACCESS
019300                                 THRU MMMMAO-ACCESS-EXIT
019400             IF  SS08WS-RC-FC-NOTFND
019500                 MOVE SPACES     TO TM02-NAME
019600                                    TM02-ADDR-1
019700                                    TM02-ADDR-2
019800                                    TM02-CITY
019900                                    TM02-ST-PROV
020000                                    TM02-COUNTRY-CODE
020100                                    TM02-POST-CD
020200                                    TM02-PHONE
020300                                    TM02-DBA
020400                                    TM02-FED-TAX
020500             ELSE
020600                 MOVE MMMM-NA-LINE (1 1)
020700                                 TO TM02-NAME
020800                 MOVE MMMM-NA-LINE (1 2)
020900                                 TO TM02-ADDR-1
021000                 MOVE MMMM-NA-LINE (1 3)
021100                                 TO TM02-ADDR-2
021200                 MOVE MMMM-DBA-CITY
021300                                 TO TM02-CITY
021400                 MOVE MMMM-STATE-CODE (1)
021500                                 TO TM02-ST-PROV
021600                 MOVE MMMM-COUNTRY-CODE (1)
021700                                 TO TM02-COUNTRY-CODE
021800                 MOVE MMMM-POSTAL-CODE (1)
021900                                 TO TM02-POST-CD
022000                 MOVE MMMM-PHONE (1)
022100                                 TO TM02-PHONE
022200                 MOVE MMMM-DBA-NAME
022300                                 TO TM02-DBA
022400                 MOVE MMMM-TAX-ID
022500                                 TO TM02-FED-TAX
022600         ELSE
022700             MOVE MBCA-MERCHANT-ORG
022800                                 TO MBIOWS-MMSM-ORG
022900             MOVE MBCA-MERCHANT  TO MBIOWS-MMSM-STORE
023000             MOVE SS08WS-CICS-FC-NOTFND
023100                                 TO MBIORO-TEMP-STATUS-1
023200             MOVE 'FC03'         TO MBCA-PROGRAM-LOCATION
023300             SET MBIORO-READ-RANDOM
023400                                 TO TRUE
023500             PERFORM MMSMAO-ACCESS
023600                                 THRU MMSMAO-ACCESS-EXIT
023700             IF  SS08WS-RC-FC-NOTFND
023800                 MOVE SPACES     TO TM02-NAME
023900                                    TM02-ADDR-1
024000                                    TM02-ADDR-2
024100                                    TM02-CITY
024200                                    TM02-ST-PROV
024300                                    TM02-FED-TAX
024400                                    TM02-COUNTRY-CODE
024500                                    TM02-POST-CD
024600                                    TM02-PHONE
024700                                    TM02-DBA
024800             ELSE
024900                 MOVE MMSM-NA-LINE (1 1)
025000                                 TO TM02-NAME
025100                 MOVE MMSM-NA-LINE (1 2)
025200                                 TO TM02-ADDR-1
025300                 MOVE MMSM-NA-LINE (1 3)
025400                                 TO TM02-ADDR-2
025500                 MOVE MMSM-DBA-CITY
025600                                 TO TM02-CITY
025700                 MOVE MMSM-STATE-CODE (1)
025800                                 TO TM02-ST-PROV
025900                 MOVE MMSM-COUNTRY-CODE (1)
026000                                 TO TM02-COUNTRY-CODE
026100                 MOVE MMSM-POSTAL-CODE (1)
026200                                 TO TM02-POST-CD
026300                 MOVE MMSM-PHONE (1)
026400                                 TO TM02-PHONE
026500                 MOVE MMSM-MC-DBA-NAME
026600                                 TO TM02-DBA
026700                 MOVE MMTM-FED-TAX-ID
026800                                 TO TM02-FED-TAX
026900     ELSE
027000         MOVE MMTM-NAME-LINE-1   TO TM02-NAME
027100         MOVE MMTM-ADDR-LINE-1   TO TM02-ADDR-1
027200         MOVE MMTM-ADDR-LINE-2   TO TM02-ADDR-2
027300         MOVE MMTM-CITY          TO TM02-CITY
027400         MOVE MMTM-STATE-PROV    TO TM02-ST-PROV
027500         MOVE MMTM-COUNTRY-CODE  TO TM02-COUNTRY-CODE
027600         MOVE MMTM-POSTAL-CODE   TO TM02-POST-CD
027700         MOVE MMTM-PHONE         TO TM02-PHONE
027800         MOVE MMTM-DBA-NAME      TO TM02-DBA
027900         MOVE MMTM-FED-TAX-ID    TO TM02-FED-TAX.
028000*
028100 B020-MOVE-FIELDS-TO-SCREEN.
028200*
028300*********************************************
028400*    MOVE THE TERMINATED MERCHANT FIELDS    *
028500*    FROM THE RECORD TO THE SCREEN          *
028600*********************************************
028700*
028800     MOVE MMTM-ORG               TO TM02-ORG.
028900     MOVE MMTM-MERCHANT          TO TM02-MERCHANT.
029000     MOVE 'INQ'                  TO TM02-ACTION.
029100     MOVE DFHBMASK               TO TM02-ACTION-A.
029200     MOVE MMTM-LAST-MAINT-DATE   TO SS01WS-JULIAN.
029300     PERFORM SS26PD-NUMERICALLY-EDIT-DATE
029400        THRU SS26PD-NED-EXIT.
029500     MOVE SS01WS-XX-XX-YYYY      TO TM02-LMAINT-DATE.
029600     MOVE MMTM-LAST-MAINT-OPER   TO TM02-LMAINT-OPR.
029700     MOVE DFHBMASK               TO TM02-ACTION-A.
029800     MOVE MMTM-TRANS-REF-NBR     TO TM02-TRANS-REF-NBR.
029900     MOVE MMTM-NBR-MATCHES       TO TM02-NBR-MATCHES.
030000*
030100     PERFORM
030200         VARYING X-TM02-REGION
030300         FROM 1 BY 1
030400         UNTIL X-TM02-REGION IS GREATER THAN 6
030500         SET X-MMTM-REGION       TO X-TM02-REGION
030600         MOVE MMTM-REGION (X-MMTM-REGION)
030700                                 TO TM02-REGION (X-TM02-REGION)
030800     END-PERFORM.
030900*
031000     PERFORM
031100         VARYING X-TM02-COUNTRY
031200         FROM 1 BY 1
031300         UNTIL X-TM02-COUNTRY IS GREATER THAN 10
031400         SET X-MMTM-COUNTRY      TO X-TM02-COUNTRY
031500         MOVE MMTM-COUNTRY (X-MMTM-COUNTRY)
031600                                 TO TM02-COUNTRY
031700                                    (X-TM02-COUNTRY)
031800     END-PERFORM.
031900*
032000     MOVE MMTM-STATE-TAX-ID      TO TM02-ST-TAX.
032100*
032200 B100-SEND-MAP.
032300*
032400     MOVE SS08WS-CURSOR          TO TM02-DBA-L.
032500     COMPUTE MBCA-SCREEN-NBR     =  MBCA-SCREEN-NBR - 50.
032600*
032700**********************
032800*    SEND THE MAP    *
032900**********************
033000*
033100     MOVE DFHBMASK               TO TM02-CURRENT-PAGE-A.
033200*
033300     MOVE 'BM01'                 TO MBCA-PROGRAM-LOCATION.
033400     PERFORM MB60PD-SEND-MAP-WITH-ERASE
033500                                 THRU MB60PD-SMWE-EXIT.
033600*
033700************************
033800*    RETURN TO CICS    *
033900************************
034000*
034100     MOVE 'PC02'                 TO MBCA-PROGRAM-LOCATION.
034200     PERFORM MB70PD-RETURN-TRANS-ID
034300                                 THRU MB70PD-RTI-EXIT.
034400/
034500 C000-RECEIVE-SCREEN SECTION.
034600*
034700******************************************
034800*    THIS SECTION RECEIVES THE SCREEN    *
034900******************************************
035000*
035100     MOVE 'BM02'                 TO MBCA-PROGRAM-LOCATION.
035200     PERFORM MB60PD-RECEIVE-MAP  THRU MB60PD-RM-EXIT.
035300*
035400**************************************************************
035500*    CHECK FOR ANOTHER TRANSACTION ID ENTERED BY THE USER    *
035600**************************************************************
035700*
035800     MOVE 'PC03'                 TO MBCA-PROGRAM-LOCATION.
035900     PERFORM MB60PD-NEW-TRANS-ROUTINE
036000                                 THRU MB60PD-NTR-EXIT.
036100*
036200*********************************************
036300*    READ THE TERMINATED MERCHANT RECORD    *
036400*********************************************
036500*
036600     MOVE MBCA-MERCHANT-ORG      TO MBIOWS-MMTM-ORG
036700                                    TM02-ORG.
036800     MOVE MBCA-MERCHANT          TO MBIOWS-MMTM-MERCHANT
036900                                    TM02-MERCHANT.
037000     MOVE MBCA-S-M               TO MBIOWS-MMTM-FILE-TYPE.
037100     MOVE MBCA-ACTION-CODE       TO MBIOWS-MMTM-ACTION-CODE.
037200     MOVE 'FC04'                 TO MBCA-PROGRAM-LOCATION.
037300     SET MBIORO-READ-RANDOM      TO TRUE.
037400     PERFORM MMTMAO-ACCESS       THRU MMTMAO-ACCESS-EXIT.
037500*
037600********************************************************
037700*    READ THE STORE OR MERCHANT RECORD FOR             *
037800*    DEPENDING ON THE STORE MERCHANT FLAG              *
037900********************************************************
038000*
038100     IF  MBCA-S-M IS EQUAL TO 'M'
038200         IF  MBCA-MBTM-MERCH-FOUND
038300             MOVE MBCA-MERCHANT-ORG
038400                                 TO MBIOWS-MMMM-ORG
038500             MOVE MBCA-MERCHANT  TO MBIOWS-MMMM-MERCHANT
038600             MOVE 'FC05'         TO MBCA-PROGRAM-LOCATION
038700             SET MBIORO-READ-RANDOM
038800                                 TO TRUE
038900             PERFORM MMMMAO-ACCESS
039000                                 THRU MMMMAO-ACCESS-EXIT.
039100*
039200     IF  MBCA-S-M IS EQUAL TO 'S'
039300         IF  MBCA-MBTM-STORE-FOUND
039400             MOVE MBCA-MERCHANT-ORG
039500                                 TO MBIOWS-MMSM-ORG
039600             MOVE MBCA-MERCHANT  TO MBIOWS-MMSM-STORE
039700             MOVE 'FC06'         TO MBCA-PROGRAM-LOCATION
039800             SET MBIORO-READ-RANDOM
039900                                 TO TRUE
040000             PERFORM MMSMAO-ACCESS
040100                                 THRU MMSMAO-ACCESS-EXIT.
040200*
040300***********************************************************
040400*    MOVE THE LAST MAINT DATE AND LAST MAINT OPERATOR,    *
040500*    DEPENDING ON THE FUNCTION                            *
040600***********************************************************
040700*
040800     MOVE MMTM-LAST-MAINT-DATE   TO SS01WS-JULIAN.
040900     PERFORM SS26PD-NUMERICALLY-EDIT-DATE
041000        THRU SS26PD-NED-EXIT.
041100     MOVE SS01WS-XX-XX-YYYY      TO TM02-LMAINT-DATE.
041200     MOVE MMTM-LAST-MAINT-OPER   TO TM02-LMAINT-OPR.
041300*
041400*********************
041500*    FIELD EDITS    *
041600*********************
041700*
041800 C010-EDIT-DBA-NAME.
041900*
042000     MOVE DFHBMDAS               TO TM02-DBA-LP-A
042100                                    TM02-DBA-RP-A.
042200     MOVE DFHBMASK               TO TM02-DBA-A.
042300*
042400     IF  TM02-DBA-L IS LESS THAN 1
042500         IF  MBCA-MBTM-FUNCTION-ADD
042600             IF  MBCA-S-M IS EQUAL TO 'S'
042700                 IF  MBCA-MBTM-STORE-FOUND
042800                     MOVE MMSM-MC-DBA-NAME
042900                                 TO TM02-DBA
043000                     MOVE DFHBMASF
043100                                 TO TM02-DBA-A
043200                     MOVE 1      TO TM02-DBA-L
043300                 ELSE
043400                     MOVE SPACES TO TM02-DBA
043500             ELSE
043600                 IF  MBCA-MBTM-MERCH-FOUND
043700                     MOVE MMMM-DBA-NAME
043800                                 TO TM02-DBA
043900                     MOVE DFHBMASF
044000                                 TO TM02-DBA-A
044100                     MOVE 1      TO TM02-DBA-L
044200                 ELSE
044300                     MOVE SPACES TO TM02-DBA
044400         ELSE
044500             MOVE MMTM-DBA-NAME
044600                                 TO TM02-DBA
044700     ELSE
044800         MOVE DFHBMASF           TO TM02-DBA-A.
044900*
045000     IF  TM02-DBA IS EQUAL TO SPACES
045100         SET SS08WS-ERROR-SW-YES TO TRUE
045200         MOVE SS08WS-CURSOR      TO TM02-DBA-L
045300         MOVE DFHBMASB           TO TM02-DBA-LP-A
045400                                    TM02-DBA-RP-A
045500         MOVE DFHBMUBF           TO TM02-DBA-A.
045600*
045700 C030-EDIT-NAME.
045800*
045900     MOVE DFHBMDAS               TO TM02-NAME-LP-A
046000                                    TM02-NAME-RP-A.
046100     MOVE DFHBMASK               TO TM02-NAME-A.
046200*
046300     IF  TM02-NAME-L IS LESS THAN 1
046400         IF  MBCA-MBTM-FUNCTION-ADD
046500             IF  MBCA-S-M IS EQUAL TO 'M'
046600                 IF  MBCA-MBTM-MERCH-FOUND
046700                     MOVE MMMM-NA-LINE (1 1)
046800                                 TO TM02-NAME
046900                     MOVE DFHBMASF
047000                                 TO TM02-NAME-A
047100                     MOVE 1      TO TM02-NAME-L
047200                 ELSE
047300                     MOVE SPACES TO TM02-NAME
047400             ELSE
047500                 IF  MBCA-MBTM-STORE-FOUND
047600                     MOVE MMSM-NA-LINE (1 1)
047700                                 TO TM02-NAME
047800                     MOVE DFHBMASF
047900                                 TO TM02-NAME-A
048000                     MOVE 1      TO TM02-NAME-L
048100                 ELSE
048200                     MOVE SPACES TO TM02-NAME
048300         ELSE
048400             MOVE MMTM-NAME-LINE-1
048500                                 TO TM02-NAME
048600     ELSE
048700         MOVE DFHBMASF           TO TM02-NAME-A.
048800*
048900*
049000     IF  TM02-NAME IS EQUAL TO SPACES
049100         SET SS08WS-ERROR-SW-YES TO TRUE
049200         MOVE SS08WS-CURSOR      TO TM02-NAME-L
049300         MOVE DFHBMASB           TO TM02-NAME-LP-A
049400                                    TM02-NAME-RP-A
049500         MOVE DFHBMUBF           TO TM02-NAME-A.
049600*
049700 C050-EDIT-ADDRESS1.
049800*
049900     MOVE DFHBMDAS               TO TM02-ADDR-1-LP-A
050000                                    TM02-ADDR-1-RP-A.
050100     MOVE DFHBMASK               TO TM02-ADDR-1-A.
050200*
050300     IF  TM02-ADDR-1-L IS LESS THAN 1
050400         IF  MBCA-MBTM-FUNCTION-ADD
050500             IF  MBCA-S-M IS EQUAL TO 'M'
050600                 IF  MBCA-MBTM-MERCH-FOUND
050700                     MOVE MMMM-NA-LINE (1 2)
050800                                 TO TM02-ADDR-1
050900                     MOVE DFHBMASF
051000                                 TO TM02-ADDR-1-A
051100                     MOVE 1      TO TM02-ADDR-1-L
051200                 ELSE
051300                     MOVE SPACES TO TM02-ADDR-1
051400             ELSE
051500                 IF  MBCA-MBTM-STORE-FOUND
051600                     MOVE MMSM-NA-LINE (1 2)
051700                                 TO TM02-ADDR-1
051800                     MOVE DFHBMASF
051900                                 TO TM02-ADDR-1-A
052000                     MOVE 1      TO TM02-ADDR-1-L
052100                 ELSE
052200                     MOVE SPACES TO TM02-ADDR-1
052300         ELSE
052400             MOVE MMTM-ADDR-LINE-1
052500                                 TO TM02-ADDR-1
052600     ELSE
052700         MOVE DFHBMASF           TO TM02-ADDR-1-A.
052800*
052900*
053000     IF  TM02-ADDR-1 IS EQUAL TO SPACES
053100         SET SS08WS-ERROR-SW-YES TO TRUE
053200         MOVE SS08WS-CURSOR      TO TM02-ADDR-1-L
053300         MOVE DFHBMASB           TO TM02-ADDR-1-LP-A
053400                                    TM02-ADDR-1-RP-A
053500         MOVE DFHBMUBF           TO TM02-ADDR-1-A.
053600*
053700 C070-EDIT-ADDRESS2.
053800*
053900     MOVE DFHBMDAS               TO TM02-ADDR-2-LP-A
054000                                    TM02-ADDR-2-RP-A.
054100     MOVE DFHBMASK               TO TM02-ADDR-2-A.
054200*
054300     IF  TM02-ADDR-2-L IS LESS THAN 1
054400         IF  MBCA-MBTM-FUNCTION-ADD
054500             IF  MBCA-S-M IS EQUAL TO 'M'
054600                 IF  MBCA-MBTM-MERCH-FOUND
054700                     MOVE MMMM-NA-LINE (1 3)
054800                                 TO TM02-ADDR-2
054900                     MOVE DFHBMASF
055000                                 TO TM02-ADDR-2-A
055100                     MOVE 1      TO TM02-ADDR-2-L
055200                 ELSE
055300                     MOVE SPACES TO TM02-ADDR-2
055400             ELSE
055500                 IF  MBCA-MBTM-STORE-FOUND
055600                     MOVE MMSM-NA-LINE (1 3)
055700                                 TO TM02-ADDR-2
055800                     MOVE DFHBMASF
055900                                 TO TM02-ADDR-2-A
056000                     MOVE 1      TO TM02-ADDR-2-L
056100                 ELSE
056200                     MOVE SPACES TO TM02-ADDR-2
056300         ELSE
056400             MOVE MMTM-ADDR-LINE-2
056500                                 TO TM02-ADDR-2
056600     ELSE
056700         MOVE DFHBMASF           TO TM02-ADDR-2-A.
056800*
056900*
057000 C090-EDIT-CITY.
057100*
057200     MOVE DFHBMDAS               TO TM02-CITY-LP-A
057300                                    TM02-CITY-RP-A.
057400     MOVE DFHBMASK               TO TM02-CITY-A.
057500*
057600     IF  TM02-CITY-L IS LESS THAN 1
057700         IF  MBCA-MBTM-FUNCTION-ADD
057800             IF  MBCA-S-M IS EQUAL TO 'M'
057900                 IF  MBCA-MBTM-MERCH-FOUND
058000                     MOVE MMMM-DBA-CITY
058100                                 TO TM02-CITY
058200                     MOVE DFHBMASF
058300                                 TO TM02-CITY-A
058400                     MOVE 1      TO TM02-CITY-L
058500                 ELSE
058600                     MOVE SPACES TO TM02-CITY
058700             ELSE
058800                 IF  MBCA-MBTM-STORE-FOUND
058900                     MOVE MMSM-DBA-CITY
059000                                 TO TM02-CITY
059100                     MOVE DFHBMASF
059200                                 TO TM02-CITY-A
059300                     MOVE 1      TO TM02-CITY-L
059400                 ELSE
059500                     MOVE SPACES TO TM02-CITY
059600         ELSE
059700             MOVE MMTM-CITY      TO TM02-CITY
059800     ELSE
059900         MOVE DFHBMASF           TO TM02-CITY-A.
060000*
060100*
060200     IF  TM02-CITY IS EQUAL TO SPACES
060300         SET SS08WS-ERROR-SW-YES TO TRUE
060400         MOVE SS08WS-CURSOR      TO TM02-CITY-L
060500         MOVE DFHBMASB           TO TM02-CITY-LP-A
060600                                    TM02-CITY-RP-A
060700         MOVE DFHBMUBF           TO TM02-CITY-A.
060800*
060900 C110-EDIT-COUNTRY-CODE.
061000*
061100     MOVE DFHBMDAS               TO TM02-COUNTRY-CODE-LP-A
061200                                    TM02-COUNTRY-CODE-RP-A.
061300     MOVE DFHBMASK               TO TM02-COUNTRY-CODE-A.
061400*
061500     IF  TM02-COUNTRY-CODE-L IS LESS THAN 1
061600         IF  MBCA-MBTM-FUNCTION-ADD
061700             IF  MBCA-S-M IS EQUAL TO 'M'
061800                 IF  MBCA-MBTM-MERCH-FOUND
061900                     MOVE MMMM-COUNTRY-CODE (1)
062000                                 TO TM02-COUNTRY-CODE
062100                     MOVE DFHBMASF
062200                                 TO TM02-COUNTRY-CODE-A
062300                     MOVE 1      TO TM02-COUNTRY-CODE-L
062400                 ELSE
062500                     MOVE SPACES TO TM02-COUNTRY-CODE
062600             ELSE
062700                 IF  MBCA-MBTM-STORE-FOUND
062800                     MOVE MMSM-COUNTRY-CODE (1)
062900                                 TO TM02-COUNTRY-CODE
063000                     MOVE DFHBMASF
063100                                 TO TM02-COUNTRY-CODE-A
063200                     MOVE 1      TO TM02-COUNTRY-CODE-L
063300                 ELSE
063400                     MOVE SPACES TO TM02-COUNTRY-CODE
063500         ELSE
063600             MOVE MMTM-COUNTRY-CODE
063700                                 TO TM02-COUNTRY-CODE
063800     ELSE
063900         MOVE DFHBMASF           TO TM02-COUNTRY-CODE-A.
064000*
064100*
064200     IF  TM02-COUNTRY-CODE IS EQUAL TO SPACES
064300         SET SS08WS-ERROR-SW-YES TO TRUE
064400         MOVE SS08WS-CURSOR      TO TM02-COUNTRY-CODE-L
064500         MOVE DFHBMASB           TO TM02-COUNTRY-CODE-LP-A
064600                                    TM02-COUNTRY-CODE-RP-A
064700         MOVE DFHBMUBF           TO TM02-COUNTRY-CODE-A.
064800*
064900 C130-EDIT-STATE-PROV.
065000*
065100     MOVE DFHBMDAS               TO TM02-ST-PROV-LP-A
065200                                    TM02-ST-PROV-RP-A.
065300     MOVE DFHBMASK               TO TM02-ST-PROV-A.
065400*
065500     IF  TM02-ST-PROV-L IS LESS THAN 1
065600         IF  MBCA-MBTM-FUNCTION-ADD
065700             IF  MBCA-S-M IS EQUAL TO 'M'
065800                 IF  MBCA-MBTM-MERCH-FOUND
065900                     MOVE MMMM-STATE-CODE (1)
066000                                 TO TM02-ST-PROV
066100                     MOVE DFHBMASF
066200                                 TO TM02-ST-PROV-A
066300                     MOVE 1      TO TM02-ST-PROV-L
066400                 ELSE
066500                     MOVE SPACES TO TM02-ST-PROV
066600             ELSE
066700                 IF  MBCA-MBTM-STORE-FOUND
066800                     MOVE MMSM-STATE-CODE (1)
066900                                 TO TM02-ST-PROV
067000                     MOVE DFHBMASF
067100                                 TO TM02-ST-PROV-A
067200                     MOVE 1      TO TM02-ST-PROV-L
067300                 ELSE
067400                     MOVE SPACES TO TM02-ST-PROV
067500         ELSE
067600             MOVE MMTM-STATE-PROV    TO TM02-ST-PROV
067700     ELSE
067800         MOVE DFHBMASF           TO TM02-ST-PROV-A.
067900*
068000*
068100     IF  TM02-ST-PROV IS EQUAL TO SPACES
068200     AND TM02-COUNTRY-CODE IS EQUAL TO 'USA'
068300         SET SS08WS-ERROR-SW-YES TO TRUE
068400         MOVE SS08WS-CURSOR      TO TM02-ST-PROV-L
068500         MOVE DFHBMASB           TO TM02-ST-PROV-LP-A
068600                                    TM02-ST-PROV-RP-A
068700         MOVE DFHBMUBF           TO TM02-ST-PROV-A.
068800*
068900 C150-EDIT-POSTAL-CODE.
069000*
069100     MOVE DFHBMDAS               TO TM02-POST-CD-LP-A
069200                                    TM02-POST-CD-RP-A.
069300     MOVE DFHBMASK               TO TM02-POST-CD-A.
069400*
069500     IF  TM02-POST-CD-L IS LESS THAN 1
069600         IF  MBCA-MBTM-FUNCTION-ADD
069700             IF  MBCA-S-M IS EQUAL TO 'M'
069800                 IF  MBCA-MBTM-MERCH-FOUND
069900                     MOVE MMMM-POSTAL-CODE (1)
070000                                 TO TM02-POST-CD
070100                     MOVE DFHBMASF
070200                                 TO TM02-POST-CD-A
070300                     MOVE 1      TO TM02-POST-CD-L
070400                 ELSE
070500                     MOVE SPACES TO TM02-POST-CD
070600             ELSE
070700                 IF  MBCA-MBTM-STORE-FOUND
070800                     MOVE MMSM-POSTAL-CODE (1)
070900                                 TO TM02-POST-CD
071000                     MOVE DFHBMASF
071100                                 TO TM02-POST-CD-A
071200                     MOVE 1      TO TM02-POST-CD-L
071300                 ELSE
071400                     MOVE SPACES TO TM02-POST-CD
071500         ELSE
071600             MOVE MMTM-POSTAL-CODE   TO TM02-POST-CD
071700     ELSE
071800         MOVE DFHBMASF           TO TM02-POST-CD-A.
071900*
072000*
072100*
072200     IF  TM02-POST-CD IS EQUAL TO SPACES
072300     AND TM02-COUNTRY-CODE IS EQUAL TO 'USA'
072400         SET SS08WS-ERROR-SW-YES TO TRUE
072500         MOVE SS08WS-CURSOR      TO TM02-POST-CD-L
072600         MOVE DFHBMASB           TO TM02-POST-CD-LP-A
072700                                    TM02-POST-CD-RP-A
072800         MOVE DFHBMUBF           TO TM02-POST-CD-A.
072900*
073000 C170-EDIT-PHONE.
073100*
073200     MOVE DFHBMDAS               TO TM02-PHONE-LP-A
073300                                    TM02-PHONE-RP-A.
073400     MOVE DFHBMASK               TO TM02-PHONE-A.
073500*
073600     IF  TM02-PHONE-L IS LESS THAN 1
073700         IF  MBCA-MBTM-FUNCTION-ADD
073800             IF  MBCA-S-M IS EQUAL TO 'M'
073900                 IF  MBCA-MBTM-MERCH-FOUND
074000                     MOVE MMMM-PHONE (1)
074100                                 TO TM02-PHONE
074200                     MOVE DFHBMASF
074300                                 TO TM02-PHONE-A
074400                     MOVE 1      TO TM02-PHONE-L
074500                 ELSE
074600                     MOVE SPACES TO TM02-PHONE
074700             ELSE
074800                 IF  MBCA-MBTM-STORE-FOUND
074900                     MOVE MMSM-PHONE (1)
075000                                 TO TM02-PHONE
075100                     MOVE DFHBMASF
075200                                 TO TM02-PHONE-A
075300                     MOVE 1      TO TM02-PHONE-L
075400                 ELSE
075500                     MOVE SPACES TO TM02-PHONE
075600         ELSE
075700             MOVE MMTM-PHONE     TO TM02-PHONE
075800     ELSE
075900         MOVE DFHBMASF           TO TM02-PHONE-A.
076000*
076100*
076200     IF  TM02-PHONE IS EQUAL TO SPACES
076300     AND TM02-COUNTRY-CODE IS EQUAL TO 'USA'
076400         SET SS08WS-ERROR-SW-YES TO TRUE
076500         MOVE SS08WS-CURSOR      TO TM02-PHONE-L
076600         MOVE DFHBMASB           TO TM02-PHONE-LP-A
076700                                    TM02-PHONE-RP-A
076800         MOVE DFHBMUBF           TO TM02-PHONE-A.
076900*
077000 C190-EDIT-FED-TAX-ID.
077100*
077200     MOVE DFHBMDAS               TO TM02-FED-TAX-LP-A
077300                                    TM02-FED-TAX-RP-A.
077400     MOVE DFHBMASK               TO TM02-FED-TAX-A.
077500*
077600     IF  TM02-FED-TAX-L IS LESS THAN 1
077700         IF  MBCA-MBTM-FUNCTION-ADD
077800             IF  MBCA-S-M IS EQUAL TO 'M'
077900                 IF  MBCA-MBTM-MERCH-FOUND
078000                     MOVE MMMM-TAX-ID
078100                                 TO TM02-FED-TAX
078200                     MOVE DFHBMASF
078300                                 TO TM02-FED-TAX-A
078400                     MOVE 1      TO TM02-FED-TAX-L
078500                 ELSE
078600                     MOVE SPACES TO TM02-FED-TAX
078700             ELSE
078800                 IF  MBCA-MBTM-STORE-FOUND
078900                     MOVE MMTM-FED-TAX-ID
079000                                 TO TM02-FED-TAX
079100                 ELSE
079200                     MOVE SPACES TO TM02-FED-TAX
079300         ELSE
079400             MOVE MMTM-FED-TAX-ID
079500                                 TO TM02-FED-TAX
079600     ELSE
079700         MOVE DFHBMASF           TO TM02-FED-TAX-A.
079800*
079900*
080000 C210-EDIT-STATE-TAX-ID.
080100*
080200     MOVE DFHBMDAS               TO TM02-ST-TAX-LP-A
080300                                    TM02-ST-TAX-RP-A.
080400     MOVE DFHBMASK               TO TM02-ST-TAX-A.
080500*
080600     IF  TM02-ST-TAX-L IS LESS THAN 1
080700         MOVE MMTM-STATE-TAX-ID  TO TM02-ST-TAX
080800     ELSE
080900         MOVE DFHBMASF           TO TM02-ST-TAX-A.
081000*
081100     IF  TM02-COUNTRY-CODE IS NOT EQUAL TO 'USA'
081200     AND TM02-ST-TAX IS EQUAL TO SPACES
081300         SET SS08WS-ERROR-SW-YES TO TRUE
081400         MOVE SS08WS-CURSOR      TO TM02-ST-TAX-L
081500         MOVE DFHBMASB           TO TM02-ST-TAX-LP-A
081600                                    TM02-ST-TAX-RP-A
081700         MOVE DFHBMUBF           TO TM02-ST-TAX-A.
081800*
081900 C230-EDIT-ACTION-CODE.
082000*
082100     MOVE DFHBMASK               TO TM02-ACTION-A.
082200     SET  TM02-ACTION-INQ        TO TRUE.
082300*
082400 C250-EDIT-TRANS-REF-NBR.
082500*
082600     MOVE DFHBMDAS               TO TM02-TRANS-REF-NBR-LP-A
082700                                    TM02-TRANS-REF-NBR-RP-A.
082800     MOVE DFHBMASK               TO TM02-TRANS-REF-NBR-A.
082900*
083000     IF  TM02-TRANS-REF-NBR-L IS LESS THAN 1
083100         MOVE MMTM-TRANS-REF-NBR TO TM02-TRANS-REF-NBR
083200     ELSE
083300         MOVE DFHBMASF           TO TM02-TRANS-REF-NBR-A.
083400*
083500     IF  TM02-TRANS-REF-NBR IS NOT NUMERIC
083600         SET SS08WS-ERROR-SW-YES TO TRUE
083700         MOVE SS08WS-CURSOR      TO TM02-TRANS-REF-NBR-L
083800         MOVE DFHBMASB           TO TM02-TRANS-REF-NBR-LP-A
083900                                    TM02-TRANS-REF-NBR-RP-A
084000         MOVE DFHBMNBF           TO TM02-TRANS-REF-NBR-A.
084100*
084200 C270-EDIT-NBR-MATCHES.
084300*
084400     MOVE DFHBMDAS               TO TM02-NBR-MATCHES-LP-A
084500                                    TM02-NBR-MATCHES-RP-A.
084600     MOVE DFHBMASK               TO TM02-NBR-MATCHES-A.
084700*
084800     IF  TM02-NBR-MATCHES-L IS LESS THAN 1
084900         MOVE MMTM-NBR-MATCHES   TO TM02-NBR-MATCHES
085000     ELSE
085100         MOVE DFHBMASF           TO TM02-NBR-MATCHES-A.
085200*
085300     IF  TM02-NBR-MATCHES IS NOT NUMERIC
085400     OR  NOT TM02-VALID-NBR-MATCHES
085500         SET SS08WS-ERROR-SW-YES TO TRUE
085600         MOVE SS08WS-CURSOR      TO TM02-NBR-MATCHES-L
085700         MOVE DFHBMASB           TO TM02-NBR-MATCHES-LP-A
085800                                    TM02-NBR-MATCHES-RP-A
085900         MOVE DFHBMNBF           TO TM02-NBR-MATCHES-A.
086000*
086100 C290-EDIT-REGION.
086200*
086300     PERFORM
086400         VARYING X-TM02-REGION
086500         FROM 1 BY 1
086600         UNTIL X-TM02-REGION IS GREATER THAN 6
086700         SET X-MMTM-REGION       TO X-TM02-REGION
086800         MOVE DFHBMDAS           TO TM02-REGION-LP-A
086900                                    (X-TM02-REGION)
087000                                    TM02-REGION-RP-A
087100                                    (X-TM02-REGION)
087200         MOVE DFHBMASK           TO TM02-REGION-A
087300                                    (X-TM02-REGION)
087400         IF  TM02-REGION-L (X-TM02-REGION) IS GREATER THAN ZERO
087500             MOVE DFHBMASF       TO TM02-REGION-A
087600                                    (X-TM02-REGION)
087700         ELSE
087800             MOVE MMTM-REGION (X-MMTM-REGION)
087900                                 TO TM02-REGION
088000                                    (X-TM02-REGION)
088100         END-IF
088200     END-PERFORM.
088300*
088400 C310-EDIT-COUNTRY.
088500*
088600     PERFORM
088700         VARYING X-TM02-COUNTRY
088800         FROM 1 BY 1
088900         UNTIL X-TM02-COUNTRY IS GREATER THAN 10
089000         SET X-MMTM-COUNTRY      TO X-TM02-COUNTRY
089100         MOVE DFHBMDAS           TO TM02-COUNTRY-LP-A
089200                                    (X-TM02-COUNTRY)
089300                                    TM02-COUNTRY-RP-A
089400                                    (X-TM02-COUNTRY)
089500         MOVE DFHBMASK           TO TM02-COUNTRY-A
089600                                    (X-TM02-COUNTRY)
089700         IF  TM02-COUNTRY-L (X-TM02-COUNTRY) IS GREATER THAN ZERO
089800             MOVE DFHBMASF       TO TM02-COUNTRY-A
089900                                    (X-TM02-COUNTRY)
090000         ELSE
090100             MOVE MMTM-COUNTRY (X-MMTM-COUNTRY)
090200                                 TO TM02-COUNTRY
090300                                    (X-TM02-COUNTRY)
090400         END-IF
090500     END-PERFORM.
090600*
090700/
090800 D000-RETURN-ERRORS SECTION.
090900*
091000     IF  SS08WS-ERROR-SW-NO
091100         GO TO E000-UPDATE-FILE.
091200*
091300***************************************************************
091400*    INITIALIZE THE STANDARD MAP LINES.  IN AN ERROR          *
091500*    CONDITION, THIS ROUTINE IS PERFORMED PRIMARILY           *
091600*    TO UPDATE THE DATE AND TIME ON THE SCREEN.               *
091700***************************************************************
091800*
091900     PERFORM MB60PD-INIT-STD-MAP-LINES
092000                                 THRU MB60PD-ISML-EXIT.
092100*
092200**********************
092300*    SEND THE MAP    *
092400**********************
092500*
092600     MOVE 'BM03'                 TO MBCA-PROGRAM-LOCATION.
092700     PERFORM MB60PD-SEND-MAP-DATA-ONLY
092800                                 THRU MB60PD-SMDO-EXIT.
092900*
093000************************
093100*    RETURN TO CICS    *
093200************************
093300*
093400     MOVE 'PC04'                 TO MBCA-PROGRAM-LOCATION.
093500     PERFORM MB70PD-RETURN-TRANS-ID
093600                                 THRU MB70PD-RTI-EXIT.
093700/
093800 E000-UPDATE-FILE SECTION.
093900*
094000********************************************************
094100*    READ THE TERMINATED MERCHANT RECORD FOR UPDATE    *
094200********************************************************
094300*
094400     MOVE MMTM-RECORD            TO MMTMIO-RECORD.
094500*
094600     MOVE 'FC07'                 TO MBCA-PROGRAM-LOCATION.
094700     SET MBIORO-READ-RANDOM-UPDATE
094800                                 TO TRUE.
094900     PERFORM MMTMAO-ACCESS       THRU MMTMAO-ACCESS-EXIT.
095000*
095100*************************************
095200*    OBTAIN STORAGE FOR LOG FILE    *
095300*    RECORD IF DOING MAINTENANCE    *
095400*************************************
095500*
095600     MOVE 'SC02'                 TO MBCA-PROGRAM-LOCATION.
095700     SET MBIORO-GETMAIN          TO TRUE.
095800     PERFORM MML1AO-ACCESS       THRU MML1AO-ACCESS-EXIT.
095900*
096000*************************************************
096100*    SET UP THE COMMON PORTION OF THE RECORD    *
096200*************************************************
096300*
096400     MOVE 'TM'                   TO MML1-FILE-CODE.
096500     MOVE MBCA-MERCHANT-ORG      TO MML1-MMTM-ORG.
096600     MOVE MBCA-MERCHANT          TO MML1-MMTM-MERCHANT.
096700     MOVE MBCA-SIGNON-NAME       TO MML1-SIGNON-NAME.
096800     MOVE MBCA-TERMINAL-ID       TO MML1-TERMINAL-ID.
096900     MOVE ZEROS                  TO MML1-SOURCE-CODE.
097000     MOVE MBCA-FIELD-SECURITY    TO MML1-FIELD-SECURITY.
097100*
097200 E020-UPDATE-FIELDS.
097300*
097400     IF  TM02-DBA-L IS GREATER THAN ZERO
097500         IF  TM02-DBA IS NOT EQUAL
097600                                 TO MMTM-DBA-NAME
097700             SET WS-UPDATE-SW-YES
097800                                 TO TRUE
097900             IF  MMTM-ADD-COMPLETED
098000                 MOVE 0103       TO MML1-FIELD-CODE
098100                 MOVE ZEROS      TO MML1-FIELD-OCCURRENCE
098200                 MOVE ZEROS      TO MML1-FIELD-OCCURRENCE-2
098300                 MOVE MML1WS-VL-30
098400                                 TO MML1-VARIABLE-LENGTH
098500                 MOVE MMTM-DBA-NAME
098600                                 TO MML1-VL30-B-DATA-X
098700                 MOVE TM02-DBA   TO MMTM-DBA-NAME
098800                 MOVE MMTM-DBA-NAME
098900                                 TO MML1-VL30-A-DATA-X
099000                 MOVE 'FC08'     TO MBCA-PROGRAM-LOCATION
099100                 PERFORM Y910-WRITE-LOG-RECORD
099200                                 THRU Y919-WLR-EXIT
099300             ELSE
099400                 MOVE TM02-DBA   TO MMTM-DBA-NAME.
099500*
099600     IF  TM02-NAME-L IS GREATER THAN ZERO
099700         IF  TM02-NAME IS NOT EQUAL
099800                                 TO MMTM-NAME-LINE-1
099900             SET WS-UPDATE-SW-YES
100000                                 TO TRUE
100100             IF  MMTM-ADD-COMPLETED
100200                 MOVE 0104       TO MML1-FIELD-CODE
100300                 MOVE ZEROS      TO MML1-FIELD-OCCURRENCE
100400                 MOVE ZEROS      TO MML1-FIELD-OCCURRENCE-2
100500                 MOVE MML1WS-VL-30
100600                                 TO MML1-VARIABLE-LENGTH
100700                 MOVE MMTM-NAME-LINE-1
100800                                 TO MML1-VL30-B-DATA-X
100900                 MOVE TM02-NAME
101000                                 TO MMTM-NAME-LINE-1
101100                 MOVE MMTM-NAME-LINE-1
101200                                 TO MML1-VL30-A-DATA-X
101300                 MOVE 'FC09'     TO MBCA-PROGRAM-LOCATION
101400                 PERFORM Y910-WRITE-LOG-RECORD
101500                                 THRU Y919-WLR-EXIT
101600             ELSE
101700                 MOVE TM02-NAME  TO MMTM-NAME-LINE-1.
101800*
101900     IF  TM02-ADDR-1-L IS GREATER THAN ZERO
102000         IF  TM02-ADDR-1 IS NOT EQUAL
102100                                 TO MMTM-ADDR-LINE-1
102200             SET WS-UPDATE-SW-YES
102300                                 TO TRUE
102400             IF  MMTM-ADD-COMPLETED
102500                 MOVE 0105       TO MML1-FIELD-CODE
102600                 MOVE ZEROS      TO MML1-FIELD-OCCURRENCE
102700                 MOVE ZEROS      TO MML1-FIELD-OCCURRENCE-2
102800                 MOVE MML1WS-VL-30
102900                                 TO MML1-VARIABLE-LENGTH
103000                 MOVE MMTM-ADDR-LINE-1
103100                                 TO MML1-VL30-B-DATA-X
103200                 MOVE TM02-ADDR-1
103300                                 TO MMTM-ADDR-LINE-1
103400                 MOVE MMTM-ADDR-LINE-1
103500                                 TO MML1-VL30-A-DATA-X
103600                 MOVE 'FC10'     TO MBCA-PROGRAM-LOCATION
103700                 PERFORM Y910-WRITE-LOG-RECORD
103800                                 THRU Y919-WLR-EXIT
103900             ELSE
104000                 MOVE TM02-ADDR-1 TO MMTM-ADDR-LINE-1.
104100*
104200     IF  TM02-ADDR-2-L IS GREATER THAN ZERO
104300         IF  TM02-ADDR-2 IS NOT EQUAL
104400                                 TO MMTM-ADDR-LINE-2
104500             SET WS-UPDATE-SW-YES
104600                                 TO TRUE
104700             IF  MMTM-ADD-COMPLETED
104800                 MOVE 0106       TO MML1-FIELD-CODE
104900                 MOVE ZEROS      TO MML1-FIELD-OCCURRENCE
105000                 MOVE ZEROS      TO MML1-FIELD-OCCURRENCE-2
105100                 MOVE MML1WS-VL-30
105200                                 TO MML1-VARIABLE-LENGTH
105300                 MOVE MMTM-ADDR-LINE-2
105400                                 TO MML1-VL30-B-DATA-X
105500                 MOVE TM02-ADDR-2
105600                                 TO MMTM-ADDR-LINE-2
105700                 MOVE MMTM-ADDR-LINE-2
105800                                 TO MML1-VL30-A-DATA-X
105900                 MOVE 'FC11'     TO MBCA-PROGRAM-LOCATION
106000                 PERFORM Y910-WRITE-LOG-RECORD
106100                                 THRU Y919-WLR-EXIT
106200             ELSE
106300                 MOVE TM02-ADDR-2
106400                                 TO MMTM-ADDR-LINE-2.
106500*
106600     IF  TM02-CITY-L IS GREATER THAN ZERO
106700         IF  TM02-CITY IS NOT EQUAL
106800                                 TO MMTM-CITY
106900             SET WS-UPDATE-SW-YES
107000                                 TO TRUE
107100             IF  MMTM-ADD-COMPLETED
107200                 MOVE 0107       TO MML1-FIELD-CODE
107300                 MOVE ZEROS      TO MML1-FIELD-OCCURRENCE
107400                 MOVE ZEROS      TO MML1-FIELD-OCCURRENCE-2
107500                 MOVE MML1WS-VL-20
107600                                 TO MML1-VARIABLE-LENGTH
107700                 MOVE MMTM-CITY  TO MML1-VL20-B-DATA-X
107800                 MOVE TM02-CITY  TO MMTM-CITY
107900                 MOVE MMTM-CITY  TO MML1-VL20-A-DATA-X
108000                 MOVE 'FC12'     TO MBCA-PROGRAM-LOCATION
108100                 PERFORM Y910-WRITE-LOG-RECORD
108200                                 THRU Y919-WLR-EXIT
108300             ELSE
108400                 MOVE TM02-CITY  TO MMTM-CITY.
108500*
108600     IF  TM02-ST-PROV-L IS GREATER THAN ZERO
108700         IF  TM02-ST-PROV IS NOT EQUAL
108800                                 TO MMTM-STATE-PROV
108900             SET WS-UPDATE-SW-YES
109000                                 TO TRUE
109100             IF  MMTM-ADD-COMPLETED
109200                 MOVE 0108       TO MML1-FIELD-CODE
109300                 MOVE ZEROS      TO MML1-FIELD-OCCURRENCE
109400                 MOVE ZEROS      TO MML1-FIELD-OCCURRENCE-2
109500                 MOVE MML1WS-VL-02
109600                                 TO MML1-VARIABLE-LENGTH
109700                 MOVE MMTM-STATE-PROV
109800                                 TO MML1-VL02-B-DATA-X
109900                 MOVE TM02-ST-PROV
110000                                 TO MMTM-STATE-PROV
110100                 MOVE MMTM-STATE-PROV
110200                                 TO MML1-VL02-A-DATA-X
110300                 MOVE 'FC13'     TO MBCA-PROGRAM-LOCATION
110400                 PERFORM Y910-WRITE-LOG-RECORD
110500                                 THRU Y919-WLR-EXIT
110600             ELSE
110700                 MOVE TM02-ST-PROV
110800                                 TO MMTM-STATE-PROV.
110900*
111000     IF  TM02-COUNTRY-CODE-L IS GREATER THAN ZERO
111100         IF  TM02-COUNTRY-CODE IS NOT EQUAL
111200                                 TO MMTM-COUNTRY-CODE
111300             SET WS-UPDATE-SW-YES
111400                                 TO TRUE
111500             IF  MMTM-ADD-COMPLETED
111600                 MOVE 0109       TO MML1-FIELD-CODE
111700                 MOVE ZEROS      TO MML1-FIELD-OCCURRENCE
111800                 MOVE ZEROS      TO MML1-FIELD-OCCURRENCE-2
111900                 MOVE MML1WS-VL-03
112000                                 TO MML1-VARIABLE-LENGTH
112100                 MOVE MMTM-COUNTRY-CODE
112200                                 TO MML1-VL03-B-DATA-X
112300                 MOVE TM02-COUNTRY-CODE
112400                                 TO MMTM-COUNTRY-CODE
112500                 MOVE MMTM-COUNTRY-CODE
112600                                 TO MML1-VL03-A-DATA-X
112700                 MOVE 'FC14'     TO MBCA-PROGRAM-LOCATION
112800                 PERFORM Y910-WRITE-LOG-RECORD
112900                                 THRU Y919-WLR-EXIT
113000             ELSE
113100                 MOVE TM02-COUNTRY-CODE
113200                                 TO MMTM-COUNTRY-CODE.
113300*
113400     IF  TM02-POST-CD-L IS GREATER THAN ZERO
113500         IF  TM02-POST-CD IS NOT EQUAL
113600                                 TO MMTM-POSTAL-CODE
113700             SET WS-UPDATE-SW-YES
113800                                 TO TRUE
113900             IF  MMTM-ADD-COMPLETED
114000                 MOVE 0110       TO MML1-FIELD-CODE
114100                 MOVE ZEROS      TO MML1-FIELD-OCCURRENCE
114200                 MOVE ZEROS      TO MML1-FIELD-OCCURRENCE-2
114300                 MOVE MML1WS-VL-10
114400                                 TO MML1-VARIABLE-LENGTH
114500                 MOVE MMTM-POSTAL-CODE
114600                                 TO MML1-VL10-B-DATA-X
114700                 MOVE TM02-POST-CD
114800                                 TO MMTM-POSTAL-CODE
114900                 MOVE MMTM-POSTAL-CODE
115000                                 TO MML1-VL10-A-DATA-X
115100                 MOVE 'FC15'     TO MBCA-PROGRAM-LOCATION
115200                 PERFORM Y910-WRITE-LOG-RECORD
115300                                 THRU Y919-WLR-EXIT
115400             ELSE
115500                 MOVE TM02-POST-CD
115600                                 TO MMTM-POSTAL-CODE.
115700*
115800     IF  TM02-PHONE-L IS GREATER THAN ZERO
115900         IF  TM02-PHONE IS NOT EQUAL
116000                                 TO MMTM-PHONE
116100             SET WS-UPDATE-SW-YES
116200                                 TO TRUE
116300             IF  MMTM-ADD-COMPLETED
116400                 MOVE 0111       TO MML1-FIELD-CODE
116500                 MOVE ZEROS      TO MML1-FIELD-OCCURRENCE
116600                 MOVE ZEROS      TO MML1-FIELD-OCCURRENCE-2
116700                 MOVE MML1WS-VL-10   TO MML1-VARIABLE-LENGTH
116800                 MOVE MMTM-PHONE
116900                                 TO MML1-VL10-B-DATA-X
117000                 MOVE TM02-PHONE
117100                                 TO MMTM-PHONE
117200                 MOVE MMTM-PHONE
117300                                 TO MML1-VL10-A-DATA-X
117400                 MOVE 'FC16'     TO MBCA-PROGRAM-LOCATION
117500                 PERFORM Y910-WRITE-LOG-RECORD
117600                                 THRU Y919-WLR-EXIT
117700             ELSE
117800                 MOVE TM02-PHONE TO MMTM-PHONE.
117900*
118000     IF  TM02-FED-TAX-L IS GREATER THAN ZERO
118100         IF  TM02-FED-TAX IS NOT EQUAL
118200                                 TO MMTM-FED-TAX-ID
118300             SET WS-UPDATE-SW-YES
118400                                 TO TRUE
118500             IF  MMTM-ADD-COMPLETED
118600                 MOVE 0116           TO MML1-FIELD-CODE
118700                 MOVE ZEROS          TO MML1-FIELD-OCCURRENCE
118800                 MOVE ZEROS          TO MML1-FIELD-OCCURRENCE-2
118900                 MOVE MML1WS-VL-10   TO MML1-VARIABLE-LENGTH
119000                 MOVE MMTM-FED-TAX-ID
119100                                 TO MML1-VL10-B-DATA-X
119200                 MOVE TM02-FED-TAX
119300                                 TO MMTM-FED-TAX-ID
119400                 MOVE MMTM-FED-TAX-ID
119500                                 TO MML1-VL10-A-DATA-X
119600                 MOVE 'FC17'         TO MBCA-PROGRAM-LOCATION
119700                 PERFORM Y910-WRITE-LOG-RECORD
119800                                 THRU Y919-WLR-EXIT
119900             ELSE
120000                 MOVE TM02-FED-TAX
120100                                 TO MMTM-FED-TAX-ID.
120200*
120300     IF  TM02-ST-TAX-L IS GREATER THAN ZERO
120400         IF  TM02-ST-TAX IS NOT EQUAL
120500                                 TO MMTM-STATE-TAX-ID
120600             SET WS-UPDATE-SW-YES
120700                                 TO TRUE
120800             IF  MMTM-ADD-COMPLETED
120900                 MOVE 0117       TO MML1-FIELD-CODE
121000                 MOVE ZEROS      TO MML1-FIELD-OCCURRENCE
121100                 MOVE ZEROS      TO MML1-FIELD-OCCURRENCE-2
121200                 MOVE MML1WS-VL-10
121300                                 TO MML1-VARIABLE-LENGTH
121400                 MOVE MMTM-STATE-TAX-ID
121500                                 TO MML1-VL10-B-DATA-X
121600                 MOVE TM02-ST-TAX
121700                                 TO MMTM-STATE-TAX-ID
121800                 MOVE MMTM-STATE-TAX-ID
121900                                 TO MML1-VL10-A-DATA-X
122000                 MOVE 'FC18'     TO MBCA-PROGRAM-LOCATION
122100                 PERFORM Y910-WRITE-LOG-RECORD
122200                                 THRU Y919-WLR-EXIT
122300             ELSE
122400                 MOVE TM02-ST-TAX
122500                                 TO MMTM-STATE-TAX-ID.
122600*
122700     IF  TM02-TRANS-REF-NBR-L IS GREATER THAN ZERO
122800         IF  TM02-TRANS-REF-NBR IS NOT EQUAL
122900                                 TO MMTM-TRANS-REF-NBR
123000             SET WS-UPDATE-SW-YES
123100                                 TO TRUE
123200             IF  MMTM-ADD-COMPLETED
123300                 MOVE 0201       TO MML1-FIELD-CODE
123400                 MOVE ZEROS      TO MML1-FIELD-OCCURRENCE
123500                 MOVE ZEROS      TO MML1-FIELD-OCCURRENCE-2
123600                 MOVE MML1WS-VL-05
123700                                 TO MML1-VARIABLE-LENGTH
123800                 MOVE MMTM-TRANS-REF-NBR
123900                                 TO MML1-VL05-B-DATA-9
124000                 MOVE TM02-TRANS-REF-NBR
124100                                 TO MMTM-TRANS-REF-NBR
124200                 MOVE MMTM-TRANS-REF-NBR
124300                                 TO MML1-VL05-A-DATA-9
124400                 MOVE 'FC19'     TO MBCA-PROGRAM-LOCATION
124500                 PERFORM Y910-WRITE-LOG-RECORD
124600                                 THRU Y919-WLR-EXIT
124700             ELSE
124800                 MOVE TM02-TRANS-REF-NBR
124900                                 TO MMTM-TRANS-REF-NBR.
125000*
125100     IF  TM02-NBR-MATCHES-L IS GREATER THAN ZERO
125200         IF  TM02-NBR-MATCHES IS NOT EQUAL
125300                                 TO MMTM-NBR-MATCHES
125400             SET WS-UPDATE-SW-YES
125500                                 TO TRUE
125600             IF  MMTM-ADD-COMPLETED
125700                 MOVE 0202           TO MML1-FIELD-CODE
125800                 MOVE ZEROS          TO MML1-FIELD-OCCURRENCE
125900                 MOVE ZEROS          TO MML1-FIELD-OCCURRENCE-2
126000                 MOVE MML1WS-VL-01   TO MML1-VARIABLE-LENGTH
126100                 MOVE MMTM-NBR-MATCHES
126200                                 TO MML1-VL01-B-DATA-9
126300                 MOVE TM02-NBR-MATCHES
126400                                 TO MMTM-NBR-MATCHES
126500                 MOVE MMTM-NBR-MATCHES
126600                                 TO MML1-VL01-A-DATA-9
126700                 MOVE 'FC20'         TO MBCA-PROGRAM-LOCATION
126800                 PERFORM Y910-WRITE-LOG-RECORD
126900                                 THRU Y919-WLR-EXIT
127000             ELSE
127100                 MOVE TM02-NBR-MATCHES
127200                                 TO MMTM-NBR-MATCHES.
127300*
127400     PERFORM
127500         VARYING X-TM02-REGION
127600         FROM 1 BY 1
127700         UNTIL X-TM02-REGION IS GREATER THAN 6
127800         SET  X-MMTM-REGION      TO X-TM02-REGION
127900         IF  TM02-REGION-L (X-TM02-REGION)
128000                                 IS GREATER THAN ZERO
128100             IF  TM02-REGION (X-TM02-REGION) IS NOT EQUAL
128200                                 TO MMTM-REGION
128300                                    (X-MMTM-REGION)
128400                 SET WS-UPDATE-SW-YES
128500                                 TO TRUE
128600                 IF  MMTM-ADD-COMPLETED
128700                     MOVE 0203   TO MML1-FIELD-CODE
128800                     SET MML1-FIELD-OCCURRENCE
128900                                 TO X-TM02-REGION
129000                     MOVE ZEROS  TO MML1-FIELD-OCCURRENCE-2
129100                     MOVE MML1WS-VL-03
129200                                 TO MML1-VARIABLE-LENGTH
129300                     MOVE MMTM-REGION (X-MMTM-REGION)
129400                                 TO MML1-VL03-B-DATA-X
129500                     MOVE TM02-REGION (X-TM02-REGION)
129600                                 TO MMTM-REGION
129700                                    (X-MMTM-REGION)
129800                     MOVE MMTM-REGION (X-MMTM-REGION)
129900                                 TO MML1-VL03-A-DATA-X
130000                     MOVE 'FC21' TO MBCA-PROGRAM-LOCATION
130100                     PERFORM Y910-WRITE-LOG-RECORD
130200                                 THRU Y919-WLR-EXIT
130300                 ELSE
130400                     MOVE TM02-REGION (X-TM02-REGION)
130500                                 TO MMTM-REGION (X-MMTM-REGION)
130600                 END-IF
130700             END-IF
130800         END-IF
130900      END-PERFORM.
131000*
131100     PERFORM
131200         VARYING X-TM02-COUNTRY
131300         FROM 1 BY 1
131400         UNTIL X-TM02-COUNTRY IS GREATER THAN 10
131500         SET  X-MMTM-COUNTRY     TO X-TM02-COUNTRY
131600         IF  TM02-COUNTRY-L (X-TM02-COUNTRY)
131700                                 IS GREATER THAN ZERO
131800             IF  TM02-COUNTRY (X-TM02-COUNTRY) IS NOT EQUAL
131900                                 TO MMTM-COUNTRY
132000                                    (X-MMTM-COUNTRY)
132100                 SET WS-UPDATE-SW-YES
132200                                 TO TRUE
132300                 IF  MMTM-ADD-COMPLETED
132400                     MOVE 0204       TO MML1-FIELD-CODE
132500                     SET MML1-FIELD-OCCURRENCE
132600                                 TO X-TM02-COUNTRY
132700                     MOVE ZEROS      TO MML1-FIELD-OCCURRENCE-2
132800                     MOVE MML1WS-VL-03
132900                                 TO MML1-VARIABLE-LENGTH
133000                     MOVE MMTM-COUNTRY (X-MMTM-COUNTRY)
133100                                 TO MML1-VL03-B-DATA-X
133200                     MOVE TM02-COUNTRY (X-TM02-COUNTRY)
133300                                 TO MMTM-COUNTRY
133400                                    (X-MMTM-COUNTRY)
133500                     MOVE MMTM-COUNTRY (X-MMTM-COUNTRY)
133600                                 TO MML1-VL03-A-DATA-X
133700                     MOVE 'FC22'         TO MBCA-PROGRAM-LOCATION
133800                     PERFORM Y910-WRITE-LOG-RECORD
133900                                 THRU Y919-WLR-EXIT
134000                 ELSE
134100                     MOVE TM02-COUNTRY (X-TM02-COUNTRY)
134200                                 TO MMTM-COUNTRY
134300                                    (X-MMTM-COUNTRY)
134400                 END-IF
134500             END-IF
134600         END-IF
134700      END-PERFORM.
134800*
134900 E040-UPDATE-MMTM.
135000*
135100**************************************************************
135200*    WRITE A LOG RECORD TO SHOW THAT THE LAST MAINT DATE     *
135300*    AND OPERATOR HAS BEEN UPDATED IF FIELDS WERE CHANGED    *
135400*    ON THE SCREEN                                           *
135500**************************************************************
135600*
135700     IF  WS-UPDATE-SW-YES
135800         MOVE 0198               TO MML1-FIELD-CODE
135900         MOVE ZEROES             TO MML1-FIELD-OCCURRENCE
136000                                    MML1-FIELD-OCCURRENCE-2
136100         MOVE MML1WS-VL-03       TO MML1-VARIABLE-LENGTH
136200         MOVE MMTM-LAST-MAINT-OPER
136300                                 TO MML1-VL03-B-DATA-X
136400         MOVE MBCA-OPERATOR-ID   TO MMTM-LAST-MAINT-OPER
136500         MOVE MMTM-LAST-MAINT-OPER
136600                                 TO MML1-VL03-A-DATA-X
136700         MOVE 'FC23'             TO MBCA-PROGRAM-LOCATION
136800         PERFORM Y910-WRITE-LOG-RECORD
136900                                 THRU Y919-WLR-EXIT
137000         MOVE 0199               TO MML1-FIELD-CODE
137100         MOVE MML1WS-VL-07       TO MML1-VARIABLE-LENGTH
137200         MOVE MMTM-LAST-MAINT-DATE
137300                                 TO MML1-VL07-B-DATA-9
137400         MOVE MBCA-START-DATE    TO MMTM-LAST-MAINT-DATE
137500         MOVE MMTM-LAST-MAINT-DATE
137600                                 TO MML1-VL07-A-DATA-9
137700         MOVE 'FC24'             TO MBCA-PROGRAM-LOCATION
137800         PERFORM Y910-WRITE-LOG-RECORD
137900                                 THRU Y919-WLR-EXIT.
138000*
138100     IF  MMTM-ADD-PENDING
138200         MOVE MBCA-SCREEN-NBR    TO MMTM-ONLINE-STATUS.
138300*
138400****************************************************
138500*    REWRITE THE TERMINATED MERCHANT RECORD IF     *
138600*    FIELDS HAVE BEEN CHANGED ON THE SCREEN, OR    *
138700*    UNLOCK IT IF THEY HAVE NOT                    *
138800****************************************************
138900*
139000     IF  WS-UPDATE-SW-YES
139100         MOVE 'FC25'             TO MBCA-PROGRAM-LOCATION
139200         SET MBIORO-REWRITE      TO TRUE
139300         PERFORM MMTMAO-ACCESS   THRU MMTMAO-ACCESS-EXIT
139400     ELSE
139500         MOVE 'FC26'             TO MBCA-PROGRAM-LOCATION
139600         SET MBIORO-UNLOCK       TO TRUE
139700         PERFORM MMTMAO-ACCESS   THRU MMTMAO-ACCESS-EXIT.
139800/
139900 F000-SETUP-COMMAREA SECTION.
140000*
140100***************************************************************
140200*  SET UP COMMAREA FIELDS AND TRANSFER TO THE NEXT PROGRAM    *
140300***************************************************************
140400*
140500     MOVE MBCA-EIBAID            TO SS08WS-EIBAID.
140600*
140700     PERFORM MB60PD-EDIT-PAGE-NBR
140800                                 THRU MB60PD-EPN-EXIT.
140900*
141000     IF  SS08WS-VALID-PF-KEY
141100     OR  SS08WS-EIBAID-VALID-PF-KEY
141200         SET MBCA-INITIAL-SCREEN-NBR
141300                                 TO TRUE.
141400*
141500     MOVE DFHBMASK               TO TM02-CURRENT-PAGE-A.
141600*
141700 F090-TRANSFER-XCTL.
141800*
141900     MOVE 'PC05'                 TO MBCA-PROGRAM-LOCATION.
142000     PERFORM MB70PD-XCTL-TO-MBOXCTL
142100                                 THRU MB70PD-XTM-EXIT.
142200*
142300 Y910-WRITE-LOG-RECORD.
142400*
142500     IF  MMTM-ADD-PENDING
142600         GO TO Y919-WLR-EXIT.
142700*
142800     SET MBIORO-WRITE            TO TRUE.
142900     PERFORM MML1AO-ACCESS       THRU MML1AO-ACCESS-EXIT.
143000     MOVE SPACES                 TO MML1-VARIABLE-AREA.
143100*
143200 Y919-WLR-EXIT.
143300     EXIT.
143400/
143500 Z000-COPIED-ROUTINES SECTION.
143600*
143700**********************************
143800*    JUL TO GREG DATE ROUTINE    *
143900**********************************
144000*
144100     COPY SS08PD.
144200/
144300     COPY SS26PD.
144400/
144500     COPY SS27PD.
144600/
144700**********************************
144800*    GREG TO JUL DATE ROUTINE    *
144900**********************************
145000*
145100     COPY SS07PD.
145200/
145300**********************************
145400*    DATE VALIDATION ROUTINE     *
145500**********************************
145600*
145700     COPY SS05PD.
145800/
145900*********************************
146000*    LINE 24 PF KEYS ROUTINE    *
146100*********************************
146200*
146300     COPY SS15PD.
146400/
146500****************************************************
146600*    TERMINATED MERCHANT RECORD ACCESS ROUTINES    *
146700****************************************************
146800*
146900     COPY MMTMAO.
147000/
147100****************************************************
147200*    MERCHANT MASTER RECORD ACCESS ROUTINES        *
147300****************************************************
147400*
147500     COPY MMMMAO.
147600/
147700****************************************************
147800*    STORE MASTER RECORD ACCESS ROUTINES           *
147900****************************************************
148000*
148100     COPY MMSMAO.
148200/
148300*****************************************
148400*    LOG FILE RECORD ACCESS ROUTINES    *
148500*****************************************
148600*
148700     COPY MML1AO.
148800/
148900*****************************
149000*    ONLINE MAP ROUTINES    *
149100*****************************
149200*
149300     COPY MB60PD REPLACING 'MBMAPXX' BY 'MBTM02 '
149400                           MBMAPXXI BY MBTM02I
149500                           MBMAPXXO BY MBTM02O.
149600/
149700***************************
149800*    ONLINE PROCEDURES    *
149900***************************
150000*
150100     COPY MB70PD.
150200/
150300     COPY SMFTPXO.
