000100 IDENTIFICATION DIVISION.
000200 PROGRAM-ID. MBOTM03.
000201*       RELEASE DATE=08/24/01.        REVISION LEVEL=08.06      * ++++++++
000202***************************************************************** ++++++++
000203*WARNING.  THIS COMPUTER PROGRAM IS PROTECTED BY COPYRIGHT LAW  * ++++++++
000204*AND INTERNATIONAL TREATIES.  UNAUTHORIZED REPRODUCTION OR      * ++++++++
000205*DISTRIBUTION OF THIS PROGRAM, OR ANY PORTION OF IT, MAY RESULT * ++++++++
000206*IN SEVERE CIVIL AND CRIMINAL PENATLIES, AND WILL BE PROSECUTED * ++++++++
000207*TO THE MAXIMUM EXTENT POSSIBLE UNDER THE LAW.                  * ++++++++
000208*COPYRIGHT 1999 PAYSYS INTERNATIONAL, INC.  ALL RIGHTS RESERVED.* ++++++++
000209***************************************************************** ++++++++
000300*****************************************************************
000400*                                                               *
000500*   V - PLUS  M E R C H A N T   B A N K C A R D   S Y S T E M   *
000600*                                                               *
000700*      MBOTM03 - TERMINATED MERCHANTS ADD/MAINT/INQ             *
000800*                SCREEN 03                                      *
000900*                                                               *
001000*              1. TRANSID                                       *
001100*                 B. MBTM                                       *
001200*              2. MAPS USED -                                   *
001300*                 A. MBTM03 (SCREEN 03)                         *
001400*              3. FILES USED -                                  *
001500*                 A. MMTM (TERMINATED MERCHANTS FILE)           *
001600*                 B. MMMM (MERCHANT MASTER)                     *
001700*                 C. MMSM (STORE MASTER)                        *
001800*                 D. MML1 (LOG FILE)                            *
001900*                                                               *
002000*****************************************************************
002100*
002200 ENVIRONMENT DIVISION.
002300*
002400 DATA DIVISION.
002500*
002600 WORKING-STORAGE SECTION.
002700*
002800 01  FILLER                  PIC  X(12)      VALUE '** WS-BEG **'.
002900*
003000 01  FILLER                  PIC  X(14)      VALUE
003100     'MISCELLANEOUS:'.
003200*
003300 01  FILLER                  PIC  X(17)      VALUE
003400     'PROGRAM SWITCHES:'.
003500*
003600 01  WS-PROGRAM-SWITCHES.
003700     03  WS-UPDATE-SW        PIC  X(01)      VALUE 'N'.
003800         88  WS-UPDATE-SW-YES                VALUE 'Y'.
003900         88  WS-UPDATE-SW-NO                 VALUE 'N'.
004000     03  WS-CROSS-EDIT-X     PIC  X(01)      VALUE 'N'.
004100         88  WS-CROSS-EDIT                   VALUE 'Y'.
004200         88  WS-NO-CROSS-EDIT                VALUE 'N'.
004300/
004400 01  FILLER                  PIC  X(29)      VALUE
004500     'I/O REQUEST BLOCK WORK AREAS:'.
004600*
004700     COPY MBIOWS.
004800/
004900 01  FILLER                  PIC  X(18)      VALUE
005000     'I/O REQUEST BLOCK:'.
005100*
005200     COPY MBIORO.
005300/
005400 01  FILLER                  PIC  X(23)      VALUE
005500     'TERMINATED MERCHANT I/O'.
005600*
005700     COPY MMTMIO.
005800/
005900 01  FILLER                  PIC  X(25)      VALUE
006000     'LOG RECORD REQUEST BLOCK:'.
006100*
006200     COPY MML1WS REPLACING ==:MML1:== BY ==MML1==.
006300/
006400 01  FILLER                  PIC  X(20)      VALUE
006500     'CCS DATE WORK AREAS:'.
006600*
006700     COPY SS01WS.
006800/
006900 01  FILLER                  PIC  X(15)      VALUE
007000     'CCS WORK AREAS:'.
007100*
007200     COPY SS08WS.
007300/
007400     COPY SS00WS.
007500/
007600     COPY SMFTWS.
007700/
007800     COPY SMPTRL REPLACING ==:SMPT:== BY ==SMPT==.
007900/
008000     COPY MB61LK.
008100/
008200 01  FILLER                  PIC  X(12)      VALUE '** WS-END **'.
008300/
008400 LINKAGE SECTION.
008500*
008600 01  DFHCOMMAREA.
008700*
008800     COPY MB60WS.
008900/
009000*********************************
009100*    TERMINATED MERCHANT MAP    *
009200*********************************
009300*
009400     COPY MBTM03.
009500/
009600**********************************************
009700*    TERMINATED MERCHANT MAP REDEFINITION    *
009800**********************************************
009900*
010000     COPY MBTM03R.
010100/
010200******************************************
010300*    TERMINATED MECHANT RECORD LAYOUT    *
010400******************************************
010500*
010600     COPY MMTMRL.
010700/
010800******************************************
010900*    MERCHANT MASTER  RECORD LAYOUT      *
011000******************************************
011100*
011200     COPY MMMMRL.
011300/
011400******************************************
011500*    STORE MASTER  RECORD LAYOUT         *
011600******************************************
011700*
011800     COPY MMSMRL.
011900/
012000***************************
012100*    LOG RECORD LAYOUT    *
012200***************************
012300*
012400     COPY MML1RL REPLACING ==:MML1:== BY ==MML1==.
012500/
012600 PROCEDURE DIVISION.
012700*
012800 A000-HOUSEKEEPING SECTION.
012900*
013000 A020-INIT.
013100*
013200     MOVE 'PC01'                 TO MBCA-PROGRAM-LOCATION.
013300     PERFORM MB70PD-ON-LINE-HOUSEKEEPING
013400                                 THRU MB70PD-OLH-EXIT.
013500*
013600     IF  MBCA-RECEIVE-SCREEN
013700         GO TO C000-RECEIVE-SCREEN.
013800/
013900 B000-SEND-SCREEN SECTION.
014000*
014100*********************************************
014200*    GET CICS STORAGE NEEDED FOR THE MAP    *
014300*********************************************
014400*
014500     MOVE 'SC01'                 TO MBCA-PROGRAM-LOCATION.
014600     PERFORM MB60PD-GETMAIN-FOR-MAP
014700                                 THRU MB60PD-GFM-EXIT.
014800*
014900*******************************************
015000*    INITIALIZE THE STANDARD MAP LINES    *
015100*******************************************
015200*
015300     PERFORM MB60PD-INIT-STD-MAP-LINES
015400                                 THRU MB60PD-ISML-EXIT.
015500*
015600**********************************************************
015700*    READ THE TERMINATED MERCHANT RECORD TO DISPLAY      *
015800*    THE SCREEN.                                         *
015900**********************************************************
016000*
016100     MOVE MBCA-MERCHANT-ORG      TO MBIOWS-MMTM-ORG.
016200     MOVE MBCA-MERCHANT          TO MBIOWS-MMTM-MERCHANT.
016300     MOVE MBCA-S-M               TO MBIOWS-MMTM-FILE-TYPE.
016400     MOVE MBCA-ACTION-CODE       TO MBIOWS-MMTM-ACTION-CODE.
016500     MOVE 'FC01'                 TO MBCA-PROGRAM-LOCATION.
016600     SET MBIORO-READ-RANDOM      TO TRUE.
016700     PERFORM MMTMAO-ACCESS       THRU MMTMAO-ACCESS-EXIT.
016800*
016900**********************************************************
017000*    READ THE MERCHANT MASTER FOR MERCHANT NAME          *
017100*                       OR                               *
017200*    READ THE STORE MASTER FOR STORE NAME                *
017300**********************************************************
017400*
017500     IF  MBCA-S-M IS EQUAL TO 'M'
017600         IF  MMTM-ACTION-CODE-INQ
017700             IF  MBCA-MBTM-MERCH-FOUND
017800                 MOVE MBCA-MERCHANT-ORG
017900                                 TO MBIOWS-MMMM-ORG
018000                 MOVE MBCA-MERCHANT
018100                                 TO MBIOWS-MMMM-MERCHANT
018200                 MOVE 'FC02'     TO MBCA-PROGRAM-LOCATION
018300                 SET MBIORO-READ-RANDOM
018400                                 TO TRUE
018500                 PERFORM MMMMAO-ACCESS
018600                                 THRU MMMMAO-ACCESS-EXIT
018700                 MOVE MMMM-NA-LINE (1 1)
018800                                 TO TM03-MERCHANT-NAME
018900             ELSE
019000                 GO TO B020-MOVE-FIELDS-TO-SCREEN
019100         ELSE
019200             MOVE MBCA-MERCHANT-ORG
019300                                 TO MBIOWS-MMMM-ORG
019400             MOVE MBCA-MERCHANT  TO MBIOWS-MMMM-MERCHANT
019500             MOVE 'FC03'         TO MBCA-PROGRAM-LOCATION
019600             SET MBIORO-READ-RANDOM
019700                                 TO TRUE
019800             PERFORM MMMMAO-ACCESS
019900                                 THRU MMMMAO-ACCESS-EXIT
020000             MOVE MMMM-NA-LINE (1 1)
020100                                 TO TM03-MERCHANT-NAME
020200     ELSE
020300         IF  MMTM-ACTION-CODE-INQ
020400             IF  MBCA-MBTM-STORE-FOUND
020500                 MOVE MBCA-MERCHANT-ORG
020600                                 TO MBIOWS-MMSM-ORG
020700                 MOVE MBCA-MERCHANT
020800                                 TO MBIOWS-MMSM-STORE
020900                 MOVE 'FC04'     TO MBCA-PROGRAM-LOCATION
021000                 SET MBIORO-READ-RANDOM
021100                                 TO TRUE
021200                 PERFORM MMSMAO-ACCESS
021300                                 THRU MMSMAO-ACCESS-EXIT
021400                 MOVE MMSM-NA-LINE (1 1)
021500                                 TO TM03-MERCHANT-NAME
021600             ELSE
021700                 GO TO B020-MOVE-FIELDS-TO-SCREEN
021800         ELSE
021900             MOVE MBCA-MERCHANT-ORG
022000                                 TO MBIOWS-MMSM-ORG
022100             MOVE MBCA-MERCHANT
022200                                 TO MBIOWS-MMSM-STORE
022300             MOVE 'FC05'         TO MBCA-PROGRAM-LOCATION
022400             SET MBIORO-READ-RANDOM
022500                                 TO TRUE
022600             PERFORM MMSMAO-ACCESS
022700                                 THRU MMSMAO-ACCESS-EXIT
022800             MOVE MMSM-NA-LINE (1 1)
022900                                 TO TM03-MERCHANT-NAME.
023000*
023100 B020-MOVE-FIELDS-TO-SCREEN.
023200*
023300*********************************************
023400*    MOVE THE TERMINATED MERCHANT FIELDS    *
023500*    FROM THE RECORD TO THE SCREEN          *
023600*********************************************
023700*
023800     MOVE MMTM-ORG               TO TM03-ORG.
023900     MOVE MMTM-MERCHANT          TO TM03-MERCHANT.
024000*
024100     IF  MMTM-ACTION-CODE-INQ
024200         SET TM03-ACTION-INQ     TO TRUE
024300     ELSE
024400         SET TM03-ACTION-ADD     TO TRUE.
024500*
024600     SET X-MMTM-PRIN-DATA        TO MBCA-MBTM-PD-INDEX
024700*
024800     EVALUATE TRUE
024900         WHEN X-MMTM-PRIN-DATA IS EQUAL TO 1
025000              MOVE ' PRINCIPAL NUMBER ONE '
025100                                 TO TM03-PRIN-NBR2-LIT
025200         WHEN X-MMTM-PRIN-DATA IS EQUAL TO 2
025300              MOVE ' PRINCIPAL NUMBER TWO '
025400                                 TO TM03-PRIN-NBR2-LIT
025500         WHEN X-MMTM-PRIN-DATA IS EQUAL TO 3
025600              MOVE 'PRINCIPAL NUMBER THREE'
025700                                 TO TM03-PRIN-NBR2-LIT
025800         WHEN X-MMTM-PRIN-DATA IS EQUAL TO 4
025900              MOVE ' PRINCIPAL NUMBER FOUR'
026000                                 TO TM03-PRIN-NBR2-LIT
026100         WHEN X-MMTM-PRIN-DATA IS EQUAL TO 5
026200              MOVE ' PRINCIPAL NUMBER FIVE'
026300                                 TO TM03-PRIN-NBR2-LIT
026400     END-EVALUATE.
026500*
026600     MOVE MMTM-PR-FIRST-NAME (X-MMTM-PRIN-DATA)
026700                                 TO TM03-1ST-NAME.
026800     MOVE MMTM-PR-MIDDLE-INITIAL (X-MMTM-PRIN-DATA)
026900                                 TO TM03-MID-INIT.
027000     MOVE MMTM-PR-LAST-NAME (X-MMTM-PRIN-DATA)
027100                                 TO TM03-LAST-NAME.
027200     MOVE MMTM-PR-ADDR-1 (X-MMTM-PRIN-DATA)
027300                                 TO TM03-ADDR-1.
027400     MOVE MMTM-PR-ADDR-2 (X-MMTM-PRIN-DATA)
027500                                 TO TM03-ADDR-2.
027600     MOVE MMTM-PR-CITY (X-MMTM-PRIN-DATA)
027700                                 TO TM03-CITY.
027800     MOVE MMTM-PR-STATE (X-MMTM-PRIN-DATA)
027900                                 TO TM03-STATE.
028000     MOVE MMTM-PR-POSTAL-CODE (X-MMTM-PRIN-DATA)
028100                                 TO TM03-POST-CD.
028200     MOVE MMTM-PR-PHONE (X-MMTM-PRIN-DATA)
028300                                 TO TM03-PHONE.
028400     MOVE MMTM-DL-NBR (X-MMTM-PRIN-DATA)
028500                                 TO TM03-DL-NBR.
028600     MOVE MMTM-DL-STATE (X-MMTM-PRIN-DATA)
028700                                 TO TM03-DL-ST.
028800     MOVE MMTM-DL-COUNTRY (X-MMTM-PRIN-DATA)
028900                                 TO TM03-DL-COUNTRY.
029000     MOVE MMTM-PR-COUNTRY (X-MMTM-PRIN-DATA)
029100                                 TO TM03-COUNTRY.
029200     MOVE MMTM-SOC-SEC-NBR (X-MMTM-PRIN-DATA)
029300                                 TO TM03-SSN.
029400*
029500     MOVE SS08WS-CURSOR          TO TM03-1ST-NAME-L.
029600     COMPUTE MBCA-SCREEN-NBR     =  MBCA-SCREEN-NBR - 50.
029700*
029800 B025-CONTINUE.
029900*
030000     MOVE '*TOP*'                TO SS08WS-LINE-24-PF-KEY-FUNC(3).
030100     MOVE '*BOT*'                TO SS08WS-LINE-24-PF-KEY-FUNC(4).
030200     MOVE '*FWD*'                TO SS08WS-LINE-24-PF-KEY-FUNC(5).
030300     MOVE '*BWD*'                TO SS08WS-LINE-24-PF-KEY-FUNC(6).
030400     MOVE SS08WS-LINE-24         TO TM03-PF-KEYS.
030500     MOVE 'RESV'                 TO MBCA-PGMX-PF-TRANS-ID (3).
030600     MOVE 'RESV'                 TO MBCA-PGMX-PF-TRANS-ID (4).
030700     MOVE 'RESV'                 TO MBCA-PGMX-PF-TRANS-ID (5).
030800     MOVE 'RESV'                 TO MBCA-PGMX-PF-TRANS-ID (6).
030900*
031000**********************
031100*    SEND THE MAP    *
031200**********************
031300*
031400     MOVE DFHBMASK               TO TM03-CURRENT-PAGE-A.
031500*
031600     MOVE 'BM01'                 TO MBCA-PROGRAM-LOCATION.
031700     PERFORM MB60PD-SEND-MAP-WITH-ERASE
031800                                 THRU MB60PD-SMWE-EXIT.
031900*
032000************************
032100*    RETURN TO CICS    *
032200************************
032300*
032400     MOVE 'PC02'                 TO MBCA-PROGRAM-LOCATION.
032500     PERFORM MB70PD-RETURN-TRANS-ID
032600                                 THRU MB70PD-RTI-EXIT.
032700/
032800 C000-RECEIVE-SCREEN SECTION.
032900*
033000******************************************
033100*    THIS SECTION RECEIVES THE SCREEN    *
033200******************************************
033300*
033400     MOVE 'BM02'                 TO MBCA-PROGRAM-LOCATION.
033500     PERFORM MB60PD-RECEIVE-MAP  THRU MB60PD-RM-EXIT.
033600*
033700**************************************************************
033800*    CHECK FOR ANOTHER TRANSACTION ID ENTERED BY THE USER    *
033900**************************************************************
034000*
034100     MOVE 'PC03'                 TO MBCA-PROGRAM-LOCATION.
034200     PERFORM MB60PD-NEW-TRANS-ROUTINE
034300                                 THRU MB60PD-NTR-EXIT.
034400*
034500*********************************************
034600*    READ THE TERMINATED MERCHANT RECORD    *
034700*********************************************
034800*
034900     MOVE MBCA-MERCHANT-ORG      TO MBIOWS-MMTM-ORG
035000                                    TM03-ORG.
035100     MOVE MBCA-MERCHANT          TO MBIOWS-MMTM-MERCHANT
035200                                    TM03-MERCHANT.
035300     MOVE MBCA-S-M               TO MBIOWS-MMTM-FILE-TYPE.
035400     MOVE MBCA-ACTION-CODE       TO MBIOWS-MMTM-ACTION-CODE.
035500     MOVE 'FC06'                 TO MBCA-PROGRAM-LOCATION.
035600     SET MBIORO-READ-RANDOM      TO TRUE.
035700     PERFORM MMTMAO-ACCESS       THRU MMTMAO-ACCESS-EXIT.
035800*
035900 C020-FIELD-EDITS.
036000*
036100*********************
036200*    FIELD EDITS    *
036300*********************
036400*
036500     SET X-MMTM-PRIN-DATA        TO MBCA-MBTM-PD-INDEX.
036600*
036700     SET WS-NO-CROSS-EDIT        TO TRUE.
036800*
036900     EVALUATE TRUE
037000         WHEN X-MMTM-PRIN-DATA IS EQUAL TO 1
037100              MOVE ' PRINCIPAL NUMBER ONE '
037200                                 TO TM03-PRIN-NBR2-LIT
037300         WHEN X-MMTM-PRIN-DATA IS EQUAL TO 2
037400              MOVE ' PRINCIPAL NUMBER TWO '
037500                                 TO TM03-PRIN-NBR2-LIT
037600         WHEN X-MMTM-PRIN-DATA IS EQUAL TO 3
037700              MOVE 'PRINCIPAL NUMBER THREE'
037800                                 TO TM03-PRIN-NBR2-LIT
037900         WHEN X-MMTM-PRIN-DATA IS EQUAL TO 4
038000              MOVE ' PRINCIPAL NUMBER FOUR'
038100                                 TO TM03-PRIN-NBR2-LIT
038200         WHEN X-MMTM-PRIN-DATA IS EQUAL TO 5
038300              MOVE ' PRINCIPAL NUMBER FIVE'
038400                                 TO TM03-PRIN-NBR2-LIT
038500     END-EVALUATE.
038600*
038700***************************************************************
038800*    EDIT 1ST NAME
038900***************************************************************
039000*
039100     MOVE DFHBMDAS               TO TM03-1ST-NAME-LP-A
039200                                    TM03-1ST-NAME-RP-A.
039300     MOVE DFHBMASK               TO TM03-1ST-NAME-A.
039400*
039500     IF  TM03-1ST-NAME-L IS LESS THAN 1
039600         MOVE MMTM-PR-FIRST-NAME (X-MMTM-PRIN-DATA)
039700                                 TO TM03-1ST-NAME
039800     ELSE
039900         MOVE DFHBMASF           TO TM03-1ST-NAME-A.
040000*
040100***************************************************************
040200*    EDIT MIDDLE INITIAL
040300***************************************************************
040400*
040500     MOVE DFHBMDAS               TO TM03-MID-INIT-LP-A
040600                                    TM03-MID-INIT-RP-A.
040700     MOVE DFHBMASK               TO TM03-MID-INIT-A.
040800*
040900     IF  TM03-MID-INIT-L IS LESS THAN 1
041000         MOVE MMTM-PR-MIDDLE-INITIAL (X-MMTM-PRIN-DATA)
041100                                 TO TM03-MID-INIT
041200     ELSE
041300         MOVE DFHBMASF           TO TM03-MID-INIT-A.
041400*
041500***************************************************************
041600*    EDIT LAST NAME
041700***************************************************************
041800*
041900     MOVE DFHBMDAS               TO TM03-LAST-NAME-LP-A
042000                                    TM03-LAST-NAME-RP-A.
042100     MOVE DFHBMASK               TO TM03-LAST-NAME-A.
042200*
042300     IF  TM03-LAST-NAME-L IS LESS THAN 1
042400         MOVE MMTM-PR-LAST-NAME (X-MMTM-PRIN-DATA)
042500                                 TO TM03-LAST-NAME
042600     ELSE
042700         MOVE DFHBMASF           TO TM03-LAST-NAME-A.
042800*
042900***************************************************************
043000*    EDIT ADDRESS ONE
043100***************************************************************
043200*
043300     MOVE DFHBMDAS               TO TM03-ADDR-1-LP-A
043400                                    TM03-ADDR-1-RP-A.
043500     MOVE DFHBMASK               TO TM03-ADDR-1-A.
043600*
043700     IF  TM03-ADDR-1-L IS LESS THAN 1
043800         MOVE MMTM-PR-ADDR-1 (X-MMTM-PRIN-DATA)
043900                                 TO TM03-ADDR-1
044000     ELSE
044100         MOVE DFHBMASF           TO TM03-ADDR-1-A.
044200*
044300***************************************************************
044400*    EDIT ADDRESS TWO
044500***************************************************************
044600*
044700     MOVE DFHBMDAS               TO TM03-ADDR-2-LP-A
044800                                    TM03-ADDR-2-RP-A.
044900     MOVE DFHBMASK               TO TM03-ADDR-2-A.
045000*
045100     IF  TM03-ADDR-2-L IS LESS THAN 1
045200         MOVE MMTM-PR-ADDR-2 (X-MMTM-PRIN-DATA)
045300                                 TO TM03-ADDR-2
045400     ELSE
045500         MOVE DFHBMASF           TO TM03-ADDR-2-A.
045600*
045700***************************************************************
045800*    EDIT PRINCIPAL CITY
045900***************************************************************
046000*
046100     MOVE DFHBMDAS               TO TM03-CITY-LP-A
046200                                    TM03-CITY-RP-A.
046300     MOVE DFHBMASK               TO TM03-CITY-A.
046400*
046500     IF  TM03-CITY-L IS LESS THAN 1
046600         MOVE MMTM-PR-CITY (X-MMTM-PRIN-DATA)
046700                                 TO TM03-CITY
046800     ELSE
046900         MOVE DFHBMASF           TO TM03-CITY-A.
047000*
047100***************************************************************
047200*    EDIT PRINCIPAL STATE
047300***************************************************************
047400*
047500     MOVE DFHBMDAS               TO TM03-STATE-LP-A
047600                                    TM03-STATE-RP-A.
047700     MOVE DFHBMASK               TO TM03-STATE-A.
047800*
047900     IF  TM03-STATE-L IS LESS THAN 1
048000         MOVE MMTM-PR-STATE (X-MMTM-PRIN-DATA)
048100                                 TO TM03-STATE
048200     ELSE
048300         MOVE DFHBMASF           TO TM03-STATE-A.
048400*
048500***************************************************************
048600*    EDIT COUNTRY
048700***************************************************************
048800*
048900     MOVE DFHBMDAS               TO TM03-COUNTRY-LP-A
049000                                    TM03-COUNTRY-RP-A.
049100     MOVE DFHBMASK               TO TM03-COUNTRY-A.
049200*
049300     IF  TM03-COUNTRY-L IS LESS THAN 1
049400         MOVE MMTM-PR-COUNTRY (X-MMTM-PRIN-DATA)
049500                                 TO TM03-COUNTRY
049600     ELSE
049700         MOVE DFHBMASF           TO TM03-COUNTRY-A.
049800*
049900***************************************************************
050000*    EDIT PRINCIPAL POSTAL-CODE
050100***************************************************************
050200*
050300     MOVE DFHBMDAS               TO TM03-POST-CD-LP-A
050400                                    TM03-POST-CD-RP-A.
050500     MOVE DFHBMASK               TO TM03-POST-CD-A.
050600*
050700     IF  TM03-POST-CD-L IS LESS THAN 1
050800         MOVE MMTM-PR-POSTAL-CODE (X-MMTM-PRIN-DATA)
050900                                 TO TM03-POST-CD
051000     ELSE
051100         MOVE DFHBMASF           TO TM03-POST-CD-A.
051200*
051300***************************************************************
051400*    EDIT PRINCIPAL PHONE
051500***************************************************************
051600*
051700     MOVE DFHBMDAS               TO TM03-PHONE-LP-A
051800                                    TM03-PHONE-RP-A.
051900     MOVE DFHBMASK               TO TM03-PHONE-A.
052000*
052100     IF  TM03-PHONE-L IS LESS THAN 1
052200         MOVE MMTM-PR-PHONE (X-MMTM-PRIN-DATA)
052300                                 TO TM03-PHONE
052400     ELSE
052500         MOVE DFHBMASF           TO TM03-PHONE-A.
052600*
052700***************************************************************
052800*    EDIT DL NUMBER
052900***************************************************************
053000*
053100     MOVE DFHBMDAS               TO TM03-DL-NBR-LP-A
053200                                    TM03-DL-NBR-RP-A.
053300     MOVE DFHBMASK               TO TM03-DL-NBR-A.
053400*
053500     IF  TM03-DL-NBR-L IS LESS THAN 1
053600         MOVE MMTM-DL-NBR (X-MMTM-PRIN-DATA)
053700                                 TO TM03-DL-NBR
053800     ELSE
053900         MOVE DFHBMASF           TO TM03-DL-NBR-A.
054000*
054100***************************************************************
054200*    EDIT DL STATE
054300***************************************************************
054400*
054500     MOVE DFHBMDAS               TO TM03-DL-ST-LP-A
054600                                    TM03-DL-ST-RP-A.
054700     MOVE DFHBMASK               TO TM03-DL-ST-A.
054800*
054900     IF  TM03-DL-ST-L IS LESS THAN 1
055000         MOVE MMTM-DL-STATE (X-MMTM-PRIN-DATA)
055100                                 TO TM03-DL-ST
055200     ELSE
055300         MOVE DFHBMASF           TO TM03-DL-ST-A.
055400*
055500***************************************************************
055600*    EDIT DL COUNTRY
055700***************************************************************
055800*
055900     MOVE DFHBMDAS               TO TM03-DL-COUNTRY-LP-A
056000                                    TM03-DL-COUNTRY-RP-A.
056100     MOVE DFHBMASK               TO TM03-DL-COUNTRY-A.
056200*
056300     IF  TM03-DL-COUNTRY-L IS LESS THAN 1
056400         MOVE MMTM-DL-COUNTRY (X-MMTM-PRIN-DATA)
056500                                 TO TM03-DL-COUNTRY
056600     ELSE
056700         MOVE DFHBMASF           TO TM03-DL-COUNTRY-A.
056800*
056900***************************************************************
057000*    EDIT SOCIAL SECURITY NUMBER
057100***************************************************************
057200*
057300     MOVE DFHBMDAS               TO TM03-SSN-LP-A
057400                                    TM03-SSN-RP-A.
057500     MOVE DFHBMASK               TO TM03-SSN-A.
057600*
057700     IF  TM03-SSN-L IS LESS THAN 1
057800         MOVE MMTM-SOC-SEC-NBR (X-MMTM-PRIN-DATA)
057900                                 TO TM03-SSN
058000     ELSE
058100         MOVE DFHBMASF           TO TM03-SSN-A.
058200*
058300*
058400******************************************************************
058500*    IF THIS IS PRINCIPAL NUMBER ONE THE FIRST NAME, LAST NAME,  *
058600*    AND SOC SEC NBR MUST HAVE VALID DATA.                       *
058700*    ALSO, OCCURANCES TWO AND THREE MUST HAVE VALID DATA IN THE  *
058800*    SAME 4 FIELDS IF ANY FIELD FOR THE OCCURANCE CONTAINS DATA. *
058900******************************************************************
059000*
059100 C500-CROSS-EDIT.
059200*
059300     IF  X-MMTM-PRIN-DATA IS EQUAL TO 1
059400     AND (TM03-1ST-NAME  IS EQUAL TO SPACES
059500     OR  TM03-LAST-NAME IS EQUAL TO SPACES)
059600         SET SS08WS-ERROR-SW-YES TO TRUE
059700         MOVE SS08WS-CURSOR      TO TM03-1ST-NAME-L
059800         MOVE DFHBMASB           TO TM03-1ST-NAME-LP-A
059900                                    TM03-1ST-NAME-RP-A
060000                                    TM03-LAST-NAME-LP-A
060100                                    TM03-LAST-NAME-RP-A
060200         MOVE DFHBMUBF           TO TM03-1ST-NAME-A
060300                                    TM03-LAST-NAME-A.
060400*
060441     IF (TM03-COUNTRY IS EQUAL TO 'USA' OR                        FX800059
060442         TM03-COUNTRY IS EQUAL TO 'US ')                          FX800059
060443     AND TM03-STATE IS EQUAL TO SPACES                            FX800059
060444         SET SS08WS-ERROR-SW-YES TO TRUE                          FX800059
060445         MOVE SS08WS-CURSOR      TO TM03-STATE-L                  FX800059
060446         MOVE DFHBMASB           TO TM03-STATE-LP-A               FX800059
060447                                    TM03-STATE-RP-A               FX800059
060448         MOVE DFHBMUBF           TO TM03-STATE-A.                 FX800059
060449*                                                                 FX800059
060450     IF (TM03-DL-COUNTRY IS EQUAL TO 'USA' OR                     FX800059
060451         TM03-DL-COUNTRY IS EQUAL TO 'US ')                       FX800059
060452     AND TM03-DL-ST IS EQUAL TO SPACES                            FX800059
060453         SET SS08WS-ERROR-SW-YES TO TRUE                          FX800059
060454         MOVE SS08WS-CURSOR      TO TM03-DL-ST-L                  FX800059
060455         MOVE DFHBMASB           TO TM03-DL-ST-LP-A               FX800059
060456                                    TM03-DL-ST-RP-A               FX800059
060457         MOVE DFHBMUBF           TO TM03-DL-ST-A.                 FX800059
060458*                                                                 FX800059
060500 C599-CE-EXIT.
060600     EXIT.
060700/
060800 D000-RETURN-ERRORS SECTION.
060900*
061000     IF  SS08WS-ERROR-SW-NO
061100         GO TO E000-UPDATE-FILE.
061200*
061300***************************************************************
061400*    INITIALIZE THE STANDARD MAP LINES.  IN AN ERROR          *
061500*    CONDITION, THIS ROUTINE IS PERFORMED PRIMARILY           *
061600*    TO UPDATE THE DATE AND TIME ON THE SCREEN.               *
061700***************************************************************
061800*
061900     PERFORM MB60PD-INIT-STD-MAP-LINES
062000                                 THRU MB60PD-ISML-EXIT.
062100*
062200     MOVE '*TOP*'                TO SS08WS-LINE-24-PF-KEY-FUNC(3).
062300     MOVE '*BOT*'                TO SS08WS-LINE-24-PF-KEY-FUNC(4).
062400     MOVE '*FWD*'                TO SS08WS-LINE-24-PF-KEY-FUNC(5).
062500     MOVE '*BWD*'                TO SS08WS-LINE-24-PF-KEY-FUNC(6).
062600     MOVE SS08WS-LINE-24         TO TM03-PF-KEYS.
062700     MOVE 'RESV'                 TO MBCA-PGMX-PF-TRANS-ID (3).
062800     MOVE 'RESV'                 TO MBCA-PGMX-PF-TRANS-ID (4).
062900     MOVE 'RESV'                 TO MBCA-PGMX-PF-TRANS-ID (5).
063000     MOVE 'RESV'                 TO MBCA-PGMX-PF-TRANS-ID (6).
063100*
063200**********************
063300*    SEND THE MAP    *
063400**********************
063500*
063600     MOVE 'BM03'                 TO MBCA-PROGRAM-LOCATION.
063700     PERFORM MB60PD-SEND-MAP-DATA-ONLY
063800                                 THRU MB60PD-SMDO-EXIT.
063900*
064000************************
064100*    RETURN TO CICS    *
064200************************
064300*
064400     MOVE 'PC04'                 TO MBCA-PROGRAM-LOCATION.
064500     PERFORM MB70PD-RETURN-TRANS-ID
064600                                 THRU MB70PD-RTI-EXIT.
064700/
064800 E000-UPDATE-FILE SECTION.
064900*
065000********************************************************
065100*    READ THE TERMINATED MERCHANT RECORD FOR UPDATE    *
065200********************************************************
065300*
065400     MOVE MMTM-RECORD            TO MMTMIO-RECORD.
065500*
065600     MOVE 'FC07'                 TO MBCA-PROGRAM-LOCATION.
065700     SET MBIORO-READ-RANDOM-UPDATE
065800                                 TO TRUE.
065900     PERFORM MMTMAO-ACCESS       THRU MMTMAO-ACCESS-EXIT.
066000*
066100     MOVE MMTMIO-RECORD          TO MMTM-RECORD.
066200*
066300*************************************
066400*    OBTAIN STORAGE FOR LOG FILE    *
066500*    RECORD IF DOING MAINTENANCE    *
066600*************************************
066700*
066800     MOVE 'SC02'                 TO MBCA-PROGRAM-LOCATION.
066900     SET MBIORO-GETMAIN          TO TRUE.
067000     PERFORM MML1AO-ACCESS       THRU MML1AO-ACCESS-EXIT.
067100*
067200*************************************************
067300*    SET UP THE COMMON PORTION OF THE RECORD    *
067400*************************************************
067500*
067600     MOVE 'TM'                   TO MML1-FILE-CODE.
067700     MOVE MBCA-MERCHANT-ORG      TO MML1-MMTM-ORG.
067800     MOVE MBCA-MERCHANT          TO MML1-MMTM-MERCHANT.
067900     MOVE MBCA-S-M               TO MML1-MMTM-FILE-TYPE.
068000     MOVE MBCA-SIGNON-NAME       TO MML1-SIGNON-NAME.
068100     MOVE MBCA-TERMINAL-ID       TO MML1-TERMINAL-ID.
068200     MOVE ZEROS                  TO MML1-SOURCE-CODE.
068300     MOVE MBCA-FIELD-SECURITY    TO MML1-FIELD-SECURITY.
068400*
068500 E020-UPDATE-FIELDS.
068600*
068700     IF  TM03-1ST-NAME-L IS GREATER THAN ZERO
068800         IF  TM03-1ST-NAME IS NOT EQUAL
068900                                 TO MMTM-PR-FIRST-NAME
069000                                    (X-MMTM-PRIN-DATA)
069100             SET WS-UPDATE-SW-YES
069200                                 TO TRUE
069300             IF  MMTM-ADD-COMPLETED
069400                 MOVE 0301       TO MML1-FIELD-CODE
069500                 SET MML1-FIELD-OCCURRENCE
069600                                 TO X-MMTM-PRIN-DATA
069700                 MOVE ZEROS      TO MML1-FIELD-OCCURRENCE-2
069800                 MOVE MML1WS-VL-20
069900                                 TO MML1-VARIABLE-LENGTH
070000                 MOVE MMTM-PR-FIRST-NAME (X-MMTM-PRIN-DATA)
070100                                 TO MML1-VL20-B-DATA-X
070200                 MOVE TM03-1ST-NAME
070300                                 TO MMTM-PR-FIRST-NAME
070400                                    (X-MMTM-PRIN-DATA)
070500                 MOVE MMTM-PR-FIRST-NAME (X-MMTM-PRIN-DATA)
070600                                 TO MML1-VL20-A-DATA-X
070700                 MOVE 'FC08'     TO MBCA-PROGRAM-LOCATION
070800                 PERFORM Y910-WRITE-LOG-RECORD
070900                                 THRU Y919-WLR-EXIT
071000             ELSE
071100                 MOVE TM03-1ST-NAME
071200                                 TO MMTM-PR-FIRST-NAME
071300                                    (X-MMTM-PRIN-DATA).
071400*
071500     IF  TM03-MID-INIT-L IS GREATER THAN ZERO
071600         IF  TM03-MID-INIT IS NOT EQUAL
071700                                 TO MMTM-PR-MIDDLE-INITIAL
071800                                    (X-MMTM-PRIN-DATA)
071900             SET WS-UPDATE-SW-YES
072000                                 TO TRUE
072100             IF  MMTM-ADD-COMPLETED
072200                 MOVE 0302           TO MML1-FIELD-CODE
072300                 SET MML1-FIELD-OCCURRENCE
072400                                   TO X-MMTM-PRIN-DATA
072500                 MOVE ZEROS          TO MML1-FIELD-OCCURRENCE-2
072600                 MOVE MML1WS-VL-01   TO MML1-VARIABLE-LENGTH
072700                 MOVE MMTM-PR-MIDDLE-INITIAL (X-MMTM-PRIN-DATA)
072800                                 TO MML1-VL01-B-DATA-X
072900                 MOVE TM03-MID-INIT  TO MMTM-PR-MIDDLE-INITIAL
073000                                    (X-MMTM-PRIN-DATA)
073100                 MOVE MMTM-PR-MIDDLE-INITIAL (X-MMTM-PRIN-DATA)
073200                                 TO MML1-VL01-A-DATA-X
073300                 MOVE 'FC09'         TO MBCA-PROGRAM-LOCATION
073400                 PERFORM Y910-WRITE-LOG-RECORD
073500                                 THRU Y919-WLR-EXIT
073600             ELSE
073700                 MOVE TM03-MID-INIT
073800                                 TO MMTM-PR-MIDDLE-INITIAL
073900                                    (X-MMTM-PRIN-DATA).
074000*
074100     IF  TM03-LAST-NAME-L IS GREATER THAN ZERO
074200         IF  TM03-LAST-NAME IS NOT EQUAL
074300                                 TO MMTM-PR-LAST-NAME
074400                                    (X-MMTM-PRIN-DATA)
074500             SET WS-UPDATE-SW-YES
074600                                 TO TRUE
074700             IF  MMTM-ADD-COMPLETED
074800                 MOVE 0303       TO MML1-FIELD-CODE
074900                 SET MML1-FIELD-OCCURRENCE
075000                                 TO X-MMTM-PRIN-DATA
075100                 MOVE ZEROS      TO MML1-FIELD-OCCURRENCE-2
075200                 MOVE MML1WS-VL-30
075300                                 TO MML1-VARIABLE-LENGTH
075400                 MOVE MMTM-PR-LAST-NAME (X-MMTM-PRIN-DATA)
075500                                 TO MML1-VL30-B-DATA-X
075600                 MOVE TM03-LAST-NAME TO MMTM-PR-LAST-NAME
075700                                    (X-MMTM-PRIN-DATA)
075800                 MOVE MMTM-PR-LAST-NAME (X-MMTM-PRIN-DATA)
075900                                 TO MML1-VL30-A-DATA-X
076000                 MOVE 'FC10'     TO MBCA-PROGRAM-LOCATION
076100                 PERFORM Y910-WRITE-LOG-RECORD
076200                                 THRU Y919-WLR-EXIT
076300             ELSE
076400                 MOVE TM03-LAST-NAME
076500                                 TO MMTM-PR-LAST-NAME
076600                                    (X-MMTM-PRIN-DATA).
076700*
076800     IF  TM03-ADDR-1-L IS GREATER THAN ZERO
076900         IF  TM03-ADDR-1 IS NOT EQUAL
077000                                 TO MMTM-PR-ADDR-1
077100                                    (X-MMTM-PRIN-DATA)
077200             SET WS-UPDATE-SW-YES
077300                                 TO TRUE
077400             IF  MMTM-ADD-COMPLETED
077500                 MOVE 0304       TO MML1-FIELD-CODE
077600                 SET MML1-FIELD-OCCURRENCE
077700                                 TO X-MMTM-PRIN-DATA
077800                 MOVE ZEROS      TO MML1-FIELD-OCCURRENCE-2
077900                 MOVE MML1WS-VL-30
078000                                 TO MML1-VARIABLE-LENGTH
078100                 MOVE MMTM-PR-ADDR-1 (X-MMTM-PRIN-DATA)
078200                                 TO MML1-VL30-B-DATA-X
078300                 MOVE TM03-ADDR-1
078400                                 TO MMTM-PR-ADDR-1
078500                                    (X-MMTM-PRIN-DATA)
078600                 MOVE MMTM-PR-ADDR-1 (X-MMTM-PRIN-DATA)
078700                                 TO MML1-VL30-A-DATA-X
078800                 MOVE 'FC11'     TO MBCA-PROGRAM-LOCATION
078900                 PERFORM Y910-WRITE-LOG-RECORD
079000                                 THRU Y919-WLR-EXIT
079100             ELSE
079200                 MOVE TM03-ADDR-1
079300                                 TO MMTM-PR-ADDR-1
079400                                    (X-MMTM-PRIN-DATA).
079500*
079600     IF  TM03-ADDR-2-L IS GREATER THAN ZERO
079700         IF  TM03-ADDR-2 IS NOT EQUAL
079800                                 TO MMTM-PR-ADDR-2
079900                                    (X-MMTM-PRIN-DATA)
080000             SET WS-UPDATE-SW-YES
080100                                 TO TRUE
080200             IF  MMTM-ADD-COMPLETED
080300                 MOVE 0305       TO MML1-FIELD-CODE
080400                 SET MML1-FIELD-OCCURRENCE
080500                                 TO X-MMTM-PRIN-DATA
080600                 MOVE ZEROS      TO MML1-FIELD-OCCURRENCE-2
080700                 MOVE MML1WS-VL-30
080800                                 TO MML1-VARIABLE-LENGTH
080900                 MOVE MMTM-PR-ADDR-2 (X-MMTM-PRIN-DATA)
081000                                 TO MML1-VL30-B-DATA-X
081100                 MOVE TM03-ADDR-2
081200                                 TO MMTM-PR-ADDR-2
081300                                    (X-MMTM-PRIN-DATA)
081400                 MOVE MMTM-PR-ADDR-2 (X-MMTM-PRIN-DATA)
081500                                 TO MML1-VL30-A-DATA-X
081600                 MOVE 'FC12'     TO MBCA-PROGRAM-LOCATION
081700                 PERFORM Y910-WRITE-LOG-RECORD
081800                                 THRU Y919-WLR-EXIT
081900             ELSE
082000                 MOVE TM03-ADDR-2
082100                                 TO MMTM-PR-ADDR-2
082200                                    (X-MMTM-PRIN-DATA).
082300*
082400     IF  TM03-CITY-L IS GREATER THAN ZERO
082500         IF  TM03-CITY IS NOT EQUAL
082600                                 TO MMTM-PR-CITY
082700                                    (X-MMTM-PRIN-DATA)
082800             SET WS-UPDATE-SW-YES
082900                                 TO TRUE
083000             IF  MMTM-ADD-COMPLETED
083100                 MOVE 0306       TO MML1-FIELD-CODE
083200                 SET MML1-FIELD-OCCURRENCE
083300                                 TO X-MMTM-PRIN-DATA
083400                 MOVE ZEROS      TO MML1-FIELD-OCCURRENCE-2
083500                 MOVE MML1WS-VL-20
083600                                 TO MML1-VARIABLE-LENGTH
083700                 MOVE MMTM-PR-CITY (X-MMTM-PRIN-DATA)
083800                                 TO MML1-VL20-B-DATA-X
083900                 MOVE TM03-CITY TO MMTM-PR-CITY
084000                                    (X-MMTM-PRIN-DATA)
084100                 MOVE MMTM-PR-CITY (X-MMTM-PRIN-DATA)
084200                                 TO MML1-VL20-A-DATA-X
084300                 MOVE 'FC13'     TO MBCA-PROGRAM-LOCATION
084400                 PERFORM Y910-WRITE-LOG-RECORD
084500                                 THRU Y919-WLR-EXIT
084600             ELSE
084700                 MOVE TM03-CITY  TO MMTM-PR-CITY
084800                                    (X-MMTM-PRIN-DATA).
084900*
085000     IF  TM03-STATE-L IS GREATER THAN ZERO
085100         IF  TM03-STATE IS NOT EQUAL
085200                                 TO MMTM-PR-STATE
085300                                    (X-MMTM-PRIN-DATA)
085400             SET WS-UPDATE-SW-YES
085500                                 TO TRUE
085600             IF  MMTM-ADD-COMPLETED
085700                 MOVE 0307       TO MML1-FIELD-CODE
085800                 SET MML1-FIELD-OCCURRENCE
085900                                 TO X-MMTM-PRIN-DATA
086000                 MOVE ZEROS      TO MML1-FIELD-OCCURRENCE-2
086100                 MOVE MML1WS-VL-02
086200                                 TO MML1-VARIABLE-LENGTH
086300                 MOVE MMTM-PR-STATE (X-MMTM-PRIN-DATA)
086400                                 TO MML1-VL02-B-DATA-X
086500                 MOVE TM03-STATE TO MMTM-PR-STATE
086600                                    (X-MMTM-PRIN-DATA)
086700                 MOVE MMTM-PR-STATE (X-MMTM-PRIN-DATA)
086800                                 TO MML1-VL02-A-DATA-X
086900                 MOVE 'FC14'     TO MBCA-PROGRAM-LOCATION
087000                 PERFORM Y910-WRITE-LOG-RECORD
087100                                 THRU Y919-WLR-EXIT
087200             ELSE
087300                 MOVE TM03-STATE TO MMTM-PR-STATE
087400                                    (X-MMTM-PRIN-DATA).
087500*
087600     IF  TM03-COUNTRY-L IS GREATER THAN ZERO
087700         IF  TM03-COUNTRY IS NOT EQUAL
087800                                 TO MMTM-PR-COUNTRY
087900                                    (X-MMTM-PRIN-DATA)
088000             SET WS-UPDATE-SW-YES
088100                                 TO TRUE
088200             IF  MMTM-ADD-COMPLETED
088300                 MOVE 0314       TO MML1-FIELD-CODE
088400                 SET MML1-FIELD-OCCURRENCE
088500                                 TO X-MMTM-PRIN-DATA
088600                 MOVE ZEROS      TO MML1-FIELD-OCCURRENCE-2
088700                 MOVE MML1WS-VL-03
088800                                 TO MML1-VARIABLE-LENGTH
088900                 MOVE MMTM-PR-COUNTRY (X-MMTM-PRIN-DATA)
089000                                 TO MML1-VL03-B-DATA-X
089100                 MOVE TM03-COUNTRY
089200                                 TO MMTM-PR-COUNTRY
089300                                    (X-MMTM-PRIN-DATA)
089400                 MOVE MMTM-PR-COUNTRY (X-MMTM-PRIN-DATA)
089500                                 TO MML1-VL03-A-DATA-X
089600                 MOVE 'FC15'     TO MBCA-PROGRAM-LOCATION
089700                 PERFORM Y910-WRITE-LOG-RECORD
089800                                 THRU Y919-WLR-EXIT
089900             ELSE
090000                 MOVE TM03-COUNTRY
090100                                 TO MMTM-PR-COUNTRY
090200                                    (X-MMTM-PRIN-DATA).
090300*
090400     IF  TM03-POST-CD-L IS GREATER THAN ZERO
090500         IF  TM03-POST-CD IS NOT EQUAL
090600                                 TO MMTM-PR-POSTAL-CODE
090700                                    (X-MMTM-PRIN-DATA)
090800             SET WS-UPDATE-SW-YES
090900                                 TO TRUE
091000             IF  MMTM-ADD-COMPLETED
091100                 MOVE 0308       TO MML1-FIELD-CODE
091200                 SET MML1-FIELD-OCCURRENCE
091300                                 TO X-MMTM-PRIN-DATA
091400                 MOVE ZEROS      TO MML1-FIELD-OCCURRENCE-2
091500                 MOVE MML1WS-VL-10
091600                                 TO MML1-VARIABLE-LENGTH
091700                 MOVE MMTM-PR-POSTAL-CODE (X-MMTM-PRIN-DATA)
091800                                 TO MML1-VL10-B-DATA-X
091900                 MOVE TM03-POST-CD
092000                                 TO MMTM-PR-POSTAL-CODE
092100                                    (X-MMTM-PRIN-DATA)
092200                 MOVE MMTM-PR-POSTAL-CODE (X-MMTM-PRIN-DATA)
092300                                 TO MML1-VL10-A-DATA-X
092400                 MOVE 'FC16'     TO MBCA-PROGRAM-LOCATION
092500                 PERFORM Y910-WRITE-LOG-RECORD
092600                                 THRU Y919-WLR-EXIT
092700             ELSE
092800                 MOVE TM03-POST-CD
092900                                 TO MMTM-PR-POSTAL-CODE
093000                                    (X-MMTM-PRIN-DATA).
093100*
093200     IF  TM03-PHONE-L IS GREATER THAN ZERO
093300         IF  TM03-PHONE IS NOT EQUAL
093400                                 TO MMTM-PR-PHONE
093500                                    (X-MMTM-PRIN-DATA)
093600             SET WS-UPDATE-SW-YES
093700                                 TO TRUE
093800             IF  MMTM-ADD-COMPLETED
093900                 MOVE 0309       TO MML1-FIELD-CODE
094000                 SET MML1-FIELD-OCCURRENCE
094100                                 TO X-MMTM-PRIN-DATA
094200                 MOVE ZEROS      TO MML1-FIELD-OCCURRENCE-2
094300                 MOVE MML1WS-VL-10
094400                                 TO MML1-VARIABLE-LENGTH
094500                 MOVE MMTM-PR-PHONE (X-MMTM-PRIN-DATA)
094600                                 TO MML1-VL10-B-DATA-X
094700                 MOVE TM03-PHONE TO MMTM-PR-PHONE
094800                                    (X-MMTM-PRIN-DATA)
094900                 MOVE MMTM-PR-PHONE (X-MMTM-PRIN-DATA)
095000                                 TO MML1-VL10-A-DATA-X
095100                 MOVE 'FC17'     TO MBCA-PROGRAM-LOCATION
095200                 PERFORM Y910-WRITE-LOG-RECORD
095300                                 THRU Y919-WLR-EXIT
095400             ELSE
095500                 MOVE TM03-PHONE TO MMTM-PR-PHONE
095600                                    (X-MMTM-PRIN-DATA).
095700*
095800     IF  TM03-DL-NBR-L IS GREATER THAN ZERO
095900         IF  TM03-DL-NBR IS NOT EQUAL
096000                                 TO MMTM-DL-NBR
096100                                    (X-MMTM-PRIN-DATA)
096200             SET WS-UPDATE-SW-YES
096300                                 TO TRUE
096400             IF  MMTM-ADD-COMPLETED
096500                 MOVE 0310       TO MML1-FIELD-CODE
096600                 SET MML1-FIELD-OCCURRENCE
096700                                 TO X-MMTM-PRIN-DATA
096800                 MOVE ZEROS      TO MML1-FIELD-OCCURRENCE-2
096900                 MOVE MML1WS-VL-30
097000                                 TO MML1-VARIABLE-LENGTH
097100                 MOVE MMTM-DL-NBR (X-MMTM-PRIN-DATA)
097200                                 TO MML1-VL30-B-DATA-X
097300                 MOVE TM03-DL-NBR
097400                                 TO MMTM-DL-NBR
097500                                    (X-MMTM-PRIN-DATA)
097600                 MOVE MMTM-DL-NBR (X-MMTM-PRIN-DATA)
097700                                 TO MML1-VL30-A-DATA-X
097800                 MOVE 'FC18'     TO MBCA-PROGRAM-LOCATION
097900                 PERFORM Y910-WRITE-LOG-RECORD
098000                                 THRU Y919-WLR-EXIT
098100             ELSE
098200                 MOVE TM03-DL-NBR
098300                                 TO MMTM-DL-NBR
098400                                    (X-MMTM-PRIN-DATA).
098500*
098600     IF  TM03-DL-ST-L IS GREATER THAN ZERO
098700         IF  TM03-DL-ST IS NOT EQUAL
098800                                 TO MMTM-DL-STATE
098900                                    (X-MMTM-PRIN-DATA)
099000             SET WS-UPDATE-SW-YES
099100                                 TO TRUE
099200             IF  MMTM-ADD-COMPLETED
099300                 MOVE 0311       TO MML1-FIELD-CODE
099400                 SET MML1-FIELD-OCCURRENCE
099500                                 TO X-MMTM-PRIN-DATA
099600                 MOVE ZEROS      TO MML1-FIELD-OCCURRENCE-2
099700                 MOVE MML1WS-VL-02
099800                                 TO MML1-VARIABLE-LENGTH
099900                 MOVE MMTM-DL-STATE (X-MMTM-PRIN-DATA)
100000                                 TO MML1-VL02-B-DATA-X
100100                 MOVE TM03-DL-ST TO MMTM-DL-STATE
100200                                    (X-MMTM-PRIN-DATA)
100300                 MOVE MMTM-DL-STATE (X-MMTM-PRIN-DATA)
100400                                 TO MML1-VL02-A-DATA-X
100500                 MOVE 'FC19'     TO MBCA-PROGRAM-LOCATION
100600                 PERFORM Y910-WRITE-LOG-RECORD
100700                                 THRU Y919-WLR-EXIT
100800             ELSE
100900                 MOVE TM03-DL-ST TO MMTM-DL-STATE
101000                                    (X-MMTM-PRIN-DATA).
101100*
101200     IF  TM03-DL-COUNTRY-L IS GREATER THAN ZERO
101300         IF  TM03-DL-COUNTRY IS NOT EQUAL
101400                                 TO MMTM-DL-COUNTRY
101500                                    (X-MMTM-PRIN-DATA)
101600             SET WS-UPDATE-SW-YES
101700                                 TO TRUE
101800             IF  MMTM-ADD-COMPLETED
101900                 MOVE 0312       TO MML1-FIELD-CODE
102000                 SET MML1-FIELD-OCCURRENCE
102100                                 TO X-MMTM-PRIN-DATA
102200                 MOVE ZEROS      TO MML1-FIELD-OCCURRENCE-2
102300                 MOVE MML1WS-VL-03
102400                                 TO MML1-VARIABLE-LENGTH
102500                 MOVE MMTM-DL-COUNTRY (X-MMTM-PRIN-DATA)
102600                                 TO MML1-VL03-B-DATA-X
102700                 MOVE TM03-DL-COUNTRY
102800                                 TO MMTM-DL-COUNTRY
102900                                    (X-MMTM-PRIN-DATA)
103000                 MOVE MMTM-DL-COUNTRY (X-MMTM-PRIN-DATA)
103100                                 TO MML1-VL03-A-DATA-X
103200                 MOVE 'FC20'     TO MBCA-PROGRAM-LOCATION
103300                 PERFORM Y910-WRITE-LOG-RECORD
103400                                 THRU Y919-WLR-EXIT
103500             ELSE
103600                 MOVE TM03-DL-COUNTRY
103700                                 TO MMTM-DL-COUNTRY
103800                                    (X-MMTM-PRIN-DATA).
103900*
104000     IF  TM03-SSN-L IS GREATER THAN ZERO
104100         IF  TM03-SSN IS NOT EQUAL
104200                                 TO MMTM-SOC-SEC-NBR
104300                                    (X-MMTM-PRIN-DATA)
104400             SET WS-UPDATE-SW-YES
104500                                 TO TRUE
104600             IF  MMTM-ADD-COMPLETED
104700                 MOVE 0313       TO MML1-FIELD-CODE
104800                 SET MML1-FIELD-OCCURRENCE
104900                                 TO X-MMTM-PRIN-DATA
105000                 MOVE ZEROS      TO MML1-FIELD-OCCURRENCE-2
105100                 MOVE MML1WS-VL-10
105200                                 TO MML1-VARIABLE-LENGTH
105300                 MOVE MMTM-SOC-SEC-NBR (X-MMTM-PRIN-DATA)
105400                                 TO MML1-VL10-B-DATA-X
105500                 MOVE TM03-SSN   TO MMTM-SOC-SEC-NBR
105600                                    (X-MMTM-PRIN-DATA)
105700                 MOVE MMTM-SOC-SEC-NBR (X-MMTM-PRIN-DATA)
105800                                 TO MML1-VL10-A-DATA-X
105900                 MOVE 'FC21'     TO MBCA-PROGRAM-LOCATION
106000                 PERFORM Y910-WRITE-LOG-RECORD
106100                                 THRU Y919-WLR-EXIT
106200             ELSE
106300                 MOVE TM03-SSN   TO MMTM-SOC-SEC-NBR
106400                                    (X-MMTM-PRIN-DATA).
106500*
106600*
106700 E040-UPDATE-MMTM.
106800*
106900**************************************************************
107000*    WRITE A LOG RECORD TO SHOW THAT THE LAST MAINT DATE     *
107100*    AND OPERATOR HAS BEEN UPDATED IF FIELDS WERE CHANGED    *
107200*    ON THE SCREEN                                           *
107300**************************************************************
107400*
107500     IF  WS-UPDATE-SW-YES
107600     AND MMTM-ADD-COMPLETED
107700         MOVE MBCA-SCREEN-NBR    TO MMTM-ONLINE-STATUS
107800         MOVE 0198               TO MML1-FIELD-CODE
107900         MOVE ZEROES             TO MML1-FIELD-OCCURRENCE
108000                                    MML1-FIELD-OCCURRENCE-2
108100         MOVE MML1WS-VL-03       TO MML1-VARIABLE-LENGTH
108200         MOVE MMTM-LAST-MAINT-OPER
108300                                 TO MML1-VL03-B-DATA-X
108400         MOVE MBCA-OPERATOR-ID   TO MMTM-LAST-MAINT-OPER
108500         MOVE MMTM-LAST-MAINT-OPER
108600                                 TO MML1-VL03-A-DATA-X
108700         MOVE 'FC22'             TO MBCA-PROGRAM-LOCATION
108800         PERFORM Y910-WRITE-LOG-RECORD
108900                                 THRU Y919-WLR-EXIT
109000         MOVE 0199               TO MML1-FIELD-CODE
109100         MOVE MML1WS-VL-07       TO MML1-VARIABLE-LENGTH
109200         MOVE MMTM-LAST-MAINT-DATE
109300                                 TO MML1-VL07-B-DATA-9
109400         MOVE MBCA-START-DATE    TO MMTM-LAST-MAINT-DATE
109500         MOVE MMTM-LAST-MAINT-DATE
109600                                 TO MML1-VL07-A-DATA-9
109700         MOVE 'FC23'             TO MBCA-PROGRAM-LOCATION
109800         PERFORM Y910-WRITE-LOG-RECORD
109900                                 THRU Y919-WLR-EXIT.
110000*
110100****************************************************
110200*    IF THIS IS A ADD PENDING WRITE THE ENTIRE     *
110300*    RECORD TO THE LOG FILE.                       *
110400****************************************************
110500*
110600     IF  MMTM-ADD-PENDING
110700         MOVE MBCA-SCREEN-NBR    TO MMTM-ONLINE-STATUS
110800         SET MMTM-ADD-COMPLETED  TO TRUE
110900         SET MMTM-REC-ACTIVE     TO TRUE
111000         MOVE MBCA-START-DATE    TO MMTM-LAST-MAINT-DATE
111100         MOVE MBCA-OPERATOR-ID   TO MMTM-LAST-MAINT-OPER
111200         MOVE ZEROES             TO MML1-FIELD-CODE
111300                                    MML1-FIELD-OCCURRENCE
111400                                    MML1-FIELD-OCCURRENCE-2
111500         MOVE LENGTH OF MMTM-RECORD
111600                                 TO MML1-VARIABLE-LENGTH
111700         MOVE 'TM'               TO MML1-FILE-CODE
111800         MOVE MBCA-MERCHANT-ORG  TO MML1-MMOC-ORG
111900         MOVE MBCA-SIGNON-NAME   TO MML1-SIGNON-NAME
112000         MOVE MBCA-TERMINAL-ID   TO MML1-TERMINAL-ID
112100         MOVE MMTM-RECORD        TO MML1-ADD-AREA
112200         MOVE 'FC24'             TO MBCA-PROGRAM-LOCATION
112300         SET MBIORO-WRITE        TO TRUE
112400         PERFORM MML1AO-ACCESS   THRU MML1AO-ACCESS-EXIT.
112500*
112600****************************************************
112700*    REWRITE THE TERMINATED MERCHANT RECORD IF     *
112800*    FIELDS HAVE BEEN CHANGED ON THE SCREEN, OR    *
112900*    UNLOCK IT IF THEY HAVE NOT                    *
113000****************************************************
113100*
113200     IF  WS-UPDATE-SW-YES
113300         MOVE 'FC25'             TO MBCA-PROGRAM-LOCATION
113400         SET MBIORO-REWRITE      TO TRUE
113500         PERFORM MMTMAO-ACCESS   THRU MMTMAO-ACCESS-EXIT
113600     ELSE
113700         MOVE 'FC26'             TO MBCA-PROGRAM-LOCATION
113800         SET MBIORO-UNLOCK       TO TRUE
113900         PERFORM MMTMAO-ACCESS   THRU MMTMAO-ACCESS-EXIT.
114000/
114100 F000-SETUP-COMMAREA SECTION.
114200*
114300***************************************************************
114400*  SET UP COMMAREA FIELDS AND TRANSFER TO THE NEXT PROGRAM    *
114500***************************************************************
114600*
114700     MOVE MBCA-EIBAID            TO SS08WS-EIBAID.
114800*
114900     IF  SS08WS-VALID-PF3
115000     OR  SS08WS-EIBAID-VALID-PF3
115100         MOVE 53                 TO MBCA-SCREEN-NBR
115200         MOVE 1                  TO MBCA-MBTM-PD-INDEX
115300         GO TO 2690-PF-KEY-BYPASS.
115400*
115500     IF  SS08WS-VALID-PF4
115600     OR  SS08WS-EIBAID-VALID-PF4
115700         MOVE 53                 TO MBCA-SCREEN-NBR
115800         MOVE 5                  TO MBCA-MBTM-PD-INDEX
115900         GO TO 2690-PF-KEY-BYPASS.
116000*
116100     IF  SS08WS-VALID-PF5
116200     OR  SS08WS-EIBAID-VALID-PF5
116300         MOVE 53                 TO MBCA-SCREEN-NBR
116400         ADD 1                   TO MBCA-MBTM-PD-INDEX
116500         IF  MBCA-MBTM-PD-INDEX  IS GREATER THAN 5
116600             MOVE 5              TO MBCA-MBTM-PD-INDEX
116700             GO TO 2690-PF-KEY-BYPASS
116800         ELSE
116900             GO TO 2690-PF-KEY-BYPASS.
117000*
117100     IF  SS08WS-VALID-PF6
117200     OR  SS08WS-EIBAID-VALID-PF6
117300         MOVE 53                 TO MBCA-SCREEN-NBR
117400         SUBTRACT 1              FROM MBCA-MBTM-PD-INDEX
117500         IF  MBCA-MBTM-PD-INDEX  IS LESS THAN 1
117600             MOVE 1              TO MBCA-MBTM-PD-INDEX
117700             GO TO 2690-PF-KEY-BYPASS
117800         ELSE
117900             GO TO 2690-PF-KEY-BYPASS.
118000*
118100     IF  SS08WS-VALID-PF-KEY
118200     OR  SS08WS-EIBAID-VALID-PF-KEY
118300         SET MBCA-INITIAL-SCREEN-NBR
118400                                 TO TRUE.
118500*
118600     MOVE DFHBMASK               TO TM03-CURRENT-PAGE-A.
118700*
118800     SET MBCA-INITIAL-SCREEN-NBR TO TRUE.
118900*
119000 2690-PF-KEY-BYPASS.
119100*
119200 F090-TRANSFER-XCTL.
119300*
119400     MOVE 'PC05'                 TO MBCA-PROGRAM-LOCATION.
119500     PERFORM MB70PD-XCTL-TO-MBOXCTL
119600                                 THRU MB70PD-XTM-EXIT.
119700*
119800******************************************
119900*    IF THIS IS NOT A ADD PENDING RECORD *
120000*    WRITE A LOG RECORD.                 *
120100******************************************
120200*
120300 Y910-WRITE-LOG-RECORD.
120400*
120500     IF  MMTM-ADD-PENDING
120600         GO TO Y919-WLR-EXIT.
120700*
120800     SET MBIORO-WRITE            TO TRUE.
120900     PERFORM MML1AO-ACCESS       THRU MML1AO-ACCESS-EXIT.
121000     MOVE SPACES                 TO MML1-VARIABLE-AREA.
121100*
121200 Y919-WLR-EXIT.
121300     EXIT.
121400/
121500 Z000-COPIED-ROUTINES SECTION.
121600*
121700**********************************
121800*    JUL TO GREG DATE ROUTINE    *
121900**********************************
122000*
122100     COPY SS08PD.
122200/
122300     COPY SS26PD.
122400/
122500     COPY SS27PD.
122600/
122700**********************************
122800*    GREG TO JUL DATE ROUTINE    *
122900**********************************
123000*
123100     COPY SS07PD.
123200/
123300*********************************
123400*    LINE 24 PF KEYS ROUTINE    *
123500*********************************
123600*
123700     COPY SS15PD.
123800/
123900****************************************************
124000*    TERMINATED MERCHANT RECORD ACCESS ROUTINES    *
124100****************************************************
124200*
124300     COPY MMTMAO.
124400/
124500****************************************************
124600*    MERCHANT MASTER RECORD ACCESS ROUTINES        *
124700****************************************************
124800*
124900     COPY MMMMAO.
125000/
125100****************************************************
125200*    STORE MASTER RECORD ACCESS ROUTINES           *
125300****************************************************
125400*
125500     COPY MMSMAO.
125600/
125700*****************************************
125800*    LOG FILE RECORD ACCESS ROUTINES    *
125900*****************************************
126000*
126100     COPY MML1AO.
126200/
126300*****************************
126400*    ONLINE MAP ROUTINES    *
126500*****************************
126600*
126700     COPY MB60PD REPLACING 'MBMAPXX' BY 'MBTM03 '
126800                           MBMAPXXI BY MBTM03I
126900                           MBMAPXXO BY MBTM03O.
127000/
127100***************************
127200*    ONLINE PROCEDURES    *
127300***************************
127400*
127500     COPY MB70PD.
127600/
127700     COPY SMFTPXO.
