000100 IDENTIFICATION DIVISION.
000200 PROGRAM-ID. MBOUI00.
000201*       RELEASE DATE=08/24/01.        REVISION LEVEL=08.06      *
000202*****************************************************************
000203*WARNING.  THIS COMPUTER PROGRAM IS PROTECTED BY COPYRIGHT LAW  *
000204*AND INTERNATIONAL TREATIES.  UNAUTHORIZED REPRODUCTION OR      *
000205*DISTRIBUTION OF THIS PROGRAM, OR ANY PORTION OF IT, MAY RESULT *
000206*IN SEVERE CIVIL AND CRIMINAL PENATLIES, AND WILL BE PROSECUTED *
000207*TO THE MAXIMUM EXTENT POSSIBLE UNDER THE LAW.                  *
000208*COPYRIGHT 1999 PAYSYS INTERNATIONAL, INC.  ALL RIGHTS RESERVED.*
000209*****************************************************************
000300*****************************************************************
000400*                                                               *
000500*               M E R C H A N T   S Y S T E M                   *
000600*                                                               *
000700*      MBOUI00 - ON-LINE USER INPUT LOCATE                      *
000800*                SCREEN 00                                      *
000900*                                                               *
001000*              1. TRANSIDS                                      *
001100*                 A. MBUI                                       *
001200*              2. MAPS USED -                                   *
001300*                 A. MBUI00 (SCREEN 00)                         *
001400*              3. FILES USED -                                  *
001500*                 A. MMUI   (USER INPUT FILE)                   *
001600*                                                               *
001700*****************************************************************
001800*
001900 ENVIRONMENT DIVISION.
002000 DATA DIVISION.
002100 WORKING-STORAGE SECTION.
002200 01  FILLER                  PIC  X(12)      VALUE '** WS-BEG **'.
002300*         I/O REQUEST BLOCK WORK AREAS
002400     COPY MBIOWS.
002500/         I/O REQUEST BLOCK
002600     COPY MBIORO.
002700/         DATE WORK AREAS
002800     COPY SS01WS.
002900/         ONLINE WORK AREAS
003000     COPY SS08WS.
003100/
003200     COPY SS00WS.
003300/
003400     COPY SMFTWS.
003500/
003600     COPY SMPTRL REPLACING ==:SMPT:== BY ==SMPT==.
003700/
003800     COPY MB61LK.
003900/         STANDARD ERROR MESSAGES
004000     COPY MBEMWS.
004100*
004200 01  TS-QUEUE-NAME.
004300     03  TS-QN-TERMID        PIC  X(04)      VALUE SPACES.
004400     03  TS-QN-TRANID        PIC  X(04)      VALUE 'MBUI'.
004500*
004600 01  FILLER                  PIC  X(12)      VALUE '** WS-END **'.
004700/
004800 LINKAGE SECTION.
004900 01  DFHCOMMAREA.
005000     COPY MB60WS.
005100/         STORE CHAIN DIRECTORY SCREEN 01 MAP DSECT
005200     COPY MBUI00.
005300/         STORE CHAIN DIRECTORY SCREEN 01 MAP REDEFINITION
005400     COPY MBUI00R.
005500/         USER OUTPUT RECORD LAYOUT
005600     COPY MMUIRL REPLACING ==:MMUI:== BY ==MMUO==.
005700/         USER INPUT RECORD LAYOUT
005800     COPY MMUIRL REPLACING ==:MMUI:== BY ==MMUI==.
005900/
006000 PROCEDURE DIVISION.
006100 0000-HOUSEKEEPING SECTION.
006200 0100-INIT.
006300*
006400     MOVE 'PC01'                 TO MBCA-PROGRAM-LOCATION.
006500     PERFORM MB70PD-ON-LINE-HOUSEKEEPING
006600                                 THRU MB70PD-OLH-EXIT.
006700*
006800     MOVE ZEROS                  TO MBCA-MBUI-PREV-ORG
006900                                    MBCA-MBUI-PREV-KEY.
007000     MOVE 1                      TO MBCA-MBUI-SEQ.
007100     MOVE MBCA-TERMINAL-ID       TO TS-QN-TERMID.
007200*
007300     IF  MBCA-RECEIVE-SCREEN
007400         GO TO 2000-RECEIVE-SCREEN.
007500*
007600 1000-SEND-SCREEN SECTION.
007700*
007800****************************************************************
007900*    GET CICS STORAGE NEEDED FOR THE MAP                       *
008000****************************************************************
008100*
008200     MOVE 'SC01'                 TO MBCA-PROGRAM-LOCATION.
008300     PERFORM MB60PD-GETMAIN-FOR-MAP
008400                                 THRU MB60PD-GFM-EXIT.
008500*
008600 1100-BUILD-SCREEN.
008700*
008800****************************************************************
008900*    INITIALIZE THE STANDARD MAP LINES                         *
009000****************************************************************
009100*
009200     MOVE SS08WS-CURSOR          TO UI00-UPDATE-L.
009300     MOVE 00                     TO MBCA-SCREEN-NBR.
009400     PERFORM MB60PD-INIT-STD-MAP-LINES
009500                                 THRU MB60PD-ISML-EXIT.
009600*
009700****************************************************************
009800*    START BROWSE THE USER INPUT FILE                          *
009900****************************************************************
010000*
010100     MOVE 'FC01'                 TO MBCA-PROGRAM-LOCATION.
010200     MOVE SS08WS-CICS-FC-NOTFND  TO MBIORO-TEMP-STATUS-1.
010300     MOVE 9999999                TO MBIOWS-MMUI-SEQ.
010400     SET MBIORO-STARTBR-GTE      TO TRUE.
010500     PERFORM MMUIAO-ACCESS       THRU MMUIAO-ACCESS-EXIT.
010600*
010700     IF  SS08WS-RC-FC-NOTFND
010800         SET MBCA-MBUI-EMPTY-FILE
010900                                 TO TRUE
011000         MOVE ZEROS              TO UI00-SEQ
011100         SET UI00-UPDATE-NO      TO TRUE
011200         MOVE 'FILE IS EMPTY  PLEASE RUN MBU040 AND MBU045'
011300                                 TO UI00-ERR-MESSAGE
011400         GO TO 1200-SEND-MAP.
011500*
011600****************************************************************
011700*    READNEXT THE USER INPUT FILE                              *
011800****************************************************************
011900*
012000     MOVE 'FC02'                 TO MBCA-PROGRAM-LOCATION.
012100     SET MBIORO-READ-SEQ         TO TRUE.
012200     PERFORM MMUIAO-ACCESS       THRU MMUIAO-ACCESS-EXIT.
012300*
012400****************************************************************
012500*    READPREV THE USER INPUT FILE                              *
012600****************************************************************
012700*
012800     MOVE 'FC03'                 TO MBCA-PROGRAM-LOCATION.
012900     SET MBIORO-READ-PREV        TO TRUE.
013000     PERFORM MMUIAO-ACCESS       THRU MMUIAO-ACCESS-EXIT.
013100*
013200****************************************************************
013300*    READPREV THE USER INPUT FILE                              *
013400****************************************************************
013500*
013600     MOVE 'FC04'                 TO MBCA-PROGRAM-LOCATION.
013700     MOVE SS08WS-CICS-FC-ENDFILE TO MBIORO-TEMP-STATUS-1.
013800     SET MBIORO-READ-PREV        TO TRUE.
013900     PERFORM MMUIAO-ACCESS       THRU MMUIAO-ACCESS-EXIT.
014000*
014100     IF  SS08WS-RC-FC-ENDFILE
014200         SET MBCA-MBUI-EMPTY-FILE
014300                                 TO TRUE
014400         MOVE ZEROS              TO UI00-SEQ
014500         SET UI00-UPDATE-NO      TO TRUE
014600         MOVE 'ONLY A TRAILER EXISTS PLEASE RUN MBU040 AND MBU045'
014700                                 TO UI00-ERR-MESSAGE
014800         MOVE 'FC05'             TO MBCA-PROGRAM-LOCATION
014900         SET MBIORO-ENDBR        TO TRUE
015000         PERFORM MMUIAO-ACCESS   THRU MMUIAO-ACCESS-EXIT
015100         GO TO 1200-SEND-MAP.
015200*
015300     MOVE 'FC05'                 TO MBCA-PROGRAM-LOCATION.
015400     SET MBIORO-ENDBR            TO TRUE.
015500     PERFORM MMUIAO-ACCESS       THRU MMUIAO-ACCESS-EXIT.
015600*
015700     MOVE MMUI-SEQ               TO UI00-SEQ.
015800     SET UI00-UPDATE-NO          TO TRUE.
015900     MOVE DFHBMASK               TO UI00-CURRENT-PAGE-A.
016000*
016100     IF  MBCA-MBUI-COMPLETE
016200         MOVE 'TS03'             TO MBCA-PROGRAM-LOCATION
016300         EXEC CICS IGNORE CONDITION
016400                   QIDERR
016500              END-EXEC
016600         EXEC CICS DELETEQ TS
016700                   QUEUE  (TS-QUEUE-NAME)
016800              END-EXEC
016900         SET MBCA-MBUI-NOT-COMPLETE
017000                                 TO TRUE
017100         MOVE 'PROCESSING IS COMPLETE  PLEASE RUN MBU100'
017200                                 TO UI00-ERR-MESSAGE.
017300*
017400 1200-SEND-MAP.
017500*
017600****************************************************************
017700*    SEND THE MAP                                              *
017800****************************************************************
017900*
018000     MOVE 'BM01'                 TO MBCA-PROGRAM-LOCATION.
018100     PERFORM MB60PD-SEND-MAP-WITH-ERASE
018200                                 THRU MB60PD-SMWE-EXIT.
018300*
018400****************************************************************
018500*    RETURN TO CICS                                            *
018600****************************************************************
018700*
018800     MOVE 'PC02'                 TO MBCA-PROGRAM-LOCATION.
018900     PERFORM MB70PD-RETURN-TRANS-ID
019000                                 THRU MB70PD-RTI-EXIT.
019100/
019200 2000-RECEIVE-SCREEN SECTION.
019300*
019400****************************************************************
019500*    THIS SECTION RECEIVES THE 00 SCREEN                       *
019600****************************************************************
019700*
019800     MOVE 'BM02'                 TO MBCA-PROGRAM-LOCATION.
019900     PERFORM MB60PD-RECEIVE-MAP  THRU MB60PD-RM-EXIT.
020000*
020100****************************************************************
020200*    CHECK FOR ANOTHER TRANSACTION ID ENTERED BY THE USER      *
020300****************************************************************
020400*
020500     MOVE 'PC03'                 TO MBCA-PROGRAM-LOCATION.
020600     PERFORM MB60PD-NEW-TRANS-ROUTINE
020700                                 THRU MB60PD-NTR-EXIT.
020800*
020900 2100-EDIT-SCREEN.
021000*
021100     SET SS08WS-ERROR-SW-NO      TO TRUE.
021200     MOVE MBCA-EIBAID            TO SS08WS-EIBAID.
021300*
021400     IF  UI00-UPDATE-L IS LESS THAN 1
021500     AND (SS08WS-VALID-PF-KEY
021600     OR   SS08WS-EIBAID-VALID-PF-KEY)
021700         SET MBCA-INITIAL-SCREEN-NBR
021800                                 TO TRUE
021900         GO TO 2690-TRANSFER-XCTL.
022000*
022100 2110-EDIT-UPDATE-SW.
022200*
022300     MOVE DFHBMUNF               TO UI00-UPDATE-A.
022400     MOVE DFHBMASK               TO UI00-UPDATE-LP-A
022500                                    UI00-UPDATE-RP-A.
022600*
022700     IF  UI00-UPDATE-L IS EQUAL TO ZERO
022800         SET UI00-UPDATE-NO      TO TRUE
022900         SET MBCA-MBUI-UI-UPDATE-NO
023000                                 TO TRUE
023100     ELSE
023200         IF  UI00-VALID-UPDATE
023300             MOVE DFHBMASF       TO UI00-UPDATE-A
023400             MOVE UI00-UPDATE    TO MBCA-MBUI-USER-INPUT-UPDATE-SW
023500         ELSE
023600             GO TO 2130-UPDATE-ERROR.
023700*
023800     GO TO 2290-CHECK-ERROR.
023900*
024000 2130-UPDATE-ERROR.
024100*
024200     MOVE DFHBMNBF               TO UI00-UPDATE-A.
024300     MOVE DFHBMASB               TO UI00-UPDATE-LP-A
024400                                    UI00-UPDATE-RP-A.
024500     MOVE SS08WS-CURSOR          TO UI00-UPDATE-L.
024600     SET SS08WS-ERROR-SW-YES     TO TRUE.
024700*
024800 2290-CHECK-ERROR.
024900*
025000     IF  SS08WS-ERROR-SW-NO
025100         GO TO 2600-SETUP-COMMAREA
025200     ELSE
025300         IF  SS08WS-VALID-PF-KEY
025400         OR  SS08WS-EIBAID-VALID-PF-KEY
025500             SET MBCA-INITIAL-SCREEN-NBR
025600                                 TO TRUE
025700             GO TO 2690-TRANSFER-XCTL.
025800*
025900 2300-SEND-MAP.
026000*
026100****************************************************************
026200*    SEND THE MAP                                              *
026300****************************************************************
026400*
026500     PERFORM MB60PD-INIT-STD-MAP-LINES
026600                                 THRU MB60PD-ISML-EXIT.
026700*
026800     MOVE DFHBMASK               TO UI00-CURRENT-PAGE-A.
026900*
027000     MOVE 'BM03'                 TO MBCA-PROGRAM-LOCATION.
027100     PERFORM MB60PD-SEND-MAP-DATA-ONLY
027200                                 THRU MB60PD-SMDO-EXIT.
027300*
027400****************************************************************
027500*    RETURN TO CICS                                            *
027600****************************************************************
027700*
027800     MOVE 'PC04'                 TO MBCA-PROGRAM-LOCATION.
027900     PERFORM MB70PD-RETURN-TRANS-ID
028000                                 THRU MB70PD-RTI-EXIT.
028100/
028200 2600-SETUP-COMMAREA.
028300*
028400****************************************************************
028500*    SET UP COMMAREA FIELDS AND TRANSFER TO THE NEXT PROGRAM   *
028600****************************************************************
028700*
028800     MOVE MBCA-EIBAID            TO SS08WS-EIBAID.
028900*
029000     PERFORM MB60PD-EDIT-PAGE-NBR
029100                                 THRU MB60PD-EPN-EXIT.
029200*
029300     IF  SS08WS-VALID-PF-KEY
029400     OR  SS08WS-EIBAID-VALID-PF-KEY
029500         SET MBCA-INITIAL-SCREEN-NBR
029600                                 TO TRUE.
029700*
029800 2690-TRANSFER-XCTL.
029900*
030000     IF  MBCA-MBUI-EMPTY-FILE
030100         SET MBCA-INITIAL-SCREEN-NBR
030200                                 TO TRUE
030300     ELSE
030400         MOVE 'SC02'             TO MBCA-PROGRAM-LOCATION
030500         SET MBIORO-GETMAIN      TO TRUE
030600         PERFORM MMUOAO-ACCESS   THRU MMUOAO-ACCESS-EXIT
030700*
030800****************************************************************
030900*    WRITE THE USER OUTPUT FILE                                *
031000****************************************************************
031100*
031200         SET MMUO-HEADER         TO TRUE
031300         MOVE 6                  TO MMUO-VAR-LENGTH
031400         IF MBCA-MBUI-UI-UPDATE-YES
031500             SET MMUO-HO-UPDATE  TO TRUE
031600         ELSE
031700             SET MMUO-HO-EDIT-ONLY TO TRUE
031800         END-IF
031900*
032000         MOVE 'FC06'             TO MBCA-PROGRAM-LOCATION
032100         SET MBIORO-WRITE        TO TRUE
032200         PERFORM MMUOAO-ACCESS   THRU MMUOAO-ACCESS-EXIT
032300     END-IF.
032400*
032500     MOVE 'PC05'                 TO MBCA-PROGRAM-LOCATION.
032600     PERFORM MB70PD-XCTL-TO-MBOXCTL
032700                                 THRU MB70PD-XTM-EXIT.
032800/
032900 9000-PERFORMED-ROUTINES-SECT SECTION.
033000*         JULIAN TO GREGORIAN DATE ROUTINE
033100     COPY SS08PD.
033200/
033300     COPY SS15PD.
033400/
033500     COPY SS26PD.
033600/
033700     COPY SS27PD.
033800/         LINE 24 PF KEYS ROUTINE
033900     COPY MMUIAO.
034000/         USER OUTPUT ACCESS ROUTINES
034100     COPY MMUOAO.
034200/         ON-LINE MAP ROUTINES
034300     COPY MB60PD REPLACING 'MBMAPXX' BY 'MBUI00 '
034400                           MBMAPXXI BY MBUI00I
034500                           MBMAPXXO BY MBUI00O.
034600/         ON-LINE PROCEDURES
034700     COPY MB70PD.
034800/
034900     COPY SMFTPXO.
