000100 IDENTIFICATION DIVISION.
000200 PROGRAM-ID. MBOUI01.
000201*       RELEASE DATE=08/24/01.        REVISION LEVEL=08.06      *
000202*****************************************************************
000203*WARNING.  THIS COMPUTER PROGRAM IS PROTECTED BY COPYRIGHT LAW  *
000204*AND INTERNATIONAL TREATIES.  UNAUTHORIZED REPRODUCTION OR      *
000205*DISTRIBUTION OF THIS PROGRAM, OR ANY PORTION OF IT, MAY RESULT *
000206*IN SEVERE CIVIL AND CRIMINAL PENATLIES, AND WILL BE PROSECUTED *
000207*TO THE MAXIMUM EXTENT POSSIBLE UNDER THE LAW.                  *
000208*COPYRIGHT 1999 PAYSYS INTERNATIONAL, INC.  ALL RIGHTS RESERVED.*
000209*****************************************************************
000300*****************************************************************
000400*                                                               *
000500*               M E R C H A N T   S Y S T E M                   *
000600*                                                               *
000700*      MBOUI01 - ON-LINE USER INPUT UPDATE SCREEN               *
000800*                SCREEN 00                                      *
000900*                                                               *
001000*              1. TRANSIDS                                      *
001100*                 A. MBUI                                       *
001200*              2. MAPS USED -                                   *
001300*                 A. MBUI01 (SCREEN 00)                         *
001400*              3. FILES USED -                                  *
001500*                 A. MMUI   (USER INPUT FILE)                   *
001600*                 B. MMUO   (USER OUTPUT FILE)                  *
001700*                                                               *
001800*****************************************************************
001900*
002000 ENVIRONMENT DIVISION.
002100 DATA DIVISION.
002200 WORKING-STORAGE SECTION.
002300 01  FILLER                  PIC  X(12)      VALUE '** WS-BEG **'.
002400*
002500 01  WS-MISCELLANEOUS.
002600     03  TS-QUEUE-NAME.
002700         05  TS-QN-TERMID    PIC  X(04)      VALUE SPACES.
002800         05  TS-QN-TRANID    PIC  X(04)      VALUE 'MBUI'.
002900     03  WS-MBUI-KEY-X.
003000         05  WS-MBUI-ORG     PIC  9(03)      VALUE ZEROS.
003100         05  WS-MBUI-KEY     PIC  9(09)      VALUE ZEROS.
003200*
003300/         I/O REQUEST BLOCK WORK AREAS
003400     COPY MBIOWS.
003500/         I/O REQUEST BLOCK
003600     COPY MBIORO.
003700/         DATE WORK AREAS
003800     COPY SS01WS.
003900/         ONLINE WORK AREAS
004000     COPY SS08WS.
004100/
004200     COPY SS00WS.
004300/
004400     COPY SMFTWS.
004500/
004600     COPY SMPTRL REPLACING ==:SMPT:== BY ==SMPT==.
004700/
004800     COPY MB61LK.
004900/         STANDARD ERROR MESSAGES
005000     COPY MBEMWS.
005100*
005200 01  FILLER                  PIC  X(12)      VALUE '** WS-END **'.
005300/
005400 LINKAGE SECTION.
005500 01  DFHCOMMAREA.
005600     COPY MB60WS.
005700/         USER INPUT RECORD LAYOUT
005800     COPY MMUIRL REPLACING ==:MMUI:== BY ==MMUI==.
005900/         USER OUTPUT RECORD LAYOUT
006000     COPY MMUIRL REPLACING ==:MMUI:== BY ==MMUO==.
006100/         USER INPUT TEMPORARY STORAGE
006200     COPY MBUITS.
006300/
006400 PROCEDURE DIVISION.
006500 0000-HOUSEKEEPING SECTION.
006600 0100-INIT.
006700*
006800     MOVE 'PC01'                 TO MBCA-PROGRAM-LOCATION.
006900     PERFORM MB70PD-ON-LINE-HOUSEKEEPING
007000                                 THRU MB70PD-OLH-EXIT.
007100*
007200     SET MBCA-MBUI-UI-YES        TO TRUE.
007300*
007400     MOVE MBCA-TERMINAL-ID       TO TS-QN-TERMID.
007500*
007600     IF  MBCA-RECEIVE-SCREEN
007700         GO TO 2000-WRITE-OUTPUT.
007800*
007900 1000-READ-INPUT SECTION.
008000*
008100****************************************************************
008200*    START BROWSE THE USER INPUT FILE                          *
008300****************************************************************
008400*
008500     MOVE 'FC01'                 TO MBCA-PROGRAM-LOCATION.
008600     MOVE MBCA-MBUI-SEQ          TO MBIOWS-MMUI-SEQ.
008700     SET MBIORO-STARTBR-GTE      TO TRUE.
008800     PERFORM MMUIAO-ACCESS       THRU MMUIAO-ACCESS-EXIT.
008900*
009000 1010-READ-NEXT.
009100*
009200****************************************************************
009300*    READNEXT THE USER INPUT FILE                              *
009400****************************************************************
009500*
009600     MOVE 'FC02'                 TO MBCA-PROGRAM-LOCATION.
009700     SET MBIORO-READ-SEQ         TO TRUE.
009800     PERFORM MMUIAO-ACCESS       THRU MMUIAO-ACCESS-EXIT.
009900*
010000     MOVE 'FC03'                 TO MBCA-PROGRAM-LOCATION.
010100     SET MBIORO-ENDBR            TO TRUE.
010200     PERFORM MMUIAO-ACCESS       THRU MMUIAO-ACCESS-EXIT.
010300*
010400     IF  MMUI-TRAILER
010500         SET MBCA-MBUI-COMPLETE  TO TRUE
010600         SET MBCA-MBUI-UI-NO     TO TRUE
010700         SET MBCA-MBUI-UI-UPDATE-NO
010800                                 TO TRUE
010900         SET MBCA-INITIAL-SCREEN-NBR
011000                                 TO TRUE
011100         MOVE MMUI-RECORD        TO MMUO-RECORD
011200         PERFORM 9010-WRITE-MMUO-REC
011300                                 THRU 9019-WMR-EXIT
011400         MOVE 'PC08'             TO MBCA-PROGRAM-LOCATION
011500         PERFORM MB70PD-XCTL-TO-MBOXCTL
011600                                 THRU MB70PD-XTM-EXIT.
011700*
011800     IF  MMUI-FILLER IS NOT EQUAL TO SPACES
011900     AND MMUI-FILLER IS NOT EQUAL TO LOW-VALUES
012000         MOVE MMUI-RECORD        TO MMUO-RECORD
012100         PERFORM 9010-WRITE-MMUO-REC
012200                                 THRU 9019-WMR-EXIT
012300         MOVE MMUI-SEQ           TO MBCA-MBUI-SEQ
012400         ADD 1                   TO MBCA-MBUI-SEQ
012500         GO TO 1000-READ-INPUT.
012600*
012700****************************************************************
012800*    GET CICS STORAGE FOR TEMP STORAGE                         *
012900****************************************************************
013000*
013100     MOVE 'TS01'                 TO MBCA-PROGRAM-LOCATION.
013200*
013300     EXEC CICS GETMAIN
013400               FLENGTH (LENGTH  OF MBUITS-RECORD)
013500
013600               SET     (ADDRESS OF MBUITS-RECORD)
013700
013800          END-EXEC.
013900*
014000 1200-BUILD-TEMP-STORAGE.
014100*
014200     MOVE MMUI-VAR-DATA          TO MBUITS-VAR-DATA.
014300     MOVE MMUI-SEQ               TO MBUITS-SEQ
014400                                    MBCA-MBUI-SEQ.
014500     MOVE MMUI-VAR-LENGTH        TO MBUITS-VAR-LENGTH.
014600     MOVE MMUI-TRANID            TO MBCA-TRANS-ID
014700                                    MBCA-PREV-TRANS-ID.
014800     MOVE MMUI-CURRENT-PAGE      TO MBCA-SCREEN-NBR.
014900*
015000     EVALUATE TRUE
015100       WHEN MMUI-FILE-MMMM
015200         EVALUATE TRUE
015300           WHEN MMUI-CURRENT-PAGE IS EQUAL TO ZERO
015400             MOVE MMUI-MM-L-ORG  TO WS-MBUI-ORG
015500             MOVE MMUI-MM-L-MERCHANT
015600                                 TO WS-MBUI-KEY
015700           WHEN OTHER
015800             MOVE MMUI-MM-ORG    TO WS-MBUI-ORG
015900                                    MBCA-MERCHANT-ORG
016000             MOVE MMUI-MM-MERCHANT
016100                                 TO WS-MBUI-KEY
016200                                    MBCA-MERCHANT
016300             MOVE MMUI-MM-PRODUCT
016400                                 TO MBCA-CARD-PROD
016500         END-EVALUATE
016600       WHEN MMUI-FILE-MMSM
016700         EVALUATE TRUE
016800           WHEN MMUI-CURRENT-PAGE IS EQUAL TO ZERO
016900             MOVE MMUI-MS-L-ORG  TO WS-MBUI-ORG
017000             MOVE MMUI-MS-L-STORE
017100                                 TO WS-MBUI-KEY
017200           WHEN OTHER
017300             MOVE MMUI-MS-ORG    TO WS-MBUI-ORG
017400                                    MBCA-MERCHANT-ORG
017500             MOVE MMUI-MS-STORE  TO WS-MBUI-KEY
017600                                    MBCA-STORE
017700         END-EVALUATE
017800       WHEN MMUI-FILE-MMRC
017900         EVALUATE TRUE
018000           WHEN MMUI-CURRENT-PAGE IS EQUAL TO ZERO
018100             MOVE MMUI-MC-L-ORG  TO WS-MBUI-ORG
018200             MOVE MMUI-MC-L-CHAIN
018300                                 TO WS-MBUI-KEY
018400           WHEN OTHER
018500             MOVE MMUI-MC-ORG    TO WS-MBUI-ORG
018600                                    MBCA-MERCHANT-ORG
018700             MOVE MMUI-MC-CHAIN  TO WS-MBUI-KEY
018800                                    MBCA-CHAIN
018900         END-EVALUATE
019000       WHEN MMUI-FILE-MMSR
019100         EVALUATE TRUE
019200           WHEN MMUI-CURRENT-PAGE IS EQUAL TO ZERO
019300             MOVE MMUI-MG-L-ORG  TO WS-MBUI-ORG
019400             MOVE MMUI-MG-L-CHAIN
019500                                 TO WS-MBUI-KEY
019600           WHEN OTHER
019700             MOVE MMUI-MG-ORG    TO WS-MBUI-ORG
019800                                    MBCA-MERCHANT-ORG
019900             MOVE MMUI-MG-CHAIN  TO WS-MBUI-KEY
020000                                    MBCA-S-CHAIN
020100         END-EVALUATE
020200     END-EVALUATE.
020300*
020400     IF  MBCA-MBUI-ERROR-YES
020500     AND MBCA-MBUI-UI-UPDATE-YES
020600     AND MMUI-ADD-TI
020700     AND WS-MBUI-KEY-X IS EQUAL TO MBCA-MBUI-PREV-KEY-X
020800         SET MMUI-ADD-SEQ-ERROR  TO TRUE
020900         MOVE MMUI-RECORD        TO MMUO-RECORD
021000         PERFORM 9010-WRITE-MMUO-REC
021100                                 THRU 9019-WMR-EXIT
021200         MOVE MBUITS-SEQ         TO MBCA-MBUI-SEQ
021300         ADD 1                   TO MBCA-MBUI-SEQ
021400         GO TO 1000-READ-INPUT.
021500*
021600     MOVE WS-MBUI-KEY-X          TO MBCA-MBUI-PREV-KEY-X.
021700*
021800***********************************************
021900*    WRITE THE TEMP STORAGE RECORD            *
022000***********************************************
022100*
022200     MOVE 'TS09'                 TO MBCA-PROGRAM-LOCATION.
022300*
022400     EXEC CICS WRITEQ TS
022500               QUEUE   (TS-QUEUE-NAME)
022600               FROM    (MBUITS-RECORD)
022700               LENGTH  (LENGTH  OF MBUITS-RECORD)
022800
022900          END-EXEC.
023000*
023100****************************************************************
023200*    TRANSFER TO XCTL                                          *
023300****************************************************************
023400*
023500     SET MBCA-MBUI-ERROR-NO      TO TRUE.
023600*
023700     MOVE 'PC05'                 TO MBCA-PROGRAM-LOCATION.
023800     PERFORM MB70PD-XCTL-TO-MBOXCTL
023900                                 THRU MB70PD-XTM-EXIT.
024000/
024100 2000-WRITE-OUTPUT SECTION.
024200*
024300****************************************************************
024400*    ACQUIRE MAIN STORAGE FOR TEMP STORAGE RECORD              *
024500****************************************************************
024600*
024700     MOVE 'TS01'                 TO MBCA-PROGRAM-LOCATION.
024800*
024900     EXEC CICS GETMAIN
025000               FLENGTH (LENGTH  OF MBUITS-RECORD)
025100
025200               SET     (ADDRESS OF MBUITS-RECORD)
025300
025400          END-EXEC.
025500*
025600*
025700***********************************************
025800*    READ THE TEMP STORAGE RECORD             *
025900***********************************************
026000*
026100     MOVE 'TS02'                 TO MBCA-PROGRAM-LOCATION.
026200*
026300     EXEC CICS READQ TS
026400               QUEUE   (TS-QUEUE-NAME)
026500               INTO    (MBUITS-RECORD)
026600               LENGTH  (LENGTH  OF MBUITS-RECORD)
026700               ITEM    (1)
026800          END-EXEC.
026900*
027000***********************************************
027100*    DELETE THE TEMP STORAGE RECORD           *
027200***********************************************
027300*
027400     MOVE 'TS03'                 TO MBCA-PROGRAM-LOCATION.
027500*
027600     EXEC CICS IGNORE CONDITION
027700               QIDERR
027800          END-EXEC.
027900*
028000     EXEC CICS DELETEQ TS
028100               QUEUE  (TS-QUEUE-NAME)
028200          END-EXEC.
028300*
028400     MOVE 'SC01'                 TO MBCA-PROGRAM-LOCATION.
028500     SET MBIORO-GETMAIN          TO TRUE.
028600     PERFORM MMUOAO-ACCESS       THRU MMUOAO-ACCESS-EXIT.
028700*
028800     MOVE MBUITS-SEQ             TO MMUO-SEQ.
028900     MOVE MBUITS-VAR-LENGTH      TO MMUO-VAR-LENGTH.
029000     MOVE MBUITS-VAR-DATA        TO MMUO-VAR-DATA.
029100*
029200     IF  MBCA-MBUI-ERROR-YES
029300     AND MBCA-MBUI-UI-UPDATE-YES
029400     AND MMUO-ADD-TI
029500     AND (MMUO-FILLER IS EQUAL TO SPACES
029600     OR  MMUO-FILLER IS EQUAL TO LOW-VALUES)
029700         SET MMUO-MAP-ERROR      TO TRUE
029800     ELSE
029900         IF  ((MMUO-FILLER IS EQUAL TO SPACES
030000         OR  MMUO-FILLER IS EQUAL TO LOW-VALUES)
030100         AND MBCA-MBUI-ERROR-YES)
030200             SET MMUO-MAP-ERROR  TO TRUE.
030300*
030400     PERFORM 9010-WRITE-MMUO-REC THRU 9019-WMR-EXIT.
030500*
030600     MOVE MBUITS-SEQ             TO MBCA-MBUI-SEQ.
030700     ADD 1                       TO MBCA-MBUI-SEQ.
030800     GO TO 1000-READ-INPUT.
030900*
031000/
031100 9000-PERFORMED-ROUTINES-SECT SECTION.
031200*
031300 9010-WRITE-MMUO-REC.
031400*
031500****************************************************************
031600*    WRITE THE USER OUTPUT FILE                                *
031700****************************************************************
031800*
031900     MOVE 'FC04 '                TO MBCA-PROGRAM-LOCATION.
032000     SET MBIORO-WRITE            TO TRUE.
032100     PERFORM MMUOAO-ACCESS       THRU MMUOAO-ACCESS-EXIT.
032200*
032300 9019-WMR-EXIT.
032400     EXIT.
032500*
032600*         JULIAN TO GREGORIAN DATE ROUTINE
032700     COPY SS08PD.
032800/
032900     COPY SS26PD.
033000/
033100     COPY SS27PD.
033200/         LINE 24 PF KEYS ROUTINE
033300     COPY SS15PD.
033400/         USER INPUT ACCESS ROUTINES
033500     COPY MMUIAO.
033600/         USER OUTPUT ACCESS ROUTINES
033700     COPY MMUOAO.
033800/         ON-LINE PROCEDURES
033900     COPY MB70PD.
034000/
034100     COPY SMFTPXO.
