000100 IDENTIFICATION DIVISION.
000200 PROGRAM-ID. MBOVR00.
000201*       RELEASE DATE=08/24/01.        REVISION LEVEL=08.06      *
000202*****************************************************************
000203*WARNING.  THIS COMPUTER PROGRAM IS PROTECTED BY COPYRIGHT LAW  *
000204*AND INTERNATIONAL TREATIES.  UNAUTHORIZED REPRODUCTION OR      *
000205*DISTRIBUTION OF THIS PROGRAM, OR ANY PORTION OF IT, MAY RESULT *
000206*IN SEVERE CIVIL AND CRIMINAL PENATLIES, AND WILL BE PROSECUTED *
000207*TO THE MAXIMUM EXTENT POSSIBLE UNDER THE LAW.                  *
000208*COPYRIGHT 1999 PAYSYS INTERNATIONAL, INC.  ALL RIGHTS RESERVED.*
000209*****************************************************************
000300*****************************************************************
000400*                                                               *
000500*               M E R C H A N T   S Y S T E M                   *
000600*                                                               *
000700*      MBOVR00 - ON-LINE STORE/MERCHANT VISIT/REVIEW INPUT      *
000800*                LOCATE SCREEN 00                               *
000900*                                                               *
001000*              1. TRANSIDS                                      *
001100*                 A. MBVR                                       *
001200*              2. MAPS USED -                                   *
001300*                 A. MBVR00 (LOCATE MAP)                        *
001400*              3. FILES USED -                                  *
001500*                 A. MMOC (ORG CONTROL FILE)                    *
001600*                 B. MMFS (FIELD SECURITY FILE)                 *
001700*                                                               *
001800*****************************************************************
001900*
002000 ENVIRONMENT DIVISION.
002100*
002200 DATA DIVISION.
002300*
002400 WORKING-STORAGE SECTION.
002500*
002600 01  FILLER                  PIC  X(12)      VALUE
002700     '** WS-BEG **'.
002800*
002900 01  FILLER                  PIC  X(14)      VALUE
003000     'MISCELLANEOUS:'.
003100*
003200 01  WS-MISCELLANEOUS.
003300     03  WS-ORG-LOW          PIC S9(03)      COMP-3
003400                                             VALUE +001.
003500     03  WS-ORG-HIGH         PIC S9(03)      COMP-3
003600                                             VALUE +998.
003700     03  WS-MMFS-FOUND-SW    PIC  X(01)      VALUE 'Y'.
003800         88  MMFS-RECORD-FOUND               VALUE 'Y'.
003900         88  MMFS-RECORD-NOT-FOUND           VALUE 'N'.
004000/
004100 01  FILLER                  PIC  X(29)      VALUE
004200     'I/O REQUEST BLOCK WORK AREAS:'.
004300*
004400     COPY MBIOWS.
004500/
004600 01  FILLER                  PIC  X(18)      VALUE
004700     'I/O REQUEST BLOCK:'.
004800*
004900     COPY MBIORO.
005000/
005100 01  FILLER                  PIC  X(21)      VALUE
005200     'ERROR MESSAGES TABLE:'.
005300*
005400     COPY MBEMWS.
005500/
005600 01  FILLER                  PIC  X(20)      VALUE
005700     'CCS DATE WORK AREAS:'.
005800*
005900     COPY SS01WS.
006000/
006100 01  FILLER                  PIC  X(15)      VALUE
006200     'CCS WORK AREAS:'.
006300*
006400     COPY SS08WS.
006500/
006600     COPY SS00WS.
006700/
006800     COPY SMFTWS.
006900/
007000     COPY SMPTRL REPLACING ==:SMPT:== BY ==SMPT==.
007100/
007200     COPY MB61LK.
007300/
007400 01  FILLER                  PIC  X(12)      VALUE
007500     '** WS-END **'.
007600/
007700 LINKAGE SECTION.
007800*
007900 01  DFHCOMMAREA.
008000*
008100     COPY MB60WS.
008200/
008300***************************************
008400*    VISIT/REVIEW INPUT LOCATE MAP    *
008500***************************************
008600*
008700     COPY MBVR00.
008800/
008900****************************************************
009000*    VISIT/REVIEW INPUT LOCATE MAP REDEFINITION    *
009100****************************************************
009200*
009300     COPY MBVR00R.
009400/
009500***************************
009600*    ORG RECORD LAYOUT    *
009700***************************
009800*
009900     COPY MMOCRL.
010000/
010100**************************************
010200*    FIELD SECURITY RECORD LAYOUT    *
010300**************************************
010400*
010500     COPY MMFSRL.
010600/
010700 PROCEDURE DIVISION.
010800*
010900 A000-HOUSEKEEPING SECTION.
011000*
011100 A020-INIT.
011200*
011300     MOVE 'PC01'                 TO MBCA-PROGRAM-LOCATION.
011400     PERFORM MB70PD-ON-LINE-HOUSEKEEPING
011500                                 THRU MB70PD-OLH-EXIT.
011600*
011700     IF  MBCA-RECEIVE-SCREEN
011800         GO TO C000-RECEIVE-SCREEN.
011900/
012000 B000-SEND-SCREEN SECTION.
012100*
012200*********************************************
012300*    GET CICS STORAGE NEEDED FOR THE MAP    *
012400*********************************************
012500*
012600     MOVE 'SC01'                 TO MBCA-PROGRAM-LOCATION.
012700     PERFORM MB60PD-GETMAIN-FOR-MAP
012800                                 THRU MB60PD-GFM-EXIT.
012900*
013000*****************************************************************
013100*    CHECK KEY CODES                                            *
013200* 1. IF ADD FUNCTION, BYPASS CHECK OF KEY CODES.                *
013300* 2. IF INITIAL KEY CODE, BYPASS CHECK OF KEY CODES.            *
013400* 3. IF MMOC KEY CODE, IT MUST HAVE AN ORGANIZATION NUMBER      *
013500*    GREATER THAN ZERO.  THE ORGANIZATION IS PLUGGED INTO THE   *
013600*    MAP.                                                       *
013700*****************************************************************
013800*
013900     IF  MBCA-INITIAL-KEY-CODE
014000         GO TO B020-BUILD-SCREEN.
014100*
014200     IF  MBCA-VALID-KEY-CODES
014300         IF  MBCA-MERCHANT-ORG IS GREATER THAN ZERO
014400             MOVE MBCA-MERCHANT-ORG
014500                                 TO VR00-ORG
014600             MOVE DFHBMUNF       TO VR00-ORG-A.
014700*
014800 B020-BUILD-SCREEN.
014900*
015000*******************************************
015100*    INITIALIZE THE STANDARD MAP LINES    *
015200*******************************************
015300*
015400     MOVE SS08WS-CURSOR          TO VR00-ORG-L.
015500     MOVE 00                     TO MBCA-SCREEN-NBR.
015600     PERFORM MB60PD-INIT-STD-MAP-LINES
015700                                 THRU MB60PD-ISML-EXIT.
015800*
015900**********************
016000*    SEND THE MAP    *
016100**********************
016200*
016300     MOVE 'BM01'                 TO MBCA-PROGRAM-LOCATION.
016400     PERFORM MB60PD-SEND-MAP-WITH-ERASE
016500                                 THRU MB60PD-SMWE-EXIT.
016600*
016700************************
016800*    RETURN TO CICS    *
016900************************
017000*
017100     MOVE 'PC02'                 TO MBCA-PROGRAM-LOCATION.
017200     PERFORM MB70PD-RETURN-TRANS-ID
017300                                 THRU MB70PD-RTI-EXIT.
017400/
017500 C000-RECEIVE-SCREEN SECTION.
017600*
017700*************************************************
017800*    THIS SECTION RECEIVES THE LOCATE SCREEN    *
017900*************************************************
018000*
018100     MOVE 'BM02'                 TO MBCA-PROGRAM-LOCATION.
018200     PERFORM MB60PD-RECEIVE-MAP  THRU MB60PD-RM-EXIT.
018300*
018400**************************************************************
018500*    CHECK FOR ANOTHER TRANSACTION ID ENTERED BY THE USER    *
018600**************************************************************
018700*
018800     MOVE 'PC03'                 TO MBCA-PROGRAM-LOCATION.
018900     PERFORM MB60PD-NEW-TRANS-ROUTINE
019000                                 THRU MB60PD-NTR-EXIT.
019100*
019200 C020-EDIT-ORG.
019300*
019400     MOVE 'N'                    TO SS08WS-ERROR.
019500     MOVE MBCA-EIBAID            TO SS08WS-EIBAID.
019600*
019700     IF  (VR00-ORG-L IS LESS THAN 1)
019800     AND (SS08WS-VALID-PF-KEY
019900     OR   SS08WS-EIBAID-VALID-PF-KEY)
020000         MOVE 99                 TO MBCA-SCREEN-NBR
020100         GO TO F090-TRANSFER-XCTL.
020200*
020300     IF  VR00-ORG-L IS EQUAL TO ZERO
020400     OR  VR00-ORG IS NOT NUMERIC
020500     OR  VR00-ORG IS LESS THAN MBCA-ORG-LOW
020600     OR  VR00-ORG IS GREATER THAN MBCA-ORG-HIGH
020700     OR  VR00-ORG IS LESS THAN WS-ORG-LOW
020800     OR  VR00-ORG IS GREATER THAN WS-ORG-HIGH
020900         MOVE MBEMWS-INVALID-ORG TO VR00-ERR-MESSAGE
021000         GO TO C038-ORG-ERROR.
021100*
021200 C022-READ-ORG.
021300*
021400************************************************
021500*    READ THE ORGANIZATION RECORD.  IT MUST    *
021600*    BE ON FILE AND AN ACTIVE RECORD.          *
021700************************************************
021800*
021900     MOVE VR00-ORG               TO MBIOWS-MMOC-ORG.
022000     MOVE 'FC01'                 TO MBCA-PROGRAM-LOCATION.
022100     MOVE SS08WS-CICS-FC-NOTFND  TO MBIORO-TEMP-STATUS-1.
022200     SET MBIORO-READ-RANDOM      TO TRUE.
022300     PERFORM MMOCAO-ACCESS       THRU MMOCAO-ACCESS-EXIT.
022400*
022500     IF  SS08WS-RC-FC-NOTFND
022600         MOVE MBEMWS-NOT-ON-FILE TO VR00-ERR-MESSAGE
022700     ELSE
022800         IF  MMOC-ADD-PENDING
022900             MOVE MBEMWS-ADD-PENDING
023000                                 TO VR00-ERR-MESSAGE
023100         ELSE
023200             IF  MMOC-REC-PURGED
023300                 MOVE MBEMWS-NOT-ACTIVE
023400                                 TO VR00-ERR-MESSAGE
023500             ELSE
023600                 MOVE DFHBMUNF   TO VR00-ORG-A
023700                 MOVE VR00-ORG   TO MBCA-MERCHANT-ORG
023800                 GO TO D000-RETURN-ERRORS.
023900*
024000 C038-ORG-ERROR.
024100*
024200     MOVE 'Y'                    TO SS08WS-ERROR.
024300     MOVE DFHBMASB               TO VR00-ORG-LP-A
024400                                    VR00-ORG-RP-A.
024500     MOVE SS08WS-CURSOR          TO VR00-ORG-L.
024600     MOVE DFHBMNBF               TO VR00-ORG-A.
024700     GO TO D000-RETURN-ERRORS.
024800/
024900 D000-RETURN-ERRORS SECTION.
025000*
025100     IF  SS08WS-ERROR IS EQUAL TO 'N'
025200         GO TO F000-SETUP-COMMAREA
025300     ELSE
025400         IF  SS08WS-VALID-PF-KEY
025500         OR  SS08WS-EIBAID-VALID-PF-KEY
025600             MOVE 99             TO MBCA-SCREEN-NBR
025700             GO TO F090-TRANSFER-XCTL.
025800*
025900***************************************************************
026000*    INITIALIZE THE STANDARD MAP LINES.  IN AN ERROR          *
026100*    CONDITION, THIS ROUTINE IS PERFORMED PRIMARILY           *
026200*    TO UPDATE THE DATE AND TIME ON THE SCREEN.               *
026300***************************************************************
026400*
026500     PERFORM MB60PD-INIT-STD-MAP-LINES
026600                                 THRU MB60PD-ISML-EXIT.
026700*
026800**********************
026900*    SEND THE MAP    *
027000**********************
027100*
027200     MOVE 'BM03'                 TO MBCA-PROGRAM-LOCATION.
027300     PERFORM MB60PD-SEND-MAP-WITH-ERASE
027400                                 THRU MB60PD-SMWE-EXIT.
027500*
027600************************
027700*    RETURN TO CICS    *
027800************************
027900*
028000     MOVE 'PC04'                 TO MBCA-PROGRAM-LOCATION.
028100     PERFORM MB70PD-RETURN-TRANS-ID
028200                                 THRU MB70PD-RTI-EXIT.
028300/
028400 F000-SETUP-COMMAREA SECTION.
028500*
028600********************************************************
028700*    READ THE FIELD SECURITY FILE TO ENSURE THAT       *
028800*    THE FIELD SECURITY RECORD CORRESPONDING TO THE    *
028900*    SIGNON IS ON FILE AND AN ACTIVE RECORD            *
029000********************************************************
029100*
029200     MOVE 'FC02'                 TO MBCA-PROGRAM-LOCATION.
029300     PERFORM Y900-READ-MMFS      THRU Y919-READ-MMFS-EXIT.
029400*
029500     IF  MMFS-RECORD-NOT-FOUND
029600         MOVE MBCA-FIELD-SECURITY
029700                                 TO MBEMWS-FS-PROFILE
029800         MOVE SS08WS-CURSOR      TO VR00-ALT-TRANID-L
029900         MOVE MBEMWS-FIELD-SECURITY-NOTFND
030000                                 TO VR00-ERR-MESSAGE
030100         MOVE 'Y'                TO SS08WS-ERROR
030200         GO TO D000-RETURN-ERRORS.
030300*
030400***************************************************************
030500*  SET UP COMMAREA FIELDS AND TRANSFER TO THE NEXT PROGRAM    *
030600***************************************************************
030700*
030800     MOVE MBCA-EIBAID            TO SS08WS-EIBAID.
030900*
031000     MOVE MBIOWS-MMOC-DIRECT-KEY-CODE
031100                                 TO MBCA-KEY-CODE.
031200*
031300     PERFORM MB60PD-EDIT-PAGE-NBR
031400                                 THRU MB60PD-EPN-EXIT.
031500*
031600     IF  SS08WS-VALID-PF-KEY
031700     OR  SS08WS-EIBAID-VALID-PF-KEY
031800         MOVE 99                 TO MBCA-SCREEN-NBR.
031900*
032000 F090-TRANSFER-XCTL.
032100*
032200     MOVE 'PC05'                 TO MBCA-PROGRAM-LOCATION.
032300     PERFORM MB70PD-XCTL-TO-MBOXCTL
032400                                 THRU MB70PD-XTM-EXIT.
032500/
032600 Y000-PERFORMED-ROUTINES SECTION.
032700*
032800 Y900-READ-MMFS.
032900*
033000****************************************
033100*    READ THE FIELD SECURITY RECORD    *
033200*    TO OBTAIN THE SECURITY CODES      *
033300****************************************
033400*
033500     MOVE MBCA-MERCHANT-ORG      TO MBIOWS-MMFS-ORG.
033600     MOVE MBCA-FIELD-SECURITY    TO MBIOWS-MMFS-FS-CODE.
033700     SET MBIORO-READ-RANDOM      TO TRUE.
033800     MOVE SS08WS-CICS-FC-NOTFND  TO MBIORO-TEMP-STATUS-1.
033900     PERFORM MMFSAO-ACCESS       THRU MMFSAO-ACCESS-EXIT.
034000*
034100     IF  SS08WS-RC-FC-NOTFND
034200     OR  NOT MMFS-REC-ACTIVE
034300         MOVE 'N'                TO WS-MMFS-FOUND-SW.
034400*
034500 Y919-READ-MMFS-EXIT.
034600     EXIT.
034700/
034800 Z000-COPIED-ROUTINES SECTION.
034900*
035000**********************************
035100*    JUL TO GREG DATE ROUTINE    *
035200**********************************
035300*
035400     COPY SS08PD.
035500/
035600     COPY SS26PD.
035700/
035800     COPY SS27PD.
035900/
036000*********************************
036100*    LINE 24 PF KEYS ROUTINE    *
036200*********************************
036300*
036400     COPY SS15PD.
036500/
036600*******************************************
036700*    ORG FILE ACCESS ROUTINES             *
036800*******************************************
036900*
037000     COPY MMOCAO.
037100/
037200***********************************************
037300*    FIELD SECURITY RECORD ACCESS ROUTINES    *
037400***********************************************
037500*
037600     COPY MMFSAO.
037700/
037800*****************************
037900*    ONLINE MAP ROUTINES    *
038000*****************************
038100*
038200     COPY MB60PD REPLACING 'MBMAPXX' BY 'MBVR00 '
038300                           MBMAPXXI BY MBVR00I
038400                           MBMAPXXO BY MBVR00O.
038500/
038600***************************
038700*    ONLINE PROCEDURES    *
038800***************************
038900*
039000     COPY MB70PD.
039100/
039200     COPY SMFTPXO.
