000100 IDENTIFICATION DIVISION.
000200 PROGRAM-ID. MBOVR01.
000201*       RELEASE DATE=08/24/01.        REVISION LEVEL=08.06      *
000202*****************************************************************
000203*WARNING.  THIS COMPUTER PROGRAM IS PROTECTED BY COPYRIGHT LAW  *
000204*AND INTERNATIONAL TREATIES.  UNAUTHORIZED REPRODUCTION OR      *
000205*DISTRIBUTION OF THIS PROGRAM, OR ANY PORTION OF IT, MAY RESULT *
000206*IN SEVERE CIVIL AND CRIMINAL PENATLIES, AND WILL BE PROSECUTED *
000207*TO THE MAXIMUM EXTENT POSSIBLE UNDER THE LAW.                  *
000208*COPYRIGHT 1999 PAYSYS INTERNATIONAL, INC.  ALL RIGHTS RESERVED.*
000209*****************************************************************
000300*****************************************************************
000400*                                                               *
000500*               M E R C H A N T   S Y S T E M                   *
000600*                                                               *
000700*      MBOVR01 - ON-LINE MERCHANT/STORE VISIT/REVIEW INPUT      *
000800*                SCREEN 01                                      *
000900*                                                               *
001000*              1. TRANSIDS                                      *
001100*                 A. MBVR                                       *
001200*              2. MAPS USED -                                   *
001300*                 A. MBVR01 (SCREEN 01)                         *
001400*              3. FILES USED -                                  *
001500*                 A. MMOC (ORG CONTROL FILE)                    *
001600*                 B. MMFS (FIELD SECURITY FILE)                 *
001700*                 C. MMMM (MERCHANT MASTER FILE)                *
001800*                 D. MMSM (STORE MASTER FILE)                   *
001900*                 E. MML1 (LOG FILE)                            *
002000*                                                               *
002100*****************************************************************
002200*
002300 ENVIRONMENT DIVISION.
002400*
002500 DATA DIVISION.
002600*
002700 WORKING-STORAGE SECTION.
002800*
002900 01  FILLER                  PIC  X(12)      VALUE
003000     '** WS-BEG **'.
003100*
003200 01  FILLER                  PIC  X(11)      VALUE
003300     'DUP STRING:'.
003400*
003500************************************************************
003600*    THE CHARACTER IN THE FIELD 'WS-DUP-CHARACTER' IS      *
003700*    USED TO COPY THE DEFAULT DATE INTO THE VISIT AND/OR   *
003800*    REVIEW DATE FIELDS WHEN RECOGNIZED IN THOSE FIELDS.   *
003900*    IF YOU WHICH TO CHANGE THE CHARACTER, SIMPLY CHANGE   *
004000*    THE LITERAL VALUE IN THE 'WS-DUP-CHARACTER' FIELD     *
004100*    AND RECOMPILE THE PROGRAM.                            *
004200************************************************************
004300*
004400 01  WS-DUP-STRING.
004500     03  FILLER              PIC  X(07)      VALUE ZEROES.
004600     03  WS-DUP-CHARACTER    PIC  X(01)      VALUE '*'.
004700*
004800 01  FILLER                  PIC  X(14)      VALUE
004900     'MISCELLANEOUS:'.
005000*
005100 01  WS-MISCELLANEOUS.
005200     03  WS-VISIT-DATE       PIC  X(08)      VALUE ZEROES.
005300     03  WS-REVIEW-DATE      PIC  X(08)      VALUE ZEROES.
005400*
005500 01  FILLER                  PIC  X(17)      VALUE
005600     'PROGRAM SWITCHES:'.
005700*
005800 01  WS-PROGRAM-SWITCHES.
005900     03  WS-DEFAULT-ERROR-SW PIC  X(01)      VALUE 'N'.
006000         88  DEFAULT-DATE-IS-IN-ERROR        VALUE 'Y'.
006100         88  DEFAULT-DATE-IS-VALID           VALUE 'N'.
006200     03  WS-STORE-MERCH-ERROR-SW
006300                             PIC  X(01)      VALUE 'N'.
006400         88  STORE-MERCH-IS-IN-ERROR         VALUE 'Y'.
006500         88  STORE-MERCH-IS-VALID            VALUE 'N'.
006600     03  WS-S-M-ERROR-SW     PIC  X(01)      VALUE 'N'.
006700         88  S-M-IS-IN-ERROR                 VALUE 'Y'.
006800         88  S-M-IS-VALID                    VALUE 'N'.
006900     03  WS-VISIT-ERROR-SW   PIC  X(01)      VALUE 'N'.
007000         88  VISIT-DATE-IS-IN-ERROR          VALUE 'Y'.
007100         88  VISIT-DATE-IS-VALID             VALUE 'N'.
007200     03  WS-REVIEW-ERROR-SW  PIC  X(01)      VALUE 'N'.
007300         88  REVIEW-DATE-IS-IN-ERROR         VALUE 'Y'.
007400         88  REVIEW-DATE-IS-VALID            VALUE 'N'.
007500     03  WS-UPDATE-SW        PIC  X(01)      VALUE 'N'.
007600         88  FIELDS-WERE-UPDATED             VALUE 'Y'.
007700         88  NO-FIELDS-WERE-UPDATED          VALUE 'N'.
007800     03  WS-MERCH-INDEX-X.
007900         05  WS-MERCH-INDEX  PIC  9(04)      VALUE ZEROS.
008000     03  WS-STORE-INDEX-X.
008100         05  WS-STORE-INDEX  PIC  9(04)      VALUE ZEROS.
008200/
008300 01  FILLER                  PIC  X(29)      VALUE
008400     'I/O REQUEST BLOCK WORK AREAS:'.
008500*
008600     COPY MBIOWS.
008700/
008800 01  FILLER                  PIC  X(18)      VALUE
008900     'I/O REQUEST BLOCK:'.
009000*
009100     COPY MBIORO.
009200/
009300 01  FILLER                  PIC  X(25)      VALUE
009400     'LOG RECORD REQUEST BLOCK:'.
009500*
009600     COPY MML1WS REPLACING ==:MML1:== BY ==MML1==.
009700/
009800 01  FILLER                  PIC  X(29)      VALUE
009900     'MERCHANT MASTER FIELDS TABLE:'.
010000*
010100     COPY MMMMTB.
010200/
010300 01  FILLER                  PIC  X(26)      VALUE
010400     'STORE MASTER FIELDS TABLE:'.
010500*
010600     COPY MMSMTB.
010700/
010800 01  FILLER                  PIC  X(20)      VALUE
010900     'CCS DATE WORK AREAS:'.
011000*
011100     COPY SS01WS.
011200/
011300 01  FILLER                  PIC  X(15)      VALUE
011400     'CCS WORK AREAS:'.
011500*
011600     COPY SS08WS.
011700/
011800     COPY SS00WS.
011900/
012000     COPY SMFTWS.
012100/
012200     COPY SMPTRL REPLACING ==:SMPT:== BY ==SMPT==.
012300/
012400     COPY MB61LK.
012500/
012600 01  FILLER                  PIC  X(12)      VALUE
012700     '** WS-END **'.
012800/
012900 LINKAGE SECTION.
013000*
013100 01  DFHCOMMAREA.
013200*
013300     COPY MB60WS.
013400/
013500********************************
013600*    VISIT/REVIEW INPUT MAP    *
013700********************************
013800*
013900     COPY MBVR01.
014000/
014100*********************************************
014200*    VISIT/REVIEW INPUT MAP REDEFINITION    *
014300*********************************************
014400*
014500     COPY MBVR01R.
014600/
014700***************************
014800*    ORG RECORD LAYOUT    *
014900***************************
015000*
015100     COPY MMOCRL.
015200/
015300**************************************
015400*    FIELD SECURITY RECORD LAYOUT    *
015500**************************************
015600*
015700     COPY MMFSRL.
015800/
015900***************************************
016000*    MERCHANT MASTER RECORD LAYOUT    *
016100***************************************
016200*
016300     COPY MMMMRL.
016400/
016500************************************
016600*    STORE MASTER RECORD LAYOUT    *
016700************************************
016800*
016900     COPY MMSMRL.
017000/
017100***************************
017200*    LOG RECORD LAYOUT    *
017300***************************
017400*
017500     COPY MML1RL REPLACING ==:MML1:== BY ==MML1==.
017600/
017700 PROCEDURE DIVISION.
017800*
017900 A000-HOUSEKEEPING SECTION.
018000*
018100 A020-INIT.
018200*
018300     MOVE 'PC01'                 TO MBCA-PROGRAM-LOCATION.
018400     PERFORM MB70PD-ON-LINE-HOUSEKEEPING
018500                                 THRU MB70PD-OLH-EXIT.
018600*
018700     IF  MBCA-RECEIVE-SCREEN
018800         GO TO C000-RECEIVE-SCREEN.
018900/
019000 B000-SEND-SCREEN SECTION.
019100*
019200*********************************************
019300*    GET CICS STORAGE NEEDED FOR THE MAP    *
019400*********************************************
019500*
019600     MOVE 'SC01'                 TO MBCA-PROGRAM-LOCATION.
019700     PERFORM MB60PD-GETMAIN-FOR-MAP
019800                                 THRU MB60PD-GFM-EXIT.
019900*
020000*******************************************
020100*    INITIALIZE THE STANDARD MAP LINES    *
020200*******************************************
020300*
020400     PERFORM MB60PD-INIT-STD-MAP-LINES
020500                                 THRU MB60PD-ISML-EXIT.
020600*
020700**************************************
020800*    READ THE ORGANIZATION RECORD    *
020900**************************************
021000*
021100     MOVE 'FC01'                 TO MBCA-PROGRAM-LOCATION.
021200     PERFORM Y900-READ-MMOC      THRU Y919-READ-MMOC-EXIT.
021300*
021400**********************************************************
021500*    MOVE THE ORG NAME AND DEFAULT DATE TO THE SCREEN    *
021600**********************************************************
021700*
021800     MOVE MMOC-NA-LINE (1 1)     TO VR01-ORG-NAME.
021900*
022000     MOVE MMOC-TODAYS-JULIAN     TO SS01WS-JULIAN.
022100     PERFORM SS08PD-JUL-TO-GREG
022200        THRU SS08PD-JTG-EXIT
022300     MOVE SS01WS-DATE            TO VR01-DEFAULT.
022400     MOVE DFHBMUNF               TO VR01-DEFAULT-A.
022500*
022600****************************************
022700*    READ THE FIELD SECURITY RECORD    *
022800****************************************
022900*
023000     MOVE 'FC02'                 TO MBCA-PROGRAM-LOCATION.
023100     PERFORM Y920-READ-MMFS      THRU Y939-READ-MMFS-EXIT.
023200*
023300******************************************
023400*    SET THE CURSOR AND SCREEN NUMBER    *
023500******************************************
023600*
023700     COMPUTE MBCA-SCREEN-NBR     =  MBCA-SCREEN-NBR - 50.
023800*
023900     SET  X-VR01-ITEM            TO 1.
024000     MOVE SS08WS-CURSOR          TO VR01-STORE-MERCH-L
024100                                        (X-VR01-ITEM).
024200*
024300**********************
024400*    SEND THE MAP    *
024500**********************
024600*
024700     MOVE 'BM01'                 TO MBCA-PROGRAM-LOCATION.
024800*
024900     PERFORM MB60PD-SEND-MAP-WITH-ERASE
025000                                 THRU MB60PD-SMWE-EXIT.
025100*
025200************************
025300*    RETURN TO CICS    *
025400************************
025500*
025600     MOVE 'PC02'                 TO MBCA-PROGRAM-LOCATION.
025700     PERFORM MB70PD-RETURN-TRANS-ID
025800                                 THRU MB70PD-RTI-EXIT.
025900/
026000 C000-RECEIVE-SCREEN SECTION.
026100*
026200******************************************
026300*    THIS SECTION RECEIVES THE SCREEN    *
026400******************************************
026500*
026600     MOVE 'BM02'                 TO MBCA-PROGRAM-LOCATION.
026700     PERFORM MB60PD-RECEIVE-MAP  THRU MB60PD-RM-EXIT.
026800*
026900**************************************************************
027000*    CHECK FOR ANOTHER TRANSACTION ID ENTERED BY THE USER    *
027100**************************************************************
027200*
027300     MOVE 'PC03'                 TO MBCA-PROGRAM-LOCATION.
027400     PERFORM MB60PD-NEW-TRANS-ROUTINE
027500                                 THRU MB60PD-NTR-EXIT.
027600*
027700**************************************
027800*    READ THE ORGANIZATION RECORD    *
027900**************************************
028000*
028100     MOVE 'FC03'                 TO MBCA-PROGRAM-LOCATION.
028200     PERFORM Y900-READ-MMOC      THRU Y919-READ-MMOC-EXIT.
028300*
028400     MOVE MMOC-NA-LINE (1 1)     TO VR01-ORG-NAME.
028500*
028600****************************************
028700*    READ THE FIELD SECURITY RECORD    *
028800****************************************
028900*
029000     MOVE 'FC04'                 TO MBCA-PROGRAM-LOCATION.
029100     PERFORM Y920-READ-MMFS      THRU Y939-READ-MMFS-EXIT.
029200*
029300 C020-FIELD-EDITS.
029400*
029500     PERFORM W020-EDIT-DEFAULT-DATE
029600                                 THRU W039-EDD-EXIT.
029700*
029800     SET X-VR01-ITEM             TO 1.
029900*
030000  C040-FE-LOOP.
030100*
030200     MOVE 'N'                    TO WS-STORE-MERCH-ERROR-SW
030300                                    WS-S-M-ERROR-SW
030400                                    WS-VISIT-ERROR-SW
030500                                    WS-REVIEW-ERROR-SW.
030600*
030700     PERFORM W040-EDIT-STORE-MERCH
030800                                 THRU W059-ESM-EXIT.
030900*
031000     PERFORM W060-EDIT-S-M       THRU W079-ESM-EXIT.
031100*
031200     PERFORM W080-EDIT-VISIT-DATE
031300                                 THRU W099-EVD-EXIT.
031400*
031500     PERFORM W100-EDIT-REVIEW-DATE
031600                                 THRU W119-ERD-EXIT.
031700*
031800     PERFORM W520-CROSS-EDITS    THRU W539-CE-EXIT.
031900*
032000 C060-INCREMENT-INDEXES.
032100*
032200     IF  X-VR01-ITEM IS LESS THAN 15
032300         SET X-VR01-ITEM         UP BY 1
032400         GO TO C040-FE-LOOP.
032500/
032600 D000-RETURN-ERRORS SECTION.
032700*
032800     IF  SS08WS-ERROR IS EQUAL TO 'N'
032900         GO TO E000-UPDATE-FILE.
033000*
033100***************************************************************
033200*    INITIALIZE THE STANDARD MAP LINES.  IN AN ERROR          *
033300*    CONDITION, THIS ROUTINE IS PERFORMED PRIMARILY           *
033400*    TO UPDATE THE DATE AND TIME ON THE SCREEN.               *
033500***************************************************************
033600*
033700     PERFORM MB60PD-INIT-STD-MAP-LINES
033800                                 THRU MB60PD-ISML-EXIT.
033900*
034000**********************
034100*    SEND THE MAP    *
034200**********************
034300*
034400     MOVE 'BM03'                 TO MBCA-PROGRAM-LOCATION.
034500     PERFORM MB60PD-SEND-MAP-DATA-ONLY
034600                                 THRU MB60PD-SMDO-EXIT.
034700*
034800************************
034900*    RETURN TO CICS    *
035000************************
035100*
035200     MOVE 'PC04'                 TO MBCA-PROGRAM-LOCATION.
035300     PERFORM MB70PD-RETURN-TRANS-ID
035400                                 THRU MB70PD-RTI-EXIT.
035500/
035600 E000-UPDATE-FILE SECTION.
035700*
035800*******************************************
035900*    OBTAIN STORAGE FOR THE LOG RECORD    *
036000*******************************************
036100*
036200     MOVE 'SC02'                 TO MBCA-PROGRAM-LOCATION.
036300     SET MBIORO-GETMAIN          TO TRUE.
036400     PERFORM MML1AO-ACCESS       THRU MML1AO-ACCESS-EXIT.
036500*
036600*************************************************
036700*    SET UP THE COMMON PORTION OF THE RECORD    *
036800*************************************************
036900*
037000     MOVE MBCA-SIGNON-NAME       TO MML1-SIGNON-NAME.
037100     MOVE MBCA-TERMINAL-ID       TO MML1-TERMINAL-ID.
037200     MOVE ZEROS                  TO MML1-SOURCE-CODE.
037300     MOVE MBCA-FIELD-SECURITY    TO MML1-FIELD-SECURITY.
037400*
037500 E020-UPDATE-FIELDS.
037600*
037700     SET X-VR01-ITEM             TO 1.
037800*
037900 E040-UF-LOOP.
038000*
038100*************************************************************
038200*    READ THE MERCHANT RECORD OR STORE RECORD FOR UPDATE    *
038300*************************************************************
038400*
038500     IF  VR01-MERCHANT-RECORD (X-VR01-ITEM)
038600         MOVE 'MM'               TO MML1-FILE-CODE
038700         MOVE MBCA-MERCHANT-ORG  TO MML1-MMMM-ORG
038800         MOVE VR01-STORE-MERCH (X-VR01-ITEM)
038900                                 TO MBIOWS-MMMM-MERCHANT
039000                                    MML1-MMMM-MERCHANT
039100         SET MBIORO-READ-RANDOM-UPDATE
039200                                 TO TRUE
039300         MOVE 'FC05'             TO MBCA-PROGRAM-LOCATION
039400         PERFORM MMMMAO-ACCESS   THRU MMMMAO-ACCESS-EXIT.
039500*
039600     IF  VR01-STORE-RECORD (X-VR01-ITEM)
039700         MOVE 'SM'               TO MML1-FILE-CODE
039800         MOVE MBCA-MERCHANT-ORG  TO MML1-MMSM-ORG
039900         MOVE VR01-STORE-MERCH (X-VR01-ITEM)
040000                                 TO MBIOWS-MMSM-STORE
040100                                    MML1-MMSM-STORE
040200         SET MBIORO-READ-RANDOM-UPDATE
040300                                 TO TRUE
040400         MOVE 'FC06'             TO MBCA-PROGRAM-LOCATION
040500         PERFORM MMSMAO-ACCESS   THRU MMSMAO-ACCESS-EXIT.
040600*
040700     MOVE 'N'                    TO WS-UPDATE-SW.
040800*
040900     PERFORM X080-UPDATE-VISIT-DATE
041000                                 THRU X099-UVD-EXIT.
041100*
041200     PERFORM X100-UPDATE-REVIEW-DATE
041300                                 THRU X119-URD-EXIT.
041400*
041500 E060-UPDATE-MMMM.
041600*
041700**********************************************************
041800*    BYPASS THIS ROUTINE IF PROCESSING A STORE RECORD    *
041900**********************************************************
042000*
042100     IF  VR01-STORE-RECORD (X-VR01-ITEM)
042200         GO TO E080-UPDATE-MMSM.
042300*
042400**************************************************************
042500*    WRITE A LOG RECORD TO SHOW THAT THE LAST MAINT DATE     *
042600*    AND OPERATOR HAS BEEN UPDATED IF FIELDS WERE UPDATED    *
042700**************************************************************
042800*
042900     IF  FIELDS-WERE-UPDATED
043000         MOVE 0198               TO MML1-FIELD-CODE
043100         MOVE ZEROES             TO MML1-FIELD-OCCURRENCE
043200                                    MML1-FIELD-OCCURRENCE-2
043300         MOVE 'N'                TO MML1-MMMM-AUDIT-CODE
043400         MOVE MML1WS-VL-03       TO MML1-VARIABLE-LENGTH
043500         MOVE MMMM-LAST-MAINT-OPER
043600                                 TO MML1-VL03-B-DATA-X
043700         MOVE MBCA-OPERATOR-ID   TO MMMM-LAST-MAINT-OPER
043800         MOVE MMMM-LAST-MAINT-OPER
043900                                 TO MML1-VL03-A-DATA-X
044000         MOVE 'FC07'             TO MBCA-PROGRAM-LOCATION
044100         PERFORM Y020-WRITE-LOG-RECORD
044200                                 THRU Y039-WLR-EXIT
044300         MOVE 0199               TO MML1-FIELD-CODE
044400         MOVE MML1WS-VL-07       TO MML1-VARIABLE-LENGTH
044500         MOVE MMMM-LAST-MAINT-DATE
044600                                 TO MML1-VL07-B-DATA-9
044700         MOVE MBCA-START-DATE    TO MMMM-LAST-MAINT-DATE
044800         MOVE MMMM-LAST-MAINT-DATE
044900                                 TO MML1-VL07-A-DATA-9
045000         MOVE 'FC08'             TO MBCA-PROGRAM-LOCATION
045100         PERFORM Y020-WRITE-LOG-RECORD
045200                                 THRU Y039-WLR-EXIT.
045300*
045400************************************************
045500*    REWRITE THE MERCHANT MASTER RECORD IF     *
045600*    FIELDS HAVE WERE UPDATED, OR UNLOCK IT    *
045700*    IT IF THEY WERE NOT                       *
045800************************************************
045900*
046000     IF  FIELDS-WERE-UPDATED
046100         MOVE 'FC09'             TO MBCA-PROGRAM-LOCATION
046200         SET MBIORO-REWRITE      TO TRUE
046300         PERFORM MMMMAO-ACCESS   THRU MMMMAO-ACCESS-EXIT
046400     ELSE
046500         MOVE 'FC10'             TO MBCA-PROGRAM-LOCATION
046600         SET MBIORO-UNLOCK       TO TRUE
046700         PERFORM MMMMAO-ACCESS   THRU MMMMAO-ACCESS-EXIT.
046800*
046900     GO TO E100-INCREMENT-INDEXES.
047000*
047100 E080-UPDATE-MMSM.
047200*
047300**************************************************************
047400*    WRITE A LOG RECORD TO SHOW THAT THE LAST MAINT DATE     *
047500*    AND OPERATOR HAS BEEN UPDATED IF FIELDS WERE UPDATED    *
047600**************************************************************
047700*
047800     IF  FIELDS-WERE-UPDATED
047900         MOVE 0198               TO MML1-FIELD-CODE
048000         MOVE ZEROES             TO MML1-FIELD-OCCURRENCE
048100                                    MML1-FIELD-OCCURRENCE-2
048200         MOVE 'N'                TO MML1-MMSM-AUDIT-CODE
048300         MOVE MML1WS-VL-03       TO MML1-VARIABLE-LENGTH
048400         MOVE MMSM-LAST-MAINT-OPER
048500                                 TO MML1-VL03-B-DATA-X
048600         MOVE MBCA-OPERATOR-ID   TO MMSM-LAST-MAINT-OPER
048700         MOVE MMSM-LAST-MAINT-OPER
048800                                 TO MML1-VL03-A-DATA-X
048900         MOVE 'FC11'             TO MBCA-PROGRAM-LOCATION
049000         PERFORM Y020-WRITE-LOG-RECORD
049100                                 THRU Y039-WLR-EXIT
049200         MOVE 0199               TO MML1-FIELD-CODE
049300         MOVE MML1WS-VL-07       TO MML1-VARIABLE-LENGTH
049400         MOVE MMSM-LAST-MAINT-DATE
049500                                 TO MML1-VL07-B-DATA-9
049600         MOVE MBCA-START-DATE    TO MMSM-LAST-MAINT-DATE
049700         MOVE MMSM-LAST-MAINT-DATE
049800                                 TO MML1-VL07-A-DATA-9
049900         MOVE 'FC12'             TO MBCA-PROGRAM-LOCATION
050000         PERFORM Y020-WRITE-LOG-RECORD
050100                                 THRU Y039-WLR-EXIT.
050200*
050300************************************************
050400*    REWRITE THE STORE MASTER RECORD IF        *
050500*    FIELDS HAVE WERE UPDATED, OR UNLOCK IT    *
050600*    IT IF THEY WERE NOT                       *
050700************************************************
050800*
050900     IF  FIELDS-WERE-UPDATED
051000         MOVE 'FC13'             TO MBCA-PROGRAM-LOCATION
051100         SET MBIORO-REWRITE      TO TRUE
051200         PERFORM MMSMAO-ACCESS   THRU MMSMAO-ACCESS-EXIT
051300     ELSE
051400         MOVE 'FC14'             TO MBCA-PROGRAM-LOCATION
051500         SET MBIORO-UNLOCK       TO TRUE
051600         PERFORM MMSMAO-ACCESS   THRU MMSMAO-ACCESS-EXIT.
051700*
051800 E100-INCREMENT-INDEXES.
051900*
052000     IF  X-VR01-ITEM IS LESS THAN 15
052100         SET X-VR01-ITEM         UP BY 1
052200         GO TO E040-UF-LOOP.
052300/
052400 F000-SETUP-COMMAREA SECTION.
052500*
052600***************************************************************
052700*  SET UP COMMAREA FIELDS AND TRANSFER TO THE NEXT PROGRAM    *
052800***************************************************************
052900*
053000     MOVE MBCA-EIBAID            TO SS08WS-EIBAID.
053100*
053200     PERFORM MB60PD-EDIT-PAGE-NBR
053300                                 THRU MB60PD-EPN-EXIT.
053400*
053500     IF  VR01-CURRENT-PAGE-L IS EQUAL TO ZERO
053600         MOVE 51                 TO MBCA-SCREEN-NBR.
053700*
053800     IF  SS08WS-VALID-PF-KEY
053900     OR  SS08WS-EIBAID-VALID-PF-KEY
054000         MOVE 99                 TO MBCA-SCREEN-NBR.
054100*
054200     MOVE 'PC05'                 TO MBCA-PROGRAM-LOCATION.
054300     PERFORM MB70PD-XCTL-TO-MBOXCTL
054400                                 THRU MB70PD-XTM-EXIT.
054500/
054600 W000-FIELD-EDITS SECTION.
054700*
054800 W020-EDIT-DEFAULT-DATE.
054900*
055000     IF  VR01-DEFAULT IS NOT NUMERIC
055100     OR  VR01-DEFAULT IS EQUAL TO ZEROES
055200         GO TO W038-DEFAULT-DATE-ERROR.
055300*
055400     IF  VR01-DEFAULT IS LESS THAN 1000000
055500         MOVE VR01-DEFAULT       TO SS01WS-MDY
055600         MOVE SS01WS-MDYZ        TO SS01WS-DATEZ
055700     ELSE
055800         MOVE VR01-DEFAULT       TO SS01WS-DATE.
055900*
056000     PERFORM SS05PD-DATE-VALIDATION
056100                                 THRU SS05PD-DV-EXIT.
056200*
056300     IF  SS01WS-DATE-IS-INVALID
056400         GO TO W038-DEFAULT-DATE-ERROR
056500     ELSE
056600         MOVE SS01WS-DATE        TO VR01-DEFAULT.
056700*
056800     PERFORM SS07PD-GREG-TO-JUL  THRU SS07PD-GTJ-EXIT.
056900*
057000     IF  SS01WS-JULIAN IS NOT GREATER THAN MMOC-TODAYS-JULIAN
057100         MOVE DFHBMDAS           TO VR01-DEFAULT-LP-A
057200                                    VR01-DEFAULT-RP-A
057300         MOVE DFHBMASF           TO VR01-DEFAULT-A
057400         GO TO W039-EDD-EXIT.
057500*
057600 W038-DEFAULT-DATE-ERROR.
057700*
057800     MOVE 'Y'                    TO SS08WS-ERROR
057900                                    WS-DEFAULT-ERROR-SW.
058000     MOVE SS08WS-CURSOR          TO VR01-DEFAULT-L.
058100     MOVE DFHBMNBF               TO VR01-DEFAULT-A.
058200     MOVE DFHBMASB               TO VR01-DEFAULT-LP-A
058300                                    VR01-DEFAULT-RP-A.
058400*
058500 W039-EDD-EXIT.
058600     EXIT.
058700*
058800 W040-EDIT-STORE-MERCH.
058900*
059000
059100     MOVE DFHBMDAS               TO VR01-STORE-MERCH-LP-A
059200                                        (X-VR01-ITEM)
059300                                    VR01-STORE-MERCH-RP-A
059400                                        (X-VR01-ITEM).
059500     MOVE DFHBMASK               TO VR01-STORE-MERCH-A
059600                                        (X-VR01-ITEM).
059700*
059800     IF  VR01-STORE-MERCH-L (X-VR01-ITEM) IS EQUAL TO ZERO
059900         GO TO W059-ESM-EXIT.
060000*
060100     IF  VR01-STORE-MERCH (X-VR01-ITEM) IS NOT NUMERIC
060200     OR  VR01-STORE-MERCH (X-VR01-ITEM) IS EQUAL TO ZEROES
060300     OR  VR01-STORE-MERCH (X-VR01-ITEM) IS EQUAL TO 999999999
060400         GO TO W058-STORE-MERCH-ERROR.
060500*
060600     MOVE DFHBMASF               TO VR01-STORE-MERCH-A
060700                                        (X-VR01-ITEM).
060800     GO TO W059-ESM-EXIT.
060900*
061000 W058-STORE-MERCH-ERROR.
061100*
061200     MOVE 'Y'                    TO SS08WS-ERROR
061300                                    WS-STORE-MERCH-ERROR-SW.
061400     MOVE SS08WS-CURSOR          TO VR01-STORE-MERCH-L
061500                                        (X-VR01-ITEM).
061600     MOVE DFHBMNBF               TO VR01-STORE-MERCH-A
061700                                        (X-VR01-ITEM).
061800     MOVE DFHBMASB               TO VR01-STORE-MERCH-LP-A
061900                                        (X-VR01-ITEM)
062000                                    VR01-STORE-MERCH-RP-A
062100                                        (X-VR01-ITEM).
062200*
062300 W058-SME-EXIT.
062400     EXIT.
062500*
062600 W059-ESM-EXIT.
062700     EXIT.
062800*
062900 W060-EDIT-S-M.
063000*
063100     MOVE DFHBMDAS               TO VR01-S-M-LP-A
063200                                        (X-VR01-ITEM)
063300                                    VR01-S-M-RP-A
063400                                        (X-VR01-ITEM).
063500     MOVE DFHBMASK               TO VR01-S-M-A
063600                                        (X-VR01-ITEM).
063700*
063800     IF  VR01-S-M-L (X-VR01-ITEM) IS EQUAL TO ZERO
063900         GO TO W079-ESM-EXIT.
064000*
064100     IF  NOT VR01-STORE-RECORD    (X-VR01-ITEM)
064200     AND NOT VR01-MERCHANT-RECORD (X-VR01-ITEM)
064300         GO TO W078-S-M-ERROR.
064400*
064500     MOVE DFHBMASF               TO VR01-S-M-A
064600                                        (X-VR01-ITEM).
064700*
064800     IF  STORE-MERCH-IS-IN-ERROR
064900         GO TO W079-ESM-EXIT.
065000*
065100*******************************************
065200*    THE MERCHANT/STORE RECORD MUST BE    *
065300*    ON FILE AND AN ACTIVE RECORD         *
065400*******************************************
065500*
065600     IF  VR01-MERCHANT-RECORD (X-VR01-ITEM)
065700         MOVE MBCA-MERCHANT-ORG TO MBIOWS-MMMM-ORG
065800         MOVE VR01-STORE-MERCH (X-VR01-ITEM)
065900                                 TO MBIOWS-MMMM-MERCHANT
066000         MOVE SS08WS-CICS-FC-NOTFND TO MBIORO-TEMP-STATUS-1
066100         SET MBIORO-READ-RANDOM  TO TRUE
066200         MOVE 'FC15'             TO MBCA-PROGRAM-LOCATION
066300         PERFORM MMMMAO-ACCESS   THRU MMMMAO-ACCESS-EXIT
066400         IF  SS08WS-RC-FC-VALID-RTN-CODE
066500         AND NOT MMMM-REC-PURGED
066600             GO TO W079-ESM-EXIT
066700         ELSE
066800             PERFORM W058-STORE-MERCH-ERROR
066900                                 THRU W058-SME-EXIT
067000             GO TO W078-S-M-ERROR.
067100*
067200     MOVE MBCA-MERCHANT-ORG      TO MBIOWS-MMSM-ORG.
067300     MOVE VR01-STORE-MERCH (X-VR01-ITEM)
067400                                 TO MBIOWS-MMSM-STORE.
067500     MOVE SS08WS-CICS-FC-NOTFND  TO MBIORO-TEMP-STATUS-1.
067600     SET MBIORO-READ-RANDOM      TO TRUE.
067700     MOVE 'FC16'                 TO MBCA-PROGRAM-LOCATION.
067800     PERFORM MMSMAO-ACCESS       THRU MMSMAO-ACCESS-EXIT.
067900     IF  SS08WS-RC-FC-VALID-RTN-CODE
068000     AND NOT MMSM-REC-PURGED
068100         GO TO W079-ESM-EXIT
068200     ELSE
068300         PERFORM W058-STORE-MERCH-ERROR
068400                                 THRU W058-SME-EXIT
068500         GO TO W078-S-M-ERROR.
068600*
068700 W078-S-M-ERROR.
068800*
068900     MOVE 'Y'                    TO SS08WS-ERROR
069000                                    WS-S-M-ERROR-SW.
069100     MOVE SS08WS-CURSOR          TO VR01-S-M-L
069200                                        (X-VR01-ITEM).
069300     MOVE DFHBMUBF               TO VR01-S-M-A
069400                                        (X-VR01-ITEM).
069500     MOVE DFHBMASB               TO VR01-S-M-LP-A
069600                                        (X-VR01-ITEM)
069700                                    VR01-S-M-RP-A
069800                                        (X-VR01-ITEM).
069900*
070000 W079-ESM-EXIT.
070100     EXIT.
070200*
070300 W080-EDIT-VISIT-DATE.
070400*
070500     MOVE DFHBMDAS               TO VR01-DATE-VISITED-LP-A
070600                                        (X-VR01-ITEM)
070700                                    VR01-DATE-VISITED-RP-A
070800                                        (X-VR01-ITEM).
070900     MOVE DFHBMASK               TO VR01-DATE-VISITED-A
071000                                        (X-VR01-ITEM).
071100*
071200     IF  VR01-DATE-VISITED-L (X-VR01-ITEM) IS EQUAL TO ZERO
071300         GO TO W099-EVD-EXIT.
071400*
071500     MOVE VR01-DATE-VISITED-X (X-VR01-ITEM)
071600                                 TO WS-VISIT-DATE.
071700*
071800     IF  WS-VISIT-DATE IS EQUAL TO WS-DUP-STRING
071900     AND DEFAULT-DATE-IS-VALID
072000         MOVE VR01-DEFAULT       TO VR01-DATE-VISITED
072100                                        (X-VR01-ITEM).
072200*
072300     IF  VR01-MERCHANT-RECORD (X-VR01-ITEM)
072400         MOVE MMMMTB-DATE-LAST-VISIT (1:4)
072500                                 TO WS-MERCH-INDEX-X
072600         SET X-MMFS-MERCH        TO WS-MERCH-INDEX
072700         IF  NOT MMFS-MT-MAINT-ALLOWED (X-MMFS-MERCH)
072800             GO TO W098-VISIT-DATE-ERROR.
072900*
073000     IF  VR01-STORE-RECORD (X-VR01-ITEM)
073100         MOVE MMSMTB-DATE-LAST-VISIT (1:4)
073200                                 TO WS-STORE-INDEX-X
073300         SET X-MMFS-STORE        TO WS-STORE-INDEX
073400         IF  NOT MMFS-ST-MAINT-ALLOWED (X-MMFS-STORE)
073500             GO TO W098-VISIT-DATE-ERROR.
073600*
073700     IF  VR01-DATE-VISITED (X-VR01-ITEM) IS NOT NUMERIC
073800     OR  VR01-DATE-VISITED (X-VR01-ITEM) IS EQUAL TO ZEROES
073900         GO TO W098-VISIT-DATE-ERROR.
074000*
074100     IF  VR01-DATE-VISITED (X-VR01-ITEM) IS LESS THAN 1000000
074200         MOVE VR01-DATE-VISITED (X-VR01-ITEM)
074300                                 TO SS01WS-MDY
074400         MOVE SS01WS-MDYZ        TO SS01WS-DATEZ
074500     ELSE
074600         MOVE VR01-DATE-VISITED (X-VR01-ITEM)
074700                                 TO SS01WS-DATE.
074800*
074900     PERFORM SS05PD-DATE-VALIDATION
075000                                 THRU SS05PD-DV-EXIT.
075100*
075200     IF  SS01WS-DATE-IS-INVALID
075300         GO TO W098-VISIT-DATE-ERROR
075400     ELSE
075500         MOVE SS01WS-DATE        TO VR01-DATE-VISITED
075600                                         (X-VR01-ITEM).
075700*
075800     PERFORM SS07PD-GREG-TO-JUL  THRU SS07PD-GTJ-EXIT.
075900*
076000     IF  SS01WS-JULIAN IS NOT GREATER THAN MMOC-TODAYS-JULIAN
076100         MOVE DFHBMASF           TO VR01-DATE-VISITED-A
076200                                        (X-VR01-ITEM)
076300         GO TO W099-EVD-EXIT.
076400*
076500 W098-VISIT-DATE-ERROR.
076600*
076700     MOVE 'Y'                    TO SS08WS-ERROR
076800                                    WS-VISIT-ERROR-SW.
076900     MOVE SS08WS-CURSOR          TO VR01-DATE-VISITED-L
077000                                        (X-VR01-ITEM).
077100     MOVE DFHBMNBF               TO VR01-DATE-VISITED-A
077200                                        (X-VR01-ITEM).
077300     MOVE DFHBMASB               TO VR01-DATE-VISITED-LP-A
077400                                        (X-VR01-ITEM)
077500                                    VR01-DATE-VISITED-RP-A
077600                                        (X-VR01-ITEM).
077700*
077800 W099-EVD-EXIT.
077900     EXIT.
078000*
078100 W100-EDIT-REVIEW-DATE.
078200*
078300     MOVE DFHBMDAS               TO VR01-DATE-REVIEWED-LP-A
078400                                        (X-VR01-ITEM)
078500                                    VR01-DATE-REVIEWED-RP-A
078600                                        (X-VR01-ITEM).
078700     MOVE DFHBMASK               TO VR01-DATE-REVIEWED-A
078800                                        (X-VR01-ITEM).
078900*
079000     IF  VR01-DATE-REVIEWED-L (X-VR01-ITEM) IS EQUAL TO ZERO
079100         GO TO W119-ERD-EXIT.
079200*
079300     MOVE VR01-DATE-REVIEWED-X (X-VR01-ITEM)
079400                                 TO WS-REVIEW-DATE.
079500*
079600     IF  WS-REVIEW-DATE IS EQUAL TO WS-DUP-STRING
079700     AND DEFAULT-DATE-IS-VALID
079800         MOVE VR01-DEFAULT       TO VR01-DATE-REVIEWED
079900                                        (X-VR01-ITEM).
080000*
080100     IF  VR01-MERCHANT-RECORD (X-VR01-ITEM)
080200         MOVE MMMMTB-DATE-LAST-REVIEW (1:4)
080300                                 TO WS-MERCH-INDEX-X
080400         SET X-MMFS-MERCH        TO WS-MERCH-INDEX
080500         IF  NOT MMFS-MT-MAINT-ALLOWED (X-MMFS-MERCH)
080600             GO TO W118-REVIEW-DATE-ERROR.
080700*
080800     IF  VR01-STORE-RECORD (X-VR01-ITEM)
080900         MOVE MMSMTB-DATE-LAST-REVIEW (1:4)
081000                                 TO WS-STORE-INDEX-X
081100         SET X-MMFS-STORE        TO WS-STORE-INDEX
081200         IF  NOT MMFS-ST-MAINT-ALLOWED (X-MMFS-STORE)
081300             GO TO W118-REVIEW-DATE-ERROR.
081400*
081500     IF  VR01-DATE-REVIEWED (X-VR01-ITEM) IS NOT NUMERIC
081600     OR  VR01-DATE-REVIEWED (X-VR01-ITEM) IS EQUAL TO ZEROES
081700         GO TO W118-REVIEW-DATE-ERROR.
081800*
081900     IF  VR01-DATE-REVIEWED (X-VR01-ITEM) IS LESS THAN 1000000
082000         MOVE VR01-DATE-REVIEWED (X-VR01-ITEM)
082100                                 TO SS01WS-MDY
082200         MOVE SS01WS-MDYZ        TO SS01WS-DATEZ
082300     ELSE
082400         MOVE VR01-DATE-REVIEWED (X-VR01-ITEM)
082500                                 TO SS01WS-DATE.
082600*
082700     PERFORM SS05PD-DATE-VALIDATION
082800                                 THRU SS05PD-DV-EXIT.
082900*
083000     IF  SS01WS-DATE-IS-INVALID
083100         GO TO W118-REVIEW-DATE-ERROR
083200     ELSE
083300         MOVE SS01WS-DATE        TO VR01-DATE-REVIEWED
083400                                        (X-VR01-ITEM).
083500*
083600     PERFORM SS07PD-GREG-TO-JUL  THRU SS07PD-GTJ-EXIT.
083700*
083800     IF  SS01WS-JULIAN IS NOT GREATER THAN MMOC-TODAYS-JULIAN
083900         MOVE DFHBMASF           TO VR01-DATE-REVIEWED-A
084000                                        (X-VR01-ITEM)
084100         GO TO W119-ERD-EXIT.
084200*
084300 W118-REVIEW-DATE-ERROR.
084400*
084500     MOVE 'Y'                    TO SS08WS-ERROR
084600                                    WS-REVIEW-ERROR-SW.
084700     MOVE SS08WS-CURSOR          TO VR01-DATE-REVIEWED-L
084800                                        (X-VR01-ITEM).
084900     MOVE DFHBMNBF               TO VR01-DATE-REVIEWED-A
085000                                        (X-VR01-ITEM).
085100     MOVE DFHBMASB               TO VR01-DATE-REVIEWED-LP-A
085200                                        (X-VR01-ITEM)
085300                                    VR01-DATE-REVIEWED-RP-A
085400                                        (X-VR01-ITEM).
085500*
085600 W119-ERD-EXIT.
085700     EXIT.
085800*
085900 W520-CROSS-EDITS.
086000*
086100***********************************************************
086200*                                                         *
086300*    THE CROSS EDITS ARE AS FOLLOWS:                      *
086400*                                                         *
086500*    . IF A VISIT DATE AND/OR REVIEW DATE IS ENTERED,     *
086600*      A CORRSPONDING STORE/MERCHANT AND S-M ID           *
086700*      MUST ALSO BE ENTERED.                              *
086800*                                                         *
086900*    . IF A STORE/MERCH AND S-M ID ARE ENTERED            *
087000*      A CORRSPONDING VISIT DATE AND/OR REVIEW DATE       *
087100*      MUST ALSO BE ENTERED.                              *
087200*                                                         *
087300*      IF AN ERROR IS DETECTED, THE ENTIRE LINE IS        *
087400*      HIGHLIGHTED AND OPENED FOR CORRECTION.             *
087500*                                                         *
087600***********************************************************
087700*
087800     IF  STORE-MERCH-IS-IN-ERROR
087900     OR  S-M-IS-IN-ERROR
088000     OR  VISIT-DATE-IS-IN-ERROR
088100     OR  REVIEW-DATE-IS-IN-ERROR
088200         GO TO W539-CE-EXIT.
088300*
088400     IF  VR01-STORE-MERCH-L   (X-VR01-ITEM) IS EQUAL TO ZERO
088500     AND VR01-S-M-L           (X-VR01-ITEM) IS EQUAL TO ZERO
088600     AND VR01-DATE-VISITED-L  (X-VR01-ITEM) IS EQUAL TO ZERO
088700     AND VR01-DATE-REVIEWED-L (X-VR01-ITEM) IS EQUAL TO ZERO
088800         GO TO W539-CE-EXIT.
088900*
089000     IF  VR01-STORE-MERCH-L  (X-VR01-ITEM) IS GREATER THAN ZERO
089100     AND VR01-S-M-L          (X-VR01-ITEM) IS GREATER THAN ZERO
089200         IF  VR01-DATE-VISITED-L  (X-VR01-ITEM) IS EQUAL TO ZERO
089300         AND VR01-DATE-REVIEWED-L (X-VR01-ITEM) IS EQUAL TO ZERO
089400             GO TO W538-CROSS-EDIT-ERROR
089500         ELSE
089600             GO TO W539-CE-EXIT.
089700*
089800 W538-CROSS-EDIT-ERROR.
089900*
090000     MOVE 'Y'                    TO SS08WS-ERROR.
090100*
090200     MOVE DFHBMASB               TO VR01-STORE-MERCH-LP-A
090300                                        (X-VR01-ITEM)
090400                                    VR01-STORE-MERCH-RP-A
090500                                        (X-VR01-ITEM)
090600                                    VR01-S-M-LP-A
090700                                        (X-VR01-ITEM)
090800                                    VR01-S-M-RP-A
090900                                        (X-VR01-ITEM).
091000     MOVE DFHBMNBF               TO VR01-STORE-MERCH-A
091100                                        (X-VR01-ITEM).
091200     MOVE DFHBMUBF               TO VR01-S-M-A
091300                                        (X-VR01-ITEM).
091400*
091500     IF  VR01-STORE-MERCH-L (X-VR01-ITEM) IS EQUAL TO ZERO
091600         MOVE SS08WS-CURSOR      TO VR01-STORE-MERCH-L
091700                                        (X-VR01-ITEM).
091800     IF  VR01-S-M-L         (X-VR01-ITEM) IS EQUAL TO ZERO
091900         MOVE SS08WS-CURSOR      TO VR01-S-M-L
092000                                        (X-VR01-ITEM).
092100*
092200     MOVE MMMMTB-DATE-LAST-VISIT (1:4)
092300                                 TO WS-MERCH-INDEX-X.
092400     SET X-MMFS-MERCH            TO WS-MERCH-INDEX.
092500*
092600     IF  MMFS-MT-MAINT-ALLOWED (X-MMFS-MERCH)
092700         MOVE DFHBMASB           TO VR01-DATE-VISITED-LP-A
092800                                        (X-VR01-ITEM)
092900                                    VR01-DATE-VISITED-RP-A
093000                                        (X-VR01-ITEM)
093100         MOVE DFHBMNBF           TO VR01-DATE-VISITED-A
093200                                        (X-VR01-ITEM)
093300         IF  VR01-DATE-VISITED-L (X-VR01-ITEM) IS EQUAL TO ZERO
093400             MOVE SS08WS-CURSOR  TO VR01-DATE-VISITED-L
093500                                        (X-VR01-ITEM).
093600*
093700     MOVE MMMMTB-DATE-LAST-REVIEW (1:4)
093800                                 TO WS-MERCH-INDEX-X.
093900     SET X-MMFS-MERCH            TO WS-MERCH-INDEX.
094000*
094100     IF  MMFS-MT-MAINT-ALLOWED (X-MMFS-MERCH)
094200         MOVE DFHBMASB           TO VR01-DATE-REVIEWED-LP-A
094300                                        (X-VR01-ITEM)
094400                                    VR01-DATE-REVIEWED-RP-A
094500                                        (X-VR01-ITEM)
094600         MOVE DFHBMNBF           TO VR01-DATE-REVIEWED-A
094700                                        (X-VR01-ITEM)
094800         IF  VR01-DATE-REVIEWED-L (X-VR01-ITEM) IS EQUAL TO ZERO
094900             MOVE SS08WS-CURSOR  TO VR01-DATE-REVIEWED-L
095000                                        (X-VR01-ITEM).
095100*
095200 W539-CE-EXIT.
095300     EXIT.
095400/
095500 X000-UPDATE-FIELDS SECTION.
095600*
095700 X080-UPDATE-VISIT-DATE.
095800*
095900     IF  VR01-DATE-VISITED-L (X-VR01-ITEM) IS EQUAL TO ZERO
096000         GO TO X099-UVD-EXIT.
096100*
096200     MOVE VR01-DATE-VISITED (X-VR01-ITEM)
096300                                 TO SS01WS-DATE.
096400     PERFORM SS07PD-GREG-TO-JUL  THRU SS07PD-GTJ-EXIT.
096500*
096600     IF  VR01-STORE-RECORD (X-VR01-ITEM)
096700         GO TO X084-UPDATE-STORE-VISIT.
096800*
096900     MOVE 'MM'                   TO MML1-FILE-CODE.
097000*
097100     IF  SS01WS-JULIAN IS EQUAL TO MMMM-DATE-LAST-VISIT
097200         GO TO X082-CALC-NEXT-MERCH-VISIT.
097300*
097400     MOVE 'Y'                    TO WS-UPDATE-SW.
097500     MOVE MMMMTB-DATE-LAST-VISIT (1:4)
097600                                 TO WS-MERCH-INDEX-X.
097700     SET  X-MMFS-MERCH           TO WS-MERCH-INDEX.
097800*
097900     MOVE MMFS-MT-AUDIT-CODE (X-MMFS-MERCH)
098000                                 TO MML1-MMMM-AUDIT-CODE.
098100     MOVE 0819                   TO MML1-FIELD-CODE.
098200     MOVE ZEROES                 TO MML1-FIELD-OCCURRENCE
098300                                    MML1-FIELD-OCCURRENCE-2.
098400     MOVE MML1WS-VL-07           TO MML1-VARIABLE-LENGTH.
098500     MOVE MMMM-DATE-LAST-VISIT   TO MML1-VL07-B-DATA-9.
098600     MOVE SS01WS-JULIAN          TO MMMM-DATE-LAST-VISIT.
098700     MOVE MMMM-DATE-LAST-VISIT   TO MML1-VL07-A-DATA-9.
098800     MOVE 'FC17'                 TO MBCA-PROGRAM-LOCATION.
098900     PERFORM Y020-WRITE-LOG-RECORD
099000                                 THRU Y039-WLR-EXIT.
099100*
099200 X082-CALC-NEXT-MERCH-VISIT.
099300*
099400     IF  MMMM-VISIT-FREQ IS EQUAL TO ZEROES
099500         MOVE ZEROES             TO SS01WS-JULIAN
099600     ELSE
099700         MOVE MMMM-VISIT-FREQ    TO SS01WS-FREQ
099800         MOVE 'M'                TO SS01WS-PERIOD
099900         MOVE ZERO               TO SS01WS-DAY-OF-MON
100000         PERFORM SS03PD-FUTURE-DATE
100100                                 THRU SS03PD-FD-EXIT
100200         IF  SS01WS-JULIAN IS LESS THAN MMOC-DATE-NEXT-PROC
100300             MOVE MMOC-DATE-NEXT-PROC
100400                                 TO SS01WS-JULIAN.
100500*
100600     IF  SS01WS-JULIAN IS EQUAL TO MMMM-DATE-NEXT-VISIT
100700         GO TO X099-UVD-EXIT.
100800*
100900     MOVE 'Y'                    TO WS-UPDATE-SW.
101000     MOVE MMMMTB-DATE-NEXT-VISIT (1:4)
101100                                 TO WS-MERCH-INDEX-X.
101200     SET  X-MMFS-MERCH           TO WS-MERCH-INDEX.
101300*
101400     MOVE MMFS-MT-AUDIT-CODE (X-MMFS-MERCH)
101500                                 TO MML1-MMMM-AUDIT-CODE.
101600     MOVE 0821                   TO MML1-FIELD-CODE.
101700     MOVE ZEROES                 TO MML1-FIELD-OCCURRENCE
101800                                    MML1-FIELD-OCCURRENCE-2.
101900     MOVE MML1WS-VL-07           TO MML1-VARIABLE-LENGTH.
102000     MOVE MMMM-DATE-NEXT-VISIT   TO MML1-VL07-B-DATA-9.
102100     MOVE SS01WS-JULIAN          TO MMMM-DATE-NEXT-VISIT.
102200     MOVE MMMM-DATE-NEXT-VISIT   TO MML1-VL07-A-DATA-9.
102300     MOVE 'FC18'                 TO MBCA-PROGRAM-LOCATION.
102400     PERFORM Y020-WRITE-LOG-RECORD
102500                                 THRU Y039-WLR-EXIT.
102600     GO TO X099-UVD-EXIT.
102700*
102800 X084-UPDATE-STORE-VISIT.
102900*
103000     IF  SS01WS-JULIAN IS EQUAL TO MMSM-DATE-LAST-VISIT
103100         GO TO X086-CALC-NEXT-STORE-VISIT.
103200*
103300     MOVE 'Y'                    TO WS-UPDATE-SW.
103400     MOVE MMSMTB-DATE-LAST-VISIT (1:4)
103500                                 TO WS-STORE-INDEX-X.
103600     SET  X-MMFS-STORE           TO WS-STORE-INDEX.
103700*
103800     MOVE MMFS-ST-AUDIT-CODE (X-MMFS-STORE)
103900                                 TO MML1-MMSM-AUDIT-CODE.
104000     MOVE 0415                   TO MML1-FIELD-CODE.
104100     MOVE ZEROES                 TO MML1-FIELD-OCCURRENCE
104200                                    MML1-FIELD-OCCURRENCE-2.
104300     MOVE MML1WS-VL-07           TO MML1-VARIABLE-LENGTH.
104400     MOVE MMSM-DATE-LAST-VISIT   TO MML1-VL07-B-DATA-9.
104500     MOVE SS01WS-JULIAN          TO MMSM-DATE-LAST-VISIT.
104600     MOVE MMSM-DATE-LAST-VISIT   TO MML1-VL07-A-DATA-9.
104700     MOVE 'FC19'                 TO MBCA-PROGRAM-LOCATION.
104800     PERFORM Y020-WRITE-LOG-RECORD
104900                                 THRU Y039-WLR-EXIT.
105000*
105100 X086-CALC-NEXT-STORE-VISIT.
105200*
105300     IF  MMSM-VISIT-FREQ IS EQUAL TO ZEROES
105400         MOVE ZEROES             TO SS01WS-JULIAN
105500     ELSE
105600         MOVE MMSM-VISIT-FREQ    TO SS01WS-FREQ
105700         MOVE 'M'                TO SS01WS-PERIOD
105800         MOVE ZERO               TO SS01WS-DAY-OF-MON
105900         PERFORM SS03PD-FUTURE-DATE
106000                                 THRU SS03PD-FD-EXIT
106100         IF  SS01WS-JULIAN IS LESS THAN MMOC-DATE-NEXT-PROC
106200             MOVE MMOC-DATE-NEXT-PROC
106300                                 TO SS01WS-JULIAN.
106400*
106500     IF  SS01WS-JULIAN IS EQUAL TO MMSM-DATE-NEXT-VISIT
106600         GO TO X099-UVD-EXIT.
106700*
106800     MOVE 'Y'                    TO WS-UPDATE-SW.
106900     MOVE MMSMTB-DATE-NEXT-VISIT (1:4)
107000                                 TO WS-STORE-INDEX-X.
107100     SET  X-MMFS-STORE           TO WS-STORE-INDEX.
107200*
107300     MOVE MMFS-ST-AUDIT-CODE (X-MMFS-STORE)
107400                                 TO MML1-MMSM-AUDIT-CODE.
107500     MOVE 0417                   TO MML1-FIELD-CODE.
107600     MOVE ZEROES                 TO MML1-FIELD-OCCURRENCE
107700                                    MML1-FIELD-OCCURRENCE-2.
107800     MOVE MML1WS-VL-07           TO MML1-VARIABLE-LENGTH.
107900     MOVE MMSM-DATE-NEXT-VISIT   TO MML1-VL07-B-DATA-9.
108000     MOVE SS01WS-JULIAN          TO MMSM-DATE-NEXT-VISIT.
108100     MOVE MMSM-DATE-NEXT-VISIT   TO MML1-VL07-A-DATA-9.
108200     MOVE 'FC20'                 TO MBCA-PROGRAM-LOCATION.
108300     PERFORM Y020-WRITE-LOG-RECORD
108400                                 THRU Y039-WLR-EXIT.
108500*
108600 X099-UVD-EXIT.
108700     EXIT.
108800*
108900 X100-UPDATE-REVIEW-DATE.
109000*
109100     IF  VR01-DATE-REVIEWED-L (X-VR01-ITEM) IS EQUAL TO ZERO
109200         GO TO X119-URD-EXIT.
109300*
109400     MOVE VR01-DATE-REVIEWED (X-VR01-ITEM)
109500                                 TO SS01WS-DATE.
109600     PERFORM SS07PD-GREG-TO-JUL  THRU SS07PD-GTJ-EXIT.
109700*
109800     IF  VR01-STORE-RECORD (X-VR01-ITEM)
109900         GO TO X104-UPDATE-STORE-REVIEW.
110000*
110100     MOVE 'MM'                   TO MML1-FILE-CODE.
110200*
110300     IF  SS01WS-JULIAN IS EQUAL TO MMMM-DATE-LAST-REVIEW
110400         GO TO X102-CALC-NEXT-MERCH-REVIEW.
110500*
110600     MOVE 'Y'                    TO WS-UPDATE-SW.
110700     MOVE MMMMTB-DATE-LAST-REVIEW (1:4)
110800                                 TO WS-MERCH-INDEX-X.
110900     SET  X-MMFS-MERCH           TO WS-MERCH-INDEX.
111000*
111100     MOVE MMFS-MT-AUDIT-CODE (X-MMFS-MERCH)
111200                                 TO MML1-MMMM-AUDIT-CODE.
111300     MOVE 0820                   TO MML1-FIELD-CODE.
111400     MOVE ZEROES                 TO MML1-FIELD-OCCURRENCE
111500                                    MML1-FIELD-OCCURRENCE-2.
111600     MOVE MML1WS-VL-07           TO MML1-VARIABLE-LENGTH.
111700     MOVE MMMM-DATE-LAST-REVIEW  TO MML1-VL07-B-DATA-9.
111800     MOVE SS01WS-JULIAN          TO MMMM-DATE-LAST-REVIEW.
111900     MOVE MMMM-DATE-LAST-REVIEW  TO MML1-VL07-A-DATA-9.
112000     MOVE 'FC21'                 TO MBCA-PROGRAM-LOCATION.
112100     PERFORM Y020-WRITE-LOG-RECORD
112200                                 THRU Y039-WLR-EXIT.
112300*
112400 X102-CALC-NEXT-MERCH-REVIEW.
112500*
112600     IF  MMMM-REVIEW-FREQ IS EQUAL TO ZEROES
112700         MOVE ZEROES             TO SS01WS-JULIAN
112800     ELSE
112900         MOVE MMMM-REVIEW-FREQ   TO SS01WS-FREQ
113000         MOVE 'M'                TO SS01WS-PERIOD
113100         MOVE ZERO               TO SS01WS-DAY-OF-MON
113200         PERFORM SS03PD-FUTURE-DATE
113300                                 THRU SS03PD-FD-EXIT
113400         IF  SS01WS-JULIAN IS LESS THAN MMOC-DATE-NEXT-PROC
113500             MOVE MMOC-DATE-NEXT-PROC
113600                                 TO SS01WS-JULIAN.
113700*
113800     IF  SS01WS-JULIAN IS EQUAL TO MMMM-DATE-NEXT-REVIEW
113900         GO TO X119-URD-EXIT.
114000*
114100     MOVE 'Y'                    TO WS-UPDATE-SW.
114200     MOVE MMMMTB-DATE-NEXT-REVIEW (1:4)
114300                                 TO WS-MERCH-INDEX-X.
114400     SET  X-MMFS-MERCH           TO WS-MERCH-INDEX.
114500*
114600     MOVE MMFS-MT-AUDIT-CODE (X-MMFS-MERCH)
114700                                 TO MML1-MMMM-AUDIT-CODE.
114800     MOVE 0822                   TO MML1-FIELD-CODE.
114900     MOVE ZEROES                 TO MML1-FIELD-OCCURRENCE
115000                                    MML1-FIELD-OCCURRENCE-2.
115100     MOVE MML1WS-VL-07           TO MML1-VARIABLE-LENGTH.
115200     MOVE MMMM-DATE-NEXT-REVIEW  TO MML1-VL07-B-DATA-9.
115300     MOVE SS01WS-JULIAN          TO MMMM-DATE-NEXT-REVIEW.
115400     MOVE MMMM-DATE-NEXT-REVIEW  TO MML1-VL07-A-DATA-9.
115500     MOVE 'FC22'                 TO MBCA-PROGRAM-LOCATION.
115600     PERFORM Y020-WRITE-LOG-RECORD
115700                                 THRU Y039-WLR-EXIT.
115800     GO TO X119-URD-EXIT.
115900*
116000 X104-UPDATE-STORE-REVIEW.
116100*
116200     IF  SS01WS-JULIAN IS EQUAL TO MMSM-DATE-LAST-REVIEW
116300         GO TO X106-CALC-NEXT-STORE-REVIEW.
116400*
116500     MOVE 'Y'                    TO WS-UPDATE-SW.
116600     MOVE MMSMTB-DATE-LAST-REVIEW (1:4)
116700                                 TO WS-STORE-INDEX-X.
116800     SET  X-MMFS-STORE           TO WS-STORE-INDEX.
116900*
117000     MOVE MMFS-ST-AUDIT-CODE (X-MMFS-STORE)
117100                                 TO MML1-MMSM-AUDIT-CODE.
117200     MOVE 0416                   TO MML1-FIELD-CODE.
117300     MOVE ZEROES                 TO MML1-FIELD-OCCURRENCE
117400                                    MML1-FIELD-OCCURRENCE-2.
117500     MOVE MML1WS-VL-07           TO MML1-VARIABLE-LENGTH.
117600     MOVE MMSM-DATE-LAST-REVIEW  TO MML1-VL07-B-DATA-9.
117700     MOVE SS01WS-JULIAN          TO MMSM-DATE-LAST-REVIEW.
117800     MOVE MMSM-DATE-LAST-REVIEW  TO MML1-VL07-A-DATA-9.
117900     MOVE 'FC23'                 TO MBCA-PROGRAM-LOCATION.
118000     PERFORM Y020-WRITE-LOG-RECORD
118100                                 THRU Y039-WLR-EXIT.
118200*
118300 X106-CALC-NEXT-STORE-REVIEW.
118400*
118500     IF  MMSM-REVIEW-FREQ IS EQUAL TO ZEROES
118600         MOVE ZEROES             TO SS01WS-JULIAN
118700     ELSE
118800         MOVE MMSM-REVIEW-FREQ   TO SS01WS-FREQ
118900         MOVE 'M'                TO SS01WS-PERIOD
119000         MOVE ZERO               TO SS01WS-DAY-OF-MON
119100         PERFORM SS03PD-FUTURE-DATE
119200                                 THRU SS03PD-FD-EXIT
119300         IF  SS01WS-JULIAN IS LESS THAN MMOC-DATE-NEXT-PROC
119400             MOVE MMOC-DATE-NEXT-PROC
119500                                 TO SS01WS-JULIAN.
119600*
119700     IF  SS01WS-JULIAN IS EQUAL TO MMSM-DATE-NEXT-REVIEW
119800         GO TO X119-URD-EXIT.
119900*
120000     MOVE 'Y'                    TO WS-UPDATE-SW.
120100     MOVE MMSMTB-DATE-NEXT-REVIEW (1:4)
120200                                 TO WS-STORE-INDEX-X.
120300     SET  X-MMFS-STORE           TO WS-STORE-INDEX.
120400*
120500     MOVE MMFS-ST-AUDIT-CODE (X-MMFS-STORE)
120600                                 TO MML1-MMSM-AUDIT-CODE.
120700     MOVE 0418                   TO MML1-FIELD-CODE.
120800     MOVE ZEROES                 TO MML1-FIELD-OCCURRENCE
120900                                    MML1-FIELD-OCCURRENCE-2.
121000     MOVE MML1WS-VL-07           TO MML1-VARIABLE-LENGTH.
121100     MOVE MMSM-DATE-NEXT-REVIEW  TO MML1-VL07-B-DATA-9.
121200     MOVE SS01WS-JULIAN          TO MMSM-DATE-NEXT-REVIEW.
121300     MOVE MMSM-DATE-NEXT-REVIEW  TO MML1-VL07-A-DATA-9.
121400     MOVE 'FC24'                 TO MBCA-PROGRAM-LOCATION.
121500     PERFORM Y020-WRITE-LOG-RECORD
121600                                 THRU Y039-WLR-EXIT.
121700*
121800 X119-URD-EXIT.
121900     EXIT.
122000/
122100 Y000-PERFORMED-ROUTINES SECTION.
122200*
122300 Y020-WRITE-LOG-RECORD.
122400*
122500     SET MBIORO-WRITE            TO TRUE.
122600     PERFORM MML1AO-ACCESS       THRU MML1AO-ACCESS-EXIT.
122700     MOVE SPACES                 TO MML1-VARIABLE-AREA.
122800*
122900 Y039-WLR-EXIT.
123000     EXIT.
123100*
123200 Y900-READ-MMOC.
123300*
123400     MOVE MBCA-MERCHANT-ORG      TO MBIOWS-MMOC-ORG
123500                                    VR01-ORG.
123600     SET MBIORO-READ-RANDOM      TO TRUE.
123700     PERFORM MMOCAO-ACCESS       THRU MMOCAO-ACCESS-EXIT.
123800*
123900 Y919-READ-MMOC-EXIT.
124000     EXIT.
124100*
124200 Y920-READ-MMFS.
124300*
124400     MOVE MBCA-MERCHANT-ORG      TO MBIOWS-MMFS-ORG.
124500     MOVE MBCA-FIELD-SECURITY    TO MBIOWS-MMFS-FS-CODE.
124600     SET MBIORO-READ-RANDOM      TO TRUE.
124700     PERFORM MMFSAO-ACCESS       THRU MMFSAO-ACCESS-EXIT.
124800*
124900     IF  NOT MMFS-REC-ACTIVE
125000         MOVE MBIORO-IO-REQUEST  TO MBCA-ERRR-IO-REQUEST
125100         MOVE ZERO               TO MBCA-ERROR-ROUTINE-SW
125200         MOVE SPACES             TO MBCA-TRANS-WORK-AREA
125300         MOVE 'READ ERROR - MMFSAO'
125400                                 TO MBCA-ERRR-MSG1
125500         MOVE 'FIELD SECURITY PROFILE IS NOT ACTIVE'
125600                                 TO MBCA-ERRR-MSG2
125700         GO TO MB70PD-ERROR-ROUTINE.
125800*
125900 Y939-READ-MMFS-EXIT.
126000     EXIT.
126100/
126200 Z000-COPIED-ROUTINES SECTION.
126300*
126400*****************************
126500*    FUTURE DATE ROUTINE    *
126600*****************************
126700*
126800     COPY SS03PD.
126900/
127000*********************************
127100*    DATE VALIDATION ROUTINE    *
127200*********************************
127300*
127400     COPY SS05PD.
127500/
127600**********************************
127700*    GREG TO JUL DATE ROUTINE    *
127800**********************************
127900*
128000     COPY SS07PD.
128100/
128200**********************************
128300*    JUL TO GREG DATE ROUTINE    *
128400**********************************
128500*
128600     COPY SS08PD.
128700/
128800     COPY SS26PD.
128900/
129000     COPY SS27PD.
129100/
129200*********************************
129300*    LINE 24 PF KEYS ROUTINE    *
129400*********************************
129500*
129600     COPY SS15PD.
129700/
129800*******************************************
129900*    ORG FILE ACCESS ROUTINES             *
130000*******************************************
130100*
130200     COPY MMOCAO.
130300/
130400***********************************************
130500*    FIELD SECURITY RECORD ACCESS ROUTINES    *
130600***********************************************
130700*
130800     COPY MMFSAO.
130900/
131000************************************************
131100*    MERCHANT MASTER RECORD ACCESS ROUTINES    *
131200************************************************
131300*
131400     COPY MMMMAO.
131500/
131600*********************************************
131700*    STORE MASTER RECORD ACCESS ROUTINES    *
131800*********************************************
131900*
132000     COPY MMSMAO.
132100/
132200*****************************************
132300*    LOG FILE RECORD ACCESS ROUTINES    *
132400*****************************************
132500*
132600     COPY MML1AO.
132700/
132800*****************************
132900*    ONLINE MAP ROUTINES    *
133000*****************************
133100*
133200     COPY MB60PD REPLACING 'MBMAPXX' BY 'MBVR01 '
133300                           MBMAPXXI BY MBVR01I
133400                           MBMAPXXO BY MBVR01O.
133500/
133600***************************
133700*    ONLINE PROCEDURES    *
133800***************************
133900*
134000     COPY MB70PD.
134100/
134200     COPY SMFTPXO.
