000100 IDENTIFICATION DIVISION.
000200 PROGRAM-ID. MBU100RC.
000201*       RELEASE DATE=08/24/01.        REVISION LEVEL=08.06      *
000202*****************************************************************
000203*WARNING.  THIS COMPUTER PROGRAM IS PROTECTED BY COPYRIGHT LAW  *
000204*AND INTERNATIONAL TREATIES.  UNAUTHORIZED REPRODUCTION OR      *
000205*DISTRIBUTION OF THIS PROGRAM, OR ANY PORTION OF IT, MAY RESULT *
000206*IN SEVERE CIVIL AND CRIMINAL PENATLIES, AND WILL BE PROSECUTED *
000207*TO THE MAXIMUM EXTENT POSSIBLE UNDER THE LAW.                  *
000208*COPYRIGHT 1999 PAYSYS INTERNATIONAL, INC.  ALL RIGHTS RESERVED.*
000209*****************************************************************
000300*****************************************************************
000400*                                                               *
000500*   V - PLUS  M E R C H A N T   B A N K C A R D   S Y S T E M   *
000600*                                                               *
000700*   MBU100RC - NON-MONETARY USER-INPUT                          *
000800*              MERCHANT CHAIN RELATIONSHIPS SCREENS REPORT      *
000900*                                                               *
001000*****************************************************************
001100 ENVIRONMENT DIVISION.
001200 CONFIGURATION SECTION.
001300 SOURCE-COMPUTER.            IBM-4341.
001400 OBJECT-COMPUTER.            IBM-4341.
001500/
001600 INPUT-OUTPUT SECTION.
001700*
001800 FILE-CONTROL.
001900/
002000 DATA DIVISION.
002100 FILE SECTION.
002200/
002300 WORKING-STORAGE SECTION.
002400*
002500 01  FILLER                  PIC  X(12)      VALUE '** WS-BEG **'.
002600*
002700 01  WS-U100-WORK-AREAS.
002800     03  WS-L                PIC S9(04)      BINARY VALUE ZERO.
002900     03  WS-U100-PAGE-ERROR-SW
003000                             PIC  X(01)      VALUE 'N'.
003100         88  WS-U100-PAGE-ERRORS             VALUE 'Y'.
003200         88  WS-U100-NO-PAGE-ERRORS          VALUE 'N'.
003300     03  WS-U100-FIRST-TIME-SW
003400                             PIC  X(01)      VALUE 'Y'.
003500         88  WS-U100-FIRST-TIME              VALUE 'Y'.
003600         88  WS-U100-SUBSEQUENT              VALUE 'N'.
003700     03  WS-U100-SEQ-LIT.
003800         05  FILLER          PIC  X(02)      VALUE 'S='.
003900         05  WS-U100-SL-SEQ  PIC  9(07)      VALUE ZERO.
004000/
004100     COPY MBMC00.
004200     COPY MBMC00R.
004300/
004400     COPY MBMC01.
004500     COPY MBMC01R.
004600/
004700     COPY MBMC02.
004800     COPY MBMC02R.
004900/
005000     COPY MB00WS.
005100/
005200     COPY MB20WS.
005300/
005400     COPY SS00WS.
005500/
005600     COPY SS01WS.
005700/
005800     COPY SS02WS.
005900*
006000 01  FILLER                  PIC  X(12)      VALUE '** WS-END **'.
006100/
006200 LINKAGE SECTION.
006300     COPY MBU100WS.
006400/
006500     COPY MTCCRL REPLACING ==:MTCC:== BY ==MTCC==.
006600/
006700     COPY MMUIRL REPLACING ==:MMUI:== BY ==MMUO==.
006800/
006900     COPY MB22WS.
007000/
007100 PROCEDURE DIVISION              USING MBU100WS-AREA
007200                                       MTCC-RECORD
007300                                       MMUO-RECORD
007400                                       MB22WS-LINK-DATA.
007500*
007600 A000-MAIN-LINE-SECT SECTION.
007700 A010-ML-BEGIN.
007800*
007900     IF  WS-U100-FIRST-TIME
008000         SET WS-U100-SUBSEQUENT  TO TRUE
008100         MOVE SPACES             TO MB20WS-SH-L1
008200         MOVE SPACES             TO MB20WS-SH-L2
008300         MOVE SPACES             TO MB20WS-SH-L3
008400         MOVE SPACES             TO MB20WS-SH-L4
008500         MOVE SPACES             TO MB20WS-SH-L5
008600         MOVE SPACES             TO MB20WS-SH-L6
008700         MOVE SPACES             TO MB20WS-SH-L7
008800         MOVE SPACES             TO MB20WS-SH-L8.
008900*
009000     PERFORM P000-PROCESS-RECORD
009100        THRU P099-PR-EXIT.
009200*
009300     GOBACK.
009400*
009500 A999-ML-EXIT.
009600     EXIT.
009700/
009800 P000-PROCESS-RECORD SECTION.
009900 P010-PR-BEGIN.
010000*
010100     MOVE SPACES                 TO MBU100WS-PRINT-LINE-1.
010200     MOVE ZERO                   TO WS-U100-SL-SEQ.
010300*
010400     EVALUATE TRUE
010500       WHEN MMUO-CURRENT-PAGE IS EQUAL TO ZERO
010600         MOVE MMUO-VAR-DATA      TO MBMC00I
010700         PERFORM 0000-PAGE-00    THRU 0099-P00-EXIT
010800       WHEN MMUO-CURRENT-PAGE IS EQUAL TO 01
010900         MOVE MMUO-VAR-DATA      TO MBMC01I
011000         PERFORM 0100-PAGE-01    THRU 0199-P01-EXIT
011100       WHEN MMUO-CURRENT-PAGE IS EQUAL TO 02
011200         MOVE MMUO-VAR-DATA      TO MBMC02I
011300         PERFORM 0200-PAGE-02    THRU 0299-P02-EXIT
011400       WHEN MMUO-CURRENT-PAGE IS EQUAL TO 03
011500         MOVE MMUO-VAR-DATA      TO MBMC02I
011600         PERFORM 0300-PAGE-03    THRU 0399-P03-EXIT
011700     END-EVALUATE.
011800*
011900 P099-PR-EXIT.
012000     EXIT.
012100/
012200 0000-PAGE-00 SECTION.
012300 0001-P00-BEGIN.
012400*
012500     SET WS-U100-NO-PAGE-ERRORS  TO TRUE.
012600*
012700     IF  MC00-ORG-L              IS LESS THAN ZERO
012800     OR  MC00-CHAIN-L            IS LESS THAN ZERO
012900     OR  MC00-COPY-ORG-L         IS LESS THAN ZERO
013000     OR  MC00-COPY-CHAIN-L       IS LESS THAN ZERO
013100         SET WS-U100-PAGE-ERRORS TO TRUE.
013200*
013300     IF  MC00-ORG-L IS LESS THAN ZERO
013400     OR
013500        (MC00-ORG-L IS GREATER THAN ZERO
013600     AND MTCC-MBU100-PRINT-ALL)
013700         MOVE 'ORGANIZATION          '
013800                                 TO MBU100WS-PL1-DESC
013900         MOVE MC00-ORG           TO MBU100WS-PL1-FROM-VALUE
014000         MOVE MC00-ORG-L         TO WS-L
014100         PERFORM Z900-ERROR-MESSAGE
014200            THRU Z999-EM-EXIT.
014300*
014400     IF  MC00-CHAIN-L IS LESS THAN ZERO
014500     OR
014600        (MC00-CHAIN-L IS GREATER THAN ZERO
014700     AND MTCC-MBU100-PRINT-ALL)
014800         MOVE 'CHAIN                 '
014900                                 TO MBU100WS-PL1-DESC
015000         MOVE MC00-CHAIN         TO MBU100WS-PL1-FROM-VALUE
015100         MOVE MC00-CHAIN-L       TO WS-L
015200         PERFORM Z900-ERROR-MESSAGE
015300            THRU Z999-EM-EXIT.
015400*
015500     IF  MC00-COPY-ORG-L IS LESS THAN ZERO
015600     OR
015700        (MC00-COPY-ORG-L IS GREATER THAN ZERO
015800     AND MTCC-MBU100-PRINT-ALL)
015900         MOVE 'COPY ORGANIZATION     '
016000                                 TO MBU100WS-PL1-DESC
016100         MOVE MC00-COPY-ORG      TO MBU100WS-PL1-FROM-VALUE
016200         MOVE MC00-COPY-ORG-L    TO WS-L
016300         PERFORM Z900-ERROR-MESSAGE
016400            THRU Z999-EM-EXIT.
016500*
016600     IF  MC00-COPY-CHAIN-L IS LESS THAN ZERO
016700     OR
016800        (MC00-COPY-CHAIN-L IS GREATER THAN ZERO
016900     AND MTCC-MBU100-PRINT-ALL)
017000         MOVE 'COPY CHAIN            '
017100                                 TO MBU100WS-PL1-DESC
017200         MOVE MC00-COPY-CHAIN    TO MBU100WS-PL1-FROM-VALUE
017300         MOVE MC00-COPY-CHAIN-L
017400                                 TO WS-L
017500         PERFORM Z900-ERROR-MESSAGE
017600            THRU Z999-EM-EXIT.
017700*
017800 0099-P00-EXIT.
017900     EXIT.
018000/
018100 0100-PAGE-01 SECTION.
018200 0101-P01-BEGIN.
018300*
018400     SET WS-U100-NO-PAGE-ERRORS  TO TRUE.
018500*
018600     IF  MC01-STMT-FREQ1-L       IS LESS THAN ZERO
018700     OR  MC01-STMT-FREQ2-L       IS LESS THAN ZERO
018800     OR  MC01-STMT-MSG-FLAG-L(1) IS LESS THAN ZERO
018900     OR  MC01-STMT-MSG-FLAG-L(2) IS LESS THAN ZERO
019000     OR  MC01-STMT-MSG-FLAG-L(3) IS LESS THAN ZERO
019100     OR  MC01-STMT-MSG-FLAG-L(4) IS LESS THAN ZERO
019200     OR  MC01-STMT-MSG-FLAG-L(5) IS LESS THAN ZERO
019300     OR  MC01-STMT-FLAG-L        IS LESS THAN ZERO
019400     OR  MC01-STMT-OPTION-L      IS LESS THAN ZERO
019500     OR  MC01-NA-LINE-L (1)      IS LESS THAN ZERO
019600     OR  MC01-NA-LINE-L (2)      IS LESS THAN ZERO
019700     OR  MC01-NA-LINE-L (3)      IS LESS THAN ZERO
019800     OR  MC01-NA-LINE-L (4)      IS LESS THAN ZERO
019900     OR  MC01-NA-LINE-L (5)      IS LESS THAN ZERO
020000     OR  MC01-STATE-L            IS LESS THAN ZERO
020100     OR  MC01-PHONE-L            IS LESS THAN ZERO
020200     OR  MC01-POSTAL-CODE-L      IS LESS THAN ZERO
020300     OR  MC01-FAX-L              IS LESS THAN ZERO
020400         SET WS-U100-PAGE-ERRORS TO TRUE.
020500*
020600     IF  MC01-STMT-FREQ1-L       IS LESS THAN ZERO
020700     OR
020800        (MC01-STMT-FREQ1-L       IS GREATER THAN ZERO
020900     AND MTCC-MBU100-PRINT-ALL)
021000         MOVE 'STATEMENT FREQUENCY 1 '
021100                                 TO MBU100WS-PL1-DESC
021200         MOVE MC01-STMT-FREQ1    TO MBU100WS-PL1-FROM-VALUE
021300         MOVE MC01-STMT-FREQ1-L  TO WS-L
021400         PERFORM Z900-ERROR-MESSAGE
021500            THRU Z999-EM-EXIT.
021600*
021700     IF  MC01-STMT-FREQ2-L       IS LESS THAN ZERO
021800     OR
021900        (MC01-STMT-FREQ2-L       IS GREATER THAN ZERO
022000     AND MTCC-MBU100-PRINT-ALL)
022100         MOVE 'STATEMENT FREQUENCY 2 '
022200                                 TO MBU100WS-PL1-DESC
022300         MOVE MC01-STMT-FREQ2    TO MBU100WS-PL1-FROM-VALUE
022400         MOVE MC01-STMT-FREQ2-L  TO WS-L
022500         PERFORM Z900-ERROR-MESSAGE
022600            THRU Z999-EM-EXIT.
022700*
022800     IF  MC01-STMT-MSG-FLAG-L (1)
022900                                 IS LESS THAN ZERO
023000     OR
023100        (MC01-STMT-MSG-FLAG-L (1)
023200                                 IS GREATER THAN ZERO
023300     AND MTCC-MBU100-PRINT-ALL)
023400         MOVE 'STATEMENT MSG FLAG 1  '
023500                                 TO MBU100WS-PL1-DESC
023600         MOVE MC01-STMT-MSG-FLAG (1)
023700                                 TO MBU100WS-PL1-FROM-VALUE
023800         MOVE MC01-STMT-MSG-FLAG-L (1)
023900                                 TO WS-L
024000         PERFORM Z900-ERROR-MESSAGE
024100            THRU Z999-EM-EXIT.
024200*
024300     IF  MC01-STMT-MSG-FLAG-L (2)
024400                                 IS LESS THAN ZERO
024500     OR
024600        (MC01-STMT-MSG-FLAG-L (2)
024700                                 IS GREATER THAN ZERO
024800     AND MTCC-MBU100-PRINT-ALL)
024900         MOVE 'STATEMENT MSG FLAG 2  '
025000                                 TO MBU100WS-PL1-DESC
025100         MOVE MC01-STMT-MSG-FLAG (2)
025200                                 TO MBU100WS-PL1-FROM-VALUE
025300         MOVE MC01-STMT-MSG-FLAG-L (2)
025400                                 TO WS-L
025500         PERFORM Z900-ERROR-MESSAGE
025600            THRU Z999-EM-EXIT.
025700*
025800     IF  MC01-STMT-MSG-FLAG-L (3)
025900                                 IS LESS THAN ZERO
026000     OR
026100        (MC01-STMT-MSG-FLAG-L (3)
026200                                 IS GREATER THAN ZERO
026300     AND MTCC-MBU100-PRINT-ALL)
026400         MOVE 'STATEMENT MSG FLAG 3  '
026500                                 TO MBU100WS-PL1-DESC
026600         MOVE MC01-STMT-MSG-FLAG (3)
026700                                 TO MBU100WS-PL1-FROM-VALUE
026800         MOVE MC01-STMT-MSG-FLAG-L (3)
026900                                 TO WS-L
027000         PERFORM Z900-ERROR-MESSAGE
027100            THRU Z999-EM-EXIT.
027200*
027300     IF  MC01-STMT-MSG-FLAG-L (4)
027400                                 IS LESS THAN ZERO
027500     OR
027600        (MC01-STMT-MSG-FLAG-L (4)
027700                                 IS GREATER THAN ZERO
027800     AND MTCC-MBU100-PRINT-ALL)
027900         MOVE 'STATEMENT MSG FLAG 4  '
028000                                 TO MBU100WS-PL1-DESC
028100         MOVE MC01-STMT-MSG-FLAG (4)
028200                                 TO MBU100WS-PL1-FROM-VALUE
028300         MOVE MC01-STMT-MSG-FLAG-L (4)
028400                                 TO WS-L
028500         PERFORM Z900-ERROR-MESSAGE
028600            THRU Z999-EM-EXIT.
028700*
028800     IF  MC01-STMT-MSG-FLAG-L (5)
028900                                 IS LESS THAN ZERO
029000     OR
029100        (MC01-STMT-MSG-FLAG-L (5)
029200                                 IS GREATER THAN ZERO
029300     AND MTCC-MBU100-PRINT-ALL)
029400         MOVE 'STATEMENT MSG FLAG 5  '
029500                                 TO MBU100WS-PL1-DESC
029600         MOVE MC01-STMT-MSG-FLAG (5)
029700                                 TO MBU100WS-PL1-FROM-VALUE
029800         MOVE MC01-STMT-MSG-FLAG-L (5)
029900                                 TO WS-L
030000         PERFORM Z900-ERROR-MESSAGE
030100            THRU Z999-EM-EXIT.
030200*
030300     IF  MC01-STMT-FLAG-L        IS LESS THAN ZERO
030400     OR
030500        (MC01-STMT-FLAG-L        IS GREATER THAN ZERO
030600     AND MTCC-MBU100-PRINT-ALL)
030700         MOVE 'STATEMENT FLAG        '
030800                                 TO MBU100WS-PL1-DESC
030900         MOVE MC01-STMT-FLAG     TO MBU100WS-PL1-FROM-VALUE
031000         MOVE MC01-STMT-FLAG-L   TO WS-L
031100         PERFORM Z900-ERROR-MESSAGE
031200            THRU Z999-EM-EXIT.
031300*
031400     IF  MC01-STMT-OPTION-L      IS LESS THAN ZERO
031500     OR
031600        (MC01-STMT-OPTION-L      IS GREATER THAN ZERO
031700     AND MTCC-MBU100-PRINT-ALL)
031800         MOVE 'STATEMENT OPTION      '
031900                                 TO MBU100WS-PL1-DESC
032000         MOVE MC01-STMT-OPTION   TO MBU100WS-PL1-FROM-VALUE
032100         MOVE MC01-STMT-OPTION-L TO WS-L
032200         PERFORM Z900-ERROR-MESSAGE
032300            THRU Z999-EM-EXIT.
032400*
032500     IF  MC01-NA-LINE-L (1)      IS LESS THAN ZERO
032600     OR
032700        (MC01-NA-LINE-L (1)      IS GREATER THAN ZERO
032800     AND MTCC-MBU100-PRINT-ALL)
032900         MOVE 'NAME/ADDRESS LINE 1   '
033000                                 TO MBU100WS-PL1-DESC
033100         MOVE MC01-NA-LINE (1)   TO MBU100WS-PL1-FROM-VALUE
033200         MOVE MC01-NA-LINE-L (1) TO WS-L
033300         PERFORM Z900-ERROR-MESSAGE
033400            THRU Z999-EM-EXIT.
033500*
033600     IF  MC01-NA-LINE-L (2)      IS LESS THAN ZERO
033700     OR
033800        (MC01-NA-LINE-L (2)      IS GREATER THAN ZERO
033900     AND MTCC-MBU100-PRINT-ALL)
034000         MOVE 'NAME/ADDRESS LINE 2   '
034100                                 TO MBU100WS-PL1-DESC
034200         MOVE MC01-NA-LINE (2)   TO MBU100WS-PL1-FROM-VALUE
034300         MOVE MC01-NA-LINE-L (2) TO WS-L
034400         PERFORM Z900-ERROR-MESSAGE
034500            THRU Z999-EM-EXIT.
034600*
034700     IF  MC01-NA-LINE-L (3)      IS LESS THAN ZERO
034800     OR
034900        (MC01-NA-LINE-L (3)      IS GREATER THAN ZERO
035000     AND MTCC-MBU100-PRINT-ALL)
035100         MOVE 'NAME/ADDRESS LINE 3   '
035200                                 TO MBU100WS-PL1-DESC
035300         MOVE MC01-NA-LINE (3)   TO MBU100WS-PL1-FROM-VALUE
035400         MOVE MC01-NA-LINE-L (3) TO WS-L
035500         PERFORM Z900-ERROR-MESSAGE
035600            THRU Z999-EM-EXIT.
035700*
035800     IF  MC01-NA-LINE-L (4)      IS LESS THAN ZERO
035900     OR
036000        (MC01-NA-LINE-L (4)      IS GREATER THAN ZERO
036100     AND MTCC-MBU100-PRINT-ALL)
036200         MOVE 'NAME/ADDRESS LINE 4   '
036300                                 TO MBU100WS-PL1-DESC
036400         MOVE MC01-NA-LINE (4)   TO MBU100WS-PL1-FROM-VALUE
036500         MOVE MC01-NA-LINE-L (4) TO WS-L
036600         PERFORM Z900-ERROR-MESSAGE
036700            THRU Z999-EM-EXIT.
036800*
036900     IF  MC01-NA-LINE-L (5)      IS LESS THAN ZERO
037000     OR
037100        (MC01-NA-LINE-L (5)      IS GREATER THAN ZERO
037200     AND MTCC-MBU100-PRINT-ALL)
037300         MOVE 'NAME/ADDRESS LINE 5   '
037400                                 TO MBU100WS-PL1-DESC
037500         MOVE MC01-NA-LINE (5)   TO MBU100WS-PL1-FROM-VALUE
037600         MOVE MC01-NA-LINE-L (5) TO WS-L
037700         PERFORM Z900-ERROR-MESSAGE
037800            THRU Z999-EM-EXIT.
037900*
038000     IF  MC01-STATE-L            IS LESS THAN ZERO
038100     OR
038200        (MC01-STATE-L            IS GREATER THAN ZERO
038300     AND MTCC-MBU100-PRINT-ALL)
038400         MOVE 'STATE/PROVINCE        '
038500                                 TO MBU100WS-PL1-DESC
038600         MOVE MC01-STATE         TO MBU100WS-PL1-FROM-VALUE
038700         MOVE MC01-STATE-L       TO WS-L
038800         PERFORM Z900-ERROR-MESSAGE
038900            THRU Z999-EM-EXIT.
039000*
039100     IF  MC01-PHONE-L            IS LESS THAN ZERO
039200     OR
039300        (MC01-PHONE-L            IS GREATER THAN ZERO
039400     AND MTCC-MBU100-PRINT-ALL)
039500         MOVE 'PHONE                 '
039600                                 TO MBU100WS-PL1-DESC
039700         MOVE MC01-PHONE         TO MBU100WS-PL1-FROM-VALUE
039800         MOVE MC01-PHONE-L       TO WS-L
039900         PERFORM Z900-ERROR-MESSAGE
040000            THRU Z999-EM-EXIT.
040100*
040200     IF  MC01-POSTAL-CODE-L      IS LESS THAN ZERO
040300     OR
040400        (MC01-POSTAL-CODE-L      IS GREATER THAN ZERO
040500     AND MTCC-MBU100-PRINT-ALL)
040600         MOVE 'POSTAL CODE           '
040700                                 TO MBU100WS-PL1-DESC
040800         MOVE MC01-POSTAL-CODE   TO MBU100WS-PL1-FROM-VALUE
040900         MOVE MC01-POSTAL-CODE-L TO WS-L
041000         PERFORM Z900-ERROR-MESSAGE
041100            THRU Z999-EM-EXIT.
041200*
041300     IF  MC01-FAX-L              IS LESS THAN ZERO
041400     OR
041500        (MC01-FAX-L              IS GREATER THAN ZERO
041600     AND MTCC-MBU100-PRINT-ALL)
041700         MOVE 'FAX                   '
041800                                 TO MBU100WS-PL1-DESC
041900         MOVE MC01-FAX           TO MBU100WS-PL1-FROM-VALUE
042000         MOVE MC01-FAX-L         TO WS-L
042100         PERFORM Z900-ERROR-MESSAGE
042200            THRU Z999-EM-EXIT.
042300*
042400 0199-P01-EXIT.
042500     EXIT.
042600/
042700 0200-PAGE-02 SECTION.
042800 0201-P02-BEGIN.
042900*
043000     SET WS-U100-NO-PAGE-ERRORS  TO TRUE.
043100*
043200     IF  MC02-STMT-LINE-L (1 1)  IS LESS THAN ZERO
043300     OR  MC02-STMT-LINE-L (1 2)  IS LESS THAN ZERO
043400     OR  MC02-STMT-LINE-L (1 3)  IS LESS THAN ZERO
043500     OR  MC02-STMT-LINE-L (2 1)  IS LESS THAN ZERO
043600     OR  MC02-STMT-LINE-L (2 2)  IS LESS THAN ZERO
043700     OR  MC02-STMT-LINE-L (2 3)  IS LESS THAN ZERO
043800     OR  MC02-STMT-LINE-L (3 1)  IS LESS THAN ZERO
043900     OR  MC02-STMT-LINE-L (3 2)  IS LESS THAN ZERO
044000     OR  MC02-STMT-LINE-L (3 3)  IS LESS THAN ZERO
044100     OR  MC02-STMT-LINE-L (4 1)  IS LESS THAN ZERO
044200     OR  MC02-STMT-LINE-L (4 2)  IS LESS THAN ZERO
044300     OR  MC02-STMT-LINE-L (4 3)  IS LESS THAN ZERO
044400         SET WS-U100-PAGE-ERRORS TO TRUE.
044500*
044600     IF  MC02-STMT-LINE-L (1 1)  IS LESS THAN ZERO
044700     OR
044800        (MC02-STMT-LINE-L (1 1)  IS GREATER THAN ZERO
044900     AND MTCC-MBU100-PRINT-ALL)
045000         MOVE 'STMT MESSAGE 1 LINE 1 '
045100                                 TO MBU100WS-PL1-DESC
045200         MOVE MC02-STMT-LINE (1 1)
045300                                 TO MBU100WS-PL1-FROM-VALUE
045400         MOVE MC02-STMT-LINE-L (1 1)
045500                                 TO WS-L
045600         PERFORM Z900-ERROR-MESSAGE
045700            THRU Z999-EM-EXIT.
045800*
045900     IF  MC02-STMT-LINE-L (1 2)  IS LESS THAN ZERO
046000     OR
046100        (MC02-STMT-LINE-L (1 2)  IS GREATER THAN ZERO
046200     AND MTCC-MBU100-PRINT-ALL)
046300         MOVE 'STMT MESSAGE 1 LINE 2 '
046400                                 TO MBU100WS-PL1-DESC
046500         MOVE MC02-STMT-LINE (1 2)
046600                                 TO MBU100WS-PL1-FROM-VALUE
046700         MOVE MC02-STMT-LINE-L (1 2)
046800                                 TO WS-L
046900         PERFORM Z900-ERROR-MESSAGE
047000            THRU Z999-EM-EXIT.
047100*
047200     IF  MC02-STMT-LINE-L (1 3)  IS LESS THAN ZERO
047300     OR
047400        (MC02-STMT-LINE-L (1 3)  IS GREATER THAN ZERO
047500     AND MTCC-MBU100-PRINT-ALL)
047600         MOVE 'STMT MESSAGE 1 LINE 3 '
047700                                 TO MBU100WS-PL1-DESC
047800         MOVE MC02-STMT-LINE (1 3)
047900                                 TO MBU100WS-PL1-FROM-VALUE
048000         MOVE MC02-STMT-LINE-L (1 3)
048100                                 TO WS-L
048200         PERFORM Z900-ERROR-MESSAGE
048300            THRU Z999-EM-EXIT.
048400*
048500     IF  MC02-STMT-LINE-L (2 1)  IS LESS THAN ZERO
048600     OR
048700        (MC02-STMT-LINE-L (2 1)  IS GREATER THAN ZERO
048800     AND MTCC-MBU100-PRINT-ALL)
048900         MOVE 'STMT MESSAGE 2 LINE 1 '
049000                                 TO MBU100WS-PL1-DESC
049100         MOVE MC02-STMT-LINE (2 1)
049200                                 TO MBU100WS-PL1-FROM-VALUE
049300         MOVE MC02-STMT-LINE-L (2 1)
049400                                 TO WS-L
049500         PERFORM Z900-ERROR-MESSAGE
049600            THRU Z999-EM-EXIT.
049700*
049800     IF  MC02-STMT-LINE-L (2 2)  IS LESS THAN ZERO
049900     OR
050000        (MC02-STMT-LINE-L (2 2)  IS GREATER THAN ZERO
050100     AND MTCC-MBU100-PRINT-ALL)
050200         MOVE 'STMT MESSAGE 2 LINE 2 '
050300                                 TO MBU100WS-PL1-DESC
050400         MOVE MC02-STMT-LINE (2 2)
050500                                 TO MBU100WS-PL1-FROM-VALUE
050600         MOVE MC02-STMT-LINE-L (2 2)
050700                                 TO WS-L
050800         PERFORM Z900-ERROR-MESSAGE
050900            THRU Z999-EM-EXIT.
051000*
051100     IF  MC02-STMT-LINE-L (2 3)  IS LESS THAN ZERO
051200     OR
051300        (MC02-STMT-LINE-L (2 3)  IS GREATER THAN ZERO
051400     AND MTCC-MBU100-PRINT-ALL)
051500         MOVE 'STMT MESSAGE 2 LINE 3 '
051600                                 TO MBU100WS-PL1-DESC
051700         MOVE MC02-STMT-LINE (2 3)
051800                                 TO MBU100WS-PL1-FROM-VALUE
051900         MOVE MC02-STMT-LINE-L (2 3)
052000                                 TO WS-L
052100         PERFORM Z900-ERROR-MESSAGE
052200            THRU Z999-EM-EXIT.
052300*
052400     IF  MC02-STMT-LINE-L (3 1)  IS LESS THAN ZERO
052500     OR
052600        (MC02-STMT-LINE-L (3 1)  IS GREATER THAN ZERO
052700     AND MTCC-MBU100-PRINT-ALL)
052800         MOVE 'STMT MESSAGE 3 LINE 1 '
052900                                 TO MBU100WS-PL1-DESC
053000         MOVE MC02-STMT-LINE (3 1)
053100                                 TO MBU100WS-PL1-FROM-VALUE
053200         MOVE MC02-STMT-LINE-L (3 1)
053300                                 TO WS-L
053400         PERFORM Z900-ERROR-MESSAGE
053500            THRU Z999-EM-EXIT.
053600*
053700     IF  MC02-STMT-LINE-L (3 2)  IS LESS THAN ZERO
053800     OR
053900        (MC02-STMT-LINE-L (3 2)  IS GREATER THAN ZERO
054000     AND MTCC-MBU100-PRINT-ALL)
054100         MOVE 'STMT MESSAGE 3 LINE 2 '
054200                                 TO MBU100WS-PL1-DESC
054300         MOVE MC02-STMT-LINE (3 2)
054400                                 TO MBU100WS-PL1-FROM-VALUE
054500         MOVE MC02-STMT-LINE-L (3 2)
054600                                 TO WS-L
054700         PERFORM Z900-ERROR-MESSAGE
054800            THRU Z999-EM-EXIT.
054900*
055000     IF  MC02-STMT-LINE-L (3 3)  IS LESS THAN ZERO
055100     OR
055200        (MC02-STMT-LINE-L (3 3)  IS GREATER THAN ZERO
055300     AND MTCC-MBU100-PRINT-ALL)
055400         MOVE 'STMT MESSAGE 3 LINE 3 '
055500                                 TO MBU100WS-PL1-DESC
055600         MOVE MC02-STMT-LINE (3 3)
055700                                 TO MBU100WS-PL1-FROM-VALUE
055800         MOVE MC02-STMT-LINE-L (3 3)
055900                                 TO WS-L
056000         PERFORM Z900-ERROR-MESSAGE
056100            THRU Z999-EM-EXIT.
056200*
056300     IF  MC02-STMT-LINE-L (4 1)  IS LESS THAN ZERO
056400     OR
056500        (MC02-STMT-LINE-L (4 1)  IS GREATER THAN ZERO
056600     AND MTCC-MBU100-PRINT-ALL)
056700         MOVE 'STMT MESSAGE 4 LINE 1 '
056800                                 TO MBU100WS-PL1-DESC
056900         MOVE MC02-STMT-LINE (4 1)
057000                                 TO MBU100WS-PL1-FROM-VALUE
057100         MOVE MC02-STMT-LINE-L (4 1)
057200                                 TO WS-L
057300         PERFORM Z900-ERROR-MESSAGE
057400            THRU Z999-EM-EXIT.
057500*
057600     IF  MC02-STMT-LINE-L (4 2)  IS LESS THAN ZERO
057700     OR
057800        (MC02-STMT-LINE-L (4 2)  IS GREATER THAN ZERO
057900     AND MTCC-MBU100-PRINT-ALL)
058000         MOVE 'STMT MESSAGE 4 LINE 2 '
058100                                 TO MBU100WS-PL1-DESC
058200         MOVE MC02-STMT-LINE (4 2)
058300                                 TO MBU100WS-PL1-FROM-VALUE
058400         MOVE MC02-STMT-LINE-L (4 2)
058500                                 TO WS-L
058600         PERFORM Z900-ERROR-MESSAGE
058700            THRU Z999-EM-EXIT.
058800*
058900     IF  MC02-STMT-LINE-L (4 3)  IS LESS THAN ZERO
059000     OR
059100        (MC02-STMT-LINE-L (4 3)  IS GREATER THAN ZERO
059200     AND MTCC-MBU100-PRINT-ALL)
059300         MOVE 'STMT MESSAGE 4 LINE 3 '
059400                                 TO MBU100WS-PL1-DESC
059500         MOVE MC02-STMT-LINE (4 3)
059600                                 TO MBU100WS-PL1-FROM-VALUE
059700         MOVE MC02-STMT-LINE-L (4 3)
059800                                 TO WS-L
059900         PERFORM Z900-ERROR-MESSAGE
060000            THRU Z999-EM-EXIT.
060100*
060200 0299-P02-EXIT.
060300     EXIT.
060400/
060500 0300-PAGE-03 SECTION.
060600 0301-P03-BEGIN.
060700*
060800     SET WS-U100-NO-PAGE-ERRORS  TO TRUE.
060900*
061000     IF  MC02-STMT-LINE-L (1 1)  IS LESS THAN ZERO
061100     OR  MC02-STMT-LINE-L (1 2)  IS LESS THAN ZERO
061200     OR  MC02-STMT-LINE-L (1 3)  IS LESS THAN ZERO
061300         SET WS-U100-PAGE-ERRORS TO TRUE.
061400*
061500     IF  MC02-STMT-LINE-L (1 1)  IS LESS THAN ZERO
061600     OR
061700        (MC02-STMT-LINE-L (1 1)  IS GREATER THAN ZERO
061800     AND MTCC-MBU100-PRINT-ALL)
061900         MOVE 'STMT MESSAGE 5 LINE 1 '
062000                                 TO MBU100WS-PL1-DESC
062100         MOVE MC02-STMT-LINE (1 1)
062200                                 TO MBU100WS-PL1-FROM-VALUE
062300         MOVE MC02-STMT-LINE-L (1 1)
062400                                 TO WS-L
062500         PERFORM Z900-ERROR-MESSAGE
062600            THRU Z999-EM-EXIT.
062700*
062800     IF  MC02-STMT-LINE-L (1 2)  IS LESS THAN ZERO
062900     OR
063000        (MC02-STMT-LINE-L (1 2)  IS GREATER THAN ZERO
063100     AND MTCC-MBU100-PRINT-ALL)
063200         MOVE 'STMT MESSAGE 5 LINE 2 '
063300                                 TO MBU100WS-PL1-DESC
063400         MOVE MC02-STMT-LINE (1 2)
063500                                 TO MBU100WS-PL1-FROM-VALUE
063600         MOVE MC02-STMT-LINE-L (1 2)
063700                                 TO WS-L
063800         PERFORM Z900-ERROR-MESSAGE
063900            THRU Z999-EM-EXIT.
064000*
064100     IF  MC02-STMT-LINE-L (1 3)  IS LESS THAN ZERO
064200     OR
064300        (MC02-STMT-LINE-L (1 3)  IS GREATER THAN ZERO
064400     AND MTCC-MBU100-PRINT-ALL)
064500         MOVE 'STMT MESSAGE 5 LINE 3 '
064600                                 TO MBU100WS-PL1-DESC
064700         MOVE MC02-STMT-LINE (1 3)
064800                                 TO MBU100WS-PL1-FROM-VALUE
064900         MOVE MC02-STMT-LINE-L (1 3)
065000                                 TO WS-L
065100         PERFORM Z900-ERROR-MESSAGE
065200            THRU Z999-EM-EXIT.
065300*
065400 0399-P03-EXIT.
065500     EXIT.
065600/
065700 Z900-ERROR-MESSAGE SECTION.
065800 Z901-EM-BEGIN.
065900*
066000     EVALUATE TRUE
066100         WHEN MMUO-CURRENT-PAGE IS EQUAL TO ZERO
066200             MOVE MMUO-MC-L-ORG  TO MBU100WS-PL1-K5-ORG
066300             MOVE MMUO-MC-L-CHAIN
066400                                 TO MBU100WS-PL1-K5-NBR
066500         WHEN OTHER
066600             MOVE MMUO-MC-ORG    TO MBU100WS-PL1-K5-ORG
066700             MOVE MMUO-MC-CHAIN  TO MBU100WS-PL1-K5-NBR
066800     END-EVALUATE.
066900*
067000     MOVE MMUO-TI-POS-3-4        TO MBU100WS-PL1-TRANS-ID.
067100     MOVE MMUO-CURRENT-PAGE      TO MBU100WS-PL1-PAGE.
067200     MOVE '  TO='                TO MBU100WS-PL1-FROM.
067300*
067400     EVALUATE TRUE
067500         WHEN WS-L IS LESS THAN ZERO
067600             MOVE '*** E R R O R ***    '
067700                                 TO MBU100WS-PL1-MSG
067800         WHEN OTHER
067900             EVALUATE TRUE
068000                 WHEN WS-U100-PAGE-ERRORS
068100                     MOVE 'VALID DATA/PAGE ERROR'
068200                                 TO MBU100WS-PL1-MSG
068300                 WHEN MBU100WS-PO-UPDATE
068400                     MOVE 'ACCEPTED / UPDATED   '
068500                                 TO MBU100WS-PL1-MSG
068600                 WHEN OTHER
068700                     MOVE 'VALID DATA/NO UPDATE '
068800                                 TO MBU100WS-PL1-MSG
068900             END-EVALUATE
069000     END-EVALUATE.
069100*
069200     IF  MBU100WS-PL1-FROM-VALUE (42:9) IS EQUAL TO SPACES
069300     AND WS-U100-SL-SEQ IS EQUAL TO ZERO
069400         MOVE MMUO-SEQ           TO WS-U100-SL-SEQ
069500         MOVE WS-U100-SEQ-LIT    TO MBU100WS-PL1-FROM-VALUE(42:9)
069600     END-IF.
069700*
069800     MOVE MBU100WS-PRINT-LINE-1  TO MB20WS-PRINT-LINE.
069900     PERFORM MB22PD-PRINT-1-LINE
070000        THRU MB22PD-P1L-EXIT.
070100*
070200 Z999-EM-EXIT.
070300     EXIT.
070400/
070500 9000-PERFORMED-ROUTINES-SECT SECTION.
070600*
070700     COPY MB22PD.
070800/
070900     COPY SS02PD.
071000/
071100     COPY SS07PD.
071200/
071300     COPY SS08PD.
071400/
071500     COPY SS16PD.
071600/
071700     COPY SS26PD.
071800/
071900     COPY SS27PD.
072000*
072100 9995-END-SOURCE-STATEMENTS SECTION.
072200 9999-END-OF-PROGRAM.
072300     EXIT.
