000100 IDENTIFICATION DIVISION.
000200 PROGRAM-ID. MBU120.
000201*       RELEASE DATE=08/24/01.        REVISION LEVEL=08.06      *
000202*****************************************************************
000203*WARNING.  THIS COMPUTER PROGRAM IS PROTECTED BY COPYRIGHT LAW  *
000204*AND INTERNATIONAL TREATIES.  UNAUTHORIZED REPRODUCTION OR      *
000205*DISTRIBUTION OF THIS PROGRAM, OR ANY PORTION OF IT, MAY RESULT *
000206*IN SEVERE CIVIL AND CRIMINAL PENATLIES, AND WILL BE PROSECUTED *
000207*TO THE MAXIMUM EXTENT POSSIBLE UNDER THE LAW.                  *
000208*COPYRIGHT 1999 PAYSYS INTERNATIONAL, INC.  ALL RIGHTS RESERVED.*
000209*****************************************************************
000300*****************************************************************
000400*                                                               *
000500*       MBU120 - MONETARY FILE RECOVERY                         *
000600*                                                               *
000700*****************************************************************
000800 ENVIRONMENT DIVISION.
000900 CONFIGURATION SECTION.
001000 SOURCE-COMPUTER.            IBM-4341.
001100 OBJECT-COMPUTER.            IBM-4341.
001200/
001300 INPUT-OUTPUT SECTION.
001400*
001500 FILE-CONTROL.
001600*
001700/
001800 DATA DIVISION.
001900 FILE SECTION.
002000*
002100/
002200 WORKING-STORAGE SECTION.
002300*
002400 01  FILLER                  PIC  X(12)      VALUE '** WS-BEG **'.
002500*
002600 01  WS-MBU120-WORK-AREAS.
002700     03  WS-MML1-EOF-SW      PIC  X(01).
002800         88  WS-MML1-IS-EOF                  VALUE 'Y'.
002900*
003000     03  WS-PROG-ID          PIC  X(06)      VALUE 'MBU120'.
003100/
003200     COPY MTPTRL REPLACING ==:MTPT:== BY ==MMT1==.
003300/
003400     COPY MB00RB REPLACING ==:MB00:== BY ==MMT1==.
003500/
003600     COPY MTPTIO REPLACING ==:MTPT:== BY ==MMT1==.
003700/
003800     COPY MML1RL REPLACING ==:MML1:== BY ==MML1==.
003900/
004000     COPY MML1WS REPLACING ==:MML1:== BY ==MML1==.
004100/
004200     COPY MB00RB REPLACING ==:MB00:== BY ==MML1==.
004300/
004400     COPY MML1IO REPLACING ==:MML1:== BY ==MML1==.
004500/
004600     COPY MB00WS.
004700/
004800     COPY SS00WS.
004900/
005000     COPY SS01WS.
005100/
005200     COPY SS02WS.
005300*
005400 01  FILLER                  PIC  X(12)      VALUE '** WS-END **'.
005500/
005600 PROCEDURE DIVISION.
005700 A000-MAIN-LINE-SECT SECTION.
005800 A010-ML-BEGIN.
005900*
006000     PERFORM A100-OPEN-FILES
006100        THRU A199-OF-EXIT.
006200*
006300     PERFORM B100-PROCESS-MML1
006400        THRU B199-MML1-EXIT
006500        UNTIL WS-MML1-IS-EOF.
006600*
006700     PERFORM C100-CLOSE-FILES
006800        THRU C199-CF-EXIT.
006900*
007000     STOP RUN.
007100*
007200 A100-OPEN-FILES.
007300*
007400     MOVE WS-PROG-ID             TO SS02WS-ABEND-PROG-ID.
007500     MOVE 'O1T1'                 TO SS02WS-ABEND-LOCATION.
007600     SET MMT1RB-OPEN-IO-DYN      TO TRUE.
007700     PERFORM MB00PD-MMT1-ACCESS
007800        THRU MB00PD-MMT1-ACCESS-EXIT.
007900*
008000     MOVE SS02WS-DUPLICATE-RECORD
008100                                 TO MMT1RB-PERM-STATUS-1.
008200*
008300     MOVE 'O1L1'                 TO SS02WS-ABEND-LOCATION.
008400     SET MML1RB-OPEN-INPUT       TO TRUE.
008500     PERFORM MB00PD-MML1-ACCESS
008600        THRU MB00PD-MML1-ACCESS-EXIT.
008700*
008800     MOVE SS02WS-END-OF-FILE     TO MML1RB-PERM-STATUS-1.
008900*
009000 A199-OF-EXIT.
009100     EXIT.
009200/
009300 B100-PROCESS-MML1.
009400*
009500     MOVE 'R1L1'                 TO SS02WS-ABEND-LOCATION.
009600     SET MML1RB-READ-SEQ         TO TRUE.
009700     PERFORM MB00PD-MML1-ACCESS
009800        THRU MB00PD-MML1-ACCESS-EXIT.
009900     MOVE MML1IO-RECORD          TO MML1-RECORD.
010000*
010100     IF  SS02WS-FS-END-OF-FILE
010200         MOVE 'Y'                TO WS-MML1-EOF-SW
010300         GO TO B199-MML1-EXIT.
010400*
010500     IF  MML1-FILE-IS-MMT1
010600         MOVE MML1-ADD-AREA      TO MMT1IO-RECORD
010700         MOVE 'W1T1'             TO SS02WS-ABEND-LOCATION
010800         SET MMT1RB-WRITE        TO TRUE
010900         PERFORM MB00PD-MMT1-ACCESS
011000            THRU MB00PD-MMT1-ACCESS-EXIT
011100     ELSE
011200         GO TO B199-MML1-EXIT.
011300*
011400     IF  SS02WS-FS-DUPLICATE-RECORD
011500         MOVE MML1-ADD-AREA      TO MMT1IO-RECORD
011600         MOVE 'U1T1'             TO SS02WS-ABEND-LOCATION
011700         SET MMT1RB-REWRITE      TO TRUE
011800         PERFORM MB00PD-MMT1-ACCESS
011900            THRU MB00PD-MMT1-ACCESS-EXIT.
012000*
012100*
012200 B199-MML1-EXIT.
012300     EXIT.
012400*
012500 C100-CLOSE-FILES.
012600*
012700     MOVE 'C1T1'                 TO SS02WS-ABEND-LOCATION.
012800     SET MMT1RB-CLOSE            TO TRUE.
012900     PERFORM MB00PD-MMT1-ACCESS
013000        THRU MB00PD-MMT1-ACCESS-EXIT.
013100*
013200     MOVE 'C1L1'                 TO SS02WS-ABEND-LOCATION.
013300     SET MML1RB-CLOSE            TO TRUE.
013400     PERFORM MB00PD-MML1-ACCESS
013500        THRU MB00PD-MML1-ACCESS-EXIT.
013600*
013700 C199-CF-EXIT.
013800     EXIT.
013900/
014000 9000-PERFORMED-ROUTINES-SECT SECTION.
014100*
014200     COPY MB00PD REPLACING ==:MB00:== BY ==MML1==.
014300/
014400     COPY MB00PD REPLACING ==:MB00:== BY ==MMT1==.
014500/
014600     COPY SS02PD.
014700/
014800     COPY SS07PD.
014900/
015000     COPY SS08PD.
015100/
015200     COPY SS16PD.
015300/
015400     COPY SS26PD.
015500/
015600     COPY SS27PD.
015700*
015800 9995-END-SOURCE-STATEMENTS SECTION.
015900 9999-END-OF-PROGRAM.
016000     EXIT.
