000100 IDENTIFICATION DIVISION.
000200 PROGRAM-ID. MBU200.
000201*       RELEASE DATE=08/24/01.        REVISION LEVEL=08.06      *
000202*****************************************************************
000203*WARNING.  THIS COMPUTER PROGRAM IS PROTECTED BY COPYRIGHT LAW  *
000204*AND INTERNATIONAL TREATIES.  UNAUTHORIZED REPRODUCTION OR      *
000205*DISTRIBUTION OF THIS PROGRAM, OR ANY PORTION OF IT, MAY RESULT *
000206*IN SEVERE CIVIL AND CRIMINAL PENATLIES, AND WILL BE PROSECUTED *
000207*TO THE MAXIMUM EXTENT POSSIBLE UNDER THE LAW.                  *
000208*COPYRIGHT 1999 PAYSYS INTERNATIONAL, INC.  ALL RIGHTS RESERVED.*
000209*****************************************************************
000300*****************************************************************
000400*                                                               *
000500*   V - PLUS  M E R C H A N T   B A N K C A R D   S Y S T E M   *
000600*                                                               *
000700*       MBU200 - NAME LOCATE REBUILD                            *
000800*                                                               *
000900*****************************************************************
001000 ENVIRONMENT DIVISION.
001100 CONFIGURATION SECTION.
001200 SOURCE-COMPUTER.            IBM-4341.
001300 OBJECT-COMPUTER.            IBM-4341.
001400*
001500 INPUT-OUTPUT SECTION.
001600 FILE-CONTROL.
001700*
001800     COPY MS1SES.
001900*
002000 DATA DIVISION.
002100 FILE SECTION.
002200*
002300     COPY MS1SSD.
002400*
002500 01  MS1S-RECORD.
002600     03  MS1S-KEY.
002700         05  MS1S-NAME       PIC  X(40).
002800         05  MS1S-TIE-BREAKER
002900                             PIC S9(08)      BINARY.
003000     03  MS1S-MMNL-RECORD    PIC  X(200).
003100/
003200 WORKING-STORAGE SECTION.
003300*
003400 01  FILLER                  PIC  X(12)      VALUE '** WS-BEG **'.
003500*
003600 01  WS-MBU200-WORK-AREAS.
003700     03  WS-MS1S-EOF-SW      PIC  X(01)      VALUE 'N'.
003800         88  WS-MS1S-IS-END-OF-FILE          VALUE 'Y'.
003900     03  WS-1ST-TIME-MS1S-SW PIC  X(01)      VALUE 'Y'.
004000         88  WS-1ST-TIME-MS1S                VALUE 'Y'.
004100     03  WS-TIE-BREAKER-CNT  PIC S9(04)      BINARY VALUE ZEROS.
004200     03  WS-PREV-MMNL-RECORD.
004300         05  WS-PREV-KEY.
004400             07  WS-PREV-NAME
004500                             PIC  X(40)      VALUE SPACES.
004600             07  WS-PREV-TIE-BREAKER
004700                             PIC S9(08)      BINARY VALUE ZEROS.
004800         05  WS-PREV-REST-OF-REC
004900                             PIC  X(156)     VALUE SPACES.
005000/
005100     COPY MMNLIO.
005200/
005300     COPY MB00RB REPLACING ==:MB00:== BY ==MMNL==.
005400/
005500     COPY MMNLRL.
005600/
005700     COPY MMSMIO.
005800/
005900     COPY MB00RB REPLACING ==:MB00:== BY ==MMSM==.
006000/
006100     COPY MMSMRL.
006200/
006300     COPY MMMMIO.
006400/
006500     COPY MB00RB REPLACING ==:MB00:== BY ==MMMM==.
006600/
006700     COPY MMMMRL.
006800/
006900     COPY MMRCIO.
007000/
007100     COPY MB00RB REPLACING ==:MB00:== BY ==MMRC==.
007200/
007300     COPY MMRCRL.
007400/
007500     COPY MMSRIO.
007600/
007700     COPY MB00RB REPLACING ==:MB00:== BY ==MMSR==.
007800/
007900     COPY MMSRRL.
008000/
008100     COPY MMOCIO.
008200/
008300     COPY MB00RB REPLACING ==:MB00:== BY ==MMOC==.
008400/
008500     COPY MMOCRL.
008600/
008700     COPY MMSCIO.
008800/
008900     COPY MB00RB REPLACING ==:MB00:== BY ==MMSC==.
009000/
009100     COPY MMSCRL.
009200/
009300     COPY MB00WS.
009400/
009500     COPY MB99WS.
009600/
009700     COPY SS00WS.
009800/
009900     COPY SS01WS.
010000/
010100     COPY SS02WS.
010200/
010300     COPY SS05WS.
010400/
010500     COPY SS12WS.
010600*
010700 01  FILLER                  PIC  X(12)      VALUE '** WS-END **'.
010800/
010900 PROCEDURE DIVISION.
011000 A000-MAIN-LINE-SECT SECTION.
011100 A010-ML-BEGIN.
011200*
011300     MOVE 'MBU200'               TO SS02WS-ABEND-PROG-ID.
011400*
011500     PERFORM A100-OPEN-FILES     THRU A199-OF-EXIT.
011600*
011700     SORT MS1S-SORT-FILE
011800          ASCENDING KEY MS1S-KEY
011900          INPUT PROCEDURE        IS B000-READ-INPUT-SEC
012000          OUTPUT PROCEDURE       IS C000-WRITE-SORTED-FILE-SEC.
012100*
012200     PERFORM SS98PD-VERIFY-SORT-RETURN
012300        THRU SS98PD-VSR-EXIT.
012400*
012500     PERFORM A200-CLOSE-FILES    THRU A299-CF-EXIT.
012600*
012700     STOP RUN.
012800*
012900 A099-ML-EXIT.
013000     EXIT.
013100/
013200 A100-OPEN-FILES SECTION.
013300 A101-OF-OPEN-FILES.
013400*
013500     MOVE 'O1NL'                 TO SS02WS-ABEND-LOCATION.
013600     SET MMNLRB-OPEN-OUTPUT      TO TRUE.
013700     PERFORM MB00PD-MMNL-ACCESS  THRU MB00PD-MMNL-ACCESS-EXIT.
013800*
013900     MOVE 'O1SM'                 TO SS02WS-ABEND-LOCATION.
014000     SET MMSMRB-OPEN-INPUT       TO TRUE.
014100     PERFORM MB00PD-MMSM-ACCESS  THRU MB00PD-MMSM-ACCESS-EXIT.
014200*
014300     MOVE 'O1MM'                 TO SS02WS-ABEND-LOCATION.
014400     SET MMMMRB-OPEN-INPUT       TO TRUE.
014500     PERFORM MB00PD-MMMM-ACCESS  THRU MB00PD-MMMM-ACCESS-EXIT.
014600*
014700     MOVE 'O1RC'                 TO SS02WS-ABEND-LOCATION.
014800     SET MMRCRB-OPEN-INPUT       TO TRUE.
014900     PERFORM MB00PD-MMRC-ACCESS  THRU MB00PD-MMRC-ACCESS-EXIT.
015000*
015100     MOVE 'O1SR'                 TO SS02WS-ABEND-LOCATION.
015200     SET MMSRRB-OPEN-INPUT       TO TRUE.
015300     PERFORM MB00PD-MMSR-ACCESS  THRU MB00PD-MMSR-ACCESS-EXIT.
015400*
015500     MOVE 'O1OC'                 TO SS02WS-ABEND-LOCATION.
015600     SET MMOCRB-OPEN-INPUT       TO TRUE.
015700     PERFORM MB00PD-MMOC-ACCESS  THRU MB00PD-MMOC-ACCESS-EXIT.
015800*
015900     MOVE 'O1SC'                 TO SS02WS-ABEND-LOCATION.
016000     SET MMSCRB-OPEN-INPUT       TO TRUE.
016100     PERFORM MB00PD-MMSC-ACCESS  THRU MB00PD-MMSC-ACCESS-EXIT.
016200*
016300 A110-CHECK-HEADERS-READ.
016400*
016500     MOVE 'R0SC'                 TO SS02WS-ABEND-LOCATION.
016600     SET MMSCRB-READ-SEQ         TO TRUE.
016700     PERFORM MB00PD-MMSC-ACCESS  THRU MB00PD-MMSC-ACCESS-EXIT.
016800*
016900     MOVE 'MMSC'                 TO MB99WS-FILE-ID.
017000*
017100     IF  MMSCIO-HEADER
017200         NEXT SENTENCE
017300     ELSE
017400         PERFORM MB99PD-MISSING-HEADER-ABEND
017500                                 THRU MB99PD-MHA-EXIT.
017600*
017700     MOVE MMSCIO-RECORD          TO MMSC-RECORD.
017800     MOVE MMSC-TODAYS-JULIAN     TO MB99WS-PROC-DATE.
017900     MOVE MMSC-TIME-STAMP        TO MB99WS-PROC-TIME.
018000*
018100*
018200*
018300     MOVE 'R0OC'                 TO SS02WS-ABEND-LOCATION.
018400     SET MMOCRB-READ-SEQ         TO TRUE.
018500     PERFORM MB00PD-MMOC-ACCESS  THRU MB00PD-MMOC-ACCESS-EXIT.
018600     MOVE 'MMOC'                 TO MB99WS-FILE-ID.
018700*
018800     IF  MMOCIO-HEADER
018900         NEXT SENTENCE
019000     ELSE
019100         PERFORM MB99PD-MISSING-HEADER-ABEND
019200                                 THRU MB99PD-MHA-EXIT.
019300*
019400     MOVE MMOCIO-DATE-STAMP      TO MB99WS-FILE-DATE.
019500     MOVE MMOCIO-TIME-STAMP      TO MB99WS-FILE-TIME.
019600     PERFORM MB99PD-CHECK-DATE-TIME
019700                                 THRU MB99PD-CDT-EXIT.
019800*
019900     MOVE MMOCIO-RECORD          TO MMOC-RECORD.
020000*
020100*
020200*
020300     MOVE 'R0SM'                 TO SS02WS-ABEND-LOCATION.
020400     SET MMSMRB-READ-SEQ         TO TRUE.
020500     PERFORM MB00PD-MMSM-ACCESS  THRU MB00PD-MMSM-ACCESS-EXIT.
020600     MOVE 'MMSM'                 TO MB99WS-FILE-ID.
020700*
020800     IF  MMSMIO-HEADER
020900         NEXT SENTENCE
021000     ELSE
021100         PERFORM MB99PD-MISSING-HEADER-ABEND
021200                                 THRU MB99PD-MHA-EXIT.
021300*
021400     MOVE MMSMIO-DATE-STAMP      TO MB99WS-FILE-DATE.
021500     MOVE MMSMIO-TIME-STAMP      TO MB99WS-FILE-TIME.
021600     PERFORM MB99PD-CHECK-DATE-TIME
021700                                 THRU MB99PD-CDT-EXIT.
021800*
021900     MOVE 'R1SM'                 TO SS02WS-ABEND-LOCATION.
022000     SET MMSMRB-READ-SEQ         TO TRUE.
022100     PERFORM MB00PD-MMSM-ACCESS  THRU MB00PD-MMSM-ACCESS-EXIT.
022200*
022300     MOVE MMSMIO-RECORD          TO MMSM-RECORD.
022400*
022500*
022600     MOVE 'R0MM'                 TO SS02WS-ABEND-LOCATION.
022700     SET MMMMRB-READ-SEQ         TO TRUE.
022800     PERFORM MB00PD-MMMM-ACCESS  THRU MB00PD-MMMM-ACCESS-EXIT.
022900     MOVE 'MMMM'                 TO MB99WS-FILE-ID.
023000*
023100     IF  MMMMIO-HEADER
023200         NEXT SENTENCE
023300     ELSE
023400         PERFORM MB99PD-MISSING-HEADER-ABEND
023500                                 THRU MB99PD-MHA-EXIT.
023600*
023700     MOVE MMMMIO-DATE-STAMP      TO MB99WS-FILE-DATE.
023800     MOVE MMMMIO-TIME-STAMP      TO MB99WS-FILE-TIME.
023900     PERFORM MB99PD-CHECK-DATE-TIME
024000                                 THRU MB99PD-CDT-EXIT.
024100*
024200     MOVE 'R1MM'                 TO SS02WS-ABEND-LOCATION.
024300     SET MMMMRB-READ-SEQ         TO TRUE.
024400     PERFORM MB00PD-MMMM-ACCESS  THRU MB00PD-MMMM-ACCESS-EXIT.
024500*
024600     MOVE MMMMIO-RECORD          TO MMMM-RECORD.
024700*
024800*
024900     MOVE 'R0RC'                 TO SS02WS-ABEND-LOCATION.
025000     SET MMRCRB-READ-SEQ         TO TRUE.
025100     PERFORM MB00PD-MMRC-ACCESS  THRU MB00PD-MMRC-ACCESS-EXIT.
025200     MOVE 'MMRC'                 TO MB99WS-FILE-ID.
025300*
025400     IF  MMRCIO-HEADER
025500         NEXT SENTENCE
025600     ELSE
025700         PERFORM MB99PD-MISSING-HEADER-ABEND
025800                                 THRU MB99PD-MHA-EXIT.
025900*
026000     MOVE MMRCIO-DATE-STAMP      TO MB99WS-FILE-DATE.
026100     MOVE MMRCIO-TIME-STAMP      TO MB99WS-FILE-TIME.
026200     PERFORM MB99PD-CHECK-DATE-TIME
026300                                 THRU MB99PD-CDT-EXIT.
026400*
026500     MOVE 'R1RC'                 TO SS02WS-ABEND-LOCATION.
026600     SET MMRCRB-READ-SEQ         TO TRUE.
026700     PERFORM MB00PD-MMRC-ACCESS  THRU MB00PD-MMRC-ACCESS-EXIT.
026800*
026900     MOVE MMRCIO-RECORD          TO MMRC-RECORD.
027000*
027100*
027200     MOVE 'R0SR'                 TO SS02WS-ABEND-LOCATION.
027300     SET MMSRRB-READ-SEQ         TO TRUE.
027400     PERFORM MB00PD-MMSR-ACCESS  THRU MB00PD-MMSR-ACCESS-EXIT.
027500     MOVE 'MMSR'                 TO MB99WS-FILE-ID.
027600*
027700     IF  MMSRIO-HEADER
027800         NEXT SENTENCE
027900     ELSE
028000         PERFORM MB99PD-MISSING-HEADER-ABEND
028100                                 THRU MB99PD-MHA-EXIT.
028200*
028300     MOVE MMSRIO-DATE-STAMP      TO MB99WS-FILE-DATE.
028400     MOVE MMSRIO-TIME-STAMP      TO MB99WS-FILE-TIME.
028500     PERFORM MB99PD-CHECK-DATE-TIME
028600                                 THRU MB99PD-CDT-EXIT.
028700*
028800     MOVE 'R1SR'                 TO SS02WS-ABEND-LOCATION.
028900     SET MMSRRB-READ-SEQ         TO TRUE.
029000     PERFORM MB00PD-MMSR-ACCESS  THRU MB00PD-MMSR-ACCESS-EXIT.
029100*
029200     MOVE MMSRIO-RECORD          TO MMSR-RECORD.
029300*
029400*
029500*
029600 A199-OF-EXIT.
029700     EXIT.
029800/
029900 A200-CLOSE-FILES SECTION.
030000 A201-CF-BEGIN.
030100*
030200     MOVE 'C1NL'                 TO SS02WS-ABEND-LOCATION.
030300     SET MMNLRB-CLOSE            TO TRUE.
030400     PERFORM MB00PD-MMNL-ACCESS  THRU MB00PD-MMNL-ACCESS-EXIT.
030500*
030600     MOVE 'C1SM'                 TO SS02WS-ABEND-LOCATION.
030700     SET MMSMRB-CLOSE            TO TRUE.
030800     PERFORM MB00PD-MMSM-ACCESS  THRU MB00PD-MMSM-ACCESS-EXIT.
030900*
031000     MOVE 'C1MM'                 TO SS02WS-ABEND-LOCATION.
031100     SET MMMMRB-CLOSE            TO TRUE.
031200     PERFORM MB00PD-MMMM-ACCESS  THRU MB00PD-MMMM-ACCESS-EXIT.
031300*
031400     MOVE 'C1RC'                 TO SS02WS-ABEND-LOCATION.
031500     SET MMRCRB-CLOSE            TO TRUE.
031600     PERFORM MB00PD-MMRC-ACCESS  THRU MB00PD-MMRC-ACCESS-EXIT.
031700*
031800     MOVE 'C1SR'                 TO SS02WS-ABEND-LOCATION.
031900     SET MMSRRB-CLOSE            TO TRUE.
032000     PERFORM MB00PD-MMSR-ACCESS  THRU MB00PD-MMSR-ACCESS-EXIT.
032100*
032200     MOVE 'C1OC'                 TO SS02WS-ABEND-LOCATION.
032300     SET MMOCRB-CLOSE            TO TRUE.
032400     PERFORM MB00PD-MMOC-ACCESS  THRU MB00PD-MMOC-ACCESS-EXIT.
032500*
032600     MOVE 'C1SC'                 TO SS02WS-ABEND-LOCATION.
032700     SET MMSCRB-CLOSE            TO TRUE.
032800     PERFORM MB00PD-MMSC-ACCESS  THRU MB00PD-MMSC-ACCESS-EXIT.
032900*
033000 A299-CF-EXIT.
033100     EXIT.
033200 A999-EXIT.
033300     EXIT.
033400/
033500*
033600 B000-READ-INPUT-SEC SECTION.
033700 B010-PP-BEGIN.
033800*
033900     PERFORM E000-PROCESS-ORG    THRU E019-PO-EXIT.
034000*
034100     IF  MMOCIO-TRAILER
034200         GO TO B010-PP-BEGIN-EXIT.
034300*
034400     PERFORM F000-PROCESS-MERCHANTS
034500                                 THRU F019-PM-EXIT
034600        UNTIL MMMMIO-ORG IS GREATER THAN MMOC-ORG.
034700*
034800     PERFORM G000-PROCESS-STORES THRU G019-PS-EXIT
034900        UNTIL MMSMIO-ORG IS GREATER THAN MMOC-ORG.
035000*
035100     PERFORM H000-PROCESS-CHAINS THRU H019-PC-EXIT
035200        UNTIL MMRCIO-ORG IS GREATER THAN MMOC-ORG.
035300*
035400     PERFORM I000-PROCESS-S-CHAINS THRU I019-PC-EXIT
035500        UNTIL MMSRIO-ORG IS GREATER THAN MMOC-ORG.
035600*
035700     GO TO B010-PP-BEGIN.
035800*
035900 B010-PP-BEGIN-EXIT.
036000     EXIT.
036100 B999-PP-EXIT.
036200     EXIT.
036300*
036400 C000-WRITE-SORTED-FILE-SEC SECTION.
036500 C010-BEG-RETURN.
036600*
036700     PERFORM C020-PROCESS-RETURNS
036800                                 THRU C029-BEGIN-RETURN-EXIT
036900         UNTIL WS-MS1S-IS-END-OF-FILE.
037000*
037100     IF  MS1S-NAME NOT EQUAL TO SPACES
037200         MOVE WS-PREV-MMNL-RECORD
037300                                 TO MMNLIO-RECORD
037400         PERFORM 9000-WRITE-MMNL THRU 9099-WM-EXIT.
037500*
037600     MOVE SPACES                 TO MMNL-RECORD.
037700     MOVE HIGH-VALUES            TO MMNL-NAME.
037800     MOVE 99999999               TO MMNL-TIE-BREAKER.
037900     MOVE MMNL-RECORD            TO MMNLIO-RECORD.
038000     PERFORM 9000-WRITE-MMNL     THRU 9099-WM-EXIT.
038100*
038200     GO TO C999-EXIT.
038300*
038400 C020-PROCESS-RETURNS.
038500*
038600     RETURN MS1S-SORT-FILE
038700         AT END
038800            MOVE 'Y'             TO WS-MS1S-EOF-SW
038900            GO TO C029-BEGIN-RETURN-EXIT.
039000*
039100     IF  WS-1ST-TIME-MS1S
039200         MOVE 'N'                TO WS-1ST-TIME-MS1S-SW
039300         MOVE MS1S-MMNL-RECORD   TO WS-PREV-MMNL-RECORD
039400         GO TO C029-BEGIN-RETURN-EXIT.
039500*
039600     IF  MS1S-NAME IS EQUAL TO WS-PREV-NAME
039700         MOVE WS-PREV-MMNL-RECORD
039800                                 TO MMNLIO-RECORD
039900         PERFORM 9000-WRITE-MMNL THRU 9099-WM-EXIT
040000         MOVE MS1S-MMNL-RECORD   TO WS-PREV-MMNL-RECORD
040100         ADD 1                   TO WS-TIE-BREAKER-CNT
040200         MOVE WS-TIE-BREAKER-CNT TO WS-PREV-TIE-BREAKER
040300     ELSE
040400         MOVE WS-PREV-MMNL-RECORD
040500                                 TO MMNLIO-RECORD
040600         PERFORM 9000-WRITE-MMNL THRU 9099-WM-EXIT
040700         MOVE MS1S-MMNL-RECORD   TO WS-PREV-MMNL-RECORD
040800         MOVE ZEROS              TO WS-TIE-BREAKER-CNT
040900                                    WS-PREV-TIE-BREAKER.
041000*
041100 C029-BEGIN-RETURN-EXIT.
041200     EXIT.
041300 C999-EXIT.
041400     EXIT.
041500/
041600 E000-PROCESS-ORG SECTION.
041700 E010-PO-BEGIN.
041800*
041900     MOVE 'R1OC'                 TO SS02WS-ABEND-LOCATION.
042000     SET MMOCRB-READ-SEQ         TO TRUE.
042100     PERFORM MB00PD-MMOC-ACCESS  THRU MB00PD-MMOC-ACCESS-EXIT.
042200*
042300     IF  MMOCIO-TRAILER
042400         GO TO E019-PO-EXIT.
042500*
042600     MOVE MMOCIO-RECORD          TO MMOC-RECORD.
042700*
042800     IF  MMOC-REC-INCOMPLETE
042900     OR  MMOC-ADD-PENDING
043000     OR  MMOC-REC-PURGED
043100         GO TO E010-PO-BEGIN.
043200*
043300 E019-PO-EXIT.
043400     EXIT.
043500 E999-EXIT.
043600     EXIT.
043700/
043800 F000-PROCESS-MERCHANTS SECTION.
043900 F010-PM-BEGIN.
044000*
044100     IF  MMMM-TRAILER
044200         GO TO F019-PM-EXIT.
044300*
044400     IF  MMMM-ORG IS LESS THAN MMOC-ORG
044500         PERFORM 9100-GET-NEXT-MERCHANT
044600                                 THRU 9199-GNM-EXIT
044700         GO TO F019-PM-EXIT.
044800*
044900     IF  MMMM-ORG IS NOT EQUAL TO MMOC-ORG
045000         GO TO F019-PM-EXIT.
045100*
045200     IF  MMMM-REC-INCOMPLETE
045300     OR  MMMM-ADD-PENDING
045400     OR  MMMM-REC-PURGED
045500         PERFORM 9100-GET-NEXT-MERCHANT
045600                                 THRU 9199-GNM-EXIT
045700         GO TO F019-PM-EXIT.
045800*
045900     IF  MMMM-NA-LINE (1 1) IS EQUAL TO SPACES
046000         PERFORM 9100-GET-NEXT-MERCHANT
046100                                 THRU 9199-GNM-EXIT
046200         GO TO F019-PM-EXIT.
046300*
046400     IF  MMOC-MERCH-PRIMARY-ON
046500         MOVE SPACES             TO MMNL-RECORD
046600         MOVE ZEROS              TO MMNL-TIE-BREAKER
046700                                    MS1S-TIE-BREAKER
046800         MOVE MMMM-ORG           TO MMNL-ORG
046900         MOVE 'MM'               TO MMNL-FILE-TYPE
047000         MOVE 'P'                TO MMNL-NAME-LOCATION
047100         MOVE MMMM-MERCHANT      TO MMNL-FILE-NBR
047200         MOVE MMMM-NA-LINE (1 1) TO MMNL-NAME
047300                                    MS1S-NAME
047400         MOVE MMMM-NA-LINE (1 2) TO MMNL-ADDR1
047500         EVALUATE TRUE
047600           WHEN  MMMM-NA-LINE (1 5) IS NOT EQUAL TO SPACES
047700             MOVE MMMM-NA-LINE (1 5)
047800                                 TO MMNL-CITY
047900           WHEN  MMMM-NA-LINE (1 4) IS NOT EQUAL TO SPACES
048000             MOVE MMMM-NA-LINE (1 4)
048100                                 TO MMNL-CITY
048200           WHEN  MMMM-NA-LINE (1 3) IS NOT EQUAL TO SPACES
048300             MOVE MMMM-NA-LINE (1 3)
048400                                 TO MMNL-CITY
048500         END-EVALUATE
048600         MOVE MMMM-STATE-CODE (1)
048700                                 TO MMNL-STATE
048800         MOVE MMMM-POSTAL-CODE (1)
048900                                 TO MMNL-POSTAL-CODE
049000         MOVE MMMM-PHONE (1)     TO MMNL-PHONE
049100         MOVE MMNL-RECORD        TO MS1S-MMNL-RECORD
049200         RELEASE MS1S-RECORD.
049300*
049400     IF  MMOC-MERCH-SECONDARY-ON
049500         MOVE SPACES             TO MMNL-RECORD
049600         MOVE ZEROS              TO MMNL-TIE-BREAKER
049700                                    MS1S-TIE-BREAKER
049800         MOVE MMMM-ORG           TO MMNL-ORG
049900         MOVE 'MM'               TO MMNL-FILE-TYPE
050000         MOVE 'S'                TO MMNL-NAME-LOCATION
050100         MOVE MMMM-MERCHANT      TO MMNL-FILE-NBR
050200         MOVE MMMM-NA-LINE (2 1) TO MMNL-NAME
050300                                    MS1S-NAME
050400         MOVE MMMM-NA-LINE (2 2) TO MMNL-ADDR1
050500         EVALUATE TRUE
050600           WHEN  MMMM-NA-LINE (2 5) IS NOT EQUAL TO SPACES
050700             MOVE MMMM-NA-LINE (2 5)
050800                                 TO MMNL-CITY
050900           WHEN  MMMM-NA-LINE (2 4) IS NOT EQUAL TO SPACES
051000             MOVE MMMM-NA-LINE (2 4)
051100                                 TO MMNL-CITY
051200           WHEN  MMMM-NA-LINE (2 3) IS NOT EQUAL TO SPACES
051300             MOVE MMMM-NA-LINE (2 3)
051400                                 TO MMNL-CITY
051500         END-EVALUATE
051600         MOVE MMMM-STATE-CODE (2)
051700                                 TO MMNL-STATE
051800         MOVE MMMM-POSTAL-CODE (2)
051900                                 TO MMNL-POSTAL-CODE
052000         MOVE MMMM-PHONE (2)     TO MMNL-PHONE
052100         MOVE MMNL-RECORD        TO MS1S-MMNL-RECORD
052200         RELEASE MS1S-RECORD.
052300*
052400     IF  MMOC-MERCH-DBA-ON
052500         MOVE SPACES             TO MMNL-RECORD
052600         MOVE ZEROS              TO MMNL-TIE-BREAKER
052700                                    MS1S-TIE-BREAKER
052800         MOVE MMMM-ORG           TO MMNL-ORG
052900         MOVE 'MM'               TO MMNL-FILE-TYPE
053000         MOVE 'D'                TO MMNL-NAME-LOCATION
053100         MOVE MMMM-MERCHANT      TO MMNL-FILE-NBR
053200         MOVE MMMM-DBA-NAME      TO MMNL-NAME
053300                                    MS1S-NAME
053400         MOVE MMMM-NA-LINE (1 2) TO MMNL-ADDR1
053500         MOVE MMMM-POSTAL-CODE (1)
053600                                 TO MMNL-POSTAL-CODE
053700         MOVE MMMM-PHONE (1)     TO MMNL-PHONE
053800         MOVE MMMM-DBA-CITY      TO MMNL-CITY
053900         MOVE MMMM-DBA-COUNTRY-CODE
054000                                 TO MMNL-STATE
054100         MOVE MMNL-RECORD        TO MS1S-MMNL-RECORD
054200         RELEASE MS1S-RECORD.
054300*
054400     PERFORM 9100-GET-NEXT-MERCHANT
054500                                 THRU 9199-GNM-EXIT.
054600*
054700*
054800 F019-PM-EXIT.
054900     EXIT.
055000 F999-EXIT.
055100     EXIT.
055200*
055300/
055400 G000-PROCESS-STORES SECTION.
055500 G010-PS-BEGIN.
055600*
055700     IF  MMSMIO-TRAILER
055800         GO TO G019-PS-EXIT.
055900*
056000     IF  MMSM-ORG IS LESS THAN MMOC-ORG
056100         PERFORM 9200-GET-NEXT-STORE
056200                                 THRU 9299-GNS-EXIT
056300         GO TO G019-PS-EXIT.
056400*
056500     IF  MMSM-ORG IS NOT EQUAL TO MMOC-ORG
056600         GO TO G019-PS-EXIT.
056700*
056800     IF  MMSM-REC-INCOMPLETE
056900     OR  MMSM-ADD-PENDING
057000     OR  MMSM-REC-PURGED
057100         PERFORM 9200-GET-NEXT-STORE
057200                                 THRU 9299-GNS-EXIT
057300         GO TO G019-PS-EXIT.
057400*
057500     IF  MMSM-NA-LINE (1 1) IS EQUAL TO SPACES
057600         PERFORM 9200-GET-NEXT-STORE
057700                                 THRU 9299-GNS-EXIT
057800         GO TO G019-PS-EXIT.
057900*
058000     IF  MMOC-STORE-PRIMARY-ON
058100         MOVE SPACES             TO MMNL-RECORD
058200         MOVE ZEROS              TO MMNL-TIE-BREAKER
058300                                    MS1S-TIE-BREAKER
058400         MOVE MMSM-ORG           TO MMNL-ORG
058500         MOVE 'SM'               TO MMNL-FILE-TYPE
058600         MOVE 'P'                TO MMNL-NAME-LOCATION
058700         MOVE MMSM-STORE         TO MMNL-FILE-NBR
058800         MOVE MMSM-NA-LINE (1 1) TO MMNL-NAME
058900                                    MS1S-NAME
059000         MOVE MMSM-NA-LINE (1 2) TO MMNL-ADDR1
059100         EVALUATE TRUE
059200           WHEN  MMSM-NA-LINE (1 5) IS NOT EQUAL TO SPACES
059300             MOVE MMSM-NA-LINE (1 5)
059400                                 TO MMNL-CITY
059500           WHEN  MMSM-NA-LINE (1 4) IS NOT EQUAL TO SPACES
059600             MOVE MMSM-NA-LINE (1 4)
059700                                 TO MMNL-CITY
059800           WHEN  MMSM-NA-LINE (1 3) IS NOT EQUAL TO SPACES
059900             MOVE MMSM-NA-LINE (1 3)
060000                                 TO MMNL-CITY
060100         END-EVALUATE
060200         MOVE MMSM-STATE-CODE (1)
060300                                 TO MMNL-STATE
060400         MOVE MMSM-POSTAL-CODE (1)
060500                                 TO MMNL-POSTAL-CODE
060600         MOVE MMSM-PHONE (1)     TO MMNL-PHONE
060700         MOVE MMNL-RECORD        TO MS1S-MMNL-RECORD
060800         RELEASE MS1S-RECORD.
060900*
061000     IF  MMOC-STORE-SECONDARY-ON
061100         MOVE SPACES             TO MMNL-RECORD
061200         MOVE ZEROS              TO MMNL-TIE-BREAKER
061300                                    MS1S-TIE-BREAKER
061400         MOVE MMSM-ORG           TO MMNL-ORG
061500         MOVE 'SM'               TO MMNL-FILE-TYPE
061600         MOVE 'S'                TO MMNL-NAME-LOCATION
061700         MOVE MMSM-STORE         TO MMNL-FILE-NBR
061800         MOVE MMSM-NA-LINE (2 1) TO MMNL-NAME
061900                                    MS1S-NAME
062000         MOVE MMSM-NA-LINE (2 2) TO MMNL-ADDR1
062100         EVALUATE TRUE
062200           WHEN  MMSM-NA-LINE (2 5) IS NOT EQUAL TO SPACES
062300             MOVE MMSM-NA-LINE (2 5)
062400                                 TO MMNL-CITY
062500           WHEN  MMSM-NA-LINE (2 4) IS NOT EQUAL TO SPACES
062600             MOVE MMSM-NA-LINE (2 4)
062700                                 TO MMNL-CITY
062800           WHEN  MMSM-NA-LINE (2 3) IS NOT EQUAL TO SPACES
062900             MOVE MMSM-NA-LINE (2 3)
063000                                 TO MMNL-CITY
063100         END-EVALUATE
063200         MOVE MMSM-STATE-CODE (2)
063300                                 TO MMNL-STATE
063400         MOVE MMSM-POSTAL-CODE (2)
063500                                 TO MMNL-POSTAL-CODE
063600         MOVE MMSM-PHONE (2)     TO MMNL-PHONE
063700         MOVE MMNL-RECORD        TO MS1S-MMNL-RECORD
063800         RELEASE MS1S-RECORD.
063900*
064000     IF  MMOC-STORE-DBA-ON
064100         MOVE SPACES             TO MMNL-RECORD
064200         MOVE ZEROS              TO MMNL-TIE-BREAKER
064300                                    MS1S-TIE-BREAKER
064400         MOVE MMSM-ORG           TO MMNL-ORG
064500         MOVE 'SM'               TO MMNL-FILE-TYPE
064600         MOVE 'D'                TO MMNL-NAME-LOCATION
064700         MOVE MMSM-STORE         TO MMNL-FILE-NBR
064800         MOVE MMSM-DBA-NAME      TO MMNL-NAME
064900                                    MS1S-NAME
065000         MOVE MMSM-NA-LINE (1 2) TO MMNL-ADDR1
065100         MOVE MMSM-POSTAL-CODE (1)
065200                                 TO MMNL-POSTAL-CODE
065300         MOVE MMSM-PHONE (1)     TO MMNL-PHONE
065400         MOVE MMSM-DBA-CITY      TO MMNL-CITY
065500         MOVE MMSM-DBA-COUNTRY-CODE
065600                                 TO MMNL-STATE
065700         MOVE MMNL-RECORD        TO MS1S-MMNL-RECORD
065800         RELEASE MS1S-RECORD.
065900*
066000     PERFORM 9200-GET-NEXT-STORE THRU 9299-GNS-EXIT.
066100*
066200 G019-PS-EXIT.
066300     EXIT.
066400 G999-EXIT.
066500     EXIT.
066600/
066700 H000-PROCESS-CHAINS SECTION.
066800 H010-PC-BEGIN.
066900*
067000     IF  MMRCIO-TRAILER
067100         GO TO H019-PC-EXIT.
067200*
067300     IF  MMRC-ORG IS LESS THAN MMOC-ORG
067400         PERFORM 9300-GET-NEXT-CHAIN
067500                                 THRU 9399-GNC-EXIT
067600         GO TO H019-PC-EXIT.
067700*
067800     IF  MMRC-ORG IS NOT EQUAL TO MMOC-ORG
067900         GO TO H019-PC-EXIT.
068000*
068100     IF  MMRC-REC-INCOMPLETE
068200     OR  MMRC-ADD-PENDING
068300     OR  MMRC-REC-PURGED
068400         PERFORM 9300-GET-NEXT-CHAIN
068500                                 THRU 9399-GNC-EXIT
068600         GO TO H019-PC-EXIT.
068700*
068800     IF  MMRC-NA-LINE (1) IS EQUAL TO SPACES
068900         PERFORM 9300-GET-NEXT-CHAIN
069000                                 THRU 9399-GNC-EXIT
069100         GO TO H019-PC-EXIT.
069200*
069300     IF  MMOC-CHAIN-PRIMARY-ON
069400         MOVE SPACES             TO MMNL-RECORD
069500         MOVE ZEROS              TO MMNL-TIE-BREAKER
069600                                    MS1S-TIE-BREAKER
069700         MOVE MMRC-ORG           TO MMNL-ORG
069800         MOVE 'MC'               TO MMNL-FILE-TYPE
069900         MOVE 'P'                TO MMNL-NAME-LOCATION
070000         MOVE MMRC-CHAIN         TO MMNL-FILE-NBR
070100         MOVE MMRC-NA-LINE (1)   TO MMNL-NAME
070200                                    MS1S-NAME
070300         MOVE MMRC-NA-LINE (2)   TO MMNL-ADDR1
070400         EVALUATE TRUE
070500           WHEN  MMRC-NA-LINE (5) IS NOT EQUAL TO SPACES
070600             MOVE MMRC-NA-LINE (5)
070700                                 TO MMNL-CITY
070800           WHEN  MMRC-NA-LINE (4) IS NOT EQUAL TO SPACES
070900             MOVE MMRC-NA-LINE (4)
071000                                 TO MMNL-CITY
071100           WHEN  MMRC-NA-LINE (3) IS NOT EQUAL TO SPACES
071200             MOVE MMRC-NA-LINE (3)
071300                                 TO MMNL-CITY
071400         END-EVALUATE
071500         MOVE MMRC-STATE-CODE    TO MMNL-STATE
071600         MOVE MMRC-POSTAL-CODE   TO MMNL-POSTAL-CODE
071700         MOVE MMRC-PHONE         TO MMNL-PHONE
071800         MOVE MMNL-RECORD        TO MS1S-MMNL-RECORD
071900         RELEASE MS1S-RECORD.
072000*
072100     PERFORM 9300-GET-NEXT-CHAIN THRU 9399-GNC-EXIT.
072200*
072300 H019-PC-EXIT.
072400     EXIT.
072500/
072600 I000-PROCESS-S-CHAINS SECTION.
072700 I010-PC-BEGIN.
072800*
072900     IF  MMSRIO-TRAILER
073000         GO TO I019-PC-EXIT.
073100*
073200     IF  MMSR-ORG IS LESS THAN MMOC-ORG
073300         PERFORM 9400-GET-NEXT-S-CHAIN
073400                                 THRU 9499-GNC-EXIT
073500         GO TO I019-PC-EXIT.
073600*
073700     IF  MMSR-ORG IS NOT EQUAL TO MMOC-ORG
073800         GO TO I019-PC-EXIT.
073900*
074000     IF  MMSR-REC-INCOMPLETE
074100     OR  MMSR-ADD-PENDING
074200     OR  MMSR-REC-PURGED
074300         PERFORM 9400-GET-NEXT-S-CHAIN
074400                                 THRU 9499-GNC-EXIT
074500         GO TO I019-PC-EXIT.
074600*
074700     IF  MMSR-NA-LINE (1) IS EQUAL TO SPACES
074800         PERFORM 9400-GET-NEXT-S-CHAIN
074900                                 THRU 9499-GNC-EXIT
075000         GO TO I019-PC-EXIT.
075100*
075200     IF  MMOC-STORE-CHAIN-PRIMARY-ON
075300         MOVE SPACES             TO MMNL-RECORD
075400         MOVE ZEROS              TO MMNL-TIE-BREAKER
075500                                    MS1S-TIE-BREAKER
075600         MOVE MMSR-ORG           TO MMNL-ORG
075700         MOVE 'SC'               TO MMNL-FILE-TYPE
075800         MOVE 'P'                TO MMNL-NAME-LOCATION
075900         MOVE MMSR-CHAIN         TO MMNL-FILE-NBR
076000         MOVE MMSR-NA-LINE (1)   TO MMNL-NAME
076100                                    MS1S-NAME
076200         MOVE MMSR-NA-LINE (2)   TO MMNL-ADDR1
076300         EVALUATE TRUE
076400           WHEN  MMSR-NA-LINE (5) IS NOT EQUAL TO SPACES
076500             MOVE MMSR-NA-LINE (5)
076600                                 TO MMNL-CITY
076700           WHEN  MMSR-NA-LINE (4) IS NOT EQUAL TO SPACES
076800             MOVE MMSR-NA-LINE (4)
076900                                 TO MMNL-CITY
077000           WHEN  MMSR-NA-LINE (3) IS NOT EQUAL TO SPACES
077100             MOVE MMSR-NA-LINE (3)
077200                                 TO MMNL-CITY
077300         END-EVALUATE
077400         MOVE MMSR-STATE-CODE    TO MMNL-STATE
077500         MOVE MMSR-POSTAL-CODE   TO MMNL-POSTAL-CODE
077600         MOVE MMSR-PHONE         TO MMNL-PHONE
077700         MOVE MMNL-RECORD        TO MS1S-MMNL-RECORD
077800         RELEASE MS1S-RECORD.
077900*
078000     PERFORM 9400-GET-NEXT-S-CHAIN
078100                                 THRU 9499-GNC-EXIT.
078200*
078300 I019-PC-EXIT.
078400     EXIT.
078500 I999-EXIT.
078600     EXIT.
078700*
078800 9000-PERFORMED-ROUTINS-SEC SECTION.
078900 9000-WRITE-MMNL.
079000*
079100     IF  MMNLIO-NAME IS EQUAL TO SPACES
079200         GO TO 9099-WM-EXIT.
079300*
079400     MOVE 'W1NL'                 TO SS02WS-ABEND-LOCATION.
079500     SET MMNLRB-WRITE            TO TRUE.
079600     PERFORM MB00PD-MMNL-ACCESS  THRU MB00PD-MMNL-ACCESS-EXIT.
079700*
079800 9099-WM-EXIT.
079900     EXIT.
080000*
080100 9100-GET-NEXT-MERCHANT.
080200*
080300*
080400     MOVE 'R2MM'                 TO SS02WS-ABEND-LOCATION.
080500     SET MMMMRB-READ-SEQ         TO TRUE.
080600     PERFORM MB00PD-MMMM-ACCESS  THRU MB00PD-MMMM-ACCESS-EXIT.
080700*
080800     IF  MMMMIO-TRAILER
080900         GO TO 9199-GNM-EXIT.
081000*
081100     MOVE MMMMIO-RECORD          TO MMMM-RECORD.
081200*
081300 9199-GNM-EXIT.
081400     EXIT.
081500*
081600 9200-GET-NEXT-STORE.
081700*
081800     MOVE 'R2SM'                 TO SS02WS-ABEND-LOCATION.
081900     SET MMSMRB-READ-SEQ         TO TRUE.
082000     PERFORM MB00PD-MMSM-ACCESS  THRU MB00PD-MMSM-ACCESS-EXIT.
082100*
082200     IF  MMSMIO-TRAILER
082300         GO TO 9299-GNS-EXIT.
082400*
082500     MOVE MMSMIO-RECORD          TO MMSM-RECORD.
082600*
082700 9299-GNS-EXIT.
082800     EXIT.
082900*
083000 9300-GET-NEXT-CHAIN.
083100*
083200     MOVE 'R2RC'                 TO SS02WS-ABEND-LOCATION.
083300     SET MMRCRB-READ-SEQ         TO TRUE.
083400     PERFORM MB00PD-MMRC-ACCESS  THRU MB00PD-MMRC-ACCESS-EXIT.
083500*
083600     IF  MMRCIO-TRAILER
083700         GO TO 9399-GNC-EXIT.
083800*
083900     MOVE MMRCIO-RECORD          TO MMRC-RECORD.
084000*
084100 9399-GNC-EXIT.
084200     EXIT.
084300*
084400 9400-GET-NEXT-S-CHAIN.
084500*
084600     MOVE 'R2SR'                 TO SS02WS-ABEND-LOCATION.
084700     SET MMSRRB-READ-SEQ         TO TRUE.
084800     PERFORM MB00PD-MMSR-ACCESS  THRU MB00PD-MMSR-ACCESS-EXIT.
084900*
085000     IF  MMSRIO-TRAILER
085100         GO TO 9499-GNC-EXIT.
085200*
085300     MOVE MMSRIO-RECORD          TO MMSR-RECORD.
085400*
085500 9499-GNC-EXIT.
085600     EXIT.
085700/
085800/
085900     COPY MB00PD REPLACING ==:MB00:== BY ==MMNL==.
086000/
086100     COPY MB00PD REPLACING ==:MB00:== BY ==MMSM==.
086200/
086300     COPY MB00PD REPLACING ==:MB00:== BY ==MMMM==.
086400/
086500     COPY MB00PD REPLACING ==:MB00:== BY ==MMRC==.
086600/
086700     COPY MB00PD REPLACING ==:MB00:== BY ==MMSR==.
086800/
086900     COPY MB00PD REPLACING ==:MB00:== BY ==MMOC==.
087000/
087100     COPY MB00PD REPLACING ==:MB00:== BY ==MMSC==.
087200/
087300     COPY MB99PD.
087400/
087500     COPY SS02PD.
087600/
087700     COPY SS03PD.
087800/
087900     COPY SS04PD.
088000/
088100     COPY SS06PD.
088200/
088300     COPY SS07PD.
088400/
088500     COPY SS08PD.
088600/
088700     COPY SS09PD.
088800/
088900     COPY SS12PD.
089000/
089100     COPY SS18PD.
089200/
089300     COPY SS26PD.
089400/
089500     COPY SS27PD.
089600/
089700     COPY SS98PD.
089800*
089900 9995-END-SOURCE-STATEMENTS SECTION.
090000 9999-END-OF-PROGRAM.
090100     EXIT.
