000100 IDENTIFICATION DIVISION.
000200 PROGRAM-ID. MBU300.
000201*       RELEASE DATE=08/24/01.        REVISION LEVEL=08.06      *
000202*****************************************************************
000203*WARNING.  THIS COMPUTER PROGRAM IS PROTECTED BY COPYRIGHT LAW  *
000204*AND INTERNATIONAL TREATIES.  UNAUTHORIZED REPRODUCTION OR      *
000205*DISTRIBUTION OF THIS PROGRAM, OR ANY PORTION OF IT, MAY RESULT *
000206*IN SEVERE CIVIL AND CRIMINAL PENATLIES, AND WILL BE PROSECUTED *
000207*TO THE MAXIMUM EXTENT POSSIBLE UNDER THE LAW.                  *
000208*COPYRIGHT 1999 PAYSYS INTERNATIONAL, INC.  ALL RIGHTS RESERVED.*
000209*****************************************************************
000300*****************************************************************
000400*                                                               *
000500*          MBU300 - LABELS PRINT (1 UP THRU 4 UP)               *
000600*                                                               *
000700*****************************************************************
000800*
000900 ENVIRONMENT DIVISION.
001000 CONFIGURATION SECTION.
001100 SOURCE-COMPUTER.   IBM-4341.
001200 OBJECT-COMPUTER.   IBM-4341.
001300/
001400 INPUT-OUTPUT SECTION.
001500 FILE-CONTROL.
001600*
001700/
001800 DATA DIVISION.
001900 FILE SECTION.
002000*
002100/
002200 WORKING-STORAGE SECTION.
002300*
002400 01  FILLER                  PIC  X(12)      VALUE '** WS-BEG **'.
002500*
002600     COPY MB00RB REPLACING ==:MB00:== BY ==MMMM==.
002700/
002800     COPY MMMMIO.
002900/
003000     COPY MMMMRL.
003100/
003200     COPY MB00RB REPLACING ==:MB00:== BY ==MMSM==.
003300/
003400     COPY MMSMIO.
003500/
003600     COPY MMSMRL.
003700/
003800     COPY MB00RB REPLACING ==:MB00:== BY ==MMIC==.
003900/
004000     COPY MMICIO.
004100/
004200     COPY MMICRL.
004300/
004400     COPY MB20WS.
004500*
004600 01  MB20WS-PRT-LINE         REDEFINES MB20WS-PRINT-LINE.
004700     03  FILLER              PIC  X(132).
004800/
004900     COPY MTCCRL REPLACING ==:MTCC:== BY ==MTCC==.
005000/
005100     COPY MB00RB REPLACING ==:MB00:== BY ==MTCC==.
005200/
005300     COPY MTCCIO REPLACING ==:MTCC:== BY ==MTCC==.
005400/
005500     COPY MB00WS.
005600/
005700     COPY MB99WS.
005800/
005900     COPY SS00WS.
006000/
006100     COPY SS01WS.
006200/
006300     COPY SS02WS.
006400/
006500     COPY SS12WS.
006600/
006700 01  WS-WORK-AREAS.
006800     03  WS-PROG-ID          PIC  X(06)      VALUE 'MBU300'.
006900     03  WS-1ST-TIME-SW      PIC  X(01)      VALUE 'Y'.
007000     03  WS-CC-EOF-SW        PIC  X(01)      VALUE 'N'.
007100     03  WS-ORG-MERCH-GROUP.
007200         05  WS-END-ORG      PIC  9(03)      VALUE ZEROS.
007300         05  WS-END-MERCHANT PIC  9(09)      VALUE ZEROS.
007400*
007500*
007600 01  WS-PWA-DATA-FIELDS.
007700     03  WS-INDX-LIN-LIMIT   PIC S9(03)      COMP-3 VALUE +5.
007800     03  WS-INDX-COL-LIMIT   PIC S9(01)      COMP-3 VALUE ZEROS.
007900*
008000 01  WS-PRINT-PAGE.
008100     03  WS-PP-LINE                          OCCURS 5 TIMES
008200                                             INDEXED BY
008300                                             INDX-LIN.
008400         05  WS-PP-COL40                     OCCURS 4 TIMES
008500                                             INDEXED BY
008600                                             INDX-COL
008700                             PIC  X(40).
008800*
008900 01  WS-PRINT-WORK-AREA                      VALUE SPACES.
009000     03  WS-PWA-NAME-ADDR    PIC  X(40).
009100*
009200 01  FILLER                  PIC  X(12)      VALUE '** WS-END **'.
009300/
009400 PROCEDURE DIVISION.
009500*
009600 A000-HOUSEKEEPING.
009700*
009800     SET SS12WS-ENVIRONMENT-BATCH
009900                                 TO TRUE.
010000     SET SS12WS-FUNCTION-INITIALIZE
010100                                 TO TRUE.
010200     PERFORM SS12PD-FORMAT-DEMOGRAPHICS
010300                                 THRU SS12PD-FD-EXIT.
010400*
010500     MOVE 'MBU300'               TO SS02WS-ABEND-PROG-ID.
010600*
010700     PERFORM A100-OPEN-FILES
010800        THRU A199-OF-EXIT.
010900*
011000     PERFORM B100-PROCESS-MTCC
011100        THRU B199-PR-EXIT
011200        UNTIL WS-CC-EOF-SW IS EQUAL TO 'Y'.
011300*
011400     PERFORM MB21PD-PRINT-A-PAGE
011500        THRU MB21PD-PAP-EXIT.
011600*
011700     PERFORM C100-CLOSE-FILES
011800        THRU C199-CF-EXIT.
011900*
012000     STOP RUN.
012100*
012200 A999-HK-EXIT.
012300     EXIT.
012400*
012500*
012600 A100-OPEN-FILES.
012700*
012800     MOVE SS02WS-END-OF-FILE     TO MTCCRB-PERM-STATUS-1.
012900     MOVE 'O1CC'                 TO SS02WS-ABEND-LOCATION.
013000     SET MTCCRB-OPEN-INPUT       TO TRUE.
013100     PERFORM MB00PD-MTCC-ACCESS
013200        THRU MB00PD-MTCC-ACCESS-EXIT.
013300*
013400     MOVE SS02WS-END-OF-FILE     TO MMMMRB-PERM-STATUS-1.
013500     MOVE 'O1MM'                 TO SS02WS-ABEND-LOCATION.
013600     SET MMMMRB-OPEN-INPUT-DYN   TO TRUE.
013700     PERFORM MB00PD-MMMM-ACCESS
013800        THRU MB00PD-MMMM-ACCESS-EXIT.
013900*
014000     MOVE SS02WS-END-OF-FILE     TO MMSMRB-PERM-STATUS-1.
014100     MOVE 'O1SM'                 TO SS02WS-ABEND-LOCATION.
014200     SET MMSMRB-OPEN-INPUT-DYN   TO TRUE.
014300     PERFORM MB00PD-MMSM-ACCESS
014400        THRU MB00PD-MMSM-ACCESS-EXIT.
014500*
014600     MOVE SS02WS-END-OF-FILE     TO MMICRB-PERM-STATUS-1.
014700     MOVE 'O1IC'                 TO SS02WS-ABEND-LOCATION.
014800     SET MMICRB-OPEN-INPUT-DYN   TO TRUE.
014900     PERFORM MB00PD-MMIC-ACCESS
015000        THRU MB00PD-MMIC-ACCESS-EXIT.
015100*
015200     PERFORM MB21PD-PAP-RESET-INDEXES
015300                                 THRU MB21PD-PAP-EXIT.
015400*
015500     MOVE +1                     TO WS-INDX-COL-LIMIT.
015600*
015700     MOVE SPACES                 TO MB20WS-SH-L1.
015800     MOVE SPACES                 TO MB20WS-SH-L2.
015900     MOVE SPACES                 TO MB20WS-SH-L3.
016000     MOVE SPACES                 TO MB20WS-SH-L4.
016100     MOVE SPACES                 TO MB20WS-SH-L5.
016200     MOVE SPACES                 TO MB20WS-SH-L6.
016300     MOVE SPACES                 TO MB20WS-SH-L7.
016400     MOVE SPACES                 TO MB20WS-SH-L8.
016500     MOVE 900                    TO MB20WS-LINE-COUNT.
016600*
016700 A199-OF-EXIT.
016800     EXIT.
016900*
017000*
017100 B100-PROCESS-MTCC.
017200*
017300     MOVE 'R1CC'                 TO SS02WS-ABEND-LOCATION.
017400     SET MTCCRB-READ-SEQ         TO TRUE.
017500     PERFORM MB00PD-MTCC-ACCESS
017600        THRU MB00PD-MTCC-ACCESS-EXIT.
017700*
017800     IF  SS02WS-FS-END-OF-FILE
017900         MOVE 'Y'                TO WS-CC-EOF-SW
018000         GO TO B199-PR-EXIT.
018100*
018200     IF  MTCCIO-PROGRAM-ID  IS NOT EQUAL TO WS-PROG-ID
018300         GO TO B199-PR-EXIT.
018400*
018500     MOVE MTCCIO-CARD-DATA       TO MTCC-RECORD.
018600*
018700     IF  MTCC-MBU300-FI-COLUMNS
018800     AND WS-1ST-TIME-SW EQUAL 'N'
018900         GO TO B199-PR-EXIT.
019000*
019100     IF  WS-1ST-TIME-SW EQUAL 'Y'
019200     AND MTCC-MBU300-FI-COLUMNS
019300         IF  MTCC-MBU300-NBR-OF-COL IS NUMERIC
019400         AND MTCC-MBU300-NBR-OF-COL GREATER THAN ZEROS
019500         AND MTCC-MBU300-NBR-OF-COL IS LESS THAN 5
019600             MOVE MTCC-MBU300-NBR-OF-COL
019700                                 TO WS-INDX-COL-LIMIT
019800             MOVE 'N'            TO WS-1ST-TIME-SW
019900         ELSE
020000             MOVE 'N'            TO WS-1ST-TIME-SW
020100             GO TO B199-PR-EXIT.
020200*
020300*
020400     INSPECT MTCC-MBU300-BEG-X REPLACING ALL SPACE BY ZERO.
020500*
020600     IF  MTCC-MBU300-END-X IS EQUAL TO SPACES
020700         MOVE MTCC-MBU300-BEG-X  TO MTCC-MBU300-END-X.
020800*
020900     INSPECT MTCC-MBU300-END-X REPLACING ALL SPACE BY ZERO.
021000*
021100     IF  MTCC-MBU300-FI-MERCHANT
021200         MOVE MTCC-MBU300-BEG-ORG
021300                                 TO MMMMIO-ORG
021400         MOVE MTCC-MBU300-BEG-MERCHANT
021500                                 TO MMMMIO-MERCHANT
021600         MOVE 'S1MM'             TO SS02WS-ABEND-LOCATION
021700         SET MMMMRB-START-GTE    TO TRUE
021800         PERFORM MB00PD-MMMM-ACCESS
021900            THRU MB00PD-MMMM-ACCESS-EXIT
022000         IF  SS02WS-FS-NO-RECORD-FOUND
022100             PERFORM E100-CARD-ERROR
022200                THRU E199-CE-EXIT
022300             GO TO B199-PR-EXIT
022400         ELSE
022500             MOVE MTCC-MBU300-END-ORG
022600                                 TO WS-END-ORG
022700             MOVE MTCC-MBU300-END-MERCHANT
022800                                 TO WS-END-MERCHANT
022900             PERFORM D100-PROCESS-MMMM
023000                THRU D199-PR-EXIT
023100                UNTIL MMMMIO-ORG-MERCHANT IS GREATER THAN
023200                    WS-ORG-MERCH-GROUP
023300                OR  SS02WS-FS-END-OF-FILE.
023400*
023500     IF  MTCC-MBU300-FI-INVENTORY
023600         MOVE LOW-VALUES         TO MMICIO-KEY
023700         MOVE MTCC-MBU300-BEG-ORG
023800                                 TO MMICIO-ORG
023900         MOVE MTCC-MBU300-BEG-MERCHANT
024000                                 TO MMICIO-MERCHANT
024100         MOVE 'S1IC'             TO SS02WS-ABEND-LOCATION
024200         SET MMICRB-START-GTE    TO TRUE
024300         PERFORM MB00PD-MMIC-ACCESS
024400            THRU MB00PD-MMIC-ACCESS-EXIT
024500         IF  SS02WS-FS-NO-RECORD-FOUND
024600             PERFORM E100-CARD-ERROR
024700                THRU E199-CE-EXIT
024800             GO TO B199-PR-EXIT
024900         ELSE
025000             PERFORM D200-PROCESS-MMIC
025100                THRU D299-PR-EXIT
025200                UNTIL MMICIO-ORG-MERCHANT IS GREATER THAN
025300                    MTCC-MBU300-END-X
025400                OR  SS02WS-FS-END-OF-FILE.
025500*
025600     IF  MTCC-MBU300-FI-STORE
025700         MOVE MTCC-MBU300-BEG-ORG
025800                                 TO MMSMIO-ORG
025900         MOVE MTCC-MBU300-BEG-MERCHANT
026000                                 TO MMSMIO-STORE
026100         MOVE 'S1SM'             TO SS02WS-ABEND-LOCATION
026200         SET MMSMRB-START-GTE    TO TRUE
026300         PERFORM MB00PD-MMSM-ACCESS
026400            THRU MB00PD-MMSM-ACCESS-EXIT
026500         IF  SS02WS-FS-NO-RECORD-FOUND
026600             PERFORM E100-CARD-ERROR
026700                THRU E199-CE-EXIT
026800             GO TO B199-PR-EXIT
026900         ELSE
027000             MOVE MTCC-MBU300-END-ORG
027100                                 TO WS-END-ORG
027200             MOVE MTCC-MBU300-END-MERCHANT
027300                                 TO WS-END-MERCHANT
027400             PERFORM D300-PROCESS-MMSM
027500                THRU D399-PR-EXIT
027600                UNTIL MMSMIO-ORG-STORE IS GREATER THAN
027700                    WS-ORG-MERCH-GROUP
027800                OR  SS02WS-FS-END-OF-FILE.
027900*
028000 B199-PR-EXIT.
028100     EXIT.
028200*
028300*
028400 C100-CLOSE-FILES.
028500*
028600     MOVE 'C1CC'                 TO SS02WS-ABEND-LOCATION.
028700     SET MTCCRB-CLOSE            TO TRUE.
028800     PERFORM MB00PD-MTCC-ACCESS
028900        THRU MB00PD-MTCC-ACCESS-EXIT.
029000*
029100     MOVE 'C1MM'                 TO SS02WS-ABEND-LOCATION.
029200     SET MMMMRB-CLOSE            TO TRUE.
029300     PERFORM MB00PD-MMMM-ACCESS
029400        THRU MB00PD-MMMM-ACCESS-EXIT.
029500*
029600     MOVE 'C1IC'                 TO SS02WS-ABEND-LOCATION.
029700     SET MMICRB-CLOSE            TO TRUE.
029800     PERFORM MB00PD-MMIC-ACCESS
029900        THRU MB00PD-MMIC-ACCESS-EXIT.
030000*
030100     PERFORM MB20PD-CLOSE-PRINT-FILES
030200        THRU MB20PD-CPF-EXIT.
030300*
030400 C199-CF-EXIT.
030500     EXIT.
030600*
030700 D100-PROCESS-MMMM.
030800*
030900     MOVE 'R1MM'                 TO SS02WS-ABEND-LOCATION.
031000     SET MMMMRB-READ-SEQ         TO TRUE.
031100     PERFORM MB00PD-MMMM-ACCESS
031200        THRU MB00PD-MMMM-ACCESS-EXIT.
031300*
031400     IF  MMMMIO-HEADER
031500     OR  MMMMIO-TRAILER
031600     OR  SS02WS-FS-END-OF-FILE
031700         GO TO D199-PR-EXIT.
031800*
031900     MOVE MMMMIO-RECORD          TO MMMM-RECORD.
032000*
032100     IF  MMMM-ADD-PENDING
032200     OR  MMMM-REC-PURGED
032300         GO TO D199-PR-EXIT.
032400*
032500     IF  MMMM-KEY IS GREATER THAN WS-ORG-MERCH-GROUP
032600         GO TO D199-PR-EXIT.
032700*
032800     IF  MMMM-SAC-USE-SECONDARY
032900         SET X-MMMM-DEMOGRAPHICS TO 2
033000     ELSE
033100         SET X-MMMM-DEMOGRAPHICS TO 1.
033200*
033300     MOVE SPACES                 TO SS12WS-NAME-ADDR-GROUP.
033400*
033500     MOVE MMMM-NA-LINE (X-MMMM-DEMOGRAPHICS 1)
033600                                 TO SS12WS-NAME-ADDR (1).
033700     MOVE MMMM-NA-LINE (X-MMMM-DEMOGRAPHICS 2)
033800                                 TO SS12WS-NAME-ADDR (2).
033900     MOVE MMMM-NA-LINE (X-MMMM-DEMOGRAPHICS 3)
034000                                 TO SS12WS-NAME-ADDR (3).
034100     MOVE MMMM-NA-LINE (X-MMMM-DEMOGRAPHICS 4)
034200                                 TO SS12WS-NAME-ADDR (4).
034300     MOVE MMMM-NA-LINE (X-MMMM-DEMOGRAPHICS 5)
034400                                 TO SS12WS-NAME-ADDR (5).
034500     MOVE MMMM-POSTAL-CODE (1)   TO SS12WS-POSTAL-CODE.
034600     MOVE MMMM-STATE-CODE (1)    TO SS12WS-STATE-CODE.
034700     MOVE MMMM-COUNTRY-CODE (1)  TO SS12WS-COUNTRY-CODE.
034800*
034900     PERFORM SS12PD-FORMAT-DEMOGRAPHICS
035000                                 THRU SS12PD-FD-EXIT.
035100*
035200     MOVE SS12WS-MAIL-LINE (1)
035300                                 TO WS-PWA-NAME-ADDR.
035400     PERFORM MB21PD-INSERT-A-COLUMN
035500                                 THRU MB21PD-IAC-EXIT.
035600     MOVE SS12WS-MAIL-LINE (2)
035700                                 TO WS-PWA-NAME-ADDR.
035800     PERFORM MB21PD-INSERT-A-COLUMN
035900                                 THRU MB21PD-IAC-EXIT.
036000     MOVE SS12WS-MAIL-LINE (3)
036100                                 TO WS-PWA-NAME-ADDR.
036200     PERFORM MB21PD-INSERT-A-COLUMN
036300                                 THRU MB21PD-IAC-EXIT.
036400     MOVE SS12WS-MAIL-LINE (4)
036500                                 TO WS-PWA-NAME-ADDR.
036600     PERFORM MB21PD-INSERT-A-COLUMN
036700                                 THRU MB21PD-IAC-EXIT.
036800     MOVE SS12WS-MAIL-LINE (5)
036900                                 TO WS-PWA-NAME-ADDR.
037000*
037100     PERFORM MB21PD-INSERT-A-COLUMN
037200                                 THRU MB21PD-IAC-EXIT.
038400*
038500 D199-PR-EXIT.
038600     EXIT.
038700*
038800*
038900 D200-PROCESS-MMIC.
039000*
039100     MOVE 'R1IC'                 TO SS02WS-ABEND-LOCATION.
039200     SET MMICRB-READ-SEQ         TO TRUE.
039300     PERFORM MB00PD-MMIC-ACCESS
039400        THRU MB00PD-MMIC-ACCESS-EXIT.
039500*
039600     IF  MMICIO-HEADER
039700     OR  MMICIO-TRAILER
039800     OR  SS02WS-FS-END-OF-FILE
039900         GO TO D299-PR-EXIT.
040000*
040100     MOVE MMICIO-RECORD          TO MMIC-RECORD.
040200*
040300     IF  MMIC-ADD-PENDING
040400         GO TO D299-PR-EXIT.
040500*
040600     IF  MMIC-ORG-MERCHANT IS GREATER THAN MTCC-MBU300-END-X
040700         GO TO D299-PR-EXIT.
040800*
040900     IF (MTCC-MBU300-IT-IS-MERCHANT
041000     AND MMIC-TYPE-IS-MERCHANT)
041100     OR
041200        (MTCC-MBU300-IT-IS-STORE
041300     AND MMIC-TYPE-IS-STORE)
041400     OR
041500         MTCC-MBU300-IT-BOTH
041600         NEXT SENTENCE
041700     ELSE
041800         GO TO D299-PR-EXIT.
041900*
042000     IF  MMIC-SAC-USE-SECONDARY
042100         SET X-MMIC-DEMOGRAPHICS TO 2
042200     ELSE
042300         SET X-MMIC-DEMOGRAPHICS TO 1.
042400*
042500     MOVE SPACES                 TO SS12WS-NAME-ADDR-GROUP.
042600*
042700     MOVE MMIC-NA-LINE (X-MMIC-DEMOGRAPHICS 1)
042800                                 TO SS12WS-NAME-ADDR (1).
042900     MOVE MMIC-NA-LINE (X-MMIC-DEMOGRAPHICS 2)
043000                                 TO SS12WS-NAME-ADDR (2).
043100     MOVE MMIC-NA-LINE (X-MMIC-DEMOGRAPHICS 3)
043200                                 TO SS12WS-NAME-ADDR (3).
043300     MOVE MMIC-NA-LINE (X-MMIC-DEMOGRAPHICS 4)
043400                                 TO SS12WS-NAME-ADDR (4).
043500     MOVE MMIC-NA-LINE (X-MMIC-DEMOGRAPHICS 5)
043600                                 TO SS12WS-NAME-ADDR (5).
043700     MOVE MMIC-POSTAL-CODE (1)   TO SS12WS-POSTAL-CODE.
043800     MOVE MMIC-STATE-CODE (1)    TO SS12WS-STATE-CODE.
043900     MOVE MMIC-COUNTRY-CODE (1)  TO SS12WS-COUNTRY-CODE.
044000*
044100     PERFORM SS12PD-FORMAT-DEMOGRAPHICS
044200                                 THRU SS12PD-FD-EXIT.
044300*
044400     MOVE SS12WS-MAIL-LINE (1)
044500                                 TO WS-PWA-NAME-ADDR.
044600     PERFORM MB21PD-INSERT-A-COLUMN
044700                                 THRU MB21PD-IAC-EXIT.
044800     MOVE SS12WS-MAIL-LINE (2)
044900                                 TO WS-PWA-NAME-ADDR.
045000     PERFORM MB21PD-INSERT-A-COLUMN
045100                                 THRU MB21PD-IAC-EXIT.
045200     MOVE SS12WS-MAIL-LINE (3)
045300                                 TO WS-PWA-NAME-ADDR.
045400     PERFORM MB21PD-INSERT-A-COLUMN
045500                                 THRU MB21PD-IAC-EXIT.
045600     MOVE SS12WS-MAIL-LINE (4)
045700                                 TO WS-PWA-NAME-ADDR.
045800     PERFORM MB21PD-INSERT-A-COLUMN
045900                                 THRU MB21PD-IAC-EXIT.
046000     MOVE SS12WS-MAIL-LINE (5)
046100                                 TO WS-PWA-NAME-ADDR.
046200*
046300     PERFORM MB21PD-INSERT-A-COLUMN
046400                                 THRU MB21PD-IAC-EXIT.
047600*
047700 D299-PR-EXIT.
047800     EXIT.
047900*
048000 D300-PROCESS-MMSM.
048100*
048200     MOVE 'R1SM'                 TO SS02WS-ABEND-LOCATION.
048300     SET MMSMRB-READ-SEQ         TO TRUE.
048400     PERFORM MB00PD-MMSM-ACCESS
048500        THRU MB00PD-MMSM-ACCESS-EXIT.
048600*
048700     IF  MMSMIO-HEADER
048800     OR  MMSMIO-TRAILER
048900     OR  SS02WS-FS-END-OF-FILE
049000         GO TO D399-PR-EXIT.
049100*
049200     MOVE MMSMIO-RECORD          TO MMSM-RECORD.
049300*
049400     IF  MMSM-ADD-PENDING
049500     OR  MMSM-REC-PURGED
049600         GO TO D399-PR-EXIT.
049700*
049800     IF  MMSM-KEY IS GREATER THAN WS-ORG-MERCH-GROUP
049900         GO TO D399-PR-EXIT.
050000*
050100     IF  MMSM-SAC-USE-SECONDARY
050200         SET X-MMSM-DEMOGRAPHICS TO 2
050300     ELSE
050400         SET X-MMSM-DEMOGRAPHICS TO 1.
050500*
050600     MOVE SPACES                 TO SS12WS-NAME-ADDR-GROUP.
050700*
050800     MOVE MMSM-NA-LINE (X-MMSM-DEMOGRAPHICS 1)
050900                                 TO SS12WS-NAME-ADDR (1).
051000     MOVE MMSM-NA-LINE (X-MMSM-DEMOGRAPHICS 2)
051100                                 TO SS12WS-NAME-ADDR (2).
051200     MOVE MMSM-NA-LINE (X-MMSM-DEMOGRAPHICS 3)
051300                                 TO SS12WS-NAME-ADDR (3).
051400     MOVE MMSM-NA-LINE (X-MMSM-DEMOGRAPHICS 4)
051500                                 TO SS12WS-NAME-ADDR (4).
051600     MOVE MMSM-NA-LINE (X-MMSM-DEMOGRAPHICS 5)
051700                                 TO SS12WS-NAME-ADDR (5).
051800     MOVE MMSM-POSTAL-CODE (1)   TO SS12WS-POSTAL-CODE.
051900     MOVE MMSM-STATE-CODE (1)    TO SS12WS-STATE-CODE.
052000     MOVE MMSM-COUNTRY-CODE (1)  TO SS12WS-COUNTRY-CODE.
052100*
052200     PERFORM SS12PD-FORMAT-DEMOGRAPHICS
052300                                 THRU SS12PD-FD-EXIT.
052400*
052500     MOVE SS12WS-MAIL-LINE (1)
052600                                 TO WS-PWA-NAME-ADDR.
052700     PERFORM MB21PD-INSERT-A-COLUMN
052800                                 THRU MB21PD-IAC-EXIT.
052900     MOVE SS12WS-MAIL-LINE (2)
053000                                 TO WS-PWA-NAME-ADDR.
053100     PERFORM MB21PD-INSERT-A-COLUMN
053200                                 THRU MB21PD-IAC-EXIT.
053300     MOVE SS12WS-MAIL-LINE (3)
053400                                 TO WS-PWA-NAME-ADDR.
053500     PERFORM MB21PD-INSERT-A-COLUMN
053600                                 THRU MB21PD-IAC-EXIT.
053700     MOVE SS12WS-MAIL-LINE (4)
053800                                 TO WS-PWA-NAME-ADDR.
053900     PERFORM MB21PD-INSERT-A-COLUMN
054000                                 THRU MB21PD-IAC-EXIT.
054100     MOVE SS12WS-MAIL-LINE (5)
054200                                 TO WS-PWA-NAME-ADDR.
054300     PERFORM MB21PD-INSERT-A-COLUMN
054400                                 THRU MB21PD-IAC-EXIT.
055500*
055600 D399-PR-EXIT.
055700     EXIT.
055800*
055900 E100-CARD-ERROR.
056000*
056100     MOVE MTCC-RECORD            TO WS-PP-LINE (4).
056200     MOVE 'CONTROL CARD ERROR'   TO WS-PP-COL40 (4 3).
056300     PERFORM MB21PD-PRINT-A-PAGE
056400        THRU MB21PD-PAP-EXIT.
056500     MOVE SPACE                  TO WS-PP-LINE (4).
056600     MOVE SPACE                  TO WS-PP-COL40 (4 3).
056700*
056800 E199-CE-EXIT.
056900     EXIT.
057000/
057100 MB21PD-INSERT-A-COLUMN.
057200 MB21PD-IAC-BEGIN.
057300*
057400     SET INDX-LIN                UP BY 1.
057500*
057600     IF  INDX-LIN IS GREATER THAN WS-INDX-LIN-LIMIT
057700         SET INDX-LIN            TO 1
057800         SET INDX-COL            UP BY 1.
057900*
058000     IF  INDX-COL IS GREATER THAN WS-INDX-COL-LIMIT
058100         PERFORM MB21PD-PRINT-A-PAGE
058200                                 THRU MB21PD-PAP-EXIT
058300         GO TO MB21PD-IAC-BEGIN.
058400*
058500     MOVE WS-PRINT-WORK-AREA     TO WS-PP-COL40
058600                                 (INDX-LIN INDX-COL).
058700     MOVE SPACES                 TO WS-PRINT-WORK-AREA.
058800*
058900 MB21PD-IAC-EXIT.
059000     EXIT.
059100*
059200* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
059300*     PRINT DOES NOT OCCUR UNTIL A FULL PAGE OF DATA OR         *
059400*     A CHANGE OF RECORD IS OBTAINED                            *
059500* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
059600 MB21PD-PRINT-A-PAGE.
059700 MB21PD-PAP-BEGIN.
059800*
059900     SET INDX-LIN                TO 1.
060000     MOVE SPACES                 TO MB20WS-PRT-LINE.
060100     PERFORM MB20PD-PRINT-1-LINE THRU MB20PD-P1L-EXIT.
060200     MOVE ZERO                   TO MB20WS-LINE-COUNT.
060300*
060400 MB21PD-PAP-LOOP.
060500*
060600     IF  INDX-LIN IS GREATER THAN WS-INDX-LIN-LIMIT
060700         GO TO MB21PD-PAP-RESET-INDEXES.
060800*
060900     MOVE WS-PP-LINE (INDX-LIN)  TO MB20WS-PRT-LINE.
061000     PERFORM MB20PD-PRINT-1-LINE THRU MB20PD-P1L-EXIT.
061100     SET INDX-LIN                UP BY 1.
061200     GO TO MB21PD-PAP-LOOP.
061300*
061400 MB21PD-PAP-RESET-INDEXES.
061500*
061600     SET INDX-LIN                TO 1.
061700     SET INDX-LIN                DOWN BY 1.
061800     SET INDX-COL                TO 1.
061900     MOVE SPACES                 TO WS-PRINT-PAGE.
062000*
062100 MB21PD-PAP-EXIT.
062200     EXIT.
062300/
062400     COPY MB00PD REPLACING ==:MB00:== BY ==MMMM==.
062500/
062600     COPY MB00PD REPLACING ==:MB00:== BY ==MMSM==.
062700/
062800     COPY MB00PD REPLACING ==:MB00:== BY ==MMIC==.
062900/
063000     COPY MB00PD REPLACING ==:MB00:== BY ==MTCC==.
063100/
063200     COPY MB20PD.
063300/
063400     COPY SS02PD.
063500/
063600     COPY SS08PD.
063700/
063800     COPY SS12PD.
063900/
064000     COPY SS16PD.
064100/
064200     COPY SS26PD.
064300/
064400     COPY SS27PD.
