000100 IDENTIFICATION DIVISION.
000200 PROGRAM-ID. MBU381.
000201*       RELEASE DATE=08/24/01.        REVISION LEVEL=08.06      *
000202*****************************************************************
000203*WARNING.  THIS COMPUTER PROGRAM IS PROTECTED BY COPYRIGHT LAW  *
000204*AND INTERNATIONAL TREATIES.  UNAUTHORIZED REPRODUCTION OR      *
000205*DISTRIBUTION OF THIS PROGRAM, OR ANY PORTION OF IT, MAY RESULT *
000206*IN SEVERE CIVIL AND CRIMINAL PENATLIES, AND WILL BE PROSECUTED *
000207*TO THE MAXIMUM EXTENT POSSIBLE UNDER THE LAW.                  *
000208*COPYRIGHT 1999 PAYSYS INTERNATIONAL, INC.  ALL RIGHTS RESERVED.*
000209*****************************************************************
000300*****************************************************************
000400*                                                               *
000500*   V - PLUS  M E R C H A N T   B A N K C A R D   S Y S T E M   *
000600*                                                               *
000700*       MBU381 - CHAIN MANAGEMENT REPORT                        *
000800*                                                               *
000900*****************************************************************
001000 ENVIRONMENT DIVISION.
001100 CONFIGURATION SECTION.
001200 SOURCE-COMPUTER.            IBM-4341.
001300 OBJECT-COMPUTER.            IBM-4341.
001400/
001500 INPUT-OUTPUT SECTION.
001600 FILE-CONTROL.
001700     COPY MS1SES.
001800*
001900     COPY MS2SES.
002000*
002100     COPY MS3SES.
002200/
002300 DATA DIVISION.
002400 FILE SECTION.
002500     COPY MS1SSD.
002600     COPY MMPARL REPLACING ==:MMPA:== BY ==MWPA==.
002700/
002800     COPY MS2SSD.
002900     COPY MMPARL REPLACING ==:MMPA:== BY ==MWOI==.
003000/
003100     COPY MS3SSD.
003200     COPY MMPARL REPLACING ==:MMPA:== BY ==MWCP==.
003300/
003400 WORKING-STORAGE SECTION.
003500*
003600 01  FILLER                  PIC  X(12)      VALUE '** WS-BEG **'.
003700/
003800 01  WS-MBU381-WORK-AREAS.
003900     03  WS-PROG-ID          PIC  X(06)      VALUE 'MBU381'.
004000     03  WS-SORT-ORG         PIC  9(03)      VALUE ZERO.
004100     03  WS-KEY-TYPE         PIC  9(01)      VALUE ZERO.
004200     03  WS-PREV-PROD        PIC  9(02)      VALUE ZERO.
004300     03  WS-CTA              PIC  9(03)      VALUE ZERO.
004400     03  WS-PREV-PLAN        PIC  9(05)      VALUE ZERO.
004500     03  WS-U381-RPT-REC-TYPE
004600                             PIC  9(01)      VALUE ZERO.
004700     03  WS-U381-QL-DISPLAY-X.
004800         05  WS-U381-QL-DISPLAY
004900                             PIC  9(02)      VALUE ZERO.
005000     03  WS-U381-CP-DISPLAY-X.
005100         05  WS-U381-CP-DISPLAY
005200                             PIC  9(05)      VALUE ZERO.
005300     03  WS-RPT-PROCESSING-SW
005400                             PIC  X(01)      VALUE 'Y'.
005500         88  WS-RPT-PROCESS                  VALUE 'Y'.
005600         88  WS-NO-RPT-PROCESS               VALUE 'N'.
005700     03  WS-1ST-TIME-CP-TOT-SW
005800                             PIC  X(01)      VALUE 'Y'.
005900         88  WS-1ST-TIME-CP-TOT-ON           VALUE 'Y'.
006000         88  WS-1ST-TIME-CP-TOT-OFF          VALUE 'N'.
006100     03  WS-1ST-TIME-CP-HD-SW
006200                             PIC  X(01)      VALUE 'Y'.
006300         88  WS-1ST-TIME-CP-HD-ON            VALUE 'Y'.
006400         88  WS-1ST-TIME-CP-HD-OFF           VALUE 'N'.
006500     03  WS-1ST-TIME-CP-PROD-HD-SW
006600                             PIC  X(01)      VALUE 'Y'.
006700         88  WS-1ST-TIME-CP-PROD-HD-ON       VALUE 'Y'.
006800         88  WS-1ST-TIME-CP-PROD-HD-OFF      VALUE 'N'.
006900/
007000 01  WS-PROD-TOTALS-AREA.
007100     03  WS-PTA-TABLE                        OCCURS 101 TIMES
007200                                             INDEXED BY
007300                                             X-WS-PTA.
007400         05  WS-PTA-ACTIVITY-SW
007500                             PIC  X(01).
007600             88  WS-PTA-NO-ACTIVITY          VALUE 'N' SPACE.
007700             88  WS-PTA-ACTIVITY             VALUE 'Y'.
007800         05  WS-PTA-NBR-AMT                  OCCURS 3 TIMES
007900                                             INDEXED BY
008000                                             X-PTA-NBR-AMT.
008100             07 WS-PTA-SALE-NBR
008200                             PIC S9(11)      COMP-3.
008300             07 WS-PTA-SALE-AMT
008400                             PIC S9(17)      COMP-3.
008500             07 WS-PTA-RETURN-NBR
008600                             PIC S9(11)      COMP-3.
008700             07 WS-PTA-RETURN-AMT
008800                             PIC S9(17)      COMP-3.
008900             07 WS-PTA-TOTAL-INCOME
009000                             PIC S9(17)      COMP-3.
009100/
009200 01  WS-QL-TOTALS-AREA.
009300     03  WS-QTA-TABLE                        OCCURS 101 TIMES
009400                                             INDEXED BY
009500                                             X-WS-QTA.
009600         05  WS-QTA-PROD-ACTIVITY-SW
009700                             PIC  X(01).
009800             88  WS-QTA-PROD-NO-ACTIVITY     VALUE 'N' SPACE.
009900             88  WS-QTA-PROD-ACTIVITY        VALUE 'Y'.
010000*
010100         05  WS-QTA-QL-TABLE                 OCCURS 99 TIMES
010200                                             INDEXED BY
010300                                             X-WS-QTA-QL.
010400             07  WS-QTA-ACTIVITY-SW
010500                             PIC  X(01).
010600                 88  WS-QTA-NO-ACTIVITY      VALUE 'N' SPACE.
010700                 88  WS-QTA-ACTIVITY         VALUE 'Y'.
010800             07  WS-QTA-NBR-AMT              OCCURS 3 TIMES
010900                                             INDEXED BY
011000                                             X-QTA-NBR-AMT.
011100                 09 WS-QTA-SALE-NBR
011200                             PIC S9(11)      COMP-3.
011300                 09 WS-QTA-SALE-AMT
011400                             PIC S9(17)      COMP-3.
011500                 09 WS-QTA-RETURN-NBR
011600                             PIC S9(11)      COMP-3.
011700                 09 WS-QTA-RETURN-AMT
011800                             PIC S9(17)      COMP-3.
011900/
012000 01  WS-CP-TOTALS-AREA.
012100     03  WS-CTA-NBR-AMT                      OCCURS 3 TIMES
012200                                             INDEXED BY
012300                                             X-CTA-NBR-AMT.
012400         05 WS-CTA-SALE-NBR  PIC S9(11)      COMP-3.
012500         05 WS-CTA-SALE-AMT  PIC S9(17)      COMP-3.
012600         05 WS-CTA-RETURN-NBR
012700                             PIC S9(11)      COMP-3.
012800         05 WS-CTA-RETURN-AMT
012900                             PIC S9(17)      COMP-3.
013000/
013100 01  WS-HIST-TOTALS-AREA.
013200     03  WS-HTA-TABLE                        OCCURS 12 TIMES
013300                                             INDEXED BY
013400                                             X-WS-HTA.
013500         05  WS-HTA-SALE-NBR
013600                             PIC S9(11)      COMP-3.
013700         05  WS-HTA-SALE-AMT
013800                             PIC S9(17)      COMP-3.
013900         05  WS-HTA-RETURN-NBR
014000                             PIC S9(11)      COMP-3.
014100         05  WS-HTA-RETURN-AMT
014200                             PIC S9(17)      COMP-3.
014300         05  WS-HTA-REC-ADJ-NBR
014400                             PIC S9(11)      COMP-3.
014500         05  WS-HTA-REC-ADJ-AMT
014600                             PIC S9(17)      COMP-3.
014700         05  WS-HTA-ADJ-NBR
014800                             PIC S9(11)      COMP-3.
014900         05  WS-HTA-ADJ-AMT
015000                             PIC S9(17)      COMP-3.
015100         05  WS-HTA-TOTAL-INCOME
015200                             PIC S9(17)      COMP-3.
015300/
015400*
015500 01  WS-U381-TABLE.
015600     03  WS-U381-ORG-RANGES-TABLE-X.
015700         05  WS-U381-ORG-RANGES-TABLE        OCCURS 999 TIMES
015800                                             INDEXED BY
015900                                             X-WS-U381-ORT.
016000             07  WS-U381-ORT-BEG-ORG-CHAIN.
016100                 88  WS-U381-ORT-END-OF-TABLE
016200                                             VALUE '999999999999'.
016300                 09  WS-U381-ORT-BEG-ORG-X.
016400                     11  WS-U381-ORT-BEG-ORG
016500                             PIC  9(03)      VALUE 999.
016600                 09  WS-U381-ORT-BEG-MERCH-X.
016700                     11  WS-U381-ORT-BEG-MERCH
016800                             PIC  9(09)      VALUE 999999999.
016900             07  WS-U381-ORT-END-ORG-CHAIN.
017000                 09  WS-U381-ORT-END-ORG-X.
017100                     11  WS-U381-ORT-END-ORG
017200                             PIC  9(03)      VALUE 999.
017300                 09  WS-U381-ORT-BEG-MERCH-X.
017400                     11  WS-U381-ORT-END-MERCH
017500                             PIC  9(09)      VALUE 999999999.
017600/
017700     COPY MMSCIO.
017800/
017900     COPY MB00RB REPLACING ==:MB00:== BY ==MMSC==.
018000/
018100     COPY MMSCRL.
018200/
018300     COPY MTCCRL REPLACING ==:MTCC:== BY ==MTC1==.
018400/
018500     COPY MTCCIO REPLACING ==:MTCC:== BY ==MTCC==.
018600/
018700     COPY MB00RB REPLACING ==:MB00:== BY ==MTCC==.
018800/
018900     COPY MMOCIO.
019000/
019100     COPY MB00RB REPLACING ==:MB00:== BY ==MMOC==.
019200/
019300     COPY MMOCRL.
019400/
019500     COPY MMRCIO.
019600/
019700     COPY MMRCIR.
019800/
019900     COPY MB00RB REPLACING ==:MB00:== BY ==MMRC==.
020000/
020100     COPY MMRCRL.
020200/
020300     COPY MMRCWS.
020400/
020500     COPY MMPAIO REPLACING ==:MMPA:== BY ==MMCG==.
020600/
020700     COPY MMPAIR REPLACING ==:MMPA:== BY ==MMCG==.
020800/
020900     COPY MB00RB REPLACING ==:MB00:== BY ==MMCG==.
021000/
021100     COPY MMPARL REPLACING ==:MMPA:== BY ==MMCG==.
021200/
021300     COPY MMPAIO REPLACING ==:MMPA:== BY ==MMOG==.
021400/
021500     COPY MMPAIR REPLACING ==:MMPA:== BY ==MMOG==.
021600/
021700     COPY MB00RB REPLACING ==:MB00:== BY ==MMOG==.
021800/
021900     COPY MMPARL REPLACING ==:MMPA:== BY ==MMOG==.
022000/
022100     COPY MMPARL REPLACING ==:MMPA:== BY ==MTCP==.
022200/
022300     COPY MMPARL REPLACING ==:MMPA:== BY ==MTOI==.
022400/
022500     COPY MMPAIO REPLACING ==:MMPA:== BY ==MMPG==.
022600/
022700     COPY MMPAIR REPLACING ==:MMPA:== BY ==MMPG==.
022800/
022900     COPY MB00RB REPLACING ==:MB00:== BY ==MMPG==.
023000/
023100     COPY MMPARL REPLACING ==:MMPA:== BY ==MMPG==.
023200/
023300     COPY MMPARL REPLACING ==:MMPA:== BY ==MTPA==.
023400/
023500     COPY MTCCRL REPLACING ==:MTCC:== BY ==MTCC==.
023600/
023700     COPY MTRFRL REPLACING ==:MTRF:== BY ==MTRF==.
023800/
023900     COPY MTRFIO REPLACING ==:MTRF:== BY ==MTRF==.
024000/
024100     COPY MB00RB REPLACING ==:MB00:== BY ==MTRF==.
024200/
024300     COPY MTRFWS REPLACING ==:MTRF:== BY ==MTRF==.
024400/
024500     COPY MMPAIO REPLACING ==:MMPA:== BY ==MWCP==.
024600/
024700     COPY MB00RB REPLACING ==:MB00:== BY ==MWCP==.
024800/
024900     COPY MMPAIO REPLACING ==:MMPA:== BY ==MWOI==.
025000/
025100     COPY MB00RB REPLACING ==:MB00:== BY ==MWOI==.
025200/
025300     COPY MMPAIO REPLACING ==:MMPA:== BY ==MWPA==.
025400/
025500     COPY MB00RB REPLACING ==:MB00:== BY ==MWPA==.
025600/
025700     COPY MMTCWS.
025800/
025900     COPY MB00WS.
026000/
026100     COPY MB80WS.
026200/
026300     COPY MB99WS.
026400/
026500     COPY MB00RB REPLACING ==:MB00:== BY ==MS1S==.
026600/
026700     COPY MB00RB REPLACING ==:MB00:== BY ==MS2S==.
026800/
026900     COPY MB00RB REPLACING ==:MB00:== BY ==MS3S==.
027000/
027100     COPY SS00WS.
027200/
027300     COPY SS01WS.
027400/
027500     COPY SS02WS.
027600/
027700 PROCEDURE DIVISION.
027800 A000-MAIN-LINE-SECT SECTION.
027900 A010-ML-BEGIN.
028000*
028100     MOVE 'MBU381'               TO SS02WS-ABEND-PROG-ID.
028200*
028300     MOVE SS02WS-END-OF-FILE     TO MTCCRB-PERM-STATUS-1.
028400     MOVE SPACES                 TO MTC1-RECORD.
028500*
028600     SET MMOCRB-OPEN-INPUT-DYN   TO TRUE.
028700     MOVE 'O1OC'                 TO SS02WS-ABEND-LOCATION.
028800     PERFORM MB00PD-MMOC-ACCESS  THRU MB00PD-MMOC-ACCESS-EXIT.
028900*
029000     SET MMSCRB-OPEN-INPUT       TO TRUE.
029100     MOVE 'O1SC'                 TO SS02WS-ABEND-LOCATION.
029200     PERFORM MB00PD-MMSC-ACCESS  THRU MB00PD-MMSC-ACCESS-EXIT.
029300*
029400     MOVE 'R0SC'                 TO SS02WS-ABEND-LOCATION.
029500     SET MMSCRB-READ-SEQ         TO TRUE.
029600     PERFORM MB00PD-MMSC-ACCESS
029700        THRU MB00PD-MMSC-ACCESS-EXIT.
029800*
029900     MOVE 'MMSC'                 TO MB99WS-FILE-ID.
030000*
030100     IF  MMSCIO-HEADER
030200         NEXT SENTENCE
030300     ELSE
030400         PERFORM MB99PD-MISSING-HEADER-ABEND
030500            THRU MB99PD-MHA-EXIT.
030600*
030700     MOVE MMSCIO-RECORD          TO MMSC-RECORD.
030800*
030900     MOVE MMSC-TODAYS-JULIAN     TO MB99WS-PROC-DATE.
031000     MOVE MMSC-TIME-STAMP        TO MB99WS-PROC-TIME.
031100*
031200     PERFORM A200-GET-CC-OPTIONS
031300        THRU A299-GCCO-EXIT.
031400*
031500     IF  WS-RPT-PROCESS
031600         PERFORM A300-GET-CC-RANGES
031700            THRU A399-GCCR-EXIT
031800         PERFORM A500-BUILD-REPORT
031900            THRU A599-BR-EXIT.
032000*
032100     SET MMOCRB-CLOSE            TO TRUE.
032200     MOVE 'C1OC'                 TO SS02WS-ABEND-LOCATION.
032300     PERFORM MB00PD-MMOC-ACCESS  THRU MB00PD-MMOC-ACCESS-EXIT.
032400*
032500     SET MMSCRB-CLOSE            TO TRUE.
032600     MOVE 'C1SC'                 TO SS02WS-ABEND-LOCATION.
032700     PERFORM MB00PD-MMSC-ACCESS  THRU MB00PD-MMSC-ACCESS-EXIT.
032800*
032900     STOP RUN.
033000*
033100 A099-MLS-EXIT.
033200     EXIT.
033300*
033400/
033500 A200-GET-CC-OPTIONS SECTION.
033600 A201-GCCO-BEGIN.
033700*
033800     SET MTCCRB-OPEN-INPUT       TO TRUE.
033900     MOVE 'O1CC'                 TO SS02WS-ABEND-LOCATION.
034000     PERFORM MB00PD-MTCC-ACCESS  THRU MB00PD-MTCC-ACCESS-EXIT.
034100*
034200 A210-GCCO-READ-MTCC.
034300*
034400     SET MTCCRB-READ-SEQ         TO TRUE.
034500     MOVE 'R1CC'                 TO SS02WS-ABEND-LOCATION.
034600     PERFORM MB00PD-MTCC-ACCESS  THRU MB00PD-MTCC-ACCESS-EXIT.
034700*
034800     IF  SS02WS-FS-END-OF-FILE
034900         GO TO A290-GCCO-CLOSE-FILE.
035000*
035100     IF  MTCCIO-PROGRAM-ID IS NOT EQUAL TO WS-PROG-ID
035200         GO TO A210-GCCO-READ-MTCC.
035300*
035400     MOVE MTCCIO-RECORD          TO MTCC-RECORD.
035500*
035600     PERFORM
035700         VARYING X-MTCC-MBU380-HIST FROM 1 BY 1
035800         UNTIL X-MTCC-MBU380-HIST IS GREATER THAN 3
035900         IF  MTCC-MBU380-HIST-PERIOD (X-MTCC-MBU380-HIST)
036000                                 IS NOT NUMERIC
036100         OR  NOT MTCC-MBU380-VALID-HIST (X-MTCC-MBU380-HIST)
036200             EVALUATE TRUE
036300                 WHEN X-MTCC-MBU380-HIST IS EQUAL TO 1
036400                     MOVE 16     TO MTCC-MBU380-HIST-PERIOD
036500                                    (X-MTCC-MBU380-HIST)
036600                 WHEN X-MTCC-MBU380-HIST IS EQUAL TO 2
036700                     MOVE 14     TO MTCC-MBU380-HIST-PERIOD
036800                                    (X-MTCC-MBU380-HIST)
036900                 WHEN X-MTCC-MBU380-HIST IS EQUAL TO 3
037000                     MOVE 15     TO MTCC-MBU380-HIST-PERIOD
037100                                    (X-MTCC-MBU380-HIST)
037200             END-EVALUATE
037300         END-IF
037400     END-PERFORM.
037500*
037600     IF  NOT MTCC-MBU380-VALID-PROD
037700         SET MTCC-MBU380-PROD-DET
037800                                 TO TRUE.
037900*
038000     IF  NOT MTCC-MBU380-VALID-QUAL
038100         SET MTCC-MBU380-QUAL-DET
038200                                 TO TRUE.
038300*
038400     IF  NOT MTCC-MBU380-VALID-PLAN
038500         SET MTCC-MBU380-PLAN-DET
038600                                 TO TRUE.
038700*
038800     IF  NOT MTCC-MBU380-VALID-HIST-SEC
038900         SET MTCC-MBU380-HIST-YES
039000                                 TO TRUE.
039100*
039200     IF  MTCC-MBU380-FREQ IS NUMERIC
039300     AND
039400        (MTCC-MBU380-ON-REQUEST
039500     OR  MTCC-MBU380-WEEKLY
039600     OR  MTCC-MBU380-MONTHLY)
039700         NEXT SENTENCE
039800     ELSE
039900         MOVE 99                 TO MTCC-MBU380-FREQ.
040000*
040100     IF (MTCC-MBU380-DETAIL-OPTION
040200     OR  MTCC-MBU380-ORG-OPTION
040300     OR  MTCC-MBU380-SYSTEM-OPTION)
040400     AND
040500        (MTCC-MBU380-ON-REQUEST
040600     OR  MTCC-MBU380-WEEKLY
040700     OR  MTCC-MBU380-MONTHLY)
040800         MOVE MTCCIO-RECORD      TO MTC1-RECORD
040900     ELSE
041000         GO TO A210-GCCO-READ-MTCC.
041100*
041200 A290-GCCO-CLOSE-FILE.
041300*
041400     IF  MTC1-RECORD IS EQUAL TO SPACES
041500         MOVE 'MD99'             TO MTCC-RECORD
041600         MOVE WS-PROG-ID         TO MTCC-PROGRAM-ID
041700         MOVE MTCC-RECORD        TO MTC1-RECORD.
041800*
041900     MOVE MTCC-RECORD            TO MTC1-RECORD.
042000*
042100     SET MTCCRB-CLOSE            TO TRUE.
042200     MOVE 'C1CC'                 TO SS02WS-ABEND-LOCATION.
042300     PERFORM MB00PD-MTCC-ACCESS  THRU MB00PD-MTCC-ACCESS-EXIT.
042400*
042500     MOVE MTC1-RECORD            TO MTCC-RECORD.
042600*****************************************************************
042700*    CHECK CONTROL CARD FOR REPORT FREQUENCY. VALID ENTRIES:
042800*        ... 99 RUN REPORT (DEFAULT WHEN NONE OF THE FOLLOWING)
042900*        ... 1-31 DAY OF THE MONTH
043000*                DAY SELECTED IS GREATER THAN OR EQUAL TO THE
043100*                SYSTEM CONTROL TODAYS JULIAN AND LESS THAN
043200*                THE SYSTEM CONTROL NEXT PROCESSING DATE
043300*        ... 41-47 DAY OF THE WEEK
043400*                DAY SELECTED IS INDICATED BY THE LAST DIGIT
043500*                (1-7) WITH 1 BEING SUNDAY. IT IS COMPARED TO
043600*                THE SYSTEM CONTROL TODAYS JULIAN DAY.
043700*****************************************************************
043800*
043900     MOVE MMSC-TODAYS-JULIAN     TO SS01WS-JULIAN.
044000*
044100     EVALUATE TRUE
044200         WHEN MTCC-MBU380-ON-REQUEST
044300              CONTINUE
044400         WHEN MTCC-MBU380-WEEKLY
044500              PERFORM SS06PD-DAY-OF-WEEK
044600                                 THRU SS06PD-DOW-EXIT
044700              COMPUTE SS01WS-DOW
044800                                 = SS01WS-DOW + 1
044900              EVALUATE TRUE
045000                  WHEN SS01WS-DOW IS NOT EQUAL TO
045100                                 MTCC-MBU380-FREQ-DOW
045200                      SET WS-NO-RPT-PROCESS
045300                                 TO TRUE
045400              END-EVALUATE
045500         WHEN OTHER
045600              MOVE ZERO          TO SS01WS-FREQ
045700              MOVE 'M'           TO SS01WS-PERIOD
045800              MOVE MTCC-MBU380-FREQ
045900                                 TO SS01WS-DAY-OF-MON
046000              PERFORM SS03PD-FUTURE-DATE
046100                                 THRU SS03PD-FD-EXIT
046200              EVALUATE TRUE
046300                  WHEN SS01WS-JULIAN IS LESS THAN
046400                                 MMSC-TODAYS-JULIAN
046500                  WHEN SS01WS-JULIAN IS NOT LESS THAN
046600                                 MMSC-DATE-NEXT-PROC
046700                       SET WS-NO-RPT-PROCESS
046800                                 TO TRUE
046900              END-EVALUATE
047000     END-EVALUATE.
047100*
047200 A299-GCCO-EXIT.
047300     EXIT.
047400/
047500 A300-GET-CC-RANGES SECTION.
047600 A301-GCCR-BEGIN.
047700*
047800     SET X-WS-U381-ORT           TO 1.
047900     MOVE ZERO                   TO WS-U381-ORT-BEG-ORG (1).
048000     MOVE ZERO                   TO WS-U381-ORT-BEG-MERCH (1).
048100*
048200     SET MTCCRB-OPEN-INPUT       TO TRUE.
048300     MOVE 'O2CC'                 TO SS02WS-ABEND-LOCATION.
048400     PERFORM MB00PD-MTCC-ACCESS  THRU MB00PD-MTCC-ACCESS-EXIT.
048500*
048600 A310-GCCR-READ-MTCC.
048700*
048800     SET MTCCRB-READ-SEQ         TO TRUE.
048900     MOVE 'R2CC'                 TO SS02WS-ABEND-LOCATION.
049000     PERFORM MB00PD-MTCC-ACCESS  THRU MB00PD-MTCC-ACCESS-EXIT.
049100*
049200     IF  SS02WS-FS-END-OF-FILE
049300         GO TO A390-GCCR-CLOSE-FILE.
049400*
049500     IF  MTCCIO-PROGRAM-ID IS NOT EQUAL TO WS-PROG-ID
049600         GO TO A310-GCCR-READ-MTCC.
049700*
049800     MOVE MTCCIO-RECORD          TO MTCC-RECORD.
049900*
050000     IF  MTCC-MBU380-DETAIL-OPTION
050100     OR  MTCC-MBU380-ORG-OPTION
050200     OR  MTCC-MBU380-SYSTEM-OPTION
050300         GO TO A310-GCCR-READ-MTCC.
050400*
050500     IF  MTCC-MBU380-END-ORG-X   IS EQUAL TO SPACES
050600     AND MTCC-MBU380-END-MERCH-X IS EQUAL TO SPACES
050700         MOVE MTCC-MBU380-BEG-ORG-X
050800                                 TO MTCC-MBU380-END-ORG-X
050900         MOVE MTCC-MBU380-BEG-MERCH-X
051000                                 TO MTCC-MBU380-END-MERCH-X.
051100*
051200     IF  MTCC-MBU380-BEG-ORG   IS NUMERIC
051300     AND MTCC-MBU380-BEG-MERCH IS NUMERIC
051400     AND MTCC-MBU380-END-ORG   IS NUMERIC
051500     AND MTCC-MBU380-END-MERCH IS NUMERIC
051600         NEXT SENTENCE
051700     ELSE
051800         DISPLAY MTCC-RECORD ' INVALID CONTROL CARD'
051900         GO TO A310-GCCR-READ-MTCC.
052000*
052100     MOVE MTCC-MBU380-BEG-ORG    TO WS-U381-ORT-BEG-ORG
052200                                    (X-WS-U381-ORT).
052300     MOVE MTCC-MBU380-BEG-MERCH  TO WS-U381-ORT-BEG-MERCH
052400                                    (X-WS-U381-ORT).
052500     MOVE MTCC-MBU380-END-ORG    TO WS-U381-ORT-END-ORG
052600                                    (X-WS-U381-ORT).
052700     MOVE MTCC-MBU380-END-MERCH  TO WS-U381-ORT-END-MERCH
052800                                    (X-WS-U381-ORT).
052900     SET X-WS-U381-ORT           UP BY 1.
053000     GO TO A310-GCCR-READ-MTCC.
053100*
053200 A390-GCCR-CLOSE-FILE.
053300*
053400     SET MTCCRB-CLOSE            TO TRUE.
053500     MOVE 'C2CC'                 TO SS02WS-ABEND-LOCATION.
053600     PERFORM MB00PD-MTCC-ACCESS  THRU MB00PD-MTCC-ACCESS-EXIT.
053700*
053800 A399-GCCR-EXIT.
053900     EXIT.
054000/
054100 A500-BUILD-REPORT SECTION.
054200 A501-BR-BEGIN.
054300*
054400     MOVE MTC1-RECORD            TO MTCC-RECORD.
054500*
054600     SET MMRCRB-OPEN-INPUT       TO TRUE.
054700     MOVE 'O1RC'                 TO SS02WS-ABEND-LOCATION.
054800     PERFORM MB00PD-MMRC-ACCESS  THRU MB00PD-MMRC-ACCESS-EXIT.
054900*
055000     SET MMCGRB-OPEN-INPUT       TO TRUE.
055100     MOVE 'O1CG'                 TO SS02WS-ABEND-LOCATION.
055200     PERFORM MB00PD-MMCG-ACCESS  THRU MB00PD-MMCG-ACCESS-EXIT.
055300*
055400     SET MMOGRB-OPEN-INPUT       TO TRUE.
055500     MOVE 'O1OG'                 TO SS02WS-ABEND-LOCATION.
055600     PERFORM MB00PD-MMOG-ACCESS  THRU MB00PD-MMOG-ACCESS-EXIT.
055700*
055800     SET MMPGRB-OPEN-INPUT       TO TRUE.
055900     MOVE 'O1PG'                 TO SS02WS-ABEND-LOCATION.
056000     PERFORM MB00PD-MMPG-ACCESS  THRU MB00PD-MMPG-ACCESS-EXIT.
056100*
056200     SET MTRFRB-OPEN-OUTPUT      TO TRUE.
056300     MOVE 'O1RF'                 TO SS02WS-ABEND-LOCATION.
056400     PERFORM MB00PD-MTRF-ACCESS  THRU MB00PD-MTRF-ACCESS-EXIT.
056500*
056600     MOVE SPACES                 TO MTRFIO-RECORD.
056700     SET MTRFIO-HEADER           TO TRUE.
056800     MOVE MMSC-TODAYS-JULIAN     TO MTRFIO-DATE-STAMP.
056900     MOVE MMSC-TIME-STAMP        TO MTRFIO-TIME-STAMP.
057000*
057100     SET MTRFRB-WRITE            TO TRUE.
057200     MOVE 'W0RF'                 TO SS02WS-ABEND-LOCATION.
057300     PERFORM MB00PD-MTRF-ACCESS  THRU MB00PD-MTRF-ACCESS-EXIT.
057400*
057500*
057600*
057700     SET MMRCRB-READ-SEQ         TO TRUE.
057800     MOVE 'O1RC'                 TO SS02WS-ABEND-LOCATION.
057900     PERFORM MB00PD-MMRC-ACCESS  THRU MB00PD-MMRC-ACCESS-EXIT.
058000*
058100     MOVE 'MMRC'                 TO MB99WS-FILE-ID.
058200*
058300     IF  MMRCIO-HEADER
058400         NEXT SENTENCE
058500     ELSE
058600         PERFORM MB99PD-MISSING-HEADER-ABEND
058700            THRU MB99PD-MHA-EXIT.
058800*
058900     MOVE MMRCIO-DATE-STAMP      TO MB99WS-FILE-DATE.
059000     MOVE MMRCIO-TIME-STAMP      TO MB99WS-FILE-TIME.
059100     PERFORM MB99PD-CHECK-DATE-TIME
059200        THRU MB99PD-CDT-EXIT.
059300*
059400*
059500*
059600     MOVE 'R0CG'                 TO SS02WS-ABEND-LOCATION.
059700     SET MMCGRB-READ-SEQ         TO TRUE.
059800     PERFORM MB00PD-MMCG-ACCESS
059900        THRU MB00PD-MMCG-ACCESS-EXIT.
060000     MOVE 'MMCG'                 TO MB99WS-FILE-ID.
060100*
060200     IF  MMCGIO-HEADER
060300         NEXT SENTENCE
060400     ELSE
060500         PERFORM MB99PD-MISSING-HEADER-ABEND
060600            THRU MB99PD-MHA-EXIT.
060700*
060800     MOVE MMCGIO-DATE-STAMP      TO MB99WS-FILE-DATE.
060900     MOVE MMCGIO-TIME-STAMP      TO MB99WS-FILE-TIME.
061000     PERFORM MB99PD-CHECK-DATE-TIME
061100        THRU MB99PD-CDT-EXIT.
061200*
061300     MOVE 'R1CG'                 TO SS02WS-ABEND-LOCATION.
061400     SET MMCGRB-READ-SEQ         TO TRUE.
061500     PERFORM MB00PD-MMCG-ACCESS
061600        THRU MB00PD-MMCG-ACCESS-EXIT.
061700*
061800     MOVE MMCGIO-RECORD          TO MMCG-RECORD.
061900*
062000*
062100*
062200     MOVE 'R0OG'                 TO SS02WS-ABEND-LOCATION.
062300     SET MMOGRB-READ-SEQ         TO TRUE.
062400     PERFORM MB00PD-MMOG-ACCESS
062500        THRU MB00PD-MMOG-ACCESS-EXIT.
062600     MOVE 'MMOG'                 TO MB99WS-FILE-ID.
062700*
062800     IF  MMOGIO-HEADER
062900         NEXT SENTENCE
063000     ELSE
063100         PERFORM MB99PD-MISSING-HEADER-ABEND
063200            THRU MB99PD-MHA-EXIT.
063300*
063400     MOVE MMOGIO-DATE-STAMP      TO MB99WS-FILE-DATE.
063500     MOVE MMOGIO-TIME-STAMP      TO MB99WS-FILE-TIME.
063600     PERFORM MB99PD-CHECK-DATE-TIME
063700        THRU MB99PD-CDT-EXIT.
063800*
063900     MOVE 'R1OG'                 TO SS02WS-ABEND-LOCATION.
064000     SET MMOGRB-READ-SEQ         TO TRUE.
064100     PERFORM MB00PD-MMOG-ACCESS
064200        THRU MB00PD-MMOG-ACCESS-EXIT.
064300*
064400*
064500*
064600     MOVE 'R0PG'                 TO SS02WS-ABEND-LOCATION.
064700     SET MMPGRB-READ-SEQ         TO TRUE.
064800     PERFORM MB00PD-MMPG-ACCESS
064900        THRU MB00PD-MMPG-ACCESS-EXIT.
065000     MOVE 'MMPG'                 TO MB99WS-FILE-ID.
065100*
065200     IF  MMPGIO-HEADER
065300         NEXT SENTENCE
065400     ELSE
065500         PERFORM MB99PD-MISSING-HEADER-ABEND
065600            THRU MB99PD-MHA-EXIT.
065700*
065800     MOVE MMPGIO-DATE-STAMP      TO MB99WS-FILE-DATE.
065900     MOVE MMPGIO-TIME-STAMP      TO MB99WS-FILE-TIME.
066000     PERFORM MB99PD-CHECK-DATE-TIME
066100        THRU MB99PD-CDT-EXIT.
066200*
066300     MOVE 'R1PG'                 TO SS02WS-ABEND-LOCATION.
066400     SET MMPGRB-READ-SEQ         TO TRUE.
066500     PERFORM MB00PD-MMPG-ACCESS
066600        THRU MB00PD-MMPG-ACCESS-EXIT.
066700*
066800*
066900*
067000     EVALUATE TRUE
067100         WHEN (MTCC-MBU380-ORG-OPTION
067200           OR  MTCC-MBU380-SYSTEM-OPTION)
067300             SORT MS1S-SORT-FILE ON ASCENDING KEY MWPA-KEY
067400                  INPUT  PROCEDURE IS 1000-EXTRACT-MMPG
067500                  OUTPUT PROCEDURE IS 2000-BUILD-MWPA
067600             PERFORM SS98PD-VERIFY-SORT-RETURN
067700             THRU SS98PD-VSR-EXIT
067800             MOVE 'OAPA'         TO SS02WS-ABEND-LOCATION
067900             SET MWPARB-OPEN-INPUT
068000                                 TO TRUE
068100             PERFORM MB00PD-MWPA-ACCESS
068200                THRU MB00PD-MWPA-ACCESS-EXIT
068300             MOVE 'RAPA'         TO SS02WS-ABEND-LOCATION
068400             SET MWPARB-READ-SEQ TO TRUE
068500             PERFORM MB00PD-MWPA-ACCESS
068600                THRU MB00PD-MWPA-ACCESS-EXIT
068700             MOVE 'RBPA'     TO SS02WS-ABEND-LOCATION
068800             SET MWPARB-READ-SEQ TO TRUE
068900             PERFORM MB00PD-MWPA-ACCESS
069000                THRU MB00PD-MWPA-ACCESS-EXIT
069100             IF  MTCC-MBU380-QUAL-DET
069200                 SORT MS2S-SORT-FILE ON ASCENDING KEY MWOI-KEY
069300                      INPUT PROCEDURE IS 3000-EXTRACT-MMOG
069400                      OUTPUT PROCEDURE IS 4000-BUILD-MWOI
069500                 PERFORM SS98PD-VERIFY-SORT-RETURN
069600                    THRU SS98PD-VSR-EXIT
069700                 MOVE 'OAOI'     TO SS02WS-ABEND-LOCATION
069800                 SET MWOIRB-OPEN-INPUT
069900                                     TO TRUE
070000                 PERFORM MB00PD-MWOI-ACCESS
070100                    THRU MB00PD-MWOI-ACCESS-EXIT
070200                 MOVE 'RAOI'     TO SS02WS-ABEND-LOCATION
070300                 SET MWOIRB-READ-SEQ
070400                                     TO TRUE
070500                 PERFORM MB00PD-MWOI-ACCESS
070600                    THRU MB00PD-MWOI-ACCESS-EXIT
070700                 MOVE 'RBOI'     TO SS02WS-ABEND-LOCATION
070800                 SET MWOIRB-READ-SEQ
070900                                     TO TRUE
071000                 PERFORM MB00PD-MWOI-ACCESS
071100                    THRU MB00PD-MWOI-ACCESS-EXIT
071200             END-IF
071300             IF  MTCC-MBU380-PLAN-DET
071400                 SORT MS3S-SORT-FILE ON ASCENDING KEY MWCP-KEY
071500                      INPUT PROCEDURE IS 5000-EXTRACT-MMCG
071600                      OUTPUT PROCEDURE IS 6000-BUILD-MWCP
071700                 PERFORM SS98PD-VERIFY-SORT-RETURN
071800                    THRU SS98PD-VSR-EXIT
071900                 MOVE 'OACP'     TO SS02WS-ABEND-LOCATION
072000                 SET MWCPRB-OPEN-INPUT
072100                                     TO TRUE
072200                 PERFORM MB00PD-MWCP-ACCESS
072300                    THRU MB00PD-MWCP-ACCESS-EXIT
072400                 MOVE 'RACP'     TO SS02WS-ABEND-LOCATION
072500                 SET MWCPRB-READ-SEQ
072600                                     TO TRUE
072700                 PERFORM MB00PD-MWCP-ACCESS
072800                    THRU MB00PD-MWCP-ACCESS-EXIT
072900                 MOVE 'RBCP'     TO SS02WS-ABEND-LOCATION
073000                 SET MWCPRB-READ-SEQ
073100                                     TO TRUE
073200                 PERFORM MB00PD-MWCP-ACCESS
073300                    THRU MB00PD-MWCP-ACCESS-EXIT
073400                 MOVE MWCPIO-RECORD TO MMCG-RECORD
073500             END-IF
073600             EVALUATE TRUE
073700                 WHEN MTCC-MBU380-ORG-OPTION
073800                     MOVE ZERO   TO MMOCIO-ORG
073900                     MOVE 'S1OC' TO SS02WS-ABEND-LOCATION
074000                     SET MMOCRB-START-GTE
074100                                 TO TRUE
074200                     PERFORM MB00PD-MMOC-ACCESS
074300                        THRU MB00PD-MMOC-ACCESS-EXIT
074400                     PERFORM B500-PROCESS-ORG
074500                        THRU B599-PO-EXIT
074600                        UNTIL MMOCIO-TRAILER
074700                 WHEN OTHER
074800                     MOVE WS-SORT-ORG
074900                                 TO MMOCIO-ORG
075000                     MOVE 'S2OC' TO SS02WS-ABEND-LOCATION
075100                     SET MMOCRB-START-GTE
075200                                 TO TRUE
075300                     PERFORM MB00PD-MMOC-ACCESS
075400                        THRU MB00PD-MMOC-ACCESS-EXIT
075500                     PERFORM B500-PROCESS-ORG
075600                        THRU B599-PO-EXIT
075700             END-EVALUATE
075800             SET MWPARB-CLOSE    TO TRUE
075900             MOVE 'CAPA'         TO SS02WS-ABEND-LOCATION
076000             PERFORM MB00PD-MWPA-ACCESS
076100                THRU MB00PD-MWPA-ACCESS-EXIT
076200             IF  MTCC-MBU380-QUAL-DET
076300                 SET MWOIRB-CLOSE TO TRUE
076400                 MOVE 'CAOI'     TO SS02WS-ABEND-LOCATION
076500                 PERFORM MB00PD-MWOI-ACCESS
076600                    THRU MB00PD-MWOI-ACCESS-EXIT
076700             END-IF
076800             IF  MTCC-MBU380-PLAN-DET
076900                 SET MWCPRB-CLOSE TO TRUE
077000                 MOVE 'CACP'     TO SS02WS-ABEND-LOCATION
077100                 PERFORM MB00PD-MWCP-ACCESS
077200                    THRU MB00PD-MWCP-ACCESS-EXIT
077300             END-IF
077400         WHEN OTHER
077500             PERFORM B000-PROCESS-MMRC
077600                THRU B099-PMMRC-EXIT
077700                UNTIL MMRCIO-TRAILER
077800     END-EVALUATE.
077900*
078000*
078100*
078200     MOVE SPACES                 TO MTRFIO-RECORD.
078300     SET MTRFIO-TRAILER          TO TRUE.
078400     MOVE MMSC-TODAYS-JULIAN     TO MTRFIO-DATE-STAMP.
078500     MOVE MMSC-TIME-STAMP        TO MTRFIO-TIME-STAMP.
078600*
078700     SET MTRFRB-WRITE            TO TRUE.
078800     MOVE 'W9RF'                 TO SS02WS-ABEND-LOCATION.
078900     PERFORM MB00PD-MTRF-ACCESS  THRU MB00PD-MTRF-ACCESS-EXIT.
079000*
079100     SET MTRFRB-CLOSE            TO TRUE.
079200     MOVE 'C1RF'                 TO SS02WS-ABEND-LOCATION.
079300     PERFORM MB00PD-MTRF-ACCESS  THRU MB00PD-MTRF-ACCESS-EXIT.
079400*
079500     SET MMRCRB-CLOSE            TO TRUE.
079600     MOVE 'C1RC'                 TO SS02WS-ABEND-LOCATION.
079700     PERFORM MB00PD-MMRC-ACCESS  THRU MB00PD-MMRC-ACCESS-EXIT.
079800*
079900     SET MMCGRB-CLOSE            TO TRUE.
080000     MOVE 'C1CG'                 TO SS02WS-ABEND-LOCATION.
080100     PERFORM MB00PD-MMCG-ACCESS  THRU MB00PD-MMCG-ACCESS-EXIT.
080200*
080300     SET MMOGRB-CLOSE            TO TRUE.
080400     MOVE 'C1OG'                 TO SS02WS-ABEND-LOCATION.
080500     PERFORM MB00PD-MMOG-ACCESS  THRU MB00PD-MMOG-ACCESS-EXIT.
080600*
080700     SET MMPGRB-CLOSE            TO TRUE.
080800     MOVE 'C1PG'                 TO SS02WS-ABEND-LOCATION.
080900     PERFORM MB00PD-MMPG-ACCESS  THRU MB00PD-MMPG-ACCESS-EXIT.
081000*
081100*
081200*
081300 A599-BR-EXIT.
081400     EXIT.
081500/
081600 A900-REPORT-HEADERS-TRAILERS SECTION.
081700 A901-RHT-BEGIN.
081800*
081900     IF  MTRFWS-ORT-F1-NOT-REQUESTED  (X-MTRFWS-ORT)
082000         NEXT SENTENCE
082100     ELSE
082200         MOVE SPACES             TO MTRF-RECORD
082300         MOVE MTRFWS-ORT-FREQ-1  (X-MTRFWS-ORT)
082400                                 TO MTRF-KEY-1
082500         MOVE ZERO               TO MTRF-K1-REC-TYPE
082600         MOVE MTRFWS-ORT-HEADINGS-DATA  (X-MTRFWS-ORT)
082700                                 TO MTRF-HD-HEADINGS-DATA
082800         MOVE MTRF-RECORD        TO MTRFIO-RECORD
082900         MOVE 'W1RF'             TO SS02WS-ABEND-LOCATION
083000         SET MTRFRB-WRITE        TO TRUE
083100         PERFORM MB00PD-MTRF-ACCESS
083200            THRU MB00PD-MTRF-ACCESS-EXIT
083300         MOVE SPACES             TO MTRF-RECORD
083400         MOVE MTRFWS-ORT-FREQ-1  (X-MTRFWS-ORT)
083500                                 TO MTRF-KEY-1
083600         MOVE 9                  TO MTRF-K1-REC-TYPE
083700         MOVE MTRF-RECORD        TO MTRFIO-RECORD
083800         MOVE 'W2RF'             TO SS02WS-ABEND-LOCATION
083900         SET MTRFRB-WRITE        TO TRUE
084000         PERFORM MB00PD-MTRF-ACCESS
084100            THRU MB00PD-MTRF-ACCESS-EXIT.
084200*
084300     MOVE SPACES                 TO MTRF-RECORD.
084400*
084500 A999-RHT-EXIT.
084600     EXIT.
084700/
084800 B000-PROCESS-MMRC SECTION.
084900 B001-PMMRC-BEGIN.
085000*
085100     SET MMRCRB-READ-SEQ         TO TRUE.
085200     MOVE 'R1RC'                 TO SS02WS-ABEND-LOCATION.
085300     PERFORM MB00PD-MMRC-ACCESS  THRU MB00PD-MMRC-ACCESS-EXIT.
085400*
085500     IF  MMRCIO-HEADER
085600         GO TO B001-PMMRC-BEGIN.
085700*
085800     IF  MMRCIO-TRAILER
085900         GO TO B099-PMMRC-EXIT.
086000*
086100     MOVE MMRCIO-RECORD          TO MMRC-RECORD.
086200*
086300     IF  MMRC-REC-INCOMPLETE
086400     OR  MMRC-REC-PURGED
086500     OR  MMRC-ADD-PENDING
086600         GO TO B001-PMMRC-BEGIN.
086700*
086800     SET X-WS-U381-ORT           TO 1.
086900     SEARCH WS-U381-ORG-RANGES-TABLE VARYING X-WS-U381-ORT
087000         AT END
087100             GO TO B001-PMMRC-BEGIN
087200         WHEN WS-U381-ORT-END-OF-TABLE (X-WS-U381-ORT)
087300             GO TO B001-PMMRC-BEGIN
087400         WHEN MMRCIO-ORG-CHAIN IS NOT LESS THAN
087500              WS-U381-ORT-BEG-ORG-CHAIN (X-WS-U381-ORT)
087600         AND  MMRCIO-ORG-CHAIN IS NOT GREATER THAN
087700              WS-U381-ORT-END-ORG-CHAIN (X-WS-U381-ORT)
087800             NEXT SENTENCE.
087900*
088000     INITIALIZE WS-PROD-TOTALS-AREA.
088100     INITIALIZE WS-QL-TOTALS-AREA.
088200     INITIALIZE WS-CP-TOTALS-AREA.
088300     INITIALIZE WS-HIST-TOTALS-AREA.
088400*
088500     IF  MMRC-ORG IS NOT EQUAL TO MMOC-ORG
088600         MOVE MMRC-ORG           TO MMOCIO-ORG
088700         SET MMOCRB-READ-RANDOM  TO TRUE
088800         MOVE 'R1OC'             TO SS02WS-ABEND-LOCATION
088900         PERFORM MB00PD-MMOC-ACCESS THRU MB00PD-MMOC-ACCESS-EXIT
089000         MOVE MMOCIO-RECORD      TO MMOC-RECORD
089100         PERFORM Z100-ADJUST-ORG
089200            THRU Z199-AO-EXIT
089300         PERFORM MTRFPX-BUILD-REPORT-TABLE
089400            THRU MTRFPX-BRT-EXIT
089500         SET X-MTRFWS-ORT        TO 88
089600         PERFORM A900-REPORT-HEADERS-TRAILERS
089700            THRU A999-RHT-EXIT.
089800*
089900     SET MTRF-K2-O88-KT-MERCHANT TO TRUE.
090000     MOVE MTRF-K2-O88-KEY-TYPE   TO WS-KEY-TYPE.
090100     MOVE MMRC-CHAIN             TO MTRF-K2-O88-MERCHANT.
090200     SET MTRF-K2-O88-RS-HEADER   TO TRUE.
090300     MOVE ZERO                   TO MTRF-K2-O88-PRODUCT.
090400     SET MTRF-K2-O88-RT-PROD-QL-HEADER
090500                                 TO TRUE.
090600     MOVE ZERO                   TO MTRF-K2-O88-CREDIT-PLAN.
090700     MOVE ZERO                   TO MTRF-K2-O88-LOGIC-MODULE.
090800     MOVE ZERO                   TO MTRF-K2-O88-HIST-YEAR.
090900     MOVE ZERO                   TO MTRF-K2-O88-HIST-MON.
091000     MOVE 1                      TO WS-U381-RPT-REC-TYPE.
091100*
091200     MOVE MMRC-NA-LINE (1)       TO MTRF-O88-NAME.
091300*
091400     PERFORM
091500         VARYING X-MTCC-MBU380-HIST
091600         FROM 1 BY 1
091700         UNTIL X-MTCC-MBU380-HIST IS GREATER THAN 3
091800         SET X-MMRC              TO MTCC-MBU380-HIST-PERIOD
091900                                    (X-MTCC-MBU380-HIST)
092000         SET X-MTRF-O88-HIST     TO X-MTCC-MBU380-HIST
092100         MOVE MMRC-OCCURRENCE-ID (X-MMRC)
092200                                 TO MTRF-O88-HIST-HEADING-ID
092300                                    (X-MTRF-O88-HIST)
092400         MOVE MMRC-OCCURRENCE-YEAR (X-MMRC)
092500                                 TO MTRF-O88-HIST-HEADING-YR
092600                                    (X-MTRF-O88-HIST)
092700     END-PERFORM.
092800*
092900     PERFORM R980-WRITE-REPORT-FILE
093000        THRU R989-WRF-EXIT.
093100*
093200     PERFORM
093300         UNTIL MMPGIO-ORG-ACCT  IS GREATER THAN
093400                                 MMRC-ORG-CHAIN
093500         MOVE MMPGIO-LOGIC-MODULE
093600                                 TO MMTCWS-LOGIC-MODULE
093700         EVALUATE TRUE
093800             WHEN MMTCWS-LM-VALID-INTERNAL
093900                 CONTINUE
094000             WHEN MMPGIO-ORG-ACCT
094100                                 IS EQUAL TO MMRC-ORG-CHAIN
094200                 MOVE MMPGIO-RECORD
094300                                 TO MMPG-RECORD
094400                 PERFORM C200-PRODUCT-DETAIL
094500                    THRU C299-PD-EXIT
094600         END-EVALUATE
094700         SET MMPGRB-READ-SEQ     TO TRUE
094800         MOVE 'R2PG'             TO SS02WS-ABEND-LOCATION
094900         PERFORM MB00PD-MMPG-ACCESS
095000            THRU MB00PD-MMPG-ACCESS-EXIT
095100     END-PERFORM.
095200*
095300*
095400     IF  MTCC-MBU380-PROD-NO
095500         GO TO B003-QUAL-LEVEL.
095600*
095700     PERFORM C100-PRODUCT-HEADER
095800        THRU C199-PH-EXIT
095900        VARYING X-WS-PTA FROM 1 BY 1
096000        UNTIL   X-WS-PTA IS GREATER THAN 101.
096100*
096200     PERFORM C300-PRODUCT-TOTALS
096300        THRU C399-PT-EXIT
096400        VARYING X-WS-PTA FROM 1 BY 1
096500        UNTIL   X-WS-PTA IS GREATER THAN 101.
096600*
096700 B003-QUAL-LEVEL.
096800*
096900     IF  MTCC-MBU380-QUAL-NO
097000         GO TO B005-CREDIT-PLAN.
097100*
097200     PERFORM
097300         UNTIL MMOGIO-ORG-ACCT  IS GREATER THAN
097400                                 MMRC-ORG-CHAIN
097500         MOVE MMOGIO-LOGIC-MODULE
097600                                 TO MMTCWS-LOGIC-MODULE
097700         EVALUATE TRUE
097800             WHEN MMTCWS-LM-VALID-INTERNAL
097900                 CONTINUE
098000             WHEN MMOGIO-ORG-ACCT
098100                                 IS EQUAL TO MMRC-ORG-CHAIN
098200                 MOVE MMOGIO-RECORD
098300                                 TO MMOG-RECORD
098400                 PERFORM D200-QUAL-LEVEL-DETAIL
098500                    THRU D299-QLD-EXIT
098600         END-EVALUATE
098700         SET MMOGRB-READ-SEQ     TO TRUE
098800         MOVE 'R2OG'             TO SS02WS-ABEND-LOCATION
098900         PERFORM MB00PD-MMOG-ACCESS
099000            THRU MB00PD-MMOG-ACCESS-EXIT
099100     END-PERFORM.
099200*
099300     PERFORM
099400         VARYING X-WS-QTA FROM 1 BY 1
099500         UNTIL   X-WS-QTA IS GREATER THAN 101
099600         PERFORM D000-PRODUCT-QL-HEADER
099700            THRU D099-PQLH-EXIT
099800     END-PERFORM.
099900*
100000     PERFORM
100100         VARYING X-WS-QTA FROM 1 BY 1
100200         UNTIL   X-WS-QTA IS GREATER THAN 101
100300         PERFORM D100-QUAL-LEVEL-HEADER
100400            THRU D199-QLH-EXIT
100500            VARYING X-WS-QTA-QL FROM 1 BY 1
100600            UNTIL   X-WS-QTA-QL IS GREATER THAN 99
100700     END-PERFORM.
100800*
100900     PERFORM
101000         VARYING X-WS-QTA FROM 1 BY 1
101100         UNTIL   X-WS-QTA IS GREATER THAN 101
101200         PERFORM D300-QUAL-LEVEL-TOTALS
101300            THRU D399-QLT-EXIT
101400            VARYING X-WS-QTA-QL FROM 1 BY 1
101500            UNTIL   X-WS-QTA-QL IS GREATER THAN 99
101600     END-PERFORM.
101700*
101800 B005-CREDIT-PLAN.
101900*
102000     IF  MTCC-MBU380-PLAN-NO
102100         GO TO B007-HISTORY.
102200*
102300     PERFORM
102400         UNTIL MMCGIO-ORG-ACCT  IS GREATER THAN
102500                                 MMRC-ORG-CHAIN
102600         MOVE MMCGIO-LOGIC-MODULE
102700                                 TO MMTCWS-LOGIC-MODULE
102800         EVALUATE TRUE
102900             WHEN MMTCWS-LM-VALID-INTERNAL
103000                 SET MMCGRB-READ-SEQ
103100                                 TO TRUE
103200                 MOVE 'R2CG'     TO SS02WS-ABEND-LOCATION
103300                 PERFORM MB00PD-MMCG-ACCESS
103400                    THRU MB00PD-MMCG-ACCESS-EXIT
103500                 MOVE MMCGIO-RECORD
103600                                 TO MMCG-RECORD
103700             WHEN MMCGIO-ORG-ACCT
103800                                 IS EQUAL TO MMRC-ORG-CHAIN
103900                 PERFORM E200-CREDIT-PLAN-DETAIL
104000                    THRU E299-CPD-EXIT
104100                 MOVE MMCG-PLAN  TO WS-PREV-PLAN
104200                 MOVE MMCG-PRODUCT
104300                                 TO WS-PREV-PROD
104400                 SET MMCGRB-READ-SEQ
104500                                 TO TRUE
104600                 MOVE 'R2CG'     TO SS02WS-ABEND-LOCATION
104700                 PERFORM MB00PD-MMCG-ACCESS
104800                    THRU MB00PD-MMCG-ACCESS-EXIT
104900                 MOVE MMCGIO-RECORD
105000                                 TO MMCG-RECORD
105100                 PERFORM E100-CREDIT-PLAN-HEADER
105200                    THRU E199-CPH-EXIT
105300                 PERFORM E300-CREDIT-PLAN-TOTALS
105400                    THRU E399-CPT-EXIT
105500                 PERFORM E000-PRODUCT-CP-HEADER
105600                    THRU E099-PCPH-EXIT
105700             WHEN OTHER
105800                 SET MMCGRB-READ-SEQ
105900                                 TO TRUE
106000                 MOVE 'R2CG'     TO SS02WS-ABEND-LOCATION
106100                 PERFORM MB00PD-MMCG-ACCESS
106200                    THRU MB00PD-MMCG-ACCESS-EXIT
106300                 MOVE MMCGIO-RECORD
106400                                 TO MMCG-RECORD
106500         END-EVALUATE
106600     END-PERFORM.
106700*
106800 B007-HISTORY.
106900*
107000     PERFORM F100-HIST-HEADER
107100        THRU F199-HH-EXIT.
107200*
107300     PERFORM F900-HISTORICAL
107400        THRU F999-H-EXIT
107500        VARYING X-MMRC FROM 1 BY 1
107600        UNTIL   X-MMRC IS GREATER THAN 12.
107700*
107800 B099-PMMRC-EXIT.
107900     EXIT.
108000/
108100 B500-PROCESS-ORG SECTION.
108200 B501-PO-BEGIN.
108300*
108400     SET MMOCRB-READ-SEQ         TO TRUE.
108500     MOVE 'R2OC'                 TO SS02WS-ABEND-LOCATION.
108600     PERFORM MB00PD-MMOC-ACCESS  THRU MB00PD-MMOC-ACCESS-EXIT.
108700*
108800     IF  MMOCIO-HEADER
108900         GO TO B501-PO-BEGIN.
109000*
109100     IF  MMOCIO-TRAILER
109200         GO TO B599-PO-EXIT.
109300*
109400     SET X-WS-U381-ORT           TO 1.
109500     SEARCH WS-U381-ORG-RANGES-TABLE VARYING X-WS-U381-ORT
109600         AT END
109700             GO TO B501-PO-BEGIN
109800         WHEN WS-U381-ORT-END-OF-TABLE (X-WS-U381-ORT)
109900             GO TO B501-PO-BEGIN
110000         WHEN MMOCIO-ORG IS NOT LESS THAN
110100              WS-U381-ORT-BEG-ORG (X-WS-U381-ORT)
110200         AND  MMOCIO-ORG IS NOT GREATER THAN
110300              WS-U381-ORT-END-ORG (X-WS-U381-ORT)
110400             NEXT SENTENCE.
110500*
110600     MOVE MMOCIO-RECORD          TO MMOC-RECORD.
110700     PERFORM Z100-ADJUST-ORG
110800        THRU Z199-AO-EXIT.
110900*
111000     IF  MMOC-REC-INCOMPLETE
111100     OR  MMOC-REC-PURGED
111200     OR  MMOC-ADD-PENDING
111300         GO TO B501-PO-BEGIN.
111400*
111500     IF  MWPAIO-ORG IS GREATER THAN MMOC-ORG
111600         GO TO B501-PO-BEGIN.
111700*
111800     INITIALIZE WS-PROD-TOTALS-AREA.
111900     INITIALIZE WS-QL-TOTALS-AREA.
112000     INITIALIZE WS-CP-TOTALS-AREA.
112100     INITIALIZE WS-HIST-TOTALS-AREA.
112200*
112300     MOVE MMOC-TODAYS-JULIAN     TO MMRCIR-DATE.
112400     PERFORM MMRCPX-INIT-RECORD
112500        THRU MMRCPX-IR-EXIT.
112600     MOVE MMRCIR-RECORD          TO MMRC-RECORD.
112700     MOVE MMOC-ORG               TO MMRC-ORG.
112800     MOVE MMOC-DEMOGRAPHICS-AREA TO MMRC-DEMOGRAPHICS-AREA.
112900     MOVE MMOC-REC-STATUS        TO MMRC-REC-STATUS.
113000*
113100     PERFORM MTRFPX-BUILD-REPORT-TABLE
113200        THRU MTRFPX-BRT-EXIT.
113300     SET X-MTRFWS-ORT            TO 88.
113400     PERFORM A900-REPORT-HEADERS-TRAILERS
113500        THRU A999-RHT-EXIT.
113600*
113700     SET MTRF-K2-O88-KT-ORG-TOTALS
113800                                 TO TRUE.
113900*
114000     IF  MTCC-MBU380-SYSTEM-OPTION
114100         SET MTRF-K2-O88-KT-SYSTEM-TOTALS
114200                                 TO TRUE.
114300*
114400     MOVE MTRF-K2-O88-KEY-TYPE   TO WS-KEY-TYPE.
114500     MOVE MMRC-CHAIN             TO MTRF-K2-O88-MERCHANT.
114600     SET MTRF-K2-O88-RS-HEADER   TO TRUE.
114700     MOVE ZERO                   TO MTRF-K2-O88-PRODUCT.
114800*
114900     PERFORM
115000         VARYING X-MTCC-MBU380-HIST
115100         FROM 1 BY 1
115200         UNTIL X-MTCC-MBU380-HIST IS GREATER THAN 3
115300         SET X-MMRC              TO MTCC-MBU380-HIST-PERIOD
115400                                    (X-MTCC-MBU380-HIST)
115500         SET X-MTRF-O88-HIST     TO X-MTCC-MBU380-HIST
115600         MOVE MMRC-OCCURRENCE-ID (X-MMRC)
115700                                 TO MTRF-O88-HIST-HEADING-ID
115800                                    (X-MTRF-O88-HIST)
115900         MOVE MMRC-OCCURRENCE-YEAR (X-MMRC)
116000                                 TO MTRF-O88-HIST-HEADING-YR
116100                                    (X-MTRF-O88-HIST)
116200     END-PERFORM.
116300*
116400     SET MTRF-K2-O88-RT-PROD-QL-HEADER
116500                                 TO TRUE.
116600     MOVE ZERO                   TO MTRF-K2-O88-CREDIT-PLAN.
116700     MOVE ZERO                   TO MTRF-K2-O88-LOGIC-MODULE.
116800     MOVE ZERO                   TO MTRF-K2-O88-HIST-YEAR.
116900     MOVE ZERO                   TO MTRF-K2-O88-HIST-MON.
117000     MOVE 1                      TO WS-U381-RPT-REC-TYPE.
117100*
117200     MOVE MMRC-NA-LINE (1)       TO MTRF-O88-NAME.
117300*
117400     PERFORM R980-WRITE-REPORT-FILE
117500        THRU R989-WRF-EXIT.
117600*
117700 B503-PRODUCT.
117800*
117900     PERFORM
118000         UNTIL MWPAIO-ORG IS GREATER THAN MMOC-ORG
118100         MOVE MWPAIO-LOGIC-MODULE
118200                                 TO MMTCWS-LOGIC-MODULE
118300         EVALUATE TRUE
118400             WHEN MMTCWS-LM-VALID-INTERNAL
118500                 CONTINUE
118600             WHEN MWPAIO-ORG IS EQUAL TO MMOC-ORG
118700                 MOVE MWPAIO-RECORD
118800                                 TO MMPG-RECORD
118900                 PERFORM C200-PRODUCT-DETAIL
119000                    THRU C299-PD-EXIT
119100         END-EVALUATE
119200         SET MWPARB-READ-SEQ     TO TRUE
119300         MOVE 'R3PA'             TO SS02WS-ABEND-LOCATION
119400         PERFORM MB00PD-MWPA-ACCESS
119500            THRU MB00PD-MWPA-ACCESS-EXIT
119600     END-PERFORM.
119700*
119800     IF  MTCC-MBU380-PROD-NO
119900         GO TO B505-QUAL-LEVEL.
120000*
120100     PERFORM C100-PRODUCT-HEADER
120200        THRU C199-PH-EXIT
120300        VARYING X-WS-PTA FROM 1 BY 1
120400        UNTIL   X-WS-PTA IS GREATER THAN 101.
120500*
120600     PERFORM C300-PRODUCT-TOTALS
120700        THRU C399-PT-EXIT
120800        VARYING X-WS-PTA FROM 1 BY 1
120900        UNTIL   X-WS-PTA IS GREATER THAN 101.
121000*
121100*
121200 B505-QUAL-LEVEL.
121300*
121400     IF  MTCC-MBU380-QUAL-NO
121500         GO TO B507-CREDIT-PLAN.
121600*
121700     PERFORM
121800         UNTIL MWOIIO-ORG IS GREATER THAN MMOC-ORG
121900         MOVE MWOIIO-LOGIC-MODULE
122000                                 TO MMTCWS-LOGIC-MODULE
122100         EVALUATE TRUE
122200             WHEN MMTCWS-LM-VALID-INTERNAL
122300                 CONTINUE
122400             WHEN MWOIIO-ORG IS EQUAL TO MMOC-ORG
122500                 MOVE MWOIIO-RECORD
122600                                 TO MMOG-RECORD
122700                 PERFORM D200-QUAL-LEVEL-DETAIL
122800                    THRU D299-QLD-EXIT
122900         END-EVALUATE
123000         SET MWOIRB-READ-SEQ     TO TRUE
123100         MOVE 'R3OI'             TO SS02WS-ABEND-LOCATION
123200         PERFORM MB00PD-MWOI-ACCESS
123300            THRU MB00PD-MWOI-ACCESS-EXIT
123400     END-PERFORM.
123500*
123600     PERFORM
123700         VARYING X-WS-QTA FROM 1 BY 1
123800         UNTIL   X-WS-QTA IS GREATER THAN 101
123900         PERFORM D000-PRODUCT-QL-HEADER
124000            THRU D099-PQLH-EXIT
124100     END-PERFORM.
124200*
124300     PERFORM
124400         VARYING X-WS-QTA FROM 1 BY 1
124500         UNTIL   X-WS-QTA IS GREATER THAN 101
124600         PERFORM D100-QUAL-LEVEL-HEADER
124700            THRU D199-QLH-EXIT
124800            VARYING X-WS-QTA-QL FROM 1 BY 1
124900            UNTIL   X-WS-QTA-QL IS GREATER THAN 99
125000     END-PERFORM.
125100*
125200     PERFORM
125300         VARYING X-WS-QTA FROM 1 BY 1
125400         UNTIL   X-WS-QTA IS GREATER THAN 101
125500         PERFORM D300-QUAL-LEVEL-TOTALS
125600            THRU D399-QLT-EXIT
125700            VARYING X-WS-QTA-QL FROM 1 BY 1
125800            UNTIL   X-WS-QTA-QL IS GREATER THAN 99
125900     END-PERFORM.
126000*
126100*
126200 B507-CREDIT-PLAN.
126300*
126400     IF  MTCC-MBU380-PLAN-NO
126500         GO TO B509-HISTORY.
126600*
126700     PERFORM
126800         UNTIL MWCPIO-ORG IS GREATER THAN
126900                                 MMOC-ORG
127000         MOVE MWCPIO-LOGIC-MODULE
127100                                 TO MMTCWS-LOGIC-MODULE
127200         EVALUATE TRUE
127300             WHEN MMTCWS-LM-VALID-INTERNAL
127400                 SET MWCPRB-READ-SEQ
127500                                 TO TRUE
127600                 MOVE 'R3CP'     TO SS02WS-ABEND-LOCATION
127700                 PERFORM MB00PD-MWCP-ACCESS
127800                    THRU MB00PD-MWCP-ACCESS-EXIT
127900                 MOVE MWCPIO-RECORD
128000                                 TO MMCG-RECORD
128100             WHEN MWCPIO-ORG     IS EQUAL TO MMOC-ORG
128200                 PERFORM E200-CREDIT-PLAN-DETAIL
128300                    THRU E299-CPD-EXIT
128400                 MOVE MMCG-PLAN  TO WS-PREV-PLAN
128500                 MOVE MMCG-PRODUCT
128600                                 TO WS-PREV-PROD
128700                 SET MWCPRB-READ-SEQ
128800                                 TO TRUE
128900                 MOVE 'R4CP'     TO SS02WS-ABEND-LOCATION
129000                 PERFORM MB00PD-MWCP-ACCESS
129100                    THRU MB00PD-MWCP-ACCESS-EXIT
129200                 MOVE MWCPIO-RECORD
129300                                 TO MMCG-RECORD
129400                 PERFORM E100-CREDIT-PLAN-HEADER
129500                    THRU E199-CPH-EXIT
129600                 PERFORM E300-CREDIT-PLAN-TOTALS
129700                    THRU E399-CPT-EXIT
129800                 PERFORM E000-PRODUCT-CP-HEADER
129900                    THRU E099-PCPH-EXIT
130000             WHEN OTHER
130100                 SET MWCPRB-READ-SEQ
130200                                 TO TRUE
130300                 MOVE 'R6CP'     TO SS02WS-ABEND-LOCATION
130400                 PERFORM MB00PD-MWCP-ACCESS
130500                    THRU MB00PD-MWCP-ACCESS-EXIT
130600                 MOVE MWCPIO-RECORD
130700                                 TO MMCG-RECORD
130800         END-EVALUATE
130900     END-PERFORM.
131000*
131100*
131200 B509-HISTORY.
131300*
131400     IF  MTCC-MBU380-HIST-NO
131500         GO TO B599-PO-EXIT.
131600*
131700     PERFORM F100-HIST-HEADER
131800        THRU F199-HH-EXIT.
131900*
132000     PERFORM F900-HISTORICAL
132100        THRU F999-H-EXIT
132200        VARYING X-MMRC FROM 1 BY 1
132300        UNTIL   X-MMRC IS GREATER THAN 12.
132400*
132500 B599-PO-EXIT.
132600     EXIT.
132700/
132800 C100-PRODUCT-HEADER SECTION.
132900 C101-PH-BEGIN.
133000*
133100     IF  WS-PTA-NO-ACTIVITY (X-WS-PTA)
133200     OR  MTCC-MBU380-PROD-NO
133300         GO TO C199-PH-EXIT.
133400*
133500     MOVE WS-KEY-TYPE            TO MTRF-K2-O88-KEY-TYPE.
133600     MOVE MMRC-CHAIN             TO MTRF-K2-O88-MERCHANT.
133700     SET MTRF-K2-O88-RS-PRODUCT  TO TRUE.
133800     SET MTRF-K2-O88-RT-PROD-HEADER
133900                                 TO TRUE.
134000     MOVE ZERO                   TO MTRF-K2-O88-CREDIT-PLAN.
134100     MOVE ZERO                   TO MTRF-K2-O88-LOGIC-MODULE.
134200     MOVE ZERO                   TO MTRF-K2-O88-HIST-YEAR.
134300     MOVE ZERO                   TO MTRF-K2-O88-HIST-MON.
134400     MOVE 1                      TO WS-U381-RPT-REC-TYPE.
134500*
134600     MOVE SPACES                 TO MTRF-O88-QL-DESC.
134700*
134800     EVALUATE TRUE
134900         WHEN X-WS-PTA IS EQUAL TO 101
135000             SET MTRF-K2-O88-ALL-PRODUCTS
135100                                 TO TRUE
135200             MOVE '**ALL PRODUCTS**'
135300                                 TO MTRF-O88-PROD-DESC
135400         WHEN X-WS-PTA IS EQUAL TO 100
135500             MOVE ZERO           TO MTRF-K2-O88-PRODUCT
135600             MOVE 'CHAIN LEVEL     '
135700                                 TO MTRF-O88-PROD-DESC
135800         WHEN OTHER
135900             SET  MTRF-K2-O88-PRODUCT
136000                                 TO X-WS-PTA
136100             SET  X-MMOC-PROD    TO X-WS-PTA
136200             MOVE MMOC-PRODUCT-DESC (X-MMOC-PROD)
136300                                 TO MTRF-O88-PROD-DESC
136400     END-EVALUATE.
136500*
136600     IF  MTCC-MBU380-PROD-TOT
136700     AND X-WS-PTA IS NOT EQUAL TO 101
136800         GO TO C199-PH-EXIT.
136900*
137000     PERFORM R980-WRITE-REPORT-FILE
137100        THRU R989-WRF-EXIT.
137200*
137300 C199-PH-EXIT.
137400     EXIT.
137500/
137600 C200-PRODUCT-DETAIL SECTION.
137700 C201-PD-BEGIN.
137800*
137900     MOVE WS-KEY-TYPE            TO MTRF-K2-O88-KEY-TYPE.
138000     MOVE MMRC-CHAIN             TO MTRF-K2-O88-MERCHANT.
138100     SET MTRF-K2-O88-RS-PRODUCT  TO TRUE.
138200*
138300     IF  MMPG-DETAIL
138400         EVALUATE TRUE
138500             WHEN MMPG-PRODUCT IS GREATER THAN ZERO
138600                 SET X-WS-PTA    TO MMPG-PRODUCT
138700             WHEN OTHER
138800                 SET X-WS-PTA    TO 100
138900         END-EVALUATE
139000         MOVE MMPG-PRODUCT       TO MTRF-K2-O88-PRODUCT
139100     ELSE
139200         SET X-WS-PTA            TO 101
139300         SET MTRF-K2-O88-ALL-PRODUCTS
139400                                 TO TRUE.
139500*
139600     SET MTRF-K2-O88-RT-PROD-DETAIL
139700                                 TO TRUE.
139800     MOVE ZERO                   TO MTRF-K2-O88-CREDIT-PLAN.
139900     MOVE MMPG-LOGIC-MODULE      TO MTRF-K2-O88-LOGIC-MODULE.
140000     MOVE ZERO                   TO MTRF-K2-O88-HIST-YEAR.
140100     MOVE ZERO                   TO MTRF-K2-O88-HIST-MON.
140200     MOVE 1                      TO WS-U381-RPT-REC-TYPE.
140300*
140400     MOVE MMPG-LOGIC-MODULE      TO MTRF-O88-LOGIC-MODULE.
140500*
140600     PERFORM
140700         VARYING X-MTCC-MBU380-HIST FROM 1 BY 1
140800         UNTIL X-MTCC-MBU380-HIST IS GREATER THAN 3
140900         SET X-MMPG              TO MTCC-MBU380-HIST-PERIOD
141000                                    (X-MTCC-MBU380-HIST)
141100         SET X-O88-PQ-DET        TO X-MTCC-MBU380-HIST
141200         MOVE MMPG-NBR (X-MMPG)  TO MTRF-O88-NBR-DET
141300                                    (X-O88-PQ-DET)
141400         MOVE MMPG-AMT (X-MMPG)  TO MTRF-O88-AMT-DET
141500                                    (X-O88-PQ-DET)
141600     END-PERFORM.
141700*
141800     IF  MTCC-MBU380-PROD-TOT
141900     AND X-WS-PTA IS NOT EQUAL TO 101
142000         NEXT SENTENCE
142100     ELSE
142200         IF  MTCC-MBU380-PROD-NO
142300             NEXT SENTENCE
142400         ELSE
142500             PERFORM R980-WRITE-REPORT-FILE
142600                THRU R989-WRF-EXIT.
142700*
142800     SET WS-PTA-ACTIVITY (X-WS-PTA)
142900                                 TO TRUE.
143000*
143100 C203-CALC-TOT.
143200*
143300     IF  MTCC-MBU380-PROD-NO
143400         GO TO C205-CALC-HIST.
143500*
143600     EVALUATE TRUE
143700         WHEN (MMTCWS-LM-CR-FEES
143800           OR  MMTCWS-LM-REFUND)
143900             PERFORM
144000                 VARYING X-MTCC-MBU380-HIST FROM 1 BY 1
144100                 UNTIL X-MTCC-MBU380-HIST IS GREATER THAN 3
144200                 SET X-MMPG      TO MTCC-MBU380-HIST-PERIOD
144300                                    (X-MTCC-MBU380-HIST)
144400                 SET X-PTA-NBR-AMT
144500                                 TO X-MTCC-MBU380-HIST
144600                 SUBTRACT MMPG-AMT (X-MMPG)
144700                                 FROM  WS-PTA-TOTAL-INCOME
144800                                       (X-WS-PTA X-PTA-NBR-AMT)
144900             END-PERFORM
145000         WHEN (MMTCWS-LM-DR-FEES
145100           OR  MMTCWS-LM-DISCOUNT)
145200             PERFORM
145300                 VARYING X-MTCC-MBU380-HIST FROM 1 BY 1
145400                 UNTIL X-MTCC-MBU380-HIST IS GREATER THAN 3
145500                 SET X-MMPG      TO MTCC-MBU380-HIST-PERIOD
145600                                    (X-MTCC-MBU380-HIST)
145700                 SET X-PTA-NBR-AMT
145800                                 TO X-MTCC-MBU380-HIST
145900                 ADD MMPG-AMT (X-MMPG)
146000                                 TO WS-PTA-TOTAL-INCOME
146100                                    (X-WS-PTA X-PTA-NBR-AMT)
146200             END-PERFORM
146300     END-EVALUATE.
146400*
146500     EVALUATE TRUE
146600         WHEN MMTCWS-LM-SALE
146700             PERFORM
146800                 VARYING X-MTCC-MBU380-HIST FROM 1 BY 1
146900                 UNTIL X-MTCC-MBU380-HIST IS GREATER THAN 3
147000                 SET X-MMPG      TO MTCC-MBU380-HIST-PERIOD
147100                                    (X-MTCC-MBU380-HIST)
147200                 SET X-PTA-NBR-AMT
147300                                 TO X-MTCC-MBU380-HIST
147400                 ADD MMPG-NBR (X-MMPG)
147500                                 TO WS-PTA-SALE-NBR
147600                                    (X-WS-PTA X-PTA-NBR-AMT)
147700                 ADD MMPG-AMT (X-MMPG)
147800                                 TO WS-PTA-SALE-AMT
147900                                    (X-WS-PTA X-PTA-NBR-AMT)
148000             END-PERFORM
148100         WHEN MMTCWS-LM-SALE-REV
148200             PERFORM
148300                 VARYING X-MTCC-MBU380-HIST FROM 1 BY 1
148400                 UNTIL X-MTCC-MBU380-HIST IS GREATER THAN 3
148500                 SET X-MMPG      TO MTCC-MBU380-HIST-PERIOD
148600                                    (X-MTCC-MBU380-HIST)
148700                 SET X-PTA-NBR-AMT
148800                                 TO X-MTCC-MBU380-HIST
148900                 SUBTRACT MMPG-NBR (X-MMPG)
149000                                 FROM WS-PTA-SALE-NBR
149100                                      (X-WS-PTA X-PTA-NBR-AMT)
149200                 SUBTRACT MMPG-AMT (X-MMPG)
149300                                 FROM WS-PTA-SALE-AMT
149400                                      (X-WS-PTA X-PTA-NBR-AMT)
149500             END-PERFORM
149600         WHEN MMTCWS-LM-RETURN
149700             PERFORM
149800                 VARYING X-MTCC-MBU380-HIST FROM 1 BY 1
149900                 UNTIL X-MTCC-MBU380-HIST IS GREATER THAN 3
150000                 SET X-MMPG      TO MTCC-MBU380-HIST-PERIOD
150100                                    (X-MTCC-MBU380-HIST)
150200                 SET X-PTA-NBR-AMT
150300                                 TO X-MTCC-MBU380-HIST
150400                 ADD MMPG-NBR (X-MMPG)
150500                                 TO WS-PTA-RETURN-NBR
150600                                    (X-WS-PTA X-PTA-NBR-AMT)
150700                 ADD MMPG-AMT (X-MMPG)
150800                                 TO WS-PTA-RETURN-AMT
150900                                    (X-WS-PTA X-PTA-NBR-AMT)
151000             END-PERFORM
151100         WHEN MMTCWS-LM-RETURN-REV
151200             PERFORM
151300                 VARYING X-MTCC-MBU380-HIST FROM 1 BY 1
151400                 UNTIL X-MTCC-MBU380-HIST IS GREATER THAN 3
151500                 SET X-MMPG      TO MTCC-MBU380-HIST-PERIOD
151600                                    (X-MTCC-MBU380-HIST)
151700                 SET X-PTA-NBR-AMT
151800                                 TO X-MTCC-MBU380-HIST
151900                 SUBTRACT MMPG-NBR (X-MMPG)
152000                                 FROM WS-PTA-RETURN-NBR
152100                                      (X-WS-PTA X-PTA-NBR-AMT)
152200                 SUBTRACT MMPG-AMT (X-MMPG)
152300                                 FROM WS-PTA-RETURN-AMT
152400                                      (X-WS-PTA X-PTA-NBR-AMT)
152500             END-PERFORM
152600     END-EVALUATE.
152700*
152800 C205-CALC-HIST.
152900*
153000     IF  MTCC-MBU380-HIST-NO
153100         GO TO C299-PD-EXIT.
153200*
153300     EVALUATE TRUE
153400         WHEN (MMPG-DETAIL
153500          AND (MMTCWS-LM-CR-FEES
153600           OR  MMTCWS-LM-REFUND))
153700             PERFORM
153800                 VARYING X-WS-HTA FROM 1 BY 1
153900                 UNTIL   X-WS-HTA IS GREATER THAN 12
154000                 SET X-MMPG      TO X-WS-HTA
154100                 SUBTRACT MMPG-AMT (X-MMPG)
154200                                 FROM  WS-HTA-TOTAL-INCOME
154300                                       (X-WS-HTA)
154400             END-PERFORM
154500         WHEN (MMPG-DETAIL
154600          AND (MMTCWS-LM-DR-FEES
154700           OR  MMTCWS-LM-DISCOUNT))
154800             PERFORM
154900                 VARYING X-WS-HTA FROM 1 BY 1
155000                 UNTIL   X-WS-HTA IS GREATER THAN 12
155100                 SET X-MMPG      TO X-WS-HTA
155200                 ADD MMPG-AMT (X-MMPG)
155300                                 TO WS-HTA-TOTAL-INCOME
155400                                    (X-WS-HTA)
155500             END-PERFORM
155600     END-EVALUATE.
155700*
155800     EVALUATE TRUE
155900         WHEN (MMTCWS-LM-SALE
156000          AND  MMPG-DETAIL)
156100             PERFORM
156200                 VARYING X-WS-HTA FROM 1 BY 1
156300                 UNTIL   X-WS-HTA IS GREATER THAN 12
156400                    SET X-MMPG   TO X-WS-HTA
156500                    ADD MMPG-NBR (X-MMPG)
156600                                 TO WS-HTA-SALE-NBR (X-WS-HTA)
156700                    ADD MMPG-AMT (X-MMPG)
156800                                 TO WS-HTA-SALE-AMT (X-WS-HTA)
156900             END-PERFORM
157000         WHEN (MMTCWS-LM-SALE-REV
157100          AND  MMPG-DETAIL)
157200             PERFORM
157300                 VARYING X-WS-HTA FROM 1 BY 1
157400                 UNTIL   X-WS-HTA IS GREATER THAN 12
157500                 SET X-MMPG      TO X-WS-HTA
157600                 SUBTRACT MMPG-NBR (X-MMPG)
157700                               FROM WS-HTA-SALE-NBR (X-WS-HTA)
157800                 SUBTRACT MMPG-AMT (X-MMPG)
157900                               FROM WS-HTA-SALE-AMT (X-WS-HTA)
158000             END-PERFORM
158100         WHEN (MMTCWS-LM-RETURN
158200          AND  MMPG-DETAIL)
158300             PERFORM
158400                 VARYING X-WS-HTA FROM 1 BY 1
158500                 UNTIL   X-WS-HTA IS GREATER THAN 12
158600                 SET X-MMPG      TO X-WS-HTA
158700                 ADD MMPG-NBR (X-MMPG)
158800                                 TO WS-HTA-RETURN-NBR (X-WS-HTA)
158900                 ADD MMPG-AMT (X-MMPG)
159000                                 TO WS-HTA-RETURN-AMT (X-WS-HTA)
159100             END-PERFORM
159200         WHEN (MMTCWS-LM-RETURN-REV
159300          AND  MMPG-DETAIL)
159400             PERFORM
159500                 VARYING X-WS-HTA FROM 1 BY 1
159600                 UNTIL   X-WS-HTA IS GREATER THAN 12
159700                 SET X-MMPG      TO X-WS-HTA
159800                 SUBTRACT MMPG-NBR (X-MMPG)
159900                               FROM WS-HTA-RETURN-NBR (X-WS-HTA)
160000                 SUBTRACT MMPG-AMT (X-MMPG)
160100                               FROM WS-HTA-RETURN-AMT (X-WS-HTA)
160200             END-PERFORM
160300         WHEN (MMTCWS-LM-RECOVERY-ADJ-CR
160400          AND  MMPG-DETAIL)
160500             PERFORM
160600                 VARYING X-WS-HTA FROM 1 BY 1
160700                 UNTIL   X-WS-HTA IS GREATER THAN 12
160800                 SET X-MMPG      TO X-WS-HTA
160900                 ADD MMPG-NBR (X-MMPG)
161000                                 TO WS-HTA-REC-ADJ-NBR (X-WS-HTA)
161100                 ADD MMPG-AMT (X-MMPG)
161200                                 TO WS-HTA-REC-ADJ-AMT (X-WS-HTA)
161300             END-PERFORM
161400         WHEN (MMTCWS-LM-RECOVERY-ADJ-DR
161500          AND  MMPG-DETAIL)
161600             PERFORM
161700                 VARYING X-WS-HTA FROM 1 BY 1
161800                 UNTIL   X-WS-HTA IS GREATER THAN 12
161900                 SET X-MMPG      TO X-WS-HTA
162000                 SUBTRACT MMPG-NBR (X-MMPG)
162100                               FROM WS-HTA-REC-ADJ-NBR (X-WS-HTA)
162200                 SUBTRACT MMPG-AMT (X-MMPG)
162300                               FROM WS-HTA-REC-ADJ-AMT (X-WS-HTA)
162400             END-PERFORM
162500         WHEN (MMTCWS-LM-ADJ-CR
162600          AND  MMPG-DETAIL)
162700             PERFORM
162800                 VARYING X-WS-HTA FROM 1 BY 1
162900                 UNTIL   X-WS-HTA IS GREATER THAN 12
163000                 SET X-MMPG      TO X-WS-HTA
163100                 ADD MMPG-NBR (X-MMPG)
163200                                 TO WS-HTA-ADJ-NBR (X-WS-HTA)
163300                 ADD MMPG-AMT (X-MMPG)
163400                                 TO WS-HTA-ADJ-AMT (X-WS-HTA)
163500             END-PERFORM
163600         WHEN (MMTCWS-LM-ADJ-DR
163700          AND  MMPG-DETAIL)
163800             PERFORM
163900                 VARYING X-WS-HTA FROM 1 BY 1
164000                 UNTIL   X-WS-HTA IS GREATER THAN 12
164100                 SET X-MMPG      TO X-WS-HTA
164200                 SUBTRACT MMPG-NBR (X-MMPG)
164300                               FROM WS-HTA-ADJ-NBR (X-WS-HTA)
164400                 SUBTRACT MMPG-AMT (X-MMPG)
164500                               FROM WS-HTA-ADJ-AMT (X-WS-HTA)
164600             END-PERFORM
164700     END-EVALUATE.
164800*
164900 C299-PD-EXIT.
165000     EXIT.
165100/
165200 C300-PRODUCT-TOTALS SECTION.
165300 C301-PT-BEGIN.
165400*
165500     IF  WS-PTA-NO-ACTIVITY (X-WS-PTA)
165600     OR  MTCC-MBU380-PROD-NO
165700         GO TO C399-PT-EXIT.
165800*
165900     MOVE WS-KEY-TYPE            TO MTRF-K2-O88-KEY-TYPE.
166000     MOVE MMRC-CHAIN             TO MTRF-K2-O88-MERCHANT.
166100     SET MTRF-K2-O88-RS-PRODUCT  TO TRUE.
166200     SET MTRF-K2-O88-RT-PROD-TOTALS
166300                                 TO TRUE.
166400     MOVE ZERO                   TO MTRF-K2-O88-CREDIT-PLAN.
166500     MOVE ZERO                   TO MTRF-K2-O88-LOGIC-MODULE.
166600     MOVE ZERO                   TO MTRF-K2-O88-HIST-YEAR.
166700     MOVE ZERO                   TO MTRF-K2-O88-HIST-MON.
166800     MOVE 1                      TO WS-U381-RPT-REC-TYPE.
166900*
167000     MOVE SPACES                 TO MTRF-O88-QL-DESC.
167100*
167200     EVALUATE TRUE
167300         WHEN X-WS-PTA IS EQUAL TO 101
167400             SET MTRF-K2-O88-ALL-PRODUCTS
167500                                 TO TRUE
167600         WHEN X-WS-PTA IS EQUAL TO 100
167700             MOVE ZERO           TO MTRF-K2-O88-PRODUCT
167800         WHEN OTHER
167900             SET  MTRF-K2-O88-PRODUCT
168000                                 TO X-WS-PTA
168100     END-EVALUATE.
168200*
168300     PERFORM
168400         VARYING X-MTCC-MBU380-HIST FROM 1 BY 1
168500         UNTIL X-MTCC-MBU380-HIST IS GREATER THAN 3
168600         SET X-PTA-NBR-AMT       TO X-MTCC-MBU380-HIST
168700         SET X-O88-PQ-TOT        TO X-MTCC-MBU380-HIST
168800         COMPUTE MTRF-O88-PQ-NET-SALES (X-O88-PQ-TOT)
168900                                 =  WS-PTA-SALE-AMT
169000                                    (X-WS-PTA X-PTA-NBR-AMT)
169100                                 -  WS-PTA-RETURN-AMT
169200                                    (X-WS-PTA X-PTA-NBR-AMT)
169300*
169400         IF  WS-PTA-SALE-NBR (X-WS-PTA X-PTA-NBR-AMT)
169500                                 IS NOT GREATER THAN ZERO
169600             MOVE ZERO           TO MTRF-O88-PQ-AVG-TKT
169700                                    (X-O88-PQ-TOT)
169800         ELSE
169900             COMPUTE MTRF-O88-PQ-AVG-TKT (X-O88-PQ-TOT) ROUNDED
170000                                 =  WS-PTA-SALE-AMT
170100                                    (X-WS-PTA X-PTA-NBR-AMT)
170200                                 /  WS-PTA-SALE-NBR
170300                                    (X-WS-PTA X-PTA-NBR-AMT)
170400         END-IF
170500*
170600         MOVE WS-PTA-TOTAL-INCOME (X-WS-PTA X-PTA-NBR-AMT)
170700                                 TO MTRF-O88-PQ-TOTAL-INCOME
170800                                    (X-O88-PQ-TOT)
170900     END-PERFORM.
171000*
171100     IF  MTCC-MBU380-PROD-TOT
171200     AND X-WS-PTA IS NOT EQUAL TO 101
171300         GO TO C399-PT-EXIT.
171400*
171500     PERFORM R980-WRITE-REPORT-FILE
171600        THRU R989-WRF-EXIT.
171700*
171800 C399-PT-EXIT.
171900     EXIT.
172000/
172100 D000-PRODUCT-QL-HEADER SECTION.
172200 D001-PQLH-BEGIN.
172300*
172400     IF  WS-QTA-PROD-NO-ACTIVITY (X-WS-QTA)
172500     OR  MTCC-MBU380-QUAL-NO
172600         GO TO D099-PQLH-EXIT.
172700*
172800     MOVE WS-KEY-TYPE            TO MTRF-K2-O88-KEY-TYPE.
172900     MOVE MMRC-CHAIN             TO MTRF-K2-O88-MERCHANT.
173000     SET MTRF-K2-O88-RS-QUAL-LEVEL
173100                                 TO TRUE.
173200     SET MTRF-K2-O88-RT-PROD-QL-HEADER
173300                                 TO TRUE.
173400     MOVE ZERO                   TO MTRF-K2-O88-CREDIT-PLAN.
173500     MOVE ZERO                   TO MTRF-K2-O88-LOGIC-MODULE.
173600     MOVE ZERO                   TO MTRF-K2-O88-HIST-YEAR.
173700     MOVE ZERO                   TO MTRF-K2-O88-HIST-MON.
173800     MOVE 1                      TO WS-U381-RPT-REC-TYPE.
173900*
174000     MOVE SPACES                 TO MTRF-O88-QL-DESC.
174100*
174200     EVALUATE TRUE
174300         WHEN X-WS-QTA IS EQUAL TO 101
174400             SET MTRF-K2-O88-ALL-PRODUCTS
174500                                 TO TRUE
174600             MOVE '**ALL PRODUCTS**'
174700                                 TO MTRF-O88-PROD-DESC
174800         WHEN X-WS-QTA IS EQUAL TO 100
174900             MOVE ZERO           TO MTRF-K2-O88-PRODUCT
175000             MOVE 'CHAIN LEVEL     '
175100                                 TO MTRF-O88-PROD-DESC
175200         WHEN OTHER
175300             SET  MTRF-K2-O88-PRODUCT
175400                                 TO X-WS-QTA
175500             SET  X-MMOC-PROD    TO X-WS-QTA
175600             MOVE MMOC-PRODUCT-DESC (X-MMOC-PROD)
175700                                 TO MTRF-O88-PROD-DESC
175800     END-EVALUATE.
175900*
176000     PERFORM R980-WRITE-REPORT-FILE
176100        THRU R989-WRF-EXIT.
176200*
176300 D099-PQLH-EXIT.
176400     EXIT.
176500/
176600 D100-QUAL-LEVEL-HEADER SECTION.
176700 D101-QLH-BEGIN.
176800*
176900     IF  WS-QTA-NO-ACTIVITY (X-WS-QTA X-WS-QTA-QL)
177000     OR  MTCC-MBU380-QUAL-NO
177100         GO TO D199-QLH-EXIT.
177200*
177300     IF  X-WS-QTA IS GREATER THAN 2
177400     AND X-WS-QTA-QL IS GREATER THAN 9
177500         GO TO D199-QLH-EXIT.
177600*
177700     MOVE WS-KEY-TYPE            TO MTRF-K2-O88-KEY-TYPE.
177800     MOVE MMRC-CHAIN             TO MTRF-K2-O88-MERCHANT.
177900     MOVE ZEROS                  TO MTRF-K2-O88-CREDIT-PLAN.
178000     SET MTRF-K2-O88-RS-QUAL-LEVEL
178100                                 TO TRUE.
178200     SET MTRF-K2-O88-RT-QL-HEADER
178300                                 TO TRUE.
178400     SET MTRF-K2-O88-QUAL-LEVEL  TO X-WS-QTA-QL.
178500     MOVE ZERO                   TO MTRF-K2-O88-LOGIC-MODULE.
178600     MOVE ZERO                   TO MTRF-K2-O88-HIST-YEAR.
178700     MOVE ZERO                   TO MTRF-K2-O88-HIST-MON.
178800     MOVE 1                      TO WS-U381-RPT-REC-TYPE.
178900*
179000     EVALUATE TRUE
179100         WHEN X-WS-QTA IS EQUAL TO 101
179200             SET MTRF-K2-O88-ALL-PRODUCTS
179300                                 TO TRUE
179400             MOVE 'ALL QUAL-LEVELS'
179500                                 TO MTRF-O88-PROD-DESC
179600         WHEN X-WS-QTA IS EQUAL TO 100
179700             MOVE ZERO           TO MTRF-K2-O88-PRODUCT
179800             MOVE 'CHAIN LEVEL     '
179900                                 TO MTRF-O88-PROD-DESC
180000         WHEN OTHER
180100             SET  MTRF-K2-O88-PRODUCT
180200                                 TO X-WS-QTA
180300             SET  X-MMOC-PROD    TO X-WS-QTA
180400             MOVE MMOC-PRODUCT-DESC (X-MMOC-PROD)
180500                                 TO MTRF-O88-PROD-DESC
180600     END-EVALUATE.
180700*
180800     MOVE SPACES                 TO MTRF-O88-QL-DESC.
180900*
181000     EVALUATE TRUE
181100         WHEN X-WS-QTA IS GREATER THAN 99
181200             MOVE 'QUAL LEVEL-'
181300                                 TO MTRF-O88-QL-DESC
181400             SET  WS-U381-QL-DISPLAY
181500                                 TO X-WS-QTA-QL
181600             MOVE WS-U381-QL-DISPLAY-X
181700                                 TO MTRF-O88-QL-DESC (12:2)
181800         WHEN (X-WS-QTA IS EQUAL TO 1
181900           OR  X-WS-QTA IS EQUAL TO 2)
182000             SET X-MB80WS-IFT    TO X-WS-QTA
182100             SET X-MB80WS-QL     TO X-WS-QTA-QL
182200             MOVE MB80WS-INTCHG-QL-DESC
182300                  (X-MB80WS-IFT X-MB80WS-QL)
182400                                 TO MTRF-O88-QL-DESC
182500         WHEN OTHER
182600             SET X-MB80WS-PL-IFT TO X-WS-QTA
182700             SET X-MB80WS-PL-QL  TO X-WS-QTA-QL
182800             MOVE MB80WS-PL-INTCHG-QL-DESC
182900                  (X-MB80WS-PL-IFT X-MB80WS-PL-QL)
183000                                 TO MTRF-O88-QL-DESC
183100     END-EVALUATE.
183200*
183300     PERFORM R980-WRITE-REPORT-FILE
183400        THRU R989-WRF-EXIT.
183500*
183600 D199-QLH-EXIT.
183700     EXIT.
183800/
183900 D200-QUAL-LEVEL-DETAIL SECTION.
184000 D201-QLD-BEGIN.
184100*
184200     IF  MTCC-MBU380-QUAL-NO
184300         GO TO D299-QLD-EXIT.
184400*
184500     MOVE WS-KEY-TYPE            TO MTRF-K2-O88-KEY-TYPE.
184600     MOVE MMRC-CHAIN             TO MTRF-K2-O88-MERCHANT.
184700     MOVE ZEROS                  TO MTRF-K2-O88-CREDIT-PLAN.
184800     SET MTRF-K2-O88-RS-QUAL-LEVEL
184900                                 TO TRUE.
185000*
185100     IF  MMOG-DETAIL
185200         EVALUATE TRUE
185300             WHEN MMOG-PRODUCT IS GREATER THAN ZERO
185400                 SET X-WS-QTA    TO MMOG-PRODUCT
185500             WHEN OTHER
185600                 SET X-WS-QTA    TO 100
185700         END-EVALUATE
185800         MOVE MMOG-PRODUCT       TO MTRF-K2-O88-PRODUCT
185900     ELSE
186000         SET X-WS-QTA            TO 101
186100         SET MTRF-K2-O88-ALL-PRODUCTS
186200                                 TO TRUE.
186300*
186400     IF  MMOG-QUAL-LEVEL IS GREATER THAN ZERO
186500         EVALUATE TRUE
186600             WHEN (MMOG-PROD-IS-VISA
186700               OR  MMOG-PROD-IS-MC)
186800                 SET X-WS-QTA-QL TO MMOG-QUAL-LEVEL
186900             WHEN OTHER
187000                 IF  MMOG-QUAL-LEVEL IS GREATER THAN 9
187100                     SET X-WS-QTA-QL
187200                                 TO 9
187300                 ELSE
187400                     SET X-WS-QTA-QL
187500                                 TO MMOG-QUAL-LEVEL
187600                 END-IF
187700         END-EVALUATE
187800     ELSE
187900         EVALUATE TRUE
188000             WHEN (MMOG-PROD-IS-VISA
188100               OR  MMOG-PROD-IS-MC)
188200                 SET X-WS-QTA-QL TO 99
188300             WHEN OTHER
188400                 SET X-WS-QTA-QL TO 9
188500         END-EVALUATE.
188600*
188700     SET MTRF-K2-O88-RT-QL-DETAIL
188800                                 TO TRUE.
188900     SET MTRF-K2-O88-QUAL-LEVEL  TO X-WS-QTA-QL.
189000     MOVE MMOG-LOGIC-MODULE      TO MTRF-K2-O88-LOGIC-MODULE.
189100     MOVE ZERO                   TO MTRF-K2-O88-HIST-YEAR.
189200     MOVE ZERO                   TO MTRF-K2-O88-HIST-MON.
189300     MOVE 1                      TO WS-U381-RPT-REC-TYPE.
189400*
189500     MOVE MMOG-LOGIC-MODULE      TO MTRF-O88-LOGIC-MODULE.
189600*
189700     PERFORM
189800         VARYING X-MTCC-MBU380-HIST FROM 1 BY 1
189900         UNTIL X-MTCC-MBU380-HIST IS GREATER THAN 3
190000         SET X-MMOG              TO MTCC-MBU380-HIST-PERIOD
190100                                    (X-MTCC-MBU380-HIST)
190200         SET X-O88-PQ-DET        TO X-MTCC-MBU380-HIST
190300         MOVE MMOG-NBR (X-MMOG)  TO MTRF-O88-NBR-DET
190400                                    (X-O88-PQ-DET)
190500         MOVE MMOG-AMT (X-MMOG)  TO MTRF-O88-AMT-DET
190600                                    (X-O88-PQ-DET)
190700     END-PERFORM.
190800*
190900     PERFORM R980-WRITE-REPORT-FILE
191000        THRU R989-WRF-EXIT.
191100*
191200     SET WS-QTA-ACTIVITY (X-WS-QTA X-WS-QTA-QL)
191300                                 TO TRUE.
191400     SET WS-QTA-PROD-ACTIVITY (X-WS-QTA)
191500                                 TO TRUE.
191600*
191700     EVALUATE TRUE
191800         WHEN MMTCWS-LM-SALE
191900             PERFORM
192000                 VARYING X-MTCC-MBU380-HIST FROM 1 BY 1
192100                 UNTIL X-MTCC-MBU380-HIST IS GREATER THAN 3
192200                 SET X-MMOG      TO MTCC-MBU380-HIST-PERIOD
192300                                    (X-MTCC-MBU380-HIST)
192400                 SET X-QTA-NBR-AMT
192500                                 TO X-MTCC-MBU380-HIST
192600                 ADD MMOG-NBR (X-MMOG)
192700                                 TO WS-QTA-SALE-NBR
192800                             (X-WS-QTA X-WS-QTA-QL X-QTA-NBR-AMT)
192900                 ADD MMOG-AMT (X-MMOG)
193000                                 TO WS-QTA-SALE-AMT
193100                             (X-WS-QTA X-WS-QTA-QL X-QTA-NBR-AMT)
193200             END-PERFORM
193300         WHEN MMTCWS-LM-SALE-REV
193400             PERFORM
193500                 VARYING X-MTCC-MBU380-HIST FROM 1 BY 1
193600                 UNTIL X-MTCC-MBU380-HIST IS GREATER THAN 3
193700                 SET X-MMOG      TO MTCC-MBU380-HIST-PERIOD
193800                                    (X-MTCC-MBU380-HIST)
193900                 SET X-QTA-NBR-AMT
194000                                 TO X-MTCC-MBU380-HIST
194100                 SUBTRACT MMOG-NBR (X-MMOG)
194200                                 FROM WS-QTA-SALE-NBR
194300                             (X-WS-QTA X-WS-QTA-QL X-QTA-NBR-AMT)
194400                 SUBTRACT MMOG-AMT (X-MMOG)
194500                                 FROM WS-QTA-SALE-AMT
194600                             (X-WS-QTA X-WS-QTA-QL X-QTA-NBR-AMT)
194700             END-PERFORM
194800         WHEN MMTCWS-LM-RETURN
194900             PERFORM
195000                 VARYING X-MTCC-MBU380-HIST FROM 1 BY 1
195100                 UNTIL X-MTCC-MBU380-HIST IS GREATER THAN 3
195200                 SET X-MMOG      TO MTCC-MBU380-HIST-PERIOD
195300                                    (X-MTCC-MBU380-HIST)
195400                 SET X-QTA-NBR-AMT
195500                                 TO X-MTCC-MBU380-HIST
195600                 ADD MMOG-NBR (X-MMOG)
195700                                 TO WS-QTA-RETURN-NBR
195800                             (X-WS-QTA X-WS-QTA-QL X-QTA-NBR-AMT)
195900                 ADD MMOG-AMT (X-MMOG)
196000                                 TO WS-QTA-RETURN-AMT
196100                             (X-WS-QTA X-WS-QTA-QL X-QTA-NBR-AMT)
196200             END-PERFORM
196300         WHEN MMTCWS-LM-RETURN-REV
196400             PERFORM
196500                 VARYING X-MTCC-MBU380-HIST FROM 1 BY 1
196600                 UNTIL X-MTCC-MBU380-HIST IS GREATER THAN 3
196700                 SET X-MMOG      TO MTCC-MBU380-HIST-PERIOD
196800                                    (X-MTCC-MBU380-HIST)
196900                 SET X-QTA-NBR-AMT
197000                                 TO X-MTCC-MBU380-HIST
197100                 SUBTRACT MMOG-NBR (X-MMOG)
197200                                 FROM WS-QTA-RETURN-NBR
197300                             (X-WS-QTA X-WS-QTA-QL X-QTA-NBR-AMT)
197400                 SUBTRACT MMOG-AMT (X-MMOG)
197500                                 FROM WS-QTA-RETURN-AMT
197600                             (X-WS-QTA X-WS-QTA-QL X-QTA-NBR-AMT)
197700             END-PERFORM
197800     END-EVALUATE.
197900*
198000 D299-QLD-EXIT.
198100     EXIT.
198200/
198300 D300-QUAL-LEVEL-TOTALS SECTION.
198400 D301-QLT-BEGIN.
198500*
198600     IF  WS-QTA-NO-ACTIVITY (X-WS-QTA X-WS-QTA-QL)
198700     OR  MTCC-MBU380-QUAL-NO
198800         GO TO D399-QLT-EXIT.
198900*
199000     IF  X-WS-QTA IS GREATER THAN 2
199100     AND X-WS-QTA-QL IS GREATER THAN 9
199200         GO TO D399-QLT-EXIT.
199300*
199400     MOVE WS-KEY-TYPE            TO MTRF-K2-O88-KEY-TYPE.
199500     MOVE MMRC-CHAIN             TO MTRF-K2-O88-MERCHANT.
199600     MOVE ZEROS                  TO MTRF-K2-O88-CREDIT-PLAN.
199700     SET MTRF-K2-O88-RS-QUAL-LEVEL
199800                                 TO TRUE.
199900     SET MTRF-K2-O88-RT-QL-TOTALS
200000                                 TO TRUE.
200100     SET MTRF-K2-O88-QUAL-LEVEL  TO X-WS-QTA-QL.
200200     MOVE ZERO                   TO MTRF-K2-O88-LOGIC-MODULE.
200300     MOVE ZERO                   TO MTRF-K2-O88-HIST-YEAR.
200400     MOVE ZERO                   TO MTRF-K2-O88-HIST-MON.
200500     MOVE 1                      TO WS-U381-RPT-REC-TYPE.
200600*
200700     MOVE SPACES                 TO MTRF-O88-QL-DESC.
200800*
200900     INITIALIZE MTRF-O88-PROD-QL-TOTALS.
201000*
201100     EVALUATE TRUE
201200         WHEN X-WS-QTA IS EQUAL TO 101
201300             SET MTRF-K2-O88-ALL-PRODUCTS
201400                                 TO TRUE
201500         WHEN X-WS-QTA IS EQUAL TO 100
201600             MOVE ZERO           TO MTRF-K2-O88-PRODUCT
201700         WHEN OTHER
201800             SET  MTRF-K2-O88-PRODUCT
201900                                 TO X-WS-QTA
202000     END-EVALUATE.
202100*
202200*
202300     PERFORM
202400         VARYING X-MTCC-MBU380-HIST FROM 1 BY 1
202500         UNTIL X-MTCC-MBU380-HIST IS GREATER THAN 3
202600         SET X-QTA-NBR-AMT       TO X-MTCC-MBU380-HIST
202700         SET X-O88-PQ-TOT        TO X-MTCC-MBU380-HIST
202800         COMPUTE MTRF-O88-PQ-NET-SALES (X-O88-PQ-TOT)
202900                                 =  WS-QTA-SALE-AMT
203000                             (X-WS-QTA X-WS-QTA-QL X-QTA-NBR-AMT)
203100                                 -  WS-QTA-RETURN-AMT
203200                             (X-WS-QTA X-WS-QTA-QL X-QTA-NBR-AMT)
203300*
203400         IF  WS-QTA-SALE-NBR (X-WS-QTA X-WS-QTA-QL X-QTA-NBR-AMT)
203500                                 IS NOT GREATER THAN ZERO
203600             MOVE ZERO           TO MTRF-O88-PQ-AVG-TKT
203700                                    (X-O88-PQ-TOT)
203800         ELSE
203900             COMPUTE MTRF-O88-PQ-AVG-TKT (X-O88-PQ-TOT) ROUNDED
204000                                 =  WS-QTA-SALE-AMT
204100                             (X-WS-QTA X-WS-QTA-QL X-QTA-NBR-AMT)
204200                                 /  WS-QTA-SALE-NBR
204300                             (X-WS-QTA X-WS-QTA-QL X-QTA-NBR-AMT)
204400         END-IF
204500     END-PERFORM.
204600*
204700     PERFORM R980-WRITE-REPORT-FILE
204800        THRU R989-WRF-EXIT.
204900*
205000 D399-QLT-EXIT.
205100     EXIT.
205200/
205300 E000-PRODUCT-CP-HEADER SECTION.
205400 E001-PCPH-BEGIN.
205500*
205600     IF  MTCC-MBU380-PLAN-NO
205700         GO TO E099-PCPH-EXIT.
205800*
205900     IF (MTCC-MBU380-ORG-OPTION
206000     OR  MTCC-MBU380-SYSTEM-OPTION)
206100         IF  MMCG-ORG IS GREATER THAN
206200                                 MMOC-ORG
206300            GO TO E001-CONT
206400         ELSE
206500             IF  MMCG-PRODUCT IS EQUAL TO WS-PREV-PROD
206600                 GO TO E099-PCPH-EXIT
206700             ELSE
206800                 GO TO E001-CONT.
206900*
207000     IF  MMCG-ORG-ACCT  IS GREATER THAN
207100                                 MMRC-ORG-CHAIN
207200         NEXT SENTENCE
207300     ELSE
207400         IF  MMCG-PRODUCT IS EQUAL TO WS-PREV-PROD
207500             GO TO E099-PCPH-EXIT.
207600*
207700 E001-CONT.
207800*
207900     MOVE WS-KEY-TYPE            TO MTRF-K2-O88-KEY-TYPE.
208000     MOVE MMRC-CHAIN             TO MTRF-K2-O88-MERCHANT.
208100     SET MTRF-K2-O88-RS-CREDIT-PLAN
208200                                 TO TRUE.
208300     SET MTRF-K2-O88-RT-PROD-CP-HEADER
208400                                 TO TRUE.
208500     MOVE ZERO                   TO MTRF-K2-O88-CREDIT-PLAN.
208600     MOVE ZERO                   TO MTRF-K2-O88-LOGIC-MODULE.
208700     MOVE ZERO                   TO MTRF-K2-O88-HIST-YEAR.
208800     MOVE ZERO                   TO MTRF-K2-O88-HIST-MON.
208900     MOVE 1                      TO WS-U381-RPT-REC-TYPE.
209000*
209100     MOVE SPACES                 TO MTRF-O88-QL-DESC
209200                                    MTRF-O88-CP-DESC.
209300*
209400     EVALUATE TRUE
209500         WHEN WS-CTA IS EQUAL TO 101
209600             SET MTRF-K2-O88-ALL-PRODUCTS
209700                                 TO TRUE
209800             MOVE '**ALL PRODUCTS**'
209900                                 TO MTRF-O88-PROD-DESC
210000         WHEN WS-CTA IS EQUAL TO 100
210100             MOVE ZERO           TO MTRF-K2-O88-PRODUCT
210200             MOVE 'CHAIN LEVEL     '
210300                                 TO MTRF-O88-PROD-DESC
210400         WHEN OTHER
210500             MOVE WS-PREV-PROD   TO MTRF-K2-O88-PRODUCT
210600             SET  X-MMOC-PROD    TO WS-PREV-PROD
210700             MOVE MMOC-PRODUCT-DESC (X-MMOC-PROD)
210800                                 TO MTRF-O88-PROD-DESC
210900     END-EVALUATE.
211000*
211100     PERFORM R980-WRITE-REPORT-FILE
211200        THRU R989-WRF-EXIT.
211300*
211400 E099-PCPH-EXIT.
211500     EXIT.
211600/
211700 E100-CREDIT-PLAN-HEADER SECTION.
211800 E101-CPH-BEGIN.
211900*
212000     IF  MTCC-MBU380-PLAN-NO
212100         GO TO E199-CPH-EXIT.
212200*
212300     IF (MTCC-MBU380-ORG-OPTION
212400     OR  MTCC-MBU380-SYSTEM-OPTION)
212500         IF  MMCG-ORG IS GREATER THAN
212600                                 MMOC-ORG
212700             GO TO E101-CONT
212800         ELSE
212900             IF  (MMCG-PRODUCT IS NOT EQUAL TO WS-PREV-PROD
213000             OR  MMCG-PLAN IS NOT EQUAL TO WS-PREV-PLAN)
213100                 GO TO E101-CONT
213200             ELSE
213300                 GO TO E199-CPH-EXIT.
213400*
213500     IF  MMCG-ORG-ACCT  IS GREATER THAN
213600                                 MMRC-ORG-CHAIN
213700         NEXT SENTENCE
213800     ELSE
213900         IF  (MMCG-PRODUCT IS NOT EQUAL TO WS-PREV-PROD
214000         OR  MMCG-PLAN IS NOT EQUAL TO WS-PREV-PLAN)
214100             NEXT SENTENCE
214200         ELSE
214300             GO TO E199-CPH-EXIT.
214400*
214500 E101-CONT.
214600*
214700     MOVE WS-KEY-TYPE            TO MTRF-K2-O88-KEY-TYPE.
214800     MOVE MMRC-CHAIN             TO MTRF-K2-O88-MERCHANT.
214900     SET MTRF-K2-O88-RS-CREDIT-PLAN
215000                                 TO TRUE.
215100     SET MTRF-K2-O88-RT-CP-HEADER
215200                                 TO TRUE.
215300     MOVE WS-PREV-PLAN           TO MTRF-K2-O88-CREDIT-PLAN.
215400     MOVE ZERO                   TO MTRF-K2-O88-LOGIC-MODULE.
215500     MOVE ZERO                   TO MTRF-K2-O88-HIST-YEAR.
215600     MOVE ZERO                   TO MTRF-K2-O88-HIST-MON.
215700     MOVE 1                      TO WS-U381-RPT-REC-TYPE.
215800*
215900     EVALUATE TRUE
216000         WHEN WS-CTA IS EQUAL TO 101
216100             SET MTRF-K2-O88-ALL-PRODUCTS
216200                                 TO TRUE
216300             MOVE 'ALL CREDIT-PLANS'
216400                                 TO MTRF-O88-PROD-DESC
216500         WHEN WS-CTA IS EQUAL TO 100
216600             MOVE ZERO           TO MTRF-K2-O88-PRODUCT
216700             MOVE 'CHAIN LEVEL     '
216800                                 TO MTRF-O88-PROD-DESC
216900         WHEN OTHER
217000             MOVE WS-PREV-PROD   TO MTRF-K2-O88-PRODUCT
217100             SET  X-MMOC-PROD    TO WS-PREV-PROD
217200             MOVE MMOC-PRODUCT-DESC (X-MMOC-PROD)
217300                                 TO MTRF-O88-PROD-DESC
217400     END-EVALUATE.
217500*
217600     MOVE SPACES                 TO MTRF-O88-QL-DESC.
217700*
217800     MOVE 'CREDIT PLAN'          TO MTRF-O88-QL-DESC.
217900     MOVE MMCG-PLAN              TO WS-U381-CP-DISPLAY.
218000     MOVE WS-U381-CP-DISPLAY-X   TO MTRF-O88-CP-DESC (13:5).
218100*
218200     PERFORM R980-WRITE-REPORT-FILE
218300        THRU R989-WRF-EXIT.
218400*
218500 E199-CPH-EXIT.
218600     EXIT.
218700/
218800 E200-CREDIT-PLAN-DETAIL SECTION.
218900 E201-CPD-BEGIN.
219000*
219100     IF  MTCC-MBU380-PLAN-NO
219200         GO TO E299-CPD-EXIT.
219300*
219400     MOVE WS-KEY-TYPE            TO MTRF-K2-O88-KEY-TYPE.
219500     MOVE MMRC-CHAIN             TO MTRF-K2-O88-MERCHANT.
219600     SET MTRF-K2-O88-RS-CREDIT-PLAN
219700                                 TO TRUE.
219800*
219900     IF  MMCG-DETAIL
220000         EVALUATE TRUE
220100             WHEN MMCG-PRODUCT IS GREATER THAN ZERO
220200                 MOVE MMCG-PRODUCT
220300                                 TO WS-CTA
220400             WHEN OTHER
220500                 MOVE 100        TO WS-CTA
220600         END-EVALUATE
220700         MOVE MMCG-PRODUCT       TO MTRF-K2-O88-PRODUCT
220800     ELSE
220900         MOVE 101                TO WS-CTA
221000         SET MTRF-K2-O88-ALL-PRODUCTS
221100                                 TO TRUE.
221200*
221300     SET MTRF-K2-O88-RT-CP-DETAIL
221400                                 TO TRUE.
221500     MOVE MMCG-PLAN              TO MTRF-K2-O88-CREDIT-PLAN.
221600     MOVE MMCG-LOGIC-MODULE      TO MTRF-K2-O88-LOGIC-MODULE.
221700     MOVE ZERO                   TO MTRF-K2-O88-HIST-YEAR.
221800     MOVE ZERO                   TO MTRF-K2-O88-HIST-MON.
221900     MOVE 1                      TO WS-U381-RPT-REC-TYPE.
222000*
222100     MOVE MMCG-LOGIC-MODULE      TO MTRF-O88-LOGIC-MODULE.
222200*
222300     PERFORM
222400         VARYING X-MTCC-MBU380-HIST FROM 1 BY 1
222500         UNTIL X-MTCC-MBU380-HIST IS GREATER THAN 3
222600         SET X-MMCG              TO MTCC-MBU380-HIST-PERIOD
222700                                    (X-MTCC-MBU380-HIST)
222800         SET X-O88-PQ-DET        TO X-MTCC-MBU380-HIST
222900         MOVE MMCG-NBR (X-MMCG)  TO MTRF-O88-NBR-DET
223000                                    (X-O88-PQ-DET)
223100         MOVE MMCG-AMT (X-MMCG)  TO MTRF-O88-AMT-DET
223200                                    (X-O88-PQ-DET)
223300     END-PERFORM.
223400*
223500     PERFORM R980-WRITE-REPORT-FILE
223600        THRU R989-WRF-EXIT.
223700*
223800     EVALUATE TRUE
223900         WHEN MMTCWS-LM-SALE
224000             PERFORM
224100                 VARYING X-MTCC-MBU380-HIST FROM 1 BY 1
224200                 UNTIL X-MTCC-MBU380-HIST IS GREATER THAN 3
224300                 SET X-MMCG      TO MTCC-MBU380-HIST-PERIOD
224400                                    (X-MTCC-MBU380-HIST)
224500                 SET X-CTA-NBR-AMT
224600                                 TO X-MTCC-MBU380-HIST
224700                 ADD MMCG-NBR (X-MMCG)
224800                                 TO WS-CTA-SALE-NBR
224900                                    (X-CTA-NBR-AMT)
225000                 ADD MMCG-AMT (X-MMCG)
225100                                 TO WS-CTA-SALE-AMT
225200                                    (X-CTA-NBR-AMT)
225300             END-PERFORM
225400         WHEN MMTCWS-LM-SALE-REV
225500             PERFORM
225600                 VARYING X-MTCC-MBU380-HIST FROM 1 BY 1
225700                 UNTIL X-MTCC-MBU380-HIST IS GREATER THAN 3
225800                 SET X-MMCG      TO MTCC-MBU380-HIST-PERIOD
225900                                    (X-MTCC-MBU380-HIST)
226000                 SET X-CTA-NBR-AMT
226100                                 TO X-MTCC-MBU380-HIST
226200                 SUBTRACT MMCG-NBR (X-MMCG)
226300                                 FROM WS-CTA-SALE-NBR
226400                                    (X-CTA-NBR-AMT)
226500                 SUBTRACT MMCG-AMT (X-MMCG)
226600                                 FROM WS-CTA-SALE-AMT
226700                                    (X-CTA-NBR-AMT)
226800             END-PERFORM
226900         WHEN MMTCWS-LM-RETURN
227000             PERFORM
227100                 VARYING X-MTCC-MBU380-HIST FROM 1 BY 1
227200                 UNTIL X-MTCC-MBU380-HIST IS GREATER THAN 3
227300                 SET X-MMCG      TO MTCC-MBU380-HIST-PERIOD
227400                                    (X-MTCC-MBU380-HIST)
227500                 SET X-CTA-NBR-AMT
227600                                 TO X-MTCC-MBU380-HIST
227700                 ADD MMCG-NBR (X-MMCG)
227800                                 TO WS-CTA-RETURN-NBR
227900                                    (X-CTA-NBR-AMT)
228000                 ADD MMCG-AMT (X-MMCG)
228100                                 TO WS-CTA-RETURN-AMT
228200                                    (X-CTA-NBR-AMT)
228300             END-PERFORM
228400         WHEN MMTCWS-LM-RETURN-REV
228500             PERFORM
228600                 VARYING X-MTCC-MBU380-HIST FROM 1 BY 1
228700                 UNTIL X-MTCC-MBU380-HIST IS GREATER THAN 3
228800                 SET X-MMCG      TO MTCC-MBU380-HIST-PERIOD
228900                                    (X-MTCC-MBU380-HIST)
229000                 SET X-CTA-NBR-AMT
229100                                 TO X-MTCC-MBU380-HIST
229200                 SUBTRACT MMCG-NBR (X-MMCG)
229300                                 FROM WS-CTA-RETURN-NBR
229400                                   (X-CTA-NBR-AMT)
229500                 SUBTRACT MMCG-AMT (X-MMCG)
229600                                 FROM WS-CTA-RETURN-AMT
229700                                   (X-CTA-NBR-AMT)
229800             END-PERFORM
229900     END-EVALUATE.
230000*
230100 E299-CPD-EXIT.
230200     EXIT.
230300/
230400 E300-CREDIT-PLAN-TOTALS SECTION.
230500 E301-CPT-BEGIN.
230600*
230700     IF  MTCC-MBU380-PLAN-NO
230800         GO TO E399-CPT-EXIT.
230900*
231000     IF (MTCC-MBU380-ORG-OPTION
231100     OR  MTCC-MBU380-SYSTEM-OPTION)
231200         IF  MMCG-ORG IS GREATER THAN
231300                                 MMOC-ORG
231400             GO TO E301-CONT
231500         ELSE
231600             IF (MMCG-PRODUCT IS NOT EQUAL TO WS-PREV-PROD
231700             OR  MMCG-PLAN IS NOT EQUAL TO WS-PREV-PLAN)
231800                 GO TO E301-CONT
231900             ELSE
232000                 GO TO E399-CPT-EXIT.
232100*
232200     IF  MMCG-ORG-ACCT  IS GREATER THAN
232300                                 MMRC-ORG-CHAIN
232400         NEXT SENTENCE
232500     ELSE
232600         IF  MMCG-PRODUCT IS NOT EQUAL TO WS-PREV-PROD
232700         OR  MMCG-PLAN IS NOT EQUAL TO WS-PREV-PLAN
232800             NEXT SENTENCE
232900         ELSE
233000             GO TO E399-CPT-EXIT.
233100*
233200 E301-CONT.
233300*
233400     MOVE WS-KEY-TYPE            TO MTRF-K2-O88-KEY-TYPE.
233500     MOVE MMRC-CHAIN             TO MTRF-K2-O88-MERCHANT.
233600     SET MTRF-K2-O88-RS-CREDIT-PLAN
233700                                 TO TRUE.
233800     SET MTRF-K2-O88-RT-CP-TOTALS
233900                                 TO TRUE.
234000     MOVE WS-PREV-PLAN           TO MTRF-K2-O88-CREDIT-PLAN.
234100     MOVE ZERO                   TO MTRF-K2-O88-LOGIC-MODULE.
234200     MOVE ZERO                   TO MTRF-K2-O88-HIST-YEAR.
234300     MOVE ZERO                   TO MTRF-K2-O88-HIST-MON.
234400     MOVE 1                      TO WS-U381-RPT-REC-TYPE.
234500*
234600     MOVE SPACES                 TO MTRF-O88-QL-DESC.
234700*
234800     INITIALIZE MTRF-O88-PROD-QL-TOTALS.
234900*
235000     EVALUATE TRUE
235100         WHEN WS-CTA IS EQUAL TO 101
235200             SET MTRF-K2-O88-ALL-PRODUCTS
235300                                 TO TRUE
235400         WHEN WS-CTA IS EQUAL TO 100
235500             MOVE ZERO           TO MTRF-K2-O88-PRODUCT
235600         WHEN OTHER
235700             MOVE WS-PREV-PROD   TO MTRF-K2-O88-PRODUCT
235800     END-EVALUATE.
235900*
236000*
236100     PERFORM
236200         VARYING X-MTCC-MBU380-HIST FROM 1 BY 1
236300         UNTIL X-MTCC-MBU380-HIST IS GREATER THAN 3
236400         SET X-CTA-NBR-AMT       TO X-MTCC-MBU380-HIST
236500         SET X-O88-PQ-TOT        TO X-MTCC-MBU380-HIST
236600         COMPUTE MTRF-O88-PQ-NET-SALES (X-O88-PQ-TOT)
236700                                 =  WS-CTA-SALE-AMT
236800                                    (X-CTA-NBR-AMT)
236900                                 -  WS-CTA-RETURN-AMT
237000                                    (X-CTA-NBR-AMT)
237100*
237200         IF  WS-CTA-SALE-NBR (X-CTA-NBR-AMT)
237300                                 IS NOT GREATER THAN ZERO
237400             MOVE ZERO       TO MTRF-O88-PQ-AVG-TKT
237500                                    (X-O88-PQ-TOT)
237600         ELSE
237700             COMPUTE MTRF-O88-PQ-AVG-TKT (X-O88-PQ-TOT)
237800                                             ROUNDED
237900                                 =  WS-CTA-SALE-AMT
238000                                    (X-CTA-NBR-AMT)
238100                                 /  WS-CTA-SALE-NBR
238200                                    (X-CTA-NBR-AMT)
238300         END-IF
238400     END-PERFORM.
238500*
238600     PERFORM R980-WRITE-REPORT-FILE
238700        THRU R989-WRF-EXIT.
238800*
238900     PERFORM
239000         VARYING X-CTA-NBR-AMT FROM 1 BY 1
239100         UNTIL X-CTA-NBR-AMT IS GREATER THAN 3
239200         MOVE ZEROS              TO WS-CTA-SALE-AMT
239300                                    (X-CTA-NBR-AMT)
239400                                    WS-CTA-SALE-AMT
239500                                    (X-CTA-NBR-AMT)
239600                                    WS-CTA-SALE-NBR
239700                                    (X-CTA-NBR-AMT)
239800                                    WS-CTA-RETURN-AMT
239900                                    (X-CTA-NBR-AMT)
240000                                    WS-CTA-RETURN-NBR
240100                                    (X-CTA-NBR-AMT)
240200     END-PERFORM.
240300*
240400 E399-CPT-EXIT.
240500     EXIT.
240600/
240700 F100-HIST-HEADER SECTION.
240800 F101-HH-BEGIN.
240900*
241000     IF  MTCC-MBU380-HIST-NO
241100         GO TO F199-HH-EXIT.
241200*
241300     MOVE WS-KEY-TYPE            TO MTRF-K2-O88-KEY-TYPE.
241400     MOVE MMRC-CHAIN             TO MTRF-K2-O88-MERCHANT.
241500     SET MTRF-K2-O88-RS-HISTORICAL
241600                                 TO TRUE.
241700     SET MTRF-K2-O88-RT-HIST-HEADER
241800                                 TO TRUE.
241900     MOVE ZERO                   TO MTRF-K2-O88-CREDIT-PLAN.
242000     MOVE ZERO                   TO MTRF-K2-O88-PRODUCT.
242100     MOVE ZERO                   TO MTRF-K2-O88-LOGIC-MODULE.
242200     MOVE ZERO                   TO MTRF-K2-O88-HIST-YEAR.
242300     MOVE ZERO                   TO MTRF-K2-O88-HIST-MON.
242400     MOVE 1                      TO WS-U381-RPT-REC-TYPE.
242500*
242600     PERFORM R980-WRITE-REPORT-FILE
242700        THRU R989-WRF-EXIT.
242800*
242900 F199-HH-EXIT.
243000     EXIT.
243100/
243200 F900-HISTORICAL SECTION.
243300 F901-H-BEGIN.
243400*
243500     IF  MTCC-MBU380-HIST-NO
243600         GO TO F999-H-EXIT.
243700*
243800     MOVE WS-KEY-TYPE            TO MTRF-K2-O88-KEY-TYPE.
243900     MOVE MMRC-CHAIN             TO MTRF-K2-O88-MERCHANT.
244000     SET MTRF-K2-O88-RS-HISTORICAL
244100                                 TO TRUE.
244200     SET MTRF-K2-O88-RT-HISTORICAL
244300                                 TO TRUE.
244400     MOVE ZERO                   TO MTRF-K2-O88-PRODUCT.
244500     MOVE ZERO                   TO MTRF-K2-O88-CREDIT-PLAN.
244600     MOVE ZERO                   TO MTRF-K2-O88-LOGIC-MODULE.
244700     SET  X-WS-HTA               TO X-MMRC.
244800     MOVE MMRC-OCCURRENCE-YEAR (X-MMRC)
244900                                 TO MTRF-K2-O88-HIST-YEAR.
245000     EVALUATE TRUE
245100         WHEN MMRC-OID-JAN (X-MMRC)
245200             MOVE 01             TO MTRF-K2-O88-HIST-MON
245300         WHEN MMRC-OID-FEB (X-MMRC)
245400             MOVE 02             TO MTRF-K2-O88-HIST-MON
245500         WHEN MMRC-OID-MAR (X-MMRC)
245600             MOVE 03             TO MTRF-K2-O88-HIST-MON
245700         WHEN MMRC-OID-APR (X-MMRC)
245800             MOVE 04             TO MTRF-K2-O88-HIST-MON
245900         WHEN MMRC-OID-MAY (X-MMRC)
246000             MOVE 05             TO MTRF-K2-O88-HIST-MON
246100         WHEN MMRC-OID-JUN (X-MMRC)
246200             MOVE 06             TO MTRF-K2-O88-HIST-MON
246300         WHEN MMRC-OID-JUL (X-MMRC)
246400             MOVE 07             TO MTRF-K2-O88-HIST-MON
246500         WHEN MMRC-OID-AUG (X-MMRC)
246600             MOVE 08             TO MTRF-K2-O88-HIST-MON
246700         WHEN MMRC-OID-SEP (X-MMRC)
246800             MOVE 09             TO MTRF-K2-O88-HIST-MON
246900         WHEN MMRC-OID-OCT (X-MMRC)
247000             MOVE 10             TO MTRF-K2-O88-HIST-MON
247100         WHEN MMRC-OID-NOV (X-MMRC)
247200             MOVE 11             TO MTRF-K2-O88-HIST-MON
247300         WHEN MMRC-OID-DEC (X-MMRC)
247400             MOVE 12             TO MTRF-K2-O88-HIST-MON
247500         WHEN OTHER
247600             MOVE 01             TO MTRF-K2-O88-HIST-MON
247700     END-EVALUATE.
247800*
247900     MOVE 1                      TO WS-U381-RPT-REC-TYPE.
248000*
248100     MOVE MMRC-OCCURRENCE-DESC (X-MMRC)
248200                                 TO MTRF-O88-OCCURRENCE-DESC.
248300*
248400     MOVE WS-HTA-SALE-NBR (X-WS-HTA)
248500                                 TO MTRF-O88-SALES-NBR.
248600     MOVE WS-HTA-SALE-AMT (X-WS-HTA)
248700                                 TO MTRF-O88-SALES-AMT.
248800*
248900     MOVE WS-HTA-RETURN-NBR (X-WS-HTA)
249000                                 TO MTRF-O88-RETURNS-NBR.
249100     MOVE WS-HTA-RETURN-AMT (X-WS-HTA)
249200                                 TO MTRF-O88-RETURNS-AMT.
249300*
249400     MOVE WS-HTA-REC-ADJ-NBR (X-WS-HTA)
249500                                 TO MTRF-O88-RECOVERY-ADJ-NBR.
249600     MOVE WS-HTA-REC-ADJ-AMT (X-WS-HTA)
249700                                 TO MTRF-O88-RECOVERY-ADJ-AMT.
249800*
249900     MOVE WS-HTA-ADJ-NBR (X-WS-HTA)
250000                                 TO MTRF-O88-ADJUSTMENT-NBR.
250100     MOVE WS-HTA-ADJ-AMT (X-WS-HTA)
250200                                 TO MTRF-O88-ADJUSTMENT-AMT.
250300*
250400     IF  WS-HTA-SALE-NBR (X-WS-HTA) IS NOT GREATER THAN ZERO
250500         MOVE ZERO               TO MTRF-O88-AVG-TKT
250600     ELSE
250700         COMPUTE MTRF-O88-AVG-TKT ROUNDED
250800                                 =  WS-HTA-SALE-AMT
250900                                    (X-WS-HTA)
251000                                 /  WS-HTA-SALE-NBR
251100                                    (X-WS-HTA).
251200*
251300     MOVE WS-HTA-TOTAL-INCOME (X-WS-HTA)
251400                                 TO MTRF-O88-TOT-INCOME-AMT.
251500*
251600     PERFORM R980-WRITE-REPORT-FILE
251700        THRU R989-WRF-EXIT.
251800*
251900 F999-H-EXIT.
252000     EXIT.
252100/
252200 R980-WRITE-REPORT-FILE SECTION.
252300 R981-WRF-BEGIN.
252400*
252500     IF  MTRFWS-ORT-F1-NOT-REQUESTED  (X-MTRFWS-ORT)
252600         NEXT SENTENCE
252700     ELSE
252800         MOVE MTRFWS-ORT-FREQ-1  (X-MTRFWS-ORT)
252900                                 TO MTRF-KEY-1
253000         PERFORM R990-OBTAIN-STATIC-DATA
253100            THRU R999-OSD-EXIT
253200         MOVE MTRF-RECORD        TO MTRFIO-RECORD
253300         MOVE 'W3RF'             TO SS02WS-ABEND-LOCATION
253400         SET MTRFRB-WRITE        TO TRUE
253500         PERFORM MB00PD-MTRF-ACCESS
253600            THRU MB00PD-MTRF-ACCESS-EXIT.
253700*
253800     MOVE SPACES                 TO MTRF-RECORD.
253900*
254000 R989-WRF-EXIT.
254100     EXIT.
254200/
254300 R990-OBTAIN-STATIC-DATA SECTION.
254400 R990-OSD-BEGIN.
254500*
254600     MOVE WS-U381-RPT-REC-TYPE   TO MTRF-K1-REC-TYPE.
254700*
254800     IF  MTRF-K1-RT-HEADER
254900     OR  MTRF-K1-RT-TRAILER
255000         GO TO R999-OSD-EXIT.
255100*
255200     MOVE MMRC-CHAIN             TO MTRF-MERCHANT.
255300     MOVE ZERO                   TO MTRF-STORE.
255400     MOVE ZERO                   TO MTRF-CHAIN.
255500     MOVE SPACES                 TO MTRF-BLOCK-CODE.
255600     MOVE MMRC-REC-STATUS        TO MTRF-REC-STATUS.
255700     MOVE MMRC-GNA-NBR           TO MTRF-GNA-NBR.
255800     MOVE MMRC-NA-OVERFLOW-SW    TO MTRF-NA-OVERFLOW-SW.
255900     MOVE MMRC-NA-LINE (1)       TO MTRF-NAME.
256000     MOVE MMRC-STATE-CODE        TO MTRF-STATE.
256100     MOVE MMRC-COUNTRY-CODE      TO MTRF-COUNTRY.
256200     MOVE MMRC-STMT-FREQ-1       TO MTRF-STMT-FREQ-1.
256300     MOVE MMRC-STMT-FREQ-2       TO MTRF-STMT-FREQ-2.
256400     MOVE ZERO                   TO MTRF-DISC-FREQ-1.
256500     MOVE ZERO                   TO MTRF-DISC-FREQ-2.
256600     MOVE ZERO                   TO MTRF-PART-FREQ-1.
256700     MOVE ZERO                   TO MTRF-PART-FREQ-2.
256800     MOVE ZERO                   TO MTRF-SETT-FREQ-1.
256900     MOVE ZERO                   TO MTRF-SETT-FREQ-2.
257000*
257100 R999-OSD-EXIT.
257200     EXIT.
257300/
257400 Z100-ADJUST-ORG SECTION.
257500 Z101-AO-BEGIN.
257600*
257700     MOVE 99                     TO MMOC-OR-FREQ-1 (88).
257800     MOVE ZERO                   TO MMOC-OR-FREQ-2 (88).
257900     MOVE 'MBU381  '             TO MMOC-OR-REPORT-ID (88).
258000*
258100     IF  MTCC-MBU380-RPT-TITLE IS NOT EQUAL TO SPACES
258200         MOVE MTCC-MBU380-RPT-TITLE
258300                                 TO MMOC-OR-RPT-TITLE (88).
258400*
258500 Z199-AO-EXIT.
258600     EXIT.
258700/
258800 1000-EXTRACT-MMPG SECTION.
258900 1001-EMMPG-BEGIN.
259000*
259100     MOVE ZERO                   TO WS-SORT-ORG.
259200     MOVE LOW-VALUES             TO MMRCIO-KEY.
259300     SET MMRCRB-START-GTE        TO TRUE.
259400     MOVE 'S2RC'                 TO SS02WS-ABEND-LOCATION.
259500     PERFORM MB00PD-MMRC-ACCESS  THRU MB00PD-MMRC-ACCESS-EXIT.
259600*
259700 1100-EMMPG-READ-MMRC.
259800*
259900     SET MMRCRB-READ-SEQ         TO TRUE.
260000     MOVE 'R2RC'                 TO SS02WS-ABEND-LOCATION.
260100     PERFORM MB00PD-MMRC-ACCESS  THRU MB00PD-MMRC-ACCESS-EXIT.
260200*
260300     IF  MMRCIO-HEADER
260400         GO TO 1100-EMMPG-READ-MMRC.
260500*
260600     IF  MMRCIO-TRAILER
260700         GO TO 1900-EMMPG-TRAILER.
260800*
260900     MOVE MMRCIO-RECORD          TO MMRC-RECORD.
261000*
261100     IF  MMRC-REC-INCOMPLETE
261200     OR  MMRC-REC-PURGED
261300     OR  MMRC-ADD-PENDING
261400         GO TO 1100-EMMPG-READ-MMRC.
261500*
261600     SET X-WS-U381-ORT           TO 1.
261700     SEARCH WS-U381-ORG-RANGES-TABLE VARYING X-WS-U381-ORT
261800         AT END
261900             GO TO 1100-EMMPG-READ-MMRC
262000         WHEN WS-U381-ORT-END-OF-TABLE (X-WS-U381-ORT)
262100             GO TO 1100-EMMPG-READ-MMRC
262200         WHEN MMRCIO-ORG-CHAIN IS NOT LESS THAN
262300              WS-U381-ORT-BEG-ORG-CHAIN (X-WS-U381-ORT)
262400         AND  MMRCIO-ORG-CHAIN IS NOT GREATER THAN
262500              WS-U381-ORT-END-ORG-CHAIN (X-WS-U381-ORT)
262600             NEXT SENTENCE.
262700*
262800     EVALUATE TRUE
262900         WHEN MTCC-MBU380-ORG-OPTION
263000             MOVE MMRC-ORG       TO WS-SORT-ORG
263100         WHEN OTHER
263200             IF  WS-SORT-ORG IS EQUAL TO ZERO
263300                 MOVE MMRC-ORG   TO WS-SORT-ORG
263400             END-IF
263500     END-EVALUATE.
263600*
263700     PERFORM
263800         UNTIL MMPGIO-ORG-ACCT  IS GREATER THAN
263900                                 MMRC-ORG-CHAIN
264000         MOVE MMPGIO-LOGIC-MODULE
264100                                 TO MMTCWS-LOGIC-MODULE
264200         EVALUATE TRUE
264300             WHEN MMTCWS-LM-VALID-INTERNAL
264400                 CONTINUE
264500             WHEN MMPGIO-ORG-ACCT
264600                                 IS EQUAL TO MMRC-ORG-CHAIN
264700                 MOVE MMPGIO-RECORD
264800                                 TO MWPA-RECORD
264900                 MOVE WS-SORT-ORG
265000                                 TO MWPA-ORG
265100                 MOVE ZERO       TO MWPA-ACCT
265200                 RELEASE MWPA-RECORD
265300         END-EVALUATE
265400         SET MMPGRB-READ-SEQ     TO TRUE
265500         MOVE 'R4PG'             TO SS02WS-ABEND-LOCATION
265600         PERFORM MB00PD-MMPG-ACCESS
265700            THRU MB00PD-MMPG-ACCESS-EXIT
265800     END-PERFORM.
265900*
266000     GO TO 1100-EMMPG-READ-MMRC.
266100*
266200 1900-EMMPG-TRAILER.
266300*
266400     MOVE MMPGIO-RECORD          TO MWPA-RECORD.
266500     RELEASE MWPA-RECORD.
266600*
266700 1999-EMMPG-EXIT.
266800     EXIT.
266900/
267000 2000-BUILD-MWPA SECTION.
267100 2001-BMWPA-BEGIN.
267200*
267300     MOVE MMPGIR-RECORD          TO MTPA-RECORD.
267400*
267500     SET MWPARB-OPEN-OUTPUT      TO TRUE.
267600     MOVE 'OBPA'                 TO SS02WS-ABEND-LOCATION.
267700     PERFORM MB00PD-MWPA-ACCESS  THRU MB00PD-MWPA-ACCESS-EXIT.
267800*
267900 2100-BMWPA-RETURN-SORT.
268000*
268100     RETURN MS1S-SORT-FILE
268200         AT END
268300             GO TO 2900-BMWPA-CLOSE-FILE.
268400*
268500     IF  MWPA-KEY IS EQUAL TO MTPA-KEY
268600         PERFORM
268700             VARYING X-MWPA FROM 1 BY 1
268800             UNTIL   X-MWPA IS GREATER THAN 18
268900             SET X-MTPA          TO X-MWPA
269000             ADD MWPA-NBR (X-MWPA)
269100                                 TO MTPA-NBR (X-MTPA)
269200             ADD MWPA-AMT (X-MWPA)
269300                                 TO MTPA-AMT (X-MTPA)
269400         END-PERFORM
269500     ELSE
269600         MOVE MTPA-RECORD        TO MWPAIO-RECORD
269700         SET MWPARB-WRITE        TO TRUE
269800         MOVE 'WAPA'             TO SS02WS-ABEND-LOCATION
269900         PERFORM MB00PD-MWPA-ACCESS THRU MB00PD-MWPA-ACCESS-EXIT
270000         MOVE MWPA-RECORD        TO MTPA-RECORD.
270100*
270200     GO TO 2100-BMWPA-RETURN-SORT.
270300*
270400 2900-BMWPA-CLOSE-FILE.
270500*
270600     MOVE MMPGIR-RECORD          TO MWPAIO-RECORD.
270700     SET MWPAIO-TRAILER          TO TRUE.
270800*
270900     SET MWPARB-WRITE            TO TRUE.
271000     MOVE 'WBPA'                 TO SS02WS-ABEND-LOCATION.
271100     PERFORM MB00PD-MWPA-ACCESS  THRU MB00PD-MWPA-ACCESS-EXIT.
271200*
271300     SET MWPARB-CLOSE            TO TRUE.
271400     MOVE 'CBPA'                 TO SS02WS-ABEND-LOCATION.
271500     PERFORM MB00PD-MWPA-ACCESS  THRU MB00PD-MWPA-ACCESS-EXIT.
271600*
271700 2999-BMWPA-EXIT.
271800     EXIT.
271900/
272000 3000-EXTRACT-MMOG SECTION.
272100 3001-EMMOG-BEGIN.
272200*
272300     MOVE ZERO                   TO WS-SORT-ORG.
272400     MOVE LOW-VALUES             TO MMRCIO-KEY.
272500     SET MMRCRB-START-GTE        TO TRUE.
272600     MOVE 'S3RC'                 TO SS02WS-ABEND-LOCATION.
272700     PERFORM MB00PD-MMRC-ACCESS  THRU MB00PD-MMRC-ACCESS-EXIT.
272800*
272900 3100-EMMOG-READ-MMRC.
273000*
273100     SET MMRCRB-READ-SEQ         TO TRUE.
273200     MOVE 'R3RC'                 TO SS02WS-ABEND-LOCATION.
273300     PERFORM MB00PD-MMRC-ACCESS  THRU MB00PD-MMRC-ACCESS-EXIT.
273400*
273500     IF  MMRCIO-HEADER
273600         GO TO 3100-EMMOG-READ-MMRC.
273700*
273800     IF  MMRCIO-TRAILER
273900         GO TO 3900-EMMOG-TRAILER.
274000*
274100     MOVE MMRCIO-RECORD          TO MMRC-RECORD.
274200*
274300     IF  MMRC-REC-INCOMPLETE
274400     OR  MMRC-REC-PURGED
274500     OR  MMRC-ADD-PENDING
274600         GO TO 3100-EMMOG-READ-MMRC.
274700*
274800     SET X-WS-U381-ORT           TO 1.
274900     SEARCH WS-U381-ORG-RANGES-TABLE VARYING X-WS-U381-ORT
275000         AT END
275100             GO TO 3100-EMMOG-READ-MMRC
275200         WHEN WS-U381-ORT-END-OF-TABLE (X-WS-U381-ORT)
275300             GO TO 3100-EMMOG-READ-MMRC
275400         WHEN MMRCIO-ORG-CHAIN IS NOT LESS THAN
275500              WS-U381-ORT-BEG-ORG-CHAIN (X-WS-U381-ORT)
275600         AND  MMRCIO-ORG-CHAIN IS NOT GREATER THAN
275700              WS-U381-ORT-END-ORG-CHAIN (X-WS-U381-ORT)
275800             NEXT SENTENCE.
275900*
276000     EVALUATE TRUE
276100         WHEN MTCC-MBU380-ORG-OPTION
276200             MOVE MMRC-ORG       TO WS-SORT-ORG
276300         WHEN OTHER
276400             IF  WS-SORT-ORG IS EQUAL TO ZERO
276500                 MOVE MMRC-ORG   TO WS-SORT-ORG
276600             END-IF
276700     END-EVALUATE.
276800*
276900     PERFORM
277000         UNTIL MMOGIO-ORG-ACCT  IS GREATER THAN
277100                                 MMRC-ORG-CHAIN
277200         MOVE MMOGIO-LOGIC-MODULE
277300                                 TO MMTCWS-LOGIC-MODULE
277400         EVALUATE TRUE
277500             WHEN MMTCWS-LM-VALID-INTERNAL
277600                 CONTINUE
277700             WHEN MMOGIO-ORG-ACCT
277800                                 IS EQUAL TO MMRC-ORG-CHAIN
277900                 MOVE MMOGIO-RECORD
278000                                 TO MWOI-RECORD
278100                 MOVE WS-SORT-ORG
278200                                 TO MWOI-ORG
278300                 MOVE ZERO       TO MWOI-ACCT
278400                 RELEASE MWOI-RECORD
278500         END-EVALUATE
278600         SET MMOGRB-READ-SEQ     TO TRUE
278700         MOVE 'R4OG'             TO SS02WS-ABEND-LOCATION
278800         PERFORM MB00PD-MMOG-ACCESS
278900            THRU MB00PD-MMOG-ACCESS-EXIT
279000     END-PERFORM.
279100*
279200     GO TO 3100-EMMOG-READ-MMRC.
279300*
279400 3900-EMMOG-TRAILER.
279500*
279600     MOVE MMOGIO-RECORD          TO MWOI-RECORD.
279700     RELEASE MWOI-RECORD.
279800*
279900 3999-EMMOG-EXIT.
280000     EXIT.
280100/
280200 4000-BUILD-MWOI SECTION.
280300 4001-BMWOI-BEGIN.
280400*
280500     MOVE MMOGIR-RECORD          TO MTOI-RECORD.
280600*
280700     SET MWOIRB-OPEN-OUTPUT      TO TRUE.
280800     MOVE 'OBOI'                 TO SS02WS-ABEND-LOCATION.
280900     PERFORM MB00PD-MWOI-ACCESS  THRU MB00PD-MWOI-ACCESS-EXIT.
281000*
281100 4100-BMWOI-RETURN-SORT.
281200*
281300     RETURN MS1S-SORT-FILE
281400         AT END
281500             GO TO 4900-BMWOI-CLOSE-FILE.
281600*
281700     IF  MWOI-KEY IS EQUAL TO MTOI-KEY
281800         PERFORM
281900             VARYING X-MWOI FROM 1 BY 1
282000             UNTIL   X-MWOI IS GREATER THAN 18
282100             SET X-MTOI          TO X-MWOI
282200             ADD MWOI-NBR (X-MWOI)
282300                                 TO MTOI-NBR (X-MTOI)
282400             ADD MWOI-AMT (X-MWOI)
282500                                 TO MTOI-AMT (X-MTOI)
282600         END-PERFORM
282700     ELSE
282800         MOVE MTOI-RECORD        TO MWOIIO-RECORD
282900         SET MWOIRB-WRITE        TO TRUE
283000         MOVE 'WAOI'             TO SS02WS-ABEND-LOCATION
283100         PERFORM MB00PD-MWOI-ACCESS THRU MB00PD-MWOI-ACCESS-EXIT
283200         MOVE MWOI-RECORD        TO MTOI-RECORD.
283300*
283400     GO TO 4100-BMWOI-RETURN-SORT.
283500*
283600 4900-BMWOI-CLOSE-FILE.
283700*
283800     MOVE MMOGIR-RECORD          TO MWOIIO-RECORD.
283900     SET MWOIIO-TRAILER          TO TRUE.
284000*
284100     SET MWOIRB-WRITE            TO TRUE.
284200     MOVE 'WBOI'                 TO SS02WS-ABEND-LOCATION.
284300     PERFORM MB00PD-MWOI-ACCESS  THRU MB00PD-MWOI-ACCESS-EXIT.
284400*
284500     SET MWOIRB-CLOSE            TO TRUE.
284600     MOVE 'CBOI'                 TO SS02WS-ABEND-LOCATION.
284700     PERFORM MB00PD-MWOI-ACCESS  THRU MB00PD-MWOI-ACCESS-EXIT.
284800*
284900 4999-BMWOI-EXIT.
285000     EXIT.
285100/
285200 5000-EXTRACT-MMCG SECTION.
285300 5001-EMMCG-BEGIN.
285400*
285500     MOVE ZERO                   TO WS-SORT-ORG.
285600     MOVE LOW-VALUES             TO MMRCIO-KEY.
285700     SET MMRCRB-START-GTE        TO TRUE.
285800     MOVE 'S3RC'                 TO SS02WS-ABEND-LOCATION.
285900     PERFORM MB00PD-MMRC-ACCESS  THRU MB00PD-MMRC-ACCESS-EXIT.
286000*
286100 5100-EMMCG-READ-MMRC.
286200*
286300     SET MMRCRB-READ-SEQ         TO TRUE.
286400     MOVE 'R3RC'                 TO SS02WS-ABEND-LOCATION.
286500     PERFORM MB00PD-MMRC-ACCESS  THRU MB00PD-MMRC-ACCESS-EXIT.
286600*
286700     IF  MMRCIO-HEADER
286800         GO TO 5100-EMMCG-READ-MMRC.
286900*
287000     IF  MMRCIO-TRAILER
287100         GO TO 5900-EMMCG-TRAILER.
287200*
287300     MOVE MMRCIO-RECORD          TO MMRC-RECORD.
287400*
287500     IF  MMRC-REC-INCOMPLETE
287600     OR  MMRC-REC-PURGED
287700     OR  MMRC-ADD-PENDING
287800         GO TO 5100-EMMCG-READ-MMRC.
287900*
288000     SET X-WS-U381-ORT           TO 1.
288100     SEARCH WS-U381-ORG-RANGES-TABLE VARYING X-WS-U381-ORT
288200         AT END
288300             GO TO 5100-EMMCG-READ-MMRC
288400         WHEN WS-U381-ORT-END-OF-TABLE (X-WS-U381-ORT)
288500             GO TO 5100-EMMCG-READ-MMRC
288600         WHEN MMRCIO-ORG-CHAIN IS NOT LESS THAN
288700              WS-U381-ORT-BEG-ORG-CHAIN (X-WS-U381-ORT)
288800         AND  MMRCIO-ORG-CHAIN IS NOT GREATER THAN
288900              WS-U381-ORT-END-ORG-CHAIN (X-WS-U381-ORT)
289000             NEXT SENTENCE.
289100*
289200     EVALUATE TRUE
289300         WHEN MTCC-MBU380-ORG-OPTION
289400             MOVE MMRC-ORG       TO WS-SORT-ORG
289500         WHEN OTHER
289600             IF  WS-SORT-ORG IS EQUAL TO ZERO
289700                 MOVE MMRC-ORG   TO WS-SORT-ORG
289800             END-IF
289900     END-EVALUATE.
290000*
290100     PERFORM
290200         UNTIL MMCGIO-ORG-ACCT  IS GREATER THAN
290300                                 MMRC-ORG-CHAIN
290400         MOVE MMCGIO-LOGIC-MODULE
290500                                 TO MMTCWS-LOGIC-MODULE
290600         EVALUATE TRUE
290700             WHEN MMTCWS-LM-VALID-INTERNAL
290800                 CONTINUE
290900             WHEN MMCGIO-ORG-ACCT
291000                                 IS EQUAL TO MMRC-ORG-CHAIN
291100                 MOVE MMCGIO-RECORD
291200                                 TO MWCP-RECORD
291300                 MOVE WS-SORT-ORG
291400                                 TO MWCP-ORG
291500                 MOVE ZERO       TO MWCP-ACCT
291600                 RELEASE MWCP-RECORD
291700         END-EVALUATE
291800         SET MMCGRB-READ-SEQ     TO TRUE
291900         MOVE 'R4CG'             TO SS02WS-ABEND-LOCATION
292000         PERFORM MB00PD-MMCG-ACCESS
292100            THRU MB00PD-MMCG-ACCESS-EXIT
292200     END-PERFORM.
292300*
292400     GO TO 5100-EMMCG-READ-MMRC.
292500*
292600 5900-EMMCG-TRAILER.
292700*
292800     MOVE MMCGIO-RECORD          TO MWCP-RECORD.
292900     RELEASE MWCP-RECORD.
293000*
293100 5999-EMMCG-EXIT.
293200     EXIT.
293300/
293400 6000-BUILD-MWCP SECTION.
293500 6001-BMWCP-BEGIN.
293600*
293700     MOVE MMCGIR-RECORD          TO MTCP-RECORD.
293800*
293900     SET MWCPRB-OPEN-OUTPUT      TO TRUE.
294000     MOVE 'OBCP'                 TO SS02WS-ABEND-LOCATION.
294100     PERFORM MB00PD-MWCP-ACCESS  THRU MB00PD-MWCP-ACCESS-EXIT.
294200*
294300 6100-BMWCP-RETURN-SORT.
294400*
294500     RETURN MS1S-SORT-FILE
294600         AT END
294700             GO TO 6900-BMWCP-CLOSE-FILE.
294800*
294900     IF  MWCP-KEY IS EQUAL TO MTCP-KEY
295000         PERFORM
295100             VARYING X-MWCP FROM 1 BY 1
295200             UNTIL   X-MWCP IS GREATER THAN 18
295300             SET X-MTCP          TO X-MWCP
295400             ADD MWCP-NBR (X-MWCP)
295500                                 TO MTCP-NBR (X-MTCP)
295600             ADD MWCP-AMT (X-MWCP)
295700                                 TO MTCP-AMT (X-MTCP)
295800         END-PERFORM
295900     ELSE
296000         MOVE MTCP-RECORD        TO MWCPIO-RECORD
296100         SET MWCPRB-WRITE        TO TRUE
296200         MOVE 'WACP'             TO SS02WS-ABEND-LOCATION
296300         PERFORM MB00PD-MWCP-ACCESS THRU MB00PD-MWCP-ACCESS-EXIT
296400         MOVE MWCP-RECORD        TO MTCP-RECORD.
296500*
296600     GO TO 6100-BMWCP-RETURN-SORT.
296700*
296800 6900-BMWCP-CLOSE-FILE.
296900*
297000     MOVE MMCGIR-RECORD          TO MWCPIO-RECORD.
297100     SET MWCPIO-TRAILER          TO TRUE.
297200*
297300     SET MWCPRB-WRITE            TO TRUE.
297400     MOVE 'WBCP'                 TO SS02WS-ABEND-LOCATION.
297500     PERFORM MB00PD-MWCP-ACCESS  THRU MB00PD-MWCP-ACCESS-EXIT.
297600*
297700     SET MWCPRB-CLOSE            TO TRUE.
297800     MOVE 'CBCP'                 TO SS02WS-ABEND-LOCATION.
297900     PERFORM MB00PD-MWCP-ACCESS  THRU MB00PD-MWCP-ACCESS-EXIT.
298000*
298100 6999-BMWCP-EXIT.
298200     EXIT.
298300/
298400 9000-PERFORMED-ROUTINES-SECT SECTION.
298500*
298600     COPY MB00PD REPLACING ==:MB00:== BY ==MMSC==.
298700/
298800     COPY MB00PD REPLACING ==:MB00:== BY ==MTCC==.
298900/
299000     COPY MB00PD REPLACING ==:MB00:== BY ==MMOC==.
299100/
299200     COPY MB00PD REPLACING ==:MB00:== BY ==MMRC==.
299300/
299400     COPY MMRCPX.
299500/
299600     COPY MB00PD REPLACING ==:MB00:== BY ==MMCG==.
299700/
299800     COPY MB00PD REPLACING ==:MB00:== BY ==MMOG==.
299900/
300000     COPY MB00PD REPLACING ==:MB00:== BY ==MMPG==.
300100/
300200     COPY MB00PD REPLACING ==:MB00:== BY ==MTRF==.
300300/
300400     COPY MTRFPX.
300500/
300600     COPY MB00PD REPLACING ==:MB00:== BY ==MWCP==.
300700/
300800     COPY MB00PD REPLACING ==:MB00:== BY ==MWOI==.
300900/
301000     COPY MB00PD REPLACING ==:MB00:== BY ==MWPA==.
301100/
301200     COPY MB99PD.
301300/
301400     COPY SS02PD.
301500/
301600     COPY SS03PD.
301700/
301800     COPY SS06PD.
301900/
302000     COPY SS07PD.
302100/
302200     COPY SS08PD.
302300/
302400     COPY SS26PD.
302500/
302600     COPY SS27PD.
302700/
302800     COPY SS98PD.
302900*
303000 9995-END-SOURCE-STATEMENTS SECTION.
303100 9999-END-OF-PROGRAM.
303200     EXIT.
