000100 IDENTIFICATION DIVISION.
000200 PROGRAM-ID. MBU401.
000201*       RELEASE DATE=08/24/01.        REVISION LEVEL=08.06      *
000202*****************************************************************
000203*WARNING.  THIS COMPUTER PROGRAM IS PROTECTED BY COPYRIGHT LAW  *
000204*AND INTERNATIONAL TREATIES.  UNAUTHORIZED REPRODUCTION OR      *
000205*DISTRIBUTION OF THIS PROGRAM, OR ANY PORTION OF IT, MAY RESULT *
000206*IN SEVERE CIVIL AND CRIMINAL PENATLIES, AND WILL BE PROSECUTED *
000207*TO THE MAXIMUM EXTENT POSSIBLE UNDER THE LAW.                  *
000208*COPYRIGHT 1999 PAYSYS INTERNATIONAL, INC.  ALL RIGHTS RESERVED.*
000209*****************************************************************
000300*****************************************************************
000400*                                                               *
000500*   V - PLUS  M E R C H A N T   B A N K C A R D   S Y S T E M   *
000600*                                                               *
000700*       MBU401 - FLAG INACTIVE EXPENSE RECORDS (MMEF)           *
000800*                                                               *
000900*****************************************************************
001000 ENVIRONMENT DIVISION.
001100 CONFIGURATION SECTION.
001200 SOURCE-COMPUTER.            IBM-4341.
001300 OBJECT-COMPUTER.            IBM-4341.
001400*
001500 INPUT-OUTPUT SECTION.
001600 FILE-CONTROL.
001700*
001800     COPY MS1SES.
001900/
002000 DATA DIVISION.
002100 FILE SECTION.
002200*
002300     COPY MS1SSD.
002400 01  MS1S-RECORD.
002500     03  MS1S-KEY.
002600         05  MS1S-ORG-TABLE.
002700             07  MS1S-ORG-X.
002800                 09  MS1S-ORG
002900                             PIC  9(03).
003000             07  MS1S-TABLE-NBR-X.
003100                 09  MS1S-TABLE-NBR
003200                             PIC  9(09).
003300     03  MS1S-DATA.
003400         05  MS1S-MERCHANT-X.
003500             07  MS1S-MERCHANT
003600                             PIC  9(09).
003700         05  MS1S-PRODUCT-X.
003800             07  MS1S-PRODUCT
003900                             PIC  9(02).
004000         05  MS1S-NAME       PIC  X(40).
004100/
004200 WORKING-STORAGE SECTION.
004300*
004400 01  FILLER                  PIC  X(12)      VALUE '** WS-BEG **'.
004500*
004600 01  WS-MBU401-WORK-AREAS.
004700     03  WS-MBU401-EOF-SW    PIC  X(01)      VALUE 'N'.
004800     03  WS-PREV-KEY         PIC  X(12)      VALUE ZERO.
004900     03  WS-ACTIVE-NBR       PIC S9(09)      COMP-3 VALUE ZERO.
005000     03  WS-INACTIVE-NBR     PIC S9(09)      COMP-3 VALUE ZERO.
005100     03  WS-PURGED-NBR       PIC S9(09)      COMP-3 VALUE ZERO.
005200     03  WS-INCOMPLETE-NBR   PIC S9(09)      COMP-3 VALUE ZERO.
005300*
005400     COPY MMSCRL.
005500/
005600     COPY MMOCRL.
005700/
005800     COPY MMMMRL.
005900/
006000     COPY MMIFRL REPLACING ==:MMIF:== BY ==MMEF==.
006100/
006200     COPY MTCCRL REPLACING ==:MTCC:== BY ==MTCC==.
006300/
006400******************************************************************
006500     COPY MMSCIO.
006600/
006700     COPY MMOCIO.
006800/
006900     COPY MMMMIO.
007000/
007100     COPY MMIFIO REPLACING ==:MMIF:== BY ==MMEF==.
007200/
007300     COPY MTCCIO REPLACING ==:MTCC:== BY ==MTCC==.
007400/
007500******************************************************************
007600     COPY MB00RB REPLACING ==:MB00:== BY ==MMSC==.
007700/
007800     COPY MB00RB REPLACING ==:MB00:== BY ==MMOC==.
007900/
008000     COPY MB00RB REPLACING ==:MB00:== BY ==MMMM==.
008100/
008200     COPY MB00RB REPLACING ==:MB00:== BY ==MMEF==.
008300/
008400     COPY MB00RB REPLACING ==:MB00:== BY ==MTCC==.
008500/
008600******************************************************************
008700     COPY MB00RB REPLACING ==:MB00:== BY ==MS1S==.
008800/
008900     COPY MB00WS.
009000/
009100     COPY MB20WS.
009200 01  WS-PRINT-LINE-1         REDEFINES MB20WS-PRINT-LINE.
009300     03  WS-PL1-TABLE-NBR    PIC  9(09)-.
009400     03  FILLER              PIC  X(03).
009500     03  WS-PL1-STATUS       PIC  X(01).
009600     03  FILLER              PIC  X(03).
009700     03  WS-PL1-TABLE-NAME   PIC  X(30).
009800     03  FILLER              PIC  X(01).
009900     03  WS-PL1-MERCHANT     PIC  9(09)-.
010000     03  WS-PL1-NAME         PIC  X(41).
010100     03  FILLER              PIC  X(04).
010200     03  WS-PL1-PRODUCT      PIC  9(02).
010300     03  FILLER              PIC  X(04).
010400     03  FILLER              PIC  X(24).
010500 01  WS-PRINT-LINE-2         REDEFINES MB20WS-PRINT-LINE.
010600     03  WS-PL2-SIGN         PIC  X(01).
010700     03  WS-PL2-TOTAL        PIC  ZZZZZZZZZZ9-.
010800     03  WS-PL2-TOTAL-DESC   PIC  X(119).
010900/
011000     COPY MB99WS.
011100/
011200     COPY SS00WS.
011300/
011400     COPY SS01WS.
011500/
011600     COPY SS02WS.
011700*
011800 01  FILLER                  PIC  X(12)      VALUE '** WS-END **'.
011900/
012000 PROCEDURE DIVISION.
012100 A000-MAIN-LINE-SECT SECTION.
012200 A010-ML-BEGIN.
012300*
012400     MOVE 'MBU401'               TO SS02WS-ABEND-PROG-ID.
012500*
012600     PERFORM A100-OPEN-FILES
012700        THRU A199-OF-EXIT.
012800*
012900     PERFORM A200-SORT-PROCESS
013000        THRU A299-SP-EXIT.
013100*
013200     PERFORM A300-CLOSE-FILES
013300        THRU A399-CF-EXIT.
013400*
013500     STOP RUN.
013600*
013700 A099-ML-EXIT.
013800     EXIT.
013900/
014000 A100-OPEN-FILES SECTION.
014100 A101-OF-OPEN-FILES.
014200*
014300     MOVE SS02WS-END-OF-FILE     TO MTCCRB-PERM-STATUS-1.
014400*
014500     MOVE 'O1CC'                 TO SS02WS-ABEND-LOCATION.
014600     SET MTCCRB-OPEN-INPUT       TO TRUE.
014700     PERFORM MB00PD-MTCC-ACCESS
014800        THRU MB00PD-MTCC-ACCESS-EXIT.
014900*
015000 A110-OF-READ-MTCC.
015100*
015200     MOVE 'R1CC'                 TO SS02WS-ABEND-LOCATION.
015300     SET MTCCRB-READ-SEQ         TO TRUE.
015400     PERFORM MB00PD-MTCC-ACCESS
015500        THRU MB00PD-MTCC-ACCESS-EXIT.
015600*
015700     IF  SS02WS-FS-END-OF-FILE
015800         MOVE 'ALL2'             TO MTCCIO-RECORD
015900         MOVE SS02WS-ABEND-PROG-ID TO MTCCIO-PROGRAM-ID.
016000*
016100     IF  MTCCIO-PROGRAM-ID IS EQUAL TO SS02WS-ABEND-PROG-ID
016200         MOVE MTCCIO-RECORD      TO MTCC-RECORD
016300     ELSE
016400         GO TO A110-OF-READ-MTCC.
016500*
016600     EVALUATE TRUE
016700       WHEN MTCC-MBU40X-ALL-ORGS
016800           CONTINUE
016900       WHEN (MTCC-MBU40X-ORG-OPTION IS NUMERIC
017000        AND  MTCC-MBU40X-ORG-OPTION IS GREATER THAN ZERO
017100        AND  MTCC-MBU40X-ORG-OPTION IS LESS THAN 999)
017200           CONTINUE
017300       WHEN OTHER
017400           MOVE 40101            TO SS02WS-ABEND-CODE
017500           MOVE 'INVALID ORG OPTION'
017600                                 TO SS02WS-ABENDMSG8
017700           PERFORM SS02PD-ABEND
017800              THRU SS02PD-ABEND-EXIT
017900     END-EVALUATE.
018000*
018100     EVALUATE TRUE
018200       WHEN MTCC-MBU40X-FULL-RPT
018300           CONTINUE
018400       WHEN MTCC-MBU40X-STATUS-2-RPT
018500           CONTINUE
018600       WHEN OTHER
018700           SET MTCC-MBU40X-STATUS-2-RPT
018800                                 TO TRUE
018900     END-EVALUATE.
019000*
019100     EVALUATE TRUE
019200       WHEN MTCC-MBU40X-NO-UPDATE
019300           CONTINUE
019400       WHEN MTCC-MBU40X-UPDATE
019500           CONTINUE
019600       WHEN OTHER
019700           SET MTCC-MBU40X-NO-UPDATE
019800                                 TO TRUE
019900     END-EVALUATE.
020000*
020100*
020200*
020300     MOVE 'O1SC'                 TO SS02WS-ABEND-LOCATION.
020400     SET MMSCRB-OPEN-INPUT       TO TRUE.
020500     PERFORM MB00PD-MMSC-ACCESS
020600        THRU MB00PD-MMSC-ACCESS-EXIT.
020700*
020800     MOVE 'O1OC'                 TO SS02WS-ABEND-LOCATION.
020900     SET MMOCRB-OPEN-INPUT-DYN   TO TRUE.
021000     PERFORM MB00PD-MMOC-ACCESS
021100        THRU MB00PD-MMOC-ACCESS-EXIT.
021200*
021300*
021400*
021500     MOVE 'O1MM'                 TO SS02WS-ABEND-LOCATION.
021600*
021700     IF  MTCC-MBU40X-UPDATE
021800         SET MMMMRB-OPEN-IO      TO TRUE
021900     ELSE
022000         SET MMMMRB-OPEN-INPUT   TO TRUE.
022100*
022200     PERFORM MB00PD-MMMM-ACCESS
022300        THRU MB00PD-MMMM-ACCESS-EXIT.
022400*
022500*
022600*
022700     MOVE 'O1EF'                 TO SS02WS-ABEND-LOCATION.
022800*
022900     IF  MTCC-MBU40X-UPDATE
023000         SET MMEFRB-OPEN-IO      TO TRUE
023100     ELSE
023200         SET MMEFRB-OPEN-INPUT   TO TRUE.
023300*
023400     PERFORM MB00PD-MMEF-ACCESS
023500        THRU MB00PD-MMEF-ACCESS-EXIT.
023600*
023700*
023800*
023900 A120-OF-CHECK-HEADERS.
024000*
024100     MOVE 'R0SC'                 TO SS02WS-ABEND-LOCATION.
024200     SET MMSCRB-READ-SEQ         TO TRUE.
024300     PERFORM MB00PD-MMSC-ACCESS
024400        THRU MB00PD-MMSC-ACCESS-EXIT.
024500*
024600     MOVE 'MMSC'                 TO MB99WS-FILE-ID.
024700*
024800     IF  MMSCIO-HEADER
024900         NEXT SENTENCE
025000     ELSE
025100         PERFORM MB99PD-MISSING-HEADER-ABEND
025200            THRU MB99PD-MHA-EXIT.
025300*
025400     MOVE MMSCIO-RECORD          TO MMSC-RECORD.
025500     MOVE MMSC-TODAYS-JULIAN     TO MB99WS-PROC-DATE.
025600     MOVE MMSC-TIME-STAMP        TO MB99WS-PROC-TIME.
025700*
025800     MOVE MB20WS-FORCE-PAGE      TO MB20WS-LINE-COUNT.
025900     MOVE ZERO                   TO MB20WS-PAGE-COUNT.
026000     MOVE SS02WS-ABEND-PROG-ID   TO MB20WS-SH-RPT-ID.
026100     MOVE 'S401'                 TO MB20WS-SH-INTERNAL-RPT-ID.
026200     MOVE MMSC-DATE-FORMAT       TO SS01WS-DATE-FORMAT.
026300     MOVE MMSC-SCREEN-HEADER     TO MB20WS-SH-SYSTEM.
026400     MOVE MMSC-TODAYS-JULIAN     TO SS01WS-JULIAN.
026500     PERFORM SS26PD-NUMERICALLY-EDIT-DATE
026600                                 THRU SS26PD-NED-EXIT.
026700     MOVE SS01WS-XX-XX-YYYY      TO MB20WS-SH-FILE-DATE.
026800     MOVE ' EXPENSE RECORDS TO INACTIVE  '
026900                                 TO MB20WS-SH-RPT-NAME.
027000     MOVE SPACES                 TO MB20WS-SH-LIT-5.
027100     MOVE ' EXPENSE RECORD                             '
027200                                 TO MB20WS-SH-L4R-1.
027300     MOVE '     MERCHANT                               '
027400                                 TO MB20WS-SH-L4R-2.
027500     MOVE '                                            '
027600                                 TO MB20WS-SH-L4R-3.
027700     MOVE '  TABLE  STATUS *-----EXPENSE TABLE NAME----'
027800                                 TO MB20WS-SH-L5R-1.
027900     MOVE '-*    NUMBER  *------------MERCHANT  NAME---'
028000                                 TO MB20WS-SH-L5R-2.
028100     MOVE '---------*                                  '
028200                                 TO MB20WS-SH-L5R-3.
028300*
028400*
028500*
028600     MOVE 'R0OC'                 TO SS02WS-ABEND-LOCATION.
028700     SET MMOCRB-READ-SEQ         TO TRUE.
028800     PERFORM MB00PD-MMOC-ACCESS
028900        THRU MB00PD-MMOC-ACCESS-EXIT.
029000     MOVE 'MMOC'                 TO MB99WS-FILE-ID.
029100*
029200     IF  MMOCIO-HEADER
029300         NEXT SENTENCE
029400     ELSE
029500         PERFORM MB99PD-MISSING-HEADER-ABEND
029600            THRU MB99PD-MHA-EXIT.
029700*
029800     MOVE MMOCIO-RECORD          TO MMOC-RECORD.
029900*
030000*
030100*
030200     MOVE 'R0MM'                 TO SS02WS-ABEND-LOCATION.
030300     SET MMMMRB-READ-SEQ         TO TRUE.
030400     PERFORM MB00PD-MMMM-ACCESS
030500        THRU MB00PD-MMMM-ACCESS-EXIT.
030600     MOVE 'MMMM'                 TO MB99WS-FILE-ID.
030700*
030800     IF  MMMMIO-HEADER
030900         NEXT SENTENCE
031000     ELSE
031100         PERFORM MB99PD-MISSING-HEADER-ABEND
031200            THRU MB99PD-MHA-EXIT.
031300*
031400*
031500*
031600     MOVE 'R0EF'                 TO SS02WS-ABEND-LOCATION.
031700     SET MMEFRB-READ-SEQ         TO TRUE.
031800     PERFORM MB00PD-MMEF-ACCESS
031900        THRU MB00PD-MMEF-ACCESS-EXIT.
032000     MOVE 'MMEF'                 TO MB99WS-FILE-ID.
032100*
032200     IF  MMEFIO-HEADER
032300         NEXT SENTENCE
032400     ELSE
032500         PERFORM MB99PD-MISSING-HEADER-ABEND
032600            THRU MB99PD-MHA-EXIT.
032700*
032800*
032900*
033000 A199-OF-EXIT.
033100     EXIT.
033200/
033300 A200-SORT-PROCESS SECTION.
033400 A201-SP-BEGIN.
033500*
033600     IF  MTCC-MBU40X-ALL-ORGS
033700         NEXT SENTENCE
033800     ELSE
033900         MOVE LOW-VALUES         TO MMEFIO-RECORD
034000         MOVE MTCC-MBU40X-ORG-OPTION
034100                                 TO MMEFIO-ORG
034200         MOVE 'S1EF'             TO SS02WS-ABEND-LOCATION
034300         SET MMEFRB-START-GTE    TO TRUE
034400         PERFORM MB00PD-MMEF-ACCESS
034500            THRU MB00PD-MMEF-ACCESS-EXIT
034600         MOVE LOW-VALUES         TO MMMMIO-RECORD
034700         MOVE MTCC-MBU40X-ORG-OPTION
034800                                 TO MMMMIO-ORG
034900         MOVE 'S1MM'             TO SS02WS-ABEND-LOCATION
035000         SET MMMMRB-START-GTE    TO TRUE
035100         PERFORM MB00PD-MMMM-ACCESS
035200            THRU MB00PD-MMMM-ACCESS-EXIT
035300     END-IF.
035400*
035500*
035600*
035700     SORT MS1S-SORT-FILE
035800         ON ASCENDING KEY MS1S-KEY
035900                          MS1S-MERCHANT-X
036000                          MS1S-PRODUCT-X
036100         INPUT  PROCEDURE IS 1000-BUILD-SORT-RECORD
036200         OUTPUT PROCEDURE IS 2000-UPDATE-MMEF.
036300*
036400     PERFORM SS98PD-VERIFY-SORT-RETURN
036500        THRU SS98PD-VSR-EXIT.
036600*
036700*
036800*
036900 A299-SP-EXIT.
037000     EXIT.
037100/
037200 A300-CLOSE-FILES SECTION.
037300 A301-CF-BEGIN.
037400*
037500     MOVE 'C1SC'                 TO SS02WS-ABEND-LOCATION.
037600     SET MMSCRB-CLOSE            TO TRUE.
037700     PERFORM MB00PD-MMSC-ACCESS
037800        THRU MB00PD-MMSC-ACCESS-EXIT.
037900*
038000     MOVE 'C1OC'                 TO SS02WS-ABEND-LOCATION.
038100     SET MMOCRB-CLOSE            TO TRUE.
038200     PERFORM MB00PD-MMOC-ACCESS
038300        THRU MB00PD-MMOC-ACCESS-EXIT.
038400*
038500     MOVE 'C1MM'                 TO SS02WS-ABEND-LOCATION.
038600     SET MMMMRB-CLOSE            TO TRUE.
038700     PERFORM MB00PD-MMMM-ACCESS
038800        THRU MB00PD-MMMM-ACCESS-EXIT.
038900*
039000     MOVE 'C1EF'                 TO SS02WS-ABEND-LOCATION.
039100     SET MMEFRB-CLOSE            TO TRUE.
039200     PERFORM MB00PD-MMEF-ACCESS
039300        THRU MB00PD-MMEF-ACCESS-EXIT.
039400*
039500     MOVE 'C1CC'                 TO SS02WS-ABEND-LOCATION.
039600     SET MTCCRB-CLOSE            TO TRUE.
039700     PERFORM MB00PD-MTCC-ACCESS
039800        THRU MB00PD-MTCC-ACCESS-EXIT.
039900*
040000     PERFORM MB20PD-CLOSE-PRINT-FILES
040100        THRU MB20PD-CPF-EXIT.
040200*
040300 A399-CF-EXIT.
040400     EXIT.
040500/
040600 1000-BUILD-SORT-RECORD SECTION.
040700 1001-BSR-BEGIN.
040800*
040900     MOVE 'R1MM'                 TO SS02WS-ABEND-LOCATION.
041000     SET MMMMRB-READ-SEQ         TO TRUE.
041100     PERFORM MB00PD-MMMM-ACCESS
041200        THRU MB00PD-MMMM-ACCESS-EXIT.
041300*
041400     IF  MMMMIO-TRAILER
041500         GO TO 1090-BSR-BUILD-TRAILER.
041600*
041700     IF  MTCC-MBU40X-ALL-ORGS
041800         NEXT SENTENCE
041900     ELSE
042000         IF  MMMMIO-ORG-X IS GREATER THAN MTCC-MBU40X-ORG-OPTION-X
042100             GO TO 1090-BSR-BUILD-TRAILER.
042200*
042300     IF  MTCC-MBU40X-ALL-ORGS
042400     OR  MTCC-MBU40X-ORG-OPTION-X IS EQUAL TO MMMMIO-ORG-X
042500         NEXT SENTENCE
042600     ELSE
042700         GO TO 1001-BSR-BEGIN.
042800*
042900     MOVE MMMMIO-RECORD          TO MMMM-RECORD.
043000*
043100     IF  MMMM-REC-PURGED
043200         GO TO 1001-BSR-BEGIN.
043300*
043400     IF  MMMM-EXPENSE-TABLE-NBR IS NOT EQUAL TO ZERO
043500         MOVE MMMM-ORG           TO MS1S-ORG
043600         MOVE MMMM-EXPENSE-TABLE-NBR
043700                                 TO MS1S-TABLE-NBR
043800         MOVE MMMM-MERCHANT      TO MS1S-MERCHANT
043900         MOVE ZERO               TO MS1S-PRODUCT
044000         MOVE MMMM-NA-LINE (1 1) TO MS1S-NAME
044100         RELEASE MS1S-RECORD
044200     END-IF.
044300*
044400     GO TO 1001-BSR-BEGIN.
044500*
044600*
044700*
044800 1090-BSR-BUILD-TRAILER.
044900*
045000     MOVE 999                    TO MS1S-ORG.
045100     MOVE 999999999              TO MS1S-TABLE-NBR.
045200     MOVE ZERO                   TO MS1S-MERCHANT.
045300     MOVE ZERO                   TO MS1S-PRODUCT.
045400     MOVE SPACES                 TO MS1S-NAME.
045500     RELEASE MS1S-RECORD.
045600*
045700*
045800*
045900 1099-BSR-EXIT.
046000     EXIT.
046100/
046200 2000-UPDATE-MMEF SECTION.
046300 2001-UMMEF-BEGIN.
046400*
046500     PERFORM 2080-UMMEF-RETURN-SORT
046600        THRU 2080-UMMEF-RS-EXIT.
046700*
046800 2010-UMMEF-BEGIN.
046900*
047000     MOVE 'R1EF'                 TO SS02WS-ABEND-LOCATION.
047100     SET MMEFRB-READ-SEQ         TO TRUE.
047200     PERFORM MB00PD-MMEF-ACCESS
047300        THRU MB00PD-MMEF-ACCESS-EXIT.
047400*
047500     IF  MMEFIO-TRAILER
047600         GO TO 2090-UMMEF-BLEED-SORT.
047700*
047800     IF  MTCC-MBU40X-ALL-ORGS
047900         NEXT SENTENCE
048000     ELSE
048100         IF  MMEFIO-ORG-X IS GREATER THAN MTCC-MBU40X-ORG-OPTION-X
048200             GO TO 2090-UMMEF-BLEED-SORT.
048300*
048400     IF  MTCC-MBU40X-ALL-ORGS
048500     OR  MTCC-MBU40X-ORG-OPTION-X IS EQUAL TO MMEFIO-ORG-X
048600         NEXT SENTENCE
048700     ELSE
048800         GO TO 2010-UMMEF-BEGIN.
048900*
049000     MOVE MMEFIO-RECORD          TO MMEF-RECORD.
049100*
049200     IF  MMEF-REC-PURGED
049300         ADD  1                  TO WS-PURGED-NBR.
049400*
049500     IF  MMEF-REC-INCOMPLETE
049600     OR  MMEF-ADD-PENDING
049700         ADD  1                  TO WS-INCOMPLETE-NBR.
049800*
049900     IF  MMEF-REC-PURGED
050000     OR  MMEF-REC-INCOMPLETE
050100     OR  MMEF-ADD-PENDING
050200         PERFORM 2200-INACTIVE-RECORD
050300            THRU 2299-IR-EXIT
050400         GO TO 2010-UMMEF-BEGIN.
050500*
050600     IF  MMEF-ORG IS NOT EQUAL TO MMOC-ORG
050700         PERFORM 8000-ORG-CHANGE
050800            THRU 8099-OC-EXIT.
050900*
051000     IF  MMEF-REC-INACTIVE
051100     AND MTCC-MBU40X-UPDATE
051200         SET MMEF-REC-ACTIVE     TO TRUE.
051300*
051400     IF  MMEF-KEY IS GREATER THAN MS1S-KEY
051500         PERFORM 2300-MISSING-RECORD
051600            THRU 2399-MR-EXIT
051700            UNTIL MS1S-KEY IS NOT LESS THAN MMEF-KEY.
051800*
051900     EVALUATE TRUE
052000       WHEN MMEF-KEY IS LESS THAN MS1S-KEY
052100           IF  MTCC-MBU40X-UPDATE
052200               SET MMEF-REC-INACTIVE
052300                                 TO TRUE
052400           END-IF
052500           PERFORM 2200-INACTIVE-RECORD
052600              THRU 2299-IR-EXIT
052700       WHEN OTHER
052800           PERFORM
052900               UNTIL MS1S-KEY IS GREATER THAN MMEF-KEY
053000               PERFORM 2100-ACTIVE-RECORD
053100                  THRU 2199-AR-EXIT
053200               IF  MTCC-MBU40X-FULL-RPT
053300                   PERFORM 2080-UMMEF-RETURN-SORT
053400                      THRU 2080-UMMEF-RS-EXIT
053500               ELSE
053600                   PERFORM 2080-UMMEF-RETURN-SORT
053700                      THRU 2080-UMMEF-RS-EXIT
053800                      UNTIL MS1S-KEY IS GREATER THAN MMEF-KEY
053900               END-IF
054000           END-PERFORM
054100     END-EVALUATE.
054200*
054300     EVALUATE TRUE
054400       WHEN MMEF-REC-INACTIVE
054500           ADD  1                TO WS-INACTIVE-NBR
054600       WHEN OTHER
054700           ADD  1                TO WS-ACTIVE-NBR
054800     END-EVALUATE.
054900*
055000     IF  MTCC-MBU40X-UPDATE
055100         MOVE MMEF-RECORD        TO MMEFIO-RECORD
055200         MOVE 'U1EF'             TO SS02WS-ABEND-LOCATION
055300         SET MMEFRB-REWRITE      TO TRUE
055400         PERFORM MB00PD-MMEF-ACCESS
055500            THRU MB00PD-MMEF-ACCESS-EXIT
055600     END-IF.
055700*
055800     GO TO 2010-UMMEF-BEGIN.
055900*
056000*
056100*
056200 2080-UMMEF-RETURN-SORT.
056300*
056400     RETURN MS1S-SORT-FILE
056500         AT END
056600             MOVE 'Y'            TO WS-MBU401-EOF-SW.
056700*
056800 2080-UMMEF-RS-EXIT.
056900     EXIT.
057000*
057100*
057200*
057300 2090-UMMEF-BLEED-SORT.
057400*
057500     PERFORM 2080-UMMEF-RETURN-SORT
057600        THRU 2080-UMMEF-RS-EXIT
057700        UNTIL WS-MBU401-EOF-SW IS EQUAL TO 'Y'.
057800*
057900*
058000*
058100     MOVE SPACES                 TO MB20WS-PRINT-LINE.
058200     PERFORM MB20PD-PRINT-2-LINES
058300        THRU MB20PD-P2L-EXIT.
058400*
058500     MOVE WS-INCOMPLETE-NBR      TO WS-PL2-TOTAL.
058600     MOVE 'STATUS=0, INCOMPLETE RECORDS'
058700                                 TO WS-PL2-TOTAL-DESC.
058800     PERFORM MB20PD-PRINT-1-LINE
058900        THRU MB20PD-P1L-EXIT.
059000*
059100     MOVE WS-ACTIVE-NBR          TO WS-PL2-TOTAL.
059200     MOVE 'STATUS=1, ACTIVE RECORDS'
059300                                 TO WS-PL2-TOTAL-DESC.
059400     PERFORM MB20PD-PRINT-1-LINE
059500        THRU MB20PD-P1L-EXIT.
059600*
059700     MOVE WS-INACTIVE-NBR        TO WS-PL2-TOTAL.
059800     MOVE 'STATUS=2, INACTIVE RECORDS'
059900                                 TO WS-PL2-TOTAL-DESC.
060000     PERFORM MB20PD-PRINT-1-LINE
060100        THRU MB20PD-P1L-EXIT.
060200*
060300     MOVE WS-PURGED-NBR          TO WS-PL2-TOTAL.
060400     MOVE 'STATUS=9, PURGED RECORDS'
060500                                 TO WS-PL2-TOTAL-DESC.
060600     PERFORM MB20PD-PRINT-1-LINE
060700        THRU MB20PD-P1L-EXIT.
060800*
060900     MOVE '+------------'        TO WS-PRINT-LINE-2.
061000     PERFORM MB20PD-PRINT-1-LINE
061100        THRU MB20PD-P1L-EXIT.
061200*
061300     MOVE '='                    TO WS-PRINT-LINE-2.
061400     COMPUTE WS-PL2-TOTAL        =  WS-INCOMPLETE-NBR
061500                                 +  WS-ACTIVE-NBR
061600                                 +  WS-INACTIVE-NBR
061700                                 +  WS-PURGED-NBR.
061800     MOVE 'TOTAL RECORDS'        TO WS-PL2-TOTAL-DESC.
061900     PERFORM MB20PD-PRINT-1-LINE
062000        THRU MB20PD-P1L-EXIT.
062100*
062200 2099-UMMEF-EXIT.
062300     EXIT.
062400/
062500 2100-ACTIVE-RECORD SECTION.
062600 2101-AR-BEGIN.
062700*
062800     IF  MMEF-KEY IS NOT EQUAL TO WS-PREV-KEY
062900         PERFORM MB20PD-PRINT-1-LINE
063000            THRU MB20PD-P1L-EXIT
063100         MOVE MMEF-TABLE-NBR     TO WS-PL1-TABLE-NBR
063200         MOVE MMEF-REC-STATUS    TO WS-PL1-STATUS
063300         MOVE MMEF-TABLE-NAME    TO WS-PL1-TABLE-NAME
063400     ELSE
063500         MOVE MMEF-TABLE-NBR     TO WS-PL1-TABLE-NBR
063600     END-IF.
063700*
063800     IF  MTCC-MBU40X-FULL-RPT
063900         MOVE MS1S-MERCHANT      TO WS-PL1-MERCHANT
064000         MOVE MS1S-NAME          TO WS-PL1-NAME
064100         PERFORM MB20PD-PRINT-1-LINE
064200            THRU MB20PD-P1L-EXIT
064300     ELSE
064400         PERFORM MB20PD-PRINT-2-LINES
064500            THRU MB20PD-P2L-EXIT
064600     END-IF.
064700*
064800     MOVE MMEF-KEY               TO WS-PREV-KEY.
064900*
065000 2199-AR-EXIT.
065100     EXIT.
065200/
065300 2200-INACTIVE-RECORD SECTION.
065400 2201-IR-BEGIN.
065500*
065600     PERFORM MB20PD-PRINT-1-LINE
065700        THRU MB20PD-P1L-EXIT.
065800     MOVE MMEF-TABLE-NBR         TO WS-PL1-TABLE-NBR.
065900     MOVE MMEF-REC-STATUS        TO WS-PL1-STATUS.
066000     MOVE MMEF-TABLE-NAME        TO WS-PL1-TABLE-NAME.
066100     PERFORM MB20PD-PRINT-2-LINES
066200        THRU MB20PD-P2L-EXIT.
066300*
066400 2299-IR-EXIT.
066500     EXIT.
066600/
066700 2300-MISSING-RECORD SECTION.
066800 2301-MR-BEGIN.
066900*
067000     PERFORM MB20PD-PRINT-1-LINE
067100        THRU MB20PD-P1L-EXIT.
067200     MOVE MS1S-TABLE-NBR         TO WS-PL1-TABLE-NBR.
067300     MOVE '?'                    TO WS-PL1-STATUS.
067400     MOVE '>>> TABLE NOT DEFINED <<<'
067500                                 TO WS-PL1-TABLE-NAME.
067600     MOVE MS1S-MERCHANT          TO WS-PL1-MERCHANT.
067700     MOVE MS1S-NAME              TO WS-PL1-NAME.
067800*
067900     PERFORM MB20PD-PRINT-2-LINES
068000        THRU MB20PD-P2L-EXIT.
068100*
068200     PERFORM 2080-UMMEF-RETURN-SORT
068300        THRU 2080-UMMEF-RS-EXIT.
068400*
068500 2399-MR-EXIT.
068600     EXIT.
068700/
068800 8000-ORG-CHANGE SECTION.
068900 8010-OC-BEGIN.
069000*
069100     MOVE MMEF-ORG               TO MMOCIO-ORG.
069200*
069300     MOVE 'R2OC'                 TO SS02WS-ABEND-LOCATION.
069400     SET MMOCRB-READ-RANDOM      TO TRUE.
069500     PERFORM MB00PD-MMOC-ACCESS
069600        THRU MB00PD-MMOC-ACCESS-EXIT.
069700*
069800     MOVE MMOCIO-RECORD          TO MMOC-RECORD.
069900*
070000     MOVE MMOC-ORG               TO MB20WS-SH-ORG.
070100     MOVE MMOC-NA-LINE (1 1)     TO MB20WS-SH-ORG-NAME.
070200*
070300     MOVE MMOC-LINES-PER-PAGE    TO MB20WS-LINE-LIMIT.
070400     MOVE MMOC-FORM              TO MB20WS-FORM-CODE.
070500     MOVE MMOC-FICHE-FLAG        TO MB20WS-FICHE-CODE.
070600     MOVE MB20WS-FORCE-PAGE      TO MB20WS-LINE-COUNT.
070700     MOVE ZERO                   TO MB20WS-PAGE-COUNT.
070800*
070900 8099-OC-EXIT.
071000     EXIT.
071100/
071200 9000-PERFORMED-ROUTINES SECTION.
071300     COPY MB00PD REPLACING ==:MB00:== BY ==MMSC==.
071400/
071500     COPY MB00PD REPLACING ==:MB00:== BY ==MMOC==.
071600/
071700     COPY MB00PD REPLACING ==:MB00:== BY ==MMMM==.
071800/
071900     COPY MB00PD REPLACING ==:MB00:== BY ==MMEF==.
072000/
072100     COPY MB00PD REPLACING ==:MB00:== BY ==MTCC==.
072200/
072300     COPY MB20PD.
072400/
072500     COPY MB99PD.
072600/
072700     COPY SS02PD.
072800/
072900     COPY SS07PD.
073000/
073100     COPY SS08PD.
073200/
073300     COPY SS16PD.
073400/
073500     COPY SS26PD.
073600/
073700     COPY SS27PD.
073800/
073900     COPY SS98PD.
074000*
074100 9995-END-SOURCE-STATEMENTS SECTION.
074200 9999-END-OF-PROGRAM.
074300     EXIT.
