000100 IDENTIFICATION DIVISION.
000200 PROGRAM-ID. MBU420.
000201*       RELEASE DATE=08/24/01.        REVISION LEVEL=08.06      *
000202*****************************************************************
000203*WARNING.  THIS COMPUTER PROGRAM IS PROTECTED BY COPYRIGHT LAW  *
000204*AND INTERNATIONAL TREATIES.  UNAUTHORIZED REPRODUCTION OR      *
000205*DISTRIBUTION OF THIS PROGRAM, OR ANY PORTION OF IT, MAY RESULT *
000206*IN SEVERE CIVIL AND CRIMINAL PENATLIES, AND WILL BE PROSECUTED *
000207*TO THE MAXIMUM EXTENT POSSIBLE UNDER THE LAW.                  *
000208*COPYRIGHT 1999 PAYSYS INTERNATIONAL, INC.  ALL RIGHTS RESERVED.*
000209*****************************************************************
000300*****************************************************************
000400*                                                               *
000500*       MBU420 - MERCHANT RELATIONSHIP FILE BUILD
000600*                                                               *
000700*****************************************************************
000800 ENVIRONMENT DIVISION.
000900 CONFIGURATION SECTION.
001000 SOURCE-COMPUTER.            IBM-4341.
001100 OBJECT-COMPUTER.            IBM-4341.
001200/
001300 INPUT-OUTPUT SECTION.
001400*
001500 FILE-CONTROL.
001600*
001700     COPY MS1SES.
001800/
001900 DATA DIVISION.
002000 FILE SECTION.
002100/
002200     COPY MS1SSD.
002300 01  MS1S-RECORD.
002400     03 MS1S-KEY.
002500         05  MS1S-ORG-CHAIN.
002600             07  MS1S-ORG    PIC  9(03).
002700             07  MS1S-CHAIN  PIC  9(09).
002800         05  MS1S-MERCHANT   PIC  9(09).
002900     03  MS1S-MERCH-NAME     PIC  X(30).
003000/
003100 WORKING-STORAGE SECTION.
003200*
003300 01  FILLER                  PIC  X(12)      VALUE '** WS-BEG **'.
003400*
003500 01  WS-MBU420-WORK-AREAS.
003600     03  WS-SEQ-NBR          PIC S9(04)      BINARY VALUE +1.
003700     03  WS-SEQ              PIC S9(04)      BINARY VALUE ZEROS.
003800     03  WS-NBR-OF-MEMBERS   PIC S9(03)      COMP-3 VALUE ZEROS.
003900     03  WS-TOTAL-MEMBERS    PIC S9(09)      COMP-3 VALUE ZEROS.
004000     03  WS-ORG              PIC  9(03)      VALUE ZEROS.
004100     03  WS-CHAIN            PIC  9(09)      VALUE ZEROS.
004200     03  WS-CHAIN-NAME       PIC  X(30)      VALUE SPACES.
004300     03  WS-R1-MERCH-NAMES.
004400         05  WS-MERCH-NAME   PIC  X(30)      OCCURS 800 TIMES
004500                                             INDEXED BY
004600                                             X-MERCH-NAME.
004700*
004800*
004900 01  WS-SWITCHS.
005000     03  WS-MS1S-EOF-SW      PIC  X(01)      VALUE 'N'.
005100         88  WS-MS1S-IS-END-OF-FILE          VALUE 'Y'.
005200     03  WS-1ST-TIME-MS1S-SW PIC  X(01)      VALUE 'Y'.
005300         88  WS-1ST-TIME-MS1S                VALUE 'Y'.
005400     03  WS-1ST-TIME-MERCH-SW
005500                             PIC  X(01)      VALUE 'Y'.
005600         88  WS-1ST-TIME-MERCH-ON            VALUE 'Y'.
005700         88  WS-1ST-TIME-MERCH-OFF           VALUE 'N'.
005800     03  WS-1ST-TIME-RPT-SW  PIC  X(01)      VALUE 'Y'.
005900         88  WS-1ST-TIME-RPT                 VALUE 'Y'.
006000     03  WS-SEQ-NBR-SW       PIC  X(01)      VALUE 'N'.
006100         88  WS-SEQ-NBR-ON                   VALUE 'Y'.
006200/
006300     COPY MMMMRL.
006400/
006500     COPY MB00RB REPLACING ==:MB00:== BY ==MMMM==.
006600/
006700     COPY MMMMIO.
006800/
006900     COPY MMRCRL.
007000/
007100     COPY MB00RB REPLACING ==:MB00:== BY ==MMRC==.
007200/
007300     COPY MMRCIO.
007400/
007500     COPY MMRDIR REPLACING ==:MMRD:== BY ==MMRD==.
007600/
007700     COPY MMRDRL REPLACING ==:MMRD:== BY ==MTRD==.
007800/
007900     COPY MB00RB REPLACING ==:MB00:== BY ==MTRD==.
008000/
008100     COPY MMRDIO REPLACING ==:MMRD:== BY ==MTRD==.
008200/
008300     COPY MMSCRL.
008400/
008500     COPY MB00RB REPLACING ==:MB00:== BY ==MMSC==.
008600/
008700     COPY MMSCIO.
008800/
008900     COPY MMOCRL.
009000/
009100     COPY MB00RB REPLACING ==:MB00:== BY ==MMOC==.
009200/
009300     COPY MMOCIO.
009400/
009500     COPY MB00WS.
009600/
009700     COPY MB99WS.
009800/
009900     COPY MB20WS.
010000*
010100 01  WS-PRINT-LINE-00        REDEFINES MB20WS-PRINT-LINE.
010200     05  FILLER              PIC  X(132).
010300*
010400 01  WS-PRINT-LINE-01        REDEFINES MB20WS-PRINT-LINE.
010500     03  WS-MERCH-DATA                       OCCURS 3 TIMES
010600                                             INDEXED BY
010700                                             X-MERCH.
010800         05  FILLER          PIC  X(02).
010900         05  WS-PL01-MERCH   PIC  9(09).
011000         05  FILLER          PIC  X(02).
011100         05  WS-PL01-MERCH-NAME
011200                             PIC  X(30).
011300         05  FILLER          PIC  X(01).
011400*
011500 01  WS-HEADING-LINE-01      REDEFINES MB20WS-PRINT-LINE.
011600     03  FILLER              PIC  X(05).
011700     03  WS-HL01-LIT-1       PIC  X(03).
011800     03  FILLER              PIC  X(02).
011900     03  WS-HL01-ORG         PIC  9(03).
012000     03  FILLER              PIC  X(02).
012100     03  WS-HL01-LIT-2       PIC  X(15).
012200     03  FILLER              PIC  X(02).
012300     03  WS-HL01-CHAIN       PIC  9(09).
012400     03  FILLER              PIC  X(02).
012500     03  WS-HL01-LIT-3       PIC  X(13).
012600     03  FILLER              PIC  X(03).
012700     03  WS-HL01-CHAIN-NAME  PIC  X(40).
012800     03  FILLER              PIC  X(03).
012900     03  WS-HL01-MSG         PIC  X(30).
013000*
013100 01  WS-HEADING-LINE-03      REDEFINES MB20WS-PRINT-LINE.
013200     03  FILLER              PIC  X(02).
013300     03  WS-HL03-MERCH-1     PIC  X(09).
013400     03  FILLER              PIC  X(09).
013500     03  WS-HL03-NAME-1      PIC  X(13).
013600     03  FILLER              PIC  X(13).
013700     03  WS-HL03-MERCH-2     PIC  X(09).
013800     03  FILLER              PIC  X(09).
013900     03  WS-HL03-NAME-2      PIC  X(13).
014000     03  FILLER              PIC  X(13).
014100     03  WS-HL03-MERCH-3     PIC  X(09).
014200     03  FILLER              PIC  X(09).
014300     03  WS-HL03-NAME-3      PIC  X(13).
014400*
014500 01  WS-TOTAL-LINE-02        REDEFINES MB20WS-PRINT-LINE.
014600     03  FILLER              PIC  X(05).
014700     03  WS-TL02-LIT-1       PIC  X(19).
014800     03  FILLER              PIC  X(02).
014900     03  WS-TL02-NBR-MERCH   PIC  ZZZZZZZZZZ9-.
015000     03  WS-TL02-SEQ-DESC    PIC  X(14).
015100     03  WS-TL02-SEQ-NBR     PIC  ZZZ9-.
015200/
015300     COPY SS00WS.
015400/
015500     COPY SS01WS.
015600/
015700     COPY SS02WS.
015800*
015900 01  FILLER                  PIC  X(12)      VALUE '** WS-END **'.
016000/
016100 PROCEDURE DIVISION.
016200 A000-MAIN-LINE-SECT SECTION.
016300 A010-ML-BEGIN.
016400*
016500     PERFORM A100-OPEN-FILES
016600        THRU A199-OF-EXIT.
016700*
016800     MOVE MMSC-FICHE-FLAG        TO MB20WS-FICHE-CODE.
016900     MOVE MMSC-SCREEN-HEADER     TO MB20WS-SH-SYSTEM.
017000     MOVE 'MB000000'             TO MB20WS-SH-RPT-ID.
017100     MOVE 'T420'                 TO MB20WS-SH-INTERNAL-RPT-ID.
017200     MOVE MMSC-ORG               TO MB20WS-SH-ORG.
017300     MOVE MMSC-PROC-CENTER-ID    TO MB20WS-SH-ORG-NAME.
017400     MOVE '          MERCH GROUP REBUILD'
017500                                 TO MB20WS-SH-RPT-NAME.
017600     MOVE MMSC-TODAYS-JULIAN     TO SS01WS-JULIAN.
017700     PERFORM SS26PD-NUMERICALLY-EDIT-DATE
017800                                 THRU SS26PD-NED-EXIT.
017900     MOVE SS01WS-XX-XX-YYYY      TO MB20WS-SH-FILE-DATE.
018000     MOVE SPACES                 TO MB20WS-SH-DEST-ID.
018100     MOVE SPACES                 TO MB20WS-SH-DEST-DESC.
018200*
018300     SORT MS1S-SORT-FILE
018400          ASCENDING KEY MS1S-KEY
018500          INPUT PROCEDURE        IS B000-READ-INPUT-SEC
018600          OUTPUT PROCEDURE       IS C000-WRITE-SORTED-FILE-SEC.
018700*
018800     PERFORM SS98PD-VERIFY-SORT-RETURN
018900        THRU SS98PD-VSR-EXIT.
019000*
019100     PERFORM A200-CLOSE-FILES
019200        THRU A299-CF-EXIT.
019300*
019400     STOP RUN.
019500/
019600 A100-OPEN-FILES.
019700     MOVE 'MBU420'               TO SS02WS-ABEND-PROG-ID.
019800*
019900     MOVE 'O1SC'                 TO SS02WS-ABEND-LOCATION.
020000     SET MMSCRB-OPEN-INPUT       TO TRUE.
020100     PERFORM MB00PD-MMSC-ACCESS
020200        THRU MB00PD-MMSC-ACCESS-EXIT.
020300*
020400     MOVE 'O1OC'                 TO SS02WS-ABEND-LOCATION.
020500     SET MMOCRB-OPEN-INPUT-DYN   TO TRUE.
020600     PERFORM MB00PD-MMOC-ACCESS
020700        THRU MB00PD-MMOC-ACCESS-EXIT.
020800*
020900     MOVE 'O1MM'                 TO SS02WS-ABEND-LOCATION.
021000     SET MMMMRB-OPEN-INPUT       TO TRUE.
021100     PERFORM MB00PD-MMMM-ACCESS
021200        THRU MB00PD-MMMM-ACCESS-EXIT.
021300*
021400     MOVE 'O1RC'                 TO SS02WS-ABEND-LOCATION.
021500     SET MMRCRB-OPEN-INPUT       TO TRUE.
021600     PERFORM MB00PD-MMRC-ACCESS
021700        THRU MB00PD-MMRC-ACCESS-EXIT.
021800*
021900     MOVE 'O1RD'                 TO SS02WS-ABEND-LOCATION.
022000     SET MTRDRB-OPEN-OUTPUT      TO TRUE.
022100     PERFORM MB00PD-MTRD-ACCESS
022200        THRU MB00PD-MTRD-ACCESS-EXIT.
022300*
022400*
022500*
022600     MOVE 'R0SC'                 TO SS02WS-ABEND-LOCATION.
022700     SET MMSCRB-READ-SEQ         TO TRUE.
022800     PERFORM MB00PD-MMSC-ACCESS
022900        THRU MB00PD-MMSC-ACCESS-EXIT.
023000     MOVE 'MMSC'                 TO MB99WS-FILE-ID.
023100*
023200     IF  MMSCIO-HEADER
023300         NEXT SENTENCE
023400     ELSE
023500         PERFORM MB99PD-MISSING-HEADER-ABEND
023600            THRU MB99PD-MHA-EXIT.
023700*
023800     MOVE MMSCIO-RECORD          TO MMSC-RECORD.
023900     MOVE MMSC-TODAYS-JULIAN     TO MB99WS-PROC-DATE.
024000     MOVE MMSC-TIME-STAMP        TO MB99WS-PROC-TIME.
024100     MOVE MMSC-DATE-FORMAT       TO SS01WS-DATE-FORMAT.
024200*
024300*
024400*
024500     MOVE 'R0OC'                 TO SS02WS-ABEND-LOCATION.
024600     SET MMOCRB-READ-SEQ         TO TRUE.
024700     PERFORM MB00PD-MMOC-ACCESS
024800        THRU MB00PD-MMOC-ACCESS-EXIT.
024900     MOVE 'MMOC'                 TO MB99WS-FILE-ID.
025000*
025100     IF  MMOCIO-HEADER
025200         NEXT SENTENCE
025300     ELSE
025400         PERFORM MB99PD-MISSING-HEADER-ABEND
025500            THRU MB99PD-MHA-EXIT.
025600*
025700     MOVE MMOCIO-DATE-STAMP      TO MB99WS-FILE-DATE.
025800     MOVE MMOCIO-TIME-STAMP      TO MB99WS-FILE-TIME.
025900     PERFORM MB99PD-CHECK-DATE-TIME
026000        THRU MB99PD-CDT-EXIT.
026100*
026200*
026300*
026400     MOVE 'R0MM'                 TO SS02WS-ABEND-LOCATION.
026500     SET MMMMRB-READ-SEQ         TO TRUE.
026600     PERFORM MB00PD-MMMM-ACCESS
026700        THRU MB00PD-MMMM-ACCESS-EXIT.
026800     MOVE 'MMMM'                 TO MB99WS-FILE-ID.
026900*
027000     IF  MMMMIO-HEADER
027100         NEXT SENTENCE
027200     ELSE
027300         PERFORM MB99PD-MISSING-HEADER-ABEND
027400            THRU MB99PD-MHA-EXIT.
027500*
027600     MOVE MMMMIO-DATE-STAMP      TO MB99WS-FILE-DATE.
027700     MOVE MMMMIO-TIME-STAMP      TO MB99WS-FILE-TIME.
027800     PERFORM MB99PD-CHECK-DATE-TIME
027900        THRU MB99PD-CDT-EXIT.
028000*
028100     MOVE 'R1MM'                 TO SS02WS-ABEND-LOCATION.
028200     SET MMMMRB-READ-SEQ         TO TRUE.
028300     PERFORM MB00PD-MMMM-ACCESS
028400        THRU MB00PD-MMMM-ACCESS-EXIT.
028500     MOVE MMMMIO-RECORD          TO MMMM-RECORD.
028600*
028700*
028800*
028900*
029000     MOVE 'R0RC'                 TO SS02WS-ABEND-LOCATION.
029100     SET MMRCRB-READ-SEQ         TO TRUE.
029200     PERFORM MB00PD-MMRC-ACCESS
029300        THRU MB00PD-MMRC-ACCESS-EXIT.
029400     MOVE 'MMRC'                 TO MB99WS-FILE-ID.
029500*
029600     IF  MMRCIO-HEADER
029700         NEXT SENTENCE
029800     ELSE
029900         PERFORM MB99PD-MISSING-HEADER-ABEND
030000            THRU MB99PD-MHA-EXIT.
030100*
030200     MOVE MMRCIO-DATE-STAMP      TO MB99WS-FILE-DATE.
030300     MOVE MMRCIO-TIME-STAMP      TO MB99WS-FILE-TIME.
030400     PERFORM MB99PD-CHECK-DATE-TIME
030500        THRU MB99PD-CDT-EXIT.
030600*
030700*
030800*
030900     MOVE SPACES                 TO MTRDIO-RECORD.
031000     MOVE ZEROS                  TO MTRDIO-KEY
031100                                    MTRDIO-DATE-STAMP
031200                                    MTRDIO-TIME-STAMP.
031300     MOVE 'W1RD'                 TO SS02WS-ABEND-LOCATION.
031400     SET MTRDRB-WRITE            TO TRUE.
031500     PERFORM MB00PD-MTRD-ACCESS
031600        THRU MB00PD-MTRD-ACCESS-EXIT.
031700*
031800*
031900 A199-OF-EXIT.
032000     EXIT.
032100/
032200 A200-CLOSE-FILES.
032300*
032400     MOVE 'C1SC'                 TO SS02WS-ABEND-LOCATION.
032500     SET MMSCRB-CLOSE            TO TRUE.
032600     PERFORM MB00PD-MMSC-ACCESS
032700        THRU MB00PD-MMSC-ACCESS-EXIT.
032800*
032900     MOVE 'C1MM'                 TO SS02WS-ABEND-LOCATION.
033000     SET MMMMRB-CLOSE            TO TRUE.
033100     PERFORM MB00PD-MMMM-ACCESS
033200        THRU MB00PD-MMMM-ACCESS-EXIT.
033300*
033400     MOVE 'C1OC'                 TO SS02WS-ABEND-LOCATION.
033500     SET MMOCRB-CLOSE            TO TRUE.
033600     PERFORM MB00PD-MMOC-ACCESS
033700        THRU MB00PD-MMOC-ACCESS-EXIT.
033800*
033900     MOVE 'C1RC'                 TO SS02WS-ABEND-LOCATION.
034000     SET MMRCRB-CLOSE            TO TRUE.
034100     PERFORM MB00PD-MMRC-ACCESS
034200        THRU MB00PD-MMRC-ACCESS-EXIT.
034300*
034400     MOVE 'C1RD'                 TO SS02WS-ABEND-LOCATION.
034500     SET MTRDRB-CLOSE            TO TRUE.
034600     PERFORM MB00PD-MTRD-ACCESS
034700        THRU MB00PD-MTRD-ACCESS-EXIT.
034800*
034900     PERFORM MB20PD-CLOSE-PRINT-FILES
035000        THRU MB20PD-CPF-EXIT.
035100*
035200 A299-CF-EXIT.
035300     EXIT.
035400/
035500 B000-READ-INPUT-SEC SECTION.
035600 B010-BEG-INPUT.
035700*
035800     PERFORM B100-PROCESS-MMMM
035900        THRU B199-PR-EXIT
036000        UNTIL MMMMIO-TRAILER.
036100*
036200     MOVE LOW-VALUES             TO MS1S-RECORD.
036300*
036400     GO TO B999-EXIT.
036500*
036600 B099-RIS-EXIT.
036700     EXIT.
036800/
036900 B100-PROCESS-MMMM.
037000*
037100     MOVE MMMMIO-RECORD          TO MMMM-RECORD.
037200*
037300     IF  MMMM-REC-ACTIVE
037400     OR  MMMM-REC-CLOSED
037500     OR  MMMM-REC-PENDING-PURGE
037600     OR  MMMM-REC-PURGING
037700         NEXT SENTENCE
037800     ELSE
037900         GO TO B110-CONTINUE.
038000*
038100     SET X-MMMM-MERCH-CHAIN      TO 1.
038200     PERFORM B200-FIND-CHAINS
038300        THRU B299-FC-EXIT
038400        UNTIL X-MMMM-MERCH-CHAIN GREATER THAN 10.
038500*
038600 B110-CONTINUE.
038700*
038800     MOVE 'R2MM'                 TO SS02WS-ABEND-LOCATION.
038900     SET MMMMRB-READ-SEQ         TO TRUE.
039000     PERFORM MB00PD-MMMM-ACCESS
039100        THRU MB00PD-MMMM-ACCESS-EXIT.
039200*
039300 B199-PR-EXIT.
039400     EXIT.
039500/
039600 B200-FIND-CHAINS.
039700*
039800     IF  MMMM-MERCH-CHAIN-ID (X-MMMM-MERCH-CHAIN)
039900         IS GREATER THAN ZERO
040000         MOVE MMMM-ORG           TO MS1S-ORG
040100         MOVE MMMM-MERCHANT      TO MS1S-MERCHANT
040200         MOVE MMMM-MERCH-CHAIN-ID (X-MMMM-MERCH-CHAIN)
040300                                 TO MS1S-CHAIN
040400         MOVE MMMM-NA-LINE (1 1) TO MS1S-MERCH-NAME
040500         RELEASE MS1S-RECORD.
040600*
040700     SET X-MMMM-MERCH-CHAIN      UP BY 1.
040800*
040900 B299-FC-EXIT.
041000     EXIT.
041100*
041200 B999-EXIT.
041300     EXIT.
041400/
041500 C000-WRITE-SORTED-FILE-SEC SECTION.
041600 C010-BEG-RETURN.
041700*
041800*
041900*
042000     PERFORM C100-PROCESS-MMRC
042100        THRU C199-PR-EXIT
042200        UNTIL MMRCIO-TRAILER.
042300*
042400     MOVE SPACES                 TO MTRDIO-RECORD.
042500     MOVE 999999999999           TO MTRDIO-KEY.
042600     MOVE 9999999                TO MTRDIO-DATE-STAMP.
042700     MOVE 99999999999            TO MTRDIO-TIME-STAMP.
042800     MOVE 'W3RD'                 TO SS02WS-ABEND-LOCATION.
042900     SET MTRDRB-WRITE            TO TRUE.
043000     PERFORM MB00PD-MTRD-ACCESS
043100        THRU MB00PD-MTRD-ACCESS-EXIT.
043200*
043300*
043400     GO TO C999-EXIT.
043500*
043600 C099-FR-EXIT.
043700     EXIT.
043800*
043900 C100-PROCESS-MMRC.
044000*
044100     MOVE 'R2RC'                 TO SS02WS-ABEND-LOCATION.
044200     SET MMRCRB-READ-SEQ         TO TRUE.
044300     PERFORM MB00PD-MMRC-ACCESS
044400        THRU MB00PD-MMRC-ACCESS-EXIT.
044500*
044600     MOVE 'N'                    TO WS-SEQ-NBR-SW.
044700     MOVE MMRCIO-RECORD          TO MMRC-RECORD.
044800     MOVE ZERO                   TO WS-TOTAL-MEMBERS.
044900*
045000     MOVE MMRDIR-RECORD          TO MTRD-RECORD.
045100*
045200     PERFORM C200-RETURN-SORT
045300        THRU C299-RS-EXIT
045400        UNTIL MS1S-ORG-CHAIN IS GREATER THAN
045500              MMRCIO-ORG-CHAIN
045600          OR  WS-MS1S-IS-END-OF-FILE.
045700*
045800 C199-PR-EXIT.
045900     EXIT.
046000*
046100 C200-RETURN-SORT.
046200*
046300     IF  WS-1ST-TIME-MS1S
046400         MOVE 'N'                TO WS-1ST-TIME-MS1S-SW
046500         RETURN MS1S-SORT-FILE
046600             AT END
046700                MOVE 'Y'         TO WS-MS1S-EOF-SW
046800                GO TO C299-RS-EXIT.
046900*
047000     IF  MS1S-ORG-CHAIN LESS THAN MMRCIO-ORG-CHAIN
047100         GO TO C220-RETURN.
047200*
047300     IF  MS1S-ORG-CHAIN GREATER THAN MMRCIO-ORG-CHAIN
047400     AND WS-1ST-TIME-MERCH-ON
047500         GO TO C299-RS-EXIT.
047600*
047700     IF  MS1S-ORG-CHAIN GREATER THAN MMRCIO-ORG-CHAIN
047800         GO TO C210-WRITE.
047900*
048000     IF  WS-1ST-TIME-MERCH-ON
048100         IF  WS-SEQ-NBR-ON
048200             NEXT SENTENCE
048300         ELSE
048400             MOVE 1              TO WS-SEQ-NBR.
048500*
048600     IF  WS-1ST-TIME-MERCH-ON
048700         MOVE 'SYS'              TO MTRD-LAST-MAINT-OPER
048800         MOVE MMSC-TODAYS-JULIAN
048900                                 TO MTRD-LAST-MAINT-DATE
049000         MOVE MS1S-ORG           TO MTRD-ORG
049100         MOVE MS1S-CHAIN         TO MTRD-CHAIN
049200         SET X-MTRD-MEMBER       TO 1
049300         MOVE ZEROS              TO WS-NBR-OF-MEMBERS
049400         SET WS-1ST-TIME-MERCH-OFF
049500                                 TO TRUE.
049600*
049700     IF  MS1S-ORG-CHAIN EQUAL MMRCIO-ORG-CHAIN
049800         MOVE MS1S-MERCHANT      TO
049900                                 MTRD-MEMBER (X-MTRD-MEMBER)
050000         SET X-MERCH-NAME        TO X-MTRD-MEMBER
050100         MOVE MS1S-MERCH-NAME    TO WS-MERCH-NAME (X-MERCH-NAME)
050200         ADD 1                   TO WS-NBR-OF-MEMBERS
050300         SET X-MTRD-MEMBER       UP BY 1
050400         IF  WS-NBR-OF-MEMBERS NOT LESS THAN 800
050500             GO TO C210-WRITE
050600         ELSE
050700             GO TO C220-RETURN.
050800*
050900 C210-WRITE.
051000*
051100     IF  MTRD-ORG IS EQUAL TO ZERO
051200         MOVE MMRDIR-RECORD      TO MTRD-RECORD
051300         MOVE ZERO               TO WS-NBR-OF-MEMBERS
051400         MOVE 1                  TO WS-SEQ-NBR
051500         MOVE 'N'                TO WS-SEQ-NBR-SW
051600         SET WS-1ST-TIME-MERCH-ON
051700                                 TO TRUE
051800         GO TO C299-RS-EXIT.
051900*
052000*
052100     SET WS-1ST-TIME-MERCH-ON    TO TRUE.
052200     MOVE 'W2RD'                 TO SS02WS-ABEND-LOCATION.
052300     MOVE WS-NBR-OF-MEMBERS      TO MTRD-NBR-OF-MEMBERS.
052400     ADD WS-NBR-OF-MEMBERS       TO WS-TOTAL-MEMBERS.
052500     MOVE WS-SEQ-NBR             TO MTRD-SEQ-NBR.
052600     SET MTRD-REC-ACTIVE         TO TRUE.
052700     PERFORM R100-REPORT-SECT
052800        THRU R199-RS-EXIT.
052900     MOVE MTRD-RECORD            TO MTRDIO-RECORD.
053000     SET MTRDRB-WRITE            TO TRUE.
053100     PERFORM MB00PD-MTRD-ACCESS
053200        THRU MB00PD-MTRD-ACCESS-EXIT.
053300*
053400     MOVE MMRDIR-RECORD          TO MTRD-RECORD.
053500*
053600     IF  WS-NBR-OF-MEMBERS NOT LESS THAN 800
053700         ADD 1                   TO WS-SEQ-NBR
053800         MOVE 'Y'                TO WS-SEQ-NBR-SW
053900         GO TO C220-RETURN.
054000*
054100     GO TO C299-RS-EXIT.
054200*
054300 C220-RETURN.
054400*
054500     RETURN MS1S-SORT-FILE
054600        AT END
054700           MOVE 'Y'              TO WS-MS1S-EOF-SW
054800           GO TO C210-WRITE.
054900*
055000     IF  MS1S-ORG-CHAIN NOT EQUAL MMRCIO-ORG-CHAIN
055100         AND
055200         WS-1ST-TIME-MERCH-OFF
055300         GO TO C210-WRITE.
055400*
055500 C299-RS-EXIT.
055600     EXIT.
055700*
055800 C999-EXIT.
055900     EXIT.
056000/
056100 R100-REPORT-SECT SECTION.
056200 R110-REPORTS.
056300*
056400     IF  WS-1ST-TIME-RPT
056500         MOVE 'N'                TO WS-1ST-TIME-RPT-SW
056600         PERFORM Z100-GET-ORG-OPTIONS
056700            THRU Z199-GOO-EXIT
056800         MOVE MTRD-ORG           TO WS-ORG
056900         MOVE MTRD-CHAIN         TO WS-CHAIN
057000         MOVE MTRD-SEQ-NBR       TO WS-SEQ
057100         PERFORM R300-HEADING-LINE1
057200            THRU R309-HL1-EXIT
057300         PERFORM R320-HEADING-LINE3
057400            THRU R329-HL3-EXIT
057500         SET X-MTRD-MEMBER       TO 1
057600         SET X-MERCH             TO 1
057700         SET X-MERCH-NAME        TO 1
057800         PERFORM R200-PRINT-DETAIL
057900            THRU R299-PD-EXIT
058000         PERFORM R410-TOTAL-LINE2
058100            THRU R419-TL2-EXIT
058200         GO TO R199-RS-EXIT.
058300*
058400     IF  MTRD-ORG NOT EQUAL WS-ORG
058500         PERFORM Z100-GET-ORG-OPTIONS
058600            THRU Z199-GOO-EXIT
058700         MOVE MB20WS-FORCE-PAGE  TO MB20WS-LINE-COUNT.
058800*
058900     IF  MTRD-CHAIN NOT EQUAL WS-CHAIN
059000     OR  (MTRD-CHAIN IS EQUAL WS-CHAIN
059100     AND  MTRD-SEQ-NBR IS NOT EQUAL WS-SEQ)
059200         MOVE MTRD-ORG        TO WS-ORG
059300         MOVE MTRD-CHAIN      TO WS-CHAIN
059400         MOVE MTRD-SEQ-NBR       TO WS-SEQ
059500         PERFORM R300-HEADING-LINE1
059600            THRU R309-HL1-EXIT
059700         PERFORM R320-HEADING-LINE3
059800            THRU R329-HL3-EXIT
059900         SET X-MTRD-MEMBER    TO 1
060000         SET X-MERCH             TO 1
060100         SET X-MERCH-NAME        TO 1
060200         PERFORM R200-PRINT-DETAIL
060300            THRU R299-PD-EXIT
060400         PERFORM R410-TOTAL-LINE2
060500            THRU R419-TL2-EXIT
060600         GO TO R199-RS-EXIT.
060700*
060800 R199-RS-EXIT.
060900     EXIT.
061000*
061100*
061200 R200-PRINT-DETAIL SECTION.
061300 R201-PD-SECT.
061400*
061500     IF  MTRD-MEMBER (X-MTRD-MEMBER) IS EQUAL ZEROS
061600         IF  MB20WS-PRINT-LINE IS NOT EQUAL TO SPACES
061700             PERFORM MB20PD-PRINT-1-LINE
061800                THRU MB20PD-P1L-EXIT
061900             GO TO R299-PD-EXIT
062000         ELSE
062100             GO TO R299-PD-EXIT
062200     ELSE
062300         MOVE MTRD-MEMBER (X-MTRD-MEMBER)
062400                                 TO WS-PL01-MERCH (X-MERCH)
062500         MOVE WS-MERCH-NAME (X-MERCH-NAME)
062600                                 TO WS-PL01-MERCH-NAME (X-MERCH)
062700         SET X-MTRD-MEMBER       UP BY 1
062800         SET X-MERCH-NAME        UP BY 1
062900         SET X-MERCH             UP BY 1.
063000*
063100     IF  X-MTRD-MEMBER GREATER THAN 800
063200         PERFORM MB20PD-PRINT-1-LINE
063300            THRU MB20PD-P1L-EXIT
063400         GO TO R299-PD-EXIT.
063500*
063600     IF  X-MERCH IS GREATER THAN 3
063700         PERFORM MB20PD-PRINT-1-LINE
063800            THRU MB20PD-P1L-EXIT
063900         SET X-MERCH              TO 1
064000         GO TO R201-PD-SECT
064100     ELSE
064200         GO TO R201-PD-SECT.
064300*
064400 R299-PD-EXIT.
064500     EXIT.
064600*
064700 R300-HEADING-LINE1 SECTION.
064800 R301-HL1-SECT.
064900*
065000     MOVE 'ORG'                  TO WS-HL01-LIT-1.
065100     MOVE MTRD-ORG               TO WS-HL01-ORG.
065200     MOVE 'CHAIN NUMBER'         TO WS-HL01-LIT-2.
065300     MOVE MTRD-CHAIN             TO WS-HL01-CHAIN.
065400     MOVE 'CHAIN NAME'           TO WS-HL01-LIT-3.
065500     MOVE MMRC-NA-LINE (1)       TO WS-HL01-CHAIN-NAME.
065600     MOVE 'STATEMENT FREQ-1='    TO WS-HL01-MSG.
065700     MOVE MMRC-STMT-FREQ-1-X     TO WS-HL01-MSG (18:2).
065800     MOVE '2='                   TO WS-HL01-MSG (21:2)
065900     MOVE MMRC-STMT-FREQ-2-X     TO WS-HL01-MSG (23:2).
066000*
066100     PERFORM MB20PD-PRINT-2-LINES
066200        THRU MB20PD-P2L-EXIT.
066300*
066400 R309-HL1-EXIT.
066500     EXIT.
066600*
066700 R320-HEADING-LINE3 SECTION.
066800 R321-HL3-SECT.
066900*
067000     MOVE 'MERCH NBR'            TO WS-HL03-MERCH-1.
067100     MOVE 'MERCHANT NAME'        TO WS-HL03-NAME-1.
067200     MOVE 'MERCH NBR'            TO WS-HL03-MERCH-2.
067300     MOVE 'MERCHANT NAME'        TO WS-HL03-NAME-2.
067400     MOVE 'MERCH NBR'            TO WS-HL03-MERCH-3.
067500     MOVE 'MERCHANT NAME'        TO WS-HL03-NAME-3.
067600*
067700     PERFORM MB20PD-PRINT-2-LINES
067800        THRU MB20PD-P2L-EXIT.
067900*
068000 R329-HL3-EXIT.
068100     EXIT.
068200*
068300 R410-TOTAL-LINE2 SECTION.
068400 R411-TL2-SECT.
068500*
068600     MOVE 'NUMBER OF MERCHANTS'  TO WS-TL02-LIT-1.
068700     MOVE WS-NBR-OF-MEMBERS      TO WS-TL02-NBR-MERCH.
068800     MOVE '  FOR SEQ NBR '       TO WS-TL02-SEQ-DESC.
068900     MOVE WS-SEQ-NBR             TO WS-TL02-SEQ-NBR.
069000*
069100     PERFORM MB20PD-PRINT-3-LINES
069200        THRU MB20PD-P3L-EXIT.
069300*
069400 R419-TL2-EXIT.
069500     EXIT.
069600/
069700 Z100-GET-ORG-OPTIONS SECTION.
069800 Z110-GOO-BEGIN.
069900*
070000     MOVE MTRD-ORG               TO MMOCIO-ORG.
070100*
070200     MOVE 'R1OC'                 TO SS02WS-ABEND-LOCATION.
070300     SET MMOCRB-READ-RANDOM      TO TRUE.
070400     PERFORM MB00PD-MMOC-ACCESS
070500        THRU MB00PD-MMOC-ACCESS-EXIT.
070600*
070700     MOVE MMOCIO-RECORD          TO MMOC-RECORD.
070800*
070900     MOVE MMOC-ORG               TO MB20WS-SH-ORG.
071000     MOVE ' - '                  TO MB20WS-SH-LIT-1.
071100     MOVE MMOC-NA-LINE (1 1)     TO MB20WS-SH-ORG-NAME.
071200     MOVE ZERO                   TO MB20WS-PAGE-COUNT.
071300     MOVE SPACES                 TO MB20WS-SH-LIT-5.
071400*
071500 Z199-GOO-EXIT.
071600     EXIT.
071700/
071800 9000-PERFORMED-ROUTINES-SECT SECTION.
071900*
072000     COPY MB00PD REPLACING ==:MB00:== BY ==MMMM==.
072100/
072200     COPY MB00PD REPLACING ==:MB00:== BY ==MMSC==.
072300/
072400     COPY MB00PD REPLACING ==:MB00:== BY ==MMOC==.
072500/
072600     COPY MB00PD REPLACING ==:MB00:== BY ==MMRC==.
072700/
072800     COPY MB00PD REPLACING ==:MB00:== BY ==MTRD==.
072900/
073000     COPY MB20PD.
073100/
073200     COPY MB99PD.
073300/
073400     COPY SS02PD.
073500/
073600     COPY SS08PD.
073700/
073800     COPY SS16PD.
073900/
074000     COPY SS26PD.
074100/
074200     COPY SS27PD.
074300/
074400     COPY SS98PD.
074500*
074600 9995-END-SOURCE-STATEMENTS SECTION.
074700 9999-END-OF-PROGRAM.
074800     EXIT.
