000100 IDENTIFICATION DIVISION.
000200 PROGRAM-ID. MBU480.
000201*       RELEASE DATE=08/24/01.        REVISION LEVEL=08.06      *
000202*****************************************************************
000203*WARNING.  THIS COMPUTER PROGRAM IS PROTECTED BY COPYRIGHT LAW  *
000204*AND INTERNATIONAL TREATIES.  UNAUTHORIZED REPRODUCTION OR      *
000205*DISTRIBUTION OF THIS PROGRAM, OR ANY PORTION OF IT, MAY RESULT *
000206*IN SEVERE CIVIL AND CRIMINAL PENATLIES, AND WILL BE PROSECUTED *
000207*TO THE MAXIMUM EXTENT POSSIBLE UNDER THE LAW.                  *
000208*COPYRIGHT 1999 PAYSYS INTERNATIONAL, INC.  ALL RIGHTS RESERVED.*
000209*****************************************************************
000300*****************************************************************
000400*                                                               *
000500*   V - PLUS  R E T A I L    M E R C H A N T      S Y S T E M   *
000600*                                                               *
000700*       MBU480 - REFRESH STORE MASTER WITH MERCHANT MASTER DATA *
000800*                                                               *
000900*****************************************************************
001000 ENVIRONMENT DIVISION.
001100 CONFIGURATION SECTION.
001200 SOURCE-COMPUTER.            IBM-4341.
001300 OBJECT-COMPUTER.            IBM-4341.
001400*
001500 INPUT-OUTPUT SECTION.
001600 FILE-CONTROL.
001700*
001800     COPY MS1SES.
001900*
002000 DATA DIVISION.
002100 FILE SECTION.
002200*
002300     COPY MS1SSD.
002400     COPY MMMMRL.
002500     03  MMMP-VI-RECORD      PIC  X(110).
002600     03  MMMP-MC-RECORD      PIC  X(110).
002700/
002800 WORKING-STORAGE SECTION.
002900*
003000 01  FILLER                  PIC  X(12)      VALUE '** WS-BEG **'.
003100/
003200     COPY MMSMIO.
003300/
003400     COPY MB00RB REPLACING ==:MB00:== BY ==MMSM==.
003500/
003600     COPY MMSMRL.
003700/
003800     COPY MMMMIO.
003900/
004000     COPY MMMMIR.
004100/
004200     COPY MB00RB REPLACING ==:MB00:== BY ==MMMM==.
004300/
004400     COPY MMMPIO.
004500/
004600     COPY MMMPIR.
004700/
004800     COPY MB00RB REPLACING ==:MB00:== BY ==MMMP==.
004900/
005000     COPY MMMPRL.
005100/
005200     COPY MMMPTB.
005300/
005400     COPY MMSCIO.
005500/
005600     COPY MB00RB REPLACING ==:MB00:== BY ==MMSC==.
005700/
005800     COPY MMSCRL.
005900/
006000     COPY MMXRIO.
006100/
006200     COPY MB00RB REPLACING ==:MB00:== BY ==MMXR==.
006300/
006400     COPY MMXRRL.
006500/
006600     COPY MB00WS.
006700/
006800     COPY MB99WS.
006900/
007000     COPY SS00WS.
007100/
007200     COPY SS01WS.
007300/
007400     COPY SS02WS.
007500*
007600 01  FILLER                  PIC  X(12)      VALUE '** WS-END **'.
007700/
007800 PROCEDURE DIVISION.
007900 A000-MAIN-LINE-SECT SECTION.
008000 A010-ML-BEGIN.
008100*
008200     MOVE 'MBU480'               TO SS02WS-ABEND-PROG-ID.
008300*
008400     PERFORM A100-OPEN-FILES     THRU A199-OF-EXIT.
008500*
008600     SORT MS1S-SORT-FILE
008700          ON ASCENDING KEY MMMM-KEY
008800          INPUT PROCEDURE        IS 0000-READ-MERCHANTS
008900          OUTPUT PROCEDURE       IS 5000-UPDATE-STORES.
009000*
009100     PERFORM SS98PD-VERIFY-SORT-RETURN
009200        THRU SS98PD-VSR-EXIT.
009300*
009400     PERFORM A200-CLOSE-FILES    THRU A299-CF-EXIT.
009500*
009600     STOP RUN.
009700*
009800 A099-ML-EXIT.
009900     EXIT.
010000/
010100 A100-OPEN-FILES SECTION.
010200 A101-OF-OPEN-FILES.
010300*
010400     MOVE 'O1SM'                 TO SS02WS-ABEND-LOCATION.
010500     SET MMSMRB-OPEN-IO          TO TRUE.
010600     PERFORM MB00PD-MMSM-ACCESS  THRU MB00PD-MMSM-ACCESS-EXIT.
010700*
010800     MOVE 'O1MM'                 TO SS02WS-ABEND-LOCATION.
010900     SET MMMMRB-OPEN-INPUT       TO TRUE.
011000     PERFORM MB00PD-MMMM-ACCESS  THRU MB00PD-MMMM-ACCESS-EXIT.
011100*
011200     MOVE 'O1MP'                 TO SS02WS-ABEND-LOCATION.
011300     SET MMMPRB-OPEN-INPUT       TO TRUE.
011400     PERFORM MB00PD-MMMP-ACCESS  THRU MB00PD-MMMP-ACCESS-EXIT.
011500*
011600     MOVE 'O1SC'                 TO SS02WS-ABEND-LOCATION.
011700     SET MMSCRB-OPEN-INPUT       TO TRUE.
011800     PERFORM MB00PD-MMSC-ACCESS  THRU MB00PD-MMSC-ACCESS-EXIT.
011900*
012000     MOVE 'O1XR'                 TO SS02WS-ABEND-LOCATION.
012100     SET MMXRRB-OPEN-INPUT       TO TRUE.
012200     PERFORM MB00PD-MMXR-ACCESS  THRU MB00PD-MMXR-ACCESS-EXIT.
012300*
012400 A110-CHECK-HEADERS-READ.
012500*
012600     MOVE 'R0SC'                 TO SS02WS-ABEND-LOCATION.
012700     SET MMSCRB-READ-SEQ         TO TRUE.
012800     PERFORM MB00PD-MMSC-ACCESS  THRU MB00PD-MMSC-ACCESS-EXIT.
012900*
013000     MOVE 'MMSC'                 TO MB99WS-FILE-ID.
013100*
013200     IF  MMSCIO-HEADER
013300         NEXT SENTENCE
013400     ELSE
013500         PERFORM MB99PD-MISSING-HEADER-ABEND
013600                                 THRU MB99PD-MHA-EXIT.
013700*
013800     MOVE MMSCIO-RECORD          TO MMSC-RECORD.
013900     MOVE MMSC-TODAYS-JULIAN     TO MB99WS-PROC-DATE.
014000     MOVE MMSC-TIME-STAMP        TO MB99WS-PROC-TIME.
014100*
014200*
014300*
014400     MOVE 'R0MM'                 TO SS02WS-ABEND-LOCATION.
014500     SET MMMMRB-READ-SEQ         TO TRUE.
014600     PERFORM MB00PD-MMMM-ACCESS  THRU MB00PD-MMMM-ACCESS-EXIT.
014700     MOVE 'MMMM'                 TO MB99WS-FILE-ID.
014800*
014900     IF  MMMMIO-HEADER
015000         NEXT SENTENCE
015100     ELSE
015200         PERFORM MB99PD-MISSING-HEADER-ABEND
015300                                 THRU MB99PD-MHA-EXIT.
015400*
015500     MOVE MMMMIO-DATE-STAMP      TO MB99WS-FILE-DATE.
015600     MOVE MMMMIO-TIME-STAMP      TO MB99WS-FILE-TIME.
015700     PERFORM MB99PD-CHECK-DATE-TIME
015800                                 THRU MB99PD-CDT-EXIT.
015900*
016000     MOVE MMMMIO-RECORD          TO MMMM-RECORD.
016100*
016200*
016300*
016400     MOVE 'R0MP'                 TO SS02WS-ABEND-LOCATION.
016500     SET MMMPRB-READ-SEQ         TO TRUE.
016600     PERFORM MB00PD-MMMP-ACCESS  THRU MB00PD-MMMP-ACCESS-EXIT.
016700     MOVE 'MMMP'                 TO MB99WS-FILE-ID.
016800*
016900     IF  MMMPIO-HEADER
017000         NEXT SENTENCE
017100     ELSE
017200         PERFORM MB99PD-MISSING-HEADER-ABEND
017300                                 THRU MB99PD-MHA-EXIT.
017400*
017500     MOVE MMMPIO-DATE-STAMP      TO MB99WS-FILE-DATE.
017600     MOVE MMMPIO-TIME-STAMP      TO MB99WS-FILE-TIME.
017700     PERFORM MB99PD-CHECK-DATE-TIME
017800                                 THRU MB99PD-CDT-EXIT.
017900*
018000     MOVE MMMPIO-RECORD          TO MMMP-RECORD.
018100*
018200*
018300*
018400     MOVE 'R0SM'                 TO SS02WS-ABEND-LOCATION.
018500     SET MMSMRB-READ-SEQ         TO TRUE.
018600     PERFORM MB00PD-MMSM-ACCESS  THRU MB00PD-MMSM-ACCESS-EXIT.
018700     MOVE 'MMSM'                 TO MB99WS-FILE-ID.
018800*
018900     IF  MMSMIO-HEADER
019000         NEXT SENTENCE
019100     ELSE
019200         PERFORM MB99PD-MISSING-HEADER-ABEND
019300                                 THRU MB99PD-MHA-EXIT.
019400*
019500     MOVE MMSMIO-DATE-STAMP      TO MB99WS-FILE-DATE.
019600     MOVE MMSMIO-TIME-STAMP      TO MB99WS-FILE-TIME.
019700     PERFORM MB99PD-CHECK-DATE-TIME
019800                                 THRU MB99PD-CDT-EXIT.
019900*
020000     MOVE MMSMIO-RECORD          TO MMSM-RECORD.
020100*
020200*
020300*
020400     MOVE 'R0XR'                 TO SS02WS-ABEND-LOCATION.
020500     SET MMXRRB-READ-SEQ         TO TRUE.
020600     PERFORM MB00PD-MMXR-ACCESS  THRU MB00PD-MMXR-ACCESS-EXIT.
020700     MOVE 'MMXR'                 TO MB99WS-FILE-ID.
020800*
020900     IF  MMXRIO-HEADER
021000         NEXT SENTENCE
021100     ELSE
021200         PERFORM MB99PD-MISSING-HEADER-ABEND
021300                                 THRU MB99PD-MHA-EXIT.
021400*
021500     MOVE MMXRIO-DATE-STAMP      TO MB99WS-FILE-DATE.
021600     MOVE MMXRIO-TIME-STAMP      TO MB99WS-FILE-TIME.
021700     PERFORM MB99PD-CHECK-DATE-TIME
021800                                 THRU MB99PD-CDT-EXIT.
021900*
022000     MOVE MMXRIO-RECORD          TO MMXR-RECORD.
022100*
022200*
022300*
022400 A199-OF-EXIT.
022500     EXIT.
022600/
022700 A200-CLOSE-FILES SECTION.
022800 A201-CF-BEGIN.
022900*
023000     MOVE 'C1SM'                 TO SS02WS-ABEND-LOCATION.
023100     SET MMSMRB-CLOSE            TO TRUE.
023200     PERFORM MB00PD-MMSM-ACCESS  THRU MB00PD-MMSM-ACCESS-EXIT.
023300*
023400     MOVE 'C1MM'                 TO SS02WS-ABEND-LOCATION.
023500     SET MMMMRB-CLOSE            TO TRUE.
023600     PERFORM MB00PD-MMMM-ACCESS  THRU MB00PD-MMMM-ACCESS-EXIT.
023700*
023800     MOVE 'C1MP'                 TO SS02WS-ABEND-LOCATION.
023900     SET MMMPRB-CLOSE            TO TRUE.
024000     PERFORM MB00PD-MMMP-ACCESS  THRU MB00PD-MMMP-ACCESS-EXIT.
024100*
024200     MOVE 'C1SC'                 TO SS02WS-ABEND-LOCATION.
024300     SET MMSCRB-CLOSE            TO TRUE.
024400     PERFORM MB00PD-MMSC-ACCESS  THRU MB00PD-MMSC-ACCESS-EXIT.
024500*
024600     MOVE 'C1XR'                 TO SS02WS-ABEND-LOCATION.
024700     SET MMXRRB-CLOSE            TO TRUE.
024800     PERFORM MB00PD-MMXR-ACCESS  THRU MB00PD-MMXR-ACCESS-EXIT.
024900*
025000 A299-CF-EXIT.
025100     EXIT.
025200 A999-EXIT.
025300     EXIT.
025400/
025500 0000-READ-MERCHANTS SECTION.
025600 0001-RM-BEGIN.
025700*
025800     MOVE 'R2MM'                 TO SS02WS-ABEND-LOCATION.
025900     SET MMMMRB-READ-SEQ         TO TRUE.
026000     PERFORM MB00PD-MMMM-ACCESS  THRU MB00PD-MMMM-ACCESS-EXIT.
026100*
026200     IF  MMMMIO-TRAILER
026300         MOVE MMMMIR-RECORD      TO MMMM-RECORD
026400         SET MMMM-TRAILER        TO TRUE
026500         RELEASE MMMM-RECORD
026600         GO TO 0999-RM-EXIT.
026700*
026800     MOVE MMMMIO-RECORD          TO MMMM-RECORD.
026900*
027000     IF  MMMM-REC-INCOMPLETE
027100     OR  MMMM-REC-MODEL
027200     OR  MMMM-REC-PURGED
027300     OR  MMMM-ADD-PENDING
027400         GO TO 0001-RM-BEGIN.
027500*
027600     MOVE SPACES                 TO MMMPTB-TABLE-DATA.
027700     MOVE MMMM-ORG-MERCHANT      TO MMMPTB-START-ORG-ACCT.
027800     SET X-MMMPTB                TO 1.
027900     PERFORM MMMPPX-READ-AND-LOAD
028000        THRU MMMPPX-RAL-EXIT
028100        UNTIL MMMPIO-ORG-MERCHANT IS GREATER THAN
028200                                 MMMM-ORG-MERCHANT
028300          OR  X-MMMPTB IS GREATER THAN MMMPTB-MAX-ENTRIES
028400          OR  MMMPIO-TRAILER.
028500*
028600     MOVE SPACES                 TO MMMP-VI-RECORD.
028700     MOVE SPACES                 TO MMMP-MC-RECORD.
028800*
028900     IF  MMMPTB-PRODUCT (1) IS NUMERIC
029000     AND MMMPTB-PROD-IS-VISA (1)
029100         MOVE MMMPTB-RECORD (1)  TO MMMP-VI-RECORD.
029200*
029300     IF  MMMPTB-PRODUCT (1) IS NUMERIC
029400     AND MMMPTB-PROD-IS-MC (1)
029500         MOVE MMMPTB-RECORD (1)  TO MMMP-MC-RECORD.
029600*
029700     IF  MMMPTB-PRODUCT (2) IS NUMERIC
029800     AND MMMPTB-PROD-IS-MC (2)
029900         MOVE MMMPTB-RECORD (2)  TO MMMP-MC-RECORD.
030000*
030100     PERFORM
030200         UNTIL MMXRIO-ORG-MERCHANT IS GREATER THAN
030300               MMMMIO-ORG-MERCHANT
030400         MOVE MMXRIO-RECORD      TO MMXR-RECORD
030500         EVALUATE TRUE
030600             WHEN MMXRIO-ORG-MERCHANT IS LESS THAN
030700                  MMMMIO-ORG-MERCHANT
030800                 CONTINUE
030900             WHEN MMXR-ADD-PENDING
031000                 CONTINUE
031100             WHEN MMXR-REC-PURGED
031200                 CONTINUE
031300             WHEN OTHER
031400                 MOVE MMXR-STORE TO MMMM-MERCHANT
031500                 RELEASE MMMM-RECORD
031600         END-EVALUATE
031700         MOVE 'R2XR'             TO SS02WS-ABEND-LOCATION
031800         SET MMXRRB-READ-SEQ     TO TRUE
031900         PERFORM MB00PD-MMXR-ACCESS THRU MB00PD-MMXR-ACCESS-EXIT
032000     END-PERFORM.
032100*
032200     GO TO 0001-RM-BEGIN.
032300*
032400 0999-RM-EXIT.
032500     EXIT.
032600/
032700 5000-UPDATE-STORES SECTION.
032800 5001-US-BEGIN.
032900*
033000     RETURN MS1S-SORT-FILE
033100         AT END
033200             PERFORM 6000-PROCESS-STORE
033300                THRU 6099-PS-EXIT
033400                UNTIL MMSMIO-ORG-STORE IS NOT LESS THAN
033500                      MMMM-ORG-MERCHANT
033600             GO TO 5099-US-EXIT.
033700*
033800     PERFORM 6000-PROCESS-STORE
033900        THRU 6099-PS-EXIT
034000        UNTIL MMSMIO-ORG-STORE IS NOT LESS THAN MMMM-ORG-MERCHANT.
034100*
034200     GO TO 5001-US-BEGIN.
034300*
034400*
034500*
034600 5099-US-EXIT.
034700     EXIT.
034800/
034900 6000-PROCESS-STORE SECTION.
035000 6001-PS-BEGIN.
035100*
035200     MOVE 'R1SM'                 TO SS02WS-ABEND-LOCATION.
035300     SET MMSMRB-READ-SEQ         TO TRUE.
035400     PERFORM MB00PD-MMSM-ACCESS  THRU MB00PD-MMSM-ACCESS-EXIT.
035500*
035600     IF  MMSMIO-HEADER
035700     OR  MMSMIO-TRAILER
035800         GO TO 6099-PS-EXIT.
035900*
036000     MOVE MMSMIO-RECORD          TO MMSM-RECORD.
036100*
036200     IF  MMSM-REC-INCOMPLETE
036300     OR  MMSM-REC-MODEL
036400     OR  MMSM-REC-PURGED
036500     OR  MMSM-ADD-PENDING
036600         GO TO 6099-PS-EXIT.
036700*
036800     IF  MMSM-ORG-STORE IS NOT EQUAL TO MMMM-ORG-MERCHANT
036900         PERFORM 6100-NO-MERCHANT-FOR-STORE
037000            THRU 6199-NMFS-EXIT
037100     ELSE
037200         PERFORM 6500-STORE-MODIFICATIONS
037300            THRU 6599-SM-EXIT.
037400*
037500 6099-PS-EXIT.
037600     EXIT.
037700/
037800 6100-NO-MERCHANT-FOR-STORE SECTION.
037900 6101-NMFS-BEGIN.
038000*
038100     IF  MMSM-ORG-STORE IS GREATER THAN MMMM-ORG-MERCHANT
038200         DISPLAY MMMM-ORG-X ' '
038300                 MMMM-MERCHANT-X
038400                 ' **** INVALID XREF STORE-------> '
038500                 MMMM-MERCHANT-X
038600         PERFORM 8800-STORE-START
038700            THRU 8899-SS-EXIT
038800         GO TO 6199-NMFS-EXIT.
038900*
039000     IF  MMSM-ORG-STORE IS LESS THAN MMMM-ORG-MERCHANT
039100         DISPLAY MMSM-ORG-X ' '
039200                 MMSM-MERCHANT-ID
039300                 ' **** NO MERCHANT FOR STORE ---> '
039400                 MMSM-STORE-X.
039500*
039600 6199-NMFS-EXIT.
039700     EXIT.
039800/
039900 6500-STORE-MODIFICATIONS SECTION.
040000 6501-SM-BEGIN.
040100*
040200     MOVE MMMM-DATE-LAST-SETT    TO MMSM-DATE-LAST-SETT.
040300     MOVE MMMM-DATE-LAST-DISC    TO MMSM-DATE-LAST-DISC.
040400     MOVE MMMM-DATE-LAST-STMT    TO MMSM-DATE-LAST-STMT.
040500     MOVE MMMM-DATE-PREV-STMT    TO MMSM-DATE-PREV-STMT.
040600     MOVE MMMM-CTD-CLEAR-DATE-1  TO MMSM-CTD-CLEAR-DATE-1.
040700     MOVE MMMM-CTD-CLEAR-DATE-2  TO MMSM-CTD-CLEAR-DATE-2.
040800     MOVE MMMM-DTD-CLEAR-DATE-1  TO MMSM-DTD-CLEAR-DATE-1.
040900     MOVE MMMM-DTD-CLEAR-DATE-2  TO MMSM-DTD-CLEAR-DATE-2.
041000     MOVE MMMM-PTD-CLEAR-DATE-1  TO MMSM-PTD-CLEAR-DATE-1.
041100     MOVE MMMM-PTD-CLEAR-DATE-2  TO MMSM-PTD-CLEAR-DATE-2.
041200     MOVE MMMM-BI-WEEKLY-SETT-DATE
041300                                 TO MMSM-BI-WEEKLY-SETT-DATE.
041400     MOVE MMMM-BI-WEEKLY-STMT-DATE
041500                                 TO MMSM-BI-WEEKLY-STMT-DATE.
041600     MOVE MMMM-BI-WEEKLY-DISC-DATE
041700                                 TO MMSM-BI-WEEKLY-DISC-DATE.
041800     MOVE MMMM-BI-WEEKLY-PART-DATE
041900                                 TO MMSM-BI-WEEKLY-PART-DATE.
042000     MOVE MMMM-DATE-LAST-PART    TO MMSM-DATE-LAST-PART.
042100     MOVE MMMM-OUT-OF-BUS-DATE   TO MMSM-OUT-OF-BUS-DATE.
042200     MOVE MMMM-OWNERSHIP-CHG-DATE
042300                                 TO MMSM-OWNERSHIP-CHG-DATE.
042400     MOVE MMMM-TIN-TYPE          TO MMSM-TIN-TYPE.
042500     MOVE MMMM-1099-REFUSAL-IND  TO MMSM-1099-REFUSAL-IND.
042600     MOVE MMMM-CORP-LEGAL-NAME   TO MMSM-CORP-LEGAL-NAME.
042700     MOVE MMMM-STMT-FREQ-1       TO MMSM-STMT-FREQ-1.
042800     MOVE MMMM-STMT-FREQ-2       TO MMSM-STMT-FREQ-2.
042900     MOVE MMMM-DISC-FREQ-1       TO MMSM-DISC-FREQ-1.
043000     MOVE MMMM-DISC-FREQ-2       TO MMSM-DISC-FREQ-2.
043100     MOVE MMMM-PART-FREQ-1       TO MMSM-PART-FREQ-1.
043200     MOVE MMMM-PART-FREQ-2       TO MMSM-PART-FREQ-2.
043300     MOVE MMMM-SETT-FREQ-1       TO MMSM-SETT-FREQ-1.
043400     MOVE MMMM-SETT-FREQ-2       TO MMSM-SETT-FREQ-2.
043500     MOVE MMMM-SOLE-PROP-LAST    TO MMSM-SOLE-PROP-LAST.
043600     MOVE MMMM-SOLE-PROP-FIRST   TO MMSM-SOLE-PROP-FIRST.
043700     MOVE MMMM-SOLE-PROP-INITIAL TO MMSM-SOLE-PROP-INITIAL.
043800     MOVE MMMM-MINORITY-CODE     TO MMSM-MINORITY-CODE.
043900     MOVE MMMM-WOMAN-OWNED-CODE  TO MMSM-WOMAN-OWNED-CODE.
044000     MOVE MMMM-DUN-AND-BRADSTREET-NBR
044100                                 TO MMSM-DUN-AND-BRADSTREET-NBR.
044200*
044300     IF  MMSM-REC-SINGLE-STORE
044400         PERFORM 6800-SINGLE-STORE-MOVES
044500            THRU 6899-SSM-EXIT.
044600*
044700     IF  MMMP-VI-RECORD IS NOT EQUAL TO SPACES
044800         MOVE MMMP-VI-RECORD     TO MMMP-RECORD
044900         MOVE MMMP-PROD-STATUS   TO MMSM-VI-STATUS
045000         MOVE MMMP-PROD-EFF-DATE TO MMSM-VI-EFF-DATE
045100     ELSE
045200         SET MMSM-VI-NOT-ALLOWED TO TRUE
045300         MOVE ZERO               TO MMSM-VI-EFF-DATE.
045400*
045500     IF  MMMP-MC-RECORD IS NOT EQUAL TO SPACES
045600         MOVE MMMP-MC-RECORD     TO MMMP-RECORD
045700         MOVE MMMP-PROD-STATUS   TO MMSM-MC-STATUS
045800         MOVE MMMP-PROD-EFF-DATE TO MMSM-MC-EFF-DATE
045900     ELSE
046000         SET MMSM-MC-NOT-ALLOWED TO TRUE
046100         MOVE ZERO               TO MMSM-MC-EFF-DATE.
046200*
046300     PERFORM 8900-STORE-REWRITE
046400        THRU 8999-SR-EXIT.
046500*
046600 6599-SM-EXIT.
046700     EXIT.
046800/
046900 6800-SINGLE-STORE-MOVES SECTION.
047000 6801-SSM-BEGIN.
047100*
047200     MOVE MMMM-DEMOGRAPHICS-AREA TO MMSM-DEMOGRAPHICS-AREA.
047300     MOVE MMMM-DBA-DEMOGRAPHICS  TO MMSM-DBA-DEMOGRAPHICS.
047400     MOVE MMMM-CONTACT (1)       TO MMSM-CONTACT (1).
047500     MOVE MMMM-CONTACT-PHONE (1) TO MMSM-CONTACT-PHONE (1).
047600     MOVE MMMM-CONTACT-FAX (1)   TO MMSM-CONTACT-FAX (1).
047700     MOVE MMMM-CONTACT (2)       TO MMSM-CONTACT (2).
047800     MOVE MMMM-CONTACT-PHONE (2) TO MMSM-CONTACT-PHONE (2).
047900     MOVE MMMM-CONTACT-FAX (2)   TO MMSM-CONTACT-FAX (2).
048000     MOVE MMMM-BRANCH            TO MMSM-BRANCH.
048100     MOVE MMMM-AGENT-BANK        TO MMSM-AGENT-BANK.
048200     MOVE MMMM-OFFICER-ID        TO MMSM-OFFICER-ID.
048300     MOVE MMMM-NBR-BULLETINS     TO MMSM-NBR-BULLETINS.
048400*****MOVE MMMM-GOVERNING-STATE   TO MMSM-GOVERNING-STATE.
048500     MOVE MMMM-STMT-ADDR-CONTROL TO MMSM-STMT-ADDR-CONTROL.
048600     MOVE MMMM-IMP-INFO          TO MMSM-IMP-INFO.
048700     MOVE MMMM-POS-INFO          TO MMSM-POS-INFO.
048800*
048900 6899-SSM-EXIT.
049000     EXIT.
049100/
049200 8800-STORE-START SECTION.
049300 8801-SS-BEGIN.
049400*
049500     MOVE 'S1SM'                 TO SS02WS-ABEND-LOCATION.
049600     SET MMSMRB-START-GTE        TO TRUE.
049700     PERFORM MB00PD-MMSM-ACCESS  THRU MB00PD-MMSM-ACCESS-EXIT.
049800*
049900 8899-SS-EXIT.
050000     EXIT.
050100/
050200 8900-STORE-REWRITE SECTION.
050300 8901-SR-BEGIN.
050400*
050500     MOVE MMSM-RECORD            TO MMSMIO-RECORD.
050600*
050700     MOVE 'U1SM'                 TO SS02WS-ABEND-LOCATION.
050800     SET MMSMRB-REWRITE          TO TRUE.
050900     PERFORM MB00PD-MMSM-ACCESS  THRU MB00PD-MMSM-ACCESS-EXIT.
051000*
051100 8999-SR-EXIT.
051200     EXIT.
051300/
051400 9000-PERFORMED-ROUTINES-SECT SECTION.
051500     COPY MB00PD REPLACING ==:MB00:== BY ==MMSM==.
051600/
051700     COPY MB00PD REPLACING ==:MB00:== BY ==MMMM==.
051800/
051900     COPY MB00PD REPLACING ==:MB00:== BY ==MMMP==.
052000/
052100     COPY MMMPPX.
052200/
052300     COPY MB00PD REPLACING ==:MB00:== BY ==MMSC==.
052400/
052500     COPY MB00PD REPLACING ==:MB00:== BY ==MMXR==.
052600/
052700     COPY MB99PD.
052800/
052900     COPY SS02PD.
053000/
053100     COPY SS07PD.
053200/
053300     COPY SS08PD.
053400/
053500     COPY SS26PD.
053600/
053700     COPY SS27PD.
053800/
053900     COPY SS98PD.
054000*
054100 9995-END-SOURCE-STATEMENTS SECTION.
054200 9999-END-OF-PROGRAM.
054300     EXIT.
