000100 IDENTIFICATION DIVISION.
000200 PROGRAM-ID. MBU610.
000201*       RELEASE DATE=08/24/01.        REVISION LEVEL=08.06      *
000202*****************************************************************
000203*WARNING.  THIS COMPUTER PROGRAM IS PROTECTED BY COPYRIGHT LAW  *
000204*AND INTERNATIONAL TREATIES.  UNAUTHORIZED REPRODUCTION OR      *
000205*DISTRIBUTION OF THIS PROGRAM, OR ANY PORTION OF IT, MAY RESULT *
000206*IN SEVERE CIVIL AND CRIMINAL PENATLIES, AND WILL BE PROSECUTED *
000207*TO THE MAXIMUM EXTENT POSSIBLE UNDER THE LAW.                  *
000208*COPYRIGHT 1999 PAYSYS INTERNATIONAL, INC.  ALL RIGHTS RESERVED.*
000209*****************************************************************
000300*****************************************************************
000400*                                                               *
000500*       MBU610 - DATA DICTIONARY PRINT                         *
000600*                                                               *
000700*****************************************************************
000800 ENVIRONMENT DIVISION.
000900 CONFIGURATION SECTION.
001000 SOURCE-COMPUTER.            IBM-4341.
001100 OBJECT-COMPUTER.            IBM-4341.
001200/
001300 INPUT-OUTPUT SECTION.
001400*
001500 FILE-CONTROL.
001600/
001700 DATA DIVISION.
001800 FILE SECTION.
001900 WORKING-STORAGE SECTION.
002000*
002100 01  FILLER                  PIC  X(12)      VALUE '** WS-BEG **'.
002200*
002300 01  WS-LINES                PIC  9(05)      VALUE ZERO.
002400/
002500     COPY MMSCRL.
002600/
002700     COPY MMSCIO.
002800/
002900     COPY MB00RB REPLACING ==:MB00:== BY ==MMSC==.
003000/
003100     COPY MMEXTB REPLACING ==:MMEX:== BY ==MMEX==.
003200/
003300     COPY MB00WS.
003400/
003500     COPY MB99WS.
003600/
003700     COPY MB20WS.
003800*
003900 01  WS-PRINT-LINE-01        REDEFINES MB20WS-PRINT-LINE.
004000     03  FILLER              PIC  X(03).
004100     03  WS-PL01-FILE-ID     PIC  X(02).
004200     03  FILLER              PIC  X(08).
004300     03  WS-PL01-FIELD-NBR   PIC  9(04).
004400     03  FILLER              PIC  X(06).
004500     03  WS-PL01-DESC        PIC  X(22).
004600     03  FILLER              PIC  X(06).
004700     03  WS-PL01-MAP-CODE    PIC  X(04).
004800     03  FILLER              PIC  X(08).
004900     03  WS-PL01-START-POS   PIC  9(05).
005000     03  FILLER              PIC  X(07).
005100     03  WS-PL01-LENGTH      PIC  9(02).
005200     03  FILLER              PIC  X(09).
005300     03  WS-PL01-SPEC-DATA   PIC  X(01).
005400     03  FILLER              PIC  X(11).
005500     03  WS-PL01-FILE-FMT    PIC  X(02).
005600     03  FILLER              PIC  X(14).
005700     03  WS-PL01-SINGLE-STORE
005800                             PIC  X(01).
005900/
006000     COPY SS00WS.
006100/
006200     COPY SS01WS.
006300/
006400     COPY SS02WS.
006500/
006600     COPY SS05WS.
006700*
006800 01  FILLER                  PIC  X(12)      VALUE '** WS-END **'.
006900/
007000 PROCEDURE DIVISION.
007100 A000-MAIN-LINE-SECT SECTION.
007200 A010-ML-BEGIN.
007300*
007400     PERFORM A100-OPEN-FILES
007500        THRU A199-OF-EXIT.
007600*
007700     PERFORM A200-PRODUCE-REPORT
007800        THRU A299-PR-EXIT.
007900*
008000     PERFORM A400-CLOSE-FILES
008100        THRU A499-CF-EXIT.
008200*
008300     STOP RUN.
008400/
008500 A100-OPEN-FILES.
008600*
008700     MOVE 'MBU610'               TO SS02WS-ABEND-PROG-ID.
008800*
008900     MOVE 'O1SC'                 TO SS02WS-ABEND-LOCATION.
009000     SET MMSCRB-OPEN-INPUT       TO TRUE.
009100     PERFORM MB00PD-MMSC-ACCESS
009200        THRU MB00PD-MMSC-ACCESS-EXIT.
009300*
009400*
009500     MOVE 'R0SC'                 TO SS02WS-ABEND-LOCATION.
009600     SET MMSCRB-READ-SEQ         TO TRUE.
009700     PERFORM MB00PD-MMSC-ACCESS
009800        THRU MB00PD-MMSC-ACCESS-EXIT.
009900     MOVE 'MMSC'                 TO MB99WS-FILE-ID.
010000*
010100     IF  MMSCIO-HEADER
010200         NEXT SENTENCE
010300     ELSE
010400         PERFORM MB99PD-MISSING-HEADER-ABEND
010500            THRU MB99PD-MHA-EXIT.
010600*
010700     MOVE MMSCIO-RECORD          TO MMSC-RECORD.
010800     MOVE MMSC-TODAYS-JULIAN     TO MB99WS-PROC-DATE.
010900     MOVE MMSC-TIME-STAMP        TO MB99WS-PROC-TIME.
011000*
011100     MOVE MB20WS-FORCE-PAGE      TO MB20WS-LINE-COUNT.
011200     MOVE ZERO                   TO MB20WS-PAGE-COUNT.
011300     MOVE 'MBU610'               TO MB20WS-SH-RPT-ID.
011400     MOVE 'EXAM DATA DICTIONARY' TO MB20WS-SH-RPT-NAME.
011500     MOVE 'T610'                 TO MB20WS-SH-INTERNAL-RPT-ID.
011600     MOVE MMSC-DATE-FORMAT       TO SS01WS-DATE-FORMAT.
011700     MOVE MMSC-SCREEN-HEADER     TO MB20WS-SH-SYSTEM.
011800     MOVE MMSC-TODAYS-JULIAN     TO SS01WS-JULIAN.
011900     PERFORM SS26PD-NUMERICALLY-EDIT-DATE
012000                                 THRU SS26PD-NED-EXIT.
012100     MOVE SS01WS-XX-XX-YYYY      TO MB20WS-SH-FILE-DATE.
012200     MOVE SPACES                 TO MB20WS-SH-LIT-5.
012300*
012400*
012500     MOVE ' FILE ID   FIELD NBR   FIELD DESCRIPTION    '
012600                                 TO MB20WS-SH-L6R-1.
012700     MOVE '      MAP CODE   START POS   LENGTH   SPEC D'
012800                                 TO MB20WS-SH-L6R-2.
012900     MOVE 'ATA   FILE FORMAT   SINGLE STORE            '
013000                                 TO MB20WS-SH-L6R-3.
013100*
013200*
013300*
013400 A199-OF-EXIT.
013500     EXIT.
013600/
013700 A200-PRODUCE-REPORT.
013800*
013900     PERFORM
014000         VARYING X-MMEXTB FROM 1 BY 1
014100         UNTIL X-MMEXTB IS GREATER THAN 1100
014200         IF  MMEXTB-FILE-ID (X-MMEXTB) IS EQUAL TO SPACES
014300             CONTINUE
014400         ELSE
014500             MOVE MMEXTB-FILE-ID (X-MMEXTB)
014600                                 TO WS-PL01-FILE-ID
014700             MOVE MMEXTB-FIELD-NBR (X-MMEXTB)
014800                                 TO WS-PL01-FIELD-NBR
014900             MOVE MMEXTB-MAP-CODE (X-MMEXTB)
015000                                 TO WS-PL01-MAP-CODE
015100             MOVE MMEXTB-START-POS (X-MMEXTB)
015200                                 TO WS-PL01-START-POS
015300             MOVE MMEXTB-LENGTH (X-MMEXTB)
015400                                 TO WS-PL01-LENGTH
015500             MOVE MMEXTB-SPECIAL-DATA (X-MMEXTB)
015600                                 TO WS-PL01-SPEC-DATA
015700             MOVE MMEXTB-FILE-FORMAT (X-MMEXTB)
015800                                 TO WS-PL01-FILE-FMT
015900             MOVE MMEXTB-SINGLE-STORE (X-MMEXTB)
016000                                 TO WS-PL01-SINGLE-STORE
016100             MOVE MMEXTB-FIELD-DESC (X-MMEXTB)
016200                                 TO WS-PL01-DESC
016300             PERFORM MB20PD-PRINT-1-LINE
016400                THRU MB20PD-P1L-EXIT
016500         END-IF
016600     END-PERFORM.
016700/
016800*
016900 A299-PR-EXIT.
017000     EXIT.
017100/
017200 A400-CLOSE-FILES.
017300*
017400     MOVE 'C3SC'                 TO SS02WS-ABEND-LOCATION.
017500     SET MMSCRB-CLOSE            TO TRUE.
017600     PERFORM MB00PD-MMSC-ACCESS
017700        THRU MB00PD-MMSC-ACCESS-EXIT.
017800*
017900     PERFORM MB20PD-CLOSE-PRINT-FILES
018000        THRU MB20PD-CPF-EXIT.
018100*
018200 A499-CF-EXIT.
018300     EXIT.
018400 9000-PERFORMED-ROUTINES-SECT SECTION.
018500*
018600/
018700     COPY MB00PD REPLACING ==:MB00:== BY ==MMSC==.
018800/
018900     COPY MB20PD.
019000/
019100     COPY MB99PD.
019200/
019300     COPY SS02PD.
019400/
019500     COPY SS03PD.
019600/
019700     COPY SS04PD.
019800/
019900     COPY SS05PD.
020000/
020100     COPY SS06PD.
020200/
020300     COPY SS07PD.
020400/
020500     COPY SS08PD.
020600/
020700     COPY SS09PD.
020800/
020900     COPY SS10PD.
021000/
021100     COPY SS16PD.
021200/
021300     COPY SS18PD.
021400/
021500     COPY SS23PD.
021600/
021700     COPY SS26PD.
021800/
021900     COPY SS27PD.
022000*
022100 9995-END-SOURCE-STATEMENTS SECTION.
022200 9999-END-OF-PROGRAM.
022300     EXIT.
