000100 IDENTIFICATION DIVISION.
000200 PROGRAM-ID. MBU620.
000201*       RELEASE DATE=08/24/01.        REVISION LEVEL=08.06      * ++++++++
000202***************************************************************** ++++++++
000203*WARNING.  THIS COMPUTER PROGRAM IS PROTECTED BY COPYRIGHT LAW  * ++++++++
000204*AND INTERNATIONAL TREATIES.  UNAUTHORIZED REPRODUCTION OR      * ++++++++
000205*DISTRIBUTION OF THIS PROGRAM, OR ANY PORTION OF IT, MAY RESULT * ++++++++
000206*IN SEVERE CIVIL AND CRIMINAL PENATLIES, AND WILL BE PROSECUTED * ++++++++
000207*TO THE MAXIMUM EXTENT POSSIBLE UNDER THE LAW.                  * ++++++++
000208*COPYRIGHT 1999 PAYSYS INTERNATIONAL, INC.  ALL RIGHTS RESERVED.* ++++++++
000209***************************************************************** ++++++++
001200*****************************************************************
001300*                                                               *
001400*       MBU620 - MERCHANT TAXPAYER ID UTILITY PROGRAM           *
001500*                                                               *
001600* THIS PROGRAM ASSISTS ACQUIRERS IN GLOBALLY EXAMINING AND      *
001700* MODIFYING IN AN AUTOMATED MANNER, THE TAXPAYER ID IN THE      *
001800* MERCHANT MASTER (MMMM) FILE FOR THOSE MERCHANTS WITH A        *
001900* PRODUCT OF 01 (VISA) OR 02 (MASTERCARD).  MODIFICATIONS TO    *
002000* THE MMMM TAXPAYER ID ARE PROPAGATED TO THE MMSM FILE.         *
002100*                                                               *
002200*****************************************************************
002300* FILES USED:  MTCC - CONTROL CARD FILE                         *
002400*              MMOC - ORG MASTER FILE                           *
002500*              MMMM - MERCHANT MASTER FILE                      *
002600*              MMMP - MERCHANT PRODUCT FILE                     *
002700*              MMSM - STORE MASTER FILE                         *
002800*              MMXR - STORE/MERCHANT CROSS REFERENCE FILE       *
002900*              MMSC - SYSTEM FILE                               *
003000*****************************************************************
003100 ENVIRONMENT DIVISION.
003200 CONFIGURATION SECTION.
003300 SOURCE-COMPUTER.            IBM-4341.
003400 OBJECT-COMPUTER.            IBM-4341.
003500*
003600 INPUT-OUTPUT SECTION.
003700 FILE-CONTROL.
003800 DATA DIVISION.
003900 FILE SECTION.
004000/
004100 WORKING-STORAGE SECTION.
004200*
004300 01  FILLER                      PIC  X(12)  VALUE '** WS-BEG **'.
004400*
004500 01  WS-MBU620-WORK-AREAS.
004600     03  WS-COUNTERS.
004700         05  WS-CTL-CARD-CNTR    PIC 9(01)   VALUE ZERO.
004800         05  WS-NBR-CHARS-CNTR   PIC 9(01)   VALUE ZERO.
004900         05  WS-REPORTED-CNTR    PIC 9(11)   VALUE ZERO.
005000         05  WS-CORRECTED-CNTR   PIC 9(11)   VALUE ZERO.
005100         05  WS-LEFTJUST-TIMES   PIC 9(02)   VALUE ZERO.
005200     03  WS-SWITCHES.
005300         05  WS-VISA-PROD-FND    PIC X(01)   VALUE SPACE.
005400         05  WS-MC-PROD-FND      PIC X(01)   VALUE SPACE.
005500         05  WS-ERROR-SW         PIC X(01)   VALUE SPACE.
005600         05  WS-SEARCH-VALS-FND  PIC X(01)   VALUE SPACE.
005700     03  WS-MISC.
005800         05  WS-SEARCH-POS       PIC 9(02)   VALUE ZERO.
005900         05  WS-CUR-POS          PIC 9(02)   VALUE ZERO.
006000         05  WS-PREV-ORG         PIC 9(03)   VALUE ZEROES.
006100         05  WS-ORIG-TAX-ID      PIC X(15)   VALUE SPACES.
006200         05  WS-MMMM-TAX-ID      PIC X(15)   VALUE SPACES.
006300         05  WS-CORRECTED-TAX-ID PIC X(15)   VALUE SPACES.
006400*
006500 01  WS-MTCC-MBU620-STEP-MODE.
006600     03  WS-MTCC-MBU620-SIMULATE PIC X(01)   VALUE 'Y'.
006700     03  WS-MTCC-MBU620-CORRECT  PIC X(01)   VALUE 'N'.
006800     03  FILLER                  PIC X(84)   VALUE SPACES.
006900*
007000 01  WS-MTCC-MBU620-SEARCH-VALS.
007100     03  WS-MTCC-MBU620-SV-REPEAT-NUMS
007200                                 PIC X(01)   VALUE 'Y'.
007300     03  WS-MTCC-MBU620-SV-ALL-SPACES
007400                                 PIC X(01)   VALUE 'Y'.
007500     03  WS-MTCC-MBU620-SV-LESS-9-CHARS
007600                                 PIC X(01)   VALUE 'Y'.
007700     03  WS-MTCC-MBU620-SV-LEAD-SPACES
007800                                 PIC X(01)   VALUE 'Y'.
007900     03  WS-MTCC-MBU620-SV-EMBED-SPACES
008000                                 PIC X(01)   VALUE 'Y'.
008100     03  WS-MTCC-MBU620-SV-DASHES
008200                                 PIC X(01)   VALUE 'N'.
008300     03  WS-MTCC-MBU620-SV-SLASHES
008400                                 PIC X(01)   VALUE 'N'.
008500     03  WS-MTCC-MBU620-SV-SPEC-CHARS
008600                                 PIC X(01)   VALUE 'Y'.
008700     03  WS-MTCC-MBU620-SV-ALPHAS
008800                                 PIC X(01)   VALUE 'Y'.
008900*
009000 01  WS-MTCC-MBU620-COMPRESS-VALS.
009100     03  WS-MTCC-MBU620-CV-LEAD-SPACES
009200                                 PIC X(01)   VALUE 'Y'.
009300     03  WS-MTCC-MBU620-CV-EMBED-SPACES
009400                                 PIC X(01)   VALUE 'Y'.
009500     03  WS-MTCC-MBU620-CV-DASHES
009600                                 PIC X(01)   VALUE 'Y'.
009700     03  WS-MTCC-MBU620-CV-SLASHES
009800                                 PIC X(01)   VALUE 'Y'.
009900     03  WS-MTCC-MBU620-CV-SPEC-CHARS
010000                                 PIC X(01)   VALUE 'Y'.
010100     03  WS-MTCC-MBU620-CV-ALPHAS
010200                                 PIC X(01)   VALUE 'Y'.
010300*
010400*
010500     COPY MB20WS.
010600 01  WS-PRINT-LINE-1         REDEFINES MB20WS-PRINT-LINE.
010700     03  FILLER                  PIC X(01).
010800     03  WS-PL1-MER-NBR          PIC 9(09).
010900     03  FILLER                  PIC X(03).
011000     03  WS-PL1-MER-NAME         PIC X(25).
011100     03  FILLER                  PIC X(06).
011200     03  WS-PL1-CARD-PROD-01     PIC X(02).
011300     03  FILLER                  PIC X(02).
011400     03  WS-PL1-CARD-PROD-02     PIC X(02).
011500     03  FILLER                  PIC X(06).
011600     03  WS-PL1-IRI              PIC X(01).
011700     03  FILLER                  PIC X(06).
011800     03  WS-PL1-ORIG-TAX-ID      PIC X(15).
011900     03  FILLER                  PIC X(04).
012000     03  WS-PL1-SIMU-TAX-ID      PIC X(15).
012100     03  FILLER                  PIC X(04).
012200     03  WS-PL1-CORR-TAX-ID      PIC X(15).
012300     03  FILLER                  PIC X(16).
012400*
012500 01  WS-MBU620-HEADINGS.
012600     03  WS-MBU620-HDL-1.
012700         05  FILLER              PIC X(06)   VALUE ' MERCH'.
012800         05  FILLER              PIC X(39)   VALUE SPACES.
012900         05  FILLER              PIC X(04)   VALUE 'CARD'.
013000         05  FILLER              PIC X(06)   VALUE SPACES.
013100         05  FILLER              PIC X(04)   VALUE '1099'.
013200         05  FILLER              PIC X(07)   VALUE SPACES.
013300         05  FILLER              PIC X(08)   VALUE 'ORIGINAL'.
013400         05  FILLER              PIC X(11)   VALUE SPACES.
013500         05  FILLER              PIC X(09)   VALUE 'SIMULATED'.
013600         05  FILLER              PIC X(10)   VALUE SPACES.
013700         05  FILLER              PIC X(09)   VALUE 'CORRECTED'.
013800         05  FILLER              PIC X(19)   VALUE SPACES.
013900     03  WS-MBU620-HDL-2.
014000         05  FILLER              PIC X(07)   VALUE ' NUMBER'.
014100         05  FILLER              PIC X(05)   VALUE SPACES.
014200         05  FILLER              PIC X(27)   VALUE
014300                                 '*-----MERCH DBA NAME------*'.
014400         05  FILLER              PIC X(04)   VALUE SPACES.
014500         05  FILLER              PIC X(08)   VALUE 'PRODUCTS'.
014600         05  FILLER              PIC X(04)   VALUE SPACES.
014700         05  FILLER              PIC X(03)   VALUE 'IRI'.
014800         05  FILLER              PIC X(05)   VALUE SPACES.
014900         05  FILLER              PIC X(15)   VALUE
015000                                 'TAXPAYER ID NBR'.
015100         05  FILLER              PIC X(04)   VALUE SPACES.
015200         05  FILLER              PIC X(15)   VALUE
015300                                 'TAXPAYER ID NBR'.
015400         05  FILLER              PIC X(04)   VALUE SPACES.
015500         05  FILLER              PIC X(15)   VALUE
015600                                 'TAXPAYER ID NBR'.
015700         05  FILLER              PIC X(16)   VALUE SPACES.
015800*
015900     03  WS-MBU620-DTL-2.
016000         05  FILLER              PIC X(30)   VALUE
016100                                 ' CONTROL CARD SEARCH VALUES : '.
016200         05  WS-MBU620-SEARCH-VALS
016300                                 PIC X(102)  VALUE SPACES.
016400     03  WS-MBU620-DTL-3.
016500         05  FILLER              PIC X(30)   VALUE
016600                                 ' CONTROL CARD REPLACE VALUES: '.
016700         05  WS-MBU620-COMPRESS-VALS
016800                                 PIC X(102)  VALUE SPACES.
016900     03  WS-MBU620-TTL-1.
017000         05  FILLER              PIC X(30)   VALUE
017100                                 '    NBR OF MERCHANTS REPORTED '.
017200         05  FILLER              PIC X(14)   VALUE SPACES.
017300         05  WS-TTL1-NBR-REPORTED
017400                                 PIC ZZ,ZZZ,ZZZ,ZZ9.
017500         05  FILLER              PIC X(74)   VALUE SPACES.
017600     03  WS-MBU620-TTL-2.
017700         05  FILLER              PIC X(30)   VALUE
017800                                 '    NBR OF MERCHANTS CORRECTED'.
017900         05  FILLER              PIC X(14)   VALUE SPACES.
018000         05  WS-TTL2-NBR-CORRECTED
018100                                 PIC ZZ,ZZZ,ZZZ,ZZ9.
018200         05  FILLER              PIC X(74)   VALUE SPACES.
018300*
018400/    CONTROL CARD
018500     COPY MTCCIO REPLACING ==:MTCC:== BY ==MTCC==.
018600/
018700     COPY MB00RB REPLACING ==:MB00:== BY ==MTCC==.
018800/
018900     COPY MTCCRL REPLACING ==:MTCC:== BY ==MTCC==.
019000/    STORE MASTER
019100     COPY MMSMIO.
019200/
019300     COPY MB00RB REPLACING ==:MB00:== BY ==MMSM==.
019400/
019500     COPY MMSMRL.
019600/    MERCHANT MASTER
019700     COPY MMMMIO.
019800/
019900     COPY MMMMIR.
020000/
020100     COPY MB00RB REPLACING ==:MB00:== BY ==MMMM==.
020200/
020300     COPY MMMMRL.
020400/    ORG MASTER
020500     COPY MMOCIO.
020600/
020700     COPY MMOCIR.
020800/
020900     COPY MB00RB REPLACING ==:MB00:== BY ==MMOC==.
021000/
021100     COPY MMOCRL.
021200/    MERCHANT PRODUCT
021300     COPY MMMPIO.
021400/
021500     COPY MMMPIR.
021600/
021700     COPY MB00RB REPLACING ==:MB00:== BY ==MMMP==.
021800/
021900     COPY MMMPRL.
022000/
022100     COPY MMMPTB.
022200/    SYSTEM
022300     COPY MMSCIO.
022400/
022500     COPY MB00RB REPLACING ==:MB00:== BY ==MMSC==.
022600/
022700     COPY MMSCRL.
022800/    STORE/MERCHANT CROSS REF
022900     COPY MMXRIO.
023000/
023100     COPY MB00RB REPLACING ==:MB00:== BY ==MMXR==.
023200/
023300     COPY MMXRRL.
023400/    DYNAMICALLY CALLED SUBRTNS
023500     COPY MB00WS.
023600/    DATE/TIME STAMP CHECK, MISSING HDR AND FILE NOT ON BKUP W/A
023700     COPY MB99WS.
023800/    COMMON DATE RTN W/A
023900     COPY SS00WS.
024000/    COMMON DATE RTN W/A
024100     COPY SS01WS.
024200/    COMMON ABEND RTN W/A
024300     COPY SS02WS.
024400*
024500 01  FILLER                  PIC  X(12)      VALUE '** WS-END **'.
024600/
024700 PROCEDURE DIVISION.
024800 A000-MAIN-LINE-SECT SECTION.
024900 A010-ML-BEGIN.
025000*
025100     MOVE 'MBU620'               TO SS02WS-ABEND-PROG-ID.
025200*
025300     MOVE 'O1SC'                 TO SS02WS-ABEND-LOCATION.
025400     SET MMSCRB-OPEN-INPUT       TO TRUE.
025500     PERFORM MB00PD-MMSC-ACCESS  THRU MB00PD-MMSC-ACCESS-EXIT.
025600*
025700     MOVE 'R0SC'                 TO SS02WS-ABEND-LOCATION.
025800     SET MMSCRB-READ-SEQ         TO TRUE.
025900     PERFORM MB00PD-MMSC-ACCESS  THRU MB00PD-MMSC-ACCESS-EXIT.
026000*
026100     MOVE 'MMSC'                 TO MB99WS-FILE-ID.
026200*
026300     IF  MMSCIO-HEADER
026400         NEXT SENTENCE
026500     ELSE
026600         PERFORM MB99PD-MISSING-HEADER-ABEND
026700                                 THRU MB99PD-MHA-EXIT.
026800*
026900     MOVE MMSCIO-RECORD          TO MMSC-RECORD.
027000*
027100     MOVE 'C1SC'                 TO SS02WS-ABEND-LOCATION.
027200     SET MMSCRB-CLOSE            TO TRUE.
027300     PERFORM MB00PD-MMSC-ACCESS  THRU MB00PD-MMSC-ACCESS-EXIT.
027400*
027500     MOVE MMSC-TODAYS-JULIAN     TO MB99WS-PROC-DATE.
027600     MOVE MMSC-TIME-STAMP        TO MB99WS-PROC-TIME.
027700*
027800     MOVE 'MBU620  '             TO MB20WS-SH-RPT-ID.
027900     MOVE 'T620'                 TO MB20WS-SH-INTERNAL-RPT-ID.
028000     MOVE MMSC-SCREEN-HEADER     TO MB20WS-SH-SYSTEM.
028100     MOVE 'MERCHANT FIELD INQUIRY REPORT'
028200                                 TO MB20WS-SH-RPT-NAME.
028300     MOVE MMSC-TODAYS-JULIAN     TO SS01WS-JULIAN.
028400     PERFORM SS08PD-JUL-TO-GREG
028500        THRU SS08PD-JTG-EXIT.
028600     MOVE SS01WS-DATE-L6         TO MB20WS-SH-PROC-DATE.
028700     MOVE MMSC-TIME-STAMP        TO MB20WS-SH-PROC-TIME.
028800     INSPECT MB20WS-SH-PROC-TIME REPLACING ALL SPACE BY ':'.
028900     MOVE 60                     TO MB20WS-LINE-COUNT.
029000     MOVE WS-MBU620-HDL-1        TO MB20WS-SH-L5.
029100     MOVE WS-MBU620-HDL-2        TO MB20WS-SH-L6.
029200*
029300*
029400*
029500     PERFORM A100-CONTROL-CARDS
029600        THRU A199-CC-EXIT.
029700*
029800     IF  WS-CTL-CARD-CNTR IS GREATER THAN ZERO
029900     AND WS-CTL-CARD-CNTR IS LESS THAN 3
030000        MOVE ' '                 TO MB20WS-PRINT-LINE
030100        PERFORM MB20PD-PRINT-2-LINES
030200           THRU MB20PD-P2L-EXIT
030300        MOVE 'CONTROL CARD 1 (STEP MODE), '
030400                                 TO MB20WS-PRINT-LINE
030500        PERFORM MB20PD-PRINT-2-LINES
030600           THRU MB20PD-P2L-EXIT
030700        MOVE 'CONTROL CARD 2 (SEARCH VALUES), AND '
030800                                 TO MB20WS-PRINT-LINE
030900        PERFORM MB20PD-PRINT-2-LINES
031000           THRU MB20PD-P2L-EXIT
031100        MOVE 'CONTROL CARD 3 (COMPRESS VALUES) ARE REQUIRED'
031200                                 TO MB20WS-PRINT-LINE
031300        PERFORM MB20PD-PRINT-2-LINES
031400           THRU MB20PD-P2L-EXIT
031500        GO TO A099-ML-EXIT
031600     END-IF.
031700*
031800     IF WS-ERROR-SW = 'Y'
031900        GO TO A099-ML-EXIT.
032000*
032100     PERFORM A200-OPEN-FILES
032200        THRU A299-OF-EXIT.
032300*
032400     MOVE 'R1MM'                 TO SS02WS-ABEND-LOCATION.
032500     SET MMMMRB-READ-SEQ         TO TRUE.
032600     PERFORM MB00PD-MMMM-ACCESS  THRU MB00PD-MMMM-ACCESS-EXIT.
032700*
032800*
032900     PERFORM UNTIL SS02WS-FS-END-OF-FILE
033000          OR MMMMIO-TRAILER
033100*
033200        MOVE MMMMIO-RECORD       TO MMMM-RECORD
033300*
033400        IF MMMM-ORG IS NOT EQUAL TO MMOC-ORG
033500           MOVE MMMM-ORG         TO MMOCIO-ORG
033600           SET MMOCRB-READ-RANDOM
033700                                 TO TRUE
033800           PERFORM MB00PD-MMOC-ACCESS THRU MB00PD-MMOC-ACCESS-EXIT
033900           MOVE MMOCIO-RECORD    TO MMOC-RECORD
034000        END-IF
034100*
034200        IF MMMM-ORG IS NOT EQUAL TO WS-PREV-ORG
034300           IF WS-PREV-ORG IS NOT EQUAL TO ZEROES
034400              PERFORM A720-PRINT-BREAK
034500                 THRU A799-PR-EXIT
034600           END-IF
034700           MOVE MMMM-ORG         TO WS-PREV-ORG
034800           MOVE MMOC-ORG         TO MB20WS-SH-ORG
034900           MOVE MMOC-NA-LINE (1 1)
035000                                 TO MB20WS-SH-ORG-NAME
035100           MOVE MMOC-TODAYS-JULIAN
035200                                 TO SS01WS-JULIAN
035300           PERFORM SS08PD-JUL-TO-GREG
035400              THRU SS08PD-JTG-EXIT
035500           MOVE SS01WS-DATE-L6   TO MB20WS-SH-FILE-DATE
035600           MOVE MB20WS-FORCE-PAGE
035700                                 TO MB20WS-LINE-COUNT
035800        END-IF
035900*
036000        MOVE MMMM-TAX-ID         TO WS-ORIG-TAX-ID
036100*
036200        MOVE 01                  TO MMMPIO-PRODUCT
036300        MOVE 'R1MP'              TO SS02WS-ABEND-LOCATION
036400        PERFORM A300-READ-PRODUCT
036500           THRU A399-RP-EXIT
036600        IF MMMP-PROD-ACTIVE
036700           MOVE 'Y'              TO WS-VISA-PROD-FND
036800        ELSE
036900           MOVE 'N'              TO WS-VISA-PROD-FND
037000        END-IF
037100*
037200        MOVE 02                  TO MMMPIO-PRODUCT
037300        MOVE 'R2MP'              TO SS02WS-ABEND-LOCATION
037400        PERFORM A300-READ-PRODUCT
037500           THRU A399-RP-EXIT
037600        IF MMMP-PROD-ACTIVE
037700           MOVE 'Y'              TO WS-MC-PROD-FND
037800        ELSE
037900           MOVE 'N'              TO WS-MC-PROD-FND
038000        END-IF
038100*
038200        IF WS-VISA-PROD-FND IS EQUAL TO 'Y'
038300        OR WS-MC-PROD-FND   IS EQUAL TO 'Y'
038400           PERFORM A400-SEARCH-TAXPAYER-ID
038500              THRU A499-STI-EXIT
038600        END-IF
038700*
038800        IF WS-SEARCH-VALS-FND IS EQUAL TO 'Y'
038900           MOVE MMMM-TAX-ID      TO WS-MMMM-TAX-ID
039000           PERFORM A500-COMPRESS-TAXPAYER-ID
039100              THRU A599-CTI-EXIT
039200        END-IF
039300*
039400        IF  WS-MTCC-MBU620-CORRECT IS EQUAL TO 'Y'
039500        AND WS-SEARCH-VALS-FND     IS EQUAL TO 'Y'
039600        AND WS-CORRECTED-TAX-ID IS NOT EQUAL TO
039700            WS-ORIG-TAX-ID
039800           PERFORM A600-CORRECT-MMMM-MMSM
039900              THRU A699-CMM-EXIT
040000           ADD 1                 TO WS-CORRECTED-CNTR
040100        END-IF
040200*
040300        IF WS-SEARCH-VALS-FND IS EQUAL TO 'Y'
040400           PERFORM A700-PRINT-REPORT
040500              THRU A799-PR-EXIT
040600        END-IF
040700*
040800        MOVE 'R2MM'              TO SS02WS-ABEND-LOCATION
040900        SET MMMMRB-READ-SEQ      TO TRUE
041000        PERFORM MB00PD-MMMM-ACCESS THRU MB00PD-MMMM-ACCESS-EXIT
041100*
041200        MOVE 'N'                 TO WS-SEARCH-VALS-FND
041300                                    WS-VISA-PROD-FND
041400                                    WS-MC-PROD-FND
041500        MOVE SPACES              TO WS-CORRECTED-TAX-ID
041600*
041700     END-PERFORM.
041800*
041900     PERFORM A720-PRINT-BREAK
042000        THRU A799-PR-EXIT.
042100*
042200*
042300     PERFORM A900-CLOSE-FILES
042400        THRU A999-CF-EXIT.
042500*
042600*
042700 A099-ML-EXIT.
042800     STOP RUN.
042900/
043000 A100-CONTROL-CARDS.
043100*
043200     MOVE SS02WS-END-OF-FILE     TO MTCCRB-PERM-STATUS-1.
043300     MOVE 'O1CC'                 TO SS02WS-ABEND-LOCATION.
043400     SET MTCCRB-OPEN-INPUT       TO TRUE.
043500     PERFORM MB00PD-MTCC-ACCESS
043600        THRU MB00PD-MTCC-ACCESS-EXIT.
043700*
043800 A110-CC-READ-LOOP.
043900*
044000     MOVE 'R1CC'                 TO SS02WS-ABEND-LOCATION.
044100*
044200     SET MTCCRB-READ-SEQ         TO TRUE.
044300     PERFORM MB00PD-MTCC-ACCESS
044400        THRU MB00PD-MTCC-ACCESS-EXIT.
044500*
044600     IF SS02WS-FS-END-OF-FILE
044700        GO TO A190-CC-CLOSE-FILE.
044800
044900     IF MTCCIO-PROGRAM-ID IS EQUAL TO SS02WS-ABEND-PROG-ID
045000        ADD 1                    TO WS-CTL-CARD-CNTR
045100     ELSE
045200        GO TO A110-CC-READ-LOOP.
045300*
045400     MOVE MTCCIO-RECORD          TO MTCC-RECORD.
045500*
045600     IF WS-CTL-CARD-CNTR IS     EQUAL TO 1
045700        MOVE MTCC-RECORD  TO WS-MTCC-MBU620-STEP-MODE
045800        IF  (WS-MTCC-MBU620-SIMULATE IS EQUAL TO 'Y'
045900        AND  WS-MTCC-MBU620-CORRECT  IS EQUAL TO 'Y')
046000        OR  (WS-MTCC-MBU620-SIMULATE IS EQUAL TO 'N'
046100        AND  WS-MTCC-MBU620-CORRECT  IS EQUAL TO 'N')
046200            MOVE ' '               TO MB20WS-PRINT-LINE
046300            PERFORM MB20PD-PRINT-2-LINES
046400               THRU MB20PD-P2L-EXIT
046500            MOVE '----+----1 POSITION 1 AND 2 ON CONTROL CARD 1 (S
046600-                'TEP MODE) CANNOT BOTH BE Y OR N ----+-'
046700                                 TO MB20WS-PRINT-LINE
046800            PERFORM MB20PD-PRINT-2-LINES
046900               THRU MB20PD-P2L-EXIT
047000            MOVE MTCC-RECORD-MBU620-1
047100                                 TO MB20WS-PRINT-LINE
047200            PERFORM MB20PD-PRINT-2-LINES
047300               THRU MB20PD-P2L-EXIT
047400            MOVE 'Y'             TO WS-ERROR-SW
047500        ELSE
047600           PERFORM VARYING WS-CUR-POS FROM 1 BY 1
047700             UNTIL WS-CUR-POS  IS GREATER THAN 2
047800             IF WS-MTCC-MBU620-STEP-MODE (WS-CUR-POS:1)
047900                                 IS EQUAL TO 'Y'
048000             OR WS-MTCC-MBU620-STEP-MODE (WS-CUR-POS:1)
048100                                 IS EQUAL TO 'N'
048200                CONTINUE
048300             ELSE
048400                MOVE ' '         TO MB20WS-PRINT-LINE
048500                PERFORM MB20PD-PRINT-2-LINES
048600                   THRU MB20PD-P2L-EXIT
048700                MOVE '----+----1 VALID VALUES FOR CONTROL CARD 1 (
048800-                    'STEP MODE) ARE Y OR N       --+----8----+-'
048900                                 TO MB20WS-PRINT-LINE
049000                PERFORM MB20PD-PRINT-2-LINES
049100                   THRU MB20PD-P2L-EXIT
049200                MOVE MTCC-RECORD-MBU620-1
049300                                 TO MB20WS-PRINT-LINE
049400                PERFORM MB20PD-PRINT-2-LINES
049500                   THRU MB20PD-P2L-EXIT
049600                MOVE 'Y'         TO WS-ERROR-SW
049700                MOVE 2           TO WS-CUR-POS
049800             END-IF
049900           END-PERFORM
050000        END-IF
050100     END-IF.
050200*
050300     IF WS-CTL-CARD-CNTR IS EQUAL TO 2
050400        MOVE MTCC-RECORD         TO WS-MTCC-MBU620-SEARCH-VALS
050500        IF WS-MTCC-MBU620-SEARCH-VALS IS EQUAL TO ALL 'N'
050600           MOVE ' '              TO MB20WS-PRINT-LINE
050700           PERFORM MB20PD-PRINT-2-LINES
050800              THRU MB20PD-P2L-EXIT
050900           MOVE '----+----1 AT LEAST ONE POSITION ON CONTROL CARD
051000-               '2 (SEARCH VALUES) MUST BE Y    ----+-'
051100                                 TO MB20WS-PRINT-LINE
051200           PERFORM MB20PD-PRINT-2-LINES
051300              THRU MB20PD-P2L-EXIT
051400           MOVE MTCC-RECORD-MBU620-2
051500                                 TO MB20WS-PRINT-LINE
051600           PERFORM MB20PD-PRINT-2-LINES
051700              THRU MB20PD-P2L-EXIT
051800           MOVE 'Y'              TO WS-ERROR-SW
051900        ELSE
052000           PERFORM VARYING WS-CUR-POS FROM 1 BY 1
052100             UNTIL WS-CUR-POS  IS GREATER THAN 9
052200             IF WS-MTCC-MBU620-SEARCH-VALS (WS-CUR-POS:1)
052300                                 IS EQUAL TO 'Y'
052400             OR WS-MTCC-MBU620-SEARCH-VALS (WS-CUR-POS:1)
052500                                 IS EQUAL TO 'N'
052600                CONTINUE
052700             ELSE
052800                MOVE ' '         TO MB20WS-PRINT-LINE
052900                PERFORM MB20PD-PRINT-2-LINES
053000                   THRU MB20PD-P2L-EXIT
053100                MOVE '----+----1 VALID VALUES FOR CONTROL CARD 2 (
053200-                    'SEARCH VALUES) ARE Y OR N   --+----8----+-'
053300                                 TO MB20WS-PRINT-LINE
053400                PERFORM MB20PD-PRINT-2-LINES
053500                   THRU MB20PD-P2L-EXIT
053600                MOVE MTCC-RECORD-MBU620-2
053700                                 TO MB20WS-PRINT-LINE
053800                PERFORM MB20PD-PRINT-2-LINES
053900                   THRU MB20PD-P2L-EXIT
054000                MOVE 'Y'         TO WS-ERROR-SW
054100                MOVE 9           TO WS-CUR-POS
054200             END-IF
054300          END-PERFORM
054400        END-IF
054500     END-IF.
054600*
054700     IF WS-CTL-CARD-CNTR IS     EQUAL TO 3
054800        MOVE MTCC-RECORD        TO WS-MTCC-MBU620-COMPRESS-VALS
054900        IF WS-MTCC-MBU620-COMPRESS-VALS IS EQUAL TO ALL 'N'
055000           MOVE ' '             TO MB20WS-PRINT-LINE
055100           PERFORM MB20PD-PRINT-2-LINES
055200              THRU MB20PD-P2L-EXIT
055300           MOVE '----+----1 AT LEAST ONE POSITION ON CONTROL CARD
055400-               '3 (COMPRESS VALUES) MUST BE Y  ----+-'
055500                                TO MB20WS-PRINT-LINE
055600           PERFORM MB20PD-PRINT-2-LINES
055700              THRU MB20PD-P2L-EXIT
055800           MOVE MTCC-RECORD-MBU620-3
055900                                TO MB20WS-PRINT-LINE
056000           PERFORM MB20PD-PRINT-2-LINES
056100              THRU MB20PD-P2L-EXIT
056200           MOVE 'Y'              TO WS-ERROR-SW
056300        ELSE
056400           PERFORM VARYING WS-CUR-POS FROM 1 BY 1
056500             UNTIL WS-CUR-POS  IS GREATER THAN 6
056600             IF WS-MTCC-MBU620-COMPRESS-VALS (WS-CUR-POS:1)
056700                                 IS EQUAL TO 'Y'
056800             OR WS-MTCC-MBU620-COMPRESS-VALS (WS-CUR-POS:1)
056900                                 IS EQUAL TO 'N'
057000                CONTINUE
057100             ELSE
057200                MOVE ' '         TO MB20WS-PRINT-LINE
057300                PERFORM MB20PD-PRINT-2-LINES
057400                   THRU MB20PD-P2L-EXIT
057500                MOVE '----+----1 VALID VALUES FOR CONTROL CARD 3 (
057600-                    'COMPRESS VALUES) ARE Y OR N --+----8----+-'
057700                                 TO MB20WS-PRINT-LINE
057800                PERFORM MB20PD-PRINT-2-LINES
057900                   THRU MB20PD-P2L-EXIT
058000                MOVE MTCC-RECORD-MBU620-3
058100                                 TO MB20WS-PRINT-LINE
058200                PERFORM MB20PD-PRINT-2-LINES
058300                   THRU MB20PD-P2L-EXIT
058400                MOVE 'Y'         TO WS-ERROR-SW
058500                MOVE 6           TO WS-CUR-POS
058600             END-IF
058700          END-PERFORM
058800        END-IF
058900     END-IF.
059000*
059100     GO TO A110-CC-READ-LOOP.
059200*
059300 A190-CC-CLOSE-FILE.
059400     MOVE 'C1CC'                 TO SS02WS-ABEND-LOCATION.
059500     SET MTCCRB-CLOSE            TO TRUE.
059600     PERFORM MB00PD-MTCC-ACCESS
059700        THRU MB00PD-MTCC-ACCESS-EXIT.
059800*
059900 A199-CC-EXIT.
060000     EXIT.
060100*
060200/
060300 A200-OPEN-FILES SECTION.
060400 A210-OF-OPEN-FILES.
060500*
060600     MOVE 'O1MP'                 TO SS02WS-ABEND-LOCATION.
060700     SET MMMPRB-OPEN-INPUT-DYN   TO TRUE.
060800     PERFORM MB00PD-MMMP-ACCESS  THRU MB00PD-MMMP-ACCESS-EXIT.
060900*
061000     IF WS-MTCC-MBU620-SIMULATE IS EQUAL TO 'Y'
061100        MOVE 'O1MM'              TO SS02WS-ABEND-LOCATION
061200        SET MMMMRB-OPEN-INPUT    TO TRUE
061300        PERFORM MB00PD-MMMM-ACCESS THRU MB00PD-MMMM-ACCESS-EXIT.
061400*
061500     IF WS-MTCC-MBU620-CORRECT IS EQUAL TO 'Y'
061600        MOVE 'O1XR'              TO SS02WS-ABEND-LOCATION
061700        SET MMXRRB-OPEN-INPUT    TO TRUE
061800        PERFORM MB00PD-MMXR-ACCESS THRU MB00PD-MMXR-ACCESS-EXIT
061900*
062000        MOVE 'O1MM'              TO SS02WS-ABEND-LOCATION
062100        SET MMMMRB-OPEN-IO-DYN   TO TRUE
062200        PERFORM MB00PD-MMMM-ACCESS THRU MB00PD-MMMM-ACCESS-EXIT
062300*
062400        MOVE 'O1SM'              TO SS02WS-ABEND-LOCATION
062500        SET MMSMRB-OPEN-IO-DYN   TO TRUE
062600        PERFORM MB00PD-MMSM-ACCESS THRU MB00PD-MMSM-ACCESS-EXIT.
062700*
062800     MOVE 'O1OC'                 TO SS02WS-ABEND-LOCATION.
062900     SET MMOCRB-OPEN-INPUT-DYN   TO TRUE.
063000     PERFORM MB00PD-MMOC-ACCESS  THRU MB00PD-MMOC-ACCESS-EXIT.
063100*
063200 A220-CHECK-HEADERS-READ.
063300*
063400     MOVE 'R0OC'                 TO SS02WS-ABEND-LOCATION.
063500     SET MMOCRB-READ-SEQ         TO TRUE.
063600     PERFORM MB00PD-MMOC-ACCESS  THRU MB00PD-MMOC-ACCESS-EXIT.
063700     MOVE 'MOCM'                 TO MB99WS-FILE-ID.
063800*
063900     IF  MMOCIO-HEADER
064000         NEXT SENTENCE
064100     ELSE
064200         PERFORM MB99PD-MISSING-HEADER-ABEND
064300                                 THRU MB99PD-MHA-EXIT.
064400*
064500     MOVE MMOCIO-DATE-STAMP      TO MB99WS-FILE-DATE.
064600     MOVE MMOCIO-TIME-STAMP      TO MB99WS-FILE-TIME.
064700     PERFORM MB99PD-CHECK-DATE-TIME
064800                                 THRU MB99PD-CDT-EXIT.
064900*
065000     MOVE MMOCIO-RECORD          TO MMOC-RECORD.
065100*
065200*
065300*
065400     MOVE 'R0MM'                 TO SS02WS-ABEND-LOCATION.
065500     SET MMMMRB-READ-SEQ         TO TRUE.
065600     PERFORM MB00PD-MMMM-ACCESS  THRU MB00PD-MMMM-ACCESS-EXIT.
065700     MOVE 'MMMM'                 TO MB99WS-FILE-ID.
065800*
065900     IF  MMMMIO-HEADER
066000         NEXT SENTENCE
066100     ELSE
066200         PERFORM MB99PD-MISSING-HEADER-ABEND
066300                                 THRU MB99PD-MHA-EXIT.
066400*
066500     MOVE MMMMIO-DATE-STAMP      TO MB99WS-FILE-DATE.
066600     MOVE MMMMIO-TIME-STAMP      TO MB99WS-FILE-TIME.
066700     PERFORM MB99PD-CHECK-DATE-TIME
066800                                 THRU MB99PD-CDT-EXIT.
066900*
067000     MOVE MMMMIO-RECORD          TO MMMM-RECORD.
067100*
067200*
067300*
067400     MOVE 'R0MP'                 TO SS02WS-ABEND-LOCATION.
067500     SET MMMPRB-READ-SEQ         TO TRUE.
067600     PERFORM MB00PD-MMMP-ACCESS  THRU MB00PD-MMMP-ACCESS-EXIT.
067700     MOVE 'MMMP'                 TO MB99WS-FILE-ID.
067800*
067900     IF  MMMPIO-HEADER
068000         NEXT SENTENCE
068100     ELSE
068200         PERFORM MB99PD-MISSING-HEADER-ABEND
068300                                 THRU MB99PD-MHA-EXIT.
068400*
068500     MOVE MMMPIO-DATE-STAMP      TO MB99WS-FILE-DATE.
068600     MOVE MMMPIO-TIME-STAMP      TO MB99WS-FILE-TIME.
068700     PERFORM MB99PD-CHECK-DATE-TIME
068800                                 THRU MB99PD-CDT-EXIT.
068900*
069000     MOVE MMMPIO-RECORD          TO MMMP-RECORD.
069100*
069200*
069300*
069400     IF WS-MTCC-MBU620-CORRECT IS EQUAL TO 'Y'
069500        MOVE 'R0SM'              TO SS02WS-ABEND-LOCATION
069600        SET MMSMRB-READ-SEQ      TO TRUE
069700        PERFORM MB00PD-MMSM-ACCESS THRU MB00PD-MMSM-ACCESS-EXIT
069800        MOVE 'MMSM'              TO MB99WS-FILE-ID
069900*
070000        IF  MMSMIO-HEADER
070100            NEXT SENTENCE
070200        ELSE
070300            PERFORM MB99PD-MISSING-HEADER-ABEND
070400               THRU MB99PD-MHA-EXIT
070500        END-IF
070600*
070700        MOVE MMSMIO-DATE-STAMP   TO MB99WS-FILE-DATE
070800        MOVE MMSMIO-TIME-STAMP   TO MB99WS-FILE-TIME
070900        PERFORM MB99PD-CHECK-DATE-TIME
071000           THRU MB99PD-CDT-EXIT
071100*
071200        MOVE MMSMIO-RECORD       TO MMSM-RECORD
071300*
071400*
071500*
071600        MOVE 'R0XR'              TO SS02WS-ABEND-LOCATION
071700        SET MMXRRB-READ-SEQ      TO TRUE
071800        PERFORM MB00PD-MMXR-ACCESS THRU MB00PD-MMXR-ACCESS-EXIT
071900        MOVE 'MMXR'              TO MB99WS-FILE-ID
072000*
072100        IF  MMXRIO-HEADER
072200            NEXT SENTENCE
072300        ELSE
072400            PERFORM MB99PD-MISSING-HEADER-ABEND
072500               THRU MB99PD-MHA-EXIT
072600        END-IF
072700*
072800        MOVE MMXRIO-DATE-STAMP   TO MB99WS-FILE-DATE
072900        MOVE MMXRIO-TIME-STAMP   TO MB99WS-FILE-TIME
073000        PERFORM MB99PD-CHECK-DATE-TIME
073100           THRU MB99PD-CDT-EXIT
073200*
073300        MOVE MMXRIO-RECORD       TO MMXR-RECORD
073400     END-IF.
073500*
073600*
073700*
073800 A299-OF-EXIT.
073900     EXIT.
074000/
074100 A300-READ-PRODUCT SECTION.
074200 A310-RP-BEGIN.
074300*
074400***  MMMP-PRODUCT SET PRIOR TO PERFORM OF THIS PARAGRAPH
074500     MOVE MMMM-ORG-MERCHANT      TO MMMPIO-ORG-MERCHANT.
074600     SET MMMPRB-READ-RANDOM      TO TRUE.
074700     MOVE SS02WS-NO-RECORD-FOUND
074800                                 TO MMMPRB-TEMP-STATUS-1.
074900     PERFORM MB00PD-MMMP-ACCESS  THRU MB00PD-MMMP-ACCESS-EXIT.
075000     IF SS02WS-FS-NO-RECORD-FOUND
075100        MOVE SPACES              TO MMMP-RECORD
075200     ELSE
075300        MOVE MMMPIO-RECORD       TO MMMP-RECORD
075400     END-IF.
075500*
075600 A399-RP-EXIT.
075700     EXIT.
075800/
075900 A400-SEARCH-TAXPAYER-ID SECTION.
076000 A410-STI-BEGIN.
076100*
076200     IF  WS-MTCC-MBU620-SV-REPEAT-NUMS IS EQUAL TO 'Y'
076300     AND MMMM-TAX-ID IS NUMERIC
076400         IF MMMM-TAX-ID IS EQUAL TO ALL '0'
076500         OR MMMM-TAX-ID IS EQUAL TO ALL '1'
076600         OR MMMM-TAX-ID IS EQUAL TO ALL '2'
076700         OR MMMM-TAX-ID IS EQUAL TO ALL '3'
076800         OR MMMM-TAX-ID IS EQUAL TO ALL '4'
076900         OR MMMM-TAX-ID IS EQUAL TO ALL '5'
077000         OR MMMM-TAX-ID IS EQUAL TO ALL '6'
077100         OR MMMM-TAX-ID IS EQUAL TO ALL '7'
077200         OR MMMM-TAX-ID IS EQUAL TO ALL '8'
077300         OR MMMM-TAX-ID IS EQUAL TO ALL '9'
077400            MOVE 'Y'             TO WS-SEARCH-VALS-FND
077500         END-IF
077600     END-IF.
077700*
077800     IF  WS-MTCC-MBU620-SV-ALL-SPACES IS EQUAL TO 'Y'
077900     AND WS-SEARCH-VALS-FND           IS EQUAL TO 'N'
078000        IF MMMM-TAX-ID IS EQUAL TO SPACES
078100           MOVE 'Y'              TO WS-SEARCH-VALS-FND
078200        END-IF
078300     END-IF.
078400*
078500     IF  WS-MTCC-MBU620-SV-LESS-9-CHARS IS EQUAL TO 'Y'
078600     AND WS-SEARCH-VALS-FND             IS EQUAL TO 'N'
078700        MOVE ZERO               TO WS-NBR-CHARS-CNTR
078800        PERFORM VARYING WS-CUR-POS FROM 1 BY 1
078900          UNTIL WS-CUR-POS IS GREATER THAN 15
079000             OR WS-NBR-CHARS-CNTR IS EQUAL TO 9
079100          IF MMMM-TAX-ID (WS-CUR-POS:1) IS GREATER THAN SPACE
079200             ADD 1              TO WS-NBR-CHARS-CNTR
079300          END-IF
079400        END-PERFORM
079500        IF  WS-NBR-CHARS-CNTR IS GREATER THAN ZERO
079600        AND WS-NBR-CHARS-CNTR IS LESS    THAN 9
079700           MOVE 'Y'             TO WS-SEARCH-VALS-FND
079800        END-IF
079900     END-IF.
080000*
080100     IF  WS-MTCC-MBU620-SV-LEAD-SPACES IS EQUAL TO 'Y'
080200     AND WS-SEARCH-VALS-FND            IS EQUAL TO 'N'
080300        IF  MMMM-TAX-ID       IS NOT EQUAL TO SPACES
080400        AND MMMM-TAX-ID (1:1) IS EQUAL TO SPACE
080500           MOVE 'Y'              TO WS-SEARCH-VALS-FND
080600        END-IF
080700     END-IF.
080800*
080900     IF  WS-MTCC-MBU620-SV-EMBED-SPACES IS EQUAL TO 'Y'
081000     AND WS-SEARCH-VALS-FND             IS EQUAL TO 'N'
081100        IF  MMMM-TAX-ID (1:1)  IS NOT EQUAL TO SPACE
081200           PERFORM VARYING WS-CUR-POS FROM 2 BY 1
081300             UNTIL WS-CUR-POS IS GREATER THAN 15
081400                OR WS-SEARCH-VALS-FND IS EQUAL TO 'Y'
081500             IF MMMM-TAX-ID (WS-CUR-POS:1) IS EQUAL TO SPACE
081600                MOVE 'Y'         TO WS-SEARCH-VALS-FND
081700             END-IF
081800           END-PERFORM
081900           IF WS-SEARCH-VALS-FND IS EQUAL TO 'Y'
082000              IF WS-CUR-POS IS LESS THAN 15
082100                 ADD 1           TO WS-CUR-POS
082200                 MOVE 'N'        TO WS-SEARCH-VALS-FND
082300                 PERFORM VARYING WS-CUR-POS FROM WS-CUR-POS BY 1
082400                   UNTIL WS-CUR-POS IS GREATER THAN 15
082500                      OR WS-SEARCH-VALS-FND IS EQUAL TO 'Y'
082600                    IF MMMM-TAX-ID (WS-CUR-POS:1)
082700                                 IS NOT EQUAL TO SPACE
082800                       MOVE 'Y'  TO WS-SEARCH-VALS-FND
082900                    END-IF
083000                 END-PERFORM
083100              END-IF
083200           END-IF
083300        END-IF
083400     END-IF.
083500*
083600     IF  WS-MTCC-MBU620-SV-DASHES IS EQUAL TO 'Y'
083700     AND WS-SEARCH-VALS-FND       IS EQUAL TO 'N'
083800        PERFORM VARYING WS-CUR-POS FROM 1 BY 1
083900          UNTIL WS-CUR-POS IS GREATER THAN 15
084000             OR WS-SEARCH-VALS-FND IS EQUAL TO 'Y'
084100          IF MMMM-TAX-ID (WS-CUR-POS:1) IS EQUAL TO '-'
084200             MOVE 'Y'            TO WS-SEARCH-VALS-FND
084300          END-IF
084400        END-PERFORM
084500     END-IF.
084600*
084700     IF  WS-MTCC-MBU620-SV-SLASHES IS EQUAL TO 'Y'
084800     AND WS-SEARCH-VALS-FND        IS EQUAL TO 'N'
084900        PERFORM VARYING WS-CUR-POS FROM 1 BY 1
085000          UNTIL WS-CUR-POS IS GREATER THAN 15
085100             OR WS-SEARCH-VALS-FND IS EQUAL TO 'Y'
085200          IF MMMM-TAX-ID (WS-CUR-POS:1) IS EQUAL TO '/'
085300          OR MMMM-TAX-ID (WS-CUR-POS:1) IS EQUAL TO '\'
085400             MOVE 'Y'            TO WS-SEARCH-VALS-FND
085500          END-IF
085600        END-PERFORM
085700     END-IF.
085800*
085900     IF  WS-MTCC-MBU620-SV-SPEC-CHARS IS EQUAL TO 'Y'
086000     AND WS-SEARCH-VALS-FND           IS EQUAL TO 'N'
086100        PERFORM VARYING WS-CUR-POS FROM 1 BY 1
086200          UNTIL WS-CUR-POS IS GREATER THAN 15
086300             OR WS-SEARCH-VALS-FND IS EQUAL TO 'Y'
086400          IF MMMM-TAX-ID (WS-CUR-POS:1) IS ALPHABETIC
086500          OR MMMM-TAX-ID (WS-CUR-POS:1) IS NUMERIC
086600          OR MMMM-TAX-ID (WS-CUR-POS:1) IS EQUAL TO '/'
086700          OR MMMM-TAX-ID (WS-CUR-POS:1) IS EQUAL TO '\'
086800          OR MMMM-TAX-ID (WS-CUR-POS:1) IS EQUAL TO '-'
086900             CONTINUE
087000          ELSE
087100             MOVE 'Y'            TO WS-SEARCH-VALS-FND
087200          END-IF
087300        END-PERFORM
087400     END-IF.
087500*
087600     IF  WS-MTCC-MBU620-SV-ALPHAS IS EQUAL TO 'Y'
087700     AND WS-SEARCH-VALS-FND       IS EQUAL TO 'N'
087800        PERFORM VARYING WS-CUR-POS FROM 1 BY 1
087900          UNTIL WS-CUR-POS IS GREATER THAN 15
088000             OR WS-SEARCH-VALS-FND IS EQUAL TO 'Y'
088100          IF  MMMM-TAX-ID (WS-CUR-POS:1) IS ALPHABETIC
088200          AND MMMM-TAX-ID (WS-CUR-POS:1) IS NOT EQUAL TO SPACE
088300             MOVE 'Y'            TO WS-SEARCH-VALS-FND
088400          END-IF
088500        END-PERFORM
088600     END-IF.
088700*
088800 A499-STI-EXIT.
088900     EXIT.
089000/
089100 A500-COMPRESS-TAXPAYER-ID SECTION.
089200 A510-CTI-BEGIN.
089300*
089400     IF WS-MTCC-MBU620-CV-LEAD-SPACES IS EQUAL TO 'Y'
089500        IF WS-CORRECTED-TAX-ID IS NOT EQUAL TO SPACES
089600           MOVE WS-CORRECTED-TAX-ID
089700                                 TO WS-MMMM-TAX-ID
089800           MOVE SPACES           TO WS-CORRECTED-TAX-ID
089900        END-IF
090000***     COUNT LEADING SPACES
090100        PERFORM VARYING WS-SEARCH-POS FROM 1 BY 1
090200          UNTIL WS-SEARCH-POS IS GREATER THAN 15
090300             OR WS-MMMM-TAX-ID (WS-SEARCH-POS:1) IS GREATER THAN
090400                                 SPACE
090500          IF WS-MMMM-TAX-ID (WS-SEARCH-POS:1) IS LESS THAN OR
090600                                 EQUAL TO SPACE
090700             CONTINUE
090800          END-IF
090900        END-PERFORM
091000        MOVE 1                   TO WS-CUR-POS
091100        COMPUTE WS-LEFTJUST-TIMES = 15 - WS-SEARCH-POS + 1
091200***     LEFT JUSTIFY
091300        PERFORM WS-LEFTJUST-TIMES TIMES
091400           MOVE WS-MMMM-TAX-ID (WS-SEARCH-POS:1)
091500                                 TO WS-CORRECTED-TAX-ID
091600                                   (WS-CUR-POS:1)
091700           ADD 1                 TO WS-SEARCH-POS
091800                                    WS-CUR-POS
091900        END-PERFORM
092000        COMPUTE WS-LEFTJUST-TIMES = 15 - WS-LEFTJUST-TIMES
092100***     SPACE FILL THE REST
092200        MOVE SPACE               TO WS-CORRECTED-TAX-ID
092300                                   (WS-CUR-POS:WS-LEFTJUST-TIMES)
092400     END-IF.
092500*
092600     IF WS-MTCC-MBU620-CV-EMBED-SPACES IS EQUAL TO 'Y'
092700        MOVE 1                   TO WS-CUR-POS
092800        IF WS-CORRECTED-TAX-ID IS NOT EQUAL TO SPACES
092900           MOVE WS-CORRECTED-TAX-ID
093000                                 TO WS-MMMM-TAX-ID
093100           MOVE SPACES           TO WS-CORRECTED-TAX-ID
093200        END-IF
093300        PERFORM VARYING WS-SEARCH-POS FROM 1 BY 1
093400          UNTIL WS-SEARCH-POS IS GREATER THAN 15
093500          IF WS-MMMM-TAX-ID (WS-SEARCH-POS:1) IS EQUAL TO SPACE
093600             CONTINUE
093700          ELSE
093800             MOVE WS-MMMM-TAX-ID (WS-SEARCH-POS:1)
093900                                 TO WS-CORRECTED-TAX-ID
094000                                   (WS-CUR-POS:1)
094100             ADD 1               TO WS-CUR-POS
094200          END-IF
094300        END-PERFORM
094400     END-IF.
094500*
094600     IF WS-MTCC-MBU620-CV-DASHES IS EQUAL TO 'Y'
094700        MOVE 1                   TO WS-CUR-POS
094800        IF WS-CORRECTED-TAX-ID IS NOT EQUAL TO SPACES
094900           MOVE WS-CORRECTED-TAX-ID
095000                                 TO WS-MMMM-TAX-ID
095100           MOVE SPACES           TO WS-CORRECTED-TAX-ID
095200        END-IF
095300        PERFORM VARYING WS-SEARCH-POS FROM 1 BY 1
095400          UNTIL WS-SEARCH-POS IS GREATER THAN 15
095500          IF WS-MMMM-TAX-ID (WS-SEARCH-POS:1) IS EQUAL TO '-'
095600             CONTINUE
095700          ELSE
095800             MOVE WS-MMMM-TAX-ID (WS-SEARCH-POS:1)
095900                                 TO WS-CORRECTED-TAX-ID
096000                                   (WS-CUR-POS:1)
096100             ADD 1               TO WS-CUR-POS
096200          END-IF
096300        END-PERFORM
096400     END-IF.
096500*
096600     IF WS-MTCC-MBU620-CV-SLASHES IS EQUAL TO 'Y'
096700        MOVE 1                   TO WS-CUR-POS
096800        IF WS-CORRECTED-TAX-ID IS NOT EQUAL TO SPACES
096900           MOVE WS-CORRECTED-TAX-ID
097000                                 TO WS-MMMM-TAX-ID
097100           MOVE SPACES           TO WS-CORRECTED-TAX-ID
097200        END-IF
097300        PERFORM VARYING WS-SEARCH-POS FROM 1 BY 1
097400          UNTIL WS-SEARCH-POS IS GREATER THAN 15
097500          IF WS-MMMM-TAX-ID (WS-SEARCH-POS:1) IS EQUAL TO '/'
097600          OR WS-MMMM-TAX-ID (WS-SEARCH-POS:1) IS EQUAL TO '\'
097700             CONTINUE
097800          ELSE
097900             MOVE WS-MMMM-TAX-ID (WS-SEARCH-POS:1)
098000                                 TO WS-CORRECTED-TAX-ID
098100                                   (WS-CUR-POS:1)
098200             ADD 1               TO WS-CUR-POS
098300          END-IF
098400        END-PERFORM
098500     END-IF.
098600*
098700     IF WS-MTCC-MBU620-CV-SPEC-CHARS IS EQUAL TO 'Y'
098800        MOVE 1                   TO WS-CUR-POS
098900        IF WS-CORRECTED-TAX-ID IS NOT EQUAL TO SPACES
099000           MOVE WS-CORRECTED-TAX-ID
099100                                 TO WS-MMMM-TAX-ID
099200           MOVE SPACES           TO WS-CORRECTED-TAX-ID
099300        END-IF
099400        PERFORM VARYING WS-SEARCH-POS FROM 1 BY 1
099500          UNTIL WS-SEARCH-POS IS GREATER THAN 15
099600          IF WS-MMMM-TAX-ID (WS-SEARCH-POS:1) IS ALPHABETIC
099700          OR WS-MMMM-TAX-ID (WS-SEARCH-POS:1) IS NUMERIC
099800          OR WS-MMMM-TAX-ID (WS-SEARCH-POS:1) IS EQUAL TO '/'
099900          OR WS-MMMM-TAX-ID (WS-SEARCH-POS:1) IS EQUAL TO '\'
100000          OR WS-MMMM-TAX-ID (WS-SEARCH-POS:1) IS EQUAL TO '-'
100100             MOVE WS-MMMM-TAX-ID (WS-SEARCH-POS:1)
100200                                 TO WS-CORRECTED-TAX-ID
100300                                   (WS-CUR-POS:1)
100400             ADD 1               TO WS-CUR-POS
100500          ELSE
100600             CONTINUE
100700          END-IF
100800        END-PERFORM
100900     END-IF.
101000*
101100     IF WS-MTCC-MBU620-CV-ALPHAS IS EQUAL TO 'Y'
101200        MOVE 1                   TO WS-CUR-POS
101300        IF WS-CORRECTED-TAX-ID IS NOT EQUAL TO SPACES
101400           MOVE WS-CORRECTED-TAX-ID
101500                                 TO WS-MMMM-TAX-ID
101600           MOVE SPACES           TO WS-CORRECTED-TAX-ID
101700        END-IF
101800        PERFORM VARYING WS-SEARCH-POS FROM 1 BY 1
101900          UNTIL WS-SEARCH-POS IS GREATER THAN 15
102000          IF WS-MMMM-TAX-ID (WS-SEARCH-POS:1) IS ALPHABETIC
102100             CONTINUE
102200          ELSE
102300             MOVE WS-MMMM-TAX-ID (WS-SEARCH-POS:1)
102400                                 TO WS-CORRECTED-TAX-ID
102500                                   (WS-CUR-POS:1)
102600             ADD 1               TO WS-CUR-POS
102700          END-IF
102800        END-PERFORM
102900     END-IF.
103000*
103100 A599-CTI-EXIT.
103200     EXIT.
103300/
103400 A600-CORRECT-MMMM-MMSM SECTION.
103500 A610-CMM-BEGIN.
103600*
103700     MOVE WS-CORRECTED-TAX-ID    TO MMMM-TAX-ID.
103800     MOVE MMMM-RECORD            TO MMMMIO-RECORD.
103900     MOVE 'U1MM'                 TO SS02WS-ABEND-LOCATION.
104000     SET MMMMRB-REWRITE          TO TRUE.
104100     PERFORM MB00PD-MMMM-ACCESS  THRU MB00PD-MMMM-ACCESS-EXIT.
104200*
104300     MOVE MMMM-ORG-MERCHANT      TO MMXRIO-ORG-MERCHANT.
104400     MOVE ZEROES                 TO MMXRIO-STORE.
104500     MOVE 'S1XR'                 TO SS02WS-ABEND-LOCATION.
104600     SET MMXRRB-START-GTE        TO TRUE.
104700     PERFORM MB00PD-MMXR-ACCESS  THRU MB00PD-MMXR-ACCESS-EXIT.
104800*
104900     PERFORM UNTIL MMXRIO-ORG-MERCHANT IS NOT EQUAL TO
105000                   MMMM-ORG-MERCHANT
105100        MOVE 'R1XR'              TO SS02WS-ABEND-LOCATION
105200        SET MMXRRB-READ-SEQ      TO TRUE
105300        PERFORM MB00PD-MMXR-ACCESS THRU MB00PD-MMXR-ACCESS-EXIT
105400        IF MMXRIO-ORG-MERCHANT IS EQUAL TO MMMM-ORG-MERCHANT
105500           MOVE MMXRIO-RECORD    TO MMXR-RECORD
105600           MOVE MMXR-ORG         TO MMSMIO-ORG
105700           MOVE MMXR-STORE       TO MMSMIO-STORE
105800           MOVE 'R1SM'           TO SS02WS-ABEND-LOCATION
105900           SET MMSMRB-READ-RANDOM
106000                                 TO TRUE
106100           PERFORM MB00PD-MMSM-ACCESS THRU MB00PD-MMSM-ACCESS-EXIT
106200           MOVE MMSMIO-RECORD    TO MMSM-RECORD
106300           MOVE WS-CORRECTED-TAX-ID
106400                                 TO MMSM-TAX-ID
106500           MOVE MMSM-RECORD      TO MMSMIO-RECORD
106600           MOVE 'U1SM'           TO SS02WS-ABEND-LOCATION
106700           SET MMSMRB-REWRITE    TO TRUE
106800           PERFORM MB00PD-MMSM-ACCESS THRU MB00PD-MMSM-ACCESS-EXIT
106900        END-IF
107000     END-PERFORM.
107100*
107200*
107300 A699-CMM-EXIT.
107400     EXIT.
107500/
107600 A700-PRINT-REPORT SECTION.
107700 A710-PR-BEGIN.
107800*
107900     MOVE MMMM-MERCHANT          TO WS-PL1-MER-NBR.
108000     MOVE MMMM-DBA-NAME          TO WS-PL1-MER-NAME.
108100     IF WS-VISA-PROD-FND IS EQUAL TO 'Y'
108200        MOVE 01                  TO WS-PL1-CARD-PROD-01
108300        MOVE SPACES              TO WS-PL1-CARD-PROD-02
108400        IF WS-MC-PROD-FND IS EQUAL TO 'Y'
108500           MOVE 02               TO WS-PL1-CARD-PROD-02
108600        END-IF
108700     ELSE
108800        IF WS-MC-PROD-FND IS EQUAL TO 'Y'
108900           MOVE 02               TO WS-PL1-CARD-PROD-01
109000           MOVE SPACES           TO WS-PL1-CARD-PROD-02
109100        END-IF
109200     END-IF.
109300     MOVE MMMM-1099-REFUSAL-IND  TO WS-PL1-IRI.
109400     MOVE WS-ORIG-TAX-ID         TO WS-PL1-ORIG-TAX-ID.
109500     IF WS-MTCC-MBU620-SIMULATE IS EQUAL TO 'Y'
109600        MOVE WS-CORRECTED-TAX-ID TO WS-PL1-SIMU-TAX-ID
109700        MOVE SPACES              TO WS-PL1-CORR-TAX-ID
109800     ELSE
109900        MOVE WS-CORRECTED-TAX-ID TO WS-PL1-CORR-TAX-ID
110000        MOVE SPACES              TO WS-PL1-SIMU-TAX-ID
110100     END-IF.
110200     PERFORM MB20PD-PRINT-2-LINES
110300        THRU MB20PD-P2L-EXIT.
110400     ADD 1                       TO WS-REPORTED-CNTR.
110500     GO TO A799-PR-EXIT.
110600*
110700*
110800 A720-PRINT-BREAK.
110900*
111000     MOVE SPACES                 TO MB20WS-PRINT-LINE.
111100     PERFORM MB20PD-PRINT-2-LINES
111200        THRU MB20PD-P2L-EXIT.
111300*
111400     MOVE 1                      TO WS-CUR-POS.
111500*
111600     IF WS-MTCC-MBU620-SV-REPEAT-NUMS IS EQUAL TO 'Y'
111700        MOVE 'REPEAT NUMS'       TO WS-MBU620-SEARCH-VALS
111800                                    (WS-CUR-POS:11)
111900        ADD 11                   TO WS-CUR-POS
112000     END-IF.
112100*
112200     IF WS-MTCC-MBU620-SV-ALL-SPACES IS EQUAL TO 'Y'
112300        IF WS-MBU620-SEARCH-VALS IS EQUAL TO SPACES
112400           MOVE 'ALL SPACES'     TO WS-MBU620-SEARCH-VALS
112500                                    (WS-CUR-POS:10)
112600           ADD 10                TO WS-CUR-POS
112700        ELSE
112800           MOVE ', ALL SPACES'   TO WS-MBU620-SEARCH-VALS
112900                                    (WS-CUR-POS:12)
113000           ADD 12                TO WS-CUR-POS
113100        END-IF
113200     END-IF.
113300*
113400     IF WS-MTCC-MBU620-SV-LESS-9-CHARS IS EQUAL TO 'Y'
113500        IF WS-MBU620-SEARCH-VALS IS EQUAL TO SPACES
113600           MOVE '< 9 CHARS'      TO WS-MBU620-SEARCH-VALS
113700                                    (WS-CUR-POS:09)
113800           ADD 09                TO WS-CUR-POS
113900        ELSE
114000           MOVE ', < 9 CHARS'    TO WS-MBU620-SEARCH-VALS
114100                                 (WS-CUR-POS:11)
114200           ADD 11                TO WS-CUR-POS
114300        END-IF
114400     END-IF.
114500*
114600     IF WS-MTCC-MBU620-SV-LEAD-SPACES IS EQUAL TO 'Y'
114700        IF WS-MBU620-SEARCH-VALS IS EQUAL TO SPACES
114800           MOVE 'LEAD SPACES'    TO WS-MBU620-SEARCH-VALS
114900                                    (WS-CUR-POS:11)
115000           ADD 11                TO WS-CUR-POS
115100        ELSE
115200           MOVE ', LEAD SPACES'  TO WS-MBU620-SEARCH-VALS
115300                                    (WS-CUR-POS:13)
115400           ADD 13                TO WS-CUR-POS
115500        END-IF
115600     END-IF.
115700*
115800     IF WS-MTCC-MBU620-SV-EMBED-SPACES IS EQUAL TO 'Y'
115900        IF WS-MBU620-SEARCH-VALS IS EQUAL TO SPACES
116000           MOVE 'EMBED SPACES'   TO WS-MBU620-SEARCH-VALS
116100                                    (WS-CUR-POS:12)
116200           ADD 12                TO WS-CUR-POS
116300        ELSE
116400           MOVE ', EMBED SPACES' TO WS-MBU620-SEARCH-VALS
116500                                    (WS-CUR-POS:14)
116600           ADD 14                TO WS-CUR-POS
116700     END-IF.
116800*
116900     IF WS-MTCC-MBU620-SV-DASHES IS EQUAL TO 'Y'
117000        IF WS-MBU620-SEARCH-VALS IS EQUAL TO SPACES
117100           MOVE 'DASHES'         TO WS-MBU620-SEARCH-VALS
117200                                    (WS-CUR-POS:06)
117300           ADD 06                TO WS-CUR-POS
117400        ELSE
117500           MOVE ', DASHES'       TO WS-MBU620-SEARCH-VALS
117600                                    (WS-CUR-POS:08)
117700           ADD 08                TO WS-CUR-POS
117800        END-IF
117900     END-IF.
118000*
118100     IF WS-MTCC-MBU620-SV-SLASHES IS EQUAL TO 'Y'
118200        IF WS-MBU620-SEARCH-VALS IS EQUAL TO SPACES
118300           MOVE 'SLASHES'        TO WS-MBU620-SEARCH-VALS
118400                                    (WS-CUR-POS:07)
118500           ADD 07                TO WS-CUR-POS
118600        ELSE
118700           MOVE ', SLASHES'      TO WS-MBU620-SEARCH-VALS
118800                                    (WS-CUR-POS:09)
118900           ADD 09                TO WS-CUR-POS
119000        END-IF
119100     END-IF.
119200*
119300     IF WS-MTCC-MBU620-SV-SPEC-CHARS IS EQUAL TO 'Y'
119400        IF WS-MBU620-SEARCH-VALS IS EQUAL TO SPACES
119500           MOVE 'SPECIAL CHARS'  TO WS-MBU620-SEARCH-VALS
119600                                    (WS-CUR-POS:13)
119700           ADD 13                TO WS-CUR-POS
119800        ELSE
119900           MOVE ', SPECIAL CHARS'
120000                                 TO WS-MBU620-SEARCH-VALS
120100                                    (WS-CUR-POS:15)
120200           ADD 15                TO WS-CUR-POS
120300        END-IF
120400     END-IF.
120500*
120600     IF WS-MTCC-MBU620-SV-ALPHAS IS EQUAL TO 'Y'
120700        IF WS-MBU620-SEARCH-VALS IS EQUAL TO SPACES
120800           MOVE 'ALPHAS'         TO WS-MBU620-SEARCH-VALS
120900                                    (WS-CUR-POS:06)
121000           ADD 06                TO WS-CUR-POS
121100        ELSE
121200           MOVE ', ALPHAS'       TO WS-MBU620-SEARCH-VALS
121300                                    (WS-CUR-POS:08)
121400           ADD 08                TO WS-CUR-POS
121500        END-IF
121600     END-IF.
121700*
121800     MOVE WS-MBU620-DTL-2        TO MB20WS-PRINT-LINE.
121900     PERFORM MB20PD-PRINT-2-LINES
122000        THRU MB20PD-P2L-EXIT.
122100*
122200*
122300*
122400*
122500     MOVE 1                      TO WS-CUR-POS.
122600*
122700     IF WS-MTCC-MBU620-CV-LEAD-SPACES IS EQUAL TO 'Y'
122800        MOVE 'LEAD SPACES'       TO WS-MBU620-COMPRESS-VALS
122900                                    (WS-CUR-POS:11)
123000        ADD 11                   TO WS-CUR-POS
123100     END-IF.
123200*
123300     IF WS-MTCC-MBU620-CV-EMBED-SPACES IS EQUAL TO 'Y'
123400        IF WS-MBU620-COMPRESS-VALS IS EQUAL TO SPACES
123500           MOVE 'EMBED SPACES'   TO WS-MBU620-COMPRESS-VALS
123600                                    (WS-CUR-POS:12)
123700           ADD 12                TO WS-CUR-POS
123800        ELSE
123900           MOVE ', EMBED SPACES' TO WS-MBU620-COMPRESS-VALS
124000                                    (WS-CUR-POS:14)
124100           ADD 14                TO WS-CUR-POS
124200        END-IF
124300     END-IF.
124400*
124500     IF WS-MTCC-MBU620-CV-DASHES IS EQUAL TO 'Y'
124600        IF WS-MBU620-COMPRESS-VALS IS EQUAL TO SPACES
124700           MOVE 'DASHES'         TO WS-MBU620-COMPRESS-VALS
124800                                    (WS-CUR-POS:06)
124900           ADD 06                TO WS-CUR-POS
125000        ELSE
125100           MOVE ', DASHES'       TO WS-MBU620-COMPRESS-VALS
125200                                    (WS-CUR-POS:8)
125300           ADD 8                 TO WS-CUR-POS
125400        END-IF
125500     END-IF.
125600*
125700     IF WS-MTCC-MBU620-CV-SLASHES IS EQUAL TO 'Y'
125800        IF WS-MBU620-COMPRESS-VALS IS EQUAL TO SPACES
125900           MOVE 'SLASHES'        TO WS-MBU620-COMPRESS-VALS
126000                                    (WS-CUR-POS:07)
126100           ADD 07                TO WS-CUR-POS
126200        ELSE
126300           MOVE ', SLASHES'      TO WS-MBU620-COMPRESS-VALS
126400                                    (WS-CUR-POS:09)
126500           ADD 09                TO WS-CUR-POS
126600        END-IF
126700     END-IF.
126800*
126900     IF WS-MTCC-MBU620-CV-SPEC-CHARS IS EQUAL TO 'Y'
127000        IF WS-MBU620-COMPRESS-VALS IS EQUAL TO SPACES
127100           MOVE 'SPECIAL CHARS'  TO WS-MBU620-COMPRESS-VALS
127200                                    (WS-CUR-POS:13)
127300           ADD 13                TO WS-CUR-POS
127400        ELSE
127500           MOVE ', SPECIAL CHARS'
127600                                 TO WS-MBU620-COMPRESS-VALS
127700                                    (WS-CUR-POS:15)
127800           ADD 15                TO WS-CUR-POS
127900        END-IF
128000     END-IF.
128100*
128200     IF WS-MTCC-MBU620-CV-ALPHAS IS EQUAL TO 'Y'
128300        IF WS-MBU620-COMPRESS-VALS IS EQUAL TO SPACES
128400           MOVE 'ALPHAS'         TO WS-MBU620-COMPRESS-VALS
128500                                    (WS-CUR-POS:06)
128600           ADD 06                TO WS-CUR-POS
128700        ELSE
128800           MOVE ', ALPHAS'       TO WS-MBU620-COMPRESS-VALS
128900                                    (WS-CUR-POS:8)
129000           ADD 8                 TO WS-CUR-POS
129100        END-IF
129200     END-IF.
129300*
129400     MOVE WS-MBU620-DTL-3        TO MB20WS-PRINT-LINE.
129500     PERFORM MB20PD-PRINT-2-LINES
129600        THRU MB20PD-P2L-EXIT.
129700*
129800     MOVE SPACES                 TO MB20WS-PRINT-LINE.
129900     PERFORM MB20PD-PRINT-2-LINES
130000        THRU MB20PD-P2L-EXIT.
130100*
130200     MOVE ' *** ORGANIZATION TOTALS ***'
130300                                 TO MB20WS-PRINT-LINE.
130400     PERFORM MB20PD-PRINT-2-LINES
130500        THRU MB20PD-P2L-EXIT.
130600*
130700     MOVE SPACES                 TO MB20WS-PRINT-LINE.
130800     PERFORM MB20PD-PRINT-2-LINES
130900        THRU MB20PD-P2L-EXIT.
131000*
131100     MOVE WS-REPORTED-CNTR       TO WS-TTL1-NBR-REPORTED.
131200     MOVE WS-MBU620-TTL-1        TO MB20WS-PRINT-LINE.
131300     PERFORM MB20PD-PRINT-2-LINES
131400        THRU MB20PD-P2L-EXIT.
131500*
131600     MOVE WS-CORRECTED-CNTR      TO WS-TTL2-NBR-CORRECTED.
131700     MOVE WS-MBU620-TTL-2        TO MB20WS-PRINT-LINE.
131800     PERFORM MB20PD-PRINT-2-LINES
131900        THRU MB20PD-P2L-EXIT.
132000*
132100     MOVE ZEROES                 TO WS-REPORTED-CNTR
132200                                    WS-CORRECTED-CNTR.
132300     MOVE SPACES                 TO WS-MBU620-SEARCH-VALS
132400                                    WS-MBU620-COMPRESS-VALS.
132500*
132600*
132700 A799-PR-EXIT.
132800     EXIT.
132900/
133000 A900-CLOSE-FILES SECTION.
133100 A910-CF-BEGIN.
133200*
133300     MOVE 'C1OC'                 TO SS02WS-ABEND-LOCATION.
133400     SET MMOCRB-CLOSE            TO TRUE.
133500     PERFORM MB00PD-MMOC-ACCESS  THRU MB00PD-MMOC-ACCESS-EXIT.
133600*
133700     MOVE 'C1MM'                 TO SS02WS-ABEND-LOCATION.
133800     SET MMMMRB-CLOSE            TO TRUE.
133900     PERFORM MB00PD-MMMM-ACCESS  THRU MB00PD-MMMM-ACCESS-EXIT.
134000*
134100     MOVE 'C1MP'                 TO SS02WS-ABEND-LOCATION.
134200     SET MMMPRB-CLOSE            TO TRUE.
134300     PERFORM MB00PD-MMMP-ACCESS  THRU MB00PD-MMMP-ACCESS-EXIT.
134400*
134500*
134600     IF WS-MTCC-MBU620-CORRECT IS EQUAL TO 'Y'
134700        MOVE 'C1SM'              TO SS02WS-ABEND-LOCATION
134800        SET MMSMRB-CLOSE         TO TRUE
134900        PERFORM MB00PD-MMSM-ACCESS THRU MB00PD-MMSM-ACCESS-EXIT
135000*
135100        MOVE 'C1XR'              TO SS02WS-ABEND-LOCATION
135200        SET MMXRRB-CLOSE         TO TRUE
135300        PERFORM MB00PD-MMXR-ACCESS THRU MB00PD-MMXR-ACCESS-EXIT
135400     END-IF.
135500*
135600     PERFORM MB20PD-CLOSE-PRINT-FILES
135700        THRU MB20PD-CPF-EXIT.
135800*
135900 A999-CF-EXIT.
136000     EXIT.
136100/
136200 9000-PERFORMED-ROUTINES-SECT SECTION.
136300*
136400     COPY MB20PD.
136500/
136600     COPY MB00PD REPLACING ==:MB00:== BY ==MTCC==.
136700/
136800     COPY MB00PD REPLACING ==:MB00:== BY ==MMOC==.
136900/
137000     COPY MB00PD REPLACING ==:MB00:== BY ==MMMM==.
137100/
137200     COPY MB00PD REPLACING ==:MB00:== BY ==MMMP==.
137300/
137400     COPY MB00PD REPLACING ==:MB00:== BY ==MMSM==.
137500/
137600     COPY MB00PD REPLACING ==:MB00:== BY ==MMSC==.
137700/
137800     COPY MB00PD REPLACING ==:MB00:== BY ==MMXR==.
137900/
138000     COPY MB99PD.
138100/
138200     COPY SS02PD.
138300/
138400     COPY SS07PD.
138500/
138600     COPY SS08PD.
138700/
138800     COPY SS16PD.
138900/
139000     COPY SS26PD.
139100/
139200     COPY SS27PD.
139300*
139400 9995-END-SOURCE-STATEMENTS SECTION.
139500 9999-END-OF-PROGRAM.
139600     EXIT.
