000100 IDENTIFICATION DIVISION.
000200 PROGRAM-ID. MBU6MM10.
000201*       RELEASE DATE=08/24/01.        REVISION LEVEL=08.06      * ++++++++
000202***************************************************************** ++++++++
000203*WARNING.  THIS COMPUTER PROGRAM IS PROTECTED BY COPYRIGHT LAW  * ++++++++
000204*AND INTERNATIONAL TREATIES.  UNAUTHORIZED REPRODUCTION OR      * ++++++++
000205*DISTRIBUTION OF THIS PROGRAM, OR ANY PORTION OF IT, MAY RESULT * ++++++++
000206*IN SEVERE CIVIL AND CRIMINAL PENATLIES, AND WILL BE PROSECUTED * ++++++++
000207*TO THE MAXIMUM EXTENT POSSIBLE UNDER THE LAW.                  * ++++++++
000208*COPYRIGHT 1999 PAYSYS INTERNATIONAL, INC.  ALL RIGHTS RESERVED.* ++++++++
000209***************************************************************** ++++++++
000300*****************************************************************
000400*                                                               *
000500*   V - PLUS  M E R C H A N T   B A N K C A R D   S Y S T E M   *
000600*                                                               *
000700*   MBU6MM10 - BUILD MERCHANT NON-MONETARY FROM E.X.A.M. PAGE 10*
000800*                                                               *
000900*****************************************************************
001000 ENVIRONMENT DIVISION.
001100 CONFIGURATION SECTION.
001200 SOURCE-COMPUTER.            IBM-4341.
001300 OBJECT-COMPUTER.            IBM-4341.
001400*
001500 INPUT-OUTPUT SECTION.
001600 FILE-CONTROL.
001700*
001800 DATA DIVISION.
001900 FILE SECTION.
002000/
002100 WORKING-STORAGE SECTION.
002200*
002300 01  FILLER                  PIC  X(12)      VALUE '** WS-BEG **'.
002400*
002500     COPY MBMM10.
002600     COPY MBMM10R.
002700/
002800     COPY MMEXTB REPLACING ==:MMEX:== BY ==MMEX==.
002900/
003000     COPY MMEXWS REPLACING ==:MMEX:== BY ==MMEX==.
003100/
003200     COPY SS00WS.
003300/
003400     COPY SS01WS.
003500/
003600     COPY SS02WS.
003700*
003800 01  FILLER                  PIC  X(12)      VALUE '** WS-END **'.
003900/
004000 LINKAGE SECTION.
004100     COPY MMEXRL REPLACING ==:MMEX:== BY ==MMEX==.
004200/
004300     COPY MMMMRL.
004400/
004500     COPY MMUIRL REPLACING ==:MMUI:== BY ==MMUO==.
004600/
004700     COPY MMUIRL REPLACING ==:MMUI:== BY ==MMUI==.
004800/
004900 PROCEDURE DIVISION              USING MMEX-RECORD
005000                                       MMMM-RECORD
005100                                       MMUO-RECORD
005200                                       MMUI-RECORD.
005300 A000-MAIN-LINE-SECT SECTION.
005400 A010-ML-BEGIN.
005500*
005600     MOVE LOW-VALUES             TO MMUO-RECORD.
005700     MOVE LOW-VALUES             TO MMUI-RECORD.
005800     MOVE LOW-VALUES             TO MBMM10I.
005900*
006000     PERFORM 0100-FRAUD-TABLE
006100        THRU 0199-FT-EXIT.
006200*
006300     PERFORM 0200-AVG-NBR-MONTHS
006400        THRU 0299-ANM-EXIT.
006500*
006600     PERFORM 0300-FRAUD-AMT-1
006700        THRU 0399-FA1-EXIT.
006800*
006900     PERFORM 0400-FRAUD-NBR-1
007000        THRU 0499-FN1-EXIT.
007100*
007200     PERFORM 0500-FRAUD-AMT-2
007300        THRU 0599-FA2-EXIT.
007400*
007500     PERFORM 0600-FRAUD-NBR-2
007600        THRU 0699-FN2-EXIT.
007700*
007800     PERFORM 0700-FRAUD-AMT-3
007900        THRU 0799-FA3-EXIT.
008000*
008100     PERFORM 0800-FRAUD-NBR-3
008200        THRU 0899-FN3-EXIT.
008300*
008400     PERFORM 0900-FRAUD-AMT-4
008500        THRU 0999-FA4-EXIT.
008600*
008700     PERFORM 1000-FRAUD-NBR-4
008800        THRU 1099-FN4-EXIT.
008900*
009000     PERFORM 1100-FRAUD-AMT-5
009100        THRU 1199-FA5-EXIT.
009200*
009300     PERFORM 1200-FRAUD-NBR-5
009400        THRU 1299-FN5-EXIT.
009500*
009600     PERFORM 1300-DUP-SALES-NBR-BATCH
009700        THRU 1399-DSNB-EXIT.
009800*
009900     PERFORM 1400-DUP-AUTHS-NBR-BATCH
010000        THRU 1499-DANB-EXIT.
010100*
010200     PERFORM 1500-DUP-SALES-NBR-DAY
010300        THRU 1599-DSND-EXIT.
010400*
010500     PERFORM 1600-DUP-AUTHS-NBR-DAY
010600        THRU 1699-DAND-EXIT.
010700*
010800     PERFORM 1700-DUP-SALES-AMT
010900        THRU 1799-DSA-EXIT.
011000*
011100     PERFORM 1800-DUP-AUTHS-AMT
011200        THRU 1899-DAA-EXIT.
011300*
011400*
011500     IF  MBMM10I IS EQUAL TO LOW-VALUES
011600         NEXT SENTENCE
011700     ELSE
011800         MOVE MBMM10I            TO MMUO-MAP-DATA
011900         MOVE 'MBMM'             TO MMUO-TRANID
012000         MOVE 10                 TO MMUO-CURRENT-PAGE
012100         MOVE MMMM-ORG           TO MMUO-MM-ORG
012200         MOVE MMMM-MERCHANT      TO MMUO-MM-MERCHANT
012300         MOVE LENGTH OF MBMM10I  TO MMUO-VAR-LENGTH
012400     END-IF.
012500*
012600     GO TO 9999-END-OF-PROGRAM.
012700*
012800 A999-ML-EXIT.
012900     EXIT.
013000/
013100 0000-MERCHANT-MAINT-PAGE-10 SECTION.
013200 0100-FRAUD-TABLE.
013300*
013400     SET X-MMEXTB                TO 461.
013500     PERFORM 8000-SEARCH-MMEX-MAINT
013600        THRU 8099-SMM-EXIT.
013700*
013800     IF  SS02WS-FS-NO-RECORD-FOUND
013900         GO TO 0199-FT-EXIT.
014000*
014100     PERFORM MBU600PD-EXTRACT-NUMERICS
014200        THRU MBU600PD-EN-EXIT.
014300*
014400     MOVE MMEXWS-NUMBER          TO MM10-TABLE-NBR.
014500     MOVE LENGTH OF MM10-TABLE-NBR
014600                                 TO MM10-TABLE-NBR-L.
014700*
014800 0199-FT-EXIT.
014900     EXIT.
015000/
015100 0200-AVG-NBR-MONTHS.
015200*
015300     SET X-MMEXTB                TO 462.
015400     PERFORM 8000-SEARCH-MMEX-MAINT
015500        THRU 8099-SMM-EXIT.
015600*
015700     IF  SS02WS-FS-NO-RECORD-FOUND
015800         GO TO 0299-ANM-EXIT.
015900*
016000     PERFORM MBU600PD-EXTRACT-NUMERICS
016100        THRU MBU600PD-EN-EXIT.
016200*
016300     MOVE MMMM-FRAUD-AVG-NBR-MONTHS
016400                                 TO MMEXWS-F-S18V0.
016500     MOVE MMEXWS-NUMBER          TO MMEXWS-E-S18V0.
016600*
016700     EVALUATE TRUE
016800         WHEN MMEXWS-PERCENT-ON
016900             PERFORM MBU600PD-PERCENT-CHANGE
017000                THRU MBU600PD-PC-EXIT
017100         WHEN MMEXWS-SIGN-POSITIVE
017200             PERFORM MBU600PD-INCREASE-NUMERICS
017300                THRU MBU600PD-IN-EXIT
017400         WHEN MMEXWS-SIGN-NEGATIVE
017500             PERFORM MBU600PD-DECREASE-NUMERICS
017600                THRU MBU600PD-DN-EXIT
017700         WHEN OTHER
017800             MOVE MMEXWS-NUMBER  TO MMEXWS-F-S18V0
017900     END-EVALUATE.
018000*
018100     MOVE MMEXWS-F-S18V0         TO MM10-AVERAGE-MONTHS.
018200     MOVE LENGTH OF MM10-AVERAGE-MONTHS
018300                                 TO MM10-AVERAGE-MONTHS-L.
018400*
018500 0299-ANM-EXIT.
018600     EXIT.
018700/
018800 0300-FRAUD-AMT-1.
018900*
019000     SET X-MMEXTB                TO 465.
019100     PERFORM 8000-SEARCH-MMEX-MAINT
019200        THRU 8099-SMM-EXIT.
019300*
019400     IF  SS02WS-FS-NO-RECORD-FOUND
019500         GO TO 0399-FA1-EXIT.
019600*
019700     PERFORM MBU600PD-EXTRACT-NUMERICS
019800        THRU MBU600PD-EN-EXIT.
019900*
020000     MOVE MMMM-PROJ-AMT (1)      TO MMEXWS-F-S16V2.
020100     MOVE MMEXWS-NUMBER          TO MMEXWS-E-S18V0.
020200*
020300     EVALUATE TRUE
020400         WHEN MMEXWS-PERCENT-ON
020500             PERFORM MBU600PD-PERCENT-CHANGE
020600                THRU MBU600PD-PC-EXIT
020700             PERFORM MBU600PD-AMOUNT-ROUNDING
020800                THRU MBU600PD-AR-EXIT
020900         WHEN MMEXWS-SIGN-POSITIVE
021000             PERFORM MBU600PD-INCREASE-NUMERICS
021100                THRU MBU600PD-IN-EXIT
021200         WHEN MMEXWS-SIGN-NEGATIVE
021300             PERFORM MBU600PD-DECREASE-NUMERICS
021400                THRU MBU600PD-DN-EXIT
021500         WHEN OTHER
021600             MOVE MMEXWS-NUMBER  TO MMEXWS-F-S18V0
021700     END-EVALUATE.
021800*
021900     MOVE MMEXWS-F-S16V2         TO MM10-PROJ-AMOUNT (1).
022000     MOVE LENGTH OF MM10-PROJ-AMOUNT (1)
022100                                 TO MM10-PROJ-AMOUNT-L (1).
022200*
022300 0399-FA1-EXIT.
022400     EXIT.
022500/
022600 0400-FRAUD-NBR-1.
022700*
022800     SET X-MMEXTB                TO 466.
022900     PERFORM 8000-SEARCH-MMEX-MAINT
023000        THRU 8099-SMM-EXIT.
023100*
023200     IF  SS02WS-FS-NO-RECORD-FOUND
023300         GO TO 0499-FN1-EXIT.
023400*
023500     PERFORM MBU600PD-EXTRACT-NUMERICS
023600        THRU MBU600PD-EN-EXIT.
023700*
023800     MOVE MMMM-PROJ-NBR (1)
023900                                 TO MMEXWS-F-S18V0.
024000     MOVE MMEXWS-NUMBER          TO MMEXWS-E-S18V0.
024100*
024200     EVALUATE TRUE
024300         WHEN MMEXWS-PERCENT-ON
024400             PERFORM MBU600PD-PERCENT-CHANGE
024500                THRU MBU600PD-PC-EXIT
024600         WHEN MMEXWS-SIGN-POSITIVE
024700             PERFORM MBU600PD-INCREASE-NUMERICS
024800                THRU MBU600PD-IN-EXIT
024900         WHEN MMEXWS-SIGN-NEGATIVE
025000             PERFORM MBU600PD-DECREASE-NUMERICS
025100                THRU MBU600PD-DN-EXIT
025200         WHEN OTHER
025300             MOVE MMEXWS-NUMBER  TO MMEXWS-F-S18V0
025400     END-EVALUATE.
025500*
025600     MOVE MMEXWS-F-S18V0         TO MM10-PROJ-NUMBER (1).
025700     MOVE LENGTH OF MM10-PROJ-NUMBER (1)
025800                                 TO MM10-PROJ-NUMBER-L (1).
025900*
026000 0499-FN1-EXIT.
026100     EXIT.
026200/
026300 0500-FRAUD-AMT-2.
026400*
026500     SET X-MMEXTB                TO 467.
026600     PERFORM 8000-SEARCH-MMEX-MAINT
026700        THRU 8099-SMM-EXIT.
026800*
026900     IF  SS02WS-FS-NO-RECORD-FOUND
027000         GO TO 0599-FA2-EXIT.
027100*
027200     PERFORM MBU600PD-EXTRACT-NUMERICS
027300        THRU MBU600PD-EN-EXIT.
027400*
027500     MOVE MMMM-PROJ-AMT (2)      TO MMEXWS-F-S16V2.
027600     MOVE MMEXWS-NUMBER          TO MMEXWS-E-S18V0.
027700*
027800     EVALUATE TRUE
027900         WHEN MMEXWS-PERCENT-ON
028000             PERFORM MBU600PD-PERCENT-CHANGE
028100                THRU MBU600PD-PC-EXIT
028200             PERFORM MBU600PD-AMOUNT-ROUNDING
028300                THRU MBU600PD-AR-EXIT
028400         WHEN MMEXWS-SIGN-POSITIVE
028500             PERFORM MBU600PD-INCREASE-NUMERICS
028600                THRU MBU600PD-IN-EXIT
028700         WHEN MMEXWS-SIGN-NEGATIVE
028800             PERFORM MBU600PD-DECREASE-NUMERICS
028900                THRU MBU600PD-DN-EXIT
029000         WHEN OTHER
029100             MOVE MMEXWS-NUMBER  TO MMEXWS-F-S18V0
029200     END-EVALUATE.
029300*
029400     MOVE MMEXWS-F-S16V2         TO MM10-PROJ-AMOUNT (2).
029500     MOVE LENGTH OF MM10-PROJ-AMOUNT (2)
029600                                 TO MM10-PROJ-AMOUNT-L (2).
029700*
029800 0599-FA2-EXIT.
029900     EXIT.
030000/
030100 0600-FRAUD-NBR-2.
030200*
030300     SET X-MMEXTB                TO 468.
030400     PERFORM 8000-SEARCH-MMEX-MAINT
030500        THRU 8099-SMM-EXIT.
030600*
030700     IF  SS02WS-FS-NO-RECORD-FOUND
030800         GO TO 0699-FN2-EXIT.
030900*
031000     PERFORM MBU600PD-EXTRACT-NUMERICS
031100        THRU MBU600PD-EN-EXIT.
031200*
031300     MOVE MMMM-PROJ-NBR (2)
031400                                 TO MMEXWS-F-S18V0.
031500     MOVE MMEXWS-NUMBER          TO MMEXWS-E-S18V0.
031600*
031700     EVALUATE TRUE
031800         WHEN MMEXWS-PERCENT-ON
031900             PERFORM MBU600PD-PERCENT-CHANGE
032000                THRU MBU600PD-PC-EXIT
032100         WHEN MMEXWS-SIGN-POSITIVE
032200             PERFORM MBU600PD-INCREASE-NUMERICS
032300                THRU MBU600PD-IN-EXIT
032400         WHEN MMEXWS-SIGN-NEGATIVE
032500             PERFORM MBU600PD-DECREASE-NUMERICS
032600                THRU MBU600PD-DN-EXIT
032700         WHEN OTHER
032800             MOVE MMEXWS-NUMBER  TO MMEXWS-F-S18V0
032900     END-EVALUATE.
033000*
033100     MOVE MMEXWS-F-S18V0         TO MM10-PROJ-NUMBER (2).
033200     MOVE LENGTH OF MM10-PROJ-NUMBER (2)
033300                                 TO MM10-PROJ-NUMBER-L (2).
033400*
033500 0699-FN2-EXIT.
033600     EXIT.
033700/
033800 0700-FRAUD-AMT-3.
033900*
034000     SET X-MMEXTB                TO 469.
034100     PERFORM 8000-SEARCH-MMEX-MAINT
034200        THRU 8099-SMM-EXIT.
034300*
034400     IF  SS02WS-FS-NO-RECORD-FOUND
034500         GO TO 0799-FA3-EXIT.
034600*
034700     PERFORM MBU600PD-EXTRACT-NUMERICS
034800        THRU MBU600PD-EN-EXIT.
034900*
035000     MOVE MMMM-PROJ-AMT (3)      TO MMEXWS-F-S16V2.
035100     MOVE MMEXWS-NUMBER          TO MMEXWS-E-S18V0.
035200*
035300     EVALUATE TRUE
035400         WHEN MMEXWS-PERCENT-ON
035500             PERFORM MBU600PD-PERCENT-CHANGE
035600                THRU MBU600PD-PC-EXIT
035700             PERFORM MBU600PD-AMOUNT-ROUNDING
035800                THRU MBU600PD-AR-EXIT
035900         WHEN MMEXWS-SIGN-POSITIVE
036000             PERFORM MBU600PD-INCREASE-NUMERICS
036100                THRU MBU600PD-IN-EXIT
036200         WHEN MMEXWS-SIGN-NEGATIVE
036300             PERFORM MBU600PD-DECREASE-NUMERICS
036400                THRU MBU600PD-DN-EXIT
036500         WHEN OTHER
036600             MOVE MMEXWS-NUMBER  TO MMEXWS-F-S18V0
036700     END-EVALUATE.
036800*
036900     MOVE MMEXWS-F-S16V2         TO MM10-PROJ-AMOUNT (3).
037000     MOVE LENGTH OF MM10-PROJ-AMOUNT (3)
037100                                 TO MM10-PROJ-AMOUNT-L (3).
037200*
037300 0799-FA3-EXIT.
037400     EXIT.
037500/
037600 0800-FRAUD-NBR-3.
037700*
037800     SET X-MMEXTB                TO 470.
037900     PERFORM 8000-SEARCH-MMEX-MAINT
038000        THRU 8099-SMM-EXIT.
038100*
038200     IF  SS02WS-FS-NO-RECORD-FOUND
038300         GO TO 0899-FN3-EXIT.
038400*
038500     PERFORM MBU600PD-EXTRACT-NUMERICS
038600        THRU MBU600PD-EN-EXIT.
038700*
038800     MOVE MMMM-PROJ-NBR (3)
038900                                 TO MMEXWS-F-S18V0.
039000     MOVE MMEXWS-NUMBER          TO MMEXWS-E-S18V0.
039100*
039200     EVALUATE TRUE
039300         WHEN MMEXWS-PERCENT-ON
039400             PERFORM MBU600PD-PERCENT-CHANGE
039500                THRU MBU600PD-PC-EXIT
039600         WHEN MMEXWS-SIGN-POSITIVE
039700             PERFORM MBU600PD-INCREASE-NUMERICS
039800                THRU MBU600PD-IN-EXIT
039900         WHEN MMEXWS-SIGN-NEGATIVE
040000             PERFORM MBU600PD-DECREASE-NUMERICS
040100                THRU MBU600PD-DN-EXIT
040200         WHEN OTHER
040300             MOVE MMEXWS-NUMBER  TO MMEXWS-F-S18V0
040400     END-EVALUATE.
040500*
040600     MOVE MMEXWS-F-S18V0         TO MM10-PROJ-NUMBER (3).
040700     MOVE LENGTH OF MM10-PROJ-NUMBER (3)
040800                                 TO MM10-PROJ-NUMBER-L (3).
040900*
041000 0899-FN3-EXIT.
041100     EXIT.
041200/
041300 0900-FRAUD-AMT-4.
041400*
041500     SET X-MMEXTB                TO 471.
041600     PERFORM 8000-SEARCH-MMEX-MAINT
041700        THRU 8099-SMM-EXIT.
041800*
041900     IF  SS02WS-FS-NO-RECORD-FOUND
042000         GO TO 0999-FA4-EXIT.
042100*
042200     PERFORM MBU600PD-EXTRACT-NUMERICS
042300        THRU MBU600PD-EN-EXIT.
042400*
042500     MOVE MMMM-PROJ-AMT (4)      TO MMEXWS-F-S16V2.
042600     MOVE MMEXWS-NUMBER          TO MMEXWS-E-S18V0.
042700*
042800     EVALUATE TRUE
042900         WHEN MMEXWS-PERCENT-ON
043000             PERFORM MBU600PD-PERCENT-CHANGE
043100                THRU MBU600PD-PC-EXIT
043200             PERFORM MBU600PD-AMOUNT-ROUNDING
043300                THRU MBU600PD-AR-EXIT
043400         WHEN MMEXWS-SIGN-POSITIVE
043500             PERFORM MBU600PD-INCREASE-NUMERICS
043600                THRU MBU600PD-IN-EXIT
043700         WHEN MMEXWS-SIGN-NEGATIVE
043800             PERFORM MBU600PD-DECREASE-NUMERICS
043900                THRU MBU600PD-DN-EXIT
044000         WHEN OTHER
044100             MOVE MMEXWS-NUMBER  TO MMEXWS-F-S18V0
044200     END-EVALUATE.
044300*
044400     MOVE MMEXWS-F-S16V2         TO MM10-PROJ-AMOUNT (4).
044500     MOVE LENGTH OF MM10-PROJ-AMOUNT (4)
044600                                 TO MM10-PROJ-AMOUNT-L (4).
044700*
044800 0999-FA4-EXIT.
044900     EXIT.
045000/
045100 1000-FRAUD-NBR-4.
045200*
045300     SET X-MMEXTB                TO 472.
045400     PERFORM 8000-SEARCH-MMEX-MAINT
045500        THRU 8099-SMM-EXIT.
045600*
045700     IF  SS02WS-FS-NO-RECORD-FOUND
045800         GO TO 1099-FN4-EXIT.
045900*
046000     PERFORM MBU600PD-EXTRACT-NUMERICS
046100        THRU MBU600PD-EN-EXIT.
046200*
046300     MOVE MMMM-PROJ-NBR (4)
046400                                 TO MMEXWS-F-S18V0.
046500     MOVE MMEXWS-NUMBER          TO MMEXWS-E-S18V0.
046600*
046700     EVALUATE TRUE
046800         WHEN MMEXWS-PERCENT-ON
046900             PERFORM MBU600PD-PERCENT-CHANGE
047000                THRU MBU600PD-PC-EXIT
047100         WHEN MMEXWS-SIGN-POSITIVE
047200             PERFORM MBU600PD-INCREASE-NUMERICS
047300                THRU MBU600PD-IN-EXIT
047400         WHEN MMEXWS-SIGN-NEGATIVE
047500             PERFORM MBU600PD-DECREASE-NUMERICS
047600                THRU MBU600PD-DN-EXIT
047700         WHEN OTHER
047800             MOVE MMEXWS-NUMBER  TO MMEXWS-F-S18V0
047900     END-EVALUATE.
048000*
048100     MOVE MMEXWS-F-S18V0         TO MM10-PROJ-NUMBER (4).
048200     MOVE LENGTH OF MM10-PROJ-NUMBER (4)
048300                                 TO MM10-PROJ-NUMBER-L (4).
048400*
048500 1099-FN4-EXIT.
048600     EXIT.
048700/
048800 1100-FRAUD-AMT-5.
048900*
049000     SET X-MMEXTB                TO 473.
049100     PERFORM 8000-SEARCH-MMEX-MAINT
049200        THRU 8099-SMM-EXIT.
049300*
049400     IF  SS02WS-FS-NO-RECORD-FOUND
049500         GO TO 1199-FA5-EXIT.
049600*
049700     PERFORM MBU600PD-EXTRACT-NUMERICS
049800        THRU MBU600PD-EN-EXIT.
049900*
050000     MOVE MMMM-PROJ-AMT (5)      TO MMEXWS-F-S16V2.
050100     MOVE MMEXWS-NUMBER          TO MMEXWS-E-S18V0.
050200*
050300     EVALUATE TRUE
050400         WHEN MMEXWS-PERCENT-ON
050500             PERFORM MBU600PD-PERCENT-CHANGE
050600                THRU MBU600PD-PC-EXIT
050700             PERFORM MBU600PD-AMOUNT-ROUNDING
050800                THRU MBU600PD-AR-EXIT
050900         WHEN MMEXWS-SIGN-POSITIVE
051000             PERFORM MBU600PD-INCREASE-NUMERICS
051100                THRU MBU600PD-IN-EXIT
051200         WHEN MMEXWS-SIGN-NEGATIVE
051300             PERFORM MBU600PD-DECREASE-NUMERICS
051400                THRU MBU600PD-DN-EXIT
051500         WHEN OTHER
051600             MOVE MMEXWS-NUMBER  TO MMEXWS-F-S18V0
051700     END-EVALUATE.
051800*
051900     MOVE MMEXWS-F-S16V2         TO MM10-PROJ-AMOUNT (5).
052000     MOVE LENGTH OF MM10-PROJ-AMOUNT (5)
052100                                 TO MM10-PROJ-AMOUNT-L (5).
052200*
052300 1199-FA5-EXIT.
052400     EXIT.
052500/
052600 1200-FRAUD-NBR-5.
052700*
052800     SET X-MMEXTB                TO 474.
052900     PERFORM 8000-SEARCH-MMEX-MAINT
053000        THRU 8099-SMM-EXIT.
053100*
053200     IF  SS02WS-FS-NO-RECORD-FOUND
053300         GO TO 1299-FN5-EXIT.
053400*
053500     PERFORM MBU600PD-EXTRACT-NUMERICS
053600        THRU MBU600PD-EN-EXIT.
053700*
053800     MOVE MMMM-PROJ-NBR (5)
053900                                 TO MMEXWS-F-S18V0.
054000     MOVE MMEXWS-NUMBER          TO MMEXWS-E-S18V0.
054100*
054200     EVALUATE TRUE
054300         WHEN MMEXWS-PERCENT-ON
054400             PERFORM MBU600PD-PERCENT-CHANGE
054500                THRU MBU600PD-PC-EXIT
054600         WHEN MMEXWS-SIGN-POSITIVE
054700             PERFORM MBU600PD-INCREASE-NUMERICS
054800                THRU MBU600PD-IN-EXIT
054900         WHEN MMEXWS-SIGN-NEGATIVE
055000             PERFORM MBU600PD-DECREASE-NUMERICS
055100                THRU MBU600PD-DN-EXIT
055200         WHEN OTHER
055300             MOVE MMEXWS-NUMBER  TO MMEXWS-F-S18V0
055400     END-EVALUATE.
055500*
055600     MOVE MMEXWS-F-S18V0         TO MM10-PROJ-NUMBER (5).
055700     MOVE LENGTH OF MM10-PROJ-NUMBER (5)
055800                                 TO MM10-PROJ-NUMBER-L (5).
055900*
056000 1299-FN5-EXIT.
056100     EXIT.
056200/
056300 1300-DUP-SALES-NBR-BATCH.
056400*
056500     SET X-MMEXTB                TO 463.
056600     PERFORM 8000-SEARCH-MMEX-MAINT
056700        THRU 8099-SMM-EXIT.
056800*
056900     IF  SS02WS-FS-NO-RECORD-FOUND
057000         GO TO 1399-DSNB-EXIT.
057100*
057200     PERFORM MBU600PD-EXTRACT-NUMERICS
057300        THRU MBU600PD-EN-EXIT.
057400*
057500     MOVE MMMM-DUP-SALES-BATCH-NBR-C-H
057600                                 TO MMEXWS-F-S18V0.
057700     MOVE MMEXWS-NUMBER          TO MMEXWS-E-S18V0.
057800*
057900     EVALUATE TRUE
058000         WHEN MMEXWS-PERCENT-ON
058100             PERFORM MBU600PD-PERCENT-CHANGE
058200                THRU MBU600PD-PC-EXIT
058300         WHEN MMEXWS-SIGN-POSITIVE
058400             PERFORM MBU600PD-INCREASE-NUMERICS
058500                THRU MBU600PD-IN-EXIT
058600         WHEN MMEXWS-SIGN-NEGATIVE
058700             PERFORM MBU600PD-DECREASE-NUMERICS
058800                THRU MBU600PD-DN-EXIT
058900         WHEN OTHER
059000             MOVE MMEXWS-NUMBER  TO MMEXWS-F-S18V0
059100     END-EVALUATE.
059200*
059300     MOVE MMEXWS-F-S18V0         TO MM10-DUP-SALES-BATCH.
059400     MOVE LENGTH OF MM10-DUP-SALES-BATCH
059500                                 TO MM10-DUP-SALES-BATCH.
059600*
059700 1399-DSNB-EXIT.
059800     EXIT.
059900/
060000 1400-DUP-AUTHS-NBR-BATCH.
060100*
060200     SET X-MMEXTB                TO 558.
060300     PERFORM 8000-SEARCH-MMEX-MAINT
060400        THRU 8099-SMM-EXIT.
060500*
060600     IF  SS02WS-FS-NO-RECORD-FOUND
060700         GO TO 1499-DANB-EXIT.
060800*
060900     PERFORM MBU600PD-EXTRACT-NUMERICS
061000        THRU MBU600PD-EN-EXIT.
061100*
061200     MOVE MMMM-DUP-AUTHS-BATCH-NBR-C-H
061300                                 TO MMEXWS-F-S18V0.
061400     MOVE MMEXWS-NUMBER          TO MMEXWS-E-S18V0.
061500*
061600     EVALUATE TRUE
061700         WHEN MMEXWS-PERCENT-ON
061800             PERFORM MBU600PD-PERCENT-CHANGE
061900                THRU MBU600PD-PC-EXIT
062000         WHEN MMEXWS-SIGN-POSITIVE
062100             PERFORM MBU600PD-INCREASE-NUMERICS
062200                THRU MBU600PD-IN-EXIT
062300         WHEN MMEXWS-SIGN-NEGATIVE
062400             PERFORM MBU600PD-DECREASE-NUMERICS
062500                THRU MBU600PD-DN-EXIT
062600         WHEN OTHER
062700             MOVE MMEXWS-NUMBER  TO MMEXWS-F-S18V0
062800     END-EVALUATE.
062900*
063000     MOVE MMEXWS-F-S18V0         TO MM10-DUP-AUTHS-BATCH.
063100     MOVE LENGTH OF MM10-DUP-AUTHS-BATCH
063200                                 TO MM10-DUP-AUTHS-BATCH.
063300*
063400 1499-DANB-EXIT.
063500     EXIT.
063600/
063700 1500-DUP-SALES-NBR-DAY.
063800*
063900     SET X-MMEXTB                TO 464.
064000     PERFORM 8000-SEARCH-MMEX-MAINT
064100        THRU 8099-SMM-EXIT.
064200*
064300     IF  SS02WS-FS-NO-RECORD-FOUND
064400         GO TO 1599-DSND-EXIT.
064500*
064600     PERFORM MBU600PD-EXTRACT-NUMERICS
064700        THRU MBU600PD-EN-EXIT.
064800*
064900     MOVE MMMM-DUP-SALES-DAY-NBR-C-H
065000                                 TO MMEXWS-F-S18V0.
065100     MOVE MMEXWS-NUMBER          TO MMEXWS-E-S18V0.
065200*
065300     EVALUATE TRUE
065400         WHEN MMEXWS-PERCENT-ON
065500             PERFORM MBU600PD-PERCENT-CHANGE
065600                THRU MBU600PD-PC-EXIT
065700         WHEN MMEXWS-SIGN-POSITIVE
065800             PERFORM MBU600PD-INCREASE-NUMERICS
065900                THRU MBU600PD-IN-EXIT
066000         WHEN MMEXWS-SIGN-NEGATIVE
066100             PERFORM MBU600PD-DECREASE-NUMERICS
066200                THRU MBU600PD-DN-EXIT
066300         WHEN OTHER
066400             MOVE MMEXWS-NUMBER  TO MMEXWS-F-S18V0
066500     END-EVALUATE.
066600*
066700     MOVE MMEXWS-F-S18V0         TO MM10-DUP-SALES-DAY.
066800     MOVE LENGTH OF MM10-DUP-SALES-DAY
066900                                 TO MM10-DUP-SALES-DAY.
067000*
067100 1599-DSND-EXIT.
067200     EXIT.
067300/
067400 1600-DUP-AUTHS-NBR-DAY.
067500*
067600     SET X-MMEXTB                TO 559.
067700     PERFORM 8000-SEARCH-MMEX-MAINT
067800        THRU 8099-SMM-EXIT.
067900*
068000     IF  SS02WS-FS-NO-RECORD-FOUND
068100         GO TO 1699-DAND-EXIT.
068200*
068300     PERFORM MBU600PD-EXTRACT-NUMERICS
068400        THRU MBU600PD-EN-EXIT.
068500*
068600     MOVE MMMM-DUP-AUTHS-DAY-NBR-C-H
068700                                 TO MMEXWS-F-S18V0.
068800     MOVE MMEXWS-NUMBER          TO MMEXWS-E-S18V0.
068900*
069000     EVALUATE TRUE
069100         WHEN MMEXWS-PERCENT-ON
069200             PERFORM MBU600PD-PERCENT-CHANGE
069300                THRU MBU600PD-PC-EXIT
069400         WHEN MMEXWS-SIGN-POSITIVE
069500             PERFORM MBU600PD-INCREASE-NUMERICS
069600                THRU MBU600PD-IN-EXIT
069700         WHEN MMEXWS-SIGN-NEGATIVE
069800             PERFORM MBU600PD-DECREASE-NUMERICS
069900                THRU MBU600PD-DN-EXIT
070000         WHEN OTHER
070100             MOVE MMEXWS-NUMBER  TO MMEXWS-F-S18V0
070200     END-EVALUATE.
070300*
070400     MOVE MMEXWS-F-S18V0         TO MM10-DUP-AUTHS-DAY.
070500     MOVE LENGTH OF MM10-DUP-AUTHS-DAY
070600                                 TO MM10-DUP-AUTHS-DAY.
070700*
070800 1699-DAND-EXIT.
070900     EXIT.
071000/
071100 1700-DUP-SALES-AMT.
071200*
071300     SET X-MMEXTB                TO 557.
071400     PERFORM 8000-SEARCH-MMEX-MAINT
071500        THRU 8099-SMM-EXIT.
071600*
071700     IF  SS02WS-FS-NO-RECORD-FOUND
071800         GO TO 1799-DSA-EXIT.
071900*
072000     PERFORM MBU600PD-EXTRACT-NUMERICS
072100        THRU MBU600PD-EN-EXIT.
072200*
072300     MOVE MMMM-DUP-SALES-DAY-AMT-C-H
072400                                 TO MMEXWS-F-S16V2.
072500     MOVE MMEXWS-NUMBER          TO MMEXWS-E-S18V0.
072600*
072700     EVALUATE TRUE
072800         WHEN MMEXWS-PERCENT-ON
072900             PERFORM MBU600PD-PERCENT-CHANGE
073000                THRU MBU600PD-PC-EXIT
073100             PERFORM MBU600PD-AMOUNT-ROUNDING
073200                THRU MBU600PD-AR-EXIT
073300         WHEN MMEXWS-SIGN-POSITIVE
073400             PERFORM MBU600PD-INCREASE-NUMERICS
073500                THRU MBU600PD-IN-EXIT
073600         WHEN MMEXWS-SIGN-NEGATIVE
073700             PERFORM MBU600PD-DECREASE-NUMERICS
073800                THRU MBU600PD-DN-EXIT
073900         WHEN OTHER
074000             MOVE MMEXWS-NUMBER  TO MMEXWS-F-S18V0
074100     END-EVALUATE.
074200*
074300     MOVE MMEXWS-F-S16V2         TO MM10-DUP-SALES-AMT.
074400     MOVE LENGTH OF MM10-DUP-SALES-AMT
074500                                 TO MM10-DUP-SALES-AMT.
074600*
074700 1799-DSA-EXIT.
074800     EXIT.
074900/
075000 1800-DUP-AUTHS-AMT.
075100*
075200     SET X-MMEXTB                TO 560.
075300     PERFORM 8000-SEARCH-MMEX-MAINT
075400        THRU 8099-SMM-EXIT.
075500*
075600     IF  SS02WS-FS-NO-RECORD-FOUND
075700         GO TO 1899-DAA-EXIT.
075800*
075900     PERFORM MBU600PD-EXTRACT-NUMERICS
076000        THRU MBU600PD-EN-EXIT.
076100*
076200     MOVE MMMM-DUP-AUTHS-DAY-AMT-C-H
076300                                 TO MMEXWS-F-S16V2.
076400     MOVE MMEXWS-NUMBER          TO MMEXWS-E-S18V0.
076500*
076600     EVALUATE TRUE
076700         WHEN MMEXWS-PERCENT-ON
076800             PERFORM MBU600PD-PERCENT-CHANGE
076900                THRU MBU600PD-PC-EXIT
077000             PERFORM MBU600PD-AMOUNT-ROUNDING
077100                THRU MBU600PD-AR-EXIT
077200         WHEN MMEXWS-SIGN-POSITIVE
077300             PERFORM MBU600PD-INCREASE-NUMERICS
077400                THRU MBU600PD-IN-EXIT
077500         WHEN MMEXWS-SIGN-NEGATIVE
077600             PERFORM MBU600PD-DECREASE-NUMERICS
077700                THRU MBU600PD-DN-EXIT
077800         WHEN OTHER
077900             MOVE MMEXWS-NUMBER  TO MMEXWS-F-S18V0
078000     END-EVALUATE.
078100*
078200     MOVE MMEXWS-F-S16V2         TO MM10-DUP-AUTHS-AMT.
078300     MOVE LENGTH OF MM10-DUP-AUTHS-AMT
078400                                 TO MM10-DUP-AUTHS-AMT.
078500*
078600 1899-DAA-EXIT.
078700     EXIT.
078800/
078900 8000-SEARCH-MMEX-MAINT SECTION.
079000 8001-SMM-BEGIN.
079100*
079200     SET X-MMEX-MAINT            TO 1.
079300     SEARCH MMEX-MAINT-CRITERIA VARYING X-MMEX-MAINT
079400         AT END
079500             SET SS02WS-FS-NO-RECORD-FOUND
079600                                 TO TRUE
079700         WHEN MMEX-MAINT-FILE-ID(X-MMEX-MAINT) IS EQUAL TO SPACES
079800             SET SS02WS-FS-NO-RECORD-FOUND
079900                                 TO TRUE
080000         WHEN MMEX-MAINT-FIELD-CODE (X-MMEX-MAINT)
080100              IS EQUAL TO MMEXTB-FIELD-CODE (X-MMEXTB)
080200             SET SS02WS-FS-SUCCESSFUL
080300                                 TO TRUE.
080400*
080500 8099-SMM-EXIT.
080600     EXIT.
080700/
080800 9000-PERFORMED-ROUTINES-SECT SECTION.
080900     COPY SS07PD.
081000/
081100     COPY SS08PD.
081200/
081300     COPY SS26PD.
081400/
081500     COPY SS27PD.
081600/
081700     COPY MBU600PD.
081800*
081900 9995-END-SOURCE-STATEMENTS SECTION.
082000 9999-END-OF-PROGRAM.
082100     GOBACK.
