000100 IDENTIFICATION DIVISION.
000200 PROGRAM-ID. MBU6MM16.
000201*       RELEASE DATE=08/24/01.        REVISION LEVEL=08.06      * ++++++++
000202***************************************************************** ++++++++
000203*WARNING.  THIS COMPUTER PROGRAM IS PROTECTED BY COPYRIGHT LAW  * ++++++++
000204*AND INTERNATIONAL TREATIES.  UNAUTHORIZED REPRODUCTION OR      * ++++++++
000205*DISTRIBUTION OF THIS PROGRAM, OR ANY PORTION OF IT, MAY RESULT * ++++++++
000206*IN SEVERE CIVIL AND CRIMINAL PENATLIES, AND WILL BE PROSECUTED * ++++++++
000207*TO THE MAXIMUM EXTENT POSSIBLE UNDER THE LAW.                  * ++++++++
000208*COPYRIGHT 1999 PAYSYS INTERNATIONAL, INC.  ALL RIGHTS RESERVED.* ++++++++
000209***************************************************************** ++++++++
000300*****************************************************************
000400*                                                               *
000500*   V - PLUS  M E R C H A N T   B A N K C A R D   S Y S T E M   *
000600*                                                               *
000700*   MBU6MM16 - BUILD MERCHANT NON-MONETARY FROM E.X.A.M. PAGE 16*
000800*                                                               *
000900*****************************************************************
001000 ENVIRONMENT DIVISION.
001100 CONFIGURATION SECTION.
001200 SOURCE-COMPUTER.            IBM-4341.
001300 OBJECT-COMPUTER.            IBM-4341.
001400*
001500 INPUT-OUTPUT SECTION.
001600 FILE-CONTROL.
001700*
001800 DATA DIVISION.
001900 FILE SECTION.
002000/
002100 WORKING-STORAGE SECTION.
002200*
002300 01  FILLER                  PIC  X(12)      VALUE '** WS-BEG **'.
002400*
002500     COPY MBMM16.
002600     COPY MBMM16R.
002700/
002800     COPY MMEXTB REPLACING ==:MMEX:== BY ==MMEX==.
002900/
003000     COPY MMEXWS REPLACING ==:MMEX:== BY ==MMEX==.
003100/
003200     COPY SS00WS.
003300/
003400     COPY SS01WS.
003500/
003600     COPY SS02WS.
003700*
003800 01  FILLER                  PIC  X(12)      VALUE '** WS-END **'.
003900/
004000 LINKAGE SECTION.
004100     COPY MMEXRL REPLACING ==:MMEX:== BY ==MMEX==.
004200/
004300     COPY MMMMRL.
004400/
004500     COPY MMMPRL.
004600/
004700     COPY MMUIRL REPLACING ==:MMUI:== BY ==MMUO==.
004800/
004900     COPY MMUIRL REPLACING ==:MMUI:== BY ==MMUI==.
005000/
005100 PROCEDURE DIVISION              USING MMEX-RECORD
005200                                       MMMM-RECORD
005300                                       MMMP-RECORD
005400                                       MMUO-RECORD
005500                                       MMUI-RECORD.
005600 A000-MAIN-LINE-SECT SECTION.
005700 A010-ML-BEGIN.
005800*
005900     MOVE LOW-VALUES             TO MMUO-RECORD.
006000     MOVE LOW-VALUES             TO MMUI-RECORD.
006100     MOVE LOW-VALUES             TO MBMM16I.
006200*
006300     PERFORM 0100-PRODUCT-STATUS
006400        THRU 0199-PS-EXIT.
006500*
006600     PERFORM 0200-EFF-DATE
006700        THRU 0299-ED-EXIT.
006800*
006900     PERFORM 0300-SHORT-DESC
007000        THRU 0399-SD-EXIT.
007100*
007200     PERFORM 0400-SETTLE-FLAG
007300        THRU 0499-SF-EXIT.
007400*
007500     PERFORM 0500-SOURCE
007600        THRU 0599-S-EXIT.
007700*
007800     PERFORM 0600-DISC-RATE-TABLE
007900        THRU 0699-DRT-EXIT.
008000*
008100     PERFORM 0700-DISC-FEE-BASE
008200        THRU 0799-DFB-EXIT.
008300*
008400     PERFORM 0800-PART-RATE-TABLE
008500        THRU 0899-PRT-EXIT.
008600*
008700     PERFORM 0900-PART-FEE-BASE
008800        THRU 0999-PFB-EXIT.
008900*
009000     PERFORM 1000-RESV-1-RATE-TABLE
009100        THRU 1099-R1RT-EXIT.
009200*
009300     PERFORM 1100-RESV-1-FEE-BASE
009400        THRU 1199-R1FB-EXIT.
009500*
009600     PERFORM 1200-RESV-2-RATE-TABLE
009700        THRU 1299-R2RT-EXIT.
009800*
009900     PERFORM 1300-RESV-2-FEE-BASE
010000        THRU 1399-R2FB-EXIT.
010100*
010200     PERFORM 1400-RESV-3-RATE-TABLE
010300        THRU 1499-R3RT-EXIT.
010400*
010500     PERFORM 1500-RESV-3-FEE-BASE
010600        THRU 1599-R3FB-EXIT.
010700*
010800     PERFORM 1600-RESV-4-RATE-TABLE
010900        THRU 1699-R4RT-EXIT.
011000*
011100     PERFORM 1700-RESV-4-FEE-BASE
011200        THRU 1799-R4FB-EXIT.
011300*
011400     PERFORM 1800-INTCHG-FEE-BASE
011500        THRU 1899-IFB-EXIT.
011600*
011700     PERFORM 1900-USER-CODE
011800        THRU 1999-UC-EXIT.
011900*
012000     IF  MBMM16I IS EQUAL TO LOW-VALUES
012100         NEXT SENTENCE
012200     ELSE
012300         MOVE MBMM16I            TO MMUO-MAP-DATA
012400         MOVE 'MBMM'             TO MMUO-TRANID
012500         MOVE 16                 TO MMUO-CURRENT-PAGE
012600         MOVE MMMP-ORG           TO MMUO-MM-ORG
012700         MOVE MMMP-MERCHANT      TO MMUO-MM-MERCHANT
012800         MOVE MMMP-PRODUCT       TO MMUO-MM-PRODUCT
012900         MOVE LENGTH OF MBMM16I  TO MMUO-VAR-LENGTH
013000     END-IF.
013100*
013200     GO TO 9999-END-OF-PROGRAM.
013300*
013400 A999-ML-EXIT.
013500     EXIT.
013600/
013700 0000-PRODUCT-MAINT-PAGE-16 SECTION.
013800 0100-PRODUCT-STATUS.
013900*
014000     SET X-MMEXTB                TO 608.
014100     PERFORM 8000-SEARCH-MMEX-MAINT
014200        THRU 8099-SMM-EXIT.
014300*
014400     IF  SS02WS-FS-NO-RECORD-FOUND
014500         GO TO 0199-PS-EXIT.
014600*
014700     MOVE MMEX-MAINT-FIELD-VALUE (X-MMEX-MAINT)
014800                                 TO MM16-PROD-STATUS.
014900     MOVE LENGTH OF MM16-PROD-STATUS
015000                                 TO MM16-PROD-STATUS-L.
015100*
015200 0199-PS-EXIT.
015300     EXIT.
015400/
015500 0200-EFF-DATE.
015600*
015700     SET X-MMEXTB                TO 609.
015800     PERFORM 8000-SEARCH-MMEX-MAINT
015900        THRU 8099-SMM-EXIT.
016000*
016100     IF  SS02WS-FS-NO-RECORD-FOUND
016200         GO TO 0299-ED-EXIT.
016300*
016400     PERFORM MBU600PD-EXTRACT-NUMERICS
016500        THRU MBU600PD-EN-EXIT.
016600*
016700     MOVE MMEXWS-NUMBER          TO MM16-PROD-EFF-DATE.
016800     MOVE LENGTH OF MM16-PROD-EFF-DATE
016900                                 TO MM16-PROD-EFF-DATE-L.
017000*
017100 0299-ED-EXIT.
017200     EXIT.
017300/
017400 0300-SHORT-DESC.
017500*
017600     SET X-MMEXTB                TO 610.
017700     PERFORM 8000-SEARCH-MMEX-MAINT
017800        THRU 8099-SMM-EXIT.
017900*
018000     IF  SS02WS-FS-NO-RECORD-FOUND
018100         GO TO 0399-SD-EXIT.
018200*
018300     MOVE MMEX-MAINT-FIELD-VALUE (X-MMEX-MAINT)
018400                                 TO MM16-PROD-SHORT-DESC.
018500     MOVE LENGTH OF MM16-PROD-SHORT-DESC
018600                                 TO MM16-PROD-SHORT-DESC-L.
018700*
018800 0399-SD-EXIT.
018900     EXIT.
019000/
019100 0400-SETTLE-FLAG.
019200*
019300     SET X-MMEXTB                TO 611.
019400     PERFORM 8000-SEARCH-MMEX-MAINT
019500        THRU 8099-SMM-EXIT.
019600*
019700     IF  SS02WS-FS-NO-RECORD-FOUND
019800         GO TO 0499-SF-EXIT.
019900*
020000     MOVE MMEX-MAINT-FIELD-VALUE (X-MMEX-MAINT)
020100                                 TO MM16-PROD-SETTLE-FLAG.
020200     MOVE LENGTH OF MM16-PROD-SETTLE-FLAG
020300                                 TO MM16-PROD-SETTLE-FLAG-L.
020400*
020500 0499-SF-EXIT.
020600     EXIT.
020700/
020800 0500-SOURCE.
020900*
021000     SET X-MMEXTB                TO 612.
021100     PERFORM 8000-SEARCH-MMEX-MAINT
021200        THRU 8099-SMM-EXIT.
021300*
021400     IF  SS02WS-FS-NO-RECORD-FOUND
021500         GO TO 0599-S-EXIT.
021600*
021700     MOVE MMEX-MAINT-FIELD-VALUE (X-MMEX-MAINT)
021800                                 TO MM16-PROD-SOURCE.
021900     MOVE LENGTH OF MM16-PROD-SOURCE
022000                                 TO MM16-PROD-SOURCE-L.
022100*
022200 0599-S-EXIT.
022300     EXIT.
022400/
022500 0600-DISC-RATE-TABLE.
022600*
022700     SET X-MMEXTB                TO 613.
022800     PERFORM 8000-SEARCH-MMEX-MAINT
022900        THRU 8099-SMM-EXIT.
023000*
023100     IF  SS02WS-FS-NO-RECORD-FOUND
023200         GO TO 0699-DRT-EXIT.
023300*
023400     PERFORM MBU600PD-EXTRACT-NUMERICS
023500        THRU MBU600PD-EN-EXIT.
023600*
023700     MOVE MMEXWS-NUMBER          TO MM16-PROD-DISC-RATE-TBL.
023800     MOVE LENGTH OF MM16-PROD-DISC-RATE-TBL
023900                                 TO MM16-PROD-DISC-RATE-TBL-L.
024000*
024100 0699-DRT-EXIT.
024200     EXIT.
024300/
024400 0700-DISC-FEE-BASE.
024500*
024600     SET X-MMEXTB                TO 614.
024700     PERFORM 8000-SEARCH-MMEX-MAINT
024800        THRU 8099-SMM-EXIT.
024900*
025000     IF  SS02WS-FS-NO-RECORD-FOUND
025100         GO TO 0799-DFB-EXIT.
025200*
025300     MOVE MMEX-MAINT-FIELD-VALUE (X-MMEX-MAINT)
025400                                 TO MM16-PROD-DISC-FEE-BASE.
025500     MOVE LENGTH OF MM16-PROD-DISC-FEE-BASE
025600                                 TO MM16-PROD-DISC-FEE-BASE-L.
025700*
025800 0799-DFB-EXIT.
025900     EXIT.
026000/
026100 0800-PART-RATE-TABLE.
026200*
026300     SET X-MMEXTB                TO 615.
026400     PERFORM 8000-SEARCH-MMEX-MAINT
026500        THRU 8099-SMM-EXIT.
026600*
026700     IF  SS02WS-FS-NO-RECORD-FOUND
026800         GO TO 0899-PRT-EXIT.
026900*
027000     PERFORM MBU600PD-EXTRACT-NUMERICS
027100        THRU MBU600PD-EN-EXIT.
027200*
027300     MOVE MMEXWS-NUMBER          TO MM16-PROD-PART-RATE-TBL.
027400     MOVE LENGTH OF MM16-PROD-PART-RATE-TBL
027500                                 TO MM16-PROD-PART-RATE-TBL-L.
027600*
027700 0899-PRT-EXIT.
027800     EXIT.
027900/
028000 0900-PART-FEE-BASE.
028100*
028200     SET X-MMEXTB                TO 616.
028300     PERFORM 8000-SEARCH-MMEX-MAINT
028400        THRU 8099-SMM-EXIT.
028500*
028600     IF  SS02WS-FS-NO-RECORD-FOUND
028700         GO TO 0999-PFB-EXIT.
028800*
028900     MOVE MMEX-MAINT-FIELD-VALUE (X-MMEX-MAINT)
029000                                 TO MM16-PROD-PART-FEE-BASE.
029100     MOVE LENGTH OF MM16-PROD-PART-FEE-BASE
029200                                 TO MM16-PROD-PART-FEE-BASE-L.
029300*
029400 0999-PFB-EXIT.
029500     EXIT.
029600/
029700 1000-RESV-1-RATE-TABLE.
029800*
029900     SET X-MMEXTB                TO 617.
030000     PERFORM 8000-SEARCH-MMEX-MAINT
030100        THRU 8099-SMM-EXIT.
030200*
030300     IF  SS02WS-FS-NO-RECORD-FOUND
030400         GO TO 1099-R1RT-EXIT.
030500*
030600     PERFORM MBU600PD-EXTRACT-NUMERICS
030700        THRU MBU600PD-EN-EXIT.
030800*
030900     MOVE MMEXWS-NUMBER          TO MM16-PROD-RESV-1-RATE-TBL.
031000     MOVE LENGTH OF MM16-PROD-RESV-1-RATE-TBL
031100                                 TO MM16-PROD-RESV-1-RATE-TBL-L.
031200*
031300 1099-R1RT-EXIT.
031400     EXIT.
031500/
031600 1100-RESV-1-FEE-BASE.
031700*
031800     SET X-MMEXTB                TO 618.
031900     PERFORM 8000-SEARCH-MMEX-MAINT
032000        THRU 8099-SMM-EXIT.
032100*
032200     IF  SS02WS-FS-NO-RECORD-FOUND
032300         GO TO 1199-R1FB-EXIT.
032400*
032500     MOVE MMEX-MAINT-FIELD-VALUE (X-MMEX-MAINT)
032600                                 TO MM16-PROD-RESV-1-FEE-BASE.
032700     MOVE LENGTH OF MM16-PROD-RESV-1-FEE-BASE
032800                                 TO MM16-PROD-RESV-1-FEE-BASE-L.
032900*
033000 1199-R1FB-EXIT.
033100     EXIT.
033200/
033300 1200-RESV-2-RATE-TABLE.
033400*
033500     SET X-MMEXTB                TO 619.
033600     PERFORM 8000-SEARCH-MMEX-MAINT
033700        THRU 8099-SMM-EXIT.
033800*
033900     IF  SS02WS-FS-NO-RECORD-FOUND
034000         GO TO 1299-R2RT-EXIT.
034100*
034200     PERFORM MBU600PD-EXTRACT-NUMERICS
034300        THRU MBU600PD-EN-EXIT.
034400*
034500     MOVE MMEXWS-NUMBER          TO MM16-PROD-RESV-2-RATE-TBL.
034600     MOVE LENGTH OF MM16-PROD-RESV-2-RATE-TBL
034700                                 TO MM16-PROD-RESV-2-RATE-TBL-L.
034800*
034900 1299-R2RT-EXIT.
035000     EXIT.
035100/
035200 1300-RESV-2-FEE-BASE.
035300*
035400     SET X-MMEXTB                TO 620.
035500     PERFORM 8000-SEARCH-MMEX-MAINT
035600        THRU 8099-SMM-EXIT.
035700*
035800     IF  SS02WS-FS-NO-RECORD-FOUND
035900         GO TO 1399-R2FB-EXIT.
036000*
036100     MOVE MMEX-MAINT-FIELD-VALUE (X-MMEX-MAINT)
036200                                 TO MM16-PROD-RESV-2-FEE-BASE.
036300     MOVE LENGTH OF MM16-PROD-RESV-2-FEE-BASE
036400                                 TO MM16-PROD-RESV-2-FEE-BASE-L.
036500*
036600 1399-R2FB-EXIT.
036700     EXIT.
036800/
036900 1400-RESV-3-RATE-TABLE.
037000*
037100     SET X-MMEXTB                TO 621.
037200     PERFORM 8000-SEARCH-MMEX-MAINT
037300        THRU 8099-SMM-EXIT.
037400*
037500     IF  SS02WS-FS-NO-RECORD-FOUND
037600         GO TO 1499-R3RT-EXIT.
037700*
037800     PERFORM MBU600PD-EXTRACT-NUMERICS
037900        THRU MBU600PD-EN-EXIT.
038000*
038100     MOVE MMEXWS-NUMBER          TO MM16-PROD-RESV-3-RATE-TBL.
038200     MOVE LENGTH OF MM16-PROD-RESV-3-RATE-TBL
038300                                 TO MM16-PROD-RESV-3-RATE-TBL-L.
038400*
038500 1499-R3RT-EXIT.
038600     EXIT.
038700/
038800 1500-RESV-3-FEE-BASE.
038900*
039000     SET X-MMEXTB                TO 622.
039100     PERFORM 8000-SEARCH-MMEX-MAINT
039200        THRU 8099-SMM-EXIT.
039300*
039400     IF  SS02WS-FS-NO-RECORD-FOUND
039500         GO TO 1599-R3FB-EXIT.
039600*
039700     MOVE MMEX-MAINT-FIELD-VALUE (X-MMEX-MAINT)
039800                                 TO MM16-PROD-RESV-3-FEE-BASE.
039900     MOVE LENGTH OF MM16-PROD-RESV-3-FEE-BASE
040000                                 TO MM16-PROD-RESV-3-FEE-BASE-L.
040100*
040200 1599-R3FB-EXIT.
040300     EXIT.
040400/
040500 1600-RESV-4-RATE-TABLE.
040600*
040700     SET X-MMEXTB                TO 623.
040800     PERFORM 8000-SEARCH-MMEX-MAINT
040900        THRU 8099-SMM-EXIT.
041000*
041100     IF  SS02WS-FS-NO-RECORD-FOUND
041200         GO TO 1699-R4RT-EXIT.
041300*
041400     PERFORM MBU600PD-EXTRACT-NUMERICS
041500        THRU MBU600PD-EN-EXIT.
041600*
041700     MOVE MMEXWS-NUMBER          TO MM16-PROD-RESV-4-RATE-TBL.
041800     MOVE LENGTH OF MM16-PROD-RESV-4-RATE-TBL
041900                                 TO MM16-PROD-RESV-4-RATE-TBL-L.
042000*
042100 1699-R4RT-EXIT.
042200     EXIT.
042300/
042400 1700-RESV-4-FEE-BASE.
042500*
042600     SET X-MMEXTB                TO 624.
042700     PERFORM 8000-SEARCH-MMEX-MAINT
042800        THRU 8099-SMM-EXIT.
042900*
043000     IF  SS02WS-FS-NO-RECORD-FOUND
043100         GO TO 1799-R4FB-EXIT.
043200*
043300     MOVE MMEX-MAINT-FIELD-VALUE (X-MMEX-MAINT)
043400                                 TO MM16-PROD-RESV-4-FEE-BASE.
043500     MOVE LENGTH OF MM16-PROD-RESV-4-FEE-BASE
043600                                 TO MM16-PROD-RESV-4-FEE-BASE-L.
043700*
043800 1799-R4FB-EXIT.
043900     EXIT.
044000/
044100 1800-INTCHG-FEE-BASE.
044200*
044300     SET X-MMEXTB                TO 625.
044400     PERFORM 8000-SEARCH-MMEX-MAINT
044500        THRU 8099-SMM-EXIT.
044600*
044700     IF  SS02WS-FS-NO-RECORD-FOUND
044800         GO TO 1899-IFB-EXIT.
044900*
045000     MOVE MMEX-MAINT-FIELD-VALUE (X-MMEX-MAINT)
045100                                 TO MM16-PROD-INTCHG-FEE-BASE.
045200     MOVE LENGTH OF MM16-PROD-INTCHG-FEE-BASE
045300                                 TO MM16-PROD-INTCHG-FEE-BASE-L.
045400*
045500 1899-IFB-EXIT.
045600     EXIT.
045700/
045800 1900-USER-CODE.
045900*
046000     SET X-MMEXTB                TO 626.
046100     PERFORM 8000-SEARCH-MMEX-MAINT
046200        THRU 8099-SMM-EXIT.
046300*
046400     IF  SS02WS-FS-NO-RECORD-FOUND
046500         GO TO 1999-UC-EXIT.
046600*
046700     MOVE MMEX-MAINT-FIELD-VALUE (X-MMEX-MAINT)
046800                                 TO MM16-PROD-USER-CODE.
046900     MOVE LENGTH OF MM16-PROD-USER-CODE
047000                                 TO MM16-PROD-USER-CODE-L.
047100*
047200 1999-UC-EXIT.
047300     EXIT.
047400/
047500 8000-SEARCH-MMEX-MAINT SECTION.
047600 8001-SMM-BEGIN.
047700*
047800     SET X-MMEX-MAINT            TO 1.
047900     SEARCH MMEX-MAINT-CRITERIA VARYING X-MMEX-MAINT
048000         AT END
048100             SET SS02WS-FS-NO-RECORD-FOUND
048200                                 TO TRUE
048300         WHEN MMEX-MAINT-FILE-ID(X-MMEX-MAINT) IS EQUAL TO SPACES
048400             SET SS02WS-FS-NO-RECORD-FOUND
048500                                 TO TRUE
048600         WHEN MMEX-MAINT-FIELD-CODE (X-MMEX-MAINT)
048700              IS EQUAL TO MMEXTB-FIELD-CODE (X-MMEXTB)
048800             SET SS02WS-FS-SUCCESSFUL
048900                                 TO TRUE.
049000*
049100 8099-SMM-EXIT.
049200     EXIT.
049300/
049400 9000-PERFORMED-ROUTINES-SECT SECTION.
049500     COPY SS07PD.
049600/
049700     COPY SS08PD.
049800/
049900     COPY SS26PD.
050000/
050100     COPY SS27PD.
050200/
050300     COPY MBU600PD.
050400*
050500 9995-END-SOURCE-STATEMENTS SECTION.
050600 9999-END-OF-PROGRAM.
050700     GOBACK.
