000100 IDENTIFICATION DIVISION.
000200 PROGRAM-ID. MBU902.
000201*       RELEASE DATE=08/24/01.        REVISION LEVEL=08.06      *
000202*****************************************************************
000203*WARNING.  THIS COMPUTER PROGRAM IS PROTECTED BY COPYRIGHT LAW  *
000204*AND INTERNATIONAL TREATIES.  UNAUTHORIZED REPRODUCTION OR      *
000205*DISTRIBUTION OF THIS PROGRAM, OR ANY PORTION OF IT, MAY RESULT *
000206*IN SEVERE CIVIL AND CRIMINAL PENATLIES, AND WILL BE PROSECUTED *
000207*TO THE MAXIMUM EXTENT POSSIBLE UNDER THE LAW.                  *
000208*COPYRIGHT 1999 PAYSYS INTERNATIONAL, INC.  ALL RIGHTS RESERVED.*
000209*****************************************************************
000300*****************************************************************
000400*                                                               *
000500*       MBU902 - SYSTEM SOURCE DEFINITIONS FILE DISPLAY (MMSS)  *
000600*                                                               *
000700*****************************************************************
000800 ENVIRONMENT DIVISION.
000900 CONFIGURATION SECTION.
001000 SOURCE-COMPUTER.   IBM-4341.
001100 OBJECT-COMPUTER.   IBM-4341.
001200/
001300 INPUT-OUTPUT SECTION.
001400 FILE-CONTROL.
001500/
001600 DATA DIVISION.
001700 FILE SECTION.
001800 WORKING-STORAGE SECTION.
001900*
002000 01  FILLER                  PIC  X(12)      VALUE '** WS-BEG **'.
002100*
002200     COPY MB00RB REPLACING ==:MB00:== BY ==MTCC==.
002300/
002400     COPY MB00RB REPLACING ==:MB00:== BY ==MMSC==.
002500/
002600     COPY MB00RB REPLACING ==:MB00:== BY ==MMSS==.
002700/
002800     COPY MBU999WS.
002900/
003000     COPY MB00RB REPLACING ==:MB00:== BY ==MBMF==.
003100/
003200     COPY MTCCRL REPLACING ==:MTCC:== BY ==MTCC==.
003300/
003400     COPY MMSCRL.
003500/
003600     COPY MMSSRL.
003700/
003800     COPY MBMFRL.
003900/
004000     COPY MTCCIO REPLACING ==:MTCC:== BY ==MTCC==.
004100/
004200     COPY MMSCIO.
004300/
004400     COPY MMSSIO.
004500/
004600     COPY MBMFIO.
004700/
004800     COPY MB00WS.
004900/
005000     COPY MB20WS.
005100/
005200     COPY MB99WS.
005300/
005400     COPY SS00WS.
005500/
005600     COPY SS01WS.
005700/
005800     COPY SS02WS.
005900/
006000 01  WS-WORK-AREAS.
006100     03  WS-PROG-ID          PIC  X(06)      VALUE 'MBU902'.
006200     03  WS-CARD-READ-SW     PIC  X(01)      VALUE 'N'.
006300*
006400     03  WS-BACKUP-OR-MASTER PIC  X(06)      VALUE SPACES.
006500         88  WS-BACKUP                       VALUE 'BACKUP'.
006600         88  WS-MASTER                       VALUE 'MASTER'.
006700*
006800     COPY MB21WS.
006900*
007000 01  FILLER                  PIC  X(12)      VALUE '** WS-END **'.
007100/
007200 PROCEDURE DIVISION.
007300*
007400 A000-DRIVER.
007500*
007600     MOVE 'MBU902'               TO SS02WS-ABEND-PROG-ID
007700                                    MBU999WS-PROGRAM-ID.
007800*
007900     CALL MB00WS-MBU999CC        USING MBU999WS-AREA.
008000*
008100     MOVE 'MB000000'             TO MB20WS-SH-RPT-ID.
008200     MOVE 'T902'                 TO MB20WS-SH-INTERNAL-RPT-ID.
008300     MOVE '   SYSTEM SOURCE DEFS FILE    '
008400                                 TO MB20WS-SH-RPT-NAME.
008500     MOVE SPACES                 TO MB20WS-SH-LIT-1
008600                                    MB20WS-SH-LIT-5
008700                                    MB20WS-SH-L4
008800                                    MB20WS-SH-L5
008900                                    MB20WS-SH-L6.
009000     PERFORM MB21PD-PAP-RESET-INDEXES
009100                                 THRU MB21PD-PAP-EXIT.
009200*
009300 A100-OPEN-FILES.
009400*
009500     MOVE SPACES                 TO MB21WS-PRINT-PAGE.
009600     MOVE 'O1CC'                 TO SS02WS-ABEND-LOCATION.
009700     MOVE SS02WS-END-OF-FILE     TO MTCCRB-PERM-STATUS-1.
009800     SET MTCCRB-OPEN-INPUT       TO TRUE.
009900     PERFORM MB00PD-MTCC-ACCESS  THRU MB00PD-MTCC-ACCESS-EXIT.
010000*
010100     MOVE 'O1SC'                 TO SS02WS-ABEND-LOCATION.
010200     SET MMSCRB-OPEN-INPUT       TO TRUE.
010300     PERFORM MB00PD-MMSC-ACCESS  THRU MB00PD-MMSC-ACCESS-EXIT.
010400*
010500     MOVE 'R1SC'                 TO SS02WS-ABEND-LOCATION.
010600     SET  MMSCRB-READ-SEQ        TO TRUE.
010700     PERFORM MB00PD-MMSC-ACCESS  THRU MB00PD-MMSC-ACCESS-EXIT.
010800*
010900     MOVE 'MMSC'                 TO MB99WS-FILE-ID.
011000*
011100     IF  MMSCIO-HEADER
011200         NEXT SENTENCE
011300     ELSE
011400         PERFORM MB99PD-MISSING-HEADER-ABEND
011500            THRU MB99PD-MHA-EXIT.
011600*
011700     MOVE MMSCIO-RECORD          TO MMSC-RECORD.
011710     MOVE MMSC-DATE-FORMAT       TO SS01WS-DATE-FORMAT.
011800     MOVE MMSC-TODAYS-JULIAN     TO SS01WS-JULIAN.
011900     PERFORM SS26PD-NUMERICALLY-EDIT-DATE
012000                                 THRU SS26PD-NED-EXIT.
012100     MOVE SS01WS-XX-XX-YYYY  TO MB20WS-SH-FILE-DATE.
012200     MOVE MMSC-TIME-STAMP        TO SS01WS-TIME-HHMMSS.
012300     PERFORM SS27PD-NUMERICALLY-EDIT-TIME
012400                                 THRU SS27PD-NET-EXIT.
012500     MOVE SS01WS-HH-MM-SS        TO MB20WS-SH-PROC-TIME .
012600*
012700     MOVE MMSC-FORM              TO MB20WS-FORM-CODE.
012800     MOVE MMSC-FICHE-FLAG        TO MB20WS-FICHE-CODE.
012900     MOVE MMSC-LINES-PER-PAGE    TO MB20WS-LINES-PER-PAGE.
013000     MOVE 99                     TO MB20WS-LINE-LIMIT.
013100     COMPUTE MB21WS-LIN-LIMIT    =  MMSC-LINES-PER-PAGE - 4.
013200     MOVE MMSC-SCREEN-HEADER     TO MB20WS-SH-SYSTEM.
013400*
013500     MOVE 'R1CC'                 TO SS02WS-ABEND-LOCATION.
013600     SET MTCCRB-READ-SEQ         TO TRUE.
013700     PERFORM MB00PD-MTCC-ACCESS  THRU MB00PD-MTCC-ACCESS-EXIT.
013800*
013900     IF  SS02WS-FS-END-OF-FILE
014000         GO TO A400-CHECK-READ-SWITCH.
014100*
014200     IF  MTCCIO-PROGRAM-ID  IS NOT EQUAL TO WS-PROG-ID
014300         GO TO A200-PROGRAM-CONTROL
014400     END-IF.
014500*
014600     MOVE MTCCIO-CARD-DATA       TO MTCC-RECORD.
014700*
014800     IF  MTCC-MBU9XX-BACKUP
014900         MOVE 'BACKUP'           TO WS-BACKUP-OR-MASTER
015000         MOVE 'O1MF'             TO SS02WS-ABEND-LOCATION
015100         SET MBMFRB-OPEN-INPUT   TO TRUE
015200         PERFORM MB00PD-MBMF-ACCESS THRU MB00PD-MBMF-ACCESS-EXIT
015300         MOVE 'R1MF'             TO SS02WS-ABEND-LOCATION
015400         SET MBMFRB-READ-SEQ     TO TRUE
015500         MOVE SS02WS-NO-RECORD-FOUND
015600                                 TO MBMFRB-PERM-STATUS-3
015700         MOVE SS02WS-END-OF-FILE
015800                                 TO MBMFRB-PERM-STATUS-4
015900         PERFORM MB00PD-MBMF-ACCESS THRU MB00PD-MBMF-ACCESS-EXIT
016000     ELSE
016100         MOVE 'O1SS'             TO SS02WS-ABEND-LOCATION
016200         SET MMSSRB-OPEN-INPUT-DYN
016300                                 TO TRUE
016400         PERFORM MB00PD-MMSS-ACCESS THRU MB00PD-MMSS-ACCESS-EXIT
016500         MOVE 'R1SS'             TO SS02WS-ABEND-LOCATION
016600         SET MMSSRB-READ-SEQ     TO TRUE
016700         MOVE SS02WS-NO-RECORD-FOUND
016800                                 TO MMSSRB-PERM-STATUS-3
016900         MOVE SS02WS-END-OF-FILE
017000                                 TO MMSSRB-PERM-STATUS-4
017100         PERFORM MB00PD-MMSS-ACCESS THRU MB00PD-MMSS-ACCESS-EXIT
017200         GO TO A130-PRINT-HR-RECORD.
017300*
017400     MOVE 'MBMF'                 TO MB99WS-FILE-ID.
017500*
017600     IF  MBMFIO-FILE-IS-HEADER
017700         NEXT SENTENCE
017800     ELSE
017900         PERFORM MB99PD-MISSING-HEADER-ABEND
018000            THRU MB99PD-MHA-EXIT.
018100*
018200     MOVE MBMFIO-RECORD          TO MBMF-RECORD.
018300*
018400     SET X-MBMF-FILE             TO 1.
018500*
018600 A110-SEARCH-HEADER-TABLE-LOOP.
018700*
018800     IF  X-MBMF-FILE IS GREATER THAN 75
018900         MOVE 'MMSS'             TO MB99WS-FILE-ID
019000         PERFORM MB99PD-NOT-ON-BACKUP
019100            THRU MB99PD-NOB-EXIT.
019200*
019300     IF  MBMF-MBU020-ENTRY (X-MBMF-FILE) IS EQUAL TO 'SS'
019400         CONTINUE
019500     ELSE
019600         SET X-MBMF-FILE         UP BY 1
019700         GO TO A110-SEARCH-HEADER-TABLE-LOOP
019800     END-IF.
019900*
020000 A120-READ-MBMF-LOOP.
020100*
020200     MOVE 'R2MF'                 TO SS02WS-ABEND-LOCATION.
020300     SET MBMFRB-READ-SEQ         TO TRUE.
020400     MOVE SS02WS-NO-RECORD-FOUND
020500                                 TO MBMFRB-PERM-STATUS-3.
020600     MOVE SS02WS-END-OF-FILE     TO MBMFRB-PERM-STATUS-4.
020700     PERFORM MB00PD-MBMF-ACCESS  THRU MB00PD-MBMF-ACCESS-EXIT.
020800*
020900     IF  SS02WS-FS-END-OF-FILE
021000         GO TO A200-PROGRAM-CONTROL
021100     END-IF.
021200*
021300     IF  MBMFIO-FILE IS NOT EQUAL TO 'SS'
021400         GO TO A120-READ-MBMF-LOOP
021500     END-IF.
021600*
021700 A130-PRINT-HR-RECORD.
021800*
021900     IF  WS-BACKUP
022000         MOVE MBMFIO-VAR-DATA    TO MMSSIO-RECORD
022100     END-IF.
022200*
022300     MOVE 'MMSS'                 TO MB99WS-FILE-ID.
022400*
022500     IF  MMSSIO-HEADER
022600         NEXT SENTENCE
022700     ELSE
022800         PERFORM MB99PD-MISSING-HEADER-ABEND
022900            THRU MB99PD-MHA-EXIT.
023000*
023100     IF  MMSSIO-ORG IS EQUAL TO ZEROES
023200     AND MMSSIO-SEQ IS EQUAL TO ZEROES
023300         PERFORM B200-PRINT-HEADER
023400                                 THRU B200-PH-EXIT
023500     END-IF.
023600*
023700 A200-PROGRAM-CONTROL.
023800*
023900     IF  MTCC-MBU9XX-BACKUP OR MTCC-MBU9XX-MASTER
024000         MOVE MTCC-MBU9XX-OPTION TO WS-BACKUP-OR-MASTER
024100     ELSE
024200         IF  WS-BACKUP-OR-MASTER IS EQUAL TO SPACES
024300             MOVE 'MASTER'       TO WS-BACKUP-OR-MASTER
024400             GO TO A210-PC-BY-FIRST-READ.
024500*
024600     MOVE 'R2CC'                 TO SS02WS-ABEND-LOCATION.
024700     SET MTCCRB-READ-SEQ         TO TRUE.
024800     PERFORM MB00PD-MTCC-ACCESS  THRU MB00PD-MTCC-ACCESS-EXIT.
024900*
025000     IF  SS02WS-FS-END-OF-FILE
025100         GO TO A400-CHECK-READ-SWITCH
025200     END-IF.
025300*
025400 A210-PC-BY-FIRST-READ.
025500*
025600     IF  MTCCIO-PROGRAM-ID  IS NOT EQUAL TO WS-PROG-ID
025700         GO TO A200-PROGRAM-CONTROL.
025800*
025900     MOVE MTCCIO-CARD-DATA       TO MTCC-RECORD.
026000*
026100 A300-RANGE-CARD.
026200*
026300     MOVE 'Y'                    TO WS-CARD-READ-SW.
026400     INSPECT MTCC-MBU902-BEG-X   REPLACING ALL SPACE BY ZERO.
026500*
026600     IF  MTCC-MBU902-END-X IS EQUAL TO SPACES
026700         MOVE MTCC-MBU902-BEG-X  TO MTCC-MBU902-END-X
026800     END-IF.
026900*
027000     INSPECT MTCC-MBU902-END-X   REPLACING ALL SPACE BY ZERO.
027100*
027200     IF  MTCC-MBU902-END-X IS LESS THAN MTCC-MBU902-BEG-X
027400         GO TO A500-CONTROL-CARD-ERROR
027500     END-IF.
027600*
027700     IF  WS-BACKUP
027800         GO TO A350-READ-NEXT-MBMF.
027900*
028000 A350-READ-NEXT.
028100*
028200     MOVE 'R2SS'                 TO SS02WS-ABEND-LOCATION.
028300     SET MMSSRB-READ-SEQ         TO TRUE.
028400     PERFORM MB00PD-MMSS-ACCESS  THRU MB00PD-MMSS-ACCESS-EXIT.
028500*
028600     IF  SS02WS-FS-END-OF-FILE
028700         IF  MB21WS-PRINT-PAGE IS EQUAL TO SPACES
028800             GO TO A200-PROGRAM-CONTROL
028900         ELSE
029000             PERFORM MB21PD-PRINT-A-PAGE
029100                                 THRU MB21PD-PAP-EXIT
029200             GO TO A200-PROGRAM-CONTROL.
029300*
029400     IF  MMSSIO-TRAILER
029500         GO TO A350-READ-NEXT.
029600*
029700     MOVE MMSSIO-RECORD          TO MMSS-RECORD.
029800*
029900     IF  MMSS-ADD-COMPLETED
030000         PERFORM B100-PSR-BEGIN  THRU B100-PSR-EXIT
030100         GO TO A350-READ-NEXT
030200     ELSE
030300         GO TO A350-READ-NEXT.
030400*
030500 A350-READ-NEXT-MBMF.
030600*
030700     MOVE 'R3MF'                 TO SS02WS-ABEND-LOCATION.
030800     SET MBMFRB-READ-SEQ         TO TRUE.
030900     PERFORM MB00PD-MBMF-ACCESS  THRU MB00PD-MBMF-ACCESS-EXIT.
031000*
031100     IF  SS02WS-FS-NO-RECORD-FOUND
031200         GO TO A500-CONTROL-CARD-ERROR.
031300*
031400     IF  SS02WS-FS-END-OF-FILE
031500         IF  MB21WS-PRINT-PAGE IS EQUAL TO SPACES
031600             GO TO A200-PROGRAM-CONTROL
031700         ELSE
031800             PERFORM MB21PD-PRINT-A-PAGE
031900                                 THRU MB21PD-PAP-EXIT
032000             GO TO A200-PROGRAM-CONTROL.
032100*
032200     IF  MBMFIO-FILE-IS-MMSS
032300         NEXT SENTENCE
032400     ELSE
032500         GO TO A350-READ-NEXT-MBMF.
032600*
032700     MOVE MBMFIO-VAR-DATA        TO MMSS-RECORD.
032800*
032900     IF  MMSS-TRAILER
033000         GO TO A350-READ-NEXT-MBMF.
033100*
033200     IF  MMSS-ADD-COMPLETED
033300         NEXT SENTENCE
033400     ELSE
033500         GO TO A350-READ-NEXT-MBMF.
033600*
033700     PERFORM B100-PSR-BEGIN      THRU B100-PSR-EXIT.
033800     GO TO A350-READ-NEXT-MBMF.
033900*
034000 A400-CHECK-READ-SWITCH.
034100*
034200     IF  WS-CARD-READ-SW IS EQUAL TO 'N'
034300         MOVE '*** NO CONTROL CARDS ***'
034400                                 TO MB21WS-PP-COL44 (5 1)
034500         PERFORM MB21PD-PRINT-A-PAGE
034600                                 THRU MB21PD-PAP-EXIT.
034700*
034800     GO TO A600-CLOSE-FILES.
034900*
035000 A500-CONTROL-CARD-ERROR.
035100*
035200     MOVE MTCC-RECORD            TO MB21WS-PP-LINE (4).
035300     MOVE 'CONTROL CARD ERROR'   TO MB21WS-PP-COL44 (4 3).
035400     PERFORM MB21PD-PRINT-A-PAGE THRU MB21PD-PAP-EXIT.
035500     MOVE SPACE                  TO MB21WS-PP-LINE (4).
035600     MOVE SPACE                  TO MB21WS-PP-COL44 (4 3).
035700     GO TO A200-PROGRAM-CONTROL.
035800*
035900 A600-CLOSE-FILES.
036000*
036100     EVALUATE TRUE
036200         WHEN  WS-BACKUP
036300             MOVE 'C1MF'         TO SS02WS-ABEND-LOCATION
036400             SET MBMFRB-CLOSE    TO TRUE
036500             PERFORM MB00PD-MBMF-ACCESS
036600                                 THRU MB00PD-MBMF-ACCESS-EXIT
036700         WHEN  WS-MASTER
036800             MOVE 'C1SS'         TO SS02WS-ABEND-LOCATION
036900             SET MMSSRB-CLOSE    TO TRUE
037000             PERFORM MB00PD-MMSS-ACCESS
037100                                 THRU MB00PD-MMSS-ACCESS-EXIT
037200         WHEN  OTHER
037300             CONTINUE
037400     END-EVALUATE.
037500*
037600     MOVE 'C1SC'                 TO SS02WS-ABEND-LOCATION.
037700     SET MMSCRB-CLOSE            TO TRUE.
037800     PERFORM MB00PD-MMSC-ACCESS  THRU MB00PD-MMSC-ACCESS-EXIT.
037900*
038000     MOVE 'C1CC'                 TO SS02WS-ABEND-LOCATION.
038100     SET MTCCRB-CLOSE            TO TRUE.
038200     PERFORM MB00PD-MTCC-ACCESS  THRU MB00PD-MTCC-ACCESS-EXIT.
038300*
038400     PERFORM MB20PD-CLOSE-PRINT-FILES
038500                                 THRU MB20PD-CPF-EXIT.
038600     STOP RUN.
038700/
038800 B100-PSR-BEGIN.
038900*
039000     MOVE 'SYS SOURCE RECORD(MMSS)'
039100                                 TO MB21WS-NAME.
039200     PERFORM MB21PD-INSERT-A-COLUMN
039300                                 THRU MB21PD-IAC-EXIT.
039400*
039500     MOVE 'ORG'                  TO MB21WS-NAME.
039600     MOVE MMSS-ORG               TO MB21WS-3V0.
039700     PERFORM MB21PD-INSERT-A-COLUMN
039800                                 THRU MB21PD-IAC-EXIT.
039900*
040000     MOVE 'SEQ'                  TO MB21WS-NAME.
040100     MOVE MMSS-SEQ               TO MB21WS-5V0.
040200     PERFORM MB21PD-INSERT-A-COLUMN
040300                                 THRU MB21PD-IAC-EXIT.
040400*
040500     MOVE 'REC-STATUS'           TO MB21WS-NAME.
040600     MOVE MMSS-REC-STATUS        TO MB21WS-1V0.
040700     PERFORM MB21PD-INSERT-A-COLUMN
040800                                 THRU MB21PD-IAC-EXIT.
040900*
041000     MOVE 'ADD-STATUS'           TO MB21WS-NAME.
041100     MOVE MMSS-ONLINE-STATUS     TO MB21WS-2V0.
041200     PERFORM MB21PD-INSERT-A-COLUMN
041300                                 THRU MB21PD-IAC-EXIT 2 TIMES.
041400*
041500     MOVE 'LAST-MAINT-DATE'      TO MB21WS-NAME.
041600     MOVE MMSS-LAST-MAINT-DATE   TO SS01WS-JULIAN.
041700     PERFORM SS26PD-NUMERICALLY-EDIT-DATE THRU SS26PD-NED-EXIT.
041800     MOVE MMSS-LAST-MAINT-DATE   TO MB21WS-JULIAN.
041900     MOVE SS01WS-XX-XX-YYYY      TO MB21WS-GREG.
042000     INSPECT MB21WS-JULIAN       REPLACING ALL ',' BY '-'.
042100     PERFORM MB21PD-INSERT-A-COLUMN
042200                                 THRU MB21PD-IAC-EXIT.
042300*
042400     MOVE 'LAST-MAINT-OPER'      TO MB21WS-NAME.
042500     MOVE MMSS-LAST-MAINT-OPER   TO MB21WS-3X.
042600     PERFORM MB21PD-INSERT-A-COLUMN
042700                                 THRU MB21PD-IAC-EXIT 2 TIMES.
042800*
042900     MOVE '*------------ SOURCE DATA -------------*'
043000                                 TO MB21WS-PRINT-WORK-AREA.
043100     PERFORM MB21PD-INSERT-A-COLUMN
043200                                 THRU MB21PD-IAC-EXIT.
043300*
043400     MOVE 'SOURCE-CODE'          TO MB21WS-NAME.
043500     MOVE MMSS-SOURCE-CODE       TO MB21WS-5X.
043600     PERFORM MB21PD-INSERT-A-COLUMN
043700                                 THRU MB21PD-IAC-EXIT.
043800*
043900     MOVE 'SOURCE-DESC'          TO MB21WS-NAME.
044000     MOVE MMSS-SOURCE-DESC       TO MB21WS-16X.
044100     PERFORM MB21PD-INSERT-A-COLUMN
044200                                 THRU MB21PD-IAC-EXIT.
044300*
044400     MOVE 'SOURCE-PRODUCT'       TO MB21WS-NAME.
044500     MOVE MMSS-SOURCE-PRODUCT    TO MB21WS-2V0.
044600     PERFORM MB21PD-INSERT-A-COLUMN
044700                                 THRU MB21PD-IAC-EXIT.
044800*
044900     MOVE 'SOURCE-ORG'           TO MB21WS-NAME.
045000     MOVE MMSS-SOURCE-ORG        TO MB21WS-3V0.
045100     PERFORM MB21PD-INSERT-A-COLUMN
045200                                 THRU MB21PD-IAC-EXIT.
045300*
045400     MOVE 'SOURCE-LOGO'          TO MB21WS-NAME.
045500     MOVE MMSS-SOURCE-LOGO       TO MB21WS-3V0.
045600     PERFORM MB21PD-INSERT-A-COLUMN
045700                                 THRU MB21PD-IAC-EXIT.
045800*
045900     MOVE 'SOURCE-FROM-PREFIX'   TO MB21WS-NAME.
046000     MOVE MMSS-SOURCE-FROM-PREFIX
046100                                 TO MB21WS-11X.
046200     PERFORM MB21PD-INSERT-A-COLUMN
046300                                 THRU MB21PD-IAC-EXIT.
046400*
046500     MOVE 'SOURCE-CRITERIA-OPER' TO MB21WS-NAME.
046600     MOVE MMSS-SOURCE-CRITERIA-OPER
046700                                 TO MB21WS-X.
046800     PERFORM MB21PD-INSERT-A-COLUMN
046900                                 THRU MB21PD-IAC-EXIT.
047000*
047100     MOVE 'SOURCE-TO-PREFIX'     TO MB21WS-NAME.
047200     MOVE MMSS-SOURCE-TO-PREFIX  TO MB21WS-11X.
047300     PERFORM MB21PD-INSERT-A-COLUMN
047400                                 THRU MB21PD-IAC-EXIT.
047500*
047510     SET X-MB21WS-LIN            TO 1.
047512     SET X-MB21WS-LIN            DOWN BY 1.
047514     SET X-MB21WS-COL            UP BY 1.
047516*
047600 B100-PSR-EXIT.
047700     EXIT.
047800*
047900 B200-PRINT-HEADER.
048000*
048100     MOVE 'SYS SOURCE HDR RECORD(MMSS)'
048200                                 TO MB21WS-NAME.
048300     PERFORM MB21PD-INSERT-A-COLUMN
048400                                 THRU MB21PD-IAC-EXIT.
048500*
048600     MOVE 'ORG'                  TO MB21WS-NAME.
048700     MOVE MMSSIO-ORG             TO MB21WS-3V0.
048800     PERFORM MB21PD-INSERT-A-COLUMN
048900                                 THRU MB21PD-IAC-EXIT.
049000*
049100     MOVE 'SEQUENCE'             TO MB21WS-NAME.
049200     MOVE MMSSIO-SEQ             TO MB21WS-5V0.
049300     PERFORM MB21PD-INSERT-A-COLUMN
049400                                 THRU MB21PD-IAC-EXIT.
049500*
049600     MOVE 'DATE-STAMP'           TO MB21WS-NAME.
049700     MOVE MMSSIO-DATE-STAMP      TO SS01WS-JULIAN.
049800     PERFORM SS26PD-NUMERICALLY-EDIT-DATE THRU SS26PD-NED-EXIT.
049900     MOVE MMSSIO-DATE-STAMP      TO MB21WS-JULIAN.
050000     MOVE SS01WS-XX-XX-YYYY      TO MB21WS-GREG.
050100     INSPECT MB21WS-JULIAN       REPLACING ALL ',' BY '-'.
050200     PERFORM MB21PD-INSERT-A-COLUMN
050300                                 THRU MB21PD-IAC-EXIT.
050400*
050500     MOVE 'TIME-STAMP'           TO MB21WS-NAME.
050600     MOVE MMSSIO-TIME-STAMP      TO SS01WS-TIME-HHMMSS.
050700     PERFORM SS27PD-NUMERICALLY-EDIT-TIME
050800                                 THRU SS27PD-NET-EXIT.
050900     MOVE SS01WS-HH-MM-SS        TO MB21WS-TIME.
051000     PERFORM MB21PD-INSERT-A-COLUMN
051100                                 THRU MB21PD-IAC-EXIT.
051200*
051300     PERFORM MB21PD-PRINT-A-PAGE
051400                                 THRU MB21PD-PAP-EXIT.
051500*
051600 B200-PH-EXIT.
051700     EXIT.
051800/
051900* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
052000*                          COMMON ROUTINES                      *
052100* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
052200*
052300     COPY SS02PD.
052400/
052500     COPY SS08PD.
052600/
052700     COPY SS16PD.
052800/
052900     COPY SS26PD.
053000/
053100     COPY SS27PD.
053200/
053300     COPY MB20PD.
053400/
053500     COPY MB21PD.
053600/
053700     COPY MB99PD.
053800/
053900     COPY MB00PD REPLACING ==:MB00:== BY ==MTCC==.
054000/
054100     COPY MB00PD REPLACING ==:MB00:== BY ==MMSC==.
054200/
054300     COPY MB00PD REPLACING ==:MB00:== BY ==MMSS==.
054400/
054500     COPY MB00PD REPLACING ==:MB00:== BY ==MBMF==.
