000100 IDENTIFICATION DIVISION.
000200 PROGRAM-ID. MBU907.
000201*       RELEASE DATE=08/24/01.        REVISION LEVEL=08.06      *
000202*****************************************************************
000203*WARNING.  THIS COMPUTER PROGRAM IS PROTECTED BY COPYRIGHT LAW  *
000204*AND INTERNATIONAL TREATIES.  UNAUTHORIZED REPRODUCTION OR      *
000205*DISTRIBUTION OF THIS PROGRAM, OR ANY PORTION OF IT, MAY RESULT *
000206*IN SEVERE CIVIL AND CRIMINAL PENATLIES, AND WILL BE PROSECUTED *
000207*TO THE MAXIMUM EXTENT POSSIBLE UNDER THE LAW.                  *
000208*COPYRIGHT 1999 PAYSYS INTERNATIONAL, INC.  ALL RIGHTS RESERVED.*
000209*****************************************************************
000300*****************************************************************
000400*                                                               *
000500*       MBU907 - DATE AND TIME STAMP FILE (MMDT)                *
000600*                                                               *
000700*****************************************************************
000800 ENVIRONMENT DIVISION.
000900 CONFIGURATION SECTION.
001000 SOURCE-COMPUTER.   IBM-4341.
001100 OBJECT-COMPUTER.   IBM-4341.
001200/
001300 INPUT-OUTPUT SECTION.
001400 FILE-CONTROL.
001500/
001600 DATA DIVISION.
001700 FILE SECTION.
001800 WORKING-STORAGE SECTION.
001900*
002000 01  FILLER                  PIC  X(12)      VALUE '** WS-BEG **'.
002100*
002200     COPY MB00RB REPLACING ==:MB00:== BY ==MTCC==.
002300/
002400     COPY MB00RB REPLACING ==:MB00:== BY ==MMSC==.
002500/
002600     COPY MB00RB REPLACING ==:MB00:== BY ==MMDT==.
002700/
002800     COPY MBU999WS.
002900/
003000     COPY MB00RB REPLACING ==:MB00:== BY ==MBMF==.
003100/
003200     COPY MTCCRL REPLACING ==:MTCC:== BY ==MTCC==.
003300/
003400     COPY MMSCRL.
003500/
003600     COPY MMDTRL.
003700/
003800     COPY MBMFRL.
003900/
004000     COPY MTCCIO REPLACING ==:MTCC:== BY ==MTCC==.
004100/
004200     COPY MMSCIO.
004300/
004400     COPY MMDTIO.
004500/
004600     COPY MBMFIO.
004700/
004800     COPY MB00WS.
004900/
005000     COPY MB20WS.
005100/
005200     COPY MB99WS.
005300/
005400     COPY SS00WS.
005500/
005600     COPY SS01WS.
005700/
005800     COPY SS02WS.
005900/
006000 01  WS-WORK-AREAS.
006100     03  WS-PROG-ID          PIC  X(06)      VALUE 'MBU907'.
006200     03  WS-CARD-READ-SW     PIC  X(01)      VALUE 'N'.
006300     03  WS-HOLD-TIME        PIC   9(11)     VALUE ZEROES.
006400     03  WS-HOLD-TIME-R      REDEFINES WS-HOLD-TIME.
006500         05  FILLER          PIC   9(05).
006600         05  WS-HOLD-TIME-6  PIC   9(06).
006700*
006800     03  WS-BACKUP-OR-MASTER PIC  X(06)      VALUE SPACES.
006900         88  WS-BACKUP                       VALUE 'BACKUP'.
007000         88  WS-MASTER                       VALUE 'MASTER'.
007100/
007200     COPY MB21WS.
007300*
007400 01  FILLER                  PIC  X(12)      VALUE '** WS-END **'.
007500/
007600 PROCEDURE DIVISION.
007700*
007800 A000-DRIVER.
007900*
008000     MOVE 'MBU907'               TO SS02WS-ABEND-PROG-ID
008100                                    MBU999WS-PROGRAM-ID.
008200*
008300     CALL MB00WS-MBU999CC        USING MBU999WS-AREA.
008400*
008500     MOVE 'MB000000'             TO MB20WS-SH-RPT-ID.
008600     MOVE 'T907'                 TO MB20WS-SH-INTERNAL-RPT-ID.
008700     MOVE '   DATE AND TIME STAMP FILE   '
008800                                 TO MB20WS-SH-RPT-NAME.
008900     MOVE SPACES                 TO MB20WS-SH-LIT-1
009000                                    MB20WS-SH-LIT-5
009100                                    MB20WS-SH-L4
009200                                    MB20WS-SH-L5
009300                                    MB20WS-SH-L6.
009400     PERFORM MB21PD-PAP-RESET-INDEXES
009500                                 THRU MB21PD-PAP-EXIT.
009600*
009700 A100-OPEN-FILES.
009800*
009900     MOVE SPACES                 TO MB21WS-PRINT-PAGE.
010000     MOVE 'O1CC'                 TO SS02WS-ABEND-LOCATION.
010100     MOVE SS02WS-END-OF-FILE     TO MTCCRB-PERM-STATUS-1.
010200     SET MTCCRB-OPEN-INPUT       TO TRUE.
010300     PERFORM MB00PD-MTCC-ACCESS  THRU MB00PD-MTCC-ACCESS-EXIT.
010400*
010500     MOVE 'O1SC'                 TO SS02WS-ABEND-LOCATION.
010600     SET MMSCRB-OPEN-INPUT       TO TRUE.
010700     PERFORM MB00PD-MMSC-ACCESS  THRU MB00PD-MMSC-ACCESS-EXIT.
010800*
010900     MOVE 'R1SC'                 TO SS02WS-ABEND-LOCATION.
011000     SET  MMSCRB-READ-SEQ        TO TRUE.
011100     PERFORM MB00PD-MMSC-ACCESS  THRU MB00PD-MMSC-ACCESS-EXIT.
011200*
011300     MOVE 'MMSC'                 TO MB99WS-FILE-ID.
011400*
011500     IF  MMSCIO-HEADER
011600         NEXT SENTENCE
011700     ELSE
011800         PERFORM MB99PD-MISSING-HEADER-ABEND
011900            THRU MB99PD-MHA-EXIT.
012000*
012100     MOVE MMSCIO-RECORD          TO MMSC-RECORD.
012200*
012210     MOVE MMSC-DATE-FORMAT       TO SS01WS-DATE-FORMAT.
012300     MOVE MMSC-TODAYS-JULIAN     TO SS01WS-JULIAN.
012400     PERFORM SS26PD-NUMERICALLY-EDIT-DATE THRU SS26PD-NED-EXIT.
012500     MOVE SS01WS-XX-XX-YYYY      TO MB20WS-SH-FILE-DATE.
012600     MOVE MMSC-TIME-STAMP        TO SS01WS-TIME-HHMMSS.
012700     PERFORM SS27PD-NUMERICALLY-EDIT-TIME
012800                                 THRU SS27PD-NET-EXIT.
012900     MOVE SS01WS-HH-MM-SS        TO MB20WS-SH-PROC-TIME .
013000*
013100     MOVE MMSC-FORM              TO MB20WS-FORM-CODE.
013200     MOVE MMSC-FICHE-FLAG        TO MB20WS-FICHE-CODE.
013300     MOVE MMSC-LINES-PER-PAGE    TO MB20WS-LINES-PER-PAGE.
013400     MOVE 99                     TO MB20WS-LINE-LIMIT.
013500     COMPUTE MB21WS-LIN-LIMIT
013600                                 =  MMSC-LINES-PER-PAGE - 4.
013700     MOVE MMSC-SCREEN-HEADER     TO MB20WS-SH-SYSTEM.
013900*
014000     MOVE 'R1CC'                 TO SS02WS-ABEND-LOCATION.
014100     SET MTCCRB-READ-SEQ         TO TRUE.
014200     PERFORM MB00PD-MTCC-ACCESS  THRU MB00PD-MTCC-ACCESS-EXIT.
014300*
014400     IF  SS02WS-FS-END-OF-FILE
014500     OR  MTCCIO-PROGRAM-ID IS NOT EQUAL TO WS-PROG-ID
014600         GO TO A400-CHECK-READ-SWITCH
014700     END-IF.
014800*
014900     MOVE MTCCIO-CARD-DATA       TO MTCC-RECORD.
015000*
015100     IF  MTCC-MBU9XX-BACKUP
015200         MOVE 'BACKUP'           TO WS-BACKUP-OR-MASTER
015300         MOVE 'O1MF'             TO SS02WS-ABEND-LOCATION
015400         SET MBMFRB-OPEN-INPUT   TO TRUE
015500         PERFORM MB00PD-MBMF-ACCESS THRU MB00PD-MBMF-ACCESS-EXIT
015600         MOVE 'R1MF'             TO SS02WS-ABEND-LOCATION
015700         SET MBMFRB-READ-SEQ     TO TRUE
015800         MOVE SS02WS-NO-RECORD-FOUND
015900                                 TO MBMFRB-PERM-STATUS-3
016000         MOVE SS02WS-END-OF-FILE
016100                                 TO MBMFRB-PERM-STATUS-4
016200         PERFORM MB00PD-MBMF-ACCESS THRU MB00PD-MBMF-ACCESS-EXIT
016300     ELSE
016400         MOVE 'O1DT'             TO SS02WS-ABEND-LOCATION
016500         SET MMDTRB-OPEN-INPUT   TO TRUE
016600         PERFORM MB00PD-MMDT-ACCESS THRU MB00PD-MMDT-ACCESS-EXIT
016700         MOVE 'R1DT'             TO SS02WS-ABEND-LOCATION
016800         SET MMDTRB-READ-SEQ     TO TRUE
016900         MOVE SS02WS-NO-RECORD-FOUND
017000                                 TO MMDTRB-PERM-STATUS-3
017100         MOVE SS02WS-END-OF-FILE
017200                                 TO MMDTRB-PERM-STATUS-4
017300         PERFORM MB00PD-MMDT-ACCESS THRU MB00PD-MMDT-ACCESS-EXIT
017400         GO TO A130-PRINT-HR-RECORD
017500     END-IF.
017600*
017700     MOVE 'MBMF'                 TO MB99WS-FILE-ID.
017800*
017900     IF  MBMFIO-FILE-IS-HEADER
018000         NEXT SENTENCE
018100     ELSE
018200         PERFORM MB99PD-MISSING-HEADER-ABEND
018300            THRU MB99PD-MHA-EXIT.
018400*
018500     MOVE MBMFIO-RECORD          TO MBMF-RECORD.
018600*
018700     SET X-MBMF-FILE             TO 1.
018800*
018900 A110-SEARCH-HEADER-TABLE-LOOP.
019000*
019100     IF  X-MBMF-FILE IS GREATER THAN 75
019200         MOVE 'MMDT'             TO MB99WS-FILE-ID
019300         PERFORM MB99PD-NOT-ON-BACKUP
019400            THRU MB99PD-NOB-EXIT.
019500*
019600     IF  MBMF-MBU020-ENTRY (X-MBMF-FILE) IS EQUAL TO 'DT'
019700         CONTINUE
019800     ELSE
019900         SET X-MBMF-FILE         UP BY 1
020000         GO TO A110-SEARCH-HEADER-TABLE-LOOP
020100     END-IF.
020200*
020300 A120-READ-MBMF-LOOP.
020400*
020500     MOVE 'R2MF'                 TO SS02WS-ABEND-LOCATION.
020600     SET MBMFRB-READ-SEQ         TO TRUE.
020700     MOVE SS02WS-NO-RECORD-FOUND
020800                                 TO MBMFRB-PERM-STATUS-3.
020900     MOVE SS02WS-END-OF-FILE     TO MBMFRB-PERM-STATUS-4.
021000     PERFORM MB00PD-MBMF-ACCESS  THRU MB00PD-MBMF-ACCESS-EXIT.
021100*
021200     IF  SS02WS-FS-END-OF-FILE
021300         GO TO A600-CLOSE-FILES
021400     END-IF.
021500*
021600     IF  MBMFIO-FILE-IS-MMDT
021700         CONTINUE
021800     ELSE
021900         GO TO A120-READ-MBMF-LOOP
022000     END-IF.
022100*
022200 A130-PRINT-HR-RECORD.
022300*
022400     IF  WS-BACKUP
022500         MOVE MBMFIO-VAR-DATA    TO MMDTIO-RECORD
022600     END-IF.
022700*
022800     MOVE 'MMDT'                 TO MB99WS-FILE-ID.
022900*
023000     IF  MMDTIO-HEADER
023100         NEXT SENTENCE
023200     ELSE
023300         PERFORM MB99PD-MISSING-HEADER-ABEND
023400            THRU MB99PD-MHA-EXIT.
023500*
023600     MOVE MMDTIO-RECORD          TO MMDT-RECORD.
023700*
023800 A200-PROGRAM-CONTROL.
023900*
024000     IF  MTCC-MBU9XX-BACKUP OR MTCC-MBU9XX-MASTER
024100         MOVE MTCC-MBU9XX-OPTION TO WS-BACKUP-OR-MASTER
024200     ELSE
024300         IF  WS-BACKUP-OR-MASTER IS EQUAL TO SPACES
024400             MOVE 'MASTER'       TO WS-BACKUP-OR-MASTER.
024500*
024600     IF  WS-BACKUP
024700         GO TO A350-READ-NEXT-MBMF
024800     END-IF.
024900*
025000 A350-READ-NEXT.
025100*
025200     MOVE 'R2DT'                 TO SS02WS-ABEND-LOCATION.
025300     SET  MMDTRB-READ-SEQ        TO TRUE.
025400     PERFORM MB00PD-MMDT-ACCESS  THRU MB00PD-MMDT-ACCESS-EXIT.
025500*
025600     IF  SS02WS-FS-END-OF-FILE
025700         IF  MB21WS-PRINT-PAGE IS EQUAL TO SPACES
025800             GO TO A600-CLOSE-FILES
025900         ELSE
026000             PERFORM MB21PD-PRINT-A-PAGE
026100                                 THRU MB21PD-PAP-EXIT
026200             GO TO A600-CLOSE-FILES.
026300*
026400     IF  MMDTIO-HEADER
026500     OR  MMDTIO-TRAILER
026600         GO TO A350-READ-NEXT.
026700*
026800     MOVE MMDTIO-RECORD          TO MMDT-RECORD.
026900*
027000     PERFORM B100-PRT-BEGIN      THRU B999-PRT-EXIT.
027100     GO TO A350-READ-NEXT.
027200*
027300 A350-READ-NEXT-MBMF.
027400*
027500     MOVE 'R3MF'                 TO SS02WS-ABEND-LOCATION.
027600     SET  MBMFRB-READ-SEQ        TO TRUE.
027700     PERFORM MB00PD-MBMF-ACCESS  THRU MB00PD-MBMF-ACCESS-EXIT.
027800*
027900     IF  SS02WS-FS-NO-RECORD-FOUND
028000         GO TO A600-CLOSE-FILES
028100     END-IF.
028200*
028300     IF  SS02WS-FS-END-OF-FILE
028400         IF  MB21WS-PRINT-PAGE IS EQUAL TO SPACES
028500             GO TO A600-CLOSE-FILES
028600         ELSE
028700             PERFORM MB21PD-PRINT-A-PAGE
028800                                 THRU MB21PD-PAP-EXIT
028900             GO TO A600-CLOSE-FILES.
029000*
029100     IF  MBMFIO-FILE-IS-MMDT
029200         CONTINUE
029300     ELSE
029400         GO TO A350-READ-NEXT-MBMF
029500     END-IF.
029600*
029700     MOVE MBMFIO-VAR-DATA        TO MMDTIO-RECORD.
029800*
029900     IF  MMDTIO-TRAILER
030000         GO TO A350-READ-NEXT-MBMF.
030100*
030200     MOVE MMDTIO-RECORD          TO MMDT-RECORD.
030300*
030400     PERFORM B100-PRT-BEGIN      THRU B999-PRT-EXIT.
030500     GO TO A350-READ-NEXT-MBMF.
030600*
030700 A400-CHECK-READ-SWITCH.
030800*
030900     IF  WS-CARD-READ-SW IS EQUAL TO 'N'
031000         MOVE '*** NO CONTROL CARDS ***'
031100                                 TO MB21WS-PP-COL44 (5 1)
031200         PERFORM MB21PD-PRINT-A-PAGE
031300                                 THRU MB21PD-PAP-EXIT.
031400*
031500     GO TO A600-CLOSE-FILES.
031600*
031700 A600-CLOSE-FILES.
031800*
031900     EVALUATE TRUE
032000         WHEN  WS-BACKUP
032100             MOVE 'C1MF'         TO SS02WS-ABEND-LOCATION
032200             SET MBMFRB-CLOSE    TO TRUE
032300             PERFORM MB00PD-MBMF-ACCESS
032400                                 THRU MB00PD-MBMF-ACCESS-EXIT
032500         WHEN  WS-MASTER
032600             MOVE 'C1DT'         TO SS02WS-ABEND-LOCATION
032700             SET MMDTRB-CLOSE    TO TRUE
032800             PERFORM MB00PD-MMDT-ACCESS
032900                                 THRU MB00PD-MMDT-ACCESS-EXIT
033000         WHEN  OTHER
033100             CONTINUE
033200     END-EVALUATE.
033300*
033400     MOVE 'C1CC'                 TO SS02WS-ABEND-LOCATION.
033500     SET MTCCRB-CLOSE            TO TRUE.
033600     PERFORM MB00PD-MTCC-ACCESS  THRU MB00PD-MTCC-ACCESS-EXIT.
033700*
033800     MOVE 'C1SC'                 TO SS02WS-ABEND-LOCATION.
033900     SET MMSCRB-CLOSE            TO TRUE.
034000     PERFORM MB00PD-MMSC-ACCESS  THRU MB00PD-MMSC-ACCESS-EXIT.
034100*
034200     PERFORM MB20PD-CLOSE-PRINT-FILES
034300                                 THRU MB20PD-CPF-EXIT.
034400*
034500     STOP RUN.
034600*
034700 B100-PRT-BEGIN.
034800*
034900     MOVE 'DATE AND TIME STAMP RECORD (MMDT)'
035000                                 TO MB21WS-PRINT-WORK-AREA.
035100     PERFORM MB21PD-INSERT-A-COLUMN
035200                                 THRU MB21PD-IAC-EXIT.
035300*
035400     IF  MMDTIO-MBD520
035500         MOVE 'MB1O-DATE-STAMP'  TO MB21WS-NAME
035600     ELSE
035700         MOVE 'MB2O-DATE-STAMP'  TO MB21WS-NAME
035800     END-IF.
035900*
036000     MOVE MMDT-MB1O-DATE-STAMP   TO SS01WS-JULIAN.
036100     PERFORM SS26PD-NUMERICALLY-EDIT-DATE THRU SS26PD-NED-EXIT.
036200     MOVE MMDT-MB1O-DATE-STAMP   TO MB21WS-JULIAN.
036300     MOVE SS01WS-XX-XX-YYYY      TO MB21WS-GREG.
036400     INSPECT MB21WS-JULIAN       REPLACING ALL ',' BY '-'.
036500     PERFORM MB21PD-INSERT-A-COLUMN
036600                                 THRU MB21PD-IAC-EXIT.
036700*
036800     IF  MMDTIO-MBD520
036900         MOVE 'MB1O-TIME-STAMP'  TO MB21WS-NAME
037000     ELSE
037100         MOVE 'MB2O-TIME-STAMP'  TO MB21WS-NAME
037200     END-IF.
037300*
037400     MOVE MMDT-MB1O-TIME-STAMP   TO WS-HOLD-TIME.
037500     MOVE WS-HOLD-TIME-6         TO SS01WS-TIME-HHMMSS.
037600     PERFORM SS27PD-NUMERICALLY-EDIT-TIME
037700                                 THRU SS27PD-NET-EXIT.
037800     MOVE SS01WS-HH-MM-SS        TO MB21WS-TIME.
037900     PERFORM MB21PD-INSERT-A-COLUMN
038000                                 THRU MB21PD-IAC-EXIT.
038100*
038200     IF  MMDTIO-MBD520
038300         MOVE 'MB1O-LAST-DATE-STAMP'
038400                                 TO MB21WS-NAME
038500     ELSE
038600         MOVE 'MB2O-LAST-DATE-STAMP'
038700                                 TO MB21WS-NAME
038800     END-IF.
038900*
039000     MOVE MMDT-MB1O-LAST-DATE-STAMP
039100                                 TO SS01WS-JULIAN.
039200     PERFORM SS26PD-NUMERICALLY-EDIT-DATE THRU SS26PD-NED-EXIT.
039300     MOVE MMDT-MB1O-LAST-DATE-STAMP
039400                                 TO MB21WS-JULIAN.
039500     MOVE SS01WS-XX-XX-YYYY      TO MB21WS-GREG.
039600     INSPECT MB21WS-JULIAN       REPLACING ALL ',' BY '-'.
039700     PERFORM MB21PD-INSERT-A-COLUMN
039800                                 THRU MB21PD-IAC-EXIT.
039900*
040000     IF  MMDTIO-MBD520
040100         MOVE 'MB1O-LAST-TIME-STAMP'
040200                                 TO MB21WS-NAME
040300     ELSE
040400         MOVE 'MB2O-LAST-TIME-STAMP'
040500                                 TO MB21WS-NAME
040600     END-IF.
040700*
040800     MOVE MMDT-MB1O-LAST-TIME-STAMP
040900                                 TO WS-HOLD-TIME.
041000     MOVE WS-HOLD-TIME-6         TO SS01WS-TIME-HHMMSS.
041100     PERFORM SS27PD-NUMERICALLY-EDIT-TIME
041200                                 THRU SS27PD-NET-EXIT.
041300     MOVE SS01WS-HH-MM-SS        TO MB21WS-TIME.
041400     PERFORM MB21PD-INSERT-A-COLUMN
041500                                 THRU MB21PD-IAC-EXIT.
041600*
041700     MOVE 'PROG-ID'              TO MB21WS-NAME.
041800     MOVE MMDT-PROG-ID           TO MB21WS-6X.
041900     PERFORM MB21PD-INSERT-A-COLUMN
042000                                 THRU MB21PD-IAC-EXIT 2 TIMES.
042100*
042200 B999-PRT-EXIT.
042300     EXIT.
042400*
042500 B200-PRINT-HEADER.
042600*
042700     MOVE 'DATE AND TIME STAMP HEADER(MMDT)'
042800                                 TO MB21WS-NAME.
042900     PERFORM MB21PD-INSERT-A-COLUMN
043000                                 THRU MB21PD-IAC-EXIT.
043100*
043200     MOVE 'DATE-STAMP'           TO MB21WS-NAME.
043300     MOVE MMDTIO-DATE-STAMP      TO SS01WS-JULIAN.
043400     PERFORM SS26PD-NUMERICALLY-EDIT-DATE THRU SS26PD-NED-EXIT.
043500     MOVE MMDTIO-DATE-STAMP      TO MB21WS-JULIAN.
043600     MOVE SS01WS-XX-XX-YYYY      TO MB21WS-GREG.
043700     INSPECT MB21WS-JULIAN       REPLACING ALL ',' BY '-'.
043800     PERFORM MB21PD-INSERT-A-COLUMN
043900                                 THRU MB21PD-IAC-EXIT.
044000*
044100     MOVE 'TIME-STAMP'           TO MB21WS-NAME.
044200     MOVE MMDTIO-TIME-STAMP      TO SS01WS-TIME-HHMMSS.
044300     PERFORM SS27PD-NUMERICALLY-EDIT-TIME
044400                                 THRU SS27PD-NET-EXIT.
044500     MOVE SS01WS-HH-MM-SS        TO MB21WS-TIME.
044600     PERFORM MB21PD-INSERT-A-COLUMN
044700                                 THRU MB21PD-IAC-EXIT.
044800*
044900     MOVE 'PROG-ID'              TO MB21WS-NAME.
045000     MOVE MMDTIO-PROG-ID         TO MB21WS-6X.
045100     PERFORM MB21PD-INSERT-A-COLUMN
045200                                 THRU MB21PD-IAC-EXIT.
045300*
045400     PERFORM MB21PD-PRINT-A-PAGE
045500                                 THRU MB21PD-PAP-EXIT.
045600*
045700 B200-PH-EXIT.
045800     EXIT.
045900/
046000* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
046100*                          COMMON ROUTINES                      *
046200* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
046300*
046400     COPY SS02PD.
046500/
046600     COPY SS08PD.
046700/
046800     COPY SS16PD.
046900/
047000     COPY SS26PD.
047100/
047200     COPY SS27PD.
047300/
047400     COPY MB20PD.
047500/
047600     COPY MB21PD.
047700/
047800     COPY MB99PD.
047900/
048000     COPY MB00PD REPLACING ==:MB00:== BY ==MTCC==.
048100/
048200     COPY MB00PD REPLACING ==:MB00:== BY ==MMDT==.
048300/
048400     COPY MB00PD REPLACING ==:MB00:== BY ==MMSC==.
048500/
048600     COPY MB00PD REPLACING ==:MB00:== BY ==MBMF==.
