000100 IDENTIFICATION DIVISION.
000200 PROGRAM-ID. MBU914.
000201*       RELEASE DATE=08/24/01.        REVISION LEVEL=08.06      *
000202*****************************************************************
000203*WARNING.  THIS COMPUTER PROGRAM IS PROTECTED BY COPYRIGHT LAW  *
000204*AND INTERNATIONAL TREATIES.  UNAUTHORIZED REPRODUCTION OR      *
000205*DISTRIBUTION OF THIS PROGRAM, OR ANY PORTION OF IT, MAY RESULT *
000206*IN SEVERE CIVIL AND CRIMINAL PENATLIES, AND WILL BE PROSECUTED *
000207*TO THE MAXIMUM EXTENT POSSIBLE UNDER THE LAW.                  *
000208*COPYRIGHT 1999 PAYSYS INTERNATIONAL, INC.  ALL RIGHTS RESERVED.*
000209*****************************************************************
000300*****************************************************************
000400*                                                               *
000500*        MBU914 - MERCHANT PRODUCT FILE   -       (MMMP)        *
000600*                                                               *
000700*****************************************************************
000800 ENVIRONMENT DIVISION.
000900 CONFIGURATION SECTION.
001000 SOURCE-COMPUTER.   IBM-4341.
001100 OBJECT-COMPUTER.   IBM-4341.
001200/
001300 INPUT-OUTPUT SECTION.
001400 FILE-CONTROL.
001500/
001600 DATA DIVISION.
001700 FILE SECTION.
001800 WORKING-STORAGE SECTION.
001900*
002000 01  FILLER                  PIC  X(12)      VALUE '** WS-BEG **'.
002100*
002200     COPY MTCCIO REPLACING ==:MTCC:== BY ==MTCC==.
002300/
002400     COPY MB00RB REPLACING ==:MB00:== BY ==MTCC==.
002500/
002600     COPY MTCCRL REPLACING ==:MTCC:== BY ==MTCC==.
002700/
002800     COPY MBMFIO.
002900/
003000     COPY MB00RB REPLACING ==:MB00:== BY ==MBMF==.
003100/
003200     COPY MBMFRL.
003300/
003400     COPY MMSCIO.
003500/
003600     COPY MB00RB REPLACING ==:MB00:== BY ==MMSC==.
003700/
003800     COPY MMSCRL.
003900/
004000     COPY MMMPIO.
004100/
004200     COPY MB00RB REPLACING ==:MB00:== BY ==MMMP==.
004300/
004400     COPY MMMPRL.
004500/
004600     COPY MBU999WS.
004700/
004800     COPY MB00WS.
004900/
005000     COPY MB20WS.
005100/
005200     COPY MB21WS.
005300/
005400     COPY MB99WS.
005500/
005600     COPY SS00WS.
005700/
005800     COPY SS01WS.
005900/
006000     COPY SS02WS.
006100/
006200 01  WS-WORK-AREAS.
006300     03  WS-PROG-ID          PIC  X(06)      VALUE 'MBU914'.
006400     03  WS-CARD-READ-SW     PIC  X(01)      VALUE 'N'.
006500*
006600     03  WS-MMMP-BEG-KEY.
006700         05  WS-BEG-ORG-MERCHANT.
006800             07  WS-BEG-ORG  PIC  9(03)      VALUE ZEROES.
006900             07  WS-BEG-MERCHANT
007000                             PIC  9(09)      VALUE ZEROES.
007100         05  WS-BEG-PRODUCT  PIC  9(02)      VALUE ZEROES.
007200*
007300     03  WS-MMMP-END-KEY.
007400         05  WS-END-ORG-MERCHANT.
007500             07  WS-END-ORG  PIC  9(03)      VALUE ZEROES.
007600             07  WS-END-MERCHANT
007700                             PIC  9(09)      VALUE ZEROES.
007800         05  WS-END-PRODUCT  PIC  9(02)      VALUE 99.
007900*
008000     03  WS-BACKUP-OR-MASTER PIC  X(06)      VALUE SPACES.
008100         88  WS-BACKUP                       VALUE 'BACKUP'.
008200         88  WS-MASTER                       VALUE 'MASTER'.
008300*
008400     03  WS-PROD-RESV-LINES.
008500         05  FILLER          PIC  X(22)      VALUE
008600             'PRODUCT RESERVE TABLE '.
008700         05  WS-PROD-RESV-LINE-NBR
008800                             PIC  9(01).
008900*
009000 01  FILLER                  PIC  X(12)      VALUE '** WS-END **'.
009100/
009200 PROCEDURE DIVISION.
009300*
009400 A000-DRIVER.
009500*
009600     MOVE 'MBU914'               TO SS02WS-ABEND-PROG-ID
009700                                    MBU999WS-PROGRAM-ID.
009800*
009900     CALL MB00WS-MBU999CC        USING MBU999WS-AREA.
010000*
010100     MOVE 'MB000000'             TO MB20WS-SH-RPT-ID.
010200     MOVE 'T914'                 TO MB20WS-SH-INTERNAL-RPT-ID.
010300     MOVE ' MERCHANT PRODUCT FILE DISPLAY'
010400                                 TO MB20WS-SH-RPT-NAME.
010500     MOVE SPACES                 TO MB20WS-SH-LIT-1
010600                                    MB20WS-SH-LIT-5
010700                                    MB20WS-SH-L4
010800                                    MB20WS-SH-L5
010900                                    MB20WS-SH-L6.
011000     PERFORM MB21PD-PAP-RESET-INDEXES
011100                                 THRU MB21PD-PAP-EXIT.
011200*
011300 A100-OPEN-FILES.
011400*
011500     MOVE SPACES                 TO MB21WS-PRINT-PAGE.
011600     MOVE 'O1CC'                 TO SS02WS-ABEND-LOCATION.
011700     MOVE SS02WS-END-OF-FILE     TO MTCCRB-PERM-STATUS-1.
011800     SET MTCCRB-OPEN-INPUT       TO TRUE.
011900     PERFORM MB00PD-MTCC-ACCESS  THRU MB00PD-MTCC-ACCESS-EXIT.
012000*
012100     MOVE 'O1SC'                 TO SS02WS-ABEND-LOCATION.
012200     SET MMSCRB-OPEN-INPUT       TO TRUE.
012300     PERFORM MB00PD-MMSC-ACCESS  THRU MB00PD-MMSC-ACCESS-EXIT.
012400*
012500     MOVE 'R1SC'                 TO SS02WS-ABEND-LOCATION.
012600     SET MMSCRB-READ-SEQ         TO TRUE.
012700     PERFORM MB00PD-MMSC-ACCESS  THRU MB00PD-MMSC-ACCESS-EXIT.
012800*
012900     MOVE 'MMSC'                 TO MB99WS-FILE-ID.
013000*
013100     IF  MMSCIO-HEADER
013200         NEXT SENTENCE
013300     ELSE
013400         PERFORM MB99PD-MISSING-HEADER-ABEND
013500            THRU MB99PD-MHA-EXIT.
013600*
013700     MOVE MMSCIO-RECORD          TO MMSC-RECORD.
013800*
013810     MOVE MMSC-DATE-FORMAT       TO SS01WS-DATE-FORMAT.
013900     MOVE MMSC-TODAYS-JULIAN     TO SS01WS-JULIAN.
014000     PERFORM SS26PD-NUMERICALLY-EDIT-DATE THRU SS26PD-NED-EXIT.
014100     MOVE SS01WS-XX-XX-YYYY      TO MB20WS-SH-FILE-DATE.
014200     MOVE MMSC-TIME-STAMP        TO SS01WS-TIME-HHMMSS.
014300     PERFORM SS27PD-NUMERICALLY-EDIT-TIME
014400                                 THRU SS27PD-NET-EXIT.
014500     MOVE SS01WS-HH-MM-SS        TO MB20WS-SH-PROC-TIME.
014600*
014700     MOVE MMSC-FORM              TO MB20WS-FORM-CODE.
014800     MOVE MMSC-FICHE-FLAG        TO MB20WS-FICHE-CODE.
014900     MOVE MMSC-LINES-PER-PAGE    TO MB20WS-LINES-PER-PAGE.
015000     MOVE 99                     TO MB20WS-LINE-LIMIT.
015100     COMPUTE MB21WS-LIN-LIMIT    =  MMSC-LINES-PER-PAGE - 4.
015200     MOVE MMSC-SCREEN-HEADER     TO MB20WS-SH-SYSTEM.
015400*
015500 A100-READ-MTCC-LOOP.
015600*
015700     MOVE 'R1CC'                 TO SS02WS-ABEND-LOCATION
015800     SET MTCCRB-READ-SEQ         TO TRUE
015900     PERFORM MB00PD-MTCC-ACCESS  THRU MB00PD-MTCC-ACCESS-EXIT
016000*
016100     IF  SS02WS-FS-END-OF-FILE
016200         GO TO A400-CHECK-READ-SWITCH
016300     END-IF.
016400*
016500     IF  MTCCIO-PROGRAM-ID IS NOT EQUAL TO WS-PROG-ID
016600         GO TO A200-PROGRAM-CONTROL
016700     END-IF.
016800*
016900     MOVE MTCCIO-CARD-DATA       TO MTCC-RECORD.
017000*
017100     IF  MTCC-MBU9XX-BACKUP
017200         MOVE 'BACKUP'           TO WS-BACKUP-OR-MASTER
017300         MOVE 'O1MF'             TO SS02WS-ABEND-LOCATION
017400         SET MBMFRB-OPEN-INPUT   TO TRUE
017500         PERFORM MB00PD-MBMF-ACCESS THRU MB00PD-MBMF-ACCESS-EXIT
017600         MOVE 'R1MF'             TO SS02WS-ABEND-LOCATION
017700         SET MBMFRB-READ-SEQ     TO TRUE
017800         MOVE SS02WS-NO-RECORD-FOUND
017900                                 TO MBMFRB-PERM-STATUS-3
018000         MOVE SS02WS-END-OF-FILE
018100                                 TO MBMFRB-PERM-STATUS-4
018200         PERFORM MB00PD-MBMF-ACCESS THRU MB00PD-MBMF-ACCESS-EXIT
018300     ELSE
018400         MOVE 'O1MP'             TO SS02WS-ABEND-LOCATION
018500         SET MMMPRB-OPEN-INPUT   TO TRUE
018600         PERFORM MB00PD-MMMP-ACCESS THRU MB00PD-MMMP-ACCESS-EXIT
018700         MOVE 'R1MP'             TO SS02WS-ABEND-LOCATION
018800         SET MMMPRB-READ-SEQ     TO TRUE
018900         MOVE SS02WS-NO-RECORD-FOUND
019000                                 TO MMMPRB-PERM-STATUS-3
019100         MOVE SS02WS-END-OF-FILE
019200                                 TO MMMPRB-PERM-STATUS-4
019300         PERFORM MB00PD-MMMP-ACCESS THRU MB00PD-MMMP-ACCESS-EXIT
019400         GO TO A130-PRINT-HR-RECORD
019500     END-IF.
019600*
019700     MOVE 'MBMF'                 TO MB99WS-FILE-ID.
019800*
019900     IF  MBMFIO-FILE-IS-HEADER
020000         NEXT SENTENCE
020100     ELSE
020200         PERFORM MB99PD-MISSING-HEADER-ABEND
020300            THRU MB99PD-MHA-EXIT.
020400*
020500     MOVE MBMFIO-RECORD          TO MBMF-RECORD.
020600*
020700     SET X-MBMF-FILE             TO 1.
020800*
020900 A110-SEARCH-HEADER-TABLE-LOOP.
021000*
021100     IF  X-MBMF-FILE IS GREATER THAN 75
021200         MOVE 'MMMP'             TO MB99WS-FILE-ID
021300         PERFORM MB99PD-NOT-ON-BACKUP
021400            THRU MB99PD-NOB-EXIT.
021500*
021600     IF  MBMF-MBU020-ENTRY (X-MBMF-FILE) IS EQUAL TO 'MP'
021700         CONTINUE
021800     ELSE
021900         SET X-MBMF-FILE         UP BY 1
022000         GO TO A110-SEARCH-HEADER-TABLE-LOOP
022100     END-IF.
022200*
022300 A120-READ-MBMF-LOOP.
022400*
022500     MOVE 'R2MF'                 TO SS02WS-ABEND-LOCATION.
022600     SET MBMFRB-READ-SEQ         TO TRUE.
022700     MOVE SS02WS-NO-RECORD-FOUND
022800                                 TO MBMFRB-PERM-STATUS-3.
022900     MOVE SS02WS-END-OF-FILE     TO MBMFRB-PERM-STATUS-4.
023000     PERFORM MB00PD-MBMF-ACCESS  THRU MB00PD-MBMF-ACCESS-EXIT.
023100*
023200     IF  SS02WS-FS-END-OF-FILE
023300         GO TO A200-PROGRAM-CONTROL
023400     END-IF.
023500*
023600     IF  MBMFIO-FILE-IS-MMMP
023700         CONTINUE
023800     ELSE
023900         GO TO A120-READ-MBMF-LOOP
024000     END-IF.
024100*
024200 A130-PRINT-HR-RECORD.
024300*
024400     IF  WS-BACKUP
024500         MOVE MBMFIO-VAR-DATA    TO MMMPIO-RECORD
024600     END-IF.
024700*
024800     MOVE 'MMMP'                 TO MB99WS-FILE-ID.
024900*
025000     IF  MMMPIO-HEADER
025100         NEXT SENTENCE
025200     ELSE
025300         PERFORM MB99PD-MISSING-HEADER-ABEND
025400            THRU MB99PD-MHA-EXIT.
025500*
025600     MOVE MMMPIO-RECORD          TO MMMP-RECORD.
025700*
025800     IF  MMMPIO-HEADER
025900         PERFORM B200-PRINT-HEADER
026000                                 THRU B200-PH-EXIT
026100     END-IF.
026200*
026300 A200-PROGRAM-CONTROL.
026400*
026500     IF  MTCC-MBU9XX-BACKUP OR MTCC-MBU9XX-MASTER
026600         MOVE MTCC-MBU9XX-OPTION TO WS-BACKUP-OR-MASTER
026700     ELSE
026800         IF  WS-BACKUP-OR-MASTER IS EQUAL TO SPACES
026900             MOVE 'MASTER'       TO WS-BACKUP-OR-MASTER
027000             GO TO A210-PC-BY-FIRST-READ.
027100*
027200     MOVE 'R2CC'                 TO SS02WS-ABEND-LOCATION.
027300     SET MTCCRB-READ-SEQ         TO TRUE.
027400     PERFORM MB00PD-MTCC-ACCESS  THRU MB00PD-MTCC-ACCESS-EXIT.
027500*
027600     IF  SS02WS-FS-END-OF-FILE
027700         GO TO A400-CHECK-READ-SWITCH
027800     END-IF.
027900*
028000 A210-PC-BY-FIRST-READ.
028100*
028200     IF  MTCCIO-PROGRAM-ID  IS NOT EQUAL TO WS-PROG-ID
028300         GO TO A200-PROGRAM-CONTROL
028400     END-IF.
028500*
028600     MOVE MTCCIO-CARD-DATA       TO MTCC-RECORD.
028700*
028800 A300-RANGE-CARD.
028900*
029000     MOVE 'Y'                    TO WS-CARD-READ-SW.
029100     INSPECT MTCC-MBU914-BEG-X   REPLACING ALL SPACE BY ZERO.
029200*
029300     IF  MTCC-MBU914-END-X IS EQUAL TO SPACES
029400         MOVE MTCC-MBU914-BEG-X  TO MTCC-MBU914-END-X
029500     END-IF.
029600*
029700     INSPECT MTCC-MBU914-END-X   REPLACING ALL SPACE BY ZERO.
029800*
029900     MOVE MTCC-MBU914-BEG-X      TO WS-BEG-ORG-MERCHANT.
030000*
030100     MOVE MTCC-MBU914-END-X      TO WS-END-ORG-MERCHANT.
030200*
030300     IF  WS-BACKUP
030400         GO TO A350-READ-NEXT-MBMF
030500     END-IF.
030600*
030700     MOVE MTCC-MBU914-BEG-X      TO MMMPIO-KEY.
030800*
030900     MOVE 'S1MP'                 TO SS02WS-ABEND-LOCATION.
031000     SET  MMMPRB-START-GTE       TO TRUE.
031100     PERFORM MB00PD-MMMP-ACCESS  THRU MB00PD-MMMP-ACCESS-EXIT.
031200*
031300     IF  SS02WS-FS-NO-RECORD-FOUND
031400         GO TO A500-CONTROL-CARD-ERROR
031500     END-IF.
031600*
031700 A350-READ-NEXT.
031800*
031900     MOVE 'R2MM'                 TO SS02WS-ABEND-LOCATION.
032000     SET  MMMPRB-READ-SEQ        TO TRUE.
032100     PERFORM MB00PD-MMMP-ACCESS  THRU MB00PD-MMMP-ACCESS-EXIT.
032200*
032300     IF  SS02WS-FS-END-OF-FILE
032400         IF  MB21WS-PRINT-PAGE IS EQUAL TO SPACES
032500             GO TO A200-PROGRAM-CONTROL
032600         ELSE
032700             PERFORM MB21PD-PRINT-A-PAGE
032800                                 THRU MB21PD-PAP-EXIT
032900             GO TO A200-PROGRAM-CONTROL.
033000*
033100     IF  MMMPIO-KEY IS GREATER THAN WS-MMMP-END-KEY
033200         IF  MB21WS-PRINT-PAGE IS EQUAL TO SPACES
033300             GO TO A200-PROGRAM-CONTROL
033400         ELSE
033500             PERFORM MB21PD-PRINT-A-PAGE
033600                                 THRU MB21PD-PAP-EXIT
033700             GO TO A200-PROGRAM-CONTROL.
033800*
033900     IF  MMMPIO-HEADER
034000     OR  MMMPIO-TRAILER
034100         GO TO A350-READ-NEXT.
034200*
034300     MOVE MMMPIO-RECORD          TO MMMP-RECORD.
034400*
034500     PERFORM B100-PRT-BEGIN      THRU B999-PRT-EXIT.
034600     GO TO A350-READ-NEXT.
034700*
034800 A350-READ-NEXT-MBMF.
034900*
035000     MOVE 'R3MF'                 TO SS02WS-ABEND-LOCATION.
035100     SET  MBMFRB-READ-SEQ        TO TRUE.
035200     PERFORM MB00PD-MBMF-ACCESS  THRU MB00PD-MBMF-ACCESS-EXIT.
035300*
035400     IF  SS02WS-FS-NO-RECORD-FOUND
035500         GO TO A500-CONTROL-CARD-ERROR
035600     END-IF.
035700*
035800     IF  SS02WS-FS-END-OF-FILE
035900         IF  MB21WS-PRINT-PAGE IS EQUAL TO SPACES
036000             GO TO A200-PROGRAM-CONTROL
036100         ELSE
036200             PERFORM MB21PD-PRINT-A-PAGE
036300                                 THRU MB21PD-PAP-EXIT
036400             GO TO A200-PROGRAM-CONTROL.
036500*
036600     IF  MBMFIO-FILE-IS-MMMP
036700         CONTINUE
036800     ELSE
036900         GO TO A350-READ-NEXT-MBMF
037000     END-IF.
037100*
037200     MOVE MBMFIO-VAR-DATA        TO MMMP-RECORD.
037300*
037400     IF  MMMP-KEY IS LESS THAN WS-MMMP-BEG-KEY
037500         GO TO A350-READ-NEXT-MBMF
037600     END-IF.
037700*
037800     IF  MMMP-KEY IS GREATER THAN WS-MMMP-END-KEY
037900         PERFORM MB21PD-PRINT-A-PAGE
038000                                 THRU MB21PD-PAP-EXIT
038100         GO TO A200-PROGRAM-CONTROL
038200     END-IF.
038300*
038400     IF  MMMP-ORG IS EQUAL TO 999
038500         GO TO A350-READ-NEXT-MBMF.
038600*
038700     PERFORM B100-PRT-BEGIN      THRU B999-PRT-EXIT.
038800     GO TO A350-READ-NEXT-MBMF.
038900*
039000 A400-CHECK-READ-SWITCH.
039100*
039200     IF  WS-CARD-READ-SW IS EQUAL TO 'N'
039300         MOVE '*** NO CONTROL CARDS ***'
039400                                 TO MB21WS-PP-COL44 (5 1)
039500         PERFORM MB21PD-PRINT-A-PAGE
039600                                 THRU MB21PD-PAP-EXIT.
039700*
039800     GO TO A600-CLOSE-FILES.
039900*
040000 A500-CONTROL-CARD-ERROR.
040100*
040200     MOVE MTCC-RECORD            TO MB21WS-PP-LINE (4).
040300     MOVE 'CONTROL CARD ERROR'   TO MB21WS-PP-COL44 (4 3).
040400     PERFORM MB21PD-PRINT-A-PAGE THRU MB21PD-PAP-EXIT.
040500     MOVE SPACE                  TO MB21WS-PP-LINE (4).
040600     MOVE SPACE                  TO MB21WS-PP-COL44 (4 3).
040700     GO TO A200-PROGRAM-CONTROL.
040800*
040900 A600-CLOSE-FILES.
041000*
041100     EVALUATE TRUE
041200         WHEN  WS-BACKUP
041300             MOVE 'C1MF'         TO SS02WS-ABEND-LOCATION
041400             SET MBMFRB-CLOSE    TO TRUE
041500             PERFORM MB00PD-MBMF-ACCESS
041600                                 THRU MB00PD-MBMF-ACCESS-EXIT
041700         WHEN  WS-MASTER
041800             MOVE 'C1MP'         TO SS02WS-ABEND-LOCATION
041900             SET MMMPRB-CLOSE    TO TRUE
042000             PERFORM MB00PD-MMMP-ACCESS
042100                                 THRU MB00PD-MMMP-ACCESS-EXIT
042200         WHEN  OTHER
042300             CONTINUE
042400     END-EVALUATE.
042500*
042600     MOVE 'C1CC'                 TO SS02WS-ABEND-LOCATION.
042700     SET MTCCRB-CLOSE            TO TRUE.
042800     PERFORM MB00PD-MTCC-ACCESS  THRU MB00PD-MTCC-ACCESS-EXIT.
042900*
043000     MOVE 'C1SC'                 TO SS02WS-ABEND-LOCATION.
043100     SET MMSCRB-CLOSE            TO TRUE.
043200     PERFORM MB00PD-MMSC-ACCESS  THRU MB00PD-MMSC-ACCESS-EXIT.
043300*
043400     PERFORM MB20PD-CLOSE-PRINT-FILES
043500                                 THRU MB20PD-CPF-EXIT.
043600*
043700     STOP RUN.
043800/
043900 B100-PRT-BEGIN.
044000*
044100     MOVE '*\*\*------MERCHANT PRODUCT RECORD-----*/*/*'
044200                                 TO MB21WS-PRINT-WORK-AREA.
044300     PERFORM MB21PD-INSERT-A-COLUMN
044400                                 THRU MB21PD-IAC-EXIT.
044500*
044600     MOVE 'ORG'                  TO MB21WS-NAME.
044700     MOVE MMMP-ORG               TO MB21WS-3V0.
044800     PERFORM MB21PD-INSERT-A-COLUMN
044900                                 THRU MB21PD-IAC-EXIT.
045000*
045100     MOVE 'MERCHANT'             TO MB21WS-NAME.
045200     MOVE MMMP-MERCHANT          TO MB21WS-9V0.
045300     PERFORM MB21PD-INSERT-A-COLUMN
045400                                 THRU MB21PD-IAC-EXIT.
045500*
045600     MOVE 'PRODUCT'              TO MB21WS-NAME.
045700     MOVE MMMP-PRODUCT           TO MB21WS-2V0.
045800     PERFORM MB21PD-INSERT-A-COLUMN
045900                                 THRU MB21PD-IAC-EXIT 2 TIMES.
046000*
046100     MOVE '*-----------STATUS INFORMATION-------------*'
046200                                 TO MB21WS-PRINT-WORK-AREA.
046300     PERFORM MB21PD-INSERT-A-COLUMN
046400                                 THRU MB21PD-IAC-EXIT.
046500*
046600     MOVE 'REC STATUS'           TO MB21WS-NAME.
046700     MOVE MMMP-REC-STATUS        TO MB21WS-1V0.
046800     PERFORM MB21PD-INSERT-A-COLUMN
046900                                 THRU MB21PD-IAC-EXIT.
047000*
047100     MOVE 'ONLINE STATUS'        TO MB21WS-NAME.
047200     MOVE MMMP-ONLINE-STATUS     TO MB21WS-2V0.
047300     PERFORM MB21PD-INSERT-A-COLUMN
047400                                 THRU MB21PD-IAC-EXIT.
047500*
047600     MOVE 'LAST MAINT DATE'      TO MB21WS-NAME.
047700     MOVE MMMP-LAST-MAINT-DATE   TO SS01WS-JULIAN.
047800     PERFORM SS26PD-NUMERICALLY-EDIT-DATE THRU SS26PD-NED-EXIT.
047900     MOVE MMMP-LAST-MAINT-DATE   TO MB21WS-JULIAN.
048000     MOVE SS01WS-XX-XX-YYYY      TO MB21WS-GREG.
048100     INSPECT MB21WS-JULIAN       REPLACING ALL ',' BY '-'.
048200     PERFORM MB21PD-INSERT-A-COLUMN
048300                                 THRU MB21PD-IAC-EXIT.
048400*
048500     MOVE 'LAST MAINT OPER'      TO MB21WS-NAME.
048600     MOVE MMMP-LAST-MAINT-OPER   TO MB21WS-3X.
048700     PERFORM MB21PD-INSERT-A-COLUMN
048800                                 THRU MB21PD-IAC-EXIT 2 TIMES.
048900*
049000     MOVE '*----------------PRODUCT DATA--------------*'
049100                                 TO MB21WS-PRINT-WORK-AREA.
049200     PERFORM MB21PD-INSERT-A-COLUMN
049300                                 THRU MB21PD-IAC-EXIT.
049400*
049500     MOVE 'PROD STATUS'          TO MB21WS-NAME.
049600     MOVE MMMP-PROD-STATUS       TO MB21WS-X.
049700     PERFORM MB21PD-INSERT-A-COLUMN
049800                                 THRU MB21PD-IAC-EXIT.
049900*
050000     MOVE 'PROD EFF DATE'        TO MB21WS-NAME.
050100     MOVE MMMP-PROD-EFF-DATE     TO SS01WS-JULIAN.
050200     PERFORM SS26PD-NUMERICALLY-EDIT-DATE THRU SS26PD-NED-EXIT.
050300     MOVE MMMP-PROD-EFF-DATE     TO MB21WS-JULIAN.
050400     MOVE SS01WS-XX-XX-YYYY      TO MB21WS-GREG.
050500     INSPECT MB21WS-JULIAN       REPLACING ALL ',' BY '-'.
050600     PERFORM MB21PD-INSERT-A-COLUMN
050700                                 THRU MB21PD-IAC-EXIT.
050800*
050900     MOVE 'PROD SHORT-DESC'      TO MB21WS-NAME.
051000     MOVE MMMP-PROD-SHORT-DESC   TO MB21WS-5X.
051100     PERFORM MB21PD-INSERT-A-COLUMN
051200                                 THRU MB21PD-IAC-EXIT.
051300*
051400     MOVE 'PROD SETTLE FLAG'     TO MB21WS-NAME.
051500     MOVE MMMP-PROD-SETTLE-FLAG  TO MB21WS-X.
051600     PERFORM MB21PD-INSERT-A-COLUMN
051700                                 THRU MB21PD-IAC-EXIT.
051800*
051900     MOVE 'PROD SOURCE'          TO MB21WS-NAME.
052000     MOVE MMMP-PROD-SOURCE       TO MB21WS-5X.
052100     PERFORM MB21PD-INSERT-A-COLUMN
052200                                 THRU MB21PD-IAC-EXIT.
052300*
052400     MOVE 'PROD DISC RATE TABLE' TO MB21WS-NAME.
052500     MOVE MMMP-PROD-DISC-RATE-TABLE
052600                                 TO MB21WS-9V0.
052700     PERFORM MB21PD-INSERT-A-COLUMN
052800                                 THRU MB21PD-IAC-EXIT.
052900*
053000     MOVE 'PROD DISC FEE BASE'   TO MB21WS-NAME.
053100     MOVE MMMP-PROD-DISC-FEE-BASE
053200                                 TO MB21WS-X.
053300     PERFORM MB21PD-INSERT-A-COLUMN
053400                                 THRU MB21PD-IAC-EXIT.
053500*
053600     MOVE 'PROD PART RATE TABLE' TO MB21WS-NAME.
053700     MOVE MMMP-PROD-PART-RATE-TABLE
053800                                 TO MB21WS-9V0.
053900     PERFORM MB21PD-INSERT-A-COLUMN
054000                                 THRU MB21PD-IAC-EXIT.
054100*
054200     MOVE 'PROD PART FEE BASE'   TO MB21WS-NAME.
054300     MOVE MMMP-PROD-PART-FEE-BASE
054400                                 TO MB21WS-X.
054500     PERFORM MB21PD-INSERT-A-COLUMN
054600                                 THRU MB21PD-IAC-EXIT.
054700*
054800     PERFORM
054900         VARYING X-MMMP-PROD-RESV FROM +1 BY +1
055000         UNTIL   X-MMMP-PROD-RESV IS GREATER THAN +4
055100         SET WS-PROD-RESV-LINE-NBR
055200                                 TO X-MMMP-PROD-RESV
055300         MOVE WS-PROD-RESV-LINES TO MB21WS-DATA-NAME
055400         PERFORM MB21PD-INSERT-A-COLUMN
055500                                 THRU MB21PD-IAC-EXIT
055600         MOVE 'PROD RESV RATE TABLE'
055700                                 TO MB21WS-NAME
055800         MOVE MMMP-PROD-RESV-RATE-TABLE (X-MMMP-PROD-RESV)
055900                                 TO MB21WS-9V0
056000         PERFORM MB21PD-INSERT-A-COLUMN
056100                                 THRU MB21PD-IAC-EXIT
056200         MOVE 'PROD RESV FEE BASE  '
056300                                 TO MB21WS-NAME
056400         MOVE MMMP-PROD-RESV-FEE-BASE (X-MMMP-PROD-RESV)
056500                                 TO MB21WS-X
056600         PERFORM MB21PD-INSERT-A-COLUMN
056700                                 THRU MB21PD-IAC-EXIT
056800     END-PERFORM.
056900*
057000     MOVE 'PROD INTCHG FEE BASE' TO MB21WS-NAME.
057100     MOVE MMMP-PROD-INTCHG-FEE-BASE
057200                                 TO MB21WS-X.
057300     PERFORM MB21PD-INSERT-A-COLUMN
057400                                 THRU MB21PD-IAC-EXIT.
057500*
057600     MOVE 'PROD USER CODE'       TO MB21WS-NAME.
057700     MOVE MMMP-PROD-USER-CODE    TO MB21WS-2X.
057800     PERFORM MB21PD-INSERT-A-COLUMN
057900                                 THRU MB21PD-IAC-EXIT.
058000*
058100 B999-PRT-EXIT.
058200     EXIT.
058300/
058400 B200-PRINT-HEADER.
058500*
058600     MOVE 'HEADER RECORD (MMMP-)'
058700                                 TO MB21WS-NAME.
058800     PERFORM MB21PD-INSERT-A-COLUMN
058900                                 THRU MB21PD-IAC-EXIT.
059000*
059100     MOVE SPACES                 TO MB21WS-PRINT-WORK-AREA
059200     MOVE 'ORG'                  TO MB21WS-NAME.
059300     MOVE MMMPIO-ORG             TO MB21WS-3V0.
059400     PERFORM MB21PD-INSERT-A-COLUMN
059500                                 THRU MB21PD-IAC-EXIT.
059600*
059700     MOVE 'MERCHANT NBR'         TO MB21WS-NAME.
059800     MOVE MMMPIO-MERCHANT        TO MB21WS-9V0.
059900     PERFORM MB21PD-INSERT-A-COLUMN
060000                                 THRU MB21PD-IAC-EXIT.
060100*
060200     MOVE 'PRODUCT NBR'          TO MB21WS-NAME.
060300     MOVE MMMPIO-PRODUCT         TO MB21WS-2V0.
060400     PERFORM MB21PD-INSERT-A-COLUMN
060500                                 THRU MB21PD-IAC-EXIT.
060600*
060700     MOVE 'DATE-STAMP'           TO MB21WS-NAME.
060800     MOVE MMMPIO-DATE-STAMP      TO SS01WS-JULIAN.
060900     PERFORM SS26PD-NUMERICALLY-EDIT-DATE THRU SS26PD-NED-EXIT.
061000     MOVE MMMPIO-DATE-STAMP      TO MB21WS-JULIAN.
061100     MOVE SS01WS-XX-XX-YYYY      TO MB21WS-GREG.
061200     INSPECT MB21WS-JULIAN       REPLACING ALL ',' BY '-'.
061300     PERFORM MB21PD-INSERT-A-COLUMN
061400                                 THRU MB21PD-IAC-EXIT.
061500*
061600     MOVE 'TIME-STAMP'           TO MB21WS-NAME.
061700     MOVE MMMPIO-TIME-STAMP      TO SS01WS-TIME-HHMMSS.
061800     PERFORM SS27PD-NUMERICALLY-EDIT-TIME
061900                                 THRU SS27PD-NET-EXIT.
062000     MOVE SS01WS-HH-MM-SS        TO MB21WS-TIME.
062100     PERFORM MB21PD-INSERT-A-COLUMN
062200                                 THRU MB21PD-IAC-EXIT.
062300*
062400     PERFORM MB21PD-PRINT-A-PAGE
062500                                 THRU MB21PD-PAP-EXIT.
062600*
062700 B200-PH-EXIT.
062800     EXIT.
062900/
063000* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
063100*                          COMMON ROUTINES                      *
063200* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
063300*
063400     COPY SS02PD.
063500/
063600     COPY SS08PD.
063700/
063800     COPY SS16PD.
063900/
064000     COPY SS26PD.
064100/
064200     COPY SS27PD.
064300/
064400     COPY MB20PD.
064500/
064600     COPY MB21PD.
064700/
064800     COPY MB99PD.
064900/
065000     COPY MB00PD REPLACING ==:MB00:== BY ==MTCC==.
065100/
065200     COPY MB00PD REPLACING ==:MB00:== BY ==MMSC==.
065300/
065400     COPY MB00PD REPLACING ==:MB00:== BY ==MBMF==.
065500/
065600     COPY MB00PD REPLACING ==:MB00:== BY ==MMMP==.
