000100 IDENTIFICATION DIVISION.
000200 PROGRAM-ID. MBU919.
000201*       RELEASE DATE=08/24/01.        REVISION LEVEL=08.06      * ++++++++
000202***************************************************************** ++++++++
000203*WARNING.  THIS COMPUTER PROGRAM IS PROTECTED BY COPYRIGHT LAW  * ++++++++
000204*AND INTERNATIONAL TREATIES.  UNAUTHORIZED REPRODUCTION OR      * ++++++++
000205*DISTRIBUTION OF THIS PROGRAM, OR ANY PORTION OF IT, MAY RESULT * ++++++++
000206*IN SEVERE CIVIL AND CRIMINAL PENATLIES, AND WILL BE PROSECUTED * ++++++++
000207*TO THE MAXIMUM EXTENT POSSIBLE UNDER THE LAW.                  * ++++++++
000208*COPYRIGHT 1999 PAYSYS INTERNATIONAL, INC.  ALL RIGHTS RESERVED.* ++++++++
000209***************************************************************** ++++++++
000300*****************************************************************
000400*                                                               *
000500*       MBU919 - SETTLEMENT AND STATEMENT HISTORY               *
000600*                FILE DISPLAY (MMSH)                            *
000700*                                                               *
000800*****************************************************************
000900 ENVIRONMENT DIVISION.
001000 CONFIGURATION SECTION.
001100 SOURCE-COMPUTER.   IBM-4341.
001200 OBJECT-COMPUTER.   IBM-4341.
001300/
001400 INPUT-OUTPUT SECTION.
001500 FILE-CONTROL.
001600/
001700 DATA DIVISION.
001800 FILE SECTION.
001900 WORKING-STORAGE SECTION.
002000*
002100 01  FILLER                  PIC  X(12)      VALUE '** WS-BEG **'.
002200*
002300     COPY MB00RB REPLACING ==:MB00:== BY ==MTCC==.
002400/
002500     COPY MB00RB REPLACING ==:MB00:== BY ==MMSC==.
002600/
002700     COPY MB00RB REPLACING ==:MB00:== BY ==MMSH==.
002800/
002900     COPY MBU999WS.
003000/
003100     COPY MB00RB REPLACING ==:MB00:== BY ==MBMF==.
003200/
003300     COPY MTCCRL REPLACING ==:MTCC:== BY ==MTCC==.
003400/
003500     COPY MMSCRL.
003600/
003700     COPY MTPTRL REPLACING ==:MTPT:== BY ==MMSH==.
003800/
003900     COPY MBMFRL.
004000/
004100     COPY MTCCIO REPLACING ==:MTCC:== BY ==MTCC==.
004200/
004300     COPY MMSCIO.
004400/
004500     COPY MTPTIO REPLACING ==:MTPT:== BY ==MMSH==.
004600/
004700     COPY MBMFIO.
004800/
004900     COPY MB00WS.
005000/
005100     COPY MB20WS.
005200/
005300     COPY MB21WS.
005400/
005500     COPY MB99WS.
005600/
005700     COPY SS00WS.
005800/
005900     COPY SS01WS.
006000/
006100     COPY SS02WS.
006200/
006300 01  WS-WORK-AREAS.
006400     03  WS-PROG-ID          PIC  X(06)      VALUE 'MBU919'.
006500     03  WS-CARD-READ-SW     PIC  X(01)      VALUE 'N'.
006600*
006700     03  WS-MMSH-BEG-KEY.
006800         05  WS-MMSH-BEG-ORG-MERCHANT.
006900             07  WS-MMSH-BEG-ORG
007000                             PIC  9(03)      VALUE ZEROES.
007100             07  WS-MMSH-BEG-MERCHANT
007200                             PIC  9(09)      VALUE ZEROES.
007300         05  WS-MMSH-BEG-SEQ PIC S9(08)      BINARY VALUE ZEROES.
007400*
007500     03  WS-MMSH-END-KEY.
007600         05  WS-MMSH-END-ORG-MERCHANT.
007700             07  WS-MMSH-END-ORG
007800                             PIC  9(03)      VALUE ZEROES.
007900             07  WS-MMSH-END-MERCHANT
008000                             PIC  9(09)      VALUE ZEROES.
008100*
008200     03  WS-BACKUP-OR-MASTER PIC  X(06)      VALUE SPACES.
008300         88  WS-BACKUP                       VALUE 'BACKUP'.
008400         88  WS-MASTER                       VALUE 'MASTER'.
008500*
008600 01  FILLER                  PIC  X(12)      VALUE '** WS-END **'.
008700/
008800 PROCEDURE DIVISION.
008900*
009000 A000-DRIVER.
009100*
009200     MOVE 'MBU919'               TO SS02WS-ABEND-PROG-ID
009300                                    MBU999WS-PROGRAM-ID.
009400*
009500     CALL MB00WS-MBU999CC        USING MBU999WS-AREA.
009600*
009700     MOVE 'MB000000'             TO MB20WS-SH-RPT-ID.
009800     MOVE 'T919'                 TO MB20WS-SH-INTERNAL-RPT-ID.    FX800028
009900     MOVE ' STATEMENT/SETTLEMENT HISTORY '
010000                                 TO MB20WS-SH-RPT-NAME.
010100     MOVE SPACES                 TO MB20WS-SH-LIT-1
010200                                    MB20WS-SH-LIT-5
010300                                    MB20WS-SH-L4
010400                                    MB20WS-SH-L5
010500                                    MB20WS-SH-L6.
010600     PERFORM MB21PD-PAP-RESET-INDEXES
010700                                 THRU MB21PD-PAP-EXIT.
010800*
010900 A100-OPEN-FILES.
011000*
011100     MOVE SPACES                 TO MB21WS-PRINT-PAGE.
011200     MOVE 'O1CC'                 TO SS02WS-ABEND-LOCATION.
011300     MOVE SS02WS-END-OF-FILE     TO MTCCRB-PERM-STATUS-1.
011400     SET MTCCRB-OPEN-INPUT       TO TRUE.
011500     PERFORM MB00PD-MTCC-ACCESS  THRU MB00PD-MTCC-ACCESS-EXIT.
011600*
011700     MOVE 'O1SC'                 TO SS02WS-ABEND-LOCATION.
011800     SET MMSCRB-OPEN-INPUT       TO TRUE.
011900     PERFORM MB00PD-MMSC-ACCESS  THRU MB00PD-MMSC-ACCESS-EXIT.
012000*
012100     MOVE 'R1SC'                 TO SS02WS-ABEND-LOCATION.
012200     SET  MMSCRB-READ-SEQ        TO TRUE.
012300     PERFORM MB00PD-MMSC-ACCESS  THRU MB00PD-MMSC-ACCESS-EXIT.
012400     MOVE 'MMSC'                 TO MB99WS-FILE-ID.
012500*
012600     IF  MMSCIO-HEADER
012700         NEXT SENTENCE
012800     ELSE
012900         PERFORM MB99PD-MISSING-HEADER-ABEND
013000            THRU MB99PD-MHA-EXIT.
013100*
013200     MOVE MMSCIO-RECORD          TO MMSC-RECORD.
013300*
013310     MOVE MMSC-DATE-FORMAT       TO SS01WS-DATE-FORMAT.
013400     MOVE MMSC-TODAYS-JULIAN     TO SS01WS-JULIAN.
013500     PERFORM SS26PD-NUMERICALLY-EDIT-DATE THRU SS26PD-NED-EXIT.
013600     MOVE SS01WS-XX-XX-YYYY      TO MB20WS-SH-FILE-DATE.
013700     MOVE MMSC-TIME-STAMP        TO SS01WS-TIME-HHMMSS.
013800     PERFORM SS27PD-NUMERICALLY-EDIT-TIME
013900                                 THRU SS27PD-NET-EXIT.
014000     MOVE SS01WS-HH-MM-SS        TO MB20WS-SH-PROC-TIME .
014100*
014200     MOVE MMSC-FORM              TO MB20WS-FORM-CODE.
014300     MOVE MMSC-FICHE-FLAG        TO MB20WS-FICHE-CODE.
014400     MOVE MMSC-LINES-PER-PAGE    TO MB20WS-LINES-PER-PAGE.
014500     MOVE 99                     TO MB20WS-LINE-LIMIT.
014600     COMPUTE MB21WS-LIN-LIMIT    =  MMSC-LINES-PER-PAGE - 4.
014700     MOVE MMSC-SCREEN-HEADER     TO MB20WS-SH-SYSTEM.
014900*
015000     MOVE 'R1CC'                 TO SS02WS-ABEND-LOCATION.
015100     SET MTCCRB-READ-SEQ         TO TRUE.
015200     PERFORM MB00PD-MTCC-ACCESS  THRU MB00PD-MTCC-ACCESS-EXIT.
015300*
015400     IF  SS02WS-FS-END-OF-FILE
015500         GO TO A400-CHECK-READ-SWITCH
015600     END-IF.
015700*
015800     IF  MTCCIO-PROGRAM-ID IS NOT EQUAL TO WS-PROG-ID
015900         GO TO A200-PROGRAM-CONTROL
016000     END-IF.
016100*
016200     MOVE MTCCIO-CARD-DATA       TO MTCC-RECORD.
016300*
016400     IF  MTCC-MBU9XX-BACKUP
016500         MOVE 'BACKUP'           TO WS-BACKUP-OR-MASTER
016600         MOVE 'O1MF'             TO SS02WS-ABEND-LOCATION
016700         SET MBMFRB-OPEN-INPUT   TO TRUE
016800         PERFORM MB00PD-MBMF-ACCESS THRU MB00PD-MBMF-ACCESS-EXIT
016900         MOVE 'R1MF'             TO SS02WS-ABEND-LOCATION
017000         SET MBMFRB-READ-SEQ     TO TRUE
017100         MOVE SS02WS-NO-RECORD-FOUND
017200                                 TO MBMFRB-PERM-STATUS-3
017300         MOVE SS02WS-END-OF-FILE
017400                                 TO MBMFRB-PERM-STATUS-4
017500         PERFORM MB00PD-MBMF-ACCESS THRU MB00PD-MBMF-ACCESS-EXIT
017600     ELSE
017700         MOVE 'O1SH'             TO SS02WS-ABEND-LOCATION
017800         SET MMSHRB-OPEN-INPUT   TO TRUE
017900         PERFORM MB00PD-MMSH-ACCESS THRU MB00PD-MMSH-ACCESS-EXIT
018000         MOVE 'R1SH'             TO SS02WS-ABEND-LOCATION
018100         SET MMSHRB-READ-SEQ     TO TRUE
018200         MOVE SS02WS-NO-RECORD-FOUND
018300                                 TO MMSHRB-PERM-STATUS-3
018400         MOVE SS02WS-END-OF-FILE
018500                                 TO MMSHRB-PERM-STATUS-4
018600         PERFORM MB00PD-MMSH-ACCESS THRU MB00PD-MMSH-ACCESS-EXIT
018700         GO TO A130-PRINT-HR-RECORD
018800     END-IF.
018900*
019000     MOVE 'MBMF'                 TO MB99WS-FILE-ID.
019100*
019200     IF  MBMFIO-FILE-IS-HEADER
019300         NEXT SENTENCE
019400     ELSE
019500         PERFORM MB99PD-MISSING-HEADER-ABEND
019600            THRU MB99PD-MHA-EXIT.
019700*
019800     MOVE MBMFIO-RECORD          TO MBMF-RECORD.
019900*
020000     SET X-MBMF-FILE             TO 1.
020100*
020200 A110-SEARCH-HEADER-TABLE-LOOP.
020300*
020400     IF  X-MBMF-FILE IS GREATER THAN 75
020500         MOVE 'MMSH'             TO MB99WS-FILE-ID
020600         PERFORM MB99PD-NOT-ON-BACKUP
020700            THRU MB99PD-NOB-EXIT.
020800*
020900     IF  MBMF-MBU020-ENTRY (X-MBMF-FILE) IS EQUAL TO 'SH'
021000         CONTINUE
021100     ELSE
021200         SET X-MBMF-FILE         UP BY 1
021300         GO TO A110-SEARCH-HEADER-TABLE-LOOP
021400     END-IF.
021500*
021600 A120-READ-MBMF-LOOP.
021700*
021800     MOVE 'R2MF'                 TO SS02WS-ABEND-LOCATION.
021900     SET MBMFRB-READ-SEQ         TO TRUE.
022000     PERFORM MB00PD-MBMF-ACCESS  THRU MB00PD-MBMF-ACCESS-EXIT.
022100*
022200     IF  SS02WS-FS-END-OF-FILE
022300         GO TO A200-PROGRAM-CONTROL
022400     END-IF.
022500*
022600     IF  MBMFIO-FILE-IS-MMSH
022700         CONTINUE
022800     ELSE
022900         GO TO A120-READ-MBMF-LOOP
023000     END-IF.
023100*
023200 A130-PRINT-HR-RECORD.
023300*
023400     IF  WS-BACKUP
023500         MOVE MBMFIO-VAR-DATA    TO MMSHIO-RECORD
023600     END-IF.
023700*
023800     MOVE 'MMSH'                 TO MB99WS-FILE-ID.
023900*
024000     IF  MMSHIO-HEADER
024100         PERFORM B200-PRINT-HEADER
024200                                 THRU B200-PH-EXIT
024300     ELSE
024400         PERFORM MB99PD-MISSING-HEADER-ABEND
024500            THRU MB99PD-MHA-EXIT.
024600*
024700     MOVE MMSHIO-RECORD          TO MMSH-RECORD.
024800*
024900 A200-PROGRAM-CONTROL.
025000*
025100     IF  MTCC-MBU9XX-BACKUP OR MTCC-MBU9XX-MASTER
025200         MOVE MTCC-MBU9XX-OPTION TO WS-BACKUP-OR-MASTER
025300     ELSE
025400         IF  WS-BACKUP-OR-MASTER IS EQUAL TO SPACES
025500             MOVE 'MASTER'       TO WS-BACKUP-OR-MASTER
025600             GO TO A210-PC-BY-FIRST-READ.
025700*
025800     MOVE 'R2CC'                 TO SS02WS-ABEND-LOCATION.
025900     SET MTCCRB-READ-SEQ         TO TRUE.
026000     PERFORM MB00PD-MTCC-ACCESS  THRU MB00PD-MTCC-ACCESS-EXIT.
026100*
026200     IF  SS02WS-FS-END-OF-FILE
026300         GO TO A400-CHECK-READ-SWITCH
026400     END-IF.
026500*
026600 A210-PC-BY-FIRST-READ.
026700*
026800     IF  MTCCIO-PROGRAM-ID  IS NOT EQUAL TO WS-PROG-ID
026900         GO TO A200-PROGRAM-CONTROL
027000     END-IF.
027100*
027200     MOVE MTCCIO-CARD-DATA       TO MTCC-RECORD.
027300*
027400 A300-RANGE-CARD.
027500*
027600     MOVE 'Y'                    TO WS-CARD-READ-SW.
027700     INSPECT MTCC-MBU919-BEG-X   REPLACING ALL SPACE BY ZERO.
027800*
027900     IF  MTCC-MBU919-END-X IS EQUAL TO SPACES
028000         MOVE MTCC-MBU919-BEG-X  TO MTCC-MBU919-END-X
028100     END-IF.
028200*
028300     INSPECT MTCC-MBU919-END-X   REPLACING ALL SPACE BY ZERO.
028400*
028500     MOVE MTCC-MBU919-BEG-ORG    TO WS-MMSH-BEG-ORG.
028600     MOVE MTCC-MBU919-BEG-MERCHANT
028700                                 TO WS-MMSH-BEG-MERCHANT.
028800*
028900     MOVE MTCC-MBU919-END-ORG    TO WS-MMSH-END-ORG.
029000     MOVE MTCC-MBU919-END-MERCHANT
029100                                 TO WS-MMSH-END-MERCHANT.
029200*
029300     IF  WS-BACKUP
029400         GO TO A350-READ-NEXT-MBMF
029500     END-IF.
029600*
029700 A350-READ-NEXT.
029800*
029900     MOVE 'R2SH'                 TO SS02WS-ABEND-LOCATION.
030000     SET  MMSHRB-READ-SEQ        TO TRUE.
030100     PERFORM MB00PD-MMSH-ACCESS  THRU MB00PD-MMSH-ACCESS-EXIT.
030200*
030300     IF  SS02WS-FS-END-OF-FILE
030400         IF  MB21WS-PRINT-PAGE IS EQUAL TO SPACES
030500             GO TO A200-PROGRAM-CONTROL
030600         ELSE
030700             PERFORM MB21PD-PRINT-A-PAGE
030800                                 THRU MB21PD-PAP-EXIT
030900             GO TO A200-PROGRAM-CONTROL.
031000*
031100     IF  MMSHIO-KEY IS LESS THAN WS-MMSH-BEG-KEY
031200         GO TO A350-READ-NEXT
031300     END-IF.
031400*
031500     IF  MMSHIO-ORG-MERCHANT IS GREATER THAN WS-MMSH-END-KEY
031600         IF  MB21WS-PRINT-PAGE IS EQUAL TO SPACES
031700             GO TO A200-PROGRAM-CONTROL
031800         ELSE
031900             PERFORM MB21PD-PRINT-A-PAGE
032000                                 THRU MB21PD-PAP-EXIT
032100             GO TO A200-PROGRAM-CONTROL.
032200*
032300     IF  MMSHIO-HEADER
032400     OR  MMSHIO-TRAILER
032500         GO TO A350-READ-NEXT.
032600*
032700     MOVE MMSHIO-RECORD          TO MMSH-RECORD.
032800*
032900     IF  MMSH-ORG IS EQUAL TO 999
033000         GO TO A350-READ-NEXT-MBMF.
033100*
033200     PERFORM B100-PRT-BEGIN      THRU B999-PRT-EXIT.
033300     GO TO A350-READ-NEXT.
033400*
033500 A350-READ-NEXT-MBMF.
033600*
033700     MOVE 'R3MF'                 TO SS02WS-ABEND-LOCATION.
033800     SET  MBMFRB-READ-SEQ        TO TRUE.
033900     PERFORM MB00PD-MBMF-ACCESS  THRU MB00PD-MBMF-ACCESS-EXIT.
034000*
034100     IF  SS02WS-FS-NO-RECORD-FOUND
034200         GO TO A500-CONTROL-CARD-ERROR
034300     END-IF.
034400*
034500     IF  SS02WS-FS-END-OF-FILE
034600         IF  MB21WS-PRINT-PAGE IS EQUAL TO SPACES
034700             GO TO A200-PROGRAM-CONTROL
034800         ELSE
034900             PERFORM MB21PD-PRINT-A-PAGE
035000                                 THRU MB21PD-PAP-EXIT
035100             GO TO A200-PROGRAM-CONTROL.
035200*
035300     IF  MBMFIO-FILE-IS-MMSH
035400         CONTINUE
035500     ELSE
035600         GO TO A350-READ-NEXT-MBMF
035700     END-IF.
035800*
035900     MOVE MBMFIO-VAR-DATA        TO MMSH-RECORD.
036000*
036100     IF  MMSH-KEY IS LESS THAN WS-MMSH-BEG-KEY
036200         GO TO A350-READ-NEXT-MBMF
036300     END-IF.
036400*
036500     IF  MMSH-ORG-MERCHANT IS GREATER THAN WS-MMSH-END-KEY
036600         PERFORM MB21PD-PRINT-A-PAGE
036700                                 THRU MB21PD-PAP-EXIT
036800         GO TO A200-PROGRAM-CONTROL
036900     END-IF.
037000*
037100     IF  MMSH-ORG IS EQUAL TO 999
037200         GO TO A350-READ-NEXT-MBMF.
037300*
037400     PERFORM B100-PRT-BEGIN      THRU B999-PRT-EXIT.
037500     GO TO A350-READ-NEXT-MBMF.
037600*
037700 A400-CHECK-READ-SWITCH.
037800*
037900     IF  WS-CARD-READ-SW IS EQUAL TO 'N'
038000         MOVE '*** NO CONTROL CARDS ***'
038100                                 TO MB21WS-PP-COL44 (5 1)
038200         PERFORM MB21PD-PRINT-A-PAGE
038300                                 THRU MB21PD-PAP-EXIT.
038400*
038500     GO TO A600-CLOSE-FILES.
038600*
038700 A500-CONTROL-CARD-ERROR.
038800*
038900     MOVE MTCC-RECORD            TO MB21WS-PP-LINE (4).
039000     MOVE 'CONTROL CARD ERROR'   TO MB21WS-PP-COL44 (4 3).
039100     PERFORM MB21PD-PRINT-A-PAGE THRU MB21PD-PAP-EXIT.
039200     MOVE SPACE                  TO MB21WS-PP-LINE (4).
039300     MOVE SPACE                  TO MB21WS-PP-COL44 (4 3).
039400     GO TO A200-PROGRAM-CONTROL.
039500*
039600 A600-CLOSE-FILES.
039700*
039800     EVALUATE TRUE
039900         WHEN  WS-BACKUP
040000             MOVE 'C1MF'         TO SS02WS-ABEND-LOCATION
040100             SET MBMFRB-CLOSE    TO TRUE
040200             PERFORM MB00PD-MBMF-ACCESS
040300                                 THRU MB00PD-MBMF-ACCESS-EXIT
040400         WHEN  WS-MASTER
040500             MOVE 'C1SH'         TO SS02WS-ABEND-LOCATION
040600             SET MMSHRB-CLOSE    TO TRUE
040700             PERFORM MB00PD-MMSH-ACCESS
040800                                 THRU MB00PD-MMSH-ACCESS-EXIT
040900         WHEN  OTHER
041000             CONTINUE
041100     END-EVALUATE.
041200*
041300     MOVE 'C1CC'                 TO SS02WS-ABEND-LOCATION.
041400     SET MTCCRB-CLOSE            TO TRUE.
041500     PERFORM MB00PD-MTCC-ACCESS  THRU MB00PD-MTCC-ACCESS-EXIT.
041600*
041700     MOVE 'C1SC'                 TO SS02WS-ABEND-LOCATION.
041800     SET MMSCRB-CLOSE            TO TRUE.
041900     PERFORM MB00PD-MMSC-ACCESS  THRU MB00PD-MMSC-ACCESS-EXIT.
042000*
042100     PERFORM MB20PD-CLOSE-PRINT-FILES
042200                                 THRU MB20PD-CPF-EXIT.
042300*
042400     STOP RUN.
042500/
042600 B100-PRT-BEGIN.
042700*
042800     MOVE 'STMT/SETT HISTORY RECORD     (MMSH)'
042900                                 TO MB21WS-PRINT-WORK-AREA.
043000     PERFORM MB21PD-INSERT-A-COLUMN
043100                                 THRU MB21PD-IAC-EXIT.
043200*
043300     MOVE 'ORG'                  TO MB21WS-NAME.
043400     MOVE MMSH-ORG               TO MB21WS-3V0.
043500     PERFORM MB21PD-INSERT-A-COLUMN
043600                                 THRU MB21PD-IAC-EXIT.
043700*
043800     MOVE 'MERCHANT'             TO MB21WS-NAME.
043900     MOVE MMSH-MERCHANT          TO MB21WS-9V0.
044000     PERFORM MB21PD-INSERT-A-COLUMN
044100                                 THRU MB21PD-IAC-EXIT.
044200*
044300     MOVE 'SEQ-NBR'              TO MB21WS-NAME.
044400     MOVE MMSH-SEQ-NBR           TO MB21WS-10V0.
044500     PERFORM MB21PD-INSERT-A-COLUMN
044600                                 THRU MB21PD-IAC-EXIT.
044700*
044800     MOVE 'STORE'                TO MB21WS-NAME.
044900     MOVE MMSH-STORE             TO MB21WS-9V0.
045000     PERFORM MB21PD-INSERT-A-COLUMN
045100                                 THRU MB21PD-IAC-EXIT.
045200*
045300     MOVE 'PRODUCT'              TO MB21WS-NAME.
045400     MOVE MMSH-PRODUCT           TO MB21WS-2V0.
045500     PERFORM MB21PD-INSERT-A-COLUMN
045600                                 THRU MB21PD-IAC-EXIT.
045700*
045800     MOVE 'PLAN'                 TO MB21WS-NAME.
045900     MOVE MMSH-PLAN              TO MB21WS-5V0.
046000     PERFORM MB21PD-INSERT-A-COLUMN
046100                                 THRU MB21PD-IAC-EXIT.
046200*
046300     MOVE 'LOGIC-MODULE'         TO MB21WS-NAME.
046400     MOVE MMSH-LOGIC-MODULE      TO MB21WS-3V0.
046500     PERFORM MB21PD-INSERT-A-COLUMN
046600                                 THRU MB21PD-IAC-EXIT.
046700*
046800     MOVE 'QUAL-LEVEL'           TO MB21WS-NAME.
046900     MOVE MMSH-QUAL-LEVEL        TO MB21WS-2V0.
047000     PERFORM MB21PD-INSERT-A-COLUMN
047100                                 THRU MB21PD-IAC-EXIT.
047200*
047300     MOVE 'TRANS CODE'           TO MB21WS-NAME.
047400     MOVE MMSH-TRANS-CODE        TO MB21WS-3V0.
047500     PERFORM MB21PD-INSERT-A-COLUMN
047600                                 THRU MB21PD-IAC-EXIT.
047700*
047800     MOVE 'TRANS FLAG'           TO MB21WS-NAME.
047900     MOVE MMSH-TRANS-FLAG        TO MB21WS-X.
048000     PERFORM MB21PD-INSERT-A-COLUMN
048100                                 THRU MB21PD-IAC-EXIT.
048200*
048300     MOVE 'NBR-ITEMS'            TO MB21WS-NAME.
048400     MOVE MMSH-NBR-ITEMS         TO MB21WS-10V0.
048500     PERFORM MB21PD-INSERT-A-COLUMN
048600                                 THRU MB21PD-IAC-EXIT.
048700*
048800     MOVE 'AMOUNT'               TO MB21WS-NAME.
048900     MOVE MMSH-AMOUNT            TO MB21WS-17V0.
049000     PERFORM MB21PD-INSERT-A-COLUMN
049100                                 THRU MB21PD-IAC-EXIT.
049200*
049300     MOVE 'POST DATE'            TO MB21WS-NAME.
049400     MOVE MMSH-POST-DATE         TO SS01WS-JULIAN.
049500     PERFORM SS26PD-NUMERICALLY-EDIT-DATE THRU SS26PD-NED-EXIT.
049600     MOVE MMSH-POST-DATE         TO MB21WS-JULIAN.
049700     MOVE SS01WS-XX-XX-YYYY      TO MB21WS-GREG.
049800     INSPECT MB21WS-JULIAN       REPLACING ALL ',' BY '-'.
049900     PERFORM MB21PD-INSERT-A-COLUMN
050000                                 THRU MB21PD-IAC-EXIT.
050100*
050200     MOVE 'ENTRY DATE'           TO MB21WS-NAME.
050300     MOVE MMSH-ENTRY-DATE        TO SS01WS-JULIAN.
050400     PERFORM SS26PD-NUMERICALLY-EDIT-DATE THRU SS26PD-NED-EXIT.
050500     MOVE MMSH-ENTRY-DATE        TO MB21WS-JULIAN.
050600     MOVE SS01WS-XX-XX-YYYY      TO MB21WS-GREG.
050700     INSPECT MB21WS-JULIAN       REPLACING ALL ',' BY '-'.
050800     PERFORM MB21PD-INSERT-A-COLUMN
050900                                 THRU MB21PD-IAC-EXIT.
051000*
051100     MOVE 'STMT-FLAG'            TO MB21WS-NAME.
051200     MOVE MMSH-STMT-FLAG         TO MB21WS-X.
051300     PERFORM MB21PD-INSERT-A-COLUMN
051400                                 THRU MB21PD-IAC-EXIT.
051500*
051600     MOVE 'SETT-FLAG'            TO MB21WS-NAME.
051700     MOVE MMSH-SETT-FLAG         TO MB21WS-X.
051800     PERFORM MB21PD-INSERT-A-COLUMN
051900                                 THRU MB21PD-IAC-EXIT.
052000*
052100     MOVE 'SETT-ACCT'            TO MB21WS-NAME.
052200     MOVE MMSH-SETT-ACCT         TO MB21WS-1V0
052300     PERFORM MB21PD-INSERT-A-COLUMN
052400                                 THRU MB21PD-IAC-EXIT.
052500*
052600     MOVE 'SETT-DATE'            TO MB21WS-NAME.
052700     MOVE MMSH-SETT-DATE         TO SS01WS-JULIAN.
052800     PERFORM SS26PD-NUMERICALLY-EDIT-DATE THRU SS26PD-NED-EXIT.
052900     MOVE MMSH-SETT-DATE         TO MB21WS-JULIAN.
053000     MOVE SS01WS-XX-XX-YYYY      TO MB21WS-GREG.
053100     INSPECT MB21WS-JULIAN       REPLACING ALL ',' BY '-'.
053200     PERFORM MB21PD-INSERT-A-COLUMN
053300                                 THRU MB21PD-IAC-EXIT.
053400*
053500     MOVE 'BATCH-DATE'           TO MB21WS-NAME.
053600     MOVE MMSH-BATCH-DATE        TO SS01WS-JULIAN.
053700     PERFORM SS26PD-NUMERICALLY-EDIT-DATE THRU SS26PD-NED-EXIT.
053800     MOVE MMSH-BATCH-DATE        TO MB21WS-JULIAN.
053900     MOVE SS01WS-XX-XX-YYYY      TO MB21WS-GREG.
054000     INSPECT MB21WS-JULIAN       REPLACING ALL ',' BY '-'.
054100     PERFORM MB21PD-INSERT-A-COLUMN
054200                                 THRU MB21PD-IAC-EXIT.
054300*
054400     MOVE 'BATCH-SOURCE'         TO MB21WS-NAME.
054500     MOVE MMSH-BATCH-SOURCE      TO MB21WS-5V0.
054600     PERFORM MB21PD-INSERT-A-COLUMN
054700                                 THRU MB21PD-IAC-EXIT.
054800*
054900     MOVE 'BATCH-NBR'            TO MB21WS-NAME.
055000     MOVE MMSH-BATCH-NBR         TO MB21WS-5V0.
055100     PERFORM MB21PD-INSERT-A-COLUMN
055200                                 THRU MB21PD-IAC-EXIT.
055300*
055400     MOVE 'BATCH-SEQ'            TO MB21WS-NAME.
055500     MOVE MMSH-BATCH-SEQ         TO MB21WS-10V0.
055600     PERFORM MB21PD-INSERT-A-COLUMN
055700                                 THRU MB21PD-IAC-EXIT.
055800*
055900     MOVE 'REF-BATCH-DATE'       TO MB21WS-NAME.
056000     MOVE MMSH-REF-BATCH-DATE    TO SS01WS-JULIAN.
056100     PERFORM SS26PD-NUMERICALLY-EDIT-DATE THRU SS26PD-NED-EXIT.
056200     MOVE MMSH-REF-BATCH-DATE    TO MB21WS-JULIAN.
056300     MOVE SS01WS-XX-XX-YYYY      TO MB21WS-GREG.
056400     INSPECT MB21WS-JULIAN       REPLACING ALL ',' BY '-'.
056500     PERFORM MB21PD-INSERT-A-COLUMN
056600                                 THRU MB21PD-IAC-EXIT.
056700*
056800     MOVE 'REF-BATCH-SOURCE'     TO MB21WS-NAME.
056900     MOVE MMSH-REF-BATCH-SOURCE  TO MB21WS-5V0.
057000     PERFORM MB21PD-INSERT-A-COLUMN
057100                                 THRU MB21PD-IAC-EXIT.
057200*
057300     MOVE 'REF-BATCH-NBR'        TO MB21WS-NAME.
057400     MOVE MMSH-REF-BATCH-NBR     TO MB21WS-5V0.
057500     PERFORM MB21PD-INSERT-A-COLUMN
057600                                 THRU MB21PD-IAC-EXIT.
057700*
057800     MOVE 'REF-BATCH-SEQ'        TO MB21WS-NAME.
057900     MOVE MMSH-REF-BATCH-SEQ     TO MB21WS-10V0.
058000     PERFORM MB21PD-INSERT-A-COLUMN
058100                                 THRU MB21PD-IAC-EXIT.
058200*
058300     MOVE 'REF-NBR'              TO MB21WS-NAME.
058400     MOVE MMSH-REF-NBR           TO MB21WS-23X.
058500     PERFORM MB21PD-INSERT-A-COLUMN
058600                                 THRU MB21PD-IAC-EXIT.
058700*
058800     MOVE 'REF-AMOUNT-1'         TO MB21WS-NAME.
058900     MOVE MMSH-REF-AMOUNT-1      TO MB21WS-17V0.
059000     PERFORM MB21PD-INSERT-A-COLUMN
059100                                 THRU MB21PD-IAC-EXIT.
059200*
059300     MOVE 'REF-AMOUNT-2'         TO MB21WS-NAME.
059400     MOVE MMSH-REF-AMOUNT-2      TO MB21WS-17V0.
059500     PERFORM MB21PD-INSERT-A-COLUMN
059600                                 THRU MB21PD-IAC-EXIT.
059700*
059800     MOVE 'REF-NBR-ITEMS'        TO MB21WS-NAME.
059900     MOVE MMSH-REF-NBR-ITEMS     TO MB21WS-10V0.
060000     PERFORM MB21PD-INSERT-A-COLUMN
060100                                 THRU MB21PD-IAC-EXIT.
060200*
060300     MOVE 'REF-PRODUCT'          TO MB21WS-NAME.
060400     MOVE MMSH-REF-PRODUCT       TO MB21WS-2V0.
060500     PERFORM MB21PD-INSERT-A-COLUMN
060600                                 THRU MB21PD-IAC-EXIT.
060700*
060800     MOVE 'REF-PLAN'             TO MB21WS-NAME.
060900     MOVE MMSH-REF-PLAN          TO MB21WS-5V0.
061000     PERFORM MB21PD-INSERT-A-COLUMN
061100                                 THRU MB21PD-IAC-EXIT.
061200*
061300     MOVE 'REF-QUAL-LEVEL'       TO MB21WS-NAME.
061400     MOVE MMSH-REF-QUAL-LEVEL    TO MB21WS-2V0.
061500     PERFORM MB21PD-INSERT-A-COLUMN
061600                                 THRU MB21PD-IAC-EXIT.
061700*
061800     MOVE 'ORIG-GL-SOURCE'       TO MB21WS-NAME.
061900     MOVE MMSH-ORIG-GL-SOURCE    TO MB21WS-1V0.
062000     PERFORM MB21PD-INSERT-A-COLUMN
062100                                 THRU MB21PD-IAC-EXIT.
062200*
062300     MOVE 'GL-SOURCE'            TO MB21WS-NAME.
062400     MOVE MMSH-GL-SOURCE         TO MB21WS-1V0.
062500     PERFORM MB21PD-INSERT-A-COLUMN
062600                                 THRU MB21PD-IAC-EXIT.
062700*
062800     MOVE 'TRANS STATUS'         TO MB21WS-NAME.
062900     MOVE MMSH-TRANS-STATUS      TO MB21WS-X.
063000     PERFORM MB21PD-INSERT-A-COLUMN
063100                                 THRU MB21PD-IAC-EXIT.
063200*
063300     MOVE 'QUAL INDICATOR'       TO MB21WS-NAME.
063400     MOVE MMSH-QUAL-INDICATOR    TO MB21WS-X.
063500     PERFORM MB21PD-INSERT-A-COLUMN
063600                                 THRU MB21PD-IAC-EXIT.
063700*
063800     MOVE 'DATA ENTRY MODE'      TO MB21WS-NAME.
063900     MOVE MMSH-DATA-ENTRY-MODE   TO MB21WS-X.
064000     PERFORM MB21PD-INSERT-A-COLUMN
064100                                 THRU MB21PD-IAC-EXIT.
064200*
064300     MOVE 'REJECT REENTRY FLAG'  TO MB21WS-NAME.
064400     MOVE MMSH-REJECT-REENTRY-FLAG
064500                                 TO MB21WS-X.
064600     PERFORM MB21PD-INSERT-A-COLUMN
064700                                 THRU MB21PD-IAC-EXIT.
064800*
064900     MOVE 'AR-CURR-INPUT-SOURCE' TO MB21WS-NAME.
065000     MOVE MMSH-AR-CURR-INPUT-SOURCE
065100                                 TO MB21WS-X.
065200     PERFORM MB21PD-INSERT-A-COLUMN
065300                                 THRU MB21PD-IAC-EXIT.
065400*
065500     MOVE 'AR-MT-TYPE'           TO MB21WS-NAME.
065600     MOVE MMSH-AR-MT-TYPE        TO MB21WS-X.
065700     PERFORM MB21PD-INSERT-A-COLUMN
065800                                 THRU MB21PD-IAC-EXIT.
065900*
066000     MOVE 'STORE DUP IND'        TO MB21WS-NAME.                  RG800902
066100     MOVE MMSH-STORE-DUP-IND     TO MB21WS-X.                     RG800902
066200     PERFORM MB21PD-INSERT-A-COLUMN
066300                                 THRU MB21PD-IAC-EXIT.
066400*
066500     MOVE 'MERCH DUP IND'        TO MB21WS-NAME.                  RG800902
066600     MOVE MMSH-MERCH-DUP-IND     TO MB21WS-X.                     RG800902
066700     PERFORM MB21PD-INSERT-A-COLUMN
066800                                 THRU MB21PD-IAC-EXIT.
066900*
067000     MOVE 'ORIG OPERATOR'        TO MB21WS-NAME.
067100     MOVE MMSH-ORIG-OPERATOR     TO MB21WS-3X.
067200     PERFORM MB21PD-INSERT-A-COLUMN
067300                                 THRU MB21PD-IAC-EXIT.
067400*
067500     MOVE 'LAST OPERATOR'        TO MB21WS-NAME.
067600     MOVE MMSH-LAST-OPERATOR     TO MB21WS-3X.
067700     PERFORM MB21PD-INSERT-A-COLUMN
067800                                 THRU MB21PD-IAC-EXIT.
067900*
068000     MOVE 'GOVERNING-STATE'      TO MB21WS-NAME.
068100     MOVE MMSH-GOVERNING-STATE   TO MB21WS-3X.
068200     PERFORM MB21PD-INSERT-A-COLUMN
068300                                 THRU MB21PD-IAC-EXIT.
068400*
068500     MOVE 'LOGO'                 TO MB21WS-NAME.
068600     MOVE MMSH-LOGO              TO MB21WS-3V0.
068700     PERFORM MB21PD-INSERT-A-COLUMN
068800                                 THRU MB21PD-IAC-EXIT.
068900*
069000     MOVE 'SKU-NBR'              TO MB21WS-NAME.
069100     MOVE MMSH-SKU-NBR           TO MB21WS-9V0.
069200     PERFORM MB21PD-INSERT-A-COLUMN
069300                                 THRU MB21PD-IAC-EXIT.
069400*
069500     MOVE 'DEPT-CODE'            TO MB21WS-NAME.
069600     MOVE MMSH-DEPT-CODE         TO MB21WS-4X.
069700     PERFORM MB21PD-INSERT-A-COLUMN
069800                                 THRU MB21PD-IAC-EXIT.
069900*
070000     MOVE 'DESC'                 TO MB21WS-NAME.
070100     PERFORM MB21PD-INSERT-A-COLUMN
070200                                 THRU MB21PD-IAC-EXIT.
070300     MOVE MMSH-DESC              TO MB21WS-X40.
070400     PERFORM MB21PD-INSERT-A-COLUMN
070500                                 THRU MB21PD-IAC-EXIT.
070600*
070610     MOVE 'CARD PROD TYPE'       TO MB21WS-NAME.                  RG800902
070612     MOVE MMSH-CARD-PROD-TYPE    TO MB21WS-3X.                    RG800902
070614     PERFORM MB21PD-INSERT-A-COLUMN                               RG800902
070616                                 THRU MB21PD-IAC-EXIT.            RG800902
070618*                                                                 RG800902
070620     MOVE 'CATEGORY-CODE'        TO MB21WS-NAME.                  RG800902
070622     MOVE MMSH-CATEGORY-CODE     TO MB21WS-4X.                    RG800902
070624     PERFORM MB21PD-INSERT-A-COLUMN                               RG800902
070626                                 THRU MB21PD-IAC-EXIT.            RG800902
070628*                                                                 RG800902
070700     MOVE 'RPT-DESC'             TO MB21WS-NAME.
070800     MOVE MMSH-RPT-DESC          TO MB21WS-15X.
070900     PERFORM MB21PD-INSERT-A-COLUMN
071000                                 THRU MB21PD-IAC-EXIT.
071100*
071200     MOVE 'POST-FLAG'            TO MB21WS-NAME.
071300     MOVE MMSH-POST-FLAG         TO MB21WS-2V0.
071400     PERFORM MB21PD-INSERT-A-COLUMN
071500                                 THRU MB21PD-IAC-EXIT.
071600*
071700     MOVE 'VAR-DATA-IND'         TO MB21WS-NAME.
071800     MOVE MMSH-VAR-DATA-IND      TO MB21WS-1V0.
071900     PERFORM MB21PD-INSERT-A-COLUMN
072000                                 THRU MB21PD-IAC-EXIT.
072100*
072200     EVALUATE TRUE
072300         WHEN MMSH-VDI-DEPOSIT-DATA
072400             PERFORM V100-DEPOSIT-DATA
072500                THRU V199-DD-EXIT
072600         WHEN MMSH-VDI-FEE-DATA
072700             PERFORM V200-FEE-DATA
072800                THRU V299-FD-EXIT
072900         WHEN MMSH-VDI-HEADER-DATA
073000             PERFORM V300-HEADER-DATA
073100                THRU V399-HD-EXIT
073200     END-EVALUATE.
073300*
073400     PERFORM MB21PD-INSERT-A-COLUMN
073500                                 THRU MB21PD-IAC-EXIT 2 TIMES.
073600*
073700 B999-PRT-EXIT.
073800     EXIT.
073900*
074000 B200-PRINT-HEADER.
074100*
074200     MOVE 'STMT/SETT HISTORY HEADER RECORD (MMSH)'
074300                                 TO MB21WS-PRINT-WORK-AREA.
074400     PERFORM MB21PD-INSERT-A-COLUMN
074500                                 THRU MB21PD-IAC-EXIT.
074600*
074700     MOVE SPACES                 TO MB21WS-PRINT-WORK-AREA.
074800     MOVE 'ORG'                  TO MB21WS-NAME.
074900     MOVE MMSHIO-ORG             TO MB21WS-3V0.
075000     PERFORM MB21PD-INSERT-A-COLUMN
075100                                 THRU MB21PD-IAC-EXIT.
075200*
075300     MOVE 'MERCHANT-NBR'         TO MB21WS-NAME.
075400     MOVE MMSHIO-MERCHANT        TO MB21WS-9V0.
075500     PERFORM MB21PD-INSERT-A-COLUMN
075600                                 THRU MB21PD-IAC-EXIT.
075700*
075800     MOVE 'SEQUENCE-NBR'         TO MB21WS-NAME.
075900     MOVE MMSHIO-SEQ-NBR         TO MB21WS-10V0.
076000     PERFORM MB21PD-INSERT-A-COLUMN
076100                                 THRU MB21PD-IAC-EXIT.
076200*
076300     MOVE 'DATE-STAMP'           TO MB21WS-NAME.
076400     MOVE MMSHIO-DATE-STAMP      TO SS01WS-JULIAN.
076500     PERFORM SS26PD-NUMERICALLY-EDIT-DATE THRU SS26PD-NED-EXIT.
076600     MOVE MMSHIO-DATE-STAMP      TO MB21WS-JULIAN.
076700     MOVE SS01WS-XX-XX-YYYY      TO MB21WS-GREG.
076800     INSPECT MB21WS-JULIAN       REPLACING ALL ',' BY '-'.
076900     PERFORM MB21PD-INSERT-A-COLUMN
077000                                 THRU MB21PD-IAC-EXIT.
077100*
077200     MOVE 'TIME-STAMP'           TO MB21WS-NAME.
077300     MOVE MMSHIO-TIME-STAMP      TO SS01WS-TIME-HHMMSS.
077400     PERFORM SS27PD-NUMERICALLY-EDIT-TIME
077500                                 THRU SS27PD-NET-EXIT.
077600     MOVE SS01WS-HH-MM-SS        TO MB21WS-TIME.
077700     PERFORM MB21PD-INSERT-A-COLUMN
077800                                 THRU MB21PD-IAC-EXIT.
077900*
078000     PERFORM MB21PD-PRINT-A-PAGE
078100                                 THRU MB21PD-PAP-EXIT.
078200*
078300 B200-PH-EXIT.
078400     EXIT.
078500/
078600 V100-DEPOSIT-DATA.
078700*
078800     MOVE '*---------  MMSH DEPOSIT-DATA ---------*'
078900                                 TO MB21WS-PRINT-WORK-AREA.
079000     PERFORM MB21PD-INSERT-A-COLUMN
079100                                 THRU MB21PD-IAC-EXIT.
079200*
079300     MOVE 'AR-ORG'               TO MB21WS-NAME.
079400     MOVE MMSH-AR-ORG            TO MB21WS-3V0.
079500     PERFORM MB21PD-INSERT-A-COLUMN
079600                                 THRU MB21PD-IAC-EXIT.
079700*
079800     MOVE 'AR-ACCT'              TO MB21WS-NAME.
079900     MOVE MMSH-AR-ACCT           TO MB21WS-19X.
080000     PERFORM MB21PD-INSERT-A-COLUMN
080100                                 THRU MB21PD-IAC-EXIT.
080200*
080300     MOVE 'AR-TRANS-CODE'        TO MB21WS-NAME.
080400     MOVE MMSH-AR-TRANS-CODE     TO MB21WS-3V0.
080500     PERFORM MB21PD-INSERT-A-COLUMN
080600                                 THRU MB21PD-IAC-EXIT.
080700*
080800     MOVE 'AR-LOGIC-MODULE'      TO MB21WS-NAME.
080900     MOVE MMSH-AR-LOGIC-MODULE   TO MB21WS-2V0.
081000     PERFORM MB21PD-INSERT-A-COLUMN
081100                                 THRU MB21PD-IAC-EXIT.
081200*
081300     MOVE 'AR-POST-FLAG'         TO MB21WS-NAME.
081400     MOVE MMSH-AR-POST-FLAG      TO MB21WS-2V0.
081500     PERFORM MB21PD-INSERT-A-COLUMN
081600                                 THRU MB21PD-IAC-EXIT.
081700*
081800     MOVE 'INDIV-DISC-FLAG'      TO MB21WS-NAME.
081900     MOVE MMSH-INDIV-DISC-FLAG   TO MB21WS-X.
082000     PERFORM MB21PD-INSERT-A-COLUMN
082100                                 THRU MB21PD-IAC-EXIT.
082200*
082300     MOVE 'INDIV-DISC-AMT'       TO MB21WS-NAME.
082400     MOVE MMSH-INDIV-DISC-AMT    TO MB21WS-17V0.
082500     PERFORM MB21PD-INSERT-A-COLUMN
082600                                 THRU MB21PD-IAC-EXIT.
082700*
082800     MOVE 'INDIV-DISC-IND'       TO MB21WS-NAME.
082900     MOVE MMSH-INDIV-DISC-IND    TO MB21WS-X.
083000     PERFORM MB21PD-INSERT-A-COLUMN
083100                                 THRU MB21PD-IAC-EXIT.
083200*
083300     IF  MMSH-IDI-IS-PER-ITEM
083400         MOVE 'INDIV-DISC-PER-ITEM'
083500                                 TO MB21WS-NAME
083600         MOVE MMSH-INDIV-DISC-PER-ITEM
083700                                 TO MB21WS-9V0
083800         PERFORM MB21PD-INSERT-A-COLUMN
083900                                 THRU MB21PD-IAC-EXIT
084000         MOVE 'INDIV-DISC-ADJ-PER-ITEM'
084100                                 TO MB21WS-NAME
084200         MOVE MMSH-INDIV-DISC-ADJ-PER-ITEM
084300                                 TO MB21WS-9V0
084400         PERFORM MB21PD-INSERT-A-COLUMN
084500                                 THRU MB21PD-IAC-EXIT
084600     ELSE
084700         MOVE 'INDIV-DISC-ADJ-RATE'
084800                                 TO MB21WS-NAME
084900         MOVE MMSH-INDIV-DISC-RATE
085000                                 TO MB21WS-9V0
085100         PERFORM MB21PD-INSERT-A-COLUMN
085200                                 THRU MB21PD-IAC-EXIT
085300         MOVE 'INDIV-DISC-RATE'  TO MB21WS-NAME
085400         MOVE MMSH-INDIV-DISC-RATE
085500                                 TO MB21WS-9V0
085600         PERFORM MB21PD-INSERT-A-COLUMN
085700                                 THRU MB21PD-IAC-EXIT.
085800*
085900     MOVE 'INDIV-PART-FLAG'      TO MB21WS-NAME.
086000     MOVE MMSH-INDIV-PART-FLAG   TO MB21WS-X.
086100     PERFORM MB21PD-INSERT-A-COLUMN
086200                                 THRU MB21PD-IAC-EXIT.
086300*
086400     MOVE 'INDIV-PART-AMT'       TO MB21WS-NAME.
086500     MOVE MMSH-INDIV-PART-AMT    TO MB21WS-17V0.
086600     PERFORM MB21PD-INSERT-A-COLUMN
086700                                 THRU MB21PD-IAC-EXIT.
086800*
086900     MOVE 'INDIV-PART-IND'       TO MB21WS-NAME.
087000     MOVE MMSH-INDIV-PART-IND    TO MB21WS-X.
087100     PERFORM MB21PD-INSERT-A-COLUMN
087200                                 THRU MB21PD-IAC-EXIT.
087300*
087400     IF  MMSH-IDI-IS-PER-ITEM
087500         MOVE 'INDIV-PART-PER-ITEM'
087600                                 TO MB21WS-NAME
087700         MOVE MMSH-INDIV-PART-PER-ITEM
087800                                 TO MB21WS-9V0
087900         PERFORM MB21PD-INSERT-A-COLUMN
088000                                 THRU MB21PD-IAC-EXIT
088100         MOVE 'INDIV-PART-ADJ-PER-ITEM'
088200                                 TO MB21WS-NAME
088300         MOVE MMSH-INDIV-PART-ADJ-PER-ITEM
088400                                 TO MB21WS-9V0
088500         PERFORM MB21PD-INSERT-A-COLUMN
088600                                 THRU MB21PD-IAC-EXIT
088700     ELSE
088800         MOVE 'INDIV-PART-ADJ-RATE'
088900                                 TO MB21WS-NAME
089000         MOVE MMSH-INDIV-PART-RATE
089100                                 TO MB21WS-9V0
089200         PERFORM MB21PD-INSERT-A-COLUMN
089300                                 THRU MB21PD-IAC-EXIT
089400         MOVE 'INDIV-PART-RATE'  TO MB21WS-NAME
089500         MOVE MMSH-INDIV-PART-RATE
089600                                 TO MB21WS-9V0
089700         PERFORM MB21PD-INSERT-A-COLUMN
089800                                 THRU MB21PD-IAC-EXIT.
089900*
090000     MOVE 'AR AUTH CODE'         TO MB21WS-NAME.
090100     MOVE MMSH-AR-AUTH-CODE      TO MB21WS-6X.
090200     PERFORM MB21PD-INSERT-A-COLUMN
090300                                 THRU MB21PD-IAC-EXIT.
090400*
090500 V199-DD-EXIT.
090600     EXIT.
090700/
090800 V200-FEE-DATA.
090900*
091000     MOVE '*------------ MMSH FEE-DATA -----------*'
091100                                 TO MB21WS-PRINT-WORK-AREA.
091200     PERFORM MB21PD-INSERT-A-COLUMN
091300                                 THRU MB21PD-IAC-EXIT.
091400*
091500     MOVE 'AR-ORG'               TO MB21WS-NAME.
091600     MOVE MMSH-AR-ORG            TO MB21WS-3V0.
091700     PERFORM MB21PD-INSERT-A-COLUMN
091800                                 THRU MB21PD-IAC-EXIT.
091900*
092000     MOVE 'AR-ACCT'              TO MB21WS-NAME.
092100     MOVE MMSH-AR-ACCT           TO MB21WS-19X.
092200     PERFORM MB21PD-INSERT-A-COLUMN
092300                                 THRU MB21PD-IAC-EXIT.
092400*
092500     MOVE 'AR-TRANS-CODE'        TO MB21WS-NAME.
092600     MOVE MMSH-AR-TRANS-CODE     TO MB21WS-3V0.
092700     PERFORM MB21PD-INSERT-A-COLUMN
092800                                 THRU MB21PD-IAC-EXIT.
092900*
093000     MOVE 'AR-LOGIC-MODULE'      TO MB21WS-NAME.
093100     MOVE MMSH-AR-LOGIC-MODULE   TO MB21WS-2V0.
093200     PERFORM MB21PD-INSERT-A-COLUMN
093300                                 THRU MB21PD-IAC-EXIT.
093400*
093500     MOVE 'AR-POST-FLAG'         TO MB21WS-NAME.
093600     MOVE MMSH-AR-POST-FLAG      TO MB21WS-2V0.
093700     PERFORM MB21PD-INSERT-A-COLUMN
093800                                 THRU MB21PD-IAC-EXIT.
093900*
094000     MOVE 'FEE-FACTOR-NBR'       TO MB21WS-NAME.
094100     MOVE MMSH-FEE-FACTOR-NBR    TO MB21WS-9V0.
094200     PERFORM MB21PD-INSERT-A-COLUMN
094300                                 THRU MB21PD-IAC-EXIT.
094400*
094500     MOVE 'FEE-FACTOR-AMT'       TO MB21WS-NAME.
094600     MOVE MMSH-FEE-FACTOR-AMT    TO MB21WS-17V0.
094700     PERFORM MB21PD-INSERT-A-COLUMN
094800                                 THRU MB21PD-IAC-EXIT.
094900*
095000     MOVE 'FEE-INC-PER-ITEM'     TO MB21WS-NAME.
095100     MOVE MMSH-FEE-INC-PER-ITEM  TO MB21WS-17V0.
095200     PERFORM MB21PD-INSERT-A-COLUMN
095300                                 THRU MB21PD-IAC-EXIT.
095400*
095500     MOVE 'FEE-INC-RATE'         TO MB21WS-NAME.
095600     MOVE MMSH-FEE-INC-RATE      TO MB21WS-7V0.
095700     PERFORM MB21PD-INSERT-A-COLUMN
095800                                 THRU MB21PD-IAC-EXIT.
095900*
096000     MOVE 'FEE-EXP-PER-ITEM'     TO MB21WS-NAME.
096100     MOVE MMSH-FEE-EXP-PER-ITEM  TO MB21WS-17V0.
096200     PERFORM MB21PD-INSERT-A-COLUMN
096300                                 THRU MB21PD-IAC-EXIT.
096400*
096500     MOVE 'FEE-EXP-RATE'         TO MB21WS-NAME.
096600     MOVE MMSH-FEE-EXP-RATE      TO MB21WS-7V0.
096700     PERFORM MB21PD-INSERT-A-COLUMN
096800                                 THRU MB21PD-IAC-EXIT.
096900*
097000     MOVE 'FEE-EXP-AMOUNT'       TO MB21WS-NAME.
097100     MOVE MMSH-FEE-EXP-AMOUNT    TO MB21WS-17V0.
097200     PERFORM MB21PD-INSERT-A-COLUMN
097300                                 THRU MB21PD-IAC-EXIT.
097400*
097500 V299-FD-EXIT.
097600     EXIT.
097700/
097800 V300-HEADER-DATA.
097900*
098000     MOVE 'SALES-NBR'            TO MB21WS-NAME.
098100     MOVE MMSH-SALES-NBR         TO MB21WS-9V0.
098200     PERFORM MB21PD-INSERT-A-COLUMN
098300                                 THRU MB21PD-IAC-EXIT.
098400*
098500     MOVE 'SALES-AMT'            TO MB21WS-NAME.
098600     MOVE MMSH-SALES-AMT         TO MB21WS-17V0.
098700     PERFORM MB21PD-INSERT-A-COLUMN
098800                                 THRU MB21PD-IAC-EXIT.
098900*
099000     MOVE 'SALES-REV-NBR'        TO MB21WS-NAME.
099100     MOVE MMSH-SALES-REV-NBR     TO MB21WS-9V0.
099200     PERFORM MB21PD-INSERT-A-COLUMN
099300                                 THRU MB21PD-IAC-EXIT.
099400*
099500     MOVE 'SALES-REV-AMT'        TO MB21WS-NAME.
099600     MOVE MMSH-SALES-REV-AMT     TO MB21WS-17V0.
099700     PERFORM MB21PD-INSERT-A-COLUMN
099800                                 THRU MB21PD-IAC-EXIT.
099900*
100000     MOVE 'RETURNS-NBR'          TO MB21WS-NAME.
100100     MOVE MMSH-RETURNS-NBR       TO MB21WS-9V0.
100200     PERFORM MB21PD-INSERT-A-COLUMN
100300                                 THRU MB21PD-IAC-EXIT.
100400*
100500     MOVE 'RETURNS-AMT'          TO MB21WS-NAME.
100600     MOVE MMSH-RETURNS-AMT       TO MB21WS-17V0.
100700     PERFORM MB21PD-INSERT-A-COLUMN
100800                                 THRU MB21PD-IAC-EXIT.
100900*
101000     MOVE 'RETURNS-REV-NBR'      TO MB21WS-NAME.
101100     MOVE MMSH-RETURNS-REV-NBR   TO MB21WS-9V0.
101200     PERFORM MB21PD-INSERT-A-COLUMN
101300                                 THRU MB21PD-IAC-EXIT.
101400*
101500     MOVE 'RETURNS-REV-AMT'      TO MB21WS-NAME.
101600     MOVE MMSH-RETURNS-REV-AMT   TO MB21WS-17V0.
101700     PERFORM MB21PD-INSERT-A-COLUMN
101800                                 THRU MB21PD-IAC-EXIT.
101900*
102000     MOVE 'MEMO-NBR'             TO MB21WS-NAME.
102100     MOVE MMSH-MEMO-NBR          TO MB21WS-9V0.
102200     PERFORM MB21PD-INSERT-A-COLUMN
102300                                 THRU MB21PD-IAC-EXIT.
102400*
102500     MOVE 'MEMO-AMT'             TO MB21WS-NAME.
102600     MOVE MMSH-MEMO-AMT          TO MB21WS-17V0.
102700     PERFORM MB21PD-INSERT-A-COLUMN
102800                                 THRU MB21PD-IAC-EXIT.
102900*
103000 V399-HD-EXIT.
103100     EXIT.
103200/
103300* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
103400*                          COMMON ROUTINES                      *
103500* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
103600*
103700     COPY SS02PD.
103800/
103900     COPY SS08PD.
104000/
104100     COPY SS16PD.
104200/
104300     COPY SS26PD.
104400/
104500     COPY SS27PD.
104600/
104700     COPY MB20PD.
104800/
104900     COPY MB21PD.
105000/
105100     COPY MB99PD.
105200/
105300     COPY MB00PD REPLACING ==:MB00:== BY ==MTCC==.
105400/
105500     COPY MB00PD REPLACING ==:MB00:== BY ==MMSH==.
105600/
105700     COPY MB00PD REPLACING ==:MB00:== BY ==MMSC==.
105800/
105900     COPY MB00PD REPLACING ==:MB00:== BY ==MBMF==.
