000100 IDENTIFICATION DIVISION.
000200 PROGRAM-ID. MBU922.
000201*       RELEASE DATE=08/24/01.        REVISION LEVEL=08.06      * ++++++++
000202***************************************************************** ++++++++
000203*WARNING.  THIS COMPUTER PROGRAM IS PROTECTED BY COPYRIGHT LAW  * ++++++++
000204*AND INTERNATIONAL TREATIES.  UNAUTHORIZED REPRODUCTION OR      * ++++++++
000205*DISTRIBUTION OF THIS PROGRAM, OR ANY PORTION OF IT, MAY RESULT * ++++++++
000206*IN SEVERE CIVIL AND CRIMINAL PENATLIES, AND WILL BE PROSECUTED * ++++++++
000207*TO THE MAXIMUM EXTENT POSSIBLE UNDER THE LAW.                  * ++++++++
000208*COPYRIGHT 1999 PAYSYS INTERNATIONAL, INC.  ALL RIGHTS RESERVED.* ++++++++
000209***************************************************************** ++++++++
000300*****************************************************************
000400*                                                               *
000500*       MBU922 - WAREHOUSE TRANSACTIONS FILE DISPLAY (MMWT)     *
000600*                                                               *
000700*****************************************************************
000800 ENVIRONMENT DIVISION.
000900 CONFIGURATION SECTION.
001000 SOURCE-COMPUTER.   IBM-4341.
001100 OBJECT-COMPUTER.   IBM-4341.
001200/
001300 INPUT-OUTPUT SECTION.
001400 FILE-CONTROL.
001500/
001600 DATA DIVISION.
001700 FILE SECTION.
001800 WORKING-STORAGE SECTION.
001900*
002000 01  FILLER                  PIC  X(12)      VALUE '** WS-BEG **'.
002100*
002200     COPY MB00RB REPLACING ==:MB00:== BY ==MTCC==.
002300/
002400     COPY MB00RB REPLACING ==:MB00:== BY ==MMSC==.
002500/
002600     COPY MB00RB REPLACING ==:MB00:== BY ==MMWT==.
002700/
002800     COPY MBU999WS.
002900/
003000     COPY MB00RB REPLACING ==:MB00:== BY ==MBMF==.
003100/
003200     COPY MTCCRL REPLACING ==:MTCC:== BY ==MTCC==.
003300/
003400     COPY MMSCRL.
003500/
003600     COPY MTPTRL REPLACING ==:MTPT:== BY ==MMWT==.
003700/
003800     COPY MBMFRL.
003900/
004000     COPY MTCCIO REPLACING ==:MTCC:== BY ==MTCC==.
004100/
004200     COPY MMSCIO.
004300/
004400     COPY MTPTIO REPLACING ==:MTPT:== BY ==MMWT==.
004500/
004600     COPY MBMFIO.
004700/
004800     COPY MB00WS.
004900/
005000     COPY MB20WS.
005100/
005200     COPY MB21WS.
005300/
005400     COPY MB99WS.
005500/
005600     COPY SS00WS.
005700/
005800     COPY SS01WS.
005900/
006000     COPY SS02WS.
006100/
006200 01  WS-WORK-AREAS.
006300     03  WS-PROG-ID          PIC  X(06)      VALUE 'MBU922'.
006400     03  WS-CARD-READ-SW     PIC  X(01)      VALUE 'N'.
006500*
006600     03  WS-MMWT-BEG-KEY.
006700         05  WS-MMWT-BEG-ORG-MERCHANT.
006800             07  WS-MMWT-BEG-ORG
006900                             PIC  9(03)      VALUE ZEROES.
007000             07  WS-MMWT-BEG-MERCHANT
007100                             PIC  9(09)      VALUE ZEROES.
007200         05  WS-MMWT-BEG-SEQ PIC S9(08)      BINARY VALUE ZEROES.
007300*
007400     03  WS-MMWT-END-KEY.
007500         05  WS-MMWT-END-ORG-MERCHANT.
007600             07  WS-MMWT-END-ORG
007700                             PIC  9(03)      VALUE ZEROES.
007800             07  WS-MMWT-END-MERCHANT
007900                             PIC  9(09)      VALUE ZEROES.
008000*
008100     03  WS-BACKUP-OR-MASTER PIC  X(06)      VALUE SPACES.
008200         88  WS-BACKUP                       VALUE 'BACKUP'.
008300         88  WS-MASTER                       VALUE 'MASTER'.
008400*
008500 01  FILLER                  PIC  X(12)      VALUE '** WS-END **'.
008600/
008700 PROCEDURE DIVISION.
008800*
008900 A000-DRIVER.
009000*
009100     MOVE 'MBU922'               TO SS02WS-ABEND-PROG-ID
009200                                    MBU999WS-PROGRAM-ID.
009300*
009400     CALL MB00WS-MBU999CC        USING MBU999WS-AREA.
009500*
009600     MOVE 'MB000000'             TO MB20WS-SH-RPT-ID.
009700     MOVE 'T922'                 TO MB20WS-SH-INTERNAL-RPT-ID.
009800     MOVE '  WAREHOUSE/TRANSACTION FILE  '
009900                                 TO MB20WS-SH-RPT-NAME.
010000     MOVE SPACES                 TO MB20WS-SH-LIT-1
010100                                    MB20WS-SH-LIT-5
010200                                    MB20WS-SH-L4
010300                                    MB20WS-SH-L5
010400                                    MB20WS-SH-L6.
010500     PERFORM MB21PD-PAP-RESET-INDEXES
010600                                 THRU MB21PD-PAP-EXIT.
010700*
010800 A100-OPEN-FILES.
010900*
011000     MOVE SPACES                 TO MB21WS-PRINT-PAGE.
011100     MOVE 'O1CC'                 TO SS02WS-ABEND-LOCATION.
011200     MOVE SS02WS-END-OF-FILE     TO MTCCRB-PERM-STATUS-1.
011300     SET MTCCRB-OPEN-INPUT       TO TRUE.
011400     PERFORM MB00PD-MTCC-ACCESS  THRU MB00PD-MTCC-ACCESS-EXIT.
011500*
011600     MOVE 'O1SC'                 TO SS02WS-ABEND-LOCATION.
011700     SET MMSCRB-OPEN-INPUT       TO TRUE.
011800     PERFORM MB00PD-MMSC-ACCESS  THRU MB00PD-MMSC-ACCESS-EXIT.
011900*
012000     MOVE 'R1SC'                 TO SS02WS-ABEND-LOCATION.
012100     SET  MMSCRB-READ-SEQ        TO TRUE.
012200     PERFORM MB00PD-MMSC-ACCESS  THRU MB00PD-MMSC-ACCESS-EXIT.
012300     MOVE 'MMSC'                 TO MB99WS-FILE-ID.
012400*
012500     IF  MMSCIO-HEADER
012600         NEXT SENTENCE
012700     ELSE
012800         PERFORM MB99PD-MISSING-HEADER-ABEND
012900            THRU MB99PD-MHA-EXIT.
013000*
013100     MOVE MMSCIO-RECORD          TO MMSC-RECORD.
013200*
013210     MOVE MMSC-DATE-FORMAT       TO SS01WS-DATE-FORMAT.
013300     MOVE MMSC-TODAYS-JULIAN     TO SS01WS-JULIAN.
013400     PERFORM SS26PD-NUMERICALLY-EDIT-DATE THRU SS26PD-NED-EXIT.
013500     MOVE SS01WS-XX-XX-YYYY      TO MB20WS-SH-FILE-DATE.
013600     MOVE MMSC-TIME-STAMP        TO SS01WS-TIME-HHMMSS.
013700     PERFORM SS27PD-NUMERICALLY-EDIT-TIME
013800                                 THRU SS27PD-NET-EXIT.
013900     MOVE SS01WS-HH-MM-SS        TO MB20WS-SH-PROC-TIME .
014000*
014100     MOVE MMSC-FORM              TO MB20WS-FORM-CODE.
014200     MOVE MMSC-FICHE-FLAG        TO MB20WS-FICHE-CODE.
014300     MOVE MMSC-LINES-PER-PAGE    TO MB20WS-LINES-PER-PAGE.
014400     MOVE 99                     TO MB20WS-LINE-LIMIT.
014500     COMPUTE MB21WS-LIN-LIMIT    =  MMSC-LINES-PER-PAGE - 4.
014600     MOVE MMSC-SCREEN-HEADER     TO MB20WS-SH-SYSTEM.
014800*
014900     MOVE 'R1CC'                 TO SS02WS-ABEND-LOCATION.
015000     SET MTCCRB-READ-SEQ         TO TRUE.
015100     PERFORM MB00PD-MTCC-ACCESS  THRU MB00PD-MTCC-ACCESS-EXIT.
015200*
015300     IF  SS02WS-FS-END-OF-FILE
015400         GO TO A400-CHECK-READ-SWITCH
015500     END-IF.
015600*
015700     IF  MTCCIO-PROGRAM-ID IS NOT EQUAL TO WS-PROG-ID
015800         GO TO A200-PROGRAM-CONTROL
015900     END-IF.
016000*
016100     MOVE MTCCIO-CARD-DATA       TO MTCC-RECORD.
016200*
016300     IF  MTCC-MBU9XX-BACKUP
016400         MOVE 'BACKUP'           TO WS-BACKUP-OR-MASTER
016500         MOVE 'O1MF'             TO SS02WS-ABEND-LOCATION
016600         SET MBMFRB-OPEN-INPUT   TO TRUE
016700         PERFORM MB00PD-MBMF-ACCESS THRU MB00PD-MBMF-ACCESS-EXIT
016800         MOVE 'R1MF'             TO SS02WS-ABEND-LOCATION
016900         SET MBMFRB-READ-SEQ     TO TRUE
017000         MOVE SS02WS-NO-RECORD-FOUND
017100                                 TO MBMFRB-PERM-STATUS-3
017200         MOVE SS02WS-END-OF-FILE
017300                                 TO MBMFRB-PERM-STATUS-4
017400         PERFORM MB00PD-MBMF-ACCESS THRU MB00PD-MBMF-ACCESS-EXIT
017500     ELSE
017600         MOVE 'O1WT'             TO SS02WS-ABEND-LOCATION
017700         SET MMWTRB-OPEN-INPUT   TO TRUE
017800         PERFORM MB00PD-MMWT-ACCESS THRU MB00PD-MMWT-ACCESS-EXIT
017900         MOVE 'R1WT'             TO SS02WS-ABEND-LOCATION
018000         SET MMWTRB-READ-SEQ     TO TRUE
018100         MOVE SS02WS-NO-RECORD-FOUND
018200                                 TO MMWTRB-PERM-STATUS-3
018300         MOVE SS02WS-END-OF-FILE
018400                                 TO MMWTRB-PERM-STATUS-4
018500         PERFORM MB00PD-MMWT-ACCESS THRU MB00PD-MMWT-ACCESS-EXIT
018600         GO TO A130-PRINT-HR-RECORD
018700     END-IF.
018800*
018900     MOVE 'MBMF'                 TO MB99WS-FILE-ID.
019000*
019100     IF  MBMFIO-FILE-IS-HEADER
019200         NEXT SENTENCE
019300     ELSE
019400         PERFORM MB99PD-MISSING-HEADER-ABEND
019500            THRU MB99PD-MHA-EXIT.
019600*
019700     MOVE MBMFIO-RECORD          TO MBMF-RECORD.
019800*
019900     SET X-MBMF-FILE             TO 1.
020000*
020100 A110-SEARCH-HEADER-TABLE-LOOP.
020200*
020300     IF  X-MBMF-FILE IS GREATER THAN 75
020400         MOVE 'MMWT'             TO MB99WS-FILE-ID
020500         PERFORM MB99PD-NOT-ON-BACKUP
020600            THRU MB99PD-NOB-EXIT.
020700*
020800     IF  MBMF-MBU020-ENTRY (X-MBMF-FILE) IS EQUAL TO 'WT'
020900         CONTINUE
021000     ELSE
021100         SET X-MBMF-FILE         UP BY 1
021200         GO TO A110-SEARCH-HEADER-TABLE-LOOP
021300     END-IF.
021400*
021500 A120-READ-MBMF-LOOP.
021600*
021700     MOVE 'R2MF'                 TO SS02WS-ABEND-LOCATION.
021800     SET MBMFRB-READ-SEQ         TO TRUE.
021900     PERFORM MB00PD-MBMF-ACCESS  THRU MB00PD-MBMF-ACCESS-EXIT.
022000*
022100     IF  SS02WS-FS-END-OF-FILE
022200         GO TO A200-PROGRAM-CONTROL
022300     END-IF.
022400*
022500     IF  MBMFIO-FILE-IS-MMWT
022600         CONTINUE
022700     ELSE
022800         GO TO A120-READ-MBMF-LOOP
022900     END-IF.
023000*
023100 A130-PRINT-HR-RECORD.
023200*
023300     IF  WS-BACKUP
023400         MOVE MBMFIO-VAR-DATA    TO MMWTIO-RECORD
023500     END-IF.
023600*
023700     MOVE 'MMWT'                 TO MB99WS-FILE-ID.
023800*
023900     IF  MMWTIO-HEADER
024000         PERFORM B200-PRINT-HEADER
024100                                 THRU B200-PH-EXIT
024200     ELSE
024300         PERFORM MB99PD-MISSING-HEADER-ABEND
024400            THRU MB99PD-MHA-EXIT.
024500*
024600     MOVE MMWTIO-RECORD          TO MMWT-RECORD.
024700*
024800 A200-PROGRAM-CONTROL.
024900*
025000     IF  MTCC-MBU9XX-BACKUP OR MTCC-MBU9XX-MASTER
025100         MOVE MTCC-MBU9XX-OPTION TO WS-BACKUP-OR-MASTER
025200     ELSE
025300         IF  WS-BACKUP-OR-MASTER IS EQUAL TO SPACES
025400             MOVE 'MASTER'       TO WS-BACKUP-OR-MASTER
025500             GO TO A210-PC-BY-FIRST-READ.
025600*
025700     MOVE 'R2CC'                 TO SS02WS-ABEND-LOCATION.
025800     SET MTCCRB-READ-SEQ         TO TRUE.
025900     PERFORM MB00PD-MTCC-ACCESS  THRU MB00PD-MTCC-ACCESS-EXIT.
026000*
026100     IF  SS02WS-FS-END-OF-FILE
026200         GO TO A400-CHECK-READ-SWITCH
026300     END-IF.
026400*
026500 A210-PC-BY-FIRST-READ.
026600*
026700     IF  MTCCIO-PROGRAM-ID  IS NOT EQUAL TO WS-PROG-ID
026800         GO TO A200-PROGRAM-CONTROL
026900     END-IF.
027000*
027100     MOVE MTCCIO-CARD-DATA       TO MTCC-RECORD.
027200*
027300 A300-RANGE-CARD.
027400*
027500     MOVE 'Y'                    TO WS-CARD-READ-SW.
027600     INSPECT MTCC-MBU922-BEG-X   REPLACING ALL SPACE BY ZERO.
027700*
027800     IF  MTCC-MBU922-END-X IS EQUAL TO SPACES
027900         MOVE MTCC-MBU922-BEG-X  TO MTCC-MBU922-END-X
028000     END-IF.
028100*
028200     INSPECT MTCC-MBU922-END-X   REPLACING ALL SPACE BY ZERO.
028300*
028400     MOVE MTCC-MBU922-BEG-ORG    TO WS-MMWT-BEG-ORG.
028500     MOVE MTCC-MBU922-BEG-MERCHANT
028600                                 TO WS-MMWT-BEG-MERCHANT.
028700*
028800     MOVE MTCC-MBU922-END-ORG    TO WS-MMWT-END-ORG.
028900     MOVE MTCC-MBU922-END-MERCHANT
029000                                 TO WS-MMWT-END-MERCHANT.
029100*
029200     IF  WS-BACKUP
029300         GO TO A350-READ-NEXT-MBMF
029400     END-IF.
029500*
029600 A350-READ-NEXT.
029700*
029800     MOVE 'R2WT'                 TO SS02WS-ABEND-LOCATION.
029900     SET  MMWTRB-READ-SEQ        TO TRUE.
030000     PERFORM MB00PD-MMWT-ACCESS  THRU MB00PD-MMWT-ACCESS-EXIT.
030100*
030200     IF  SS02WS-FS-END-OF-FILE
030300         IF  MB21WS-PRINT-PAGE IS EQUAL TO SPACES
030400             GO TO A200-PROGRAM-CONTROL
030500         ELSE
030600             PERFORM MB21PD-PRINT-A-PAGE
030700                                 THRU MB21PD-PAP-EXIT
030800             GO TO A200-PROGRAM-CONTROL.
030900*
031000     IF  MMWTIO-KEY IS LESS THAN WS-MMWT-BEG-KEY
031100         GO TO A350-READ-NEXT-MBMF
031200     END-IF.
031300*
031400     IF  MMWTIO-ORG-MERCHANT IS GREATER THAN WS-MMWT-END-KEY
031500         IF  MB21WS-PRINT-PAGE IS EQUAL TO SPACES
031600             GO TO A200-PROGRAM-CONTROL
031700         ELSE
031800             PERFORM MB21PD-PRINT-A-PAGE
031900                                 THRU MB21PD-PAP-EXIT
032000             GO TO A200-PROGRAM-CONTROL.
032100*
032200     IF  MMWTIO-HEADER
032300     OR  MMWTIO-TRAILER
032400         GO TO A350-READ-NEXT.
032500*
032600     MOVE MMWTIO-RECORD          TO MMWT-RECORD.
032700*
032800     IF  MMWT-ORG IS EQUAL TO 999
032900         GO TO A350-READ-NEXT-MBMF.
033000*
033100     PERFORM B100-PRT-BEGIN      THRU B999-PRT-EXIT.
033200     GO TO A350-READ-NEXT.
033300*
033400 A350-READ-NEXT-MBMF.
033500*
033600     MOVE 'R3MF'                 TO SS02WS-ABEND-LOCATION.
033700     SET  MBMFRB-READ-SEQ        TO TRUE.
033800     PERFORM MB00PD-MBMF-ACCESS  THRU MB00PD-MBMF-ACCESS-EXIT.
033900*
034000     IF  SS02WS-FS-NO-RECORD-FOUND
034100         GO TO A500-CONTROL-CARD-ERROR
034200     END-IF.
034300*
034400     IF  SS02WS-FS-END-OF-FILE
034500         IF  MB21WS-PRINT-PAGE IS EQUAL TO SPACES
034600             GO TO A200-PROGRAM-CONTROL
034700         ELSE
034800             PERFORM MB21PD-PRINT-A-PAGE
034900                                 THRU MB21PD-PAP-EXIT
035000             GO TO A200-PROGRAM-CONTROL.
035100*
035200     IF  MBMFIO-FILE-IS-MMWT
035300         CONTINUE
035400     ELSE
035500         GO TO A350-READ-NEXT-MBMF
035600     END-IF.
035700*
035800     MOVE MBMFIO-VAR-DATA        TO MMWT-RECORD.
035900*
036000     IF  MMWT-KEY IS LESS THAN WS-MMWT-BEG-KEY
036100         GO TO A350-READ-NEXT-MBMF
036200     END-IF.
036300*
036400     IF  MMWT-ORG-MERCHANT IS GREATER THAN WS-MMWT-END-KEY
036500         PERFORM MB21PD-PRINT-A-PAGE
036600                                 THRU MB21PD-PAP-EXIT
036700         GO TO A200-PROGRAM-CONTROL
036800     END-IF.
036900*
037000     IF  MMWT-ORG IS EQUAL TO 999
037100         GO TO A350-READ-NEXT-MBMF.
037200*
037300     PERFORM B100-PRT-BEGIN      THRU B999-PRT-EXIT.
037400     GO TO A350-READ-NEXT-MBMF.
037500*
037600 A400-CHECK-READ-SWITCH.
037700*
037800     IF  WS-CARD-READ-SW IS EQUAL TO 'N'
037900         MOVE '*** NO CONTROL CARDS ***'
038000                                 TO MB21WS-PP-COL44 (5 1)
038100         PERFORM MB21PD-PRINT-A-PAGE
038200                                 THRU MB21PD-PAP-EXIT.
038300*
038400     GO TO A600-CLOSE-FILES.
038500*
038600 A500-CONTROL-CARD-ERROR.
038700*
038800     MOVE MTCC-RECORD            TO MB21WS-PP-LINE (4).
038900     MOVE 'CONTROL CARD ERROR'   TO MB21WS-PP-COL44 (4 3).
039000     PERFORM MB21PD-PRINT-A-PAGE THRU MB21PD-PAP-EXIT.
039100     MOVE SPACE                  TO MB21WS-PP-LINE (4).
039200     MOVE SPACE                  TO MB21WS-PP-COL44 (4 3).
039300     GO TO A200-PROGRAM-CONTROL.
039400*
039500 A600-CLOSE-FILES.
039600*
039700     EVALUATE TRUE
039800         WHEN  WS-BACKUP
039900             MOVE 'C1MF'         TO SS02WS-ABEND-LOCATION
040000             SET MBMFRB-CLOSE    TO TRUE
040100             PERFORM MB00PD-MBMF-ACCESS
040200                                 THRU MB00PD-MBMF-ACCESS-EXIT
040300         WHEN  WS-MASTER
040400             MOVE 'C1WT'         TO SS02WS-ABEND-LOCATION
040500             SET MMWTRB-CLOSE    TO TRUE
040600             PERFORM MB00PD-MMWT-ACCESS
040700                                 THRU MB00PD-MMWT-ACCESS-EXIT
040800         WHEN  OTHER
040900             CONTINUE
041000     END-EVALUATE.
041100*
041200     MOVE 'C1CC'                 TO SS02WS-ABEND-LOCATION.
041300     SET MTCCRB-CLOSE            TO TRUE.
041400     PERFORM MB00PD-MTCC-ACCESS  THRU MB00PD-MTCC-ACCESS-EXIT.
041500*
041600     MOVE 'C1SC'                 TO SS02WS-ABEND-LOCATION.
041700     SET MMSCRB-CLOSE            TO TRUE.
041800     PERFORM MB00PD-MMSC-ACCESS  THRU MB00PD-MMSC-ACCESS-EXIT.
041900*
042000     PERFORM MB20PD-CLOSE-PRINT-FILES
042100                                 THRU MB20PD-CPF-EXIT.
042200*
042300     STOP RUN.
042400/
042500 B100-PRT-BEGIN.
042600*
042700     MOVE 'WAREHOUSE TRANSACTION RECORD (MMWT)'
042800                                 TO MB21WS-PRINT-WORK-AREA.
042900     PERFORM MB21PD-INSERT-A-COLUMN
043000                                 THRU MB21PD-IAC-EXIT.
043100*
043200     MOVE 'ORG'                  TO MB21WS-NAME.
043300     MOVE MMWT-ORG               TO MB21WS-3V0.
043400     PERFORM MB21PD-INSERT-A-COLUMN
043500                                 THRU MB21PD-IAC-EXIT.
043600*
043700     MOVE 'MERCHANT'             TO MB21WS-NAME.
043800     MOVE MMWT-MERCHANT          TO MB21WS-9V0.
043900     PERFORM MB21PD-INSERT-A-COLUMN
044000                                 THRU MB21PD-IAC-EXIT.
044100*
044200     MOVE 'SEQ-NBR'              TO MB21WS-NAME.
044300     MOVE MMWT-SEQ-NBR           TO MB21WS-10V0.
044400     PERFORM MB21PD-INSERT-A-COLUMN
044500                                 THRU MB21PD-IAC-EXIT.
044600*
044700     MOVE 'STORE'                TO MB21WS-NAME.
044800     MOVE MMWT-STORE             TO MB21WS-9V0.
044900     PERFORM MB21PD-INSERT-A-COLUMN
045000                                 THRU MB21PD-IAC-EXIT.
045100*
045200     MOVE 'PRODUCT'              TO MB21WS-NAME.
045300     MOVE MMWT-PRODUCT           TO MB21WS-2V0.
045400     PERFORM MB21PD-INSERT-A-COLUMN
045500                                 THRU MB21PD-IAC-EXIT.
045600*
045700     MOVE 'PLAN'                 TO MB21WS-NAME.
045800     MOVE MMWT-PLAN              TO MB21WS-5V0.
045900     PERFORM MB21PD-INSERT-A-COLUMN
046000                                 THRU MB21PD-IAC-EXIT.
046100*
046200     MOVE 'LOGIC-MODULE'         TO MB21WS-NAME.
046300     MOVE MMWT-LOGIC-MODULE      TO MB21WS-3V0.
046400     PERFORM MB21PD-INSERT-A-COLUMN
046500                                 THRU MB21PD-IAC-EXIT.
046600*
046700     MOVE 'QUAL-LEVEL'           TO MB21WS-NAME.
046800     MOVE MMWT-QUAL-LEVEL        TO MB21WS-2V0.
046900     PERFORM MB21PD-INSERT-A-COLUMN
047000                                 THRU MB21PD-IAC-EXIT.
047100*
047200     MOVE 'TRANS CODE'           TO MB21WS-NAME.
047300     MOVE MMWT-TRANS-CODE        TO MB21WS-3V0.
047400     PERFORM MB21PD-INSERT-A-COLUMN
047500                                 THRU MB21PD-IAC-EXIT.
047600*
047700     MOVE 'TRANS FLAG'           TO MB21WS-NAME.
047800     MOVE MMWT-TRANS-FLAG        TO MB21WS-X.
047900     PERFORM MB21PD-INSERT-A-COLUMN
048000                                 THRU MB21PD-IAC-EXIT.
048100*
048200     MOVE 'NBR-ITEMS'            TO MB21WS-NAME.
048300     MOVE MMWT-NBR-ITEMS         TO MB21WS-10V0.
048400     PERFORM MB21PD-INSERT-A-COLUMN
048500                                 THRU MB21PD-IAC-EXIT.
048600*
048700     MOVE 'AMOUNT'               TO MB21WS-NAME.
048800     MOVE MMWT-AMOUNT            TO MB21WS-17V0.
048900     PERFORM MB21PD-INSERT-A-COLUMN
049000                                 THRU MB21PD-IAC-EXIT.
049100*
049200     MOVE 'POST DATE'            TO MB21WS-NAME.
049300     MOVE MMWT-POST-DATE         TO SS01WS-JULIAN.
049400     PERFORM SS26PD-NUMERICALLY-EDIT-DATE THRU SS26PD-NED-EXIT.
049500     MOVE MMWT-POST-DATE         TO MB21WS-JULIAN.
049600     MOVE SS01WS-XX-XX-YYYY      TO MB21WS-GREG.
049700     INSPECT MB21WS-JULIAN       REPLACING ALL ',' BY '-'.
049800     PERFORM MB21PD-INSERT-A-COLUMN
049900                                 THRU MB21PD-IAC-EXIT.
050000*
050100     MOVE 'ENTRY DATE'           TO MB21WS-NAME.
050200     MOVE MMWT-ENTRY-DATE        TO SS01WS-JULIAN.
050300     PERFORM SS26PD-NUMERICALLY-EDIT-DATE THRU SS26PD-NED-EXIT.
050400     MOVE MMWT-ENTRY-DATE        TO MB21WS-JULIAN.
050500     MOVE SS01WS-XX-XX-YYYY      TO MB21WS-GREG.
050600     INSPECT MB21WS-JULIAN       REPLACING ALL ',' BY '-'.
050700     PERFORM MB21PD-INSERT-A-COLUMN
050800                                 THRU MB21PD-IAC-EXIT.
050900*
051000     MOVE 'STMT-FLAG'            TO MB21WS-NAME.
051100     MOVE MMWT-STMT-FLAG         TO MB21WS-X.
051200     PERFORM MB21PD-INSERT-A-COLUMN
051300                                 THRU MB21PD-IAC-EXIT.
051400*
051500     MOVE 'SETT-FLAG'            TO MB21WS-NAME.
051600     MOVE MMWT-SETT-FLAG         TO MB21WS-X.
051700     PERFORM MB21PD-INSERT-A-COLUMN
051800                                 THRU MB21PD-IAC-EXIT.
051900*
052000     MOVE 'SETT-ACCT'            TO MB21WS-NAME.
052100     MOVE MMWT-SETT-ACCT         TO MB21WS-1V0
052200     PERFORM MB21PD-INSERT-A-COLUMN
052300                                 THRU MB21PD-IAC-EXIT.
052400*
052500     MOVE 'SETT-DATE'            TO MB21WS-NAME.
052600     MOVE MMWT-SETT-DATE         TO SS01WS-JULIAN.
052700     PERFORM SS26PD-NUMERICALLY-EDIT-DATE THRU SS26PD-NED-EXIT.
052800     MOVE MMWT-SETT-DATE         TO MB21WS-JULIAN.
052900     MOVE SS01WS-XX-XX-YYYY      TO MB21WS-GREG.
053000     INSPECT MB21WS-JULIAN       REPLACING ALL ',' BY '-'.
053100     PERFORM MB21PD-INSERT-A-COLUMN
053200                                 THRU MB21PD-IAC-EXIT.
053300*
053400     MOVE 'BATCH-DATE'           TO MB21WS-NAME.
053500     MOVE MMWT-BATCH-DATE        TO SS01WS-JULIAN.
053600     PERFORM SS26PD-NUMERICALLY-EDIT-DATE THRU SS26PD-NED-EXIT.
053700     MOVE MMWT-BATCH-DATE        TO MB21WS-JULIAN.
053800     MOVE SS01WS-XX-XX-YYYY      TO MB21WS-GREG.
053900     INSPECT MB21WS-JULIAN       REPLACING ALL ',' BY '-'.
054000     PERFORM MB21PD-INSERT-A-COLUMN
054100                                 THRU MB21PD-IAC-EXIT.
054200*
054300     MOVE 'BATCH-SOURCE'         TO MB21WS-NAME.
054400     MOVE MMWT-BATCH-SOURCE      TO MB21WS-5V0.
054500     PERFORM MB21PD-INSERT-A-COLUMN
054600                                 THRU MB21PD-IAC-EXIT.
054700*
054800     MOVE 'BATCH-NBR'            TO MB21WS-NAME.
054900     MOVE MMWT-BATCH-NBR         TO MB21WS-5V0.
055000     PERFORM MB21PD-INSERT-A-COLUMN
055100                                 THRU MB21PD-IAC-EXIT.
055200*
055300     MOVE 'BATCH-SEQ'            TO MB21WS-NAME.
055400     MOVE MMWT-BATCH-SEQ         TO MB21WS-10V0.
055500     PERFORM MB21PD-INSERT-A-COLUMN
055600                                 THRU MB21PD-IAC-EXIT.
055700*
055800     MOVE 'REF-BATCH-DATE'       TO MB21WS-NAME.
055900     MOVE MMWT-REF-BATCH-DATE    TO SS01WS-JULIAN.
056000     PERFORM SS26PD-NUMERICALLY-EDIT-DATE THRU SS26PD-NED-EXIT.
056100     MOVE MMWT-REF-BATCH-DATE    TO MB21WS-JULIAN.
056200     MOVE SS01WS-XX-XX-YYYY      TO MB21WS-GREG.
056300     INSPECT MB21WS-JULIAN       REPLACING ALL ',' BY '-'.
056400     PERFORM MB21PD-INSERT-A-COLUMN
056500                                 THRU MB21PD-IAC-EXIT.
056600*
056700     MOVE 'REF-BATCH-SOURCE'     TO MB21WS-NAME.
056800     MOVE MMWT-REF-BATCH-SOURCE  TO MB21WS-5V0.
056900     PERFORM MB21PD-INSERT-A-COLUMN
057000                                 THRU MB21PD-IAC-EXIT.
057100*
057200     MOVE 'REF-BATCH-NBR'        TO MB21WS-NAME.
057300     MOVE MMWT-REF-BATCH-NBR     TO MB21WS-5V0.
057400     PERFORM MB21PD-INSERT-A-COLUMN
057500                                 THRU MB21PD-IAC-EXIT.
057600*
057700     MOVE 'REF-BATCH-SEQ'        TO MB21WS-NAME.
057800     MOVE MMWT-REF-BATCH-SEQ     TO MB21WS-10V0.
057900     PERFORM MB21PD-INSERT-A-COLUMN
058000                                 THRU MB21PD-IAC-EXIT.
058100*
058200     MOVE 'REF-NBR'              TO MB21WS-NAME.
058300     MOVE MMWT-REF-NBR           TO MB21WS-23X.
058400     PERFORM MB21PD-INSERT-A-COLUMN
058500                                 THRU MB21PD-IAC-EXIT.
058600*
058700     MOVE 'REF-AMOUNT-1'         TO MB21WS-NAME.
058800     MOVE MMWT-REF-AMOUNT-1      TO MB21WS-17V0.
058900     PERFORM MB21PD-INSERT-A-COLUMN
059000                                 THRU MB21PD-IAC-EXIT.
059100*
059200     MOVE 'REF-AMOUNT-2'         TO MB21WS-NAME.
059300     MOVE MMWT-REF-AMOUNT-2      TO MB21WS-17V0.
059400     PERFORM MB21PD-INSERT-A-COLUMN
059500                                 THRU MB21PD-IAC-EXIT.
059600*
059700     MOVE 'REF-NBR-ITEMS'        TO MB21WS-NAME.
059800     MOVE MMWT-REF-NBR-ITEMS     TO MB21WS-10V0.
059900     PERFORM MB21PD-INSERT-A-COLUMN
060000                                 THRU MB21PD-IAC-EXIT.
060100*
060200     MOVE 'REF-PRODUCT'          TO MB21WS-NAME.
060300     MOVE MMWT-REF-PRODUCT       TO MB21WS-2V0.
060400     PERFORM MB21PD-INSERT-A-COLUMN
060500                                 THRU MB21PD-IAC-EXIT.
060600*
060700     MOVE 'REF-PLAN'             TO MB21WS-NAME.
060800     MOVE MMWT-REF-PLAN          TO MB21WS-5V0.
060900     PERFORM MB21PD-INSERT-A-COLUMN
061000                                 THRU MB21PD-IAC-EXIT.
061100*
061200     MOVE 'REF-QUAL-LEVEL'       TO MB21WS-NAME.
061300     MOVE MMWT-REF-QUAL-LEVEL    TO MB21WS-2V0.
061400     PERFORM MB21PD-INSERT-A-COLUMN
061500                                 THRU MB21PD-IAC-EXIT.
061600*
061700     MOVE 'ORIG-GL-SOURCE'       TO MB21WS-NAME.
061800     MOVE MMWT-ORIG-GL-SOURCE    TO MB21WS-1V0.
061900     PERFORM MB21PD-INSERT-A-COLUMN
062000                                 THRU MB21PD-IAC-EXIT.
062100*
062200     MOVE 'GL-SOURCE'            TO MB21WS-NAME.
062300     MOVE MMWT-GL-SOURCE         TO MB21WS-1V0.
062400     PERFORM MB21PD-INSERT-A-COLUMN
062500                                 THRU MB21PD-IAC-EXIT.
062600*
062700     MOVE 'TRANS STATUS'         TO MB21WS-NAME.
062800     MOVE MMWT-TRANS-STATUS      TO MB21WS-X.
062900     PERFORM MB21PD-INSERT-A-COLUMN
063000                                 THRU MB21PD-IAC-EXIT.
063100*
063200     MOVE 'QUAL INDICATOR'       TO MB21WS-NAME.
063300     MOVE MMWT-QUAL-INDICATOR    TO MB21WS-X.
063400     PERFORM MB21PD-INSERT-A-COLUMN
063500                                 THRU MB21PD-IAC-EXIT.
063600*
063700     MOVE 'DATA ENTRY MODE'      TO MB21WS-NAME.
063800     MOVE MMWT-DATA-ENTRY-MODE   TO MB21WS-X.
063900     PERFORM MB21PD-INSERT-A-COLUMN
064000                                 THRU MB21PD-IAC-EXIT.
064100*
064200     MOVE 'REJECT REENTRY FLAG'  TO MB21WS-NAME.
064300     MOVE MMWT-REJECT-REENTRY-FLAG
064400                                 TO MB21WS-X.
064500     PERFORM MB21PD-INSERT-A-COLUMN
064600                                 THRU MB21PD-IAC-EXIT.
064700*
064800     MOVE 'AR-CURR-INPUT-SOURCE' TO MB21WS-NAME.
064900     MOVE MMWT-AR-CURR-INPUT-SOURCE
065000                                 TO MB21WS-X.
065100     PERFORM MB21PD-INSERT-A-COLUMN
065200                                 THRU MB21PD-IAC-EXIT.
065300*
065400     MOVE 'AR-MT-TYPE'           TO MB21WS-NAME.
065500     MOVE MMWT-AR-MT-TYPE        TO MB21WS-X.
065600     PERFORM MB21PD-INSERT-A-COLUMN
065700                                 THRU MB21PD-IAC-EXIT.
065800*
065900     MOVE 'STORE DUP IND'        TO MB21WS-NAME.                  RG800902
066000     MOVE MMWT-STORE-DUP-IND     TO MB21WS-X.                     RG800902
066100     PERFORM MB21PD-INSERT-A-COLUMN
066200                                 THRU MB21PD-IAC-EXIT.
066300*
066400     MOVE 'MERCH DUP IND'        TO MB21WS-NAME.                  RG800902
066500     MOVE MMWT-MERCH-DUP-IND     TO MB21WS-X.                     RG800902
066600     PERFORM MB21PD-INSERT-A-COLUMN
066700                                 THRU MB21PD-IAC-EXIT.
066800*
066900     MOVE 'ORIG OPERATOR'        TO MB21WS-NAME.
067000     MOVE MMWT-ORIG-OPERATOR     TO MB21WS-3X.
067100     PERFORM MB21PD-INSERT-A-COLUMN
067200                                 THRU MB21PD-IAC-EXIT.
067300*
067400     MOVE 'LAST OPERATOR'        TO MB21WS-NAME.
067500     MOVE MMWT-LAST-OPERATOR     TO MB21WS-3X.
067600     PERFORM MB21PD-INSERT-A-COLUMN
067700                                 THRU MB21PD-IAC-EXIT.
067800*
067900     MOVE 'GOVERNING-STATE'      TO MB21WS-NAME.
068000     MOVE MMWT-GOVERNING-STATE   TO MB21WS-3X.
068100     PERFORM MB21PD-INSERT-A-COLUMN
068200                                 THRU MB21PD-IAC-EXIT.
068300*
068400     MOVE 'LOGO'                 TO MB21WS-NAME.
068500     MOVE MMWT-LOGO              TO MB21WS-3V0.
068600     PERFORM MB21PD-INSERT-A-COLUMN
068700                                 THRU MB21PD-IAC-EXIT.
068800*
068900     MOVE 'SKU-NBR'              TO MB21WS-NAME.
069000     MOVE MMWT-SKU-NBR           TO MB21WS-9V0.
069100     PERFORM MB21PD-INSERT-A-COLUMN
069200                                 THRU MB21PD-IAC-EXIT.
069300*
069400     MOVE 'DEPT-CODE'            TO MB21WS-NAME.
069500     MOVE MMWT-DEPT-CODE         TO MB21WS-4X.
069600     PERFORM MB21PD-INSERT-A-COLUMN
069700                                 THRU MB21PD-IAC-EXIT.
069800*
069900     MOVE 'DESC'                 TO MB21WS-NAME.
070000     PERFORM MB21PD-INSERT-A-COLUMN
070100                                 THRU MB21PD-IAC-EXIT.
070200     MOVE MMWT-DESC              TO MB21WS-X40.
070300     PERFORM MB21PD-INSERT-A-COLUMN
070400                                 THRU MB21PD-IAC-EXIT.
070500*
070510     MOVE 'CARD PROD TYPE'       TO MB21WS-NAME.                  RG800902
070512     MOVE MMWT-CARD-PROD-TYPE    TO MB21WS-3X.                    RG800902
070514     PERFORM MB21PD-INSERT-A-COLUMN                               RG800902
070516                                 THRU MB21PD-IAC-EXIT.            RG800902
070518*                                                                 RG800902
070520     MOVE 'CATEGORY-CODE'        TO MB21WS-NAME.                  RG800902
070522     MOVE MMWT-CATEGORY-CODE     TO MB21WS-4X.                    RG800902
070524     PERFORM MB21PD-INSERT-A-COLUMN                               RG800902
070526                                 THRU MB21PD-IAC-EXIT.            RG800902
070528*                                                                 RG800902
070600     MOVE 'RPT-DESC'             TO MB21WS-NAME.
070700     MOVE MMWT-RPT-DESC          TO MB21WS-15X.
070800     PERFORM MB21PD-INSERT-A-COLUMN
070900                                 THRU MB21PD-IAC-EXIT.
071000*
071100     MOVE 'POST-FLAG'            TO MB21WS-NAME.
071200     MOVE MMWT-POST-FLAG         TO MB21WS-2V0.
071300     PERFORM MB21PD-INSERT-A-COLUMN
071400                                 THRU MB21PD-IAC-EXIT.
071500*
071600     MOVE 'VAR-DATA-IND'         TO MB21WS-NAME.
071700     MOVE MMWT-VAR-DATA-IND      TO MB21WS-1V0.
071800     PERFORM MB21PD-INSERT-A-COLUMN
071900                                 THRU MB21PD-IAC-EXIT.
072000*
072100     EVALUATE TRUE
072200         WHEN MMWT-VDI-DEPOSIT-DATA
072300             PERFORM V100-DEPOSIT-DATA
072400                THRU V199-DD-EXIT
072500         WHEN MMWT-VDI-FEE-DATA
072600             PERFORM V200-FEE-DATA
072700                THRU V299-FD-EXIT
072800         WHEN MMWT-VDI-HEADER-DATA
072900             PERFORM V300-HEADER-DATA
073000                THRU V399-HD-EXIT
073100     END-EVALUATE.
073200*
073300     PERFORM MB21PD-INSERT-A-COLUMN
073400                                 THRU MB21PD-IAC-EXIT 2 TIMES.
073500*
073600 B999-PRT-EXIT.
073700     EXIT.
073800*
073900 B200-PRINT-HEADER.
074000*
074100     MOVE 'WAREHOUSE/TRANSACTIONS HEADER RECORD (MMWT)'
074200                                 TO MB21WS-PRINT-WORK-AREA.
074300     PERFORM MB21PD-INSERT-A-COLUMN
074400                                 THRU MB21PD-IAC-EXIT.
074500*
074600     MOVE SPACES                 TO MB21WS-PRINT-WORK-AREA.
074700     MOVE 'ORG'                  TO MB21WS-NAME.
074800     MOVE MMWTIO-ORG             TO MB21WS-3V0.
074900     PERFORM MB21PD-INSERT-A-COLUMN
075000                                 THRU MB21PD-IAC-EXIT.
075100*
075200     MOVE 'MERCHANT-NBR'         TO MB21WS-NAME.
075300     MOVE MMWTIO-MERCHANT        TO MB21WS-9V0.
075400     PERFORM MB21PD-INSERT-A-COLUMN
075500                                 THRU MB21PD-IAC-EXIT.
075600*
075700     MOVE 'SEQUENCE-NBR'         TO MB21WS-NAME.
075800     MOVE MMWTIO-SEQ-NBR         TO MB21WS-10V0.
075900     PERFORM MB21PD-INSERT-A-COLUMN
076000                                 THRU MB21PD-IAC-EXIT.
076100*
076200     MOVE 'DATE-STAMP'           TO MB21WS-NAME.
076300     MOVE MMWTIO-DATE-STAMP      TO SS01WS-JULIAN.
076400     PERFORM SS26PD-NUMERICALLY-EDIT-DATE THRU SS26PD-NED-EXIT.
076500     MOVE MMWTIO-DATE-STAMP      TO MB21WS-JULIAN.
076600     MOVE SS01WS-XX-XX-YYYY      TO MB21WS-GREG.
076700     INSPECT MB21WS-JULIAN       REPLACING ALL ',' BY '-'.
076800     PERFORM MB21PD-INSERT-A-COLUMN
076900                                 THRU MB21PD-IAC-EXIT.
077000*
077100     MOVE 'TIME-STAMP'           TO MB21WS-NAME.
077200     MOVE MMWTIO-TIME-STAMP      TO SS01WS-TIME-HHMMSS.
077300     PERFORM SS27PD-NUMERICALLY-EDIT-TIME
077400                                 THRU SS27PD-NET-EXIT.
077500     MOVE SS01WS-HH-MM-SS        TO MB21WS-TIME.
077600     PERFORM MB21PD-INSERT-A-COLUMN
077700                                 THRU MB21PD-IAC-EXIT.
077800*
077900     PERFORM MB21PD-PRINT-A-PAGE
078000                                 THRU MB21PD-PAP-EXIT.
078100*
078200 B200-PH-EXIT.
078300     EXIT.
078400/
078500 V100-DEPOSIT-DATA.
078600*
078700     MOVE '*---------  MMWT DEPOSIT-DATA ---------*'
078800                                 TO MB21WS-PRINT-WORK-AREA.
078900     PERFORM MB21PD-INSERT-A-COLUMN
079000                                 THRU MB21PD-IAC-EXIT.
079100*
079200     MOVE 'AR-ORG'               TO MB21WS-NAME.
079300     MOVE MMWT-AR-ORG            TO MB21WS-3V0.
079400     PERFORM MB21PD-INSERT-A-COLUMN
079500                                 THRU MB21PD-IAC-EXIT.
079600*
079700     MOVE 'AR-ACCT'              TO MB21WS-NAME.
079800     MOVE MMWT-AR-ACCT           TO MB21WS-19X.
079900     PERFORM MB21PD-INSERT-A-COLUMN
080000                                 THRU MB21PD-IAC-EXIT.
080100*
080200     MOVE 'AR-TRANS-CODE'        TO MB21WS-NAME.
080300     MOVE MMWT-AR-TRANS-CODE     TO MB21WS-3V0.
080400     PERFORM MB21PD-INSERT-A-COLUMN
080500                                 THRU MB21PD-IAC-EXIT.
080600*
080700     MOVE 'AR-LOGIC-MODULE'      TO MB21WS-NAME.
080800     MOVE MMWT-AR-LOGIC-MODULE   TO MB21WS-2V0.
080900     PERFORM MB21PD-INSERT-A-COLUMN
081000                                 THRU MB21PD-IAC-EXIT.
081100*
081200     MOVE 'AR-POST-FLAG'         TO MB21WS-NAME.
081300     MOVE MMWT-AR-POST-FLAG      TO MB21WS-2V0.
081400     PERFORM MB21PD-INSERT-A-COLUMN
081500                                 THRU MB21PD-IAC-EXIT.
081600*
081700     MOVE 'INDIV-DISC-FLAG'      TO MB21WS-NAME.
081800     MOVE MMWT-INDIV-DISC-FLAG   TO MB21WS-X.
081900     PERFORM MB21PD-INSERT-A-COLUMN
082000                                 THRU MB21PD-IAC-EXIT.
082100*
082200     MOVE 'INDIV-DISC-AMT'       TO MB21WS-NAME.
082300     MOVE MMWT-INDIV-DISC-AMT    TO MB21WS-17V0.
082400     PERFORM MB21PD-INSERT-A-COLUMN
082500                                 THRU MB21PD-IAC-EXIT.
082600*
082700     MOVE 'INDIV-DISC-IND'       TO MB21WS-NAME.
082800     MOVE MMWT-INDIV-DISC-IND    TO MB21WS-X.
082900     PERFORM MB21PD-INSERT-A-COLUMN
083000                                 THRU MB21PD-IAC-EXIT.
083100*
083200     IF  MMWT-IDI-IS-PER-ITEM
083300         MOVE 'INDIV-DISC-PER-ITEM'
083400                                 TO MB21WS-NAME
083500         MOVE MMWT-INDIV-DISC-PER-ITEM
083600                                 TO MB21WS-9V0
083700         PERFORM MB21PD-INSERT-A-COLUMN
083800                                 THRU MB21PD-IAC-EXIT
083900         MOVE 'INDIV-DISC-ADJ-PER-ITEM'
084000                                 TO MB21WS-NAME
084100         MOVE MMWT-INDIV-DISC-ADJ-PER-ITEM
084200                                 TO MB21WS-9V0
084300         PERFORM MB21PD-INSERT-A-COLUMN
084400                                 THRU MB21PD-IAC-EXIT
084500     ELSE
084600         MOVE 'INDIV-DISC-ADJ-RATE'
084700                                 TO MB21WS-NAME
084800         MOVE MMWT-INDIV-DISC-RATE
084900                                 TO MB21WS-9V0
085000         PERFORM MB21PD-INSERT-A-COLUMN
085100                                 THRU MB21PD-IAC-EXIT
085200         MOVE 'INDIV-DISC-RATE'  TO MB21WS-NAME
085300         MOVE MMWT-INDIV-DISC-RATE
085400                                 TO MB21WS-9V0
085500         PERFORM MB21PD-INSERT-A-COLUMN
085600                                 THRU MB21PD-IAC-EXIT.
085700*
085800     MOVE 'INDIV-PART-FLAG'      TO MB21WS-NAME.
085900     MOVE MMWT-INDIV-PART-FLAG   TO MB21WS-X.
086000     PERFORM MB21PD-INSERT-A-COLUMN
086100                                 THRU MB21PD-IAC-EXIT.
086200*
086300     MOVE 'INDIV-PART-AMT'       TO MB21WS-NAME.
086400     MOVE MMWT-INDIV-PART-AMT    TO MB21WS-17V0.
086500     PERFORM MB21PD-INSERT-A-COLUMN
086600                                 THRU MB21PD-IAC-EXIT.
086700*
086800     MOVE 'INDIV-PART-IND'       TO MB21WS-NAME.
086900     MOVE MMWT-INDIV-PART-IND    TO MB21WS-X.
087000     PERFORM MB21PD-INSERT-A-COLUMN
087100                                 THRU MB21PD-IAC-EXIT.
087200*
087300     IF  MMWT-IDI-IS-PER-ITEM
087400         MOVE 'INDIV-PART-PER-ITEM'
087500                                 TO MB21WS-NAME
087600         MOVE MMWT-INDIV-PART-PER-ITEM
087700                                 TO MB21WS-9V0
087800         PERFORM MB21PD-INSERT-A-COLUMN
087900                                 THRU MB21PD-IAC-EXIT
088000         MOVE 'INDIV-PART-ADJ-PER-ITEM'
088100                                 TO MB21WS-NAME
088200         MOVE MMWT-INDIV-PART-ADJ-PER-ITEM
088300                                 TO MB21WS-9V0
088400         PERFORM MB21PD-INSERT-A-COLUMN
088500                                 THRU MB21PD-IAC-EXIT
088600     ELSE
088700         MOVE 'INDIV-PART-ADJ-RATE'
088800                                 TO MB21WS-NAME
088900         MOVE MMWT-INDIV-PART-RATE
089000                                 TO MB21WS-9V0
089100         PERFORM MB21PD-INSERT-A-COLUMN
089200                                 THRU MB21PD-IAC-EXIT
089300         MOVE 'INDIV-PART-RATE'  TO MB21WS-NAME
089400         MOVE MMWT-INDIV-PART-RATE
089500                                 TO MB21WS-9V0
089600         PERFORM MB21PD-INSERT-A-COLUMN
089700                                 THRU MB21PD-IAC-EXIT.
089800*
089900     MOVE 'AR AUTH CODE'         TO MB21WS-NAME.
090000     MOVE MMWT-AR-AUTH-CODE      TO MB21WS-6X.
090100     PERFORM MB21PD-INSERT-A-COLUMN
090200                                 THRU MB21PD-IAC-EXIT.
090300*
090400 V199-DD-EXIT.
090500     EXIT.
090600/
090700 V200-FEE-DATA.
090800*
090900     MOVE '*------------ MMWT FEE-DATA -----------*'
091000                                 TO MB21WS-PRINT-WORK-AREA.
091100     PERFORM MB21PD-INSERT-A-COLUMN
091200                                 THRU MB21PD-IAC-EXIT.
091300*
091400     MOVE 'AR-ORG'               TO MB21WS-NAME.
091500     MOVE MMWT-AR-ORG            TO MB21WS-3V0.
091600     PERFORM MB21PD-INSERT-A-COLUMN
091700                                 THRU MB21PD-IAC-EXIT.
091800*
091900     MOVE 'AR-ACCT'              TO MB21WS-NAME.
092000     MOVE MMWT-AR-ACCT           TO MB21WS-19X.
092100     PERFORM MB21PD-INSERT-A-COLUMN
092200                                 THRU MB21PD-IAC-EXIT.
092300*
092400     MOVE 'AR-TRANS-CODE'        TO MB21WS-NAME.
092500     MOVE MMWT-AR-TRANS-CODE     TO MB21WS-3V0.
092600     PERFORM MB21PD-INSERT-A-COLUMN
092700                                 THRU MB21PD-IAC-EXIT.
092800*
092900     MOVE 'AR-LOGIC-MODULE'      TO MB21WS-NAME.
093000     MOVE MMWT-AR-LOGIC-MODULE   TO MB21WS-2V0.
093100     PERFORM MB21PD-INSERT-A-COLUMN
093200                                 THRU MB21PD-IAC-EXIT.
093300*
093400     MOVE 'AR-POST-FLAG'         TO MB21WS-NAME.
093500     MOVE MMWT-AR-POST-FLAG      TO MB21WS-2V0.
093600     PERFORM MB21PD-INSERT-A-COLUMN
093700                                 THRU MB21PD-IAC-EXIT.
093800*
093900     MOVE 'FEE-FACTOR-NBR'       TO MB21WS-NAME.
094000     MOVE MMWT-FEE-FACTOR-NBR    TO MB21WS-9V0.
094100     PERFORM MB21PD-INSERT-A-COLUMN
094200                                 THRU MB21PD-IAC-EXIT.
094300*
094400     MOVE 'FEE-FACTOR-AMT'       TO MB21WS-NAME.
094500     MOVE MMWT-FEE-FACTOR-AMT    TO MB21WS-17V0.
094600     PERFORM MB21PD-INSERT-A-COLUMN
094700                                 THRU MB21PD-IAC-EXIT.
094800*
094900     MOVE 'FEE-INC-PER-ITEM'     TO MB21WS-NAME.
095000     MOVE MMWT-FEE-INC-PER-ITEM  TO MB21WS-17V0.
095100     PERFORM MB21PD-INSERT-A-COLUMN
095200                                 THRU MB21PD-IAC-EXIT.
095300*
095400     MOVE 'FEE-INC-RATE'         TO MB21WS-NAME.
095500     MOVE MMWT-FEE-INC-RATE      TO MB21WS-7V0.
095600     PERFORM MB21PD-INSERT-A-COLUMN
095700                                 THRU MB21PD-IAC-EXIT.
095800*
095900     MOVE 'FEE-EXP-PER-ITEM'     TO MB21WS-NAME.
096000     MOVE MMWT-FEE-EXP-PER-ITEM  TO MB21WS-17V0.
096100     PERFORM MB21PD-INSERT-A-COLUMN
096200                                 THRU MB21PD-IAC-EXIT.
096300*
096400     MOVE 'FEE-EXP-RATE'         TO MB21WS-NAME.
096500     MOVE MMWT-FEE-EXP-RATE      TO MB21WS-7V0.
096600     PERFORM MB21PD-INSERT-A-COLUMN
096700                                 THRU MB21PD-IAC-EXIT.
096800*
096900     MOVE 'FEE-EXP-AMOUNT'       TO MB21WS-NAME.
097000     MOVE MMWT-FEE-EXP-AMOUNT    TO MB21WS-17V0.
097100     PERFORM MB21PD-INSERT-A-COLUMN
097200                                 THRU MB21PD-IAC-EXIT.
097300*
097400 V299-FD-EXIT.
097500     EXIT.
097600/
097700 V300-HEADER-DATA.
097800*
097900     MOVE 'SALES-NBR'            TO MB21WS-NAME.
098000     MOVE MMWT-SALES-NBR         TO MB21WS-9V0.
098100     PERFORM MB21PD-INSERT-A-COLUMN
098200                                 THRU MB21PD-IAC-EXIT.
098300*
098400     MOVE 'SALES-AMT'            TO MB21WS-NAME.
098500     MOVE MMWT-SALES-AMT         TO MB21WS-17V0.
098600     PERFORM MB21PD-INSERT-A-COLUMN
098700                                 THRU MB21PD-IAC-EXIT.
098800*
098900     MOVE 'SALES-REV-NBR'        TO MB21WS-NAME.
099000     MOVE MMWT-SALES-REV-NBR     TO MB21WS-9V0.
099100     PERFORM MB21PD-INSERT-A-COLUMN
099200                                 THRU MB21PD-IAC-EXIT.
099300*
099400     MOVE 'SALES-REV-AMT'        TO MB21WS-NAME.
099500     MOVE MMWT-SALES-REV-AMT     TO MB21WS-17V0.
099600     PERFORM MB21PD-INSERT-A-COLUMN
099700                                 THRU MB21PD-IAC-EXIT.
099800*
099900     MOVE 'RETURNS-NBR'          TO MB21WS-NAME.
100000     MOVE MMWT-RETURNS-NBR       TO MB21WS-9V0.
100100     PERFORM MB21PD-INSERT-A-COLUMN
100200                                 THRU MB21PD-IAC-EXIT.
100300*
100400     MOVE 'RETURNS-AMT'          TO MB21WS-NAME.
100500     MOVE MMWT-RETURNS-AMT       TO MB21WS-17V0.
100600     PERFORM MB21PD-INSERT-A-COLUMN
100700                                 THRU MB21PD-IAC-EXIT.
100800*
100900     MOVE 'RETURNS-REV-NBR'      TO MB21WS-NAME.
101000     MOVE MMWT-RETURNS-REV-NBR   TO MB21WS-9V0.
101100     PERFORM MB21PD-INSERT-A-COLUMN
101200                                 THRU MB21PD-IAC-EXIT.
101300*
101400     MOVE 'RETURNS-REV-AMT'      TO MB21WS-NAME.
101500     MOVE MMWT-RETURNS-REV-AMT   TO MB21WS-17V0.
101600     PERFORM MB21PD-INSERT-A-COLUMN
101700                                 THRU MB21PD-IAC-EXIT.
101800*
101900     MOVE 'MEMO-NBR'             TO MB21WS-NAME.
102000     MOVE MMWT-MEMO-NBR          TO MB21WS-9V0.
102100     PERFORM MB21PD-INSERT-A-COLUMN
102200                                 THRU MB21PD-IAC-EXIT.
102300*
102400     MOVE 'MEMO-AMT'             TO MB21WS-NAME.
102500     MOVE MMWT-MEMO-AMT          TO MB21WS-17V0.
102600     PERFORM MB21PD-INSERT-A-COLUMN
102700                                 THRU MB21PD-IAC-EXIT.
102800*
102900 V399-HD-EXIT.
103000     EXIT.
103100/
103200* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
103300*                          COMMON ROUTINES                      *
103400* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
103500*
103600     COPY SS02PD.
103700/
103800     COPY SS08PD.
103900/
104000     COPY SS16PD.
104100/
104200     COPY SS26PD.
104300/
104400     COPY SS27PD.
104500/
104600     COPY MB20PD.
104700/
104800     COPY MB21PD.
104900/
105000     COPY MB99PD.
105100/
105200     COPY MB00PD REPLACING ==:MB00:== BY ==MTCC==.
105300/
105400     COPY MB00PD REPLACING ==:MB00:== BY ==MMWT==.
105500/
105600     COPY MB00PD REPLACING ==:MB00:== BY ==MMSC==.
105700/
105800     COPY MB00PD REPLACING ==:MB00:== BY ==MBMF==.
