000100 IDENTIFICATION DIVISION.
000200 PROGRAM-ID. MBU923.
000201*       RELEASE DATE=08/24/01.        REVISION LEVEL=08.06      *
000202*****************************************************************
000203*WARNING.  THIS COMPUTER PROGRAM IS PROTECTED BY COPYRIGHT LAW  *
000204*AND INTERNATIONAL TREATIES.  UNAUTHORIZED REPRODUCTION OR      *
000205*DISTRIBUTION OF THIS PROGRAM, OR ANY PORTION OF IT, MAY RESULT *
000206*IN SEVERE CIVIL AND CRIMINAL PENATLIES, AND WILL BE PROSECUTED *
000207*TO THE MAXIMUM EXTENT POSSIBLE UNDER THE LAW.                  *
000208*COPYRIGHT 1999 PAYSYS INTERNATIONAL, INC.  ALL RIGHTS RESERVED.*
000209*****************************************************************
000300*****************************************************************
000400*                                                               *
000500*       MBU923 - STORE/MERCHANT CROSS REFERENCE FILE (MMXR)     *
000600*                                                               *
000700*****************************************************************
000800 ENVIRONMENT DIVISION.
000900 CONFIGURATION SECTION.
001000 SOURCE-COMPUTER.   IBM-4341.
001100 OBJECT-COMPUTER.   IBM-4341.
001200/
001300 INPUT-OUTPUT SECTION.
001400 FILE-CONTROL.
001500/
001600 DATA DIVISION.
001700 FILE SECTION.
001800 WORKING-STORAGE SECTION.
001900*
002000 01  FILLER                  PIC  X(12)      VALUE '** WS-BEG **'.
002100*
002200     COPY MB00RB REPLACING ==:MB00:== BY ==MTCC==.
002300/
002400     COPY MB00RB REPLACING ==:MB00:== BY ==MMSC==.
002500/
002600     COPY MB00RB REPLACING ==:MB00:== BY ==MMXR==.
002700/
002800     COPY MBU999WS.
002900/
003000     COPY MB00RB REPLACING ==:MB00:== BY ==MBMF==.
003100/
003200     COPY MTCCRL REPLACING ==:MTCC:== BY ==MTCC==.
003300/
003400     COPY MMSCRL.
003500/
003600     COPY MMXRRL.
003700/
003800     COPY MBMFRL.
003900/
004000     COPY MTCCIO REPLACING ==:MTCC:== BY ==MTCC==.
004100/
004200     COPY MMSCIO.
004300/
004400     COPY MMXRIO.
004500/
004600     COPY MBMFIO.
004700/
004800     COPY MB00WS.
004900/
005000     COPY MB20WS.
005100/
005200     COPY SS00WS.
005300/
005400     COPY SS01WS.
005500/
005600     COPY SS02WS.
005700/
005800     COPY MB21WS.
005900/
006000     COPY MB99WS.
006100/
006200 01  WS-WORK-AREAS.
006300     03  WS-PROG-ID          PIC  X(06)      VALUE 'MBU923'.
006400     03  WS-CARD-READ-SW     PIC  X(01)      VALUE 'N'.
006500*
006600     03  WS-MMXR-BEG-KEY.
006700         05  WS-MMXR-BEG-ORG-MERCHANT.
006800             07  WS-MMXR-BEG-ORG
006900                             PIC  9(03)      VALUE ZEROES.
007000             07  WS-MMXR-BEG-MERCHANT
007100                             PIC  9(09)      VALUE ZEROES.
007200         05  WS-MMXR-BEG-STORE
007300                             PIC S9(09)      BINARY VALUE ZEROES.
007400*
007500     03  WS-MMXR-END-KEY.
007600         05  WS-MMXR-END-ORG-MERCHANT.
007700             07  WS-MMXR-END-ORG
007800                             PIC  9(03)      VALUE ZEROES.
007900             07  WS-MMXR-END-MERCHANT
008000                             PIC  9(09)      VALUE ZEROES.
008100*
008200     03  WS-BACKUP-OR-MASTER PIC  X(06)      VALUE SPACES.
008300         88  WS-BACKUP                       VALUE 'BACKUP'.
008400         88  WS-MASTER                       VALUE 'MASTER'.
008500*
008600 01  FILLER                  PIC  X(12)      VALUE '** WS-END **'.
008700/
008800 PROCEDURE DIVISION.
008900*
009000 A000-DRIVER.
009100*
009200     MOVE 'MBU923'               TO SS02WS-ABEND-PROG-ID
009300                                    MBU999WS-PROGRAM-ID.
009400*
009500     CALL MB00WS-MBU999CC        USING MBU999WS-AREA.
009600*
009700     MOVE 'MB000000'             TO MB20WS-SH-RPT-ID.
009800     MOVE 'T923'                 TO MB20WS-SH-INTERNAL-RPT-ID.
009900     MOVE ' STORE/MERCHANT CROSS REF FILE'
010000                                 TO MB20WS-SH-RPT-NAME.
010100     MOVE SPACES                 TO MB20WS-SH-LIT-1
010200                                    MB20WS-SH-LIT-5
010300                                    MB20WS-SH-L4
010400                                    MB20WS-SH-L5
010500                                    MB20WS-SH-L6.
010600     PERFORM MB21PD-PAP-RESET-INDEXES
010700                                 THRU MB21PD-PAP-EXIT.
010800*
010900 A100-OPEN-FILES.
011000*
011100     MOVE SPACES                 TO MB21WS-PRINT-PAGE.
011200     MOVE 'O1CC'                 TO SS02WS-ABEND-LOCATION.
011300     MOVE SS02WS-END-OF-FILE     TO MTCCRB-PERM-STATUS-1.
011400     SET MTCCRB-OPEN-INPUT       TO TRUE.
011500     PERFORM MB00PD-MTCC-ACCESS  THRU MB00PD-MTCC-ACCESS-EXIT.
011600*
011700     MOVE 'O1SC'                 TO SS02WS-ABEND-LOCATION.
011800     SET MMSCRB-OPEN-INPUT       TO TRUE.
011900     PERFORM MB00PD-MMSC-ACCESS  THRU MB00PD-MMSC-ACCESS-EXIT.
012000*
012100     MOVE 'R1SC'                 TO SS02WS-ABEND-LOCATION.
012200     SET  MMSCRB-READ-SEQ        TO TRUE.
012300     PERFORM MB00PD-MMSC-ACCESS  THRU MB00PD-MMSC-ACCESS-EXIT.
012400     MOVE 'MMSC'                 TO MB99WS-FILE-ID.
012500*
012600     IF  MMSCIO-HEADER
012700         NEXT SENTENCE
012800     ELSE
012900         PERFORM MB99PD-MISSING-HEADER-ABEND
013000            THRU MB99PD-MHA-EXIT.
013100*
013200     MOVE MMSCIO-RECORD          TO MMSC-RECORD.
013300*
013310     MOVE MMSC-DATE-FORMAT       TO SS01WS-DATE-FORMAT.
013400     MOVE MMSC-TODAYS-JULIAN     TO SS01WS-JULIAN.
013500     PERFORM SS26PD-NUMERICALLY-EDIT-DATE THRU SS26PD-NED-EXIT.
013600     MOVE SS01WS-XX-XX-YYYY      TO MB20WS-SH-FILE-DATE.
013700     MOVE MMSC-TIME-STAMP        TO SS01WS-TIME-HHMMSS.
013800     PERFORM SS27PD-NUMERICALLY-EDIT-TIME
013900                                 THRU SS27PD-NET-EXIT.
014000     MOVE SS01WS-HH-MM-SS        TO MB20WS-SH-PROC-TIME .
014100*
014200     MOVE MMSC-FORM              TO MB20WS-FORM-CODE.
014300     MOVE MMSC-FICHE-FLAG        TO MB20WS-FICHE-CODE.
014400     MOVE MMSC-LINES-PER-PAGE    TO MB20WS-LINES-PER-PAGE.
014500     MOVE 99                     TO MB20WS-LINE-LIMIT.
014600     COMPUTE MB21WS-LIN-LIMIT    =  MMSC-LINES-PER-PAGE - 4.
014700     MOVE MMSC-SCREEN-HEADER     TO MB20WS-SH-SYSTEM.
014900*
015000     MOVE 'R1CC'                 TO SS02WS-ABEND-LOCATION.
015100     SET MTCCRB-READ-SEQ         TO TRUE.
015200     PERFORM MB00PD-MTCC-ACCESS  THRU MB00PD-MTCC-ACCESS-EXIT.
015300*
015400     IF  SS02WS-FS-END-OF-FILE
015500         GO TO A400-CHECK-READ-SWITCH
015600     END-IF.
015700*
015800     IF  MTCCIO-PROGRAM-ID IS NOT EQUAL TO WS-PROG-ID
015900         GO TO A200-PROGRAM-CONTROL
016000     END-IF.
016100*
016200     MOVE MTCCIO-CARD-DATA       TO MTCC-RECORD.
016300*
016400     IF  MTCC-MBU9XX-BACKUP
016500         MOVE 'BACKUP'           TO WS-BACKUP-OR-MASTER
016600         MOVE 'O1MF'             TO SS02WS-ABEND-LOCATION
016700         SET MBMFRB-OPEN-INPUT   TO TRUE
016800         PERFORM MB00PD-MBMF-ACCESS THRU MB00PD-MBMF-ACCESS-EXIT
016900         MOVE 'R1MF'             TO SS02WS-ABEND-LOCATION
017000         SET MBMFRB-READ-SEQ     TO TRUE
017100         MOVE SS02WS-NO-RECORD-FOUND
017200                                 TO MBMFRB-PERM-STATUS-3
017300         MOVE SS02WS-END-OF-FILE
017400                                 TO MBMFRB-PERM-STATUS-4
017500         PERFORM MB00PD-MBMF-ACCESS THRU MB00PD-MBMF-ACCESS-EXIT
017600     ELSE
017700         MOVE 'O1XR'             TO SS02WS-ABEND-LOCATION
017800         SET MMXRRB-OPEN-INPUT   TO TRUE
017900         PERFORM MB00PD-MMXR-ACCESS THRU MB00PD-MMXR-ACCESS-EXIT
018000         MOVE 'R1XR'             TO SS02WS-ABEND-LOCATION
018100         SET MMXRRB-READ-SEQ     TO TRUE
018200         MOVE SS02WS-NO-RECORD-FOUND
018300                                 TO MMXRRB-PERM-STATUS-3
018400         MOVE SS02WS-END-OF-FILE
018500                                 TO MMXRRB-PERM-STATUS-4
018600         PERFORM MB00PD-MMXR-ACCESS THRU MB00PD-MMXR-ACCESS-EXIT
018700         GO TO A130-PRINT-HR-RECORD
018800     END-IF.
018900*
019000     MOVE 'MBMF'                 TO MB99WS-FILE-ID.
019100*
019200     IF  MBMFIO-FILE-IS-HEADER
019300         NEXT SENTENCE
019400     ELSE
019500         PERFORM MB99PD-MISSING-HEADER-ABEND
019600            THRU MB99PD-MHA-EXIT.
019700*
019800     MOVE MBMFIO-RECORD          TO MBMF-RECORD.
019900*
020000     SET X-MBMF-FILE             TO 1.
020100*
020200 A110-SEARCH-HEADER-TABLE-LOOP.
020300*
020400     IF  X-MBMF-FILE IS GREATER THAN 75
020500         MOVE 'MMXR'             TO MB99WS-FILE-ID
020600         PERFORM MB99PD-NOT-ON-BACKUP
020700            THRU MB99PD-NOB-EXIT.
020800*
020900*
021000     IF  MBMF-MBU020-ENTRY (X-MBMF-FILE) IS EQUAL TO 'XR'
021100         CONTINUE
021200     ELSE
021300         SET X-MBMF-FILE         UP BY 1
021400         GO TO A110-SEARCH-HEADER-TABLE-LOOP
021500     END-IF.
021600*
021700 A120-READ-MBMF-LOOP.
021800*
021900     MOVE 'R2MF'                 TO SS02WS-ABEND-LOCATION.
022000     SET MBMFRB-READ-SEQ         TO TRUE.
022100     PERFORM MB00PD-MBMF-ACCESS  THRU MB00PD-MBMF-ACCESS-EXIT.
022200*
022300     IF  SS02WS-FS-END-OF-FILE
022400         GO TO A200-PROGRAM-CONTROL
022500     END-IF.
022600*
022700     IF  MBMFIO-FILE-IS-MMXR
022800         CONTINUE
022900     ELSE
023000         GO TO A120-READ-MBMF-LOOP
023100     END-IF.
023200*
023300 A130-PRINT-HR-RECORD.
023400*
023500     IF  WS-BACKUP
023600         MOVE MBMFIO-VAR-DATA    TO MMXRIO-RECORD
023700     END-IF.
023800*
023900     MOVE 'MMXR'                 TO MB99WS-FILE-ID.
024000*
024100     IF  MMXRIO-HEADER
024200         PERFORM B200-PRINT-HEADER
024300                                 THRU B200-PH-EXIT
024400     ELSE
024500         PERFORM MB99PD-MISSING-HEADER-ABEND
024600            THRU MB99PD-MHA-EXIT.
024700*
024800     MOVE MMXRIO-RECORD          TO MMXR-RECORD.
024900*
025000 A200-PROGRAM-CONTROL.
025100*
025200     IF  MTCC-MBU9XX-BACKUP OR MTCC-MBU9XX-MASTER
025300         MOVE MTCC-MBU9XX-OPTION TO WS-BACKUP-OR-MASTER
025400     ELSE
025500         IF  WS-BACKUP-OR-MASTER IS EQUAL TO SPACES
025600             MOVE 'MASTER'       TO WS-BACKUP-OR-MASTER
025700             GO TO A210-PC-BY-FIRST-READ.
025800*
025900     MOVE 'R2CC'                 TO SS02WS-ABEND-LOCATION.
026000     SET MTCCRB-READ-SEQ         TO TRUE.
026100     PERFORM MB00PD-MTCC-ACCESS  THRU MB00PD-MTCC-ACCESS-EXIT.
026200*
026300     IF  SS02WS-FS-END-OF-FILE
026400         GO TO A400-CHECK-READ-SWITCH
026500     END-IF.
026600*
026700 A210-PC-BY-FIRST-READ.
026800*
026900     IF  MTCCIO-PROGRAM-ID IS NOT EQUAL TO WS-PROG-ID
027000         GO TO A200-PROGRAM-CONTROL
027100     END-IF.
027200*
027300     MOVE MTCCIO-CARD-DATA       TO MTCC-RECORD.
027400*
027500 A300-RANGE-CARD.
027600*
027700     MOVE 'Y'                    TO WS-CARD-READ-SW.
027800     INSPECT MTCC-MBU923-BEG-X   REPLACING ALL SPACE BY ZERO.
027900*
028000     IF  MTCC-MBU923-END-X IS EQUAL TO SPACES
028100         MOVE MTCC-MBU923-BEG-X  TO MTCC-MBU923-END-X
028200     END-IF.
028300*
028400     INSPECT MTCC-MBU923-END-X   REPLACING ALL SPACE BY ZERO.
028500*
028600     MOVE MTCC-MBU923-BEG-ORG    TO WS-MMXR-BEG-ORG.
028700     MOVE MTCC-MBU923-BEG-MERCHANT
028800                                 TO WS-MMXR-BEG-MERCHANT.
028900*
029000     MOVE MTCC-MBU923-END-ORG    TO WS-MMXR-END-ORG.
029100     MOVE MTCC-MBU923-END-MERCHANT
029200                                 TO WS-MMXR-END-MERCHANT.
029300*
029400     IF  WS-BACKUP
029500         GO TO A350-READ-NEXT-MBMF
029600     END-IF.
029700*
029800     MOVE WS-MMXR-BEG-KEY        TO MMXRIO-KEY.
029900*
030000     MOVE 'S1XR'                 TO SS02WS-ABEND-LOCATION.
030100     SET  MMXRRB-START-GTE       TO TRUE.
030200     PERFORM MB00PD-MMXR-ACCESS  THRU MB00PD-MMXR-ACCESS-EXIT.
030300*
030400     IF  SS02WS-FS-NO-RECORD-FOUND
030500         GO TO A500-CONTROL-CARD-ERROR
030600     END-IF.
030700*
030800 A350-READ-NEXT.
030900*
031000     MOVE 'R2XR'                 TO SS02WS-ABEND-LOCATION.
031100     SET  MMXRRB-READ-SEQ        TO TRUE.
031200     PERFORM MB00PD-MMXR-ACCESS  THRU MB00PD-MMXR-ACCESS-EXIT.
031300*
031400     IF  SS02WS-FS-END-OF-FILE
031500         IF  MB21WS-PRINT-PAGE IS EQUAL TO SPACES
031600             GO TO A200-PROGRAM-CONTROL
031700         ELSE
031800             PERFORM MB21PD-PRINT-A-PAGE
031900                                 THRU MB21PD-PAP-EXIT
032000             GO TO A200-PROGRAM-CONTROL.
032100*
032200     IF  MMXRIO-ORG-MERCHANT IS GREATER THAN WS-MMXR-END-KEY
032300         IF  MB21WS-PRINT-PAGE IS EQUAL TO SPACES
032400             GO TO A200-PROGRAM-CONTROL
032500         ELSE
032600             PERFORM MB21PD-PRINT-A-PAGE
032700                                 THRU MB21PD-PAP-EXIT
032800             GO TO A200-PROGRAM-CONTROL.
032900*
033000     IF  MMXRIO-HEADER
033100     OR  MMXRIO-TRAILER
033200         GO TO A350-READ-NEXT.
033300*
033400     MOVE MMXRIO-RECORD          TO MMXR-RECORD.
033500*
033600     PERFORM B100-PRT-BEGIN      THRU B999-PRT-EXIT.
033700     GO TO A350-READ-NEXT.
033800*
033900 A350-READ-NEXT-MBMF.
034000*
034100     MOVE 'R3MF'                 TO SS02WS-ABEND-LOCATION.
034200     SET  MBMFRB-READ-SEQ        TO TRUE.
034300     PERFORM MB00PD-MBMF-ACCESS  THRU MB00PD-MBMF-ACCESS-EXIT.
034400*
034500     IF  SS02WS-FS-NO-RECORD-FOUND
034600         GO TO A500-CONTROL-CARD-ERROR
034700     END-IF.
034800*
034900     IF  SS02WS-FS-END-OF-FILE
035000         IF  MB21WS-PRINT-PAGE IS EQUAL TO SPACES
035100             GO TO A200-PROGRAM-CONTROL
035200         ELSE
035300             PERFORM MB21PD-PRINT-A-PAGE
035400                                 THRU MB21PD-PAP-EXIT
035500             GO TO A200-PROGRAM-CONTROL.
035600*
035700     IF  MBMFIO-FILE-IS-MMXR
035800         CONTINUE
035900     ELSE
036000         GO TO A350-READ-NEXT-MBMF
036100     END-IF.
036200*
036300     MOVE MBMFIO-VAR-DATA        TO MMXR-RECORD.
036400*
036500     IF  MMXR-KEY IS LESS THAN WS-MMXR-BEG-KEY
036600         GO TO A350-READ-NEXT-MBMF
036700     END-IF.
036800*
036900     IF  MMXR-ORG-MERCHANT IS GREATER THAN WS-MMXR-END-KEY
037000         PERFORM MB21PD-PRINT-A-PAGE
037100                                 THRU MB21PD-PAP-EXIT
037200         GO TO A200-PROGRAM-CONTROL
037300     END-IF.
037400*
037500     IF  MMXR-ORG IS EQUAL TO 999
037600         GO TO A350-READ-NEXT-MBMF.
037700*
037800     PERFORM B100-PRT-BEGIN      THRU B999-PRT-EXIT.
037900     GO TO A350-READ-NEXT-MBMF.
038000*
038100 A400-CHECK-READ-SWITCH.
038200*
038300     IF  WS-CARD-READ-SW IS EQUAL TO 'N'
038400         MOVE '*** NO CONTROL CARDS ***'
038500                                 TO MB21WS-PP-COL44 (5 1)
038600         PERFORM MB21PD-PRINT-A-PAGE
038700                                 THRU MB21PD-PAP-EXIT.
038800*
038900     GO TO A600-CLOSE-FILES.
039000*
039100 A500-CONTROL-CARD-ERROR.
039200*
039300     MOVE MTCC-RECORD            TO MB21WS-PP-LINE (4).
039400     MOVE 'CONTROL CARD ERROR'   TO MB21WS-PP-COL44 (4 3).
039500     PERFORM MB21PD-PRINT-A-PAGE THRU MB21PD-PAP-EXIT.
039600     MOVE SPACE                  TO MB21WS-PP-LINE (4).
039700     MOVE SPACE                  TO MB21WS-PP-COL44 (4 3).
039800     GO TO A200-PROGRAM-CONTROL.
039900*
040000 A600-CLOSE-FILES.
040100*
040200     EVALUATE TRUE
040300         WHEN  WS-BACKUP
040400             MOVE 'C1MF'         TO SS02WS-ABEND-LOCATION
040500             SET MBMFRB-CLOSE    TO TRUE
040600             PERFORM MB00PD-MBMF-ACCESS
040700                                 THRU MB00PD-MBMF-ACCESS-EXIT
040800         WHEN  WS-MASTER
040900             MOVE 'C1XR'         TO SS02WS-ABEND-LOCATION
041000             SET MMXRRB-CLOSE    TO TRUE
041100             PERFORM MB00PD-MMXR-ACCESS
041200                                 THRU MB00PD-MMXR-ACCESS-EXIT
041300         WHEN  OTHER
041400             CONTINUE
041500     END-EVALUATE.
041600*
041700     MOVE 'C1CC'                 TO SS02WS-ABEND-LOCATION.
041800     SET MTCCRB-CLOSE            TO TRUE.
041900     PERFORM MB00PD-MTCC-ACCESS  THRU MB00PD-MTCC-ACCESS-EXIT.
042000*
042100     MOVE 'C1SC'                 TO SS02WS-ABEND-LOCATION.
042200     SET MMSCRB-CLOSE            TO TRUE.
042300     PERFORM MB00PD-MMSC-ACCESS  THRU MB00PD-MMSC-ACCESS-EXIT.
042400*
042500     PERFORM MB20PD-CLOSE-PRINT-FILES
042600                                 THRU MB20PD-CPF-EXIT.
042700*
042800     STOP RUN.
042900/
043000 B100-PRT-BEGIN.
043100*
043200     MOVE 'STORE/MERCHANT CROSS REFERENCE REC (MMXR)'
043300                                 TO MB21WS-PRINT-WORK-AREA.
043400     PERFORM MB21PD-INSERT-A-COLUMN
043500                                 THRU MB21PD-IAC-EXIT.
043600*
043700     MOVE 'ORG'                  TO MB21WS-NAME.
043800     MOVE MMXR-ORG               TO MB21WS-3V0.
043900     PERFORM MB21PD-INSERT-A-COLUMN
044000                                 THRU MB21PD-IAC-EXIT.
044100*
044200     MOVE 'MERCHANT'             TO MB21WS-NAME.
044300     MOVE MMXR-MERCHANT          TO MB21WS-9V0.
044400     PERFORM MB21PD-INSERT-A-COLUMN
044500                                 THRU MB21PD-IAC-EXIT.
044600*
044700     MOVE 'STORE'                TO MB21WS-NAME.
044800     MOVE MMXR-STORE             TO MB21WS-10V0.
044900     PERFORM MB21PD-INSERT-A-COLUMN
045000                                 THRU MB21PD-IAC-EXIT 2 TIMES.
045100*
045200     MOVE '*-----  MMXR STATUS INFORMATION  ------*'
045300                                 TO MB21WS-PRINT-WORK-AREA.
045400     PERFORM MB21PD-INSERT-A-COLUMN
045500                                 THRU MB21PD-IAC-EXIT.
045600*
045700     MOVE 'REC-STATUS'           TO MB21WS-NAME.
045800     MOVE MMXR-REC-STATUS        TO MB21WS-1V0.
045900     PERFORM MB21PD-INSERT-A-COLUMN
046000                                 THRU MB21PD-IAC-EXIT.
046100*
046200     MOVE 'ONLINE-STATUS'        TO MB21WS-NAME.
046300     MOVE MMXR-ONLINE-STATUS     TO MB21WS-2V0.
046400     PERFORM MB21PD-INSERT-A-COLUMN
046500                                 THRU MB21PD-IAC-EXIT.
046600*
046700     MOVE 'LAST-MAINT-DATE'      TO MB21WS-NAME.
046800     MOVE MMXR-LAST-MAINT-DATE   TO SS01WS-JULIAN.
046900     PERFORM SS26PD-NUMERICALLY-EDIT-DATE THRU SS26PD-NED-EXIT.
047000     MOVE MMXR-LAST-MAINT-DATE   TO MB21WS-JULIAN.
047100     MOVE SS01WS-XX-XX-YYYY      TO MB21WS-GREG.
047200     INSPECT MB21WS-JULIAN       REPLACING ALL ',' BY '-'.
047300     PERFORM MB21PD-INSERT-A-COLUMN
047400                                 THRU MB21PD-IAC-EXIT.
047500*
047600     MOVE 'LAST-MAINT-OPER'      TO MB21WS-NAME.
047700     MOVE MMXR-LAST-MAINT-OPER   TO MB21WS-3X.
047800     PERFORM MB21PD-INSERT-A-COLUMN
047900                                 THRU MB21PD-IAC-EXIT 2 TIMES.
048000*
048100 B999-PRT-EXIT.
048200     EXIT.
048300*
048400 B200-PRINT-HEADER.
048500*
048600     MOVE 'STORE/MERCHANT CROSS REF HDR (MMXR)'
048700                                 TO MB21WS-DATA-NAME.
048800     PERFORM MB21PD-INSERT-A-COLUMN
048900                                 THRU MB21PD-IAC-EXIT.
049000*
049100     MOVE SPACES                 TO MB21WS-PRINT-WORK-AREA.
049200     MOVE 'ORG'                  TO MB21WS-NAME.
049300     MOVE MMXRIO-ORG             TO MB21WS-3V0.
049400     PERFORM MB21PD-INSERT-A-COLUMN
049500                                 THRU MB21PD-IAC-EXIT.
049600*
049700     MOVE 'MERCHANT'             TO MB21WS-NAME.
049800     MOVE MMXRIO-MERCHANT        TO MB21WS-9V0.
049900     PERFORM MB21PD-INSERT-A-COLUMN
050000                                 THRU MB21PD-IAC-EXIT.
050100*
050200     MOVE 'STORE'                TO MB21WS-NAME.
050300     MOVE MMXRIO-STORE           TO MB21WS-10V0.
050400     PERFORM MB21PD-INSERT-A-COLUMN
050500                                 THRU MB21PD-IAC-EXIT.
050600*
050700     MOVE 'DATE-STAMP'           TO MB21WS-NAME.
050800     MOVE MMXRIO-DATE-STAMP      TO SS01WS-JULIAN.
050900     PERFORM SS26PD-NUMERICALLY-EDIT-DATE THRU SS26PD-NED-EXIT.
051000     MOVE MMXRIO-DATE-STAMP      TO MB21WS-JULIAN.
051100     MOVE SS01WS-XX-XX-YYYY      TO MB21WS-GREG.
051200     INSPECT MB21WS-JULIAN       REPLACING ALL ',' BY '-'.
051300     PERFORM MB21PD-INSERT-A-COLUMN
051400                                 THRU MB21PD-IAC-EXIT.
051500*
051600     MOVE 'TIME-STAMP'           TO MB21WS-NAME.
051700     MOVE MMXRIO-TIME-STAMP      TO SS01WS-TIME-HHMMSS.
051800     PERFORM SS27PD-NUMERICALLY-EDIT-TIME
051900                                 THRU SS27PD-NET-EXIT.
052000     MOVE SS01WS-HH-MM-SS        TO MB21WS-TIME.
052100     PERFORM MB21PD-INSERT-A-COLUMN
052200                                 THRU MB21PD-IAC-EXIT.
052300*
052400     PERFORM MB21PD-PRINT-A-PAGE
052500                                 THRU MB21PD-PAP-EXIT.
052600*
052700 B200-PH-EXIT.
052800     EXIT.
052900/
053000* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
053100*                          COMMON ROUTINES                      *
053200* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
053300*
053400     COPY SS02PD.
053500/
053600     COPY SS08PD.
053700/
053800     COPY SS16PD.
053900/
054000     COPY SS26PD.
054100/
054200     COPY SS27PD.
054300/
054400     COPY MB20PD.
054500/
054600     COPY MB21PD.
054700/
054800     COPY MB99PD.
054900/
055000     COPY MB00PD REPLACING ==:MB00:== BY ==MTCC==.
055100/
055200     COPY MB00PD REPLACING ==:MB00:== BY ==MMXR==.
055300/
055400     COPY MB00PD REPLACING ==:MB00:== BY ==MMSC==.
055500/
055600     COPY MB00PD REPLACING ==:MB00:== BY ==MBMF==.
