000100 IDENTIFICATION DIVISION.
000200 PROGRAM-ID. MBU962.
000201*       RELEASE DATE=08/24/01.        REVISION LEVEL=08.06      * ++++++++
000202***************************************************************** ++++++++
000203*WARNING.  THIS COMPUTER PROGRAM IS PROTECTED BY COPYRIGHT LAW  * ++++++++
000204*AND INTERNATIONAL TREATIES.  UNAUTHORIZED REPRODUCTION OR      * ++++++++
000205*DISTRIBUTION OF THIS PROGRAM, OR ANY PORTION OF IT, MAY RESULT * ++++++++
000206*IN SEVERE CIVIL AND CRIMINAL PENATLIES, AND WILL BE PROSECUTED * ++++++++
000207*TO THE MAXIMUM EXTENT POSSIBLE UNDER THE LAW.                  * ++++++++
000208*COPYRIGHT 1999 PAYSYS INTERNATIONAL, INC.  ALL RIGHTS RESERVED.* ++++++++
000209***************************************************************** ++++++++
000300*****************************************************************
000400*                                                               *
000500*       MBU962 - CANADA VISA QUARTERLY FILE DISPLAY (MMQ2)      *
000600*                                                               *
000700*****************************************************************
000800 ENVIRONMENT DIVISION.
000900 CONFIGURATION SECTION.
001000 SOURCE-COMPUTER.   IBM-4341.
001100 OBJECT-COMPUTER.   IBM-4341.
001200/
001300 INPUT-OUTPUT SECTION.
001400 FILE-CONTROL.
001500/
001600 DATA DIVISION.
001700 FILE SECTION.
001800 WORKING-STORAGE SECTION.
001900*
002000 01  FILLER                  PIC  X(12)      VALUE '** WS-BEG **'.
002100*
002200     COPY MB00RB REPLACING ==:MB00:== BY ==MTCC==.
002300/
002400     COPY MB00RB REPLACING ==:MB00:== BY ==MMSC==.
002500/
002600     COPY MB00RB REPLACING ==:MB00:== BY ==MMQ2==.
002700/
002800     COPY MBU999WS.
002900/
003000     COPY MB00RB REPLACING ==:MB00:== BY ==MBMF==.
003100/
003200     COPY MTCCRL REPLACING ==:MTCC:== BY ==MTCC==.
003300/
003400     COPY MMSCRL.
003500/
003600     COPY MMQ2RL.
003700/
003800     COPY MBMFRL.
003900/
004000     COPY MTCCIO REPLACING ==:MTCC:== BY ==MTCC==.
004100/
004200     COPY MMSCIO.
004300/
004400     COPY MMQ2IO.
004500/
004600     COPY MBMFIO.
004700/
004800     COPY MB00WS.
004900/
005000     COPY MB20WS.
005100/
005200     COPY MB99WS.
005300/
005400     COPY SS00WS.
005500/
005600     COPY SS01WS.
005700/
005800     COPY SS02WS.
005900*
006000 01  WS-WORK-AREAS.
006100     03  WS-PROG-ID          PIC  X(06)      VALUE 'MBU962'.
006200     03  WS-CARD-READ-SW     PIC  X(01)      VALUE 'N'.
006300     03  X-WS-INDEX          PIC S9(04)      COMP.
006400     03  X-WS-TEMP-INDEX     PIC  9(01).
006500     03  X-WS-MON-INDEX      PIC  9(02).
006600     03  X-WS-MON1-INDEX     PIC  9(01).
006700     03  WS-WORK-DATE        PIC  9(08).
006800     03  WS-WORK-DATE-R      REDEFINES WS-WORK-DATE.
006900         05  WS-WK-DTE-MDY   PIC  9(06).
007000         05  WS-WK-DTE-MDY-R REDEFINES WS-WK-DTE-MDY.
007100             07  WS-WORK-DATE-MM
007200                             PIC  9(02).
007300             07  WS-WORK-DATE-DD
007400                             PIC  9(02).
007500             07  WS-WORK-DATE-XX
007600                             PIC  9(02).
007700         05  WS-WORK-DATE-YY PIC  9(02).
007800*
007900     03  WS-MMQ2-BEG-KEY     PIC  9(03)      VALUE ZEROES.
008000     03  WS-MMQ2-END-KEY     PIC  9(03)      VALUE ZEROES.
008100*
008200     03  WS-BACKUP-OR-MASTER PIC  X(06)      VALUE SPACES.
008300         88  WS-BACKUP                       VALUE 'BACKUP'.
008400         88  WS-MASTER                       VALUE 'MASTER'.
008500*
008600     03  WS-END-OF-PERFORM-SW
008700                             PIC  X(01)      VALUE SPACES.
008800         88  WS-END-OF-PERFORM               VALUE 'Y'.
008900         88  WS-NOT-END-OF-PERFORM           VALUE 'N'.
009000/
009100     COPY MB21WS.
009200*
009300 01  FILLER                  PIC  X(12)      VALUE '** WS-END **'.
009400/
009500 PROCEDURE DIVISION.
009600*
009700 A000-DRIVER.
009800*
009900     MOVE 'MBU962'               TO SS02WS-ABEND-PROG-ID
010000                                    MBU999WS-PROGRAM-ID.
010100*
010200     CALL MB00WS-MBU999CC        USING MBU999WS-AREA.
010300*
010400     MOVE 'MB000000'             TO MB20WS-SH-RPT-ID.
010500     MOVE 'T962'                 TO MB20WS-SH-INTERNAL-RPT-ID.
010600     MOVE '   CANADA MASTER FILE         '
010700                                 TO MB20WS-SH-RPT-NAME.
010800     MOVE SPACES                 TO MB20WS-SH-LIT-1
010900                                    MB20WS-SH-LIT-5
011000                                    MB20WS-SH-L4
011100                                    MB20WS-SH-L5
011200                                    MB20WS-SH-L6.
011300     PERFORM MB21PD-PAP-RESET-INDEXES
011400                                 THRU MB21PD-PAP-EXIT.
011500*
011600 A100-OPEN-FILES.
011700*
011800     MOVE SPACES                 TO MB21WS-PRINT-PAGE.
011900     MOVE 'O1CC'                 TO SS02WS-ABEND-LOCATION.
012000     MOVE SS02WS-END-OF-FILE     TO MTCCRB-PERM-STATUS-1.
012100     SET MTCCRB-OPEN-INPUT       TO TRUE.
012200     PERFORM MB00PD-MTCC-ACCESS  THRU MB00PD-MTCC-ACCESS-EXIT.
012300*
012400     MOVE 'O1SC'                 TO SS02WS-ABEND-LOCATION.
012500     SET MMSCRB-OPEN-INPUT       TO TRUE.
012600     PERFORM MB00PD-MMSC-ACCESS  THRU MB00PD-MMSC-ACCESS-EXIT.
012700*
012800     MOVE 'R1SC'                 TO SS02WS-ABEND-LOCATION.
012900     SET MMSCRB-READ-SEQ         TO TRUE.
013000     PERFORM MB00PD-MMSC-ACCESS  THRU MB00PD-MMSC-ACCESS-EXIT.
013100*
013200     MOVE 'MMSC'                 TO MB99WS-FILE-ID.
013300*
013400     IF  MMSCIO-HEADER
013500         NEXT SENTENCE
013600     ELSE
013700         PERFORM MB99PD-MISSING-HEADER-ABEND
013800            THRU MB99PD-MHA-EXIT.
013900*
014000     MOVE MMSCIO-RECORD          TO MMSC-RECORD.
014100     MOVE MMSC-TODAYS-JULIAN     TO SS01WS-JULIAN.
014200     PERFORM SS08PD-JUL-TO-GREG  THRU SS08PD-JTG-EXIT.
014300     MOVE SS01WS-DATE-L6         TO MB20WS-SH-FILE-DATE.
014400     MOVE MMSC-TIME-STAMP        TO MB20WS-SH-PROC-TIME .
014500     INSPECT MB20WS-SH-PROC-TIME REPLACING ALL SPACE BY '.'.
014600*
014700     MOVE MMSC-FORM              TO MB20WS-FORM-CODE.
014800     MOVE MMSC-FICHE-FLAG        TO MB20WS-FICHE-CODE.
014900     MOVE MMSC-LINES-PER-PAGE    TO MB20WS-LINES-PER-PAGE.
015000     MOVE 99                     TO MB20WS-LINE-LIMIT.
015100     COMPUTE MB21WS-LIN-LIMIT    =  MMSC-LINES-PER-PAGE - 4.
015200     MOVE MMSC-SCREEN-HEADER     TO MB20WS-SH-SYSTEM.
015300     MOVE MMSC-DATE-FORMAT       TO SS01WS-DATE-FORMAT.
015400*
015500     MOVE 'R1CC'                 TO SS02WS-ABEND-LOCATION.
015600     SET MTCCRB-READ-SEQ         TO TRUE.
015700     PERFORM MB00PD-MTCC-ACCESS  THRU MB00PD-MTCC-ACCESS-EXIT.
015800*
015900     IF  SS02WS-FS-END-OF-FILE
016000         GO TO A400-CHECK-READ-SWITCH.
016100*
016200     IF  MTCCIO-PROGRAM-ID IS NOT EQUAL TO WS-PROG-ID
016300         GO TO A200-PROGRAM-CONTROL.
016400*
016500     MOVE MTCCIO-CARD-DATA       TO MTCC-RECORD.
016600*
016700     IF  MTCC-MBU9XX-BACKUP
016800         MOVE 'BACKUP'           TO WS-BACKUP-OR-MASTER
016900         MOVE 'O1MF'             TO SS02WS-ABEND-LOCATION
017000         SET MBMFRB-OPEN-INPUT   TO TRUE
017100         PERFORM MB00PD-MBMF-ACCESS THRU MB00PD-MBMF-ACCESS-EXIT
017200         MOVE 'R1MF'             TO SS02WS-ABEND-LOCATION
017300         SET MBMFRB-READ-SEQ     TO TRUE
017400         MOVE SS02WS-NO-RECORD-FOUND
017500                                 TO MBMFRB-PERM-STATUS-3
017600         MOVE SS02WS-END-OF-FILE
017700                                 TO MBMFRB-PERM-STATUS-4
017800         PERFORM MB00PD-MBMF-ACCESS THRU MB00PD-MBMF-ACCESS-EXIT
017900     ELSE
018000         MOVE 'O1Q2'             TO SS02WS-ABEND-LOCATION
018100         SET MMQ2RB-OPEN-INPUT   TO TRUE
018200         PERFORM MB00PD-MMQ2-ACCESS THRU MB00PD-MMQ2-ACCESS-EXIT
018300         MOVE 'R1Q2'             TO SS02WS-ABEND-LOCATION
018400         SET MMQ2RB-READ-SEQ     TO TRUE
018500         MOVE SS02WS-NO-RECORD-FOUND
018600                                 TO MMQ2RB-PERM-STATUS-3
018700         MOVE SS02WS-END-OF-FILE
018800                                 TO MMQ2RB-PERM-STATUS-4
018900         PERFORM MB00PD-MMQ2-ACCESS THRU MB00PD-MMQ2-ACCESS-EXIT
019000         GO TO A130-PRINT-HR-RECORD.
019100*
019200     MOVE 'MBMF'                 TO MB99WS-FILE-ID.
019300*
019400     IF  MBMFIO-FILE-IS-HEADER
019500         NEXT SENTENCE
019600     ELSE
019700         PERFORM MB99PD-MISSING-HEADER-ABEND
019800            THRU MB99PD-MHA-EXIT.
019900*
020000     MOVE MBMFIO-RECORD          TO MBMF-RECORD.
020100*
020200     SET X-MBMF-FILE             TO 1.
020300*
020400 A110-SEARCH-HEADER-TABLE-LOOP.
020500*
020600     IF  X-MBMF-FILE IS GREATER THAN 75
020700         MOVE 'MMQ2'             TO MB99WS-FILE-ID
020800         PERFORM MB99PD-NOT-ON-BACKUP
020900            THRU MB99PD-NOB-EXIT.
021000*
021100     IF  MBMF-MBU020-ENTRY (X-MBMF-FILE) IS EQUAL TO 'Q2'
021200         CONTINUE
021300     ELSE
021400         SET X-MBMF-FILE         UP BY 1
021500         GO TO A110-SEARCH-HEADER-TABLE-LOOP
021600     END-IF.
021700*
021800 A120-READ-MBMF-LOOP.
021900*
022000     MOVE 'R2MF'                 TO SS02WS-ABEND-LOCATION.
022100     SET MBMFRB-READ-SEQ         TO TRUE.
022200     MOVE SS02WS-NO-RECORD-FOUND
022300                                 TO MBMFRB-PERM-STATUS-3.
022400     MOVE SS02WS-END-OF-FILE     TO MBMFRB-PERM-STATUS-4.
022500     PERFORM MB00PD-MBMF-ACCESS  THRU MB00PD-MBMF-ACCESS-EXIT.
022600*
022700     IF  SS02WS-FS-END-OF-FILE
022800         GO TO A200-PROGRAM-CONTROL
022900     END-IF.
023000*
023100     IF  MBMFIO-FILE IS NOT EQUAL TO 'Q2'
023200         GO TO A120-READ-MBMF-LOOP
023300     END-IF.
023400*
023500 A130-PRINT-HR-RECORD.
023600*
023700     IF  WS-BACKUP
023800         MOVE MBMFIO-VAR-DATA    TO MMQ2IO-RECORD
023900     END-IF.
024000*
024100     MOVE 'MMQ2'                 TO MB99WS-FILE-ID.
024200*
024300     IF  MMQ2IO-HEADER
024400         NEXT SENTENCE
024500     ELSE
024600         PERFORM MB99PD-MISSING-HEADER-ABEND
024700            THRU MB99PD-MHA-EXIT.
024800*
024900     MOVE MMQ2IO-RECORD          TO MMQ2-RECORD.
025000*
025100     IF  MMQ2IO-HEADER
025200         PERFORM B200-PRINT-HEADER
025300                                 THRU B200-PH-EXIT
025400     END-IF.
025500*
025600 A200-PROGRAM-CONTROL.
025700*
025800     IF  MTCC-MBU9XX-BACKUP OR MTCC-MBU9XX-MASTER
025900         MOVE MTCC-MBU9XX-OPTION TO WS-BACKUP-OR-MASTER
026000     ELSE
026100         IF  WS-BACKUP-OR-MASTER IS EQUAL TO SPACES
026200             MOVE 'MASTER'       TO WS-BACKUP-OR-MASTER
026300             GO TO A210-PC-BY-FIRST-READ.
026400*
026500     MOVE 'R2CC'                 TO SS02WS-ABEND-LOCATION.
026600     SET MTCCRB-READ-SEQ         TO TRUE.
026700     PERFORM MB00PD-MTCC-ACCESS  THRU MB00PD-MTCC-ACCESS-EXIT.
026800*
026900     IF  SS02WS-FS-END-OF-FILE
027000         GO TO A400-CHECK-READ-SWITCH
027100     END-IF.
027200*
027300 A210-PC-BY-FIRST-READ.
027400*
027500     IF  MTCCIO-PROGRAM-ID IS NOT EQUAL TO WS-PROG-ID
027600         GO TO A200-PROGRAM-CONTROL.
027700*
027800     MOVE MTCCIO-CARD-DATA       TO MTCC-RECORD.
027900*
028000 A300-RANGE-CARD.
028100*
028200     MOVE 'Y'                    TO WS-CARD-READ-SW.
028300     INSPECT MTCC-MBU962-BEG-X   REPLACING ALL SPACE BY ZERO.
028400*
028500     IF  MTCC-MBU962-END-X IS EQUAL TO SPACES
028600         MOVE MTCC-MBU962-BEG-X  TO MTCC-MBU962-END-X
028700     END-IF.
028800*
028900     INSPECT MTCC-MBU962-END-X   REPLACING ALL SPACE BY ZERO.
029000*
029100     MOVE MTCC-MBU962-BEG-ORG    TO WS-MMQ2-BEG-KEY
029200*
029300     MOVE MTCC-MBU962-END-ORG    TO WS-MMQ2-END-KEY.
029400*
029500     IF  WS-BACKUP
029600         GO TO A350-READ-NEXT-MBMF.
029700*
029800     MOVE MTCC-MBU962-BEG-X      TO MMQ2IO-KEY.
029900*
030000     MOVE 'S1Q2'                 TO SS02WS-ABEND-LOCATION.
030100     SET  MMQ2RB-START-GTE       TO TRUE.
030200     PERFORM MB00PD-MMQ2-ACCESS  THRU MB00PD-MMQ2-ACCESS-EXIT.
030300*
030400     IF  SS02WS-FS-NO-RECORD-FOUND
030500         GO TO A500-CONTROL-CARD-ERROR.
030600*
030700 A350-READ-NEXT.
030800*
030900     MOVE 'R2Q2'                 TO SS02WS-ABEND-LOCATION.
031000     SET  MMQ2RB-READ-SEQ        TO TRUE.
031100     PERFORM MB00PD-MMQ2-ACCESS  THRU MB00PD-MMQ2-ACCESS-EXIT.
031200*
031300     IF  SS02WS-FS-END-OF-FILE
031400         IF  MB21WS-PRINT-PAGE IS EQUAL TO SPACES
031500             GO TO A200-PROGRAM-CONTROL
031600         ELSE
031700             PERFORM MB21PD-PRINT-A-PAGE
031800                                 THRU MB21PD-PAP-EXIT
031900             GO TO A200-PROGRAM-CONTROL.
032000*
032100     IF  MMQ2IO-KEY IS GREATER THAN WS-MMQ2-END-KEY
032200         IF  MB21WS-PRINT-PAGE IS EQUAL TO SPACES
032300             GO TO A200-PROGRAM-CONTROL
032400         ELSE
032500             PERFORM MB21PD-PRINT-A-PAGE
032600                                 THRU MB21PD-PAP-EXIT
032700             GO TO A200-PROGRAM-CONTROL.
032800*
032900     IF  MMQ2IO-HEADER
033000     OR  MMQ2IO-TRAILER
033100         GO TO A350-READ-NEXT.
033200*
033300     MOVE MMQ2IO-RECORD          TO MMQ2-RECORD.
033400*
033500     IF  MMQ2-ADD-COMPLETED
033600         PERFORM B100-PRT-BEGIN  THRU B999-PRT-EXIT
033700         GO TO A350-READ-NEXT
033800     ELSE
033900         GO TO A350-READ-NEXT.
034000*
034100 A350-READ-NEXT-MBMF.
034200*
034300     MOVE 'R3MF'                 TO SS02WS-ABEND-LOCATION.
034400     SET  MBMFRB-READ-SEQ        TO TRUE.
034500     PERFORM MB00PD-MBMF-ACCESS  THRU MB00PD-MBMF-ACCESS-EXIT.
034600*
034700     IF  SS02WS-FS-NO-RECORD-FOUND
034800         GO TO A500-CONTROL-CARD-ERROR.
034900*
035000     IF  SS02WS-FS-END-OF-FILE
035100         IF  MB21WS-PRINT-PAGE IS EQUAL TO SPACES
035200             GO TO A200-PROGRAM-CONTROL
035300         ELSE
035400             PERFORM MB21PD-PRINT-A-PAGE
035500                                 THRU MB21PD-PAP-EXIT
035600             GO TO A200-PROGRAM-CONTROL.
035700*
035800     IF  MBMFIO-FILE-IS-MMQ2
035900         CONTINUE
036000     ELSE
036100         GO TO A350-READ-NEXT-MBMF.
036200*
036300     MOVE MBMFIO-VAR-DATA        TO MMQ2-RECORD.
036400*
036500     IF  MMQ2-KEY IS LESS THAN WS-MMQ2-BEG-KEY
036600         GO TO A350-READ-NEXT-MBMF.
036700*
036800     IF  MMQ2-KEY IS GREATER THAN WS-MMQ2-END-KEY
036900         PERFORM MB21PD-PRINT-A-PAGE
037000                                 THRU MB21PD-PAP-EXIT
037100         GO TO A200-PROGRAM-CONTROL.
037200*
037300     IF  MMQ2-ORG IS EQUAL TO 999
037400         GO TO A350-READ-NEXT-MBMF.
037500*
037600     IF  MMQ2-ADD-COMPLETED
037700         NEXT SENTENCE
037800     ELSE
037900         GO TO A350-READ-NEXT-MBMF.
038000*
038100     PERFORM B100-PRT-BEGIN      THRU B999-PRT-EXIT.
038200     GO TO A350-READ-NEXT-MBMF.
038300*
038400 A400-CHECK-READ-SWITCH.
038500*
038600     IF  WS-CARD-READ-SW IS EQUAL TO 'N'
038700         MOVE '*** NO CONTROL CARDS ***'
038800                                 TO MB21WS-PP-COL44 (5 1)
038900         PERFORM MB21PD-PRINT-A-PAGE
039000                                 THRU MB21PD-PAP-EXIT.
039100*
039200     GO TO A600-CLOSE-FILES.
039300*
039400 A500-CONTROL-CARD-ERROR.
039500*
039600     MOVE MTCC-RECORD            TO MB21WS-PP-LINE (4).
039700     MOVE 'CONTROL CARD ERROR'   TO MB21WS-PP-COL44 (4 3).
039800     PERFORM MB21PD-PRINT-A-PAGE THRU MB21PD-PAP-EXIT.
039900     MOVE SPACE                  TO MB21WS-PP-LINE (4).
040000     MOVE SPACE                  TO MB21WS-PP-COL44 (4 3).
040100     GO TO A200-PROGRAM-CONTROL.
040200*
040300 A600-CLOSE-FILES.
040400*
040500     EVALUATE TRUE
040600         WHEN  WS-BACKUP
040700             MOVE 'C1MF'         TO SS02WS-ABEND-LOCATION
040800             SET MBMFRB-CLOSE    TO TRUE
040900             PERFORM MB00PD-MBMF-ACCESS
041000                                 THRU MB00PD-MBMF-ACCESS-EXIT
041100         WHEN  WS-MASTER
041200             MOVE 'C1Q2'         TO SS02WS-ABEND-LOCATION
041300             SET MMQ2RB-CLOSE    TO TRUE
041400             PERFORM MB00PD-MMQ2-ACCESS
041500                                 THRU MB00PD-MMQ2-ACCESS-EXIT
041600         WHEN  OTHER
041700             CONTINUE
041800     END-EVALUATE.
041900*
042000     MOVE 'C1CC'                 TO SS02WS-ABEND-LOCATION.
042100     SET MTCCRB-CLOSE            TO TRUE.
042200     PERFORM MB00PD-MTCC-ACCESS  THRU MB00PD-MTCC-ACCESS-EXIT.
042300*
042400     MOVE 'C1SC'                 TO SS02WS-ABEND-LOCATION.
042500     SET MMSCRB-CLOSE            TO TRUE.
042600     PERFORM MB00PD-MMSC-ACCESS  THRU MB00PD-MMSC-ACCESS-EXIT.
042700*
042800     PERFORM MB20PD-CLOSE-PRINT-FILES
042900                                 THRU MB20PD-CPF-EXIT.
043000*
043100     STOP RUN.
043200*
043300 B100-PRT-BEGIN.
043400*
043500     MOVE 'CANADA RPT RECORD(MMQ2)'
043600                                 TO MB21WS-NAME.
043700     PERFORM MB21PD-INSERT-A-COLUMN
043800                                 THRU MB21PD-IAC-EXIT.
043900*
044000     MOVE SPACES                 TO MB21WS-PRINT-WORK-AREA.
044100     MOVE 'ORG'                  TO MB21WS-NAME.
044200     MOVE MMQ2-ORG               TO MB21WS-3V0.
044300     PERFORM MB21PD-INSERT-A-COLUMN
044400                                 THRU MB21PD-IAC-EXIT.
044500*
044600     MOVE 'REC-STATUS'           TO MB21WS-NAME.
044700     MOVE MMQ2-REC-STATUS        TO MB21WS-1V0.
044800     PERFORM MB21PD-INSERT-A-COLUMN
044900                                 THRU MB21PD-IAC-EXIT 2 TIMES.
045000*
045100     MOVE 'ADD-STATUS'           TO MB21WS-NAME.
045200     MOVE MMQ2-ONLINE-STATUS     TO MB21WS-2V0.
045300     PERFORM MB21PD-INSERT-A-COLUMN
045400                                 THRU MB21PD-IAC-EXIT 2 TIMES.
045500*
045600     MOVE 'LAST-MAINT-DATE'      TO MB21WS-NAME.
045700     MOVE MMQ2-LAST-MAINT-DATE   TO SS01WS-JULIAN.
045800     PERFORM SS08PD-JUL-TO-GREG  THRU SS08PD-JTG-EXIT.
045900     MOVE MMQ2-LAST-MAINT-DATE   TO MB21WS-JULIAN.
046000     MOVE SS01WS-DATE-L6         TO MB21WS-GREG.
046100     INSPECT MB21WS-JULIAN       REPLACING ALL ',' BY '-'.
046200     PERFORM MB21PD-INSERT-A-COLUMN
046300                                 THRU MB21PD-IAC-EXIT.
046400*
046500     MOVE 'LAST-MAINT-OPER'      TO MB21WS-NAME.
046600     MOVE MMQ2-LAST-MAINT-OPER   TO MB21WS-3X.
046700     PERFORM MB21PD-INSERT-A-COLUMN
046800                                 THRU MB21PD-IAC-EXIT 2 TIMES.
046900*
047000     SET X-MMQ2-VI               TO 1.
047100     SET X-MMQ2-VI-PROV          TO 1.
047200     SET X-MMQ2-VI-MON           TO 1.
047300*
047400*
047500 B100-LOOP.
047600*
047700*
047800     MOVE '*** CANADA (VISA) QUARTLY REPORT TOTALS *'
047900                                 TO MB21WS-PRINT-WORK-AREA.
048000     PERFORM MB21PD-INSERT-A-COLUMN
048100                                 THRU MB21PD-IAC-EXIT.
048200*
048300     MOVE 'QTR-BEG-DATE'         TO MB21WS-NAME.
048400     SET WS-NOT-END-OF-PERFORM   TO TRUE
048500     PERFORM
048600         VARYING X-WS-INDEX
048700         FROM 30 BY -1
048800         UNTIL X-WS-INDEX IS EQUAL TO 1
048900         OR WS-END-OF-PERFORM
049000         IF  MB21WS-NAME (X-WS-INDEX:1)
049100                                 IS NOT EQUAL TO SPACES
049200             ADD 1               TO X-WS-INDEX
049300             MOVE '('            TO MB21WS-NAME (X-WS-INDEX:1)
049400             ADD 1               TO X-WS-INDEX
049500             SET X-WS-TEMP-INDEX
049600                                 TO X-MMQ2-VI
049700             MOVE X-WS-TEMP-INDEX
049800                                 TO MB21WS-NAME (X-WS-INDEX:2)
049900             ADD 2               TO X-WS-INDEX
050000             SET X-WS-MON1-INDEX TO X-MMQ2-VI-MON
050100             MOVE X-WS-MON1-INDEX
050200                                 TO MB21WS-NAME (X-WS-INDEX:2)
050300             ADD 1               TO X-WS-INDEX
050400             MOVE ')'            TO MB21WS-NAME (X-WS-INDEX:1)
050500             SET WS-END-OF-PERFORM
050600                                 TO TRUE
050700         END-IF
050800     END-PERFORM.
050900     MOVE MMQ2-QTR-BEG-DATE (X-MMQ2-VI)
051000                                 TO SS01WS-JULIAN.
051100     PERFORM SS08PD-JUL-TO-GREG  THRU SS08PD-JTG-EXIT.
051200     MOVE MMQ2-QTR-BEG-DATE (X-MMQ2-VI)
051300                                 TO MB21WS-JULIAN.
051400     MOVE SS01WS-DATE-L6         TO MB21WS-GREG.
051500     INSPECT MB21WS-JULIAN       REPLACING ALL ',' BY '-'.
051600     PERFORM MB21PD-INSERT-A-COLUMN
051700                                 THRU MB21PD-IAC-EXIT.
051800*
051900     MOVE 'QTR-END-DATE'         TO MB21WS-NAME.
052000     SET WS-NOT-END-OF-PERFORM   TO TRUE
052100     PERFORM
052200         VARYING X-WS-INDEX
052300         FROM 30 BY -1
052400         UNTIL X-WS-INDEX IS EQUAL TO 1
052500         OR WS-END-OF-PERFORM
052600         IF  MB21WS-NAME (X-WS-INDEX:1)
052700                                 IS NOT EQUAL TO SPACES
052800             ADD 1               TO X-WS-INDEX
052900             MOVE '('            TO MB21WS-NAME (X-WS-INDEX:1)
053000             ADD 1               TO X-WS-INDEX
053100             SET X-WS-TEMP-INDEX
053200                                 TO X-MMQ2-VI
053300             MOVE X-WS-TEMP-INDEX
053400                                 TO MB21WS-NAME (X-WS-INDEX:2)
053500             ADD 2               TO X-WS-INDEX
053600             SET X-WS-MON1-INDEX TO X-MMQ2-VI-MON
053700             MOVE X-WS-MON1-INDEX
053800                                 TO MB21WS-NAME (X-WS-INDEX:2)
053900             ADD 1               TO X-WS-INDEX
054000             MOVE ')'            TO MB21WS-NAME (X-WS-INDEX:1)
054100             SET WS-END-OF-PERFORM
054200                                 TO TRUE
054300         END-IF
054400     END-PERFORM.
054500     MOVE MMQ2-QTR-END-DATE (X-MMQ2-VI)
054600                                 TO SS01WS-JULIAN.
054700     PERFORM SS08PD-JUL-TO-GREG  THRU SS08PD-JTG-EXIT.
054800     MOVE MMQ2-QTR-END-DATE (X-MMQ2-VI)
054900                                 TO MB21WS-JULIAN.
055000     MOVE SS01WS-DATE-L6         TO MB21WS-GREG.
055100     INSPECT MB21WS-JULIAN       REPLACING ALL ',' BY '-'.
055200     PERFORM MB21PD-INSERT-A-COLUMN
055300                                 THRU MB21PD-IAC-EXIT.
055400*
055500 B110-LOOP.
055600*
055700*
055800     MOVE 'VI-NBR-MERCHANTS'     TO MB21WS-NAME.
055900     SET WS-NOT-END-OF-PERFORM   TO TRUE
056000     PERFORM
056100         VARYING X-WS-INDEX
056200         FROM 30 BY -1
056300         UNTIL X-WS-INDEX IS EQUAL TO 1
056400         OR WS-END-OF-PERFORM
056500         IF  MB21WS-NAME (X-WS-INDEX:1)
056600                                 IS NOT EQUAL TO SPACES
056700             ADD 1               TO X-WS-INDEX
056800             MOVE '('            TO MB21WS-NAME (X-WS-INDEX:1)
056900             ADD 1               TO X-WS-INDEX
057000             SET X-WS-TEMP-INDEX
057100                                 TO X-MMQ2-VI
057200             MOVE X-WS-TEMP-INDEX
057300                                 TO MB21WS-NAME (X-WS-INDEX:2)
057400             ADD 2               TO X-WS-INDEX
057500             SET X-WS-MON-INDEX  TO X-MMQ2-VI-PROV
057600             MOVE X-WS-MON-INDEX
057700                                 TO MB21WS-NAME (X-WS-INDEX:2)
057800             ADD 2               TO X-WS-INDEX
057900             MOVE ')'            TO MB21WS-NAME (X-WS-INDEX:1)
058000             SET WS-END-OF-PERFORM
058100                                 TO TRUE
058200         END-IF
058300     END-PERFORM.
058400     MOVE MMQ2-VI-NBR-MERCHANTS (X-MMQ2-VI X-MMQ2-VI-PROV)
058500                                 TO MB21WS-2V0.
058600     PERFORM MB21PD-INSERT-A-COLUMN
058700                                 THRU MB21PD-IAC-EXIT.
058800*
058900     MOVE 'VI-NBR-STORES'        TO MB21WS-NAME.
059000     SET WS-NOT-END-OF-PERFORM   TO TRUE
059100     PERFORM
059200         VARYING X-WS-INDEX
059300         FROM 30 BY -1
059400         UNTIL X-WS-INDEX IS EQUAL TO 1
059500         OR WS-END-OF-PERFORM
059600         IF  MB21WS-NAME (X-WS-INDEX:1)
059700                                 IS NOT EQUAL TO SPACES
059800             ADD 1               TO X-WS-INDEX
059900             MOVE '('            TO MB21WS-NAME (X-WS-INDEX:1)
060000             ADD 1               TO X-WS-INDEX
060100             SET X-WS-TEMP-INDEX
060200                                 TO X-MMQ2-VI
060300             MOVE X-WS-TEMP-INDEX
060400                                 TO MB21WS-NAME (X-WS-INDEX:2)
060500             ADD 2               TO X-WS-INDEX
060600             SET X-WS-MON-INDEX  TO X-MMQ2-VI-PROV
060700             MOVE X-WS-MON-INDEX
060800                                 TO MB21WS-NAME (X-WS-INDEX:2)
060900             ADD 2               TO X-WS-INDEX
061000             MOVE ')'            TO MB21WS-NAME (X-WS-INDEX:1)
061100             SET WS-END-OF-PERFORM
061200                                 TO TRUE
061300         END-IF
061400     END-PERFORM.
061500     MOVE MMQ2-VI-NBR-STORES (X-MMQ2-VI X-MMQ2-VI-PROV)
061600                                 TO MB21WS-2V0.
061700     PERFORM MB21PD-INSERT-A-COLUMN
061800                                 THRU MB21PD-IAC-EXIT.
061900*
062000*
062100     IF  X-MMQ2-VI-PROV IS LESS THAN 10
062200         SET X-MMQ2-VI-PROV UP BY 1
062300         GO TO B110-LOOP.
062400*
062500*
062600*
062700 B120-LOOP.
062800*
062900*
063000     MOVE 'VI-MONTH'             TO MB21WS-NAME.
063100     SET WS-NOT-END-OF-PERFORM   TO TRUE
063200     PERFORM
063300         VARYING X-WS-INDEX
063400         FROM 30 BY -1
063500         UNTIL X-WS-INDEX IS EQUAL TO 1
063600         OR WS-END-OF-PERFORM
063700         IF  MB21WS-NAME (X-WS-INDEX:1)
063800                                 IS NOT EQUAL TO SPACES
063900             ADD 1               TO X-WS-INDEX
064000             MOVE '('            TO MB21WS-NAME (X-WS-INDEX:1)
064100             ADD 1               TO X-WS-INDEX
064200             SET X-WS-TEMP-INDEX
064300                                 TO X-MMQ2-VI
064400             MOVE X-WS-TEMP-INDEX
064500                                 TO MB21WS-NAME (X-WS-INDEX:2)
064600             ADD 2               TO X-WS-INDEX
064700             SET X-WS-MON1-INDEX TO X-MMQ2-VI-MON
064800             MOVE X-WS-MON1-INDEX
064900                                 TO MB21WS-NAME (X-WS-INDEX:2)
065000             ADD 1               TO X-WS-INDEX
065100             MOVE ')'            TO MB21WS-NAME (X-WS-INDEX:1)
065200             SET WS-END-OF-PERFORM
065300                                 TO TRUE
065400         END-IF
065500     END-PERFORM.
065600     MOVE MMQ2-VI-MONTH (X-MMQ2-VI X-MMQ2-VI-MON)
065700                                 TO MB21WS-2V0.
065800     PERFORM MB21PD-INSERT-A-COLUMN
065900                                 THRU MB21PD-IAC-EXIT.
066000*
066100     MOVE 'VI-YEAR'              TO MB21WS-NAME.
066200     SET WS-NOT-END-OF-PERFORM   TO TRUE
066300     PERFORM
066400         VARYING X-WS-INDEX
066500         FROM 30 BY -1
066600         UNTIL X-WS-INDEX IS EQUAL TO 1
066700         OR WS-END-OF-PERFORM
066800         IF  MB21WS-NAME (X-WS-INDEX:1)
066900                                 IS NOT EQUAL TO SPACES
067000             ADD 1               TO X-WS-INDEX
067100             MOVE '('            TO MB21WS-NAME (X-WS-INDEX:1)
067200             ADD 1               TO X-WS-INDEX
067300             SET X-WS-TEMP-INDEX
067400                                 TO X-MMQ2-VI
067500             MOVE X-WS-TEMP-INDEX
067600                                 TO MB21WS-NAME (X-WS-INDEX:2)
067700             ADD 2               TO X-WS-INDEX
067800             SET X-WS-MON1-INDEX TO X-MMQ2-VI-MON
067900             MOVE X-WS-MON1-INDEX
068000                                 TO MB21WS-NAME (X-WS-INDEX:2)
068100             ADD 1               TO X-WS-INDEX
068200             MOVE ')'            TO MB21WS-NAME (X-WS-INDEX:1)
068300             SET WS-END-OF-PERFORM
068400                                 TO TRUE
068500         END-IF
068600     END-PERFORM.
068700     MOVE MMQ2-VI-YEAR (X-MMQ2-VI X-MMQ2-VI-MON)
068800                                 TO MB21WS-4V0.
068900     PERFORM MB21PD-INSERT-A-COLUMN
069000                                 THRU MB21PD-IAC-EXIT.
069100*
069200*
069300     MOVE 'VI-ONUS-NBR'          TO MB21WS-NAME.
069400     SET WS-NOT-END-OF-PERFORM   TO TRUE
069500     PERFORM
069600         VARYING X-WS-INDEX
069700         FROM 30 BY -1
069800         UNTIL X-WS-INDEX IS EQUAL TO 1
069900         OR WS-END-OF-PERFORM
070000         IF  MB21WS-NAME (X-WS-INDEX:1)
070100                                 IS NOT EQUAL TO SPACES
070200             ADD 1               TO X-WS-INDEX
070300             MOVE '('            TO MB21WS-NAME (X-WS-INDEX:1)
070400             ADD 1               TO X-WS-INDEX
070500             SET X-WS-TEMP-INDEX TO X-MMQ2-VI
070600             MOVE X-WS-TEMP-INDEX
070700                                 TO MB21WS-NAME (X-WS-INDEX:2)
070800             ADD 2               TO X-WS-INDEX
070900             SET X-WS-MON1-INDEX TO X-MMQ2-VI-MON
071000             MOVE X-WS-MON1-INDEX
071100                                 TO MB21WS-NAME (X-WS-INDEX:2)
071200             ADD 1               TO X-WS-INDEX
071300             MOVE ')'            TO MB21WS-NAME (X-WS-INDEX:1)
071400             SET WS-END-OF-PERFORM
071500                                 TO TRUE
071600         END-IF
071700     END-PERFORM.
071800     MOVE MMQ2-VI-ONUS-NBR (X-MMQ2-VI X-MMQ2-VI-MON)
071900                                 TO MB21WS-9V0Z.
072000     PERFORM MB21PD-INSERT-A-COLUMN
072100                                 THRU MB21PD-IAC-EXIT.
072200*
072300     MOVE 'VI-ONUS-AMT'          TO MB21WS-NAME.
072400     SET WS-NOT-END-OF-PERFORM   TO TRUE
072500     PERFORM
072600         VARYING X-WS-INDEX
072700         FROM 30 BY -1
072800         UNTIL X-WS-INDEX IS EQUAL TO 1
072900         OR WS-END-OF-PERFORM
073000         IF  MB21WS-NAME (X-WS-INDEX:1)
073100                                 IS NOT EQUAL TO SPACES
073200             ADD 1               TO X-WS-INDEX
073300             MOVE '('            TO MB21WS-NAME (X-WS-INDEX:1)
073400             ADD 1               TO X-WS-INDEX
073500             SET X-WS-TEMP-INDEX TO X-MMQ2-VI
073600             MOVE X-WS-TEMP-INDEX
073700                                 TO MB21WS-NAME (X-WS-INDEX:2)
073800             ADD 2               TO X-WS-INDEX
073900             SET X-WS-MON1-INDEX TO X-MMQ2-VI-MON
074000             MOVE X-WS-MON1-INDEX
074100                                 TO MB21WS-NAME (X-WS-INDEX:2)
074200             ADD 1               TO X-WS-INDEX
074300             MOVE ')'            TO MB21WS-NAME (X-WS-INDEX:1)
074400             SET WS-END-OF-PERFORM
074500                                 TO TRUE
074600         END-IF
074700     END-PERFORM.
074800     MOVE MMQ2-VI-ONUS-AMT (X-MMQ2-VI X-MMQ2-VI-MON)
074900                                 TO MB21WS-15V2.
075000     PERFORM MB21PD-INSERT-A-COLUMN
075100                                 THRU MB21PD-IAC-EXIT.
075200*
075300     MOVE 'VI-DOMESTIC-NBR'      TO MB21WS-NAME.
075400     SET WS-NOT-END-OF-PERFORM   TO TRUE
075500     PERFORM
075600         VARYING X-WS-INDEX
075700         FROM 30 BY -1
075800         UNTIL X-WS-INDEX IS EQUAL TO 1
075900         OR WS-END-OF-PERFORM
076000         IF  MB21WS-NAME (X-WS-INDEX:1)
076100                                 IS NOT EQUAL TO SPACES
076200             ADD 1               TO X-WS-INDEX
076300             MOVE '('            TO MB21WS-NAME (X-WS-INDEX:1)
076400             ADD 1               TO X-WS-INDEX
076500             SET X-WS-TEMP-INDEX TO X-MMQ2-VI
076600             MOVE X-WS-TEMP-INDEX
076700                                 TO MB21WS-NAME (X-WS-INDEX:2)
076800             ADD 2               TO X-WS-INDEX
076900             SET X-WS-MON1-INDEX TO X-MMQ2-VI-MON
077000             MOVE X-WS-MON1-INDEX
077100                                 TO MB21WS-NAME (X-WS-INDEX:2)
077200             ADD 1               TO X-WS-INDEX
077300             MOVE ')'            TO MB21WS-NAME (X-WS-INDEX:1)
077400             SET WS-END-OF-PERFORM
077500                                 TO TRUE
077600         END-IF
077700     END-PERFORM.
077800     MOVE MMQ2-VI-DOMESTIC-NBR (X-MMQ2-VI X-MMQ2-VI-MON)
077900                                 TO MB21WS-9V0Z.
078000     PERFORM MB21PD-INSERT-A-COLUMN
078100                                 THRU MB21PD-IAC-EXIT.
078200*
078300     MOVE 'VI-DOMESTIC-AMT'      TO MB21WS-NAME.
078400     SET WS-NOT-END-OF-PERFORM   TO TRUE
078500     PERFORM
078600         VARYING X-WS-INDEX
078700         FROM 30 BY -1
078800         UNTIL X-WS-INDEX IS EQUAL TO 1
078900         OR WS-END-OF-PERFORM
079000         IF  MB21WS-NAME (X-WS-INDEX:1)
079100                                 IS NOT EQUAL TO SPACES
079200             ADD 1               TO X-WS-INDEX
079300             MOVE '('            TO MB21WS-NAME (X-WS-INDEX:1)
079400             ADD 1               TO X-WS-INDEX
079500             SET X-WS-TEMP-INDEX TO X-MMQ2-VI
079600             MOVE X-WS-TEMP-INDEX
079700                                 TO MB21WS-NAME (X-WS-INDEX:2)
079800             ADD 2               TO X-WS-INDEX
079900             SET X-WS-MON1-INDEX TO X-MMQ2-VI-MON
080000             MOVE X-WS-MON1-INDEX
080100                                 TO MB21WS-NAME (X-WS-INDEX:2)
080200             ADD 1               TO X-WS-INDEX
080300             MOVE ')'            TO MB21WS-NAME (X-WS-INDEX:1)
080400             SET WS-END-OF-PERFORM
080500                                 TO TRUE
080600         END-IF
080700     END-PERFORM.
080800     MOVE MMQ2-VI-DOMESTIC-AMT (X-MMQ2-VI X-MMQ2-VI-MON)
080900                                 TO MB21WS-15V2.
081000     PERFORM MB21PD-INSERT-A-COLUMN
081100                                 THRU MB21PD-IAC-EXIT.
081200*
081300     MOVE 'VI-INTER-NBR'         TO MB21WS-NAME.
081400     SET WS-NOT-END-OF-PERFORM   TO TRUE
081500     PERFORM
081600         VARYING X-WS-INDEX
081700         FROM 30 BY -1
081800         UNTIL X-WS-INDEX IS EQUAL TO 1
081900         OR WS-END-OF-PERFORM
082000         IF  MB21WS-NAME (X-WS-INDEX:1)
082100                                 IS NOT EQUAL TO SPACES
082200             ADD 1               TO X-WS-INDEX
082300             MOVE '('            TO MB21WS-NAME (X-WS-INDEX:1)
082400             ADD 1               TO X-WS-INDEX
082500             SET X-WS-TEMP-INDEX TO X-MMQ2-VI
082600             MOVE X-WS-TEMP-INDEX
082700                                 TO MB21WS-NAME (X-WS-INDEX:2)
082800             ADD 2               TO X-WS-INDEX
082900             SET X-WS-MON1-INDEX TO X-MMQ2-VI-MON
083000             MOVE X-WS-MON1-INDEX
083100                                 TO MB21WS-NAME (X-WS-INDEX:2)
083200             ADD 1               TO X-WS-INDEX
083300             MOVE ')'            TO MB21WS-NAME (X-WS-INDEX:1)
083400             SET WS-END-OF-PERFORM
083500                                 TO TRUE
083600         END-IF
083700     END-PERFORM.
083800     MOVE MMQ2-VI-INTER-NBR (X-MMQ2-VI X-MMQ2-VI-MON)
083900                                 TO MB21WS-9V0Z.
084000     PERFORM MB21PD-INSERT-A-COLUMN
084100                                 THRU MB21PD-IAC-EXIT.
084200*
084300     MOVE 'VI-INTER-AMT'         TO MB21WS-NAME.
084400     SET WS-NOT-END-OF-PERFORM   TO TRUE
084500     PERFORM
084600         VARYING X-WS-INDEX
084700         FROM 30 BY -1
084800         UNTIL X-WS-INDEX IS EQUAL TO 1
084900         OR WS-END-OF-PERFORM
085000         IF  MB21WS-NAME (X-WS-INDEX:1)
085100                                 IS NOT EQUAL TO SPACES
085200             ADD 1               TO X-WS-INDEX
085300             MOVE '('            TO MB21WS-NAME (X-WS-INDEX:1)
085400             ADD 1               TO X-WS-INDEX
085500             SET X-WS-TEMP-INDEX TO X-MMQ2-VI
085600             MOVE X-WS-TEMP-INDEX
085700                                 TO MB21WS-NAME (X-WS-INDEX:2)
085800             ADD 2               TO X-WS-INDEX
085900             SET X-WS-MON1-INDEX TO X-MMQ2-VI-MON
086000             MOVE X-WS-MON1-INDEX
086100                                 TO MB21WS-NAME (X-WS-INDEX:2)
086200             ADD 1               TO X-WS-INDEX
086300             MOVE ')'            TO MB21WS-NAME (X-WS-INDEX:1)
086400             SET WS-END-OF-PERFORM
086500                                 TO TRUE
086600         END-IF
086700     END-PERFORM.
086800     MOVE MMQ2-VI-INTER-AMT (X-MMQ2-VI X-MMQ2-VI-MON)
086900                                 TO MB21WS-15V2.
087000     PERFORM MB21PD-INSERT-A-COLUMN
087100                                 THRU MB21PD-IAC-EXIT.
087200*
087300     MOVE 'VI-CREDITS-NBR'       TO MB21WS-NAME.
087400     SET WS-NOT-END-OF-PERFORM   TO TRUE
087500     PERFORM
087600         VARYING X-WS-INDEX
087700         FROM 30 BY -1
087800         UNTIL X-WS-INDEX IS EQUAL TO 1
087900         OR WS-END-OF-PERFORM
088000         IF  MB21WS-NAME (X-WS-INDEX:1)
088100                                 IS NOT EQUAL TO SPACES
088200             ADD 1               TO X-WS-INDEX
088300             MOVE '('            TO MB21WS-NAME (X-WS-INDEX:1)
088400             ADD 1               TO X-WS-INDEX
088500             SET X-WS-TEMP-INDEX TO X-MMQ2-VI
088600             MOVE X-WS-TEMP-INDEX
088700                                 TO MB21WS-NAME (X-WS-INDEX:2)
088800             ADD 2               TO X-WS-INDEX
088900             SET X-WS-MON1-INDEX TO X-MMQ2-VI-MON
089000             MOVE X-WS-MON1-INDEX
089100                                 TO MB21WS-NAME (X-WS-INDEX:2)
089200             ADD 1               TO X-WS-INDEX
089300             MOVE ')'            TO MB21WS-NAME (X-WS-INDEX:1)
089400             SET WS-END-OF-PERFORM
089500                                 TO TRUE
089600         END-IF
089700     END-PERFORM.
089800     MOVE MMQ2-VI-CREDITS-NBR (X-MMQ2-VI X-MMQ2-VI-MON)
089900                                 TO MB21WS-9V0Z.
090000     PERFORM MB21PD-INSERT-A-COLUMN
090100                                 THRU MB21PD-IAC-EXIT.
090200*
090300     MOVE 'VI-CREDITS-AMT'       TO MB21WS-NAME.
090400     SET WS-NOT-END-OF-PERFORM   TO TRUE
090500     PERFORM
090600         VARYING X-WS-INDEX
090700         FROM 30 BY -1
090800         UNTIL X-WS-INDEX IS EQUAL TO 1
090900         OR WS-END-OF-PERFORM
091000         IF  MB21WS-NAME (X-WS-INDEX:1)
091100                                 IS NOT EQUAL TO SPACES
091200             ADD 1               TO X-WS-INDEX
091300             MOVE '('            TO MB21WS-NAME (X-WS-INDEX:1)
091400             ADD 1               TO X-WS-INDEX
091500             SET X-WS-TEMP-INDEX TO X-MMQ2-VI
091600             MOVE X-WS-TEMP-INDEX
091700                                 TO MB21WS-NAME (X-WS-INDEX:2)
091800             ADD 2               TO X-WS-INDEX
091900             SET X-WS-MON1-INDEX TO X-MMQ2-VI-MON
092000             MOVE X-WS-MON1-INDEX
092100                                 TO MB21WS-NAME (X-WS-INDEX:2)
092200             ADD 1               TO X-WS-INDEX
092300             MOVE ')'            TO MB21WS-NAME (X-WS-INDEX:1)
092400             SET WS-END-OF-PERFORM
092500                                 TO TRUE
092600         END-IF
092700     END-PERFORM.
092800     MOVE MMQ2-VI-CREDITS-AMT (X-MMQ2-VI X-MMQ2-VI-MON)
092900                                 TO MB21WS-15V2.
093000     PERFORM MB21PD-INSERT-A-COLUMN
093100                                 THRU MB21PD-IAC-EXIT.
093200*
093300     MOVE 'VI-ONUS-CD-NBR'       TO MB21WS-NAME.
093400     SET WS-NOT-END-OF-PERFORM   TO TRUE
093500     PERFORM
093600         VARYING X-WS-INDEX
093700         FROM 30 BY -1
093800         UNTIL X-WS-INDEX IS EQUAL TO 1
093900         OR WS-END-OF-PERFORM
094000         IF  MB21WS-NAME (X-WS-INDEX:1)
094100                                 IS NOT EQUAL TO SPACES
094200             ADD 1               TO X-WS-INDEX
094300             MOVE '('            TO MB21WS-NAME (X-WS-INDEX:1)
094400             ADD 1               TO X-WS-INDEX
094500             SET X-WS-TEMP-INDEX TO X-MMQ2-VI
094600             MOVE X-WS-TEMP-INDEX
094700                                 TO MB21WS-NAME (X-WS-INDEX:2)
094800             ADD 2               TO X-WS-INDEX
094900             SET X-WS-MON1-INDEX TO X-MMQ2-VI-MON
095000             MOVE X-WS-MON1-INDEX
095100                                 TO MB21WS-NAME (X-WS-INDEX:2)
095200             ADD 1               TO X-WS-INDEX
095300             MOVE ')'            TO MB21WS-NAME (X-WS-INDEX:1)
095400             SET WS-END-OF-PERFORM
095500                                 TO TRUE
095600         END-IF
095700     END-PERFORM.
095800     MOVE MMQ2-VI-ONUS-CD-NBR (X-MMQ2-VI X-MMQ2-VI-MON)
095900                                 TO MB21WS-9V0Z.
096000     PERFORM MB21PD-INSERT-A-COLUMN
096100                                 THRU MB21PD-IAC-EXIT.
096200*
096300     MOVE 'VI-ONUS-CD-AMT'       TO MB21WS-NAME.
096400     SET WS-NOT-END-OF-PERFORM   TO TRUE
096500     PERFORM
096600         VARYING X-WS-INDEX
096700         FROM 30 BY -1
096800         UNTIL X-WS-INDEX IS EQUAL TO 1
096900         OR WS-END-OF-PERFORM
097000         IF  MB21WS-NAME (X-WS-INDEX:1)
097100                                 IS NOT EQUAL TO SPACES
097200             ADD 1               TO X-WS-INDEX
097300             MOVE '('            TO MB21WS-NAME (X-WS-INDEX:1)
097400             ADD 1               TO X-WS-INDEX
097500             SET X-WS-TEMP-INDEX TO X-MMQ2-VI
097600             MOVE X-WS-TEMP-INDEX
097700                                 TO MB21WS-NAME (X-WS-INDEX:2)
097800             ADD 2               TO X-WS-INDEX
097900             SET X-WS-MON1-INDEX TO X-MMQ2-VI-MON
098000             MOVE X-WS-MON1-INDEX
098100                                 TO MB21WS-NAME (X-WS-INDEX:2)
098200             ADD 1               TO X-WS-INDEX
098300             MOVE ')'            TO MB21WS-NAME (X-WS-INDEX:1)
098400             SET WS-END-OF-PERFORM
098500                                 TO TRUE
098600         END-IF
098700     END-PERFORM.
098800     MOVE MMQ2-VI-ONUS-CD-AMT (X-MMQ2-VI X-MMQ2-VI-MON)
098900                                 TO MB21WS-15V2.
099000     PERFORM MB21PD-INSERT-A-COLUMN
099100                                 THRU MB21PD-IAC-EXIT.
099200*
099300     MOVE 'VI-DOMESTIC-CD-NBR'   TO MB21WS-NAME.
099400     SET WS-NOT-END-OF-PERFORM   TO TRUE
099500     PERFORM
099600         VARYING X-WS-INDEX
099700         FROM 30 BY -1
099800         UNTIL X-WS-INDEX IS EQUAL TO 1
099900         OR WS-END-OF-PERFORM
100000         IF  MB21WS-NAME (X-WS-INDEX:1)
100100                                 IS NOT EQUAL TO SPACES
100200             ADD 1               TO X-WS-INDEX
100300             MOVE '('            TO MB21WS-NAME (X-WS-INDEX:1)
100400             ADD 1               TO X-WS-INDEX
100500             SET X-WS-TEMP-INDEX TO X-MMQ2-VI
100600             MOVE X-WS-TEMP-INDEX
100700                                 TO MB21WS-NAME (X-WS-INDEX:2)
100800             ADD 2               TO X-WS-INDEX
100900             SET X-WS-MON1-INDEX TO X-MMQ2-VI-MON
101000             MOVE X-WS-MON1-INDEX
101100                                 TO MB21WS-NAME (X-WS-INDEX:2)
101200             ADD 1               TO X-WS-INDEX
101300             MOVE ')'            TO MB21WS-NAME (X-WS-INDEX:1)
101400             SET WS-END-OF-PERFORM
101500                                 TO TRUE
101600         END-IF
101700     END-PERFORM.
101800     MOVE MMQ2-VI-DOMESTIC-CD-NBR (X-MMQ2-VI X-MMQ2-VI-MON)
101900                                 TO MB21WS-9V0Z.
102000     PERFORM MB21PD-INSERT-A-COLUMN
102100                                 THRU MB21PD-IAC-EXIT.
102200*
102300     MOVE 'VI-DOMESTIC-CD-AMT'   TO MB21WS-NAME.
102400     SET WS-NOT-END-OF-PERFORM   TO TRUE
102500     PERFORM
102600         VARYING X-WS-INDEX
102700         FROM 30 BY -1
102800         UNTIL X-WS-INDEX IS EQUAL TO 1
102900         OR WS-END-OF-PERFORM
103000         IF  MB21WS-NAME (X-WS-INDEX:1)
103100                                 IS NOT EQUAL TO SPACES
103200             ADD 1               TO X-WS-INDEX
103300             MOVE '('            TO MB21WS-NAME (X-WS-INDEX:1)
103400             ADD 1               TO X-WS-INDEX
103500             SET X-WS-TEMP-INDEX TO X-MMQ2-VI
103600             MOVE X-WS-TEMP-INDEX
103700                                 TO MB21WS-NAME (X-WS-INDEX:2)
103800             ADD 2               TO X-WS-INDEX
103900             SET X-WS-MON1-INDEX TO X-MMQ2-VI-MON
104000             MOVE X-WS-MON1-INDEX
104100                                 TO MB21WS-NAME (X-WS-INDEX:2)
104200             ADD 1               TO X-WS-INDEX
104300             MOVE ')'            TO MB21WS-NAME (X-WS-INDEX:1)
104400             SET WS-END-OF-PERFORM
104500                                 TO TRUE
104600         END-IF
104700     END-PERFORM.
104800     MOVE MMQ2-VI-DOMESTIC-CD-AMT (X-MMQ2-VI X-MMQ2-VI-MON)
104900                                 TO MB21WS-15V2.
105000     PERFORM MB21PD-INSERT-A-COLUMN
105100                                 THRU MB21PD-IAC-EXIT.
105200*
105300     MOVE 'VI-INTER-CD-NBR'      TO MB21WS-NAME.
105400     SET WS-NOT-END-OF-PERFORM   TO TRUE
105500     PERFORM
105600         VARYING X-WS-INDEX
105700         FROM 30 BY -1
105800         UNTIL X-WS-INDEX IS EQUAL TO 1
105900         OR WS-END-OF-PERFORM
106000         IF  MB21WS-NAME (X-WS-INDEX:1)
106100                                 IS NOT EQUAL TO SPACES
106200             ADD 1               TO X-WS-INDEX
106300             MOVE '('            TO MB21WS-NAME (X-WS-INDEX:1)
106400             ADD 1               TO X-WS-INDEX
106500             SET X-WS-TEMP-INDEX TO X-MMQ2-VI
106600             MOVE X-WS-TEMP-INDEX
106700                                 TO MB21WS-NAME (X-WS-INDEX:2)
106800             ADD 2               TO X-WS-INDEX
106900             SET X-WS-MON1-INDEX TO X-MMQ2-VI-MON
107000             MOVE X-WS-MON1-INDEX
107100                                 TO MB21WS-NAME (X-WS-INDEX:2)
107200             ADD 1               TO X-WS-INDEX
107300             MOVE ')'            TO MB21WS-NAME (X-WS-INDEX:1)
107400             SET WS-END-OF-PERFORM
107500                                 TO TRUE
107600         END-IF
107700     END-PERFORM.
107800     MOVE MMQ2-VI-INTER-CD-NBR (X-MMQ2-VI X-MMQ2-VI-MON)
107900                                 TO MB21WS-9V0Z.
108000     PERFORM MB21PD-INSERT-A-COLUMN
108100                                 THRU MB21PD-IAC-EXIT.
108200*
108300     MOVE 'VI-INTER-CD-AMT'      TO MB21WS-NAME.
108400     SET WS-NOT-END-OF-PERFORM   TO TRUE
108500     PERFORM
108600         VARYING X-WS-INDEX
108700         FROM 30 BY -1
108800         UNTIL X-WS-INDEX IS EQUAL TO 1
108900         OR WS-END-OF-PERFORM
109000         IF  MB21WS-NAME (X-WS-INDEX:1)
109100                                 IS NOT EQUAL TO SPACES
109200             ADD 1               TO X-WS-INDEX
109300             MOVE '('            TO MB21WS-NAME (X-WS-INDEX:1)
109400             ADD 1               TO X-WS-INDEX
109500             SET X-WS-TEMP-INDEX TO X-MMQ2-VI
109600             MOVE X-WS-TEMP-INDEX
109700                                 TO MB21WS-NAME (X-WS-INDEX:2)
109800             ADD 2               TO X-WS-INDEX
109900             SET X-WS-MON1-INDEX TO X-MMQ2-VI-MON
110000             MOVE X-WS-MON1-INDEX
110100                                 TO MB21WS-NAME (X-WS-INDEX:2)
110200             ADD 1               TO X-WS-INDEX
110300             MOVE ')'            TO MB21WS-NAME (X-WS-INDEX:1)
110400             SET WS-END-OF-PERFORM
110500                                 TO TRUE
110600         END-IF
110700     END-PERFORM.
110800     MOVE MMQ2-VI-INTER-CD-AMT (X-MMQ2-VI X-MMQ2-VI-MON)
110900                                 TO MB21WS-15V2.
111000     PERFORM MB21PD-INSERT-A-COLUMN
111100                                 THRU MB21PD-IAC-EXIT.
111200*
111300     MOVE 'VI-NET-SALES-NBR'     TO MB21WS-NAME.
111400     SET WS-NOT-END-OF-PERFORM   TO TRUE
111500     PERFORM
111600         VARYING X-WS-INDEX
111700         FROM 30 BY -1
111800         UNTIL X-WS-INDEX IS EQUAL TO 1
111900         OR WS-END-OF-PERFORM
112000         IF  MB21WS-NAME (X-WS-INDEX:1)
112100                                 IS NOT EQUAL TO SPACES
112200             ADD 1               TO X-WS-INDEX
112300             MOVE '('            TO MB21WS-NAME (X-WS-INDEX:1)
112400             ADD 1               TO X-WS-INDEX
112500             SET X-WS-TEMP-INDEX TO X-MMQ2-VI
112600             MOVE X-WS-TEMP-INDEX
112700                                 TO MB21WS-NAME (X-WS-INDEX:2)
112800             ADD 2               TO X-WS-INDEX
112900             SET X-WS-MON1-INDEX TO X-MMQ2-VI-MON
113000             MOVE X-WS-MON1-INDEX
113100                                 TO MB21WS-NAME (X-WS-INDEX:2)
113200             ADD 1               TO X-WS-INDEX
113300             MOVE ')'            TO MB21WS-NAME (X-WS-INDEX:1)
113400             SET WS-END-OF-PERFORM
113500                                 TO TRUE
113600         END-IF
113700     END-PERFORM.
113800     MOVE MMQ2-VI-NET-SALES-NBR (X-MMQ2-VI X-MMQ2-VI-MON)
113900                                 TO MB21WS-9V0Z.
114000     PERFORM MB21PD-INSERT-A-COLUMN
114100                                 THRU MB21PD-IAC-EXIT.
114200*
114300     MOVE 'VI-NET-SALES-AMT'     TO MB21WS-NAME.
114400     SET WS-NOT-END-OF-PERFORM   TO TRUE
114500     PERFORM
114600         VARYING X-WS-INDEX
114700         FROM 30 BY -1
114800         UNTIL X-WS-INDEX IS EQUAL TO 1
114900         OR WS-END-OF-PERFORM
115000         IF  MB21WS-NAME (X-WS-INDEX:1)
115100                                 IS NOT EQUAL TO SPACES
115200             ADD 1               TO X-WS-INDEX
115300             MOVE '('            TO MB21WS-NAME (X-WS-INDEX:1)
115400             ADD 1               TO X-WS-INDEX
115500             SET X-WS-TEMP-INDEX TO X-MMQ2-VI
115600             MOVE X-WS-TEMP-INDEX
115700                                 TO MB21WS-NAME (X-WS-INDEX:2)
115800             ADD 2               TO X-WS-INDEX
115900             SET X-WS-MON1-INDEX TO X-MMQ2-VI-MON
116000             MOVE X-WS-MON1-INDEX
116100                                 TO MB21WS-NAME (X-WS-INDEX:2)
116200             ADD 1               TO X-WS-INDEX
116300             MOVE ')'            TO MB21WS-NAME (X-WS-INDEX:1)
116400             SET WS-END-OF-PERFORM
116500                                 TO TRUE
116600         END-IF
116700     END-PERFORM.
116800     MOVE MMQ2-VI-NET-SALES-AMT (X-MMQ2-VI X-MMQ2-VI-MON)
116900                                 TO MB21WS-15V2.
117000     PERFORM MB21PD-INSERT-A-COLUMN
117100                                 THRU MB21PD-IAC-EXIT.
117200*
117300     IF  X-MMQ2-VI-MON IS EQUAL TO 3
117400         PERFORM MB21PD-INSERT-A-COLUMN
117500                                 THRU MB21PD-IAC-EXIT 2 TIMES
117600     ELSE
117700         PERFORM MB21PD-INSERT-A-COLUMN
117800                                 THRU MB21PD-IAC-EXIT.
117900*
118000     IF  X-MMQ2-VI-MON IS LESS THAN 3
118100         SET X-MMQ2-VI-MON       UP BY 1
118200         GO TO B120-LOOP.
118300*
118400*
118500     IF  X-MMQ2-VI IS LESS THAN 4
118600         SET X-MMQ2-VI           UP BY 1
118700         SET X-MMQ2-VI-PROV      TO 1
118800         SET X-MMQ2-VI-MON       TO 1
118900         GO TO B100-LOOP.
119000*
119100 B999-PRT-EXIT.
119200     EXIT.
119300*
119400 B200-PRINT-HEADER.
119500*
119600     MOVE 'ORG HEADER RECORD(MMQ2)'
119700                                 TO MB21WS-NAME.
119800     PERFORM MB21PD-INSERT-A-COLUMN
119900                                 THRU MB21PD-IAC-EXIT.
120000*
120100     MOVE SPACES                 TO MB21WS-PRINT-WORK-AREA.
120200     MOVE 'ORG'                  TO MB21WS-NAME.
120300     MOVE MMQ2IO-ORG             TO MB21WS-3V0.
120400     PERFORM MB21PD-INSERT-A-COLUMN
120500                                 THRU MB21PD-IAC-EXIT.
120600*
120700     MOVE 'DATE-STAMP'           TO MB21WS-NAME.
120800     MOVE MMQ2IO-DATE-STAMP      TO SS01WS-JULIAN.
120900     PERFORM SS08PD-JUL-TO-GREG  THRU SS08PD-JTG-EXIT.
121000     MOVE MMQ2IO-DATE-STAMP      TO MB21WS-JULIAN.
121100     MOVE SS01WS-DATE-L6         TO MB21WS-GREG.
121200     INSPECT MB21WS-JULIAN       REPLACING ALL ',' BY '-'.
121300     PERFORM MB21PD-INSERT-A-COLUMN
121400                                 THRU MB21PD-IAC-EXIT.
121500*
121600     MOVE 'TIME-STAMP'           TO MB21WS-NAME.
121700     MOVE MMQ2IO-TIME-STAMP      TO MB21WS-TIME.
121800     INSPECT MB21WS-TIME         REPLACING ALL SPACE BY '.'.
121900     PERFORM MB21PD-INSERT-A-COLUMN
122000                                 THRU MB21PD-IAC-EXIT.
122100*
122200     PERFORM MB21PD-PRINT-A-PAGE
122300                                 THRU MB21PD-PAP-EXIT.
122400*
122500 B200-PH-EXIT.
122600     EXIT.
122700/
122800* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
122900*                          COMMON ROUTINES                      *
123000* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
123100*
123200     COPY SS02PD.
123300/
123400     COPY SS08PD.
123500/
123600     COPY SS16PD.
123700/
123800     COPY SS26PD.
123900/
124000     COPY SS27PD.
124100/
124200     COPY MB20PD.
124300/
124400     COPY MB21PD.
124500/
124600     COPY MB99PD.
124700/
124800     COPY MB00PD REPLACING ==:MB00:== BY ==MTCC==.
124900/
125000     COPY MB00PD REPLACING ==:MB00:== BY ==MMQ2==.
125100/
125200     COPY MB00PD REPLACING ==:MB00:== BY ==MMSC==.
125300/
125400     COPY MB00PD REPLACING ==:MB00:== BY ==MBMF==.
