000100 IDENTIFICATION DIVISION.
000200 PROGRAM-ID. MBU963.
000201*       RELEASE DATE=08/24/01.        REVISION LEVEL=08.06      * ++++++++
000202***************************************************************** ++++++++
000203*WARNING.  THIS COMPUTER PROGRAM IS PROTECTED BY COPYRIGHT LAW  * ++++++++
000204*AND INTERNATIONAL TREATIES.  UNAUTHORIZED REPRODUCTION OR      * ++++++++
000205*DISTRIBUTION OF THIS PROGRAM, OR ANY PORTION OF IT, MAY RESULT * ++++++++
000206*IN SEVERE CIVIL AND CRIMINAL PENATLIES, AND WILL BE PROSECUTED * ++++++++
000207*TO THE MAXIMUM EXTENT POSSIBLE UNDER THE LAW.                  * ++++++++
000208*COPYRIGHT 1999 PAYSYS INTERNATIONAL, INC.  ALL RIGHTS RESERVED.* ++++++++
000209***************************************************************** ++++++++
000300*****************************************************************
000400*                                                               *
000500*       MBU963 - RESERVED QUARTERLY FILE DISPLAY (MMQ3)         *
000600*                                                               *
000700*****************************************************************
000800 ENVIRONMENT DIVISION.
000900 CONFIGURATION SECTION.
001000 SOURCE-COMPUTER.   IBM-4341.
001100 OBJECT-COMPUTER.   IBM-4341.
001200/
001300 INPUT-OUTPUT SECTION.
001400 FILE-CONTROL.
001500/
001600 DATA DIVISION.
001700 FILE SECTION.
001800 WORKING-STORAGE SECTION.
001900*
002000 01  FILLER                  PIC  X(12)      VALUE '** WS-BEG **'.
002100*
002200     COPY MB00RB REPLACING ==:MB00:== BY ==MTCC==.
002300/
002400     COPY MB00RB REPLACING ==:MB00:== BY ==MMSC==.
002500/
002600     COPY MB00RB REPLACING ==:MB00:== BY ==MMQ3==.
002700/
002800     COPY MBU999WS.
002900/
003000     COPY MB00RB REPLACING ==:MB00:== BY ==MBMF==.
003100/
003200     COPY MTCCRL REPLACING ==:MTCC:== BY ==MTCC==.
003300/
003400     COPY MMSCRL.
003500/
003600     COPY MMQ3RL.
003700/
003800     COPY MBMFRL.
003900/
004000     COPY MTCCIO REPLACING ==:MTCC:== BY ==MTCC==.
004100/
004200     COPY MMSCIO.
004300/
004400     COPY MMQ3IO.
004500/
004600     COPY MBMFIO.
004700/
004800     COPY MB00WS.
004900/
005000     COPY MB20WS.
005100/
005200     COPY MB99WS.
005300/
005400     COPY SS00WS.
005500/
005600     COPY SS01WS.
005700/
005800     COPY SS02WS.
005900*
006000 01  WS-WORK-AREAS.
006100     03  WS-PROG-ID          PIC  X(06)      VALUE 'MBU963'.
006200     03  WS-CARD-READ-SW     PIC  X(01)      VALUE 'N'.
006300     03  X-WS-INDEX          PIC S9(04)      COMP.
006400     03  X-WS-TEMP-INDEX     PIC  9(01).
006500     03  X-WS-MON-INDEX      PIC  9(02).
006600     03  X-WS-MON1-INDEX     PIC  9(01).
006700     03  WS-WORK-DATE        PIC  9(08).
006800     03  WS-WORK-DATE-R      REDEFINES WS-WORK-DATE.
006900         05  WS-WK-DTE-MDY   PIC  9(06).
007000         05  WS-WK-DTE-MDY-R REDEFINES WS-WK-DTE-MDY.
007100             07  WS-WORK-DATE-MM
007200                             PIC  9(02).
007300             07  WS-WORK-DATE-DD
007400                             PIC  9(02).
007500             07  WS-WORK-DATE-XX
007600                             PIC  9(02).
007700         05  WS-WORK-DATE-YY PIC  9(02).
007800*
007900     03  WS-MMQ3-BEG-KEY     PIC  9(03)      VALUE ZEROES.
008000     03  WS-MMQ3-END-KEY     PIC  9(03)      VALUE ZEROES.
008100*
008200     03  WS-BACKUP-OR-MASTER PIC  X(06)      VALUE SPACES.
008300         88  WS-BACKUP                       VALUE 'BACKUP'.
008400         88  WS-MASTER                       VALUE 'MASTER'.
008500*
008600     03  WS-END-OF-PERFORM-SW
008700                             PIC  X(01)      VALUE SPACES.
008800         88  WS-END-OF-PERFORM               VALUE 'Y'.
008900         88  WS-NOT-END-OF-PERFORM           VALUE 'N'.
009000/
009100     COPY MB21WS.
009200*
009300 01  FILLER                  PIC  X(12)      VALUE '** WS-END **'.
009400/
009500 PROCEDURE DIVISION.
009600*
009700 A000-DRIVER.
009800*
009900     MOVE 'MBU963'               TO SS02WS-ABEND-PROG-ID
010000                                    MBU999WS-PROGRAM-ID.
010100*
010200     CALL MB00WS-MBU999CC        USING MBU999WS-AREA.
010300*
010400     MOVE 'MB000000'             TO MB20WS-SH-RPT-ID.
010500     MOVE 'T963'                 TO MB20WS-SH-INTERNAL-RPT-ID.
010600     MOVE '   OPEN FOE MMQ3 FILE         '
010700                                 TO MB20WS-SH-RPT-NAME.
010800     MOVE SPACES                 TO MB20WS-SH-LIT-1
010900                                    MB20WS-SH-LIT-5
011000                                    MB20WS-SH-L4
011100                                    MB20WS-SH-L5
011200                                    MB20WS-SH-L6.
011300     PERFORM MB21PD-PAP-RESET-INDEXES
011400                                 THRU MB21PD-PAP-EXIT.
011500*
011600 A100-OPEN-FILES.
011700*
011800     MOVE SPACES                 TO MB21WS-PRINT-PAGE.
011900     MOVE 'O1CC'                 TO SS02WS-ABEND-LOCATION.
012000     MOVE SS02WS-END-OF-FILE     TO MTCCRB-PERM-STATUS-1.
012100     SET MTCCRB-OPEN-INPUT       TO TRUE.
012200     PERFORM MB00PD-MTCC-ACCESS  THRU MB00PD-MTCC-ACCESS-EXIT.
012300*
012400     MOVE 'O1SC'                 TO SS02WS-ABEND-LOCATION.
012500     SET MMSCRB-OPEN-INPUT       TO TRUE.
012600     PERFORM MB00PD-MMSC-ACCESS  THRU MB00PD-MMSC-ACCESS-EXIT.
012700*
012800     MOVE 'R1SC'                 TO SS02WS-ABEND-LOCATION.
012900     SET MMSCRB-READ-SEQ         TO TRUE.
013000     PERFORM MB00PD-MMSC-ACCESS  THRU MB00PD-MMSC-ACCESS-EXIT.
013100*
013200     MOVE 'MMSC'                 TO MB99WS-FILE-ID.
013300*
013400     IF  MMSCIO-HEADER
013500         NEXT SENTENCE
013600     ELSE
013700         PERFORM MB99PD-MISSING-HEADER-ABEND
013800            THRU MB99PD-MHA-EXIT.
013900*
014000     MOVE MMSCIO-RECORD          TO MMSC-RECORD.
014100     MOVE MMSC-TODAYS-JULIAN     TO SS01WS-JULIAN.
014200     PERFORM SS08PD-JUL-TO-GREG  THRU SS08PD-JTG-EXIT.
014300     MOVE SS01WS-DATE-L6         TO MB20WS-SH-FILE-DATE.
014400     MOVE MMSC-TIME-STAMP        TO MB20WS-SH-PROC-TIME .
014500     INSPECT MB20WS-SH-PROC-TIME REPLACING ALL SPACE BY '.'.
014600*
014700     MOVE MMSC-FORM              TO MB20WS-FORM-CODE.
014800     MOVE MMSC-FICHE-FLAG        TO MB20WS-FICHE-CODE.
014900     MOVE MMSC-LINES-PER-PAGE    TO MB20WS-LINES-PER-PAGE.
015000     MOVE 99                     TO MB20WS-LINE-LIMIT.
015100     COMPUTE MB21WS-LIN-LIMIT    =  MMSC-LINES-PER-PAGE - 4.
015200     MOVE MMSC-SCREEN-HEADER     TO MB20WS-SH-SYSTEM.
015300     MOVE MMSC-DATE-FORMAT       TO SS01WS-DATE-FORMAT.
015400*
015500     MOVE 'R1CC'                 TO SS02WS-ABEND-LOCATION.
015600     SET MTCCRB-READ-SEQ         TO TRUE.
015700     PERFORM MB00PD-MTCC-ACCESS  THRU MB00PD-MTCC-ACCESS-EXIT.
015800*
015900     IF  SS02WS-FS-END-OF-FILE
016000         GO TO A400-CHECK-READ-SWITCH.
016100*
016200     IF  MTCCIO-PROGRAM-ID IS NOT EQUAL TO WS-PROG-ID
016300         GO TO A200-PROGRAM-CONTROL.
016400*
016500     MOVE MTCCIO-CARD-DATA       TO MTCC-RECORD.
016600*
016700     IF  MTCC-MBU9XX-BACKUP
016800         MOVE 'BACKUP'           TO WS-BACKUP-OR-MASTER
016900         MOVE 'O1MF'             TO SS02WS-ABEND-LOCATION
017000         SET MBMFRB-OPEN-INPUT   TO TRUE
017100         PERFORM MB00PD-MBMF-ACCESS THRU MB00PD-MBMF-ACCESS-EXIT
017200         MOVE 'R1MF'             TO SS02WS-ABEND-LOCATION
017300         SET MBMFRB-READ-SEQ     TO TRUE
017400         MOVE SS02WS-NO-RECORD-FOUND
017500                                 TO MBMFRB-PERM-STATUS-3
017600         MOVE SS02WS-END-OF-FILE
017700                                 TO MBMFRB-PERM-STATUS-4
017800         PERFORM MB00PD-MBMF-ACCESS THRU MB00PD-MBMF-ACCESS-EXIT
017900     ELSE
018000         MOVE 'O1Q3'             TO SS02WS-ABEND-LOCATION
018100         SET MMQ3RB-OPEN-INPUT   TO TRUE
018200         PERFORM MB00PD-MMQ3-ACCESS THRU MB00PD-MMQ3-ACCESS-EXIT
018300         MOVE 'R1Q3'             TO SS02WS-ABEND-LOCATION
018400         SET MMQ3RB-READ-SEQ     TO TRUE
018500         MOVE SS02WS-NO-RECORD-FOUND
018600                                 TO MMQ3RB-PERM-STATUS-3
018700         MOVE SS02WS-END-OF-FILE
018800                                 TO MMQ3RB-PERM-STATUS-4
018900         PERFORM MB00PD-MMQ3-ACCESS THRU MB00PD-MMQ3-ACCESS-EXIT
019000         GO TO A130-PRINT-HR-RECORD.
019100*
019200     MOVE 'MBMF'                 TO MB99WS-FILE-ID.
019300*
019400     IF  MBMFIO-FILE-IS-HEADER
019500         NEXT SENTENCE
019600     ELSE
019700         PERFORM MB99PD-MISSING-HEADER-ABEND
019800            THRU MB99PD-MHA-EXIT.
019900*
020000     MOVE MBMFIO-RECORD          TO MBMF-RECORD.
020100*
020200     SET X-MBMF-FILE             TO 1.
020300*
020400 A110-SEARCH-HEADER-TABLE-LOOP.
020500*
020600     IF  X-MBMF-FILE IS GREATER THAN 75
020700         MOVE 'MMQ3'             TO MB99WS-FILE-ID
020800         PERFORM MB99PD-NOT-ON-BACKUP
020900            THRU MB99PD-NOB-EXIT.
021000*
021100     IF  MBMF-MBU020-ENTRY (X-MBMF-FILE) IS EQUAL TO 'Q3'
021200         CONTINUE
021300     ELSE
021400         SET X-MBMF-FILE         UP BY 1
021500         GO TO A110-SEARCH-HEADER-TABLE-LOOP
021600     END-IF.
021700*
021800 A120-READ-MBMF-LOOP.
021900*
022000     MOVE 'R2MF'                 TO SS02WS-ABEND-LOCATION.
022100     SET MBMFRB-READ-SEQ         TO TRUE.
022200     MOVE SS02WS-NO-RECORD-FOUND
022300                                 TO MBMFRB-PERM-STATUS-3.
022400     MOVE SS02WS-END-OF-FILE     TO MBMFRB-PERM-STATUS-4.
022500     PERFORM MB00PD-MBMF-ACCESS  THRU MB00PD-MBMF-ACCESS-EXIT.
022600*
022700     IF  SS02WS-FS-END-OF-FILE
022800         GO TO A200-PROGRAM-CONTROL
022900     END-IF.
023000*
023100     IF  MBMFIO-FILE IS NOT EQUAL TO 'Q3'
023200         GO TO A120-READ-MBMF-LOOP
023300     END-IF.
023400*
023500 A130-PRINT-HR-RECORD.
023600*
023700     IF  WS-BACKUP
023800         MOVE MBMFIO-VAR-DATA    TO MMQ3IO-RECORD
023900     END-IF.
024000*
024100     MOVE 'MMQ3'                 TO MB99WS-FILE-ID.
024200*
024300     IF  MMQ3IO-HEADER
024400         NEXT SENTENCE
024500     ELSE
024600         PERFORM MB99PD-MISSING-HEADER-ABEND
024700            THRU MB99PD-MHA-EXIT.
024800*
024900     MOVE MMQ3IO-RECORD          TO MMQ3-RECORD.
025000*
025100     IF  MMQ3IO-HEADER
025200         PERFORM B200-PRINT-HEADER
025300                                 THRU B200-PH-EXIT
025400     END-IF.
025500*
025600 A200-PROGRAM-CONTROL.
025700*
025800     IF  MTCC-MBU9XX-BACKUP OR MTCC-MBU9XX-MASTER
025900         MOVE MTCC-MBU9XX-OPTION TO WS-BACKUP-OR-MASTER
026000     ELSE
026100         IF  WS-BACKUP-OR-MASTER IS EQUAL TO SPACES
026200             MOVE 'MASTER'       TO WS-BACKUP-OR-MASTER
026300             GO TO A210-PC-BY-FIRST-READ.
026400*
026500     MOVE 'R2CC'                 TO SS02WS-ABEND-LOCATION.
026600     SET MTCCRB-READ-SEQ         TO TRUE.
026700     PERFORM MB00PD-MTCC-ACCESS  THRU MB00PD-MTCC-ACCESS-EXIT.
026800*
026900     IF  SS02WS-FS-END-OF-FILE
027000         GO TO A400-CHECK-READ-SWITCH
027100     END-IF.
027200*
027300 A210-PC-BY-FIRST-READ.
027400*
027500     IF  MTCCIO-PROGRAM-ID IS NOT EQUAL TO WS-PROG-ID
027600         GO TO A200-PROGRAM-CONTROL.
027700*
027800     MOVE MTCCIO-CARD-DATA       TO MTCC-RECORD.
027900*
028000 A300-RANGE-CARD.
028100*
028200     MOVE 'Y'                    TO WS-CARD-READ-SW.
028300     INSPECT MTCC-MBU963-BEG-X   REPLACING ALL SPACE BY ZERO.
028400*
028500     IF  MTCC-MBU963-END-X IS EQUAL TO SPACES
028600         MOVE MTCC-MBU963-BEG-X  TO MTCC-MBU963-END-X
028700     END-IF.
028800*
028900     INSPECT MTCC-MBU963-END-X   REPLACING ALL SPACE BY ZERO.
029000*
029100     MOVE MTCC-MBU963-BEG-ORG    TO WS-MMQ3-BEG-KEY
029200*
029300     MOVE MTCC-MBU963-END-ORG    TO WS-MMQ3-END-KEY.
029400*
029500     IF  WS-BACKUP
029600         GO TO A350-READ-NEXT-MBMF.
029700*
029800     MOVE MTCC-MBU963-BEG-X      TO MMQ3IO-KEY.
029900*
030000     MOVE 'S1Q3'                 TO SS02WS-ABEND-LOCATION.
030100     SET  MMQ3RB-START-GTE       TO TRUE.
030200     PERFORM MB00PD-MMQ3-ACCESS  THRU MB00PD-MMQ3-ACCESS-EXIT.
030300*
030400     IF  SS02WS-FS-NO-RECORD-FOUND
030500         GO TO A500-CONTROL-CARD-ERROR.
030600*
030700 A350-READ-NEXT.
030800*
030900     MOVE 'R2Q3'                 TO SS02WS-ABEND-LOCATION.
031000     SET  MMQ3RB-READ-SEQ        TO TRUE.
031100     PERFORM MB00PD-MMQ3-ACCESS  THRU MB00PD-MMQ3-ACCESS-EXIT.
031200*
031300     IF  SS02WS-FS-END-OF-FILE
031400         IF  MB21WS-PRINT-PAGE IS EQUAL TO SPACES
031500             GO TO A200-PROGRAM-CONTROL
031600         ELSE
031700             PERFORM MB21PD-PRINT-A-PAGE
031800                                 THRU MB21PD-PAP-EXIT
031900             GO TO A200-PROGRAM-CONTROL.
032000*
032100     IF  MMQ3IO-KEY IS GREATER THAN WS-MMQ3-END-KEY
032200         IF  MB21WS-PRINT-PAGE IS EQUAL TO SPACES
032300             GO TO A200-PROGRAM-CONTROL
032400         ELSE
032500             PERFORM MB21PD-PRINT-A-PAGE
032600                                 THRU MB21PD-PAP-EXIT
032700             GO TO A200-PROGRAM-CONTROL.
032800*
032900     IF  MMQ3IO-HEADER
033000     OR  MMQ3IO-TRAILER
033100         GO TO A350-READ-NEXT.
033200*
033300     MOVE MMQ3IO-RECORD          TO MMQ3-RECORD.
033400*
033500     IF  MMQ3-ADD-COMPLETED
033600         PERFORM B100-PRT-BEGIN  THRU B999-PRT-EXIT
033700         GO TO A350-READ-NEXT
033800     ELSE
033900         GO TO A350-READ-NEXT.
034000*
034100 A350-READ-NEXT-MBMF.
034200*
034300     MOVE 'R3MF'                 TO SS02WS-ABEND-LOCATION.
034400     SET  MBMFRB-READ-SEQ        TO TRUE.
034500     PERFORM MB00PD-MBMF-ACCESS  THRU MB00PD-MBMF-ACCESS-EXIT.
034600*
034700     IF  SS02WS-FS-NO-RECORD-FOUND
034800         GO TO A500-CONTROL-CARD-ERROR.
034900*
035000     IF  SS02WS-FS-END-OF-FILE
035100         IF  MB21WS-PRINT-PAGE IS EQUAL TO SPACES
035200             GO TO A200-PROGRAM-CONTROL
035300         ELSE
035400             PERFORM MB21PD-PRINT-A-PAGE
035500                                 THRU MB21PD-PAP-EXIT
035600             GO TO A200-PROGRAM-CONTROL.
035700*
035800     IF  MBMFIO-FILE-IS-MMQ3
035900         CONTINUE
036000     ELSE
036100         GO TO A350-READ-NEXT-MBMF.
036200*
036300     MOVE MBMFIO-VAR-DATA        TO MMQ3-RECORD.
036400*
036500     IF  MMQ3-KEY IS LESS THAN WS-MMQ3-BEG-KEY
036600         GO TO A350-READ-NEXT-MBMF.
036700*
036800     IF  MMQ3-KEY IS GREATER THAN WS-MMQ3-END-KEY
036900         PERFORM MB21PD-PRINT-A-PAGE
037000                                 THRU MB21PD-PAP-EXIT
037100         GO TO A200-PROGRAM-CONTROL.
037200*
037300     IF  MMQ3-ORG IS EQUAL TO 999
037400         GO TO A350-READ-NEXT-MBMF.
037500*
037600     IF  MMQ3-ADD-COMPLETED
037700         NEXT SENTENCE
037800     ELSE
037900         GO TO A350-READ-NEXT-MBMF.
038000*
038100     PERFORM B100-PRT-BEGIN      THRU B999-PRT-EXIT.
038200     GO TO A350-READ-NEXT-MBMF.
038300*
038400 A400-CHECK-READ-SWITCH.
038500*
038600     IF  WS-CARD-READ-SW IS EQUAL TO 'N'
038700         MOVE '*** NO CONTROL CARDS ***'
038800                                 TO MB21WS-PP-COL44 (5 1)
038900         PERFORM MB21PD-PRINT-A-PAGE
039000                                 THRU MB21PD-PAP-EXIT.
039100*
039200     GO TO A600-CLOSE-FILES.
039300*
039400 A500-CONTROL-CARD-ERROR.
039500*
039600     MOVE MTCC-RECORD            TO MB21WS-PP-LINE (4).
039700     MOVE 'CONTROL CARD ERROR'   TO MB21WS-PP-COL44 (4 3).
039800     PERFORM MB21PD-PRINT-A-PAGE THRU MB21PD-PAP-EXIT.
039900     MOVE SPACE                  TO MB21WS-PP-LINE (4).
040000     MOVE SPACE                  TO MB21WS-PP-COL44 (4 3).
040100     GO TO A200-PROGRAM-CONTROL.
040200*
040300 A600-CLOSE-FILES.
040400*
040500     EVALUATE TRUE
040600         WHEN  WS-BACKUP
040700             MOVE 'C1MF'         TO SS02WS-ABEND-LOCATION
040800             SET MBMFRB-CLOSE    TO TRUE
040900             PERFORM MB00PD-MBMF-ACCESS
041000                                 THRU MB00PD-MBMF-ACCESS-EXIT
041100         WHEN  WS-MASTER
041200             MOVE 'C1Q3'         TO SS02WS-ABEND-LOCATION
041300             SET MMQ3RB-CLOSE    TO TRUE
041400             PERFORM MB00PD-MMQ3-ACCESS
041500                                 THRU MB00PD-MMQ3-ACCESS-EXIT
041600         WHEN  OTHER
041700             CONTINUE
041800     END-EVALUATE.
041900*
042000     MOVE 'C1CC'                 TO SS02WS-ABEND-LOCATION.
042100     SET MTCCRB-CLOSE            TO TRUE.
042200     PERFORM MB00PD-MTCC-ACCESS  THRU MB00PD-MTCC-ACCESS-EXIT.
042300*
042400     MOVE 'C1SC'                 TO SS02WS-ABEND-LOCATION.
042500     SET MMSCRB-CLOSE            TO TRUE.
042600     PERFORM MB00PD-MMSC-ACCESS  THRU MB00PD-MMSC-ACCESS-EXIT.
042700*
042800     PERFORM MB20PD-CLOSE-PRINT-FILES
042900                                 THRU MB20PD-CPF-EXIT.
043000*
043100     STOP RUN.
043200*
043300 B100-PRT-BEGIN.
043400*
043500*
043600 B999-PRT-EXIT.
043700     EXIT.
043800*
043900 B200-PRINT-HEADER.
044000*
044100     MOVE 'ORG HEADER RECORD(MMQ3)'
044200                                 TO MB21WS-NAME.
044300     PERFORM MB21PD-INSERT-A-COLUMN
044400                                 THRU MB21PD-IAC-EXIT.
044500*
044600     MOVE SPACES                 TO MB21WS-PRINT-WORK-AREA.
044700     MOVE 'ORG'                  TO MB21WS-NAME.
044800     MOVE MMQ3IO-ORG             TO MB21WS-3V0.
044900     PERFORM MB21PD-INSERT-A-COLUMN
045000                                 THRU MB21PD-IAC-EXIT.
045100*
045200     MOVE 'DATE-STAMP'           TO MB21WS-NAME.
045300     MOVE MMQ3IO-DATE-STAMP      TO SS01WS-JULIAN.
045400     PERFORM SS08PD-JUL-TO-GREG  THRU SS08PD-JTG-EXIT.
045500     MOVE MMQ3IO-DATE-STAMP      TO MB21WS-JULIAN.
045600     MOVE SS01WS-DATE-L6         TO MB21WS-GREG.
045700     INSPECT MB21WS-JULIAN       REPLACING ALL ',' BY '-'.
045800     PERFORM MB21PD-INSERT-A-COLUMN
045900                                 THRU MB21PD-IAC-EXIT.
046000*
046100     MOVE 'TIME-STAMP'           TO MB21WS-NAME.
046200     MOVE MMQ3IO-TIME-STAMP      TO MB21WS-TIME.
046300     INSPECT MB21WS-TIME         REPLACING ALL SPACE BY '.'.
046400     PERFORM MB21PD-INSERT-A-COLUMN
046500                                 THRU MB21PD-IAC-EXIT.
046600*
046700     PERFORM MB21PD-PRINT-A-PAGE
046800                                 THRU MB21PD-PAP-EXIT.
046900*
047000 B200-PH-EXIT.
047100     EXIT.
047200/
047300* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
047400*                          COMMON ROUTINES                      *
047500* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
047600*
047700     COPY SS02PD.
047800/
047900     COPY SS08PD.
048000/
048100     COPY SS16PD.
048200/
048300     COPY SS26PD.
048400/
048500     COPY SS27PD.
048600/
048700     COPY MB20PD.
048800/
048900     COPY MB21PD.
049000/
049100     COPY MB99PD.
049200/
049300     COPY MB00PD REPLACING ==:MB00:== BY ==MTCC==.
049400/
049500     COPY MB00PD REPLACING ==:MB00:== BY ==MMQ3==.
049600/
049700     COPY MB00PD REPLACING ==:MB00:== BY ==MMSC==.
049800/
049900     COPY MB00PD REPLACING ==:MB00:== BY ==MBMF==.
