000100 IDENTIFICATION DIVISION.
000200 PROGRAM-ID. MBU965.
000201*       RELEASE DATE=08/24/01.        REVISION LEVEL=08.06      * ++++++++
000202***************************************************************** ++++++++
000203*WARNING.  THIS COMPUTER PROGRAM IS PROTECTED BY COPYRIGHT LAW  * ++++++++
000204*AND INTERNATIONAL TREATIES.  UNAUTHORIZED REPRODUCTION OR      * ++++++++
000205*DISTRIBUTION OF THIS PROGRAM, OR ANY PORTION OF IT, MAY RESULT * ++++++++
000206*IN SEVERE CIVIL AND CRIMINAL PENATLIES, AND WILL BE PROSECUTED * ++++++++
000207*TO THE MAXIMUM EXTENT POSSIBLE UNDER THE LAW.                  * ++++++++
000208*COPYRIGHT 1999 PAYSYS INTERNATIONAL, INC.  ALL RIGHTS RESERVED.* ++++++++
000209***************************************************************** ++++++++
000300*****************************************************************
000400*                                                               *
000500* MBU965 - LATIN AMERICA/CARIBBEAN QUARTERLY FILE DISPLAY (MMQ5)*
000600*                                                               *
000700*****************************************************************
000800 ENVIRONMENT DIVISION.
000900 CONFIGURATION SECTION.
001000 SOURCE-COMPUTER.   IBM-4341.
001100 OBJECT-COMPUTER.   IBM-4341.
001200/
001300 INPUT-OUTPUT SECTION.
001400 FILE-CONTROL.
001500/
001600 DATA DIVISION.
001700 FILE SECTION.
001800 WORKING-STORAGE SECTION.
001900*
002000 01  FILLER                  PIC  X(12)      VALUE '** WS-BEG **'.
002100*
002200     COPY MB00RB REPLACING ==:MB00:== BY ==MTCC==.
002300/
002400     COPY MB00RB REPLACING ==:MB00:== BY ==MMSC==.
002500/
002600     COPY MB00RB REPLACING ==:MB00:== BY ==MMQ5==.
002700/
002800     COPY MBU999WS.
002900/
003000     COPY MB00RB REPLACING ==:MB00:== BY ==MBMF==.
003100/
003200     COPY MTCCRL REPLACING ==:MTCC:== BY ==MTCC==.
003300/
003400     COPY MMSCRL.
003500/
003600     COPY MMQ5RL.
003700/
003800     COPY MBMFRL.
003900/
004000     COPY MTCCIO REPLACING ==:MTCC:== BY ==MTCC==.
004100/
004200     COPY MMSCIO.
004300/
004400     COPY MMQ5IO.
004500/
004600     COPY MBMFIO.
004700/
004800     COPY MB00WS.
004900/
005000     COPY MB20WS.
005100/
005200     COPY MB99WS.
005300/
005400     COPY SS00WS.
005500/
005600     COPY SS01WS.
005700/
005800     COPY SS02WS.
005900*
006000 01  WS-WORK-AREAS.
006100     03  WS-PROG-ID          PIC  X(06)      VALUE 'MBU965'.
006200     03  WS-CARD-READ-SW     PIC  X(01)      VALUE 'N'.
006300     03  X-WS-INDEX          PIC S9(04)      COMP.
006400     03  X-WS-TEMP-INDEX     PIC  9(01).
006500     03  X-WS-MON-INDEX      PIC  9(01).
006600     03  WS-WORK-DATE        PIC  9(08).
006700     03  WS-WORK-DATE-R      REDEFINES WS-WORK-DATE.
006800         05  WS-WK-DTE-MDY   PIC  9(06).
006900         05  WS-WK-DTE-MDY-R REDEFINES WS-WK-DTE-MDY.
007000             07  WS-WORK-DATE-MM
007100                             PIC  9(02).
007200             07  WS-WORK-DATE-DD
007300                             PIC  9(02).
007400             07  WS-WORK-DATE-XX
007500                             PIC  9(02).
007600         05  WS-WORK-DATE-YY PIC  9(02).
007700*
007800     03  WS-MMQ5-BEG-KEY     PIC  9(03)      VALUE ZEROES.
007900     03  WS-MMQ5-END-KEY     PIC  9(03)      VALUE ZEROES.
008000*
008100     03  WS-BACKUP-OR-MASTER PIC  X(06)      VALUE SPACES.
008200         88  WS-BACKUP                       VALUE 'BACKUP'.
008300         88  WS-MASTER                       VALUE 'MASTER'.
008400*
008500     03  WS-END-OF-PERFORM-SW
008600                             PIC  X(01)      VALUE SPACES.
008700         88  WS-END-OF-PERFORM               VALUE 'Y'.
008800         88  WS-NOT-END-OF-PERFORM           VALUE 'N'.
008900/
009000     COPY MB21WS.
009100*
009200 01  FILLER                  PIC  X(12)      VALUE '** WS-END **'.
009300/
009400 PROCEDURE DIVISION.
009500*
009600 A000-DRIVER.
009700*
009800     MOVE 'MBU965'               TO SS02WS-ABEND-PROG-ID
009900                                    MBU999WS-PROGRAM-ID.
010000*
010100     CALL MB00WS-MBU999CC        USING MBU999WS-AREA.
010200*
010300     MOVE 'MB000000'             TO MB20WS-SH-RPT-ID.
010400     MOVE 'T965'                 TO MB20WS-SH-INTERNAL-RPT-ID.
010500     MOVE '  LATIN AMERICA/CARIBBEAN FILE '
010600                                 TO MB20WS-SH-RPT-NAME.
010700     MOVE SPACES                 TO MB20WS-SH-LIT-1
010800                                    MB20WS-SH-LIT-5
010900                                    MB20WS-SH-L4
011000                                    MB20WS-SH-L5
011100                                    MB20WS-SH-L6.
011200     PERFORM MB21PD-PAP-RESET-INDEXES
011300                                 THRU MB21PD-PAP-EXIT.
011400*
011500 A100-OPEN-FILES.
011600*
011700     MOVE SPACES                 TO MB21WS-PRINT-PAGE.
011800     MOVE 'O1CC'                 TO SS02WS-ABEND-LOCATION.
011900     MOVE SS02WS-END-OF-FILE     TO MTCCRB-PERM-STATUS-1.
012000     SET MTCCRB-OPEN-INPUT       TO TRUE.
012100     PERFORM MB00PD-MTCC-ACCESS  THRU MB00PD-MTCC-ACCESS-EXIT.
012200*
012300     MOVE 'O1SC'                 TO SS02WS-ABEND-LOCATION.
012400     SET MMSCRB-OPEN-INPUT       TO TRUE.
012500     PERFORM MB00PD-MMSC-ACCESS  THRU MB00PD-MMSC-ACCESS-EXIT.
012600*
012700     MOVE 'R1SC'                 TO SS02WS-ABEND-LOCATION.
012800     SET MMSCRB-READ-SEQ         TO TRUE.
012900     PERFORM MB00PD-MMSC-ACCESS  THRU MB00PD-MMSC-ACCESS-EXIT.
013000*
013100     MOVE 'MMSC'                 TO MB99WS-FILE-ID.
013200*
013300     IF  MMSCIO-HEADER
013400         NEXT SENTENCE
013500     ELSE
013600         PERFORM MB99PD-MISSING-HEADER-ABEND
013700            THRU MB99PD-MHA-EXIT.
013800*
013900     MOVE MMSCIO-RECORD          TO MMSC-RECORD.
014000     MOVE MMSC-TODAYS-JULIAN     TO SS01WS-JULIAN.
014100     PERFORM SS08PD-JUL-TO-GREG  THRU SS08PD-JTG-EXIT.
014200     MOVE SS01WS-DATE-L6         TO MB20WS-SH-FILE-DATE.
014300     MOVE MMSC-TIME-STAMP        TO MB20WS-SH-PROC-TIME .
014400     INSPECT MB20WS-SH-PROC-TIME REPLACING ALL SPACE BY '.'.
014500*
014600     MOVE MMSC-FORM              TO MB20WS-FORM-CODE.
014700     MOVE MMSC-FICHE-FLAG        TO MB20WS-FICHE-CODE.
014800     MOVE MMSC-LINES-PER-PAGE    TO MB20WS-LINES-PER-PAGE.
014900     MOVE 99                     TO MB20WS-LINE-LIMIT.
015000     COMPUTE MB21WS-LIN-LIMIT    =  MMSC-LINES-PER-PAGE - 4.
015100     MOVE MMSC-SCREEN-HEADER     TO MB20WS-SH-SYSTEM.
015200     MOVE MMSC-DATE-FORMAT       TO SS01WS-DATE-FORMAT.
015300*
015400     MOVE 'R1CC'                 TO SS02WS-ABEND-LOCATION.
015500     SET MTCCRB-READ-SEQ         TO TRUE.
015600     PERFORM MB00PD-MTCC-ACCESS  THRU MB00PD-MTCC-ACCESS-EXIT.
015700*
015800     IF  SS02WS-FS-END-OF-FILE
015900         GO TO A400-CHECK-READ-SWITCH.
016000*
016100     IF  MTCCIO-PROGRAM-ID IS NOT EQUAL TO WS-PROG-ID
016200         GO TO A200-PROGRAM-CONTROL.
016300*
016400     MOVE MTCCIO-CARD-DATA       TO MTCC-RECORD.
016500*
016600     IF  MTCC-MBU9XX-BACKUP
016700         MOVE 'BACKUP'           TO WS-BACKUP-OR-MASTER
016800         MOVE 'O1MF'             TO SS02WS-ABEND-LOCATION
016900         SET MBMFRB-OPEN-INPUT   TO TRUE
017000         PERFORM MB00PD-MBMF-ACCESS THRU MB00PD-MBMF-ACCESS-EXIT
017100         MOVE 'R1MF'             TO SS02WS-ABEND-LOCATION
017200         SET MBMFRB-READ-SEQ     TO TRUE
017300         MOVE SS02WS-NO-RECORD-FOUND
017400                                 TO MBMFRB-PERM-STATUS-3
017500         MOVE SS02WS-END-OF-FILE
017600                                 TO MBMFRB-PERM-STATUS-4
017700         PERFORM MB00PD-MBMF-ACCESS THRU MB00PD-MBMF-ACCESS-EXIT
017800     ELSE
017900         MOVE 'O1Q5'             TO SS02WS-ABEND-LOCATION
018000         SET MMQ5RB-OPEN-INPUT   TO TRUE
018100         PERFORM MB00PD-MMQ5-ACCESS THRU MB00PD-MMQ5-ACCESS-EXIT
018200         MOVE 'R1Q5'             TO SS02WS-ABEND-LOCATION
018300         SET MMQ5RB-READ-SEQ     TO TRUE
018400         MOVE SS02WS-NO-RECORD-FOUND
018500                                 TO MMQ5RB-PERM-STATUS-3
018600         MOVE SS02WS-END-OF-FILE
018700                                 TO MMQ5RB-PERM-STATUS-4
018800         PERFORM MB00PD-MMQ5-ACCESS THRU MB00PD-MMQ5-ACCESS-EXIT
018900         GO TO A130-PRINT-HR-RECORD.
019000*
019100     MOVE 'MBMF'                 TO MB99WS-FILE-ID.
019200*
019300     IF  MBMFIO-FILE-IS-HEADER
019400         NEXT SENTENCE
019500     ELSE
019600         PERFORM MB99PD-MISSING-HEADER-ABEND
019700            THRU MB99PD-MHA-EXIT.
019800*
019900     MOVE MBMFIO-RECORD          TO MBMF-RECORD.
020000*
020100     SET X-MBMF-FILE             TO 1.
020200*
020300 A110-SEARCH-HEADER-TABLE-LOOP.
020400*
020500     IF  X-MBMF-FILE IS GREATER THAN 75
020600         MOVE 'MMQ5'             TO MB99WS-FILE-ID
020700         PERFORM MB99PD-NOT-ON-BACKUP
020800            THRU MB99PD-NOB-EXIT.
020900*
021000     IF  MBMF-MBU020-ENTRY (X-MBMF-FILE) IS EQUAL TO 'Q5'
021100         CONTINUE
021200     ELSE
021300         SET X-MBMF-FILE         UP BY 1
021400         GO TO A110-SEARCH-HEADER-TABLE-LOOP
021500     END-IF.
021600*
021700 A120-READ-MBMF-LOOP.
021800*
021900     MOVE 'R2MF'                 TO SS02WS-ABEND-LOCATION.
022000     SET MBMFRB-READ-SEQ         TO TRUE.
022100     MOVE SS02WS-NO-RECORD-FOUND
022200                                 TO MBMFRB-PERM-STATUS-3.
022300     MOVE SS02WS-END-OF-FILE     TO MBMFRB-PERM-STATUS-4.
022400     PERFORM MB00PD-MBMF-ACCESS  THRU MB00PD-MBMF-ACCESS-EXIT.
022500*
022600     IF  SS02WS-FS-END-OF-FILE
022700         GO TO A200-PROGRAM-CONTROL
022800     END-IF.
022900*
023000     IF  MBMFIO-FILE IS NOT EQUAL TO 'Q5'
023100         GO TO A120-READ-MBMF-LOOP
023200     END-IF.
023300*
023400 A130-PRINT-HR-RECORD.
023500*
023600     IF  WS-BACKUP
023700         MOVE MBMFIO-VAR-DATA    TO MMQ5IO-RECORD
023800     END-IF.
023900*
024000     MOVE 'MMQ5'                 TO MB99WS-FILE-ID.
024100*
024200     IF  MMQ5IO-HEADER
024300         NEXT SENTENCE
024400     ELSE
024500         PERFORM MB99PD-MISSING-HEADER-ABEND
024600            THRU MB99PD-MHA-EXIT.
024700*
024800     MOVE MMQ5IO-RECORD          TO MMQ5-RECORD.
024900*
025000     IF  MMQ5IO-HEADER
025100         PERFORM B200-PRINT-HEADER
025200                                 THRU B200-PH-EXIT
025300     END-IF.
025400*
025500 A200-PROGRAM-CONTROL.
025600*
025700     IF  MTCC-MBU9XX-BACKUP OR MTCC-MBU9XX-MASTER
025800         MOVE MTCC-MBU9XX-OPTION TO WS-BACKUP-OR-MASTER
025900     ELSE
026000         IF  WS-BACKUP-OR-MASTER IS EQUAL TO SPACES
026100             MOVE 'MASTER'       TO WS-BACKUP-OR-MASTER
026200             GO TO A210-PC-BY-FIRST-READ.
026300*
026400     MOVE 'R2CC'                 TO SS02WS-ABEND-LOCATION.
026500     SET MTCCRB-READ-SEQ         TO TRUE.
026600     PERFORM MB00PD-MTCC-ACCESS  THRU MB00PD-MTCC-ACCESS-EXIT.
026700*
026800     IF  SS02WS-FS-END-OF-FILE
026900         GO TO A400-CHECK-READ-SWITCH
027000     END-IF.
027100*
027200 A210-PC-BY-FIRST-READ.
027300*
027400     IF  MTCCIO-PROGRAM-ID IS NOT EQUAL TO WS-PROG-ID
027500         GO TO A200-PROGRAM-CONTROL.
027600*
027700     MOVE MTCCIO-CARD-DATA       TO MTCC-RECORD.
027800*
027900 A300-RANGE-CARD.
028000*
028100     MOVE 'Y'                    TO WS-CARD-READ-SW.
028200     INSPECT MTCC-MBU965-BEG-X   REPLACING ALL SPACE BY ZERO.
028300*
028400     IF  MTCC-MBU965-END-X IS EQUAL TO SPACES
028500         MOVE MTCC-MBU965-BEG-X  TO MTCC-MBU965-END-X
028600     END-IF.
028700*
028800     INSPECT MTCC-MBU965-END-X   REPLACING ALL SPACE BY ZERO.
028900*
029000     MOVE MTCC-MBU965-BEG-ORG    TO WS-MMQ5-BEG-KEY
029100*
029200     MOVE MTCC-MBU965-END-ORG    TO WS-MMQ5-END-KEY.
029300*
029400     IF  WS-BACKUP
029500         GO TO A350-READ-NEXT-MBMF.
029600*
029700     MOVE MTCC-MBU965-BEG-X      TO MMQ5IO-KEY.
029800*
029900     MOVE 'S1Q5'                 TO SS02WS-ABEND-LOCATION.
030000     SET  MMQ5RB-START-GTE       TO TRUE.
030100     PERFORM MB00PD-MMQ5-ACCESS  THRU MB00PD-MMQ5-ACCESS-EXIT.
030200*
030300     IF  SS02WS-FS-NO-RECORD-FOUND
030400         GO TO A500-CONTROL-CARD-ERROR.
030500*
030600 A350-READ-NEXT.
030700*
030800     MOVE 'R2Q5'                 TO SS02WS-ABEND-LOCATION.
030900     SET  MMQ5RB-READ-SEQ        TO TRUE.
031000     PERFORM MB00PD-MMQ5-ACCESS  THRU MB00PD-MMQ5-ACCESS-EXIT.
031100*
031200     IF  SS02WS-FS-END-OF-FILE
031300         IF  MB21WS-PRINT-PAGE IS EQUAL TO SPACES
031400             GO TO A200-PROGRAM-CONTROL
031500         ELSE
031600             PERFORM MB21PD-PRINT-A-PAGE
031700                                 THRU MB21PD-PAP-EXIT
031800             GO TO A200-PROGRAM-CONTROL.
031900*
032000     IF  MMQ5IO-KEY IS GREATER THAN WS-MMQ5-END-KEY
032100         IF  MB21WS-PRINT-PAGE IS EQUAL TO SPACES
032200             GO TO A200-PROGRAM-CONTROL
032300         ELSE
032400             PERFORM MB21PD-PRINT-A-PAGE
032500                                 THRU MB21PD-PAP-EXIT
032600             GO TO A200-PROGRAM-CONTROL.
032700*
032800     IF  MMQ5IO-HEADER
032900     OR  MMQ5IO-TRAILER
033000         GO TO A350-READ-NEXT.
033100*
033200     MOVE MMQ5IO-RECORD          TO MMQ5-RECORD.
033300*
033400     IF  MMQ5-ADD-COMPLETED
033500         PERFORM B100-PRT-BEGIN  THRU B999-PRT-EXIT
033600         GO TO A350-READ-NEXT
033700     ELSE
033800         GO TO A350-READ-NEXT.
033900*
034000 A350-READ-NEXT-MBMF.
034100*
034200     MOVE 'R3MF'                 TO SS02WS-ABEND-LOCATION.
034300     SET  MBMFRB-READ-SEQ        TO TRUE.
034400     PERFORM MB00PD-MBMF-ACCESS  THRU MB00PD-MBMF-ACCESS-EXIT.
034500*
034600     IF  SS02WS-FS-NO-RECORD-FOUND
034700         GO TO A500-CONTROL-CARD-ERROR.
034800*
034900     IF  SS02WS-FS-END-OF-FILE
035000         IF  MB21WS-PRINT-PAGE IS EQUAL TO SPACES
035100             GO TO A200-PROGRAM-CONTROL
035200         ELSE
035300             PERFORM MB21PD-PRINT-A-PAGE
035400                                 THRU MB21PD-PAP-EXIT
035500             GO TO A200-PROGRAM-CONTROL.
035600*
035700     IF  MBMFIO-FILE-IS-MMQ5
035800         CONTINUE
035900     ELSE
036000         GO TO A350-READ-NEXT-MBMF.
036100*
036200     MOVE MBMFIO-VAR-DATA        TO MMQ5-RECORD.
036300*
036400     IF  MMQ5-KEY IS LESS THAN WS-MMQ5-BEG-KEY
036500         GO TO A350-READ-NEXT-MBMF.
036600*
036700     IF  MMQ5-KEY IS GREATER THAN WS-MMQ5-END-KEY
036800         PERFORM MB21PD-PRINT-A-PAGE
036900                                 THRU MB21PD-PAP-EXIT
037000         GO TO A200-PROGRAM-CONTROL.
037100*
037200     IF  MMQ5-ORG IS EQUAL TO 999
037300         GO TO A350-READ-NEXT-MBMF.
037400*
037500     IF  MMQ5-ADD-COMPLETED
037600         NEXT SENTENCE
037700     ELSE
037800         GO TO A350-READ-NEXT-MBMF.
037900*
038000     PERFORM B100-PRT-BEGIN      THRU B999-PRT-EXIT.
038100     GO TO A350-READ-NEXT-MBMF.
038200*
038300 A400-CHECK-READ-SWITCH.
038400*
038500     IF  WS-CARD-READ-SW IS EQUAL TO 'N'
038600         MOVE '*** NO CONTROL CARDS ***'
038700                                 TO MB21WS-PP-COL44 (5 1)
038800         PERFORM MB21PD-PRINT-A-PAGE
038900                                 THRU MB21PD-PAP-EXIT.
039000*
039100     GO TO A600-CLOSE-FILES.
039200*
039300 A500-CONTROL-CARD-ERROR.
039400*
039500     MOVE MTCC-RECORD            TO MB21WS-PP-LINE (4).
039600     MOVE 'CONTROL CARD ERROR'   TO MB21WS-PP-COL44 (4 3).
039700     PERFORM MB21PD-PRINT-A-PAGE THRU MB21PD-PAP-EXIT.
039800     MOVE SPACE                  TO MB21WS-PP-LINE (4).
039900     MOVE SPACE                  TO MB21WS-PP-COL44 (4 3).
040000     GO TO A200-PROGRAM-CONTROL.
040100*
040200 A600-CLOSE-FILES.
040300*
040400     EVALUATE TRUE
040500         WHEN  WS-BACKUP
040600             MOVE 'C1MF'         TO SS02WS-ABEND-LOCATION
040700             SET MBMFRB-CLOSE    TO TRUE
040800             PERFORM MB00PD-MBMF-ACCESS
040900                                 THRU MB00PD-MBMF-ACCESS-EXIT
041000         WHEN  WS-MASTER
041100             MOVE 'C1Q5'         TO SS02WS-ABEND-LOCATION
041200             SET MMQ5RB-CLOSE    TO TRUE
041300             PERFORM MB00PD-MMQ5-ACCESS
041400                                 THRU MB00PD-MMQ5-ACCESS-EXIT
041500         WHEN  OTHER
041600             CONTINUE
041700     END-EVALUATE.
041800*
041900     MOVE 'C1CC'                 TO SS02WS-ABEND-LOCATION.
042000     SET MTCCRB-CLOSE            TO TRUE.
042100     PERFORM MB00PD-MTCC-ACCESS  THRU MB00PD-MTCC-ACCESS-EXIT.
042200*
042300     MOVE 'C1SC'                 TO SS02WS-ABEND-LOCATION.
042400     SET MMSCRB-CLOSE            TO TRUE.
042500     PERFORM MB00PD-MMSC-ACCESS  THRU MB00PD-MMSC-ACCESS-EXIT.
042600*
042700     PERFORM MB20PD-CLOSE-PRINT-FILES
042800                                 THRU MB20PD-CPF-EXIT.
042900*
043000     STOP RUN.
043100*
043200 B100-PRT-BEGIN.
043300*
043400     MOVE 'LATIN AMERICA/CARIBBEAN RPT RECORD(MMQ5)'
043500                                 TO MB21WS-NAME.
043600     PERFORM MB21PD-INSERT-A-COLUMN
043700                                 THRU MB21PD-IAC-EXIT.
043800*
043900     MOVE SPACES                 TO MB21WS-PRINT-WORK-AREA.
044000     MOVE 'ORG'                  TO MB21WS-NAME.
044100     MOVE MMQ5-ORG               TO MB21WS-3V0.
044200     PERFORM MB21PD-INSERT-A-COLUMN
044300                                 THRU MB21PD-IAC-EXIT.
044400*
044500     MOVE 'REC-STATUS'           TO MB21WS-NAME.
044600     MOVE MMQ5-REC-STATUS        TO MB21WS-1V0.
044700     PERFORM MB21PD-INSERT-A-COLUMN
044800                                 THRU MB21PD-IAC-EXIT 2 TIMES.
044900*
045000     MOVE 'ADD-STATUS'           TO MB21WS-NAME.
045100     MOVE MMQ5-ONLINE-STATUS     TO MB21WS-2V0.
045200     PERFORM MB21PD-INSERT-A-COLUMN
045300                                 THRU MB21PD-IAC-EXIT 2 TIMES.
045400*
045500     MOVE 'LAST-MAINT-DATE'      TO MB21WS-NAME.
045600     MOVE MMQ5-LAST-MAINT-DATE   TO SS01WS-JULIAN.
045700     PERFORM SS08PD-JUL-TO-GREG  THRU SS08PD-JTG-EXIT.
045800     MOVE MMQ5-LAST-MAINT-DATE   TO MB21WS-JULIAN.
045900     MOVE SS01WS-DATE-L6         TO MB21WS-GREG.
046000     INSPECT MB21WS-JULIAN       REPLACING ALL ',' BY '-'.
046100     PERFORM MB21PD-INSERT-A-COLUMN
046200                                 THRU MB21PD-IAC-EXIT.
046300*
046400     MOVE 'LAST-MAINT-OPER'      TO MB21WS-NAME.
046500     MOVE MMQ5-LAST-MAINT-OPER   TO MB21WS-3X.
046600     PERFORM MB21PD-INSERT-A-COLUMN
046700                                 THRU MB21PD-IAC-EXIT 2 TIMES.
046800*
046900     SET X-MMQ5-VI               TO 1.
047000*
047100*
047200 B100-LOOP.
047300*
047400*
047500     MOVE '*** LATIN AMERICA/CARIBBEAN TOTALS  ***'
047600                                 TO MB21WS-PRINT-WORK-AREA.
047700     PERFORM MB21PD-INSERT-A-COLUMN
047800                                 THRU MB21PD-IAC-EXIT.
047900*
048000     MOVE 'QTR-BEG-DATE'         TO MB21WS-NAME.
048100     SET WS-NOT-END-OF-PERFORM   TO TRUE
048200     PERFORM
048300         VARYING X-WS-INDEX
048400         FROM 30 BY -1
048500         UNTIL X-WS-INDEX IS EQUAL TO 1
048600         OR WS-END-OF-PERFORM
048700         IF  MB21WS-NAME (X-WS-INDEX:1)
048800                                 IS NOT EQUAL TO SPACES
048900             ADD 1               TO X-WS-INDEX
049000             MOVE '('            TO MB21WS-NAME (X-WS-INDEX:1)
049100             ADD 1               TO X-WS-INDEX
049200             SET X-WS-TEMP-INDEX
049300                                 TO X-MMQ5-VI
049400             MOVE X-WS-TEMP-INDEX
049500                                 TO MB21WS-NAME (X-WS-INDEX:2)
049600             ADD 2               TO X-WS-INDEX
049700             SET X-WS-MON-INDEX TO X-MMQ5-VI-MON
049800             MOVE X-WS-MON-INDEX
049900                                 TO MB21WS-NAME (X-WS-INDEX:2)
050000             ADD 1               TO X-WS-INDEX
050100             MOVE ')'            TO MB21WS-NAME (X-WS-INDEX:1)
050200             SET WS-END-OF-PERFORM
050300                                 TO TRUE
050400         END-IF
050500     END-PERFORM.
050600     MOVE MMQ5-QTR-BEG-DATE (X-MMQ5-VI)
050700                                 TO SS01WS-JULIAN.
050800     PERFORM SS08PD-JUL-TO-GREG  THRU SS08PD-JTG-EXIT.
050900     MOVE MMQ5-QTR-BEG-DATE (X-MMQ5-VI)
051000                                 TO MB21WS-JULIAN.
051100     MOVE SS01WS-DATE-L6         TO MB21WS-GREG.
051200     INSPECT MB21WS-JULIAN       REPLACING ALL ',' BY '-'.
051300     PERFORM MB21PD-INSERT-A-COLUMN
051400                                 THRU MB21PD-IAC-EXIT.
051500*
051600     MOVE 'QTR-END-DATE'         TO MB21WS-NAME.
051700     SET WS-NOT-END-OF-PERFORM   TO TRUE
051800     PERFORM
051900         VARYING X-WS-INDEX
052000         FROM 30 BY -1
052100         UNTIL X-WS-INDEX IS EQUAL TO 1
052200         OR WS-END-OF-PERFORM
052300         IF  MB21WS-NAME (X-WS-INDEX:1)
052400                                 IS NOT EQUAL TO SPACES
052500             ADD 1               TO X-WS-INDEX
052600             MOVE '('            TO MB21WS-NAME (X-WS-INDEX:1)
052700             ADD 1               TO X-WS-INDEX
052800             SET X-WS-TEMP-INDEX
052900                                 TO X-MMQ5-VI
053000             MOVE X-WS-TEMP-INDEX
053100                                 TO MB21WS-NAME (X-WS-INDEX:2)
053200             ADD 2               TO X-WS-INDEX
053300             SET X-WS-MON-INDEX TO X-MMQ5-VI-MON
053400             MOVE X-WS-MON-INDEX
053500                                 TO MB21WS-NAME (X-WS-INDEX:2)
053600             ADD 1               TO X-WS-INDEX
053700             MOVE ')'            TO MB21WS-NAME (X-WS-INDEX:1)
053800             SET WS-END-OF-PERFORM
053900                                 TO TRUE
054000         END-IF
054100     END-PERFORM.
054200     MOVE MMQ5-QTR-END-DATE (X-MMQ5-VI)
054300                                 TO SS01WS-JULIAN.
054400     PERFORM SS08PD-JUL-TO-GREG  THRU SS08PD-JTG-EXIT.
054500     MOVE MMQ5-QTR-END-DATE (X-MMQ5-VI)
054600                                 TO MB21WS-JULIAN.
054700     MOVE SS01WS-DATE-L6         TO MB21WS-GREG.
054800     INSPECT MB21WS-JULIAN       REPLACING ALL ',' BY '-'.
054900     PERFORM MB21PD-INSERT-A-COLUMN
055000                                 THRU MB21PD-IAC-EXIT.
055100*
055200     MOVE 'VI-NBR-MERCHANTS'     TO MB21WS-NAME.
055300     SET WS-NOT-END-OF-PERFORM   TO TRUE
055400     PERFORM
055500         VARYING X-WS-INDEX
055600         FROM 30 BY -1
055700         UNTIL X-WS-INDEX IS EQUAL TO 1
055800         OR WS-END-OF-PERFORM
055900         IF  MB21WS-NAME (X-WS-INDEX:1)
056000                                 IS NOT EQUAL TO SPACES
056100             ADD 1               TO X-WS-INDEX
056200             MOVE '('            TO MB21WS-NAME (X-WS-INDEX:1)
056300             ADD 1               TO X-WS-INDEX
056400             SET X-WS-TEMP-INDEX
056500                                 TO X-MMQ5-VI
056600             MOVE X-WS-TEMP-INDEX
056700                                 TO MB21WS-NAME (X-WS-INDEX:2)
056800             ADD 1               TO X-WS-INDEX
056900             MOVE ')'            TO MB21WS-NAME (X-WS-INDEX:1)
057000             SET WS-END-OF-PERFORM
057100                                 TO TRUE
057200         END-IF
057300     END-PERFORM.
057400     MOVE MMQ5-VI-NBR-MERCHANTS (X-MMQ5-VI)
057500                                 TO MB21WS-9V0Z.
057600     PERFORM MB21PD-INSERT-A-COLUMN
057700                                 THRU MB21PD-IAC-EXIT.
057800*
057900     MOVE 'VI-NBR-STORES'        TO MB21WS-NAME.
058000     SET WS-NOT-END-OF-PERFORM   TO TRUE
058100     PERFORM
058200         VARYING X-WS-INDEX
058300         FROM 30 BY -1
058400         UNTIL X-WS-INDEX IS EQUAL TO 1
058500         OR WS-END-OF-PERFORM
058600         IF  MB21WS-NAME (X-WS-INDEX:1)
058700                                 IS NOT EQUAL TO SPACES
058800             ADD 1               TO X-WS-INDEX
058900             MOVE '('            TO MB21WS-NAME (X-WS-INDEX:1)
059000             ADD 1               TO X-WS-INDEX
059100             SET X-WS-TEMP-INDEX TO X-MMQ5-VI
059200             MOVE X-WS-TEMP-INDEX
059300                                 TO MB21WS-NAME (X-WS-INDEX:2)
059400             ADD 1               TO X-WS-INDEX
059500             MOVE ')'            TO MB21WS-NAME (X-WS-INDEX:1)
059600             SET WS-END-OF-PERFORM
059700                                 TO TRUE
059800         END-IF
059900     END-PERFORM.
060000     MOVE MMQ5-VI-NBR-STORES (X-MMQ5-VI)
060100                                 TO MB21WS-9V0Z.
060200     PERFORM MB21PD-INSERT-A-COLUMN
060300                                 THRU MB21PD-IAC-EXIT.
060400*
060500     MOVE 'VI-NBR-ATM'           TO MB21WS-NAME.
060600     SET WS-NOT-END-OF-PERFORM   TO TRUE
060700     PERFORM
060800         VARYING X-WS-INDEX
060900         FROM 30 BY -1
061000         UNTIL X-WS-INDEX IS EQUAL TO 1
061100         OR WS-END-OF-PERFORM
061200         IF  MB21WS-NAME (X-WS-INDEX:1)
061300                                 IS NOT EQUAL TO SPACES
061400             ADD 1               TO X-WS-INDEX
061500             MOVE '('            TO MB21WS-NAME (X-WS-INDEX:1)
061600             ADD 1               TO X-WS-INDEX
061700             SET X-WS-TEMP-INDEX TO X-MMQ5-VI
061800             MOVE X-WS-TEMP-INDEX
061900                                 TO MB21WS-NAME (X-WS-INDEX:2)
062000             ADD 1               TO X-WS-INDEX
062100             MOVE ')'            TO MB21WS-NAME (X-WS-INDEX:1)
062200             SET WS-END-OF-PERFORM
062300                                 TO TRUE
062400         END-IF
062500     END-PERFORM.
062600     MOVE MMQ5-VI-NBR-ATM (X-MMQ5-VI)
062700                                 TO MB21WS-9V0Z.
062800     PERFORM MB21PD-INSERT-A-COLUMN
062900                                 THRU MB21PD-IAC-EXIT.
063000*
063100     MOVE 'VI-NBR-POS-TERMINALS'
063200                                 TO MB21WS-NAME.
063300     SET WS-NOT-END-OF-PERFORM   TO TRUE
063400     PERFORM
063500         VARYING X-WS-INDEX
063600         FROM 30 BY -1
063700         UNTIL X-WS-INDEX IS EQUAL TO 1
063800         OR WS-END-OF-PERFORM
063900         IF  MB21WS-NAME (X-WS-INDEX:1)
064000                                 IS NOT EQUAL TO SPACES
064100             ADD 1               TO X-WS-INDEX
064200             MOVE '('            TO MB21WS-NAME (X-WS-INDEX:1)
064300             ADD 1               TO X-WS-INDEX
064400             SET X-WS-TEMP-INDEX TO X-MMQ5-VI
064500             MOVE X-WS-TEMP-INDEX
064600                                 TO MB21WS-NAME (X-WS-INDEX:2)
064700             ADD 1               TO X-WS-INDEX
064800             MOVE ')'            TO MB21WS-NAME (X-WS-INDEX:1)
064900             SET WS-END-OF-PERFORM
065000                                 TO TRUE
065100         END-IF
065200     END-PERFORM.
065300     MOVE MMQ5-VI-NBR-POS-TERMINALS (X-MMQ5-VI)
065400                                 TO MB21WS-9V0Z.
065500     PERFORM MB21PD-INSERT-A-COLUMN
065600                                 THRU MB21PD-IAC-EXIT.
065700*
065800     MOVE 'VI-NBR-ELECTRON-MERCH'
065900                                 TO MB21WS-NAME.
066000     SET WS-NOT-END-OF-PERFORM   TO TRUE
066100     PERFORM
066200         VARYING X-WS-INDEX
066300         FROM 30 BY -1
066400         UNTIL X-WS-INDEX IS EQUAL TO 1
066500         OR WS-END-OF-PERFORM
066600         IF  MB21WS-NAME (X-WS-INDEX:1)
066700                                 IS NOT EQUAL TO SPACES
066800             ADD 1               TO X-WS-INDEX
066900             MOVE '('            TO MB21WS-NAME (X-WS-INDEX:1)
067000             ADD 1               TO X-WS-INDEX
067100             SET X-WS-TEMP-INDEX TO X-MMQ5-VI
067200             MOVE X-WS-TEMP-INDEX
067300                                 TO MB21WS-NAME (X-WS-INDEX:2)
067400             ADD 1               TO X-WS-INDEX
067500             MOVE ')'            TO MB21WS-NAME (X-WS-INDEX:1)
067600             SET WS-END-OF-PERFORM
067700                                 TO TRUE
067800         END-IF
067900     END-PERFORM.
068000     MOVE MMQ5-VI-NBR-ELECTRON-MERCH (X-MMQ5-VI)
068100                                 TO MB21WS-9V0Z.
068200     PERFORM MB21PD-INSERT-A-COLUMN
068300                                 THRU MB21PD-IAC-EXIT.
068400*
068500     MOVE 'VI-NBR-ELECTRON-STORES'
068600                                 TO MB21WS-NAME.
068700     SET WS-NOT-END-OF-PERFORM   TO TRUE
068800     PERFORM
068900         VARYING X-WS-INDEX
069000         FROM 30 BY -1
069100         UNTIL X-WS-INDEX IS EQUAL TO 1
069200         OR WS-END-OF-PERFORM
069300         IF  MB21WS-NAME (X-WS-INDEX:1)
069400                                 IS NOT EQUAL TO SPACES
069500             ADD 1               TO X-WS-INDEX
069600             MOVE '('            TO MB21WS-NAME (X-WS-INDEX:1)
069700             ADD 1               TO X-WS-INDEX
069800             SET X-WS-TEMP-INDEX TO X-MMQ5-VI
069900             MOVE X-WS-TEMP-INDEX
070000                                 TO MB21WS-NAME (X-WS-INDEX:2)
070100             ADD 1               TO X-WS-INDEX
070200             MOVE ')'            TO MB21WS-NAME (X-WS-INDEX:1)
070300             SET WS-END-OF-PERFORM
070400                                 TO TRUE
070500         END-IF
070600     END-PERFORM.
070700     MOVE MMQ5-VI-NBR-ELECTRON-STORES (X-MMQ5-VI)
070800                                 TO MB21WS-9V0Z.
070900     PERFORM MB21PD-INSERT-A-COLUMN
071000                                 THRU MB21PD-IAC-EXIT.
071100*
071200     MOVE 'VI-NBR-INTERLINK-MERCH'
071300                                 TO MB21WS-NAME.
071400     SET WS-NOT-END-OF-PERFORM   TO TRUE
071500     PERFORM
071600         VARYING X-WS-INDEX
071700         FROM 30 BY -1
071800         UNTIL X-WS-INDEX IS EQUAL TO 1
071900         OR WS-END-OF-PERFORM
072000         IF  MB21WS-NAME (X-WS-INDEX:1)
072100                                 IS NOT EQUAL TO SPACES
072200             ADD 1               TO X-WS-INDEX
072300             MOVE '('            TO MB21WS-NAME (X-WS-INDEX:1)
072400             ADD 1               TO X-WS-INDEX
072500             SET X-WS-TEMP-INDEX TO X-MMQ5-VI
072600             MOVE X-WS-TEMP-INDEX
072700                                 TO MB21WS-NAME (X-WS-INDEX:2)
072800             ADD 1               TO X-WS-INDEX
072900             MOVE ')'            TO MB21WS-NAME (X-WS-INDEX:1)
073000             SET WS-END-OF-PERFORM
073100                                 TO TRUE
073200         END-IF
073300     END-PERFORM.
073400     MOVE MMQ5-VI-NBR-INTERLINK-MERCH (X-MMQ5-VI)
073500                                 TO MB21WS-9V0Z.
073600     PERFORM MB21PD-INSERT-A-COLUMN
073700                                 THRU MB21PD-IAC-EXIT.
073800*
073900*
074000*
074100     SET X-MMQ5-VI-MON           TO 1.
074200*
074300*
074400 B110-LOOP.
074500*
074600*
074700     MOVE 'VI-MONTH'             TO MB21WS-NAME.
074800     SET WS-NOT-END-OF-PERFORM   TO TRUE
074900     PERFORM
075000         VARYING X-WS-INDEX
075100         FROM 30 BY -1
075200         UNTIL X-WS-INDEX IS EQUAL TO 1
075300         OR WS-END-OF-PERFORM
075400         IF  MB21WS-NAME (X-WS-INDEX:1)
075500                                 IS NOT EQUAL TO SPACES
075600             ADD 1               TO X-WS-INDEX
075700             MOVE '('            TO MB21WS-NAME (X-WS-INDEX:1)
075800             ADD 1               TO X-WS-INDEX
075900             SET X-WS-TEMP-INDEX
076000                                 TO X-MMQ5-VI
076100             MOVE X-WS-TEMP-INDEX
076200                                 TO MB21WS-NAME (X-WS-INDEX:2)
076300             ADD 2               TO X-WS-INDEX
076400             SET X-WS-MON-INDEX  TO X-MMQ5-VI-MON
076500             MOVE X-WS-MON-INDEX
076600                                 TO MB21WS-NAME (X-WS-INDEX:2)
076700             ADD 2               TO X-WS-INDEX
076800             MOVE ')'            TO MB21WS-NAME (X-WS-INDEX:1)
076900             SET WS-END-OF-PERFORM
077000                                 TO TRUE
077100         END-IF
077200     END-PERFORM.
077300     MOVE MMQ5-VI-MONTH (X-MMQ5-VI X-MMQ5-VI-MON)
077400                                 TO MB21WS-2V0.
077500     PERFORM MB21PD-INSERT-A-COLUMN
077600                                 THRU MB21PD-IAC-EXIT.
077700*
077800     MOVE 'VI-YEAR'              TO MB21WS-NAME.
077900     SET WS-NOT-END-OF-PERFORM   TO TRUE
078000     PERFORM
078100         VARYING X-WS-INDEX
078200         FROM 30 BY -1
078300         UNTIL X-WS-INDEX IS EQUAL TO 1
078400         OR WS-END-OF-PERFORM
078500         IF  MB21WS-NAME (X-WS-INDEX:1)
078600                                 IS NOT EQUAL TO SPACES
078700             ADD 1               TO X-WS-INDEX
078800             MOVE '('            TO MB21WS-NAME (X-WS-INDEX:1)
078900             ADD 1               TO X-WS-INDEX
079000             SET X-WS-TEMP-INDEX
079100                                 TO X-MMQ5-VI
079200             MOVE X-WS-TEMP-INDEX
079300                                 TO MB21WS-NAME (X-WS-INDEX:2)
079400             ADD 2               TO X-WS-INDEX
079500             SET X-WS-MON-INDEX  TO X-MMQ5-VI-MON
079600             MOVE X-WS-MON-INDEX
079700                                 TO MB21WS-NAME (X-WS-INDEX:2)
079800             ADD 2               TO X-WS-INDEX
079900             MOVE ')'            TO MB21WS-NAME (X-WS-INDEX:1)
080000             SET WS-END-OF-PERFORM
080100                                 TO TRUE
080200         END-IF
080300     END-PERFORM.
080400     MOVE MMQ5-VI-YEAR (X-MMQ5-VI X-MMQ5-VI-MON)
080500                                 TO MB21WS-4V0.
080600     PERFORM MB21PD-INSERT-A-COLUMN
080700                                 THRU MB21PD-IAC-EXIT.
080800*
080900*
081000     MOVE 'VI-CREDITS-NBR'       TO MB21WS-NAME.
081100     SET WS-NOT-END-OF-PERFORM   TO TRUE
081200     PERFORM
081300         VARYING X-WS-INDEX
081400         FROM 30 BY -1
081500         UNTIL X-WS-INDEX IS EQUAL TO 1
081600         OR WS-END-OF-PERFORM
081700         IF  MB21WS-NAME (X-WS-INDEX:1)
081800                                 IS NOT EQUAL TO SPACES
081900             ADD 1               TO X-WS-INDEX
082000             MOVE '('            TO MB21WS-NAME (X-WS-INDEX:1)
082100             ADD 1               TO X-WS-INDEX
082200             SET X-WS-TEMP-INDEX TO X-MMQ5-VI
082300             MOVE X-WS-TEMP-INDEX
082400                                 TO MB21WS-NAME (X-WS-INDEX:2)
082500             ADD 2               TO X-WS-INDEX
082600             SET X-WS-MON-INDEX  TO X-MMQ5-VI-MON
082700             MOVE X-WS-MON-INDEX
082800                                 TO MB21WS-NAME (X-WS-INDEX:2)
082900             ADD 2               TO X-WS-INDEX
083000             MOVE ')'            TO MB21WS-NAME (X-WS-INDEX:1)
083100             SET WS-END-OF-PERFORM
083200                                 TO TRUE
083300         END-IF
083400     END-PERFORM.
083500     MOVE MMQ5-VI-CREDITS-NBR (X-MMQ5-VI X-MMQ5-VI-MON)
083600                                 TO MB21WS-9V0Z.
083700     PERFORM MB21PD-INSERT-A-COLUMN
083800                                 THRU MB21PD-IAC-EXIT.
083900*
084000     MOVE 'VI-CREDITS-AMT'       TO MB21WS-NAME.
084100     SET WS-NOT-END-OF-PERFORM   TO TRUE
084200     PERFORM
084300         VARYING X-WS-INDEX
084400         FROM 30 BY -1
084500         UNTIL X-WS-INDEX IS EQUAL TO 1
084600         OR WS-END-OF-PERFORM
084700         IF  MB21WS-NAME (X-WS-INDEX:1)
084800                                 IS NOT EQUAL TO SPACES
084900             ADD 1               TO X-WS-INDEX
085000             MOVE '('            TO MB21WS-NAME (X-WS-INDEX:1)
085100             ADD 1               TO X-WS-INDEX
085200             SET X-WS-TEMP-INDEX TO X-MMQ5-VI
085300             MOVE X-WS-TEMP-INDEX
085400                                 TO MB21WS-NAME (X-WS-INDEX:2)
085500             ADD 2               TO X-WS-INDEX
085600             SET X-WS-MON-INDEX  TO X-MMQ5-VI-MON
085700             MOVE X-WS-MON-INDEX
085800                                 TO MB21WS-NAME (X-WS-INDEX:2)
085900             ADD 2               TO X-WS-INDEX
086000             MOVE ')'            TO MB21WS-NAME (X-WS-INDEX:1)
086100             SET WS-END-OF-PERFORM
086200                                 TO TRUE
086300         END-IF
086400     END-PERFORM.
086500     MOVE MMQ5-VI-CREDITS-AMT (X-MMQ5-VI X-MMQ5-VI-MON)
086600                                 TO MB21WS-15V2.
086700     PERFORM MB21PD-INSERT-A-COLUMN
086800                                 THRU MB21PD-IAC-EXIT.
086900*
087000     MOVE 'VI-ONUS-NBR-MAN'      TO MB21WS-NAME.
087100     SET WS-NOT-END-OF-PERFORM   TO TRUE
087200     PERFORM
087300         VARYING X-WS-INDEX
087400         FROM 30 BY -1
087500         UNTIL X-WS-INDEX IS EQUAL TO 1
087600         OR WS-END-OF-PERFORM
087700         IF  MB21WS-NAME (X-WS-INDEX:1)
087800                                 IS NOT EQUAL TO SPACES
087900             ADD 1               TO X-WS-INDEX
088000             MOVE '('            TO MB21WS-NAME (X-WS-INDEX:1)
088100             ADD 1               TO X-WS-INDEX
088200             SET X-WS-TEMP-INDEX TO X-MMQ5-VI
088300             MOVE X-WS-TEMP-INDEX
088400                                 TO MB21WS-NAME (X-WS-INDEX:2)
088500             ADD 2               TO X-WS-INDEX
088600             SET X-WS-MON-INDEX  TO X-MMQ5-VI-MON
088700             MOVE X-WS-MON-INDEX
088800                                 TO MB21WS-NAME (X-WS-INDEX:2)
088900             ADD 2               TO X-WS-INDEX
089000             MOVE ')'            TO MB21WS-NAME (X-WS-INDEX:1)
089100             SET WS-END-OF-PERFORM
089200                                 TO TRUE
089300         END-IF
089400     END-PERFORM.
089500     MOVE MMQ5-VI-ONUS-NBR-MAN (X-MMQ5-VI X-MMQ5-VI-MON)
089600                                 TO MB21WS-9V0Z.
089700     PERFORM MB21PD-INSERT-A-COLUMN
089800                                 THRU MB21PD-IAC-EXIT.
089900*
090000     MOVE 'VI-ONUS-AMT-MAN'      TO MB21WS-NAME.
090100     SET WS-NOT-END-OF-PERFORM   TO TRUE
090200     PERFORM
090300         VARYING X-WS-INDEX
090400         FROM 30 BY -1
090500         UNTIL X-WS-INDEX IS EQUAL TO 1
090600         OR WS-END-OF-PERFORM
090700         IF  MB21WS-NAME (X-WS-INDEX:1)
090800                                 IS NOT EQUAL TO SPACES
090900             ADD 1               TO X-WS-INDEX
091000             MOVE '('            TO MB21WS-NAME (X-WS-INDEX:1)
091100             ADD 1               TO X-WS-INDEX
091200             SET X-WS-TEMP-INDEX TO X-MMQ5-VI
091300             MOVE X-WS-TEMP-INDEX
091400                                 TO MB21WS-NAME (X-WS-INDEX:2)
091500             ADD 2               TO X-WS-INDEX
091600             SET X-WS-MON-INDEX  TO X-MMQ5-VI-MON
091700             MOVE X-WS-MON-INDEX
091800                                 TO MB21WS-NAME (X-WS-INDEX:2)
091900             ADD 2               TO X-WS-INDEX
092000             MOVE ')'            TO MB21WS-NAME (X-WS-INDEX:1)
092100             SET WS-END-OF-PERFORM
092200                                 TO TRUE
092300         END-IF
092400     END-PERFORM.
092500     MOVE MMQ5-VI-ONUS-AMT-MAN (X-MMQ5-VI X-MMQ5-VI-MON)
092600                                 TO MB21WS-15V2.
092700     PERFORM MB21PD-INSERT-A-COLUMN
092800                                 THRU MB21PD-IAC-EXIT.
092900*
093000     MOVE 'VI-ONUS-NBR-ELE'      TO MB21WS-NAME.
093100     SET WS-NOT-END-OF-PERFORM   TO TRUE
093200     PERFORM
093300         VARYING X-WS-INDEX
093400         FROM 30 BY -1
093500         UNTIL X-WS-INDEX IS EQUAL TO 1
093600         OR WS-END-OF-PERFORM
093700         IF  MB21WS-NAME (X-WS-INDEX:1)
093800                                 IS NOT EQUAL TO SPACES
093900             ADD 1               TO X-WS-INDEX
094000             MOVE '('            TO MB21WS-NAME (X-WS-INDEX:1)
094100             ADD 1               TO X-WS-INDEX
094200             SET X-WS-TEMP-INDEX TO X-MMQ5-VI
094300             MOVE X-WS-TEMP-INDEX
094400                                 TO MB21WS-NAME (X-WS-INDEX:2)
094500             ADD 2               TO X-WS-INDEX
094600             SET X-WS-MON-INDEX  TO X-MMQ5-VI-MON
094700             MOVE X-WS-MON-INDEX
094800                                 TO MB21WS-NAME (X-WS-INDEX:2)
094900             ADD 2               TO X-WS-INDEX
095000             MOVE ')'            TO MB21WS-NAME (X-WS-INDEX:1)
095100             SET WS-END-OF-PERFORM
095200                                 TO TRUE
095300         END-IF
095400     END-PERFORM.
095500     MOVE MMQ5-VI-ONUS-NBR-ELE (X-MMQ5-VI X-MMQ5-VI-MON)
095600                                 TO MB21WS-9V0Z.
095700     PERFORM MB21PD-INSERT-A-COLUMN
095800                                 THRU MB21PD-IAC-EXIT.
095900*
096000     MOVE 'VI-ONUS-AMT-ELE'      TO MB21WS-NAME.
096100     SET WS-NOT-END-OF-PERFORM   TO TRUE
096200     PERFORM
096300         VARYING X-WS-INDEX
096400         FROM 30 BY -1
096500         UNTIL X-WS-INDEX IS EQUAL TO 1
096600         OR WS-END-OF-PERFORM
096700         IF  MB21WS-NAME (X-WS-INDEX:1)
096800                                 IS NOT EQUAL TO SPACES
096900             ADD 1               TO X-WS-INDEX
097000             MOVE '('            TO MB21WS-NAME (X-WS-INDEX:1)
097100             ADD 1               TO X-WS-INDEX
097200             SET X-WS-TEMP-INDEX TO X-MMQ5-VI
097300             MOVE X-WS-TEMP-INDEX
097400                                 TO MB21WS-NAME (X-WS-INDEX:2)
097500             ADD 2               TO X-WS-INDEX
097600             SET X-WS-MON-INDEX  TO X-MMQ5-VI-MON
097700             MOVE X-WS-MON-INDEX
097800                                 TO MB21WS-NAME (X-WS-INDEX:2)
097900             ADD 2               TO X-WS-INDEX
098000             MOVE ')'            TO MB21WS-NAME (X-WS-INDEX:1)
098100             SET WS-END-OF-PERFORM
098200                                 TO TRUE
098300         END-IF
098400     END-PERFORM.
098500     MOVE MMQ5-VI-ONUS-AMT-ELE (X-MMQ5-VI X-MMQ5-VI-MON)
098600                                 TO MB21WS-15V2.
098700     PERFORM MB21PD-INSERT-A-COLUMN
098800                                 THRU MB21PD-IAC-EXIT.
098900*
099000     MOVE 'VI-ONUS-NBR-MAN-CA'  TO MB21WS-NAME.
099100     SET WS-NOT-END-OF-PERFORM   TO TRUE
099200     PERFORM
099300         VARYING X-WS-INDEX
099400         FROM 30 BY -1
099500         UNTIL X-WS-INDEX IS EQUAL TO 1
099600         OR WS-END-OF-PERFORM
099700         IF  MB21WS-NAME (X-WS-INDEX:1)
099800                                 IS NOT EQUAL TO SPACES
099900             ADD 1               TO X-WS-INDEX
100000             MOVE '('            TO MB21WS-NAME (X-WS-INDEX:1)
100100             ADD 1               TO X-WS-INDEX
100200             SET X-WS-TEMP-INDEX TO X-MMQ5-VI
100300             MOVE X-WS-TEMP-INDEX
100400                                 TO MB21WS-NAME (X-WS-INDEX:2)
100500             ADD 2               TO X-WS-INDEX
100600             SET X-WS-MON-INDEX  TO X-MMQ5-VI-MON
100700             MOVE X-WS-MON-INDEX
100800                                 TO MB21WS-NAME (X-WS-INDEX:2)
100900             ADD 2               TO X-WS-INDEX
101000             MOVE ')'            TO MB21WS-NAME (X-WS-INDEX:1)
101100             SET WS-END-OF-PERFORM
101200                                 TO TRUE
101300         END-IF
101400     END-PERFORM.
101500     MOVE MMQ5-VI-ONUS-NBR-MAN-CA (X-MMQ5-VI X-MMQ5-VI-MON)
101600                                 TO MB21WS-9V0Z.
101700     PERFORM MB21PD-INSERT-A-COLUMN
101800                                 THRU MB21PD-IAC-EXIT.
101900*
102000     MOVE 'VI-ONUS-AMT-MAN-CA'  TO MB21WS-NAME.
102100     SET WS-NOT-END-OF-PERFORM   TO TRUE
102200     PERFORM
102300         VARYING X-WS-INDEX
102400         FROM 30 BY -1
102500         UNTIL X-WS-INDEX IS EQUAL TO 1
102600         OR WS-END-OF-PERFORM
102700         IF  MB21WS-NAME (X-WS-INDEX:1)
102800                                 IS NOT EQUAL TO SPACES
102900             ADD 1               TO X-WS-INDEX
103000             MOVE '('            TO MB21WS-NAME (X-WS-INDEX:1)
103100             ADD 1               TO X-WS-INDEX
103200             SET X-WS-TEMP-INDEX TO X-MMQ5-VI
103300             MOVE X-WS-TEMP-INDEX
103400                                 TO MB21WS-NAME (X-WS-INDEX:2)
103500             ADD 2               TO X-WS-INDEX
103600             SET X-WS-MON-INDEX  TO X-MMQ5-VI-MON
103700             MOVE X-WS-MON-INDEX
103800                                 TO MB21WS-NAME (X-WS-INDEX:2)
103900             ADD 2               TO X-WS-INDEX
104000             MOVE ')'            TO MB21WS-NAME (X-WS-INDEX:1)
104100             SET WS-END-OF-PERFORM
104200                                 TO TRUE
104300         END-IF
104400     END-PERFORM.
104500     MOVE MMQ5-VI-ONUS-AMT-MAN-CA (X-MMQ5-VI X-MMQ5-VI-MON)
104600                                 TO MB21WS-15V2.
104700     PERFORM MB21PD-INSERT-A-COLUMN
104800                                 THRU MB21PD-IAC-EXIT.
104900*
105000     MOVE 'VI-ONUS-NBR-ATM'      TO MB21WS-NAME.
105100     SET WS-NOT-END-OF-PERFORM   TO TRUE
105200     PERFORM
105300         VARYING X-WS-INDEX
105400         FROM 30 BY -1
105500         UNTIL X-WS-INDEX IS EQUAL TO 1
105600         OR WS-END-OF-PERFORM
105700         IF  MB21WS-NAME (X-WS-INDEX:1)
105800                                 IS NOT EQUAL TO SPACES
105900             ADD 1               TO X-WS-INDEX
106000             MOVE '('            TO MB21WS-NAME (X-WS-INDEX:1)
106100             ADD 1               TO X-WS-INDEX
106200             SET X-WS-TEMP-INDEX TO X-MMQ5-VI
106300             MOVE X-WS-TEMP-INDEX
106400                                 TO MB21WS-NAME (X-WS-INDEX:2)
106500             ADD 2               TO X-WS-INDEX
106600             SET X-WS-MON-INDEX  TO X-MMQ5-VI-MON
106700             MOVE X-WS-MON-INDEX
106800                                 TO MB21WS-NAME (X-WS-INDEX:2)
106900             ADD 2               TO X-WS-INDEX
107000             MOVE ')'            TO MB21WS-NAME (X-WS-INDEX:1)
107100             SET WS-END-OF-PERFORM
107200                                 TO TRUE
107300         END-IF
107400     END-PERFORM.
107500     MOVE MMQ5-VI-ONUS-NBR-ATM (X-MMQ5-VI X-MMQ5-VI-MON)
107600                                 TO MB21WS-9V0Z.
107700     PERFORM MB21PD-INSERT-A-COLUMN
107800                                 THRU MB21PD-IAC-EXIT.
107900*
108000     MOVE 'VI-ONUS-AMT-ATM'      TO MB21WS-NAME.
108100     SET WS-NOT-END-OF-PERFORM   TO TRUE
108200     PERFORM
108300         VARYING X-WS-INDEX
108400         FROM 30 BY -1
108500         UNTIL X-WS-INDEX IS EQUAL TO 1
108600         OR WS-END-OF-PERFORM
108700         IF  MB21WS-NAME (X-WS-INDEX:1)
108800                                 IS NOT EQUAL TO SPACES
108900             ADD 1               TO X-WS-INDEX
109000             MOVE '('            TO MB21WS-NAME (X-WS-INDEX:1)
109100             ADD 1               TO X-WS-INDEX
109200             SET X-WS-TEMP-INDEX TO X-MMQ5-VI
109300             MOVE X-WS-TEMP-INDEX
109400                                 TO MB21WS-NAME (X-WS-INDEX:2)
109500             ADD 2               TO X-WS-INDEX
109600             SET X-WS-MON-INDEX  TO X-MMQ5-VI-MON
109700             MOVE X-WS-MON-INDEX
109800                                 TO MB21WS-NAME (X-WS-INDEX:2)
109900             ADD 2               TO X-WS-INDEX
110000             MOVE ')'            TO MB21WS-NAME (X-WS-INDEX:1)
110100             SET WS-END-OF-PERFORM
110200                                 TO TRUE
110300         END-IF
110400     END-PERFORM.
110500     MOVE MMQ5-VI-ONUS-AMT-ATM (X-MMQ5-VI X-MMQ5-VI-MON)
110600                                 TO MB21WS-15V2.
110700     PERFORM MB21PD-INSERT-A-COLUMN
110800                                 THRU MB21PD-IAC-EXIT.
110900*
111000     MOVE 'VI-NAT-OUT-NBR-MAN'   TO MB21WS-NAME.
111100     SET WS-NOT-END-OF-PERFORM   TO TRUE
111200     PERFORM
111300         VARYING X-WS-INDEX
111400         FROM 30 BY -1
111500         UNTIL X-WS-INDEX IS EQUAL TO 1
111600         OR WS-END-OF-PERFORM
111700         IF  MB21WS-NAME (X-WS-INDEX:1)
111800                                 IS NOT EQUAL TO SPACES
111900             ADD 1               TO X-WS-INDEX
112000             MOVE '('            TO MB21WS-NAME (X-WS-INDEX:1)
112100             ADD 1               TO X-WS-INDEX
112200             SET X-WS-TEMP-INDEX TO X-MMQ5-VI
112300             MOVE X-WS-TEMP-INDEX
112400                                 TO MB21WS-NAME (X-WS-INDEX:2)
112500             ADD 2               TO X-WS-INDEX
112600             SET X-WS-MON-INDEX  TO X-MMQ5-VI-MON
112700             MOVE X-WS-MON-INDEX
112800                                 TO MB21WS-NAME (X-WS-INDEX:2)
112900             ADD 2               TO X-WS-INDEX
113000             MOVE ')'            TO MB21WS-NAME (X-WS-INDEX:1)
113100             SET WS-END-OF-PERFORM
113200                                 TO TRUE
113300         END-IF
113400     END-PERFORM.
113500     MOVE MMQ5-VI-NAT-OUT-NBR-MAN (X-MMQ5-VI X-MMQ5-VI-MON)
113600                                 TO MB21WS-9V0Z.
113700     PERFORM MB21PD-INSERT-A-COLUMN
113800                                 THRU MB21PD-IAC-EXIT.
113900*
114000     MOVE 'VI-NAT-OUT-AMT-MAN'   TO MB21WS-NAME.
114100     SET WS-NOT-END-OF-PERFORM   TO TRUE
114200     PERFORM
114300         VARYING X-WS-INDEX
114400         FROM 30 BY -1
114500         UNTIL X-WS-INDEX IS EQUAL TO 1
114600         OR WS-END-OF-PERFORM
114700         IF  MB21WS-NAME (X-WS-INDEX:1)
114800                                 IS NOT EQUAL TO SPACES
114900             ADD 1               TO X-WS-INDEX
115000             MOVE '('            TO MB21WS-NAME (X-WS-INDEX:1)
115100             ADD 1               TO X-WS-INDEX
115200             SET X-WS-TEMP-INDEX TO X-MMQ5-VI
115300             MOVE X-WS-TEMP-INDEX
115400                                 TO MB21WS-NAME (X-WS-INDEX:2)
115500             ADD 2               TO X-WS-INDEX
115600             SET X-WS-MON-INDEX  TO X-MMQ5-VI-MON
115700             MOVE X-WS-MON-INDEX
115800                                 TO MB21WS-NAME (X-WS-INDEX:2)
115900             ADD 2               TO X-WS-INDEX
116000             MOVE ')'            TO MB21WS-NAME (X-WS-INDEX:1)
116100             SET WS-END-OF-PERFORM
116200                                 TO TRUE
116300         END-IF
116400     END-PERFORM.
116500     MOVE MMQ5-VI-NAT-OUT-AMT-MAN (X-MMQ5-VI X-MMQ5-VI-MON)
116600                                 TO MB21WS-15V2.
116700     PERFORM MB21PD-INSERT-A-COLUMN
116800                                 THRU MB21PD-IAC-EXIT.
116900*
117000     MOVE 'VI-NAT-OUT-NBR-ELE'   TO MB21WS-NAME.
117100     SET WS-NOT-END-OF-PERFORM   TO TRUE
117200     PERFORM
117300         VARYING X-WS-INDEX
117400         FROM 30 BY -1
117500         UNTIL X-WS-INDEX IS EQUAL TO 1
117600         OR WS-END-OF-PERFORM
117700         IF  MB21WS-NAME (X-WS-INDEX:1)
117800                                 IS NOT EQUAL TO SPACES
117900             ADD 1               TO X-WS-INDEX
118000             MOVE '('            TO MB21WS-NAME (X-WS-INDEX:1)
118100             ADD 1               TO X-WS-INDEX
118200             SET X-WS-TEMP-INDEX TO X-MMQ5-VI
118300             MOVE X-WS-TEMP-INDEX
118400                                 TO MB21WS-NAME (X-WS-INDEX:2)
118500             ADD 2               TO X-WS-INDEX
118600             SET X-WS-MON-INDEX  TO X-MMQ5-VI-MON
118700             MOVE X-WS-MON-INDEX
118800                                 TO MB21WS-NAME (X-WS-INDEX:2)
118900             ADD 2               TO X-WS-INDEX
119000             MOVE ')'            TO MB21WS-NAME (X-WS-INDEX:1)
119100             SET WS-END-OF-PERFORM
119200                                 TO TRUE
119300         END-IF
119400     END-PERFORM.
119500     MOVE MMQ5-VI-NAT-OUT-NBR-ELE (X-MMQ5-VI X-MMQ5-VI-MON)
119600                                 TO MB21WS-9V0Z.
119700     PERFORM MB21PD-INSERT-A-COLUMN
119800                                 THRU MB21PD-IAC-EXIT.
119900*
120000     MOVE 'VI-NAT-OUT-AMT-ELE'   TO MB21WS-NAME.
120100     SET WS-NOT-END-OF-PERFORM   TO TRUE
120200     PERFORM
120300         VARYING X-WS-INDEX
120400         FROM 30 BY -1
120500         UNTIL X-WS-INDEX IS EQUAL TO 1
120600         OR WS-END-OF-PERFORM
120700         IF  MB21WS-NAME (X-WS-INDEX:1)
120800                                 IS NOT EQUAL TO SPACES
120900             ADD 1               TO X-WS-INDEX
121000             MOVE '('            TO MB21WS-NAME (X-WS-INDEX:1)
121100             ADD 1               TO X-WS-INDEX
121200             SET X-WS-TEMP-INDEX TO X-MMQ5-VI
121300             MOVE X-WS-TEMP-INDEX
121400                                 TO MB21WS-NAME (X-WS-INDEX:2)
121500             ADD 2               TO X-WS-INDEX
121600             SET X-WS-MON-INDEX  TO X-MMQ5-VI-MON
121700             MOVE X-WS-MON-INDEX
121800                                 TO MB21WS-NAME (X-WS-INDEX:2)
121900             ADD 2               TO X-WS-INDEX
122000             MOVE ')'            TO MB21WS-NAME (X-WS-INDEX:1)
122100             SET WS-END-OF-PERFORM
122200                                 TO TRUE
122300         END-IF
122400     END-PERFORM.
122500     MOVE MMQ5-VI-NAT-OUT-AMT-ELE (X-MMQ5-VI X-MMQ5-VI-MON)
122600                                 TO MB21WS-15V2.
122700     PERFORM MB21PD-INSERT-A-COLUMN
122800                                 THRU MB21PD-IAC-EXIT.
122900*
123000     MOVE 'VI-NAT-OUT-NBR-MAN-CA' TO MB21WS-NAME.
123100     SET WS-NOT-END-OF-PERFORM   TO TRUE
123200     PERFORM
123300         VARYING X-WS-INDEX
123400         FROM 30 BY -1
123500         UNTIL X-WS-INDEX IS EQUAL TO 1
123600         OR WS-END-OF-PERFORM
123700         IF  MB21WS-NAME (X-WS-INDEX:1)
123800                                 IS NOT EQUAL TO SPACES
123900             ADD 1               TO X-WS-INDEX
124000             MOVE '('            TO MB21WS-NAME (X-WS-INDEX:1)
124100             ADD 1               TO X-WS-INDEX
124200             SET X-WS-TEMP-INDEX TO X-MMQ5-VI
124300             MOVE X-WS-TEMP-INDEX
124400                                 TO MB21WS-NAME (X-WS-INDEX:2)
124500             ADD 2               TO X-WS-INDEX
124600             SET X-WS-MON-INDEX  TO X-MMQ5-VI-MON
124700             MOVE X-WS-MON-INDEX
124800                                 TO MB21WS-NAME (X-WS-INDEX:2)
124900             ADD 2               TO X-WS-INDEX
125000             MOVE ')'            TO MB21WS-NAME (X-WS-INDEX:1)
125100             SET WS-END-OF-PERFORM
125200                                 TO TRUE
125300         END-IF
125400     END-PERFORM.
125500     MOVE MMQ5-VI-NAT-OUT-NBR-MAN-CA (X-MMQ5-VI X-MMQ5-VI-MON)
125600                                 TO MB21WS-9V0Z.
125700     PERFORM MB21PD-INSERT-A-COLUMN
125800                                 THRU MB21PD-IAC-EXIT.
125900*
126000     MOVE 'VI-NAT-OUT-AMT-MAN-CA' TO MB21WS-NAME.
126100     SET WS-NOT-END-OF-PERFORM   TO TRUE
126200     PERFORM
126300         VARYING X-WS-INDEX
126400         FROM 30 BY -1
126500         UNTIL X-WS-INDEX IS EQUAL TO 1
126600         OR WS-END-OF-PERFORM
126700         IF  MB21WS-NAME (X-WS-INDEX:1)
126800                                 IS NOT EQUAL TO SPACES
126900             ADD 1               TO X-WS-INDEX
127000             MOVE '('            TO MB21WS-NAME (X-WS-INDEX:1)
127100             ADD 1               TO X-WS-INDEX
127200             SET X-WS-TEMP-INDEX TO X-MMQ5-VI
127300             MOVE X-WS-TEMP-INDEX
127400                                 TO MB21WS-NAME (X-WS-INDEX:2)
127500             ADD 2               TO X-WS-INDEX
127600             SET X-WS-MON-INDEX  TO X-MMQ5-VI-MON
127700             MOVE X-WS-MON-INDEX
127800                                 TO MB21WS-NAME (X-WS-INDEX:2)
127900             ADD 2               TO X-WS-INDEX
128000             MOVE ')'            TO MB21WS-NAME (X-WS-INDEX:1)
128100             SET WS-END-OF-PERFORM
128200                                 TO TRUE
128300         END-IF
128400     END-PERFORM.
128500     MOVE MMQ5-VI-NAT-OUT-AMT-MAN-CA (X-MMQ5-VI X-MMQ5-VI-MON)
128600                                 TO MB21WS-15V2.
128700     PERFORM MB21PD-INSERT-A-COLUMN
128800                                 THRU MB21PD-IAC-EXIT.
128900*
129000     MOVE 'VI-NAT-OUT-NBR-ATM'   TO MB21WS-NAME.
129100     SET WS-NOT-END-OF-PERFORM   TO TRUE
129200     PERFORM
129300         VARYING X-WS-INDEX
129400         FROM 30 BY -1
129500         UNTIL X-WS-INDEX IS EQUAL TO 1
129600         OR WS-END-OF-PERFORM
129700         IF  MB21WS-NAME (X-WS-INDEX:1)
129800                                 IS NOT EQUAL TO SPACES
129900             ADD 1               TO X-WS-INDEX
130000             MOVE '('            TO MB21WS-NAME (X-WS-INDEX:1)
130100             ADD 1               TO X-WS-INDEX
130200             SET X-WS-TEMP-INDEX TO X-MMQ5-VI
130300             MOVE X-WS-TEMP-INDEX
130400                                 TO MB21WS-NAME (X-WS-INDEX:2)
130500             ADD 2               TO X-WS-INDEX
130600             SET X-WS-MON-INDEX  TO X-MMQ5-VI-MON
130700             MOVE X-WS-MON-INDEX
130800                                 TO MB21WS-NAME (X-WS-INDEX:2)
130900             ADD 2               TO X-WS-INDEX
131000             MOVE ')'            TO MB21WS-NAME (X-WS-INDEX:1)
131100             SET WS-END-OF-PERFORM
131200                                 TO TRUE
131300         END-IF
131400     END-PERFORM.
131500     MOVE MMQ5-VI-NAT-OUT-NBR-ATM (X-MMQ5-VI X-MMQ5-VI-MON)
131600                                 TO MB21WS-9V0Z.
131700     PERFORM MB21PD-INSERT-A-COLUMN
131800                                 THRU MB21PD-IAC-EXIT.
131900*
132000     MOVE 'VI-NAT-OUT-AMT-ATM'   TO MB21WS-NAME.
132100     SET WS-NOT-END-OF-PERFORM   TO TRUE
132200     PERFORM
132300         VARYING X-WS-INDEX
132400         FROM 30 BY -1
132500         UNTIL X-WS-INDEX IS EQUAL TO 1
132600         OR WS-END-OF-PERFORM
132700         IF  MB21WS-NAME (X-WS-INDEX:1)
132800                                 IS NOT EQUAL TO SPACES
132900             ADD 1               TO X-WS-INDEX
133000             MOVE '('            TO MB21WS-NAME (X-WS-INDEX:1)
133100             ADD 1               TO X-WS-INDEX
133200             SET X-WS-TEMP-INDEX TO X-MMQ5-VI
133300             MOVE X-WS-TEMP-INDEX
133400                                 TO MB21WS-NAME (X-WS-INDEX:2)
133500             ADD 2               TO X-WS-INDEX
133600             SET X-WS-MON-INDEX  TO X-MMQ5-VI-MON
133700             MOVE X-WS-MON-INDEX
133800                                 TO MB21WS-NAME (X-WS-INDEX:2)
133900             ADD 2               TO X-WS-INDEX
134000             MOVE ')'            TO MB21WS-NAME (X-WS-INDEX:1)
134100             SET WS-END-OF-PERFORM
134200                                 TO TRUE
134300         END-IF
134400     END-PERFORM.
134500     MOVE MMQ5-VI-NAT-OUT-AMT-ATM (X-MMQ5-VI X-MMQ5-VI-MON)
134600                                 TO MB21WS-15V2.
134700     PERFORM MB21PD-INSERT-A-COLUMN
134800                                 THRU MB21PD-IAC-EXIT.
134900*
135000     MOVE 'VI-INT-OUT-NBR-MAN'   TO MB21WS-NAME.
135100     SET WS-NOT-END-OF-PERFORM   TO TRUE
135200     PERFORM
135300         VARYING X-WS-INDEX
135400         FROM 30 BY -1
135500         UNTIL X-WS-INDEX IS EQUAL TO 1
135600         OR WS-END-OF-PERFORM
135700         IF  MB21WS-NAME (X-WS-INDEX:1)
135800                                 IS NOT EQUAL TO SPACES
135900             ADD 1               TO X-WS-INDEX
136000             MOVE '('            TO MB21WS-NAME (X-WS-INDEX:1)
136100             ADD 1               TO X-WS-INDEX
136200             SET X-WS-TEMP-INDEX TO X-MMQ5-VI
136300             MOVE X-WS-TEMP-INDEX
136400                                 TO MB21WS-NAME (X-WS-INDEX:2)
136500             ADD 2               TO X-WS-INDEX
136600             SET X-WS-MON-INDEX  TO X-MMQ5-VI-MON
136700             MOVE X-WS-MON-INDEX
136800                                 TO MB21WS-NAME (X-WS-INDEX:2)
136900             ADD 2               TO X-WS-INDEX
137000             MOVE ')'            TO MB21WS-NAME (X-WS-INDEX:1)
137100             SET WS-END-OF-PERFORM
137200                                 TO TRUE
137300         END-IF
137400     END-PERFORM.
137500     MOVE MMQ5-VI-INT-OUT-NBR-MAN (X-MMQ5-VI X-MMQ5-VI-MON)
137600                                 TO MB21WS-9V0Z.
137700     PERFORM MB21PD-INSERT-A-COLUMN
137800                                 THRU MB21PD-IAC-EXIT.
137900*
138000     MOVE 'VI-INT-OUT-AMT-MAN'   TO MB21WS-NAME.
138100     SET WS-NOT-END-OF-PERFORM   TO TRUE
138200     PERFORM
138300         VARYING X-WS-INDEX
138400         FROM 30 BY -1
138500         UNTIL X-WS-INDEX IS EQUAL TO 1
138600         OR WS-END-OF-PERFORM
138700         IF  MB21WS-NAME (X-WS-INDEX:1)
138800                                 IS NOT EQUAL TO SPACES
138900             ADD 1               TO X-WS-INDEX
139000             MOVE '('            TO MB21WS-NAME (X-WS-INDEX:1)
139100             ADD 1               TO X-WS-INDEX
139200             SET X-WS-TEMP-INDEX TO X-MMQ5-VI
139300             MOVE X-WS-TEMP-INDEX
139400                                 TO MB21WS-NAME (X-WS-INDEX:2)
139500             ADD 2               TO X-WS-INDEX
139600             SET X-WS-MON-INDEX  TO X-MMQ5-VI-MON
139700             MOVE X-WS-MON-INDEX
139800                                 TO MB21WS-NAME (X-WS-INDEX:2)
139900             ADD 2               TO X-WS-INDEX
140000             MOVE ')'            TO MB21WS-NAME (X-WS-INDEX:1)
140100             SET WS-END-OF-PERFORM
140200                                 TO TRUE
140300         END-IF
140400     END-PERFORM.
140500     MOVE MMQ5-VI-INT-OUT-AMT-MAN (X-MMQ5-VI X-MMQ5-VI-MON)
140600                                 TO MB21WS-15V2.
140700     PERFORM MB21PD-INSERT-A-COLUMN
140800                                 THRU MB21PD-IAC-EXIT.
140900*
141000     MOVE 'VI-INT-OUT-NBR-ELE'   TO MB21WS-NAME.
141100     SET WS-NOT-END-OF-PERFORM   TO TRUE
141200     PERFORM
141300         VARYING X-WS-INDEX
141400         FROM 30 BY -1
141500         UNTIL X-WS-INDEX IS EQUAL TO 1
141600         OR WS-END-OF-PERFORM
141700         IF  MB21WS-NAME (X-WS-INDEX:1)
141800                                 IS NOT EQUAL TO SPACES
141900             ADD 1               TO X-WS-INDEX
142000             MOVE '('            TO MB21WS-NAME (X-WS-INDEX:1)
142100             ADD 1               TO X-WS-INDEX
142200             SET X-WS-TEMP-INDEX TO X-MMQ5-VI
142300             MOVE X-WS-TEMP-INDEX
142400                                 TO MB21WS-NAME (X-WS-INDEX:2)
142500             ADD 2               TO X-WS-INDEX
142600             SET X-WS-MON-INDEX  TO X-MMQ5-VI-MON
142700             MOVE X-WS-MON-INDEX
142800                                 TO MB21WS-NAME (X-WS-INDEX:2)
142900             ADD 2               TO X-WS-INDEX
143000             MOVE ')'            TO MB21WS-NAME (X-WS-INDEX:1)
143100             SET WS-END-OF-PERFORM
143200                                 TO TRUE
143300         END-IF
143400     END-PERFORM.
143500     MOVE MMQ5-VI-INT-OUT-NBR-ELE (X-MMQ5-VI X-MMQ5-VI-MON)
143600                                 TO MB21WS-9V0Z.
143700     PERFORM MB21PD-INSERT-A-COLUMN
143800                                 THRU MB21PD-IAC-EXIT.
143900*
144000     MOVE 'VI-INT-OUT-AMT-ELE'   TO MB21WS-NAME.
144100     SET WS-NOT-END-OF-PERFORM   TO TRUE
144200     PERFORM
144300         VARYING X-WS-INDEX
144400         FROM 30 BY -1
144500         UNTIL X-WS-INDEX IS EQUAL TO 1
144600         OR WS-END-OF-PERFORM
144700         IF  MB21WS-NAME (X-WS-INDEX:1)
144800                                 IS NOT EQUAL TO SPACES
144900             ADD 1               TO X-WS-INDEX
145000             MOVE '('            TO MB21WS-NAME (X-WS-INDEX:1)
145100             ADD 1               TO X-WS-INDEX
145200             SET X-WS-TEMP-INDEX TO X-MMQ5-VI
145300             MOVE X-WS-TEMP-INDEX
145400                                 TO MB21WS-NAME (X-WS-INDEX:2)
145500             ADD 2               TO X-WS-INDEX
145600             SET X-WS-MON-INDEX  TO X-MMQ5-VI-MON
145700             MOVE X-WS-MON-INDEX
145800                                 TO MB21WS-NAME (X-WS-INDEX:2)
145900             ADD 2               TO X-WS-INDEX
146000             MOVE ')'            TO MB21WS-NAME (X-WS-INDEX:1)
146100             SET WS-END-OF-PERFORM
146200                                 TO TRUE
146300         END-IF
146400     END-PERFORM.
146500     MOVE MMQ5-VI-INT-OUT-AMT-ELE (X-MMQ5-VI X-MMQ5-VI-MON)
146600                                 TO MB21WS-15V2.
146700     PERFORM MB21PD-INSERT-A-COLUMN
146800                                 THRU MB21PD-IAC-EXIT.
146900*
147000     MOVE 'VI-INT-OUT-NBR-MAN-CA' TO MB21WS-NAME.
147100     SET WS-NOT-END-OF-PERFORM   TO TRUE
147200     PERFORM
147300         VARYING X-WS-INDEX
147400         FROM 30 BY -1
147500         UNTIL X-WS-INDEX IS EQUAL TO 1
147600         OR WS-END-OF-PERFORM
147700         IF  MB21WS-NAME (X-WS-INDEX:1)
147800                                 IS NOT EQUAL TO SPACES
147900             ADD 1               TO X-WS-INDEX
148000             MOVE '('            TO MB21WS-NAME (X-WS-INDEX:1)
148100             ADD 1               TO X-WS-INDEX
148200             SET X-WS-TEMP-INDEX TO X-MMQ5-VI
148300             MOVE X-WS-TEMP-INDEX
148400                                 TO MB21WS-NAME (X-WS-INDEX:2)
148500             ADD 2               TO X-WS-INDEX
148600             SET X-WS-MON-INDEX  TO X-MMQ5-VI-MON
148700             MOVE X-WS-MON-INDEX
148800                                 TO MB21WS-NAME (X-WS-INDEX:2)
148900             ADD 2               TO X-WS-INDEX
149000             MOVE ')'            TO MB21WS-NAME (X-WS-INDEX:1)
149100             SET WS-END-OF-PERFORM
149200                                 TO TRUE
149300         END-IF
149400     END-PERFORM.
149500     MOVE MMQ5-VI-INT-OUT-NBR-MAN-CA (X-MMQ5-VI X-MMQ5-VI-MON)
149600                                 TO MB21WS-9V0Z.
149700     PERFORM MB21PD-INSERT-A-COLUMN
149800                                 THRU MB21PD-IAC-EXIT.
149900*
150000     MOVE 'VI-INT-OUT-AMT-MAN-CA' TO MB21WS-NAME.
150100     SET WS-NOT-END-OF-PERFORM   TO TRUE
150200     PERFORM
150300         VARYING X-WS-INDEX
150400         FROM 30 BY -1
150500         UNTIL X-WS-INDEX IS EQUAL TO 1
150600         OR WS-END-OF-PERFORM
150700         IF  MB21WS-NAME (X-WS-INDEX:1)
150800                                 IS NOT EQUAL TO SPACES
150900             ADD 1               TO X-WS-INDEX
151000             MOVE '('            TO MB21WS-NAME (X-WS-INDEX:1)
151100             ADD 1               TO X-WS-INDEX
151200             SET X-WS-TEMP-INDEX TO X-MMQ5-VI
151300             MOVE X-WS-TEMP-INDEX
151400                                 TO MB21WS-NAME (X-WS-INDEX:2)
151500             ADD 2               TO X-WS-INDEX
151600             SET X-WS-MON-INDEX  TO X-MMQ5-VI-MON
151700             MOVE X-WS-MON-INDEX
151800                                 TO MB21WS-NAME (X-WS-INDEX:2)
151900             ADD 2               TO X-WS-INDEX
152000             MOVE ')'            TO MB21WS-NAME (X-WS-INDEX:1)
152100             SET WS-END-OF-PERFORM
152200                                 TO TRUE
152300         END-IF
152400     END-PERFORM.
152500     MOVE MMQ5-VI-INT-OUT-AMT-MAN-CA (X-MMQ5-VI X-MMQ5-VI-MON)
152600                                 TO MB21WS-15V2.
152700     PERFORM MB21PD-INSERT-A-COLUMN
152800                                 THRU MB21PD-IAC-EXIT.
152900*
153000     MOVE 'VI-INT-OUT-NBR-ATM'   TO MB21WS-NAME.
153100     SET WS-NOT-END-OF-PERFORM   TO TRUE
153200     PERFORM
153300         VARYING X-WS-INDEX
153400         FROM 30 BY -1
153500         UNTIL X-WS-INDEX IS EQUAL TO 1
153600         OR WS-END-OF-PERFORM
153700         IF  MB21WS-NAME (X-WS-INDEX:1)
153800                                 IS NOT EQUAL TO SPACES
153900             ADD 1               TO X-WS-INDEX
154000             MOVE '('            TO MB21WS-NAME (X-WS-INDEX:1)
154100             ADD 1               TO X-WS-INDEX
154200             SET X-WS-TEMP-INDEX TO X-MMQ5-VI
154300             MOVE X-WS-TEMP-INDEX
154400                                 TO MB21WS-NAME (X-WS-INDEX:2)
154500             ADD 2               TO X-WS-INDEX
154600             SET X-WS-MON-INDEX  TO X-MMQ5-VI-MON
154700             MOVE X-WS-MON-INDEX
154800                                 TO MB21WS-NAME (X-WS-INDEX:2)
154900             ADD 2               TO X-WS-INDEX
155000             MOVE ')'            TO MB21WS-NAME (X-WS-INDEX:1)
155100             SET WS-END-OF-PERFORM
155200                                 TO TRUE
155300         END-IF
155400     END-PERFORM.
155500     MOVE MMQ5-VI-INT-OUT-NBR-ATM (X-MMQ5-VI X-MMQ5-VI-MON)
155600                                 TO MB21WS-9V0Z.
155700     PERFORM MB21PD-INSERT-A-COLUMN
155800                                 THRU MB21PD-IAC-EXIT.
155900*
156000     MOVE 'VI-INT-OUT-AMT-ATM'   TO MB21WS-NAME.
156100     SET WS-NOT-END-OF-PERFORM   TO TRUE
156200     PERFORM
156300         VARYING X-WS-INDEX
156400         FROM 30 BY -1
156500         UNTIL X-WS-INDEX IS EQUAL TO 1
156600         OR WS-END-OF-PERFORM
156700         IF  MB21WS-NAME (X-WS-INDEX:1)
156800                                 IS NOT EQUAL TO SPACES
156900             ADD 1               TO X-WS-INDEX
157000             MOVE '('            TO MB21WS-NAME (X-WS-INDEX:1)
157100             ADD 1               TO X-WS-INDEX
157200             SET X-WS-TEMP-INDEX TO X-MMQ5-VI
157300             MOVE X-WS-TEMP-INDEX
157400                                 TO MB21WS-NAME (X-WS-INDEX:2)
157500             ADD 2               TO X-WS-INDEX
157600             SET X-WS-MON-INDEX  TO X-MMQ5-VI-MON
157700             MOVE X-WS-MON-INDEX
157800                                 TO MB21WS-NAME (X-WS-INDEX:2)
157900             ADD 2               TO X-WS-INDEX
158000             MOVE ')'            TO MB21WS-NAME (X-WS-INDEX:1)
158100             SET WS-END-OF-PERFORM
158200                                 TO TRUE
158300         END-IF
158400     END-PERFORM.
158500     MOVE MMQ5-VI-INT-OUT-AMT-ATM (X-MMQ5-VI X-MMQ5-VI-MON)
158600                                 TO MB21WS-15V2.
158700     PERFORM MB21PD-INSERT-A-COLUMN
158800                                 THRU MB21PD-IAC-EXIT.
158900*
159000     IF  X-MMQ5-VI-MON IS EQUAL TO 3
159100         PERFORM MB21PD-INSERT-A-COLUMN
159200                                 THRU MB21PD-IAC-EXIT 2 TIMES
159300     ELSE
159400         PERFORM MB21PD-INSERT-A-COLUMN
159500                                 THRU MB21PD-IAC-EXIT.
159600*
159700     IF  X-MMQ5-VI-MON IS LESS THAN 3
159800         SET X-MMQ5-VI-MON UP BY 1
159900         GO TO B110-LOOP.
160000*
160100*
160200     IF  X-MMQ5-VI IS LESS THAN 4
160300         SET X-MMQ5-VI   UP BY 1
160400         GO TO B100-LOOP.
160500*
160600 B999-PRT-EXIT.
160700     EXIT.
160800*
160900 B200-PRINT-HEADER.
161000*
161100     MOVE 'ORG HEADER RECORD(MMQ5)'
161200                                 TO MB21WS-NAME.
161300     PERFORM MB21PD-INSERT-A-COLUMN
161400                                 THRU MB21PD-IAC-EXIT.
161500*
161600     MOVE SPACES                 TO MB21WS-PRINT-WORK-AREA.
161700     MOVE 'ORG'                  TO MB21WS-NAME.
161800     MOVE MMQ5IO-ORG             TO MB21WS-3V0.
161900     PERFORM MB21PD-INSERT-A-COLUMN
162000                                 THRU MB21PD-IAC-EXIT.
162100*
162200     MOVE 'DATE-STAMP'           TO MB21WS-NAME.
162300     MOVE MMQ5IO-DATE-STAMP      TO SS01WS-JULIAN.
162400     PERFORM SS08PD-JUL-TO-GREG  THRU SS08PD-JTG-EXIT.
162500     MOVE MMQ5IO-DATE-STAMP      TO MB21WS-JULIAN.
162600     MOVE SS01WS-DATE-L6         TO MB21WS-GREG.
162700     INSPECT MB21WS-JULIAN       REPLACING ALL ',' BY '-'.
162800     PERFORM MB21PD-INSERT-A-COLUMN
162900                                 THRU MB21PD-IAC-EXIT.
163000*
163100     MOVE 'TIME-STAMP'           TO MB21WS-NAME.
163200     MOVE MMQ5IO-TIME-STAMP      TO MB21WS-TIME.
163300     INSPECT MB21WS-TIME         REPLACING ALL SPACE BY '.'.
163400     PERFORM MB21PD-INSERT-A-COLUMN
163500                                 THRU MB21PD-IAC-EXIT.
163600*
163700     PERFORM MB21PD-PRINT-A-PAGE
163800                                 THRU MB21PD-PAP-EXIT.
163900*
164000 B200-PH-EXIT.
164100     EXIT.
164200/
164300* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
164400*                          COMMON ROUTINES                      *
164500* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
164600*
164700     COPY SS02PD.
164800/
164900     COPY SS08PD.
165000/
165100     COPY SS16PD.
165200/
165300     COPY SS26PD.
165400/
165500     COPY SS27PD.
165600/
165700     COPY MB20PD.
165800/
165900     COPY MB21PD.
166000/
166100     COPY MB99PD.
166200/
166300     COPY MB00PD REPLACING ==:MB00:== BY ==MTCC==.
166400/
166500     COPY MB00PD REPLACING ==:MB00:== BY ==MMQ5==.
166600/
166700     COPY MB00PD REPLACING ==:MB00:== BY ==MMSC==.
166800/
166900     COPY MB00PD REPLACING ==:MB00:== BY ==MBMF==.
