000100 IDENTIFICATION DIVISION.
000200 PROGRAM-ID. MMD3AB.
000201*       RELEASE DATE=08/24/01.        REVISION LEVEL=08.06      * ++++++++
000202***************************************************************** ++++++++
000203*WARNING.  THIS COMPUTER PROGRAM IS PROTECTED BY COPYRIGHT LAW  * ++++++++
000204*AND INTERNATIONAL TREATIES.  UNAUTHORIZED REPRODUCTION OR      * ++++++++
000205*DISTRIBUTION OF THIS PROGRAM, OR ANY PORTION OF IT, MAY RESULT * ++++++++
000206*IN SEVERE CIVIL AND CRIMINAL PENATLIES, AND WILL BE PROSECUTED * ++++++++
000207*TO THE MAXIMUM EXTENT POSSIBLE UNDER THE LAW.                  * ++++++++
000208*COPYRIGHT 1999 PAYSYS INTERNATIONAL, INC.  ALL RIGHTS RESERVED.* ++++++++
000209***************************************************************** ++++++++
000300*
000400******************************************************************
000500*                                                                *
000600*    ---------------MERCHANT BANKCARD SYSTEM---------------      *
000700*                                                                *
000800*          MMD3AB - MMD3 FILE COMMON BATCH I/O ROUTINE           *
000900*                                                                *
001000*                 VARIABLE LENGTH VSAM FILE                      *
001100*                                                                *
001200*    --------------DEPOSIT HISTORY FILE 3------------------      *
001300*                                                                *
001400******************************************************************
001500*                                                                *
001600*    COPYBOOKS WHICH MUST APPEAR IN YOUR BATCH PROGRAM:          *
001700*                                                                *
001800*    (WS) MB00RB - BATCH REQUEST BLOCK                           *
001900*    (WS) MMD3IO - I/O AREA                                      *
002000*    (WS) SS02WS - STANDARD ABEND ROUTINE WORK AREA              *
002100*    (PD) MB00PD - PROCEDURE DIVISION CALL STATEMENT             *
002200*                                                                *
002300******************************************************************
002400*                                                                *
002500*    TO USE THIS ROUTINE.........                                *
002600*                                                                *
002700* 1. HOUSEKEEPING DUTIES:                                        *
002800*                                                                *
002900*    A. IN THE HOUSEKEEPING SECTION OF YOUR PROGRAM, MOVE THE    *
003000*       NAME OF THE PROGRAM USING THIS ROUTINE TO THE FIELD      *
003100*       'SS02WS-ABEND-PROG-ID'. THIS FIELD IS USED AS PART OF THE*
003200*       STANDARD ABEND MESSAGES IF A PROGRAM ABORTS WITHIN THIS  *
003300*       ACCESS ROUTINE.  IF THE FIELD 'SS02WS-ABEND-PROG-ID' IS  *
003400*       LEFT BLANK, THIS ROUTINE WILL FORCE AN ABEND SITUATION.  *
003500*                                                                *
003600*    B. BEFORE PERFORMING THE ACCESS ROUTINE, MOVE A LITERAL TO  *
003700*       THE FIELD 'SS02WS-ABEND-LOCATION'. THIS FIELD CAN BE USED*
003800*       TO INDICATE WHERE THE ROUTINE IS BEING 'FROM' IN CASE    *
003900*       OF ABNORMAL TERMINATION. (E.G. DEBUGGING ASSISTANCE)     *
004000*                                                                *
004100*    C. SET THE RETURN CODES WHICH YOU WANT, FOR THE DURATION    *
004200*       OF THIS PROGRAM, TO BE CONSIDERED VALID IN THE FIELDS    *
004300*       'MMD3RB-PERM-STATUS-1 TO -5'. THESE FIELDS ARE INITIAL-  *
004400*       IZED TO ZERO (AS ZERO IS ALWAYS AN ACCEPTABLE RETURN     *
004500*       CODE).  THIS ROUTINE WILL (IN ALL I-O REQUESTS) SUCCESS- *
004600*       FULLY SATISFY YOUR PERFORM REQUEST IF ANY OF THE REQUESTS*
004700*       ENCOUNTER ANY OF THE PERMANENT STATUS CODES 1-5.         *
004800*                                                                *
004900* 2. SET ONE OF THE FOLLOWING CONDITION NAMES TO 'TRUE' TO SET   *
005000*    THE FILE REQUEST:                                           *
005100*                                                                *
005200*        CONDITION NAME                EXPLANATION               *
005300*   *----------------------***---------------------------------* *
005400*                                                                *
005500*    MMD3RB-OPEN-INPUT      - OPEN THE FILE AS INPUT WITH        *
005600*                             SEQUENTIAL ACCESS.                 *
005700*    MMD3RB-OPEN-OUTPUT     - OPEN THE FILE AS OUTPUT WITH       *
005800*                             SEQUENTIAL ACCESS.                 *
005900*    MMD3RB-OPEN-IO         - OPEN THE FILE AS I-O WITH          *
006000*                             SEQUENTIAL ACCESS.                 *
006100*    MMD3RB-OPEN-INPUT-DYN  - OPEN THE FILE AS INPUT WITH        *
006200*                             DYNAMIC ACCESS.                    *
006300*    MMD3RB-OPEN-OUTPUT-DYN - OPEN THE FILE AS OUTPUT WITH       *
006400*                             DYNAMIC ACCESS.                    *
006500*    MMD3RB-OPEN-IO-DYN     - OPEN THE FILE AS I-O WITH          *
006600*                             DYNAMIC ACCESS.                    *
006700*    MMD3RB-OPEN-INPUT-RDM  - OPEN THE FILE AS INPUT WITH        *
006800*                             RANDOM ACCESS.                     *
006900*    MMD3RB-OPEN-OUTPUT-RDM - OPEN THE FILE AS OUTPUT WITH       *
007000*                             RANDOM ACCESS.                     *
007100*    MMD3RB-OPEN-IO-RDM     - OPEN THE FILE AS I-O WITH          *
007200*                             RANDOM ACCESS.                     *
007300*    MMD3RB-START-GTE       - START THE FILE WIOTH A KEY         *
007400*                             > OR            = THE        KEY   *
007500*                             CONTAINED IN 'MMD3IO-KEY'.         *
007600*    MMD3RB-START-EQUAL     - START THE FILE WITH A KEY =        *
007700*                             TO THE KEY CONTAINED IN            *
007800*                             'MMD3IO-KEY'.                      *
007900*    MMD3RB-READ-SEQ        - READ THE NEXT SEQUENTIAL RECORD    *
008000*                             IN THE FILE.                       *
008100*    MMD3RB-READ-RANDOM     - READ THE RECORD IN THE FILE        *
008200*                             CORRESPONDING TO THE KEY CONTAINED *
008300*                             IN 'MMD3IO-KEY'.                   *
008400*    MMD3RB-WRITE           - WRITE A RECORD (THE RECORD MUST    *
008500*                             BE IN 'MMD3IO-RECORD').            *
008600*    MMD3RB-REWRITE         - REWRITE A RECORD (THE RECORD MUST  *
008700*                             BE IN 'MMD3IO-RECORD').            *
008800*    MMD3RB-DELETE          - DELETE THE RECORD IN THE FILE      *
008900*                             CORRESPONDING TO THE KEY CONTAINED *
009000*                             IN 'MMD3IO-KEY'.                   *
009100*    MMD3RB-CLOSE           - CLOSE THE FILE.                    *
009200*                                                                *
009300* 3. SET ONE OR BOTH OF THE 'TEMPORARY' RETURN CODE FIELDS       *
009400*    'MMD3RB-TEMP-STATUS-1 AND -2'.  THESE TWO RETURN CODES      *
009500*    ARE TO BE USED ON A PER USE BASIS OF THIS ROUTINE.          *
009600*    THESE TWO RETURN CODES ARE INITIALIZED TO ZERO AND ARE      *
009700*    BOTH RESET TO ZERO AFTER EACH CALL OF THIS PROGRAM.         *
009800*    THE TEMPORARY RETURN CODE FIELDS ARE CHECKED FIRST AND      *
009900*    THEN THE PERMANENT RETURN CODES (POINT 1.C ABOVE) WILL      *
010000*    BE CHECKED.                                                 *
010100*                                                                *
010200* 4. PERFORM MB00PD-MMD3-ACCESS THRU MB00PD-MMD3-ACCESS-EXIT.    *
010300*                                                                *
010400*    A. YOU MUST HANDLE MANUALLY ANY RETURN CODE (EITHER TEMP    *
010500*       OR PERM) THAT YOU REQUESTED, AND IF NEEDED, YOUR OWN     *
010600*       ABEND REQUEST.                                           *
010700*                                                                *
010800*    B. ALL ACCESS ROUTINES MOVE THE FILE STATUS TO THE FIELD    *
010900*       SS02WS-FILE-STATUS IN COPYBOOK SS02WS. USE THE '88' LEVEL*
011000*       NAMES TO TEST YOUR MANUAL STATUS CHECKS.  ALSO IN COPY   *
011100*       BOOK SS02WS, USE THE 'WS-' FILE STATUS DATA NAMES WHEN   *
011200*       SETTING THE PERM OR TEMP FILE STATUS CODES PRIOR TO      *
011300*       PERFORMING THE ACCESS ROUTINE.  FOR VSAM FILES, THE VSAM *
011400*       RETURN CODE IS MOVED TO THE FIELD 'SS02WS-FILE-RETURN' IN*
011500*       COPYBOOK SS02WS.                                         *
011600*                                                                *
011700******************************************************************
011800/
011900 ENVIRONMENT DIVISION.
012000*
012100 CONFIGURATION SECTION.
012200 SOURCE-COMPUTER.            IBM-4341.
012300 OBJECT-COMPUTER.            IBM-4341.
012400*
012500 INPUT-OUTPUT SECTION.
012600*
012700 FILE-CONTROL.
012800*
012900     SELECT  MMD3-FILE-SEQ
013000             ASSIGN TO MMD3
013100             ORGANIZATION IS INDEXED
013200             ACCESS       IS SEQUENTIAL
013300             FILE STATUS  IS WS-STATUS
013400                             WS-RETURN
013500             RECORD KEY   IS MMD3-SEQ-KEY.
013600*
013700     SELECT  MMD3-FILE-DYN
013800             ASSIGN TO MMD3
013900             ORGANIZATION IS INDEXED
014000             ACCESS       IS DYNAMIC
014100             FILE STATUS  IS WS-STATUS
014200                             WS-RETURN
014300             RECORD KEY   IS MMD3-DYN-KEY.
014400*
014500     SELECT  MMD3-FILE-RDM
014600             ASSIGN TO MMD3
014700             ORGANIZATION IS INDEXED
014800             ACCESS       IS RANDOM
014900             FILE STATUS  IS WS-STATUS
015000                             WS-RETURN
015100             RECORD KEY   IS MMD3-RDM-KEY.
015200*
015300 I-O-CONTROL.
015400*
015500     SAME AREA FOR
015600         MMD3-FILE-SEQ
015700         MMD3-FILE-DYN
015800         MMD3-FILE-RDM.
015900/
016000 DATA DIVISION.
016100*
016200 FILE SECTION.
016300*
016400***********************
016500*    SEQUENTIAL FD    *
016600***********************
016700*
016800 FD  MMD3-FILE-SEQ
016900     RECORD CONTAINS 273 TO 350 CHARACTERS.
017000*
017100 01  MMD3-SEQ-MAX-RECORD.
017200     03  MMD3-SEQ-MAX-KEY    PIC  X(35).
017300     03  MMD3-SEQ-MAX-DATA   PIC  X(315).
017400*
017500 01  MMD3-SEQ-RECORD.
017600     03  MMD3-SEQ-KEY        PIC  X(35).
017700     03  MMD3-SEQ-DATA       PIC  X(237).
017800     03  MMD3-SEQ-VAR-IND    PIC  9(01).
017900         88  MMD3-SEQ-VDI-NOT-PRESENT        VALUE ZERO.
018000         88  MMD3-SEQ-VDI-DEPOSIT-DATA       VALUE 1.
018100         88  MMD3-SEQ-VDI-FEE-DATA           VALUE 2.
018200         88  MMD3-SEQ-VDI-HEADER-DATA        VALUE 3.
018300     03  MMD3-SEQ-VAR-DATA                   OCCURS 0 TO 77 TIMES
018400                                             DEPENDING ON
018500                                             WS-DATA-LENGTH.
018600         05  MMD3-SEQ-VD-BYTE
018700                             PIC  X(01).
018800*
018900********************
019000*    DYNAMIC FD    *
019100********************
019200*
019300 FD  MMD3-FILE-DYN
019400     RECORD CONTAINS 273 TO 350 CHARACTERS.
019500*
019600 01  MMD3-DYN-MAX-RECORD.
019700     03  MMD3-DYN-MAX-KEY    PIC  X(35).
019800     03  MMD3-DYN-MAX-DATA   PIC  X(315).
019900*
020000 01  MMD3-DYN-RECORD.
020100     03  MMD3-DYN-KEY        PIC  X(35).
020200     03  MMD3-DYN-DATA       PIC  X(237).
020300     03  MMD3-DYN-VAR-IND    PIC  9(01).
020400         88  MMD3-DYN-VDI-NOT-PRESENT        VALUE ZERO.
020500         88  MMD3-DYN-VDI-DEPOSIT-DATA       VALUE 1.
020600         88  MMD3-DYN-VDI-FEE-DATA           VALUE 2.
020700         88  MMD3-DYN-VDI-HEADER-DATA        VALUE 3.
020800     03  MMD3-DYN-VAR-DATA   PIC  X(01)      OCCURS 0 TO 77 TIMES
020900                                             DEPENDING ON
021000                                             WS-DATA-LENGTH.
021100*
021200*******************
021300*    RANDOM FD    *
021400*******************
021500*
021600 FD  MMD3-FILE-RDM
021700     RECORD CONTAINS 273 TO 350 CHARACTERS.
021800*
021900 01  MMD3-RDM-MAX-RECORD.
022000     03  MMD3-RDM-MAX-KEY    PIC  X(35).
022100     03  MMD3-RDM-MAX-DATA   PIC  X(315).
022200*
022300 01  MMD3-RDM-RECORD.
022400     03  MMD3-RDM-KEY        PIC  X(35).
022500     03  MMD3-RDM-DATA       PIC  X(237).
022600     03  MMD3-RDM-VAR-IND    PIC  9(01).
022700         88  MMD3-RDM-VDI-NOT-PRESENT        VALUE ZERO.
022800         88  MMD3-RDM-VDI-DEPOSIT-DATA       VALUE 1.
022900         88  MMD3-RDM-VDI-FEE-DATA           VALUE 2.
023000         88  MMD3-RDM-VDI-HEADER-DATA        VALUE 3.
023100     03  MMD3-RDM-VAR-DATA   PIC  X(01)      OCCURS 0 TO 77 TIMES
023200                                             DEPENDING ON
023300                                             WS-DATA-LENGTH.
023400/
023500 WORKING-STORAGE SECTION.
023600*
023700 01  FILLER                  PIC  X(12)      VALUE '** WS-BEG **'.
023800*
023900 01  FILLER                  PIC  X(24)      VALUE
024000     'ACCESS METHOD INDICATOR:'.
024100*
024200 01  WS-ACCESS-METHOD        PIC  X(01)      VALUE SPACE.
024300     88  ACCESS-METHOD-NOT-SET               VALUE SPACE.
024400     88  ACCESS-IS-SEQUENTIAL                VALUE 'S'.
024500     88  ACCESS-IS-DYNAMIC                   VALUE 'D'.
024600     88  ACCESS-IS-RANDOM                    VALUE 'R'.
024700*
024800 01  FILLER                  PIC  X(12)      VALUE
024900     'FILE STATUS:'.
025000*
025100 01  WS-STATUS               PIC  X(02)      VALUE ZERO.
025200*
025300 01  FILLER                  PIC  X(16)      VALUE
025400     'EXTENDED RETURN:'.
025500*
025600 01  WS-RETURN.
025700     03  WS-RETURN-CODE      PIC 9(02)       BINARY
025800                                             VALUE ZERO.
025900     03  WS-FUNCTION-CODE    PIC 9(02)       BINARY
026000                                             VALUE ZERO.
026100     03  WS-FEEDBACK-CODE    PIC 9(02)       BINARY
026200                                             VALUE ZERO.
026300*
026400 01  FILLER                  PIC  X(12)      VALUE
026500     'I-O REQUEST:'.
026600*
026700 01  WS-IO-REQUEST           PIC  9(02)      VALUE ZERO.
026800*
026900 01  FILLER                  PIC  X(28)      VALUE
027000     'PROCESSING SUMMARY COUNTERS:'.
027100*
027200 01  WS-SUMMARY-COUNTERS.
027300     03  WS-SC-READS         PIC S9(09)      PACKED-DECIMAL
027400                                             VALUE ZERO.
027500     03  WS-SC-WRITES        PIC S9(09)      PACKED-DECIMAL
027600                                             VALUE ZERO.
027700     03  WS-SC-REWRITES      PIC S9(09)      PACKED-DECIMAL
027800                                             VALUE ZERO.
027900     03  WS-SC-DELETES       PIC S9(09)      PACKED-DECIMAL
028000                                             VALUE ZERO.
028100*
028200 01  FILLER                  PIC  X(27)      VALUE
028300     'PROCESSING SUMMARY MESSAGE:'.
028400*
028500 01  WS-SUMMARY-MESSAGE.
028600     03  FILLER              PIC  X(10)      VALUE '(PGMSTAT) '.
028700     03  WS-SM-PROG-ID       PIC  X(06)      VALUE SPACES.
028800     03  FILLER              PIC  X(03)      VALUE ' - '.
028900     03  WS-SM-FILE-ID       PIC  X(04)      VALUE 'MMD3'.
029000     03  FILLER              PIC  X(11)      VALUE ' - OPENED: '.
029100     03  WS-SM-ACCESS        PIC  X(03)      VALUE SPACES.
029200     03  FILLER              PIC  X(01)      VALUE SPACE.
029300     03  WS-SM-OPENED        PIC  X(06)      VALUE SPACES.
029400     03  FILLER              PIC  X(01)      VALUE SPACE.
029500     03  WS-SM-READS         PIC  ZZZZZZZZ9.
029600     03  FILLER              PIC  X(08)      VALUE ' READS, '.
029700     03  WS-SM-WRITES        PIC  ZZZZZZZZ9.
029800     03  FILLER              PIC  X(09)      VALUE ' WRITES, '.
029900     03  WS-SM-REWRITES      PIC  ZZZZZZZZ9.
030000     03  FILLER              PIC  X(11)      VALUE ' REWRITES, '.
030100     03  WS-SM-DELETES       PIC  ZZZZZZZZ9.
030200     03  FILLER              PIC  X(08)      VALUE ' DELETES'.
030300*
030400 01  WS-DATA-LENGTH          PIC S9(08)      BINARY
030500                                             VALUE ZERO.
030600/
030700     COPY MMD3RL REPLACING ==:MMD3:== BY ==MMD3==.
030800/
030900     COPY SS00WS.
031000*
031100 01  FILLER                  PIC  X(12)      VALUE '** WS-END **'.
031200/
031300 LINKAGE SECTION.
031400*
031500****************************
031600*    FILE REQUEST BLOCK    *
031700****************************
031800*
031900     COPY MB00RB REPLACING ==:MB00:== BY ==MMD3==.
032000*
032100******************
032200*    I/O AREA    *
032300******************
032400*
032500     COPY MMD3IO REPLACING ==:MMD3:== BY ==MMD3==.
032600*
032700*********************************
032800*    ABEND ROUTINE WORK AREA    *
032900*********************************
033000*
033100     COPY SS02WS.
033200/
033300 PROCEDURE DIVISION          USING MMD3RB-WORK-AREA,
033400                                   MMD3IO-RECORD,
033500                                   SS02WS-ABEND-WORK-AREA.
033600*
033700 A000-MAIN-LINE-SECTION.
033800*
033900*
034000***************************************************
034100*    SET THE ACCESS METHOD AND ABEND WORK AREA    *
034200*    IF THIS IS THE FIRST CALL OF THIS PROGRAM    *
034300***************************************************
034400*
034500     IF  ACCESS-METHOD-NOT-SET
034600         PERFORM Z000-PROGRAM-INITIALIZATION
034700            THRU Z099-PI-EXIT.
034800*
034900**************************************************************
035000*    PROCESS THE FILE DEPENDING OF THE PROCESSING OPTION.    *
035100**************************************************************
035200*
035300     IF  ACCESS-IS-SEQUENTIAL
035400         PERFORM S000-SEQUENTIAL-ACCESS
035500            THRU S999-SA-EXIT
035600     ELSE
035700         IF  ACCESS-IS-DYNAMIC
035800             PERFORM D000-DYNAMIC-ACCESS
035900                THRU D999-DA-EXIT
036000         ELSE
036100             PERFORM R000-RANDOM-ACCESS
036200                THRU R999-RA-EXIT.
036300*
036400*****************************************************
036500*    MOVE THE STATUS CODE AND RETURN CODE TO        *
036600*    THEIR RESPECTIVE FIELDS IN COPYBOOK SS02WS.    *
036700*****************************************************
036800*
036900     MOVE MMD3RB-STATUS          TO SS02WS-FILE-STATUS.
037000     MOVE MMD3RB-RETURN          TO SS02WS-FILE-RETURN.
037100*
037200 A999-GOBACK.
037300*
037400     GOBACK.
037500/
037600 D000-DYNAMIC-ACCESS.
037700*
037800     GO TO D100-DA-INVALID-REQUEST
037900           D100-DA-INVALID-REQUEST
038000           D100-DA-INVALID-REQUEST
038100           D110-DA-OPEN-INPUT
038200           D120-DA-OPEN-OUTPUT
038300           D130-DA-OPEN-I-O
038400           D100-DA-INVALID-REQUEST
038500           D100-DA-INVALID-REQUEST
038600           D100-DA-INVALID-REQUEST
038700           D140-DA-START-GTE
038800           D150-DA-START-EQUAL
038900           D160-DA-READ-SEQ
039000           D170-DA-READ-RANDOM
039100           D180-DA-WRITE
039200           D190-DA-REWRITE
039300           D200-DA-DELETE
039400           D210-DA-CLOSE
039500           DEPENDING ON MMD3RB-IO-REQUEST.
039600*
039700 D100-DA-INVALID-REQUEST.
039800*
039900     MOVE MMD3RB-IO-REQUEST      TO SS02WS-ABEND-REQUEST.
040000     MOVE '- BAD I-O REQ - MMD3' TO SS02WS-ABENDMSG8.
040100     GO TO Z950-ABORT.
040200*
040300 D110-DA-OPEN-INPUT.
040400*
040500     OPEN INPUT MMD3-FILE-DYN.
040600*
040700     IF  WS-STATUS IS EQUAL TO '97'
040800         MOVE '97'               TO MMD3RB-OPEN-STATUS
040900         MOVE LOW-VALUES         TO WS-RETURN
041000         MOVE ZEROS              TO WS-STATUS.
041100*
041200     MOVE 'DYN'                  TO WS-SM-ACCESS.
041300     MOVE 'INPUT'                TO WS-SM-OPENED.
041400     MOVE '- OPEN  ERROR - MMD3' TO SS02WS-ABENDMSG8.
041500     GO TO D900-DA-CHECK-STATUS.
041600*
041700 D120-DA-OPEN-OUTPUT.
041800*
041900     OPEN OUTPUT MMD3-FILE-DYN.
042000*
042100     IF  WS-STATUS IS EQUAL TO '97'
042200         MOVE '97'               TO MMD3RB-OPEN-STATUS
042300         MOVE LOW-VALUES         TO WS-RETURN
042400         MOVE ZEROS              TO WS-STATUS.
042500*
042600     MOVE 'DYN'                  TO WS-SM-ACCESS.
042700     MOVE 'OUTPUT'               TO WS-SM-OPENED.
042800     MOVE '- OPEN  ERROR - MMD3' TO SS02WS-ABENDMSG8.
042900     GO TO D900-DA-CHECK-STATUS.
043000*
043100 D130-DA-OPEN-I-O.
043200*
043300     OPEN I-O MMD3-FILE-DYN.
043400*
043500     MOVE 'DYN'                  TO WS-SM-ACCESS.
043600     MOVE 'I-O'                  TO WS-SM-OPENED.
043700     MOVE '- OPEN  ERROR - MMD3' TO SS02WS-ABENDMSG8.
043800     GO TO D900-DA-CHECK-STATUS.
043900*
044000 D140-DA-START-GTE.
044100*
044200     MOVE MMD3IO-KEY             TO MMD3-DYN-KEY.
044300     START MMD3-FILE-DYN
044400           KEY IS NOT LESS THAN MMD3-DYN-KEY.
044500*
044600     MOVE '- START ERROR - MMD3' TO SS02WS-ABENDMSG8.
044700     GO TO D900-DA-CHECK-STATUS.
044800*
044900 D150-DA-START-EQUAL.
045000*
045100     MOVE MMD3IO-KEY             TO MMD3-DYN-KEY.
045200     START MMD3-FILE-DYN
045300           KEY IS EQUAL TO MMD3-DYN-KEY.
045400*
045500     MOVE '- START ERROR - MMD3' TO SS02WS-ABENDMSG8.
045600     GO TO D900-DA-CHECK-STATUS.
045700*
045800 D160-DA-READ-SEQ.
045900*
046000     READ MMD3-FILE-DYN NEXT RECORD
046100                                 INTO MMD3IO-RECORD.
046200*
046300     ADD 1                       TO WS-SC-READS.
046400     MOVE '- READ  ERROR - MMD3' TO SS02WS-ABENDMSG8.
046500     GO TO D900-DA-CHECK-STATUS.
046600*
046700 D170-DA-READ-RANDOM.
046800*
046900     MOVE MMD3IO-KEY             TO MMD3-DYN-KEY.
047000     READ MMD3-FILE-DYN          INTO MMD3IO-RECORD.
047100*
047200     ADD 1                       TO WS-SC-READS.
047300     MOVE '- READ  ERROR - MMD3' TO SS02WS-ABENDMSG8.
047400     GO TO D900-DA-CHECK-STATUS.
047500*
047600 D180-DA-WRITE.
047700*
047800     MOVE MMD3IO-RECORD          TO MMD3-DYN-MAX-RECORD.
047900*
048000     EVALUATE TRUE
048100         WHEN MMD3-DYN-VAR-IND IS NOT NUMERIC
048200             MOVE ZERO           TO MMD3-DYN-VAR-IND
048300             MOVE ZERO           TO WS-DATA-LENGTH
048400         WHEN MMD3-DYN-VDI-DEPOSIT-DATA
048500             MOVE LENGTH OF MMD3-VD-DEPOSIT-DATA
048600                                 TO WS-DATA-LENGTH
048700         WHEN MMD3-DYN-VDI-FEE-DATA
048800             MOVE LENGTH OF MMD3-VD-FEE-AREA
048900                                 TO WS-DATA-LENGTH
049000         WHEN MMD3-DYN-VDI-HEADER-DATA
049100             MOVE LENGTH OF MMD3-VD-HEADER-TOTALS
049200                                 TO WS-DATA-LENGTH
049300         WHEN OTHER
049400             MOVE ZERO           TO MMD3-DYN-VAR-IND
049500             MOVE ZERO           TO WS-DATA-LENGTH
049600     END-EVALUATE.
049700*
049800     WRITE MMD3-DYN-RECORD.
049900*
050000     ADD 1                       TO WS-SC-WRITES.
050100     MOVE '- WRITE ERROR - MMD3' TO SS02WS-ABENDMSG8.
050200     GO TO D900-DA-CHECK-STATUS.
050300*
050400 D190-DA-REWRITE.
050500*
050600     MOVE MMD3IO-RECORD          TO MMD3-DYN-MAX-RECORD.
050700*
050800     EVALUATE TRUE
050900         WHEN MMD3-DYN-VAR-IND IS NOT NUMERIC
051000             MOVE ZERO           TO MMD3-DYN-VAR-IND
051100             MOVE ZERO           TO WS-DATA-LENGTH
051200         WHEN MMD3-DYN-VDI-DEPOSIT-DATA
051300             MOVE LENGTH OF MMD3-VD-DEPOSIT-DATA
051400                                 TO WS-DATA-LENGTH
051500         WHEN MMD3-DYN-VDI-FEE-DATA
051600             MOVE LENGTH OF MMD3-VD-FEE-AREA
051700                                 TO WS-DATA-LENGTH
051800         WHEN MMD3-DYN-VDI-HEADER-DATA
051900             MOVE LENGTH OF MMD3-VD-HEADER-TOTALS
052000                                 TO WS-DATA-LENGTH
052100         WHEN OTHER
052200             MOVE ZERO           TO MMD3-DYN-VAR-IND
052300             MOVE ZERO           TO WS-DATA-LENGTH
052400     END-EVALUATE.
052500*
052600     REWRITE MMD3-DYN-RECORD.
052700*
052800     ADD 1                       TO WS-SC-REWRITES.
052900     MOVE '- REWRT ERROR - MMD3' TO SS02WS-ABENDMSG8.
053000     GO TO D900-DA-CHECK-STATUS.
053100*
053200 D200-DA-DELETE.
053300*
053400     MOVE MMD3IO-KEY             TO MMD3-DYN-KEY.
053500     DELETE MMD3-FILE-DYN RECORD.
053600*
053700     ADD 1                       TO WS-SC-DELETES.
053800     MOVE '- DELET ERROR - MMD3' TO SS02WS-ABENDMSG8.
053900     GO TO D900-DA-CHECK-STATUS.
054000*
054100 D210-DA-CLOSE.
054200*
054300     MOVE SPACE                  TO WS-ACCESS-METHOD.
054400     CLOSE  MMD3-FILE-DYN.
054500*
054600     PERFORM Z100-DISPLAY-THE-SUMMARY
054700        THRU Z199-DTS-EXIT.
054800*
054900     MOVE '- CLOSE ERROR - MMD3' TO SS02WS-ABENDMSG8.
055000     GO TO D900-DA-CHECK-STATUS.
055100*
055200 D900-DA-CHECK-STATUS.
055300*
055400     MOVE WS-STATUS              TO MMD3RB-STATUS.
055500     MOVE WS-RETURN              TO MMD3RB-RETURN.
055600*
055700     IF  MMD3RB-STATUS IS EQUAL  TO MMD3RB-TEMP-STATUS-1   OR
055800         MMD3RB-STATUS IS EQUAL  TO MMD3RB-TEMP-STATUS-2   OR
055900         MMD3RB-STATUS IS EQUAL  TO MMD3RB-PERM-STATUS-1   OR
056000         MMD3RB-STATUS IS EQUAL  TO MMD3RB-PERM-STATUS-2   OR
056100         MMD3RB-STATUS IS EQUAL  TO MMD3RB-PERM-STATUS-3   OR
056200         MMD3RB-STATUS IS EQUAL  TO MMD3RB-PERM-STATUS-4   OR
056300         MMD3RB-STATUS IS EQUAL  TO MMD3RB-PERM-STATUS-5
056400         MOVE ZERO               TO MMD3RB-TEMP-STATUS-1
056500         MOVE ZERO               TO MMD3RB-TEMP-STATUS-2
056600     ELSE
056700         GO TO Z900-ABORT.
056800*
056900 D999-DA-EXIT.
057000     EXIT.
057100/
057200 R000-RANDOM-ACCESS.
057300*
057400     GO TO R100-RA-INVALID-REQUEST
057500           R100-RA-INVALID-REQUEST
057600           R100-RA-INVALID-REQUEST
057700           R100-RA-INVALID-REQUEST
057800           R100-RA-INVALID-REQUEST
057900           R100-RA-INVALID-REQUEST
058000           R110-RA-OPEN-INPUT
058100           R120-RA-OPEN-OUTPUT
058200           R130-RA-OPEN-I-O
058300           R100-RA-INVALID-REQUEST
058400           R100-RA-INVALID-REQUEST
058500           R100-RA-INVALID-REQUEST
058600           R140-RA-READ-RANDOM
058700           R150-RA-WRITE
058800           R160-RA-REWRITE
058900           R170-RA-DELETE
059000           R180-RA-CLOSE
059100           DEPENDING ON MMD3RB-IO-REQUEST.
059200*
059300 R100-RA-INVALID-REQUEST.
059400*
059500     MOVE MMD3RB-IO-REQUEST      TO SS02WS-ABEND-REQUEST.
059600     MOVE '- BAD I-O REQ - MMD3' TO SS02WS-ABENDMSG8.
059700     GO TO Z950-ABORT.
059800*
059900 R110-RA-OPEN-INPUT.
060000*
060100     OPEN INPUT MMD3-FILE-RDM.
060200*
060300     IF  WS-STATUS IS EQUAL TO '97'
060400         MOVE '97'               TO MMD3RB-OPEN-STATUS
060500         MOVE LOW-VALUES         TO WS-RETURN
060600         MOVE ZEROS              TO WS-STATUS.
060700*
060800     MOVE 'RDM'                  TO WS-SM-ACCESS.
060900     MOVE 'INPUT'                TO WS-SM-OPENED.
061000     MOVE '- OPEN  ERROR - MMD3' TO SS02WS-ABENDMSG8.
061100     GO TO R900-RA-CHECK-STATUS.
061200*
061300 R120-RA-OPEN-OUTPUT.
061400*
061500     OPEN OUTPUT MMD3-FILE-RDM.
061600*
061700     IF  WS-STATUS IS EQUAL TO '97'
061800         MOVE '97'               TO MMD3RB-OPEN-STATUS
061900         MOVE LOW-VALUES         TO WS-RETURN
062000         MOVE ZEROS              TO WS-STATUS.
062100*
062200     MOVE 'RDM'                  TO WS-SM-ACCESS.
062300     MOVE 'OUTPUT'               TO WS-SM-OPENED.
062400     MOVE '- OPEN  ERROR - MMD3' TO SS02WS-ABENDMSG8.
062500     GO TO R900-RA-CHECK-STATUS.
062600*
062700 R130-RA-OPEN-I-O.
062800*
062900     OPEN I-O MMD3-FILE-RDM.
063000*
063100     MOVE 'RDM'                  TO WS-SM-ACCESS.
063200     MOVE 'I-O'                  TO WS-SM-OPENED.
063300     MOVE '- OPEN  ERROR - MMD3' TO SS02WS-ABENDMSG8.
063400     GO TO R900-RA-CHECK-STATUS.
063500*
063600 R140-RA-READ-RANDOM.
063700*
063800     MOVE MMD3IO-KEY             TO MMD3-RDM-KEY.
063900     READ MMD3-FILE-RDM          INTO MMD3IO-RECORD.
064000*
064100     ADD 1                       TO WS-SC-READS.
064200     MOVE '- READ  ERROR - MMD3' TO SS02WS-ABENDMSG8.
064300     GO TO R900-RA-CHECK-STATUS.
064400*
064500 R150-RA-WRITE.
064600*
064700     MOVE MMD3IO-RECORD          TO MMD3-RDM-MAX-RECORD.
064800*
064900     EVALUATE TRUE
065000         WHEN MMD3-RDM-VAR-IND IS NOT NUMERIC
065100             MOVE ZERO           TO MMD3-RDM-VAR-IND
065200             MOVE ZERO           TO WS-DATA-LENGTH
065300         WHEN MMD3-RDM-VDI-DEPOSIT-DATA
065400             MOVE LENGTH OF MMD3-VD-DEPOSIT-DATA
065500                                 TO WS-DATA-LENGTH
065600         WHEN MMD3-RDM-VDI-FEE-DATA
065700             MOVE LENGTH OF MMD3-VD-FEE-AREA
065800                                 TO WS-DATA-LENGTH
065900         WHEN MMD3-RDM-VDI-HEADER-DATA
066000             MOVE LENGTH OF MMD3-VD-HEADER-TOTALS
066100                                 TO WS-DATA-LENGTH
066200         WHEN OTHER
066300             MOVE ZERO           TO MMD3-RDM-VAR-IND
066400             MOVE ZERO           TO WS-DATA-LENGTH
066500     END-EVALUATE.
066600*
066700     WRITE MMD3-RDM-RECORD.
066800*
066900     ADD 1                       TO WS-SC-WRITES.
067000     MOVE '- WRITE ERROR - MMD3' TO SS02WS-ABENDMSG8.
067100     GO TO R900-RA-CHECK-STATUS.
067200*
067300 R160-RA-REWRITE.
067400*
067500     MOVE MMD3IO-RECORD          TO MMD3-RDM-MAX-RECORD.
067600*
067700     EVALUATE TRUE
067800         WHEN MMD3-RDM-VAR-IND IS NOT NUMERIC
067900             MOVE ZERO           TO MMD3-RDM-VAR-IND
068000             MOVE ZERO           TO WS-DATA-LENGTH
068100         WHEN MMD3-RDM-VDI-DEPOSIT-DATA
068200             MOVE LENGTH OF MMD3-VD-DEPOSIT-DATA
068300                                 TO WS-DATA-LENGTH
068400         WHEN MMD3-RDM-VDI-FEE-DATA
068500             MOVE LENGTH OF MMD3-VD-FEE-AREA
068600                                 TO WS-DATA-LENGTH
068700         WHEN MMD3-RDM-VDI-HEADER-DATA
068800             MOVE LENGTH OF MMD3-VD-HEADER-TOTALS
068900                                 TO WS-DATA-LENGTH
069000         WHEN OTHER
069100             MOVE ZERO           TO MMD3-RDM-VAR-IND
069200             MOVE ZERO           TO WS-DATA-LENGTH
069300     END-EVALUATE.
069400*
069500     REWRITE MMD3-RDM-RECORD.
069600*
069700     ADD 1                       TO WS-SC-REWRITES.
069800     MOVE '- REWRT ERROR - MMD3' TO SS02WS-ABENDMSG8.
069900     GO TO R900-RA-CHECK-STATUS.
070000*
070100 R170-RA-DELETE.
070200*
070300     MOVE MMD3IO-KEY             TO MMD3-RDM-KEY.
070400     DELETE MMD3-FILE-RDM RECORD.
070500*
070600     ADD 1                       TO WS-SC-DELETES.
070700     MOVE '- DELET ERROR - MMD3' TO SS02WS-ABENDMSG8.
070800     GO TO R900-RA-CHECK-STATUS.
070900*
071000 R180-RA-CLOSE.
071100*
071200     MOVE SPACE                  TO WS-ACCESS-METHOD.
071300     CLOSE  MMD3-FILE-RDM.
071400*
071500     PERFORM Z100-DISPLAY-THE-SUMMARY
071600        THRU Z199-DTS-EXIT.
071700*
071800     MOVE '- CLOSE ERROR - MMD3' TO SS02WS-ABENDMSG8.
071900     GO TO R900-RA-CHECK-STATUS.
072000*
072100 R900-RA-CHECK-STATUS.
072200*
072300     MOVE WS-STATUS              TO MMD3RB-STATUS.
072400     MOVE WS-RETURN              TO MMD3RB-RETURN.
072500*
072600     IF  MMD3RB-STATUS IS EQUAL  TO MMD3RB-TEMP-STATUS-1   OR
072700         MMD3RB-STATUS IS EQUAL  TO MMD3RB-TEMP-STATUS-2   OR
072800         MMD3RB-STATUS IS EQUAL  TO MMD3RB-PERM-STATUS-1   OR
072900         MMD3RB-STATUS IS EQUAL  TO MMD3RB-PERM-STATUS-2   OR
073000         MMD3RB-STATUS IS EQUAL  TO MMD3RB-PERM-STATUS-3   OR
073100         MMD3RB-STATUS IS EQUAL  TO MMD3RB-PERM-STATUS-4   OR
073200         MMD3RB-STATUS IS EQUAL  TO MMD3RB-PERM-STATUS-5
073300         MOVE ZERO               TO MMD3RB-TEMP-STATUS-1
073400         MOVE ZERO               TO MMD3RB-TEMP-STATUS-2
073500     ELSE
073600         GO TO Z900-ABORT.
073700*
073800 R999-RA-EXIT.
073900     EXIT.
074000/
074100 S000-SEQUENTIAL-ACCESS.
074200*
074300     GO TO S110-SA-OPEN-INPUT
074400           S120-SA-OPEN-OUTPUT
074500           S130-SA-OPEN-I-O
074600           S100-SA-INVALID-REQUEST
074700           S100-SA-INVALID-REQUEST
074800           S100-SA-INVALID-REQUEST
074900           S100-SA-INVALID-REQUEST
075000           S100-SA-INVALID-REQUEST
075100           S100-SA-INVALID-REQUEST
075200           S140-SA-START-GTE
075300           S150-SA-START-EQUAL
075400           S160-SA-READ-SEQ
075500           S100-SA-INVALID-REQUEST
075600           S170-SA-WRITE
075700           S180-SA-REWRITE
075800           S190-SA-DELETE
075900           S200-SA-CLOSE
076000           DEPENDING ON MMD3RB-IO-REQUEST.
076100*
076200 S100-SA-INVALID-REQUEST.
076300*
076400     MOVE MMD3RB-IO-REQUEST      TO SS02WS-ABEND-REQUEST.
076500     MOVE '- BAD I-O REQ - MMD3' TO SS02WS-ABENDMSG8.
076600     GO TO Z950-ABORT.
076700*
076800 S110-SA-OPEN-INPUT.
076900*
077000     OPEN INPUT MMD3-FILE-SEQ.
077100*
077200     IF  WS-STATUS IS EQUAL TO '97'
077300         MOVE '97'               TO MMD3RB-OPEN-STATUS
077400         MOVE LOW-VALUES         TO WS-RETURN
077500         MOVE ZEROS              TO WS-STATUS.
077600*
077700     MOVE 'SEQ'                  TO WS-SM-ACCESS.
077800     MOVE 'INPUT'                TO WS-SM-OPENED.
077900     MOVE '- OPEN  ERROR - MMD3' TO SS02WS-ABENDMSG8.
078000     GO TO S900-SA-CHECK-STATUS.
078100*
078200 S120-SA-OPEN-OUTPUT.
078300*
078400     OPEN OUTPUT MMD3-FILE-SEQ.
078500*
078600     IF  WS-STATUS IS EQUAL TO '97'
078700         MOVE '97'               TO MMD3RB-OPEN-STATUS
078800         MOVE LOW-VALUES         TO WS-RETURN
078900         MOVE ZEROS              TO WS-STATUS.
079000*
079100     MOVE 'SEQ'                  TO WS-SM-ACCESS.
079200     MOVE 'OUTPUT'               TO WS-SM-OPENED.
079300     MOVE '- OPEN  ERROR - MMD3' TO SS02WS-ABENDMSG8.
079400     GO TO S900-SA-CHECK-STATUS.
079500*
079600 S130-SA-OPEN-I-O.
079700*
079800     OPEN I-O MMD3-FILE-SEQ.
079900*
080000     MOVE 'SEQ'                  TO WS-SM-ACCESS.
080100     MOVE 'I-O'                  TO WS-SM-OPENED.
080200     MOVE '- OPEN  ERROR - MMD3' TO SS02WS-ABENDMSG8.
080300     GO TO S900-SA-CHECK-STATUS.
080400*
080500 S140-SA-START-GTE.
080600*
080700     MOVE MMD3IO-KEY             TO MMD3-SEQ-KEY.
080800     START MMD3-FILE-SEQ
080900           KEY IS NOT LESS THAN MMD3-SEQ-KEY.
081000*
081100     MOVE '- START ERROR - MMD3' TO SS02WS-ABENDMSG8.
081200     GO TO S900-SA-CHECK-STATUS.
081300*
081400 S150-SA-START-EQUAL.
081500*
081600     MOVE MMD3IO-KEY             TO MMD3-SEQ-KEY.
081700     START MMD3-FILE-SEQ
081800           KEY IS EQUAL TO MMD3-SEQ-KEY.
081900*
082000     MOVE '- START ERROR - MMD3' TO SS02WS-ABENDMSG8.
082100     GO TO S900-SA-CHECK-STATUS.
082200*
082300 S160-SA-READ-SEQ.
082400*
082500     READ MMD3-FILE-SEQ          INTO MMD3IO-RECORD.
082600*
082700     ADD 1                       TO WS-SC-READS.
082800     MOVE '- READ  ERROR - MMD3' TO SS02WS-ABENDMSG8.
082900     GO TO S900-SA-CHECK-STATUS.
083000*
083100 S170-SA-WRITE.
083200*
083300     MOVE MMD3IO-RECORD          TO MMD3-SEQ-MAX-RECORD.
083400*
083500     EVALUATE TRUE
083600         WHEN MMD3-SEQ-VAR-IND IS NOT NUMERIC
083700             MOVE ZERO           TO MMD3-SEQ-VAR-IND
083800             MOVE ZERO           TO WS-DATA-LENGTH
083900         WHEN MMD3-SEQ-VDI-DEPOSIT-DATA
084000             MOVE LENGTH OF MMD3-VD-DEPOSIT-DATA
084100                                 TO WS-DATA-LENGTH
084200         WHEN MMD3-SEQ-VDI-FEE-DATA
084300             MOVE LENGTH OF MMD3-VD-FEE-AREA
084400                                 TO WS-DATA-LENGTH
084500         WHEN MMD3-SEQ-VDI-HEADER-DATA
084600             MOVE LENGTH OF MMD3-VD-HEADER-TOTALS
084700                                 TO WS-DATA-LENGTH
084800         WHEN OTHER
084900             MOVE ZERO           TO MMD3-SEQ-VAR-IND
085000             MOVE ZERO           TO WS-DATA-LENGTH
085100     END-EVALUATE.
085200*
085300     WRITE MMD3-SEQ-RECORD.
085400*
085500     ADD 1                       TO WS-SC-WRITES.
085600     MOVE '- WRITE ERROR - MMD3' TO SS02WS-ABENDMSG8.
085700     GO TO S900-SA-CHECK-STATUS.
085800*
085900 S180-SA-REWRITE.
086000*
086100     MOVE MMD3IO-RECORD          TO MMD3-SEQ-MAX-RECORD.
086200*
086300     EVALUATE TRUE
086400         WHEN MMD3-SEQ-VAR-IND IS NOT NUMERIC
086500             MOVE ZERO           TO MMD3-SEQ-VAR-IND
086600             MOVE ZERO           TO WS-DATA-LENGTH
086700         WHEN MMD3-SEQ-VDI-DEPOSIT-DATA
086800             MOVE LENGTH OF MMD3-VD-DEPOSIT-DATA
086900                                 TO WS-DATA-LENGTH
087000         WHEN MMD3-SEQ-VDI-FEE-DATA
087100             MOVE LENGTH OF MMD3-VD-FEE-AREA
087200                                 TO WS-DATA-LENGTH
087300         WHEN MMD3-SEQ-VDI-HEADER-DATA
087400             MOVE LENGTH OF MMD3-VD-HEADER-TOTALS
087500                                 TO WS-DATA-LENGTH
087600         WHEN OTHER
087700             MOVE ZERO           TO MMD3-SEQ-VAR-IND
087800             MOVE ZERO           TO WS-DATA-LENGTH
087900     END-EVALUATE.
088000*
088100     REWRITE MMD3-SEQ-RECORD.
088200*
088300     ADD 1                       TO WS-SC-REWRITES.
088400     MOVE '- REWRT ERROR - MMD3' TO SS02WS-ABENDMSG8.
088500     GO TO S900-SA-CHECK-STATUS.
088600*
088700 S190-SA-DELETE.
088800*
088900     MOVE MMD3IO-KEY             TO MMD3-SEQ-KEY.
089000     DELETE MMD3-FILE-SEQ RECORD.
089100*
089200     ADD 1                       TO WS-SC-DELETES.
089300     MOVE '- DELET ERROR - MMD3' TO SS02WS-ABENDMSG8.
089400     GO TO S900-SA-CHECK-STATUS.
089500*
089600 S200-SA-CLOSE.
089700*
089800     MOVE SPACE                  TO WS-ACCESS-METHOD.
089900     CLOSE MMD3-FILE-SEQ.
090000*
090100     PERFORM Z100-DISPLAY-THE-SUMMARY
090200        THRU Z199-DTS-EXIT.
090300*
090400     MOVE '- CLOSE ERROR - MMD3' TO SS02WS-ABENDMSG8.
090500     GO TO S900-SA-CHECK-STATUS.
090600*
090700 S900-SA-CHECK-STATUS.
090800*
090900     MOVE WS-STATUS              TO MMD3RB-STATUS.
091000     MOVE WS-RETURN              TO MMD3RB-RETURN.
091100*
091200     IF  MMD3RB-STATUS IS EQUAL  TO MMD3RB-TEMP-STATUS-1   OR
091300         MMD3RB-STATUS IS EQUAL  TO MMD3RB-TEMP-STATUS-2   OR
091400         MMD3RB-STATUS IS EQUAL  TO MMD3RB-PERM-STATUS-1   OR
091500         MMD3RB-STATUS IS EQUAL  TO MMD3RB-PERM-STATUS-2   OR
091600         MMD3RB-STATUS IS EQUAL  TO MMD3RB-PERM-STATUS-3   OR
091700         MMD3RB-STATUS IS EQUAL  TO MMD3RB-PERM-STATUS-4   OR
091800         MMD3RB-STATUS IS EQUAL  TO MMD3RB-PERM-STATUS-5
091900         MOVE ZERO               TO MMD3RB-TEMP-STATUS-1
092000         MOVE ZERO               TO MMD3RB-TEMP-STATUS-2
092100     ELSE
092200         GO TO Z900-ABORT.
092300*
092400 S999-SA-EXIT.
092500     EXIT.
092600/
092700 Z000-PROGRAM-INITIALIZATION.
092800*
092900************************************************************
093000*    THE CALLING PROGRAM MUST SUPPLY THE PROGRAM ID TO     *
093100*    ENSURE THAT ANY SUBSEQUENT ABEND CAN BE TRACED TO     *
093200*    IT.  IF THE PROGRAM ID IS NOT SUPPLIED, THE ACCESS    *
093300*    ROUTINE ABENDS HERE.                                  *
093400************************************************************
093500*
093600     IF  SS02WS-ABEND-PROG-ID IS EQUAL TO SPACES
093700         MOVE '- BAD PROG NAME - MMD3'
093800                                 TO SS02WS-ABENDMSG8
093900         MOVE 'BADPRO'           TO SS02WS-ABEND-PROG-ID
094000         GO TO Z950-ABORT.
094100*
094200     MOVE SS02WS-ABEND-PROG-ID   TO WS-SM-PROG-ID.
094300*
094400*************************************************************
094500*    SINCE THIS ROUTINE IS PERFORMED ONLY ONCE DURING       *
094600*    THE EXECUTION OF A CALLING PROGRAM, THE FIRST          *
094700*    REQUEST MUST BE FOR AN OPEN.  SET THE ACCESS METHOD    *
094800*    (SEQENTIAL, DYNAMIC, OR RANDOM), OR ISSUE AN ABEND     *
094900*    IF THE REQUEST IS NOT FOR AN OPEN.                     *
095000*************************************************************
095100*
095200     IF  MMD3RB-OPEN-INPUT    OR
095300         MMD3RB-OPEN-OUTPUT   OR
095400         MMD3RB-OPEN-IO
095500         MOVE 'S'                TO WS-ACCESS-METHOD.
095600*
095700     IF  MMD3RB-OPEN-INPUT-DYN    OR
095800         MMD3RB-OPEN-OUTPUT-DYN   OR
095900         MMD3RB-OPEN-IO-DYN
096000         MOVE 'D'                TO WS-ACCESS-METHOD.
096100*
096200     IF  MMD3RB-OPEN-INPUT-RDM    OR
096300         MMD3RB-OPEN-OUTPUT-RDM   OR
096400         MMD3RB-OPEN-IO-RDM
096500         MOVE 'R'                TO WS-ACCESS-METHOD.
096600*
096700     IF  ACCESS-METHOD-NOT-SET
096800         MOVE 'SMMD3'            TO SS02WS-ABEND-CODE-X
096900         MOVE MMD3RB-IO-REQUEST  TO WS-IO-REQUEST
097000         MOVE WS-IO-REQUEST      TO SS02WS-ABEND-REQUEST
097100         MOVE 'ILLEGAL ACCESS REQUEST'
097200                                 TO SS02WS-ABENDMSG8
097300         GO TO Z950-ABORT.
097400*
097500 Z099-PI-EXIT.
097600     EXIT.
097700*
097800 Z100-DISPLAY-THE-SUMMARY.
097900*
098000     MOVE WS-SC-READS            TO WS-SM-READS.
098100     MOVE WS-SC-WRITES           TO WS-SM-WRITES.
098200     MOVE WS-SC-REWRITES         TO WS-SM-REWRITES.
098300     MOVE WS-SC-DELETES          TO WS-SM-DELETES.
098400     DISPLAY WS-SUMMARY-MESSAGE.
098500*
098600     INITIALIZE WS-SUMMARY-COUNTERS.
098700*
098800 Z199-DTS-EXIT.
098900     EXIT.
099000/
099100 Z900-ABORT.
099200*
099300     MOVE 'SMMD3'                TO SS02WS-ABEND-CODE-X.
099400     MOVE MMD3RB-STATUS          TO SS02WS-ABEND-STATUS.
099500     MOVE MMD3RB-RETURN-CODE     TO SS02WS-ABEND-RETURN.
099600     MOVE MMD3RB-FUNCTION-CODE   TO SS02WS-ABEND-FUNCTION.
099700     MOVE MMD3RB-FEEDBACK-CODE   TO SS02WS-ABEND-FEEDBACK.
099800     MOVE MMD3RB-IO-REQUEST      TO WS-IO-REQUEST.
099900     MOVE WS-IO-REQUEST          TO SS02WS-ABEND-REQUEST.
100000*
100100 Z950-ABORT.
100200*
100300     PERFORM SS02PD-ABEND        THRU SS02PD-ABEND-EXIT.
100400*
100500 Z999-ABORT-EXIT.
100600     EXIT.
100700/
100800********************************
100900*    STANDARD ABEND ROUTINE    *
101000********************************
101100*
101200     COPY SS02PD.
101300*
