000100 IDENTIFICATION DIVISION.
000200 PROGRAM-ID.     MTEDAB.
000201*       RELEASE DATE=08/24/01.        REVISION LEVEL=08.06      * ++++++++
000202***************************************************************** ++++++++
000203*WARNING.  THIS COMPUTER PROGRAM IS PROTECTED BY COPYRIGHT LAW  * ++++++++
000204*AND INTERNATIONAL TREATIES.  UNAUTHORIZED REPRODUCTION OR      * ++++++++
000205*DISTRIBUTION OF THIS PROGRAM, OR ANY PORTION OF IT, MAY RESULT * ++++++++
000206*IN SEVERE CIVIL AND CRIMINAL PENATLIES, AND WILL BE PROSECUTED * ++++++++
000207*TO THE MAXIMUM EXTENT POSSIBLE UNDER THE LAW.                  * ++++++++
000208*COPYRIGHT 1999 PAYSYS INTERNATIONAL, INC.  ALL RIGHTS RESERVED.* ++++++++
000209***************************************************************** ++++++++
000300*
000400******************************************************************
000500*                                                                *
000600*    -------------MERCHANT BANKCARD SYSTEM-----------------      *
000700*                                                                *
000800*          MTEDAB - MTED FILE COMMON BATCH I/O ROUTINE           *
000900*                                                                *
001000*                 DEFAULT DESCRIPTION TABLE FILE                 *
001100*                                                                *
001200*    -------------------SYSTEM CONTROL---------------------      *
001300*                                                                *
001400******************************************************************
001500*                                                                *
001600*    COPYBOOKS WHICH MUST APPEAR IN YOUR BATCH PROGRAM:          *
001700*                                                                *
001800*    (WS) MTEDRB - BATCH REQUEST BLOCK                           *
001900*    (WS) MTEDIO - I/O AREA                                      *
002000*    (WS) SS02WS  - STANDARD ABEND ROUTINE WORK AREA             *
002100*    (PD) MTEDPD - PROCEDURE DIVISION CALL STATEMENT             *
002200*                                                                *
002300******************************************************************
002400*                                                                *
002500*    TO USE THIS ROUTINE.........                                *
002600*                                                                *
002700* 1. HOUSEKEEPING DUTIES:                                        *
002800*                                                                *
002900*    A. IN THE HOUSEKEEPING SECTION OF YOUR PROGRAM, MOVE THE    *
003000*       NAME OF THE PROGRAM USING THIS ROUTINE TO THE FIELD      *
003100*       'SS02WS-ABEND-PROG-ID'. THIS FIELD IS USED AS PART OF THE
003200*       STANDARD ABEND MESSAGES IF A PROGRAM ABORTS WITHIN THIS  *
003300*       ACCESS ROUTINE.  IF THE FIELD 'SS02WS-ABEND-PROG-ID' IS LE
003400*       BLANK, THIS ROUTINE WILL FORCE AN ABEND SITUATION.       *
003500*                                                                *
003600*    B. BEFORE PERFORMING THE ACCESS ROUTINE, MOVE A LITERAL TO  *
003700*       THE FIELD 'SS02WS-ABEND-LOCATION'. THIS FIELD CAN BE USED
003800*       TO INDICATE WHERE THE ROUTINE IS BEING 'FROM' IN CASE    *
003900*       OF ABNORMAL TERMINATION. (E.G. DEBUGGING ASSISTANCE)     *
004000*                                                                *
004100*    C. SET THE RETURN CODES WHICH YOU WANT, FOR THE DURATION    *
004200*       OF THIS PROGRAM, TO BE CONSIDERED VALID IN THE FIELDS    *
004300*       'MTEDRB-PERM-STATUS-1 TO -5'. THESE FIELDS ARE INITIAL- *
004400*       IZED TO ZERO (AS ZERO IS ALWAYS AN ACCEPTABLE RETURN     *
004500*       CODE).  THIS ROUTINE WILL (IN ALL I-O REQUESTS) SUCCESS- *
004600*       FULLY SATISFY YOUR PERFORM REQUEST IF ANY OF THE REQUESTS*
004700*       ENCOUNTER ANY OF THE PERMANENT STATUS CODES 1-5.         *
004800*                                                                *
004900* 2. SET ONE OF THE FOLLOWING CONDITION NAMES TO 'TRUE' TO SET   *
005000*    THE FILE REQUEST:                                           *
005100*                                                                *
005200*        CONDITION NAME                EXPLANATION               *
005300*   *----------------------***---------------------------------* *
005400*                                                                *
005500*    MTEDRB-OPEN-INPUT      - OPEN THE FILE AS INPUT WITH        *
005600*                             SEQUENTIAL ACCESS.                 *
005700*    MTEDRB-OPEN-OUTPUT     - OPEN THE FILE AS OUTPUT WITH       *
005800*                             SEQUENTIAL ACCESS.                 *
005900*    MTEDRB-READ-SEQ        - READ THE NEXT SEQUENTIAL RECORD    *
006000*                             IN THE FILE.                       *
006100*    MTEDRB-WRITE           - WRITE A RECORD (THE RECORD MUST    *
006200*                             BE IN 'MTEDIO-RECORD').            *
006300*    MTEDRB-CLOSE           - CLOSE THE FILE.                    *
006400*                                                                *
006500* 3. SET ONE OR BOTH OF THE 'TEMPORARY' RETURN CODE FIELDS       *
006600*    'MTEDRB-TEMP-STATUS-1 AND -2'. THESE TWO RETURN CODES       *
006700*    ARE TO BE USED ON A PER USE BASIS OF THIS ROUTINE.          *
006800*    THESE TWO RETURN CODES ARE INITIALIZED TO ZERO AND ARE      *
006900*    BOTH RESET TO ZERO AFTER EACH CALL OF THIS PROGRAM.         *
007000*    THE TEMPORARY RETURN CODE FIELDS ARE CHECKED FIRST AND      *
007100*    THEN THE PERMANENT RETURN CODES (POINT 1.C ABOVE) WILL      *
007200*    BE CHECKED.                                                 *
007300*                                                                *
007400* 4. PERFORM MTEDPD-ACCESS THRU MTEDPD-ACCESS-EXIT.              *
007500*                                                                *
007600*    A. YOU MUST HANDLE MANUALLY ANY RETURN CODE (EITHER TEMP    *
007700*       OR PERM) THAT YOU REQUESTED, AND IF NEEDED, YOUR OWN     *
007800*       ABEND REQUEST.                                           *
007900*                                                                *
008000*    B. ALL ACCESS ROUTINES MOVE THE FILE STATUS TO THE FIELD    *
008100*       'SS02WS-FILE-STATUS' IN COPYBOOK SS02WS.  USE THE '88'   *
008200*       NAMES TO TEST YOUR MANUAL STATUS CHECKS.  ALSO IN COPY   *
008300*       BOOK SS02WS, USE THE 'WS-' FILE STATUS DATA NAMES WHEN   *
008400*       SETTING THE PERM OR TEMP FILE STATUS CODES PRIOR TO      *
008500*       PERFORMING THE ACCESS ROUTINE.  FOR VSAM FILES, THE VSAM *
008600*       RETURN CODE IS MOVED TO THE FIELD 'WS-FILE-RETURN' IN    *
008700*       COPYBOOK SS02WS.                                         *
008800*                                                                *
008900******************************************************************
009000*
009100 ENVIRONMENT DIVISION.
009200*
009300 CONFIGURATION SECTION.
009400 SOURCE-COMPUTER.            IBM-4341.
009500 OBJECT-COMPUTER.            IBM-4341.
009600*
009700 INPUT-OUTPUT SECTION.
009800*
009900 FILE-CONTROL.
010000*
010100     SELECT  MTED-FILE
010200             ASSIGN              TO SYS002-UT-3380-S-MTED
010300             FILE STATUS         IS WS-STATUS.
010400*
010500 DATA DIVISION.
010600*
010700 FILE SECTION.
010800*
010900 FD  MTED-FILE
011000     RECORD CONTAINS 145 CHARACTERS
011100     BLOCK  CONTAINS 000 RECORDS
011200     RECORDING MODE IS F.
011300*
011400 01  MTED-RECORD.
011500     03  FILLER                  PIC  X(145).
011600*
011700 WORKING-STORAGE SECTION.
011800*
011900 01  FILLER                  PIC  X(12)      VALUE '** WS-BEG **'.
012000*
012100 01  FILLER                  PIC  X(18)      VALUE
012200     'FIRST CALL SWITCH:'.
012300*
012400 01  WS-FIRST-CALL-SW        PIC  X(01)      VALUE 'Y'.
012500     88  WS-FIRST-CALL-SW-IS-YES             VALUE 'Y'.
012600*
012700 01  FILLER                  PIC  X(12)      VALUE
012800     'FILE STATUS:'.
012900*
013000 01  WS-STATUS               PIC  X(02)      VALUE ZERO.
013100*
013200 01  FILLER                  PIC  X(12)      VALUE
013300     'I-O REQUEST:'.
013400*
013500 01  WS-IO-REQUEST           PIC  9(02)      VALUE ZERO.
013600*
013700 01  FILLER                  PIC  X(28)      VALUE
013800     'PROCESSING SUMMARY COUNTERS:'.
013900*
014000 01  WS-SUMMARY-COUNTERS.
014100     03  WS-SC-READS         PIC S9(09)      COMP-3
014200                                             VALUE ZERO.
014300     03  WS-SC-WRITES        PIC S9(09)      COMP-3
014400                                             VALUE ZERO.
014500*
014600 01  FILLER                  PIC  X(27)      VALUE
014700     'PROCESSING SUMMARY MESSAGE:'.
014800*
014900 01  WS-SUMMARY-MESSAGE.
015000     03  FILLER              PIC  X(10)      VALUE '(PGMSTAT) '.
015100     03  WS-SM-PROG-ID       PIC  X(06)      VALUE SPACES.
015200     03  FILLER              PIC  X(03)      VALUE ' - '.
015300     03  WS-SM-FILE-ID       PIC  X(05)      VALUE 'MTED'.
015400     03  FILLER              PIC  X(10)      VALUE '- OPENED: '.
015500     03  WS-SM-ACCESS        PIC  X(03)      VALUE SPACES.
015600     03  FILLER              PIC  X(01)      VALUE SPACE.
015700     03  WS-SM-OPENED        PIC  X(06)      VALUE SPACES.
015800     03  FILLER              PIC  X(01)      VALUE SPACE.
015900     03  WS-SM-READS         PIC  ZZZZZZZZ9.
016000     03  FILLER              PIC  X(08)      VALUE ' READS, '.
016100     03  WS-SM-WRITES        PIC  ZZZZZZZZ9.
016200     03  FILLER              PIC  X(09)      VALUE ' WRITES, '.
016300     03  WS-SM-REWRITES      PIC  ZZZZZZZZ9.
016400     03  FILLER              PIC  X(11)      VALUE '           '.
016500     03  WS-SM-DELETES       PIC  ZZZZZZZZ9.
016600     03  FILLER              PIC  X(08)      VALUE '        '.
016700/
016800     COPY SS00WS.
016900*
017000 01  FILLER                  PIC  X(12)      VALUE '** WS-END **'.
017100*
017200 LINKAGE SECTION.
017300*
017400****************************
017500*    FILE REQUEST BLOCK    *
017600****************************
017700*
017800     COPY MB00RB REPLACING ==:MB00:== BY ==MTED==.
017900*
018000******************
018100*    I/O AREA    *
018200******************
018300*
018400     COPY MTEDIO REPLACING ==:MTED:== BY ==MTED==.
018500*
018600*********************************
018700*    ABEND ROUTINE WORK AREA    *
018800*********************************
018900*
019000     COPY SS02WS.
019100*
019200 PROCEDURE DIVISION          USING MTEDRB-WORK-AREA,
019300                                   MTEDIO-RECORD,
019400                                   SS02WS-ABEND-WORK-AREA.
019500*
019600 A000-MAIN-LINE-SECTION.
019700*
019800*
019900***************************************************
020000*    SET THE ACCESS METHOD AND ABEND WORK AREA    *
020100*    IF THIS IS THE FIRST CALL OF THIS PROGRAM    *
020200***************************************************
020300*
020400     IF  WS-FIRST-CALL-SW-IS-YES
020500         PERFORM Z000-PROGRAM-INITIALIZATION
020600            THRU Z099-PI-EXIT.
020700*
020800**************************************************************
020900*    PROCESS THE FILE DEPENDING OF THE PROCESSING OPTION.    *
021000**************************************************************
021100*
021200     PERFORM S000-SEQUENTIAL-ACCESS
021300                                 THRU S999-SA-EXIT.
021400*
021500*****************************************************
021600*    MOVE THE STATUS CODE AND RETURN CODE TO        *
021700*    THEIR RESPECTIVE FIELDS IN COPYBOOK SS02WS.    *
021800*****************************************************
021900*
022000     MOVE MTEDRB-STATUS          TO SS02WS-FILE-STATUS.
022100*
022200 A999-GOBACK.
022300*
022400     GOBACK.
022500*
022600 S000-SEQUENTIAL-ACCESS.
022700*
022800     GO TO S110-SA-OPEN-INPUT
022900           S120-SA-OPEN-OUTPUT
023000           S100-SA-INVALID-REQUEST
023100           S100-SA-INVALID-REQUEST
023200           S100-SA-INVALID-REQUEST
023300           S100-SA-INVALID-REQUEST
023400           S100-SA-INVALID-REQUEST
023500           S100-SA-INVALID-REQUEST
023600           S100-SA-INVALID-REQUEST
023700           S100-SA-INVALID-REQUEST
023800           S100-SA-INVALID-REQUEST
023900           S160-SA-READ-SEQ
024000           S100-SA-INVALID-REQUEST
024100           S170-SA-WRITE
024200           S100-SA-INVALID-REQUEST
024300           S100-SA-INVALID-REQUEST
024400           S200-SA-CLOSE
024500           DEPENDING ON MTEDRB-IO-REQUEST.
024600*
024700 S100-SA-INVALID-REQUEST.
024800*
024900     MOVE MTEDRB-IO-REQUEST      TO SS02WS-ABEND-REQUEST.
025000     MOVE '- BAD I-O REQ -MTED'  TO SS02WS-ABENDMSG8.
025100     GO TO Z950-ABORT.
025200*
025300 S110-SA-OPEN-INPUT.
025400*
025500     OPEN INPUT MTED-FILE.
025600*
025700     MOVE 'SEQ'                  TO WS-SM-ACCESS.
025800     MOVE 'INPUT'                TO WS-SM-OPENED.
025900     MOVE '- OPEN  ERROR -MTED'  TO SS02WS-ABENDMSG8.
026000     GO TO S900-SA-CHECK-STATUS.
026100*
026200 S120-SA-OPEN-OUTPUT.
026300*
026400     OPEN OUTPUT MTED-FILE.
026500*
026600     MOVE 'SEQ'                  TO WS-SM-ACCESS.
026700     MOVE 'OUTPUT'               TO WS-SM-OPENED.
026800     MOVE '- OPEN  ERROR -MTED'  TO SS02WS-ABENDMSG8.
026900     GO TO S900-SA-CHECK-STATUS.
027000*
027100 S160-SA-READ-SEQ.
027200*
027300     READ MTED-FILE              INTO MTEDIO-RECORD.
027400*
027500     ADD 1                       TO WS-SC-READS.
027600     MOVE '- READ  ERROR -MTED'  TO SS02WS-ABENDMSG8.
027700     GO TO S900-SA-CHECK-STATUS.
027800*
027900 S170-SA-WRITE.
028000*
028100     WRITE MTED-RECORD           FROM MTEDIO-RECORD.
028200*
028300     ADD 1                       TO WS-SC-WRITES.
028400     MOVE '- WRITE ERROR -MTED'  TO SS02WS-ABENDMSG8.
028500     GO TO S900-SA-CHECK-STATUS.
028600*
028700 S200-SA-CLOSE.
028800*
028900     MOVE SPACE                  TO WS-FIRST-CALL-SW.
029000     CLOSE MTED-FILE.
029100*
029200     PERFORM Z100-DISPLAY-THE-SUMMARY
029300        THRU Z199-DTS-EXIT.
029400*
029500     MOVE '- CLOSE ERROR -MTED'  TO SS02WS-ABENDMSG8.
029600     GO TO S900-SA-CHECK-STATUS.
029700*
029800 S900-SA-CHECK-STATUS.
029900*
030000     MOVE WS-STATUS              TO MTEDRB-STATUS.
030100*
030200     IF  MTEDRB-STATUS IS EQUAL  TO MTEDRB-TEMP-STATUS-1
030300     OR  MTEDRB-STATUS IS EQUAL  TO MTEDRB-TEMP-STATUS-2
030400     OR  MTEDRB-STATUS IS EQUAL  TO MTEDRB-PERM-STATUS-1
030500     OR  MTEDRB-STATUS IS EQUAL  TO MTEDRB-PERM-STATUS-2
030600     OR  MTEDRB-STATUS IS EQUAL  TO MTEDRB-PERM-STATUS-3
030700     OR  MTEDRB-STATUS IS EQUAL  TO MTEDRB-PERM-STATUS-4
030800     OR  MTEDRB-STATUS IS EQUAL  TO MTEDRB-PERM-STATUS-5
030900         MOVE ZERO               TO MTEDRB-TEMP-STATUS-1
031000         MOVE ZERO               TO MTEDRB-TEMP-STATUS-2
031100     ELSE
031200         GO TO Z900-ABORT.
031300*
031400 S999-SA-EXIT.
031500     EXIT.
031600*
031700 Z000-PROGRAM-INITIALIZATION.
031800*
031900************************************************************
032000*    THE CALLING PROGRAM MUST SUPPLY THE PROGRAM ID TO     *
032100*    ENSURE THAT ANY SUBSEQUENT ABEND CAN BE TRACED TO     *
032200*    IT.  IF THE PROGRAM ID IS NOT SUPPLIED, THE ACCESS    *
032300*    ROUTINE ABENDS HERE.                                  *
032400************************************************************
032500*
032600     IF  SS02WS-ABEND-PROG-ID IS EQUAL TO SPACES
032700         MOVE '- BAD PROG NAME - MTED'
032800                                 TO SS02WS-ABENDMSG8
032900         MOVE 'BADPRO'           TO SS02WS-ABEND-PROG-ID
033000         GO TO Z950-ABORT.
033100*
033200     MOVE SS02WS-ABEND-PROG-ID   TO WS-SM-PROG-ID.
033300*
033400*************************************************************
033500*    SINCE THIS ROUTINE IS PERFORMED ONLY ONCE DURING       *
033600*    THE EXECUTION OF A CALLING PROGRAM, THE FIRST          *
033700*    REQUEST MUST BE FOR AN OPEN.  SET THE ACCESS METHOD    *
033800*    (SEQENTIAL, DYNAMIC, OR RANDOM), OR ISSUE AN ABEND     *
033900*    IF THE REQUEST IS NOT FOR AN OPEN.                     *
034000*************************************************************
034100*
034200     IF  MTEDRB-OPEN-INPUT
034300     OR  MTEDRB-OPEN-OUTPUT
034400         MOVE 'N'                TO WS-FIRST-CALL-SW
034500     ELSE
034600         MOVE 'ILLEGAL ACCESS REQUEST'
034700                                 TO SS02WS-ABENDMSG8
034800         GO TO Z950-ABORT.
034900*
035000 Z099-PI-EXIT.
035100     EXIT.
035200*
035300 Z100-DISPLAY-THE-SUMMARY.
035400*
035500     MOVE WS-SC-READS            TO WS-SM-READS.
035600     MOVE WS-SC-WRITES           TO WS-SM-WRITES.
035700     DISPLAY WS-SUMMARY-MESSAGE.
035800*
035900     INITIALIZE WS-SUMMARY-COUNTERS.
036000*
036100 Z199-DTS-EXIT.
036200     EXIT.
036300*
036400 Z900-ABORT.
036500*
036600     MOVE 'SMTED'                TO SS02WS-ABEND-CODE-X.
036700     MOVE MTEDRB-STATUS          TO SS02WS-ABEND-STATUS.
036800     MOVE MTEDRB-IO-REQUEST      TO WS-IO-REQUEST.
036900     MOVE WS-IO-REQUEST          TO SS02WS-ABEND-REQUEST.
037000*
037100 Z950-ABORT.
037200*
037300     PERFORM SS02PD-ABEND        THRU SS02PD-ABEND-EXIT.
037400*
037500 Z999-ABORT-EXIT.
037600     EXIT.
037700*
037800********************************
037900*    STANDARD ABEND ROUTINE    *
038000********************************
038100*
038200     COPY SS02PD.
038300*
