000100 IDENTIFICATION DIVISION.
000200 PROGRAM-ID. MTF6AB.
000201*       RELEASE DATE=08/24/01.        REVISION LEVEL=08.06      * ++++++++
000202***************************************************************** ++++++++
000203*WARNING.  THIS COMPUTER PROGRAM IS PROTECTED BY COPYRIGHT LAW  * ++++++++
000204*AND INTERNATIONAL TREATIES.  UNAUTHORIZED REPRODUCTION OR      * ++++++++
000205*DISTRIBUTION OF THIS PROGRAM, OR ANY PORTION OF IT, MAY RESULT * ++++++++
000206*IN SEVERE CIVIL AND CRIMINAL PENATLIES, AND WILL BE PROSECUTED * ++++++++
000207*TO THE MAXIMUM EXTENT POSSIBLE UNDER THE LAW.                  * ++++++++
000208*COPYRIGHT 1999 PAYSYS INTERNATIONAL, INC.  ALL RIGHTS RESERVED.* ++++++++
000209***************************************************************** ++++++++
000300*
000400******************************************************************
000500*                                                                *
000600*    ----------------MERCHANT BANKCARD SYSTEM--------------      *
000700*                                                                *
000800*          MTF6AB - MTF6 FILE COMMON BATCH I/O ROUTINE           *
000900*                                                                *
001000*                  FIXED LENGTH SEQUENTIAL FILE                  *
001100*                                                                *
001200*    --------------------FICHE FILE 6----------------------      *
001300*                                                                *
001400******************************************************************
001500*                                                                *
001600*    COPYBOOKS WHICH MUST APPEAR IN YOUR BATCH PROGRAM:          *
001700*                                                                *
001800*    (WS) MB00RB - BATCH REQUEST BLOCK                           *
001900*    (WS) MTFXIO - I/O AREA                                      *
002000*    (WS) SS02WS - STANDARD ABEND ROUTINE WORK AREA              *
002100*    (PD) MB00PD - PROCEDURE DIVISION CALL STATEMENT             *
002200*                                                                *
002300******************************************************************
002400*                                                                *
002500*    TO USE THIS ROUTINE.........                                *
002600*                                                                *
002700* 1. HOUSEKEEPING DUTIES:                                        *
002800*                                                                *
002900*    A. IN THE HOUSEKEEPING SECTION OF YOUR PROGRAM, MOVE THE    *
003000*       NAME OF THE PROGRAM USING THIS ROUTINE TO THE FIELD      *
003100*       'SS02WS-ABEND-PROG-ID'. THIS FIELD IS USED AS PART OF THE*
003200*       STANDARD ABEND MESSAGES IF A PROGRAM ABORTS WITHIN THIS  *
003300*       ACCESS ROUTINE.  IF THE FIELD 'SS02WS-ABEND-PROG-ID' IS  *
003400*       LEFT BLANK, THIS ROUTINE WILL FORCE AN ABEND SITUATION.  *
003500*                                                                *
003600*    B. BEFORE PERFORMING THE ACCESS ROUTINE, MOVE A LITERAL TO  *
003700*       THE FIELD 'SS02WS-ABEND-LOCATION'. THIS FIELD CAN BE USED*
003800*       TO INDICATE WHERE THE ROUTINE IS BEING 'FROM' IN CASE    *
003900*       OF ABNORMAL TERMINATION. (E.G. DEBUGGING ASSISTANCE)     *
004000*                                                                *
004100*    C. SET THE RETURN CODES WHICH YOU WANT, FOR THE DURATION    *
004200*       OF THIS PROGRAM, TO BE CONSIDERED VALID IN THE FIELDS    *
004300*       'MTF6RB-PERM-STATUS-1 TO -5'. THESE FIELDS ARE INITIAL-  *
004400*       IZED TO ZERO (AS ZERO IS ALWAYS AN ACCEPTABLE RETURN     *
004500*       CODE).  THIS ROUTINE WILL (IN ALL I-O REQUESTS) SUCCESS- *
004600*       FULLY SATISFY YOUR PERFORM REQUEST IF ANY OF THE REQUESTS*
004700*       ENCOUNTER ANY OF THE PERMANENT STATUS CODES 1-5.         *
004800*                                                                *
004900* 2. SET ONE OF THE FOLLOWING CONDITION NAMES TO 'TRUE' TO SET   *
005000*    THE FILE REQUEST:                                           *
005100*                                                                *
005200*        CONDITION NAME                EXPLANATION               *
005300*   *----------------------***---------------------------------* *
005400*                                                                *
005500*    MTF6RB-OPEN-INPUT      - OPEN THE FILE AS INPUT.            *
005600*    MTF6RB-OPEN-OUTPUT     - OPEN THE FILE AS OUTPUT.           *
005700*    MTF6RB-OPEN-IO         - OPEN THE FILE AS I-O.              *
005800*    MTF6RB-READ-SEQ        - READ THE NEXT SEQUENTIAL RECORD    *
005900*                             IN THE FILE.                       *
006000*    MTF6RB-WRITE           - WRITE A RECORD (THE RECORD MUST    *
006100*                             BE IN 'MTF6IO-RECORD').            *
006200*    MTF6RB-REWRITE         - REWRITE A RECORD (THE RECORD MUST  *
006300*                             BE IN 'MTF6IO-RECORD').            *
006400*    MTF6RB-CLOSE           - CLOSE THE FILE.                    *
006500*                                                                *
006600* 3. SET ONE OR BOTH OF THE 'TEMPORARY' RETURN CODE FIELDS       *
006700*    'MTF6RB-TEMP-STATUS-1 AND -2'.  THESE TWO RETURN CODES      *
006800*    ARE TO BE USED ON A PER USE BASIS OF THIS ROUTINE.          *
006900*    THESE TWO RETURN CODES ARE INITIALIZED TO ZERO AND ARE      *
007000*    BOTH RESET TO ZERO AFTER EACH CALL OF THIS PROGRAM.         *
007100*    THE TEMPORARY RETURN CODE FIELDS ARE CHECKED FIRST AND      *
007200*    THEN THE PERMANENT RETURN CODES (POINT 1.C ABOVE) WILL      *
007300*    BE CHECKED.                                                 *
007400*                                                                *
007500* 4. PERFORM MB00PD-MTF6-ACCESS THRU MB00PD-MTF6-ACCESS-EXIT.    *
007600*                                                                *
007700*    A. YOU MUST HANDLE MANUALLY ANY RETURN CODE (EITHER TEMP    *
007800*       OR PERM) THAT YOU REQUESTED, AND IF NEEDED, YOUR OWN     *
007900*       ABEND REQUEST.                                           *
008000*                                                                *
008100*    B. ALL ACCESS ROUTINES MOVE THE FILE STATUS TO THE FIELD    *
008200*       SS02WS-FILE-STATUS IN COPYBOOK SS02WS. USE THE '88' LEVEL*
008300*       NAMES TO TEST YOUR MANUAL STATUS CHECKS.  ALSO IN COPY   *
008400*       BOOK SS02WS, USE THE 'WS-' FILE STATUS DATA NAMES WHEN   *
008500*       SETTING THE PERM OR TEMP FILE STATUS CODES PRIOR TO      *
008600*       PERFORMING THE ACCESS ROUTINE.                           *
008700*                                                                *
008800******************************************************************
008900/
009000 ENVIRONMENT DIVISION.
009100*
009200 CONFIGURATION SECTION.
009300 SOURCE-COMPUTER.            IBM-4341.
009400 OBJECT-COMPUTER.            IBM-4341.
009500*
009600 INPUT-OUTPUT SECTION.
009700*
009800 FILE-CONTROL.
009900*
010000     SELECT  MTF6-FILE
010100             ASSIGN              TO SYS002-UT-3380-S-MTF6
010200             FILE STATUS         IS WS-STATUS.
010300/
010400 DATA DIVISION.
010500*
010600 FILE SECTION.
010700*
010800 FD  MTF6-FILE
010900     RECORD CONTAINS 133 CHARACTERS
011000     BLOCK  CONTAINS 000 RECORDS
011100     RECORDING MODE IS F.
011200*
011300 01  MTF6-RECORD.
011400     03  MTF6-DATA           PIC  X(133).
011500/
011600 WORKING-STORAGE SECTION.
011700*
011800 01  FILLER                  PIC  X(12)      VALUE '** WS-BEG **'.
011900*
012000 01  FILLER                  PIC  X(18)      VALUE
012100     'FIRST CALL SWITCH:'.
012200*
012300 01  WS-FIRST-CALL-SW        PIC  X(01)      VALUE 'Y'.
012400     88  WS-FIRST-CALL-SW-IS-YES             VALUE 'Y'.
012500*
012600 01  FILLER                  PIC  X(12)      VALUE
012700     'FILE STATUS:'.
012800*
012900 01  WS-STATUS               PIC  X(02)      VALUE ZERO.
013000*
013100 01  FILLER                  PIC  X(12)      VALUE
013200     'I-O REQUEST:'.
013300*
013400 01  WS-IO-REQUEST           PIC  9(02)      VALUE ZERO.
013500*
013600 01  FILLER                  PIC  X(28)      VALUE
013700     'PROCESSING SUMMARY COUNTERS:'.
013800*
013900 01  WS-SUMMARY-COUNTERS.
014000     03  WS-SC-READS         PIC S9(09)      PACKED-DECIMAL
014100                                             VALUE ZERO.
014200     03  WS-SC-WRITES        PIC S9(09)      PACKED-DECIMAL
014300                                             VALUE ZERO.
014400     03  WS-SC-REWRITES      PIC S9(09)      PACKED-DECIMAL
014500                                             VALUE ZERO.
014600*
014700 01  FILLER                  PIC  X(27)      VALUE
014800     'PROCESSING SUMMARY MESSAGE:'.
014900*
015000 01  WS-SUMMARY-MESSAGE.
015100     03  FILLER              PIC  X(10)      VALUE '(PGMSTAT) '.
015200     03  WS-SM-PROG-ID       PIC  X(06)      VALUE SPACES.
015300     03  FILLER              PIC  X(03)      VALUE ' - '.
015400     03  WS-SM-FILE-ID       PIC  X(04)      VALUE 'MTF6'.
015500     03  FILLER              PIC  X(11)      VALUE ' - OPENED: '.
015600     03  WS-SM-ACCESS        PIC  X(03)      VALUE SPACES.
015700     03  FILLER              PIC  X(01)      VALUE SPACE.
015800     03  WS-SM-OPENED        PIC  X(06)      VALUE SPACES.
015900     03  FILLER              PIC  X(01)      VALUE SPACE.
016000     03  WS-SM-READS         PIC  ZZZZZZZZ9.
016100     03  FILLER              PIC  X(08)      VALUE ' READS, '.
016200     03  WS-SM-WRITES        PIC  ZZZZZZZZ9.
016300     03  FILLER              PIC  X(09)      VALUE ' WRITES, '.
016400     03  WS-SM-REWRITES      PIC  ZZZZZZZZ9.
016500     03  FILLER              PIC  X(09)      VALUE ' REWRITES'.
016600/
016700     COPY SS00WS.
016800*
016900 01  FILLER                  PIC  X(12)      VALUE '** WS-END **'.
017000/
017100 LINKAGE SECTION.
017200*
017300****************************
017400*    FILE REQUEST BLOCK    *
017500****************************
017600*
017700     COPY MB00RB REPLACING ==:MB00:== BY ==MTF6==.
017800*
017900******************
018000*    I/O AREA    *
018100******************
018200*
018300     COPY MTFXIO REPLACING ==:MTFX:== BY ==MTF6==.
018400*
018500*********************************
018600*    ABEND ROUTINE WORK AREA    *
018700*********************************
018800*
018900     COPY SS02WS.
019000/
019100 PROCEDURE DIVISION          USING MTF6RB-WORK-AREA,
019200                                   MTF6IO-RECORD,
019300                                   SS02WS-ABEND-WORK-AREA.
019400*
019500 A000-MAIN-LINE-SECTION.
019600*
019700*
019800******************************************
019900*    SET THE ABEND WORK AREA IF THIS     *
020000*    IS THE FIRST CALL OF THE PROGRAM    *
020100******************************************
020200*
020300     IF  WS-FIRST-CALL-SW-IS-YES
020400         PERFORM Z000-PROGRAM-INITIALIZATION
020500            THRU Z099-PI-EXIT.
020600*
020700**************************
020800*    PROCESS THE FILE    *
020900**************************
021000*
021100     PERFORM S000-SEQUENTIAL-ACCESS
021200        THRU S999-SA-EXIT.
021300*
021400************************************************
021500*    MOVE THE STATUS CODE TO ITS RESPECTIVE    *
021600*    FIELD IN COPYBOOK SS02WS.                 *
021700************************************************
021800*
021900     MOVE MTF6RB-STATUS          TO SS02WS-FILE-STATUS.
022000*
022100 A999-GOBACK.
022200*
022300     GOBACK.
022400/
022500 S000-SEQUENTIAL-ACCESS.
022600*
022700     GO TO S110-SA-OPEN-INPUT
022800           S120-SA-OPEN-OUTPUT
022900           S130-SA-OPEN-I-O
023000           S100-SA-INVALID-REQUEST
023100           S100-SA-INVALID-REQUEST
023200           S100-SA-INVALID-REQUEST
023300           S100-SA-INVALID-REQUEST
023400           S100-SA-INVALID-REQUEST
023500           S100-SA-INVALID-REQUEST
023600           S100-SA-INVALID-REQUEST
023700           S100-SA-INVALID-REQUEST
023800           S140-SA-READ-SEQ
023900           S100-SA-INVALID-REQUEST
024000           S150-SA-WRITE
024100           S160-SA-REWRITE
024200           S100-SA-INVALID-REQUEST
024300           S170-SA-CLOSE
024400           DEPENDING ON MTF6RB-IO-REQUEST.
024500*
024600 S100-SA-INVALID-REQUEST.
024700*
024800     MOVE MTF6RB-IO-REQUEST      TO SS02WS-ABEND-REQUEST.
024900     MOVE '- BAD I-O REQ - MTF6' TO SS02WS-ABENDMSG8.
025000     GO TO Z950-ABORT.
025100*
025200 S110-SA-OPEN-INPUT.
025300*
025400     OPEN INPUT MTF6-FILE.
025500*
025600     MOVE 'SEQ'                  TO WS-SM-ACCESS.
025700     MOVE 'INPUT'                TO WS-SM-OPENED.
025800     MOVE '- OPEN  ERROR - MTF6' TO SS02WS-ABENDMSG8.
025900     GO TO S900-SA-CHECK-STATUS.
026000*
026100 S120-SA-OPEN-OUTPUT.
026200*
026300     OPEN OUTPUT MTF6-FILE.
026400*
026500     MOVE 'SEQ'                  TO WS-SM-ACCESS.
026600     MOVE 'OUTPUT'               TO WS-SM-OPENED.
026700     MOVE '- OPEN  ERROR - MTF6' TO SS02WS-ABENDMSG8.
026800     GO TO S900-SA-CHECK-STATUS.
026900*
027000 S130-SA-OPEN-I-O.
027100*
027200     OPEN I-O MTF6-FILE.
027300*
027400     MOVE 'SEQ'                  TO WS-SM-ACCESS.
027500     MOVE 'I-O'                  TO WS-SM-OPENED.
027600     MOVE '- OPEN  ERROR - MTF6' TO SS02WS-ABENDMSG8.
027700     GO TO S900-SA-CHECK-STATUS.
027800*
027900 S140-SA-READ-SEQ.
028000*
028100     READ MTF6-FILE              INTO MTF6IO-RECORD.
028200*
028300     ADD 1                       TO WS-SC-READS.
028400     MOVE '- READ  ERROR - MTF6' TO SS02WS-ABENDMSG8.
028500     GO TO S900-SA-CHECK-STATUS.
028600*
028700 S150-SA-WRITE.
028800*
028900     WRITE MTF6-RECORD           FROM MTF6IO-RECORD.
029000*
029100     ADD 1                       TO WS-SC-WRITES.
029200     MOVE '- WRITE ERROR - MTF6' TO SS02WS-ABENDMSG8.
029300     GO TO S900-SA-CHECK-STATUS.
029400*
029500 S160-SA-REWRITE.
029600*
029700     REWRITE MTF6-RECORD         FROM MTF6IO-RECORD.
029800*
029900     ADD 1                       TO WS-SC-REWRITES.
030000     MOVE '- REWRT ERROR - MTF6' TO SS02WS-ABENDMSG8.
030100     GO TO S900-SA-CHECK-STATUS.
030200*
030300 S170-SA-CLOSE.
030400*
030500     MOVE SPACE                  TO WS-FIRST-CALL-SW.
030600     CLOSE MTF6-FILE.
030700*
030800     PERFORM Z100-DISPLAY-THE-SUMMARY
030900        THRU Z199-DTS-EXIT.
031000*
031100     MOVE '- CLOSE ERROR - MTF6' TO SS02WS-ABENDMSG8.
031200     GO TO S900-SA-CHECK-STATUS.
031300*
031400 S900-SA-CHECK-STATUS.
031500*
031600     MOVE WS-STATUS              TO MTF6RB-STATUS.
031700*
031800     IF  MTF6RB-STATUS IS EQUAL  TO MTF6RB-TEMP-STATUS-1   OR
031900         MTF6RB-STATUS IS EQUAL  TO MTF6RB-TEMP-STATUS-2   OR
032000         MTF6RB-STATUS IS EQUAL  TO MTF6RB-PERM-STATUS-1   OR
032100         MTF6RB-STATUS IS EQUAL  TO MTF6RB-PERM-STATUS-2   OR
032200         MTF6RB-STATUS IS EQUAL  TO MTF6RB-PERM-STATUS-3   OR
032300         MTF6RB-STATUS IS EQUAL  TO MTF6RB-PERM-STATUS-4   OR
032400         MTF6RB-STATUS IS EQUAL  TO MTF6RB-PERM-STATUS-5
032500         MOVE ZERO               TO MTF6RB-TEMP-STATUS-1
032600         MOVE ZERO               TO MTF6RB-TEMP-STATUS-2
032700     ELSE
032800         GO TO Z900-ABORT.
032900*
033000 S999-SA-EXIT.
033100     EXIT.
033200/
033300 Z000-PROGRAM-INITIALIZATION.
033400*
033500************************************************************
033600*    THE CALLING PROGRAM MUST SUPPLY THE PROGRAM ID TO     *
033700*    ENSURE THAT ANY SUBSEQUENT ABEND CAN BE TRACED TO     *
033800*    IT.  IF THE PROGRAM ID IS NOT SUPPLIED, THE ACCESS    *
033900*    ROUTINE ABENDS HERE.                                  *
034000************************************************************
034100*
034200     IF  SS02WS-ABEND-PROG-ID IS EQUAL TO SPACES
034300         MOVE '- BAD PROG NAME - MTF6'
034400                                 TO SS02WS-ABENDMSG8
034500         MOVE 'BADPRO'           TO SS02WS-ABEND-PROG-ID
034600         GO TO Z950-ABORT.
034700*
034800     MOVE SS02WS-ABEND-PROG-ID   TO WS-SM-PROG-ID.
034900*
035000*************************************************************
035100*    SINCE THIS ROUTINE IS PERFORMED ONLY ONCE DURING       *
035200*    THE EXECUTION OF A CALLING PROGRAM, THE FIRST          *
035300*    REQUEST MUST BE FOR AN OPEN.  SET THE ACCESS METHOD    *
035400*    (SEQENTIAL, DYNAMIC, OR RANDOM), OR ISSUE AN ABEND     *
035500*    IF THE REQUEST IS NOT FOR AN OPEN.                     *
035600*************************************************************
035700*
035800     IF  MTF6RB-OPEN-INPUT    OR
035900         MTF6RB-OPEN-OUTPUT   OR
036000         MTF6RB-OPEN-IO
036100         MOVE 'N'                TO WS-FIRST-CALL-SW
036200     ELSE
036300         MOVE 'ILLEGAL ACCESS REQUEST'
036400                                 TO SS02WS-ABENDMSG8
036500         GO TO Z950-ABORT.
036600*
036700 Z099-PI-EXIT.
036800     EXIT.
036900*
037000 Z100-DISPLAY-THE-SUMMARY.
037100*
037200     MOVE WS-SC-READS            TO WS-SM-READS.
037300     MOVE WS-SC-WRITES           TO WS-SM-WRITES.
037400     MOVE WS-SC-REWRITES         TO WS-SM-REWRITES.
037500     DISPLAY WS-SUMMARY-MESSAGE.
037600*
037700     INITIALIZE WS-SUMMARY-COUNTERS.
037800*
037900 Z199-DTS-EXIT.
038000     EXIT.
038100/
038200 Z900-ABORT.
038300*
038400     MOVE 'SMTF6'                TO SS02WS-ABEND-CODE-X.
038500     MOVE MTF6RB-STATUS          TO SS02WS-ABEND-STATUS.
038600     MOVE MTF6RB-IO-REQUEST      TO WS-IO-REQUEST.
038700     MOVE WS-IO-REQUEST          TO SS02WS-ABEND-REQUEST.
038800*
038900 Z950-ABORT.
039000*
039100     PERFORM SS02PD-ABEND        THRU SS02PD-ABEND-EXIT.
039200*
039300 Z999-ABORT-EXIT.
039400     EXIT.
039500/
039600********************************
039700*    STANDARD ABEND ROUTINE    *
039800********************************
039900*
040000     COPY SS02PD.
040100*
