000100 IDENTIFICATION DIVISION.
000200 PROGRAM-ID. MBOMM05.
000201*       RELEASE DATE=08/24/01.        REVISION LEVEL=08.06      *
000202*****************************************************************
000203*WARNING.  THIS COMPUTER PROGRAM IS PROTECTED BY COPYRIGHT LAW  *
000204*AND INTERNATIONAL TREATIES.  UNAUTHORIZED REPRODUCTION OR      *
000205*DISTRIBUTION OF THIS PROGRAM, OR ANY PORTION OF IT, MAY RESULT *
000206*IN SEVERE CIVIL AND CRIMINAL PENATLIES, AND WILL BE PROSECUTED *
000207*TO THE MAXIMUM EXTENT POSSIBLE UNDER THE LAW.                  *
000208*COPYRIGHT 1999 PAYSYS INTERNATIONAL, INC.  ALL RIGHTS RESERVED.*
000209*****************************************************************
000300*****************************************************************
000400*                                                               *
000500*   V - PLUS  M E R C H A N T   B A N K C A R D   S Y S T E M   *
000600*                                                               *
000700*      MBOMM05 - MERCHANT MASTER RECORD ADD/MAINT/INQ           *
000800*                SCREEN 05 AND 06                               *
000900*                                                               *
001000*              1. TRANSIDS                                      *
001100*                 A. MBAM                                       *
001200*                 B. MBMM                                       *
001300*                 C. MBQM                                       *
001400*              2. MAPS USED -                                   *
001500*                 A. MBMM05 (SCREENS 05 AND 06)                 *
001600*              3. FILES USED -                                  *
001700*                 A. MMMM (MERCHANT MASTER FILE)                *
001800*                 B. MMFS (FIELD SECURITY FILE)                 *
001900*                 C. MMSC (SYSTEM FILE)                         *
002000*                 D. MMOC (ORGANIZATION FILE)                   *
002100*                 E. MML1 (LOG FILE)                            *
002200*                                                               *
002300*****************************************************************
002400*
002500 ENVIRONMENT DIVISION.
002600*
002700 DATA DIVISION.
002800*
002900 WORKING-STORAGE SECTION.
003000*
003100 01  FILLER                  PIC  X(12)      VALUE '** WS-BEG **'.
003200*
003300 01  FILLER                  PIC  X(14)      VALUE
003400     'MISCELLANEOUS:'.
003500*
003600 01  WS-MISCELLANEOUS.
003700     03  WS-FIELD-POSITION   PIC S9(03)      BINARY
003800                                             VALUE ZEROES.
003900*
004000     03  WS-TAT-ACCOUNT.
004100         05  WS-TAT-SETT-BILL-IND
004200                             PIC  X(01)      VALUE 'S'.
004300         05  WS-TAT-SETT-BILL-INDEX
004400                             PIC  9(01)      VALUE ZEROS.
004500*
004600     03  WS-NEXT-PROC-GREG   PIC  9(08)      VALUE ZEROES.
004700     03  WS-ACTIVE-DATE-JUL  PIC S9(07)      COMP-3
004800                                             VALUE ZEROES.
004900     03  WS-ACTIVE-DATE-GREG PIC  9(08)      VALUE ZEROES.
005000*
005100 01  FILLER                  PIC  X(17)      VALUE
005200     'PROGRAM SWITCHES:'.
005300*
005400 01  WS-PROGRAM-SWITCHES.
005500     03  WS-PRENOTE-FLAG-ERROR-SW            OCCURS 2 TIMES
005600                                             INDEXED BY
005700                                             X-PRENOTE-INDEX
005800                             PIC  X(01)      VALUE 'N'.
005900         88  PRENOTE-FLAG-ERRORS-EXIST       VALUE 'Y'.
006000         88  NO-PRENOTE-FLAG-ERRORS-EXIST    VALUE 'N'.
006100     03  WS-ACTIVE-ACH-ERROR-SW              OCCURS 2 TIMES
006200                                             INDEXED BY
006300                                             X-ACTIVE-INDEX
006400                             PIC  X(01)      VALUE 'N'.
006500         88  ACTIVE-ACH-ERRORS-EXIST         VALUE 'Y'.
006600         88  NO-ACTIVE-ACH-ERRORS-EXIST      VALUE 'N'.
006700     03  WS-PENDING-ACH-ERROR-SW             OCCURS 2 TIMES
006800                                             INDEXED BY
006900                                             X-PENDING-ACH-INDEX
007000                             PIC  X(01)      VALUE 'N'.
007100         88  PENDING-ACH-ERRORS-EXIST        VALUE 'Y'.
007200         88  NO-PENDING-ACH-ERRORS-EXIST     VALUE 'N'.
007300     03  WS-PENDING-RT-DDA-ERROR-SW          OCCURS 2 TIMES
007400                                             INDEXED BY
007500                                             X-PENDING-RT-INDEX
007600                             PIC  X(01)      VALUE 'N'.
007700         88  PENDING-RT-DDA-ERRORS-EXIST     VALUE 'Y'.
007800         88  NO-PENDING-RT-DDA-ERRORS-EXIST  VALUE 'N'.
007900     03  WS-ACTIVE-RT-DDA-ERROR-SW           OCCURS 2 TIMES
008000                                             INDEXED BY
008100                                             X-ACTIVE-RT-INDEX
008200                             PIC  X(01)      VALUE 'N'.
008300         88  ACTIVE-RT-DDA-ERRORS-EXIST      VALUE 'Y'.
008400         88  NO-ACTIVE-RT-DDA-ERRORS-EXIST   VALUE 'N'.
008500     03  WS-ACTIVE-DATE-ERROR-SW             OCCURS 2 TIMES
008600                                             INDEXED BY
008700                                             X-ACTIVE-DATE-INDEX
008800                             PIC  X(01)      VALUE 'N'.
008900         88  ACTIVE-DATE-ERRORS-EXIST        VALUE 'Y'.
009000         88  NO-ACTIVE-DATE-ERRORS-EXIST     VALUE 'N'.
009100     03  WS-SEND-PRENOTE-SW                  OCCURS 2 TIMES
009200                                             INDEXED BY
009300                                             X-SEND-PRENOTE-INDEX
009400                             PIC  X(01)      VALUE 'N'.
009500         88  PRENOTE-IS-TO-BE-SENT           VALUE 'Y'.
009600         88  NO-PRENOTE-IS-TO-BE-SENT        VALUE 'N'.
009700     03  WS-UPDATE-SW        PIC  X(01)      VALUE 'N'.
009800         88  WS-UPDATE-SW-YES                VALUE 'Y'.
009900         88  WS-UPDATE-SW-NO                 VALUE 'N'.
010000     03  WS-DATA-SW          PIC  X(01)      VALUE 'N'.
010100         88  WS-DATA-CHANGED                 VALUE 'Y'.
010200         88  WS-DATA-NOT-CHANGED             VALUE 'N'.
010300     03  WS-INDEX-X.
010400         05  WS-INDEX        PIC  9(04)      VALUE ZEROS.
010500     03  WS-INDEX-INTERIM-X.
010600         05  WS-INDEX-INTERIM
010700                             PIC  9(04)      VALUE ZEROS.
010800     03  TS-QUEUE-NAME.
010900         05  TS-QN-TERMID    PIC  X(04)      VALUE SPACES.
011000         05  TS-QN-TRANID    PIC  X(04)      VALUE 'MBUI'.
011100/
011200 01  FILLER                  PIC  X(29)      VALUE
011300     'I/O REQUEST BLOCK WORK AREAS:'.
011400*
011500     COPY MBIOWS.
011600/
011700 01  FILLER                  PIC  X(18)      VALUE
011800     'I/O REQUEST BLOCK:'.
011900*
012000     COPY MBIORO.
012100/
012200 01  FILLER                  PIC  X(25)      VALUE
012300     'LOG RECORD REQUEST BLOCK:'.
012400*
012500     COPY MML1WS REPLACING ==:MML1:== BY ==MML1==.
012600/
012700 01  FILLER                  PIC  X(29)      VALUE
012800     'MERCHANT MASTER FIELDS TABLE:'.
012900*
013000     COPY MMMMTB.
013100/
013200 01  FILLER                  PIC  X(35)      VALUE
013300     'MERCHANT MASTER INITIALIZER RECORD:'.
013400*
013500     COPY MMMMIR.
013600/
013700 01  FILLER                  PIC  X(20)      VALUE
013800     'CCS DATE WORK AREAS:'.
013900*
014000     COPY SS01WS.
014100/
014200 01  FILLER                  PIC  X(27)      VALUE
014300     'CCS CHECK DIGIT WORK AREAS:'.
014400*
014500     COPY SS05WS.
014600/
014700 01  FILLER                  PIC  X(15)      VALUE
014800     'CCS WORK AREAS:'.
014900*
015000     COPY SS08WS.
015100/
015200     COPY SS00WS.
015300/
015400     COPY SMFTWS.
015500/
015600     COPY SMPTRL REPLACING ==:SMPT:== BY ==SMPT==.
015700/
015800     COPY MB61LK.
015900/
016000 01  FILLER                  PIC  X(12)      VALUE '** WS-END **'.
016100/
016200 LINKAGE SECTION.
016300*
016400 01  DFHCOMMAREA.
016500*
016600     COPY MB60WS.
016700/
016800*****************************
016900*    MERCHANT MASTER MAP    *
017000*****************************
017100*
017200     COPY MBMM05.
017300/
017400******************************************
017500*    MERCHANT MASTER MAP REDEFINITION    *
017600******************************************
017700*
017800     COPY MBMM05R.
017900/
018000****************************************
018100*    MERCHANT MASTER  RECORD LAYOUT    *
018200****************************************
018300*
018400     COPY MMMMRL.
018500/
018600**************************************
018700*    FIELD SECURITY RECORD LAYOUT    *
018800**************************************
018900*
019000     COPY MMFSRL.
019100/
019200******************************
019300*    SYSTEM RECORD LAYOUT    *
019400******************************
019500*
019600     COPY MMSCRL.
019700/
019800************************************
019900*    ORGANIZATION RECORD LAYOUT    *
020000************************************
020100*
020200     COPY MMOCRL.
020300/
020400***************************
020500*    LOG RECORD LAYOUT    *
020600***************************
020700*
020800     COPY MML1RL REPLACING ==:MML1:== BY ==MML1==.
020900/
021000***************************************
021100*    USER INPUT TEMP STORAGE RECORD   *
021200***************************************
021300*
021400     COPY MBUITS.
021500/
021600 PROCEDURE DIVISION.
021700*
021800 A000-HOUSEKEEPING SECTION.
021900*
022000 A020-INIT.
022100*
022200     MOVE 'PC01'                 TO MBCA-PROGRAM-LOCATION.
022300     PERFORM MB70PD-ON-LINE-HOUSEKEEPING
022400                                 THRU MB70PD-OLH-EXIT.
022500*
022600     IF  MBCA-MBUI-UI-YES
022700         NEXT SENTENCE
022800     ELSE
022900         SET MBCA-MBUI-UI-NO     TO TRUE.
023000*
023100     MOVE MBCA-TERMINAL-ID       TO TS-QN-TERMID.
023200*
023300     IF  MBCA-RECEIVE-SCREEN
023400         GO TO C000-RECEIVE-SCREEN.
023500/
023600 B000-SEND-SCREEN SECTION.
023700*
023800*********************************************
023900*    GET CICS STORAGE NEEDED FOR THE MAP    *
024000*********************************************
024100*
024200     MOVE 'SC01'                 TO MBCA-PROGRAM-LOCATION.
024300     PERFORM MB60PD-GETMAIN-FOR-MAP
024400                                 THRU MB60PD-GFM-EXIT.
024500*
024600*******************************************
024700*    INITIALIZE THE STANDARD MAP LINES    *
024800*******************************************
024900*
025000     PERFORM MB60PD-INIT-STD-MAP-LINES
025100                                 THRU MB60PD-ISML-EXIT.
025200*
025300*****************************************
025400*    READ THE MERCHANT MASTER RECORD    *
025500*    FOR SUBSEQUENT DISPLAY             *
025600*****************************************
025700*
025800     MOVE MBCA-MERCHANT-ORG      TO MBIOWS-MMMM-ORG
025900                                    MM05-ORG.
026000     MOVE MBCA-MERCHANT          TO MBIOWS-MMMM-MERCHANT
026100                                    MM05-MERCHANT.
026200     MOVE 'FC01'                 TO MBCA-PROGRAM-LOCATION.
026300     SET MBIORO-READ-RANDOM      TO TRUE.
026400     PERFORM MMMMAO-ACCESS       THRU MMMMAO-ACCESS-EXIT.
026500*
026600*********************************************
026700*    MOVE THE PRIMARY NAME TO THE SCREEN    *
026800*********************************************
026900*
027000     MOVE MMMM-NA-LINE (1 1)     TO MM05-MERCHANT-NAME.
027100*
027200****************************************
027300*    READ THE FIELD SECURITY RECORD    *
027400****************************************
027500*
027600     MOVE 'FC02'                 TO MBCA-PROGRAM-LOCATION.
027700     PERFORM Y900-READ-MMFS      THRU Y909-READ-MMFS-EXIT.
027800*
027900 B020-MOVE-FIELDS-TO-SCREEN.
028000*
028100*****************************************
028200*    MOVE THE MERCHANT MASTER FIELDS    *
028300*    FROM THE RECORD TO THE SCREEN      *
028400*****************************************
028500*
028600     EVALUATE MBCA-SCREEN-NBR
028700         WHEN 55
028800             SET X-MMMM-SETT-ACH TO +1
028900             MOVE MMMMTB-ACTIVE-DATE-1 (1:4)
029000                                 TO WS-INDEX-X
029100             SET X-MMFS-MERCH    TO WS-INDEX
029200             SET X-MMFS-MERCH    DOWN BY 1
029300         WHEN 56
029400             SET X-MMMM-SETT-ACH TO +3
029500             MOVE MMMMTB-ACTIVE-DATE-3 (1:4)
029600                                 TO WS-INDEX-X
029700             SET X-MMFS-MERCH    TO WS-INDEX
029800             SET X-MMFS-MERCH    DOWN BY 1
029900             SET X-MM05-SETT-INDEX
030000                                 TO +1
030100             MOVE 3              TO MM05-SETT-ACCT-NBR
030200                                    (X-MM05-SETT-INDEX)
030300             SET X-MM05-SETT-INDEX
030400                                 UP BY +1
030500             MOVE 4              TO MM05-SETT-ACCT-NBR
030600                                    (X-MM05-SETT-INDEX)
030700         WHEN OTHER
030800             SET X-MMMM-SETT-ACH TO +1
030900     END-EVALUATE.
031000*
031100     PERFORM
031200         VARYING X-MM05-SETT-INDEX FROM +1 BY +1
031300         UNTIL   X-MM05-SETT-INDEX IS GREATER THAN +2
031400             SET X-MMMM-SETT-ACCT
031500                                 TO X-MMMM-SETT-ACH
031600             PERFORM Y010-MOVE-ACH-PRENOTE-FLAG
031700                                 THRU Y019-EXIT
031800             PERFORM Y030-MOVE-PRENOTE-DATE
031900                                 THRU Y039-EXIT
032000             PERFORM Y050-MOVE-MSA-METHOD
032100                                 THRU Y059-EXIT
032200             PERFORM Y070-MOVE-PENDING-TO-ACTIVE
032300                                 THRU Y079-EXIT
032400             PERFORM Y090-MOVE-ISA-METHOD
032500                                 THRU Y099-EXIT
032600             PERFORM Y110-MOVE-ACTIVE-CR-ACCT-TYPE
032700                                 THRU Y119-EXIT
032800             PERFORM Y130-MOVE-ACTIVE-CR-RT
032900                                 THRU Y139-EXIT
033000             PERFORM Y150-MOVE-PENDING-CR-ACCT-TYPE
033100                                 THRU Y159-EXIT
033200             PERFORM Y170-MOVE-PENDING-CR-RT
033300                                 THRU Y179-EXIT
033400             PERFORM Y190-MOVE-ACTIVE-CR-DDA
033500                                 THRU Y199-EXIT
033600             PERFORM Y210-MOVE-PENDING-CR-DDA
033700                                 THRU Y219-EXIT
033800             PERFORM Y230-MOVE-ACTIVE-DR-ACCT-TYPE
033900                                 THRU Y239-EXIT
034000             PERFORM Y250-MOVE-ACTIVE-DR-RT
034100                                 THRU Y259-EXIT
034200             PERFORM Y270-MOVE-PENDING-DR-ACCT-TYPE
034300                                 THRU Y279-EXIT
034400             PERFORM Y290-MOVE-PENDING-DR-RT
034500                                 THRU Y299-EXIT
034600             PERFORM Y310-MOVE-ACTIVE-DR-DDA
034700                                 THRU Y319-EXIT
034800             PERFORM Y330-MOVE-PENDING-DR-DDA
034900                                 THRU Y339-EXIT
035000             SET X-MMMM-SETT-ACH UP BY +1
035100     END-PERFORM.
035200*
035300******************************************
035400*    SET THE CURSOR AND SCREEN NUMBER    *
035500******************************************
035600*
035700     IF  MBCA-PTI-FUNCTION-IS-INQUIRY
035800         MOVE SS08WS-CURSOR      TO MM05-ALT-TRANID-L
035900     ELSE
036000         PERFORM Y800-SET-CURSOR THRU Y809-SC-EXIT.
036100*
036200     COMPUTE MBCA-SCREEN-NBR     =  MBCA-SCREEN-NBR - 50.
036300*
036400**********************
036500*    SEND THE MAP    *
036600**********************
036700*
036800     MOVE 'BM01'                 TO MBCA-PROGRAM-LOCATION.
036900*
037000     PERFORM MB60PD-SEND-MAP-WITH-ERASE
037100                                 THRU MB60PD-SMWE-EXIT.
037200*
037300************************
037400*    RETURN TO CICS    *
037500************************
037600*
037700     MOVE 'PC02'                 TO MBCA-PROGRAM-LOCATION.
037800     PERFORM MB70PD-RETURN-TRANS-ID
037900                                 THRU MB70PD-RTI-EXIT.
038000/
038100 C000-RECEIVE-SCREEN SECTION.
038200*
038300******************************************
038400*    THIS SECTION RECEIVES THE SCREEN    *
038500******************************************
038600*
038700     IF  MBCA-MBUI-UI-YES
038800*
038900****************************************************************
039000*    ACQUIRE MAIN STORAGE FOR TEMP STORAGE RECORD              *
039100****************************************************************
039200*
039300         MOVE 'TS01'             TO MBCA-PROGRAM-LOCATION
039400         EXEC CICS GETMAIN
039500                   FLENGTH (LENGTH  OF MBUITS-RECORD)
039600
039700                   SET     (ADDRESS OF MBUITS-RECORD)
039800
039900              END-EXEC
040000*
040100***********************************************
040200*    READ THE TEMP STORAGE RECORD             *
040300***********************************************
040400*
040500         MOVE 'TS02'             TO MBCA-PROGRAM-LOCATION
040600*
040700         EXEC CICS READQ TS
040800                   QUEUE   (TS-QUEUE-NAME)
040900                   INTO    (MBUITS-RECORD)
041000                   LENGTH  (LENGTH  OF MBUITS-RECORD)
041100                   ITEM    (1)
041200              END-EXEC
041300*
041400***********************************************
041500*    DELETE THE TEMP STORAGE RECORD           *
041600***********************************************
041700*
041800         MOVE 'TS03'             TO MBCA-PROGRAM-LOCATION
041900*
042000         EXEC CICS IGNORE CONDITION
042100                   QIDERR
042200              END-EXEC
042300*
042400         EXEC CICS DELETEQ TS
042500                   QUEUE  (TS-QUEUE-NAME)
042600              END-EXEC
042700         MOVE 'SC02'             TO MBCA-PROGRAM-LOCATION
042800         PERFORM MB60PD-GETMAIN-FOR-MAP
042900                                 THRU MB60PD-GFM-EXIT
043000         MOVE MBUITS-VAR-DATA    TO MBMM05I
043100     ELSE
043200         MOVE 'BM02'             TO MBCA-PROGRAM-LOCATION
043300         PERFORM MB60PD-RECEIVE-MAP
043400                                 THRU MB60PD-RM-EXIT.
043500*
043600**************************************************************
043700*    CHECK FOR ANOTHER TRANSACTION ID ENTERED BY THE USER    *
043800**************************************************************
043900*
044000     MOVE 'PC03'                 TO MBCA-PROGRAM-LOCATION.
044100     PERFORM MB60PD-NEW-TRANS-ROUTINE
044200                                 THRU MB60PD-NTR-EXIT.
044300*
044400****************************************************
044500*    BYPASS ALL SCREEN EDITS IF THIS IS INQIURY    *
044600****************************************************
044700*
044800     IF  MBCA-PTI-FUNCTION-IS-INQUIRY
044900         GO TO F000-SETUP-COMMAREA.
045000*
045100********************************
045200*    READ THE SYSTEM RECORD    *
045300********************************
045400*
045500     MOVE ZEROES                 TO MBIOWS-MMSC-KEY.
045600     SET MBIORO-READ-RANDOM      TO TRUE.
045700     MOVE 'FC03'                 TO MBCA-PROGRAM-LOCATION.
045800     PERFORM MMSCAO-ACCESS       THRU MMSCAO-ACCESS-EXIT.
045900*
046000**************************************
046100*    READ THE ORGANIZATION RECORD    *
046200**************************************
046300*
046400     MOVE MBCA-MERCHANT-ORG      TO MBIOWS-MMOC-ORG.
046500     SET MBIORO-READ-RANDOM      TO TRUE.
046600     MOVE 'FC04'                 TO MBCA-PROGRAM-LOCATION.
046700     PERFORM MMOCAO-ACCESS       THRU MMOCAO-ACCESS-EXIT.
046800*
046900*****************************************
047000*    READ THE MERCHANT MASTER RECORD    *
047100*****************************************
047200*
047300*
047400     IF  MBCA-PTI-FUNCTION-IS-ADD
047500     AND MBCA-MBUI-UI-YES
047600     AND MBCA-MBUI-UI-UPDATE-NO
047700         MOVE 'SC03'             TO MBCA-PROGRAM-LOCATION
047800         SET MBIORO-GETMAIN      TO TRUE
047900         PERFORM MMMMAO-ACCESS   THRU MMMMAO-ACCESS-EXIT
048000         MOVE MMMMIR-RECORD      TO MMMM-RECORD
048100     ELSE
048200         MOVE SS08WS-CICS-FC-NOTFND TO MBIORO-TEMP-STATUS-1
048300         MOVE MBCA-MERCHANT-ORG  TO MBIOWS-MMMM-ORG
048400                                    MM05-ORG
048500         MOVE MBCA-MERCHANT      TO MBIOWS-MMMM-MERCHANT
048600                                    MM05-MERCHANT
048700         MOVE 'FC05'             TO MBCA-PROGRAM-LOCATION
048800         SET MBIORO-READ-RANDOM  TO TRUE
048900         PERFORM MMMMAO-ACCESS   THRU MMMMAO-ACCESS-EXIT
049000         IF  SS08WS-RC-FC-NOTFND
049100         AND MBCA-MBUI-UI-YES
049200             MOVE 'MBUI'         TO MBCA-TRANS-ID
049300                                    MBCA-PREV-TRANS-ID
049400             MOVE 01             TO MBCA-SCREEN-NBR
049500             MOVE 'MER'          TO MM05-FILLER
049600             SET MBCA-MBUI-ERROR-YES
049700                                 TO TRUE
049800             GO TO F000-SETUP-COMMAREA.
049900*
050000     IF (MBCA-PTI-FUNCTION-IS-MAINT
050100     AND MBCA-MBUI-UI-YES
050200     AND (MMMM-REC-PURGED
050300       OR MMMM-REC-INCOMPLETE))
050400     OR
050500        (MBCA-PTI-FUNCTION-IS-ADD
050600     AND MBCA-MBUI-UI-YES
050700     AND MMMM-REC-PURGED)
050800         MOVE 'MBUI'             TO MBCA-TRANS-ID
050900                                    MBCA-PREV-TRANS-ID
051000         MOVE 01                 TO MBCA-SCREEN-NBR
051100         MOVE 'MER'              TO MM05-FILLER
051200         SET MBCA-MBUI-ERROR-YES
051300                                 TO TRUE
051400         GO TO F000-SETUP-COMMAREA.
051500*
051600*********************************************
051700*    MOVE THE PRIMARY NAME TO THE SCREEN    *
051800*    AND OTHER FIELDS TO WS THAT ARE        *
051900*    NEEDED BY THE EDITS                    *
052000*********************************************
052100*
052200     MOVE MMMM-NA-LINE (1 1)     TO MM05-MERCHANT-NAME.
052300*
052400****************************************
052500*    READ THE FIELD SECURITY RECORD    *
052600****************************************
052700*
052800     MOVE 'FC06'                 TO MBCA-PROGRAM-LOCATION.
052900     PERFORM Y900-READ-MMFS      THRU Y909-READ-MMFS-EXIT.
053000*
053100     EVALUATE MBCA-SCREEN-NBR
053200         WHEN 05
053300             SET X-MMMM-SETT-ACH TO +1
053400             MOVE MMMMTB-ACTIVE-DATE-1 (1:4)
053500                                 TO WS-INDEX-X
053600             SET X-MMFS-MERCH    TO WS-INDEX
053700             SET X-MMFS-MERCH    DOWN BY +1
053800         WHEN 06
053900             SET X-MMMM-SETT-ACH TO +3
054000             MOVE MMMMTB-ACTIVE-DATE-3 (1:4)
054100                                 TO WS-INDEX-X
054200             SET X-MMFS-MERCH    TO WS-INDEX
054300             SET X-MMFS-MERCH    DOWN BY +1
054400     END-EVALUATE.
054500*
054600     SET X-MMMM-SETT-ACCT        TO X-MMMM-SETT-ACH.
054700*
054800 C020-FIELD-EDITS.
054900*
055000*********************
055100*    FIELD EDITS    *
055200*********************
055300*
055400     PERFORM
055500         VARYING X-MM05-SETT-INDEX FROM +1 BY +1
055600         UNTIL   X-MM05-SETT-INDEX IS GREATER THAN +2
055700             SET X-PRENOTE-INDEX TO X-MM05-SETT-INDEX
055800             SET X-ACTIVE-INDEX  TO X-MM05-SETT-INDEX
055900             SET X-PENDING-ACH-INDEX
056000                                 TO X-MM05-SETT-INDEX
056100             SET X-PENDING-RT-INDEX
056200                                 TO X-MM05-SETT-INDEX
056300             SET X-ACTIVE-RT-INDEX
056400                                 TO X-MM05-SETT-INDEX
056500             SET X-ACTIVE-DATE-INDEX
056600                                 TO X-MM05-SETT-INDEX
056700             SET X-SEND-PRENOTE-INDEX
056800                                 TO X-MM05-SETT-INDEX
056900             PERFORM W010-EDIT-ACH-PRENOTE-FLAG
057000                                 THRU W019-EXIT
057100             PERFORM Y030-MOVE-PRENOTE-DATE
057200                                 THRU Y039-EXIT
057300             PERFORM W050-EDIT-MSA-METHOD
057400                                 THRU W059-EXIT
057500             PERFORM W070-EDIT-PENDING-TO-ACTIVE
057600                                 THRU W079-EXIT
057700             PERFORM W090-EDIT-ISA-METHOD
057800                                 THRU W099-EXIT
057900             PERFORM Y110-MOVE-ACTIVE-CR-ACCT-TYPE
058000                                 THRU Y119-EXIT
058100             PERFORM Y130-MOVE-ACTIVE-CR-RT
058200                                 THRU Y139-EXIT
058300             PERFORM W150-EDIT-PENDING-CR-ACCT-TYPE
058400                                 THRU W159-EXIT
058500             PERFORM W170-EDIT-PENDING-CR-RT
058600                                 THRU W179-EXIT
058700             PERFORM Y190-MOVE-ACTIVE-CR-DDA
058800                                 THRU Y199-EXIT
058900             PERFORM W210-EDIT-PENDING-CR-DDA
059000                                 THRU W219-EXIT
059100             PERFORM Y230-MOVE-ACTIVE-DR-ACCT-TYPE
059200                                 THRU Y239-EXIT
059300             PERFORM Y250-MOVE-ACTIVE-DR-RT
059400                                 THRU Y259-EXIT
059500             PERFORM W270-EDIT-PENDING-DR-ACCT-TYPE
059600                                 THRU W279-EXIT
059700             PERFORM W290-EDIT-PENDING-DR-RT
059800                                 THRU W299-EXIT
059900             PERFORM Y310-MOVE-ACTIVE-DR-DDA
060000                                 THRU Y319-EXIT
060100             PERFORM W330-EDIT-PENDING-DR-DDA
060200                                 THRU W339-EXIT
060300             PERFORM W510-CROSS-EDITS
060400                                 THRU W549-ACE-EXIT
060500             SET X-MMMM-SETT-ACH UP BY +1
060600             SET X-MMMM-SETT-ACCT UP BY +1
060700     END-PERFORM.
060800/
060900 D000-RETURN-ERRORS SECTION.
061000*
061100     IF  SS08WS-ERROR-SW-NO
061200         GO TO E000-UPDT-FILE.
061300*
061400     IF  MBCA-MBUI-UI-YES
061500         MOVE 'MBUI'             TO MBCA-TRANS-ID
061600                                    MBCA-PREV-TRANS-ID
061700         MOVE 01                 TO MBCA-SCREEN-NBR
061800         SET MBCA-MBUI-ERROR-YES TO TRUE
061900         GO TO F090-TRANSFER-XCTL.
062000*
062100***************************************************************
062200*    INITIALIZE THE STANDARD MAP LINES.  IN AN ERROR          *
062300*    CONDITION, THIS ROUTINE IS PERFORMED PRIMARILY           *
062400*    TO UPDATE THE DATE AND TIME ON THE SCREEN.               *
062500***************************************************************
062600*
062700     PERFORM MB60PD-INIT-STD-MAP-LINES
062800                                 THRU MB60PD-ISML-EXIT.
062900*
063000**********************
063100*    SEND THE MAP    *
063200**********************
063300*
063400     MOVE 'BM03'                 TO MBCA-PROGRAM-LOCATION.
063500     PERFORM MB60PD-SEND-MAP-DATA-ONLY
063600                                 THRU MB60PD-SMDO-EXIT.
063700*
063800************************
063900*    RETURN TO CICS    *
064000************************
064100*
064200     MOVE 'PC04'                 TO MBCA-PROGRAM-LOCATION.
064300     PERFORM MB70PD-RETURN-TRANS-ID
064400                                 THRU MB70PD-RTI-EXIT.
064500/
064600 E000-UPDT-FILE SECTION.
064700*
064800     IF  MBCA-MBUI-UI-YES
064900         SET MBCA-MBUI-ERROR-NO  TO TRUE.
065000*
065100     IF  MBCA-MBUI-UI-YES
065200     AND MBCA-MBUI-UI-UPDATE-NO
065300         GO TO F090-TRANSFER-XCTL.
065400*
065500****************************************************
065600*    READ THE MERCHANT MASTER RECORD FOR UPDATE    *
065700****************************************************
065800*
065900     MOVE 'FC07'                 TO MBCA-PROGRAM-LOCATION.
066000     SET MBIORO-READ-RANDOM-UPDATE
066100                                 TO TRUE.
066200     PERFORM MMMMAO-ACCESS       THRU MMMMAO-ACCESS-EXIT.
066300*
066400*************************************
066500*    OBTAIN STORAGE FOR LOG FILE    *
066600*    RECORD IF DOING MAINTENANCE    *
066700*************************************
066800*
066900     IF  MBCA-PTI-FUNCTION-IS-ADD
067000         GO TO E020-UPDT-FIELDS.
067100*
067200     MOVE 'SC04'                 TO MBCA-PROGRAM-LOCATION.
067300     SET MBIORO-GETMAIN          TO TRUE.
067400     PERFORM MML1AO-ACCESS       THRU MML1AO-ACCESS-EXIT.
067500*
067600*************************************************
067700*    SET UP THE COMMON PORTION OF THE RECORD    *
067800*************************************************
067900*
068000     MOVE 'MM'                   TO MML1-FILE-CODE.
068100     MOVE MBCA-MERCHANT-ORG      TO MML1-MMMM-ORG.
068200     MOVE MBCA-MERCHANT          TO MML1-MMMM-MERCHANT.
068300     MOVE MBCA-SIGNON-NAME       TO MML1-SIGNON-NAME.
068400     MOVE MBCA-TERMINAL-ID       TO MML1-TERMINAL-ID.
068500     MOVE ZEROS                  TO MML1-SOURCE-CODE.
068600     MOVE MBCA-FIELD-SECURITY    TO MML1-FIELD-SECURITY.
068700*
068800 E020-UPDT-FIELDS.
068900*
069000     EVALUATE MBCA-SCREEN-NBR
069100         WHEN 05
069200             SET X-MMMM-SETT-ACH TO +1
069300             MOVE MMMMTB-ACTIVE-DATE-1 (1:4)
069400                                 TO WS-INDEX-X
069500             SET X-MMFS-MERCH    TO WS-INDEX
069600             SET X-MMFS-MERCH    DOWN BY +1
069700         WHEN 06
069800             SET X-MMMM-SETT-ACH TO +3
069900             MOVE MMMMTB-ACTIVE-DATE-3 (1:4)
070000                                 TO WS-INDEX-X
070100             SET X-MMFS-MERCH    TO WS-INDEX
070200             SET X-MMFS-MERCH    DOWN BY +1
070300     END-EVALUATE.
070400*
070500     PERFORM
070600         VARYING X-MM05-SETT-INDEX FROM +1 BY +1
070700         UNTIL   X-MM05-SETT-INDEX IS GREATER THAN +2
070800             PERFORM X010-UPDT-ACH-PRENOTE-FLAG
070900                                 THRU X019-EXIT
071000             PERFORM X030-UPDT-PRENOTE-DATE
071100                                 THRU X039-EXIT
071200             PERFORM X050-UPDT-MSA-METHOD
071300                                 THRU X059-EXIT
071400             PERFORM X070-UPDT-PENDING-TO-ACTIVE
071500                                 THRU X079-EXIT
071600             PERFORM X090-UPDT-ISA-METHOD
071700                                 THRU X099-EXIT
071800             PERFORM X150-UPDT-PENDING-CR-ACCT-TYPE
071900                                 THRU X159-EXIT
072000             PERFORM X170-UPDT-PENDING-CR-RT
072100                                 THRU X179-EXIT
072200             PERFORM X210-UPDT-PENDING-CR-DDA
072300                                 THRU X219-EXIT
072400             PERFORM X270-UPDT-PENDING-DR-ACCT-TYPE
072500                                 THRU X279-EXIT
072600             PERFORM X290-UPDT-PENDING-DR-RT
072700                                 THRU X299-EXIT
072800             PERFORM X330-UPDT-PENDING-DR-DDA
072900                                 THRU X339-EXIT
073000             SET X-MMMM-SETT-ACH UP BY +1
073100     END-PERFORM.
073200*
073300 E040-UPDT-MMMM.
073400*
073500     IF  MBCA-PTI-FUNCTION-IS-ADD
073600         MOVE MBCA-SCREEN-NBR    TO MMMM-ONLINE-STATUS
073700         MOVE MBCA-START-DATE    TO MMMM-LAST-MAINT-DATE
073800         MOVE MBCA-OPERATOR-ID   TO MMMM-LAST-MAINT-OPER
073900         SET WS-UPDATE-SW-YES    TO TRUE.
074000*
074100**************************************************************
074200*    WRITE A LOG RECORD TO SHOW THAT THE LAST MAINT DATE     *
074300*    AND OPERATOR HAS BEEN UPDATED IF FIELDS WERE CHANGED    *
074400*    ON THE SCREEN                                           *
074500**************************************************************
074600*
074700     IF  MBCA-PTI-FUNCTION-IS-MAINT
074800     AND WS-UPDATE-SW-YES
074900         MOVE 0198               TO MML1-FIELD-CODE
075000         MOVE ZEROES             TO MML1-FIELD-OCCURRENCE
075100                                    MML1-FIELD-OCCURRENCE-2
075200         MOVE MML1WS-VL-03       TO MML1-VARIABLE-LENGTH
075300         MOVE MMMM-LAST-MAINT-OPER
075400                                 TO MML1-VL03-B-DATA-X
075500         MOVE MBCA-OPERATOR-ID   TO MMMM-LAST-MAINT-OPER
075600         MOVE MMMM-LAST-MAINT-OPER
075700                                 TO MML1-VL03-A-DATA-X
075800         MOVE 'FC08'             TO MBCA-PROGRAM-LOCATION
075900         PERFORM Y910-WRITE-LOG-RECORD
076000                                 THRU Y919-WLR-EXIT
076100         MOVE 0199               TO MML1-FIELD-CODE
076200         MOVE MML1WS-VL-07       TO MML1-VARIABLE-LENGTH
076300         MOVE MMMM-LAST-MAINT-DATE
076400                                 TO MML1-VL07-B-DATA-9
076500         MOVE MBCA-START-DATE    TO MMMM-LAST-MAINT-DATE
076600         MOVE MMMM-LAST-MAINT-DATE
076700                                 TO MML1-VL07-A-DATA-9
076800         MOVE 'FC09'             TO MBCA-PROGRAM-LOCATION
076900         PERFORM Y910-WRITE-LOG-RECORD
077000                                 THRU Y919-WLR-EXIT.
077100*
077200****************************************************
077300*    REWRITE THE MERCHANT MASTER RECORD IF         *
077400*    FIELDS HAVE BEEN CHANGED ON THE SCREEN, OR    *
077500*    UNLOCK IT IF THEY HAVE NOT                    *
077600****************************************************
077700*
077800     IF  WS-UPDATE-SW-YES
077900         MOVE 'FC10'             TO MBCA-PROGRAM-LOCATION
078000         SET MBIORO-REWRITE      TO TRUE
078100         PERFORM MMMMAO-ACCESS   THRU MMMMAO-ACCESS-EXIT
078200     ELSE
078300         MOVE 'FC11'             TO MBCA-PROGRAM-LOCATION
078400         SET MBIORO-UNLOCK       TO TRUE
078500         PERFORM MMMMAO-ACCESS   THRU MMMMAO-ACCESS-EXIT.
078600/
078700 F000-SETUP-COMMAREA SECTION.
078800*
078900***************************************************************
079000*  SET UP COMMAREA FIELDS AND TRANSFER TO THE NEXT PROGRAM    *
079100***************************************************************
079200*
079300     MOVE MBCA-EIBAID            TO SS08WS-EIBAID.
079400*
079500     IF  MM05-CURRENT-PAGE-L IS GREATER THAN ZERO
079600     AND MM05-CURRENT-PAGE   IS NUMERIC
079700         IF  MM05-CURRENT-PAGE IS GREATER THAN 13
079800             MOVE 63             TO MBCA-SCREEN-NBR
079900             GO TO F090-TRANSFER-XCTL.
080000*
080100     PERFORM MB60PD-EDIT-PAGE-NBR
080200                                 THRU MB60PD-EPN-EXIT.
080300*
080400     IF  SS08WS-VALID-PF-KEY
080500     OR  SS08WS-EIBAID-VALID-PF-KEY
080600         SET MBCA-INITIAL-SCREEN-NBR
080700                                 TO TRUE.
080800*
080900 F090-TRANSFER-XCTL.
081000*
081100     IF  MBCA-MBUI-UI-YES
081200         MOVE 'MBUI'             TO MBCA-TRANS-ID
081300                                    MBCA-PREV-TRANS-ID
081400         MOVE 01                 TO MBCA-SCREEN-NBR
081500         MOVE MBMM05I            TO MBUITS-VAR-DATA
081600         MOVE LENGTH OF MBMM05I  TO MBUITS-VAR-LENGTH
081700         MOVE 'TS10'             TO MBCA-PROGRAM-LOCATION
081800         EXEC CICS WRITEQ TS
081900                   QUEUE   (TS-QUEUE-NAME)
082000                   FROM    (MBUITS-RECORD)
082100                   LENGTH  (LENGTH  OF MBUITS-RECORD)
082200
082300              END-EXEC.
082400*
082500     MOVE 'PC05'                 TO MBCA-PROGRAM-LOCATION.
082600     PERFORM MB70PD-XCTL-TO-MBOXCTL
082700                                 THRU MB70PD-XTM-EXIT.
082800/
082900 X000-FIELD-EDITS SECTION.
083000*
083100*********************************************************
083200*    EACH FIELD IS CODED IN A SEPERATE ROUTINE, AND     *
083300*    IN A LIKE MANNER.  THE COMMENTS FOR THE FLOW OF    *
083400*    THE EDIT ROUTINES CAN BE FOUND IN ROUTINES         *
083500*    'W010-EDIT-ACH-PRENOTE-FLAG'  THRU 'W019-EXIT'     *
083600*    EACH ROUTINE MAY CONTAIN COMMENTS, BUT THEY        *
083700*    ARE UNIQUE TO THAT ROUTINE.                        *
083800*********************************************************
083900*
084000 W010-EDIT-ACH-PRENOTE-FLAG.
084100*
084200     MOVE DFHBMDAS               TO MM05-PRENOTE-CONTROL-LP-A
084300                                    (X-MM05-SETT-INDEX)
084400                                    MM05-PRENOTE-CONTROL-RP-A
084500                                    (X-MM05-SETT-INDEX).
084600     MOVE DFHBMASK               TO MM05-PRENOTE-CONTROL-A
084700                                    (X-MM05-SETT-INDEX).
084800*
084900     PERFORM Y015-ACH-PRENOTE-FLAG-SECURITY
085000                                 THRU Y019-EXIT.
085100*
085200     IF  MM05-PRENOTE-CONTROL-L (X-MM05-SETT-INDEX)
085300                                 IS GREATER THAN ZERO
085400         MOVE DFHBMASF           TO MM05-PRENOTE-CONTROL-A
085500                                    (X-MM05-SETT-INDEX)
085600     ELSE
085700         MOVE MMMM-PRENOTE-CONTROL (X-MMMM-SETT-ACH)
085800                                 TO MM05-PRENOTE-CONTROL
085900                                    (X-MM05-SETT-INDEX).
086000*
086100     MOVE MM05-PRENOTE-CONTROL (X-MM05-SETT-INDEX)
086200                                 TO MMMM-PRENOTE-CONTROL
086300                                    (X-MMMM-SETT-ACH).
086400*
086500     IF  NOT MMMM-VALID-PRENOTE-CONTROL (X-MMMM-SETT-ACH)
086600         GO TO W018-ACH-PRENOTE-FLAG-ERROR.
086700*
086800     IF  MM05-PRENOTE-CONTROL-L (X-MM05-SETT-INDEX)
086900                                 IS GREATER THAN ZERO
087000         IF  MMMM-SEND-PRENOTE (X-MMMM-SETT-ACH)
087100             MOVE MMOC-DATE-NEXT-PROC
087200                                 TO MMMM-DATE-PRENOTE-INIT
087300                                    (X-MMMM-SETT-ACH)
087400                                    SS01WS-JULIAN
087500             PERFORM SS26PD-NUMERICALLY-EDIT-DATE
087600                                 THRU SS26PD-NED-EXIT
087700             MOVE SS01WS-XX-XX-YYYY
087800                                 TO MM05-PRENOTE-DATE
087900                                    (X-MM05-SETT-INDEX)
088000             MOVE +10            TO MM05-PRENOTE-DATE-L
088100                                    (X-MM05-SETT-INDEX)
088200         ELSE
088300             MOVE ZEROES         TO MMMM-DATE-PRENOTE-INIT
088400                                    (X-MMMM-SETT-ACH)
088500                                    SS01WS-EDIT-YYYY
088600             MOVE SS01WS-EDIT-X  TO MM05-PRENOTE-DATE
088700                                    (X-MM05-SETT-INDEX)
088800             MOVE +10            TO MM05-PRENOTE-DATE-L
088900                                    (X-MM05-SETT-INDEX).
089000*
089100     IF  MBCA-PTI-FUNCTION-IS-MAINT
089200     OR  MM05-PRENOTE-CONTROL-L (X-MM05-SETT-INDEX)
089300                                 IS GREATER THAN ZERO
089400     OR  NOT MMFS-MT-REQUIRED (X-MMFS-MERCH)
089500         GO TO W019-EXIT.
089600*
089700 W018-ACH-PRENOTE-FLAG-ERROR.
089800*
089900     IF  MM05-PRENOTE-CONTROL-L (X-MM05-SETT-INDEX)
090000                                 IS GREATER THAN ZERO
090100         MOVE DFHBMUBF           TO MM05-PRENOTE-CONTROL-A
090200                                    (X-MM05-SETT-INDEX)
090300     ELSE
090400         MOVE DFHBMBRY           TO MM05-PRENOTE-CONTROL-A
090500                                    (X-MM05-SETT-INDEX).
090600*
090700     SET SS08WS-ERROR-SW-YES     TO TRUE.
090800     SET PRENOTE-FLAG-ERRORS-EXIST (X-PRENOTE-INDEX)
090900                                 TO TRUE.
091000     MOVE DFHBMASB               TO MM05-PRENOTE-CONTROL-LP-A
091100                                    (X-MM05-SETT-INDEX)
091200                                    MM05-PRENOTE-CONTROL-RP-A
091300                                    (X-MM05-SETT-INDEX).
091400     MOVE SS08WS-CURSOR          TO MM05-PRENOTE-CONTROL-L
091500                                    (X-MM05-SETT-INDEX).
091600*
091700 W019-EXIT.
091800     EXIT.
091900*
092000 W050-EDIT-MSA-METHOD.
092100*
092200     MOVE DFHBMDAS               TO MM05-MSA-METHOD-LP-A
092300                                    (X-MM05-SETT-INDEX)
092400                                    MM05-MSA-METHOD-RP-A
092500                                    (X-MM05-SETT-INDEX).
092600     MOVE DFHBMASK               TO MM05-MSA-METHOD-A
092700                                    (X-MM05-SETT-INDEX).
092800*
092900     PERFORM Y055-MSA-METHOD-SECURITY
093000                                 THRU Y059-EXIT.
093100*
093200     IF  MM05-MSA-METHOD-L (X-MM05-SETT-INDEX)
093300                                 IS GREATER THAN ZERO
093400         MOVE DFHBMASF           TO MM05-MSA-METHOD-A
093500                                    (X-MM05-SETT-INDEX)
093600     ELSE
093700         MOVE MMMM-PENDING-SETT-ACCT-METH (X-MMMM-SETT-ACH)
093800                                 TO MM05-MSA-METHOD
093900                                    (X-MM05-SETT-INDEX).
094000*
094100     IF  NOT MM05-VALID-MSA-METHODS (X-MM05-SETT-INDEX)
094200         GO TO W058-MSA-METHOD-ERROR.
094300*
094400     IF  MBCA-PTI-FUNCTION-IS-MAINT
094500     OR  MM05-MSA-METHOD-L (X-MM05-SETT-INDEX)
094600                                 IS GREATER THAN ZERO
094700     OR  NOT MMFS-MT-REQUIRED (X-MMFS-MERCH)
094800         GO TO W059-EXIT.
094900*
095000 W058-MSA-METHOD-ERROR.
095100*
095200     IF  MM05-MSA-METHOD-L (X-MM05-SETT-INDEX)
095300                                 IS GREATER THAN ZERO
095400         MOVE DFHBMUBF           TO MM05-MSA-METHOD-A
095500                                    (X-MM05-SETT-INDEX)
095600     ELSE
095700         MOVE DFHBMBRY           TO MM05-MSA-METHOD-A
095800                                    (X-MM05-SETT-INDEX).
095900*
096000     SET SS08WS-ERROR-SW-YES     TO TRUE.
096100     MOVE DFHBMASB               TO MM05-MSA-METHOD-LP-A
096200                                    (X-MM05-SETT-INDEX)
096300                                    MM05-MSA-METHOD-RP-A
096400                                    (X-MM05-SETT-INDEX).
096500     MOVE SS08WS-CURSOR          TO MM05-MSA-METHOD-L
096600                                    (X-MM05-SETT-INDEX).
096700*
096800 W059-EXIT.
096900     EXIT.
097000*
097100 W070-EDIT-PENDING-TO-ACTIVE.
097200*
097300*****************************************************
097400*    SET THE ATTRIBUTES TO WHAT THEY WOULD BE IF    *
097500*    SOMETHING WERE KEYED AND THE EDITS PASSED.     *
097600*****************************************************
097700*
097800     MOVE DFHBMDAS               TO MM05-PENDING-DATE-LP-A
097900                                    (X-MM05-SETT-INDEX)
098000                                    MM05-PENDING-DATE-RP-A
098100                                    (X-MM05-SETT-INDEX).
098200     MOVE DFHBMASK               TO MM05-PENDING-DATE-A
098300                                    (X-MM05-SETT-INDEX).
098400*
098500************************************************************
098600*    THE SECURITY ROUTINE IS PERFORMED TO SET THE FIELD    *
098700*    ATTRIBUTES ACCORDING TO THE SECURITY PROFILE.  IT     *
098800*    WAS ALSO PERFORMED IN THE B000-SEND-SCREEN SECTION    *
098900*    OF THIS PROGRAM.  IF THIS FIELD IS (OR WAS)           *
099000*    PROTECTED AS A RESULT OF THIS ROUTINE, THE LENGTH     *
099100*    RETURNED WILL BE ZERO.                                *
099200************************************************************
099300*
099400     PERFORM Y075-PENDING-TO-ACTIVE-SECUR
099500                                 THRU Y079-EXIT.
099600*
099700************************
099800*    EDIT THE FIELD    *
099900************************
100000*
100100     IF  MM05-PENDING-DATE-L (X-MM05-SETT-INDEX)
100200                                 IS GREATER THAN ZERO
100300         MOVE DFHBMASF           TO MM05-PENDING-DATE-A
100400                                    (X-MM05-SETT-INDEX)
100500     ELSE
100600         MOVE MMMM-DATE-PENDING-ACH-ACTIVE (X-MMMM-SETT-ACH)
100700                                 TO SS01WS-JULIAN
100800         PERFORM SS08PD-JUL-TO-GREG
100900                                 THRU SS08PD-JTG-EXIT
101000         MOVE SS01WS-DATE        TO MM05-PENDING-DATE
101100                                    (X-MM05-SETT-INDEX).
101200*
101300     IF  MM05-PENDING-DATE (X-MM05-SETT-INDEX) IS NOT NUMERIC
101400         GO TO W078-PENDING-TO-ACTIVE-ERROR.
101500*
101600     IF  MM05-PENDING-DATE (X-MM05-SETT-INDEX)
101700                                 IS LESS THAN 1000000
101800         MOVE MM05-PENDING-DATE (X-MM05-SETT-INDEX)
101900                                 TO SS01WS-MDY
102000         MOVE SS01WS-MDYZ        TO SS01WS-DATEZ
102100     ELSE
102200         MOVE MM05-PENDING-DATE (X-MM05-SETT-INDEX)
102300                                 TO SS01WS-DATE.
102400*
102500     PERFORM SS05PD-DATE-VALIDATION
102600                                 THRU SS05PD-DV-EXIT.
102700*
102800     IF  SS01WS-DATE-IS-INVALID
102900         GO TO W078-PENDING-TO-ACTIVE-ERROR
103000     ELSE
103100         MOVE SS01WS-DATE        TO MM05-PENDING-DATE
103200                                    (X-MM05-SETT-INDEX).
103300*
103400     IF  MBCA-PTI-FUNCTION-IS-MAINT
103500     OR  MM05-PENDING-DATE-L (X-MM05-SETT-INDEX)
103600                                 IS GREATER THAN ZERO
103700     OR  NOT MMFS-MT-REQUIRED (X-MMFS-MERCH)
103800         GO TO W079-EXIT.
103900*
104000 W078-PENDING-TO-ACTIVE-ERROR.
104100*
104200*******************************************************
104300*    THE FIELD IS IN ERROR.  SET THE ERROR SWITCH,    *
104400*    BRIGHTEN THE PARENS, AND BRIGHTEN AND FSET       *
104500*    THE DATA ELEMENT.                                *
104600*******************************************************
104700*
104800     IF  MM05-PENDING-DATE-L (X-MM05-SETT-INDEX)
104900                                 IS GREATER THAN ZERO
105000         MOVE DFHBMNBF           TO MM05-PENDING-DATE-A
105100                                    (X-MM05-SETT-INDEX)
105200     ELSE
105300         MOVE DFHBMUNB           TO MM05-PENDING-DATE-A
105400                                    (X-MM05-SETT-INDEX).
105500*
105600     SET SS08WS-ERROR-SW-YES     TO TRUE.
105700     SET ACTIVE-DATE-ERRORS-EXIST (X-ACTIVE-DATE-INDEX)
105800                                 TO TRUE.
105900     MOVE DFHBMASB               TO MM05-PENDING-DATE-LP-A
106000                                    (X-MM05-SETT-INDEX)
106100                                    MM05-PENDING-DATE-RP-A
106200                                    (X-MM05-SETT-INDEX).
106300     MOVE SS08WS-CURSOR          TO MM05-PENDING-DATE-L
106400                                    (X-MM05-SETT-INDEX).
106500*
106600 W079-EXIT.
106700     EXIT.
106800*
106900 W090-EDIT-ISA-METHOD.
107000*
107100     MOVE DFHBMDAS               TO MM05-ISA-METHOD-LP-A
107200                                    (X-MM05-SETT-INDEX)
107300                                    MM05-ISA-METHOD-RP-A
107400                                    (X-MM05-SETT-INDEX).
107500     MOVE DFHBMASK               TO MM05-ISA-METHOD-A
107600                                    (X-MM05-SETT-INDEX).
107700*
107800     PERFORM Y095-ISA-METHOD-SECURITY
107900                                 THRU Y099-EXIT.
108000*
108100     IF  MM05-ISA-METHOD-L (X-MM05-SETT-INDEX)
108200                                 IS GREATER THAN ZERO
108300         MOVE DFHBMASF           TO MM05-ISA-METHOD-A
108400                                    (X-MM05-SETT-INDEX)
108500     ELSE
108600         MOVE MMMM-INTERIM-SETT-ACCT-METH (X-MMMM-SETT-ACH)
108700                                 TO MM05-ISA-METHOD
108800                                    (X-MM05-SETT-INDEX).
108900*
109000     IF  NOT MM05-VALID-ISA-METHODS (X-MM05-SETT-INDEX)
109100         GO TO W098-ISA-METHOD-ERROR.
109200*
109300     IF  MBCA-PTI-FUNCTION-IS-MAINT
109400     OR  MM05-ISA-METHOD-L (X-MM05-SETT-INDEX)
109500                                 IS GREATER THAN ZERO
109600     OR  NOT MMFS-MT-REQUIRED (X-MMFS-MERCH)
109700         GO TO W099-EXIT.
109800*
109900 W098-ISA-METHOD-ERROR.
110000*
110100     IF  MM05-ISA-METHOD-L (X-MM05-SETT-INDEX)
110200                                 IS GREATER THAN ZERO
110300         MOVE DFHBMUBF           TO MM05-ISA-METHOD-A
110400                                    (X-MM05-SETT-INDEX)
110500     ELSE
110600         MOVE DFHBMBRY           TO MM05-ISA-METHOD-A
110700                                    (X-MM05-SETT-INDEX).
110800*
110900     SET SS08WS-ERROR-SW-YES     TO TRUE.
111000     MOVE DFHBMASB               TO MM05-ISA-METHOD-LP-A
111100                                    (X-MM05-SETT-INDEX)
111200                                    MM05-ISA-METHOD-RP-A
111300                                    (X-MM05-SETT-INDEX).
111400     MOVE SS08WS-CURSOR          TO MM05-ISA-METHOD-L
111500                                    (X-MM05-SETT-INDEX).
111600*
111700 W099-EXIT.
111800     EXIT.
111900*
112000 W150-EDIT-PENDING-CR-ACCT-TYPE.
112100*
112200     MOVE DFHBMDAS               TO MM05-PENDING-CR-ACCT-TYPE-LP-A
112300                                    (X-MM05-SETT-INDEX)
112400                                    MM05-PENDING-CR-ACCT-TYPE-RP-A
112500                                    (X-MM05-SETT-INDEX).
112600     MOVE DFHBMASK               TO MM05-PENDING-CR-ACCT-TYPE-A
112700                                    (X-MM05-SETT-INDEX).
112800*
112900     PERFORM Y155-PND-CR-ACCT-TYPE-SECURITY
113000                                 THRU Y159-EXIT.
113100*
113200     IF  MM05-PENDING-CR-ACCT-TYPE-L (X-MM05-SETT-INDEX)
113300                                 IS GREATER THAN ZERO
113400         MOVE DFHBMASF           TO MM05-PENDING-CR-ACCT-TYPE-A
113500                                    (X-MM05-SETT-INDEX)
113600     ELSE
113700         MOVE MMMM-PENDING-CR-ACCT-TYPE (X-MMMM-SETT-ACH)
113800                                 TO MM05-PENDING-CR-ACCT-TYPE
113900                                    (X-MM05-SETT-INDEX).
114000*
114100     MOVE MM05-PENDING-CR-ACCT-TYPE (X-MM05-SETT-INDEX)
114200                                 TO MMMM-PENDING-CR-ACCT-TYPE
114300                                    (X-MMMM-SETT-ACH).
114400*
114500     IF  NOT MMMM-VALID-PEND-CR-ACCT-TYPE (X-MMMM-SETT-ACH)
114600         GO TO W158-ACT-DR-AT-FLAG-ERROR.
114700*
114800     IF  MBCA-PTI-FUNCTION-IS-MAINT
114900     OR  MM05-PENDING-CR-ACCT-TYPE-L (X-MM05-SETT-INDEX)
115000                                 IS GREATER THAN ZERO
115100     OR  NOT MMFS-MT-REQUIRED (X-MMFS-MERCH)
115200         GO TO W159-EXIT.
115300*
115400 W158-ACT-DR-AT-FLAG-ERROR.
115500*
115600     IF  MM05-PENDING-CR-ACCT-TYPE-L (X-MM05-SETT-INDEX)
115700                                 IS GREATER THAN ZERO
115800         MOVE DFHBMUBF           TO MM05-PENDING-CR-ACCT-TYPE-A
115900                                    (X-MM05-SETT-INDEX)
116000     ELSE
116100         MOVE DFHBMBRY           TO MM05-PENDING-CR-ACCT-TYPE-A
116200                                    (X-MM05-SETT-INDEX).
116300*
116400     SET SS08WS-ERROR-SW-YES     TO TRUE.
116500     SET PRENOTE-FLAG-ERRORS-EXIST (X-PRENOTE-INDEX)
116600                                 TO TRUE.
116700     MOVE DFHBMASB               TO MM05-PENDING-CR-ACCT-TYPE-LP-A
116800                                    (X-MM05-SETT-INDEX)
116900                                    MM05-PENDING-CR-ACCT-TYPE-RP-A
117000                                    (X-MM05-SETT-INDEX).
117100     MOVE SS08WS-CURSOR          TO MM05-PENDING-CR-ACCT-TYPE-L
117200                                    (X-MM05-SETT-INDEX).
117300*
117400 W159-EXIT.
117500     EXIT.
117600*
117700 W170-EDIT-PENDING-CR-RT.
117800*
117900     MOVE DFHBMDAS               TO MM05-PENDING-CR-RT-LP-A
118000                                    (X-MM05-SETT-INDEX)
118100                                    MM05-PENDING-CR-RT-RP-A
118200                                    (X-MM05-SETT-INDEX).
118300     MOVE DFHBMASK               TO MM05-PENDING-CR-RT-A
118400                                    (X-MM05-SETT-INDEX).
118500*
118600     PERFORM Y175-PENDING-CR-RT-SECURITY
118700                                 THRU Y179-EXIT.
118800*
118900     IF  MM05-PENDING-CR-RT-L (X-MM05-SETT-INDEX)
119000                                 IS GREATER THAN ZERO
119100         MOVE DFHBMASF           TO MM05-PENDING-CR-RT-A
119200                                    (X-MM05-SETT-INDEX)
119300     ELSE
119400         MOVE MMMM-PENDING-CR-RT (X-MMMM-SETT-ACH)
119500                                 TO MM05-PENDING-CR-RT
119600                                    (X-MM05-SETT-INDEX).
119700*
119800     IF  MM05-PENDING-CR-RT (X-MM05-SETT-INDEX) IS NOT NUMERIC
119900         GO TO W178-PENDING-CR-RT-ERROR.
120000*
120100     MOVE MM05-PENDING-CR-RT (X-MM05-SETT-INDEX)
120200                                 TO SS05WS-NBR.
120300     MOVE ZERO                   TO SS05WS-OPTION.
120400     PERFORM SS09PD-MOD10-137    THRU SS09PD-M137-EXIT.
120500*
120600     IF  SS05WS-CD-IS-INVALID
120700         GO TO W178-PENDING-CR-RT-ERROR.
120800*
120900     IF  MBCA-PTI-FUNCTION-IS-MAINT
121000     OR  MM05-PENDING-CR-RT-L (X-MM05-SETT-INDEX)
121100                                 IS GREATER THAN ZERO
121200     OR  NOT MMFS-MT-REQUIRED (X-MMFS-MERCH)
121300         GO TO W179-EXIT.
121400*
121500 W178-PENDING-CR-RT-ERROR.
121600*
121700     IF  MM05-PENDING-CR-RT-L (X-MM05-SETT-INDEX)
121800                                 IS GREATER THAN ZERO
121900         MOVE DFHBMNBF           TO MM05-PENDING-CR-RT-A
122000                                    (X-MM05-SETT-INDEX)
122100     ELSE
122200         MOVE DFHBMUNB           TO MM05-PENDING-CR-RT-A
122300                                    (X-MM05-SETT-INDEX).
122400*
122500     SET SS08WS-ERROR-SW-YES     TO TRUE.
122600     SET PENDING-ACH-ERRORS-EXIST (X-PENDING-ACH-INDEX)
122700                                 TO TRUE.
122800     MOVE DFHBMASB               TO MM05-PENDING-CR-RT-LP-A
122900                                    (X-MM05-SETT-INDEX)
123000                                    MM05-PENDING-CR-RT-RP-A
123100                                    (X-MM05-SETT-INDEX).
123200     MOVE SS08WS-CURSOR          TO MM05-PENDING-CR-RT-L
123300                                    (X-MM05-SETT-INDEX).
123400*
123500 W179-EXIT.
123600     EXIT.
123700*
123800 W210-EDIT-PENDING-CR-DDA.
123900*
124000     MOVE DFHBMDAS               TO MM05-PENDING-CR-DDA-LP-A
124100                                    (X-MM05-SETT-INDEX)
124200                                    MM05-PENDING-CR-DDA-RP-A
124300                                    (X-MM05-SETT-INDEX).
124400     MOVE DFHBMASK               TO MM05-PENDING-CR-DDA-A
124500                                    (X-MM05-SETT-INDEX).
124600*
124700     PERFORM Y215-PENDING-CR-DDA-SECURITY
124800                                 THRU Y219-EXIT.
124900*
125000     IF  MM05-PENDING-CR-DDA-L (X-MM05-SETT-INDEX)
125100                                 IS GREATER THAN ZERO
125200         MOVE DFHBMASF           TO MM05-PENDING-CR-DDA-A
125300                                    (X-MM05-SETT-INDEX)
125400     ELSE
125500         MOVE MMMM-PENDING-CR-ACCT (X-MMMM-SETT-ACH)
125600                                 TO MM05-PENDING-CR-DDA
125700                                    (X-MM05-SETT-INDEX).
125800*
125900     IF  MBCA-PTI-FUNCTION-IS-MAINT
126000     OR  MM05-PENDING-CR-DDA-L (X-MM05-SETT-INDEX)
126100                                 IS GREATER THAN ZERO
126200     OR  NOT MMFS-MT-REQUIRED (X-MMFS-MERCH)
126300         GO TO W219-EXIT.
126400*
126500 W218-PENDING-CR-DDA-ERROR.
126600*
126700     IF  MM05-PENDING-CR-DDA-L (X-MM05-SETT-INDEX)
126800                                 IS GREATER THAN ZERO
126900         MOVE DFHBMUBF           TO MM05-PENDING-CR-DDA-A
127000                                    (X-MM05-SETT-INDEX)
127100     ELSE
127200         MOVE DFHBMBRY           TO MM05-PENDING-CR-DDA-A
127300                                    (X-MM05-SETT-INDEX).
127400*
127500     SET SS08WS-ERROR-SW-YES     TO TRUE.
127600     SET PENDING-ACH-ERRORS-EXIST (X-PENDING-ACH-INDEX)
127700                                 TO TRUE.
127800     MOVE DFHBMASB               TO MM05-PENDING-CR-DDA-LP-A
127900                                    (X-MM05-SETT-INDEX)
128000                                    MM05-PENDING-CR-DDA-RP-A
128100                                    (X-MM05-SETT-INDEX).
128200     MOVE SS08WS-CURSOR          TO MM05-PENDING-CR-DDA-L
128300                                    (X-MM05-SETT-INDEX).
128400*
128500 W219-EXIT.
128600     EXIT.
128700*
128800 W270-EDIT-PENDING-DR-ACCT-TYPE.
128900*
129000     MOVE DFHBMDAS               TO MM05-PENDING-DR-ACCT-TYPE-LP-A
129100                                    (X-MM05-SETT-INDEX)
129200                                    MM05-PENDING-DR-ACCT-TYPE-RP-A
129300                                    (X-MM05-SETT-INDEX).
129400     MOVE DFHBMASK               TO MM05-PENDING-DR-ACCT-TYPE-A
129500                                    (X-MM05-SETT-INDEX).
129600*
129700     PERFORM Y275-PND-DR-ACCT-TYPE-SECURITY
129800                                 THRU Y279-EXIT.
129900*
130000     IF  MM05-PENDING-DR-ACCT-TYPE-L (X-MM05-SETT-INDEX)
130100                                 IS GREATER THAN ZERO
130200         MOVE DFHBMASF           TO MM05-PENDING-DR-ACCT-TYPE-A
130300                                    (X-MM05-SETT-INDEX)
130400     ELSE
130500         MOVE MMMM-PENDING-DR-ACCT-TYPE (X-MMMM-SETT-ACH)
130600                                 TO MM05-PENDING-DR-ACCT-TYPE
130700                                    (X-MM05-SETT-INDEX).
130800*
130900     MOVE MM05-PENDING-DR-ACCT-TYPE (X-MM05-SETT-INDEX)
131000                                 TO MMMM-PENDING-DR-ACCT-TYPE
131100                                    (X-MMMM-SETT-ACH).
131200*
131300     IF  NOT MMMM-VALID-PEND-DR-ACCT-TYPE (X-MMMM-SETT-ACH)
131400         GO TO W278-ACT-DR-AT-FLAG-ERROR.
131500*
131600     IF  MBCA-PTI-FUNCTION-IS-MAINT
131700     OR  MM05-PENDING-DR-ACCT-TYPE-L (X-MM05-SETT-INDEX)
131800                                 IS GREATER THAN ZERO
131900     OR  NOT MMFS-MT-REQUIRED (X-MMFS-MERCH)
132000         GO TO W279-EXIT.
132100*
132200 W278-ACT-DR-AT-FLAG-ERROR.
132300*
132400     IF  MM05-PENDING-DR-ACCT-TYPE-L (X-MM05-SETT-INDEX)
132500                                 IS GREATER THAN ZERO
132600         MOVE DFHBMUBF           TO MM05-PENDING-DR-ACCT-TYPE-A
132700                                    (X-MM05-SETT-INDEX)
132800     ELSE
132900         MOVE DFHBMBRY           TO MM05-PENDING-DR-ACCT-TYPE-A
133000                                    (X-MM05-SETT-INDEX).
133100*
133200     SET SS08WS-ERROR-SW-YES     TO TRUE.
133300     SET PRENOTE-FLAG-ERRORS-EXIST (X-PRENOTE-INDEX)
133400                                 TO TRUE.
133500     MOVE DFHBMASB               TO MM05-PENDING-DR-ACCT-TYPE-LP-A
133600                                    (X-MM05-SETT-INDEX)
133700                                    MM05-PENDING-DR-ACCT-TYPE-RP-A
133800                                    (X-MM05-SETT-INDEX).
133900     MOVE SS08WS-CURSOR          TO MM05-PENDING-DR-ACCT-TYPE-L
134000                                    (X-MM05-SETT-INDEX).
134100*
134200 W279-EXIT.
134300     EXIT.
134400*
134500 W290-EDIT-PENDING-DR-RT.
134600*
134700     MOVE DFHBMDAS               TO MM05-PENDING-DR-RT-LP-A
134800                                    (X-MM05-SETT-INDEX)
134900                                    MM05-PENDING-DR-RT-RP-A
135000                                    (X-MM05-SETT-INDEX).
135100     MOVE DFHBMASK               TO MM05-PENDING-DR-RT-A
135200                                    (X-MM05-SETT-INDEX).
135300*
135400     PERFORM Y295-PENDING-DR-RT-SECURITY
135500                                 THRU Y299-EXIT.
135600*
135700     IF  MM05-PENDING-DR-RT-L (X-MM05-SETT-INDEX)
135800                                 IS GREATER THAN ZERO
135900         MOVE DFHBMASF           TO MM05-PENDING-DR-RT-A
136000                                    (X-MM05-SETT-INDEX)
136100     ELSE
136200         MOVE MMMM-PENDING-DR-RT (X-MMMM-SETT-ACH)
136300                                 TO MM05-PENDING-DR-RT
136400                                    (X-MM05-SETT-INDEX).
136500*
136600     IF  MM05-PENDING-DR-RT (X-MM05-SETT-INDEX) IS NOT NUMERIC
136700         GO TO W298-PENDING-DR-RT-ERROR.
136800*
136900     MOVE MM05-PENDING-DR-RT (X-MM05-SETT-INDEX)
137000                                 TO SS05WS-NBR.
137100     MOVE ZERO                   TO SS05WS-OPTION.
137200     PERFORM SS09PD-MOD10-137    THRU SS09PD-M137-EXIT.
137300*
137400     IF  SS05WS-CD-IS-INVALID
137500         GO TO W298-PENDING-DR-RT-ERROR.
137600*
137700     IF  MBCA-PTI-FUNCTION-IS-MAINT
137800     OR  MM05-PENDING-DR-RT-L (X-MM05-SETT-INDEX)
137900                                 IS GREATER THAN ZERO
138000     OR  NOT MMFS-MT-REQUIRED (X-MMFS-MERCH)
138100         GO TO W299-EXIT.
138200*
138300 W298-PENDING-DR-RT-ERROR.
138400*
138500     IF  MM05-PENDING-DR-RT-L (X-MM05-SETT-INDEX)
138600                                 IS GREATER THAN ZERO
138700         MOVE DFHBMNBF           TO MM05-PENDING-DR-RT-A
138800                                    (X-MM05-SETT-INDEX)
138900     ELSE
139000         MOVE DFHBMUNB           TO MM05-PENDING-DR-RT-A
139100                                    (X-MM05-SETT-INDEX).
139200*
139300     SET SS08WS-ERROR-SW-YES     TO TRUE.
139400     SET PENDING-ACH-ERRORS-EXIST (X-PENDING-ACH-INDEX)
139500                                 TO TRUE.
139600     MOVE DFHBMASB               TO MM05-PENDING-DR-RT-LP-A
139700                                    (X-MM05-SETT-INDEX)
139800                                    MM05-PENDING-DR-RT-RP-A
139900                                    (X-MM05-SETT-INDEX).
140000     MOVE SS08WS-CURSOR          TO MM05-PENDING-DR-RT-L
140100                                    (X-MM05-SETT-INDEX).
140200*
140300 W299-EXIT.
140400     EXIT.
140500*
140600 W330-EDIT-PENDING-DR-DDA.
140700*
140800     MOVE DFHBMDAS               TO MM05-PENDING-DR-DDA-LP-A
140900                                    (X-MM05-SETT-INDEX)
141000                                    MM05-PENDING-DR-DDA-RP-A
141100                                    (X-MM05-SETT-INDEX).
141200     MOVE DFHBMASK               TO MM05-PENDING-DR-DDA-A
141300                                    (X-MM05-SETT-INDEX).
141400*
141500     PERFORM Y335-PENDING-DR-DDA-SECURITY
141600                                 THRU Y339-EXIT.
141700*
141800     IF  MM05-PENDING-DR-DDA-L (X-MM05-SETT-INDEX)
141900                                 IS GREATER THAN ZERO
142000         MOVE DFHBMASF           TO MM05-PENDING-DR-DDA-A
142100                                    (X-MM05-SETT-INDEX)
142200     ELSE
142300         MOVE MMMM-PENDING-DR-ACCT (X-MMMM-SETT-ACH)
142400                                 TO MM05-PENDING-DR-DDA
142500                                    (X-MM05-SETT-INDEX).
142600*
142700     IF  MBCA-PTI-FUNCTION-IS-MAINT
142800     OR  MM05-PENDING-DR-DDA-L (X-MM05-SETT-INDEX)
142900                                 IS GREATER THAN ZERO
143000     OR  NOT MMFS-MT-REQUIRED (X-MMFS-MERCH)
143100         GO TO W339-EXIT.
143200*
143300 W338-PENDING-DR-DDA-ERROR.
143400*
143500     IF  MM05-PENDING-DR-DDA-L (X-MM05-SETT-INDEX)
143600                                 IS GREATER THAN ZERO
143700         MOVE DFHBMUBF           TO MM05-PENDING-DR-DDA-A
143800                                    (X-MM05-SETT-INDEX)
143900     ELSE
144000         MOVE DFHBMBRY           TO MM05-PENDING-DR-DDA-A
144100                                    (X-MM05-SETT-INDEX).
144200*
144300     SET SS08WS-ERROR-SW-YES     TO TRUE.
144400     SET PENDING-ACH-ERRORS-EXIST (X-PENDING-ACH-INDEX)
144500                                 TO TRUE.
144600     MOVE DFHBMASB               TO MM05-PENDING-DR-DDA-LP-A
144700                                    (X-MM05-SETT-INDEX)
144800                                    MM05-PENDING-DR-DDA-RP-A
144900                                    (X-MM05-SETT-INDEX).
145000     MOVE SS08WS-CURSOR          TO MM05-PENDING-DR-DDA-L
145100                                    (X-MM05-SETT-INDEX).
145200*
145300 W339-EXIT.
145400     EXIT.
145500*
145600 W510-CROSS-EDITS.
145700*
145800*
145900     SET X-MMMMIR-SETT-ACH       TO X-MMMM-SETT-ACH.
146000*
146100     IF  PRENOTE-FLAG-ERRORS-EXIST (X-PRENOTE-INDEX)
146200     OR  ACTIVE-ACH-ERRORS-EXIST   (X-ACTIVE-INDEX)
146300     OR  PENDING-ACH-ERRORS-EXIST  (X-PENDING-ACH-INDEX)
146400     OR  ACTIVE-DATE-ERRORS-EXIST  (X-ACTIVE-DATE-INDEX)
146500         GO TO W549-ACE-EXIT.
146600*
146700     PERFORM W512-CHECK-PRENOTE-FLAG
146800                                 THRU W512-CPF-EXIT.
146900     PERFORM W513-CHECK-MIGRATING-METHODS
147000                                 THRU W513-CMM-EXIT.
147100     PERFORM W515-CHECK-INTERIM-DATA
147200                                 THRU W515-CID-EXIT.
147300     PERFORM W517-CHECK-PENDING-TO-ACTIVE
147400                                 THRU W517-CPTA-EXIT.
147500     GO TO W549-ACE-EXIT.
147600*
147700 W512-CHECK-PRENOTE-FLAG.
147800*
147900**************************************************************
148000***        PRENOTE FLAG CAN NOT BE SET TO A 'Y'            ***
148100***        IF MIGRATING METHOD IS NOT ACH.                 ***
148200**************************************************************
148300*
148400     IF  MM05-PRENOTE-SEND (X-MM05-SETT-INDEX)
148500     AND NOT MM05-MSA-ACH (X-MM05-SETT-INDEX)
148600         SET SS08WS-ERROR-SW-YES TO TRUE
148700         MOVE SS08WS-CURSOR      TO MM05-PRENOTE-CONTROL-L
148800                                    (X-MM05-SETT-INDEX)
148900         MOVE DFHBMASB           TO MM05-MSA-METHOD-LP-A
149000                                    (X-MM05-SETT-INDEX)
149100                                    MM05-MSA-METHOD-RP-A
149200                                    (X-MM05-SETT-INDEX)
149300                                    MM05-PRENOTE-CONTROL-LP-A
149400                                    (X-MM05-SETT-INDEX)
149500                                    MM05-PRENOTE-CONTROL-RP-A
149600                                    (X-MM05-SETT-INDEX)
149700         MOVE DFHBMUBF           TO MM05-MSA-METHOD-A
149800                                    (X-MM05-SETT-INDEX)
149900                                    MM05-PRENOTE-CONTROL-A
150000                                    (X-MM05-SETT-INDEX).
150100
150200*
150300 W512-CPF-EXIT.
150400     EXIT.
150500*
150600*
150700 W513-CHECK-MIGRATING-METHODS.
150800*
150900**************************************************************
151000***             ACH AND WIRE CROSS EDITS FOR MIGRATING     ***
151100**************************************************************
151200*
151300     IF  PENDING-ACH-ERRORS-EXIST  (X-PENDING-ACH-INDEX)
151400         GO TO W513-CMM-EXIT.
151500*
151600     EVALUATE TRUE
151700       WHEN (MM05-MSA-NOT-USED (X-MM05-SETT-INDEX)
151800        AND  MM05-ISA-METHOD (X-MM05-SETT-INDEX)
151900                                 IS NOT EQUAL TO 'N0')
152000             SET SS08WS-ERROR-SW-YES TO TRUE
152100             MOVE SS08WS-CURSOR  TO MM05-MSA-METHOD-L
152200                                    (X-MM05-SETT-INDEX)
152300             MOVE DFHBMASB       TO MM05-MSA-METHOD-LP-A
152400                                    (X-MM05-SETT-INDEX)
152500                                    MM05-MSA-METHOD-RP-A
152600                                    (X-MM05-SETT-INDEX)
152700                                    MM05-ISA-METHOD-LP-A
152800                                    (X-MM05-SETT-INDEX)
152900                                    MM05-ISA-METHOD-RP-A
153000                                    (X-MM05-SETT-INDEX)
153100             MOVE DFHBMUBF       TO MM05-MSA-METHOD-A
153200                                    (X-MM05-SETT-INDEX)
153300                                    MM05-ISA-METHOD-A
153400                                    (X-MM05-SETT-INDEX)
153500     END-EVALUATE.
153600*
153700     EVALUATE TRUE
153800       WHEN ((MM05-MSA-ACH (X-MM05-SETT-INDEX)
153900         OR  MM05-MSA-WIRE (X-MM05-SETT-INDEX))
154000        AND  MM05-ACTIVE-CR-RT (X-MM05-SETT-INDEX)
154100                                 IS EQUAL TO ZEROS)
154200         EVALUATE TRUE
154300           WHEN MM05-PENDING-CR-RT (X-MM05-SETT-INDEX)
154400                                 IS EQUAL TO ZEROS
154500             SET SS08WS-ERROR-SW-YES TO TRUE
154600             MOVE SS08WS-CURSOR  TO MM05-PENDING-CR-RT-L
154700                                    (X-MM05-SETT-INDEX)
154800             MOVE DFHBMASB       TO MM05-PENDING-CR-RT-LP-A
154900                                    (X-MM05-SETT-INDEX)
155000                                    MM05-PENDING-CR-RT-RP-A
155100                                    (X-MM05-SETT-INDEX)
155200             MOVE DFHBMNBF       TO MM05-PENDING-CR-RT-A
155300                                    (X-MM05-SETT-INDEX)
155400         END-EVALUATE
155500         EVALUATE TRUE
155600           WHEN MM05-PENDING-CR-DDA (X-MM05-SETT-INDEX)
155700                                 IS EQUAL TO SPACES
155800             SET SS08WS-ERROR-SW-YES TO TRUE
155900             MOVE SS08WS-CURSOR  TO MM05-PENDING-CR-DDA-L
156000                                    (X-MM05-SETT-INDEX)
156100             MOVE DFHBMASB       TO MM05-PENDING-CR-DDA-LP-A
156200                                    (X-MM05-SETT-INDEX)
156300                                    MM05-PENDING-CR-DDA-RP-A
156400                                    (X-MM05-SETT-INDEX)
156500                                    MM05-PENDING-CR-ACCT-TYPE-LP-A
156600                                    (X-MM05-SETT-INDEX)
156700                                    MM05-PENDING-CR-ACCT-TYPE-RP-A
156800                                    (X-MM05-SETT-INDEX)
156900             MOVE DFHBMUBF       TO MM05-PENDING-CR-DDA-A
157000                                    (X-MM05-SETT-INDEX)
157100                                    MM05-PENDING-CR-ACCT-TYPE-A
157200                                    (X-MM05-SETT-INDEX)
157300         END-EVALUATE
157400     END-EVALUATE.
157500*
157600     EVALUATE TRUE
157700       WHEN  (MM05-MSA-DEBIT-ACH (X-MM05-SETT-INDEX)
157800        AND  MM05-ACTIVE-DR-RT (X-MM05-SETT-INDEX)
157900                                 IS EQUAL TO ZEROS)
158000         EVALUATE TRUE
158100           WHEN MM05-PENDING-DR-RT (X-MM05-SETT-INDEX)
158200                                 IS EQUAL TO ZEROS
158300             SET SS08WS-ERROR-SW-YES TO TRUE
158400             MOVE SS08WS-CURSOR  TO MM05-PENDING-DR-RT-L
158500                                    (X-MM05-SETT-INDEX)
158600             MOVE DFHBMASB       TO MM05-PENDING-DR-RT-LP-A
158700                                    (X-MM05-SETT-INDEX)
158800                                    MM05-PENDING-DR-RT-RP-A
158900                                    (X-MM05-SETT-INDEX)
159000             MOVE DFHBMNBF       TO MM05-PENDING-DR-RT-A
159100                                    (X-MM05-SETT-INDEX)
159200         END-EVALUATE
159300         EVALUATE TRUE
159400           WHEN MM05-PENDING-DR-DDA (X-MM05-SETT-INDEX)
159500                                 IS EQUAL TO SPACES
159600             SET SS08WS-ERROR-SW-YES TO TRUE
159700             MOVE SS08WS-CURSOR  TO MM05-PENDING-DR-DDA-L
159800                                    (X-MM05-SETT-INDEX)
159900             MOVE DFHBMASB       TO MM05-PENDING-DR-DDA-LP-A
160000                                    (X-MM05-SETT-INDEX)
160100                                    MM05-PENDING-DR-DDA-RP-A
160200                                    (X-MM05-SETT-INDEX)
160300                                    MM05-PENDING-DR-ACCT-TYPE-LP-A
160400                                    (X-MM05-SETT-INDEX)
160500                                    MM05-PENDING-DR-ACCT-TYPE-RP-A
160600                                    (X-MM05-SETT-INDEX)
160700             MOVE DFHBMUBF       TO MM05-PENDING-DR-DDA-A
160800                                    (X-MM05-SETT-INDEX)
160900                                    MM05-PENDING-DR-ACCT-TYPE-A
161000                                    (X-MM05-SETT-INDEX)
161100         END-EVALUATE
161200     END-EVALUATE.
161300*
161400*
161500************************************************************
161600**    EDIT FOR 'A3' 'M3' AND MAKE SURE A 'H' IS IN ONE OF **
161700**    THE FOUR BILLING ACCOUNTS                           **
161800************************************************************
161900*
162000     EVALUATE TRUE
162100       WHEN MM05-MSA-HOLDOVER-BILLED (X-MM05-SETT-INDEX)
162200         PERFORM
162300           VARYING X-MMMM-BILL FROM 1 BY 1
162400           UNTIL X-MMMM-BILL IS GREATER THAN 4
162500           EVALUATE TRUE
162600             WHEN MMMM-BUF-HOLDOVER-TO-XFER (X-MMMM-BILL)
162700               SET X-MMMM-BILL   TO 4
162800               CONTINUE
162900             WHEN X-MMMM-BILL IS EQUAL TO 4
163000               SET SS08WS-ERROR-SW-YES TO TRUE
163100               MOVE SS08WS-CURSOR TO MM05-MSA-METHOD-L
163200                                    (X-MM05-SETT-INDEX)
163300               MOVE DFHBMASB     TO MM05-MSA-METHOD-LP-A
163400                                    (X-MM05-SETT-INDEX)
163500                                    MM05-MSA-METHOD-RP-A
163600                                    (X-MM05-SETT-INDEX)
163700               MOVE DFHBMUBF     TO MM05-MSA-METHOD-A
163800                                    (X-MM05-SETT-INDEX)
163900           END-EVALUATE
164000         END-PERFORM
164100     END-EVALUATE.
164200*
164300     EVALUATE TRUE
164400       WHEN (MM05-PENDING-DATE-L (X-MM05-SETT-INDEX)
164500                                 IS LESS THAN 1
164600        AND  MM05-PENDING-DATE (X-MM05-SETT-INDEX)
164700                                 IS GREATER THAN ZERO
164800         AND MM05-MSA-NOT-USED (X-MM05-SETT-INDEX))
164900             MOVE SS08WS-CURSOR  TO MM05-MSA-METHOD-L
165000                                    (X-MM05-SETT-INDEX)
165100             MOVE DFHBMNBF       TO MM05-PENDING-DATE-A
165200                                    (X-MM05-SETT-INDEX)
165300             MOVE DFHBMUBF       TO MM05-MSA-METHOD-A
165400                                    (X-MM05-SETT-INDEX)
165500             MOVE DFHBMASB       TO MM05-MSA-METHOD-LP-A
165600                                    (X-MM05-SETT-INDEX)
165700                                    MM05-MSA-METHOD-RP-A
165800                                    (X-MM05-SETT-INDEX)
165900                                    MM05-PENDING-DATE-LP-A
166000                                    (X-MM05-SETT-INDEX)
166100                                    MM05-PENDING-DATE-RP-A
166200                                    (X-MM05-SETT-INDEX)
166300             SET SS08WS-ERROR-SW-YES
166400                                 TO TRUE
166500             GO TO W513-CMM-EXIT
166600     END-EVALUATE.
166700*
166800 W513-CMM-EXIT.
166900     EXIT.
167000*
167100 W515-CHECK-INTERIM-DATA.
167200*
167300     IF  PENDING-ACH-ERRORS-EXIST    (X-PENDING-ACH-INDEX)
167400     OR  PENDING-RT-DDA-ERRORS-EXIST (X-PENDING-RT-INDEX)
167500         GO TO W515-CID-EXIT.
167600*
167700**************************************************************
167800***             IF INTERIM IS CHANGED FROM A VALID         ***
167900***             METHOD TO 'N0' AND IF ACTIVE               ***
168000***             METHOD IS EQUAL TO 'N0' THE TAT            ***
168100***             ACCOUNTS ON SCREEN 07 CAN NOT BE           ***
168200***             POINTING TO THIS PARTICULAR DEST ACCT.     ***
168300**************************************************************
168400*
168500     EVALUATE MBCA-SCREEN-NBR
168600         WHEN 05
168700             SET X-MMMM-SETT-ACH TO 1
168800             SET X-MMMM-SETT-ACH DOWN BY 1
168900         WHEN 06
169000             SET X-MMMM-SETT-ACH TO 3
169100             SET X-MMMM-SETT-ACH DOWN BY 1
169200     END-EVALUATE.
169300*
169400     SET WS-INDEX-INTERIM        TO X-MM05-SETT-INDEX.
169500     SET X-MMMM-SETT-ACH         UP BY WS-INDEX-INTERIM.
169600     SET X-MMMM-SETT-ACCT        TO X-MMMM-SETT-ACH.
169700*
169800     EVALUATE TRUE
169900       WHEN (MM05-ISA-NOT-USED (X-MM05-SETT-INDEX)
170000        AND  MMMM-INTERIM-SETT-ACCT-METH (X-MMMM-SETT-ACH)
170100                                 IS NOT EQUAL TO 'N0'
170200        AND  MMMM-SA-NOT-USED (X-MMMM-SETT-ACCT))
170300         SET WS-TAT-SETT-BILL-INDEX
170400                                 TO X-MMMM-SETT-ACCT
170500         PERFORM
170600           VARYING X-MMMM-TAT FROM 1 BY 1
170700           UNTIL X-MMMM-TAT IS GREATER THAN 16
170800           EVALUATE TRUE
170900             WHEN MMMM-TAT-ACCOUNT (X-MMMM-TAT)
171000                                 IS EQUAL TO WS-TAT-ACCOUNT
171100               SET X-MMMM-TAT    TO 16
171200               SET SS08WS-ERROR-SW-YES
171300                                 TO TRUE
171400               MOVE SS08WS-CURSOR TO MM05-ISA-METHOD-L
171500                                    (X-MM05-SETT-INDEX)
171600               MOVE DFHBMASB     TO MM05-ISA-METHOD-LP-A
171700                                    (X-MM05-SETT-INDEX)
171800                                    MM05-ISA-METHOD-RP-A
171900                                    (X-MM05-SETT-INDEX)
172000               MOVE DFHBMUBF     TO MM05-ISA-METHOD-A
172100                                    (X-MM05-SETT-INDEX)
172200           END-EVALUATE
172300         END-PERFORM
172400     END-EVALUATE.
172500*
172600**************************************************************
172700***             ACH CROSS EDITS FOR MIGRATING              ***
172800**************************************************************
172900*
173000     EVALUATE TRUE
173100       WHEN (MM05-ISA-ACH (X-MM05-SETT-INDEX)
173200         OR MM05-ISA-WIRE (X-MM05-SETT-INDEX))
173300         EVALUATE TRUE
173400           WHEN (MM05-ACTIVE-CR-RT (X-MM05-SETT-INDEX)
173500                                 IS EQUAL TO ZEROS
173600             OR MM05-ACTIVE-CR-DDA (X-MM05-SETT-INDEX)
173700                                 IS EQUAL TO SPACES)
173800             SET SS08WS-ERROR-SW-YES TO TRUE
173900             MOVE SS08WS-CURSOR  TO MM05-ISA-METHOD-L
174000                                    (X-MM05-SETT-INDEX)
174100             MOVE DFHBMASB       TO MM05-ISA-METHOD-LP-A
174200                                    (X-MM05-SETT-INDEX)
174300                                    MM05-ISA-METHOD-RP-A
174400                                    (X-MM05-SETT-INDEX)
174500             MOVE DFHBMUBF       TO MM05-ISA-METHOD-A
174600                                    (X-MM05-SETT-INDEX)
174700         END-EVALUATE
174800     END-EVALUATE.
174900*
175000     EVALUATE TRUE
175100       WHEN MM05-ISA-DEBIT-ACH (X-MM05-SETT-INDEX)
175200         EVALUATE TRUE
175300           WHEN ((MM05-ACTIVE-CR-RT (X-MM05-SETT-INDEX)
175400                                 IS EQUAL TO ZEROS
175500             OR MM05-ACTIVE-CR-DDA (X-MM05-SETT-INDEX)
175600                                 IS EQUAL TO SPACES
175700             OR MM05-ACTIVE-DR-RT (X-MM05-SETT-INDEX)
175800                                 IS EQUAL TO ZEROS
175900             OR MM05-ACTIVE-DR-DDA (X-MM05-SETT-INDEX)
176000                                 IS EQUAL TO SPACES))
176100             SET SS08WS-ERROR-SW-YES TO TRUE
176200             MOVE SS08WS-CURSOR  TO MM05-ISA-METHOD-L
176300                                    (X-MM05-SETT-INDEX)
176400             MOVE DFHBMASB       TO MM05-ISA-METHOD-LP-A
176500                                    (X-MM05-SETT-INDEX)
176600                                    MM05-ISA-METHOD-RP-A
176700                                    (X-MM05-SETT-INDEX)
176800             MOVE DFHBMUBF       TO MM05-ISA-METHOD-A
176900                                    (X-MM05-SETT-INDEX)
177000         END-EVALUATE
177100     END-EVALUATE.
177200*
177300************************************************************
177400**    EDIT FOR 'A3' 'M3' AND MAKE SURE A 'H' IS IN ONE OF **
177500**    THE FOUR BILLING ACCOUNTS                           **
177600************************************************************
177700*
177800     EVALUATE TRUE
177900       WHEN MM05-ISA-HOLDOVER-BILLED (X-MM05-SETT-INDEX)
178000         PERFORM
178100           VARYING X-MMMM-BILL FROM 1 BY 1
178200           UNTIL X-MMMM-BILL IS GREATER THAN 4
178300           EVALUATE TRUE
178400             WHEN MMMM-BUF-HOLDOVER-TO-XFER (X-MMMM-BILL)
178500               SET X-MMMM-BILL   TO 4
178600               CONTINUE
178700             WHEN X-MMMM-BILL IS EQUAL TO 4
178800               SET SS08WS-ERROR-SW-YES TO TRUE
178900               MOVE SS08WS-CURSOR TO MM05-ISA-METHOD-L
179000                                    (X-MM05-SETT-INDEX)
179100               MOVE DFHBMASB     TO MM05-ISA-METHOD-LP-A
179200                                    (X-MM05-SETT-INDEX)
179300                                    MM05-ISA-METHOD-RP-A
179400                                    (X-MM05-SETT-INDEX)
179500               MOVE DFHBMUBF     TO MM05-ISA-METHOD-A
179600                                    (X-MM05-SETT-INDEX)
179700           END-EVALUATE
179800         END-PERFORM
179900     END-EVALUATE.
180000*
180100 W515-CID-EXIT.
180200     EXIT.
180300*
180400 W517-CHECK-PENDING-TO-ACTIVE.
180500*
180600     IF  PENDING-ACH-ERRORS-EXIST    (X-PENDING-ACH-INDEX)
180700     OR  PENDING-RT-DDA-ERRORS-EXIST (X-PENDING-RT-INDEX)
180800         GO TO W517-CPTA-EXIT.
180900*
181000     EVALUATE TRUE
181100       WHEN (MM05-MSA-CHECK (X-MM05-SETT-INDEX)
181200         OR  MM05-MSA-MANUAL (X-MM05-SETT-INDEX))
181300             CONTINUE
181400       WHEN ((MM05-PENDING-CR-RT (X-MM05-SETT-INDEX)
181500                             IS GREATER THAN ZERO
181600        AND MM05-PENDING-CR-DDA (X-MM05-SETT-INDEX)
181700                             IS EQUAL TO SPACES)
181800         OR (MM05-PENDING-CR-RT (X-MM05-SETT-INDEX)
181900                             IS EQUAL TO ZEROS
182000        AND MM05-PENDING-CR-DDA (X-MM05-SETT-INDEX)
182100                             IS NOT EQUAL TO SPACES))
182200            SET SS08WS-ERROR-SW-YES
182300                                 TO TRUE
182400            MOVE SS08WS-CURSOR   TO MM05-PENDING-CR-RT-L
182500                                   (X-MM05-SETT-INDEX)
182600            MOVE DFHBMASB        TO MM05-PENDING-CR-RT-LP-A
182700                                    (X-MM05-SETT-INDEX)
182800                                    MM05-PENDING-CR-RT-RP-A
182900                                    (X-MM05-SETT-INDEX)
183000                                    MM05-PENDING-CR-DDA-LP-A
183100                                    (X-MM05-SETT-INDEX)
183200                                    MM05-PENDING-CR-DDA-RP-A
183300                                    (X-MM05-SETT-INDEX)
183400                                    MM05-PENDING-CR-ACCT-TYPE-LP-A
183500                                    (X-MM05-SETT-INDEX)
183600                                    MM05-PENDING-CR-ACCT-TYPE-RP-A
183700                                    (X-MM05-SETT-INDEX)
183800           MOVE DFHBMNBF         TO MM05-PENDING-CR-RT-A
183900                                    (X-MM05-SETT-INDEX)
184000           MOVE DFHBMUBF         TO MM05-PENDING-CR-DDA-A
184100                                    (X-MM05-SETT-INDEX)
184200                                    MM05-PENDING-CR-ACCT-TYPE-A
184300                                    (X-MM05-SETT-INDEX)
184400           GO TO W517-CPTA-EXIT
184500     END-EVALUATE.
184600*
184700     EVALUATE TRUE
184800       WHEN (MM05-MSA-CHECK (X-MM05-SETT-INDEX)
184900         OR  MM05-MSA-WIRE (X-MM05-SETT-INDEX)
185000         OR  MM05-MSA-NO-DEBIT-ACH (X-MM05-SETT-INDEX)
185100         OR  MM05-MSA-MANUAL (X-MM05-SETT-INDEX))
185200             CONTINUE
185300       WHEN ((MM05-PENDING-DR-RT (X-MM05-SETT-INDEX)
185400                             IS GREATER THAN ZERO
185500        AND MM05-PENDING-DR-DDA (X-MM05-SETT-INDEX)
185600                             IS EQUAL TO SPACES)
185700         OR (MM05-PENDING-DR-RT (X-MM05-SETT-INDEX)
185800                             IS EQUAL TO ZEROS
185900        AND MM05-PENDING-DR-DDA (X-MM05-SETT-INDEX)
186000                                 IS NOT EQUAL TO SPACES))
186100            SET SS08WS-ERROR-SW-YES TO TRUE
186200            MOVE SS08WS-CURSOR   TO MM05-PENDING-DR-RT-L
186300                                    (X-MM05-SETT-INDEX)
186400            MOVE DFHBMASB        TO MM05-PENDING-DR-RT-LP-A
186500                                   (X-MM05-SETT-INDEX)
186600                                    MM05-PENDING-DR-RT-RP-A
186700                                    (X-MM05-SETT-INDEX)
186800                                    MM05-PENDING-DR-DDA-LP-A
186900                                    (X-MM05-SETT-INDEX)
187000                                    MM05-PENDING-DR-DDA-RP-A
187100                                    (X-MM05-SETT-INDEX)
187200                                    MM05-PENDING-DR-ACCT-TYPE-LP-A
187300                                    (X-MM05-SETT-INDEX)
187400                                    MM05-PENDING-DR-ACCT-TYPE-RP-A
187500                                    (X-MM05-SETT-INDEX)
187600            MOVE DFHBMNBF        TO MM05-PENDING-DR-RT-A
187700                                    (X-MM05-SETT-INDEX)
187800            MOVE DFHBMUBF        TO MM05-PENDING-DR-DDA-A
187900                                    (X-MM05-SETT-INDEX)
188000                                    MM05-PENDING-DR-ACCT-TYPE-A
188100                                    (X-MM05-SETT-INDEX)
188200           GO TO W517-CPTA-EXIT
188300     END-EVALUATE.
188400*
188500     IF  MM05-MSA-ACH (X-MM05-SETT-INDEX)
188600     OR  MM05-ISA-ACH (X-MM05-SETT-INDEX)
188700         NEXT SENTENCE
188800     ELSE
188900         EVALUATE TRUE
189000           WHEN (MM05-PENDING-DATE-L (X-MM05-SETT-INDEX)
189100                                 IS GREATER THAN ZERO
189200             AND MM05-PENDING-DATE (X-MM05-SETT-INDEX)
189300                                 IS GREATER THAN ZERO
189400             AND MM05-MSA-NOT-USED (X-MM05-SETT-INDEX))
189500                 MOVE SS08WS-CURSOR TO MM05-MSA-METHOD-L
189600                                    (X-MM05-SETT-INDEX)
189700                 MOVE DFHBMNBF   TO MM05-PENDING-DATE-A
189800                                    (X-MM05-SETT-INDEX)
189900                 MOVE DFHBMUBF   TO MM05-MSA-METHOD-A
190000                                    (X-MM05-SETT-INDEX)
190100                 MOVE DFHBMASB   TO MM05-MSA-METHOD-LP-A
190200                                    (X-MM05-SETT-INDEX)
190300                                    MM05-MSA-METHOD-RP-A
190400                                    (X-MM05-SETT-INDEX)
190500                                    MM05-PENDING-DATE-LP-A
190600                                    (X-MM05-SETT-INDEX)
190700                                    MM05-PENDING-DATE-RP-A
190800                                    (X-MM05-SETT-INDEX)
190900                 SET SS08WS-ERROR-SW-YES
191000                                 TO TRUE
191100                 GO TO W517-CPTA-EXIT
191200         END-EVALUATE
191300         EVALUATE TRUE
191400           WHEN (MM05-PENDING-DATE-L (X-MM05-SETT-INDEX)
191500                                 IS GREATER THAN ZERO
191600            AND  MM05-PENDING-DATE (X-MM05-SETT-INDEX)
191700                                 IS GREATER THAN ZERO)
191800             MOVE MM05-PENDING-DATE (X-MM05-SETT-INDEX)
191900                                 TO SS01WS-DATE
192000             PERFORM SS07PD-GREG-TO-JUL
192100                                 THRU SS07PD-GTJ-EXIT
192200             EVALUATE TRUE
192300               WHEN  MMOC-DATE-NEXT-PROC
192400                                 IS GREATER THAN
192500                                    SS01WS-JULIAN
192600                 SET SS08WS-ERROR-SW-YES
192700                                 TO TRUE
192800                 MOVE SS08WS-CURSOR TO MM05-PENDING-DATE-L
192900                                    (X-MM05-SETT-INDEX)
193000                 MOVE DFHBMASB   TO MM05-PENDING-DATE-LP-A
193100                                   (X-MM05-SETT-INDEX)
193200                                    MM05-PENDING-DATE-RP-A
193300                                    (X-MM05-SETT-INDEX)
193400                 MOVE DFHBMNBF   TO MM05-PENDING-DATE-A
193500                                    (X-MM05-SETT-INDEX)
193600                 GO TO W517-CPTA-EXIT
193700               WHEN OTHER
193800                 GO TO W517-CPTA-EXIT
193900             END-EVALUATE
194000           WHEN OTHER
194100             GO TO W517-CPTA-EXIT
194200         END-EVALUATE.
194300*
194400     IF  MM05-PRENOTE-SEND (X-MM05-SETT-INDEX)
194500     AND MM05-MSA-ACH (X-MM05-SETT-INDEX)
194600         NEXT SENTENCE
194700     ELSE
194800         IF  MM05-PENDING-DATE-L (X-MM05-SETT-INDEX)
194900                                 IS GREATER THAN ZEROS
195000         AND MM05-PENDING-DATE (X-MM05-SETT-INDEX)
195100                                 IS GREATER THAN ZEROS
195200             MOVE MM05-PENDING-DATE (X-MM05-SETT-INDEX)
195300                                 TO SS01WS-DATE
195400             PERFORM SS07PD-GREG-TO-JUL
195500                                 THRU SS07PD-GTJ-EXIT
195600             IF  SS01WS-JULIAN IS LESS THAN
195700                                 MMOC-DATE-NEXT-PROC
195800                 GO TO W517-PENDING-TO-ACTIVE-ERROR
195900             ELSE
196000                 GO TO W517-CPTA-EXIT
196100         ELSE
196200             IF  MM05-MSA-ACH (X-MM05-SETT-INDEX)
196300             OR  MM05-MSA-WIRE (X-MM05-SETT-INDEX)
196400                 GO TO W517-CPTA-EXIT
196500             ELSE
196600                 MOVE MMOC-DATE-NEXT-PROC
196700                                 TO SS01WS-JULIAN
196800                 PERFORM SS08PD-JUL-TO-GREG
196900                                 THRU SS08PD-JTG-EXIT
197000                 MOVE SS01WS-DATE
197100                                 TO MM05-PENDING-DATE
197200                                    (X-MM05-SETT-INDEX)
197300                 MOVE +8         TO MM05-PENDING-DATE-L
197400                                    (X-MM05-SETT-INDEX)
197500                 GO TO W517-CPTA-EXIT.
197600*
197700     EVALUATE TRUE
197800       WHEN MM05-MSA-ACH (X-MM05-SETT-INDEX)
197900         EVALUATE TRUE
198000           WHEN MM05-PENDING-CR-RT (X-MM05-SETT-INDEX)
198100                                 IS EQUAL TO ZEROS
198200             SET SS08WS-ERROR-SW-YES TO TRUE
198300             MOVE SS08WS-CURSOR  TO MM05-PENDING-DATE-L
198400                                    (X-MM05-SETT-INDEX)
198500             MOVE DFHBMASB       TO MM05-PENDING-CR-RT-LP-A
198600                                    (X-MM05-SETT-INDEX)
198700                                    MM05-PENDING-CR-RT-RP-A
198800                                    (X-MM05-SETT-INDEX)
198900                                    MM05-PRENOTE-CONTROL-LP-A
199000                                    (X-MM05-SETT-INDEX)
199100                                    MM05-PRENOTE-CONTROL-RP-A
199200                                    (X-MM05-SETT-INDEX)
199300                                    MM05-PENDING-DATE-LP-A
199400                                    (X-MM05-SETT-INDEX)
199500                                    MM05-PENDING-DATE-RP-A
199600                                    (X-MM05-SETT-INDEX)
199700             MOVE DFHBMNBF       TO MM05-PENDING-CR-RT-A
199800                                    (X-MM05-SETT-INDEX)
199900                                    MM05-PENDING-DATE-A
200000                                    (X-MM05-SETT-INDEX)
200100             MOVE DFHBMUBF       TO MM05-PRENOTE-CONTROL-A
200200                                    (X-MM05-SETT-INDEX)
200300         END-EVALUATE
200400         EVALUATE TRUE
200500           WHEN MM05-PENDING-CR-DDA (X-MM05-SETT-INDEX)
200600                                 IS EQUAL TO SPACES
200700             SET SS08WS-ERROR-SW-YES TO TRUE
200800             MOVE SS08WS-CURSOR  TO MM05-PENDING-DATE-L
200900                                    (X-MM05-SETT-INDEX)
201000             MOVE DFHBMASB       TO MM05-PENDING-CR-DDA-LP-A
201100                                    (X-MM05-SETT-INDEX)
201200                                    MM05-PENDING-CR-DDA-RP-A
201300                                    (X-MM05-SETT-INDEX)
201400                                    MM05-PENDING-CR-ACCT-TYPE-LP-A
201500                                    (X-MM05-SETT-INDEX)
201600                                    MM05-PENDING-CR-ACCT-TYPE-RP-A
201700                                    (X-MM05-SETT-INDEX)
201800                                    MM05-PRENOTE-CONTROL-LP-A
201900                                    (X-MM05-SETT-INDEX)
202000                                    MM05-PRENOTE-CONTROL-RP-A
202100                                    (X-MM05-SETT-INDEX)
202200                                    MM05-PENDING-DATE-LP-A
202300                                    (X-MM05-SETT-INDEX)
202400                                    MM05-PENDING-DATE-RP-A
202500                                    (X-MM05-SETT-INDEX)
202600             MOVE DFHBMNBF       TO MM05-PENDING-DATE-A
202700                                    (X-MM05-SETT-INDEX)
202800             MOVE DFHBMUBF       TO MM05-PENDING-CR-DDA-A
202900                                    (X-MM05-SETT-INDEX)
203000                                    MM05-PENDING-CR-ACCT-TYPE-A
203100                                    (X-MM05-SETT-INDEX)
203200                                    MM05-PRENOTE-CONTROL-A
203300                                    (X-MM05-SETT-INDEX)
203400         END-EVALUATE
203500     END-EVALUATE.
203600*
203700     EVALUATE TRUE
203800       WHEN  MM05-MSA-DEBIT-ACH (X-MM05-SETT-INDEX)
203900         EVALUATE TRUE
204000           WHEN MM05-PENDING-DR-RT (X-MM05-SETT-INDEX)
204100                                 IS EQUAL TO ZEROS
204200             SET SS08WS-ERROR-SW-YES TO TRUE
204300             MOVE SS08WS-CURSOR  TO MM05-PENDING-DR-RT-L
204400                                    (X-MM05-SETT-INDEX)
204500             MOVE DFHBMASB       TO MM05-PENDING-DR-RT-LP-A
204600                                    (X-MM05-SETT-INDEX)
204700                                    MM05-PENDING-DR-RT-RP-A
204800                                    (X-MM05-SETT-INDEX)
204900             MOVE DFHBMNBF       TO MM05-PENDING-DR-RT-A
205000                                    (X-MM05-SETT-INDEX)
205100         END-EVALUATE
205200         EVALUATE TRUE
205300           WHEN MM05-PENDING-DR-DDA (X-MM05-SETT-INDEX)
205400                                 IS EQUAL TO SPACES
205500             SET SS08WS-ERROR-SW-YES TO TRUE
205600             MOVE SS08WS-CURSOR  TO MM05-PENDING-DR-DDA-L
205700                                    (X-MM05-SETT-INDEX)
205800             MOVE DFHBMASB       TO MM05-PENDING-DR-DDA-LP-A
205900                                    (X-MM05-SETT-INDEX)
206000                                    MM05-PENDING-DR-DDA-RP-A
206100                                    (X-MM05-SETT-INDEX)
206200                                    MM05-PENDING-DR-ACCT-TYPE-LP-A
206300                                    (X-MM05-SETT-INDEX)
206400                                    MM05-PENDING-DR-ACCT-TYPE-RP-A
206500                                    (X-MM05-SETT-INDEX)
206600             MOVE DFHBMUBF       TO MM05-PENDING-DR-DDA-A
206700                                    (X-MM05-SETT-INDEX)
206800                                    MM05-PENDING-DR-ACCT-TYPE-A
206900                                    (X-MM05-SETT-INDEX)
207000         END-EVALUATE
207100     END-EVALUATE.
207200*
207300     MOVE MMOC-DATE-NEXT-PROC    TO SS01WS-JULIAN.
207400     MOVE MMSC-ACH-CONFIRM-DAYS  TO SS01WS-FREQ.
207500     MOVE 'D'                    TO SS01WS-PERIOD.
207600     MOVE ZERO                   TO SS01WS-DAY-OF-MON.
207700     PERFORM SS03PD-FUTURE-DATE  THRU SS03PD-FD-EXIT.
207800     MOVE SS01WS-JULIAN          TO WS-ACTIVE-DATE-JUL.
207900     MOVE SS01WS-DATE            TO WS-ACTIVE-DATE-GREG.
208000*
208100     IF  MM05-PENDING-DATE (X-MM05-SETT-INDEX) IS EQUAL TO ZERO
208200         MOVE +8                 TO MM05-PENDING-DATE-L
208300                                    (X-MM05-SETT-INDEX)
208400         MOVE WS-ACTIVE-DATE-GREG
208500                                 TO MM05-PENDING-DATE
208600                                    (X-MM05-SETT-INDEX)
208700         GO TO W517-CPTA-EXIT.
208800*
208900     MOVE MM05-PENDING-DATE (X-MM05-SETT-INDEX)
209000                                 TO SS01WS-DATE.
209100     PERFORM SS07PD-GREG-TO-JUL  THRU SS07PD-GTJ-EXIT.
209200*
209300     IF  SS01WS-JULIAN IS LESS THAN WS-ACTIVE-DATE-JUL
209400         GO TO W517-PENDING-TO-ACTIVE-ERROR
209500     ELSE
209600         GO TO W517-CPTA-EXIT.
209700*
209800
209900 W517-PENDING-TO-ACTIVE-ERROR.
210000*
210100     SET SS08WS-ERROR-SW-YES     TO TRUE.
210200     SET ACTIVE-DATE-ERRORS-EXIST (X-ACTIVE-DATE-INDEX)
210300                                 TO TRUE.
210400     MOVE SS08WS-CURSOR          TO MM05-PENDING-DATE-L
210500                                    (X-MM05-SETT-INDEX).
210600     MOVE DFHBMASB               TO MM05-PENDING-DATE-LP-A
210700                                    (X-MM05-SETT-INDEX)
210800                                    MM05-PENDING-DATE-RP-A
210900                                    (X-MM05-SETT-INDEX).
211000     MOVE DFHBMNBF               TO MM05-PENDING-DATE-A
211100                                    (X-MM05-SETT-INDEX).
211200*
211300 W517-CPTA-EXIT.
211400     EXIT.
211500*
211600 W549-ACE-EXIT.
211700     EXIT.
211800/
211900 X000-UPDT-FIELDS SECTION.
212000*
212100 X010-UPDT-ACH-PRENOTE-FLAG.
212200*
212300     EVALUATE TRUE
212400       WHEN  X-MMMM-SETT-ACH IS EQUAL TO 1
212500         MOVE MMMMTB-PRENOTE-CTL-1 (1:4)
212600                                 TO WS-INDEX-X
212700         SET X-MMFS-MERCH        TO WS-INDEX
212800       WHEN  X-MMMM-SETT-ACH IS EQUAL TO 2
212900         MOVE MMMMTB-PRENOTE-CTL-2 (1:4)
213000                                 TO WS-INDEX-X
213100         SET X-MMFS-MERCH        TO WS-INDEX
213200       WHEN  X-MMMM-SETT-ACH IS EQUAL TO 3
213300         MOVE MMMMTB-PRENOTE-CTL-3 (1:4)
213400                                 TO WS-INDEX-X
213500         SET X-MMFS-MERCH        TO WS-INDEX
213600       WHEN  X-MMMM-SETT-ACH IS EQUAL TO 4
213700         MOVE MMMMTB-PRENOTE-CTL-4 (1:4)
213800                                 TO WS-INDEX-X
213900         SET X-MMFS-MERCH        TO WS-INDEX
214000     END-EVALUATE.
214100*
214200     IF  MM05-PRENOTE-CONTROL-L (X-MM05-SETT-INDEX)
214300                                 IS GREATER THAN ZERO
214400         IF  MM05-PRENOTE-CONTROL (X-MM05-SETT-INDEX) IS NOT EQUAL
214500                                 TO MMMM-PRENOTE-CONTROL
214600                                    (X-MMMM-SETT-ACH)
214700             SET WS-UPDATE-SW-YES
214800                                 TO TRUE
214900             IF  MBCA-PTI-FUNCTION-IS-MAINT
215000                 MOVE MMFS-MT-AUDIT-CODE (X-MMFS-MERCH)
215100                                 TO MML1-MMMM-AUDIT-CODE
215200                 MOVE 0501       TO MML1-FIELD-CODE
215300                 SET MML1-FIELD-OCCURRENCE
215400                                 TO X-MMMM-SETT-ACH
215500                 MOVE ZEROES     TO MML1-FIELD-OCCURRENCE-2
215600                 MOVE MML1WS-VL-01
215700                                 TO MML1-VARIABLE-LENGTH
215800                 MOVE MMMM-PRENOTE-CONTROL (X-MMMM-SETT-ACH)
215900                                 TO MML1-VL01-B-DATA-X
216000                 MOVE MM05-PRENOTE-CONTROL (X-MM05-SETT-INDEX)
216100                                 TO MMMM-PRENOTE-CONTROL
216200                                    (X-MMMM-SETT-ACH)
216300                 MOVE MMMM-PRENOTE-CONTROL (X-MMMM-SETT-ACH)
216400                                 TO MML1-VL01-A-DATA-X
216500                 MOVE 'FC12'     TO MBCA-PROGRAM-LOCATION
216600                 PERFORM Y910-WRITE-LOG-RECORD
216700                                 THRU Y919-WLR-EXIT
216800             ELSE
216900                 MOVE MM05-PRENOTE-CONTROL (X-MM05-SETT-INDEX)
217000                                 TO MMMM-PRENOTE-CONTROL
217100                                    (X-MMMM-SETT-ACH).
217200*
217300 X019-EXIT.
217400     EXIT.
217500*
217600 X030-UPDT-PRENOTE-DATE.
217700*
217800     EVALUATE TRUE
217900       WHEN  X-MMMM-SETT-ACH IS EQUAL TO 1
218000         MOVE MMMMTB-PRENOTE-SENT-1 (1:4)
218100                                 TO WS-INDEX-X
218200         SET X-MMFS-MERCH        TO WS-INDEX
218300       WHEN  X-MMMM-SETT-ACH IS EQUAL TO 2
218400         MOVE MMMMTB-PRENOTE-SENT-2 (1:4)
218500                                 TO WS-INDEX-X
218600         SET X-MMFS-MERCH        TO WS-INDEX
218700       WHEN  X-MMMM-SETT-ACH IS EQUAL TO 3
218800         MOVE MMMMTB-PRENOTE-SENT-3 (1:4)
218900                                 TO WS-INDEX-X
219000         SET X-MMFS-MERCH        TO WS-INDEX
219100       WHEN  X-MMMM-SETT-ACH IS EQUAL TO 4
219200         MOVE MMMMTB-PRENOTE-SENT-4 (1:4)
219300                                 TO WS-INDEX-X
219400         SET X-MMFS-MERCH        TO WS-INDEX
219500     END-EVALUATE.
219600*
219700     IF  MM05-PRENOTE-DATE-L (X-MM05-SETT-INDEX)
219800                                 IS GREATER THAN ZERO
219900         MOVE MM05-PRENOTE-DATE-MM (X-MM05-SETT-INDEX)
220000                                 TO SS01WS-MON
220100         MOVE MM05-PRENOTE-DATE-DD (X-MM05-SETT-INDEX)
220200                                 TO SS01WS-DAY
220300         MOVE MM05-PRENOTE-DATE-YYYY (X-MM05-SETT-INDEX)
220400                                 TO SS01WS-YEAR
220500         PERFORM SS07PD-GREG-TO-JUL
220600                                 THRU SS07PD-GTJ-EXIT
220700         IF  SS01WS-JULIAN IS NOT EQUAL
220800                                 TO MMMM-DATE-PRENOTE-INIT
220900                                    (X-MMMM-SETT-ACH)
221000             SET WS-UPDATE-SW-YES
221100                                 TO TRUE
221200             IF  MBCA-PTI-FUNCTION-IS-MAINT
221300                 MOVE MMFS-MT-AUDIT-CODE (X-MMFS-MERCH)
221400                                 TO MML1-MMMM-AUDIT-CODE
221500                 MOVE 0502       TO MML1-FIELD-CODE
221600                 SET MML1-FIELD-OCCURRENCE
221700                                 TO X-MMMM-SETT-ACH
221800                 MOVE ZEROES     TO MML1-FIELD-OCCURRENCE-2
221900                 MOVE MML1WS-VL-07
222000                                 TO MML1-VARIABLE-LENGTH
222100                 MOVE MMMM-DATE-PRENOTE-INIT (X-MMMM-SETT-ACH)
222200                                 TO MML1-VL07-B-DATA-9
222300                 MOVE SS01WS-JULIAN
222400                                 TO MMMM-DATE-PRENOTE-INIT
222500                                    (X-MMMM-SETT-ACH)
222600                 MOVE MMMM-DATE-PRENOTE-INIT (X-MMMM-SETT-ACH)
222700                                 TO MML1-VL07-A-DATA-9
222800                 MOVE 'FC13'     TO MBCA-PROGRAM-LOCATION
222900                 PERFORM Y910-WRITE-LOG-RECORD
223000                                 THRU Y919-WLR-EXIT
223100             ELSE
223200                 MOVE SS01WS-JULIAN
223300                                 TO MMMM-DATE-PRENOTE-INIT
223400                                    (X-MMMM-SETT-ACH).
223500*
223600 X039-EXIT.
223700     EXIT.
223800*
223900 X050-UPDT-MSA-METHOD.
224000*
224100     EVALUATE TRUE
224200       WHEN  X-MMMM-SETT-ACH IS EQUAL TO 1
224300         MOVE MMMMTB-METHOD-1 (1:4)
224400                                 TO WS-INDEX-X
224500         SET X-MMFS-MERCH        TO WS-INDEX
224600       WHEN  X-MMMM-SETT-ACH IS EQUAL TO 2
224700         MOVE MMMMTB-METHOD-2 (1:4)
224800                                 TO WS-INDEX-X
224900         SET X-MMFS-MERCH        TO WS-INDEX
225000       WHEN  X-MMMM-SETT-ACH IS EQUAL TO 3
225100         MOVE MMMMTB-METHOD-3 (1:4)
225200                                 TO WS-INDEX-X
225300         SET X-MMFS-MERCH        TO WS-INDEX
225400       WHEN  X-MMMM-SETT-ACH IS EQUAL TO 4
225500         MOVE MMMMTB-METHOD-4 (1:4)
225600                                 TO WS-INDEX-X
225700         SET X-MMFS-MERCH        TO WS-INDEX
225800     END-EVALUATE.
225900*
226000     IF  MM05-MSA-METHOD-L (X-MM05-SETT-INDEX)
226100                                 IS GREATER THAN ZERO
226200         IF  MM05-MSA-METHOD (X-MM05-SETT-INDEX) IS NOT EQUAL
226300                                 TO MMMM-PENDING-SETT-ACCT-METH
226400                                    (X-MMMM-SETT-ACH)
226500             SET WS-UPDATE-SW-YES
226600                                 TO TRUE
226700             IF  MBCA-PTI-FUNCTION-IS-MAINT
226800                 MOVE MMFS-MT-AUDIT-CODE (X-MMFS-MERCH)
226900                                 TO MML1-MMMM-AUDIT-CODE
227000                 MOVE 0503       TO MML1-FIELD-CODE
227100                 SET MML1-FIELD-OCCURRENCE
227200                                 TO X-MMMM-SETT-ACH
227300                 MOVE ZEROES     TO MML1-FIELD-OCCURRENCE-2
227400                 MOVE MML1WS-VL-02
227500                                 TO MML1-VARIABLE-LENGTH
227600                 MOVE MMMM-PENDING-SETT-ACCT-METH
227700                                    (X-MMMM-SETT-ACH)
227800                                 TO MML1-VL02-B-DATA-X
227900                 MOVE MM05-MSA-METHOD (X-MM05-SETT-INDEX)
228000                                 TO MMMM-PENDING-SETT-ACCT-METH
228100                                    (X-MMMM-SETT-ACH)
228200                 MOVE MMMM-PENDING-SETT-ACCT-METH
228300                                    (X-MMMM-SETT-ACH)
228400                                 TO MML1-VL02-A-DATA-X
228500                 MOVE 'FC14'     TO MBCA-PROGRAM-LOCATION
228600                 PERFORM Y910-WRITE-LOG-RECORD
228700                                 THRU Y919-WLR-EXIT
228800             ELSE
228900                 MOVE MM05-MSA-METHOD (X-MM05-SETT-INDEX)
229000                                 TO MMMM-PENDING-SETT-ACCT-METH
229100                                    (X-MMMM-SETT-ACH).
229200*
229300 X059-EXIT.
229400     EXIT.
229500*
229600 X070-UPDT-PENDING-TO-ACTIVE.
229700*
229800     EVALUATE TRUE
229900       WHEN  X-MMMM-SETT-ACH IS EQUAL TO 1
230000         MOVE MMMMTB-ACTIVE-DATE-1 (1:4)
230100                                 TO WS-INDEX-X
230200         SET X-MMFS-MERCH        TO WS-INDEX
230300       WHEN  X-MMMM-SETT-ACH IS EQUAL TO 2
230400         MOVE MMMMTB-ACTIVE-DATE-2 (1:4)
230500                                 TO WS-INDEX-X
230600         SET X-MMFS-MERCH        TO WS-INDEX
230700       WHEN  X-MMMM-SETT-ACH IS EQUAL TO 3
230800         MOVE MMMMTB-ACTIVE-DATE-3 (1:4)
230900                                 TO WS-INDEX-X
231000         SET X-MMFS-MERCH        TO WS-INDEX
231100       WHEN  X-MMMM-SETT-ACH IS EQUAL TO 4
231200         MOVE MMMMTB-ACTIVE-DATE-4 (1:4)
231300                                 TO WS-INDEX-X
231400         SET X-MMFS-MERCH        TO WS-INDEX
231500     END-EVALUATE.
231600*
231700     IF  MM05-PENDING-DATE-L (X-MM05-SETT-INDEX)
231800                                 IS GREATER THAN ZERO
231900         MOVE MM05-PENDING-DATE (X-MM05-SETT-INDEX)
232000                                 TO SS01WS-DATE
232100         PERFORM SS07PD-GREG-TO-JUL
232200                                 THRU SS07PD-GTJ-EXIT
232300         IF  SS01WS-JULIAN IS NOT EQUAL
232400                                 TO MMMM-DATE-PENDING-ACH-ACTIVE
232500                                    (X-MMMM-SETT-ACH)
232600             SET WS-UPDATE-SW-YES
232700                                 TO TRUE
232800             IF  MBCA-PTI-FUNCTION-IS-MAINT
232900                 MOVE MMFS-MT-AUDIT-CODE (X-MMFS-MERCH)
233000                                 TO MML1-MMMM-AUDIT-CODE
233100                 MOVE 0504       TO MML1-FIELD-CODE
233200                 SET MML1-FIELD-OCCURRENCE
233300                                 TO X-MMMM-SETT-ACH
233400                 MOVE ZEROES     TO MML1-FIELD-OCCURRENCE-2
233500                 MOVE MML1WS-VL-07
233600                                 TO MML1-VARIABLE-LENGTH
233700                 MOVE MMMM-DATE-PENDING-ACH-ACTIVE
233800                                    (X-MMMM-SETT-ACH)
233900                                 TO MML1-VL07-B-DATA-9
234000                 MOVE SS01WS-JULIAN
234100                                 TO MMMM-DATE-PENDING-ACH-ACTIVE
234200                                    (X-MMMM-SETT-ACH)
234300                 MOVE MMMM-DATE-PENDING-ACH-ACTIVE
234400                                    (X-MMMM-SETT-ACH)
234500                                 TO MML1-VL07-A-DATA-9
234600                 MOVE 'FC15'     TO MBCA-PROGRAM-LOCATION
234700                 PERFORM Y910-WRITE-LOG-RECORD
234800                                 THRU Y919-WLR-EXIT
234900             ELSE
235000                 MOVE SS01WS-JULIAN
235100                                 TO MMMM-DATE-PENDING-ACH-ACTIVE
235200                                    (X-MMMM-SETT-ACH).
235300*
235400 X079-EXIT.
235500     EXIT.
235600*
235700 X090-UPDT-ISA-METHOD.
235800*
235900     EVALUATE TRUE
236000       WHEN  X-MMMM-SETT-ACH IS EQUAL TO 1
236100         MOVE MMMMTB-METHOD-1 (1:4)
236200                                 TO WS-INDEX-X
236300         SET X-MMFS-MERCH        TO WS-INDEX
236400       WHEN  X-MMMM-SETT-ACH IS EQUAL TO 2
236500         MOVE MMMMTB-METHOD-2 (1:4)
236600                                 TO WS-INDEX-X
236700         SET X-MMFS-MERCH        TO WS-INDEX
236800       WHEN  X-MMMM-SETT-ACH IS EQUAL TO 3
236900         MOVE MMMMTB-METHOD-3 (1:4)
237000                                 TO WS-INDEX-X
237100         SET X-MMFS-MERCH        TO WS-INDEX
237200       WHEN  X-MMMM-SETT-ACH IS EQUAL TO 4
237300         MOVE MMMMTB-METHOD-4 (1:4)
237400                                 TO WS-INDEX-X
237500         SET X-MMFS-MERCH        TO WS-INDEX
237600     END-EVALUATE.
237700*
237800     IF  MM05-ISA-METHOD-L (X-MM05-SETT-INDEX)
237900                                 IS GREATER THAN ZERO
238000         IF  MM05-ISA-METHOD (X-MM05-SETT-INDEX) IS NOT EQUAL
238100                                 TO MMMM-INTERIM-SETT-ACCT-METH
238200                                    (X-MMMM-SETT-ACH)
238300             SET WS-UPDATE-SW-YES
238400                                 TO TRUE
238500             IF  MBCA-PTI-FUNCTION-IS-MAINT
238600                 MOVE MMFS-MT-AUDIT-CODE (X-MMFS-MERCH)
238700                                 TO MML1-MMMM-AUDIT-CODE
238800                 MOVE 0505       TO MML1-FIELD-CODE
238900                 SET MML1-FIELD-OCCURRENCE
239000                                 TO X-MMMM-SETT-ACH
239100                 MOVE ZEROES     TO MML1-FIELD-OCCURRENCE-2
239200                 MOVE MML1WS-VL-02
239300                                 TO MML1-VARIABLE-LENGTH
239400                 MOVE MMMM-INTERIM-SETT-ACCT-METH
239500                                    (X-MMMM-SETT-ACH)
239600                                 TO MML1-VL02-B-DATA-X
239700                 MOVE MM05-ISA-METHOD (X-MM05-SETT-INDEX)
239800                                 TO MMMM-INTERIM-SETT-ACCT-METH
239900                                    (X-MMMM-SETT-ACH)
240000                 MOVE MMMM-INTERIM-SETT-ACCT-METH
240100                                    (X-MMMM-SETT-ACH)
240200                                 TO MML1-VL02-A-DATA-X
240300                 MOVE 'FC16'     TO MBCA-PROGRAM-LOCATION
240400                 PERFORM Y910-WRITE-LOG-RECORD
240500                                 THRU Y919-WLR-EXIT
240600             ELSE
240700                 MOVE MM05-ISA-METHOD (X-MM05-SETT-INDEX)
240800                                 TO MMMM-INTERIM-SETT-ACCT-METH
240900                                    (X-MMMM-SETT-ACH).
241000*
241100 X099-EXIT.
241200     EXIT.
241300*
241400 X150-UPDT-PENDING-CR-ACCT-TYPE.
241500*
241600     EVALUATE TRUE
241700       WHEN  X-MMMM-SETT-ACH IS EQUAL TO 1
241800         MOVE MMMMTB-PENDING-CR-TYPE-1 (1:4)
241900                                 TO WS-INDEX-X
242000         SET X-MMFS-MERCH        TO WS-INDEX
242100       WHEN  X-MMMM-SETT-ACH IS EQUAL TO 2
242200         MOVE MMMMTB-PENDING-CR-TYPE-2 (1:4)
242300                                 TO WS-INDEX-X
242400         SET X-MMFS-MERCH        TO WS-INDEX
242500       WHEN  X-MMMM-SETT-ACH IS EQUAL TO 3
242600         MOVE MMMMTB-PENDING-CR-TYPE-3 (1:4)
242700                                 TO WS-INDEX-X
242800         SET X-MMFS-MERCH        TO WS-INDEX
242900       WHEN  X-MMMM-SETT-ACH IS EQUAL TO 4
243000         MOVE MMMMTB-PENDING-CR-TYPE-4 (1:4)
243100                                 TO WS-INDEX-X
243200         SET X-MMFS-MERCH        TO WS-INDEX
243300     END-EVALUATE.
243400*
243500     IF  MM05-PENDING-CR-ACCT-TYPE-L (X-MM05-SETT-INDEX)
243600                                 IS GREATER THAN ZERO
243700         IF  MM05-PENDING-CR-ACCT-TYPE (X-MM05-SETT-INDEX)
243800                                    IS NOT EQUAL
243900                                 TO MMMM-PENDING-CR-ACCT-TYPE
244000                                    (X-MMMM-SETT-ACH)
244100             SET WS-UPDATE-SW-YES
244200                                 TO TRUE
244300             IF  MBCA-PTI-FUNCTION-IS-MAINT
244400                 MOVE MMFS-MT-AUDIT-CODE (X-MMFS-MERCH)
244500                                 TO MML1-MMMM-AUDIT-CODE
244600                 MOVE 0506       TO MML1-FIELD-CODE
244700                 SET MML1-FIELD-OCCURRENCE
244800                                 TO X-MMMM-SETT-ACH
244900                 MOVE ZEROES     TO MML1-FIELD-OCCURRENCE-2
245000                 MOVE MML1WS-VL-01
245100                                 TO MML1-VARIABLE-LENGTH
245200                 MOVE MMMM-PENDING-CR-ACCT-TYPE (X-MMMM-SETT-ACH)
245300                                 TO MML1-VL01-B-DATA-X
245400                 MOVE MM05-PENDING-CR-ACCT-TYPE
245500                                    (X-MM05-SETT-INDEX)
245600                                 TO MMMM-PENDING-CR-ACCT-TYPE
245700                                    (X-MMMM-SETT-ACH)
245800                 MOVE MMMM-PENDING-CR-ACCT-TYPE (X-MMMM-SETT-ACH)
245900                                 TO MML1-VL01-A-DATA-X
246000                 MOVE 'FC17'     TO MBCA-PROGRAM-LOCATION
246100                 PERFORM Y910-WRITE-LOG-RECORD
246200                                 THRU Y919-WLR-EXIT
246300             ELSE
246400                 MOVE MM05-PENDING-CR-ACCT-TYPE
246500                                    (X-MM05-SETT-INDEX)
246600                                 TO MMMM-PENDING-CR-ACCT-TYPE
246700                                    (X-MMMM-SETT-ACH).
246800*
246900 X159-EXIT.
247000     EXIT.
247100*
247200 X170-UPDT-PENDING-CR-RT.
247300*
247400     EVALUATE TRUE
247500       WHEN  X-MMMM-SETT-ACH IS EQUAL TO 1
247600         MOVE MMMMTB-PENDING-CR-RT-1 (1:4)
247700                                 TO WS-INDEX-X
247800         SET X-MMFS-MERCH        TO WS-INDEX
247900       WHEN  X-MMMM-SETT-ACH IS EQUAL TO 2
248000         MOVE MMMMTB-PENDING-CR-RT-2 (1:4)
248100                                 TO WS-INDEX-X
248200         SET X-MMFS-MERCH        TO WS-INDEX
248300       WHEN  X-MMMM-SETT-ACH IS EQUAL TO 3
248400         MOVE MMMMTB-PENDING-CR-RT-3 (1:4)
248500                                 TO WS-INDEX-X
248600         SET X-MMFS-MERCH        TO WS-INDEX
248700       WHEN  X-MMMM-SETT-ACH IS EQUAL TO 4
248800         MOVE MMMMTB-PENDING-CR-RT-4 (1:4)
248900                                 TO WS-INDEX-X
249000         SET X-MMFS-MERCH        TO WS-INDEX
249100     END-EVALUATE.
249200*
249300     IF  MM05-PENDING-CR-RT-L (X-MM05-SETT-INDEX)
249400                                 IS GREATER THAN ZERO
249500         IF  MM05-PENDING-CR-RT (X-MM05-SETT-INDEX) IS NOT EQUAL
249600                                 TO MMMM-PENDING-CR-RT
249700                                    (X-MMMM-SETT-ACH)
249800             SET WS-UPDATE-SW-YES
249900                                 TO TRUE
250000             SET PRENOTE-IS-TO-BE-SENT (X-SEND-PRENOTE-INDEX)
250100                                 TO TRUE
250200             IF  MBCA-PTI-FUNCTION-IS-MAINT
250300                 MOVE MMFS-MT-AUDIT-CODE (X-MMFS-MERCH)
250400                                 TO MML1-MMMM-AUDIT-CODE
250500                 MOVE 0507       TO MML1-FIELD-CODE
250600                 SET MML1-FIELD-OCCURRENCE
250700                                 TO X-MMMM-SETT-ACH
250800                 MOVE ZEROES     TO MML1-FIELD-OCCURRENCE-2
250900                 MOVE MML1WS-VL-10
251000                                 TO MML1-VARIABLE-LENGTH
251100                 MOVE MMMM-PENDING-CR-RT (X-MMMM-SETT-ACH)
251200                                 TO MML1-VL10-B-DATA-9
251300                 MOVE MM05-PENDING-CR-RT (X-MM05-SETT-INDEX)
251400                                 TO MMMM-PENDING-CR-RT
251500                                    (X-MMMM-SETT-ACH)
251600                 MOVE MMMM-PENDING-CR-RT (X-MMMM-SETT-ACH)
251700                                 TO MML1-VL10-A-DATA-9
251800                 MOVE 'FC18'     TO MBCA-PROGRAM-LOCATION
251900                 PERFORM Y910-WRITE-LOG-RECORD
252000                                 THRU Y919-WLR-EXIT
252100             ELSE
252200                 MOVE MM05-PENDING-CR-RT (X-MM05-SETT-INDEX)
252300                                 TO MMMM-PENDING-CR-RT
252400                                    (X-MMMM-SETT-ACH).
252500*
252600 X179-EXIT.
252700     EXIT.
252800*
252900 X210-UPDT-PENDING-CR-DDA.
253000*
253100     EVALUATE TRUE
253200       WHEN  X-MMMM-SETT-ACH IS EQUAL TO 1
253300         MOVE MMMMTB-PENDING-CR-ACCT-1 (1:4)
253400                                 TO WS-INDEX-X
253500         SET X-MMFS-MERCH        TO WS-INDEX
253600       WHEN  X-MMMM-SETT-ACH IS EQUAL TO 2
253700         MOVE MMMMTB-PENDING-CR-ACCT-2 (1:4)
253800                                 TO WS-INDEX-X
253900         SET X-MMFS-MERCH        TO WS-INDEX
254000       WHEN  X-MMMM-SETT-ACH IS EQUAL TO 3
254100         MOVE MMMMTB-PENDING-CR-ACCT-3 (1:4)
254200                                 TO WS-INDEX-X
254300         SET X-MMFS-MERCH        TO WS-INDEX
254400       WHEN  X-MMMM-SETT-ACH IS EQUAL TO 4
254500         MOVE MMMMTB-PENDING-CR-ACCT-4 (1:4)
254600                                 TO WS-INDEX-X
254700         SET X-MMFS-MERCH        TO WS-INDEX
254800     END-EVALUATE.
254900*
255000     IF  MM05-PENDING-CR-DDA-L (X-MM05-SETT-INDEX)
255100                                 IS GREATER THAN ZERO
255200         IF  MM05-PENDING-CR-DDA (X-MM05-SETT-INDEX) IS NOT EQUAL
255300                                 TO MMMM-PENDING-CR-ACCT
255400                                    (X-MMMM-SETT-ACH)
255500             SET WS-UPDATE-SW-YES
255600                                 TO TRUE
255700             SET PRENOTE-IS-TO-BE-SENT (X-SEND-PRENOTE-INDEX)
255800                                 TO TRUE
255900             IF  MBCA-PTI-FUNCTION-IS-MAINT
256000                 MOVE MMFS-MT-AUDIT-CODE (X-MMFS-MERCH)
256100                                 TO MML1-MMMM-AUDIT-CODE
256200                 MOVE 0508       TO MML1-FIELD-CODE
256300                 SET MML1-FIELD-OCCURRENCE
256400                                 TO X-MMMM-SETT-ACH
256500                 MOVE ZEROES     TO MML1-FIELD-OCCURRENCE-2
256600                 MOVE MML1WS-VL-20
256700                                 TO MML1-VARIABLE-LENGTH
256800                 MOVE MMMM-PENDING-CR-ACCT (X-MMMM-SETT-ACH)
256900                                 TO MML1-VL20-B-DATA-X
257000                 MOVE MM05-PENDING-CR-DDA (X-MM05-SETT-INDEX)
257100                                 TO MMMM-PENDING-CR-ACCT
257200                                    (X-MMMM-SETT-ACH)
257300                 MOVE MMMM-PENDING-CR-ACCT (X-MMMM-SETT-ACH)
257400                                 TO MML1-VL20-A-DATA-X
257500                 MOVE 'FC19'     TO MBCA-PROGRAM-LOCATION
257600                 PERFORM Y910-WRITE-LOG-RECORD
257700                                 THRU Y919-WLR-EXIT
257800             ELSE
257900                 MOVE MM05-PENDING-CR-DDA (X-MM05-SETT-INDEX)
258000                                 TO MMMM-PENDING-CR-ACCT
258100                                    (X-MMMM-SETT-ACH).
258200*
258300 X219-EXIT.
258400     EXIT.
258500*
258600 X270-UPDT-PENDING-DR-ACCT-TYPE.
258700*
258800     EVALUATE TRUE
258900       WHEN  X-MMMM-SETT-ACH IS EQUAL TO 1
259000         MOVE MMMMTB-PENDING-DR-TYPE-1 (1:4)
259100                                 TO WS-INDEX-X
259200         SET X-MMFS-MERCH        TO WS-INDEX
259300       WHEN  X-MMMM-SETT-ACH IS EQUAL TO 2
259400         MOVE MMMMTB-PENDING-DR-TYPE-2 (1:4)
259500                                 TO WS-INDEX-X
259600         SET X-MMFS-MERCH        TO WS-INDEX
259700       WHEN  X-MMMM-SETT-ACH IS EQUAL TO 3
259800         MOVE MMMMTB-PENDING-DR-TYPE-3 (1:4)
259900                                 TO WS-INDEX-X
260000         SET X-MMFS-MERCH        TO WS-INDEX
260100       WHEN  X-MMMM-SETT-ACH IS EQUAL TO 4
260200         MOVE MMMMTB-PENDING-DR-TYPE-4 (1:4)
260300                                 TO WS-INDEX-X
260400         SET X-MMFS-MERCH        TO WS-INDEX
260500     END-EVALUATE.
260600*
260700     IF  MM05-PENDING-DR-ACCT-TYPE-L (X-MM05-SETT-INDEX)
260800                                 IS GREATER THAN ZERO
260900         IF  MM05-PENDING-DR-ACCT-TYPE (X-MM05-SETT-INDEX)
261000                                    IS NOT EQUAL
261100                                 TO MMMM-PENDING-DR-ACCT-TYPE
261200                                    (X-MMMM-SETT-ACH)
261300             SET WS-UPDATE-SW-YES
261400                                 TO TRUE
261500             IF  MBCA-PTI-FUNCTION-IS-MAINT
261600                 MOVE MMFS-MT-AUDIT-CODE (X-MMFS-MERCH)
261700                                 TO MML1-MMMM-AUDIT-CODE
261800                 MOVE 0509       TO MML1-FIELD-CODE
261900                 SET MML1-FIELD-OCCURRENCE
262000                                 TO X-MMMM-SETT-ACH
262100                 MOVE ZEROES     TO MML1-FIELD-OCCURRENCE-2
262200                 MOVE MML1WS-VL-01
262300                                 TO MML1-VARIABLE-LENGTH
262400                 MOVE MMMM-PENDING-DR-ACCT-TYPE (X-MMMM-SETT-ACH)
262500                                 TO MML1-VL01-B-DATA-X
262600                 MOVE MM05-PENDING-DR-ACCT-TYPE
262700                                    (X-MM05-SETT-INDEX)
262800                                 TO MMMM-PENDING-DR-ACCT-TYPE
262900                                    (X-MMMM-SETT-ACH)
263000                 MOVE MMMM-PENDING-DR-ACCT-TYPE (X-MMMM-SETT-ACH)
263100                                 TO MML1-VL01-A-DATA-X
263200                 MOVE 'FC20'     TO MBCA-PROGRAM-LOCATION
263300                 PERFORM Y910-WRITE-LOG-RECORD
263400                                 THRU Y919-WLR-EXIT
263500             ELSE
263600                 MOVE MM05-PENDING-DR-ACCT-TYPE
263700                                    (X-MM05-SETT-INDEX)
263800                                 TO MMMM-PENDING-DR-ACCT-TYPE
263900                                    (X-MMMM-SETT-ACH).
264000*
264100 X279-EXIT.
264200     EXIT.
264300*
264400 X290-UPDT-PENDING-DR-RT.
264500*
264600     EVALUATE TRUE
264700       WHEN  X-MMMM-SETT-ACH IS EQUAL TO 1
264800         MOVE MMMMTB-PENDING-DR-RT-1 (1:4)
264900                                 TO WS-INDEX-X
265000         SET X-MMFS-MERCH        TO WS-INDEX
265100       WHEN  X-MMMM-SETT-ACH IS EQUAL TO 2
265200         MOVE MMMMTB-PENDING-DR-RT-2 (1:4)
265300                                 TO WS-INDEX-X
265400         SET X-MMFS-MERCH        TO WS-INDEX
265500       WHEN  X-MMMM-SETT-ACH IS EQUAL TO 3
265600         MOVE MMMMTB-PENDING-DR-RT-3 (1:4)
265700                                 TO WS-INDEX-X
265800         SET X-MMFS-MERCH        TO WS-INDEX
265900       WHEN  X-MMMM-SETT-ACH IS EQUAL TO 4
266000         MOVE MMMMTB-PENDING-DR-RT-4 (1:4)
266100                                 TO WS-INDEX-X
266200         SET X-MMFS-MERCH        TO WS-INDEX
266300     END-EVALUATE.
266400*
266500     IF  MM05-PENDING-DR-RT-L (X-MM05-SETT-INDEX)
266600                                 IS GREATER THAN ZERO
266700         IF  MM05-PENDING-DR-RT (X-MM05-SETT-INDEX) IS NOT EQUAL
266800                                 TO MMMM-PENDING-DR-RT
266900                                    (X-MMMM-SETT-ACH)
267000             SET WS-UPDATE-SW-YES
267100                                 TO TRUE
267200             SET PRENOTE-IS-TO-BE-SENT (X-SEND-PRENOTE-INDEX)
267300                                 TO TRUE
267400             IF  MBCA-PTI-FUNCTION-IS-MAINT
267500                 MOVE MMFS-MT-AUDIT-CODE (X-MMFS-MERCH)
267600                                 TO MML1-MMMM-AUDIT-CODE
267700                 MOVE 0510       TO MML1-FIELD-CODE
267800                 SET MML1-FIELD-OCCURRENCE
267900                                 TO X-MMMM-SETT-ACH
268000                 MOVE ZEROES     TO MML1-FIELD-OCCURRENCE-2
268100                 MOVE MML1WS-VL-10
268200                                 TO MML1-VARIABLE-LENGTH
268300                 MOVE MMMM-PENDING-DR-RT (X-MMMM-SETT-ACH)
268400                                 TO MML1-VL10-B-DATA-9
268500                 MOVE MM05-PENDING-DR-RT (X-MM05-SETT-INDEX)
268600                                 TO MMMM-PENDING-DR-RT
268700                                    (X-MMMM-SETT-ACH)
268800                 MOVE MMMM-PENDING-DR-RT (X-MMMM-SETT-ACH)
268900                                 TO MML1-VL10-A-DATA-9
269000                 MOVE 'FC21'     TO MBCA-PROGRAM-LOCATION
269100                 PERFORM Y910-WRITE-LOG-RECORD
269200                                 THRU Y919-WLR-EXIT
269300             ELSE
269400                 MOVE MM05-PENDING-DR-RT (X-MM05-SETT-INDEX)
269500                                 TO MMMM-PENDING-DR-RT
269600                                    (X-MMMM-SETT-ACH).
269700*
269800 X299-EXIT.
269900     EXIT.
270000*
270100 X330-UPDT-PENDING-DR-DDA.
270200*
270300     EVALUATE TRUE
270400       WHEN  X-MMMM-SETT-ACH IS EQUAL TO 1
270500         MOVE MMMMTB-PENDING-DR-ACCT-1 (1:4)
270600                                 TO WS-INDEX-X
270700         SET X-MMFS-MERCH        TO WS-INDEX
270800       WHEN  X-MMMM-SETT-ACH IS EQUAL TO 2
270900         MOVE MMMMTB-PENDING-DR-ACCT-2 (1:4)
271000                                 TO WS-INDEX-X
271100         SET X-MMFS-MERCH        TO WS-INDEX
271200       WHEN  X-MMMM-SETT-ACH IS EQUAL TO 3
271300         MOVE MMMMTB-PENDING-DR-ACCT-3 (1:4)
271400                                 TO WS-INDEX-X
271500         SET X-MMFS-MERCH        TO WS-INDEX
271600       WHEN  X-MMMM-SETT-ACH IS EQUAL TO 4
271700         MOVE MMMMTB-PENDING-DR-ACCT-4 (1:4)
271800                                 TO WS-INDEX-X
271900         SET X-MMFS-MERCH        TO WS-INDEX
272000     END-EVALUATE.
272100*
272200     IF  MM05-PENDING-DR-DDA-L (X-MM05-SETT-INDEX)
272300                                 IS GREATER THAN ZERO
272400         IF  MM05-PENDING-DR-DDA (X-MM05-SETT-INDEX) IS NOT EQUAL
272500                                 TO MMMM-PENDING-DR-ACCT
272600                                    (X-MMMM-SETT-ACH)
272700             SET WS-UPDATE-SW-YES
272800                                 TO TRUE
272900             SET PRENOTE-IS-TO-BE-SENT (X-SEND-PRENOTE-INDEX)
273000                                 TO TRUE
273100             IF  MBCA-PTI-FUNCTION-IS-MAINT
273200                 MOVE MMFS-MT-AUDIT-CODE (X-MMFS-MERCH)
273300                                 TO MML1-MMMM-AUDIT-CODE
273400                 MOVE 0511       TO MML1-FIELD-CODE
273500                 SET MML1-FIELD-OCCURRENCE
273600                                 TO X-MMMM-SETT-ACH
273700                 MOVE ZEROES     TO MML1-FIELD-OCCURRENCE-2
273800                 MOVE MML1WS-VL-20
273900                                 TO MML1-VARIABLE-LENGTH
274000                 MOVE MMMM-PENDING-DR-ACCT (X-MMMM-SETT-ACH)
274100                                 TO MML1-VL20-B-DATA-X
274200                 MOVE MM05-PENDING-DR-DDA (X-MM05-SETT-INDEX)
274300                                 TO MMMM-PENDING-DR-ACCT
274400                                    (X-MMMM-SETT-ACH)
274500                 MOVE MMMM-PENDING-DR-ACCT (X-MMMM-SETT-ACH)
274600                                 TO MML1-VL20-A-DATA-X
274700                 MOVE 'FC22'     TO MBCA-PROGRAM-LOCATION
274800                 PERFORM Y910-WRITE-LOG-RECORD
274900                                 THRU Y919-WLR-EXIT
275000             ELSE
275100                 MOVE MM05-PENDING-DR-DDA (X-MM05-SETT-INDEX)
275200                                 TO MMMM-PENDING-DR-ACCT
275300                                    (X-MMMM-SETT-ACH).
275400*
275500 X339-EXIT.
275600     EXIT.
275700/
275800 Y000-PERFORMED-ROUTINES SECTION.
275900*
276000 Y010-MOVE-ACH-PRENOTE-FLAG.
276100*
276200     MOVE MMMM-PRENOTE-CONTROL (X-MMMM-SETT-ACH)
276300                                 TO MM05-PRENOTE-CONTROL
276400                                    (X-MM05-SETT-INDEX).
276500*
276600 Y015-ACH-PRENOTE-FLAG-SECURITY.
276700*
276800     EVALUATE TRUE
276900       WHEN  X-MMMM-SETT-ACH IS EQUAL TO 1
277000         MOVE MMMMTB-PRENOTE-CTL-1 (1:4)
277100                                 TO WS-INDEX-X
277200         SET X-MMFS-MERCH        TO WS-INDEX
277300       WHEN  X-MMMM-SETT-ACH IS EQUAL TO 2
277400         MOVE MMMMTB-PRENOTE-CTL-2 (1:4)
277500                                 TO WS-INDEX-X
277600         SET X-MMFS-MERCH        TO WS-INDEX
277700       WHEN  X-MMMM-SETT-ACH IS EQUAL TO 3
277800         MOVE MMMMTB-PRENOTE-CTL-3 (1:4)
277900                                 TO WS-INDEX-X
278000         SET X-MMFS-MERCH        TO WS-INDEX
278100       WHEN  X-MMMM-SETT-ACH IS EQUAL TO 4
278200         MOVE MMMMTB-PRENOTE-CTL-4 (1:4)
278300                                 TO WS-INDEX-X
278400         SET X-MMFS-MERCH        TO WS-INDEX
278500     END-EVALUATE.
278600*
278700     IF  MMFS-MT-NO-ACCESS (X-MMFS-MERCH)
278800         MOVE DFHBMDAS           TO MM05-PRENOTE-CONTROL-LIT-A
278900                                    (X-MM05-SETT-INDEX)
279000                                    MM05-PRENOTE-CONTROL-LP-A
279100                                    (X-MM05-SETT-INDEX)
279200                                    MM05-PRENOTE-CONTROL-RP-A
279300                                    (X-MM05-SETT-INDEX)
279400                                    MM05-PRENOTE-CONTROL-A
279500                                    (X-MM05-SETT-INDEX)
279600         MOVE ZERO               TO MM05-PRENOTE-CONTROL-L
279700                                    (X-MM05-SETT-INDEX)
279800         GO TO Y019-EXIT.
279900*
280000     IF  MBCA-PTI-FUNCTION-IS-INQUIRY
280100         MOVE DFHBMDAS           TO MM05-PRENOTE-CONTROL-LP-A
280200                                    (X-MM05-SETT-INDEX)
280300                                    MM05-PRENOTE-CONTROL-RP-A
280400                                    (X-MM05-SETT-INDEX)
280500         MOVE DFHBMASB           TO MM05-PRENOTE-CONTROL-A
280600                                    (X-MM05-SETT-INDEX)
280700         GO TO Y019-EXIT.
280800*
280900     IF  MMFS-MT-INQ-ONLY (X-MMFS-MERCH)
281000         MOVE ZERO               TO MM05-PRENOTE-CONTROL-L
281100                                    (X-MM05-SETT-INDEX)
281200         MOVE DFHBMDAS           TO MM05-PRENOTE-CONTROL-LP-A
281300                                    (X-MM05-SETT-INDEX)
281400                                    MM05-PRENOTE-CONTROL-RP-A
281500                                    (X-MM05-SETT-INDEX)
281600         MOVE DFHBMASK           TO MM05-PRENOTE-CONTROL-A
281700                                    (X-MM05-SETT-INDEX)
281800         GO TO Y019-EXIT.
281900*
282000     IF  MBCA-PTI-FUNCTION-IS-ADD
282100         IF  MMFS-MT-REQUIRED (X-MMFS-MERCH)
282200             MOVE DFHBMASB       TO MM05-PRENOTE-CONTROL-LIT-A
282300                                    (X-MM05-SETT-INDEX)
282400         ELSE
282500             IF  MMFS-MT-MAINT-ONLY (X-MMFS-MERCH)
282600                 MOVE ZERO       TO MM05-PRENOTE-CONTROL-L
282700                                    (X-MM05-SETT-INDEX)
282800                 MOVE DFHBMDAS   TO MM05-PRENOTE-CONTROL-LP-A
282900                                    (X-MM05-SETT-INDEX)
283000                                    MM05-PRENOTE-CONTROL-RP-A
283100                                    (X-MM05-SETT-INDEX)
283200                 MOVE DFHBMASK   TO MM05-PRENOTE-CONTROL-A
283300                                    (X-MM05-SETT-INDEX).
283400*
283500     IF  MBCA-PTI-FUNCTION-IS-MAINT
283600         IF  MMFS-MT-NO-MAINT (X-MMFS-MERCH)
283700             MOVE ZERO           TO MM05-PRENOTE-CONTROL-L
283800                                    (X-MM05-SETT-INDEX)
283900             MOVE DFHBMDAS       TO MM05-PRENOTE-CONTROL-LP-A
284000                                    (X-MM05-SETT-INDEX)
284100                                    MM05-PRENOTE-CONTROL-RP-A
284200                                    (X-MM05-SETT-INDEX)
284300             MOVE DFHBMASK       TO MM05-PRENOTE-CONTROL-A
284400                                    (X-MM05-SETT-INDEX).
284500*
284600 Y019-EXIT.
284700     EXIT.
284800*
284900 Y030-MOVE-PRENOTE-DATE.
285000*
285100     MOVE MMMM-DATE-PRENOTE-INIT (X-MMMM-SETT-ACH)
285200                                 TO SS01WS-JULIAN.
285300     PERFORM SS26PD-NUMERICALLY-EDIT-DATE  THRU SS26PD-NED-EXIT.
285400     MOVE SS01WS-XX-XX-YYYY      TO MM05-PRENOTE-DATE
285500                                    (X-MM05-SETT-INDEX).
285600*
285700 Y035-PRENOTE-DATE-SECURITY.
285800*
285900     EVALUATE TRUE
286000       WHEN  X-MMMM-SETT-ACH IS EQUAL TO 1
286100         MOVE MMMMTB-PRENOTE-SENT-1 (1:4)
286200                                 TO WS-INDEX-X
286300         SET X-MMFS-MERCH        TO WS-INDEX
286400       WHEN  X-MMMM-SETT-ACH IS EQUAL TO 2
286500         MOVE MMMMTB-PRENOTE-SENT-2 (1:4)
286600                                 TO WS-INDEX-X
286700         SET X-MMFS-MERCH        TO WS-INDEX
286800       WHEN  X-MMMM-SETT-ACH IS EQUAL TO 3
286900         MOVE MMMMTB-PRENOTE-SENT-3 (1:4)
287000                                 TO WS-INDEX-X
287100         SET X-MMFS-MERCH        TO WS-INDEX
287200       WHEN  X-MMMM-SETT-ACH IS EQUAL TO 4
287300         MOVE MMMMTB-PRENOTE-SENT-4 (1:4)
287400                                 TO WS-INDEX-X
287500         SET X-MMFS-MERCH        TO WS-INDEX
287600     END-EVALUATE.
287700*
287800     IF  MMFS-MT-NO-ACCESS (X-MMFS-MERCH)
287900         MOVE DFHBMDAS           TO MM05-PRENOTE-DATE-LIT-A
288000                                    (X-MM05-SETT-INDEX)
288100                                    MM05-PRENOTE-DATE-A
288200                                    (X-MM05-SETT-INDEX)
288300         MOVE ZERO               TO MM05-PRENOTE-DATE-L
288400                                    (X-MM05-SETT-INDEX)
288500         GO TO Y039-EXIT.
288600*
288700     IF  MBCA-PTI-FUNCTION-IS-INQUIRY
288800         MOVE DFHBMASB           TO MM05-PRENOTE-DATE-A
288900                                    (X-MM05-SETT-INDEX)
289000         GO TO Y039-EXIT.
289100*
289200 Y039-EXIT.
289300     EXIT.
289400*
289500 Y050-MOVE-MSA-METHOD.
289600*
289700     MOVE MMMM-PENDING-SETT-ACCT-METH (X-MMMM-SETT-ACH)
289800                                 TO MM05-MSA-METHOD
289900                                    (X-MM05-SETT-INDEX).
290000*
290100 Y055-MSA-METHOD-SECURITY.
290200*
290300     EVALUATE TRUE
290400       WHEN  X-MMMM-SETT-ACH IS EQUAL TO 1
290500         MOVE MMMMTB-METHOD-1 (1:4)
290600                                 TO WS-INDEX-X
290700         SET X-MMFS-MERCH        TO WS-INDEX
290800       WHEN  X-MMMM-SETT-ACH IS EQUAL TO 2
290900         MOVE MMMMTB-METHOD-2 (1:4)
291000                                 TO WS-INDEX-X
291100         SET X-MMFS-MERCH        TO WS-INDEX
291200       WHEN  X-MMMM-SETT-ACH IS EQUAL TO 3
291300         MOVE MMMMTB-METHOD-3 (1:4)
291400                                 TO WS-INDEX-X
291500         SET X-MMFS-MERCH        TO WS-INDEX
291600       WHEN  X-MMMM-SETT-ACH IS EQUAL TO 4
291700         MOVE MMMMTB-METHOD-4 (1:4)
291800                                 TO WS-INDEX-X
291900         SET X-MMFS-MERCH        TO WS-INDEX
292000     END-EVALUATE.
292100*
292200     IF  MMFS-MT-NO-ACCESS (X-MMFS-MERCH)
292300         MOVE DFHBMDAS           TO MM05-MSA-METHOD-LIT-A
292400                                    (X-MM05-SETT-INDEX)
292500                                    MM05-MSA-METHOD-LP-A
292600                                    (X-MM05-SETT-INDEX)
292700                                    MM05-MSA-METHOD-RP-A
292800                                    (X-MM05-SETT-INDEX)
292900                                    MM05-MSA-METHOD-A
293000                                    (X-MM05-SETT-INDEX)
293100         MOVE ZERO               TO MM05-MSA-METHOD-L
293200                                    (X-MM05-SETT-INDEX)
293300         GO TO Y059-EXIT.
293400*
293500     IF  MBCA-PTI-FUNCTION-IS-INQUIRY
293600         MOVE DFHBMDAS           TO MM05-MSA-METHOD-LP-A
293700                                    (X-MM05-SETT-INDEX)
293800                                    MM05-MSA-METHOD-RP-A
293900                                    (X-MM05-SETT-INDEX)
294000         MOVE DFHBMASB           TO MM05-MSA-METHOD-A
294100                                    (X-MM05-SETT-INDEX)
294200         GO TO Y059-EXIT.
294300*
294400     IF  MMFS-MT-INQ-ONLY (X-MMFS-MERCH)
294500         MOVE ZERO               TO MM05-MSA-METHOD-L
294600                                    (X-MM05-SETT-INDEX)
294700         MOVE DFHBMDAS           TO MM05-MSA-METHOD-LP-A
294800                                    (X-MM05-SETT-INDEX)
294900                                    MM05-MSA-METHOD-RP-A
295000                                    (X-MM05-SETT-INDEX)
295100         MOVE DFHBMASK           TO MM05-MSA-METHOD-A
295200                                    (X-MM05-SETT-INDEX)
295300         GO TO Y059-EXIT.
295400*
295500     IF  MBCA-PTI-FUNCTION-IS-ADD
295600         IF  MMFS-MT-REQUIRED (X-MMFS-MERCH)
295700             MOVE DFHBMASB       TO MM05-MSA-METHOD-LIT-A
295800                                    (X-MM05-SETT-INDEX)
295900         ELSE
296000             IF  MMFS-MT-MAINT-ONLY (X-MMFS-MERCH)
296100                 MOVE ZERO       TO MM05-MSA-METHOD-L
296200                                    (X-MM05-SETT-INDEX)
296300                 MOVE DFHBMDAS   TO MM05-MSA-METHOD-LP-A
296400                                    (X-MM05-SETT-INDEX)
296500                                    MM05-MSA-METHOD-RP-A
296600                                    (X-MM05-SETT-INDEX)
296700                 MOVE DFHBMASK   TO MM05-MSA-METHOD-A
296800                                    (X-MM05-SETT-INDEX).
296900*
297000     IF  MBCA-PTI-FUNCTION-IS-MAINT
297100         IF  MMFS-MT-NO-MAINT (X-MMFS-MERCH)
297200             MOVE ZERO           TO MM05-MSA-METHOD-L
297300                                    (X-MM05-SETT-INDEX)
297400             MOVE DFHBMDAS       TO MM05-MSA-METHOD-LP-A
297500                                    (X-MM05-SETT-INDEX)
297600                                    MM05-MSA-METHOD-RP-A
297700                                    (X-MM05-SETT-INDEX)
297800             MOVE DFHBMASK       TO MM05-MSA-METHOD-A
297900                                    (X-MM05-SETT-INDEX).
298000*
298100 Y059-EXIT.
298200     EXIT.
298300*
298400 Y070-MOVE-PENDING-TO-ACTIVE.
298500*
298600     MOVE MMMM-DATE-PENDING-ACH-ACTIVE (X-MMMM-SETT-ACH)
298700                                 TO SS01WS-JULIAN.
298800     PERFORM SS08PD-JUL-TO-GREG  THRU SS08PD-JTG-EXIT.
298900     MOVE SS01WS-DATE            TO MM05-PENDING-DATE
299000                                    (X-MM05-SETT-INDEX).
299100*
299200 Y075-PENDING-TO-ACTIVE-SECUR.
299300*
299400     EVALUATE TRUE
299500       WHEN  X-MMMM-SETT-ACH IS EQUAL TO 1
299600         MOVE MMMMTB-ACTIVE-DATE-1 (1:4)
299700                                 TO WS-INDEX-X
299800         SET X-MMFS-MERCH        TO WS-INDEX
299900       WHEN  X-MMMM-SETT-ACH IS EQUAL TO 2
300000         MOVE MMMMTB-ACTIVE-DATE-2 (1:4)
300100                                 TO WS-INDEX-X
300200         SET X-MMFS-MERCH        TO WS-INDEX
300300       WHEN  X-MMMM-SETT-ACH IS EQUAL TO 3
300400         MOVE MMMMTB-ACTIVE-DATE-3 (1:4)
300500                                 TO WS-INDEX-X
300600         SET X-MMFS-MERCH        TO WS-INDEX
300700       WHEN  X-MMMM-SETT-ACH IS EQUAL TO 4
300800         MOVE MMMMTB-ACTIVE-DATE-4 (1:4)
300900                                 TO WS-INDEX-X
301000         SET X-MMFS-MERCH        TO WS-INDEX
301100     END-EVALUATE.
301200*
301300     IF  MMFS-MT-NO-ACCESS (X-MMFS-MERCH)
301400         MOVE DFHBMDAS           TO MM05-PENDING-DATE-LIT-A
301500                                    (X-MM05-SETT-INDEX)
301600                                    MM05-PENDING-DATE-LP-A
301700                                    (X-MM05-SETT-INDEX)
301800                                    MM05-PENDING-DATE-RP-A
301900                                    (X-MM05-SETT-INDEX)
302000                                    MM05-PENDING-DATE-A
302100                                    (X-MM05-SETT-INDEX)
302200         MOVE ZERO               TO MM05-PENDING-DATE-L
302300                                    (X-MM05-SETT-INDEX)
302400         GO TO Y079-EXIT.
302500*
302600     IF  MBCA-PTI-FUNCTION-IS-INQUIRY
302700         MOVE DFHBMDAS           TO MM05-PENDING-DATE-LP-A
302800                                    (X-MM05-SETT-INDEX)
302900                                    MM05-PENDING-DATE-RP-A
303000                                    (X-MM05-SETT-INDEX)
303100         MOVE DFHBMASB           TO MM05-PENDING-DATE-A
303200                                    (X-MM05-SETT-INDEX)
303300         GO TO Y079-EXIT.
303400*
303500     IF  MMFS-MT-INQ-ONLY (X-MMFS-MERCH)
303600         MOVE ZERO               TO MM05-PENDING-DATE-L
303700                                    (X-MM05-SETT-INDEX)
303800         MOVE DFHBMDAS           TO MM05-PENDING-DATE-LP-A
303900                                    (X-MM05-SETT-INDEX)
304000                                    MM05-PENDING-DATE-RP-A
304100                                    (X-MM05-SETT-INDEX)
304200         MOVE DFHBMASK           TO MM05-PENDING-DATE-A
304300                                    (X-MM05-SETT-INDEX)
304400         GO TO Y079-EXIT.
304500*
304600     IF  MBCA-PTI-FUNCTION-IS-ADD
304700         IF  MMFS-MT-REQUIRED (X-MMFS-MERCH)
304800             MOVE DFHBMASB       TO MM05-PENDING-DATE-LIT-A
304900                                    (X-MM05-SETT-INDEX)
305000         ELSE
305100             IF  MMFS-MT-MAINT-ONLY (X-MMFS-MERCH)
305200                 MOVE ZERO       TO MM05-PENDING-DATE-L
305300                                    (X-MM05-SETT-INDEX)
305400                 MOVE DFHBMDAS   TO MM05-PENDING-DATE-LP-A
305500                                    (X-MM05-SETT-INDEX)
305600                                    MM05-PENDING-DATE-RP-A
305700                                    (X-MM05-SETT-INDEX)
305800                 MOVE DFHBMASK   TO MM05-PENDING-DATE-A
305900                                    (X-MM05-SETT-INDEX).
306000*
306100     IF  MBCA-PTI-FUNCTION-IS-MAINT
306200         IF  MMFS-MT-NO-MAINT (X-MMFS-MERCH)
306300             MOVE ZERO           TO MM05-PENDING-DATE-L
306400                                    (X-MM05-SETT-INDEX)
306500             MOVE DFHBMDAS       TO MM05-PENDING-DATE-LP-A
306600                                    (X-MM05-SETT-INDEX)
306700                                    MM05-PENDING-DATE-RP-A
306800                                    (X-MM05-SETT-INDEX)
306900             MOVE DFHBMASK       TO MM05-PENDING-DATE-A
307000                                    (X-MM05-SETT-INDEX).
307100*
307200 Y079-EXIT.
307300     EXIT.
307400*
307500 Y090-MOVE-ISA-METHOD.
307600*
307700     MOVE MMMM-INTERIM-SETT-ACCT-METH (X-MMMM-SETT-ACH)
307800                                 TO MM05-ISA-METHOD
307900                                    (X-MM05-SETT-INDEX).
308000*
308100 Y095-ISA-METHOD-SECURITY.
308200*
308300     EVALUATE TRUE
308400       WHEN  X-MMMM-SETT-ACH IS EQUAL TO 1
308500         MOVE MMMMTB-METHOD-1 (1:4)
308600                                 TO WS-INDEX-X
308700         SET X-MMFS-MERCH        TO WS-INDEX
308800       WHEN  X-MMMM-SETT-ACH IS EQUAL TO 2
308900         MOVE MMMMTB-METHOD-2 (1:4)
309000                                 TO WS-INDEX-X
309100         SET X-MMFS-MERCH        TO WS-INDEX
309200       WHEN  X-MMMM-SETT-ACH IS EQUAL TO 3
309300         MOVE MMMMTB-METHOD-3 (1:4)
309400                                 TO WS-INDEX-X
309500         SET X-MMFS-MERCH        TO WS-INDEX
309600       WHEN  X-MMMM-SETT-ACH IS EQUAL TO 4
309700         MOVE MMMMTB-METHOD-4 (1:4)
309800                                 TO WS-INDEX-X
309900         SET X-MMFS-MERCH        TO WS-INDEX
310000     END-EVALUATE.
310100*
310200     IF  MMFS-MT-NO-ACCESS (X-MMFS-MERCH)
310300         MOVE DFHBMDAS           TO MM05-ISA-METHOD-LIT-A
310400                                    (X-MM05-SETT-INDEX)
310500                                    MM05-ISA-METHOD-LP-A
310600                                    (X-MM05-SETT-INDEX)
310700                                    MM05-ISA-METHOD-RP-A
310800                                    (X-MM05-SETT-INDEX)
310900                                    MM05-ISA-METHOD-A
311000                                    (X-MM05-SETT-INDEX)
311100         MOVE ZERO               TO MM05-ISA-METHOD-L
311200                                    (X-MM05-SETT-INDEX)
311300         GO TO Y099-EXIT.
311400*
311500     IF  MBCA-PTI-FUNCTION-IS-INQUIRY
311600         MOVE DFHBMDAS           TO MM05-ISA-METHOD-LP-A
311700                                    (X-MM05-SETT-INDEX)
311800                                    MM05-ISA-METHOD-RP-A
311900                                    (X-MM05-SETT-INDEX)
312000         MOVE DFHBMASB           TO MM05-ISA-METHOD-A
312100                                    (X-MM05-SETT-INDEX)
312200         GO TO Y099-EXIT.
312300*
312400     IF  MMFS-MT-INQ-ONLY (X-MMFS-MERCH)
312500         MOVE ZERO               TO MM05-ISA-METHOD-L
312600                                    (X-MM05-SETT-INDEX)
312700         MOVE DFHBMDAS           TO MM05-ISA-METHOD-LP-A
312800                                    (X-MM05-SETT-INDEX)
312900                                    MM05-ISA-METHOD-RP-A
313000                                    (X-MM05-SETT-INDEX)
313100         MOVE DFHBMASK           TO MM05-ISA-METHOD-A
313200                                    (X-MM05-SETT-INDEX)
313300         GO TO Y099-EXIT.
313400*
313500     IF  MBCA-PTI-FUNCTION-IS-ADD
313600         IF  MMFS-MT-REQUIRED (X-MMFS-MERCH)
313700             MOVE DFHBMASB       TO MM05-ISA-METHOD-LIT-A
313800                                    (X-MM05-SETT-INDEX)
313900         ELSE
314000             IF  MMFS-MT-MAINT-ONLY (X-MMFS-MERCH)
314100                 MOVE ZERO       TO MM05-ISA-METHOD-L
314200                                    (X-MM05-SETT-INDEX)
314300                 MOVE DFHBMDAS   TO MM05-ISA-METHOD-LP-A
314400                                    (X-MM05-SETT-INDEX)
314500                                    MM05-ISA-METHOD-RP-A
314600                                    (X-MM05-SETT-INDEX)
314700                 MOVE DFHBMASK   TO MM05-ISA-METHOD-A
314800                                    (X-MM05-SETT-INDEX).
314900*
315000     IF  MBCA-PTI-FUNCTION-IS-MAINT
315100         IF  MMFS-MT-NO-MAINT (X-MMFS-MERCH)
315200             MOVE ZERO           TO MM05-ISA-METHOD-L
315300                                    (X-MM05-SETT-INDEX)
315400             MOVE DFHBMDAS       TO MM05-ISA-METHOD-LP-A
315500                                    (X-MM05-SETT-INDEX)
315600                                    MM05-ISA-METHOD-RP-A
315700                                    (X-MM05-SETT-INDEX)
315800             MOVE DFHBMASK       TO MM05-ISA-METHOD-A
315900                                    (X-MM05-SETT-INDEX).
316000*
316100 Y099-EXIT.
316200     EXIT.
316300*
316400 Y110-MOVE-ACTIVE-CR-ACCT-TYPE.
316500*
316600     MOVE MMMM-ACTIVE-CR-ACCT-TYPE (X-MMMM-SETT-ACH)
316700                                 TO MM05-ACTIVE-CR-ACCT-TYPE
316800                                    (X-MM05-SETT-INDEX).
316900*
317000 Y115-ACT-CR-ACCT-TYPE-SECURITY.
317100*
317200     EVALUATE TRUE
317300       WHEN  X-MMMM-SETT-ACH IS EQUAL TO 1
317400         MOVE MMMMTB-ACTIVE-CR-TYPE-1 (1:4)
317500                                 TO WS-INDEX-X
317600         SET X-MMFS-MERCH        TO WS-INDEX
317700       WHEN  X-MMMM-SETT-ACH IS EQUAL TO 2
317800         MOVE MMMMTB-ACTIVE-CR-TYPE-2 (1:4)
317900                                 TO WS-INDEX-X
318000         SET X-MMFS-MERCH        TO WS-INDEX
318100       WHEN  X-MMMM-SETT-ACH IS EQUAL TO 3
318200         MOVE MMMMTB-ACTIVE-CR-TYPE-3 (1:4)
318300                                 TO WS-INDEX-X
318400         SET X-MMFS-MERCH        TO WS-INDEX
318500       WHEN  X-MMMM-SETT-ACH IS EQUAL TO 4
318600         MOVE MMMMTB-ACTIVE-CR-TYPE-4 (1:4)
318700                                 TO WS-INDEX-X
318800         SET X-MMFS-MERCH        TO WS-INDEX
318900     END-EVALUATE.
319000*
319100     IF  MMFS-MT-NO-ACCESS (X-MMFS-MERCH)
319200         MOVE DFHBMDAS           TO MM05-ACTIVE-CR-ACCT-TYPE-A
319300                                    (X-MM05-SETT-INDEX)
319400         MOVE ZERO               TO MM05-ACTIVE-CR-ACCT-TYPE-L
319500                                    (X-MM05-SETT-INDEX)
319600         GO TO Y119-EXIT.
319700*
319800     IF  MBCA-PTI-FUNCTION-IS-INQUIRY
319900         MOVE DFHBMASB           TO MM05-ACTIVE-CR-ACCT-TYPE-A
320000                                    (X-MM05-SETT-INDEX)
320100         GO TO Y119-EXIT.
320200*
320300     IF  MMFS-MT-INQ-ONLY (X-MMFS-MERCH)
320400         MOVE ZERO               TO MM05-ACTIVE-CR-ACCT-TYPE-L
320500                                    (X-MM05-SETT-INDEX)
320600         MOVE DFHBMASK           TO MM05-ACTIVE-CR-ACCT-TYPE-A
320700                                    (X-MM05-SETT-INDEX)
320800         GO TO Y119-EXIT.
320900*
321000     IF  MBCA-PTI-FUNCTION-IS-ADD
321100         IF  NOT MMFS-MT-REQUIRED (X-MMFS-MERCH)
321200             IF  MMFS-MT-MAINT-ONLY (X-MMFS-MERCH)
321300                 MOVE ZERO       TO MM05-ACTIVE-CR-ACCT-TYPE-L
321400                                    (X-MM05-SETT-INDEX)
321500                 MOVE DFHBMASK   TO MM05-ACTIVE-CR-ACCT-TYPE-A
321600                                    (X-MM05-SETT-INDEX).
321700*
321800     IF  MBCA-PTI-FUNCTION-IS-MAINT
321900         IF  MMFS-MT-NO-MAINT (X-MMFS-MERCH)
322000             MOVE ZERO           TO MM05-ACTIVE-CR-ACCT-TYPE-L
322100                                    (X-MM05-SETT-INDEX)
322200             MOVE DFHBMASK       TO MM05-ACTIVE-CR-ACCT-TYPE-A
322300                                    (X-MM05-SETT-INDEX).
322400*
322500 Y119-EXIT.
322600     EXIT.
322700*
322800 Y130-MOVE-ACTIVE-CR-RT.
322900*
323000     MOVE MMMM-ACTIVE-CR-RT (X-MMMM-SETT-ACH)
323100                                 TO MM05-ACTIVE-CR-RT
323200                                    (X-MM05-SETT-INDEX).
323300*
323400 Y135-ACTIVE-CR-RT-SECURITY.
323500*
323600     EVALUATE TRUE
323700       WHEN  X-MMMM-SETT-ACH IS EQUAL TO 1
323800         MOVE MMMMTB-ACTIVE-CR-RT-1 (1:4)
323900                                 TO WS-INDEX-X
324000         SET X-MMFS-MERCH        TO WS-INDEX
324100       WHEN  X-MMMM-SETT-ACH IS EQUAL TO 2
324200         MOVE MMMMTB-ACTIVE-CR-RT-2 (1:4)
324300                                 TO WS-INDEX-X
324400         SET X-MMFS-MERCH        TO WS-INDEX
324500       WHEN  X-MMMM-SETT-ACH IS EQUAL TO 3
324600         MOVE MMMMTB-ACTIVE-CR-RT-3 (1:4)
324700                                 TO WS-INDEX-X
324800         SET X-MMFS-MERCH        TO WS-INDEX
324900       WHEN  X-MMMM-SETT-ACH IS EQUAL TO 4
325000         MOVE MMMMTB-ACTIVE-CR-RT-4 (1:4)
325100                                 TO WS-INDEX-X
325200         SET X-MMFS-MERCH        TO WS-INDEX
325300     END-EVALUATE.
325400*
325500     IF  MMFS-MT-NO-ACCESS (X-MMFS-MERCH)
325600         MOVE DFHBMDAS           TO MM05-ACTIVE-CR-RT-LIT-A
325700                                    (X-MM05-SETT-INDEX)
325800                                    MM05-ACTIVE-CR-RT-A
325900                                    (X-MM05-SETT-INDEX)
326000         MOVE ZERO               TO MM05-ACTIVE-CR-RT-L
326100                                    (X-MM05-SETT-INDEX)
326200         GO TO Y139-EXIT.
326300*
326400     IF  MBCA-PTI-FUNCTION-IS-INQUIRY
326500         MOVE DFHBMASB           TO MM05-ACTIVE-CR-RT-A
326600                                    (X-MM05-SETT-INDEX)
326700         GO TO Y139-EXIT.
326800*
326900     IF  MMFS-MT-INQ-ONLY (X-MMFS-MERCH)
327000         MOVE ZERO               TO MM05-ACTIVE-CR-RT-L
327100                                    (X-MM05-SETT-INDEX)
327200         MOVE DFHBMASK           TO MM05-ACTIVE-CR-RT-A
327300                                    (X-MM05-SETT-INDEX)
327400         GO TO Y139-EXIT.
327500*
327600     IF  MBCA-PTI-FUNCTION-IS-ADD
327700         IF  MMFS-MT-REQUIRED (X-MMFS-MERCH)
327800             MOVE DFHBMASB       TO MM05-ACTIVE-CR-RT-LIT-A
327900                                    (X-MM05-SETT-INDEX)
328000         ELSE
328100             IF  MMFS-MT-MAINT-ONLY (X-MMFS-MERCH)
328200                 MOVE ZERO       TO MM05-ACTIVE-CR-RT-L
328300                                    (X-MM05-SETT-INDEX)
328400                 MOVE DFHBMASK   TO MM05-ACTIVE-CR-RT-A
328500                                    (X-MM05-SETT-INDEX).
328600*
328700     IF  MBCA-PTI-FUNCTION-IS-MAINT
328800         IF  MMFS-MT-NO-MAINT (X-MMFS-MERCH)
328900             MOVE ZERO           TO MM05-ACTIVE-CR-RT-L
329000                                    (X-MM05-SETT-INDEX)
329100             MOVE DFHBMASK       TO MM05-ACTIVE-CR-RT-A
329200                                    (X-MM05-SETT-INDEX).
329300*
329400 Y139-EXIT.
329500     EXIT.
329600*
329700 Y150-MOVE-PENDING-CR-ACCT-TYPE.
329800*
329900     MOVE MMMM-PENDING-CR-ACCT-TYPE (X-MMMM-SETT-ACH)
330000                                 TO MM05-PENDING-CR-ACCT-TYPE
330100                                    (X-MM05-SETT-INDEX).
330200*
330300 Y155-PND-CR-ACCT-TYPE-SECURITY.
330400*
330500     EVALUATE TRUE
330600       WHEN  X-MMMM-SETT-ACH IS EQUAL TO 1
330700         MOVE MMMMTB-PENDING-CR-TYPE-1 (1:4)
330800                                 TO WS-INDEX-X
330900         SET X-MMFS-MERCH        TO WS-INDEX
331000       WHEN  X-MMMM-SETT-ACH IS EQUAL TO 2
331100         MOVE MMMMTB-PENDING-CR-TYPE-2 (1:4)
331200                                 TO WS-INDEX-X
331300         SET X-MMFS-MERCH        TO WS-INDEX
331400       WHEN  X-MMMM-SETT-ACH IS EQUAL TO 3
331500         MOVE MMMMTB-PENDING-CR-TYPE-3 (1:4)
331600                                 TO WS-INDEX-X
331700         SET X-MMFS-MERCH        TO WS-INDEX
331800       WHEN  X-MMMM-SETT-ACH IS EQUAL TO 4
331900         MOVE MMMMTB-PENDING-CR-TYPE-4 (1:4)
332000                                 TO WS-INDEX-X
332100         SET X-MMFS-MERCH        TO WS-INDEX
332200     END-EVALUATE.
332300*
332400     IF  MMFS-MT-NO-ACCESS (X-MMFS-MERCH)
332500         MOVE DFHBMDAS           TO MM05-PENDING-CR-ACCT-TYPE-LP-A
332600                                    (X-MM05-SETT-INDEX)
332700                                    MM05-PENDING-CR-ACCT-TYPE-RP-A
332800                                    (X-MM05-SETT-INDEX)
332900                                    MM05-PENDING-CR-ACCT-TYPE-A
333000                                    (X-MM05-SETT-INDEX)
333100         MOVE ZERO               TO MM05-PENDING-CR-ACCT-TYPE-L
333200                                    (X-MM05-SETT-INDEX)
333300         GO TO Y159-EXIT.
333400*
333500     IF  MBCA-PTI-FUNCTION-IS-INQUIRY
333600         MOVE DFHBMDAS           TO MM05-PENDING-CR-ACCT-TYPE-LP-A
333700                                    (X-MM05-SETT-INDEX)
333800                                    MM05-PENDING-CR-ACCT-TYPE-RP-A
333900                                    (X-MM05-SETT-INDEX)
334000         MOVE DFHBMASB           TO MM05-PENDING-CR-ACCT-TYPE-A
334100                                    (X-MM05-SETT-INDEX)
334200         GO TO Y159-EXIT.
334300*
334400     IF  MMFS-MT-INQ-ONLY (X-MMFS-MERCH)
334500         MOVE ZERO               TO MM05-PENDING-CR-ACCT-TYPE-L
334600                                    (X-MM05-SETT-INDEX)
334700         MOVE DFHBMDAS           TO MM05-PENDING-CR-ACCT-TYPE-LP-A
334800                                    (X-MM05-SETT-INDEX)
334900                                    MM05-PENDING-CR-ACCT-TYPE-RP-A
335000                                    (X-MM05-SETT-INDEX)
335100         MOVE DFHBMASK           TO MM05-PENDING-CR-ACCT-TYPE-A
335200                                    (X-MM05-SETT-INDEX)
335300         GO TO Y159-EXIT.
335400*
335500     IF  MBCA-PTI-FUNCTION-IS-ADD
335600         IF  MMFS-MT-REQUIRED (X-MMFS-MERCH)
335700             IF  MMFS-MT-MAINT-ONLY (X-MMFS-MERCH)
335800                 MOVE ZERO       TO MM05-PENDING-CR-ACCT-TYPE-L
335900                                    (X-MM05-SETT-INDEX)
336000                 MOVE DFHBMDAS   TO MM05-PENDING-CR-ACCT-TYPE-LP-A
336100                                    (X-MM05-SETT-INDEX)
336200                                    MM05-PENDING-CR-ACCT-TYPE-RP-A
336300                                    (X-MM05-SETT-INDEX)
336400                 MOVE DFHBMASK   TO MM05-PENDING-CR-ACCT-TYPE-A
336500                                    (X-MM05-SETT-INDEX).
336600*
336700     IF  MBCA-PTI-FUNCTION-IS-MAINT
336800         IF  MMFS-MT-NO-MAINT (X-MMFS-MERCH)
336900             MOVE ZERO           TO MM05-PENDING-CR-ACCT-TYPE-L
337000                                    (X-MM05-SETT-INDEX)
337100             MOVE DFHBMDAS       TO MM05-PENDING-CR-ACCT-TYPE-LP-A
337200                                    (X-MM05-SETT-INDEX)
337300                                    MM05-PENDING-CR-ACCT-TYPE-RP-A
337400                                    (X-MM05-SETT-INDEX)
337500             MOVE DFHBMASK       TO MM05-PENDING-CR-ACCT-TYPE-A
337600                                    (X-MM05-SETT-INDEX).
337700*
337800 Y159-EXIT.
337900     EXIT.
338000*
338100 Y170-MOVE-PENDING-CR-RT.
338200*
338300     MOVE MMMM-PENDING-CR-RT (X-MMMM-SETT-ACH)
338400                                 TO MM05-PENDING-CR-RT
338500                                    (X-MM05-SETT-INDEX).
338600*
338700 Y175-PENDING-CR-RT-SECURITY.
338800*
338900     EVALUATE TRUE
339000       WHEN  X-MMMM-SETT-ACH IS EQUAL TO 1
339100         MOVE MMMMTB-PENDING-CR-RT-1 (1:4)
339200                                 TO WS-INDEX-X
339300         SET X-MMFS-MERCH        TO WS-INDEX
339400       WHEN  X-MMMM-SETT-ACH IS EQUAL TO 2
339500         MOVE MMMMTB-PENDING-CR-RT-2 (1:4)
339600                                 TO WS-INDEX-X
339700         SET X-MMFS-MERCH        TO WS-INDEX
339800       WHEN  X-MMMM-SETT-ACH IS EQUAL TO 3
339900         MOVE MMMMTB-PENDING-CR-RT-3 (1:4)
340000                                 TO WS-INDEX-X
340100         SET X-MMFS-MERCH        TO WS-INDEX
340200       WHEN  X-MMMM-SETT-ACH IS EQUAL TO 4
340300         MOVE MMMMTB-PENDING-CR-RT-4 (1:4)
340400                                 TO WS-INDEX-X
340500         SET X-MMFS-MERCH        TO WS-INDEX
340600     END-EVALUATE.
340700*
340800     IF  MMFS-MT-NO-ACCESS (X-MMFS-MERCH)
340900         MOVE DFHBMDAS           TO MM05-PENDING-CR-RT-LIT-A
341000                                    (X-MM05-SETT-INDEX)
341100                                    MM05-PENDING-CR-RT-LP-A
341200                                    (X-MM05-SETT-INDEX)
341300                                    MM05-PENDING-CR-RT-RP-A
341400                                    (X-MM05-SETT-INDEX)
341500                                    MM05-PENDING-CR-RT-A
341600                                    (X-MM05-SETT-INDEX)
341700         MOVE ZERO               TO MM05-PENDING-CR-RT-L
341800                                    (X-MM05-SETT-INDEX)
341900         GO TO Y179-EXIT.
342000*
342100     IF  MBCA-PTI-FUNCTION-IS-INQUIRY
342200         MOVE DFHBMDAS           TO MM05-PENDING-CR-RT-LP-A
342300                                    (X-MM05-SETT-INDEX)
342400                                    MM05-PENDING-CR-RT-RP-A
342500                                    (X-MM05-SETT-INDEX)
342600         MOVE DFHBMASB           TO MM05-PENDING-CR-RT-A
342700                                    (X-MM05-SETT-INDEX)
342800         GO TO Y179-EXIT.
342900*
343000     IF  MMFS-MT-INQ-ONLY (X-MMFS-MERCH)
343100         MOVE ZERO               TO MM05-PENDING-CR-RT-L
343200                                    (X-MM05-SETT-INDEX)
343300         MOVE DFHBMDAS           TO MM05-PENDING-CR-RT-LP-A
343400                                    (X-MM05-SETT-INDEX)
343500                                    MM05-PENDING-CR-RT-RP-A
343600                                    (X-MM05-SETT-INDEX)
343700         MOVE DFHBMASK           TO MM05-PENDING-CR-RT-A
343800                                    (X-MM05-SETT-INDEX)
343900         GO TO Y179-EXIT.
344000*
344100     IF  MBCA-PTI-FUNCTION-IS-ADD
344200         IF  MMFS-MT-REQUIRED (X-MMFS-MERCH)
344300             MOVE DFHBMASB       TO MM05-PENDING-CR-RT-LIT-A
344400                                    (X-MM05-SETT-INDEX)
344500         ELSE
344600             IF  MMFS-MT-MAINT-ONLY (X-MMFS-MERCH)
344700                 MOVE ZERO       TO MM05-PENDING-CR-RT-L
344800                                    (X-MM05-SETT-INDEX)
344900                 MOVE DFHBMDAS   TO MM05-PENDING-CR-RT-LP-A
345000                                    (X-MM05-SETT-INDEX)
345100                                    MM05-PENDING-CR-RT-RP-A
345200                                    (X-MM05-SETT-INDEX)
345300                 MOVE DFHBMASK   TO MM05-PENDING-CR-RT-A
345400                                    (X-MM05-SETT-INDEX).
345500*
345600     IF  MBCA-PTI-FUNCTION-IS-MAINT
345700         IF  MMFS-MT-NO-MAINT (X-MMFS-MERCH)
345800             MOVE ZERO           TO MM05-PENDING-CR-RT-L
345900                                    (X-MM05-SETT-INDEX)
346000             MOVE DFHBMDAS       TO MM05-PENDING-CR-RT-LP-A
346100                                    (X-MM05-SETT-INDEX)
346200                                    MM05-PENDING-CR-RT-RP-A
346300                                    (X-MM05-SETT-INDEX)
346400             MOVE DFHBMASK       TO MM05-PENDING-CR-RT-A
346500                                    (X-MM05-SETT-INDEX).
346600*
346700 Y179-EXIT.
346800     EXIT.
346900*
347000 Y190-MOVE-ACTIVE-CR-DDA.
347100*
347200     MOVE MMMM-ACTIVE-CR-ACCT (X-MMMM-SETT-ACH)
347300                                 TO MM05-ACTIVE-CR-DDA
347400                                    (X-MM05-SETT-INDEX).
347500*
347600 Y195-ACTIVE-CR-DDA-SECURITY.
347700*
347800     EVALUATE TRUE
347900       WHEN  X-MMMM-SETT-ACH IS EQUAL TO 1
348000         MOVE MMMMTB-ACTIVE-CR-ACCT-1 (1:4)
348100                                 TO WS-INDEX-X
348200         SET X-MMFS-MERCH        TO WS-INDEX
348300       WHEN  X-MMMM-SETT-ACH IS EQUAL TO 2
348400         MOVE MMMMTB-ACTIVE-CR-ACCT-2 (1:4)
348500                                 TO WS-INDEX-X
348600         SET X-MMFS-MERCH        TO WS-INDEX
348700       WHEN  X-MMMM-SETT-ACH IS EQUAL TO 3
348800         MOVE MMMMTB-ACTIVE-CR-ACCT-3 (1:4)
348900                                 TO WS-INDEX-X
349000         SET X-MMFS-MERCH        TO WS-INDEX
349100       WHEN  X-MMMM-SETT-ACH IS EQUAL TO 4
349200         MOVE MMMMTB-ACTIVE-CR-ACCT-4 (1:4)
349300                                 TO WS-INDEX-X
349400         SET X-MMFS-MERCH        TO WS-INDEX
349500     END-EVALUATE.
349600*
349700     IF  MMFS-MT-NO-ACCESS (X-MMFS-MERCH)
349800         MOVE DFHBMDAS           TO MM05-ACTIVE-CR-DDA-LIT-A
349900                                    (X-MM05-SETT-INDEX)
350000                                    MM05-ACTIVE-CR-DDA-A
350100                                    (X-MM05-SETT-INDEX)
350200         MOVE ZERO               TO MM05-ACTIVE-CR-DDA-L
350300                                    (X-MM05-SETT-INDEX)
350400         GO TO Y199-EXIT.
350500*
350600     IF  MBCA-PTI-FUNCTION-IS-INQUIRY
350700         MOVE DFHBMASB           TO MM05-ACTIVE-CR-DDA-A
350800                                    (X-MM05-SETT-INDEX)
350900         GO TO Y199-EXIT.
351000*
351100     IF  MMFS-MT-INQ-ONLY (X-MMFS-MERCH)
351200         MOVE ZERO               TO MM05-ACTIVE-CR-DDA-L
351300                                    (X-MM05-SETT-INDEX)
351400         MOVE DFHBMASK           TO MM05-ACTIVE-CR-DDA-A
351500                                    (X-MM05-SETT-INDEX)
351600         GO TO Y199-EXIT.
351700*
351800     IF  MBCA-PTI-FUNCTION-IS-ADD
351900         IF  MMFS-MT-REQUIRED (X-MMFS-MERCH)
352000             MOVE DFHBMASB       TO MM05-ACTIVE-CR-DDA-LIT-A
352100                                    (X-MM05-SETT-INDEX)
352200         ELSE
352300             IF  MMFS-MT-MAINT-ONLY (X-MMFS-MERCH)
352400                 MOVE ZERO       TO MM05-ACTIVE-CR-DDA-L
352500                                    (X-MM05-SETT-INDEX)
352600                 MOVE DFHBMASK   TO MM05-ACTIVE-CR-DDA-A
352700                                    (X-MM05-SETT-INDEX).
352800*
352900     IF  MBCA-PTI-FUNCTION-IS-MAINT
353000         IF  MMFS-MT-NO-MAINT (X-MMFS-MERCH)
353100             MOVE ZERO           TO MM05-ACTIVE-CR-DDA-L
353200                                    (X-MM05-SETT-INDEX)
353300             MOVE DFHBMASK       TO MM05-ACTIVE-CR-DDA-A
353400                                    (X-MM05-SETT-INDEX).
353500*
353600 Y199-EXIT.
353700     EXIT.
353800*
353900 Y210-MOVE-PENDING-CR-DDA.
354000*
354100     MOVE MMMM-PENDING-CR-ACCT (X-MMMM-SETT-ACH)
354200                                 TO MM05-PENDING-CR-DDA
354300                                    (X-MM05-SETT-INDEX).
354400*
354500 Y215-PENDING-CR-DDA-SECURITY.
354600*
354700     EVALUATE TRUE
354800       WHEN  X-MMMM-SETT-ACH IS EQUAL TO 1
354900         MOVE MMMMTB-PENDING-CR-ACCT-1 (1:4)
355000                                 TO WS-INDEX-X
355100         SET X-MMFS-MERCH        TO WS-INDEX
355200       WHEN  X-MMMM-SETT-ACH IS EQUAL TO 2
355300         MOVE MMMMTB-PENDING-CR-ACCT-2 (1:4)
355400                                 TO WS-INDEX-X
355500         SET X-MMFS-MERCH        TO WS-INDEX
355600       WHEN  X-MMMM-SETT-ACH IS EQUAL TO 3
355700         MOVE MMMMTB-PENDING-CR-ACCT-3 (1:4)
355800                                 TO WS-INDEX-X
355900         SET X-MMFS-MERCH        TO WS-INDEX
356000       WHEN  X-MMMM-SETT-ACH IS EQUAL TO 4
356100         MOVE MMMMTB-PENDING-CR-ACCT-4 (1:4)
356200                                 TO WS-INDEX-X
356300         SET X-MMFS-MERCH        TO WS-INDEX
356400     END-EVALUATE.
356500*
356600     IF  MMFS-MT-NO-ACCESS (X-MMFS-MERCH)
356700         MOVE DFHBMDAS           TO MM05-PENDING-CR-DDA-LIT-A
356800                                    (X-MM05-SETT-INDEX)
356900                                    MM05-PENDING-CR-DDA-LP-A
357000                                    (X-MM05-SETT-INDEX)
357100                                    MM05-PENDING-CR-DDA-RP-A
357200                                    (X-MM05-SETT-INDEX)
357300                                    MM05-PENDING-CR-DDA-A
357400                                    (X-MM05-SETT-INDEX)
357500         MOVE ZERO               TO MM05-PENDING-CR-DDA-L
357600                                    (X-MM05-SETT-INDEX)
357700         GO TO Y219-EXIT.
357800*
357900     IF  MBCA-PTI-FUNCTION-IS-INQUIRY
358000         MOVE DFHBMDAS           TO MM05-PENDING-CR-DDA-LP-A
358100                                    (X-MM05-SETT-INDEX)
358200                                    MM05-PENDING-CR-DDA-RP-A
358300                                    (X-MM05-SETT-INDEX)
358400         MOVE DFHBMASB           TO MM05-PENDING-CR-DDA-A
358500                                    (X-MM05-SETT-INDEX)
358600         GO TO Y219-EXIT.
358700*
358800     IF  MMFS-MT-INQ-ONLY (X-MMFS-MERCH)
358900         MOVE ZERO               TO MM05-PENDING-CR-DDA-L
359000                                    (X-MM05-SETT-INDEX)
359100         MOVE DFHBMDAS           TO MM05-PENDING-CR-DDA-LP-A
359200                                    (X-MM05-SETT-INDEX)
359300                                    MM05-PENDING-CR-DDA-RP-A
359400                                    (X-MM05-SETT-INDEX)
359500         MOVE DFHBMASK           TO MM05-PENDING-CR-DDA-A
359600                                    (X-MM05-SETT-INDEX)
359700         GO TO Y219-EXIT.
359800*
359900     IF  MBCA-PTI-FUNCTION-IS-ADD
360000         IF  MMFS-MT-REQUIRED (X-MMFS-MERCH)
360100             MOVE DFHBMASB       TO MM05-PENDING-CR-DDA-LIT-A
360200                                    (X-MM05-SETT-INDEX)
360300         ELSE
360400             IF  MMFS-MT-MAINT-ONLY (X-MMFS-MERCH)
360500                 MOVE ZERO       TO MM05-PENDING-CR-DDA-L
360600                                    (X-MM05-SETT-INDEX)
360700                 MOVE DFHBMDAS   TO MM05-PENDING-CR-DDA-LP-A
360800                                    (X-MM05-SETT-INDEX)
360900                                    MM05-PENDING-CR-DDA-RP-A
361000                                    (X-MM05-SETT-INDEX)
361100                 MOVE DFHBMASK   TO MM05-PENDING-CR-DDA-A
361200                                    (X-MM05-SETT-INDEX).
361300*
361400     IF  MBCA-PTI-FUNCTION-IS-MAINT
361500         IF  MMFS-MT-NO-MAINT (X-MMFS-MERCH)
361600             MOVE ZERO           TO MM05-PENDING-CR-DDA-L
361700                                    (X-MM05-SETT-INDEX)
361800             MOVE DFHBMDAS       TO MM05-PENDING-CR-DDA-LP-A
361900                                    (X-MM05-SETT-INDEX)
362000                                    MM05-PENDING-CR-DDA-RP-A
362100                                    (X-MM05-SETT-INDEX)
362200             MOVE DFHBMASK       TO MM05-PENDING-CR-DDA-A
362300                                    (X-MM05-SETT-INDEX).
362400*
362500 Y219-EXIT.
362600     EXIT.
362700*
362800 Y230-MOVE-ACTIVE-DR-ACCT-TYPE.
362900*
363000     MOVE MMMM-ACTIVE-DR-ACCT-TYPE (X-MMMM-SETT-ACH)
363100                                 TO MM05-ACTIVE-DR-ACCT-TYPE
363200                                    (X-MM05-SETT-INDEX).
363300*
363400 Y235-ACT-DR-ACCT-TYPE-SECURITY.
363500*
363600     EVALUATE TRUE
363700       WHEN  X-MMMM-SETT-ACH IS EQUAL TO 1
363800         MOVE MMMMTB-ACTIVE-DR-TYPE-1 (1:4)
363900                                 TO WS-INDEX-X
364000         SET X-MMFS-MERCH        TO WS-INDEX
364100       WHEN  X-MMMM-SETT-ACH IS EQUAL TO 2
364200         MOVE MMMMTB-ACTIVE-DR-TYPE-2 (1:4)
364300                                 TO WS-INDEX-X
364400         SET X-MMFS-MERCH        TO WS-INDEX
364500       WHEN  X-MMMM-SETT-ACH IS EQUAL TO 3
364600         MOVE MMMMTB-ACTIVE-DR-TYPE-3 (1:4)
364700                                 TO WS-INDEX-X
364800         SET X-MMFS-MERCH        TO WS-INDEX
364900       WHEN  X-MMMM-SETT-ACH IS EQUAL TO 4
365000         MOVE MMMMTB-ACTIVE-DR-TYPE-4 (1:4)
365100                                 TO WS-INDEX-X
365200         SET X-MMFS-MERCH        TO WS-INDEX
365300     END-EVALUATE.
365400*
365500     IF  MMFS-MT-NO-ACCESS (X-MMFS-MERCH)
365600         MOVE DFHBMDAS           TO MM05-ACTIVE-DR-ACCT-TYPE-A
365700                                    (X-MM05-SETT-INDEX)
365800         MOVE ZERO               TO MM05-ACTIVE-DR-ACCT-TYPE-L
365900                                    (X-MM05-SETT-INDEX)
366000         GO TO Y239-EXIT.
366100*
366200     IF  MBCA-PTI-FUNCTION-IS-INQUIRY
366300         MOVE DFHBMASB           TO MM05-ACTIVE-DR-ACCT-TYPE-A
366400                                    (X-MM05-SETT-INDEX)
366500         GO TO Y239-EXIT.
366600*
366700     IF  MMFS-MT-INQ-ONLY (X-MMFS-MERCH)
366800         MOVE ZERO               TO MM05-ACTIVE-DR-ACCT-TYPE-L
366900                                    (X-MM05-SETT-INDEX)
367000         MOVE DFHBMASK           TO MM05-ACTIVE-DR-ACCT-TYPE-A
367100                                    (X-MM05-SETT-INDEX)
367200         GO TO Y239-EXIT.
367300*
367400     IF  MBCA-PTI-FUNCTION-IS-ADD
367500         IF  MMFS-MT-MAINT-ONLY (X-MMFS-MERCH)
367600             MOVE ZERO           TO MM05-ACTIVE-DR-ACCT-TYPE-L
367700                                    (X-MM05-SETT-INDEX)
367800             MOVE DFHBMASK       TO MM05-ACTIVE-DR-ACCT-TYPE-A
367900                                    (X-MM05-SETT-INDEX).
368000*
368100     IF  MBCA-PTI-FUNCTION-IS-MAINT
368200         IF  MMFS-MT-NO-MAINT (X-MMFS-MERCH)
368300             MOVE ZERO           TO MM05-ACTIVE-DR-ACCT-TYPE-L
368400                                    (X-MM05-SETT-INDEX)
368500             MOVE DFHBMASK       TO MM05-ACTIVE-DR-ACCT-TYPE-A
368600                                    (X-MM05-SETT-INDEX).
368700*
368800 Y239-EXIT.
368900     EXIT.
369000*
369100 Y250-MOVE-ACTIVE-DR-RT.
369200*
369300     MOVE MMMM-ACTIVE-DR-RT (X-MMMM-SETT-ACH)
369400                                 TO MM05-ACTIVE-DR-RT
369500                                    (X-MM05-SETT-INDEX).
369600*
369700 Y255-ACTIVE-DR-RT-SECURITY.
369800*
369900     EVALUATE TRUE
370000       WHEN  X-MMMM-SETT-ACH IS EQUAL TO 1
370100         MOVE MMMMTB-ACTIVE-DR-RT-1 (1:4)
370200                                 TO WS-INDEX-X
370300         SET X-MMFS-MERCH        TO WS-INDEX
370400       WHEN  X-MMMM-SETT-ACH IS EQUAL TO 2
370500         MOVE MMMMTB-ACTIVE-DR-RT-2 (1:4)
370600                                 TO WS-INDEX-X
370700         SET X-MMFS-MERCH        TO WS-INDEX
370800       WHEN  X-MMMM-SETT-ACH IS EQUAL TO 3
370900         MOVE MMMMTB-ACTIVE-DR-RT-3 (1:4)
371000                                 TO WS-INDEX-X
371100         SET X-MMFS-MERCH        TO WS-INDEX
371200       WHEN  X-MMMM-SETT-ACH IS EQUAL TO 4
371300         MOVE MMMMTB-ACTIVE-DR-RT-4 (1:4)
371400                                 TO WS-INDEX-X
371500         SET X-MMFS-MERCH        TO WS-INDEX
371600     END-EVALUATE.
371700*
371800     IF  MMFS-MT-NO-ACCESS (X-MMFS-MERCH)
371900         MOVE DFHBMDAS           TO MM05-ACTIVE-DR-RT-LIT-A
372000                                    (X-MM05-SETT-INDEX)
372100                                    MM05-ACTIVE-DR-RT-A
372200                                    (X-MM05-SETT-INDEX)
372300         MOVE ZERO               TO MM05-ACTIVE-DR-RT-L
372400                                    (X-MM05-SETT-INDEX)
372500         GO TO Y259-EXIT.
372600*
372700     IF  MBCA-PTI-FUNCTION-IS-INQUIRY
372800         MOVE DFHBMASB           TO MM05-ACTIVE-DR-RT-A
372900                                    (X-MM05-SETT-INDEX)
373000         GO TO Y259-EXIT.
373100*
373200     IF  MMFS-MT-INQ-ONLY (X-MMFS-MERCH)
373300         MOVE ZERO               TO MM05-ACTIVE-DR-RT-L
373400                                    (X-MM05-SETT-INDEX)
373500         MOVE DFHBMASK           TO MM05-ACTIVE-DR-RT-A
373600                                    (X-MM05-SETT-INDEX)
373700         GO TO Y259-EXIT.
373800*
373900     IF  MBCA-PTI-FUNCTION-IS-ADD
374000         IF  MMFS-MT-REQUIRED (X-MMFS-MERCH)
374100             MOVE DFHBMASB       TO MM05-ACTIVE-DR-RT-LIT-A
374200                                    (X-MM05-SETT-INDEX)
374300         ELSE
374400             IF  MMFS-MT-MAINT-ONLY (X-MMFS-MERCH)
374500                 MOVE ZERO       TO MM05-ACTIVE-DR-RT-L
374600                                    (X-MM05-SETT-INDEX)
374700                 MOVE DFHBMASK   TO MM05-ACTIVE-DR-RT-A
374800                                    (X-MM05-SETT-INDEX).
374900*
375000     IF  MBCA-PTI-FUNCTION-IS-MAINT
375100         IF  MMFS-MT-NO-MAINT (X-MMFS-MERCH)
375200             MOVE ZERO           TO MM05-ACTIVE-DR-RT-L
375300                                    (X-MM05-SETT-INDEX)
375400             MOVE DFHBMASK       TO MM05-ACTIVE-DR-RT-A
375500                                    (X-MM05-SETT-INDEX).
375600*
375700 Y259-EXIT.
375800     EXIT.
375900*
376000 Y270-MOVE-PENDING-DR-ACCT-TYPE.
376100*
376200     MOVE MMMM-PENDING-DR-ACCT-TYPE (X-MMMM-SETT-ACH)
376300                                 TO MM05-PENDING-DR-ACCT-TYPE
376400                                    (X-MM05-SETT-INDEX).
376500*
376600 Y275-PND-DR-ACCT-TYPE-SECURITY.
376700*
376800     EVALUATE TRUE
376900       WHEN  X-MMMM-SETT-ACH IS EQUAL TO 1
377000         MOVE MMMMTB-PENDING-DR-TYPE-1 (1:4)
377100                                 TO WS-INDEX-X
377200         SET X-MMFS-MERCH        TO WS-INDEX
377300       WHEN  X-MMMM-SETT-ACH IS EQUAL TO 2
377400         MOVE MMMMTB-PENDING-DR-TYPE-2 (1:4)
377500                                 TO WS-INDEX-X
377600         SET X-MMFS-MERCH        TO WS-INDEX
377700       WHEN  X-MMMM-SETT-ACH IS EQUAL TO 3
377800         MOVE MMMMTB-PENDING-DR-TYPE-3 (1:4)
377900                                 TO WS-INDEX-X
378000         SET X-MMFS-MERCH        TO WS-INDEX
378100       WHEN  X-MMMM-SETT-ACH IS EQUAL TO 4
378200         MOVE MMMMTB-PENDING-DR-TYPE-4 (1:4)
378300                                 TO WS-INDEX-X
378400         SET X-MMFS-MERCH        TO WS-INDEX
378500     END-EVALUATE.
378600*
378700     IF  MMFS-MT-NO-ACCESS (X-MMFS-MERCH)
378800         MOVE DFHBMDAS           TO MM05-PENDING-DR-ACCT-TYPE-LP-A
378900                                    (X-MM05-SETT-INDEX)
379000                                    MM05-PENDING-DR-ACCT-TYPE-RP-A
379100                                    (X-MM05-SETT-INDEX)
379200                                    MM05-PENDING-DR-ACCT-TYPE-A
379300                                    (X-MM05-SETT-INDEX)
379400         MOVE ZERO               TO MM05-PENDING-DR-ACCT-TYPE-L
379500                                    (X-MM05-SETT-INDEX)
379600         GO TO Y279-EXIT.
379700*
379800     IF  MBCA-PTI-FUNCTION-IS-INQUIRY
379900         MOVE DFHBMDAS           TO MM05-PENDING-DR-ACCT-TYPE-LP-A
380000                                    (X-MM05-SETT-INDEX)
380100                                    MM05-PENDING-DR-ACCT-TYPE-RP-A
380200                                    (X-MM05-SETT-INDEX)
380300         MOVE DFHBMASB           TO MM05-PENDING-DR-ACCT-TYPE-A
380400                                    (X-MM05-SETT-INDEX)
380500         GO TO Y279-EXIT.
380600*
380700     IF  MMFS-MT-INQ-ONLY (X-MMFS-MERCH)
380800         MOVE ZERO               TO MM05-PENDING-DR-ACCT-TYPE-L
380900                                    (X-MM05-SETT-INDEX)
381000         MOVE DFHBMDAS           TO MM05-PENDING-DR-ACCT-TYPE-LP-A
381100                                    (X-MM05-SETT-INDEX)
381200                                    MM05-PENDING-DR-ACCT-TYPE-RP-A
381300                                    (X-MM05-SETT-INDEX)
381400         MOVE DFHBMASK           TO MM05-PENDING-DR-ACCT-TYPE-A
381500                                    (X-MM05-SETT-INDEX)
381600         GO TO Y279-EXIT.
381700*
381800     IF  MBCA-PTI-FUNCTION-IS-ADD
381900         IF  MMFS-MT-REQUIRED (X-MMFS-MERCH)
382000             IF  MMFS-MT-MAINT-ONLY (X-MMFS-MERCH)
382100                 MOVE ZERO       TO MM05-PENDING-DR-ACCT-TYPE-L
382200                                    (X-MM05-SETT-INDEX)
382300                 MOVE DFHBMDAS   TO MM05-PENDING-DR-ACCT-TYPE-LP-A
382400                                    (X-MM05-SETT-INDEX)
382500                                    MM05-PENDING-DR-ACCT-TYPE-RP-A
382600                                    (X-MM05-SETT-INDEX)
382700                 MOVE DFHBMASK   TO MM05-PENDING-DR-ACCT-TYPE-A
382800                                    (X-MM05-SETT-INDEX).
382900*
383000     IF  MBCA-PTI-FUNCTION-IS-MAINT
383100         IF  MMFS-MT-NO-MAINT (X-MMFS-MERCH)
383200             MOVE ZERO           TO MM05-PENDING-DR-ACCT-TYPE-L
383300                                    (X-MM05-SETT-INDEX)
383400             MOVE DFHBMDAS       TO MM05-PENDING-DR-ACCT-TYPE-LP-A
383500                                    (X-MM05-SETT-INDEX)
383600                                    MM05-PENDING-DR-ACCT-TYPE-RP-A
383700                                    (X-MM05-SETT-INDEX)
383800             MOVE DFHBMASK       TO MM05-PENDING-DR-ACCT-TYPE-A
383900                                    (X-MM05-SETT-INDEX).
384000*
384100 Y279-EXIT.
384200     EXIT.
384300*
384400 Y290-MOVE-PENDING-DR-RT.
384500*
384600     MOVE MMMM-PENDING-DR-RT (X-MMMM-SETT-ACH)
384700                                 TO MM05-PENDING-DR-RT
384800                                    (X-MM05-SETT-INDEX).
384900*
385000 Y295-PENDING-DR-RT-SECURITY.
385100*
385200     EVALUATE TRUE
385300       WHEN  X-MMMM-SETT-ACH IS EQUAL TO 1
385400         MOVE MMMMTB-PENDING-DR-RT-1 (1:4)
385500                                 TO WS-INDEX-X
385600         SET X-MMFS-MERCH        TO WS-INDEX
385700       WHEN  X-MMMM-SETT-ACH IS EQUAL TO 2
385800         MOVE MMMMTB-PENDING-DR-RT-2 (1:4)
385900                                 TO WS-INDEX-X
386000         SET X-MMFS-MERCH        TO WS-INDEX
386100       WHEN  X-MMMM-SETT-ACH IS EQUAL TO 3
386200         MOVE MMMMTB-PENDING-DR-RT-3 (1:4)
386300                                 TO WS-INDEX-X
386400         SET X-MMFS-MERCH        TO WS-INDEX
386500       WHEN  X-MMMM-SETT-ACH IS EQUAL TO 4
386600         MOVE MMMMTB-PENDING-DR-RT-4 (1:4)
386700                                 TO WS-INDEX-X
386800         SET X-MMFS-MERCH        TO WS-INDEX
386900     END-EVALUATE.
387000*
387100     IF  MMFS-MT-NO-ACCESS (X-MMFS-MERCH)
387200         MOVE DFHBMDAS           TO MM05-PENDING-DR-RT-LIT-A
387300                                    (X-MM05-SETT-INDEX)
387400                                    MM05-PENDING-DR-RT-LP-A
387500                                    (X-MM05-SETT-INDEX)
387600                                    MM05-PENDING-DR-RT-RP-A
387700                                    (X-MM05-SETT-INDEX)
387800                                    MM05-PENDING-DR-RT-A
387900                                    (X-MM05-SETT-INDEX)
388000         MOVE ZERO               TO MM05-PENDING-DR-RT-L
388100                                    (X-MM05-SETT-INDEX)
388200         GO TO Y299-EXIT.
388300*
388400     IF  MBCA-PTI-FUNCTION-IS-INQUIRY
388500         MOVE DFHBMDAS           TO MM05-PENDING-DR-RT-LP-A
388600                                    (X-MM05-SETT-INDEX)
388700                                    MM05-PENDING-DR-RT-RP-A
388800                                    (X-MM05-SETT-INDEX)
388900         MOVE DFHBMASB           TO MM05-PENDING-DR-RT-A
389000                                    (X-MM05-SETT-INDEX)
389100         GO TO Y299-EXIT.
389200*
389300     IF  MMFS-MT-INQ-ONLY (X-MMFS-MERCH)
389400         MOVE ZERO               TO MM05-PENDING-DR-RT-L
389500                                    (X-MM05-SETT-INDEX)
389600         MOVE DFHBMDAS           TO MM05-PENDING-DR-RT-LP-A
389700                                    (X-MM05-SETT-INDEX)
389800                                    MM05-PENDING-DR-RT-RP-A
389900                                    (X-MM05-SETT-INDEX)
390000         MOVE DFHBMASK           TO MM05-PENDING-DR-RT-A
390100                                    (X-MM05-SETT-INDEX)
390200         GO TO Y299-EXIT.
390300*
390400     IF  MBCA-PTI-FUNCTION-IS-ADD
390500         IF  MMFS-MT-REQUIRED (X-MMFS-MERCH)
390600             MOVE DFHBMASB       TO MM05-PENDING-DR-RT-LIT-A
390700                                    (X-MM05-SETT-INDEX)
390800         ELSE
390900             IF  MMFS-MT-MAINT-ONLY (X-MMFS-MERCH)
391000                 MOVE ZERO       TO MM05-PENDING-DR-RT-L
391100                                    (X-MM05-SETT-INDEX)
391200                 MOVE DFHBMDAS   TO MM05-PENDING-DR-RT-LP-A
391300                                    (X-MM05-SETT-INDEX)
391400                                    MM05-PENDING-DR-RT-RP-A
391500                                    (X-MM05-SETT-INDEX)
391600                 MOVE DFHBMASK   TO MM05-PENDING-DR-RT-A
391700                                    (X-MM05-SETT-INDEX).
391800*
391900     IF  MBCA-PTI-FUNCTION-IS-MAINT
392000         IF  MMFS-MT-NO-MAINT (X-MMFS-MERCH)
392100             MOVE ZERO           TO MM05-PENDING-DR-RT-L
392200                                    (X-MM05-SETT-INDEX)
392300             MOVE DFHBMDAS       TO MM05-PENDING-DR-RT-LP-A
392400                                    (X-MM05-SETT-INDEX)
392500                                    MM05-PENDING-DR-RT-RP-A
392600                                    (X-MM05-SETT-INDEX)
392700             MOVE DFHBMASK       TO MM05-PENDING-DR-RT-A
392800                                    (X-MM05-SETT-INDEX).
392900*
393000 Y299-EXIT.
393100     EXIT.
393200*
393300 Y310-MOVE-ACTIVE-DR-DDA.
393400*
393500     MOVE MMMM-ACTIVE-DR-ACCT (X-MMMM-SETT-ACH)
393600                                 TO MM05-ACTIVE-DR-DDA
393700                                    (X-MM05-SETT-INDEX).
393800*
393900 Y315-ACTIVE-DR-DDA-SECURITY.
394000*
394100     EVALUATE TRUE
394200       WHEN  X-MMMM-SETT-ACH IS EQUAL TO 1
394300         MOVE MMMMTB-ACTIVE-DR-ACCT-1 (1:4)
394400                                 TO WS-INDEX-X
394500         SET X-MMFS-MERCH        TO WS-INDEX
394600       WHEN  X-MMMM-SETT-ACH IS EQUAL TO 2
394700         MOVE MMMMTB-ACTIVE-DR-ACCT-2 (1:4)
394800                                 TO WS-INDEX-X
394900         SET X-MMFS-MERCH        TO WS-INDEX
395000       WHEN  X-MMMM-SETT-ACH IS EQUAL TO 3
395100         MOVE MMMMTB-ACTIVE-DR-ACCT-3 (1:4)
395200                                 TO WS-INDEX-X
395300         SET X-MMFS-MERCH        TO WS-INDEX
395400       WHEN  X-MMMM-SETT-ACH IS EQUAL TO 4
395500         MOVE MMMMTB-ACTIVE-DR-ACCT-4 (1:4)
395600                                 TO WS-INDEX-X
395700         SET X-MMFS-MERCH        TO WS-INDEX
395800     END-EVALUATE.
395900*
396000     IF  MMFS-MT-NO-ACCESS (X-MMFS-MERCH)
396100         MOVE DFHBMDAS           TO MM05-ACTIVE-DR-DDA-LIT-A
396200                                    (X-MM05-SETT-INDEX)
396300                                    MM05-ACTIVE-DR-DDA-A
396400                                    (X-MM05-SETT-INDEX)
396500         GO TO Y319-EXIT.
396600*
396700     IF  MBCA-PTI-FUNCTION-IS-INQUIRY
396800         MOVE DFHBMASB           TO MM05-ACTIVE-DR-DDA-A
396900                                    (X-MM05-SETT-INDEX)
397000         MOVE ZERO               TO MM05-ACTIVE-DR-DDA-L
397100                                    (X-MM05-SETT-INDEX)
397200         GO TO Y319-EXIT.
397300*
397400     IF  MMFS-MT-INQ-ONLY (X-MMFS-MERCH)
397500         MOVE DFHBMASK           TO MM05-ACTIVE-DR-DDA-A
397600                                    (X-MM05-SETT-INDEX)
397700         GO TO Y319-EXIT.
397800*
397900     IF  MBCA-PTI-FUNCTION-IS-ADD
398000         IF  MMFS-MT-REQUIRED (X-MMFS-MERCH)
398100             MOVE DFHBMASB       TO MM05-ACTIVE-DR-DDA-LIT-A
398200                                    (X-MM05-SETT-INDEX)
398300         ELSE
398400             IF  MMFS-MT-MAINT-ONLY (X-MMFS-MERCH)
398500                 MOVE ZERO       TO MM05-ACTIVE-DR-DDA-L
398600                                    (X-MM05-SETT-INDEX)
398700                 MOVE DFHBMASK   TO MM05-ACTIVE-DR-DDA-A
398800                                    (X-MM05-SETT-INDEX).
398900*
399000     IF  MBCA-PTI-FUNCTION-IS-MAINT
399100         IF  MMFS-MT-NO-MAINT (X-MMFS-MERCH)
399200             MOVE ZERO           TO MM05-ACTIVE-DR-DDA-L
399300                                    (X-MM05-SETT-INDEX)
399400             MOVE DFHBMASK       TO MM05-ACTIVE-DR-DDA-A
399500                                    (X-MM05-SETT-INDEX).
399600*
399700 Y319-EXIT.
399800     EXIT.
399900*
400000 Y330-MOVE-PENDING-DR-DDA.
400100*
400200     MOVE MMMM-PENDING-DR-ACCT (X-MMMM-SETT-ACH)
400300                                 TO MM05-PENDING-DR-DDA
400400                                    (X-MM05-SETT-INDEX).
400500*
400600 Y335-PENDING-DR-DDA-SECURITY.
400700*
400800     EVALUATE TRUE
400900       WHEN  X-MMMM-SETT-ACH IS EQUAL TO 1
401000         MOVE MMMMTB-PENDING-DR-ACCT-1 (1:4)
401100                                 TO WS-INDEX-X
401200         SET X-MMFS-MERCH        TO WS-INDEX
401300       WHEN  X-MMMM-SETT-ACH IS EQUAL TO 2
401400         MOVE MMMMTB-PENDING-DR-ACCT-2 (1:4)
401500                                 TO WS-INDEX-X
401600         SET X-MMFS-MERCH        TO WS-INDEX
401700       WHEN  X-MMMM-SETT-ACH IS EQUAL TO 3
401800         MOVE MMMMTB-PENDING-DR-ACCT-3 (1:4)
401900                                 TO WS-INDEX-X
402000         SET X-MMFS-MERCH        TO WS-INDEX
402100       WHEN  X-MMMM-SETT-ACH IS EQUAL TO 4
402200         MOVE MMMMTB-PENDING-DR-ACCT-4 (1:4)
402300                                 TO WS-INDEX-X
402400         SET X-MMFS-MERCH        TO WS-INDEX
402500     END-EVALUATE.
402600*
402700     IF  MMFS-MT-NO-ACCESS (X-MMFS-MERCH)
402800         MOVE DFHBMDAS           TO MM05-PENDING-DR-DDA-LIT-A
402900                                    (X-MM05-SETT-INDEX)
403000                                    MM05-PENDING-DR-DDA-LP-A
403100                                    (X-MM05-SETT-INDEX)
403200                                    MM05-PENDING-DR-DDA-RP-A
403300                                    (X-MM05-SETT-INDEX)
403400                                    MM05-PENDING-DR-DDA-A
403500                                    (X-MM05-SETT-INDEX)
403600         MOVE ZERO               TO MM05-PENDING-DR-DDA-L
403700                                    (X-MM05-SETT-INDEX)
403800         GO TO Y339-EXIT.
403900*
404000     IF  MBCA-PTI-FUNCTION-IS-INQUIRY
404100         MOVE DFHBMDAS           TO MM05-PENDING-DR-DDA-LP-A
404200                                    (X-MM05-SETT-INDEX)
404300                                    MM05-PENDING-DR-DDA-RP-A
404400                                    (X-MM05-SETT-INDEX)
404500         MOVE DFHBMASB           TO MM05-PENDING-DR-DDA-A
404600                                    (X-MM05-SETT-INDEX)
404700         GO TO Y339-EXIT.
404800*
404900     IF  MMFS-MT-INQ-ONLY (X-MMFS-MERCH)
405000         MOVE ZERO               TO MM05-PENDING-DR-DDA-L
405100                                    (X-MM05-SETT-INDEX)
405200         MOVE DFHBMDAS           TO MM05-PENDING-DR-DDA-LP-A
405300                                    (X-MM05-SETT-INDEX)
405400                                    MM05-PENDING-DR-DDA-RP-A
405500                                    (X-MM05-SETT-INDEX)
405600         MOVE DFHBMASK           TO MM05-PENDING-DR-DDA-A
405700                                    (X-MM05-SETT-INDEX)
405800         GO TO Y339-EXIT.
405900*
406000     IF  MBCA-PTI-FUNCTION-IS-ADD
406100         IF  MMFS-MT-REQUIRED (X-MMFS-MERCH)
406200             MOVE DFHBMASB       TO MM05-PENDING-DR-DDA-LIT-A
406300                                    (X-MM05-SETT-INDEX)
406400         ELSE
406500             IF  MMFS-MT-MAINT-ONLY (X-MMFS-MERCH)
406600                 MOVE ZERO       TO MM05-PENDING-DR-DDA-L
406700                                    (X-MM05-SETT-INDEX)
406800                 MOVE DFHBMDAS   TO MM05-PENDING-DR-DDA-LP-A
406900                                    (X-MM05-SETT-INDEX)
407000                                    MM05-PENDING-DR-DDA-RP-A
407100                                    (X-MM05-SETT-INDEX)
407200                 MOVE DFHBMASK   TO MM05-PENDING-DR-DDA-A
407300                                    (X-MM05-SETT-INDEX).
407400*
407500     IF  MBCA-PTI-FUNCTION-IS-MAINT
407600         IF  MMFS-MT-NO-MAINT (X-MMFS-MERCH)
407700             MOVE ZERO           TO MM05-PENDING-DR-DDA-L
407800                                    (X-MM05-SETT-INDEX)
407900             MOVE DFHBMDAS       TO MM05-PENDING-DR-DDA-LP-A
408000                                    (X-MM05-SETT-INDEX)
408100                                    MM05-PENDING-DR-DDA-RP-A
408200                                    (X-MM05-SETT-INDEX)
408300             MOVE DFHBMASK       TO MM05-PENDING-DR-DDA-A
408400                                    (X-MM05-SETT-INDEX).
408500*
408600 Y339-EXIT.
408700     EXIT.
408800*
408900 Y800-SET-CURSOR.
409000*
409100     SET X-MM05-SETT-INDEX       TO 1.
409200*
409300     IF  MBCA-SCREEN-NBR IS EQUAL TO 55
409400         MOVE MMMMTB-PRENOTE-CTL-1 (1:4)
409500                                 TO WS-INDEX-X
409600         SET X-MMFS-MERCH        TO WS-INDEX
409700     ELSE
409800         MOVE MMMMTB-PRENOTE-CTL-3 (1:4)
409900                                 TO WS-INDEX-X
410000         SET X-MMFS-MERCH        TO WS-INDEX.
410100*
410200 Y803-PRENOTE-CTL.
410300*
410400     IF  MBCA-PTI-FUNCTION-IS-ADD
410500         IF  MMFS-MT-OPTIONAL (X-MMFS-MERCH)
410600         OR  MMFS-MT-REQUIRED (X-MMFS-MERCH)
410700             MOVE SS08WS-CURSOR  TO MM05-PRENOTE-CONTROL-L
410800                                    (X-MM05-SETT-INDEX)
410900             GO TO Y809-SC-EXIT.
411000*
411100     IF  MBCA-PTI-FUNCTION-IS-MAINT
411200         IF  MMFS-MT-MAINT-ALLOWED (X-MMFS-MERCH)
411300             MOVE SS08WS-CURSOR  TO MM05-PRENOTE-CONTROL-L
411400                                    (X-MM05-SETT-INDEX)
411500             GO TO Y809-SC-EXIT.
411600*
411700 Y803-MIGRATING-METHOD.
411800*
411900     SET X-MMFS-MERCH            UP BY 2.
412000*
412100     IF  MBCA-PTI-FUNCTION-IS-ADD
412200         IF  MMFS-MT-OPTIONAL (X-MMFS-MERCH)
412300         OR  MMFS-MT-REQUIRED (X-MMFS-MERCH)
412400             MOVE SS08WS-CURSOR  TO MM05-MSA-METHOD-L
412500                                    (X-MM05-SETT-INDEX)
412600             GO TO Y809-SC-EXIT.
412700*
412800     IF  MBCA-PTI-FUNCTION-IS-MAINT
412900         IF  MMFS-MT-MAINT-ALLOWED (X-MMFS-MERCH)
413000             MOVE SS08WS-CURSOR  TO MM05-MSA-METHOD-L
413100                                    (X-MM05-SETT-INDEX)
413200             GO TO Y809-SC-EXIT.
413300*
413400 Y803-PENDING-TO-ACTIVE.
413500*
413600     SET X-MMFS-MERCH            UP BY 1.
413700*
413800     IF  MBCA-PTI-FUNCTION-IS-ADD
413900         IF  MMFS-MT-OPTIONAL (X-MMFS-MERCH)
414000         OR  MMFS-MT-REQUIRED (X-MMFS-MERCH)
414100             MOVE SS08WS-CURSOR  TO MM05-PENDING-DATE-L
414200                                    (X-MM05-SETT-INDEX)
414300             GO TO Y809-SC-EXIT.
414400*
414500     IF  MBCA-PTI-FUNCTION-IS-MAINT
414600         IF  MMFS-MT-MAINT-ALLOWED (X-MMFS-MERCH)
414700             MOVE SS08WS-CURSOR  TO MM05-PENDING-DATE-L
414800                                    (X-MM05-SETT-INDEX)
414900             GO TO Y809-SC-EXIT.
415000*
415100 Y803-INTERIM-METHOD-1.
415200*
415300     SET X-MMFS-MERCH            DOWN BY 1.
415400*
415500     IF  MBCA-PTI-FUNCTION-IS-ADD
415600         IF  MMFS-MT-OPTIONAL (X-MMFS-MERCH)
415700         OR  MMFS-MT-REQUIRED (X-MMFS-MERCH)
415800             MOVE SS08WS-CURSOR  TO MM05-ISA-METHOD-L
415900                                    (X-MM05-SETT-INDEX)
416000             GO TO Y809-SC-EXIT.
416100*
416200     IF  MBCA-PTI-FUNCTION-IS-MAINT
416300         IF  MMFS-MT-MAINT-ALLOWED (X-MMFS-MERCH)
416400             MOVE SS08WS-CURSOR  TO MM05-ISA-METHOD-L
416500                                    (X-MM05-SETT-INDEX)
416600             GO TO Y809-SC-EXIT.
416700*
416800 Y803-ACTIVE-CR-ACCT-TYPE.
416900*
417000     SET X-MMFS-MERCH            UP BY 2.
417100*
417200     IF  MBCA-PTI-FUNCTION-IS-ADD
417300         IF  MMFS-MT-OPTIONAL (X-MMFS-MERCH)
417400         OR  MMFS-MT-REQUIRED (X-MMFS-MERCH)
417500             MOVE SS08WS-CURSOR  TO MM05-ACTIVE-CR-ACCT-TYPE-L
417600                                    (X-MM05-SETT-INDEX)
417700             GO TO Y809-SC-EXIT.
417800*
417900     IF  MBCA-PTI-FUNCTION-IS-MAINT
418000         IF  MMFS-MT-MAINT-ALLOWED (X-MMFS-MERCH)
418100             MOVE SS08WS-CURSOR  TO MM05-ACTIVE-CR-ACCT-TYPE-L
418200                                    (X-MM05-SETT-INDEX)
418300             GO TO Y809-SC-EXIT.
418400*
418500 Y803-ACTIVE-CR-RT.
418600*
418700     SET X-MMFS-MERCH            UP BY 1.
418800*
418900     IF  MBCA-PTI-FUNCTION-IS-ADD
419000         IF  MMFS-MT-OPTIONAL (X-MMFS-MERCH)
419100         OR  MMFS-MT-REQUIRED (X-MMFS-MERCH)
419200             MOVE SS08WS-CURSOR  TO MM05-ACTIVE-CR-RT-L
419300                                    (X-MM05-SETT-INDEX)
419400             GO TO Y809-SC-EXIT.
419500*
419600     IF  MBCA-PTI-FUNCTION-IS-MAINT
419700         IF  MMFS-MT-MAINT-ALLOWED (X-MMFS-MERCH)
419800             MOVE SS08WS-CURSOR  TO MM05-ACTIVE-CR-RT-L
419900                                    (X-MM05-SETT-INDEX)
420000             GO TO Y809-SC-EXIT.
420100*
420200 Y803-PENDING-CR-ACCT-TYPE.
420300*
420400     SET X-MMFS-MERCH            UP BY 1.
420500*
420600     IF  MBCA-PTI-FUNCTION-IS-ADD
420700         IF  MMFS-MT-OPTIONAL (X-MMFS-MERCH)
420800         OR  MMFS-MT-REQUIRED (X-MMFS-MERCH)
420900             MOVE SS08WS-CURSOR  TO MM05-PENDING-CR-ACCT-TYPE-L
421000                                    (X-MM05-SETT-INDEX)
421100             GO TO Y809-SC-EXIT.
421200*
421300     IF  MBCA-PTI-FUNCTION-IS-MAINT
421400         IF  MMFS-MT-MAINT-ALLOWED (X-MMFS-MERCH)
421500             MOVE SS08WS-CURSOR  TO MM05-PENDING-CR-ACCT-TYPE-L
421600                                    (X-MM05-SETT-INDEX)
421700             GO TO Y809-SC-EXIT.
421800*
421900 Y803-PENDING-CR-RT.
422000*
422100     SET X-MMFS-MERCH            UP BY 1.
422200*
422300     IF  MBCA-PTI-FUNCTION-IS-ADD
422400         IF  MMFS-MT-OPTIONAL (X-MMFS-MERCH)
422500         OR  MMFS-MT-REQUIRED (X-MMFS-MERCH)
422600             MOVE SS08WS-CURSOR  TO MM05-PENDING-CR-RT-L
422700                                    (X-MM05-SETT-INDEX)
422800             GO TO Y809-SC-EXIT.
422900*
423000     IF  MBCA-PTI-FUNCTION-IS-MAINT
423100         IF  MMFS-MT-MAINT-ALLOWED (X-MMFS-MERCH)
423200             MOVE SS08WS-CURSOR  TO MM05-PENDING-CR-RT-L
423300                                    (X-MM05-SETT-INDEX)
423400             GO TO Y809-SC-EXIT.
423500*
423600 Y803-ACTIVE-CR-DDA.
423700*
423800     SET X-MMFS-MERCH            UP BY 1.
423900*
424000     IF  MBCA-PTI-FUNCTION-IS-ADD
424100         IF  MMFS-MT-OPTIONAL (X-MMFS-MERCH)
424200         OR  MMFS-MT-REQUIRED (X-MMFS-MERCH)
424300             MOVE SS08WS-CURSOR  TO MM05-ACTIVE-CR-DDA-L
424400                                    (X-MM05-SETT-INDEX)
424500             GO TO Y809-SC-EXIT.
424600*
424700     IF  MBCA-PTI-FUNCTION-IS-MAINT
424800         IF  MMFS-MT-MAINT-ALLOWED (X-MMFS-MERCH)
424900             MOVE SS08WS-CURSOR  TO MM05-ACTIVE-CR-DDA-L
425000                                    (X-MM05-SETT-INDEX)
425100             GO TO Y809-SC-EXIT.
425200*
425300 Y803-PENDING-CR-DDA.
425400*
425500     SET X-MMFS-MERCH            UP BY 1.
425600*
425700     IF  MBCA-PTI-FUNCTION-IS-ADD
425800         IF  MMFS-MT-OPTIONAL (X-MMFS-MERCH)
425900         OR  MMFS-MT-REQUIRED (X-MMFS-MERCH)
426000             MOVE SS08WS-CURSOR  TO MM05-PENDING-CR-DDA-L
426100                                    (X-MM05-SETT-INDEX)
426200             GO TO Y809-SC-EXIT.
426300*
426400     IF  MBCA-PTI-FUNCTION-IS-MAINT
426500         IF  MMFS-MT-MAINT-ALLOWED (X-MMFS-MERCH)
426600             MOVE SS08WS-CURSOR  TO MM05-PENDING-CR-DDA-L
426700                                    (X-MM05-SETT-INDEX)
426800             GO TO Y809-SC-EXIT.
426900*
427000 Y803-ACTIVE-DR-ACCT-TYPE.
427100*
427200     SET X-MMFS-MERCH            UP BY 1.
427300*
427400     IF  MBCA-PTI-FUNCTION-IS-ADD
427500         IF  MMFS-MT-OPTIONAL (X-MMFS-MERCH)
427600         OR  MMFS-MT-REQUIRED (X-MMFS-MERCH)
427700             MOVE SS08WS-CURSOR  TO MM05-ACTIVE-DR-ACCT-TYPE-L
427800                                    (X-MM05-SETT-INDEX)
427900             GO TO Y809-SC-EXIT.
428000*
428100     IF  MBCA-PTI-FUNCTION-IS-MAINT
428200         IF  MMFS-MT-MAINT-ALLOWED (X-MMFS-MERCH)
428300             MOVE SS08WS-CURSOR  TO MM05-ACTIVE-DR-ACCT-TYPE-L
428400                                    (X-MM05-SETT-INDEX)
428500             GO TO Y809-SC-EXIT.
428600*
428700 Y803-ACTIVE-DR-RT.
428800*
428900     SET X-MMFS-MERCH            UP BY 1.
429000*
429100     IF  MBCA-PTI-FUNCTION-IS-ADD
429200         IF  MMFS-MT-OPTIONAL (X-MMFS-MERCH)
429300         OR  MMFS-MT-REQUIRED (X-MMFS-MERCH)
429400             MOVE SS08WS-CURSOR  TO MM05-ACTIVE-DR-RT-L
429500                                    (X-MM05-SETT-INDEX)
429600             GO TO Y809-SC-EXIT.
429700*
429800     IF  MBCA-PTI-FUNCTION-IS-MAINT
429900         IF  MMFS-MT-MAINT-ALLOWED (X-MMFS-MERCH)
430000             MOVE SS08WS-CURSOR  TO MM05-ACTIVE-DR-RT-L
430100                                    (X-MM05-SETT-INDEX)
430200             GO TO Y809-SC-EXIT.
430300*
430400 Y803-PENDING-DR-ACCT-TYPE.
430500*
430600     SET X-MMFS-MERCH            UP BY 1.
430700*
430800     IF  MBCA-PTI-FUNCTION-IS-ADD
430900         IF  MMFS-MT-OPTIONAL (X-MMFS-MERCH)
431000         OR  MMFS-MT-REQUIRED (X-MMFS-MERCH)
431100             MOVE SS08WS-CURSOR  TO MM05-PENDING-DR-ACCT-TYPE-L
431200                                    (X-MM05-SETT-INDEX)
431300             GO TO Y809-SC-EXIT.
431400*
431500     IF  MBCA-PTI-FUNCTION-IS-MAINT
431600         IF  MMFS-MT-MAINT-ALLOWED (X-MMFS-MERCH)
431700             MOVE SS08WS-CURSOR  TO MM05-PENDING-DR-ACCT-TYPE-L
431800                                    (X-MM05-SETT-INDEX)
431900             GO TO Y809-SC-EXIT.
432000*
432100 Y803-PENDING-DR-RT.
432200*
432300     SET X-MMFS-MERCH            UP BY 1.
432400*
432500     IF  MBCA-PTI-FUNCTION-IS-ADD
432600         IF  MMFS-MT-OPTIONAL (X-MMFS-MERCH)
432700         OR  MMFS-MT-REQUIRED (X-MMFS-MERCH)
432800             MOVE SS08WS-CURSOR  TO MM05-PENDING-DR-RT-L
432900                                    (X-MM05-SETT-INDEX)
433000             GO TO Y809-SC-EXIT.
433100*
433200     IF  MBCA-PTI-FUNCTION-IS-MAINT
433300         IF  MMFS-MT-MAINT-ALLOWED (X-MMFS-MERCH)
433400             MOVE SS08WS-CURSOR  TO MM05-PENDING-DR-RT-L
433500                                    (X-MM05-SETT-INDEX)
433600             GO TO Y809-SC-EXIT.
433700*
433800 Y803-ACTIVE-DR-DDA.
433900*
434000     SET X-MMFS-MERCH            UP BY 1.
434100*
434200     IF  MBCA-PTI-FUNCTION-IS-ADD
434300         IF  MMFS-MT-OPTIONAL (X-MMFS-MERCH)
434400         OR  MMFS-MT-REQUIRED (X-MMFS-MERCH)
434500             MOVE SS08WS-CURSOR  TO MM05-ACTIVE-DR-DDA-L
434600                                    (X-MM05-SETT-INDEX)
434700             GO TO Y809-SC-EXIT.
434800*
434900     IF  MBCA-PTI-FUNCTION-IS-MAINT
435000         IF  MMFS-MT-MAINT-ALLOWED (X-MMFS-MERCH)
435100             MOVE SS08WS-CURSOR  TO MM05-ACTIVE-DR-DDA-L
435200                                    (X-MM05-SETT-INDEX)
435300             GO TO Y809-SC-EXIT.
435400*
435500 Y803-PENDING-DR-DDA.
435600*
435700     SET X-MMFS-MERCH            UP BY 1.
435800*
435900     IF  MBCA-PTI-FUNCTION-IS-ADD
436000         IF  MMFS-MT-OPTIONAL (X-MMFS-MERCH)
436100         OR  MMFS-MT-REQUIRED (X-MMFS-MERCH)
436200             MOVE SS08WS-CURSOR  TO MM05-PENDING-DR-DDA-L
436300                                    (X-MM05-SETT-INDEX)
436400             GO TO Y809-SC-EXIT.
436500*
436600     IF  MBCA-PTI-FUNCTION-IS-MAINT
436700         IF  MMFS-MT-MAINT-ALLOWED (X-MMFS-MERCH)
436800             MOVE SS08WS-CURSOR  TO MM05-PENDING-DR-DDA-L
436900                                    (X-MM05-SETT-INDEX)
437000             GO TO Y809-SC-EXIT.
437100*
437200 Y803-CURSOR-DEFAULT.
437300*
437400     IF  MBCA-SCREEN-NBR IS EQUAL TO 55
437500         IF  X-MM05-SETT-INDEX IS EQUAL TO 1
437600             SET X-MM05-SETT-INDEX
437700                                 UP BY 1
437800             MOVE MMMMTB-PRENOTE-CTL-2 (1:4)
437900                                 TO WS-INDEX-X
438000             SET X-MMFS-MERCH    TO WS-INDEX
438100             GO TO Y803-PRENOTE-CTL
438200         ELSE
438300             MOVE SS08WS-CURSOR  TO MM05-ALT-TRANID-L
438400     ELSE
438500         IF  X-MM05-SETT-INDEX IS EQUAL TO 1
438600             SET X-MM05-SETT-INDEX
438700                                 UP BY 1
438800             MOVE MMMMTB-PRENOTE-CTL-4 (1:4)
438900                                 TO WS-INDEX-X
439000             SET X-MMFS-MERCH    TO WS-INDEX
439100             GO TO Y803-PRENOTE-CTL
439200         ELSE
439300             MOVE SS08WS-CURSOR  TO MM05-ALT-TRANID-L.
439400*
439500 Y809-SC-EXIT.
439600     EXIT.
439700*
439800*
439900 Y900-READ-MMFS.
440000*
440100****************************************
440200*    READ THE FIELD SECURITY RECORD    *
440300*    TO OBTAIN THE SECURITY CODES      *
440400****************************************
440500*
440600     MOVE MBCA-MERCHANT-ORG      TO MBIOWS-MMFS-ORG.
440700     MOVE MBCA-FIELD-SECURITY    TO MBIOWS-MMFS-FS-CODE.
440800     SET MBIORO-READ-RANDOM      TO TRUE.
440900     PERFORM MMFSAO-ACCESS       THRU MMFSAO-ACCESS-EXIT.
441000*
441100     IF  NOT MMFS-REC-ACTIVE
441200         MOVE MBIORO-IO-REQUEST  TO MBCA-ERRR-IO-REQUEST
441300         MOVE MBIORO-FILE-NAME   TO MBCA-ERRR-EIBDS
441400         MOVE EIBFN              TO MBCA-ERRR-EIBFN-CODES
441500         MOVE MBCA-PROGRAM-ID    TO MBCA-ERRR-BAD-PROGRAM
441600         MOVE MBCA-TRANS-ID      TO MBCA-ERRR-BAD-TRANSID
441700         SET MBCA-ERROR-MSGS-PROVIDED
441800                                 TO TRUE
441900         MOVE 'READ ERROR - MMFSAO'
442000                                 TO MBCA-ERRR-MSG1
442100         MOVE 'FIELDS SECURITY PROFILE IS NOT ACTIVE'
442200                                 TO MBCA-ERRR-MSG2
442300         GO TO MB70PD-ERROR-ROUTINE.
442400*
442500 Y909-READ-MMFS-EXIT.
442600     EXIT.
442700*
442800 Y910-WRITE-LOG-RECORD.
442900*
443000     SET MBIORO-WRITE            TO TRUE.
443100     PERFORM MML1AO-ACCESS       THRU MML1AO-ACCESS-EXIT.
443200     MOVE SPACES                 TO MML1-VARIABLE-AREA.
443300*
443400 Y919-WLR-EXIT.
443500     EXIT.
443600/
443700 Z000-COPIED-ROUTINES SECTION.
443800*
443900*****************************
444000*    FUTURE DATE ROUTINE    *
444100*****************************
444200*
444300     COPY SS03PD.
444400/
444500*********************************
444600*    DATE VALIDATION ROUTINE    *
444700*********************************
444800*
444900     COPY SS05PD.
445000/
445100**********************************
445200*    GREG TO JUL DATE ROUTINE    *
445300**********************************
445400*
445500     COPY SS07PD.
445600/
445700**********************************
445800*    JUL TO GREG DATE ROUTINE    *
445900**********************************
446000*
446100     COPY SS08PD.
446200/
446300**********************************
446400*    DATE AND TIME EDIT ROUTINES *
446500**********************************
446600*
446700     COPY SS26PD.
446800     COPY SS27PD.
446900/
447000*****************************
447100*    CHECK DIGIT ROUTINE    *
447200*****************************
447300*
447400     COPY SS09PD.
447500/
447600*********************************
447700*    LINE 24 PF KEYS ROUTINE    *
447800*********************************
447900*
448000     COPY SS15PD.
448100/
448200************************************************
448300*    MERCHANT MASTER RECORD ACCESS ROUTINES    *
448400************************************************
448500*
448600     COPY MMMMAO.
448700/
448800***********************************************
448900*    FIELD SECURITY RECORD ACCESS ROUTINES    *
449000***********************************************
449100*
449200     COPY MMFSAO.
449300/
449400***************************************
449500*    SYSTEM RECORD ACCESS ROUTINES    *
449600***************************************
449700*
449800     COPY MMSCAO.
449900/
450000*********************************************
450100*    ORGANIZATION RECORD ACCESS ROUTINES    *
450200*********************************************
450300*
450400     COPY MMOCAO.
450500/
450600*****************************************
450700*    LOG FILE RECORD ACCESS ROUTINES    *
450800*****************************************
450900*
451000     COPY MML1AO.
451100/
451200*****************************
451300*    ONLINE MAP ROUTINES    *
451400*****************************
451500*
451600     COPY MB60PD REPLACING 'MBMAPXX' BY 'MBMM05 '
451700                           MBMAPXXI BY MBMM05I
451800                           MBMAPXXO BY MBMM05O.
451900/
452000***************************
452100*    ONLINE PROCEDURES    *
452200***************************
452300*
452400     COPY MB70PD.
452500/
452600     COPY SMFTPXO.
