000100 IDENTIFICATION DIVISION.
000200 PROGRAM-ID. MBOMM14.
000201*       RELEASE DATE=08/24/01.        REVISION LEVEL=08.06      * ++++++++
000202***************************************************************** ++++++++
000203*WARNING.  THIS COMPUTER PROGRAM IS PROTECTED BY COPYRIGHT LAW  * ++++++++
000204*AND INTERNATIONAL TREATIES.  UNAUTHORIZED REPRODUCTION OR      * ++++++++
000205*DISTRIBUTION OF THIS PROGRAM, OR ANY PORTION OF IT, MAY RESULT * ++++++++
000206*IN SEVERE CIVIL AND CRIMINAL PENATLIES, AND WILL BE PROSECUTED * ++++++++
000207*TO THE MAXIMUM EXTENT POSSIBLE UNDER THE LAW.                  * ++++++++
000208*COPYRIGHT 1999 PAYSYS INTERNATIONAL, INC.  ALL RIGHTS RESERVED.* ++++++++
000209***************************************************************** ++++++++
000300*****************************************************************
000400*                                                               *
000500*   V - PLUS  M E R C H A N T   B A N K C A R D   S Y S T E M   *
000600*                                                               *
000700*      MBOMM14 - MERCHANT MASTER RECORD ADD/MAINT/INQ           *
000800*                SCREEN 14                                      *
000900*                                                               *
001000*              1. TRANSIDS                                      *
001100*                 A. MBAM                                       *
001200*                 B. MBMM                                       *
001300*                 C. MBQM                                       *
001400*              2. MAPS USED -                                   *
001500*                 A. MBMM14 (SCREEN 14)                         *
001600*              3. FILES USED -                                  *
001700*                 A. MMMM (MERCHANT MASTER FILE)                *
001800*                 B. MMFS (FIELD SECURITY FILE)                 *
001900*                 C. MMMP (MERCHANT PROD ASSIGNMENS FILE)       *
002000*                 D. MMSM (STORE MASTER FILE)                   *
002100*                 E. MMOC (ORGANIZATION FILE)                   *
002200*                 F. MMXR (STORE MERCH XREF FILE)               *
002300*                 G. MML1 (LOG FILE)                            *
002400*                                                               *
002500*****************************************************************
002600*
002700 ENVIRONMENT DIVISION.
002800*
002900 DATA DIVISION.
003000*
003100 WORKING-STORAGE SECTION.
003200*
003300 01  FILLER                  PIC  X(12)      VALUE '** WS-BEG **'.
003400*
003500 01  FILLER                  PIC  X(14)      VALUE
003600     'MISCELLANEOUS:'.
003700*
003800 01  WS-MISCELLANEOUS.
003900     03  WS-FIELD-POSITION   PIC S9(03)      VALUE ZEROES COMP-3.
004000     03  WS-INDEX-X.
004100         05  WS-INDEX        PIC  9(04)      VALUE ZEROS.
004200     03  WS-POS-MODE.
004300         05  WS-POS-MODE-1   PIC  X(01)      VALUE SPACES.
004400         05  WS-POS-MODE-2   PIC  X(01)      VALUE SPACES.
004500*
004600 01  FILLER                  PIC  X(17)      VALUE
004700     'PROGRAM SWITCHES:'.
004800*
004900 01  WS-PROGRAM-SWITCHES.
005000     03  WS-UPDATE-MMMP-SW   PIC  X(01)      VALUE 'N'.
005100         88  WS-UPDATE-MMMP-SW-YES           VALUE 'Y'.
005200         88  WS-UPDATE-MMMP-SW-NO            VALUE 'N'.
005300     03  WS-UPDATE-MMSM-SW   PIC  X(01)      VALUE 'N'.
005400         88  WS-UPDATE-MMSM-SW-YES           VALUE 'Y'.
005500         88  WS-UPDATE-MMSM-SW-NO            VALUE 'N'.
005600     03  WS-UPDATE-VI-SW     PIC  X(01)      VALUE 'N'.
005700         88  WS-UPDATE-VI-SW-YES             VALUE 'Y'.
005800         88  WS-UPDATE-VI-SW-NO              VALUE 'N'.
005900     03  TS-QUEUE-NAME.
006000         05  TS-QN-TERMID    PIC  X(04)      VALUE SPACES.
006100         05  TS-QN-TRANID    PIC  X(04)      VALUE 'MBUI'.
006200/
006300 01  FILLER                  PIC  X(29)      VALUE
006400     'I/O REQUEST BLOCK WORK AREAS:'.
006500*
006600     COPY MBIOWS.
006700/
006800 01  FILLER                  PIC  X(18)      VALUE
006900     'I/O REQUEST BLOCK:'.
007000*
007100     COPY MBIORO.
007200/
007300 01  FILLER                  PIC  X(25)      VALUE
007400     'LOG RECORD REQUEST BLOCK:'.
007500*
007600     COPY MML1WS REPLACING ==:MML1:== BY ==MML1==.
007700/
007800 01  FILLER                  PIC  X(25)      VALUE
007900     'RATE TABLE VALID METHODS:'.
008000*
008100     COPY MMRTWS.
008200/
008300 01  FILLER                  PIC  X(29)      VALUE
008400     'MERCHANT MASTER FIELDS TABLE:'.
008500*
008600     COPY MMMMTB.
008700/
008800 01  FILLER                  PIC  X(26)      VALUE
008900     'STORE MASTER FIELDS TABLE:'.
009000*
009100     COPY MMSMTB.
009200/
009300 01  FILLER                  PIC  X(35)      VALUE
009400     'MERCHANT MASTER INITIALIZER RECORD:'.
009500*
009600     COPY MMMMIR.
009700/
009800 01  FILLER                  PIC  X(36)      VALUE
009900     'MERCHANT PRODUCT INITIALIZER RECORD:'.
010000*
010100     COPY MMMPIR.
010200/
010300 01  FILLER                  PIC  X(20)      VALUE
010400     'CCS DATE WORK AREAS:'.
010500*
010600     COPY SS01WS.
010700/
010800 01  FILLER                  PIC  X(15)      VALUE
010900     'CCS WORK AREAS:'.
011000*
011100     COPY SS08WS.
011200/
011300     COPY SS00WS.
011400/
011500     COPY SMFTWS.
011600/
011700     COPY SMPTRL REPLACING ==:SMPT:== BY ==SMPT==.
011800/
011810     COPY SC00WS.
011812/
011820     COPY SMCAWS.
011822/
011830     COPY SMCARL.
011832/
011900     COPY MB61LK.
012000/
012100 01  FILLER                  PIC  X(12)      VALUE '** WS-END **'.
012200/
012300 LINKAGE SECTION.
012400*
012500 01  DFHCOMMAREA.
012600*
012700     COPY MB60WS.
012800/
012900*****************************
013000*    MERCHANT MASTER MAP    *
013100*****************************
013200*
013300     COPY MBMM14.
013400/
013500******************************************
013600*    MERCHANT MASTER MAP REDEFINITION    *
013700******************************************
013800*
013900     COPY MBMM14R.
014000/
014100************************************
014200*    ORGANIZATION RECORD LAYOUT    *
014300************************************
014400*
014500     COPY MMOCRL.
014600/
014700***************************************
014800*    MERCHANT MASTER RECORD LAYOUT    *
014900***************************************
015000*
015100     COPY MMMMRL.
015200/
015300************************************************
015400*    MERCHANT PROD ASSIGNMENT RECORD LAYOUT    *
015500************************************************
015600*
015700     COPY MMMPRL.
015800/
015900************************************************
016000*    STORE MERCH XREF RECORD LAYOUT            *
016100************************************************
016200*
016300     COPY MMXRRL.
016400/
016500************************************************
016600*    STORE MASTER RECORD LAYOUT                *
016700************************************************
016800*
016900     COPY MMSMRL.
017000/
017100**************************************
017200*    RATE TABLE RECORD LAYOUT        *
017300**************************************
017400*
017500     COPY MMRTRL.
017600/
017700**************************************
017800*    FIELD SECURITY RECORD LAYOUT    *
017900**************************************
018000*
018100     COPY MMFSRL.
018200/
018300***************************
018400*    LOG RECORD LAYOUT    *
018500***************************
018600*
018700     COPY MML1RL REPLACING ==:MML1:== BY ==MML1==.
018800/
018900***************************************
019000*    USER INPUT TEMP STORAGE RECORD   *
019100***************************************
019200*
019300     COPY MBUITS.
019400/
019500 PROCEDURE DIVISION.
019600*
019700 A000-HOUSEKEEPING SECTION.
019800*
019900 A020-INIT.
020000*
020100     MOVE 'PC01'                 TO MBCA-PROGRAM-LOCATION.
020200     PERFORM MB70PD-ON-LINE-HOUSEKEEPING
020300                                 THRU MB70PD-OLH-EXIT.
020400*
020500     IF  MBCA-MBUI-UI-YES
020600         NEXT SENTENCE
020700     ELSE
020800         SET MBCA-MBUI-UI-NO     TO TRUE.
020900*
021000     MOVE MBCA-TERMINAL-ID       TO TS-QN-TERMID.
021100*
021200     IF  MBCA-RECEIVE-SCREEN
021300         GO TO C000-RECEIVE-SCREEN.
021400/
021500 B000-SEND-SCREEN SECTION.
021600*
021700*********************************************
021800*    GET CICS STORAGE NEEDED FOR THE MAP    *
021900*********************************************
022000*
022100     MOVE 'SC01'                 TO MBCA-PROGRAM-LOCATION.
022200     PERFORM MB60PD-GETMAIN-FOR-MAP
022300                                 THRU MB60PD-GFM-EXIT.
022400*
022500*******************************************
022600*    INITIALIZE THE STANDARD MAP LINES    *
022700*******************************************
022800*
022900     PERFORM MB60PD-INIT-STD-MAP-LINES
023000                                 THRU MB60PD-ISML-EXIT.
023100*
023200*****************************************
023300*    READ THE MERCHANT MASTER RECORD    *
023400*    FOR SUBSEQUENT DISPLAY             *
023500*****************************************
023600*
023700     MOVE MBCA-MERCHANT-ORG      TO MBIOWS-MMMM-ORG
023800                                    MM14-ORG.
023900     MOVE MBCA-MERCHANT          TO MBIOWS-MMMM-MERCHANT
024000                                    MM14-MERCHANT.
024100     MOVE 'FC01'                 TO MBCA-PROGRAM-LOCATION.
024200     SET MBIORO-READ-RANDOM      TO TRUE.
024300     PERFORM MMMMAO-ACCESS       THRU MMMMAO-ACCESS-EXIT.
024400*
024500     MOVE MMMM-NA-LINE (1 1)     TO MM14-MERCHANT-NAME.
024600*
024700*****************************************
024800*    READ THE MERCHANT PROD ASSIGN FILE *
024900*    FOR SUBSEQUENT DISPLAY             *
025000*****************************************
025100*
025200     MOVE MBCA-MERCHANT-ORG      TO MBIOWS-MMMP-ORG.
025300     MOVE MBCA-MERCHANT          TO MBIOWS-MMMP-MERCHANT.
025400     MOVE MBCA-CARD-PROD         TO MBIOWS-MMMP-PRODUCT
025500                                    MM14-PRODUCT.
025600     MOVE 'FC02'                 TO MBCA-PROGRAM-LOCATION.
025700     SET MBIORO-READ-RANDOM      TO TRUE.
025800     PERFORM MMMPAO-ACCESS       THRU MMMPAO-ACCESS-EXIT.
025900*
026000*****************************************
026100*    READ THE STORE MASTER FILE         *
026200*    ONLY IF SINGLE STORE IS ON         *
026300*****************************************
026400*
026500     IF  MMMM-SINGLE-STORE-YES
026600         MOVE MBCA-MERCHANT-ORG  TO MBIOWS-MMSM-ORG
026700         MOVE MMMM-STORE-NBR     TO MBIOWS-MMSM-STORE
026800         MOVE 'FC03'             TO MBCA-PROGRAM-LOCATION
026900         SET MBIORO-READ-RANDOM  TO TRUE
027000         PERFORM MMSMAO-ACCESS   THRU MMSMAO-ACCESS-EXIT.
027100*
027200*****************************************
027300*    READ THE ORGANIZATION FILE         *
027400*****************************************
027500*
027600     MOVE MBCA-MERCHANT-ORG      TO MBIOWS-MMOC-ORG.
027700     MOVE 'FC04'                 TO MBCA-PROGRAM-LOCATION.
027800     SET MBIORO-READ-RANDOM      TO TRUE.
027900     PERFORM MMOCAO-ACCESS       THRU MMOCAO-ACCESS-EXIT.
028000*
028100     SET X-MMOC-PROD             TO MBCA-CARD-PROD.
028200*
028300     MOVE MMOC-PRODUCT-DESC (X-MMOC-PROD)
028400                                 TO MM14-PROD-DESC.
028500     MOVE MBCA-CARD-PROD         TO MM14-PRODUCT.
028600*
028700****************************************
028800*    READ THE FIELD SECURITY RECORD    *
028900****************************************
029000*
029100     MOVE 'FC05'                 TO MBCA-PROGRAM-LOCATION.
029200     PERFORM Y900-READ-MMFS      THRU Y909-READ-MMFS-EXIT.
029300*
029400 B020-MOVE-FIELDS-TO-SCREEN.
029500*
029600*****************************************
029700*    MOVE THE MERCHANT MASTER FIELDS    *
029800*    FROM THE RECORD TO THE SCREEN      *
029900*****************************************
030000*
030100*
030200     PERFORM Y010-MOVE-VI-STATUS
030300                                 THRU Y019-EXIT.
030400*
030500     PERFORM Y030-MOVE-DISC-FEE-BASE
030600                                 THRU Y039-EXIT.
030700*
030800     PERFORM Y050-MOVE-DISC-TABLE
030900                                 THRU Y059-EXIT.
031000*
031100     PERFORM Y070-MOVE-EFF-DATE  THRU Y079-EXIT.
031200*
031300     PERFORM Y090-MOVE-PART-FEE-BASE
031400                                 THRU Y099-EXIT.
031500*
031600     PERFORM Y110-MOVE-PART-TABLE
031700                                 THRU Y119-EXIT.
031800*
031900     PERFORM Y130-MOVE-SETTLE-FLAG
032000                                 THRU Y139-EXIT.
032100*
032200     PERFORM Y170-MOVE-RESV-1-FEE-BASE
032300                                 THRU Y179-EXIT.
032400*
032500     PERFORM Y190-MOVE-RESV-1-TABLE
032600                                 THRU Y199-EXIT.
032700*
032800     PERFORM Y210-MOVE-SOURCE    THRU Y219-EXIT.
032900*
033000     PERFORM Y230-MOVE-RESV-2-FEE-BASE
033100                                 THRU Y239-EXIT.
033200*
033300     PERFORM Y250-MOVE-RESV-2-TABLE
033400                                 THRU Y259-EXIT.
033500*
033600     PERFORM Y270-MOVE-SHORT-DESC
033700                                 THRU Y279-EXIT.
033800*
033900     PERFORM Y290-MOVE-RESV-3-FEE-BASE
034000                                 THRU Y299-EXIT.
034100*
034200     PERFORM Y310-MOVE-RESV-3-TABLE
034300                                 THRU Y319-EXIT.
034400*
034500     PERFORM Y330-MOVE-RESV-4-FEE-BASE
034600                                 THRU Y339-EXIT.
034700*
034800     PERFORM Y350-MOVE-RESV-4-TABLE
034900                                 THRU Y359-EXIT.
035000*
035100     PERFORM Y370-MOVE-USER-CODE
035200                                 THRU Y379-EXIT.
035300*
035400     PERFORM Y390-MOVE-INTCHG-FEE-BASE
035500                                 THRU Y399-EXIT.
035600*
035700     IF  MMMM-SINGLE-STORE-YES
035800         NEXT SENTENCE
035900     ELSE
036000         MOVE DFHBMDAS           TO MM14-VI-DBA-NAME-LIT-A
036100                                    MM14-VI-DBA-NAME-LP-A
036200                                    MM14-VI-DBA-NAME-RP-A
036300                                    MM14-VI-DBA-NAME-A
036400                                    MM14-VI-INTCHG-FLAG-LIT-A
036500                                    MM14-VI-INTCHG-FLAG-LP-A
036600                                    MM14-VI-INTCHG-FLAG-RP-A
036700                                    MM14-VI-INTCHG-FLAG-A
036800                                    MM14-VI-MEMBER-ID-LIT-A
036900                                    MM14-VI-MEMBER-ID-RP-A
037000                                    MM14-VI-MEMBER-ID-LP-A
037100                                    MM14-VI-MEMBER-ID-A
037200                                    MM14-VI-SPECIAL-COND-LIT-A
037300                                    MM14-VI-SPECIAL-COND-1-LP-A
037400                                    MM14-VI-SPECIAL-COND-1-RP-A
037500                                    MM14-VI-SPECIAL-COND-1-A
037600                                    MM14-VI-SPECIAL-COND-2-LP-A
037700                                    MM14-VI-SPECIAL-COND-2-RP-A
037800                                    MM14-VI-SPECIAL-COND-2-A
037900                                    MM14-VI-MAIL-PHONE-IND-LIT-A
038000                                    MM14-VI-MAIL-PHONE-IND-LP-A
038100                                    MM14-VI-MAIL-PHONE-IND-RP-A
038200                                    MM14-VI-MAIL-PHONE-IND-A
038300                                    MM14-VI-CH-TERM-IND-LIT-A
038400                                    MM14-VI-CH-TERM-IND-LP-A
038500                                    MM14-VI-CH-TERM-IND-RP-A
038600                                    MM14-VI-CH-TERM-IND-A
038700                                    MM14-VI-RPT-THSHOLD-LIT-A
038800                                    MM14-VI-RPT-THSHOLD-LP-A
038900                                    MM14-VI-RPT-THSHOLD-RP-A
039000                                    MM14-VI-RPT-THSHOLD-A
039010                                    MM14-VI-CONTACT-IND-LIT-A     RG802901
039020                                    MM14-VI-CONTACT-IND-LP-A      RG802901
039030                                    MM14-VI-CONTACT-IND-RP-A      RG802901
039040                                    MM14-VI-CONTACT-IND-A         RG802901
039100                                    MM14-VI-CRB-REGION-LIT-A
039200                                    MM14-VI-CRB-REGION-LP-A
039300                                    MM14-VI-CRB-REGION-RP-A
039400                                    MM14-VI-CRB-REGION-A
039500                                    MM14-VI-REG-ADDR-IND-LIT-A
039600                                    MM14-VI-REG-ADDR-IND-LP-A
039700                                    MM14-VI-REG-ADDR-IND-RP-A
039800                                    MM14-VI-REG-ADDR-IND1-A
039900                                    MM14-VI-REG-ADDR-IND2-A
040000                                    MM14-VI-CATEGORY-CODE-LIT-A
040100                                    MM14-VI-CATEGORY-CODE-LP-A
040200                                    MM14-VI-CATEGORY-CODE-RP-A
040300                                    MM14-VI-CATEGORY-CODE-A
040400                                    MM14-VI-FLOOR-LIMIT-LIT-A
040500                                    MM14-VI-FLOOR-LIMIT-LP-A
040600                                    MM14-VI-FLOOR-LIMIT-RP-A
040700                                    MM14-VI-FLOOR-LIMIT-A
040800                                    MM14-VI-VOLUME-IND-LIT-A
040900                                    MM14-VI-VOLUME-IND-LP-A
041000                                    MM14-VI-VOLUME-IND-RP-A
041100                                    MM14-VI-VOLUME-IND-A
041110                                    MM14-VI-SVC-DVLP-IND-LIT-A    RG800914
041112                                    MM14-VI-SVC-DVLP-IND-LP-A     RG800914
041114                                    MM14-VI-SVC-DVLP-IND-RP-A     RG800914
041116                                    MM14-VI-SVC-DVLP-IND-A        RG800914
041200         GO TO B020-CONTINUE.
041300*
041400     PERFORM Y410-MOVE-DBA-NAME
041500                                 THRU Y419-EXIT.
041600*
041700     PERFORM Y450-MOVE-INTCHG-IND
041800                                 THRU Y459-EXIT.
041900*
042000     PERFORM Y470-MOVE-VISA-MEMBER-ID
042100                                 THRU Y479-EXIT.
042200*
042300     PERFORM Y490-MOVE-SPECIAL-COND-1
042400                                 THRU Y499-EXIT.
042500*
042600     PERFORM Y510-MOVE-SPECIAL-COND-2
042700                                 THRU Y519-EXIT.
042800*
042900     PERFORM Y530-MOVE-MAIL-PHONE-IND
043000                                 THRU Y539-EXIT.
043100*
043200     PERFORM Y550-MOVE-CH-TERM-IND
043300                                 THRU Y559-EXIT.
043400*
043500     PERFORM Y620-MOVE-RPT-THSHOLD
043600                                 THRU Y629-EXIT.
043610*                                                                 RG802901
043620     PERFORM Y630-MOVE-CONTACT-IND                                RG802901
043630                                 THRU Y639-EXIT.                  RG802901
043700*
043800     PERFORM Y650-MOVE-CRB-REGION
043900                                 THRU Y659-EXIT.
044000*
044100     PERFORM Y670-MOVE-REG-ADDR-IND1
044200                                 THRU Y679-EXIT.
044300*
044400     PERFORM Y690-MOVE-REG-ADDR-IND2
044500                                 THRU Y699-EXIT.
044600*
044700     PERFORM Y710-MOVE-CATEGORY-CODE
044800                                 THRU Y719-EXIT.
044900*
045000     PERFORM Y730-MOVE-FLOOR-LIMIT
045100                                 THRU Y739-EXIT.
045200*
045300     PERFORM Y750-MOVE-VOLUME-IND
045400                                 THRU Y759-EXIT.
045410*                                                                 RG800914
045420     PERFORM Y760-MOVE-SVC-DVLP-IND                               RG800914
045430                                 THRU Y769-EXIT.                  RG800914
045500*
045600 B020-CONTINUE.
045700*
045800     IF  MMMM-DL-MERCHANT
045900         MOVE DFHBMDAS           TO MM14-PROD-DISC-FEE-BASE-LP-A
046000                                    MM14-PROD-DISC-FEE-BASE-RP-A
046100                                    MM14-PROD-DISC-FEE-BASE-A
046200                                    MM14-PROD-DISC-RATE-TBL-LP-A
046300                                    MM14-PROD-DISC-RATE-TBL-RP-A
046400                                    MM14-PROD-DISC-RATE-TBL-A
046500                                    MM14-PROD-DISCOUNT-LIT-A.
046600*
046700     IF  MMMM-PL-MERCHANT
046800         MOVE DFHBMDAS           TO MM14-PROD-PART-FEE-BASE-LP-A
046900                                    MM14-PROD-PART-FEE-BASE-RP-A
047000                                    MM14-PROD-PART-FEE-BASE-A
047100                                    MM14-PROD-PART-RATE-TBL-LP-A
047200                                    MM14-PROD-PART-RATE-TBL-RP-A
047300                                    MM14-PROD-PART-RATE-TBL-A
047400                                    MM14-PROD-PARTICIPATION-LIT-A.
047500*
047600     IF  MMMM-RL-MERCHANT (1)
047700         MOVE DFHBMDAS           TO MM14-PROD-RESV-1-FEE-BASE-LP-A
047800                                    MM14-PROD-RESV-1-FEE-BASE-RP-A
047900                                    MM14-PROD-RESV-1-FEE-BASE-A
048000                                    MM14-PROD-RESV-1-RATE-TBL-LP-A
048100                                    MM14-PROD-RESV-1-RATE-TBL-RP-A
048200                                    MM14-PROD-RESV-1-RATE-TBL-A
048300                                    MM14-PROD-RESERVE-1-LIT-A.
048400*
048500     IF  MMMM-RL-MERCHANT (2)
048600         MOVE DFHBMDAS           TO MM14-PROD-RESV-2-FEE-BASE-LP-A
048700                                    MM14-PROD-RESV-2-FEE-BASE-RP-A
048800                                    MM14-PROD-RESV-2-FEE-BASE-A
048900                                    MM14-PROD-RESV-2-RATE-TBL-LP-A
049000                                    MM14-PROD-RESV-2-RATE-TBL-RP-A
049100                                    MM14-PROD-RESV-2-RATE-TBL-A
049200                                    MM14-PROD-RESERVE-2-LIT-A.
049300*
049400     IF  MMMM-RL-MERCHANT (3)
049500         MOVE DFHBMDAS           TO MM14-PROD-RESV-3-FEE-BASE-LP-A
049600                                    MM14-PROD-RESV-3-FEE-BASE-RP-A
049700                                    MM14-PROD-RESV-3-FEE-BASE-A
049800                                    MM14-PROD-RESV-3-RATE-TBL-LP-A
049900                                    MM14-PROD-RESV-3-RATE-TBL-RP-A
050000                                    MM14-PROD-RESV-3-RATE-TBL-A
050100                                    MM14-PROD-RESERVE-3-LIT-A.
050200*
050300     IF  MMMM-RL-MERCHANT (4)
050400         MOVE DFHBMDAS           TO MM14-PROD-RESV-4-FEE-BASE-LP-A
050500                                    MM14-PROD-RESV-4-FEE-BASE-RP-A
050600                                    MM14-PROD-RESV-4-FEE-BASE-A
050700                                    MM14-PROD-RESV-4-RATE-TBL-LP-A
050800                                    MM14-PROD-RESV-4-RATE-TBL-RP-A
050900                                    MM14-PROD-RESV-4-RATE-TBL-A
051000                                    MM14-PROD-RESERVE-4-LIT-A.
051100*
051200********************************************
051300*  TO FORMAT AND POPULATE THE MESSAGE LINE *
051400********************************************
051500*
051600     IF MM14-ERR-MESSAGE IS EQUAL TO SPACES OR LOW-VALUES
051700        PERFORM MB06PD-FORMAT-MESSAGE-LINE
051800           THRU MB06PD-FML-EXIT
051900        MOVE SS08WS-FORMATTED-MSG   TO MM14-ERR-MESSAGE
052000     END-IF.
052100*
052200******************************************
052300*    SET THE CURSOR AND SCREEN NUMBER    *
052400******************************************
052500*
052600     IF  MBCA-PTI-FUNCTION-IS-INQUIRY
052700         MOVE SS08WS-CURSOR      TO MM14-ALT-TRANID-L
052800     ELSE
052900         PERFORM Y800-SET-CURSOR THRU Y809-SC-EXIT.
053000*
053100     COMPUTE MBCA-SCREEN-NBR     =  MBCA-SCREEN-NBR - 50.
053200*
053300**********************
053400*    SEND THE MAP    *
053500**********************
053600*
053700     MOVE 'BM01'                 TO MBCA-PROGRAM-LOCATION.
053800     PERFORM MB60PD-SEND-MAP-WITH-ERASE
053900                                 THRU MB60PD-SMWE-EXIT.
054000*
054100************************
054200*    RETURN TO CICS    *
054300************************
054400*
054500     MOVE 'PC02'                 TO MBCA-PROGRAM-LOCATION.
054600     PERFORM MB70PD-RETURN-TRANS-ID
054700                                 THRU MB70PD-RTI-EXIT.
054800/
054900 C000-RECEIVE-SCREEN SECTION.
055000*
055100***********************************************
055200*    SET RESV PRODUCT TO TRUE FOR USER INPUT  *
055300***********************************************
055400*
055500     SET MMMMIR-RL-PRODUCT (1)   TO TRUE.
055600     SET MMMMIR-RL-PRODUCT (2)   TO TRUE.
055700     SET MMMMIR-RL-PRODUCT (3)   TO TRUE.
055800     SET MMMMIR-RL-PRODUCT (4)   TO TRUE.
055900*
056000******************************************
056100*    THIS SECTION RECEIVES THE SCREEN    *
056200******************************************
056300*
056400     IF  MBCA-MBUI-UI-YES
056500*
056600****************************************************************
056700*    ACQUIRE MAIN STORAGE FOR TEMP STORAGE RECORD              *
056800****************************************************************
056900*
057000         MOVE 'TS01'             TO MBCA-PROGRAM-LOCATION
057100         EXEC CICS GETMAIN
057200                   FLENGTH (LENGTH  OF MBUITS-RECORD)
057300
057400                   SET     (ADDRESS OF MBUITS-RECORD)
057500
057600              END-EXEC
057700*
057800***********************************************
057900*    READ THE TEMP STORAGE RECORD             *
058000***********************************************
058100*
058200         MOVE 'TS02'             TO MBCA-PROGRAM-LOCATION
058300*
058400         EXEC CICS READQ TS
058500                   QUEUE   (TS-QUEUE-NAME)
058600                   INTO    (MBUITS-RECORD)
058700                   LENGTH  (LENGTH  OF MBUITS-RECORD)
058800                   ITEM    (1)
058900              END-EXEC
059000*
059100***********************************************
059200*    DELETE THE TEMP STORAGE RECORD           *
059300***********************************************
059400*
059500         MOVE 'TS03'             TO MBCA-PROGRAM-LOCATION
059600*
059700         EXEC CICS IGNORE CONDITION
059800                   QIDERR
059900              END-EXEC
060000*
060100         EXEC CICS DELETEQ TS
060200                   QUEUE  (TS-QUEUE-NAME)
060300              END-EXEC
060400         MOVE 'SC02'             TO MBCA-PROGRAM-LOCATION
060500         PERFORM MB60PD-GETMAIN-FOR-MAP
060600                                 THRU MB60PD-GFM-EXIT
060700         MOVE MBUITS-VAR-DATA    TO MBMM14I
060800     ELSE
060900         MOVE 'BM02'             TO MBCA-PROGRAM-LOCATION
061000         PERFORM MB60PD-RECEIVE-MAP
061100                                 THRU MB60PD-RM-EXIT.
061200*
061300**************************************************************
061400*    CHECK FOR ANOTHER TRANSACTION ID ENTERED BY THE USER    *
061500**************************************************************
061600*
061700     MOVE 'PC03'                 TO MBCA-PROGRAM-LOCATION.
061800     PERFORM MB60PD-NEW-TRANS-ROUTINE
061900                                 THRU MB60PD-NTR-EXIT.
062000*
062100****************************************************
062200*    BYPASS ALL SCREEN EDITS IF THIS IS INQIURY    *
062300****************************************************
062400*
062500     IF  MBCA-PTI-FUNCTION-IS-INQUIRY
062600         GO TO F000-SETUP-COMMAREA.
062700*
062800*****************************************
062900*    READ THE MERCHANT MASTER RECORD    *
063000*****************************************
063100*
063200     IF  MBCA-PTI-FUNCTION-IS-ADD
063300     AND MBCA-MBUI-UI-YES
063400     AND MBCA-MBUI-UI-UPDATE-NO
063500         MOVE 'SC03'             TO MBCA-PROGRAM-LOCATION
063600         SET MBIORO-GETMAIN      TO TRUE
063700         PERFORM MMMMAO-ACCESS   THRU MMMMAO-ACCESS-EXIT
063800         MOVE MMMMIR-RECORD      TO MMMM-RECORD
063900     ELSE
064000         MOVE SS08WS-CICS-FC-NOTFND TO MBIORO-TEMP-STATUS-1
064100         MOVE MBCA-MERCHANT-ORG  TO MBIOWS-MMMM-ORG
064200                                    MM14-ORG
064300         MOVE MBCA-MERCHANT      TO MBIOWS-MMMM-MERCHANT
064400                                    MM14-MERCHANT
064500         MOVE 'FC06'             TO MBCA-PROGRAM-LOCATION
064600         SET MBIORO-READ-RANDOM  TO TRUE
064700         PERFORM MMMMAO-ACCESS   THRU MMMMAO-ACCESS-EXIT
064800         IF  SS08WS-RC-FC-NOTFND
064900         AND MBCA-MBUI-UI-YES
065000             MOVE 'MBUI'         TO MBCA-TRANS-ID
065100                                    MBCA-PREV-TRANS-ID
065200             MOVE 01             TO MBCA-SCREEN-NBR
065300             MOVE 'MER'          TO MM14-FILLER
065400             SET MBCA-MBUI-ERROR-YES
065500                                 TO TRUE
065600             GO TO F000-SETUP-COMMAREA.
065700*
065800     IF (MBCA-PTI-FUNCTION-IS-MAINT
065900     AND MBCA-MBUI-UI-YES
066000     AND (MMMM-REC-PURGED
066100       OR MMMM-REC-INCOMPLETE))
066200     OR
066300        (MBCA-PTI-FUNCTION-IS-ADD
066400     AND MBCA-MBUI-UI-YES
066500     AND MMMM-REC-PURGED)
066600         MOVE 'MBUI'             TO MBCA-TRANS-ID
066700                                    MBCA-PREV-TRANS-ID
066800         MOVE 01                 TO MBCA-SCREEN-NBR
066900         MOVE 'MER'              TO MM14-FILLER
067000         SET MBCA-MBUI-ERROR-YES
067100                                 TO TRUE
067200         GO TO F000-SETUP-COMMAREA.
067300*
067400************************************************
067500*    READ THE MERCHANT PROD ASSIGNMENT RECORD  *
067600************************************************
067700*
067800*
067900     IF  MBCA-PTI-FUNCTION-IS-ADD
068000     AND MBCA-MBUI-UI-YES
068100     AND MBCA-MBUI-UI-UPDATE-NO
068200         MOVE 'SC04'             TO MBCA-PROGRAM-LOCATION
068300         SET MBIORO-GETMAIN      TO TRUE
068400         PERFORM MMMPAO-ACCESS   THRU MMMPAO-ACCESS-EXIT
068500         MOVE MMMPIR-RECORD      TO MMMP-RECORD
068600     ELSE
068700         MOVE SS08WS-CICS-FC-NOTFND TO MBIORO-TEMP-STATUS-1
068800         MOVE MBCA-MERCHANT-ORG  TO MBIOWS-MMMP-ORG
068900         MOVE MBCA-MERCHANT      TO MBIOWS-MMMP-MERCHANT
069000         MOVE MBCA-CARD-PROD     TO MBIOWS-MMMP-PRODUCT
069100                                    MM14-PRODUCT
069200         MOVE 'FC07'             TO MBCA-PROGRAM-LOCATION
069300         SET MBIORO-READ-RANDOM  TO TRUE
069400         PERFORM MMMPAO-ACCESS   THRU MMMPAO-ACCESS-EXIT
069500         IF  SS08WS-RC-FC-NOTFND
069600         AND MBCA-MBUI-UI-YES
069700             MOVE 'MBUI'         TO MBCA-TRANS-ID
069800                                    MBCA-PREV-TRANS-ID
069900             MOVE 01             TO MBCA-SCREEN-NBR
070000             MOVE 'PRD'          TO MM14-FILLER
070100             SET MBCA-MBUI-ERROR-YES
070200                                 TO TRUE
070300             GO TO F000-SETUP-COMMAREA.
070400*
070500************************************************
070600*    READ THE STORE MASTER RECORD              *
070700************************************************
070800*
070900     IF  MMMM-SINGLE-STORE-YES
071000         MOVE MBCA-MERCHANT-ORG  TO MBIOWS-MMSM-ORG
071100         MOVE MMMM-STORE-NBR     TO MBIOWS-MMSM-STORE
071200         MOVE 'FC08'             TO MBCA-PROGRAM-LOCATION
071300         SET MBIORO-READ-RANDOM  TO TRUE
071400         PERFORM MMSMAO-ACCESS   THRU MMSMAO-ACCESS-EXIT.
071500*
071600************************************************
071700*    READ THE ORG CONTROL RECORD               *
071800************************************************
071900*
072000     MOVE MBCA-MERCHANT-ORG      TO MBIOWS-MMOC-ORG.
072100     MOVE 'FC09'                 TO MBCA-PROGRAM-LOCATION.
072200     SET MBIORO-READ-RANDOM      TO TRUE.
072300     PERFORM MMOCAO-ACCESS       THRU MMOCAO-ACCESS-EXIT.
072400*
072500****************************************
072600*    READ THE FIELD SECURITY RECORD    *
072700****************************************
072800*
072900     MOVE 'FC10'                 TO MBCA-PROGRAM-LOCATION.
073000     PERFORM Y900-READ-MMFS      THRU Y909-READ-MMFS-EXIT.
073100*
073200 C020-FIELD-EDITS.
073300*
073400*********************
073500*    FIELD EDITS    *
073600*********************
073700*
073800     PERFORM W010-EDIT-VI-STATUS
073900                                 THRU W019-EXIT.
074000*
074100     PERFORM W030-EDIT-DISC-FEE-BASE
074200                                 THRU W039-EXIT.
074300*
074400     PERFORM W050-EDIT-DISC-TABLE
074500                                 THRU W059-EXIT.
074600*
074700     PERFORM W070-EDIT-EFF-DATE  THRU W079-EXIT.
074800*
074900     PERFORM W090-EDIT-PART-FEE-BASE
075000                                 THRU W099-EXIT.
075100*
075200     PERFORM W110-EDIT-PART-TABLE
075300                                 THRU W119-EXIT.
075400*
075500     PERFORM W130-EDIT-SETTLE-FLAG
075600                                 THRU W139-EXIT.
075700*
075800     PERFORM W170-EDIT-RESV-1-FEE-BASE
075900                                 THRU W179-EXIT.
076000*
076100     PERFORM W190-EDIT-RESV-1-TABLE
076200                                 THRU W199-EXIT.
076300*
076400     PERFORM W210-EDIT-SOURCE    THRU W219-EXIT.
076500*
076600     PERFORM W230-EDIT-RESV-2-FEE-BASE
076700                                 THRU W239-EXIT.
076800*
076900     PERFORM W250-EDIT-RESV-2-TABLE
077000                                 THRU W259-EXIT.
077100*
077200     PERFORM W270-EDIT-SHORT-DESC
077300                                 THRU W279-EXIT.
077400*
077500     PERFORM W290-EDIT-RESV-3-FEE-BASE
077600                                 THRU W299-EXIT.
077700*
077800     PERFORM W310-EDIT-RESV-3-TABLE
077900                                 THRU W319-EXIT.
078000*
078100     PERFORM W330-EDIT-RESV-4-FEE-BASE
078200                                 THRU W339-EXIT.
078300*
078400     PERFORM W350-EDIT-RESV-4-TABLE
078500                                 THRU W359-EXIT.
078600*
078700     PERFORM W370-EDIT-USER-CODE THRU W379-EXIT.
078800*
078900     PERFORM W390-EDIT-INTCHG-FEE-BASE
079000                                 THRU W399-EXIT.
079100*
079200     IF  MMMM-SINGLE-STORE-YES
079300         NEXT SENTENCE
079400     ELSE
079500         MOVE DFHBMDAS           TO MM14-VI-DBA-NAME-LIT-A
079600                                    MM14-VI-DBA-NAME-LP-A
079700                                    MM14-VI-DBA-NAME-RP-A
079800                                    MM14-VI-DBA-NAME-A
079900                                    MM14-VI-INTCHG-FLAG-LIT-A
080000                                    MM14-VI-INTCHG-FLAG-LP-A
080100                                    MM14-VI-INTCHG-FLAG-RP-A
080200                                    MM14-VI-INTCHG-FLAG-A
080300                                    MM14-VI-MEMBER-ID-LIT-A
080400                                    MM14-VI-MEMBER-ID-RP-A
080500                                    MM14-VI-MEMBER-ID-LP-A
080600                                    MM14-VI-MEMBER-ID-A
080700                                    MM14-VI-SPECIAL-COND-LIT-A
080800                                    MM14-VI-SPECIAL-COND-1-LP-A
080900                                    MM14-VI-SPECIAL-COND-1-RP-A
081000                                    MM14-VI-SPECIAL-COND-1-A
081100                                    MM14-VI-SPECIAL-COND-2-LP-A
081200                                    MM14-VI-SPECIAL-COND-2-RP-A
081300                                    MM14-VI-SPECIAL-COND-2-A
081400                                    MM14-VI-MAIL-PHONE-IND-LIT-A
081500                                    MM14-VI-MAIL-PHONE-IND-LP-A
081600                                    MM14-VI-MAIL-PHONE-IND-RP-A
081700                                    MM14-VI-MAIL-PHONE-IND-A
081800                                    MM14-VI-CH-TERM-IND-LIT-A
081900                                    MM14-VI-CH-TERM-IND-LP-A
082000                                    MM14-VI-CH-TERM-IND-RP-A
082100                                    MM14-VI-CH-TERM-IND-A
082200                                    MM14-VI-RPT-THSHOLD-LIT-A
082300                                    MM14-VI-RPT-THSHOLD-LP-A
082400                                    MM14-VI-RPT-THSHOLD-RP-A
082500                                    MM14-VI-RPT-THSHOLD-A
082510                                    MM14-VI-CONTACT-IND-LIT-A     RG802901
082520                                    MM14-VI-CONTACT-IND-LP-A      RG802901
082530                                    MM14-VI-CONTACT-IND-RP-A      RG802901
082540                                    MM14-VI-CONTACT-IND-A         RG802901
082600                                    MM14-VI-CRB-REGION-LIT-A
082700                                    MM14-VI-CRB-REGION-LP-A
082800                                    MM14-VI-CRB-REGION-RP-A
082900                                    MM14-VI-CRB-REGION-A
083000                                    MM14-VI-REG-ADDR-IND-LIT-A
083100                                    MM14-VI-REG-ADDR-IND-LP-A
083200                                    MM14-VI-REG-ADDR-IND-RP-A
083300                                    MM14-VI-REG-ADDR-IND1-A
083400                                    MM14-VI-REG-ADDR-IND2-A
083500                                    MM14-VI-CATEGORY-CODE-LIT-A
083600                                    MM14-VI-CATEGORY-CODE-LP-A
083700                                    MM14-VI-CATEGORY-CODE-RP-A
083800                                    MM14-VI-CATEGORY-CODE-A
083900                                    MM14-VI-FLOOR-LIMIT-LIT-A
084000                                    MM14-VI-FLOOR-LIMIT-LP-A
084100                                    MM14-VI-FLOOR-LIMIT-RP-A
084200                                    MM14-VI-FLOOR-LIMIT-A
084300                                    MM14-VI-VOLUME-IND-LIT-A
084400                                    MM14-VI-VOLUME-IND-LP-A
084500                                    MM14-VI-VOLUME-IND-RP-A
084600                                    MM14-VI-VOLUME-IND-A
084610                                    MM14-VI-SVC-DVLP-IND-LIT-A    RG800914
084612                                    MM14-VI-SVC-DVLP-IND-LP-A     RG800914
084614                                    MM14-VI-SVC-DVLP-IND-RP-A     RG800914
084616                                    MM14-VI-SVC-DVLP-IND-A        RG800914
084700         GO TO C040-CROSS-EDITS.
084800*
084900     PERFORM W410-EDIT-DBA-NAME  THRU W419-EXIT.
085000*
085100     PERFORM W450-EDIT-INTCHG-IND
085200                                 THRU W459-EXIT.
085300*
085400     PERFORM W470-EDIT-VISA-MEMBER-ID
085500                                 THRU W479-EXIT.
085600*
085700     PERFORM W490-EDIT-SPECIAL-COND-1
085800                                 THRU W499-EXIT.
085900*
086000     PERFORM W510-EDIT-SPECIAL-COND-2
086100                                 THRU W519-EXIT.
086200*
086300     PERFORM W530-EDIT-MAIL-PHONE-IND
086400                                 THRU W539-EXIT.
086500*
086600     PERFORM W550-EDIT-CH-ACCT-IND
086700                                 THRU W559-EXIT.
086800*
086900     PERFORM W620-EDIT-RPT-THRESHOLD
087000                                 THRU W629-EXIT.
087010*                                                                 RG802901
087020     PERFORM W630-EDIT-CONTACT-IND                                RG802901
087030                                 THRU W639-EXIT.                  RG802901
087100*
087200     PERFORM W650-EDIT-CRB-REGION
087300                                 THRU W659-EXIT.
087400*
087500     PERFORM W670-EDIT-REG-ADDR-IND1
087600                                 THRU W679-EXIT.
087700*
087800     PERFORM W690-EDIT-REG-ADDR-IND2
087900                                 THRU W699-EXIT.
088000*
088100     PERFORM W710-EDIT-CATEGORY  THRU W719-EXIT.
088200*
088300     PERFORM W730-EDIT-FLOOR-LIMIT
088400                                 THRU W739-EXIT.
088500*
088600     PERFORM W750-EDIT-VOLUME-IND
088700                                 THRU W759-EXIT.
088710*                                                                 RG800914
088720     PERFORM W760-EDIT-SVC-DVLP-IND                               RG800914
088730                                 THRU W769-EXIT.                  RG800914
088800*
088900 C040-CROSS-EDITS.
089000*
089100*********************
089200*    CROSS EDITS    *
089300*********************
089400*
089500     PERFORM W770-STATUS-X-EDITS
089600                                 THRU W779-EXIT.
089700*
089800     PERFORM W780-CROSS-EDIT-MPEC-IND
089900                                 THRU W789-EXIT.
089910*                                                                 RG802901
089920     PERFORM W790-CROSS-EDIT-CONTACT-IND                          RG802901
089930                                 THRU W799-EXIT.                  RG802901
090000/
090100 D000-RETURN-ERRORS SECTION.
090200*
090300     IF  SS08WS-ERROR-SW-NO
090400         GO TO E000-UPDATE-FILE.
090500*
090600     IF  MBCA-MBUI-UI-YES
090700         MOVE 'MBUI'             TO MBCA-TRANS-ID
090800                                    MBCA-PREV-TRANS-ID
090900         MOVE 01                 TO MBCA-SCREEN-NBR
091000         SET MBCA-MBUI-ERROR-YES TO TRUE
091100         GO TO F000-SETUP-COMMAREA.
091200*
091300***************************************************************
091400*    INITIALIZE THE STANDARD MAP LINES.  IN AN ERROR          *
091500*    CONDITION, THIS ROUTINE IS PERFORMED PRIMARILY           *
091600*    TO UPDATE THE DATE AND TIME ON THE SCREEN.               *
091700***************************************************************
091800*
091900     PERFORM MB60PD-INIT-STD-MAP-LINES
092000                                 THRU MB60PD-ISML-EXIT.
092100*
092200********************************************
092300*  TO FORMAT AND POPULATE THE MESSAGE LINE *
092400********************************************
092500*
092600     IF MM14-ERR-MESSAGE IS EQUAL TO SPACES OR LOW-VALUES
092700        PERFORM MB06PD-FORMAT-MESSAGE-LINE
092800           THRU MB06PD-FML-EXIT
092900        MOVE SS08WS-FORMATTED-MSG   TO MM14-ERR-MESSAGE
093000     END-IF.
093100*
093200**********************
093300*    SEND THE MAP    *
093400**********************
093500*
093600     MOVE 'BM03'                 TO MBCA-PROGRAM-LOCATION.
093700     PERFORM MB60PD-SEND-MAP-DATA-ONLY
093800                                 THRU MB60PD-SMDO-EXIT.
093900*
094000************************
094100*    RETURN TO CICS    *
094200************************
094300*
094400     MOVE 'PC04'                 TO MBCA-PROGRAM-LOCATION.
094500     PERFORM MB70PD-RETURN-TRANS-ID
094600                                 THRU MB70PD-RTI-EXIT.
094700/
094800 E000-UPDATE-FILE SECTION.
094900*
095000     IF  MBCA-MBUI-UI-YES
095100         SET MBCA-MBUI-ERROR-NO  TO TRUE.
095200*
095300     IF  MBCA-MBUI-UI-YES
095400     AND MBCA-MBUI-UI-UPDATE-NO
095500         GO TO F000-SETUP-COMMAREA.
095600*
095700**********************************************************
095800*    READ THE MERCHANT PROD ASSIGNMENT RECORD FOR UPDATE *
095900**********************************************************
096000*
096100     MOVE 'FC11'                 TO MBCA-PROGRAM-LOCATION.
096200     MOVE MBCA-MERCHANT-ORG      TO MBIOWS-MMMP-ORG.
096300     MOVE MBCA-MERCHANT          TO MBIOWS-MMMP-MERCHANT.
096400     MOVE MBCA-CARD-PROD         TO MBIOWS-MMMP-PRODUCT.
096500     SET MBIORO-READ-RANDOM-UPDATE
096600                                 TO TRUE.
096700     PERFORM MMMPAO-ACCESS       THRU MMMPAO-ACCESS-EXIT.
096800*
096900**********************************************************
097000*    READ THE STORE MASTER RECORD FOR UPDATE             *
097100**********************************************************
097200*
097300     IF  MMMM-SINGLE-STORE-YES
097400         MOVE 'FC12'             TO MBCA-PROGRAM-LOCATION
097500         MOVE MBCA-MERCHANT-ORG  TO MBIOWS-MMSM-ORG
097600         MOVE MMMM-STORE-NBR     TO MBIOWS-MMSM-STORE
097700         SET MBIORO-READ-RANDOM-UPDATE
097800                                 TO TRUE
097900         PERFORM MMSMAO-ACCESS   THRU MMSMAO-ACCESS-EXIT.
098000*
098100*************************************
098200*    OBTAIN STORAGE FOR LOG FILE    *
098300*    RECORD IF DOING MAINTENANCE    *
098400*************************************
098500*
098600     MOVE 'SC05'                 TO MBCA-PROGRAM-LOCATION.
098700     SET MBIORO-GETMAIN          TO TRUE.
098800     PERFORM MML1AO-ACCESS       THRU MML1AO-ACCESS-EXIT.
098900*
099000 E020-UPDATE-FIELDS.
099100*
099200*
099300     PERFORM X010-UPDATE-VI-STATUS
099400                                 THRU X019-EXIT.
099500*
099600     PERFORM X030-UPDATE-DISC-FEE-BASE
099700                                 THRU X039-EXIT.
099800*
099900     PERFORM X050-UPDATE-DISC-TABLE
100000                                 THRU X059-EXIT.
100100*
100200     PERFORM X070-UPDATE-EFF-DATE THRU X079-EXIT.
100300*
100400     PERFORM X090-UPDATE-PART-FEE-BASE
100500                                 THRU X099-EXIT.
100600*
100700     PERFORM X110-UPDATE-PART-TABLE
100800                                 THRU X119-EXIT.
100900*
101000     PERFORM X130-UPDATE-SETTLE-FLAG
101100                                 THRU X139-EXIT.
101200*
101300     PERFORM X170-UPDATE-RESV-1-FEE-BASE
101400                                 THRU X179-EXIT.
101500*
101600     PERFORM X190-UPDATE-RESV-1-TABLE
101700                                 THRU X199-EXIT.
101800*
101900     PERFORM X210-UPDATE-SOURCE  THRU X219-EXIT.
102000*
102100     PERFORM X230-UPDATE-RESV-2-FEE-BASE
102200                                 THRU X239-EXIT.
102300*
102400     PERFORM X250-UPDATE-RESV-2-TABLE
102500                                 THRU X259-EXIT.
102600*
102700     PERFORM X270-UPDATE-SHORT-DESC
102800                                 THRU X279-EXIT.
102900*
103000     PERFORM X290-UPDATE-RESV-3-FEE-BASE
103100                                 THRU X299-EXIT.
103200*
103300     PERFORM X310-UPDATE-RESV-3-TABLE
103400                                 THRU X319-EXIT.
103500*
103600     PERFORM X330-UPDATE-RESV-4-FEE-BASE
103700                                 THRU X339-EXIT.
103800*
103900     PERFORM X350-UPDATE-RESV-4-TABLE
104000                                 THRU X359-EXIT.
104100*
104200     PERFORM X370-UPDATE-USER-CODE
104300                                 THRU X379-EXIT.
104400*
104500     PERFORM X390-UPDATE-INTCHG-FEE-BASE
104600                                 THRU X399-EXIT.
104700*
104800     IF  MMMM-SINGLE-STORE-YES
104900         NEXT SENTENCE
105000     ELSE
105100         GO TO E040-UPDATE-MMMP.
105200*
105300     PERFORM X410-UPDATE-DBA-NAME
105400                                 THRU X419-EXIT.
105500*
105600     PERFORM X450-UPDATE-INTCHG-IND
105700                                 THRU X459-EXIT.
105800*
105900     PERFORM X470-UPDATE-VISA-MEMBER-ID
106000                                 THRU X479-EXIT.
106100*
106200     PERFORM X490-UPDATE-SPECIAL-COND-1
106300                                 THRU X499-EXIT.
106400*
106500     PERFORM X510-UPDATE-SPECIAL-COND-2
106600                                 THRU X519-EXIT.
106700*
106800     PERFORM X530-UPDATE-MAIL-PHONE-IND
106900                                 THRU X539-EXIT.
107000*
107100     PERFORM X550-UPDATE-CH-TERM-IND
107200                                 THRU X559-EXIT.
107300*
107400     PERFORM X620-UPDATE-RPT-THSHOLD
107500                                 THRU X629-EXIT.
107510*                                                                 RG802901
107520     PERFORM X630-UPDATE-CONTACT-IND                              RG802901
107530                                 THRU X639-EXIT.                  RG802901
107600*
107700     PERFORM X650-UPDATE-CRB-REGION
107800                                 THRU X659-EXIT.
107900*
108000     PERFORM X670-UPDATE-REG-ADDR-IND1
108100                                 THRU X679-EXIT.
108200*
108300     PERFORM X690-UPDATE-REG-ADDR-IND2
108400                                 THRU X699-EXIT.
108500*
108600     PERFORM X710-UPDATE-CATEGORY-CODE
108700                                 THRU X719-EXIT.
108800*
108900     PERFORM X730-UPDATE-FLOOR-LIMIT
109000                                 THRU X739-EXIT.
109100*
109200     PERFORM X750-UPDATE-VOLUME-IND
109300                                 THRU X759-EXIT.
109310*                                                                 RG800914
109320     PERFORM X760-UPDATE-SVC-DVLP-IND                             RG800914
109330                                 THRU X769-EXIT.                  RG800914
109400*
109500 E040-UPDATE-MMMP.
109600*
109700     IF  MBCA-PTI-FUNCTION-IS-ADD
109800         MOVE MBCA-START-DATE    TO MMMP-LAST-MAINT-DATE
109900         MOVE MBCA-OPERATOR-ID   TO MMMP-LAST-MAINT-OPER
110000         SET WS-UPDATE-MMMP-SW-YES
110100                                 TO TRUE.
110200*
110300     IF  MBCA-PTI-FUNCTION-IS-ADD
110400     AND MMMM-SINGLE-STORE-YES
110500         MOVE MBCA-START-DATE    TO MMSM-LAST-MAINT-DATE
110600         MOVE MBCA-OPERATOR-ID   TO MMSM-LAST-MAINT-OPER
110700         SET WS-UPDATE-MMSM-SW-YES
110800                                 TO TRUE.
110900*
111000**************************************************************
111100*    WRITE A LOG RECORD TO SHOW THAT THE LAST MAINT DATE     *
111200*    AND OPERATOR HAS BEEN UPDATED IF FIELDS WERE CHANGED    *
111300*    ON THE SCREEN                                           *
111400**************************************************************
111500*
111600     IF  MBCA-PTI-FUNCTION-IS-MAINT
111700     AND MMMM-SINGLE-STORE-YES
111800     AND WS-UPDATE-MMSM-SW-YES
111900         MOVE 0198               TO MML1-FIELD-CODE
112000         MOVE ZEROES             TO MML1-FIELD-OCCURRENCE
112100                                    MML1-FIELD-OCCURRENCE-2
112200         MOVE MML1WS-VL-03       TO MML1-VARIABLE-LENGTH
112300         MOVE MMSM-LAST-MAINT-OPER
112400                                 TO MML1-VL03-B-DATA-X
112500         MOVE MBCA-OPERATOR-ID   TO MMSM-LAST-MAINT-OPER
112600         MOVE MMSM-LAST-MAINT-OPER
112700                                 TO MML1-VL03-A-DATA-X
112800         MOVE 'FC13'             TO MBCA-PROGRAM-LOCATION
112900         PERFORM Y920-WRITE-MMSM-LOG-RECORD
113000                                 THRU Y929-WLR-EXIT
113100         MOVE 0199               TO MML1-FIELD-CODE
113200         MOVE MML1WS-VL-07       TO MML1-VARIABLE-LENGTH
113300         MOVE MMSM-LAST-MAINT-DATE
113400                                 TO MML1-VL07-B-DATA-9
113500         MOVE MBCA-START-DATE    TO MMSM-LAST-MAINT-DATE
113600         MOVE MMSM-LAST-MAINT-DATE
113700                                 TO MML1-VL07-A-DATA-9
113800         MOVE 'FC14'             TO MBCA-PROGRAM-LOCATION
113900         PERFORM Y920-WRITE-MMSM-LOG-RECORD
114000                                 THRU Y929-WLR-EXIT.
114100*
114200     IF  MBCA-PTI-FUNCTION-IS-MAINT
114300     AND WS-UPDATE-MMMP-SW-YES
114400     AND MMMP-ADD-COMPLETED
114500         MOVE 0198               TO MML1-FIELD-CODE
114600         MOVE ZEROES             TO MML1-FIELD-OCCURRENCE
114700                                    MML1-FIELD-OCCURRENCE-2
114800         MOVE MML1WS-VL-03       TO MML1-VARIABLE-LENGTH
114900         MOVE MMMP-LAST-MAINT-OPER
115000                                 TO MML1-VL03-B-DATA-X
115100         MOVE MBCA-OPERATOR-ID   TO MMMP-LAST-MAINT-OPER
115200         MOVE MMMP-LAST-MAINT-OPER
115300                                 TO MML1-VL03-A-DATA-X
115400         MOVE 'FC15'             TO MBCA-PROGRAM-LOCATION
115500         PERFORM Y910-WRITE-MMMP-LOG-RECORD
115600                                 THRU Y919-WLR-EXIT
115700         MOVE 0199               TO MML1-FIELD-CODE
115800         MOVE MML1WS-VL-07       TO MML1-VARIABLE-LENGTH
115900         MOVE MMMP-LAST-MAINT-DATE
116000                                 TO MML1-VL07-B-DATA-9
116100         MOVE MBCA-START-DATE    TO MMMP-LAST-MAINT-DATE
116200         MOVE MMMP-LAST-MAINT-DATE
116300                                 TO MML1-VL07-A-DATA-9
116400         MOVE 'FC16'             TO MBCA-PROGRAM-LOCATION
116500         PERFORM Y910-WRITE-MMMP-LOG-RECORD
116600                                 THRU Y919-WLR-EXIT.
116700*
116800****************************************************
116900*    REWRITE THE STORE    MASTER RECORD IF         *
117000*    FIELDS HAVE BEEN CHANGED ON THE SCREEN, OR    *
117100*    UNLOCK IT IF THEY HAVE NOT                    *
117200****************************************************
117300*
117400     IF  WS-UPDATE-MMSM-SW-YES
117500     AND MMMM-SINGLE-STORE-YES
117600         MOVE 'FC17'             TO MBCA-PROGRAM-LOCATION
117700         SET MBIORO-REWRITE      TO TRUE
117800         PERFORM MMSMAO-ACCESS   THRU MMSMAO-ACCESS-EXIT
117900     ELSE
118000         IF  MMMM-SINGLE-STORE-YES
118100             MOVE 'FC18'         TO MBCA-PROGRAM-LOCATION
118200             SET MBIORO-UNLOCK   TO TRUE
118300             PERFORM MMSMAO-ACCESS
118400                                 THRU MMSMAO-ACCESS-EXIT.
118500*
118600     IF  MBCA-PTI-FUNCTION-IS-MAINT
118700     AND MMMP-REC-INCOMPLETE
118800         MOVE 'FC19'             TO MBCA-PROGRAM-LOCATION
118900         SET MMMP-REC-ACTIVE     TO TRUE
119000         SET MMMP-ADD-COMPLETED  TO TRUE
119100         MOVE MBCA-START-DATE    TO MMMP-LAST-MAINT-DATE
119200         MOVE MBCA-OPERATOR-ID   TO MMMP-LAST-MAINT-OPER
119300         SET MBIORO-REWRITE      TO TRUE
119400         SET MBCA-MBMM-PRODUCT-ON
119500                                 TO TRUE
119600         PERFORM MMMPAO-ACCESS   THRU MMMPAO-ACCESS-EXIT
119700         MOVE ZEROES             TO MML1-FIELD-CODE
119800                                    MML1-FIELD-OCCURRENCE
119900                                    MML1-FIELD-OCCURRENCE-2
120000         MOVE LENGTH OF MMMP-RECORD
120100                                 TO MML1-VARIABLE-LENGTH
120200         MOVE 'MP'               TO MML1-FILE-CODE
120300         MOVE MBCA-MERCHANT-ORG  TO MML1-MMMP-ORG
120400         MOVE MBCA-MERCHANT      TO MML1-MMMP-MERCHANT
120500         MOVE MBCA-CARD-PROD     TO MML1-MMMP-PRODUCT
120600         MOVE MBCA-SIGNON-NAME   TO MML1-SIGNON-NAME
120700         MOVE MBCA-TERMINAL-ID   TO MML1-TERMINAL-ID
120800         MOVE MMMP-RECORD        TO MML1-ADD-AREA
120900         MOVE 'FC20'             TO MBCA-PROGRAM-LOCATION
121000         SET MBIORO-WRITE        TO TRUE
121100         PERFORM MML1AO-ACCESS   THRU MML1AO-ACCESS-EXIT
121200     ELSE
121300         MOVE 'FC21'             TO MBCA-PROGRAM-LOCATION
121400         SET MBIORO-REWRITE      TO TRUE
121500         PERFORM MMMPAO-ACCESS   THRU MMMPAO-ACCESS-EXIT.
121600*
121700/
121800 F000-SETUP-COMMAREA SECTION.
121900*
122000***************************************************************
122100*  SET UP COMMAREA FIELDS AND TRANSFER TO THE NEXT PROGRAM    *
122200***************************************************************
122300*
122400     MOVE MBCA-EIBAID            TO SS08WS-EIBAID.
122500*
122600     PERFORM MB60PD-EDIT-PAGE-NBR
122700                                 THRU MB60PD-EPN-EXIT.
122800*
122900     MOVE 63                     TO MBCA-SCREEN-NBR.
123000*
123100     IF  SS08WS-VALID-PF-KEY
123200     OR  SS08WS-EIBAID-VALID-PF-KEY
123300         SET MBCA-INITIAL-SCREEN-NBR
123400                                 TO TRUE.
123500*
123600     IF  MBCA-MBUI-UI-YES
123700         MOVE 'MBUI'             TO MBCA-TRANS-ID
123800                                    MBCA-PREV-TRANS-ID
123900         MOVE 01                 TO MBCA-SCREEN-NBR
124000         MOVE MBMM14I            TO MBUITS-VAR-DATA
124100         MOVE LENGTH OF MBMM14I  TO MBUITS-VAR-LENGTH
124200         MOVE 'TS10'             TO MBCA-PROGRAM-LOCATION
124300         EXEC CICS WRITEQ TS
124400                   QUEUE   (TS-QUEUE-NAME)
124500                   FROM    (MBUITS-RECORD)
124600                   LENGTH  (LENGTH  OF MBUITS-RECORD)
124700
124800              END-EXEC.
124900*
125000     MOVE 'PC05'                 TO MBCA-PROGRAM-LOCATION.
125100     PERFORM MB70PD-XCTL-TO-MBOXCTL
125200                                 THRU MB70PD-XTM-EXIT.
125300/
125400 W000-FIELD-EDITS SECTION.
125500*
125600*********************************************************
125700*    EACH FIELD IS CODED IN A SEPERATE ROUTINE, AND     *
125800*    IN A LIKE MANNER.  THE COMMENTS FOR THE FLOW OF    *
125900*    THE EDIT ROUTINES CAN BE FOUND IN ROUTINES         *
126000*    'W010-EDIT-STATUS' THRU 'W019-ES-EXIT'.  EACH      *
126100*    ROUTINE MAY CONTAIN COMMENTS, BUT THEY ARE         *
126200*    UNIQUE TO THAT ROUTINE.                            *
126300*********************************************************
126400*
126500 W010-EDIT-VI-STATUS.
126600*
126700     MOVE DFHBMDAS               TO MM14-VI-STATUS-LP-A
126800                                    MM14-VI-STATUS-RP-A.
126900     MOVE DFHBMASK               TO MM14-VI-STATUS-A.
127000*
127100     PERFORM Y015-STATUS-SECURITY
127200                                 THRU Y019-EXIT.
127300*
127400     IF  MM14-VI-STATUS-L IS GREATER THAN ZERO
127500         MOVE DFHBMASF           TO MM14-VI-STATUS-A
127600     ELSE
127700         MOVE MMMP-PROD-STATUS   TO MM14-VI-STATUS.
127800*
127900     IF  MM14-VI-STATUS-VALID
128000         NEXT SENTENCE
128100     ELSE
128200         GO TO W018-VI-STATUS-ERROR.
128300*
128400     IF  MBCA-PTI-FUNCTION-IS-MAINT
128500     OR  MM14-VI-STATUS-L IS GREATER THAN ZERO
128600     OR  NOT MMFS-MT-REQUIRED (X-MMFS-MERCH)
128700         GO TO W019-EXIT.
128800*
128900 W018-VI-STATUS-ERROR.
129000*
129100     IF  MM14-VI-STATUS-L IS GREATER THAN ZERO
129200         MOVE DFHBMUBF           TO MM14-VI-STATUS-A
129300     ELSE
129400         MOVE DFHBMBRY           TO MM14-VI-STATUS-A.
129500*
129600     SET SS08WS-ERROR-SW-YES     TO TRUE.
129700     MOVE DFHBMASB               TO MM14-VI-STATUS-LP-A
129800                                    MM14-VI-STATUS-RP-A.
129900     MOVE SS08WS-CURSOR          TO MM14-VI-STATUS-L.
130000*
130100 W019-EXIT.
130200     EXIT.
130300*
130400 W030-EDIT-DISC-FEE-BASE.
130500*
130600     IF  MMMM-DL-MERCHANT
130700         MOVE DFHBMDAS           TO MM14-PROD-DISC-FEE-BASE-LP-A
130800                                    MM14-PROD-DISC-FEE-BASE-RP-A
130900                                    MM14-PROD-DISC-FEE-BASE-A
131000                                    MM14-PROD-DISCOUNT-LIT-A
131100         GO TO W039-EXIT.
131200*
131300     MOVE DFHBMDAS               TO MM14-PROD-DISC-FEE-BASE-LP-A
131400                                    MM14-PROD-DISC-FEE-BASE-RP-A.
131500     MOVE DFHBMASK               TO MM14-PROD-DISC-FEE-BASE-A.
131600*
131700     PERFORM Y035-DISC-FEE-BASE-SECURITY
131800                                 THRU Y039-EXIT.
131900*
132000     IF  MM14-PROD-DISC-FEE-BASE-L IS GREATER THAN ZERO
132100         MOVE DFHBMASF           TO MM14-PROD-DISC-FEE-BASE-A
132200     ELSE
132300         MOVE MMMP-PROD-DISC-FEE-BASE
132400                                 TO MM14-PROD-DISC-FEE-BASE.
132500*
132600     IF  MM14-PDFB-VALID
132700         NEXT SENTENCE
132800     ELSE
132900         GO TO W038-DISC-FEE-BASE-ERROR.
133000*
133100     IF  MBCA-PTI-FUNCTION-IS-MAINT
133200     OR  MM14-PROD-DISC-FEE-BASE-L IS GREATER THAN ZERO
133300     OR  NOT MMFS-MT-REQUIRED (X-MMFS-MERCH)
133400         GO TO W039-EXIT.
133500*
133600 W038-DISC-FEE-BASE-ERROR.
133700*
133800     IF  MM14-PROD-DISC-FEE-BASE-L IS GREATER THAN ZERO
133900         MOVE DFHBMUBF           TO MM14-PROD-DISC-FEE-BASE-A
134000     ELSE
134100         MOVE DFHBMBRY           TO MM14-PROD-DISC-FEE-BASE-A.
134200*
134300     SET SS08WS-ERROR-SW-YES     TO TRUE.
134400     MOVE DFHBMASB               TO MM14-PROD-DISC-FEE-BASE-LP-A
134500                                    MM14-PROD-DISC-FEE-BASE-RP-A.
134600     MOVE SS08WS-CURSOR          TO MM14-PROD-DISC-FEE-BASE-L.
134700*
134800 W039-EXIT.
134900     EXIT.
135000*
135100 W050-EDIT-DISC-TABLE.
135200*
135300     IF  MMMM-DL-MERCHANT
135400         MOVE DFHBMDAS           TO MM14-PROD-DISC-RATE-TBL-LP-A
135500                                    MM14-PROD-DISC-RATE-TBL-RP-A
135600                                    MM14-PROD-DISC-RATE-TBL-A
135700                                    MM14-PROD-DISCOUNT-LIT-A
135800         GO TO W059-EXIT.
135900*
136000     MOVE DFHBMDAS               TO MM14-PROD-DISC-RATE-TBL-LP-A
136100                                    MM14-PROD-DISC-RATE-TBL-RP-A.
136200     MOVE DFHBMASK               TO MM14-PROD-DISC-RATE-TBL-A.
136300     PERFORM Y055-DISC-RATE-TBL-SECURITY
136400                                 THRU Y059-EXIT.
136500*
136600     IF  MM14-PROD-DISC-RATE-TBL-L IS GREATER THAN ZERO
136700         MOVE DFHBMASF           TO MM14-PROD-DISC-RATE-TBL-A
136800     ELSE
136900         MOVE MMMP-PROD-DISC-RATE-TABLE
137000                                 TO MM14-PROD-DISC-RATE-TBL.
137100*
137200     IF  MM14-PROD-DISC-RATE-TBL IS NUMERIC
137300         NEXT SENTENCE
137400     ELSE
137500         GO TO W058-DISC-RATE-TBL-ERROR.
137600*
137700     IF  MM14-PROD-DISC-RATE-TBL IS EQUAL TO ZEROS
137800         GO TO W055-CONTINUE
137900     ELSE
138000         MOVE MM14-PROD-DISC-RATE-TBL
138100                                 TO MBIOWS-MMRT-TABLE-NBR
138200         SET MBIOWS-MMRT-TT-DISCOUNT
138300                                 TO TRUE
138400         PERFORM Y930-READ-MMRT  THRU Y939-RRT-EXIT
138500         IF  SS08WS-RC-FC-NOTFND
138600         OR  MMRT-REC-INCOMPLETE
138700         OR  MMRT-REC-PURGED
138800         OR  MMRT-REC-INACTIVE
138900         OR  MMRT-ADD-PENDING
139000             GO TO W058-DISC-RATE-TBL-ERROR.
139100*
139200     IF  MMRT-TT-DISCOUNT
139300         NEXT SENTENCE
139400     ELSE
139500         GO TO W058-DISC-RATE-TBL-ERROR.
139600*
139700     IF  MMRT-PRODUCT-LEVEL
139800         NEXT SENTENCE
139900     ELSE
140000         GO TO W058-DISC-RATE-TBL-ERROR.
140100*
140200     MOVE MMRT-METHOD            TO MMRTWS-METHOD.
140300*
140400     IF  MMRTWS-VALID-AT-PRODUCT-LEVEL
140500         NEXT SENTENCE
140600     ELSE
140700         GO TO W058-DISC-RATE-TBL-ERROR.
140800*
140900     EVALUATE TRUE
141000         WHEN (MMRTWS-DTD-VOLUME-W-CR-PLAN
141100           OR MMRTWS-PTD-VOLUME-W-CR-PLAN
141200           OR MMRTWS-RESV-PCT-ON-VOL-PLAN)
141300           IF  MMOC-CP-MERCH-NO
141400               GO TO W058-DISC-RATE-TBL-ERROR
141500           END-IF
141600         WHEN MMMM-DF1-DAILY-DISC
141700             IF  MMRTWS-VALID-DAILY-METHODS
141800                 CONTINUE
141900             ELSE
142000                 GO TO W058-DISC-RATE-TBL-ERROR
142100             END-IF
142200         WHEN MMMM-DF1-WEEKLY-DISC
142300             IF  MMRTWS-VALID-WEEKLY-METHODS
142400                 CONTINUE
142500             ELSE
142600                 GO TO W058-DISC-RATE-TBL-ERROR
142700             END-IF
142800         WHEN MMMM-DF1-BI-WEEKLY-DISC
142900             IF  MMRTWS-VALID-BI-WEEKLY-METHODS
143000                 CONTINUE
143100             ELSE
143200                 GO TO W058-DISC-RATE-TBL-ERROR
143300             END-IF
143400         WHEN MMMM-DF1-MONTHLY-DISC
143500             IF  MMRTWS-VALID-MONTHLY-METHODS
143600                 CONTINUE
143700             ELSE
143800                 GO TO W058-DISC-RATE-TBL-ERROR
143900             END-IF
144000         WHEN OTHER
144100             GO TO W058-DISC-RATE-TBL-ERROR
144200     END-EVALUATE.
144300*
144400 W055-CONTINUE.
144500*
144600     IF  MBCA-PTI-FUNCTION-IS-MAINT
144700     OR  MM14-PROD-DISC-RATE-TBL-L IS GREATER THAN ZERO
144800     OR  NOT MMFS-MT-REQUIRED (X-MMFS-MERCH)
144900         GO TO W059-EXIT.
145000*
145100 W058-DISC-RATE-TBL-ERROR.
145200*
145300     IF  MM14-PROD-DISC-RATE-TBL-L IS GREATER THAN ZERO
145400         MOVE DFHBMNBF           TO MM14-PROD-DISC-RATE-TBL-A
145500     ELSE
145600         MOVE DFHBMUNB           TO MM14-PROD-DISC-RATE-TBL-A.
145700*
145800     SET SS08WS-ERROR-SW-YES     TO TRUE.
145900     MOVE DFHBMASB               TO MM14-PROD-DISC-RATE-TBL-LP-A
146000                                    MM14-PROD-DISC-RATE-TBL-RP-A.
146100     MOVE SS08WS-CURSOR          TO MM14-PROD-DISC-RATE-TBL-L.
146200*
146300 W059-EXIT.
146400     EXIT.
146500*
146600 W070-EDIT-EFF-DATE.
146700*
146800     MOVE DFHBMDAS               TO MM14-VI-EFF-DATE-LP-A
146900                                    MM14-VI-EFF-DATE-RP-A.
147000     MOVE DFHBMASK               TO MM14-VI-EFF-DATE-A.
147100*
147200     PERFORM Y075-EFF-DATE-SECURITY
147300                                 THRU Y079-EXIT.
147400*
147500     IF  MM14-VI-EFF-DATE-L IS EQUAL TO ZERO
147600         MOVE MMMP-PROD-EFF-DATE TO SS01WS-JULIAN
147700         PERFORM SS08PD-JUL-TO-GREG
147800                                 THRU SS08PD-JTG-EXIT
147900         MOVE SS01WS-DATE        TO MM14-VI-EFF-DATE.
148000*
148100     IF  MM14-VI-EFF-DATE IS NOT NUMERIC
148200         GO TO W077-PROD-EFF-DATE-ERROR.
148300*
148400     IF  MM14-VI-EFF-DATE IS LESS THAN 1000000
148500         MOVE MM14-VI-EFF-DATE TO SS01WS-MDY
148600         MOVE SS01WS-MDYZ        TO SS01WS-DATEZ
148700     ELSE
148800         MOVE MM14-VI-EFF-DATE TO SS01WS-DATE.
148900*
149000     PERFORM SS05PD-DATE-VALIDATION
149100                                 THRU SS05PD-DV-EXIT.
149200*
149300     IF  SS01WS-DATE-IS-INVALID
149400         GO TO W077-PROD-EFF-DATE-ERROR
149500     ELSE
149600         MOVE SS01WS-DATE        TO MM14-VI-EFF-DATE.
149700*
149800     IF  MM14-VI-EFF-DATE-L IS GREATER THAN ZERO
149900         IF  MBCA-PTI-FUNCTION-IS-ADD
150000         AND MMFS-MT-REQUIRED (X-MMFS-MERCH)
150100             MOVE DFHBMABF       TO MM14-VI-EFF-DATE-A
150200             GO TO W079-EXIT
150300         ELSE
150400             MOVE DFHBMASF       TO MM14-VI-EFF-DATE-A
150500             GO TO W079-EXIT.
150600*
150700     IF  MBCA-PTI-FUNCTION-IS-MAINT
150800     OR  NOT MMFS-MT-REQUIRED (X-MMFS-MERCH)
150900         GO TO W079-EXIT.
151000*
151100 W077-PROD-EFF-DATE-ERROR.
151200*
151300     IF  MM14-VI-EFF-DATE-L IS GREATER THAN ZERO
151400         MOVE DFHBMNBF           TO MM14-VI-EFF-DATE-A
151500     ELSE
151600         MOVE DFHBMUNB           TO MM14-VI-EFF-DATE-A.
151700
151800     SET SS08WS-ERROR-SW-YES     TO TRUE.
151900     MOVE DFHBMASB               TO MM14-VI-EFF-DATE-LP-A
152000                                    MM14-VI-EFF-DATE-RP-A.
152100     MOVE SS08WS-CURSOR          TO MM14-VI-EFF-DATE-L.
152200*
152300 W079-EXIT.
152400     EXIT.
152500*
152600 W090-EDIT-PART-FEE-BASE.
152700*
152800     IF  MMMM-PL-MERCHANT
152900         MOVE DFHBMDAS           TO MM14-PROD-PART-FEE-BASE-LP-A
153000                                    MM14-PROD-PART-FEE-BASE-RP-A
153100                                    MM14-PROD-PART-FEE-BASE-A
153200                                    MM14-PROD-PARTICIPATION-LIT-A
153300         GO TO W099-EXIT.
153400*
153500     MOVE DFHBMDAS               TO MM14-PROD-PART-FEE-BASE-LP-A
153600                                    MM14-PROD-PART-FEE-BASE-RP-A.
153700     MOVE DFHBMASK               TO MM14-PROD-PART-FEE-BASE-A.
153800*
153900     PERFORM Y095-PART-FEE-BASE-SECURITY
154000                                 THRU Y099-EXIT.
154100*
154200*
154300     IF  MM14-PROD-PART-FEE-BASE-L IS GREATER THAN ZERO
154400         MOVE DFHBMASF           TO MM14-PROD-PART-FEE-BASE-A
154500     ELSE
154600         MOVE MMMP-PROD-PART-FEE-BASE
154700                                 TO MM14-PROD-PART-FEE-BASE.
154800*
154900     IF  MM14-PPFB-VALID
155000         NEXT SENTENCE
155100     ELSE
155200         GO TO W098-PART-FEE-BASE-ERROR.
155300*
155400     IF  MBCA-PTI-FUNCTION-IS-MAINT
155500     OR  MM14-PROD-PART-FEE-BASE-L IS GREATER THAN ZERO
155600     OR  NOT MMFS-MT-REQUIRED (X-MMFS-MERCH)
155700         GO TO W099-EXIT.
155800*
155900 W098-PART-FEE-BASE-ERROR.
156000*
156100     IF  MM14-PROD-PART-FEE-BASE-L IS GREATER THAN ZERO
156200         MOVE DFHBMUBF           TO MM14-PROD-PART-FEE-BASE-A
156300     ELSE
156400         MOVE DFHBMBRY           TO MM14-PROD-PART-FEE-BASE-A.
156500*
156600     SET SS08WS-ERROR-SW-YES     TO TRUE.
156700     MOVE DFHBMASB               TO MM14-PROD-PART-FEE-BASE-LP-A
156800                                    MM14-PROD-PART-FEE-BASE-RP-A.
156900     MOVE SS08WS-CURSOR          TO MM14-PROD-PART-FEE-BASE-L.
157000*
157100 W099-EXIT.
157200     EXIT.
157300*
157400 W110-EDIT-PART-TABLE.
157500*
157600     IF  MMMM-PL-MERCHANT
157700         MOVE DFHBMDAS           TO MM14-PROD-PART-RATE-TBL-LP-A
157800                                    MM14-PROD-PART-RATE-TBL-RP-A
157900                                    MM14-PROD-PART-RATE-TBL-A
158000                                    MM14-PROD-PARTICIPATION-LIT-A
158100         GO TO W119-EXIT.
158200*
158300     MOVE DFHBMDAS               TO MM14-PROD-PART-RATE-TBL-LP-A
158400                                    MM14-PROD-PART-RATE-TBL-RP-A.
158500     MOVE DFHBMASK               TO MM14-PROD-PART-RATE-TBL-A.
158600*
158700     PERFORM Y115-PART-RATE-TBL-SECURITY
158800                                 THRU Y119-EXIT.
158900*
159000     IF  MM14-PROD-PART-RATE-TBL-L IS GREATER THAN ZERO
159100         MOVE DFHBMASF           TO MM14-PROD-PART-RATE-TBL-A
159200     ELSE
159300         MOVE MMMP-PROD-PART-RATE-TABLE
159400                                 TO MM14-PROD-PART-RATE-TBL.
159500*
159600     IF  MM14-PROD-PART-RATE-TBL IS NUMERIC
159700         NEXT SENTENCE
159800     ELSE
159900         GO TO W118-PART-RATE-TBL-ERROR.
160000*
160100     IF  MM14-PROD-PART-RATE-TBL IS EQUAL TO ZEROS
160200         GO TO W115-CONTINUE
160300     ELSE
160400         MOVE MM14-PROD-PART-RATE-TBL
160500                                 TO MBIOWS-MMRT-TABLE-NBR
160600         SET MBIOWS-MMRT-TT-PARTICIPATION
160700                                 TO TRUE
160800         PERFORM Y930-READ-MMRT  THRU Y939-RRT-EXIT
160900         IF  SS08WS-RC-FC-NOTFND
161000         OR  MMRT-REC-INCOMPLETE
161100         OR  MMRT-REC-PURGED
161200         OR  MMRT-REC-INACTIVE
161300         OR  MMRT-ADD-PENDING
161400             GO TO W118-PART-RATE-TBL-ERROR.
161500*
161600     IF  MMRT-TT-PARTICIPATION
161700         NEXT SENTENCE
161800     ELSE
161900         GO TO W118-PART-RATE-TBL-ERROR.
162000*
162100     IF  MMRT-PRODUCT-LEVEL
162200         NEXT SENTENCE
162300     ELSE
162400         GO TO W118-PART-RATE-TBL-ERROR.
162500*
162600     MOVE MMRT-METHOD            TO MMRTWS-METHOD.
162700*
162800     IF  MMRTWS-VALID-AT-PRODUCT-LEVEL
162900         NEXT SENTENCE
163000     ELSE
163100         GO TO W118-PART-RATE-TBL-ERROR.
163200*
163300     EVALUATE TRUE
163400         WHEN (MMRTWS-DTD-VOLUME-W-CR-PLAN
163500           OR MMRTWS-PTD-VOLUME-W-CR-PLAN
163600           OR MMRTWS-RESV-PCT-ON-VOL-PLAN)
163700           IF  MMOC-CP-MERCH-NO
163800               GO TO W118-PART-RATE-TBL-ERROR
163900           END-IF
164000         WHEN MMMM-PF1-DAILY-PART
164100             IF  MMRTWS-VALID-DAILY-METHODS
164200                 CONTINUE
164300             ELSE
164400                 GO TO W118-PART-RATE-TBL-ERROR
164500             END-IF
164600         WHEN MMMM-PF1-WEEKLY-PART
164700             IF  MMRTWS-VALID-WEEKLY-METHODS
164800                 CONTINUE
164900             ELSE
165000                 GO TO W118-PART-RATE-TBL-ERROR
165100             END-IF
165200         WHEN MMMM-PF1-BI-WEEKLY-PART
165300             IF  MMRTWS-VALID-BI-WEEKLY-METHODS
165400                 CONTINUE
165500             ELSE
165600                 GO TO W118-PART-RATE-TBL-ERROR
165700             END-IF
165800         WHEN MMMM-PF1-MONTHLY-PART
165900             IF  MMRTWS-VALID-MONTHLY-METHODS
166000                 CONTINUE
166100             ELSE
166200                 GO TO W118-PART-RATE-TBL-ERROR
166300             END-IF
166400         WHEN OTHER
166500             GO TO W118-PART-RATE-TBL-ERROR
166600     END-EVALUATE.
166700*
166800 W115-CONTINUE.
166900*
167000     IF  MBCA-PTI-FUNCTION-IS-MAINT
167100     OR  MM14-PROD-PART-RATE-TBL-L IS GREATER THAN ZERO
167200     OR  NOT MMFS-MT-REQUIRED (X-MMFS-MERCH)
167300         GO TO W119-EXIT.
167400*
167500 W118-PART-RATE-TBL-ERROR.
167600*
167700     IF  MM14-PROD-PART-RATE-TBL-L IS GREATER THAN ZERO
167800         MOVE DFHBMNBF           TO MM14-PROD-PART-RATE-TBL-A
167900     ELSE
168000         MOVE DFHBMUNB           TO MM14-PROD-PART-RATE-TBL-A.
168100*
168200     SET SS08WS-ERROR-SW-YES     TO TRUE.
168300     MOVE DFHBMASB               TO MM14-PROD-PART-RATE-TBL-LP-A
168400                                    MM14-PROD-PART-RATE-TBL-RP-A.
168500     MOVE SS08WS-CURSOR          TO MM14-PROD-PART-RATE-TBL-L.
168600*
168700 W119-EXIT.
168800     EXIT.
168900*
169000 W130-EDIT-SETTLE-FLAG.
169100*
169200     MOVE DFHBMDAS               TO MM14-PROD-SETTLE-FLAG-LP-A
169300                                    MM14-PROD-SETTLE-FLAG-RP-A.
169400     MOVE DFHBMASK               TO MM14-PROD-SETTLE-FLAG-A.
169500*
169600     PERFORM Y135-SETTLE-FLAG-SECURITY
169700                                 THRU Y139-EXIT.
169800*
169900     IF  MM14-PROD-SETTLE-FLAG-L IS GREATER THAN ZERO
170000         MOVE DFHBMASF           TO MM14-PROD-SETTLE-FLAG-A
170100     ELSE
170200         MOVE MMMP-PROD-SETTLE-FLAG
170300                                 TO MM14-PROD-SETTLE-FLAG.
170400*
170500     IF  MM14-PROD-SETTLE-FLAG-VALID
170600         NEXT SENTENCE
170700     ELSE
170800         GO TO W138-SETTLE-FLAG-ERROR.
170900*
171000     IF  MBCA-PTI-FUNCTION-IS-MAINT
171100     OR  MM14-PROD-SETTLE-FLAG-L IS GREATER THAN ZERO
171200     OR  NOT MMFS-MT-REQUIRED (X-MMFS-MERCH)
171300         GO TO W139-EXIT.
171400*
171500 W138-SETTLE-FLAG-ERROR.
171600*
171700     IF  MM14-PROD-SETTLE-FLAG-L IS GREATER THAN ZERO
171800         MOVE DFHBMUBF           TO MM14-PROD-SETTLE-FLAG-A
171900     ELSE
172000         MOVE DFHBMBRY           TO MM14-PROD-SETTLE-FLAG-A.
172100*
172200     SET SS08WS-ERROR-SW-YES     TO TRUE.
172300     MOVE DFHBMASB               TO MM14-PROD-SETTLE-FLAG-LP-A
172400                                    MM14-PROD-SETTLE-FLAG-RP-A.
172500     MOVE SS08WS-CURSOR          TO MM14-PROD-SETTLE-FLAG-L.
172600*
172700 W139-EXIT.
172800     EXIT.
172900*
173000 W170-EDIT-RESV-1-FEE-BASE.
173100*
173200     SET  X-MMMP-PROD-RESV       TO 1.
173300*
173400     IF  MMMM-RL-MERCHANT (1)
173500         MOVE DFHBMDAS           TO MM14-PROD-RESV-1-FEE-BASE-LP-A
173600                                    MM14-PROD-RESV-1-FEE-BASE-RP-A
173700                                    MM14-PROD-RESV-1-FEE-BASE-A
173800                                    MM14-PROD-RESERVE-1-LIT-A
173900         MOVE ZERO               TO MM14-PROD-RESV-1-FEE-BASE-L
174000         GO TO W179-EXIT.
174100*
174200     MOVE DFHBMDAS               TO MM14-PROD-RESV-1-FEE-BASE-LP-A
174300                                   MM14-PROD-RESV-1-FEE-BASE-RP-A.
174400     MOVE DFHBMASK               TO MM14-PROD-RESV-1-FEE-BASE-A.
174500*
174600     PERFORM Y175-RESV-1-FEE-BASE-SECURITY
174700                                 THRU Y179-EXIT.
174800*
174900     IF  MM14-PROD-RESV-1-FEE-BASE-L IS GREATER THAN ZERO
175000         MOVE DFHBMASF           TO MM14-PROD-RESV-1-FEE-BASE-A
175100     ELSE
175200         MOVE MMMP-PROD-RESV-FEE-BASE (X-MMMP-PROD-RESV)
175300                                 TO MM14-PROD-RESV-1-FEE-BASE.
175400*
175500     IF  MM14-PR1FB-VALID
175600         NEXT SENTENCE
175700     ELSE
175800         GO TO W178-RESV-1-FEE-BASE-ERROR.
175900*
176000     IF  MBCA-PTI-FUNCTION-IS-MAINT
176100     OR  MM14-PROD-RESV-1-FEE-BASE-L IS GREATER THAN ZERO
176200     OR  NOT MMFS-MT-REQUIRED (X-MMFS-MERCH)
176300         GO TO W179-EXIT.
176400*
176500 W178-RESV-1-FEE-BASE-ERROR.
176600*
176700     IF  MM14-PROD-RESV-1-FEE-BASE-L IS GREATER THAN ZERO
176800         MOVE DFHBMUBF           TO MM14-PROD-RESV-1-FEE-BASE-A
176900     ELSE
177000         MOVE DFHBMBRY           TO MM14-PROD-RESV-1-FEE-BASE-A.
177100*
177200     SET SS08WS-ERROR-SW-YES     TO TRUE.
177300     MOVE DFHBMASB               TO MM14-PROD-RESV-1-FEE-BASE-LP-A
177400                                   MM14-PROD-RESV-1-FEE-BASE-RP-A.
177500     MOVE SS08WS-CURSOR          TO MM14-PROD-RESV-1-FEE-BASE-L.
177600*
177700 W179-EXIT.
177800     EXIT.
177900*
178000 W190-EDIT-RESV-1-TABLE.
178100*
178200     SET X-MMMM-RESV             TO 1.
178300     SET X-MMMP-PROD-RESV        TO 1.
178400*
178500     IF  MMMM-RL-MERCHANT (X-MMMM-RESV)
178600         MOVE DFHBMDAS           TO MM14-PROD-RESV-1-RATE-TBL-LP-A
178700                                    MM14-PROD-RESV-1-RATE-TBL-RP-A
178800                                    MM14-PROD-RESV-1-RATE-TBL-A
178900                                    MM14-PROD-RESERVE-1-LIT-A
179000         MOVE ZERO               TO MM14-PROD-RESV-1-RATE-TBL-L
179100         GO TO W199-EXIT.
179200*
179300     MOVE DFHBMDAS               TO MM14-PROD-RESV-1-RATE-TBL-LP-A
179400                                   MM14-PROD-RESV-1-RATE-TBL-RP-A.
179500     MOVE DFHBMASK               TO MM14-PROD-RESV-1-RATE-TBL-A.
179600*
179700     PERFORM Y195-RESV-1-RATE-TBL-SECURITY
179800                                 THRU Y199-EXIT.
179900*
180000     IF  MM14-PROD-RESV-1-RATE-TBL-L IS GREATER THAN ZERO
180100         MOVE DFHBMASF           TO MM14-PROD-RESV-1-RATE-TBL-A
180200     ELSE
180300         MOVE MMMP-PROD-RESV-RATE-TABLE (X-MMMP-PROD-RESV)
180400                                 TO MM14-PROD-RESV-1-RATE-TBL.
180500*
180600     IF  MM14-PROD-RESV-1-RATE-TBL IS NUMERIC
180700         NEXT SENTENCE
180800     ELSE
180900         GO TO W198-RESV-1-RATE-TBL-ERROR.
181000*
181100     IF  MM14-PROD-RESV-1-RATE-TBL IS EQUAL TO ZEROS
181200         GO TO W195-CONTINUE
181300     ELSE
181400         MOVE MM14-PROD-RESV-1-RATE-TBL
181500                                 TO MBIOWS-MMRT-TABLE-NBR
181600         SET MBIOWS-MMRT-TT-RESERVE
181700                                 TO TRUE
181800         PERFORM Y930-READ-MMRT  THRU Y939-RRT-EXIT
181900         IF  SS08WS-RC-FC-NOTFND
182000         OR  MMRT-REC-INCOMPLETE
182100         OR  MMRT-REC-PURGED
182200         OR  MMRT-REC-INACTIVE
182300         OR  MMRT-ADD-PENDING
182400             GO TO W198-RESV-1-RATE-TBL-ERROR.
182500*
182600     IF  MMRT-TT-RESERVE
182700         NEXT SENTENCE
182800     ELSE
182900         GO TO W198-RESV-1-RATE-TBL-ERROR.
183000*
183100     IF  MMRT-PRODUCT-LEVEL
183200         NEXT SENTENCE
183300     ELSE
183400         GO TO W198-RESV-1-RATE-TBL-ERROR.
183500*
183600     MOVE MMRT-METHOD            TO MMRTWS-METHOD.
183700*
183800     IF  MMRTWS-VALID-AT-PRODUCT-LEVEL
183900         NEXT SENTENCE
184000     ELSE
184100         GO TO W198-RESV-1-RATE-TBL-ERROR.
184200*
184300     EVALUATE TRUE
184400         WHEN (MMRTWS-DTD-VOLUME-W-CR-PLAN
184500           OR MMRTWS-PTD-VOLUME-W-CR-PLAN
184600           OR MMRTWS-RESV-PCT-ON-VOL-PLAN)
184700           IF  MMOC-CP-MERCH-NO
184800               GO TO W198-RESV-1-RATE-TBL-ERROR
184900           END-IF
185000     END-EVALUATE.
185100
185200*
185300 W195-CONTINUE.
185400*
185500     IF  MBCA-PTI-FUNCTION-IS-MAINT
185600     OR  MM14-PROD-RESV-1-RATE-TBL-L IS GREATER THAN ZERO
185700     OR  NOT MMFS-MT-REQUIRED (X-MMFS-MERCH)
185800         GO TO W199-EXIT.
185900*
186000 W198-RESV-1-RATE-TBL-ERROR.
186100*
186200     IF  MM14-PROD-RESV-1-RATE-TBL-L IS GREATER THAN ZERO
186300         MOVE DFHBMNBF           TO MM14-PROD-RESV-1-RATE-TBL-A
186400     ELSE
186500         MOVE DFHBMUNB           TO MM14-PROD-RESV-1-RATE-TBL-A.
186600*
186700     SET SS08WS-ERROR-SW-YES     TO TRUE.
186800     MOVE DFHBMASB               TO MM14-PROD-RESV-1-RATE-TBL-LP-A
186900                                   MM14-PROD-RESV-1-RATE-TBL-RP-A.
187000     MOVE SS08WS-CURSOR          TO MM14-PROD-RESV-1-RATE-TBL-L.
187100*
187200 W199-EXIT.
187300     EXIT.
187400*
187500 W210-EDIT-SOURCE.
187600*
187700     MOVE DFHBMDAS               TO MM14-PROD-SOURCE-LP-A
187800                                    MM14-PROD-SOURCE-RP-A.
187900     MOVE DFHBMASK               TO MM14-PROD-SOURCE-A.
188000*
188100     PERFORM Y215-SOURCE-SECURITY
188200                                 THRU Y219-EXIT.
188300*
188400     IF  MM14-PROD-SOURCE-L IS GREATER THAN ZERO
188500         MOVE DFHBMASF           TO MM14-PROD-SOURCE-A
188600     ELSE
188700         MOVE MMMP-PROD-SOURCE   TO MM14-PROD-SOURCE.
188800*
188900     IF  MBCA-PTI-FUNCTION-IS-MAINT
189000     OR  MM14-PROD-SOURCE-L IS GREATER THAN ZERO
189100     OR  NOT MMFS-MT-REQUIRED (X-MMFS-MERCH)
189200         GO TO W219-EXIT.
189300*
189400 W218-SOURCE-ERROR.
189500*
189600     IF  MM14-PROD-SOURCE-L IS GREATER THAN ZERO
189700         MOVE DFHBMUBF           TO MM14-PROD-SOURCE-A
189800     ELSE
189900         MOVE DFHBMBRY           TO MM14-PROD-SOURCE-A.
190000*
190100     SET SS08WS-ERROR-SW-YES     TO TRUE.
190200     MOVE DFHBMASB               TO MM14-PROD-SOURCE-LP-A
190300                                    MM14-PROD-SOURCE-RP-A.
190400     MOVE SS08WS-CURSOR          TO MM14-PROD-SOURCE-L.
190500*
190600 W219-EXIT.
190700     EXIT.
190800*
190900 W230-EDIT-RESV-2-FEE-BASE.
191000*
191100     SET  X-MMMP-PROD-RESV       TO 2.
191200*
191300     IF  MMMM-RL-MERCHANT (2)
191400         MOVE DFHBMDAS           TO MM14-PROD-RESV-2-FEE-BASE-LP-A
191500                                    MM14-PROD-RESV-2-FEE-BASE-RP-A
191600                                    MM14-PROD-RESV-2-FEE-BASE-A
191700                                    MM14-PROD-RESERVE-2-LIT-A
191800         MOVE ZERO               TO MM14-PROD-RESV-2-FEE-BASE-L
191900         GO TO W239-EXIT.
192000*
192100     MOVE DFHBMDAS               TO MM14-PROD-RESV-2-FEE-BASE-LP-A
192200                                   MM14-PROD-RESV-2-FEE-BASE-RP-A.
192300     MOVE DFHBMASK               TO MM14-PROD-RESV-2-FEE-BASE-A.
192400*
192500     PERFORM Y235-RESV-2-FEE-BASE-SECURITY
192600                                 THRU Y239-EXIT.
192700*
192800     IF  MM14-PROD-RESV-2-FEE-BASE-L IS GREATER THAN ZERO
192900         MOVE DFHBMASF           TO MM14-PROD-RESV-2-FEE-BASE-A
193000     ELSE
193100         MOVE MMMP-PROD-RESV-FEE-BASE (X-MMMP-PROD-RESV)
193200                                 TO MM14-PROD-RESV-2-FEE-BASE.
193300*
193400     IF  MM14-PR2FB-VALID
193500         NEXT SENTENCE
193600     ELSE
193700         GO TO W238-RESV-2-FEE-BASE-ERROR.
193800*
193900     IF  MBCA-PTI-FUNCTION-IS-MAINT
194000     OR  MM14-PROD-RESV-2-FEE-BASE-L IS GREATER THAN ZERO
194100     OR  NOT MMFS-MT-REQUIRED (X-MMFS-MERCH)
194200         GO TO W239-EXIT.
194300*
194400 W238-RESV-2-FEE-BASE-ERROR.
194500*
194600     IF  MM14-PROD-RESV-2-FEE-BASE-L IS GREATER THAN ZERO
194700         MOVE DFHBMUBF           TO MM14-PROD-RESV-2-FEE-BASE-A
194800     ELSE
194900         MOVE DFHBMBRY           TO MM14-PROD-RESV-2-FEE-BASE-A.
195000*
195100     SET SS08WS-ERROR-SW-YES     TO TRUE.
195200     MOVE DFHBMASB               TO MM14-PROD-RESV-2-FEE-BASE-LP-A
195300                                   MM14-PROD-RESV-2-FEE-BASE-RP-A.
195400     MOVE SS08WS-CURSOR          TO MM14-PROD-RESV-2-FEE-BASE-L.
195500*
195600 W239-EXIT.
195700     EXIT.
195800*
195900 W250-EDIT-RESV-2-TABLE.
196000*
196100     SET X-MMMM-RESV             TO 2.
196200     SET X-MMMP-PROD-RESV        TO 2.
196300*
196400     IF  MMMM-RL-MERCHANT (X-MMMM-RESV)
196500         MOVE DFHBMDAS           TO MM14-PROD-RESV-2-RATE-TBL-LP-A
196600                                    MM14-PROD-RESV-2-RATE-TBL-RP-A
196700                                    MM14-PROD-RESV-2-RATE-TBL-A
196800                                    MM14-PROD-RESERVE-2-LIT-A
196900         MOVE ZERO               TO MM14-PROD-RESV-2-RATE-TBL-L
197000         GO TO W259-EXIT.
197100*
197200     MOVE DFHBMDAS               TO MM14-PROD-RESV-2-RATE-TBL-LP-A
197300                                   MM14-PROD-RESV-2-RATE-TBL-RP-A.
197400     MOVE DFHBMASK               TO MM14-PROD-RESV-2-RATE-TBL-A.
197500*
197600     PERFORM Y255-RESV-2-RATE-TBL-SECURITY
197700                                 THRU Y259-EXIT.
197800*
197900     IF  MM14-PROD-RESV-2-RATE-TBL-L IS GREATER THAN ZERO
198000         MOVE DFHBMASF           TO MM14-PROD-RESV-2-RATE-TBL-A
198100     ELSE
198200         MOVE MMMP-PROD-RESV-RATE-TABLE (X-MMMP-PROD-RESV)
198300                                 TO MM14-PROD-RESV-2-RATE-TBL.
198400*
198500     IF  MM14-PROD-RESV-2-RATE-TBL IS NUMERIC
198600         NEXT SENTENCE
198700     ELSE
198800         GO TO W258-RESV-2-RATE-TBL-ERROR.
198900*
199000     IF  MM14-PROD-RESV-2-RATE-TBL IS EQUAL TO ZEROS
199100         GO TO W255-CONTINUE
199200     ELSE
199300         MOVE MM14-PROD-RESV-2-RATE-TBL
199400                                 TO MBIOWS-MMRT-TABLE-NBR
199500         SET MBIOWS-MMRT-TT-RESERVE
199600                                 TO TRUE
199700         PERFORM Y930-READ-MMRT  THRU Y939-RRT-EXIT
199800         IF SS08WS-RC-FC-NOTFND
199900         OR MMRT-REC-INCOMPLETE
200000         OR  MMRT-REC-PURGED
200100         OR  MMRT-REC-INACTIVE
200200         OR MMRT-ADD-PENDING
200300             GO TO W258-RESV-2-RATE-TBL-ERROR.
200400*
200500     IF  MMRT-TT-RESERVE
200600         NEXT SENTENCE
200700     ELSE
200800         GO TO W258-RESV-2-RATE-TBL-ERROR.
200900*
201000     IF  MMRT-PRODUCT-LEVEL
201100         NEXT SENTENCE
201200     ELSE
201300         GO TO W258-RESV-2-RATE-TBL-ERROR.
201400*
201500     MOVE MMRT-METHOD            TO MMRTWS-METHOD.
201600*
201700     IF  MMRTWS-VALID-AT-PRODUCT-LEVEL
201800         NEXT SENTENCE
201900     ELSE
202000         GO TO W258-RESV-2-RATE-TBL-ERROR.
202100*
202200     EVALUATE TRUE
202300         WHEN (MMRTWS-DTD-VOLUME-W-CR-PLAN
202400           OR MMRTWS-PTD-VOLUME-W-CR-PLAN
202500           OR MMRTWS-RESV-PCT-ON-VOL-PLAN)
202600           IF  MMOC-CP-MERCH-NO
202700               GO TO W258-RESV-2-RATE-TBL-ERROR
202800           END-IF
202900     END-EVALUATE.
203000*
203100 W255-CONTINUE.
203200*
203300     IF  MBCA-PTI-FUNCTION-IS-MAINT
203400     OR  MM14-PROD-RESV-2-RATE-TBL-L IS GREATER THAN ZERO
203500     OR  NOT MMFS-MT-REQUIRED (X-MMFS-MERCH)
203600         GO TO W259-EXIT.
203700*
203800 W258-RESV-2-RATE-TBL-ERROR.
203900*
204000     IF  MM14-PROD-RESV-2-RATE-TBL-L IS GREATER THAN ZERO
204100         MOVE DFHBMNBF           TO MM14-PROD-RESV-2-RATE-TBL-A
204200     ELSE
204300         MOVE DFHBMUNB           TO MM14-PROD-RESV-2-RATE-TBL-A.
204400*
204500     SET SS08WS-ERROR-SW-YES     TO TRUE.
204600     MOVE DFHBMASB               TO MM14-PROD-RESV-2-RATE-TBL-LP-A
204700                                   MM14-PROD-RESV-2-RATE-TBL-RP-A.
204800     MOVE SS08WS-CURSOR          TO MM14-PROD-RESV-2-RATE-TBL-L.
204900*
205000 W259-EXIT.
205100     EXIT.
205200*
205300 W270-EDIT-SHORT-DESC.
205400*
205500     MOVE DFHBMDAS               TO MM14-PROD-SHORT-DESC-LP-A
205600                                    MM14-PROD-SHORT-DESC-RP-A.
205700     MOVE DFHBMASK               TO MM14-PROD-SHORT-DESC-A.
205800*
205900     PERFORM Y275-SHORT-DESC-SECURITY
206000                                 THRU Y279-EXIT.
206100*
206200     IF  MM14-PROD-SHORT-DESC-L IS GREATER THAN ZERO
206300         MOVE DFHBMASF           TO MM14-PROD-SHORT-DESC-A
206400     ELSE
206500         MOVE MMMP-PROD-SHORT-DESC
206600                                 TO MM14-PROD-SHORT-DESC.
206700*
206800     IF  MBCA-PTI-FUNCTION-IS-MAINT
206900     OR  MM14-PROD-SHORT-DESC-L IS GREATER THAN ZERO
207000     OR  NOT MMFS-MT-REQUIRED (X-MMFS-MERCH)
207100         GO TO W279-EXIT.
207200*
207300 W278-SHORT-DESC-ERROR.
207400*
207500     IF  MM14-PROD-SHORT-DESC-L IS GREATER THAN ZERO
207600         MOVE DFHBMUBF           TO MM14-PROD-SHORT-DESC-A
207700     ELSE
207800         MOVE DFHBMBRY           TO MM14-PROD-SHORT-DESC-A.
207900*
208000     SET SS08WS-ERROR-SW-YES     TO TRUE.
208100     MOVE DFHBMASB               TO MM14-PROD-SHORT-DESC-LP-A
208200                                    MM14-PROD-SHORT-DESC-RP-A.
208300     MOVE SS08WS-CURSOR          TO MM14-PROD-SHORT-DESC-L.
208400*
208500 W279-EXIT.
208600     EXIT.
208700*
208800 W290-EDIT-RESV-3-FEE-BASE.
208900*
209000     SET  X-MMMP-PROD-RESV       TO 3.
209100*
209200     IF  MMMM-RL-MERCHANT (3)
209300         MOVE DFHBMDAS           TO MM14-PROD-RESV-3-FEE-BASE-LP-A
209400                                    MM14-PROD-RESV-3-FEE-BASE-RP-A
209500                                    MM14-PROD-RESV-3-FEE-BASE-A
209600                                    MM14-PROD-RESERVE-3-LIT-A
209700         MOVE ZERO               TO MM14-PROD-RESV-3-FEE-BASE-L
209800         GO TO W299-EXIT.
209900*
210000     MOVE DFHBMDAS               TO MM14-PROD-RESV-3-FEE-BASE-LP-A
210100                                   MM14-PROD-RESV-3-FEE-BASE-RP-A.
210200     MOVE DFHBMASK               TO MM14-PROD-RESV-3-FEE-BASE-A.
210300*
210400     PERFORM Y295-RESV-3-FEE-BASE-SECURITY
210500                                 THRU Y299-EXIT.
210600*
210700     IF  MM14-PROD-RESV-3-FEE-BASE-L IS GREATER THAN ZERO
210800         MOVE DFHBMASF           TO MM14-PROD-RESV-3-FEE-BASE-A
210900     ELSE
211000         MOVE MMMP-PROD-RESV-FEE-BASE (X-MMMP-PROD-RESV)
211100                                 TO MM14-PROD-RESV-3-FEE-BASE.
211200*
211300     IF  MM14-PR3FB-VALID
211400         NEXT SENTENCE
211500     ELSE
211600         GO TO W298-RESV-3-FEE-BASE-ERROR.
211700*
211800     IF  MBCA-PTI-FUNCTION-IS-MAINT
211900     OR  MM14-PROD-RESV-3-FEE-BASE-L IS GREATER THAN ZERO
212000     OR  NOT MMFS-MT-REQUIRED (X-MMFS-MERCH)
212100         GO TO W299-EXIT.
212200*
212300 W298-RESV-3-FEE-BASE-ERROR.
212400*
212500     IF  MM14-PROD-RESV-3-FEE-BASE-L IS GREATER THAN ZERO
212600         MOVE DFHBMUBF           TO MM14-PROD-RESV-3-FEE-BASE-A
212700     ELSE
212800         MOVE DFHBMBRY           TO MM14-PROD-RESV-3-FEE-BASE-A.
212900*
213000     SET SS08WS-ERROR-SW-YES     TO TRUE.
213100     MOVE DFHBMASB               TO MM14-PROD-RESV-3-FEE-BASE-LP-A
213200                                   MM14-PROD-RESV-3-FEE-BASE-RP-A.
213300     MOVE SS08WS-CURSOR          TO MM14-PROD-RESV-3-FEE-BASE-L.
213400*
213500 W299-EXIT.
213600     EXIT.
213700*
213800 W310-EDIT-RESV-3-TABLE.
213900*
214000     SET X-MMMM-RESV             TO 3.
214100     SET X-MMMP-PROD-RESV        TO 3.
214200*
214300     IF  MMMM-RL-MERCHANT (X-MMMM-RESV)
214400         MOVE DFHBMDAS           TO MM14-PROD-RESV-3-RATE-TBL-LP-A
214500                                    MM14-PROD-RESV-3-RATE-TBL-RP-A
214600                                    MM14-PROD-RESV-3-RATE-TBL-A
214700                                    MM14-PROD-RESERVE-3-LIT-A
214800         MOVE ZERO               TO MM14-PROD-RESV-3-RATE-TBL-L
214900         GO TO W319-EXIT.
215000*
215100     MOVE DFHBMDAS               TO MM14-PROD-RESV-3-RATE-TBL-LP-A
215200                                   MM14-PROD-RESV-3-RATE-TBL-RP-A.
215300     MOVE DFHBMASK               TO MM14-PROD-RESV-3-RATE-TBL-A.
215400*
215500     PERFORM Y315-RESV-3-RATE-TBL-SECURITY
215600                                 THRU Y319-EXIT.
215700*
215800     IF  MM14-PROD-RESV-3-RATE-TBL-L IS GREATER THAN ZERO
215900         MOVE DFHBMASF           TO MM14-PROD-RESV-3-RATE-TBL-A
216000     ELSE
216100         MOVE MMMP-PROD-RESV-RATE-TABLE (X-MMMP-PROD-RESV)
216200                                 TO MM14-PROD-RESV-3-RATE-TBL.
216300*
216400     IF  MM14-PROD-RESV-3-RATE-TBL IS NUMERIC
216500         NEXT SENTENCE
216600     ELSE
216700         GO TO W318-RESV-3-RATE-TBL-ERROR.
216800*
216900     IF  MM14-PROD-RESV-3-RATE-TBL IS EQUAL TO ZEROS
217000         GO TO W315-CONTINUE
217100     ELSE
217200         MOVE MM14-PROD-RESV-3-RATE-TBL
217300                                 TO MBIOWS-MMRT-TABLE-NBR
217400         SET MBIOWS-MMRT-TT-RESERVE
217500                                 TO TRUE
217600         PERFORM Y930-READ-MMRT  THRU Y939-RRT-EXIT
217700         IF SS08WS-RC-FC-NOTFND
217800         OR MMRT-REC-INCOMPLETE
217900         OR  MMRT-REC-PURGED
218000         OR  MMRT-REC-INACTIVE
218100         OR MMRT-ADD-PENDING
218200             GO TO W318-RESV-3-RATE-TBL-ERROR.
218300*
218400     IF  MMRT-TT-RESERVE
218500         NEXT SENTENCE
218600     ELSE
218700         GO TO W318-RESV-3-RATE-TBL-ERROR.
218800*
218900     IF  MMRT-PRODUCT-LEVEL
219000         NEXT SENTENCE
219100     ELSE
219200         GO TO W318-RESV-3-RATE-TBL-ERROR.
219300*
219400     MOVE MMRT-METHOD            TO MMRTWS-METHOD.
219500*
219600     IF  MMRTWS-VALID-AT-PRODUCT-LEVEL
219700         NEXT SENTENCE
219800     ELSE
219900         GO TO W318-RESV-3-RATE-TBL-ERROR.
220000*
220100     EVALUATE TRUE
220200         WHEN (MMRTWS-DTD-VOLUME-W-CR-PLAN
220300           OR MMRTWS-PTD-VOLUME-W-CR-PLAN
220400           OR MMRTWS-RESV-PCT-ON-VOL-PLAN)
220500           IF  MMOC-CP-MERCH-NO
220600               GO TO W318-RESV-3-RATE-TBL-ERROR
220700           END-IF
220800     END-EVALUATE.
220900*
221000 W315-CONTINUE.
221100*
221200     IF  MBCA-PTI-FUNCTION-IS-MAINT
221300     OR  MM14-PROD-RESV-3-RATE-TBL-L IS GREATER THAN ZERO
221400     OR  NOT MMFS-MT-REQUIRED (X-MMFS-MERCH)
221500         GO TO W319-EXIT.
221600*
221700 W318-RESV-3-RATE-TBL-ERROR.
221800*
221900     IF  MM14-PROD-RESV-3-RATE-TBL-L IS GREATER THAN ZERO
222000         MOVE DFHBMNBF           TO MM14-PROD-RESV-3-RATE-TBL-A
222100     ELSE
222200         MOVE DFHBMUNB           TO MM14-PROD-RESV-3-RATE-TBL-A.
222300*
222400     SET SS08WS-ERROR-SW-YES     TO TRUE.
222500     MOVE DFHBMASB               TO MM14-PROD-RESV-3-RATE-TBL-LP-A
222600                                   MM14-PROD-RESV-3-RATE-TBL-RP-A.
222700     MOVE SS08WS-CURSOR          TO MM14-PROD-RESV-3-RATE-TBL-L.
222800*
222900 W319-EXIT.
223000     EXIT.
223100*
223200 W330-EDIT-RESV-4-FEE-BASE.
223300*
223400     SET  X-MMMP-PROD-RESV       TO 4.
223500*
223600     IF  MMMM-RL-MERCHANT (4)
223700         MOVE DFHBMDAS           TO MM14-PROD-RESV-4-FEE-BASE-LP-A
223800                                    MM14-PROD-RESV-4-FEE-BASE-RP-A
223900                                    MM14-PROD-RESV-4-FEE-BASE-A
224000                                    MM14-PROD-RESERVE-4-LIT-A
224100         MOVE ZERO               TO MM14-PROD-RESV-4-FEE-BASE-L
224200         GO TO W339-EXIT.
224300*
224400     MOVE DFHBMDAS               TO MM14-PROD-RESV-4-FEE-BASE-LP-A
224500                                   MM14-PROD-RESV-4-FEE-BASE-RP-A.
224600     MOVE DFHBMASK               TO MM14-PROD-RESV-4-FEE-BASE-A.
224700*
224800     PERFORM Y335-RESV-4-FEE-BASE-SECURITY
224900                                 THRU Y339-EXIT.
225000*
225100     IF  MM14-PROD-RESV-4-FEE-BASE-L IS GREATER THAN ZERO
225200         MOVE DFHBMASF           TO MM14-PROD-RESV-4-FEE-BASE-A
225300     ELSE
225400         MOVE MMMP-PROD-RESV-FEE-BASE (X-MMMP-PROD-RESV)
225500                                 TO MM14-PROD-RESV-4-FEE-BASE.
225600*
225700     IF  MM14-PR4FB-VALID
225800         NEXT SENTENCE
225900     ELSE
226000         GO TO W338-RESV-4-FEE-BASE-ERROR.
226100*
226200     IF  MBCA-PTI-FUNCTION-IS-MAINT
226300     OR  MM14-PROD-RESV-4-FEE-BASE-L IS GREATER THAN ZERO
226400     OR  NOT MMFS-MT-REQUIRED (X-MMFS-MERCH)
226500         GO TO W339-EXIT.
226600*
226700 W338-RESV-4-FEE-BASE-ERROR.
226800*
226900     IF  MM14-PROD-RESV-4-FEE-BASE-L IS GREATER THAN ZERO
227000         MOVE DFHBMUBF           TO MM14-PROD-RESV-4-FEE-BASE-A
227100     ELSE
227200         MOVE DFHBMBRY           TO MM14-PROD-RESV-4-FEE-BASE-A.
227300*
227400     SET SS08WS-ERROR-SW-YES     TO TRUE.
227500     MOVE DFHBMASB               TO MM14-PROD-RESV-4-FEE-BASE-LP-A
227600                                   MM14-PROD-RESV-4-FEE-BASE-RP-A.
227700     MOVE SS08WS-CURSOR          TO MM14-PROD-RESV-4-FEE-BASE-L.
227800*
227900 W339-EXIT.
228000     EXIT.
228100*
228200 W350-EDIT-RESV-4-TABLE.
228300*
228400     SET X-MMMM-RESV             TO 4.
228500     SET X-MMMP-PROD-RESV        TO 4.
228600*
228700     IF  MMMM-RL-MERCHANT (X-MMMM-RESV)
228800         MOVE DFHBMDAS           TO MM14-PROD-RESV-4-RATE-TBL-LP-A
228900                                    MM14-PROD-RESV-4-RATE-TBL-RP-A
229000                                    MM14-PROD-RESV-4-RATE-TBL-A
229100                                    MM14-PROD-RESERVE-4-LIT-A
229200         MOVE ZERO               TO MM14-PROD-RESV-4-RATE-TBL-L
229300         GO TO W359-EXIT.
229400*
229500     MOVE DFHBMDAS               TO MM14-PROD-RESV-4-RATE-TBL-LP-A
229600                                   MM14-PROD-RESV-4-RATE-TBL-RP-A.
229700     MOVE DFHBMASK               TO MM14-PROD-RESV-4-RATE-TBL-A.
229800*
229900     PERFORM Y355-RESV-4-RATE-TBL-SECURITY
230000                                 THRU Y359-EXIT.
230100*
230200     IF  MM14-PROD-RESV-4-RATE-TBL-L IS GREATER THAN ZERO
230300         MOVE DFHBMASF           TO MM14-PROD-RESV-4-RATE-TBL-A
230400     ELSE
230500         MOVE MMMP-PROD-RESV-RATE-TABLE (X-MMMP-PROD-RESV)
230600                                 TO MM14-PROD-RESV-4-RATE-TBL.
230700*
230800     IF  MM14-PROD-RESV-4-RATE-TBL IS NUMERIC
230900         NEXT SENTENCE
231000     ELSE
231100         GO TO W358-RESV-4-RATE-TBL-ERROR.
231200*
231300     IF  MM14-PROD-RESV-4-RATE-TBL IS EQUAL TO ZEROS
231400         GO TO W355-CONTINUE
231500     ELSE
231600         MOVE MM14-PROD-RESV-4-RATE-TBL
231700                                 TO MBIOWS-MMRT-TABLE-NBR
231800         SET MBIOWS-MMRT-TT-RESERVE
231900                                 TO TRUE
232000         PERFORM Y930-READ-MMRT  THRU Y939-RRT-EXIT
232100         IF SS08WS-RC-FC-NOTFND
232200         OR MMRT-REC-INCOMPLETE
232300         OR  MMRT-REC-PURGED
232400         OR  MMRT-REC-INACTIVE
232500         OR MMRT-ADD-PENDING
232600             GO TO W358-RESV-4-RATE-TBL-ERROR.
232700*
232800     IF  MMRT-TT-RESERVE
232900         NEXT SENTENCE
233000     ELSE
233100         GO TO W358-RESV-4-RATE-TBL-ERROR.
233200*
233300     IF  MMRT-PRODUCT-LEVEL
233400         NEXT SENTENCE
233500     ELSE
233600         GO TO W358-RESV-4-RATE-TBL-ERROR.
233700*
233800     MOVE MMRT-METHOD            TO MMRTWS-METHOD.
233900*
234000     IF  MMRTWS-VALID-AT-PRODUCT-LEVEL
234100         NEXT SENTENCE
234200     ELSE
234300         GO TO W358-RESV-4-RATE-TBL-ERROR.
234400*
234500     EVALUATE TRUE
234600         WHEN (MMRTWS-DTD-VOLUME-W-CR-PLAN
234700           OR MMRTWS-PTD-VOLUME-W-CR-PLAN
234800           OR MMRTWS-RESV-PCT-ON-VOL-PLAN)
234900           IF  MMOC-CP-MERCH-NO
235000               GO TO W358-RESV-4-RATE-TBL-ERROR
235100           END-IF
235200     END-EVALUATE.
235300*
235400 W355-CONTINUE.
235500*
235600     IF  MBCA-PTI-FUNCTION-IS-MAINT
235700     OR  MM14-PROD-RESV-4-RATE-TBL-L IS GREATER THAN ZERO
235800     OR  NOT MMFS-MT-REQUIRED (X-MMFS-MERCH)
235900         GO TO W359-EXIT.
236000*
236100 W358-RESV-4-RATE-TBL-ERROR.
236200*
236300     IF  MM14-PROD-RESV-4-RATE-TBL-L IS GREATER THAN ZERO
236400         MOVE DFHBMNBF           TO MM14-PROD-RESV-4-RATE-TBL-A
236500     ELSE
236600         MOVE DFHBMUNB           TO MM14-PROD-RESV-4-RATE-TBL-A.
236700*
236800     SET SS08WS-ERROR-SW-YES     TO TRUE.
236900     MOVE DFHBMASB               TO MM14-PROD-RESV-4-RATE-TBL-LP-A
237000                                   MM14-PROD-RESV-4-RATE-TBL-RP-A.
237100     MOVE SS08WS-CURSOR          TO MM14-PROD-RESV-4-RATE-TBL-L.
237200*
237300 W359-EXIT.
237400     EXIT.
237500*
237600 W370-EDIT-USER-CODE.
237700*
237800     MOVE DFHBMDAS               TO MM14-PROD-USER-CODE-LP-A
237900                                    MM14-PROD-USER-CODE-RP-A.
238000     MOVE DFHBMASK               TO MM14-PROD-USER-CODE-A.
238100*
238200     PERFORM Y375-USER-CODE-SECURITY
238300                                 THRU Y379-EXIT.
238400*
238500     IF  MM14-PROD-USER-CODE-L IS GREATER THAN ZERO
238600         MOVE DFHBMASF           TO MM14-PROD-USER-CODE-A
238700     ELSE
238800         MOVE MMMP-PROD-USER-CODE
238900                                 TO MM14-PROD-USER-CODE.
239000*
239100     IF  MBCA-PTI-FUNCTION-IS-MAINT
239200     OR  MM14-PROD-USER-CODE-L IS GREATER THAN ZERO
239300     OR  NOT MMFS-MT-REQUIRED (X-MMFS-MERCH)
239400         GO TO W379-EXIT.
239500*
239600 W378-USER-CODE-ERROR.
239700*
239800     IF  MM14-PROD-USER-CODE-L IS GREATER THAN ZERO
239900         MOVE DFHBMUBF           TO MM14-PROD-USER-CODE-A
240000     ELSE
240100         MOVE DFHBMBRY           TO MM14-PROD-USER-CODE-A.
240200*
240300     SET SS08WS-ERROR-SW-YES     TO TRUE.
240400     MOVE DFHBMASB               TO MM14-PROD-USER-CODE-LP-A
240500                                    MM14-PROD-USER-CODE-RP-A.
240600     MOVE SS08WS-CURSOR          TO MM14-PROD-USER-CODE-L.
240700*
240800 W379-EXIT.
240900     EXIT.
241000*
241100 W390-EDIT-INTCHG-FEE-BASE.
241200*
241300     MOVE DFHBMDAS               TO MM14-PROD-INTCHG-FEE-BASE-LP-A
241400                                   MM14-PROD-INTCHG-FEE-BASE-RP-A.
241500     MOVE DFHBMASK               TO MM14-PROD-INTCHG-FEE-BASE-A.
241600*
241700     PERFORM Y395-INTCHG-FEE-BASE-SECURITY
241800                                 THRU Y399-EXIT.
241900*
242000     IF  MM14-PROD-INTCHG-FEE-BASE-L IS GREATER THAN ZERO
242100         MOVE DFHBMASF           TO MM14-PROD-INTCHG-FEE-BASE-A
242200     ELSE
242300         MOVE MMMP-PROD-INTCHG-FEE-BASE
242400                                 TO MM14-PROD-INTCHG-FEE-BASE.
242500*
242600     IF  MM14-PIFB-VALID
242700         NEXT SENTENCE
242800     ELSE
242900         GO TO W398-INTCHG-FEE-BASE-ERROR.
243000*
243100     IF  MBCA-PTI-FUNCTION-IS-MAINT
243200     OR  MM14-PROD-INTCHG-FEE-BASE-L IS GREATER THAN ZERO
243300     OR  NOT MMFS-MT-REQUIRED (X-MMFS-MERCH)
243400         GO TO W399-EXIT.
243500*
243600 W398-INTCHG-FEE-BASE-ERROR.
243700*
243800     IF  MM14-PROD-INTCHG-FEE-BASE-L IS GREATER THAN ZERO
243900         MOVE DFHBMUBF           TO MM14-PROD-INTCHG-FEE-BASE-A
244000     ELSE
244100         MOVE DFHBMBRY           TO MM14-PROD-INTCHG-FEE-BASE-A.
244200*
244300     SET SS08WS-ERROR-SW-YES     TO TRUE.
244400     MOVE DFHBMASB               TO MM14-PROD-INTCHG-FEE-BASE-LP-A
244500                                   MM14-PROD-INTCHG-FEE-BASE-RP-A.
244600     MOVE SS08WS-CURSOR          TO MM14-PROD-INTCHG-FEE-BASE-L.
244700*
244800 W399-EXIT.
244900     EXIT.
245000*
245100 W410-EDIT-DBA-NAME.
245200*
245300     MOVE DFHBMDAS               TO MM14-VI-DBA-NAME-LP-A
245400                                    MM14-VI-DBA-NAME-RP-A.
245500     MOVE DFHBMASK               TO MM14-VI-DBA-NAME-A.
245600*
245700     PERFORM Y415-DBA-NAME-SECURITY
245800                                 THRU Y419-EXIT.
245900*
246000     IF  MM14-VI-DBA-NAME-L IS GREATER THAN ZERO
246100         MOVE DFHBMASF           TO MM14-VI-DBA-NAME-A
246200         EVALUATE TRUE
246300           WHEN MM14-VI-DBA-NAME IS EQUAL TO SPACES
246400             CONTINUE
246500           WHEN MM14-VI-DBA-NAME (1:1)
246600                                 IS EQUAL TO SPACE
246700             GO TO W418-DBA-NAME-ERROR
246800           WHEN OTHER
246900             CONTINUE
247000         END-EVALUATE
247100     ELSE
247200         MOVE MMSM-VI-DBA-NAME   TO MM14-VI-DBA-NAME.
247300*
247400     IF  MM14-VI-DBA-NAME IS EQUAL TO SPACES
247500         MOVE MMMM-DBA-NAME      TO MM14-VI-DBA-NAME
247600         MOVE +25                TO MM14-VI-DBA-NAME-L.
247700*
247800     IF  MBCA-PTI-FUNCTION-IS-MAINT
247900     OR  MM14-VI-DBA-NAME-L IS GREATER THAN ZERO
248000     OR  NOT MMFS-ST-REQUIRED (X-MMFS-STORE)
248100         GO TO W419-EXIT.
248200*
248300 W418-DBA-NAME-ERROR.
248400*
248500     IF  MM14-VI-DBA-NAME-L IS GREATER THAN ZERO
248600         MOVE DFHBMUBF           TO MM14-VI-DBA-NAME-A
248700     ELSE
248800         MOVE DFHBMBRY           TO MM14-VI-DBA-NAME-A.
248900*
249000     SET SS08WS-ERROR-SW-YES     TO TRUE.
249100     MOVE DFHBMASB               TO MM14-VI-DBA-NAME-LP-A
249200                                    MM14-VI-DBA-NAME-RP-A.
249300     MOVE SS08WS-CURSOR          TO MM14-VI-DBA-NAME-L.
249400*
249500 W419-EXIT.
249600     EXIT.
249700*
249800 W450-EDIT-INTCHG-IND.
249900*
250000     MOVE DFHBMDAS               TO MM14-VI-INTCHG-FLAG-LP-A
250100                                    MM14-VI-INTCHG-FLAG-RP-A.
250200     MOVE DFHBMASK               TO MM14-VI-INTCHG-FLAG-A.
250300*
250400     PERFORM Y455-INTCHG-FLAG-SECURITY
250500                                 THRU Y459-EXIT.
250600*
250700     IF  MM14-VI-INTCHG-FLAG-L IS GREATER THAN ZERO
250800         MOVE DFHBMASF           TO MM14-VI-INTCHG-FLAG-A
250900     ELSE
251000         MOVE MMSM-VI-INTCHG-FLAG
251100                                 TO MM14-VI-INTCHG-FLAG.
251200*
251300     IF  MM14-VI-INTCHG-FLAG-VALID
251400         NEXT SENTENCE
251500     ELSE
251600         GO TO W458-INTCHG-FLAG-ERROR.
251700*
251800     IF  MBCA-PTI-FUNCTION-IS-MAINT
251900     OR  MM14-VI-INTCHG-FLAG-L IS GREATER THAN ZERO
252000     OR  NOT MMFS-ST-REQUIRED (X-MMFS-STORE)
252100         GO TO W459-EXIT.
252200*
252300 W458-INTCHG-FLAG-ERROR.
252400*
252500     IF  MM14-VI-INTCHG-FLAG-L IS GREATER THAN ZERO
252600         MOVE DFHBMUBF           TO MM14-VI-INTCHG-FLAG-A
252700     ELSE
252800         MOVE DFHBMBRY           TO MM14-VI-INTCHG-FLAG-A.
252900*
253000     SET SS08WS-ERROR-SW-YES     TO TRUE.
253100     MOVE DFHBMASB               TO MM14-VI-INTCHG-FLAG-LP-A
253200                                    MM14-VI-INTCHG-FLAG-RP-A.
253300     MOVE SS08WS-CURSOR          TO MM14-VI-INTCHG-FLAG-L.
253400*
253500 W459-EXIT.
253600     EXIT.
253700*
253800 W470-EDIT-VISA-MEMBER-ID.
253900*
254000     MOVE DFHBMDAS               TO MM14-VI-MEMBER-ID-LP-A
254100                                    MM14-VI-MEMBER-ID-RP-A.
254200     MOVE DFHBMASK               TO MM14-VI-MEMBER-ID-A.
254300*
254400     PERFORM Y475-VI-MEMBER-ID-SECURITY
254500                                 THRU Y479-EXIT.
254600*
254700     GO TO W479-EXIT.
254800*
254900     IF  MM14-VI-MEMBER-ID-L IS GREATER THAN ZERO
255000         MOVE DFHBMASF           TO MM14-VI-MEMBER-ID-A
255100     ELSE
255200         MOVE MMSM-VI-MEMBER-ID  TO MM14-VI-MEMBER-ID.
255300*
255400     IF  MM14-VI-MEMBER-ID IS NOT NUMERIC
255500         GO TO W478-VI-MEMBER-ID-ERROR.
255600*
255700     IF  MBCA-PTI-FUNCTION-IS-MAINT
255800     OR  MM14-VI-MEMBER-ID-L IS GREATER THAN ZERO
255900     OR  NOT MMFS-ST-REQUIRED (X-MMFS-STORE)
256000         GO TO W479-EXIT.
256100*
256200 W478-VI-MEMBER-ID-ERROR.
256300*
256400     IF  MM14-VI-MEMBER-ID-L IS GREATER THAN ZERO
256500         MOVE DFHBMNBF           TO MM14-VI-MEMBER-ID-A
256600     ELSE
256700         MOVE DFHBMUNB           TO MM14-VI-MEMBER-ID-A.
256800*
256900     SET SS08WS-ERROR-SW-YES     TO TRUE.
257000     MOVE DFHBMASB               TO MM14-VI-MEMBER-ID-LP-A
257100                                    MM14-VI-MEMBER-ID-RP-A.
257200     MOVE SS08WS-CURSOR          TO MM14-VI-MEMBER-ID-L.
257300*
257400 W479-EXIT.
257500     EXIT.
257600*
257700 W490-EDIT-SPECIAL-COND-1.
257800*
257900     MOVE DFHBMDAS               TO MM14-VI-SPECIAL-COND-1-LP-A
258000                                    MM14-VI-SPECIAL-COND-1-RP-A.
258100     MOVE DFHBMASK               TO MM14-VI-SPECIAL-COND-1-A.
258200*
258300     PERFORM Y495-SPECIAL-COND-1-SECURITY
258400                                 THRU Y499-EXIT.
258500*
258600     IF  MM14-VI-SPECIAL-COND-1-L IS GREATER THAN ZERO
258700         MOVE DFHBMASF           TO MM14-VI-SPECIAL-COND-1-A
258800     ELSE
258900         MOVE MMSM-VI-SPECIAL-COND-1
259000                                 TO MM14-VI-SPECIAL-COND-1.
259100*
259200     IF  NOT MM14-VALID-SPECIAL-COND-1
259300         GO TO W498-SPECIAL-COND-1-ERROR.
259400*
259500     IF  MBCA-PTI-FUNCTION-IS-MAINT
259600     OR  MM14-VI-SPECIAL-COND-1-L IS GREATER THAN ZERO
259700     OR  NOT MMFS-ST-REQUIRED (X-MMFS-STORE)
259800         GO TO W499-EXIT.
259900*
260000 W498-SPECIAL-COND-1-ERROR.
260100*
260200     IF  MM14-VI-SPECIAL-COND-1-L IS GREATER THAN ZERO
260300         MOVE DFHBMUBF           TO MM14-VI-SPECIAL-COND-1-A
260400     ELSE
260500         MOVE DFHBMBRY           TO MM14-VI-SPECIAL-COND-1-A.
260600*
260700     SET SS08WS-ERROR-SW-YES     TO TRUE.
260800     MOVE DFHBMASB               TO MM14-VI-SPECIAL-COND-1-LP-A
260900                                    MM14-VI-SPECIAL-COND-1-RP-A.
261000     MOVE SS08WS-CURSOR          TO MM14-VI-SPECIAL-COND-1-L.
261100*
261200 W499-EXIT.
261300     EXIT.
261400*
261500 W510-EDIT-SPECIAL-COND-2.
261600*
261700     MOVE DFHBMDAS               TO MM14-VI-SPECIAL-COND-2-LP-A
261800                                    MM14-VI-SPECIAL-COND-2-RP-A.
261900     MOVE DFHBMASK               TO MM14-VI-SPECIAL-COND-2-A.
262000*
262100     PERFORM Y515-SPECIAL-COND-2-SECURITY
262200                                 THRU Y519-EXIT.
262300*
262400     IF  MM14-VI-SPECIAL-COND-2-L IS GREATER THAN ZERO
262500         MOVE DFHBMASF           TO MM14-VI-SPECIAL-COND-2-A
262600     ELSE
262700         MOVE MMSM-VI-SPECIAL-COND-2
262800                                 TO MM14-VI-SPECIAL-COND-2.
262900*
263000     IF  NOT MM14-VALID-SPECIAL-COND-2
263100         GO TO W518-SPECIAL-COND-2-ERROR.
263200*
263300     IF  MBCA-PTI-FUNCTION-IS-MAINT
263400     OR  MM14-VI-SPECIAL-COND-2-L IS GREATER THAN ZERO
263500     OR  NOT MMFS-ST-REQUIRED (X-MMFS-STORE)
263600         GO TO W519-EXIT.
263700*
263800 W518-SPECIAL-COND-2-ERROR.
263900*
264000     IF  MM14-VI-SPECIAL-COND-2-L IS GREATER THAN ZERO
264100         MOVE DFHBMUBF           TO MM14-VI-SPECIAL-COND-2-A
264200     ELSE
264300         MOVE DFHBMBRY           TO MM14-VI-SPECIAL-COND-2-A.
264400*
264500     SET SS08WS-ERROR-SW-YES     TO TRUE.
264600     MOVE DFHBMASB               TO MM14-VI-SPECIAL-COND-2-LP-A
264700                                    MM14-VI-SPECIAL-COND-2-RP-A.
264800     MOVE SS08WS-CURSOR          TO MM14-VI-SPECIAL-COND-2-L.
264900*
265000 W519-EXIT.
265100     EXIT.
265200*
265300 W530-EDIT-MAIL-PHONE-IND.
265400*
265500     MOVE DFHBMDAS               TO MM14-VI-MAIL-PHONE-IND-LP-A
265600                                    MM14-VI-MAIL-PHONE-IND-RP-A.
265700     MOVE DFHBMASK               TO MM14-VI-MAIL-PHONE-IND-A.
265800*
265900     PERFORM Y535-MAIL-PHONE-SECURITY
266000                                 THRU Y539-EXIT.
266100*
266200     IF  MM14-VI-MAIL-PHONE-IND-L IS GREATER THAN ZERO
266300         MOVE DFHBMASF           TO MM14-VI-MAIL-PHONE-IND-A
266400     ELSE
266500         MOVE MMSM-VI-MAIL-PHONE-IND
266600                                 TO MM14-VI-MAIL-PHONE-IND.
266700*
266800     IF  NOT MM14-VALID-MAIL-PHONE-IND
266900         GO TO W538-MAIL-PHONE-IND-ERROR.
267000*
267100     IF  MBCA-PTI-FUNCTION-IS-MAINT
267200     OR  MM14-VI-MAIL-PHONE-IND-L IS GREATER THAN ZERO
267300     OR  NOT MMFS-ST-REQUIRED (X-MMFS-STORE)
267400         GO TO W539-EXIT.
267500*
267600 W538-MAIL-PHONE-IND-ERROR.
267700*
267800     IF  MM14-VI-MAIL-PHONE-IND-L IS GREATER THAN ZERO
267900         MOVE DFHBMUBF           TO MM14-VI-MAIL-PHONE-IND-A
268000     ELSE
268100         MOVE DFHBMBRY           TO MM14-VI-MAIL-PHONE-IND-A.
268200*
268300     SET SS08WS-ERROR-SW-YES     TO TRUE.
268400     MOVE DFHBMASB               TO MM14-VI-MAIL-PHONE-IND-LP-A
268500                                    MM14-VI-MAIL-PHONE-IND-RP-A.
268600     MOVE SS08WS-CURSOR          TO MM14-VI-MAIL-PHONE-IND-L.
268700*
268800 W539-EXIT.
268900     EXIT.
269000*
269100 W550-EDIT-CH-ACCT-IND.
269200*
269300     MOVE DFHBMDAS               TO MM14-VI-CH-TERM-IND-LP-A
269400                                    MM14-VI-CH-TERM-IND-RP-A.
269500     MOVE DFHBMASK               TO MM14-VI-CH-TERM-IND-A.
269600*
269700     PERFORM Y555-CH-TERM-IND-SECURITY
269800                                 THRU Y559-EXIT.
269900*
270000     IF  MM14-VI-CH-TERM-IND-L IS GREATER THAN ZERO
270100         MOVE DFHBMASF           TO MM14-VI-CH-TERM-IND-A
270200     ELSE
270300         MOVE MMSM-VI-CH-TERM-IND
270400                                 TO MM14-VI-CH-TERM-IND.
270500*
270600     IF  NOT MM14-VALID-VI-CH-TERM-IND
270700         GO TO W558-CH-TERM-IND-ERROR.
270800*
270900     IF  MBCA-PTI-FUNCTION-IS-MAINT
271000     OR  MM14-VI-CH-TERM-IND-L IS GREATER THAN ZERO
271100     OR  NOT MMFS-ST-REQUIRED (X-MMFS-STORE)
271200         GO TO W559-EXIT.
271300*
271400 W558-CH-TERM-IND-ERROR.
271500*
271600     IF  MM14-VI-CH-TERM-IND-L IS GREATER THAN ZERO
271700         MOVE DFHBMUBF           TO MM14-VI-CH-TERM-IND-A
271800     ELSE
271900         MOVE DFHBMBRY           TO MM14-VI-CH-TERM-IND-A.
272000*
272100     SET SS08WS-ERROR-SW-YES     TO TRUE.
272200     MOVE DFHBMASB               TO MM14-VI-CH-TERM-IND-LP-A
272300                                    MM14-VI-CH-TERM-IND-RP-A.
272400     MOVE SS08WS-CURSOR          TO MM14-VI-CH-TERM-IND-L.
272500*
272600 W559-EXIT.
272700     EXIT.
272800*
272900 W620-EDIT-RPT-THRESHOLD.
273000*
273100     MOVE DFHBMDAS               TO MM14-VI-RPT-THSHOLD-LP-A
273200                                    MM14-VI-RPT-THSHOLD-RP-A.
273300     MOVE DFHBMASK               TO MM14-VI-RPT-THSHOLD-A.
273400*
273500     PERFORM Y625-RPT-THSHOLD-SECURITY
273600                                 THRU Y629-EXIT.
273700*
273800     IF  MM14-VI-RPT-THSHOLD-L IS GREATER THAN ZERO
273900         MOVE DFHBMASF           TO MM14-VI-RPT-THSHOLD-A
274000     ELSE
274100         MOVE MMSM-VI-RPT-THSHOLD
274200                                 TO MM14-VI-RPT-THSHOLD.
274300*
274400     IF  NOT MM14-VALID-RPT-THSHOLD
274500         GO TO W628-RPT-THSHOLD-ERROR.
274600*
274700     IF  MBCA-PTI-FUNCTION-IS-MAINT
274800     OR  MM14-VI-RPT-THSHOLD-L IS GREATER THAN ZERO
274900     OR  NOT MMFS-ST-REQUIRED (X-MMFS-STORE)
275000         GO TO W629-EXIT.
275100*
275200 W628-RPT-THSHOLD-ERROR.
275300*
275400     IF  MM14-VI-RPT-THSHOLD-L IS GREATER THAN ZERO
275500         MOVE DFHBMUBF           TO MM14-VI-RPT-THSHOLD-A
275600     ELSE
275700         MOVE DFHBMBRY           TO MM14-VI-RPT-THSHOLD-A.
275800*
275900     SET SS08WS-ERROR-SW-YES     TO TRUE.
276000     MOVE DFHBMASB               TO MM14-VI-RPT-THSHOLD-LP-A
276100                                    MM14-VI-RPT-THSHOLD-RP-A.
276200     MOVE SS08WS-CURSOR          TO MM14-VI-RPT-THSHOLD-L.
276300*
276400 W629-EXIT.
276500     EXIT.
276502*                                                                 RG802901
276504 W630-EDIT-CONTACT-IND.                                           RG802901
276506*                                                                 RG802901
276508     MOVE DFHBMDAS               TO MM14-VI-CONTACT-IND-LP-A      RG802901
276510                                    MM14-VI-CONTACT-IND-RP-A.     RG802901
276512     MOVE DFHBMASK               TO MM14-VI-CONTACT-IND-A.        RG802901
276514*                                                                 RG802901
276516     PERFORM Y635-CONTACT-IND-SECURITY                            RG802901
276518                                 THRU Y639-EXIT.                  RG802901
276520*                                                                 RG802901
276522     IF  MM14-VI-CONTACT-IND-L IS GREATER THAN ZERO               RG802901
276524         MOVE DFHBMASF           TO MM14-VI-CONTACT-IND-A         RG802901
276526     ELSE                                                         RG802901
276528         MOVE MMSM-VI-CONTACT-IND                                 RG802901
276530                                 TO MM14-VI-CONTACT-IND.          RG802901
276532*                                                                 RG802901
276534     IF  NOT MM14-VALID-CONTACT-IND                               RG802901
276536         GO TO W638-CONTACT-IND-ERROR.                            RG802901
276538*                                                                 RG802901
276540     IF  MBCA-PTI-FUNCTION-IS-MAINT                               RG802901
276542     OR  MM14-VI-CONTACT-IND-L IS GREATER THAN ZERO               RG802901
276544     OR  NOT MMFS-ST-REQUIRED (X-MMFS-STORE)                      RG802901
276546         GO TO W639-EXIT.                                         RG802901
276548*                                                                 RG802901
276550 W638-CONTACT-IND-ERROR.                                          RG802901
276552*                                                                 RG802901
276554     IF  MM14-VI-CONTACT-IND-L IS GREATER THAN ZERO               RG802901
276556         MOVE DFHBMUBF           TO MM14-VI-CONTACT-IND-A         RG802901
276558     ELSE                                                         RG802901
276560         MOVE DFHBMBRY           TO MM14-VI-CONTACT-IND-A.        RG802901
276562*                                                                 RG802901
276564     SET SS08WS-ERROR-SW-YES     TO TRUE.                         RG802901
276566     MOVE DFHBMASB               TO MM14-VI-CONTACT-IND-LP-A      RG802901
276568                                    MM14-VI-CONTACT-IND-RP-A.     RG802901
276570     MOVE SS08WS-CURSOR          TO MM14-VI-CONTACT-IND-L.        RG802901
276572*                                                                 RG802901
276574 W639-EXIT.                                                       RG802901
276576     EXIT.                                                        RG802901
276600*
276700 W650-EDIT-CRB-REGION.
276800*
276900     MOVE DFHBMDAS               TO MM14-VI-CRB-REGION-LP-A
277000                                    MM14-VI-CRB-REGION-RP-A.
277100     MOVE DFHBMASK               TO MM14-VI-CRB-REGION-A.
277200*
277300     PERFORM Y655-CRB-REGION-SECURITY
277400                                 THRU Y659-EXIT.
277500*
277600     IF  MM14-VI-CRB-REGION-L IS GREATER THAN ZERO
277700         MOVE DFHBMASF           TO MM14-VI-CRB-REGION-A
277800     ELSE
277900         MOVE MMSM-VI-CRB-REGION
278000                                 TO MM14-VI-CRB-REGION.
278100*
278200     IF  MBCA-PTI-FUNCTION-IS-MAINT
278300     OR  MM14-VI-CRB-REGION-L IS GREATER THAN ZERO
278400     OR  NOT MMFS-ST-REQUIRED (X-MMFS-STORE)
278500         GO TO W659-EXIT.
278600*
278700 W658-CRB-REGION-ERROR.
278800*
278900     IF  MM14-VI-CRB-REGION-L IS GREATER THAN ZERO
279000         MOVE DFHBMNBF           TO MM14-VI-CRB-REGION-A
279100     ELSE
279200         MOVE DFHBMUNB           TO MM14-VI-CRB-REGION-A.
279300*
279400     SET SS08WS-ERROR-SW-YES     TO TRUE.
279500     MOVE DFHBMASB               TO MM14-VI-CRB-REGION-LP-A
279600                                    MM14-VI-CRB-REGION-RP-A.
279700     MOVE SS08WS-CURSOR          TO MM14-VI-CRB-REGION-L.
279800*
279900 W659-EXIT.
280000     EXIT.
280100*
280200 W670-EDIT-REG-ADDR-IND1.
280300*
280400     MOVE DFHBMDAS               TO MM14-VI-REG-ADDR-IND-LP-A
280500                                    MM14-VI-REG-ADDR-IND-RP-A.
280600     MOVE DFHBMASK               TO MM14-VI-REG-ADDR-IND1-A.
280700*
280800     PERFORM Y675-REG-ADDR-IND1-SECURITY
280900                                 THRU Y679-EXIT.
281000*
281100     IF  MM14-VI-REG-ADDR-IND1-L IS GREATER THAN ZERO
281200         MOVE DFHBMASF           TO MM14-VI-REG-ADDR-IND1-A
281300     ELSE
281400         MOVE MMSM-VI-REG-ADDR-IND
281500                                 TO MM14-VI-REG-ADDR-IND1.
281600*
281700     IF  MM14-VALID-VI-REG-ADDR-IND1
281800         NEXT SENTENCE
281900     ELSE
282000         GO TO W678-REG-ADDR-IND1-ERROR.
282100*
282200     IF  MBCA-PTI-FUNCTION-IS-MAINT
282300     OR  MM14-VI-REG-ADDR-IND1-L IS GREATER THAN ZERO
282400     OR  NOT MMFS-ST-REQUIRED (X-MMFS-STORE)
282500         GO TO W679-EXIT.
282600*
282700 W678-REG-ADDR-IND1-ERROR.
282800*
282900     IF  MM14-VI-REG-ADDR-IND1-L IS GREATER THAN ZERO
283000         MOVE DFHBMUBF           TO MM14-VI-REG-ADDR-IND1-A
283100     ELSE
283200         MOVE DFHBMBRY           TO MM14-VI-REG-ADDR-IND1-A.
283300*
283400     SET SS08WS-ERROR-SW-YES     TO TRUE.
283500     MOVE DFHBMASB               TO MM14-VI-REG-ADDR-IND-LP-A
283600                                    MM14-VI-REG-ADDR-IND-RP-A.
283700     MOVE SS08WS-CURSOR          TO MM14-VI-REG-ADDR-IND1-L.
283800*
283900 W679-EXIT.
284000     EXIT.
284100*
284200 W690-EDIT-REG-ADDR-IND2.
284300*
284400     MOVE DFHBMDAS               TO MM14-VI-REG-ADDR-IND-LP-A
284500                                    MM14-VI-REG-ADDR-IND-RP-A.
284600     MOVE DFHBMASK               TO MM14-VI-REG-ADDR-IND2-A.
284700*
284800     PERFORM Y695-REG-ADDR-IND2-SECURITY
284900                                 THRU Y699-EXIT.
285000*
285100     IF  MM14-VI-REG-ADDR-IND2-L IS GREATER THAN ZERO
285200         MOVE DFHBMASF           TO MM14-VI-REG-ADDR-IND2-A
285300     ELSE
285400         MOVE MMSM-VI-REG-ADDR-LINE
285500                                 TO MM14-VI-REG-ADDR-IND2.
285600*
285700     IF  MM14-VALID-VI-REG-ADDR-IND2
285800         NEXT SENTENCE
285900     ELSE
286000         GO TO W698-REG-ADDR-IND2-ERROR.
286100*
286200     IF  MBCA-PTI-FUNCTION-IS-MAINT
286300     OR  MM14-VI-REG-ADDR-IND2-L IS GREATER THAN ZERO
286400     OR  NOT MMFS-ST-REQUIRED (X-MMFS-STORE)
286500         GO TO W699-EXIT.
286600*
286700 W698-REG-ADDR-IND2-ERROR.
286800*
286900     IF  MM14-VI-REG-ADDR-IND2-L IS GREATER THAN ZERO
287000         MOVE DFHBMUBF           TO MM14-VI-REG-ADDR-IND2-A
287100     ELSE
287200         MOVE DFHBMBRY           TO MM14-VI-REG-ADDR-IND2-A.
287300*
287400     SET SS08WS-ERROR-SW-YES     TO TRUE.
287500     MOVE DFHBMASB               TO MM14-VI-REG-ADDR-IND-LP-A
287600                                    MM14-VI-REG-ADDR-IND-RP-A.
287700     MOVE SS08WS-CURSOR          TO MM14-VI-REG-ADDR-IND2-L.
287800*
287900 W699-EXIT.
288000     EXIT.
288100*
288200 W710-EDIT-CATEGORY.
288300*
288400     MOVE DFHBMDAS               TO MM14-VI-CATEGORY-CODE-LP-A
288500                                    MM14-VI-CATEGORY-CODE-RP-A.
288600     MOVE DFHBMASK               TO MM14-VI-CATEGORY-CODE-A.
288700*
288800     PERFORM Y715-CATEGORY-CODE-SECURITY
288900                                 THRU Y719-EXIT.
289000*
289100     IF  MM14-VI-CATEGORY-CODE-L IS GREATER THAN ZERO
289200         MOVE DFHBMASF           TO MM14-VI-CATEGORY-CODE-A
289300     ELSE
289400         MOVE MMSM-VI-CATEGORY-CODE
289500                                 TO MM14-VI-CATEGORY-CODE.
289600*
289700     IF  MM14-VI-CATEGORY-CODE IS NOT NUMERIC
289800         GO TO W718-PROD-CATEGORY-ERROR.
289900*
289910     MOVE MM14-VI-CATEGORY-CODE  TO SMCAWS-CATEGORY-CODE.
289914     PERFORM SMCAPXO-OBTAIN-CAT-CODE-DATA
289916        THRU SMCAPXO-OCCD-EXIT.
289918*
289920     IF  SMCAWS-RC-NO-CATEGORY-FOUND
289922         GO TO W718-PROD-CATEGORY-ERROR.
289924*
289926     MOVE SMCAWS-RECORD          TO SMCA-RECORD.
289928*
289930     IF  SMCA-HEADER
289932     OR  SMCA-TRAILER
289934     OR  SMCA-REC-PURGED
289936     OR  SMCA-ADD-PENDING
289938         GO TO W718-PROD-CATEGORY-ERROR.
289940*
289942     IF  SMCA-REC-ACTIVE
289944     AND SMCA-VI-IS-VALID
289946         CONTINUE
289948     ELSE
289950         GO TO W718-PROD-CATEGORY-ERROR.
289952*
290000     IF  MBCA-PTI-FUNCTION-IS-MAINT
290100     OR  MM14-VI-CATEGORY-CODE-L IS GREATER THAN ZERO
290200     OR  NOT MMFS-ST-REQUIRED (X-MMFS-STORE)
290300         GO TO W719-EXIT.
290400*
290500 W718-PROD-CATEGORY-ERROR.
290600*
290700     IF  MM14-VI-CATEGORY-CODE-L IS GREATER THAN ZERO
290800         MOVE DFHBMNBF           TO MM14-VI-CATEGORY-CODE-A
290900     ELSE
291000         MOVE DFHBMUNB           TO MM14-VI-CATEGORY-CODE-A.
291100*
291200     SET SS08WS-ERROR-SW-YES     TO TRUE.
291300     MOVE DFHBMASB               TO MM14-VI-CATEGORY-CODE-LP-A
291400                                    MM14-VI-CATEGORY-CODE-RP-A.
291500     MOVE SS08WS-CURSOR          TO MM14-VI-CATEGORY-CODE-L.
291600*
291700 W719-EXIT.
291800     EXIT.
291900*
292000 W730-EDIT-FLOOR-LIMIT.
292100*
292200     MOVE DFHBMDAS               TO MM14-VI-FLOOR-LIMIT-LP-A
292300                                    MM14-VI-FLOOR-LIMIT-RP-A.
292400     MOVE DFHBMASK               TO MM14-VI-FLOOR-LIMIT-A.
292500*
292600     PERFORM Y735-FLOOR-LIMIT-SECURITY
292700                                 THRU Y739-EXIT.
292800*
292900     IF  MM14-VI-FLOOR-LIMIT-L IS GREATER THAN ZERO
293000         MOVE DFHBMASF           TO MM14-VI-FLOOR-LIMIT-A
293100     ELSE
293200         MOVE MMSM-VI-FLOOR-LIMIT
293300                                 TO MM14-VI-FLOOR-LIMIT.
293400*
293500     IF  MM14-VI-FLOOR-LIMIT IS NOT NUMERIC
293600         GO TO W738-VI-FLOOR-LIMIT-ERROR.
293700*
293800     IF  MBCA-PTI-FUNCTION-IS-MAINT
293900     OR  MM14-VI-FLOOR-LIMIT-L IS GREATER THAN ZERO
294000     OR  NOT MMFS-ST-REQUIRED (X-MMFS-STORE)
294100         GO TO W739-EXIT.
294200*
294300 W738-VI-FLOOR-LIMIT-ERROR.
294400*
294500     IF  MM14-VI-FLOOR-LIMIT-L IS GREATER THAN ZERO
294600         MOVE DFHBMNBF           TO MM14-VI-FLOOR-LIMIT-A
294700     ELSE
294800         MOVE DFHBMUNB           TO MM14-VI-FLOOR-LIMIT-A.
294900*
295000     SET SS08WS-ERROR-SW-YES     TO TRUE.
295100     MOVE DFHBMASB               TO MM14-VI-FLOOR-LIMIT-LP-A
295200                                    MM14-VI-FLOOR-LIMIT-RP-A.
295300     MOVE SS08WS-CURSOR          TO MM14-VI-FLOOR-LIMIT-L.
295400*
295500 W739-EXIT.
295600     EXIT.
295700*
295800 W750-EDIT-VOLUME-IND.
295900*
296000     MOVE DFHBMDAS               TO MM14-VI-VOLUME-IND-LP-A
296100                                    MM14-VI-VOLUME-IND-RP-A.
296200     MOVE DFHBMASK               TO MM14-VI-VOLUME-IND-A.
296300*
296400     PERFORM Y755-VOLUME-IND-SECURITY
296500                                 THRU Y759-EXIT.
296600*
296700     IF  MM14-VI-VOLUME-IND-L IS GREATER THAN ZERO
296800         MOVE DFHBMASF           TO MM14-VI-VOLUME-IND-A
296900     ELSE
297000         MOVE MMSM-VI-VOLUME-IND
297100                                 TO MM14-VI-VOLUME-IND.
297200*
297300     IF  NOT MM14-VALID-VOLUME-IND
297400         GO TO W758-VOLUME-IND-ERROR.
297500*
297600     IF  MBCA-PTI-FUNCTION-IS-MAINT
297700     OR  MM14-VI-VOLUME-IND-L IS GREATER THAN ZERO
297800     OR  NOT MMFS-ST-REQUIRED (X-MMFS-STORE)
297900         GO TO W759-EXIT.
298000*
298100 W758-VOLUME-IND-ERROR.
298200*
298300     IF  MM14-VI-VOLUME-IND-L IS GREATER THAN ZERO
298400         MOVE DFHBMUBF           TO MM14-VI-VOLUME-IND-A
298500     ELSE
298600         MOVE DFHBMBRY           TO MM14-VI-VOLUME-IND-A.
298700*
298800     SET SS08WS-ERROR-SW-YES     TO TRUE.
298900     MOVE DFHBMASB               TO MM14-VI-VOLUME-IND-LP-A
299000                                    MM14-VI-VOLUME-IND-RP-A.
299100     MOVE SS08WS-CURSOR          TO MM14-VI-VOLUME-IND-L.
299200*
299300 W759-EXIT.
299400     EXIT.
299500*
299502 W760-EDIT-SVC-DVLP-IND.                                          RG800914
299504*                                                                 RG800914
299506     MOVE DFHBMDAS               TO MM14-VI-SVC-DVLP-IND-LP-A     RG800914
299508                                    MM14-VI-SVC-DVLP-IND-RP-A.    RG800914
299510     MOVE DFHBMASK               TO MM14-VI-SVC-DVLP-IND-A.       RG800914
299512*                                                                 RG800914
299514     PERFORM Y765-SVC-DVLP-IND                                    RG800914
299516                                 THRU Y769-EXIT.                  RG800914
299518*                                                                 RG800914
299520     IF  MM14-VI-SVC-DVLP-IND-L IS GREATER THAN ZERO              RG800914
299522         MOVE DFHBMASF           TO MM14-VI-SVC-DVLP-IND-A        RG800914
299524     ELSE                                                         RG800914
299526         MOVE MMSM-VI-SVC-DVLP-IND                                RG800914
299528                                 TO MM14-VI-SVC-DVLP-IND.         RG800914
299530*                                                                 RG800914
299532     IF  NOT MM14-VALID-SVC-DVLP-IND                              RG800914
299534         GO TO W768-SVC-DVLP-IND-ERROR.                           RG800914
299536*                                                                 RG800914
299538     IF  MBCA-PTI-FUNCTION-IS-MAINT                               RG800914
299540     OR  MM14-VI-SVC-DVLP-IND-L IS GREATER THAN ZERO              RG800914
299542     OR  NOT MMFS-ST-REQUIRED (X-MMFS-STORE)                      RG800914
299544         GO TO W769-EXIT.                                         RG800914
299546*                                                                 RG800914
299548 W768-SVC-DVLP-IND-ERROR.                                         RG800914
299550*                                                                 RG800914
299552     IF  MM14-VI-SVC-DVLP-IND-L IS GREATER THAN ZERO              RG800914
299554         MOVE DFHBMUBF           TO MM14-VI-SVC-DVLP-IND-A        RG800914
299556     ELSE                                                         RG800914
299558         MOVE DFHBMBRY           TO MM14-VI-SVC-DVLP-IND-A.       RG800914
299560*                                                                 RG800914
299562     SET SS08WS-ERROR-SW-YES     TO TRUE.                         RG800914
299564     MOVE DFHBMASB               TO MM14-VI-SVC-DVLP-IND-LP-A     RG800914
299566                                    MM14-VI-SVC-DVLP-IND-RP-A.    RG800914
299568     MOVE SS08WS-CURSOR          TO MM14-VI-SVC-DVLP-IND-L.       RG800914
299570*                                                                 RG800914
299572 W769-EXIT.                                                       RG800914
299574     EXIT.                                                        RG800914
299600*
299700*
299800 W770-STATUS-X-EDITS.
299900*
300000     IF  SS08WS-ERROR-SW-YES
300100         GO TO W779-EXIT.
300200*
300300     IF  MM14-VI-STATUS-L IS LESS THAN 1
300400         GO TO W779-EXIT.
300500*
300600     IF  MM14-VI-STATUS-ACTIVE
300700         IF  MMOC-PRODUCT-NOT-ACTIVE (1)
300800             GO TO W775-STATUS-ERROR.
300900*
301000     IF  MM14-VI-STATUS-CLOSED
301100     OR  MM14-VI-STATUS-PURGED
301200         IF  MMMP-PROD-NOT-ALLOWED
301300             GO TO W775-STATUS-ERROR
301400         ELSE
301500             IF  MM14-VI-EFF-DATE-L IS EQUAL TO ZERO
301600                 GO TO W775-STATUS-ERROR
301700             ELSE
301800                 IF  MM14-VI-EFF-DATE IS GREATER THAN
301900                     MMMP-PROD-EFF-DATE
302000                 OR  MM14-VI-EFF-DATE IS EQUAL TO
302100                     MMMP-PROD-EFF-DATE
302200                     GO TO W779-EXIT
302300                 ELSE
302400                     GO TO W775-STATUS-ERROR.
302500*
302600     GO TO W779-EXIT.
302700*
302800 W775-STATUS-ERROR.
302900*
303000     MOVE 'Y'                    TO SS08WS-ERROR.
303100     MOVE DFHBMASB               TO MM14-VI-STATUS-LP-A
303200                                    MM14-VI-STATUS-RP-A
303300                                    MM14-VI-EFF-DATE-LP-A
303400                                    MM14-VI-EFF-DATE-RP-A.
303500     MOVE DFHBMUBF               TO MM14-VI-STATUS-A.
303600     MOVE DFHBMNBF               TO MM14-VI-EFF-DATE-A.
303700     MOVE SS08WS-CURSOR          TO MM14-VI-STATUS-L.
303800*
303900 W779-EXIT.
304000     EXIT.
304100*
304200 W780-CROSS-EDIT-MPEC-IND.
304300*
304400     IF  MM14-VI-MAIL-PHONE-IND-L IS GREATER THAN ZERO
304500         IF  MM14-VALID-MAIL-BASE-II
304600             IF  MMSM-STORE-TYPE IS EQUAL TO 09
304700                 NEXT SENTENCE
304800             ELSE
304900                 MOVE DFHBMUBF   TO MM14-VI-MAIL-PHONE-IND-A
305000                 SET SS08WS-ERROR-SW-YES
305100                                 TO TRUE
305200                 MOVE DFHBMASB   TO MM14-VI-MAIL-PHONE-IND-LP-A
305300                                    MM14-VI-MAIL-PHONE-IND-RP-A
305400                 MOVE SS08WS-CURSOR TO MM14-VI-MAIL-PHONE-IND-L.
305500*
305600 W789-EXIT.
305700     EXIT.
305702*                                                                 RG802901
305704 W790-CROSS-EDIT-CONTACT-IND.                                     RG802901
305706*                                                                 RG802901
305708     IF MM14-VI-CONTACT-IND-L IS NOT GREATER THAN ZERO            RG802901
305710         GO TO W799-EXIT                                          RG802901
305712     END-IF.                                                      RG802901
305714     IF MM14-VALID-CONTACT-IND                                    RG802901
305716         NEXT SENTENCE                                            RG802901
305718      ELSE                                                        RG802901
305720         MOVE DFHBMUBF           TO MM14-VI-CONTACT-IND-A         RG802901
305722         SET SS08WS-ERROR-SW-YES TO TRUE                          RG802901
305724         MOVE DFHBMASB           TO MM14-VI-CONTACT-IND-LP-A      RG802901
305726                                    MM14-VI-CONTACT-IND-RP-A      RG802901
305728         MOVE SS08WS-CURSOR      TO MM14-VI-CONTACT-IND-L         RG802901
305730         GO TO W799-EXIT                                          RG802901
305732     END-IF.                                                      RG802901
305734     IF MM14-VI-USE-PHONE                                         RG802901
305736         GO TO W799-EXIT                                          RG802901
305738     END-IF.                                                      RG802901
305740     IF MM14-VI-USE-URL-EMAIL    AND                              RG802901
305742        MMMM-URL-EMAIL GREATER THAN SPACES                        RG802901
305744         NEXT SENTENCE                                            RG802901
305746      ELSE                                                        RG802901
305748         MOVE DFHBMUBF           TO MM14-VI-CONTACT-IND-A         RG802901
305750         SET SS08WS-ERROR-SW-YES TO TRUE                          RG802901
305752         MOVE DFHBMASB           TO MM14-VI-CONTACT-IND-LP-A      RG802901
305754                                    MM14-VI-CONTACT-IND-RP-A      RG802901
305756         MOVE SS08WS-CURSOR      TO MM14-VI-CONTACT-IND-L         RG802901
305758         GO TO W799-EXIT                                          RG802901
305760     END-IF.                                                      RG802901
305762*                                                                 RG802901
305764 W799-EXIT.                                                       RG802901
305766     EXIT.                                                        RG802901
305800*
305900/
306000 X000-UPDATE-FIELDS SECTION.
306100*
306200 X010-UPDATE-VI-STATUS.
306300*
306400     IF  MM14-VI-STATUS-L IS GREATER THAN ZERO
306500         IF  MM14-VI-STATUS IS NOT EQUAL TO MMMP-PROD-STATUS
306600             SET WS-UPDATE-MMMP-SW-YES
306700                                 TO TRUE
306800             IF  MBCA-PTI-FUNCTION-IS-MAINT
306900             AND MMMP-ADD-COMPLETED
307000                 MOVE MMMMTB-PROD-STATUS (1:4)
307100                                 TO WS-INDEX-X
307200                 SET X-MMFS-MERCH
307300                                 TO WS-INDEX
307400                 MOVE MMFS-MT-AUDIT-CODE (X-MMFS-MERCH)
307500                                 TO MML1-MMMP-AUDIT-CODE
307600                 MOVE 1451       TO MML1-FIELD-CODE
307700                 MOVE ZEROES     TO MML1-FIELD-OCCURRENCE
307800                                    MML1-FIELD-OCCURRENCE-2
307900                 MOVE MML1WS-VL-01
308000                                 TO MML1-VARIABLE-LENGTH
308100                 MOVE MMMP-PROD-STATUS
308200                                 TO MML1-VL01-B-DATA-X
308300                 MOVE MM14-VI-STATUS
308400                                 TO MMMP-PROD-STATUS
308410                                    MBCA-MBMM-PROD-STATUS         EH800900
308500                 MOVE MMMP-PROD-STATUS
308600                                 TO MML1-VL01-A-DATA-X
308700                 MOVE 'FC22'     TO MBCA-PROGRAM-LOCATION
308800                 PERFORM Y910-WRITE-MMMP-LOG-RECORD
308900                                 THRU Y919-WLR-EXIT
309000             ELSE
309100                 MOVE MM14-VI-STATUS
309200                                 TO MMMP-PROD-STATUS              EH800900
309210                                    MBCA-MBMM-PROD-STATUS.        EH800900
309300*
309400     IF  MMMM-SINGLE-STORE-YES
309500       IF  MM14-VI-STATUS-L IS GREATER THAN ZERO
309600         IF  MM14-VI-STATUS IS NOT EQUAL TO MMSM-VI-STATUS
309700             SET WS-UPDATE-MMSM-SW-YES
309800                                 TO TRUE
309900             IF  MBCA-PTI-FUNCTION-IS-MAINT
310000             AND MMSM-ADD-COMPLETED
310100                 MOVE MMMMTB-PROD-STATUS (1:4)
310200                                 TO WS-INDEX-X
310300                 SET X-MMFS-MERCH
310400                                 TO WS-INDEX
310500                 MOVE MMFS-MT-AUDIT-CODE (X-MMFS-MERCH)
310600                                 TO MML1-MMSM-AUDIT-CODE
310700                 MOVE 9016       TO MML1-FIELD-CODE
310800                 MOVE ZEROES     TO MML1-FIELD-OCCURRENCE
310900                                    MML1-FIELD-OCCURRENCE-2
311000                 MOVE MML1WS-VL-01
311100                                 TO MML1-VARIABLE-LENGTH
311200                 MOVE MMSM-VI-STATUS
311300                                 TO MML1-VL01-B-DATA-X
311400                 MOVE MM14-VI-STATUS
311500                                 TO MMSM-VI-STATUS
311600                 MOVE MMSM-VI-STATUS
311700                                 TO MML1-VL01-A-DATA-X
311800                 MOVE 'FC23'     TO MBCA-PROGRAM-LOCATION
311900                 PERFORM Y920-WRITE-MMSM-LOG-RECORD
312000                                 THRU Y929-WLR-EXIT
312100             ELSE
312200                 MOVE MM14-VI-STATUS
312300                                 TO MMSM-VI-STATUS
312400             END-IF
312500         END-IF
312600       END-IF
312700     ELSE
312800         PERFORM Y950-READ-MMXR  THRU Y959-EXIT
312900     END-IF.
313000*
313100 X019-EXIT.
313200     EXIT.
313300*
313400 X030-UPDATE-DISC-FEE-BASE.
313500*
313600     IF  MM14-PROD-DISC-FEE-BASE-L IS GREATER THAN ZERO
313700         IF  MM14-PROD-DISC-FEE-BASE IS NOT EQUAL TO
313800                                     MMMP-PROD-DISC-FEE-BASE
313900             SET WS-UPDATE-MMMP-SW-YES
314000                                 TO TRUE
314100             IF  MBCA-PTI-FUNCTION-IS-MAINT
314200             AND MMMP-ADD-COMPLETED
314300                 MOVE MMMMTB-PROD-DISC-FEE-BASE (1:4)
314400                                 TO WS-INDEX-X
314500                 SET X-MMFS-MERCH
314600                                 TO WS-INDEX
314700                 MOVE MMFS-MT-AUDIT-CODE (X-MMFS-MERCH)
314800                                 TO MML1-MMMP-AUDIT-CODE
314900                 MOVE 1452       TO MML1-FIELD-CODE
315000                 MOVE ZEROES     TO MML1-FIELD-OCCURRENCE
315100                                    MML1-FIELD-OCCURRENCE-2
315200                 MOVE MML1WS-VL-01
315300                                 TO MML1-VARIABLE-LENGTH
315400                 MOVE MMMP-PROD-DISC-FEE-BASE
315500                                 TO MML1-VL01-B-DATA-X
315600                 MOVE MM14-PROD-DISC-FEE-BASE
315700                                 TO MMMP-PROD-DISC-FEE-BASE
315800                 MOVE MMMP-PROD-DISC-FEE-BASE
315900                                 TO MML1-VL01-A-DATA-X
316000                 MOVE 'FC24'     TO MBCA-PROGRAM-LOCATION
316100                 PERFORM Y910-WRITE-MMMP-LOG-RECORD
316200                                 THRU Y919-WLR-EXIT
316300             ELSE
316400                 MOVE MM14-PROD-DISC-FEE-BASE
316500                                 TO MMMP-PROD-DISC-FEE-BASE.
316600*
316700 X039-EXIT.
316800     EXIT.
316900*
317000 X050-UPDATE-DISC-TABLE.
317100*
317200     IF  MM14-PROD-DISC-RATE-TBL-L IS GREATER THAN ZERO
317300         IF  MM14-PROD-DISC-RATE-TBL IS NOT EQUAL TO
317400                                    MMMP-PROD-DISC-RATE-TABLE
317500             SET WS-UPDATE-MMMP-SW-YES
317600                                 TO TRUE
317700             IF  MBCA-PTI-FUNCTION-IS-MAINT
317800             AND MMMP-ADD-COMPLETED
317900                 MOVE MMMMTB-PROD-DISC-RATE-TABLE (1:4)
318000                                 TO WS-INDEX-X
318100                 SET X-MMFS-MERCH
318200                                 TO WS-INDEX
318300                 MOVE MMFS-MT-AUDIT-CODE (X-MMFS-MERCH)
318400                                 TO MML1-MMMP-AUDIT-CODE
318500                 MOVE 1453       TO MML1-FIELD-CODE
318600                 MOVE ZEROES     TO MML1-FIELD-OCCURRENCE
318700                                    MML1-FIELD-OCCURRENCE-2
318800                 MOVE MML1WS-VL-10
318900                                 TO MML1-VARIABLE-LENGTH
319000                 MOVE MMMP-PROD-DISC-RATE-TABLE
319100                                 TO MML1-VL10-B-DATA-9
319200                 MOVE MM14-PROD-DISC-RATE-TBL
319300                                 TO MMMP-PROD-DISC-RATE-TABLE
319400                 MOVE MMMP-PROD-DISC-RATE-TABLE
319500                                 TO MML1-VL10-A-DATA-9
319600                 MOVE 'FC25'     TO MBCA-PROGRAM-LOCATION
319700                 PERFORM Y910-WRITE-MMMP-LOG-RECORD
319800                                 THRU Y919-WLR-EXIT
319900             ELSE
320000                 MOVE MM14-PROD-DISC-RATE-TBL
320100                                 TO MMMP-PROD-DISC-RATE-TABLE.
320200*
320300 X059-EXIT.
320400     EXIT.
320500*
320600 X070-UPDATE-EFF-DATE.
320700*
320800     IF  MM14-VI-EFF-DATE-L IS GREATER THAN ZERO
320900         MOVE MM14-VI-EFF-DATE TO SS01WS-DATE
321000         PERFORM SS07PD-GREG-TO-JUL
321100                                 THRU SS07PD-GTJ-EXIT
321200         IF  SS01WS-JULIAN IS NOT EQUAL
321300                                 TO MMMP-PROD-EFF-DATE
321400             SET WS-UPDATE-MMMP-SW-YES
321500                                 TO TRUE
321600             IF  MBCA-PTI-FUNCTION-IS-MAINT
321700             AND MMMP-ADD-COMPLETED
321800                 MOVE MMMMTB-PROD-EFF-DATE (1:4)
321900                                 TO WS-INDEX-X
322000                 SET X-MMFS-MERCH
322100                                 TO WS-INDEX
322200                 MOVE MMFS-MT-AUDIT-CODE (X-MMFS-MERCH)
322300                                 TO MML1-MMMP-AUDIT-CODE
322400                 MOVE 1454       TO MML1-FIELD-CODE
322500                 MOVE ZEROES     TO MML1-FIELD-OCCURRENCE
322600                                    MML1-FIELD-OCCURRENCE-2
322700                 MOVE MML1WS-VL-07
322800                                 TO MML1-VARIABLE-LENGTH
322900                 MOVE MMMP-PROD-EFF-DATE
323000                                 TO MML1-VL07-B-DATA-9
323100                 MOVE SS01WS-JULIAN
323200                                 TO MMMP-PROD-EFF-DATE
323300                 MOVE MMMP-PROD-EFF-DATE
323400                                 TO MML1-VL07-A-DATA-9
323500                 MOVE 'FC26'     TO MBCA-PROGRAM-LOCATION
323600                 PERFORM Y910-WRITE-MMMP-LOG-RECORD
323700                                 THRU Y919-WLR-EXIT
323800             ELSE
323900                 MOVE SS01WS-JULIAN
324000                                 TO MMMP-PROD-EFF-DATE.
324100*
324200     IF  MMMM-SINGLE-STORE-YES
324300       IF  MM14-VI-EFF-DATE-L IS GREATER THAN ZERO
324400           MOVE MM14-VI-EFF-DATE   TO SS01WS-DATE
324500           PERFORM SS07PD-GREG-TO-JUL
324600                                 THRU SS07PD-GTJ-EXIT
324700           IF  SS01WS-JULIAN IS NOT EQUAL
324800                                 TO MMSM-VI-EFF-DATE
324900               SET WS-UPDATE-MMSM-SW-YES
325000                                 TO TRUE
325100               IF  MBCA-PTI-FUNCTION-IS-MAINT
325200               AND MMSM-ADD-COMPLETED
325300                   MOVE MMMMTB-PROD-EFF-DATE (1:4)
325400                                 TO WS-INDEX-X
325500                   SET X-MMFS-MERCH
325600                                 TO WS-INDEX
325700                   MOVE MMFS-MT-AUDIT-CODE (X-MMFS-MERCH)
325800                                 TO MML1-MMSM-AUDIT-CODE
325900                   MOVE 9017     TO MML1-FIELD-CODE
326000                   MOVE ZEROES   TO MML1-FIELD-OCCURRENCE
326100                                    MML1-FIELD-OCCURRENCE-2
326200                   MOVE MML1WS-VL-07
326300                                 TO MML1-VARIABLE-LENGTH
326400                   MOVE MMSM-VI-EFF-DATE
326500                                 TO MML1-VL07-B-DATA-9
326600                   MOVE SS01WS-JULIAN
326700                                 TO MMSM-VI-EFF-DATE
326800                   MOVE MMSM-VI-EFF-DATE
326900                                 TO MML1-VL07-A-DATA-9
327000                   MOVE 'FC27'   TO MBCA-PROGRAM-LOCATION
327100                   PERFORM Y920-WRITE-MMSM-LOG-RECORD
327200                                 THRU Y929-WLR-EXIT
327300               ELSE
327400                   MOVE SS01WS-JULIAN
327500                                 TO MMSM-VI-EFF-DATE.
327600*
327700 X079-EXIT.
327800     EXIT.
327900*
328000 X090-UPDATE-PART-FEE-BASE.
328100*
328200     IF  MM14-PROD-PART-FEE-BASE-L IS GREATER THAN ZERO
328300         IF  MM14-PROD-PART-FEE-BASE IS NOT EQUAL TO
328400                                     MMMP-PROD-PART-FEE-BASE
328500             SET WS-UPDATE-MMMP-SW-YES
328600                                 TO TRUE
328700             IF  MBCA-PTI-FUNCTION-IS-MAINT
328800             AND MMMP-ADD-COMPLETED
328900                 MOVE MMMMTB-PROD-PART-FEE-BASE (1:4)
329000                                 TO WS-INDEX-X
329100                 SET X-MMFS-MERCH
329200                                 TO WS-INDEX
329300                 MOVE MMFS-MT-AUDIT-CODE (X-MMFS-MERCH)
329400                                 TO MML1-MMMP-AUDIT-CODE
329500                 MOVE 1455       TO MML1-FIELD-CODE
329600                 MOVE ZEROES     TO MML1-FIELD-OCCURRENCE
329700                                    MML1-FIELD-OCCURRENCE-2
329800                 MOVE MML1WS-VL-01
329900                                 TO MML1-VARIABLE-LENGTH
330000                 MOVE MMMP-PROD-PART-FEE-BASE
330100                                 TO MML1-VL01-B-DATA-X
330200                 MOVE MM14-PROD-PART-FEE-BASE
330300                                 TO MMMP-PROD-PART-FEE-BASE
330400                 MOVE MMMP-PROD-PART-FEE-BASE
330500                                 TO MML1-VL01-A-DATA-X
330600                 MOVE 'FC28'     TO MBCA-PROGRAM-LOCATION
330700                 PERFORM Y910-WRITE-MMMP-LOG-RECORD
330800                                 THRU Y919-WLR-EXIT
330900             ELSE
331000                 MOVE MM14-PROD-PART-FEE-BASE
331100                                 TO MMMP-PROD-PART-FEE-BASE.
331200*
331300 X099-EXIT.
331400     EXIT.
331500*
331600 X110-UPDATE-PART-TABLE.
331700*
331800     IF  MM14-PROD-PART-RATE-TBL-L IS GREATER THAN ZERO
331900         IF  MM14-PROD-PART-RATE-TBL IS NOT EQUAL TO
332000                                    MMMP-PROD-PART-RATE-TABLE
332100             SET WS-UPDATE-MMMP-SW-YES
332200                                 TO TRUE
332300             IF  MBCA-PTI-FUNCTION-IS-MAINT
332400             AND MMMP-ADD-COMPLETED
332500                 MOVE MMMMTB-PROD-PART-RATE-TABLE (1:4)
332600                                 TO WS-INDEX-X
332700                 SET X-MMFS-MERCH
332800                                 TO WS-INDEX
332900                 MOVE MMFS-MT-AUDIT-CODE (X-MMFS-MERCH)
333000                                 TO MML1-MMMP-AUDIT-CODE
333100                 MOVE 1456       TO MML1-FIELD-CODE
333200                 MOVE ZEROES     TO MML1-FIELD-OCCURRENCE
333300                                    MML1-FIELD-OCCURRENCE-2
333400                 MOVE MML1WS-VL-10
333500                                 TO MML1-VARIABLE-LENGTH
333600                 MOVE MMMP-PROD-PART-RATE-TABLE
333700                                 TO MML1-VL10-B-DATA-9
333800                 MOVE MM14-PROD-PART-RATE-TBL
333900                                 TO MMMP-PROD-PART-RATE-TABLE
334000                 MOVE MMMP-PROD-PART-RATE-TABLE
334100                                 TO MML1-VL10-A-DATA-9
334200                 MOVE 'FC29'     TO MBCA-PROGRAM-LOCATION
334300                 PERFORM Y910-WRITE-MMMP-LOG-RECORD
334400                                 THRU Y919-WLR-EXIT
334500             ELSE
334600                 MOVE MM14-PROD-PART-RATE-TBL
334700                                 TO MMMP-PROD-PART-RATE-TABLE.
334800*
334900 X119-EXIT.
335000     EXIT.
335100*
335200 X130-UPDATE-SETTLE-FLAG.
335300*
335400     IF  MM14-PROD-SETTLE-FLAG-L IS GREATER THAN ZERO
335500         IF  MM14-PROD-SETTLE-FLAG IS NOT EQUAL TO
335600                                   MMMP-PROD-SETTLE-FLAG
335700             SET WS-UPDATE-MMMP-SW-YES
335800                                 TO TRUE
335900             IF  MBCA-PTI-FUNCTION-IS-MAINT
336000             AND MMMP-ADD-COMPLETED
336100                 MOVE MMMMTB-PROD-SETT-FLAG (1:4)
336200                                 TO WS-INDEX-X
336300                 SET X-MMFS-MERCH
336400                                 TO WS-INDEX
336500                 MOVE MMFS-MT-AUDIT-CODE (X-MMFS-MERCH)
336600                                 TO MML1-MMMP-AUDIT-CODE
336700                 MOVE 1457       TO MML1-FIELD-CODE
336800                 MOVE ZEROES     TO MML1-FIELD-OCCURRENCE
336900                                    MML1-FIELD-OCCURRENCE-2
337000                 MOVE MML1WS-VL-01
337100                                 TO MML1-VARIABLE-LENGTH
337200                 MOVE MMMP-PROD-SETTLE-FLAG
337300                                 TO MML1-VL01-B-DATA-X
337400                 MOVE MM14-PROD-SETTLE-FLAG
337500                                 TO MMMP-PROD-SETTLE-FLAG
337600                 MOVE MMMP-PROD-SETTLE-FLAG
337700                                 TO MML1-VL01-A-DATA-X
337800                 MOVE 'FC30'     TO MBCA-PROGRAM-LOCATION
337900                 PERFORM Y910-WRITE-MMMP-LOG-RECORD
338000                                 THRU Y919-WLR-EXIT
338100             ELSE
338200                 MOVE MM14-PROD-SETTLE-FLAG
338300                                 TO MMMP-PROD-SETTLE-FLAG.
338400*
338500 X139-EXIT.
338600     EXIT.
338700*
338800 X170-UPDATE-RESV-1-FEE-BASE.
338900*
339000     SET X-MMMM-RESV             TO 1.
339100     SET X-MMMP-PROD-RESV        TO 1.
339200*
339300     IF  MM14-PROD-RESV-1-FEE-BASE-L IS GREATER THAN ZERO
339400         IF  MM14-PROD-RESV-1-FEE-BASE IS NOT EQUAL TO
339500                                     MMMP-PROD-RESV-FEE-BASE
339600                                     (X-MMMP-PROD-RESV)
339700             SET WS-UPDATE-MMMP-SW-YES
339800                                 TO TRUE
339900             IF  MBCA-PTI-FUNCTION-IS-MAINT
340000             AND MMMP-ADD-COMPLETED
340100                 MOVE MMMMTB-PROD-RESV-1-FEE-BASE (1:4)
340200                                 TO WS-INDEX-X
340300                 SET X-MMFS-MERCH
340400                                 TO WS-INDEX
340500                 MOVE MMFS-MT-AUDIT-CODE (X-MMFS-MERCH)
340600                                 TO MML1-MMMP-AUDIT-CODE
340700                 MOVE 1458       TO MML1-FIELD-CODE
340800                 SET  MML1-FIELD-OCCURRENCE
340900                                 TO X-MMMP-PROD-RESV
341000                 MOVE ZEROES     TO MML1-FIELD-OCCURRENCE-2
341100                 MOVE MML1WS-VL-01
341200                                 TO MML1-VARIABLE-LENGTH
341300                 MOVE MMMP-PROD-RESV-FEE-BASE (X-MMMP-PROD-RESV)
341400                                 TO MML1-VL01-B-DATA-X
341500                 MOVE MM14-PROD-RESV-1-FEE-BASE
341600                                 TO MMMP-PROD-RESV-FEE-BASE
341700                                    (X-MMMP-PROD-RESV)
341800                 MOVE MMMP-PROD-RESV-FEE-BASE (X-MMMP-PROD-RESV)
341900                                 TO MML1-VL01-A-DATA-X
342000                 MOVE 'FC31'     TO MBCA-PROGRAM-LOCATION
342100                 PERFORM Y910-WRITE-MMMP-LOG-RECORD
342200                                 THRU Y919-WLR-EXIT
342300             ELSE
342400                 MOVE MM14-PROD-RESV-1-FEE-BASE
342500                                 TO MMMP-PROD-RESV-FEE-BASE
342600                                    (X-MMMP-PROD-RESV).
342700*
342800 X179-EXIT.
342900     EXIT.
343000*
343100 X190-UPDATE-RESV-1-TABLE.
343200*
343300     IF  MM14-PROD-RESV-1-RATE-TBL-L IS GREATER THAN ZERO
343400         IF  MM14-PROD-RESV-1-RATE-TBL IS NOT EQUAL TO
343500                                    MMMP-PROD-RESV-RATE-TABLE
343600                                    (X-MMMP-PROD-RESV)
343700             SET WS-UPDATE-MMMP-SW-YES
343800                                 TO TRUE
343900             IF  MBCA-PTI-FUNCTION-IS-MAINT
344000             AND MMMP-ADD-COMPLETED
344100                 MOVE MMMMTB-PROD-RESV-1-RATE-TABLE (1:4)
344200                                 TO WS-INDEX-X
344300                 SET X-MMFS-MERCH
344400                                 TO WS-INDEX
344500                 MOVE MMFS-MT-AUDIT-CODE (X-MMFS-MERCH)
344600                                 TO MML1-MMMP-AUDIT-CODE
344700                 MOVE 1459       TO MML1-FIELD-CODE
344800                 SET  MML1-FIELD-OCCURRENCE
344900                                 TO X-MMMP-PROD-RESV
345000                 MOVE ZEROES     TO MML1-FIELD-OCCURRENCE-2
345100                 MOVE MML1WS-VL-10
345200                                 TO MML1-VARIABLE-LENGTH
345300                 MOVE MMMP-PROD-RESV-RATE-TABLE (X-MMMP-PROD-RESV)
345400                                 TO MML1-VL10-B-DATA-9
345500                 MOVE MM14-PROD-RESV-1-RATE-TBL
345600                                 TO MMMP-PROD-RESV-RATE-TABLE
345700                                    (X-MMMP-PROD-RESV)
345800                 MOVE MMMP-PROD-RESV-RATE-TABLE (X-MMMP-PROD-RESV)
345900                                 TO MML1-VL10-A-DATA-9
346000                 MOVE 'FC32'     TO MBCA-PROGRAM-LOCATION
346100                 PERFORM Y910-WRITE-MMMP-LOG-RECORD
346200                                 THRU Y919-WLR-EXIT
346300             ELSE
346400                 MOVE MM14-PROD-RESV-1-RATE-TBL
346500                                 TO MMMP-PROD-RESV-RATE-TABLE
346600                                    (X-MMMP-PROD-RESV).
346700*
346800 X199-EXIT.
346900     EXIT.
347000*
347100 X210-UPDATE-SOURCE.
347200*
347300     IF  MM14-PROD-SOURCE-L IS GREATER THAN ZERO
347400         IF  MM14-PROD-SOURCE IS NOT EQUAL TO
347500                                    MMMP-PROD-SOURCE
347600             SET WS-UPDATE-MMMP-SW-YES
347700                                 TO TRUE
347800             IF  MBCA-PTI-FUNCTION-IS-MAINT
347900             AND MMMP-ADD-COMPLETED
348000                 MOVE MMMMTB-PROD-SOURCE (1:4)
348100                                 TO WS-INDEX-X
348200                 SET X-MMFS-MERCH
348300                                 TO WS-INDEX
348400                 MOVE MMFS-MT-AUDIT-CODE (X-MMFS-MERCH)
348500                                 TO MML1-MMMP-AUDIT-CODE
348600                 MOVE 1460       TO MML1-FIELD-CODE
348700                 MOVE ZEROES     TO MML1-FIELD-OCCURRENCE
348800                                    MML1-FIELD-OCCURRENCE-2
348900                 MOVE MML1WS-VL-05
349000                                 TO MML1-VARIABLE-LENGTH
349100                 MOVE MMMP-PROD-SOURCE
349200                                 TO MML1-VL05-B-DATA-X
349300                 MOVE MM14-PROD-SOURCE
349400                                 TO MMMP-PROD-SOURCE
349500                 MOVE MMMP-PROD-SOURCE
349600                                 TO MML1-VL05-A-DATA-X
349700                 MOVE 'FC33'     TO MBCA-PROGRAM-LOCATION
349800                 PERFORM Y910-WRITE-MMMP-LOG-RECORD
349900                                 THRU Y919-WLR-EXIT
350000             ELSE
350100                 MOVE MM14-PROD-SOURCE
350200                                 TO MMMP-PROD-SOURCE.
350300*
350400 X219-EXIT.
350500     EXIT.
350600*
350700 X230-UPDATE-RESV-2-FEE-BASE.
350800*
350900     SET X-MMMM-RESV             TO 2.
351000     SET X-MMMP-PROD-RESV        TO 2.
351100*
351200     IF  MM14-PROD-RESV-2-FEE-BASE-L IS GREATER THAN ZERO
351300         IF  MM14-PROD-RESV-2-FEE-BASE IS NOT EQUAL TO
351400                                     MMMP-PROD-RESV-FEE-BASE
351500                                     (X-MMMP-PROD-RESV)
351600             SET WS-UPDATE-MMMP-SW-YES
351700                                 TO TRUE
351800             IF  MBCA-PTI-FUNCTION-IS-MAINT
351900             AND MMMP-ADD-COMPLETED
352000                 MOVE MMMMTB-PROD-RESV-2-FEE-BASE (1:4)
352100                                 TO WS-INDEX-X
352200                 SET X-MMFS-MERCH
352300                                 TO WS-INDEX
352400                 MOVE MMFS-MT-AUDIT-CODE (X-MMFS-MERCH)
352500                                 TO MML1-MMMP-AUDIT-CODE
352600                 MOVE 1458       TO MML1-FIELD-CODE
352700                 SET  MML1-FIELD-OCCURRENCE
352800                                 TO X-MMMP-PROD-RESV
352900                 MOVE ZEROES     TO MML1-FIELD-OCCURRENCE-2
353000                 MOVE MML1WS-VL-01
353100                                 TO MML1-VARIABLE-LENGTH
353200                 MOVE MMMP-PROD-RESV-FEE-BASE (X-MMMP-PROD-RESV)
353300                                 TO MML1-VL01-B-DATA-X
353400                 MOVE MM14-PROD-RESV-2-FEE-BASE
353500                                 TO MMMP-PROD-RESV-FEE-BASE
353600                                    (X-MMMP-PROD-RESV)
353700                 MOVE MMMP-PROD-RESV-FEE-BASE (X-MMMP-PROD-RESV)
353800                                 TO MML1-VL01-A-DATA-X
353900                 MOVE 'FC34'     TO MBCA-PROGRAM-LOCATION
354000                 PERFORM Y910-WRITE-MMMP-LOG-RECORD
354100                                 THRU Y919-WLR-EXIT
354200             ELSE
354300                 MOVE MM14-PROD-RESV-2-FEE-BASE
354400                                 TO MMMP-PROD-RESV-FEE-BASE
354500                                    (X-MMMP-PROD-RESV).
354600*
354700 X239-EXIT.
354800     EXIT.
354900*
355000 X250-UPDATE-RESV-2-TABLE.
355100*
355200     IF  MM14-PROD-RESV-2-RATE-TBL-L IS GREATER THAN ZERO
355300         IF  MM14-PROD-RESV-2-RATE-TBL IS NOT EQUAL TO
355400                                    MMMP-PROD-RESV-RATE-TABLE
355500                                    (X-MMMP-PROD-RESV)
355600             SET WS-UPDATE-MMMP-SW-YES
355700                                 TO TRUE
355800             IF  MBCA-PTI-FUNCTION-IS-MAINT
355900             AND MMMP-ADD-COMPLETED
356000                 MOVE MMMMTB-PROD-RESV-2-RATE-TABLE (1:4)
356100                                 TO WS-INDEX-X
356200                 SET X-MMFS-MERCH
356300                                 TO WS-INDEX
356400                 MOVE MMFS-MT-AUDIT-CODE (X-MMFS-MERCH)
356500                                 TO MML1-MMMP-AUDIT-CODE
356600                 MOVE 1459       TO MML1-FIELD-CODE
356700                 SET  MML1-FIELD-OCCURRENCE
356800                                 TO X-MMMP-PROD-RESV
356900                 MOVE ZEROES     TO MML1-FIELD-OCCURRENCE-2
357000                 MOVE MML1WS-VL-10
357100                                 TO MML1-VARIABLE-LENGTH
357200                 MOVE MMMP-PROD-RESV-RATE-TABLE (X-MMMP-PROD-RESV)
357300                                 TO MML1-VL10-B-DATA-9
357400                 MOVE MM14-PROD-RESV-2-RATE-TBL
357500                                 TO MMMP-PROD-RESV-RATE-TABLE
357600                                    (X-MMMP-PROD-RESV)
357700                 MOVE MMMP-PROD-RESV-RATE-TABLE (X-MMMP-PROD-RESV)
357800                                 TO MML1-VL10-A-DATA-9
357900                 MOVE 'FC35'     TO MBCA-PROGRAM-LOCATION
358000                 PERFORM Y910-WRITE-MMMP-LOG-RECORD
358100                                 THRU Y919-WLR-EXIT
358200             ELSE
358300                 MOVE MM14-PROD-RESV-2-RATE-TBL
358400                                 TO MMMP-PROD-RESV-RATE-TABLE
358500                                    (X-MMMP-PROD-RESV).
358600*
358700 X259-EXIT.
358800     EXIT.
358900*
359000 X270-UPDATE-SHORT-DESC.
359100*
359200     IF  MM14-PROD-SHORT-DESC-L IS GREATER THAN ZERO
359300         IF  MM14-PROD-SHORT-DESC IS NOT EQUAL TO
359400                                    MMMP-PROD-SHORT-DESC
359500             SET WS-UPDATE-MMMP-SW-YES
359600                                 TO TRUE
359700             IF  MBCA-PTI-FUNCTION-IS-MAINT
359800             AND MMMP-ADD-COMPLETED
359900                 MOVE MMMMTB-PROD-SHORT-DESC (1:4)
360000                                 TO WS-INDEX-X
360100                 SET X-MMFS-MERCH
360200                                 TO WS-INDEX
360300                 MOVE MMFS-MT-AUDIT-CODE (X-MMFS-MERCH)
360400                                 TO MML1-MMMP-AUDIT-CODE
360500                 MOVE 1461       TO MML1-FIELD-CODE
360600                 MOVE ZEROES     TO MML1-FIELD-OCCURRENCE
360700                                    MML1-FIELD-OCCURRENCE-2
360800                 MOVE MML1WS-VL-05
360900                                 TO MML1-VARIABLE-LENGTH
361000                 MOVE MMMP-PROD-SHORT-DESC
361100                                 TO MML1-VL05-B-DATA-X
361200                 MOVE MM14-PROD-SHORT-DESC
361300                                 TO MMMP-PROD-SHORT-DESC
361400                 MOVE MMMP-PROD-SHORT-DESC
361500                                 TO MML1-VL05-A-DATA-X
361600                 MOVE 'FC36'     TO MBCA-PROGRAM-LOCATION
361700                 PERFORM Y910-WRITE-MMMP-LOG-RECORD
361800                                 THRU Y919-WLR-EXIT
361900             ELSE
362000                 MOVE MM14-PROD-SHORT-DESC
362100                                 TO MMMP-PROD-SHORT-DESC.
362200*
362300 X279-EXIT.
362400     EXIT.
362500*
362600 X290-UPDATE-RESV-3-FEE-BASE.
362700*
362800     SET X-MMMM-RESV             TO 3.
362900     SET X-MMMP-PROD-RESV        TO 3.
363000*
363100     IF  MM14-PROD-RESV-3-FEE-BASE-L IS GREATER THAN ZERO
363200         IF  MM14-PROD-RESV-3-FEE-BASE IS NOT EQUAL TO
363300                                     MMMP-PROD-RESV-FEE-BASE
363400                                     (X-MMMP-PROD-RESV)
363500             SET WS-UPDATE-MMMP-SW-YES
363600                                 TO TRUE
363700             IF  MBCA-PTI-FUNCTION-IS-MAINT
363800             AND MMMP-ADD-COMPLETED
363900                 MOVE MMMMTB-PROD-RESV-3-FEE-BASE (1:4)
364000                                 TO WS-INDEX-X
364100                 SET X-MMFS-MERCH
364200                                 TO WS-INDEX
364300                 MOVE MMFS-MT-AUDIT-CODE (X-MMFS-MERCH)
364400                                 TO MML1-MMMP-AUDIT-CODE
364500                 MOVE 1458       TO MML1-FIELD-CODE
364600                 SET  MML1-FIELD-OCCURRENCE
364700                                 TO X-MMMP-PROD-RESV
364800                 MOVE ZEROES     TO MML1-FIELD-OCCURRENCE-2
364900                 MOVE MML1WS-VL-01
365000                                 TO MML1-VARIABLE-LENGTH
365100                 MOVE MMMP-PROD-RESV-FEE-BASE (X-MMMP-PROD-RESV)
365200                                 TO MML1-VL01-B-DATA-X
365300                 MOVE MM14-PROD-RESV-3-FEE-BASE
365400                                 TO MMMP-PROD-RESV-FEE-BASE
365500                                    (X-MMMP-PROD-RESV)
365600                 MOVE MMMP-PROD-RESV-FEE-BASE (X-MMMP-PROD-RESV)
365700                                 TO MML1-VL01-A-DATA-X
365800                 MOVE 'FC37'     TO MBCA-PROGRAM-LOCATION
365900                 PERFORM Y910-WRITE-MMMP-LOG-RECORD
366000                                 THRU Y919-WLR-EXIT
366100             ELSE
366200                 MOVE MM14-PROD-RESV-3-FEE-BASE
366300                                 TO MMMP-PROD-RESV-FEE-BASE
366400                                    (X-MMMP-PROD-RESV).
366500*
366600 X299-EXIT.
366700     EXIT.
366800*
366900 X310-UPDATE-RESV-3-TABLE.
367000*
367100     IF  MM14-PROD-RESV-3-RATE-TBL-L IS GREATER THAN ZERO
367200         IF  MM14-PROD-RESV-3-RATE-TBL IS NOT EQUAL TO
367300                                    MMMP-PROD-RESV-RATE-TABLE
367400                                    (X-MMMP-PROD-RESV)
367500             SET WS-UPDATE-MMMP-SW-YES
367600                                 TO TRUE
367700             IF  MBCA-PTI-FUNCTION-IS-MAINT
367800             AND MMMP-ADD-COMPLETED
367900                 MOVE MMMMTB-PROD-RESV-3-RATE-TABLE (1:4)
368000                                 TO WS-INDEX-X
368100                 SET X-MMFS-MERCH
368200                                 TO WS-INDEX
368300                 MOVE MMFS-MT-AUDIT-CODE (X-MMFS-MERCH)
368400                                 TO MML1-MMMP-AUDIT-CODE
368500                 MOVE 1459       TO MML1-FIELD-CODE
368600                 SET  MML1-FIELD-OCCURRENCE
368700                                 TO X-MMMP-PROD-RESV
368800                 MOVE ZEROES     TO MML1-FIELD-OCCURRENCE-2
368900                 MOVE MML1WS-VL-10
369000                                 TO MML1-VARIABLE-LENGTH
369100                 MOVE MMMP-PROD-RESV-RATE-TABLE (X-MMMP-PROD-RESV)
369200                                 TO MML1-VL10-B-DATA-9
369300                 MOVE MM14-PROD-RESV-3-RATE-TBL
369400                                 TO MMMP-PROD-RESV-RATE-TABLE
369500                                    (X-MMMP-PROD-RESV)
369600                 MOVE MMMP-PROD-RESV-RATE-TABLE (X-MMMP-PROD-RESV)
369700                                 TO MML1-VL10-A-DATA-9
369800                 MOVE 'FC38'     TO MBCA-PROGRAM-LOCATION
369900                 PERFORM Y910-WRITE-MMMP-LOG-RECORD
370000                                 THRU Y919-WLR-EXIT
370100             ELSE
370200                 MOVE MM14-PROD-RESV-3-RATE-TBL
370300                                 TO MMMP-PROD-RESV-RATE-TABLE
370400                                    (X-MMMP-PROD-RESV).
370500*
370600 X319-EXIT.
370700     EXIT.
370800*
370900 X330-UPDATE-RESV-4-FEE-BASE.
371000*
371100     SET X-MMMM-RESV             TO 4.
371200     SET X-MMMP-PROD-RESV        TO 4.
371300*
371400     IF  MM14-PROD-RESV-4-FEE-BASE-L IS GREATER THAN ZERO
371500         IF  MM14-PROD-RESV-4-FEE-BASE IS NOT EQUAL TO
371600                                     MMMP-PROD-RESV-FEE-BASE
371700                                     (X-MMMP-PROD-RESV)
371800             SET WS-UPDATE-MMMP-SW-YES
371900                                 TO TRUE
372000             IF  MBCA-PTI-FUNCTION-IS-MAINT
372100             AND MMMP-ADD-COMPLETED
372200                 MOVE MMMMTB-PROD-RESV-4-FEE-BASE (1:4)
372300                                 TO WS-INDEX-X
372400                 SET X-MMFS-MERCH
372500                                 TO WS-INDEX
372600                 MOVE MMFS-MT-AUDIT-CODE (X-MMFS-MERCH)
372700                                 TO MML1-MMMP-AUDIT-CODE
372800                 MOVE 1458       TO MML1-FIELD-CODE
372900                 SET  MML1-FIELD-OCCURRENCE
373000                                 TO X-MMMP-PROD-RESV
373100                 MOVE ZEROES     TO MML1-FIELD-OCCURRENCE-2
373200                 MOVE MML1WS-VL-01
373300                                 TO MML1-VARIABLE-LENGTH
373400                 MOVE MMMP-PROD-RESV-FEE-BASE (X-MMMP-PROD-RESV)
373500                                 TO MML1-VL01-B-DATA-X
373600                 MOVE MM14-PROD-RESV-4-FEE-BASE
373700                                 TO MMMP-PROD-RESV-FEE-BASE
373800                                    (X-MMMP-PROD-RESV)
373900                 MOVE MMMP-PROD-RESV-FEE-BASE (X-MMMP-PROD-RESV)
374000                                 TO MML1-VL01-A-DATA-X
374100                 MOVE 'FC39'     TO MBCA-PROGRAM-LOCATION
374200                 PERFORM Y910-WRITE-MMMP-LOG-RECORD
374300                                 THRU Y919-WLR-EXIT
374400             ELSE
374500                 MOVE MM14-PROD-RESV-4-FEE-BASE
374600                                 TO MMMP-PROD-RESV-FEE-BASE
374700                                    (X-MMMP-PROD-RESV).
374800*
374900 X339-EXIT.
375000     EXIT.
375100*
375200 X350-UPDATE-RESV-4-TABLE.
375300*
375400     IF  MM14-PROD-RESV-4-RATE-TBL-L IS GREATER THAN ZERO
375500         IF  MM14-PROD-RESV-4-RATE-TBL IS NOT EQUAL TO
375600                                    MMMP-PROD-RESV-RATE-TABLE
375700                                    (X-MMMP-PROD-RESV)
375800             SET WS-UPDATE-MMMP-SW-YES
375900                                 TO TRUE
376000             IF  MBCA-PTI-FUNCTION-IS-MAINT
376100             AND MMMP-ADD-COMPLETED
376200                 MOVE MMMMTB-PROD-RESV-4-RATE-TABLE (1:4)
376300                                 TO WS-INDEX-X
376400                 SET X-MMFS-MERCH
376500                                 TO WS-INDEX
376600                 MOVE MMFS-MT-AUDIT-CODE (X-MMFS-MERCH)
376700                                 TO MML1-MMMP-AUDIT-CODE
376800                 MOVE 1459       TO MML1-FIELD-CODE
376900                 SET  MML1-FIELD-OCCURRENCE
377000                                 TO X-MMMP-PROD-RESV
377100                 MOVE ZEROES     TO MML1-FIELD-OCCURRENCE-2
377200                 MOVE MML1WS-VL-10
377300                                 TO MML1-VARIABLE-LENGTH
377400                 MOVE MMMP-PROD-RESV-RATE-TABLE (X-MMMP-PROD-RESV)
377500                                 TO MML1-VL10-B-DATA-9
377600                 MOVE MM14-PROD-RESV-4-RATE-TBL
377700                                 TO MMMP-PROD-RESV-RATE-TABLE
377800                                    (X-MMMP-PROD-RESV)
377900                 MOVE MMMP-PROD-RESV-RATE-TABLE (X-MMMP-PROD-RESV)
378000                                 TO MML1-VL10-A-DATA-9
378100                 MOVE 'FC40'     TO MBCA-PROGRAM-LOCATION
378200                 PERFORM Y910-WRITE-MMMP-LOG-RECORD
378300                                 THRU Y919-WLR-EXIT
378400             ELSE
378500                 MOVE MM14-PROD-RESV-4-RATE-TBL
378600                                 TO MMMP-PROD-RESV-RATE-TABLE
378700                                    (X-MMMP-PROD-RESV).
378800*
378900 X359-EXIT.
379000     EXIT.
379100*
379200 X370-UPDATE-USER-CODE.
379300*
379400     IF  MM14-PROD-USER-CODE-L IS GREATER THAN ZERO
379500         IF  MM14-PROD-USER-CODE IS NOT EQUAL TO
379600                                    MMMP-PROD-USER-CODE
379700             SET WS-UPDATE-MMMP-SW-YES
379800                                 TO TRUE
379900             IF  MBCA-PTI-FUNCTION-IS-MAINT
380000             AND MMMP-ADD-COMPLETED
380100                 MOVE MMMMTB-PROD-USER-CODE (1:4)
380200                                 TO WS-INDEX-X
380300                 SET X-MMFS-MERCH
380400                                 TO WS-INDEX
380500                 MOVE MMFS-MT-AUDIT-CODE (X-MMFS-MERCH)
380600                                 TO MML1-MMMP-AUDIT-CODE
380700                 MOVE 1462       TO MML1-FIELD-CODE
380800                 MOVE ZEROES     TO MML1-FIELD-OCCURRENCE
380900                                    MML1-FIELD-OCCURRENCE-2
381000                 MOVE MML1WS-VL-02
381100                                 TO MML1-VARIABLE-LENGTH
381200                 MOVE MMMP-PROD-USER-CODE
381300                                 TO MML1-VL02-B-DATA-X
381400                 MOVE MM14-PROD-USER-CODE
381500                                 TO MMMP-PROD-USER-CODE
381600                 MOVE MMMP-PROD-USER-CODE
381700                                 TO MML1-VL02-A-DATA-X
381800                 MOVE 'FC41'     TO MBCA-PROGRAM-LOCATION
381900                 PERFORM Y910-WRITE-MMMP-LOG-RECORD
382000                                 THRU Y919-WLR-EXIT
382100             ELSE
382200                 MOVE MM14-PROD-USER-CODE
382300                                 TO MMMP-PROD-USER-CODE.
382400*
382500 X379-EXIT.
382600     EXIT.
382700*
382800 X390-UPDATE-INTCHG-FEE-BASE.
382900*
383000     IF  MM14-PROD-INTCHG-FEE-BASE-L IS GREATER THAN ZERO
383100         IF  MM14-PROD-INTCHG-FEE-BASE IS NOT EQUAL TO
383200                                    MMMP-PROD-INTCHG-FEE-BASE
383300             SET WS-UPDATE-MMMP-SW-YES
383400                                 TO TRUE
383500             IF  MBCA-PTI-FUNCTION-IS-MAINT
383600             AND MMMP-ADD-COMPLETED
383700                 MOVE MMMMTB-PROD-INTCHG-FEE-BASE (1:4)
383800                                 TO WS-INDEX-X
383900                 SET X-MMFS-MERCH
384000                                 TO WS-INDEX
384100                 MOVE MMFS-MT-AUDIT-CODE (X-MMFS-MERCH)
384200                                 TO MML1-MMMP-AUDIT-CODE
384300                 MOVE 1463       TO MML1-FIELD-CODE
384400                 MOVE ZEROES     TO MML1-FIELD-OCCURRENCE
384500                                    MML1-FIELD-OCCURRENCE-2
384600                 MOVE MML1WS-VL-01
384700                                 TO MML1-VARIABLE-LENGTH
384800                 MOVE MMMP-PROD-INTCHG-FEE-BASE
384900                                 TO MML1-VL01-B-DATA-X
385000                 MOVE MM14-PROD-INTCHG-FEE-BASE
385100                                 TO MMMP-PROD-INTCHG-FEE-BASE
385200                 MOVE MMMP-PROD-INTCHG-FEE-BASE
385300                                 TO MML1-VL01-A-DATA-X
385400                 MOVE 'FC42'     TO MBCA-PROGRAM-LOCATION
385500                 PERFORM Y910-WRITE-MMMP-LOG-RECORD
385600                                 THRU Y919-WLR-EXIT
385700             ELSE
385800                 MOVE MM14-PROD-INTCHG-FEE-BASE
385900                                 TO MMMP-PROD-INTCHG-FEE-BASE.
386000*
386100 X399-EXIT.
386200     EXIT.
386300*
386400 X410-UPDATE-DBA-NAME.
386500*
386600     IF  MM14-VI-DBA-NAME-L IS GREATER THAN ZERO
386700         IF  MM14-VI-DBA-NAME IS NOT EQUAL TO
386800                                    MMSM-VI-DBA-NAME
386900             SET WS-UPDATE-MMSM-SW-YES
387000                                 TO TRUE
387100             IF  MBCA-PTI-FUNCTION-IS-MAINT
387200             AND MMSM-ADD-COMPLETED
387300                 MOVE MMSMTB-VI-DBA-NAME (1:4)
387400                                 TO WS-INDEX-X
387500                 SET X-MMFS-STORE
387600                                 TO WS-INDEX
387700                 MOVE MMFS-ST-AUDIT-CODE (X-MMFS-STORE)
387800                                 TO MML1-MMSM-AUDIT-CODE
387900                 MOVE 0701       TO MML1-FIELD-CODE
388000                 MOVE ZEROES     TO MML1-FIELD-OCCURRENCE
388100                                    MML1-FIELD-OCCURRENCE-2
388200                 MOVE MML1WS-VL-30
388300                                 TO MML1-VARIABLE-LENGTH
388400                 MOVE MMSM-VI-DBA-NAME
388500                                 TO MML1-VL30-B-DATA-X
388600                 MOVE MM14-VI-DBA-NAME
388700                                 TO MMSM-VI-DBA-NAME
388800                 MOVE MMSM-VI-DBA-NAME
388900                                 TO MML1-VL30-A-DATA-X
389000                 MOVE 'FC43'     TO MBCA-PROGRAM-LOCATION
389100                 PERFORM Y920-WRITE-MMSM-LOG-RECORD
389200                                 THRU Y929-WLR-EXIT
389300             ELSE
389400                 MOVE MM14-VI-DBA-NAME
389500                                 TO MMSM-VI-DBA-NAME.
389600*
389700 X419-EXIT.
389800     EXIT.
389900*
390000 X450-UPDATE-INTCHG-IND.
390100*
390200     IF  MM14-VI-INTCHG-FLAG-L IS GREATER THAN ZERO
390300         IF  MM14-VI-INTCHG-FLAG IS NOT EQUAL TO
390400                                    MMSM-VI-INTCHG-FLAG
390500             SET WS-UPDATE-MMSM-SW-YES
390600                                 TO TRUE
390700             IF  MBCA-PTI-FUNCTION-IS-MAINT
390800             AND MMSM-ADD-COMPLETED
390900                 MOVE MMSMTB-VI-INTCHG-IND (1:4)
391000                                 TO WS-INDEX-X
391100                 SET X-MMFS-STORE
391200                                 TO WS-INDEX
391300                 MOVE MMFS-ST-AUDIT-CODE (X-MMFS-STORE)
391400                                 TO MML1-MMSM-AUDIT-CODE
391500                 MOVE 0703       TO MML1-FIELD-CODE
391600                 MOVE ZEROES     TO MML1-FIELD-OCCURRENCE
391700                                    MML1-FIELD-OCCURRENCE-2
391800                 MOVE MML1WS-VL-01
391900                                 TO MML1-VARIABLE-LENGTH
392000                 MOVE MMSM-VI-INTCHG-FLAG
392100                                 TO MML1-VL01-B-DATA-X
392200                 MOVE MM14-VI-INTCHG-FLAG
392300                                 TO MMSM-VI-INTCHG-FLAG
392400                 MOVE MMSM-VI-INTCHG-FLAG
392500                                 TO MML1-VL01-A-DATA-X
392600                 MOVE 'FC44'     TO MBCA-PROGRAM-LOCATION
392700                 PERFORM Y920-WRITE-MMSM-LOG-RECORD
392800                                 THRU Y929-WLR-EXIT
392900             ELSE
393000                 MOVE MM14-VI-INTCHG-FLAG
393100                                 TO MMSM-VI-INTCHG-FLAG.
393200*
393300 X459-EXIT.
393400     EXIT.
393500*
393600 X470-UPDATE-VISA-MEMBER-ID.
393700*
393800     IF  MM14-VI-MEMBER-ID-L IS GREATER THAN ZERO
393900         IF  MM14-VI-MEMBER-ID IS NOT EQUAL TO
394000                                    MMSM-VI-MEMBER-ID
394100             SET WS-UPDATE-MMSM-SW-YES
394200                                 TO TRUE
394300             IF  MBCA-PTI-FUNCTION-IS-MAINT
394400             AND MMSM-ADD-COMPLETED
394500                 MOVE MMSMTB-VI-MEMBER-ID (1:4)
394600                                 TO WS-INDEX-X
394700                 SET X-MMFS-STORE
394800                                 TO WS-INDEX
394900                 MOVE MMFS-ST-AUDIT-CODE (X-MMFS-STORE)
395000                                 TO MML1-MMSM-AUDIT-CODE
395100                 MOVE 0704       TO MML1-FIELD-CODE
395200                 MOVE ZEROES     TO MML1-FIELD-OCCURRENCE
395300                                    MML1-FIELD-OCCURRENCE-2
395400                 MOVE MML1WS-VL-10
395500                                 TO MML1-VARIABLE-LENGTH
395600                 MOVE MMSM-VI-MEMBER-ID
395700                                 TO MML1-VL10-B-DATA-9
395800                 MOVE MM14-VI-MEMBER-ID
395900                                 TO MMSM-VI-MEMBER-ID
396000                 MOVE MMSM-VI-MEMBER-ID
396100                                 TO MML1-VL10-A-DATA-9
396200                 MOVE 'FC45'     TO MBCA-PROGRAM-LOCATION
396300                 PERFORM Y920-WRITE-MMSM-LOG-RECORD
396400                                 THRU Y929-WLR-EXIT
396500             ELSE
396600                 MOVE MM14-VI-MEMBER-ID
396700                                 TO MMSM-VI-MEMBER-ID.
396800*
396900 X479-EXIT.
397000     EXIT.
397100*
397200 X490-UPDATE-SPECIAL-COND-1.
397300*
397400     IF  MM14-VI-SPECIAL-COND-1-L IS GREATER THAN ZERO
397500         IF  MM14-VI-SPECIAL-COND-1 IS NOT EQUAL TO
397600                                    MMSM-VI-SPECIAL-COND-1
397700             SET WS-UPDATE-MMSM-SW-YES
397800                                 TO TRUE
397900             IF  MBCA-PTI-FUNCTION-IS-MAINT
398000             AND MMSM-ADD-COMPLETED
398100                 MOVE MMSMTB-VI-SPECIAL-COND-1 (1:4)
398200                                 TO WS-INDEX-X
398300                 SET X-MMFS-STORE
398400                                 TO WS-INDEX
398500                 MOVE MMFS-ST-AUDIT-CODE (X-MMFS-STORE)
398600                                 TO MML1-MMSM-AUDIT-CODE
398700                 MOVE 0705       TO MML1-FIELD-CODE
398800                 MOVE ZEROES     TO MML1-FIELD-OCCURRENCE
398900                                    MML1-FIELD-OCCURRENCE-2
399000                 MOVE MML1WS-VL-01
399100                                 TO MML1-VARIABLE-LENGTH
399200                 MOVE MMSM-VI-SPECIAL-COND-1
399300                                 TO MML1-VL01-B-DATA-X
399400                 MOVE MM14-VI-SPECIAL-COND-1
399500                                 TO MMSM-VI-SPECIAL-COND-1
399600                 MOVE MMSM-VI-SPECIAL-COND-1
399700                                 TO MML1-VL01-A-DATA-X
399800                 MOVE 'FC46'     TO MBCA-PROGRAM-LOCATION
399900                 PERFORM Y920-WRITE-MMSM-LOG-RECORD
400000                                 THRU Y929-WLR-EXIT
400100             ELSE
400200                 MOVE MM14-VI-SPECIAL-COND-1
400300                                 TO MMSM-VI-SPECIAL-COND-1.
400400*
400500 X499-EXIT.
400600     EXIT.
400700*
400800 X510-UPDATE-SPECIAL-COND-2.
400900*
401000     IF  MM14-VI-SPECIAL-COND-2-L IS GREATER THAN ZERO
401100         IF  MM14-VI-SPECIAL-COND-2 IS NOT EQUAL TO
401200                                    MMSM-VI-SPECIAL-COND-2
401300             SET WS-UPDATE-MMSM-SW-YES
401400                                 TO TRUE
401500             IF  MBCA-PTI-FUNCTION-IS-MAINT
401600             AND MMSM-ADD-COMPLETED
401700                 MOVE MMSMTB-VI-SPECIAL-COND-2 (1:4)
401800                                 TO WS-INDEX-X
401900                 SET X-MMFS-STORE
402000                                 TO WS-INDEX
402100                 MOVE MMFS-ST-AUDIT-CODE (X-MMFS-STORE)
402200                                 TO MML1-MMSM-AUDIT-CODE
402300                 MOVE 0706       TO MML1-FIELD-CODE
402400                 MOVE ZEROES     TO MML1-FIELD-OCCURRENCE
402500                                    MML1-FIELD-OCCURRENCE-2
402600                 MOVE MML1WS-VL-01
402700                                 TO MML1-VARIABLE-LENGTH
402800                 MOVE MMSM-VI-SPECIAL-COND-2
402900                                 TO MML1-VL01-B-DATA-X
403000                 MOVE MM14-VI-SPECIAL-COND-2
403100                                 TO MMSM-VI-SPECIAL-COND-2
403200                 MOVE MMSM-VI-SPECIAL-COND-2
403300                                 TO MML1-VL01-A-DATA-X
403400                 MOVE 'FC47'     TO MBCA-PROGRAM-LOCATION
403500                 PERFORM Y920-WRITE-MMSM-LOG-RECORD
403600                                 THRU Y929-WLR-EXIT
403700             ELSE
403800                 MOVE MM14-VI-SPECIAL-COND-2
403900                                 TO MMSM-VI-SPECIAL-COND-2.
404000*
404100 X519-EXIT.
404200     EXIT.
404300*
404400 X530-UPDATE-MAIL-PHONE-IND.
404500*
404600     IF  MM14-VI-MAIL-PHONE-IND-L IS GREATER THAN ZERO
404700         IF  MM14-VI-MAIL-PHONE-IND IS NOT EQUAL TO
404800                                    MMSM-VI-MAIL-PHONE-IND
404900             SET WS-UPDATE-MMSM-SW-YES
405000                                 TO TRUE
405100             IF  MBCA-PTI-FUNCTION-IS-MAINT
405200             AND MMSM-ADD-COMPLETED
405300                 MOVE MMSMTB-VI-MAIL-PHONE-IND (1:4)
405400                                 TO WS-INDEX-X
405500                 SET X-MMFS-STORE
405600                                 TO WS-INDEX
405700                 MOVE MMFS-ST-AUDIT-CODE (X-MMFS-STORE)
405800                                 TO MML1-MMSM-AUDIT-CODE
405900                 MOVE 0707       TO MML1-FIELD-CODE
406000                 MOVE ZEROES     TO MML1-FIELD-OCCURRENCE
406100                                    MML1-FIELD-OCCURRENCE-2
406200                 MOVE MML1WS-VL-01
406300                                 TO MML1-VARIABLE-LENGTH
406400                 MOVE MMSM-VI-MAIL-PHONE-IND
406500                                 TO MML1-VL01-B-DATA-X
406600                 MOVE MM14-VI-MAIL-PHONE-IND
406700                                 TO MMSM-VI-MAIL-PHONE-IND
406800                 MOVE MMSM-VI-MAIL-PHONE-IND
406900                                 TO MML1-VL01-A-DATA-X
407000                 MOVE 'FC48'     TO MBCA-PROGRAM-LOCATION
407100                 PERFORM Y920-WRITE-MMSM-LOG-RECORD
407200                                 THRU Y929-WLR-EXIT
407300             ELSE
407400                 MOVE MM14-VI-MAIL-PHONE-IND
407500                                 TO MMSM-VI-MAIL-PHONE-IND.
407600*
407700 X539-EXIT.
407800     EXIT.
407900*
408000 X550-UPDATE-CH-TERM-IND.
408100*
408200     IF  MM14-VI-CH-TERM-IND-L IS GREATER THAN ZERO
408300         IF  MM14-VI-CH-TERM-IND IS NOT EQUAL TO
408400                                    MMSM-VI-CH-TERM-IND
408500             SET WS-UPDATE-MMSM-SW-YES
408600                                 TO TRUE
408700             IF  MBCA-PTI-FUNCTION-IS-MAINT
408800             AND MMSM-ADD-COMPLETED
408900                 MOVE MMSMTB-VI-CH-TERM-IND (1:4)
409000                                 TO WS-INDEX-X
409100                 SET X-MMFS-STORE
409200                                 TO WS-INDEX
409300                 MOVE MMFS-ST-AUDIT-CODE (X-MMFS-STORE)
409400                                 TO MML1-MMSM-AUDIT-CODE
409500                 MOVE 0708       TO MML1-FIELD-CODE
409600                 MOVE ZEROES     TO MML1-FIELD-OCCURRENCE
409700                                    MML1-FIELD-OCCURRENCE-2
409800                 MOVE MML1WS-VL-01
409900                                 TO MML1-VARIABLE-LENGTH
410000                 MOVE MMSM-VI-CH-TERM-IND
410100                                 TO MML1-VL01-B-DATA-X
410200                 MOVE MM14-VI-CH-TERM-IND
410300                                 TO MMSM-VI-CH-TERM-IND
410400                 MOVE MMSM-VI-CH-TERM-IND
410500                                 TO MML1-VL01-A-DATA-X
410600                 MOVE 'FC49'     TO MBCA-PROGRAM-LOCATION
410700                 PERFORM Y920-WRITE-MMSM-LOG-RECORD
410800                                 THRU Y929-WLR-EXIT
410900             ELSE
411000                 MOVE MM14-VI-CH-TERM-IND
411100                                 TO MMSM-VI-CH-TERM-IND.
411200*
411300 X559-EXIT.
411400     EXIT.
411500*
411600 X620-UPDATE-RPT-THSHOLD.
411700*
411800     IF  MM14-VI-RPT-THSHOLD-L IS GREATER THAN ZERO
411900         IF  MM14-VI-RPT-THSHOLD IS NOT EQUAL TO
412000                                    MMSM-VI-RPT-THSHOLD
412100             SET WS-UPDATE-MMSM-SW-YES
412200                                 TO TRUE
412300             IF  MBCA-PTI-FUNCTION-IS-MAINT
412400             AND MMSM-ADD-COMPLETED
412500                 MOVE MMSMTB-VI-RPT-THSHOLD (1:4)
412600                                 TO WS-INDEX-X
412700                 SET X-MMFS-STORE
412800                                 TO WS-INDEX
412900                 MOVE MMFS-ST-AUDIT-CODE (X-MMFS-STORE)
413000                                 TO MML1-MMSM-AUDIT-CODE
413100                 MOVE 0712       TO MML1-FIELD-CODE
413200                 MOVE ZEROES     TO MML1-FIELD-OCCURRENCE
413300                                    MML1-FIELD-OCCURRENCE-2
413400                 MOVE MML1WS-VL-01
413500                                 TO MML1-VARIABLE-LENGTH
413600                 MOVE MMSM-VI-RPT-THSHOLD
413700                                 TO MML1-VL01-B-DATA-X
413800                 MOVE MM14-VI-RPT-THSHOLD
413900                                 TO MMSM-VI-RPT-THSHOLD
414000                 MOVE MMSM-VI-RPT-THSHOLD
414100                                 TO MML1-VL01-A-DATA-X
414200                 MOVE 'FC50'     TO MBCA-PROGRAM-LOCATION
414300                 PERFORM Y920-WRITE-MMSM-LOG-RECORD
414400                                 THRU Y929-WLR-EXIT
414500             ELSE
414600                 MOVE MM14-VI-RPT-THSHOLD
414700                                 TO MMSM-VI-RPT-THSHOLD.
414800*
414900 X629-EXIT.
415000     EXIT.
415002*                                                                 RG802901
415004 X630-UPDATE-CONTACT-IND.                                         RG802901
415006*                                                                 RG802901
415008     IF  MM14-VI-CONTACT-IND-L IS GREATER THAN ZERO               RG802901
415010        IF  MM14-VI-CONTACT-IND IS NOT EQUAL TO                   RG802901
415012                                    MMSM-VI-CONTACT-IND           RG802901
415014             SET WS-UPDATE-MMSM-SW-YES                            RG802901
415016                                 TO TRUE                          RG802901
415018             IF  MBCA-PTI-FUNCTION-IS-MAINT                       RG802901
415020             AND MMSM-ADD-COMPLETED                               RG802901
415022                 MOVE MMSMTB-VI-CONTACT-IND (1:4)                 RG802901
415024                                 TO WS-INDEX-X                    RG802901
415026                 SET X-MMFS-STORE                                 RG802901
415028                                 TO WS-INDEX                      RG802901
415030                 MOVE MMFS-ST-AUDIT-CODE (X-MMFS-STORE)           RG802901
415032                                 TO MML1-MMSM-AUDIT-CODE          RG802901
415034                 MOVE 9043       TO MML1-FIELD-CODE               RG802901
415036                 MOVE ZEROES     TO MML1-FIELD-OCCURRENCE         RG802901
415038                                    MML1-FIELD-OCCURRENCE-2       RG802901
415040                 MOVE MML1WS-VL-01                                RG802901
415042                                 TO MML1-VARIABLE-LENGTH          RG802901
415044                 MOVE MMSM-VI-CONTACT-IND                         RG802901
415046                                 TO MML1-VL01-B-DATA-X            RG802901
415048                 MOVE MM14-VI-CONTACT-IND                         RG802901
415050                                 TO MMSM-VI-CONTACT-IND           RG802901
415052                 MOVE MMSM-VI-CONTACT-IND                         RG802901
415054                                 TO MML1-VL01-A-DATA-X            RG802901
415056                 MOVE 'FC67'     TO MBCA-PROGRAM-LOCATION         RG802901
415058                 PERFORM Y920-WRITE-MMSM-LOG-RECORD               RG802901
415060                                 THRU Y929-WLR-EXIT               RG802901
415062             ELSE                                                 RG802901
415064                 MOVE MM14-VI-CONTACT-IND                         RG802901
415066                                 TO MMSM-VI-CONTACT-IND.          RG802901
415068*                                                                 RG802901
415070 X639-EXIT.                                                       RG802901
415072     EXIT.                                                        RG802901
415100*
415200 X650-UPDATE-CRB-REGION.
415300*
415400     IF  MM14-VI-CRB-REGION-L IS GREATER THAN ZERO
415500         IF  MM14-VI-CRB-REGION IS NOT EQUAL TO
415600                                    MMSM-VI-CRB-REGION
415700             SET WS-UPDATE-MMSM-SW-YES
415800                                 TO TRUE
415900             IF  MBCA-PTI-FUNCTION-IS-MAINT
416000             AND MMSM-ADD-COMPLETED
416100                 MOVE MMSMTB-VI-CRB-REGION (1:4)
416200                                 TO WS-INDEX-X
416300                 SET X-MMFS-STORE
416400                                 TO WS-INDEX
416500                 MOVE MMFS-ST-AUDIT-CODE (X-MMFS-STORE)
416600                                 TO MML1-MMSM-AUDIT-CODE
416700                 MOVE 0714       TO MML1-FIELD-CODE
416800                 MOVE ZEROES     TO MML1-FIELD-OCCURRENCE
416900                                    MML1-FIELD-OCCURRENCE-2
417000                 MOVE MML1WS-VL-02
417100                                 TO MML1-VARIABLE-LENGTH
417200                 MOVE MMSM-VI-CRB-REGION
417300                                 TO MML1-VL02-B-DATA-X
417400                 MOVE MM14-VI-CRB-REGION
417500                                 TO MMSM-VI-CRB-REGION
417600                 MOVE MMSM-VI-CRB-REGION
417700                                 TO MML1-VL02-A-DATA-X
417800                 MOVE 'FC51'     TO MBCA-PROGRAM-LOCATION
417900                 PERFORM Y920-WRITE-MMSM-LOG-RECORD
418000                                 THRU Y929-WLR-EXIT
418100             ELSE
418200                 MOVE MM14-VI-CRB-REGION
418300                                 TO MMSM-VI-CRB-REGION.
418400*
418500 X659-EXIT.
418600     EXIT.
418700*
418800 X670-UPDATE-REG-ADDR-IND1.
418900*
419000     IF  MM14-VI-REG-ADDR-IND1-L IS GREATER THAN ZERO
419100         IF  MM14-VI-REG-ADDR-IND1 IS NOT EQUAL TO
419200                                    MMSM-VI-REG-ADDR-IND
419300             SET WS-UPDATE-MMSM-SW-YES
419400                                 TO TRUE
419500             IF  MBCA-PTI-FUNCTION-IS-MAINT
419600             AND MMSM-ADD-COMPLETED
419700                 MOVE MMSMTB-VI-REG-ADDR-IND1 (1:4)
419800                                 TO WS-INDEX-X
419900                 SET X-MMFS-STORE
420000                                 TO WS-INDEX
420100                 MOVE MMFS-ST-AUDIT-CODE (X-MMFS-STORE)
420200                                 TO MML1-MMSM-AUDIT-CODE
420300                 MOVE 0715       TO MML1-FIELD-CODE
420400                 MOVE ZEROES     TO MML1-FIELD-OCCURRENCE
420500                                    MML1-FIELD-OCCURRENCE-2
420600                 MOVE MML1WS-VL-01
420700                                 TO MML1-VARIABLE-LENGTH
420800                 MOVE MMSM-VI-REG-ADDR-IND
420900                                 TO MML1-VL01-B-DATA-X
421000                 MOVE MM14-VI-REG-ADDR-IND1
421100                                 TO MMSM-VI-REG-ADDR-IND
421200                 MOVE MMSM-VI-REG-ADDR-IND
421300                                 TO MML1-VL01-A-DATA-X
421400                 MOVE 'FC52'     TO MBCA-PROGRAM-LOCATION
421500                 PERFORM Y920-WRITE-MMSM-LOG-RECORD
421600                                 THRU Y929-WLR-EXIT
421700             ELSE
421800                 MOVE MM14-VI-REG-ADDR-IND1
421900                                 TO MMSM-VI-REG-ADDR-IND.
422000*
422100 X679-EXIT.
422200     EXIT.
422300*
422400 X690-UPDATE-REG-ADDR-IND2.
422500*
422600     IF  MM14-VI-REG-ADDR-IND2-L IS GREATER THAN ZERO
422700         IF  MM14-VI-REG-ADDR-IND2 IS NOT EQUAL TO
422800                                    MMSM-VI-REG-ADDR-LINE
422900             SET WS-UPDATE-MMSM-SW-YES
423000                                 TO TRUE
423100             IF  MBCA-PTI-FUNCTION-IS-MAINT
423200             AND MMSM-ADD-COMPLETED
423300                 MOVE MMSMTB-VI-REG-ADDR-IND2 (1:4)
423400                                 TO WS-INDEX-X
423500                 SET X-MMFS-STORE
423600                                 TO WS-INDEX
423700                 MOVE MMFS-ST-AUDIT-CODE (X-MMFS-STORE)
423800                                 TO MML1-MMSM-AUDIT-CODE
423900                 MOVE 0716       TO MML1-FIELD-CODE
424000                 MOVE ZEROES     TO MML1-FIELD-OCCURRENCE
424100                                    MML1-FIELD-OCCURRENCE-2
424200                 MOVE MML1WS-VL-01
424300                                 TO MML1-VARIABLE-LENGTH
424400                 MOVE MMSM-VI-REG-ADDR-LINE
424500                                 TO MML1-VL01-B-DATA-9
424600                 MOVE MM14-VI-REG-ADDR-IND2
424700                                 TO MMSM-VI-REG-ADDR-LINE
424800                 MOVE MMSM-VI-REG-ADDR-LINE
424900                                 TO MML1-VL01-A-DATA-9
425000                 MOVE 'FC53'     TO MBCA-PROGRAM-LOCATION
425100                 PERFORM Y920-WRITE-MMSM-LOG-RECORD
425200                                 THRU Y929-WLR-EXIT
425300             ELSE
425400                 MOVE MM14-VI-REG-ADDR-IND2
425500                                 TO MMSM-VI-REG-ADDR-LINE.
425600*
425700 X699-EXIT.
425800     EXIT.
425900*
426000 X710-UPDATE-CATEGORY-CODE.
426100*
426200     IF  MM14-VI-CATEGORY-CODE-L IS GREATER THAN ZERO
426300         IF  MM14-VI-CATEGORY-CODE IS NOT EQUAL TO
426400                                    MMSM-VI-CATEGORY-CODE
426500             SET WS-UPDATE-MMSM-SW-YES
426600                                 TO TRUE
426700             IF  MBCA-PTI-FUNCTION-IS-MAINT
426800             AND MMSM-ADD-COMPLETED
426900                 MOVE MMSMTB-VI-CATEGORY-CODE (1:4)
427000                                 TO WS-INDEX-X
427100                 SET X-MMFS-STORE
427200                                 TO WS-INDEX
427300                 MOVE MMFS-ST-AUDIT-CODE (X-MMFS-STORE)
427400                                 TO MML1-MMSM-AUDIT-CODE
427500                 MOVE 0717       TO MML1-FIELD-CODE
427600                 MOVE ZEROES     TO MML1-FIELD-OCCURRENCE
427700                                    MML1-FIELD-OCCURRENCE-2
427800                 MOVE MML1WS-VL-04
427900                                 TO MML1-VARIABLE-LENGTH
428000                 MOVE MMSM-VI-CATEGORY-CODE
428100                                 TO MML1-VL04-B-DATA-9
428200                 MOVE MM14-VI-CATEGORY-CODE
428300                                 TO MMSM-VI-CATEGORY-CODE
428400                 MOVE MMSM-VI-CATEGORY-CODE
428500                                 TO MML1-VL04-A-DATA-9
428600                 MOVE 'FC54'     TO MBCA-PROGRAM-LOCATION
428700                 PERFORM Y920-WRITE-MMSM-LOG-RECORD
428800                                 THRU Y929-WLR-EXIT
428900             ELSE
429000                 MOVE MM14-VI-CATEGORY-CODE
429100                                 TO MMSM-VI-CATEGORY-CODE.
429200*
429300 X719-EXIT.
429400     EXIT.
429500*
429600 X730-UPDATE-FLOOR-LIMIT.
429700*
429800     IF  MM14-VI-FLOOR-LIMIT-L IS GREATER THAN ZERO
429900         IF  MM14-VI-FLOOR-LIMIT IS NOT EQUAL TO
430000                                    MMSM-VI-FLOOR-LIMIT
430100             SET WS-UPDATE-MMSM-SW-YES
430200                                 TO TRUE
430300             IF  MBCA-PTI-FUNCTION-IS-MAINT
430400             AND MMSM-ADD-COMPLETED
430500                 MOVE MMSMTB-VI-FLOOR-LIMIT (1:4)
430600                                 TO WS-INDEX-X
430700                 SET X-MMFS-STORE
430800                                 TO WS-INDEX
430900                 MOVE MMFS-ST-AUDIT-CODE (X-MMFS-STORE)
431000                                 TO MML1-MMSM-AUDIT-CODE
431100                 MOVE 0718       TO MML1-FIELD-CODE
431200                 MOVE ZEROES     TO MML1-FIELD-OCCURRENCE
431300                                    MML1-FIELD-OCCURRENCE-2
431400                 MOVE MML1WS-VL-20
431500                                 TO MML1-VARIABLE-LENGTH
431600                 MOVE MMSM-VI-FLOOR-LIMIT
431700                                 TO MML1-VL20-B-NBR-NO-DEC
431800                 MOVE MM14-VI-FLOOR-LIMIT
431900                                 TO MMSM-VI-FLOOR-LIMIT
432000                 MOVE MMSM-VI-FLOOR-LIMIT
432100                                 TO MML1-VL20-A-NBR-NO-DEC
432200                 MOVE 'FC55'     TO MBCA-PROGRAM-LOCATION
432300                 PERFORM Y920-WRITE-MMSM-LOG-RECORD
432400                                 THRU Y929-WLR-EXIT
432500             ELSE
432600                 MOVE MM14-VI-FLOOR-LIMIT
432700                                 TO MMSM-VI-FLOOR-LIMIT.
432800*
432900 X739-EXIT.
433000     EXIT.
433100*
433200 X750-UPDATE-VOLUME-IND.
433300*
433400     IF  MM14-VI-VOLUME-IND-L IS GREATER THAN ZERO
433500         IF  MM14-VI-VOLUME-IND IS NOT EQUAL TO
433600                                    MMSM-VI-VOLUME-IND
433700             SET WS-UPDATE-MMSM-SW-YES
433800                                 TO TRUE
433900             IF  MBCA-PTI-FUNCTION-IS-MAINT
434000             AND MMSM-ADD-COMPLETED
434100                 MOVE MMSMTB-VI-VOLUME-IND (1:4)
434200                                 TO WS-INDEX-X
434300                 SET X-MMFS-STORE
434400                                 TO WS-INDEX
434500                 MOVE MMFS-ST-AUDIT-CODE (X-MMFS-STORE)
434600                                 TO MML1-MMSM-AUDIT-CODE
434700                 MOVE 0719       TO MML1-FIELD-CODE
434800                 MOVE ZEROES     TO MML1-FIELD-OCCURRENCE
434900                                    MML1-FIELD-OCCURRENCE-2
435000                 MOVE MML1WS-VL-02
435100                                 TO MML1-VARIABLE-LENGTH
435200                 MOVE MMSM-VI-VOLUME-IND
435300                                 TO MML1-VL02-B-DATA-X
435400                 MOVE MM14-VI-VOLUME-IND
435500                                 TO MMSM-VI-VOLUME-IND
435600                 MOVE MMSM-VI-VOLUME-IND
435700                                 TO MML1-VL02-A-DATA-X
435800                 MOVE 'FC56'     TO MBCA-PROGRAM-LOCATION
435900                 PERFORM Y920-WRITE-MMSM-LOG-RECORD
436000                                 THRU Y929-WLR-EXIT
436100             ELSE
436200                 MOVE MM14-VI-VOLUME-IND
436300                                 TO MMSM-VI-VOLUME-IND.
436400*
436500 X759-EXIT.
436600     EXIT.
436610*                                                                 RG800914
436612 X760-UPDATE-SVC-DVLP-IND.                                        RG800914
436614*                                                                 RG800914
436616     IF  MM14-VI-SVC-DVLP-IND-L IS GREATER THAN ZERO              RG800914
436618         IF  MM14-VI-SVC-DVLP-IND IS NOT EQUAL TO                 RG800914
436620                                    MMSM-VI-SVC-DVLP-IND          RG800914
436622             SET WS-UPDATE-MMSM-SW-YES                            RG800914
436624                                 TO TRUE                          RG800914
436626             IF  MBCA-PTI-FUNCTION-IS-MAINT                       RG800914
436628             AND MMSM-ADD-COMPLETED                               RG800914
436630                 MOVE MMSMTB-VI-SVC-DVLP-IND (1:4)                RG800914
436632                                 TO WS-INDEX-X                    RG800914
436634                 SET X-MMFS-STORE                                 RG800914
436636                                 TO WS-INDEX                      RG800914
436638                 MOVE MMFS-ST-AUDIT-CODE (X-MMFS-STORE)           RG800914
436640                                 TO MML1-MMSM-AUDIT-CODE          RG800914
436642                 MOVE 0721       TO MML1-FIELD-CODE               RG800914
436644                 MOVE ZEROES     TO MML1-FIELD-OCCURRENCE         RG800914
436646                                    MML1-FIELD-OCCURRENCE-2       RG800914
436648                 MOVE MML1WS-VL-01                                RG800914
436650                                 TO MML1-VARIABLE-LENGTH          RG800914
436652                 MOVE MMSM-VI-SVC-DVLP-IND                        RG800914
436654                                 TO MML1-VL01-B-DATA-X            RG800914
436656                 MOVE MM14-VI-SVC-DVLP-IND                        RG800914
436658                                 TO MMSM-VI-SVC-DVLP-IND          RG800914
436660                 MOVE MMSM-VI-SVC-DVLP-IND                        RG800914
436662                                 TO MML1-VL01-A-DATA-X            RG800914
436664                 MOVE 'FC57'     TO MBCA-PROGRAM-LOCATION         RG800914
436666                 PERFORM Y920-WRITE-MMSM-LOG-RECORD               RG800914
436668                                 THRU Y929-WLR-EXIT               RG800914
436670             ELSE                                                 RG800914
436672                 MOVE MM14-VI-SVC-DVLP-IND                        RG800914
436674                                 TO MMSM-VI-SVC-DVLP-IND.         RG800914
436676*                                                                 RG800914
436678 X769-EXIT.                                                       RG800914
436680     EXIT.                                                        RG800914
436682/                                                                 RG800914
436700/
436800 Y000-PERFORMED-ROUTINES SECTION.
436900*
437000 Y010-MOVE-VI-STATUS.
437100*
437200     MOVE MMMP-PROD-STATUS       TO MM14-VI-STATUS.
437300*
437400 Y015-STATUS-SECURITY.
437500*
437600     MOVE MMMMTB-PROD-STATUS (1:4)
437700                                 TO WS-INDEX-X.
437800     SET  X-MMFS-MERCH           TO WS-INDEX.
437900*
438000     IF  MMFS-MT-NO-ACCESS (X-MMFS-MERCH)
438100         MOVE DFHBMDAS           TO MM14-VI-STATUS-LIT-A
438200                                    MM14-VI-STATUS-LP-A
438300                                    MM14-VI-STATUS-RP-A
438400                                    MM14-VI-STATUS-A
438500         MOVE ZERO               TO MM14-VI-STATUS-L
438600         GO TO Y019-EXIT.
438700*
438800     IF  MBCA-PTI-FUNCTION-IS-INQUIRY
438900         MOVE DFHBMDAS           TO MM14-VI-STATUS-LP-A
439000                                    MM14-VI-STATUS-RP-A
439100         MOVE DFHBMASB           TO MM14-VI-STATUS-A
439200         GO TO Y019-EXIT.
439300*
439400     IF  MMFS-MT-INQ-ONLY (X-MMFS-MERCH)
439500         MOVE ZERO               TO MM14-VI-STATUS-L
439600         MOVE DFHBMDAS           TO MM14-VI-STATUS-LP-A
439700                                    MM14-VI-STATUS-RP-A
439800         MOVE DFHBMASK           TO MM14-VI-STATUS-A
439900         GO TO Y019-EXIT.
440000*
440100     IF  MBCA-PTI-FUNCTION-IS-ADD
440200         IF  MMFS-MT-REQUIRED (X-MMFS-MERCH)
440300             MOVE DFHBMASB       TO MM14-VI-STATUS-LIT-A
440400         ELSE
440500             IF  MMFS-MT-MAINT-ONLY (X-MMFS-MERCH)
440600                 MOVE ZERO       TO MM14-VI-STATUS-L
440700                 MOVE DFHBMDAS   TO MM14-VI-STATUS-LP-A
440800                                    MM14-VI-STATUS-RP-A
440900                 MOVE DFHBMASK   TO MM14-VI-STATUS-A.
441000*
441100     IF  MBCA-PTI-FUNCTION-IS-MAINT
441200         IF  MMFS-MT-NO-MAINT (X-MMFS-MERCH)
441300             MOVE ZERO           TO MM14-VI-STATUS-L
441400             MOVE DFHBMDAS       TO MM14-VI-STATUS-LP-A
441500                                    MM14-VI-STATUS-RP-A
441600             MOVE DFHBMASK       TO MM14-VI-STATUS-A.
441700*
441800*
441900 Y019-EXIT.
442000     EXIT.
442100*
442200 Y030-MOVE-DISC-FEE-BASE.
442300*
442400     MOVE MMMP-PROD-DISC-FEE-BASE
442500                                TO MM14-PROD-DISC-FEE-BASE.
442600*
442700 Y035-DISC-FEE-BASE-SECURITY.
442800*
442900     MOVE MMMMTB-PROD-DISC-FEE-BASE (1:4)
443000                                 TO WS-INDEX-X.
443100     SET  X-MMFS-MERCH           TO WS-INDEX.
443200*
443300     IF  MMFS-MT-NO-ACCESS (X-MMFS-MERCH)
443400         MOVE DFHBMDAS           TO MM14-PROD-DISCOUNT-LIT-A
443500                                    MM14-PROD-DISC-FEE-BASE-LP-A
443600                                    MM14-PROD-DISC-FEE-BASE-RP-A
443700                                    MM14-PROD-DISC-FEE-BASE-A
443800         MOVE ZERO               TO MM14-PROD-DISC-FEE-BASE-L
443900         GO TO Y039-EXIT.
444000*
444100     IF  MBCA-PTI-FUNCTION-IS-INQUIRY
444200         MOVE DFHBMDAS           TO MM14-PROD-DISC-FEE-BASE-LP-A
444300                                    MM14-PROD-DISC-FEE-BASE-RP-A
444400         MOVE DFHBMASB           TO MM14-PROD-DISC-FEE-BASE-A
444500         GO TO Y039-EXIT.
444600*
444700     IF  MMFS-MT-INQ-ONLY (X-MMFS-MERCH)
444800         MOVE ZERO               TO MM14-PROD-DISC-FEE-BASE-L
444900         MOVE DFHBMDAS           TO MM14-PROD-DISC-FEE-BASE-LP-A
445000                                    MM14-PROD-DISC-FEE-BASE-RP-A
445100         MOVE DFHBMASK           TO MM14-PROD-DISC-FEE-BASE-A
445200         GO TO Y039-EXIT.
445300*
445400     IF  MBCA-PTI-FUNCTION-IS-ADD
445500         IF  MMFS-MT-REQUIRED (X-MMFS-MERCH)
445600             MOVE DFHBMASB       TO MM14-PROD-DISCOUNT-LIT-A
445700         ELSE
445800             IF  MMFS-MT-MAINT-ONLY (X-MMFS-MERCH)
445900                 MOVE ZERO       TO MM14-PROD-DISC-FEE-BASE-L
446000                 MOVE DFHBMDAS   TO MM14-PROD-DISC-FEE-BASE-LP-A
446100                                    MM14-PROD-DISC-FEE-BASE-RP-A
446200                 MOVE DFHBMASK   TO MM14-PROD-DISC-FEE-BASE-A.
446300*
446400     IF  MBCA-PTI-FUNCTION-IS-MAINT
446500         IF  MMFS-MT-NO-MAINT (X-MMFS-MERCH)
446600             MOVE ZERO           TO MM14-PROD-DISC-FEE-BASE-L
446700             MOVE DFHBMDAS       TO MM14-PROD-DISC-FEE-BASE-LP-A
446800                                    MM14-PROD-DISC-FEE-BASE-RP-A
446900             MOVE DFHBMASK       TO MM14-PROD-DISC-FEE-BASE-A.
447000*
447100 Y039-EXIT.
447200     EXIT.
447300*
447400 Y050-MOVE-DISC-TABLE.
447500*
447600     IF  MMMM-DL-MERCHANT
447700         MOVE DFHBMDAS           TO MM14-PROD-DISC-RATE-TBL-LP-A
447800                                    MM14-PROD-DISC-RATE-TBL-RP-A
447900                                    MM14-PROD-DISC-RATE-TBL-A
448000                                    MM14-PROD-DISCOUNT-LIT-A
448100         GO TO Y059-EXIT.
448200*
448300     MOVE MMMP-PROD-DISC-RATE-TABLE
448400                                 TO MM14-PROD-DISC-RATE-TBL.
448500*
448600 Y055-DISC-RATE-TBL-SECURITY.
448700*
448800     MOVE MMMMTB-PROD-DISC-RATE-TABLE (1:4)
448900                                 TO WS-INDEX-X.
449000     SET  X-MMFS-MERCH           TO WS-INDEX.
449100*
449200     IF  MMFS-MT-NO-ACCESS (X-MMFS-MERCH)
449300         MOVE DFHBMDAS           TO MM14-PROD-DISC-RATE-TBL-LP-A
449400                                    MM14-PROD-DISC-RATE-TBL-RP-A
449500                                    MM14-PROD-DISC-RATE-TBL-A
449600         MOVE ZERO               TO MM14-PROD-DISC-RATE-TBL-L
449700         GO TO Y059-EXIT.
449800*
449900     IF  MBCA-PTI-FUNCTION-IS-INQUIRY
450000         MOVE DFHBMDAS           TO MM14-PROD-DISC-RATE-TBL-LP-A
450100                                    MM14-PROD-DISC-RATE-TBL-RP-A
450200         MOVE DFHBMASB           TO MM14-PROD-DISC-RATE-TBL-A
450300         GO TO Y059-EXIT.
450400*
450500     IF  MMFS-MT-INQ-ONLY (X-MMFS-MERCH)
450600         MOVE ZERO               TO MM14-PROD-DISC-RATE-TBL-L
450700         MOVE DFHBMDAS           TO MM14-PROD-DISC-RATE-TBL-LP-A
450800                                    MM14-PROD-DISC-RATE-TBL-RP-A
450900         MOVE DFHBMASK           TO MM14-PROD-DISC-RATE-TBL-A
451000         GO TO Y059-EXIT.
451100*
451200     IF  MBCA-PTI-FUNCTION-IS-ADD
451300         IF  MMFS-MT-REQUIRED (X-MMFS-MERCH)
451400             MOVE DFHBMASB       TO MM14-PROD-DISCOUNT-LIT-A
451500         ELSE
451600             IF  MMFS-MT-MAINT-ONLY (X-MMFS-MERCH)
451700                 MOVE ZERO       TO MM14-PROD-DISC-RATE-TBL-L
451800                 MOVE DFHBMDAS   TO MM14-PROD-DISC-RATE-TBL-LP-A
451900                                    MM14-PROD-DISC-RATE-TBL-RP-A
452000                 MOVE DFHBMASK   TO MM14-PROD-DISC-RATE-TBL-A.
452100*
452200     IF  MBCA-PTI-FUNCTION-IS-MAINT
452300         IF  MMFS-MT-NO-MAINT (X-MMFS-MERCH)
452400             MOVE ZERO           TO MM14-PROD-DISC-RATE-TBL-L
452500             MOVE DFHBMDAS       TO MM14-PROD-DISC-RATE-TBL-LP-A
452600                                    MM14-PROD-DISC-RATE-TBL-RP-A
452700             MOVE DFHBMASK       TO MM14-PROD-DISC-RATE-TBL-A.
452800*
452900 Y059-EXIT.
453000     EXIT.
453100*
453200 Y070-MOVE-EFF-DATE.
453300*
453400     MOVE MMMP-PROD-EFF-DATE     TO SS01WS-JULIAN.
453500     PERFORM SS08PD-JUL-TO-GREG  THRU SS08PD-JTG-EXIT.
453600     MOVE SS01WS-DATE            TO MM14-VI-EFF-DATE.
453700*
453800 Y075-EFF-DATE-SECURITY.
453900*
454000     MOVE MMMMTB-PROD-EFF-DATE (1:4)
454100                                 TO WS-INDEX-X.
454200     SET  X-MMFS-MERCH           TO WS-INDEX.
454300*
454400     IF  MMFS-MT-NO-ACCESS (X-MMFS-MERCH)
454500         MOVE DFHBMDAS           TO MM14-VI-EFF-DATE-LIT-A
454600                                    MM14-VI-EFF-DATE-LP-A
454700                                    MM14-VI-EFF-DATE-RP-A
454800                                    MM14-VI-EFF-DATE-A
454900         MOVE ZERO               TO MM14-VI-EFF-DATE-L
455000         GO TO Y079-EXIT.
455100*
455200     IF  MBCA-PTI-FUNCTION-IS-INQUIRY
455300         MOVE DFHBMDAS           TO MM14-VI-EFF-DATE-LP-A
455400                                    MM14-VI-EFF-DATE-RP-A
455500         MOVE DFHBMASB           TO MM14-VI-EFF-DATE-A
455600         GO TO Y079-EXIT.
455700*
455800     IF  MMFS-MT-INQ-ONLY (X-MMFS-MERCH)
455900         MOVE ZERO               TO MM14-VI-EFF-DATE-L
456000         MOVE DFHBMDAS           TO MM14-VI-EFF-DATE-LP-A
456100                                    MM14-VI-EFF-DATE-RP-A
456200         MOVE DFHBMASK           TO MM14-VI-EFF-DATE-A
456300         GO TO Y079-EXIT.
456400*
456500     IF  MBCA-PTI-FUNCTION-IS-ADD
456600         IF  MMFS-MT-REQUIRED (X-MMFS-MERCH)
456700             MOVE DFHBMASB       TO MM14-VI-EFF-DATE-LIT-A
456800         ELSE
456900             IF  MMFS-MT-MAINT-ONLY (X-MMFS-MERCH)
457000                 MOVE ZERO       TO MM14-VI-EFF-DATE-L
457100                 MOVE DFHBMDAS   TO MM14-VI-EFF-DATE-LP-A
457200                                    MM14-VI-EFF-DATE-RP-A
457300                 MOVE DFHBMASK   TO MM14-VI-EFF-DATE-A.
457400*
457500     IF  MBCA-PTI-FUNCTION-IS-MAINT
457600         IF  MMFS-MT-NO-MAINT (X-MMFS-MERCH)
457700             MOVE ZERO           TO MM14-VI-EFF-DATE-L
457800             MOVE DFHBMDAS       TO MM14-VI-EFF-DATE-LP-A
457900                                    MM14-VI-EFF-DATE-RP-A
458000             MOVE DFHBMASK       TO MM14-VI-EFF-DATE-A.
458100*
458200 Y079-EXIT.
458300     EXIT.
458400*
458500 Y090-MOVE-PART-FEE-BASE.
458600*
458700     MOVE MMMP-PROD-PART-FEE-BASE
458800                                 TO MM14-PROD-PART-FEE-BASE.
458900*
459000 Y095-PART-FEE-BASE-SECURITY.
459100*
459200     MOVE MMMMTB-PROD-PART-FEE-BASE (1:4)
459300                                 TO WS-INDEX-X.
459400     SET  X-MMFS-MERCH           TO WS-INDEX.
459500*
459600     IF  MMFS-MT-NO-ACCESS (X-MMFS-MERCH)
459700         MOVE DFHBMDAS           TO MM14-PROD-PARTICIPATION-LIT-A
459800                                    MM14-PROD-PART-FEE-BASE-LP-A
459900                                    MM14-PROD-PART-FEE-BASE-RP-A
460000                                    MM14-PROD-PART-FEE-BASE-A
460100         MOVE ZERO               TO MM14-PROD-PART-FEE-BASE-L
460200         GO TO Y099-EXIT.
460300*
460400     IF  MBCA-PTI-FUNCTION-IS-INQUIRY
460500         MOVE DFHBMDAS           TO MM14-PROD-PART-FEE-BASE-LP-A
460600                                    MM14-PROD-PART-FEE-BASE-RP-A
460700         MOVE DFHBMASB           TO MM14-PROD-PART-FEE-BASE-A
460800         GO TO Y099-EXIT.
460900*
461000     IF  MMFS-MT-INQ-ONLY (X-MMFS-MERCH)
461100         MOVE ZERO               TO MM14-PROD-PART-FEE-BASE-L
461200         MOVE DFHBMDAS           TO MM14-PROD-PART-FEE-BASE-LP-A
461300                                    MM14-PROD-PART-FEE-BASE-RP-A
461400         MOVE DFHBMASK           TO MM14-PROD-PART-FEE-BASE-A
461500         GO TO Y099-EXIT.
461600*
461700     IF  MBCA-PTI-FUNCTION-IS-ADD
461800         IF  MMFS-MT-REQUIRED (X-MMFS-MERCH)
461900             MOVE DFHBMASB       TO MM14-PROD-PARTICIPATION-LIT-A
462000         ELSE
462100             IF  MMFS-MT-MAINT-ONLY (X-MMFS-MERCH)
462200                 MOVE ZERO       TO MM14-PROD-PART-FEE-BASE-L
462300                 MOVE DFHBMDAS   TO MM14-PROD-PART-FEE-BASE-LP-A
462400                                    MM14-PROD-PART-FEE-BASE-RP-A
462500                 MOVE DFHBMASK   TO MM14-PROD-PART-FEE-BASE-A.
462600*
462700     IF  MBCA-PTI-FUNCTION-IS-MAINT
462800         IF  MMFS-MT-NO-MAINT (X-MMFS-MERCH)
462900             MOVE ZERO           TO MM14-PROD-PART-FEE-BASE-L
463000             MOVE DFHBMDAS       TO MM14-PROD-PART-FEE-BASE-LP-A
463100                                    MM14-PROD-PART-FEE-BASE-RP-A
463200             MOVE DFHBMASK       TO MM14-PROD-PART-FEE-BASE-A.
463300*
463400 Y099-EXIT.
463500     EXIT.
463600*
463700 Y110-MOVE-PART-TABLE.
463800*
463900     IF  MMMM-PL-MERCHANT
464000         MOVE DFHBMDAS           TO MM14-PROD-PART-RATE-TBL-LP-A
464100                                    MM14-PROD-PART-RATE-TBL-RP-A
464200                                    MM14-PROD-PART-RATE-TBL-A
464300                                    MM14-PROD-PARTICIPATION-LIT-A
464400         GO TO Y119-EXIT.
464500*
464600     MOVE MMMP-PROD-PART-RATE-TABLE
464700                                 TO MM14-PROD-PART-RATE-TBL.
464800*
464900 Y115-PART-RATE-TBL-SECURITY.
465000*
465100     MOVE MMMMTB-PROD-PART-RATE-TABLE (1:4)
465200                                 TO WS-INDEX-X.
465300     SET  X-MMFS-MERCH           TO WS-INDEX.
465400*
465500     IF  MMFS-MT-NO-ACCESS (X-MMFS-MERCH)
465600         MOVE DFHBMDAS           TO MM14-PROD-PARTICIPATION-LIT-A
465700                                    MM14-PROD-PART-RATE-TBL-LP-A
465800                                    MM14-PROD-PART-RATE-TBL-RP-A
465900                                    MM14-PROD-PART-RATE-TBL-A
466000         MOVE ZERO               TO MM14-PROD-PART-RATE-TBL-L
466100         GO TO Y119-EXIT.
466200*
466300     IF  MBCA-PTI-FUNCTION-IS-INQUIRY
466400         MOVE DFHBMDAS           TO MM14-PROD-PART-RATE-TBL-LP-A
466500                                    MM14-PROD-PART-RATE-TBL-RP-A
466600         MOVE DFHBMASB           TO MM14-PROD-PART-RATE-TBL-A
466700         GO TO Y119-EXIT.
466800*
466900     IF  MMFS-MT-INQ-ONLY (X-MMFS-MERCH)
467000         MOVE ZERO               TO MM14-PROD-PART-RATE-TBL-L
467100         MOVE DFHBMDAS           TO MM14-PROD-PART-RATE-TBL-LP-A
467200                                    MM14-PROD-PART-RATE-TBL-RP-A
467300         MOVE DFHBMASK           TO MM14-PROD-PART-RATE-TBL-A
467400         GO TO Y119-EXIT.
467500*
467600     IF  MBCA-PTI-FUNCTION-IS-ADD
467700         IF  MMFS-MT-REQUIRED (X-MMFS-MERCH)
467800             MOVE DFHBMASB       TO MM14-PROD-PARTICIPATION-LIT-A
467900         ELSE
468000             IF  MMFS-MT-MAINT-ONLY (X-MMFS-MERCH)
468100                 MOVE ZERO       TO MM14-PROD-PART-RATE-TBL-L
468200                 MOVE DFHBMDAS   TO MM14-PROD-PART-RATE-TBL-LP-A
468300                                    MM14-PROD-PART-RATE-TBL-RP-A
468400                 MOVE DFHBMASK   TO MM14-PROD-PART-RATE-TBL-A.
468500*
468600     IF  MBCA-PTI-FUNCTION-IS-MAINT
468700         IF  MMFS-MT-NO-MAINT (X-MMFS-MERCH)
468800             MOVE ZERO           TO MM14-PROD-PART-RATE-TBL-L
468900             MOVE DFHBMDAS       TO MM14-PROD-PART-RATE-TBL-LP-A
469000                                    MM14-PROD-PART-RATE-TBL-RP-A
469100             MOVE DFHBMASK       TO MM14-PROD-PART-RATE-TBL-A.
469200*
469300 Y119-EXIT.
469400     EXIT.
469500*
469600 Y130-MOVE-SETTLE-FLAG.
469700*
469800     MOVE MMMP-PROD-SETTLE-FLAG  TO MM14-PROD-SETTLE-FLAG.
469900*
470000 Y135-SETTLE-FLAG-SECURITY.
470100*
470200     MOVE MMMMTB-PROD-SETT-FLAG (1:4)
470300                                 TO WS-INDEX-X.
470400     SET  X-MMFS-MERCH           TO WS-INDEX.
470500*
470600     IF  MMFS-MT-NO-ACCESS (X-MMFS-MERCH)
470700         MOVE DFHBMDAS           TO MM14-PROD-SETTLE-FLAG-LIT-A
470800                                    MM14-PROD-SETTLE-FLAG-LP-A
470900                                    MM14-PROD-SETTLE-FLAG-RP-A
471000                                    MM14-PROD-SETTLE-FLAG-A
471100         MOVE ZERO               TO MM14-PROD-SETTLE-FLAG-L
471200         GO TO Y139-EXIT.
471300*
471400     IF  MBCA-PTI-FUNCTION-IS-INQUIRY
471500         MOVE DFHBMDAS           TO MM14-PROD-SETTLE-FLAG-LP-A
471600                                    MM14-PROD-SETTLE-FLAG-RP-A
471700         MOVE DFHBMASB           TO MM14-PROD-SETTLE-FLAG-A
471800         GO TO Y139-EXIT.
471900*
472000     IF  MMFS-MT-INQ-ONLY (X-MMFS-MERCH)
472100         MOVE ZERO               TO MM14-PROD-SETTLE-FLAG-L
472200         MOVE DFHBMDAS           TO MM14-PROD-SETTLE-FLAG-LP-A
472300                                    MM14-PROD-SETTLE-FLAG-RP-A
472400         MOVE DFHBMASK           TO MM14-PROD-SETTLE-FLAG-A
472500         GO TO Y139-EXIT.
472600*
472700     IF  MBCA-PTI-FUNCTION-IS-ADD
472800         IF  MMFS-MT-REQUIRED (X-MMFS-MERCH)
472900             MOVE DFHBMASB       TO MM14-PROD-SETTLE-FLAG-LIT-A
473000         ELSE
473100             IF  MMFS-MT-MAINT-ONLY (X-MMFS-MERCH)
473200                 MOVE ZERO       TO MM14-PROD-SETTLE-FLAG-L
473300                 MOVE DFHBMDAS   TO MM14-PROD-SETTLE-FLAG-LP-A
473400                                    MM14-PROD-SETTLE-FLAG-RP-A
473500                 MOVE DFHBMASK   TO MM14-PROD-SETTLE-FLAG-A.
473600*
473700     IF  MBCA-PTI-FUNCTION-IS-MAINT
473800         IF  MMFS-MT-NO-MAINT (X-MMFS-MERCH)
473900             MOVE ZERO           TO MM14-PROD-SETTLE-FLAG-L
474000             MOVE DFHBMDAS       TO MM14-PROD-SETTLE-FLAG-LP-A
474100                                    MM14-PROD-SETTLE-FLAG-RP-A
474200             MOVE DFHBMASK       TO MM14-PROD-SETTLE-FLAG-A.
474300*
474400 Y139-EXIT.
474500     EXIT.
474600*
474700 Y170-MOVE-RESV-1-FEE-BASE.
474800*
474900     MOVE MMMP-PROD-RESV-FEE-BASE (1)
475000                                 TO MM14-PROD-RESV-1-FEE-BASE.
475100*
475200 Y175-RESV-1-FEE-BASE-SECURITY.
475300*
475400     MOVE MMMMTB-PROD-RESV-1-FEE-BASE (1:4)
475500                                 TO WS-INDEX-X.
475600     SET  X-MMFS-MERCH           TO WS-INDEX.
475700*
475800     IF  MMFS-MT-NO-ACCESS (X-MMFS-MERCH)
475900         MOVE DFHBMDAS           TO MM14-PROD-RESERVE-1-LIT-A
476000                                    MM14-PROD-RESV-1-FEE-BASE-LP-A
476100                                    MM14-PROD-RESV-1-FEE-BASE-RP-A
476200                                    MM14-PROD-RESV-1-FEE-BASE-A
476300         MOVE ZERO               TO MM14-PROD-RESV-1-FEE-BASE-L
476400         GO TO Y179-EXIT.
476500*
476600     IF  MBCA-PTI-FUNCTION-IS-INQUIRY
476700         MOVE DFHBMDAS           TO MM14-PROD-RESV-1-FEE-BASE-LP-A
476800                                    MM14-PROD-RESV-1-FEE-BASE-RP-A
476900         MOVE DFHBMASB           TO MM14-PROD-RESV-1-FEE-BASE-A
477000         GO TO Y179-EXIT.
477100*
477200     IF  MMFS-MT-INQ-ONLY (X-MMFS-MERCH)
477300         MOVE ZERO               TO MM14-PROD-RESV-1-FEE-BASE-L
477400         MOVE DFHBMDAS           TO MM14-PROD-RESV-1-FEE-BASE-LP-A
477500                                    MM14-PROD-RESV-1-FEE-BASE-RP-A
477600         MOVE DFHBMASK           TO MM14-PROD-RESV-1-FEE-BASE-A
477700         GO TO Y179-EXIT.
477800*
477900     IF  MBCA-PTI-FUNCTION-IS-ADD
478000         IF  MMFS-MT-REQUIRED (X-MMFS-MERCH)
478100             MOVE DFHBMASB       TO MM14-PROD-RESERVE-1-LIT-A
478200         ELSE
478300             IF  MMFS-MT-MAINT-ONLY (X-MMFS-MERCH)
478400                 MOVE ZERO       TO MM14-PROD-RESV-1-FEE-BASE-L
478500                 MOVE DFHBMDAS   TO MM14-PROD-RESV-1-FEE-BASE-LP-A
478600                                    MM14-PROD-RESV-1-FEE-BASE-RP-A
478700                 MOVE DFHBMASK   TO MM14-PROD-RESV-1-FEE-BASE-A.
478800*
478900     IF  MBCA-PTI-FUNCTION-IS-MAINT
479000         IF  MMFS-MT-NO-MAINT (X-MMFS-MERCH)
479100             MOVE ZERO           TO MM14-PROD-RESV-1-FEE-BASE-L
479200             MOVE DFHBMDAS       TO MM14-PROD-RESV-1-FEE-BASE-LP-A
479300                                    MM14-PROD-RESV-1-FEE-BASE-RP-A
479400             MOVE DFHBMASK       TO MM14-PROD-RESV-1-FEE-BASE-A.
479500*
479600*
479700 Y179-EXIT.
479800     EXIT.
479900*
480000 Y190-MOVE-RESV-1-TABLE.
480100*
480200     MOVE MMMP-PROD-RESV-RATE-TABLE (1)
480300                                 TO MM14-PROD-RESV-1-RATE-TBL.
480400*
480500 Y195-RESV-1-RATE-TBL-SECURITY.
480600*
480700     MOVE MMMMTB-PROD-RESV-1-RATE-TABLE (1:4)
480800                                 TO WS-INDEX-X.
480900     SET  X-MMFS-MERCH           TO WS-INDEX.
481000*
481100     IF  MMFS-MT-NO-ACCESS (X-MMFS-MERCH)
481200         MOVE DFHBMDAS           TO MM14-PROD-RESERVE-1-LIT-A
481300                                    MM14-PROD-RESV-1-RATE-TBL-LP-A
481400                                    MM14-PROD-RESV-1-RATE-TBL-RP-A
481500                                    MM14-PROD-RESV-1-RATE-TBL-A
481600         MOVE ZERO               TO MM14-PROD-RESV-1-RATE-TBL-L
481700         GO TO Y199-EXIT.
481800*
481900     IF  MBCA-PTI-FUNCTION-IS-INQUIRY
482000         MOVE DFHBMDAS           TO MM14-PROD-RESV-1-RATE-TBL-LP-A
482100                                    MM14-PROD-RESV-1-RATE-TBL-RP-A
482200         MOVE DFHBMASB           TO MM14-PROD-RESV-1-RATE-TBL-A
482300         GO TO Y199-EXIT.
482400*
482500     IF  MMFS-MT-INQ-ONLY (X-MMFS-MERCH)
482600         MOVE ZERO               TO MM14-PROD-RESV-1-RATE-TBL-L
482700         MOVE DFHBMDAS           TO MM14-PROD-RESV-1-RATE-TBL-LP-A
482800                                    MM14-PROD-RESV-1-RATE-TBL-RP-A
482900         MOVE DFHBMASK           TO MM14-PROD-RESV-1-RATE-TBL-A
483000         GO TO Y199-EXIT.
483100*
483200     IF  MBCA-PTI-FUNCTION-IS-ADD
483300         IF  MMFS-MT-REQUIRED (X-MMFS-MERCH)
483400             MOVE DFHBMASB       TO MM14-PROD-RESERVE-1-LIT-A
483500         ELSE
483600             IF  MMFS-MT-MAINT-ONLY (X-MMFS-MERCH)
483700                 MOVE ZERO       TO MM14-PROD-RESV-1-RATE-TBL-L
483800                 MOVE DFHBMDAS   TO MM14-PROD-RESV-1-RATE-TBL-LP-A
483900                                    MM14-PROD-RESV-1-RATE-TBL-RP-A
484000                 MOVE DFHBMASK   TO MM14-PROD-RESV-1-RATE-TBL-A.
484100*
484200     IF  MBCA-PTI-FUNCTION-IS-MAINT
484300         IF  MMFS-MT-NO-MAINT (X-MMFS-MERCH)
484400             MOVE ZERO           TO MM14-PROD-RESV-1-RATE-TBL-L
484500             MOVE DFHBMDAS       TO MM14-PROD-RESV-1-RATE-TBL-LP-A
484600                                    MM14-PROD-RESV-1-RATE-TBL-RP-A
484700             MOVE DFHBMASK       TO MM14-PROD-RESV-1-RATE-TBL-A.
484800*
484900 Y199-EXIT.
485000     EXIT.
485100*
485200 Y210-MOVE-SOURCE.
485300*
485400     MOVE MMMP-PROD-SOURCE       TO MM14-PROD-SOURCE.
485500*
485600 Y215-SOURCE-SECURITY.
485700*
485800     MOVE MMMMTB-PROD-SOURCE (1:4)
485900                                 TO WS-INDEX-X.
486000     SET  X-MMFS-MERCH           TO WS-INDEX.
486100*
486200     IF  MMFS-MT-NO-ACCESS (X-MMFS-MERCH)
486300         MOVE DFHBMDAS           TO MM14-PROD-SOURCE-LIT-A
486400                                    MM14-PROD-SOURCE-LP-A
486500                                    MM14-PROD-SOURCE-RP-A
486600                                    MM14-PROD-SOURCE-A
486700         MOVE ZERO               TO MM14-PROD-SOURCE-L
486800         GO TO Y219-EXIT.
486900*
487000     IF  MBCA-PTI-FUNCTION-IS-INQUIRY
487100         MOVE DFHBMDAS           TO MM14-PROD-SOURCE-LP-A
487200                                    MM14-PROD-SOURCE-RP-A
487300         MOVE DFHBMASB           TO MM14-PROD-SOURCE-A
487400         GO TO Y219-EXIT.
487500*
487600     IF  MMFS-MT-INQ-ONLY (X-MMFS-MERCH)
487700         MOVE ZERO               TO MM14-PROD-SOURCE-L
487800         MOVE DFHBMDAS           TO MM14-PROD-SOURCE-LP-A
487900                                    MM14-PROD-SOURCE-RP-A
488000         MOVE DFHBMASK           TO MM14-PROD-SOURCE-A
488100         GO TO Y219-EXIT.
488200*
488300     IF  MBCA-PTI-FUNCTION-IS-ADD
488400         IF  MMFS-MT-REQUIRED (X-MMFS-MERCH)
488500             MOVE DFHBMASB       TO MM14-PROD-SOURCE-LIT-A
488600         ELSE
488700             IF  MMFS-MT-MAINT-ONLY (X-MMFS-MERCH)
488800                 MOVE ZERO       TO MM14-PROD-SOURCE-L
488900                 MOVE DFHBMDAS   TO MM14-PROD-SOURCE-LP-A
489000                                    MM14-PROD-SOURCE-RP-A
489100                 MOVE DFHBMASK   TO MM14-PROD-SOURCE-A.
489200*
489300     IF  MBCA-PTI-FUNCTION-IS-MAINT
489400         IF  MMFS-MT-NO-MAINT (X-MMFS-MERCH)
489500             MOVE ZERO           TO MM14-PROD-SOURCE-L
489600             MOVE DFHBMDAS       TO MM14-PROD-SOURCE-LP-A
489700                                    MM14-PROD-SOURCE-RP-A
489800             MOVE DFHBMASK       TO MM14-PROD-SOURCE-A.
489900*
490000 Y219-EXIT.
490100     EXIT.
490200*
490300 Y230-MOVE-RESV-2-FEE-BASE.
490400*
490500     MOVE MMMP-PROD-RESV-FEE-BASE (2)
490600                                 TO MM14-PROD-RESV-2-FEE-BASE.
490700*
490800 Y235-RESV-2-FEE-BASE-SECURITY.
490900*
491000     MOVE MMMMTB-PROD-RESV-2-FEE-BASE (1:4)
491100                                 TO WS-INDEX-X.
491200     SET  X-MMFS-MERCH           TO WS-INDEX.
491300*
491400     IF  MMFS-MT-NO-ACCESS (X-MMFS-MERCH)
491500         MOVE DFHBMDAS           TO MM14-PROD-RESERVE-2-LIT-A
491600                                    MM14-PROD-RESV-2-FEE-BASE-LP-A
491700                                    MM14-PROD-RESV-2-FEE-BASE-RP-A
491800                                    MM14-PROD-RESV-2-FEE-BASE-A
491900         MOVE ZERO               TO MM14-PROD-RESV-2-FEE-BASE-L
492000         GO TO Y239-EXIT.
492100*
492200     IF  MBCA-PTI-FUNCTION-IS-INQUIRY
492300         MOVE DFHBMDAS           TO MM14-PROD-RESV-2-FEE-BASE-LP-A
492400                                    MM14-PROD-RESV-2-FEE-BASE-RP-A
492500         MOVE DFHBMASB           TO MM14-PROD-RESV-2-FEE-BASE-A
492600         GO TO Y239-EXIT.
492700*
492800     IF  MMFS-MT-INQ-ONLY (X-MMFS-MERCH)
492900         MOVE ZERO               TO MM14-PROD-RESV-2-FEE-BASE-L
493000         MOVE DFHBMDAS           TO MM14-PROD-RESV-2-FEE-BASE-LP-A
493100                                    MM14-PROD-RESV-2-FEE-BASE-RP-A
493200         MOVE DFHBMASK           TO MM14-PROD-RESV-2-FEE-BASE-A
493300         GO TO Y239-EXIT.
493400*
493500     IF  MBCA-PTI-FUNCTION-IS-ADD
493600         IF  MMFS-MT-REQUIRED (X-MMFS-MERCH)
493700             MOVE DFHBMASB       TO MM14-PROD-RESERVE-2-LIT-A
493800         ELSE
493900             IF  MMFS-MT-MAINT-ONLY (X-MMFS-MERCH)
494000                 MOVE ZERO       TO MM14-PROD-RESV-2-FEE-BASE-L
494100                 MOVE DFHBMDAS   TO MM14-PROD-RESV-2-FEE-BASE-LP-A
494200                                    MM14-PROD-RESV-2-FEE-BASE-RP-A
494300                 MOVE DFHBMASK   TO MM14-PROD-RESV-2-FEE-BASE-A.
494400*
494500     IF  MBCA-PTI-FUNCTION-IS-MAINT
494600         IF  MMFS-MT-NO-MAINT (X-MMFS-MERCH)
494700             MOVE ZERO           TO MM14-PROD-RESV-2-FEE-BASE-L
494800             MOVE DFHBMDAS       TO MM14-PROD-RESV-2-FEE-BASE-LP-A
494900                                    MM14-PROD-RESV-2-FEE-BASE-RP-A
495000             MOVE DFHBMASK       TO MM14-PROD-RESV-2-FEE-BASE-A.
495100*
495200*
495300 Y239-EXIT.
495400     EXIT.
495500*
495600 Y250-MOVE-RESV-2-TABLE.
495700*
495800     MOVE MMMP-PROD-RESV-RATE-TABLE (2)
495900                                 TO MM14-PROD-RESV-2-RATE-TBL.
496000*
496100 Y255-RESV-2-RATE-TBL-SECURITY.
496200*
496300     MOVE MMMMTB-PROD-RESV-2-RATE-TABLE (1:4)
496400                                 TO WS-INDEX-X.
496500     SET  X-MMFS-MERCH           TO WS-INDEX.
496600*
496700     IF  MMFS-MT-NO-ACCESS (X-MMFS-MERCH)
496800         MOVE DFHBMDAS           TO MM14-PROD-RESERVE-2-LIT-A
496900                                    MM14-PROD-RESV-2-RATE-TBL-LP-A
497000                                    MM14-PROD-RESV-2-RATE-TBL-RP-A
497100                                    MM14-PROD-RESV-2-RATE-TBL-A
497200         MOVE ZERO               TO MM14-PROD-RESV-2-RATE-TBL-L
497300         GO TO Y259-EXIT.
497400*
497500     IF  MBCA-PTI-FUNCTION-IS-INQUIRY
497600         MOVE DFHBMDAS           TO MM14-PROD-RESV-2-RATE-TBL-LP-A
497700                                    MM14-PROD-RESV-2-RATE-TBL-RP-A
497800         MOVE DFHBMASB           TO MM14-PROD-RESV-2-RATE-TBL-A
497900         GO TO Y259-EXIT.
498000*
498100     IF  MMFS-MT-INQ-ONLY (X-MMFS-MERCH)
498200         MOVE ZERO               TO MM14-PROD-RESV-2-RATE-TBL-L
498300         MOVE DFHBMDAS           TO MM14-PROD-RESV-2-RATE-TBL-LP-A
498400                                    MM14-PROD-RESV-2-RATE-TBL-RP-A
498500         MOVE DFHBMASK           TO MM14-PROD-RESV-2-RATE-TBL-A
498600         GO TO Y259-EXIT.
498700*
498800     IF  MBCA-PTI-FUNCTION-IS-ADD
498900         IF  MMFS-MT-REQUIRED (X-MMFS-MERCH)
499000             MOVE DFHBMASB       TO MM14-PROD-RESERVE-2-LIT-A
499100         ELSE
499200             IF  MMFS-MT-MAINT-ONLY (X-MMFS-MERCH)
499300                 MOVE ZERO       TO MM14-PROD-RESV-2-RATE-TBL-L
499400                 MOVE DFHBMDAS   TO MM14-PROD-RESV-2-RATE-TBL-LP-A
499500                                    MM14-PROD-RESV-2-RATE-TBL-RP-A
499600                 MOVE DFHBMASK   TO MM14-PROD-RESV-2-RATE-TBL-A.
499700*
499800     IF  MBCA-PTI-FUNCTION-IS-MAINT
499900         IF  MMFS-MT-NO-MAINT (X-MMFS-MERCH)
500000             MOVE ZERO           TO MM14-PROD-RESV-2-RATE-TBL-L
500100             MOVE DFHBMDAS       TO MM14-PROD-RESV-2-RATE-TBL-LP-A
500200                                    MM14-PROD-RESV-2-RATE-TBL-RP-A
500300             MOVE DFHBMASK       TO MM14-PROD-RESV-2-RATE-TBL-A.
500400*
500500 Y259-EXIT.
500600     EXIT.
500700*
500800 Y270-MOVE-SHORT-DESC.
500900*
501000     MOVE MMMP-PROD-SHORT-DESC   TO MM14-PROD-SHORT-DESC.
501100*
501200 Y275-SHORT-DESC-SECURITY.
501300*
501400     MOVE MMMMTB-PROD-SHORT-DESC (1:4)
501500                                 TO WS-INDEX-X.
501600     SET  X-MMFS-MERCH           TO WS-INDEX.
501700*
501800     IF  MMFS-MT-NO-ACCESS (X-MMFS-MERCH)
501900         MOVE DFHBMDAS           TO MM14-PROD-SHORT-DESC-LIT-A
502000                                    MM14-PROD-SHORT-DESC-LP-A
502100                                    MM14-PROD-SHORT-DESC-RP-A
502200                                    MM14-PROD-SHORT-DESC-A
502300         MOVE ZERO               TO MM14-PROD-SHORT-DESC-L
502400         GO TO Y279-EXIT.
502500*
502600     IF  MBCA-PTI-FUNCTION-IS-INQUIRY
502700         MOVE DFHBMDAS           TO MM14-PROD-SHORT-DESC-LP-A
502800                                    MM14-PROD-SHORT-DESC-RP-A
502900         MOVE DFHBMASB           TO MM14-PROD-SHORT-DESC-A
503000         GO TO Y279-EXIT.
503100*
503200     IF  MMFS-MT-INQ-ONLY (X-MMFS-MERCH)
503300         MOVE ZERO               TO MM14-PROD-SHORT-DESC-L
503400         MOVE DFHBMDAS           TO MM14-PROD-SHORT-DESC-LP-A
503500                                    MM14-PROD-SHORT-DESC-RP-A
503600         MOVE DFHBMASK           TO MM14-PROD-SHORT-DESC-A
503700         GO TO Y279-EXIT.
503800*
503900     IF  MBCA-PTI-FUNCTION-IS-ADD
504000         IF  MMFS-MT-REQUIRED (X-MMFS-MERCH)
504100             MOVE DFHBMASB       TO MM14-PROD-SHORT-DESC-LIT-A
504200         ELSE
504300             IF  MMFS-MT-MAINT-ONLY (X-MMFS-MERCH)
504400                 MOVE ZERO       TO MM14-PROD-SHORT-DESC-L
504500                 MOVE DFHBMDAS   TO MM14-PROD-SHORT-DESC-LP-A
504600                                    MM14-PROD-SHORT-DESC-RP-A
504700                 MOVE DFHBMASK   TO MM14-PROD-SHORT-DESC-A.
504800*
504900     IF  MBCA-PTI-FUNCTION-IS-MAINT
505000         IF  MMFS-MT-NO-MAINT (X-MMFS-MERCH)
505100             MOVE ZERO           TO MM14-PROD-SHORT-DESC-L
505200             MOVE DFHBMDAS       TO MM14-PROD-SHORT-DESC-LP-A
505300                                    MM14-PROD-SHORT-DESC-RP-A
505400             MOVE DFHBMASK       TO MM14-PROD-SHORT-DESC-A.
505500*
505600 Y279-EXIT.
505700     EXIT.
505800*
505900 Y290-MOVE-RESV-3-FEE-BASE.
506000*
506100     MOVE MMMP-PROD-RESV-FEE-BASE (3)
506200                                 TO MM14-PROD-RESV-3-FEE-BASE.
506300*
506400 Y295-RESV-3-FEE-BASE-SECURITY.
506500*
506600     MOVE MMMMTB-PROD-RESV-3-FEE-BASE (1:4)
506700                                 TO WS-INDEX-X.
506800     SET  X-MMFS-MERCH           TO WS-INDEX.
506900*
507000     IF  MMFS-MT-NO-ACCESS (X-MMFS-MERCH)
507100         MOVE DFHBMDAS           TO MM14-PROD-RESERVE-3-LIT-A
507200                                    MM14-PROD-RESV-3-FEE-BASE-LP-A
507300                                    MM14-PROD-RESV-3-FEE-BASE-RP-A
507400                                    MM14-PROD-RESV-3-FEE-BASE-A
507500         MOVE ZERO               TO MM14-PROD-RESV-3-FEE-BASE-L
507600         GO TO Y299-EXIT.
507700*
507800     IF  MBCA-PTI-FUNCTION-IS-INQUIRY
507900         MOVE DFHBMDAS           TO MM14-PROD-RESV-3-FEE-BASE-LP-A
508000                                    MM14-PROD-RESV-3-FEE-BASE-RP-A
508100         MOVE DFHBMASB           TO MM14-PROD-RESV-3-FEE-BASE-A
508200         GO TO Y299-EXIT.
508300*
508400     IF  MMFS-MT-INQ-ONLY (X-MMFS-MERCH)
508500         MOVE ZERO               TO MM14-PROD-RESV-3-FEE-BASE-L
508600         MOVE DFHBMDAS           TO MM14-PROD-RESV-3-FEE-BASE-LP-A
508700                                    MM14-PROD-RESV-3-FEE-BASE-RP-A
508800         MOVE DFHBMASK           TO MM14-PROD-RESV-3-FEE-BASE-A
508900         GO TO Y299-EXIT.
509000*
509100     IF  MBCA-PTI-FUNCTION-IS-ADD
509200         IF  MMFS-MT-REQUIRED (X-MMFS-MERCH)
509300             MOVE DFHBMASB       TO MM14-PROD-RESERVE-3-LIT-A
509400         ELSE
509500             IF  MMFS-MT-MAINT-ONLY (X-MMFS-MERCH)
509600                 MOVE ZERO       TO MM14-PROD-RESV-3-FEE-BASE-L
509700                 MOVE DFHBMDAS   TO MM14-PROD-RESV-3-FEE-BASE-LP-A
509800                                    MM14-PROD-RESV-3-FEE-BASE-RP-A
509900                 MOVE DFHBMASK   TO MM14-PROD-RESV-3-FEE-BASE-A.
510000*
510100     IF  MBCA-PTI-FUNCTION-IS-MAINT
510200         IF  MMFS-MT-NO-MAINT (X-MMFS-MERCH)
510300             MOVE ZERO           TO MM14-PROD-RESV-3-FEE-BASE-L
510400             MOVE DFHBMDAS       TO MM14-PROD-RESV-3-FEE-BASE-LP-A
510500                                    MM14-PROD-RESV-3-FEE-BASE-RP-A
510600             MOVE DFHBMASK       TO MM14-PROD-RESV-3-FEE-BASE-A.
510700*
510800*
510900 Y299-EXIT.
511000     EXIT.
511100*
511200 Y310-MOVE-RESV-3-TABLE.
511300*
511400     MOVE MMMP-PROD-RESV-RATE-TABLE (3)
511500                                 TO MM14-PROD-RESV-3-RATE-TBL.
511600*
511700 Y315-RESV-3-RATE-TBL-SECURITY.
511800*
511900     MOVE MMMMTB-PROD-RESV-3-RATE-TABLE (1:4)
512000                                 TO WS-INDEX-X.
512100     SET  X-MMFS-MERCH           TO WS-INDEX.
512200*
512300     IF  MMFS-MT-NO-ACCESS (X-MMFS-MERCH)
512400         MOVE DFHBMDAS           TO MM14-PROD-RESERVE-3-LIT-A
512500                                    MM14-PROD-RESV-3-RATE-TBL-LP-A
512600                                    MM14-PROD-RESV-3-RATE-TBL-RP-A
512700                                    MM14-PROD-RESV-3-RATE-TBL-A
512800         MOVE ZERO               TO MM14-PROD-RESV-3-RATE-TBL-L
512900         GO TO Y319-EXIT.
513000*
513100     IF  MBCA-PTI-FUNCTION-IS-INQUIRY
513200         MOVE DFHBMDAS           TO MM14-PROD-RESV-3-RATE-TBL-LP-A
513300                                    MM14-PROD-RESV-3-RATE-TBL-RP-A
513400         MOVE DFHBMASB           TO MM14-PROD-RESV-3-RATE-TBL-A
513500         GO TO Y319-EXIT.
513600*
513700     IF  MMFS-MT-INQ-ONLY (X-MMFS-MERCH)
513800         MOVE ZERO               TO MM14-PROD-RESV-3-RATE-TBL-L
513900         MOVE DFHBMDAS           TO MM14-PROD-RESV-3-RATE-TBL-LP-A
514000                                    MM14-PROD-RESV-3-RATE-TBL-RP-A
514100         MOVE DFHBMASK           TO MM14-PROD-RESV-3-RATE-TBL-A
514200         GO TO Y319-EXIT.
514300*
514400     IF  MBCA-PTI-FUNCTION-IS-ADD
514500         IF  MMFS-MT-REQUIRED (X-MMFS-MERCH)
514600             MOVE DFHBMASB       TO MM14-PROD-RESERVE-3-LIT-A
514700         ELSE
514800             IF  MMFS-MT-MAINT-ONLY (X-MMFS-MERCH)
514900                 MOVE ZERO       TO MM14-PROD-RESV-3-RATE-TBL-L
515000                 MOVE DFHBMDAS   TO MM14-PROD-RESV-3-RATE-TBL-LP-A
515100                                    MM14-PROD-RESV-3-RATE-TBL-RP-A
515200                 MOVE DFHBMASK   TO MM14-PROD-RESV-3-RATE-TBL-A.
515300*
515400     IF  MBCA-PTI-FUNCTION-IS-MAINT
515500         IF  MMFS-MT-NO-MAINT (X-MMFS-MERCH)
515600             MOVE ZERO           TO MM14-PROD-RESV-3-RATE-TBL-L
515700             MOVE DFHBMDAS       TO MM14-PROD-RESV-3-RATE-TBL-LP-A
515800                                    MM14-PROD-RESV-3-RATE-TBL-RP-A
515900             MOVE DFHBMASK       TO MM14-PROD-RESV-3-RATE-TBL-A.
516000*
516100 Y319-EXIT.
516200     EXIT.
516300*
516400 Y330-MOVE-RESV-4-FEE-BASE.
516500*
516600     MOVE MMMP-PROD-RESV-FEE-BASE (4)
516700                                 TO MM14-PROD-RESV-4-FEE-BASE.
516800*
516900 Y335-RESV-4-FEE-BASE-SECURITY.
517000*
517100     MOVE MMMMTB-PROD-RESV-4-FEE-BASE (1:4)
517200                                 TO WS-INDEX-X.
517300     SET  X-MMFS-MERCH           TO WS-INDEX.
517400*
517500     IF  MMFS-MT-NO-ACCESS (X-MMFS-MERCH)
517600         MOVE DFHBMDAS           TO MM14-PROD-RESERVE-4-LIT-A
517700                                    MM14-PROD-RESV-4-FEE-BASE-LP-A
517800                                    MM14-PROD-RESV-4-FEE-BASE-RP-A
517900                                    MM14-PROD-RESV-4-FEE-BASE-A
518000         MOVE ZERO               TO MM14-PROD-RESV-4-FEE-BASE-L
518100         GO TO Y339-EXIT.
518200*
518300     IF  MBCA-PTI-FUNCTION-IS-INQUIRY
518400         MOVE DFHBMDAS           TO MM14-PROD-RESV-4-FEE-BASE-LP-A
518500                                    MM14-PROD-RESV-4-FEE-BASE-RP-A
518600         MOVE DFHBMASB           TO MM14-PROD-RESV-4-FEE-BASE-A
518700         GO TO Y339-EXIT.
518800*
518900     IF  MMFS-MT-INQ-ONLY (X-MMFS-MERCH)
519000         MOVE ZERO               TO MM14-PROD-RESV-4-FEE-BASE-L
519100         MOVE DFHBMDAS           TO MM14-PROD-RESV-4-FEE-BASE-LP-A
519200                                    MM14-PROD-RESV-4-FEE-BASE-RP-A
519300         MOVE DFHBMASK           TO MM14-PROD-RESV-4-FEE-BASE-A
519400         GO TO Y339-EXIT.
519500*
519600     IF  MBCA-PTI-FUNCTION-IS-ADD
519700         IF  MMFS-MT-REQUIRED (X-MMFS-MERCH)
519800             MOVE DFHBMASB       TO MM14-PROD-RESERVE-4-LIT-A
519900         ELSE
520000             IF  MMFS-MT-MAINT-ONLY (X-MMFS-MERCH)
520100                 MOVE ZERO       TO MM14-PROD-RESV-4-FEE-BASE-L
520200                 MOVE DFHBMDAS   TO MM14-PROD-RESV-4-FEE-BASE-LP-A
520300                                    MM14-PROD-RESV-4-FEE-BASE-RP-A
520400                 MOVE DFHBMASK   TO MM14-PROD-RESV-4-FEE-BASE-A.
520500*
520600     IF  MBCA-PTI-FUNCTION-IS-MAINT
520700         IF  MMFS-MT-NO-MAINT (X-MMFS-MERCH)
520800             MOVE ZERO           TO MM14-PROD-RESV-4-FEE-BASE-L
520900             MOVE DFHBMDAS       TO MM14-PROD-RESV-4-FEE-BASE-LP-A
521000                                    MM14-PROD-RESV-4-FEE-BASE-RP-A
521100             MOVE DFHBMASK       TO MM14-PROD-RESV-4-FEE-BASE-A.
521200*
521300*
521400 Y339-EXIT.
521500     EXIT.
521600*
521700 Y350-MOVE-RESV-4-TABLE.
521800*
521900     MOVE MMMP-PROD-RESV-RATE-TABLE (4)
522000                                 TO MM14-PROD-RESV-4-RATE-TBL.
522100*
522200 Y355-RESV-4-RATE-TBL-SECURITY.
522300*
522400     MOVE MMMMTB-PROD-RESV-4-RATE-TABLE (1:4)
522500                                 TO WS-INDEX-X.
522600     SET  X-MMFS-MERCH           TO WS-INDEX.
522700*
522800     IF  MMFS-MT-NO-ACCESS (X-MMFS-MERCH)
522900         MOVE DFHBMDAS           TO MM14-PROD-RESERVE-4-LIT-A
523000                                    MM14-PROD-RESV-4-RATE-TBL-LP-A
523100                                    MM14-PROD-RESV-4-RATE-TBL-RP-A
523200                                    MM14-PROD-RESV-4-RATE-TBL-A
523300         MOVE ZERO               TO MM14-PROD-RESV-4-RATE-TBL-L
523400         GO TO Y359-EXIT.
523500*
523600     IF  MBCA-PTI-FUNCTION-IS-INQUIRY
523700         MOVE DFHBMDAS           TO MM14-PROD-RESV-4-RATE-TBL-LP-A
523800                                    MM14-PROD-RESV-4-RATE-TBL-RP-A
523900         MOVE DFHBMASB           TO MM14-PROD-RESV-4-RATE-TBL-A
524000         GO TO Y359-EXIT.
524100*
524200     IF  MMFS-MT-INQ-ONLY (X-MMFS-MERCH)
524300         MOVE ZERO               TO MM14-PROD-RESV-4-RATE-TBL-L
524400         MOVE DFHBMDAS           TO MM14-PROD-RESV-4-RATE-TBL-LP-A
524500                                    MM14-PROD-RESV-4-RATE-TBL-RP-A
524600         MOVE DFHBMASK           TO MM14-PROD-RESV-4-RATE-TBL-A
524700         GO TO Y359-EXIT.
524800*
524900     IF  MBCA-PTI-FUNCTION-IS-ADD
525000         IF  MMFS-MT-REQUIRED (X-MMFS-MERCH)
525100             MOVE DFHBMASB       TO MM14-PROD-RESERVE-4-LIT-A
525200         ELSE
525300             IF  MMFS-MT-MAINT-ONLY (X-MMFS-MERCH)
525400                 MOVE ZERO       TO MM14-PROD-RESV-4-RATE-TBL-L
525500                 MOVE DFHBMDAS   TO MM14-PROD-RESV-4-RATE-TBL-LP-A
525600                                    MM14-PROD-RESV-4-RATE-TBL-RP-A
525700                 MOVE DFHBMASK   TO MM14-PROD-RESV-4-RATE-TBL-A.
525800*
525900     IF  MBCA-PTI-FUNCTION-IS-MAINT
526000         IF  MMFS-MT-NO-MAINT (X-MMFS-MERCH)
526100             MOVE ZERO           TO MM14-PROD-RESV-4-RATE-TBL-L
526200             MOVE DFHBMDAS       TO MM14-PROD-RESV-4-RATE-TBL-LP-A
526300                                    MM14-PROD-RESV-4-RATE-TBL-RP-A
526400             MOVE DFHBMASK       TO MM14-PROD-RESV-4-RATE-TBL-A.
526500*
526600 Y359-EXIT.
526700     EXIT.
526800*
526900 Y370-MOVE-USER-CODE.
527000*
527100     MOVE MMMP-PROD-USER-CODE    TO MM14-PROD-USER-CODE.
527200*
527300 Y375-USER-CODE-SECURITY.
527400*
527500     MOVE MMMMTB-PROD-USER-CODE (1:4)
527600                                 TO WS-INDEX-X.
527700     SET  X-MMFS-MERCH           TO WS-INDEX.
527800*
527900     IF  MMFS-MT-NO-ACCESS (X-MMFS-MERCH)
528000         MOVE DFHBMDAS           TO MM14-PROD-USER-CODE-LIT-A
528100                                    MM14-PROD-USER-CODE-LP-A
528200                                    MM14-PROD-USER-CODE-RP-A
528300                                    MM14-PROD-USER-CODE-A
528400         MOVE ZERO               TO MM14-PROD-USER-CODE-L
528500         GO TO Y379-EXIT.
528600*
528700     IF  MBCA-PTI-FUNCTION-IS-INQUIRY
528800         MOVE DFHBMDAS           TO MM14-PROD-USER-CODE-LP-A
528900                                    MM14-PROD-USER-CODE-RP-A
529000         MOVE DFHBMASB           TO MM14-PROD-USER-CODE-A
529100         GO TO Y379-EXIT.
529200*
529300     IF  MMFS-MT-INQ-ONLY (X-MMFS-MERCH)
529400         MOVE ZERO               TO MM14-PROD-USER-CODE-L
529500         MOVE DFHBMDAS           TO MM14-PROD-USER-CODE-LP-A
529600                                    MM14-PROD-USER-CODE-RP-A
529700         MOVE DFHBMASK           TO MM14-PROD-USER-CODE-A
529800         GO TO Y379-EXIT.
529900*
530000     IF  MBCA-PTI-FUNCTION-IS-ADD
530100         IF  MMFS-MT-REQUIRED (X-MMFS-MERCH)
530200             MOVE DFHBMASB       TO MM14-PROD-USER-CODE-LIT-A
530300         ELSE
530400             IF  MMFS-MT-MAINT-ONLY (X-MMFS-MERCH)
530500                 MOVE ZERO       TO MM14-PROD-USER-CODE-L
530600                 MOVE DFHBMDAS   TO MM14-PROD-USER-CODE-LP-A
530700                                    MM14-PROD-USER-CODE-RP-A
530800                 MOVE DFHBMASK   TO MM14-PROD-USER-CODE-A.
530900*
531000     IF  MBCA-PTI-FUNCTION-IS-MAINT
531100         IF  MMFS-MT-NO-MAINT (X-MMFS-MERCH)
531200             MOVE ZERO           TO MM14-PROD-USER-CODE-L
531300             MOVE DFHBMDAS       TO MM14-PROD-USER-CODE-LP-A
531400                                    MM14-PROD-USER-CODE-RP-A
531500             MOVE DFHBMASK       TO MM14-PROD-USER-CODE-A.
531600*
531700 Y379-EXIT.
531800     EXIT.
531900*
532000 Y390-MOVE-INTCHG-FEE-BASE.
532100*
532200     MOVE MMMP-PROD-INTCHG-FEE-BASE
532300                                 TO MM14-PROD-INTCHG-FEE-BASE.
532400*
532500 Y395-INTCHG-FEE-BASE-SECURITY.
532600*
532700     MOVE MMMMTB-PROD-INTCHG-FEE-BASE (1:4)
532800                                 TO WS-INDEX-X.
532900     SET  X-MMFS-MERCH           TO WS-INDEX.
533000*
533100     IF  MMFS-MT-NO-ACCESS (X-MMFS-MERCH)
533200         MOVE DFHBMDAS           TO MM14-PROD-INTCHG-FB-LIT-A
533300                                    MM14-PROD-INTCHG-FEE-BASE-LP-A
533400                                    MM14-PROD-INTCHG-FEE-BASE-RP-A
533500                                    MM14-PROD-INTCHG-FEE-BASE-A
533600         MOVE ZERO               TO MM14-PROD-INTCHG-FEE-BASE-L
533700         GO TO Y399-EXIT.
533800*
533900     IF  MBCA-PTI-FUNCTION-IS-INQUIRY
534000         MOVE DFHBMDAS           TO MM14-PROD-INTCHG-FEE-BASE-LP-A
534100                                    MM14-PROD-INTCHG-FEE-BASE-RP-A
534200         MOVE DFHBMASB           TO MM14-PROD-INTCHG-FEE-BASE-A
534300         GO TO Y399-EXIT.
534400*
534500     IF  MMFS-MT-INQ-ONLY (X-MMFS-MERCH)
534600         MOVE ZERO               TO MM14-PROD-INTCHG-FEE-BASE-L
534700         MOVE DFHBMDAS           TO MM14-PROD-INTCHG-FEE-BASE-LP-A
534800                                    MM14-PROD-INTCHG-FEE-BASE-RP-A
534900         MOVE DFHBMASK           TO MM14-PROD-INTCHG-FEE-BASE-A
535000         GO TO Y399-EXIT.
535100*
535200     IF  MBCA-PTI-FUNCTION-IS-ADD
535300         IF  MMFS-MT-REQUIRED (X-MMFS-MERCH)
535400             MOVE DFHBMASB       TO MM14-PROD-INTCHG-FB-LIT-A
535500         ELSE
535600             IF  MMFS-MT-MAINT-ONLY (X-MMFS-MERCH)
535700                 MOVE ZERO       TO MM14-PROD-INTCHG-FEE-BASE-L
535800                 MOVE DFHBMDAS   TO MM14-PROD-INTCHG-FEE-BASE-LP-A
535900                                    MM14-PROD-INTCHG-FEE-BASE-RP-A
536000                 MOVE DFHBMASK   TO MM14-PROD-INTCHG-FEE-BASE-A.
536100*
536200     IF  MBCA-PTI-FUNCTION-IS-MAINT
536300         IF  MMFS-MT-NO-MAINT (X-MMFS-MERCH)
536400             MOVE ZERO           TO MM14-PROD-INTCHG-FEE-BASE-L
536500             MOVE DFHBMDAS       TO MM14-PROD-INTCHG-FEE-BASE-LP-A
536600                                    MM14-PROD-INTCHG-FEE-BASE-RP-A
536700             MOVE DFHBMASK       TO MM14-PROD-INTCHG-FEE-BASE-A.
536800*
536900 Y399-EXIT.
537000     EXIT.
537100*
537200 Y410-MOVE-DBA-NAME.
537300*
537400     MOVE MMSM-VI-DBA-NAME       TO MM14-VI-DBA-NAME.
537500*
537600 Y415-DBA-NAME-SECURITY.
537700*
537800     MOVE MMSMTB-VI-DBA-NAME (1:4)
537900                                 TO WS-INDEX-X.
538000     SET  X-MMFS-STORE           TO WS-INDEX.
538100*
538200     IF  MMFS-ST-NO-ACCESS (X-MMFS-STORE)
538300         MOVE DFHBMDAS           TO MM14-VI-DBA-NAME-LIT-A
538400                                    MM14-VI-DBA-NAME-LP-A
538500                                    MM14-VI-DBA-NAME-RP-A
538600                                    MM14-VI-DBA-NAME-A
538700         MOVE ZERO               TO MM14-VI-DBA-NAME-L
538800         GO TO Y419-EXIT.
538900*
539000     IF  MBCA-PTI-FUNCTION-IS-INQUIRY
539100         MOVE DFHBMDAS           TO MM14-VI-DBA-NAME-LP-A
539200                                    MM14-VI-DBA-NAME-RP-A
539300         MOVE DFHBMASB           TO MM14-VI-DBA-NAME-A
539400         GO TO Y419-EXIT.
539500*
539600     IF  MMFS-ST-INQ-ONLY (X-MMFS-STORE)
539700         MOVE ZERO               TO MM14-VI-DBA-NAME-L
539800         MOVE DFHBMDAS           TO MM14-VI-DBA-NAME-LP-A
539900                                    MM14-VI-DBA-NAME-RP-A
540000         MOVE DFHBMASK           TO MM14-VI-DBA-NAME-A
540100         GO TO Y419-EXIT.
540200*
540300     IF  MBCA-PTI-FUNCTION-IS-ADD
540400         IF  MMFS-ST-REQUIRED (X-MMFS-STORE)
540500             MOVE DFHBMASB       TO MM14-VI-DBA-NAME-LIT-A
540600         ELSE
540700             IF  MMFS-ST-MAINT-ONLY (X-MMFS-STORE)
540800                 MOVE ZERO       TO MM14-VI-DBA-NAME-L
540900                 MOVE DFHBMDAS   TO MM14-VI-DBA-NAME-LP-A
541000                                    MM14-VI-DBA-NAME-RP-A
541100                 MOVE DFHBMASK   TO MM14-VI-DBA-NAME-A.
541200*
541300     IF  MBCA-PTI-FUNCTION-IS-MAINT
541400         IF  MMFS-ST-NO-MAINT (X-MMFS-STORE)
541500             MOVE ZERO           TO MM14-VI-DBA-NAME-L
541600             MOVE DFHBMDAS       TO MM14-VI-DBA-NAME-LP-A
541700                                    MM14-VI-DBA-NAME-RP-A
541800             MOVE DFHBMASK       TO MM14-VI-DBA-NAME-A.
541900*
542000 Y419-EXIT.
542100     EXIT.
542200*
542300 Y450-MOVE-INTCHG-IND.
542400*
542500     MOVE MMSM-VI-INTCHG-FLAG    TO MM14-VI-INTCHG-FLAG.
542600*
542700 Y455-INTCHG-FLAG-SECURITY.
542800*
542900     MOVE MMSMTB-VI-INTCHG-IND (1:4)
543000                                 TO WS-INDEX-X.
543100     SET  X-MMFS-STORE           TO WS-INDEX.
543200*
543300     IF  MMFS-ST-NO-ACCESS (X-MMFS-STORE)
543400         MOVE DFHBMDAS           TO MM14-VI-INTCHG-FLAG-LP-A
543500                                    MM14-VI-INTCHG-FLAG-RP-A
543600                                    MM14-VI-INTCHG-FLAG-A
543700         MOVE ZERO               TO MM14-VI-INTCHG-FLAG-L
543800         GO TO Y459-EXIT.
543900*
544000     IF  MBCA-PTI-FUNCTION-IS-INQUIRY
544100         MOVE DFHBMDAS           TO MM14-VI-INTCHG-FLAG-LP-A
544200                                    MM14-VI-INTCHG-FLAG-RP-A
544300         MOVE DFHBMASB           TO MM14-VI-INTCHG-FLAG-A
544400         GO TO Y459-EXIT.
544500*
544600     IF  MMFS-ST-INQ-ONLY (X-MMFS-STORE)
544700         MOVE ZERO               TO MM14-VI-INTCHG-FLAG-L
544800         MOVE DFHBMDAS           TO MM14-VI-INTCHG-FLAG-LP-A
544900                                    MM14-VI-INTCHG-FLAG-RP-A
545000         MOVE DFHBMASK           TO MM14-VI-INTCHG-FLAG-A
545100         GO TO Y459-EXIT.
545200*
545300     IF  MBCA-PTI-FUNCTION-IS-ADD
545400         IF  MMFS-ST-REQUIRED (X-MMFS-STORE)
545500             MOVE DFHBMASB       TO MM14-VI-INTCHG-FLAG-LIT-A
545600         ELSE
545700             IF  MMFS-ST-MAINT-ONLY (X-MMFS-STORE)
545800                 MOVE ZERO       TO MM14-VI-INTCHG-FLAG-L
545900                 MOVE DFHBMDAS   TO MM14-VI-INTCHG-FLAG-LP-A
546000                                    MM14-VI-INTCHG-FLAG-RP-A
546100                 MOVE DFHBMASK   TO MM14-VI-INTCHG-FLAG-A.
546200*
546300     IF  MBCA-PTI-FUNCTION-IS-MAINT
546400         IF  MMFS-ST-NO-MAINT (X-MMFS-STORE)
546500             MOVE ZERO           TO MM14-VI-INTCHG-FLAG-L
546600             MOVE DFHBMDAS       TO MM14-VI-INTCHG-FLAG-LP-A
546700                                    MM14-VI-INTCHG-FLAG-RP-A
546800             MOVE DFHBMASK       TO MM14-VI-INTCHG-FLAG-A.
546900*
547000 Y459-EXIT.
547100     EXIT.
547200*
547300 Y470-MOVE-VISA-MEMBER-ID.
547400*
547500     MOVE MMSM-VI-MEMBER-ID      TO MM14-VI-MEMBER-ID.
547600*
547700 Y475-VI-MEMBER-ID-SECURITY.
547800*
547900     MOVE DFHBMDAS               TO MM14-VI-MEMBER-ID-LIT-A
548000                                    MM14-VI-MEMBER-ID-LP-A
548100                                    MM14-VI-MEMBER-ID-RP-A
548200                                    MM14-VI-MEMBER-ID-A.
548300     GO TO Y479-EXIT.
548400*
548500     MOVE MMSMTB-VI-MEMBER-ID (1:4)
548600                                 TO WS-INDEX-X.
548700     SET  X-MMFS-STORE           TO WS-INDEX.
548800*
548900     IF  MMFS-ST-NO-ACCESS (X-MMFS-STORE)
549000         MOVE DFHBMDAS           TO MM14-VI-MEMBER-ID-LIT-A
549100                                    MM14-VI-MEMBER-ID-LP-A
549200                                    MM14-VI-MEMBER-ID-RP-A
549300                                    MM14-VI-MEMBER-ID-A
549400         MOVE ZERO               TO MM14-VI-MEMBER-ID-L
549500         GO TO Y479-EXIT.
549600*
549700     IF  MBCA-PTI-FUNCTION-IS-INQUIRY
549800         MOVE DFHBMDAS           TO MM14-VI-MEMBER-ID-LP-A
549900                                    MM14-VI-MEMBER-ID-RP-A
550000         MOVE DFHBMASB           TO MM14-VI-MEMBER-ID-A
550100         GO TO Y479-EXIT.
550200*
550300     IF  MMFS-ST-INQ-ONLY (X-MMFS-STORE)
550400         MOVE ZERO               TO MM14-VI-MEMBER-ID-L
550500         MOVE DFHBMDAS           TO MM14-VI-MEMBER-ID-LP-A
550600                                    MM14-VI-MEMBER-ID-RP-A
550700         MOVE DFHBMASK           TO MM14-VI-MEMBER-ID-A
550800         GO TO Y479-EXIT.
550900*
551000     IF  MBCA-PTI-FUNCTION-IS-ADD
551100         IF  MMFS-ST-REQUIRED (X-MMFS-STORE)
551200             MOVE DFHBMASB       TO MM14-VI-MEMBER-ID-LIT-A
551300         ELSE
551400             IF  MMFS-ST-MAINT-ONLY (X-MMFS-STORE)
551500                 MOVE ZERO       TO MM14-VI-MEMBER-ID-L
551600                 MOVE DFHBMDAS   TO MM14-VI-MEMBER-ID-LP-A
551700                                    MM14-VI-MEMBER-ID-RP-A
551800                 MOVE DFHBMASK   TO MM14-VI-MEMBER-ID-A.
551900*
552000     IF  MBCA-PTI-FUNCTION-IS-MAINT
552100         IF  MMFS-ST-NO-MAINT (X-MMFS-STORE)
552200             MOVE ZERO           TO MM14-VI-MEMBER-ID-L
552300             MOVE DFHBMDAS       TO MM14-VI-MEMBER-ID-LP-A
552400                                    MM14-VI-MEMBER-ID-RP-A
552500             MOVE DFHBMASK       TO MM14-VI-MEMBER-ID-A.
552600*
552700 Y479-EXIT.
552800     EXIT.
552900*
553000 Y490-MOVE-SPECIAL-COND-1.
553100*
553200     MOVE MMSM-VI-SPECIAL-COND-1 TO MM14-VI-SPECIAL-COND-1.
553300*
553400 Y495-SPECIAL-COND-1-SECURITY.
553500*
553600     MOVE MMSMTB-VI-SPECIAL-COND-1 (1:4)
553700                                 TO WS-INDEX-X.
553800     SET  X-MMFS-STORE           TO WS-INDEX.
553900*
554000     IF  MMFS-ST-NO-ACCESS (X-MMFS-STORE)
554100         MOVE DFHBMDAS           TO MM14-VI-SPECIAL-COND-LIT-A
554200                                    MM14-VI-SPECIAL-COND-1-LP-A
554300                                    MM14-VI-SPECIAL-COND-1-RP-A
554400                                    MM14-VI-SPECIAL-COND-1-A
554500         MOVE ZERO               TO MM14-VI-SPECIAL-COND-1-L
554600         GO TO Y499-EXIT.
554700*
554800     IF  MBCA-PTI-FUNCTION-IS-INQUIRY
554900         MOVE DFHBMDAS           TO MM14-VI-SPECIAL-COND-1-LP-A
555000                                    MM14-VI-SPECIAL-COND-1-RP-A
555100         MOVE DFHBMASB           TO MM14-VI-SPECIAL-COND-1-A
555200         GO TO Y499-EXIT.
555300*
555400     IF  MMFS-ST-INQ-ONLY (X-MMFS-STORE)
555500         MOVE ZERO               TO MM14-VI-SPECIAL-COND-1-L
555600         MOVE DFHBMDAS           TO MM14-VI-SPECIAL-COND-1-LP-A
555700                                    MM14-VI-SPECIAL-COND-1-RP-A
555800         MOVE DFHBMASK           TO MM14-VI-SPECIAL-COND-1-A
555900         GO TO Y499-EXIT.
556000*
556100     IF  MBCA-PTI-FUNCTION-IS-ADD
556200         IF  MMFS-ST-REQUIRED (X-MMFS-STORE)
556300             MOVE DFHBMASB       TO MM14-VI-SPECIAL-COND-LIT-A
556400         ELSE
556500             IF  MMFS-ST-MAINT-ONLY (X-MMFS-STORE)
556600                 MOVE ZERO       TO MM14-VI-SPECIAL-COND-1-L
556700                 MOVE DFHBMDAS   TO MM14-VI-SPECIAL-COND-1-LP-A
556800                                    MM14-VI-SPECIAL-COND-1-RP-A
556900                 MOVE DFHBMASK   TO MM14-VI-SPECIAL-COND-1-A.
557000*
557100     IF  MBCA-PTI-FUNCTION-IS-MAINT
557200         IF  MMFS-ST-NO-MAINT (X-MMFS-STORE)
557300             MOVE ZERO           TO MM14-VI-SPECIAL-COND-1-L
557400             MOVE DFHBMDAS       TO MM14-VI-SPECIAL-COND-1-LP-A
557500                                    MM14-VI-SPECIAL-COND-1-RP-A
557600             MOVE DFHBMASK       TO MM14-VI-SPECIAL-COND-1-A.
557700*
557800 Y499-EXIT.
557900     EXIT.
558000*
558100 Y510-MOVE-SPECIAL-COND-2.
558200*
558300     MOVE MMSM-VI-SPECIAL-COND-2 TO MM14-VI-SPECIAL-COND-2.
558400*
558500 Y515-SPECIAL-COND-2-SECURITY.
558600*
558700     MOVE MMSMTB-VI-SPECIAL-COND-2 (1:4)
558800                                 TO WS-INDEX-X.
558900     SET  X-MMFS-STORE           TO WS-INDEX.
559000*
559100     IF  MMFS-ST-NO-ACCESS (X-MMFS-STORE)
559200         MOVE DFHBMDAS           TO MM14-VI-SPECIAL-COND-LIT-A
559300                                    MM14-VI-SPECIAL-COND-2-LP-A
559400                                    MM14-VI-SPECIAL-COND-2-RP-A
559500                                    MM14-VI-SPECIAL-COND-2-A
559600         MOVE ZERO               TO MM14-VI-SPECIAL-COND-2-L
559700         GO TO Y519-EXIT.
559800*
559900     IF  MBCA-PTI-FUNCTION-IS-INQUIRY
560000         MOVE DFHBMDAS           TO MM14-VI-SPECIAL-COND-2-LP-A
560100                                    MM14-VI-SPECIAL-COND-2-RP-A
560200         MOVE DFHBMASB           TO MM14-VI-SPECIAL-COND-2-A
560300         GO TO Y519-EXIT.
560400*
560500     IF  MMFS-ST-INQ-ONLY (X-MMFS-STORE)
560600         MOVE ZERO               TO MM14-VI-SPECIAL-COND-2-L
560700         MOVE DFHBMDAS           TO MM14-VI-SPECIAL-COND-2-LP-A
560800                                    MM14-VI-SPECIAL-COND-2-RP-A
560900         MOVE DFHBMASK           TO MM14-VI-SPECIAL-COND-2-A
561000         GO TO Y519-EXIT.
561100*
561200     IF  MBCA-PTI-FUNCTION-IS-ADD
561300         IF  MMFS-ST-REQUIRED (X-MMFS-STORE)
561400             MOVE DFHBMASB       TO MM14-VI-SPECIAL-COND-LIT-A
561500         ELSE
561600             IF  MMFS-ST-MAINT-ONLY (X-MMFS-STORE)
561700                 MOVE ZERO       TO MM14-VI-SPECIAL-COND-2-L
561800                 MOVE DFHBMDAS   TO MM14-VI-SPECIAL-COND-2-LP-A
561900                                    MM14-VI-SPECIAL-COND-2-RP-A
562000                 MOVE DFHBMASK   TO MM14-VI-SPECIAL-COND-2-A.
562100*
562200     IF  MBCA-PTI-FUNCTION-IS-MAINT
562300         IF  MMFS-ST-NO-MAINT (X-MMFS-STORE)
562400             MOVE ZERO           TO MM14-VI-SPECIAL-COND-2-L
562500             MOVE DFHBMDAS       TO MM14-VI-SPECIAL-COND-2-LP-A
562600                                    MM14-VI-SPECIAL-COND-2-RP-A
562700             MOVE DFHBMASK       TO MM14-VI-SPECIAL-COND-2-A.
562800*
562900 Y519-EXIT.
563000     EXIT.
563100*
563200 Y530-MOVE-MAIL-PHONE-IND.
563300*
563400     MOVE MMSM-VI-MAIL-PHONE-IND TO MM14-VI-MAIL-PHONE-IND.
563500*
563600 Y535-MAIL-PHONE-SECURITY.
563700*
563800     MOVE MMSMTB-VI-MAIL-PHONE-IND (1:4)
563900                                 TO WS-INDEX-X.
564000     SET  X-MMFS-STORE           TO WS-INDEX.
564100*
564200     IF  MMFS-ST-NO-ACCESS (X-MMFS-STORE)
564300         MOVE DFHBMDAS           TO MM14-VI-MAIL-PHONE-IND-LIT-A
564400                                    MM14-VI-MAIL-PHONE-IND-LP-A
564500                                    MM14-VI-MAIL-PHONE-IND-RP-A
564600                                    MM14-VI-MAIL-PHONE-IND-A
564700         MOVE ZERO               TO MM14-VI-MAIL-PHONE-IND-L
564800         GO TO Y539-EXIT.
564900*
565000     IF  MBCA-PTI-FUNCTION-IS-INQUIRY
565100         MOVE DFHBMDAS           TO MM14-VI-MAIL-PHONE-IND-LP-A
565200                                    MM14-VI-MAIL-PHONE-IND-RP-A
565300         MOVE DFHBMASB           TO MM14-VI-MAIL-PHONE-IND-A
565400         GO TO Y539-EXIT.
565500*
565600     IF  MMFS-ST-INQ-ONLY (X-MMFS-STORE)
565700         MOVE ZERO               TO MM14-VI-MAIL-PHONE-IND-L
565800         MOVE DFHBMDAS           TO MM14-VI-MAIL-PHONE-IND-LP-A
565900                                    MM14-VI-MAIL-PHONE-IND-RP-A
566000         MOVE DFHBMASK           TO MM14-VI-MAIL-PHONE-IND-A
566100         GO TO Y539-EXIT.
566200*
566300     IF  MBCA-PTI-FUNCTION-IS-ADD
566400         IF  MMFS-ST-REQUIRED (X-MMFS-STORE)
566500             MOVE DFHBMASB       TO MM14-VI-MAIL-PHONE-IND-LIT-A
566600         ELSE
566700             IF  MMFS-ST-MAINT-ONLY (X-MMFS-STORE)
566800                 MOVE ZERO       TO MM14-VI-MAIL-PHONE-IND-L
566900                 MOVE DFHBMDAS   TO MM14-VI-MAIL-PHONE-IND-LP-A
567000                                    MM14-VI-MAIL-PHONE-IND-RP-A
567100                 MOVE DFHBMASK   TO MM14-VI-MAIL-PHONE-IND-A.
567200*
567300     IF  MBCA-PTI-FUNCTION-IS-MAINT
567400         IF  MMFS-ST-NO-MAINT (X-MMFS-STORE)
567500             MOVE ZERO           TO MM14-VI-MAIL-PHONE-IND-L
567600             MOVE DFHBMDAS       TO MM14-VI-MAIL-PHONE-IND-LP-A
567700                                    MM14-VI-MAIL-PHONE-IND-RP-A
567800             MOVE DFHBMASK       TO MM14-VI-MAIL-PHONE-IND-A.
567900*
568000 Y539-EXIT.
568100     EXIT.
568200*
568300 Y550-MOVE-CH-TERM-IND.
568400*
568500     MOVE MMSM-VI-CH-TERM-IND    TO MM14-VI-CH-TERM-IND.
568600*
568700 Y555-CH-TERM-IND-SECURITY.
568800*
568900     MOVE MMSMTB-VI-CH-TERM-IND (1:4)
569000                                 TO WS-INDEX-X.
569100     SET  X-MMFS-STORE           TO WS-INDEX.
569200*
569300     IF  MMFS-ST-NO-ACCESS (X-MMFS-STORE)
569400         MOVE DFHBMDAS           TO MM14-VI-CH-TERM-IND-LIT-A
569500                                    MM14-VI-CH-TERM-IND-LP-A
569600                                    MM14-VI-CH-TERM-IND-RP-A
569700                                    MM14-VI-CH-TERM-IND-A
569800         MOVE ZERO               TO MM14-VI-CH-TERM-IND-L
569900         GO TO Y559-EXIT.
570000*
570100     IF  MBCA-PTI-FUNCTION-IS-INQUIRY
570200         MOVE DFHBMDAS           TO MM14-VI-CH-TERM-IND-LP-A
570300                                    MM14-VI-CH-TERM-IND-RP-A
570400         MOVE DFHBMASB           TO MM14-VI-CH-TERM-IND-A
570500         GO TO Y559-EXIT.
570600*
570700     IF  MMFS-ST-INQ-ONLY (X-MMFS-STORE)
570800         MOVE ZERO               TO MM14-VI-CH-TERM-IND-L
570900         MOVE DFHBMDAS           TO MM14-VI-CH-TERM-IND-LP-A
571000                                    MM14-VI-CH-TERM-IND-RP-A
571100         MOVE DFHBMASK           TO MM14-VI-CH-TERM-IND-A
571200         GO TO Y559-EXIT.
571300*
571400     IF  MBCA-PTI-FUNCTION-IS-ADD
571500         IF  MMFS-ST-REQUIRED (X-MMFS-STORE)
571600             MOVE DFHBMASB       TO MM14-VI-CH-TERM-IND-LIT-A
571700         ELSE
571800             IF  MMFS-ST-MAINT-ONLY (X-MMFS-STORE)
571900                 MOVE ZERO       TO MM14-VI-CH-TERM-IND-L
572000                 MOVE DFHBMDAS   TO MM14-VI-CH-TERM-IND-LP-A
572100                                    MM14-VI-CH-TERM-IND-RP-A
572200                 MOVE DFHBMASK   TO MM14-VI-CH-TERM-IND-A.
572300*
572400     IF  MBCA-PTI-FUNCTION-IS-MAINT
572500         IF  MMFS-ST-NO-MAINT (X-MMFS-STORE)
572600             MOVE ZERO           TO MM14-VI-CH-TERM-IND-L
572700             MOVE DFHBMDAS       TO MM14-VI-CH-TERM-IND-LP-A
572800                                    MM14-VI-CH-TERM-IND-RP-A
572900             MOVE DFHBMASK       TO MM14-VI-CH-TERM-IND-A.
573000*
573100 Y559-EXIT.
573200     EXIT.
573300*
573400 Y620-MOVE-RPT-THSHOLD.
573500*
573600     MOVE MMSM-VI-RPT-THSHOLD    TO MM14-VI-RPT-THSHOLD.
573700*
573800 Y625-RPT-THSHOLD-SECURITY.
573900*
574000     MOVE MMSMTB-VI-RPT-THSHOLD (1:4)
574100                                 TO WS-INDEX-X.
574200     SET  X-MMFS-STORE           TO WS-INDEX.
574300*
574400     IF  MMFS-ST-NO-ACCESS (X-MMFS-STORE)
574500         MOVE DFHBMDAS           TO MM14-VI-RPT-THSHOLD-LIT-A
574600                                    MM14-VI-RPT-THSHOLD-LP-A
574700                                    MM14-VI-RPT-THSHOLD-RP-A
574800                                    MM14-VI-RPT-THSHOLD-A
574900         MOVE ZERO               TO MM14-VI-RPT-THSHOLD-L
575000         GO TO Y629-EXIT.
575100*
575200     IF  MBCA-PTI-FUNCTION-IS-INQUIRY
575300         MOVE DFHBMDAS           TO MM14-VI-RPT-THSHOLD-LP-A
575400                                    MM14-VI-RPT-THSHOLD-RP-A
575500         MOVE DFHBMASB           TO MM14-VI-RPT-THSHOLD-A
575600         GO TO Y629-EXIT.
575700*
575800     IF  MMFS-ST-INQ-ONLY (X-MMFS-STORE)
575900         MOVE ZERO               TO MM14-VI-RPT-THSHOLD-L
576000         MOVE DFHBMDAS           TO MM14-VI-RPT-THSHOLD-LP-A
576100                                    MM14-VI-RPT-THSHOLD-RP-A
576200         MOVE DFHBMASK           TO MM14-VI-RPT-THSHOLD-A
576300         GO TO Y629-EXIT.
576400*
576500     IF  MBCA-PTI-FUNCTION-IS-ADD
576600         IF  MMFS-ST-REQUIRED (X-MMFS-STORE)
576700             MOVE DFHBMASB       TO MM14-VI-RPT-THSHOLD-LIT-A
576800         ELSE
576900             IF  MMFS-ST-MAINT-ONLY (X-MMFS-STORE)
577000                 MOVE ZERO       TO MM14-VI-RPT-THSHOLD-L
577100                 MOVE DFHBMDAS TO MM14-VI-RPT-THSHOLD-LP-A
577200                                    MM14-VI-RPT-THSHOLD-RP-A
577300                 MOVE DFHBMASK   TO MM14-VI-RPT-THSHOLD-A.
577400*
577500     IF  MBCA-PTI-FUNCTION-IS-MAINT
577600         IF  MMFS-ST-NO-MAINT (X-MMFS-STORE)
577700             MOVE ZERO           TO MM14-VI-RPT-THSHOLD-L
577800             MOVE DFHBMDAS       TO MM14-VI-RPT-THSHOLD-LP-A
577900                                    MM14-VI-RPT-THSHOLD-RP-A
578000             MOVE DFHBMASK       TO MM14-VI-RPT-THSHOLD-A.
578100*
578200 Y629-EXIT.
578300     EXIT.
578302*                                                                 RG802901
578304 Y630-MOVE-CONTACT-IND.                                           RG802901
578306*                                                                 RG802901
578308     MOVE MMSM-VI-CONTACT-IND    TO MM14-VI-CONTACT-IND.          RG802901
578310*                                                                 RG802901
578312 Y635-CONTACT-IND-SECURITY.                                       RG802901
578314*                                                                 RG802901
578316     MOVE MMSMTB-VI-CONTACT-IND (1:4)                             RG802901
578318                                 TO WS-INDEX-X.                   RG802901
578320     SET  X-MMFS-STORE           TO WS-INDEX.                     RG802901
578322*                                                                 RG802901
578324     IF  MMFS-ST-NO-ACCESS (X-MMFS-STORE)                         RG802901
578326         MOVE DFHBMDAS           TO MM14-VI-CONTACT-IND-LIT-A     RG802901
578328                                    MM14-VI-CONTACT-IND-LP-A      RG802901
578330                                    MM14-VI-CONTACT-IND-RP-A      RG802901
578332                                    MM14-VI-CONTACT-IND-A         RG802901
578334         MOVE ZERO               TO MM14-VI-CONTACT-IND-L         RG802901
578336         GO TO Y639-EXIT.                                         RG802901
578338*                                                                 RG802901
578340     IF  MBCA-PTI-FUNCTION-IS-INQUIRY                             RG802901
578342         MOVE DFHBMDAS           TO MM14-VI-CONTACT-IND-LP-A      RG802901
578344                                    MM14-VI-CONTACT-IND-RP-A      RG802901
578346         MOVE DFHBMASB           TO MM14-VI-CONTACT-IND-A         RG802901
578348         GO TO Y639-EXIT.                                         RG802901
578350*                                                                 RG802901
578352     IF  MMFS-ST-INQ-ONLY (X-MMFS-STORE)                          RG802901
578354         MOVE ZERO               TO MM14-VI-CONTACT-IND-L         RG802901
578356         MOVE DFHBMDAS           TO MM14-VI-CONTACT-IND-LP-A      RG802901
578358                                    MM14-VI-CONTACT-IND-RP-A      RG802901
578360         MOVE DFHBMASK           TO MM14-VI-CONTACT-IND-A         RG802901
578362         GO TO Y639-EXIT.                                         RG802901
578364*                                                                 RG802901
578366     IF  MBCA-PTI-FUNCTION-IS-ADD                                 RG802901
578368         IF  MMFS-ST-REQUIRED (X-MMFS-STORE)                      RG802901
578370             MOVE DFHBMASB       TO MM14-VI-CONTACT-IND-LIT-A     RG802901
578372         ELSE                                                     RG802901
578374             IF  MMFS-ST-MAINT-ONLY (X-MMFS-STORE)                RG802901
578376                 MOVE ZERO       TO MM14-VI-CONTACT-IND-L         RG802901
578378                 MOVE DFHBMDAS   TO MM14-VI-CONTACT-IND-LP-A      RG802901
578380                                    MM14-VI-CONTACT-IND-RP-A      RG802901
578382                 MOVE DFHBMASK   TO MM14-VI-CONTACT-IND-A.        RG802901
578384*                                                                 RG802901
578386     IF  MBCA-PTI-FUNCTION-IS-MAINT                               RG802901
578388         IF  MMFS-ST-NO-MAINT (X-MMFS-STORE)                      RG802901
578390             MOVE ZERO           TO MM14-VI-CONTACT-IND-L         RG802901
578391             MOVE DFHBMDAS       TO MM14-VI-CONTACT-IND-LP-A      RG802901
578392                                    MM14-VI-CONTACT-IND-RP-A      RG802901
578394             MOVE DFHBMASK       TO MM14-VI-CONTACT-IND-A.        RG802901
578395*                                                                 RG802901
578396 Y639-EXIT.                                                       RG802901
578397     EXIT.                                                        RG802901
578400*
578500 Y650-MOVE-CRB-REGION.
578600*
578700     MOVE MMSM-VI-CRB-REGION     TO MM14-VI-CRB-REGION.
578800*
578900 Y655-CRB-REGION-SECURITY.
579000*
579100     MOVE MMSMTB-VI-CRB-REGION (1:4)
579200                                 TO WS-INDEX-X.
579300     SET  X-MMFS-STORE           TO WS-INDEX.
579400*
579500     IF  MMFS-ST-NO-ACCESS (X-MMFS-STORE)
579600         MOVE DFHBMDAS           TO MM14-VI-CRB-REGION-LIT-A
579700                                    MM14-VI-CRB-REGION-LP-A
579800                                    MM14-VI-CRB-REGION-RP-A
579900                                    MM14-VI-CRB-REGION-A
580000         MOVE ZERO               TO MM14-VI-CRB-REGION-L
580100         GO TO Y659-EXIT.
580200*
580300     IF  MBCA-PTI-FUNCTION-IS-INQUIRY
580400         MOVE DFHBMDAS           TO MM14-VI-CRB-REGION-LP-A
580500                                    MM14-VI-CRB-REGION-RP-A
580600         MOVE DFHBMASB           TO MM14-VI-CRB-REGION-A
580700         GO TO Y659-EXIT.
580800*
580900     IF  MMFS-ST-INQ-ONLY (X-MMFS-STORE)
581000         MOVE ZERO               TO MM14-VI-CRB-REGION-L
581100         MOVE DFHBMDAS           TO MM14-VI-CRB-REGION-LP-A
581200                                    MM14-VI-CRB-REGION-RP-A
581300         MOVE DFHBMASK           TO MM14-VI-CRB-REGION-A
581400         GO TO Y659-EXIT.
581500*
581600     IF  MBCA-PTI-FUNCTION-IS-ADD
581700         IF  MMFS-ST-REQUIRED (X-MMFS-STORE)
581800             MOVE DFHBMASB       TO MM14-VI-CRB-REGION-LIT-A
581900         ELSE
582000             IF  MMFS-ST-MAINT-ONLY (X-MMFS-STORE)
582100                 MOVE ZERO       TO MM14-VI-CRB-REGION-L
582200                 MOVE DFHBMDAS   TO MM14-VI-CRB-REGION-LP-A
582300                                    MM14-VI-CRB-REGION-RP-A
582400                 MOVE DFHBMASK   TO MM14-VI-CRB-REGION-A.
582500*
582600     IF  MBCA-PTI-FUNCTION-IS-MAINT
582700         IF  MMFS-ST-NO-MAINT (X-MMFS-STORE)
582800             MOVE ZERO           TO MM14-VI-CRB-REGION-L
582900             MOVE DFHBMDAS       TO MM14-VI-CRB-REGION-LP-A
583000                                    MM14-VI-CRB-REGION-RP-A
583100             MOVE DFHBMASK       TO MM14-VI-CRB-REGION-A.
583200*
583300 Y659-EXIT.
583400     EXIT.
583500*
583600 Y670-MOVE-REG-ADDR-IND1.
583700*
583800     MOVE MMSM-VI-REG-ADDR-IND   TO MM14-VI-REG-ADDR-IND1.
583900*
584000 Y675-REG-ADDR-IND1-SECURITY.
584100*
584200     MOVE MMSMTB-VI-REG-ADDR-IND1 (1:4)
584300                                 TO WS-INDEX-X.
584400     SET  X-MMFS-STORE           TO WS-INDEX.
584500*
584600     IF  MMFS-ST-NO-ACCESS (X-MMFS-STORE)
584700         MOVE DFHBMDAS           TO MM14-VI-REG-ADDR-IND-LIT-A
584800                                    MM14-VI-REG-ADDR-IND-LP-A
584900                                    MM14-VI-REG-ADDR-IND-RP-A
585000                                    MM14-VI-REG-ADDR-IND1-A
585100         MOVE ZERO               TO MM14-VI-REG-ADDR-IND1-L
585200         GO TO Y679-EXIT.
585300*
585400     IF  MBCA-PTI-FUNCTION-IS-INQUIRY
585500         MOVE DFHBMDAS           TO MM14-VI-REG-ADDR-IND-LP-A
585600                                    MM14-VI-REG-ADDR-IND-RP-A
585700         MOVE DFHBMASB           TO MM14-VI-REG-ADDR-IND1-A
585800         GO TO Y679-EXIT.
585900*
586000     IF  MMFS-ST-INQ-ONLY (X-MMFS-STORE)
586100         MOVE ZERO               TO MM14-VI-REG-ADDR-IND1-L
586200         MOVE DFHBMDAS           TO MM14-VI-REG-ADDR-IND-LP-A
586300                                    MM14-VI-REG-ADDR-IND-RP-A
586400         MOVE DFHBMASK           TO MM14-VI-REG-ADDR-IND1-A
586500         GO TO Y679-EXIT.
586600*
586700     IF  MBCA-PTI-FUNCTION-IS-ADD
586800         IF  MMFS-ST-REQUIRED (X-MMFS-STORE)
586900             MOVE DFHBMASB       TO MM14-VI-REG-ADDR-IND-LIT-A
587000         ELSE
587100             IF  MMFS-ST-MAINT-ONLY (X-MMFS-STORE)
587200                 MOVE ZERO       TO MM14-VI-REG-ADDR-IND1-L
587300                 MOVE DFHBMDAS   TO MM14-VI-REG-ADDR-IND-LP-A
587400                                    MM14-VI-REG-ADDR-IND-RP-A
587500                 MOVE DFHBMASK   TO MM14-VI-REG-ADDR-IND1-A.
587600*
587700     IF  MBCA-PTI-FUNCTION-IS-MAINT
587800         IF  MMFS-ST-NO-MAINT (X-MMFS-STORE)
587900             MOVE ZERO           TO MM14-VI-REG-ADDR-IND1-L
588000             MOVE DFHBMDAS       TO MM14-VI-REG-ADDR-IND-LP-A
588100                                    MM14-VI-REG-ADDR-IND-RP-A
588200             MOVE DFHBMASK       TO MM14-VI-REG-ADDR-IND1-A.
588300*
588400 Y679-EXIT.
588500     EXIT.
588600*
588700 Y690-MOVE-REG-ADDR-IND2.
588800*
588900     MOVE MMSM-VI-REG-ADDR-LINE  TO MM14-VI-REG-ADDR-IND2.
589000*
589100 Y695-REG-ADDR-IND2-SECURITY.
589200*
589300     MOVE MMSMTB-VI-REG-ADDR-IND2 (1:4)
589400                                 TO WS-INDEX-X.
589500     SET  X-MMFS-STORE           TO WS-INDEX.
589600*
589700     IF  MMFS-ST-NO-ACCESS (X-MMFS-STORE)
589800         MOVE DFHBMDAS           TO MM14-VI-REG-ADDR-IND-LIT-A
589900                                    MM14-VI-REG-ADDR-IND-LP-A
590000                                    MM14-VI-REG-ADDR-IND-RP-A
590100                                    MM14-VI-REG-ADDR-IND2-A
590200         MOVE ZERO               TO MM14-VI-REG-ADDR-IND2-L
590300         GO TO Y699-EXIT.
590400*
590500     IF  MBCA-PTI-FUNCTION-IS-INQUIRY
590600         MOVE DFHBMDAS           TO MM14-VI-REG-ADDR-IND-LP-A
590700                                    MM14-VI-REG-ADDR-IND-RP-A
590800         MOVE DFHBMASB           TO MM14-VI-REG-ADDR-IND2-A
590900         GO TO Y699-EXIT.
591000*
591100     IF  MMFS-ST-INQ-ONLY (X-MMFS-STORE)
591200         MOVE ZERO               TO MM14-VI-REG-ADDR-IND2-L
591300         MOVE DFHBMDAS           TO MM14-VI-REG-ADDR-IND-LP-A
591400                                    MM14-VI-REG-ADDR-IND-RP-A
591500         MOVE DFHBMASK           TO MM14-VI-REG-ADDR-IND2-A
591600         GO TO Y699-EXIT.
591700*
591800     IF  MBCA-PTI-FUNCTION-IS-ADD
591900         IF  MMFS-ST-REQUIRED (X-MMFS-STORE)
592000             MOVE DFHBMASB       TO MM14-VI-REG-ADDR-IND-LIT-A
592100         ELSE
592200             IF  MMFS-ST-MAINT-ONLY (X-MMFS-STORE)
592300                 MOVE ZERO       TO MM14-VI-REG-ADDR-IND2-L
592400                 MOVE DFHBMDAS   TO MM14-VI-REG-ADDR-IND-LP-A
592500                                    MM14-VI-REG-ADDR-IND-RP-A
592600                 MOVE DFHBMASK   TO MM14-VI-REG-ADDR-IND2-A.
592700*
592800     IF  MBCA-PTI-FUNCTION-IS-MAINT
592900         IF  MMFS-ST-NO-MAINT (X-MMFS-STORE)
593000             MOVE ZERO           TO MM14-VI-REG-ADDR-IND2-L
593100             MOVE DFHBMDAS       TO MM14-VI-REG-ADDR-IND-LP-A
593200                                    MM14-VI-REG-ADDR-IND-RP-A
593300             MOVE DFHBMASK       TO MM14-VI-REG-ADDR-IND2-A.
593400*
593500 Y699-EXIT.
593600     EXIT.
593700*
593800 Y710-MOVE-CATEGORY-CODE.
593900*
594000     MOVE MMSM-VI-CATEGORY-CODE
594100                                 TO MM14-VI-CATEGORY-CODE.
594200*
594300 Y715-CATEGORY-CODE-SECURITY.
594400*
594500     MOVE MMSMTB-VI-CATEGORY-CODE (1:4)
594600                                 TO WS-INDEX-X.
594700     SET  X-MMFS-STORE           TO WS-INDEX.
594800*
594900     IF  MMFS-ST-NO-ACCESS (X-MMFS-STORE)
595000         MOVE DFHBMDAS           TO MM14-VI-CATEGORY-CODE-LIT-A
595100                                    MM14-VI-CATEGORY-CODE-LP-A
595200                                    MM14-VI-CATEGORY-CODE-RP-A
595300                                    MM14-VI-CATEGORY-CODE-A
595400         MOVE ZERO               TO MM14-VI-CATEGORY-CODE-L
595500         GO TO Y719-EXIT.
595600*
595700     IF  MBCA-PTI-FUNCTION-IS-INQUIRY
595800         MOVE DFHBMDAS           TO MM14-VI-CATEGORY-CODE-LP-A
595900                                    MM14-VI-CATEGORY-CODE-RP-A
596000         MOVE DFHBMASB           TO MM14-VI-CATEGORY-CODE-A
596100         GO TO Y719-EXIT.
596200*
596300     IF  MMFS-ST-INQ-ONLY (X-MMFS-STORE)
596400         MOVE ZERO               TO MM14-VI-CATEGORY-CODE-L
596500         MOVE DFHBMDAS           TO MM14-VI-CATEGORY-CODE-LP-A
596600                                    MM14-VI-CATEGORY-CODE-RP-A
596700         MOVE DFHBMASK           TO MM14-VI-CATEGORY-CODE-A
596800         GO TO Y719-EXIT.
596900*
597000     IF  MBCA-PTI-FUNCTION-IS-ADD
597100         IF  MMFS-ST-REQUIRED (X-MMFS-STORE)
597200             MOVE DFHBMASB       TO MM14-VI-CATEGORY-CODE-LIT-A
597300         ELSE
597400             IF  MMFS-ST-MAINT-ONLY (X-MMFS-STORE)
597500                 MOVE ZERO       TO MM14-VI-CATEGORY-CODE-L
597600                 MOVE DFHBMDAS   TO MM14-VI-CATEGORY-CODE-LP-A
597700                                    MM14-VI-CATEGORY-CODE-RP-A
597800                 MOVE DFHBMASK   TO MM14-VI-CATEGORY-CODE-A.
597900*
598000     IF  MBCA-PTI-FUNCTION-IS-MAINT
598100         IF  MMFS-ST-NO-MAINT (X-MMFS-STORE)
598200             MOVE ZERO           TO MM14-VI-CATEGORY-CODE-L
598300             MOVE DFHBMDAS       TO MM14-VI-CATEGORY-CODE-LP-A
598400                                    MM14-VI-CATEGORY-CODE-RP-A
598500             MOVE DFHBMASK       TO MM14-VI-CATEGORY-CODE-A.
598600*
598700 Y719-EXIT.
598800     EXIT.
598900*
599000 Y730-MOVE-FLOOR-LIMIT.
599100*
599200     MOVE MMSM-VI-FLOOR-LIMIT    TO MM14-VI-FLOOR-LIMIT.
599300*
599400 Y735-FLOOR-LIMIT-SECURITY.
599500*
599600     MOVE MMSMTB-VI-FLOOR-LIMIT (1:4)
599700                                 TO WS-INDEX-X.
599800     SET  X-MMFS-STORE           TO WS-INDEX.
599900*
600000     IF  MMFS-ST-NO-ACCESS (X-MMFS-STORE)
600100         MOVE DFHBMDAS           TO MM14-VI-FLOOR-LIMIT-LIT-A
600200                                    MM14-VI-FLOOR-LIMIT-LP-A
600300                                    MM14-VI-FLOOR-LIMIT-RP-A
600400                                    MM14-VI-FLOOR-LIMIT-A
600500         MOVE ZERO               TO MM14-VI-FLOOR-LIMIT-L
600600         GO TO Y739-EXIT.
600700*
600800     IF  MBCA-PTI-FUNCTION-IS-INQUIRY
600900         MOVE DFHBMDAS           TO MM14-VI-FLOOR-LIMIT-LP-A
601000                                    MM14-VI-FLOOR-LIMIT-RP-A
601100         MOVE DFHBMASB           TO MM14-VI-FLOOR-LIMIT-A
601200         GO TO Y739-EXIT.
601300*
601400     IF  MMFS-ST-INQ-ONLY (X-MMFS-STORE)
601500         MOVE ZERO               TO MM14-VI-FLOOR-LIMIT-L
601600         MOVE DFHBMDAS           TO MM14-VI-FLOOR-LIMIT-LP-A
601700                                    MM14-VI-FLOOR-LIMIT-RP-A
601800         MOVE DFHBMASK           TO MM14-VI-FLOOR-LIMIT-A
601900         GO TO Y739-EXIT.
602000*
602100     IF  MBCA-PTI-FUNCTION-IS-ADD
602200         IF  MMFS-ST-REQUIRED (X-MMFS-STORE)
602300             MOVE DFHBMASB       TO MM14-VI-FLOOR-LIMIT-LIT-A
602400         ELSE
602500             IF  MMFS-ST-MAINT-ONLY (X-MMFS-STORE)
602600                 MOVE ZERO       TO MM14-VI-FLOOR-LIMIT-L
602700                 MOVE DFHBMDAS   TO MM14-VI-FLOOR-LIMIT-LP-A
602800                                    MM14-VI-FLOOR-LIMIT-RP-A
602900                 MOVE DFHBMASK   TO MM14-VI-FLOOR-LIMIT-A.
603000*
603100     IF  MBCA-PTI-FUNCTION-IS-MAINT
603200         IF  MMFS-ST-NO-MAINT (X-MMFS-STORE)
603300             MOVE ZERO           TO MM14-VI-FLOOR-LIMIT-L
603400             MOVE DFHBMDAS       TO MM14-VI-FLOOR-LIMIT-LP-A
603500                                    MM14-VI-FLOOR-LIMIT-RP-A
603600             MOVE DFHBMASK       TO MM14-VI-FLOOR-LIMIT-A.
603700*
603800 Y739-EXIT.
603900     EXIT.
604000*
604100 Y750-MOVE-VOLUME-IND.
604200*
604300     MOVE MMSM-VI-VOLUME-IND TO MM14-VI-VOLUME-IND.
604400*
604500 Y755-VOLUME-IND-SECURITY.
604600*
604700     MOVE MMSMTB-VI-VOLUME-IND (1:4)
604800                                 TO WS-INDEX-X.
604900     SET  X-MMFS-STORE           TO WS-INDEX.
605000*
605100     IF  MMFS-ST-NO-ACCESS (X-MMFS-STORE)
605200         MOVE DFHBMDAS           TO MM14-VI-VOLUME-IND-LIT-A
605300                                    MM14-VI-VOLUME-IND-LP-A
605400                                    MM14-VI-VOLUME-IND-RP-A
605500                                    MM14-VI-VOLUME-IND-A
605600         MOVE ZERO               TO MM14-VI-VOLUME-IND-L
605700         GO TO Y759-EXIT.
605800*
605900     IF  MBCA-PTI-FUNCTION-IS-INQUIRY
606000         MOVE DFHBMDAS           TO MM14-VI-VOLUME-IND-LP-A
606100                                    MM14-VI-VOLUME-IND-RP-A
606200         MOVE DFHBMASB           TO MM14-VI-VOLUME-IND-A
606300         GO TO Y759-EXIT.
606400*
606500     IF  MMFS-ST-INQ-ONLY (X-MMFS-STORE)
606600         MOVE ZERO               TO MM14-VI-VOLUME-IND-L
606700         MOVE DFHBMDAS           TO MM14-VI-VOLUME-IND-LP-A
606800                                    MM14-VI-VOLUME-IND-RP-A
606900         MOVE DFHBMASK           TO MM14-VI-VOLUME-IND-A
607000         GO TO Y759-EXIT.
607100*
607200     IF  MBCA-PTI-FUNCTION-IS-ADD
607300         IF  MMFS-ST-REQUIRED (X-MMFS-STORE)
607400             MOVE DFHBMASB       TO MM14-VI-VOLUME-IND-LIT-A
607500         ELSE
607600             IF  MMFS-ST-MAINT-ONLY (X-MMFS-STORE)
607700                 MOVE ZERO       TO MM14-VI-VOLUME-IND-L
607800                 MOVE DFHBMDAS   TO MM14-VI-VOLUME-IND-LP-A
607900                                    MM14-VI-VOLUME-IND-RP-A
608000                 MOVE DFHBMASK   TO MM14-VI-VOLUME-IND-A.
608100*
608200     IF  MBCA-PTI-FUNCTION-IS-MAINT
608300         IF  MMFS-ST-NO-MAINT (X-MMFS-STORE)
608400             MOVE ZERO           TO MM14-VI-VOLUME-IND-L
608500             MOVE DFHBMDAS       TO MM14-VI-VOLUME-IND-LP-A
608600                                    MM14-VI-VOLUME-IND-RP-A
608700             MOVE DFHBMASK       TO MM14-VI-VOLUME-IND-A.
608800*
608900 Y759-EXIT.
609000     EXIT.
609100*
609102*                                                                 RG800914
609110 Y760-MOVE-SVC-DVLP-IND.                                          RG800914
609111*                                                                 RG800914
609112     MOVE MMSM-VI-SVC-DVLP-IND   TO MM14-VI-SVC-DVLP-IND.         RG800914
609113*                                                                 RG800914
609114 Y765-SVC-DVLP-IND.                                               RG800914
609115*                                                                 RG800914
609116     MOVE MMSMTB-VI-SVC-DVLP-IND (1:4)                            RG800914
609117                                 TO WS-INDEX-X.                   RG800914
609118     SET  X-MMFS-STORE           TO WS-INDEX.                     RG800914
609119*                                                                 RG800914
609120     IF  MMFS-ST-NO-ACCESS (X-MMFS-STORE)                         RG800914
609121         MOVE DFHBMDAS           TO MM14-VI-SVC-DVLP-IND-LIT-A    RG800914
609122                                    MM14-VI-SVC-DVLP-IND-LP-A     RG800914
609123                                    MM14-VI-SVC-DVLP-IND-RP-A     RG800914
609124                                    MM14-VI-SVC-DVLP-IND-A        RG800914
609125         MOVE ZERO               TO MM14-VI-SVC-DVLP-IND-L        RG800914
609126         GO TO Y769-EXIT.                                         RG800914
609127*                                                                 RG800914
609128     IF  MBCA-PTI-FUNCTION-IS-INQUIRY                             RG800914
609129         MOVE DFHBMDAS           TO MM14-VI-SVC-DVLP-IND-LP-A     RG800914
609130                                    MM14-VI-SVC-DVLP-IND-RP-A     RG800914
609131         MOVE DFHBMASB           TO MM14-VI-SVC-DVLP-IND-A        RG800914
609132         GO TO Y769-EXIT.                                         RG800914
609133*                                                                 RG800914
609134     IF  MMFS-ST-INQ-ONLY (X-MMFS-STORE)                          RG800914
609135         MOVE ZERO               TO MM14-VI-SVC-DVLP-IND-L        RG800914
609136         MOVE DFHBMDAS           TO MM14-VI-SVC-DVLP-IND-LP-A     RG800914
609137                                    MM14-VI-SVC-DVLP-IND-RP-A     RG800914
609138         MOVE DFHBMASK           TO MM14-VI-SVC-DVLP-IND-A        RG800914
609139         GO TO Y769-EXIT.                                         RG800914
609140*                                                                 RG800914
609141     IF  MBCA-PTI-FUNCTION-IS-ADD                                 RG800914
609142         IF  MMFS-ST-REQUIRED (X-MMFS-STORE)                      RG800914
609143             MOVE DFHBMASB       TO MM14-VI-SVC-DVLP-IND-LIT-A    RG800914
609144         ELSE                                                     RG800914
609145             IF  MMFS-ST-MAINT-ONLY (X-MMFS-STORE)                RG800914
609146                 MOVE ZERO       TO MM14-VI-SVC-DVLP-IND-L        RG800914
609147                 MOVE DFHBMDAS TO MM14-VI-SVC-DVLP-IND-LP-A       RG800914
609148                                    MM14-VI-SVC-DVLP-IND-RP-A     RG800914
609149                 MOVE DFHBMASK   TO MM14-VI-SVC-DVLP-IND-A.       RG800914
609150*                                                                 RG800914
609151     IF  MBCA-PTI-FUNCTION-IS-MAINT                               RG800914
609152         IF  MMFS-ST-NO-MAINT (X-MMFS-STORE)                      RG800914
609153             MOVE ZERO           TO MM14-VI-SVC-DVLP-IND-L        RG800914
609154             MOVE DFHBMDAS       TO MM14-VI-SVC-DVLP-IND-LP-A     RG800914
609155                                    MM14-VI-SVC-DVLP-IND-RP-A     RG800914
609156             MOVE DFHBMASK       TO MM14-VI-SVC-DVLP-IND-A.       RG800914
609157*                                                                 RG800914
609158 Y769-EXIT.                                                       RG800914
609159     EXIT.                                                        RG800914
609200 Y800-SET-CURSOR.
609300*
609400 Y803-VI-STATUS.
609500*
609600     MOVE MMMMTB-PROD-STATUS (1:4)
609700                                 TO WS-INDEX-X.
609800     SET X-MMFS-MERCH            TO WS-INDEX.
609900*
610000     IF  MBCA-PTI-FUNCTION-IS-ADD
610100         IF  MMFS-MT-OPTIONAL (X-MMFS-MERCH)
610200         OR  MMFS-MT-REQUIRED (X-MMFS-MERCH)
610300             MOVE SS08WS-CURSOR  TO MM14-VI-STATUS-L
610400             GO TO Y809-SC-EXIT.
610500*
610600     IF  MBCA-PTI-FUNCTION-IS-MAINT
610700         IF  MMFS-MT-MAINT-ALLOWED (X-MMFS-MERCH)
610800             MOVE SS08WS-CURSOR  TO MM14-VI-STATUS-L
610900             GO TO Y809-SC-EXIT.
611000*
611100 Y803-PROD-DISC-FEE-BASE.
611200*
611300     MOVE MMMMTB-PROD-DISC-FEE-BASE (1:4)
611400                                 TO WS-INDEX-X.
611500     SET X-MMFS-MERCH            TO WS-INDEX.
611600*
611700     IF  MBCA-PTI-FUNCTION-IS-ADD
611800         IF  MMFS-MT-OPTIONAL (X-MMFS-MERCH)
611900         OR  MMFS-MT-REQUIRED (X-MMFS-MERCH)
612000             MOVE SS08WS-CURSOR  TO MM14-PROD-DISC-FEE-BASE-L
612100             GO TO Y809-SC-EXIT.
612200*
612300     IF  MBCA-PTI-FUNCTION-IS-MAINT
612400         IF  MMFS-MT-MAINT-ALLOWED (X-MMFS-MERCH)
612500             MOVE SS08WS-CURSOR  TO MM14-PROD-DISC-FEE-BASE-L
612600             GO TO Y809-SC-EXIT.
612700*
612800 Y803-PROD-DISC-RATE-TBL.
612900*
613000     MOVE MMMMTB-PROD-DISC-RATE-TABLE (1:4)
613100                                 TO WS-INDEX-X.
613200     SET X-MMFS-MERCH            TO WS-INDEX.
613300*
613400     IF  MBCA-PTI-FUNCTION-IS-ADD
613500         IF  MMFS-MT-OPTIONAL (X-MMFS-MERCH)
613600         OR  MMFS-MT-REQUIRED (X-MMFS-MERCH)
613700             MOVE SS08WS-CURSOR  TO MM14-PROD-DISC-RATE-TBL-L
613800             GO TO Y809-SC-EXIT.
613900*
614000     IF  MBCA-PTI-FUNCTION-IS-MAINT
614100         IF  MMFS-MT-MAINT-ALLOWED (X-MMFS-MERCH)
614200             MOVE SS08WS-CURSOR  TO MM14-PROD-DISC-RATE-TBL-L
614300             GO TO Y809-SC-EXIT.
614400*
614500 Y803-PROD-EFF-DATE.
614600*
614700     MOVE MMMMTB-PROD-EFF-DATE (1:4)
614800                                 TO WS-INDEX-X.
614900     SET X-MMFS-MERCH            TO WS-INDEX.
615000*
615100     IF  MBCA-PTI-FUNCTION-IS-ADD
615200         IF  MMFS-MT-OPTIONAL (X-MMFS-MERCH)
615300         OR  MMFS-MT-REQUIRED (X-MMFS-MERCH)
615400             MOVE SS08WS-CURSOR  TO MM14-VI-EFF-DATE-L
615500             GO TO Y809-SC-EXIT.
615600*
615700     IF  MBCA-PTI-FUNCTION-IS-MAINT
615800         IF  MMFS-MT-MAINT-ALLOWED (X-MMFS-MERCH)
615900             MOVE SS08WS-CURSOR  TO MM14-VI-EFF-DATE-L
616000             GO TO Y809-SC-EXIT.
616100*
616200 Y803-PROD-PART-FEE-BASE.
616300*
616400     MOVE MMMMTB-PROD-PART-FEE-BASE (1:4)
616500                                 TO WS-INDEX-X.
616600     SET X-MMFS-MERCH            TO WS-INDEX.
616700*
616800     IF  MBCA-PTI-FUNCTION-IS-ADD
616900         IF  MMFS-MT-OPTIONAL (X-MMFS-MERCH)
617000         OR  MMFS-MT-REQUIRED (X-MMFS-MERCH)
617100             MOVE SS08WS-CURSOR  TO MM14-PROD-PART-FEE-BASE-L
617200             GO TO Y809-SC-EXIT.
617300*
617400     IF  MBCA-PTI-FUNCTION-IS-MAINT
617500         IF  MMFS-MT-MAINT-ALLOWED (X-MMFS-MERCH)
617600             MOVE SS08WS-CURSOR  TO MM14-PROD-PART-FEE-BASE-L
617700             GO TO Y809-SC-EXIT.
617800*
617900 Y803-PROD-PART-RATE-TBL.
618000*
618100     MOVE MMMMTB-PROD-PART-RATE-TABLE (1:4)
618200                                 TO WS-INDEX-X.
618300     SET X-MMFS-MERCH            TO WS-INDEX.
618400*
618500     IF  MBCA-PTI-FUNCTION-IS-ADD
618600         IF  MMFS-MT-OPTIONAL (X-MMFS-MERCH)
618700         OR  MMFS-MT-REQUIRED (X-MMFS-MERCH)
618800             MOVE SS08WS-CURSOR  TO MM14-PROD-PART-RATE-TBL-L
618900             GO TO Y809-SC-EXIT.
619000*
619100     IF  MBCA-PTI-FUNCTION-IS-MAINT
619200         IF  MMFS-MT-MAINT-ALLOWED (X-MMFS-MERCH)
619300             MOVE SS08WS-CURSOR  TO MM14-PROD-PART-RATE-TBL-L
619400             GO TO Y809-SC-EXIT.
619500*
619600 Y803-PROD-SETTLE-FLAG.
619700*
619800     MOVE MMMMTB-PROD-SETT-FLAG (1:4)
619900                                 TO WS-INDEX-X.
620000     SET X-MMFS-MERCH            TO WS-INDEX.
620100*
620200     IF  MBCA-PTI-FUNCTION-IS-ADD
620300         IF  MMFS-MT-OPTIONAL (X-MMFS-MERCH)
620400         OR  MMFS-MT-REQUIRED (X-MMFS-MERCH)
620500             MOVE SS08WS-CURSOR  TO MM14-PROD-SETTLE-FLAG-L
620600             GO TO Y809-SC-EXIT.
620700*
620800     IF  MBCA-PTI-FUNCTION-IS-MAINT
620900         IF  MMFS-MT-MAINT-ALLOWED (X-MMFS-MERCH)
621000             MOVE SS08WS-CURSOR  TO MM14-PROD-SETTLE-FLAG-L
621100             GO TO Y809-SC-EXIT.
621200*
621300 Y803-PROD-RESV-1-FEE-BASE.
621400*
621500     MOVE MMMMTB-PROD-RESV-1-FEE-BASE (1:4)
621600                                 TO WS-INDEX-X.
621700     SET X-MMFS-MERCH            TO WS-INDEX.
621800*
621900     IF  MBCA-PTI-FUNCTION-IS-ADD
622000         IF  MMFS-MT-OPTIONAL (X-MMFS-MERCH)
622100         OR  MMFS-MT-REQUIRED (X-MMFS-MERCH)
622200             MOVE SS08WS-CURSOR  TO MM14-PROD-RESV-1-FEE-BASE-L
622300             GO TO Y809-SC-EXIT.
622400*
622500     IF  MBCA-PTI-FUNCTION-IS-MAINT
622600         IF  MMFS-MT-MAINT-ALLOWED (X-MMFS-MERCH)
622700             MOVE SS08WS-CURSOR  TO MM14-PROD-RESV-1-FEE-BASE-L
622800             GO TO Y809-SC-EXIT.
622900*
623000 Y803-PROD-RESV-1-RATE-TBL.
623100*
623200     MOVE MMMMTB-PROD-RESV-1-RATE-TABLE (1:4)
623300                                 TO WS-INDEX-X.
623400     SET X-MMFS-MERCH            TO WS-INDEX.
623500*
623600     IF  MBCA-PTI-FUNCTION-IS-ADD
623700         IF  MMFS-MT-OPTIONAL (X-MMFS-MERCH)
623800         OR  MMFS-MT-REQUIRED (X-MMFS-MERCH)
623900             MOVE SS08WS-CURSOR  TO MM14-PROD-RESV-1-RATE-TBL-L
624000             GO TO Y809-SC-EXIT.
624100*
624200     IF  MBCA-PTI-FUNCTION-IS-MAINT
624300         IF  MMFS-MT-MAINT-ALLOWED (X-MMFS-MERCH)
624400             MOVE SS08WS-CURSOR  TO MM14-PROD-RESV-1-RATE-TBL-L
624500             GO TO Y809-SC-EXIT.
624600*
624700 Y803-PROD-SOURCE.
624800*
624900     MOVE MMMMTB-PROD-SOURCE (1:4)
625000                                 TO WS-INDEX-X.
625100     SET X-MMFS-MERCH            TO WS-INDEX.
625200*
625300     IF  MBCA-PTI-FUNCTION-IS-ADD
625400         IF  MMFS-MT-OPTIONAL (X-MMFS-MERCH)
625500         OR  MMFS-MT-REQUIRED (X-MMFS-MERCH)
625600             MOVE SS08WS-CURSOR  TO MM14-PROD-SOURCE-L
625700             GO TO Y809-SC-EXIT.
625800*
625900     IF  MBCA-PTI-FUNCTION-IS-MAINT
626000         IF  MMFS-MT-MAINT-ALLOWED (X-MMFS-MERCH)
626100             MOVE SS08WS-CURSOR  TO MM14-PROD-SOURCE-L
626200             GO TO Y809-SC-EXIT.
626300*
626400 Y803-PROD-RESV-2-FEE-BASE.
626500*
626600     MOVE MMMMTB-PROD-RESV-2-FEE-BASE (1:4)
626700                                 TO WS-INDEX-X.
626800     SET X-MMFS-MERCH            TO WS-INDEX.
626900*
627000     IF  MBCA-PTI-FUNCTION-IS-ADD
627100         IF  MMFS-MT-OPTIONAL (X-MMFS-MERCH)
627200         OR  MMFS-MT-REQUIRED (X-MMFS-MERCH)
627300             MOVE SS08WS-CURSOR  TO MM14-PROD-RESV-2-FEE-BASE-L
627400             GO TO Y809-SC-EXIT.
627500*
627600     IF  MBCA-PTI-FUNCTION-IS-MAINT
627700         IF  MMFS-MT-MAINT-ALLOWED (X-MMFS-MERCH)
627800             MOVE SS08WS-CURSOR  TO MM14-PROD-RESV-2-FEE-BASE-L
627900             GO TO Y809-SC-EXIT.
628000*
628100 Y803-PROD-RESV-2-RATE-TBL.
628200*
628300     MOVE MMMMTB-PROD-RESV-2-RATE-TABLE (1:4)
628400                                 TO WS-INDEX-X.
628500     SET X-MMFS-MERCH            TO WS-INDEX.
628600*
628700     IF  MBCA-PTI-FUNCTION-IS-ADD
628800         IF  MMFS-MT-OPTIONAL (X-MMFS-MERCH)
628900         OR  MMFS-MT-REQUIRED (X-MMFS-MERCH)
629000             MOVE SS08WS-CURSOR  TO MM14-PROD-RESV-2-RATE-TBL-L
629100             GO TO Y809-SC-EXIT.
629200*
629300     IF  MBCA-PTI-FUNCTION-IS-MAINT
629400         IF  MMFS-MT-MAINT-ALLOWED (X-MMFS-MERCH)
629500             MOVE SS08WS-CURSOR  TO MM14-PROD-RESV-2-RATE-TBL-L
629600             GO TO Y809-SC-EXIT.
629700*
629800 Y803-PROD-SHORT-DESC.
629900*
630000     MOVE MMMMTB-PROD-SHORT-DESC (1:4)
630100                                 TO WS-INDEX-X.
630200     SET X-MMFS-MERCH            TO WS-INDEX.
630300*
630400     IF  MBCA-PTI-FUNCTION-IS-ADD
630500         IF  MMFS-MT-OPTIONAL (X-MMFS-MERCH)
630600         OR  MMFS-MT-REQUIRED (X-MMFS-MERCH)
630700             MOVE SS08WS-CURSOR  TO MM14-PROD-SHORT-DESC-L
630800             GO TO Y809-SC-EXIT.
630900*
631000     IF  MBCA-PTI-FUNCTION-IS-MAINT
631100         IF  MMFS-MT-MAINT-ALLOWED (X-MMFS-MERCH)
631200             MOVE SS08WS-CURSOR  TO MM14-PROD-SHORT-DESC-L
631300             GO TO Y809-SC-EXIT.
631400*
631500 Y803-PROD-RESV-3-FEE-BASE.
631600*
631700     MOVE MMMMTB-PROD-RESV-3-FEE-BASE (1:4)
631800                                 TO WS-INDEX-X.
631900     SET X-MMFS-MERCH            TO WS-INDEX.
632000*
632100     IF  MBCA-PTI-FUNCTION-IS-ADD
632200         IF  MMFS-MT-OPTIONAL (X-MMFS-MERCH)
632300         OR  MMFS-MT-REQUIRED (X-MMFS-MERCH)
632400             MOVE SS08WS-CURSOR  TO MM14-PROD-RESV-3-FEE-BASE-L
632500             GO TO Y809-SC-EXIT.
632600*
632700     IF  MBCA-PTI-FUNCTION-IS-MAINT
632800         IF  MMFS-MT-MAINT-ALLOWED (X-MMFS-MERCH)
632900             MOVE SS08WS-CURSOR  TO MM14-PROD-RESV-3-FEE-BASE-L
633000             GO TO Y809-SC-EXIT.
633100*
633200 Y803-PROD-RESV-3-RATE-TBL.
633300*
633400     MOVE MMMMTB-PROD-RESV-3-RATE-TABLE (1:4)
633500                                 TO WS-INDEX-X.
633600     SET X-MMFS-MERCH            TO WS-INDEX.
633700*
633800     IF  MBCA-PTI-FUNCTION-IS-ADD
633900         IF  MMFS-MT-OPTIONAL (X-MMFS-MERCH)
634000         OR  MMFS-MT-REQUIRED (X-MMFS-MERCH)
634100             MOVE SS08WS-CURSOR  TO MM14-PROD-RESV-3-RATE-TBL-L
634200             GO TO Y809-SC-EXIT.
634300*
634400     IF  MBCA-PTI-FUNCTION-IS-MAINT
634500         IF  MMFS-MT-MAINT-ALLOWED (X-MMFS-MERCH)
634600             MOVE SS08WS-CURSOR  TO MM14-PROD-RESV-3-RATE-TBL-L
634700             GO TO Y809-SC-EXIT.
634800*
634900 Y803-PROD-RESV-4-FEE-BASE.
635000*
635100     MOVE MMMMTB-PROD-RESV-4-FEE-BASE (1:4)
635200                                 TO WS-INDEX-X.
635300     SET X-MMFS-MERCH            TO WS-INDEX.
635400*
635500     IF  MBCA-PTI-FUNCTION-IS-ADD
635600         IF  MMFS-MT-OPTIONAL (X-MMFS-MERCH)
635700         OR  MMFS-MT-REQUIRED (X-MMFS-MERCH)
635800             MOVE SS08WS-CURSOR  TO MM14-PROD-RESV-4-FEE-BASE-L
635900             GO TO Y809-SC-EXIT.
636000*
636100     IF  MBCA-PTI-FUNCTION-IS-MAINT
636200         IF  MMFS-MT-MAINT-ALLOWED (X-MMFS-MERCH)
636300             MOVE SS08WS-CURSOR  TO MM14-PROD-RESV-4-FEE-BASE-L
636400             GO TO Y809-SC-EXIT.
636500*
636600 Y803-PROD-RESV-4-RATE-TBL.
636700*
636800     MOVE MMMMTB-PROD-RESV-4-RATE-TABLE (1:4)
636900                                 TO WS-INDEX-X.
637000     SET X-MMFS-MERCH            TO WS-INDEX.
637100*
637200     IF  MBCA-PTI-FUNCTION-IS-ADD
637300         IF  MMFS-MT-OPTIONAL (X-MMFS-MERCH)
637400         OR  MMFS-MT-REQUIRED (X-MMFS-MERCH)
637500             MOVE SS08WS-CURSOR  TO MM14-PROD-RESV-4-RATE-TBL-L
637600             GO TO Y809-SC-EXIT.
637700*
637800     IF  MBCA-PTI-FUNCTION-IS-MAINT
637900         IF  MMFS-MT-MAINT-ALLOWED (X-MMFS-MERCH)
638000             MOVE SS08WS-CURSOR  TO MM14-PROD-RESV-4-RATE-TBL-L
638100             GO TO Y809-SC-EXIT.
638200*
638300 Y803-PROD-USER-CODE.
638400*
638500     MOVE MMMMTB-PROD-USER-CODE (1:4)
638600                                 TO WS-INDEX-X.
638700     SET X-MMFS-MERCH            TO WS-INDEX.
638800*
638900     IF  MBCA-PTI-FUNCTION-IS-ADD
639000         IF  MMFS-MT-OPTIONAL (X-MMFS-MERCH)
639100         OR  MMFS-MT-REQUIRED (X-MMFS-MERCH)
639200             MOVE SS08WS-CURSOR  TO MM14-PROD-USER-CODE-L
639300             GO TO Y809-SC-EXIT.
639400*
639500     IF  MBCA-PTI-FUNCTION-IS-MAINT
639600         IF  MMFS-MT-MAINT-ALLOWED (X-MMFS-MERCH)
639700             MOVE SS08WS-CURSOR  TO MM14-PROD-USER-CODE-L
639800             GO TO Y809-SC-EXIT.
639900*
640000 Y803-PROD-INTCHG-FEE-BASE.
640100*
640200     MOVE MMMMTB-PROD-INTCHG-FEE-BASE (1:4)
640300                                 TO WS-INDEX-X.
640400     SET X-MMFS-MERCH            TO WS-INDEX.
640500*
640600     IF  MBCA-PTI-FUNCTION-IS-ADD
640700         IF  MMFS-MT-OPTIONAL (X-MMFS-MERCH)
640800         OR  MMFS-MT-REQUIRED (X-MMFS-MERCH)
640900             MOVE SS08WS-CURSOR  TO MM14-PROD-INTCHG-FEE-BASE-L
641000             GO TO Y809-SC-EXIT.
641100*
641200     IF  MBCA-PTI-FUNCTION-IS-MAINT
641300         IF  MMFS-MT-MAINT-ALLOWED (X-MMFS-MERCH)
641400             MOVE SS08WS-CURSOR  TO MM14-PROD-INTCHG-FEE-BASE-L
641500             GO TO Y809-SC-EXIT.
641600*
641700 Y803-VI-DBA-NAME.
641800*
641900     MOVE MMSMTB-VI-DBA-NAME (1:4)
642000                                 TO WS-INDEX-X.
642100     SET X-MMFS-STORE            TO WS-INDEX.
642200*
642300     IF  MBCA-PTI-FUNCTION-IS-ADD
642400         IF  MMFS-ST-OPTIONAL (X-MMFS-STORE)
642500         OR  MMFS-ST-REQUIRED (X-MMFS-STORE)
642600             MOVE SS08WS-CURSOR  TO MM14-VI-DBA-NAME-L
642700             GO TO Y809-SC-EXIT.
642800*
642900     IF  MBCA-PTI-FUNCTION-IS-MAINT
643000         IF  MMFS-ST-MAINT-ALLOWED (X-MMFS-STORE)
643100             MOVE SS08WS-CURSOR  TO MM14-VI-DBA-NAME-L
643200             GO TO Y809-SC-EXIT.
643300*
643400 Y803-VI-INTCHG-IND.
643500*
643600     MOVE MMSMTB-VI-INTCHG-IND (1:4)
643700                                 TO WS-INDEX-X.
643800     SET X-MMFS-STORE            TO WS-INDEX.
643900*
644000     IF  MBCA-PTI-FUNCTION-IS-ADD
644100         IF  MMFS-ST-OPTIONAL (X-MMFS-STORE)
644200         OR  MMFS-ST-REQUIRED (X-MMFS-STORE)
644300             MOVE SS08WS-CURSOR  TO MM14-VI-INTCHG-FLAG-L
644400             GO TO Y809-SC-EXIT.
644500*
644600     IF  MBCA-PTI-FUNCTION-IS-MAINT
644700         IF  MMFS-ST-MAINT-ALLOWED (X-MMFS-STORE)
644800             MOVE SS08WS-CURSOR  TO MM14-VI-INTCHG-FLAG-L
644900             GO TO Y809-SC-EXIT.
645000*
645100 Y803-VI-MEMBER-ID.
645200*
645300     MOVE MMSMTB-VI-MEMBER-ID (1:4)
645400                                 TO WS-INDEX-X.
645500     SET X-MMFS-STORE            TO WS-INDEX.
645600*
645700     IF  MBCA-PTI-FUNCTION-IS-ADD
645800         IF  MMFS-ST-OPTIONAL (X-MMFS-STORE)
645900         OR  MMFS-ST-REQUIRED (X-MMFS-STORE)
646000             MOVE SS08WS-CURSOR  TO MM14-VI-MEMBER-ID-L
646100             GO TO Y809-SC-EXIT.
646200*
646300     IF  MBCA-PTI-FUNCTION-IS-MAINT
646400         IF  MMFS-ST-MAINT-ALLOWED (X-MMFS-STORE)
646500             MOVE SS08WS-CURSOR  TO MM14-VI-MEMBER-ID-L
646600             GO TO Y809-SC-EXIT.
646700*
646800 Y803-VI-SPECIAL-COND-1.
646900*
647000     MOVE MMSMTB-VI-SPECIAL-COND-1 (1:4)
647100                                 TO WS-INDEX-X.
647200     SET X-MMFS-STORE            TO WS-INDEX.
647300*
647400     IF  MBCA-PTI-FUNCTION-IS-ADD
647500         IF  MMFS-ST-OPTIONAL (X-MMFS-STORE)
647600         OR  MMFS-ST-REQUIRED (X-MMFS-STORE)
647700             MOVE SS08WS-CURSOR  TO MM14-VI-SPECIAL-COND-1-L
647800             GO TO Y809-SC-EXIT.
647900*
648000     IF  MBCA-PTI-FUNCTION-IS-MAINT
648100         IF  MMFS-ST-MAINT-ALLOWED (X-MMFS-STORE)
648200             MOVE SS08WS-CURSOR  TO MM14-VI-SPECIAL-COND-1-L
648300             GO TO Y809-SC-EXIT.
648400*
648500 Y803-VI-SPECIAL-COND-2.
648600*
648700     MOVE MMSMTB-VI-SPECIAL-COND-2 (1:4)
648800                                 TO WS-INDEX-X.
648900     SET X-MMFS-STORE            TO WS-INDEX.
649000*
649100     IF  MBCA-PTI-FUNCTION-IS-ADD
649200         IF  MMFS-ST-OPTIONAL (X-MMFS-STORE)
649300         OR  MMFS-ST-REQUIRED (X-MMFS-STORE)
649400             MOVE SS08WS-CURSOR  TO MM14-VI-SPECIAL-COND-2-L
649500             GO TO Y809-SC-EXIT.
649600*
649700     IF  MBCA-PTI-FUNCTION-IS-MAINT
649800         IF  MMFS-ST-MAINT-ALLOWED (X-MMFS-STORE)
649900             MOVE SS08WS-CURSOR  TO MM14-VI-SPECIAL-COND-2-L
650000             GO TO Y809-SC-EXIT.
650100*
650200 Y803-VI-MAIL-PHONE-IND.
650300*
650400     MOVE MMSMTB-VI-MAIL-PHONE-IND (1:4)
650500                                 TO WS-INDEX-X.
650600     SET X-MMFS-STORE            TO WS-INDEX.
650700*
650800     IF  MBCA-PTI-FUNCTION-IS-ADD
650900         IF  MMFS-ST-OPTIONAL (X-MMFS-STORE)
651000         OR  MMFS-ST-REQUIRED (X-MMFS-STORE)
651100             MOVE SS08WS-CURSOR  TO MM14-VI-MAIL-PHONE-IND-L
651200             GO TO Y809-SC-EXIT.
651300*
651400     IF  MBCA-PTI-FUNCTION-IS-MAINT
651500         IF  MMFS-ST-MAINT-ALLOWED (X-MMFS-STORE)
651600             MOVE SS08WS-CURSOR  TO MM14-VI-MAIL-PHONE-IND-L
651700             GO TO Y809-SC-EXIT.
651800*
651900 Y803-VI-CH-TERM-IND.
652000*
652100     MOVE MMSMTB-VI-CH-TERM-IND (1:4)
652200                                 TO WS-INDEX-X.
652300     SET X-MMFS-STORE            TO WS-INDEX.
652400*
652500     IF  MBCA-PTI-FUNCTION-IS-ADD
652600         IF  MMFS-ST-OPTIONAL (X-MMFS-STORE)
652700         OR  MMFS-ST-REQUIRED (X-MMFS-STORE)
652800             MOVE SS08WS-CURSOR  TO MM14-VI-CH-TERM-IND-L
652900             GO TO Y809-SC-EXIT.
653000*
653100     IF  MBCA-PTI-FUNCTION-IS-MAINT
653200         IF  MMFS-ST-MAINT-ALLOWED (X-MMFS-STORE)
653300             MOVE SS08WS-CURSOR  TO MM14-VI-CH-TERM-IND-L
653400             GO TO Y809-SC-EXIT.
653500*
653600 Y803-VI-RPT-THSHOLD.
653700*
653800     MOVE MMSMTB-VI-RPT-THSHOLD (1:4)
653900                                 TO WS-INDEX-X.
654000     SET X-MMFS-STORE            TO WS-INDEX.
654100*
654200     IF  MBCA-PTI-FUNCTION-IS-ADD
654300         IF  MMFS-ST-OPTIONAL (X-MMFS-STORE)
654400         OR  MMFS-ST-REQUIRED (X-MMFS-STORE)
654500             MOVE SS08WS-CURSOR  TO MM14-VI-RPT-THSHOLD-L
654600             GO TO Y809-SC-EXIT.
654700*
654800     IF  MBCA-PTI-FUNCTION-IS-MAINT
654900         IF  MMFS-ST-MAINT-ALLOWED (X-MMFS-STORE)
655000             MOVE SS08WS-CURSOR  TO MM14-VI-RPT-THSHOLD-L
655100             GO TO Y809-SC-EXIT.
655102*                                                                 RG802901
655104 Y803-VI-CONTACT.                                                 RG802901
655106*                                                                 RG802901
655108     MOVE MMSMTB-VI-CONTACT-IND (1:4)                             RG802901
655110                                 TO WS-INDEX-X.                   RG802901
655112     SET X-MMFS-STORE            TO WS-INDEX.                     RG802901
655114*                                                                 RG802901
655116     IF  MBCA-PTI-FUNCTION-IS-ADD                                 RG802901
655118         IF  MMFS-ST-OPTIONAL (X-MMFS-STORE)                      RG802901
655120         OR  MMFS-ST-REQUIRED (X-MMFS-STORE)                      RG802901
655122             MOVE SS08WS-CURSOR  TO MM14-VI-CONTACT-IND-L         RG802901
655124             GO TO Y809-SC-EXIT.                                  RG802901
655126*                                                                 RG802901
655128     IF  MBCA-PTI-FUNCTION-IS-MAINT                               RG802901
655130         IF  MMFS-ST-MAINT-ALLOWED (X-MMFS-STORE)                 RG802901
655132             MOVE SS08WS-CURSOR  TO MM14-VI-CONTACT-IND-L         RG802901
655134             GO TO Y809-SC-EXIT.                                  RG802901
655139*                                                                 RG802901
655200 Y803-VI-VOLUME-IND.
655300*
655400     MOVE MMSMTB-VI-VOLUME-IND (1:4)
655500                                 TO WS-INDEX-X.
655600     SET X-MMFS-STORE            TO WS-INDEX.
655700*
655800     IF  MBCA-PTI-FUNCTION-IS-ADD
655900         IF  MMFS-ST-OPTIONAL (X-MMFS-STORE)
656000         OR  MMFS-ST-REQUIRED (X-MMFS-STORE)
656100             MOVE SS08WS-CURSOR  TO MM14-VI-VOLUME-IND-L
656200             GO TO Y809-SC-EXIT.
656300*
656400     IF  MBCA-PTI-FUNCTION-IS-MAINT
656500         IF  MMFS-ST-MAINT-ALLOWED (X-MMFS-STORE)
656600             MOVE SS08WS-CURSOR  TO MM14-VI-VOLUME-IND-L
656700             GO TO Y809-SC-EXIT.
656800*
656900 Y803-VI-CRB-REGION.
657000*
657100*
657200     MOVE MMSMTB-VI-CRB-REGION (1:4)
657300                                 TO WS-INDEX-X.
657400     SET X-MMFS-STORE            TO WS-INDEX.
657500*
657600     IF  MBCA-PTI-FUNCTION-IS-ADD
657700         IF  MMFS-ST-OPTIONAL (X-MMFS-STORE)
657800         OR  MMFS-ST-REQUIRED (X-MMFS-STORE)
657900             MOVE SS08WS-CURSOR  TO MM14-VI-CRB-REGION-L
658000             GO TO Y809-SC-EXIT.
658100*
658200     IF  MBCA-PTI-FUNCTION-IS-MAINT
658300         IF  MMFS-ST-MAINT-ALLOWED (X-MMFS-STORE)
658400             MOVE SS08WS-CURSOR  TO MM14-VI-CRB-REGION-L
658500             GO TO Y809-SC-EXIT.
658600*
658700 Y803-VI-REG-ADDR-IND1.
658800*
658900     MOVE MMSMTB-VI-REG-ADDR-IND1 (1:4)
659000                                 TO WS-INDEX-X.
659100     SET X-MMFS-STORE            TO WS-INDEX.
659200*
659300     IF  MBCA-PTI-FUNCTION-IS-ADD
659400         IF  MMFS-ST-OPTIONAL (X-MMFS-STORE)
659500         OR  MMFS-ST-REQUIRED (X-MMFS-STORE)
659600             MOVE SS08WS-CURSOR  TO MM14-VI-REG-ADDR-IND1-L
659700             GO TO Y809-SC-EXIT.
659800*
659900     IF  MBCA-PTI-FUNCTION-IS-MAINT
660000         IF  MMFS-ST-MAINT-ALLOWED (X-MMFS-STORE)
660100             MOVE SS08WS-CURSOR  TO MM14-VI-REG-ADDR-IND1-L
660200             GO TO Y809-SC-EXIT.
660300*
660400 Y803-VI-REG-ADDR-IND2.
660500*
660600     MOVE MMSMTB-VI-REG-ADDR-IND2 (1:4)
660700                                 TO WS-INDEX-X.
660800     SET X-MMFS-STORE            TO WS-INDEX.
660900*
661000     IF  MBCA-PTI-FUNCTION-IS-ADD
661100         IF  MMFS-ST-OPTIONAL (X-MMFS-STORE)
661200         OR  MMFS-ST-REQUIRED (X-MMFS-STORE)
661300             MOVE SS08WS-CURSOR  TO MM14-VI-REG-ADDR-IND2-L
661400             GO TO Y809-SC-EXIT.
661500*
661600     IF  MBCA-PTI-FUNCTION-IS-MAINT
661700         IF  MMFS-ST-MAINT-ALLOWED (X-MMFS-STORE)
661800             MOVE SS08WS-CURSOR  TO MM14-VI-REG-ADDR-IND2-L
661900             GO TO Y809-SC-EXIT.
662000*
662100 Y803-VI-CATEGORY-CODE.
662200*
662300     MOVE MMSMTB-VI-CATEGORY-CODE (1:4)
662400                                 TO WS-INDEX-X.
662500     SET X-MMFS-STORE            TO WS-INDEX.
662600*
662700     IF  MBCA-PTI-FUNCTION-IS-ADD
662800         IF  MMFS-ST-OPTIONAL (X-MMFS-STORE)
662900         OR  MMFS-ST-REQUIRED (X-MMFS-STORE)
663000             MOVE SS08WS-CURSOR  TO MM14-VI-CATEGORY-CODE-L
663100             GO TO Y809-SC-EXIT.
663200*
663300     IF  MBCA-PTI-FUNCTION-IS-MAINT
663400         IF  MMFS-ST-MAINT-ALLOWED (X-MMFS-STORE)
663500             MOVE SS08WS-CURSOR  TO MM14-VI-CATEGORY-CODE-L
663600             GO TO Y809-SC-EXIT.
663700*
663800 Y803-VI-FLOOR-LIMIT.
663900*
664000     MOVE MMSMTB-VI-FLOOR-LIMIT (1:4)
664100                                 TO WS-INDEX-X.
664200     SET X-MMFS-STORE            TO WS-INDEX.
664300*
664400     IF  MBCA-PTI-FUNCTION-IS-ADD
664500         IF  MMFS-ST-OPTIONAL (X-MMFS-STORE)
664600         OR  MMFS-ST-REQUIRED (X-MMFS-STORE)
664700             MOVE SS08WS-CURSOR  TO MM14-VI-FLOOR-LIMIT-L
664800             GO TO Y809-SC-EXIT.
664900*
665000     IF  MBCA-PTI-FUNCTION-IS-MAINT
665100         IF  MMFS-ST-MAINT-ALLOWED (X-MMFS-STORE)
665200             MOVE SS08WS-CURSOR  TO MM14-VI-FLOOR-LIMIT-L
665300             GO TO Y809-SC-EXIT.
665400*
665402 Y803-VI-SVC-DVLP-IND.                                            RG800914
665404*                                                                 RG800914
665406     MOVE MMSMTB-VI-SVC-DVLP-IND (1:4)                            RG800914
665408                                 TO WS-INDEX-X.                   RG800914
665410     SET X-MMFS-STORE            TO WS-INDEX.                     RG800914
665412*                                                                 RG800914
665414     IF  MBCA-PTI-FUNCTION-IS-ADD                                 RG800914
665416         IF  MMFS-ST-OPTIONAL (X-MMFS-STORE)                      RG800914
665418         OR  MMFS-ST-REQUIRED (X-MMFS-STORE)                      RG800914
665420             MOVE SS08WS-CURSOR  TO MM14-VI-SVC-DVLP-IND-L        RG800914
665422             GO TO Y809-SC-EXIT.                                  RG800914
665424*                                                                 RG800914
665426     IF  MBCA-PTI-FUNCTION-IS-MAINT                               RG800914
665428         IF  MMFS-ST-MAINT-ALLOWED (X-MMFS-STORE)                 RG800914
665430             MOVE SS08WS-CURSOR  TO MM14-VI-SVC-DVLP-IND-L        RG800914
665432             GO TO Y809-SC-EXIT.                                  RG800914
665434*                                                                 RG800914
665500 Y803-CURSOR-DEFAULT.
665600*
665700     MOVE SS08WS-CURSOR          TO MM14-ALT-TRANID-L.
665800*
665900 Y809-SC-EXIT.
666000     EXIT.
666100*
666200 Y900-READ-MMFS.
666300*
666400****************************************
666500*    READ THE FIELD SECURITY RECORD    *
666600*    TO OBTAIN THE SECURITY CODES      *
666700****************************************
666800*
666900     MOVE MBCA-MERCHANT-ORG      TO MBIOWS-MMFS-ORG.
667000     MOVE MBCA-FIELD-SECURITY    TO MBIOWS-MMFS-FS-CODE.
667100     SET MBIORO-READ-RANDOM      TO TRUE.
667200     PERFORM MMFSAO-ACCESS       THRU MMFSAO-ACCESS-EXIT.
667300*
667400     IF  NOT MMFS-REC-ACTIVE
667500         MOVE MBIORO-IO-REQUEST  TO MBCA-ERRR-IO-REQUEST
667600         MOVE MBIORO-FILE-NAME   TO MBCA-ERRR-EIBDS
667700         MOVE EIBFN              TO MBCA-ERRR-EIBFN-CODES
667800         MOVE MBCA-PROGRAM-ID    TO MBCA-ERRR-BAD-PROGRAM
667900         MOVE MBCA-TRANS-ID      TO MBCA-ERRR-BAD-TRANSID
668000         SET MBCA-ERROR-MSGS-PROVIDED
668100                                 TO TRUE
668200         MOVE 'READ ERROR - MMFSAO'
668300                                 TO MBCA-ERRR-MSG1
668400         MOVE 'FIELD SECURITY PROFILE IS NOT ACTIVE'
668500                                 TO MBCA-ERRR-MSG2
668600         GO TO MB70PD-ERROR-ROUTINE.
668700*
668800 Y909-READ-MMFS-EXIT.
668900     EXIT.
669000*
669100 Y910-WRITE-MMMP-LOG-RECORD.
669200*
669300     MOVE 'MP'                   TO MML1-FILE-CODE.
669400     MOVE MBCA-MERCHANT-ORG      TO MML1-MMMP-ORG.
669500     MOVE MBCA-MERCHANT          TO MML1-MMMP-MERCHANT.
669600     MOVE MBCA-CARD-PROD         TO MML1-MMMP-PRODUCT.
669700     MOVE MBCA-SIGNON-NAME       TO MML1-SIGNON-NAME.
669800     MOVE MBCA-TERMINAL-ID       TO MML1-TERMINAL-ID.
669900     MOVE ZEROS                  TO MML1-SOURCE-CODE.
670000     MOVE MBCA-FIELD-SECURITY    TO MML1-FIELD-SECURITY.
670100     SET MBIORO-WRITE            TO TRUE.
670200     PERFORM MML1AO-ACCESS       THRU MML1AO-ACCESS-EXIT.
670300     MOVE SPACES                 TO MML1-VARIABLE-AREA.
670400*
670500 Y919-WLR-EXIT.
670600     EXIT.
670700*
670800 Y920-WRITE-MMSM-LOG-RECORD.
670900*
671000     MOVE 'SM'                   TO MML1-FILE-CODE.
671100     MOVE MBCA-MERCHANT-ORG      TO MML1-MMSM-ORG.
671200     MOVE MMSM-STORE             TO MML1-MMSM-STORE.
671300     MOVE MBCA-SIGNON-NAME       TO MML1-SIGNON-NAME.
671400     MOVE MBCA-TERMINAL-ID       TO MML1-TERMINAL-ID.
671500     MOVE ZEROS                  TO MML1-SOURCE-CODE.
671600     MOVE MBCA-FIELD-SECURITY    TO MML1-FIELD-SECURITY.
671700     SET MBIORO-WRITE            TO TRUE.
671800     PERFORM MML1AO-ACCESS       THRU MML1AO-ACCESS-EXIT.
671900     MOVE SPACES                 TO MML1-VARIABLE-AREA.
672000*
672100 Y929-WLR-EXIT.
672200     EXIT.
672300*
672400 Y930-READ-MMRT.
672500*
672600****************************************
672700*    READ THE RATE TABLE TO VERIFY     *
672800*    THAT THE RECORD IS PRESENT        *
672900****************************************
673000*
673100     MOVE SS08WS-CICS-FC-NOTFND  TO MBIORO-TEMP-STATUS-1
673200     MOVE MBCA-MERCHANT-ORG      TO MBIOWS-MMRT-ORG.
673300     SET MBIORO-READ-RANDOM      TO TRUE.
673400     PERFORM MMRTAO-ACCESS       THRU MMRTAO-ACCESS-EXIT.
673500*
673600*
673700 Y939-RRT-EXIT.
673800     EXIT.
673900*
674000 Y950-READ-MMXR.
674100*
674200****************************************************************
674300*    START BROWSE THE STORE XREF FILE                          *
674400****************************************************************
674500*
674600     MOVE 'FC56'                 TO MBCA-PROGRAM-LOCATION.
674700     MOVE MBCA-MERCHANT-ORG      TO MBIOWS-MMXR-ORG.
674800     MOVE MBCA-MERCHANT          TO MBIOWS-MMXR-MERCHANT.
674900     MOVE ZEROS                  TO MBIOWS-MMXR-STORE.
675000     SET MBIORO-STARTBR-GTE      TO TRUE.
675100     PERFORM MMXRAO-ACCESS       THRU MMXRAO-ACCESS-EXIT.
675200*
675300 Y951-READ-LOOP.
675400*
675500****************************************************************
675600*    READNEXT THE STORE XREF FILE                              *
675700****************************************************************
675800*
675900     MOVE 'FC57'                 TO MBCA-PROGRAM-LOCATION.
676000     SET MBIORO-READ-SEQ         TO TRUE.
676100     PERFORM MMXRAO-ACCESS       THRU MMXRAO-ACCESS-EXIT.
676200*
676300*
676400     IF  MMXR-ORG-MERCHANT IS EQUAL TO MBCA-ORG-MERCHANT
676500     AND MMXR-STORE IS GREATER THAN ZEROS
676600     AND MMXR-REC-ACTIVE
676700         PERFORM Y960-READ-STORE
676800                                 THRU Y969-EXIT
676900         IF  SS08WS-RC-FC-NOTFND
677000             GO TO Y951-READ-LOOP
677100         ELSE
677200             IF  MM14-VI-STATUS-L IS GREATER THAN ZERO
677300               IF  MM14-VI-STATUS IS NOT EQUAL TO MMSM-VI-STATUS
677400                   SET WS-UPDATE-VI-SW-YES
677500                                 TO TRUE
677600                 IF  MBCA-PTI-FUNCTION-IS-MAINT
677700                 AND MMSM-ADD-COMPLETED
677800                     MOVE MMMMTB-PROD-STATUS (1:4)
677900                                 TO WS-INDEX-X
678000                     SET X-MMFS-MERCH
678100                                 TO WS-INDEX
678200                     MOVE MMFS-MT-AUDIT-CODE (X-MMFS-MERCH)
678300                                 TO MML1-MMSM-AUDIT-CODE
678400                     MOVE 9016   TO MML1-FIELD-CODE
678500                     MOVE ZEROES TO MML1-FIELD-OCCURRENCE
678600                                    MML1-FIELD-OCCURRENCE-2
678700                     MOVE MML1WS-VL-01
678800                                 TO MML1-VARIABLE-LENGTH
678900                     MOVE MMSM-VI-STATUS
679000                                 TO MML1-VL01-B-DATA-X
679100                     MOVE MM14-VI-STATUS
679200                                 TO MMSM-VI-STATUS
679300                     MOVE MMSM-VI-STATUS
679400                                 TO MML1-VL01-A-DATA-X
679500                     MOVE 'FC58'     TO MBCA-PROGRAM-LOCATION
679600                     PERFORM Y920-WRITE-MMSM-LOG-RECORD
679700                                 THRU Y929-WLR-EXIT
679800                 ELSE
679900                     MOVE MM14-VI-STATUS
680000                                 TO MMSM-VI-STATUS
680100                 END-IF
680200               END-IF
680300             END-IF
680400             IF  MM14-VI-EFF-DATE-L IS GREATER THAN ZERO
680500                 MOVE MM14-VI-EFF-DATE   TO SS01WS-DATE
680600                 PERFORM SS07PD-GREG-TO-JUL
680700                                 THRU SS07PD-GTJ-EXIT
680800               IF  SS01WS-JULIAN IS NOT EQUAL
680900                                 TO MMSM-VI-EFF-DATE
681000                   SET WS-UPDATE-VI-SW-YES
681100                                 TO TRUE
681200                  IF  MBCA-PTI-FUNCTION-IS-MAINT
681300                  AND MMSM-ADD-COMPLETED
681400                      MOVE MMMMTB-PROD-EFF-DATE (1:4)
681500                                 TO WS-INDEX-X
681600                      SET X-MMFS-MERCH
681700                                 TO WS-INDEX
681800                      MOVE MMFS-MT-AUDIT-CODE (X-MMFS-MERCH)
681900                                 TO MML1-MMSM-AUDIT-CODE
682000                      MOVE 9017  TO MML1-FIELD-CODE
682100                      MOVE ZEROES
682200                                 TO MML1-FIELD-OCCURRENCE
682300                                    MML1-FIELD-OCCURRENCE-2
682400                      MOVE MML1WS-VL-07
682500                                 TO MML1-VARIABLE-LENGTH
682600                      MOVE MMSM-VI-EFF-DATE
682700                                 TO MML1-VL07-B-DATA-9
682800                      MOVE SS01WS-JULIAN
682900                                 TO MMSM-VI-EFF-DATE
683000                      MOVE MMSM-VI-EFF-DATE
683100                                 TO MML1-VL07-A-DATA-9
683200                      MOVE 'FC59'   TO MBCA-PROGRAM-LOCATION
683300                      PERFORM Y920-WRITE-MMSM-LOG-RECORD
683400                                 THRU Y929-WLR-EXIT
683500                  ELSE
683600                      MOVE SS01WS-JULIAN
683700                                 TO MMSM-VI-EFF-DATE
683800                  END-IF
683900                END-IF
684000              END-IF
684100              IF  WS-UPDATE-VI-SW-YES
684200                IF  MBCA-PTI-FUNCTION-IS-MAINT
684300                    MOVE 0198    TO MML1-FIELD-CODE
684400                    MOVE ZEROES  TO MML1-FIELD-OCCURRENCE
684500                                    MML1-FIELD-OCCURRENCE-2
684600                    MOVE MML1WS-VL-03
684700                                 TO MML1-VARIABLE-LENGTH
684800                    MOVE MMSM-LAST-MAINT-OPER
684900                                 TO MML1-VL03-B-DATA-X
685000                    MOVE MBCA-OPERATOR-ID
685100                                 TO MMSM-LAST-MAINT-OPER
685200                    MOVE MMSM-LAST-MAINT-OPER
685300                                 TO MML1-VL03-A-DATA-X
685400                    MOVE 'FC60'  TO MBCA-PROGRAM-LOCATION
685500                    PERFORM Y920-WRITE-MMSM-LOG-RECORD
685600                                 THRU Y929-WLR-EXIT
685700                    MOVE 0199    TO MML1-FIELD-CODE
685800                    MOVE MML1WS-VL-07
685900                                 TO MML1-VARIABLE-LENGTH
686000                    MOVE MMSM-LAST-MAINT-DATE
686100                                 TO MML1-VL07-B-DATA-9
686200                    MOVE MBCA-START-DATE
686300                                 TO MMSM-LAST-MAINT-DATE
686400                    MOVE MMSM-LAST-MAINT-DATE
686500                                 TO MML1-VL07-A-DATA-9
686600                    MOVE 'FC61'  TO MBCA-PROGRAM-LOCATION
686700                    PERFORM Y920-WRITE-MMSM-LOG-RECORD
686800                                 THRU Y929-WLR-EXIT
686900                    MOVE 'FC62'    TO MBCA-PROGRAM-LOCATION
687000                    SET MBIORO-REWRITE
687100                                 TO TRUE
687200                    PERFORM MMSMAO-ACCESS
687300                                 THRU MMSMAO-ACCESS-EXIT
687400                    GO TO Y951-READ-LOOP
687500                ELSE
687600                    MOVE 'FC63'    TO MBCA-PROGRAM-LOCATION
687700                    SET MBIORO-REWRITE
687800                                 TO TRUE
687900                    PERFORM MMSMAO-ACCESS
688000                                 THRU MMSMAO-ACCESS-EXIT
688100                    GO TO Y951-READ-LOOP
688200              ELSE
688300                  MOVE 'FC64'    TO MBCA-PROGRAM-LOCATION
688400                  SET MBIORO-UNLOCK
688500                                 TO TRUE
688600                  PERFORM MMSMAO-ACCESS
688700                                 THRU MMSMAO-ACCESS-EXIT
688800              END-IF
688900         END-IF
689000     ELSE
689100         IF  MMXR-ORG-MERCHANT IS GREATER THAN MBCA-ORG-MERCHANT
689200             NEXT SENTENCE
689300         ELSE
689400             GO TO Y951-READ-LOOP.
689500*
689600****************************************************************
689700*    END BROWSE THE STORE XREF FILE                            *
689800****************************************************************
689900*
690000     MOVE 'FC65'                 TO MBCA-PROGRAM-LOCATION.
690100     SET MBIORO-ENDBR            TO TRUE.
690200     PERFORM MMXRAO-ACCESS       THRU MMXRAO-ACCESS-EXIT.
690300*
690400 Y959-EXIT.
690500     EXIT.
690600*
690700 Y960-READ-STORE.
690800*
690900     MOVE MBCA-MERCHANT-ORG      TO MBIOWS-MMSM-ORG.
691000     MOVE MMXR-STORE             TO MBIOWS-MMSM-STORE.
691100     MOVE SS08WS-CICS-FC-NOTFND  TO MBIORO-TEMP-STATUS-1.
691200     MOVE 'FC66'                 TO MBCA-PROGRAM-LOCATION.
691300     SET MBIORO-READ-RANDOM-UPDATE
691400                                 TO TRUE.
691500     PERFORM MMSMAO-ACCESS       THRU MMSMAO-ACCESS-EXIT.
691600*
691700 Y969-EXIT.
691800     EXIT.
691900/
692000 Z000-COPIED-ROUTINES SECTION.
692100*
692110     COPY SMCAPXO REPLACING ==:XXCA:== BY ==MBCA==.
692112/
692200*********************************
692300*    DATE VALIDATION ROUTINE    *
692400*********************************
692500*
692600     COPY SS05PD.
692700/
692800**********************************
692900*    GREG TO JUL DATE ROUTINE    *
693000**********************************
693100*
693200     COPY SS07PD.
693300*
693400**********************************
693500*    JUL TO GREG DATE ROUTINE    *
693600**********************************
693700*
693800     COPY SS08PD.
693900/
694000**********************************
694100*    DATE AND TIME EDIT ROUTINES *
694200**********************************
694300*
694400     COPY SS26PD.
694500     COPY SS27PD.
694600/
694700*********************************
694800*    LINE 24 PF KEYS ROUTINE    *
694900*********************************
695000*
695100     COPY SS15PD.
695200/
695300*********************************************
695400*    ORGANIZATION RECORD ACCESS ROUTINES    *
695500*********************************************
695600*
695700     COPY MMOCAO.
695800/
695900************************************************
696000*    MERCHANT MASTER RECORD ACCESS ROUTINES    *
696100************************************************
696200*
696300     COPY MMMMAO.
696400/
696500************************************************
696600*    STORE MASTER RECORD ACCESS ROUTINES       *
696700************************************************
696800*
696900     COPY MMSMAO.
697000/
697100*********************************************************
697200*    MERCHANT PRODASSIGNMENTS RECORD ACCESS ROUTINES    *
697300*********************************************************
697400*
697500     COPY MMMPAO.
697600/
697700*********************************************************
697800*    STORE MERCH CROSS REF FILE RECORD ACCESS ROUTINES  *
697900*********************************************************
698000*
698100     COPY MMXRAO.
698200/
698300************************************************
698400*    RATE TABLE RECORD ACCESS ROUTINES         *
698500************************************************
698600*
698700     COPY MMRTAO.
698800/
698900***********************************************
699000*    FIELD SECURITY RECORD ACCESS ROUTINES    *
699100***********************************************
699200*
699300     COPY MMFSAO.
699400/
699500*****************************************
699600*    LOG FILE RECORD ACCESS ROUTINES    *
699700*****************************************
699800*
699900     COPY MML1AO.
700000/
700100*****************************
700200*    FORMATTED MESSAGE LINE *
700300*****************************
700400*
700500     COPY MB06PD.
700600/
700700*****************************
700800*    ONLINE MAP ROUTINES    *
700900*****************************
701000*
701100     COPY MB60PD REPLACING 'MBMAPXX' BY 'MBMM14 '
701200                           MBMAPXXI BY MBMM14I
701300                           MBMAPXXO BY MBMM14O.
701400/
701500***************************
701600*    ONLINE PROCEDURES    *
701700***************************
701800*
701900     COPY MB70PD.
702000/
702100     COPY SMFTPXO.
