000100 IDENTIFICATION DIVISION.
000200 PROGRAM-ID. MBOMS08.
000201*       RELEASE DATE=08/24/01.        REVISION LEVEL=08.06      * ++++++++
000202***************************************************************** ++++++++
000203*WARNING.  THIS COMPUTER PROGRAM IS PROTECTED BY COPYRIGHT LAW  * ++++++++
000204*AND INTERNATIONAL TREATIES.  UNAUTHORIZED REPRODUCTION OR      * ++++++++
000205*DISTRIBUTION OF THIS PROGRAM, OR ANY PORTION OF IT, MAY RESULT * ++++++++
000206*IN SEVERE CIVIL AND CRIMINAL PENATLIES, AND WILL BE PROSECUTED * ++++++++
000207*TO THE MAXIMUM EXTENT POSSIBLE UNDER THE LAW.                  * ++++++++
000208*COPYRIGHT 1999 PAYSYS INTERNATIONAL, INC.  ALL RIGHTS RESERVED.* ++++++++
000209***************************************************************** ++++++++
001200*****************************************************************
001300*                                                               *
001400*   V - 2 1   M E R C H A N T   B A N K C A R D   S Y S T E M   *
001500*                                                               *
001600*      MBOMS08 - STORE MASTER RECORD ADD/MAINT/INQ              *
001700*                SCREEN 08                                      *
001800*                                                               *
001900*              1. TRANSIDS                                      *
002000*                 A. MBAS                                       *
002100*                 B. MBMS                                       *
002200*                 C. MBQS                                       *
002300*              2. MAPS USED -                                   *
002400*                 A. MBMS08 (SCREEN 08)                         *
002500*              3. FILES USED -                                  *
002600*                 A. MMFS (FIELD SECURITY FILE)                 *
002700*                 B. MMSM (STORE MASTER FILE)                   *
002800*                 C. MMOC (ORGANIZATION FILE)                   *
002900*                 F. MMMP (MERCH PRODUCT FILE)                  *
003000*                 G. MML1 (LOG FILE)                            *
003100*                                                               *
003200*****************************************************************
003300*
003400 ENVIRONMENT DIVISION.
003500*
003600 DATA DIVISION.
003700*
003800 WORKING-STORAGE SECTION.
003900*
004000 01  FILLER                  PIC  X(12)      VALUE '** WS-BEG **'.
004100*
004200 01  FILLER                  PIC  X(14)      VALUE
004300     'MISCELLANEOUS:'.
004400*
004500 01  WS-MISCELLANEOUS.
004600     03  WS-FIELD-POSITION   PIC S9(03)      VALUE ZEROES COMP-3.
004700     03  WS-INDEX-X.
004800         05  WS-INDEX        PIC  9(04)      VALUE ZEROS.
004900     03  WS-PRODUCT-NBR      PIC  9(02)      VALUE ZEROS.
005000*
005100 01  FILLER                  PIC  X(17)      VALUE
005200     'PROGRAM SWITCHES:'.
005300*
005400 01  WS-PROGRAM-SWITCHES.
005500     03  WS-UPDATE-MMSM-SW   PIC  X(01)      VALUE 'N'.
005600         88  WS-UPDATE-MMSM-SW-YES           VALUE 'Y'.
005700         88  WS-UPDATE-MMSM-SW-NO            VALUE 'N'.
005800     03  TS-QUEUE-NAME.
005900         05  TS-QN-TERMID    PIC  X(04)      VALUE SPACES.
006000         05  TS-QN-TRANID    PIC  X(04)      VALUE 'MBUI'.
006100/
006200 01  FILLER                  PIC  X(29)      VALUE
006300     'I/O REQUEST BLOCK WORK AREAS:'.
006400*
006500     COPY MBIOWS.
006600/
006700 01  FILLER                  PIC  X(18)      VALUE
006800     'I/O REQUEST BLOCK:'.
006900*
007000     COPY MBIORO.
007100/
007200 01  FILLER                  PIC  X(25)      VALUE
007300     'LOG RECORD REQUEST BLOCK:'.
007400*
007500     COPY MML1WS REPLACING ==:MML1:== BY ==MML1==.
007600/
007700 01  FILLER                  PIC  X(26)      VALUE
007800     'STORE MASTER FIELDS TABLE:'.
007900*
008000     COPY MMSMTB.
008100/
008200 01  FILLER                  PIC  X(29)      VALUE
008300     'STORE INIT RECORD         '.
008400*
008500     COPY MMSMIR.
008600/
008700 01  FILLER                  PIC  X(20)      VALUE
008800     'CCS DATE WORK AREAS:'.
008900*
009000     COPY SS01WS.
009100/
009200 01  FILLER                  PIC  X(15)      VALUE
009300     'CCS WORK AREAS:'.
009400*
009500     COPY SS08WS.
009600/
009700     COPY SS00WS.
009800/
009900     COPY SMFTWS.
010000/
010100     COPY SMPTRL REPLACING ==:SMPT:== BY ==SMPT==.
010200/
010300     COPY MB61LK.
010400/
010500     COPY SMCAWS.
010600/
010700     COPY SMCARL.
010800/
010900     COPY SC00WS.
011000*
011100 01  FILLER                  PIC  X(12)      VALUE '** WS-END **'.
011200/
011300 LINKAGE SECTION.
011400*
011500 01  DFHCOMMAREA.
011600*
011700***************************
011800*    ONLINE FILE TABLE    *
011900***************************
012000*
012100     COPY MB60WS.
012200/
012300*
012400*****************************
012500*    MERCHANT MASTER MAP    *
012600*****************************
012700*
012800     COPY MBMS08.
012900/
013000******************************************
013100*    MERCHANT MASTER MAP REDEFINITION    *
013200******************************************
013300*
013400     COPY MBMS08R.
013500/
013600************************************
013700*    ORGANIZATION RECORD LAYOUT    *
013800************************************
013900*
014000     COPY MMOCRL.
014100/
014200***************************************
014300*    STORE MASTER RECORD LAYOUT       *
014400***************************************
014500*
014600     COPY MMSMRL.
014700/
014800***************************************
014900*    MERCHANT PRODUCT RECORD LAYOUT   *
015000***************************************
015100*
015200     COPY MMMPRL.
015300/
015400**************************************
015500*    FIELD SECURITY RECORD LAYOUT    *
015600**************************************
015700*
015800     COPY MMFSRL.
015900/
016000***************************
016100*    LOG RECORD LAYOUT    *
016200***************************
016300*
016400     COPY MML1RL REPLACING ==:MML1:== BY ==MML1==.
016500/
016600***************************************
016700*    USER INPUT TEMP STORAGE RECORD   *
016800***************************************
016900*
017000     COPY MBUITS.
017100/
017200 PROCEDURE DIVISION.
017300*
017400 A000-HOUSEKEEPING SECTION.
017500*
017600 A020-INIT.
017700*
017800     MOVE 'PC01'                 TO MBCA-PROGRAM-LOCATION.
017900     PERFORM MB70PD-ON-LINE-HOUSEKEEPING
018000                                 THRU MB70PD-OLH-EXIT.
018100*
018200     IF  MBCA-MBUI-UI-YES
018300         NEXT SENTENCE
018400     ELSE
018500         SET MBCA-MBUI-UI-NO     TO TRUE.
018600*
018700     MOVE MBCA-TERMINAL-ID       TO TS-QN-TERMID.
018800*
018900     IF  MBCA-RECEIVE-SCREEN
019000         GO TO C000-RECEIVE-SCREEN.
019100/
019200 B000-SEND-SCREEN SECTION.
019300*
019400*********************************************
019500*    GET CICS STORAGE NEEDED FOR THE MAP    *
019600*********************************************
019700*
019800     MOVE 'SC01'                 TO MBCA-PROGRAM-LOCATION.
019900     PERFORM MB60PD-GETMAIN-FOR-MAP
020000                                 THRU MB60PD-GFM-EXIT.
020100*
020200*******************************************
020300*    INITIALIZE THE STANDARD MAP LINES    *
020400*******************************************
020500*
020600     PERFORM MB60PD-INIT-STD-MAP-LINES
020700                                 THRU MB60PD-ISML-EXIT.
020800*
020900*****************************************
021000*    READ THE STORE MASTER RECORD       *
021100*****************************************
021200*
021300     MOVE MBCA-MERCHANT-ORG      TO MBIOWS-MMSM-ORG
021400                                    MS08-ORG.
021500     MOVE MBCA-STORE             TO MBIOWS-MMSM-STORE
021600                                    MS08-STORE.
021700     MOVE 'FC01'                 TO MBCA-PROGRAM-LOCATION.
021800     SET MBIORO-READ-RANDOM      TO TRUE.
021900     PERFORM MMSMAO-ACCESS       THRU MMSMAO-ACCESS-EXIT.
022000*
022100*****************************************
022200*    EDIT FOR SINGLE STORE RECORD       *
022300*****************************************
022400*
022500     IF  MBCA-PTI-FUNCTION-IS-MAINT
022600     AND MMSM-REC-SINGLE-STORE
022700         MOVE 59                 TO MBCA-SCREEN-NBR
022800         MOVE 'PC09'             TO MBCA-PROGRAM-LOCATION
022900         PERFORM MB70PD-XCTL-TO-MBOXCTL
023000                                 THRU MB70PD-XTM-EXIT.
023100*
023200     MOVE MMSM-NA-LINE (1 1)     TO MS08-STORE-NAME.
023300*
023400*************************************************
023500*    IF MC-STATUS IS NOT ACTIVE GO TO LOCATE    *
023600*************************************************
023700*
023800     MOVE MBCA-MERCHANT-ORG      TO MBIOWS-MMMP-ORG.
023900     MOVE MMSM-MERCHANT-ID       TO MBIOWS-MMMP-MERCHANT.
024000     MOVE 02                     TO MBIOWS-MMMP-PRODUCT.
024100     MOVE SS08WS-CICS-FC-NOTFND  TO MBIORO-TEMP-STATUS-1.
024200     MOVE 'FC02'                 TO MBCA-PROGRAM-LOCATION.
024300     SET MBIORO-READ-RANDOM      TO TRUE.
024400     PERFORM MMMPAO-ACCESS       THRU MMMPAO-ACCESS-EXIT.
024500*
024600     IF  SS08WS-RC-FC-NOTFND
024700         MOVE 59                 TO MBCA-SCREEN-NBR
024800         MOVE 'PC06'             TO MBCA-PROGRAM-LOCATION
024900         PERFORM MB70PD-XCTL-TO-MBOXCTL
025000                                 THRU MB70PD-XTM-EXIT
025100     ELSE
025200         IF  NOT MMMP-PROD-ACTIVE
025300             MOVE 59             TO MBCA-SCREEN-NBR
025400             MOVE 'PC02'         TO MBCA-PROGRAM-LOCATION
025500             PERFORM MB70PD-XCTL-TO-MBOXCTL
025600                                 THRU MB70PD-XTM-EXIT.
025700*
025800*****************************************
025900*    READ THE ORGANIZATION FILE         *
026000*****************************************
026100*
026200     MOVE MBCA-MERCHANT-ORG      TO MBIOWS-MMOC-ORG.
026300     MOVE 'FC03'                 TO MBCA-PROGRAM-LOCATION.
026400     SET MBIORO-READ-RANDOM      TO TRUE.
026500     PERFORM MMOCAO-ACCESS       THRU MMOCAO-ACCESS-EXIT.
026600*
026700     IF  MMOC-MC-QTR-FLAG-EUROCARD
026800     OR  MMOC-VISA-QTR-FLAG-EU
026900         SET MBCA-MBMS-EUROPAY-ON
027000                                 TO TRUE
027100     ELSE
027200         SET MBCA-MBMS-EUROPAY-OFF
027300                                 TO TRUE
027400     END-IF.
027500*
027600****************************************
027700*    READ THE FIELD SECURITY RECORD    *
027800****************************************
027900*
028000     MOVE 'FC04'                 TO MBCA-PROGRAM-LOCATION.
028100     PERFORM Y900-READ-MMFS      THRU Y909-READ-MMFS-EXIT.
028200*
028300 B020-MOVE-FIELDS-TO-SCREEN.
028400*
028500*****************************************
028600*    MOVE THE MERCHANT MASTER FIELDS    *
028700*    FROM THE RECORD TO THE SCREEN      *
028800*****************************************
028900*
029000*
029100     PERFORM Y010-MOVE-DBA-NAME
029200                                 THRU Y019-EXIT.
029300*
029400     PERFORM Y030-MOVE-CIRRUS-IND
029500                                 THRU Y039-EXIT.
029600*
029700     PERFORM Y050-MOVE-INTCHG-IND
029800                                 THRU Y059-EXIT.
029900*
030000     PERFORM Y070-MOVE-BUS-CLASS-CODE
030100                                 THRU Y079-EXIT.
030200*
030300     PERFORM Y130-MOVE-CATEGORY-CODE
030400                                 THRU Y139-EXIT.
030500*
030600     PERFORM Y150-MOVE-FLOOR-LIMIT
030700                                 THRU Y159-EXIT.
030800*
030900     PERFORM Y170-MOVE-MC-CH-TERM-IND
031000                                 THRU Y179-EXIT.
031100*
031110*                                                                 RG800913
031120     PERFORM Y180-MOVE-ASSIGNED-ID                                RG800913
031130                                 THRU Y189-EXIT.                  RG800913
031200     IF  MBCA-MBMS-EUROPAY-ON
031300         PERFORM Y190-MOVE-MC-POS-DC-01
031400                                 THRU Y199-EXIT
031500*
031600         PERFORM Y210-MOVE-MC-POS-DC-02
031700                                 THRU Y219-EXIT
031800*
031900         PERFORM Y230-MOVE-MC-POS-DC-03
032000                                 THRU Y239-EXIT
032100*
032200         PERFORM Y250-MOVE-MC-POS-DC-04
032300                                 THRU Y259-EXIT
032400*
032500         PERFORM Y270-MOVE-MC-POS-DC-05
032600                                 THRU Y279-EXIT
032700*
032800         PERFORM Y290-MOVE-MC-POS-DC-06
032900                                 THRU Y299-EXIT
033000*
033100         PERFORM Y310-MOVE-MC-POS-DC-07
033200                                 THRU Y319-EXIT
033300*
033400         PERFORM Y330-MOVE-MC-POS-DC-08
033500                                 THRU Y339-EXIT
033600*
033700         PERFORM Y350-MOVE-MC-POS-DC-09
033800                                 THRU Y359-EXIT
033900*
034000         PERFORM Y370-MOVE-MC-POS-DC-10
034100                                 THRU Y379-EXIT
034200*
034300         PERFORM Y390-MOVE-MC-POS-DC-11
034400                                 THRU Y399-EXIT
034500*
034600         PERFORM Y410-MOVE-MC-POS-DC-12
034700                                 THRU Y419-EXIT
034800     ELSE
034900         MOVE DFHBMDAS           TO MS08-MC-POS-DC-01-LP-A
035000                                    MS08-MC-POS-DC-01-RP-A
035100                                    MS08-MC-POS-DC-02-LP-A
035200                                    MS08-MC-POS-DC-02-RP-A
035300                                    MS08-MC-POS-DC-03-LP-A
035400                                    MS08-MC-POS-DC-03-RP-A
035500                                    MS08-MC-POS-DC-04-LP-A
035600                                    MS08-MC-POS-DC-04-RP-A
035700                                    MS08-MC-POS-DC-05-LP-A
035800                                    MS08-MC-POS-DC-05-RP-A
035900                                    MS08-MC-POS-DC-06-LP-A
036000                                    MS08-MC-POS-DC-06-RP-A
036100                                    MS08-MC-POS-DC-07-LP-A
036200                                    MS08-MC-POS-DC-07-RP-A
036300                                    MS08-MC-POS-DC-08-LP-A
036400                                    MS08-MC-POS-DC-08-RP-A
036500                                    MS08-MC-POS-DC-09-LP-A
036600                                    MS08-MC-POS-DC-09-RP-A
036700                                    MS08-MC-POS-DC-10-LP-A
036800                                    MS08-MC-POS-DC-10-RP-A
036900                                    MS08-MC-POS-DC-11-LP-A
037000                                    MS08-MC-POS-DC-11-RP-A
037100                                    MS08-MC-POS-DC-12-LP-A
037200                                    MS08-MC-POS-DC-12-RP-A
037300                                    MS08-MC-POS-DC-12-RP-A
037400                                    MS08-MC-POS-DC-DESC-LIT-A
037500         MOVE DFHBMASK           TO MS08-MC-POS-DC-01-A
037600                                    MS08-MC-POS-DC-02-A
037700                                    MS08-MC-POS-DC-03-A
037800                                    MS08-MC-POS-DC-04-A
037900                                    MS08-MC-POS-DC-05-A
038000                                    MS08-MC-POS-DC-06-A
038100                                    MS08-MC-POS-DC-07-A
038200                                    MS08-MC-POS-DC-08-A
038300                                    MS08-MC-POS-DC-09-A
038400                                    MS08-MC-POS-DC-10-A
038500                                    MS08-MC-POS-DC-11-A
038600                                    MS08-MC-POS-DC-12-A.
038700*
038800******************************************
038900*    SET THE CURSOR AND SCREEN NUMBER    *
039000******************************************
039100*
039200     IF  MBCA-PTI-FUNCTION-IS-INQUIRY
039300         MOVE SS08WS-CURSOR      TO MS08-ALT-TRANID-L
039400     ELSE
039500         PERFORM Y800-SET-CURSOR THRU Y809-SC-EXIT.
039600*
039700     COMPUTE MBCA-SCREEN-NBR     =  MBCA-SCREEN-NBR - 50.
039800*
039900**********************
040000*    SEND THE MAP    *
040100**********************
040200*
040300     MOVE 'BM01'                 TO MBCA-PROGRAM-LOCATION.
040400     PERFORM MB60PD-SEND-MAP-WITH-ERASE
040500                                 THRU MB60PD-SMWE-EXIT.
040600*
040700************************
040800*    RETURN TO CICS    *
040900************************
041000*
041100     MOVE 'PC02'                 TO MBCA-PROGRAM-LOCATION.
041200     PERFORM MB70PD-RETURN-TRANS-ID
041300                                 THRU MB70PD-RTI-EXIT.
041400/
041500 C000-RECEIVE-SCREEN SECTION.
041600*
041700******************************************
041800*    THIS SECTION RECEIVES THE SCREEN    *
041900******************************************
042000*
042100     IF  MBCA-MBUI-UI-YES
042200*
042300****************************************************************
042400*    ACQUIRE MAIN STORAGE FOR TEMP STORAGE RECORD              *
042500****************************************************************
042600*
042700         MOVE 'TS01'             TO MBCA-PROGRAM-LOCATION
042800         EXEC CICS GETMAIN
042900                   FLENGTH (LENGTH  OF MBUITS-RECORD)
043000
043100                   SET     (ADDRESS OF MBUITS-RECORD)
043200
043300              END-EXEC
043400*
043500***********************************************
043600*    READ THE TEMP STORAGE RECORD             *
043700***********************************************
043800*
043900         MOVE 'TS02'             TO MBCA-PROGRAM-LOCATION
044000*
044100         EXEC CICS READQ TS
044200                   QUEUE   (TS-QUEUE-NAME)
044300                   INTO    (MBUITS-RECORD)
044400                   LENGTH  (LENGTH  OF MBUITS-RECORD)
044500                   ITEM    (1)
044600              END-EXEC
044700*
044800***********************************************
044900*    DELETE THE TEMP STORAGE RECORD           *
045000***********************************************
045100*
045200         MOVE 'TS03'             TO MBCA-PROGRAM-LOCATION
045300*
045400         EXEC CICS IGNORE CONDITION
045500                   QIDERR
045600              END-EXEC
045700*
045800         EXEC CICS DELETEQ TS
045900                   QUEUE  (TS-QUEUE-NAME)
046000              END-EXEC
046100         MOVE 'SC02'             TO MBCA-PROGRAM-LOCATION
046200         PERFORM MB60PD-GETMAIN-FOR-MAP
046300                                 THRU MB60PD-GFM-EXIT
046400         MOVE MBUITS-VAR-DATA    TO MBMS08I
046500     ELSE
046600         MOVE 'BM02'             TO MBCA-PROGRAM-LOCATION
046700         PERFORM MB60PD-RECEIVE-MAP
046800                                 THRU MB60PD-RM-EXIT.
046900*
047000**************************************************************
047100*    CHECK FOR ANOTHER TRANSACTION ID ENTERED BY THE USER    *
047200**************************************************************
047300*
047400     MOVE 'PC03'                 TO MBCA-PROGRAM-LOCATION.
047500     PERFORM MB60PD-NEW-TRANS-ROUTINE
047600                                 THRU MB60PD-NTR-EXIT.
047700*
047800****************************************************
047900*    BYPASS ALL SCREEN EDITS IF THIS IS INQIURY    *
048000****************************************************
048100*
048200     IF  MBCA-PTI-FUNCTION-IS-INQUIRY
048300         GO TO F000-SETUP-COMMAREA.
048400*
048500*****************************************
048600*    READ THE STORE MASTER RECORD       *
048700*****************************************
048800*
048900*
049000     IF  MBCA-PTI-FUNCTION-IS-ADD
049100     AND MBCA-MBUI-UI-YES
049200     AND MBCA-MBUI-UI-UPDATE-NO
049300         MOVE 'SC03'             TO MBCA-PROGRAM-LOCATION
049400         SET MBIORO-GETMAIN      TO TRUE
049500         PERFORM MMSMAO-ACCESS   THRU MMSMAO-ACCESS-EXIT
049600         MOVE MMSMIR-RECORD      TO MMSM-RECORD
049700     ELSE
049800         MOVE SS08WS-CICS-FC-NOTFND TO MBIORO-TEMP-STATUS-1
049900         MOVE MBCA-MERCHANT-ORG  TO MBIOWS-MMSM-ORG
050000                                    MS08-ORG
050100         MOVE MBCA-STORE         TO MBIOWS-MMSM-STORE
050200                                    MS08-STORE
050300         MOVE 'FC05'             TO MBCA-PROGRAM-LOCATION
050400         SET MBIORO-READ-RANDOM  TO TRUE
050500         PERFORM MMSMAO-ACCESS   THRU MMSMAO-ACCESS-EXIT
050600         IF  SS08WS-RC-FC-NOTFND
050700         AND MBCA-MBUI-UI-YES
050800             MOVE 'MBUI'         TO MBCA-TRANS-ID
050900                                    MBCA-PREV-TRANS-ID
051000             MOVE 01             TO MBCA-SCREEN-NBR
051100             MOVE 'STR'          TO MS08-FILLER
051200             SET MBCA-MBUI-ERROR-YES
051300                                 TO TRUE
051400             GO TO F000-SETUP-COMMAREA.
051500*
051600     IF (MBCA-PTI-FUNCTION-IS-MAINT
051700     AND MBCA-MBUI-UI-YES
051800     AND (MMSM-REC-PURGED
051900       OR MMSM-REC-INCOMPLETE))
052000     OR
052100        (MBCA-PTI-FUNCTION-IS-ADD
052200     AND MBCA-MBUI-UI-YES
052300     AND MMSM-REC-PURGED)
052400         MOVE 'MBUI'             TO MBCA-TRANS-ID
052500                                    MBCA-PREV-TRANS-ID
052600         MOVE 01                 TO MBCA-SCREEN-NBR
052700         MOVE 'STR'              TO MS08-FILLER
052800         SET MBCA-MBUI-ERROR-YES
052900                                 TO TRUE
053000         GO TO F000-SETUP-COMMAREA.
053100*
053200****************************************
053300*    READ THE FIELD SECURITY RECORD    *
053400****************************************
053500*
053600     MOVE 'FC06'                 TO MBCA-PROGRAM-LOCATION.
053700     PERFORM Y900-READ-MMFS      THRU Y909-READ-MMFS-EXIT.
053800*
053900 C020-FIELD-EDITS.
054000*
054100*********************
054200*    FIELD EDITS    *
054300*********************
054400*
054500     PERFORM W010-EDIT-DBA-NAME  THRU W019-EXIT.
054600*
054700     PERFORM W030-EDIT-CIRRUS-IND
054800                                 THRU W039-EXIT.
054900*
055000     PERFORM W050-EDIT-INTCHG-IND
055100                                 THRU W059-EXIT.
055200*
055300     PERFORM W070-EDIT-BUS-CLASS-CODE
055400                                 THRU W079-EXIT.
055500*
055600     PERFORM W130-EDIT-CATEGORY  THRU W139-EXIT.
055700*
055800     PERFORM W150-EDIT-FLOOR-LIMIT
055900                                 THRU W159-EXIT.
056000*
056100     PERFORM W170-EDIT-MC-CH-TERM-IND
056200                                 THRU W179-EXIT.
056300*
056310*                                                                 RG800913
056320     PERFORM W180-EDIT-ASSIGNED-ID                                RG800913
056330                                 THRU W189-EXIT.                  RG800913
056400     IF  MBCA-MBMS-EUROPAY-ON
056500         PERFORM W190-EDIT-MC-POS-DC-01
056600                                 THRU W199-EXIT
056700*
056800         PERFORM W210-EDIT-MC-POS-DC-02
056900                                 THRU W219-EXIT
057000*
057100         PERFORM W230-EDIT-MC-POS-DC-03
057200                                 THRU W239-EXIT
057300*
057400         PERFORM W250-EDIT-MC-POS-DC-04
057500                                 THRU W259-EXIT
057600*
057700         PERFORM W270-EDIT-MC-POS-DC-05
057800                                 THRU W279-EXIT
057900*
058000         PERFORM W290-EDIT-MC-POS-DC-06
058100                                 THRU W299-EXIT
058200*
058300         PERFORM W310-EDIT-MC-POS-DC-07
058400                                 THRU W319-EXIT
058500*
058600         PERFORM W330-EDIT-MC-POS-DC-08
058700                                 THRU W339-EXIT
058800*
058900         PERFORM W350-EDIT-MC-POS-DC-09
059000                                 THRU W359-EXIT
059100*
059200         PERFORM W370-EDIT-MC-POS-DC-10
059300                                 THRU W379-EXIT
059400*
059500         PERFORM W390-EDIT-MC-POS-DC-11
059600                                 THRU W399-EXIT
059700*
059800         PERFORM W410-EDIT-MC-POS-DC-12
059900                                 THRU W419-EXIT
060000     ELSE
060100         MOVE DFHBMDAS           TO MS08-MC-POS-DC-01-LP-A
060200                                    MS08-MC-POS-DC-01-RP-A
060300                                    MS08-MC-POS-DC-02-LP-A
060400                                    MS08-MC-POS-DC-02-RP-A
060500                                    MS08-MC-POS-DC-03-LP-A
060600                                    MS08-MC-POS-DC-03-RP-A
060700                                    MS08-MC-POS-DC-04-LP-A
060800                                    MS08-MC-POS-DC-04-RP-A
060900                                    MS08-MC-POS-DC-05-LP-A
061000                                    MS08-MC-POS-DC-05-RP-A
061100                                    MS08-MC-POS-DC-06-LP-A
061200                                    MS08-MC-POS-DC-06-RP-A
061300                                    MS08-MC-POS-DC-07-LP-A
061400                                    MS08-MC-POS-DC-07-RP-A
061500                                    MS08-MC-POS-DC-08-LP-A
061600                                    MS08-MC-POS-DC-08-RP-A
061700                                    MS08-MC-POS-DC-09-LP-A
061800                                    MS08-MC-POS-DC-09-RP-A
061900                                    MS08-MC-POS-DC-10-LP-A
062000                                    MS08-MC-POS-DC-10-RP-A
062100                                    MS08-MC-POS-DC-11-LP-A
062200                                    MS08-MC-POS-DC-11-RP-A
062300                                    MS08-MC-POS-DC-12-LP-A
062400                                    MS08-MC-POS-DC-12-RP-A
062500                                    MS08-MC-POS-DC-12-RP-A
062600                                    MS08-MC-POS-DC-DESC-LIT-A
062700         MOVE DFHBMASK           TO MS08-MC-POS-DC-01-A
062800                                    MS08-MC-POS-DC-02-A
062900                                    MS08-MC-POS-DC-03-A
063000                                    MS08-MC-POS-DC-04-A
063100                                    MS08-MC-POS-DC-05-A
063200                                    MS08-MC-POS-DC-06-A
063300                                    MS08-MC-POS-DC-07-A
063400                                    MS08-MC-POS-DC-08-A
063500                                    MS08-MC-POS-DC-09-A
063600                                    MS08-MC-POS-DC-10-A
063700                                    MS08-MC-POS-DC-11-A
063800                                    MS08-MC-POS-DC-12-A.
063900*
064000 C040-CROSS-EDITS.
064100*
064200*********************
064300*    CROSS EDITS    *
064400*********************
064500*
064600     PERFORM W700-CIRRUS-X-EDITS
064700                                 THRU W709-EXIT.
064800*
064900     IF  MBCA-MBMS-EUROPAY-OFF
065000         PERFORM W720-CAT-X-EDIT THRU W729-EXIT.                  RG802901
065100*
065200     IF  MBCA-MBMS-EUROPAY-ON
065300         PERFORM W710-POS-DC-01-X-EDITS
065400                                 THRU W719-EXIT.
065500/
065600 D000-RETURN-ERRORS SECTION.
065700*
065800     IF  SS08WS-ERROR-SW-NO
065900         GO TO E000-UPDATE-FILE.
066000*
066100     IF  MBCA-MBUI-UI-YES
066200         MOVE 'MBUI'             TO MBCA-TRANS-ID
066300                                    MBCA-PREV-TRANS-ID
066400         MOVE 01                 TO MBCA-SCREEN-NBR
066500         SET MBCA-MBUI-ERROR-YES TO TRUE
066600         GO TO F000-SETUP-COMMAREA.
066700*
066800***************************************************************
066900*    INITIALIZE THE STANDARD MAP LINES.  IN AN ERROR          *
067000*    CONDITION, THIS ROUTINE IS PERFORMED PRIMARILY           *
067100*    TO UPDATE THE DATE AND TIME ON THE SCREEN.               *
067200***************************************************************
067300*
067400     PERFORM MB60PD-INIT-STD-MAP-LINES
067500                                 THRU MB60PD-ISML-EXIT.
067600*
067700**********************
067800*    SEND THE MAP    *
067900**********************
068000*
068100     MOVE 'BM03'                 TO MBCA-PROGRAM-LOCATION.
068200     PERFORM MB60PD-SEND-MAP-DATA-ONLY
068300                                 THRU MB60PD-SMDO-EXIT.
068400*
068500************************
068600*    RETURN TO CICS    *
068700************************
068800*
068900     MOVE 'PC04'                 TO MBCA-PROGRAM-LOCATION.
069000     PERFORM MB70PD-RETURN-TRANS-ID
069100                                 THRU MB70PD-RTI-EXIT.
069200/
069300 E000-UPDATE-FILE SECTION.
069400*
069500     IF  MBCA-MBUI-UI-YES
069600         SET MBCA-MBUI-ERROR-NO  TO TRUE.
069700*
069800     IF  MBCA-MBUI-UI-YES
069900     AND MBCA-MBUI-UI-UPDATE-NO
070000         GO TO F000-SETUP-COMMAREA.
070100*
070200**********************************************
070300*    READ THE STORE MASTER RECORD FOR UPDATE *
070400**********************************************
070500*
070600     MOVE MBCA-MERCHANT-ORG      TO MBIOWS-MMSM-ORG.
070700     MOVE MBCA-STORE             TO MBIOWS-MMSM-STORE.
070800     MOVE 'FC07'                 TO MBCA-PROGRAM-LOCATION.
070900     SET MBIORO-READ-RANDOM-UPDATE
071000                                 TO TRUE.
071100     PERFORM MMSMAO-ACCESS       THRU MMSMAO-ACCESS-EXIT.
071200*
071300*************************************
071400*    OBTAIN STORAGE FOR LOG FILE    *
071500*    RECORD IF DOING MAINTENANCE    *
071600*************************************
071700*
071800     IF  MBCA-PTI-FUNCTION-IS-ADD
071900         GO TO E020-UPDATE-FIELDS.
072000*
072100     MOVE 'SC04'                 TO MBCA-PROGRAM-LOCATION.
072200     SET MBIORO-GETMAIN          TO TRUE.
072300     PERFORM MML1AO-ACCESS       THRU MML1AO-ACCESS-EXIT.
072400*
072500*************************************************
072600*    SET UP THE COMMON PORTION OF THE RECORD    *
072700*************************************************
072800*
072900     MOVE 'SM'                   TO MML1-FILE-CODE.
073000     MOVE MBCA-MERCHANT-ORG      TO MML1-MMSM-ORG.
073100     MOVE MBCA-STORE             TO MML1-MMSM-STORE.
073200     MOVE MBCA-SIGNON-NAME       TO MML1-SIGNON-NAME.
073300     MOVE MBCA-TERMINAL-ID       TO MML1-TERMINAL-ID.
073400     MOVE ZEROS                  TO MML1-SOURCE-CODE.
073500     MOVE MBCA-FIELD-SECURITY    TO MML1-FIELD-SECURITY.
073600*
073700 E020-UPDATE-FIELDS.
073800*
073900*
074000     PERFORM X010-UPDATE-DBA-NAME
074100                                 THRU X019-EXIT.
074200*
074300     PERFORM X030-UPDATE-CIRRUS-IND
074400                                 THRU X039-EXIT.
074500*
074600     PERFORM X050-UPDATE-INTCHG-IND
074700                                 THRU X059-EXIT.
074800*
074900     PERFORM X070-UPDATE-BUS-CLASS-CODE
075000                                 THRU X079-EXIT.
075100*
075200     PERFORM X130-UPDATE-CATEGORY-CODE
075300                                 THRU X139-EXIT.
075400*
075500     PERFORM X150-UPDATE-FLOOR-LIMIT
075600                                 THRU X159-EXIT.
075700*
075800     PERFORM X170-UPDATE-MC-CH-TERM-IND
075900                                 THRU X179-EXIT.
076000*
076010*                                                                 RG800913
076020     PERFORM X180-UPDATE-ASSIGNED-ID                              RG800913
076030                                 THRU X189-EXIT.                  RG800913
076100     IF  MBCA-MBMS-EUROPAY-ON
076200         PERFORM X190-UPDATE-MC-POS-DC-01
076300                                 THRU X199-EXIT
076400*
076500         PERFORM X210-UPDATE-MC-POS-DC-02
076600                                 THRU X219-EXIT
076700*
076800         PERFORM X230-UPDATE-MC-POS-DC-03
076900                                 THRU X239-EXIT
077000*
077100         PERFORM X250-UPDATE-MC-POS-DC-04
077200                                 THRU X259-EXIT
077300*
077400         PERFORM X270-UPDATE-MC-POS-DC-05
077500                                 THRU X279-EXIT
077600*
077700         PERFORM X290-UPDATE-MC-POS-DC-06
077800                                 THRU X299-EXIT
077900*
078000         PERFORM X310-UPDATE-MC-POS-DC-07
078100                                 THRU X319-EXIT
078200*
078300         PERFORM X330-UPDATE-MC-POS-DC-08
078400                                 THRU X339-EXIT
078500*
078600         PERFORM X350-UPDATE-MC-POS-DC-09
078700                                 THRU X359-EXIT
078800*
078900         PERFORM X370-UPDATE-MC-POS-DC-10
079000                                 THRU X379-EXIT
079100*
079200         PERFORM X390-UPDATE-MC-POS-DC-11
079300                                 THRU X399-EXIT
079400*
079500         PERFORM X410-UPDATE-MC-POS-DC-12
079600                                 THRU X419-EXIT.
079700*
079800 E040-UPDATE-MMSM.
079900*
080000     IF  MBCA-PTI-FUNCTION-IS-ADD
080100         MOVE MBCA-SCREEN-NBR    TO MMSM-ONLINE-STATUS
080200         MOVE MBCA-START-DATE    TO MMSM-LAST-MAINT-DATE
080300         MOVE MBCA-OPERATOR-ID   TO MMSM-LAST-MAINT-OPER
080400         SET WS-UPDATE-MMSM-SW-YES
080500                                 TO TRUE.
080600*
080700**************************************************************
080800*    WRITE A LOG RECORD TO SHOW THAT THE LAST MAINT DATE     *
080900*    AND OPERATOR HAS BEEN UPDATED IF FIELDS WERE CHANGED    *
081000*    ON THE SCREEN                                           *
081100**************************************************************
081200*
081300     IF  MBCA-PTI-FUNCTION-IS-MAINT
081400     AND WS-UPDATE-MMSM-SW-YES
081500         MOVE 0198               TO MML1-FIELD-CODE
081600         MOVE ZEROES             TO MML1-FIELD-OCCURRENCE
081700                                    MML1-FIELD-OCCURRENCE-2
081800         MOVE MML1WS-VL-03       TO MML1-VARIABLE-LENGTH
081900         MOVE MMSM-LAST-MAINT-OPER
082000                                 TO MML1-VL03-B-DATA-X
082100         MOVE MBCA-OPERATOR-ID   TO MMSM-LAST-MAINT-OPER
082200         MOVE MMSM-LAST-MAINT-OPER
082300                                 TO MML1-VL03-A-DATA-X
082400         MOVE 'FC08'             TO MBCA-PROGRAM-LOCATION
082500         PERFORM Y920-WRITE-LOG-RECORD
082600                                 THRU Y929-WLR-EXIT
082700         MOVE 0199               TO MML1-FIELD-CODE
082800         MOVE MML1WS-VL-07       TO MML1-VARIABLE-LENGTH
082900         MOVE MMSM-LAST-MAINT-DATE
083000                                 TO MML1-VL07-B-DATA-9
083100         MOVE MBCA-START-DATE    TO MMSM-LAST-MAINT-DATE
083200         MOVE MMSM-LAST-MAINT-DATE
083300                                 TO MML1-VL07-A-DATA-9
083400         MOVE 'FC09'             TO MBCA-PROGRAM-LOCATION
083500         PERFORM Y920-WRITE-LOG-RECORD
083600                                 THRU Y929-WLR-EXIT.
083700*
083800****************************************************
083900*    REWRITE THE MERCHANT MASTER RECORD IF         *
084000*    FIELDS HAVE BEEN CHANGED ON THE SCREEN, OR    *
084100*    UNLOCK IT IF THEY HAVE NOT                    *
084200****************************************************
084300*
084400     IF  WS-UPDATE-MMSM-SW-YES
084500         MOVE 'FC10'             TO MBCA-PROGRAM-LOCATION
084600         SET MBIORO-REWRITE      TO TRUE
084700         PERFORM MMSMAO-ACCESS   THRU MMSMAO-ACCESS-EXIT
084800     ELSE
084900         MOVE 'FC11'             TO MBCA-PROGRAM-LOCATION
085000         SET MBIORO-UNLOCK       TO TRUE
085100         PERFORM MMSMAO-ACCESS   THRU MMSMAO-ACCESS-EXIT.
085200*
085300/
085400 F000-SETUP-COMMAREA SECTION.
085500*
085600***************************************************************
085700*  SET UP COMMAREA FIELDS AND TRANSFER TO THE NEXT PROGRAM    *
085800***************************************************************
085900*
086000     MOVE MBCA-EIBAID            TO SS08WS-EIBAID.
086100*
086200     PERFORM MB60PD-EDIT-PAGE-NBR
086300                                 THRU MB60PD-EPN-EXIT.
086400*
086500     IF  SS08WS-VALID-PF-KEY
086600     OR  SS08WS-EIBAID-VALID-PF-KEY
086700         SET MBCA-INITIAL-SCREEN-NBR
086800                                 TO TRUE.
086900*
087000     IF  MBCA-MBUI-UI-YES
087100         MOVE 'MBUI'             TO MBCA-TRANS-ID
087200                                    MBCA-PREV-TRANS-ID
087300         MOVE 01                 TO MBCA-SCREEN-NBR
087400         MOVE MBMS08I            TO MBUITS-VAR-DATA
087500         MOVE LENGTH OF MBMS08I  TO MBUITS-VAR-LENGTH
087600         MOVE 'TS10'             TO MBCA-PROGRAM-LOCATION
087700         EXEC CICS WRITEQ TS
087800                   QUEUE   (TS-QUEUE-NAME)
087900                   FROM    (MBUITS-RECORD)
088000                   LENGTH  (LENGTH  OF MBUITS-RECORD)
088100
088200              END-EXEC.
088300*
088400     MOVE 'PC05'                 TO MBCA-PROGRAM-LOCATION.
088500     PERFORM MB70PD-XCTL-TO-MBOXCTL
088600                                 THRU MB70PD-XTM-EXIT.
088700/
088800 W000-FIELD-EDITS SECTION.
088900*
089000 W010-EDIT-DBA-NAME.
089100*
089200     MOVE DFHBMDAS               TO MS08-MC-DBA-NAME-LP-A
089300                                    MS08-MC-DBA-NAME-RP-A.
089400     MOVE DFHBMASK               TO MS08-MC-DBA-NAME-A.
089500*
089600     PERFORM Y015-DBA-NAME-SECURITY
089700                                 THRU Y019-EXIT.
089800*
089900     IF  MS08-MC-DBA-NAME-L IS GREATER THAN ZERO
090000         MOVE DFHBMASF           TO MS08-MC-DBA-NAME-A
090100         EVALUATE TRUE
090200           WHEN MS08-MC-DBA-NAME IS EQUAL TO SPACES
090300             CONTINUE
090400           WHEN MS08-MC-DBA-NAME (1:1)
090500                                 IS EQUAL TO SPACE
090600             GO TO W018-DBA-NAME-ERROR
090700           WHEN OTHER
090800             CONTINUE
090900         END-EVALUATE
091000     ELSE
091100         MOVE MMSM-MC-DBA-NAME   TO MS08-MC-DBA-NAME.
091200*
091300     IF  MS08-MC-DBA-NAME IS EQUAL TO SPACES
091400         MOVE MMSM-DBA-NAME      TO MS08-MC-DBA-NAME
091500         MOVE +25                TO MS08-MC-DBA-NAME-L.
091600*
091700     IF  MBCA-PTI-FUNCTION-IS-MAINT
091800     OR  MS08-MC-DBA-NAME-L IS GREATER THAN ZERO
091900     OR  NOT MMFS-ST-REQUIRED (X-MMFS-STORE)
092000         GO TO W019-EXIT.
092100*
092200 W018-DBA-NAME-ERROR.
092300*
092400     IF  MS08-MC-DBA-NAME-L IS GREATER THAN ZERO
092500         MOVE DFHBMUBF           TO MS08-MC-DBA-NAME-A
092600     ELSE
092700         MOVE DFHBMBRY           TO MS08-MC-DBA-NAME-A.
092800*
092900     SET SS08WS-ERROR-SW-YES     TO TRUE.
093000     MOVE DFHBMASB               TO MS08-MC-DBA-NAME-LP-A
093100                                    MS08-MC-DBA-NAME-RP-A.
093200     MOVE SS08WS-CURSOR          TO MS08-MC-DBA-NAME-L.
093300*
093400 W019-EXIT.
093500     EXIT.
093600*
093700 W030-EDIT-CIRRUS-IND.
093800*
093900     MOVE DFHBMDAS               TO MS08-MC-CIRRUS-IND-LP-A
094000                                    MS08-MC-CIRRUS-IND-RP-A.
094100     MOVE DFHBMASK               TO MS08-MC-CIRRUS-IND-A.
094200*
094300     PERFORM Y035-CIRRUS-IND-SECURITY
094400                                 THRU Y039-EXIT.
094500*
094600     IF  MS08-MC-CIRRUS-IND-L IS GREATER THAN ZERO
094700         MOVE DFHBMASF           TO MS08-MC-CIRRUS-IND-A
094800     ELSE
094900         MOVE MMSM-MC-CIRRUS-IND TO MS08-MC-CIRRUS-IND.
095000*
095100     IF NOT MS08-MC-VALID-CIRRUS-IND
095200        GO TO W038-CIRRUS-IND-ERROR.
095300*
095400     IF  MBCA-PTI-FUNCTION-IS-MAINT
095500     OR  MS08-MC-CIRRUS-IND-L IS GREATER THAN ZERO
095600     OR  NOT MMFS-ST-REQUIRED (X-MMFS-STORE)
095700         GO TO W039-EXIT.
095800*
095900 W038-CIRRUS-IND-ERROR.
096000*
096100     IF  MS08-MC-CIRRUS-IND-L IS GREATER THAN ZERO
096200         MOVE DFHBMUBF           TO MS08-MC-CIRRUS-IND-A
096300     ELSE
096400         MOVE DFHBMBRY           TO MS08-MC-CIRRUS-IND-A.
096500*
096600     SET SS08WS-ERROR-SW-YES     TO TRUE.
096700     MOVE DFHBMASB               TO MS08-MC-CIRRUS-IND-LP-A
096800                                    MS08-MC-CIRRUS-IND-RP-A.
096900     MOVE SS08WS-CURSOR          TO MS08-MC-CIRRUS-IND-L.
097000*
097100 W039-EXIT.
097200     EXIT.
097300*
097400 W050-EDIT-INTCHG-IND.
097500*
097600     MOVE DFHBMDAS               TO MS08-MC-INTCHG-FLAG-LP-A
097700                                    MS08-MC-INTCHG-FLAG-RP-A.
097800     MOVE DFHBMASK               TO MS08-MC-INTCHG-FLAG-A.
097900*
098000     PERFORM Y055-INTCHG-FLAG-SECURITY
098100                                 THRU Y059-EXIT.
098200*
098300     IF  MS08-MC-INTCHG-FLAG-L IS GREATER THAN ZERO
098400         MOVE DFHBMASF           TO MS08-MC-INTCHG-FLAG-A
098500     ELSE
098600         MOVE MMSM-MC-INTCHG-FLAG
098700                                 TO MS08-MC-INTCHG-FLAG.
098800*
098900     IF  NOT MS08-MC-INTCHG-FLAG-VALID
099000         GO TO W058-INTCHG-FLAG-ERROR.
099100*
099200     IF  MBCA-PTI-FUNCTION-IS-MAINT
099300     OR  MS08-MC-INTCHG-FLAG-L IS GREATER THAN ZERO
099400     OR  NOT MMFS-ST-REQUIRED (X-MMFS-STORE)
099500         GO TO W059-EXIT.
099600*
099700 W058-INTCHG-FLAG-ERROR.
099800*
099900     IF  MS08-MC-INTCHG-FLAG-L IS GREATER THAN ZERO
100000         MOVE DFHBMUBF           TO MS08-MC-INTCHG-FLAG-A
100100     ELSE
100200         MOVE DFHBMBRY           TO MS08-MC-INTCHG-FLAG-A.
100300*
100400     SET SS08WS-ERROR-SW-YES     TO TRUE.
100500     MOVE DFHBMASB               TO MS08-MC-INTCHG-FLAG-LP-A
100600                                    MS08-MC-INTCHG-FLAG-RP-A.
100700     MOVE SS08WS-CURSOR          TO MS08-MC-INTCHG-FLAG-L.
100800*
100900 W059-EXIT.
101000     EXIT.
101100*
101200 W070-EDIT-BUS-CLASS-CODE.
101300*
101400     MOVE DFHBMDAS               TO MS08-MC-BUS-CLASS-CODE-LP-A
101500                                    MS08-MC-BUS-CLASS-CODE-RP-A.
101600     MOVE DFHBMASK               TO MS08-MC-BUS-CLASS-CODE-A.
101700*
101800     IF  MBCA-MBMS-EUROPAY-ON
101900         MOVE DFHBMDAS           TO MS08-MC-BUS-CLASS-CODE-A
102000                                    MS08-MC-BUS-CLASS-CODE-LIT-A
102100         GO TO W079-EXIT.
102200*
102300     PERFORM Y075-BUS-CLASS-CODE-SECURITY
102400                                 THRU Y079-EXIT.
102500*
102600     IF  MS08-MC-BUS-CLASS-CODE-L IS GREATER THAN ZERO
102700         MOVE DFHBMASF           TO MS08-MC-BUS-CLASS-CODE-A
102800     ELSE
102900         MOVE MMSM-MC-BUSINESS-CLASS
103000                                 TO MS08-MC-BUS-CLASS-CODE.
104000*
104100*
104200*
104300     IF  MBCA-PTI-FUNCTION-IS-MAINT
104400     OR  MS08-MC-BUS-CLASS-CODE-L IS GREATER THAN ZERO
104500     OR  NOT MMFS-ST-REQUIRED (X-MMFS-STORE)
104600         GO TO W079-EXIT.
104700*
104800 W078-BUS-CLASS-CODE-ERROR.
104900*
105000     IF  MS08-MC-BUS-CLASS-CODE-L IS GREATER THAN ZERO
105100         MOVE DFHBMUBF           TO MS08-MC-BUS-CLASS-CODE-A
105200     ELSE
105300         MOVE DFHBMUNB           TO MS08-MC-BUS-CLASS-CODE-A.
105400*
105500     SET SS08WS-ERROR-SW-YES     TO TRUE.
105600     MOVE DFHBMASB               TO MS08-MC-BUS-CLASS-CODE-LP-A
105700                                    MS08-MC-BUS-CLASS-CODE-RP-A.
105800     MOVE SS08WS-CURSOR          TO MS08-MC-BUS-CLASS-CODE-L.
105900*
106000 W079-EXIT.
106100     EXIT.
106200*
106300 W130-EDIT-CATEGORY.
106400*
106500     MOVE DFHBMDAS               TO MS08-MC-CATEGORY-CODE-LP-A
106600                                    MS08-MC-CATEGORY-CODE-RP-A.
106700     MOVE DFHBMASK               TO MS08-MC-CATEGORY-CODE-A.
106800*
106900     PERFORM Y135-CATEGORY-CODE-SECURITY
107000                                 THRU Y139-EXIT.
107100*
107200     IF  MS08-MC-CATEGORY-CODE-L IS GREATER THAN ZERO
107300         MOVE DFHBMASF           TO MS08-MC-CATEGORY-CODE-A
107400     ELSE
107500         MOVE MMSM-MC-CATEGORY-CODE
107600                                 TO MS08-MC-CATEGORY-CODE.
107700*
107800     IF  MS08-MC-CATEGORY-CODE IS NOT NUMERIC
107900         GO TO W138-MC-CATEGORY-ERROR.
108000*
108100     IF  MBCA-PTI-FUNCTION-IS-MAINT
108200     OR  MS08-MC-CATEGORY-CODE-L IS GREATER THAN ZERO
108300     OR  NOT MMFS-ST-REQUIRED (X-MMFS-STORE)
108400         GO TO W139-EXIT.
108500*
108600 W138-MC-CATEGORY-ERROR.
108700*
108800     IF  MS08-MC-CATEGORY-CODE-L IS GREATER THAN ZERO
108900         MOVE DFHBMNBF           TO MS08-MC-CATEGORY-CODE-A
109000     ELSE
109100         MOVE DFHBMUNB           TO MS08-MC-CATEGORY-CODE-A.
109200*
109300     SET SS08WS-ERROR-SW-YES     TO TRUE.
109400     MOVE DFHBMASB               TO MS08-MC-CATEGORY-CODE-LP-A
109500                                    MS08-MC-CATEGORY-CODE-RP-A.
109600     MOVE SS08WS-CURSOR          TO MS08-MC-CATEGORY-CODE-L.
109700*
109800 W139-EXIT.
109900     EXIT.
110000*
110100 W150-EDIT-FLOOR-LIMIT.
110200*
110300     MOVE DFHBMDAS               TO MS08-MC-FLOOR-LIMIT-LP-A
110400                                    MS08-MC-FLOOR-LIMIT-RP-A.
110500     MOVE DFHBMASK               TO MS08-MC-FLOOR-LIMIT-A.
110600*
110700     PERFORM Y155-FLOOR-LIMIT-SECURITY
110800                                 THRU Y159-EXIT.
110900*
111000     IF  MS08-MC-FLOOR-LIMIT-L IS GREATER THAN ZERO
111100         MOVE DFHBMASF           TO MS08-MC-FLOOR-LIMIT-A
111200     ELSE
111300         MOVE MMSM-MC-FLOOR-LIMIT
111400                                 TO MS08-MC-FLOOR-LIMIT.
111500*
111600     IF  MS08-MC-FLOOR-LIMIT IS NOT NUMERIC
111700         GO TO W158-MC-FLOOR-LIMIT-ERROR.
111800*
111900     IF  MBCA-PTI-FUNCTION-IS-MAINT
112000     OR  MS08-MC-FLOOR-LIMIT-L IS GREATER THAN ZERO
112100     OR  NOT MMFS-ST-REQUIRED (X-MMFS-STORE)
112200         GO TO W159-EXIT.
112300*
112400 W158-MC-FLOOR-LIMIT-ERROR.
112500*
112600     IF  MS08-MC-FLOOR-LIMIT-L IS GREATER THAN ZERO
112700         MOVE DFHBMNBF           TO MS08-MC-FLOOR-LIMIT-A
112800     ELSE
112900         MOVE DFHBMUNB           TO MS08-MC-FLOOR-LIMIT-A.
113000*
113100     SET SS08WS-ERROR-SW-YES     TO TRUE.
113200     MOVE DFHBMASB               TO MS08-MC-FLOOR-LIMIT-LP-A
113300                                    MS08-MC-FLOOR-LIMIT-RP-A.
113400     MOVE SS08WS-CURSOR          TO MS08-MC-FLOOR-LIMIT-L.
113500*
113600 W159-EXIT.
113700     EXIT.
113800*
113900 W170-EDIT-MC-CH-TERM-IND.
114000*
114100     MOVE DFHBMDAS               TO MS08-MC-CH-TERM-IND-LP-A
114200                                    MS08-MC-CH-TERM-IND-RP-A.
114300     MOVE DFHBMASK               TO MS08-MC-CH-TERM-IND-A.
114400*
114500     IF  MBCA-MBMS-EUROPAY-ON
114600         MOVE DFHBMDAS           TO MS08-MC-CH-TERM-IND-A
114700                                    MS08-MC-CH-TERM-IND-LIT-A
114800         GO TO W179-EXIT.
114900*
115000     PERFORM Y175-MC-CH-TERM-IND-SECURITY
115100                                 THRU Y179-EXIT.
115200*
115300     IF  MS08-MC-CH-TERM-IND-L IS GREATER THAN ZERO
115400         MOVE DFHBMASF           TO MS08-MC-CH-TERM-IND-A
115500     ELSE
115600         MOVE MMSM-MC-CH-TERM-IND
115700                                 TO MS08-MC-CH-TERM-IND.
115800*
115900     IF  NOT MS08-VALID-MC-CH-TERM-IND
116000         GO TO W178-MC-CH-TERM-IND-ERROR.
116100*
116200     IF  MBCA-PTI-FUNCTION-IS-MAINT
116300     OR  MS08-MC-CH-TERM-IND-L IS GREATER THAN ZERO
116400     OR  NOT MMFS-ST-REQUIRED (X-MMFS-STORE)
116500         GO TO W179-EXIT.
116600*
116700 W178-MC-CH-TERM-IND-ERROR.
116800*
116900     IF  MS08-MC-CH-TERM-IND-L IS GREATER THAN ZERO
117000         MOVE DFHBMUBF           TO MS08-MC-CH-TERM-IND-A
117100     ELSE
117200         MOVE DFHBMBRY           TO MS08-MC-CH-TERM-IND-A.
117300*
117400     SET SS08WS-ERROR-SW-YES     TO TRUE.
117500     MOVE DFHBMASB               TO MS08-MC-CH-TERM-IND-LP-A
117600                                    MS08-MC-CH-TERM-IND-RP-A.
117700     MOVE SS08WS-CURSOR          TO MS08-MC-CH-TERM-IND-L.
117800*
117900 W179-EXIT.
118000     EXIT.
118002*                                                                 RG800913
118004 W180-EDIT-ASSIGNED-ID.                                           RG800913
118006*                                                                 RG800913
118008     MOVE DFHBMDAS               TO MS08-MC-ASSIGNED-ID-LP-A      RG800913
118010                                    MS08-MC-ASSIGNED-ID-RP-A.     RG800913
118012     MOVE DFHBMASK               TO MS08-MC-ASSIGNED-ID-A.        RG800913
118014*                                                                 RG800913
118016     PERFORM Y185-ASSIGNED-ID                                     RG800913
118018                                 THRU Y189-EXIT.                  RG800913
118020*                                                                 RG800913
118022     IF  MS08-MC-ASSIGNED-ID-L IS GREATER THAN ZERO               RG800913
118024         MOVE DFHBMASF           TO MS08-MC-ASSIGNED-ID-A         RG800913
118026     ELSE                                                         RG800913
118028         MOVE MMSM-MC-ASSIGNED-ID                                 RG800913
118030                                 TO MS08-MC-ASSIGNED-ID.          RG800913
118032*                                                                 RG800913
118034     IF  MBCA-PTI-FUNCTION-IS-MAINT                               RG800913
118036     OR  MS08-MC-ASSIGNED-ID-L IS GREATER THAN ZERO               RG800913
118038     OR  NOT MMFS-ST-REQUIRED (X-MMFS-STORE)                      RG800913
118040         GO TO W189-EXIT.                                         RG800913
118042*                                                                 RG800913
118044 W188-ASSIGNED-ID-ERROR.                                          RG800913
118046*                                                                 RG800913
118048     IF  MS08-MC-ASSIGNED-ID-L IS GREATER THAN ZERO               RG800913
118050         MOVE DFHBMUBF           TO MS08-MC-ASSIGNED-ID-A         RG800913
118052     ELSE                                                         RG800913
118054         MOVE DFHBMBRY           TO MS08-MC-ASSIGNED-ID-A.        RG800913
118056*                                                                 RG800913
118058     SET SS08WS-ERROR-SW-YES     TO TRUE.                         RG800913
118060     MOVE DFHBMASB               TO MS08-MC-ASSIGNED-ID-LP-A      RG800913
118062                                    MS08-MC-ASSIGNED-ID-RP-A.     RG800913
118064     MOVE SS08WS-CURSOR          TO MS08-MC-ASSIGNED-ID-L.        RG800913
118066*                                                                 RG800913
118068 W189-EXIT.                                                       RG800913
118070     EXIT.                                                        RG800913
118100*
118200 W190-EDIT-MC-POS-DC-01.
118300*
118400     MOVE DFHBMDAS               TO MS08-MC-POS-DC-01-LP-A
118500                                    MS08-MC-POS-DC-01-RP-A.
118600     MOVE DFHBMASK               TO MS08-MC-POS-DC-01-A.
118700*
118800     PERFORM Y195-POS-DC-01-SECURITY
118900                                 THRU Y199-EXIT.
119000*
119100     IF  MS08-MC-POS-DC-01-L IS GREATER THAN ZERO
119200         MOVE DFHBMASF           TO MS08-MC-POS-DC-01-A
119300     ELSE
119400         MOVE MMSM-MC-POS-DC-01  TO MS08-MC-POS-DC-01.
119500*
119600     IF NOT MS08-MC-POS-DC-01-VALID
119700        GO TO W198-POS-DC-01-ERROR.
119800*
119900     IF  MBCA-PTI-FUNCTION-IS-MAINT
120000     OR  MS08-MC-POS-DC-01-L IS GREATER THAN ZERO
120100     OR  NOT MMFS-ST-REQUIRED (X-MMFS-STORE)
120200         GO TO W199-EXIT.
120300*
120400 W198-POS-DC-01-ERROR.
120500*
120600     IF  MS08-MC-POS-DC-01-L IS GREATER THAN ZERO
120700         MOVE DFHBMUBF           TO MS08-MC-POS-DC-01-A
120800     ELSE
120900         MOVE DFHBMBRY           TO MS08-MC-POS-DC-01-A.
121000*
121100     SET SS08WS-ERROR-SW-YES     TO TRUE.
121200     MOVE DFHBMASB               TO MS08-MC-POS-DC-01-LP-A
121300                                    MS08-MC-POS-DC-01-RP-A.
121400     MOVE SS08WS-CURSOR          TO MS08-MC-POS-DC-01-L.
121500*
121600 W199-EXIT.
121700     EXIT.
121800*
121900 W210-EDIT-MC-POS-DC-02.
122000*
122100     MOVE DFHBMDAS               TO MS08-MC-POS-DC-02-LP-A
122200                                    MS08-MC-POS-DC-02-RP-A.
122300     MOVE DFHBMASK               TO MS08-MC-POS-DC-02-A.
122400*
122500     PERFORM Y215-POS-DC-02-SECURITY
122600                                 THRU Y219-EXIT.
122700*
122800     IF  MS08-MC-POS-DC-02-L IS GREATER THAN ZERO
122900         MOVE DFHBMASF           TO MS08-MC-POS-DC-02-A
123000     ELSE
123100         MOVE MMSM-MC-POS-DC-02  TO MS08-MC-POS-DC-02.
123200*
123300     IF NOT MS08-MC-POS-DC-02-VALID
123400        GO TO W218-POS-DC-02-ERROR.
123500*
123600     IF  MBCA-PTI-FUNCTION-IS-MAINT
123700     OR  MS08-MC-POS-DC-02-L IS GREATER THAN ZERO
123800     OR  NOT MMFS-ST-REQUIRED (X-MMFS-STORE)
123900         GO TO W219-EXIT.
124000*
124100 W218-POS-DC-02-ERROR.
124200*
124300     IF  MS08-MC-POS-DC-02-L IS GREATER THAN ZERO
124400         MOVE DFHBMUBF           TO MS08-MC-POS-DC-02-A
124500     ELSE
124600         MOVE DFHBMBRY           TO MS08-MC-POS-DC-02-A.
124700*
124800     SET SS08WS-ERROR-SW-YES     TO TRUE.
124900     MOVE DFHBMASB               TO MS08-MC-POS-DC-02-LP-A
125000                                    MS08-MC-POS-DC-02-RP-A.
125100     MOVE SS08WS-CURSOR          TO MS08-MC-POS-DC-02-L.
125200*
125300 W219-EXIT.
125400     EXIT.
125500*
125600 W230-EDIT-MC-POS-DC-03.
125700*
125800     MOVE DFHBMDAS               TO MS08-MC-POS-DC-03-LP-A
125900                                    MS08-MC-POS-DC-03-RP-A.
126000     MOVE DFHBMASK               TO MS08-MC-POS-DC-03-A.
126100*
126200     PERFORM Y235-POS-DC-03-SECURITY
126300                                 THRU Y239-EXIT.
126400*
126500     IF  MS08-MC-POS-DC-03-L IS GREATER THAN ZERO
126600         MOVE DFHBMASF           TO MS08-MC-POS-DC-03-A
126700     ELSE
126800         MOVE MMSM-MC-POS-DC-03  TO MS08-MC-POS-DC-03.
126900*
127000     IF NOT MS08-MC-POS-DC-03-VALID
127100        GO TO W238-POS-DC-03-ERROR.
127200*
127300     IF  MBCA-PTI-FUNCTION-IS-MAINT
127400     OR  MS08-MC-POS-DC-03-L IS GREATER THAN ZERO
127500     OR  NOT MMFS-ST-REQUIRED (X-MMFS-STORE)
127600         GO TO W239-EXIT.
127700*
127800 W238-POS-DC-03-ERROR.
127900*
128000     IF  MS08-MC-POS-DC-03-L IS GREATER THAN ZERO
128100         MOVE DFHBMUBF           TO MS08-MC-POS-DC-03-A
128200     ELSE
128300         MOVE DFHBMBRY           TO MS08-MC-POS-DC-03-A.
128400*
128500     SET SS08WS-ERROR-SW-YES     TO TRUE.
128600     MOVE DFHBMASB               TO MS08-MC-POS-DC-03-LP-A
128700                                    MS08-MC-POS-DC-03-RP-A.
128800     MOVE SS08WS-CURSOR          TO MS08-MC-POS-DC-03-L.
128900*
129000 W239-EXIT.
129100     EXIT.
129200*
129300 W250-EDIT-MC-POS-DC-04.
129400*
129500     MOVE DFHBMDAS               TO MS08-MC-POS-DC-04-LP-A
129600                                    MS08-MC-POS-DC-04-RP-A.
129700     MOVE DFHBMASK               TO MS08-MC-POS-DC-04-A.
129800*
129900     PERFORM Y255-POS-DC-04-SECURITY
130000                                 THRU Y259-EXIT.
130100*
130200     IF  MS08-MC-POS-DC-04-L IS GREATER THAN ZERO
130300         MOVE DFHBMASF           TO MS08-MC-POS-DC-04-A
130400     ELSE
130500         MOVE MMSM-MC-POS-DC-04  TO MS08-MC-POS-DC-04.
130600*
130700     IF NOT MS08-MC-POS-DC-04-VALID
130800        GO TO W258-POS-DC-04-ERROR.
130900*
131000     IF  MBCA-PTI-FUNCTION-IS-MAINT
131100     OR  MS08-MC-POS-DC-04-L IS GREATER THAN ZERO
131200     OR  NOT MMFS-ST-REQUIRED (X-MMFS-STORE)
131300         GO TO W259-EXIT.
131400*
131500 W258-POS-DC-04-ERROR.
131600*
131700     IF  MS08-MC-POS-DC-04-L IS GREATER THAN ZERO
131800         MOVE DFHBMUBF           TO MS08-MC-POS-DC-04-A
131900     ELSE
132000         MOVE DFHBMBRY           TO MS08-MC-POS-DC-04-A.
132100*
132200     SET SS08WS-ERROR-SW-YES     TO TRUE.
132300     MOVE DFHBMASB               TO MS08-MC-POS-DC-04-LP-A
132400                                    MS08-MC-POS-DC-04-RP-A.
132500     MOVE SS08WS-CURSOR          TO MS08-MC-POS-DC-04-L.
132600*
132700 W259-EXIT.
132800     EXIT.
132900*
133000 W270-EDIT-MC-POS-DC-05.
133100*
133200     MOVE DFHBMDAS               TO MS08-MC-POS-DC-05-LP-A
133300                                    MS08-MC-POS-DC-05-RP-A.
133400     MOVE DFHBMASK               TO MS08-MC-POS-DC-05-A.
133500*
133600     PERFORM Y275-POS-DC-05-SECURITY
133700                                 THRU Y279-EXIT.
133800*
133900     IF  MS08-MC-POS-DC-05-L IS GREATER THAN ZERO
134000         MOVE DFHBMASF           TO MS08-MC-POS-DC-05-A
134100     ELSE
134200         MOVE MMSM-MC-POS-DC-05  TO MS08-MC-POS-DC-05.
134300*
134400     IF NOT MS08-MC-POS-DC-05-VALID
134500        GO TO W278-POS-DC-05-ERROR.
134600*
134700     IF  MBCA-PTI-FUNCTION-IS-MAINT
134800     OR  MS08-MC-POS-DC-05-L IS GREATER THAN ZERO
134900     OR  NOT MMFS-ST-REQUIRED (X-MMFS-STORE)
135000         GO TO W279-EXIT.
135100*
135200 W278-POS-DC-05-ERROR.
135300*
135400     IF  MS08-MC-POS-DC-05-L IS GREATER THAN ZERO
135500         MOVE DFHBMUBF           TO MS08-MC-POS-DC-05-A
135600     ELSE
135700         MOVE DFHBMBRY           TO MS08-MC-POS-DC-05-A.
135800*
135900     SET SS08WS-ERROR-SW-YES     TO TRUE.
136000     MOVE DFHBMASB               TO MS08-MC-POS-DC-05-LP-A
136100                                    MS08-MC-POS-DC-05-RP-A.
136200     MOVE SS08WS-CURSOR          TO MS08-MC-POS-DC-05-L.
136300*
136400 W279-EXIT.
136500     EXIT.
136600*
136700 W290-EDIT-MC-POS-DC-06.
136800*
136900     MOVE DFHBMDAS               TO MS08-MC-POS-DC-06-LP-A
137000                                    MS08-MC-POS-DC-06-RP-A.
137100     MOVE DFHBMASK               TO MS08-MC-POS-DC-06-A.
137200*
137300     PERFORM Y295-POS-DC-06-SECURITY
137400                                 THRU Y299-EXIT.
137500*
137600     IF  MS08-MC-POS-DC-06-L IS GREATER THAN ZERO
137700         MOVE DFHBMASF           TO MS08-MC-POS-DC-06-A
137800     ELSE
137900         MOVE MMSM-MC-POS-DC-06  TO MS08-MC-POS-DC-06.
138000*
138100     IF NOT MS08-MC-POS-DC-06-VALID
138200        GO TO W298-POS-DC-06-ERROR.
138300*
138400     IF  MBCA-PTI-FUNCTION-IS-MAINT
138500     OR  MS08-MC-POS-DC-06-L IS GREATER THAN ZERO
138600     OR  NOT MMFS-ST-REQUIRED (X-MMFS-STORE)
138700         GO TO W299-EXIT.
138800*
138900 W298-POS-DC-06-ERROR.
139000*
139100     IF  MS08-MC-POS-DC-06-L IS GREATER THAN ZERO
139200         MOVE DFHBMUBF           TO MS08-MC-POS-DC-06-A
139300     ELSE
139400         MOVE DFHBMBRY           TO MS08-MC-POS-DC-06-A.
139500*
139600     SET SS08WS-ERROR-SW-YES     TO TRUE.
139700     MOVE DFHBMASB               TO MS08-MC-POS-DC-06-LP-A
139800                                    MS08-MC-POS-DC-06-RP-A.
139900     MOVE SS08WS-CURSOR          TO MS08-MC-POS-DC-06-L.
140000*
140100 W299-EXIT.
140200     EXIT.
140300*
140400 W310-EDIT-MC-POS-DC-07.
140500*
140600     MOVE DFHBMDAS               TO MS08-MC-POS-DC-07-LP-A
140700                                    MS08-MC-POS-DC-07-RP-A.
140800     MOVE DFHBMASK               TO MS08-MC-POS-DC-07-A.
140900*
141000     PERFORM Y315-POS-DC-07-SECURITY
141100                                 THRU Y319-EXIT.
141200*
141300     IF  MS08-MC-POS-DC-07-L IS GREATER THAN ZERO
141400         MOVE DFHBMASF           TO MS08-MC-POS-DC-07-A
141500     ELSE
141600         MOVE MMSM-MC-POS-DC-07  TO MS08-MC-POS-DC-07.
141700*
141800     IF NOT MS08-MC-POS-DC-07-VALID
141900        GO TO W318-POS-DC-07-ERROR.
142000*
142100     IF  MBCA-PTI-FUNCTION-IS-MAINT
142200     OR  MS08-MC-POS-DC-07-L IS GREATER THAN ZERO
142300     OR  NOT MMFS-ST-REQUIRED (X-MMFS-STORE)
142400         GO TO W319-EXIT.
142500*
142600 W318-POS-DC-07-ERROR.
142700*
142800     IF  MS08-MC-POS-DC-07-L IS GREATER THAN ZERO
142900         MOVE DFHBMUBF           TO MS08-MC-POS-DC-07-A
143000     ELSE
143100         MOVE DFHBMBRY           TO MS08-MC-POS-DC-07-A.
143200*
143300     SET SS08WS-ERROR-SW-YES     TO TRUE.
143400     MOVE DFHBMASB               TO MS08-MC-POS-DC-07-LP-A
143500                                    MS08-MC-POS-DC-07-RP-A.
143600     MOVE SS08WS-CURSOR          TO MS08-MC-POS-DC-07-L.
143700*
143800 W319-EXIT.
143900     EXIT.
144000*
144100 W330-EDIT-MC-POS-DC-08.
144200*
144300     MOVE DFHBMDAS               TO MS08-MC-POS-DC-08-LP-A
144400                                    MS08-MC-POS-DC-08-RP-A.
144500     MOVE DFHBMASK               TO MS08-MC-POS-DC-08-A.
144600*
144700     PERFORM Y335-POS-DC-08-SECURITY
144800                                 THRU Y339-EXIT.
144900*
145000     IF  MS08-MC-POS-DC-08-L IS GREATER THAN ZERO
145100         MOVE DFHBMASF           TO MS08-MC-POS-DC-08-A
145200     ELSE
145300         MOVE MMSM-MC-POS-DC-08  TO MS08-MC-POS-DC-08.
145400*
145500     IF NOT MS08-MC-POS-DC-08-VALID
145600        GO TO W338-POS-DC-08-ERROR.
145700*
145800     IF  MBCA-PTI-FUNCTION-IS-MAINT
145900     OR  MS08-MC-POS-DC-08-L IS GREATER THAN ZERO
146000     OR  NOT MMFS-ST-REQUIRED (X-MMFS-STORE)
146100         GO TO W339-EXIT.
146200*
146300 W338-POS-DC-08-ERROR.
146400*
146500     IF  MS08-MC-POS-DC-08-L IS GREATER THAN ZERO
146600         MOVE DFHBMUBF           TO MS08-MC-POS-DC-08-A
146700     ELSE
146800         MOVE DFHBMBRY           TO MS08-MC-POS-DC-08-A.
146900*
147000     SET SS08WS-ERROR-SW-YES     TO TRUE.
147100     MOVE DFHBMASB               TO MS08-MC-POS-DC-08-LP-A
147200                                    MS08-MC-POS-DC-08-RP-A.
147300     MOVE SS08WS-CURSOR          TO MS08-MC-POS-DC-08-L.
147400*
147500 W339-EXIT.
147600     EXIT.
147700*
147800 W350-EDIT-MC-POS-DC-09.
147900*
148000     MOVE DFHBMDAS               TO MS08-MC-POS-DC-09-LP-A
148100                                    MS08-MC-POS-DC-09-RP-A.
148200     MOVE DFHBMASK               TO MS08-MC-POS-DC-09-A.
148300*
148400     PERFORM Y355-POS-DC-09-SECURITY
148500                                 THRU Y359-EXIT.
148600*
148700     IF  MS08-MC-POS-DC-09-L IS GREATER THAN ZERO
148800         MOVE DFHBMASF           TO MS08-MC-POS-DC-09-A
148900     ELSE
149000         MOVE MMSM-MC-POS-DC-09  TO MS08-MC-POS-DC-09.
149100*
149200     IF NOT MS08-MC-POS-DC-09-VALID
149300        GO TO W358-POS-DC-09-ERROR.
149400*
149500     IF  MBCA-PTI-FUNCTION-IS-MAINT
149600     OR  MS08-MC-POS-DC-09-L IS GREATER THAN ZERO
149700     OR  NOT MMFS-ST-REQUIRED (X-MMFS-STORE)
149800         GO TO W359-EXIT.
149900*
150000 W358-POS-DC-09-ERROR.
150100*
150200     IF  MS08-MC-POS-DC-09-L IS GREATER THAN ZERO
150300         MOVE DFHBMUBF           TO MS08-MC-POS-DC-09-A
150400     ELSE
150500         MOVE DFHBMBRY           TO MS08-MC-POS-DC-09-A.
150600*
150700     SET SS08WS-ERROR-SW-YES     TO TRUE.
150800     MOVE DFHBMASB               TO MS08-MC-POS-DC-09-LP-A
150900                                    MS08-MC-POS-DC-09-RP-A.
151000     MOVE SS08WS-CURSOR          TO MS08-MC-POS-DC-09-L.
151100*
151200 W359-EXIT.
151300     EXIT.
151400*
151500 W370-EDIT-MC-POS-DC-10.
151600*
151700     MOVE DFHBMDAS               TO MS08-MC-POS-DC-10-LP-A
151800                                    MS08-MC-POS-DC-10-RP-A.
151900     MOVE DFHBMASK               TO MS08-MC-POS-DC-10-A.
152000*
152100     PERFORM Y375-POS-DC-10-SECURITY
152200                                 THRU Y379-EXIT.
152300*
152400     IF  MS08-MC-POS-DC-10-L IS GREATER THAN ZERO
152500         MOVE DFHBMASF           TO MS08-MC-POS-DC-10-A
152600     ELSE
152700         MOVE MMSM-MC-POS-DC-10  TO MS08-MC-POS-DC-10.
152800*
152900     IF NOT MS08-MC-POS-DC-10-VALID
153000        GO TO W378-POS-DC-10-ERROR.
153100*
153200     IF  MBCA-PTI-FUNCTION-IS-MAINT
153300     OR  MS08-MC-POS-DC-10-L IS GREATER THAN ZERO
153400     OR  NOT MMFS-ST-REQUIRED (X-MMFS-STORE)
153500         GO TO W379-EXIT.
153600*
153700 W378-POS-DC-10-ERROR.
153800*
153900     IF  MS08-MC-POS-DC-10-L IS GREATER THAN ZERO
154000         MOVE DFHBMUBF           TO MS08-MC-POS-DC-10-A
154100     ELSE
154200         MOVE DFHBMBRY           TO MS08-MC-POS-DC-10-A.
154300*
154400     SET SS08WS-ERROR-SW-YES     TO TRUE.
154500     MOVE DFHBMASB               TO MS08-MC-POS-DC-10-LP-A
154600                                    MS08-MC-POS-DC-10-RP-A.
154700     MOVE SS08WS-CURSOR          TO MS08-MC-POS-DC-10-L.
154800*
154900 W379-EXIT.
155000     EXIT.
155100*
155200 W390-EDIT-MC-POS-DC-11.
155300*
155400     MOVE DFHBMDAS               TO MS08-MC-POS-DC-11-LP-A
155500                                    MS08-MC-POS-DC-11-RP-A.
155600     MOVE DFHBMASK               TO MS08-MC-POS-DC-11-A.
155700*
155800     PERFORM Y395-POS-DC-11-SECURITY
155900                                 THRU Y399-EXIT.
156000*
156100     IF  MS08-MC-POS-DC-11-L IS GREATER THAN ZERO
156200         MOVE DFHBMASF           TO MS08-MC-POS-DC-11-A
156300     ELSE
156400         MOVE MMSM-MC-POS-DC-11  TO MS08-MC-POS-DC-11.
156500*
156600     IF NOT MS08-MC-POS-DC-11-VALID
156700        GO TO W398-POS-DC-11-ERROR.
156800*
156900     IF  MBCA-PTI-FUNCTION-IS-MAINT
157000     OR  MS08-MC-POS-DC-11-L IS GREATER THAN ZERO
157100     OR  NOT MMFS-ST-REQUIRED (X-MMFS-STORE)
157200         GO TO W399-EXIT.
157300*
157400 W398-POS-DC-11-ERROR.
157500*
157600     IF  MS08-MC-POS-DC-11-L IS GREATER THAN ZERO
157700         MOVE DFHBMUBF           TO MS08-MC-POS-DC-11-A
157800     ELSE
157900         MOVE DFHBMBRY           TO MS08-MC-POS-DC-11-A.
158000*
158100     SET SS08WS-ERROR-SW-YES     TO TRUE.
158200     MOVE DFHBMASB               TO MS08-MC-POS-DC-11-LP-A
158300                                    MS08-MC-POS-DC-11-RP-A.
158400     MOVE SS08WS-CURSOR          TO MS08-MC-POS-DC-11-L.
158500*
158600 W399-EXIT.
158700     EXIT.
158800*
158900 W410-EDIT-MC-POS-DC-12.
159000*
159100     MOVE DFHBMDAS               TO MS08-MC-POS-DC-12-LP-A
159200                                    MS08-MC-POS-DC-12-RP-A.
159300     MOVE DFHBMASK               TO MS08-MC-POS-DC-12-A.
159400*
159500     PERFORM Y415-POS-DC-12-SECURITY
159600                                 THRU Y419-EXIT.
159700*
159800     IF  MS08-MC-POS-DC-12-L IS GREATER THAN ZERO
159900         MOVE DFHBMASF           TO MS08-MC-POS-DC-12-A
160000     ELSE
160100         MOVE MMSM-MC-POS-DC-12  TO MS08-MC-POS-DC-12.
160200*
160300     IF NOT MS08-MC-POS-DC-12-VALID
160400        GO TO W418-POS-DC-12-ERROR.
160500*
160600     IF  MBCA-PTI-FUNCTION-IS-MAINT
160700     OR  MS08-MC-POS-DC-12-L IS GREATER THAN ZERO
160800     OR  NOT MMFS-ST-REQUIRED (X-MMFS-STORE)
160900         GO TO W419-EXIT.
161000*
161100 W418-POS-DC-12-ERROR.
161200*
161300     IF  MS08-MC-POS-DC-12-L IS GREATER THAN ZERO
161400         MOVE DFHBMUBF           TO MS08-MC-POS-DC-12-A
161500     ELSE
161600         MOVE DFHBMBRY           TO MS08-MC-POS-DC-12-A.
161700*
161800     SET SS08WS-ERROR-SW-YES     TO TRUE.
161900     MOVE DFHBMASB               TO MS08-MC-POS-DC-12-LP-A
162000                                    MS08-MC-POS-DC-12-RP-A.
162100     MOVE SS08WS-CURSOR          TO MS08-MC-POS-DC-12-L.
162200*
162300 W419-EXIT.
162400     EXIT.
162500*
162600*
162700*
162800 W700-CIRRUS-X-EDITS.
162900*
163000     IF  SS08WS-ERROR-SW-YES
163100         GO TO W709-EXIT.
163200*
163300     IF  MS08-MC-CIRRUS-IND-ON
163400         IF  MS08-MC-CATEGORY-CODE IS NOT EQUAL TO 6011
163500             GO TO W705-CIRRUS-ERROR.
163600*
163700     GO TO W709-EXIT.
163800*
163900 W705-CIRRUS-ERROR.
164000*
164100     MOVE 'Y'                    TO SS08WS-ERROR.
164200     MOVE DFHBMASB               TO MS08-MC-CIRRUS-IND-LP-A
164300                                    MS08-MC-CIRRUS-IND-RP-A
164400                                    MS08-MC-CATEGORY-CODE-LP-A
164500                                    MS08-MC-CATEGORY-CODE-RP-A.
164600     MOVE DFHBMUBF               TO MS08-MC-CIRRUS-IND-A.
164700     MOVE DFHBMNBF               TO MS08-MC-CATEGORY-CODE-A.
164800     MOVE SS08WS-CURSOR          TO MS08-MC-CIRRUS-IND-L.
164900*
165000 W709-EXIT.
165100     EXIT.
165200*
165300*
165400*
165500 W710-POS-DC-01-X-EDITS.
165600*
165700     IF  SS08WS-ERROR-SW-YES
165800         GO TO W719-EXIT.
165900*
166000     EVALUATE TRUE
166100         WHEN (MS08-MC-POS-DC-01 IS EQUAL TO '1'
166200          AND  MS08-MC-CATEGORY-CODE IS NOT EQUAL TO 6011)
166300             IF  MS08-MC-POS-DC-02 IS NOT EQUAL TO '0'
166400                 MOVE 'Y'        TO SS08WS-ERROR
166500                 MOVE DFHBMASB   TO MS08-MC-POS-DC-01-LP-A
166600                                    MS08-MC-POS-DC-01-RP-A
166700                                    MS08-MC-POS-DC-02-LP-A
166800                                    MS08-MC-POS-DC-02-RP-A
166900                 MOVE DFHBMUBF   TO MS08-MC-POS-DC-01-A
167000                                    MS08-MC-POS-DC-02-A
167100                 MOVE SS08WS-CURSOR TO MS08-MC-POS-DC-02-L
167200                 GO TO W719-EXIT
167300             END-IF
167400             IF  MS08-MC-POS-DC-03 IS NOT EQUAL TO '0'
167500                 MOVE 'Y'        TO SS08WS-ERROR
167600                 MOVE DFHBMASB   TO MS08-MC-POS-DC-01-LP-A
167700                                    MS08-MC-POS-DC-01-RP-A
167800                                    MS08-MC-POS-DC-03-LP-A
167900                                    MS08-MC-POS-DC-03-RP-A
168000                 MOVE DFHBMUBF   TO MS08-MC-POS-DC-01-A
168100                                    MS08-MC-POS-DC-03-A
168200                 MOVE SS08WS-CURSOR TO MS08-MC-POS-DC-03-L
168300                 GO TO W719-EXIT
168400             END-IF
168500             IF  MS08-MC-POS-DC-07 IS NOT EQUAL TO '1'
168600                 IF  MS08-MC-POS-DC-04 IS NOT EQUAL TO '0'
168700                     MOVE 'Y'    TO SS08WS-ERROR
168800                     MOVE DFHBMASB
168900                                 TO MS08-MC-POS-DC-01-LP-A
169000                                    MS08-MC-POS-DC-01-RP-A
169100                                    MS08-MC-POS-DC-04-LP-A
169200                                    MS08-MC-POS-DC-04-RP-A
169300                                    MS08-MC-POS-DC-07-LP-A
169400                                    MS08-MC-POS-DC-07-RP-A
169500                     MOVE DFHBMUBF
169600                                 TO MS08-MC-POS-DC-01-A
169700                                    MS08-MC-POS-DC-04-A
169800                                    MS08-MC-POS-DC-07-A
169900                     MOVE SS08WS-CURSOR
170000                                 TO MS08-MC-POS-DC-04-L
170100                     GO TO W719-EXIT
170200                 END-IF
170300                 IF  MS08-MC-POS-DC-06 IS NOT EQUAL TO '0'
170400                     MOVE 'Y'    TO SS08WS-ERROR
170500                     MOVE DFHBMASB
170600                                 TO MS08-MC-POS-DC-01-LP-A
170700                                    MS08-MC-POS-DC-01-RP-A
170800                                    MS08-MC-POS-DC-06-LP-A
170900                                    MS08-MC-POS-DC-06-RP-A
171000                                    MS08-MC-POS-DC-07-LP-A
171100                                    MS08-MC-POS-DC-07-RP-A
171200                     MOVE DFHBMUBF
171300                                 TO MS08-MC-POS-DC-01-A
171400                                    MS08-MC-POS-DC-06-A
171500                                    MS08-MC-POS-DC-07-A
171600                     MOVE SS08WS-CURSOR
171700                                 TO MS08-MC-POS-DC-06-L
171800                     GO TO W719-EXIT
171900                 END-IF
172000                 IF  MS08-MC-POS-DC-08 IS NOT EQUAL TO '0'
172100                     MOVE 'Y'    TO SS08WS-ERROR
172200                     MOVE DFHBMASB
172300                                 TO MS08-MC-POS-DC-01-LP-A
172400                                    MS08-MC-POS-DC-01-RP-A
172500                                    MS08-MC-POS-DC-07-LP-A
172600                                    MS08-MC-POS-DC-07-RP-A
172700                                    MS08-MC-POS-DC-08-LP-A
172800                                    MS08-MC-POS-DC-08-RP-A
172900                     MOVE DFHBMUBF
173000                                 TO MS08-MC-POS-DC-01-A
173100                                    MS08-MC-POS-DC-07-A
173200                                    MS08-MC-POS-DC-08-A
173300                     MOVE SS08WS-CURSOR
173400                                 TO MS08-MC-POS-DC-08-L
173500                     GO TO W719-EXIT
173600                 END-IF
173700                 IF  MS08-MC-POS-DC-07 IS NOT EQUAL TO '6'
173800                     IF  MS08-MC-POS-DC-07 IS NOT EQUAL TO 'S'
173900                     AND MS08-MC-POS-DC-07 IS NOT EQUAL TO 'T'
174000                     AND MS08-MC-POS-DC-07 IS NOT EQUAL TO 'U'
174100                     AND MS08-MC-POS-DC-07 IS NOT EQUAL TO 'V'
174200                         MOVE 'Y'    TO SS08WS-ERROR
174300                         MOVE DFHBMASB
174400                                 TO MS08-MC-POS-DC-01-LP-A
174500                                    MS08-MC-POS-DC-01-RP-A
174600                                    MS08-MC-POS-DC-07-LP-A
174700                                    MS08-MC-POS-DC-07-RP-A
174800                         MOVE DFHBMUBF
174900                                 TO MS08-MC-POS-DC-01-A
175000                                    MS08-MC-POS-DC-07-A
175100                         MOVE SS08WS-CURSOR
175200                                 TO MS08-MC-POS-DC-07-L
175300                         GO TO W719-EXIT
175400                     END-IF
175500                     IF  MS08-MC-POS-DC-12 IS NOT EQUAL TO '0'
175600                     AND MS08-MC-POS-DC-12 IS NOT EQUAL TO '4'
175700                     AND MS08-MC-POS-DC-12 IS NOT EQUAL TO '5'
175800                     AND MS08-MC-POS-DC-12 IS NOT EQUAL TO '6'
175900                         MOVE 'Y'    TO SS08WS-ERROR
176000                         MOVE DFHBMASB
176100                                 TO MS08-MC-POS-DC-01-LP-A
176200                                    MS08-MC-POS-DC-01-RP-A
176300                                    MS08-MC-POS-DC-12-LP-A
176400                                    MS08-MC-POS-DC-12-RP-A
176500                         MOVE DFHBMUBF
176600                                 TO MS08-MC-POS-DC-01-A
176700                                    MS08-MC-POS-DC-12-A
176800                         MOVE SS08WS-CURSOR
176900                                 TO MS08-MC-POS-DC-12-L
177000                         GO TO W719-EXIT
177100                     END-IF
177200                 ELSE
177300                     IF  MS08-MC-POS-DC-07 IS EQUAL TO '6'
177400                         IF  MS08-MC-POS-DC-10 IS NOT EQUAL TO '0'
177500                         AND MS08-MC-POS-DC-10 IS NOT EQUAL TO '1'
177600                             MOVE 'Y'
177700                                 TO SS08WS-ERROR
177800                             MOVE DFHBMASB
177900                                 TO MS08-MC-POS-DC-01-LP-A
178000                                    MS08-MC-POS-DC-01-RP-A
178100                                    MS08-MC-POS-DC-10-LP-A
178200                                    MS08-MC-POS-DC-10-RP-A
178300                            MOVE DFHBMUBF
178400                                 TO MS08-MC-POS-DC-01-A
178500                                    MS08-MC-POS-DC-10-A
178600                            MOVE SS08WS-CURSOR
178700                                 TO MS08-MC-POS-DC-10-L
178800                            GO TO W719-EXIT
178900                         END-IF
179000                         IF  MS08-MC-POS-DC-11 IS NOT EQUAL TO '1'
179100                             MOVE 'Y'
179200                                 TO SS08WS-ERROR
179300                             MOVE DFHBMASB
179400                                 TO MS08-MC-POS-DC-01-LP-A
179500                                    MS08-MC-POS-DC-01-RP-A
179600                                    MS08-MC-POS-DC-11-LP-A
179700                                    MS08-MC-POS-DC-11-RP-A
179800                             MOVE DFHBMUBF
179900                                 TO MS08-MC-POS-DC-01-A
180000                                    MS08-MC-POS-DC-11-A
180100                             MOVE SS08WS-CURSOR
180200                                 TO MS08-MC-POS-DC-11-L
180300                             GO TO W719-EXIT
180400                         END-IF
180500                         IF  MS08-MC-POS-DC-12 IS NOT EQUAL TO '0'
180600                             MOVE 'Y'
180700                                 TO SS08WS-ERROR
180800                             MOVE DFHBMASB
180900                                 TO MS08-MC-POS-DC-01-LP-A
181000                                    MS08-MC-POS-DC-01-RP-A
181100                                    MS08-MC-POS-DC-12-LP-A
181200                                    MS08-MC-POS-DC-12-RP-A
181300                             MOVE DFHBMUBF
181400                                 TO MS08-MC-POS-DC-01-A
181500                                    MS08-MC-POS-DC-12-A
181600                             MOVE SS08WS-CURSOR
181700                                 TO MS08-MC-POS-DC-12-L
181800                             GO TO W719-EXIT
181900                         END-IF
182000                     END-IF
182100                 END-IF
182200             ELSE
182300                 IF  MS08-MC-POS-DC-04 IS NOT EQUAL TO '0'
182400                 AND MS08-MC-POS-DC-04 IS NOT EQUAL TO '1'
182500                 AND MS08-MC-POS-DC-04 IS NOT EQUAL TO '2'
182600                 AND MS08-MC-POS-DC-04 IS NOT EQUAL TO '3'
182700                 AND MS08-MC-POS-DC-04 IS NOT EQUAL TO '4'
182800                 AND MS08-MC-POS-DC-04 IS NOT EQUAL TO '5'
182900                     MOVE 'Y'    TO SS08WS-ERROR
183000                     MOVE DFHBMASB
183100                                 TO MS08-MC-POS-DC-01-LP-A
183200                                    MS08-MC-POS-DC-01-RP-A
183300                                    MS08-MC-POS-DC-04-LP-A
183400                                    MS08-MC-POS-DC-04-RP-A
183500                     MOVE DFHBMUBF
183600                                 TO MS08-MC-POS-DC-01-A
183700                                    MS08-MC-POS-DC-04-A
183800                     MOVE SS08WS-CURSOR
183900                                 TO MS08-MC-POS-DC-04-L
184000                     GO TO W719-EXIT
184100                 END-IF
184200                 IF  MS08-MC-POS-DC-08 IS NOT EQUAL TO '5'
184300                     MOVE 'Y'    TO SS08WS-ERROR
184400                     MOVE DFHBMASB
184500                                 TO MS08-MC-POS-DC-01-LP-A
184600                                    MS08-MC-POS-DC-01-RP-A
184700                                    MS08-MC-POS-DC-08-LP-A
184800                                    MS08-MC-POS-DC-08-RP-A
184900                     MOVE DFHBMUBF
185000                                 TO MS08-MC-POS-DC-01-A
185100                                    MS08-MC-POS-DC-08-A
185200                     MOVE SS08WS-CURSOR
185300                                 TO MS08-MC-POS-DC-08-L
185400                     GO TO W719-EXIT
185500                 END-IF
185600                 IF  MS08-MC-POS-DC-09 IS NOT EQUAL TO '4'
185700                     MOVE 'Y'    TO SS08WS-ERROR
185800                     MOVE DFHBMASB
185900                                 TO MS08-MC-POS-DC-01-LP-A
186000                                    MS08-MC-POS-DC-01-RP-A
186100                                    MS08-MC-POS-DC-09-LP-A
186200                                    MS08-MC-POS-DC-09-RP-A
186300                     MOVE DFHBMUBF
186400                                 TO MS08-MC-POS-DC-01-A
186500                                    MS08-MC-POS-DC-09-A
186600                     MOVE SS08WS-CURSOR
186700                                 TO MS08-MC-POS-DC-09-L
186800                     GO TO W719-EXIT
186900                 END-IF
187000                 IF  MS08-MC-POS-DC-10 IS NOT EQUAL TO '0'
187100                 AND MS08-MC-POS-DC-10 IS NOT EQUAL TO '1'
187200                     MOVE 'Y'    TO SS08WS-ERROR
187300                     MOVE DFHBMASB
187400                                 TO MS08-MC-POS-DC-01-LP-A
187500                                    MS08-MC-POS-DC-01-RP-A
187600                                    MS08-MC-POS-DC-10-LP-A
187700                                    MS08-MC-POS-DC-10-RP-A
187800                     MOVE DFHBMUBF
187900                                 TO MS08-MC-POS-DC-01-A
188000                                    MS08-MC-POS-DC-10-A
188100                     MOVE SS08WS-CURSOR
188200                                 TO MS08-MC-POS-DC-10-L
188300                     GO TO W719-EXIT
188400                 END-IF
188500                 IF  MS08-MC-POS-DC-11 IS NOT EQUAL TO '1'
188600                     MOVE 'Y'    TO SS08WS-ERROR
188700                     MOVE DFHBMASB
188800                                 TO MS08-MC-POS-DC-01-LP-A
188900                                    MS08-MC-POS-DC-01-RP-A
189000                                    MS08-MC-POS-DC-11-LP-A
189100                                    MS08-MC-POS-DC-11-RP-A
189200                     MOVE DFHBMUBF
189300                                 TO MS08-MC-POS-DC-01-A
189400                                    MS08-MC-POS-DC-11-A
189500                     MOVE SS08WS-CURSOR
189600                                 TO MS08-MC-POS-DC-11-L
189700                     GO TO W719-EXIT
189800                 END-IF
189900                 IF  MS08-MC-POS-DC-12 IS NOT EQUAL TO '0'
190000                     MOVE 'Y'    TO SS08WS-ERROR
190100                     MOVE DFHBMASB
190200                                 TO MS08-MC-POS-DC-01-LP-A
190300                                    MS08-MC-POS-DC-01-RP-A
190400                                    MS08-MC-POS-DC-12-LP-A
190500                                    MS08-MC-POS-DC-12-RP-A
190600                     MOVE DFHBMUBF
190700                                 TO MS08-MC-POS-DC-01-A
190800                                    MS08-MC-POS-DC-12-A
190900                     MOVE SS08WS-CURSOR
191000                                 TO MS08-MC-POS-DC-12-L
191100                     GO TO W719-EXIT
191200                 END-IF
191300             END-IF
191400         WHEN OTHER
191500             IF  MS08-MC-POS-DC-04 IS NOT EQUAL TO '1'
191600             AND MS08-MC-POS-DC-04 IS NOT EQUAL TO '2'
191700             AND MS08-MC-POS-DC-04 IS NOT EQUAL TO '3'
191800             AND MS08-MC-POS-DC-04 IS NOT EQUAL TO '4'
191900             AND MS08-MC-POS-DC-04 IS NOT EQUAL TO '5'
192000               IF  MS08-MC-CATEGORY-CODE NOT EQUAL TO 6011
192100                 IF  MS08-MC-CATEGORY-CODE NOT EQUAL TO 6010
192200                     IF  MS08-MC-POS-DC-04 IS NOT EQUAL TO 'S'
192300                     AND MS08-MC-POS-DC-04 IS NOT EQUAL TO 'T'
192400                     AND MS08-MC-POS-DC-04 IS NOT EQUAL TO 'U'
192500                     AND MS08-MC-POS-DC-04 IS NOT EQUAL TO 'V'
192600                         MOVE 'Y'
192700                                 TO SS08WS-ERROR
192800                         MOVE DFHBMASB
192900                                 TO MS08-MC-POS-DC-01-LP-A
193000                                    MS08-MC-POS-DC-01-RP-A
193100                                    MS08-MC-POS-DC-04-LP-A
193200                                    MS08-MC-POS-DC-04-RP-A
193300                         MOVE DFHBMUBF
193400                                 TO MS08-MC-POS-DC-01-A
193500                                    MS08-MC-POS-DC-04-A
193600                         MOVE SS08WS-CURSOR
193700                                 TO MS08-MC-POS-DC-04-L
193800                         GO TO W719-EXIT
193900                     END-IF
194000                 ELSE
194100                     IF  MS08-MC-CATEGORY-CODE IS EQUAL TO 6010
194200                         MOVE 'Y'
194300                                 TO SS08WS-ERROR
194400                         MOVE DFHBMASB
194500                                 TO MS08-MC-POS-DC-01-LP-A
194600                                    MS08-MC-POS-DC-01-RP-A
194700                                    MS08-MC-POS-DC-04-LP-A
194800                                    MS08-MC-POS-DC-04-RP-A
194900                                    MS08-MC-CATEGORY-CODE-LP-A
195000                                    MS08-MC-CATEGORY-CODE-RP-A
195100                         MOVE DFHBMUBF
195200                                 TO MS08-MC-POS-DC-01-A
195300                                    MS08-MC-POS-DC-04-A
195400                                    MS08-MC-CATEGORY-CODE-A
195500                         MOVE SS08WS-CURSOR
195600                                 TO MS08-MC-CATEGORY-CODE-L
195700                         GO TO W719-EXIT
195800                     END-IF
195900                 END-IF
196000               ELSE
196100                 IF  MS08-MC-CATEGORY-CODE IS EQUAL TO 6011
196200                     IF  MS08-MC-POS-DC-04 IS NOT EQUAL TO '9'
196300                         MOVE 'Y'
196400                                 TO SS08WS-ERROR
196500                         MOVE DFHBMASB
196600                                 TO MS08-MC-POS-DC-01-LP-A
196700                                    MS08-MC-POS-DC-01-RP-A
196800                                    MS08-MC-POS-DC-04-LP-A
196900                                    MS08-MC-POS-DC-04-RP-A
197000                                    MS08-MC-CATEGORY-CODE-LP-A
197100                                    MS08-MC-CATEGORY-CODE-RP-A
197200                         MOVE DFHBMUBF
197300                                 TO MS08-MC-POS-DC-01-A
197400                                    MS08-MC-POS-DC-04-A
197500                                    MS08-MC-CATEGORY-CODE-A
197600                         MOVE SS08WS-CURSOR
197700                                 TO MS08-MC-CATEGORY-CODE-L
197800                         GO TO W719-EXIT
197900                     END-IF
198000                 END-IF
198100               END-IF
198200             END-IF
198300             IF  MS08-MC-POS-DC-01 IS NOT EQUAL TO '2'
198400             AND MS08-MC-POS-DC-01 IS NOT EQUAL TO '5'
198500                 MOVE 'Y'        TO SS08WS-ERROR
198600                 MOVE DFHBMASB   TO MS08-MC-POS-DC-01-LP-A
198700                                    MS08-MC-POS-DC-01-RP-A
198800                                    MS08-MC-POS-DC-04-LP-A
198900                                    MS08-MC-POS-DC-04-RP-A
199000                 MOVE DFHBMUBF   TO MS08-MC-POS-DC-01-A
199100                                    MS08-MC-POS-DC-04-A
199200                 MOVE SS08WS-CURSOR TO MS08-MC-POS-DC-04-L
199300                 GO TO W719-EXIT
199400             END-IF
199500             IF  MS08-MC-POS-DC-05 IS NOT EQUAL TO '0'
199600                 MOVE 'Y'        TO SS08WS-ERROR
199700                 MOVE DFHBMASB   TO MS08-MC-POS-DC-05-LP-A
199800                                    MS08-MC-POS-DC-05-RP-A
199900                                    MS08-MC-POS-DC-04-LP-A
200000                                    MS08-MC-POS-DC-04-RP-A
200100                 MOVE DFHBMUBF   TO MS08-MC-POS-DC-05-A
200200                                    MS08-MC-POS-DC-04-A
200300                 MOVE SS08WS-CURSOR TO MS08-MC-POS-DC-05-L
200400                 GO TO W719-EXIT
200500             END-IF
200600             IF  MS08-MC-POS-DC-06 IS NOT EQUAL TO '1'
200700                 MOVE 'Y'        TO SS08WS-ERROR
200800                 MOVE DFHBMASB   TO MS08-MC-POS-DC-06-LP-A
200900                                    MS08-MC-POS-DC-06-RP-A
201000                                    MS08-MC-POS-DC-04-LP-A
201100                                    MS08-MC-POS-DC-04-RP-A
201200                 MOVE DFHBMUBF   TO MS08-MC-POS-DC-06-A
201300                                    MS08-MC-POS-DC-04-A
201400                 MOVE SS08WS-CURSOR TO MS08-MC-POS-DC-06-L
201500                 GO TO W719-EXIT
201600             END-IF
201700             IF  MS08-MC-POS-DC-07 IS NOT EQUAL TO '2'
201800             AND MS08-MC-POS-DC-07 IS NOT EQUAL TO '5'
201900             AND MS08-MC-POS-DC-07 IS NOT EQUAL TO '6'
202000                 MOVE 'Y'        TO SS08WS-ERROR
202100                 MOVE DFHBMASB   TO MS08-MC-POS-DC-07-LP-A
202200                                    MS08-MC-POS-DC-07-RP-A
202300                                    MS08-MC-POS-DC-04-LP-A
202400                                    MS08-MC-POS-DC-04-RP-A
202500                 MOVE DFHBMUBF   TO MS08-MC-POS-DC-07-A
202600                                    MS08-MC-POS-DC-04-A
202700                 MOVE SS08WS-CURSOR TO MS08-MC-POS-DC-07-L
202800                 GO TO W719-EXIT
202900             END-IF
203000             IF  MS08-MC-POS-DC-02 IS NOT EQUAL TO '0'
203100                 IF  MS08-MC-POS-DC-02 IS NOT EQUAL TO '1'
203200                     MOVE 'Y'    TO SS08WS-ERROR
203300                     MOVE DFHBMASB
203400                                 TO MS08-MC-POS-DC-02-LP-A
203500                                    MS08-MC-POS-DC-02-RP-A
203600                                    MS08-MC-POS-DC-04-LP-A
203700                                    MS08-MC-POS-DC-04-RP-A
203800                     MOVE DFHBMUBF
203900                                 TO MS08-MC-POS-DC-02-A
204000                                    MS08-MC-POS-DC-04-A
204100                     MOVE SS08WS-CURSOR
204200                                 TO MS08-MC-POS-DC-02-L
204300                     GO TO W719-EXIT
204400                 END-IF
204500                 IF  MS08-MC-POS-DC-08 IS NOT EQUAL TO '1'
204600                     MOVE 'Y'    TO SS08WS-ERROR
204700                     MOVE DFHBMASB
204800                                 TO MS08-MC-POS-DC-08-LP-A
204900                                    MS08-MC-POS-DC-08-RP-A
205000                                    MS08-MC-POS-DC-04-LP-A
205100                                    MS08-MC-POS-DC-04-RP-A
205200                     MOVE DFHBMUBF
205300                                 TO MS08-MC-POS-DC-08-A
205400                                    MS08-MC-POS-DC-04-A
205500                     MOVE SS08WS-CURSOR
205600                                 TO MS08-MC-POS-DC-08-L
205700                     GO TO W719-EXIT
205800                 END-IF
205900             ELSE
206000                 IF  MS08-MC-POS-DC-08 IS NOT EQUAL TO '5'
206100                     MOVE 'Y'    TO SS08WS-ERROR
206200                     MOVE DFHBMASB
206300                                 TO MS08-MC-POS-DC-08-LP-A
206400                                    MS08-MC-POS-DC-08-RP-A
206500                                    MS08-MC-POS-DC-04-LP-A
206600                                    MS08-MC-POS-DC-04-RP-A
206700                     MOVE DFHBMUBF
206800                                 TO MS08-MC-POS-DC-08-A
206900                                    MS08-MC-POS-DC-04-A
207000                     MOVE SS08WS-CURSOR
207100                                 TO MS08-MC-POS-DC-08-L
207200                     GO TO W719-EXIT
207300                 END-IF
207400                 IF  MS08-MC-POS-DC-03 IS NOT EQUAL TO '0'
207500                     MOVE 'Y'    TO SS08WS-ERROR
207600                     MOVE DFHBMASB
207700                                 TO MS08-MC-POS-DC-03-LP-A
207800                                    MS08-MC-POS-DC-03-RP-A
207900                                    MS08-MC-POS-DC-04-LP-A
208000                                    MS08-MC-POS-DC-04-RP-A
208100                     MOVE DFHBMUBF
208200                                 TO MS08-MC-POS-DC-03-A
208300                                    MS08-MC-POS-DC-04-A
208400                     MOVE SS08WS-CURSOR
208500                                 TO MS08-MC-POS-DC-03-L
208600                     GO TO W719-EXIT
208700                 END-IF
208800             END-IF
208900     END-EVALUATE.
209000*
209100 W719-EXIT.
209200     EXIT.
209300*
209400 W720-CAT-X-EDIT.                                                 RG802901
209500*
209600     IF  SS08WS-ERROR-SW-YES
209700         GO TO W729-EXIT.
209800*
209900     IF  MS08-MC-CATEGORY-CODE IS EQUAL TO 5542
210000         IF  MS08-MC-CH-TERM-IND IS EQUAL TO ('1' OR '2')         RG802901
210010* MCC 5542 (AUTOMATED FUEL DISPENSERS) ARE ALLOWED TO HAVE        RG802901
210020* CAT LEVELS 1 OR 2                                               RG802901
210100             CONTINUE
210200         ELSE
210300             MOVE 'Y'            TO SS08WS-ERROR
210400             MOVE DFHBMASB       TO MS08-MC-CATEGORY-CODE-LP-A
210500                                    MS08-MC-CATEGORY-CODE-RP-A
210600                                    MS08-MC-CH-TERM-IND-LP-A
210700                                    MS08-MC-CH-TERM-IND-RP-A
210800             MOVE DFHBMNBF       TO MS08-MC-CATEGORY-CODE-A
210900             MOVE DFHBMUBF       TO MS08-MC-CH-TERM-IND-A
211000             MOVE SS08WS-CURSOR  TO MS08-MC-CATEGORY-CODE-L
211100         END-IF
211200     END-IF.
211300*
211305     IF  MS08-MC-CH-TERM-IND IS EQUAL TO '2'                      RG802901
211310         IF  MS08-MC-CATEGORY-CODE IS EQUAL TO 5542               RG802901
211312* IN ADDITION, CAT LEVEL 2 IS ONLY VALID FOR                      RG802901
211313* MCC 5542 (AUTOMATED FUEL DISPENSERS)                            RG802901
211315             CONTINUE                                             RG802901
211320         ELSE                                                     RG802901
211325             MOVE 'Y'            TO SS08WS-ERROR                  RG802901
211330             MOVE DFHBMASB       TO MS08-MC-CATEGORY-CODE-LP-A    RG802901
211335                                    MS08-MC-CATEGORY-CODE-RP-A    RG802901
211340                                    MS08-MC-CH-TERM-IND-LP-A      RG802901
211345                                    MS08-MC-CH-TERM-IND-RP-A      RG802901
211350             MOVE DFHBMNBF       TO MS08-MC-CATEGORY-CODE-A       RG802901
211355             MOVE DFHBMUBF       TO MS08-MC-CH-TERM-IND-A         RG802901
211360             MOVE SS08WS-CURSOR  TO MS08-MC-CH-TERM-IND-L         RG802901
211365         END-IF                                                   RG802901
211370     END-IF.                                                      RG802901
211375*                                                                 RG802901
211380     IF MS08-MC-CH-TERM-IND IS NOT EQUAL TO '6'                   RG802901
211385         GO TO W729-EXIT.                                         RG802901
211390* EDIT THE INTERCHANGE INDICATOR FOR CAT LEVEL 6 ONLY             RG802901
211395* IT MUST BE A '1' FOR STORES IN THE US, AND A 'B' FOR            RG802901
211400* STORES OUTSIDE THE US.                                          RG802901
211405     IF MS08-MC-MERIT-1-RATE                                      RG802901
211410*            (VALUE OF 1)                                         RG802901
211415         IF MMSM-COUNTRY-CODE (1) EQUAL TO ('US ' OR 'USA')       RG802901
211416* USE THE PRIMARY DEMOGRAPHICS AREA COUNTRY CODE                  RG802901
211420             CONTINUE                                             RG802901
211425          ELSE                                                    RG802901
211430             MOVE 'Y'            TO SS08WS-ERROR                  RG802901
211435             MOVE DFHBMASB       TO MS08-MC-INTCHG-FLAG-LP-A      RG802901
211440                                    MS08-MC-INTCHG-FLAG-RP-A      RG802901
211445                                    MS08-MC-CH-TERM-IND-LP-A      RG802901
211450                                    MS08-MC-CH-TERM-IND-RP-A      RG802901
211455             MOVE DFHBMUBF       TO MS08-MC-INTCHG-FLAG-A         RG802901
211460                                    MS08-MC-CH-TERM-IND-A         RG802901
211465             MOVE SS08WS-CURSOR  TO MS08-MC-INTCHG-FLAG-L         RG802901
211470         END-IF                                                   RG802901
211475     END-IF.                                                      RG802901
211480*                                                                 RG802901
211485     IF MS08-MC-INTL-ELECTRONIC                                   RG802901
211490*            (VALUE OF B)                                         RG802901
211495         IF MMSM-COUNTRY-CODE (1) IS NOT EQUAL TO ('US ' OR 'USA')RG802901
211496* USE THE PRIMARY DEMOGRAPHICS AREA COUNTRY CODE                  RG802901
211500             CONTINUE                                             RG802901
211505          ELSE                                                    RG802901
211510             MOVE 'Y'            TO SS08WS-ERROR                  RG802901
211515             MOVE DFHBMASB       TO MS08-MC-INTCHG-FLAG-LP-A      RG802901
211520                                    MS08-MC-INTCHG-FLAG-RP-A      RG802901
211525                                    MS08-MC-CH-TERM-IND-LP-A      RG802901
211530                                    MS08-MC-CH-TERM-IND-RP-A      RG802901
211535             MOVE DFHBMUBF       TO MS08-MC-INTCHG-FLAG-A         RG802901
211540                                    MS08-MC-CH-TERM-IND-A         RG802901
211545             MOVE SS08WS-CURSOR  TO MS08-MC-INTCHG-FLAG-L         RG802901
211550         END-IF                                                   RG802901
211555     END-IF.                                                      RG802901
211560*                                                                 RG802901
211565 W729-EXIT.                                                       RG802901
211570     EXIT.                                                        RG802901
211600*
211700*
211800*
211900/
212000 X000-UPDATE-FIELDS SECTION.
212100*
212200 X010-UPDATE-DBA-NAME.
212300*
212400     IF  MS08-MC-DBA-NAME-L IS GREATER THAN ZERO
212500         IF  MS08-MC-DBA-NAME IS NOT EQUAL TO
212600                                    MMSM-MC-DBA-NAME
212700             SET WS-UPDATE-MMSM-SW-YES
212800                                 TO TRUE
212900             IF  MBCA-PTI-FUNCTION-IS-MAINT
213000             AND MMSM-ADD-COMPLETED
213100                 MOVE MMSMTB-MC-DBA-NAME (1:4)
213200                                 TO WS-INDEX-X
213300                 SET X-MMFS-STORE
213400                                 TO WS-INDEX
213500                 MOVE MMFS-ST-AUDIT-CODE (X-MMFS-STORE)
213600                                 TO MML1-MMSM-AUDIT-CODE
213700                 MOVE 0801       TO MML1-FIELD-CODE
213800                 MOVE ZEROES     TO MML1-FIELD-OCCURRENCE
213900                                    MML1-FIELD-OCCURRENCE-2
214000                 MOVE MML1WS-VL-30
214100                                 TO MML1-VARIABLE-LENGTH
214200                 MOVE MMSM-MC-DBA-NAME
214300                                 TO MML1-VL30-B-DATA-X
214400                 MOVE MS08-MC-DBA-NAME
214500                                 TO MMSM-MC-DBA-NAME
214600                 MOVE MMSM-MC-DBA-NAME
214700                                 TO MML1-VL30-A-DATA-X
214800                 MOVE 'FC12'     TO MBCA-PROGRAM-LOCATION
214900                 PERFORM Y920-WRITE-LOG-RECORD
215000                                 THRU Y929-WLR-EXIT
215100             ELSE
215200                 MOVE MS08-MC-DBA-NAME
215300                                 TO MMSM-MC-DBA-NAME.
215400*
215500 X019-EXIT.
215600     EXIT.
215700*
215800 X030-UPDATE-CIRRUS-IND.
215900*
216000     IF  MS08-MC-CIRRUS-IND-L IS GREATER THAN ZERO
216100         IF  MS08-MC-CIRRUS-IND IS NOT EQUAL TO
216200                                    MMSM-MC-CIRRUS-IND
216300             SET WS-UPDATE-MMSM-SW-YES
216400                                 TO TRUE
216500             IF  MBCA-PTI-FUNCTION-IS-MAINT
216600             AND MMSM-ADD-COMPLETED
216700                 MOVE MMSMTB-MC-CIRRUS-IND (1:4)
216800                                 TO WS-INDEX-X
216900                 SET X-MMFS-STORE
217000                                 TO WS-INDEX
217100                 MOVE MMFS-ST-AUDIT-CODE (X-MMFS-STORE)
217200                                 TO MML1-MMSM-AUDIT-CODE
217300                 MOVE 0802       TO MML1-FIELD-CODE
217400                 MOVE ZEROES     TO MML1-FIELD-OCCURRENCE
217500                                    MML1-FIELD-OCCURRENCE-2
217600                 MOVE MML1WS-VL-01
217700                                 TO MML1-VARIABLE-LENGTH
217800                 MOVE MMSM-MC-CIRRUS-IND
217900                                 TO MML1-VL01-B-DATA-X
218000                 MOVE MS08-MC-CIRRUS-IND
218100                                 TO MMSM-MC-CIRRUS-IND
218200                 MOVE MMSM-MC-CIRRUS-IND
218300                                 TO MML1-VL01-A-DATA-X
218400                 MOVE 'FC13'     TO MBCA-PROGRAM-LOCATION
218500                 PERFORM Y920-WRITE-LOG-RECORD
218600                                 THRU Y929-WLR-EXIT
218700             ELSE
218800                 MOVE MS08-MC-CIRRUS-IND
218900                                 TO MMSM-MC-CIRRUS-IND.
219000*
219100 X039-EXIT.
219200     EXIT.
219300*
219400 X050-UPDATE-INTCHG-IND.
219500*
219600     IF  MS08-MC-INTCHG-FLAG-L IS GREATER THAN ZERO
219700         IF  MS08-MC-INTCHG-FLAG IS NOT EQUAL TO
219800                                    MMSM-MC-INTCHG-FLAG
219900             SET WS-UPDATE-MMSM-SW-YES
220000                                 TO TRUE
220100             IF  MBCA-PTI-FUNCTION-IS-MAINT
220200             AND MMSM-ADD-COMPLETED
220300                 MOVE MMSMTB-MC-INTCHG-IND (1:4)
220400                                 TO WS-INDEX-X
220500                 SET X-MMFS-STORE
220600                                 TO WS-INDEX
220700                 MOVE MMFS-ST-AUDIT-CODE (X-MMFS-STORE)
220800                                 TO MML1-MMSM-AUDIT-CODE
220900                 MOVE 0803       TO MML1-FIELD-CODE
221000                 MOVE ZEROES     TO MML1-FIELD-OCCURRENCE
221100                                    MML1-FIELD-OCCURRENCE-2
221200                 MOVE MML1WS-VL-01
221300                                 TO MML1-VARIABLE-LENGTH
221400                 MOVE MMSM-MC-INTCHG-FLAG
221500                                 TO MML1-VL01-B-DATA-X
221600                 MOVE MS08-MC-INTCHG-FLAG
221700                                 TO MMSM-MC-INTCHG-FLAG
221800                 MOVE MMSM-MC-INTCHG-FLAG
221900                                 TO MML1-VL01-A-DATA-X
222000                 MOVE 'FC14'     TO MBCA-PROGRAM-LOCATION
222100                 PERFORM Y920-WRITE-LOG-RECORD
222200                                 THRU Y929-WLR-EXIT
222300             ELSE
222400                 MOVE MS08-MC-INTCHG-FLAG
222500                                 TO MMSM-MC-INTCHG-FLAG.
222600*
222700 X059-EXIT.
222800     EXIT.
222900*
223000 X070-UPDATE-BUS-CLASS-CODE.
223100*
223200     IF  MS08-MC-BUS-CLASS-CODE-L IS GREATER THAN ZERO
223300         IF  MS08-MC-BUS-CLASS-CODE IS NOT EQUAL TO
223400                                    MMSM-MC-BUSINESS-CLASS
223500             SET WS-UPDATE-MMSM-SW-YES
223600                                 TO TRUE
223700             IF  MBCA-PTI-FUNCTION-IS-MAINT
223800             AND MMSM-ADD-COMPLETED
223900                 MOVE MMSMTB-MC-BUSINESS-CLASS (1:4)
224000                                 TO WS-INDEX-X
224100                 SET X-MMFS-STORE
224200                                 TO WS-INDEX
224300                 MOVE MMFS-ST-AUDIT-CODE (X-MMFS-STORE)
224400                                 TO MML1-MMSM-AUDIT-CODE
224500                 MOVE 0804       TO MML1-FIELD-CODE
224600                 MOVE ZEROES     TO MML1-FIELD-OCCURRENCE
224700                                    MML1-FIELD-OCCURRENCE-2
224800                 MOVE MML1WS-VL-04
224900                                 TO MML1-VARIABLE-LENGTH
225000                 MOVE MMSM-MC-BUSINESS-CLASS
225100                                 TO MML1-VL04-B-DATA-X
225200                 MOVE MS08-MC-BUS-CLASS-CODE
225300                                 TO MMSM-MC-BUSINESS-CLASS
225400                 MOVE MMSM-MC-BUSINESS-CLASS
225500                                 TO MML1-VL04-A-DATA-X
225600                 MOVE 'FC15'     TO MBCA-PROGRAM-LOCATION
225700                 PERFORM Y920-WRITE-LOG-RECORD
225800                                 THRU Y929-WLR-EXIT
225900             ELSE
226000                 MOVE MS08-MC-BUS-CLASS-CODE
226100                                 TO MMSM-MC-BUSINESS-CLASS.
226200*
226300 X079-EXIT.
226400     EXIT.
226500*
226600 X130-UPDATE-CATEGORY-CODE.
226700*
226800     IF  MS08-MC-CATEGORY-CODE-L IS GREATER THAN ZERO
226900         IF  MS08-MC-CATEGORY-CODE IS NOT EQUAL TO
227000                                    MMSM-MC-CATEGORY-CODE
227100             SET WS-UPDATE-MMSM-SW-YES
227200                                 TO TRUE
227300             IF  MBCA-PTI-FUNCTION-IS-MAINT
227400             AND MMSM-ADD-COMPLETED
227500                 MOVE MMSMTB-MC-CATEGORY-CODE (1:4)
227600                                 TO WS-INDEX-X
227700                 SET X-MMFS-STORE
227800                                 TO WS-INDEX
227900                 MOVE MMFS-ST-AUDIT-CODE (X-MMFS-STORE)
228000                                 TO MML1-MMSM-AUDIT-CODE
228100                 MOVE 0807       TO MML1-FIELD-CODE
228200                 MOVE ZEROES     TO MML1-FIELD-OCCURRENCE
228300                                    MML1-FIELD-OCCURRENCE-2
228400                 MOVE MML1WS-VL-04
228500                                 TO MML1-VARIABLE-LENGTH
228600                 MOVE MMSM-MC-CATEGORY-CODE
228700                                 TO MML1-VL04-B-DATA-9
228800                 MOVE MS08-MC-CATEGORY-CODE
228900                                 TO MMSM-MC-CATEGORY-CODE
229000                 MOVE MMSM-MC-CATEGORY-CODE
229100                                 TO MML1-VL04-A-DATA-9
229200                 MOVE 'FC16'     TO MBCA-PROGRAM-LOCATION
229300                 PERFORM Y920-WRITE-LOG-RECORD
229400                                 THRU Y929-WLR-EXIT
229500             ELSE
229600                 MOVE MS08-MC-CATEGORY-CODE
229700                                 TO MMSM-MC-CATEGORY-CODE.
229800*
229900 X139-EXIT.
230000     EXIT.
230100*
230200 X150-UPDATE-FLOOR-LIMIT.
230300*
230400     IF  MS08-MC-FLOOR-LIMIT-L IS GREATER THAN ZERO
230500         IF  MS08-MC-FLOOR-LIMIT IS NOT EQUAL TO
230600                                    MMSM-MC-FLOOR-LIMIT
230700             SET WS-UPDATE-MMSM-SW-YES
230800                                 TO TRUE
230900             IF  MBCA-PTI-FUNCTION-IS-MAINT
231000             AND MMSM-ADD-COMPLETED
231100                 MOVE MMSMTB-MC-FLOOR-LIMIT (1:4)
231200                                 TO WS-INDEX-X
231300                 SET X-MMFS-STORE
231400                                 TO WS-INDEX
231500                 MOVE MMFS-ST-AUDIT-CODE (X-MMFS-STORE)
231600                                 TO MML1-MMSM-AUDIT-CODE
231700                 MOVE 0808       TO MML1-FIELD-CODE
231800                 MOVE ZEROES     TO MML1-FIELD-OCCURRENCE
231900                                    MML1-FIELD-OCCURRENCE-2
232000                 MOVE MML1WS-VL-20
232100                                 TO MML1-VARIABLE-LENGTH
232200                 MOVE MMSM-MC-FLOOR-LIMIT
232300                                 TO MML1-VL20-B-NBR-V902
232400                 MOVE MS08-MC-FLOOR-LIMIT
232500                                 TO MMSM-MC-FLOOR-LIMIT
232600                 MOVE MMSM-MC-FLOOR-LIMIT
232700                                 TO MML1-VL20-A-NBR-V902
232800                 MOVE 'FC17'     TO MBCA-PROGRAM-LOCATION
232900                 PERFORM Y920-WRITE-LOG-RECORD
233000                                 THRU Y929-WLR-EXIT
233100             ELSE
233200                 MOVE MS08-MC-FLOOR-LIMIT
233300                                 TO MMSM-MC-FLOOR-LIMIT.
233400*
233500 X159-EXIT.
233600     EXIT.
233700*
233800 X170-UPDATE-MC-CH-TERM-IND.
233900*
234000     IF  MS08-MC-CH-TERM-IND-L IS GREATER THAN ZERO
234100         IF  MS08-MC-CH-TERM-IND IS NOT EQUAL TO
234200                                    MMSM-MC-CH-TERM-IND
234300             SET WS-UPDATE-MMSM-SW-YES
234400                                 TO TRUE
234500             IF  MBCA-PTI-FUNCTION-IS-MAINT
234600             AND MMSM-ADD-COMPLETED
234700                 MOVE MMSMTB-MC-CH-TERM-IND (1:4)
234800                                 TO WS-INDEX-X
234900                 SET X-MMFS-STORE
235000                                 TO WS-INDEX
235100                 MOVE MMFS-ST-AUDIT-CODE (X-MMFS-STORE)
235200                                 TO MML1-MMSM-AUDIT-CODE
235300                 MOVE 0809       TO MML1-FIELD-CODE
235400                 MOVE ZEROES     TO MML1-FIELD-OCCURRENCE
235500                                    MML1-FIELD-OCCURRENCE-2
235600                 MOVE MML1WS-VL-01
235700                                 TO MML1-VARIABLE-LENGTH
235800                 MOVE MMSM-MC-CH-TERM-IND
235900                                 TO MML1-VL01-B-DATA-X
236000                 MOVE MS08-MC-CH-TERM-IND
236100                                 TO MMSM-MC-CH-TERM-IND
236200                 MOVE MMSM-MC-CH-TERM-IND
236300                                 TO MML1-VL01-A-DATA-X
236400                 MOVE 'FC22'     TO MBCA-PROGRAM-LOCATION
236500                 PERFORM Y920-WRITE-LOG-RECORD
236600                                 THRU Y929-WLR-EXIT
236700             ELSE
236800                 MOVE MS08-MC-CH-TERM-IND
236900                                 TO MMSM-MC-CH-TERM-IND.
237000*
237100 X179-EXIT.
237200     EXIT.
237202*                                                                 RG800913
237204 X180-UPDATE-ASSIGNED-ID.                                         RG800913
237206*                                                                 RG800913
237208     IF  MS08-MC-ASSIGNED-ID-L IS GREATER THAN ZERO               RG800913
237210         IF  MS08-MC-ASSIGNED-ID IS NOT EQUAL TO                  RG800913
237212                                    MMSM-MC-ASSIGNED-ID           RG800913
237214             SET WS-UPDATE-MMSM-SW-YES                            RG800913
237216                                 TO TRUE                          RG800913
237218             IF  MBCA-PTI-FUNCTION-IS-MAINT                       RG800913
237220             AND MMSM-ADD-COMPLETED                               RG800913
237222                 MOVE MMSMTB-MC-ASSIGNED-ID (1:4)                 RG800913
237224                                 TO WS-INDEX-X                    RG800913
237226                 SET X-MMFS-STORE                                 RG800913
237228                                 TO WS-INDEX                      RG800913
237230                 MOVE MMFS-ST-AUDIT-CODE (X-MMFS-STORE)           RG800913
237232                                 TO MML1-MMSM-AUDIT-CODE          RG800913
237234                 MOVE 0822       TO MML1-FIELD-CODE               RG800913
237236                 MOVE ZEROES     TO MML1-FIELD-OCCURRENCE         RG800913
237238                                    MML1-FIELD-OCCURRENCE-2       RG800913
237240                 MOVE MML1WS-VL-03                                RG800913
237242                                 TO MML1-VARIABLE-LENGTH          RG800913
237244                 MOVE MMSM-MC-ASSIGNED-ID                         RG800913
237246                                 TO MML1-VL03-B-DATA-X            RG800913
237248                 MOVE MS08-MC-ASSIGNED-ID                         RG800913
237250                                 TO MMSM-MC-ASSIGNED-ID           RG800913
237252                 MOVE MMSM-MC-ASSIGNED-ID                         RG800913
237254                                 TO MML1-VL03-A-DATA-X            RG800913
237256                 MOVE 'FC28'     TO MBCA-PROGRAM-LOCATION         RG800913
237258                 PERFORM Y920-WRITE-LOG-RECORD                    RG800913
237260                                 THRU Y929-WLR-EXIT               RG800913
237262             ELSE                                                 RG800913
237264                 MOVE MS08-MC-ASSIGNED-ID                         RG800913
237266                                 TO MMSM-MC-ASSIGNED-ID.          RG800913
237268*                                                                 RG800913
237270 X189-EXIT.                                                       RG800913
237272     EXIT.                                                        RG800913
237300*
237400 X190-UPDATE-MC-POS-DC-01.
237500*
237600     IF  MS08-MC-POS-DC-01-L IS GREATER THAN ZERO
237700         IF  MS08-MC-POS-DC-01 IS NOT EQUAL TO
237800                                    MMSM-MC-POS-DC-01
237900             SET WS-UPDATE-MMSM-SW-YES
238000                                 TO TRUE
238100             IF  MBCA-PTI-FUNCTION-IS-MAINT
238200             AND MMSM-ADD-COMPLETED
238300                 MOVE MMSMTB-MC-POS-DC-01 (1:4)
238400                                 TO WS-INDEX-X
238500                 SET X-MMFS-STORE
238600                                 TO WS-INDEX
238700                 MOVE MMFS-ST-AUDIT-CODE (X-MMFS-STORE)
238800                                 TO MML1-MMSM-AUDIT-CODE
238900                 MOVE 0810       TO MML1-FIELD-CODE
239000                 MOVE ZEROES     TO MML1-FIELD-OCCURRENCE
239100                                    MML1-FIELD-OCCURRENCE-2
239200                 MOVE MML1WS-VL-01
239300                                 TO MML1-VARIABLE-LENGTH
239400                 MOVE MMSM-MC-POS-DC-01
239500                                 TO MML1-VL01-B-DATA-X
239600                 MOVE MS08-MC-POS-DC-01
239700                                 TO MMSM-MC-POS-DC-01
239800                 MOVE MMSM-MC-POS-DC-01
239900                                 TO MML1-VL01-A-DATA-X
240000                 MOVE 'FC13'     TO MBCA-PROGRAM-LOCATION
240100                 PERFORM Y920-WRITE-LOG-RECORD
240200                                 THRU Y929-WLR-EXIT
240300             ELSE
240400                 MOVE MS08-MC-POS-DC-01
240500                                 TO MMSM-MC-POS-DC-01.
240600*
240700 X199-EXIT.
240800     EXIT.
240900*
241000 X210-UPDATE-MC-POS-DC-02.
241100*
241200     IF  MS08-MC-POS-DC-02-L IS GREATER THAN ZERO
241300         IF  MS08-MC-POS-DC-02 IS NOT EQUAL TO
241400                                    MMSM-MC-POS-DC-02
241500             SET WS-UPDATE-MMSM-SW-YES
241600                                 TO TRUE
241700             IF  MBCA-PTI-FUNCTION-IS-MAINT
241800             AND MMSM-ADD-COMPLETED
241900                 MOVE MMSMTB-MC-POS-DC-02 (1:4)
242000                                 TO WS-INDEX-X
242100                 SET X-MMFS-STORE
242200                                 TO WS-INDEX
242300                 MOVE MMFS-ST-AUDIT-CODE (X-MMFS-STORE)
242400                                 TO MML1-MMSM-AUDIT-CODE
242500                 MOVE 0811       TO MML1-FIELD-CODE
242600                 MOVE ZEROES     TO MML1-FIELD-OCCURRENCE
242700                                    MML1-FIELD-OCCURRENCE-2
242800                 MOVE MML1WS-VL-01
242900                                 TO MML1-VARIABLE-LENGTH
243000                 MOVE MMSM-MC-POS-DC-02
243100                                 TO MML1-VL01-B-DATA-X
243200                 MOVE MS08-MC-POS-DC-02
243300                                 TO MMSM-MC-POS-DC-02
243400                 MOVE MMSM-MC-POS-DC-02
243500                                 TO MML1-VL01-A-DATA-X
243600                 MOVE 'FC13'     TO MBCA-PROGRAM-LOCATION
243700                 PERFORM Y920-WRITE-LOG-RECORD
243800                                 THRU Y929-WLR-EXIT
243900             ELSE
244000                 MOVE MS08-MC-POS-DC-02
244100                                 TO MMSM-MC-POS-DC-02.
244200*
244300 X219-EXIT.
244400     EXIT.
244500*
244600 X230-UPDATE-MC-POS-DC-03.
244700*
244800     IF  MS08-MC-POS-DC-03-L IS GREATER THAN ZERO
244900         IF  MS08-MC-POS-DC-03 IS NOT EQUAL TO
245000                                    MMSM-MC-POS-DC-03
245100             SET WS-UPDATE-MMSM-SW-YES
245200                                 TO TRUE
245300             IF  MBCA-PTI-FUNCTION-IS-MAINT
245400             AND MMSM-ADD-COMPLETED
245500                 MOVE MMSMTB-MC-POS-DC-03 (1:4)
245600                                 TO WS-INDEX-X
245700                 SET X-MMFS-STORE
245800                                 TO WS-INDEX
245900                 MOVE MMFS-ST-AUDIT-CODE (X-MMFS-STORE)
246000                                 TO MML1-MMSM-AUDIT-CODE
246100                 MOVE 0812       TO MML1-FIELD-CODE
246200                 MOVE ZEROES     TO MML1-FIELD-OCCURRENCE
246300                                    MML1-FIELD-OCCURRENCE-2
246400                 MOVE MML1WS-VL-01
246500                                 TO MML1-VARIABLE-LENGTH
246600                 MOVE MMSM-MC-POS-DC-03
246700                                 TO MML1-VL01-B-DATA-X
246800                 MOVE MS08-MC-POS-DC-03
246900                                 TO MMSM-MC-POS-DC-03
247000                 MOVE MMSM-MC-POS-DC-03
247100                                 TO MML1-VL01-A-DATA-X
247200                 MOVE 'FC13'     TO MBCA-PROGRAM-LOCATION
247300                 PERFORM Y920-WRITE-LOG-RECORD
247400                                 THRU Y929-WLR-EXIT
247500             ELSE
247600                 MOVE MS08-MC-POS-DC-03
247700                                 TO MMSM-MC-POS-DC-03.
247800*
247900 X239-EXIT.
248000     EXIT.
248100*
248200 X250-UPDATE-MC-POS-DC-04.
248300*
248400     IF  MS08-MC-POS-DC-04-L IS GREATER THAN ZERO
248500         IF  MS08-MC-POS-DC-04 IS NOT EQUAL TO
248600                                    MMSM-MC-POS-DC-04
248700             SET WS-UPDATE-MMSM-SW-YES
248800                                 TO TRUE
248900             IF  MBCA-PTI-FUNCTION-IS-MAINT
249000             AND MMSM-ADD-COMPLETED
249100                 MOVE MMSMTB-MC-POS-DC-04 (1:4)
249200                                 TO WS-INDEX-X
249300                 SET X-MMFS-STORE
249400                                 TO WS-INDEX
249500                 MOVE MMFS-ST-AUDIT-CODE (X-MMFS-STORE)
249600                                 TO MML1-MMSM-AUDIT-CODE
249700                 MOVE 0813       TO MML1-FIELD-CODE
249800                 MOVE ZEROES     TO MML1-FIELD-OCCURRENCE
249900                                    MML1-FIELD-OCCURRENCE-2
250000                 MOVE MML1WS-VL-01
250100                                 TO MML1-VARIABLE-LENGTH
250200                 MOVE MMSM-MC-POS-DC-04
250300                                 TO MML1-VL01-B-DATA-X
250400                 MOVE MS08-MC-POS-DC-04
250500                                 TO MMSM-MC-POS-DC-04
250600                 MOVE MMSM-MC-POS-DC-04
250700                                 TO MML1-VL01-A-DATA-X
250800                 MOVE 'FC13'     TO MBCA-PROGRAM-LOCATION
250900                 PERFORM Y920-WRITE-LOG-RECORD
251000                                 THRU Y929-WLR-EXIT
251100             ELSE
251200                 MOVE MS08-MC-POS-DC-04
251300                                 TO MMSM-MC-POS-DC-04.
251400*
251500 X259-EXIT.
251600     EXIT.
251700*
251800 X270-UPDATE-MC-POS-DC-05.
251900*
252000     IF  MS08-MC-POS-DC-05-L IS GREATER THAN ZERO
252100         IF  MS08-MC-POS-DC-05 IS NOT EQUAL TO
252200                                    MMSM-MC-POS-DC-05
252300             SET WS-UPDATE-MMSM-SW-YES
252400                                 TO TRUE
252500             IF  MBCA-PTI-FUNCTION-IS-MAINT
252600             AND MMSM-ADD-COMPLETED
252700                 MOVE MMSMTB-MC-POS-DC-05 (1:4)
252800                                 TO WS-INDEX-X
252900                 SET X-MMFS-STORE
253000                                 TO WS-INDEX
253100                 MOVE MMFS-ST-AUDIT-CODE (X-MMFS-STORE)
253200                                 TO MML1-MMSM-AUDIT-CODE
253300                 MOVE 0814       TO MML1-FIELD-CODE
253400                 MOVE ZEROES     TO MML1-FIELD-OCCURRENCE
253500                                    MML1-FIELD-OCCURRENCE-2
253600                 MOVE MML1WS-VL-01
253700                                 TO MML1-VARIABLE-LENGTH
253800                 MOVE MMSM-MC-POS-DC-05
253900                                 TO MML1-VL01-B-DATA-X
254000                 MOVE MS08-MC-POS-DC-05
254100                                 TO MMSM-MC-POS-DC-05
254200                 MOVE MMSM-MC-POS-DC-05
254300                                 TO MML1-VL01-A-DATA-X
254400                 MOVE 'FC13'     TO MBCA-PROGRAM-LOCATION
254500                 PERFORM Y920-WRITE-LOG-RECORD
254600                                 THRU Y929-WLR-EXIT
254700             ELSE
254800                 MOVE MS08-MC-POS-DC-05
254900                                 TO MMSM-MC-POS-DC-05.
255000*
255100 X279-EXIT.
255200     EXIT.
255300*
255400 X290-UPDATE-MC-POS-DC-06.
255500*
255600     IF  MS08-MC-POS-DC-06-L IS GREATER THAN ZERO
255700         IF  MS08-MC-POS-DC-06 IS NOT EQUAL TO
255800                                    MMSM-MC-POS-DC-06
255900             SET WS-UPDATE-MMSM-SW-YES
256000                                 TO TRUE
256100             IF  MBCA-PTI-FUNCTION-IS-MAINT
256200             AND MMSM-ADD-COMPLETED
256300                 MOVE MMSMTB-MC-POS-DC-06 (1:4)
256400                                 TO WS-INDEX-X
256500                 SET X-MMFS-STORE
256600                                 TO WS-INDEX
256700                 MOVE MMFS-ST-AUDIT-CODE (X-MMFS-STORE)
256800                                 TO MML1-MMSM-AUDIT-CODE
256900                 MOVE 0815       TO MML1-FIELD-CODE
257000                 MOVE ZEROES     TO MML1-FIELD-OCCURRENCE
257100                                    MML1-FIELD-OCCURRENCE-2
257200                 MOVE MML1WS-VL-01
257300                                 TO MML1-VARIABLE-LENGTH
257400                 MOVE MMSM-MC-POS-DC-06
257500                                 TO MML1-VL01-B-DATA-X
257600                 MOVE MS08-MC-POS-DC-06
257700                                 TO MMSM-MC-POS-DC-06
257800                 MOVE MMSM-MC-POS-DC-06
257900                                 TO MML1-VL01-A-DATA-X
258000                 MOVE 'FC13'     TO MBCA-PROGRAM-LOCATION
258100                 PERFORM Y920-WRITE-LOG-RECORD
258200                                 THRU Y929-WLR-EXIT
258300             ELSE
258400                 MOVE MS08-MC-POS-DC-06
258500                                 TO MMSM-MC-POS-DC-06.
258600*
258700 X299-EXIT.
258800     EXIT.
258900*
259000 X310-UPDATE-MC-POS-DC-07.
259100*
259200     IF  MS08-MC-POS-DC-07-L IS GREATER THAN ZERO
259300         IF  MS08-MC-POS-DC-07 IS NOT EQUAL TO
259400                                    MMSM-MC-POS-DC-07
259500             SET WS-UPDATE-MMSM-SW-YES
259600                                 TO TRUE
259700             IF  MBCA-PTI-FUNCTION-IS-MAINT
259800             AND MMSM-ADD-COMPLETED
259900                 MOVE MMSMTB-MC-POS-DC-07 (1:4)
260000                                 TO WS-INDEX-X
260100                 SET X-MMFS-STORE
260200                                 TO WS-INDEX
260300                 MOVE MMFS-ST-AUDIT-CODE (X-MMFS-STORE)
260400                                 TO MML1-MMSM-AUDIT-CODE
260500                 MOVE 0816       TO MML1-FIELD-CODE               RG800913
260600                 MOVE ZEROES     TO MML1-FIELD-OCCURRENCE
260700                                    MML1-FIELD-OCCURRENCE-2
260800                 MOVE MML1WS-VL-01
260900                                 TO MML1-VARIABLE-LENGTH
261000                 MOVE MMSM-MC-POS-DC-07
261100                                 TO MML1-VL01-B-DATA-X
261200                 MOVE MS08-MC-POS-DC-07
261300                                 TO MMSM-MC-POS-DC-07
261400                 MOVE MMSM-MC-POS-DC-07
261500                                 TO MML1-VL01-A-DATA-X
261600                 MOVE 'FC13'     TO MBCA-PROGRAM-LOCATION
261700                 PERFORM Y920-WRITE-LOG-RECORD
261800                                 THRU Y929-WLR-EXIT
261900             ELSE
262000                 MOVE MS08-MC-POS-DC-07
262100                                 TO MMSM-MC-POS-DC-07.
262200*
262300 X319-EXIT.
262400     EXIT.
262500*
262600 X330-UPDATE-MC-POS-DC-08.
262700*
262800     IF  MS08-MC-POS-DC-08-L IS GREATER THAN ZERO
262900         IF  MS08-MC-POS-DC-08 IS NOT EQUAL TO
263000                                    MMSM-MC-POS-DC-08
263100             SET WS-UPDATE-MMSM-SW-YES
263200                                 TO TRUE
263300             IF  MBCA-PTI-FUNCTION-IS-MAINT
263400             AND MMSM-ADD-COMPLETED
263500                 MOVE MMSMTB-MC-POS-DC-08 (1:4)
263600                                 TO WS-INDEX-X
263700                 SET X-MMFS-STORE
263800                                 TO WS-INDEX
263900                 MOVE MMFS-ST-AUDIT-CODE (X-MMFS-STORE)
264000                                 TO MML1-MMSM-AUDIT-CODE
264100                 MOVE 0817       TO MML1-FIELD-CODE               RG800913
264200                 MOVE ZEROES     TO MML1-FIELD-OCCURRENCE
264300                                    MML1-FIELD-OCCURRENCE-2
264400                 MOVE MML1WS-VL-01
264500                                 TO MML1-VARIABLE-LENGTH
264600                 MOVE MMSM-MC-POS-DC-08
264700                                 TO MML1-VL01-B-DATA-X
264800                 MOVE MS08-MC-POS-DC-08
264900                                 TO MMSM-MC-POS-DC-08
265000                 MOVE MMSM-MC-POS-DC-08
265100                                 TO MML1-VL01-A-DATA-X
265200                 MOVE 'FC13'     TO MBCA-PROGRAM-LOCATION
265300                 PERFORM Y920-WRITE-LOG-RECORD
265400                                 THRU Y929-WLR-EXIT
265500             ELSE
265600                 MOVE MS08-MC-POS-DC-08
265700                                 TO MMSM-MC-POS-DC-08.
265800*
265900 X339-EXIT.
266000     EXIT.
266100*
266200 X350-UPDATE-MC-POS-DC-09.
266300*
266400     IF  MS08-MC-POS-DC-09-L IS GREATER THAN ZERO
266500         IF  MS08-MC-POS-DC-09 IS NOT EQUAL TO
266600                                    MMSM-MC-POS-DC-09
266700             SET WS-UPDATE-MMSM-SW-YES
266800                                 TO TRUE
266900             IF  MBCA-PTI-FUNCTION-IS-MAINT
267000             AND MMSM-ADD-COMPLETED
267100                 MOVE MMSMTB-MC-POS-DC-09 (1:4)
267200                                 TO WS-INDEX-X
267300                 SET X-MMFS-STORE
267400                                 TO WS-INDEX
267500                 MOVE MMFS-ST-AUDIT-CODE (X-MMFS-STORE)
267600                                 TO MML1-MMSM-AUDIT-CODE
267700                 MOVE 0818       TO MML1-FIELD-CODE               RG800913
267800                 MOVE ZEROES     TO MML1-FIELD-OCCURRENCE
267900                                    MML1-FIELD-OCCURRENCE-2
268000                 MOVE MML1WS-VL-01
268100                                 TO MML1-VARIABLE-LENGTH
268200                 MOVE MMSM-MC-POS-DC-09
268300                                 TO MML1-VL01-B-DATA-X
268400                 MOVE MS08-MC-POS-DC-09
268500                                 TO MMSM-MC-POS-DC-09
268600                 MOVE MMSM-MC-POS-DC-09
268700                                 TO MML1-VL01-A-DATA-X
268800                 MOVE 'FC13'     TO MBCA-PROGRAM-LOCATION
268900                 PERFORM Y920-WRITE-LOG-RECORD
269000                                 THRU Y929-WLR-EXIT
269100             ELSE
269200                 MOVE MS08-MC-POS-DC-09
269300                                 TO MMSM-MC-POS-DC-09.
269400*
269500 X359-EXIT.
269600     EXIT.
269700*
269800 X370-UPDATE-MC-POS-DC-10.
269900*
270000     IF  MS08-MC-POS-DC-10-L IS GREATER THAN ZERO
270100         IF  MS08-MC-POS-DC-10 IS NOT EQUAL TO
270200                                    MMSM-MC-POS-DC-10
270300             SET WS-UPDATE-MMSM-SW-YES
270400                                 TO TRUE
270500             IF  MBCA-PTI-FUNCTION-IS-MAINT
270600             AND MMSM-ADD-COMPLETED
270700                 MOVE MMSMTB-MC-POS-DC-10 (1:4)
270800                                 TO WS-INDEX-X
270900                 SET X-MMFS-STORE
271000                                 TO WS-INDEX
271100                 MOVE MMFS-ST-AUDIT-CODE (X-MMFS-STORE)
271200                                 TO MML1-MMSM-AUDIT-CODE
271300                 MOVE 0819       TO MML1-FIELD-CODE               RG800913
271400                 MOVE ZEROES     TO MML1-FIELD-OCCURRENCE
271500                                    MML1-FIELD-OCCURRENCE-2
271600                 MOVE MML1WS-VL-01
271700                                 TO MML1-VARIABLE-LENGTH
271800                 MOVE MMSM-MC-POS-DC-10
271900                                 TO MML1-VL01-B-DATA-X
272000                 MOVE MS08-MC-POS-DC-10
272100                                 TO MMSM-MC-POS-DC-10
272200                 MOVE MMSM-MC-POS-DC-10
272300                                 TO MML1-VL01-A-DATA-X
272400                 MOVE 'FC13'     TO MBCA-PROGRAM-LOCATION
272500                 PERFORM Y920-WRITE-LOG-RECORD
272600                                 THRU Y929-WLR-EXIT
272700             ELSE
272800                 MOVE MS08-MC-POS-DC-10
272900                                 TO MMSM-MC-POS-DC-10.
273000*
273100 X379-EXIT.
273200     EXIT.
273300*
273400 X390-UPDATE-MC-POS-DC-11.
273500*
273600     IF  MS08-MC-POS-DC-11-L IS GREATER THAN ZERO
273700         IF  MS08-MC-POS-DC-11 IS NOT EQUAL TO
273800                                    MMSM-MC-POS-DC-11
273900             SET WS-UPDATE-MMSM-SW-YES
274000                                 TO TRUE
274100             IF  MBCA-PTI-FUNCTION-IS-MAINT
274200             AND MMSM-ADD-COMPLETED
274300                 MOVE MMSMTB-MC-POS-DC-11 (1:4)
274400                                 TO WS-INDEX-X
274500                 SET X-MMFS-STORE
274600                                 TO WS-INDEX
274700                 MOVE MMFS-ST-AUDIT-CODE (X-MMFS-STORE)
274800                                 TO MML1-MMSM-AUDIT-CODE
274900                 MOVE 0820       TO MML1-FIELD-CODE               RG800913
275000                 MOVE ZEROES     TO MML1-FIELD-OCCURRENCE
275100                                    MML1-FIELD-OCCURRENCE-2
275200                 MOVE MML1WS-VL-01
275300                                 TO MML1-VARIABLE-LENGTH
275400                 MOVE MMSM-MC-POS-DC-11
275500                                 TO MML1-VL01-B-DATA-X
275600                 MOVE MS08-MC-POS-DC-11
275700                                 TO MMSM-MC-POS-DC-11
275800                 MOVE MMSM-MC-POS-DC-11
275900                                 TO MML1-VL01-A-DATA-X
276000                 MOVE 'FC13'     TO MBCA-PROGRAM-LOCATION
276100                 PERFORM Y920-WRITE-LOG-RECORD
276200                                 THRU Y929-WLR-EXIT
276300             ELSE
276400                 MOVE MS08-MC-POS-DC-11
276500                                 TO MMSM-MC-POS-DC-11.
276600*
276700 X399-EXIT.
276800     EXIT.
276900*
277000 X410-UPDATE-MC-POS-DC-12.
277100*
277200     IF  MS08-MC-POS-DC-12-L IS GREATER THAN ZERO
277300         IF  MS08-MC-POS-DC-12 IS NOT EQUAL TO
277400                                    MMSM-MC-POS-DC-12
277500             SET WS-UPDATE-MMSM-SW-YES
277600                                 TO TRUE
277700             IF  MBCA-PTI-FUNCTION-IS-MAINT
277800             AND MMSM-ADD-COMPLETED
277900                 MOVE MMSMTB-MC-POS-DC-12 (1:4)
278000                                 TO WS-INDEX-X
278100                 SET X-MMFS-STORE
278200                                 TO WS-INDEX
278300                 MOVE MMFS-ST-AUDIT-CODE (X-MMFS-STORE)
278400                                 TO MML1-MMSM-AUDIT-CODE
278500                 MOVE 0821       TO MML1-FIELD-CODE               RG800913
278600                 MOVE ZEROES     TO MML1-FIELD-OCCURRENCE
278700                                    MML1-FIELD-OCCURRENCE-2
278800                 MOVE MML1WS-VL-01
278900                                 TO MML1-VARIABLE-LENGTH
279000                 MOVE MMSM-MC-POS-DC-12
279100                                 TO MML1-VL01-B-DATA-X
279200                 MOVE MS08-MC-POS-DC-12
279300                                 TO MMSM-MC-POS-DC-12
279400                 MOVE MMSM-MC-POS-DC-12
279500                                 TO MML1-VL01-A-DATA-X
279600                 MOVE 'FC13'     TO MBCA-PROGRAM-LOCATION
279700                 PERFORM Y920-WRITE-LOG-RECORD
279800                                 THRU Y929-WLR-EXIT
279900             ELSE
280000                 MOVE MS08-MC-POS-DC-12
280100                                 TO MMSM-MC-POS-DC-12.
280200*
280300 X419-EXIT.
280400     EXIT.
280500/
280600 Y000-PERFORMED-ROUTINES SECTION.
280700*
280800 Y010-MOVE-DBA-NAME.
280900*
281000     MOVE MMSM-MC-DBA-NAME       TO MS08-MC-DBA-NAME.
281100*
281200 Y015-DBA-NAME-SECURITY.
281300*
281400     MOVE MMSMTB-MC-DBA-NAME (1:4)
281500                                 TO WS-INDEX-X.
281600     SET  X-MMFS-STORE           TO WS-INDEX.
281700*
281800     IF  MMFS-ST-NO-ACCESS (X-MMFS-STORE)
281900         MOVE DFHBMDAS           TO MS08-MC-DBA-NAME-LIT-A
282000                                    MS08-MC-DBA-NAME-LP-A
282100                                    MS08-MC-DBA-NAME-RP-A
282200                                    MS08-MC-DBA-NAME-A
282300         MOVE ZERO               TO MS08-MC-DBA-NAME-L
282400         GO TO Y019-EXIT.
282500*
282600     IF  MBCA-PTI-FUNCTION-IS-INQUIRY
282700         MOVE DFHBMDAS           TO MS08-MC-DBA-NAME-LP-A
282800                                    MS08-MC-DBA-NAME-RP-A
282900         MOVE DFHBMASB           TO MS08-MC-DBA-NAME-A
283000         GO TO Y019-EXIT.
283100*
283200     IF  MMFS-ST-INQ-ONLY (X-MMFS-STORE)
283300         MOVE ZERO               TO MS08-MC-DBA-NAME-L
283400         MOVE DFHBMDAS           TO MS08-MC-DBA-NAME-LP-A
283500                                    MS08-MC-DBA-NAME-RP-A
283600         MOVE DFHBMASK           TO MS08-MC-DBA-NAME-A
283700         GO TO Y019-EXIT.
283800*
283900     IF  MBCA-PTI-FUNCTION-IS-ADD
284000         IF  MMFS-ST-REQUIRED (X-MMFS-STORE)
284100             MOVE DFHBMASB       TO MS08-MC-DBA-NAME-LIT-A
284200         ELSE
284300             IF  MMFS-ST-MAINT-ONLY (X-MMFS-STORE)
284400                 MOVE ZERO       TO MS08-MC-DBA-NAME-L
284500                 MOVE DFHBMDAS   TO MS08-MC-DBA-NAME-LP-A
284600                                    MS08-MC-DBA-NAME-RP-A
284700                 MOVE DFHBMASK   TO MS08-MC-DBA-NAME-A.
284800*
284900     IF  MBCA-PTI-FUNCTION-IS-MAINT
285000         IF  MMFS-ST-NO-MAINT (X-MMFS-STORE)
285100             MOVE ZERO           TO MS08-MC-DBA-NAME-L
285200             MOVE DFHBMDAS       TO MS08-MC-DBA-NAME-LP-A
285300                                    MS08-MC-DBA-NAME-RP-A
285400             MOVE DFHBMASK       TO MS08-MC-DBA-NAME-A.
285500*
285600 Y019-EXIT.
285700     EXIT.
285800*
285900 Y030-MOVE-CIRRUS-IND.
286000*
286100     MOVE MMSM-MC-CIRRUS-IND     TO MS08-MC-CIRRUS-IND.
286200*
286300 Y035-CIRRUS-IND-SECURITY.
286400*
286500     MOVE MMSMTB-MC-CIRRUS-IND (1:4)
286600                                 TO WS-INDEX-X.
286700     SET  X-MMFS-STORE           TO WS-INDEX.
286800*
286900     IF  MMFS-ST-NO-ACCESS (X-MMFS-STORE)
287000         MOVE DFHBMDAS           TO MS08-MC-CIRRUS-IND-LIT-A
287100                                    MS08-MC-CIRRUS-IND-LP-A
287200                                    MS08-MC-CIRRUS-IND-RP-A
287300                                    MS08-MC-CIRRUS-IND-A
287400         MOVE ZERO               TO MS08-MC-CIRRUS-IND-L
287500         GO TO Y039-EXIT.
287600*
287700     IF  MBCA-PTI-FUNCTION-IS-INQUIRY
287800         MOVE DFHBMDAS           TO MS08-MC-CIRRUS-IND-LP-A
287900                                    MS08-MC-CIRRUS-IND-RP-A
288000         MOVE DFHBMASB           TO MS08-MC-CIRRUS-IND-A
288100         GO TO Y039-EXIT.
288200*
288300     IF  MMFS-ST-INQ-ONLY (X-MMFS-STORE)
288400         MOVE ZERO               TO MS08-MC-CIRRUS-IND-L
288500         MOVE DFHBMDAS           TO MS08-MC-CIRRUS-IND-LP-A
288600                                    MS08-MC-CIRRUS-IND-RP-A
288700         MOVE DFHBMASK           TO MS08-MC-CIRRUS-IND-A
288800         GO TO Y039-EXIT.
288900*
289000     IF  MBCA-PTI-FUNCTION-IS-ADD
289100         IF  MMFS-ST-REQUIRED (X-MMFS-STORE)
289200             MOVE DFHBMASB       TO MS08-MC-CIRRUS-IND-LIT-A
289300         ELSE
289400             IF  MMFS-ST-MAINT-ONLY (X-MMFS-STORE)
289500                 MOVE ZERO       TO MS08-MC-CIRRUS-IND-L
289600                 MOVE DFHBMDAS   TO MS08-MC-CIRRUS-IND-LP-A
289700                                    MS08-MC-CIRRUS-IND-RP-A
289800                 MOVE DFHBMASK   TO MS08-MC-CIRRUS-IND-A.
289900*
290000     IF  MBCA-PTI-FUNCTION-IS-MAINT
290100         IF  MMFS-ST-NO-MAINT (X-MMFS-STORE)
290200             MOVE ZERO           TO MS08-MC-CIRRUS-IND-L
290300             MOVE DFHBMDAS       TO MS08-MC-CIRRUS-IND-LP-A
290400                                    MS08-MC-CIRRUS-IND-RP-A
290500             MOVE DFHBMASK       TO MS08-MC-CIRRUS-IND-A.
290600*
290700 Y039-EXIT.
290800     EXIT.
290900*
291000 Y050-MOVE-INTCHG-IND.
291100*
291200     MOVE MMSM-MC-INTCHG-FLAG    TO MS08-MC-INTCHG-FLAG.
291300*
291400 Y055-INTCHG-FLAG-SECURITY.
291500*
291600     MOVE MMSMTB-MC-INTCHG-IND (1:4)
291700                                 TO WS-INDEX-X.
291800     SET  X-MMFS-STORE           TO WS-INDEX.
291900*
292000     IF  MMFS-ST-NO-ACCESS (X-MMFS-STORE)
292100         MOVE DFHBMDAS           TO MS08-MC-INTCHG-FLAG-LP-A
292200                                    MS08-MC-INTCHG-FLAG-RP-A
292300                                    MS08-MC-INTCHG-FLAG-A
292400         MOVE ZERO               TO MS08-MC-INTCHG-FLAG-L
292500         GO TO Y059-EXIT.
292600*
292700     IF  MBCA-PTI-FUNCTION-IS-INQUIRY
292800         MOVE DFHBMDAS           TO MS08-MC-INTCHG-FLAG-LP-A
292900                                    MS08-MC-INTCHG-FLAG-RP-A
293000         MOVE DFHBMASB           TO MS08-MC-INTCHG-FLAG-A
293100         GO TO Y059-EXIT.
293200*
293300     IF  MMFS-ST-INQ-ONLY (X-MMFS-STORE)
293400         MOVE ZERO               TO MS08-MC-INTCHG-FLAG-L
293500         MOVE DFHBMDAS           TO MS08-MC-INTCHG-FLAG-LP-A
293600                                    MS08-MC-INTCHG-FLAG-RP-A
293700         MOVE DFHBMASK           TO MS08-MC-INTCHG-FLAG-A
293800         GO TO Y059-EXIT.
293900*
294000     IF  MBCA-PTI-FUNCTION-IS-ADD
294100         IF  MMFS-ST-REQUIRED (X-MMFS-STORE)
294200             MOVE DFHBMASB       TO MS08-MC-INTCHG-FLAG-LIT-A
294300         ELSE
294400             IF  MMFS-ST-MAINT-ONLY (X-MMFS-STORE)
294500                 MOVE ZERO       TO MS08-MC-INTCHG-FLAG-L
294600                 MOVE DFHBMDAS   TO MS08-MC-INTCHG-FLAG-LP-A
294700                                    MS08-MC-INTCHG-FLAG-RP-A
294800                 MOVE DFHBMASK   TO MS08-MC-INTCHG-FLAG-A.
294900*
295000     IF  MBCA-PTI-FUNCTION-IS-MAINT
295100         IF  MMFS-ST-NO-MAINT (X-MMFS-STORE)
295200             MOVE ZERO           TO MS08-MC-INTCHG-FLAG-L
295300             MOVE DFHBMDAS       TO MS08-MC-INTCHG-FLAG-LP-A
295400                                    MS08-MC-INTCHG-FLAG-RP-A
295500             MOVE DFHBMASK       TO MS08-MC-INTCHG-FLAG-A.
295600*
295700 Y059-EXIT.
295800     EXIT.
295900*
296000 Y070-MOVE-BUS-CLASS-CODE.
296100*
296200     MOVE MMSM-MC-BUSINESS-CLASS TO MS08-MC-BUS-CLASS-CODE.
296300*
296400     IF  MBCA-MBMS-EUROPAY-ON
296500         MOVE DFHBMDAS           TO MS08-MC-BUS-CLASS-CODE-LP-A
296600                                    MS08-MC-BUS-CLASS-CODE-RP-A
296700                                    MS08-MC-BUS-CLASS-CODE-A
296800                                    MS08-MC-BUS-CLASS-CODE-LIT-A
296900         GO TO Y079-EXIT.
297000*
297100 Y075-BUS-CLASS-CODE-SECURITY.
297200*
297300     MOVE MMSMTB-MC-BUSINESS-CLASS (1:4)
297400                                 TO WS-INDEX-X.
297500     SET  X-MMFS-STORE           TO WS-INDEX.
297600*
297700     IF  MMFS-ST-NO-ACCESS (X-MMFS-STORE)
297800         MOVE DFHBMDAS           TO MS08-MC-BUS-CLASS-CODE-LP-A
297900                                    MS08-MC-BUS-CLASS-CODE-RP-A
298000                                    MS08-MC-BUS-CLASS-CODE-A
298100         MOVE ZERO               TO MS08-MC-BUS-CLASS-CODE-L
298200         GO TO Y079-EXIT.
298300*
298400     IF  MBCA-PTI-FUNCTION-IS-INQUIRY
298500         MOVE DFHBMDAS           TO MS08-MC-BUS-CLASS-CODE-LP-A
298600                                    MS08-MC-BUS-CLASS-CODE-RP-A
298700         MOVE DFHBMASB           TO MS08-MC-BUS-CLASS-CODE-A
298800         GO TO Y079-EXIT.
298900*
299000     IF  MMFS-ST-INQ-ONLY (X-MMFS-STORE)
299100         MOVE ZERO               TO MS08-MC-BUS-CLASS-CODE-L
299200         MOVE DFHBMDAS           TO MS08-MC-BUS-CLASS-CODE-LP-A
299300                                    MS08-MC-BUS-CLASS-CODE-RP-A
299400         MOVE DFHBMASK           TO MS08-MC-BUS-CLASS-CODE-A
299500         GO TO Y079-EXIT.
299600*
299700     IF  MBCA-PTI-FUNCTION-IS-ADD
299800         IF  MMFS-ST-REQUIRED (X-MMFS-STORE)
299900             MOVE DFHBMASB       TO MS08-MC-BUS-CLASS-CODE-LIT-A
300000         ELSE
300100             IF  MMFS-ST-MAINT-ONLY (X-MMFS-STORE)
300200                 MOVE ZERO       TO MS08-MC-BUS-CLASS-CODE-L
300300                 MOVE DFHBMDAS   TO MS08-MC-BUS-CLASS-CODE-LP-A
300400                                    MS08-MC-BUS-CLASS-CODE-RP-A
300500                 MOVE DFHBMASK   TO MS08-MC-BUS-CLASS-CODE-A.
300600*
300700     IF  MBCA-PTI-FUNCTION-IS-MAINT
300800         IF  MMFS-ST-NO-MAINT (X-MMFS-STORE)
300900             MOVE ZERO           TO MS08-MC-BUS-CLASS-CODE-L
301000             MOVE DFHBMDAS       TO MS08-MC-BUS-CLASS-CODE-LP-A
301100                                    MS08-MC-BUS-CLASS-CODE-RP-A
301200             MOVE DFHBMASK       TO MS08-MC-BUS-CLASS-CODE-A.
301300*
301400 Y079-EXIT.
301500     EXIT.
301600*
301700 Y130-MOVE-CATEGORY-CODE.
301800*
301900     MOVE MMSM-MC-CATEGORY-CODE
302000                                 TO MS08-MC-CATEGORY-CODE.
302100*
302200 Y135-CATEGORY-CODE-SECURITY.
302300*
302400     MOVE MMSMTB-MC-CATEGORY-CODE (1:4)
302500                                 TO WS-INDEX-X.
302600     SET  X-MMFS-STORE           TO WS-INDEX.
302700*
302800     IF  MMFS-ST-NO-ACCESS (X-MMFS-STORE)
302900         MOVE DFHBMDAS           TO MS08-MC-CATEGORY-CODE-LIT-A
303000                                    MS08-MC-CATEGORY-CODE-LP-A
303100                                    MS08-MC-CATEGORY-CODE-RP-A
303200                                    MS08-MC-CATEGORY-CODE-A
303300         MOVE ZERO               TO MS08-MC-CATEGORY-CODE-L
303400         GO TO Y139-EXIT.
303500*
303600     IF  MBCA-PTI-FUNCTION-IS-INQUIRY
303700         MOVE DFHBMDAS           TO MS08-MC-CATEGORY-CODE-LP-A
303800                                    MS08-MC-CATEGORY-CODE-RP-A
303900         MOVE DFHBMASB           TO MS08-MC-CATEGORY-CODE-A
304000         GO TO Y139-EXIT.
304100*
304200     IF  MMFS-ST-INQ-ONLY (X-MMFS-STORE)
304300         MOVE ZERO               TO MS08-MC-CATEGORY-CODE-L
304400         MOVE DFHBMDAS           TO MS08-MC-CATEGORY-CODE-LP-A
304500                                    MS08-MC-CATEGORY-CODE-RP-A
304600         MOVE DFHBMASK           TO MS08-MC-CATEGORY-CODE-A
304700         GO TO Y139-EXIT.
304800*
304900     IF  MBCA-PTI-FUNCTION-IS-ADD
305000         IF  MMFS-ST-REQUIRED (X-MMFS-STORE)
305100             MOVE DFHBMASB       TO MS08-MC-CATEGORY-CODE-LIT-A
305200         ELSE
305300             IF  MMFS-ST-MAINT-ONLY (X-MMFS-STORE)
305400                 MOVE ZERO       TO MS08-MC-CATEGORY-CODE-L
305500                 MOVE DFHBMDAS   TO MS08-MC-CATEGORY-CODE-LP-A
305600                                    MS08-MC-CATEGORY-CODE-RP-A
305700                 MOVE DFHBMASK   TO MS08-MC-CATEGORY-CODE-A.
305800*
305900     IF  MBCA-PTI-FUNCTION-IS-MAINT
306000         IF  MMFS-ST-NO-MAINT (X-MMFS-STORE)
306100             MOVE ZERO           TO MS08-MC-CATEGORY-CODE-L
306200             MOVE DFHBMDAS       TO MS08-MC-CATEGORY-CODE-LP-A
306300                                    MS08-MC-CATEGORY-CODE-RP-A
306400             MOVE DFHBMASK       TO MS08-MC-CATEGORY-CODE-A.
306500*
306600 Y139-EXIT.
306700     EXIT.
306800*
306900 Y150-MOVE-FLOOR-LIMIT.
307000*
307100     MOVE MMSM-MC-FLOOR-LIMIT    TO MS08-MC-FLOOR-LIMIT.
307200*
307300 Y155-FLOOR-LIMIT-SECURITY.
307400*
307500     MOVE MMSMTB-MC-FLOOR-LIMIT (1:4)
307600                                 TO WS-INDEX-X.
307700     SET  X-MMFS-STORE           TO WS-INDEX.
307800*
307900     IF  MMFS-ST-NO-ACCESS (X-MMFS-STORE)
308000         MOVE DFHBMDAS           TO MS08-MC-FLOOR-LIMIT-LIT-A
308100                                    MS08-MC-FLOOR-LIMIT-LP-A
308200                                    MS08-MC-FLOOR-LIMIT-RP-A
308300                                    MS08-MC-FLOOR-LIMIT-A
308400         MOVE ZERO               TO MS08-MC-FLOOR-LIMIT-L
308500         GO TO Y159-EXIT.
308600*
308700     IF  MBCA-PTI-FUNCTION-IS-INQUIRY
308800         MOVE DFHBMDAS           TO MS08-MC-FLOOR-LIMIT-LP-A
308900                                    MS08-MC-FLOOR-LIMIT-RP-A
309000         MOVE DFHBMASB           TO MS08-MC-FLOOR-LIMIT-A
309100         GO TO Y159-EXIT.
309200*
309300     IF  MMFS-ST-INQ-ONLY (X-MMFS-STORE)
309400         MOVE ZERO               TO MS08-MC-FLOOR-LIMIT-L
309500         MOVE DFHBMDAS           TO MS08-MC-FLOOR-LIMIT-LP-A
309600                                    MS08-MC-FLOOR-LIMIT-RP-A
309700         MOVE DFHBMASK           TO MS08-MC-FLOOR-LIMIT-A
309800         GO TO Y159-EXIT.
309900*
310000     IF  MBCA-PTI-FUNCTION-IS-ADD
310100         IF  MMFS-ST-REQUIRED (X-MMFS-STORE)
310200             MOVE DFHBMASB       TO MS08-MC-FLOOR-LIMIT-LIT-A
310300         ELSE
310400             IF  MMFS-ST-MAINT-ONLY (X-MMFS-STORE)
310500                 MOVE ZERO       TO MS08-MC-FLOOR-LIMIT-L
310600                 MOVE DFHBMDAS   TO MS08-MC-FLOOR-LIMIT-LP-A
310700                                    MS08-MC-FLOOR-LIMIT-RP-A
310800                 MOVE DFHBMASK   TO MS08-MC-FLOOR-LIMIT-A.
310900*
311000     IF  MBCA-PTI-FUNCTION-IS-MAINT
311100         IF  MMFS-ST-NO-MAINT (X-MMFS-STORE)
311200             MOVE ZERO           TO MS08-MC-FLOOR-LIMIT-L
311300             MOVE DFHBMDAS       TO MS08-MC-FLOOR-LIMIT-LP-A
311400                                    MS08-MC-FLOOR-LIMIT-RP-A
311500             MOVE DFHBMASK       TO MS08-MC-FLOOR-LIMIT-A.
311600*
311700 Y159-EXIT.
311800     EXIT.
311900*
312000 Y170-MOVE-MC-CH-TERM-IND.
312100*
312200     MOVE MMSM-MC-CH-TERM-IND    TO MS08-MC-CH-TERM-IND.
312300*
312400     IF  MBCA-MBMS-EUROPAY-ON
312500         MOVE DFHBMDAS           TO MS08-MC-CH-TERM-IND-LP-A
312600                                    MS08-MC-CH-TERM-IND-RP-A
312700                                    MS08-MC-CH-TERM-IND-A
312800                                    MS08-MC-CH-TERM-IND-LIT-A
312900         GO TO Y179-EXIT.
313000*
313100 Y175-MC-CH-TERM-IND-SECURITY.
313200*
313300     MOVE MMSMTB-MC-CH-TERM-IND (1:4)
313400                                 TO WS-INDEX-X.
313500     SET  X-MMFS-STORE           TO WS-INDEX.
313600*
313700     IF  MMFS-ST-NO-ACCESS (X-MMFS-STORE)
313800         MOVE DFHBMDAS           TO MS08-MC-CH-TERM-IND-LP-A
313900                                    MS08-MC-CH-TERM-IND-RP-A
314000                                    MS08-MC-CH-TERM-IND-A
314100         MOVE ZERO               TO MS08-MC-CH-TERM-IND-L
314200         GO TO Y179-EXIT.
314300*
314400     IF  MBCA-PTI-FUNCTION-IS-INQUIRY
314500         MOVE DFHBMDAS           TO MS08-MC-CH-TERM-IND-LP-A
314600                                    MS08-MC-CH-TERM-IND-RP-A
314700         MOVE DFHBMASB           TO MS08-MC-CH-TERM-IND-A
314800         GO TO Y179-EXIT.
314900*
315000     IF  MMFS-ST-INQ-ONLY (X-MMFS-STORE)
315100         MOVE ZERO               TO MS08-MC-CH-TERM-IND-L
315200         MOVE DFHBMDAS           TO MS08-MC-CH-TERM-IND-LP-A
315300                                    MS08-MC-CH-TERM-IND-RP-A
315400         MOVE DFHBMASK           TO MS08-MC-CH-TERM-IND-A
315500         GO TO Y179-EXIT.
315600*
315700     IF  MBCA-PTI-FUNCTION-IS-ADD
315800         IF  MMFS-ST-REQUIRED (X-MMFS-STORE)
315900             MOVE DFHBMASB       TO MS08-MC-CH-TERM-IND-LIT-A
316000         ELSE
316100             IF  MMFS-ST-MAINT-ONLY (X-MMFS-STORE)
316200                 MOVE ZERO       TO MS08-MC-CH-TERM-IND-L
316300                 MOVE DFHBMDAS   TO MS08-MC-CH-TERM-IND-LP-A
316400                                    MS08-MC-CH-TERM-IND-RP-A
316500                 MOVE DFHBMASK   TO MS08-MC-CH-TERM-IND-A.
316600*
316700     IF  MBCA-PTI-FUNCTION-IS-MAINT
316800         IF  MMFS-ST-NO-MAINT (X-MMFS-STORE)
316900             MOVE ZERO           TO MS08-MC-CH-TERM-IND-L
317000             MOVE DFHBMDAS       TO MS08-MC-CH-TERM-IND-LP-A
317100                                    MS08-MC-CH-TERM-IND-RP-A
317200             MOVE DFHBMASK       TO MS08-MC-CH-TERM-IND-A.
317300*
317400 Y179-EXIT.
317500     EXIT.
317502*                                                                 RG800913
317504 Y180-MOVE-ASSIGNED-ID.                                           RG800913
317506*                                                                 RG800913
317508     MOVE MMSM-MC-ASSIGNED-ID    TO MS08-MC-ASSIGNED-ID.          RG800913
317510*                                                                 RG800913
317512     IF  MBCA-MBMS-EUROPAY-ON                                     RG800913
317514         MOVE DFHBMDAS           TO MS08-MC-ASSIGNED-ID-LP-A      FX800061
317516                                    MS08-MC-ASSIGNED-ID-RP-A      FX800061
317518                                    MS08-MC-ASSIGNED-ID-A         FX800061
317520                                    MS08-MC-ASSIGNED-ID-LIT-A     FX800061
317522         GO TO Y189-EXIT.                                         RG800913
317524*                                                                 RG800913
317526 Y185-ASSIGNED-ID.                                                RG800913
317528*                                                                 RG800913
317530     MOVE MMSMTB-MC-ASSIGNED-ID (1:4)                             RG800913
317532                                 TO WS-INDEX-X.                   RG800913
317534     SET  X-MMFS-STORE           TO WS-INDEX.                     RG800913
317536*                                                                 RG800913
317538     IF  MMFS-ST-NO-ACCESS (X-MMFS-STORE)                         RG800913
317540         MOVE DFHBMDAS           TO MS08-MC-ASSIGNED-ID-LIT-A     RG800913
317542                                    MS08-MC-ASSIGNED-ID-LP-A      RG800913
317544                                    MS08-MC-ASSIGNED-ID-RP-A      RG800913
317546                                    MS08-MC-ASSIGNED-ID-A         RG800913
317548         MOVE ZERO               TO MS08-MC-ASSIGNED-ID-L         RG800913
317550         GO TO Y189-EXIT.                                         RG800913
317552*                                                                 RG800913
317554     IF  MBCA-PTI-FUNCTION-IS-INQUIRY                             RG800913
317556         MOVE DFHBMDAS           TO MS08-MC-ASSIGNED-ID-LP-A      RG800913
317558                                    MS08-MC-ASSIGNED-ID-RP-A      RG800913
317560         MOVE DFHBMASB           TO MS08-MC-ASSIGNED-ID-A         RG800913
317562         GO TO Y189-EXIT.                                         RG800913
317564*                                                                 RG800913
317566     IF  MMFS-ST-INQ-ONLY (X-MMFS-STORE)                          RG800913
317568         MOVE ZERO               TO MS08-MC-ASSIGNED-ID-L         RG800913
317570         MOVE DFHBMDAS           TO MS08-MC-ASSIGNED-ID-LP-A      RG800913
317572                                    MS08-MC-ASSIGNED-ID-RP-A      RG800913
317574         MOVE DFHBMASK           TO MS08-MC-ASSIGNED-ID-A         RG800913
317576         GO TO Y189-EXIT.                                         RG800913
317578*                                                                 RG800913
317580     IF  MBCA-PTI-FUNCTION-IS-ADD                                 RG800913
317582         IF  MMFS-ST-REQUIRED (X-MMFS-STORE)                      RG800913
317584             MOVE DFHBMASB       TO MS08-MC-ASSIGNED-ID-LIT-A     RG800913
317586         ELSE                                                     RG800913
317588             IF  MMFS-ST-MAINT-ONLY (X-MMFS-STORE)                RG800913
317590                 MOVE ZERO       TO MS08-MC-ASSIGNED-ID-L         RG800913
317592                 MOVE DFHBMDAS   TO MS08-MC-ASSIGNED-ID-LP-A      RG800913
317594                                    MS08-MC-ASSIGNED-ID-RP-A      RG800913
317596                 MOVE DFHBMASK   TO MS08-MC-ASSIGNED-ID-A.        RG800913
317598*                                                                 RG800913
317600     IF  MBCA-PTI-FUNCTION-IS-MAINT                               RG800913
317602         IF  MMFS-ST-NO-MAINT (X-MMFS-STORE)                      RG800913
317604             MOVE ZERO           TO MS08-MC-ASSIGNED-ID-L         RG800913
317606             MOVE DFHBMDAS       TO MS08-MC-ASSIGNED-ID-LP-A      RG800913
317608                                    MS08-MC-ASSIGNED-ID-RP-A      RG800913
317610             MOVE DFHBMASK       TO MS08-MC-ASSIGNED-ID-A.        RG800913
317612*                                                                 RG800913
317614 Y189-EXIT.                                                       RG800913
317616     EXIT.                                                        RG800913
317699*                                                                 RG800913
317700 Y190-MOVE-MC-POS-DC-01.
317800*
317900     MOVE MMSM-MC-POS-DC-01      TO MS08-MC-POS-DC-01.
318000*
318100 Y195-POS-DC-01-SECURITY.
318200*
318300     MOVE MMSMTB-MC-POS-DC-01 (1:4)
318400                                 TO WS-INDEX-X.
318500     SET  X-MMFS-STORE           TO WS-INDEX.
318600*
318700     IF  MMFS-ST-NO-ACCESS (X-MMFS-STORE)
318800         MOVE DFHBMDAS           TO MS08-MC-POS-DC-01-LP-A
318900                                    MS08-MC-POS-DC-01-RP-A
319000                                    MS08-MC-POS-DC-01-A
319100         MOVE ZERO               TO MS08-MC-POS-DC-01-L
319200         GO TO Y199-EXIT.
319300*
319400     IF  MBCA-PTI-FUNCTION-IS-INQUIRY
319500         MOVE DFHBMDAS           TO MS08-MC-POS-DC-01-LP-A
319600                                    MS08-MC-POS-DC-01-RP-A
319700         MOVE DFHBMASB           TO MS08-MC-POS-DC-01-A
319800         GO TO Y199-EXIT.
319900*
320000     IF  MMFS-ST-INQ-ONLY (X-MMFS-STORE)
320100         MOVE ZERO               TO MS08-MC-POS-DC-01-L
320200         MOVE DFHBMDAS           TO MS08-MC-POS-DC-01-LP-A
320300                                    MS08-MC-POS-DC-01-RP-A
320400         MOVE DFHBMASK           TO MS08-MC-POS-DC-01-A
320500         GO TO Y199-EXIT.
320600*
320700     IF  MBCA-PTI-FUNCTION-IS-ADD
320800         IF  MMFS-ST-REQUIRED (X-MMFS-STORE)
320900             MOVE DFHBMASB       TO MS08-MC-POS-DC-DESC-LIT-A
321000         ELSE
321100             IF  MMFS-ST-MAINT-ONLY (X-MMFS-STORE)
321200                 MOVE ZERO       TO MS08-MC-POS-DC-01-L
321300                 MOVE DFHBMDAS   TO MS08-MC-POS-DC-01-LP-A
321400                                    MS08-MC-POS-DC-01-RP-A
321500                 MOVE DFHBMASK   TO MS08-MC-POS-DC-01-A.
321600*
321700     IF  MBCA-PTI-FUNCTION-IS-MAINT
321800         IF  MMFS-ST-NO-MAINT (X-MMFS-STORE)
321900             MOVE ZERO           TO MS08-MC-POS-DC-01-L
322000             MOVE DFHBMDAS       TO MS08-MC-POS-DC-01-LP-A
322100                                    MS08-MC-POS-DC-01-RP-A
322200             MOVE DFHBMASK       TO MS08-MC-POS-DC-01-A.
322300*
322400 Y199-EXIT.
322500     EXIT.
322600*
322700 Y210-MOVE-MC-POS-DC-02.
322800*
322900     MOVE MMSM-MC-POS-DC-02      TO MS08-MC-POS-DC-02.
323000*
323100 Y215-POS-DC-02-SECURITY.
323200*
323300     MOVE MMSMTB-MC-POS-DC-02 (1:4)
323400                                 TO WS-INDEX-X.
323500     SET  X-MMFS-STORE           TO WS-INDEX.
323600*
323700     IF  MMFS-ST-NO-ACCESS (X-MMFS-STORE)
323800         MOVE DFHBMDAS           TO MS08-MC-POS-DC-02-LP-A
323900                                    MS08-MC-POS-DC-02-RP-A
324000                                    MS08-MC-POS-DC-02-A
324100         MOVE ZERO               TO MS08-MC-POS-DC-02-L
324200         GO TO Y219-EXIT.
324300*
324400     IF  MBCA-PTI-FUNCTION-IS-INQUIRY
324500         MOVE DFHBMDAS           TO MS08-MC-POS-DC-02-LP-A
324600                                    MS08-MC-POS-DC-02-RP-A
324700         MOVE DFHBMASB           TO MS08-MC-POS-DC-02-A
324800         GO TO Y219-EXIT.
324900*
325000     IF  MMFS-ST-INQ-ONLY (X-MMFS-STORE)
325100         MOVE ZERO               TO MS08-MC-POS-DC-02-L
325200         MOVE DFHBMDAS           TO MS08-MC-POS-DC-02-LP-A
325300                                    MS08-MC-POS-DC-02-RP-A
325400         MOVE DFHBMASK           TO MS08-MC-POS-DC-02-A
325500         GO TO Y219-EXIT.
325600*
325700     IF  MBCA-PTI-FUNCTION-IS-ADD
325800         IF  MMFS-ST-REQUIRED (X-MMFS-STORE)
325900             MOVE DFHBMASB       TO MS08-MC-POS-DC-DESC-LIT-A
326000         ELSE
326100             IF  MMFS-ST-MAINT-ONLY (X-MMFS-STORE)
326200                 MOVE ZERO       TO MS08-MC-POS-DC-02-L
326300                 MOVE DFHBMDAS   TO MS08-MC-POS-DC-02-LP-A
326400                                    MS08-MC-POS-DC-02-RP-A
326500                 MOVE DFHBMASK   TO MS08-MC-POS-DC-02-A.
326600*
326700     IF  MBCA-PTI-FUNCTION-IS-MAINT
326800         IF  MMFS-ST-NO-MAINT (X-MMFS-STORE)
326900             MOVE ZERO           TO MS08-MC-POS-DC-02-L
327000             MOVE DFHBMDAS       TO MS08-MC-POS-DC-02-LP-A
327100                                    MS08-MC-POS-DC-02-RP-A
327200             MOVE DFHBMASK       TO MS08-MC-POS-DC-02-A.
327300*
327400 Y219-EXIT.
327500     EXIT.
327600*
327700 Y230-MOVE-MC-POS-DC-03.
327800*
327900     MOVE MMSM-MC-POS-DC-03      TO MS08-MC-POS-DC-03.
328000*
328100 Y235-POS-DC-03-SECURITY.
328200*
328300     MOVE MMSMTB-MC-POS-DC-03 (1:4)
328400                                 TO WS-INDEX-X.
328500     SET  X-MMFS-STORE           TO WS-INDEX.
328600*
328700     IF  MMFS-ST-NO-ACCESS (X-MMFS-STORE)
328800         MOVE DFHBMDAS           TO MS08-MC-POS-DC-03-LP-A
328900                                    MS08-MC-POS-DC-03-RP-A
329000                                    MS08-MC-POS-DC-03-A
329100         MOVE ZERO               TO MS08-MC-POS-DC-03-L
329200         GO TO Y239-EXIT.
329300*
329400     IF  MBCA-PTI-FUNCTION-IS-INQUIRY
329500         MOVE DFHBMDAS           TO MS08-MC-POS-DC-03-LP-A
329600                                    MS08-MC-POS-DC-03-RP-A
329700         MOVE DFHBMASB           TO MS08-MC-POS-DC-03-A
329800         GO TO Y239-EXIT.
329900*
330000     IF  MMFS-ST-INQ-ONLY (X-MMFS-STORE)
330100         MOVE ZERO               TO MS08-MC-POS-DC-03-L
330200         MOVE DFHBMDAS           TO MS08-MC-POS-DC-03-LP-A
330300                                    MS08-MC-POS-DC-03-RP-A
330400         MOVE DFHBMASK           TO MS08-MC-POS-DC-03-A
330500         GO TO Y239-EXIT.
330600*
330700     IF  MBCA-PTI-FUNCTION-IS-ADD
330800         IF  MMFS-ST-REQUIRED (X-MMFS-STORE)
330900             MOVE DFHBMASB       TO MS08-MC-POS-DC-DESC-LIT-A
331000         ELSE
331100             IF  MMFS-ST-MAINT-ONLY (X-MMFS-STORE)
331200                 MOVE ZERO       TO MS08-MC-POS-DC-03-L
331300                 MOVE DFHBMDAS   TO MS08-MC-POS-DC-03-LP-A
331400                                    MS08-MC-POS-DC-03-RP-A
331500                 MOVE DFHBMASK   TO MS08-MC-POS-DC-03-A.
331600*
331700     IF  MBCA-PTI-FUNCTION-IS-MAINT
331800         IF  MMFS-ST-NO-MAINT (X-MMFS-STORE)
331900             MOVE ZERO           TO MS08-MC-POS-DC-03-L
332000             MOVE DFHBMDAS       TO MS08-MC-POS-DC-03-LP-A
332100                                    MS08-MC-POS-DC-03-RP-A
332200             MOVE DFHBMASK       TO MS08-MC-POS-DC-03-A.
332300*
332400 Y239-EXIT.
332500     EXIT.
332600*
332700 Y250-MOVE-MC-POS-DC-04.
332800*
332900     MOVE MMSM-MC-POS-DC-04      TO MS08-MC-POS-DC-04.
333000*
333100 Y255-POS-DC-04-SECURITY.
333200*
333300     MOVE MMSMTB-MC-POS-DC-04 (1:4)
333400                                 TO WS-INDEX-X.
333500     SET  X-MMFS-STORE           TO WS-INDEX.
333600*
333700     IF  MMFS-ST-NO-ACCESS (X-MMFS-STORE)
333800         MOVE DFHBMDAS           TO MS08-MC-POS-DC-04-LP-A
333900                                    MS08-MC-POS-DC-04-RP-A
334000                                    MS08-MC-POS-DC-04-A
334100         MOVE ZERO               TO MS08-MC-POS-DC-04-L
334200         GO TO Y259-EXIT.
334300*
334400     IF  MBCA-PTI-FUNCTION-IS-INQUIRY
334500         MOVE DFHBMDAS           TO MS08-MC-POS-DC-04-LP-A
334600                                    MS08-MC-POS-DC-04-RP-A
334700         MOVE DFHBMASB           TO MS08-MC-POS-DC-04-A
334800         GO TO Y259-EXIT.
334900*
335000     IF  MMFS-ST-INQ-ONLY (X-MMFS-STORE)
335100         MOVE ZERO               TO MS08-MC-POS-DC-04-L
335200         MOVE DFHBMDAS           TO MS08-MC-POS-DC-04-LP-A
335300                                    MS08-MC-POS-DC-04-RP-A
335400         MOVE DFHBMASK           TO MS08-MC-POS-DC-04-A
335500         GO TO Y259-EXIT.
335600*
335700     IF  MBCA-PTI-FUNCTION-IS-ADD
335800         IF  MMFS-ST-REQUIRED (X-MMFS-STORE)
335900             MOVE DFHBMASB       TO MS08-MC-POS-DC-DESC-LIT-A
336000         ELSE
336100             IF  MMFS-ST-MAINT-ONLY (X-MMFS-STORE)
336200                 MOVE ZERO       TO MS08-MC-POS-DC-04-L
336300                 MOVE DFHBMDAS   TO MS08-MC-POS-DC-04-LP-A
336400                                    MS08-MC-POS-DC-04-RP-A
336500                 MOVE DFHBMASK   TO MS08-MC-POS-DC-04-A.
336600*
336700     IF  MBCA-PTI-FUNCTION-IS-MAINT
336800         IF  MMFS-ST-NO-MAINT (X-MMFS-STORE)
336900             MOVE ZERO           TO MS08-MC-POS-DC-04-L
337000             MOVE DFHBMDAS       TO MS08-MC-POS-DC-04-LP-A
337100                                    MS08-MC-POS-DC-04-RP-A
337200             MOVE DFHBMASK       TO MS08-MC-POS-DC-04-A.
337300*
337400 Y259-EXIT.
337500     EXIT.
337600*
337700 Y270-MOVE-MC-POS-DC-05.
337800*
337900     MOVE MMSM-MC-POS-DC-05      TO MS08-MC-POS-DC-05.
338000*
338100 Y275-POS-DC-05-SECURITY.
338200*
338300     MOVE MMSMTB-MC-POS-DC-05 (1:4)
338400                                 TO WS-INDEX-X.
338500     SET  X-MMFS-STORE           TO WS-INDEX.
338600*
338700     IF  MMFS-ST-NO-ACCESS (X-MMFS-STORE)
338800         MOVE DFHBMDAS           TO MS08-MC-POS-DC-05-LP-A
338900                                    MS08-MC-POS-DC-05-RP-A
339000                                    MS08-MC-POS-DC-05-A
339100         MOVE ZERO               TO MS08-MC-POS-DC-05-L
339200         GO TO Y279-EXIT.
339300*
339400     IF  MBCA-PTI-FUNCTION-IS-INQUIRY
339500         MOVE DFHBMDAS           TO MS08-MC-POS-DC-05-LP-A
339600                                    MS08-MC-POS-DC-05-RP-A
339700         MOVE DFHBMASB           TO MS08-MC-POS-DC-05-A
339800         GO TO Y279-EXIT.
339900*
340000     IF  MMFS-ST-INQ-ONLY (X-MMFS-STORE)
340100         MOVE ZERO               TO MS08-MC-POS-DC-05-L
340200         MOVE DFHBMDAS           TO MS08-MC-POS-DC-05-LP-A
340300                                    MS08-MC-POS-DC-05-RP-A
340400         MOVE DFHBMASK           TO MS08-MC-POS-DC-05-A
340500         GO TO Y279-EXIT.
340600*
340700     IF  MBCA-PTI-FUNCTION-IS-ADD
340800         IF  MMFS-ST-REQUIRED (X-MMFS-STORE)
340900             MOVE DFHBMASB       TO MS08-MC-POS-DC-DESC-LIT-A
341000         ELSE
341100             IF  MMFS-ST-MAINT-ONLY (X-MMFS-STORE)
341200                 MOVE ZERO       TO MS08-MC-POS-DC-05-L
341300                 MOVE DFHBMDAS   TO MS08-MC-POS-DC-05-LP-A
341400                                    MS08-MC-POS-DC-05-RP-A
341500                 MOVE DFHBMASK   TO MS08-MC-POS-DC-05-A.
341600*
341700     IF  MBCA-PTI-FUNCTION-IS-MAINT
341800         IF  MMFS-ST-NO-MAINT (X-MMFS-STORE)
341900             MOVE ZERO           TO MS08-MC-POS-DC-05-L
342000             MOVE DFHBMDAS       TO MS08-MC-POS-DC-05-LP-A
342100                                    MS08-MC-POS-DC-05-RP-A
342200             MOVE DFHBMASK       TO MS08-MC-POS-DC-05-A.
342300*
342400 Y279-EXIT.
342500     EXIT.
342600*
342700 Y290-MOVE-MC-POS-DC-06.
342800*
342900     MOVE MMSM-MC-POS-DC-06      TO MS08-MC-POS-DC-06.
343000*
343100 Y295-POS-DC-06-SECURITY.
343200*
343300     MOVE MMSMTB-MC-POS-DC-06 (1:4)
343400                                 TO WS-INDEX-X.
343500     SET  X-MMFS-STORE           TO WS-INDEX.
343600*
343700     IF  MMFS-ST-NO-ACCESS (X-MMFS-STORE)
343800         MOVE DFHBMDAS           TO MS08-MC-POS-DC-06-LP-A
343900                                    MS08-MC-POS-DC-06-RP-A
344000                                    MS08-MC-POS-DC-06-A
344100         MOVE ZERO               TO MS08-MC-POS-DC-06-L
344200         GO TO Y299-EXIT.
344300*
344400     IF  MBCA-PTI-FUNCTION-IS-INQUIRY
344500         MOVE DFHBMDAS           TO MS08-MC-POS-DC-06-LP-A
344600                                    MS08-MC-POS-DC-06-RP-A
344700         MOVE DFHBMASB           TO MS08-MC-POS-DC-06-A
344800         GO TO Y299-EXIT.
344900*
345000     IF  MMFS-ST-INQ-ONLY (X-MMFS-STORE)
345100         MOVE ZERO               TO MS08-MC-POS-DC-06-L
345200         MOVE DFHBMDAS           TO MS08-MC-POS-DC-06-LP-A
345300                                    MS08-MC-POS-DC-06-RP-A
345400         MOVE DFHBMASK           TO MS08-MC-POS-DC-06-A
345500         GO TO Y299-EXIT.
345600*
345700     IF  MBCA-PTI-FUNCTION-IS-ADD
345800         IF  MMFS-ST-REQUIRED (X-MMFS-STORE)
345900             MOVE DFHBMASB       TO MS08-MC-POS-DC-DESC-LIT-A
346000         ELSE
346100             IF  MMFS-ST-MAINT-ONLY (X-MMFS-STORE)
346200                 MOVE ZERO       TO MS08-MC-POS-DC-06-L
346300                 MOVE DFHBMDAS   TO MS08-MC-POS-DC-06-LP-A
346400                                    MS08-MC-POS-DC-06-RP-A
346500                 MOVE DFHBMASK   TO MS08-MC-POS-DC-06-A.
346600*
346700     IF  MBCA-PTI-FUNCTION-IS-MAINT
346800         IF  MMFS-ST-NO-MAINT (X-MMFS-STORE)
346900             MOVE ZERO           TO MS08-MC-POS-DC-06-L
347000             MOVE DFHBMDAS       TO MS08-MC-POS-DC-06-LP-A
347100                                    MS08-MC-POS-DC-06-RP-A
347200             MOVE DFHBMASK       TO MS08-MC-POS-DC-06-A.
347300*
347400 Y299-EXIT.
347500     EXIT.
347600*
347700 Y310-MOVE-MC-POS-DC-07.
347800*
347900     MOVE MMSM-MC-POS-DC-07      TO MS08-MC-POS-DC-07.
348000*
348100 Y315-POS-DC-07-SECURITY.
348200*
348300     MOVE MMSMTB-MC-POS-DC-07 (1:4)
348400                                 TO WS-INDEX-X.
348500     SET  X-MMFS-STORE           TO WS-INDEX.
348600*
348700     IF  MMFS-ST-NO-ACCESS (X-MMFS-STORE)
348800         MOVE DFHBMDAS           TO MS08-MC-POS-DC-07-LP-A
348900                                    MS08-MC-POS-DC-07-RP-A
349000                                    MS08-MC-POS-DC-07-A
349100         MOVE ZERO               TO MS08-MC-POS-DC-07-L
349200         GO TO Y319-EXIT.
349300*
349400     IF  MBCA-PTI-FUNCTION-IS-INQUIRY
349500         MOVE DFHBMDAS           TO MS08-MC-POS-DC-07-LP-A
349600                                    MS08-MC-POS-DC-07-RP-A
349700         MOVE DFHBMASB           TO MS08-MC-POS-DC-07-A
349800         GO TO Y319-EXIT.
349900*
350000     IF  MMFS-ST-INQ-ONLY (X-MMFS-STORE)
350100         MOVE ZERO               TO MS08-MC-POS-DC-07-L
350200         MOVE DFHBMDAS           TO MS08-MC-POS-DC-07-LP-A
350300                                    MS08-MC-POS-DC-07-RP-A
350400         MOVE DFHBMASK           TO MS08-MC-POS-DC-07-A
350500         GO TO Y319-EXIT.
350600*
350700     IF  MBCA-PTI-FUNCTION-IS-ADD
350800         IF  MMFS-ST-REQUIRED (X-MMFS-STORE)
350900             MOVE DFHBMASB       TO MS08-MC-POS-DC-DESC-LIT-A
351000         ELSE
351100             IF  MMFS-ST-MAINT-ONLY (X-MMFS-STORE)
351200                 MOVE ZERO       TO MS08-MC-POS-DC-07-L
351300                 MOVE DFHBMDAS   TO MS08-MC-POS-DC-07-LP-A
351400                                    MS08-MC-POS-DC-07-RP-A
351500                 MOVE DFHBMASK   TO MS08-MC-POS-DC-07-A.
351600*
351700     IF  MBCA-PTI-FUNCTION-IS-MAINT
351800         IF  MMFS-ST-NO-MAINT (X-MMFS-STORE)
351900             MOVE ZERO           TO MS08-MC-POS-DC-07-L
352000             MOVE DFHBMDAS       TO MS08-MC-POS-DC-07-LP-A
352100                                    MS08-MC-POS-DC-07-RP-A
352200             MOVE DFHBMASK       TO MS08-MC-POS-DC-07-A.
352300*
352400 Y319-EXIT.
352500     EXIT.
352600*
352700 Y330-MOVE-MC-POS-DC-08.
352800*
352900     MOVE MMSM-MC-POS-DC-08      TO MS08-MC-POS-DC-08.
353000*
353100 Y335-POS-DC-08-SECURITY.
353200*
353300     MOVE MMSMTB-MC-POS-DC-08 (1:4)
353400                                 TO WS-INDEX-X.
353500     SET  X-MMFS-STORE           TO WS-INDEX.
353600*
353700     IF  MMFS-ST-NO-ACCESS (X-MMFS-STORE)
353800         MOVE DFHBMDAS           TO MS08-MC-POS-DC-08-LP-A
353900                                    MS08-MC-POS-DC-08-RP-A
354000                                    MS08-MC-POS-DC-08-A
354100         MOVE ZERO               TO MS08-MC-POS-DC-08-L
354200         GO TO Y339-EXIT.
354300*
354400     IF  MBCA-PTI-FUNCTION-IS-INQUIRY
354500         MOVE DFHBMDAS           TO MS08-MC-POS-DC-08-LP-A
354600                                    MS08-MC-POS-DC-08-RP-A
354700         MOVE DFHBMASB           TO MS08-MC-POS-DC-08-A
354800         GO TO Y339-EXIT.
354900*
355000     IF  MMFS-ST-INQ-ONLY (X-MMFS-STORE)
355100         MOVE ZERO               TO MS08-MC-POS-DC-08-L
355200         MOVE DFHBMDAS           TO MS08-MC-POS-DC-08-LP-A
355300                                    MS08-MC-POS-DC-08-RP-A
355400         MOVE DFHBMASK           TO MS08-MC-POS-DC-08-A
355500         GO TO Y339-EXIT.
355600*
355700     IF  MBCA-PTI-FUNCTION-IS-ADD
355800         IF  MMFS-ST-REQUIRED (X-MMFS-STORE)
355900             MOVE DFHBMASB       TO MS08-MC-POS-DC-DESC-LIT-A
356000         ELSE
356100             IF  MMFS-ST-MAINT-ONLY (X-MMFS-STORE)
356200                 MOVE ZERO       TO MS08-MC-POS-DC-08-L
356300                 MOVE DFHBMDAS   TO MS08-MC-POS-DC-08-LP-A
356400                                    MS08-MC-POS-DC-08-RP-A
356500                 MOVE DFHBMASK   TO MS08-MC-POS-DC-08-A.
356600*
356700     IF  MBCA-PTI-FUNCTION-IS-MAINT
356800         IF  MMFS-ST-NO-MAINT (X-MMFS-STORE)
356900             MOVE ZERO           TO MS08-MC-POS-DC-08-L
357000             MOVE DFHBMDAS       TO MS08-MC-POS-DC-08-LP-A
357100                                    MS08-MC-POS-DC-08-RP-A
357200             MOVE DFHBMASK       TO MS08-MC-POS-DC-08-A.
357300*
357400 Y339-EXIT.
357500     EXIT.
357600*
357700 Y350-MOVE-MC-POS-DC-09.
357800*
357900     MOVE MMSM-MC-POS-DC-09      TO MS08-MC-POS-DC-09.
358000*
358100 Y355-POS-DC-09-SECURITY.
358200*
358300     MOVE MMSMTB-MC-POS-DC-09 (1:4)
358400                                 TO WS-INDEX-X.
358500     SET  X-MMFS-STORE           TO WS-INDEX.
358600*
358700     IF  MMFS-ST-NO-ACCESS (X-MMFS-STORE)
358800         MOVE DFHBMDAS           TO MS08-MC-POS-DC-09-LP-A
358900                                    MS08-MC-POS-DC-09-RP-A
359000                                    MS08-MC-POS-DC-09-A
359100         MOVE ZERO               TO MS08-MC-POS-DC-09-L
359200         GO TO Y359-EXIT.
359300*
359400     IF  MBCA-PTI-FUNCTION-IS-INQUIRY
359500         MOVE DFHBMDAS           TO MS08-MC-POS-DC-09-LP-A
359600                                    MS08-MC-POS-DC-09-RP-A
359700         MOVE DFHBMASB           TO MS08-MC-POS-DC-09-A
359800         GO TO Y359-EXIT.
359900*
360000     IF  MMFS-ST-INQ-ONLY (X-MMFS-STORE)
360100         MOVE ZERO               TO MS08-MC-POS-DC-09-L
360200         MOVE DFHBMDAS           TO MS08-MC-POS-DC-09-LP-A
360300                                    MS08-MC-POS-DC-09-RP-A
360400         MOVE DFHBMASK           TO MS08-MC-POS-DC-09-A
360500         GO TO Y359-EXIT.
360600*
360700     IF  MBCA-PTI-FUNCTION-IS-ADD
360800         IF  MMFS-ST-REQUIRED (X-MMFS-STORE)
360900             MOVE DFHBMASB       TO MS08-MC-POS-DC-DESC-LIT-A
361000         ELSE
361100             IF  MMFS-ST-MAINT-ONLY (X-MMFS-STORE)
361200                 MOVE ZERO       TO MS08-MC-POS-DC-09-L
361300                 MOVE DFHBMDAS   TO MS08-MC-POS-DC-09-LP-A
361400                                    MS08-MC-POS-DC-09-RP-A
361500                 MOVE DFHBMASK   TO MS08-MC-POS-DC-09-A.
361600*
361700     IF  MBCA-PTI-FUNCTION-IS-MAINT
361800         IF  MMFS-ST-NO-MAINT (X-MMFS-STORE)
361900             MOVE ZERO           TO MS08-MC-POS-DC-09-L
362000             MOVE DFHBMDAS       TO MS08-MC-POS-DC-09-LP-A
362100                                    MS08-MC-POS-DC-09-RP-A
362200             MOVE DFHBMASK       TO MS08-MC-POS-DC-09-A.
362300*
362400 Y359-EXIT.
362500     EXIT.
362600*
362700 Y370-MOVE-MC-POS-DC-10.
362800*
362900     MOVE MMSM-MC-POS-DC-10      TO MS08-MC-POS-DC-10.
363000*
363100 Y375-POS-DC-10-SECURITY.
363200*
363300     MOVE MMSMTB-MC-POS-DC-10 (1:4)
363400                                 TO WS-INDEX-X.
363500     SET  X-MMFS-STORE           TO WS-INDEX.
363600*
363700     IF  MMFS-ST-NO-ACCESS (X-MMFS-STORE)
363800         MOVE DFHBMDAS           TO MS08-MC-POS-DC-10-LP-A
363900                                    MS08-MC-POS-DC-10-RP-A
364000                                    MS08-MC-POS-DC-10-A
364100         MOVE ZERO               TO MS08-MC-POS-DC-10-L
364200         GO TO Y379-EXIT.
364300*
364400     IF  MBCA-PTI-FUNCTION-IS-INQUIRY
364500         MOVE DFHBMDAS           TO MS08-MC-POS-DC-10-LP-A
364600                                    MS08-MC-POS-DC-10-RP-A
364700         MOVE DFHBMASB           TO MS08-MC-POS-DC-10-A
364800         GO TO Y379-EXIT.
364900*
365000     IF  MMFS-ST-INQ-ONLY (X-MMFS-STORE)
365100         MOVE ZERO               TO MS08-MC-POS-DC-10-L
365200         MOVE DFHBMDAS           TO MS08-MC-POS-DC-10-LP-A
365300                                    MS08-MC-POS-DC-10-RP-A
365400         MOVE DFHBMASK           TO MS08-MC-POS-DC-10-A
365500         GO TO Y379-EXIT.
365600*
365700     IF  MBCA-PTI-FUNCTION-IS-ADD
365800         IF  MMFS-ST-REQUIRED (X-MMFS-STORE)
365900             MOVE DFHBMASB       TO MS08-MC-POS-DC-DESC-LIT-A
366000         ELSE
366100             IF  MMFS-ST-MAINT-ONLY (X-MMFS-STORE)
366200                 MOVE ZERO       TO MS08-MC-POS-DC-10-L
366300                 MOVE DFHBMDAS   TO MS08-MC-POS-DC-10-LP-A
366400                                    MS08-MC-POS-DC-10-RP-A
366500                 MOVE DFHBMASK   TO MS08-MC-POS-DC-10-A.
366600*
366700     IF  MBCA-PTI-FUNCTION-IS-MAINT
366800         IF  MMFS-ST-NO-MAINT (X-MMFS-STORE)
366900             MOVE ZERO           TO MS08-MC-POS-DC-10-L
367000             MOVE DFHBMDAS       TO MS08-MC-POS-DC-10-LP-A
367100                                    MS08-MC-POS-DC-10-RP-A
367200             MOVE DFHBMASK       TO MS08-MC-POS-DC-10-A.
367300*
367400 Y379-EXIT.
367500     EXIT.
367600*
367700 Y390-MOVE-MC-POS-DC-11.
367800*
367900     MOVE MMSM-MC-POS-DC-11      TO MS08-MC-POS-DC-11.
368000*
368100 Y395-POS-DC-11-SECURITY.
368200*
368300     MOVE MMSMTB-MC-POS-DC-11 (1:4)
368400                                 TO WS-INDEX-X.
368500     SET  X-MMFS-STORE           TO WS-INDEX.
368600*
368700     IF  MMFS-ST-NO-ACCESS (X-MMFS-STORE)
368800         MOVE DFHBMDAS           TO MS08-MC-POS-DC-11-LP-A
368900                                    MS08-MC-POS-DC-11-RP-A
369000                                    MS08-MC-POS-DC-11-A
369100         MOVE ZERO               TO MS08-MC-POS-DC-11-L
369200         GO TO Y399-EXIT.
369300*
369400     IF  MBCA-PTI-FUNCTION-IS-INQUIRY
369500         MOVE DFHBMDAS           TO MS08-MC-POS-DC-11-LP-A
369600                                    MS08-MC-POS-DC-11-RP-A
369700         MOVE DFHBMASB           TO MS08-MC-POS-DC-11-A
369800         GO TO Y399-EXIT.
369900*
370000     IF  MMFS-ST-INQ-ONLY (X-MMFS-STORE)
370100         MOVE ZERO               TO MS08-MC-POS-DC-11-L
370200         MOVE DFHBMDAS           TO MS08-MC-POS-DC-11-LP-A
370300                                    MS08-MC-POS-DC-11-RP-A
370400         MOVE DFHBMASK           TO MS08-MC-POS-DC-11-A
370500         GO TO Y399-EXIT.
370600*
370700     IF  MBCA-PTI-FUNCTION-IS-ADD
370800         IF  MMFS-ST-REQUIRED (X-MMFS-STORE)
370900             MOVE DFHBMASB       TO MS08-MC-POS-DC-DESC-LIT-A
371000         ELSE
371100             IF  MMFS-ST-MAINT-ONLY (X-MMFS-STORE)
371200                 MOVE ZERO       TO MS08-MC-POS-DC-11-L
371300                 MOVE DFHBMDAS   TO MS08-MC-POS-DC-11-LP-A
371400                                    MS08-MC-POS-DC-11-RP-A
371500                 MOVE DFHBMASK   TO MS08-MC-POS-DC-11-A.
371600*
371700     IF  MBCA-PTI-FUNCTION-IS-MAINT
371800         IF  MMFS-ST-NO-MAINT (X-MMFS-STORE)
371900             MOVE ZERO           TO MS08-MC-POS-DC-11-L
372000             MOVE DFHBMDAS       TO MS08-MC-POS-DC-11-LP-A
372100                                    MS08-MC-POS-DC-11-RP-A
372200             MOVE DFHBMASK       TO MS08-MC-POS-DC-11-A.
372300*
372400 Y399-EXIT.
372500     EXIT.
372600*
372700 Y410-MOVE-MC-POS-DC-12.
372800*
372900     MOVE MMSM-MC-POS-DC-12      TO MS08-MC-POS-DC-12.
373000*
373100 Y415-POS-DC-12-SECURITY.
373200*
373300     MOVE MMSMTB-MC-POS-DC-12 (1:4)
373400                                 TO WS-INDEX-X.
373500     SET  X-MMFS-STORE           TO WS-INDEX.
373600*
373700     IF  MMFS-ST-NO-ACCESS (X-MMFS-STORE)
373800         MOVE DFHBMDAS           TO MS08-MC-POS-DC-12-LP-A
373900                                    MS08-MC-POS-DC-12-RP-A
374000                                    MS08-MC-POS-DC-12-A
374100         MOVE ZERO               TO MS08-MC-POS-DC-12-L
374200         GO TO Y419-EXIT.
374300*
374400     IF  MBCA-PTI-FUNCTION-IS-INQUIRY
374500         MOVE DFHBMDAS           TO MS08-MC-POS-DC-12-LP-A
374600                                    MS08-MC-POS-DC-12-RP-A
374700         MOVE DFHBMASB           TO MS08-MC-POS-DC-12-A
374800         GO TO Y419-EXIT.
374900*
375000     IF  MMFS-ST-INQ-ONLY (X-MMFS-STORE)
375100         MOVE ZERO               TO MS08-MC-POS-DC-12-L
375200         MOVE DFHBMDAS           TO MS08-MC-POS-DC-12-LP-A
375300                                    MS08-MC-POS-DC-12-RP-A
375400         MOVE DFHBMASK           TO MS08-MC-POS-DC-12-A
375500         GO TO Y419-EXIT.
375600*
375700     IF  MBCA-PTI-FUNCTION-IS-ADD
375800         IF  MMFS-ST-REQUIRED (X-MMFS-STORE)
375900             MOVE DFHBMASB       TO MS08-MC-POS-DC-DESC-LIT-A
376000         ELSE
376100             IF  MMFS-ST-MAINT-ONLY (X-MMFS-STORE)
376200                 MOVE ZERO       TO MS08-MC-POS-DC-12-L
376300                 MOVE DFHBMDAS   TO MS08-MC-POS-DC-12-LP-A
376400                                    MS08-MC-POS-DC-12-RP-A
376500                 MOVE DFHBMASK   TO MS08-MC-POS-DC-12-A.
376600*
376700     IF  MBCA-PTI-FUNCTION-IS-MAINT
376800         IF  MMFS-ST-NO-MAINT (X-MMFS-STORE)
376900             MOVE ZERO           TO MS08-MC-POS-DC-12-L
377000             MOVE DFHBMDAS       TO MS08-MC-POS-DC-12-LP-A
377100                                    MS08-MC-POS-DC-12-RP-A
377200             MOVE DFHBMASK       TO MS08-MC-POS-DC-12-A.
377300*
377400 Y419-EXIT.
377500     EXIT.
377600*
377700 Y800-SET-CURSOR.
377800*
377900************************************************************
378000*    THIS ROUTINE IS PERFORMED IF IN ADD OR MAINTENANCE    *
378100*    AND SETS THE CURSOR TO THE FIRST FIELD WHICH IS       *
378200*    OPEN FOR INPUT                                        *
378300************************************************************
378400*
378500     MOVE MMSMTB-MC-DBA-NAME (1:4)
378600                                 TO WS-INDEX-X.
378700     SET X-MMFS-STORE            TO WS-INDEX.
378800*
378900     EVALUATE TRUE
379000         WHEN  MBCA-PTI-FUNCTION-IS-ADD
379100             IF  MMFS-ST-OPTIONAL (X-MMFS-STORE)
379200             OR  MMFS-ST-REQUIRED (X-MMFS-STORE)
379300                 MOVE SS08WS-CURSOR TO MS08-MC-DBA-NAME-L
379400             END-IF
379500         WHEN  MBCA-PTI-FUNCTION-IS-MAINT
379600             IF  MMFS-ST-MAINT-ALLOWED (X-MMFS-STORE)
379700                 MOVE SS08WS-CURSOR TO MS08-MC-DBA-NAME-L
379800             END-IF
379900     END-EVALUATE.
379902*                                                                 RG800913
379904     MOVE MMSMTB-MC-CIRRUS-IND (1:4)                              RG800913
379906                                 TO WS-INDEX-X.                   RG800913
379908     SET X-MMFS-STORE            TO WS-INDEX.                     RG800913
379910*                                                                 RG800913
379912     EVALUATE TRUE                                                RG800913
379914         WHEN  MBCA-PTI-FUNCTION-IS-ADD                           RG800913
379916             IF  MMFS-ST-OPTIONAL (X-MMFS-STORE)                  RG800913
379918             OR  MMFS-ST-REQUIRED (X-MMFS-STORE)                  RG800913
379920                 MOVE SS08WS-CURSOR TO MS08-MC-CIRRUS-IND-L       RG800913
379922             END-IF                                               RG800913
379924         WHEN  MBCA-PTI-FUNCTION-IS-MAINT                         RG800913
379926             IF  MMFS-ST-MAINT-ALLOWED (X-MMFS-STORE)             RG800913
379928                 MOVE SS08WS-CURSOR TO MS08-MC-CIRRUS-IND-L       RG800913
379930             END-IF                                               RG800913
379932     END-EVALUATE.                                                RG800913
380000*
380100     MOVE MMSMTB-MC-INTCHG-IND (1:4)
380200                                 TO WS-INDEX-X.
380300     SET X-MMFS-STORE            TO WS-INDEX.
380400*
380500     EVALUATE TRUE
380600         WHEN  MBCA-PTI-FUNCTION-IS-ADD
380700             IF  MMFS-ST-OPTIONAL (X-MMFS-STORE)
380800             OR  MMFS-ST-REQUIRED (X-MMFS-STORE)
380900                 MOVE SS08WS-CURSOR TO MS08-MC-INTCHG-FLAG-L
381000             END-IF
381100         WHEN  MBCA-PTI-FUNCTION-IS-MAINT
381200             IF  MMFS-ST-MAINT-ALLOWED (X-MMFS-STORE)
381300                 MOVE SS08WS-CURSOR TO MS08-MC-INTCHG-FLAG-L
381400             END-IF
381500     END-EVALUATE.
381502*                                                                 RG800913
381504     MOVE MMSMTB-MC-BUSINESS-CLASS (1:4)                          RG800913
381506                                 TO WS-INDEX-X.                   RG800913
381508     SET X-MMFS-STORE            TO WS-INDEX.                     RG800913
381510*                                                                 RG800913
381512     EVALUATE TRUE                                                RG800913
381514         WHEN  MBCA-PTI-FUNCTION-IS-ADD                           RG800913
381516             IF  MMFS-ST-OPTIONAL (X-MMFS-STORE)                  RG800913
381518             OR  MMFS-ST-REQUIRED (X-MMFS-STORE)                  RG800913
381520                 MOVE SS08WS-CURSOR TO MS08-MC-BUS-CLASS-CODE-L   RG800913
381522             END-IF                                               RG800913
381524         WHEN  MBCA-PTI-FUNCTION-IS-MAINT                         RG800913
381526             IF  MMFS-ST-MAINT-ALLOWED (X-MMFS-STORE)             RG800913
381528                 MOVE SS08WS-CURSOR TO MS08-MC-BUS-CLASS-CODE-L   RG800913
381530             END-IF                                               RG800913
381532     END-EVALUATE.                                                RG800913
381600*
381700     MOVE MMSMTB-MC-CATEGORY-CODE (1:4)
381800                                 TO WS-INDEX-X.
381900     SET X-MMFS-STORE            TO WS-INDEX.
382000*
382100     EVALUATE TRUE
382200         WHEN  MBCA-PTI-FUNCTION-IS-ADD
382300             IF  MMFS-ST-OPTIONAL (X-MMFS-STORE)
382400             OR  MMFS-ST-REQUIRED (X-MMFS-STORE)
382500                 MOVE SS08WS-CURSOR TO MS08-MC-CATEGORY-CODE-L
382600             END-IF
382700         WHEN  MBCA-PTI-FUNCTION-IS-MAINT
382800             IF  MMFS-ST-MAINT-ALLOWED (X-MMFS-STORE)
382900                 MOVE SS08WS-CURSOR TO MS08-MC-CATEGORY-CODE-L
383000             END-IF
383100     END-EVALUATE.
383200*
383300     MOVE MMSMTB-MC-FLOOR-LIMIT (1:4)
383400                                 TO WS-INDEX-X.
383500     SET X-MMFS-STORE            TO WS-INDEX.
383600*
383700     EVALUATE TRUE
383800         WHEN  MBCA-PTI-FUNCTION-IS-ADD
383900             IF  MMFS-ST-OPTIONAL (X-MMFS-STORE)
384000             OR  MMFS-ST-REQUIRED (X-MMFS-STORE)
384100                 MOVE SS08WS-CURSOR TO MS08-MC-FLOOR-LIMIT-L
384200             END-IF
384300         WHEN  MBCA-PTI-FUNCTION-IS-MAINT
384400             IF  MMFS-ST-MAINT-ALLOWED (X-MMFS-STORE)
384500                 MOVE SS08WS-CURSOR TO MS08-MC-FLOOR-LIMIT-L
384600             END-IF
384700     END-EVALUATE.
384702*                                                                 RG800913
384704     MOVE MMSMTB-MC-CH-TERM-IND (1:4)                             RG800913
384706                                 TO WS-INDEX-X.                   RG800913
384708     SET X-MMFS-STORE            TO WS-INDEX.                     RG800913
384710*                                                                 RG800913
384712     EVALUATE TRUE                                                RG800913
384714         WHEN  MBCA-PTI-FUNCTION-IS-ADD                           RG800913
384716             IF  MMFS-ST-OPTIONAL (X-MMFS-STORE)                  RG800913
384718             OR  MMFS-ST-REQUIRED (X-MMFS-STORE)                  RG800913
384720                 MOVE SS08WS-CURSOR TO MS08-MC-CH-TERM-IND-L      RG800913
384722             END-IF                                               RG800913
384724         WHEN  MBCA-PTI-FUNCTION-IS-MAINT                         RG800913
384726             IF  MMFS-ST-MAINT-ALLOWED (X-MMFS-STORE)             RG800913
384728                 MOVE SS08WS-CURSOR TO MS08-MC-CH-TERM-IND-L      RG800913
384730             END-IF                                               RG800913
384732     END-EVALUATE.                                                RG800913
384742*                                                                 RG800913
384744     MOVE MMSMTB-MC-ASSIGNED-ID (1:4)                             RG800913
384746                                 TO WS-INDEX-X.                   RG800913
384748     SET X-MMFS-STORE            TO WS-INDEX.                     RG800913
384750*                                                                 RG800913
384752     EVALUATE TRUE                                                RG800913
384754         WHEN  MBCA-PTI-FUNCTION-IS-ADD                           RG800913
384756             IF  MMFS-ST-OPTIONAL (X-MMFS-STORE)                  RG800913
384758             OR  MMFS-ST-REQUIRED (X-MMFS-STORE)                  RG800913
384760                 MOVE SS08WS-CURSOR TO MS08-MC-ASSIGNED-ID-L      RG800913
384762             END-IF                                               RG800913
384764         WHEN  MBCA-PTI-FUNCTION-IS-MAINT                         RG800913
384766             IF  MMFS-ST-MAINT-ALLOWED (X-MMFS-STORE)             RG800913
384768                 MOVE SS08WS-CURSOR TO MS08-MC-ASSIGNED-ID-L      RG800913
384770             END-IF                                               RG800913
384772     END-EVALUATE.                                                RG800913
384800*
384900     MOVE MMSMTB-MC-POS-DC-01 (1:4)
385000                                 TO WS-INDEX-X.
385100     SET X-MMFS-STORE            TO WS-INDEX.
385200*
385300     EVALUATE TRUE
385400         WHEN  MBCA-PTI-FUNCTION-IS-ADD
385500             IF  MMFS-ST-OPTIONAL (X-MMFS-STORE)
385600             OR  MMFS-ST-REQUIRED (X-MMFS-STORE)
385700                 MOVE SS08WS-CURSOR TO MS08-MC-POS-DC-01-L
385800             END-IF
385900         WHEN  MBCA-PTI-FUNCTION-IS-MAINT
386000             IF  MMFS-ST-MAINT-ALLOWED (X-MMFS-STORE)
386100                 MOVE SS08WS-CURSOR TO MS08-MC-POS-DC-01-L
386200             END-IF
386300     END-EVALUATE.
386400*
386500     MOVE MMSMTB-MC-POS-DC-02 (1:4)
386600                                 TO WS-INDEX-X.
386700     SET X-MMFS-STORE            TO WS-INDEX.
386800*
386900     EVALUATE TRUE
387000         WHEN  MBCA-PTI-FUNCTION-IS-ADD
387100             IF  MMFS-ST-OPTIONAL (X-MMFS-STORE)
387200             OR  MMFS-ST-REQUIRED (X-MMFS-STORE)
387300                 MOVE SS08WS-CURSOR TO MS08-MC-POS-DC-02-L
387400             END-IF
387500         WHEN  MBCA-PTI-FUNCTION-IS-MAINT
387600             IF  MMFS-ST-MAINT-ALLOWED (X-MMFS-STORE)
387700                 MOVE SS08WS-CURSOR TO MS08-MC-POS-DC-02-L
387800             END-IF
387900     END-EVALUATE.
388000*
388100     MOVE MMSMTB-MC-POS-DC-03 (1:4)
388200                                 TO WS-INDEX-X.
388300     SET X-MMFS-STORE            TO WS-INDEX.
388400*
388500     EVALUATE TRUE
388600         WHEN  MBCA-PTI-FUNCTION-IS-ADD
388700             IF  MMFS-ST-OPTIONAL (X-MMFS-STORE)
388800             OR  MMFS-ST-REQUIRED (X-MMFS-STORE)
388900                 MOVE SS08WS-CURSOR TO MS08-MC-POS-DC-03-L
389000             END-IF
389100         WHEN  MBCA-PTI-FUNCTION-IS-MAINT
389200             IF  MMFS-ST-MAINT-ALLOWED (X-MMFS-STORE)
389300                 MOVE SS08WS-CURSOR TO MS08-MC-POS-DC-03-L
389400             END-IF
389500     END-EVALUATE.
389600*
389700     MOVE MMSMTB-MC-POS-DC-04 (1:4)
389800                                 TO WS-INDEX-X.
389900     SET X-MMFS-STORE            TO WS-INDEX.
390000*
390100     EVALUATE TRUE
390200         WHEN  MBCA-PTI-FUNCTION-IS-ADD
390300             IF  MMFS-ST-OPTIONAL (X-MMFS-STORE)
390400             OR  MMFS-ST-REQUIRED (X-MMFS-STORE)
390500                 MOVE SS08WS-CURSOR TO MS08-MC-POS-DC-04-L
390600             END-IF
390700         WHEN  MBCA-PTI-FUNCTION-IS-MAINT
390800             IF  MMFS-ST-MAINT-ALLOWED (X-MMFS-STORE)
390900                 MOVE SS08WS-CURSOR TO MS08-MC-POS-DC-04-L
391000             END-IF
391100     END-EVALUATE.
391200*
391300     MOVE MMSMTB-MC-POS-DC-05 (1:4)
391400                                 TO WS-INDEX-X.
391500     SET X-MMFS-STORE            TO WS-INDEX.
391600*
391700     EVALUATE TRUE
391800         WHEN  MBCA-PTI-FUNCTION-IS-ADD
391900             IF  MMFS-ST-OPTIONAL (X-MMFS-STORE)
392000             OR  MMFS-ST-REQUIRED (X-MMFS-STORE)
392100                 MOVE SS08WS-CURSOR TO MS08-MC-POS-DC-05-L
392200             END-IF
392300         WHEN  MBCA-PTI-FUNCTION-IS-MAINT
392400             IF  MMFS-ST-MAINT-ALLOWED (X-MMFS-STORE)
392500                 MOVE SS08WS-CURSOR TO MS08-MC-POS-DC-05-L
392600             END-IF
392700     END-EVALUATE.
392800*
392900     MOVE MMSMTB-MC-POS-DC-06 (1:4)
393000                                 TO WS-INDEX-X.
393100     SET X-MMFS-STORE            TO WS-INDEX.
393200*
393300     EVALUATE TRUE
393400         WHEN  MBCA-PTI-FUNCTION-IS-ADD
393500             IF  MMFS-ST-OPTIONAL (X-MMFS-STORE)
393600             OR  MMFS-ST-REQUIRED (X-MMFS-STORE)
393700                 MOVE SS08WS-CURSOR TO MS08-MC-POS-DC-06-L
393800             END-IF
393900         WHEN  MBCA-PTI-FUNCTION-IS-MAINT
394000             IF  MMFS-ST-MAINT-ALLOWED (X-MMFS-STORE)
394100                 MOVE SS08WS-CURSOR TO MS08-MC-POS-DC-06-L
394200             END-IF
394300     END-EVALUATE.
394400*
394500     MOVE MMSMTB-MC-POS-DC-07 (1:4)
394600                                 TO WS-INDEX-X.
394700     SET X-MMFS-STORE            TO WS-INDEX.
394800*
394900     EVALUATE TRUE
395000         WHEN  MBCA-PTI-FUNCTION-IS-ADD
395100             IF  MMFS-ST-OPTIONAL (X-MMFS-STORE)
395200             OR  MMFS-ST-REQUIRED (X-MMFS-STORE)
395300                 MOVE SS08WS-CURSOR TO MS08-MC-POS-DC-07-L
395400             END-IF
395500         WHEN  MBCA-PTI-FUNCTION-IS-MAINT
395600             IF  MMFS-ST-MAINT-ALLOWED (X-MMFS-STORE)
395700                 MOVE SS08WS-CURSOR TO MS08-MC-POS-DC-07-L
395800             END-IF
395900     END-EVALUATE.
396000*
396100     MOVE MMSMTB-MC-POS-DC-08 (1:4)
396200                                 TO WS-INDEX-X.
396300     SET X-MMFS-STORE            TO WS-INDEX.
396400*
396500     EVALUATE TRUE
396600         WHEN  MBCA-PTI-FUNCTION-IS-ADD
396700             IF  MMFS-ST-OPTIONAL (X-MMFS-STORE)
396800             OR  MMFS-ST-REQUIRED (X-MMFS-STORE)
396900                 MOVE SS08WS-CURSOR TO MS08-MC-POS-DC-08-L
397000             END-IF
397100         WHEN  MBCA-PTI-FUNCTION-IS-MAINT
397200             IF  MMFS-ST-MAINT-ALLOWED (X-MMFS-STORE)
397300                 MOVE SS08WS-CURSOR TO MS08-MC-POS-DC-08-L
397400             END-IF
397500     END-EVALUATE.
397600*
397700     MOVE MMSMTB-MC-POS-DC-09 (1:4)
397800                                 TO WS-INDEX-X.
397900     SET X-MMFS-STORE            TO WS-INDEX.
398000*
398100     EVALUATE TRUE
398200         WHEN  MBCA-PTI-FUNCTION-IS-ADD
398300             IF  MMFS-ST-OPTIONAL (X-MMFS-STORE)
398400             OR  MMFS-ST-REQUIRED (X-MMFS-STORE)
398500                 MOVE SS08WS-CURSOR TO MS08-MC-POS-DC-09-L
398600             END-IF
398700         WHEN  MBCA-PTI-FUNCTION-IS-MAINT
398800             IF  MMFS-ST-MAINT-ALLOWED (X-MMFS-STORE)
398900                 MOVE SS08WS-CURSOR TO MS08-MC-POS-DC-09-L
399000             END-IF
399100     END-EVALUATE.
399200*
399300     MOVE MMSMTB-MC-POS-DC-10 (1:4)
399400                                 TO WS-INDEX-X.
399500     SET X-MMFS-STORE            TO WS-INDEX.
399600*
399700     EVALUATE TRUE
399800         WHEN  MBCA-PTI-FUNCTION-IS-ADD
399900             IF  MMFS-ST-OPTIONAL (X-MMFS-STORE)
400000             OR  MMFS-ST-REQUIRED (X-MMFS-STORE)
400100                 MOVE SS08WS-CURSOR TO MS08-MC-POS-DC-10-L
400200             END-IF
400300         WHEN  MBCA-PTI-FUNCTION-IS-MAINT
400400             IF  MMFS-ST-MAINT-ALLOWED (X-MMFS-STORE)
400500                 MOVE SS08WS-CURSOR TO MS08-MC-POS-DC-10-L
400600             END-IF
400700     END-EVALUATE.
400800*
400900     MOVE MMSMTB-MC-POS-DC-11 (1:4)
401000                                 TO WS-INDEX-X.
401100     SET X-MMFS-STORE            TO WS-INDEX.
401200*
401300     EVALUATE TRUE
401400         WHEN  MBCA-PTI-FUNCTION-IS-ADD
401500             IF  MMFS-ST-OPTIONAL (X-MMFS-STORE)
401600             OR  MMFS-ST-REQUIRED (X-MMFS-STORE)
401700                 MOVE SS08WS-CURSOR TO MS08-MC-POS-DC-11-L
401800             END-IF
401900         WHEN  MBCA-PTI-FUNCTION-IS-MAINT
402000             IF  MMFS-ST-MAINT-ALLOWED (X-MMFS-STORE)
402100                 MOVE SS08WS-CURSOR TO MS08-MC-POS-DC-11-L
402200             END-IF
402300     END-EVALUATE.
402400*
402500     MOVE MMSMTB-MC-POS-DC-12 (1:4)
402600                                 TO WS-INDEX-X.
402700     SET X-MMFS-STORE            TO WS-INDEX.
402800*
402900     EVALUATE TRUE
403000         WHEN  MBCA-PTI-FUNCTION-IS-ADD
403100             IF  MMFS-ST-OPTIONAL (X-MMFS-STORE)
403200             OR  MMFS-ST-REQUIRED (X-MMFS-STORE)
403300                 MOVE SS08WS-CURSOR TO MS08-MC-POS-DC-12-L
403400             END-IF
403500         WHEN  MBCA-PTI-FUNCTION-IS-MAINT
403600             IF  MMFS-ST-MAINT-ALLOWED (X-MMFS-STORE)
403700                 MOVE SS08WS-CURSOR TO MS08-MC-POS-DC-12-L
403800             END-IF
403900     END-EVALUATE.
404000*
404100 Y809-SC-EXIT.
404200     EXIT.
404300*
404400 Y900-READ-MMFS.
404500*
404600****************************************
404700*    READ THE FIELD SECURITY RECORD    *
404800*    TO OBTAIN THE SECURITY CODES      *
404900****************************************
405000*
405100     MOVE MBCA-MERCHANT-ORG      TO MBIOWS-MMFS-ORG.
405200     MOVE MBCA-FIELD-SECURITY    TO MBIOWS-MMFS-FS-CODE.
405300     SET MBIORO-READ-RANDOM      TO TRUE.
405400     PERFORM MMFSAO-ACCESS       THRU MMFSAO-ACCESS-EXIT.
405500*
405600     IF  NOT MMFS-REC-ACTIVE
405700         MOVE MBIORO-IO-REQUEST  TO MBCA-ERRR-IO-REQUEST
405800         MOVE MBIORO-FILE-NAME   TO MBCA-ERRR-EIBDS
405900         MOVE EIBFN              TO MBCA-ERRR-EIBFN-CODES
406000         MOVE MBCA-PROGRAM-ID    TO MBCA-ERRR-BAD-PROGRAM
406100         MOVE MBCA-TRANS-ID      TO MBCA-ERRR-BAD-TRANSID
406200         SET MBCA-ERROR-MSGS-PROVIDED
406300                                 TO TRUE
406400         MOVE 'READ ERROR - MMFSAO'
406500                                 TO MBCA-ERRR-MSG1
406600         MOVE 'FIELD SECURITY PROFILE IS NOT ACTIVE'
406700                                 TO MBCA-ERRR-MSG2
406800         GO TO MB70PD-ERROR-ROUTINE.
406900*
407000 Y909-READ-MMFS-EXIT.
407100     EXIT.
407200*
407300 Y920-WRITE-LOG-RECORD.
407400*
407500     SET MBIORO-WRITE            TO TRUE.
407600     PERFORM MML1AO-ACCESS       THRU MML1AO-ACCESS-EXIT.
407700     MOVE SPACES                 TO MML1-VARIABLE-AREA.
407800*
407900 Y929-WLR-EXIT.
408000     EXIT.
408100*
408200/
408300 Z000-COPIED-ROUTINES SECTION.
408400*
408500*********************************
408600*    DATE VALIDATION ROUTINE    *
408700*********************************
408800*
408900     COPY SS05PD.
409000/
409100**********************************
409200*    GREG TO JUL DATE ROUTINE    *
409300**********************************
409400*
409500     COPY SS07PD.
409600*
409700/    NEW ROUTINE FOR JULIAN TO GREGORIAN CONVERSION
409800     COPY SS26PD.
409900*
410000/    ROUTINE TO NUMERICALLY EDIT TIME
410100     COPY SS27PD.
410200*
410300**********************************
410400*    JUL TO GREG DATE ROUTINE    *
410500**********************************
410600*
410700     COPY SS08PD.
410800*
410900/    ROUTINE TO MOVE COMMAREA VARIABLES TO
411000*                    SS08-FORMATTED-MSG VARIABLE.
411100     COPY MB06PD.
411200/
411300*********************************
411400*    LINE 24 PF KEYS ROUTINE    *
411500*********************************
411600*
411700     COPY SS15PD.
411800/
411900*********************************************
412000*    ORGANIZATION RECORD ACCESS ROUTINES    *
412100*********************************************
412200*
412300     COPY MMOCAO.
412400/
412500************************************************
412600*    STORE MASTER RECORD ACCESS ROUTINES       *
412700************************************************
412800*
412900     COPY MMSMAO.
413000/
413100************************************************
413200*    MERCHANT PRODUCT RECORD ACCESS ROUTINES   *
413300************************************************
413400*
413500     COPY MMMPAO.
413600/
413700***********************************************
413800*    FIELD SECURITY RECORD ACCESS ROUTINES    *
413900***********************************************
414000*
414100     COPY MMFSAO.
414200/
414300*****************************************
414400*    LOG FILE RECORD ACCESS ROUTINES    *
414500*****************************************
414600*
414700     COPY MML1AO.
414800/
414900     COPY SMCAPXO REPLACING ==:XXCA:== BY ==MBCA==.
415000/
415100*****************************
415200*    ONLINE MAP ROUTINES    *
415300*****************************
415400*
415500     COPY MB60PD REPLACING 'MBMAPXX' BY 'MBMS08 '
415600                           MBMAPXXI  BY MBMS08I
415700                           MBMAPXXO  BY MBMS08O.
415800/
415900***************************
416000*    ONLINE PROCEDURES    *
416100***************************
416200*
416300     COPY MB70PD.
416400/
416500     COPY SMFTPXO.
