000100 IDENTIFICATION DIVISION.
000200 PROGRAM-ID. MBOSM01.
000201*       RELEASE DATE=08/24/01.        REVISION LEVEL=08.06      * ++++++++
000202***************************************************************** ++++++++
000203*WARNING.  THIS COMPUTER PROGRAM IS PROTECTED BY COPYRIGHT LAW  * ++++++++
000204*AND INTERNATIONAL TREATIES.  UNAUTHORIZED REPRODUCTION OR      * ++++++++
000205*DISTRIBUTION OF THIS PROGRAM, OR ANY PORTION OF IT, MAY RESULT * ++++++++
000206*IN SEVERE CIVIL AND CRIMINAL PENATLIES, AND WILL BE PROSECUTED * ++++++++
000207*TO THE MAXIMUM EXTENT POSSIBLE UNDER THE LAW.                  * ++++++++
000208*COPYRIGHT 1999 PAYSYS INTERNATIONAL, INC.  ALL RIGHTS RESERVED.* ++++++++
000209***************************************************************** ++++++++
000300*****************************************************************
000400*                                                               *
000500*   V - PLUS  M E R C H A N T   B A N K C A R D   S Y S T E M   *
000600*                                                               *
000700*      MBOSM01 - ON-LINE MERCHANT STATISTICS INQUIRY            *
000800*                SCREENS 01 - 17                                *
000900*                                                               *
001000*              1. TRANSIDS                                      *
001100*                 A. MBSM                                       *
001200*              2. MAPS USED -                                   *
001300*                 A. MBSM01 (STATISTICS MAP 01-14)              *
001400*              3. FILES USED -                                  *
001500*                 A. MMCG   (MERCH/PROD/CRED PLAN GROUP STATS)  *
001600*                 B. MMCP   (MERCH PROD CREDIT PLAN STATS FILE) *
001700*                 C. MMCS   (STORE PROD CREDIT PLAN STATS FILE) *
001800*                 D. MMOG   (OUTGOING INTCHG GROUP STATS FILE)  *
001900*                 E. MMOI   (OUTGOING INTERCHANGE STATS FILE)   *
002000*                 F. MMPA   (MERCHANT/PRODUCT STATISTICS FILE)  *
002100*                 G. MMPG   (MERCH/PRODUCT GROUP STATS FILE)    *
002200*                 H. MMPS   (STORE PRODUCT STATISTICS FILE)     *
002300*                 I. MMPX   (MERCH PROD EXP GROUP STATS FILE)   *
002400*                 J. MMOX   (OUTGOING INTCH EXP GROUP STAT FILE)*
002500*                 K. MMPE   (MERCH PROD EXP STATS)              *
002600*                 L. MMOE   (OUTGOING INTCH EXP STATS FILE)     *
002700*                 M. MMRG   (STORE CHAIN PROD STATS FILE)       *
002800*                 N. MMLG   (STORE PROD CREIDT PLAN GROUP FILE) *
002900*                 O. MMFG   (GROUP FEE ACTIVITY MASTER FILE)    *
003000*                 P. MMFA   (FEE ACTIVITY MASTER FILE)          *
003100*                                                               *
003200*****************************************************************
003300*
003400 ENVIRONMENT DIVISION.
003500 DATA DIVISION.
003600 WORKING-STORAGE SECTION.
003700 01  FILLER                  PIC  X(12)      VALUE '** WS-BEG **'.
003800*         I/O REQUEST BLOCK WORK AREAS
003900     COPY MBIOWS.
004000/         I/O REQUEST BLOCK
004100     COPY MBIORO.
004200/         FORMAT NBR AND AMT WORK AREAS
004300     COPY SS95WS.
004400/         DYNAMIC ALLOC ROUTINS
004500     COPY MB00WS.
004600/         QUALIFICATION LEVEL DESCRIPTIONS
004700     COPY MB80WS.
004800/         DATE WORK AREAS
004900     COPY SS01WS.
005000/         ONLINE WORK AREAS
005100     COPY SS08WS.
005200/
005300     COPY SS00WS.
005400/
005500     COPY SMFTWS.
005600/
005700     COPY SMPTRL REPLACING ==:SMPT:== BY ==SMPT==.
005800/
005900     COPY MB61LK.
006000/         DEF/GEN TRANS TABLE/DESCRIPTIONS
006100     COPY MMGDTB.
006200/
006300 01  WS-WORK-AREAS.
006400*
006500     03  WS-SAVE-EIBAID      PIC  X(01)      VALUE SPACES.
006600*
006700     03  WS-HOLD-PAGE-COUNT  PIC S9(04)      BINARY VALUE ZEROES.
006800     03  WS-HOLD-DESC-LINE.
006900         05  WS-HOLD-DESC    PIC  X(16)      VALUE SPACES.
007000*
007100     03  WS-STATS-OCCURS-LINE.
007200         05  WS-STATS-OCCURS-POS1.
007300             07  FILLER      PIC  X(09)      VALUE '*------- '.
007400             07  WS-STATS-POS1-LIT
007500                             PIC  X(14).
007600             07  FILLER      PIC  X(08)      VALUE ' -------'.
007700             07  FILLER      PIC  X(01)      VALUE '*'.
007800         05  WS-STATS-OCCURS-POS2.
007900             07  FILLER      PIC  X(08)      VALUE '------- '.
008000             07  WS-STATS-POS2-LIT
008100                             PIC  X(14).
008200             07  FILLER      PIC  X(09)      VALUE ' -------*'.
008300*
008400     03  WS-STATS-ACTIVITY-LINE.
008500         05  WS-STATS-ACTIVITY-LINE-1.
008600             07  FILLER      PIC  X(17)      VALUE
008700                                             '*---ACTIVITY----*'.
008800             07  FILLER      PIC  X(10)      VALUE
008900                                             '---NBR---*'.
009000             07  FILLER      PIC  X(21)      VALUE
009100                                      '------AMOUNT--------*'.
009200         05  WS-STATS-ACTIVITY-LINE-2.
009300             07  FILLER      PIC  X(10)      VALUE
009400                                             '---NBR---*'.
009500             07  FILLER      PIC  X(21)      VALUE
009600                                      '------AMOUNT--------*'.
009700*
009800     03  WS-STATS-NBR-LINE.
009900         05  WS-STATS-NBR-LINE-1.
010000             07  FILLER      PIC  X(17)      VALUE
010100                                             '*---ACTIVITY----*'.
010200             07  FILLER      PIC  X(10)      VALUE
010300                                             '---NBR---*'.
010400             07  FILLER      PIC  X(21)      VALUE
010500                                          '------AMOUNT--------*'.RG800902
010600         05  WS-STATS-NBR-LINE-2.
010700             07  FILLER      PIC  X(10)      VALUE
010800                                             '---NBR---*'.
010900             07  FILLER      PIC  X(21)      VALUE
011000                                          '------AMOUNT--------*'.RG800902
011100*
011200     03  WS-SEARCH-FLAG      PIC  X(01).
011300         88  WS-SEARCH-FOUND                 VALUE 'Y'.
011400         88  WS-SEARCH-NOT-FOUND             VALUE 'N'.
011500*
011600     03  WS-SEARCH-LM-PL-KEY.
011700         05  WS-SEARCH-LM-PL-CM-FLAG
011800                             PIC  X(01).
011900         05  WS-SEARCH-LM-PL-SUB-FLAG
012000                             PIC  X(01).
012100         05  WS-SEARCH-LM-PL-LOGIC-MODULE
012200                             PIC  9(03).
012300*
012400     03  WS-SEARCH-PAGE-TITLE-KEY.
012500         05  WS-SEARCH-PT-CM-FLAG
012600                             PIC  X(01).
012700             88  WS-SEARCH-PT-CM-GENERIC     VALUE 'X'.
012800         05  WS-SEARCH-PT-SUB-FLAG
012900                             PIC  X(01).
013000             88  WS-SEARCH-PT-SUB-GENERIC    VALUE 'X'.
013100         05  WS-SEARCH-PT-PAGE-NBR
013200                             PIC  9(02).
013300*
013400     03  WS-BUBBLE-SORT-SW   PIC  X(01)      VALUE 'Y'.
013500         88  WS-BUBBLE-SORT-SWAP             VALUE 'Y'.
013600         88  WS-BUBBLE-SORT-NO-SWAP          VALUE 'N'.
013700*
013800     03  TS-QUEUE-NAME.
013900         05  TS-QN-TERMID    PIC  X(04)      VALUE SPACES.
014000         05  TS-QN-TRANID    PIC  X(04)      VALUE 'MBSM'.
014100*
014200****
014300**** THIS TABLE CONTAINS TITLES FOR EACH SCREEN PAGE
014400****
014500     03  WS-PAGE-TITLE-TABLE.
014600*
014700*   MERCHANT CHAIN CREDIT PLAN
014800*
014900         05  FILLER          PIC  X(44)      VALUE
015000              'CC01         MERCHANT CHAIN CREDITS         '.
015100         05  FILLER          PIC  X(44)      VALUE
015200              'CC02         MERCHANT CHAIN DEBITS          '.
015300         05  FILLER          PIC  X(44)      VALUE
015400              'CC14          MERCHANT CHAIN MEMOS          '.
015500         05  FILLER          PIC  X(44)      VALUE
015600              'CC15        MERCHANT CHAIN USER MEMOS       '.
015700         05  FILLER          PIC  X(44)      VALUE
015800              'CC16        MERCHANT CHAIN USER MEMOS       '.
015900*
016000*   MERCHANT CHAIN PRODUCTS
016100*
016200         05  FILLER          PIC  X(44)      VALUE
016300              'CP01       MERCHANT CHAIN SETTLEMENT        '.
016400         05  FILLER          PIC  X(44)      VALUE
016500              'CP02        MERCHANT CHAIN DEPOSITS         '.
016600         05  FILLER          PIC  X(44)      VALUE
016700              'CP03 MERCHANT CHAIN DISCOUNT/PARTICIPATION  '.
016800         05  FILLER          PIC  X(44)      VALUE
016900              'CP04        MERCHANT CHAIN RESERVES         '.
017000         05  FILLER         PIC  X(44)      VALUE
017100              'CP05       MERCHANT CHAIN SYSTEM FEES       '.
017200         05  FILLER          PIC  X(44)      VALUE
017300              'CP06       MERCHANT CHAIN SYSTEM FEES       '.
017400         05  FILLER          PIC  X(44)      VALUE
017500              'CP07       MERCHANT CHAIN SYSTEM FEES       '.
017600         05  FILLER          PIC  X(44)      VALUE
017700              'CP08         MERCHANT CHAIN USER FEES       '.
017800         05  FILLER          PIC  X(44)      VALUE
017900              'CP09      MERCHANT CHAIN USER CREDITS       '.
018000         05  FILLER          PIC  X(44)      VALUE
018100              'CP10      MERCHANT CREDIT ADJUSTMENTS       '.
018200         05  FILLER          PIC  X(44)      VALUE
018300              'CP11       MERCHANT DEBIT ADJUSTMENTS       '.
018400         05  FILLER          PIC  X(44)      VALUE
018500              'CP12     MERCHANT CHAIN F/E ADJUSTMENTS     '.
018600         05  FILLER          PIC  X(44)      VALUE
018700              'CP13     MERCHANT CHAIN C/H ADJUSTMENTS     '.
018800         05  FILLER          PIC  X(44)      VALUE
018900              'CP14         MERCHANT CHAIN MEMOS           '.
019000         05  FILLER          PIC  X(44)      VALUE
019100              'CP15       MERCHANT CHAIN USER MEMOS        '.
019200         05  FILLER          PIC  X(44)      VALUE
019300              'CP16       MERCHANT CHAIN USER MEMOS        '.
019400         05  FILLER          PIC  X(44)      VALUE
019500              'CP17    MERCHANT CHAIN FEE BASE ACTIVITY    '.
019600*
019700*   MERCHANT CHAIN TOTALS
019800*
019900         05  FILLER          PIC  X(44)      VALUE
020000              'CT01       MERCHANT CHAIN SETTLEMENT        '.
020100         05  FILLER          PIC  X(44)      VALUE
020200              'CT02        MERCHANT CHAIN DEPOSITS         '.
020300         05  FILLER          PIC  X(44)      VALUE
020400              'CT03 MERCHANT CHAIN DISCOUNT/PARTICIPATION  '.
020500         05  FILLER          PIC  X(44)      VALUE
020600              'CT04        MERCHANT CHAIN RESERVES         '.
020700         05  FILLER         PIC  X(44)      VALUE
020800              'CT05       MERCHANT CHAIN SYSTEM FEES       '.
020900         05  FILLER          PIC  X(44)      VALUE
021000              'CT06       MERCHANT CHAIN SYSTEM FEES       '.
021100         05  FILLER          PIC  X(44)      VALUE
021200              'CT07       MERCHANT CHAIN SYSTEM FEES       '.
021300         05  FILLER          PIC  X(44)      VALUE
021400              'CT08         MERCHANT CHAIN USER FEES       '.
021500         05  FILLER          PIC  X(44)      VALUE
021600              'CT09      MERCHANT CHAIN USER CREDITS       '.
021700         05  FILLER          PIC  X(44)      VALUE
021800              'CT10   MERCHANT CHAIN CREDIT ADJUSTMENTS    '.
021900         05  FILLER          PIC  X(44)      VALUE
022000              'CT11    MERCHANT CHAIN DEBIT ADJUSTMENTS    '.
022100         05  FILLER          PIC  X(44)      VALUE
022200              'CT12     MERCHANT CHAIN F/E ADJUSTMENTS     '.
022300         05  FILLER          PIC  X(44)      VALUE
022400              'CT13     MERCHANT CHAIN C/H ADJUSTMENTS     '.
022500         05  FILLER          PIC  X(44)      VALUE
022600              'CT14         MERCHANT CHAIN MEMOS           '.
022700         05  FILLER          PIC  X(44)      VALUE
022800              'CT15        MERCHANT CHAIN USER MEMOS       '.
022900         05  FILLER          PIC  X(44)      VALUE
023000              'CT16        MERCHANT CHAIN USER MEMOS       '.
023100         05  FILLER          PIC  X(44)      VALUE
023200              'CT17    MERCHANT CHAIN FEE BASE ACTIVITY    '.
023300*
023400*   MERCHANT CREDIT PLAN
023500*
023600         05  FILLER          PIC  X(44)      VALUE
023700              'MC01            MERCHANT CREDITS            '.
023800         05  FILLER          PIC  X(44)      VALUE
023900              'MC02            MERCHANT DEBITS             '.
024000         05  FILLER          PIC  X(44)      VALUE
024100              'MC14             MERCHANT MEMOS             '.
024200         05  FILLER          PIC  X(44)      VALUE
024300              'MC15          MERCHANT USER MEMOS           '.
024400         05  FILLER          PIC  X(44)      VALUE
024500              'MC16          MERCHANT USER MEMOS           '.
024600*
024700*   MERCHANT PRODUCTS
024800*
024900         05  FILLER          PIC  X(44)      VALUE
025000              'MP01          MERCHANT SETTLEMENT           '.
025100         05  FILLER          PIC  X(44)      VALUE
025200              'MP02           MERCHANT DEPOSITS            '.
025300         05  FILLER          PIC  X(44)      VALUE
025400              'MP03    MERCHANT DISCOUNT/PARTICIPATION     '.
025500         05  FILLER          PIC  X(44)      VALUE
025600              'MP04           MERCHANT RESERVES            '.
025700         05  FILLER          PIC  X(44)      VALUE
025800              'MP05          MERCHANT SYSTEM FEES          '.
025900         05  FILLER          PIC  X(44)      VALUE
026000              'MP06          MERCHANT SYSTEM FEES          '.
026100         05  FILLER          PIC  X(44)      VALUE
026200              'MP07          MERCHANT SYSTEM FEES          '.
026300         05  FILLER          PIC  X(44)      VALUE
026400              'MP08            MERCHANT USER FEES          '.
026500         05  FILLER          PIC  X(44)      VALUE
026600              'MP09          MERCHANT USER CREDITS         '.
026700         05  FILLER          PIC  X(44)      VALUE
026800              'MP10      MERCHANT CREDIT ADJUSTMENTS       '.
026900         05  FILLER          PIC  X(44)      VALUE
027000              'MP11       MERCHANT DEBIT ADJUSTMENTS       '.
027100         05  FILLER          PIC  X(44)      VALUE
027200              'MP12        MERCHANT F/E ADJUSTMENTS        '.
027300         05  FILLER          PIC  X(44)      VALUE
027400              'MP13        MERCHANT C/H ADJUSTMENTS        '.
027500         05  FILLER          PIC  X(44)      VALUE
027600              'MP14             MERCHANT MEMOS             '.
027700         05  FILLER          PIC  X(44)      VALUE
027800              'MP15          MERCHANT USER MEMOS           '.
027900         05  FILLER          PIC  X(44)      VALUE
028000              'MP16          MERCHANT USER MEMOS           '.
028100         05  FILLER          PIC  X(44)      VALUE
028200              'MP17       MERCHANT FEE BASE ACTIVITY       '.
028300*
028400*   MERCHANT TOTALS
028500*
028600         05  FILLER          PIC  X(44)      VALUE
028700              'MT01          MERCHANT SETTLEMENT           '.
028800         05  FILLER          PIC  X(44)      VALUE
028900              'MT02           MERCHANT DEPOSITS            '.
029000         05  FILLER          PIC  X(44)      VALUE
029100              'MT03    MERCHANT DISCOUNT/PARTICIPATION     '.
029200         05  FILLER          PIC  X(44)      VALUE
029300              'MT04           MERCHANT RESERVES            '.
029400         05  FILLER          PIC  X(44)      VALUE
029500              'MT05          MERCHANT SYSTEM FEES          '.
029600         05  FILLER          PIC  X(44)      VALUE
029700              'MT06          MERCHANT SYSTEM FEES          '.
029800         05  FILLER          PIC  X(44)      VALUE
029900              'MT07          MERCHANT SYSTEM FEES          '.
030000         05  FILLER          PIC  X(44)      VALUE
030100              'MT08            MERCHANT USER FEES          '.
030200         05  FILLER          PIC  X(44)      VALUE
030300              'MT09          MERCHANT USER CREDITS         '.
030400         05  FILLER          PIC  X(44)      VALUE
030500              'MT10      MERCHANT CREDIT ADJUSTMENTS       '.
030600         05  FILLER          PIC  X(44)      VALUE
030700              'MT11       MERCHANT DEBIT ADJUSTMENTS       '.
030800         05  FILLER          PIC  X(44)      VALUE
030900              'MT12        MERCHANT F/E ADJUSTMENTS        '.
031000         05  FILLER          PIC  X(44)      VALUE
031100              'MT13        MERCHANT C/H ADJUSTMENTS        '.
031200         05  FILLER          PIC  X(44)      VALUE
031300              'MT14            MERCHANT MEMOS              '.
031400         05  FILLER          PIC  X(44)      VALUE
031500              'MT15          MERCHANT USER MEMOS           '.
031600         05  FILLER          PIC  X(44)      VALUE
031700              'MT16          MERCHANT USER MEMOS           '.
031800         05  FILLER          PIC  X(44)      VALUE
031900              'MT17       MERCHANT FEE BASE ACTIVITY       '.
032000*
032100*   STORE CREDIT PLAN
032200*
032300         05  FILLER          PIC  X(44)      VALUE
032400              'SC01             STORE CREDITS              '.
032500         05  FILLER          PIC  X(44)      VALUE
032600              'SC02              STORE DEBITS              '.
032700         05  FILLER          PIC  X(44)      VALUE
032800              'SC03              STORE MEMOS               '.
032900         05  FILLER          PIC  X(44)      VALUE
033000              'SC04            STORE USER MEMOS            '.
033100         05  FILLER          PIC  X(44)      VALUE
033200              'SC05            STORE USER MEMOS            '.
033300         05  FILLER          PIC  X(44)      VALUE
033400              'SC06              STORE MEMOS               '.
033500         05  FILLER          PIC  X(44)      VALUE
033600              'SC07            STORE USER MEMOS            '.
033700         05  FILLER          PIC  X(44)      VALUE
033800              'SC08            STORE USER MEMOS            '.
033900         05  FILLER          PIC  X(44)      VALUE
034000              'SC14               STORE MEMOS              '.
034100         05  FILLER          PIC  X(44)      VALUE
034200              'SC15             STORE USER MEMOS           '.
034300         05  FILLER          PIC  X(44)      VALUE
034400              'SC16             STORE USER MEMOS           '.
034500*
034600*   STORE PRODUCTS
034700*
034800         05  FILLER          PIC  X(44)      VALUE
034900              'SP02            STORE DEPOSITS              '.
035000         05  FILLER          PIC  X(44)      VALUE
035100              'SP03      STORE DISCOUNT/PARTICIPATION      '.
035200         05  FILLER          PIC  X(44)      VALUE
035300              'SP10        STORE CREDIT ADJUSTMENTS        '.
035400         05  FILLER          PIC  X(44)      VALUE
035500              'SP11        STORE DEBIT ADJUSTMENTS         '.
035600         05  FILLER          PIC  X(44)      VALUE
035700              'SP12         STORE F/E ADJUSTMENTS          '.
035800         05  FILLER          PIC  X(44)      VALUE
035900              'SP13         STORE C/H ADJUSTMENTS          '.
036000         05  FILLER          PIC  X(44)      VALUE
036100              'SP14              STORE MEMOS               '.
036200         05  FILLER          PIC  X(44)      VALUE
036300              'SP15            STORE USER MEMOS            '.
036400         05  FILLER          PIC  X(44)      VALUE
036500              'SP16            STORE USER MEMOS            '.
036600*
036700*   STORE TOTALS
036800*
036900         05  FILLER          PIC  X(44)      VALUE
037000              'ST02            STORE DEPOSITS              '.
037100         05  FILLER          PIC  X(44)      VALUE
037200              'ST03      STORE DISCOUNT/PARTICIPATION      '.
037300         05  FILLER          PIC  X(44)      VALUE
037400              'ST10        STORE CREDIT ADJUSTMENTS        '.
037500         05  FILLER          PIC  X(44)      VALUE
037600              'ST11        STORE DEBIT ADJUSTMENTS         '.
037700         05  FILLER          PIC  X(44)      VALUE
037800              'ST12         STORE F/E ADJUSTMENTS          '.
037900         05  FILLER          PIC  X(44)      VALUE
038000              'ST13         STORE C/H ADJUSTMENTS          '.
038100         05  FILLER          PIC  X(44)      VALUE
038200              'ST14              STORE MEMOS               '.
038300         05  FILLER          PIC  X(44)      VALUE
038400              'ST15            STORE USER MEMOS            '.
038500         05  FILLER          PIC  X(44)      VALUE
038600              'ST16            STORE USER MEMOS            '.
038700*
038800*   STORE CHAIN CREDIT PLAN
038900*
039000         05  FILLER          PIC  X(44)      VALUE
039100              'ZC01          STORE CHAIN CREDITS           '.
039200         05  FILLER          PIC  X(44)      VALUE
039300              'ZC02           STORE CHAIN DEBITS           '.
039400         05  FILLER          PIC  X(44)      VALUE
039500              'ZC14           STORE CHAIN MEMOS            '.
039600         05  FILLER          PIC  X(44)      VALUE
039700              'ZC15         STORE CHAIN USER MEMOS         '.
039800         05  FILLER          PIC  X(44)      VALUE
039900              'ZC16         STORE CHAIN USER MEMOS         '.
040000*
040100*   STORE CHAIN PRODUCTS
040200*
040300         05  FILLER          PIC  X(44)      VALUE
040400              'ZP02          STORE CHAIN DEPOSITS          '.
040500         05  FILLER          PIC  X(44)      VALUE
040600              'ZP03   STORE CHAIN DISCOUNT/PARTICIPATION   '.
040700         05  FILLER          PIC  X(44)      VALUE
040800              'ZP10     STORE CHAIN CREDIT ADJUSTMENTS     '.
040900         05  FILLER          PIC  X(44)      VALUE
041000              'ZP11     STORE CHAIN DEBIT ADJUSTMENTS      '.
041100         05  FILLER          PIC  X(44)      VALUE
041200              'ZP12      STORE CHAIN F/E ADJUSTMENTS       '.
041300         05  FILLER          PIC  X(44)      VALUE
041400              'ZP13      STORE CHAIN C/H ADJUSTMENTS       '.
041500         05  FILLER          PIC  X(44)      VALUE
041600              'ZP14           STORE CHAIN MEMOS            '.
041700         05  FILLER          PIC  X(44)      VALUE
041800              'ZP15         STORE CHAIN USER MEMOS         '.
041900         05  FILLER          PIC  X(44)      VALUE
042000              'ZP16         STORE CHAIN USER MEMOS         '.
042100*
042200*   STORE CHAIN TOTALS
042300*
042400         05  FILLER          PIC  X(44)      VALUE
042500              'ZT02          STORE CHAIN DEPOSITS          '.
042600         05  FILLER          PIC  X(44)      VALUE
042700              'ZT03   STORE CHAIN DISCOUNT/PARTICIPATION   '.
042800         05  FILLER          PIC  X(44)      VALUE
042900              'ZT10     STORE CHAIN CREDIT ADJUSTMENTS     '.
043000         05  FILLER          PIC  X(44)      VALUE
043100              'ZT11     STORE CHAIN DEBIT ADJUSTMENTS      '.
043200         05  FILLER          PIC  X(44)      VALUE
043300              'ZT12      STORE CHAIN F/E ADJUSTMENTS       '.
043400         05  FILLER          PIC  X(44)      VALUE
043500              'ZT13      STORE CHAIN C/H ADJUSTMENTS       '.
043600         05  FILLER          PIC  X(44)      VALUE
043700              'ZT14           STORE CHAIN MEMOS            '.
043800         05  FILLER          PIC  X(44)      VALUE
043900              'ZT15         STORE CHAIN USER MEMOS         '.
044000         05  FILLER          PIC  X(44)      VALUE
044100              'ZT16         STORE CHAIN USER MEMOS         '.
044200     03  WS-PAGE-TITLE-TABLE-R
044300                             REDEFINES WS-PAGE-TITLE-TABLE.
044400         05  WS-PAGE-TITLE-ENTRIES.
044500             07  WS-PAGE-TITLE-ENTRY         OCCURS 130 TIMES
044600                                             ASCENDING KEY IS
044700                                             WS-PAGE-TITLE-KEY
044800                                             INDEXED BY
044900                                             X-WS-PAGE-TITLE.
045000                 09  WS-PAGE-TITLE-KEY.
045100                     11  WS-PAGE-TITLE-CM-FLAG
045200                             PIC  X(01).
045300                         88  WS-PAGE-TITLE-CM-GENERIC
045400                                             VALUE 'X'.
045500                     11  WS-PAGE-TITLE-SUB-FLAG
045600                             PIC  X(01).
045700                         88  WS-PAGE-TITLE-SUB-GENERIC
045800                                             VALUE 'X'.
045900                     11  WS-PAGE-TITLE-PAGE-NBR
046000                             PIC  9(02).
046100                 09  WS-PAGE-TITLE-DESC
046200                             PIC  X(40).
046300*                                                               *
046400*****************************************************************
046500*                                                               *
046600*   THIS TABLE INDICATES THE PAGE NUMBER FOR EACH LOGIC MODULE  *
046700*                                                               *
046800* THE FIRST TWO BYTES INDICATE THE CODE AND SUB-CODE FROM THE   *
046900* TYPE OF KEY SELECTED.  THESE ARE MATCHED AGAINST THE FIELDS   *
047000* IN THE COMM AREA, AS FOLLOWS:                                 *
047100*    BYTE 1 = MBCA-MBSM-CM-FLAG                                 *
047200*    BYTE 2 = MBCA-MBSM-SUB-FLAG                                *
047300*                                                               *
047400* THE NEXT THREE BYTES INDICATE THE LOGIC MODULE NUMBER.        *
047500*                                                               *
047600* THE NEXT FOUR BYTES ARE THE PAGE NUMBER AND LINE NUMBER       *
047700* WHERE THAT LOGIC MODULE WILL APPEAR ON THE SCREEN.            *
047800*                                                               *
047900* NOTE: THIS TABLE IS KEPT IN ASCENDING ORDER ON THE FIRST      *
048000* FIVE BYTES SO THAT A BINARY SEARCH IS USED TO LOCATE EACH     *
048100* GIVEN LOGIC MODULE TO DETERMINE THE PAGE/LINE NBR ON WHICH    *
048200* IT SHOULD BE DISPLAYED.                                       *
048300*                                                               *
048400*****************************************************************
048500*
048600     03  WS-LOGIC-MOD-PAGE-TABLE.
048700         05  FILLER          PIC  X(09)      VALUE 'CC0020105'.
048800         05  FILLER          PIC  X(09)      VALUE 'CC0241201'.
048900         05  FILLER          PIC  X(09)      VALUE 'CC0300103'.
049000         05  FILLER          PIC  X(09)      VALUE 'CC0310104'.
049100         05  FILLER          PIC  X(09)      VALUE 'CC1020205'.
049200         05  FILLER          PIC  X(09)      VALUE 'CC1300203'.
049300         05  FILLER          PIC  X(09)      VALUE 'CC1310204'.
049400         05  FILLER          PIC  X(09)      VALUE 'CC2010101'.
049500         05  FILLER          PIC  X(09)      VALUE 'CC2080102'.
049600         05  FILLER          PIC  X(09)      VALUE 'CC3010202'.
049700         05  FILLER          PIC  X(09)      VALUE 'CC3080201'.
049800         05  FILLER          PIC  X(09)      VALUE 'CC9021401'.
049900         05  FILLER          PIC  X(09)      VALUE 'CC9121402'.
050000         05  FILLER          PIC  X(09)      VALUE 'CC9211501'.
050100         05  FILLER          PIC  X(09)      VALUE 'CC9221502'.
050200         05  FILLER          PIC  X(09)      VALUE 'CC9231503'.
050300         05  FILLER          PIC  X(09)      VALUE 'CC9241504'.
050400         05  FILLER          PIC  X(09)      VALUE 'CC9251505'.
050500         05  FILLER          PIC  X(09)      VALUE 'CC9261506'.
050600         05  FILLER          PIC  X(09)      VALUE 'CC9271507'.
050700         05  FILLER          PIC  X(09)      VALUE 'CC9281508'.
050800         05  FILLER          PIC  X(09)      VALUE 'CC9291509'.
050900         05  FILLER          PIC  X(09)      VALUE 'CC9301510'.
051000         05  FILLER          PIC  X(09)      VALUE 'CC9311601'.
051100         05  FILLER          PIC  X(09)      VALUE 'CC9321602'.
051200         05  FILLER          PIC  X(09)      VALUE 'CC9331603'.
051300         05  FILLER          PIC  X(09)      VALUE 'CC9341604'.
051400         05  FILLER          PIC  X(09)      VALUE 'CC9351605'.
051500         05  FILLER          PIC  X(09)      VALUE 'CC9361606'.
051600         05  FILLER          PIC  X(09)      VALUE 'CC9371607'.
051700         05  FILLER          PIC  X(09)      VALUE 'CC9381608'.
051800         05  FILLER          PIC  X(09)      VALUE 'CC9391609'.
051900         05  FILLER          PIC  X(09)      VALUE 'CC9401610'.
052000         05  FILLER          PIC  X(09)      VALUE 'CC9921403'.
052100         05  FILLER          PIC  X(09)      VALUE 'CP0021301'.
052200         05  FILLER          PIC  X(09)      VALUE 'CP0031302'.
052300         05  FILLER          PIC  X(09)      VALUE 'CP0041303'.
052400         05  FILLER          PIC  X(09)      VALUE 'CP0121001'.
052500         05  FILLER          PIC  X(09)      VALUE 'CP0131002'.
052600         05  FILLER          PIC  X(09)      VALUE 'CP0161003'.
052700         05  FILLER          PIC  X(09)      VALUE 'CP0171004'.
052800         05  FILLER          PIC  X(09)      VALUE 'CP0181005'.
052900         05  FILLER          PIC  X(09)      VALUE 'CP0191006'.
053000         05  FILLER          PIC  X(09)      VALUE 'CP0241201'.
053100         05  FILLER          PIC  X(09)      VALUE 'CP0251007'.
053200         05  FILLER          PIC  X(09)      VALUE 'CP0261008'.
053300         05  FILLER          PIC  X(09)      VALUE 'CP0271009'.
053400         05  FILLER          PIC  X(09)      VALUE 'CP0281010'.
053500         05  FILLER          PIC  X(09)      VALUE 'CP0291011'.
053600         05  FILLER          PIC  X(09)      VALUE 'CP0300301'.
053700         05  FILLER          PIC  X(09)      VALUE 'CP0310302'.
053800         05  FILLER          PIC  X(09)      VALUE 'CP0700601'.
053900         05  FILLER          PIC  X(09)      VALUE 'CP1021304'.
054000         05  FILLER          PIC  X(09)      VALUE 'CP1031305'.
054100         05  FILLER          PIC  X(09)      VALUE 'CP1041306'.
054200         05  FILLER          PIC  X(09)      VALUE 'CP1051307'.
054300         05  FILLER          PIC  X(09)      VALUE 'CP1121101'.
054400         05  FILLER          PIC  X(09)      VALUE 'CP1131102'.
054500         05  FILLER          PIC  X(09)      VALUE 'CP1161103'.
054600         05  FILLER          PIC  X(09)      VALUE 'CP1171104'.
054700         05  FILLER          PIC  X(09)      VALUE 'CP1181105'.
054800         05  FILLER          PIC  X(09)      VALUE 'CP1191106'.
054900         05  FILLER          PIC  X(09)      VALUE 'CP1241202'.
055000         05  FILLER          PIC  X(09)      VALUE 'CP1251107'.
055100         05  FILLER          PIC  X(09)      VALUE 'CP1261108'.
055200         05  FILLER          PIC  X(09)      VALUE 'CP1271109'.
055300         05  FILLER          PIC  X(09)      VALUE 'CP1281110'.
055400         05  FILLER          PIC  X(09)      VALUE 'CP1291111'.
055500         05  FILLER          PIC  X(09)      VALUE 'CP1300303'.
055600         05  FILLER          PIC  X(09)      VALUE 'CP1310304'.
055700         05  FILLER          PIC  X(09)      VALUE 'CP1330801'.
055800         05  FILLER          PIC  X(09)      VALUE 'CP1340802'.
055900         05  FILLER          PIC  X(09)      VALUE 'CP1350803'.
056000         05  FILLER          PIC  X(09)      VALUE 'CP1360701'.
056100         05  FILLER          PIC  X(09)      VALUE 'CP1370702'.
056200         05  FILLER          PIC  X(09)      VALUE 'CP1700601'.
056300         05  FILLER          PIC  X(09)      VALUE 'CP2010201'.
056400         05  FILLER          PIC  X(09)      VALUE 'CP2080202'.
056500         05  FILLER          PIC  X(09)      VALUE 'CP3010203'.
056600         05  FILLER          PIC  X(09)      VALUE 'CP3080204'.
056700         05  FILLER          PIC  X(09)      VALUE 'CP4010401'.
056800         05  FILLER          PIC  X(09)      VALUE 'CP4020402'.
056900         05  FILLER          PIC  X(09)      VALUE 'CP4030403'.
057000         05  FILLER          PIC  X(09)      VALUE 'CP4040404'.
057100         05  FILLER          PIC  X(09)      VALUE 'CP9021401'.
057200         05  FILLER          PIC  X(09)      VALUE 'CP9031404'.
057300         05  FILLER          PIC  X(09)      VALUE 'CP9041405'.
057400         05  FILLER          PIC  X(09)      VALUE 'CP9051406'.
057500         05  FILLER          PIC  X(09)      VALUE 'CP9061407'.
057600         05  FILLER          PIC  X(09)      VALUE 'CP9071408'.
057700         05  FILLER          PIC  X(09)      VALUE 'CP9121402'.
057800         05  FILLER          PIC  X(09)      VALUE 'CP9131409'.
057900         05  FILLER          PIC  X(09)      VALUE 'CP9141410'.
058000         05  FILLER          PIC  X(09)      VALUE 'CP9151411'.
058100         05  FILLER          PIC  X(09)      VALUE 'CP9161412'.
058200         05  FILLER          PIC  X(09)      VALUE 'CP9211501'.
058300         05  FILLER          PIC  X(09)      VALUE 'CP9221502'.
058400         05  FILLER          PIC  X(09)      VALUE 'CP9231503'.
058500         05  FILLER          PIC  X(09)      VALUE 'CP9241504'.
058600         05  FILLER          PIC  X(09)      VALUE 'CP9251505'.
058700         05  FILLER          PIC  X(09)      VALUE 'CP9261506'.
058800         05  FILLER          PIC  X(09)      VALUE 'CP9271507'.
058900         05  FILLER          PIC  X(09)      VALUE 'CP9281508'.
059000         05  FILLER          PIC  X(09)      VALUE 'CP9291509'.
059100         05  FILLER          PIC  X(09)      VALUE 'CP9301510'.
059200         05  FILLER          PIC  X(09)      VALUE 'CP9311601'.
059300         05  FILLER          PIC  X(09)      VALUE 'CP9321602'.
059400         05  FILLER          PIC  X(09)      VALUE 'CP9331603'.
059500         05  FILLER          PIC  X(09)      VALUE 'CP9341604'.
059600         05  FILLER          PIC  X(09)      VALUE 'CP9351605'.
059700         05  FILLER          PIC  X(09)      VALUE 'CP9361606'.
059800         05  FILLER          PIC  X(09)      VALUE 'CP9371607'.
059900         05  FILLER          PIC  X(09)      VALUE 'CP9381608'.
060000         05  FILLER          PIC  X(09)      VALUE 'CP9391609'.
060100         05  FILLER          PIC  X(09)      VALUE 'CP9401610'.
060200         05  FILLER          PIC  X(09)      VALUE 'CP9921403'.
060300         05  FILLER          PIC  X(09)      VALUE 'CQ0269907'.
060400         05  FILLER          PIC  X(09)      VALUE 'CQ0709906'.
060500         05  FILLER          PIC  X(09)      VALUE 'CQ1269908'.
060600         05  FILLER          PIC  X(09)      VALUE 'CQ1709905'.
060700         05  FILLER          PIC  X(09)      VALUE 'CQ2019901'.
060800         05  FILLER          PIC  X(09)      VALUE 'CQ2089904'.
060900         05  FILLER          PIC  X(09)      VALUE 'CQ3019903'.
061000         05  FILLER          PIC  X(09)      VALUE 'CQ3089902'.
061100         05  FILLER          PIC  X(09)      VALUE 'CT0000201'.
061200         05  FILLER          PIC  X(09)      VALUE 'CT0021301'.
061300         05  FILLER          PIC  X(09)      VALUE 'CT0031302'.
061400         05  FILLER          PIC  X(09)      VALUE 'CT0041303'.
061500         05  FILLER          PIC  X(09)      VALUE 'CT0111001'.
061600         05  FILLER          PIC  X(09)      VALUE 'CT0121004'.
061700         05  FILLER          PIC  X(09)      VALUE 'CT0131005'.
061800         05  FILLER          PIC  X(09)      VALUE 'CT0141006'.
061900         05  FILLER          PIC  X(09)      VALUE 'CT0151007'.
062000         05  FILLER          PIC  X(09)      VALUE 'CT0161008'.
062100         05  FILLER          PIC  X(09)      VALUE 'CT0171009'.
062200         05  FILLER          PIC  X(09)      VALUE 'CT0181010'.
062300         05  FILLER          PIC  X(09)      VALUE 'CT0191011'.
062400         05  FILLER          PIC  X(09)      VALUE 'CT0201203'.
062500         05  FILLER          PIC  X(09)      VALUE 'CT0211204'.
062600         05  FILLER          PIC  X(09)      VALUE 'CT0221205'.
062700         05  FILLER          PIC  X(09)      VALUE 'CT0231206'.
062800         05  FILLER          PIC  X(09)      VALUE 'CT0241207'.
062900         05  FILLER          PIC  X(09)      VALUE 'CT0251002'.
063000         05  FILLER          PIC  X(09)      VALUE 'CT0261003'.
063100         05  FILLER          PIC  X(09)      VALUE 'CT0271012'.
063200         05  FILLER          PIC  X(09)      VALUE 'CT0281013'.
063300         05  FILLER          PIC  X(09)      VALUE 'CT0291014'.
063400         05  FILLER          PIC  X(09)      VALUE 'CT0300301'.
063500         05  FILLER          PIC  X(09)      VALUE 'CT0310302'.
063600         05  FILLER          PIC  X(09)      VALUE 'CT0560509'.
063700         05  FILLER          PIC  X(09)      VALUE 'CT0570511'.
063800         05  FILLER          PIC  X(09)      VALUE 'CT0700602'.
063900         05  FILLER          PIC  X(09)      VALUE 'CT0710901'.
064000         05  FILLER          PIC  X(09)      VALUE 'CT0720902'.
064100         05  FILLER          PIC  X(09)      VALUE 'CT0730903'.
064200         05  FILLER          PIC  X(09)      VALUE 'CT0740904'.
064300         05  FILLER          PIC  X(09)      VALUE 'CT0750905'.
064400         05  FILLER          PIC  X(09)      VALUE 'CT0760906'.
064500         05  FILLER          PIC  X(09)      VALUE 'CT0770907'.
064600         05  FILLER          PIC  X(09)      VALUE 'CT0780908'.
064700         05  FILLER          PIC  X(09)      VALUE 'CT0790909'.
064800         05  FILLER          PIC  X(09)      VALUE 'CT0800910'.
064900         05  FILLER          PIC  X(09)      VALUE 'CT0910101'.
065000         05  FILLER          PIC  X(09)      VALUE 'CT0920102'.
065100         05  FILLER          PIC  X(09)      VALUE 'CT0930103'.
065200         05  FILLER          PIC  X(09)      VALUE 'CT0940106'.
065300         05  FILLER          PIC  X(09)      VALUE 'CT0950104'.
065400         05  FILLER          PIC  X(09)      VALUE 'CT0960105'.
065500         05  FILLER          PIC  X(09)      VALUE 'CT1000202'.
065600         05  FILLER          PIC  X(09)      VALUE 'CT1021304'.
065700         05  FILLER          PIC  X(09)      VALUE 'CT1031305'.
065800         05  FILLER          PIC  X(09)      VALUE 'CT1041306'.
065900         05  FILLER          PIC  X(09)      VALUE 'CT1051307'.
066000         05  FILLER          PIC  X(09)      VALUE 'CT1111101'.
066100         05  FILLER          PIC  X(09)      VALUE 'CT1121104'.
066200         05  FILLER          PIC  X(09)      VALUE 'CT1131105'.
066300         05  FILLER          PIC  X(09)      VALUE 'CT1141106'.
066400         05  FILLER          PIC  X(09)      VALUE 'CT1151107'.
066500         05  FILLER          PIC  X(09)      VALUE 'CT1161108'.
066600         05  FILLER          PIC  X(09)      VALUE 'CT1171109'.
066700         05  FILLER          PIC  X(09)      VALUE 'CT1181110'.
066800         05  FILLER          PIC  X(09)      VALUE 'CT1191111'.
066900         05  FILLER          PIC  X(09)      VALUE 'CT1201208'.
067000         05  FILLER          PIC  X(09)      VALUE 'CT1211209'.
067100         05  FILLER          PIC  X(09)      VALUE 'CT1221210'.
067200         05  FILLER          PIC  X(09)      VALUE 'CT1231211'.
067300         05  FILLER          PIC  X(09)      VALUE 'CT1241212'.
067400         05  FILLER          PIC  X(09)      VALUE 'CT1251102'.
067500         05  FILLER          PIC  X(09)      VALUE 'CT1261103'.
067600         05  FILLER          PIC  X(09)      VALUE 'CT1271112'.
067700         05  FILLER          PIC  X(09)      VALUE 'CT1281113'.
067800         05  FILLER          PIC  X(09)      VALUE 'CT1291114'.
067900         05  FILLER          PIC  X(09)      VALUE 'CT1300303'.
068000         05  FILLER          PIC  X(09)      VALUE 'CT1310304'.
068100         05  FILLER          PIC  X(09)      VALUE 'CT1320614'.
068200         05  FILLER          PIC  X(09)      VALUE 'CT1330801'.
068300         05  FILLER          PIC  X(09)      VALUE 'CT1340802'.
068400         05  FILLER          PIC  X(09)      VALUE 'CT1350803'.
068500         05  FILLER          PIC  X(09)      VALUE 'CT1360702'.
068600         05  FILLER          PIC  X(09)      VALUE 'CT1370707'.
068700         05  FILLER          PIC  X(09)      VALUE 'CT1390514'.
068800         05  FILLER          PIC  X(09)      VALUE 'CT1400513'.
068900         05  FILLER          PIC  X(09)      VALUE 'CT1410515'.
069000         05  FILLER          PIC  X(09)      VALUE 'CT1420516'.
069100         05  FILLER          PIC  X(09)      VALUE 'CT1430501'.
069200         05  FILLER          PIC  X(09)      VALUE 'CT1440502'.
069300         05  FILLER          PIC  X(09)      VALUE 'CT1450701'.
069400         05  FILLER          PIC  X(09)      VALUE 'CT1460506'.
069500         05  FILLER          PIC  X(09)      VALUE 'CT1470507'.
069600         05  FILLER          PIC  X(09)      VALUE 'CT1480607'.
069700         05  FILLER          PIC  X(09)      VALUE 'CT1490703'.
069800         05  FILLER          PIC  X(09)      VALUE 'CT1500704'.
069900         05  FILLER          PIC  X(09)      VALUE 'CT1510705'.
070000         05  FILLER          PIC  X(09)      VALUE 'CT1520706'.
070100         05  FILLER          PIC  X(09)      VALUE 'CT1530503'.
070200         05  FILLER          PIC  X(09)      VALUE 'CT1540504'.
070300         05  FILLER          PIC  X(09)      VALUE 'CT1550505'.
070400         05  FILLER          PIC  X(09)      VALUE 'CT1560508'.
070500         05  FILLER          PIC  X(09)      VALUE 'CT1570510'.
070600         05  FILLER          PIC  X(09)      VALUE 'CT1580603'.
070700         05  FILLER          PIC  X(09)      VALUE 'CT1590604'.
070800         05  FILLER          PIC  X(09)      VALUE 'CT1600605'.
070900         05  FILLER          PIC  X(09)      VALUE 'CT1610606'.
071000         05  FILLER          PIC  X(09)      VALUE 'CT1620608'.
071100         05  FILLER          PIC  X(09)      VALUE 'CT1630609'.
071200         05  FILLER          PIC  X(09)      VALUE 'CT1640610'.
071300         05  FILLER          PIC  X(09)      VALUE 'CT1650611'.
071400         05  FILLER          PIC  X(09)      VALUE 'CT1660612'.
071500         05  FILLER          PIC  X(09)      VALUE 'CT1670613'.
071600         05  FILLER          PIC  X(09)      VALUE 'CT1680512'.
071700         05  FILLER          PIC  X(09)      VALUE 'CT1690615'.
071800         05  FILLER          PIC  X(09)      VALUE 'CT1700601'.
071900         05  FILLER          PIC  X(09)      VALUE 'CT1710804'.
072000         05  FILLER          PIC  X(09)      VALUE 'CT1720805'.
072100         05  FILLER          PIC  X(09)      VALUE 'CT1730806'.
072200         05  FILLER          PIC  X(09)      VALUE 'CT1740807'.
072300         05  FILLER          PIC  X(09)      VALUE 'CT1750808'.
072400         05  FILLER          PIC  X(09)      VALUE 'CT1760809'.
072500         05  FILLER          PIC  X(09)      VALUE 'CT1770810'.
072600         05  FILLER          PIC  X(09)      VALUE 'CT1780811'.
072700         05  FILLER          PIC  X(09)      VALUE 'CT1790812'.
072800         05  FILLER          PIC  X(09)      VALUE 'CT1800813'.
072900         05  FILLER          PIC  X(09)      VALUE 'CT1810708'.
073000         05  FILLER          PIC  X(09)      VALUE 'CT1820709'.
073100         05  FILLER          PIC  X(09)      VALUE 'CT1830710'.
073200         05  FILLER          PIC  X(09)      VALUE 'CT1840711'.
073300         05  FILLER          PIC  X(09)      VALUE 'CT1900113'.
073400         05  FILLER          PIC  X(09)      VALUE 'CT1910107'.
073500         05  FILLER          PIC  X(09)      VALUE 'CT1920108'.
073600         05  FILLER          PIC  X(09)      VALUE 'CT1930109'.
073700         05  FILLER          PIC  X(09)      VALUE 'CT1940112'.
073800         05  FILLER          PIC  X(09)      VALUE 'CT1950110'.
073900         05  FILLER          PIC  X(09)      VALUE 'CT1960111'.
074000         05  FILLER          PIC  X(09)      VALUE 'CT1980114'.
074100         05  FILLER          PIC  X(09)      VALUE 'CT2001201'.
074200         05  FILLER          PIC  X(09)      VALUE 'CT2010203'.
074300         05  FILLER          PIC  X(09)      VALUE 'CT2080206'.
074400         05  FILLER          PIC  X(09)      VALUE 'CT3001202'.
074500         05  FILLER          PIC  X(09)      VALUE 'CT3010205'.
074600         05  FILLER          PIC  X(09)      VALUE 'CT3080204'.
074700         05  FILLER          PIC  X(09)      VALUE 'CT4010401'.
074800         05  FILLER          PIC  X(09)      VALUE 'CT4020402'.
074900         05  FILLER          PIC  X(09)      VALUE 'CT4030403'.
075000         05  FILLER          PIC  X(09)      VALUE 'CT4040404'.
075100         05  FILLER          PIC  X(09)      VALUE 'CT4110409'.
075200         05  FILLER          PIC  X(09)      VALUE 'CT4120410'.
075300         05  FILLER          PIC  X(09)      VALUE 'CT4130411'.
075400         05  FILLER          PIC  X(09)      VALUE 'CT4140412'.
075500         05  FILLER          PIC  X(09)      VALUE 'CT5210405'.
075600         05  FILLER          PIC  X(09)      VALUE 'CT5220406'.
075700         05  FILLER          PIC  X(09)      VALUE 'CT5230407'.
075800         05  FILLER          PIC  X(09)      VALUE 'CT5240408'.
075900         05  FILLER          PIC  X(09)      VALUE 'CT5310413'.
076000         05  FILLER          PIC  X(09)      VALUE 'CT5320414'.
076100         05  FILLER          PIC  X(09)      VALUE 'CT5330415'.
076200         05  FILLER          PIC  X(09)      VALUE 'CT5340416'.
076300         05  FILLER          PIC  X(09)      VALUE 'CT9021401'.
076400         05  FILLER          PIC  X(09)      VALUE 'CT9031404'.
076500         05  FILLER          PIC  X(09)      VALUE 'CT9041405'.
076600         05  FILLER          PIC  X(09)      VALUE 'CT9051406'.
076700         05  FILLER          PIC  X(09)      VALUE 'CT9061407'.
076800         05  FILLER          PIC  X(09)      VALUE 'CT9071408'.
076900         05  FILLER          PIC  X(09)      VALUE 'CT9091409'.
077000         05  FILLER          PIC  X(09)      VALUE 'CT9121402'.
077100         05  FILLER          PIC  X(09)      VALUE 'CT9131410'.
077200         05  FILLER          PIC  X(09)      VALUE 'CT9141411'.
077300         05  FILLER          PIC  X(09)      VALUE 'CT9151412'.
077400         05  FILLER          PIC  X(09)      VALUE 'CT9161413'.
077500         05  FILLER          PIC  X(09)      VALUE 'CT9211501'.
077600         05  FILLER          PIC  X(09)      VALUE 'CT9221502'.
077700         05  FILLER          PIC  X(09)      VALUE 'CT9231503'.
077800         05  FILLER          PIC  X(09)      VALUE 'CT9241504'.
077900         05  FILLER          PIC  X(09)      VALUE 'CT9251505'.
078000         05  FILLER          PIC  X(09)      VALUE 'CT9261506'.
078100         05  FILLER          PIC  X(09)      VALUE 'CT9271507'.
078200         05  FILLER          PIC  X(09)      VALUE 'CT9281508'.
078300         05  FILLER          PIC  X(09)      VALUE 'CT9291509'.
078400         05  FILLER          PIC  X(09)      VALUE 'CT9301510'.
078500         05  FILLER          PIC  X(09)      VALUE 'CT9311601'.
078600         05  FILLER          PIC  X(09)      VALUE 'CT9321602'.
078700         05  FILLER          PIC  X(09)      VALUE 'CT9331603'.
078800         05  FILLER          PIC  X(09)      VALUE 'CT9341604'.
078900         05  FILLER          PIC  X(09)      VALUE 'CT9351605'.
079000         05  FILLER          PIC  X(09)      VALUE 'CT9361606'.
079100         05  FILLER          PIC  X(09)      VALUE 'CT9371607'.
079200         05  FILLER          PIC  X(09)      VALUE 'CT9381608'.
079300         05  FILLER          PIC  X(09)      VALUE 'CT9391609'.
079400         05  FILLER          PIC  X(09)      VALUE 'CT9401610'.
079500         05  FILLER          PIC  X(09)      VALUE 'CT9921403'.
079600         05  FILLER          PIC  X(09)      VALUE 'MC0020105'.
079700         05  FILLER          PIC  X(09)      VALUE 'MC0300103'.
079800         05  FILLER          PIC  X(09)      VALUE 'MC0310104'.
079900         05  FILLER          PIC  X(09)      VALUE 'MC1020205'.
080000         05  FILLER          PIC  X(09)      VALUE 'MC1300203'.
080100         05  FILLER          PIC  X(09)      VALUE 'MC1310204'.
080200         05  FILLER          PIC  X(09)      VALUE 'MC2010101'.
080300         05  FILLER          PIC  X(09)      VALUE 'MC2080102'.
080400         05  FILLER          PIC  X(09)      VALUE 'MC3010202'.
080500         05  FILLER          PIC  X(09)      VALUE 'MC3080201'.
080600         05  FILLER          PIC  X(09)      VALUE 'MC9021401'.
080700         05  FILLER          PIC  X(09)      VALUE 'MC9121402'.
080800         05  FILLER          PIC  X(09)      VALUE 'MC9211501'.
080900         05  FILLER          PIC  X(09)      VALUE 'MC9221502'.
081000         05  FILLER          PIC  X(09)      VALUE 'MC9231503'.
081100         05  FILLER          PIC  X(09)      VALUE 'MC9241504'.
081200         05  FILLER          PIC  X(09)      VALUE 'MC9251505'.
081300         05  FILLER          PIC  X(09)      VALUE 'MC9261506'.
081400         05  FILLER          PIC  X(09)      VALUE 'MC9271507'.
081500         05  FILLER          PIC  X(09)      VALUE 'MC9281508'.
081600         05  FILLER          PIC  X(09)      VALUE 'MC9291509'.
081700         05  FILLER          PIC  X(09)      VALUE 'MC9301510'.
081800         05  FILLER          PIC  X(09)      VALUE 'MC9311601'.
081900         05  FILLER          PIC  X(09)      VALUE 'MC9321602'.
082000         05  FILLER          PIC  X(09)      VALUE 'MC9331603'.
082100         05  FILLER          PIC  X(09)      VALUE 'MC9341604'.
082200         05  FILLER          PIC  X(09)      VALUE 'MC9351605'.
082300         05  FILLER          PIC  X(09)      VALUE 'MC9361606'.
082400         05  FILLER          PIC  X(09)      VALUE 'MC9371607'.
082500         05  FILLER          PIC  X(09)      VALUE 'MC9381608'.
082600         05  FILLER          PIC  X(09)      VALUE 'MC9391609'.
082700         05  FILLER          PIC  X(09)      VALUE 'MC9401610'.
082800         05  FILLER          PIC  X(09)      VALUE 'MC9921403'.
082900         05  FILLER          PIC  X(09)      VALUE 'MP0021301'.
083000         05  FILLER          PIC  X(09)      VALUE 'MP0031302'.
083100         05  FILLER          PIC  X(09)      VALUE 'MP0041303'.
083200         05  FILLER          PIC  X(09)      VALUE 'MP0121001'.
083300         05  FILLER          PIC  X(09)      VALUE 'MP0131002'.
083400         05  FILLER          PIC  X(09)      VALUE 'MP0161003'.
083500         05  FILLER          PIC  X(09)      VALUE 'MP0171004'.
083600         05  FILLER          PIC  X(09)      VALUE 'MP0181005'.
083700         05  FILLER          PIC  X(09)      VALUE 'MP0191006'.
083800         05  FILLER          PIC  X(09)      VALUE 'MP0241201'.
083900         05  FILLER          PIC  X(09)      VALUE 'MP0251007'.
084000         05  FILLER          PIC  X(09)      VALUE 'MP0261008'.
084100         05  FILLER          PIC  X(09)      VALUE 'MP0271009'.
084200         05  FILLER          PIC  X(09)      VALUE 'MP0281010'.
084300         05  FILLER          PIC  X(09)      VALUE 'MP0291011'.
084400         05  FILLER          PIC  X(09)      VALUE 'MP0300301'.
084500         05  FILLER          PIC  X(09)      VALUE 'MP0310302'.
084600         05  FILLER          PIC  X(09)      VALUE 'MP0700601'.
084700         05  FILLER          PIC  X(09)      VALUE 'MP1021304'.
084800         05  FILLER          PIC  X(09)      VALUE 'MP1031305'.
084900         05  FILLER          PIC  X(09)      VALUE 'MP1041306'.
085000         05  FILLER          PIC  X(09)      VALUE 'MP1051307'.
085100         05  FILLER          PIC  X(09)      VALUE 'MP1121101'.
085200         05  FILLER          PIC  X(09)      VALUE 'MP1131102'.
085300         05  FILLER          PIC  X(09)      VALUE 'MP1161103'.
085400         05  FILLER          PIC  X(09)      VALUE 'MP1171104'.
085500         05  FILLER          PIC  X(09)      VALUE 'MP1181105'.
085600         05  FILLER          PIC  X(09)      VALUE 'MP1191106'.
085700         05  FILLER          PIC  X(09)      VALUE 'MP1241202'.
085800         05  FILLER          PIC  X(09)      VALUE 'MP1251107'.
085900         05  FILLER          PIC  X(09)      VALUE 'MP1261108'.
086000         05  FILLER          PIC  X(09)      VALUE 'MP1271109'.
086100         05  FILLER          PIC  X(09)      VALUE 'MP1281110'.
086200         05  FILLER          PIC  X(09)      VALUE 'MP1291111'.
086300         05  FILLER          PIC  X(09)      VALUE 'MP1300303'.
086400         05  FILLER          PIC  X(09)      VALUE 'MP1310304'.
086500         05  FILLER          PIC  X(09)      VALUE 'MP1330801'.
086600         05  FILLER          PIC  X(09)      VALUE 'MP1340802'.
086700         05  FILLER          PIC  X(09)      VALUE 'MP1350803'.
086800         05  FILLER          PIC  X(09)      VALUE 'MP1360701'.
086900         05  FILLER          PIC  X(09)      VALUE 'MP1370702'.
087000         05  FILLER          PIC  X(09)      VALUE 'MP1700601'.
087100         05  FILLER          PIC  X(09)      VALUE 'MP2010201'.
087200         05  FILLER          PIC  X(09)      VALUE 'MP2080202'.
087300         05  FILLER          PIC  X(09)      VALUE 'MP3010203'.
087400         05  FILLER          PIC  X(09)      VALUE 'MP3080204'.
087500         05  FILLER          PIC  X(09)      VALUE 'MP4010401'.
087600         05  FILLER          PIC  X(09)      VALUE 'MP4020402'.
087700         05  FILLER          PIC  X(09)      VALUE 'MP4030403'.
087800         05  FILLER          PIC  X(09)      VALUE 'MP4040404'.
087900         05  FILLER          PIC  X(09)      VALUE 'MP9021401'.
088000         05  FILLER          PIC  X(09)      VALUE 'MP9031404'.
088100         05  FILLER          PIC  X(09)      VALUE 'MP9041405'.
088200         05  FILLER          PIC  X(09)      VALUE 'MP9051406'.
088300         05  FILLER          PIC  X(09)      VALUE 'MP9061407'.
088400         05  FILLER          PIC  X(09)      VALUE 'MP9071408'.
088500         05  FILLER          PIC  X(09)      VALUE 'MP9121402'.
088600         05  FILLER          PIC  X(09)      VALUE 'MP9131409'.
088700         05  FILLER          PIC  X(09)      VALUE 'MP9141410'.
088800         05  FILLER          PIC  X(09)      VALUE 'MP9151411'.
088900         05  FILLER          PIC  X(09)      VALUE 'MP9161412'.
089000         05  FILLER          PIC  X(09)      VALUE 'MP9211501'.
089100         05  FILLER          PIC  X(09)      VALUE 'MP9221502'.
089200         05  FILLER          PIC  X(09)      VALUE 'MP9231503'.
089300         05  FILLER          PIC  X(09)      VALUE 'MP9241504'.
089400         05  FILLER          PIC  X(09)      VALUE 'MP9251505'.
089500         05  FILLER          PIC  X(09)      VALUE 'MP9261506'.
089600         05  FILLER          PIC  X(09)      VALUE 'MP9271507'.
089700         05  FILLER          PIC  X(09)      VALUE 'MP9281508'.
089800         05  FILLER          PIC  X(09)      VALUE 'MP9291509'.
089900         05  FILLER          PIC  X(09)      VALUE 'MP9301510'.
090000         05  FILLER          PIC  X(09)      VALUE 'MP9311601'.
090100         05  FILLER          PIC  X(09)      VALUE 'MP9321602'.
090200         05  FILLER          PIC  X(09)      VALUE 'MP9331603'.
090300         05  FILLER          PIC  X(09)      VALUE 'MP9341604'.
090400         05  FILLER          PIC  X(09)      VALUE 'MP9351605'.
090500         05  FILLER          PIC  X(09)      VALUE 'MP9361606'.
090600         05  FILLER          PIC  X(09)      VALUE 'MP9371607'.
090700         05  FILLER          PIC  X(09)      VALUE 'MP9381608'.
090800         05  FILLER          PIC  X(09)      VALUE 'MP9391609'.
090900         05  FILLER          PIC  X(09)      VALUE 'MP9401610'.
091000         05  FILLER          PIC  X(09)      VALUE 'MP9921403'.
091100         05  FILLER          PIC  X(09)      VALUE 'MQ0269907'.
091200         05  FILLER          PIC  X(09)      VALUE 'MQ0709906'.
091300         05  FILLER          PIC  X(09)      VALUE 'MQ1269908'.
091400         05  FILLER          PIC  X(09)      VALUE 'MQ1709905'.
091500         05  FILLER          PIC  X(09)      VALUE 'MQ2019901'.
091600         05  FILLER          PIC  X(09)      VALUE 'MQ2089904'.
091700         05  FILLER          PIC  X(09)      VALUE 'MQ3019903'.
091800         05  FILLER          PIC  X(09)      VALUE 'MQ3089902'.
091900         05  FILLER          PIC  X(09)      VALUE 'MT0000201'.
092000         05  FILLER          PIC  X(09)      VALUE 'MT0021301'.
092100         05  FILLER          PIC  X(09)      VALUE 'MT0031302'.
092200         05  FILLER          PIC  X(09)      VALUE 'MT0041303'.
092300         05  FILLER          PIC  X(09)      VALUE 'MT0111001'.
092400         05  FILLER          PIC  X(09)      VALUE 'MT0121004'.
092500         05  FILLER          PIC  X(09)      VALUE 'MT0131005'.
092600         05  FILLER          PIC  X(09)      VALUE 'MT0141006'.
092700         05  FILLER          PIC  X(09)      VALUE 'MT0151007'.
092800         05  FILLER          PIC  X(09)      VALUE 'MT0161008'.
092900         05  FILLER          PIC  X(09)      VALUE 'MT0171009'.
093000         05  FILLER          PIC  X(09)      VALUE 'MT0181010'.
093100         05  FILLER          PIC  X(09)      VALUE 'MT0191011'.
093200         05  FILLER          PIC  X(09)      VALUE 'MT0201203'.
093300         05  FILLER          PIC  X(09)      VALUE 'MT0211204'.
093400         05  FILLER          PIC  X(09)      VALUE 'MT0221205'.
093500         05  FILLER          PIC  X(09)      VALUE 'MT0231206'.
093600         05  FILLER          PIC  X(09)      VALUE 'MT0241207'.
093700         05  FILLER          PIC  X(09)      VALUE 'MT0251002'.
093800         05  FILLER          PIC  X(09)      VALUE 'MT0261003'.
093900         05  FILLER          PIC  X(09)      VALUE 'MT0271012'.
094000         05  FILLER          PIC  X(09)      VALUE 'MT0281013'.
094100         05  FILLER          PIC  X(09)      VALUE 'MT0291014'.
094200         05  FILLER          PIC  X(09)      VALUE 'MT0300301'.
094300         05  FILLER          PIC  X(09)      VALUE 'MT0310302'.
094400         05  FILLER          PIC  X(09)      VALUE 'MT0560509'.
094500         05  FILLER          PIC  X(09)      VALUE 'MT0570511'.
094600         05  FILLER          PIC  X(09)      VALUE 'MT0700602'.
094700         05  FILLER          PIC  X(09)      VALUE 'MT0710901'.
094800         05  FILLER          PIC  X(09)      VALUE 'MT0720902'.
094900         05  FILLER          PIC  X(09)      VALUE 'MT0730903'.
095000         05  FILLER          PIC  X(09)      VALUE 'MT0740904'.
095100         05  FILLER          PIC  X(09)      VALUE 'MT0750905'.
095200         05  FILLER          PIC  X(09)      VALUE 'MT0760906'.
095300         05  FILLER          PIC  X(09)      VALUE 'MT0770907'.
095400         05  FILLER          PIC  X(09)      VALUE 'MT0780908'.
095500         05  FILLER          PIC  X(09)      VALUE 'MT0790909'.
095600         05  FILLER          PIC  X(09)      VALUE 'MT0800910'.
095700         05  FILLER          PIC  X(09)      VALUE 'MT0910101'.
095800         05  FILLER          PIC  X(09)      VALUE 'MT0920102'.
095900         05  FILLER          PIC  X(09)      VALUE 'MT0930103'.
096000         05  FILLER          PIC  X(09)      VALUE 'MT0940106'.
096100         05  FILLER          PIC  X(09)      VALUE 'MT0950104'.
096200         05  FILLER          PIC  X(09)      VALUE 'MT0960105'.
096300         05  FILLER          PIC  X(09)      VALUE 'MT1000201'.
096400         05  FILLER          PIC  X(09)      VALUE 'MT1021304'.
096500         05  FILLER          PIC  X(09)      VALUE 'MT1031305'.
096600         05  FILLER          PIC  X(09)      VALUE 'MT1041306'.
096700         05  FILLER          PIC  X(09)      VALUE 'MT1051307'.
096800         05  FILLER          PIC  X(09)      VALUE 'MT1111101'.
096900         05  FILLER          PIC  X(09)      VALUE 'MT1121104'.
097000         05  FILLER          PIC  X(09)      VALUE 'MT1131105'.
097100         05  FILLER          PIC  X(09)      VALUE 'MT1141106'.
097200         05  FILLER          PIC  X(09)      VALUE 'MT1151107'.
097300         05  FILLER          PIC  X(09)      VALUE 'MT1161108'.
097400         05  FILLER          PIC  X(09)      VALUE 'MT1171109'.
097500         05  FILLER          PIC  X(09)      VALUE 'MT1181110'.
097600         05  FILLER          PIC  X(09)      VALUE 'MT1191111'.
097700         05  FILLER          PIC  X(09)      VALUE 'MT1201208'.
097800         05  FILLER          PIC  X(09)      VALUE 'MT1211209'.
097900         05  FILLER          PIC  X(09)      VALUE 'MT1221210'.
098000         05  FILLER          PIC  X(09)      VALUE 'MT1231211'.
098100         05  FILLER          PIC  X(09)      VALUE 'MT1241212'.
098200         05  FILLER          PIC  X(09)      VALUE 'MT1251102'.
098300         05  FILLER          PIC  X(09)      VALUE 'MT1261103'.
098400         05  FILLER          PIC  X(09)      VALUE 'MT1271112'.
098500         05  FILLER          PIC  X(09)      VALUE 'MT1281113'.
098600         05  FILLER          PIC  X(09)      VALUE 'MT1291114'.
098700         05  FILLER          PIC  X(09)      VALUE 'MT1300303'.
098800         05  FILLER          PIC  X(09)      VALUE 'MT1310304'.
098900         05  FILLER          PIC  X(09)      VALUE 'MT1320614'.
099000         05  FILLER          PIC  X(09)      VALUE 'MT1330801'.
099100         05  FILLER          PIC  X(09)      VALUE 'MT1340802'.
099200         05  FILLER          PIC  X(09)      VALUE 'MT1350803'.
099300         05  FILLER          PIC  X(09)      VALUE 'MT1360702'.
099400         05  FILLER          PIC  X(09)      VALUE 'MT1370707'.
099500         05  FILLER          PIC  X(09)      VALUE 'MT1390514'.
099600         05  FILLER          PIC  X(09)      VALUE 'MT1400513'.
099700         05  FILLER          PIC  X(09)      VALUE 'MT1410515'.
099800         05  FILLER          PIC  X(09)      VALUE 'MT1420516'.
099900         05  FILLER          PIC  X(09)      VALUE 'MT1430501'.
100000         05  FILLER          PIC  X(09)      VALUE 'MT1440502'.
100100         05  FILLER          PIC  X(09)      VALUE 'MT1450701'.
100200         05  FILLER          PIC  X(09)      VALUE 'MT1460506'.
100300         05  FILLER          PIC  X(09)      VALUE 'MT1470507'.
100400         05  FILLER          PIC  X(09)      VALUE 'MT1480607'.
100500         05  FILLER          PIC  X(09)      VALUE 'MT1490703'.
100600         05  FILLER          PIC  X(09)      VALUE 'MT1500704'.
100700         05  FILLER          PIC  X(09)      VALUE 'MT1510705'.
100800         05  FILLER          PIC  X(09)      VALUE 'MT1520706'.
100900         05  FILLER          PIC  X(09)      VALUE 'MT1530503'.
101000         05  FILLER          PIC  X(09)      VALUE 'MT1540504'.
101100         05  FILLER          PIC  X(09)      VALUE 'MT1550505'.
101200         05  FILLER          PIC  X(09)      VALUE 'MT1560508'.
101300         05  FILLER          PIC  X(09)      VALUE 'MT1570510'.
101400         05  FILLER          PIC  X(09)      VALUE 'MT1580603'.
101500         05  FILLER          PIC  X(09)      VALUE 'MT1590604'.
101600         05  FILLER          PIC  X(09)      VALUE 'MT1600605'.
101700         05  FILLER          PIC  X(09)      VALUE 'MT1610606'.
101800         05  FILLER          PIC  X(09)      VALUE 'MT1620608'.
101900         05  FILLER          PIC  X(09)      VALUE 'MT1630609'.
102000         05  FILLER          PIC  X(09)      VALUE 'MT1640610'.
102100         05  FILLER          PIC  X(09)      VALUE 'MT1650611'.
102200         05  FILLER          PIC  X(09)      VALUE 'MT1660612'.
102300         05  FILLER          PIC  X(09)      VALUE 'MT1670613'.
102400         05  FILLER          PIC  X(09)      VALUE 'MT1680512'.
102500         05  FILLER          PIC  X(09)      VALUE 'MT1690615'.
102600         05  FILLER          PIC  X(09)      VALUE 'MT1700601'.
102700         05  FILLER          PIC  X(09)      VALUE 'MT1710804'.
102800         05  FILLER          PIC  X(09)      VALUE 'MT1720805'.
102900         05  FILLER          PIC  X(09)      VALUE 'MT1730806'.
103000         05  FILLER          PIC  X(09)      VALUE 'MT1740807'.
103100         05  FILLER          PIC  X(09)      VALUE 'MT1750808'.
103200         05  FILLER          PIC  X(09)      VALUE 'MT1760809'.
103300         05  FILLER          PIC  X(09)      VALUE 'MT1770810'.
103400         05  FILLER          PIC  X(09)      VALUE 'MT1780811'.
103500         05  FILLER          PIC  X(09)      VALUE 'MT1790812'.
103600         05  FILLER          PIC  X(09)      VALUE 'MT1800813'.
103700         05  FILLER          PIC  X(09)      VALUE 'MT1810708'.
103800         05  FILLER          PIC  X(09)      VALUE 'MT1820709'.
103900         05  FILLER          PIC  X(09)      VALUE 'MT1830710'.
104000         05  FILLER          PIC  X(09)      VALUE 'MT1840711'.
104100         05  FILLER          PIC  X(09)      VALUE 'MT1900113'.
104200         05  FILLER          PIC  X(09)      VALUE 'MT1910107'.
104300         05  FILLER          PIC  X(09)      VALUE 'MT1920108'.
104400         05  FILLER          PIC  X(09)      VALUE 'MT1930109'.
104500         05  FILLER          PIC  X(09)      VALUE 'MT1940112'.
104600         05  FILLER          PIC  X(09)      VALUE 'MT1950110'.
104700         05  FILLER          PIC  X(09)      VALUE 'MT1960111'.
104800         05  FILLER          PIC  X(09)      VALUE 'MT1980114'.
104900         05  FILLER          PIC  X(09)      VALUE 'MT2001201'.
105000         05  FILLER          PIC  X(09)      VALUE 'MT2010203'.
105100         05  FILLER          PIC  X(09)      VALUE 'MT2080206'.
105200         05  FILLER          PIC  X(09)      VALUE 'MT3001202'.
105300         05  FILLER          PIC  X(09)      VALUE 'MT3010205'.
105400         05  FILLER          PIC  X(09)      VALUE 'MT3080204'.
105500         05  FILLER          PIC  X(09)      VALUE 'MT4010401'.
105600         05  FILLER          PIC  X(09)      VALUE 'MT4020402'.
105700         05  FILLER          PIC  X(09)      VALUE 'MT4030403'.
105800         05  FILLER          PIC  X(09)      VALUE 'MT4040404'.
105900         05  FILLER          PIC  X(09)      VALUE 'MT4110409'.
106000         05  FILLER          PIC  X(09)      VALUE 'MT4120410'.
106100         05  FILLER          PIC  X(09)      VALUE 'MT4130411'.
106200         05  FILLER          PIC  X(09)      VALUE 'MT4140412'.
106300         05  FILLER          PIC  X(09)      VALUE 'MT5210405'.
106400         05  FILLER          PIC  X(09)      VALUE 'MT5220406'.
106500         05  FILLER          PIC  X(09)      VALUE 'MT5230407'.
106600         05  FILLER          PIC  X(09)      VALUE 'MT5240408'.
106700         05  FILLER          PIC  X(09)      VALUE 'MT5310413'.
106800         05  FILLER          PIC  X(09)      VALUE 'MT5320414'.
106900         05  FILLER          PIC  X(09)      VALUE 'MT5330415'.
107000         05  FILLER          PIC  X(09)      VALUE 'MT5340416'.
107100         05  FILLER          PIC  X(09)      VALUE 'MT9021401'.
107200         05  FILLER          PIC  X(09)      VALUE 'MT9031404'.
107300         05  FILLER          PIC  X(09)      VALUE 'MT9041405'.
107400         05  FILLER          PIC  X(09)      VALUE 'MT9051406'.
107500         05  FILLER          PIC  X(09)      VALUE 'MT9061407'.
107600         05  FILLER          PIC  X(09)      VALUE 'MT9071408'.
107700         05  FILLER          PIC  X(09)      VALUE 'MT9091409'.
107800         05  FILLER          PIC  X(09)      VALUE 'MT9121402'.
107900         05  FILLER          PIC  X(09)      VALUE 'MT9131410'.
108000         05  FILLER          PIC  X(09)      VALUE 'MT9141411'.
108100         05  FILLER          PIC  X(09)      VALUE 'MT9151412'.
108200         05  FILLER          PIC  X(09)      VALUE 'MT9161413'.
108300         05  FILLER          PIC  X(09)      VALUE 'MT9211501'.
108400         05  FILLER          PIC  X(09)      VALUE 'MT9221502'.
108500         05  FILLER          PIC  X(09)      VALUE 'MT9231503'.
108600         05  FILLER          PIC  X(09)      VALUE 'MT9241504'.
108700         05  FILLER          PIC  X(09)      VALUE 'MT9251505'.
108800         05  FILLER          PIC  X(09)      VALUE 'MT9261506'.
108900         05  FILLER          PIC  X(09)      VALUE 'MT9271507'.
109000         05  FILLER          PIC  X(09)      VALUE 'MT9281508'.
109100         05  FILLER          PIC  X(09)      VALUE 'MT9291509'.
109200         05  FILLER          PIC  X(09)      VALUE 'MT9301510'.
109300         05  FILLER          PIC  X(09)      VALUE 'MT9311601'.
109400         05  FILLER          PIC  X(09)      VALUE 'MT9321602'.
109500         05  FILLER          PIC  X(09)      VALUE 'MT9331603'.
109600         05  FILLER          PIC  X(09)      VALUE 'MT9341604'.
109700         05  FILLER          PIC  X(09)      VALUE 'MT9351605'.
109800         05  FILLER          PIC  X(09)      VALUE 'MT9361606'.
109900         05  FILLER          PIC  X(09)      VALUE 'MT9371607'.
110000         05  FILLER          PIC  X(09)      VALUE 'MT9381608'.
110100         05  FILLER          PIC  X(09)      VALUE 'MT9391609'.
110200         05  FILLER          PIC  X(09)      VALUE 'MT9401610'.
110300         05  FILLER          PIC  X(09)      VALUE 'MT9921402'.
110400         05  FILLER          PIC  X(09)      VALUE 'SC0020105'.
110500         05  FILLER          PIC  X(09)      VALUE 'SC0300103'.
110600         05  FILLER          PIC  X(09)      VALUE 'SC0310104'.
110700         05  FILLER          PIC  X(09)      VALUE 'SC1020205'.
110800         05  FILLER          PIC  X(09)      VALUE 'SC1300203'.
110900         05  FILLER          PIC  X(09)      VALUE 'SC1310204'.
111000         05  FILLER          PIC  X(09)      VALUE 'SC2010101'.
111100         05  FILLER          PIC  X(09)      VALUE 'SC2080102'.
111200         05  FILLER          PIC  X(09)      VALUE 'SC3010201'.
111300         05  FILLER          PIC  X(09)      VALUE 'SC3080202'.
111400         05  FILLER          PIC  X(09)      VALUE 'SC9021401'.
111500         05  FILLER          PIC  X(09)      VALUE 'SC9121402'.
111600         05  FILLER          PIC  X(09)      VALUE 'SC9211501'.
111700         05  FILLER          PIC  X(09)      VALUE 'SC9221502'.
111800         05  FILLER          PIC  X(09)      VALUE 'SC9231503'.
111900         05  FILLER          PIC  X(09)      VALUE 'SC9241504'.
112000         05  FILLER          PIC  X(09)      VALUE 'SC9251505'.
112100         05  FILLER          PIC  X(09)      VALUE 'SC9261506'.
112200         05  FILLER          PIC  X(09)      VALUE 'SC9271507'.
112300         05  FILLER          PIC  X(09)      VALUE 'SC9281508'.
112400         05  FILLER          PIC  X(09)      VALUE 'SC9291509'.
112500         05  FILLER          PIC  X(09)      VALUE 'SC9301510'.
112600         05  FILLER          PIC  X(09)      VALUE 'SC9311601'.
112700         05  FILLER          PIC  X(09)      VALUE 'SC9321602'.
112800         05  FILLER          PIC  X(09)      VALUE 'SC9331603'.
112900         05  FILLER          PIC  X(09)      VALUE 'SC9341604'.
113000         05  FILLER          PIC  X(09)      VALUE 'SC9351605'.
113100         05  FILLER          PIC  X(09)      VALUE 'SC9361606'.
113200         05  FILLER          PIC  X(09)      VALUE 'SC9371607'.
113300         05  FILLER          PIC  X(09)      VALUE 'SC9381608'.
113400         05  FILLER          PIC  X(09)      VALUE 'SC9391609'.
113500         05  FILLER          PIC  X(09)      VALUE 'SC9401610'.
113600         05  FILLER          PIC  X(09)      VALUE 'SC9921403'.
113700         05  FILLER          PIC  X(09)      VALUE 'SP0021301'.
113800         05  FILLER          PIC  X(09)      VALUE 'SP0031302'.
113900         05  FILLER          PIC  X(09)      VALUE 'SP0041303'.
114000         05  FILLER          PIC  X(09)      VALUE 'SP0121001'.
114100         05  FILLER          PIC  X(09)      VALUE 'SP0131002'.
114200         05  FILLER          PIC  X(09)      VALUE 'SP0161003'.
114300         05  FILLER          PIC  X(09)      VALUE 'SP0171004'.
114400         05  FILLER          PIC  X(09)      VALUE 'SP0181005'.
114500         05  FILLER          PIC  X(09)      VALUE 'SP0191006'.
114600         05  FILLER          PIC  X(09)      VALUE 'SP0241201'.
114700         05  FILLER          PIC  X(09)      VALUE 'SP0271007'.
114800         05  FILLER          PIC  X(09)      VALUE 'SP0281008'.
114900         05  FILLER          PIC  X(09)      VALUE 'SP0291009'.
115000         05  FILLER          PIC  X(09)      VALUE 'SP0300301'.
115100         05  FILLER          PIC  X(09)      VALUE 'SP0310302'.
115200         05  FILLER          PIC  X(09)      VALUE 'SP1021304'.
115300         05  FILLER          PIC  X(09)      VALUE 'SP1031305'.
115400         05  FILLER          PIC  X(09)      VALUE 'SP1041306'.
115500         05  FILLER          PIC  X(09)      VALUE 'SP1051307'.
115600         05  FILLER          PIC  X(09)      VALUE 'SP1121101'.
115700         05  FILLER          PIC  X(09)      VALUE 'SP1131102'.
115800         05  FILLER          PIC  X(09)      VALUE 'SP1161103'.
115900         05  FILLER          PIC  X(09)      VALUE 'SP1171104'.
116000         05  FILLER          PIC  X(09)      VALUE 'SP1181105'.
116100         05  FILLER          PIC  X(09)      VALUE 'SP1191106'.
116200         05  FILLER          PIC  X(09)      VALUE 'SP1241202'.
116300         05  FILLER          PIC  X(09)      VALUE 'SP1271107'.
116400         05  FILLER          PIC  X(09)      VALUE 'SP1281108'.
116500         05  FILLER          PIC  X(09)      VALUE 'SP1291109'.
116600         05  FILLER          PIC  X(09)      VALUE 'SP1300303'.
116700         05  FILLER          PIC  X(09)      VALUE 'SP1310304'.
116800         05  FILLER          PIC  X(09)      VALUE 'SP2010201'.
116900         05  FILLER          PIC  X(09)      VALUE 'SP2080202'.
117000         05  FILLER          PIC  X(09)      VALUE 'SP3010203'.
117100         05  FILLER          PIC  X(09)      VALUE 'SP3080204'.
117200         05  FILLER          PIC  X(09)      VALUE 'SP9021401'.
117300         05  FILLER          PIC  X(09)      VALUE 'SP9031404'.
117400         05  FILLER          PIC  X(09)      VALUE 'SP9041405'.
117500         05  FILLER          PIC  X(09)      VALUE 'SP9051406'.
117600         05  FILLER          PIC  X(09)      VALUE 'SP9061407'.
117700         05  FILLER          PIC  X(09)      VALUE 'SP9071408'.
117800         05  FILLER          PIC  X(09)      VALUE 'SP9121402'.
117900         05  FILLER          PIC  X(09)      VALUE 'SP9131409'.
118000         05  FILLER          PIC  X(09)      VALUE 'SP9141410'.
118100         05  FILLER          PIC  X(09)      VALUE 'SP9151411'.
118200         05  FILLER          PIC  X(09)      VALUE 'SP9161412'.
118300         05  FILLER          PIC  X(09)      VALUE 'SP9211501'.
118400         05  FILLER          PIC  X(09)      VALUE 'SP9221502'.
118500         05  FILLER          PIC  X(09)      VALUE 'SP9231503'.
118600         05  FILLER          PIC  X(09)      VALUE 'SP9241504'.
118700         05  FILLER          PIC  X(09)      VALUE 'SP9251505'.
118800         05  FILLER          PIC  X(09)      VALUE 'SP9261506'.
118900         05  FILLER          PIC  X(09)      VALUE 'SP9271507'.
119000         05  FILLER          PIC  X(09)      VALUE 'SP9281508'.
119100         05  FILLER          PIC  X(09)      VALUE 'SP9291509'.
119200         05  FILLER          PIC  X(09)      VALUE 'SP9301510'.
119300         05  FILLER          PIC  X(09)      VALUE 'SP9311601'.
119400         05  FILLER          PIC  X(09)      VALUE 'SP9321602'.
119500         05  FILLER          PIC  X(09)      VALUE 'SP9331603'.
119600         05  FILLER          PIC  X(09)      VALUE 'SP9341604'.
119700         05  FILLER          PIC  X(09)      VALUE 'SP9351605'.
119800         05  FILLER          PIC  X(09)      VALUE 'SP9361606'.
119900         05  FILLER          PIC  X(09)      VALUE 'SP9371607'.
120000         05  FILLER          PIC  X(09)      VALUE 'SP9381608'.
120100         05  FILLER          PIC  X(09)      VALUE 'SP9391609'.
120200         05  FILLER          PIC  X(09)      VALUE 'SP9401610'.
120300         05  FILLER          PIC  X(09)      VALUE 'SP9921402'.
120400         05  FILLER          PIC  X(09)      VALUE 'ST0000201'.
120500         05  FILLER          PIC  X(09)      VALUE 'ST0021301'.
120600         05  FILLER          PIC  X(09)      VALUE 'ST0031302'.
120700         05  FILLER          PIC  X(09)      VALUE 'ST0041303'.
120800         05  FILLER          PIC  X(09)      VALUE 'ST0121001'.
120900         05  FILLER          PIC  X(09)      VALUE 'ST0131002'.
121000         05  FILLER          PIC  X(09)      VALUE 'ST0141003'.
121100         05  FILLER          PIC  X(09)      VALUE 'ST0151004'.
121200         05  FILLER          PIC  X(09)      VALUE 'ST0161005'.
121300         05  FILLER          PIC  X(09)      VALUE 'ST0171006'.
121400         05  FILLER          PIC  X(09)      VALUE 'ST0181007'.
121500         05  FILLER          PIC  X(09)      VALUE 'ST0191008'.
121600         05  FILLER          PIC  X(09)      VALUE 'ST0201201'.
121700         05  FILLER          PIC  X(09)      VALUE 'ST0211202'.
121800         05  FILLER          PIC  X(09)      VALUE 'ST0221203'.
121900         05  FILLER          PIC  X(09)      VALUE 'ST0231204'.
122000         05  FILLER          PIC  X(09)      VALUE 'ST0241205'.
122100         05  FILLER          PIC  X(09)      VALUE 'ST0271009'.
122200         05  FILLER          PIC  X(09)      VALUE 'ST0281010'.
122300         05  FILLER          PIC  X(09)      VALUE 'ST0291011'.
122400         05  FILLER          PIC  X(09)      VALUE 'ST0300301'.
122500         05  FILLER          PIC  X(09)      VALUE 'ST0310302'.
122600         05  FILLER          PIC  X(09)      VALUE 'ST1000202'.
122700         05  FILLER          PIC  X(09)      VALUE 'ST1021304'.
122800         05  FILLER          PIC  X(09)      VALUE 'ST1031305'.
122900         05  FILLER          PIC  X(09)      VALUE 'ST1041306'.
123000         05  FILLER          PIC  X(09)      VALUE 'ST1051307'.
123100         05  FILLER          PIC  X(09)      VALUE 'ST1121101'.
123200         05  FILLER          PIC  X(09)      VALUE 'ST1131102'.
123300         05  FILLER          PIC  X(09)      VALUE 'ST1141103'.
123400         05  FILLER          PIC  X(09)      VALUE 'ST1151104'.
123500         05  FILLER          PIC  X(09)      VALUE 'ST1161105'.
123600         05  FILLER          PIC  X(09)      VALUE 'ST1171106'.
123700         05  FILLER          PIC  X(09)      VALUE 'ST1181107'.
123800         05  FILLER          PIC  X(09)      VALUE 'ST1191108'.
123900         05  FILLER          PIC  X(09)      VALUE 'ST1201206'.
124000         05  FILLER          PIC  X(09)      VALUE 'ST1211207'.
124100         05  FILLER          PIC  X(09)      VALUE 'ST1221208'.
124200         05  FILLER          PIC  X(09)      VALUE 'ST1231209'.
124300         05  FILLER          PIC  X(09)      VALUE 'ST1241210'.
124400         05  FILLER          PIC  X(09)      VALUE 'ST1271109'.
124500         05  FILLER          PIC  X(09)      VALUE 'ST1281110'.
124600         05  FILLER          PIC  X(09)      VALUE 'ST1291111'.
124700         05  FILLER          PIC  X(09)      VALUE 'ST1300303'.
124800         05  FILLER          PIC  X(09)      VALUE 'ST1310304'.
124900         05  FILLER          PIC  X(09)      VALUE 'ST2010203'.
125000         05  FILLER          PIC  X(09)      VALUE 'ST2080204'.
125100         05  FILLER          PIC  X(09)      VALUE 'ST3010205'.
125200         05  FILLER          PIC  X(09)      VALUE 'ST3080206'.
125300         05  FILLER          PIC  X(09)      VALUE 'ST9021401'.
125400         05  FILLER          PIC  X(09)      VALUE 'ST9031404'.
125500         05  FILLER          PIC  X(09)      VALUE 'ST9041405'.
125600         05  FILLER          PIC  X(09)      VALUE 'ST9051406'.
125700         05  FILLER          PIC  X(09)      VALUE 'ST9061407'.
125800         05  FILLER          PIC  X(09)      VALUE 'ST9071408'.
125900         05  FILLER          PIC  X(09)      VALUE 'ST9091409'.
126000         05  FILLER          PIC  X(09)      VALUE 'ST9121402'.
126100         05  FILLER          PIC  X(09)      VALUE 'ST9131410'.
126200         05  FILLER          PIC  X(09)      VALUE 'ST9141411'.
126300         05  FILLER          PIC  X(09)      VALUE 'ST9151412'.
126400         05  FILLER          PIC  X(09)      VALUE 'ST9161413'.
126500         05  FILLER          PIC  X(09)      VALUE 'ST9211501'.
126600         05  FILLER          PIC  X(09)      VALUE 'ST9221502'.
126700         05  FILLER          PIC  X(09)      VALUE 'ST9231503'.
126800         05  FILLER          PIC  X(09)      VALUE 'ST9241504'.
126900         05  FILLER          PIC  X(09)      VALUE 'ST9251505'.
127000         05  FILLER          PIC  X(09)      VALUE 'ST9261506'.
127100         05  FILLER          PIC  X(09)      VALUE 'ST9271507'.
127200         05  FILLER          PIC  X(09)      VALUE 'ST9281508'.
127300         05  FILLER          PIC  X(09)      VALUE 'ST9291509'.
127400         05  FILLER          PIC  X(09)      VALUE 'ST9301510'.
127500         05  FILLER          PIC  X(09)      VALUE 'ST9311601'.
127600         05  FILLER          PIC  X(09)      VALUE 'ST9321602'.
127700         05  FILLER          PIC  X(09)      VALUE 'ST9331603'.
127800         05  FILLER          PIC  X(09)      VALUE 'ST9341604'.
127900         05  FILLER          PIC  X(09)      VALUE 'ST9351605'.
128000         05  FILLER          PIC  X(09)      VALUE 'ST9361606'.
128100         05  FILLER          PIC  X(09)      VALUE 'ST9371607'.
128200         05  FILLER          PIC  X(09)      VALUE 'ST9381608'.
128300         05  FILLER          PIC  X(09)      VALUE 'ST9391609'.
128400         05  FILLER          PIC  X(09)      VALUE 'ST9401610'.
128500         05  FILLER          PIC  X(09)      VALUE 'ST9921403'.
128600         05  FILLER          PIC  X(09)      VALUE 'ZC0020105'.
128700         05  FILLER          PIC  X(09)      VALUE 'ZC0300103'.
128800         05  FILLER          PIC  X(09)      VALUE 'ZC0310104'.
128900         05  FILLER          PIC  X(09)      VALUE 'ZC1020205'.
129000         05  FILLER          PIC  X(09)      VALUE 'ZC1300203'.
129100         05  FILLER          PIC  X(09)      VALUE 'ZC1310204'.
129200         05  FILLER          PIC  X(09)      VALUE 'ZC2010101'.
129300         05  FILLER          PIC  X(09)      VALUE 'ZC2080102'.
129400         05  FILLER          PIC  X(09)      VALUE 'ZC3010201'.
129500         05  FILLER          PIC  X(09)      VALUE 'ZC3080202'.
129600         05  FILLER          PIC  X(09)      VALUE 'ZC9021401'.
129700         05  FILLER          PIC  X(09)      VALUE 'ZC9121402'.
129800         05  FILLER          PIC  X(09)      VALUE 'ZC9211501'.
129900         05  FILLER          PIC  X(09)      VALUE 'ZC9221502'.
130000         05  FILLER          PIC  X(09)      VALUE 'ZC9231503'.
130100         05  FILLER          PIC  X(09)      VALUE 'ZC9241504'.
130200         05  FILLER          PIC  X(09)      VALUE 'ZC9251505'.
130300         05  FILLER          PIC  X(09)      VALUE 'ZC9261506'.
130400         05  FILLER          PIC  X(09)      VALUE 'ZC9271507'.
130500         05  FILLER          PIC  X(09)      VALUE 'ZC9281508'.
130600         05  FILLER          PIC  X(09)      VALUE 'ZC9291509'.
130700         05  FILLER          PIC  X(09)      VALUE 'ZC9301510'.
130800         05  FILLER          PIC  X(09)      VALUE 'ZC9311601'.
130900         05  FILLER          PIC  X(09)      VALUE 'ZC9321602'.
131000         05  FILLER          PIC  X(09)      VALUE 'ZC9331603'.
131100         05  FILLER          PIC  X(09)      VALUE 'ZC9341604'.
131200         05  FILLER          PIC  X(09)      VALUE 'ZC9351605'.
131300         05  FILLER          PIC  X(09)      VALUE 'ZC9361606'.
131400         05  FILLER          PIC  X(09)      VALUE 'ZC9371607'.
131500         05  FILLER          PIC  X(09)      VALUE 'ZC9381608'.
131600         05  FILLER          PIC  X(09)      VALUE 'ZC9391609'.
131700         05  FILLER          PIC  X(09)      VALUE 'ZC9401610'.
131800         05  FILLER          PIC  X(09)      VALUE 'ZC9921403'.
131900         05  FILLER          PIC  X(09)      VALUE 'ZP0021301'.
132000         05  FILLER          PIC  X(09)      VALUE 'ZP0031302'.
132100         05  FILLER          PIC  X(09)      VALUE 'ZP0041303'.
132200         05  FILLER          PIC  X(09)      VALUE 'ZP0121001'.
132300         05  FILLER          PIC  X(09)      VALUE 'ZP0131002'.
132400         05  FILLER          PIC  X(09)      VALUE 'ZP0161003'.
132500         05  FILLER          PIC  X(09)      VALUE 'ZP0171004'.
132600         05  FILLER          PIC  X(09)      VALUE 'ZP0181005'.
132700         05  FILLER          PIC  X(09)      VALUE 'ZP0191006'.
132800         05  FILLER          PIC  X(09)      VALUE 'ZP0241201'.
132900         05  FILLER          PIC  X(09)      VALUE 'ZP0271007'.
133000         05  FILLER          PIC  X(09)      VALUE 'ZP0281008'.
133100         05  FILLER          PIC  X(09)      VALUE 'ZP0291009'.
133200         05  FILLER          PIC  X(09)      VALUE 'ZP0300301'.
133300         05  FILLER          PIC  X(09)      VALUE 'ZP0310302'.
133400         05  FILLER          PIC  X(09)      VALUE 'ZP1021304'.
133500         05  FILLER          PIC  X(09)      VALUE 'ZP1031305'.
133600         05  FILLER          PIC  X(09)      VALUE 'ZP1041306'.
133700         05  FILLER          PIC  X(09)      VALUE 'ZP1051307'.
133800         05  FILLER          PIC  X(09)      VALUE 'ZP1121101'.
133900         05  FILLER          PIC  X(09)      VALUE 'ZP1131102'.
134000         05  FILLER          PIC  X(09)      VALUE 'ZP1161103'.
134100         05  FILLER          PIC  X(09)      VALUE 'ZP1171104'.
134200         05  FILLER          PIC  X(09)      VALUE 'ZP1181105'.
134300         05  FILLER          PIC  X(09)      VALUE 'ZP1191106'.
134400         05  FILLER          PIC  X(09)      VALUE 'ZP1241202'.
134500         05  FILLER          PIC  X(09)      VALUE 'ZP1271107'.
134600         05  FILLER          PIC  X(09)      VALUE 'ZP1281108'.
134700         05  FILLER          PIC  X(09)      VALUE 'ZP1291109'.
134800         05  FILLER          PIC  X(09)      VALUE 'ZP1300303'.
134900         05  FILLER          PIC  X(09)      VALUE 'ZP1310304'.
135000         05  FILLER          PIC  X(09)      VALUE 'ZP2010201'.
135100         05  FILLER          PIC  X(09)      VALUE 'ZP2080202'.
135200         05  FILLER          PIC  X(09)      VALUE 'ZP3010203'.
135300         05  FILLER          PIC  X(09)      VALUE 'ZP3080204'.
135400         05  FILLER          PIC  X(09)      VALUE 'ZP9021401'.
135500         05  FILLER          PIC  X(09)      VALUE 'ZP9031404'.
135600         05  FILLER          PIC  X(09)      VALUE 'ZP9041405'.
135700         05  FILLER          PIC  X(09)      VALUE 'ZP9051406'.
135800         05  FILLER          PIC  X(09)      VALUE 'ZP9061407'.
135900         05  FILLER          PIC  X(09)      VALUE 'ZP9071408'.
136000         05  FILLER          PIC  X(09)      VALUE 'ZP9121402'.
136100         05  FILLER          PIC  X(09)      VALUE 'ZP9131409'.
136200         05  FILLER          PIC  X(09)      VALUE 'ZP9141410'.
136300         05  FILLER          PIC  X(09)      VALUE 'ZP9151411'.
136400         05  FILLER          PIC  X(09)      VALUE 'ZP9161412'.
136500         05  FILLER          PIC  X(09)      VALUE 'ZP9211501'.
136600         05  FILLER          PIC  X(09)      VALUE 'ZP9221502'.
136700         05  FILLER          PIC  X(09)      VALUE 'ZP9231503'.
136800         05  FILLER          PIC  X(09)      VALUE 'ZP9241504'.
136900         05  FILLER          PIC  X(09)      VALUE 'ZP9251505'.
137000         05  FILLER          PIC  X(09)      VALUE 'ZP9261506'.
137100         05  FILLER          PIC  X(09)      VALUE 'ZP9271507'.
137200         05  FILLER          PIC  X(09)      VALUE 'ZP9281508'.
137300         05  FILLER          PIC  X(09)      VALUE 'ZP9291509'.
137400         05  FILLER          PIC  X(09)      VALUE 'ZP9301510'.
137500         05  FILLER          PIC  X(09)      VALUE 'ZP9311601'.
137600         05  FILLER          PIC  X(09)      VALUE 'ZP9321602'.
137700         05  FILLER          PIC  X(09)      VALUE 'ZP9331603'.
137800         05  FILLER          PIC  X(09)      VALUE 'ZP9341604'.
137900         05  FILLER          PIC  X(09)      VALUE 'ZP9351605'.
138000         05  FILLER          PIC  X(09)      VALUE 'ZP9361606'.
138100         05  FILLER          PIC  X(09)      VALUE 'ZP9371607'.
138200         05  FILLER          PIC  X(09)      VALUE 'ZP9381608'.
138300         05  FILLER          PIC  X(09)      VALUE 'ZP9391609'.
138400         05  FILLER          PIC  X(09)      VALUE 'ZP9401610'.
138500         05  FILLER          PIC  X(09)      VALUE 'ZP9921403'.
138600         05  FILLER          PIC  X(09)      VALUE 'ZT0000201'.
138700         05  FILLER          PIC  X(09)      VALUE 'ZT0021301'.
138800         05  FILLER          PIC  X(09)      VALUE 'ZT0031302'.
138900         05  FILLER          PIC  X(09)      VALUE 'ZT0041303'.
139000         05  FILLER          PIC  X(09)      VALUE 'ZT0121001'.
139100         05  FILLER          PIC  X(09)      VALUE 'ZT0131002'.
139200         05  FILLER          PIC  X(09)      VALUE 'ZT0141003'.
139300         05  FILLER          PIC  X(09)      VALUE 'ZT0151004'.
139400         05  FILLER          PIC  X(09)      VALUE 'ZT0161005'.
139500         05  FILLER          PIC  X(09)      VALUE 'ZT0171006'.
139600         05  FILLER          PIC  X(09)      VALUE 'ZT0181007'.
139700         05  FILLER          PIC  X(09)      VALUE 'ZT0191008'.
139800         05  FILLER          PIC  X(09)      VALUE 'ZT0201201'.
139900         05  FILLER          PIC  X(09)      VALUE 'ZT0211202'.
140000         05  FILLER          PIC  X(09)      VALUE 'ZT0221203'.
140100         05  FILLER          PIC  X(09)      VALUE 'ZT0231204'.
140200         05  FILLER          PIC  X(09)      VALUE 'ZT0241205'.
140300         05  FILLER          PIC  X(09)      VALUE 'ZT0271009'.
140400         05  FILLER          PIC  X(09)      VALUE 'ZT0281010'.
140500         05  FILLER          PIC  X(09)      VALUE 'ZT0291011'.
140600         05  FILLER          PIC  X(09)      VALUE 'ZT0300301'.
140700         05  FILLER          PIC  X(09)      VALUE 'ZT0310302'.
140800         05  FILLER          PIC  X(09)      VALUE 'ZT1000202'.
140900         05  FILLER          PIC  X(09)      VALUE 'ZT1021304'.
141000         05  FILLER          PIC  X(09)      VALUE 'ZT1031305'.
141100         05  FILLER          PIC  X(09)      VALUE 'ZT1041306'.
141200         05  FILLER          PIC  X(09)      VALUE 'ZT1051307'.
141300         05  FILLER          PIC  X(09)      VALUE 'ZT1121101'.
141400         05  FILLER          PIC  X(09)      VALUE 'ZT1131102'.
141500         05  FILLER          PIC  X(09)      VALUE 'ZT1141103'.
141600         05  FILLER          PIC  X(09)      VALUE 'ZT1151104'.
141700         05  FILLER          PIC  X(09)      VALUE 'ZT1161105'.
141800         05  FILLER          PIC  X(09)      VALUE 'ZT1171106'.
141900         05  FILLER          PIC  X(09)      VALUE 'ZT1181107'.
142000         05  FILLER          PIC  X(09)      VALUE 'ZT1191108'.
142100         05  FILLER          PIC  X(09)      VALUE 'ZT1201206'.
142200         05  FILLER          PIC  X(09)      VALUE 'ZT1211207'.
142300         05  FILLER          PIC  X(09)      VALUE 'ZT1221208'.
142400         05  FILLER          PIC  X(09)      VALUE 'ZT1231209'.
142500         05  FILLER          PIC  X(09)      VALUE 'ZT1241210'.
142600         05  FILLER          PIC  X(09)      VALUE 'ZT1271109'.
142700         05  FILLER          PIC  X(09)      VALUE 'ZT1281110'.
142800         05  FILLER          PIC  X(09)      VALUE 'ZT1291111'.
142900         05  FILLER          PIC  X(09)      VALUE 'ZT1300303'.
143000         05  FILLER          PIC  X(09)      VALUE 'ZT1310304'.
143100         05  FILLER          PIC  X(09)      VALUE 'ZT2010203'.
143200         05  FILLER          PIC  X(09)      VALUE 'ZT2080204'.
143300         05  FILLER          PIC  X(09)      VALUE 'ZT3010205'.
143400         05  FILLER          PIC  X(09)      VALUE 'ZT3080206'.
143500         05  FILLER          PIC  X(09)      VALUE 'ZT9021401'.
143600         05  FILLER          PIC  X(09)      VALUE 'ZT9031404'.
143700         05  FILLER          PIC  X(09)      VALUE 'ZT9041405'.
143800         05  FILLER          PIC  X(09)      VALUE 'ZT9051406'.
143900         05  FILLER          PIC  X(09)      VALUE 'ZT9061407'.
144000         05  FILLER          PIC  X(09)      VALUE 'ZT9071408'.
144100         05  FILLER          PIC  X(09)      VALUE 'ZT9091409'.
144200         05  FILLER          PIC  X(09)      VALUE 'ZT9121402'.
144300         05  FILLER          PIC  X(09)      VALUE 'ZT9131410'.
144400         05  FILLER          PIC  X(09)      VALUE 'ZT9141411'.
144500         05  FILLER          PIC  X(09)      VALUE 'ZT9151412'.
144600         05  FILLER          PIC  X(09)      VALUE 'ZT9161413'.
144700         05  FILLER          PIC  X(09)      VALUE 'ZT9211501'.
144800         05  FILLER          PIC  X(09)      VALUE 'ZT9221502'.
144900         05  FILLER          PIC  X(09)      VALUE 'ZT9231503'.
145000         05  FILLER          PIC  X(09)      VALUE 'ZT9241504'.
145100         05  FILLER          PIC  X(09)      VALUE 'ZT9251505'.
145200         05  FILLER          PIC  X(09)      VALUE 'ZT9261506'.
145300         05  FILLER          PIC  X(09)      VALUE 'ZT9271507'.
145400         05  FILLER          PIC  X(09)      VALUE 'ZT9281508'.
145500         05  FILLER          PIC  X(09)      VALUE 'ZT9291509'.
145600         05  FILLER          PIC  X(09)      VALUE 'ZT9301510'.
145700         05  FILLER          PIC  X(09)      VALUE 'ZT9311601'.
145800         05  FILLER          PIC  X(09)      VALUE 'ZT9321602'.
145900         05  FILLER          PIC  X(09)      VALUE 'ZT9331603'.
146000         05  FILLER          PIC  X(09)      VALUE 'ZT9341604'.
146100         05  FILLER          PIC  X(09)      VALUE 'ZT9351605'.
146200         05  FILLER          PIC  X(09)      VALUE 'ZT9361606'.
146300         05  FILLER          PIC  X(09)      VALUE 'ZT9371607'.
146400         05  FILLER          PIC  X(09)      VALUE 'ZT9381608'.
146500         05  FILLER          PIC  X(09)      VALUE 'ZT9391609'.
146600         05  FILLER          PIC  X(09)      VALUE 'ZT9401610'.
146700         05  FILLER          PIC  X(09)      VALUE 'ZT9921403'.
146800     03  WS-LOGIC-MOD-PAGE-TABLE-R
146900                             REDEFINES WS-LOGIC-MOD-PAGE-TABLE.
147000         05  WS-LM-PAGE-LINE-ENTRIES.
147100             07  WS-LM-PAGE-LINE-ENTRY       OCCURS 981 TIMES
147200                                             ASCENDING KEY IS
147300                                             WS-LM-PAGE-LINE-KEY
147400                                             INDEXED BY
147500                                             X-WS-LM-PAGE-LINE.
147600                 09  WS-LM-PAGE-LINE-KEY.
147700                     11  WS-LM-PL-CM-FLAG
147800                             PIC  X(01).
147900                         88  WS-LM-PL-CM-GENERIC
148000                                             VALUE 'X'.
148100                     11  WS-LM-PL-SUB-FLAG
148200                             PIC  X(01).
148300                         88  WS-LM-PL-SUB-GENERIC
148400                                             VALUE 'X'.
148500                     11  WS-LM-PL-LOGIC-MODULE
148600                             PIC  9(03).
148700                 09  WS-LM-PL-SCREEN-SORT.
148800                     11  WS-LM-PL-PAGE-NBR
148900                             PIC  9(02).
149000                     11  WS-LM-PL-LINE-NBR
149100                             PIC  9(02).
149200*
149300     03  WS-STATISTICS-POS-LIT-TABLE.
149400         05  FILLER          PIC  X(14)      VALUE
149500                             'JANUARY   9999'.
149600         05  FILLER          PIC  X(14)      VALUE
149700                             'FEBRUARY  9999'.
149800         05  FILLER          PIC  X(14)      VALUE
149900                             'MARCH     9999'.
150000         05  FILLER          PIC  X(14)      VALUE
150100                             'APRIL     9999'.
150200         05  FILLER          PIC  X(14)      VALUE
150300                             'MAY       9999'.
150400         05  FILLER          PIC  X(14)      VALUE
150500                             'JUNE      9999'.
150600         05  FILLER          PIC  X(14)      VALUE
150700                             'JULY      9999'.
150800         05  FILLER          PIC  X(14)      VALUE
150900                             'AUGUST    9999'.
151000         05  FILLER          PIC  X(14)      VALUE
151100                             'SEPTEMBER 9999'.
151200         05  FILLER          PIC  X(14)      VALUE
151300                             'OCTOBER   9999'.
151400         05  FILLER          PIC  X(14)      VALUE
151500                             'NOVEMBER  9999'.
151600         05  FILLER          PIC  X(14)      VALUE
151700                             'DECEMBER  9999'.
151800         05  FILLER          PIC  X(14)      VALUE
151900                             ' CURRENT DAY  '.
152000         05  FILLER          PIC  X(14)      VALUE
152100                             'MONTH TO DATE '.
152200         05  FILLER          PIC  X(14)      VALUE
152300                             ' YEAR TO DATE '.
152400         05  FILLER          PIC  X(14)      VALUE
152500                             'CYCLE TO DATE '.
152600         05  FILLER          PIC  X(14)      VALUE
152700                             'DISC  TO DATE '.
152800         05  FILLER          PIC  X(14)      VALUE
152900                             'PART  TO DATE '.
153000     03  WS-STATS-POS-TABLE  REDEFINES
153100                             WS-STATISTICS-POS-LIT-TABLE.
153200         05  WS-STATS-POS-LIT                OCCURS 18 TIMES
153300                                             INDEXED BY
153400                                             X-STATS-POS-INDEX.
153500             07  WS-STATS-LIT-1-3
153600                             PIC  X(03).
153700             07  WS-STATS-LIT-4-10
153800                             PIC  X(07).
153900             07  WS-STATS-YEAR
154000                             PIC  9(04).
154100*
154200 01  FILLER                  PIC  X(12)      VALUE '** WS-END **'.
154300/
154400 LINKAGE SECTION.
154500 01  DFHCOMMAREA.
154600     COPY MB60WS.
154700/         STATISTICS SCREEN 01-14 MAP DSECT
154800     COPY MBSM01.
154900/         STATISTICS SCREEN 01-14 MAP REDEFINITION
155000     COPY MBSM01R.
155100/         MERCH/PROD/CREDIT PLAN GROUP STATS FILE RECORD LAYOUT
155200     COPY MMPARL REPLACING ==:MMPA:== BY ==MMCG==.
155300/         MERCHANT/PROD/CREDIT PLAN STATS FILE RECORD LAYOUT
155400     COPY MMPARL REPLACING ==:MMPA:== BY ==MMCP==.
155500/         STORE/PROD/CREDIT PLAN STATS FILE RECORD LAYOUT
155600     COPY MMPARL REPLACING ==:MMPA:== BY ==MMCS==.
155700/         OUTGOING INTERCHANGE STATS FILE RECORD LAYOUT
155800     COPY MMPARL REPLACING ==:MMPA:== BY ==MMOI==.
155900/         OUTGOING INTERCHANGE GROUP STATS FILE RECORD LAYOUT
156000     COPY MMPARL REPLACING ==:MMPA:== BY ==MMOG==.
156100/         MERCHANT/PRODUCT STATS FILE RECORD LAYOUT
156200     COPY MMPARL REPLACING ==:MMPA:== BY ==MMPA==.
156300/         MERCHANT/PRODUCT GROUP STATS FILE RECORD LAYOUT
156400     COPY MMPARL REPLACING ==:MMPA:== BY ==MMPG==.
156500/         STORE PRODUCT STATS FILE RECORD LAYOUT
156600     COPY MMPARL REPLACING ==:MMPA:== BY ==MMPS==.
156700/         MERCH PROD EXPENSE GROUP STATS RECORD LAYOUT
156800     COPY MMPARL REPLACING ==:MMPA:== BY ==MMPX==.
156900/         OUTGOING INTCH EXPENSE GROUP STATS RECORD LAYOUT
157000     COPY MMPARL REPLACING ==:MMPA:== BY ==MMOX==.
157100/         MERCH PROD EXPENSE STATS RECORD LAYOUT
157200     COPY MMPARL REPLACING ==:MMPA:== BY ==MMPE==.
157300/         OUTGOING INTCH EXPENSE STATS RECORD LAYOUT
157400     COPY MMPARL REPLACING ==:MMPA:== BY ==MMOE==.
157500/         STORE CHAIN PROD STATS RECORD LAYOUT
157600     COPY MMPARL REPLACING ==:MMPA:== BY ==MMRG==.
157700/         STORE PROD CREDIT PLAN GROUP RECORD LAYOUT
157800     COPY MMPARL REPLACING ==:MMPA:== BY ==MMLG==.
157900/         GROUP FEE ACTIVITY MASTER RECORD LAYOUT
158000     COPY MMFARL REPLACING ==:MMFA:== BY ==MMFG==.
158100/         FEE ACTIVITY MASTER RECORD LAYOUT
158200     COPY MMFARL REPLACING ==:MMFA:== BY ==MMFA==.
158300/
158400 01  LS-STATS-TABLE.
158500     03  LS-STATS-ENTRY-COUNT
158600                             PIC S9(04)      BINARY.
158700     03  LS-STATS-ENTRIES.
158800         05  LS-STATS-ENTRY                  OCCURS 1000 TIMES
158900                                             INDEXED BY
159000                                             X-LS-STATS-1
159100                                             X-LS-STATS-2
159200                                             X-LS-STATS-3.
159300             07  LS-STATS-SCREEN-SORT.
159400                 09  LS-STATS-PAGE-NBR
159500                             PIC  9(02).
159600                 09  LS-STATS-LINE-NBR
159700                             PIC  9(02).
159800             07  LS-STATS-SCREEN-DATA.
159900                 09  LS-STATS-LOGIC-MODULE
160000                             PIC  9(03).
160100                 09  LS-STATS-COL1-INFO.
160200                     11  LS-STATS-NBR-COL1
160300                             PIC S9(09)      PACKED-DECIMAL.
160400                     11  LS-STATS-AMT-COL1
160500                             PIC S9(17)      PACKED-DECIMAL.
160600                 09  LS-STATS-COL2-INFO.
160700                     11  LS-STATS-NBR-COL2
160800                             PIC S9(09)      PACKED-DECIMAL.
160900                     11  LS-STATS-AMT-COL2
161000                             PIC S9(17)      PACKED-DECIMAL.
161100/
161200 PROCEDURE DIVISION.
161300 0000-HOUSEKEEPING SECTION.
161400 0100-INIT.
161500*
161600     MOVE MBCA-EIBAID            TO WS-SAVE-EIBAID.
161700     SET MBCA-EIBAID-ENTER       TO TRUE.
161800*
161900     MOVE 'PC01'                 TO MBCA-PROGRAM-LOCATION.
162000     PERFORM MB70PD-ON-LINE-HOUSEKEEPING
162100                                 THRU MB70PD-OLH-EXIT.
162200*
162300     MOVE WS-SAVE-EIBAID         TO MBCA-EIBAID.
162400     MOVE MBCA-TERMINAL-ID       TO TS-QN-TERMID
162500*
162600     SET SS95WS-FUNCTION-INITIALIZE
162700                                 TO TRUE.
162800     PERFORM SS95PD-NAP-ROUTINE
162900        THRU SS95PD-NAP-EXIT.
163000*
163100     IF  MBCA-RECEIVE-SCREEN
163200         GO TO 2000-RECEIVE-SCREEN.
163300/
163400 1000-SEND-SCREEN SECTION.
163500*
163600****************************************************************
163700*    THIS SECTION BUILDS AND SENDS THE 01 THRU 17 SCREENS      *
163800****************************************************************
163900*
164000****************************************************************
164100*    GET CICS STORAGE NEEDED FOR THE MAP                       *
164200****************************************************************
164300*
164400     MOVE 'SC09'                 TO MBCA-PROGRAM-LOCATION.
164500     PERFORM MB60PD-GETMAIN-FOR-MAP
164600                                 THRU MB60PD-GFM-EXIT.
164700*
164800     PERFORM 9800-BUILD-KEY-LINE THRU 9810-BKL-EXIT.
164900*
165000     IF  MBCA-SCREEN-NBR IS GREATER THAN +50
165100     AND MBCA-SCREEN-NBR IS LESS THAN +99
165200         COMPUTE MBCA-SCREEN-NBR = MBCA-SCREEN-NBR - 50
165300     ELSE
165400         MOVE 01                 TO MBCA-SCREEN-NBR
165500     END-IF.
165600*
165700****************************************************************
165800*    INITIALIZE THE STANDARD MAP LINES                         *
165900****************************************************************
166000*
166100     PERFORM MB60PD-INIT-STD-MAP-LINES
166200                                 THRU MB60PD-ISML-EXIT.
166300*
166400****************************************************************
166500*    LOAD APPROPRIATE TITLES FOR COLUMN 1 & 2 HEADINGS.        *
166600****************************************************************
166700*
166800     IF  MBCA-MBSM-INDEX-1 IS GREATER THAN ZERO
166900         SET X-STATS-POS-INDEX   TO MBCA-MBSM-INDEX-1
167000         IF  MBCA-MBSM-INDEX-1 IS LESS THAN +13
167100             SET X-MBCA-MBSM-STATS
167200                                 TO MBCA-MBSM-INDEX-1
167300             PERFORM
167400                 VARYING X-STATS-POS-INDEX FROM +1 BY +1
167500                 UNTIL   X-STATS-POS-INDEX IS GREATER THAN +12
167600                 OR  MBCA-MBSM-OCCURENCE-ID (X-MBCA-MBSM-STATS)
167700                     IS EQUAL TO WS-STATS-LIT-1-3
167800                                    (X-STATS-POS-INDEX)
167900             END-PERFORM
168000             MOVE MBCA-MBSM-OCCURENCE-YEAR (X-MBCA-MBSM-STATS)
168100                                 TO WS-STATS-YEAR
168200                                    (X-STATS-POS-INDEX)
168300             MOVE WS-STATS-POS-LIT (X-STATS-POS-INDEX)
168400                                 TO WS-STATS-POS1-LIT
168500         ELSE
168600             MOVE WS-STATS-POS-LIT (X-STATS-POS-INDEX)
168700                                 TO WS-STATS-POS1-LIT
168800         END-IF
168900     ELSE
169000         MOVE ALL '*'            TO WS-STATS-OCCURS-POS1
169100                                    WS-STATS-ACTIVITY-LINE-1
169200     END-IF.
169300*
169400     IF  MBCA-MBSM-INDEX-2 IS GREATER THAN ZERO
169500         SET X-STATS-POS-INDEX   TO MBCA-MBSM-INDEX-2
169600         IF  MBCA-MBSM-INDEX-2 IS LESS THAN +13
169700             SET X-MBCA-MBSM-STATS
169800                                 TO MBCA-MBSM-INDEX-2
169900             PERFORM
170000                 VARYING X-STATS-POS-INDEX FROM +1 BY +1
170100                 UNTIL   X-STATS-POS-INDEX IS GREATER THAN +12
170200                 OR  MBCA-MBSM-OCCURENCE-ID (X-MBCA-MBSM-STATS)
170300                     IS EQUAL TO WS-STATS-LIT-1-3
170400                                    (X-STATS-POS-INDEX)
170500             END-PERFORM
170600             MOVE MBCA-MBSM-OCCURENCE-YEAR (X-MBCA-MBSM-STATS)
170700                                 TO WS-STATS-YEAR
170800                                    (X-STATS-POS-INDEX)
170900             MOVE WS-STATS-POS-LIT (X-STATS-POS-INDEX)
171000                                 TO WS-STATS-POS2-LIT
171100         ELSE
171200             MOVE WS-STATS-POS-LIT (X-STATS-POS-INDEX)
171300                                 TO WS-STATS-POS2-LIT
171400         END-IF
171500     ELSE
171600         MOVE ALL '*'            TO WS-STATS-OCCURS-POS2
171700                                    WS-STATS-ACTIVITY-LINE-2
171800     END-IF.
171900*
172000     MOVE WS-STATS-OCCURS-LINE   TO SM01-STATS-LIT-LINE1.
172100     MOVE WS-STATS-ACTIVITY-LINE TO SM01-STATS-LIT-LINE2.
172200*
172300     IF  MBCA-MBSM-FIRST-SCREEN IS EQUAL TO +51
172400         PERFORM 8500-LOAD-TS-STATS
172500                                 THRU 8510-LTS-EXIT
172600     ELSE
172700         MOVE 'TS01'             TO MBCA-PROGRAM-LOCATION
172800         PERFORM 8200-TEMP-STORAGE-READ
172900                                 THRU 8299-TSR-EXIT
173000         MOVE 'TS02'             TO MBCA-PROGRAM-LOCATION
173100         PERFORM 8300-TEMP-STORAGE-DELETE
173200                                 THRU 8399-TSD-EXIT
173300     END-IF.
173400*
173500     IF  MBCA-MBSM-VALID-QUAL-LVL
173600         PERFORM 9700-BUILD-SCREEN
173700                                 THRU 9799-BS-EXIT
173800         MOVE DFHBMASK           TO SM01-CURRENT-PAGE-A
173900         MOVE '          QUALIFICATION LEVEL'
174000                                 TO SM01-MENU-DESC
174100         MOVE 01                 TO MBCA-SCREEN-NBR
174200                                    SM01-CURRENT-PAGE
174300     ELSE
174400         PERFORM 9600-BUILD-SCREEN
174500                                 THRU 9699-BS-EXIT.
174600*
174700     MOVE SS08WS-CURSOR          TO SM01-ALT-TRANID-L.
174800*
174900     IF  MBCA-MBSM-FIRST-SCREEN IS EQUAL TO +51
175000         ADD +1                  TO MBCA-MBSM-FIRST-SCREEN
175100     ELSE
175200         MOVE 'TS03'             TO MBCA-PROGRAM-LOCATION
175300         PERFORM 8400-WRITE-QUEUE
175400                                 THRU 8499-WQ-EXIT.
175500*
175600***********************************************************
175700*    SET THE CURRENCY CODE, CURRENCY NOD
175800*            PER ITEM NOD, PERCENT NOD.
175900***********************************************************
176000     IF SM01-ERROR-MESSAGE IS EQUAL TO SPACES OR LOW-VALUES
176100        PERFORM MB06PD-FORMAT-MESSAGE-LINE
176200                                 THRU MB06PD-FML-EXIT
176300        MOVE SS08WS-FORMATTED-MSG   TO SM01-ERROR-MESSAGE
176400     END-IF.
176500*
176600****************************************************************
176700*    SEND THE MAP                                              *
176800****************************************************************
176900*
177000 1400-SEND-MAP.
177100*
177200     MOVE 'BM01'                 TO MBCA-PROGRAM-LOCATION.
177300     PERFORM MB60PD-SEND-MAP-WITH-ERASE
177400                                 THRU MB60PD-SMWE-EXIT.
177500*
177600****************************************************************
177700*    RETURN TO CICS                                            *
177800****************************************************************
177900*
178000     MOVE 'PC02'                 TO MBCA-PROGRAM-LOCATION.
178100     PERFORM MB70PD-RETURN-TRANS-ID
178200                                 THRU MB70PD-RTI-EXIT.
178300/
178400 2000-RECEIVE-SCREEN SECTION.
178500*
178600     IF  MBCA-EIBAID-CLEAR
178700         MOVE 'TS04'             TO MBCA-PROGRAM-LOCATION
178800         PERFORM 8300-TEMP-STORAGE-DELETE
178900                                 THRU 8399-TSD-EXIT
179000         MOVE 'PC03'             TO MBCA-PROGRAM-LOCATION
179100         PERFORM MB70PD-ON-LINE-HOUSEKEEPING
179200                                 THRU MB70PD-OLH-EXIT.
179300*
179400****************************************************************
179500*    THIS SECTION RECEIVES THE 01 THROUGH 17 SCREENS           *
179600****************************************************************
179700*
179800     MOVE 'BM02'                 TO MBCA-PROGRAM-LOCATION.
179900     PERFORM MB60PD-RECEIVE-MAP  THRU MB60PD-RM-EXIT.
180000*
180100****************************************************************
180200*    THIS SECTION READS AND DELETES THE TEMP STORAGE RECORD    *
180300****************************************************************
180400*
180500     MOVE 'TS05'                 TO MBCA-PROGRAM-LOCATION.
180600     PERFORM 8200-TEMP-STORAGE-READ
180700                                 THRU 8299-TSR-EXIT.
180800*
180900     MOVE 'TS06'                 TO MBCA-PROGRAM-LOCATION.
181000     PERFORM 8300-TEMP-STORAGE-DELETE
181100                                 THRU 8399-TSD-EXIT.
181200*
181300****************************************************************
181400*    CHECK FOR ANOTHER TRANSACTION ID ENTERED BY THE USER      *
181500****************************************************************
181600*
181700     MOVE 'PC04'                 TO MBCA-PROGRAM-LOCATION.
181800     PERFORM MB60PD-NEW-TRANS-ROUTINE
181900                                 THRU MB60PD-NTR-EXIT.
182000/
182100 2600-SETUP-COMMAREA.
182200*
182300****************************************************************
182400*    SET UP COMMAREA FIELDS AND TRANSFER TO THE NEXT PROGRAM   *
182500****************************************************************
182600*
182700     MOVE MBCA-EIBAID            TO SS08WS-EIBAID.
182800*
182900     EVALUATE TRUE
183000       WHEN MBCA-MBSM-EXPENSE-SPACE
183100         EVALUATE TRUE ALSO TRUE
183200           WHEN MBCA-MBSM-VALID-CHAIN
183300           ALSO MBCA-MBSM-VALID-TOTALS
183400             MOVE MBIOWS-MMRC-DIRECT-KEY-CODE
183500                                 TO MBCA-KEY-CODE
183600           WHEN MBCA-MBSM-VALID-CHAIN
183700           ALSO MBCA-MBSM-VALID-PRODUCT
183800             MOVE MBIOWS-MMPG-DIRECT-KEY-CODE
183900                                 TO MBCA-KEY-CODE
184000           WHEN MBCA-MBSM-VALID-CHAIN
184100           ALSO MBCA-MBSM-VALID-CRED-PLAN
184200             MOVE MBIOWS-MMCG-DIRECT-KEY-CODE
184300                                 TO MBCA-KEY-CODE
184400           WHEN MBCA-MBSM-VALID-CHAIN
184500           ALSO MBCA-MBSM-VALID-QUAL-LVL
184600             MOVE MBIOWS-MMOG-DIRECT-KEY-CODE
184700                                 TO MBCA-KEY-CODE
184800           WHEN MBCA-MBSM-VALID-MERCHANT
184900           ALSO MBCA-MBSM-VALID-TOTALS
185000             MOVE MBIOWS-MMMM-DIRECT-KEY-CODE
185100                                 TO MBCA-KEY-CODE
185200           WHEN MBCA-MBSM-VALID-MERCHANT
185300           ALSO MBCA-MBSM-VALID-PRODUCT
185400             MOVE MBIOWS-MMPA-DIRECT-KEY-CODE
185500                                 TO MBCA-KEY-CODE
185600           WHEN MBCA-MBSM-VALID-MERCHANT
185700           ALSO MBCA-MBSM-VALID-CRED-PLAN
185800             MOVE MBIOWS-MMCP-DIRECT-KEY-CODE
185900                                 TO MBCA-KEY-CODE
186000           WHEN MBCA-MBSM-VALID-MERCHANT
186100           ALSO MBCA-MBSM-VALID-QUAL-LVL
186200             MOVE MBIOWS-MMOI-DIRECT-KEY-CODE
186300                                 TO MBCA-KEY-CODE
186400         END-EVALUATE
186500       WHEN MBCA-MBSM-EXPENSE-VALID
186600         EVALUATE TRUE ALSO TRUE
186700           WHEN MBCA-MBSM-VALID-CHAIN
186800           ALSO MBCA-MBSM-VALID-TOTALS
186900             MOVE MBIOWS-MMRC-DIRECT-KEY-CODE
187000                                 TO MBCA-KEY-CODE
187100           WHEN MBCA-MBSM-VALID-CHAIN
187200           ALSO MBCA-MBSM-VALID-PRODUCT
187300             MOVE MBIOWS-MMPX-DIRECT-KEY-CODE
187400                                 TO MBCA-KEY-CODE
187500           WHEN MBCA-MBSM-VALID-CHAIN
187600           ALSO MBCA-MBSM-VALID-QUAL-LVL
187700             MOVE MBIOWS-MMOX-DIRECT-KEY-CODE
187800                                 TO MBCA-KEY-CODE
187900           WHEN MBCA-MBSM-VALID-MERCHANT
188000           ALSO MBCA-MBSM-VALID-TOTALS
188100             MOVE MBIOWS-MMMM-DIRECT-KEY-CODE
188200                                 TO MBCA-KEY-CODE
188300           WHEN MBCA-MBSM-VALID-MERCHANT
188400           ALSO MBCA-MBSM-VALID-PRODUCT
188500             MOVE MBIOWS-MMPE-DIRECT-KEY-CODE
188600                                 TO MBCA-KEY-CODE
188700           WHEN MBCA-MBSM-VALID-MERCHANT
188800           ALSO MBCA-MBSM-VALID-QUAL-LVL
188900             MOVE MBIOWS-MMOE-DIRECT-KEY-CODE
189000                                 TO MBCA-KEY-CODE
189100         END-EVALUATE
189200     END-EVALUATE.
189300*
189400     EVALUATE TRUE ALSO TRUE
189500         WHEN MBCA-MBSM-VALID-STORE
189600         ALSO MBCA-MBSM-VALID-TOTALS
189700             MOVE MBIOWS-MMSM-DIRECT-KEY-CODE
189800                                 TO MBCA-KEY-CODE
189900         WHEN MBCA-MBSM-VALID-STORE
190000         ALSO MBCA-MBSM-VALID-PRODUCT
190100             MOVE MBIOWS-MMPS-DIRECT-KEY-CODE
190200                                 TO MBCA-KEY-CODE
190300         WHEN MBCA-MBSM-VALID-STORE
190400         ALSO MBCA-MBSM-VALID-CRED-PLAN
190500             MOVE MBIOWS-MMCS-DIRECT-KEY-CODE
190600                                 TO MBCA-KEY-CODE
190700         WHEN MBCA-MBSM-VALID-S-CHAIN
190800         ALSO MBCA-MBSM-VALID-TOTALS
190900             MOVE MBIOWS-MMSM-DIRECT-KEY-CODE
191000                                 TO MBCA-KEY-CODE
191100         WHEN MBCA-MBSM-VALID-S-CHAIN
191200         ALSO MBCA-MBSM-VALID-PRODUCT
191300             MOVE MBIOWS-MMRG-DIRECT-KEY-CODE
191400                                 TO MBCA-KEY-CODE
191500         WHEN MBCA-MBSM-VALID-S-CHAIN
191600         ALSO MBCA-MBSM-VALID-CRED-PLAN
191700             MOVE MBIOWS-MMLG-DIRECT-KEY-CODE
191800                                 TO MBCA-KEY-CODE
191900     END-EVALUATE.
192000*
192100     PERFORM MB60PD-EDIT-PAGE-NBR
192200                                 THRU MB60PD-EPN-EXIT.
192300*
192400     IF  SS08WS-VALID-PF-KEY
192500     OR  SS08WS-EIBAID-VALID-PF-KEY
192600         SET MBCA-INITIAL-SCREEN-NBR
192700                                 TO TRUE.
192800*
192900     IF  MBCA-INITIAL-SCREEN-NBR
193000     OR  MBCA-SCREEN-NBR IS EQUAL TO 50
193100         NEXT SENTENCE
193200     ELSE
193300         MOVE 'TS07'             TO MBCA-PROGRAM-LOCATION
193400         PERFORM 8400-WRITE-QUEUE
193500                                 THRU 8499-WQ-EXIT.
193600*
193700     MOVE 'PC05'                 TO MBCA-PROGRAM-LOCATION.
193800     PERFORM MB70PD-XCTL-TO-MBOXCTL
193900                                 THRU MB70PD-XTM-EXIT.
194000/
194100 8000-PERFORMED-ROUTINES-SECT SECTION.
194200*
194300 8100-TEMP-STORAGE-GETMAIN.
194400*
194500     EXEC CICS GETMAIN
194600               FLENGTH (LENGTH  OF LS-STATS-TABLE)
194700               SET     (ADDRESS OF LS-STATS-TABLE)
194800               INITIMG (SS08WS-SPACE)
194900          END-EXEC.
195000*
195100 8199-TSG-EXIT.
195200     EXIT.
195300*
195400 8200-TEMP-STORAGE-READ.
195500*
195600     EXEC CICS READQ TS
195700               QUEUE   (TS-QUEUE-NAME)
195800               SET     (ADDRESS OF LS-STATS-TABLE)
195900               LENGTH  (LENGTH  OF LS-STATS-TABLE)
196000               ITEM    (1)
196100          END-EXEC.
196200*
196300 8299-TSR-EXIT.
196400     EXIT.
196500*
196600 8300-TEMP-STORAGE-DELETE.
196700*
196800     EXEC CICS IGNORE CONDITION
196900               QIDERR
197000          END-EXEC.
197100*
197200     EXEC CICS DELETEQ TS
197300               QUEUE  (TS-QUEUE-NAME)
197400          END-EXEC.
197500*
197600 8399-TSD-EXIT.
197700     EXIT.
197800*
197900 8400-WRITE-QUEUE.
198000*
198100     MOVE LENGTH OF LS-STATS-ENTRY (1)
198200                                 TO SS08WS-LENGTH.
198300     COMPUTE SS08WS-LENGTH = (SS08WS-LENGTH
198400                                 * LS-STATS-ENTRY-COUNT) + 2.
198500
198600*
198700     EXEC CICS WRITEQ TS
198800               QUEUE   (TS-QUEUE-NAME)
198900               FROM    (LS-STATS-TABLE)
199000               LENGTH  (SS08WS-LENGTH)
199100          END-EXEC.
199200*
199300 8499-WQ-EXIT.
199400     EXIT.
199500/
199600*
199700 8500-LOAD-TS-STATS.
199800*
199900****************************************************************
200000*    ACQUIRE MAIN STORAGE FOR TEMP STORAGE RECORD              *
200100****************************************************************
200200*
200300     MOVE 'TS08'                 TO MBCA-PROGRAM-LOCATION
200400     PERFORM 8100-TEMP-STORAGE-GETMAIN
200500                                 THRU 8199-TSG-EXIT
200600*
200700****************************************************************
200800*    PERFORM APPROPRIATE LOAD ROUTINE BASED ON KEY SELECTIONS  *
200900****************************************************************
201000*
201100     EVALUATE TRUE
201200       WHEN MBCA-MBSM-EXPENSE-SPACE
201300         EVALUATE TRUE ALSO TRUE
201400           WHEN MBCA-MBSM-VALID-CHAIN
201500           ALSO MBCA-MBSM-VALID-TOTALS
201600             PERFORM 8555-LOAD-CHAIN
201700                                 THRU 8570-LC-EXIT
201800             PERFORM 8900-LOAD-FEE-ACTIVITY-GROUP
201900                                 THRU 8909-LFAG-EXIT
202000           WHEN MBCA-MBSM-VALID-CHAIN
202100           ALSO MBCA-MBSM-VALID-PRODUCT
202200             PERFORM 8555-LOAD-CHAIN
202300                                 THRU 8570-LC-EXIT
202400           WHEN MBCA-MBSM-VALID-CHAIN
202500           ALSO MBCA-MBSM-VALID-CRED-PLAN
202600             PERFORM 8575-LOAD-CHAIN-CRED-PLAN
202700                                 THRU 8590-LCCP-EXIT
202800           WHEN MBCA-MBSM-VALID-CHAIN
202900           ALSO MBCA-MBSM-VALID-QUAL-LVL
203000             PERFORM 8665-LOAD-CHAIN-QUAL-LVL
203100                                 THRU 8680-LCQL-EXIT
203200           WHEN MBCA-MBSM-VALID-MERCHANT
203300           ALSO MBCA-MBSM-VALID-TOTALS
203400             PERFORM 8515-LOAD-MERCHANT
203500                                 THRU 8530-LM-EXIT
203600             PERFORM 8910-LOAD-FEE-ACTIVITY
203700                                 THRU 8919-LFA-EXIT
203800           WHEN MBCA-MBSM-VALID-MERCHANT
203900           ALSO MBCA-MBSM-VALID-PRODUCT
204000             PERFORM 8515-LOAD-MERCHANT
204100                                 THRU 8530-LM-EXIT
204200           WHEN MBCA-MBSM-VALID-MERCHANT
204300           ALSO MBCA-MBSM-VALID-CRED-PLAN
204400             PERFORM 8625-LOAD-MERCH-CRED-PLAN
204500                                 THRU 8640-LMCP-EXIT
204600           WHEN MBCA-MBSM-VALID-MERCHANT
204700           ALSO MBCA-MBSM-VALID-QUAL-LVL
204800             PERFORM 8645-LOAD-MERCH-QUAL-LVL
204900                                 THRU 8660-LMQL-EXIT
205000         END-EVALUATE
205100       WHEN MBCA-MBSM-EXPENSE-VALID
205200         EVALUATE TRUE ALSO TRUE
205300           WHEN MBCA-MBSM-VALID-CHAIN
205400           ALSO MBCA-MBSM-VALID-TOTALS
205500             PERFORM 8700-LOAD-CHAIN-EXP
205600                                 THRU 8709-LCE-EXIT
205700           WHEN MBCA-MBSM-VALID-CHAIN
205800           ALSO MBCA-MBSM-VALID-PRODUCT
205900             PERFORM 8700-LOAD-CHAIN-EXP
206000                                 THRU 8709-LCE-EXIT
206100           WHEN MBCA-MBSM-VALID-CHAIN
206200           ALSO MBCA-MBSM-VALID-QUAL-LVL
206300             PERFORM 8710-LOAD-CHAIN-QUAL-LVL-EXP
206400                                 THRU 8719-LCQLE-EXIT
206500           WHEN MBCA-MBSM-VALID-MERCHANT
206600           ALSO MBCA-MBSM-VALID-TOTALS
206700             PERFORM 8720-LOAD-MERCHANT-EXP
206800                                 THRU 8729-LME-EXIT
206900           WHEN MBCA-MBSM-VALID-MERCHANT
207000           ALSO MBCA-MBSM-VALID-PRODUCT
207100             PERFORM 8720-LOAD-MERCHANT-EXP
207200                                 THRU 8729-LME-EXIT
207300           WHEN MBCA-MBSM-VALID-MERCHANT
207400           ALSO MBCA-MBSM-VALID-QUAL-LVL
207500             PERFORM 8730-LOAD-MERCH-QUAL-LVL-EXP
207600                                 THRU 8739-LMQLE-EXIT
207700         END-EVALUATE
207800     END-EVALUATE.
207900*
208000     EVALUATE TRUE ALSO TRUE
208100         WHEN MBCA-MBSM-VALID-STORE
208200         ALSO MBCA-MBSM-VALID-TOTALS
208300             PERFORM 8535-LOAD-STORE
208400                                 THRU 8550-LS-EXIT
208500         WHEN MBCA-MBSM-VALID-STORE
208600         ALSO MBCA-MBSM-VALID-PRODUCT
208700             PERFORM 8535-LOAD-STORE
208800                                 THRU 8550-LS-EXIT
208900         WHEN MBCA-MBSM-VALID-STORE
209000         ALSO MBCA-MBSM-VALID-CRED-PLAN
209100             PERFORM 8605-LOAD-STORE-CRED-PLAN
209200                                 THRU 8620-LSCP-EXIT
209300         WHEN MBCA-MBSM-VALID-S-CHAIN
209400         ALSO MBCA-MBSM-VALID-TOTALS
209500             PERFORM 8800-LOAD-S-CHAIN
209600                                 THRU 8809-LSC-EXIT
209700         WHEN MBCA-MBSM-VALID-S-CHAIN
209800         ALSO MBCA-MBSM-VALID-PRODUCT
209900             PERFORM 8800-LOAD-S-CHAIN
210000                                 THRU 8809-LSC-EXIT
210100         WHEN MBCA-MBSM-VALID-S-CHAIN
210200         ALSO MBCA-MBSM-VALID-CRED-PLAN
210300             PERFORM 8810-LOAD-S-CHAIN-CRED-PLAN
210400                                 THRU 8819-LSCCP-EXIT
210500     END-EVALUATE.
210600*
210700****************************************************************
210800*    GET THE PROPER PAGE AND LINE NUMBER FOR EACH LOGIC MODULE *
210900****************************************************************
211000*
211100     PERFORM VARYING X-LS-STATS-1 FROM +1 BY +1
211200         UNTIL X-LS-STATS-1 IS GREATER THAN LS-STATS-ENTRY-COUNT
211300*
211400*  1. LOOK FOR A SPECIFIC MATCH BY KEY TYPE / LOGIC MODULE
211500*
211600         MOVE LS-STATS-LOGIC-MODULE (X-LS-STATS-1)
211700                                 TO WS-SEARCH-LM-PL-LOGIC-MODULE
211800         PERFORM 9400-SEARCH-LM-PL-TABLE
211900                                 THRU 9410-SLPT-EXIT
212000         EVALUATE TRUE
212100             WHEN WS-SEARCH-NOT-FOUND
212200               EVALUATE TRUE
212300                 WHEN LS-STATS-LOGIC-MODULE (X-LS-STATS-1)
212400                      IS EQUAL TO 999
212500                   CONTINUE
212600                 WHEN OTHER
212700                   MOVE ZEROES   TO LS-STATS-PAGE-NBR
212800                                    (X-LS-STATS-1)
212900                                    LS-STATS-LINE-NBR
213000                                    (X-LS-STATS-1)
213100               END-EVALUATE
213200*
213300*  4. WHAT WE ARE POINTING AT NOW IS WHAT WE USE
213400*     NOTE: IF THIS IS A QUAL LVL, ONLY MOVE LINE NBR, AS
213500*           PAGE NBR IS DETERMINED FROM QUAL LVL
213600*           (I.E. TWO QUAL LEVELS PER PAGE)
213700*
213800             WHEN OTHER
213900                 IF  MBCA-MBSM-VALID-QUAL-LVL
214000                     MOVE WS-LM-PL-LINE-NBR (X-WS-LM-PAGE-LINE)
214100                                 TO LS-STATS-LINE-NBR
214200                                    (X-LS-STATS-1)
214300                 ELSE
214400                     MOVE WS-LM-PL-SCREEN-SORT (X-WS-LM-PAGE-LINE)
214500                                 TO LS-STATS-SCREEN-SORT
214600                                    (X-LS-STATS-1)
214700                 END-IF
214800         END-EVALUATE
214900     END-PERFORM.
215000*
215100****************************************************************
215200*    DO A BUBBLE SORT TO PUT THIS LINKAGE TABLE INTO ORDER     *
215300****************************************************************
215400*
215500     PERFORM 9500-SORT-STATS-TABLE
215600                                 THRU 9510-SST-EXIT.
215700*
215800****************************************************************
215900*    WRITE TEMP STORAGE RECORD CONTAINING THE LOADED STAT INFO *
216000****************************************************************
216100*
216200     MOVE 'TS09'                 TO MBCA-PROGRAM-LOCATION .
216300     PERFORM 8400-WRITE-QUEUE    THRU 8499-WQ-EXIT.
216400*
216500 8510-LTS-EXIT.
216600     EXIT.
216700/
216800 8515-LOAD-MERCHANT.
216900*
217000****************************************************************
217100*    START BROWSE THE MERCHANT/PRODUCT STATISTICS FILE.        *
217200****************************************************************
217300*
217400     MOVE 'FC01'                 TO MBCA-PROGRAM-LOCATION.
217500     MOVE MBCA-MBSM-ORG          TO MBIOWS-MMPA-ORG.
217600     MOVE MBCA-MBSM-CHAIN-MERCH  TO MBIOWS-MMPA-ACCT.
217700     MOVE ZERO                   TO MBIOWS-MMPA-MINOR-KEY.
217800*
217900     IF  MBCA-MBSM-VALID-PRODUCT
218000         SET MBIOWS-MMPA-DETAIL  TO TRUE
218100         MOVE MBCA-MBSM-CARD-PROD
218200                                 TO MBIOWS-MMPA-PRODUCT
218300     ELSE
218400         SET MBIOWS-MMPA-TOTALS  TO TRUE
218500         MOVE ZERO               TO MBIOWS-MMPA-PRODUCT
218600     END-IF.
218700*
218800     MOVE ZEROES                 TO MBIOWS-MMPA-LOGIC-MODULE.
218900     SET MBIORO-STARTBR-GTE      TO TRUE.
219000     PERFORM MMPAAO-ACCESS       THRU MMPAAO-ACCESS-EXIT.
219100*
219200     SET X-LS-STATS-1            TO +1.
219300*
219400 8520-READ-LOOP.
219500*
219600****************************************************************
219700*    READNEXT THE MERCHANT/PRODUCT STATISTICS FILE.            *
219800****************************************************************
219900*
220000     MOVE 'FC02'                 TO MBCA-PROGRAM-LOCATION.
220100     SET MBIORO-READ-SEQ         TO TRUE.
220200     PERFORM MMPAAO-ACCESS       THRU MMPAAO-ACCESS-EXIT.
220300*
220400     IF  MMPA-ORG IS NOT EQUAL TO MBCA-MBSM-ORG
220500     OR  MMPA-ACCT     IS NOT EQUAL TO MBCA-MBSM-CHAIN-MERCH
220600         GO TO 8525-END-BROWSE
220700     END-IF.
220800*
220900     IF  MBCA-MBSM-VALID-PRODUCT
221000         IF  MMPA-PRODUCT IS NOT EQUAL TO MBCA-MBSM-CARD-PROD
221100             GO TO 8525-END-BROWSE
221200         END-IF
221300     ELSE
221400         IF  MMPA-PRODUCT IS NOT EQUAL TO ZERO
221500             GO TO 8525-END-BROWSE
221600         END-IF
221700     END-IF.
221800*
221900     MOVE MMPA-LOGIC-MODULE      TO WS-SEARCH-LM-PL-LOGIC-MODULE.
222000     PERFORM 9400-SEARCH-LM-PL-TABLE
222100                                 THRU 9410-SLPT-EXIT.
222200*
222300     IF  WS-SEARCH-NOT-FOUND
222400         GO TO 8520-READ-LOOP.
222500*
222600     MOVE ZERO                   TO LS-STATS-PAGE-NBR
222700                                    (X-LS-STATS-1).
222800*
222900     MOVE MMPA-LOGIC-MODULE      TO LS-STATS-LOGIC-MODULE
223000                                    (X-LS-STATS-1).
223100*
223200     IF  MBCA-MBSM-INDEX-1 IS NOT EQUAL TO ZERO
223300         SET X-MMPA              TO MBCA-MBSM-INDEX-1
223400         MOVE MMPA-NBR (X-MMPA)  TO LS-STATS-NBR-COL1
223500                                    (X-LS-STATS-1)
223600         MOVE MMPA-AMT (X-MMPA)  TO LS-STATS-AMT-COL1
223700                                    (X-LS-STATS-1)
223800     END-IF.
223900*
224000     IF  MBCA-MBSM-INDEX-2 IS NOT EQUAL TO ZERO
224100         SET X-MMPA              TO MBCA-MBSM-INDEX-2
224200         MOVE MMPA-NBR (X-MMPA)  TO LS-STATS-NBR-COL2
224300                                    (X-LS-STATS-1)
224400         MOVE MMPA-AMT (X-MMPA)  TO LS-STATS-AMT-COL2
224500                                    (X-LS-STATS-1)
224600     END-IF.
224700*
224800     SET X-LS-STATS-1            UP BY +1.
224900     GO TO 8520-READ-LOOP.
225000*
225100 8525-END-BROWSE.
225200*
225300****************************************************************
225400*    END BROWSE THE MERCHANT/PRODUCT STATS FILE.               *
225500****************************************************************
225600*
225700     MOVE 'FC03'                 TO MBCA-PROGRAM-LOCATION.
225800     SET MBIORO-ENDBR            TO TRUE.
225900     PERFORM MMPAAO-ACCESS       THRU MMPAAO-ACCESS-EXIT.
226000*
226100     IF  MBCA-MBSM-VALID-MERCHANT
226200     AND MBCA-MBSM-VALID-TOTALS
226300         SET LS-STATS-ENTRY-COUNT
226400                                 TO X-LS-STATS-1
226500     ELSE
226600         SET LS-STATS-ENTRY-COUNT
226700                                 TO X-LS-STATS-1
226800         SUBTRACT +1             FROM LS-STATS-ENTRY-COUNT.
226900*
227000 8530-LM-EXIT.
227100     EXIT.
227200/
227300 8535-LOAD-STORE.
227400*
227500****************************************************************
227600*    START BROWSE THE STORE/PRODUCT STATISTICS FILE.           *
227700****************************************************************
227800*
227900     MOVE 'FC04'                 TO MBCA-PROGRAM-LOCATION.
228000     MOVE MBCA-MBSM-ORG          TO MBIOWS-MMPS-ORG.
228100     MOVE MBCA-MBSM-CHAIN-MERCH  TO MBIOWS-MMPS-ACCT.
228200     MOVE ZERO                   TO MBIOWS-MMPS-MINOR-KEY.
228300*
228400     IF  MBCA-MBSM-VALID-PRODUCT
228500         SET MBIOWS-MMPS-DETAIL  TO TRUE
228600         MOVE MBCA-MBSM-CARD-PROD
228700                                 TO MBIOWS-MMPS-PRODUCT
228800     ELSE
228900         SET MBIOWS-MMPS-TOTALS  TO TRUE
229000         MOVE ZERO               TO MBIOWS-MMPS-PRODUCT
229100     END-IF.
229200*
229300     MOVE ZEROES                 TO MBIOWS-MMPS-LOGIC-MODULE.
229400     SET MBIORO-STARTBR-GTE      TO TRUE.
229500     PERFORM MMPSAO-ACCESS       THRU MMPSAO-ACCESS-EXIT.
229600*
229700     SET X-LS-STATS-1            TO +1.
229800*
229900 8540-READ-LOOP.
230000*
230100****************************************************************
230200*    READNEXT THE STORE/PRODUCT STATISTICS FILE.               *
230300****************************************************************
230400*
230500     MOVE 'FC05'                 TO MBCA-PROGRAM-LOCATION.
230600     SET MBIORO-READ-SEQ         TO TRUE.
230700     PERFORM MMPSAO-ACCESS       THRU MMPSAO-ACCESS-EXIT.
230800*
230900     IF  MMPS-ORG   IS NOT EQUAL TO MBCA-MBSM-ORG
231000     OR  MMPS-ACCT  IS NOT EQUAL TO MBCA-MBSM-CHAIN-MERCH
231100         GO TO 8545-END-BROWSE
231200     END-IF.
231300*
231400     IF  MBCA-MBSM-VALID-PRODUCT
231500         IF  MMPS-PRODUCT IS NOT EQUAL TO MBCA-MBSM-CARD-PROD
231600             GO TO 8545-END-BROWSE
231700         END-IF
231800     ELSE
231900         IF  MMPS-PRODUCT IS NOT EQUAL TO ZERO
232000             GO TO 8545-END-BROWSE
232100         END-IF
232200     END-IF.
232300*
232400     MOVE MMPS-LOGIC-MODULE      TO WS-SEARCH-LM-PL-LOGIC-MODULE.
232500     PERFORM 9400-SEARCH-LM-PL-TABLE
232600                                 THRU 9410-SLPT-EXIT.
232700*
232800     IF  WS-SEARCH-NOT-FOUND
232900         GO TO 8540-READ-LOOP.
233000*
233100     MOVE ZERO                   TO LS-STATS-PAGE-NBR
233200                                    (X-LS-STATS-1).
233300*
233400     MOVE MMPS-LOGIC-MODULE      TO LS-STATS-LOGIC-MODULE
233500                                    (X-LS-STATS-1).
233600*
233700     IF  MBCA-MBSM-INDEX-1 IS NOT EQUAL TO ZERO
233800         SET X-MMPS              TO MBCA-MBSM-INDEX-1
233900         MOVE MMPS-NBR (X-MMPS)  TO LS-STATS-NBR-COL1
234000                                    (X-LS-STATS-1)
234100         MOVE MMPS-AMT (X-MMPS)  TO LS-STATS-AMT-COL1
234200                                    (X-LS-STATS-1)
234300     END-IF.
234400*
234500     IF  MBCA-MBSM-INDEX-2 IS NOT EQUAL TO ZERO
234600         SET X-MMPS              TO MBCA-MBSM-INDEX-2
234700         MOVE MMPS-NBR (X-MMPS)  TO LS-STATS-NBR-COL2
234800                                    (X-LS-STATS-1)
234900         MOVE MMPS-AMT (X-MMPS)  TO LS-STATS-AMT-COL2
235000                                    (X-LS-STATS-1)
235100     END-IF.
235200*
235300     SET X-LS-STATS-1            UP BY +1.
235400     GO TO 8540-READ-LOOP.
235500*
235600 8545-END-BROWSE.
235700*
235800****************************************************************
235900*    END BROWSE THE STORE/PRODUCT STATS FILE.                  *
236000****************************************************************
236100*
236200     MOVE 'FC06'                 TO MBCA-PROGRAM-LOCATION.
236300     SET MBIORO-ENDBR            TO TRUE.
236400     PERFORM MMPSAO-ACCESS       THRU MMPSAO-ACCESS-EXIT.
236500*
236600     SET LS-STATS-ENTRY-COUNT    TO X-LS-STATS-1.
236700     SUBTRACT +1                 FROM LS-STATS-ENTRY-COUNT.
236800*
236900 8550-LS-EXIT.
237000     EXIT.
237100/
237200 8555-LOAD-CHAIN.
237300*
237400****************************************************************
237500*    START BROWSE THE CHAIN/PRODUCT STATISTICS FILE.           *
237600****************************************************************
237700*
237800     MOVE 'FC07'                 TO MBCA-PROGRAM-LOCATION.
237900     MOVE MBCA-MBSM-ORG          TO MBIOWS-MMPG-ORG.
238000     MOVE MBCA-MBSM-CHAIN-MERCH  TO MBIOWS-MMPG-ACCT.
238100     MOVE ZERO                   TO MBIOWS-MMPG-MINOR-KEY.
238200*
238300     IF  MBCA-MBSM-VALID-PRODUCT
238400         SET MBIOWS-MMPG-DETAIL  TO TRUE
238500         MOVE MBCA-MBSM-CARD-PROD
238600                                 TO MBIOWS-MMPG-PRODUCT
238700     ELSE
238800         SET MBIOWS-MMPG-TOTALS  TO TRUE
238900         MOVE ZERO               TO MBIOWS-MMPG-PRODUCT
239000     END-IF.
239100*
239200     MOVE ZEROES                 TO MBIOWS-MMPG-LOGIC-MODULE.
239300     SET MBIORO-STARTBR-GTE      TO TRUE.
239400     PERFORM MMPGAO-ACCESS       THRU MMPGAO-ACCESS-EXIT.
239500*
239600     SET X-LS-STATS-1            TO +1.
239700*
239800 8560-READ-LOOP.
239900*
240000****************************************************************
240100*    READNEXT THE CHAIN/PRODUCT STATISTICS FILE.               *
240200****************************************************************
240300*
240400     MOVE 'FC08'                 TO MBCA-PROGRAM-LOCATION.
240500     SET MBIORO-READ-SEQ         TO TRUE.
240600     PERFORM MMPGAO-ACCESS       THRU MMPGAO-ACCESS-EXIT.
240700*
240800     IF  MMPG-ORG   IS NOT EQUAL TO MBCA-MBSM-ORG
240900     OR  MMPG-ACCT  IS NOT EQUAL TO MBCA-MBSM-CHAIN-MERCH
241000         GO TO 8565-END-BROWSE
241100     END-IF.
241200*
241300     IF  MBCA-MBSM-VALID-PRODUCT
241400         IF  MMPG-PRODUCT IS NOT EQUAL TO MBCA-MBSM-CARD-PROD
241500             GO TO 8565-END-BROWSE
241600         END-IF
241700     ELSE
241800         IF  MMPG-PRODUCT IS NOT EQUAL TO ZERO
241900             GO TO 8565-END-BROWSE
242000         END-IF
242100     END-IF.
242200*
242300     MOVE MMPG-LOGIC-MODULE      TO WS-SEARCH-LM-PL-LOGIC-MODULE.
242400     PERFORM 9400-SEARCH-LM-PL-TABLE
242500                                 THRU 9410-SLPT-EXIT.
242600*
242700     IF  WS-SEARCH-NOT-FOUND
242800         GO TO 8560-READ-LOOP.
242900*
243000     MOVE ZERO                   TO LS-STATS-PAGE-NBR
243100                                    (X-LS-STATS-1).
243200*
243300     MOVE MMPG-LOGIC-MODULE      TO LS-STATS-LOGIC-MODULE
243400                                    (X-LS-STATS-1).
243500*
243600     IF  MBCA-MBSM-INDEX-1 IS NOT EQUAL TO ZERO
243700         SET X-MMPG              TO MBCA-MBSM-INDEX-1
243800         MOVE MMPG-NBR (X-MMPG)  TO LS-STATS-NBR-COL1
243900                                    (X-LS-STATS-1)
244000         MOVE MMPG-AMT (X-MMPG)  TO LS-STATS-AMT-COL1
244100                                    (X-LS-STATS-1)
244200     END-IF.
244300*
244400     IF  MBCA-MBSM-INDEX-2 IS NOT EQUAL TO ZERO
244500         SET X-MMPG              TO MBCA-MBSM-INDEX-2
244600         MOVE MMPG-NBR (X-MMPG)  TO LS-STATS-NBR-COL2
244700                                    (X-LS-STATS-1)
244800         MOVE MMPG-AMT (X-MMPG)  TO LS-STATS-AMT-COL2
244900                                    (X-LS-STATS-1)
245000     END-IF.
245100*
245200     SET X-LS-STATS-1            UP BY +1.
245300     GO TO 8560-READ-LOOP.
245400*
245500 8565-END-BROWSE.
245600*
245700****************************************************************
245800*    END BROWSE THE CHAIN/PRODUCT STATS FILE.                  *
245900****************************************************************
246000*
246100     MOVE 'FC09'                 TO MBCA-PROGRAM-LOCATION.
246200     SET MBIORO-ENDBR            TO TRUE.
246300     PERFORM MMPGAO-ACCESS       THRU MMPGAO-ACCESS-EXIT.
246400*
246500     IF  MBCA-MBSM-VALID-CHAIN
246600     AND MBCA-MBSM-VALID-TOTALS
246700         SET LS-STATS-ENTRY-COUNT
246800                                 TO X-LS-STATS-1
246900     ELSE
247000         SET LS-STATS-ENTRY-COUNT
247100                                 TO X-LS-STATS-1
247200         SUBTRACT +1             FROM LS-STATS-ENTRY-COUNT.
247300*
247400 8570-LC-EXIT.
247500     EXIT.
247600/
247700 8575-LOAD-CHAIN-CRED-PLAN.
247800*
247900****************************************************************
248000*    START BROWSE THE CHAIN/CRED PLAN STATISTICS FILE.         *
248100****************************************************************
248200*
248300     MOVE 'FC10'                 TO MBCA-PROGRAM-LOCATION.
248400     MOVE MBCA-MBSM-ORG          TO MBIOWS-MMCG-ORG.
248500     MOVE MBCA-MBSM-CHAIN-MERCH  TO MBIOWS-MMCG-ACCT.
248600     MOVE ZERO                   TO MBIOWS-MMCG-MINOR-KEY.
248700     SET MBIOWS-MMCG-DETAIL      TO TRUE.
248800     MOVE MBCA-MBSM-CARD-PROD    TO MBIOWS-MMCG-PRODUCT.
248900     MOVE MBCA-MBSM-PLAN         TO MBIOWS-MMCG-PLAN.
249000     MOVE ZEROES                 TO MBIOWS-MMCG-LOGIC-MODULE.
249100     SET MBIORO-STARTBR-GTE      TO TRUE.
249200     PERFORM MMCGAO-ACCESS       THRU MMCGAO-ACCESS-EXIT.
249300*
249400     SET X-LS-STATS-1            TO +1.
249500*
249600 8580-READ-LOOP.
249700*
249800****************************************************************
249900*    READNEXT THE CHAIN/CRED PLAN STATISTICS FILE.             *
250000****************************************************************
250100*
250200     MOVE 'FC11'                 TO MBCA-PROGRAM-LOCATION.
250300     SET MBIORO-READ-SEQ         TO TRUE.
250400     PERFORM MMCGAO-ACCESS       THRU MMCGAO-ACCESS-EXIT.
250500*
250600     IF  MMCG-ORG      IS NOT EQUAL TO MBCA-MBSM-ORG
250700     OR  MMCG-ACCT     IS NOT EQUAL TO MBCA-MBSM-CHAIN-MERCH
250800     OR  MMCG-PRODUCT  IS NOT EQUAL TO MBCA-MBSM-CARD-PROD
250900     OR  MMCG-PLAN     IS NOT EQUAL TO MBCA-MBSM-PLAN
251000         GO TO 8585-END-BROWSE
251100     END-IF.
251200*
251300     MOVE MMCG-LOGIC-MODULE      TO WS-SEARCH-LM-PL-LOGIC-MODULE.
251400     PERFORM 9400-SEARCH-LM-PL-TABLE
251500                                 THRU 9410-SLPT-EXIT.
251600*
251700     IF  WS-SEARCH-NOT-FOUND
251800         GO TO 8580-READ-LOOP.
251900*
252000     MOVE ZERO                   TO LS-STATS-PAGE-NBR
252100                                    (X-LS-STATS-1).
252200*
252300     MOVE MMCG-LOGIC-MODULE      TO LS-STATS-LOGIC-MODULE
252400                                    (X-LS-STATS-1).
252500*
252600     IF  MBCA-MBSM-INDEX-1 IS NOT EQUAL TO ZERO
252700         SET X-MMCG              TO MBCA-MBSM-INDEX-1
252800         MOVE MMCG-NBR (X-MMCG)  TO LS-STATS-NBR-COL1
252900                                    (X-LS-STATS-1)
253000         MOVE MMCG-AMT (X-MMCG)  TO LS-STATS-AMT-COL1
253100                                    (X-LS-STATS-1)
253200     END-IF.
253300*
253400     IF  MBCA-MBSM-INDEX-2 IS NOT EQUAL TO ZERO
253500         SET X-MMCG              TO MBCA-MBSM-INDEX-2
253600         MOVE MMCG-NBR (X-MMCG)  TO LS-STATS-NBR-COL2
253700                                    (X-LS-STATS-1)
253800         MOVE MMCG-AMT (X-MMCG)  TO LS-STATS-AMT-COL2
253900                                    (X-LS-STATS-1)
254000     END-IF.
254100*
254200     SET X-LS-STATS-1            UP BY +1.
254300     GO TO 8580-READ-LOOP.
254400*
254500 8585-END-BROWSE.
254600*
254700****************************************************************
254800*    END BROWSE THE CHAIN/PRODUCT STATS FILE.                  *
254900****************************************************************
255000*
255100     MOVE 'FC12'                 TO MBCA-PROGRAM-LOCATION.
255200     SET MBIORO-ENDBR            TO TRUE.
255300     PERFORM MMCGAO-ACCESS       THRU MMCGAO-ACCESS-EXIT.
255400*
255500     SET LS-STATS-ENTRY-COUNT    TO X-LS-STATS-1.
255600     SUBTRACT +1                 FROM LS-STATS-ENTRY-COUNT.
255700*
255800 8590-LCCP-EXIT.
255900     EXIT.
256000/
256100 8605-LOAD-STORE-CRED-PLAN.
256200*
256300****************************************************************
256400*    START BROWSE THE STORE/CRED PLAN STATISTICS FILE.         *
256500****************************************************************
256600*
256700     MOVE 'FC13'                 TO MBCA-PROGRAM-LOCATION.
256800     MOVE MBCA-MBSM-ORG          TO MBIOWS-MMCS-ORG.
256900     MOVE MBCA-MBSM-CHAIN-MERCH  TO MBIOWS-MMCS-ACCT.
257000     MOVE ZERO                   TO MBIOWS-MMCS-MINOR-KEY.
257100     SET MBIOWS-MMCS-DETAIL      TO TRUE.
257200     MOVE MBCA-MBSM-CARD-PROD    TO MBIOWS-MMCS-PRODUCT.
257300     MOVE MBCA-MBSM-PLAN         TO MBIOWS-MMCS-PLAN.
257400     MOVE ZEROES                 TO MBIOWS-MMCS-LOGIC-MODULE.
257500     SET MBIORO-STARTBR-GTE      TO TRUE.
257600     PERFORM MMCSAO-ACCESS       THRU MMCSAO-ACCESS-EXIT.
257700*
257800     SET X-LS-STATS-1            TO +1.
257900*
258000 8610-READ-LOOP.
258100*
258200****************************************************************
258300*    READNEXT THE STORE/CRED PLAN STATISTICS FILE.             *
258400****************************************************************
258500*
258600     MOVE 'FC14'                 TO MBCA-PROGRAM-LOCATION.
258700     SET MBIORO-READ-SEQ         TO TRUE.
258800     PERFORM MMCSAO-ACCESS       THRU MMCSAO-ACCESS-EXIT.
258900*
259000     IF  MMCS-ORG      IS NOT EQUAL TO MBCA-MBSM-ORG
259100     OR  MMCS-ACCT     IS NOT EQUAL TO MBCA-MBSM-CHAIN-MERCH
259200     OR  MMCS-PRODUCT  IS NOT EQUAL TO MBCA-MBSM-CARD-PROD
259300     OR  MMCS-PLAN     IS NOT EQUAL TO MBCA-MBSM-PLAN
259400         GO TO 8615-END-BROWSE
259500     END-IF.
259600*
259700     MOVE MMCS-LOGIC-MODULE      TO WS-SEARCH-LM-PL-LOGIC-MODULE.
259800     PERFORM 9400-SEARCH-LM-PL-TABLE
259900                                 THRU 9410-SLPT-EXIT.
260000*
260100     IF  WS-SEARCH-NOT-FOUND
260200         GO TO 8610-READ-LOOP.
260300*
260400     MOVE ZERO                   TO LS-STATS-PAGE-NBR
260500                                    (X-LS-STATS-1).
260600*
260700     MOVE MMCS-LOGIC-MODULE      TO LS-STATS-LOGIC-MODULE
260800                                    (X-LS-STATS-1).
260900*
261000     IF  MBCA-MBSM-INDEX-1 IS NOT EQUAL TO ZERO
261100         SET X-MMCS              TO MBCA-MBSM-INDEX-1
261200         MOVE MMCS-NBR (X-MMCS)  TO LS-STATS-NBR-COL1
261300                                    (X-LS-STATS-1)
261400         MOVE MMCS-AMT (X-MMCS)  TO LS-STATS-AMT-COL1
261500                                    (X-LS-STATS-1)
261600     END-IF.
261700*
261800     IF  MBCA-MBSM-INDEX-2 IS NOT EQUAL TO ZERO
261900         SET X-MMCS              TO MBCA-MBSM-INDEX-2
262000         MOVE MMCS-NBR (X-MMCS)  TO LS-STATS-NBR-COL2
262100                                    (X-LS-STATS-1)
262200         MOVE MMCS-AMT (X-MMCS)  TO LS-STATS-AMT-COL2
262300                                    (X-LS-STATS-1)
262400     END-IF.
262500*
262600     SET X-LS-STATS-1            UP BY +1.
262700     GO TO 8610-READ-LOOP.
262800*
262900 8615-END-BROWSE.
263000*
263100****************************************************************
263200*    END BROWSE THE STORE/PRODUCT STATS FILE.                  *
263300****************************************************************
263400*
263500     MOVE 'FC15'                 TO MBCA-PROGRAM-LOCATION.
263600     SET MBIORO-ENDBR            TO TRUE.
263700     PERFORM MMCSAO-ACCESS       THRU MMCSAO-ACCESS-EXIT.
263800*
263900     SET LS-STATS-ENTRY-COUNT    TO X-LS-STATS-1.
264000     SUBTRACT +1                 FROM LS-STATS-ENTRY-COUNT.
264100*
264200 8620-LSCP-EXIT.
264300     EXIT.
264400/
264500 8625-LOAD-MERCH-CRED-PLAN.
264600*
264700****************************************************************
264800*    START BROWSE THE MERCH/CRED PLAN STATISTICS FILE.         *
264900****************************************************************
265000*
265100     MOVE 'FC16'                 TO MBCA-PROGRAM-LOCATION.
265200     MOVE MBCA-MBSM-ORG          TO MBIOWS-MMCP-ORG.
265300     MOVE MBCA-MBSM-CHAIN-MERCH  TO MBIOWS-MMCP-ACCT.
265400     MOVE ZERO                   TO MBIOWS-MMCP-MINOR-KEY.
265500     SET MBIOWS-MMCP-DETAIL      TO TRUE.
265600     MOVE MBCA-MBSM-CARD-PROD    TO MBIOWS-MMCP-PRODUCT.
265700     MOVE MBCA-MBSM-PLAN         TO MBIOWS-MMCP-PLAN.
265800     MOVE ZEROES                 TO MBIOWS-MMCP-LOGIC-MODULE.
265900     SET MBIORO-STARTBR-GTE      TO TRUE.
266000     PERFORM MMCPAO-ACCESS       THRU MMCPAO-ACCESS-EXIT.
266100*
266200     SET X-LS-STATS-1            TO +1.
266300*
266400 8630-READ-LOOP.
266500*
266600****************************************************************
266700*    READNEXT THE MERCH/CRED PLAN STATISTICS FILE.             *
266800****************************************************************
266900*
267000     MOVE 'FC17'                 TO MBCA-PROGRAM-LOCATION.
267100     SET MBIORO-READ-SEQ         TO TRUE.
267200     PERFORM MMCPAO-ACCESS       THRU MMCPAO-ACCESS-EXIT.
267300*
267400     IF  MMCP-ORG      IS NOT EQUAL TO MBCA-MBSM-ORG
267500     OR  MMCP-ACCT     IS NOT EQUAL TO MBCA-MBSM-CHAIN-MERCH
267600     OR  MMCP-PRODUCT  IS NOT EQUAL TO MBCA-MBSM-CARD-PROD
267700     OR  MMCP-PLAN     IS NOT EQUAL TO MBCA-MBSM-PLAN
267800         GO TO 8635-END-BROWSE
267900     END-IF.
268000*
268100     MOVE MMCP-LOGIC-MODULE      TO WS-SEARCH-LM-PL-LOGIC-MODULE.
268200     PERFORM 9400-SEARCH-LM-PL-TABLE
268300                                 THRU 9410-SLPT-EXIT.
268400*
268500     IF  WS-SEARCH-NOT-FOUND
268600         GO TO 8630-READ-LOOP.
268700*
268800     MOVE ZERO                   TO LS-STATS-PAGE-NBR
268900                                    (X-LS-STATS-1).
269000*
269100     MOVE MMCP-LOGIC-MODULE      TO LS-STATS-LOGIC-MODULE
269200                                    (X-LS-STATS-1).
269300*
269400     IF  MBCA-MBSM-INDEX-1 IS NOT EQUAL TO ZERO
269500         SET X-MMCP              TO MBCA-MBSM-INDEX-1
269600         MOVE MMCP-NBR (X-MMCP)  TO LS-STATS-NBR-COL1
269700                                    (X-LS-STATS-1)
269800         MOVE MMCP-AMT (X-MMCP)  TO LS-STATS-AMT-COL1
269900                                    (X-LS-STATS-1)
270000     END-IF.
270100*
270200     IF  MBCA-MBSM-INDEX-2 IS NOT EQUAL TO ZERO
270300         SET X-MMCP              TO MBCA-MBSM-INDEX-2
270400         MOVE MMCP-NBR (X-MMCP)  TO LS-STATS-NBR-COL2
270500                                    (X-LS-STATS-1)
270600         MOVE MMCP-AMT (X-MMCP)  TO LS-STATS-AMT-COL2
270700                                    (X-LS-STATS-1)
270800     END-IF.
270900*
271000     SET X-LS-STATS-1            UP BY +1.
271100     GO TO 8630-READ-LOOP.
271200*
271300 8635-END-BROWSE.
271400*
271500****************************************************************
271600*    END BROWSE THE MERCH/PRODUCT STATS FILE.                  *
271700****************************************************************
271800*
271900     MOVE 'FC18'                 TO MBCA-PROGRAM-LOCATION.
272000     SET MBIORO-ENDBR            TO TRUE.
272100     PERFORM MMCPAO-ACCESS       THRU MMCPAO-ACCESS-EXIT.
272200*
272300     SET LS-STATS-ENTRY-COUNT    TO X-LS-STATS-1.
272400     SUBTRACT +1                 FROM LS-STATS-ENTRY-COUNT.
272500*
272600 8640-LMCP-EXIT.
272700     EXIT.
272800/
272900 8645-LOAD-MERCH-QUAL-LVL.
273000*
273100****************************************************************
273200*    START BROWSE THE MERCH/QUAL LVL STATISTICS FILE.          *
273300****************************************************************
273400*
273500     MOVE 'FC19'                 TO MBCA-PROGRAM-LOCATION.
273600     MOVE MBCA-MBSM-ORG          TO MBIOWS-MMOI-ORG.
273700     MOVE MBCA-MBSM-CHAIN-MERCH  TO MBIOWS-MMOI-ACCT.
273800     MOVE ZERO                   TO MBIOWS-MMOI-MINOR-KEY.
273900     SET MBIOWS-MMOI-DETAIL      TO TRUE.
274000     MOVE MBCA-MBSM-CARD-PROD    TO MBIOWS-MMOI-PRODUCT.
274100     MOVE MBCA-MBSM-QUAL-LEVEL   TO MBIOWS-MMOI-QUAL-LEVEL.
274200     MOVE ZEROES                 TO MBIOWS-MMOI-LOGIC-MODULE.
274300     SET MBIORO-STARTBR-GTE      TO TRUE.
274400     PERFORM MMOIAO-ACCESS       THRU MMOIAO-ACCESS-EXIT.
274500*
274600     SET X-LS-STATS-1            TO +1.
274700*
274800 8650-READ-LOOP.
274900*
275000****************************************************************
275100*    READNEXT THE MERCH/QUAL LVL STATISTICS FILE.              *
275200****************************************************************
275300*
275400     MOVE 'FC20'                 TO MBCA-PROGRAM-LOCATION.
275500     SET MBIORO-READ-SEQ         TO TRUE.
275600     PERFORM MMOIAO-ACCESS       THRU MMOIAO-ACCESS-EXIT.
275700*
275800     IF  MMOI-ORG        IS NOT EQUAL TO MBCA-MBSM-ORG
275900     OR  MMOI-ACCT       IS NOT EQUAL TO MBCA-MBSM-CHAIN-MERCH
276000     OR  MMOI-PRODUCT    IS NOT EQUAL TO MBCA-MBSM-CARD-PROD
276100     OR  MMOI-QUAL-LEVEL IS NOT EQUAL TO MBCA-MBSM-QUAL-LEVEL
276200         GO TO 8655-END-BROWSE
276300     END-IF.
276400*
276500     MOVE MMOI-LOGIC-MODULE      TO WS-SEARCH-LM-PL-LOGIC-MODULE.
276600     PERFORM 9400-SEARCH-LM-PL-TABLE
276700                                 THRU 9410-SLPT-EXIT.
276800*
276900     IF  WS-SEARCH-NOT-FOUND
277000         GO TO 8650-READ-LOOP.
277100*
277200     MOVE MMOI-QUAL-LEVEL        TO LS-STATS-PAGE-NBR
277300                                    (X-LS-STATS-1).
277400     MOVE MMOI-LOGIC-MODULE      TO LS-STATS-LOGIC-MODULE
277500                                    (X-LS-STATS-1).
277600*
277700     IF  MBCA-MBSM-INDEX-1 IS NOT EQUAL TO ZERO
277800         SET X-MMOI              TO MBCA-MBSM-INDEX-1
277900         MOVE MMOI-NBR (X-MMOI)  TO LS-STATS-NBR-COL1
278000                                    (X-LS-STATS-1)
278100         MOVE MMOI-AMT (X-MMOI)  TO LS-STATS-AMT-COL1
278200                                    (X-LS-STATS-1)
278300     END-IF.
278400*
278500     IF  MBCA-MBSM-INDEX-2 IS NOT EQUAL TO ZERO
278600         SET X-MMOI              TO MBCA-MBSM-INDEX-2
278700         MOVE MMOI-NBR (X-MMOI)  TO LS-STATS-NBR-COL2
278800                                    (X-LS-STATS-1)
278900         MOVE MMOI-AMT (X-MMOI)  TO LS-STATS-AMT-COL2
279000                                    (X-LS-STATS-1)
279100     END-IF.
279200*
279300     SET X-LS-STATS-1            UP BY +1.
279400     GO TO 8650-READ-LOOP.
279500*
279600 8655-END-BROWSE.
279700*
279800****************************************************************
279900*    END BROWSE THE MERCH/PRODUCT STATS FILE.                  *
280000****************************************************************
280100*
280200     MOVE 'FC21'                 TO MBCA-PROGRAM-LOCATION.
280300     SET MBIORO-ENDBR            TO TRUE.
280400     PERFORM MMOIAO-ACCESS       THRU MMOIAO-ACCESS-EXIT.
280500*
280600     SET LS-STATS-ENTRY-COUNT    TO X-LS-STATS-1.
280700     SUBTRACT +1                 FROM LS-STATS-ENTRY-COUNT.
280800*
280900 8660-LMQL-EXIT.
281000     EXIT.
281100/
281200 8665-LOAD-CHAIN-QUAL-LVL.
281300*
281400****************************************************************
281500*    START BROWSE THE CHAIN/QUAL LVL STATISTICS FILE.          *
281600****************************************************************
281700*
281800     MOVE 'FC22'                 TO MBCA-PROGRAM-LOCATION.
281900     MOVE MBCA-MBSM-ORG          TO MBIOWS-MMOG-ORG.
282000     MOVE MBCA-MBSM-CHAIN-MERCH  TO MBIOWS-MMOG-ACCT.
282100     MOVE ZERO                   TO MBIOWS-MMOG-MINOR-KEY.
282200     SET MBIOWS-MMOG-DETAIL      TO TRUE.
282300     MOVE MBCA-MBSM-CARD-PROD    TO MBIOWS-MMOG-PRODUCT.
282400     MOVE MBCA-MBSM-QUAL-LEVEL   TO MBIOWS-MMOG-QUAL-LEVEL.
282500     MOVE ZEROES                 TO MBIOWS-MMOG-LOGIC-MODULE.
282600     SET MBIORO-STARTBR-GTE      TO TRUE.
282700     PERFORM MMOGAO-ACCESS       THRU MMOGAO-ACCESS-EXIT.
282800*
282900     SET X-LS-STATS-1            TO +1.
283000*
283100 8670-READ-LOOP.
283200*
283300****************************************************************
283400*    READNEXT THE CHAIN/QUAL LVL STATISTICS FILE.              *
283500****************************************************************
283600*
283700     MOVE 'FC23'                 TO MBCA-PROGRAM-LOCATION.
283800     SET MBIORO-READ-SEQ         TO TRUE.
283900     PERFORM MMOGAO-ACCESS       THRU MMOGAO-ACCESS-EXIT.
284000*
284100     IF  MMOG-ORG        IS NOT EQUAL TO MBCA-MBSM-ORG
284200     OR  MMOG-ACCT       IS NOT EQUAL TO MBCA-MBSM-CHAIN-MERCH
284300     OR  MMOG-PRODUCT    IS NOT EQUAL TO MBCA-MBSM-CARD-PROD
284400     OR  MMOG-QUAL-LEVEL IS NOT EQUAL TO MBCA-MBSM-QUAL-LEVEL
284500         GO TO 8675-END-BROWSE
284600     END-IF.
284700*
284800     MOVE MMOG-LOGIC-MODULE      TO WS-SEARCH-LM-PL-LOGIC-MODULE.
284900     PERFORM 9400-SEARCH-LM-PL-TABLE
285000                                 THRU 9410-SLPT-EXIT.
285100*
285200     IF  WS-SEARCH-NOT-FOUND
285300         GO TO 8670-READ-LOOP.
285400*
285500     MOVE MMOG-QUAL-LEVEL        TO LS-STATS-PAGE-NBR
285600                                    (X-LS-STATS-1).
285700     MOVE MMOG-LOGIC-MODULE      TO LS-STATS-LOGIC-MODULE
285800                                    (X-LS-STATS-1).
285900*
286000     IF  MBCA-MBSM-INDEX-1 IS NOT EQUAL TO ZERO
286100         SET X-MMOG              TO MBCA-MBSM-INDEX-1
286200         MOVE MMOG-NBR (X-MMOG)  TO LS-STATS-NBR-COL1
286300                                    (X-LS-STATS-1)
286400         MOVE MMOG-AMT (X-MMOG)  TO LS-STATS-AMT-COL1
286500                                    (X-LS-STATS-1)
286600     END-IF.
286700*
286800     IF  MBCA-MBSM-INDEX-2 IS NOT EQUAL TO ZERO
286900         SET X-MMOG              TO MBCA-MBSM-INDEX-2
287000         MOVE MMOG-NBR (X-MMOG)  TO LS-STATS-NBR-COL2
287100                                    (X-LS-STATS-1)
287200         MOVE MMOG-AMT (X-MMOG)  TO LS-STATS-AMT-COL2
287300                                    (X-LS-STATS-1)
287400     END-IF.
287500*
287600     SET X-LS-STATS-1            UP BY +1.
287700     GO TO 8670-READ-LOOP.
287800*
287900 8675-END-BROWSE.
288000*
288100****************************************************************
288200*    END BROWSE THE CHAIN/PRODUCT STATS FILE.                  *
288300****************************************************************
288400*
288500     MOVE 'FC24'                 TO MBCA-PROGRAM-LOCATION.
288600     SET MBIORO-ENDBR            TO TRUE.
288700     PERFORM MMOGAO-ACCESS       THRU MMOGAO-ACCESS-EXIT.
288800*
288900     SET LS-STATS-ENTRY-COUNT    TO X-LS-STATS-1.
289000     SUBTRACT +1                 FROM LS-STATS-ENTRY-COUNT.
289100*
289200 8680-LCQL-EXIT.
289300     EXIT.
289400/
289500 8700-LOAD-CHAIN-EXP.
289600*
289700****************************************************************
289800*    START BROWSE THE CHAIN/PRODUCT EXPENSE STATISTICS FILE.   *
289900****************************************************************
290000*
290100     MOVE 'FC25'                 TO MBCA-PROGRAM-LOCATION.
290200     MOVE MBCA-MBSM-ORG          TO MBIOWS-MMPX-ORG.
290300     MOVE MBCA-MBSM-CHAIN-MERCH  TO MBIOWS-MMPX-ACCT.
290400     MOVE ZERO                   TO MBIOWS-MMPX-MINOR-KEY.
290500*
290600     IF  MBCA-MBSM-VALID-PRODUCT
290700         SET MBIOWS-MMPX-DETAIL  TO TRUE
290800         MOVE MBCA-MBSM-CARD-PROD
290900                                 TO MBIOWS-MMPX-PRODUCT
291000     ELSE
291100         SET MBIOWS-MMPX-TOTALS  TO TRUE
291200         MOVE ZERO               TO MBIOWS-MMPX-PRODUCT
291300     END-IF.
291400*
291500     MOVE ZEROES                 TO MBIOWS-MMPX-LOGIC-MODULE.
291600     SET MBIORO-STARTBR-GTE      TO TRUE.
291700     PERFORM MMPXAO-ACCESS       THRU MMPXAO-ACCESS-EXIT.
291800*
291900     SET X-LS-STATS-1            TO +1.
292000*
292100 8701-READ-LOOP.
292200*
292300****************************************************************
292400*    READNEXT THE CHAIN/PRODUCT EXPENSE STATISTICS FILE.       *
292500****************************************************************
292600*
292700     MOVE 'FC26'                 TO MBCA-PROGRAM-LOCATION.
292800     SET MBIORO-READ-SEQ         TO TRUE.
292900     PERFORM MMPXAO-ACCESS       THRU MMPXAO-ACCESS-EXIT.
293000*
293100     IF  MMPX-ORG   IS NOT EQUAL TO MBCA-MBSM-ORG
293200     OR  MMPX-ACCT  IS NOT EQUAL TO MBCA-MBSM-CHAIN-MERCH
293300         GO TO 8705-END-BROWSE
293400     END-IF.
293500*
293600     IF  MBCA-MBSM-VALID-PRODUCT
293700         IF  MMPX-PRODUCT IS NOT EQUAL TO MBCA-MBSM-CARD-PROD
293800             GO TO 8705-END-BROWSE
293900         END-IF
294000     ELSE
294100         IF  MMPX-PRODUCT IS NOT EQUAL TO ZERO
294200             GO TO 8705-END-BROWSE
294300         END-IF
294400     END-IF.
294500*
294600     MOVE MMPX-LOGIC-MODULE      TO WS-SEARCH-LM-PL-LOGIC-MODULE.
294700     PERFORM 9400-SEARCH-LM-PL-TABLE
294800                                 THRU 9410-SLPT-EXIT.
294900*
295000     IF  WS-SEARCH-NOT-FOUND
295100         GO TO 8701-READ-LOOP.
295200*
295300     MOVE ZERO                   TO LS-STATS-PAGE-NBR
295400                                    (X-LS-STATS-1).
295500*
295600     MOVE MMPX-LOGIC-MODULE      TO LS-STATS-LOGIC-MODULE
295700                                    (X-LS-STATS-1).
295800*
295900     IF  MBCA-MBSM-INDEX-1 IS NOT EQUAL TO ZERO
296000         SET X-MMPX              TO MBCA-MBSM-INDEX-1
296100         MOVE MMPX-NBR (X-MMPX)  TO LS-STATS-NBR-COL1
296200                                    (X-LS-STATS-1)
296300         MOVE MMPX-AMT (X-MMPX)  TO LS-STATS-AMT-COL1
296400                                    (X-LS-STATS-1)
296500     END-IF.
296600*
296700     IF  MBCA-MBSM-INDEX-2 IS NOT EQUAL TO ZERO
296800         SET X-MMPX              TO MBCA-MBSM-INDEX-2
296900         MOVE MMPX-NBR (X-MMPX)  TO LS-STATS-NBR-COL2
297000                                    (X-LS-STATS-1)
297100         MOVE MMPX-AMT (X-MMPX)  TO LS-STATS-AMT-COL2
297200                                    (X-LS-STATS-1)
297300     END-IF.
297400*
297500     SET X-LS-STATS-1            UP BY +1.
297600     GO TO 8701-READ-LOOP.
297700*
297800 8705-END-BROWSE.
297900*
298000****************************************************************
298100*    END BROWSE THE CHAIN/PRODUCT EXPENSE STATS FILE.          *
298200****************************************************************
298300*
298400     MOVE 'FC27'                 TO MBCA-PROGRAM-LOCATION.
298500     SET MBIORO-ENDBR            TO TRUE.
298600     PERFORM MMPXAO-ACCESS       THRU MMPXAO-ACCESS-EXIT.
298700*
298800     SET LS-STATS-ENTRY-COUNT    TO X-LS-STATS-1.
298900     SUBTRACT +1                 FROM LS-STATS-ENTRY-COUNT.
299000*
299100 8709-LCE-EXIT.
299200     EXIT.
299300/
299400 8710-LOAD-CHAIN-QUAL-LVL-EXP.
299500*
299600****************************************************************
299700*    START BROWSE THE CHAIN/QUAL LVL EXP STATISTICS FILE.      *
299800****************************************************************
299900*
300000     MOVE 'FC28'                 TO MBCA-PROGRAM-LOCATION.
300100     MOVE MBCA-MBSM-ORG          TO MBIOWS-MMOX-ORG.
300200     MOVE MBCA-MBSM-CHAIN-MERCH  TO MBIOWS-MMOX-ACCT.
300300     MOVE ZERO                   TO MBIOWS-MMOX-MINOR-KEY.
300400     SET MBIOWS-MMOX-DETAIL      TO TRUE.
300500     MOVE MBCA-MBSM-CARD-PROD    TO MBIOWS-MMOX-PRODUCT.
300600     MOVE MBCA-MBSM-QUAL-LEVEL   TO MBIOWS-MMOX-QUAL-LEVEL.
300700     MOVE ZEROES                 TO MBIOWS-MMOX-LOGIC-MODULE.
300800     SET MBIORO-STARTBR-GTE      TO TRUE.
300900     PERFORM MMOXAO-ACCESS       THRU MMOXAO-ACCESS-EXIT.
301000*
301100     SET X-LS-STATS-1            TO +1.
301200*
301300 8711-READ-LOOP.
301400*
301500****************************************************************
301600*    READNEXT THE CHAIN/QUAL LVL EXP STATISTICS FILE.          *
301700****************************************************************
301800*
301900     MOVE 'FC29'                 TO MBCA-PROGRAM-LOCATION.
302000     SET MBIORO-READ-SEQ         TO TRUE.
302100     PERFORM MMOXAO-ACCESS       THRU MMOXAO-ACCESS-EXIT.
302200*
302300     IF  MMOX-ORG        IS NOT EQUAL TO MBCA-MBSM-ORG
302400     OR  MMOX-ACCT       IS NOT EQUAL TO MBCA-MBSM-CHAIN-MERCH
302500     OR  MMOX-PRODUCT    IS NOT EQUAL TO MBCA-MBSM-CARD-PROD
302600     OR  MMOX-QUAL-LEVEL IS NOT EQUAL TO MBCA-MBSM-QUAL-LEVEL
302700         GO TO 8715-END-BROWSE
302800     END-IF.
302900*
303000     MOVE MMOX-LOGIC-MODULE      TO WS-SEARCH-LM-PL-LOGIC-MODULE.
303100     PERFORM 9400-SEARCH-LM-PL-TABLE
303200                                 THRU 9410-SLPT-EXIT.
303300*
303400     IF  WS-SEARCH-NOT-FOUND
303500         GO TO 8711-READ-LOOP.
303600*
303700     MOVE MMOX-QUAL-LEVEL        TO LS-STATS-PAGE-NBR
303800                                    (X-LS-STATS-1).
303900     MOVE MMOX-LOGIC-MODULE      TO LS-STATS-LOGIC-MODULE
304000                                    (X-LS-STATS-1).
304100*
304200     IF  MBCA-MBSM-INDEX-1 IS NOT EQUAL TO ZERO
304300         SET X-MMOX              TO MBCA-MBSM-INDEX-1
304400         MOVE MMOX-NBR (X-MMOX)  TO LS-STATS-NBR-COL1
304500                                    (X-LS-STATS-1)
304600         MOVE MMOX-AMT (X-MMOX)  TO LS-STATS-AMT-COL1
304700                                    (X-LS-STATS-1)
304800     END-IF.
304900*
305000     IF  MBCA-MBSM-INDEX-2 IS NOT EQUAL TO ZERO
305100         SET X-MMOX              TO MBCA-MBSM-INDEX-2
305200         MOVE MMOX-NBR (X-MMOX)  TO LS-STATS-NBR-COL2
305300                                    (X-LS-STATS-1)
305400         MOVE MMOX-AMT (X-MMOX)  TO LS-STATS-AMT-COL2
305500                                    (X-LS-STATS-1)
305600     END-IF.
305700*
305800     SET X-LS-STATS-1            UP BY +1.
305900     GO TO 8711-READ-LOOP.
306000*
306100 8715-END-BROWSE.
306200*
306300****************************************************************
306400*    END BROWSE THE CHAIN/PRODUCT STATS FILE.                  *
306500****************************************************************
306600*
306700     MOVE 'FC30'                 TO MBCA-PROGRAM-LOCATION.
306800     SET MBIORO-ENDBR            TO TRUE.
306900     PERFORM MMOXAO-ACCESS       THRU MMOXAO-ACCESS-EXIT.
307000*
307100     SET LS-STATS-ENTRY-COUNT    TO X-LS-STATS-1.
307200     SUBTRACT +1                 FROM LS-STATS-ENTRY-COUNT.
307300*
307400 8719-LCQLE-EXIT.
307500     EXIT.
307600/
307700 8720-LOAD-MERCHANT-EXP.
307800*
307900****************************************************************
308000*    START BROWSE THE MERCHANT/PRODUCT EXP STATISTICS FILE.    *
308100****************************************************************
308200*
308300     MOVE 'FC31'                 TO MBCA-PROGRAM-LOCATION.
308400     MOVE MBCA-MBSM-ORG          TO MBIOWS-MMPE-ORG.
308500     MOVE MBCA-MBSM-CHAIN-MERCH  TO MBIOWS-MMPE-ACCT.
308600     MOVE ZERO                   TO MBIOWS-MMPE-MINOR-KEY.
308700*
308800     IF  MBCA-MBSM-VALID-PRODUCT
308900         SET MBIOWS-MMPE-DETAIL  TO TRUE
309000         MOVE MBCA-MBSM-CARD-PROD
309100                                 TO MBIOWS-MMPE-PRODUCT
309200     ELSE
309300         SET MBIOWS-MMPE-TOTALS  TO TRUE
309400         MOVE ZERO               TO MBIOWS-MMPE-PRODUCT
309500     END-IF.
309600*
309700     MOVE ZEROES                 TO MBIOWS-MMPE-LOGIC-MODULE.
309800     SET MBIORO-STARTBR-GTE      TO TRUE.
309900     PERFORM MMPEAO-ACCESS       THRU MMPEAO-ACCESS-EXIT.
310000*
310100     SET X-LS-STATS-1            TO +1.
310200*
310300 8721-READ-LOOP.
310400*
310500****************************************************************
310600*    READNEXT THE MERCHANT/PRODUCT EXP STATISTICS FILE.        *
310700****************************************************************
310800*
310900     MOVE 'FC32'                 TO MBCA-PROGRAM-LOCATION.
311000     SET MBIORO-READ-SEQ         TO TRUE.
311100     PERFORM MMPEAO-ACCESS       THRU MMPEAO-ACCESS-EXIT.
311200*
311300     IF  MMPE-ORG IS NOT EQUAL TO MBCA-MBSM-ORG
311400     OR  MMPE-ACCT     IS NOT EQUAL TO MBCA-MBSM-CHAIN-MERCH
311500         GO TO 8725-END-BROWSE
311600     END-IF.
311700*
311800     IF  MBCA-MBSM-VALID-PRODUCT
311900         IF  MMPE-PRODUCT IS NOT EQUAL TO MBCA-MBSM-CARD-PROD
312000             GO TO 8725-END-BROWSE
312100         END-IF
312200     ELSE
312300         IF  MMPE-PRODUCT IS NOT EQUAL TO ZERO
312400             GO TO 8725-END-BROWSE
312500         END-IF
312600     END-IF.
312700*
312800     MOVE MMPE-LOGIC-MODULE      TO WS-SEARCH-LM-PL-LOGIC-MODULE.
312900     PERFORM 9400-SEARCH-LM-PL-TABLE
313000                                 THRU 9410-SLPT-EXIT.
313100*
313200     IF  WS-SEARCH-NOT-FOUND
313300         GO TO 8721-READ-LOOP.
313400*
313500     MOVE ZERO                   TO LS-STATS-PAGE-NBR
313600                                    (X-LS-STATS-1).
313700*
313800     MOVE MMPE-LOGIC-MODULE      TO LS-STATS-LOGIC-MODULE
313900                                    (X-LS-STATS-1).
314000*
314100     IF  MBCA-MBSM-INDEX-1 IS NOT EQUAL TO ZERO
314200         SET X-MMPE              TO MBCA-MBSM-INDEX-1
314300         MOVE MMPE-NBR (X-MMPE)  TO LS-STATS-NBR-COL1
314400                                    (X-LS-STATS-1)
314500         MOVE MMPE-AMT (X-MMPE)  TO LS-STATS-AMT-COL1
314600                                    (X-LS-STATS-1)
314700     END-IF.
314800*
314900     IF  MBCA-MBSM-INDEX-2 IS NOT EQUAL TO ZERO
315000         SET X-MMPE              TO MBCA-MBSM-INDEX-2
315100         MOVE MMPE-NBR (X-MMPE)  TO LS-STATS-NBR-COL2
315200                                    (X-LS-STATS-1)
315300         MOVE MMPE-AMT (X-MMPE)  TO LS-STATS-AMT-COL2
315400                                    (X-LS-STATS-1)
315500     END-IF.
315600*
315700     SET X-LS-STATS-1            UP BY +1.
315800     GO TO 8721-READ-LOOP.
315900*
316000 8725-END-BROWSE.
316100*
316200****************************************************************
316300*    END BROWSE THE MERCHANT/PRODUCT EXP STATS FILE.           *
316400****************************************************************
316500*
316600     MOVE 'FC33'                 TO MBCA-PROGRAM-LOCATION.
316700     SET MBIORO-ENDBR            TO TRUE.
316800     PERFORM MMPEAO-ACCESS       THRU MMPEAO-ACCESS-EXIT.
316900*
317000     SET LS-STATS-ENTRY-COUNT    TO X-LS-STATS-1.
317100     SUBTRACT +1                 FROM LS-STATS-ENTRY-COUNT.
317200*
317300 8729-LME-EXIT.
317400     EXIT.
317500/
317600 8730-LOAD-MERCH-QUAL-LVL-EXP.
317700*
317800****************************************************************
317900*    START BROWSE THE MERCH/QUAL LVL EXP STATISTICS FILE.      *
318000****************************************************************
318100*
318200     MOVE 'FC34'                 TO MBCA-PROGRAM-LOCATION.
318300     MOVE MBCA-MBSM-ORG          TO MBIOWS-MMOE-ORG.
318400     MOVE MBCA-MBSM-CHAIN-MERCH  TO MBIOWS-MMOE-ACCT.
318500     MOVE ZERO                   TO MBIOWS-MMOE-MINOR-KEY.
318600     SET MBIOWS-MMOE-DETAIL      TO TRUE.
318700     MOVE MBCA-MBSM-CARD-PROD    TO MBIOWS-MMOE-PRODUCT.
318800     MOVE MBCA-MBSM-QUAL-LEVEL   TO MBIOWS-MMOE-QUAL-LEVEL.
318900     MOVE ZEROES                 TO MBIOWS-MMOE-LOGIC-MODULE.
319000     SET MBIORO-STARTBR-GTE      TO TRUE.
319100     PERFORM MMOEAO-ACCESS       THRU MMOEAO-ACCESS-EXIT.
319200*
319300     SET X-LS-STATS-1            TO +1.
319400*
319500 8731-READ-LOOP.
319600*
319700****************************************************************
319800*    READNEXT THE MERCH/QUAL LVL STATISTICS FILE.              *
319900****************************************************************
320000*
320100     MOVE 'FC35'                 TO MBCA-PROGRAM-LOCATION.
320200     SET MBIORO-READ-SEQ         TO TRUE.
320300     PERFORM MMOEAO-ACCESS       THRU MMOEAO-ACCESS-EXIT.
320400*
320500     IF  MMOE-ORG        IS NOT EQUAL TO MBCA-MBSM-ORG
320600     OR  MMOE-ACCT       IS NOT EQUAL TO MBCA-MBSM-CHAIN-MERCH
320700     OR  MMOE-PRODUCT    IS NOT EQUAL TO MBCA-MBSM-CARD-PROD
320800     OR  MMOE-QUAL-LEVEL IS NOT EQUAL TO MBCA-MBSM-QUAL-LEVEL
320900         GO TO 8735-END-BROWSE
321000     END-IF.
321100*
321200     MOVE MMOE-LOGIC-MODULE      TO WS-SEARCH-LM-PL-LOGIC-MODULE.
321300     PERFORM 9400-SEARCH-LM-PL-TABLE
321400                                 THRU 9410-SLPT-EXIT.
321500*
321600     IF  WS-SEARCH-NOT-FOUND
321700         GO TO 8731-READ-LOOP.
321800*
321900     MOVE MMOE-QUAL-LEVEL        TO LS-STATS-PAGE-NBR
322000                                    (X-LS-STATS-1).
322100     MOVE MMOE-LOGIC-MODULE      TO LS-STATS-LOGIC-MODULE
322200                                    (X-LS-STATS-1).
322300*
322400     IF  MBCA-MBSM-INDEX-1 IS NOT EQUAL TO ZERO
322500         SET X-MMOE              TO MBCA-MBSM-INDEX-1
322600         MOVE MMOE-NBR (X-MMOE)  TO LS-STATS-NBR-COL1
322700                                    (X-LS-STATS-1)
322800         MOVE MMOE-AMT (X-MMOE)  TO LS-STATS-AMT-COL1
322900                                    (X-LS-STATS-1)
323000     END-IF.
323100*
323200     IF  MBCA-MBSM-INDEX-2 IS NOT EQUAL TO ZERO
323300         SET X-MMOE              TO MBCA-MBSM-INDEX-2
323400         MOVE MMOE-NBR (X-MMOE)  TO LS-STATS-NBR-COL2
323500                                    (X-LS-STATS-1)
323600         MOVE MMOE-AMT (X-MMOE)  TO LS-STATS-AMT-COL2
323700                                    (X-LS-STATS-1)
323800     END-IF.
323900*
324000     SET X-LS-STATS-1            UP BY +1.
324100     GO TO 8731-READ-LOOP.
324200*
324300 8735-END-BROWSE.
324400*
324500****************************************************************
324600*    END BROWSE THE MERCH/PRODUCT EXP STATS FILE.              *
324700****************************************************************
324800*
324900     MOVE 'FC36'                 TO MBCA-PROGRAM-LOCATION.
325000     SET MBIORO-ENDBR            TO TRUE.
325100     PERFORM MMOEAO-ACCESS       THRU MMOEAO-ACCESS-EXIT.
325200*
325300     SET LS-STATS-ENTRY-COUNT    TO X-LS-STATS-1.
325400     SUBTRACT +1                 FROM LS-STATS-ENTRY-COUNT.
325500*
325600 8739-LMQLE-EXIT.
325700     EXIT.
325800/
325900 8800-LOAD-S-CHAIN.
326000*
326100****************************************************************
326200*    START BROWSE THE STORE CHAIN/PRODUCT STATISTICS FILE.     *
326300****************************************************************
326400*
326500     MOVE 'FC37'                 TO MBCA-PROGRAM-LOCATION.
326600     MOVE MBCA-MBSM-ORG          TO MBIOWS-MMRG-ORG.
326700     MOVE MBCA-MBSM-CHAIN-MERCH  TO MBIOWS-MMRG-ACCT.
326800     MOVE ZERO                   TO MBIOWS-MMRG-MINOR-KEY.
326900*
327000     IF  MBCA-MBSM-VALID-PRODUCT
327100         SET MBIOWS-MMRG-DETAIL  TO TRUE
327200         MOVE MBCA-MBSM-CARD-PROD
327300                                 TO MBIOWS-MMRG-PRODUCT
327400     ELSE
327500         SET MBIOWS-MMRG-TOTALS  TO TRUE
327600         MOVE ZERO               TO MBIOWS-MMRG-PRODUCT
327700     END-IF.
327800*
327900     MOVE ZEROES                 TO MBIOWS-MMRG-LOGIC-MODULE.
328000     SET MBIORO-STARTBR-GTE      TO TRUE.
328100     PERFORM MMRGAO-ACCESS       THRU MMRGAO-ACCESS-EXIT.
328200*
328300     SET X-LS-STATS-1            TO +1.
328400*
328500 8801-READ-LOOP.
328600*
328700****************************************************************
328800*    READNEXT THE STORE CHAIN/PRODUCT STATISTICS FILE.         *
328900****************************************************************
329000*
329100     MOVE 'FC38'                 TO MBCA-PROGRAM-LOCATION.
329200     SET MBIORO-READ-SEQ         TO TRUE.
329300     PERFORM MMRGAO-ACCESS       THRU MMRGAO-ACCESS-EXIT.
329400*
329500     IF  MMRG-ORG   IS NOT EQUAL TO MBCA-MBSM-ORG
329600     OR  MMRG-ACCT  IS NOT EQUAL TO MBCA-MBSM-CHAIN-MERCH
329700         GO TO 8805-END-BROWSE
329800     END-IF.
329900*
330000     IF  MBCA-MBSM-VALID-PRODUCT
330100         IF  MMRG-PRODUCT IS NOT EQUAL TO MBCA-MBSM-CARD-PROD
330200             GO TO 8805-END-BROWSE
330300         END-IF
330400     ELSE
330500         IF  MMRG-PRODUCT IS NOT EQUAL TO ZERO
330600             GO TO 8805-END-BROWSE
330700         END-IF
330800     END-IF.
330900*
331000     MOVE MMRG-LOGIC-MODULE      TO WS-SEARCH-LM-PL-LOGIC-MODULE.
331100     PERFORM 9400-SEARCH-LM-PL-TABLE
331200                                 THRU 9410-SLPT-EXIT.
331300*
331400     IF  WS-SEARCH-NOT-FOUND
331500         GO TO 8801-READ-LOOP.
331600*
331700     MOVE ZERO                   TO LS-STATS-PAGE-NBR
331800                                    (X-LS-STATS-1).
331900*
332000     MOVE MMRG-LOGIC-MODULE      TO LS-STATS-LOGIC-MODULE
332100                                    (X-LS-STATS-1).
332200*
332300     IF  MBCA-MBSM-INDEX-1 IS NOT EQUAL TO ZERO
332400         SET X-MMRG              TO MBCA-MBSM-INDEX-1
332500         MOVE MMRG-NBR (X-MMRG)  TO LS-STATS-NBR-COL1
332600                                    (X-LS-STATS-1)
332700         MOVE MMRG-AMT (X-MMRG)  TO LS-STATS-AMT-COL1
332800                                    (X-LS-STATS-1)
332900     END-IF.
333000*
333100     IF  MBCA-MBSM-INDEX-2 IS NOT EQUAL TO ZERO
333200         SET X-MMRG              TO MBCA-MBSM-INDEX-2
333300         MOVE MMRG-NBR (X-MMRG)  TO LS-STATS-NBR-COL2
333400                                    (X-LS-STATS-1)
333500         MOVE MMRG-AMT (X-MMRG)  TO LS-STATS-AMT-COL2
333600                                    (X-LS-STATS-1)
333700     END-IF.
333800*
333900     SET X-LS-STATS-1            UP BY +1.
334000     GO TO 8801-READ-LOOP.
334100*
334200 8805-END-BROWSE.
334300*
334400****************************************************************
334500*    END BROWSE THE STORE CHAIN/PRODUCT STATS FILE.            *
334600****************************************************************
334700*
334800     MOVE 'FC39'                 TO MBCA-PROGRAM-LOCATION.
334900     SET MBIORO-ENDBR            TO TRUE.
335000     PERFORM MMRGAO-ACCESS       THRU MMRGAO-ACCESS-EXIT.
335100*
335200     SET LS-STATS-ENTRY-COUNT    TO X-LS-STATS-1.
335300     SUBTRACT +1                 FROM LS-STATS-ENTRY-COUNT.
335400*
335500 8809-LSC-EXIT.
335600     EXIT.
335700/
335800 8810-LOAD-S-CHAIN-CRED-PLAN.
335900*
336000****************************************************************
336100*    START BROWSE THE STORE CHAIN/CRED PLAN STATISTICS FILE.   *
336200****************************************************************
336300*
336400     MOVE 'FC40'                 TO MBCA-PROGRAM-LOCATION.
336500     MOVE MBCA-MBSM-ORG          TO MBIOWS-MMLG-ORG.
336600     MOVE MBCA-MBSM-CHAIN-MERCH  TO MBIOWS-MMLG-ACCT.
336700     MOVE ZERO                   TO MBIOWS-MMLG-MINOR-KEY.
336800     SET MBIOWS-MMLG-DETAIL      TO TRUE.
336900     MOVE MBCA-MBSM-CARD-PROD    TO MBIOWS-MMLG-PRODUCT.
337000     MOVE MBCA-MBSM-PLAN         TO MBIOWS-MMLG-PLAN.
337100     MOVE ZEROES                 TO MBIOWS-MMLG-LOGIC-MODULE.
337200     SET MBIORO-STARTBR-GTE      TO TRUE.
337300     PERFORM MMLGAO-ACCESS       THRU MMLGAO-ACCESS-EXIT.
337400*
337500     SET X-LS-STATS-1            TO +1.
337600*
337700 8811-READ-LOOP.
337800*
337900****************************************************************
338000*    READNEXT THE CHAIN/CRED PLAN STATISTICS FILE.             *
338100****************************************************************
338200*
338300     MOVE 'FC41'                 TO MBCA-PROGRAM-LOCATION.
338400     SET MBIORO-READ-SEQ         TO TRUE.
338500     PERFORM MMLGAO-ACCESS       THRU MMLGAO-ACCESS-EXIT.
338600*
338700     IF  MMLG-ORG      IS NOT EQUAL TO MBCA-MBSM-ORG
338800     OR  MMLG-ACCT     IS NOT EQUAL TO MBCA-MBSM-CHAIN-MERCH
338900     OR  MMLG-PRODUCT  IS NOT EQUAL TO MBCA-MBSM-CARD-PROD
339000     OR  MMLG-PLAN     IS NOT EQUAL TO MBCA-MBSM-PLAN
339100         GO TO 8815-END-BROWSE
339200     END-IF.
339300*
339400     MOVE MMLG-LOGIC-MODULE      TO WS-SEARCH-LM-PL-LOGIC-MODULE.
339500     PERFORM 9400-SEARCH-LM-PL-TABLE
339600                                 THRU 9410-SLPT-EXIT.
339700*
339800     IF  WS-SEARCH-NOT-FOUND
339900         GO TO 8811-READ-LOOP.
340000*
340100     MOVE ZERO                   TO LS-STATS-PAGE-NBR
340200                                    (X-LS-STATS-1).
340300*
340400     MOVE MMLG-LOGIC-MODULE      TO LS-STATS-LOGIC-MODULE
340500                                    (X-LS-STATS-1).
340600*
340700     IF  MBCA-MBSM-INDEX-1 IS NOT EQUAL TO ZERO
340800         SET X-MMLG              TO MBCA-MBSM-INDEX-1
340900         MOVE MMLG-NBR (X-MMLG)  TO LS-STATS-NBR-COL1
341000                                    (X-LS-STATS-1)
341100         MOVE MMLG-AMT (X-MMLG)  TO LS-STATS-AMT-COL1
341200                                    (X-LS-STATS-1)
341300     END-IF.
341400*
341500     IF  MBCA-MBSM-INDEX-2 IS NOT EQUAL TO ZERO
341600         SET X-MMLG              TO MBCA-MBSM-INDEX-2
341700         MOVE MMLG-NBR (X-MMLG)  TO LS-STATS-NBR-COL2
341800                                    (X-LS-STATS-1)
341900         MOVE MMLG-AMT (X-MMLG)  TO LS-STATS-AMT-COL2
342000                                    (X-LS-STATS-1)
342100     END-IF.
342200*
342300     SET X-LS-STATS-1            UP BY +1.
342400     GO TO 8811-READ-LOOP.
342500*
342600 8815-END-BROWSE.
342700*
342800****************************************************************
342900*    END BROWSE THE CHAIN/PRODUCT STATS FILE.                  *
343000****************************************************************
343100*
343200     MOVE 'FC42'                 TO MBCA-PROGRAM-LOCATION.
343300     SET MBIORO-ENDBR            TO TRUE.
343400     PERFORM MMLGAO-ACCESS       THRU MMLGAO-ACCESS-EXIT.
343500*
343600     SET LS-STATS-ENTRY-COUNT    TO X-LS-STATS-1.
343700     SUBTRACT +1                 FROM LS-STATS-ENTRY-COUNT.
343800*
343900 8819-LSCCP-EXIT.
344000     EXIT.
344100/
344200 8900-LOAD-FEE-ACTIVITY-GROUP.
344300*
344400****************************************************************
344500*    START RANDOM THE GROUP FEE ACTIVITY STATS FILE.           *
344600****************************************************************
344700*
344800     MOVE 'FC43'                 TO MBCA-PROGRAM-LOCATION.
344900     MOVE SS08WS-CICS-FC-NOTFND  TO MBIORO-TEMP-STATUS-1.
345000     MOVE MBCA-MBSM-ORG          TO MBIOWS-MMFG-ORG.
345100     MOVE MBCA-MBSM-CHAIN-MERCH  TO MBIOWS-MMFG-CHAIN.
345200     SET MBIORO-READ-RANDOM      TO TRUE.
345300     PERFORM MMFGAO-ACCESS       THRU MMFGAO-ACCESS-EXIT.
345400*
345500     IF  SS08WS-RC-FC-NOTFND
345600         GO TO 8909-LFAG-EXIT.
345700*
345800     MOVE 17                     TO LS-STATS-PAGE-NBR
345900                                    (X-LS-STATS-1).
346000     MOVE 999                    TO LS-STATS-LOGIC-MODULE
346100                                    (X-LS-STATS-1).
346200*
346300     IF  MBCA-MBSM-INDEX-1 IS NOT EQUAL TO ZERO
346400         SET X-MMFG              TO MBCA-MBSM-INDEX-1
346500         MOVE MMFG-KEYED-AUTHS-NBR (X-MMFG)                       RG800902
346600                                 TO LS-STATS-NBR-COL1
346700                                    (X-LS-STATS-1)
346800         MOVE ZEROS              TO LS-STATS-AMT-COL1
346900                                    (X-LS-STATS-1)
347000         MOVE 1                  TO LS-STATS-LINE-NBR
347100                                    (X-LS-STATS-1)
347200     END-IF.
347300*
347400     IF  MBCA-MBSM-INDEX-2 IS NOT EQUAL TO ZERO
347500         SET X-MMFG              TO MBCA-MBSM-INDEX-2
347600         MOVE MMFG-KEYED-AUTHS-NBR (X-MMFG)                       RG800902
347700                                 TO LS-STATS-NBR-COL2
347800                                    (X-LS-STATS-1)
347900         MOVE ZEROS              TO LS-STATS-AMT-COL2
348000                                    (X-LS-STATS-1)
348100         MOVE 1                  TO LS-STATS-LINE-NBR
348200                                    (X-LS-STATS-1)
348300     END-IF.
348400*
348500     SET X-LS-STATS-1            UP BY +1.
348600*
348700     MOVE 17                     TO LS-STATS-PAGE-NBR
348800                                    (X-LS-STATS-1).
348900     MOVE 999                    TO LS-STATS-LOGIC-MODULE
349000                                    (X-LS-STATS-1).
349100*
349200     IF  MBCA-MBSM-INDEX-1 IS NOT EQUAL TO ZERO
349300         SET X-MMFG              TO MBCA-MBSM-INDEX-1
349400         MOVE MMFG-SWIPED-AUTHS-NBR (X-MMFG)                      RG800902
349500                                 TO LS-STATS-NBR-COL1
349600                                    (X-LS-STATS-1)
349700         MOVE ZEROS              TO LS-STATS-AMT-COL1
349800                                    (X-LS-STATS-1)
349900         MOVE 2                  TO LS-STATS-LINE-NBR
350000                                    (X-LS-STATS-1)
350100     END-IF.
350200*
350300     IF  MBCA-MBSM-INDEX-2 IS NOT EQUAL TO ZERO
350400         SET X-MMFG              TO MBCA-MBSM-INDEX-2
350500         MOVE MMFG-SWIPED-AUTHS-NBR (X-MMFG)                      RG800902
350600                                 TO LS-STATS-NBR-COL2
350700                                    (X-LS-STATS-1)
350800         MOVE ZEROS              TO LS-STATS-AMT-COL2
350900                                    (X-LS-STATS-1)
351000         MOVE 2                  TO LS-STATS-LINE-NBR
351100                                    (X-LS-STATS-1)
351200     END-IF.
351300*
351400     SET X-LS-STATS-1            UP BY +1.
351402*                                                                 RG800902
351404     MOVE 17                     TO LS-STATS-PAGE-NBR             RG800902
351406                                    (X-LS-STATS-1).               RG800902
351408     MOVE 999                    TO LS-STATS-LOGIC-MODULE         RG800902
351410                                    (X-LS-STATS-1).               RG800902
351412*                                                                 RG800902
351414     IF  MBCA-MBSM-INDEX-1 IS NOT EQUAL TO ZERO                   RG800902
351416         SET X-MMFG              TO MBCA-MBSM-INDEX-1             RG800902
351418         COMPUTE LS-STATS-NBR-COL1 (X-LS-STATS-1)                 RG800902
351420                                 = MMFG-KEYED-SALES-NBR (X-MMFG)  RG800902
351422                                 - MMFG-KEYED-SALES-REV-NBR       RG800902
351424                                   (X-MMFG)                       RG800902
351426         MOVE ZEROS              TO LS-STATS-AMT-COL1             RG800902
351428                                    (X-LS-STATS-1)                RG800902
351430         MOVE 3                  TO LS-STATS-LINE-NBR             RG800902
351432                                    (X-LS-STATS-1)                RG800902
351434     END-IF.                                                      RG800902
351436*                                                                 RG800902
351438     IF  MBCA-MBSM-INDEX-2 IS NOT EQUAL TO ZERO                   RG800902
351440         SET X-MMFG              TO MBCA-MBSM-INDEX-2             RG800902
351442         COMPUTE LS-STATS-NBR-COL2 (X-LS-STATS-1)                 RG800902
351444                                 = MMFG-KEYED-SALES-NBR (X-MMFG)  RG800902
351446                                 - MMFG-KEYED-SALES-REV-NBR       RG800902
351448                                   (X-MMFG)                       RG800902
351450         MOVE ZEROS              TO LS-STATS-AMT-COL2             RG800902
351452                                    (X-LS-STATS-1)                RG800902
351454         MOVE 3                  TO LS-STATS-LINE-NBR             RG800902
351456                                    (X-LS-STATS-1)                RG800902
351458     END-IF.                                                      RG800902
351460*                                                                 RG800902
351462     SET X-LS-STATS-1            UP BY +1.                        RG800902
351464*                                                                 RG800902
351466     MOVE 17                     TO LS-STATS-PAGE-NBR             RG800902
351468                                    (X-LS-STATS-1).               RG800902
351470     MOVE 999                    TO LS-STATS-LOGIC-MODULE         RG800902
351472                                    (X-LS-STATS-1).               RG800902
351474*                                                                 RG800902
351476     IF  MBCA-MBSM-INDEX-1 IS NOT EQUAL TO ZERO                   RG800902
351478         SET X-MMFG              TO MBCA-MBSM-INDEX-1             RG800902
351480         COMPUTE LS-STATS-NBR-COL1 (X-LS-STATS-1)                 RG800902
351482                                 = MMFG-SWIPED-SALES-NBR (X-MMFG) RG800902
351484                                 - MMFG-KEYED-SALES-REV-NBR       RG800902
351486                                   (X-MMFG)                       RG800902
351488         MOVE ZEROS              TO LS-STATS-AMT-COL1             RG800902
351490                                    (X-LS-STATS-1)                RG800902
351492         MOVE 4                  TO LS-STATS-LINE-NBR             RG800902
351494                                    (X-LS-STATS-1)                RG800902
351496     END-IF.                                                      RG800902
351498*                                                                 RG800902
351500     IF  MBCA-MBSM-INDEX-2 IS NOT EQUAL TO ZERO                   RG800902
351502         SET X-MMFG              TO MBCA-MBSM-INDEX-2             RG800902
351504         COMPUTE LS-STATS-NBR-COL2 (X-LS-STATS-1)                 RG800902
351506                                 = MMFG-SWIPED-SALES-NBR (X-MMFG) RG800902
351508                                 - MMFG-KEYED-SALES-REV-NBR       RG800902
351510                                   (X-MMFG)                       RG800902
351512         MOVE ZEROS              TO LS-STATS-AMT-COL2             RG800902
351514                                    (X-LS-STATS-1)                RG800902
351516         MOVE 4                  TO LS-STATS-LINE-NBR             RG800902
351518                                    (X-LS-STATS-1)                RG800902
351520     END-IF.                                                      RG800902
351522*                                                                 RG800902
351524     SET X-LS-STATS-1            UP BY +1.                        RG800902
351599*                                                                 RG800902
351600     MOVE 17                     TO LS-STATS-PAGE-NBR
351700                                    (X-LS-STATS-1).
351800     MOVE 999                    TO LS-STATS-LOGIC-MODULE
351900                                    (X-LS-STATS-1).
352000*
352100     IF  MBCA-MBSM-INDEX-1 IS NOT EQUAL TO ZERO
352200         SET X-MMFG              TO MBCA-MBSM-INDEX-1
352300         MOVE MMFG-USER-INP-NBR (X-MMFG)
352400                                 TO LS-STATS-NBR-COL1
352500                                    (X-LS-STATS-1)
352600         MOVE ZEROS              TO LS-STATS-AMT-COL1
352700                                    (X-LS-STATS-1)
352800         MOVE 5                  TO LS-STATS-LINE-NBR             RG800902
352900                                    (X-LS-STATS-1)
353000     END-IF.
353100*
353200     IF  MBCA-MBSM-INDEX-2 IS NOT EQUAL TO ZERO
353300         SET X-MMFG              TO MBCA-MBSM-INDEX-2
353400         MOVE MMFG-USER-INP-NBR (X-MMFG)
353500                                 TO LS-STATS-NBR-COL2
353600                                    (X-LS-STATS-1)
353700         MOVE ZEROS              TO LS-STATS-AMT-COL2
353800                                    (X-LS-STATS-1)
353900         MOVE 5                  TO LS-STATS-LINE-NBR             RG800902
354000                                    (X-LS-STATS-1)
354100     END-IF.
354200*
354300     SET X-LS-STATS-1            UP BY +1.
354400*
354500     MOVE 17                     TO LS-STATS-PAGE-NBR
354600                                    (X-LS-STATS-1).
354700     MOVE 999                    TO LS-STATS-LOGIC-MODULE
354800                                    (X-LS-STATS-1).
354900*
355000     IF  MBCA-MBSM-INDEX-1 IS NOT EQUAL TO ZERO
355100         SET X-MMFG              TO MBCA-MBSM-INDEX-1
355200         MOVE MMFG-LOCAL-INP-NBR (X-MMFG)
355300                                 TO LS-STATS-NBR-COL1
355400                                    (X-LS-STATS-1)
355500         MOVE ZEROS              TO LS-STATS-AMT-COL1
355600                                    (X-LS-STATS-1)
355700         MOVE 6                  TO LS-STATS-LINE-NBR             RG800902
355800                                    (X-LS-STATS-1)
355900     END-IF.
356000*
356100     IF  MBCA-MBSM-INDEX-2 IS NOT EQUAL TO ZERO
356200         SET X-MMFG              TO MBCA-MBSM-INDEX-2
356300         MOVE MMFG-LOCAL-INP-NBR (X-MMFG)
356400                                 TO LS-STATS-NBR-COL2
356500                                    (X-LS-STATS-1)
356600         MOVE ZEROS              TO LS-STATS-AMT-COL2
356700                                    (X-LS-STATS-1)
356800         MOVE 6                  TO LS-STATS-LINE-NBR             RG800902
356900                                    (X-LS-STATS-1)
357000     END-IF.
357100*
357200     SET X-LS-STATS-1            UP BY +1.
357300*
357400     MOVE 17                     TO LS-STATS-PAGE-NBR
357500                                    (X-LS-STATS-1).
357600     MOVE 999                    TO LS-STATS-LOGIC-MODULE
357700                                    (X-LS-STATS-1).
357800*
357900     IF  MBCA-MBSM-INDEX-1 IS NOT EQUAL TO ZERO
358000         SET X-MMFG              TO MBCA-MBSM-INDEX-1
358100         MOVE MMFG-POS-1-CAP-NBR (X-MMFG)
358200                                 TO LS-STATS-NBR-COL1
358300                                    (X-LS-STATS-1)
358400         MOVE ZEROS              TO LS-STATS-AMT-COL1
358500                                    (X-LS-STATS-1)
358600         MOVE 7                  TO LS-STATS-LINE-NBR             RG800902
358700                                    (X-LS-STATS-1)
358800     END-IF.
358900*
359000     IF  MBCA-MBSM-INDEX-2 IS NOT EQUAL TO ZERO
359100         SET X-MMFG              TO MBCA-MBSM-INDEX-2
359200         MOVE MMFG-POS-1-CAP-NBR (X-MMFG)
359300                                 TO LS-STATS-NBR-COL2
359400                                    (X-LS-STATS-1)
359500         MOVE ZEROS              TO LS-STATS-AMT-COL2
359600                                    (X-LS-STATS-1)
359700         MOVE 7                  TO LS-STATS-LINE-NBR             RG800902
359800                                    (X-LS-STATS-1)
359900     END-IF.
360000*
360100     SET X-LS-STATS-1            UP BY +1.
360200*
360300     MOVE 17                     TO LS-STATS-PAGE-NBR
360400                                    (X-LS-STATS-1).
360500     MOVE 999                    TO LS-STATS-LOGIC-MODULE
360600                                    (X-LS-STATS-1).
360700*
360800     IF  MBCA-MBSM-INDEX-1 IS NOT EQUAL TO ZERO
360900         SET X-MMFG              TO MBCA-MBSM-INDEX-1
361000         MOVE MMFG-POS-2-CAP-NBR (X-MMFG)
361100                                 TO LS-STATS-NBR-COL1
361200                                    (X-LS-STATS-1)
361300         MOVE ZEROS              TO LS-STATS-AMT-COL1
361400                                    (X-LS-STATS-1)
361500         MOVE 8                  TO LS-STATS-LINE-NBR             RG800902
361600                                    (X-LS-STATS-1)
361700     END-IF.
361800*
361900     IF  MBCA-MBSM-INDEX-2 IS NOT EQUAL TO ZERO
362000         SET X-MMFG              TO MBCA-MBSM-INDEX-2
362100         MOVE MMFG-POS-2-CAP-NBR (X-MMFG)
362200                                 TO LS-STATS-NBR-COL2
362300                                    (X-LS-STATS-1)
362400         MOVE ZEROS              TO LS-STATS-AMT-COL2
362500                                    (X-LS-STATS-1)
362600         MOVE 8                  TO LS-STATS-LINE-NBR             RG800902
362700                                    (X-LS-STATS-1)
362800     END-IF.
362900*
363000     SET X-LS-STATS-1            UP BY +1.
363100*
363200     MOVE 17                     TO LS-STATS-PAGE-NBR
363300                                    (X-LS-STATS-1).
363400     MOVE 999                    TO LS-STATS-LOGIC-MODULE
363500                                    (X-LS-STATS-1).
363600*
363700     IF  MBCA-MBSM-INDEX-1 IS NOT EQUAL TO ZERO
363800         SET X-MMFG              TO MBCA-MBSM-INDEX-1
363900         MOVE MMFG-POS-3-CAP-NBR (X-MMFG)
364000                                 TO LS-STATS-NBR-COL1
364100                                    (X-LS-STATS-1)
364200         MOVE ZEROS              TO LS-STATS-AMT-COL1
364300                                    (X-LS-STATS-1)
364400         MOVE 9                  TO LS-STATS-LINE-NBR             RG800902
364500                                    (X-LS-STATS-1)
364600     END-IF.
364700*
364800     IF  MBCA-MBSM-INDEX-2 IS NOT EQUAL TO ZERO
364900         SET X-MMFG              TO MBCA-MBSM-INDEX-2
365000         MOVE MMFG-POS-3-CAP-NBR (X-MMFG)
365100                                 TO LS-STATS-NBR-COL2
365200                                    (X-LS-STATS-1)
365300         MOVE ZEROS              TO LS-STATS-AMT-COL2
365400                                    (X-LS-STATS-1)
365500         MOVE 9                  TO LS-STATS-LINE-NBR             RG800902
365600                                    (X-LS-STATS-1)
365700     END-IF.
365800*
365900     SET X-LS-STATS-1            UP BY +1.
366000*
366100     MOVE 17                     TO LS-STATS-PAGE-NBR
366200                                    (X-LS-STATS-1).
366300     MOVE 999                    TO LS-STATS-LOGIC-MODULE
366400                                    (X-LS-STATS-1).
366500*
366600     IF  MBCA-MBSM-INDEX-1 IS NOT EQUAL TO ZERO
366700         SET X-MMFG              TO MBCA-MBSM-INDEX-1
366800         MOVE MMFG-ACH-NBR (X-MMFG)
366900                                 TO LS-STATS-NBR-COL1
367000                                    (X-LS-STATS-1)
367100         MOVE ZEROS              TO LS-STATS-AMT-COL1
367200                                    (X-LS-STATS-1)
367300         MOVE 10                 TO LS-STATS-LINE-NBR             RG800902
367400                                    (X-LS-STATS-1)
367500     END-IF.
367600*
367700     IF  MBCA-MBSM-INDEX-2 IS NOT EQUAL TO ZERO
367800         SET X-MMFG              TO MBCA-MBSM-INDEX-2
367900         MOVE MMFG-ACH-NBR (X-MMFG)
368000                                 TO LS-STATS-NBR-COL2
368100                                    (X-LS-STATS-1)
368200         MOVE ZEROS              TO LS-STATS-AMT-COL2
368300                                    (X-LS-STATS-1)
368400         MOVE 10                 TO LS-STATS-LINE-NBR             RG800902
368500                                    (X-LS-STATS-1)
368600     END-IF.
368700*
368702     SET X-LS-STATS-1            UP BY +1.                        RG800902
368704*                                                                 RG800902
368706     MOVE 17                     TO LS-STATS-PAGE-NBR             RG800902
368708                                    (X-LS-STATS-1).               RG800902
368710     MOVE 999                    TO LS-STATS-LOGIC-MODULE         RG800902
368712                                    (X-LS-STATS-1).               RG800902
368714*                                                                 RG800902
368716     IF  MBCA-MBSM-INDEX-1 IS NOT EQUAL TO ZERO                   RG800902
368718         SET X-MMFG              TO MBCA-MBSM-INDEX-1             RG800902
368720         MOVE ZEROES             TO LS-STATS-NBR-COL1             RG800902
368722                                    (X-LS-STATS-1)                RG800902
368724         MOVE MMFG-KEYED-AUTHS-AMT (X-MMFG)                       RG800902
368726                                 TO LS-STATS-AMT-COL1             RG800902
368728                                    (X-LS-STATS-1)                RG800902
368730         MOVE 11                 TO LS-STATS-LINE-NBR             RG800902
368732                                    (X-LS-STATS-1)                RG800902
368734     END-IF.                                                      RG800902
368736*                                                                 RG800902
368738     IF  MBCA-MBSM-INDEX-2 IS NOT EQUAL TO ZERO                   RG800902
368740         SET X-MMFG              TO MBCA-MBSM-INDEX-2             RG800902
368742         MOVE ZEROES             TO LS-STATS-NBR-COL2             RG800902
368744                                    (X-LS-STATS-1)                RG800902
368746         MOVE MMFG-KEYED-AUTHS-AMT (X-MMFG)                       RG800902
368748                                 TO LS-STATS-AMT-COL2             RG800902
368750                                    (X-LS-STATS-1)                RG800902
368752         MOVE 11                 TO LS-STATS-LINE-NBR             RG800902
368754                                    (X-LS-STATS-1)                RG800902
368756     END-IF.                                                      RG800902
368758*                                                                 RG800902
368760     SET X-LS-STATS-1            UP BY +1.                        RG800902
368762*                                                                 RG800902
368764     MOVE 17                     TO LS-STATS-PAGE-NBR             RG800902
368766                                    (X-LS-STATS-1).               RG800902
368768     MOVE 999                    TO LS-STATS-LOGIC-MODULE         RG800902
368770                                    (X-LS-STATS-1).               RG800902
368772*                                                                 RG800902
368774     IF  MBCA-MBSM-INDEX-1 IS NOT EQUAL TO ZERO                   RG800902
368776         SET X-MMFG              TO MBCA-MBSM-INDEX-1             RG800902
368778         MOVE ZEROES             TO LS-STATS-NBR-COL1             RG800902
368780                                    (X-LS-STATS-1)                RG800902
368782         MOVE MMFG-SWIPED-AUTHS-AMT (X-MMFG)                      RG800902
368784                                 TO LS-STATS-AMT-COL1             RG800902
368786                                    (X-LS-STATS-1)                RG800902
368788         MOVE 12                 TO LS-STATS-LINE-NBR             RG800902
368790                                    (X-LS-STATS-1)                RG800902
368792     END-IF.                                                      RG800902
368794*                                                                 RG800902
368796     IF  MBCA-MBSM-INDEX-2 IS NOT EQUAL TO ZERO                   RG800902
368798         SET X-MMFG              TO MBCA-MBSM-INDEX-2             RG800902
368800         MOVE ZEROES             TO LS-STATS-NBR-COL2             RG800902
368802                                    (X-LS-STATS-1)                RG800902
368804         MOVE MMFG-SWIPED-AUTHS-AMT (X-MMFG)                      RG800902
368806                                 TO LS-STATS-AMT-COL2             RG800902
368808                                    (X-LS-STATS-1)                RG800902
368810         MOVE 12                 TO LS-STATS-LINE-NBR             RG800902
368812                                    (X-LS-STATS-1)                RG800902
368814     END-IF.                                                      RG800902
368816*                                                                 RG800902
368818     SET X-LS-STATS-1            UP BY +1.                        RG800902
368820*                                                                 RG800902
368822     MOVE 17                     TO LS-STATS-PAGE-NBR             RG800902
368824                                    (X-LS-STATS-1).               RG800902
368826     MOVE 999                    TO LS-STATS-LOGIC-MODULE         RG800902
368828                                    (X-LS-STATS-1).               RG800902
368830*                                                                 RG800902
368832     IF  MBCA-MBSM-INDEX-1 IS NOT EQUAL TO ZERO                   RG800902
368834         SET X-MMFG              TO MBCA-MBSM-INDEX-1             RG800902
368836         MOVE ZEROES             TO LS-STATS-NBR-COL1             RG800902
368838                                    (X-LS-STATS-1)                RG800902
368840         COMPUTE LS-STATS-AMT-COL1 (X-LS-STATS-1)                 RG800902
368842                                 = MMFG-KEYED-SALES-AMT (X-MMFG)  RG800902
368844                                 - MMFG-KEYED-SALES-REV-AMT       RG800902
368846                                   (X-MMFG)                       RG800902
368848                                 + MMFG-SWIPED-SALES-AMT (X-MMFG) RG800902
368850                                 - MMFG-SWIPED-SALES-REV-AMT      RG800902
368852                                   (X-MMFG)                       RG800902
368854         MOVE 13                 TO LS-STATS-LINE-NBR             RG800902
368856                                    (X-LS-STATS-1)                RG800902
368858     END-IF.                                                      RG800902
368860*                                                                 RG800902
368862     IF  MBCA-MBSM-INDEX-2 IS NOT EQUAL TO ZERO                   RG800902
368864         SET X-MMFG              TO MBCA-MBSM-INDEX-2             RG800902
368866         MOVE ZEROES             TO LS-STATS-NBR-COL2             RG800902
368868                                    (X-LS-STATS-1)                RG800902
368870         COMPUTE LS-STATS-AMT-COL2 (X-LS-STATS-1)                 RG800902
368872                                 = MMFG-KEYED-SALES-AMT (X-MMFG)  RG800902
368874                                 - MMFG-KEYED-SALES-REV-AMT       RG800902
368876                                   (X-MMFG)                       RG800902
368878                                 + MMFG-SWIPED-SALES-AMT (X-MMFG) RG800902
368880                                 - MMFG-SWIPED-SALES-REV-AMT      RG800902
368882                                   (X-MMFG)                       RG800902
368884         MOVE 13                 TO LS-STATS-LINE-NBR             RG800902
368886                                    (X-LS-STATS-1)                RG800902
368888     END-IF.                                                      RG800902
368890*                                                                 RG800902
368892     SET X-LS-STATS-1            UP BY +1.                        RG800902
368894*                                                                 RG800902
368896     MOVE 17                     TO LS-STATS-PAGE-NBR             RG800902
368898                                    (X-LS-STATS-1).               RG800902
368900     MOVE 999                    TO LS-STATS-LOGIC-MODULE         RG800902
368902                                    (X-LS-STATS-1).               RG800902
368904*                                                                 RG800902
368906     IF  MBCA-MBSM-INDEX-1 IS NOT EQUAL TO ZERO                   RG800902
368908         SET X-MMFG              TO MBCA-MBSM-INDEX-1             RG800902
368910         MOVE ZEROES             TO LS-STATS-NBR-COL1             RG800902
368912                                    (X-LS-STATS-1)                RG800902
368914         MOVE MMFG-SALES-BELOW-FLOOR-AMT (X-MMFG)                 RG800902
368916                                 TO LS-STATS-AMT-COL1             RG800902
368918                                    (X-LS-STATS-1)                RG800902
368920         MOVE 14                 TO LS-STATS-LINE-NBR             RG800902
368922                                    (X-LS-STATS-1)                RG800902
368924     END-IF.                                                      RG800902
368926*                                                                 RG800902
368928     IF  MBCA-MBSM-INDEX-2 IS NOT EQUAL TO ZERO                   RG800902
368930         SET X-MMFG              TO MBCA-MBSM-INDEX-2             RG800902
368932         MOVE ZEROES             TO LS-STATS-NBR-COL2             RG800902
368934                                    (X-LS-STATS-1)                RG800902
368936         MOVE MMFG-SALES-BELOW-FLOOR-AMT (X-MMFG)                 RG800902
368938                                 TO LS-STATS-AMT-COL2             RG800902
368940                                    (X-LS-STATS-1)                RG800902
368942         MOVE 14                 TO LS-STATS-LINE-NBR             RG800902
368944                                    (X-LS-STATS-1)                RG800902
368946*                                                                 RG800902
368948     SET X-LS-STATS-1            UP BY +1.                        RG800902
368950*                                                                 RG800902
368952     MOVE 17                     TO LS-STATS-PAGE-NBR             RG800902
368954                                    (X-LS-STATS-1).               RG800902
368956     MOVE 999                    TO LS-STATS-LOGIC-MODULE         RG800902
368958                                    (X-LS-STATS-1).               RG800902
368960*                                                                 RG800902
368962     IF  MBCA-MBSM-INDEX-1 IS NOT EQUAL TO ZERO                   RG800902
368964         SET X-MMFG              TO MBCA-MBSM-INDEX-1             RG800902
368966         MOVE ZEROES             TO LS-STATS-NBR-COL1             RG800902
368968                                    (X-LS-STATS-1)                RG800902
368970         COMPUTE LS-STATS-AMT-COL1 (X-LS-STATS-1)                 RG800902
368972                                 = MMFG-KEYED-RETURNS-AMT (X-MMFG)RG800902
368974                                 - MMFG-KEYED-RETURNS-REV-AMT     RG800902
368976                                   (X-MMFG)                       RG800902
368978                                 + MMFG-SWIPED-RETURNS-AMT        RG800902
368980                                   (X-MMFG)                       RG800902
368982                                 - MMFG-SWIPED-RETURNS-REV-AMT    RG800902
368984                                   (X-MMFG)                       RG800902
368986         MOVE 15                 TO LS-STATS-LINE-NBR             RG800902
368988                                    (X-LS-STATS-1)                RG800902
368990     END-IF.                                                      RG800902
368992*                                                                 RG800902
368994     IF  MBCA-MBSM-INDEX-2 IS NOT EQUAL TO ZERO                   RG800902
368996         SET X-MMFG              TO MBCA-MBSM-INDEX-2             RG800902
368998         MOVE ZEROES             TO LS-STATS-NBR-COL2             RG800902
369000                                    (X-LS-STATS-1)                RG800902
369002         COMPUTE LS-STATS-AMT-COL2 (X-LS-STATS-1)                 RG800902
369004                                 = MMFG-KEYED-RETURNS-AMT (X-MMFG)RG800902
369006                                 - MMFG-KEYED-RETURNS-REV-AMT     RG800902
369008                                   (X-MMFG)                       RG800902
369010                                 + MMFG-SWIPED-RETURNS-AMT        RG800902
369012                                   (X-MMFG)                       RG800902
369014                                 - MMFG-SWIPED-RETURNS-REV-AMT    RG800902
369016                                   (X-MMFG)                       RG800902
369018         MOVE 15                 TO LS-STATS-LINE-NBR             RG800902
369020                                    (X-LS-STATS-1)                RG800902
369022     END-IF.                                                      RG800902
369024*                                                                 RG800902
369026     SET X-LS-STATS-1            UP BY +1.                        RG800902
369028*                                                                 RG800902
369030     MOVE 17                     TO LS-STATS-PAGE-NBR             RG800902
369032                                    (X-LS-STATS-1).               RG800902
369034     MOVE 999                    TO LS-STATS-LOGIC-MODULE         RG800902
369036                                    (X-LS-STATS-1).               RG800902
369038*                                                                 RG800902
369040     IF  MBCA-MBSM-INDEX-1 IS NOT EQUAL TO ZERO                   RG800902
369042         SET X-MMFG              TO MBCA-MBSM-INDEX-1             RG800902
369044         COMPUTE LS-STATS-NBR-COL1 (X-LS-STATS-1)                 RG800902
369046                                 = MMFG-KEYED-RETURNS-NBR (X-MMFG)RG800902
369048                                 - MMFG-KEYED-RETURNS-REV-NBR     RG800902
369050                                   (X-MMFG)                       RG800902
369052                                 + MMFG-SWIPED-RETURNS-NBR        RG800902
369054                                   (X-MMFG)                       RG800902
369056                                 - MMFG-SWIPED-RETURNS-REV-NBR    RG800902
369058                                   (X-MMFG)                       RG800902
369060         MOVE ZEROES             TO LS-STATS-AMT-COL1             RG800902
369062                                    (X-LS-STATS-1)                RG800902
369064         MOVE 16                 TO LS-STATS-LINE-NBR             RG800902
369066                                    (X-LS-STATS-1)                RG800902
369068     END-IF.                                                      RG800902
369070*                                                                 RG800902
369072     IF  MBCA-MBSM-INDEX-2 IS NOT EQUAL TO ZERO                   RG800902
369074         SET X-MMFG              TO MBCA-MBSM-INDEX-2             RG800902
369076         COMPUTE LS-STATS-NBR-COL2 (X-LS-STATS-1)                 RG800902
369078                                 = MMFG-KEYED-RETURNS-NBR (X-MMFG)RG800902
369080                                 - MMFG-KEYED-RETURNS-REV-NBR     RG800902
369082                                   (X-MMFG)                       RG800902
369084                                 + MMFG-SWIPED-RETURNS-NBR        RG800902
369086                                   (X-MMFG)                       RG800902
369088                                 - MMFG-SWIPED-RETURNS-REV-NBR    RG800902
369090                                   (X-MMFG)                       RG800902
369092         MOVE ZEROES             TO LS-STATS-AMT-COL2             RG800902
369094                                    (X-LS-STATS-1)                RG800902
369096         MOVE 16                 TO LS-STATS-LINE-NBR             RG800902
369098                                    (X-LS-STATS-1)                RG800902
369100     END-IF.                                                      RG800902
369102*                                                                 RG800902
369196     SET LS-STATS-ENTRY-COUNT    TO X-LS-STATS-1.                 RG800902
369197*                                                                 RG800902
369198 8909-LFAG-EXIT.                                                  RG800902
369199     EXIT.                                                        RG800902
369200/
369300 8910-LOAD-FEE-ACTIVITY.
369400*
369500****************************************************************
369600*    START RANDOM THE FEE ACTIVITY STATS FILE.                 *
369700****************************************************************
369800*
369900     MOVE 'FC44'                 TO MBCA-PROGRAM-LOCATION.
370000     MOVE SS08WS-CICS-FC-NOTFND  TO MBIORO-TEMP-STATUS-1.
370100     MOVE MBCA-MBSM-ORG          TO MBIOWS-MMFA-ORG.
370200     MOVE MBCA-MBSM-CHAIN-MERCH  TO MBIOWS-MMFA-MERCHANT.
370300     SET MBIORO-READ-RANDOM      TO TRUE.
370400     PERFORM MMFAAO-ACCESS       THRU MMFAAO-ACCESS-EXIT.
370500*
370600     IF  SS08WS-RC-FC-NOTFND
370700         GO TO 8919-LFA-EXIT.
370800*
370900     SET X-LS-STATS-1            UP BY +1.
371000*
371100     MOVE 17                     TO LS-STATS-PAGE-NBR
371200                                    (X-LS-STATS-1).
371300     MOVE 999                    TO LS-STATS-LOGIC-MODULE
371400                                    (X-LS-STATS-1).
371500*
371600     IF  MBCA-MBSM-INDEX-1 IS NOT EQUAL TO ZERO
371700         SET X-MMFA              TO MBCA-MBSM-INDEX-1
371800         MOVE MMFA-KEYED-AUTHS-NBR (X-MMFA)                       RG800902
371900                                 TO LS-STATS-NBR-COL1
372000                                    (X-LS-STATS-1)
372100         MOVE ZEROS              TO LS-STATS-AMT-COL1
372200                                    (X-LS-STATS-1)
372300         MOVE 1                  TO LS-STATS-LINE-NBR
372400                                    (X-LS-STATS-1)
372500     END-IF.
372600*
372700     IF  MBCA-MBSM-INDEX-2 IS NOT EQUAL TO ZERO
372800         SET X-MMFA              TO MBCA-MBSM-INDEX-2
372900         MOVE MMFA-KEYED-AUTHS-NBR (X-MMFA)                       RG800902
373000                                 TO LS-STATS-NBR-COL2
373100                                    (X-LS-STATS-1)
373200         MOVE ZEROS              TO LS-STATS-AMT-COL2
373300                                    (X-LS-STATS-1)
373400         MOVE 1                  TO LS-STATS-LINE-NBR
373500                                    (X-LS-STATS-1)
373600     END-IF.
373700*
373800     SET X-LS-STATS-1            UP BY +1.
373900*
374000     MOVE 17                     TO LS-STATS-PAGE-NBR
374100                                    (X-LS-STATS-1).
374200     MOVE 999                    TO LS-STATS-LOGIC-MODULE
374300                                    (X-LS-STATS-1).
374400*
374500     IF  MBCA-MBSM-INDEX-1 IS NOT EQUAL TO ZERO
374600         SET X-MMFA              TO MBCA-MBSM-INDEX-1
374700         MOVE MMFA-SWIPED-AUTHS-NBR (X-MMFA)                      RG800902
374800                                 TO LS-STATS-NBR-COL1
374900                                    (X-LS-STATS-1)
375000         MOVE ZEROS              TO LS-STATS-AMT-COL1
375100                                    (X-LS-STATS-1)
375200         MOVE 2                  TO LS-STATS-LINE-NBR
375300                                    (X-LS-STATS-1)
375400     END-IF.
375500*
375600     IF  MBCA-MBSM-INDEX-2 IS NOT EQUAL TO ZERO
375700         SET X-MMFA              TO MBCA-MBSM-INDEX-2
375800         MOVE MMFA-SWIPED-AUTHS-NBR (X-MMFA)                      RG800902
375900                                 TO LS-STATS-NBR-COL2
376000                                    (X-LS-STATS-1)
376100         MOVE ZEROS              TO LS-STATS-AMT-COL2
376200                                    (X-LS-STATS-1)
376300         MOVE 2                  TO LS-STATS-LINE-NBR
376400                                    (X-LS-STATS-1)
376500     END-IF.
376600*
376700     SET X-LS-STATS-1            UP BY +1.
376702*                                                                 RG800902
376704     MOVE 17                     TO LS-STATS-PAGE-NBR             RG800902
376706                                    (X-LS-STATS-1).               RG800902
376708     MOVE 999                    TO LS-STATS-LOGIC-MODULE         RG800902
376710                                    (X-LS-STATS-1).               RG800902
376712*                                                                 RG800902
376714     IF  MBCA-MBSM-INDEX-1 IS NOT EQUAL TO ZERO                   RG800902
376716         SET X-MMFA              TO MBCA-MBSM-INDEX-1             RG800902
376718         COMPUTE LS-STATS-NBR-COL1 (X-LS-STATS-1)                 RG800902
376720                                 = MMFA-KEYED-SALES-NBR (X-MMFA)  RG800902
376722                                 - MMFA-KEYED-SALES-REV-NBR       RG800902
376724                                   (X-MMFA)                       RG800902
376726         MOVE ZEROS              TO LS-STATS-AMT-COL1             RG800902
376728                                    (X-LS-STATS-1)                RG800902
376730         MOVE 3                  TO LS-STATS-LINE-NBR             RG800902
376732                                    (X-LS-STATS-1)                RG800902
376734     END-IF.                                                      RG800902
376736*                                                                 RG800902
376738     IF  MBCA-MBSM-INDEX-2 IS NOT EQUAL TO ZERO                   RG800902
376740         SET X-MMFA              TO MBCA-MBSM-INDEX-2             RG800902
376742         COMPUTE LS-STATS-NBR-COL2 (X-LS-STATS-1)                 RG800902
376744                                 = MMFA-KEYED-SALES-NBR (X-MMFA)  RG800902
376746                                 - MMFA-KEYED-SALES-REV-NBR       RG800902
376748                                   (X-MMFA)                       RG800902
376750         MOVE ZEROS              TO LS-STATS-AMT-COL2             RG800902
376752                                    (X-LS-STATS-1)                RG800902
376754         MOVE 3                  TO LS-STATS-LINE-NBR             RG800902
376756                                    (X-LS-STATS-1)                RG800902
376758     END-IF.                                                      RG800902
376760*                                                                 RG800902
376762     SET X-LS-STATS-1            UP BY +1.                        RG800902
376764*                                                                 RG800902
376766     MOVE 17                     TO LS-STATS-PAGE-NBR             RG800902
376768                                    (X-LS-STATS-1).               RG800902
376770     MOVE 999                    TO LS-STATS-LOGIC-MODULE         RG800902
376772                                    (X-LS-STATS-1).               RG800902
376774*                                                                 RG800902
376776     IF  MBCA-MBSM-INDEX-1 IS NOT EQUAL TO ZERO                   RG800902
376778         SET X-MMFA              TO MBCA-MBSM-INDEX-1             RG800902
376780         COMPUTE LS-STATS-NBR-COL1 (X-LS-STATS-1)                 RG800902
376782                                 = MMFA-SWIPED-SALES-NBR (X-MMFA) RG800902
376784                                 - MMFA-KEYED-SALES-REV-NBR       RG800902
376786                                   (X-MMFA)                       RG800902
376788         MOVE ZEROS              TO LS-STATS-AMT-COL1             RG800902
376790                                    (X-LS-STATS-1)                RG800902
376792         MOVE 4                  TO LS-STATS-LINE-NBR             RG800902
376794                                    (X-LS-STATS-1)                RG800902
376796     END-IF.                                                      RG800902
376798*                                                                 RG800902
376800     IF  MBCA-MBSM-INDEX-2 IS NOT EQUAL TO ZERO                   RG800902
376802         SET X-MMFA              TO MBCA-MBSM-INDEX-2             RG800902
376804         COMPUTE LS-STATS-NBR-COL2 (X-LS-STATS-1)                 RG800902
376806                                 = MMFA-SWIPED-SALES-NBR (X-MMFA) RG800902
376808                                 - MMFA-KEYED-SALES-REV-NBR       RG800902
376810                                   (X-MMFA)                       RG800902
376812         MOVE ZEROS              TO LS-STATS-AMT-COL2             RG800902
376814                                    (X-LS-STATS-1)                RG800902
376816         MOVE 4                  TO LS-STATS-LINE-NBR             RG800902
376818                                    (X-LS-STATS-1)                RG800902
376820     END-IF.                                                      RG800902
376822*                                                                 RG800902
376824     SET X-LS-STATS-1            UP BY +1.                        RG800902
376899*                                                                 RG800902
376900     MOVE 17                     TO LS-STATS-PAGE-NBR
377000                                    (X-LS-STATS-1).
377100     MOVE 999                    TO LS-STATS-LOGIC-MODULE
377200                                    (X-LS-STATS-1).
377300*
377400     IF  MBCA-MBSM-INDEX-1 IS NOT EQUAL TO ZERO
377500         SET X-MMFA              TO MBCA-MBSM-INDEX-1
377600         MOVE MMFA-USER-INP-NBR (X-MMFA)
377700                                 TO LS-STATS-NBR-COL1
377800                                    (X-LS-STATS-1)
377900         MOVE ZEROS              TO LS-STATS-AMT-COL1
378000                                    (X-LS-STATS-1)
378100         MOVE 5                  TO LS-STATS-LINE-NBR             RG800902
378200                                    (X-LS-STATS-1)
378300     END-IF.
378400*
378500     IF  MBCA-MBSM-INDEX-2 IS NOT EQUAL TO ZERO
378600         SET X-MMFA              TO MBCA-MBSM-INDEX-2
378700         MOVE MMFA-USER-INP-NBR (X-MMFA)
378800                                 TO LS-STATS-NBR-COL2
378900                                    (X-LS-STATS-1)
379000         MOVE ZEROS              TO LS-STATS-AMT-COL2
379100                                    (X-LS-STATS-1)
379200         MOVE 5                  TO LS-STATS-LINE-NBR             RG800902
379300                                    (X-LS-STATS-1)
379400     END-IF.
379500*
379600     SET X-LS-STATS-1            UP BY +1.
379700*
379800     MOVE 17                     TO LS-STATS-PAGE-NBR
379900                                    (X-LS-STATS-1).
380000     MOVE 999                    TO LS-STATS-LOGIC-MODULE
380100                                    (X-LS-STATS-1).
380200*
380300     IF  MBCA-MBSM-INDEX-1 IS NOT EQUAL TO ZERO
380400         SET X-MMFA              TO MBCA-MBSM-INDEX-1
380500         MOVE MMFA-LOCAL-INP-NBR (X-MMFA)
380600                                 TO LS-STATS-NBR-COL1
380700                                    (X-LS-STATS-1)
380800         MOVE ZEROS              TO LS-STATS-AMT-COL1
380900                                    (X-LS-STATS-1)
381000         MOVE 6                  TO LS-STATS-LINE-NBR             RG800902
381100                                    (X-LS-STATS-1)
381200     END-IF.
381300*
381400     IF  MBCA-MBSM-INDEX-2 IS NOT EQUAL TO ZERO
381500         SET X-MMFA              TO MBCA-MBSM-INDEX-2
381600         MOVE MMFA-LOCAL-INP-NBR (X-MMFA)
381700                                 TO LS-STATS-NBR-COL2
381800                                    (X-LS-STATS-1)
381900         MOVE ZEROS              TO LS-STATS-AMT-COL2
382000                                    (X-LS-STATS-1)
382100         MOVE 6                  TO LS-STATS-LINE-NBR             RG800902
382200                                    (X-LS-STATS-1)
382300     END-IF.
382400*
382500     SET X-LS-STATS-1            UP BY +1.
382600*
382700     MOVE 17                     TO LS-STATS-PAGE-NBR
382800                                    (X-LS-STATS-1).
382900     MOVE 999                    TO LS-STATS-LOGIC-MODULE
383000                                    (X-LS-STATS-1).
383100*
383200     IF  MBCA-MBSM-INDEX-1 IS NOT EQUAL TO ZERO
383300         SET X-MMFA              TO MBCA-MBSM-INDEX-1
383400         MOVE MMFA-POS-1-CAP-NBR (X-MMFA)
383500                                 TO LS-STATS-NBR-COL1
383600                                    (X-LS-STATS-1)
383700         MOVE ZEROS              TO LS-STATS-AMT-COL1
383800                                    (X-LS-STATS-1)
383900         MOVE 7                  TO LS-STATS-LINE-NBR             RG800902
384000                                    (X-LS-STATS-1)
384100     END-IF.
384200*
384300     IF  MBCA-MBSM-INDEX-2 IS NOT EQUAL TO ZERO
384400         SET X-MMFA              TO MBCA-MBSM-INDEX-2
384500         MOVE MMFA-POS-1-CAP-NBR (X-MMFA)
384600                                 TO LS-STATS-NBR-COL2
384700                                    (X-LS-STATS-1)
384800         MOVE ZEROS              TO LS-STATS-AMT-COL2
384900                                    (X-LS-STATS-1)
385000         MOVE 7                  TO LS-STATS-LINE-NBR             RG800902
385100                                    (X-LS-STATS-1)
385200     END-IF.
385300*
385400     SET X-LS-STATS-1            UP BY +1.
385500*
385600     MOVE 17                     TO LS-STATS-PAGE-NBR
385700                                    (X-LS-STATS-1).
385800     MOVE 999                    TO LS-STATS-LOGIC-MODULE
385900                                    (X-LS-STATS-1).
386000*
386100     IF  MBCA-MBSM-INDEX-1 IS NOT EQUAL TO ZERO
386200         SET X-MMFA              TO MBCA-MBSM-INDEX-1
386300         MOVE MMFA-POS-2-CAP-NBR (X-MMFA)
386400                                 TO LS-STATS-NBR-COL1
386500                                    (X-LS-STATS-1)
386600         MOVE ZEROS              TO LS-STATS-AMT-COL1
386700                                    (X-LS-STATS-1)
386800         MOVE 8                  TO LS-STATS-LINE-NBR             RG800902
386900                                    (X-LS-STATS-1)
387000     END-IF.
387100*
387200     IF  MBCA-MBSM-INDEX-2 IS NOT EQUAL TO ZERO
387300         SET X-MMFA              TO MBCA-MBSM-INDEX-2
387400         MOVE MMFA-POS-2-CAP-NBR (X-MMFA)
387500                                 TO LS-STATS-NBR-COL2
387600                                    (X-LS-STATS-1)
387700         MOVE ZEROS              TO LS-STATS-AMT-COL2
387800                                    (X-LS-STATS-1)
387900         MOVE 8                  TO LS-STATS-LINE-NBR             RG800902
388000                                    (X-LS-STATS-1)
388100     END-IF.
388200*
388300     SET X-LS-STATS-1            UP BY +1.
388400*
388500     MOVE 17                     TO LS-STATS-PAGE-NBR
388600                                    (X-LS-STATS-1).
388700     MOVE 999                    TO LS-STATS-LOGIC-MODULE
388800                                    (X-LS-STATS-1).
388900*
389000     IF  MBCA-MBSM-INDEX-1 IS NOT EQUAL TO ZERO
389100         SET X-MMFA              TO MBCA-MBSM-INDEX-1
389200         MOVE MMFA-POS-3-CAP-NBR (X-MMFA)
389300                                 TO LS-STATS-NBR-COL1
389400                                    (X-LS-STATS-1)
389500         MOVE ZEROS              TO LS-STATS-AMT-COL1
389600                                    (X-LS-STATS-1)
389700         MOVE 9                  TO LS-STATS-LINE-NBR             RG800902
389800                                    (X-LS-STATS-1)
389900     END-IF.
390000*
390100     IF  MBCA-MBSM-INDEX-2 IS NOT EQUAL TO ZERO
390200         SET X-MMFA              TO MBCA-MBSM-INDEX-2
390300         MOVE MMFA-POS-3-CAP-NBR (X-MMFA)
390400                                 TO LS-STATS-NBR-COL2
390500                                    (X-LS-STATS-1)
390600         MOVE ZEROS              TO LS-STATS-AMT-COL2
390700                                    (X-LS-STATS-1)
390800         MOVE 9                  TO LS-STATS-LINE-NBR             RG800902
390900                                    (X-LS-STATS-1)
391000     END-IF.
391100*
391200     SET X-LS-STATS-1            UP BY +1.
391300*
391400     MOVE 17                     TO LS-STATS-PAGE-NBR
391500                                    (X-LS-STATS-1).
391600     MOVE 999                    TO LS-STATS-LOGIC-MODULE
391700                                    (X-LS-STATS-1).
391800*
391900     IF  MBCA-MBSM-INDEX-1 IS NOT EQUAL TO ZERO
392000         SET X-MMFA              TO MBCA-MBSM-INDEX-1
392100         MOVE MMFA-ACH-NBR (X-MMFA)
392200                                 TO LS-STATS-NBR-COL1
392300                                    (X-LS-STATS-1)
392400         MOVE ZEROS              TO LS-STATS-AMT-COL1
392500                                    (X-LS-STATS-1)
392600         MOVE 10                 TO LS-STATS-LINE-NBR             RG800902
392700                                    (X-LS-STATS-1)
392800     END-IF.
392900*
393000     IF  MBCA-MBSM-INDEX-2 IS NOT EQUAL TO ZERO
393100         SET X-MMFA              TO MBCA-MBSM-INDEX-2
393200         MOVE MMFA-ACH-NBR (X-MMFA)
393300                                 TO LS-STATS-NBR-COL2
393400                                    (X-LS-STATS-1)
393500         MOVE ZEROS              TO LS-STATS-AMT-COL2
393600                                    (X-LS-STATS-1)
393700         MOVE 10                 TO LS-STATS-LINE-NBR             RG800902
393800                                    (X-LS-STATS-1)
393900     END-IF.
394000*
394002     SET X-LS-STATS-1            UP BY +1.                        RG800902
394004*                                                                 RG800902
394006     MOVE 17                     TO LS-STATS-PAGE-NBR             RG800902
394008                                    (X-LS-STATS-1).               RG800902
394010     MOVE 999                    TO LS-STATS-LOGIC-MODULE         RG800902
394012                                    (X-LS-STATS-1).               RG800902
394014*                                                                 RG800902
394016     IF  MBCA-MBSM-INDEX-1 IS NOT EQUAL TO ZERO                   RG800902
394018         SET X-MMFA              TO MBCA-MBSM-INDEX-1             RG800902
394020         MOVE ZEROES             TO LS-STATS-NBR-COL1             RG800902
394022                                    (X-LS-STATS-1)                RG800902
394024         MOVE MMFA-KEYED-AUTHS-AMT (X-MMFA)                       RG800902
394026                                 TO LS-STATS-AMT-COL1             RG800902
394028                                    (X-LS-STATS-1)                RG800902
394030         MOVE 11                 TO LS-STATS-LINE-NBR             RG800902
394032                                    (X-LS-STATS-1)                RG800902
394034     END-IF.                                                      RG800902
394036*                                                                 RG800902
394038     IF  MBCA-MBSM-INDEX-2 IS NOT EQUAL TO ZERO                   RG800902
394040         SET X-MMFA              TO MBCA-MBSM-INDEX-2             RG800902
394042         MOVE ZEROES             TO LS-STATS-NBR-COL2             RG800902
394044                                    (X-LS-STATS-1)                RG800902
394046         MOVE MMFA-KEYED-AUTHS-AMT (X-MMFA)                       RG800902
394048                                 TO LS-STATS-AMT-COL2             RG800902
394050                                    (X-LS-STATS-1)                RG800902
394052         MOVE 11                 TO LS-STATS-LINE-NBR             RG800902
394054                                    (X-LS-STATS-1)                RG800902
394056     END-IF.                                                      RG800902
394058*                                                                 RG800902
394060     SET X-LS-STATS-1            UP BY +1.                        RG800902
394062*                                                                 RG800902
394064     MOVE 17                     TO LS-STATS-PAGE-NBR             RG800902
394066                                    (X-LS-STATS-1).               RG800902
394068     MOVE 999                    TO LS-STATS-LOGIC-MODULE         RG800902
394070                                    (X-LS-STATS-1).               RG800902
394072*                                                                 RG800902
394074     IF  MBCA-MBSM-INDEX-1 IS NOT EQUAL TO ZERO                   RG800902
394076         SET X-MMFA              TO MBCA-MBSM-INDEX-1             RG800902
394078         MOVE ZEROES             TO LS-STATS-NBR-COL1             RG800902
394080                                    (X-LS-STATS-1)                RG800902
394082         MOVE MMFA-SWIPED-AUTHS-AMT (X-MMFA)                      RG800902
394084                                 TO LS-STATS-AMT-COL1             RG800902
394086                                    (X-LS-STATS-1)                RG800902
394088         MOVE 12                 TO LS-STATS-LINE-NBR             RG800902
394090                                    (X-LS-STATS-1)                RG800902
394092     END-IF.                                                      RG800902
394094*                                                                 RG800902
394096     IF  MBCA-MBSM-INDEX-2 IS NOT EQUAL TO ZERO                   RG800902
394098         SET X-MMFA              TO MBCA-MBSM-INDEX-2             RG800902
394100         MOVE ZEROES             TO LS-STATS-NBR-COL2             RG800902
394102                                    (X-LS-STATS-1)                RG800902
394104         MOVE MMFA-SWIPED-AUTHS-AMT (X-MMFA)                      RG800902
394106                                 TO LS-STATS-AMT-COL2             RG800902
394108                                    (X-LS-STATS-1)                RG800902
394110         MOVE 12                 TO LS-STATS-LINE-NBR             RG800902
394112                                    (X-LS-STATS-1)                RG800902
394114     END-IF.                                                      RG800902
394116*                                                                 RG800902
394118     SET X-LS-STATS-1            UP BY +1.                        RG800902
394120*                                                                 RG800902
394122     MOVE 17                     TO LS-STATS-PAGE-NBR             RG800902
394124                                    (X-LS-STATS-1).               RG800902
394126     MOVE 999                    TO LS-STATS-LOGIC-MODULE         RG800902
394128                                    (X-LS-STATS-1).               RG800902
394130*                                                                 RG800902
394132     IF  MBCA-MBSM-INDEX-1 IS NOT EQUAL TO ZERO                   RG800902
394134         SET X-MMFA              TO MBCA-MBSM-INDEX-1             RG800902
394136         MOVE ZEROES             TO LS-STATS-NBR-COL1             RG800902
394138                                    (X-LS-STATS-1)                RG800902
394140         COMPUTE LS-STATS-AMT-COL1 (X-LS-STATS-1)                 RG800902
394142                                 = MMFA-KEYED-SALES-AMT (X-MMFA)  RG800902
394144                                 - MMFA-KEYED-SALES-REV-AMT       RG800902
394146                                   (X-MMFA)                       RG800902
394148                                 + MMFA-SWIPED-SALES-AMT (X-MMFA) RG800902
394150                                 - MMFA-SWIPED-SALES-REV-AMT      RG800902
394152                                   (X-MMFA)                       RG800902
394154         MOVE 13                 TO LS-STATS-LINE-NBR             RG800902
394156                                    (X-LS-STATS-1)                RG800902
394158     END-IF.                                                      RG800902
394160*                                                                 RG800902
394162     IF  MBCA-MBSM-INDEX-2 IS NOT EQUAL TO ZERO                   RG800902
394164         SET X-MMFA              TO MBCA-MBSM-INDEX-2             RG800902
394166         MOVE ZEROES             TO LS-STATS-NBR-COL2             RG800902
394168                                    (X-LS-STATS-1)                RG800902
394170         COMPUTE LS-STATS-AMT-COL2 (X-LS-STATS-1)                 RG800902
394172                                 = MMFA-KEYED-SALES-AMT (X-MMFA)  RG800902
394174                                 - MMFA-KEYED-SALES-REV-AMT       RG800902
394176                                   (X-MMFA)                       RG800902
394178                                 + MMFA-SWIPED-SALES-AMT (X-MMFA) RG800902
394180                                 - MMFA-SWIPED-SALES-REV-AMT      RG800902
394182                                   (X-MMFA)                       RG800902
394184         MOVE 13                 TO LS-STATS-LINE-NBR             RG800902
394186                                    (X-LS-STATS-1)                RG800902
394188     END-IF.                                                      RG800902
394190*                                                                 RG800902
394192     SET X-LS-STATS-1            UP BY +1.                        RG800902
394194*                                                                 RG800902
394196     MOVE 17                     TO LS-STATS-PAGE-NBR             RG800902
394198                                    (X-LS-STATS-1).               RG800902
394200     MOVE 999                    TO LS-STATS-LOGIC-MODULE         RG800902
394202                                    (X-LS-STATS-1).               RG800902
394204*                                                                 RG800902
394206     IF  MBCA-MBSM-INDEX-1 IS NOT EQUAL TO ZERO                   RG800902
394208         SET X-MMFA              TO MBCA-MBSM-INDEX-1             RG800902
394210         MOVE ZEROES             TO LS-STATS-NBR-COL1             RG800902
394212                                    (X-LS-STATS-1)                RG800902
394214         MOVE MMFA-SALES-BELOW-FLOOR-AMT (X-MMFA)                 RG800902
394216                                 TO LS-STATS-AMT-COL1             RG800902
394218                                    (X-LS-STATS-1)                RG800902
394220         MOVE 14                 TO LS-STATS-LINE-NBR             RG800902
394222                                    (X-LS-STATS-1)                RG800902
394224     END-IF.                                                      RG800902
394226*                                                                 RG800902
394228     IF  MBCA-MBSM-INDEX-2 IS NOT EQUAL TO ZERO                   RG800902
394230         SET X-MMFA              TO MBCA-MBSM-INDEX-2             RG800902
394232         MOVE ZEROES             TO LS-STATS-NBR-COL2             RG800902
394234                                    (X-LS-STATS-1)                RG800902
394236         MOVE MMFA-SALES-BELOW-FLOOR-AMT (X-MMFA)                 RG800902
394238                                 TO LS-STATS-AMT-COL2             RG800902
394240                                    (X-LS-STATS-1)                RG800902
394242         MOVE 14                 TO LS-STATS-LINE-NBR             RG800902
394244                                    (X-LS-STATS-1)                RG800902
394246     END-IF.                                                      RG800902
394248*                                                                 RG800902
394250     SET X-LS-STATS-1            UP BY +1.                        RG800902
394252*                                                                 RG800902
394254     MOVE 17                     TO LS-STATS-PAGE-NBR             RG800902
394256                                    (X-LS-STATS-1).               RG800902
394258     MOVE 999                    TO LS-STATS-LOGIC-MODULE         RG800902
394260                                    (X-LS-STATS-1).               RG800902
394262*                                                                 RG800902
394264     IF  MBCA-MBSM-INDEX-1 IS NOT EQUAL TO ZERO                   RG800902
394266         SET X-MMFA              TO MBCA-MBSM-INDEX-1             RG800902
394268         MOVE ZEROES             TO LS-STATS-NBR-COL1             RG800902
394270                                    (X-LS-STATS-1)                RG800902
394272         COMPUTE LS-STATS-AMT-COL1 (X-LS-STATS-1)                 RG800902
394274                                 = MMFA-KEYED-RETURNS-AMT (X-MMFA)RG800902
394276                                 - MMFA-KEYED-RETURNS-REV-AMT     RG800902
394278                                   (X-MMFA)                       RG800902
394280                                 + MMFA-SWIPED-RETURNS-AMT        RG800902
394282                                   (X-MMFA)                       RG800902
394284                                 - MMFA-SWIPED-RETURNS-REV-AMT    RG800902
394286                                   (X-MMFA)                       RG800902
394288         MOVE 15                 TO LS-STATS-LINE-NBR             RG800902
394290                                    (X-LS-STATS-1)                RG800902
394292     END-IF.                                                      RG800902
394294*                                                                 RG800902
394296     IF  MBCA-MBSM-INDEX-2 IS NOT EQUAL TO ZERO                   RG800902
394298         SET X-MMFA              TO MBCA-MBSM-INDEX-2             RG800902
394300         MOVE ZEROES             TO LS-STATS-NBR-COL2             RG800902
394302                                    (X-LS-STATS-1)                RG800902
394304         COMPUTE LS-STATS-AMT-COL2 (X-LS-STATS-1)                 RG800902
394306                                 = MMFA-KEYED-RETURNS-AMT (X-MMFA)RG800902
394308                                 - MMFA-KEYED-RETURNS-REV-AMT     RG800902
394310                                   (X-MMFA)                       RG800902
394312                                 + MMFA-SWIPED-RETURNS-AMT        RG800902
394314                                   (X-MMFA)                       RG800902
394316                                 - MMFA-SWIPED-RETURNS-REV-AMT    RG800902
394318                                   (X-MMFA)                       RG800902
394320         MOVE 15                 TO LS-STATS-LINE-NBR             RG800902
394322                                    (X-LS-STATS-1)                RG800902
394324     END-IF.                                                      RG800902
394326*                                                                 RG800902
394328     SET X-LS-STATS-1            UP BY +1.                        RG800902
394330*                                                                 RG800902
394332     MOVE 17                     TO LS-STATS-PAGE-NBR             RG800902
394334                                    (X-LS-STATS-1).               RG800902
394336     MOVE 999                    TO LS-STATS-LOGIC-MODULE         RG800902
394338                                    (X-LS-STATS-1).               RG800902
394340*                                                                 RG800902
394342     IF  MBCA-MBSM-INDEX-1 IS NOT EQUAL TO ZERO                   RG800902
394344         SET X-MMFA              TO MBCA-MBSM-INDEX-1             RG800902
394346         COMPUTE LS-STATS-NBR-COL1 (X-LS-STATS-1)                 RG800902
394348                                 = MMFA-KEYED-RETURNS-NBR (X-MMFA)RG800902
394350                                 - MMFA-KEYED-RETURNS-REV-NBR     RG800902
394352                                   (X-MMFA)                       RG800902
394354                                 + MMFA-SWIPED-RETURNS-NBR        RG800902
394356                                   (X-MMFA)                       RG800902
394358                                 - MMFA-SWIPED-RETURNS-REV-NBR    RG800902
394360                                   (X-MMFA)                       RG800902
394362         MOVE ZEROES             TO LS-STATS-AMT-COL1             RG800902
394364                                    (X-LS-STATS-1)                RG800902
394366         MOVE 16                 TO LS-STATS-LINE-NBR             RG800902
394368                                    (X-LS-STATS-1)                RG800902
394370     END-IF.                                                      RG800902
394372*                                                                 RG800902
394374     IF  MBCA-MBSM-INDEX-2 IS NOT EQUAL TO ZERO                   RG800902
394376         SET X-MMFA              TO MBCA-MBSM-INDEX-2             RG800902
394378         COMPUTE LS-STATS-NBR-COL2 (X-LS-STATS-1)                 RG800902
394380                                 = MMFA-KEYED-RETURNS-NBR (X-MMFA)RG800902
394382                                 - MMFA-KEYED-RETURNS-REV-NBR     RG800902
394384                                   (X-MMFA)                       RG800902
394386                                 + MMFA-SWIPED-RETURNS-NBR        RG800902
394388                                   (X-MMFA)                       RG800902
394390                                 - MMFA-SWIPED-RETURNS-REV-NBR    RG800902
394392                                   (X-MMFA)                       RG800902
394394         MOVE ZEROES             TO LS-STATS-AMT-COL2             RG800902
394396                                    (X-LS-STATS-1)                RG800902
394398         MOVE 16                 TO LS-STATS-LINE-NBR             RG800902
394400                                    (X-LS-STATS-1)                RG800902
394402     END-IF.                                                      RG800902
394404*                                                                 RG800902
394496     SET LS-STATS-ENTRY-COUNT    TO X-LS-STATS-1.                 RG800902
394497*                                                                 RG800902
394498 8919-LFA-EXIT.                                                   RG800902
394499     EXIT.                                                        RG800902
394500/
394600 9400-SEARCH-LM-PL-TABLE.
394700*
394800****************************************************************
394900*    SEARCH THE LOGIC MODULE/PAGE LINE CROSS-REFERENCE TABLE   *
395000****************************************************************
395100*
395200     MOVE MBCA-MBSM-CM-FLAG      TO WS-SEARCH-LM-PL-CM-FLAG.
395300     MOVE MBCA-MBSM-SUB-FLAG     TO WS-SEARCH-LM-PL-SUB-FLAG.
395400     SET WS-SEARCH-NOT-FOUND     TO TRUE.
395500*
395600     SEARCH ALL WS-LM-PAGE-LINE-ENTRY
395700         AT END
395800             CONTINUE
395900         WHEN WS-LM-PAGE-LINE-KEY (X-WS-LM-PAGE-LINE)
396000             IS EQUAL TO WS-SEARCH-LM-PL-KEY
396100             SET WS-SEARCH-FOUND TO TRUE
396200     END-SEARCH.
396300*
396400 9410-SLPT-EXIT.
396500     EXIT.
396600*
396700 9420-SEARCH-PAGE-TITLE-TABLE.
396800*
396900****************************************************************
397000*    SEARCH THE LOGIC MODULE/PAGE LINE CROSS-REFERENCE TABLE   *
397100****************************************************************
397200*
397300     SET WS-SEARCH-NOT-FOUND     TO TRUE.
397400*
397500     SEARCH ALL WS-PAGE-TITLE-ENTRY
397600         AT END
397700             CONTINUE
397800         WHEN WS-PAGE-TITLE-KEY (X-WS-PAGE-TITLE)
397900             IS EQUAL TO WS-SEARCH-PAGE-TITLE-KEY
398000             SET WS-SEARCH-FOUND TO TRUE
398100     END-SEARCH.
398200*
398300 9430-SPTT-EXIT.
398400     EXIT.
398500*
398600 9500-SORT-STATS-TABLE.
398700*
398800******************************************************************
398900******************************************************************
399000******************************************************************
399100*****************BUBBLE SORT LS-STATS-TABLE***********************
399200******************************************************************
399300******************************************************************
399400******************************************************************
399500*
399600* X-LS-STATS-1 = WORKING POINTER FOR SWAPPING WITHIN TABLE
399700* X-LS-STATS-2 = POINTER TO LAST UN-SORTED ENTRY
399800* X-LS-STATS-3 = POINTS TO EMPTY SLOT AT END OF TABLE USED
399900*                AS A HOLDING BUCKET FOR SWAPS
400000*
400100     SET WS-BUBBLE-SORT-SWAP     TO TRUE.
400200     SET X-LS-STATS-2            TO LS-STATS-ENTRY-COUNT.
400300     SET X-LS-STATS-3            TO X-LS-STATS-2.
400400     SET X-LS-STATS-3            UP BY 1.
400500*
400600     PERFORM
400700         UNTIL WS-BUBBLE-SORT-NO-SWAP
400800         SET WS-BUBBLE-SORT-NO-SWAP
400900                                 TO TRUE
401000         PERFORM
401100             VARYING X-LS-STATS-1 FROM 1 BY 1
401200             UNTIL   X-LS-STATS-1 IS GREATER THAN X-LS-STATS-2
401300                 IF  LS-STATS-SCREEN-SORT (X-LS-STATS-1)
401400                                 IS GREATER THAN
401500                     LS-STATS-SCREEN-SORT (X-LS-STATS-1 + 1)
401600                     SET WS-BUBBLE-SORT-SWAP
401700                                 TO TRUE
401800                     MOVE LS-STATS-ENTRY (X-LS-STATS-1)
401900                       TO LS-STATS-ENTRY (X-LS-STATS-3)
402000                     MOVE LS-STATS-ENTRY (X-LS-STATS-1 + 1)
402100                       TO LS-STATS-ENTRY (X-LS-STATS-1)
402200                     MOVE LS-STATS-ENTRY (X-LS-STATS-3)
402300                       TO LS-STATS-ENTRY (X-LS-STATS-1 + 1)
402400                 END-IF
402500         END-PERFORM
402600         IF  X-LS-STATS-2        IS GREATER THAN +1
402700             SET X-LS-STATS-2    DOWN BY 1
402800         END-IF
402900     END-PERFORM.
403000*
403100 9510-SST-EXIT.
403200     EXIT.
403300*
403400 9600-BUILD-SCREEN.
403500*
403600     MOVE MBCA-CURRENCY-CODE     TO SS95WS-CURRENCY-CODE.
403700*
403800* FIND FIRST OCCURANCE IN T/S TABLE FOR CURRENT OR
403900* HIGHER PAGE NUMBER
404000*
404100     PERFORM VARYING X-LS-STATS-1 FROM +1 BY +1
404200         UNTIL X-LS-STATS-1 IS GREATER THAN LS-STATS-ENTRY-COUNT
404300         OR  LS-STATS-PAGE-NBR (X-LS-STATS-1)
404400                                  IS NOT LESS THAN MBCA-SCREEN-NBR
404500     END-PERFORM.
404600*
404700     IF  X-LS-STATS-1 IS GREATER THAN LS-STATS-ENTRY-COUNT
404800     OR  LS-STATS-PAGE-NBR (X-LS-STATS-1)
404900                                  IS LESS THAN MBCA-SCREEN-NBR
405000         SET MBCA-INITIAL-SCREEN-NBR
405100                                 TO TRUE
405200         MOVE 'PC06'             TO MBCA-PROGRAM-LOCATION
405300         PERFORM MB70PD-XCTL-TO-MBOXCTL
405400                                 THRU MB70PD-XTM-EXIT
405500     ELSE
405600         MOVE LS-STATS-PAGE-NBR (X-LS-STATS-1)
405700                                  TO MBCA-SCREEN-NBR
405800                                     SM01-CURRENT-PAGE
405900     END-IF.
406000*
406100* GET SCREEN TITLE FROM TABLE
406200*
406300     MOVE MBCA-MBSM-CM-FLAG      TO WS-SEARCH-PT-CM-FLAG.
406400     MOVE MBCA-MBSM-SUB-FLAG     TO WS-SEARCH-PT-SUB-FLAG.
406500     MOVE MBCA-SCREEN-NBR        TO WS-SEARCH-PT-PAGE-NBR.
406600*
406700     PERFORM 9420-SEARCH-PAGE-TITLE-TABLE
406800                                 THRU 9430-SPTT-EXIT.
406900*
407000     IF  WS-SEARCH-NOT-FOUND
407100         SET WS-SEARCH-PT-CM-GENERIC
407200                                 TO TRUE
407300         PERFORM 9420-SEARCH-PAGE-TITLE-TABLE
407400                                 THRU 9430-SPTT-EXIT
407500         IF  WS-SEARCH-NOT-FOUND
407600             SET WS-SEARCH-PT-SUB-GENERIC
407700                                 TO TRUE
407800             PERFORM 9420-SEARCH-PAGE-TITLE-TABLE
407900                                 THRU 9430-SPTT-EXIT
408000         END-IF
408100     END-IF.
408200*
408300     IF  MBCA-MBSM-EXPENSE-VALID
408400     AND (WS-PAGE-TITLE-KEY (X-WS-PAGE-TITLE) IS EQUAL TO 'CP05'
408500      OR  WS-PAGE-TITLE-KEY (X-WS-PAGE-TITLE) IS EQUAL TO 'CP06'
408600      OR  WS-PAGE-TITLE-KEY (X-WS-PAGE-TITLE) IS EQUAL TO 'CP07'
408700      OR  WS-PAGE-TITLE-KEY (X-WS-PAGE-TITLE) IS EQUAL TO 'CP08'
408800      OR  WS-PAGE-TITLE-KEY (X-WS-PAGE-TITLE) IS EQUAL TO 'CT05'
408900      OR  WS-PAGE-TITLE-KEY (X-WS-PAGE-TITLE) IS EQUAL TO 'CT06'
409000      OR  WS-PAGE-TITLE-KEY (X-WS-PAGE-TITLE) IS EQUAL TO 'CT07'
409100      OR  WS-PAGE-TITLE-KEY (X-WS-PAGE-TITLE) IS EQUAL TO 'CT08')
409200         MOVE WS-PAGE-TITLE-DESC (X-WS-PAGE-TITLE)
409300                                 TO SM01-MENU-DESC
409400         MOVE 'EXP '             TO SM01-MENU-DESC (30:4)
409500     ELSE
409600         IF  MBCA-MBSM-EXPENSE-VALID
409700         AND (WS-PAGE-TITLE-KEY (X-WS-PAGE-TITLE)
409800                                 IS EQUAL TO 'MP05'
409900         OR  WS-PAGE-TITLE-KEY (X-WS-PAGE-TITLE)
410000                                 IS EQUAL TO 'MP06'
410100         OR  WS-PAGE-TITLE-KEY (X-WS-PAGE-TITLE)
410200                                 IS EQUAL TO 'MP07'
410300         OR  WS-PAGE-TITLE-KEY (X-WS-PAGE-TITLE)
410400                                 IS EQUAL TO 'MP08'
410500         OR  WS-PAGE-TITLE-KEY (X-WS-PAGE-TITLE)
410600                                 IS EQUAL TO 'MT05'
410700         OR  WS-PAGE-TITLE-KEY (X-WS-PAGE-TITLE)
410800                                 IS EQUAL TO 'MT06'
410900         OR  WS-PAGE-TITLE-KEY (X-WS-PAGE-TITLE)
411000                                 IS EQUAL TO 'MT07'
411100         OR  WS-PAGE-TITLE-KEY (X-WS-PAGE-TITLE)
411200                                 IS EQUAL TO 'MT08')
411300             MOVE WS-PAGE-TITLE-DESC (X-WS-PAGE-TITLE)
411400                                 TO SM01-MENU-DESC
411500             MOVE 'EXP '         TO SM01-MENU-DESC (27:4)
411600         ELSE
411700             MOVE WS-PAGE-TITLE-DESC (X-WS-PAGE-TITLE)
411800                                 TO SM01-MENU-DESC.
411900
412000*
412100* CHECK FOR LOGIC MODULE 999 PAGE 17 INFORMATION
412200*
412300     SET X-STATS-INDEX           TO 1.
412400*
412500     IF  LS-STATS-LOGIC-MODULE (X-LS-STATS-1)
412600                                 IS EQUAL TO 999
412700         EVALUATE TRUE
412800           WHEN MBCA-MBSM-INDEX-1 IS LESS THAN 1
412900             MOVE ALL '*'        TO WS-STATS-NBR-LINE-1
413000         END-EVALUATE
413100         EVALUATE TRUE
413200           WHEN MBCA-MBSM-INDEX-2 IS LESS THAN 1
413300             MOVE ALL '*'        TO WS-STATS-NBR-LINE-2
413400         END-EVALUATE
413500         MOVE WS-STATS-NBR-LINE  TO SM01-STATS-LIT-LINE2
413600         PERFORM VARYING X-LS-STATS-1 FROM X-LS-STATS-1 BY 1
413700             UNTIL X-LS-STATS-1 IS GREATER THAN
413800                                 LS-STATS-ENTRY-COUNT
413900             OR  LS-STATS-PAGE-NBR (X-LS-STATS-1)
414000                                 IS NOT EQUAL TO MBCA-SCREEN-NBR
414100             EVALUATE TRUE
414200               WHEN LS-STATS-LINE-NBR (X-LS-STATS-1)
414300                                 IS EQUAL TO 1
414400                 MOVE 'KEYED AUTHS'
414500                                 TO SM01-STATS-DESC
414600                                    (X-STATS-INDEX)
414700               WHEN LS-STATS-LINE-NBR (X-LS-STATS-1)
414800                                 IS EQUAL TO 2
414900                 MOVE 'SWIPED AUTHS'
415000                                 TO SM01-STATS-DESC
415100                                    (X-STATS-INDEX)
415110               WHEN LS-STATS-LINE-NBR (X-LS-STATS-1)              RG800902
415112                                 IS EQUAL TO 3                    RG800902
415114                 MOVE 'KEYED SALES'                               RG800902
415116                                 TO SM01-STATS-DESC               RG800902
415118                                    (X-STATS-INDEX)               RG800902
415120               WHEN LS-STATS-LINE-NBR (X-LS-STATS-1)              RG800902
415122                                 IS EQUAL TO 4                    RG800902
415124                 MOVE 'SWIPED SALES'                              RG800902
415126                                 TO SM01-STATS-DESC               RG800902
415128                                    (X-STATS-INDEX)               RG800902
415200               WHEN LS-STATS-LINE-NBR (X-LS-STATS-1)
415300                                 IS EQUAL TO 5                    RG800902
415400                 MOVE 'USER INPUT'
415500                                 TO SM01-STATS-DESC
415600                                    (X-STATS-INDEX)
415700               WHEN LS-STATS-LINE-NBR (X-LS-STATS-1)
415800                                 IS EQUAL TO 6                    RG800902
415900                 MOVE 'LOCAL INPUT'
416000                                 TO SM01-STATS-DESC
416100                                    (X-STATS-INDEX)
416200               WHEN LS-STATS-LINE-NBR (X-LS-STATS-1)
416300                                 IS EQUAL TO 7                    RG800902
416400                 MOVE 'POS 1 INPUT'
416500                                 TO SM01-STATS-DESC
416600                                    (X-STATS-INDEX)
416700               WHEN LS-STATS-LINE-NBR (X-LS-STATS-1)
416800                                 IS EQUAL TO 8                    RG800902
416900                 MOVE 'POS 2 INPUT'
417000                                 TO SM01-STATS-DESC
417100                                    (X-STATS-INDEX)
417200               WHEN LS-STATS-LINE-NBR (X-LS-STATS-1)
417300                                 IS EQUAL TO 9                    RG800902
417400                 MOVE 'POS 3 INPUT'
417500                                 TO SM01-STATS-DESC
417600                                    (X-STATS-INDEX)
417700               WHEN LS-STATS-LINE-NBR (X-LS-STATS-1)
417800                                 IS EQUAL TO 10                   RG800902
417900                 MOVE 'ACH NBR'
418000                                 TO SM01-STATS-DESC
418100                                    (X-STATS-INDEX)
418110               WHEN LS-STATS-LINE-NBR (X-LS-STATS-1)              RG800902
418112                                 IS EQUAL TO 11                   RG800902
418114                 MOVE 'KEYED AUTHS AMT'                           RG800902
418116                                 TO SM01-STATS-DESC               RG800902
418118                                    (X-STATS-INDEX)               RG800902
418120               WHEN LS-STATS-LINE-NBR (X-LS-STATS-1)              RG800902
418122                                 IS EQUAL TO 12                   RG800902
418124                 MOVE 'SWIPED AUTH AMT'                           RG800902
418126                                 TO SM01-STATS-DESC               RG800902
418128                                    (X-STATS-INDEX)               RG800902
418130               WHEN LS-STATS-LINE-NBR (X-LS-STATS-1)              RG800902
418132                                 IS EQUAL TO 13                   RG800902
418134                 MOVE 'SALES AMT NET  '                           RG800902
418136                                 TO SM01-STATS-DESC               RG800902
418138                                    (X-STATS-INDEX)               RG800902
418140               WHEN LS-STATS-LINE-NBR (X-LS-STATS-1)              RG800902
418142                                 IS EQUAL TO 14                   RG800902
418144                 MOVE 'SALES BELOW AMT'                           RG800902
418146                                 TO SM01-STATS-DESC               RG800902
418148                                    (X-STATS-INDEX)               RG800902
418150               WHEN LS-STATS-LINE-NBR (X-LS-STATS-1)              RG800902
418152                                 IS EQUAL TO 15                   RG800902
418154                 MOVE 'RETURNS AMT NET'                           RG800902
418156                                 TO SM01-STATS-DESC               RG800902
418158                                    (X-STATS-INDEX)               RG800902
418160               WHEN LS-STATS-LINE-NBR (X-LS-STATS-1)              RG800902
418162                                 IS EQUAL TO 16                   RG800902
418164                 MOVE 'RETURNS NBR NET'                           RG800902
418166                                 TO SM01-STATS-DESC               RG800902
418168                                    (X-STATS-INDEX)               RG800902
418200             END-EVALUATE
418300             IF  MBCA-MBSM-INDEX-1 IS GREATER THAN ZEROES
418400                 MOVE LS-STATS-NBR-COL1 (X-LS-STATS-1)
418500                                 TO SS95WS-IN-NBR
418510                 MOVE LS-STATS-AMT-COL1 (X-LS-STATS-1)            RG800902
418512                                 TO SS95WS-IN-AMT                 RG800902
418600                 PERFORM SS95PD-NAP-ROUTINE
418700                                 THRU SS95PD-NAP-EXIT
418800                 MOVE SS95WS-OUT-NBR-L10
418900                                 TO SM01-STATS-NBR1
419000                                    (X-STATS-INDEX)
419010                 MOVE SS95WS-OUT-AMT-L21                          RG800902
419012                                 TO SM01-STATS-AMT1               RG800902
419014                                    (X-STATS-INDEX)               RG800902
419100             ELSE
419200                 MOVE SPACE      TO SM01-STATS-NBR1
419300                                    (X-STATS-INDEX)
419400                                    SM01-STATS-AMT1
419500                                    (X-STATS-INDEX)
419600             END-IF
419700*
419800             IF  MBCA-MBSM-INDEX-2 IS GREATER THAN ZEROES
419900                 MOVE LS-STATS-NBR-COL2 (X-LS-STATS-1)
420000                                 TO SS95WS-IN-NBR
420010                 MOVE LS-STATS-AMT-COL2 (X-LS-STATS-1)            RG800902
420012                                 TO SS95WS-IN-AMT                 RG800902
420100                 PERFORM SS95PD-NAP-ROUTINE
420200                                 THRU SS95PD-NAP-EXIT
420300                 MOVE SS95WS-OUT-NBR-L10
420400                                 TO SM01-STATS-NBR2
420500                                    (X-STATS-INDEX)
420510                 MOVE SS95WS-OUT-AMT-L21                          RG800902
420512                                 TO SM01-STATS-AMT2               RG800902
420514                                    (X-STATS-INDEX)               RG800902
420600             ELSE
420700                 MOVE SPACE      TO SM01-STATS-NBR2
420800                                    (X-STATS-INDEX)
420900                                    SM01-STATS-AMT2
421000                                    (X-STATS-INDEX)
421100             END-IF
421200           SET X-STATS-INDEX     UP BY 1
421300         END-PERFORM
421400         GO TO 9615-CONTINUE.
421500
421600*
421700* FILL EACH SCREEN LINE FROM L/S TABLE FOR THIS PAGE
421800*
421900     SET X-STATS-INDEX           TO 1.
422000*
422100     PERFORM VARYING X-LS-STATS-1 FROM X-LS-STATS-1 BY 1
422200         UNTIL X-LS-STATS-1 IS GREATER THAN LS-STATS-ENTRY-COUNT
422300         OR  LS-STATS-PAGE-NBR (X-LS-STATS-1)
422400                                 IS NOT EQUAL TO MBCA-SCREEN-NBR
422500*
422600*  GET DESCRIPTION FOR LOGIC MODULE FROM TRAN CODE DESC TABLE
422700*  FIRST, CHECK GENERATED TRANSACTION TABLE
422800*  IF NOT FOUND, CHECK DEFAULT TRANSACTION TABLE
422900*
423000         SET X-MMGDTB-GT         TO +1
423100         SEARCH MMGDTB-GT-TABLE VARYING X-MMGDTB-GT
423200         AT END
423300             SET X-MMGDTB-DT     TO +1
423400             SEARCH MMGDTB-DT-TABLE VARYING X-MMGDTB-DT
423500             AT END
423600                 MOVE LS-STATS-LOGIC-MODULE (X-LS-STATS-1)
423700                                 TO SM01-STATS-DESC
423800                                    (X-STATS-INDEX)
423900             WHEN MMGDTB-DT-LM (X-MMGDTB-DT) IS EQUAL
424000                                 TO LS-STATS-LOGIC-MODULE
424100                                    (X-LS-STATS-1)
424200                 MOVE MMGDTB-DT-RPT-DESC (X-MMGDTB-DT)
424300                                 TO SM01-STATS-DESC
424400                                    (X-STATS-INDEX)
424500             END-SEARCH
424600         WHEN MMGDTB-GT-LM (X-MMGDTB-GT) IS EQUAL
424700                                 TO LS-STATS-LOGIC-MODULE
424800                                    (X-LS-STATS-1)
424900             MOVE MMGDTB-GT-RPT-DESC (X-MMGDTB-GT)
425000                                 TO SM01-STATS-DESC
425100                                    (X-STATS-INDEX)
425200         END-SEARCH
425300*
425400*  LOAD/CONVERT COLUMN 1 INFO, STORE IN CURRENT LINE
425500*
425600         IF  MBCA-MBSM-INDEX-1 IS GREATER THAN ZEROES
425700             MOVE LS-STATS-NBR-COL1 (X-LS-STATS-1)
425800                                 TO SS95WS-IN-NBR
425900             MOVE LS-STATS-AMT-COL1 (X-LS-STATS-1)
426000                                 TO SS95WS-IN-AMT
426100             PERFORM SS95PD-NAP-ROUTINE
426200                                 THRU SS95PD-NAP-EXIT
426300             MOVE SS95WS-OUT-NBR-L10
426400                                 TO SM01-STATS-NBR1
426500                                    (X-STATS-INDEX)
426600             MOVE SS95WS-OUT-AMT-L21
426700                                 TO SM01-STATS-AMT1
426800                                    (X-STATS-INDEX)
426900         ELSE
427000             MOVE SPACE          TO SM01-STATS-NBR1
427100                                    (X-STATS-INDEX)
427200                                    SM01-STATS-AMT1
427300                                    (X-STATS-INDEX)
427400         END-IF
427500*
427600*  LOAD/CONVERT COLUMN 2 INFO, STORE IN CURRENT LINE
427700*
427800         IF  MBCA-MBSM-INDEX-2 IS GREATER THAN ZEROES
427900             MOVE LS-STATS-NBR-COL2 (X-LS-STATS-1)
428000                                 TO SS95WS-IN-NBR
428100             MOVE LS-STATS-AMT-COL2 (X-LS-STATS-1)
428200                                 TO SS95WS-IN-AMT
428300             PERFORM SS95PD-NAP-ROUTINE
428400                                 THRU SS95PD-NAP-EXIT
428500             MOVE SS95WS-OUT-NBR-L10
428600                                 TO SM01-STATS-NBR2
428700                                    (X-STATS-INDEX)
428800             MOVE SS95WS-OUT-AMT-L21
428900                                 TO SM01-STATS-AMT2
429000                                    (X-STATS-INDEX)
429100         ELSE
429200             MOVE SPACE          TO SM01-STATS-NBR2
429300                                    (X-STATS-INDEX)
429400                                    SM01-STATS-AMT2
429500                                    (X-STATS-INDEX)
429600         END-IF
429700*
429800* POINT TO NEXT SCREEN LINE
429900*
430000         SET X-STATS-INDEX       UP BY 1
430100     END-PERFORM.
430200*
430300*
430400 9615-CONTINUE.
430500*
430600*
430700* DARK ANY REMAINING SCREEN LINES
430800*
430900     PERFORM VARYING X-STATS-INDEX FROM X-STATS-INDEX BY 1
431000         UNTIL X-STATS-INDEX     IS GREATER +16
431100         MOVE DFHBMDAS           TO SM01-STATS-LINE-A
431200                                    (X-STATS-INDEX)
431300     END-PERFORM.
431400*
431500     IF  X-LS-STATS-1 IS GREATER THAN LS-STATS-ENTRY-COUNT
431600         NEXT SENTENCE
431700     ELSE
431800         COMPUTE MBCA-SCREEN-NBR = LS-STATS-PAGE-NBR
431900                                   (X-LS-STATS-1)
432000                                 - 1.
432100*
432200 9699-BS-EXIT.
432300     EXIT.
432400*
432500 9700-BUILD-SCREEN.
432600*
432700     MOVE MBCA-CURRENCY-CODE     TO SS95WS-CURRENCY-CODE.
432800     MOVE +1                     TO WS-HOLD-PAGE-COUNT.
432900*
433000* FIND FIRST OCCURANCE IN T/S TABLE FOR CURRENT OR
433100* HIGHER PAGE NUMBER
433200*
433300     PERFORM VARYING X-LS-STATS-1 FROM +1 BY +1
433400         UNTIL X-LS-STATS-1 IS GREATER THAN LS-STATS-ENTRY-COUNT
433500         OR  LS-STATS-PAGE-NBR (X-LS-STATS-1) IS NOT LESS
433600                                 THAN MBCA-MBSM-PAGE-NBR
433700     END-PERFORM.
433800*
433900     IF  X-LS-STATS-1 IS GREATER THAN LS-STATS-ENTRY-COUNT
434000         SET MBCA-INITIAL-SCREEN-NBR
434100                                 TO TRUE
434200         MOVE 'PC07'             TO MBCA-PROGRAM-LOCATION
434300         PERFORM MB70PD-XCTL-TO-MBOXCTL
434400                                 THRU MB70PD-XTM-EXIT.
434500*
434600* FILL EACH SCREEN LINE FROM L/S TABLE FOR THIS PAGE
434700*
434800     SET X-STATS-INDEX           TO 1.
434900     MOVE DFHBMDAS               TO SM01-STATS-LINE-A
435000                                    (X-STATS-INDEX).
435100     SET X-STATS-INDEX           UP BY +1.
435200*
435300 9710-BUILD-SCREEN.
435400*
435500     IF  MBCA-MBSM-VALID-VI
435600     OR  MBCA-MBSM-VALID-MC
435700         SET X-MB80WS-IFT        TO MBCA-MBSM-CARD-PROD
435800         SET X-MB80WS-QL         TO MBCA-MBSM-PAGE-NBR
435900         MOVE MB80WS-INTCHG-QL-DESC (X-MB80WS-IFT
436000                                     X-MB80WS-QL)
436100                                 TO SM01-STATS-LINE
436200                                    (X-STATS-INDEX)
436300     ELSE
436400         SET X-MB80WS-PL-IFT     TO MBCA-MBSM-CARD-PROD
436500         SET X-MB80WS-PL-QL      TO MBCA-MBSM-PAGE-NBR
436600         MOVE MB80WS-PL-INTCHG-QL-DESC (X-MB80WS-PL-IFT
436700                                        X-MB80WS-PL-QL)
436800                                 TO SM01-STATS-LINE
436900                                    (X-STATS-INDEX).
437000*
437100     SET X-STATS-INDEX           UP BY +1.
437200*
437300 9715-GET-DESCRIPTION.
437400*
437500*  GET DESCRIPTION FOR LOGIC MODULE FROM TRAN CODE DESC TABLE
437600*  FIRST, CHECK GENERATED TRANSACTION TABLE
437700*  IF NOT FOUND, CHECK DEFAULT TRANSACTION TABLE
437800*
437900     SET X-MMGDTB-GT         TO +1.
438000     SEARCH MMGDTB-GT-TABLE VARYING X-MMGDTB-GT
438100         AT END
438200             SET X-MMGDTB-DT     TO +1
438300             SEARCH MMGDTB-DT-TABLE VARYING X-MMGDTB-DT
438400                 AT END
438500                     MOVE LS-STATS-LOGIC-MODULE (X-LS-STATS-1)
438600                                 TO SM01-STATS-DESC
438700                                    (X-STATS-INDEX)
438800                 WHEN MMGDTB-DT-LM (X-MMGDTB-DT) IS EQUAL
438900                                 TO LS-STATS-LOGIC-MODULE
439000                                    (X-LS-STATS-1)
439100                     MOVE MMGDTB-DT-RPT-DESC (X-MMGDTB-DT)
439200                                 TO SM01-STATS-DESC
439300                                    (X-STATS-INDEX)
439400             END-SEARCH
439500         WHEN MMGDTB-GT-LM (X-MMGDTB-GT) IS EQUAL
439600                                 TO LS-STATS-LOGIC-MODULE
439700                                    (X-LS-STATS-1)
439800             MOVE MMGDTB-GT-RPT-DESC (X-MMGDTB-GT)
439900                                 TO SM01-STATS-DESC
440000                                    (X-STATS-INDEX)
440100     END-SEARCH.
440200*
440300     MOVE LS-STATS-PAGE-NBR (X-LS-STATS-1)
440400                                 TO MBCA-MBSM-PAGE-NBR.
440500*
440600*  LOAD/CONVERT COLUMN 1 INFO, STORE IN CURRENT LINE
440700*
440800     IF  MBCA-MBSM-INDEX-1 IS GREATER THAN ZEROES
440900         MOVE LS-STATS-NBR-COL1 (X-LS-STATS-1)
441000                                 TO SS95WS-IN-NBR
441100         MOVE LS-STATS-AMT-COL1 (X-LS-STATS-1)
441200                                 TO SS95WS-IN-AMT
441300         PERFORM SS95PD-NAP-ROUTINE
441400                                 THRU SS95PD-NAP-EXIT
441500         MOVE SS95WS-OUT-NBR-L10 TO SM01-STATS-NBR1
441600                                    (X-STATS-INDEX)
441700         MOVE SS95WS-OUT-AMT-L21 TO SM01-STATS-AMT1
441800                                    (X-STATS-INDEX)
441900     ELSE
442000         MOVE SPACE              TO SM01-STATS-NBR1
442100                                    (X-STATS-INDEX)
442200                                    SM01-STATS-AMT1
442300                                    (X-STATS-INDEX)
442400     END-IF.
442500*
442600*  LOAD/CONVERT COLUMN 2 INFO, STORE IN CURRENT LINE
442700*
442800     IF  MBCA-MBSM-INDEX-2 IS GREATER THAN ZEROES
442900         MOVE LS-STATS-NBR-COL2 (X-LS-STATS-1)
443000                                 TO SS95WS-IN-NBR
443100         MOVE LS-STATS-AMT-COL2 (X-LS-STATS-1)
443200                                 TO SS95WS-IN-AMT
443300         PERFORM SS95PD-NAP-ROUTINE
443400                                 THRU SS95PD-NAP-EXIT
443500         MOVE SS95WS-OUT-NBR-L10 TO SM01-STATS-NBR2
443600                                    (X-STATS-INDEX)
443700         MOVE SS95WS-OUT-AMT-L21 TO SM01-STATS-AMT2
443800                                    (X-STATS-INDEX)
443900     ELSE
444000         MOVE SPACE              TO SM01-STATS-NBR2
444100                                    (X-STATS-INDEX)
444200                                    SM01-STATS-AMT2
444300                                    (X-STATS-INDEX)
444400     END-IF.
444500*
444600* POINT TO NEXT SCREEN LINE
444700*
444800     SET X-STATS-INDEX           UP BY +1.
444900     SET X-LS-STATS-1            UP BY +1.
445000*
445100     IF  X-LS-STATS-1 IS LESS THAN OR EQUAL
445200                                 TO LS-STATS-ENTRY-COUNT
445300         IF  LS-STATS-PAGE-NBR (X-LS-STATS-1) IS NOT EQUAL
445400                                 TO MBCA-MBSM-PAGE-NBR
445500             IF  WS-HOLD-PAGE-COUNT IS EQUAL TO +1
445600                 PERFORM VARYING X-STATS-INDEX
445700                                 FROM X-STATS-INDEX BY +1
445800                     UNTIL X-STATS-INDEX IS GREATER +9
445900                         MOVE DFHBMDAS
446000                                 TO SM01-STATS-LINE-A
446100                                    (X-STATS-INDEX)
446200                 END-PERFORM
446300                 ADD +1          TO WS-HOLD-PAGE-COUNT
446400                 MOVE LS-STATS-PAGE-NBR (X-LS-STATS-1)
446500                                 TO MBCA-MBSM-PAGE-NBR
446600                 GO TO 9710-BUILD-SCREEN
446700             ELSE
446800                 MOVE LS-STATS-PAGE-NBR (X-LS-STATS-1)
446900                                 TO MBCA-MBSM-PAGE-NBR
447000             END-IF
447100         ELSE
447200             GO TO 9715-GET-DESCRIPTION
447300         END-IF
447400     ELSE
447500         ADD +1                  TO MBCA-MBSM-PAGE-NBR
447600     END-IF.
447700*
447800     PERFORM VARYING X-STATS-INDEX FROM X-STATS-INDEX BY +1
447900             UNTIL X-STATS-INDEX IS GREATER +16
448000                 MOVE DFHBMDAS   TO SM01-STATS-LINE-A
448100                                    (X-STATS-INDEX)
448200     END-PERFORM.
448300*
448400 9799-BS-EXIT.
448500     EXIT.
448600/
448700 9800-BUILD-KEY-LINE.
448800*
448900* INITIALIZE MERCHANT/STORE/CHAIN LITERAL
449000* MOVE PROPER KEY FIELDS TO KEY LINE
449100*
449200     MOVE MBCA-MERCHANT-ORG      TO SM01-ORG.
449300*
449400     EVALUATE TRUE
449500         WHEN MBCA-MBSM-VALID-MERCHANT
449600             MOVE 'MERCHANT'     TO SM01-CHAIN-MERCH-LIT
449700             MOVE MBCA-MERCHANT  TO SM01-CHAIN-MERCH
449800         WHEN MBCA-MBSM-VALID-CHAIN
449900             MOVE 'CHAIN   '     TO SM01-CHAIN-MERCH-LIT
450000             MOVE MBCA-CHAIN     TO SM01-CHAIN-MERCH
450100         WHEN MBCA-MBSM-VALID-STORE
450200             MOVE 'STORE   '     TO SM01-CHAIN-MERCH-LIT
450300             MOVE MBCA-STORE     TO SM01-CHAIN-MERCH
450400         WHEN MBCA-MBSM-VALID-S-CHAIN
450500             MOVE 'ST CHAIN'     TO SM01-CHAIN-MERCH-LIT
450600             MOVE MBCA-S-CHAIN   TO SM01-CHAIN-MERCH
450700     END-EVALUATE.
450800*
450900     EVALUATE TRUE
451000         WHEN MBCA-MBSM-VALID-TOTALS
451100             MOVE DFHBMDAS       TO SM01-CARD-PROD-LIT-A
451200             MOVE DFHBMDAS       TO SM01-CARD-PROD-A
451300             MOVE DFHBMDAS       TO SM01-PLAN-LIT-A
451400             MOVE DFHBMDAS       TO SM01-PLAN-A
451500             MOVE DFHBMDAS       TO SM01-QLVL-LIT-A
451600             MOVE DFHBMDAS       TO SM01-QLVL-A
451700         WHEN MBCA-MBSM-VALID-PRODUCT
451800             MOVE MBCA-CARD-PROD TO SM01-CARD-PROD
451900             MOVE DFHBMDAS       TO SM01-PLAN-LIT-A
452000             MOVE DFHBMDAS       TO SM01-PLAN-A
452100             MOVE DFHBMDAS       TO SM01-QLVL-LIT-A
452200             MOVE DFHBMDAS       TO SM01-QLVL-A
452300         WHEN MBCA-MBSM-VALID-CRED-PLAN
452400             MOVE MBCA-CARD-PROD TO SM01-CARD-PROD
452500             MOVE MBCA-PLAN      TO SM01-PLAN
452600             MOVE DFHBMDAS       TO SM01-QLVL-LIT-A
452700             MOVE DFHBMDAS       TO SM01-QLVL-A
452800         WHEN MBCA-MBSM-VALID-QUAL-LVL
452900             MOVE MBCA-CARD-PROD TO SM01-CARD-PROD
453000             MOVE MBCA-QUAL-LEVEL
453100                                 TO SM01-QLVL
453200             MOVE DFHBMDAS       TO SM01-PLAN-LIT-A
453300             MOVE DFHBMDAS       TO SM01-PLAN-A
453400     END-EVALUATE.
453500*
453600 9810-BKL-EXIT.
453700     EXIT.
453800*
453900/         NEW ROUTINE FOR JULIAN TO GREGORIAN CONVERSION
454000     COPY SS26PD.
454100/         ROUTINE TO NUMERICALLY EDIT TIME
454200     COPY SS27PD.
454300/         JULIAN TO GREGORIAN DATE ROUTINE.
454400     COPY SS08PD.
454500/    ROUTINE TO MOVE CA VARIABLES TO  SS08-FORMATTED-MSG.
454600     COPY MB06PD.
454700/         LINE 24 PF KEYS ROUTINE
454800     COPY SS15PD.
454900/         MERCH/PROD/CRED PLAN GROUP STATS RECORD ACCESS ROUTINES
455000     COPY MMCGAO.
455100/         MERCHANT/PROD/CREDIT PLANS RECORD ACCESS ROUTINES
455200     COPY MMCPAO.
455300/         STORE/PRODUCT/CREDIT PLAN STATS RECORD ACCESS ROUTINES
455400     COPY MMCSAO.
455500/         OUTGOING INTERCHANGE GROUP STATS RECORD ACCESS ROUTINES
455600     COPY MMOGAO.
455700/         OUTGOING INTERCHANGE STATS RECORD ACCESS ROUTINES
455800     COPY MMOIAO.
455900/         MERCHANT PRODUCT STATS RECORD ACCESS ROUTINES
456000     COPY MMPAAO.
456100/         MERCHANT PRODUCT GROUP STATS RECORD ACCESS ROUTINES
456200     COPY MMPGAO.
456300/         STORE PRODUCT STATS RECORD ACCESS ROUTINES
456400     COPY MMPSAO.
456500/         MERCH PROD EXPENSE GROUP STATS ACCESS ROUTINES
456600     COPY MMPXAO.
456700/         OUTGOING INTCH EXPENSE GROUP STATS ACCESS ROUTINES
456800     COPY MMOXAO.
456900/         MERCH PROD EXPENSE STATS ACCESS ROUTINES
457000     COPY MMPEAO.
457100/         OUTGOING INTCH EXPENSE STATS ACCESS ROUTINES
457200     COPY MMOEAO.
457300/         STORE CHAIN PROD STATS ACCESS ROUTINES
457400     COPY MMRGAO.
457500/         STORE PROD CREIST PLAN GROUP ACCESS ROUTINES
457600     COPY MMLGAO.
457700/         GROUP FEE ACTIVITY MASTER ACCESS ROUTINES
457800     COPY MMFGAO.
457900/         FEE ACTIVITY MASTER ACCESS ROUTINES
458000     COPY MMFAAO.
458100/         ON-LINE MAP ROUTINES
458200     COPY MB60PD REPLACING 'MBMAPXX' BY 'MBSM01 '
458300                           MBMAPXXI BY MBSM01I
458400                           MBMAPXXO BY MBSM01O.
458500/         FORMAT NBR AND AMT PROCEDURS
458600     COPY SS95PDO REPLACING ==:XXCA:== BY ==MBCA==.
458700/         ON-LINE PROCEDURES
458800     COPY MB70PD.
458900/
459000     COPY SMFTPXO.
